class
	SD_DIRENT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	d_ino: NATURAL_32 assign set_d_ino
		do
			Result := c_d_ino (c_pointer)
		end

	d_off: INTEGER_32 assign set_d_off
		do
			Result := c_d_off (c_pointer)
		end

	d_reclen: NATURAL_16 assign set_d_reclen
		do
			Result := c_d_reclen (c_pointer)
		end

	d_type: NATURAL_8 assign set_d_type
		do
			Result := c_d_type (c_pointer)
		end

	d_name: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_d_name (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_d_ino (a_d_ino: NATURAL_32)
		do
			c_set_d_ino (c_pointer, a_d_ino)
		end

	set_d_off (a_d_off: INTEGER_32)
		do
			c_set_d_off (c_pointer, a_d_off)
		end

	set_d_reclen (a_d_reclen: NATURAL_16)
		do
			c_set_d_reclen (c_pointer, a_d_reclen)
		end

	set_d_type (a_d_type: NATURAL_8)
		do
			c_set_d_type (c_pointer, a_d_type)
		end

feature {NONE} -- C getters

	c_d_ino (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct dirent *)$tmp)->d_ino;"
		end

	c_d_off (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct dirent *)$tmp)->d_off;"
		end

	c_d_reclen (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct dirent *)$tmp)->d_reclen;"
		end

	c_d_type (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct dirent *)$tmp)->d_type;"
		end

	c_d_name (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct dirent *tmp = (struct dirent *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->d_name) / sizeof(tmp->d_name[0]);
				return tmp->d_name;
			]"
		end

feature {NONE} -- C setters

	c_set_d_ino (tmp: POINTER; a_d_ino: NATURAL_32)
		external
			"C inline"
		alias
			"((struct dirent *)$tmp)->d_ino = $a_d_ino;"
		end

	c_set_d_off (tmp: POINTER; a_d_off: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dirent *)$tmp)->d_off = $a_d_off;"
		end

	c_set_d_reclen (tmp: POINTER; a_d_reclen: NATURAL_16)
		external
			"C inline"
		alias
			"((struct dirent *)$tmp)->d_reclen = $a_d_reclen;"
		end

	c_set_d_type (tmp: POINTER; a_d_type: NATURAL_8)
		external
			"C inline"
		alias
			"((struct dirent *)$tmp)->d_type = $a_d_type;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <micro_httpd.h>"
		alias
			"return sizeof(struct dirent);"
		end

end
