class
	SD_IO_FILE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	flags: INTEGER_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	IO_read_ptr: CE_POINTER [INTEGER_8] assign set_IO_read_ptr
		do
			create Result.make_shared (c_IO_read_ptr (c_pointer))
		end

	IO_read_end: CE_POINTER [INTEGER_8] assign set_IO_read_end
		do
			create Result.make_shared (c_IO_read_end (c_pointer))
		end

	IO_read_base: CE_POINTER [INTEGER_8] assign set_IO_read_base
		do
			create Result.make_shared (c_IO_read_base (c_pointer))
		end

	IO_write_base: CE_POINTER [INTEGER_8] assign set_IO_write_base
		do
			create Result.make_shared (c_IO_write_base (c_pointer))
		end

	IO_write_ptr: CE_POINTER [INTEGER_8] assign set_IO_write_ptr
		do
			create Result.make_shared (c_IO_write_ptr (c_pointer))
		end

	IO_write_end: CE_POINTER [INTEGER_8] assign set_IO_write_end
		do
			create Result.make_shared (c_IO_write_end (c_pointer))
		end

	IO_buf_base: CE_POINTER [INTEGER_8] assign set_IO_buf_base
		do
			create Result.make_shared (c_IO_buf_base (c_pointer))
		end

	IO_buf_end: CE_POINTER [INTEGER_8] assign set_IO_buf_end
		do
			create Result.make_shared (c_IO_buf_end (c_pointer))
		end

	IO_save_base: CE_POINTER [INTEGER_8] assign set_IO_save_base
		do
			create Result.make_shared (c_IO_save_base (c_pointer))
		end

	IO_backup_base: CE_POINTER [INTEGER_8] assign set_IO_backup_base
		do
			create Result.make_shared (c_IO_backup_base (c_pointer))
		end

	IO_save_end: CE_POINTER [INTEGER_8] assign set_IO_save_end
		do
			create Result.make_shared (c_IO_save_end (c_pointer))
		end

	markers: CE_POINTER [SD_IO_MARKER] assign set_markers
		do
			create Result.make_shared (c_markers (c_pointer))
		end

	chain: CE_POINTER [SD_IO_FILE] assign set_chain
		do
			create Result.make_shared (c_chain (c_pointer))
		end

	fileno: INTEGER_32 assign set_fileno
		do
			Result := c_fileno (c_pointer)
		end

	flags2: INTEGER_32 assign set_flags2
		do
			Result := c_flags2 (c_pointer)
		end

	old_offset: INTEGER_32 assign set_old_offset
		do
			Result := c_old_offset (c_pointer)
		end

	cur_column: NATURAL_16 assign set_cur_column
		do
			Result := c_cur_column (c_pointer)
		end

	vtable_offset: INTEGER_8 assign set_vtable_offset
		do
			Result := c_vtable_offset (c_pointer)
		end

	shortbuf: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_shortbuf (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	lock: CE_POINTER [ANY] assign set_lock
		do
			create Result.make_shared (c_lock (c_pointer))
		end

	offset: INTEGER_64 assign set_offset
		do
			Result := c_offset (c_pointer)
		end

	pad1: CE_POINTER [ANY] assign set_pad1
		do
			create Result.make_shared (c_pad1 (c_pointer))
		end

	pad2: CE_POINTER [ANY] assign set_pad2
		do
			create Result.make_shared (c_pad2 (c_pointer))
		end

	pad3: CE_POINTER [ANY] assign set_pad3
		do
			create Result.make_shared (c_pad3 (c_pointer))
		end

	pad4: CE_POINTER [ANY] assign set_pad4
		do
			create Result.make_shared (c_pad4 (c_pointer))
		end

	pad5: NATURAL_32 assign set_pad5
		do
			Result := c_pad5 (c_pointer)
		end

	mode: INTEGER_32 assign set_mode
		do
			Result := c_mode (c_pointer)
		end

	unused2: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_unused2 (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_flags (a_flags: INTEGER_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

	set_IO_read_ptr (a_IO_read_ptr: CE_POINTER [INTEGER_8])
		do
			c_set_IO_read_ptr (c_pointer, a_IO_read_ptr.c_pointer)
		end

	set_IO_read_end (a_IO_read_end: CE_POINTER [INTEGER_8])
		do
			c_set_IO_read_end (c_pointer, a_IO_read_end.c_pointer)
		end

	set_IO_read_base (a_IO_read_base: CE_POINTER [INTEGER_8])
		do
			c_set_IO_read_base (c_pointer, a_IO_read_base.c_pointer)
		end

	set_IO_write_base (a_IO_write_base: CE_POINTER [INTEGER_8])
		do
			c_set_IO_write_base (c_pointer, a_IO_write_base.c_pointer)
		end

	set_IO_write_ptr (a_IO_write_ptr: CE_POINTER [INTEGER_8])
		do
			c_set_IO_write_ptr (c_pointer, a_IO_write_ptr.c_pointer)
		end

	set_IO_write_end (a_IO_write_end: CE_POINTER [INTEGER_8])
		do
			c_set_IO_write_end (c_pointer, a_IO_write_end.c_pointer)
		end

	set_IO_buf_base (a_IO_buf_base: CE_POINTER [INTEGER_8])
		do
			c_set_IO_buf_base (c_pointer, a_IO_buf_base.c_pointer)
		end

	set_IO_buf_end (a_IO_buf_end: CE_POINTER [INTEGER_8])
		do
			c_set_IO_buf_end (c_pointer, a_IO_buf_end.c_pointer)
		end

	set_IO_save_base (a_IO_save_base: CE_POINTER [INTEGER_8])
		do
			c_set_IO_save_base (c_pointer, a_IO_save_base.c_pointer)
		end

	set_IO_backup_base (a_IO_backup_base: CE_POINTER [INTEGER_8])
		do
			c_set_IO_backup_base (c_pointer, a_IO_backup_base.c_pointer)
		end

	set_IO_save_end (a_IO_save_end: CE_POINTER [INTEGER_8])
		do
			c_set_IO_save_end (c_pointer, a_IO_save_end.c_pointer)
		end

	set_markers (a_markers: CE_POINTER [SD_IO_MARKER])
		do
			c_set_markers (c_pointer, a_markers.c_pointer)
		end

	set_chain (a_chain: CE_POINTER [SD_IO_FILE])
		do
			c_set_chain (c_pointer, a_chain.c_pointer)
		end

	set_fileno (a_fileno: INTEGER_32)
		do
			c_set_fileno (c_pointer, a_fileno)
		end

	set_flags2 (a_flags2: INTEGER_32)
		do
			c_set_flags2 (c_pointer, a_flags2)
		end

	set_old_offset (a_old_offset: INTEGER_32)
		do
			c_set_old_offset (c_pointer, a_old_offset)
		end

	set_cur_column (a_cur_column: NATURAL_16)
		do
			c_set_cur_column (c_pointer, a_cur_column)
		end

	set_vtable_offset (a_vtable_offset: INTEGER_8)
		do
			c_set_vtable_offset (c_pointer, a_vtable_offset)
		end

	set_lock (a_lock: CE_POINTER [ANY])
		do
			c_set_lock (c_pointer, a_lock.c_pointer)
		end

	set_offset (a_offset: INTEGER_64)
		do
			c_set_offset (c_pointer, a_offset)
		end

	set_pad1 (a_pad1: CE_POINTER [ANY])
		do
			c_set_pad1 (c_pointer, a_pad1.c_pointer)
		end

	set_pad2 (a_pad2: CE_POINTER [ANY])
		do
			c_set_pad2 (c_pointer, a_pad2.c_pointer)
		end

	set_pad3 (a_pad3: CE_POINTER [ANY])
		do
			c_set_pad3 (c_pointer, a_pad3.c_pointer)
		end

	set_pad4 (a_pad4: CE_POINTER [ANY])
		do
			c_set_pad4 (c_pointer, a_pad4.c_pointer)
		end

	set_pad5 (a_pad5: NATURAL_32)
		do
			c_set_pad5 (c_pointer, a_pad5)
		end

	set_mode (a_mode: INTEGER_32)
		do
			c_set_mode (c_pointer, a_mode)
		end

feature {NONE} -- C getters

	c_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _IO_FILE *)$tmp)->_flags;"
		end

	c_IO_read_ptr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _IO_FILE *)$tmp)->_IO_read_ptr;"
		end

	c_IO_read_end (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _IO_FILE *)$tmp)->_IO_read_end;"
		end

	c_IO_read_base (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _IO_FILE *)$tmp)->_IO_read_base;"
		end

	c_IO_write_base (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _IO_FILE *)$tmp)->_IO_write_base;"
		end

	c_IO_write_ptr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _IO_FILE *)$tmp)->_IO_write_ptr;"
		end

	c_IO_write_end (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _IO_FILE *)$tmp)->_IO_write_end;"
		end

	c_IO_buf_base (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _IO_FILE *)$tmp)->_IO_buf_base;"
		end

	c_IO_buf_end (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _IO_FILE *)$tmp)->_IO_buf_end;"
		end

	c_IO_save_base (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _IO_FILE *)$tmp)->_IO_save_base;"
		end

	c_IO_backup_base (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _IO_FILE *)$tmp)->_IO_backup_base;"
		end

	c_IO_save_end (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _IO_FILE *)$tmp)->_IO_save_end;"
		end

	c_markers (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _IO_marker *)((struct _IO_FILE *)$tmp)->_markers;"
		end

	c_chain (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _IO_FILE *)((struct _IO_FILE *)$tmp)->_chain;"
		end

	c_fileno (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _IO_FILE *)$tmp)->_fileno;"
		end

	c_flags2 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _IO_FILE *)$tmp)->_flags2;"
		end

	c_old_offset (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct _IO_FILE *)$tmp)->_old_offset;"
		end

	c_cur_column (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _IO_FILE *)$tmp)->_cur_column;"
		end

	c_vtable_offset (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct _IO_FILE *)$tmp)->_vtable_offset;"
		end

	c_shortbuf (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _IO_FILE *tmp = (struct _IO_FILE *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->_shortbuf) / sizeof(tmp->_shortbuf[0]);
				return tmp->_shortbuf;
			]"
		end

	c_lock (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _IO_FILE *)$tmp)->_lock;"
		end

	c_offset (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct _IO_FILE *)$tmp)->_offset;"
		end

	c_pad1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _IO_FILE *)$tmp)->__pad1;"
		end

	c_pad2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _IO_FILE *)$tmp)->__pad2;"
		end

	c_pad3 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _IO_FILE *)$tmp)->__pad3;"
		end

	c_pad4 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _IO_FILE *)$tmp)->__pad4;"
		end

	c_pad5 (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _IO_FILE *)$tmp)->__pad5;"
		end

	c_mode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _IO_FILE *)$tmp)->_mode;"
		end

	c_unused2 (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _IO_FILE *tmp = (struct _IO_FILE *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->_unused2) / sizeof(tmp->_unused2[0]);
				return tmp->_unused2;
			]"
		end

feature {NONE} -- C setters

	c_set_flags (tmp: POINTER; a_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->_flags = $a_flags;"
		end

	c_set_IO_read_ptr (tmp: POINTER; a_IO_read_ptr: POINTER)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->_IO_read_ptr = (char *)$a_io_read_ptr;"
		end

	c_set_IO_read_end (tmp: POINTER; a_IO_read_end: POINTER)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->_IO_read_end = (char *)$a_io_read_end;"
		end

	c_set_IO_read_base (tmp: POINTER; a_IO_read_base: POINTER)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->_IO_read_base = (char *)$a_io_read_base;"
		end

	c_set_IO_write_base (tmp: POINTER; a_IO_write_base: POINTER)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->_IO_write_base = (char *)$a_io_write_base;"
		end

	c_set_IO_write_ptr (tmp: POINTER; a_IO_write_ptr: POINTER)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->_IO_write_ptr = (char *)$a_io_write_ptr;"
		end

	c_set_IO_write_end (tmp: POINTER; a_IO_write_end: POINTER)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->_IO_write_end = (char *)$a_io_write_end;"
		end

	c_set_IO_buf_base (tmp: POINTER; a_IO_buf_base: POINTER)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->_IO_buf_base = (char *)$a_io_buf_base;"
		end

	c_set_IO_buf_end (tmp: POINTER; a_IO_buf_end: POINTER)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->_IO_buf_end = (char *)$a_io_buf_end;"
		end

	c_set_IO_save_base (tmp: POINTER; a_IO_save_base: POINTER)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->_IO_save_base = (char *)$a_io_save_base;"
		end

	c_set_IO_backup_base (tmp: POINTER; a_IO_backup_base: POINTER)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->_IO_backup_base = (char *)$a_io_backup_base;"
		end

	c_set_IO_save_end (tmp: POINTER; a_IO_save_end: POINTER)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->_IO_save_end = (char *)$a_io_save_end;"
		end

	c_set_markers (tmp: POINTER; a_markers: POINTER)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->_markers = (struct _IO_marker *)$a_markers;"
		end

	c_set_chain (tmp: POINTER; a_chain: POINTER)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->_chain = (struct _IO_FILE *)$a_chain;"
		end

	c_set_fileno (tmp: POINTER; a_fileno: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->_fileno = $a_fileno;"
		end

	c_set_flags2 (tmp: POINTER; a_flags2: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->_flags2 = $a_flags2;"
		end

	c_set_old_offset (tmp: POINTER; a_old_offset: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->_old_offset = $a_old_offset;"
		end

	c_set_cur_column (tmp: POINTER; a_cur_column: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->_cur_column = $a_cur_column;"
		end

	c_set_vtable_offset (tmp: POINTER; a_vtable_offset: INTEGER_8)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->_vtable_offset = $a_vtable_offset;"
		end

	c_set_lock (tmp: POINTER; a_lock: POINTER)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->_lock = (void *)$a_lock;"
		end

	c_set_offset (tmp: POINTER; a_offset: INTEGER_64)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->_offset = $a_offset;"
		end

	c_set_pad1 (tmp: POINTER; a_pad1: POINTER)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->__pad1 = (void *)$a_pad1;"
		end

	c_set_pad2 (tmp: POINTER; a_pad2: POINTER)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->__pad2 = (void *)$a_pad2;"
		end

	c_set_pad3 (tmp: POINTER; a_pad3: POINTER)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->__pad3 = (void *)$a_pad3;"
		end

	c_set_pad4 (tmp: POINTER; a_pad4: POINTER)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->__pad4 = (void *)$a_pad4;"
		end

	c_set_pad5 (tmp: POINTER; a_pad5: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->__pad5 = $a_pad5;"
		end

	c_set_mode (tmp: POINTER; a_mode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _IO_FILE *)$tmp)->_mode = $a_mode;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <micro_httpd.h>"
		alias
			"return sizeof(struct _IO_FILE);"
		end

end
