deferred class
	S_STDIO

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	fflush (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fflush (a_stream.c_pointer)
		end

	c_fflush (a_stream: POINTER): INTEGER_32
		external
			"C inline use <micro_httpd.h>"
		alias
			"return fflush($a_stream);"
		end

	fopen (a_filename: CE_POINTER [INTEGER_8]; a_modes: CE_POINTER [INTEGER_8]): CE_POINTER [SD_IO_FILE]
		do
			create Result.make_shared (c_fopen (a_filename.c_pointer, a_modes.c_pointer))
		end

	c_fopen (a_filename: POINTER; a_modes: POINTER): POINTER
		external
			"C inline use <micro_httpd.h>"
		alias
			"return fopen($a_filename, $a_modes);"
		end

	printf (a_args: TUPLE [a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_printf)).integer_32_item (a_args)
		end

	c_printf: POINTER
		external
			"C inline use <micro_httpd.h>"
		alias
			"return &printf;"
		end

	sprintf (a_args: TUPLE [a_s: CE_POINTER [INTEGER_8]; a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_sprintf)).integer_32_item (a_args)
		end

	c_sprintf: POINTER
		external
			"C inline use <micro_httpd.h>"
		alias
			"return &sprintf;"
		end

	snprintf (a_args: TUPLE [a_s: CE_POINTER [INTEGER_8]; a_maxlen: NATURAL_32; a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_snprintf)).integer_32_item (a_args)
		end

	c_snprintf: POINTER
		external
			"C inline use <micro_httpd.h>"
		alias
			"return &snprintf;"
		end

	sscanf (a_args: TUPLE [a_s: CE_POINTER [INTEGER_8]; a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_sscanf)).integer_32_item (a_args)
		end

	c_sscanf: POINTER
		external
			"C inline use <micro_httpd.h>"
		alias
			"return &sscanf;"
		end

	putchar (a_c: INTEGER_32): INTEGER_32
		external
			"C inline use <micro_httpd.h>"
		alias
			"return putchar($a_c);"
		end

	fgets (a_s: CE_POINTER [INTEGER_8]; a_n: INTEGER_32; a_stream: CE_POINTER [SD_IO_FILE]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_fgets (a_s.c_pointer, a_n, a_stream.c_pointer))
		end

	c_fgets (a_s: POINTER; a_n: INTEGER_32; a_stream: POINTER): POINTER
		external
			"C inline use <micro_httpd.h>"
		alias
			"return fgets($a_s, $a_n, $a_stream);"
		end

	perror (a_s: CE_POINTER [INTEGER_8])
		do
			c_perror (a_s.c_pointer)
		end

	c_perror (a_s: POINTER)
		external
			"C inline use <micro_httpd.h>"
		alias
			"perror($a_s);"
		end

end
