class
	PD_TPOINT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	x: REAL_64 assign set_x
		do
			Result := c_x (c_pointer)
		end

	y: REAL_64 assign set_y
		do
			Result := c_y (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_x (a_x: REAL_64)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: REAL_64)
		do
			c_set_y (c_pointer, a_y)
		end

feature {NONE} -- C getters

	c_x (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _TPoint *)$tmp)->x;"
		end

	c_y (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _TPoint *)$tmp)->y;"
		end

feature {NONE} -- C setters

	c_set_x (tmp: POINTER; a_x: REAL_64)
		external
			"C inline"
		alias
			"((struct _TPoint *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: REAL_64)
		external
			"C inline"
		alias
			"((struct _TPoint *)$tmp)->y = $a_y;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct _TPoint);"
		end

end
