class
	P_EYES

inherit
	XEYES_DATA
		redefine
			default_create
		end
	S_X11_XLIB
	S_X11_INTRINSIC
	S_X11_COREP
	S_X11_INTRINSICP
	S_X11_STRINGDEFS
	S_X11_XMU_CONVERTERS
	S_MATH
	S_X11_EXTENSIONS_SHAPE
	S_X11_SHELL
	S_STDLIB

feature {NONE} -- Initialization

	default_create
		do
			create resources.make (<<8>>)
			create delays.make (<<5>>)
			create eyesWidgetClass.make
			create eyesClassRec.make
			create eyes_bits.make (<<192>>)
		end

feature {ANY} -- attributes

	resources: CE_ARRAY [SD_XTRESOURCE]

	delays: CE_ARRAY [INTEGER_32]

	eyesWidgetClass: CE_POINTER [SD_WIDGETCLASSREC]

	eyesClassRec: PD_EYESCLASSREC

	eyes_bits: CE_ARRAY [NATURAL_8]

feature {ANY} -- routines

	ClassInitialize
		do
			XtAddConverter ((XtStrings + 1797), ce_string ("BackingStore"), XmuCvtStringToBackingStore_address, create {CE_POINTER [SD_XTCONVERTARGREC]}.make_shared (default_pointer), {NATURAL_32} 0)
		end

	ClassInitialize_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ClassInitialize)
		end

	Initialize (a_greq: CE_POINTER [SD_WIDGETREC]; a_gnew: CE_POINTER [SD_WIDGETREC]; a_args: CE_POINTER [SD_ARG]; a_num_args: CE_POINTER [NATURAL_32])
		local
			l_w: CE_POINTER [PD_EYESREC]
			l_valuemask: NATURAL_32
			l_myXGCV: SD_XGCVALUES
			l_shape_event_base: INTEGER_32
			l_shape_error_base: INTEGER_32
			l_fg: NATURAL_32
			l_bg: NATURAL_32
			l_tmp: REAL_64
			l_tmp___0: REAL_64
			l_tmp___1: REAL_64
		do
			create l_w.make
			create l_myXGCV.make

			l_w.ce_gets (create {CE_POINTER [PD_EYESREC]}.make_cast (a_gnew))
			if (l_w.item.eyes.reverse_video).to_boolean then
				l_fg := l_w.item.eyes.puppixel
				l_bg := l_w.item.core.background_pixel
				if l_w.item.core.border_pixel = l_fg then
					l_w.item.core.border_pixel := l_bg
				end
				if l_w.item.eyes.outline = l_fg then
					l_w.item.eyes.outline := l_bg
				end
				if l_w.item.eyes.center = l_bg then
					l_w.item.eyes.center := l_fg
				end
				l_w.item.eyes.puppixel := l_bg
				l_w.item.core.background_pixel := l_fg
			end
			l_myXGCV.foreground := l_w.item.eyes.puppixel
			l_myXGCV.background := l_w.item.core.background_pixel
			l_valuemask := ((((1).bit_shift_left (2))).bit_or (((1).bit_shift_left (3)))).to_natural_32
			l_w.item.eyes.pupGC := XtGetGC (a_gnew, l_valuemask, l_myXGCV.address)
			l_myXGCV.foreground := l_w.item.eyes.outline
			l_valuemask := ((((1).bit_shift_left (2))).bit_or (((1).bit_shift_left (3)))).to_natural_32
			l_w.item.eyes.outGC := XtGetGC (a_gnew, l_valuemask, l_myXGCV.address)
			l_myXGCV.foreground := l_w.item.eyes.center
			l_myXGCV.background := l_w.item.eyes.puppixel
			l_valuemask := ((((1).bit_shift_left (2))).bit_or (((1).bit_shift_left (3)))).to_natural_32
			l_w.item.eyes.centerGC := XtGetGC (a_gnew, l_valuemask, l_myXGCV.address)
			l_w.item.eyes.update := 0
			l_w.item.eyes.interval_id := {NATURAL_32} 0
			l_tmp := (-1000).to_double
			l_w.item.eyes.pupil[1].x := l_tmp
			l_w.item.eyes.pupil[0].x := l_tmp
			l_tmp___0 := (-1000).to_double
			l_w.item.eyes.pupil[1].y := l_tmp___0
			l_w.item.eyes.pupil[0].y := l_tmp___0
			l_tmp___1 := (-1000).to_double
			l_w.item.eyes.mouse.y := l_tmp___1
			l_w.item.eyes.mouse.x := l_tmp___1
			if (l_w.item.eyes.shape_window).to_boolean then
				if not (XShapeQueryExtension ((l_w.item.core.screen).item.display, create {CE_POINTER [INTEGER_32]}.make_shared ($l_shape_event_base), create {CE_POINTER [INTEGER_32]}.make_shared ($l_shape_error_base))).to_boolean then
					l_w.item.eyes.shape_window := (0).to_integer_8
				end
			end
			l_w.item.eyes.shape_mask := {NATURAL_32} 0
			l_w.item.eyes.shapeGC := create {CE_POINTER [ANY]}.make_shared (default_pointer)
		end

	Initialize_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent Initialize)
		end

	eyeLiner (a_w: CE_POINTER [PD_EYESREC]; a_d: NATURAL_32; a_outgc: CE_POINTER [ANY]; a_centergc: CE_POINTER [ANY]; a_num: INTEGER_32)
		local
			l_dpy: CE_POINTER [ANY]
		do
			create l_dpy.make

			l_dpy.ce_gets ((a_w.item.core.screen).item.display)
			transform_inst.TFillArc (l_dpy, a_d, a_outgc, create {CE_POINTER [PD_TRANSFORM]}.make_shared (a_w.c_pointer + {PD_EYESREC}.eyes_offset + {PD_EYESPART}.t_offset), (a_num.to_double * 2.0 - (2.0 - (0.175 + 0.1) * (2).to_double) / 2.0) - 0.175, (0.0 - (2.0 - (0.175 + 0.1) * (2).to_double) / 2.0) - 0.175, (2.0 - (0.175 + 0.1) * (2).to_double) + 0.175 * 2.0, (2.0 - (0.175 + 0.1) * (2).to_double) + 0.175 * 2.0, 5760, 23040)
			if ((a_centergc).c_pointer /= default_pointer) then
				transform_inst.TFillArc (l_dpy, a_d, a_centergc, create {CE_POINTER [PD_TRANSFORM]}.make_shared (a_w.c_pointer + {PD_EYESREC}.eyes_offset + {PD_EYESPART}.t_offset), a_num.to_double * 2.0 - (2.0 - (0.175 + 0.1) * (2).to_double) / 2.0, 0.0 - (2.0 - (0.175 + 0.1) * (2).to_double) / 2.0, 2.0 - (0.175 + 0.1) * (2).to_double, 2.0 - (0.175 + 0.1) * (2).to_double, 5760, 23040)
			end
		end

	computePupil (a_num: INTEGER_32; a_mouse: PD_TPOINT): PD_TPOINT
		local
			l_cx: REAL_64
			l_cy: REAL_64
			l_dist: REAL_64
			l_angle: REAL_64
			l_x: REAL_64
			l_y: REAL_64
			l_h: REAL_64
			l_dx: REAL_64
			l_dy: REAL_64
			l_cosa: REAL_64
			l_sina: REAL_64
			l_ret: PD_TPOINT
			l_pos: INTEGER_32
		do
			create l_ret.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dx := a_mouse.x - a_num.to_double * 2.0
					l_dy := a_mouse.y - 0.0
					if l_dx /= (0).to_double then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_dy = (0).to_double then
							l_cx := a_num.to_double * 2.0
							l_cy := 0.0
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						l_angle := atan2 (l_dy, l_dx)
						l_cosa := cos (l_angle)
						l_sina := sin (l_angle)
						l_h := hypot (((2.0 - (0.175 + 0.1) * (2).to_double) / 2.0) * l_cosa, ((2.0 - (0.175 + 0.1) * (2).to_double) / 2.0) * l_sina)
						l_x := ((((2.0 - (0.175 + 0.1) * (2).to_double) / 2.0) * ((2.0 - (0.175 + 0.1) * (2).to_double) / 2.0)) * l_cosa) / l_h
						l_y := ((((2.0 - (0.175 + 0.1) * (2).to_double) / 2.0) * ((2.0 - (0.175 + 0.1) * (2).to_double) / 2.0)) * l_sina) / l_h
						l_dist := (((2.0 - (0.175 + 0.1) * (2).to_double) - 0.3) / 2.0 - 0.05) * (hypot (l_x, l_y))
						if l_dist > (hypot (l_dx, l_dy)) then
							l_cx := l_dx + a_num.to_double * 2.0
							l_cy := l_dy + 0.0
						else
							l_cx := l_dist * l_cosa + a_num.to_double * 2.0
							l_cy := l_dist * l_sina + 0.0
						end
				when 4 then
					l_ret.x := l_cx
					l_ret.y := l_cy
					Result := l_ret
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	computePupils (a_mouse: PD_TPOINT; a_pupils: CE_POINTER [PD_TPOINT])
		do
			a_pupils[0] := computePupil (0, a_mouse)
			a_pupils[1] := computePupil (1, a_mouse)
		end

	eyeBall (a_w: CE_POINTER [PD_EYESREC]; a_gc: CE_POINTER [ANY]; a_num: INTEGER_32)
		local
			l_dpy: CE_POINTER [ANY]
			l_win: NATURAL_32
		do
			create l_dpy.make

			l_dpy.ce_gets ((a_w.item.core.screen).item.display)
			l_win := a_w.item.core.window
			transform_inst.TFillArc (l_dpy, l_win, a_gc, create {CE_POINTER [PD_TRANSFORM]}.make_shared (a_w.c_pointer + {PD_EYESREC}.eyes_offset + {PD_EYESPART}.t_offset), a_w.item.eyes.pupil[a_num].x - 0.3 / 2.0, a_w.item.eyes.pupil[a_num].y - 0.3 / 2.0, 0.3, 0.3, 5760, 23040)
		end

	repaint_window (a_w: CE_POINTER [PD_EYESREC])
		do
			if (XtWindowOfObject (create {CE_POINTER [SD_WIDGETREC]}.make_cast (a_w))) /= {NATURAL_32} 0 then
				eyeLiner (a_w, a_w.item.core.window, a_w.item.eyes.outGC, a_w.item.eyes.centerGC, 0)
				eyeLiner (a_w, a_w.item.core.window, a_w.item.eyes.outGC, a_w.item.eyes.centerGC, 1)
				computePupils (a_w.item.eyes.mouse, create {CE_POINTER [PD_TPOINT]}.make_cast ((a_w.item.eyes.pupil)))
				eyeBall (a_w, a_w.item.eyes.pupGC, 0)
				eyeBall (a_w, a_w.item.eyes.pupGC, 1)
			end
		end

	draw_it (a_client_data: CE_POINTER [ANY]; a_id: CE_POINTER [NATURAL_32])
		local
			l_w: CE_POINTER [PD_EYESREC]
			l_rep_root: NATURAL_32
			l_rep_child: NATURAL_32
			l_rep_rootx: INTEGER_32
			l_rep_rooty: INTEGER_32
			l_rep_mask: NATURAL_32
			l_dx: INTEGER_32
			l_dy: INTEGER_32
			l_mouse: PD_TPOINT
			l_dpy: CE_POINTER [ANY]
			l_win: NATURAL_32
			l_newpupil: CE_ARRAY [PD_TPOINT]
			l_xnewpupil: SD_XPOINT
			l_xpupil: SD_XPOINT
			l_pos: INTEGER_32
		do
			create l_w.make
			create l_mouse.make
			create l_dpy.make
			create l_newpupil.make (<<2>>)
			create l_xnewpupil.make
			create l_xpupil.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_w.ce_gets (create {CE_POINTER [PD_EYESREC]}.make_cast (a_client_data))
					l_dpy.ce_gets ((l_w.item.core.screen).item.display)
					l_win := l_w.item.core.window
					if (XtWindowOfObject (create {CE_POINTER [SD_WIDGETREC]}.make_cast (l_w))) = {NATURAL_32} 0 then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						XQueryPointer (l_dpy, l_win, create {CE_POINTER [NATURAL_32]}.make_shared ($l_rep_root), create {CE_POINTER [NATURAL_32]}.make_shared ($l_rep_child), create {CE_POINTER [INTEGER_32]}.make_shared ($l_rep_rootx), create {CE_POINTER [INTEGER_32]}.make_shared ($l_rep_rooty), create {CE_POINTER [INTEGER_32]}.make_shared ($l_dx), create {CE_POINTER [INTEGER_32]}.make_shared ($l_dy), create {CE_POINTER [NATURAL_32]}.make_shared ($l_rep_mask)).do_nothing
						l_mouse.x := (l_dx.to_double - l_w.item.eyes.t.bx) / l_w.item.eyes.t.mx
						l_mouse.y := (l_dy.to_double - l_w.item.eyes.t.by) / l_w.item.eyes.t.my
						if l_mouse.x /= l_w.item.eyes.mouse.x then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_mouse.y = l_w.item.eyes.mouse.y then
							if delays[l_w.item.eyes.update + 1] /= 0 then
								l_w.item.eyes.update := (l_w.item.eyes.update) + 1
							end
						else
							l_pos := -1 + 4 -- goto _L___1
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 4 then -- else: | _L___1:
						computePupils (l_mouse, create {CE_POINTER [PD_TPOINT]}.make_cast (l_newpupil))
						l_xpupil.x := ((l_w.item.eyes.t.mx * l_w.item.eyes.pupil[0].x + l_w.item.eyes.t.bx) + 0.5).truncated_to_integer.to_integer_16
						l_xpupil.y := ((l_w.item.eyes.t.my * l_w.item.eyes.pupil[0].y + l_w.item.eyes.t.by) + 0.5).truncated_to_integer.to_integer_16
						l_xnewpupil.x := ((l_w.item.eyes.t.mx * l_newpupil[0].x + l_w.item.eyes.t.bx) + 0.5).truncated_to_integer.to_integer_16
						l_xnewpupil.y := ((l_w.item.eyes.t.my * l_newpupil[0].y + l_w.item.eyes.t.by) + 0.5).truncated_to_integer.to_integer_16
						if (l_xpupil.x).to_integer_32 /= (l_xnewpupil.x).to_integer_32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (l_xpupil.y).to_integer_32 /= (l_xnewpupil.y).to_integer_32 then
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if l_w.item.eyes.pupil[0].x /= (-1000).to_double then
							eyeBall (l_w, l_w.item.eyes.centerGC, 0)
						elseif l_w.item.eyes.pupil[0].y /= (-1000).to_double then
							eyeBall (l_w, l_w.item.eyes.centerGC, 0)
						end
						l_w.item.eyes.pupil[0] := l_newpupil[0]
						eyeBall (l_w, l_w.item.eyes.pupGC, 0)
				when 8 then
						l_xpupil.x := ((l_w.item.eyes.t.mx * l_w.item.eyes.pupil[1].x + l_w.item.eyes.t.bx) + 0.5).truncated_to_integer.to_integer_16
						l_xpupil.y := ((l_w.item.eyes.t.my * l_w.item.eyes.pupil[1].y + l_w.item.eyes.t.by) + 0.5).truncated_to_integer.to_integer_16
						l_xnewpupil.x := ((l_w.item.eyes.t.mx * l_newpupil[1].x + l_w.item.eyes.t.bx) + 0.5).truncated_to_integer.to_integer_16
						l_xnewpupil.y := ((l_w.item.eyes.t.my * l_newpupil[1].y + l_w.item.eyes.t.by) + 0.5).truncated_to_integer.to_integer_16
						if (l_xpupil.x).to_integer_32 /= (l_xnewpupil.x).to_integer_32 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if (l_xpupil.y).to_integer_32 /= (l_xnewpupil.y).to_integer_32 then
							l_pos := -1 + 11 -- goto _L___0
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L___0:
						if l_w.item.eyes.pupil[1].x /= (-1).to_double then
							eyeBall (l_w, l_w.item.eyes.centerGC, 1)
						elseif l_w.item.eyes.pupil[1].y /= (-1).to_double then
							eyeBall (l_w, l_w.item.eyes.centerGC, 1)
						end
						l_w.item.eyes.pupil[1] := l_newpupil[1]
						eyeBall (l_w, l_w.item.eyes.pupGC, 1)
				when 12 then
						l_w.item.eyes.mouse := l_mouse
						l_w.item.eyes.update := 0
				when 13 then -- if done
						l_w.item.eyes.interval_id := XtAppAddTimeOut ((XtWidgetToApplicationContext (create {CE_POINTER [SD_WIDGETREC]}.make_cast (l_w))), (delays[l_w.item.eyes.update]).to_natural_32, draw_it_address, create {CE_POINTER [ANY]}.make_cast (l_w))
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	draw_it_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent draw_it)
		end

	Resize (a_gw: CE_POINTER [SD_WIDGETREC])
		local
			l_w: CE_POINTER [PD_EYESREC]
			l_xgcv: SD_XGCVALUES
			l_parent: CE_POINTER [SD_WIDGETREC]
			l_x: INTEGER_32
			l_y: INTEGER_32
		do
			create l_w.make
			create l_xgcv.make
			create l_parent.make

			l_w.ce_gets (create {CE_POINTER [PD_EYESREC]}.make_cast (a_gw))
			if (XtWindowOfObject (a_gw)) /= {NATURAL_32} 0 then
				XClearWindow ((l_w.item.core.screen).item.display, l_w.item.core.window).do_nothing
				transform_inst.SetTransform (create {CE_POINTER [PD_TRANSFORM]}.make_shared (l_w.c_pointer + {PD_EYESREC}.eyes_offset + {PD_EYESPART}.t_offset), 0, (l_w.item.core.width).to_integer_32, (l_w.item.core.height).to_integer_32, 0, -1.0 + 0.1, 3.0 - 0.1, -1.0 + 0.1, 1.0 - 0.1)
				if (l_w.item.eyes.shape_window).to_boolean then
					l_w.item.eyes.shape_mask := XCreatePixmap ((l_w.item.core.screen).item.display, l_w.item.core.window, (l_w.item.core.width).to_natural_32, (l_w.item.core.height).to_natural_32, {NATURAL_32} 1)
					if (l_w.item.eyes.shapeGC).c_pointer = default_pointer then
						l_w.item.eyes.shapeGC := XCreateGC ((l_w.item.core.screen).item.display, l_w.item.eyes.shape_mask, {NATURAL_32} 0, l_xgcv.address)
					end
					XSetForeground ((l_w.item.core.screen).item.display, l_w.item.eyes.shapeGC, {NATURAL_32} 0).do_nothing
					XFillRectangle ((l_w.item.core.screen).item.display, l_w.item.eyes.shape_mask, l_w.item.eyes.shapeGC, 0, 0, (l_w.item.core.width).to_natural_32, (l_w.item.core.height).to_natural_32).do_nothing
					XSetForeground ((l_w.item.core.screen).item.display, l_w.item.eyes.shapeGC, {NATURAL_32} 1).do_nothing
					eyeLiner (l_w, l_w.item.eyes.shape_mask, l_w.item.eyes.shapeGC, create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
					eyeLiner (l_w, l_w.item.eyes.shape_mask, l_w.item.eyes.shapeGC, create {CE_POINTER [ANY]}.make_shared (default_pointer), 1)
					l_y := 0
					l_x := l_y
					l_parent.ce_gets (create {CE_POINTER [SD_WIDGETREC]}.make_cast (l_w))
					from
					until
						(l_parent.item.core.parent).c_pointer = default_pointer
					loop
						l_x := l_x + ((l_parent.item.core.x).to_integer_32 + (l_parent.item.core.border_width).to_integer_32)
						l_x := l_x + ((l_parent.item.core.y).to_integer_32 + (l_parent.item.core.border_width).to_integer_32)
						l_parent.ce_gets (l_parent.item.core.parent)
					end
					XShapeCombineMask ((l_parent.item.core.screen).item.display, l_parent.item.core.window, 0, l_x, l_y, l_w.item.eyes.shape_mask, 0)
					XFreePixmap ((l_w.item.core.screen).item.display, l_w.item.eyes.shape_mask).do_nothing
				end
			end
		end

	Resize_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent Resize)
		end

	Realize (a_gw: CE_POINTER [SD_WIDGETREC]; a_valueMask: CE_POINTER [NATURAL_32]; a_attrs: CE_POINTER [SD_XSETWINDOWATTRIBUTES])
		local
			l_w: CE_POINTER [PD_EYESREC]
		do
			create l_w.make

			l_w.ce_gets (create {CE_POINTER [PD_EYESREC]}.make_cast (a_gw))
			if l_w.item.eyes.backing_store /= 3 then
				a_attrs.item.backing_store := l_w.item.eyes.backing_store
				a_valueMask.item := (a_valueMask.item).bit_or (((1).bit_shift_left (6)).to_natural_32)
			end
			XtCreateWindow (a_gw, {NATURAL_32} 1, create {CE_POINTER [SD_VISUAL]}.make_shared (default_pointer), a_valueMask.item, a_attrs)
			Resize (a_gw)
			l_w.item.eyes.interval_id := XtAppAddTimeOut ((XtWidgetToApplicationContext (a_gw)), (delays[l_w.item.eyes.update]).to_natural_32, draw_it_address, create {CE_POINTER [ANY]}.make_cast (a_gw))
		end

	Realize_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent Realize)
		end

	Destroy (a_gw: CE_POINTER [SD_WIDGETREC])
		local
			l_w: CE_POINTER [PD_EYESREC]
		do
			create l_w.make

			l_w.ce_gets (create {CE_POINTER [PD_EYESREC]}.make_cast (a_gw))
			if (l_w.item.eyes.interval_id).to_boolean then
				XtRemoveTimeOut (l_w.item.eyes.interval_id)
			end
			XtReleaseGC (a_gw, l_w.item.eyes.pupGC)
			XtReleaseGC (a_gw, l_w.item.eyes.outGC)
			XtReleaseGC (a_gw, l_w.item.eyes.centerGC)
		end

	Destroy_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent Destroy)
		end

	Redisplay (a_gw: CE_POINTER [SD_WIDGETREC]; a_event: CE_POINTER [SD_XEVENT]; a_region: CE_POINTER [ANY])
		local
			l_w: CE_POINTER [PD_EYESREC]
		do
			create l_w.make

			l_w.ce_gets (create {CE_POINTER [PD_EYESREC]}.make_cast (a_gw))
			l_w.item.eyes.pupil[0].x := (-1000).to_double
			l_w.item.eyes.pupil[0].y := (-1000).to_double
			l_w.item.eyes.pupil[1].x := (-1000).to_double
			l_w.item.eyes.pupil[1].y := (-1000).to_double
			repaint_window (create {CE_POINTER [PD_EYESREC]}.make_cast (a_gw))
		end

	Redisplay_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent Redisplay)
		end

	SetValues (a_current: CE_POINTER [SD_WIDGETREC]; a_request: CE_POINTER [SD_WIDGETREC]; a_new: CE_POINTER [SD_WIDGETREC]; a_args: CE_POINTER [SD_ARG]; a_num_args: CE_POINTER [NATURAL_32]): INTEGER_8
		do
			Result := (0).to_integer_8
		end

	SetValues_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent SetValues)
		end

end
