class
	P_XEYES

inherit
	XEYES_DATA
		redefine
			default_create
		end
	S_X11_XLIB
	S_X11_INTRINSIC
	S_X11_COREP
	S_X11_INTRINSICP
	S_X11_STRINGDEFS
	S_X11_XMU_CONVERTERS
	S_MATH
	S_X11_EXTENSIONS_SHAPE
	S_X11_SHELL
	S_STDLIB

feature {NONE} -- Initialization

	default_create
		do
			create options.make (<<5>>)
			create actions.make (<<1>>)
		end

feature {ANY} -- attributes

	options: CE_ARRAY [SD_XRMOPTIONDESCREC]

	wm_delete_window: NATURAL_32 assign set_wm_delete_window
		do
			Result := wm_delete_window_address[0]
		end

	set_wm_delete_window (a_wm_delete_window: NATURAL_32)
		do
			wm_delete_window_address[0] := a_wm_delete_window
		end

	wm_delete_window_address: CE_POINTER [NATURAL_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Natural_32_bytes))
		end

	actions: CE_ARRAY [SD_XTACTIONSREC]

feature {ANY} -- routines

	usage
		do
			Io.error.put_string ("usage: xeyes%N")
			Io.error.put_string ("       [-geometry [{width}][x{height}][{+-}{xoff}[{+-}{yoff}]]] [-display [{host}]:[{vs}]]%N")
			Io.error.put_string ("       [-fg {color}] [-bg {color}] [-bd {color}] [-bw {pixels}]")
			Io.error.put_string (" [-shape | +shape]")
			Io.error.put_string ("%N")
			Io.error.put_string ("       [-outline {color}] [-center {color}] [-backing {backing-store}]%N")
			exit (1)
		end

	quit (a_w: CE_POINTER [SD_WIDGETREC]; a_event: CE_POINTER [SD_XEVENT]; a_params: CE_POINTER [CE_POINTER [INTEGER_8]]; a_num_params: CE_POINTER [NATURAL_32])
		local
			l_tmp___0: CE_POINTER [ANY]
		do
			create l_tmp___0.make

			if a_event.item.type = 33 then
				if (a_event.item.xclient.data.l[0]).to_natural_32 /= wm_delete_window then
					XBell ((XtDisplay (a_w)), 0).do_nothing
				else
					l_tmp___0.ce_gets (XtWidgetToApplicationContext (a_w))
					XtDestroyApplicationContext (l_tmp___0)
					exit (0)
				end
			else
				l_tmp___0.ce_gets (XtWidgetToApplicationContext (a_w))
				XtDestroyApplicationContext (l_tmp___0)
				exit (0)
			end
		end

	quit_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent quit)
		end

	main (a_argc: INTEGER_32; a_argv: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_argc: INTEGER_32
			l_app_context: CE_POINTER [ANY]
			l_toplevel: CE_POINTER [SD_WIDGETREC]
			l_arg: CE_ARRAY [SD_ARG]
			l_i: NATURAL_32
			l_tmp___1: CE_POINTER [SD_SCREEN]
			l_tmp___4: CE_POINTER [SD_SCREEN]
			l_tmp___7: NATURAL_32
		do
			create l_app_context.make
			create l_toplevel.make
			create l_arg.make (<<2>>)
			create l_tmp___1.make
			create l_tmp___4.make

			l_argc := a_argc
			XtSetLanguageProc (create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
			l_toplevel.ce_gets (XtAppInitialize (l_app_context.address, ce_string ("XEyes"), options, ({SD_XRMOPTIONDESCREC}.sizeof.to_natural_32 * (5).to_natural_32) // {SD_XRMOPTIONDESCREC}.sizeof.to_natural_32, create {CE_POINTER [INTEGER_32]}.make_shared ($l_argc), a_argv, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), l_arg, {NATURAL_32} 0))
			if l_argc /= 1 then
				usage
			end
			Current.wm_delete_window := XInternAtom ((XtDisplay (l_toplevel)), ce_string ("WM_DELETE_WINDOW"), 0)
			XtAppAddActions (l_app_context, actions, ({SD_XTACTIONSREC}.sizeof.to_natural_32 * (1).to_natural_32) // {SD_XTACTIONSREC}.sizeof.to_natural_32)
			XtOverrideTranslations (l_toplevel, (XtParseTranslationTable (ce_string ("<Message>WM_PROTOCOLS: quit()"))))
			l_i := {NATURAL_32} 0
			l_arg[l_i.to_integer_32].name := (XtShellStrings + 18)
			l_tmp___1.ce_gets (XtScreen (l_toplevel))
			l_arg[l_i.to_integer_32].value := (XCreateBitmapFromData ((XtDisplay (l_toplevel)), l_tmp___1.item.root, create {CE_POINTER [INTEGER_8]}.make_cast (eyes_inst.eyes_bits), {NATURAL_32} 48, {NATURAL_32} 32)).to_integer_32
			l_i := l_i + 1
			l_arg[l_i.to_integer_32].name := (XtShellStrings + 62)
			l_tmp___4.ce_gets (XtScreen (l_toplevel))
			l_arg[l_i.to_integer_32].value := (XCreateBitmapFromData ((XtDisplay (l_toplevel)), l_tmp___4.item.root, create {CE_POINTER [INTEGER_8]}.make_cast (eyesmask_inst.eyesmask_bits), {NATURAL_32} 48, {NATURAL_32} 32)).to_integer_32
			l_i := l_i + 1
			XtSetValues (l_toplevel, l_arg, l_i)
			XtCreateManagedWidget (ce_string ("eyes"), eyes_inst.eyesWidgetClass, l_toplevel, create {CE_POINTER [SD_ARG]}.make_shared (default_pointer), {NATURAL_32} 0).do_nothing
			XtRealizeWidget (l_toplevel)
			l_tmp___7 := XtWindow (l_toplevel)
			XSetWMProtocols ((XtDisplay (l_toplevel)), l_tmp___7, wm_delete_window_address, 1).do_nothing
			XtAppMainLoop (l_app_context)
			Result := 0
		end

end
