class
	SD_XTCALLBACKREC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	callback: CE_ROUTINE assign set_callback
		do
			create Result.make_shared (c_callback (c_pointer))
		end

	closure: CE_POINTER [ANY] assign set_closure
		do
			create Result.make_shared (c_closure (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_callback (a_callback: CE_ROUTINE)
		do
			c_set_callback (c_pointer, a_callback.c_pointer)
		end

	set_closure (a_closure: CE_POINTER [ANY])
		do
			c_set_closure (c_pointer, a_closure.c_pointer)
		end

feature {NONE} -- C getters

	c_callback (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _WidgetRec *, void *, void *))((struct _XtCallbackRec *)$tmp)->callback;"
		end

	c_closure (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _XtCallbackRec *)$tmp)->closure;"
		end

feature {NONE} -- C setters

	c_set_callback (tmp: POINTER; a_callback: POINTER)
		external
			"C inline"
		alias
			"((struct _XtCallbackRec *)$tmp)->callback = (void( *)(struct _WidgetRec *, void *, void *))$a_callback;"
		end

	c_set_closure (tmp: POINTER; a_closure: POINTER)
		external
			"C inline"
		alias
			"((struct _XtCallbackRec *)$tmp)->closure = (void *)$a_closure;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct _XtCallbackRec);"
		end

end
