class
	SD_XTRESOURCE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	resource_name: CE_POINTER [INTEGER_8] assign set_resource_name
		do
			create Result.make_shared (c_resource_name (c_pointer))
		end

	resource_class: CE_POINTER [INTEGER_8] assign set_resource_class
		do
			create Result.make_shared (c_resource_class (c_pointer))
		end

	resource_type: CE_POINTER [INTEGER_8] assign set_resource_type
		do
			create Result.make_shared (c_resource_type (c_pointer))
		end

	resource_size: NATURAL_32 assign set_resource_size
		do
			Result := c_resource_size (c_pointer)
		end

	resource_offset: NATURAL_32 assign set_resource_offset
		do
			Result := c_resource_offset (c_pointer)
		end

	default_type: CE_POINTER [INTEGER_8] assign set_default_type
		do
			create Result.make_shared (c_default_type (c_pointer))
		end

	default_addr: CE_POINTER [ANY] assign set_default_addr
		do
			create Result.make_shared (c_default_addr (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_resource_name (a_resource_name: CE_POINTER [INTEGER_8])
		do
			c_set_resource_name (c_pointer, a_resource_name.c_pointer)
		end

	set_resource_class (a_resource_class: CE_POINTER [INTEGER_8])
		do
			c_set_resource_class (c_pointer, a_resource_class.c_pointer)
		end

	set_resource_type (a_resource_type: CE_POINTER [INTEGER_8])
		do
			c_set_resource_type (c_pointer, a_resource_type.c_pointer)
		end

	set_resource_size (a_resource_size: NATURAL_32)
		do
			c_set_resource_size (c_pointer, a_resource_size)
		end

	set_resource_offset (a_resource_offset: NATURAL_32)
		do
			c_set_resource_offset (c_pointer, a_resource_offset)
		end

	set_default_type (a_default_type: CE_POINTER [INTEGER_8])
		do
			c_set_default_type (c_pointer, a_default_type.c_pointer)
		end

	set_default_addr (a_default_addr: CE_POINTER [ANY])
		do
			c_set_default_addr (c_pointer, a_default_addr.c_pointer)
		end

feature {NONE} -- C getters

	c_resource_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _XtResource *)$tmp)->resource_name;"
		end

	c_resource_class (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _XtResource *)$tmp)->resource_class;"
		end

	c_resource_type (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _XtResource *)$tmp)->resource_type;"
		end

	c_resource_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _XtResource *)$tmp)->resource_size;"
		end

	c_resource_offset (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _XtResource *)$tmp)->resource_offset;"
		end

	c_default_type (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _XtResource *)$tmp)->default_type;"
		end

	c_default_addr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _XtResource *)$tmp)->default_addr;"
		end

feature {NONE} -- C setters

	c_set_resource_name (tmp: POINTER; a_resource_name: POINTER)
		external
			"C inline"
		alias
			"((struct _XtResource *)$tmp)->resource_name = (char *)$a_resource_name;"
		end

	c_set_resource_class (tmp: POINTER; a_resource_class: POINTER)
		external
			"C inline"
		alias
			"((struct _XtResource *)$tmp)->resource_class = (char *)$a_resource_class;"
		end

	c_set_resource_type (tmp: POINTER; a_resource_type: POINTER)
		external
			"C inline"
		alias
			"((struct _XtResource *)$tmp)->resource_type = (char *)$a_resource_type;"
		end

	c_set_resource_size (tmp: POINTER; a_resource_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _XtResource *)$tmp)->resource_size = $a_resource_size;"
		end

	c_set_resource_offset (tmp: POINTER; a_resource_offset: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _XtResource *)$tmp)->resource_offset = $a_resource_offset;"
		end

	c_set_default_type (tmp: POINTER; a_default_type: POINTER)
		external
			"C inline"
		alias
			"((struct _XtResource *)$tmp)->default_type = (char *)$a_default_type;"
		end

	c_set_default_addr (tmp: POINTER; a_default_addr: POINTER)
		external
			"C inline"
		alias
			"((struct _XtResource *)$tmp)->default_addr = (void *)$a_default_addr;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct _XtResource);"
		end

end
