class
	SD_XTTMREC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	translations: CE_POINTER [ANY] assign set_translations
		do
			create Result.make_shared (c_translations (c_pointer))
		end

	proc_table: CE_POINTER [CE_ROUTINE] assign set_proc_table
		do
			create Result.make_shared (c_proc_table (c_pointer))
		end

	current_state: CE_POINTER [ANY] assign set_current_state
		do
			create Result.make_shared (c_current_state (c_pointer))
		end

	lastEventTime: NATURAL_32 assign set_lastEventTime
		do
			Result := c_lastEventTime (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_translations (a_translations: CE_POINTER [ANY])
		do
			c_set_translations (c_pointer, a_translations.c_pointer)
		end

	set_proc_table (a_proc_table: CE_POINTER [CE_ROUTINE])
		do
			c_set_proc_table (c_pointer, a_proc_table.c_pointer)
		end

	set_current_state (a_current_state: CE_POINTER [ANY])
		do
			c_set_current_state (c_pointer, a_current_state.c_pointer)
		end

	set_lastEventTime (a_lastEventTime: NATURAL_32)
		do
			c_set_lastEventTime (c_pointer, a_lastEventTime)
		end

feature {NONE} -- C getters

	c_translations (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _XtTMRec *)$tmp)->translations;"
		end

	c_proc_table (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( * *)(struct _WidgetRec *, union _XEvent *, char * *, unsigned int *))((struct _XtTMRec *)$tmp)->proc_table;"
		end

	c_current_state (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _XtTMRec *)$tmp)->current_state;"
		end

	c_lastEventTime (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct _XtTMRec *)$tmp)->lastEventTime;"
		end

feature {NONE} -- C setters

	c_set_translations (tmp: POINTER; a_translations: POINTER)
		external
			"C inline"
		alias
			"((struct _XtTMRec *)$tmp)->translations = (void *)$a_translations;"
		end

	c_set_proc_table (tmp: POINTER; a_proc_table: POINTER)
		external
			"C inline"
		alias
			"((struct _XtTMRec *)$tmp)->proc_table = (void( * *)(struct _WidgetRec *, union _XEvent *, char * *, unsigned int *))$a_proc_table;"
		end

	c_set_current_state (tmp: POINTER; a_current_state: POINTER)
		external
			"C inline"
		alias
			"((struct _XtTMRec *)$tmp)->current_state = (void *)$a_current_state;"
		end

	c_set_lastEventTime (tmp: POINTER; a_lastEventTime: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _XtTMRec *)$tmp)->lastEventTime = $a_lasteventtime;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct _XtTMRec);"
		end

end
