expanded class
	REAL_96

inherit
	COMPARABLE
		redefine
			default_create,
			is_equal
		end

feature {NONE}

	default_create
		do
			c_pointer := c_pointer.memory_calloc (1, {CE_UTILITIES}.Real_96_bytes)
		end

feature {ANY}

	address: CE_POINTER [REAL_96]
		do
			create Result.make_shared (c_pointer)
		end

	c_pointer: POINTER

feature {ANY}

	plus alias "+" (other: REAL_96): REAL_96
		do
			c_plus (Result.c_pointer, c_pointer, other.c_pointer)
		end

	minus alias "-" (other: REAL_96): REAL_96
		do
			c_minus (Result.c_pointer, c_pointer, other.c_pointer)
		end

	product alias "*" (other: REAL_96): REAL_96
		do
			c_product (Result.c_pointer, c_pointer, other.c_pointer)
		end

	quotient alias "/" (other: REAL_96): REAL_96
		do
			c_quotient (Result.c_pointer, c_pointer, other.c_pointer)
		end

	identity alias "+": REAL_96
		do
			c_identity (Result.c_pointer, c_pointer)
		end

	opposite alias "-": REAL_96
		do
			c_opposite (Result.c_pointer, c_pointer)
		end

	is_equal (a_other: REAL_96): BOOLEAN
		do
			Result := c_is_equal (c_pointer, a_other.c_pointer)
		end

	is_less alias "<" (other: REAL_96): BOOLEAN
		do
			Result := c_is_less (c_pointer, other.c_pointer)
		end

feature {ANY}

	truncated_to_real_32: REAL_32
		do
			Result := c_truncated_to_real_32 (c_pointer)
		end

	truncated_to_real_64: REAL_64
		do
			Result := c_truncated_to_real_64 (c_pointer)
		end

feature {ANY}

	set_from_integer_8 (a_value: INTEGER_8)
		do
			c_set_from_integer_8 (c_pointer, a_value)
		end

	set_from_integer_16 (a_value: INTEGER_16)
		do
			c_set_from_integer_16 (c_pointer, a_value)
		end

	set_from_integer_32 (a_value: INTEGER_32)
		do
			c_set_from_integer_32 (c_pointer, a_value)
		end

	set_from_integer_64 (a_value: INTEGER_64)
		do
			c_set_from_integer_64 (c_pointer, a_value)
		end

	set_from_natural_8 (a_value: NATURAL_8)
		do
			c_set_from_natural_8 (c_pointer, a_value)
		end

	set_from_natural_16 (a_value: NATURAL_16)
		do
			c_set_from_natural_16 (c_pointer, a_value)
		end

	set_from_natural_32 (a_value: NATURAL_32)
		do
			c_set_from_natural_32 (c_pointer, a_value)
		end

	set_from_natural_64 (a_value: NATURAL_64)
		do
			c_set_from_natural_64 (c_pointer, a_value)
		end

	set_from_real_32 (a_value: REAL_32)
		do
			c_set_from_real_32 (c_pointer, a_value)
		end

	set_from_real_64 (a_value: REAL_64)
		do
			c_set_from_real_64 (c_pointer, a_value)
		end

feature {NONE}

	c_plus (a_res, a_data, a_other_data: POINTER)
		external
			"C inline"
		alias
			"*(long double *)$a_res = *(long double *)$a_data + *(long double *)$a_other_data;"
		end

	c_minus (a_res, a_data, a_other_data: POINTER)
		external
			"C inline"
		alias
			"*(long double *)$a_res = *(long double *)$a_data - *(long double *)$a_other_data;"
		end

	c_product (a_res, a_data, a_other_data: POINTER)
		external
			"C inline"
		alias
			"*(long double *)$a_res = *(long double *)$a_data * *(long double *)$a_other_data;"
		end

	c_quotient (a_res, a_data, a_other_data: POINTER)
		external
			"C inline"
		alias
			"*(long double *)$a_res = *(long double *)$a_data / *(long double *)$a_other_data;"
		end

	c_identity (a_res, a_data: POINTER)
		external
			"C inline"
		alias
			"*(long double *)$a_res = +*(long double *)$a_data;"
		end

	c_opposite (a_res, a_data: POINTER)
		external
			"C inline"
		alias
			"*(long double *)$a_res = -*(long double *)$a_data;"
		end

	c_is_equal (a_data, a_other_data: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return *(long double *)$a_data == *(long double *)$a_other_data;"
		end

	c_is_less (a_data, a_other_data: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return *(long double *)$a_data < *(long double *)$a_other_data;"
		end

feature {NONE}

	c_truncated_to_real_32 (a_data: POINTER): REAL_32
		external
			"C inline"
		alias
			"return (float)*(long double *)$a_data;"
		end

	c_truncated_to_real_64 (a_data: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)*(long double *)$a_data;"
		end

feature {NONE}

	c_set_from_integer_8 (a_data: POINTER; a_value: INTEGER_8)
		external
			"C inline"
		alias
			"*(long double *)$a_data = (signed char)$a_value;"
		end

	c_set_from_integer_16 (a_data: POINTER; a_value: INTEGER_16)
		external
			"C inline"
		alias
			"*(long double *)$a_data = (signed short)$a_value;"
		end

	c_set_from_integer_32 (a_data: POINTER; a_value: INTEGER_32)
		external
			"C inline"
		alias
			"*(long double *)$a_data = (signed int)$a_value;"
		end

	c_set_from_integer_64 (a_data: POINTER; a_value: INTEGER_64)
		external
			"C inline"
		alias
			"*(long double *)$a_data = (signed long long)$a_value;"
		end

	c_set_from_natural_8 (a_data: POINTER; a_value: NATURAL_8)
		external
			"C inline"
		alias
			"*(long double *)$a_data = (unsigned char)$a_value;"
		end

	c_set_from_natural_16 (a_data: POINTER; a_value: NATURAL_16)
		external
			"C inline"
		alias
			"*(long double *)$a_data = (unsigned short)$a_value;"
		end

	c_set_from_natural_32 (a_data: POINTER; a_value: NATURAL_32)
		external
			"C inline"
		alias
			"*(long double *)$a_data = (unsigned int)$a_value;"
		end

	c_set_from_natural_64 (a_data: POINTER; a_value: NATURAL_64)
		external
			"C inline"
		alias
			"*(long double *)$a_data = (unsigned long long)$a_value;"
		end

	c_set_from_real_32 (a_data: POINTER; a_value: REAL_32)
		external
			"C inline"
		alias
			"*(long double *)$a_data = (float)$a_value;"
		end

	c_set_from_real_64 (a_data: POINTER; a_value: REAL_64)
		external
			"C inline"
		alias
			"*(long double *)$a_data = (double)$a_value;"
		end

end
