class
	PD_BUF

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_BUF] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_BUF] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	hnext: CE_POINTER [PD_BUF] assign set_hnext
		do
			create Result.make_shared (c_hnext (c_pointer))
		end

	hprev: CE_POINTER [PD_BUF] assign set_hprev
		do
			create Result.make_shared (c_hprev (c_pointer))
		end

	block: INTEGER_32 assign set_block
		do
			Result := c_block (c_pointer)
		end

	datasize: NATURAL_32 assign set_datasize
		do
			Result := c_datasize (c_pointer)
		end

	data: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_data (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_BUF])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_BUF])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_hnext (a_hnext: CE_POINTER [PD_BUF])
		do
			c_set_hnext (c_pointer, a_hnext.c_pointer)
		end

	set_hprev (a_hprev: CE_POINTER [PD_BUF])
		do
			c_set_hprev (c_pointer, a_hprev.c_pointer)
		end

	set_block (a_block: INTEGER_32)
		do
			c_set_block (c_pointer, a_block)
		end

	set_datasize (a_datasize: NATURAL_32)
		do
			c_set_datasize (c_pointer, a_datasize)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct buf *)((struct buf *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct buf *)((struct buf *)$tmp)->prev;"
		end

	c_hnext (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct buf *)((struct buf *)$tmp)->hnext;"
		end

	c_hprev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct buf *)((struct buf *)$tmp)->hprev;"
		end

	c_block (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct buf *)$tmp)->block;"
		end

	c_datasize (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct buf *)$tmp)->datasize;"
		end

	c_data (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct buf *tmp = (struct buf *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->data) / sizeof(tmp->data[0]);
				return tmp->data;
			]"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct buf *)$tmp)->next = (struct buf *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct buf *)$tmp)->prev = (struct buf *)$a_prev;"
		end

	c_set_hnext (tmp: POINTER; a_hnext: POINTER)
		external
			"C inline"
		alias
			"((struct buf *)$tmp)->hnext = (struct buf *)$a_hnext;"
		end

	c_set_hprev (tmp: POINTER; a_hprev: POINTER)
		external
			"C inline"
		alias
			"((struct buf *)$tmp)->hprev = (struct buf *)$a_hprev;"
		end

	c_set_block (tmp: POINTER; a_block: INTEGER_32)
		external
			"C inline"
		alias
			"((struct buf *)$tmp)->block = $a_block;"
		end

	c_set_datasize (tmp: POINTER; a_datasize: NATURAL_32)
		external
			"C inline"
		alias
			"((struct buf *)$tmp)->datasize = $a_datasize;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return sizeof(struct buf);"
		end

end
