class
	PD_BUFLIST

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	buf_next: CE_POINTER [PD_BUF] assign set_buf_next
		do
			create Result.make_shared (c_buf_next (c_pointer))
		end

	buf_prev: CE_POINTER [PD_BUF] assign set_buf_prev
		do
			create Result.make_shared (c_buf_prev (c_pointer))
		end

	buf_hnext: CE_POINTER [PD_BUF] assign set_buf_hnext
		do
			create Result.make_shared (c_buf_hnext (c_pointer))
		end

	buf_hprev: CE_POINTER [PD_BUF] assign set_buf_hprev
		do
			create Result.make_shared (c_buf_hprev (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_buf_next (a_buf_next: CE_POINTER [PD_BUF])
		do
			c_set_buf_next (c_pointer, a_buf_next.c_pointer)
		end

	set_buf_prev (a_buf_prev: CE_POINTER [PD_BUF])
		do
			c_set_buf_prev (c_pointer, a_buf_prev.c_pointer)
		end

	set_buf_hnext (a_buf_hnext: CE_POINTER [PD_BUF])
		do
			c_set_buf_hnext (c_pointer, a_buf_hnext.c_pointer)
		end

	set_buf_hprev (a_buf_hprev: CE_POINTER [PD_BUF])
		do
			c_set_buf_hprev (c_pointer, a_buf_hprev.c_pointer)
		end

feature {NONE} -- C getters

	c_buf_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct buf *)((struct buflist *)$tmp)->buf_next;"
		end

	c_buf_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct buf *)((struct buflist *)$tmp)->buf_prev;"
		end

	c_buf_hnext (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct buf *)((struct buflist *)$tmp)->buf_hnext;"
		end

	c_buf_hprev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct buf *)((struct buflist *)$tmp)->buf_hprev;"
		end

feature {NONE} -- C setters

	c_set_buf_next (tmp: POINTER; a_buf_next: POINTER)
		external
			"C inline"
		alias
			"((struct buflist *)$tmp)->buf_next = (struct buf *)$a_buf_next;"
		end

	c_set_buf_prev (tmp: POINTER; a_buf_prev: POINTER)
		external
			"C inline"
		alias
			"((struct buflist *)$tmp)->buf_prev = (struct buf *)$a_buf_prev;"
		end

	c_set_buf_hnext (tmp: POINTER; a_buf_hnext: POINTER)
		external
			"C inline"
		alias
			"((struct buflist *)$tmp)->buf_hnext = (struct buf *)$a_buf_hnext;"
		end

	c_set_buf_hprev (tmp: POINTER; a_buf_hprev: POINTER)
		external
			"C inline"
		alias
			"((struct buflist *)$tmp)->buf_hprev = (struct buf *)$a_buf_hprev;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return sizeof(struct buflist);"
		end

end
