class
	PD_FILESTATE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	buf_next: CE_POINTER [PD_BUF] assign set_buf_next
		do
			create Result.make_shared (c_buf_next (c_pointer))
		end

	buf_next_offset: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return (int)offsetof(struct filestate, buf_next);"
		end

	buf_prev: CE_POINTER [PD_BUF] assign set_buf_prev
		do
			create Result.make_shared (c_buf_prev (c_pointer))
		end

	hashtbl: CE_ARRAY [PD_BUFLIST]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_hashtbl (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	file: INTEGER_32 assign set_file
		do
			Result := c_file (c_pointer)
		end

	flags: INTEGER_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	fpos: INTEGER_32 assign set_fpos
		do
			Result := c_fpos (c_pointer)
		end

	nbufs: INTEGER_32 assign set_nbufs
		do
			Result := c_nbufs (c_pointer)
		end

	block: INTEGER_32 assign set_block
		do
			Result := c_block (c_pointer)
		end

	offset: NATURAL_32 assign set_offset
		do
			Result := c_offset (c_pointer)
		end

	fsize: INTEGER_32 assign set_fsize
		do
			Result := c_fsize (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_buf_next (a_buf_next: CE_POINTER [PD_BUF])
		do
			c_set_buf_next (c_pointer, a_buf_next.c_pointer)
		end

	set_buf_prev (a_buf_prev: CE_POINTER [PD_BUF])
		do
			c_set_buf_prev (c_pointer, a_buf_prev.c_pointer)
		end

	set_file (a_file: INTEGER_32)
		do
			c_set_file (c_pointer, a_file)
		end

	set_flags (a_flags: INTEGER_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

	set_fpos (a_fpos: INTEGER_32)
		do
			c_set_fpos (c_pointer, a_fpos)
		end

	set_nbufs (a_nbufs: INTEGER_32)
		do
			c_set_nbufs (c_pointer, a_nbufs)
		end

	set_block (a_block: INTEGER_32)
		do
			c_set_block (c_pointer, a_block)
		end

	set_offset (a_offset: NATURAL_32)
		do
			c_set_offset (c_pointer, a_offset)
		end

	set_fsize (a_fsize: INTEGER_32)
		do
			c_set_fsize (c_pointer, a_fsize)
		end

feature {NONE} -- C getters

	c_buf_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct buf *)((struct filestate *)$tmp)->buf_next;"
		end

	c_buf_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct buf *)((struct filestate *)$tmp)->buf_prev;"
		end

	c_hashtbl (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct filestate *tmp = (struct filestate *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->hashtbl) / sizeof(tmp->hashtbl[0]);
				return tmp->hashtbl;
			]"
		end

	c_file (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct filestate *)$tmp)->file;"
		end

	c_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct filestate *)$tmp)->flags;"
		end

	c_fpos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct filestate *)$tmp)->fpos;"
		end

	c_nbufs (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct filestate *)$tmp)->nbufs;"
		end

	c_block (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct filestate *)$tmp)->block;"
		end

	c_offset (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct filestate *)$tmp)->offset;"
		end

	c_fsize (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct filestate *)$tmp)->fsize;"
		end

feature {NONE} -- C setters

	c_set_buf_next (tmp: POINTER; a_buf_next: POINTER)
		external
			"C inline"
		alias
			"((struct filestate *)$tmp)->buf_next = (struct buf *)$a_buf_next;"
		end

	c_set_buf_prev (tmp: POINTER; a_buf_prev: POINTER)
		external
			"C inline"
		alias
			"((struct filestate *)$tmp)->buf_prev = (struct buf *)$a_buf_prev;"
		end

	c_set_file (tmp: POINTER; a_file: INTEGER_32)
		external
			"C inline"
		alias
			"((struct filestate *)$tmp)->file = $a_file;"
		end

	c_set_flags (tmp: POINTER; a_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct filestate *)$tmp)->flags = $a_flags;"
		end

	c_set_fpos (tmp: POINTER; a_fpos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct filestate *)$tmp)->fpos = $a_fpos;"
		end

	c_set_nbufs (tmp: POINTER; a_nbufs: INTEGER_32)
		external
			"C inline"
		alias
			"((struct filestate *)$tmp)->nbufs = $a_nbufs;"
		end

	c_set_block (tmp: POINTER; a_block: INTEGER_32)
		external
			"C inline"
		alias
			"((struct filestate *)$tmp)->block = $a_block;"
		end

	c_set_offset (tmp: POINTER; a_offset: NATURAL_32)
		external
			"C inline"
		alias
			"((struct filestate *)$tmp)->offset = $a_offset;"
		end

	c_set_fsize (tmp: POINTER; a_fsize: INTEGER_32)
		external
			"C inline"
		alias
			"((struct filestate *)$tmp)->fsize = $a_fsize;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return sizeof(struct filestate);"
		end

end
