class
	PD_IFILE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	h_next: CE_POINTER [PD_IFILE] assign set_h_next
		do
			create Result.make_shared (c_h_next (c_pointer))
		end

	h_prev: CE_POINTER [PD_IFILE] assign set_h_prev
		do
			create Result.make_shared (c_h_prev (c_pointer))
		end

	h_filename: CE_POINTER [INTEGER_8] assign set_h_filename
		do
			create Result.make_shared (c_h_filename (c_pointer))
		end

	h_filestate: CE_POINTER [ANY] assign set_h_filestate
		do
			create Result.make_shared (c_h_filestate (c_pointer))
		end

	h_index: INTEGER_32 assign set_h_index
		do
			Result := c_h_index (c_pointer)
		end

	h_hold: INTEGER_32 assign set_h_hold
		do
			Result := c_h_hold (c_pointer)
		end

	h_opened: INTEGER_8 assign set_h_opened
		do
			Result := c_h_opened (c_pointer)
		end

	h_scrpos: PD_SCRPOS assign set_h_scrpos
		do
			create Result.make_shared (c_h_scrpos (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_h_next (a_h_next: CE_POINTER [PD_IFILE])
		do
			c_set_h_next (c_pointer, a_h_next.c_pointer)
		end

	set_h_prev (a_h_prev: CE_POINTER [PD_IFILE])
		do
			c_set_h_prev (c_pointer, a_h_prev.c_pointer)
		end

	set_h_filename (a_h_filename: CE_POINTER [INTEGER_8])
		do
			c_set_h_filename (c_pointer, a_h_filename.c_pointer)
		end

	set_h_filestate (a_h_filestate: CE_POINTER [ANY])
		do
			c_set_h_filestate (c_pointer, a_h_filestate.c_pointer)
		end

	set_h_index (a_h_index: INTEGER_32)
		do
			c_set_h_index (c_pointer, a_h_index)
		end

	set_h_hold (a_h_hold: INTEGER_32)
		do
			c_set_h_hold (c_pointer, a_h_hold)
		end

	set_h_opened (a_h_opened: INTEGER_8)
		do
			c_set_h_opened (c_pointer, a_h_opened)
		end

	set_h_scrpos (a_h_scrpos: PD_SCRPOS)
		do
			h_scrpos.ce_gets (a_h_scrpos)
		end

feature {NONE} -- C getters

	c_h_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct ifile *)((struct ifile *)$tmp)->h_next;"
		end

	c_h_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct ifile *)((struct ifile *)$tmp)->h_prev;"
		end

	c_h_filename (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct ifile *)$tmp)->h_filename;"
		end

	c_h_filestate (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct ifile *)$tmp)->h_filestate;"
		end

	c_h_index (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ifile *)$tmp)->h_index;"
		end

	c_h_hold (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ifile *)$tmp)->h_hold;"
		end

	c_h_opened (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct ifile *)$tmp)->h_opened;"
		end

	c_h_scrpos (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct scrpos *)&((struct ifile *)$tmp)->h_scrpos;"
		end

feature {NONE} -- C setters

	c_set_h_next (tmp: POINTER; a_h_next: POINTER)
		external
			"C inline"
		alias
			"((struct ifile *)$tmp)->h_next = (struct ifile *)$a_h_next;"
		end

	c_set_h_prev (tmp: POINTER; a_h_prev: POINTER)
		external
			"C inline"
		alias
			"((struct ifile *)$tmp)->h_prev = (struct ifile *)$a_h_prev;"
		end

	c_set_h_filename (tmp: POINTER; a_h_filename: POINTER)
		external
			"C inline"
		alias
			"((struct ifile *)$tmp)->h_filename = (char *)$a_h_filename;"
		end

	c_set_h_filestate (tmp: POINTER; a_h_filestate: POINTER)
		external
			"C inline"
		alias
			"((struct ifile *)$tmp)->h_filestate = (void *)$a_h_filestate;"
		end

	c_set_h_index (tmp: POINTER; a_h_index: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ifile *)$tmp)->h_index = $a_h_index;"
		end

	c_set_h_hold (tmp: POINTER; a_h_hold: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ifile *)$tmp)->h_hold = $a_h_hold;"
		end

	c_set_h_opened (tmp: POINTER; a_h_opened: INTEGER_8)
		external
			"C inline"
		alias
			"((struct ifile *)$tmp)->h_opened = $a_h_opened;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return sizeof(struct ifile);"
		end

end
