class
	PD_LOPTION

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	oletter: INTEGER_8 assign set_oletter
		do
			Result := c_oletter (c_pointer)
		end

	onames: CE_POINTER [PD_OPTNAME] assign set_onames
		do
			create Result.make_shared (c_onames (c_pointer))
		end

	otype: INTEGER_32 assign set_otype
		do
			Result := c_otype (c_pointer)
		end

	odefault: INTEGER_32 assign set_odefault
		do
			Result := c_odefault (c_pointer)
		end

	ovar: CE_POINTER [INTEGER_32] assign set_ovar
		do
			create Result.make_shared (c_ovar (c_pointer))
		end

	ofunc: CE_ROUTINE assign set_ofunc
		do
			create Result.make_shared (c_ofunc (c_pointer))
		end

	odesc: CE_ARRAY [CE_POINTER [INTEGER_8]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_odesc (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_oletter (a_oletter: INTEGER_8)
		do
			c_set_oletter (c_pointer, a_oletter)
		end

	set_onames (a_onames: CE_POINTER [PD_OPTNAME])
		do
			c_set_onames (c_pointer, a_onames.c_pointer)
		end

	set_otype (a_otype: INTEGER_32)
		do
			c_set_otype (c_pointer, a_otype)
		end

	set_odefault (a_odefault: INTEGER_32)
		do
			c_set_odefault (c_pointer, a_odefault)
		end

	set_ovar (a_ovar: CE_POINTER [INTEGER_32])
		do
			c_set_ovar (c_pointer, a_ovar.c_pointer)
		end

	set_ofunc (a_ofunc: CE_ROUTINE)
		do
			c_set_ofunc (c_pointer, a_ofunc.c_pointer)
		end

feature {NONE} -- C getters

	c_oletter (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct loption *)$tmp)->oletter;"
		end

	c_onames (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct optname *)((struct loption *)$tmp)->onames;"
		end

	c_otype (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct loption *)$tmp)->otype;"
		end

	c_odefault (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct loption *)$tmp)->odefault;"
		end

	c_ovar (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int *)((struct loption *)$tmp)->ovar;"
		end

	c_ofunc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)())((struct loption *)$tmp)->ofunc;"
		end

	c_odesc (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct loption *tmp = (struct loption *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->odesc) / sizeof(tmp->odesc[0]);
				return tmp->odesc;
			]"
		end

feature {NONE} -- C setters

	c_set_oletter (tmp: POINTER; a_oletter: INTEGER_8)
		external
			"C inline"
		alias
			"((struct loption *)$tmp)->oletter = $a_oletter;"
		end

	c_set_onames (tmp: POINTER; a_onames: POINTER)
		external
			"C inline"
		alias
			"((struct loption *)$tmp)->onames = (struct optname *)$a_onames;"
		end

	c_set_otype (tmp: POINTER; a_otype: INTEGER_32)
		external
			"C inline"
		alias
			"((struct loption *)$tmp)->otype = $a_otype;"
		end

	c_set_odefault (tmp: POINTER; a_odefault: INTEGER_32)
		external
			"C inline"
		alias
			"((struct loption *)$tmp)->odefault = $a_odefault;"
		end

	c_set_ovar (tmp: POINTER; a_ovar: POINTER)
		external
			"C inline"
		alias
			"((struct loption *)$tmp)->ovar = (int *)$a_ovar;"
		end

	c_set_ofunc (tmp: POINTER; a_ofunc: POINTER)
		external
			"C inline"
		alias
			"((struct loption *)$tmp)->ofunc = (void( *)())$a_ofunc;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return sizeof(struct loption);"
		end

end
