class
	PD_MLIST

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_MLIST] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_MLIST] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	curr_mp: CE_POINTER [PD_MLIST] assign set_curr_mp
		do
			create Result.make_shared (c_curr_mp (c_pointer))
		end

	string: CE_POINTER [INTEGER_8] assign set_string
		do
			create Result.make_shared (c_string (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_MLIST])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_MLIST])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_curr_mp (a_curr_mp: CE_POINTER [PD_MLIST])
		do
			c_set_curr_mp (c_pointer, a_curr_mp.c_pointer)
		end

	set_string (a_string: CE_POINTER [INTEGER_8])
		do
			c_set_string (c_pointer, a_string.c_pointer)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct mlist *)((struct mlist *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct mlist *)((struct mlist *)$tmp)->prev;"
		end

	c_curr_mp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct mlist *)((struct mlist *)$tmp)->curr_mp;"
		end

	c_string (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct mlist *)$tmp)->string;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct mlist *)$tmp)->next = (struct mlist *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct mlist *)$tmp)->prev = (struct mlist *)$a_prev;"
		end

	c_set_curr_mp (tmp: POINTER; a_curr_mp: POINTER)
		external
			"C inline"
		alias
			"((struct mlist *)$tmp)->curr_mp = (struct mlist *)$a_curr_mp;"
		end

	c_set_string (tmp: POINTER; a_string: POINTER)
		external
			"C inline"
		alias
			"((struct mlist *)$tmp)->string = (char *)$a_string;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return sizeof(struct mlist);"
		end

end
