class
	PD_TABLELIST

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	t_next: CE_POINTER [PD_TABLELIST] assign set_t_next
		do
			create Result.make_shared (c_t_next (c_pointer))
		end

	t_start: CE_POINTER [INTEGER_8] assign set_t_start
		do
			create Result.make_shared (c_t_start (c_pointer))
		end

	t_end: CE_POINTER [INTEGER_8] assign set_t_end
		do
			create Result.make_shared (c_t_end (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_t_next (a_t_next: CE_POINTER [PD_TABLELIST])
		do
			c_set_t_next (c_pointer, a_t_next.c_pointer)
		end

	set_t_start (a_t_start: CE_POINTER [INTEGER_8])
		do
			c_set_t_start (c_pointer, a_t_start.c_pointer)
		end

	set_t_end (a_t_end: CE_POINTER [INTEGER_8])
		do
			c_set_t_end (c_pointer, a_t_end.c_pointer)
		end

feature {NONE} -- C getters

	c_t_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct tablelist *)((struct tablelist *)$tmp)->t_next;"
		end

	c_t_start (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct tablelist *)$tmp)->t_start;"
		end

	c_t_end (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct tablelist *)$tmp)->t_end;"
		end

feature {NONE} -- C setters

	c_set_t_next (tmp: POINTER; a_t_next: POINTER)
		external
			"C inline"
		alias
			"((struct tablelist *)$tmp)->t_next = (struct tablelist *)$a_t_next;"
		end

	c_set_t_start (tmp: POINTER; a_t_start: POINTER)
		external
			"C inline"
		alias
			"((struct tablelist *)$tmp)->t_start = (char *)$a_t_start;"
		end

	c_set_t_end (tmp: POINTER; a_t_end: POINTER)
		external
			"C inline"
		alias
			"((struct tablelist *)$tmp)->t_end = (char *)$a_t_end;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return sizeof(struct tablelist);"
		end

end
