class
	PD_TAG

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_TAG] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_TAG] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	tag_file: CE_POINTER [INTEGER_8] assign set_tag_file
		do
			create Result.make_shared (c_tag_file (c_pointer))
		end

	tag_linenum: INTEGER_32 assign set_tag_linenum
		do
			Result := c_tag_linenum (c_pointer)
		end

	tag_pattern: CE_POINTER [INTEGER_8] assign set_tag_pattern
		do
			create Result.make_shared (c_tag_pattern (c_pointer))
		end

	tag_endline: INTEGER_8 assign set_tag_endline
		do
			Result := c_tag_endline (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_TAG])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_TAG])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_tag_file (a_tag_file: CE_POINTER [INTEGER_8])
		do
			c_set_tag_file (c_pointer, a_tag_file.c_pointer)
		end

	set_tag_linenum (a_tag_linenum: INTEGER_32)
		do
			c_set_tag_linenum (c_pointer, a_tag_linenum)
		end

	set_tag_pattern (a_tag_pattern: CE_POINTER [INTEGER_8])
		do
			c_set_tag_pattern (c_pointer, a_tag_pattern.c_pointer)
		end

	set_tag_endline (a_tag_endline: INTEGER_8)
		do
			c_set_tag_endline (c_pointer, a_tag_endline)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct tag *)((struct tag *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct tag *)((struct tag *)$tmp)->prev;"
		end

	c_tag_file (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct tag *)$tmp)->tag_file;"
		end

	c_tag_linenum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct tag *)$tmp)->tag_linenum;"
		end

	c_tag_pattern (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct tag *)$tmp)->tag_pattern;"
		end

	c_tag_endline (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct tag *)$tmp)->tag_endline;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct tag *)$tmp)->next = (struct tag *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct tag *)$tmp)->prev = (struct tag *)$a_prev;"
		end

	c_set_tag_file (tmp: POINTER; a_tag_file: POINTER)
		external
			"C inline"
		alias
			"((struct tag *)$tmp)->tag_file = (char *)$a_tag_file;"
		end

	c_set_tag_linenum (tmp: POINTER; a_tag_linenum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tag *)$tmp)->tag_linenum = $a_tag_linenum;"
		end

	c_set_tag_pattern (tmp: POINTER; a_tag_pattern: POINTER)
		external
			"C inline"
		alias
			"((struct tag *)$tmp)->tag_pattern = (char *)$a_tag_pattern;"
		end

	c_set_tag_endline (tmp: POINTER; a_tag_endline: INTEGER_8)
		external
			"C inline"
		alias
			"((struct tag *)$tmp)->tag_endline = $a_tag_endline;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return sizeof(struct tag);"
		end

end
