class
	PD_TEXTLIST

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	string: CE_POINTER [INTEGER_8] assign set_string
		do
			create Result.make_shared (c_string (c_pointer))
		end

	endstring: CE_POINTER [INTEGER_8] assign set_endstring
		do
			create Result.make_shared (c_endstring (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_string (a_string: CE_POINTER [INTEGER_8])
		do
			c_set_string (c_pointer, a_string.c_pointer)
		end

	set_endstring (a_endstring: CE_POINTER [INTEGER_8])
		do
			c_set_endstring (c_pointer, a_endstring.c_pointer)
		end

feature {NONE} -- C getters

	c_string (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct textlist *)$tmp)->string;"
		end

	c_endstring (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct textlist *)$tmp)->endstring;"
		end

feature {NONE} -- C setters

	c_set_string (tmp: POINTER; a_string: POINTER)
		external
			"C inline"
		alias
			"((struct textlist *)$tmp)->string = (char *)$a_string;"
		end

	c_set_endstring (tmp: POINTER; a_endstring: POINTER)
		external
			"C inline"
		alias
			"((struct textlist *)$tmp)->endstring = (char *)$a_endstring;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return sizeof(struct textlist);"
		end

end
