class
	P_CH

inherit
	LESS_DATA
		redefine
			default_create
		end
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {NONE} -- Initialization

	default_create
		do
			create thisfile.make
		end

feature {ANY} -- attributes

	ignore_eoi: INTEGER_32 assign set_ignore_eoi

	set_ignore_eoi (a_ignore_eoi: INTEGER_32)
		do
			ignore_eoi := a_ignore_eoi
		end

	thisfile: CE_POINTER [PD_FILESTATE]

	ch_ungotchar: INTEGER_32 assign set_ch_ungotchar

	set_ch_ungotchar (a_ch_ungotchar: INTEGER_32)
		do
			ch_ungotchar := a_ch_ungotchar
		end

	maxbufs: INTEGER_32 assign set_maxbufs

	set_maxbufs (a_maxbufs: INTEGER_32)
		do
			maxbufs := a_maxbufs
		end

	autobuf: INTEGER_32 assign set_autobuf
		do
			Result := autobuf_address[0]
		end

	set_autobuf (a_autobuf: INTEGER_32)
		do
			autobuf_address[0] := a_autobuf
		end

	autobuf_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	sigs: INTEGER_32 assign set_sigs

	set_sigs (a_sigs: INTEGER_32)
		do
			sigs := a_sigs
		end

	tried: INTEGER_32 assign set_tried

	set_tried (a_tried: INTEGER_32)
		do
			tried := a_tried
		end

feature {ANY} -- routines

	fch_get: INTEGER_32
		local
			l_bp: CE_POINTER [PD_BUF]
			l_n: INTEGER_32
			l_slept: INTEGER_32
			l_h: INTEGER_32
			l_pos2: INTEGER_32
			l_len: INTEGER_32
			l_parg: PD_PARG
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_bp.make
			create l_parg.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_slept := 0
					l_h := ((thisfile.item.block).bit_and (63)).to_integer_32
					l_bp.ce_gets (thisfile.item.hashtbl[l_h].buf_hnext)
				when 1 then -- loop condition:
					if (l_bp.c_pointer.to_integer_32).to_natural_32 = ((thisfile.item.hashtbl + l_h).c_pointer.to_integer_32).to_natural_32 then
						l_pos := -1 + 6 -- skip loop
					end
				when 2 then -- loop body:
						if l_bp.item.block /= thisfile.item.block then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if thisfile.item.offset >= l_bp.item.datasize then
							l_pos := -1 + 19 -- goto read_more
						end
				when 4 then
						l_pos := -1 + 20 -- goto found
				when 5 then
						l_bp.ce_gets (l_bp.item.hnext)
						l_pos := -1 + 1 -- back to loop condition
				when 6 then -- loop done
					if ((thisfile.item.buf_prev).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [CE_POINTER [PD_BUF]]}.make_shared (thisfile.c_pointer + {PD_FILESTATE}.buf_next_offset)).c_pointer.to_integer_32).to_natural_32 then
						l_pos := -1 + 9 -- skip if block
					end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___2
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 9 then -- else:
						if (thisfile.item.buf_prev).item.block = -1 then
							l_pos := -1 + 18 -- skip if block
						end
				when 10 then -- if: | _L___2:
						if not (autobuf.to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if not ((thisfile.item.flags).bit_and (1)).to_boolean then
							l_pos := -1 + 17 -- goto _L___0
						else
							l_pos := -1 + 13 -- goto _L___1
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 13 then -- else: | _L___1:
						if not (maxbufs < 0) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if not (thisfile.item.nbufs < maxbufs) then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L___0:
						if (ch_addbuf).to_boolean then
							Current.autobuf := 0
						end
				when 18 then -- if done | if done | if done | if done
						l_bp.ce_gets (thisfile.item.buf_prev);
						(l_bp.item.hnext).item.hprev := l_bp.item.hprev;
						(l_bp.item.hprev).item.hnext := l_bp.item.hnext
						l_bp.item.block := thisfile.item.block
						l_bp.item.datasize := {NATURAL_32} 0
						l_bp.item.hnext := thisfile.item.hashtbl[l_h].buf_hnext
						l_bp.item.hprev := create {CE_POINTER [PD_BUF]}.make_cast ((thisfile.item.hashtbl + l_h));
						(thisfile.item.hashtbl[l_h].buf_hnext).item.hprev := l_bp
						thisfile.item.hashtbl[l_h].buf_hnext := l_bp
				when 19 then -- read_more:
						l_pos2 := ((thisfile.item.block * 8192).to_natural_32 + (l_bp.item.datasize).to_natural_32).to_integer_32
						l_len := ch_length
						if l_len /= -1 then
							if l_pos2 >= l_len then
								Result := (-1)
								js.return
							end
						end
						if not js.return_called and then (l_pos2 /= thisfile.item.fpos) then
							if not ((thisfile.item.flags).bit_and (1)).to_boolean then
								Result := (('?').code)
								js.return
							end
							if not js.return_called then
								if (lseek (thisfile.item.file, l_pos2, 0)) = -1 then
									output_inst.error (ce_string ("seek error"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
									screen_inst.clear_eol
									Result := (-1)
									js.return
								end
							end
							if not js.return_called then
								thisfile.item.fpos := l_pos2
							end
						end
						if not js.return_called then
							if ch_ungotchar /= -1 then
								l_bp.item.data[(l_bp.item.datasize).to_integer_32] := ch_ungotchar.to_natural_8
								l_n := 1
								ch_ungotchar := -1
							elseif ((thisfile.item.flags).bit_and (8)).to_boolean then
								l_bp.item.data[(l_bp.item.datasize).to_integer_32] := (help_inst.helpdata[thisfile.item.fpos]).to_natural_8
								l_n := 1
							else
								l_n := os_inst.iread (thisfile.item.file, create {CE_POINTER [INTEGER_8]}.make_cast ((l_bp.item.data + (l_bp.item.datasize).to_integer_32)), {NATURAL_32} 8192 - l_bp.item.datasize)
							end
							if l_n = -2 then
								Result := (-1)
								js.return
							end
						end
						if not js.return_called then
							if l_n < 0 then
								output_inst.error (ce_string ("read error"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
								screen_inst.clear_eol
								l_n := 0
							end
							if not main_inst.secure.to_boolean then
								if main_inst.logfile >= 0 then
									if l_n > 0 then
										write (main_inst.logfile, create {CE_POINTER [ANY]}.make_cast ((l_bp.item.data + (l_bp.item.datasize).to_integer_32)), l_n.to_natural_32).do_nothing
									end
								end
							end
							thisfile.item.fpos := thisfile.item.fpos + l_n.to_integer_32
							l_bp.item.datasize := l_bp.item.datasize + l_n.to_natural_32
							if l_n = 0 then
								thisfile.item.fsize := l_pos2
								if ignore_eoi.to_boolean then
									if not l_slept.to_boolean then
										l_parg.p_string := prompt_inst.wait_message
										output_inst.ierror (ce_string ("%%s"), l_parg.address)
									end
									sleep ({NATURAL_32} 1).do_nothing
									l_slept := 1
								end
								if sigs.to_boolean then
									Result := (-1)
									js.return
								end
							end
						end
						if js.return_called then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if: | found:
							if ((thisfile.item.buf_next).c_pointer.to_integer_32).to_natural_32 /= (l_bp.c_pointer.to_integer_32).to_natural_32 then
								(l_bp.item.next).item.prev := l_bp.item.prev;
								(l_bp.item.prev).item.next := l_bp.item.next
								l_bp.item.next := thisfile.item.buf_next
								l_bp.item.prev := create {CE_POINTER [PD_BUF]}.make_cast ((create {CE_POINTER [CE_POINTER [PD_BUF]]}.make_shared (thisfile.c_pointer + {PD_FILESTATE}.buf_next_offset)));
								(thisfile.item.buf_next).item.prev := l_bp
								thisfile.item.buf_next := l_bp;
								(l_bp.item.hnext).item.hprev := l_bp.item.hprev;
								(l_bp.item.hprev).item.hnext := l_bp.item.hnext
								l_bp.item.hnext := thisfile.item.hashtbl[l_h].buf_hnext
								l_bp.item.hprev := create {CE_POINTER [PD_BUF]}.make_cast ((thisfile.item.hashtbl + l_h));
								(thisfile.item.hashtbl[l_h].buf_hnext).item.hprev := l_bp
								thisfile.item.hashtbl[l_h].buf_hnext := l_bp
							end
							if thisfile.item.offset >= l_bp.item.datasize then
								l_pos := -1 + 19 -- goto read_more
							end
				when 21 then
							Result := (l_bp.item.data[(thisfile.item.offset).to_integer_32]).to_integer_32
				when 22 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ch_ungetchar (a_c: INTEGER_32)
		do
			if a_c /= -1 then
				if ch_ungotchar /= -1 then
					output_inst.error (ce_string ("ch_ungetchar overrun"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
				end
			end
			ch_ungotchar := a_c
		end

	end_logfile
		local
			js: JUMP_STATE
		do
			if main_inst.logfile < 0 then
				js.return
			end
			if not js.return_called then
				if not tried.to_boolean then
					if thisfile.item.fsize = -1 then
						tried := 1
						output_inst.ierror (ce_string ("Finishing logfile"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
						from
						until
							js.loop_left
						loop
							js.reset
							if (ch_forw_get) = -1 then
								js.break
							end
							if not js.loop_jumped and then (((sigs).bit_and (3)).to_boolean) then
								js.break
							end
						end
						js.reset
					end
				end
				close (main_inst.logfile).do_nothing
				main_inst.logfile := -1
				main_inst.namelogfile.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
			end
		end

	sync_logfile
		local
			l_bp: CE_POINTER [PD_BUF]
			l_warned: INTEGER_32
			l_block: INTEGER_32
			l_nblocks: INTEGER_32
			js: JUMP_STATE
		do
			create l_bp.make

			l_warned := 0
			l_nblocks := ((thisfile.item.fpos + 8192) - 1) // 8192
			l_block := (0).to_integer_32
			from
			until
				not (not js.loop_left and then (l_block < l_nblocks))
			loop
				l_bp.ce_gets (thisfile.item.buf_next)
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_bp.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [CE_POINTER [PD_BUF]]}.make_shared (thisfile.c_pointer + {PD_FILESTATE}.buf_next_offset)).c_pointer.to_integer_32).to_natural_32 then
						if not l_warned.to_boolean then
							output_inst.error (ce_string ("Warning: log file is incomplete"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_warned := 1
						end
						js.break
					end
					if not js.loop_jumped and then (l_bp.item.block = l_block) then
						write (main_inst.logfile, create {CE_POINTER [ANY]}.make_cast ((l_bp.item.data)), l_bp.item.datasize).do_nothing
						js.break
					end
					if not js.loop_jumped then
						l_bp.ce_gets (l_bp.item.next)
					end
				end
				js.reset
				l_block := l_block + 1
			end
		end

	buffered (a_block: INTEGER_32): INTEGER_32
		local
			l_bp: CE_POINTER [PD_BUF]
			l_h: INTEGER_32
			js: JUMP_STATE
		do
			create l_bp.make

			l_h := ((a_block).bit_and (63)).to_integer_32
			l_bp.ce_gets (thisfile.item.hashtbl[l_h].buf_hnext)
			from
			until
				not (not js.loop_left and then ((l_bp.c_pointer.to_integer_32).to_natural_32 /= ((thisfile.item.hashtbl + l_h).c_pointer.to_integer_32).to_natural_32))
			loop
				if l_bp.item.block = a_block then
					Result := 1
					js.return
				end
				if not js.return_called then
					l_bp.ce_gets (l_bp.item.hnext)
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	ch_seek (a_pos: INTEGER_32): INTEGER_32
		local
			l_new_block: INTEGER_32
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			l_len := ch_length
			if a_pos < 0 then
				Result := 1
				js.return
			elseif l_len /= -1 then
				if a_pos > l_len then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				l_new_block := a_pos // 8192
				if not ((thisfile.item.flags).bit_and (1)).to_boolean then
					if a_pos /= thisfile.item.fpos then
						if not (buffered (l_new_block)).to_boolean then
							if thisfile.item.fpos > a_pos then
								Result := 1
								js.return
							end
							if not js.return_called then
								from
								until
									not (not js.loop_left and then (thisfile.item.fpos < a_pos))
								loop
									if (ch_forw_get) = -1 then
										Result := 1
										js.return
									end
									if not js.return_called and then (((sigs).bit_and (3)).to_boolean) then
										Result := 1
										js.return
									end
								end
							end
							if not js.return_called then
								Result := 0
								js.return
							end
						end
					end
				end
			end
			if not js.return_called then
				thisfile.item.block := l_new_block
				thisfile.item.offset := (a_pos \\ 8192).to_natural_32
				Result := 0
			end
		end

	ch_end_seek: INTEGER_32
		local
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			if ((thisfile.item.flags).bit_and (1)).to_boolean then
				thisfile.item.fsize := filename_inst.filesize (thisfile.item.file)
			end
			l_len := ch_length
			if l_len /= -1 then
				Result := (ch_seek (l_len))
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					if (ch_forw_get) = -1 then
						js.break
					end
					if not js.loop_jumped and then (((sigs).bit_and (3)).to_boolean) then
						Result := 1
						js.return
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	ch_beg_seek: INTEGER_32
		local
			l_bp: CE_POINTER [PD_BUF]
			l_firstbp: CE_POINTER [PD_BUF]
			js: JUMP_STATE
		do
			create l_bp.make
			create l_firstbp.make

			if (ch_seek ((0).to_integer_32)) = 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_bp.ce_gets (thisfile.item.buf_next)
				l_firstbp.ce_gets (l_bp)
				if (l_bp.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [CE_POINTER [PD_BUF]]}.make_shared (thisfile.c_pointer + {PD_FILESTATE}.buf_next_offset)).c_pointer.to_integer_32).to_natural_32 then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_bp.ce_gets (l_bp.item.next)
					if (l_bp.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [CE_POINTER [PD_BUF]]}.make_shared (thisfile.c_pointer + {PD_FILESTATE}.buf_next_offset)).c_pointer.to_integer_32).to_natural_32 then
						js.break
					end
					if not js.loop_jumped and then (l_bp.item.block < l_firstbp.item.block) then
						l_firstbp.ce_gets (l_bp)
					end
				end
				js.reset
				thisfile.item.block := l_firstbp.item.block
				thisfile.item.offset := {NATURAL_32} 0
				Result := 0
			end
		end

	ch_length: INTEGER_32
		local
			js: JUMP_STATE
		do
			if ignore_eoi.to_boolean then
				Result := (-1).to_integer_32
				js.return
			end
			if not js.return_called and then (((thisfile.item.flags).bit_and (8)).to_boolean) then
				Result := help_inst.size_helpdata.to_integer_32
				js.return
			end
			if not js.return_called then
				Result := (thisfile.item.fsize)
			end
		end

	ch_tell: INTEGER_32
		do
			Result := ((thisfile.item.block * 8192).to_natural_32 + (thisfile.item.offset).to_natural_32).to_integer_32
		end

	ch_forw_get: INTEGER_32
		local
			l_c: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			if thisfile.item.block = (thisfile.item.buf_next).item.block then
				if thisfile.item.offset < (thisfile.item.buf_next).item.datasize then
					l_c := ((thisfile.item.buf_next).item.data[(thisfile.item.offset).to_integer_32]).to_integer_32
				else
					l_tmp := fch_get
					l_c := l_tmp
				end
			else
				l_tmp := fch_get
				l_c := l_tmp
			end
			if l_c = -1 then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				if thisfile.item.offset < {NATURAL_32} 8191 then
					thisfile.item.offset := (thisfile.item.offset) + 1
				else
					thisfile.item.block := (thisfile.item.block) + 1
					thisfile.item.offset := {NATURAL_32} 0
				end
				Result := l_c
			end
		end

	ch_forw_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ch_forw_get)
		end

	ch_back_get: INTEGER_32
		local
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			if thisfile.item.offset > {NATURAL_32} 0 then
				thisfile.item.offset := (thisfile.item.offset) - 1
			else
				if thisfile.item.block <= 0 then
					Result := (-1)
					js.return
				end
				if not js.return_called and then (not ((thisfile.item.flags).bit_and (1)).to_boolean) then
					if not (buffered (thisfile.item.block - 1)).to_boolean then
						Result := (-1)
						js.return
					end
				end
				if not js.return_called then
					thisfile.item.block := (thisfile.item.block) - 1
					thisfile.item.offset := {NATURAL_32} 8191
				end
			end
			if not js.return_called then
				if thisfile.item.block = (thisfile.item.buf_next).item.block then
					if thisfile.item.offset < (thisfile.item.buf_next).item.datasize then
						l_tmp___1 := ((thisfile.item.buf_next).item.data[(thisfile.item.offset).to_integer_32]).to_integer_32
					else
						l_tmp___0 := fch_get
						l_tmp___1 := l_tmp___0
					end
				else
					l_tmp___0 := fch_get
					l_tmp___1 := l_tmp___0
				end
				Result := l_tmp___1
			end
		end

	ch_back_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ch_back_get)
		end

	ch_setbufspace (a_bufspace___0: INTEGER_32)
		do
			if a_bufspace___0 < 0 then
				maxbufs := -1
			else
				maxbufs := ((a_bufspace___0 * 1024 + 8192) - 1) // 8192
				if maxbufs < 1 then
					maxbufs := 1
				end
			end
		end

	ch_flush
		local
			l_bp: CE_POINTER [PD_BUF]
			js: JUMP_STATE
		do
			create l_bp.make

			if not ((thisfile.item.flags).bit_and (1)).to_boolean then
				thisfile.item.fsize := (-1).to_integer_32
				js.return
			end
			if not js.return_called then
				l_bp.ce_gets (thisfile.item.buf_next)
				from
				until
					(l_bp.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [CE_POINTER [PD_BUF]]}.make_shared (thisfile.c_pointer + {PD_FILESTATE}.buf_next_offset)).c_pointer.to_integer_32).to_natural_32
				loop
					l_bp.item.block := (-1).to_integer_32
					l_bp.ce_gets (l_bp.item.next)
				end
				thisfile.item.fsize := filename_inst.filesize (thisfile.item.file)
				thisfile.item.fpos := (0).to_integer_32
				thisfile.item.block := (0).to_integer_32
				thisfile.item.offset := {NATURAL_32} 0
				if thisfile.item.fsize = 0 then
					thisfile.item.fsize := (-1).to_integer_32
					thisfile.item.flags := (thisfile.item.flags).bit_and ((-2))
				end
				if (lseek (thisfile.item.file, (0).to_integer_32, 0)) = -1 then
					output_inst.error (ce_string ("seek error to 0"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
				end
			end
		end

	ch_addbuf: INTEGER_32
		local
			l_bp: CE_POINTER [PD_BUF]
			js: JUMP_STATE
		do
			create l_bp.make

			l_bp.ce_gets (create {CE_POINTER [PD_BUF]}.make_cast ((calloc ((1).to_natural_32, {PD_BUF}.sizeof.to_natural_32))))
			if (l_bp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 1
				js.return
			end
			if not js.return_called then
				thisfile.item.nbufs := (thisfile.item.nbufs) + 1
				l_bp.item.block := (-1).to_integer_32
				l_bp.item.next := create {CE_POINTER [PD_BUF]}.make_cast ((create {CE_POINTER [CE_POINTER [PD_BUF]]}.make_shared (thisfile.c_pointer + {PD_FILESTATE}.buf_next_offset)))
				l_bp.item.prev := thisfile.item.buf_prev;
				(thisfile.item.buf_prev).item.next := l_bp
				thisfile.item.buf_prev := l_bp
				l_bp.item.hnext := thisfile.item.hashtbl[0].buf_hnext
				l_bp.item.hprev := create {CE_POINTER [PD_BUF]}.make_cast ((thisfile.item.hashtbl + 0));
				(thisfile.item.hashtbl[0].buf_hnext).item.hprev := l_bp
				thisfile.item.hashtbl[0].buf_hnext := l_bp
				Result := 0
			end
		end

	init_hashtbl
		local
			l_h: INTEGER_32
		do
			l_h := 0
			from
			until
				not (l_h < 64)
			loop
				thisfile.item.hashtbl[l_h].buf_hnext := create {CE_POINTER [PD_BUF]}.make_cast ((thisfile.item.hashtbl + l_h))
				thisfile.item.hashtbl[l_h].buf_hprev := create {CE_POINTER [PD_BUF]}.make_cast ((thisfile.item.hashtbl + l_h))
				l_h := l_h + 1
			end
		end

	ch_delbufs
		local
			l_bp: CE_POINTER [PD_BUF]
		do
			create l_bp.make

			from
			until
				((thisfile.item.buf_next).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [CE_POINTER [PD_BUF]]}.make_shared (thisfile.c_pointer + {PD_FILESTATE}.buf_next_offset)).c_pointer.to_integer_32).to_natural_32
			loop
				l_bp.ce_gets (thisfile.item.buf_next);
				(l_bp.item.next).item.prev := l_bp.item.prev;
				(l_bp.item.prev).item.next := l_bp.item.next
				free (create {CE_POINTER [ANY]}.make_cast (l_bp))
			end
			thisfile.item.nbufs := 0
			init_hashtbl
		end

	seekable (a_f: INTEGER_32): INTEGER_32
		do
			Result := ((lseek (a_f, (1).to_integer_32, 0)) /= -1).to_integer
		end

	ch_init (a_f: INTEGER_32; a_flags: INTEGER_32)
		local
			l_tmp___1: CE_POINTER [PD_BUF]
		do
			create l_tmp___1.make

			thisfile.ce_gets (create {CE_POINTER [PD_FILESTATE]}.make_cast ((ifile_inst.get_filestate (main_inst.curr_ifile))))
			if (thisfile.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				thisfile.ce_gets (create {CE_POINTER [PD_FILESTATE]}.make_cast ((calloc ((1).to_natural_32, {PD_FILESTATE}.sizeof.to_natural_32))))
				l_tmp___1.ce_gets (create {CE_POINTER [PD_BUF]}.make_cast ((create {CE_POINTER [CE_POINTER [PD_BUF]]}.make_shared (thisfile.c_pointer + {PD_FILESTATE}.buf_next_offset))))
				thisfile.item.buf_prev := l_tmp___1
				thisfile.item.buf_next := l_tmp___1
				thisfile.item.nbufs := 0
				thisfile.item.flags := 0
				thisfile.item.fpos := (0).to_integer_32
				thisfile.item.block := (0).to_integer_32
				thisfile.item.offset := {NATURAL_32} 0
				thisfile.item.file := -1
				thisfile.item.fsize := (-1).to_integer_32
				thisfile.item.flags := a_flags
				init_hashtbl
				if ((a_flags).bit_and (1)).to_boolean then
					if not (seekable (a_f)).to_boolean then
						thisfile.item.flags := (thisfile.item.flags).bit_and ((-2))
					end
				end
				ifile_inst.set_filestate (main_inst.curr_ifile, create {CE_POINTER [ANY]}.make_cast (thisfile))
			end
			if thisfile.item.file = -1 then
				thisfile.item.file := a_f
			end
			ch_flush
		end

	ch_close
		local
			l_keepstate: INTEGER_32
		do
			l_keepstate := 0
			if ((thisfile.item.flags).bit_and (13)).to_boolean then
				ch_delbufs
			else
				l_keepstate := 1
			end
			if not ((thisfile.item.flags).bit_and (2)).to_boolean then
				if not ((thisfile.item.flags).bit_and (12)).to_boolean then
					close (thisfile.item.file).do_nothing
				end
				thisfile.item.file := -1
			else
				l_keepstate := 1
			end
			if not l_keepstate.to_boolean then
				free (create {CE_POINTER [ANY]}.make_cast (thisfile))
				thisfile.ce_gets (create {CE_POINTER [PD_FILESTATE]}.make_shared (default_pointer))
				ifile_inst.set_filestate (main_inst.curr_ifile, create {CE_POINTER [ANY]}.make_shared (default_pointer))
			end
		end

	ch_getflags: INTEGER_32
		do
			Result := (thisfile.item.flags)
		end

end
