class
	P_FORWBACK

inherit
	LESS_DATA
		redefine
			default_create
		end
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {NONE} -- Initialization

	default_create
		do
		end

feature {ANY} -- attributes

	squished: INTEGER_32 assign set_squished

	set_squished (a_squished: INTEGER_32)
		do
			squished := a_squished
		end

	no_back_scroll: INTEGER_32 assign set_no_back_scroll

	set_no_back_scroll (a_no_back_scroll: INTEGER_32)
		do
			no_back_scroll := a_no_back_scroll
		end

	forw_scroll: INTEGER_32 assign set_forw_scroll
		do
			Result := forw_scroll_address[0]
		end

	set_forw_scroll (a_forw_scroll: INTEGER_32)
		do
			forw_scroll_address[0] := a_forw_scroll
		end

	forw_scroll_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	back_scroll: INTEGER_32 assign set_back_scroll
		do
			Result := back_scroll_address[0]
		end

	set_back_scroll (a_back_scroll: INTEGER_32)
		do
			back_scroll_address[0] := a_back_scroll
		end

	back_scroll_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	final_attr: INTEGER_32 assign set_final_attr

	set_final_attr (a_final_attr: INTEGER_32)
		do
			final_attr := a_final_attr
		end

	first_time: INTEGER_32 assign set_first_time

	set_first_time (a_first_time: INTEGER_32)
		do
			first_time := a_first_time
		end

	cshift: INTEGER_32 assign set_cshift

	set_cshift (a_cshift: INTEGER_32)
		do
			cshift := a_cshift
		end

feature {ANY} -- routines

	eof_bell
		do
			if screen_inst.quiet = 0 then
				screen_inst.bell
			else
				screen_inst.vbell
			end
		end

	eof_check
		local
			l_pos2: INTEGER_32
			js: JUMP_STATE
		do
			if ch_inst.ignore_eoi.to_boolean then
				js.return
			end
			if not js.return_called and then (((ch_inst.sigs).bit_and (3)).to_boolean) then
				js.return
			end
			if not js.return_called then
				l_pos2 := position_inst.position (-2)
				if l_pos2 = -1 then
					command_inst.hit_eof := command_inst.hit_eof + 1
				elseif l_pos2 = (ch_inst.ch_length) then
					command_inst.hit_eof := command_inst.hit_eof + 1
				end
			end
		end

	squish_check
		local
			js: JUMP_STATE
		do
			if not squished.to_boolean then
				js.return
			end
			if not js.return_called then
				squished := 0
				jump_inst.repaint
			end
		end

	forw (a_n: INTEGER_32; a_pos: INTEGER_32; a_force: INTEGER_32; a_only_last: INTEGER_32; a_nblank: INTEGER_32)
		local
			l_n: INTEGER_32
			l_pos2: INTEGER_32
			l_force: INTEGER_32
			l_nblank: INTEGER_32
			l_eof: INTEGER_32
			l_nlines: INTEGER_32
			l_do_repaint: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_n := a_n
					l_pos2 := a_pos
					l_force := a_force
					l_nblank := a_nblank
					l_eof := 0
					l_nlines := 0
					squish_check
					if not (a_only_last.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_n > screen_inst.sc_height - 1 then
							l_tmp := 1
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if forw_scroll >= 0 then
							if l_n > forw_scroll then
								if l_n /= screen_inst.sc_height - 1 then
									l_tmp := 1
								else
									l_tmp := 0
								end
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
				when 4 then
					l_do_repaint := l_tmp
					if l_do_repaint.to_boolean then
						l_pos := -1 + 10 -- skip if block
					end
				when 5 then -- if:
						cshift := 0
						if command_inst.top_scroll.to_boolean then
							if l_n >= screen_inst.sc_height - 1 then
								if l_pos2 /= (ch_inst.ch_length) then
									position_inst.pos_clear
									position_inst.add_forw_pos (l_pos2)
									l_force := 1
									if command_inst.top_scroll = 2 then
										screen_inst.clear
									elseif first_time.to_boolean then
										screen_inst.clear
									end
									screen_inst.home
								else
									screen_inst.clear_bot
								end
							else
								screen_inst.clear_bot
							end
						else
							screen_inst.clear_bot
						end
						if l_pos2 = (position_inst.position (-2)) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L___0
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if not ((position_inst.empty_screen).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L___0:
						position_inst.pos_clear
						position_inst.add_forw_pos (l_pos2)
						l_force := 1
						if command_inst.top_scroll.to_boolean then
							if command_inst.top_scroll = 2 then
								screen_inst.clear
							end
							screen_inst.home
						elseif not first_time.to_boolean then
							output_inst.putstr (ce_string ("...skipping...%N"))
						end
				when 10 then -- if done | if done
						from
						until
							js.loop_left
						loop
							js.reset
							l_n := l_n - 1
							if not (l_n >= 0) then
								js.break
							end
							if not js.loop_jumped then
								if l_nblank > 0 then
									l_nblank := l_nblank - 1
									if l_nblank = 0 then
										l_pos2 := (0).to_integer_32
									end
								else
									l_pos2 := input_inst.forw_line (l_pos2)
									if l_pos2 = -1 then
										l_eof := 1
										if not l_force.to_boolean then
											if (position_inst.position (0)) /= -1 then
												js.break
											end
										end
										if not js.loop_jumped then
											if not (position_inst.empty_lines (0, 0)).to_boolean then
												if not (position_inst.empty_lines (1, 1)).to_boolean then
													if (position_inst.empty_lines (2, screen_inst.sc_height - 1)).to_boolean then
														js.break
													end
												end
											end
										end
									end
								end
							end
							if not js.loop_jumped then
								position_inst.add_forw_pos (l_pos2)
								l_nlines := l_nlines + 1
								if l_do_repaint.to_boolean then
									js.continue
								end
							end
							if not js.loop_jumped and then (first_time.to_boolean) then
								if l_pos2 = -1 then
									if not command_inst.top_scroll.to_boolean then
										if (optfunc_inst.tagoption.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
											if not option_inst.plusoption.to_boolean then
												squished := 1
												js.continue
											end
										end
									end
								end
							end
							if not js.loop_jumped then
								if command_inst.top_scroll = 1 then
									screen_inst.clear_eol
								end
								output_inst.put_line
								if screen_inst.clear_bg.to_boolean then
									if final_attr /= 0 then
										screen_inst.clear_eol
									end
								end
							end
						end
						js.reset
						if ch_inst.ignore_eoi.to_boolean then
							command_inst.hit_eof := 0
						elseif l_eof.to_boolean then
							if not ((ch_inst.sigs).bit_and (3)).to_boolean then
								command_inst.hit_eof := command_inst.hit_eof + 1
							else
								eof_check
							end
						else
							eof_check
						end
						if l_nlines = 0 then
							eof_bell
						elseif l_do_repaint.to_boolean then
							jump_inst.repaint
						end
						first_time := 0
						linenum_inst.currline (-1).do_nothing
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	back (a_n: INTEGER_32; a_pos: INTEGER_32; a_force: INTEGER_32; a_only_last: INTEGER_32)
		local
			l_n: INTEGER_32
			l_pos2: INTEGER_32
			l_nlines: INTEGER_32
			l_do_repaint: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			l_n := a_n
			l_pos2 := a_pos
			l_nlines := 0
			squish_check
			if l_n > (get_back_scroll) then
				l_tmp___0 := 1
			elseif a_only_last.to_boolean then
				if l_n > screen_inst.sc_height - 1 then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			l_do_repaint := l_tmp___0
			command_inst.hit_eof := 0
			from
			until
				js.loop_left
			loop
				js.reset
				l_n := l_n - 1
				if not (l_n >= 0) then
					js.break
				end
				if not js.loop_jumped then
					l_pos2 := input_inst.back_line (l_pos2)
					if l_pos2 = -1 then
						if not a_force.to_boolean then
							js.break
						end
					end
				end
				if not js.loop_jumped then
					position_inst.add_back_pos (l_pos2)
					l_nlines := l_nlines + 1
					if not l_do_repaint.to_boolean then
						screen_inst.home
						screen_inst.add_line
						output_inst.put_line
					end
				end
			end
			js.reset
			eof_check
			if l_nlines = 0 then
				eof_bell
			elseif l_do_repaint.to_boolean then
				jump_inst.repaint
			end
			linenum_inst.currline (-1).do_nothing
		end

	forward (a_n: INTEGER_32; a_force: INTEGER_32; a_only_last: INTEGER_32)
		local
			l_pos2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if command_inst.quit_at_eof.to_boolean then
						if command_inst.hit_eof.to_boolean then
							if not (((ch_inst.ch_getflags)).bit_and (8)).to_boolean then
								if (edit_inst.edit_next (1)).to_boolean then
									main_inst.quit (0)
								end
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						l_pos2 := position_inst.position (-2)
						if l_pos2 /= -1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if a_force.to_boolean then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if not ((position_inst.empty_lines (2, screen_inst.sc_height - 1)).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						if ch_inst.ignore_eoi.to_boolean then
							if (position_inst.empty_screen).to_boolean then
								l_pos2 := (0).to_integer_32
							else
								from
								until
									js.loop_left
								loop
									js.reset
									back (1, (position_inst.position (0)), 1, 0)
									l_pos2 := position_inst.position (-2)
									if l_pos2 /= -1 then
										js.break
									end
								end
								js.reset
							end
						else
							eof_bell
							command_inst.hit_eof := command_inst.hit_eof + 1
							js.return
						end
				when 7 then -- if done | if done | if done
						if not js.return_called then
							forw (a_n, l_pos2, a_force, a_only_last, 0)
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	backward (a_n: INTEGER_32; a_force: INTEGER_32; a_only_last: INTEGER_32)
		local
			l_pos2: INTEGER_32
			js: JUMP_STATE
		do
			l_pos2 := position_inst.position (0)
			if l_pos2 = -1 then
				if not a_force.to_boolean then
					eof_bell
					js.return
				elseif (position_inst.position (-1)) = 0 then
					eof_bell
					js.return
				end
			end
			if not js.return_called then
				back (a_n, l_pos2, a_force, a_only_last)
			end
		end

	get_back_scroll: INTEGER_32
		local
			js: JUMP_STATE
		do
			if no_back_scroll.to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called and then (back_scroll >= 0) then
				Result := back_scroll
				js.return
			end
			if not js.return_called and then (command_inst.top_scroll.to_boolean) then
				Result := (screen_inst.sc_height - 2)
				js.return
			end
			if not js.return_called then
				Result := 10000
			end
		end

end
