class
	P_INPUT

inherit
	LESS_DATA
		redefine
			default_create
		end
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {NONE} -- Initialization

	default_create
		do
		end

feature {ANY} -- attributes

	squeeze: INTEGER_32 assign set_squeeze
		do
			Result := squeeze_address[0]
		end

	set_squeeze (a_squeeze: INTEGER_32)
		do
			squeeze_address[0] := a_squeeze
		end

	squeeze_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	chopline: INTEGER_32 assign set_chopline
		do
			Result := chopline_address[0]
		end

	set_chopline (a_chopline: INTEGER_32)
		do
			chopline_address[0] := a_chopline
		end

	chopline_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

feature {ANY} -- routines

	forw_line (a_curr_pos: INTEGER_32): INTEGER_32
		local
			l_new_pos: INTEGER_32
			l_c: INTEGER_32
			l_blankline: INTEGER_32
			l_endline: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_curr_pos = -1 then
						line_inst.null_line
						Result := (-1).to_integer_32
						js.return
					end
					if not js.return_called then
						if screen_inst.hilite_search = 2 then
							if ch_inst.ignore_eoi.to_boolean then
								l_tmp := 1
							else
								l_tmp := -1
							end
							search_inst.prep_hilite (a_curr_pos, a_curr_pos + (3 * line_inst.size_linebuf).to_integer_32, l_tmp)
						end
						if (ch_inst.ch_seek (a_curr_pos)).to_boolean then
							line_inst.null_line
							Result := (-1).to_integer_32
							js.return
						end
					end
					if not js.return_called then
						line_inst.prewind
						line_inst.plinenum (a_curr_pos)
						ch_inst.ch_seek (a_curr_pos).do_nothing
						l_c := ch_inst.ch_forw_get
						if l_c = -1 then
							line_inst.null_line
							Result := (-1).to_integer_32
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 17 -- skip if block
					end
				when 1 then -- if:
						if l_c = 10 then
							l_tmp___1 := 1
						elseif l_c = 13 then
							l_tmp___1 := 1
						else
							l_tmp___1 := 0
						end
						l_blankline := l_tmp___1
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 16 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if ((ch_inst.sigs).bit_and (3)).to_boolean then
							line_inst.null_line
							Result := (-1).to_integer_32
							js.return
						end
						if js.return_called then
							l_pos := -1 + 15 -- skip if block
						end
				when 4 then -- if:
						if l_c = 10 then
							l_new_pos := ch_inst.ch_tell
							l_endline := 1
							js.break
						elseif l_c = -1 then
							l_new_pos := ch_inst.ch_tell
							l_endline := 1
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 14 -- skip if block
						end
				when 5 then -- if:
						if not ((line_inst.pappend (l_c, (ch_inst.ch_tell) - 1)).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 6 then -- if:
						if not (chopline.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if not (command_inst.hshift > 0) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							l_c := ch_inst.ch_forw_get
							if l_c /= 10 then
								if l_c = -1 then
									js.break
								end
							else
								js.break
							end
						end
						js.reset
						l_new_pos := ch_inst.ch_tell
						l_endline := 1
						command_inst.quit_if_one_screen := 0
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						l_new_pos := (ch_inst.ch_tell) - 1
						l_endline := 0
				when 13 then -- if done
						js.break
				when 14 then -- if done | if done
						if not js.loop_jumped then
							l_c := ch_inst.ch_forw_get
						end
				when 15 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 16 then -- loop done
						js.reset
				when 17 then -- if done
					if not js.return_called then
						line_inst.pdone (l_endline)
						if squeeze.to_boolean then
							if l_blankline.to_boolean then
								from
								until
									js.loop_left
								loop
									js.reset
									l_c := ch_inst.ch_forw_get
									if l_c /= 10 then
										if l_c /= 13 then
											js.break
										end
									end
									if not js.loop_jumped and then (((ch_inst.sigs).bit_and (3)).to_boolean) then
										line_inst.null_line
										Result := (-1).to_integer_32
										js.return
									end
								end
								js.reset
								if not js.return_called then
									if l_c /= -1 then
										ch_inst.ch_back_get.do_nothing
									end
									l_new_pos := ch_inst.ch_tell
								end
							end
						end
					end
					if not js.return_called then
						Result := l_new_pos
					end
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	back_line (a_curr_pos: INTEGER_32): INTEGER_32
		local
			l_new_pos: INTEGER_32
			l_begin_new_pos: INTEGER_32
			l_c: INTEGER_32
			l_endline: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_curr_pos = -1 then
						line_inst.null_line
						Result := (-1).to_integer_32
						js.return
					elseif a_curr_pos <= 0 then
						line_inst.null_line
						Result := (-1).to_integer_32
						js.return
					end
					if not js.return_called then
						if screen_inst.hilite_search = 2 then
							if a_curr_pos < (3 * line_inst.size_linebuf).to_integer_32 then
								l_tmp := (0).to_integer_32
							else
								l_tmp := a_curr_pos - (3 * line_inst.size_linebuf).to_integer_32
							end
							search_inst.prep_hilite (l_tmp, a_curr_pos, -1)
						end
						if (ch_inst.ch_seek (a_curr_pos - 1)).to_boolean then
							line_inst.null_line
							Result := (-1).to_integer_32
							js.return
						end
					end
					if not (not js.return_called and then (squeeze.to_boolean)) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						ch_inst.ch_forw_get.do_nothing
						l_c := ch_inst.ch_forw_get
						ch_inst.ch_back_get.do_nothing
						ch_inst.ch_back_get.do_nothing
						if l_c /= 10 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if l_c /= 13 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							l_c := ch_inst.ch_back_get
							if l_c /= 10 then
								if l_c /= 13 then
									js.break
								end
							end
							if not js.loop_jumped and then (((ch_inst.sigs).bit_and (3)).to_boolean) then
								line_inst.null_line
								Result := (-1).to_integer_32
								js.return
							end
						end
						js.reset
						if not js.return_called and then (l_c = -1) then
							line_inst.null_line
							Result := (-1).to_integer_32
							js.return
						end
						if not js.return_called then
							ch_inst.ch_forw_get.do_nothing
						end
				when 6 then -- if done | if done
						if not js.return_called then
							from
							until
								js.loop_left
							loop
								js.reset
								if ((ch_inst.sigs).bit_and (3)).to_boolean then
									line_inst.null_line
									Result := (-1).to_integer_32
									js.return
								end
								if not js.return_called then
									l_c := ch_inst.ch_back_get
									if l_c = 10 then
										l_new_pos := (ch_inst.ch_tell) + 1
										js.break
									end
									if not js.loop_jumped and then (l_c = -1) then
										l_new_pos := ch_inst.ch_tell
										js.break
									end
								end
							end
							js.reset
						end
						if not js.return_called then
							if (ch_inst.ch_seek (l_new_pos)).to_boolean then
								line_inst.null_line
								Result := (-1).to_integer_32
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 15 -- skip if block
						end
				when 7 then -- if:
							l_endline := 0
				when 8 then -- loop:
							l_begin_new_pos := l_new_pos
							line_inst.prewind
							line_inst.plinenum (l_new_pos)
							ch_inst.ch_seek (l_new_pos).do_nothing
				when 9 then -- loop condition:
							if js.loop_left then
								l_pos := -1 + 14 -- skip loop
							end
				when 10 then -- loop body:
							js.reset
							l_c := ch_inst.ch_forw_get
							if l_c = -1 then
								line_inst.null_line
								Result := (-1).to_integer_32
								js.return
							elseif ((ch_inst.sigs).bit_and (3)).to_boolean then
								line_inst.null_line
								Result := (-1).to_integer_32
								js.return
							end
							if js.return_called then
								l_pos := -1 + 13 -- skip if block
							end
				when 11 then -- if:
							l_new_pos := l_new_pos + 1
							if l_c = 10 then
								l_endline := 1
								js.break
							end
							if not js.loop_jumped then
								if (line_inst.pappend (l_c, (ch_inst.ch_tell) - 1)).to_boolean then
									if chopline.to_boolean then
										l_endline := 1
										command_inst.quit_if_one_screen := 0
										js.break
									elseif command_inst.hshift > 0 then
										l_endline := 1
										command_inst.quit_if_one_screen := 0
										js.break
									end
									if not js.loop_jumped then
										line_inst.pdone (0)
										ch_inst.ch_back_get.do_nothing
										l_new_pos := l_new_pos - 1
										l_pos := -1 + 8 -- goto loop
									end
								end
							end
				when 12 then
							if not js.loop_jumped and then (not (l_new_pos < a_curr_pos)) then
								js.break
							end
				when 13 then -- if done
							l_pos := -1 + 9 -- back to loop condition
				when 14 then -- loop done
							js.reset
				when 15 then -- if done
						if not js.return_called then
							line_inst.pdone (l_endline)
							Result := l_begin_new_pos
						end
				when 16 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	set_attnpos (a_pos: INTEGER_32)
		local
			l_pos2: INTEGER_32
			l_c: INTEGER_32
			js: JUMP_STATE
		do
			l_pos2 := a_pos
			if l_pos2 /= -1 then
				if (ch_inst.ch_seek (l_pos2)).to_boolean then
					js.return
				end
				if not js.return_called then
					from
					until
						js.loop_left
					loop
						js.reset
						l_c := ch_inst.ch_forw_get
						if l_c = -1 then
							js.return
						end
						if not js.return_called then
							if l_c /= 10 then
								if l_c /= 13 then
									js.break
								end
							end
							if not js.loop_jumped then
								l_pos2 := l_pos2 + 1
							end
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				main_inst.start_attnpos := l_pos2
				from
				until
					js.loop_left
				loop
					js.reset
					l_c := ch_inst.ch_forw_get
					l_pos2 := l_pos2 + 1
					if l_c = -1 then
						js.break
					elseif l_c = 10 then
						js.break
					elseif l_c = 13 then
						js.break
					end
				end
				js.reset
				main_inst.end_attnpos := l_pos2
			end
		end

end
