class
	P_JUMP

inherit
	LESS_DATA
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {ANY} -- routines

	jump_forw
		local
			l_pos2: INTEGER_32
			js: JUMP_STATE
		do
			if (ch_inst.ch_end_seek).to_boolean then
				output_inst.error (ce_string ("Cannot seek to end of file"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_pos2 := input_inst.back_line ((ch_inst.ch_tell))
				if l_pos2 = -1 then
					jump_loc ((0).to_integer_32, screen_inst.sc_height - 1)
				else
					jump_loc (l_pos2, screen_inst.sc_height - 1)
				end
			end
		end

	jump_back (a_linenum: INTEGER_32)
		local
			l_pos2: INTEGER_32
			l_parg: PD_PARG
			l_pos: INTEGER_32
		do
			create l_parg.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pos2 := linenum_inst.find_pos (a_linenum)
					if l_pos2 = -1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (ch_inst.ch_seek (l_pos2)) = 0 then
							if command_inst.show_attn.to_boolean then
								input_inst.set_attnpos (l_pos2)
							end
							jump_loc (l_pos2, main_inst.jump_sline)
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if a_linenum <= 1 then
							if (ch_inst.ch_beg_seek) = 0 then
								jump_loc ((ch_inst.ch_tell), main_inst.jump_sline)
								output_inst.error (ce_string ("Cannot seek to beginning of file"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							else
								l_parg.p_linenum := a_linenum
								output_inst.error (ce_string ("Cannot seek to line number %%n"), l_parg.address)
							end
						else
							l_parg.p_linenum := a_linenum
							output_inst.error (ce_string ("Cannot seek to line number %%n"), l_parg.address)
						end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	repaint
		local
			l_scrpos: PD_SCRPOS
		do
			create l_scrpos.make

			position_inst.get_scrpos (l_scrpos.address)
			position_inst.pos_clear
			jump_loc (l_scrpos.pos, l_scrpos.ln)
		end

	jump_percent (a_percent: INTEGER_32)
		local
			l_pos2: INTEGER_32
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			l_len := ch_inst.ch_length
			if l_len = -1 then
				output_inst.ierror (ce_string ("Determining length of file"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
				ch_inst.ch_end_seek.do_nothing
			end
			l_len := ch_inst.ch_length
			if l_len = -1 then
				output_inst.error (ce_string ("Don%'t know length of file"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_pos2 := os_inst.percent_pos (l_len, a_percent)
				if l_pos2 >= l_len then
					l_pos2 := l_len - 1
				end
				jump_line_loc (l_pos2, main_inst.jump_sline)
			end
		end

	jump_line_loc (a_pos: INTEGER_32; a_sline: INTEGER_32)
		local
			l_pos2: INTEGER_32
			l_c: INTEGER_32
			js: JUMP_STATE
		do
			l_pos2 := a_pos
			if (ch_inst.ch_seek (l_pos2)) = 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					l_c := ch_inst.ch_back_get
					if l_c /= 10 then
						if l_c = -1 then
							js.break
						end
					else
						js.break
					end
				end
				js.reset
				if l_c = 10 then
					ch_inst.ch_forw_get.do_nothing
				end
				l_pos2 := ch_inst.ch_tell
			end
			if command_inst.show_attn.to_boolean then
				input_inst.set_attnpos (l_pos2)
			end
			jump_loc (l_pos2, a_sline)
		end

	jump_loc (a_pos: INTEGER_32; a_sline: INTEGER_32)
		local
			l_pos2: INTEGER_32
			l_sline: INTEGER_32
			l_nline: INTEGER_32
			l_tpos: INTEGER_32
			l_bpos: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pos2 := a_pos
					l_sline := a_sline
					l_sline := position_inst.adjsline (l_sline)
					l_nline := position_inst.onscreen (l_pos2)
					if l_nline >= 0 then
						l_nline := l_nline - l_sline
						if l_nline > 0 then
							forwback_inst.forw (l_nline, (position_inst.position (-2)), 1, 0, 0)
						else
							forwback_inst.back (-l_nline, (position_inst.position (0)), 1, 0)
						end
						if command_inst.show_attn.to_boolean then
							search_inst.repaint_hilite (1)
						end
						js.return
					end
					if not js.return_called then
						if (ch_inst.ch_seek (l_pos2)).to_boolean then
							output_inst.error (ce_string ("Cannot seek to that file position"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						l_tpos := position_inst.position (0)
						l_bpos := position_inst.position (-2)
						if l_tpos /= -1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if not (l_pos2 >= l_tpos) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						l_nline := 0
						from
						until
							not (not js.loop_left and then (l_nline < l_sline))
						loop
							js.reset
							if l_bpos /= -1 then
								if l_pos2 <= l_bpos then
									forwback_inst.forw (((screen_inst.sc_height - l_sline) + l_nline) - 1, l_bpos, 1, 0, 0)
									if command_inst.show_attn.to_boolean then
										search_inst.repaint_hilite (1)
									end
									js.return
								end
							end
							if not js.return_called then
								l_pos2 := input_inst.back_line (l_pos2)
								if l_pos2 = -1 then
									js.break
								end
								if not js.loop_jumped then
									l_nline := l_nline + 1
								end
							end
						end
						js.reset
						if not js.return_called then
							mark_inst.lastmark
							command_inst.hit_eof := 0
							forwback_inst.squished := 0
							command_inst.screen_trashed := 0
							forwback_inst.forw (screen_inst.sc_height - 1, l_pos2, 1, 0, l_sline - l_nline)
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_nline := l_sline
						from
						until
							not (not js.loop_left and then (l_nline < screen_inst.sc_height - 1))
						loop
							js.reset
							l_pos2 := input_inst.forw_line (l_pos2)
							if l_pos2 = -1 then
								js.break
							end
							if not js.loop_jumped then
								if l_pos2 >= l_tpos then
									forwback_inst.back (l_nline + 1, l_tpos, 1, 0)
									if command_inst.show_attn.to_boolean then
										search_inst.repaint_hilite (1)
									end
									js.return
								end
								if not js.return_called then
									l_nline := l_nline + 1
								end
							end
						end
						js.reset
						if not js.return_called then
							mark_inst.lastmark
							screen_inst.clear
							command_inst.screen_trashed := 0
							position_inst.add_back_pos (l_pos2)
							forwback_inst.back (screen_inst.sc_height - 1, l_pos2, 1, 0)
						end
				when 8 then -- if done | if done
						if not js.return_called then
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
