class
	P_LSYSTEM

inherit
	LESS_DATA
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {ANY} -- routines

	lsystem (a_cmd: CE_POINTER [INTEGER_8]; a_donemsg: CE_POINTER [INTEGER_8])
		local
			l_cmd: CE_POINTER [INTEGER_8]
			l_inp: INTEGER_32
			l_shell: CE_POINTER [INTEGER_8]
			l_p: CE_POINTER [INTEGER_8]
			l_save_ifile: CE_POINTER [ANY]
			l_esccmd: CE_POINTER [INTEGER_8]
			l_tmp___1: NATURAL_32
		do
			create l_cmd.make
			create l_shell.make
			create l_p.make
			create l_save_ifile.make
			create l_esccmd.make

			l_cmd.ce_gets (a_cmd)
			if (l_cmd[0]).to_integer_32 = 45 then
				l_cmd.ce_gets (l_cmd + 1)
			else
				screen_inst.clear_bot
				output_inst.putstr (ce_string ("!"))
				output_inst.putstr (l_cmd)
				output_inst.putstr (ce_string ("%N"))
			end
			l_save_ifile.ce_gets (edit_inst.save_curr_ifile)
			edit_inst.edit_ifile (create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
			screen_inst.deinit
			output_inst.flush
			screen_inst.raw_mode (0)
			signal_inst.init_signals (0)
			l_inp := dup (0)
			close (0).do_nothing
			if (open ([ce_string ("/dev/tty"), 0])) < 0 then
				dup (l_inp).do_nothing
			end
			l_p.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
			l_shell.ce_gets (decode_inst.lgetenv (ce_string ("SHELL")))
			if (l_shell.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (l_shell[0]).to_integer_32 /= 0 then
					if (l_cmd[0]).to_integer_32 = 0 then
						l_p.ce_gets (main_inst.save (l_shell))
					else
						l_esccmd.ce_gets ((filename_inst.shell_quote (l_cmd)))
						if (l_esccmd.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_tmp___1 := strlen (l_shell)
							l_p.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((main_inst.ecalloc (((l_tmp___1 + (strlen (l_esccmd))) + {NATURAL_32} 5).to_integer_32, Integer_8_bytes.to_natural_32))))
							sprintf ([l_p, ce_string ("%%s %%s %%s"), l_shell, (filename_inst.shell_coption), l_esccmd]).do_nothing
							free (create {CE_POINTER [ANY]}.make_cast (l_esccmd))
						end
					end
				end
			end
			if (l_p.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				if (l_cmd[0]).to_integer_32 = 0 then
					l_p.ce_gets (main_inst.save (ce_string ("sh")))
				else
					l_p.ce_gets (main_inst.save (l_cmd))
				end
			end
			system (l_p).do_nothing
			free (create {CE_POINTER [ANY]}.make_cast (l_p))
			close (0).do_nothing
			dup (l_inp).do_nothing
			close (l_inp).do_nothing
			signal_inst.init_signals (1)
			screen_inst.raw_mode (1)
			if (a_donemsg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				output_inst.putstr (a_donemsg)
				output_inst.putstr (ce_string ("  (press RETURN)"))
				output_inst.get_return
				output_inst.putchr (('%N').code).do_nothing
				output_inst.flush
			end
			screen_inst.init
			command_inst.screen_trashed := 1
			edit_inst.reedit_ifile (l_save_ifile)
			signal_inst.winch (0)
		end

	pipe_mark (a_c: INTEGER_32; a_cmd: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_mpos: INTEGER_32
			l_tpos: INTEGER_32
			l_bpos: INTEGER_32
			js: JUMP_STATE
		do
			l_mpos := mark_inst.markpos (a_c)
			if l_mpos = -1 then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				l_tpos := position_inst.position (0)
				if l_tpos = -1 then
					l_tpos := (0).to_integer_32
				end
				l_bpos := position_inst.position (-1)
				if a_c = 46 then
					Result := (pipe_data (a_cmd, l_tpos, l_bpos))
				elseif l_mpos <= l_tpos then
					Result := (pipe_data (a_cmd, l_mpos, l_bpos))
				elseif l_bpos = -1 then
					Result := (pipe_data (a_cmd, l_tpos, l_bpos))
				else
					Result := (pipe_data (a_cmd, l_tpos, l_mpos))
				end
			end
		end

	pipe_data (a_cmd: CE_POINTER [INTEGER_8]; a_spos: INTEGER_32; a_epos: INTEGER_32): INTEGER_32
		local
			l_spos: INTEGER_32
			l_f: CE_POINTER [SD_IO_FILE]
			l_c: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_f.make

			l_spos := a_spos
			if (ch_inst.ch_seek (l_spos)) /= 0 then
				output_inst.error (ce_string ("Cannot seek to start position"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
				Result := (-1)
				js.return
			end
			if not js.return_called then
				l_f.ce_gets (popen (a_cmd, ce_string ("w")))
				if (l_f.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					output_inst.error (ce_string ("Cannot create pipe"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				screen_inst.clear_bot
				output_inst.putstr (ce_string ("!"))
				output_inst.putstr (a_cmd)
				output_inst.putstr (ce_string ("%N"))
				screen_inst.deinit
				output_inst.flush
				screen_inst.raw_mode (0)
				signal_inst.init_signals (0)
				signal (13, create {CE_ROUTINE}.make_shared (default_pointer + 1)).do_nothing
				l_c := -1
				from
				until
					js.loop_left
				loop
					js.reset
					if a_epos /= -1 then
						l_tmp___1 := l_spos
						l_spos := l_spos + 1
						if not (l_tmp___1 <= a_epos) then
							js.break
						end
					end
					if not js.loop_jumped then
						l_c := ch_inst.ch_forw_get
						if l_c = -1 then
							js.break
						end
					end
					if not js.loop_jumped then
						if (IO_putc (l_c, l_f)) = -1 then
							js.break
						end
					end
				end
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					if l_c /= 10 then
						if l_c = -1 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_c := ch_inst.ch_forw_get
						if l_c = -1 then
							js.break
						end
					end
					if not js.loop_jumped then
						if (IO_putc (l_c, l_f)) = -1 then
							js.break
						end
					end
				end
				js.reset
				pclose (l_f).do_nothing
				signal (13, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
				signal_inst.init_signals (1)
				screen_inst.raw_mode (1)
				screen_inst.init
				command_inst.screen_trashed := 1
				signal_inst.winch (0)
				Result := 0
			end
		end

end
