class
	P_OPTFUNC

inherit
	LESS_DATA
		redefine
			default_create
		end
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {NONE} -- Initialization

	default_create
		do
			create prproto.make (<<3>>)
			create tagoption.make
		end

feature {ANY} -- attributes

	bufspace: INTEGER_32 assign set_bufspace
		do
			Result := bufspace_address[0]
		end

	set_bufspace (a_bufspace: INTEGER_32)
		do
			bufspace_address[0] := a_bufspace
		end

	bufspace_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	pr_type: INTEGER_32 assign set_pr_type
		do
			Result := pr_type_address[0]
		end

	set_pr_type (a_pr_type: INTEGER_32)
		do
			pr_type_address[0] := a_pr_type
		end

	pr_type_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	prproto: CE_ARRAY [CE_POINTER [INTEGER_8]]

	tagoption: CE_POINTER [INTEGER_8]

feature {ANY} -- routines

	opt_o (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_s: CE_POINTER [INTEGER_8]
			l_parg: PD_PARG
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_parg.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s.ce_gets (a_s)
					if main_inst.secure.to_boolean then
						output_inst.error (ce_string ("log file support is not available"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						inspect a_type -- switch 1 head
						when 0 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 3
						when 1 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 2 then -- switch 1, case 0
						main_inst.namelogfile.ce_gets (l_s)
						l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case 2
						if (((ch_inst.ch_getflags)).bit_and (1)).to_boolean then
							output_inst.error (ce_string ("Input is not a pipe"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called and then (main_inst.logfile >= 0) then
							output_inst.error (ce_string ("Log file is already in use"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called then
							l_s.ce_gets (main_inst.skipsp (l_s))
							main_inst.namelogfile.ce_gets (filename_inst.lglob (l_s))
							edit_inst.use_logfile (main_inst.namelogfile)
							ch_inst.sync_logfile
						end
						l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, case 1
						if main_inst.logfile < 0 then
							output_inst.error (ce_string ("No log file"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
						else
							l_parg.p_string := main_inst.namelogfile
							output_inst.error (ce_string ("Log file %"%%s%""), l_parg.address)
						end
						l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done: | if done
						if not js.return_called then
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	opt_o_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent opt_o)
		end

	opt__O (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		do
			main_inst.force_logfile := 1
			opt_o (a_type, a_s)
		end

	opt__O_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent opt__O)
		end

	opt_l (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_err: INTEGER_32
			l_n: INTEGER_32
			l_t: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_t.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_type -- switch 1 head
					when 0 then l_pos := -1 + 1
					else l_pos := -1 + 2
					end
				when 1 then -- switch 1, case 0
					l_t.ce_gets (a_s)
					l_n := option_inst.getnum (l_t.address, ce_string ("l"), create {CE_POINTER [INTEGER_32]}.make_shared ($l_err))
					if l_err.to_boolean then
						output_inst.error (ce_string ("Line number is required after -l"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
						js.return
					elseif l_n <= 0 then
						output_inst.error (ce_string ("Line number is required after -l"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						option_inst.plusoption := 1
						command_inst.ungetsc (a_s)
					end
					l_pos := -1 + 2 -- switch 1; break
				when 2 then -- switch 1, done:
					if not js.return_called then
					end
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt_l_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent opt_l)
		end

	opt_k (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_parg: PD_PARG
			l_pos: INTEGER_32
		do
			create l_parg.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_type -- switch 1 head
					when 0 then l_pos := -1 + 1
					else l_pos := -1 + 2
					end
				when 1 then -- switch 1, case 0
					if (decode_inst.lesskey (a_s, 0)).to_boolean then
						l_parg.p_string := a_s
						output_inst.error (ce_string ("Cannot use lesskey file %"%%s%""), l_parg.address)
					end
					l_pos := -1 + 2 -- switch 1; break
				when 2 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt_k_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent opt_k)
		end

	opt_t (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_save_ifile: CE_POINTER [ANY]
			l_pos2: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_save_ifile.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_type -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					else l_pos := -1 + 6
					end
				when 1 then -- switch 1, case 0
					tagoption.ce_gets (a_s)
					l_pos := -1 + 6 -- switch 1; break
				when 2 then -- switch 1, case 2
					if main_inst.secure.to_boolean then
						output_inst.error (ce_string ("tags support is not available"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
						l_pos := -1 + 6 -- switch 1; break
					end
				when 3 then
					tags_inst.findtag ((main_inst.skipsp (a_s)))
					l_save_ifile.ce_gets (edit_inst.save_curr_ifile)
					if (tags_inst.edit_tagfile).to_boolean then
						l_pos := -1 + 6 -- switch 1; break
					end
				when 4 then
					l_pos2 := tags_inst.tagsearch
					if l_pos2 = -1 then
						edit_inst.reedit_ifile (l_save_ifile)
						l_pos := -1 + 6 -- switch 1; break
					end
				when 5 then
					edit_inst.unsave_ifile (l_save_ifile)
					jump_inst.jump_loc (l_pos2, main_inst.jump_sline)
					l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt_t_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent opt_t)
		end

	opt__T (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_s: CE_POINTER [INTEGER_8]
			l_parg: PD_PARG
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_parg.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s.ce_gets (a_s)
					inspect a_type -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 1 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 0
					tags_inst.tags.ce_gets (l_s)
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 2
					l_s.ce_gets (main_inst.skipsp (l_s))
					tags_inst.tags.ce_gets (filename_inst.lglob (l_s))
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, case 1
					l_parg.p_string := tags_inst.tags
					output_inst.error (ce_string ("Tags file %"%%s%""), l_parg.address)
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt__T_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent opt__T)
		end

	opt_p (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_type -- switch 1 head
					when 0 then l_pos := -1 + 1
					else l_pos := -1 + 2
					end
				when 1 then -- switch 1, case 0
					option_inst.plusoption := 1
					command_inst.ungetsc (a_s)
					command_inst.ungetsc (ce_string ("/"))
					l_pos := -1 + 2 -- switch 1; break
				when 2 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt_p_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent opt_p)
		end

	opt__P (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_s: CE_POINTER [INTEGER_8]
			l_proto: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_parg: PD_PARG
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_proto.make
			create l_parg.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s.ce_gets (a_s)
					inspect a_type -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 10
					else l_pos := -1 + 11
					end
				when 1 then -- switch 1, case 0 | switch 1, case 2
					inspect (l_s[0]).to_integer_32 -- switch 2 head
					when 115 then l_pos := -1 + 2
					when 109 then l_pos := -1 + 3
					when 77 then l_pos := -1 + 4
					when 61 then l_pos := -1 + 5
					when 104 then l_pos := -1 + 6
					when 119 then l_pos := -1 + 7
					else l_pos := -1 + 8
					end
				when 2 then -- switch 2, case 115
					l_proto.ce_gets (prproto + 0)
					l_s.ce_gets (l_s + 1)
					l_pos := -1 + 9 -- switch 2; break
				when 3 then -- switch 2, case 109
					l_proto.ce_gets (prproto + 1)
					l_s.ce_gets (l_s + 1)
					l_pos := -1 + 9 -- switch 2; break
				when 4 then -- switch 2, case 77
					l_proto.ce_gets (prproto + 2)
					l_s.ce_gets (l_s + 1)
					l_pos := -1 + 9 -- switch 2; break
				when 5 then -- switch 2, case 61
					l_proto.ce_gets ((prompt_inst.eqproto.address))
					l_s.ce_gets (l_s + 1)
					l_pos := -1 + 9 -- switch 2; break
				when 6 then -- switch 2, case 104
					l_proto.ce_gets ((prompt_inst.hproto.address))
					l_s.ce_gets (l_s + 1)
					l_pos := -1 + 9 -- switch 2; break
				when 7 then -- switch 2, case 119
					l_proto.ce_gets ((prompt_inst.wproto.address))
					l_s.ce_gets (l_s + 1)
					l_pos := -1 + 9 -- switch 2; break
				when 8 then -- switch 2, default:
					l_proto.ce_gets (prproto + 0)
					l_pos := -1 + 9 -- switch 2; break
				when 9 then -- switch 2, done:
					free (create {CE_POINTER [ANY]}.make_cast (l_proto.item))
					l_proto.item := main_inst.save (l_s)
					l_pos := -1 + 11 -- switch 1; break
				when 10 then -- switch 1, case 1
					l_parg.p_string := prproto[pr_type]
					output_inst.error (ce_string ("%%s"), l_parg.address)
					l_pos := -1 + 11 -- switch 1; break
				when 11 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt__P_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent opt__P)
		end

	opt_b (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_type -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 0 | switch 1, case 2
					ch_inst.ch_setbufspace (bufspace)
					l_pos := -1 + 3 -- switch 1; break
				when 2 then -- switch 1, case 1
					l_pos := -1 + 3 -- switch 1; break
				when 3 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt_b_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent opt_b)
		end

	opt_i (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_type -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 0 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2
					search_inst.chg_caseless
					l_pos := -1 + 3 -- switch 1; break
				when 2 then -- switch 1, case 1 | switch 1, case 0
					l_pos := -1 + 3 -- switch 1; break
				when 3 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt_i_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent opt_i)
		end

	opt__V (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_type -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 1
					when 0 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2 | switch 1, case 1
					command_inst.dispversion
					l_pos := -1 + 3 -- switch 1; break
				when 2 then -- switch 1, case 0
					main_inst.any_display := 1
					output_inst.putstr (ce_string ("less "))
					output_inst.putstr (version_inst.version)
					output_inst.putstr (ce_string ("%NCopyright (C) 2002 Mark Nudelman%N%N"))
					output_inst.putstr (ce_string ("less comes with NO WARRANTY, to the extent permitted by law.%N"))
					output_inst.putstr (ce_string ("For information about the terms of redistribution,%N"))
					output_inst.putstr (ce_string ("see the file named README in the less distribution.%N"))
					output_inst.putstr (ce_string ("Homepage: http://www.greenwoodsoftware.com/less%N"))
					main_inst.quit (0)
					l_pos := -1 + 3 -- switch 1; break
				when 3 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt__V_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent opt__V)
		end

	opt_x (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_s: CE_POINTER [INTEGER_8]
			l_msg: CE_ARRAY [INTEGER_8]
			l_i: INTEGER_32
			l_p: PD_PARG
			l_n: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_msg.make (<<188>>)
			create l_p.make
			create l_tmp.make
			create l_tmp___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s.ce_gets (a_s)
					inspect a_type -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 0 | switch 1, case 2
					l_i := 1
					from
					until
						not (not js.loop_left and then (l_i < 32))
					loop
						js.reset
						l_n := 0
						l_s.ce_gets (main_inst.skipsp (l_s))
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_s[0]).to_integer_32 >= 48 then
								if not ((l_s[0]).to_integer_32 <= 57) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_tmp.ce_gets (l_s)
								l_s.ce_gets (l_s + 1)
								l_n := 10 * l_n + ((l_tmp[0]).to_integer_32 - 48)
							end
						end
						js.reset
						if l_n > line_inst.tabstops[l_i - 1] then
							l_tmp___0 := l_i
							l_i := l_i + 1
							line_inst.tabstops[l_tmp___0] := l_n
						end
						l_s.ce_gets (main_inst.skipsp (l_s))
						l_tmp___1.ce_gets (l_s)
						l_s.ce_gets (l_s + 1)
						if (l_tmp___1[0]).to_integer_32 /= 44 then
							js.break
						end
					end
					js.reset
					if l_i < 2 then
						js.return
					end
					if not js.return_called then
						line_inst.ntabstops := l_i
						line_inst.tabdefault := line_inst.tabstops[line_inst.ntabstops - 1] - line_inst.tabstops[line_inst.ntabstops - 2]
					end
					l_pos := -1 + 3 -- switch 1; break
				when 2 then -- switch 1, case 1
					strcpy (l_msg, ce_string ("Tab stops ")).do_nothing
					if line_inst.ntabstops > 2 then
						l_i := 1
						from
						until
							not (l_i < line_inst.ntabstops)
						loop
							if l_i > 1 then
								strcat (l_msg, ce_string (",")).do_nothing
							end
							sprintf ([(l_msg + (strlen (l_msg)).to_integer_32), ce_string ("%%d"), line_inst.tabstops[l_i]]).do_nothing
							l_i := l_i + 1
						end
						sprintf ([(l_msg + (strlen (l_msg)).to_integer_32), ce_string (" and then ")]).do_nothing
					end
					sprintf ([(l_msg + (strlen (l_msg)).to_integer_32), ce_string ("every %%d spaces"), line_inst.tabdefault]).do_nothing
					l_p.p_string := l_msg
					output_inst.error (ce_string ("%%s"), l_p.address)
					l_pos := -1 + 3 -- switch 1; break
				when 3 then -- switch 1, done:
					if not js.return_called then
					end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt_x_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent opt_x)
		end

	opt_quote (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_buf___1: CE_ARRAY [INTEGER_8]
			l_parg: PD_PARG
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___1.make (<<3>>)
			create l_parg.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_type -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 0 | switch 1, case 2
					if (a_s[0]).to_integer_32 = 0 then
						cmdbuf_inst.closequote := (('%/0/').code).to_integer_8
						cmdbuf_inst.openquote := cmdbuf_inst.closequote
						l_pos := -1 + 4 -- switch 1; break
					end
				when 2 then
					if (a_s[1]).to_integer_32 /= 0 then
						if (a_s[2]).to_integer_32 /= 0 then
							output_inst.error (ce_string ("-%" must be followed by 1 or 2 chars"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							js.return
						end
					end
					if not js.return_called then
						cmdbuf_inst.openquote := a_s[0]
						if (a_s[1]).to_integer_32 = 0 then
							cmdbuf_inst.closequote := cmdbuf_inst.openquote
						else
							cmdbuf_inst.closequote := a_s[1]
						end
					end
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, case 1
					l_buf___1[0] := cmdbuf_inst.openquote
					l_buf___1[1] := cmdbuf_inst.closequote
					l_buf___1[2] := (('%/0/').code).to_integer_8
					l_parg.p_string := l_buf___1
					output_inst.error (ce_string ("quotes %%s"), l_parg.address)
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					if not js.return_called then
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt_quote_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent opt_quote)
		end

	opt_query (a_type: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_type -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 1
					when 0 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 1 | switch 1, case 2
					output_inst.error (ce_string ("Use %"h%" for help"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
					l_pos := -1 + 3 -- switch 1; break
				when 2 then -- switch 1, case 0
					main_inst.dohelp := 1
				when 3 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	opt_query_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent opt_query)
		end

	get_swindow: INTEGER_32
		local
			js: JUMP_STATE
		do
			if command_inst.swindow > 0 then
				Result := command_inst.swindow
				js.return
			end
			if not js.return_called then
				Result := (screen_inst.sc_height + command_inst.swindow)
			end
		end

end
