class
	P_OPTTBL

inherit
	LESS_DATA
		redefine
			default_create
		end
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {NONE} -- Initialization

	default_create
		do
			create a_optname.make
			create b_optname.make
			create B__optname.make
			create c2_optname.make
			create d_optname.make
			create e_optname.make
			create f_optname.make
			create F__optname.make
			create g_optname.make
			create h_optname.make
			create i_optname.make
			create j_optname.make
			create J__optname.make
			create k_optname.make
			create L__optname.make
			create m_optname.make
			create n_optname.make
			create o_optname.make
			create O__optname.make
			create p_optname.make
			create P__optname.make
			create q2_optname.make
			create q_optname.make
			create r_optname.make
			create s_optname.make
			create S__optname.make
			create t_optname.make
			create T__optname.make
			create u_optname.make
			create V__optname.make
			create w_optname.make
			create x_optname.make
			create X__optname.make
			create y_optname.make
			create z_optname.make
			create quote_optname.make
			create tilde_optname.make
			create query_optname.make
			create pound_optname.make
			create keypad_optname.make
			create option.make (<<41>>)
		end

feature {ANY} -- attributes

	how_search: INTEGER_32 assign set_how_search
		do
			Result := how_search_address[0]
		end

	set_how_search (a_how_search: INTEGER_32)
		do
			how_search_address[0] := a_how_search
		end

	how_search_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	tabstop: INTEGER_32 assign set_tabstop

	set_tabstop (a_tabstop: INTEGER_32)
		do
			tabstop := a_tabstop
		end

	caseless: INTEGER_32 assign set_caseless
		do
			Result := caseless_address[0]
		end

	set_caseless (a_caseless: INTEGER_32)
		do
			caseless_address[0] := a_caseless
		end

	caseless_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	a_optname: PD_OPTNAME

	b_optname: PD_OPTNAME

	B__optname: PD_OPTNAME

	c2_optname: PD_OPTNAME

	d_optname: PD_OPTNAME

	e_optname: PD_OPTNAME

	f_optname: PD_OPTNAME

	F__optname: PD_OPTNAME

	g_optname: PD_OPTNAME

	h_optname: PD_OPTNAME

	i_optname: PD_OPTNAME

	j_optname: PD_OPTNAME

	J__optname: PD_OPTNAME

	k_optname: PD_OPTNAME

	L__optname: PD_OPTNAME

	m_optname: PD_OPTNAME

	n_optname: PD_OPTNAME

	o_optname: PD_OPTNAME

	O__optname: PD_OPTNAME

	p_optname: PD_OPTNAME

	P__optname: PD_OPTNAME

	q2_optname: PD_OPTNAME

	q_optname: PD_OPTNAME

	r_optname: PD_OPTNAME

	s_optname: PD_OPTNAME

	S__optname: PD_OPTNAME

	t_optname: PD_OPTNAME

	T__optname: PD_OPTNAME

	u_optname: PD_OPTNAME

	V__optname: PD_OPTNAME

	w_optname: PD_OPTNAME

	x_optname: PD_OPTNAME

	X__optname: PD_OPTNAME

	y_optname: PD_OPTNAME

	z_optname: PD_OPTNAME

	quote_optname: PD_OPTNAME

	tilde_optname: PD_OPTNAME

	query_optname: PD_OPTNAME

	pound_optname: PD_OPTNAME

	keypad_optname: PD_OPTNAME

	option: CE_ARRAY [PD_LOPTION]

feature {ANY} -- routines

	init_option
		local
			l_o: CE_POINTER [PD_LOPTION]
		do
			create l_o.make

			l_o.ce_gets (option)
			from
			until
				(l_o.item.oletter).to_integer_32 = 0
			loop
				if ((l_o.item.ovar).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					(l_o.item.ovar).item := l_o.item.odefault
				end
				if ((l_o.item.otype).bit_and (512)).to_boolean then
					(l_o.item.ofunc).call ([0, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)])
				end
				l_o.ce_gets (l_o + 1)
			end
		end

	findopt (a_c: INTEGER_32): CE_POINTER [PD_LOPTION]
		local
			l_o: CE_POINTER [PD_LOPTION]
			js: JUMP_STATE
		do
			create l_o.make

			l_o.ce_gets (option)
			from
			until
				not (not js.loop_left and then ((l_o.item.oletter).to_integer_32 /= 0))
			loop
				if (l_o.item.oletter).to_integer_32 = a_c then
					Result := l_o
					js.return
				end
				if not js.return_called and then (((l_o.item.otype).bit_and (2)).to_boolean) then
					if (toupper ((l_o.item.oletter).to_integer_32)) = a_c then
						Result := l_o
						js.return
					end
				end
				if not js.return_called then
					l_o.ce_gets (l_o + 1)
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [PD_LOPTION]}.make_shared (default_pointer))
			end
		end

	is_optchar (a_c: INTEGER_8): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_c.to_integer_32 >= 65 then
				if a_c.to_integer_32 <= 90 then
					Result := 1
					js.return
				end
			end
			if not js.return_called and then (a_c.to_integer_32 >= 97) then
				if a_c.to_integer_32 <= 122 then
					Result := 1
					js.return
				end
			end
			if not js.return_called and then (a_c.to_integer_32 = 45) then
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	findopt_name (a_p_optname___0: CE_POINTER [CE_POINTER [INTEGER_8]]; a_p_oname: CE_POINTER [CE_POINTER [INTEGER_8]]; a_p_err: CE_POINTER [INTEGER_32]): CE_POINTER [PD_LOPTION]
		local
			l_optname: CE_POINTER [INTEGER_8]
			l_o: CE_POINTER [PD_LOPTION]
			l_oname: CE_POINTER [PD_OPTNAME]
			l_len: INTEGER_32
			l_uppercase: INTEGER_32
			l_maxo: CE_POINTER [PD_LOPTION]
			l_maxoname: CE_POINTER [PD_OPTNAME]
			l_maxlen: INTEGER_32
			l_ambig: INTEGER_32
			l_exact: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_optname.make
			create l_o.make
			create l_oname.make
			create l_maxo.make
			create l_maxoname.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_optname.ce_gets (a_p_optname___0.item)
					l_maxo.ce_gets (create {CE_POINTER [PD_LOPTION]}.make_shared (default_pointer))
					l_maxoname.ce_gets (create {CE_POINTER [PD_OPTNAME]}.make_shared (default_pointer))
					l_maxlen := 0
					l_ambig := 0
					l_exact := 0
					l_o.ce_gets (option)
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_o.item.oletter).to_integer_32 /= 0)) then
						l_pos := -1 + 15 -- skip loop
					end
				when 2 then -- loop body:
						l_oname.ce_gets (l_o.item.onames)
				when 3 then -- loop condition:
						if not (not js.loop_left and then ((l_oname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32)) then
							l_pos := -1 + 14 -- skip loop
						end
				when 4 then -- loop body:
						l_uppercase := 0
				when 5 then -- loop condition:
						if not (not js.loop_left and then (l_uppercase <= 1)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 6 then -- loop body:
						js.reset
						l_len := main_inst.sprefix (l_optname, l_oname.item.oname, l_uppercase)
						if l_len <= 0 then
							js.continue
						elseif (is_optchar (l_optname[l_len])).to_boolean then
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						if l_exact.to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_len = l_maxlen then
							l_ambig := 1
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						if l_len > l_maxlen then
							l_maxo.ce_gets (l_o)
							l_maxoname.ce_gets (l_oname)
							l_maxlen := l_len
							l_ambig := 0
							l_exact := (l_len = (strlen (l_oname.item.oname)).to_integer_32).to_integer
						end
				when 11 then
						if not ((l_o.item.otype).bit_and (2)).to_boolean then
							js.break
						end
				when 12 then -- if done
						if not js.loop_left then
							l_uppercase := l_uppercase + 1
						end
						l_pos := -1 + 5 -- back to loop condition
				when 13 then -- loop done
						js.reset
						l_oname.ce_gets (l_oname.item.onext)
						l_pos := -1 + 3 -- back to loop condition
				when 14 then -- loop done
						l_o.ce_gets (l_o + 1)
						l_pos := -1 + 1 -- back to loop condition
				when 15 then -- loop done
					if l_ambig.to_boolean then
						if (a_p_err.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							a_p_err.item := 1
						end
						Result := (create {CE_POINTER [PD_LOPTION]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						a_p_optname___0.item := l_optname + l_maxlen
						if (a_p_oname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (l_maxoname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								a_p_oname.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							else
								a_p_oname.item := l_maxoname.item.oname
							end
						end
						Result := l_maxo
					end
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
