class
	P_PROMPT

inherit
	LESS_DATA
		redefine
			default_create
		end
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {NONE} -- Initialization

	default_create
		do
			create s_proto.make (<<52>>)
			create m_proto.make (<<77>>)
			create M_proto2.make (<<102>>)
			create e_proto.make (<<84>>)
			create h_proto.make (<<80>>)
			create w_proto.make (<<17>>)
			create eqproto.make
			create hproto.make
			create wproto.make
			create message.make (<<200>>)
			create mp.make
		end

feature {ANY} -- attributes

	s_proto: CE_ARRAY [INTEGER_8]

	m_proto: CE_ARRAY [INTEGER_8]

	M_proto2: CE_ARRAY [INTEGER_8]

	e_proto: CE_ARRAY [INTEGER_8]

	h_proto: CE_ARRAY [INTEGER_8]

	w_proto: CE_ARRAY [INTEGER_8]

	eqproto: CE_POINTER [INTEGER_8]

	hproto: CE_POINTER [INTEGER_8]

	wproto: CE_POINTER [INTEGER_8]

	message: CE_ARRAY [INTEGER_8]

	mp: CE_POINTER [INTEGER_8]

feature {ANY} -- routines

	init_prompt
		do
			optfunc_inst.prproto[0] := main_inst.save (s_proto)
			optfunc_inst.prproto[1] := main_inst.save (m_proto)
			optfunc_inst.prproto[2] := main_inst.save (M_proto2)
			eqproto.ce_gets ((main_inst.save (e_proto)))
			hproto.ce_gets ((main_inst.save (h_proto)))
			wproto.ce_gets ((main_inst.save (w_proto)))
		end

	ap_str (a_s: CE_POINTER [INTEGER_8])
		local
			l_len: INTEGER_32
		do
			l_len := (strlen (a_s)).to_integer_32
			if ((mp + l_len).c_pointer.to_integer_32).to_natural_32 >= ((message + 200).c_pointer.to_integer_32).to_natural_32 then
				l_len := ((message + 200).distance (mp)) - 1
			end
			strncpy (mp, a_s, l_len.to_natural_32).do_nothing
			mp.ce_gets (mp + l_len)
			mp[0] := (('%/0/').code).to_integer_8
		end

	ap_char (a_c: INTEGER_8)
		local
			l_buf___1: CE_ARRAY [INTEGER_8]
		do
			create l_buf___1.make (<<2>>)

			l_buf___1[0] := a_c
			l_buf___1[1] := (('%/0/').code).to_integer_8
			ap_str (l_buf___1)
		end

	ap_pos (a_pos: INTEGER_32)
		local
			l_buf___1: CE_ARRAY [INTEGER_8]
		do
			create l_buf___1.make (<<(((((Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1000 + {NATURAL_32} 1) + {NATURAL_32} 1) + {NATURAL_32} 2).to_integer_32>>)

			output_inst.postoa (a_pos, l_buf___1)
			ap_str (l_buf___1)
		end

	ap_linenum (a_linenum: INTEGER_32)
		local
			l_buf___1: CE_ARRAY [INTEGER_8]
		do
			create l_buf___1.make (<<(((((Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1000 + {NATURAL_32} 1) + {NATURAL_32} 1) + {NATURAL_32} 2).to_integer_32>>)

			output_inst.linenumtoa (a_linenum, l_buf___1)
			ap_str (l_buf___1)
		end

	ap_int (a_num: INTEGER_32)
		local
			l_buf___1: CE_ARRAY [INTEGER_8]
		do
			create l_buf___1.make (<<(((((Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1000 + {NATURAL_32} 1) + {NATURAL_32} 1) + {NATURAL_32} 2).to_integer_32>>)

			output_inst.inttoa (a_num, l_buf___1)
			ap_str (l_buf___1)
		end

	ap_quest
		do
			ap_str (ce_string ("?"))
		end

	curr_byte (a_where: INTEGER_32): INTEGER_32
		local
			l_where: INTEGER_32
			l_pos2: INTEGER_32
			js: JUMP_STATE
		do
			l_where := a_where
			l_pos2 := position_inst.position (l_where)
			from
			until
				js.loop_left
			loop
				js.reset
				if l_pos2 = -1 then
					if l_where >= 0 then
						if not (l_where < screen_inst.sc_height) then
							js.break
						end
					else
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_where := l_where + 1
					l_pos2 := position_inst.position (l_where)
				end
			end
			js.reset
			if l_pos2 = -1 then
				l_pos2 := ch_inst.ch_length
			end
			Result := l_pos2
		end

	cond (a_c: INTEGER_8; a_where: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___17: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_c.to_integer_32 -- switch 1 head
					when 97 then l_pos := -1 + 1
					when 98 then l_pos := -1 + 2
					when 99 then l_pos := -1 + 3
					when 101 then l_pos := -1 + 4
					when 102 then l_pos := -1 + 5
					when 108 then l_pos := -1 + 6
					when 100 then l_pos := -1 + 6
					when 76 then l_pos := -1 + 7
					when 68 then l_pos := -1 + 7
					when 109 then l_pos := -1 + 8
					when 110 then l_pos := -1 + 9
					when 112 then l_pos := -1 + 10
					when 80 then l_pos := -1 + 11
					when 115 then l_pos := -1 + 12
					when 66 then l_pos := -1 + 12
					when 120 then l_pos := -1 + 13
					else l_pos := -1 + 14
					end
				when 1 then -- switch 1, case 97
					Result := ((mp.c_pointer.to_integer_32).to_natural_32 > (message.c_pointer.to_integer_32).to_natural_32).to_integer
					js.return
				when 2 then -- switch 1, case 98
					if not js.return_called then
						Result := ((curr_byte (a_where)) /= -1).to_integer
						js.return
					end
				when 3 then -- switch 1, case 99
					if not js.return_called then
						Result := (command_inst.hshift /= 0).to_integer
						js.return
					end
				when 4 then -- switch 1, case 101
					if not js.return_called then
						Result := command_inst.hit_eof
						js.return
					end
				when 5 then -- switch 1, case 102
					if not js.return_called then
						Result := ((strcmp ((ifile_inst.get_filename (main_inst.curr_ifile)), ce_string ("-"))) /= 0).to_integer
						js.return
					end
				when 6 then -- switch 1, case 108 | switch 1, case 100
					if not js.return_called then
						Result := line_inst.linenums
						js.return
					end
				when 7 then -- switch 1, case 76 | switch 1, case 68
					if not js.return_called then
						if line_inst.linenums.to_boolean then
							if (ch_inst.ch_length) /= -1 then
								l_tmp___3 := 1
							else
								l_tmp___3 := 0
							end
						else
							l_tmp___3 := 0
						end
						Result := l_tmp___3
						js.return
					end
				when 8 then -- switch 1, case 109
					if not js.return_called then
						if (tags_inst.ntags).to_boolean then
							l_tmp___7 := ((tags_inst.ntags) > 1).to_integer
						else
							l_tmp___7 := ((ifile_inst.nifile) > 1).to_integer
						end
						Result := l_tmp___7
						js.return
					end
				when 9 then -- switch 1, case 110
					if not js.return_called then
						if (tags_inst.ntags).to_boolean then
							l_tmp___10 := 1
						else
							l_tmp___10 := main_inst.new_file
						end
						Result := l_tmp___10
						js.return
					end
				when 10 then -- switch 1, case 112
					if not js.return_called then
						if (curr_byte (a_where)) /= -1 then
							if (ch_inst.ch_length) > 0 then
								l_tmp___14 := 1
							else
								l_tmp___14 := 0
							end
						else
							l_tmp___14 := 0
						end
						Result := l_tmp___14
						js.return
					end
				when 11 then -- switch 1, case 80
					if not js.return_called then
						if (linenum_inst.currline (a_where)) /= 0 then
							l_len := ch_inst.ch_length
							if l_len > 0 then
								if (linenum_inst.find_linenum (l_len)) /= 0 then
									l_tmp___17 := 1
								else
									l_tmp___17 := 0
								end
							else
								l_tmp___17 := 0
							end
						else
							l_tmp___17 := 0
						end
						Result := l_tmp___17
						js.return
					end
				when 12 then -- switch 1, case 115 | switch 1, case 66
					if not js.return_called then
						Result := ((ch_inst.ch_length) /= -1).to_integer
						js.return
					end
				when 13 then -- switch 1, case 120
					if not js.return_called then
						if (tags_inst.ntags).to_boolean then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						Result := (((ifile_inst.next_ifile (main_inst.curr_ifile)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
						js.return
					end
				when 14 then -- switch 1, done:
					if not js.return_called then
						Result := 0
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	protochar (a_c: INTEGER_32; a_where: INTEGER_32; a_iseditproto: INTEGER_32)
		local
			l_pos2: INTEGER_32
			l_len: INTEGER_32
			l_n: INTEGER_32
			l_linenum: INTEGER_32
			l_last_linenum: INTEGER_32
			l_h: CE_POINTER [ANY]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_h.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_c -- switch 1 head
					when 98 then l_pos := -1 + 1
					when 99 then l_pos := -1 + 2
					when 100 then l_pos := -1 + 3
					when 68 then l_pos := -1 + 4
					when 69 then l_pos := -1 + 5
					when 102 then l_pos := -1 + 6
					when 105 then l_pos := -1 + 7
					when 108 then l_pos := -1 + 8
					when 76 then l_pos := -1 + 9
					when 109 then l_pos := -1 + 10
					when 112 then l_pos := -1 + 11
					when 80 then l_pos := -1 + 12
					when 115 then l_pos := -1 + 13
					when 66 then l_pos := -1 + 13
					when 116 then l_pos := -1 + 14
					when 84 then l_pos := -1 + 15
					when 120 then l_pos := -1 + 16
					else l_pos := -1 + 17
					end
				when 1 then -- switch 1, case 98
					l_pos2 := curr_byte (a_where)
					if l_pos2 /= -1 then
						ap_pos (l_pos2)
					else
						ap_quest
					end
					l_pos := -1 + 17 -- switch 1; break
				when 2 then -- switch 1, case 99
					ap_int (command_inst.hshift)
					l_pos := -1 + 17 -- switch 1; break
				when 3 then -- switch 1, case 100
					l_linenum := linenum_inst.currline (a_where)
					if l_linenum > 0 then
						if screen_inst.sc_height > 1 then
							ap_linenum ((l_linenum - 1) // (screen_inst.sc_height - 1).to_integer_32 + 1)
						else
							ap_quest
						end
					else
						ap_quest
					end
					l_pos := -1 + 17 -- switch 1; break
				when 4 then -- switch 1, case 68
					l_len := ch_inst.ch_length
					if l_len = -1 then
						ap_quest
					elseif l_len = 0 then
						ap_quest
					else
						l_linenum := linenum_inst.find_linenum (l_len)
						if l_linenum <= 0 then
							ap_quest
						else
							ap_linenum ((l_linenum - 1) // (screen_inst.sc_height - 1).to_integer_32 + 1)
						end
					end
					l_pos := -1 + 17 -- switch 1; break
				when 5 then -- switch 1, case 69
					ap_str (main_inst.editor)
					l_pos := -1 + 17 -- switch 1; break
				when 6 then -- switch 1, case 102
					ap_str ((ifile_inst.get_filename (main_inst.curr_ifile)))
					l_pos := -1 + 17 -- switch 1; break
				when 7 then -- switch 1, case 105
					if (tags_inst.ntags).to_boolean then
						ap_int ((tags_inst.curr_tag))
					else
						ap_int ((ifile_inst.get_index (main_inst.curr_ifile)))
					end
					l_pos := -1 + 17 -- switch 1; break
				when 8 then -- switch 1, case 108
					l_linenum := linenum_inst.currline (a_where)
					if l_linenum /= 0 then
						ap_linenum (l_linenum)
					else
						ap_quest
					end
					l_pos := -1 + 17 -- switch 1; break
				when 9 then -- switch 1, case 76
					l_len := ch_inst.ch_length
					if l_len = -1 then
						ap_quest
					elseif l_len = 0 then
						ap_quest
					else
						l_linenum := linenum_inst.find_linenum (l_len)
						if l_linenum <= 0 then
							ap_quest
						else
							ap_linenum (l_linenum - 1)
						end
					end
					l_pos := -1 + 17 -- switch 1; break
				when 10 then -- switch 1, case 109
					l_n := tags_inst.ntags
					if l_n.to_boolean then
						ap_int (l_n)
					else
						ap_int ((ifile_inst.nifile))
					end
					l_pos := -1 + 17 -- switch 1; break
				when 11 then -- switch 1, case 112
					l_pos2 := curr_byte (a_where)
					l_len := ch_inst.ch_length
					if l_pos2 /= -1 then
						if l_len > 0 then
							ap_int ((os_inst.percentage (l_pos2, l_len)))
						else
							ap_quest
						end
					else
						ap_quest
					end
					l_pos := -1 + 17 -- switch 1; break
				when 12 then -- switch 1, case 80
					l_linenum := linenum_inst.currline (a_where)
					if l_linenum = 0 then
						ap_quest
					else
						l_len := ch_inst.ch_length
						if l_len = -1 then
							ap_quest
						elseif l_len = 0 then
							ap_quest
						else
							l_last_linenum := linenum_inst.find_linenum (l_len)
							if l_last_linenum <= 0 then
								ap_quest
							else
								ap_int ((os_inst.percentage (l_linenum, l_last_linenum)))
							end
						end
					end
					l_pos := -1 + 17 -- switch 1; break
				when 13 then -- switch 1, case 115 | switch 1, case 66
					l_len := ch_inst.ch_length
					if l_len /= -1 then
						ap_pos (l_len)
					else
						ap_quest
					end
					l_pos := -1 + 17 -- switch 1; break
				when 14 then -- switch 1, case 116
					from
					until
						js.loop_left
					loop
						js.reset
						if (mp.c_pointer.to_integer_32).to_natural_32 > (message.c_pointer.to_integer_32).to_natural_32 then
							if (mp[-1]).to_integer_32 /= 32 then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							mp.ce_gets (mp - 1)
						end
					end
					js.reset
					l_pos := -1 + 17 -- switch 1; break
				when 15 then -- switch 1, case 84
					if (tags_inst.ntags).to_boolean then
						ap_str (ce_string ("tag"))
					else
						ap_str (ce_string ("file"))
					end
					l_pos := -1 + 17 -- switch 1; break
				when 16 then -- switch 1, case 120
					l_h.ce_gets (ifile_inst.next_ifile (main_inst.curr_ifile))
					if (l_h.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						ap_str ((ifile_inst.get_filename (l_h)))
					else
						ap_quest
					end
					l_pos := -1 + 17 -- switch 1; break
				when 17 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	skipcond (a_p: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_p: CE_POINTER [INTEGER_8]
			l_iflevel: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p.ce_gets (a_p)
					l_iflevel := 1
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						l_p.ce_gets (l_p + 1)
						inspect (l_p[0]).to_integer_32 -- switch 1 head
						when 63 then l_pos := -1 + 3
						when 58 then l_pos := -1 + 4
						when 46 then l_pos := -1 + 5
						when 92 then l_pos := -1 + 6
						when 0 then l_pos := -1 + 7
						else l_pos := -1 + 8
						end
				when 3 then -- switch 1, case 63
						l_iflevel := l_iflevel + 1
						l_pos := -1 + 8 -- switch 1; break
				when 4 then -- switch 1, case 58
						if l_iflevel = 1 then
							Result := l_p
							js.return
						end
						l_pos := -1 + 8 -- switch 1; break
				when 5 then -- switch 1, case 46
						l_iflevel := l_iflevel - 1
						if l_iflevel = 0 then
							Result := l_p
							js.return
						end
						l_pos := -1 + 8 -- switch 1; break
				when 6 then -- switch 1, case 92
						l_p.ce_gets (l_p + 1)
						l_pos := -1 + 8 -- switch 1; break
				when 7 then -- switch 1, case 0
						Result := (l_p - 1)
						js.return
				when 8 then -- switch 1, done:
						l_pos := -1 + 1 -- back to loop condition
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	wherechar (a_p: CE_POINTER [INTEGER_8]; a_wp: CE_POINTER [INTEGER_32]): CE_POINTER [INTEGER_8]
		local
			l_p: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			create l_p.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p.ce_gets (a_p)
					inspect (l_p[0]).to_integer_32 -- switch 1 head
					when 98 then l_pos := -1 + 1
					when 100 then l_pos := -1 + 1
					when 108 then l_pos := -1 + 1
					when 112 then l_pos := -1 + 1
					when 80 then l_pos := -1 + 1
					else l_pos := -1 + 8
					end
				when 1 then -- switch 1, case 98 | switch 1, case 100 | switch 1, case 108 | switch 1, case 112 | switch 1, case 80
					l_p.ce_gets (l_p + 1)
					inspect (l_p[0]).to_integer_32 -- switch 2 head
					when 116 then l_pos := -1 + 2
					when 109 then l_pos := -1 + 3
					when 98 then l_pos := -1 + 4
					when 66 then l_pos := -1 + 5
					when 106 then l_pos := -1 + 6
					else l_pos := -1 + 7
					end
				when 2 then -- switch 2, case 116
					a_wp.item := 0
					l_pos := -1 + 8 -- switch 2; break
				when 3 then -- switch 2, case 109
					a_wp.item := -3
					l_pos := -1 + 8 -- switch 2; break
				when 4 then -- switch 2, case 98
					a_wp.item := -1
					l_pos := -1 + 8 -- switch 2; break
				when 5 then -- switch 2, case 66
					a_wp.item := -2
					l_pos := -1 + 8 -- switch 2; break
				when 6 then -- switch 2, case 106
					a_wp.item := position_inst.adjsline (main_inst.jump_sline)
					l_pos := -1 + 8 -- switch 2; break
				when 7 then -- switch 2, default:
					a_wp.item := 0
					l_p.ce_gets (l_p - 1)
					l_pos := -1 + 8 -- switch 2; break
				when 8 then -- switch 2, done: | switch 1, done:
					Result := l_p
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	pr_expand (a_proto: CE_POINTER [INTEGER_8]; a_maxwidth: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_p: CE_POINTER [INTEGER_8]
			l_c: INTEGER_32
			l_where: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					mp.ce_gets (message)
					if (a_proto[0]).to_integer_32 = 0 then
						Result := (ce_string (""))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						l_p.ce_gets (a_proto)
				when 2 then -- loop condition:
						if (l_p[0]).to_integer_32 = 0 then
							l_pos := -1 + 11 -- skip loop
						end
				when 3 then -- loop body:
						inspect (l_p[0]).to_integer_32 -- switch 1 head
						when 92 then l_pos := -1 + 5
						when 63 then l_pos := -1 + 6
						when 58 then l_pos := -1 + 7
						when 46 then l_pos := -1 + 8
						when 37 then l_pos := -1 + 9
						else l_pos := -1 + 4
						end
				when 4 then -- switch 1, default:
						ap_char (l_p[0])
						l_pos := -1 + 10 -- switch 1; break
				when 5 then -- switch 1, case 92
						l_p.ce_gets (l_p + 1)
						ap_char (l_p[0])
						l_pos := -1 + 10 -- switch 1; break
				when 6 then -- switch 1, case 63
						l_p.ce_gets (l_p + 1)
						l_c := (l_p[0]).to_integer_32
						if l_c = 0 then
							l_p.ce_gets (l_p - 1)
						else
							l_where := 0
							l_p.ce_gets (wherechar (l_p, create {CE_POINTER [INTEGER_32]}.make_shared ($l_where)))
							if not (cond (l_c.to_integer_8, l_where)).to_boolean then
								l_p.ce_gets (skipcond (l_p))
							end
						end
						l_pos := -1 + 10 -- switch 1; break
				when 7 then -- switch 1, case 58
						l_p.ce_gets (skipcond (l_p))
						l_pos := -1 + 10 -- switch 1; break
				when 8 then -- switch 1, case 46
						l_pos := -1 + 10 -- switch 1; break
				when 9 then -- switch 1, case 37
						l_p.ce_gets (l_p + 1)
						l_c := (l_p[0]).to_integer_32
						if l_c = 0 then
							l_p.ce_gets (l_p - 1)
						else
							l_where := 0
							l_p.ce_gets (wherechar (l_p, create {CE_POINTER [INTEGER_32]}.make_shared ($l_where)))
							protochar (l_c, l_where, ((a_proto.c_pointer.to_integer_32).to_natural_32 = (main_inst.editproto.c_pointer.to_integer_32).to_natural_32).to_integer)
						end
						l_pos := -1 + 10 -- switch 1; break
				when 10 then -- switch 1, done:
						l_p.ce_gets (l_p + 1)
						l_pos := -1 + 2 -- back to loop condition
				when 11 then -- loop done
						if (mp.c_pointer.to_integer_32).to_natural_32 = (message.c_pointer.to_integer_32).to_natural_32 then
							Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							js.return
						end
				when 12 then -- if done
					if not js.return_called and then (a_maxwidth > 0) then
						if (mp.c_pointer.to_integer_32).to_natural_32 >= ((message + a_maxwidth).c_pointer.to_integer_32).to_natural_32 then
							Result := (mp - a_maxwidth)
							js.return
						end
					end
					if not js.return_called then
						Result := message
					end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	eq_message: CE_POINTER [INTEGER_8]
		do
			Result := (pr_expand (eqproto, 0))
		end

	pr_string: CE_POINTER [INTEGER_8]
		local
			l_prompt___0: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
		do
			create l_prompt___0.make
			create l_tmp___0.make

			if (((ch_inst.ch_getflags)).bit_and (8)).to_boolean then
				l_tmp___0.ce_gets (hproto)
			else
				l_tmp___0.ce_gets (optfunc_inst.prproto[optfunc_inst.pr_type])
			end
			l_prompt___0.ce_gets (pr_expand (l_tmp___0, ((screen_inst.sc_width - screen_inst.so_s_width) - screen_inst.so_e_width) - 2))
			main_inst.new_file := 0
			Result := l_prompt___0
		end

	wait_message: CE_POINTER [INTEGER_8]
		do
			Result := (pr_expand (wproto, ((screen_inst.sc_width - screen_inst.so_s_width) - screen_inst.so_e_width) - 2))
		end

end
