class
	P_SEARCH

inherit
	LESS_DATA
		redefine
			default_create
		end
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {NONE} -- Initialization

	default_create
		do
			create hilite_anchor.make
			create regpattern.make
			create last_pattern.make
		end

feature {ANY} -- attributes

	hide_hilite: INTEGER_32 assign set_hide_hilite

	set_hide_hilite (a_hide_hilite: INTEGER_32)
		do
			hide_hilite := a_hide_hilite
		end

	prep_startpos: INTEGER_32 assign set_prep_startpos

	set_prep_startpos (a_prep_startpos: INTEGER_32)
		do
			prep_startpos := a_prep_startpos
		end

	prep_endpos: INTEGER_32 assign set_prep_endpos

	set_prep_endpos (a_prep_endpos: INTEGER_32)
		do
			prep_endpos := a_prep_endpos
		end

	hilite_anchor: PD_HILITE

	regpattern: CE_POINTER [SD_RE_PATTERN_BUFFER]

	is_caseless: INTEGER_32 assign set_is_caseless

	set_is_caseless (a_is_caseless: INTEGER_32)
		do
			is_caseless := a_is_caseless
		end

	is_ucase_pattern: INTEGER_32 assign set_is_ucase_pattern

	set_is_ucase_pattern (a_is_ucase_pattern: INTEGER_32)
		do
			is_ucase_pattern := a_is_ucase_pattern
		end

	last_search_type: INTEGER_32 assign set_last_search_type

	set_last_search_type (a_last_search_type: INTEGER_32)
		do
			last_search_type := a_last_search_type
		end

	last_pattern: CE_POINTER [INTEGER_8]

feature {ANY} -- routines

	cvt_text (a_odst: CE_POINTER [INTEGER_8]; a_osrc: CE_POINTER [INTEGER_8]; a_ops: INTEGER_32)
		local
			l_dst: CE_POINTER [INTEGER_8]
			l_src: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_dst.make
			create l_src.make
			create l_tmp.make
			create l_tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src.ce_gets (a_osrc)
					l_dst.ce_gets (a_odst)
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_src[0]).to_integer_32 /= 0)) then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						if not (((a_ops).bit_and (1)).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if ((((ctype_b_loc).item[((l_src[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (256)).to_boolean then
							l_tmp.ce_gets (l_dst)
							l_dst.ce_gets (l_dst + 1)
							l_tmp[0] := (tolower (((l_src[0]).to_natural_8).to_integer_32)).to_integer_8
						else
							l_pos := -1 + 5 -- goto _L___1
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else: | _L___1:
						if not (((a_ops).bit_and (2)).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (l_src[0]).to_integer_32 = 8 then
							if (l_dst.c_pointer.to_integer_32).to_natural_32 > (a_odst.c_pointer.to_integer_32).to_natural_32 then
								l_dst.ce_gets (l_dst - 1)
							else
								l_pos := -1 + 8 -- goto _L___0
							end
						else
							l_pos := -1 + 8 -- goto _L___0
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L___0:
						if ((a_ops).bit_and (8)).to_boolean then
							if (l_src[0]).to_integer_32 = 27 then
								from
								until
									not (not js.loop_left and then ((l_src[1]).to_integer_32 /= 0))
								loop
									js.reset
									l_src.ce_gets (l_src + 1)
									if (line_inst.is_ansi_end (l_src[0])).to_boolean then
										js.break
									end
								end
								js.reset
							else
								l_tmp___2.ce_gets (l_dst)
								l_dst.ce_gets (l_dst + 1)
								l_tmp___2[0] := l_src[0]
							end
						else
							l_tmp___2.ce_gets (l_dst)
							l_dst.ce_gets (l_dst + 1)
							l_tmp___2[0] := l_src[0]
						end
				when 9 then -- if done
						l_src.ce_gets (l_src + 1)
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					if ((a_ops).bit_and (4)).to_boolean then
						if (l_dst.c_pointer.to_integer_32).to_natural_32 > (a_odst.c_pointer.to_integer_32).to_natural_32 then
							if (l_dst[-1]).to_integer_32 = 13 then
								l_dst.ce_gets (l_dst - 1)
							end
						end
					end
					l_dst[0] := (('%/0/').code).to_integer_8
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_cvt_ops: INTEGER_32
		local
			l_ops: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ops := 0
					if not (is_caseless.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if line_inst.bs_mode /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						if is_caseless.to_boolean then
							l_ops := (l_ops).bit_or ((1))
						end
						if line_inst.bs_mode = 0 then
							l_ops := (l_ops).bit_or ((2))
						end
						if line_inst.bs_mode /= 2 then
							l_ops := (l_ops).bit_or ((4))
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if line_inst.bs_mode /= 2 then
							l_ops := (l_ops).bit_or ((4))
						end
				when 7 then -- if done
						if line_inst.ctldisp = 2 then
							l_ops := (l_ops).bit_or ((8))
						end
						Result := l_ops
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	is_ucase (a_s: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_p: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_p.make

			l_p.ce_gets (a_s)
			from
			until
				not (not js.loop_left and then ((l_p[0]).to_integer_32 /= 0))
			loop
				if ((((ctype_b_loc).item[((l_p[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (256)).to_boolean then
					Result := 1
					js.return
				end
				if not js.return_called then
					l_p.ce_gets (l_p + 1)
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	prev_pattern: INTEGER_32
		local
			js: JUMP_STATE
		do
			if ((last_search_type).bit_and (512)).to_boolean then
				Result := ((last_pattern.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
				js.return
			end
			if not js.return_called then
				Result := ((regpattern.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
			end
		end

	repaint_hilite (a_on: INTEGER_32)
		local
			l_slinenum: INTEGER_32
			l_pos2: INTEGER_32
			l_epos: INTEGER_32
			l_save_hide_hilite: INTEGER_32
			js: JUMP_STATE
		do
			if forwback_inst.squished.to_boolean then
				jump_inst.repaint
			end
			l_save_hide_hilite := hide_hilite
			if not a_on.to_boolean then
				if hide_hilite.to_boolean then
					js.return
				end
				if not js.return_called then
					hide_hilite := 1
				end
			end
			if not js.return_called and then (not screen_inst.can_goto_line.to_boolean) then
				jump_inst.repaint
				hide_hilite := l_save_hide_hilite
				js.return
			end
			if not js.return_called then
				l_slinenum := 0
				from
				until
					not (l_slinenum < screen_inst.sc_height - 1)
				loop
					js.reset
					l_pos2 := position_inst.position (l_slinenum)
					if l_pos2 = -1 then
						js.continue
					end
					if not js.loop_jumped then
						l_epos := position_inst.position (l_slinenum + 1)
						if (is_hilited (l_pos2, l_epos, 1)).to_boolean then
							input_inst.forw_line (l_pos2).do_nothing
							screen_inst.goto_line (l_slinenum)
							output_inst.put_line
						end
					end
					l_slinenum := l_slinenum + 1
				end
				hide_hilite := l_save_hide_hilite
			end
		end

	clear_attn
		local
			l_slinenum: INTEGER_32
			l_old_start_attnpos: INTEGER_32
			l_old_end_attnpos: INTEGER_32
			l_pos2: INTEGER_32
			l_epos: INTEGER_32
			js: JUMP_STATE
		do
			if main_inst.start_attnpos = -1 then
				js.return
			end
			if not js.return_called then
				l_old_start_attnpos := main_inst.start_attnpos
				l_old_end_attnpos := main_inst.end_attnpos
				main_inst.end_attnpos := (-1).to_integer_32
				main_inst.start_attnpos := main_inst.end_attnpos
				if not screen_inst.can_goto_line.to_boolean then
					jump_inst.repaint
					js.return
				end
			end
			if not js.return_called then
				if forwback_inst.squished.to_boolean then
					jump_inst.repaint
				end
				l_slinenum := 0
				from
				until
					not (l_slinenum < screen_inst.sc_height - 1)
				loop
					js.reset
					l_pos2 := position_inst.position (l_slinenum)
					if l_pos2 = -1 then
						js.continue
					end
					if not js.loop_jumped then
						l_epos := position_inst.position (l_slinenum + 1)
						if l_pos2 < l_old_end_attnpos then
							if l_epos = -1 then
								input_inst.forw_line (l_pos2).do_nothing
								screen_inst.goto_line (l_slinenum)
								output_inst.put_line
							elseif l_epos > l_old_start_attnpos then
								input_inst.forw_line (l_pos2).do_nothing
								screen_inst.goto_line (l_slinenum)
								output_inst.put_line
							end
						end
					end
					l_slinenum := l_slinenum + 1
				end
			end
		end

	undo_search
		local
			js: JUMP_STATE
		do
			if not (prev_pattern).to_boolean then
				output_inst.error (ce_string ("No previous regular expression"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				hide_hilite := (not hide_hilite.to_boolean).to_integer
				repaint_hilite (1)
			end
		end

	compile_pattern (a_pattern: CE_POINTER [INTEGER_8]; a_search_type___0: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [SD_RE_PATTERN_BUFFER]
			js: JUMP_STATE
		do
			create l_s.make

			if ((a_search_type___0).bit_and (512)) = 0 then
				l_s.ce_gets (create {CE_POINTER [SD_RE_PATTERN_BUFFER]}.make_cast ((main_inst.ecalloc (1, {SD_RE_PATTERN_BUFFER}.sizeof.to_natural_32))))
				if (regcomp (l_s, a_pattern, 1)).to_boolean then
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					output_inst.error (ce_string ("Invalid pattern"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
					Result := (-1)
					js.return
				end
				if not js.return_called then
					if (regpattern.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						regfree (regpattern)
					end
					regpattern.ce_gets (l_s)
				end
			end
			if not js.return_called then
				if (last_pattern.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (last_pattern))
				end
				last_pattern.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((calloc ((1).to_natural_32, (strlen (a_pattern)) + {NATURAL_32} 1))))
				if (last_pattern.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					strcpy (last_pattern, a_pattern).do_nothing
				end
				last_search_type := a_search_type___0
				Result := 0
			end
		end

	uncompile_pattern
		do
			if (regpattern.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				regfree (regpattern)
			end
			regpattern.ce_gets (create {CE_POINTER [SD_RE_PATTERN_BUFFER]}.make_shared (default_pointer))
			last_pattern.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
		end

	match_pattern (a_line: CE_POINTER [INTEGER_8]; a_sp: CE_POINTER [CE_POINTER [INTEGER_8]]; a_ep: CE_POINTER [CE_POINTER [INTEGER_8]]; a_notbol: INTEGER_32): INTEGER_32
		local
			l_matched: INTEGER_32
			l_rm: SD_REGMATCH_T
			l_flags: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_rm.make

			if ((last_search_type).bit_and (512)).to_boolean then
				Result := (match (last_pattern, a_line, a_sp, a_ep))
				js.return
			end
			if not js.return_called then
				if a_notbol.to_boolean then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
				l_flags := l_tmp___0
				if (regexec (regpattern, a_line, (1).to_natural_32, (l_rm.address), l_flags)).to_boolean then
					l_tmp___2 := 0
				else
					l_tmp___2 := 1
				end
				l_matched := l_tmp___2
				if not l_matched.to_boolean then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				a_sp.item := a_line + l_rm.rm_so
				a_ep.item := a_line + l_rm.rm_eo
				Result := l_matched
			end
		end

	clr_hilite
		local
			l_hl: CE_POINTER [PD_HILITE]
			l_nexthl: CE_POINTER [PD_HILITE]
		do
			create l_hl.make
			create l_nexthl.make

			l_hl.ce_gets (hilite_anchor.hl_next)
			from
			until
				(l_hl.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
			loop
				l_nexthl.ce_gets (l_hl.item.hl_next)
				free (create {CE_POINTER [ANY]}.make_cast (l_hl))
				l_hl.ce_gets (l_nexthl)
			end
			hilite_anchor.hl_next := create {CE_POINTER [PD_HILITE]}.make_shared (default_pointer)
			prep_endpos := (-1).to_integer_32
			prep_startpos := prep_endpos
		end

	is_hilited (a_pos: INTEGER_32; a_epos: INTEGER_32; a_nohide: INTEGER_32): INTEGER_32
		local
			l_hl: CE_POINTER [PD_HILITE]
			js: JUMP_STATE
		do
			create l_hl.make

			if not line_inst.status_col.to_boolean then
				if main_inst.start_attnpos /= -1 then
					if a_pos < main_inst.end_attnpos then
						if a_epos = -1 then
							Result := 1
							js.return
						elseif a_epos > main_inst.start_attnpos then
							Result := 1
							js.return
						end
					end
				end
			end
			if not js.return_called and then (screen_inst.hilite_search = 0) then
				Result := 0
				js.return
			end
			if not js.return_called and then (not a_nohide.to_boolean) then
				if hide_hilite.to_boolean then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_hl.ce_gets (hilite_anchor.hl_next)
				from
				until
					not (not js.loop_left and then ((l_hl.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
				loop
					if l_hl.item.hl_endpos > a_pos then
						if a_epos = -1 then
							Result := 1
							js.return
						elseif a_epos > l_hl.item.hl_startpos then
							Result := 1
							js.return
						end
					end
					if not js.return_called then
						l_hl.ce_gets (l_hl.item.hl_next)
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	add_hilite (a_anchor___1: CE_POINTER [PD_HILITE]; a_hl: CE_POINTER [PD_HILITE])
		local
			l_ihl: CE_POINTER [PD_HILITE]
			js: JUMP_STATE
		do
			create l_ihl.make

			l_ihl.ce_gets (a_anchor___1)
			from
			until
				not (not js.loop_left and then (((l_ihl.item.hl_next).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				js.reset
				if (l_ihl.item.hl_next).item.hl_startpos > a_hl.item.hl_startpos then
					js.break
				end
				if not js.loop_jumped then
					l_ihl.ce_gets (l_ihl.item.hl_next)
				end
			end
			js.reset
			if (l_ihl.c_pointer.to_integer_32).to_natural_32 /= (a_anchor___1.c_pointer.to_integer_32).to_natural_32 then
				if a_hl.item.hl_startpos > l_ihl.item.hl_endpos then
					a_hl.item.hl_startpos := a_hl.item.hl_startpos
				else
					a_hl.item.hl_startpos := l_ihl.item.hl_endpos
				end
			end
			if ((l_ihl.item.hl_next).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if a_hl.item.hl_endpos < (l_ihl.item.hl_next).item.hl_startpos then
					a_hl.item.hl_endpos := a_hl.item.hl_endpos
				else
					a_hl.item.hl_endpos := (l_ihl.item.hl_next).item.hl_startpos
				end
			end
			if a_hl.item.hl_startpos >= a_hl.item.hl_endpos then
				free (create {CE_POINTER [ANY]}.make_cast (a_hl))
				js.return
			end
			if not js.return_called then
				a_hl.item.hl_next := l_ihl.item.hl_next
				l_ihl.item.hl_next := a_hl
			end
		end

	adj_hilite (a_anchor___1: CE_POINTER [PD_HILITE]; a_linepos: INTEGER_32; a_cvt_ops: INTEGER_32)
		local
			l_line: CE_POINTER [INTEGER_8]
			l_hl: CE_POINTER [PD_HILITE]
			l_checkstart: INTEGER_32
			l_opos: INTEGER_32
			l_npos: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_line.make
			create l_hl.make
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					line_inst.forw_raw_line (a_linepos, l_line.address).do_nothing
					l_npos := a_linepos
					l_opos := l_npos
					l_hl.ce_gets (a_anchor___1.item.hl_next)
					l_checkstart := 1
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_hl.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32)) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if not (l_checkstart.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_hl.item.hl_startpos = l_opos then
							l_hl.item.hl_startpos := l_npos
							l_checkstart := 0
							js.continue
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if not l_checkstart.to_boolean then
							if l_hl.item.hl_endpos = l_opos then
								l_hl.item.hl_endpos := l_npos
								l_checkstart := 1
								l_hl.ce_gets (l_hl.item.hl_next)
								js.continue
							end
						end
				when 6 then
						if not js.loop_jumped and then ((l_line[0]).to_integer_32 = 0) then
							js.break
						end
						if not js.loop_jumped then
							if ((a_cvt_ops).bit_and (8)).to_boolean then
								from
								until
									not (not js.loop_left and then ((l_line[0]).to_integer_32 = 27))
								loop
									l_line.ce_gets (l_line + 1)
									l_npos := l_npos + 1
									from
									until
										not (not js.loop_left and then ((l_line[0]).to_integer_32 /= 0))
									loop
										js.reset
										l_npos := l_npos + 1
										l_tmp.ce_gets (l_line)
										l_line.ce_gets (l_line + 1)
										if (line_inst.is_ansi_end (l_tmp[0])).to_boolean then
											js.break
										end
									end
									js.reset
								end
							end
							l_opos := l_opos + 1
							l_npos := l_npos + 1
							l_line.ce_gets (l_line + 1)
							if ((a_cvt_ops).bit_and (2)).to_boolean then
								from
								until
									js.loop_left
								loop
									js.reset
									if (l_line[0]).to_integer_32 = 8 then
										if (l_line[1]).to_integer_32 = 0 then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_npos := l_npos + (2)
										l_line.ce_gets (l_line + (2))
									end
								end
								js.reset
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					js.reset
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	hilite_line (a_linepos: INTEGER_32; a_line: CE_POINTER [INTEGER_8]; a_sp: CE_POINTER [INTEGER_8]; a_ep: CE_POINTER [INTEGER_8]; a_cvt_ops: INTEGER_32)
		local
			l_sp: CE_POINTER [INTEGER_8]
			l_ep: CE_POINTER [INTEGER_8]
			l_searchp: CE_POINTER [INTEGER_8]
			l_hl: CE_POINTER [PD_HILITE]
			l_hilites___0: PD_HILITE
			js: JUMP_STATE
		do
			create l_sp.make
			create l_ep.make
			create l_searchp.make
			create l_hl.make
			create l_hilites___0.make

			l_sp.ce_gets (a_sp)
			l_ep.ce_gets (a_ep)
			if (l_sp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			elseif (l_ep.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				l_searchp.ce_gets (a_line)
				l_hilites___0.hl_next := create {CE_POINTER [PD_HILITE]}.make_shared (default_pointer)
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_ep.c_pointer.to_integer_32).to_natural_32 > (l_sp.c_pointer.to_integer_32).to_natural_32 then
						l_hl.ce_gets (create {CE_POINTER [PD_HILITE]}.make_cast ((main_inst.ecalloc (1, {PD_HILITE}.sizeof.to_natural_32))))
						l_hl.item.hl_startpos := a_linepos + (l_sp.distance (a_line)).to_integer_32
						l_hl.item.hl_endpos := a_linepos + (l_ep.distance (a_line)).to_integer_32
						add_hilite (l_hilites___0.address, l_hl)
					end
					if (l_ep.c_pointer.to_integer_32).to_natural_32 > (l_searchp.c_pointer.to_integer_32).to_natural_32 then
						l_searchp.ce_gets (l_ep)
					elseif (l_searchp[0]).to_integer_32 /= 0 then
						l_searchp.ce_gets (l_searchp + 1)
					else
						js.break
					end
					if not js.loop_jumped then
						if not (match_pattern (l_searchp, l_sp.address, l_ep.address, 1)).to_boolean then
							js.break
						end
					end
				end
				js.reset
				adj_hilite (l_hilites___0.address, a_linepos, a_cvt_ops)
				from
				until
					js.loop_left
				loop
					js.reset
					l_hl.ce_gets (l_hilites___0.hl_next)
					if (l_hl.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.break
					end
					if not js.loop_jumped then
						l_hilites___0.hl_next := l_hl.item.hl_next
						add_hilite (hilite_anchor.address, l_hl)
					end
				end
				js.reset
			end
		end

	chg_caseless
		do
			if not is_ucase_pattern.to_boolean then
				is_caseless := opttbl_inst.caseless
			else
				uncompile_pattern
			end
		end

	hilite_screen
		local
			l_scrpos: PD_SCRPOS
			js: JUMP_STATE
		do
			create l_scrpos.make

			position_inst.get_scrpos (l_scrpos.address)
			if l_scrpos.pos = -1 then
				js.return
			end
			if not js.return_called then
				prep_hilite (l_scrpos.pos, (position_inst.position (-2)), -1)
				repaint_hilite (1)
			end
		end

	chg_hilite
		do
			clr_hilite
			hide_hilite := 0
			if screen_inst.hilite_search = 2 then
				hilite_screen
			end
		end

	search_pos (a_search_type___0: INTEGER_32): INTEGER_32
		local
			l_pos2: INTEGER_32
			l_linenum: INTEGER_32
			js: JUMP_STATE
		do
			if (position_inst.empty_screen).to_boolean then
				if ((a_search_type___0).bit_and (1)).to_boolean then
					Result := (0).to_integer_32
					js.return
				else
					l_pos2 := ch_inst.ch_length
					if l_pos2 = -1 then
						ch_inst.ch_end_seek.do_nothing
						l_pos2 := ch_inst.ch_length
					end
					Result := l_pos2
					js.return
				end
			end
			if not js.return_called then
				if opttbl_inst.how_search.to_boolean then
					if ((a_search_type___0).bit_and (1)).to_boolean then
						l_linenum := -2
					else
						l_linenum := 0
					end
					l_pos2 := position_inst.position (l_linenum)
				else
					l_linenum := position_inst.adjsline (main_inst.jump_sline)
					l_pos2 := position_inst.position (l_linenum)
					if ((a_search_type___0).bit_and (1)).to_boolean then
						l_pos2 := line_inst.forw_raw_line (l_pos2, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer))
						from
						until
							not (not js.loop_left and then (l_pos2 = -1))
						loop
							js.reset
							l_linenum := l_linenum + 1
							if l_linenum >= screen_inst.sc_height then
								js.break
							end
							if not js.loop_jumped then
								l_pos2 := position_inst.position (l_linenum)
							end
						end
						js.reset
					else
						from
						until
							not (not js.loop_left and then (l_pos2 = -1))
						loop
							js.reset
							l_linenum := l_linenum - 1
							if l_linenum < 0 then
								js.break
							end
							if not js.loop_jumped then
								l_pos2 := position_inst.position (l_linenum)
							end
						end
						js.reset
					end
				end
				Result := l_pos2
			end
		end

	search_range (a_pos: INTEGER_32; a_endpos: INTEGER_32; a_search_type___0: INTEGER_32; a_matches: INTEGER_32; a_maxlines: INTEGER_32; a_plinepos: CE_POINTER [INTEGER_32]; a_pendpos___0: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_pos2: INTEGER_32
			l_matches: INTEGER_32
			l_maxlines: INTEGER_32
			l_line: CE_POINTER [INTEGER_8]
			l_linenum: INTEGER_32
			l_sp: CE_POINTER [INTEGER_8]
			l_ep: CE_POINTER [INTEGER_8]
			l_line_match: INTEGER_32
			l_cvt_ops: INTEGER_32
			l_linepos: INTEGER_32
			l_oldpos: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_line.make
			create l_sp.make
			create l_ep.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pos2 := a_pos
					l_matches := a_matches
					l_maxlines := a_maxlines
					l_linenum := linenum_inst.find_linenum (l_pos2)
					l_oldpos := l_pos2
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 15 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if ((ch_inst.sigs).bit_and (3)).to_boolean then
							Result := (-1)
							js.return
						end
						if js.return_called then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if a_endpos = -1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_pos2 >= a_endpos then
							l_pos := -1 + 7 -- goto _L
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else: | _L___0:
						if l_maxlines /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						if (a_pendpos___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							a_pendpos___0.item := l_pos2
						end
						Result := l_matches
						js.return
				when 8 then -- if done | if done
						if not js.return_called then
							if l_maxlines > 0 then
								l_maxlines := l_maxlines - 1
							end
							if ((a_search_type___0).bit_and (1)).to_boolean then
								l_linepos := l_pos2
								l_pos2 := line_inst.forw_raw_line (l_pos2, l_line.address)
								if l_linenum /= 0 then
									l_linenum := l_linenum + 1
								end
							else
								l_pos2 := line_inst.back_raw_line (l_pos2, l_line.address)
								l_linepos := l_pos2
								if l_linenum /= 0 then
									l_linenum := l_linenum - 1
								end
							end
							if l_pos2 = -1 then
								if (a_pendpos___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									a_pendpos___0.item := l_oldpos
								end
								Result := l_matches
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 14 -- skip if block
						end
				when 9 then -- if:
						if line_inst.linenums.to_boolean then
							if (abs ((l_pos2 - l_oldpos).to_integer_32)) > 1024 then
								linenum_inst.add_lnum (l_linenum, l_pos2)
							end
						end
						l_oldpos := l_pos2
						l_cvt_ops := get_cvt_ops
						cvt_text (l_line, l_line, l_cvt_ops)
						l_line_match := match_pattern (l_line, l_sp.address, l_ep.address, 0)
						if ((a_search_type___0).bit_and (64)).to_boolean then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if l_line_match.to_boolean then
							l_tmp___0 := 1
						else
							l_pos := -1 + 12 -- goto _L___1
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___1:
						if ((a_search_type___0).bit_and (64)).to_boolean then
							if not l_line_match.to_boolean then
								l_tmp___0 := 1
							else
								l_tmp___0 := 0
							end
						else
							l_tmp___0 := 0
						end
				when 13 then
						l_line_match := l_tmp___0
						if not l_line_match.to_boolean then
							js.continue
						end
						if not js.loop_jumped then
							if ((a_search_type___0).bit_and (8)).to_boolean then
								if l_line_match.to_boolean then
									hilite_line (l_linepos, l_line, l_sp, l_ep, l_cvt_ops)
								end
							else
								l_matches := l_matches - 1
								if l_matches <= 0 then
									if screen_inst.hilite_search = 1 then
										clr_hilite
										if l_line_match.to_boolean then
											hilite_line (l_linepos, l_line, l_sp, l_ep, l_cvt_ops)
										end
									end
									if (a_plinepos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										a_plinepos.item := l_linepos
									end
									Result := 0
									js.return
								end
							end
						end
						if not js.loop_left then
							
						end
				when 14 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	search (a_search_type___0: INTEGER_32; a_pattern: CE_POINTER [INTEGER_8]; a_n: INTEGER_32): INTEGER_32
		local
			l_n: INTEGER_32
			l_pos2: INTEGER_32
			l_ucase: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_n := a_n
					if (a_pattern.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if (a_pattern[0]).to_integer_32 /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						if not (prev_pattern).to_boolean then
							output_inst.error (ce_string ("No previous regular expression"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							Result := (-1)
							js.return
						end
						if not js.return_called and then (((a_search_type___0).bit_and (512)) /= ((last_search_type).bit_and (512))) then
							output_inst.error (ce_string ("Please re-enter search pattern"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							Result := (-1)
							js.return
						end
						if not js.return_called then
							if screen_inst.hilite_search = 1 then
								repaint_hilite (0)
							end
							if screen_inst.hilite_search = 2 then
								if hide_hilite.to_boolean then
									hide_hilite := 0
									hilite_screen
								end
							end
							hide_hilite := 0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_ucase := is_ucase (a_pattern)
						if opttbl_inst.caseless = 2 then
							cvt_text (a_pattern, a_pattern, 1)
						end
						if (compile_pattern (a_pattern, a_search_type___0)) < 0 then
							Result := (-1)
							js.return
						end
						if not js.return_called then
							is_ucase_pattern := l_ucase
							if is_ucase_pattern.to_boolean then
								if opttbl_inst.caseless /= 2 then
									is_caseless := 0
								else
									is_caseless := opttbl_inst.caseless
								end
							else
								is_caseless := opttbl_inst.caseless
							end
							if screen_inst.hilite_search.to_boolean then
								repaint_hilite (0)
								hide_hilite := 0
								clr_hilite
							end
							if screen_inst.hilite_search = 2 then
								hilite_screen
							end
						end
				when 7 then -- if done
						if not js.return_called then
							l_pos2 := search_pos (a_search_type___0)
							if l_pos2 = -1 then
								if ((a_search_type___0).bit_and (128)).to_boolean then
									Result := l_n
									js.return
								end
								if not js.return_called then
									output_inst.error (ce_string ("Nothing to search"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
									Result := (-1)
									js.return
								end
							end
						end
						if not js.return_called then
							l_n := search_range (l_pos2, (-1).to_integer_32, a_search_type___0, l_n, -1, create {CE_POINTER [INTEGER_32]}.make_shared ($l_pos2), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
							if l_n /= 0 then
								if screen_inst.hilite_search = 1 then
									if l_n > 0 then
										repaint_hilite (1)
									end
								end
								Result := l_n
								js.return
							end
						end
						if not js.return_called then
							if not ((a_search_type___0).bit_and (4)).to_boolean then
								jump_inst.jump_loc (l_pos2, main_inst.jump_sline)
							end
							if screen_inst.hilite_search = 1 then
								repaint_hilite (1)
							end
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	prep_hilite (a_spos: INTEGER_32; a_epos: INTEGER_32; a_maxlines: INTEGER_32)
		local
			l_spos: INTEGER_32
			l_epos: INTEGER_32
			l_nprep_startpos: INTEGER_32
			l_nprep_endpos: INTEGER_32
			l_new_epos: INTEGER_32
			l_max_epos: INTEGER_32
			l_result: INTEGER_32
			l_i: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_spos := a_spos
					l_epos := a_epos
					l_nprep_startpos := prep_startpos
					l_nprep_endpos := prep_endpos
					if not (prev_pattern).to_boolean then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						if a_maxlines < 0 then
							l_max_epos := (-1).to_integer_32
						else
							l_max_epos := l_spos
							l_i := 0
							from
							until
								not (l_i < a_maxlines)
							loop
								l_max_epos := line_inst.forw_raw_line (l_max_epos, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer))
								l_i := l_i + 1
							end
						end
						if prep_startpos /= -1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else:
						if l_epos = -1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_epos < prep_startpos then
							l_pos := -1 + 8 -- goto _L
						else
							l_pos := -1 + 7 -- goto _L___0
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else: | _L___0:
						if not (l_spos > prep_endpos) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L:
						clr_hilite
						if l_epos /= -1 then
							l_epos := l_epos + (3 * line_inst.size_linebuf).to_integer_32
						end
						l_nprep_startpos := l_spos
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						if l_epos /= -1 then
							if l_epos > prep_endpos then
								l_epos := l_epos + (3 * line_inst.size_linebuf).to_integer_32
							else
								l_epos := prep_startpos
							end
						end
						if l_spos < prep_startpos then
							if l_spos < (3 * line_inst.size_linebuf).to_integer_32 then
								l_spos := (0).to_integer_32
							else
								l_spos := l_spos - (3 * line_inst.size_linebuf).to_integer_32
							end
							l_nprep_startpos := l_spos
						else
							l_spos := prep_endpos
						end
				when 11 then -- if done | if done
						if l_epos /= -1 then
							if l_max_epos /= -1 then
								if l_epos > l_max_epos then
									l_epos := l_max_epos
								end
							end
						end
						if l_epos /= -1 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 15 -- goto _L___1
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 14 then -- else:
						if not (l_epos > l_spos) then
							l_pos := -1 + 16 -- skip if block
						end
				when 15 then -- if: | _L___1:
						l_result := search_range (l_spos, l_epos, 9, 0, a_maxlines, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_new_epos))
						if l_result < 0 then
							js.return
						end
						if not js.return_called then
							if prep_endpos = -1 then
								l_nprep_endpos := l_new_epos
							elseif l_new_epos > prep_endpos then
								l_nprep_endpos := l_new_epos
							end
						end
				when 16 then -- if done | if done
						if not js.return_called then
							prep_startpos := l_nprep_startpos
							prep_endpos := l_nprep_endpos
						end
				when 17 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	match (a_pattern: CE_POINTER [INTEGER_8]; a_buf___1: CE_POINTER [INTEGER_8]; a_pfound: CE_POINTER [CE_POINTER [INTEGER_8]]; a_pend: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_buf___1: CE_POINTER [INTEGER_8]
			l_pp: CE_POINTER [INTEGER_8]
			l_lp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_buf___1.make
			create l_pp.make
			create l_lp.make

			l_buf___1.ce_gets (a_buf___1)
			from
			until
				not (not js.loop_left and then ((l_buf___1[0]).to_integer_32 /= 0))
			loop
				l_pp.ce_gets (a_pattern)
				l_lp.ce_gets (l_buf___1)
				from
				until
					not (not js.loop_left and then ((l_pp[0]).to_integer_32 = (l_lp[0]).to_integer_32))
				loop
					js.reset
					if (l_pp[0]).to_integer_32 = 0 then
						js.break
					elseif (l_lp[0]).to_integer_32 = 0 then
						js.break
					end
					if not js.loop_jumped then
						l_pp.ce_gets (l_pp + 1)
						l_lp.ce_gets (l_lp + 1)
					end
				end
				js.reset
				if (l_pp[0]).to_integer_32 = 0 then
					if (a_pfound.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						a_pfound.item := l_buf___1
					end
					if (a_pend.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						a_pend.item := l_lp
					end
					Result := 1
					js.return
				end
				if not js.return_called then
					l_buf___1.ce_gets (l_buf___1 + 1)
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

end
