class
	SD_IO_MARKER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [SD_IO_MARKER] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	sbuf: CE_POINTER [SD_IO_FILE] assign set_sbuf
		do
			create Result.make_shared (c_sbuf (c_pointer))
		end

	pos: INTEGER_32 assign set_pos
		do
			Result := c_pos (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [SD_IO_MARKER])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_sbuf (a_sbuf: CE_POINTER [SD_IO_FILE])
		do
			c_set_sbuf (c_pointer, a_sbuf.c_pointer)
		end

	set_pos (a_pos: INTEGER_32)
		do
			c_set_pos (c_pointer, a_pos)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _IO_marker *)((struct _IO_marker *)$tmp)->_next;"
		end

	c_sbuf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _IO_FILE *)((struct _IO_marker *)$tmp)->_sbuf;"
		end

	c_pos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _IO_marker *)$tmp)->_pos;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct _IO_marker *)$tmp)->_next = (struct _IO_marker *)$a_next;"
		end

	c_set_sbuf (tmp: POINTER; a_sbuf: POINTER)
		external
			"C inline"
		alias
			"((struct _IO_marker *)$tmp)->_sbuf = (struct _IO_FILE *)$a_sbuf;"
		end

	c_set_pos (tmp: POINTER; a_pos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _IO_marker *)$tmp)->_pos = $a_pos;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return sizeof(struct _IO_marker);"
		end

end
