deferred class
	S_STDIO

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	sprintf (a_args: TUPLE [a_s: CE_POINTER [INTEGER_8]; a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_sprintf)).integer_32_item (a_args)
		end

	c_sprintf: POINTER
		external
			"C inline use <less.h>"
		alias
			"return &sprintf;"
		end

	fileno (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fileno (a_stream.c_pointer)
		end

	c_fileno (a_stream: POINTER): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return fileno($a_stream);"
		end

	popen (a_command: CE_POINTER [INTEGER_8]; a_modes: CE_POINTER [INTEGER_8]): CE_POINTER [SD_IO_FILE]
		do
			create Result.make_shared (c_popen (a_command.c_pointer, a_modes.c_pointer))
		end

	c_popen (a_command: POINTER; a_modes: POINTER): POINTER
		external
			"C inline use <less.h>"
		alias
			"return popen($a_command, $a_modes);"
		end

	pclose (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_pclose (a_stream.c_pointer)
		end

	c_pclose (a_stream: POINTER): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return pclose($a_stream);"
		end

	fclose (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fclose (a_stream.c_pointer)
		end

	c_fclose (a_stream: POINTER): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return fclose($a_stream);"
		end

	fopen (a_filename: CE_POINTER [INTEGER_8]; a_modes: CE_POINTER [INTEGER_8]): CE_POINTER [SD_IO_FILE]
		do
			create Result.make_shared (c_fopen (a_filename.c_pointer, a_modes.c_pointer))
		end

	c_fopen (a_filename: POINTER; a_modes: POINTER): POINTER
		external
			"C inline use <less.h>"
		alias
			"return fopen($a_filename, $a_modes);"
		end

	fgetc (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fgetc (a_stream.c_pointer)
		end

	c_fgetc (a_stream: POINTER): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return fgetc($a_stream);"
		end

	fgets (a_s: CE_POINTER [INTEGER_8]; a_n: INTEGER_32; a_stream: CE_POINTER [SD_IO_FILE]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_fgets (a_s.c_pointer, a_n, a_stream.c_pointer))
		end

	c_fgets (a_s: POINTER; a_n: INTEGER_32; a_stream: POINTER): POINTER
		external
			"C inline use <less.h>"
		alias
			"return fgets($a_s, $a_n, $a_stream);"
		end

end
