deferred class
	S_STDLIB

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	calloc (a_nmemb: NATURAL_32; a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared_with_count (
					default_pointer.memory_calloc (a_nmemb.to_integer_32, a_size.to_integer_32),
					(a_nmemb * a_size).to_integer_32
				)
		end

	exit (a_status: INTEGER_32)
		external
			"C inline use <less.h>"
		alias
			"exit($a_status);"
		end

	atoi (a_nptr: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_atoi (a_nptr.c_pointer)
		end

	c_atoi (a_nptr: POINTER): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return atoi($a_nptr);"
		end

	free (a_ptr: CE_POINTER [ANY])
		do
			c_free (a_ptr.c_pointer)
		end

	c_free (a_ptr: POINTER)
		external
			"C inline use <less.h>"
		alias
			"free($a_ptr);"
		end

	getenv (a_name: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_getenv (a_name.c_pointer))
		end

	c_getenv (a_name: POINTER): POINTER
		external
			"C inline use <less.h>"
		alias
			"return getenv($a_name);"
		end

	system (a_command: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_system (a_command.c_pointer)
		end

	c_system (a_command: POINTER): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return system($a_command);"
		end

	abs (a_x: INTEGER_32): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return abs($a_x);"
		end

end
