deferred class
	S_UNISTD

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	isatty (a_fd: INTEGER_32): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return isatty($a_fd);"
		end

	fsync (a_fd: INTEGER_32): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return fsync($a_fd);"
		end

	lseek (a_fd: INTEGER_32; a_offset: INTEGER_32; a_whence: INTEGER_32): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return lseek($a_fd, $a_offset, $a_whence);"
		end

	close (a_fd: INTEGER_32): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return close($a_fd);"
		end

	write (a_fd: INTEGER_32; a_buf: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		do
			Result := c_write (a_fd, a_buf.c_pointer, a_n)
		end

	c_write (a_fd: INTEGER_32; a_buf: POINTER; a_n: NATURAL_32): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return write($a_fd, $a_buf, $a_n);"
		end

	sleep (a_seconds: NATURAL_32): NATURAL_32
		external
			"C inline use <less.h>"
		alias
			"return sleep($a_seconds);"
		end

	read (a_fd: INTEGER_32; a_buf: CE_POINTER [ANY]; a_nbytes: NATURAL_32): INTEGER_32
		do
			Result := c_read (a_fd, a_buf.c_pointer, a_nbytes)
		end

	c_read (a_fd: INTEGER_32; a_buf: POINTER; a_nbytes: NATURAL_32): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return read($a_fd, $a_buf, $a_nbytes);"
		end

	dup (a_fd: INTEGER_32): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return dup($a_fd);"
		end

	getpid: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return getpid();"
		end

end
