class
	PD_ADDRESS_LIST

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	count: INTEGER_32 assign set_count
		do
			Result := c_count (c_pointer)
		end

	addresses: CE_POINTER [PD_IP_ADDRESS] assign set_addresses
		do
			create Result.make_shared (c_addresses (c_pointer))
		end

	faulty: INTEGER_32 assign set_faulty
		do
			Result := c_faulty (c_pointer)
		end

	connected: BOOLEAN assign set_connected
		do
			Result := c_connected (c_pointer)
		end

	refcount: INTEGER_32 assign set_refcount
		do
			Result := c_refcount (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_count (a_count: INTEGER_32)
		do
			c_set_count (c_pointer, a_count)
		end

	set_addresses (a_addresses: CE_POINTER [PD_IP_ADDRESS])
		do
			c_set_addresses (c_pointer, a_addresses.c_pointer)
		end

	set_faulty (a_faulty: INTEGER_32)
		do
			c_set_faulty (c_pointer, a_faulty)
		end

	set_connected (a_connected: BOOLEAN)
		do
			c_set_connected (c_pointer, a_connected)
		end

	set_refcount (a_refcount: INTEGER_32)
		do
			c_set_refcount (c_pointer, a_refcount)
		end

feature {NONE} -- C getters

	c_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct address_list *)$tmp)->count;"
		end

	c_addresses (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (ip_address *)((struct address_list *)$tmp)->addresses;"
		end

	c_faulty (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct address_list *)$tmp)->faulty;"
		end

	c_connected (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct address_list *)$tmp)->connected;"
		end

	c_refcount (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct address_list *)$tmp)->refcount;"
		end

feature {NONE} -- C setters

	c_set_count (tmp: POINTER; a_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct address_list *)$tmp)->count = $a_count;"
		end

	c_set_addresses (tmp: POINTER; a_addresses: POINTER)
		external
			"C inline"
		alias
			"((struct address_list *)$tmp)->addresses = (ip_address *)$a_addresses;"
		end

	c_set_faulty (tmp: POINTER; a_faulty: INTEGER_32)
		external
			"C inline"
		alias
			"((struct address_list *)$tmp)->faulty = $a_faulty;"
		end

	c_set_connected (tmp: POINTER; a_connected: BOOLEAN)
		external
			"C inline"
		alias
			"((struct address_list *)$tmp)->connected = $a_connected;"
		end

	c_set_refcount (tmp: POINTER; a_refcount: INTEGER_32)
		external
			"C inline"
		alias
			"((struct address_list *)$tmp)->refcount = $a_refcount;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct address_list);"
		end

end
