class
	PD_ATTR_PAIR

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	value: CE_POINTER [INTEGER_8] assign set_value
		do
			create Result.make_shared (c_value (c_pointer))
		end

	value_raw_beginning: CE_POINTER [INTEGER_8] assign set_value_raw_beginning
		do
			create Result.make_shared (c_value_raw_beginning (c_pointer))
		end

	value_raw_size: INTEGER_32 assign set_value_raw_size
		do
			Result := c_value_raw_size (c_pointer)
		end

	name_pool_index: INTEGER_32 assign set_name_pool_index
		do
			Result := c_name_pool_index (c_pointer)
		end

	value_pool_index: INTEGER_32 assign set_value_pool_index
		do
			Result := c_value_pool_index (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_value (a_value: CE_POINTER [INTEGER_8])
		do
			c_set_value (c_pointer, a_value.c_pointer)
		end

	set_value_raw_beginning (a_value_raw_beginning: CE_POINTER [INTEGER_8])
		do
			c_set_value_raw_beginning (c_pointer, a_value_raw_beginning.c_pointer)
		end

	set_value_raw_size (a_value_raw_size: INTEGER_32)
		do
			c_set_value_raw_size (c_pointer, a_value_raw_size)
		end

	set_name_pool_index (a_name_pool_index: INTEGER_32)
		do
			c_set_name_pool_index (c_pointer, a_name_pool_index)
		end

	set_value_pool_index (a_value_pool_index: INTEGER_32)
		do
			c_set_value_pool_index (c_pointer, a_value_pool_index)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct attr_pair *)$tmp)->name;"
		end

	c_value (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct attr_pair *)$tmp)->value;"
		end

	c_value_raw_beginning (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct attr_pair *)$tmp)->value_raw_beginning;"
		end

	c_value_raw_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct attr_pair *)$tmp)->value_raw_size;"
		end

	c_name_pool_index (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct attr_pair *)$tmp)->name_pool_index;"
		end

	c_value_pool_index (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct attr_pair *)$tmp)->value_pool_index;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct attr_pair *)$tmp)->name = (char *)$a_name;"
		end

	c_set_value (tmp: POINTER; a_value: POINTER)
		external
			"C inline"
		alias
			"((struct attr_pair *)$tmp)->value = (char *)$a_value;"
		end

	c_set_value_raw_beginning (tmp: POINTER; a_value_raw_beginning: POINTER)
		external
			"C inline"
		alias
			"((struct attr_pair *)$tmp)->value_raw_beginning = (char const *)$a_value_raw_beginning;"
		end

	c_set_value_raw_size (tmp: POINTER; a_value_raw_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct attr_pair *)$tmp)->value_raw_size = $a_value_raw_size;"
		end

	c_set_name_pool_index (tmp: POINTER; a_name_pool_index: INTEGER_32)
		external
			"C inline"
		alias
			"((struct attr_pair *)$tmp)->name_pool_index = $a_name_pool_index;"
		end

	c_set_value_pool_index (tmp: POINTER; a_value_pool_index: INTEGER_32)
		external
			"C inline"
		alias
			"((struct attr_pair *)$tmp)->value_pool_index = $a_value_pool_index;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct attr_pair);"
		end

end
