class
	PD_BAR_PROGRESS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	initial_length: INTEGER_64 assign set_initial_length
		do
			Result := c_initial_length (c_pointer)
		end

	total_length: INTEGER_64 assign set_total_length
		do
			Result := c_total_length (c_pointer)
		end

	count: INTEGER_64 assign set_count
		do
			Result := c_count (c_pointer)
		end

	last_screen_update: REAL_64 assign set_last_screen_update
		do
			Result := c_last_screen_update (c_pointer)
		end

	width: INTEGER_32 assign set_width
		do
			Result := c_width (c_pointer)
		end

	buffer: CE_POINTER [INTEGER_8] assign set_buffer
		do
			create Result.make_shared (c_buffer (c_pointer))
		end

	tick: INTEGER_32 assign set_tick
		do
			Result := c_tick (c_pointer)
		end

	hist: PD_BAR_PROGRESS_HIST assign set_hist
		do
			create Result.make_shared (c_hist (c_pointer))
		end

	hist_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct bar_progress, hist);"
		end

	recent_start: REAL_64 assign set_recent_start
		do
			Result := c_recent_start (c_pointer)
		end

	recent_bytes: INTEGER_64 assign set_recent_bytes
		do
			Result := c_recent_bytes (c_pointer)
		end

	stalled: BOOLEAN assign set_stalled
		do
			Result := c_stalled (c_pointer)
		end

	last_eta_time: REAL_64 assign set_last_eta_time
		do
			Result := c_last_eta_time (c_pointer)
		end

	last_eta_value: INTEGER_32 assign set_last_eta_value
		do
			Result := c_last_eta_value (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_initial_length (a_initial_length: INTEGER_64)
		do
			c_set_initial_length (c_pointer, a_initial_length)
		end

	set_total_length (a_total_length: INTEGER_64)
		do
			c_set_total_length (c_pointer, a_total_length)
		end

	set_count (a_count: INTEGER_64)
		do
			c_set_count (c_pointer, a_count)
		end

	set_last_screen_update (a_last_screen_update: REAL_64)
		do
			c_set_last_screen_update (c_pointer, a_last_screen_update)
		end

	set_width (a_width: INTEGER_32)
		do
			c_set_width (c_pointer, a_width)
		end

	set_buffer (a_buffer: CE_POINTER [INTEGER_8])
		do
			c_set_buffer (c_pointer, a_buffer.c_pointer)
		end

	set_tick (a_tick: INTEGER_32)
		do
			c_set_tick (c_pointer, a_tick)
		end

	set_hist (a_hist: PD_BAR_PROGRESS_HIST)
		do
			hist.ce_gets (a_hist)
		end

	set_recent_start (a_recent_start: REAL_64)
		do
			c_set_recent_start (c_pointer, a_recent_start)
		end

	set_recent_bytes (a_recent_bytes: INTEGER_64)
		do
			c_set_recent_bytes (c_pointer, a_recent_bytes)
		end

	set_stalled (a_stalled: BOOLEAN)
		do
			c_set_stalled (c_pointer, a_stalled)
		end

	set_last_eta_time (a_last_eta_time: REAL_64)
		do
			c_set_last_eta_time (c_pointer, a_last_eta_time)
		end

	set_last_eta_value (a_last_eta_value: INTEGER_32)
		do
			c_set_last_eta_value (c_pointer, a_last_eta_value)
		end

feature {NONE} -- C getters

	c_initial_length (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct bar_progress *)$tmp)->initial_length;"
		end

	c_total_length (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct bar_progress *)$tmp)->total_length;"
		end

	c_count (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct bar_progress *)$tmp)->count;"
		end

	c_last_screen_update (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct bar_progress *)$tmp)->last_screen_update;"
		end

	c_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct bar_progress *)$tmp)->width;"
		end

	c_buffer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct bar_progress *)$tmp)->buffer;"
		end

	c_tick (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct bar_progress *)$tmp)->tick;"
		end

	c_hist (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct bar_progress_hist *)&((struct bar_progress *)$tmp)->hist;"
		end

	c_recent_start (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct bar_progress *)$tmp)->recent_start;"
		end

	c_recent_bytes (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct bar_progress *)$tmp)->recent_bytes;"
		end

	c_stalled (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct bar_progress *)$tmp)->stalled;"
		end

	c_last_eta_time (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct bar_progress *)$tmp)->last_eta_time;"
		end

	c_last_eta_value (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct bar_progress *)$tmp)->last_eta_value;"
		end

feature {NONE} -- C setters

	c_set_initial_length (tmp: POINTER; a_initial_length: INTEGER_64)
		external
			"C inline"
		alias
			"((struct bar_progress *)$tmp)->initial_length = $a_initial_length;"
		end

	c_set_total_length (tmp: POINTER; a_total_length: INTEGER_64)
		external
			"C inline"
		alias
			"((struct bar_progress *)$tmp)->total_length = $a_total_length;"
		end

	c_set_count (tmp: POINTER; a_count: INTEGER_64)
		external
			"C inline"
		alias
			"((struct bar_progress *)$tmp)->count = $a_count;"
		end

	c_set_last_screen_update (tmp: POINTER; a_last_screen_update: REAL_64)
		external
			"C inline"
		alias
			"((struct bar_progress *)$tmp)->last_screen_update = $a_last_screen_update;"
		end

	c_set_width (tmp: POINTER; a_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct bar_progress *)$tmp)->width = $a_width;"
		end

	c_set_buffer (tmp: POINTER; a_buffer: POINTER)
		external
			"C inline"
		alias
			"((struct bar_progress *)$tmp)->buffer = (char *)$a_buffer;"
		end

	c_set_tick (tmp: POINTER; a_tick: INTEGER_32)
		external
			"C inline"
		alias
			"((struct bar_progress *)$tmp)->tick = $a_tick;"
		end

	c_set_recent_start (tmp: POINTER; a_recent_start: REAL_64)
		external
			"C inline"
		alias
			"((struct bar_progress *)$tmp)->recent_start = $a_recent_start;"
		end

	c_set_recent_bytes (tmp: POINTER; a_recent_bytes: INTEGER_64)
		external
			"C inline"
		alias
			"((struct bar_progress *)$tmp)->recent_bytes = $a_recent_bytes;"
		end

	c_set_stalled (tmp: POINTER; a_stalled: BOOLEAN)
		external
			"C inline"
		alias
			"((struct bar_progress *)$tmp)->stalled = $a_stalled;"
		end

	c_set_last_eta_time (tmp: POINTER; a_last_eta_time: REAL_64)
		external
			"C inline"
		alias
			"((struct bar_progress *)$tmp)->last_eta_time = $a_last_eta_time;"
		end

	c_set_last_eta_value (tmp: POINTER; a_last_eta_value: INTEGER_32)
		external
			"C inline"
		alias
			"((struct bar_progress *)$tmp)->last_eta_value = $a_last_eta_value;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct bar_progress);"
		end

end
