class
	PD_BAR_PROGRESS_HIST

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	pos: INTEGER_32 assign set_pos
		do
			Result := c_pos (c_pointer)
		end

	times: CE_ARRAY [REAL_64]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_times (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	bytes: CE_ARRAY [INTEGER_64]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_bytes (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	total_time: REAL_64 assign set_total_time
		do
			Result := c_total_time (c_pointer)
		end

	total_bytes: INTEGER_64 assign set_total_bytes
		do
			Result := c_total_bytes (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_pos (a_pos: INTEGER_32)
		do
			c_set_pos (c_pointer, a_pos)
		end

	set_total_time (a_total_time: REAL_64)
		do
			c_set_total_time (c_pointer, a_total_time)
		end

	set_total_bytes (a_total_bytes: INTEGER_64)
		do
			c_set_total_bytes (c_pointer, a_total_bytes)
		end

feature {NONE} -- C getters

	c_pos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct bar_progress_hist *)$tmp)->pos;"
		end

	c_times (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct bar_progress_hist *tmp = (struct bar_progress_hist *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->times) / sizeof(tmp->times[0]);
				return tmp->times;
			]"
		end

	c_bytes (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct bar_progress_hist *tmp = (struct bar_progress_hist *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->bytes) / sizeof(tmp->bytes[0]);
				return tmp->bytes;
			]"
		end

	c_total_time (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct bar_progress_hist *)$tmp)->total_time;"
		end

	c_total_bytes (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct bar_progress_hist *)$tmp)->total_bytes;"
		end

feature {NONE} -- C setters

	c_set_pos (tmp: POINTER; a_pos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct bar_progress_hist *)$tmp)->pos = $a_pos;"
		end

	c_set_total_time (tmp: POINTER; a_total_time: REAL_64)
		external
			"C inline"
		alias
			"((struct bar_progress_hist *)$tmp)->total_time = $a_total_time;"
		end

	c_set_total_bytes (tmp: POINTER; a_total_bytes: INTEGER_64)
		external
			"C inline"
		alias
			"((struct bar_progress_hist *)$tmp)->total_bytes = $a_total_bytes;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct bar_progress_hist);"
		end

end
