class
	PD_CCON

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	st: INTEGER_32 assign set_st
		do
			Result := c_st (c_pointer)
		end

	cmd: INTEGER_32 assign set_cmd
		do
			Result := c_cmd (c_pointer)
		end

	csock: INTEGER_32 assign set_csock
		do
			Result := c_csock (c_pointer)
		end

	dltime: REAL_64 assign set_dltime
		do
			Result := c_dltime (c_pointer)
		end

	dltime_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct __anonstruct_ccon_57, dltime);"
		end

	rs: INTEGER_32 assign set_rs
		do
			Result := c_rs (c_pointer)
		end

	rs_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct __anonstruct_ccon_57, rs);"
		end

	id: CE_POINTER [INTEGER_8] assign set_id
		do
			create Result.make_shared (c_id (c_pointer))
		end

	id_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct __anonstruct_ccon_57, id);"
		end

	target: CE_POINTER [INTEGER_8] assign set_target
		do
			create Result.make_shared (c_target (c_pointer))
		end

	proxy: CE_POINTER [PD_URL] assign set_proxy
		do
			create Result.make_shared (c_proxy (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_st (a_st: INTEGER_32)
		do
			c_set_st (c_pointer, a_st)
		end

	set_cmd (a_cmd: INTEGER_32)
		do
			c_set_cmd (c_pointer, a_cmd)
		end

	set_csock (a_csock: INTEGER_32)
		do
			c_set_csock (c_pointer, a_csock)
		end

	set_dltime (a_dltime: REAL_64)
		do
			c_set_dltime (c_pointer, a_dltime)
		end

	set_rs (a_rs: INTEGER_32)
		do
			c_set_rs (c_pointer, a_rs)
		end

	set_id (a_id: CE_POINTER [INTEGER_8])
		do
			c_set_id (c_pointer, a_id.c_pointer)
		end

	set_target (a_target: CE_POINTER [INTEGER_8])
		do
			c_set_target (c_pointer, a_target.c_pointer)
		end

	set_proxy (a_proxy: CE_POINTER [PD_URL])
		do
			c_set_proxy (c_pointer, a_proxy.c_pointer)
		end

feature {NONE} -- C getters

	c_st (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_ccon_57 *)$tmp)->st;"
		end

	c_cmd (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_ccon_57 *)$tmp)->cmd;"
		end

	c_csock (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_ccon_57 *)$tmp)->csock;"
		end

	c_dltime (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_ccon_57 *)$tmp)->dltime;"
		end

	c_rs (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_ccon_57 *)$tmp)->rs;"
		end

	c_id (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_ccon_57 *)$tmp)->id;"
		end

	c_target (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_ccon_57 *)$tmp)->target;"
		end

	c_proxy (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct url *)((struct __anonstruct_ccon_57 *)$tmp)->proxy;"
		end

feature {NONE} -- C setters

	c_set_st (tmp: POINTER; a_st: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ccon_57 *)$tmp)->st = $a_st;"
		end

	c_set_cmd (tmp: POINTER; a_cmd: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ccon_57 *)$tmp)->cmd = $a_cmd;"
		end

	c_set_csock (tmp: POINTER; a_csock: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ccon_57 *)$tmp)->csock = $a_csock;"
		end

	c_set_dltime (tmp: POINTER; a_dltime: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_ccon_57 *)$tmp)->dltime = $a_dltime;"
		end

	c_set_rs (tmp: POINTER; a_rs: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ccon_57 *)$tmp)->rs = $a_rs;"
		end

	c_set_id (tmp: POINTER; a_id: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_ccon_57 *)$tmp)->id = (char *)$a_id;"
		end

	c_set_target (tmp: POINTER; a_target: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_ccon_57 *)$tmp)->target = (char *)$a_target;"
		end

	c_set_proxy (tmp: POINTER; a_proxy: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_ccon_57 *)$tmp)->proxy = (struct url *)$a_proxy;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct __anonstruct_ccon_57);"
		end

end
