class
	PD_CELL

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	key: CE_POINTER [ANY] assign set_key
		do
			create Result.make_shared (c_key (c_pointer))
		end

	value: CE_POINTER [ANY] assign set_value
		do
			create Result.make_shared (c_value (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_key (a_key: CE_POINTER [ANY])
		do
			c_set_key (c_pointer, a_key.c_pointer)
		end

	set_value (a_value: CE_POINTER [ANY])
		do
			c_set_value (c_pointer, a_value.c_pointer)
		end

feature {NONE} -- C getters

	c_key (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct cell *)$tmp)->key;"
		end

	c_value (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct cell *)$tmp)->value;"
		end

feature {NONE} -- C setters

	c_set_key (tmp: POINTER; a_key: POINTER)
		external
			"C inline"
		alias
			"((struct cell *)$tmp)->key = (void *)$a_key;"
		end

	c_set_value (tmp: POINTER; a_value: POINTER)
		external
			"C inline"
		alias
			"((struct cell *)$tmp)->value = (void *)$a_value;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct cell);"
		end

end
