class
	PD_CMDLINE_OPTION

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	long_name: CE_POINTER [INTEGER_8] assign set_long_name
		do
			create Result.make_shared (c_long_name (c_pointer))
		end

	short_name: INTEGER_8 assign set_short_name
		do
			Result := c_short_name (c_pointer)
		end

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	data: CE_POINTER [ANY] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	argtype: INTEGER_32 assign set_argtype
		do
			Result := c_argtype (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_long_name (a_long_name: CE_POINTER [INTEGER_8])
		do
			c_set_long_name (c_pointer, a_long_name.c_pointer)
		end

	set_short_name (a_short_name: INTEGER_8)
		do
			c_set_short_name (c_pointer, a_short_name)
		end

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_argtype (a_argtype: INTEGER_32)
		do
			c_set_argtype (c_pointer, a_argtype)
		end

feature {NONE} -- C getters

	c_long_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct cmdline_option *)$tmp)->long_name;"
		end

	c_short_name (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct cmdline_option *)$tmp)->short_name;"
		end

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cmdline_option *)$tmp)->type;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct cmdline_option *)$tmp)->data;"
		end

	c_argtype (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cmdline_option *)$tmp)->argtype;"
		end

feature {NONE} -- C setters

	c_set_long_name (tmp: POINTER; a_long_name: POINTER)
		external
			"C inline"
		alias
			"((struct cmdline_option *)$tmp)->long_name = (char const *)$a_long_name;"
		end

	c_set_short_name (tmp: POINTER; a_short_name: INTEGER_8)
		external
			"C inline"
		alias
			"((struct cmdline_option *)$tmp)->short_name = $a_short_name;"
		end

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdline_option *)$tmp)->type = $a_type;"
		end

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct cmdline_option *)$tmp)->data = (void const *)$a_data;"
		end

	c_set_argtype (tmp: POINTER; a_argtype: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdline_option *)$tmp)->argtype = $a_argtype;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct cmdline_option);"
		end

end
