class
	PD_COOKIE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	domain: CE_POINTER [INTEGER_8] assign set_domain
		do
			create Result.make_shared (c_domain (c_pointer))
		end

	port: INTEGER_32 assign set_port
		do
			Result := c_port (c_pointer)
		end

	path: CE_POINTER [INTEGER_8] assign set_path
		do
			create Result.make_shared (c_path (c_pointer))
		end

	discard_requested: NATURAL_32 assign set_discard_requested
		do
			Result := c_discard_requested (c_pointer)
		end

	secure: NATURAL_32 assign set_secure
		do
			Result := c_secure (c_pointer)
		end

	domain_exact: NATURAL_32 assign set_domain_exact
		do
			Result := c_domain_exact (c_pointer)
		end

	permanent: NATURAL_32 assign set_permanent
		do
			Result := c_permanent (c_pointer)
		end

	expiry_time: INTEGER_32 assign set_expiry_time
		do
			Result := c_expiry_time (c_pointer)
		end

	attr: CE_POINTER [INTEGER_8] assign set_attr
		do
			create Result.make_shared (c_attr (c_pointer))
		end

	value: CE_POINTER [INTEGER_8] assign set_value
		do
			create Result.make_shared (c_value (c_pointer))
		end

	next: CE_POINTER [PD_COOKIE] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_domain (a_domain: CE_POINTER [INTEGER_8])
		do
			c_set_domain (c_pointer, a_domain.c_pointer)
		end

	set_port (a_port: INTEGER_32)
		do
			c_set_port (c_pointer, a_port)
		end

	set_path (a_path: CE_POINTER [INTEGER_8])
		do
			c_set_path (c_pointer, a_path.c_pointer)
		end

	set_discard_requested (a_discard_requested: NATURAL_32)
		do
			c_set_discard_requested (c_pointer, a_discard_requested)
		end

	set_secure (a_secure: NATURAL_32)
		do
			c_set_secure (c_pointer, a_secure)
		end

	set_domain_exact (a_domain_exact: NATURAL_32)
		do
			c_set_domain_exact (c_pointer, a_domain_exact)
		end

	set_permanent (a_permanent: NATURAL_32)
		do
			c_set_permanent (c_pointer, a_permanent)
		end

	set_expiry_time (a_expiry_time: INTEGER_32)
		do
			c_set_expiry_time (c_pointer, a_expiry_time)
		end

	set_attr (a_attr: CE_POINTER [INTEGER_8])
		do
			c_set_attr (c_pointer, a_attr.c_pointer)
		end

	set_value (a_value: CE_POINTER [INTEGER_8])
		do
			c_set_value (c_pointer, a_value.c_pointer)
		end

	set_next (a_next: CE_POINTER [PD_COOKIE])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

feature {NONE} -- C getters

	c_domain (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct cookie *)$tmp)->domain;"
		end

	c_port (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cookie *)$tmp)->port;"
		end

	c_path (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct cookie *)$tmp)->path;"
		end

	c_discard_requested (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct cookie *)$tmp)->discard_requested;"
		end

	c_secure (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct cookie *)$tmp)->secure;"
		end

	c_domain_exact (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct cookie *)$tmp)->domain_exact;"
		end

	c_permanent (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct cookie *)$tmp)->permanent;"
		end

	c_expiry_time (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct cookie *)$tmp)->expiry_time;"
		end

	c_attr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct cookie *)$tmp)->attr;"
		end

	c_value (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct cookie *)$tmp)->value;"
		end

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct cookie *)((struct cookie *)$tmp)->next;"
		end

feature {NONE} -- C setters

	c_set_domain (tmp: POINTER; a_domain: POINTER)
		external
			"C inline"
		alias
			"((struct cookie *)$tmp)->domain = (char *)$a_domain;"
		end

	c_set_port (tmp: POINTER; a_port: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cookie *)$tmp)->port = $a_port;"
		end

	c_set_path (tmp: POINTER; a_path: POINTER)
		external
			"C inline"
		alias
			"((struct cookie *)$tmp)->path = (char *)$a_path;"
		end

	c_set_discard_requested (tmp: POINTER; a_discard_requested: NATURAL_32)
		external
			"C inline"
		alias
			"((struct cookie *)$tmp)->discard_requested = $a_discard_requested;"
		end

	c_set_secure (tmp: POINTER; a_secure: NATURAL_32)
		external
			"C inline"
		alias
			"((struct cookie *)$tmp)->secure = $a_secure;"
		end

	c_set_domain_exact (tmp: POINTER; a_domain_exact: NATURAL_32)
		external
			"C inline"
		alias
			"((struct cookie *)$tmp)->domain_exact = $a_domain_exact;"
		end

	c_set_permanent (tmp: POINTER; a_permanent: NATURAL_32)
		external
			"C inline"
		alias
			"((struct cookie *)$tmp)->permanent = $a_permanent;"
		end

	c_set_expiry_time (tmp: POINTER; a_expiry_time: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cookie *)$tmp)->expiry_time = $a_expiry_time;"
		end

	c_set_attr (tmp: POINTER; a_attr: POINTER)
		external
			"C inline"
		alias
			"((struct cookie *)$tmp)->attr = (char *)$a_attr;"
		end

	c_set_value (tmp: POINTER; a_value: POINTER)
		external
			"C inline"
		alias
			"((struct cookie *)$tmp)->value = (char *)$a_value;"
		end

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct cookie *)$tmp)->next = (struct cookie *)$a_next;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct cookie);"
		end

end
