class
	PD_COOKIE_JAR

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	chains: CE_POINTER [PD_HASH_TABLE] assign set_chains
		do
			create Result.make_shared (c_chains (c_pointer))
		end

	cookie_count: INTEGER_32 assign set_cookie_count
		do
			Result := c_cookie_count (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_chains (a_chains: CE_POINTER [PD_HASH_TABLE])
		do
			c_set_chains (c_pointer, a_chains.c_pointer)
		end

	set_cookie_count (a_cookie_count: INTEGER_32)
		do
			c_set_cookie_count (c_pointer, a_cookie_count)
		end

feature {NONE} -- C getters

	c_chains (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct hash_table *)((struct cookie_jar *)$tmp)->chains;"
		end

	c_cookie_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cookie_jar *)$tmp)->cookie_count;"
		end

feature {NONE} -- C setters

	c_set_chains (tmp: POINTER; a_chains: POINTER)
		external
			"C inline"
		alias
			"((struct cookie_jar *)$tmp)->chains = (struct hash_table *)$a_chains;"
		end

	c_set_cookie_count (tmp: POINTER; a_cookie_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cookie_jar *)$tmp)->cookie_count = $a_cookie_count;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct cookie_jar);"
		end

end
