class
	PD_CWT_CONTEXT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	fd: INTEGER_32 assign set_fd
		do
			Result := c_fd (c_pointer)
		end

	addr: CE_POINTER [SD_SOCKADDR] assign set_addr
		do
			create Result.make_shared (c_addr (c_pointer))
		end

	addrlen: NATURAL_32 assign set_addrlen
		do
			Result := c_addrlen (c_pointer)
		end

	result2: INTEGER_32 assign set_result2
		do
			Result := c_result2 (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_fd (a_fd: INTEGER_32)
		do
			c_set_fd (c_pointer, a_fd)
		end

	set_addr (a_addr: CE_POINTER [SD_SOCKADDR])
		do
			c_set_addr (c_pointer, a_addr.c_pointer)
		end

	set_addrlen (a_addrlen: NATURAL_32)
		do
			c_set_addrlen (c_pointer, a_addrlen)
		end

	set_result2 (a_result2: INTEGER_32)
		do
			c_set_result2 (c_pointer, a_result2)
		end

feature {NONE} -- C getters

	c_fd (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cwt_context *)$tmp)->fd;"
		end

	c_addr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct sockaddr *)((struct cwt_context *)$tmp)->addr;"
		end

	c_addrlen (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct cwt_context *)$tmp)->addrlen;"
		end

	c_result2 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cwt_context *)$tmp)->result;"
		end

feature {NONE} -- C setters

	c_set_fd (tmp: POINTER; a_fd: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cwt_context *)$tmp)->fd = $a_fd;"
		end

	c_set_addr (tmp: POINTER; a_addr: POINTER)
		external
			"C inline"
		alias
			"((struct cwt_context *)$tmp)->addr = (struct sockaddr const *)$a_addr;"
		end

	c_set_addrlen (tmp: POINTER; a_addrlen: NATURAL_32)
		external
			"C inline"
		alias
			"((struct cwt_context *)$tmp)->addrlen = $a_addrlen;"
		end

	c_set_result2 (tmp: POINTER; a_result2: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cwt_context *)$tmp)->result = $a_result2;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct cwt_context);"
		end

end
