class
	PD_FILE_MEMORY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	content: CE_POINTER [INTEGER_8] assign set_content
		do
			create Result.make_shared (c_content (c_pointer))
		end

	length: INTEGER_32 assign set_length
		do
			Result := c_length (c_pointer)
		end

	mmap_p: INTEGER_32 assign set_mmap_p
		do
			Result := c_mmap_p (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_content (a_content: CE_POINTER [INTEGER_8])
		do
			c_set_content (c_pointer, a_content.c_pointer)
		end

	set_length (a_length: INTEGER_32)
		do
			c_set_length (c_pointer, a_length)
		end

	set_mmap_p (a_mmap_p: INTEGER_32)
		do
			c_set_mmap_p (c_pointer, a_mmap_p)
		end

feature {NONE} -- C getters

	c_content (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct file_memory *)$tmp)->content;"
		end

	c_length (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_memory *)$tmp)->length;"
		end

	c_mmap_p (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_memory *)$tmp)->mmap_p;"
		end

feature {NONE} -- C setters

	c_set_content (tmp: POINTER; a_content: POINTER)
		external
			"C inline"
		alias
			"((struct file_memory *)$tmp)->content = (char *)$a_content;"
		end

	c_set_length (tmp: POINTER; a_length: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_memory *)$tmp)->length = $a_length;"
		end

	c_set_mmap_p (tmp: POINTER; a_mmap_p: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_memory *)$tmp)->mmap_p = $a_mmap_p;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct file_memory);"
		end

end
