class
	PD_FILEINFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	size: INTEGER_64 assign set_size
		do
			Result := c_size (c_pointer)
		end

	tstamp: INTEGER_32 assign set_tstamp
		do
			Result := c_tstamp (c_pointer)
		end

	perms: INTEGER_32 assign set_perms
		do
			Result := c_perms (c_pointer)
		end

	linkto: CE_POINTER [INTEGER_8] assign set_linkto
		do
			create Result.make_shared (c_linkto (c_pointer))
		end

	prev: CE_POINTER [PD_FILEINFO] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	next: CE_POINTER [PD_FILEINFO] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_size (a_size: INTEGER_64)
		do
			c_set_size (c_pointer, a_size)
		end

	set_tstamp (a_tstamp: INTEGER_32)
		do
			c_set_tstamp (c_pointer, a_tstamp)
		end

	set_perms (a_perms: INTEGER_32)
		do
			c_set_perms (c_pointer, a_perms)
		end

	set_linkto (a_linkto: CE_POINTER [INTEGER_8])
		do
			c_set_linkto (c_pointer, a_linkto.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_FILEINFO])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_next (a_next: CE_POINTER [PD_FILEINFO])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct fileinfo *)$tmp)->type;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct fileinfo *)$tmp)->name;"
		end

	c_size (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct fileinfo *)$tmp)->size;"
		end

	c_tstamp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct fileinfo *)$tmp)->tstamp;"
		end

	c_perms (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct fileinfo *)$tmp)->perms;"
		end

	c_linkto (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct fileinfo *)$tmp)->linkto;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct fileinfo *)((struct fileinfo *)$tmp)->prev;"
		end

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct fileinfo *)((struct fileinfo *)$tmp)->next;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct fileinfo *)$tmp)->type = $a_type;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct fileinfo *)$tmp)->name = (char *)$a_name;"
		end

	c_set_size (tmp: POINTER; a_size: INTEGER_64)
		external
			"C inline"
		alias
			"((struct fileinfo *)$tmp)->size = $a_size;"
		end

	c_set_tstamp (tmp: POINTER; a_tstamp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct fileinfo *)$tmp)->tstamp = $a_tstamp;"
		end

	c_set_perms (tmp: POINTER; a_perms: INTEGER_32)
		external
			"C inline"
		alias
			"((struct fileinfo *)$tmp)->perms = $a_perms;"
		end

	c_set_linkto (tmp: POINTER; a_linkto: POINTER)
		external
			"C inline"
		alias
			"((struct fileinfo *)$tmp)->linkto = (char *)$a_linkto;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct fileinfo *)$tmp)->prev = (struct fileinfo *)$a_prev;"
		end

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct fileinfo *)$tmp)->next = (struct fileinfo *)$a_next;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct fileinfo);"
		end

end
