class
	PD_GAIWT_CONTEXT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	node: CE_POINTER [INTEGER_8] assign set_node
		do
			create Result.make_shared (c_node (c_pointer))
		end

	service: CE_POINTER [INTEGER_8] assign set_service
		do
			create Result.make_shared (c_service (c_pointer))
		end

	hints: CE_POINTER [SD_ADDRINFO] assign set_hints
		do
			create Result.make_shared (c_hints (c_pointer))
		end

	res: CE_POINTER [CE_POINTER [SD_ADDRINFO]] assign set_res
		do
			create Result.make_shared (c_res (c_pointer))
		end

	exit_code: INTEGER_32 assign set_exit_code
		do
			Result := c_exit_code (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_node (a_node: CE_POINTER [INTEGER_8])
		do
			c_set_node (c_pointer, a_node.c_pointer)
		end

	set_service (a_service: CE_POINTER [INTEGER_8])
		do
			c_set_service (c_pointer, a_service.c_pointer)
		end

	set_hints (a_hints: CE_POINTER [SD_ADDRINFO])
		do
			c_set_hints (c_pointer, a_hints.c_pointer)
		end

	set_res (a_res: CE_POINTER [CE_POINTER [SD_ADDRINFO]])
		do
			c_set_res (c_pointer, a_res.c_pointer)
		end

	set_exit_code (a_exit_code: INTEGER_32)
		do
			c_set_exit_code (c_pointer, a_exit_code)
		end

feature {NONE} -- C getters

	c_node (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct gaiwt_context *)$tmp)->node;"
		end

	c_service (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct gaiwt_context *)$tmp)->service;"
		end

	c_hints (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct addrinfo *)((struct gaiwt_context *)$tmp)->hints;"
		end

	c_res (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct addrinfo * *)((struct gaiwt_context *)$tmp)->res;"
		end

	c_exit_code (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct gaiwt_context *)$tmp)->exit_code;"
		end

feature {NONE} -- C setters

	c_set_node (tmp: POINTER; a_node: POINTER)
		external
			"C inline"
		alias
			"((struct gaiwt_context *)$tmp)->node = (char const *)$a_node;"
		end

	c_set_service (tmp: POINTER; a_service: POINTER)
		external
			"C inline"
		alias
			"((struct gaiwt_context *)$tmp)->service = (char const *)$a_service;"
		end

	c_set_hints (tmp: POINTER; a_hints: POINTER)
		external
			"C inline"
		alias
			"((struct gaiwt_context *)$tmp)->hints = (struct addrinfo const *)$a_hints;"
		end

	c_set_res (tmp: POINTER; a_res: POINTER)
		external
			"C inline"
		alias
			"((struct gaiwt_context *)$tmp)->res = (struct addrinfo * *)$a_res;"
		end

	c_set_exit_code (tmp: POINTER; a_exit_code: INTEGER_32)
		external
			"C inline"
		alias
			"((struct gaiwt_context *)$tmp)->exit_code = $a_exit_code;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct gaiwt_context);"
		end

end
