class
	PD_GROWABLE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	base: CE_POINTER [INTEGER_8] assign set_base
		do
			create Result.make_shared (c_base (c_pointer))
		end

	size: INTEGER_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	tail: INTEGER_32 assign set_tail
		do
			Result := c_tail (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_base (a_base: CE_POINTER [INTEGER_8])
		do
			c_set_base (c_pointer, a_base.c_pointer)
		end

	set_size (a_size: INTEGER_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_tail (a_tail: INTEGER_32)
		do
			c_set_tail (c_pointer, a_tail)
		end

feature {NONE} -- C getters

	c_base (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct growable *)$tmp)->base;"
		end

	c_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct growable *)$tmp)->size;"
		end

	c_tail (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct growable *)$tmp)->tail;"
		end

feature {NONE} -- C setters

	c_set_base (tmp: POINTER; a_base: POINTER)
		external
			"C inline"
		alias
			"((struct growable *)$tmp)->base = (char *)$a_base;"
		end

	c_set_size (tmp: POINTER; a_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct growable *)$tmp)->size = $a_size;"
		end

	c_set_tail (tmp: POINTER; a_tail: INTEGER_32)
		external
			"C inline"
		alias
			"((struct growable *)$tmp)->tail = $a_tail;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct growable);"
		end

end
