class
	PD_HASH_TABLE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	hash_function: CE_ROUTINE assign set_hash_function
		do
			create Result.make_shared (c_hash_function (c_pointer))
		end

	test_function: CE_ROUTINE assign set_test_function
		do
			create Result.make_shared (c_test_function (c_pointer))
		end

	cells: CE_POINTER [PD_CELL] assign set_cells
		do
			create Result.make_shared (c_cells (c_pointer))
		end

	size: INTEGER_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	count: INTEGER_32 assign set_count
		do
			Result := c_count (c_pointer)
		end

	resize_threshold: INTEGER_32 assign set_resize_threshold
		do
			Result := c_resize_threshold (c_pointer)
		end

	prime_offset: INTEGER_32 assign set_prime_offset
		do
			Result := c_prime_offset (c_pointer)
		end

	prime_offset_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct hash_table, prime_offset);"
		end

feature {ANY} -- Eiffel setters

	set_hash_function (a_hash_function: CE_ROUTINE)
		do
			c_set_hash_function (c_pointer, a_hash_function.c_pointer)
		end

	set_test_function (a_test_function: CE_ROUTINE)
		do
			c_set_test_function (c_pointer, a_test_function.c_pointer)
		end

	set_cells (a_cells: CE_POINTER [PD_CELL])
		do
			c_set_cells (c_pointer, a_cells.c_pointer)
		end

	set_size (a_size: INTEGER_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_count (a_count: INTEGER_32)
		do
			c_set_count (c_pointer, a_count)
		end

	set_resize_threshold (a_resize_threshold: INTEGER_32)
		do
			c_set_resize_threshold (c_pointer, a_resize_threshold)
		end

	set_prime_offset (a_prime_offset: INTEGER_32)
		do
			c_set_prime_offset (c_pointer, a_prime_offset)
		end

feature {NONE} -- C getters

	c_hash_function (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned long( *)(void *))((struct hash_table *)$tmp)->hash_function;"
		end

	c_test_function (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void *, void *))((struct hash_table *)$tmp)->test_function;"
		end

	c_cells (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct cell *)((struct hash_table *)$tmp)->cells;"
		end

	c_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct hash_table *)$tmp)->size;"
		end

	c_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct hash_table *)$tmp)->count;"
		end

	c_resize_threshold (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct hash_table *)$tmp)->resize_threshold;"
		end

	c_prime_offset (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct hash_table *)$tmp)->prime_offset;"
		end

feature {NONE} -- C setters

	c_set_hash_function (tmp: POINTER; a_hash_function: POINTER)
		external
			"C inline"
		alias
			"((struct hash_table *)$tmp)->hash_function = (unsigned long( *)(void const *))$a_hash_function;"
		end

	c_set_test_function (tmp: POINTER; a_test_function: POINTER)
		external
			"C inline"
		alias
			"((struct hash_table *)$tmp)->test_function = (int( *)(void const *, void const *))$a_test_function;"
		end

	c_set_cells (tmp: POINTER; a_cells: POINTER)
		external
			"C inline"
		alias
			"((struct hash_table *)$tmp)->cells = (struct cell *)$a_cells;"
		end

	c_set_size (tmp: POINTER; a_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct hash_table *)$tmp)->size = $a_size;"
		end

	c_set_count (tmp: POINTER; a_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct hash_table *)$tmp)->count = $a_count;"
		end

	c_set_resize_threshold (tmp: POINTER; a_resize_threshold: INTEGER_32)
		external
			"C inline"
		alias
			"((struct hash_table *)$tmp)->resize_threshold = $a_resize_threshold;"
		end

	c_set_prime_offset (tmp: POINTER; a_prime_offset: INTEGER_32)
		external
			"C inline"
		alias
			"((struct hash_table *)$tmp)->prime_offset = $a_prime_offset;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct hash_table);"
		end

end
