class
	PD_HTTP_STAT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	len: INTEGER_64 assign set_len
		do
			Result := c_len (c_pointer)
		end

	len_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct http_stat, len);"
		end

	contlen: INTEGER_64 assign set_contlen
		do
			Result := c_contlen (c_pointer)
		end

	restval: INTEGER_64 assign set_restval
		do
			Result := c_restval (c_pointer)
		end

	res: INTEGER_32 assign set_res
		do
			Result := c_res (c_pointer)
		end

	rderrmsg: CE_POINTER [INTEGER_8] assign set_rderrmsg
		do
			create Result.make_shared (c_rderrmsg (c_pointer))
		end

	newloc: CE_POINTER [INTEGER_8] assign set_newloc
		do
			create Result.make_shared (c_newloc (c_pointer))
		end

	remote_time: CE_POINTER [INTEGER_8] assign set_remote_time
		do
			create Result.make_shared (c_remote_time (c_pointer))
		end

	error: CE_POINTER [INTEGER_8] assign set_error
		do
			create Result.make_shared (c_error (c_pointer))
		end

	statcode: INTEGER_32 assign set_statcode
		do
			Result := c_statcode (c_pointer)
		end

	message: CE_POINTER [INTEGER_8] assign set_message
		do
			create Result.make_shared (c_message (c_pointer))
		end

	rd_size: INTEGER_64 assign set_rd_size
		do
			Result := c_rd_size (c_pointer)
		end

	rd_size_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct http_stat, rd_size);"
		end

	dltime: REAL_64 assign set_dltime
		do
			Result := c_dltime (c_pointer)
		end

	dltime_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct http_stat, dltime);"
		end

	referer: CE_POINTER [INTEGER_8] assign set_referer
		do
			create Result.make_shared (c_referer (c_pointer))
		end

	local_file: CE_POINTER [INTEGER_8] assign set_local_file
		do
			create Result.make_shared (c_local_file (c_pointer))
		end

	local_file_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct http_stat, local_file);"
		end

	existence_checked: BOOLEAN assign set_existence_checked
		do
			Result := c_existence_checked (c_pointer)
		end

	timestamp_checked: BOOLEAN assign set_timestamp_checked
		do
			Result := c_timestamp_checked (c_pointer)
		end

	orig_file_name: CE_POINTER [INTEGER_8] assign set_orig_file_name
		do
			create Result.make_shared (c_orig_file_name (c_pointer))
		end

	orig_file_size: INTEGER_64 assign set_orig_file_size
		do
			Result := c_orig_file_size (c_pointer)
		end

	orig_file_tstamp: INTEGER_32 assign set_orig_file_tstamp
		do
			Result := c_orig_file_tstamp (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_len (a_len: INTEGER_64)
		do
			c_set_len (c_pointer, a_len)
		end

	set_contlen (a_contlen: INTEGER_64)
		do
			c_set_contlen (c_pointer, a_contlen)
		end

	set_restval (a_restval: INTEGER_64)
		do
			c_set_restval (c_pointer, a_restval)
		end

	set_res (a_res: INTEGER_32)
		do
			c_set_res (c_pointer, a_res)
		end

	set_rderrmsg (a_rderrmsg: CE_POINTER [INTEGER_8])
		do
			c_set_rderrmsg (c_pointer, a_rderrmsg.c_pointer)
		end

	set_newloc (a_newloc: CE_POINTER [INTEGER_8])
		do
			c_set_newloc (c_pointer, a_newloc.c_pointer)
		end

	set_remote_time (a_remote_time: CE_POINTER [INTEGER_8])
		do
			c_set_remote_time (c_pointer, a_remote_time.c_pointer)
		end

	set_error (a_error: CE_POINTER [INTEGER_8])
		do
			c_set_error (c_pointer, a_error.c_pointer)
		end

	set_statcode (a_statcode: INTEGER_32)
		do
			c_set_statcode (c_pointer, a_statcode)
		end

	set_message (a_message: CE_POINTER [INTEGER_8])
		do
			c_set_message (c_pointer, a_message.c_pointer)
		end

	set_rd_size (a_rd_size: INTEGER_64)
		do
			c_set_rd_size (c_pointer, a_rd_size)
		end

	set_dltime (a_dltime: REAL_64)
		do
			c_set_dltime (c_pointer, a_dltime)
		end

	set_referer (a_referer: CE_POINTER [INTEGER_8])
		do
			c_set_referer (c_pointer, a_referer.c_pointer)
		end

	set_local_file (a_local_file: CE_POINTER [INTEGER_8])
		do
			c_set_local_file (c_pointer, a_local_file.c_pointer)
		end

	set_existence_checked (a_existence_checked: BOOLEAN)
		do
			c_set_existence_checked (c_pointer, a_existence_checked)
		end

	set_timestamp_checked (a_timestamp_checked: BOOLEAN)
		do
			c_set_timestamp_checked (c_pointer, a_timestamp_checked)
		end

	set_orig_file_name (a_orig_file_name: CE_POINTER [INTEGER_8])
		do
			c_set_orig_file_name (c_pointer, a_orig_file_name.c_pointer)
		end

	set_orig_file_size (a_orig_file_size: INTEGER_64)
		do
			c_set_orig_file_size (c_pointer, a_orig_file_size)
		end

	set_orig_file_tstamp (a_orig_file_tstamp: INTEGER_32)
		do
			c_set_orig_file_tstamp (c_pointer, a_orig_file_tstamp)
		end

feature {NONE} -- C getters

	c_len (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct http_stat *)$tmp)->len;"
		end

	c_contlen (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct http_stat *)$tmp)->contlen;"
		end

	c_restval (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct http_stat *)$tmp)->restval;"
		end

	c_res (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct http_stat *)$tmp)->res;"
		end

	c_rderrmsg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct http_stat *)$tmp)->rderrmsg;"
		end

	c_newloc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct http_stat *)$tmp)->newloc;"
		end

	c_remote_time (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct http_stat *)$tmp)->remote_time;"
		end

	c_error (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct http_stat *)$tmp)->error;"
		end

	c_statcode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct http_stat *)$tmp)->statcode;"
		end

	c_message (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct http_stat *)$tmp)->message;"
		end

	c_rd_size (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct http_stat *)$tmp)->rd_size;"
		end

	c_dltime (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct http_stat *)$tmp)->dltime;"
		end

	c_referer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct http_stat *)$tmp)->referer;"
		end

	c_local_file (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct http_stat *)$tmp)->local_file;"
		end

	c_existence_checked (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct http_stat *)$tmp)->existence_checked;"
		end

	c_timestamp_checked (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct http_stat *)$tmp)->timestamp_checked;"
		end

	c_orig_file_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct http_stat *)$tmp)->orig_file_name;"
		end

	c_orig_file_size (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct http_stat *)$tmp)->orig_file_size;"
		end

	c_orig_file_tstamp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct http_stat *)$tmp)->orig_file_tstamp;"
		end

feature {NONE} -- C setters

	c_set_len (tmp: POINTER; a_len: INTEGER_64)
		external
			"C inline"
		alias
			"((struct http_stat *)$tmp)->len = $a_len;"
		end

	c_set_contlen (tmp: POINTER; a_contlen: INTEGER_64)
		external
			"C inline"
		alias
			"((struct http_stat *)$tmp)->contlen = $a_contlen;"
		end

	c_set_restval (tmp: POINTER; a_restval: INTEGER_64)
		external
			"C inline"
		alias
			"((struct http_stat *)$tmp)->restval = $a_restval;"
		end

	c_set_res (tmp: POINTER; a_res: INTEGER_32)
		external
			"C inline"
		alias
			"((struct http_stat *)$tmp)->res = $a_res;"
		end

	c_set_rderrmsg (tmp: POINTER; a_rderrmsg: POINTER)
		external
			"C inline"
		alias
			"((struct http_stat *)$tmp)->rderrmsg = (char *)$a_rderrmsg;"
		end

	c_set_newloc (tmp: POINTER; a_newloc: POINTER)
		external
			"C inline"
		alias
			"((struct http_stat *)$tmp)->newloc = (char *)$a_newloc;"
		end

	c_set_remote_time (tmp: POINTER; a_remote_time: POINTER)
		external
			"C inline"
		alias
			"((struct http_stat *)$tmp)->remote_time = (char *)$a_remote_time;"
		end

	c_set_error (tmp: POINTER; a_error: POINTER)
		external
			"C inline"
		alias
			"((struct http_stat *)$tmp)->error = (char *)$a_error;"
		end

	c_set_statcode (tmp: POINTER; a_statcode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct http_stat *)$tmp)->statcode = $a_statcode;"
		end

	c_set_message (tmp: POINTER; a_message: POINTER)
		external
			"C inline"
		alias
			"((struct http_stat *)$tmp)->message = (char *)$a_message;"
		end

	c_set_rd_size (tmp: POINTER; a_rd_size: INTEGER_64)
		external
			"C inline"
		alias
			"((struct http_stat *)$tmp)->rd_size = $a_rd_size;"
		end

	c_set_dltime (tmp: POINTER; a_dltime: REAL_64)
		external
			"C inline"
		alias
			"((struct http_stat *)$tmp)->dltime = $a_dltime;"
		end

	c_set_referer (tmp: POINTER; a_referer: POINTER)
		external
			"C inline"
		alias
			"((struct http_stat *)$tmp)->referer = (char const *)$a_referer;"
		end

	c_set_local_file (tmp: POINTER; a_local_file: POINTER)
		external
			"C inline"
		alias
			"((struct http_stat *)$tmp)->local_file = (char *)$a_local_file;"
		end

	c_set_existence_checked (tmp: POINTER; a_existence_checked: BOOLEAN)
		external
			"C inline"
		alias
			"((struct http_stat *)$tmp)->existence_checked = $a_existence_checked;"
		end

	c_set_timestamp_checked (tmp: POINTER; a_timestamp_checked: BOOLEAN)
		external
			"C inline"
		alias
			"((struct http_stat *)$tmp)->timestamp_checked = $a_timestamp_checked;"
		end

	c_set_orig_file_name (tmp: POINTER; a_orig_file_name: POINTER)
		external
			"C inline"
		alias
			"((struct http_stat *)$tmp)->orig_file_name = (char *)$a_orig_file_name;"
		end

	c_set_orig_file_size (tmp: POINTER; a_orig_file_size: INTEGER_64)
		external
			"C inline"
		alias
			"((struct http_stat *)$tmp)->orig_file_size = $a_orig_file_size;"
		end

	c_set_orig_file_tstamp (tmp: POINTER; a_orig_file_tstamp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct http_stat *)$tmp)->orig_file_tstamp = $a_orig_file_tstamp;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct http_stat);"
		end

end
