class
	PD_IRI

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	uri_encoding: CE_POINTER [INTEGER_8] assign set_uri_encoding
		do
			create Result.make_shared (c_uri_encoding (c_pointer))
		end

	content_encoding: CE_POINTER [INTEGER_8] assign set_content_encoding
		do
			create Result.make_shared (c_content_encoding (c_pointer))
		end

	orig_url: CE_POINTER [INTEGER_8] assign set_orig_url
		do
			create Result.make_shared (c_orig_url (c_pointer))
		end

	utf8_encode: BOOLEAN assign set_utf8_encode
		do
			Result := c_utf8_encode (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_uri_encoding (a_uri_encoding: CE_POINTER [INTEGER_8])
		do
			c_set_uri_encoding (c_pointer, a_uri_encoding.c_pointer)
		end

	set_content_encoding (a_content_encoding: CE_POINTER [INTEGER_8])
		do
			c_set_content_encoding (c_pointer, a_content_encoding.c_pointer)
		end

	set_orig_url (a_orig_url: CE_POINTER [INTEGER_8])
		do
			c_set_orig_url (c_pointer, a_orig_url.c_pointer)
		end

	set_utf8_encode (a_utf8_encode: BOOLEAN)
		do
			c_set_utf8_encode (c_pointer, a_utf8_encode)
		end

feature {NONE} -- C getters

	c_uri_encoding (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct iri *)$tmp)->uri_encoding;"
		end

	c_content_encoding (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct iri *)$tmp)->content_encoding;"
		end

	c_orig_url (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct iri *)$tmp)->orig_url;"
		end

	c_utf8_encode (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct iri *)$tmp)->utf8_encode;"
		end

feature {NONE} -- C setters

	c_set_uri_encoding (tmp: POINTER; a_uri_encoding: POINTER)
		external
			"C inline"
		alias
			"((struct iri *)$tmp)->uri_encoding = (char *)$a_uri_encoding;"
		end

	c_set_content_encoding (tmp: POINTER; a_content_encoding: POINTER)
		external
			"C inline"
		alias
			"((struct iri *)$tmp)->content_encoding = (char *)$a_content_encoding;"
		end

	c_set_orig_url (tmp: POINTER; a_orig_url: POINTER)
		external
			"C inline"
		alias
			"((struct iri *)$tmp)->orig_url = (char *)$a_orig_url;"
		end

	c_set_utf8_encode (tmp: POINTER; a_utf8_encode: BOOLEAN)
		external
			"C inline"
		alias
			"((struct iri *)$tmp)->utf8_encode = $a_utf8_encode;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct iri);"
		end

end
