class
	PD_LOG_LN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	static_line: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_static_line (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	malloced_line: CE_POINTER [INTEGER_8] assign set_malloced_line
		do
			create Result.make_shared (c_malloced_line (c_pointer))
		end

	content: CE_POINTER [INTEGER_8] assign set_content
		do
			create Result.make_shared (c_content (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_malloced_line (a_malloced_line: CE_POINTER [INTEGER_8])
		do
			c_set_malloced_line (c_pointer, a_malloced_line.c_pointer)
		end

	set_content (a_content: CE_POINTER [INTEGER_8])
		do
			c_set_content (c_pointer, a_content.c_pointer)
		end

feature {NONE} -- C getters

	c_static_line (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct log_ln *tmp = (struct log_ln *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->static_line) / sizeof(tmp->static_line[0]);
				return tmp->static_line;
			]"
		end

	c_malloced_line (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct log_ln *)$tmp)->malloced_line;"
		end

	c_content (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct log_ln *)$tmp)->content;"
		end

feature {NONE} -- C setters

	c_set_malloced_line (tmp: POINTER; a_malloced_line: POINTER)
		external
			"C inline"
		alias
			"((struct log_ln *)$tmp)->malloced_line = (char *)$a_malloced_line;"
		end

	c_set_content (tmp: POINTER; a_content: POINTER)
		external
			"C inline"
		alias
			"((struct log_ln *)$tmp)->content = (char *)$a_content;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct log_ln);"
		end

end
