class
	PD_MAP_CONTEXT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	text: CE_POINTER [INTEGER_8] assign set_text
		do
			create Result.make_shared (c_text (c_pointer))
		end

	base: CE_POINTER [INTEGER_8] assign set_base
		do
			create Result.make_shared (c_base (c_pointer))
		end

	parent_base: CE_POINTER [INTEGER_8] assign set_parent_base
		do
			create Result.make_shared (c_parent_base (c_pointer))
		end

	document_file: CE_POINTER [INTEGER_8] assign set_document_file
		do
			create Result.make_shared (c_document_file (c_pointer))
		end

	nofollow: BOOLEAN assign set_nofollow
		do
			Result := c_nofollow (c_pointer)
		end

	head: CE_POINTER [PD_URLPOS] assign set_head
		do
			create Result.make_shared (c_head (c_pointer))
		end

	tail: CE_POINTER [PD_URLPOS] assign set_tail
		do
			create Result.make_shared (c_tail (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_text (a_text: CE_POINTER [INTEGER_8])
		do
			c_set_text (c_pointer, a_text.c_pointer)
		end

	set_base (a_base: CE_POINTER [INTEGER_8])
		do
			c_set_base (c_pointer, a_base.c_pointer)
		end

	set_parent_base (a_parent_base: CE_POINTER [INTEGER_8])
		do
			c_set_parent_base (c_pointer, a_parent_base.c_pointer)
		end

	set_document_file (a_document_file: CE_POINTER [INTEGER_8])
		do
			c_set_document_file (c_pointer, a_document_file.c_pointer)
		end

	set_nofollow (a_nofollow: BOOLEAN)
		do
			c_set_nofollow (c_pointer, a_nofollow)
		end

	set_head (a_head: CE_POINTER [PD_URLPOS])
		do
			c_set_head (c_pointer, a_head.c_pointer)
		end

	set_tail (a_tail: CE_POINTER [PD_URLPOS])
		do
			c_set_tail (c_pointer, a_tail.c_pointer)
		end

feature {NONE} -- C getters

	c_text (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct map_context *)$tmp)->text;"
		end

	c_base (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct map_context *)$tmp)->base;"
		end

	c_parent_base (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct map_context *)$tmp)->parent_base;"
		end

	c_document_file (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct map_context *)$tmp)->document_file;"
		end

	c_nofollow (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct map_context *)$tmp)->nofollow;"
		end

	c_head (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct urlpos *)((struct map_context *)$tmp)->head;"
		end

	c_tail (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct urlpos *)((struct map_context *)$tmp)->tail;"
		end

feature {NONE} -- C setters

	c_set_text (tmp: POINTER; a_text: POINTER)
		external
			"C inline"
		alias
			"((struct map_context *)$tmp)->text = (char *)$a_text;"
		end

	c_set_base (tmp: POINTER; a_base: POINTER)
		external
			"C inline"
		alias
			"((struct map_context *)$tmp)->base = (char *)$a_base;"
		end

	c_set_parent_base (tmp: POINTER; a_parent_base: POINTER)
		external
			"C inline"
		alias
			"((struct map_context *)$tmp)->parent_base = (char const *)$a_parent_base;"
		end

	c_set_document_file (tmp: POINTER; a_document_file: POINTER)
		external
			"C inline"
		alias
			"((struct map_context *)$tmp)->document_file = (char const *)$a_document_file;"
		end

	c_set_nofollow (tmp: POINTER; a_nofollow: BOOLEAN)
		external
			"C inline"
		alias
			"((struct map_context *)$tmp)->nofollow = $a_nofollow;"
		end

	c_set_head (tmp: POINTER; a_head: POINTER)
		external
			"C inline"
		alias
			"((struct map_context *)$tmp)->head = (struct urlpos *)$a_head;"
		end

	c_set_tail (tmp: POINTER; a_tail: POINTER)
		external
			"C inline"
		alias
			"((struct map_context *)$tmp)->tail = (struct urlpos *)$a_tail;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct map_context);"
		end

end
