class
	PD_MD5_CTX

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	A: NATURAL_32 assign set_A
		do
			Result := c_A (c_pointer)
		end

	B: NATURAL_32 assign set_B
		do
			Result := c_B (c_pointer)
		end

	C: NATURAL_32 assign set_C
		do
			Result := c_C (c_pointer)
		end

	D: NATURAL_32 assign set_D
		do
			Result := c_D (c_pointer)
		end

	total: CE_ARRAY [NATURAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_total (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	buflen: NATURAL_32 assign set_buflen
		do
			Result := c_buflen (c_pointer)
		end

	buffer: CE_ARRAY [NATURAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_buffer (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_A (a_A: NATURAL_32)
		do
			c_set_A (c_pointer, a_A)
		end

	set_B (a_B: NATURAL_32)
		do
			c_set_B (c_pointer, a_B)
		end

	set_C (a_C: NATURAL_32)
		do
			c_set_C (c_pointer, a_C)
		end

	set_D (a_D: NATURAL_32)
		do
			c_set_D (c_pointer, a_D)
		end

	set_buflen (a_buflen: NATURAL_32)
		do
			c_set_buflen (c_pointer, a_buflen)
		end

feature {NONE} -- C getters

	c_A (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct md5_ctx *)$tmp)->A;"
		end

	c_B (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct md5_ctx *)$tmp)->B;"
		end

	c_C (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct md5_ctx *)$tmp)->C;"
		end

	c_D (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct md5_ctx *)$tmp)->D;"
		end

	c_total (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct md5_ctx *tmp = (struct md5_ctx *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->total) / sizeof(tmp->total[0]);
				return tmp->total;
			]"
		end

	c_buflen (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct md5_ctx *)$tmp)->buflen;"
		end

	c_buffer (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct md5_ctx *tmp = (struct md5_ctx *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->buffer) / sizeof(tmp->buffer[0]);
				return tmp->buffer;
			]"
		end

feature {NONE} -- C setters

	c_set_A (tmp: POINTER; a_A: NATURAL_32)
		external
			"C inline"
		alias
			"((struct md5_ctx *)$tmp)->A = $a_a;"
		end

	c_set_B (tmp: POINTER; a_B: NATURAL_32)
		external
			"C inline"
		alias
			"((struct md5_ctx *)$tmp)->B = $a_b;"
		end

	c_set_C (tmp: POINTER; a_C: NATURAL_32)
		external
			"C inline"
		alias
			"((struct md5_ctx *)$tmp)->C = $a_c;"
		end

	c_set_D (tmp: POINTER; a_D: NATURAL_32)
		external
			"C inline"
		alias
			"((struct md5_ctx *)$tmp)->D = $a_d;"
		end

	c_set_buflen (tmp: POINTER; a_buflen: NATURAL_32)
		external
			"C inline"
		alias
			"((struct md5_ctx *)$tmp)->buflen = $a_buflen;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct md5_ctx);"
		end

end
