class
	PD_PATH_INFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	path: CE_POINTER [INTEGER_8] assign set_path
		do
			create Result.make_shared (c_path (c_pointer))
		end

	allowedp: BOOLEAN assign set_allowedp
		do
			Result := c_allowedp (c_pointer)
		end

	user_agent_exact_p: BOOLEAN assign set_user_agent_exact_p
		do
			Result := c_user_agent_exact_p (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_path (a_path: CE_POINTER [INTEGER_8])
		do
			c_set_path (c_pointer, a_path.c_pointer)
		end

	set_allowedp (a_allowedp: BOOLEAN)
		do
			c_set_allowedp (c_pointer, a_allowedp)
		end

	set_user_agent_exact_p (a_user_agent_exact_p: BOOLEAN)
		do
			c_set_user_agent_exact_p (c_pointer, a_user_agent_exact_p)
		end

feature {NONE} -- C getters

	c_path (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct path_info *)$tmp)->path;"
		end

	c_allowedp (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct path_info *)$tmp)->allowedp;"
		end

	c_user_agent_exact_p (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct path_info *)$tmp)->user_agent_exact_p;"
		end

feature {NONE} -- C setters

	c_set_path (tmp: POINTER; a_path: POINTER)
		external
			"C inline"
		alias
			"((struct path_info *)$tmp)->path = (char *)$a_path;"
		end

	c_set_allowedp (tmp: POINTER; a_allowedp: BOOLEAN)
		external
			"C inline"
		alias
			"((struct path_info *)$tmp)->allowedp = $a_allowedp;"
		end

	c_set_user_agent_exact_p (tmp: POINTER; a_user_agent_exact_p: BOOLEAN)
		external
			"C inline"
		alias
			"((struct path_info *)$tmp)->user_agent_exact_p = $a_user_agent_exact_p;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct path_info);"
		end

end
