class
	PD_PCONN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	socket: INTEGER_32 assign set_socket
		do
			Result := c_socket (c_pointer)
		end

	host: CE_POINTER [INTEGER_8] assign set_host
		do
			create Result.make_shared (c_host (c_pointer))
		end

	port: INTEGER_32 assign set_port
		do
			Result := c_port (c_pointer)
		end

	ssl: BOOLEAN assign set_ssl
		do
			Result := c_ssl (c_pointer)
		end

	authorized: BOOLEAN assign set_authorized
		do
			Result := c_authorized (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_socket (a_socket: INTEGER_32)
		do
			c_set_socket (c_pointer, a_socket)
		end

	set_host (a_host: CE_POINTER [INTEGER_8])
		do
			c_set_host (c_pointer, a_host.c_pointer)
		end

	set_port (a_port: INTEGER_32)
		do
			c_set_port (c_pointer, a_port)
		end

	set_ssl (a_ssl: BOOLEAN)
		do
			c_set_ssl (c_pointer, a_ssl)
		end

	set_authorized (a_authorized: BOOLEAN)
		do
			c_set_authorized (c_pointer, a_authorized)
		end

feature {NONE} -- C getters

	c_socket (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_pconn_60 *)$tmp)->socket;"
		end

	c_host (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_pconn_60 *)$tmp)->host;"
		end

	c_port (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_pconn_60 *)$tmp)->port;"
		end

	c_ssl (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct __anonstruct_pconn_60 *)$tmp)->ssl;"
		end

	c_authorized (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct __anonstruct_pconn_60 *)$tmp)->authorized;"
		end

feature {NONE} -- C setters

	c_set_socket (tmp: POINTER; a_socket: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_pconn_60 *)$tmp)->socket = $a_socket;"
		end

	c_set_host (tmp: POINTER; a_host: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_pconn_60 *)$tmp)->host = (char *)$a_host;"
		end

	c_set_port (tmp: POINTER; a_port: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_pconn_60 *)$tmp)->port = $a_port;"
		end

	c_set_ssl (tmp: POINTER; a_ssl: BOOLEAN)
		external
			"C inline"
		alias
			"((struct __anonstruct_pconn_60 *)$tmp)->ssl = $a_ssl;"
		end

	c_set_authorized (tmp: POINTER; a_authorized: BOOLEAN)
		external
			"C inline"
		alias
			"((struct __anonstruct_pconn_60 *)$tmp)->authorized = $a_authorized;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct __anonstruct_pconn_60);"
		end

end
