class
	PD_POOL

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	contents: CE_POINTER [INTEGER_8] assign set_contents
		do
			create Result.make_shared (c_contents (c_pointer))
		end

	size: INTEGER_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	tail: INTEGER_32 assign set_tail
		do
			Result := c_tail (c_pointer)
		end

	resized: BOOLEAN assign set_resized
		do
			Result := c_resized (c_pointer)
		end

	orig_contents: CE_POINTER [INTEGER_8] assign set_orig_contents
		do
			create Result.make_shared (c_orig_contents (c_pointer))
		end

	orig_size: INTEGER_32 assign set_orig_size
		do
			Result := c_orig_size (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_contents (a_contents: CE_POINTER [INTEGER_8])
		do
			c_set_contents (c_pointer, a_contents.c_pointer)
		end

	set_size (a_size: INTEGER_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_tail (a_tail: INTEGER_32)
		do
			c_set_tail (c_pointer, a_tail)
		end

	set_resized (a_resized: BOOLEAN)
		do
			c_set_resized (c_pointer, a_resized)
		end

	set_orig_contents (a_orig_contents: CE_POINTER [INTEGER_8])
		do
			c_set_orig_contents (c_pointer, a_orig_contents.c_pointer)
		end

	set_orig_size (a_orig_size: INTEGER_32)
		do
			c_set_orig_size (c_pointer, a_orig_size)
		end

feature {NONE} -- C getters

	c_contents (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct pool *)$tmp)->contents;"
		end

	c_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct pool *)$tmp)->size;"
		end

	c_tail (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct pool *)$tmp)->tail;"
		end

	c_resized (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct pool *)$tmp)->resized;"
		end

	c_orig_contents (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct pool *)$tmp)->orig_contents;"
		end

	c_orig_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct pool *)$tmp)->orig_size;"
		end

feature {NONE} -- C setters

	c_set_contents (tmp: POINTER; a_contents: POINTER)
		external
			"C inline"
		alias
			"((struct pool *)$tmp)->contents = (char *)$a_contents;"
		end

	c_set_size (tmp: POINTER; a_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct pool *)$tmp)->size = $a_size;"
		end

	c_set_tail (tmp: POINTER; a_tail: INTEGER_32)
		external
			"C inline"
		alias
			"((struct pool *)$tmp)->tail = $a_tail;"
		end

	c_set_resized (tmp: POINTER; a_resized: BOOLEAN)
		external
			"C inline"
		alias
			"((struct pool *)$tmp)->resized = $a_resized;"
		end

	c_set_orig_contents (tmp: POINTER; a_orig_contents: POINTER)
		external
			"C inline"
		alias
			"((struct pool *)$tmp)->orig_contents = (char *)$a_orig_contents;"
		end

	c_set_orig_size (tmp: POINTER; a_orig_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct pool *)$tmp)->orig_size = $a_orig_size;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct pool);"
		end

end
