class
	PD_PROGRESS_IMPLEMENTATION

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	interactive: BOOLEAN assign set_interactive
		do
			Result := c_interactive (c_pointer)
		end

	create2: CE_ROUTINE assign set_create2
		do
			create Result.make_shared (c_create2 (c_pointer))
		end

	update: CE_ROUTINE assign set_update
		do
			create Result.make_shared (c_update (c_pointer))
		end

	finish: CE_ROUTINE assign set_finish
		do
			create Result.make_shared (c_finish (c_pointer))
		end

	set_params: CE_ROUTINE assign set_set_params
		do
			create Result.make_shared (c_set_params (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_interactive (a_interactive: BOOLEAN)
		do
			c_set_interactive (c_pointer, a_interactive)
		end

	set_create2 (a_create2: CE_ROUTINE)
		do
			c_set_create2 (c_pointer, a_create2.c_pointer)
		end

	set_update (a_update: CE_ROUTINE)
		do
			c_set_update (c_pointer, a_update.c_pointer)
		end

	set_finish (a_finish: CE_ROUTINE)
		do
			c_set_finish (c_pointer, a_finish.c_pointer)
		end

	set_set_params (a_set_params: CE_ROUTINE)
		do
			c_set_set_params (c_pointer, a_set_params.c_pointer)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct progress_implementation *)$tmp)->name;"
		end

	c_interactive (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct progress_implementation *)$tmp)->interactive;"
		end

	c_create2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *( *)(long long, long long))((struct progress_implementation *)$tmp)->create;"
		end

	c_update (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void *, long long, double))((struct progress_implementation *)$tmp)->update;"
		end

	c_finish (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void *, double))((struct progress_implementation *)$tmp)->finish;"
		end

	c_set_params (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(char *))((struct progress_implementation *)$tmp)->set_params;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct progress_implementation *)$tmp)->name = (char const *)$a_name;"
		end

	c_set_interactive (tmp: POINTER; a_interactive: BOOLEAN)
		external
			"C inline"
		alias
			"((struct progress_implementation *)$tmp)->interactive = $a_interactive;"
		end

	c_set_create2 (tmp: POINTER; a_create2: POINTER)
		external
			"C inline"
		alias
			"((struct progress_implementation *)$tmp)->create = (void *( *)(long long, long long))$a_create2;"
		end

	c_set_update (tmp: POINTER; a_update: POINTER)
		external
			"C inline"
		alias
			"((struct progress_implementation *)$tmp)->update = (void( *)(void *, long long, double))$a_update;"
		end

	c_set_finish (tmp: POINTER; a_finish: POINTER)
		external
			"C inline"
		alias
			"((struct progress_implementation *)$tmp)->finish = (void( *)(void *, double))$a_finish;"
		end

	c_set_set_params (tmp: POINTER; a_set_params: POINTER)
		external
			"C inline"
		alias
			"((struct progress_implementation *)$tmp)->set_params = (void( *)(char const *))$a_set_params;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct progress_implementation);"
		end

end
