class
	PD_PTIMER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	start: SD_TIMESPEC assign set_start
		do
			create Result.make_shared (c_start (c_pointer))
		end

	start_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct ptimer, start);"
		end

	elapsed_last: REAL_64 assign set_elapsed_last
		do
			Result := c_elapsed_last (c_pointer)
		end

	elapsed_pre_start: REAL_64 assign set_elapsed_pre_start
		do
			Result := c_elapsed_pre_start (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_start (a_start: SD_TIMESPEC)
		do
			start.ce_gets (a_start)
		end

	set_elapsed_last (a_elapsed_last: REAL_64)
		do
			c_set_elapsed_last (c_pointer, a_elapsed_last)
		end

	set_elapsed_pre_start (a_elapsed_pre_start: REAL_64)
		do
			c_set_elapsed_pre_start (c_pointer, a_elapsed_pre_start)
		end

feature {NONE} -- C getters

	c_start (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct timespec *)&((struct ptimer *)$tmp)->start;"
		end

	c_elapsed_last (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct ptimer *)$tmp)->elapsed_last;"
		end

	c_elapsed_pre_start (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct ptimer *)$tmp)->elapsed_pre_start;"
		end

feature {NONE} -- C setters

	c_set_elapsed_last (tmp: POINTER; a_elapsed_last: REAL_64)
		external
			"C inline"
		alias
			"((struct ptimer *)$tmp)->elapsed_last = $a_elapsed_last;"
		end

	c_set_elapsed_pre_start (tmp: POINTER; a_elapsed_pre_start: REAL_64)
		external
			"C inline"
		alias
			"((struct ptimer *)$tmp)->elapsed_pre_start = $a_elapsed_pre_start;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct ptimer);"
		end

end
