class
	PD_QUEUE_ELEMENT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	url: CE_POINTER [INTEGER_8] assign set_url
		do
			create Result.make_shared (c_url (c_pointer))
		end

	referer: CE_POINTER [INTEGER_8] assign set_referer
		do
			create Result.make_shared (c_referer (c_pointer))
		end

	depth: INTEGER_32 assign set_depth
		do
			Result := c_depth (c_pointer)
		end

	html_allowed: BOOLEAN assign set_html_allowed
		do
			Result := c_html_allowed (c_pointer)
		end

	iri: CE_POINTER [PD_IRI] assign set_iri
		do
			create Result.make_shared (c_iri (c_pointer))
		end

	css_allowed: BOOLEAN assign set_css_allowed
		do
			Result := c_css_allowed (c_pointer)
		end

	next: CE_POINTER [PD_QUEUE_ELEMENT] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_url (a_url: CE_POINTER [INTEGER_8])
		do
			c_set_url (c_pointer, a_url.c_pointer)
		end

	set_referer (a_referer: CE_POINTER [INTEGER_8])
		do
			c_set_referer (c_pointer, a_referer.c_pointer)
		end

	set_depth (a_depth: INTEGER_32)
		do
			c_set_depth (c_pointer, a_depth)
		end

	set_html_allowed (a_html_allowed: BOOLEAN)
		do
			c_set_html_allowed (c_pointer, a_html_allowed)
		end

	set_iri (a_iri: CE_POINTER [PD_IRI])
		do
			c_set_iri (c_pointer, a_iri.c_pointer)
		end

	set_css_allowed (a_css_allowed: BOOLEAN)
		do
			c_set_css_allowed (c_pointer, a_css_allowed)
		end

	set_next (a_next: CE_POINTER [PD_QUEUE_ELEMENT])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

feature {NONE} -- C getters

	c_url (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct queue_element *)$tmp)->url;"
		end

	c_referer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct queue_element *)$tmp)->referer;"
		end

	c_depth (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct queue_element *)$tmp)->depth;"
		end

	c_html_allowed (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct queue_element *)$tmp)->html_allowed;"
		end

	c_iri (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct iri *)((struct queue_element *)$tmp)->iri;"
		end

	c_css_allowed (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct queue_element *)$tmp)->css_allowed;"
		end

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct queue_element *)((struct queue_element *)$tmp)->next;"
		end

feature {NONE} -- C setters

	c_set_url (tmp: POINTER; a_url: POINTER)
		external
			"C inline"
		alias
			"((struct queue_element *)$tmp)->url = (char const *)$a_url;"
		end

	c_set_referer (tmp: POINTER; a_referer: POINTER)
		external
			"C inline"
		alias
			"((struct queue_element *)$tmp)->referer = (char const *)$a_referer;"
		end

	c_set_depth (tmp: POINTER; a_depth: INTEGER_32)
		external
			"C inline"
		alias
			"((struct queue_element *)$tmp)->depth = $a_depth;"
		end

	c_set_html_allowed (tmp: POINTER; a_html_allowed: BOOLEAN)
		external
			"C inline"
		alias
			"((struct queue_element *)$tmp)->html_allowed = $a_html_allowed;"
		end

	c_set_iri (tmp: POINTER; a_iri: POINTER)
		external
			"C inline"
		alias
			"((struct queue_element *)$tmp)->iri = (struct iri *)$a_iri;"
		end

	c_set_css_allowed (tmp: POINTER; a_css_allowed: BOOLEAN)
		external
			"C inline"
		alias
			"((struct queue_element *)$tmp)->css_allowed = $a_css_allowed;"
		end

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct queue_element *)$tmp)->next = (struct queue_element *)$a_next;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct queue_element);"
		end

end
