class
	PD_QUOTING_OPTIONS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	style: INTEGER_32 assign set_style
		do
			Result := c_style (c_pointer)
		end

	flags: INTEGER_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	quote_these_too: CE_ARRAY [NATURAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_quote_these_too (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	left_quote: CE_POINTER [INTEGER_8] assign set_left_quote
		do
			create Result.make_shared (c_left_quote (c_pointer))
		end

	right_quote: CE_POINTER [INTEGER_8] assign set_right_quote
		do
			create Result.make_shared (c_right_quote (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_style (a_style: INTEGER_32)
		do
			c_set_style (c_pointer, a_style)
		end

	set_flags (a_flags: INTEGER_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

	set_left_quote (a_left_quote: CE_POINTER [INTEGER_8])
		do
			c_set_left_quote (c_pointer, a_left_quote.c_pointer)
		end

	set_right_quote (a_right_quote: CE_POINTER [INTEGER_8])
		do
			c_set_right_quote (c_pointer, a_right_quote.c_pointer)
		end

feature {NONE} -- C getters

	c_style (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct quoting_options *)$tmp)->style;"
		end

	c_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct quoting_options *)$tmp)->flags;"
		end

	c_quote_these_too (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct quoting_options *tmp = (struct quoting_options *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->quote_these_too) / sizeof(tmp->quote_these_too[0]);
				return tmp->quote_these_too;
			]"
		end

	c_left_quote (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct quoting_options *)$tmp)->left_quote;"
		end

	c_right_quote (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct quoting_options *)$tmp)->right_quote;"
		end

feature {NONE} -- C setters

	c_set_style (tmp: POINTER; a_style: INTEGER_32)
		external
			"C inline"
		alias
			"((struct quoting_options *)$tmp)->style = $a_style;"
		end

	c_set_flags (tmp: POINTER; a_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct quoting_options *)$tmp)->flags = $a_flags;"
		end

	c_set_left_quote (tmp: POINTER; a_left_quote: POINTER)
		external
			"C inline"
		alias
			"((struct quoting_options *)$tmp)->left_quote = (char const *)$a_left_quote;"
		end

	c_set_right_quote (tmp: POINTER; a_right_quote: POINTER)
		external
			"C inline"
		alias
			"((struct quoting_options *)$tmp)->right_quote = (char const *)$a_right_quote;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct quoting_options);"
		end

end
