class
	PD_REQUEST

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	method: CE_POINTER [INTEGER_8] assign set_method
		do
			create Result.make_shared (c_method (c_pointer))
		end

	arg: CE_POINTER [INTEGER_8] assign set_arg
		do
			create Result.make_shared (c_arg (c_pointer))
		end

	headers: CE_POINTER [PD_REQUEST_HEADER] assign set_headers
		do
			create Result.make_shared (c_headers (c_pointer))
		end

	hcount: INTEGER_32 assign set_hcount
		do
			Result := c_hcount (c_pointer)
		end

	hcapacity: INTEGER_32 assign set_hcapacity
		do
			Result := c_hcapacity (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_method (a_method: CE_POINTER [INTEGER_8])
		do
			c_set_method (c_pointer, a_method.c_pointer)
		end

	set_arg (a_arg: CE_POINTER [INTEGER_8])
		do
			c_set_arg (c_pointer, a_arg.c_pointer)
		end

	set_headers (a_headers: CE_POINTER [PD_REQUEST_HEADER])
		do
			c_set_headers (c_pointer, a_headers.c_pointer)
		end

	set_hcount (a_hcount: INTEGER_32)
		do
			c_set_hcount (c_pointer, a_hcount)
		end

	set_hcapacity (a_hcapacity: INTEGER_32)
		do
			c_set_hcapacity (c_pointer, a_hcapacity)
		end

feature {NONE} -- C getters

	c_method (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct request *)$tmp)->method;"
		end

	c_arg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct request *)$tmp)->arg;"
		end

	c_headers (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct request_header *)((struct request *)$tmp)->headers;"
		end

	c_hcount (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct request *)$tmp)->hcount;"
		end

	c_hcapacity (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct request *)$tmp)->hcapacity;"
		end

feature {NONE} -- C setters

	c_set_method (tmp: POINTER; a_method: POINTER)
		external
			"C inline"
		alias
			"((struct request *)$tmp)->method = (char const *)$a_method;"
		end

	c_set_arg (tmp: POINTER; a_arg: POINTER)
		external
			"C inline"
		alias
			"((struct request *)$tmp)->arg = (char *)$a_arg;"
		end

	c_set_headers (tmp: POINTER; a_headers: POINTER)
		external
			"C inline"
		alias
			"((struct request *)$tmp)->headers = (struct request_header *)$a_headers;"
		end

	c_set_hcount (tmp: POINTER; a_hcount: INTEGER_32)
		external
			"C inline"
		alias
			"((struct request *)$tmp)->hcount = $a_hcount;"
		end

	c_set_hcapacity (tmp: POINTER; a_hcapacity: INTEGER_32)
		external
			"C inline"
		alias
			"((struct request *)$tmp)->hcapacity = $a_hcapacity;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct request);"
		end

end
