class
	PD_REQUEST_HEADER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	value: CE_POINTER [INTEGER_8] assign set_value
		do
			create Result.make_shared (c_value (c_pointer))
		end

	release_policy: INTEGER_32 assign set_release_policy
		do
			Result := c_release_policy (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_value (a_value: CE_POINTER [INTEGER_8])
		do
			c_set_value (c_pointer, a_value.c_pointer)
		end

	set_release_policy (a_release_policy: INTEGER_32)
		do
			c_set_release_policy (c_pointer, a_release_policy)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct request_header *)$tmp)->name;"
		end

	c_value (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct request_header *)$tmp)->value;"
		end

	c_release_policy (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct request_header *)$tmp)->release_policy;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct request_header *)$tmp)->name = (char *)$a_name;"
		end

	c_set_value (tmp: POINTER; a_value: POINTER)
		external
			"C inline"
		alias
			"((struct request_header *)$tmp)->value = (char *)$a_value;"
		end

	c_set_release_policy (tmp: POINTER; a_release_policy: INTEGER_32)
		external
			"C inline"
		alias
			"((struct request_header *)$tmp)->release_policy = $a_release_policy;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct request_header);"
		end

end
