class
	PD_RESPONSE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	data: CE_POINTER [INTEGER_8] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	headers: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_headers
		do
			create Result.make_shared (c_headers (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_data (a_data: CE_POINTER [INTEGER_8])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_headers (a_headers: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			c_set_headers (c_pointer, a_headers.c_pointer)
		end

feature {NONE} -- C getters

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct response *)$tmp)->data;"
		end

	c_headers (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char * *)((struct response *)$tmp)->headers;"
		end

feature {NONE} -- C setters

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct response *)$tmp)->data = (char const *)$a_data;"
		end

	c_set_headers (tmp: POINTER; a_headers: POINTER)
		external
			"C inline"
		alias
			"((struct response *)$tmp)->headers = (char const * *)$a_headers;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct response);"
		end

end
