class
	PD_RINGEL

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	buffer: CE_POINTER [INTEGER_8] assign set_buffer
		do
			create Result.make_shared (c_buffer (c_pointer))
		end

	size: INTEGER_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_buffer (a_buffer: CE_POINTER [INTEGER_8])
		do
			c_set_buffer (c_pointer, a_buffer.c_pointer)
		end

	set_size (a_size: INTEGER_32)
		do
			c_set_size (c_pointer, a_size)
		end

feature {NONE} -- C getters

	c_buffer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct ringel *)$tmp)->buffer;"
		end

	c_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ringel *)$tmp)->size;"
		end

feature {NONE} -- C setters

	c_set_buffer (tmp: POINTER; a_buffer: POINTER)
		external
			"C inline"
		alias
			"((struct ringel *)$tmp)->buffer = (char *)$a_buffer;"
		end

	c_set_size (tmp: POINTER; a_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ringel *)$tmp)->size = $a_size;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct ringel);"
		end

end
