class
	PD_ROBOT_SPECS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	count: INTEGER_32 assign set_count
		do
			Result := c_count (c_pointer)
		end

	size: INTEGER_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	paths: CE_POINTER [PD_PATH_INFO] assign set_paths
		do
			create Result.make_shared (c_paths (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_count (a_count: INTEGER_32)
		do
			c_set_count (c_pointer, a_count)
		end

	set_size (a_size: INTEGER_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_paths (a_paths: CE_POINTER [PD_PATH_INFO])
		do
			c_set_paths (c_pointer, a_paths.c_pointer)
		end

feature {NONE} -- C getters

	c_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct robot_specs *)$tmp)->count;"
		end

	c_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct robot_specs *)$tmp)->size;"
		end

	c_paths (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct path_info *)((struct robot_specs *)$tmp)->paths;"
		end

feature {NONE} -- C setters

	c_set_count (tmp: POINTER; a_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct robot_specs *)$tmp)->count = $a_count;"
		end

	c_set_size (tmp: POINTER; a_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct robot_specs *)$tmp)->size = $a_size;"
		end

	c_set_paths (tmp: POINTER; a_paths: POINTER)
		external
			"C inline"
		alias
			"((struct robot_specs *)$tmp)->paths = (struct path_info *)$a_paths;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct robot_specs);"
		end

end
