class
	PD_SCHEME_DATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	leading_string: CE_POINTER [INTEGER_8] assign set_leading_string
		do
			create Result.make_shared (c_leading_string (c_pointer))
		end

	default_port: INTEGER_32 assign set_default_port
		do
			Result := c_default_port (c_pointer)
		end

	flags: INTEGER_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_leading_string (a_leading_string: CE_POINTER [INTEGER_8])
		do
			c_set_leading_string (c_pointer, a_leading_string.c_pointer)
		end

	set_default_port (a_default_port: INTEGER_32)
		do
			c_set_default_port (c_pointer, a_default_port)
		end

	set_flags (a_flags: INTEGER_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct scheme_data *)$tmp)->name;"
		end

	c_leading_string (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct scheme_data *)$tmp)->leading_string;"
		end

	c_default_port (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct scheme_data *)$tmp)->default_port;"
		end

	c_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct scheme_data *)$tmp)->flags;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct scheme_data *)$tmp)->name = (char const *)$a_name;"
		end

	c_set_leading_string (tmp: POINTER; a_leading_string: POINTER)
		external
			"C inline"
		alias
			"((struct scheme_data *)$tmp)->leading_string = (char const *)$a_leading_string;"
		end

	c_set_default_port (tmp: POINTER; a_default_port: INTEGER_32)
		external
			"C inline"
		alias
			"((struct scheme_data *)$tmp)->default_port = $a_default_port;"
		end

	c_set_flags (tmp: POINTER; a_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct scheme_data *)$tmp)->flags = $a_flags;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct scheme_data);"
		end

end
