class
	PD_SLOTVEC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	val: CE_POINTER [INTEGER_8] assign set_val
		do
			create Result.make_shared (c_val (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_val (a_val: CE_POINTER [INTEGER_8])
		do
			c_set_val (c_pointer, a_val.c_pointer)
		end

feature {NONE} -- C getters

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct slotvec *)$tmp)->size;"
		end

	c_val (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct slotvec *)$tmp)->val;"
		end

feature {NONE} -- C setters

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct slotvec *)$tmp)->size = $a_size;"
		end

	c_set_val (tmp: POINTER; a_val: POINTER)
		external
			"C inline"
		alias
			"((struct slotvec *)$tmp)->val = (char *)$a_val;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct slotvec);"
		end

end
