class
	PD_TAGINFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	end_tag_p: INTEGER_32 assign set_end_tag_p
		do
			Result := c_end_tag_p (c_pointer)
		end

	nattrs: INTEGER_32 assign set_nattrs
		do
			Result := c_nattrs (c_pointer)
		end

	attrs: CE_POINTER [PD_ATTR_PAIR] assign set_attrs
		do
			create Result.make_shared (c_attrs (c_pointer))
		end

	start_position: CE_POINTER [INTEGER_8] assign set_start_position
		do
			create Result.make_shared (c_start_position (c_pointer))
		end

	end_position: CE_POINTER [INTEGER_8] assign set_end_position
		do
			create Result.make_shared (c_end_position (c_pointer))
		end

	contents_begin: CE_POINTER [INTEGER_8] assign set_contents_begin
		do
			create Result.make_shared (c_contents_begin (c_pointer))
		end

	contents_end: CE_POINTER [INTEGER_8] assign set_contents_end
		do
			create Result.make_shared (c_contents_end (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_end_tag_p (a_end_tag_p: INTEGER_32)
		do
			c_set_end_tag_p (c_pointer, a_end_tag_p)
		end

	set_nattrs (a_nattrs: INTEGER_32)
		do
			c_set_nattrs (c_pointer, a_nattrs)
		end

	set_attrs (a_attrs: CE_POINTER [PD_ATTR_PAIR])
		do
			c_set_attrs (c_pointer, a_attrs.c_pointer)
		end

	set_start_position (a_start_position: CE_POINTER [INTEGER_8])
		do
			c_set_start_position (c_pointer, a_start_position.c_pointer)
		end

	set_end_position (a_end_position: CE_POINTER [INTEGER_8])
		do
			c_set_end_position (c_pointer, a_end_position.c_pointer)
		end

	set_contents_begin (a_contents_begin: CE_POINTER [INTEGER_8])
		do
			c_set_contents_begin (c_pointer, a_contents_begin.c_pointer)
		end

	set_contents_end (a_contents_end: CE_POINTER [INTEGER_8])
		do
			c_set_contents_end (c_pointer, a_contents_end.c_pointer)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct taginfo *)$tmp)->name;"
		end

	c_end_tag_p (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct taginfo *)$tmp)->end_tag_p;"
		end

	c_nattrs (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct taginfo *)$tmp)->nattrs;"
		end

	c_attrs (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct attr_pair *)((struct taginfo *)$tmp)->attrs;"
		end

	c_start_position (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct taginfo *)$tmp)->start_position;"
		end

	c_end_position (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct taginfo *)$tmp)->end_position;"
		end

	c_contents_begin (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct taginfo *)$tmp)->contents_begin;"
		end

	c_contents_end (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct taginfo *)$tmp)->contents_end;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct taginfo *)$tmp)->name = (char *)$a_name;"
		end

	c_set_end_tag_p (tmp: POINTER; a_end_tag_p: INTEGER_32)
		external
			"C inline"
		alias
			"((struct taginfo *)$tmp)->end_tag_p = $a_end_tag_p;"
		end

	c_set_nattrs (tmp: POINTER; a_nattrs: INTEGER_32)
		external
			"C inline"
		alias
			"((struct taginfo *)$tmp)->nattrs = $a_nattrs;"
		end

	c_set_attrs (tmp: POINTER; a_attrs: POINTER)
		external
			"C inline"
		alias
			"((struct taginfo *)$tmp)->attrs = (struct attr_pair *)$a_attrs;"
		end

	c_set_start_position (tmp: POINTER; a_start_position: POINTER)
		external
			"C inline"
		alias
			"((struct taginfo *)$tmp)->start_position = (char const *)$a_start_position;"
		end

	c_set_end_position (tmp: POINTER; a_end_position: POINTER)
		external
			"C inline"
		alias
			"((struct taginfo *)$tmp)->end_position = (char const *)$a_end_position;"
		end

	c_set_contents_begin (tmp: POINTER; a_contents_begin: POINTER)
		external
			"C inline"
		alias
			"((struct taginfo *)$tmp)->contents_begin = (char const *)$a_contents_begin;"
		end

	c_set_contents_end (tmp: POINTER; a_contents_end: POINTER)
		external
			"C inline"
		alias
			"((struct taginfo *)$tmp)->contents_end = (char const *)$a_contents_end;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct taginfo);"
		end

end
