class
	PD_TRANSPORT_IMPLEMENTATION

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	reader: CE_ROUTINE assign set_reader
		do
			create Result.make_shared (c_reader (c_pointer))
		end

	writer: CE_ROUTINE assign set_writer
		do
			create Result.make_shared (c_writer (c_pointer))
		end

	poller: CE_ROUTINE assign set_poller
		do
			create Result.make_shared (c_poller (c_pointer))
		end

	peeker: CE_ROUTINE assign set_peeker
		do
			create Result.make_shared (c_peeker (c_pointer))
		end

	errstr: CE_ROUTINE assign set_errstr
		do
			create Result.make_shared (c_errstr (c_pointer))
		end

	closer: CE_ROUTINE assign set_closer
		do
			create Result.make_shared (c_closer (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_reader (a_reader: CE_ROUTINE)
		do
			c_set_reader (c_pointer, a_reader.c_pointer)
		end

	set_writer (a_writer: CE_ROUTINE)
		do
			c_set_writer (c_pointer, a_writer.c_pointer)
		end

	set_poller (a_poller: CE_ROUTINE)
		do
			c_set_poller (c_pointer, a_poller.c_pointer)
		end

	set_peeker (a_peeker: CE_ROUTINE)
		do
			c_set_peeker (c_pointer, a_peeker.c_pointer)
		end

	set_errstr (a_errstr: CE_ROUTINE)
		do
			c_set_errstr (c_pointer, a_errstr.c_pointer)
		end

	set_closer (a_closer: CE_ROUTINE)
		do
			c_set_closer (c_pointer, a_closer.c_pointer)
		end

feature {NONE} -- C getters

	c_reader (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(int, char *, int, void *))((struct transport_implementation *)$tmp)->reader;"
		end

	c_writer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(int, char *, int, void *))((struct transport_implementation *)$tmp)->writer;"
		end

	c_poller (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(int, double, int, void *))((struct transport_implementation *)$tmp)->poller;"
		end

	c_peeker (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(int, char *, int, void *))((struct transport_implementation *)$tmp)->peeker;"
		end

	c_errstr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *( *)(int, void *))((struct transport_implementation *)$tmp)->errstr;"
		end

	c_closer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(int, void *))((struct transport_implementation *)$tmp)->closer;"
		end

feature {NONE} -- C setters

	c_set_reader (tmp: POINTER; a_reader: POINTER)
		external
			"C inline"
		alias
			"((struct transport_implementation *)$tmp)->reader = (int( *)(int, char *, int, void *))$a_reader;"
		end

	c_set_writer (tmp: POINTER; a_writer: POINTER)
		external
			"C inline"
		alias
			"((struct transport_implementation *)$tmp)->writer = (int( *)(int, char *, int, void *))$a_writer;"
		end

	c_set_poller (tmp: POINTER; a_poller: POINTER)
		external
			"C inline"
		alias
			"((struct transport_implementation *)$tmp)->poller = (int( *)(int, double, int, void *))$a_poller;"
		end

	c_set_peeker (tmp: POINTER; a_peeker: POINTER)
		external
			"C inline"
		alias
			"((struct transport_implementation *)$tmp)->peeker = (int( *)(int, char *, int, void *))$a_peeker;"
		end

	c_set_errstr (tmp: POINTER; a_errstr: POINTER)
		external
			"C inline"
		alias
			"((struct transport_implementation *)$tmp)->errstr = (char const *( *)(int, void *))$a_errstr;"
		end

	c_set_closer (tmp: POINTER; a_closer: POINTER)
		external
			"C inline"
		alias
			"((struct transport_implementation *)$tmp)->closer = (void( *)(int, void *))$a_closer;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct transport_implementation);"
		end

end
