class
	PD_TRANSPORT_INFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	imp: CE_POINTER [PD_TRANSPORT_IMPLEMENTATION] assign set_imp
		do
			create Result.make_shared (c_imp (c_pointer))
		end

	ctx: CE_POINTER [ANY] assign set_ctx
		do
			create Result.make_shared (c_ctx (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_imp (a_imp: CE_POINTER [PD_TRANSPORT_IMPLEMENTATION])
		do
			c_set_imp (c_pointer, a_imp.c_pointer)
		end

	set_ctx (a_ctx: CE_POINTER [ANY])
		do
			c_set_ctx (c_pointer, a_ctx.c_pointer)
		end

feature {NONE} -- C getters

	c_imp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct transport_implementation *)((struct transport_info *)$tmp)->imp;"
		end

	c_ctx (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct transport_info *)$tmp)->ctx;"
		end

feature {NONE} -- C setters

	c_set_imp (tmp: POINTER; a_imp: POINTER)
		external
			"C inline"
		alias
			"((struct transport_info *)$tmp)->imp = (struct transport_implementation *)$a_imp;"
		end

	c_set_ctx (tmp: POINTER; a_ctx: POINTER)
		external
			"C inline"
		alias
			"((struct transport_info *)$tmp)->ctx = (void *)$a_ctx;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct transport_info);"
		end

end
