class
	PD_URL

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	url: CE_POINTER [INTEGER_8] assign set_url
		do
			create Result.make_shared (c_url (c_pointer))
		end

	scheme: INTEGER_32 assign set_scheme
		do
			Result := c_scheme (c_pointer)
		end

	host: CE_POINTER [INTEGER_8] assign set_host
		do
			create Result.make_shared (c_host (c_pointer))
		end

	port: INTEGER_32 assign set_port
		do
			Result := c_port (c_pointer)
		end

	path: CE_POINTER [INTEGER_8] assign set_path
		do
			create Result.make_shared (c_path (c_pointer))
		end

	params: CE_POINTER [INTEGER_8] assign set_params
		do
			create Result.make_shared (c_params (c_pointer))
		end

	query: CE_POINTER [INTEGER_8] assign set_query
		do
			create Result.make_shared (c_query (c_pointer))
		end

	fragment: CE_POINTER [INTEGER_8] assign set_fragment
		do
			create Result.make_shared (c_fragment (c_pointer))
		end

	dir: CE_POINTER [INTEGER_8] assign set_dir
		do
			create Result.make_shared (c_dir (c_pointer))
		end

	dir_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct url, dir);"
		end

	file: CE_POINTER [INTEGER_8] assign set_file
		do
			create Result.make_shared (c_file (c_pointer))
		end

	file_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct url, file);"
		end

	user: CE_POINTER [INTEGER_8] assign set_user
		do
			create Result.make_shared (c_user (c_pointer))
		end

	passwd: CE_POINTER [INTEGER_8] assign set_passwd
		do
			create Result.make_shared (c_passwd (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_url (a_url: CE_POINTER [INTEGER_8])
		do
			c_set_url (c_pointer, a_url.c_pointer)
		end

	set_scheme (a_scheme: INTEGER_32)
		do
			c_set_scheme (c_pointer, a_scheme)
		end

	set_host (a_host: CE_POINTER [INTEGER_8])
		do
			c_set_host (c_pointer, a_host.c_pointer)
		end

	set_port (a_port: INTEGER_32)
		do
			c_set_port (c_pointer, a_port)
		end

	set_path (a_path: CE_POINTER [INTEGER_8])
		do
			c_set_path (c_pointer, a_path.c_pointer)
		end

	set_params (a_params: CE_POINTER [INTEGER_8])
		do
			c_set_params (c_pointer, a_params.c_pointer)
		end

	set_query (a_query: CE_POINTER [INTEGER_8])
		do
			c_set_query (c_pointer, a_query.c_pointer)
		end

	set_fragment (a_fragment: CE_POINTER [INTEGER_8])
		do
			c_set_fragment (c_pointer, a_fragment.c_pointer)
		end

	set_dir (a_dir: CE_POINTER [INTEGER_8])
		do
			c_set_dir (c_pointer, a_dir.c_pointer)
		end

	set_file (a_file: CE_POINTER [INTEGER_8])
		do
			c_set_file (c_pointer, a_file.c_pointer)
		end

	set_user (a_user: CE_POINTER [INTEGER_8])
		do
			c_set_user (c_pointer, a_user.c_pointer)
		end

	set_passwd (a_passwd: CE_POINTER [INTEGER_8])
		do
			c_set_passwd (c_pointer, a_passwd.c_pointer)
		end

feature {NONE} -- C getters

	c_url (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct url *)$tmp)->url;"
		end

	c_scheme (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct url *)$tmp)->scheme;"
		end

	c_host (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct url *)$tmp)->host;"
		end

	c_port (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct url *)$tmp)->port;"
		end

	c_path (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct url *)$tmp)->path;"
		end

	c_params (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct url *)$tmp)->params;"
		end

	c_query (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct url *)$tmp)->query;"
		end

	c_fragment (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct url *)$tmp)->fragment;"
		end

	c_dir (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct url *)$tmp)->dir;"
		end

	c_file (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct url *)$tmp)->file;"
		end

	c_user (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct url *)$tmp)->user;"
		end

	c_passwd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct url *)$tmp)->passwd;"
		end

feature {NONE} -- C setters

	c_set_url (tmp: POINTER; a_url: POINTER)
		external
			"C inline"
		alias
			"((struct url *)$tmp)->url = (char *)$a_url;"
		end

	c_set_scheme (tmp: POINTER; a_scheme: INTEGER_32)
		external
			"C inline"
		alias
			"((struct url *)$tmp)->scheme = $a_scheme;"
		end

	c_set_host (tmp: POINTER; a_host: POINTER)
		external
			"C inline"
		alias
			"((struct url *)$tmp)->host = (char *)$a_host;"
		end

	c_set_port (tmp: POINTER; a_port: INTEGER_32)
		external
			"C inline"
		alias
			"((struct url *)$tmp)->port = $a_port;"
		end

	c_set_path (tmp: POINTER; a_path: POINTER)
		external
			"C inline"
		alias
			"((struct url *)$tmp)->path = (char *)$a_path;"
		end

	c_set_params (tmp: POINTER; a_params: POINTER)
		external
			"C inline"
		alias
			"((struct url *)$tmp)->params = (char *)$a_params;"
		end

	c_set_query (tmp: POINTER; a_query: POINTER)
		external
			"C inline"
		alias
			"((struct url *)$tmp)->query = (char *)$a_query;"
		end

	c_set_fragment (tmp: POINTER; a_fragment: POINTER)
		external
			"C inline"
		alias
			"((struct url *)$tmp)->fragment = (char *)$a_fragment;"
		end

	c_set_dir (tmp: POINTER; a_dir: POINTER)
		external
			"C inline"
		alias
			"((struct url *)$tmp)->dir = (char *)$a_dir;"
		end

	c_set_file (tmp: POINTER; a_file: POINTER)
		external
			"C inline"
		alias
			"((struct url *)$tmp)->file = (char *)$a_file;"
		end

	c_set_user (tmp: POINTER; a_user: POINTER)
		external
			"C inline"
		alias
			"((struct url *)$tmp)->user = (char *)$a_user;"
		end

	c_set_passwd (tmp: POINTER; a_passwd: POINTER)
		external
			"C inline"
		alias
			"((struct url *)$tmp)->passwd = (char *)$a_passwd;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct url);"
		end

end
