class
	PD_URL_QUEUE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	head: CE_POINTER [PD_QUEUE_ELEMENT] assign set_head
		do
			create Result.make_shared (c_head (c_pointer))
		end

	tail: CE_POINTER [PD_QUEUE_ELEMENT] assign set_tail
		do
			create Result.make_shared (c_tail (c_pointer))
		end

	count: INTEGER_32 assign set_count
		do
			Result := c_count (c_pointer)
		end

	maxcount: INTEGER_32 assign set_maxcount
		do
			Result := c_maxcount (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_head (a_head: CE_POINTER [PD_QUEUE_ELEMENT])
		do
			c_set_head (c_pointer, a_head.c_pointer)
		end

	set_tail (a_tail: CE_POINTER [PD_QUEUE_ELEMENT])
		do
			c_set_tail (c_pointer, a_tail.c_pointer)
		end

	set_count (a_count: INTEGER_32)
		do
			c_set_count (c_pointer, a_count)
		end

	set_maxcount (a_maxcount: INTEGER_32)
		do
			c_set_maxcount (c_pointer, a_maxcount)
		end

feature {NONE} -- C getters

	c_head (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct queue_element *)((struct url_queue *)$tmp)->head;"
		end

	c_tail (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct queue_element *)((struct url_queue *)$tmp)->tail;"
		end

	c_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct url_queue *)$tmp)->count;"
		end

	c_maxcount (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct url_queue *)$tmp)->maxcount;"
		end

feature {NONE} -- C setters

	c_set_head (tmp: POINTER; a_head: POINTER)
		external
			"C inline"
		alias
			"((struct url_queue *)$tmp)->head = (struct queue_element *)$a_head;"
		end

	c_set_tail (tmp: POINTER; a_tail: POINTER)
		external
			"C inline"
		alias
			"((struct url_queue *)$tmp)->tail = (struct queue_element *)$a_tail;"
		end

	c_set_count (tmp: POINTER; a_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct url_queue *)$tmp)->count = $a_count;"
		end

	c_set_maxcount (tmp: POINTER; a_maxcount: INTEGER_32)
		external
			"C inline"
		alias
			"((struct url_queue *)$tmp)->maxcount = $a_maxcount;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct url_queue);"
		end

end
