class
	PD_WEIGHED_COOKIE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	cookie: CE_POINTER [PD_COOKIE] assign set_cookie
		do
			create Result.make_shared (c_cookie (c_pointer))
		end

	domain_goodness: INTEGER_32 assign set_domain_goodness
		do
			Result := c_domain_goodness (c_pointer)
		end

	path_goodness: INTEGER_32 assign set_path_goodness
		do
			Result := c_path_goodness (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_cookie (a_cookie: CE_POINTER [PD_COOKIE])
		do
			c_set_cookie (c_pointer, a_cookie.c_pointer)
		end

	set_domain_goodness (a_domain_goodness: INTEGER_32)
		do
			c_set_domain_goodness (c_pointer, a_domain_goodness)
		end

	set_path_goodness (a_path_goodness: INTEGER_32)
		do
			c_set_path_goodness (c_pointer, a_path_goodness)
		end

feature {NONE} -- C getters

	c_cookie (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct cookie *)((struct weighed_cookie *)$tmp)->cookie;"
		end

	c_domain_goodness (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct weighed_cookie *)$tmp)->domain_goodness;"
		end

	c_path_goodness (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct weighed_cookie *)$tmp)->path_goodness;"
		end

feature {NONE} -- C setters

	c_set_cookie (tmp: POINTER; a_cookie: POINTER)
		external
			"C inline"
		alias
			"((struct weighed_cookie *)$tmp)->cookie = (struct cookie *)$a_cookie;"
		end

	c_set_domain_goodness (tmp: POINTER; a_domain_goodness: INTEGER_32)
		external
			"C inline"
		alias
			"((struct weighed_cookie *)$tmp)->domain_goodness = $a_domain_goodness;"
		end

	c_set_path_goodness (tmp: POINTER; a_path_goodness: INTEGER_32)
		external
			"C inline"
		alias
			"((struct weighed_cookie *)$tmp)->path_goodness = $a_path_goodness;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct weighed_cookie);"
		end

end
