class
	PD_YY_BUFFER_STATE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	yy_input_file: CE_POINTER [SD_IO_FILE] assign set_yy_input_file
		do
			create Result.make_shared (c_yy_input_file (c_pointer))
		end

	yy_ch_buf: CE_POINTER [INTEGER_8] assign set_yy_ch_buf
		do
			create Result.make_shared (c_yy_ch_buf (c_pointer))
		end

	yy_buf_pos: CE_POINTER [INTEGER_8] assign set_yy_buf_pos
		do
			create Result.make_shared (c_yy_buf_pos (c_pointer))
		end

	yy_buf_size: NATURAL_32 assign set_yy_buf_size
		do
			Result := c_yy_buf_size (c_pointer)
		end

	yy_n_chars: INTEGER_32 assign set_yy_n_chars
		do
			Result := c_yy_n_chars (c_pointer)
		end

	yy_is_our_buffer: INTEGER_32 assign set_yy_is_our_buffer
		do
			Result := c_yy_is_our_buffer (c_pointer)
		end

	yy_is_interactive: INTEGER_32 assign set_yy_is_interactive
		do
			Result := c_yy_is_interactive (c_pointer)
		end

	yy_at_bol: INTEGER_32 assign set_yy_at_bol
		do
			Result := c_yy_at_bol (c_pointer)
		end

	yy_bs_lineno: INTEGER_32 assign set_yy_bs_lineno
		do
			Result := c_yy_bs_lineno (c_pointer)
		end

	yy_bs_column: INTEGER_32 assign set_yy_bs_column
		do
			Result := c_yy_bs_column (c_pointer)
		end

	yy_fill_buffer: INTEGER_32 assign set_yy_fill_buffer
		do
			Result := c_yy_fill_buffer (c_pointer)
		end

	yy_buffer_status: INTEGER_32 assign set_yy_buffer_status
		do
			Result := c_yy_buffer_status (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_yy_input_file (a_yy_input_file: CE_POINTER [SD_IO_FILE])
		do
			c_set_yy_input_file (c_pointer, a_yy_input_file.c_pointer)
		end

	set_yy_ch_buf (a_yy_ch_buf: CE_POINTER [INTEGER_8])
		do
			c_set_yy_ch_buf (c_pointer, a_yy_ch_buf.c_pointer)
		end

	set_yy_buf_pos (a_yy_buf_pos: CE_POINTER [INTEGER_8])
		do
			c_set_yy_buf_pos (c_pointer, a_yy_buf_pos.c_pointer)
		end

	set_yy_buf_size (a_yy_buf_size: NATURAL_32)
		do
			c_set_yy_buf_size (c_pointer, a_yy_buf_size)
		end

	set_yy_n_chars (a_yy_n_chars: INTEGER_32)
		do
			c_set_yy_n_chars (c_pointer, a_yy_n_chars)
		end

	set_yy_is_our_buffer (a_yy_is_our_buffer: INTEGER_32)
		do
			c_set_yy_is_our_buffer (c_pointer, a_yy_is_our_buffer)
		end

	set_yy_is_interactive (a_yy_is_interactive: INTEGER_32)
		do
			c_set_yy_is_interactive (c_pointer, a_yy_is_interactive)
		end

	set_yy_at_bol (a_yy_at_bol: INTEGER_32)
		do
			c_set_yy_at_bol (c_pointer, a_yy_at_bol)
		end

	set_yy_bs_lineno (a_yy_bs_lineno: INTEGER_32)
		do
			c_set_yy_bs_lineno (c_pointer, a_yy_bs_lineno)
		end

	set_yy_bs_column (a_yy_bs_column: INTEGER_32)
		do
			c_set_yy_bs_column (c_pointer, a_yy_bs_column)
		end

	set_yy_fill_buffer (a_yy_fill_buffer: INTEGER_32)
		do
			c_set_yy_fill_buffer (c_pointer, a_yy_fill_buffer)
		end

	set_yy_buffer_status (a_yy_buffer_status: INTEGER_32)
		do
			c_set_yy_buffer_status (c_pointer, a_yy_buffer_status)
		end

feature {NONE} -- C getters

	c_yy_input_file (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _IO_FILE *)((struct yy_buffer_state *)$tmp)->yy_input_file;"
		end

	c_yy_ch_buf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct yy_buffer_state *)$tmp)->yy_ch_buf;"
		end

	c_yy_buf_pos (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct yy_buffer_state *)$tmp)->yy_buf_pos;"
		end

	c_yy_buf_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct yy_buffer_state *)$tmp)->yy_buf_size;"
		end

	c_yy_n_chars (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct yy_buffer_state *)$tmp)->yy_n_chars;"
		end

	c_yy_is_our_buffer (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct yy_buffer_state *)$tmp)->yy_is_our_buffer;"
		end

	c_yy_is_interactive (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct yy_buffer_state *)$tmp)->yy_is_interactive;"
		end

	c_yy_at_bol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct yy_buffer_state *)$tmp)->yy_at_bol;"
		end

	c_yy_bs_lineno (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct yy_buffer_state *)$tmp)->yy_bs_lineno;"
		end

	c_yy_bs_column (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct yy_buffer_state *)$tmp)->yy_bs_column;"
		end

	c_yy_fill_buffer (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct yy_buffer_state *)$tmp)->yy_fill_buffer;"
		end

	c_yy_buffer_status (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct yy_buffer_state *)$tmp)->yy_buffer_status;"
		end

feature {NONE} -- C setters

	c_set_yy_input_file (tmp: POINTER; a_yy_input_file: POINTER)
		external
			"C inline"
		alias
			"((struct yy_buffer_state *)$tmp)->yy_input_file = (struct _IO_FILE *)$a_yy_input_file;"
		end

	c_set_yy_ch_buf (tmp: POINTER; a_yy_ch_buf: POINTER)
		external
			"C inline"
		alias
			"((struct yy_buffer_state *)$tmp)->yy_ch_buf = (char *)$a_yy_ch_buf;"
		end

	c_set_yy_buf_pos (tmp: POINTER; a_yy_buf_pos: POINTER)
		external
			"C inline"
		alias
			"((struct yy_buffer_state *)$tmp)->yy_buf_pos = (char *)$a_yy_buf_pos;"
		end

	c_set_yy_buf_size (tmp: POINTER; a_yy_buf_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct yy_buffer_state *)$tmp)->yy_buf_size = $a_yy_buf_size;"
		end

	c_set_yy_n_chars (tmp: POINTER; a_yy_n_chars: INTEGER_32)
		external
			"C inline"
		alias
			"((struct yy_buffer_state *)$tmp)->yy_n_chars = $a_yy_n_chars;"
		end

	c_set_yy_is_our_buffer (tmp: POINTER; a_yy_is_our_buffer: INTEGER_32)
		external
			"C inline"
		alias
			"((struct yy_buffer_state *)$tmp)->yy_is_our_buffer = $a_yy_is_our_buffer;"
		end

	c_set_yy_is_interactive (tmp: POINTER; a_yy_is_interactive: INTEGER_32)
		external
			"C inline"
		alias
			"((struct yy_buffer_state *)$tmp)->yy_is_interactive = $a_yy_is_interactive;"
		end

	c_set_yy_at_bol (tmp: POINTER; a_yy_at_bol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct yy_buffer_state *)$tmp)->yy_at_bol = $a_yy_at_bol;"
		end

	c_set_yy_bs_lineno (tmp: POINTER; a_yy_bs_lineno: INTEGER_32)
		external
			"C inline"
		alias
			"((struct yy_buffer_state *)$tmp)->yy_bs_lineno = $a_yy_bs_lineno;"
		end

	c_set_yy_bs_column (tmp: POINTER; a_yy_bs_column: INTEGER_32)
		external
			"C inline"
		alias
			"((struct yy_buffer_state *)$tmp)->yy_bs_column = $a_yy_bs_column;"
		end

	c_set_yy_fill_buffer (tmp: POINTER; a_yy_fill_buffer: INTEGER_32)
		external
			"C inline"
		alias
			"((struct yy_buffer_state *)$tmp)->yy_fill_buffer = $a_yy_fill_buffer;"
		end

	c_set_yy_buffer_status (tmp: POINTER; a_yy_buffer_status: INTEGER_32)
		external
			"C inline"
		alias
			"((struct yy_buffer_state *)$tmp)->yy_buffer_status = $a_yy_buffer_status;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct yy_buffer_state);"
		end

end
