class
	P_CONNECT

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create ip.make
			create transport_map.make
			create last_info.make
			create last_info___0.make
			create last_info___1.make
		end

feature {ANY} -- attributes

	called: BOOLEAN assign set_called

	set_called (a_called: BOOLEAN)
		do
			called := a_called
		end

	should_bind: BOOLEAN assign set_should_bind

	set_should_bind (a_should_bind: BOOLEAN)
		do
			should_bind := a_should_bind
		end

	ip: PD_IP_ADDRESS

	transport_map: CE_POINTER [PD_HASH_TABLE]

	transport_map_modified_tick: NATURAL_32 assign set_transport_map_modified_tick

	set_transport_map_modified_tick (a_transport_map_modified_tick: NATURAL_32)
		do
			transport_map_modified_tick := a_transport_map_modified_tick
		end

	last_info: CE_POINTER [PD_TRANSPORT_INFO]

	last_fd: INTEGER_32 assign set_last_fd

	set_last_fd (a_last_fd: INTEGER_32)
		do
			last_fd := a_last_fd
		end

	last_tick: NATURAL_32 assign set_last_tick

	set_last_tick (a_last_tick: NATURAL_32)
		do
			last_tick := a_last_tick
		end

	last_info___0: CE_POINTER [PD_TRANSPORT_INFO]

	last_fd___0: INTEGER_32 assign set_last_fd___0

	set_last_fd___0 (a_last_fd___0: INTEGER_32)
		do
			last_fd___0 := a_last_fd___0
		end

	last_tick___0: NATURAL_32 assign set_last_tick___0

	set_last_tick___0 (a_last_tick___0: NATURAL_32)
		do
			last_tick___0 := a_last_tick___0
		end

	last_info___1: CE_POINTER [PD_TRANSPORT_INFO]

	last_fd___1: INTEGER_32 assign set_last_fd___1

	set_last_fd___1 (a_last_fd___1: INTEGER_32)
		do
			last_fd___1 := a_last_fd___1
		end

	last_tick___1: NATURAL_32 assign set_last_tick___1

	set_last_tick___1 (a_last_tick___1: NATURAL_32)
		do
			last_tick___1 := a_last_tick___1
		end

feature {ANY} -- routines

	sockaddr_set_data (a_sa: CE_POINTER [SD_SOCKADDR]; a_ip___0: CE_POINTER [PD_IP_ADDRESS]; a_port: INTEGER_32)
		local
			l_sin: CE_POINTER [SD_SOCKADDR_IN]
			l_sin6: CE_POINTER [SD_SOCKADDR_IN6]
			l_pos: INTEGER_32
		do
			create l_sin.make
			create l_sin6.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_ip___0.item.family -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 10 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2
					l_sin.ce_gets (create {CE_POINTER [SD_SOCKADDR_IN]}.make_cast (a_sa))
					memset (create {CE_POINTER [ANY]}.make_cast (l_sin), ('%/0/').code, {SD_SOCKADDR_IN}.sizeof.to_natural_32).do_nothing
					l_sin.item.sin_family := (2).to_natural_16
					l_sin.item.sin_port := htons (a_port.to_natural_16)
					l_sin.item.sin_addr := a_ip___0.item.data.d4
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 10
					l_sin6.ce_gets (create {CE_POINTER [SD_SOCKADDR_IN6]}.make_cast (a_sa))
					memset (create {CE_POINTER [ANY]}.make_cast (l_sin6), ('%/0/').code, {SD_SOCKADDR_IN6}.sizeof.to_natural_32).do_nothing
					l_sin6.item.sin6_family := (10).to_natural_16
					l_sin6.item.sin6_port := htons (a_port.to_natural_16)
					l_sin6.item.sin6_addr := a_ip___0.item.data.d6
					l_sin6.item.sin6_scope_id := (a_ip___0.item.ipv6_scope).to_natural_32
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					abort
				when 4 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	sockaddr_get_data (a_sa: CE_POINTER [SD_SOCKADDR]; a_ip___0: CE_POINTER [PD_IP_ADDRESS]; a_port: CE_POINTER [INTEGER_32])
		local
			l_sin: CE_POINTER [SD_SOCKADDR_IN]
			l_sin6: CE_POINTER [SD_SOCKADDR_IN6]
			l_pos: INTEGER_32
		do
			create l_sin.make
			create l_sin6.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect (a_sa.item.sa_family).to_integer_32 -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 10 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2
					l_sin.ce_gets (create {CE_POINTER [SD_SOCKADDR_IN]}.make_cast (a_sa))
					if ((a_ip___0).c_pointer /= default_pointer) then
						a_ip___0.item.family := 2
						a_ip___0.item.data.d4 := l_sin.item.sin_addr
					end
					if ((a_port).c_pointer /= default_pointer) then
						a_port.item := (ntohs (l_sin.item.sin_port)).to_integer_32
					end
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 10
					l_sin6.ce_gets (create {CE_POINTER [SD_SOCKADDR_IN6]}.make_cast (a_sa))
					if ((a_ip___0).c_pointer /= default_pointer) then
						a_ip___0.item.family := 10
						a_ip___0.item.data.d6 := l_sin6.item.sin6_addr
						a_ip___0.item.ipv6_scope := (l_sin6.item.sin6_scope_id).to_integer_32
					end
					if ((a_port).c_pointer /= default_pointer) then
						a_port.item := (ntohs (l_sin6.item.sin6_port)).to_integer_32
					end
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					abort
				when 4 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	sockaddr_size (a_sa: CE_POINTER [SD_SOCKADDR]): NATURAL_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect (a_sa.item.sa_family).to_integer_32 -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 10 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2
					Result := ({SD_SOCKADDR_IN}.sizeof.to_natural_32)
					js.return
				when 2 then -- switch 1, case 10
					if not js.return_called then
						Result := ({SD_SOCKADDR_IN6}.sizeof.to_natural_32)
						js.return
					end
				when 3 then -- switch 1, default:
					if not js.return_called then
						abort
					end
				when 4 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	resolve_bind_address (a_sa: CE_POINTER [SD_SOCKADDR]): BOOLEAN
		local
			l_al: CE_POINTER [PD_ADDRESS_LIST]
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_al.make
			create l_tmp.make

			if called then
				if should_bind then
					sockaddr_set_data (a_sa, (ip.address), 0)
				end
				Result := should_bind
				js.return
			end
			if not js.return_called then
				called := (1).to_boolean
				l_al.ce_gets (host_inst.lookup_host (options_inst.opt.bind_address, 3))
				if (l_al).c_pointer = default_pointer then
					l_tmp.ce_gets (quote_inst.quote (options_inst.opt.bind_address))
					log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("%%s: unable to resolve bind address %%s; disabling bind.%N"))), wget_inst.exec_name, l_tmp])
					should_bind := (0).to_boolean
					Result := (0).to_boolean
					js.return
				end
			end
			if not js.return_called then
				ip.ce_gets ((host_inst.address_list_address_at (l_al, 0)).item)
				host_inst.address_list_release (l_al)
				sockaddr_set_data (a_sa, (ip.address), 0)
				should_bind := (1).to_boolean
				Result := (1).to_boolean
			end
		end

	connect_with_timeout_callback (a_arg: CE_POINTER [ANY])
		local
			l_ctx: CE_POINTER [PD_CWT_CONTEXT]
		do
			create l_ctx.make

			l_ctx.ce_gets (create {CE_POINTER [PD_CWT_CONTEXT]}.make_cast (a_arg))
			l_ctx.item.result2 := connect (l_ctx.item.fd, l_ctx.item.addr, l_ctx.item.addrlen)
		end

	connect_with_timeout_callback_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent connect_with_timeout_callback)
		end

	connect_with_timeout (a_fd: INTEGER_32; a_addr: CE_POINTER [SD_SOCKADDR]; a_addrlen: NATURAL_32; a_timeout: REAL_64): INTEGER_32
		local
			l_ctx: PD_CWT_CONTEXT
			js: JUMP_STATE
		do
			create l_ctx.make

			l_ctx.fd := a_fd
			l_ctx.addr := a_addr
			l_ctx.addrlen := a_addrlen
			if (utils_inst.run_with_timeout (a_timeout, connect_with_timeout_callback_address, create {CE_POINTER [ANY]}.make_cast ((l_ctx.address)))) then
				(errno_location).item := 110
				Result := (-1)
				js.return
			end
			if not js.return_called then
				if l_ctx.result2 = -1 then
					if (errno_location).item = 4 then
						(errno_location).item := 110
					end
				end
				Result := (l_ctx.result2)
			end
		end

	connect_to_ip (a_ip___0: CE_POINTER [PD_IP_ADDRESS]; a_port: INTEGER_32; a_print: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_ss: SD_SOCKADDR_STORAGE
			l_sa: CE_POINTER [SD_SOCKADDR]
			l_sock: INTEGER_32
			l_txt_addr: CE_POINTER [INTEGER_8]
			l_str: CE_POINTER [INTEGER_8]
			l_name: CE_POINTER [INTEGER_8]
			l_len: INTEGER_32
			l_tmp___0: NATURAL_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_on: INTEGER_32
			l_err: INTEGER_32
			l_bufsize___0: INTEGER_32
			l_bind_ss: SD_SOCKADDR_STORAGE
			l_bind_sa: CE_POINTER [SD_SOCKADDR]
			l_save_errno: INTEGER_32
			l_tmp___22: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ss.make
			create l_sa.make
			create l_txt_addr.make
			create l_str.make
			create l_name.make
			create l_tmp___4.make
			create l_bind_ss.make
			create l_bind_sa.make
			create l_tmp___22.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sa.ce_gets (create {CE_POINTER [SD_SOCKADDR]}.make_cast ((l_ss.address)))
					if ((a_print).c_pointer /= default_pointer) then
						l_txt_addr.ce_gets ((host_inst.print_address (a_ip___0)))
						if 0 /= (strcmp (a_print, l_txt_addr)) then
							l_str.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							if options_inst.opt.enable_iri then
								l_name.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								if (l_name.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_tmp___0 := strlen (a_print)
									l_len := ((l_tmp___0 + (strlen (l_name))) + {NATURAL_32} 4).to_integer_32
									l_str.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc (l_len.to_natural_32))))
									snprintf ([l_str, l_len.to_natural_32, ce_string ("%%s (%%s)"), l_name, a_print]).do_nothing
									l_str[(l_len - 1)] := (('%/0/').code).to_integer_8
									free (create {CE_POINTER [ANY]}.make_cast (l_name))
								end
							end
							if ((l_str).c_pointer /= default_pointer) then
								l_tmp___4.ce_gets (l_str)
							else
								l_tmp___4.ce_gets ((log_inst.escnonprint_uri (a_print)))
							end
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Connecting to %%s|%%s|:%%d... "))), l_tmp___4, l_txt_addr, a_port])
							if ((l_str).c_pointer /= default_pointer) then
								free (create {CE_POINTER [ANY]}.make_cast (l_str))
							end
						else
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Connecting to %%s:%%d... "))), l_txt_addr, a_port])
						end
					end
					sockaddr_set_data (l_sa, a_ip___0, a_port)
					l_sock := socket ((l_sa.item.sa_family).to_integer_32, 1, 0)
					if l_sock < 0 then
						l_pos := -1 + 4 -- goto err
					end
				when 1 then
					if options_inst.opt.ipv6_only then
						l_on := 1
						l_err := (setsockopt (l_sock, 41, 26, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared ($l_on))), Integer_32_bytes.to_natural_32))
						if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
							if l_err < 0 then
								from
								until
									js.loop_left
								loop
									js.reset
									if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
										log_inst.debug_logprintf ([ce_string ("Failed setting IPV6_V6ONLY: %%s"), (strerror ((errno_location).item))])
									end
									js.break
								end
								js.reset
							end
						end
					end
					if (options_inst.opt.limit_rate).to_boolean then
						if options_inst.opt.limit_rate < {INTEGER_64} 8192 then
							l_bufsize___0 := (options_inst.opt.limit_rate).to_integer_32
							if l_bufsize___0 < 512 then
								l_bufsize___0 := 512
							end
							setsockopt (l_sock, 1, 8, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared ($l_bufsize___0))), Integer_32_bytes.to_natural_32).do_nothing
						end
					end
					if ((options_inst.opt.bind_address).c_pointer /= default_pointer) then
						l_bind_sa.ce_gets (create {CE_POINTER [SD_SOCKADDR]}.make_cast ((l_bind_ss.address)))
						if (resolve_bind_address (l_bind_sa)) then
							if (bind (l_sock, l_bind_sa, (sockaddr_size (l_bind_sa)))) < 0 then
								l_pos := -1 + 4 -- goto err
							end
						end
					end
				when 2 then
					if (connect_with_timeout (l_sock, l_sa, (sockaddr_size (l_sa)), options_inst.opt.connect_timeout)) < 0 then
						l_pos := -1 + 4 -- goto err
					end
				when 3 then
					if not (l_sock >= 0) then
						assert_fail (ce_string ("sock >= 0"), ce_string ("connect.c"), {NATURAL_32} 356, ce_string ("connect_to_ip"))
					end
					if ((a_print).c_pointer /= default_pointer) then
						log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("connected.%N")))])
					end
					from
					until
						js.loop_left
					loop
						js.reset
						if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
							log_inst.debug_logprintf ([ce_string ("Created socket %%d.%N"), l_sock])
						end
						js.break
					end
					js.reset
					Result := l_sock
					js.return
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 4 then -- if: | err:
						l_save_errno := (errno_location).item
						if l_sock >= 0 then
							fd_close (l_sock)
						end
						if ((a_print).c_pointer /= default_pointer) then
							l_tmp___22.ce_gets (strerror ((errno_location).item))
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("failed: %%s.%N"))), l_tmp___22])
						end
						(errno_location).item := l_save_errno
						Result := (-1)
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	connect_to_host (a_host: CE_POINTER [INTEGER_8]; a_port: INTEGER_32): INTEGER_32
		local
			l_i: INTEGER_32
			l_start: INTEGER_32
			l_end: INTEGER_32
			l_sock: INTEGER_32
			l_al: CE_POINTER [PD_ADDRESS_LIST]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_ip___0: CE_POINTER [PD_IP_ADDRESS]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_al.make
			create l_tmp___0.make
			create l_ip___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_al.ce_gets ((host_inst.lookup_host (a_host, 0)))
				when 1 then -- retry:
					if (l_al).c_pointer = default_pointer then
						l_tmp___0.ce_gets (quote_inst.quote (a_host))
						log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("%%s: unable to resolve host address %%s%N"))), wget_inst.exec_name, l_tmp___0])
						Result := (-100)
						js.return
					end
					if not js.return_called then
						host_inst.address_list_get_bounds (l_al, create {CE_POINTER [INTEGER_32]}.make_shared ($l_start), create {CE_POINTER [INTEGER_32]}.make_shared ($l_end))
						l_i := l_start
						from
						until
							not (not js.loop_left and then (l_i < l_end))
						loop
							l_ip___0.ce_gets ((host_inst.address_list_address_at (l_al, l_i)))
							l_sock := connect_to_ip (l_ip___0, a_port, a_host)
							if l_sock >= 0 then
								host_inst.address_list_set_connected (l_al)
								host_inst.address_list_release (l_al)
								Result := l_sock
								js.return
							end
							if not js.return_called then
								host_inst.address_list_set_faulty (l_al, l_i)
								l_i := l_i + 1
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 4 -- skip if block
					end
				when 2 then -- if:
						if (host_inst.address_list_connected_p (l_al)) then
							host_inst.address_list_release (l_al)
							l_al.ce_gets (host_inst.lookup_host (a_host, 4))
							l_pos := -1 + 1 -- goto retry
						end
				when 3 then
						host_inst.address_list_release (l_al)
						Result := (-1)
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	bind_local (a_bind_address: CE_POINTER [PD_IP_ADDRESS]; a_port: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_sock: INTEGER_32
			l_ss: SD_SOCKADDR_STORAGE
			l_sa: CE_POINTER [SD_SOCKADDR]
			l_setopt_val: INTEGER_32
			l_setopt_ptr: CE_POINTER [ANY]
			l_setopt_size: NATURAL_32
			l_addrlen: NATURAL_32
			js: JUMP_STATE
		do
			create l_ss.make
			create l_sa.make
			create l_setopt_ptr.make

			l_sa.ce_gets (create {CE_POINTER [SD_SOCKADDR]}.make_cast ((l_ss.address)))
			l_setopt_val := 1
			l_setopt_ptr.ce_gets (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared ($l_setopt_val))))
			l_setopt_size := Integer_32_bytes.to_natural_32
			l_sock := socket (a_bind_address.item.family, 1, 0)
			if l_sock < 0 then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				setsockopt (l_sock, 1, 2, l_setopt_ptr, l_setopt_size).do_nothing
				memset (create {CE_POINTER [ANY]}.make_cast ((l_ss.address)), ('%/0/').code, {SD_SOCKADDR_STORAGE}.sizeof.to_natural_32).do_nothing
				sockaddr_set_data (l_sa, a_bind_address, a_port.item)
				if (bind (l_sock, l_sa, (sockaddr_size (l_sa)))) < 0 then
					fd_close (l_sock)
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
						log_inst.debug_logprintf ([ce_string ("Local socket fd %%d bound.%N"), l_sock])
					end
					js.break
				end
				js.reset
				if a_port.item = 0 then
					l_addrlen := (sockaddr_size (l_sa))
					if (getsockname (l_sock, l_sa, (create {CE_POINTER [NATURAL_32]}.make_shared ($l_addrlen)))) < 0 then
						fd_close (l_sock)
						Result := (-1)
						js.return
					end
					if not js.return_called then
						sockaddr_get_data (l_sa, create {CE_POINTER [PD_IP_ADDRESS]}.make_shared (default_pointer), a_port)
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("binding to address %%s using port %%i.%N"), (host_inst.print_address (a_bind_address)), a_port.item])
							end
							js.break
						end
						js.reset
					end
				end
			end
			if not js.return_called then
				if (listen (l_sock, 1)) < 0 then
					fd_close (l_sock)
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				Result := l_sock
			end
		end

	accept_connection (a_local_sock: INTEGER_32): INTEGER_32
		local
			l_sock: INTEGER_32
			l_ss: SD_SOCKADDR_STORAGE
			l_sa: CE_POINTER [SD_SOCKADDR]
			l_addrlen: NATURAL_32
			l_test: INTEGER_32
			js: JUMP_STATE
		do
			create l_ss.make
			create l_sa.make

			l_sa.ce_gets (create {CE_POINTER [SD_SOCKADDR]}.make_cast ((l_ss.address)))
			l_addrlen := {SD_SOCKADDR_STORAGE}.sizeof.to_natural_32
			if (options_inst.opt.connect_timeout).truncated_to_integer.to_boolean then
				l_test := (select_fd (a_local_sock, options_inst.opt.connect_timeout, 1))
				if l_test = 0 then
					(errno_location).item := 110
				end
				if l_test <= 0 then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				l_sock := accept (a_local_sock, l_sa, (create {CE_POINTER [NATURAL_32]}.make_shared ($l_addrlen)))
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
						log_inst.debug_logprintf ([ce_string ("Accepted client at socket %%d.%N"), l_sock])
					end
					js.break
				end
				js.reset
				Result := l_sock
			end
		end

	socket_ip_address (a_sock: INTEGER_32; a_ip___0: CE_POINTER [PD_IP_ADDRESS]; a_endpoint: INTEGER_32): BOOLEAN
		local
			l_storage: SD_SOCKADDR_STORAGE
			l_sockaddr: CE_POINTER [SD_SOCKADDR]
			l_addrlen: NATURAL_32
			l_ret: INTEGER_32
			l_sa6: CE_POINTER [SD_SOCKADDR_IN6]
			l_sa: CE_POINTER [SD_SOCKADDR_IN]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_storage.make
			create l_sockaddr.make
			create l_sa6.make
			create l_sa.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sockaddr.ce_gets (create {CE_POINTER [SD_SOCKADDR]}.make_cast ((l_storage.address)))
					l_addrlen := {SD_SOCKADDR_STORAGE}.sizeof.to_natural_32
					if a_endpoint = 0 then
						l_ret := getsockname (a_sock, l_sockaddr, (create {CE_POINTER [NATURAL_32]}.make_shared ($l_addrlen)))
					elseif a_endpoint = 1 then
						l_ret := getpeername (a_sock, l_sockaddr, (create {CE_POINTER [NATURAL_32]}.make_shared ($l_addrlen)))
					else
						abort
					end
					if l_ret < 0 then
						Result := (0).to_boolean
						js.return
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						a_ip___0.item.family := (l_sockaddr.item.sa_family).to_integer_32
						inspect (l_sockaddr.item.sa_family).to_integer_32 -- switch 1 head
						when 10 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 3
						else l_pos := -1 + 4
						end
				when 2 then -- switch 1, case 10
						l_sa6.ce_gets (create {CE_POINTER [SD_SOCKADDR_IN6]}.make_cast ((l_storage.address)))
						a_ip___0.item.data.d6 := l_sa6.item.sin6_addr
						a_ip___0.item.ipv6_scope := (l_sa6.item.sin6_scope_id).to_integer_32
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("conaddr is: %%s%N"), (host_inst.print_address (a_ip___0))])
							end
							js.break
						end
						js.reset
						Result := (1).to_boolean
						js.return
				when 3 then -- switch 1, case 2
						if not js.return_called then
							l_sa.ce_gets (create {CE_POINTER [SD_SOCKADDR_IN]}.make_cast ((l_storage.address)))
							a_ip___0.item.data.d4 := l_sa.item.sin_addr
							from
							until
								js.loop_left
							loop
								js.reset
								if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string ("conaddr is: %%s%N"), (host_inst.print_address (a_ip___0))])
								end
								js.break
							end
							js.reset
							Result := (1).to_boolean
							js.return
						end
				when 4 then -- switch 1, default:
						if not js.return_called then
							abort
						end
				when 5 then -- switch 1, done:
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	retryable_socket_connect_error (a_err: INTEGER_32): BOOLEAN
		local
			js: JUMP_STATE
		do
			if a_err = 97 then
				Result := (0).to_boolean
				js.return
			elseif a_err = 96 then
				Result := (0).to_boolean
				js.return
			elseif a_err = 94 then
				Result := (0).to_boolean
				js.return
			elseif a_err = 93 then
				Result := (0).to_boolean
				js.return
			elseif a_err = 92 then
				Result := (0).to_boolean
				js.return
			elseif a_err = 22 then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called and then (not options_inst.opt.retry_connrefused) then
				if a_err = 111 then
					Result := (0).to_boolean
					js.return
				elseif a_err = 101 then
					Result := (0).to_boolean
					js.return
				elseif a_err = 113 then
					Result := (0).to_boolean
					js.return
				end
			end
			if not js.return_called then
				Result := (1).to_boolean
			end
		end

	select_fd (a_fd: INTEGER_32; a_maxtime: REAL_64; a_wait_for: INTEGER_32): INTEGER_32
		local
			l_fdset: SD_FD_SET
			l_rd: CE_POINTER [SD_FD_SET]
			l_wr: CE_POINTER [SD_FD_SET]
			l_tmout: SD_TIMEVAL
			l_result: INTEGER_32
			l_d0: INTEGER_32
			l_d1: INTEGER_32
			js: JUMP_STATE
		do
			create l_fdset.make
			create l_rd.make
			create l_wr.make
			create l_tmout.make

			l_rd.ce_gets (create {CE_POINTER [SD_FD_SET]}.make_shared (default_pointer))
			l_wr.ce_gets (create {CE_POINTER [SD_FD_SET]}.make_shared (default_pointer))
			from
			until
				js.loop_left
			loop
				js.reset
				asm1 (create {CE_POINTER [INTEGER_32]}.make_shared ($l_d0), create {CE_POINTER [INTEGER_32]}.make_shared ($l_d1), l_fdset.address)
				js.break
			end
			js.reset
			asm2 (l_fdset.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_fd))
			if ((a_wait_for).bit_and (1)).to_boolean then
				l_rd.ce_gets (l_fdset.address)
			end
			if ((a_wait_for).bit_and (2)).to_boolean then
				l_wr.ce_gets (l_fdset.address)
			end
			l_tmout.tv_sec := a_maxtime.truncated_to_integer
			l_tmout.tv_usec := ((1000000).to_double * (a_maxtime - (a_maxtime.truncated_to_integer).to_double)).truncated_to_integer
			from
			until
				js.loop_left
			loop
				js.reset
				l_result := select2 (a_fd + 1, l_rd, l_wr, create {CE_POINTER [SD_FD_SET]}.make_shared (default_pointer), (l_tmout.address))
				if l_result < 0 then
					if (errno_location).item /= 4 then
						js.break
					end
				else
					js.break
				end
			end
			js.reset
			Result := l_result
		end

	test_socket_open (a_sock: INTEGER_32): BOOLEAN
		local
			l_check_set: SD_FD_SET
			l_to: SD_TIMEVAL
			l_d0: INTEGER_32
			l_d1: INTEGER_32
			js: JUMP_STATE
		do
			create l_check_set.make
			create l_to.make

			from
			until
				js.loop_left
			loop
				js.reset
				asm3 (create {CE_POINTER [INTEGER_32]}.make_shared ($l_d0), create {CE_POINTER [INTEGER_32]}.make_shared ($l_d1), l_check_set.address)
				js.break
			end
			js.reset
			asm4 (l_check_set.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_sock))
			l_to.tv_sec := (0).to_integer_32
			l_to.tv_usec := (1).to_integer_32
			if (select2 (a_sock + 1, (l_check_set.address), create {CE_POINTER [SD_FD_SET]}.make_shared (default_pointer), create {CE_POINTER [SD_FD_SET]}.make_shared (default_pointer), (l_to.address))) = 0 then
				Result := (1).to_boolean
			else
				Result := (0).to_boolean
			end
		end

	sock_read (a_fd: INTEGER_32; a_buf___6: CE_POINTER [INTEGER_8]; a_bufsize___0: INTEGER_32): INTEGER_32
		local
			l_res___0: INTEGER_32
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				l_res___0 := read (a_fd, create {CE_POINTER [ANY]}.make_cast (a_buf___6), a_bufsize___0.to_natural_32)
				if l_res___0 = -1 then
					if (errno_location).item /= 4 then
						js.break
					end
				else
					js.break
				end
			end
			js.reset
			Result := l_res___0
		end

	sock_write (a_fd: INTEGER_32; a_buf___6: CE_POINTER [INTEGER_8]; a_bufsize___0: INTEGER_32): INTEGER_32
		local
			l_res___0: INTEGER_32
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				l_res___0 := write (a_fd, create {CE_POINTER [ANY]}.make_cast (a_buf___6), a_bufsize___0.to_natural_32)
				if l_res___0 = -1 then
					if (errno_location).item /= 4 then
						js.break
					end
				else
					js.break
				end
			end
			js.reset
			Result := l_res___0
		end

	sock_poll (a_fd: INTEGER_32; a_timeout: REAL_64; a_wait_for: INTEGER_32): INTEGER_32
		do
			Result := (select_fd (a_fd, a_timeout, a_wait_for))
		end

	sock_peek (a_fd: INTEGER_32; a_buf___6: CE_POINTER [INTEGER_8]; a_bufsize___0: INTEGER_32): INTEGER_32
		local
			l_res___0: INTEGER_32
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				l_res___0 := recv (a_fd, create {CE_POINTER [ANY]}.make_cast (a_buf___6), a_bufsize___0.to_natural_32, 2)
				if l_res___0 = -1 then
					if (errno_location).item /= 4 then
						js.break
					end
				else
					js.break
				end
			end
			js.reset
			Result := l_res___0
		end

	sock_close (a_fd: INTEGER_32)
		local
			js: JUMP_STATE
		do
			close (a_fd).do_nothing
			from
			until
				js.loop_left
			loop
				js.reset
				if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
					log_inst.debug_logprintf ([ce_string ("Closed fd %%d%N"), a_fd])
				end
				js.break
			end
			js.reset
		end

	fd_register_transport (a_fd: INTEGER_32; a_imp: CE_POINTER [PD_TRANSPORT_IMPLEMENTATION]; a_ctx: CE_POINTER [ANY])
		local
			l_info: CE_POINTER [PD_TRANSPORT_INFO]
		do
			create l_info.make

			if not (a_fd >= 0) then
				assert_fail (ce_string ("fd >= 0"), ce_string ("connect.c"), {NATURAL_32} 792, ce_string ("fd_register_transport"))
			end
			l_info.ce_gets (create {CE_POINTER [PD_TRANSPORT_INFO]}.make_cast ((xmalloc_inst.xmalloc ({PD_TRANSPORT_INFO}.sizeof.to_natural_32))))
			l_info.item.imp := a_imp
			l_info.item.ctx := a_ctx
			if (transport_map).c_pointer = default_pointer then
				transport_map.ce_gets (hash_inst.hash_table_new (0, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer)))
			end
			hash_inst.hash_table_put (transport_map, create {CE_POINTER [ANY]}.make_shared (default_pointer + a_fd), create {CE_POINTER [ANY]}.make_cast (l_info))
			transport_map_modified_tick := transport_map_modified_tick + 1
		end

	fd_transport_context (a_fd: INTEGER_32): CE_POINTER [ANY]
		local
			l_info: CE_POINTER [PD_TRANSPORT_INFO]
		do
			create l_info.make

			l_info.ce_gets (create {CE_POINTER [PD_TRANSPORT_INFO]}.make_cast ((hash_inst.hash_table_get (transport_map, create {CE_POINTER [ANY]}.make_shared (default_pointer + a_fd)))))
			Result := (l_info.item.ctx)
		end

	poll_internal (a_fd: INTEGER_32; a_info: CE_POINTER [PD_TRANSPORT_INFO]; a_wf: INTEGER_32; a_timeout: REAL_64): BOOLEAN
		local
			l_timeout: REAL_64
			l_test: INTEGER_32
			js: JUMP_STATE
		do
			l_timeout := a_timeout
			if l_timeout = (-1).to_double then
				l_timeout := options_inst.opt.read_timeout
			end
			if l_timeout.truncated_to_integer.to_boolean then
				if ((a_info).c_pointer /= default_pointer) then
					if (((a_info.item.imp).item.poller).c_pointer /= default_pointer) then
						l_test := ((a_info.item.imp).item.poller).integer_32_item ([a_fd, l_timeout, a_wf, a_info.item.ctx])
					else
						l_test := sock_poll (a_fd, l_timeout, a_wf)
					end
				else
					l_test := sock_poll (a_fd, l_timeout, a_wf)
				end
				if l_test = 0 then
					(errno_location).item := 110
				end
				if l_test <= 0 then
					Result := (0).to_boolean
					js.return
				end
			end
			if not js.return_called then
				Result := (1).to_boolean
			end
		end

	fd_read (a_fd: INTEGER_32; a_buf___6: CE_POINTER [INTEGER_8]; a_bufsize___0: INTEGER_32; a_timeout: REAL_64): INTEGER_32
		local
			l_info: CE_POINTER [PD_TRANSPORT_INFO]
			l_tmp: CE_POINTER [ANY]
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_info.make
			create l_tmp.make

			from
			until
				js.loop_left
			loop
				js.reset
				if (transport_map).c_pointer = default_pointer then
					l_info.ce_gets (create {CE_POINTER [PD_TRANSPORT_INFO]}.make_shared (default_pointer))
				elseif last_fd = a_fd then
					if last_tick = transport_map_modified_tick then
						l_info.ce_gets (last_info)
					else
						l_tmp.ce_gets (hash_inst.hash_table_get (transport_map, create {CE_POINTER [ANY]}.make_shared (default_pointer + a_fd)))
						l_info.ce_gets (create {CE_POINTER [PD_TRANSPORT_INFO]}.make_cast (l_tmp))
						last_fd := a_fd
						last_info.ce_gets (l_info)
						last_tick := transport_map_modified_tick
					end
				else
					l_tmp.ce_gets (hash_inst.hash_table_get (transport_map, create {CE_POINTER [ANY]}.make_shared (default_pointer + a_fd)))
					l_info.ce_gets (create {CE_POINTER [PD_TRANSPORT_INFO]}.make_cast (l_tmp))
					last_fd := a_fd
					last_info.ce_gets (l_info)
					last_tick := transport_map_modified_tick
				end
				js.break
			end
			js.reset
			if not (poll_internal (a_fd, l_info, 1, a_timeout)) then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				if ((l_info).c_pointer /= default_pointer) then
					if (((l_info.item.imp).item.reader).c_pointer /= default_pointer) then
						Result := (((l_info.item.imp).item.reader).integer_32_item ([a_fd, a_buf___6, a_bufsize___0, l_info.item.ctx]))
					else
						l_tmp___2 := sock_read (a_fd, a_buf___6, a_bufsize___0)
						Result := l_tmp___2
					end
				else
					l_tmp___2 := sock_read (a_fd, a_buf___6, a_bufsize___0)
					Result := l_tmp___2
				end
			end
		end

	fd_peek (a_fd: INTEGER_32; a_buf___6: CE_POINTER [INTEGER_8]; a_bufsize___0: INTEGER_32; a_timeout: REAL_64): INTEGER_32
		local
			l_info: CE_POINTER [PD_TRANSPORT_INFO]
			l_tmp: CE_POINTER [ANY]
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_info.make
			create l_tmp.make

			from
			until
				js.loop_left
			loop
				js.reset
				if (transport_map).c_pointer = default_pointer then
					l_info.ce_gets (create {CE_POINTER [PD_TRANSPORT_INFO]}.make_shared (default_pointer))
				elseif last_fd___0 = a_fd then
					if last_tick___0 = transport_map_modified_tick then
						l_info.ce_gets (last_info___0)
					else
						l_tmp.ce_gets (hash_inst.hash_table_get (transport_map, create {CE_POINTER [ANY]}.make_shared (default_pointer + a_fd)))
						l_info.ce_gets (create {CE_POINTER [PD_TRANSPORT_INFO]}.make_cast (l_tmp))
						last_fd___0 := a_fd
						last_info___0.ce_gets (l_info)
						last_tick___0 := transport_map_modified_tick
					end
				else
					l_tmp.ce_gets (hash_inst.hash_table_get (transport_map, create {CE_POINTER [ANY]}.make_shared (default_pointer + a_fd)))
					l_info.ce_gets (create {CE_POINTER [PD_TRANSPORT_INFO]}.make_cast (l_tmp))
					last_fd___0 := a_fd
					last_info___0.ce_gets (l_info)
					last_tick___0 := transport_map_modified_tick
				end
				js.break
			end
			js.reset
			if not (poll_internal (a_fd, l_info, 1, a_timeout)) then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				if ((l_info).c_pointer /= default_pointer) then
					if (((l_info.item.imp).item.peeker).c_pointer /= default_pointer) then
						Result := (((l_info.item.imp).item.peeker).integer_32_item ([a_fd, a_buf___6, a_bufsize___0, l_info.item.ctx]))
					else
						l_tmp___2 := sock_peek (a_fd, a_buf___6, a_bufsize___0)
						Result := l_tmp___2
					end
				else
					l_tmp___2 := sock_peek (a_fd, a_buf___6, a_bufsize___0)
					Result := l_tmp___2
				end
			end
		end

	fd_write (a_fd: INTEGER_32; a_buf___6: CE_POINTER [INTEGER_8]; a_bufsize___0: INTEGER_32; a_timeout: REAL_64): INTEGER_32
		local
			l_buf___6: CE_POINTER [INTEGER_8]
			l_bufsize___0: INTEGER_32
			l_res___0: INTEGER_32
			l_info: CE_POINTER [PD_TRANSPORT_INFO]
			l_tmp: CE_POINTER [ANY]
			js: JUMP_STATE
		do
			create l_buf___6.make
			create l_info.make
			create l_tmp.make

			l_buf___6.ce_gets (a_buf___6)
			l_bufsize___0 := a_bufsize___0
			from
			until
				js.loop_left
			loop
				js.reset
				if (transport_map).c_pointer = default_pointer then
					l_info.ce_gets (create {CE_POINTER [PD_TRANSPORT_INFO]}.make_shared (default_pointer))
				elseif last_fd___1 = a_fd then
					if last_tick___1 = transport_map_modified_tick then
						l_info.ce_gets (last_info___1)
					else
						l_tmp.ce_gets (hash_inst.hash_table_get (transport_map, create {CE_POINTER [ANY]}.make_shared (default_pointer + a_fd)))
						l_info.ce_gets (create {CE_POINTER [PD_TRANSPORT_INFO]}.make_cast (l_tmp))
						last_fd___1 := a_fd
						last_info___1.ce_gets (l_info)
						last_tick___1 := transport_map_modified_tick
					end
				else
					l_tmp.ce_gets (hash_inst.hash_table_get (transport_map, create {CE_POINTER [ANY]}.make_shared (default_pointer + a_fd)))
					l_info.ce_gets (create {CE_POINTER [PD_TRANSPORT_INFO]}.make_cast (l_tmp))
					last_fd___1 := a_fd
					last_info___1.ce_gets (l_info)
					last_tick___1 := transport_map_modified_tick
				end
				js.break
			end
			js.reset
			l_res___0 := 0
			from
			until
				not (not js.loop_left and then (l_bufsize___0 > 0))
			loop
				js.reset
				if not (poll_internal (a_fd, l_info, 2, a_timeout)) then
					Result := (-1)
					js.return
				end
				if not js.return_called then
					if ((l_info).c_pointer /= default_pointer) then
						if (((l_info.item.imp).item.writer).c_pointer /= default_pointer) then
							l_res___0 := ((l_info.item.imp).item.writer).integer_32_item ([a_fd, l_buf___6, l_bufsize___0, l_info.item.ctx])
						else
							l_res___0 := sock_write (a_fd, l_buf___6, l_bufsize___0)
						end
					else
						l_res___0 := sock_write (a_fd, l_buf___6, l_bufsize___0)
					end
					if l_res___0 <= 0 then
						js.break
					end
					if not js.loop_jumped then
						l_buf___6.ce_gets (l_buf___6 + l_res___0)
						l_bufsize___0 := l_bufsize___0 - l_res___0
					end
				end
			end
			js.reset
			if not js.return_called then
				Result := l_res___0
			end
		end

	fd_errstr (a_fd: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_info: CE_POINTER [PD_TRANSPORT_INFO]
			l_err: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_info.make
			create l_err.make

			l_info.ce_gets (create {CE_POINTER [PD_TRANSPORT_INFO]}.make_shared (default_pointer))
			if ((transport_map).c_pointer /= default_pointer) then
				l_info.ce_gets (create {CE_POINTER [PD_TRANSPORT_INFO]}.make_cast ((hash_inst.hash_table_get (transport_map, create {CE_POINTER [ANY]}.make_shared (default_pointer + a_fd)))))
			end
			if ((l_info).c_pointer /= default_pointer) then
				if (((l_info.item.imp).item.errstr).c_pointer /= default_pointer) then
					l_err.ce_gets ((create {CE_POINTER [INTEGER_8]}.make_cast (((l_info.item.imp).item.errstr).pointer_item ([a_fd, l_info.item.ctx]))))
					if ((l_err).c_pointer /= default_pointer) then
						Result := l_err
						js.return
					end
				end
			end
			if not js.return_called then
				Result := (strerror ((errno_location).item))
			end
		end

	fd_close (a_fd: INTEGER_32)
		local
			l_info: CE_POINTER [PD_TRANSPORT_INFO]
			js: JUMP_STATE
		do
			create l_info.make

			if a_fd < 0 then
				js.return
			end
			if not js.return_called then
				l_info.ce_gets (create {CE_POINTER [PD_TRANSPORT_INFO]}.make_shared (default_pointer))
				if ((transport_map).c_pointer /= default_pointer) then
					l_info.ce_gets (create {CE_POINTER [PD_TRANSPORT_INFO]}.make_cast ((hash_inst.hash_table_get (transport_map, create {CE_POINTER [ANY]}.make_shared (default_pointer + a_fd)))))
				end
				if ((l_info).c_pointer /= default_pointer) then
					if (((l_info.item.imp).item.closer).c_pointer /= default_pointer) then
						((l_info.item.imp).item.closer).call ([a_fd, l_info.item.ctx])
					else
						sock_close (a_fd)
					end
				else
					sock_close (a_fd)
				end
				if ((l_info).c_pointer /= default_pointer) then
					hash_inst.hash_table_remove (transport_map, create {CE_POINTER [ANY]}.make_shared (default_pointer + a_fd)).do_nothing
					free (create {CE_POINTER [ANY]}.make_cast (l_info))
					transport_map_modified_tick := transport_map_modified_tick + 1
				end
			end
		end

end
