class
	P_CONVERT

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create dl_url_file_map.make
			create downloaded_html_set.make
			create downloaded_css_set.make
			create dl_file_url_map.make
			create converted_files.make
			create downloaded_files_hash.make
		end

feature {ANY} -- attributes

	dl_url_file_map: CE_POINTER [PD_HASH_TABLE]

	downloaded_html_set: CE_POINTER [PD_HASH_TABLE]

	downloaded_css_set: CE_POINTER [PD_HASH_TABLE]

	dl_file_url_map: CE_POINTER [PD_HASH_TABLE]

	converted_files: CE_POINTER [PD_HASH_TABLE]

	downloaded_files_hash: CE_POINTER [PD_HASH_TABLE]

	v1: INTEGER_32 assign set_v1
		do
			Result := v1_address[0]
		end

	set_v1 (a_v1: INTEGER_32)
		do
			v1_address[0] := a_v1
		end

	v1_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	v2: INTEGER_32 assign set_v2
		do
			Result := v2_address[0]
		end

	set_v2 (a_v2: INTEGER_32)
		do
			v2_address[0] := a_v2
		end

	v2_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	v3: INTEGER_32 assign set_v3
		do
			Result := v3_address[0]
		end

	set_v3 (a_v3: INTEGER_32)
		do
			v3_address[0] := a_v3
		end

	v3_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	v4: INTEGER_32 assign set_v4
		do
			Result := v4_address[0]
		end

	set_v4 (a_v4: INTEGER_32)
		do
			v4_address[0] := a_v4
		end

	v4_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

feature {ANY} -- routines

	convert_links_in_hashtable (a_downloaded_set: CE_POINTER [PD_HASH_TABLE]; a_is_css: INTEGER_32; a_file_count: CE_POINTER [INTEGER_32])
		local
			l_i: INTEGER_32
			l_cnt: INTEGER_32
			l_file_array: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_urls: CE_POINTER [PD_URLPOS]
			l_cur_url: CE_POINTER [PD_URLPOS]
			l_url: CE_POINTER [INTEGER_8]
			l_file: CE_POINTER [INTEGER_8]
			l_local_name: CE_POINTER [INTEGER_8]
			l_u: CE_POINTER [PD_URL]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_file_array.make
			create l_urls.make
			create l_cur_url.make
			create l_url.make
			create l_file.make
			create l_local_name.make
			create l_u.make

			l_cnt := 0
			if ((a_downloaded_set).c_pointer /= default_pointer) then
				l_cnt := hash_inst.hash_table_count (a_downloaded_set)
			end
			if l_cnt = 0 then
				js.return
			end
			if not js.return_called then
				l_file_array.ce_gets (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast ((l_aaf.new (l_cnt.to_natural_32 * Pointer_bytes.to_natural_32))))
				utils_inst.string_set_to_array (a_downloaded_set, l_file_array)
				l_i := 0
				from
				until
					not (not js.loop_left and then (l_i < l_cnt))
				loop
					js.reset
					l_file.ce_gets (l_file_array[l_i])
					l_url.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((hash_inst.hash_table_get (dl_file_url_map, create {CE_POINTER [ANY]}.make_cast (l_file)))))
					if (l_url).c_pointer = default_pointer then
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("Apparently %%s has been removed.%N"), l_file])
							end
							js.break
						end
						js.reset
						js.continue
					end
					if not js.loop_jumped then
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("Scanning %%s (from %%s)%N"), l_file, l_url])
							end
							js.break
						end
						js.reset
						if a_is_css.to_boolean then
							l_urls.ce_gets ((css_url_inst.get_urls_css_file (l_file, l_url)))
						else
							l_urls.ce_gets ((html_url_inst.get_urls_html (l_file, l_url, create {CE_POINTER [BOOLEAN]}.make_shared (default_pointer), create {CE_POINTER [PD_IRI]}.make_shared (default_pointer))))
						end
						l_cur_url.ce_gets (l_urls)
						from
						until
							not (not js.loop_left and then ((l_cur_url).c_pointer /= default_pointer))
						loop
							js.reset
							l_u.ce_gets (l_cur_url.item.url)
							if (l_cur_url.item.link_base_p).to_boolean then
								l_cur_url.item.convert2 := {PC_CONVERT_OPTIONS}.CO_NULLIFY_BASE
								js.continue
							end
							if not js.loop_jumped then
								l_local_name.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((hash_inst.hash_table_get (dl_url_file_map, create {CE_POINTER [ANY]}.make_cast (l_u.item.url)))))
								if ((l_local_name).c_pointer /= default_pointer) then
									l_cur_url.item.convert2 := {PC_CONVERT_OPTIONS}.CO_CONVERT_TO_RELATIVE
									l_cur_url.item.local_name := xmalloc_inst.xstrdup (l_local_name)
									from
									until
										js.loop_left
									loop
										js.reset
										if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
											log_inst.debug_logprintf ([ce_string ("will convert url %%s to local %%s%N"), l_u.item.url, l_local_name])
										end
										js.break
									end
									js.reset
								else
									if not (l_cur_url.item.link_complete_p).to_boolean then
										l_cur_url.item.convert2 := {PC_CONVERT_OPTIONS}.CO_CONVERT_TO_COMPLETE
									end
									l_cur_url.item.local_name := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
									from
									until
										js.loop_left
									loop
										js.reset
										if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
											log_inst.debug_logprintf ([ce_string ("will convert url %%s to complete%N"), l_u.item.url])
										end
										js.break
									end
									js.reset
								end
							end
							if not js.loop_left then
								l_cur_url.ce_gets (l_cur_url.item.next)
							end
						end
						convert_links (l_file, l_urls)
						a_file_count.item := (a_file_count.item) + 1
						retr_inst.free_urlpos (l_urls)
					end
					if not js.loop_left then
						l_i := l_i + 1
					end
				end
			end
		end

	convert_all_links
		local
			l_secs: REAL_64
			l_file_count: INTEGER_32
			l_timer: CE_POINTER [PD_PTIMER]
			l_tmp___0: CE_POINTER [INTEGER_8]
		do
			create l_timer.make
			create l_tmp___0.make

			l_file_count := 0
			l_timer.ce_gets ((ptimer_inst.ptimer_new))
			convert_links_in_hashtable (downloaded_html_set, 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_file_count))
			convert_links_in_hashtable (downloaded_css_set, 1, create {CE_POINTER [INTEGER_32]}.make_shared ($l_file_count))
			l_secs := ptimer_inst.ptimer_measure (l_timer)
			l_tmp___0.ce_gets (utils_inst.print_decimal (l_secs))
			log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Converted %%d files in %%s seconds.%N"))), l_file_count, l_tmp___0])
			ptimer_inst.ptimer_destroy (l_timer)
		end

	convert_links (a_file: CE_POINTER [INTEGER_8]; a_links: CE_POINTER [PD_URLPOS])
		local
			l_fm: CE_POINTER [PD_FILE_MEMORY]
			l_fp: CE_POINTER [SD_IO_FILE]
			l_p___0: CE_POINTER [INTEGER_8]
			l_downloaded_file_return: INTEGER_32
			l_link___0: CE_POINTER [PD_URLPOS]
			l_to_url_count: INTEGER_32
			l_to_file_count: INTEGER_32
			l_dry_count: INTEGER_32
			l_dry: CE_POINTER [PD_URLPOS]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_url_start: CE_POINTER [INTEGER_8]
			l_newname: CE_POINTER [INTEGER_8]
			l_quoted_newname: CE_POINTER [INTEGER_8]
			l_newlink: CE_POINTER [INTEGER_8]
			l_quoted_newlink: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fm.make
			create l_fp.make
			create l_p___0.make
			create l_link___0.make
			create l_dry.make
			create l_tmp___2.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___11.make
			create l_url_start.make
			create l_newname.make
			create l_quoted_newname.make
			create l_newlink.make
			create l_quoted_newlink.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_to_url_count := 0
					l_to_file_count := 0
					log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Converting %%s... "))), a_file])
					l_dry_count := 0
					l_dry.ce_gets (a_links)
					from
					until
						(l_dry).c_pointer = default_pointer
					loop
						if (l_dry.item.convert2).to_natural_32 /= {NATURAL_32} 0 then
							l_dry_count := l_dry_count + 1
						end
						l_dry.ce_gets (l_dry.item.next)
					end
					if not l_dry_count.to_boolean then
						log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("nothing to do.%N"))))
						js.return
					end
					if not js.return_called then
						l_fm.ce_gets (utils_inst.read_file (a_file))
						if (l_fm).c_pointer = default_pointer then
							l_tmp___2.ce_gets (strerror ((errno_location).item))
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Cannot convert links in %%s: %%s%N"))), a_file, l_tmp___2])
							js.return
						end
					end
					if not js.return_called then
						l_downloaded_file_return := downloaded_file ({PC_DOWNLOADED_FILE_T}.CHECK_FOR_FILE, a_file)
						if options_inst.opt.backup_converted then
							if l_downloaded_file_return.to_boolean then
								write_backup_file (a_file, l_downloaded_file_return)
							end
						end
						if (unlink (a_file)) < 0 then
							if (errno_location).item /= 2 then
								l_tmp___5.ce_gets (strerror ((errno_location).item))
								l_tmp___6.ce_gets (quote_inst.quote (a_file))
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Unable to delete %%s: %%s%N"))), l_tmp___6, l_tmp___5])
								utils_inst.read_file_free (l_fm)
								js.return
							end
						end
					end
					if not js.return_called then
						l_fp.ce_gets (fopen (a_file, ce_string ("wb")))
						if (l_fp).c_pointer = default_pointer then
							l_tmp___11.ce_gets (strerror ((errno_location).item))
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Cannot convert links in %%s: %%s%N"))), a_file, l_tmp___11])
							utils_inst.read_file_free (l_fm)
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						l_p___0.ce_gets (l_fm.item.content)
						l_link___0.ce_gets (a_links)
				when 2 then -- loop condition:
						if not (not js.loop_left and then ((l_link___0).c_pointer /= default_pointer)) then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						l_url_start.ce_gets (l_fm.item.content + l_link___0.item.pos)
						if (l_link___0.item.pos).to_integer_32 >= l_fm.item.length then
							from
							until
								js.loop_left
							loop
								js.reset
								if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string ("Something strange is going on.  Please investigate.")])
								end
								js.break
							end
							js.reset
							js.break
						end
						if not js.loop_jumped and then ((l_link___0.item.convert2).to_natural_32 = {NATURAL_32} 0) then
							from
							until
								js.loop_left
							loop
								js.reset
								if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string ("Skipping %%s at position %%d.%N"), (l_link___0.item.url).item.url, l_link___0.item.pos])
								end
								js.break
							end
							js.reset
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						fwrite (create {CE_POINTER [ANY]}.make_cast (l_p___0), (1).to_natural_32, (l_url_start.distance (l_p___0)).to_natural_32, l_fp).do_nothing
						l_p___0.ce_gets (l_url_start)
						inspect l_link___0.item.convert2 -- switch 1 head
						when 1 then l_pos := -1 + 5
						when 2 then l_pos := -1 + 6
						when 3 then l_pos := -1 + 7
						when 0 then l_pos := -1 + 8
						else l_pos := -1 + 9
						end
				when 5 then -- switch 1, case 1
						l_newname.ce_gets ((construct_relative (a_file, l_link___0.item.local_name)))
						l_quoted_newname.ce_gets ((local_quote_string (l_newname)))
						if (l_link___0.item.link_css_p).to_boolean then
							l_p___0.ce_gets (replace_plain (l_p___0, l_link___0.item.size, l_fp, l_quoted_newname))
						elseif not (l_link___0.item.link_refresh_p).to_boolean then
							l_p___0.ce_gets (replace_attr (l_p___0, l_link___0.item.size, l_fp, l_quoted_newname))
						else
							l_p___0.ce_gets (replace_attr_refresh_hack (l_p___0, l_link___0.item.size, l_fp, l_quoted_newname, l_link___0.item.refresh_timeout))
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("TO_RELATIVE: %%s to %%s at position %%d in %%s.%N"), (l_link___0.item.url).item.url, l_newname, l_link___0.item.pos, a_file])
							end
							js.break
						end
						js.reset
						free (create {CE_POINTER [ANY]}.make_cast (l_newname))
						free (create {CE_POINTER [ANY]}.make_cast (l_quoted_newname))
						l_to_file_count := l_to_file_count + 1
						l_pos := -1 + 9 -- switch 1; break
				when 6 then -- switch 1, case 2
						l_newlink.ce_gets ((l_link___0.item.url).item.url)
						l_quoted_newlink.ce_gets ((html_quote_string (l_newlink)))
						if (l_link___0.item.link_css_p).to_boolean then
							l_p___0.ce_gets (replace_plain (l_p___0, l_link___0.item.size, l_fp, l_quoted_newlink))
						elseif not (l_link___0.item.link_refresh_p).to_boolean then
							l_p___0.ce_gets (replace_attr (l_p___0, l_link___0.item.size, l_fp, l_quoted_newlink))
						else
							l_p___0.ce_gets (replace_attr_refresh_hack (l_p___0, l_link___0.item.size, l_fp, l_quoted_newlink, l_link___0.item.refresh_timeout))
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("TO_COMPLETE: <something> to %%s at position %%d in %%s.%N"), l_newlink, l_link___0.item.pos, a_file])
							end
							js.break
						end
						js.reset
						free (create {CE_POINTER [ANY]}.make_cast (l_quoted_newlink))
						l_to_url_count := l_to_url_count + 1
						l_pos := -1 + 9 -- switch 1; break
				when 7 then -- switch 1, case 3
						l_p___0.ce_gets (replace_attr (l_p___0, l_link___0.item.size, l_fp, ce_string ("")))
						l_pos := -1 + 9 -- switch 1; break
				when 8 then -- switch 1, case 0
						abort
						l_pos := -1 + 9 -- switch 1; break
				when 9 then -- switch 1, done: | if done
						if not js.loop_left then
							l_link___0.ce_gets (l_link___0.item.next)
						end
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						js.reset
						if (l_p___0.distance ((l_fm.item.content))).to_integer_32 < l_fm.item.length then
							fwrite (create {CE_POINTER [ANY]}.make_cast (l_p___0), (1).to_natural_32, (l_fm.item.length - (l_p___0.distance ((l_fm.item.content))).to_integer_32).to_natural_32, l_fp).do_nothing
						end
						fclose (l_fp).do_nothing
						utils_inst.read_file_free (l_fm)
						log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%%d-%%d%N"), l_to_file_count, l_to_url_count])
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	construct_relative (a_basefile: CE_POINTER [INTEGER_8]; a_linkfile: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_basefile: CE_POINTER [INTEGER_8]
			l_linkfile: CE_POINTER [INTEGER_8]
			l_link___0: CE_POINTER [INTEGER_8]
			l_basedirs: INTEGER_32
			l_b: CE_POINTER [INTEGER_8]
			l_l: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			l_start: INTEGER_32
			js: JUMP_STATE
		do
			create l_basefile.make
			create l_linkfile.make
			create l_link___0.make
			create l_b.make
			create l_l.make

			l_basefile.ce_gets (a_basefile)
			l_linkfile.ce_gets (a_linkfile)
			l_start := 0
			l_b.ce_gets (l_basefile)
			l_l.ce_gets (l_linkfile)
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_b[0]).to_integer_32 = (l_l[0]).to_integer_32 then
					if (l_b[0]).to_integer_32 = 0 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if (l_b[0]).to_integer_32 = 47 then
						l_start := (l_b.distance (l_basefile)) + 1
					end
					l_b.ce_gets (l_b + 1)
					l_l.ce_gets (l_l + 1)
				end
			end
			js.reset
			l_basefile.ce_gets (l_basefile + l_start)
			l_linkfile.ce_gets (l_linkfile + l_start)
			l_basedirs := 0
			l_b.ce_gets (l_basefile)
			from
			until
				not ((l_b[0]).to_boolean)
			loop
				if (l_b[0]).to_integer_32 = 47 then
					l_basedirs := l_basedirs + 1
				end
				l_b.ce_gets (l_b + 1)
			end
			l_link___0.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc (((3 * l_basedirs).to_natural_32 + (strlen (l_linkfile))) + {NATURAL_32} 1))))
			l_i := 0
			from
			until
				not (l_i < l_basedirs)
			loop
				memcpy (create {CE_POINTER [ANY]}.make_cast ((l_link___0 + 3 * l_i)), create {CE_POINTER [ANY]}.make_cast (ce_string ("../")), (3).to_natural_32).do_nothing
				l_i := l_i + 1
			end
			strcpy ((l_link___0 + 3 * l_i), l_linkfile).do_nothing
			Result := l_link___0
		end

	write_backup_file (a_file: CE_POINTER [INTEGER_8]; a_downloaded_file_return: INTEGER_32)
		local
			l_filename_len: NATURAL_32
			l_filename_plus_orig_suffix: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_filename_plus_orig_suffix.make
			create l_tmp___3.make

			l_filename_len := (strlen (a_file))
			if a_downloaded_file_return.to_natural_32 = {NATURAL_32} 2 then
				l_filename_plus_orig_suffix.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new (l_filename_len + {NATURAL_32} 1))))
				strcpy (l_filename_plus_orig_suffix, a_file).do_nothing
				strcpy (((l_filename_plus_orig_suffix + l_filename_len.to_integer_32) - 4), ce_string ("orig")).do_nothing
			else
				l_filename_plus_orig_suffix.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new (l_filename_len + ((".orig").count + 1).to_natural_32))))
				strcpy (l_filename_plus_orig_suffix, a_file).do_nothing
				strcpy ((l_filename_plus_orig_suffix + l_filename_len.to_integer_32), ce_string (".orig")).do_nothing
			end
			if (converted_files).c_pointer = default_pointer then
				converted_files.ce_gets (hash_inst.make_string_hash_table (0))
			end
			if not (utils_inst.string_set_contains (converted_files, a_file)).to_boolean then
				if (rename2 (a_file, l_filename_plus_orig_suffix)) /= 0 then
					l_tmp___3.ce_gets (strerror ((errno_location).item))
					log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Cannot back up %%s as %%s: %%s%N"))), a_file, l_filename_plus_orig_suffix, l_tmp___3])
				end
				utils_inst.string_set_add (converted_files, a_file)
			end
		end

	replace_plain (a_p___0: CE_POINTER [INTEGER_8]; a_size: INTEGER_32; a_fp: CE_POINTER [SD_IO_FILE]; a_new_text: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_p___0: CE_POINTER [INTEGER_8]
		do
			create l_p___0.make

			l_p___0.ce_gets (a_p___0)
			fputs (a_new_text, a_fp).do_nothing
			l_p___0.ce_gets (l_p___0 + a_size)
			Result := l_p___0
		end

	replace_attr (a_p___0: CE_POINTER [INTEGER_8]; a_size: INTEGER_32; a_fp: CE_POINTER [SD_IO_FILE]; a_new_text: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_size: INTEGER_32
			l_quote_flag: BOOLEAN
			l_quote_char: INTEGER_8
			l_frag_beg: CE_POINTER [INTEGER_8]
			l_frag_end: CE_POINTER [INTEGER_8]
		do
			create l_p___0.make
			create l_frag_beg.make
			create l_frag_end.make

			l_p___0.ce_gets (a_p___0)
			l_size := a_size
			l_quote_flag := (0).to_boolean
			l_quote_char := (('%"').code).to_integer_8
			if (l_p___0[0]).to_integer_32 = 34 then
				l_quote_char := l_p___0[0]
				l_quote_flag := (1).to_boolean
				l_p___0.ce_gets (l_p___0 + 1)
				l_size := l_size - (2)
			elseif (l_p___0[0]).to_integer_32 = 39 then
				l_quote_char := l_p___0[0]
				l_quote_flag := (1).to_boolean
				l_p___0.ce_gets (l_p___0 + 1)
				l_size := l_size - (2)
			end
			IO_putc (l_quote_char.to_integer_32, a_fp).do_nothing
			fputs (a_new_text, a_fp).do_nothing
			if (find_fragment (l_p___0, l_size, l_frag_beg.address, l_frag_end.address)) then
				fwrite (create {CE_POINTER [ANY]}.make_cast (l_frag_beg), (1).to_natural_32, (l_frag_end.distance (l_frag_beg)).to_natural_32, a_fp).do_nothing
			end
			l_p___0.ce_gets (l_p___0 + l_size)
			if l_quote_flag then
				l_p___0.ce_gets (l_p___0 + 1)
			end
			IO_putc (l_quote_char.to_integer_32, a_fp).do_nothing
			Result := l_p___0
		end

	replace_attr_refresh_hack (a_p___0: CE_POINTER [INTEGER_8]; a_size: INTEGER_32; a_fp: CE_POINTER [SD_IO_FILE]; a_new_text: CE_POINTER [INTEGER_8]; a_timeout: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_new_with_timeout: CE_POINTER [INTEGER_8]
			l_tmp: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_new_with_timeout.make

			l_tmp := utils_inst.numdigit (a_timeout.to_integer_64)
			l_new_with_timeout.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new (((l_tmp + 6).to_natural_32 + (strlen (a_new_text))) + {NATURAL_32} 1))))
			sprintf ([l_new_with_timeout, ce_string ("%%d; URL=%%s"), a_timeout, a_new_text]).do_nothing
			Result := (replace_attr (a_p___0, a_size, a_fp, l_new_with_timeout))
		end

	find_fragment (a_beg: CE_POINTER [INTEGER_8]; a_size: INTEGER_32; a_bp: CE_POINTER [CE_POINTER [INTEGER_8]]; a_ep: CE_POINTER [CE_POINTER [INTEGER_8]]): BOOLEAN
		local
			l_beg: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			l_saw_amp: BOOLEAN
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_beg.make
			create l_end.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_beg.ce_gets (a_beg)
					l_end.ce_gets (l_beg + a_size)
					l_saw_amp := (0).to_boolean
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_beg.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32)) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						inspect (l_beg[0]).to_integer_32 -- switch 1 head
						when 38 then l_pos := -1 + 3
						when 35 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 3 then -- switch 1, case 38
						l_saw_amp := (1).to_boolean
						l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 35
						if not l_saw_amp then
							a_bp.item := l_beg
							a_ep.item := l_end
							Result := (1).to_boolean
							js.return
						end
				when 5 then -- switch 1, default:
						if not js.return_called then
							l_saw_amp := (0).to_boolean
						end
				when 6 then -- switch 1, done:
						if not js.return_called then
							l_beg.ce_gets (l_beg + 1)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					if not js.return_called then
						Result := (0).to_boolean
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	local_quote_string (a_file: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_from: CE_POINTER [INTEGER_8]
			l_newname: CE_POINTER [INTEGER_8]
			l_to: CE_POINTER [INTEGER_8]
			l_any: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: CE_POINTER [INTEGER_8]
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___15: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_from.make
			create l_newname.make
			create l_to.make
			create l_any.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___7.make
			create l_tmp___8.make
			create l_tmp___9.make
			create l_tmp___10.make
			create l_tmp___11.make
			create l_tmp___12.make
			create l_tmp___13.make
			create l_tmp___14.make
			create l_tmp___15.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_any.ce_gets ((strpbrk (a_file, ce_string ("?#%%;"))))
					if (l_any).c_pointer = default_pointer then
						Result := (html_quote_string (a_file))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						l_newname.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new ({NATURAL_32} 3 * (strlen (a_file)) + {NATURAL_32} 1))))
						l_to.ce_gets (l_newname)
						l_from.ce_gets (a_file)
				when 2 then -- loop condition:
						if not ((l_from[0]).to_boolean) then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						inspect (l_from[0]).to_integer_32 -- switch 1 head
						when 37 then l_pos := -1 + 4
						when 35 then l_pos := -1 + 5
						when 59 then l_pos := -1 + 6
						when 63 then l_pos := -1 + 7
						else l_pos := -1 + 8
						end
				when 4 then -- switch 1, case 37
						l_tmp___3.ce_gets (l_to)
						l_to.ce_gets (l_to + 1)
						l_tmp___3[0] := (('%%').code).to_integer_8
						l_tmp___4.ce_gets (l_to)
						l_to.ce_gets (l_to + 1)
						l_tmp___4[0] := (('2').code).to_integer_8
						l_tmp___5.ce_gets (l_to)
						l_to.ce_gets (l_to + 1)
						l_tmp___5[0] := (('5').code).to_integer_8
						l_pos := -1 + 9 -- switch 1; break
				when 5 then -- switch 1, case 35
						l_tmp___6.ce_gets (l_to)
						l_to.ce_gets (l_to + 1)
						l_tmp___6[0] := (('%%').code).to_integer_8
						l_tmp___7.ce_gets (l_to)
						l_to.ce_gets (l_to + 1)
						l_tmp___7[0] := (('2').code).to_integer_8
						l_tmp___8.ce_gets (l_to)
						l_to.ce_gets (l_to + 1)
						l_tmp___8[0] := (('3').code).to_integer_8
						l_pos := -1 + 9 -- switch 1; break
				when 6 then -- switch 1, case 59
						l_tmp___9.ce_gets (l_to)
						l_to.ce_gets (l_to + 1)
						l_tmp___9[0] := (('%%').code).to_integer_8
						l_tmp___10.ce_gets (l_to)
						l_to.ce_gets (l_to + 1)
						l_tmp___10[0] := (('3').code).to_integer_8
						l_tmp___11.ce_gets (l_to)
						l_to.ce_gets (l_to + 1)
						l_tmp___11[0] := (('B').code).to_integer_8
						l_pos := -1 + 9 -- switch 1; break
				when 7 then -- switch 1, case 63
						if options_inst.opt.adjust_extension then
							l_tmp___12.ce_gets (l_to)
							l_to.ce_gets (l_to + 1)
							l_tmp___12[0] := (('%%').code).to_integer_8
							l_tmp___13.ce_gets (l_to)
							l_to.ce_gets (l_to + 1)
							l_tmp___13[0] := (('3').code).to_integer_8
							l_tmp___14.ce_gets (l_to)
							l_to.ce_gets (l_to + 1)
							l_tmp___14[0] := (('F').code).to_integer_8
							l_pos := -1 + 9 -- switch 1; break
						end
				when 8 then -- switch 1, default:
						l_tmp___15.ce_gets (l_to)
						l_to.ce_gets (l_to + 1)
						l_tmp___15[0] := l_from[0]
				when 9 then -- switch 1, done:
						l_from.ce_gets (l_from + 1)
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						l_to[0] := (('%/0/').code).to_integer_8
						Result := (html_quote_string (l_newname))
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	match_except_index (a_s1: CE_POINTER [INTEGER_8]; a_s2: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_s1: CE_POINTER [INTEGER_8]
			l_s2: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			l_lng: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s1.make
			create l_s2.make
			create l_lng.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s1.ce_gets (a_s1)
					l_s2.ce_gets (a_s2)
					l_i := 0
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_s1[0]).to_boolean then
							if (l_s2[0]).to_boolean then
								if (l_s1[0]).to_integer_32 /= (l_s2[0]).to_integer_32 then
									js.break
								end
							else
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_s1.ce_gets (l_s1 + 1)
							l_s2.ce_gets (l_s2 + 1)
							l_i := l_i + 1
						end
					end
					js.reset
					if l_i = 0 then
						Result := (0).to_boolean
						js.return
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if (l_s1[0]).to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if not (l_s2[0]).to_boolean then
							Result := (1).to_boolean
							js.return
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if not ((l_s1[0]).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (l_s2[0]).to_boolean then
							Result := (0).to_boolean
							js.return
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if (l_s1[0]).to_boolean then
							l_lng.ce_gets (l_s1)
						else
							l_lng.ce_gets (l_s2)
						end
				when 8 then -- if done | if done
						if not js.return_called then
							if (l_lng[0]).to_integer_32 /= 47 then
								l_lng.ce_gets (l_lng - 1)
							end
							if (l_lng[0]).to_integer_32 = 47 then
								if (l_lng[1]).to_integer_32 = 0 then
									Result := (1).to_boolean
									js.return
								end
							end
						end
						if not js.return_called then
							Result := (0 = (strcmp (l_lng, ce_string ("/index.html"))))
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	dissociate_urls_from_file_mapper (a_key: CE_POINTER [ANY]; a_value: CE_POINTER [ANY]; a_arg: CE_POINTER [ANY]): INTEGER_32
		local
			l_mapping_url: CE_POINTER [INTEGER_8]
			l_mapping_file: CE_POINTER [INTEGER_8]
			l_file: CE_POINTER [INTEGER_8]
		do
			create l_mapping_url.make
			create l_mapping_file.make
			create l_file.make

			l_mapping_url.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (a_key))
			l_mapping_file.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (a_value))
			l_file.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (a_arg))
			if 0 = (strcmp (l_mapping_file, l_file)) then
				hash_inst.hash_table_remove (dl_url_file_map, create {CE_POINTER [ANY]}.make_cast (l_mapping_url)).do_nothing
				free (create {CE_POINTER [ANY]}.make_cast (l_mapping_url))
				free (create {CE_POINTER [ANY]}.make_cast (l_mapping_file))
			end
			Result := 0
		end

	dissociate_urls_from_file_mapper_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dissociate_urls_from_file_mapper)
		end

	dissociate_urls_from_file (a_file: CE_POINTER [INTEGER_8])
		do
			hash_inst.hash_table_for_each (dl_url_file_map, dissociate_urls_from_file_mapper_address, create {CE_POINTER [ANY]}.make_cast (a_file))
		end

	register_download (a_url: CE_POINTER [INTEGER_8]; a_file: CE_POINTER [INTEGER_8])
		local
			l_old_file: CE_POINTER [INTEGER_8]
			l_old_url: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_old_file.make
			create l_old_url.make
			create l_tmp___3.make
			create l_tmp___6.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					from
					until
						js.loop_left
					loop
						js.reset
						if (dl_file_url_map).c_pointer = default_pointer then
							dl_file_url_map.ce_gets (hash_inst.make_string_hash_table (0))
						end
						if (dl_url_file_map).c_pointer = default_pointer then
							dl_url_file_map.ce_gets (hash_inst.make_string_hash_table (0))
						end
						js.break
					end
					js.reset
					if not ((hash_inst.hash_table_get_pair (dl_file_url_map, create {CE_POINTER [ANY]}.make_cast (a_file), create {CE_POINTER [ANY]}.make_cast ((l_old_file.address)), create {CE_POINTER [ANY]}.make_cast ((l_old_url.address)))).to_boolean) then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						if 0 = (strcmp (a_url, l_old_url)) then
							js.return
						end
						if js.return_called then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (match_except_index (a_url, l_old_url)) then
							if not (hash_inst.hash_table_contains (dl_url_file_map, create {CE_POINTER [ANY]}.make_cast (a_url))).to_boolean then
								l_pos := -1 + 6 -- goto url_only
							end
						end
				when 3 then
						hash_inst.hash_table_remove (dl_file_url_map, create {CE_POINTER [ANY]}.make_cast (a_file)).do_nothing
						free (create {CE_POINTER [ANY]}.make_cast (l_old_file))
						free (create {CE_POINTER [ANY]}.make_cast (l_old_url))
						dissociate_urls_from_file (a_file)
				when 4 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
							l_tmp___3.ce_gets (xmalloc_inst.xstrdup (a_url))
							hash_inst.hash_table_put (dl_file_url_map, create {CE_POINTER [ANY]}.make_cast ((xmalloc_inst.xstrdup (a_file))), create {CE_POINTER [ANY]}.make_cast (l_tmp___3))
				when 6 then -- url_only:
							if (hash_inst.hash_table_get_pair (dl_url_file_map, create {CE_POINTER [ANY]}.make_cast (a_url), create {CE_POINTER [ANY]}.make_cast ((l_old_url.address)), create {CE_POINTER [ANY]}.make_cast ((l_old_file.address)))).to_boolean then
								hash_inst.hash_table_remove (dl_url_file_map, create {CE_POINTER [ANY]}.make_cast (a_url)).do_nothing
								free (create {CE_POINTER [ANY]}.make_cast (l_old_url))
								free (create {CE_POINTER [ANY]}.make_cast (l_old_file))
							end
							l_tmp___6.ce_gets (xmalloc_inst.xstrdup (a_file))
							hash_inst.hash_table_put (dl_url_file_map, create {CE_POINTER [ANY]}.make_cast ((xmalloc_inst.xstrdup (a_url))), create {CE_POINTER [ANY]}.make_cast (l_tmp___6))
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	register_redirection (a_from: CE_POINTER [INTEGER_8]; a_to: CE_POINTER [INTEGER_8])
		local
			l_file: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_file.make
			create l_tmp___0.make

			from
			until
				js.loop_left
			loop
				js.reset
				if (dl_file_url_map).c_pointer = default_pointer then
					dl_file_url_map.ce_gets (hash_inst.make_string_hash_table (0))
				end
				if (dl_url_file_map).c_pointer = default_pointer then
					dl_url_file_map.ce_gets (hash_inst.make_string_hash_table (0))
				end
				js.break
			end
			js.reset
			l_file.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((hash_inst.hash_table_get (dl_url_file_map, create {CE_POINTER [ANY]}.make_cast (a_to)))))
			if (l_file.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				assert_fail (ce_string ("file != ((void *)0)"), ce_string ("convert.c"), {NATURAL_32} 838, ce_string ("register_redirection"))
			end
			if not (hash_inst.hash_table_contains (dl_url_file_map, create {CE_POINTER [ANY]}.make_cast (a_from))).to_boolean then
				l_tmp___0.ce_gets (xmalloc_inst.xstrdup (l_file))
				hash_inst.hash_table_put (dl_url_file_map, create {CE_POINTER [ANY]}.make_cast ((xmalloc_inst.xstrdup (a_from))), create {CE_POINTER [ANY]}.make_cast (l_tmp___0))
			end
		end

	register_delete_file (a_file: CE_POINTER [INTEGER_8])
		local
			l_old_url: CE_POINTER [INTEGER_8]
			l_old_file: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_old_url.make
			create l_old_file.make

			from
			until
				js.loop_left
			loop
				js.reset
				if (dl_file_url_map).c_pointer = default_pointer then
					dl_file_url_map.ce_gets (hash_inst.make_string_hash_table (0))
				end
				if (dl_url_file_map).c_pointer = default_pointer then
					dl_url_file_map.ce_gets (hash_inst.make_string_hash_table (0))
				end
				js.break
			end
			js.reset
			if not (hash_inst.hash_table_get_pair (dl_file_url_map, create {CE_POINTER [ANY]}.make_cast (a_file), create {CE_POINTER [ANY]}.make_cast ((l_old_file.address)), create {CE_POINTER [ANY]}.make_cast ((l_old_url.address)))).to_boolean then
				js.return
			end
			if not js.return_called then
				hash_inst.hash_table_remove (dl_file_url_map, create {CE_POINTER [ANY]}.make_cast (a_file)).do_nothing
				free (create {CE_POINTER [ANY]}.make_cast (l_old_file))
				free (create {CE_POINTER [ANY]}.make_cast (l_old_url))
				dissociate_urls_from_file (a_file)
			end
		end

	register_html (a_url: CE_POINTER [INTEGER_8]; a_file: CE_POINTER [INTEGER_8])
		do
			if (downloaded_html_set).c_pointer = default_pointer then
				downloaded_html_set.ce_gets (hash_inst.make_string_hash_table (0))
			end
			utils_inst.string_set_add (downloaded_html_set, a_file)
		end

	register_css (a_url: CE_POINTER [INTEGER_8]; a_file: CE_POINTER [INTEGER_8])
		do
			if (downloaded_css_set).c_pointer = default_pointer then
				downloaded_css_set.ce_gets (hash_inst.make_string_hash_table (0))
			end
			utils_inst.string_set_add (downloaded_css_set, a_file)
		end

	convert_cleanup
		do
			if ((dl_file_url_map).c_pointer /= default_pointer) then
				utils_inst.free_keys_and_values (dl_file_url_map)
				hash_inst.hash_table_destroy (dl_file_url_map)
				dl_file_url_map.ce_gets (create {CE_POINTER [PD_HASH_TABLE]}.make_shared (default_pointer))
			end
			if ((dl_url_file_map).c_pointer /= default_pointer) then
				utils_inst.free_keys_and_values (dl_url_file_map)
				hash_inst.hash_table_destroy (dl_url_file_map)
				dl_url_file_map.ce_gets (create {CE_POINTER [PD_HASH_TABLE]}.make_shared (default_pointer))
			end
			if ((downloaded_html_set).c_pointer /= default_pointer) then
				utils_inst.string_set_free (downloaded_html_set)
			end
			downloaded_files_free
			if ((converted_files).c_pointer /= default_pointer) then
				utils_inst.string_set_free (converted_files)
			end
		end

	downloaded_mode_to_ptr (a_mode: INTEGER_32): CE_POINTER [INTEGER_32]
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_mode -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 0
					Result := (v1_address)
					js.return
				when 2 then -- switch 1, case 1
					if not js.return_called then
						Result := (v2_address)
						js.return
					end
				when 3 then -- switch 1, case 2
					if not js.return_called then
						Result := (v3_address)
						js.return
					end
				when 4 then -- switch 1, case 3
					if not js.return_called then
						Result := (v4_address)
						js.return
					end
				when 5 then -- switch 1, done:
					if not js.return_called then
						Result := (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	downloaded_file (a_mode: INTEGER_32; a_file: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_ptr: CE_POINTER [INTEGER_32]
			js: JUMP_STATE
		do
			create l_ptr.make

			if a_mode.to_natural_32 = {NATURAL_32} 3 then
				if (downloaded_files_hash).c_pointer = default_pointer then
					Result := ({PC_DOWNLOADED_FILE_T}.FILE_NOT_ALREADY_DOWNLOADED)
					js.return
				end
				if not js.return_called then
					l_ptr.ce_gets (create {CE_POINTER [INTEGER_32]}.make_cast ((hash_inst.hash_table_get (downloaded_files_hash, create {CE_POINTER [ANY]}.make_cast (a_file)))))
					if (l_ptr).c_pointer = default_pointer then
						Result := ({PC_DOWNLOADED_FILE_T}.FILE_NOT_ALREADY_DOWNLOADED)
						js.return
					end
				end
				if not js.return_called then
					Result := (l_ptr.item)
					js.return
				end
			end
			if not js.return_called then
				if (downloaded_files_hash).c_pointer = default_pointer then
					downloaded_files_hash.ce_gets (hash_inst.make_string_hash_table (0))
				end
				l_ptr.ce_gets (create {CE_POINTER [INTEGER_32]}.make_cast ((hash_inst.hash_table_get (downloaded_files_hash, create {CE_POINTER [ANY]}.make_cast (a_file)))))
				if ((l_ptr).c_pointer /= default_pointer) then
					Result := (l_ptr.item)
					js.return
				end
			end
			if not js.return_called then
				l_ptr.ce_gets (downloaded_mode_to_ptr (a_mode))
				hash_inst.hash_table_put (downloaded_files_hash, create {CE_POINTER [ANY]}.make_cast ((xmalloc_inst.xstrdup (a_file))), create {CE_POINTER [ANY]}.make_cast (l_ptr))
				Result := ({PC_DOWNLOADED_FILE_T}.FILE_NOT_ALREADY_DOWNLOADED)
			end
		end

	downloaded_files_free
		local
			l_iter: PD_HASH_TABLE_ITERATOR
			js: JUMP_STATE
		do
			create l_iter.make

			if ((downloaded_files_hash).c_pointer /= default_pointer) then
				hash_inst.hash_table_iterate (downloaded_files_hash, l_iter.address)
				from
				until
					js.loop_left
				loop
					js.reset
					if not (hash_inst.hash_table_iter_next (l_iter.address)).to_boolean then
						js.break
					end
					if not js.loop_jumped then
						free (l_iter.key)
					end
				end
				js.reset
				hash_inst.hash_table_destroy (downloaded_files_hash)
				downloaded_files_hash.ce_gets (create {CE_POINTER [PD_HASH_TABLE]}.make_shared (default_pointer))
			end
		end

	html_quote_string (a_s: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_s: CE_POINTER [INTEGER_8]
			l_b: CE_POINTER [INTEGER_8]
			l_p___0: CE_POINTER [INTEGER_8]
			l_res___0: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: CE_POINTER [INTEGER_8]
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___17: CE_POINTER [INTEGER_8]
			l_tmp___18: CE_POINTER [INTEGER_8]
			l_tmp___19: CE_POINTER [INTEGER_8]
			l_tmp___20: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_b.make
			create l_p___0.make
			create l_res___0.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___7.make
			create l_tmp___8.make
			create l_tmp___9.make
			create l_tmp___10.make
			create l_tmp___11.make
			create l_tmp___12.make
			create l_tmp___13.make
			create l_tmp___14.make
			create l_tmp___15.make
			create l_tmp___16.make
			create l_tmp___17.make
			create l_tmp___18.make
			create l_tmp___19.make
			create l_tmp___20.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s.ce_gets (a_s)
					l_b.ce_gets (l_s)
					l_i := 0
					from
					until
						not ((l_s[0]).to_boolean)
					loop
						if (l_s[0]).to_integer_32 = 38 then
							l_i := l_i + (4)
						elseif (l_s[0]).to_integer_32 = 60 then
							l_i := l_i + (3)
						elseif (l_s[0]).to_integer_32 = 62 then
							l_i := l_i + (3)
						elseif (l_s[0]).to_integer_32 = 34 then
							l_i := l_i + (5)
						elseif (l_s[0]).to_integer_32 = 32 then
							l_i := l_i + (4)
						end
						l_s.ce_gets (l_s + 1)
						l_i := l_i + 1
					end
					l_res___0.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc ((l_i + 1).to_natural_32))))
					l_s.ce_gets (l_b)
					l_p___0.ce_gets (l_res___0)
				when 1 then -- loop condition:
					if not ((l_s[0]).to_boolean) then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						inspect (l_s[0]).to_integer_32 -- switch 1 head
						when 38 then l_pos := -1 + 3
						when 60 then l_pos := -1 + 4
						when 62 then l_pos := -1 + 4
						when 34 then l_pos := -1 + 5
						when 32 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 3 then -- switch 1, case 38
						l_tmp___0.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___0[0] := (('&').code).to_integer_8
						l_tmp___1.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___1[0] := (('a').code).to_integer_8
						l_tmp___2.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___2[0] := (('m').code).to_integer_8
						l_tmp___3.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___3[0] := (('p').code).to_integer_8
						l_tmp___4.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___4[0] := ((';').code).to_integer_8
						l_pos := -1 + 8 -- switch 1; break
				when 4 then -- switch 1, case 60 | switch 1, case 62
						l_tmp___5.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___5[0] := (('&').code).to_integer_8
						l_tmp___6.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						if (l_s[0]).to_integer_32 = 60 then
							l_tmp___6[0] := (('l').code).to_integer_8
						else
							l_tmp___6[0] := (('g').code).to_integer_8
						end
						l_tmp___7.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___7[0] := (('t').code).to_integer_8
						l_tmp___8.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___8[0] := ((';').code).to_integer_8
						l_pos := -1 + 8 -- switch 1; break
				when 5 then -- switch 1, case 34
						l_tmp___9.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___9[0] := (('&').code).to_integer_8
						l_tmp___10.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___10[0] := (('q').code).to_integer_8
						l_tmp___11.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___11[0] := (('u').code).to_integer_8
						l_tmp___12.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___12[0] := (('o').code).to_integer_8
						l_tmp___13.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___13[0] := (('t').code).to_integer_8
						l_tmp___14.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___14[0] := ((';').code).to_integer_8
						l_pos := -1 + 8 -- switch 1; break
				when 6 then -- switch 1, case 32
						l_tmp___15.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___15[0] := (('&').code).to_integer_8
						l_tmp___16.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___16[0] := (('#').code).to_integer_8
						l_tmp___17.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___17[0] := (('3').code).to_integer_8
						l_tmp___18.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___18[0] := (('2').code).to_integer_8
						l_tmp___19.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___19[0] := ((';').code).to_integer_8
						l_pos := -1 + 8 -- switch 1; break
				when 7 then -- switch 1, default:
						l_tmp___20.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___20[0] := l_s[0]
				when 8 then -- switch 1, done:
						l_s.ce_gets (l_s + 1)
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
					l_p___0[0] := (('%/0/').code).to_integer_8
					Result := l_res___0
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
