class
	P_COOKIES

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create known_toplevel_domains.make (<<7>>)
		end

feature {ANY} -- attributes

	cookies_now: INTEGER_32 assign set_cookies_now

	set_cookies_now (a_cookies_now: INTEGER_32)
		do
			cookies_now := a_cookies_now
		end

	known_toplevel_domains: CE_ARRAY [CE_POINTER [INTEGER_8]]

feature {ANY} -- routines

	cookie_jar_new: CE_POINTER [PD_COOKIE_JAR]
		local
			l_jar: CE_POINTER [PD_COOKIE_JAR]
		do
			create l_jar.make

			l_jar.ce_gets (create {CE_POINTER [PD_COOKIE_JAR]}.make_cast ((xmalloc_inst.xmalloc ({PD_COOKIE_JAR}.sizeof.to_natural_32))))
			l_jar.item.chains := hash_inst.make_nocase_string_hash_table (0)
			l_jar.item.cookie_count := 0
			Result := l_jar
		end

	cookie_new: CE_POINTER [PD_COOKIE]
		local
			l_cookie: CE_POINTER [PD_COOKIE]
		do
			create l_cookie.make

			l_cookie.ce_gets (create {CE_POINTER [PD_COOKIE]}.make_cast ((xmalloc_inst.xcalloc ((1).to_natural_32, {PD_COOKIE}.sizeof.to_natural_32))))
			l_cookie.item.port := -1
			Result := l_cookie
		end

	cookie_expired_p (a_c: CE_POINTER [PD_COOKIE]): BOOLEAN
		local
			l_tmp: INTEGER_32
		do
			if a_c.item.expiry_time /= 0 then
				if a_c.item.expiry_time < cookies_now then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp.to_boolean
		end

	delete_cookie (a_cookie: CE_POINTER [PD_COOKIE])
		do
			if ((a_cookie.item.domain).c_pointer /= default_pointer) then
				free (create {CE_POINTER [ANY]}.make_cast (a_cookie.item.domain))
			end
			if ((a_cookie.item.path).c_pointer /= default_pointer) then
				free (create {CE_POINTER [ANY]}.make_cast (a_cookie.item.path))
			end
			if ((a_cookie.item.attr).c_pointer /= default_pointer) then
				free (create {CE_POINTER [ANY]}.make_cast (a_cookie.item.attr))
			end
			if ((a_cookie.item.value).c_pointer /= default_pointer) then
				free (create {CE_POINTER [ANY]}.make_cast (a_cookie.item.value))
			end
			free (create {CE_POINTER [ANY]}.make_cast (a_cookie))
		end

	find_matching_cookie (a_jar: CE_POINTER [PD_COOKIE_JAR]; a_cookie: CE_POINTER [PD_COOKIE]; a_prevptr: CE_POINTER [CE_POINTER [PD_COOKIE]]): CE_POINTER [PD_COOKIE]
		local
			l_chain: CE_POINTER [PD_COOKIE]
			l_prev: CE_POINTER [PD_COOKIE]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_chain.make
			create l_prev.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_chain.ce_gets (create {CE_POINTER [PD_COOKIE]}.make_cast ((hash_inst.hash_table_get (a_jar.item.chains, create {CE_POINTER [ANY]}.make_cast (a_cookie.item.domain)))))
					if (l_chain).c_pointer = default_pointer then
						l_pos := -1 + 2 -- goto nomatch
					end
				when 1 then
					l_prev.ce_gets (create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer))
					from
					until
						not (not js.loop_left and then ((l_chain).c_pointer /= default_pointer))
					loop
						if 0 = (strcmp (a_cookie.item.path, l_chain.item.path)) then
							if 0 = (strcmp (a_cookie.item.attr, l_chain.item.attr)) then
								if a_cookie.item.port = l_chain.item.port then
									a_prevptr.item := l_prev
									Result := l_chain
									js.return
								end
							end
						end
						if not js.return_called then
							l_prev.ce_gets (l_chain)
							l_chain.ce_gets (l_chain.item.next)
						end
					end
					if js.return_called then
						l_pos := -1 + 3 -- skip if block
					end
				when 2 then -- if: | nomatch:
						a_prevptr.item := create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer)
						Result := (create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer))
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	store_cookie (a_jar: CE_POINTER [PD_COOKIE_JAR]; a_cookie: CE_POINTER [PD_COOKIE])
		local
			l_chain_head: CE_POINTER [PD_COOKIE]
			l_chain_key: CE_POINTER [INTEGER_8]
			l_prev: CE_POINTER [PD_COOKIE]
			l_victim: CE_POINTER [PD_COOKIE]
			l_exptime: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_chain_head.make
			create l_chain_key.make
			create l_prev.make
			create l_victim.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make

			if (hash_inst.hash_table_get_pair (a_jar.item.chains, create {CE_POINTER [ANY]}.make_cast (a_cookie.item.domain), create {CE_POINTER [ANY]}.make_cast ((l_chain_key.address)), create {CE_POINTER [ANY]}.make_cast ((l_chain_head.address)))).to_boolean then
				l_victim.ce_gets ((find_matching_cookie (a_jar, a_cookie, l_prev.address)))
				if ((l_victim).c_pointer /= default_pointer) then
					if ((l_prev).c_pointer /= default_pointer) then
						l_prev.item.next := l_victim.item.next
						a_cookie.item.next := l_chain_head
					else
						a_cookie.item.next := l_victim.item.next
					end
					delete_cookie (l_victim)
					a_jar.item.cookie_count := (a_jar.item.cookie_count) - 1
					from
					until
						js.loop_left
					loop
						js.reset
						if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
							log_inst.debug_logprintf ([ce_string ("Deleted old cookie (to be replaced.)%N")])
						end
						js.break
					end
					js.reset
				else
					a_cookie.item.next := l_chain_head
				end
			else
				a_cookie.item.next := create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer)
				l_chain_key.ce_gets (xmalloc_inst.xstrdup (a_cookie.item.domain))
			end
			hash_inst.hash_table_put (a_jar.item.chains, create {CE_POINTER [ANY]}.make_cast (l_chain_key), create {CE_POINTER [ANY]}.make_cast (a_cookie))
			a_jar.item.cookie_count := (a_jar.item.cookie_count) + 1
			if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
				l_exptime := a_cookie.item.expiry_time
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
						if (a_cookie.item.expiry_time).to_boolean then
							l_tmp___3.ce_gets ((utils_inst.datetime_str (l_exptime)))
						else
							l_tmp___3.ce_gets (ce_string ("none"))
						end
						if (a_cookie.item.secure).to_boolean then
							l_tmp___4.ce_gets (ce_string ("secure"))
						else
							l_tmp___4.ce_gets (ce_string ("insecure"))
						end
						if (a_cookie.item.permanent).to_boolean then
							l_tmp___5.ce_gets (ce_string ("permanent"))
						else
							l_tmp___5.ce_gets (ce_string ("session"))
						end
						if a_cookie.item.port = -1 then
							l_tmp___6.ce_gets (ce_string (" (ANY)"))
						else
							l_tmp___6.ce_gets (ce_string (""))
						end
						log_inst.debug_logprintf ([ce_string ("%NStored cookie %%s %%d%%s %%s <%%s> <%%s> [expiry %%s] %%s %%s%N"), a_cookie.item.domain, a_cookie.item.port, l_tmp___6, a_cookie.item.path, l_tmp___5, l_tmp___4, l_tmp___3, a_cookie.item.attr, a_cookie.item.value])
					end
					js.break
				end
				js.reset
			end
		end

	discard_matching_cookie (a_jar: CE_POINTER [PD_COOKIE_JAR]; a_cookie: CE_POINTER [PD_COOKIE])
		local
			l_prev: CE_POINTER [PD_COOKIE]
			l_victim: CE_POINTER [PD_COOKIE]
			l_chain_key: CE_POINTER [INTEGER_8]
			l_res___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_prev.make
			create l_victim.make
			create l_chain_key.make

			if not (hash_inst.hash_table_count (a_jar.item.chains)).to_boolean then
				js.return
			end
			if not js.return_called then
				l_victim.ce_gets (find_matching_cookie (a_jar, a_cookie, l_prev.address))
				if ((l_victim).c_pointer /= default_pointer) then
					if ((l_prev).c_pointer /= default_pointer) then
						l_prev.item.next := l_victim.item.next
					else
						l_chain_key.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
						l_res___0 := hash_inst.hash_table_get_pair (a_jar.item.chains, create {CE_POINTER [ANY]}.make_cast (l_victim.item.domain), create {CE_POINTER [ANY]}.make_cast ((l_chain_key.address)), create {CE_POINTER [ANY]}.make_shared (default_pointer))
						if l_res___0 = 0 then
							assert_fail (ce_string ("res != 0"), ce_string ("cookies.c"), {NATURAL_32} 302, ce_string ("discard_matching_cookie"))
						end
						if (l_victim.item.next).c_pointer = default_pointer then
							hash_inst.hash_table_remove (a_jar.item.chains, create {CE_POINTER [ANY]}.make_cast (l_victim.item.domain)).do_nothing
							free (create {CE_POINTER [ANY]}.make_cast (l_chain_key))
						else
							hash_inst.hash_table_put (a_jar.item.chains, create {CE_POINTER [ANY]}.make_cast (l_chain_key), create {CE_POINTER [ANY]}.make_cast (l_victim.item.next))
						end
					end
					delete_cookie (l_victim)
					from
					until
						js.loop_left
					loop
						js.reset
						if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
							log_inst.debug_logprintf ([ce_string ("Discarded old cookie.%N")])
						end
						js.break
					end
					js.reset
				end
			end
		end

	parse_set_cookie (a_set_cookie: CE_POINTER [INTEGER_8]; a_silent: BOOLEAN): CE_POINTER [PD_COOKIE]
		local
			l_ptr: CE_POINTER [INTEGER_8]
			l_cookie: CE_POINTER [PD_COOKIE]
			l_name: PD_PARAM_TOKEN
			l_value: PD_PARAM_TOKEN
			l_value_copy: CE_POINTER [INTEGER_8]
			l_expires: INTEGER_32
			l_BTA_beg: CE_POINTER [INTEGER_8]
			l_BTA_len: INTEGER_32
			l_BTA_dest: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_maxage: REAL_64
			l_value_copy___0: CE_POINTER [INTEGER_8]
			l_BTA_beg___0: CE_POINTER [INTEGER_8]
			l_BTA_len___0: INTEGER_32
			l_BTA_dest___0: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_tmp___9: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_ptr.make
			create l_cookie.make
			create l_name.make
			create l_value.make
			create l_value_copy.make
			create l_BTA_beg.make
			create l_BTA_dest.make
			create l_value_copy___0.make
			create l_BTA_beg___0.make
			create l_BTA_dest___0.make
			create l_tmp___9.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ptr.ce_gets (a_set_cookie)
					l_cookie.ce_gets ((cookie_new))
					if not (http_inst.extract_param (l_ptr.address, l_name.address, l_value.address, ((';').code).to_integer_8)) then
						l_pos := -1 + 38 -- goto error
					end
				when 1 then
					if (l_value.b).c_pointer = default_pointer then
						l_pos := -1 + 38 -- goto error
					end
				when 2 then
					l_cookie.item.attr := utils_inst.strdupdelim (l_name.b, l_name.e)
					l_cookie.item.value := utils_inst.strdupdelim (l_value.b, l_value.e)
				when 3 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 36 -- skip loop
					end
				when 4 then -- loop body:
						js.reset
						if not (http_inst.extract_param (l_ptr.address, l_name.address, l_value.address, ((';').code).to_integer_8)) then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 35 -- skip if block
						end
				when 5 then -- if:
						if ((l_name.e).distance ((l_name.b))).to_natural_32 /= (("domain").count + 1).to_natural_32 - {NATURAL_32} 1 then
							l_pos := -1 + 12 -- skip if block
						end
				when 6 then -- if:
						if not ((strncasecmp (l_name.b, ce_string ("domain"), (("domain").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 12 -- goto _L___2
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if ((l_value.b).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if ((l_value.b).c_pointer.to_integer_32).to_natural_32 = ((l_value.e).c_pointer.to_integer_32).to_natural_32 then
								l_pos := -1 + 38 -- goto error
							end
						else
							l_pos := -1 + 38 -- goto error
						end
				when 10 then
						if ((l_cookie.item.domain).c_pointer /= default_pointer) then
							free (create {CE_POINTER [ANY]}.make_cast (l_cookie.item.domain))
						end
						if ((l_value.b).item).to_integer_32 = 46 then
							l_value.b := (l_value.b) + 1
						end
						l_cookie.item.domain := utils_inst.strdupdelim (l_value.b, l_value.e)
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 35
				when 12 then -- else: | _L___2:
						if ((l_name.e).distance ((l_name.b))).to_natural_32 /= (("path").count + 1).to_natural_32 - {NATURAL_32} 1 then
							l_pos := -1 + 19 -- skip if block
						end
				when 13 then -- if:
						if not ((strncasecmp (l_name.b, ce_string ("path"), (("path").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 19 -- goto _L___1
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if ((l_value.b).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if ((l_value.b).c_pointer.to_integer_32).to_natural_32 = ((l_value.e).c_pointer.to_integer_32).to_natural_32 then
								l_pos := -1 + 38 -- goto error
							end
						else
							l_pos := -1 + 38 -- goto error
						end
				when 17 then
						if ((l_cookie.item.path).c_pointer /= default_pointer) then
							free (create {CE_POINTER [ANY]}.make_cast (l_cookie.item.path))
						end
						l_cookie.item.path := utils_inst.strdupdelim (l_value.b, l_value.e)
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 35
				when 19 then -- else: | _L___1:
						if ((l_name.e).distance ((l_name.b))).to_natural_32 /= (("expires").count + 1).to_natural_32 - {NATURAL_32} 1 then
							l_pos := -1 + 26 -- skip if block
						end
				when 20 then -- if:
						if not ((strncasecmp (l_name.b, ce_string ("expires"), (("expires").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 26 -- goto _L___0
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 23 then -- else:
						if ((l_value.b).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if ((l_value.b).c_pointer.to_integer_32).to_natural_32 = ((l_value.e).c_pointer.to_integer_32).to_natural_32 then
								l_pos := -1 + 38 -- goto error
							end
						else
							l_pos := -1 + 38 -- goto error
						end
				when 24 then
						from
						until
							js.loop_left
						loop
							js.reset
							l_BTA_beg.ce_gets (l_value.b)
							l_BTA_len := (l_value.e).distance (l_BTA_beg)
							l_BTA_dest.ce_gets (l_value_copy.address)
							l_BTA_dest.item := create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new ((l_BTA_len + 1).to_natural_32)))
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_BTA_dest.item), create {CE_POINTER [ANY]}.make_cast (l_BTA_beg), l_BTA_len.to_natural_32).do_nothing
							l_BTA_dest.item[l_BTA_len] := (('%/0/').code).to_integer_8
							js.break
						end
						js.reset
						l_expires := http_inst.http_atotm (l_value_copy)
						if l_expires /= -1 then
							l_cookie.item.permanent := {NATURAL_32} 1
							l_cookie.item.expiry_time := l_expires
							if l_cookie.item.expiry_time < cookies_now then
								l_cookie.item.discard_requested := {NATURAL_32} 1
							end
						end
				when 25 then -- if done | if block done, skip else block:
						l_pos := -1 + 35
				when 26 then -- else: | _L___0:
						if ((l_name.e).distance ((l_name.b))).to_natural_32 /= (("max-age").count + 1).to_natural_32 - {NATURAL_32} 1 then
							l_pos := -1 + 34 -- skip if block
						end
				when 27 then -- if:
						if not ((strncasecmp (l_name.b, ce_string ("max-age"), (("max-age").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						l_pos := -1 + 34 -- goto _L
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 30 then -- else:
						l_maxage := (-1).to_double
						if ((l_value.b).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if ((l_value.b).c_pointer.to_integer_32).to_natural_32 = ((l_value.e).c_pointer.to_integer_32).to_natural_32 then
								l_pos := -1 + 38 -- goto error
							end
						else
							l_pos := -1 + 38 -- goto error
						end
				when 31 then
						from
						until
							js.loop_left
						loop
							js.reset
							l_BTA_beg___0.ce_gets (l_value.b)
							l_BTA_len___0 := (l_value.e).distance (l_BTA_beg___0)
							l_BTA_dest___0.ce_gets (l_value_copy___0.address)
							l_BTA_dest___0.item := create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new ((l_BTA_len___0 + 1).to_natural_32)))
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_BTA_dest___0.item), create {CE_POINTER [ANY]}.make_cast (l_BTA_beg___0), l_BTA_len___0.to_natural_32).do_nothing
							l_BTA_dest___0.item[l_BTA_len___0] := (('%/0/').code).to_integer_8
							js.break
						end
						js.reset
						sscanf ([l_value_copy___0, ce_string ("%%lf"), create {CE_POINTER [REAL_64]}.make_shared ($l_maxage)]).do_nothing
						if l_maxage = (-1).to_double then
							l_pos := -1 + 38 -- goto error
						end
				when 32 then
						l_cookie.item.permanent := {NATURAL_32} 1
						l_cookie.item.expiry_time := (cookies_now.to_double + l_maxage).truncated_to_integer
						if l_maxage = (0).to_double then
							l_cookie.item.discard_requested := {NATURAL_32} 1
						end
				when 33 then -- if done | if block done, skip else block:
						l_pos := -1 + 35
				when 34 then -- else: | _L:
						if ((l_name.e).distance ((l_name.b))).to_natural_32 = (("secure").count + 1).to_natural_32 - {NATURAL_32} 1 then
							if not (strncasecmp (l_name.b, ce_string ("secure"), (("secure").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean then
								l_cookie.item.secure := {NATURAL_32} 1
							end
						end
				when 35 then -- if done | if done | if done | if done
						l_pos := -1 + 3 -- back to loop condition
				when 36 then -- loop done
					js.reset
					if (l_ptr[0]).to_boolean then
						l_pos := -1 + 38 -- goto error
					end
				when 37 then
					Result := l_cookie
					js.return
					if js.return_called then
						l_pos := -1 + 39 -- skip if block
					end
				when 38 then -- if: | error:
						if not a_silent then
							l_tmp___9.ce_gets (quotearg_inst.quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, a_set_cookie))
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Syntax error in Set-Cookie: %%s at position %%d.%N"))), l_tmp___9, l_ptr.distance (a_set_cookie)])
						end
						delete_cookie (l_cookie)
						Result := (create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer))
				when 39 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	numeric_address_p (a_addr: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_tmp___1.make
			create l_tmp___4.make
			create l_tmp___7.make

			l_p___0.ce_gets (a_addr)
			from
			until
				js.loop_left
			loop
				js.reset
				if not (c_ctype_inst.c2_isdigit ((l_p___0[0]).to_integer_32)) then
					Result := (0).to_boolean
					js.return
				end
				if not js.return_called then
					l_p___0.ce_gets (l_p___0 + 1)
					from
					until
						js.loop_left
					loop
						js.reset
						if not (c_ctype_inst.c2_isdigit ((l_p___0[0]).to_integer_32)) then
							js.break
						end
						if not js.loop_jumped then
							l_p___0.ce_gets (l_p___0 + 1)
						end
					end
					js.reset
					js.break
				end
			end
			js.reset
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_tmp___1.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					if (l_tmp___1[0]).to_integer_32 /= 46 then
						Result := (0).to_boolean
						js.return
					end
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					if not (c_ctype_inst.c2_isdigit ((l_p___0[0]).to_integer_32)) then
						Result := (0).to_boolean
						js.return
					end
					if not js.return_called then
						l_p___0.ce_gets (l_p___0 + 1)
						from
						until
							js.loop_left
						loop
							js.reset
							if not (c_ctype_inst.c2_isdigit ((l_p___0[0]).to_integer_32)) then
								js.break
							end
							if not js.loop_jumped then
								l_p___0.ce_gets (l_p___0 + 1)
							end
						end
						js.reset
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_tmp___4.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					if (l_tmp___4[0]).to_integer_32 /= 46 then
						Result := (0).to_boolean
						js.return
					end
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					if not (c_ctype_inst.c2_isdigit ((l_p___0[0]).to_integer_32)) then
						Result := (0).to_boolean
						js.return
					end
					if not js.return_called then
						l_p___0.ce_gets (l_p___0 + 1)
						from
						until
							js.loop_left
						loop
							js.reset
							if not (c_ctype_inst.c2_isdigit ((l_p___0[0]).to_integer_32)) then
								js.break
							end
							if not js.loop_jumped then
								l_p___0.ce_gets (l_p___0 + 1)
							end
						end
						js.reset
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_tmp___7.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					if (l_tmp___7[0]).to_integer_32 /= 46 then
						Result := (0).to_boolean
						js.return
					end
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					if not (c_ctype_inst.c2_isdigit ((l_p___0[0]).to_integer_32)) then
						Result := (0).to_boolean
						js.return
					end
					if not js.return_called then
						l_p___0.ce_gets (l_p___0 + 1)
						from
						until
							js.loop_left
						loop
							js.reset
							if not (c_ctype_inst.c2_isdigit ((l_p___0[0]).to_integer_32)) then
								js.break
							end
							if not js.loop_jumped then
								l_p___0.ce_gets (l_p___0 + 1)
							end
						end
						js.reset
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then ((l_p___0[0]).to_integer_32 /= 0) then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				Result := (1).to_boolean
			end
		end

	check_domain_match (a_cookie_domain: CE_POINTER [INTEGER_8]; a_host: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_dccount: INTEGER_32
			l_ldcl: INTEGER_32
			l_nldcl: INTEGER_32
			l_out: INTEGER_32
			l_i: NATURAL_32
			l_known_toplevel: INTEGER_32
			l_dlen: INTEGER_32
			l_hlen: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					from
					until
						js.loop_left
					loop
						js.reset
						if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
							log_inst.debug_logprintf ([ce_string ("cdm: 1")])
						end
						js.break
					end
					js.reset
					if (numeric_address_p (a_cookie_domain)) then
						Result := (0 = (strcmp (a_cookie_domain, a_host)))
						js.return
					end
					if not js.return_called then
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string (" 2")])
							end
							js.break
						end
						js.reset
						if 0 = (strcasecmp (a_cookie_domain, a_host)) then
							Result := (1).to_boolean
							js.return
						end
					end
					if not js.return_called then
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string (" 3")])
							end
							js.break
						end
						js.reset
						if not (utils_inst.match_tail (a_host, a_cookie_domain, (1).to_boolean)) then
							Result := (0).to_boolean
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						l_p___0.ce_gets (a_cookie_domain)
						l_dccount := 1
						l_ldcl := 0
						l_nldcl := 0
						if (l_p___0[0]).to_integer_32 = 46 then
							l_p___0.ce_gets (l_p___0 + 1)
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string (" 4")])
							end
							js.break
						end
						js.reset
						l_out := 0
				when 2 then -- loop condition:
						if not (not js.loop_left and then (not l_out.to_boolean)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 3 then -- loop body:
						inspect (l_p___0[0]).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 4
						when 46 then l_pos := -1 + 5
						else l_pos := -1 + 9
						end
				when 4 then -- switch 1, case 0
						l_out := 1
						l_pos := -1 + 10 -- switch 1; break
				when 5 then -- switch 1, case 46
						if l_ldcl = 0 then
							Result := (0).to_boolean
							js.return
						end
						if js.return_called then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (l_p___0[1]).to_integer_32 = 0 then
							l_out := 1
							l_pos := -1 + 10 -- switch 1; break
						end
				when 7 then
						l_nldcl := l_ldcl
						l_ldcl := 0
						l_dccount := l_dccount + 1
				when 8 then -- if done
						l_pos := -1 + 10 -- switch 1; break
				when 9 then -- switch 1, default:
						l_ldcl := l_ldcl + 1
				when 10 then -- switch 1, done:
						if not js.return_called then
							l_p___0.ce_gets (l_p___0 + 1)
						end
						l_pos := -1 + 2 -- back to loop condition
				when 11 then -- loop done | if done
						if not js.return_called then
							from
							until
								js.loop_left
							loop
								js.reset
								if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string (" 5")])
								end
								js.break
							end
							js.reset
							if l_dccount < 2 then
								Result := (0).to_boolean
								js.return
							end
						end
						if not js.return_called then
							from
							until
								js.loop_left
							loop
								js.reset
								if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string (" 6")])
								end
								js.break
							end
							js.reset
							if l_dccount = 2 then
								l_known_toplevel := 0
								l_i := (0).to_natural_32
								from
								until
									not (not js.loop_left and then (l_i < (Pointer_bytes.to_natural_32 * (7).to_natural_32) // Pointer_bytes.to_natural_32))
								loop
									js.reset
									if (utils_inst.match_tail (a_cookie_domain, known_toplevel_domains[l_i.to_integer_32], (1).to_boolean)) then
										l_known_toplevel := 1
										js.break
									end
									if not js.loop_jumped then
										l_i := l_i + 1
									end
								end
								js.reset
								if not l_known_toplevel.to_boolean then
									if l_nldcl <= 3 then
										Result := (0).to_boolean
										js.return
									end
								end
							end
						end
						if not js.return_called then
							from
							until
								js.loop_left
							loop
								js.reset
								if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string (" 7")])
								end
								js.break
							end
							js.reset
							if (a_cookie_domain[0]).to_integer_32 /= 46 then
								l_dlen := (strlen (a_cookie_domain)).to_integer_32
								l_hlen := (strlen (a_host)).to_integer_32
								if l_hlen > l_dlen then
									if (a_host[((l_hlen - l_dlen) - 1)]).to_integer_32 /= 46 then
										Result := (0).to_boolean
										js.return
									end
								end
							end
						end
						if not js.return_called then
							from
							until
								js.loop_left
							loop
								js.reset
								if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string (" 8")])
								end
								js.break
							end
							js.reset
							Result := (1).to_boolean
						end
				when 12 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	check_path_match (a_cookie_path: CE_POINTER [INTEGER_8]; a_path: CE_POINTER [INTEGER_8]): BOOLEAN
		do
			Result := ((path_matches (a_path, a_cookie_path)) /= 0)
		end

	cookie_handle_set_cookie (a_jar: CE_POINTER [PD_COOKIE_JAR]; a_host: CE_POINTER [INTEGER_8]; a_port: INTEGER_32; a_path: CE_POINTER [INTEGER_8]; a_set_cookie: CE_POINTER [INTEGER_8])
		local
			l_path: CE_POINTER [INTEGER_8]
			l_cookie: CE_POINTER [PD_COOKIE]
			l_PS_newstr: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_trailing_slash: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_path.make
			create l_cookie.make
			create l_PS_newstr.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_trailing_slash.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_path.ce_gets (a_path)
					cookies_now := time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
					from
					until
						js.loop_left
					loop
						js.reset
						l_PS_newstr.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new (({NATURAL_32} 1 + (strlen (l_path))) + {NATURAL_32} 1))))
						l_PS_newstr[0] := (('/').code).to_integer_8
						strcpy ((l_PS_newstr + 1), l_path).do_nothing
						l_path.ce_gets (l_PS_newstr)
						js.break
					end
					js.reset
					l_cookie.ce_gets (parse_set_cookie (a_set_cookie, (0).to_boolean))
					if (l_cookie).c_pointer = default_pointer then
						l_pos := -1 + 8 -- goto out
					end
				when 1 then
					if ((l_cookie.item.domain).c_pointer /= default_pointer) then
						l_pos := -1 + 4 -- skip if block
					end
				when 2 then -- if: | copy_domain:
						l_cookie.item.domain := xmalloc_inst.xstrdup (a_host)
						l_cookie.item.domain_exact := {NATURAL_32} 1
						if a_port /= 80 then
							if a_port /= 443 then
								l_cookie.item.port := a_port
							end
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else:
						if not (check_domain_match (l_cookie.item.domain, a_host)) then
							l_tmp___1.ce_gets (quotearg_inst.quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_cookie.item.domain))
							l_tmp___2.ce_gets (quotearg_inst.quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, a_host))
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Cookie coming from %%s attempted to set domain to %%s%N"))), l_tmp___2, l_tmp___1])
							free (create {CE_POINTER [ANY]}.make_cast (l_cookie.item.domain))
							l_pos := -1 + 2 -- goto copy_domain
						end
				when 5 then
					if (l_cookie.item.path).c_pointer = default_pointer then
						l_trailing_slash.ce_gets ((strrchr (l_path, ('/').code)))
						if ((l_trailing_slash).c_pointer /= default_pointer) then
							l_cookie.item.path := utils_inst.strdupdelim (l_path, (l_trailing_slash + 1))
						else
							l_cookie.item.path := xmalloc_inst.xstrdup (l_path)
						end
					elseif not (check_path_match (l_cookie.item.path, l_path)) then
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("Attempt to fake the path: %%s, %%s%N"), l_cookie.item.path, l_path])
							end
							js.break
						end
						js.reset
						l_pos := -1 + 8 -- goto out
					end
				when 6 then
					if (l_cookie.item.discard_requested).to_boolean then
						discard_matching_cookie (a_jar, l_cookie)
						l_pos := -1 + 8 -- goto out
					end
				when 7 then
					store_cookie (a_jar, l_cookie)
					js.return
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 8 then -- if: | out:
						if ((l_cookie).c_pointer /= default_pointer) then
							delete_cookie (l_cookie)
						end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	count_char (a_string: CE_POINTER [INTEGER_8]; a_chr: INTEGER_8): INTEGER_32
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_count: INTEGER_32
		do
			create l_p___0.make

			l_count := 0
			l_p___0.ce_gets (a_string)
			from
			until
				not ((l_p___0[0]).to_boolean)
			loop
				if (l_p___0[0]).to_integer_32 = a_chr.to_integer_32 then
					l_count := l_count + 1
				end
				l_p___0.ce_gets (l_p___0 + 1)
			end
			Result := l_count
		end

	find_chains_of_host (a_jar: CE_POINTER [PD_COOKIE_JAR]; a_host: CE_POINTER [INTEGER_8]; a_dest: CE_POINTER [CE_POINTER [PD_COOKIE]]): INTEGER_32
		local
			l_host: CE_POINTER [INTEGER_8]
			l_dest_count: INTEGER_32
			l_passes: INTEGER_32
			l_passcnt: INTEGER_32
			l_chain: CE_POINTER [PD_COOKIE]
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_host.make
			create l_chain.make

			l_host.ce_gets (a_host)
			l_dest_count := 0
			if not (hash_inst.hash_table_count (a_jar.item.chains)).to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				if (numeric_address_p (l_host)) then
					l_passes := 1
				else
					l_passes := count_char (l_host, (('.').code).to_integer_8)
				end
				l_passcnt := 0
				from
				until
					js.loop_left
				loop
					js.reset
					l_chain.ce_gets (create {CE_POINTER [PD_COOKIE]}.make_cast ((hash_inst.hash_table_get (a_jar.item.chains, create {CE_POINTER [ANY]}.make_cast (l_host)))))
					if ((l_chain).c_pointer /= default_pointer) then
						l_tmp___2 := l_dest_count
						l_dest_count := l_dest_count + 1
						a_dest[l_tmp___2] := l_chain
					end
					l_passcnt := l_passcnt + 1
					if l_passcnt >= l_passes then
						js.break
					end
					if not js.loop_jumped then
						l_host.ce_gets (((strchr (l_host, ('.').code)) + 1))
					end
				end
				js.reset
				Result := l_dest_count
			end
		end

	path_matches (a_full_path: CE_POINTER [INTEGER_8]; a_prefix: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			l_len := (strlen (a_prefix)).to_integer_32
			if 0 /= (strncmp (a_full_path, a_prefix, l_len.to_natural_32)) then
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := (l_len + 1)
			end
		end

	cookie_matches_url (a_cookie: CE_POINTER [PD_COOKIE]; a_host: CE_POINTER [INTEGER_8]; a_port: INTEGER_32; a_path: CE_POINTER [INTEGER_8]; a_secflag: BOOLEAN; a_path_goodness: CE_POINTER [INTEGER_32]): BOOLEAN
		local
			l_pg: INTEGER_32
			js: JUMP_STATE
		do
			if (cookie_expired_p (a_cookie)) then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called and then ((a_cookie.item.secure).to_boolean) then
				if not a_secflag then
					Result := (0).to_boolean
					js.return
				end
			end
			if not js.return_called and then (a_cookie.item.port /= -1) then
				if a_cookie.item.port /= a_port then
					Result := (0).to_boolean
					js.return
				end
			end
			if not js.return_called and then ((a_cookie.item.domain_exact).to_boolean) then
				if 0 /= (strcasecmp (a_host, a_cookie.item.domain)) then
					Result := (0).to_boolean
					js.return
				end
			end
			if not js.return_called then
				l_pg := path_matches (a_path, a_cookie.item.path)
				if l_pg = 0 then
					Result := (0).to_boolean
					js.return
				end
			end
			if not js.return_called then
				if ((a_path_goodness).c_pointer /= default_pointer) then
					a_path_goodness.item := l_pg
				end
				Result := (1).to_boolean
			end
		end

	equality_comparator (a_p1: CE_POINTER [ANY]; a_p2: CE_POINTER [ANY]): INTEGER_32
		local
			l_wc1: CE_POINTER [PD_WEIGHED_COOKIE]
			l_wc2: CE_POINTER [PD_WEIGHED_COOKIE]
			l_namecmp: INTEGER_32
			l_valuecmp: INTEGER_32
			l_tmp___1: INTEGER_32
		do
			create l_wc1.make
			create l_wc2.make

			l_wc1.ce_gets (create {CE_POINTER [PD_WEIGHED_COOKIE]}.make_cast (a_p1))
			l_wc2.ce_gets (create {CE_POINTER [PD_WEIGHED_COOKIE]}.make_cast (a_p2))
			l_namecmp := (strcmp ((l_wc1.item.cookie).item.attr, (l_wc2.item.cookie).item.attr))
			l_valuecmp := (strcmp ((l_wc1.item.cookie).item.value, (l_wc2.item.cookie).item.value))
			if l_namecmp.to_boolean then
				l_tmp___1 := l_namecmp
			else
				l_tmp___1 := l_valuecmp
			end
			Result := l_tmp___1
		end

	equality_comparator_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent equality_comparator)
		end

	eliminate_dups (a_outgoing: CE_POINTER [PD_WEIGHED_COOKIE]; a_count: INTEGER_32): INTEGER_32
		local
			l_h: CE_POINTER [PD_WEIGHED_COOKIE]
			l_t: CE_POINTER [PD_WEIGHED_COOKIE]
			l_end: CE_POINTER [PD_WEIGHED_COOKIE]
			l_c0: CE_POINTER [PD_COOKIE]
			l_c1: CE_POINTER [PD_COOKIE]
			l_tmp___1: CE_POINTER [PD_WEIGHED_COOKIE]
			js: JUMP_STATE
		do
			create l_h.make
			create l_t.make
			create l_end.make
			create l_c0.make
			create l_c1.make
			create l_tmp___1.make

			l_end.ce_gets (a_outgoing + a_count)
			qsort (create {CE_POINTER [ANY]}.make_cast (a_outgoing), a_count.to_natural_32, {PD_WEIGHED_COOKIE}.sizeof.to_natural_32, equality_comparator_address)
			l_t.ce_gets (a_outgoing)
			l_h.ce_gets (l_t)
			from
			until
				not ((l_h.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32)
			loop
				js.reset
				if (l_h.c_pointer.to_integer_32).to_natural_32 /= ((l_end - 1).c_pointer.to_integer_32).to_natural_32 then
					l_c0.ce_gets ((l_h + 0).item.cookie)
					l_c1.ce_gets ((l_h + 1).item.cookie)
					if not (strcmp (l_c0.item.attr, l_c1.item.attr)).to_boolean then
						if not (strcmp (l_c0.item.value, l_c1.item.value)).to_boolean then
							js.continue
						end
					end
				end
				if not js.loop_jumped then
					if (l_h.c_pointer.to_integer_32).to_natural_32 /= (l_t.c_pointer.to_integer_32).to_natural_32 then
						l_tmp___1.ce_gets (l_t)
						l_t.ce_gets (l_t + 1)
						l_tmp___1.item := l_h.item
					else
						l_t.ce_gets (l_t + 1)
					end
				end
				l_h.ce_gets (l_h + 1)
			end
			Result := (l_t.distance (a_outgoing))
		end

	goodness_comparator (a_p1: CE_POINTER [ANY]; a_p2: CE_POINTER [ANY]): INTEGER_32
		local
			l_wc1: CE_POINTER [PD_WEIGHED_COOKIE]
			l_wc2: CE_POINTER [PD_WEIGHED_COOKIE]
			l_dgdiff: INTEGER_32
			l_pgdiff: INTEGER_32
			l_tmp: INTEGER_32
		do
			create l_wc1.make
			create l_wc2.make

			l_wc1.ce_gets (create {CE_POINTER [PD_WEIGHED_COOKIE]}.make_cast (a_p1))
			l_wc2.ce_gets (create {CE_POINTER [PD_WEIGHED_COOKIE]}.make_cast (a_p2))
			l_dgdiff := l_wc2.item.domain_goodness - l_wc1.item.domain_goodness
			l_pgdiff := l_wc2.item.path_goodness - l_wc1.item.path_goodness
			if l_dgdiff.to_boolean then
				l_tmp := l_dgdiff
			else
				l_tmp := l_pgdiff
			end
			Result := l_tmp
		end

	goodness_comparator_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent goodness_comparator)
		end

	cookie_header (a_jar: CE_POINTER [PD_COOKIE_JAR]; a_host: CE_POINTER [INTEGER_8]; a_port: INTEGER_32; a_path: CE_POINTER [INTEGER_8]; a_secflag: BOOLEAN): CE_POINTER [INTEGER_8]
		local
			l_path: CE_POINTER [INTEGER_8]
			l_chains: CE_POINTER [CE_POINTER [PD_COOKIE]]
			l_chain_count: INTEGER_32
			l_cookie: CE_POINTER [PD_COOKIE]
			l_outgoing: CE_POINTER [PD_WEIGHED_COOKIE]
			l_count: INTEGER_32
			l_i: INTEGER_32
			l_ocnt: INTEGER_32
			l_result: CE_POINTER [INTEGER_8]
			l_result_size: INTEGER_32
			l_pos2: INTEGER_32
			l_PS_newstr: CE_POINTER [INTEGER_8]
			l_pg: INTEGER_32
			l_c: CE_POINTER [PD_COOKIE]
			l_tmp___7: NATURAL_32
			l_c___0: CE_POINTER [PD_COOKIE]
			l_namlen: INTEGER_32
			l_vallen: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_path.make
			create l_chains.make
			create l_cookie.make
			create l_outgoing.make
			create l_result.make
			create l_PS_newstr.make
			create l_c.make
			create l_c___0.make

			l_path.ce_gets (a_path)
			from
			until
				js.loop_left
			loop
				js.reset
				l_PS_newstr.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new (({NATURAL_32} 1 + (strlen (l_path))) + {NATURAL_32} 1))))
				l_PS_newstr[0] := (('/').code).to_integer_8
				strcpy ((l_PS_newstr + 1), l_path).do_nothing
				l_path.ce_gets (l_PS_newstr)
				js.break
			end
			js.reset
			l_chains.ce_gets (create {CE_POINTER [CE_POINTER [PD_COOKIE]]}.make_cast ((l_aaf.new ((1 + (count_char (a_host, (('.').code).to_integer_8))).to_natural_32 * Pointer_bytes.to_natural_32))))
			l_chain_count := find_chains_of_host (a_jar, a_host, l_chains)
			if not l_chain_count.to_boolean then
				Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				cookies_now := time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
				l_count := 0
				l_i := 0
				from
				until
					not (not js.loop_left and then (l_i < l_chain_count))
				loop
					l_cookie.ce_gets (l_chains[l_i])
					from
					until
						(l_cookie).c_pointer = default_pointer
					loop
						if (cookie_matches_url (l_cookie, a_host, a_port, l_path, a_secflag, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))) then
							l_count := l_count + 1
						end
						l_cookie.ce_gets (l_cookie.item.next)
					end
					l_i := l_i + 1
				end
				if not l_count.to_boolean then
					Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				l_outgoing.ce_gets (create {CE_POINTER [PD_WEIGHED_COOKIE]}.make_cast ((l_aaf.new (l_count.to_natural_32 * {PD_WEIGHED_COOKIE}.sizeof.to_natural_32))))
				l_ocnt := 0
				l_i := 0
				from
				until
					not (not js.loop_left and then (l_i < l_chain_count))
				loop
					l_cookie.ce_gets (l_chains[l_i])
					from
					until
						(l_cookie).c_pointer = default_pointer
					loop
						js.reset
						if not (cookie_matches_url (l_cookie, a_host, a_port, l_path, a_secflag, create {CE_POINTER [INTEGER_32]}.make_shared ($l_pg))) then
							js.continue
						end
						if not js.loop_jumped then
							(l_outgoing + l_ocnt).item.cookie := l_cookie;
							(l_outgoing + l_ocnt).item.domain_goodness := (strlen (l_cookie.item.domain)).to_integer_32;
							(l_outgoing + l_ocnt).item.path_goodness := l_pg
							l_ocnt := l_ocnt + 1
						end
						l_cookie.ce_gets (l_cookie.item.next)
					end
					l_i := l_i + 1
				end
				if l_ocnt /= l_count then
					assert_fail (ce_string ("ocnt == count"), ce_string ("cookies.c"), {NATURAL_32} 1016, ce_string ("cookie_header"))
				end
				l_count := eliminate_dups (l_outgoing, l_count)
				qsort (create {CE_POINTER [ANY]}.make_cast (l_outgoing), l_count.to_natural_32, {PD_WEIGHED_COOKIE}.sizeof.to_natural_32, goodness_comparator_address)
				l_result_size := 0
				l_i := 0
				from
				until
					not (l_i < l_count)
				loop
					l_c.ce_gets ((l_outgoing + l_i).item.cookie)
					l_tmp___7 := strlen (l_c.item.attr)
					l_result_size := (l_result_size.to_natural_32 + ((l_tmp___7 + {NATURAL_32} 1) + (strlen (l_c.item.value)))).to_integer_32
					l_i := l_i + 1
				end
				l_result_size := (l_result_size + (l_count - 1) * 2) + 1
				l_result.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc (l_result_size.to_natural_32))))
				l_pos2 := 0
				l_i := 0
				from
				until
					not (l_i < l_count)
				loop
					l_c___0.ce_gets ((l_outgoing + l_i).item.cookie)
					l_namlen := (strlen (l_c___0.item.attr)).to_integer_32
					l_vallen := (strlen (l_c___0.item.value)).to_integer_32
					memcpy (create {CE_POINTER [ANY]}.make_cast ((l_result + l_pos2)), create {CE_POINTER [ANY]}.make_cast (l_c___0.item.attr), l_namlen.to_natural_32).do_nothing
					l_pos2 := l_pos2 + l_namlen
					l_tmp___12 := l_pos2
					l_pos2 := l_pos2 + 1
					l_result[l_tmp___12] := (('=').code).to_integer_8
					memcpy (create {CE_POINTER [ANY]}.make_cast ((l_result + l_pos2)), create {CE_POINTER [ANY]}.make_cast (l_c___0.item.value), l_vallen.to_natural_32).do_nothing
					l_pos2 := l_pos2 + l_vallen
					if l_i < l_count - 1 then
						l_tmp___13 := l_pos2
						l_pos2 := l_pos2 + 1
						l_result[l_tmp___13] := ((';').code).to_integer_8
						l_tmp___14 := l_pos2
						l_pos2 := l_pos2 + 1
						l_result[l_tmp___14] := ((' ').code).to_integer_8
					end
					l_i := l_i + 1
				end
				l_tmp___15 := l_pos2
				l_pos2 := l_pos2 + 1
				l_result[l_tmp___15] := (('%/0/').code).to_integer_8
				if l_pos2 /= l_result_size then
					assert_fail (ce_string ("pos == result_size"), ce_string ("cookies.c"), {NATURAL_32} 1060, ce_string ("cookie_header"))
				end
				Result := l_result
			end
		end

	domain_port (a_domain_b: CE_POINTER [INTEGER_8]; a_domain_e: CE_POINTER [INTEGER_8]; a_domain_e_ptr: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_port: INTEGER_32
			l_p___0: CE_POINTER [INTEGER_8]
			l_colon: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_colon.make

			l_port := 0
			l_colon.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((memchr (create {CE_POINTER [ANY]}.make_cast (a_domain_b), (':').code, (a_domain_e.distance (a_domain_b)).to_natural_32))))
			if (l_colon).c_pointer = default_pointer then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_p___0.ce_gets (l_colon + 1)
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_domain_e.c_pointer.to_integer_32).to_natural_32 then
						if not (c_ctype_inst.c2_isdigit ((l_p___0[0]).to_integer_32)) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_port := 10 * l_port + ((l_p___0[0]).to_integer_32 - 48)
						l_p___0.ce_gets (l_p___0 + 1)
					end
				end
				js.reset
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_domain_e.c_pointer.to_integer_32).to_natural_32 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				a_domain_e_ptr.item := l_colon
				Result := l_port
			end
		end

	cookie_jar_load (a_jar: CE_POINTER [PD_COOKIE_JAR]; a_file: CE_POINTER [INTEGER_8])
		local
			l_line: CE_POINTER [INTEGER_8]
			l_fp: CE_POINTER [SD_IO_FILE]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_cookie: CE_POINTER [PD_COOKIE]
			l_p___0: CE_POINTER [INTEGER_8]
			l_expiry: REAL_64
			l_port: INTEGER_32
			l_domain_b: CE_POINTER [INTEGER_8]
			l_domain_e: CE_POINTER [INTEGER_8]
			l_domflag_b: CE_POINTER [INTEGER_8]
			l_domflag_e: CE_POINTER [INTEGER_8]
			l_path_b: CE_POINTER [INTEGER_8]
			l_path_e: CE_POINTER [INTEGER_8]
			l_secure_b: CE_POINTER [INTEGER_8]
			l_secure_e: CE_POINTER [INTEGER_8]
			l_expires_b: CE_POINTER [INTEGER_8]
			l_expires_e: CE_POINTER [INTEGER_8]
			l_name_b: CE_POINTER [INTEGER_8]
			l_name_e: CE_POINTER [INTEGER_8]
			l_value_b: CE_POINTER [INTEGER_8]
			l_value_e: CE_POINTER [INTEGER_8]
			l_tmp___7: INTEGER_32
			l_tmp___9: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_line.make
			create l_fp.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_cookie.make
			create l_p___0.make
			create l_domain_b.make
			create l_domain_e.make
			create l_domflag_b.make
			create l_domflag_e.make
			create l_path_b.make
			create l_path_e.make
			create l_secure_b.make
			create l_secure_e.make
			create l_expires_b.make
			create l_expires_e.make
			create l_name_b.make
			create l_name_e.make
			create l_value_b.make
			create l_value_e.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fp.ce_gets ((fopen (a_file, ce_string ("r"))))
					if (l_fp).c_pointer = default_pointer then
						l_tmp___1.ce_gets (strerror ((errno_location).item))
						l_tmp___2.ce_gets (quote_inst.quote (a_file))
						log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Cannot open cookies file %%s: %%s%N"))), l_tmp___2, l_tmp___1])
						js.return
					end
					if js.return_called then
						l_pos := -1 + 36 -- skip if block
					end
				when 1 then -- if:
						cookies_now := time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 35 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						l_line.ce_gets (utils_inst.read_whole_line (l_fp))
						if (l_line.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						end
						if not js.loop_jumped then
							l_p___0.ce_gets (l_line)
							l_domain_b.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							l_domain_e.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							l_domflag_b.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							l_domflag_e.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							l_path_b.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							l_path_e.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							l_secure_b.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							l_secure_e.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							l_expires_b.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							l_expires_e.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							l_name_b.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							l_name_e.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							l_value_b.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							l_value_e.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_p___0[0]).to_boolean then
									if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_p___0.ce_gets (l_p___0 + 1)
								end
							end
							js.reset
							if not (l_p___0[0]).to_boolean then
								js.continue
							elseif (l_p___0[0]).to_integer_32 = 35 then
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 32 -- skip if block
						end
				when 4 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 7 -- skip loop
						end
				when 5 then -- loop body:
						js.reset
						l_domain_b.ce_gets (l_p___0)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_p___0[0]).to_boolean then
								if (l_p___0[0]).to_integer_32 = 9 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0.ce_gets (l_p___0 + 1)
							end
						end
						js.reset
						l_domain_e.ce_gets (l_p___0)
						if (l_domain_b.c_pointer.to_integer_32).to_natural_32 = (l_domain_e.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 31 -- goto next
						elseif not (l_p___0[0]).to_boolean then
							l_pos := -1 + 31 -- goto next
						end
				when 6 then
						l_p___0.ce_gets (l_p___0 + 1)
						js.break
						l_pos := -1 + 4 -- back to loop condition
				when 7 then -- loop done
						js.reset
				when 8 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 11 -- skip loop
						end
				when 9 then -- loop body:
						js.reset
						l_domflag_b.ce_gets (l_p___0)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_p___0[0]).to_boolean then
								if (l_p___0[0]).to_integer_32 = 9 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0.ce_gets (l_p___0 + 1)
							end
						end
						js.reset
						l_domflag_e.ce_gets (l_p___0)
						if (l_domflag_b.c_pointer.to_integer_32).to_natural_32 = (l_domflag_e.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 31 -- goto next
						elseif not (l_p___0[0]).to_boolean then
							l_pos := -1 + 31 -- goto next
						end
				when 10 then
						l_p___0.ce_gets (l_p___0 + 1)
						js.break
						l_pos := -1 + 8 -- back to loop condition
				when 11 then -- loop done
						js.reset
				when 12 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 15 -- skip loop
						end
				when 13 then -- loop body:
						js.reset
						l_path_b.ce_gets (l_p___0)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_p___0[0]).to_boolean then
								if (l_p___0[0]).to_integer_32 = 9 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0.ce_gets (l_p___0 + 1)
							end
						end
						js.reset
						l_path_e.ce_gets (l_p___0)
						if (l_path_b.c_pointer.to_integer_32).to_natural_32 = (l_path_e.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 31 -- goto next
						elseif not (l_p___0[0]).to_boolean then
							l_pos := -1 + 31 -- goto next
						end
				when 14 then
						l_p___0.ce_gets (l_p___0 + 1)
						js.break
						l_pos := -1 + 12 -- back to loop condition
				when 15 then -- loop done
						js.reset
				when 16 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 19 -- skip loop
						end
				when 17 then -- loop body:
						js.reset
						l_secure_b.ce_gets (l_p___0)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_p___0[0]).to_boolean then
								if (l_p___0[0]).to_integer_32 = 9 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0.ce_gets (l_p___0 + 1)
							end
						end
						js.reset
						l_secure_e.ce_gets (l_p___0)
						if (l_secure_b.c_pointer.to_integer_32).to_natural_32 = (l_secure_e.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 31 -- goto next
						elseif not (l_p___0[0]).to_boolean then
							l_pos := -1 + 31 -- goto next
						end
				when 18 then
						l_p___0.ce_gets (l_p___0 + 1)
						js.break
						l_pos := -1 + 16 -- back to loop condition
				when 19 then -- loop done
						js.reset
				when 20 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 23 -- skip loop
						end
				when 21 then -- loop body:
						js.reset
						l_expires_b.ce_gets (l_p___0)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_p___0[0]).to_boolean then
								if (l_p___0[0]).to_integer_32 = 9 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0.ce_gets (l_p___0 + 1)
							end
						end
						js.reset
						l_expires_e.ce_gets (l_p___0)
						if (l_expires_b.c_pointer.to_integer_32).to_natural_32 = (l_expires_e.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 31 -- goto next
						elseif not (l_p___0[0]).to_boolean then
							l_pos := -1 + 31 -- goto next
						end
				when 22 then
						l_p___0.ce_gets (l_p___0 + 1)
						js.break
						l_pos := -1 + 20 -- back to loop condition
				when 23 then -- loop done
						js.reset
				when 24 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 27 -- skip loop
						end
				when 25 then -- loop body:
						js.reset
						l_name_b.ce_gets (l_p___0)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_p___0[0]).to_boolean then
								if (l_p___0[0]).to_integer_32 = 9 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0.ce_gets (l_p___0 + 1)
							end
						end
						js.reset
						l_name_e.ce_gets (l_p___0)
						if (l_name_b.c_pointer.to_integer_32).to_natural_32 = (l_name_e.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 31 -- goto next
						elseif not (l_p___0[0]).to_boolean then
							l_pos := -1 + 31 -- goto next
						end
				when 26 then
						l_p___0.ce_gets (l_p___0 + 1)
						js.break
						l_pos := -1 + 24 -- back to loop condition
				when 27 then -- loop done
						js.reset
						l_value_b.ce_gets (l_p___0)
						l_value_e.ce_gets (l_p___0 + (strlen (l_p___0)).to_integer_32)
						if (l_value_e.c_pointer.to_integer_32).to_natural_32 > (l_value_b.c_pointer.to_integer_32).to_natural_32 then
							if (l_value_e[-1]).to_integer_32 = 10 then
								l_value_e.ce_gets (l_value_e - 1)
							end
						end
						if (l_value_e.c_pointer.to_integer_32).to_natural_32 > (l_value_b.c_pointer.to_integer_32).to_natural_32 then
							if (l_value_e[-1]).to_integer_32 = 13 then
								l_value_e.ce_gets (l_value_e - 1)
							end
						end
						l_cookie.ce_gets (cookie_new)
						l_cookie.item.attr := utils_inst.strdupdelim (l_name_b, l_name_e)
						l_cookie.item.value := utils_inst.strdupdelim (l_value_b, l_value_e)
						l_cookie.item.path := utils_inst.strdupdelim (l_path_b, l_path_e)
						if (l_secure_e.distance (l_secure_b)).to_natural_32 = (("TRUE").count + 1).to_natural_32 - {NATURAL_32} 1 then
							if (memcmp (create {CE_POINTER [ANY]}.make_cast (l_secure_b), create {CE_POINTER [ANY]}.make_cast (ce_string ("TRUE")), (("TRUE").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean then
								l_tmp___7 := 0
							else
								l_tmp___7 := 1
							end
						else
							l_tmp___7 := 0
						end
						l_cookie.item.secure := l_tmp___7.to_natural_32
						if (l_domflag_e.distance (l_domflag_b)).to_natural_32 = (("TRUE").count + 1).to_natural_32 - {NATURAL_32} 1 then
							if (memcmp (create {CE_POINTER [ANY]}.make_cast (l_domflag_b), create {CE_POINTER [ANY]}.make_cast (ce_string ("TRUE")), (("TRUE").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean then
								l_tmp___9 := 1
							else
								l_tmp___9 := 0
							end
						else
							l_tmp___9 := 1
						end
						l_cookie.item.domain_exact := l_tmp___9.to_natural_32
						l_port := domain_port (l_domain_b, l_domain_e, (l_domain_e.address))
						if l_port.to_boolean then
							l_cookie.item.port := l_port
						end
						if (l_domain_b[0]).to_integer_32 = 46 then
							l_domain_b.ce_gets (l_domain_b + 1)
						end
						l_cookie.item.domain := utils_inst.strdupdelim (l_domain_b, l_domain_e)
						l_expiry := cookies_now.to_double - (1).to_double
						l_expires_e[0] := (('%/0/').code).to_integer_8
						sscanf ([l_expires_b, ce_string ("%%lf"), create {CE_POINTER [REAL_64]}.make_shared ($l_expiry)]).do_nothing
						if (l_expiry = (0).to_double) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						if l_expiry < cookies_now.to_double then
							l_pos := -1 + 33 -- goto abort_cookie
						end
				when 29 then
						l_cookie.item.expiry_time := l_expiry.truncated_to_integer
						l_cookie.item.permanent := {NATURAL_32} 1
				when 30 then -- if done
						store_cookie (a_jar, l_cookie)
				when 31 then -- next:
						js.continue
				when 32 then -- if done
						if js.loop_jumped then
							l_pos := -1 + 34 -- skip if block
						end
				when 33 then -- if: | abort_cookie:
						delete_cookie (l_cookie)
				when 34 then -- if done
						if not js.loop_left then
							free (create {CE_POINTER [ANY]}.make_cast (l_line))
						end
						l_pos := -1 + 2 -- back to loop condition
				when 35 then -- loop done
						js.reset
						fclose (l_fp).do_nothing
				when 36 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cookie_jar_save (a_jar: CE_POINTER [PD_COOKIE_JAR]; a_file: CE_POINTER [INTEGER_8])
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_iter: PD_HASH_TABLE_ITERATOR
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_domain: CE_POINTER [INTEGER_8]
			l_cookie: CE_POINTER [PD_COOKIE]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___17: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fp.make
			create l_iter.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_domain.make
			create l_cookie.make
			create l_tmp___6.make
			create l_tmp___7.make
			create l_tmp___11.make
			create l_tmp___12.make
			create l_tmp___16.make
			create l_tmp___17.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					from
					until
						js.loop_left
					loop
						js.reset
						if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
							log_inst.debug_logprintf ([ce_string ("Saving cookies to %%s.%N"), a_file])
						end
						js.break
					end
					js.reset
					cookies_now := time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
					l_fp.ce_gets (fopen (a_file, ce_string ("w")))
					if (l_fp).c_pointer = default_pointer then
						l_tmp___1.ce_gets (strerror ((errno_location).item))
						l_tmp___2.ce_gets (quote_inst.quote (a_file))
						log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Cannot open cookies file %%s: %%s%N"))), l_tmp___2, l_tmp___1])
						js.return
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						fputs (ce_string ("# HTTP cookie file.%N"), l_fp).do_nothing
						fprintf ([l_fp, ce_string ("# Generated by Wget on %%s.%N"), (utils_inst.datetime_str (cookies_now))]).do_nothing
						fputs (ce_string ("# Edit at your own risk.%N%N"), l_fp).do_nothing
						hash_inst.hash_table_iterate (a_jar.item.chains, l_iter.address)
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 9 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if not (hash_inst.hash_table_iter_next (l_iter.address)).to_boolean then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 8 -- skip if block
						end
				when 4 then -- if:
						l_domain.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (l_iter.key))
						l_cookie.ce_gets (create {CE_POINTER [PD_COOKIE]}.make_cast (l_iter.value))
				when 5 then -- loop condition:
						if (l_cookie).c_pointer = default_pointer then
							l_pos := -1 + 8 -- skip loop
						end
				when 6 then -- loop body:
						js.reset
						if not (l_cookie.item.permanent).to_boolean then
							if not options_inst.opt.keep_session_cookies then
								js.continue
							end
						end
						if not js.loop_jumped then
							if (cookie_expired_p (l_cookie)) then
								js.continue
							end
						end
						if not js.loop_jumped then
							if not (l_cookie.item.domain_exact).to_boolean then
								fputc (('.').code, l_fp).do_nothing
							end
							fputs (l_domain, l_fp).do_nothing
							if l_cookie.item.port /= -1 then
								fprintf ([l_fp, ce_string (":%%d"), l_cookie.item.port]).do_nothing
							end
							if (l_cookie.item.secure).to_boolean then
								l_tmp___6.ce_gets (ce_string ("TRUE"))
							else
								l_tmp___6.ce_gets (ce_string ("FALSE"))
							end
							if (l_cookie.item.domain_exact).to_boolean then
								l_tmp___7.ce_gets (ce_string ("FALSE"))
							else
								l_tmp___7.ce_gets (ce_string ("TRUE"))
							end
							fprintf ([l_fp, ce_string ("%T%%s%T%%s%T%%s%T%%.0f%T%%s%T%%s%N"), l_tmp___7, l_cookie.item.path, l_tmp___6, (l_cookie.item.expiry_time).to_double, l_cookie.item.attr, l_cookie.item.value]).do_nothing
							if (ferror (l_fp)).to_boolean then
								l_pos := -1 + 10 -- goto out
							end
						end
				when 7 then
						l_cookie.ce_gets (l_cookie.item.next)
						l_pos := -1 + 5 -- back to loop condition
				when 8 then -- loop done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 9 then -- loop done
						js.reset
				when 10 then -- out:
						if (ferror (l_fp)).to_boolean then
							l_tmp___11.ce_gets (strerror ((errno_location).item))
							l_tmp___12.ce_gets (quote_inst.quote (a_file))
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Error writing to %%s: %%s%N"))), l_tmp___12, l_tmp___11])
						end
						if (fclose (l_fp)) < 0 then
							l_tmp___16.ce_gets (strerror ((errno_location).item))
							l_tmp___17.ce_gets (quote_inst.quote (a_file))
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Error closing %%s: %%s%N"))), l_tmp___17, l_tmp___16])
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("Done saving cookies.%N")])
							end
							js.break
						end
						js.reset
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cookie_jar_delete (a_jar: CE_POINTER [PD_COOKIE_JAR])
		local
			l_iter: PD_HASH_TABLE_ITERATOR
			l_chain: CE_POINTER [PD_COOKIE]
			l_next: CE_POINTER [PD_COOKIE]
			js: JUMP_STATE
		do
			create l_iter.make
			create l_chain.make
			create l_next.make

			hash_inst.hash_table_iterate (a_jar.item.chains, l_iter.address)
			from
			until
				js.loop_left
			loop
				js.reset
				if not (hash_inst.hash_table_iter_next (l_iter.address)).to_boolean then
					js.break
				end
				if not js.loop_jumped then
					l_chain.ce_gets (create {CE_POINTER [PD_COOKIE]}.make_cast (l_iter.value))
					free (l_iter.key)
					from
					until
						(l_chain).c_pointer = default_pointer
					loop
						l_next.ce_gets (l_chain.item.next)
						delete_cookie (l_chain)
						l_chain.ce_gets (l_next)
					end
				end
			end
			js.reset
			hash_inst.hash_table_destroy (a_jar.item.chains)
			free (create {CE_POINTER [ANY]}.make_cast (a_jar))
		end

end
