class
	P_FTP

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create ftp_last_respline.make (<<128>>)
		end

feature {ANY} -- attributes

	depth: INTEGER_32 assign set_depth

	set_depth (a_depth: INTEGER_32)
		do
			depth := a_depth
		end

	ftp_last_respline: CE_ARRAY [INTEGER_8]

feature {ANY} -- routines

	ftp_expected_bytes (a_s: CE_POINTER [INTEGER_8]): INTEGER_64
		local
			l_s: CE_POINTER [INTEGER_8]
			l_res___0: INTEGER_64
			js: JUMP_STATE
		do
			create l_s.make

			l_s.ce_gets (a_s)
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_s[0]).to_boolean then
						if (l_s[0]).to_integer_32 = 40 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_s.ce_gets (l_s + 1)
					end
				end
				js.reset
				if not (l_s[0]).to_boolean then
					Result := (0).to_integer_64
					js.return
				end
				if not js.return_called then
					l_s.ce_gets (l_s + 1)
					l_res___0 := strtoll (l_s, (l_s.address), 10)
					if not (l_s[0]).to_boolean then
						Result := (0).to_integer_64
						js.return
					end
				end
				if not js.return_called then
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_s[0]).to_boolean then
							if not (c_ctype_inst.c2_isspace ((l_s[0]).to_integer_32)) then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_s.ce_gets (l_s + 1)
						end
					end
					js.reset
					if not (l_s[0]).to_boolean then
						Result := (0).to_integer_64
						js.return
					end
				end
				if not js.return_called then
					if (c_ctype_inst.c2_tolower ((l_s[0]).to_integer_32)) /= 98 then
						js.continue
					end
					if not js.loop_jumped then
						if (strncasecmp (l_s, ce_string ("byte"), (4).to_natural_32)).to_boolean then
							js.continue
						else
							js.break
						end
					end
				end
			end
			js.reset
			if not js.return_called then
				Result := l_res___0
			end
		end

	ftp_do_pasv (a_csock: INTEGER_32; a_addr: CE_POINTER [PD_IP_ADDRESS]; a_port: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_err: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (connect_inst.socket_ip_address (a_csock, a_addr, 1)) then
						abort
					end
					inspect a_addr.item.family -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 10 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2
					if not options_inst.opt.server_response then
						log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> PASV ... "))
					end
					l_err := ftp_basic_inst.ftp_pasv (a_csock, a_addr, a_port)
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 10
					if not options_inst.opt.server_response then
						log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> EPSV ... "))
					end
					l_err := ftp_basic_inst.ftp_epsv (a_csock, a_addr, a_port)
					if l_err.to_natural_32 = {NATURAL_32} 36 then
						if not options_inst.opt.server_response then
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> LPSV ... "))
						end
						l_err := ftp_basic_inst.ftp_lpsv (a_csock, a_addr, a_port)
					end
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					abort
				when 4 then -- switch 1, done:
					Result := l_err
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_do_port (a_csock: INTEGER_32; a_local_sock: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_err: INTEGER_32
			l_cip: PD_IP_ADDRESS
			l_pos: INTEGER_32
		do
			create l_cip.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (connect_inst.socket_ip_address (a_csock, l_cip.address, 1)) then
						abort
					end
					inspect l_cip.family -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 10 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2
					if not options_inst.opt.server_response then
						log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> PORT ... "))
					end
					l_err := ftp_basic_inst.ftp_port (a_csock, a_local_sock)
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 10
					if not options_inst.opt.server_response then
						log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> EPRT ... "))
					end
					l_err := ftp_basic_inst.ftp_eprt (a_csock, a_local_sock)
					if l_err.to_natural_32 = {NATURAL_32} 13 then
						if not options_inst.opt.server_response then
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> LPRT ... "))
						end
						l_err := ftp_basic_inst.ftp_lprt (a_csock, a_local_sock)
					end
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					abort
				when 4 then -- switch 1, done:
					Result := l_err
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	print_length (a_size: INTEGER_64; a_start: INTEGER_64; a_authoritative: BOOLEAN)
		local
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
		do
			create l_tmp.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___5.make
			create l_tmp___8.make

			l_tmp.ce_gets (utils_inst.number_to_static_string (a_size))
			log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Length: %%s"))), l_tmp])
			if a_size >= {INTEGER_64} 1024 then
				log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string (" (%%s)"), (utils_inst.human_readable (a_size))])
			end
			if a_start > {INTEGER_64} 0 then
				if a_size - a_start >= {INTEGER_64} 1024 then
					l_tmp___2.ce_gets (utils_inst.human_readable (a_size - a_start))
					l_tmp___3.ce_gets (utils_inst.number_to_static_string (a_size - a_start))
					log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string (", %%s (%%s) remaining"))), l_tmp___3, l_tmp___2])
				else
					l_tmp___5.ce_gets (utils_inst.number_to_static_string (a_size - a_start))
					log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string (", %%s remaining"))), l_tmp___5])
				end
			end
			if not a_authoritative then
				l_tmp___8.ce_gets ((gettext (ce_string (" (unauthoritative)%N"))))
			else
				l_tmp___8.ce_gets (ce_string ("%N"))
			end
			log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___8)
		end

	getftp (a_u: CE_POINTER [PD_URL]; a_passed_expected_bytes: INTEGER_64; a_qtyread: CE_POINTER [INTEGER_64]; a_restval: INTEGER_64; a_con: CE_POINTER [PD_CCON]): INTEGER_32
		local
			l_csock: INTEGER_32
			l_dtsock: INTEGER_32
			l_local_sock: INTEGER_32
			l_res___0: INTEGER_32
			l_err: INTEGER_32
			l_fp: CE_POINTER [SD_IO_FILE]
			l_user: CE_POINTER [INTEGER_8]
			l_passwd: CE_POINTER [INTEGER_8]
			l_respline: CE_POINTER [INTEGER_8]
			l_tms: CE_POINTER [INTEGER_8]
			l_tmrate: CE_POINTER [INTEGER_8]
			l_cmd: INTEGER_32
			l_pasv_mode_open: BOOLEAN
			l_expected_bytes: INTEGER_64
			l_rest_failed: BOOLEAN
			l_flags: INTEGER_32
			l_rd_size: INTEGER_64
			l_type_char: INTEGER_8
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_host: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_port: INTEGER_32
			l_tmp___2: INTEGER_32
			l_logname: CE_POINTER [INTEGER_8]
			l_tmp___5: INTEGER_32
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_targ: CE_POINTER [INTEGER_8]
			l_cwd_count: INTEGER_32
			l_cwd_end: INTEGER_32
			l_cwd_start: INTEGER_32
			l_target: CE_POINTER [INTEGER_8]
			l_idlen: INTEGER_32
			l_ntarget: CE_POINTER [INTEGER_8]
			l_p___0: CE_POINTER [INTEGER_8]
			l_tmp___30: CE_POINTER [INTEGER_8]
			l_tmp___40: CE_POINTER [INTEGER_8]
			l_tmp___46: CE_POINTER [INTEGER_8]
			l_tmp___48: CE_POINTER [INTEGER_8]
			l_passive_addr: PD_IP_ADDRESS
			l_passive_port: INTEGER_32
			l_save_errno: INTEGER_32
			l_tmp___56: CE_POINTER [INTEGER_8]
			l_tmp___57: CE_POINTER [INTEGER_8]
			l_tmp___60: INTEGER_32
			l_tmp___68: CE_POINTER [INTEGER_8]
			l_exists: BOOLEAN
			l_res___1: INTEGER_32
			l_f: CE_POINTER [PD_FILEINFO]
			l_tmp___78: CE_POINTER [INTEGER_8]
			l_tmp___80: CE_POINTER [INTEGER_8]
			l_tmp___85: CE_POINTER [INTEGER_8]
			l_tmp___90: CE_POINTER [INTEGER_8]
			l_tmp___100: INTEGER_64
			l_tmp___103: CE_POINTER [INTEGER_8]
			l_tmp___105: CE_POINTER [INTEGER_8]
			l_line: CE_POINTER [INTEGER_8]
			l_p___1: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_fp.make
			create l_user.make
			create l_passwd.make
			create l_respline.make
			create l_tms.make
			create l_tmrate.make
			create l_tmp.make
			create l_tmp___0.make
			create l_host.make
			create l_tmp___1.make
			create l_logname.make
			create l_tmp___8.make
			create l_targ.make
			create l_target.make
			create l_ntarget.make
			create l_p___0.make
			create l_tmp___30.make
			create l_tmp___40.make
			create l_tmp___46.make
			create l_tmp___48.make
			create l_passive_addr.make
			create l_tmp___56.make
			create l_tmp___57.make
			create l_tmp___68.make
			create l_f.make
			create l_tmp___78.make
			create l_tmp___80.make
			create l_tmp___85.make
			create l_tmp___90.make
			create l_tmp___103.make
			create l_tmp___105.make
			create l_line.make
			create l_p___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_err := {PC_UERR_T}.RETROK
					l_cmd := a_con.item.cmd
					l_pasv_mode_open := (0).to_boolean
					l_expected_bytes := (0).to_integer_64
					l_rest_failed := (0).to_boolean
					if (a_con.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						assert_fail (ce_string ("con != ((void *)0)"), ce_string ("ftp.c"), {NATURAL_32} 260, ce_string ("getftp"))
					end
					if ((a_con.item.target).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						assert_fail (ce_string ("con->target != ((void *)0)"), ce_string ("ftp.c"), {NATURAL_32} 261, ce_string ("getftp"))
					end
					if ((l_cmd).bit_and (8)).to_boolean then
						if ((l_cmd).bit_and (4)).to_boolean then
							assert_fail (ce_string ("!((cmd & DO_LIST) && (cmd & DO_RETR))"), ce_string ("ftp.c"), {NATURAL_32} 266, ce_string ("getftp"))
						end
					end
					if ((l_cmd).bit_and (15)) = 0 then
						assert_fail (ce_string ("(cmd & (DO_LIST | DO_CWD | DO_RETR | DO_LOGIN)) != 0"), ce_string ("ftp.c"), {NATURAL_32} 268, ce_string ("getftp"))
					end
					a_qtyread.item := a_restval
					l_user.ce_gets (a_u.item.user)
					l_passwd.ce_gets (a_u.item.passwd)
					netrc_inst.search_netrc (a_u.item.host, (l_user.address), (l_passwd.address), 1)
					if ((l_user).c_pointer /= default_pointer) then
						l_user.ce_gets (l_user)
					else
						if ((options_inst.opt.ftp_user).c_pointer /= default_pointer) then
							l_tmp.ce_gets (options_inst.opt.ftp_user)
						else
							l_tmp.ce_gets (options_inst.opt.user)
						end
						l_user.ce_gets (l_tmp)
					end
					if (l_user).c_pointer = default_pointer then
						l_user.ce_gets (ce_string ("anonymous"))
					end
					if ((l_passwd).c_pointer /= default_pointer) then
						l_passwd.ce_gets (l_passwd)
					else
						if ((options_inst.opt.ftp_passwd).c_pointer /= default_pointer) then
							l_tmp___0.ce_gets (options_inst.opt.ftp_passwd)
						else
							l_tmp___0.ce_gets (options_inst.opt.passwd)
						end
						l_passwd.ce_gets (l_tmp___0)
					end
					if (l_passwd).c_pointer = default_pointer then
						l_passwd.ce_gets (ce_string ("-wget@"))
					end
					l_dtsock := -1
					l_local_sock := -1
					a_con.item.dltime := (0).to_double
					if ((l_cmd).bit_and (1)).to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_csock := a_con.item.csock
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 3 then -- else:
						if ((a_con.item.proxy).c_pointer /= default_pointer) then
							l_tmp___1.ce_gets ((a_con.item.proxy).item.host)
						else
							l_tmp___1.ce_gets (a_u.item.host)
						end
						l_host.ce_gets (l_tmp___1)
						if ((a_con.item.proxy).c_pointer /= default_pointer) then
							l_tmp___2 := (a_con.item.proxy).item.port
						else
							l_tmp___2 := a_u.item.port
						end
						l_port := l_tmp___2
						l_logname.ce_gets (l_user)
						if ((a_con.item.proxy).c_pointer /= default_pointer) then
							l_logname.ce_gets (utils_inst.concat_strings ([l_user, ce_string ("@"), a_u.item.host, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)]))
						end
						l_csock := connect_inst.connect_to_host (l_host, l_port)
						if l_csock = -100 then
							Result := ({PC_UERR_T}.HOSTERR)
							js.return
						elseif l_csock < 0 then
							if (connect_inst.retryable_socket_connect_error ((errno_location).item)) then
								l_tmp___5 := 3
							else
								l_tmp___5 := 5
							end
							Result := l_tmp___5
							js.return
						end
						if js.return_called then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if ((l_cmd).bit_and (16)).to_boolean then
							a_con.item.csock := l_csock
						else
							a_con.item.csock := -1
						end
						l_tmp___8.ce_gets (quotearg_inst.quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_user))
						log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Logging in as %%s ... "))), l_tmp___8])
						if options_inst.opt.server_response then
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_ALWAYS, ce_string ("%N"))
						end
						l_err := ftp_basic_inst.ftp_login (l_csock, l_logname, l_passwd)
						if ((a_con.item.proxy).c_pointer /= default_pointer) then
							free (create {CE_POINTER [ANY]}.make_cast (l_logname))
						end
						inspect l_err -- switch 1 head
						when 18 then l_pos := -1 + 5
						when 20 then l_pos := -1 + 6
						when 52 then l_pos := -1 + 7
						when 12 then l_pos := -1 + 8
						when 11 then l_pos := -1 + 9
						when 10 then l_pos := -1 + 10
						else l_pos := -1 + 11
						end
				when 5 then -- switch 1, case 18
						log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
						log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Error in server response, closing control connection.%N"))))
						connect_inst.fd_close (l_csock)
						a_con.item.csock := -1
						Result := l_err
						js.return
				when 6 then -- switch 1, case 20
						if not js.return_called then
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Error in server greeting.%N"))))
							connect_inst.fd_close (l_csock)
							a_con.item.csock := -1
							Result := l_err
							js.return
						end
				when 7 then -- switch 1, case 52
						if not js.return_called then
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Write failed, closing control connection.%N"))))
							connect_inst.fd_close (l_csock)
							a_con.item.csock := -1
							Result := l_err
							js.return
						end
				when 8 then -- switch 1, case 12
						if not js.return_called then
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("The server refuses login.%N"))))
							connect_inst.fd_close (l_csock)
							a_con.item.csock := -1
							Result := ({PC_UERR_T}.FTPLOGREFUSED)
							js.return
						end
				when 9 then -- switch 1, case 11
						if not js.return_called then
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Login incorrect.%N"))))
							connect_inst.fd_close (l_csock)
							a_con.item.csock := -1
							Result := ({PC_UERR_T}.FTPLOGINC)
							js.return
						end
				when 10 then -- switch 1, case 10
						if not js.return_called and then (not options_inst.opt.server_response) then
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Logged in!%N"))))
						end
						l_pos := -1 + 12 -- switch 1; break
				when 11 then -- switch 1, default:
						abort
				when 12 then -- switch 1, done: | if done
						if js.return_called then
							l_pos := -1 + 18 -- skip if block
						end
				when 13 then -- if:
						if not options_inst.opt.server_response then
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> SYST ... ")])
						end
						l_err := ftp_basic_inst.ftp_syst (l_csock, create {CE_POINTER [INTEGER_32]}.make_shared (a_con.c_pointer + {PD_CCON}.rs_offset))
						inspect l_err -- switch 2 head
						when 18 then l_pos := -1 + 14
						when 20 then l_pos := -1 + 15
						when 10 then l_pos := -1 + 16
						else l_pos := -1 + 17
						end
				when 14 then -- switch 2, case 18
						log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
						log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Error in server response, closing control connection.%N"))))
						connect_inst.fd_close (l_csock)
						a_con.item.csock := -1
						Result := l_err
						js.return
				when 15 then -- switch 2, case 20
						if not js.return_called then
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Server error, can%'t determine system type.%N"))))
						end
						l_pos := -1 + 18 -- switch 2; break
				when 16 then -- switch 2, case 10
						l_pos := -1 + 18 -- switch 2; break
				when 17 then -- switch 2, default:
						abort
				when 18 then -- switch 2, done: | if done
						if js.return_called then
							l_pos := -1 + 24 -- skip if block
						end
				when 19 then -- if:
						if not options_inst.opt.server_response then
							if l_err.to_natural_32 /= {NATURAL_32} 20 then
								log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("done.    "))))
							end
						end
						if not options_inst.opt.server_response then
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> PWD ... ")])
						end
						l_err := ftp_basic_inst.ftp_pwd (l_csock, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (a_con.c_pointer + {PD_CCON}.id_offset))
						inspect l_err -- switch 3 head
						when 18 then l_pos := -1 + 20
						when 20 then l_pos := -1 + 21
						when 10 then l_pos := -1 + 22
						else l_pos := -1 + 23
						end
				when 20 then -- switch 3, case 18
						log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
						log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Error in server response, closing control connection.%N"))))
						connect_inst.fd_close (l_csock)
						a_con.item.csock := -1
						Result := l_err
						js.return
				when 21 then -- switch 3, case 20
						if not js.return_called then
							if ((a_con.item.id).c_pointer /= default_pointer) then
								free (create {CE_POINTER [ANY]}.make_cast (a_con.item.id))
							end
							a_con.item.id := xmalloc_inst.xstrdup (ce_string ("/"))
						end
						l_pos := -1 + 24 -- switch 3; break
				when 22 then -- switch 3, case 10
						l_pos := -1 + 24 -- switch 3; break
				when 23 then -- switch 3, default:
						abort
				when 24 then -- switch 3, done: | if done
						if js.return_called then
							l_pos := -1 + 31 -- skip if block
						end
				when 25 then -- if:
						if not options_inst.opt.server_response then
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("done.%N"))))
						end
						l_type_char := ftp_basic_inst.ftp_process_type (a_u.item.params)
						if not options_inst.opt.server_response then
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> TYPE %%c ... "), l_type_char.to_integer_32])
						end
						l_err := ftp_basic_inst.ftp_type (l_csock, l_type_char.to_integer_32)
						inspect l_err -- switch 4 head
						when 18 then l_pos := -1 + 26
						when 52 then l_pos := -1 + 27
						when 17 then l_pos := -1 + 28
						when 10 then l_pos := -1 + 29
						else l_pos := -1 + 30
						end
				when 26 then -- switch 4, case 18
						log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
						log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Error in server response, closing control connection.%N"))))
						connect_inst.fd_close (l_csock)
						a_con.item.csock := -1
						Result := l_err
						js.return
				when 27 then -- switch 4, case 52
						if not js.return_called then
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Write failed, closing control connection.%N"))))
							connect_inst.fd_close (l_csock)
							a_con.item.csock := -1
							Result := l_err
							js.return
						end
				when 28 then -- switch 4, case 17
						if not js.return_called then
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Unknown type `%%c%', closing control connection.%N"))), l_type_char.to_integer_32])
							connect_inst.fd_close (l_csock)
							a_con.item.csock := -1
							Result := l_err
							js.return
						end
				when 29 then -- switch 4, case 10
						l_pos := -1 + 31 -- switch 4; break
				when 30 then -- switch 4, default:
						abort
				when 31 then -- switch 4, done: | if done
						if not js.return_called and then (not options_inst.opt.server_response) then
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("done.  "))))
						end
				when 32 then -- if done
					if js.return_called then
						l_pos := -1 + 58 -- skip if block
					end
				when 33 then -- if:
						if not (((l_cmd).bit_and (2)).to_boolean) then
							l_pos := -1 + 57 -- skip if block
						end
				when 34 then -- if:
						if ((a_u.item.dir).item).to_boolean then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("==> CWD not needed.%N"))))
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 56
				when 37 then -- else:
						l_target.ce_gets (a_u.item.dir)
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("changing working directory%N")])
							end
							js.break
						end
						js.reset
						if (l_target[0]).to_integer_32 = 47 then
							l_pos := -1 + 42 -- skip if block
						end
				when 38 then -- if:
						if (a_con.item.rs).to_natural_32 = {NATURAL_32} 0 then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						if (c_ctype_inst.c2_isalpha ((l_target[0]).to_integer_32)) then
							if (l_target[1]).to_integer_32 /= 58 then
								l_pos := -1 + 41 -- goto _L___0
							end
						else
							l_pos := -1 + 41 -- goto _L___0
						end
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else: | _L___0:
						if (a_con.item.rs).to_natural_32 /= {NATURAL_32} 4 then
							if (a_con.item.rs).to_natural_32 /= {NATURAL_32} 1 then
								l_idlen := (strlen (a_con.item.id)).to_integer_32
								from
								until
									js.loop_left
								loop
									js.reset
									if l_idlen > 0 then
										if (a_con.item.id[(l_idlen - 1)]).to_integer_32 /= 47 then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_idlen := l_idlen - 1
									end
								end
								js.reset
								l_ntarget.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new (((l_idlen + 1).to_natural_32 + (strlen (a_u.item.dir))) + {NATURAL_32} 1))))
								l_p___0.ce_gets (l_ntarget)
								memcpy (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (a_con.item.id), l_idlen.to_natural_32).do_nothing
								l_p___0.ce_gets (l_p___0 + l_idlen)
								l_tmp___30.ce_gets (l_p___0)
								l_p___0.ce_gets (l_p___0 + 1)
								l_tmp___30[0] := (('/').code).to_integer_8
								strcpy (l_p___0, l_target).do_nothing
								from
								until
									js.loop_left
								loop
									js.reset
									if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
										log_inst.debug_logprintf ([ce_string ("Prepended initial PWD to relative path:%N")])
									end
									js.break
								end
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
										log_inst.debug_logprintf ([ce_string ("   pwd: %'%%s%'%N   old: %'%%s%'%N  new: %'%%s%'%N"), a_con.item.id, l_target, l_ntarget])
									end
									js.break
								end
								js.reset
								l_target.ce_gets (l_ntarget)
							end
						end
				when 42 then -- if done
						if (a_con.item.rs).to_natural_32 = {NATURAL_32} 1 then
							if (l_target[0]).to_integer_32 /= 47 then
								l_cwd_start := 0
								from
								until
									js.loop_left
								loop
									js.reset
									if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
										log_inst.debug_logprintf ([ce_string ("Using two-step CWD for relative path.%N")])
									end
									js.break
								end
								js.reset
							else
								l_cwd_start := 1
							end
						else
							l_cwd_start := 1
						end
						if (a_con.item.rs).to_natural_32 = {NATURAL_32} 1 then
							if ((strchr (l_target, ('/').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_cwd_end := 3
								from
								until
									js.loop_left
								loop
									js.reset
									if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
										log_inst.debug_logprintf ([ce_string ("Using extra %"CWD []%" step for VMS server.%N")])
									end
									js.break
								end
								js.reset
							else
								l_cwd_end := 2
							end
						else
							l_cwd_end := 2
						end
						l_cwd_count := l_cwd_start
				when 43 then -- loop condition:
						if not (not js.loop_left and then (l_cwd_count < l_cwd_end)) then
							l_pos := -1 + 56 -- skip loop
						end
				when 44 then -- loop body:
						inspect l_cwd_count -- switch 5 head
						when 0 then l_pos := -1 + 45
						when 1 then l_pos := -1 + 46
						when 2 then l_pos := -1 + 47
						else l_pos := -1 + 48
						end
				when 45 then -- switch 5, case 0
						l_targ.ce_gets (a_con.item.id)
						l_pos := -1 + 49 -- switch 5; break
				when 46 then -- switch 5, case 1
						l_targ.ce_gets (l_target)
						l_pos := -1 + 49 -- switch 5; break
				when 47 then -- switch 5, case 2
						l_targ.ce_gets (ce_string ("[]"))
						l_pos := -1 + 49 -- switch 5; break
				when 48 then -- switch 5, default:
						
				when 49 then -- switch 5, done:
						if not options_inst.opt.server_response then
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> CWD (%%d) %%s ... "), l_cwd_count, (quotearg_inst.quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_target))])
						end
						l_err := ftp_basic_inst.ftp_cwd (l_csock, l_target)
						inspect l_err -- switch 6 head
						when 18 then l_pos := -1 + 50
						when 52 then l_pos := -1 + 51
						when 15 then l_pos := -1 + 52
						when 10 then l_pos := -1 + 53
						else l_pos := -1 + 54
						end
				when 50 then -- switch 6, case 18
						log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
						log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Error in server response, closing control connection.%N"))))
						connect_inst.fd_close (l_csock)
						a_con.item.csock := -1
						Result := l_err
						js.return
				when 51 then -- switch 6, case 52
						if not js.return_called then
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Write failed, closing control connection.%N"))))
							connect_inst.fd_close (l_csock)
							a_con.item.csock := -1
							Result := l_err
							js.return
						end
				when 52 then -- switch 6, case 15
						if not js.return_called then
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							l_tmp___40.ce_gets (quote_inst.quote (a_u.item.dir))
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("No such directory %%s.%N%N"))), l_tmp___40])
							connect_inst.fd_close (l_csock)
							a_con.item.csock := -1
							Result := l_err
							js.return
						end
				when 53 then -- switch 6, case 10
						l_pos := -1 + 55 -- switch 6; break
				when 54 then -- switch 6, default:
						abort
				when 55 then -- switch 6, done:
						if not js.return_called then
							if not options_inst.opt.server_response then
								log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("done.%N"))))
							end
							l_cwd_count := l_cwd_count + 1
						end
						l_pos := -1 + 43 -- back to loop condition
				when 56 then -- loop done | if done | if block done, skip else block:
						l_pos := -1 + 58
				when 57 then -- else:
						log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("==> CWD not required.%N"))))
				when 58 then -- if done | if done
						if not (not js.return_called and then (((l_cmd).bit_and (4)).to_boolean)) then
							l_pos := -1 + 65 -- skip if block
						end
				when 59 then -- if:
							if a_passed_expected_bytes /= {INTEGER_64} 0 then
								l_pos := -1 + 65 -- skip if block
							end
				when 60 then -- if:
							if (options_inst.opt.verbose).to_boolean then
								if not options_inst.opt.server_response then
									log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> SIZE %%s ... "), (quotearg_inst.quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, a_u.item.file))])
								end
							end
							l_err := ftp_basic_inst.ftp_size (l_csock, a_u.item.file, create {CE_POINTER [INTEGER_64]}.make_shared ($l_expected_bytes))
							inspect l_err -- switch 7 head
							when 18 then l_pos := -1 + 61
							when 20 then l_pos := -1 + 61
							when 10 then l_pos := -1 + 62
							else l_pos := -1 + 63
							end
				when 61 then -- switch 7, case 18 | switch 7, case 20
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Error in server response, closing control connection.%N"))))
							connect_inst.fd_close (l_csock)
							a_con.item.csock := -1
							Result := l_err
							js.return
				when 62 then -- switch 7, case 10
							l_pos := -1 + 64 -- switch 7; break
				when 63 then -- switch 7, default:
							abort
				when 64 then -- switch 7, done:
							if not js.return_called and then (not options_inst.opt.server_response) then
								l_tmp___46.ce_gets (utils_inst.number_to_static_string (l_expected_bytes))
								if l_expected_bytes.to_boolean then
									l_tmp___48.ce_gets (ce_string ("%%s%N"))
								else
									l_tmp___48.ce_gets ((gettext (ce_string ("done.%N"))))
								end
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___48, l_tmp___46])
							end
				when 65 then -- if done | if done
							if not (not js.return_called and then (((l_cmd).bit_and (12)).to_boolean)) then
								l_pos := -1 + 85 -- skip if block
							end
				when 66 then -- if:
								if not (options_inst.opt.ftp_pasv) then
									l_pos := -1 + 75 -- skip if block
								end
				when 67 then -- if:
								l_err := ftp_do_pasv (l_csock, l_passive_addr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_passive_port))
								inspect l_err -- switch 8 head
								when 18 then l_pos := -1 + 68
								when 52 then l_pos := -1 + 69
								when 36 then l_pos := -1 + 70
								when 35 then l_pos := -1 + 71
								when 10 then l_pos := -1 + 72
								else l_pos := -1 + 73
								end
				when 68 then -- switch 8, case 18
								log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
								log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Error in server response, closing control connection.%N"))))
								connect_inst.fd_close (l_csock)
								a_con.item.csock := -1
								Result := l_err
								js.return
				when 69 then -- switch 8, case 52
								if not js.return_called then
									log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
									log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Write failed, closing control connection.%N"))))
									connect_inst.fd_close (l_csock)
									a_con.item.csock := -1
									Result := l_err
									js.return
								end
				when 70 then -- switch 8, case 36
								if not js.return_called then
									log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
									log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Cannot initiate PASV transfer.%N"))))
								end
								l_pos := -1 + 74 -- switch 8; break
				when 71 then -- switch 8, case 35
								log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
								log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Cannot parse PASV response.%N"))))
								l_pos := -1 + 74 -- switch 8; break
				when 72 then -- switch 8, case 10
								l_pos := -1 + 74 -- switch 8; break
				when 73 then -- switch 8, default:
								abort
				when 74 then -- switch 8, done:
								if not js.return_called and then (l_err.to_natural_32 = {NATURAL_32} 10) then
									from
									until
										js.loop_left
									loop
										js.reset
										if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
											log_inst.debug_logprintf ([ce_string ("trying to connect to %%s port %%d%N"), (host_inst.print_address ((l_passive_addr.address))), l_passive_port])
										end
										js.break
									end
									js.reset
									l_dtsock := connect_inst.connect_to_ip ((l_passive_addr.address), l_passive_port, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
									if l_dtsock < 0 then
										l_save_errno := (errno_location).item
										connect_inst.fd_close (l_csock)
										a_con.item.csock := -1
										l_tmp___56.ce_gets (strerror (l_save_errno))
										l_tmp___57.ce_gets (host_inst.print_address ((l_passive_addr.address)))
										log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("couldn%'t connect to %%s port %%d: %%s%N"))), l_tmp___57, l_passive_port, l_tmp___56])
										if (connect_inst.retryable_socket_connect_error (l_save_errno)) then
											l_tmp___60 := 3
										else
											l_tmp___60 := 5
										end
										Result := l_tmp___60
										js.return
									end
									if not js.return_called then
										l_pasv_mode_open := (1).to_boolean
										if not options_inst.opt.server_response then
											log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("done.    "))))
										end
									end
								end
				when 75 then -- if done
								if not (not js.return_called and then (not l_pasv_mode_open)) then
									l_pos := -1 + 85 -- skip if block
								end
				when 76 then -- if:
								l_err := ftp_do_port (l_csock, create {CE_POINTER [INTEGER_32]}.make_shared ($l_local_sock))
								inspect l_err -- switch 9 head
								when 18 then l_pos := -1 + 77
								when 52 then l_pos := -1 + 78
								when 2 then l_pos := -1 + 79
								when 14 then l_pos := -1 + 80
								when 13 then l_pos := -1 + 81
								when 10 then l_pos := -1 + 82
								else l_pos := -1 + 83
								end
				when 77 then -- switch 9, case 18
								log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
								log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Error in server response, closing control connection.%N"))))
								connect_inst.fd_close (l_csock)
								a_con.item.csock := -1
								connect_inst.fd_close (l_dtsock)
								connect_inst.fd_close (l_local_sock)
								Result := l_err
								js.return
				when 78 then -- switch 9, case 52
								if not js.return_called then
									log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
									log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Write failed, closing control connection.%N"))))
									connect_inst.fd_close (l_csock)
									a_con.item.csock := -1
									connect_inst.fd_close (l_dtsock)
									connect_inst.fd_close (l_local_sock)
									Result := l_err
									js.return
								end
				when 79 then -- switch 9, case 2
								if not js.return_called then
									log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
									log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("socket: %%s%N"), (strerror ((errno_location).item))])
									connect_inst.fd_close (l_csock)
									a_con.item.csock := -1
									connect_inst.fd_close (l_dtsock)
									connect_inst.fd_close (l_local_sock)
									Result := l_err
									js.return
								end
				when 80 then -- switch 9, case 14
								if not js.return_called then
									log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
									l_tmp___68.ce_gets (strerror ((errno_location).item))
									log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Bind error (%%s).%N"))), l_tmp___68])
									connect_inst.fd_close (l_dtsock)
									Result := l_err
									js.return
								end
				when 81 then -- switch 9, case 13
								if not js.return_called then
									log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
									log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Invalid PORT.%N"))))
									connect_inst.fd_close (l_csock)
									a_con.item.csock := -1
									connect_inst.fd_close (l_dtsock)
									connect_inst.fd_close (l_local_sock)
									Result := l_err
									js.return
								end
				when 82 then -- switch 9, case 10
								l_pos := -1 + 84 -- switch 9; break
				when 83 then -- switch 9, default:
								abort
				when 84 then -- switch 9, done:
								if not js.return_called and then (not options_inst.opt.server_response) then
									log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("done.    "))))
								end
				when 85 then -- if done | if done
								if not (not js.return_called and then (a_restval.to_boolean)) then
									l_pos := -1 + 94 -- skip if block
								end
				when 86 then -- if:
									if not (((l_cmd).bit_and (4)).to_boolean) then
										l_pos := -1 + 94 -- skip if block
									end
				when 87 then -- if:
									if not options_inst.opt.server_response then
										log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> REST %%s ... "), (utils_inst.number_to_static_string (a_restval))])
									end
									l_err := ftp_basic_inst.ftp_rest (l_csock, a_restval)
									inspect l_err -- switch 10 head
									when 18 then l_pos := -1 + 88
									when 52 then l_pos := -1 + 89
									when 22 then l_pos := -1 + 90
									when 10 then l_pos := -1 + 91
									else l_pos := -1 + 92
									end
				when 88 then -- switch 10, case 18
									log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
									log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Error in server response, closing control connection.%N"))))
									connect_inst.fd_close (l_csock)
									a_con.item.csock := -1
									connect_inst.fd_close (l_dtsock)
									connect_inst.fd_close (l_local_sock)
									Result := l_err
									js.return
				when 89 then -- switch 10, case 52
									if not js.return_called then
										log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
										log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Write failed, closing control connection.%N"))))
										connect_inst.fd_close (l_csock)
										a_con.item.csock := -1
										connect_inst.fd_close (l_dtsock)
										connect_inst.fd_close (l_local_sock)
										Result := l_err
										js.return
									end
				when 90 then -- switch 10, case 22
									if not js.return_called then
										log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("%NREST failed, starting from scratch.%N"))))
										l_rest_failed := (1).to_boolean
									end
									l_pos := -1 + 93 -- switch 10; break
				when 91 then -- switch 10, case 10
									l_pos := -1 + 93 -- switch 10; break
				when 92 then -- switch 10, default:
									abort
				when 93 then -- switch 10, done:
									if not js.return_called and then (l_err.to_natural_32 /= {NATURAL_32} 22) then
										if not options_inst.opt.server_response then
											log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("done.    "))))
										end
									end
				when 94 then -- if done | if done
									if not (not js.return_called and then (((l_cmd).bit_and (4)).to_boolean)) then
										l_pos := -1 + 103 -- skip if block
									end
				when 95 then -- if:
										if options_inst.opt.spider then
											l_exists := (0).to_boolean
											l_res___1 := ftp_get_listing (a_u, a_con, l_f.address)
											a_con.item.cmd := (a_con.item.cmd).bit_or ((4))
											if l_res___1.to_natural_32 = {NATURAL_32} 31 then
												from
												until
													not (not js.loop_left and then ((l_f).c_pointer /= default_pointer))
												loop
													js.reset
													if not (strcmp (l_f.item.name, a_u.item.file)).to_boolean then
														l_exists := (1).to_boolean
														js.break
													end
													if not js.loop_jumped then
														l_f.ce_gets (l_f.item.next)
													end
												end
												js.reset
												if l_exists then
													log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
													l_tmp___78.ce_gets (quote_inst.quote (a_u.item.file))
													log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("File %%s exists.%N"))), l_tmp___78])
												else
													log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
													l_tmp___80.ce_gets (quote_inst.quote (a_u.item.file))
													log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("No such file %%s.%N"))), l_tmp___80])
												end
											end
											connect_inst.fd_close (l_csock)
											a_con.item.csock := -1
											connect_inst.fd_close (l_dtsock)
											connect_inst.fd_close (l_local_sock)
											Result := ({PC_UERR_T}.RETRFINISHED)
											js.return
										end
										if js.return_called then
											l_pos := -1 + 102 -- skip if block
										end
				when 96 then -- if:
										if (options_inst.opt.verbose).to_boolean then
											if not options_inst.opt.server_response then
												if a_restval.to_boolean then
													log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
												end
												log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> RETR %%s ... "), (quotearg_inst.quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, a_u.item.file))])
											end
										end
										l_err := ftp_basic_inst.ftp_retr (l_csock, a_u.item.file)
										inspect l_err -- switch 11 head
										when 18 then l_pos := -1 + 97
										when 52 then l_pos := -1 + 98
										when 15 then l_pos := -1 + 99
										when 10 then l_pos := -1 + 100
										else l_pos := -1 + 101
										end
				when 97 then -- switch 11, case 18
										log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
										log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Error in server response, closing control connection.%N"))))
										connect_inst.fd_close (l_csock)
										a_con.item.csock := -1
										connect_inst.fd_close (l_dtsock)
										connect_inst.fd_close (l_local_sock)
										Result := l_err
										js.return
				when 98 then -- switch 11, case 52
										if not js.return_called then
											log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
											log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Write failed, closing control connection.%N"))))
											connect_inst.fd_close (l_csock)
											a_con.item.csock := -1
											connect_inst.fd_close (l_dtsock)
											connect_inst.fd_close (l_local_sock)
											Result := l_err
											js.return
										end
				when 99 then -- switch 11, case 15
										if not js.return_called then
											log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
											l_tmp___85.ce_gets (quote_inst.quote (a_u.item.file))
											log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("No such file %%s.%N%N"))), l_tmp___85])
											connect_inst.fd_close (l_dtsock)
											connect_inst.fd_close (l_local_sock)
											Result := l_err
											js.return
										end
				when 100 then -- switch 11, case 10
										l_pos := -1 + 102 -- switch 11; break
				when 101 then -- switch 11, default:
										abort
				when 102 then -- switch 11, done: | if done
										if not js.return_called then
											if not options_inst.opt.server_response then
												log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("done.%N"))))
											end
											l_expected_bytes := ftp_expected_bytes (ftp_last_respline)
										end
				when 103 then -- if done
									if not (not js.return_called and then (((l_cmd).bit_and (8)).to_boolean)) then
										l_pos := -1 + 111 -- skip if block
									end
				when 104 then -- if:
										if not options_inst.opt.server_response then
											log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("==> LIST ... "))
										end
										l_err := ftp_basic_inst.ftp_list (l_csock, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), a_con.item.rs)
										inspect l_err -- switch 12 head
										when 18 then l_pos := -1 + 105
										when 52 then l_pos := -1 + 106
										when 15 then l_pos := -1 + 107
										when 10 then l_pos := -1 + 108
										else l_pos := -1 + 109
										end
				when 105 then -- switch 12, case 18
										log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
										log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Error in server response, closing control connection.%N"))))
										connect_inst.fd_close (l_csock)
										a_con.item.csock := -1
										connect_inst.fd_close (l_dtsock)
										connect_inst.fd_close (l_local_sock)
										Result := l_err
										js.return
				when 106 then -- switch 12, case 52
										if not js.return_called then
											log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
											log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Write failed, closing control connection.%N"))))
											connect_inst.fd_close (l_csock)
											a_con.item.csock := -1
											connect_inst.fd_close (l_dtsock)
											connect_inst.fd_close (l_local_sock)
											Result := l_err
											js.return
										end
				when 107 then -- switch 12, case 15
										if not js.return_called then
											log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
											l_tmp___90.ce_gets (quote_inst.quote (ce_string (".")))
											log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("No such file or directory %%s.%N%N"))), l_tmp___90])
											connect_inst.fd_close (l_dtsock)
											connect_inst.fd_close (l_local_sock)
											Result := l_err
											js.return
										end
				when 108 then -- switch 12, case 10
										l_pos := -1 + 110 -- switch 12; break
				when 109 then -- switch 12, default:
										abort
				when 110 then -- switch 12, done:
										if not js.return_called then
											if not options_inst.opt.server_response then
												log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("done.%N"))))
											end
											l_expected_bytes := ftp_expected_bytes (ftp_last_respline)
										end
				when 111 then -- if done
									if not js.return_called then
										if not ((l_cmd).bit_and (12)).to_boolean then
											Result := ({PC_UERR_T}.RETRFINISHED)
											js.return
										elseif options_inst.opt.spider then
											if not ((l_cmd).bit_and (8)).to_boolean then
												Result := ({PC_UERR_T}.RETRFINISHED)
												js.return
											end
										end
									end
									if not js.return_called then
										if a_passed_expected_bytes.to_boolean then
											if a_restval.to_boolean then
												if l_expected_bytes.to_boolean then
													if l_expected_bytes = a_passed_expected_bytes - a_restval then
														from
														until
															js.loop_left
														loop
															js.reset
															if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
																log_inst.debug_logprintf ([ce_string ("Lying FTP server found, adjusting.%N")])
															end
															js.break
														end
														js.reset
														l_expected_bytes := a_passed_expected_bytes
													end
												end
											end
										end
										if not l_pasv_mode_open then
											l_dtsock := connect_inst.accept_connection (l_local_sock)
											if l_dtsock < 0 then
												log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("accept: %%s%N"), (strerror ((errno_location).item))])
												Result := ({PC_UERR_T}.CONERROR)
												js.return
											end
										end
									end
									if js.return_called then
										l_pos := -1 + 123 -- skip if block
									end
				when 112 then -- if:
										if ((retr_inst.output_stream).c_pointer /= default_pointer) then
											l_pos := -1 + 115 -- skip if block
										end
				when 113 then -- if:
										l_pos := -1 + 116 -- goto _L___2
				when 114 then -- if block done, skip else block:
										l_pos := -1 + 123
				when 115 then -- else:
										if not (((a_con.item.cmd).bit_and (8)).to_boolean) then
											l_pos := -1 + 122 -- skip if block
										end
				when 116 then -- if: | _L___2:
										url_inst.mkalldirs (a_con.item.target).do_nothing
										if options_inst.opt.backups then
											retr_inst.rotate_backups (a_con.item.target)
										end
										if not (a_restval.to_boolean) then
											l_pos := -1 + 119 -- skip if block
										end
				when 117 then -- if:
										if not ((a_con.item.cmd).bit_and (8)).to_boolean then
											l_fp.ce_gets (fopen (a_con.item.target, ce_string ("ab")))
										else
											l_pos := -1 + 119 -- goto _L___1
										end
				when 118 then -- if block done, skip else block:
										l_pos := -1 + 120
				when 119 then -- else: | _L___1:
										if options_inst.opt.noclobber then
											l_fp.ce_gets (fopen (a_con.item.target, ce_string ("wb")))
										elseif options_inst.opt.always_rest then
											l_fp.ce_gets (fopen (a_con.item.target, ce_string ("wb")))
										elseif options_inst.opt.timestamping then
											l_fp.ce_gets (fopen (a_con.item.target, ce_string ("wb")))
										elseif options_inst.opt.dirstruct then
											l_fp.ce_gets (fopen (a_con.item.target, ce_string ("wb")))
										elseif ((options_inst.opt.output_document).c_pointer /= default_pointer) then
											l_fp.ce_gets (fopen (a_con.item.target, ce_string ("wb")))
										else
											l_fp.ce_gets (utils_inst.fopen_excl (a_con.item.target, 1))
											if (l_fp).c_pointer = default_pointer then
												if (errno_location).item = 17 then
													log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("%%s has sprung into existence.%N"))), a_con.item.target])
													connect_inst.fd_close (l_csock)
													a_con.item.csock := -1
													connect_inst.fd_close (l_dtsock)
													connect_inst.fd_close (l_local_sock)
													Result := ({PC_UERR_T}.FOPEN_EXCL_ERR)
													js.return
												end
											end
										end
				when 120 then
										if not js.return_called and then ((l_fp).c_pointer = default_pointer) then
											log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s%N"), a_con.item.target, (strerror ((errno_location).item))])
											connect_inst.fd_close (l_csock)
											a_con.item.csock := -1
											connect_inst.fd_close (l_dtsock)
											connect_inst.fd_close (l_local_sock)
											Result := ({PC_UERR_T}.FOPENERR)
											js.return
										end
				when 121 then -- if block done, skip else block:
										l_pos := -1 + 123
				when 122 then -- else:
										l_fp.ce_gets (retr_inst.output_stream)
				when 123 then -- if done | if done
										if not js.return_called then
											if a_passed_expected_bytes.to_boolean then
												print_length (a_passed_expected_bytes, a_restval, (1).to_boolean)
												l_expected_bytes := a_passed_expected_bytes
											elseif l_expected_bytes.to_boolean then
												print_length (l_expected_bytes, a_restval, (0).to_boolean)
											end
											l_flags := 0
											if a_restval.to_boolean then
												if l_rest_failed then
													l_flags := (l_flags).bit_or ((2))
												end
											end
											l_rd_size := (0).to_integer_64
											if l_expected_bytes.to_boolean then
												l_tmp___100 := l_expected_bytes - a_restval
											else
												l_tmp___100 := (0).to_integer_64
											end
											l_res___0 := retr_inst.fd_read_body (l_dtsock, l_fp, l_tmp___100, a_restval, create {CE_POINTER [INTEGER_64]}.make_shared ($l_rd_size), a_qtyread, create {CE_POINTER [REAL_64]}.make_shared (a_con.c_pointer + {PD_CCON}.dltime_offset), l_flags)
											l_tms.ce_gets (utils_inst.datetime_str ((time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))))
											l_tmrate.ce_gets (retr_inst.retr_rate (l_rd_size, a_con.item.dltime))
											retr_inst.total_download_time := retr_inst.total_download_time + (a_con.item.dltime)
											connect_inst.fd_close (l_local_sock)
											if (retr_inst.output_stream).c_pointer = default_pointer then
												fclose (l_fp).do_nothing
											elseif ((a_con.item.cmd).bit_and (8)).to_boolean then
												fclose (l_fp).do_nothing
											end
											if l_res___0 = -2 then
												l_tmp___103.ce_gets (strerror ((errno_location).item))
												log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("%%s: %%s, closing control connection.%N"))), a_con.item.target, l_tmp___103])
												connect_inst.fd_close (l_csock)
												a_con.item.csock := -1
												connect_inst.fd_close (l_dtsock)
												Result := ({PC_UERR_T}.FWRITEERR)
												js.return
											elseif l_res___0 = -1 then
												l_tmp___105.ce_gets (connect_inst.fd_errstr (l_dtsock))
												log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("%%s (%%s) - Data connection: %%s; "))), l_tms, l_tmrate, l_tmp___105])
												if options_inst.opt.server_response then
													log_inst.logputs ({PC_LOG_OPTIONS}.LOG_ALWAYS, ce_string ("%N"))
												end
											end
										end
										if not js.return_called then
											connect_inst.fd_close (l_dtsock)
											l_err := ftp_basic_inst.ftp_response (l_csock, l_respline.address)
											if l_err.to_natural_32 /= {NATURAL_32} 10 then
												if l_res___0 /= -1 then
													log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s (%%s) - "), l_tms, l_tmrate])
												end
												log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Control connection closed.%N"))))
												connect_inst.fd_close (l_csock)
												a_con.item.csock := -1
												Result := ({PC_UERR_T}.FTPRETRINT)
												js.return
											end
										end
										if not js.return_called and then ((l_respline[0]).to_integer_32 /= 50) then
											free (create {CE_POINTER [ANY]}.make_cast (l_respline))
											if l_res___0 /= -1 then
												log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s (%%s) - "), l_tms, l_tmrate])
											end
											log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Data transfer aborted.%N"))))
											Result := ({PC_UERR_T}.FTPRETRINT)
											js.return
										end
										if not js.return_called then
											free (create {CE_POINTER [ANY]}.make_cast (l_respline))
											if l_res___0 = -1 then
												Result := ({PC_UERR_T}.FTPRETRINT)
												js.return
											end
										end
										if not js.return_called then
											if not ((l_cmd).bit_and (16)).to_boolean then
												connect_inst.fd_close (l_csock)
												a_con.item.csock := -1
											end
											if options_inst.opt.server_response then
												if ((a_con.item.cmd).bit_and (8)).to_boolean then
													url_inst.mkalldirs (a_con.item.target).do_nothing
													l_fp.ce_gets (fopen (a_con.item.target, ce_string ("r")))
													if (l_fp).c_pointer = default_pointer then
														log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_ALWAYS, ce_string ("%%s: %%s%N"), a_con.item.target, (strerror ((errno_location).item))])
													else
														from
														until
															js.loop_left
														loop
															js.reset
															l_line.ce_gets (utils_inst.read_whole_line (l_fp))
															if (l_line.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
																js.break
															end
															if not js.loop_jumped then
																l_p___1.ce_gets ((strchr (l_line, ('%/0/').code)))
																from
																until
																	js.loop_left
																loop
																	js.reset
																	if (l_p___1.c_pointer.to_integer_32).to_natural_32 > (l_line.c_pointer.to_integer_32).to_natural_32 then
																		if (l_p___1[-1]).to_integer_32 /= 10 then
																			if (l_p___1[-1]).to_integer_32 /= 13 then
																				js.break
																			end
																		end
																	else
																		js.break
																	end
																	if not js.loop_jumped then
																		l_p___1.ce_gets (l_p___1 - 1)
																		l_p___1[0] := (('%/0/').code).to_integer_8
																	end
																end
																js.reset
																log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_ALWAYS, ce_string ("%%s%N"), (quotearg_inst.quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_line))])
																free (create {CE_POINTER [ANY]}.make_cast (l_line))
															end
														end
														js.reset
														fclose (l_fp).do_nothing
													end
												end
											end
											Result := ({PC_UERR_T}.RETRFINISHED)
										end
				when 124 then
										l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
							end

	ftp_loop_internal (a_u: CE_POINTER [PD_URL]; a_f: CE_POINTER [PD_FILEINFO]; a_con: CE_POINTER [PD_CCON]): INTEGER_32
		local
			l_count: INTEGER_32
			l_orig_lp: INTEGER_32
			l_restval: INTEGER_64
			l_len: INTEGER_64
			l_qtyread: INTEGER_64
			l_tms: CE_POINTER [INTEGER_8]
			l_locf: CE_POINTER [INTEGER_8]
			l_tmrate: CE_POINTER [INTEGER_8]
			l_err: INTEGER_32
			l_st: SD_STAT
			l_tmp: CE_POINTER [INTEGER_8]
			l_hurl: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_ARRAY [INTEGER_8]
			l_write_to_stdout: BOOLEAN
			l_tmp___9: INTEGER_32
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_hurl___0: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tms.make
			create l_locf.make
			create l_tmrate.make
			create l_st.make
			create l_tmp.make
			create l_hurl.make
			create l_tmp___5.make (<<256>>)
			create l_tmp___10.make
			create l_tmp___12.make
			create l_tmp___15.make
			create l_hurl___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := (0).to_integer_64
					l_qtyread := (0).to_integer_64
					l_tmrate.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					if (a_f.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if ((a_con.item.target).c_pointer /= default_pointer) then
							l_locf.ce_gets (a_con.item.target)
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						a_con.item.target := url_inst.url_file_name (a_u)
						if (options_inst.opt.output_document).c_pointer = default_pointer then
							l_locf.ce_gets (a_con.item.target)
						else
							l_locf.ce_gets (options_inst.opt.output_document)
						end
				when 4 then
					if options_inst.opt.noclobber then
						if (options_inst.opt.output_document).c_pointer = default_pointer then
							if (utils_inst.file_exists_p (a_con.item.target)) then
								l_tmp.ce_gets (quote_inst.quote (a_con.item.target))
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("File %%s already there; not retrieving.%N"))), l_tmp])
								Result := ({PC_UERR_T}.RETROK)
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 23 -- skip if block
					end
				when 5 then -- if:
						utils_inst.remove_link (a_con.item.target).do_nothing
						l_count := 0
						if ((a_con.item.st).bit_and (1)).to_boolean then
							a_con.item.st := 1
						end
						if ((a_con.item.cmd).bit_and (16)).to_boolean then
							l_orig_lp := 1
						else
							l_orig_lp := 0
						end
				when 6 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 22 -- skip loop
						end
				when 7 then -- loop body:
						js.reset
						l_count := l_count + 1
						retr_inst.sleep_between_retrievals (l_count)
						if ((a_con.item.st).bit_and (1)).to_boolean then
							a_con.item.cmd := 0
							a_con.item.cmd := (a_con.item.cmd).bit_or ((20))
							if a_con.item.csock /= -1 then
								a_con.item.cmd := (a_con.item.cmd).bit_and ((-4))
							else
								a_con.item.cmd := (a_con.item.cmd).bit_or ((3))
							end
						else
							if a_con.item.csock /= -1 then
								a_con.item.cmd := (a_con.item.cmd).bit_and ((-2))
							else
								a_con.item.cmd := (a_con.item.cmd).bit_or ((1))
							end
							if ((a_con.item.st).bit_and (2)).to_boolean then
								a_con.item.cmd := (a_con.item.cmd).bit_and ((-3))
							else
								a_con.item.cmd := (a_con.item.cmd).bit_or ((2))
							end
						end
						if not (((a_con.item.cmd).bit_and (8)).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_restval := (0).to_integer_64
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if not (options_inst.opt.always_rest) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if (stat (l_locf, (l_st.address))) = 0 then
							if ((l_st.st_mode).bit_and ({NATURAL_32} 61440)) = {NATURAL_32} 32768 then
								l_restval := (l_st.st_size).to_integer_64
							else
								l_pos := -1 + 13 -- goto _L___1
							end
						else
							l_pos := -1 + 13 -- goto _L___1
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L___1:
						if l_count > 1 then
							l_restval := l_qtyread
						else
							l_restval := (0).to_integer_64
						end
				when 14 then -- if done
						l_tms.ce_gets (utils_inst.datetime_str ((time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))))
						if (options_inst.opt.verbose).to_boolean then
							l_hurl.ce_gets ((url_inst.url_string (a_u, {PC_URL_AUTH_MODE}.URL_AUTH_HIDE_PASSWD)))
							strcpy (l_tmp___5, ce_string ("        ")).do_nothing
							if l_count > 1 then
								sprintf ([l_tmp___5, (gettext (ce_string ("(try:%%2d)"))), l_count]).do_nothing
							end
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("--%%s--  %%s%N  %%s => %%s%N"), l_tms, l_hurl, l_tmp___5, (quote_inst.quote (l_locf))])
							free (create {CE_POINTER [ANY]}.make_cast (l_hurl))
						end
						if ((a_f).c_pointer /= default_pointer) then
							l_len := a_f.item.size
						else
							l_len := (0).to_integer_64
						end
						l_err := getftp (a_u, l_len, create {CE_POINTER [INTEGER_64]}.make_shared ($l_qtyread), l_restval, a_con)
						if a_con.item.csock = -1 then
							a_con.item.st := (a_con.item.st).bit_and ((-3))
						else
							a_con.item.st := (a_con.item.st).bit_or ((2))
						end
						inspect l_err -- switch 1 head
						when 1 then l_pos := -1 + 15
						when 5 then l_pos := -1 + 15
						when 26 then l_pos := -1 + 15
						when 24 then l_pos := -1 + 15
						when 15 then l_pos := -1 + 15
						when 11 then l_pos := -1 + 15
						when 36 then l_pos := -1 + 15
						when 37 then l_pos := -1 + 15
						when 2 then l_pos := -1 + 16
						when 3 then l_pos := -1 + 16
						when 20 then l_pos := -1 + 16
						when 18 then l_pos := -1 + 16
						when 52 then l_pos := -1 + 16
						when 17 then l_pos := -1 + 16
						when 14 then l_pos := -1 + 16
						when 13 then l_pos := -1 + 16
						when 12 then l_pos := -1 + 16
						when 35 then l_pos := -1 + 16
						when 25 then l_pos := -1 + 16
						when 21 then l_pos := -1 + 17
						when 39 then l_pos := -1 + 18
						else l_pos := -1 + 19
						end
				when 15 then -- switch 1, case 1 | switch 1, case 5 | switch 1, case 26 | switch 1, case 24 | switch 1, case 15 | switch 1, case 11 | switch 1, case 36 | switch 1, case 37
						Result := l_err
						js.return
				when 16 then -- switch 1, case 2 | switch 1, case 3 | switch 1, case 20 | switch 1, case 18 | switch 1, case 52 | switch 1, case 17 | switch 1, case 14 | switch 1, case 13 | switch 1, case 12 | switch 1, case 35 | switch 1, case 25
						if not js.return_called then
							retr_inst.printwhat (l_count, options_inst.opt.ntry)
							if l_err.to_natural_32 = {NATURAL_32} 25 then
								if ((a_con.item.target).c_pointer /= default_pointer) then
									free (create {CE_POINTER [ANY]}.make_cast (a_con.item.target))
								end
								a_con.item.target := url_inst.url_file_name (a_u)
								l_locf.ce_gets (a_con.item.target)
							end
							js.continue
						end
				when 17 then -- switch 1, case 21
						if not js.loop_jumped then
							if (a_f).c_pointer = default_pointer then
								retr_inst.printwhat (l_count, options_inst.opt.ntry)
								js.continue
							elseif l_qtyread /= a_f.item.size then
								retr_inst.printwhat (l_count, options_inst.opt.ntry)
								js.continue
							end
						end
						l_pos := -1 + 20 -- switch 1; break
				when 18 then -- switch 1, case 39
						l_pos := -1 + 20 -- switch 1; break
				when 19 then -- switch 1, default:
						abort
				when 20 then -- switch 1, done:
						if not js.return_called then
							if not js.loop_jumped then
								l_tms.ce_gets (utils_inst.datetime_str ((time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))))
								if not options_inst.opt.spider then
									l_tmrate.ce_gets (retr_inst.retr_rate (l_qtyread - l_restval, a_con.item.dltime))
								end
								convert_inst.downloaded_file ({PC_DOWNLOADED_FILE_T}.FILE_DOWNLOADED_NORMALLY, l_locf).do_nothing
								if ((a_con.item.st).bit_and (1)).to_boolean then
									connect_inst.fd_close (a_con.item.csock)
									a_con.item.csock := -1
								end
								if not options_inst.opt.spider then
									if ((options_inst.opt.output_document).c_pointer /= default_pointer) then
										if ((options_inst.opt.output_document).item).to_integer_32 = 45 then
											if not (options_inst.opt.output_document[1]).to_boolean then
												l_tmp___9 := 1
											else
												l_tmp___9 := 0
											end
										else
											l_tmp___9 := 0
										end
									else
										l_tmp___9 := 0
									end
									l_write_to_stdout := l_tmp___9.to_boolean
									l_tmp___10.ce_gets (utils_inst.number_to_static_string (l_qtyread))
									if l_write_to_stdout then
										l_tmp___12.ce_gets (ce_string (""))
									else
										l_tmp___12.ce_gets ((quote_inst.quote (l_locf)))
									end
									if l_write_to_stdout then
										l_tmp___15.ce_gets ((gettext (ce_string ("%%s (%%s) - written to stdout %%s[%%s]%N%N"))))
									else
										l_tmp___15.ce_gets ((gettext (ce_string ("%%s (%%s) - %%s saved [%%s]%N%N"))))
									end
									log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___15, l_tms, l_tmrate, l_tmp___12, l_tmp___10])
								end
								if not (options_inst.opt.verbose).to_boolean then
									if not options_inst.opt.quiet then
										l_hurl___0.ce_gets ((url_inst.url_string (a_u, {PC_URL_AUTH_MODE}.URL_AUTH_HIDE_PASSWD)))
										log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NONVERBOSE, ce_string ("%%s URL: %%s [%%s] -> %"%%s%" [%%d]%N"), l_tms, l_hurl___0, (utils_inst.number_to_static_string (l_qtyread)), l_locf, l_count])
										free (create {CE_POINTER [ANY]}.make_cast (l_hurl___0))
									end
								end
								if ((a_con.item.cmd).bit_and (8)).to_boolean then
									if not options_inst.opt.remove_listing then
										retr_inst.total_downloaded_bytes := retr_inst.total_downloaded_bytes + l_qtyread
										main_inst.numurls := main_inst.numurls + 1
									end
								elseif not options_inst.opt.spider then
									retr_inst.total_downloaded_bytes := retr_inst.total_downloaded_bytes + l_qtyread
									main_inst.numurls := main_inst.numurls + 1
									if options_inst.opt.delete_after then
										from
										until
											js.loop_left
										loop
											js.reset
											if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
												log_inst.debug_logprintf ([ce_string ("Removing file due to --delete-after in ftp_loop_internal():%N")])
											end
											js.break
										end
										js.reset
										log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Removing %%s.%N"))), l_locf])
										if (unlink (l_locf)).to_boolean then
											log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("unlink: %%s%N"), (strerror ((errno_location).item))])
										end
									end
								end
								if l_orig_lp.to_boolean then
									a_con.item.cmd := (a_con.item.cmd).bit_or ((16))
								else
									a_con.item.cmd := (a_con.item.cmd).bit_and ((-17))
								end
								Result := ({PC_UERR_T}.RETROK)
								js.return
							end
							if not js.loop_left and then ((options_inst.opt.ntry).to_boolean) then
								if not (l_count < options_inst.opt.ntry) then
									l_pos := -1 + 22 -- break
								end
							end
						end
				when 21 then
						l_pos := -1 + 6 -- back to loop condition
				when 22 then -- loop done
						js.reset
				when 23 then -- if done
					if not js.return_called then
						if a_con.item.csock /= -1 then
							if ((a_con.item.st).bit_and (1)).to_boolean then
								connect_inst.fd_close (a_con.item.csock)
								a_con.item.csock := -1
							end
						end
						Result := ({PC_UERR_T}.TRYLIMEXC)
					end
				when 24 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_get_listing (a_u: CE_POINTER [PD_URL]; a_con: CE_POINTER [PD_CCON]; a_f: CE_POINTER [CE_POINTER [PD_FILEINFO]]): INTEGER_32
		local
			l_err: INTEGER_32
			l_uf: CE_POINTER [INTEGER_8]
			l_lf: CE_POINTER [INTEGER_8]
			l_old_target: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_uf.make
			create l_lf.make
			create l_old_target.make
			create l_tmp.make
			create l_tmp___4.make

			l_old_target.ce_gets (a_con.item.target)
			a_con.item.st := (a_con.item.st).bit_and ((-2))
			a_con.item.cmd := (a_con.item.cmd).bit_or ((24))
			a_con.item.cmd := (a_con.item.cmd).bit_and ((-5))
			l_uf.ce_gets (url_inst.url_file_name (a_u))
			l_lf.ce_gets (utils_inst.file_merge (l_uf, ce_string (".listing")))
			free (create {CE_POINTER [ANY]}.make_cast (l_uf))
			from
			until
				js.loop_left
			loop
				js.reset
				if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
					l_tmp.ce_gets (quote_inst.quote (l_lf))
					log_inst.debug_logprintf ([(gettext (ce_string ("Using %%s as listing tmp file.%N"))), l_tmp])
				end
				js.break
			end
			js.reset
			a_con.item.target := xmalloc_inst.xstrdup (l_lf)
			free (create {CE_POINTER [ANY]}.make_cast (l_lf))
			l_err := ftp_loop_internal (a_u, create {CE_POINTER [PD_FILEINFO]}.make_shared (default_pointer), a_con)
			l_lf.ce_gets (xmalloc_inst.xstrdup (a_con.item.target))
			free (create {CE_POINTER [ANY]}.make_cast (a_con.item.target))
			a_con.item.target := l_old_target
			if l_err.to_natural_32 = {NATURAL_32} 31 then
				a_f.item := ftp_ls_inst.ftp_parse_ls (l_lf, a_con.item.rs)
				if options_inst.opt.remove_listing then
					if (unlink (l_lf)).to_boolean then
						log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("unlink: %%s%N"), (strerror ((errno_location).item))])
					else
						l_tmp___4.ce_gets (quote_inst.quote (l_lf))
						log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Removed %%s.%N"))), l_tmp___4])
					end
				end
			else
				a_f.item := create {CE_POINTER [PD_FILEINFO]}.make_shared (default_pointer)
			end
			free (create {CE_POINTER [ANY]}.make_cast (l_lf))
			a_con.item.cmd := (a_con.item.cmd).bit_and ((-9))
			Result := l_err
		end

	ftp_retrieve_list (a_u: CE_POINTER [PD_URL]; a_f: CE_POINTER [PD_FILEINFO]; a_con: CE_POINTER [PD_CCON]): INTEGER_32
		local
			l_f: CE_POINTER [PD_FILEINFO]
			l_err: INTEGER_32
			l_orig: CE_POINTER [PD_FILEINFO]
			l_local_size: INTEGER_64
			l_tml: INTEGER_32
			l_dlthis: BOOLEAN
			l_actual_target: CE_POINTER [INTEGER_8]
			l_old_target: CE_POINTER [INTEGER_8]
			l_ofile: CE_POINTER [INTEGER_8]
			l_st: SD_STAT
			l_eq_size: BOOLEAN
			l_cor_val: BOOLEAN
			l_tmp___1: INTEGER_32
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_st___0: SD_STAT
			l_rc: INTEGER_32
			l_len: NATURAL_32
			l_link_target: CE_POINTER [INTEGER_8]
			l_n: NATURAL_32
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_tmp___18: CE_POINTER [INTEGER_8]
			l_tmp___19: CE_POINTER [INTEGER_8]
			l_tmp___24: CE_POINTER [INTEGER_8]
			l_tmp___26: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_f.make
			create l_orig.make
			create l_actual_target.make
			create l_old_target.make
			create l_ofile.make
			create l_st.make
			create l_tmp___2.make
			create l_tmp___4.make
			create l_tmp___6.make
			create l_st___0.make
			create l_link_target.make
			create l_tmp___14.make
			create l_tmp___15.make
			create l_tmp___18.make
			create l_tmp___19.make
			create l_tmp___24.make
			create l_tmp___26.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_f.ce_gets (a_f)
					l_actual_target.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					depth := depth + 1
					if options_inst.opt.reclevel /= -1 then
						if depth > options_inst.opt.reclevel then
							from
							until
								js.loop_left
							loop
								js.reset
								if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([(gettext (ce_string ("Recursion depth %%d exceeded max. depth %%d.%N"))), depth, options_inst.opt.reclevel])
								end
								js.break
							end
							js.reset
							depth := depth - 1
							Result := ({PC_UERR_T}.RECLEVELEXC)
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 35 -- skip if block
					end
				when 1 then -- if:
						if (l_f.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							assert_fail (ce_string ("f != ((void *)0)"), ce_string ("ftp.c"), {NATURAL_32} 1670, ce_string ("ftp_retrieve_list"))
						end
						l_orig.ce_gets (l_f)
						a_con.item.st := (a_con.item.st).bit_and ((-2))
						if not ((a_con.item.st).bit_and (2)).to_boolean then
							a_con.item.cmd := (a_con.item.cmd).bit_or ((2))
						else
							a_con.item.cmd := (a_con.item.cmd).bit_and ((-3))
						end
						a_con.item.cmd := (a_con.item.cmd).bit_or ((20))
						if a_con.item.csock < 0 then
							a_con.item.cmd := (a_con.item.cmd).bit_or ((1))
						else
							a_con.item.cmd := (a_con.item.cmd).bit_and ((-2))
						end
						l_err := {PC_UERR_T}.RETROK
				when 2 then -- loop condition:
						if not (not js.loop_left and then ((l_f).c_pointer /= default_pointer)) then
							l_pos := -1 + 34 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if (options_inst.opt.quota).to_boolean then
							if retr_inst.total_downloaded_bytes > options_inst.opt.quota then
								depth := depth - 1
								Result := ({PC_UERR_T}.QUOTEXC)
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 33 -- skip if block
						end
				when 4 then -- if:
						l_old_target.ce_gets (a_con.item.target)
						l_ofile.ce_gets (xmalloc_inst.xstrdup (a_u.item.file))
						url_inst.url_set_file (a_u, l_f.item.name)
						a_con.item.target := url_inst.url_file_name (a_u)
						l_err := {PC_UERR_T}.RETROK
						l_dlthis := (1).to_boolean
						if not (options_inst.opt.timestamping) then
							l_pos := -1 + 11 -- skip if block
						end
				when 5 then -- if:
						if (l_f.item.type).to_natural_32 /= {NATURAL_32} 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if:
						if (stat (a_con.item.target, (l_st.address))).to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 7 then -- if:
						l_local_size := (l_st.st_size).to_integer_64
						l_tml := l_st.st_mtim.tv_sec
						if (a_con.item.rs).to_natural_32 = {NATURAL_32} 0 then
							l_tmp___1 := 1
						elseif (a_con.item.rs).to_natural_32 = {NATURAL_32} 2 then
							l_tmp___1 := 1
						else
							l_tmp___1 := 0
						end
						l_cor_val := l_tmp___1.to_boolean
						if l_cor_val then
							l_eq_size := (l_local_size = l_f.item.size)
						else
							l_eq_size := (1).to_boolean
						end
						if not (l_f.item.tstamp <= l_tml) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_eq_size then
							l_tmp___2.ce_gets (quote_inst.quote (a_con.item.target))
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Remote file no newer than local file %%s -- not retrieving.%N"))), l_tmp___2])
							l_dlthis := (0).to_boolean
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						if l_eq_size then
							l_tmp___4.ce_gets (quote_inst.quote (a_con.item.target))
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Remote file is newer than local file %%s -- retrieving.%N%N"))), l_tmp___4])
						else
							l_tmp___6.ce_gets (utils_inst.number_to_static_string (l_local_size))
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("The sizes do not match (local %%s) -- retrieving.%N%N"))), l_tmp___6])
						end
				when 11 then -- if done | if done | if done
						inspect l_f.item.type -- switch 1 head
						when 2 then l_pos := -1 + 12
						when 1 then l_pos := -1 + 21
						when 0 then l_pos := -1 + 22
						when 3 then l_pos := -1 + 23
						else l_pos := -1 + 24
						end
				when 12 then -- switch 1, case 2
						if options_inst.opt.retr_symlinks then
							l_pos := -1 + 19 -- skip if block
						end
				when 13 then -- if:
						if ((l_f.item.linkto).c_pointer /= default_pointer) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Invalid name of the symlink, skipping.%N"))))
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						l_rc := (lstat (a_con.item.target, (l_st___0.address)))
						if l_rc = 0 then
							l_len := (strlen (l_f.item.linkto)) + {NATURAL_32} 1
							if ((l_st___0.st_mode).bit_and ({NATURAL_32} 61440)) = {NATURAL_32} 40960 then
								l_link_target.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new (l_len))))
								l_n := (readlink (a_con.item.target, l_link_target, l_len)).to_natural_32
								if l_n = l_len - {NATURAL_32} 1 then
									if (memcmp (create {CE_POINTER [ANY]}.make_cast (l_link_target), create {CE_POINTER [ANY]}.make_cast (l_f.item.linkto), l_n)) = 0 then
										l_tmp___14.ce_gets (quote_inst.quote (l_f.item.linkto))
										l_tmp___15.ce_gets (quote_inst.quote (a_con.item.target))
										log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Already have correct symlink %%s -> %%s%N%N"))), l_tmp___15, l_tmp___14])
										l_dlthis := (0).to_boolean
										l_pos := -1 + 24 -- switch 1; break
									end
								end
							end
						end
				when 17 then
						l_tmp___18.ce_gets (quote_inst.quote (l_f.item.linkto))
						l_tmp___19.ce_gets (quote_inst.quote (a_con.item.target))
						log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Creating symlink %%s -> %%s%N"))), l_tmp___19, l_tmp___18])
						unlink (a_con.item.target).do_nothing
						if (symlink (l_f.item.linkto, a_con.item.target)) = -1 then
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("symlink: %%s%N"), (strerror ((errno_location).item))])
						end
						log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:
						if l_dlthis then
							l_err := ftp_loop_internal (a_u, l_f, a_con)
						end
				when 20 then -- if done
						l_pos := -1 + 24 -- switch 1; break
				when 21 then -- switch 1, case 1
						if not options_inst.opt.recursive then
							l_tmp___24.ce_gets (quote_inst.quote (l_f.item.name))
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Skipping directory %%s.%N"))), l_tmp___24])
						end
						l_pos := -1 + 24 -- switch 1; break
				when 22 then -- switch 1, case 0
						if l_dlthis then
							l_err := ftp_loop_internal (a_u, l_f, a_con)
						end
						l_pos := -1 + 24 -- switch 1; break
				when 23 then -- switch 1, case 3
						l_tmp___26.ce_gets (quote_inst.quote (l_f.item.name))
						log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("%%s: unknown/unsupported file type.%N"))), l_tmp___26])
						l_pos := -1 + 24 -- switch 1; break
				when 24 then -- switch 1, done:
						retr_inst.set_local_file (l_actual_target.address, a_con.item.target)
						if l_dlthis then
							if (l_actual_target.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if (l_f.item.type).to_natural_32 = {NATURAL_32} 0 then
									if (l_f.item.perms).to_boolean then
										chmod (l_actual_target, (l_f.item.perms).to_natural_32).do_nothing
									else
										from
										until
											js.loop_left
										loop
											js.reset
											if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
												log_inst.debug_logprintf ([ce_string ("Unrecognized permissions for %%s.%N"), l_actual_target])
											end
											js.break
										end
										js.reset
									end
								end
							end
						end
						if (l_actual_target.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 32 -- skip if block
						end
				when 25 then -- if:
						if (l_f.item.type).to_natural_32 /= {NATURAL_32} 2 then
							l_pos := -1 + 31 -- skip if block
						end
				when 26 then -- if:
						if options_inst.opt.retr_symlinks then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if: | _L___2:
						if l_f.item.tstamp = -1 then
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("%%s: corrupt time-stamp.%N"))), l_actual_target])
						end
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else:
						l_pos := -1 + 31 -- goto _L___3
				when 30 then -- if done | if block done, skip else block:
						l_pos := -1 + 32
				when 31 then -- else: | _L___3:
						if l_f.item.tstamp /= -1 then
							if l_dlthis then
								if (utils_inst.file_exists_p (a_con.item.target)) then
									utils_inst.touch (l_actual_target, l_f.item.tstamp)
								else
									l_pos := -1 + 27 -- goto _L___2
								end
							else
								l_pos := -1 + 27 -- goto _L___2
							end
						else
							l_pos := -1 + 27 -- goto _L___2
						end
				when 32 then -- if done
						free (create {CE_POINTER [ANY]}.make_cast (a_con.item.target))
						a_con.item.target := l_old_target
						url_inst.url_set_file (a_u, l_ofile)
						free (create {CE_POINTER [ANY]}.make_cast (l_ofile))
						if l_err.to_natural_32 = {NATURAL_32} 51 then
							js.break
						elseif l_err.to_natural_32 = {NATURAL_32} 1 then
							js.break
						elseif l_err.to_natural_32 = {NATURAL_32} 26 then
							js.break
						end
						if not js.loop_jumped then
							a_con.item.cmd := (a_con.item.cmd).bit_and ((-4))
							l_f.ce_gets (l_f.item.next)
						end
				when 33 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 34 then -- loop done
						js.reset
				when 35 then -- if done
					if js.return_called then
						l_pos := -1 + 41 -- skip if block
					end
				when 36 then -- if:
						if not (options_inst.opt.recursive) then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						if options_inst.opt.reclevel /= -1 then
							if depth >= options_inst.opt.reclevel then
								l_pos := -1 + 39 -- goto _L___4
							else
								l_err := ftp_retrieve_dirs (a_u, l_orig, a_con)
							end
						else
							l_err := ftp_retrieve_dirs (a_u, l_orig, a_con)
						end
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 39 then -- else: | _L___4:
						if options_inst.opt.recursive then
							from
							until
								js.loop_left
							loop
								js.reset
								if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([(gettext (ce_string ("Will not retrieve dirs since depth is %%d (max %%d).%N"))), depth, options_inst.opt.reclevel])
								end
								js.break
							end
							js.reset
						end
				when 40 then
						depth := depth - 1
						Result := l_err
				when 41 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_retrieve_dirs (a_u: CE_POINTER [PD_URL]; a_f: CE_POINTER [PD_FILEINFO]; a_con: CE_POINTER [PD_CCON]): INTEGER_32
		local
			l_f: CE_POINTER [PD_FILEINFO]
			l_container: CE_POINTER [INTEGER_8]
			l_container_size: INTEGER_32
			l_size: INTEGER_32
			l_odir: CE_POINTER [INTEGER_8]
			l_newdir: CE_POINTER [INTEGER_8]
			l_tmp: NATURAL_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_f.make
			create l_container.make
			create l_odir.make
			create l_newdir.make
			create l_tmp___4.make

			l_f.ce_gets (a_f)
			l_container.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
			l_container_size := 0
			from
			until
				not (not js.loop_left and then ((l_f).c_pointer /= default_pointer))
			loop
				js.reset
				if (options_inst.opt.quota).to_boolean then
					if retr_inst.total_downloaded_bytes > options_inst.opt.quota then
						js.break
					end
				end
				if not js.loop_jumped and then ((l_f.item.type).to_natural_32 /= {NATURAL_32} 1) then
					js.continue
				end
				if not js.loop_jumped then
					l_tmp := strlen (a_u.item.dir)
					l_size := (((l_tmp + {NATURAL_32} 1) + (strlen (l_f.item.name))) + {NATURAL_32} 1).to_integer_32
					if l_size > l_container_size then
						l_container.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new (l_size.to_natural_32))))
					end
					l_newdir.ce_gets (l_container)
					l_odir.ce_gets (a_u.item.dir)
					if (l_odir[0]).to_integer_32 = 0 then
						sprintf ([l_newdir, ce_string ("%%s%%s"), l_odir, l_f.item.name]).do_nothing
					elseif (l_odir[0]).to_integer_32 = 47 then
						if (l_odir[1]).to_integer_32 = 0 then
							sprintf ([l_newdir, ce_string ("%%s%%s"), l_odir, l_f.item.name]).do_nothing
						else
							sprintf ([l_newdir, ce_string ("%%s/%%s"), l_odir, l_f.item.name]).do_nothing
						end
					else
						sprintf ([l_newdir, ce_string ("%%s/%%s"), l_odir, l_f.item.name]).do_nothing
					end
					from
					until
						js.loop_left
					loop
						js.reset
						if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
							log_inst.debug_logprintf ([ce_string ("Composing new CWD relative to the initial directory.%N")])
						end
						js.break
					end
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
							log_inst.debug_logprintf ([ce_string ("  odir = %'%%s%'%N  f->name = %'%%s%'%N  newdir = %'%%s%'%N%N"), l_odir, l_f.item.name, l_newdir])
						end
						js.break
					end
					js.reset
					if not (utils_inst.accdir (l_newdir)) then
						l_tmp___4.ce_gets (quote_inst.quote (l_newdir))
						log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Not descending to %%s as it is excluded/not-included.%N"))), l_tmp___4])
						js.continue
					end
				end
				if not js.loop_jumped then
					a_con.item.st := (a_con.item.st).bit_and ((-3))
					l_odir.ce_gets (xmalloc_inst.xstrdup (a_u.item.dir))
					url_inst.url_set_dir (a_u, l_newdir)
					ftp_retrieve_glob (a_u, a_con, 1).do_nothing
					url_inst.url_set_dir (a_u, l_odir)
					free (create {CE_POINTER [ANY]}.make_cast (l_odir))
				end
				if not js.loop_left then
					l_f.ce_gets (l_f.item.next)
				end
			end
			js.reset
			if (options_inst.opt.quota).to_boolean then
				if retr_inst.total_downloaded_bytes > options_inst.opt.quota then
					Result := ({PC_UERR_T}.QUOTEXC)
				else
					Result := ({PC_UERR_T}.RETROK)
				end
			else
				Result := ({PC_UERR_T}.RETROK)
			end
		end

	has_insecure_name_p (a_s: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			js: JUMP_STATE
		do
			if (a_s[0]).to_integer_32 = 47 then
				Result := (1).to_boolean
				js.return
			end
			if not js.return_called then
				if ((strstr (a_s, ce_string ("../"))).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					Result := (1).to_boolean
					js.return
				end
			end
			if not js.return_called then
				Result := (0).to_boolean
			end
		end

	ftp_retrieve_glob (a_u: CE_POINTER [PD_URL]; a_con: CE_POINTER [PD_CCON]; a_action: INTEGER_32): INTEGER_32
		local
			l_f: CE_POINTER [PD_FILEINFO]
			l_start: CE_POINTER [PD_FILEINFO]
			l_res___0: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_matcher: CE_ROUTINE
			l_tmp___5: CE_ROUTINE
			l_matchres: INTEGER_32
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_cmp: CE_ROUTINE
			l_tmp___10: CE_ROUTINE
			l_tmp___12: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_f.make
			create l_start.make
			create l_tmp.make
			create l_tmp___2.make
			create l_matcher.make
			create l_tmp___5.make
			create l_tmp___7.make
			create l_tmp___8.make
			create l_cmp.make
			create l_tmp___10.make
			create l_tmp___12.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					a_con.item.cmd := (a_con.item.cmd).bit_or ((16))
					l_res___0 := ftp_get_listing (a_u, a_con, l_start.address)
					if l_res___0.to_natural_32 /= {NATURAL_32} 31 then
						Result := l_res___0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if (options_inst.opt.accepts).c_pointer = default_pointer then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (options_inst.opt.rejects).c_pointer = default_pointer then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						l_f.ce_gets (l_start)
						from
						until
							(l_f).c_pointer = default_pointer
						loop
							if (l_f.item.type).to_natural_32 /= {NATURAL_32} 1 then
								if (utils_inst.acceptable (l_f.item.name)) then
									l_f.ce_gets (l_f.item.next)
								else
									l_tmp.ce_gets (quote_inst.quote (l_f.item.name))
									log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Rejecting %%s.%N"))), l_tmp])
									l_f.ce_gets (delelement (l_f, l_start.address))
								end
							else
								l_f.ce_gets (l_f.item.next)
							end
						end
				when 6 then -- if done
						l_f.ce_gets (l_start)
						from
						until
							(l_f).c_pointer = default_pointer
						loop
							if (has_insecure_name_p (l_f.item.name)) then
								l_tmp___2.ce_gets (quote_inst.quote (l_f.item.name))
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Rejecting %%s.%N"))), l_tmp___2])
								l_f.ce_gets (delelement (l_f, l_start.address))
							else
								l_f.ce_gets (l_f.item.next)
							end
						end
						if ((a_u.item.file).item).to_boolean then
							if a_action = 0 then
								if options_inst.opt.ignore_case then
									l_tmp___5.ce_gets (utils_inst.fnmatch_nocase_address)
								else
									l_tmp___5.ce_gets (fnmatch_address)
								end
								l_matcher.ce_gets (l_tmp___5)
								l_matchres := 0
								l_f.ce_gets (l_start)
								from
								until
									not (not js.loop_left and then ((l_f).c_pointer /= default_pointer))
								loop
									js.reset
									l_matchres := l_matcher.integer_32_item ([a_u.item.file, l_f.item.name, 0])
									if l_matchres = -1 then
										l_tmp___7.ce_gets (strerror ((errno_location).item))
										l_tmp___8.ce_gets (quotearg_inst.quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_f.item.name))
										log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Error matching %%s against %%s: %%s%N"))), a_u.item.file, l_tmp___8, l_tmp___7])
										js.break
									end
									if not js.loop_jumped then
										if l_matchres = 1 then
											l_f.ce_gets (delelement (l_f, l_start.address))
										else
											l_f.ce_gets (l_f.item.next)
										end
									end
								end
								js.reset
								if l_matchres = -1 then
									freefileinfo (l_start)
									Result := ({PC_UERR_T}.RETRBADPATTERN)
									js.return
								end
							elseif a_action = 2 then
								if options_inst.opt.ignore_case then
									l_tmp___10.ce_gets (strcasecmp_address)
								else
									l_tmp___10.ce_gets (strcmp_address)
								end
								l_cmp.ce_gets (l_tmp___10)
								l_f.ce_gets (l_start)
								from
								until
									(l_f).c_pointer = default_pointer
								loop
									if 0 /= (l_cmp.integer_32_item ([a_u.item.file, l_f.item.name])) then
										l_f.ce_gets (delelement (l_f, l_start.address))
									else
										l_f.ce_gets (l_f.item.next)
									end
								end
							end
						end
				when 7 then -- if done
					if not js.return_called then
						if ((l_start).c_pointer /= default_pointer) then
							ftp_retrieve_list (a_u, l_start, a_con).do_nothing
						elseif a_action = 0 then
							l_tmp___12.ce_gets (quote_inst.quote (a_u.item.file))
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("No matches on pattern %%s.%N"))), l_tmp___12])
						elseif a_action = 2 then
							a_con.item.st := (a_con.item.st).bit_or ((1))
							l_res___0 := ftp_loop_internal (a_u, create {CE_POINTER [PD_FILEINFO]}.make_shared (default_pointer), a_con)
							Result := l_res___0
							js.return
						end
					end
					if not js.return_called then
						freefileinfo (l_start)
						if (options_inst.opt.quota).to_boolean then
							if retr_inst.total_downloaded_bytes > options_inst.opt.quota then
								Result := ({PC_UERR_T}.QUOTEXC)
							else
								Result := ({PC_UERR_T}.RETROK)
							end
						else
							Result := ({PC_UERR_T}.RETROK)
						end
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_loop (a_u: CE_POINTER [PD_URL]; a_dt: CE_POINTER [INTEGER_32]; a_proxy: CE_POINTER [PD_URL]; a_recursive: BOOLEAN; a_glob: BOOLEAN): INTEGER_32
		local
			l_con: PD_CCON
			l_res___0: INTEGER_32
			l_f: CE_POINTER [PD_FILEINFO]
			l_filename: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_st: SD_STAT
			l_sz: INTEGER_64
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_ispattern: BOOLEAN
			l_file_part: CE_POINTER [INTEGER_8]
			l_tmp___11: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_con.make
			create l_f.make
			create l_filename.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_st.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___8.make
			create l_file_part.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					a_dt.item := 0
					memset (create {CE_POINTER [ANY]}.make_cast ((l_con.address)), ('%/0/').code, {PD_CCON}.sizeof.to_natural_32).do_nothing
					l_con.csock := -1
					l_con.st := 1
					l_con.rs := {PC_STYPE}.ST_UNIX
					l_con.id := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_con.proxy := a_proxy
					if ((a_u.item.file).item).to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if not a_recursive then
							l_res___0 := ftp_get_listing (a_u, l_con.address, l_f.address)
							if l_res___0.to_natural_32 = {NATURAL_32} 31 then
								if options_inst.opt.htmlify then
									if not options_inst.opt.spider then
										if ((options_inst.opt.output_document).c_pointer /= default_pointer) then
											l_tmp___3.ce_gets ((xmalloc_inst.xstrdup (options_inst.opt.output_document)))
										else
											if ((l_con.target).c_pointer /= default_pointer) then
												l_tmp___2.ce_gets ((xmalloc_inst.xstrdup (l_con.target)))
											else
												l_tmp___2.ce_gets ((url_inst.url_file_name (a_u)))
											end
											l_tmp___3.ce_gets (l_tmp___2)
										end
										l_filename.ce_gets (l_tmp___3)
										l_res___0 := ftp_ls_inst.ftp_index (l_filename, a_u, l_f)
										if l_res___0.to_natural_32 = {NATURAL_32} 10 then
											if (options_inst.opt.verbose).to_boolean then
												if (options_inst.opt.output_document).c_pointer = default_pointer then
													if (stat (l_filename, (l_st.address))) = 0 then
														l_sz := (l_st.st_size).to_integer_64
													else
														l_sz := (-1).to_integer_64
													end
													l_tmp___5.ce_gets (utils_inst.number_to_static_string (l_sz))
													l_tmp___6.ce_gets (quote_inst.quote (l_filename))
													log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Wrote HTML-ized index to %%s [%%s].%N"))), l_tmp___6, l_tmp___5])
												else
													l_tmp___8.ce_gets (quote_inst.quote (l_filename))
													log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Wrote HTML-ized index to %%s.%N"))), l_tmp___8])
												end
											end
										end
										free (create {CE_POINTER [ANY]}.make_cast (l_filename))
									end
								end
								freefileinfo (l_f)
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else: | _L___0:
						l_ispattern := (0).to_boolean
						if a_glob then
							l_file_part.ce_gets ((strrchr (a_u.item.path, ('/').code)))
							if (l_file_part).c_pointer = default_pointer then
								l_file_part.ce_gets (a_u.item.path)
							end
							l_ispattern := utils_inst.has_wildcards_p (l_file_part)
						end
						if not l_ispattern then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if not a_recursive then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if not (options_inst.opt.timestamping) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L:
						if l_ispattern then
							l_tmp___11 := 0
						else
							l_tmp___11 := 2
						end
						l_res___0 := ftp_retrieve_glob (a_u, l_con.address, l_tmp___11)
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						l_res___0 := ftp_loop_internal (a_u, create {CE_POINTER [PD_FILEINFO]}.make_shared (default_pointer), l_con.address)
				when 13 then -- if done | if done | if done
						if l_res___0.to_natural_32 = {NATURAL_32} 10 then
							l_res___0 := {PC_UERR_T}.RETROK
						end
						if l_res___0.to_natural_32 = {NATURAL_32} 31 then
							a_dt.item := (a_dt.item).bit_or ((2))
						end
						if l_con.csock /= -1 then
							connect_inst.fd_close (l_con.csock)
						end
						if ((l_con.id).c_pointer /= default_pointer) then
							free (create {CE_POINTER [ANY]}.make_cast (l_con.id))
						end
						l_con.id := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						if ((l_con.target).c_pointer /= default_pointer) then
							free (create {CE_POINTER [ANY]}.make_cast (l_con.target))
						end
						l_con.target := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						Result := l_res___0
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	delelement (a_f: CE_POINTER [PD_FILEINFO]; a_start: CE_POINTER [CE_POINTER [PD_FILEINFO]]): CE_POINTER [PD_FILEINFO]
		local
			l_prev: CE_POINTER [PD_FILEINFO]
			l_next: CE_POINTER [PD_FILEINFO]
		do
			create l_prev.make
			create l_next.make

			l_prev.ce_gets (a_f.item.prev)
			l_next.ce_gets (a_f.item.next)
			free (create {CE_POINTER [ANY]}.make_cast (a_f.item.name))
			if ((a_f.item.linkto).c_pointer /= default_pointer) then
				free (create {CE_POINTER [ANY]}.make_cast (a_f.item.linkto))
			end
			free (create {CE_POINTER [ANY]}.make_cast (a_f))
			if ((l_next).c_pointer /= default_pointer) then
				l_next.item.prev := l_prev
			end
			if ((l_prev).c_pointer /= default_pointer) then
				l_prev.item.next := l_next
			else
				a_start.item := l_next
			end
			Result := l_next
		end

	freefileinfo (a_f: CE_POINTER [PD_FILEINFO])
		local
			l_f: CE_POINTER [PD_FILEINFO]
			l_next: CE_POINTER [PD_FILEINFO]
		do
			create l_f.make
			create l_next.make

			l_f.ce_gets (a_f)
			from
			until
				(l_f).c_pointer = default_pointer
			loop
				l_next.ce_gets (l_f.item.next)
				free (create {CE_POINTER [ANY]}.make_cast (l_f.item.name))
				if ((l_f.item.linkto).c_pointer /= default_pointer) then
					free (create {CE_POINTER [ANY]}.make_cast (l_f.item.linkto))
				end
				free (create {CE_POINTER [ANY]}.make_cast (l_f))
				l_f.ce_gets (l_next)
			end
		end

end
