class
	P_GEN_MD5

inherit
	WGET_DATA
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {ANY} -- routines

	gen_md5_context_size: INTEGER_32
		do
			Result := ({PD_GEN_MD5_CONTEXT}.sizeof.to_natural_32).to_integer_32
		end

	gen_md5_init (a_ctx: CE_POINTER [PD_GEN_MD5_CONTEXT])
		local
			l_ctx_imp: CE_POINTER [PD_MD5_CTX]
		do
			create l_ctx_imp.make

			l_ctx_imp.ce_gets (create {CE_POINTER [PD_MD5_CTX]}.make_shared (a_ctx.c_pointer + {PD_GEN_MD5_CONTEXT}.imp_offset))
			md5_inst.md5_init_ctx (l_ctx_imp)
		end

	gen_md5_update (a_buffer___0: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_ctx: CE_POINTER [PD_GEN_MD5_CONTEXT])
		local
			l_ctx_imp: CE_POINTER [PD_MD5_CTX]
		do
			create l_ctx_imp.make

			l_ctx_imp.ce_gets (create {CE_POINTER [PD_MD5_CTX]}.make_shared (a_ctx.c_pointer + {PD_GEN_MD5_CONTEXT}.imp_offset))
			md5_inst.md5_process_bytes (create {CE_POINTER [ANY]}.make_cast (a_buffer___0), a_len.to_natural_32, l_ctx_imp)
		end

	gen_md5_finish (a_ctx: CE_POINTER [PD_GEN_MD5_CONTEXT]; a_result: CE_POINTER [NATURAL_8])
		local
			l_ctx_imp: CE_POINTER [PD_MD5_CTX]
		do
			create l_ctx_imp.make

			l_ctx_imp.ce_gets (create {CE_POINTER [PD_MD5_CTX]}.make_shared (a_ctx.c_pointer + {PD_GEN_MD5_CONTEXT}.imp_offset))
			md5_inst.md5_finish_ctx (l_ctx_imp, create {CE_POINTER [ANY]}.make_cast (a_result)).do_nothing
		end

end
