class
	P_GETPASS

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create buf___5.make
		end

feature {ANY} -- attributes

	buf___5: CE_POINTER [INTEGER_8]

	bufsize: NATURAL_32 assign set_bufsize
		do
			Result := bufsize_address[0]
		end

	set_bufsize (a_bufsize: NATURAL_32)
		do
			bufsize_address[0] := a_bufsize
		end

	bufsize_address: CE_POINTER [NATURAL_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Natural_32_bytes))
		end

feature {ANY} -- routines

	call_fclose (a_arg: CE_POINTER [ANY])
		do
			if (a_arg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				fclose (create {CE_POINTER [SD_IO_FILE]}.make_cast (a_arg)).do_nothing
			end
		end

	gnu_getpass (a_prompt: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_tty: CE_POINTER [SD_IO_FILE]
			l_in: CE_POINTER [SD_IO_FILE]
			l_out: CE_POINTER [SD_IO_FILE]
			l_s: SD_TERMIOS
			l_t: SD_TERMIOS
			l_tty_changed: BOOLEAN
			l_nread: INTEGER_32
		do
			create l_tty.make
			create l_in.make
			create l_out.make
			create l_s.make
			create l_t.make

			l_tty_changed := (0).to_boolean
			l_tty.ce_gets (fopen (ce_string ("/dev/tty"), ce_string ("w+")))
			if (l_tty.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_in.ce_gets ((create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.input.file_pointer)))
				l_out.ce_gets ((create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)))
			else
				fsetlocking (l_tty, 2).do_nothing
				l_in.ce_gets (l_tty)
				l_out.ce_gets (l_in)
			end
			flockfile (l_out)
			if (tcgetattr ((fileno (l_in)), l_t.address)) = 0 then
				l_s.ce_gets (l_t)
				l_t.c2_lflag := (l_t.c2_lflag).bit_and (({NATURAL_32} 4294967286))
				l_tty_changed := ((tcsetattr ((fileno (l_in)), 2, (l_t.address))) = 0)
			end
			fputs_unlocked (a_prompt, l_out).do_nothing
			fflush_unlocked (l_out).do_nothing
			l_nread := getline ((buf___5.address), (bufsize_address), l_in)
			fseeko (l_out, (0).to_integer_32, 1).do_nothing
			if (buf___5.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if l_nread < 0 then
					buf___5[0] := (('%/0/').code).to_integer_8
				elseif (buf___5[(l_nread - 1)]).to_integer_32 = 10 then
					buf___5[(l_nread - 1)] := (('%/0/').code).to_integer_8
					if l_tty_changed then
						putc_unlocked (('%N').code, l_out).do_nothing
					end
				end
			end
			if l_tty_changed then
				tcsetattr ((fileno (l_in)), 2, (l_s.address)).do_nothing
			end
			funlockfile (l_out)
			call_fclose (create {CE_POINTER [ANY]}.make_cast (l_tty))
			Result := buf___5
		end

end
