class
	P_HTML_URL

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create known_tags.make (<<22>>)
			create tag_url_attributes.make (<<21>>)
			create additional_attributes.make (<<6>>)
			create interesting_tags.make
			create interesting_attributes.make
			create meta_charset.make
		end

feature {ANY} -- attributes

	known_tags: CE_ARRAY [PD_KNOWN_TAG]

	tag_url_attributes: CE_ARRAY [PD_TAG_URL_ATTRIBUTES]

	additional_attributes: CE_ARRAY [CE_POINTER [INTEGER_8]]

	interesting_tags: CE_POINTER [PD_HASH_TABLE]

	interesting_attributes: CE_POINTER [PD_HASH_TABLE]

	meta_charset: CE_POINTER [INTEGER_8]

feature {ANY} -- routines

	init_interesting
		local
			l_i: NATURAL_32
			l_ignored: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_intersect: CE_POINTER [PD_HASH_TABLE]
			l_followed: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_t: CE_POINTER [PD_KNOWN_TAG]
			js: JUMP_STATE
		do
			create l_ignored.make
			create l_intersect.make
			create l_followed.make
			create l_t.make

			interesting_tags.ce_gets (hash_inst.make_nocase_string_hash_table ((({PD_KNOWN_TAG}.sizeof.to_natural_32 * (22).to_natural_32) // {PD_KNOWN_TAG}.sizeof.to_natural_32).to_integer_32))
			l_i := (0).to_natural_32
			from
			until
				not (l_i < ({PD_KNOWN_TAG}.sizeof.to_natural_32 * (22).to_natural_32) // {PD_KNOWN_TAG}.sizeof.to_natural_32)
			loop
				hash_inst.hash_table_put (interesting_tags, create {CE_POINTER [ANY]}.make_cast (known_tags[l_i.to_integer_32].name), create {CE_POINTER [ANY]}.make_cast ((known_tags + l_i.to_integer_32)))
				l_i := l_i + 1
			end
			if ((options_inst.opt.ignore_tags).c_pointer /= default_pointer) then
				l_ignored.ce_gets (options_inst.opt.ignore_tags)
				from
				until
					(l_ignored.item).c_pointer = default_pointer
				loop
					hash_inst.hash_table_remove (interesting_tags, create {CE_POINTER [ANY]}.make_cast (l_ignored.item)).do_nothing
					l_ignored.ce_gets (l_ignored + 1)
				end
			end
			if ((options_inst.opt.follow_tags).c_pointer /= default_pointer) then
				l_intersect.ce_gets ((hash_inst.make_nocase_string_hash_table (0)))
				l_followed.ce_gets (options_inst.opt.follow_tags)
				from
				until
					(l_followed.item).c_pointer = default_pointer
				loop
					js.reset
					l_t.ce_gets (create {CE_POINTER [PD_KNOWN_TAG]}.make_cast ((hash_inst.hash_table_get (interesting_tags, create {CE_POINTER [ANY]}.make_cast (l_followed.item)))))
					if (l_t).c_pointer = default_pointer then
						js.continue
					end
					if not js.loop_jumped then
						hash_inst.hash_table_put (l_intersect, create {CE_POINTER [ANY]}.make_cast (l_followed.item), create {CE_POINTER [ANY]}.make_cast (l_t))
					end
					l_followed.ce_gets (l_followed + 1)
				end
				hash_inst.hash_table_destroy (interesting_tags)
				interesting_tags.ce_gets (l_intersect)
			end
			interesting_attributes.ce_gets (hash_inst.make_nocase_string_hash_table (10))
			l_i := (0).to_natural_32
			from
			until
				not (l_i < (Pointer_bytes.to_natural_32 * (6).to_natural_32) // Pointer_bytes.to_natural_32)
			loop
				hash_inst.hash_table_put (interesting_attributes, create {CE_POINTER [ANY]}.make_cast (additional_attributes[l_i.to_integer_32]), create {CE_POINTER [ANY]}.make_cast (ce_string ("1")))
				l_i := l_i + 1
			end
			l_i := (0).to_natural_32
			from
			until
				not (l_i < ({PD_TAG_URL_ATTRIBUTES}.sizeof.to_natural_32 * (21).to_natural_32) // {PD_TAG_URL_ATTRIBUTES}.sizeof.to_natural_32)
			loop
				hash_inst.hash_table_put (interesting_attributes, create {CE_POINTER [ANY]}.make_cast (tag_url_attributes[l_i.to_integer_32].attr_name), create {CE_POINTER [ANY]}.make_cast (ce_string ("1")))
				l_i := l_i + 1
			end
		end

	find_attr (a_tag: CE_POINTER [PD_TAGINFO]; a_name: CE_POINTER [INTEGER_8]; a_attrind: CE_POINTER [INTEGER_32]): CE_POINTER [INTEGER_8]
		local
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			l_i := 0
			from
			until
				not (not js.loop_left and then (l_i < a_tag.item.nattrs))
			loop
				if not (strcasecmp ((a_tag.item.attrs + l_i).item.name, a_name)).to_boolean then
					if ((a_attrind).c_pointer /= default_pointer) then
						a_attrind.item := l_i
					end
					Result := ((a_tag.item.attrs + l_i).item.value)
					js.return
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
			end
		end

	append_url (a_link_uri: CE_POINTER [INTEGER_8]; a_position: INTEGER_32; a_size: INTEGER_32; a_ctx: CE_POINTER [PD_MAP_CONTEXT]): CE_POINTER [PD_URLPOS]
		local
			l_link_has_scheme: INTEGER_32
			l_newel: CE_POINTER [PD_URLPOS]
			l_base: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_url: CE_POINTER [PD_URL]
			l_complete_uri: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___14: CE_POINTER [PD_URLPOS]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_newel.make
			create l_base.make
			create l_tmp___0.make
			create l_url.make
			create l_complete_uri.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___7.make
			create l_tmp___14.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_link_has_scheme := (url_inst.url_has_scheme (a_link_uri)).to_integer
					if ((a_ctx.item.base).c_pointer /= default_pointer) then
						l_tmp___0.ce_gets (a_ctx.item.base)
					else
						l_tmp___0.ce_gets (a_ctx.item.parent_base)
					end
					l_base.ce_gets (l_tmp___0)
					if (l_base).c_pointer = default_pointer then
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("%%s: no base, merge will use %"%%s%".%N"), a_ctx.item.document_file, a_link_uri])
							end
							js.break
						end
						js.reset
						if not l_link_has_scheme.to_boolean then
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("%%s: Cannot resolve incomplete link %%s.%N"))), a_ctx.item.document_file, a_link_uri])
							Result := (create {CE_POINTER [PD_URLPOS]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called then
							l_url.ce_gets (url_inst.url_parse (a_link_uri, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [PD_IRI]}.make_shared (default_pointer), (0).to_boolean))
							if (l_url).c_pointer = default_pointer then
								from
								until
									js.loop_left
								loop
									js.reset
									if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
										log_inst.debug_logprintf ([ce_string ("%%s: link %"%%s%" doesn%'t parse.%N"), a_ctx.item.document_file, a_link_uri])
									end
									js.break
								end
								js.reset
								Result := (create {CE_POINTER [PD_URLPOS]}.make_shared (default_pointer))
								js.return
							end
						end
					else
						l_complete_uri.ce_gets ((url_inst.uri_merge (l_base, a_link_uri)))
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
								l_tmp___5.ce_gets (quotearg_inst.quotearg_n_style (3, {PC_QUOTING_STYLE}.escape_quoting_style, l_complete_uri))
								l_tmp___6.ce_gets (quote_inst.quote_n (2, a_link_uri))
								l_tmp___7.ce_gets (quote_inst.quote_n (1, l_base))
								log_inst.debug_logprintf ([ce_string ("%%s: merge(%%s, %%s) -> %%s%N"), (quotearg_inst.quotearg_n_style (0, {PC_QUOTING_STYLE}.escape_quoting_style, a_ctx.item.document_file)), l_tmp___7, l_tmp___6, l_tmp___5])
							end
							js.break
						end
						js.reset
						l_url.ce_gets (url_inst.url_parse (l_complete_uri, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [PD_IRI]}.make_shared (default_pointer), (0).to_boolean))
						if (l_url).c_pointer = default_pointer then
							from
							until
								js.loop_left
							loop
								js.reset
								if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string ("%%s: merged link %"%%s%" doesn%'t parse.%N"), a_ctx.item.document_file, l_complete_uri])
								end
								js.break
							end
							js.reset
							free (create {CE_POINTER [ANY]}.make_cast (l_complete_uri))
							Result := (create {CE_POINTER [PD_URLPOS]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called then
							free (create {CE_POINTER [ANY]}.make_cast (l_complete_uri))
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("appending %%s to urlpos.%N"), (quote_inst.quote (l_url.item.url))])
							end
							js.break
						end
						js.reset
						l_newel.ce_gets (create {CE_POINTER [PD_URLPOS]}.make_cast ((xmalloc_inst.xcalloc ((1).to_natural_32, {PD_URLPOS}.sizeof.to_natural_32))))
						l_newel.item.url := l_url
						l_newel.item.pos := a_position
						l_newel.item.size := a_size
						if l_link_has_scheme.to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (a_link_uri[0]).to_integer_32 /= 47 then
							l_newel.item.link_relative_p := {NATURAL_32} 1
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_link_has_scheme.to_boolean then
							l_newel.item.link_complete_p := {NATURAL_32} 1
						end
				when 5 then
						if ((a_ctx.item.tail).c_pointer /= default_pointer) then
							(a_ctx.item.tail).item.next := l_newel
							a_ctx.item.tail := l_newel
						else
							l_tmp___14.ce_gets (l_newel)
							a_ctx.item.head := l_tmp___14
							a_ctx.item.tail := l_tmp___14
						end
						Result := l_newel
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_style_attr (a_tag: CE_POINTER [PD_TAGINFO]; a_ctx: CE_POINTER [PD_MAP_CONTEXT])
		local
			l_attrind: INTEGER_32
			l_style: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_style.make

			l_style.ce_gets ((find_attr (a_tag, ce_string ("style"), create {CE_POINTER [INTEGER_32]}.make_shared ($l_attrind))))
			if (l_style).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				css_url_inst.get_urls_css (a_ctx, (((a_tag.item.attrs + l_attrind).item.value_raw_beginning).distance ((a_ctx.item.text))) + 1, (a_tag.item.attrs + l_attrind).item.value_raw_size - 2)
			end
		end

	tag_find_urls (a_tagid: INTEGER_32; a_tag: CE_POINTER [PD_TAGINFO]; a_ctx: CE_POINTER [PD_MAP_CONTEXT])
		local
			l_i: NATURAL_32
			l_attrind: INTEGER_32
			l_first: INTEGER_32
			l_link: CE_POINTER [INTEGER_8]
			l_size: NATURAL_32
			l_up: CE_POINTER [PD_URLPOS]
			l_flags: INTEGER_32
			js: JUMP_STATE
		do
			create l_link.make
			create l_up.make

			l_first := -1
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_left and then (l_i < ({PD_TAG_URL_ATTRIBUTES}.sizeof.to_natural_32 * (21).to_natural_32) // {PD_TAG_URL_ATTRIBUTES}.sizeof.to_natural_32))
			loop
				js.reset
				if tag_url_attributes[l_i.to_integer_32].tagid = a_tagid then
					l_first := l_i.to_integer_32
					js.break
				end
				if not js.loop_jumped then
					l_i := l_i + 1
				end
			end
			js.reset
			if l_first = -1 then
				assert_fail (ce_string ("first != -1"), ce_string ("html-url.c"), {NATURAL_32} 382, ce_string ("tag_find_urls"))
			end
			l_attrind := 0
			from
			until
				not (not js.loop_left and then (l_attrind < a_tag.item.nattrs))
			loop
				l_link.ce_gets ((a_tag.item.attrs + l_attrind).item.value)
				l_size := ({PD_TAG_URL_ATTRIBUTES}.sizeof.to_natural_32 * (21).to_natural_32) // {PD_TAG_URL_ATTRIBUTES}.sizeof.to_natural_32
				l_i := l_first.to_natural_32
				from
				until
					js.loop_left
				loop
					js.reset
					if l_i < l_size then
						if tag_url_attributes[l_i.to_integer_32].tagid /= a_tagid then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						if 0 = (strcasecmp ((a_tag.item.attrs + l_attrind).item.name, tag_url_attributes[l_i.to_integer_32].attr_name)) then
							l_up.ce_gets ((append_url (l_link, ((a_tag.item.attrs + l_attrind).item.value_raw_beginning).distance ((a_ctx.item.text)), (a_tag.item.attrs + l_attrind).item.value_raw_size, a_ctx)))
							if ((l_up).c_pointer /= default_pointer) then
								l_flags := tag_url_attributes[l_i.to_integer_32].flags
								if ((l_flags).bit_and (1)).to_boolean then
									l_up.item.link_inline_p := {NATURAL_32} 1
								end
								if ((l_flags).bit_and (2)).to_boolean then
									l_up.item.link_expect_html := {NATURAL_32} 1
								end
							end
						end
						l_i := l_i + 1
					end
				end
				js.reset
				l_attrind := l_attrind + 1
			end
		end

	tag_find_urls_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent tag_find_urls)
		end

	tag_handle_base (a_tagid: INTEGER_32; a_tag: CE_POINTER [PD_TAGINFO]; a_ctx: CE_POINTER [PD_MAP_CONTEXT])
		local
			l_base_urlpos: CE_POINTER [PD_URLPOS]
			l_attrind: INTEGER_32
			l_newbase: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_base_urlpos.make
			create l_newbase.make

			l_newbase.ce_gets ((find_attr (a_tag, ce_string ("href"), create {CE_POINTER [INTEGER_32]}.make_shared ($l_attrind))))
			if (l_newbase).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				l_base_urlpos.ce_gets (append_url (l_newbase, ((a_tag.item.attrs + l_attrind).item.value_raw_beginning).distance ((a_ctx.item.text)), (a_tag.item.attrs + l_attrind).item.value_raw_size, a_ctx))
				if (l_base_urlpos).c_pointer = default_pointer then
					js.return
				end
			end
			if not js.return_called then
				l_base_urlpos.item.ignore_when_downloading := {NATURAL_32} 1
				l_base_urlpos.item.link_base_p := {NATURAL_32} 1
				if ((a_ctx.item.base).c_pointer /= default_pointer) then
					free (create {CE_POINTER [ANY]}.make_cast (a_ctx.item.base))
				end
				if ((a_ctx.item.parent_base).c_pointer /= default_pointer) then
					a_ctx.item.base := url_inst.uri_merge (a_ctx.item.parent_base, l_newbase)
				else
					a_ctx.item.base := xmalloc_inst.xstrdup (l_newbase)
				end
			end
		end

	tag_handle_base_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent tag_handle_base)
		end

	tag_handle_form (a_tagid: INTEGER_32; a_tag: CE_POINTER [PD_TAGINFO]; a_ctx: CE_POINTER [PD_MAP_CONTEXT])
		local
			l_attrind: INTEGER_32
			l_action: CE_POINTER [INTEGER_8]
			l_up: CE_POINTER [PD_URLPOS]
		do
			create l_action.make
			create l_up.make

			l_action.ce_gets ((find_attr (a_tag, ce_string ("action"), create {CE_POINTER [INTEGER_32]}.make_shared ($l_attrind))))
			if ((l_action).c_pointer /= default_pointer) then
				l_up.ce_gets ((append_url (l_action, ((a_tag.item.attrs + l_attrind).item.value_raw_beginning).distance ((a_ctx.item.text)), (a_tag.item.attrs + l_attrind).item.value_raw_size, a_ctx)))
				if ((l_up).c_pointer /= default_pointer) then
					l_up.item.ignore_when_downloading := {NATURAL_32} 1
				end
			end
		end

	tag_handle_form_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent tag_handle_form)
		end

	tag_handle_link (a_tagid: INTEGER_32; a_tag: CE_POINTER [PD_TAGINFO]; a_ctx: CE_POINTER [PD_MAP_CONTEXT])
		local
			l_attrind: INTEGER_32
			l_href: CE_POINTER [INTEGER_8]
			l_up: CE_POINTER [PD_URLPOS]
			l_rel: CE_POINTER [INTEGER_8]
		do
			create l_href.make
			create l_up.make
			create l_rel.make

			l_href.ce_gets ((find_attr (a_tag, ce_string ("href"), create {CE_POINTER [INTEGER_32]}.make_shared ($l_attrind))))
			if ((l_href).c_pointer /= default_pointer) then
				l_up.ce_gets ((append_url (l_href, ((a_tag.item.attrs + l_attrind).item.value_raw_beginning).distance ((a_ctx.item.text)), (a_tag.item.attrs + l_attrind).item.value_raw_size, a_ctx)))
				if ((l_up).c_pointer /= default_pointer) then
					l_rel.ce_gets ((find_attr (a_tag, ce_string ("rel"), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))))
					if ((l_rel).c_pointer /= default_pointer) then
						if 0 = (strcasecmp (l_rel, ce_string ("stylesheet"))) then
							l_up.item.link_inline_p := {NATURAL_32} 1
							l_up.item.link_expect_css := {NATURAL_32} 1
						elseif 0 = (strcasecmp (l_rel, ce_string ("shortcut icon"))) then
							l_up.item.link_inline_p := {NATURAL_32} 1
						end
					else
						l_up.item.link_expect_html := {NATURAL_32} 1
					end
				end
			end
		end

	tag_handle_link_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent tag_handle_link)
		end

	tag_handle_meta (a_tagid: INTEGER_32; a_tag: CE_POINTER [PD_TAGINFO]; a_ctx: CE_POINTER [PD_MAP_CONTEXT])
		local
			l_name: CE_POINTER [INTEGER_8]
			l_http_equiv: CE_POINTER [INTEGER_8]
			l_entry: CE_POINTER [PD_URLPOS]
			l_attrind: INTEGER_32
			l_timeout: INTEGER_32
			l_p___0: CE_POINTER [INTEGER_8]
			l_refresh: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_mcharset: CE_POINTER [INTEGER_8]
			l_content: CE_POINTER [INTEGER_8]
			l_content___0: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_name.make
			create l_http_equiv.make
			create l_entry.make
			create l_p___0.make
			create l_refresh.make
			create l_tmp___3.make
			create l_mcharset.make
			create l_content.make
			create l_content___0.make
			create l_end.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_name.ce_gets ((find_attr (a_tag, ce_string ("name"), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))))
					l_http_equiv.ce_gets ((find_attr (a_tag, ce_string ("http-equiv"), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))))
					if (l_http_equiv).c_pointer = default_pointer then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if 0 = (strcasecmp (l_http_equiv, ce_string ("refresh"))) then
							l_timeout := 0
							l_refresh.ce_gets ((find_attr (a_tag, ce_string ("content"), create {CE_POINTER [INTEGER_32]}.make_shared ($l_attrind))))
							if (l_refresh).c_pointer = default_pointer then
								js.return
							end
							if not js.return_called then
								l_p___0.ce_gets (l_refresh)
								from
								until
									js.loop_left
								loop
									js.reset
									if not (c_ctype_inst.c2_isdigit ((l_p___0[0]).to_integer_32)) then
										js.break
									end
									if not js.loop_jumped then
										l_timeout := (10 * l_timeout + (l_p___0[0]).to_integer_32) - 48
										l_p___0.ce_gets (l_p___0 + 1)
									end
								end
								js.reset
								l_tmp___3.ce_gets (l_p___0)
								l_p___0.ce_gets (l_p___0 + 1)
								if (l_tmp___3[0]).to_integer_32 /= 59 then
									js.return
								end
							end
							if not js.return_called then
								from
								until
									js.loop_left
								loop
									js.reset
									if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
										js.break
									end
									if not js.loop_jumped then
										l_p___0.ce_gets (l_p___0 + 1)
									end
								end
								js.reset
								if (c_ctype_inst.c2_toupper ((l_p___0[0]).to_integer_32)) = 85 then
									if (c_ctype_inst.c2_toupper ((l_p___0[1]).to_integer_32)) = 82 then
										if (c_ctype_inst.c2_toupper ((l_p___0[2]).to_integer_32)) = 76 then
											if (l_p___0[3]).to_integer_32 /= 61 then
												js.return
											end
										else
											js.return
										end
									else
										js.return
									end
								else
									js.return
								end
							end
							if not js.return_called then
								l_p___0.ce_gets (l_p___0 + (4))
								from
								until
									js.loop_left
								loop
									js.reset
									if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
										js.break
									end
									if not js.loop_jumped then
										l_p___0.ce_gets (l_p___0 + 1)
									end
								end
								js.reset
								l_entry.ce_gets (append_url (l_p___0, ((a_tag.item.attrs + l_attrind).item.value_raw_beginning).distance ((a_ctx.item.text)), (a_tag.item.attrs + l_attrind).item.value_raw_size, a_ctx))
								if ((l_entry).c_pointer /= default_pointer) then
									l_entry.item.link_refresh_p := {NATURAL_32} 1
									l_entry.item.refresh_timeout := l_timeout
									l_entry.item.link_expect_html := {NATURAL_32} 1
								end
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else: | _L___0:
						if (l_http_equiv).c_pointer = default_pointer then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if 0 = (strcasecmp (l_http_equiv, ce_string ("content-type"))) then
							l_content.ce_gets ((find_attr (a_tag, ce_string ("content"), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))))
							if (l_content).c_pointer = default_pointer then
								js.return
							end
							if not js.return_called then
								l_mcharset.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								if (l_mcharset).c_pointer = default_pointer then
									js.return
								end
							end
							if not js.return_called then
								if ((meta_charset).c_pointer /= default_pointer) then
									free (create {CE_POINTER [ANY]}.make_cast (meta_charset))
								end
								meta_charset.ce_gets (l_mcharset)
							end
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if ((l_name).c_pointer /= default_pointer) then
							if 0 = (strcasecmp (l_name, ce_string ("robots"))) then
								l_content___0.ce_gets ((find_attr (a_tag, ce_string ("content"), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))))
								if (l_content___0).c_pointer = default_pointer then
									js.return
								end
								if not js.return_called then
									if (strcasecmp (l_content___0, ce_string ("none"))).to_boolean then
										from
										until
											not ((l_content___0[0]).to_boolean)
										loop
											l_content___0.ce_gets (l_content___0 + (strspn (l_content___0, ce_string (" %F%N%R%T%/11/"))).to_integer_32)
											l_end.ce_gets (l_content___0 + (strcspn (l_content___0, ce_string (", %F%N%R%T%/11/"))).to_integer_32)
											if not (strncasecmp (l_content___0, ce_string ("nofollow"), (l_end.distance (l_content___0)).to_natural_32)).to_boolean then
												a_ctx.item.nofollow := (1).to_boolean
											end
											if (l_end[0]).to_integer_32 = 44 then
												l_end.ce_gets (l_end + 1)
											else
												l_end.ce_gets (strchr (l_end, (',').code))
												if ((l_end).c_pointer /= default_pointer) then
													l_end.ce_gets (l_end + 1)
												else
													l_end.ce_gets (l_content___0 + (strlen (l_content___0)).to_integer_32)
												end
											end
											l_content___0.ce_gets (l_end)
										end
									else
										a_ctx.item.nofollow := (1).to_boolean
									end
								end
							end
						end
				when 7 then -- if done
						if not js.return_called then
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	tag_handle_meta_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent tag_handle_meta)
		end

	collect_tags_mapper (a_tag: CE_POINTER [PD_TAGINFO]; a_arg: CE_POINTER [ANY])
		local
			l_ctx: CE_POINTER [PD_MAP_CONTEXT]
			l_t: CE_POINTER [PD_KNOWN_TAG]
		do
			create l_ctx.make
			create l_t.make

			l_ctx.ce_gets (create {CE_POINTER [PD_MAP_CONTEXT]}.make_cast (a_arg))
			l_t.ce_gets (create {CE_POINTER [PD_KNOWN_TAG]}.make_cast ((hash_inst.hash_table_get (interesting_tags, create {CE_POINTER [ANY]}.make_cast (a_tag.item.name)))))
			if (l_t.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				(l_t.item.handler).call ([l_t.item.tagid, a_tag, l_ctx])
			end
			check_style_attr (a_tag, l_ctx)
			if (a_tag.item.end_tag_p).to_boolean then
				if 0 = (strcasecmp (a_tag.item.name, ce_string ("style"))) then
					if ((a_tag.item.contents_begin).c_pointer /= default_pointer) then
						if ((a_tag.item.contents_end).c_pointer /= default_pointer) then
							css_url_inst.get_urls_css (l_ctx, (a_tag.item.contents_begin).distance ((l_ctx.item.text)), (a_tag.item.contents_end).distance ((a_tag.item.contents_begin)))
						end
					end
				end
			end
		end

	collect_tags_mapper_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent collect_tags_mapper)
		end

	get_urls_html (a_file: CE_POINTER [INTEGER_8]; a_url: CE_POINTER [INTEGER_8]; a_meta_disallow_follow: CE_POINTER [BOOLEAN]; a_iri: CE_POINTER [PD_IRI]): CE_POINTER [PD_URLPOS]
		local
			l_fm: CE_POINTER [PD_FILE_MEMORY]
			l_ctx: PD_MAP_CONTEXT
			l_flags: INTEGER_32
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
		do
			create l_fm.make
			create l_ctx.make

			l_fm.ce_gets (utils_inst.read_file (a_file))
			if (l_fm).c_pointer = default_pointer then
				log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s%N"), a_file, (strerror ((errno_location).item))])
				Result := (create {CE_POINTER [PD_URLPOS]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
						log_inst.debug_logprintf ([ce_string ("Loaded %%s (size %%s).%N"), a_file, (utils_inst.number_to_static_string ((l_fm.item.length).to_integer_64))])
					end
					js.break
				end
				js.reset
				l_ctx.text := l_fm.item.content
				l_ctx.tail := create {CE_POINTER [PD_URLPOS]}.make_shared (default_pointer)
				l_ctx.head := l_ctx.tail
				l_ctx.base := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				if ((a_url).c_pointer /= default_pointer) then
					l_ctx.parent_base := a_url
				else
					l_ctx.parent_base := options_inst.opt.base_href
				end
				l_ctx.document_file := a_file
				l_ctx.nofollow := (0).to_boolean
				if (interesting_tags).c_pointer = default_pointer then
					init_interesting
				end
				l_flags := 2
				if options_inst.opt.strict_comments then
					l_flags := (l_flags).bit_or ((1))
				end
				html_parse_inst.map_html_tags (l_fm.item.content, (l_fm.item.length).to_integer_32, collect_tags_mapper_address, create {CE_POINTER [ANY]}.make_cast ((l_ctx.address)), l_flags, create {CE_POINTER [PD_HASH_TABLE]}.make_shared (default_pointer), interesting_attributes)
				if ((a_iri).c_pointer /= default_pointer) then
					if ((meta_charset).c_pointer /= default_pointer) then
						l_tmp___3 := 1
					else
						l_tmp___3 := 0
					end
				else
					l_tmp___3 := 0
				end
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
						log_inst.debug_logprintf ([ce_string ("no-follow in %%s: %%d%N"), a_file, (l_ctx.nofollow).to_integer])
					end
					js.break
				end
				js.reset
				if ((a_meta_disallow_follow).c_pointer /= default_pointer) then
					a_meta_disallow_follow.item := l_ctx.nofollow
				end
				if ((l_ctx.base).c_pointer /= default_pointer) then
					free (create {CE_POINTER [ANY]}.make_cast (l_ctx.base))
				end
				utils_inst.read_file_free (l_fm)
				Result := (l_ctx.head)
			end
		end

	get_urls_file (a_file: CE_POINTER [INTEGER_8]): CE_POINTER [PD_URLPOS]
		local
			l_fm: CE_POINTER [PD_FILE_MEMORY]
			l_head: CE_POINTER [PD_URLPOS]
			l_tail: CE_POINTER [PD_URLPOS]
			l_text: CE_POINTER [INTEGER_8]
			l_text_end: CE_POINTER [INTEGER_8]
			l_up_error_code: INTEGER_32
			l_url_text: CE_POINTER [INTEGER_8]
			l_entry: CE_POINTER [PD_URLPOS]
			l_url: CE_POINTER [PD_URL]
			l_line_beg: CE_POINTER [INTEGER_8]
			l_line_end: CE_POINTER [INTEGER_8]
			l_merged: CE_POINTER [INTEGER_8]
			l_error___0: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_fm.make
			create l_head.make
			create l_tail.make
			create l_text.make
			create l_text_end.make
			create l_url_text.make
			create l_entry.make
			create l_url.make
			create l_line_beg.make
			create l_line_end.make
			create l_merged.make
			create l_error___0.make

			l_fm.ce_gets (utils_inst.read_file (a_file))
			if (l_fm).c_pointer = default_pointer then
				log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s%N"), a_file, (strerror ((errno_location).item))])
				Result := (create {CE_POINTER [PD_URLPOS]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
						log_inst.debug_logprintf ([ce_string ("Loaded %%s (size %%s).%N"), a_file, (utils_inst.number_to_static_string ((l_fm.item.length).to_integer_64))])
					end
					js.break
				end
				js.reset
				l_tail.ce_gets (create {CE_POINTER [PD_URLPOS]}.make_shared (default_pointer))
				l_head.ce_gets (l_tail)
				l_text.ce_gets (l_fm.item.content)
				l_text_end.ce_gets ((l_fm.item.content + l_fm.item.length))
				from
				until
					not (not js.loop_left and then ((l_text.c_pointer.to_integer_32).to_natural_32 < (l_text_end.c_pointer.to_integer_32).to_natural_32))
				loop
					js.reset
					l_line_beg.ce_gets (l_text)
					l_line_end.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((memchr (create {CE_POINTER [ANY]}.make_cast (l_text), ('%N').code, (l_text_end.distance (l_text)).to_natural_32))))
					if (l_line_end).c_pointer = default_pointer then
						l_line_end.ce_gets (l_text_end)
					else
						l_line_end.ce_gets (l_line_end + 1)
					end
					l_text.ce_gets (l_line_end)
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_line_beg.c_pointer.to_integer_32).to_natural_32 < (l_line_end.c_pointer.to_integer_32).to_natural_32 then
							if not (c_ctype_inst.c2_isspace ((l_line_beg[0]).to_integer_32)) then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_line_beg.ce_gets (l_line_beg + 1)
						end
					end
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_line_end.c_pointer.to_integer_32).to_natural_32 > (l_line_beg.c_pointer.to_integer_32).to_natural_32 then
							if not (c_ctype_inst.c2_isspace ((l_line_end[-1]).to_integer_32)) then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_line_end.ce_gets (l_line_end - 1)
						end
					end
					js.reset
					if (l_line_beg.c_pointer.to_integer_32).to_natural_32 = (l_line_end.c_pointer.to_integer_32).to_natural_32 then
						js.continue
					end
					if not js.loop_jumped then
						l_url_text.ce_gets (utils_inst.strdupdelim (l_line_beg, l_line_end))
						if ((options_inst.opt.base_href).c_pointer /= default_pointer) then
							l_merged.ce_gets ((url_inst.uri_merge (options_inst.opt.base_href, l_url_text)))
							free (create {CE_POINTER [ANY]}.make_cast (l_url_text))
							l_url_text.ce_gets (l_merged)
						end
						l_url.ce_gets (url_inst.url_parse (l_url_text, create {CE_POINTER [INTEGER_32]}.make_shared ($l_up_error_code), create {CE_POINTER [PD_IRI]}.make_shared (default_pointer), (0).to_boolean))
						if (l_url).c_pointer = default_pointer then
							l_error___0.ce_gets ((url_inst.url_error (l_url_text, l_up_error_code)))
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("%%s: Invalid URL %%s: %%s%N"))), a_file, l_url_text, l_error___0])
							free (create {CE_POINTER [ANY]}.make_cast (l_url_text))
							free (create {CE_POINTER [ANY]}.make_cast (l_error___0))
							js.continue
						end
					end
					if not js.loop_jumped then
						free (create {CE_POINTER [ANY]}.make_cast (l_url_text))
						l_entry.ce_gets (create {CE_POINTER [PD_URLPOS]}.make_cast ((xmalloc_inst.xcalloc ((1).to_natural_32, {PD_URLPOS}.sizeof.to_natural_32))))
						l_entry.item.url := l_url
						if (l_head).c_pointer = default_pointer then
							l_head.ce_gets (l_entry)
						else
							l_tail.item.next := l_entry
						end
						l_tail.ce_gets (l_entry)
					end
				end
				utils_inst.read_file_free (l_fm)
				Result := l_head
			end
		end

	cleanup_html_url
		do
			if ((interesting_tags).c_pointer /= default_pointer) then
				hash_inst.hash_table_destroy (interesting_tags)
			end
			if ((interesting_attributes).c_pointer /= default_pointer) then
				hash_inst.hash_table_destroy (interesting_attributes)
			end
		end

end
