class
	P_LOG

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create logfp.make
			create log_lines.make (<<24>>)
			create ring.make (<<3>>)
			create redirect_request_signal_name.make
		end

feature {ANY} -- attributes

	logfp: CE_POINTER [SD_IO_FILE]

	inhibit_logging: BOOLEAN assign set_inhibit_logging

	set_inhibit_logging (a_inhibit_logging: BOOLEAN)
		do
			inhibit_logging := a_inhibit_logging
		end

	save_context_p: BOOLEAN assign set_save_context_p

	set_save_context_p (a_save_context_p: BOOLEAN)
		do
			save_context_p := a_save_context_p
		end

	flush_log_p: BOOLEAN assign set_flush_log_p

	set_flush_log_p (a_flush_log_p: BOOLEAN)
		do
			flush_log_p := a_flush_log_p
		end

	needs_flushing: BOOLEAN assign set_needs_flushing

	set_needs_flushing (a_needs_flushing: BOOLEAN)
		do
			needs_flushing := a_needs_flushing
		end

	log_lines: CE_ARRAY [PD_LOG_LN]

	log_line_current: INTEGER_32 assign set_log_line_current

	set_log_line_current (a_log_line_current: INTEGER_32)
		do
			log_line_current := a_log_line_current
		end

	trailing_line: BOOLEAN assign set_trailing_line

	set_trailing_line (a_trailing_line: BOOLEAN)
		do
			trailing_line := a_trailing_line
		end

	ring: CE_ARRAY [PD_RINGEL]

	ringpos: INTEGER_32 assign set_ringpos

	set_ringpos (a_ringpos: INTEGER_32)
		do
			ringpos := a_ringpos
		end

	redirect_request: INTEGER_32 assign set_redirect_request

	set_redirect_request (a_redirect_request: INTEGER_32)
		do
			redirect_request := a_redirect_request
		end

	redirect_request_signal_name: CE_POINTER [INTEGER_8]

feature {ANY} -- routines

	free_log_line (a_num: INTEGER_32)
		local
			l_ln: CE_POINTER [PD_LOG_LN]
		do
			create l_ln.make

			l_ln.ce_gets (log_lines + a_num)
			if ((l_ln.item.malloced_line).c_pointer /= default_pointer) then
				free (create {CE_POINTER [ANY]}.make_cast (l_ln.item.malloced_line))
				l_ln.item.malloced_line := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			end
			l_ln.item.content := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
		end

	saved_append_1 (a_start: CE_POINTER [INTEGER_8]; a_end: CE_POINTER [INTEGER_8])
		local
			l_len: INTEGER_32
			l_ln: CE_POINTER [PD_LOG_LN]
			l_ln___0: CE_POINTER [PD_LOG_LN]
			l_old_len: INTEGER_32
			l_old_len___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_ln.make
			create l_ln___0.make

			l_len := a_end.distance (a_start)
			if not l_len.to_boolean then
				js.return
			end
			if not js.return_called then
				if not trailing_line then
					if log_line_current = -1 then
						log_line_current := 0
					else
						free_log_line (log_line_current)
					end
					l_ln.ce_gets (log_lines + log_line_current)
					if l_len > 128 then
						l_ln.item.malloced_line := utils_inst.strdupdelim (a_start, a_end)
						l_ln.item.content := l_ln.item.malloced_line
					else
						memcpy (create {CE_POINTER [ANY]}.make_cast ((l_ln.item.static_line)), create {CE_POINTER [ANY]}.make_cast (a_start), l_len.to_natural_32).do_nothing
						l_ln.item.static_line[l_len] := (('%/0/').code).to_integer_8
						l_ln.item.content := l_ln.item.static_line
					end
				else
					l_ln___0.ce_gets (log_lines + log_line_current)
					if ((l_ln___0.item.malloced_line).c_pointer /= default_pointer) then
						l_old_len := (strlen (l_ln___0.item.malloced_line)).to_integer_32
						l_ln___0.item.malloced_line := create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (l_ln___0.item.malloced_line), ((l_old_len + l_len) + 1).to_natural_32)))
						memcpy (create {CE_POINTER [ANY]}.make_cast ((l_ln___0.item.malloced_line + l_old_len)), create {CE_POINTER [ANY]}.make_cast (a_start), l_len.to_natural_32).do_nothing
						l_ln___0.item.malloced_line[(l_old_len + l_len)] := (('%/0/').code).to_integer_8
						l_ln___0.item.content := l_ln___0.item.malloced_line
					else
						l_old_len___0 := (strlen ((l_ln___0.item.static_line))).to_integer_32
						if l_old_len___0 + l_len > 128 then
							l_ln___0.item.malloced_line := create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc (((l_old_len___0 + l_len) + 1).to_natural_32)))
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_ln___0.item.malloced_line), create {CE_POINTER [ANY]}.make_cast ((l_ln___0.item.static_line)), l_old_len___0.to_natural_32).do_nothing
							memcpy (create {CE_POINTER [ANY]}.make_cast ((l_ln___0.item.malloced_line + l_old_len___0)), create {CE_POINTER [ANY]}.make_cast (a_start), l_len.to_natural_32).do_nothing
							l_ln___0.item.malloced_line[(l_old_len___0 + l_len)] := (('%/0/').code).to_integer_8
							l_ln___0.item.content := l_ln___0.item.malloced_line
						else
							memcpy (create {CE_POINTER [ANY]}.make_cast ((l_ln___0.item.static_line + l_old_len___0)), create {CE_POINTER [ANY]}.make_cast (a_start), l_len.to_natural_32).do_nothing
							l_ln___0.item.static_line[l_old_len___0 + l_len] := (('%/0/').code).to_integer_8
							l_ln___0.item.content := l_ln___0.item.static_line
						end
					end
				end
				trailing_line := ((a_end[-1]).to_integer_32 /= 10)
				if not trailing_line then
					from
					until
						js.loop_left
					loop
						js.reset
						log_line_current := log_line_current + 1
						if log_line_current >= 24 then
							log_line_current := 0
						end
						js.break
					end
					js.reset
				end
			end
		end

	saved_append (a_s: CE_POINTER [INTEGER_8])
		local
			l_s: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
		do
			create l_s.make
			create l_end.make

			l_s.ce_gets (a_s)
			from
			until
				not ((l_s[0]).to_boolean)
			loop
				l_end.ce_gets ((strchr (l_s, ('%N').code)))
				if (l_end).c_pointer = default_pointer then
					l_end.ce_gets (l_s + (strlen (l_s)).to_integer_32)
				else
					l_end.ce_gets (l_end + 1)
				end
				saved_append_1 (l_s, l_end)
				l_s.ce_gets (l_end)
			end
		end

	get_log_fp: CE_POINTER [SD_IO_FILE]
		local
			js: JUMP_STATE
		do
			if inhibit_logging then
				Result := (create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called and then ((logfp).c_pointer /= default_pointer) then
				Result := logfp
				js.return
			end
			if not js.return_called then
				Result := ((create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)))
			end
		end

	logputs (a_o: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					check_redirect_output
					l_fp.ce_gets (get_log_fp)
					if (l_fp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						inspect a_o -- switch 1 head
						when 3 then l_pos := -1 + 2
						when 1 then l_pos := -1 + 3
						when 2 then l_pos := -1 + 4
						when 0 then l_pos := -1 + 5
						else l_pos := -1 + 6
						end
				when 2 then -- switch 1, case 3
						l_pos := -1 + 6 -- switch 1; break
				when 3 then -- switch 1, case 1
						if options_inst.opt.quiet then
							js.return
						end
						l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 2
						if (options_inst.opt.verbose).to_boolean then
							js.return
						elseif options_inst.opt.quiet then
							js.return
						end
						l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, case 0
						if not (options_inst.opt.verbose).to_boolean then
							js.return
						end
				when 6 then -- switch 1, done: | if done
						if not js.return_called then
							fputs (a_s, l_fp).do_nothing
							if save_context_p then
								saved_append (a_s)
							end
							if flush_log_p then
								logflush
							else
								needs_flushing := (1).to_boolean
							end
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	log_vprintf_internal (a_state: CE_POINTER [PD_LOGVPRINTF_STATE]; a_fmt: CE_POINTER [INTEGER_8]; a_args: CE_VA_LIST): BOOLEAN
		local
			l_args: CE_VA_LIST
			l_smallmsg: CE_ARRAY [INTEGER_8]
			l_write_ptr: CE_POINTER [INTEGER_8]
			l_available_size: INTEGER_32
			l_numwritten: INTEGER_32
			l_fp: CE_POINTER [SD_IO_FILE]
			l_newsize: INTEGER_32
			l_newsize___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_smallmsg.make (<<128>>)
			create l_write_ptr.make
			create l_fp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					create l_args.make_copy (a_args)
					l_write_ptr.ce_gets (l_smallmsg)
					l_available_size := (Integer_8_bytes.to_natural_32 * (128).to_natural_32).to_integer_32
					l_fp.ce_gets ((get_log_fp))
					if not save_context_p then
						vfprintf (l_fp, a_fmt, l_args).do_nothing
						l_pos := -1 + 3 -- goto flush
					end
				when 1 then
					if a_state.item.allocated /= 0 then
						l_write_ptr.ce_gets (a_state.item.bigmsg)
						l_available_size := a_state.item.allocated
					end
					l_numwritten := vsnprintf (l_write_ptr, l_available_size.to_natural_32, a_fmt, l_args)
					if l_numwritten = -1 then
						l_newsize := (l_available_size).bit_shift_left (1)
						a_state.item.bigmsg := create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (a_state.item.bigmsg), l_newsize.to_natural_32)))
						a_state.item.allocated := l_newsize
						Result := (0).to_boolean
						js.return
					elseif l_numwritten >= l_available_size then
						l_newsize___0 := l_numwritten + 1
						a_state.item.bigmsg := create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (a_state.item.bigmsg), l_newsize___0.to_natural_32)))
						a_state.item.allocated := l_newsize___0
						Result := (0).to_boolean
						js.return
					end
					if js.return_called then
						l_pos := -1 + 4 -- skip if block
					end
				when 2 then -- if:
						saved_append (l_write_ptr)
						fputs (l_write_ptr, l_fp).do_nothing
						if ((a_state.item.bigmsg).c_pointer /= default_pointer) then
							free (create {CE_POINTER [ANY]}.make_cast (a_state.item.bigmsg))
						end
				when 3 then -- flush:
						if flush_log_p then
							logflush
						else
							needs_flushing := (1).to_boolean
						end
						Result := (1).to_boolean
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	logflush
		local
			l_fp: CE_POINTER [SD_IO_FILE]
		do
			create l_fp.make

			l_fp.ce_gets ((get_log_fp))
			if ((l_fp).c_pointer /= default_pointer) then
				fflush (l_fp).do_nothing
			end
			needs_flushing := (0).to_boolean
		end

	log_set_flush (a_flush: BOOLEAN)
		local
			js: JUMP_STATE
		do
			if a_flush.to_integer = flush_log_p.to_integer then
				js.return
			end
			if not js.return_called then
				if a_flush.to_integer = 0 then
					flush_log_p := (0).to_boolean
				else
					if needs_flushing then
						logflush
					end
					flush_log_p := (1).to_boolean
				end
			end
		end

	log_set_save_context (a_savep: BOOLEAN): BOOLEAN
		local
			l_old: BOOLEAN
		do
			l_old := save_context_p
			save_context_p := a_savep
			Result := l_old
		end

	logprintf (a_args: TUPLE [a_o: INTEGER_32; a_fmt: CE_POINTER [INTEGER_8]])
		local
			l_args: CE_VA_LIST
			l_lpstate: PD_LOGVPRINTF_STATE
			l_done: BOOLEAN
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_lpstate.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					check_redirect_output
					if inhibit_logging then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						inspect a_args.a_o -- switch 1 head
						when 3 then l_pos := -1 + 2
						when 1 then l_pos := -1 + 3
						when 2 then l_pos := -1 + 4
						when 0 then l_pos := -1 + 5
						else l_pos := -1 + 6
						end
				when 2 then -- switch 1, case 3
						l_pos := -1 + 6 -- switch 1; break
				when 3 then -- switch 1, case 1
						if options_inst.opt.quiet then
							js.return
						end
						l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 2
						if (options_inst.opt.verbose).to_boolean then
							js.return
						elseif options_inst.opt.quiet then
							js.return
						end
						l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, case 0
						if not (options_inst.opt.verbose).to_boolean then
							js.return
						end
				when 6 then -- switch 1, done: | if done
						if not js.return_called then
							memset (create {CE_POINTER [ANY]}.make_cast ((l_lpstate.address)), ('%/0/').code, {PD_LOGVPRINTF_STATE}.sizeof.to_natural_32).do_nothing
							from
							until
								js.loop_left
							loop
								js.reset
								create l_args.make (a_args, 3)
								l_done := log_vprintf_internal (l_lpstate.address, a_args.a_fmt, l_args)
								if l_done then
									js.break
								end
							end
							js.reset
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	debug_logprintf (a_args: TUPLE [a_fmt: CE_POINTER [INTEGER_8]])
		local
			l_args: CE_VA_LIST
			l_lpstate: PD_LOGVPRINTF_STATE
			l_done: BOOLEAN
			js: JUMP_STATE
		do
			create l_lpstate.make

			if options_inst.opt.debug2 then
				check_redirect_output
				if inhibit_logging then
					js.return
				end
				if not js.return_called then
					memset (create {CE_POINTER [ANY]}.make_cast ((l_lpstate.address)), ('%/0/').code, {PD_LOGVPRINTF_STATE}.sizeof.to_natural_32).do_nothing
					from
					until
						js.loop_left
					loop
						js.reset
						create l_args.make (a_args, 2)
						l_done := log_vprintf_internal (l_lpstate.address, a_args.a_fmt, l_args)
						if l_done then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
			end
		end

	log_init (a_file: CE_POINTER [INTEGER_8]; a_appendp: BOOLEAN)
		local
			l_tmp: CE_POINTER [INTEGER_8]
		do
			create l_tmp.make

			if ((a_file).c_pointer /= default_pointer) then
				if a_appendp then
					l_tmp.ce_gets (ce_string ("a"))
				else
					l_tmp.ce_gets (ce_string ("w"))
				end
				logfp.ce_gets (fopen (a_file, l_tmp))
				if (logfp).c_pointer = default_pointer then
					Io.error.put_string (eif_string (wget_inst.exec_name) + ": " + eif_string (a_file) + ": " + eif_string ((strerror ((errno_location).item))) + "%N")
					exit (1)
				end
			else
				logfp.ce_gets ((create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)))
				if (isatty ((fileno (logfp)))).to_boolean then
					save_context_p := (1).to_boolean
				end
			end
		end

	log_close
		local
			l_i: INTEGER_32
		do
			if ((logfp).c_pointer /= default_pointer) then
				fclose (logfp).do_nothing
			end
			logfp.ce_gets (create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer))
			inhibit_logging := (1).to_boolean
			save_context_p := (0).to_boolean
			l_i := 0
			from
			until
				not (l_i < 24)
			loop
				free_log_line (l_i)
				l_i := l_i + 1
			end
			log_line_current := -1
			trailing_line := (0).to_boolean
		end

	log_dump_context
		local
			l_num: INTEGER_32
			l_fp: CE_POINTER [SD_IO_FILE]
			l_ln: CE_POINTER [PD_LOG_LN]
			js: JUMP_STATE
		do
			create l_fp.make
			create l_ln.make

			l_num := log_line_current
			l_fp.ce_gets ((get_log_fp))
			if (l_fp).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called and then (l_num = -1) then
				js.return
			end
			if not js.return_called then
				if trailing_line then
					from
					until
						js.loop_left
					loop
						js.reset
						l_num := l_num + 1
						if l_num >= 24 then
							l_num := 0
						end
						js.break
					end
					js.reset
				end
				from
				until
					js.loop_left
				loop
					js.reset
					l_ln.ce_gets (log_lines + l_num)
					if ((l_ln.item.content).c_pointer /= default_pointer) then
						fputs (l_ln.item.content, l_fp).do_nothing
					end
					from
					until
						js.loop_left
					loop
						js.reset
						l_num := l_num + 1
						if l_num >= 24 then
							l_num := 0
						end
						js.break
					end
					js.reset
					if l_num = log_line_current then
						js.break
					end
				end
				js.reset
				if trailing_line then
					if ((log_lines[log_line_current].content).c_pointer /= default_pointer) then
						fputs (log_lines[log_line_current].content, l_fp).do_nothing
					end
				end
				fflush (l_fp).do_nothing
			end
		end

	count_nonprint (a_source: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_cnt: INTEGER_32
		do
			create l_p___0.make

			l_p___0.ce_gets (a_source)
			l_cnt := 0
			from
			until
				not ((l_p___0[0]).to_boolean)
			loop
				if not (c_ctype_inst.c2_isprint ((l_p___0[0]).to_integer_32)) then
					l_cnt := l_cnt + 1
				end
				l_p___0.ce_gets (l_p___0 + 1)
			end
			Result := l_cnt
		end

	copy_and_escape (a_source: CE_POINTER [INTEGER_8]; a_dest: CE_POINTER [INTEGER_8]; a_escape: INTEGER_8; a_base: INTEGER_32)
		local
			l_from: CE_POINTER [INTEGER_8]
			l_to: CE_POINTER [INTEGER_8]
			l_c: NATURAL_8
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_from.make
			create l_to.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___7.make
			create l_tmp___8.make
			create l_tmp___9.make
			create l_tmp___11.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_from.ce_gets (a_source)
					l_to.ce_gets (a_dest)
					inspect a_base -- switch 1 head
					when 8 then l_pos := -1 + 1
					when 16 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 8
					from
					until
						js.loop_left
					loop
						js.reset
						l_tmp___5.ce_gets (l_from)
						l_from.ce_gets (l_from + 1)
						l_c := (l_tmp___5[0]).to_natural_8
						if l_c.to_integer_32 = 0 then
							js.break
						end
						if not js.loop_jumped then
							if (c_ctype_inst.c2_isprint (l_c.to_integer_32)) then
								l_tmp.ce_gets (l_to)
								l_to.ce_gets (l_to + 1)
								l_tmp[0] := l_c.to_integer_8
							else
								l_tmp___0.ce_gets (l_to)
								l_to.ce_gets (l_to + 1)
								l_tmp___0[0] := a_escape
								l_tmp___1.ce_gets (l_to)
								l_to.ce_gets (l_to + 1)
								l_tmp___1[0] := (48 + ((l_c.to_integer_32).bit_shift_right (6))).to_integer_8
								l_tmp___2.ce_gets (l_to)
								l_to.ce_gets (l_to + 1)
								l_tmp___2[0] := (48 + ((((l_c.to_integer_32).bit_shift_right (3))).bit_and (7))).to_integer_8
								l_tmp___3.ce_gets (l_to)
								l_to.ce_gets (l_to + 1)
								l_tmp___3[0] := (48 + ((l_c.to_integer_32).bit_and (7))).to_integer_8
							end
						end
					end
					js.reset
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 16
					from
					until
						js.loop_left
					loop
						js.reset
						l_tmp___11.ce_gets (l_from)
						l_from.ce_gets (l_from + 1)
						l_c := (l_tmp___11[0]).to_natural_8
						if l_c.to_integer_32 = 0 then
							js.break
						end
						if not js.loop_jumped then
							if (c_ctype_inst.c2_isprint (l_c.to_integer_32)) then
								l_tmp___6.ce_gets (l_to)
								l_to.ce_gets (l_to + 1)
								l_tmp___6[0] := l_c.to_integer_8
							else
								l_tmp___7.ce_gets (l_to)
								l_to.ce_gets (l_to + 1)
								l_tmp___7[0] := a_escape
								l_tmp___8.ce_gets (l_to)
								l_to.ce_gets (l_to + 1)
								l_tmp___8[0] := (ce_string ("0123456789ABCDEF") + ((l_c.to_integer_32).bit_shift_right (4))).item
								l_tmp___9.ce_gets (l_to)
								l_to.ce_gets (l_to + 1)
								l_tmp___9[0] := (ce_string ("0123456789ABCDEF") + ((l_c.to_integer_32).bit_and (15))).item
							end
						end
					end
					js.reset
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					abort
				when 4 then -- switch 1, done:
					l_to[0] := (('%/0/').code).to_integer_8
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	escnonprint_internal (a_str: CE_POINTER [INTEGER_8]; a_escape: INTEGER_8; a_base: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_nprcnt: INTEGER_32
			l_r: CE_POINTER [PD_RINGEL]
			l_needed_size: INTEGER_32
			l_tmp: NATURAL_32
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [ANY]
			js: JUMP_STATE
		do
			create l_r.make
			create l_tmp___1.make

			if a_base /= 8 then
				if a_base /= 16 then
					assert_fail (ce_string ("base == 8 || base == 16"), ce_string ("log.c"), {NATURAL_32} 712, ce_string ("escnonprint_internal"))
				end
			end
			l_nprcnt := count_nonprint (a_str)
			if l_nprcnt = 0 then
				Result := a_str
				js.return
			end
			if not js.return_called then
				l_r.ce_gets (ring + ringpos)
				l_tmp := strlen (a_str)
				if a_base = 8 then
					l_tmp___0 := 3 * l_nprcnt
				else
					l_tmp___0 := 2 * l_nprcnt
				end
				l_needed_size := ((l_tmp + {NATURAL_32} 1) + l_tmp___0.to_natural_32).to_integer_32
				if ((l_r.item.buffer).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_tmp___1.ce_gets (xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (l_r.item.buffer), l_needed_size.to_natural_32))
					l_r.item.buffer := create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___1)
					l_r.item.size := l_needed_size
				elseif l_r.item.size < l_needed_size then
					l_tmp___1.ce_gets (xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (l_r.item.buffer), l_needed_size.to_natural_32))
					l_r.item.buffer := create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___1)
					l_r.item.size := l_needed_size
				end
				copy_and_escape (a_str, l_r.item.buffer, a_escape, a_base)
				ringpos := (ringpos + 1) \\ 3
				Result := (l_r.item.buffer)
			end
		end

	escnonprint (a_str: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			Result := (escnonprint_internal (a_str, (('\').code).to_integer_8, 8))
		end

	escnonprint_uri (a_str: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			Result := (escnonprint_internal (a_str, (('%%').code).to_integer_8, 16))
		end

	log_cleanup
		local
			l_i: NATURAL_32
		do
			l_i := (0).to_natural_32
			from
			until
				not (l_i < ({PD_RINGEL}.sizeof.to_natural_32 * (3).to_natural_32) // {PD_RINGEL}.sizeof.to_natural_32)
			loop
				if ((ring[l_i.to_integer_32].buffer).c_pointer /= default_pointer) then
					free (create {CE_POINTER [ANY]}.make_cast (ring[l_i.to_integer_32].buffer))
				end
				l_i := l_i + 1
			end
		end

	redirect_output
		local
			l_logfile: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
		do
			create l_logfile.make
			create l_tmp.make
			create l_tmp___3.make

			logfp.ce_gets (utils_inst.unique_create (ce_string ("wget-log"), (0).to_boolean, l_logfile.address))
			if ((logfp).c_pointer /= default_pointer) then
				l_tmp.ce_gets (quote_inst.quote (l_logfile))
				fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%N%%s received, redirecting output to %%s.%N"))), redirect_request_signal_name, l_tmp]).do_nothing
				free (create {CE_POINTER [ANY]}.make_cast (l_logfile))
				log_dump_context
			else
				fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%N%%s received.%N"))), redirect_request_signal_name]).do_nothing
				l_tmp___3.ce_gets (strerror ((errno_location).item))
				fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%%s: %%s; disabling logging.%N"))), l_logfile, l_tmp___3]).do_nothing
				inhibit_logging := (1).to_boolean
			end
			save_context_p := (0).to_boolean
		end

	check_redirect_output
		do
			if redirect_request.to_natural_32 = {NATURAL_32} 1 then
				redirect_request := {PC_REDIRECT_REQUEST}.RR_DONE
				redirect_output
			end
		end

	log_request_redirect_output (a_signal_name: CE_POINTER [INTEGER_8])
		do
			if redirect_request.to_natural_32 = {NATURAL_32} 0 then
				if save_context_p then
					redirect_request := {PC_REDIRECT_REQUEST}.RR_REQUESTED
				end
			end
			redirect_request_signal_name.ce_gets (a_signal_name)
		end

end
