class
	P_MAIN

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create option_data.make (<<121>>)
			create buffer.make (<<1024>>)
			create p.make
			create long_options.make (<<({NATURAL_32} 2 * (({PD_CMDLINE_OPTION}.sizeof.to_natural_32 * (121).to_natural_32) // {PD_CMDLINE_OPTION}.sizeof.to_natural_32) + {NATURAL_32} 1).to_integer_32>>)
			create short_options.make (<<128>>)
			create optmap.make (<<96>>)
			create help.make (<<118>>)
			create buf___1.make (<<32>>)
			create program_name.make
		end

feature {ANY} -- attributes

	numurls: INTEGER_32 assign set_numurls

	set_numurls (a_numurls: INTEGER_32)
		do
			numurls := a_numurls
		end

	option_data: CE_ARRAY [PD_CMDLINE_OPTION]

	buffer: CE_ARRAY [INTEGER_8]

	p: CE_POINTER [INTEGER_8]

	long_options: CE_ARRAY [SD_OPTION]

	short_options: CE_ARRAY [INTEGER_8]

	optmap: CE_ARRAY [NATURAL_8]

	help: CE_ARRAY [CE_POINTER [INTEGER_8]]

	buf___1: CE_ARRAY [INTEGER_8]

	program_name: CE_POINTER [INTEGER_8]

feature {ANY} -- routines

	i18n_initialize
		do
			setlocale (6, ce_string ("")).do_nothing
			bindtextdomain (ce_string ("wget"), ce_string ("/usr/local/share/locale")).do_nothing
			textdomain (ce_string ("wget")).do_nothing
		end

	no_prefix (a_s: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_cp: CE_POINTER [INTEGER_8]
			l_size: INTEGER_32
		do
			create l_cp.make

			l_cp.ce_gets (p)
			l_size := (({NATURAL_32} 3 + (strlen (a_s))) + {NATURAL_32} 1).to_integer_32
			if ((p + l_size).c_pointer.to_integer_32).to_natural_32 >= ((buffer + (Integer_8_bytes.to_natural_32 * (1024).to_natural_32).to_integer_32).c_pointer.to_integer_32).to_natural_32 then
				abort
			end
			l_cp[0] := (('n').code).to_integer_8
			l_cp[1] := (('o').code).to_integer_8
			l_cp[2] := (('-').code).to_integer_8
			strcpy ((l_cp + 3), a_s).do_nothing
			p.ce_gets (p + l_size)
			Result := l_cp
		end

	init_switches
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_i: NATURAL_32
			l_o: NATURAL_32
			l_opt___0: CE_POINTER [PD_CMDLINE_OPTION]
			l_longopt: CE_POINTER [SD_OPTION]
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: NATURAL_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_opt___0.make
			create l_longopt.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___4.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (short_options)
					l_o := (0).to_natural_32
					l_i := (0).to_natural_32
				when 1 then -- loop condition:
					if not (l_i < ({PD_CMDLINE_OPTION}.sizeof.to_natural_32 * (121).to_natural_32) // {PD_CMDLINE_OPTION}.sizeof.to_natural_32) then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_opt___0.ce_gets (option_data + l_i.to_integer_32)
						if (l_opt___0.item.long_name).c_pointer = default_pointer then
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if:
						l_tmp := l_o
						l_o := l_o + 1
						l_longopt.ce_gets (long_options + l_tmp.to_integer_32)
						l_longopt.item.name := l_opt___0.item.long_name
						l_longopt.item.val := l_i.to_integer_32
						if (l_opt___0.item.short_name).to_boolean then
							l_tmp___0.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___0[0] := l_opt___0.item.short_name
							optmap[(l_opt___0.item.short_name).to_integer_32 - 32] := (l_longopt.distance (long_options)).to_natural_8
						end
						inspect l_opt___0.item.type -- switch 1 head
						when 0 then l_pos := -1 + 4
						when 1 then l_pos := -1 + 5
						else l_pos := -1 + 6
						end
				when 4 then -- switch 1, case 0
						l_longopt.item.has_arg := 1
						if (l_opt___0.item.short_name).to_boolean then
							l_tmp___1.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___1[0] := ((':').code).to_integer_8
						end
						l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 1
						l_longopt.item.has_arg := 2
						l_tmp___2 := l_o
						l_o := l_o + 1
						l_longopt.ce_gets (long_options + l_tmp___2.to_integer_32)
						l_longopt.item.name := (no_prefix (l_opt___0.item.long_name))
						l_longopt.item.has_arg := 0
						l_longopt.item.val := ((l_i).bit_or ({NATURAL_32} 1024)).to_integer_32
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, default:
						if l_opt___0.item.argtype = -1 then
							assert_fail (ce_string ("opt->argtype != -1"), ce_string ("main.c"), {NATURAL_32} 365, ce_string ("init_switches"))
						end
						l_longopt.item.has_arg := l_opt___0.item.argtype
						if (l_opt___0.item.short_name).to_boolean then
							if l_longopt.item.has_arg = 1 then
								l_tmp___4.ce_gets (l_p___0)
								l_p___0.ce_gets (l_p___0 + 1)
								l_tmp___4[0] := ((':').code).to_integer_8
							end
						end
				when 7 then -- switch 1, done: | if done
						l_i := l_i + 1
						l_pos := -1 + 1 -- back to loop condition
				when 8 then -- loop done
					l_p___0[0] := (('%/0/').code).to_integer_8
					if not (l_o <= ({SD_OPTION}.sizeof.to_natural_32 * {NATURAL_32} 2 * (({PD_CMDLINE_OPTION}.sizeof.to_natural_32 * (121).to_natural_32) // {PD_CMDLINE_OPTION}.sizeof.to_natural_32) + {NATURAL_32} 1) // {SD_OPTION}.sizeof.to_natural_32) then
						assert_fail (ce_string ("o <= (sizeof (long_options) / sizeof ((long_options)[0]))"), ce_string ("main.c"), {NATURAL_32} 379, ce_string ("init_switches"))
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	print_usage
		do
			printf ([(gettext (ce_string ("Usage: %%s [OPTION]... [URL]...%N"))), wget_inst.exec_name]).do_nothing
		end

	print_help
		local
			l_i: NATURAL_32
		do
			printf ([(gettext (ce_string ("GNU Wget %%s, a non-interactive network retriever.%N"))), version_inst.version_string]).do_nothing
			print_usage
			l_i := (0).to_natural_32
			from
			until
				not (l_i < (Pointer_bytes.to_natural_32 * (118).to_natural_32) // Pointer_bytes.to_natural_32)
			loop
				fputs ((gettext (help[l_i.to_integer_32])), (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))).do_nothing
				l_i := l_i + 1
			end
			exit (0)
		end

	print_help_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent print_help)
		end

	secs_to_human_time (a_interval: REAL_64): CE_POINTER [INTEGER_8]
		local
			l_secs: INTEGER_32
			l_hours: INTEGER_32
			l_mins: INTEGER_32
			l_days: INTEGER_32
		do
			l_secs := (a_interval + 0.5).truncated_to_integer
			l_days := l_secs // 86400
			l_secs := l_secs \\ (86400)
			l_hours := l_secs // 3600
			l_secs := l_secs \\ (3600)
			l_mins := l_secs // 60
			l_secs := l_secs \\ (60)
			if l_days.to_boolean then
				sprintf ([buf___1, ce_string ("%%dd %%dh %%dm %%ds"), l_days, l_hours, l_mins, l_secs]).do_nothing
			elseif l_hours.to_boolean then
				sprintf ([buf___1, ce_string ("%%dh %%dm %%ds"), l_hours, l_mins, l_secs]).do_nothing
			elseif l_mins.to_boolean then
				sprintf ([buf___1, ce_string ("%%dm %%ds"), l_mins, l_secs]).do_nothing
			else
				sprintf ([buf___1, ce_string ("%%ss"), (utils_inst.print_decimal (a_interval))]).do_nothing
			end
			Result := buf___1
		end

	prompt_for_password: CE_POINTER [INTEGER_8]
		local
			l_tmp: CE_POINTER [INTEGER_8]
		do
			create l_tmp.make

			if ((options_inst.opt.user).c_pointer /= default_pointer) then
				l_tmp.ce_gets (quote_inst.quote (options_inst.opt.user))
				printf ([(gettext (ce_string ("Password for user %%s: "))), l_tmp]).do_nothing
			else
				Io.put_string (eif_string ((gettext (ce_string ("Password: ")))))
			end
			Result := (getpass_inst.gnu_getpass (ce_string ("")))
		end

	format_and_print_line (a_prefix: CE_POINTER [INTEGER_8]; a_line: CE_POINTER [INTEGER_8]; a_line_length: INTEGER_32)
		local
			l_line_length: INTEGER_32
			l_remaining_chars: INTEGER_32
			l_line_dup: CE_POINTER [INTEGER_8]
			l_token: CE_POINTER [INTEGER_8]
		do
			create l_line_dup.make
			create l_token.make

			l_line_length := a_line_length
			if (a_prefix.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				assert_fail (ce_string ("prefix != ((void *)0)"), ce_string ("main.c"), {NATURAL_32} 745, ce_string ("format_and_print_line"))
			end
			if (a_line.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				assert_fail (ce_string ("line != ((void *)0)"), ce_string ("main.c"), {NATURAL_32} 746, ce_string ("format_and_print_line"))
			end
			l_line_dup.ce_gets (xmalloc_inst.xstrdup (a_line))
			if l_line_length <= 0 then
				l_line_length := 68
			end
			Io.put_string (eif_string (a_prefix))
			l_remaining_chars := l_line_length
			l_token.ce_gets (strtok (l_line_dup, ce_string (" ")))
			from
			until
				(l_token.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
			loop
				if l_remaining_chars.to_natural_32 <= (strlen (l_token)) then
					printf ([ce_string ("%N%%*c"), 4, (' ').code]).do_nothing
					l_remaining_chars := l_line_length - 4
				end
				Io.put_string (eif_string (l_token) + " ")
				l_remaining_chars := (l_remaining_chars.to_natural_32 - ((strlen (l_token)) + {NATURAL_32} 1)).to_integer_32
				l_token.ce_gets (strtok (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string (" ")))
			end
			Io.put_string ("%N")
			free (create {CE_POINTER [ANY]}.make_cast (l_line_dup))
		end

	print_version
		local
			l_wgetrc_title: CE_POINTER [INTEGER_8]
			l_locale_title: CE_POINTER [INTEGER_8]
			l_compile_title: CE_POINTER [INTEGER_8]
			l_link_title: CE_POINTER [INTEGER_8]
			l_env_wgetrc: CE_POINTER [INTEGER_8]
			l_user_wgetrc: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			l_line_length: INTEGER_32
			js: JUMP_STATE
		do
			create l_wgetrc_title.make
			create l_locale_title.make
			create l_compile_title.make
			create l_link_title.make
			create l_env_wgetrc.make
			create l_user_wgetrc.make

			l_wgetrc_title.ce_gets ((gettext (ce_string ("Wgetrc: "))))
			l_locale_title.ce_gets ((gettext (ce_string ("Locale: "))))
			l_compile_title.ce_gets ((gettext (ce_string ("Compile: "))))
			l_link_title.ce_gets ((gettext (ce_string ("Link: "))))
			printf ([(gettext (ce_string ("GNU Wget %%s built on %%s.%N%N"))), version_inst.version_string, ce_string ("linux-gnu")]).do_nothing
			l_i := 0
			from
			until
				not (not js.loop_left and then (((build_info_inst.compiled_features[l_i]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				l_line_length := 72
				from
				until
					js.loop_left
				loop
					js.reset
					if l_line_length > 0 then
						if ((build_info_inst.compiled_features[l_i]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						Io.put_string (eif_string (build_info_inst.compiled_features[l_i]) + " ")
						l_line_length := (l_line_length.to_natural_32 - ((strlen (build_info_inst.compiled_features[l_i])) + {NATURAL_32} 2)).to_integer_32
						l_i := l_i + 1
					end
				end
				js.reset
				Io.put_string ("%N")
			end
			Io.put_string ("%N")
			Io.put_string (eif_string (l_wgetrc_title) + "%N")
			l_env_wgetrc.ce_gets (init_inst.wgetrc_env_file_name)
			if ((l_env_wgetrc).c_pointer /= default_pointer) then
				if (l_env_wgetrc[0]).to_boolean then
					printf ([(gettext (ce_string ("    %%s (env)%N"))), l_env_wgetrc]).do_nothing
					free (create {CE_POINTER [ANY]}.make_cast (l_env_wgetrc))
				end
			end
			l_user_wgetrc.ce_gets (init_inst.wgetrc_user_file_name)
			if ((l_user_wgetrc).c_pointer /= default_pointer) then
				printf ([(gettext (ce_string ("    %%s (user)%N"))), l_user_wgetrc]).do_nothing
				free (create {CE_POINTER [ANY]}.make_cast (l_user_wgetrc))
			end
			printf ([(gettext (ce_string ("    %%s (system)%N"))), ce_string ("/usr/local/etc/wgetrc")]).do_nothing
			format_and_print_line (l_locale_title, ce_string ("/usr/local/share/locale"), 72)
			format_and_print_line (l_compile_title, version_inst.compilation_string, 72)
			format_and_print_line (l_link_title, version_inst.link_string, 72)
			Io.put_string ("%N")
			fputs ((gettext (ce_string ("Copyright (C) 2009 Free Software Foundation, Inc.%N"))), (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))).do_nothing
			fputs ((gettext (ce_string ("License GPLv3+: GNU GPL version 3 or later%N<http://www.gnu.org/licenses/gpl.html>.%NThis is free software: you are free to change and redistribute it.%NThere is NO WARRANTY, to the extent permitted by law.%N"))), (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))).do_nothing
			fputs ((gettext (ce_string ("%NOriginally written by Hrvoje Niksic <hniksic@xemacs.org>.%N"))), (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))).do_nothing
			fputs ((gettext (ce_string ("Currently maintained by Micah Cowan <micah@cowan.name>.%N"))), (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))).do_nothing
			fputs ((gettext (ce_string ("Please send bug reports and questions to <bug-wget@gnu.org>.%N"))), (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))).do_nothing
			exit (0)
		end

	print_version_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent print_version)
		end

	main (a_argc: INTEGER_32; a_argv: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_url: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_t: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_i: INTEGER_32
			l_ret: INTEGER_32
			l_longindex: INTEGER_32
			l_nurl: INTEGER_32
			l_status: INTEGER_32
			l_append_to_log: BOOLEAN
			l_val: INTEGER_32
			l_opt___0: CE_POINTER [PD_CMDLINE_OPTION]
			l_neg: BOOLEAN
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_func: CE_ROUTINE
			l_p___0: CE_POINTER [INTEGER_8]
			l_flag: BOOLEAN
			l_tmp___7: INTEGER_32
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___13: CE_POINTER [INTEGER_8]
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___21: CE_POINTER [INTEGER_8]
			l_rewritten: CE_POINTER [INTEGER_8]
			l_st: SD_STAT
			l_tmp___25: CE_POINTER [INTEGER_8]
			l_filename: CE_POINTER [INTEGER_8]
			l_redirected_URL: CE_POINTER [INTEGER_8]
			l_dt: INTEGER_32
			l_url_err: INTEGER_32
			l_iri: CE_POINTER [PD_IRI]
			l_url_parsed: CE_POINTER [PD_URL]
			l_error___0: CE_POINTER [INTEGER_8]
			l_old_follow_ftp: INTEGER_32
			l_tmp___32: INTEGER_32
			l_count: INTEGER_32
			l_tmp___43: CE_POINTER [INTEGER_8]
			l_tmp___44: CE_POINTER [INTEGER_8]
			l_tmp___45: CE_POINTER [INTEGER_8]
			l_tmp___47: CE_POINTER [INTEGER_8]
			l_tmp___49: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_url.make
			create l_t.make
			create l_opt___0.make
			create l_tmp___1.make
			create l_func.make
			create l_p___0.make
			create l_tmp___8.make
			create l_tmp___9.make
			create l_tmp___13.make
			create l_tmp___14.make
			create l_tmp___21.make
			create l_rewritten.make
			create l_st.make
			create l_tmp___25.make
			create l_filename.make
			create l_redirected_URL.make
			create l_iri.make
			create l_url_parsed.make
			create l_error___0.make
			create l_tmp___43.make
			create l_tmp___44.make
			create l_tmp___45.make
			create l_tmp___47.make
			create l_tmp___49.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_append_to_log := (0).to_boolean
					program_name.ce_gets (a_argv[0])
					i18n_initialize
					wget_inst.exec_name.ce_gets ((strrchr (a_argv[0], ('/').code)))
					if (wget_inst.exec_name).c_pointer = default_pointer then
						wget_inst.exec_name.ce_gets (a_argv[0])
					else
						wget_inst.exec_name.ce_gets (wget_inst.exec_name + 1)
					end
					init_inst.initialize
					init_switches
					l_longindex := -1
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 24 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_ret := getopt_long (a_argc, a_argv, short_options, create {CE_POINTER [SD_OPTION]}.make_cast (long_options), create {CE_POINTER [INTEGER_32]}.make_shared ($l_longindex))
						if l_ret = -1 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 23 -- skip if block
						end
				when 3 then -- if:
						if l_longindex = -1 then
							if l_ret = 63 then
								print_usage
								Io.put_string ("%N")
								printf ([(gettext (ce_string ("Try `%%s --help%' for more options.%N"))), wget_inst.exec_name]).do_nothing
								exit (2)
							end
							l_longindex := (optmap[l_ret - 32]).to_integer_32
						end
						l_val := long_options[l_longindex].val
						l_opt___0.ce_gets (option_data + (l_val).bit_and (-1025))
						inspect l_opt___0.item.type -- switch 1 head
						when 0 then l_pos := -1 + 4
						when 1 then l_pos := -1 + 5
						when 2 then l_pos := -1 + 6
						when 3 then l_pos := -1 + 7
						when 6 then l_pos := -1 + 8
						when 7 then l_pos := -1 + 9
						when 8 then l_pos := -1 + 20
						when 4 then l_pos := -1 + 20
						when 5 then l_pos := -1 + 21
						else l_pos := -1 + 22
						end
				when 4 then -- switch 1, case 0
						init_inst.setoptval (create {CE_POINTER [INTEGER_8]}.make_cast (l_opt___0.item.data), optarg, l_opt___0.item.long_name)
						l_pos := -1 + 22 -- switch 1; break
				when 5 then -- switch 1, case 1
						if ((optarg).c_pointer /= default_pointer) then
							init_inst.setoptval (create {CE_POINTER [INTEGER_8]}.make_cast (l_opt___0.item.data), optarg, l_opt___0.item.long_name)
						else
							l_neg := (((l_val).bit_and (1024)).to_boolean)
							if l_neg then
								l_tmp___1.ce_gets (ce_string ("0"))
							else
								l_tmp___1.ce_gets (ce_string ("1"))
							end
							init_inst.setoptval (create {CE_POINTER [INTEGER_8]}.make_cast (l_opt___0.item.data), l_tmp___1, l_opt___0.item.long_name)
						end
						l_pos := -1 + 22 -- switch 1; break
				when 6 then -- switch 1, case 2
						l_func.ce_gets (create {CE_ROUTINE}.make_cast (l_opt___0.item.data))
						l_func.call ([])
						l_pos := -1 + 22 -- switch 1; break
				when 7 then -- switch 1, case 3
						init_inst.setoptval (ce_string ("logfile"), optarg, l_opt___0.item.long_name)
						l_append_to_log := (1).to_boolean
						l_pos := -1 + 22 -- switch 1; break
				when 8 then -- switch 1, case 6
						init_inst.run_command (optarg)
						l_pos := -1 + 22 -- switch 1; break
				when 9 then -- switch 1, case 7
						l_p___0.ce_gets (optarg)
				when 10 then -- loop condition:
						if not ((l_p___0[0]).to_boolean) then
							l_pos := -1 + 19 -- skip loop
						end
				when 11 then -- loop body:
						inspect (l_p___0[0]).to_integer_32 -- switch 2 head
						when 118 then l_pos := -1 + 12
						when 72 then l_pos := -1 + 13
						when 100 then l_pos := -1 + 14
						when 99 then l_pos := -1 + 15
						when 112 then l_pos := -1 + 16
						else l_pos := -1 + 17
						end
				when 12 then -- switch 2, case 118
						init_inst.setoptval (ce_string ("verbose"), ce_string ("0"), l_opt___0.item.long_name)
						l_pos := -1 + 18 -- switch 2; break
				when 13 then -- switch 2, case 72
						init_inst.setoptval (ce_string ("addhostdir"), ce_string ("0"), l_opt___0.item.long_name)
						l_pos := -1 + 18 -- switch 2; break
				when 14 then -- switch 2, case 100
						init_inst.setoptval (ce_string ("dirstruct"), ce_string ("0"), l_opt___0.item.long_name)
						l_pos := -1 + 18 -- switch 2; break
				when 15 then -- switch 2, case 99
						init_inst.setoptval (ce_string ("noclobber"), ce_string ("1"), l_opt___0.item.long_name)
						l_pos := -1 + 18 -- switch 2; break
				when 16 then -- switch 2, case 112
						init_inst.setoptval (ce_string ("noparent"), ce_string ("1"), l_opt___0.item.long_name)
						l_pos := -1 + 18 -- switch 2; break
				when 17 then -- switch 2, default:
						printf ([(gettext (ce_string ("%%s: illegal option -- `-n%%c%'%N"))), wget_inst.exec_name, (l_p___0[0]).to_integer_32]).do_nothing
						print_usage
						Io.put_string ("%N")
						printf ([(gettext (ce_string ("Try `%%s --help%' for more options.%N"))), wget_inst.exec_name]).do_nothing
						exit (1)
				when 18 then -- switch 2, done:
						l_p___0.ce_gets (l_p___0 + 1)
						l_pos := -1 + 10 -- back to loop condition
				when 19 then -- loop done
						l_pos := -1 + 22 -- switch 1; break
				when 20 then -- switch 1, case 8 | switch 1, case 4
						l_flag := (1).to_boolean
						if ((optarg).c_pointer /= default_pointer) then
							if (optarg[0]).to_integer_32 = 49 then
								l_tmp___7 := 1
							elseif (c_ctype_inst.c2_tolower ((optarg[0]).to_integer_32)) = 121 then
								l_tmp___7 := 1
							elseif (c_ctype_inst.c2_tolower ((optarg[0]).to_integer_32)) = 111 then
								if (c_ctype_inst.c2_tolower ((optarg[1]).to_integer_32)) = 110 then
									l_tmp___7 := 1
								else
									l_tmp___7 := 0
								end
							else
								l_tmp___7 := 0
							end
							l_flag := l_tmp___7.to_boolean
						end
						if l_flag then
							l_tmp___8.ce_gets (ce_string ("0"))
						else
							l_tmp___8.ce_gets (ce_string ("1"))
						end
						if (l_opt___0.item.type).to_natural_32 = {NATURAL_32} 8 then
							l_tmp___9.ce_gets (ce_string ("noparent"))
						else
							l_tmp___9.ce_gets (ce_string ("noclobber"))
						end
						init_inst.setoptval (l_tmp___9, l_tmp___8, l_opt___0.item.long_name)
						l_pos := -1 + 22 -- switch 1; break
				when 21 then -- switch 1, case 5
						init_inst.setoptval (ce_string ("removelisting"), ce_string ("0"), l_opt___0.item.long_name)
						l_pos := -1 + 22 -- switch 1; break
				when 22 then -- switch 1, done:
						l_longindex := -1
				when 23 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 24 then -- loop done
					js.reset
					l_nurl := a_argc - optind
					if options_inst.opt.reclevel = 0 then
						options_inst.opt.reclevel := -1
					end
					if options_inst.opt.spider then
						options_inst.opt.no_dirstruct := (1).to_boolean
					elseif options_inst.opt.delete_after then
						options_inst.opt.no_dirstruct := (1).to_boolean
					end
					if options_inst.opt.page_requisites then
						if not options_inst.opt.recursive then
							options_inst.opt.reclevel := 0
							if not options_inst.opt.no_dirstruct then
								options_inst.opt.dirstruct := (1).to_boolean
							end
						end
					end
					if options_inst.opt.verbose = -1 then
						options_inst.opt.verbose := (not options_inst.opt.quiet).to_integer
					end
					if (options_inst.opt.verbose).to_boolean then
						if options_inst.opt.quiet then
							Io.put_string (eif_string ((gettext (ce_string ("Can%'t be verbose and quiet at the same time.%N")))))
							print_usage
							exit (1)
						end
					end
					if options_inst.opt.timestamping then
						if options_inst.opt.noclobber then
							Io.put_string (eif_string ((gettext (ce_string ("Can%'t timestamp and not clobber old files at the same time.%N")))))
							print_usage
							exit (1)
						end
					end
					if options_inst.opt.ipv4_only then
						if options_inst.opt.ipv6_only then
							Io.put_string (eif_string ((gettext (ce_string ("Cannot specify both --inet4-only and --inet6-only.%N")))))
							print_usage
							exit (1)
						end
					end
					if ((options_inst.opt.output_document).c_pointer /= default_pointer) then
						if options_inst.opt.convert_links then
							if l_nurl > 1 then
								l_tmp___13.ce_gets (gettext (ce_string ("Cannot specify both -k and -O if multiple URLs are given, or in combination%Nwith -p or -r. See the manual for details.%N%N")))
								fputs (l_tmp___13, (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))).do_nothing
								print_usage
								exit (1)
							elseif options_inst.opt.page_requisites then
								l_tmp___13.ce_gets (gettext (ce_string ("Cannot specify both -k and -O if multiple URLs are given, or in combination%Nwith -p or -r. See the manual for details.%N%N")))
								fputs (l_tmp___13, (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))).do_nothing
								print_usage
								exit (1)
							elseif options_inst.opt.recursive then
								l_tmp___13.ce_gets (gettext (ce_string ("Cannot specify both -k and -O if multiple URLs are given, or in combination%Nwith -p or -r. See the manual for details.%N%N")))
								fputs (l_tmp___13, (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))).do_nothing
								print_usage
								exit (1)
							end
						end
						if options_inst.opt.page_requisites then
							l_tmp___14.ce_gets (gettext (ce_string ("WARNING: combining -O with -r or -p will mean that all downloaded content%Nwill be placed in the single file you specified.%N%N")))
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s"), l_tmp___14])
						elseif options_inst.opt.recursive then
							l_tmp___14.ce_gets (gettext (ce_string ("WARNING: combining -O with -r or -p will mean that all downloaded content%Nwill be placed in the single file you specified.%N%N")))
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s"), l_tmp___14])
						end
						if options_inst.opt.timestamping then
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s"), (gettext (ce_string ("WARNING: timestamping does nothing in combination with -O. See the manual%Nfor details.%N%N")))])
							options_inst.opt.timestamping := (0).to_boolean
						end
						if options_inst.opt.noclobber then
							if (utils_inst.file_exists_p (options_inst.opt.output_document)) then
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("File `%%s%' already there; not retrieving.%N"))), options_inst.opt.output_document])
								exit (1)
							end
						end
					end
					if options_inst.opt.ask_passwd then
						if ((options_inst.opt.passwd).c_pointer /= default_pointer) then
							Io.put_string (eif_string ((gettext (ce_string ("Cannot specify both --ask-password and --password.%N")))))
							print_usage
							exit (1)
						end
					end
					if not l_nurl.to_boolean then
						if (options_inst.opt.input_filename).c_pointer = default_pointer then
							printf ([(gettext (ce_string ("%%s: missing URL%N"))), wget_inst.exec_name]).do_nothing
							print_usage
							Io.put_string ("%N")
							printf ([(gettext (ce_string ("Try `%%s --help%' for more options.%N"))), wget_inst.exec_name]).do_nothing
							exit (1)
						end
					end
					if options_inst.opt.enable_iri then
						l_tmp___21.ce_gets (gettext (ce_string ("This version does not have support for IRIs%N")))
						Io.put_string (eif_string (l_tmp___21))
						exit (1)
					elseif ((options_inst.opt.locale).c_pointer /= default_pointer) then
						l_tmp___21.ce_gets (gettext (ce_string ("This version does not have support for IRIs%N")))
						Io.put_string (eif_string (l_tmp___21))
						exit (1)
					elseif ((options_inst.opt.encoding_remote).c_pointer /= default_pointer) then
						l_tmp___21.ce_gets (gettext (ce_string ("This version does not have support for IRIs%N")))
						Io.put_string (eif_string (l_tmp___21))
						exit (1)
					end
					if options_inst.opt.ask_passwd then
						options_inst.opt.passwd := prompt_for_password
						if ((options_inst.opt.passwd).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							exit (1)
						elseif (options_inst.opt.passwd[0]).to_integer_32 = 0 then
							exit (1)
						end
					end
					if options_inst.opt.background then
						utils_inst.fork_to_background
					end
					if (options_inst.opt.verbose).to_boolean then
						progress_inst.set_progress_implementation (options_inst.opt.progress_type)
					end
					l_url.ce_gets (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast ((l_aaf.new ((l_nurl + 1).to_natural_32 * Pointer_bytes.to_natural_32))))
					l_i := 0
					from
					until
						not (l_i < l_nurl)
					loop
						l_rewritten.ce_gets ((url_inst.rewrite_shorthand_url (a_argv[optind])))
						if ((l_rewritten).c_pointer /= default_pointer) then
							l_url[l_i] := l_rewritten
						else
							l_url[l_i] := xmalloc_inst.xstrdup (a_argv[optind])
						end
						l_i := l_i + 1
						Current.optind := optind + 1
					end
					l_url[l_i] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					log_inst.log_init (options_inst.opt.lfilename, l_append_to_log)
					from
					until
						js.loop_left
					loop
						js.reset
						if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
							log_inst.debug_logprintf ([ce_string ("DEBUG output created by Wget %%s on %%s.%N%N"), version_inst.version_string, ce_string ("linux-gnu")])
						end
						js.break
					end
					js.reset
					if (options_inst.opt.output_document).c_pointer = default_pointer then
						l_pos := -1 + 29 -- skip if block
					end
				when 25 then -- if:
						if ((options_inst.opt.output_document).item).to_integer_32 /= 45 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						if not (options_inst.opt.output_document[1]).to_boolean then
							retr_inst.output_stream.ce_gets ((create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer)))
						else
							l_pos := -1 + 28 -- goto _L
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else: | _L:
						if options_inst.opt.always_rest then
							l_tmp___25.ce_gets (ce_string ("ab"))
						else
							l_tmp___25.ce_gets (ce_string ("wb"))
						end
						retr_inst.output_stream.ce_gets (fopen (options_inst.opt.output_document, l_tmp___25))
						if (retr_inst.output_stream.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							perror (options_inst.opt.output_document)
							exit (1)
						end
						if (fstat ((fileno (retr_inst.output_stream)), l_st.address)) = 0 then
							if ((l_st.st_mode).bit_and ({NATURAL_32} 61440)) = {NATURAL_32} 32768 then
								retr_inst.output_stream_regular := (1).to_boolean
							end
						end
				when 29 then -- if done
						if ((signal (1, create {CE_ROUTINE}.make_shared (default_pointer + 1))).c_pointer.to_integer_32).to_natural_32 /= (1).to_natural_32 then
							signal (1, redirect_output_signal_address).do_nothing
						end
						signal (10, redirect_output_signal_address).do_nothing
						signal (13, create {CE_ROUTINE}.make_shared (default_pointer + 1)).do_nothing
						signal (28, progress_inst.progress_handle_sigwinch_address).do_nothing
						l_status := 31
						l_t.ce_gets (l_url)
				when 30 then -- loop condition:
						if not (not js.loop_left and then ((l_t.item).c_pointer /= default_pointer)) then
							l_pos := -1 + 49 -- skip loop
						end
				when 31 then -- loop body:
							l_filename.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							l_redirected_URL.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							l_iri.ce_gets (iri_inst.dummy_iri.address)
							l_url_parsed.ce_gets (url_inst.url_parse (l_t.item, create {CE_POINTER [INTEGER_32]}.make_shared ($l_url_err), l_iri, (1).to_boolean))
							if ((l_url_parsed).c_pointer /= default_pointer) then
								l_pos := -1 + 34 -- skip if block
							end
				when 32 then -- if:
							l_error___0.ce_gets ((url_inst.url_error (l_t.item, l_url_err)))
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s.%N"), l_t.item, l_error___0])
							free (create {CE_POINTER [ANY]}.make_cast (l_error___0))
							l_status := 23
				when 33 then -- if block done, skip else block:
							l_pos := -1 + 48
				when 34 then -- else:
							if not (options_inst.opt.recursive) then
								l_pos := -1 + 37 -- skip if block
							end
				when 35 then -- if:
							l_pos := -1 + 38 -- goto _L___1
				when 36 then -- if block done, skip else block:
							l_pos := -1 + 47
				when 37 then -- else:
							if not (options_inst.opt.page_requisites) then
								l_pos := -1 + 46 -- skip if block
							end
				when 38 then -- if: | _L___1:
							if (url_inst.url_scheme (l_t.item)).to_natural_32 = {NATURAL_32} 1 then
								l_pos := -1 + 41 -- skip if block
							end
				when 39 then -- if:
							l_pos := -1 + 42 -- goto _L___0
				when 40 then -- if block done, skip else block:
							l_pos := -1 + 45
				when 41 then -- else:
							if not (retr_inst.url_uses_proxy (l_url_parsed)) then
								l_pos := -1 + 44 -- skip if block
							end
				when 42 then -- if: | _L___0:
							l_old_follow_ftp := (options_inst.opt.follow_ftp).to_integer
							if (url_inst.url_scheme (l_t.item)).to_natural_32 = {NATURAL_32} 1 then
								options_inst.opt.follow_ftp := (1).to_boolean
							end
							l_status := (recur_inst.retrieve_tree (l_url_parsed, create {CE_POINTER [PD_IRI]}.make_shared (default_pointer)))
							options_inst.opt.follow_ftp := l_old_follow_ftp.to_boolean
				when 43 then -- if block done, skip else block:
							l_pos := -1 + 45
				when 44 then -- else:
							l_tmp___32 := retr_inst.retrieve_url (l_url_parsed, l_t.item, l_filename.address, l_redirected_URL.address, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_dt), options_inst.opt.recursive, l_iri, (1).to_boolean)
							l_status := l_tmp___32
				when 45 then -- if done | if done | if block done, skip else block:
							l_pos := -1 + 47
				when 46 then -- else:
							l_tmp___32 := retr_inst.retrieve_url (l_url_parsed, l_t.item, l_filename.address, l_redirected_URL.address, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_dt), options_inst.opt.recursive, l_iri, (1).to_boolean)
							l_status := l_tmp___32
				when 47 then -- if done
							if options_inst.opt.delete_after then
								if (utils_inst.file_exists_p (l_filename)) then
									from
									until
										js.loop_left
									loop
										js.reset
										if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
											log_inst.debug_logprintf ([ce_string ("Removing file due to --delete-after in main():%N")])
										end
										js.break
									end
									js.reset
									log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Removing %%s.%N"))), l_filename])
									if (unlink (l_filename)).to_boolean then
										log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("unlink: %%s%N"), (strerror ((errno_location).item))])
									end
								end
							end
							if ((l_redirected_URL).c_pointer /= default_pointer) then
								free (create {CE_POINTER [ANY]}.make_cast (l_redirected_URL))
							end
							if ((l_filename).c_pointer /= default_pointer) then
								free (create {CE_POINTER [ANY]}.make_cast (l_filename))
							end
							url_inst.url_free (l_url_parsed)
				when 48 then -- if done
							l_t.ce_gets (l_t + 1)
							l_pos := -1 + 30 -- back to loop condition
				when 49 then -- loop done
						if ((options_inst.opt.input_filename).c_pointer /= default_pointer) then
							l_status := (retr_inst.retrieve_from_file (options_inst.opt.input_filename, options_inst.opt.force_html, create {CE_POINTER [INTEGER_32]}.make_shared ($l_count)))
							if not l_count.to_boolean then
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("No URLs found in %%s.%N"))), options_inst.opt.input_filename])
							end
						end
						if options_inst.opt.recursive then
							if options_inst.opt.spider then
								spider_inst.print_broken_links
							end
						end
						if not (options_inst.opt.recursive) then
							l_pos := -1 + 52 -- skip if block
						end
				when 50 then -- if:
							l_pos := -1 + 60 -- goto _L___2
				when 51 then -- if block done, skip else block:
							l_pos := -1 + 61
				when 52 then -- else:
							if not (options_inst.opt.page_requisites) then
								l_pos := -1 + 55 -- skip if block
							end
				when 53 then -- if:
							l_pos := -1 + 60 -- goto _L___2
				when 54 then -- if block done, skip else block:
							l_pos := -1 + 61
				when 55 then -- else:
							if not (l_nurl > 1) then
								l_pos := -1 + 58 -- skip if block
							end
				when 56 then -- if:
							l_pos := -1 + 60 -- goto _L___2
				when 57 then -- if block done, skip else block:
							l_pos := -1 + 61
				when 58 then -- else:
							if (options_inst.opt.input_filename).c_pointer = default_pointer then
								l_pos := -1 + 61 -- skip if block
							end
				when 59 then -- if:
							if retr_inst.total_downloaded_bytes = {INTEGER_64} 0 then
								l_pos := -1 + 61 -- skip if block
							end
				when 60 then -- if: | _L___2:
							if retr_inst.total_downloaded_bytes /= {INTEGER_64} 0 then
								l_tmp___43.ce_gets (retr_inst.retr_rate (retr_inst.total_downloaded_bytes, retr_inst.total_download_time))
								l_tmp___44.ce_gets (secs_to_human_time (retr_inst.total_download_time))
								l_tmp___45.ce_gets (utils_inst.human_readable (retr_inst.total_downloaded_bytes))
								l_tmp___47.ce_gets (utils_inst.datetime_str ((time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))))
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("FINISHED --%%s--%NDownloaded: %%d files, %%s in %%s (%%s)%N"))), l_tmp___47, numurls, l_tmp___45, l_tmp___44, l_tmp___43])
								if (options_inst.opt.quota).to_boolean then
									if retr_inst.total_downloaded_bytes > options_inst.opt.quota then
										l_tmp___49.ce_gets (utils_inst.human_readable (options_inst.opt.quota))
										log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Download quota of %%s EXCEEDED!%N"))), l_tmp___49])
									end
								end
							end
				when 61 then -- if done | if done | if done | if done
							if ((options_inst.opt.cookies_output).c_pointer /= default_pointer) then
								http_inst.save_cookies
							end
							if options_inst.opt.convert_links then
								if not options_inst.opt.delete_after then
									convert_inst.convert_all_links
								end
							end
							log_inst.log_close
							l_i := 0
							from
							until
								not (l_i < l_nurl)
							loop
								free (create {CE_POINTER [ANY]}.make_cast (l_url[l_i]))
								l_i := l_i + 1
							end
							init_inst.cleanup
							Result := (exits_inst.get_exit_status)
				when 62 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	redirect_output_signal (a_sig: INTEGER_32)
		local
			l_signal_name: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
		do
			create l_signal_name.make
			create l_tmp.make
			create l_tmp___0.make

			if a_sig = 1 then
				l_tmp___0.ce_gets (ce_string ("SIGHUP"))
			else
				if a_sig = 10 then
					l_tmp.ce_gets (ce_string ("SIGUSR1"))
				else
					l_tmp.ce_gets (ce_string ("WTF?!"))
				end
				l_tmp___0.ce_gets (l_tmp)
			end
			l_signal_name.ce_gets (l_tmp___0)
			log_inst.log_request_redirect_output (l_signal_name)
			progress_inst.progress_schedule_redirect
			signal (a_sig, redirect_output_signal_address).do_nothing
		end

	redirect_output_signal_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent redirect_output_signal)
		end

end
