class
	P_PROGRESS

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create implementations.make (<<2>>)
			create current_impl.make
			create names.make (<<4>>)
			create eta_str.make (<<9>>)
			create eta_trans.make
			create short_units.make (<<4>>)
			create buf___2.make (<<10>>)
		end

feature {ANY} -- attributes

	implementations: CE_ARRAY [PD_PROGRESS_IMPLEMENTATION]

	current_impl: CE_POINTER [PD_PROGRESS_IMPLEMENTATION]

	current_impl_locked: INTEGER_32 assign set_current_impl_locked

	set_current_impl_locked (a_current_impl_locked: INTEGER_32)
		do
			current_impl_locked := a_current_impl_locked
		end

	output_redirected: INTEGER_32 assign set_output_redirected

	set_output_redirected (a_output_redirected: INTEGER_32)
		do
			output_redirected := a_output_redirected
		end

	names: CE_ARRAY [INTEGER_8]

	screen_width: INTEGER_32 assign set_screen_width

	set_screen_width (a_screen_width: INTEGER_32)
		do
			screen_width := a_screen_width
		end

	received_sigwinch: INTEGER_32 assign set_received_sigwinch

	set_received_sigwinch (a_received_sigwinch: INTEGER_32)
		do
			received_sigwinch := a_received_sigwinch
		end

	eta_str: CE_ARRAY [INTEGER_8]

	eta_trans: CE_POINTER [INTEGER_8]

	bytes_cols_diff: INTEGER_32 assign set_bytes_cols_diff

	set_bytes_cols_diff (a_bytes_cols_diff: INTEGER_32)
		do
			bytes_cols_diff := a_bytes_cols_diff
		end

	short_units: CE_ARRAY [CE_POINTER [INTEGER_8]]

	buf___2: CE_ARRAY [INTEGER_8]

	last: INTEGER_32 assign set_last

	set_last (a_last: INTEGER_32)
		do
			last := a_last
		end

feature {ANY} -- routines

	valid_progress_implementation_p (a_name: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_i: NATURAL_32
			l_pi: CE_POINTER [PD_PROGRESS_IMPLEMENTATION]
			l_colon: CE_POINTER [INTEGER_8]
			l_namelen: NATURAL_32
			l_tmp___1: NATURAL_32
			js: JUMP_STATE
		do
			create l_pi.make
			create l_colon.make

			l_pi.ce_gets (implementations)
			l_colon.ce_gets ((strchr (a_name, (':').code)))
			if ((l_colon).c_pointer /= default_pointer) then
				l_tmp___1 := (l_colon.distance (a_name)).to_natural_32
			else
				l_tmp___1 := (strlen (a_name))
			end
			l_namelen := l_tmp___1
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_left and then (l_i < ({PD_PROGRESS_IMPLEMENTATION}.sizeof.to_natural_32 * (2).to_natural_32) // {PD_PROGRESS_IMPLEMENTATION}.sizeof.to_natural_32))
			loop
				if not (strncmp (l_pi.item.name, a_name, l_namelen)).to_boolean then
					Result := (1).to_boolean
					js.return
				end
				if not js.return_called then
					l_i := l_i + 1
					l_pi.ce_gets (l_pi + 1)
				end
			end
			if not js.return_called then
				Result := (0).to_boolean
			end
		end

	set_progress_implementation (a_name: CE_POINTER [INTEGER_8])
		local
			l_name: CE_POINTER [INTEGER_8]
			l_i: NATURAL_32
			l_namelen: NATURAL_32
			l_pi: CE_POINTER [PD_PROGRESS_IMPLEMENTATION]
			l_colon: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_name.make
			create l_pi.make
			create l_colon.make

			l_name.ce_gets (a_name)
			l_pi.ce_gets (implementations)
			if (l_name).c_pointer = default_pointer then
				l_name.ce_gets (ce_string ("bar"))
			end
			l_colon.ce_gets ((strchr (l_name, (':').code)))
			if ((l_colon).c_pointer /= default_pointer) then
				l_namelen := (l_colon.distance (l_name)).to_natural_32
			else
				l_namelen := (strlen (l_name))
			end
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_left and then (l_i < ({PD_PROGRESS_IMPLEMENTATION}.sizeof.to_natural_32 * (2).to_natural_32) // {PD_PROGRESS_IMPLEMENTATION}.sizeof.to_natural_32))
			loop
				if not (strncmp (l_pi.item.name, l_name, l_namelen)).to_boolean then
					current_impl.ce_gets (l_pi)
					current_impl_locked := 0
					if ((l_colon).c_pointer /= default_pointer) then
						l_colon.ce_gets (l_colon + 1)
					end
					if ((l_pi.item.set_params).c_pointer /= default_pointer) then
						(l_pi.item.set_params).call ([l_colon])
					end
					js.return
				end
				if not js.return_called then
					l_i := l_i + 1
					l_pi.ce_gets (l_pi + 1)
				end
			end
			if not js.return_called then
				abort
			end
		end

	progress_schedule_redirect
		do
			output_redirected := 1
		end

	progress_create (a_initial: INTEGER_64; a_total: INTEGER_64): CE_POINTER [ANY]
		do
			if output_redirected.to_boolean then
				if not current_impl_locked.to_boolean then
					set_progress_implementation (ce_string ("dot"))
				end
				output_redirected := 0
			end
			Result := (create {CE_POINTER [ANY]}.make_cast ((current_impl.item.create2).pointer_item ([a_initial, a_total])))
		end

	progress_interactive_p (a_progress: CE_POINTER [ANY]): BOOLEAN
		do
			Result := (current_impl.item.interactive)
		end

	progress_update (a_progress: CE_POINTER [ANY]; a_howmuch: INTEGER_64; a_dltime: REAL_64)
		do
			(current_impl.item.update).call ([a_progress, a_howmuch, a_dltime])
		end

	progress_finish (a_progress: CE_POINTER [ANY]; a_dltime: REAL_64)
		do
			(current_impl.item.finish).call ([a_progress, a_dltime])
		end

	dot_create (a_initial: INTEGER_64; a_total: INTEGER_64): CE_POINTER [ANY]
		local
			l_dp: CE_POINTER [PD_DOT_PROGRESS]
			l_dot_bytes: INTEGER_32
			l_ROW_BYTES: INTEGER_64
			l_remainder: INTEGER_32
			l_skipped: INTEGER_64
			l_skipped_k: INTEGER_64
			l_skipped_k_len: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_8]
		do
			create l_dp.make
			create l_tmp___1.make

			l_dp.ce_gets (create {CE_POINTER [PD_DOT_PROGRESS]}.make_cast ((xmalloc_inst.xcalloc ((1).to_natural_32, {PD_DOT_PROGRESS}.sizeof.to_natural_32))))
			l_dp.item.initial_length := a_initial
			l_dp.item.total_length := a_total
			if (l_dp.item.initial_length).to_boolean then
				l_dot_bytes := (options_inst.opt.dot_bytes).to_integer_32
				l_ROW_BYTES := options_inst.opt.dot_bytes * (options_inst.opt.dots_in_line).to_integer_64
				l_remainder := (l_dp.item.initial_length \\ l_ROW_BYTES).to_integer_32
				l_skipped := l_dp.item.initial_length - l_remainder.to_integer_64
				if l_skipped.to_boolean then
					l_skipped_k := l_skipped // {INTEGER_64} 1024
					l_skipped_k_len := (utils_inst.numdigit (l_skipped_k))
					if l_skipped_k_len < 6 then
						l_skipped_k_len := 6
					end
					l_tmp___1.ce_gets (utils_inst.number_to_static_string (l_skipped_k))
					log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("%N%%*s[ skipping %%sK ]"))), 2 + l_skipped_k_len, ce_string (""), l_tmp___1])
				end
				log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N%%6sK"), (utils_inst.number_to_static_string (l_skipped // {INTEGER_64} 1024))])
				from
				until
					not (l_remainder >= l_dot_bytes)
				loop
					if l_dp.item.dots \\ options_inst.opt.dot_spacing = 0 then
						log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string (" "))
					end
					log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string (","))
					l_dp.item.dots := (l_dp.item.dots) + 1
					l_remainder := l_remainder - l_dot_bytes
				end
				if not (l_dp.item.dots < options_inst.opt.dots_in_line) then
					assert_fail (ce_string ("dp->dots < opt.dots_in_line"), ce_string ("progress.c"), {NATURAL_32} 256, ce_string ("dot_create"))
				end
				l_dp.item.accumulated := l_remainder
				l_dp.item.rows := (l_skipped // l_ROW_BYTES).to_integer_32
			end
			Result := (create {CE_POINTER [ANY]}.make_cast (l_dp))
		end

	dot_create_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dot_create)
		end

	print_row_stats (a_dp: CE_POINTER [PD_DOT_PROGRESS]; a_dltime: REAL_64; a_last___0: BOOLEAN)
		local
			l_ROW_BYTES: INTEGER_64
			l_bytes_displayed: INTEGER_64
			l_percentage: INTEGER_32
			l_units: INTEGER_32
			l_rate: REAL_64
			l_bytes_this_row: INTEGER_64
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_bytes_remaining: INTEGER_64
			l_bytes_sofar: INTEGER_64
			l_eta: REAL_64
		do
			l_ROW_BYTES := options_inst.opt.dot_bytes * (options_inst.opt.dots_in_line).to_integer_64
			l_bytes_displayed := (a_dp.item.rows).to_integer_64 * l_ROW_BYTES + (a_dp.item.dots).to_integer_64 * options_inst.opt.dot_bytes
			if a_last___0 then
				l_bytes_displayed := l_bytes_displayed + (a_dp.item.accumulated).to_integer_64
			end
			if (a_dp.item.total_length).to_boolean then
				l_percentage := ((100.0 * l_bytes_displayed.to_double) / (a_dp.item.total_length).to_double).truncated_to_integer
				log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%%3d%%%%"), l_percentage])
			end
			if not a_last___0 then
				l_bytes_this_row := l_ROW_BYTES
			else
				l_bytes_this_row := (a_dp.item.dots).to_integer_64 * options_inst.opt.dot_bytes + (a_dp.item.accumulated).to_integer_64
			end
			if (a_dp.item.rows).to_integer_64 = a_dp.item.initial_length // l_ROW_BYTES then
				l_bytes_this_row := l_bytes_this_row - (a_dp.item.initial_length \\ l_ROW_BYTES)
			end
			l_rate := retr_inst.calc_rate (l_bytes_this_row, a_dltime - a_dp.item.last_timer_value, create {CE_POINTER [INTEGER_32]}.make_shared ($l_units))
			if l_rate >= 99.95 then
				l_tmp___0 := 0
			else
				if l_rate >= 9.995 then
					l_tmp := 1
				else
					l_tmp := 2
				end
				l_tmp___0 := l_tmp
			end
			log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string (" %%4.*f%%c"), l_tmp___0, l_rate, (names[l_units]).to_integer_32])
			a_dp.item.last_timer_value := a_dltime
			if not a_last___0 then
				if (a_dp.item.total_length).to_boolean then
					l_bytes_remaining := a_dp.item.total_length - l_bytes_displayed
					l_bytes_sofar := l_bytes_displayed - a_dp.item.initial_length
					l_eta := (a_dltime * l_bytes_remaining.to_double) / l_bytes_sofar.to_double
					if l_eta < (2147483646).to_double then
						log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string (" %%s"), (eta_to_human_short ((l_eta + 0.5).truncated_to_integer, (1).to_boolean))])
					end
				end
			elseif a_dltime >= (10).to_double then
				log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("=%%s"), (eta_to_human_short ((a_dltime + 0.5).truncated_to_integer, (1).to_boolean))])
			else
				log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("=%%ss"), (utils_inst.print_decimal (a_dltime))])
			end
		end

	dot_update (a_progress: CE_POINTER [ANY]; a_howmuch: INTEGER_64; a_dltime: REAL_64)
		local
			l_dp: CE_POINTER [PD_DOT_PROGRESS]
			l_dot_bytes: INTEGER_32
			l_ROW_BYTES: INTEGER_64
		do
			create l_dp.make

			l_dp.ce_gets (create {CE_POINTER [PD_DOT_PROGRESS]}.make_cast (a_progress))
			l_dot_bytes := (options_inst.opt.dot_bytes).to_integer_32
			l_ROW_BYTES := options_inst.opt.dot_bytes * (options_inst.opt.dots_in_line).to_integer_64
			log_inst.log_set_flush ((0).to_boolean)
			l_dp.item.accumulated := ((l_dp.item.accumulated).to_integer_64 + a_howmuch).to_integer_32
			from
			until
				not (l_dp.item.accumulated >= l_dot_bytes)
			loop
				if l_dp.item.dots = 0 then
					log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N%%6sK"), (utils_inst.number_to_static_string (((l_dp.item.rows).to_integer_64 * l_ROW_BYTES) // {INTEGER_64} 1024))])
				end
				if l_dp.item.dots \\ options_inst.opt.dot_spacing = 0 then
					log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string (" "))
				end
				log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("."))
				l_dp.item.dots := (l_dp.item.dots) + 1
				if l_dp.item.dots >= options_inst.opt.dots_in_line then
					l_dp.item.rows := (l_dp.item.rows) + 1
					l_dp.item.dots := 0
					print_row_stats (l_dp, a_dltime, (0).to_boolean)
				end
				l_dp.item.accumulated := l_dp.item.accumulated - l_dot_bytes
			end
			log_inst.log_set_flush ((1).to_boolean)
		end

	dot_update_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dot_update)
		end

	dot_finish (a_progress: CE_POINTER [ANY]; a_dltime: REAL_64)
		local
			l_dp: CE_POINTER [PD_DOT_PROGRESS]
			l_ROW_BYTES: INTEGER_64
			l_i: INTEGER_32
		do
			create l_dp.make

			l_dp.ce_gets (create {CE_POINTER [PD_DOT_PROGRESS]}.make_cast (a_progress))
			l_ROW_BYTES := options_inst.opt.dot_bytes * (options_inst.opt.dots_in_line).to_integer_64
			log_inst.log_set_flush ((0).to_boolean)
			if l_dp.item.dots = 0 then
				log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N%%6sK"), (utils_inst.number_to_static_string (((l_dp.item.rows).to_integer_64 * l_ROW_BYTES) // {INTEGER_64} 1024))])
			end
			l_i := l_dp.item.dots
			from
			until
				not (l_i < options_inst.opt.dots_in_line)
			loop
				if l_i \\ options_inst.opt.dot_spacing = 0 then
					log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string (" "))
				end
				log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string (" "))
				l_i := l_i + 1
			end
			print_row_stats (l_dp, a_dltime, (1).to_boolean)
			log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N%N"))
			log_inst.log_set_flush ((0).to_boolean)
			free (create {CE_POINTER [ANY]}.make_cast (l_dp))
		end

	dot_finish_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dot_finish)
		end

	dot_set_params (a_params: CE_POINTER [INTEGER_8])
		local
			l_params: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_params.make
			create l_tmp.make

			l_params.ce_gets (a_params)
			if (l_params).c_pointer = default_pointer then
				l_params.ce_gets (options_inst.opt.dot_style)
			elseif not (l_params[0]).to_boolean then
				l_params.ce_gets (options_inst.opt.dot_style)
			end
			if (l_params).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				if (strcasecmp (l_params, ce_string ("default"))).to_boolean then
					if (strcasecmp (l_params, ce_string ("binary"))).to_boolean then
						if (strcasecmp (l_params, ce_string ("mega"))).to_boolean then
							if (strcasecmp (l_params, ce_string ("giga"))).to_boolean then
								l_tmp.ce_gets (quote_inst.quote (l_params))
								fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("Invalid dot style specification %%s; leaving unchanged.%N"))), l_tmp]).do_nothing
							else
								options_inst.opt.dot_bytes := ((1).bit_shift_left (20)).to_integer_64
								options_inst.opt.dot_spacing := 8
								options_inst.opt.dots_in_line := 32
							end
						else
							options_inst.opt.dot_bytes := (65536).to_integer_64
							options_inst.opt.dot_spacing := 8
							options_inst.opt.dots_in_line := 48
						end
					else
						options_inst.opt.dot_bytes := (8192).to_integer_64
						options_inst.opt.dot_spacing := 16
						options_inst.opt.dots_in_line := 48
					end
				else
					options_inst.opt.dot_bytes := (1024).to_integer_64
					options_inst.opt.dot_spacing := 10
					options_inst.opt.dots_in_line := 50
				end
			end
		end

	dot_set_params_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dot_set_params)
		end

	bar_create (a_initial: INTEGER_64; a_total: INTEGER_64): CE_POINTER [ANY]
		local
			l_total: INTEGER_64
			l_bp: CE_POINTER [PD_BAR_PROGRESS]
			l_pos: INTEGER_32
		do
			create l_bp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_total := a_total
					l_bp.ce_gets (create {CE_POINTER [PD_BAR_PROGRESS]}.make_cast ((xmalloc_inst.xcalloc ((1).to_natural_32, {PD_BAR_PROGRESS}.sizeof.to_natural_32))))
					if a_initial > l_total then
						l_total := a_initial
					end
					l_bp.item.initial_length := a_initial
					l_bp.item.total_length := l_total
					if screen_width.to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (received_sigwinch.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						screen_width := utils_inst.determine_screen_width
						if not screen_width.to_boolean then
							screen_width := 80
						elseif screen_width < 45 then
							screen_width := 45
						end
						received_sigwinch := 0
				when 5 then -- if done
						l_bp.item.width := screen_width - 1
						l_bp.item.buffer := create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc ((l_bp.item.width + 100).to_natural_32)))
						log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
						create_image (l_bp, (0).to_double, (0).to_boolean)
						display_image (l_bp.item.buffer)
						Result := (create {CE_POINTER [ANY]}.make_cast (l_bp))
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	bar_create_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent bar_create)
		end

	bar_update (a_progress: CE_POINTER [ANY]; a_howmuch: INTEGER_64; a_dltime: REAL_64)
		local
			l_bp: CE_POINTER [PD_BAR_PROGRESS]
			l_force_screen_update: BOOLEAN
			l_old_width: INTEGER_32
			js: JUMP_STATE
		do
			create l_bp.make

			l_bp.ce_gets (create {CE_POINTER [PD_BAR_PROGRESS]}.make_cast (a_progress))
			l_force_screen_update := (0).to_boolean
			l_bp.item.count := l_bp.item.count + a_howmuch
			if l_bp.item.total_length > {INTEGER_64} 0 then
				if l_bp.item.count + l_bp.item.initial_length > l_bp.item.total_length then
					l_bp.item.total_length := l_bp.item.initial_length + l_bp.item.count
				end
			end
			update_speed_ring (l_bp, a_howmuch, a_dltime)
			if received_sigwinch.to_boolean then
				l_old_width := screen_width
				screen_width := utils_inst.determine_screen_width
				if not screen_width.to_boolean then
					screen_width := 80
				elseif screen_width < 45 then
					screen_width := 45
				end
				if screen_width /= l_old_width then
					l_bp.item.width := screen_width - 1
					l_bp.item.buffer := create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (l_bp.item.buffer), (l_bp.item.width + 100).to_natural_32)))
					l_force_screen_update := (1).to_boolean
				end
				received_sigwinch := 0
			end
			if a_dltime - l_bp.item.last_screen_update < 0.2 then
				if not l_force_screen_update then
					js.return
				end
			end
			if not js.return_called then
				create_image (l_bp, a_dltime, (0).to_boolean)
				display_image (l_bp.item.buffer)
				l_bp.item.last_screen_update := a_dltime
			end
		end

	bar_update_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent bar_update)
		end

	bar_finish (a_progress: CE_POINTER [ANY]; a_dltime: REAL_64)
		local
			l_bp: CE_POINTER [PD_BAR_PROGRESS]
		do
			create l_bp.make

			l_bp.ce_gets (create {CE_POINTER [PD_BAR_PROGRESS]}.make_cast (a_progress))
			if l_bp.item.total_length > {INTEGER_64} 0 then
				if l_bp.item.count + l_bp.item.initial_length > l_bp.item.total_length then
					l_bp.item.total_length := l_bp.item.initial_length + l_bp.item.count
				end
			end
			create_image (l_bp, a_dltime, (1).to_boolean)
			display_image (l_bp.item.buffer)
			log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N%N"))
			free (create {CE_POINTER [ANY]}.make_cast (l_bp.item.buffer))
			free (create {CE_POINTER [ANY]}.make_cast (l_bp))
		end

	bar_finish_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent bar_finish)
		end

	update_speed_ring (a_bp: CE_POINTER [PD_BAR_PROGRESS]; a_howmuch: INTEGER_64; a_dltime: REAL_64)
		local
			l_hist: CE_POINTER [PD_BAR_PROGRESS_HIST]
			l_recent_age: REAL_64
			js: JUMP_STATE
		do
			create l_hist.make

			l_hist.ce_gets (create {CE_POINTER [PD_BAR_PROGRESS_HIST]}.make_shared (a_bp.c_pointer + {PD_BAR_PROGRESS}.hist_offset))
			l_recent_age := a_dltime - a_bp.item.recent_start
			a_bp.item.recent_bytes := a_bp.item.recent_bytes + a_howmuch
			if l_recent_age < 0.15 then
				js.return
			end
			if not js.return_called and then (a_howmuch = {INTEGER_64} 0) then
				if l_recent_age >= (5).to_double then
					a_bp.item.stalled := (1).to_boolean
					memset (create {CE_POINTER [ANY]}.make_cast (l_hist), ('%/0/').code, {PD_BAR_PROGRESS_HIST}.sizeof.to_natural_32).do_nothing
					a_bp.item.recent_bytes := (0).to_integer_64
				end
				js.return
			end
			if not js.return_called then
				if a_bp.item.stalled then
					a_bp.item.stalled := (0).to_boolean
					l_recent_age := (1).to_double
				end
				l_hist.item.total_time := l_hist.item.total_time - (l_hist.item.times[l_hist.item.pos])
				l_hist.item.total_bytes := l_hist.item.total_bytes - (l_hist.item.bytes[l_hist.item.pos])
				l_hist.item.times[l_hist.item.pos] := l_recent_age
				l_hist.item.bytes[l_hist.item.pos] := a_bp.item.recent_bytes
				l_hist.item.total_time := l_hist.item.total_time + l_recent_age
				l_hist.item.total_bytes := l_hist.item.total_bytes + (a_bp.item.recent_bytes)
				a_bp.item.recent_start := a_dltime
				a_bp.item.recent_bytes := (0).to_integer_64
				l_hist.item.pos := (l_hist.item.pos) + 1
				if l_hist.item.pos = 20 then
					l_hist.item.pos := 0
				end
			end
		end

	count_cols (a_mbs: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_mbs: CE_POINTER [INTEGER_8]
			l_wc: INTEGER_32
			l_bytes: INTEGER_32
			l_remaining: INTEGER_32
			l_cols: INTEGER_32
			l_wccols: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_mbs.make

			l_mbs.ce_gets (a_mbs)
			l_remaining := (strlen (l_mbs)).to_integer_32
			l_cols := 0
			from
			until
				not (not js.loop_left and then ((l_mbs[0]).to_integer_32 /= 0))
			loop
				l_bytes := mbtowc ((create {CE_POINTER [INTEGER_32]}.make_shared ($l_wc)), l_mbs, l_remaining.to_natural_32)
				if l_bytes = 0 then
					assert_fail (ce_string ("bytes != 0"), ce_string ("progress.c"), {NATURAL_32} 783, ce_string ("count_cols"))
				end
				if l_bytes = -1 then
					Result := (l_cols + l_remaining)
					js.return
				end
				if not js.return_called then
					l_mbs.ce_gets (l_mbs + l_bytes)
					l_remaining := l_remaining - l_bytes
					l_wccols := wcwidth (l_wc)
					if l_wccols = -1 then
						l_tmp___0 := 1
					else
						l_tmp___0 := l_wccols
					end
					l_cols := l_cols + l_tmp___0
				end
			end
			if not js.return_called then
				Result := l_cols
			end
		end

	get_eta (a_bcd: CE_POINTER [INTEGER_32]): CE_POINTER [INTEGER_8]
		local
			l_nbytes: INTEGER_32
			l_ncols: INTEGER_32
		do
			if (eta_trans.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				eta_trans.ce_gets ((gettext (eta_str)))
				l_nbytes := (strlen (eta_trans)).to_integer_32
				l_ncols := count_cols (eta_trans)
				bytes_cols_diff := l_nbytes - l_ncols
			end
			if (a_bcd.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				a_bcd.item := bytes_cols_diff
			end
			Result := eta_trans
		end

	create_image (a_bp: CE_POINTER [PD_BAR_PROGRESS]; a_dl_total_time: REAL_64; a_done: BOOLEAN)
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_size: INTEGER_64
			l_size_grouped: CE_POINTER [INTEGER_8]
			l_size_grouped_len: INTEGER_32
			l_size_grouped_diff: INTEGER_32
			l_size_grouped_pad: INTEGER_32
			l_hist: CE_POINTER [PD_BAR_PROGRESS_HIST]
			l_dlbytes_size: INTEGER_32
			l_tmp___2: INTEGER_32
			l_progress_size: INTEGER_32
			l_bytes_cols_diff___0: INTEGER_32
			l_percentage: INTEGER_32
			l_insz: INTEGER_32
			l_dlsz: INTEGER_32
			l_begin: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_ind: INTEGER_32
			l_i___0: INTEGER_32
			l_pos2: INTEGER_32
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: CE_POINTER [INTEGER_8]
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_units: INTEGER_32
			l_dlquant: INTEGER_64
			l_dltime: REAL_64
			l_dlspeed: REAL_64
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_eta: INTEGER_32
			l_bytes_remaining: INTEGER_64
			l_eta_: REAL_64
			l_tmp___19: CE_POINTER [INTEGER_8]
			l_nbytes: INTEGER_32
			l_ncols: INTEGER_32
			l_tmp___25: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_size_grouped.make
			create l_hist.make
			create l_begin.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___7.make
			create l_tmp___8.make
			create l_tmp___9.make
			create l_tmp___10.make
			create l_tmp___11.make
			create l_tmp___12.make
			create l_tmp___13.make
			create l_tmp___14.make
			create l_tmp___15.make
			create l_tmp___19.make
			create l_tmp___25.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (a_bp.item.buffer)
					l_size := a_bp.item.initial_length + a_bp.item.count
					l_size_grouped.ce_gets ((utils_inst.with_thousand_seps (l_size)))
					l_size_grouped_len := (count_cols (l_size_grouped))
					l_size_grouped_diff := ((strlen (l_size_grouped)) - l_size_grouped_len.to_natural_32).to_integer_32
					l_hist.ce_gets (create {CE_POINTER [PD_BAR_PROGRESS_HIST]}.make_shared (a_bp.c_pointer + {PD_BAR_PROGRESS}.hist_offset))
					if l_size_grouped_len >= 11 then
						l_tmp___2 := l_size_grouped_len
					else
						l_tmp___2 := 11
					end
					l_dlbytes_size := 1 + l_tmp___2
					l_progress_size := a_bp.item.width - (((6 + l_dlbytes_size) + 8) + 14)
					l_bytes_cols_diff___0 := 0
					if l_progress_size < 5 then
						l_progress_size := 0
					end
					if a_bp.item.total_length > {INTEGER_64} 0 then
						l_percentage := ((100.0 * l_size.to_double) / (a_bp.item.total_length).to_double).truncated_to_integer
						if not (l_percentage <= 100) then
							assert_fail (ce_string ("percentage <= 100"), ce_string ("progress.c"), {NATURAL_32} 897, ce_string ("create_image"))
						end
						if l_percentage < 100 then
							sprintf ([l_p___0, ce_string ("%%2d%%%% "), l_percentage]).do_nothing
						else
							strcpy (l_p___0, ce_string ("100%%")).do_nothing
						end
						l_p___0.ce_gets (l_p___0 + (4))
					else
						from
						until
							js.loop_left
						loop
							js.reset
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (ce_string ("    ")), (("    ").count + 1).to_natural_32 - {NATURAL_32} 1).do_nothing
							l_p___0.ce_gets (l_p___0 + ((("    ").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32)
							js.break
						end
						js.reset
					end
					if not (l_progress_size.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_bp.item.total_length > {INTEGER_64} 0 then
							l_insz := (((a_bp.item.initial_length).to_double / (a_bp.item.total_length).to_double) * l_progress_size.to_double).truncated_to_integer
							l_dlsz := ((l_size.to_double / (a_bp.item.total_length).to_double) * l_progress_size.to_double).truncated_to_integer
							if not (l_dlsz <= l_progress_size) then
								assert_fail (ce_string ("dlsz <= progress_size"), ce_string ("progress.c"), {NATURAL_32} 920, ce_string ("create_image"))
							end
							if not (l_insz <= l_dlsz) then
								assert_fail (ce_string ("insz <= dlsz"), ce_string ("progress.c"), {NATURAL_32} 921, ce_string ("create_image"))
							end
							l_tmp___3.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___3[0] := (('[').code).to_integer_8
							l_begin.ce_gets (l_p___0)
							l_i := 0
							from
							until
								not (l_i < l_insz)
							loop
								l_tmp___4.ce_gets (l_p___0)
								l_p___0.ce_gets (l_p___0 + 1)
								l_tmp___4[0] := (('+').code).to_integer_8
								l_i := l_i + 1
							end
							l_dlsz := l_dlsz - l_insz
							if l_dlsz > 0 then
								l_i := 0
								from
								until
									not (l_i < l_dlsz - 1)
								loop
									l_tmp___5.ce_gets (l_p___0)
									l_p___0.ce_gets (l_p___0 + 1)
									l_tmp___5[0] := (('=').code).to_integer_8
									l_i := l_i + 1
								end
								l_tmp___6.ce_gets (l_p___0)
								l_p___0.ce_gets (l_p___0 + 1)
								l_tmp___6[0] := (('>').code).to_integer_8
							end
							from
							until
								not (l_p___0.distance (l_begin) < l_progress_size)
							loop
								l_tmp___7.ce_gets (l_p___0)
								l_p___0.ce_gets (l_p___0 + 1)
								l_tmp___7[0] := ((' ').code).to_integer_8
							end
							l_tmp___8.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___8[0] := ((']').code).to_integer_8
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if l_progress_size.to_boolean then
							l_ind := a_bp.item.tick \\ (l_progress_size * 2 - 6)
							if l_ind < l_progress_size - 2 then
								l_pos2 := l_ind + 1
							else
								l_pos2 := l_progress_size - ((l_ind - l_progress_size) + 5)
							end
							l_tmp___9.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___9[0] := (('[').code).to_integer_8
							l_i___0 := 0
							from
							until
								not (l_i___0 < l_progress_size)
							loop
								if l_i___0 = l_pos2 - 1 then
									l_tmp___10.ce_gets (l_p___0)
									l_p___0.ce_gets (l_p___0 + 1)
									l_tmp___10[0] := (('<').code).to_integer_8
								elseif l_i___0 = l_pos2 then
									l_tmp___11.ce_gets (l_p___0)
									l_p___0.ce_gets (l_p___0 + 1)
									l_tmp___11[0] := (('=').code).to_integer_8
								elseif l_i___0 = l_pos2 + 1 then
									l_tmp___12.ce_gets (l_p___0)
									l_p___0.ce_gets (l_p___0 + 1)
									l_tmp___12[0] := (('>').code).to_integer_8
								else
									l_tmp___13.ce_gets (l_p___0)
									l_p___0.ce_gets (l_p___0 + 1)
									l_tmp___13[0] := ((' ').code).to_integer_8
								end
								l_i___0 := l_i___0 + 1
							end
							l_tmp___14.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___14[0] := ((']').code).to_integer_8
							a_bp.item.tick := (a_bp.item.tick) + 1
						end
				when 4 then
					sprintf ([l_p___0, ce_string (" %%s"), l_size_grouped]).do_nothing
					l_p___0.ce_gets (strchr (l_p___0, ('%/0/').code))
					l_size_grouped_pad := 11 - l_size_grouped_len
					from
					until
						not (l_size_grouped_pad > 0)
					loop
						l_tmp___15.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___15[0] := ((' ').code).to_integer_8
						l_size_grouped_pad := l_size_grouped_pad - 1
					end
					if not (l_hist.item.total_time > (0).to_double) then
						l_pos := -1 + 7 -- skip if block
					end
				when 5 then -- if:
						if (l_hist.item.total_bytes).to_boolean then
							l_units := 0
							l_dlquant := l_hist.item.total_bytes + a_bp.item.recent_bytes
							l_dltime := l_hist.item.total_time + (a_dl_total_time - a_bp.item.recent_start)
							l_dlspeed := (retr_inst.calc_rate (l_dlquant, l_dltime, create {CE_POINTER [INTEGER_32]}.make_shared ($l_units)))
							if l_dlspeed >= 99.95 then
								l_tmp___18 := 0
							else
								if l_dlspeed >= 9.995 then
									l_tmp___17 := 1
								else
									l_tmp___17 := 2
								end
								l_tmp___18 := l_tmp___17
							end
							sprintf ([l_p___0, ce_string (" %%4.*f%%s"), l_tmp___18, l_dlspeed, short_units[l_units]]).do_nothing
							l_p___0.ce_gets (strchr (l_p___0, ('%/0/').code))
						else
							l_pos := -1 + 7 -- goto _L___0
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (ce_string (" --.-K/s")), ((" --.-K/s").count + 1).to_natural_32 - {NATURAL_32} 1).do_nothing
							l_p___0.ce_gets (l_p___0 + (((" --.-K/s").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32)
							js.break
						end
						js.reset
				when 8 then
					if a_done then
						l_pos := -1 + 26 -- skip if block
					end
				when 9 then -- if:
						if not (a_bp.item.total_length > {INTEGER_64} 0) then
							l_pos := -1 + 23 -- skip if block
						end
				when 10 then -- if:
						if not (a_bp.item.count > {INTEGER_64} 0) then
							l_pos := -1 + 21 -- skip if block
						end
				when 11 then -- if:
						if not (a_dl_total_time > (3).to_double) then
							l_pos := -1 + 19 -- skip if block
						end
				when 12 then -- if:
						if a_bp.item.total_length = l_size then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if a_bp.item.last_eta_value /= 0 then
							if a_dl_total_time - a_bp.item.last_eta_time < 0.99 then
								l_eta := a_bp.item.last_eta_value
							else
								l_pos := -1 + 15 -- goto _L___2
							end
						else
							l_pos := -1 + 15 -- goto _L___2
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 15 then -- else: | _L___2:
						l_bytes_remaining := a_bp.item.total_length - l_size
						l_eta_ := (a_dl_total_time * l_bytes_remaining.to_double) / (a_bp.item.count).to_double
						if l_eta_ >= (2147483646).to_double then
							l_pos := -1 + 24 -- goto skip_eta
						end
				when 16 then
						l_eta := (l_eta_ + 0.5).truncated_to_integer
						a_bp.item.last_eta_value := l_eta
						a_bp.item.last_eta_time := a_dl_total_time
				when 17 then
						l_tmp___19.ce_gets (eta_to_human_short (l_eta, (0).to_boolean))
						sprintf ([l_p___0, (get_eta (create {CE_POINTER [INTEGER_32]}.make_shared ($l_bytes_cols_diff___0))), l_tmp___19]).do_nothing
						l_p___0.ce_gets (strchr (l_p___0, ('%/0/').code))
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:
						l_pos := -1 + 23 -- goto _L___4
				when 20 then -- if done | if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						l_pos := -1 + 23 -- goto _L___4
				when 22 then -- if done | if block done, skip else block:
						l_pos := -1 + 25
				when 23 then -- else: | _L___4:
						if not (a_bp.item.total_length > {INTEGER_64} 0) then
							l_pos := -1 + 25 -- skip if block
						end
				when 24 then -- if: | skip_eta:
						from
						until
							js.loop_left
						loop
							js.reset
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (ce_string ("             ")), (("             ").count + 1).to_natural_32 - {NATURAL_32} 1).do_nothing
							l_p___0.ce_gets (l_p___0 + ((("             ").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32)
							js.break
						end
						js.reset
				when 25 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						strcpy (l_p___0, (gettext (ce_string ("   in ")))).do_nothing
						l_nbytes := (strlen (l_p___0)).to_integer_32
						l_ncols := count_cols (l_p___0)
						l_bytes_cols_diff___0 := l_nbytes - l_ncols
						l_p___0.ce_gets (l_p___0 + l_nbytes)
						if a_dl_total_time >= (10).to_double then
							strcpy (l_p___0, (eta_to_human_short ((a_dl_total_time + 0.5).truncated_to_integer, (0).to_boolean))).do_nothing
						else
							sprintf ([l_p___0, ce_string ("%%ss"), (utils_inst.print_decimal (a_dl_total_time))]).do_nothing
						end
						l_p___0.ce_gets (strchr (l_p___0, ('%/0/').code))
				when 27 then
					from
					until
						not (((l_p___0.distance ((a_bp.item.buffer))) - l_bytes_cols_diff___0) - l_size_grouped_diff < a_bp.item.width)
					loop
						l_tmp___25.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___25[0] := ((' ').code).to_integer_8
					end
					l_p___0[0] := (('%/0/').code).to_integer_8
				when 28 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	display_image (a_buf___6: CE_POINTER [INTEGER_8])
		local
			l_old: BOOLEAN
		do
			l_old := (log_inst.log_set_save_context ((0).to_boolean))
			log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%R"))
			log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, a_buf___6)
			log_inst.log_set_save_context (l_old).do_nothing
		end

	bar_set_params (a_params: CE_POINTER [INTEGER_8])
		local
			l_term: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_term.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_term.ce_gets ((getenv (ce_string ("TERM"))))
					if ((a_params).c_pointer /= default_pointer) then
						if 0 = (strcmp (a_params, ce_string ("force"))) then
							current_impl_locked := 1
						end
					end
					if (options_inst.opt.lfilename).c_pointer = default_pointer then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 3 then -- else:
						if not ((isatty ((fileno ((create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)))))).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 4 then -- if:
						if (l_term).c_pointer = default_pointer then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if 0 /= (strcmp (l_term, ce_string ("emacs"))) then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						if not current_impl_locked.to_boolean then
							set_progress_implementation (ce_string ("dot"))
							js.return
						end
				when 7 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_pos := -1 + 6 -- goto _L
				when 9 then -- if done
						if not js.return_called then
						end
				when 10 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	bar_set_params_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent bar_set_params)
		end

	progress_handle_sigwinch (a_sig: INTEGER_32)
		do
			received_sigwinch := 1
			signal (28, progress_handle_sigwinch_address).do_nothing
		end

	progress_handle_sigwinch_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent progress_handle_sigwinch)
		end

	eta_to_human_short (a_secs: INTEGER_32; a_condensed: BOOLEAN): CE_POINTER [INTEGER_8]
		local
			l_space: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_space.make
			create l_tmp.make

			if a_condensed then
				l_tmp.ce_gets (ce_string (""))
			else
				l_tmp.ce_gets (ce_string (" "))
			end
			l_space.ce_gets (l_tmp)
			if a_secs = last then
				Result := buf___2
				js.return
			end
			if not js.return_called then
				last := a_secs
				if a_secs < 100 then
					sprintf ([buf___2, ce_string ("%%ds"), a_secs]).do_nothing
				elseif a_secs < 6000 then
					sprintf ([buf___2, ce_string ("%%dm%%s%%ds"), a_secs // 60, l_space, a_secs \\ 60]).do_nothing
				elseif a_secs < 172800 then
					sprintf ([buf___2, ce_string ("%%dh%%s%%dm"), a_secs // 3600, l_space, (a_secs // 60) \\ 60]).do_nothing
				elseif a_secs < 8640000 then
					sprintf ([buf___2, ce_string ("%%dd%%s%%dh"), a_secs // 86400, l_space, (a_secs // 3600) \\ 24]).do_nothing
				else
					sprintf ([buf___2, ce_string ("%%dd"), a_secs // 86400]).do_nothing
				end
				Result := buf___2
			end
		end

end
