class
	P_QUOTEARG

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create quoting_style_args.make (<<9>>)
			create quoting_style_vals.make (<<8>>)
			create default_quoting_options.make
			create slot0.make (<<256>>)
			create slotvec0.make
			create slotvec.make
		end

feature {ANY} -- attributes

	quoting_style_args: CE_ARRAY [CE_POINTER [INTEGER_8]]

	quoting_style_vals: CE_ARRAY [INTEGER_32]

	default_quoting_options: PD_QUOTING_OPTIONS

	slot0: CE_ARRAY [INTEGER_8]

	nslots: NATURAL_32 assign set_nslots

	set_nslots (a_nslots: NATURAL_32)
		do
			nslots := a_nslots
		end

	slotvec0: PD_SLOTVEC

	slotvec: CE_POINTER [PD_SLOTVEC]

feature {ANY} -- routines

	clone_quoting_options (a_o: CE_POINTER [PD_QUOTING_OPTIONS]): CE_POINTER [PD_QUOTING_OPTIONS]
		local
			l_e: INTEGER_32
			l_p___0: CE_POINTER [PD_QUOTING_OPTIONS]
			l_tmp___0: CE_POINTER [PD_QUOTING_OPTIONS]
		do
			create l_p___0.make
			create l_tmp___0.make

			l_e := (errno_location).item
			if ((a_o).c_pointer /= default_pointer) then
				l_tmp___0.ce_gets (a_o)
			else
				l_tmp___0.ce_gets (default_quoting_options.address)
			end
			l_p___0.ce_gets (create {CE_POINTER [PD_QUOTING_OPTIONS]}.make_cast ((xmalloc_inst.xmemdup (create {CE_POINTER [ANY]}.make_cast (l_tmp___0), {PD_QUOTING_OPTIONS}.sizeof.to_natural_32))));
			(errno_location).item := l_e
			Result := l_p___0
		end

	get_quoting_style (a_o: CE_POINTER [PD_QUOTING_OPTIONS]): INTEGER_32
		local
			l_tmp: CE_POINTER [PD_QUOTING_OPTIONS]
		do
			create l_tmp.make

			if ((a_o).c_pointer /= default_pointer) then
				l_tmp.ce_gets (a_o)
			else
				l_tmp.ce_gets (default_quoting_options.address)
			end
			Result := (l_tmp.item.style)
		end

	set_quoting_style (a_o: CE_POINTER [PD_QUOTING_OPTIONS]; a_s: INTEGER_32)
		local
			l_tmp: CE_POINTER [PD_QUOTING_OPTIONS]
		do
			create l_tmp.make

			if ((a_o).c_pointer /= default_pointer) then
				l_tmp.ce_gets (a_o)
			else
				l_tmp.ce_gets (default_quoting_options.address)
			end
			l_tmp.item.style := a_s
		end

	set_char_quoting (a_o: CE_POINTER [PD_QUOTING_OPTIONS]; a_c: INTEGER_8; a_i: INTEGER_32): INTEGER_32
		local
			l_uc: NATURAL_8
			l_p___0: CE_POINTER [NATURAL_32]
			l_tmp: CE_POINTER [PD_QUOTING_OPTIONS]
			l_shift: INTEGER_32
			l_r: INTEGER_32
		do
			create l_p___0.make
			create l_tmp.make

			l_uc := a_c.to_natural_8
			if ((a_o).c_pointer /= default_pointer) then
				l_tmp.ce_gets (a_o)
			else
				l_tmp.ce_gets (default_quoting_options.address)
			end
			l_p___0.ce_gets (l_tmp.item.quote_these_too + (l_uc.to_natural_32 // (Integer_32_bytes.to_natural_32 * {NATURAL_32} 8)).to_integer_32)
			l_shift := (l_uc.to_natural_32 \\ (Integer_32_bytes.to_natural_32 * {NATURAL_32} 8)).to_integer_32
			l_r := ((((l_p___0.item).bit_shift_right (l_shift))).bit_and ({NATURAL_32} 1)).to_integer_32
			l_p___0.item := (l_p___0.item).bit_xor (((((((a_i).bit_and (1))).bit_xor (l_r))).bit_shift_left (l_shift)).to_natural_32)
			Result := l_r
		end

	set_quoting_flags (a_o: CE_POINTER [PD_QUOTING_OPTIONS]; a_i: INTEGER_32): INTEGER_32
		local
			l_o: CE_POINTER [PD_QUOTING_OPTIONS]
			l_r: INTEGER_32
		do
			create l_o.make

			l_o.ce_gets (a_o)
			if (l_o).c_pointer = default_pointer then
				l_o.ce_gets (default_quoting_options.address)
			end
			l_r := l_o.item.flags
			l_o.item.flags := a_i
			Result := l_r
		end

	set_custom_quoting (a_o: CE_POINTER [PD_QUOTING_OPTIONS]; a_left_quote: CE_POINTER [INTEGER_8]; a_right_quote: CE_POINTER [INTEGER_8])
		local
			l_o: CE_POINTER [PD_QUOTING_OPTIONS]
		do
			create l_o.make

			l_o.ce_gets (a_o)
			if (l_o).c_pointer = default_pointer then
				l_o.ce_gets (default_quoting_options.address)
			end
			l_o.item.style := {PC_QUOTING_STYLE}.custom_quoting_style
			if (a_left_quote).c_pointer = default_pointer then
				abort
			elseif (a_right_quote).c_pointer = default_pointer then
				abort
			end
			l_o.item.left_quote := a_left_quote
			l_o.item.right_quote := a_right_quote
		end

	quoting_options_from_style (a_style: INTEGER_32): PD_QUOTING_OPTIONS
		local
			l_o: PD_QUOTING_OPTIONS
		do
			create l_o.make

			l_o.style := a_style
			l_o.flags := 0
			memset (create {CE_POINTER [ANY]}.make_cast ((l_o.quote_these_too)), 0, (Natural_32_bytes.to_natural_32 * {NATURAL_32} 255 // (Integer_32_bytes.to_natural_32 * {NATURAL_32} 8) + {NATURAL_32} 1)).do_nothing
			Result := l_o
		end

	gettext_quote (a_msgid: CE_POINTER [INTEGER_8]; a_s: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_translation: CE_POINTER [INTEGER_8]
		do
			create l_translation.make

			l_translation.ce_gets ((gettext (a_msgid)))
			if (l_translation.c_pointer.to_integer_32).to_natural_32 = (a_msgid.c_pointer.to_integer_32).to_natural_32 then
				if a_s.to_natural_32 = {NATURAL_32} 7 then
					l_translation.ce_gets (ce_string ("%""))
				end
			end
			Result := l_translation
		end

	quotearg_buffer_restyled (a_buffer___0: CE_POINTER [INTEGER_8]; a_buffersize: NATURAL_32; a_arg: CE_POINTER [INTEGER_8]; a_argsize: NATURAL_32; a_quoting_style: INTEGER_32; a_flags: INTEGER_32; a_quote_these_too: CE_POINTER [NATURAL_32]; a_left_quote: CE_POINTER [INTEGER_8]; a_right_quote: CE_POINTER [INTEGER_8]): NATURAL_32
		local
			l_argsize: NATURAL_32
			l_quoting_style: INTEGER_32
			l_left_quote: CE_POINTER [INTEGER_8]
			l_right_quote: CE_POINTER [INTEGER_8]
			l_i: NATURAL_32
			l_len: NATURAL_32
			l_quote_string: CE_POINTER [INTEGER_8]
			l_quote_string_len: NATURAL_32
			l_backslash_escapes: BOOLEAN
			l_unibyte_locale: BOOLEAN
			l_elide_outer_quotes: BOOLEAN
			l_c: NATURAL_8
			l_esc: NATURAL_8
			l_is_right_quote: BOOLEAN
			l_tmp___1: INTEGER_32
			l_m: NATURAL_32
			l_printable: BOOLEAN
			l_mbstate: SD_MBSTATE_T
			l_w: INTEGER_32
			l_bytes: NATURAL_32
			l_j: NATURAL_32
			l_ilim: NATURAL_32
			l_tmp___6: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_left_quote.make
			create l_right_quote.make
			create l_quote_string.make
			create l_mbstate.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_argsize := a_argsize
					l_quoting_style := a_quoting_style
					l_left_quote.ce_gets (a_left_quote)
					l_right_quote.ce_gets (a_right_quote)
					l_len := (0).to_natural_32
					l_quote_string.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					l_quote_string_len := (0).to_natural_32
					l_backslash_escapes := (0).to_boolean
					l_unibyte_locale := ((ctype_get_mb_cur_max) = {NATURAL_32} 1)
					l_elide_outer_quotes := (((a_flags).bit_and (2)) /= 0)
					inspect l_quoting_style -- switch 1 head
					when 4 then l_pos := -1 + 1
					when 3 then l_pos := -1 + 2
					when 5 then l_pos := -1 + 3
					when 6 then l_pos := -1 + 4
					when 7 then l_pos := -1 + 4
					when 8 then l_pos := -1 + 4
					when 1 then l_pos := -1 + 5
					when 2 then l_pos := -1 + 6
					when 0 then l_pos := -1 + 7
					else l_pos := -1 + 8
					end
				when 1 then -- switch 1, case 4
					l_quoting_style := {PC_QUOTING_STYLE}.c2_quoting_style
					l_elide_outer_quotes := (1).to_boolean
				when 2 then -- switch 1, case 3
					if not l_elide_outer_quotes then
						from
						until
							js.loop_left
						loop
							js.reset
							if l_len < a_buffersize then
								a_buffer___0[l_len.to_integer_32] := (('%"').code).to_integer_8
							end
							l_len := l_len + 1
							js.break
						end
						js.reset
					end
					l_backslash_escapes := (1).to_boolean
					l_quote_string.ce_gets (ce_string ("%""))
					l_quote_string_len := (1).to_natural_32
					l_pos := -1 + 9 -- switch 1; break
				when 3 then -- switch 1, case 5
					l_backslash_escapes := (1).to_boolean
					l_elide_outer_quotes := (0).to_boolean
					l_pos := -1 + 9 -- switch 1; break
				when 4 then -- switch 1, case 6 | switch 1, case 7 | switch 1, case 8
					if l_quoting_style.to_natural_32 /= {NATURAL_32} 8 then
						l_left_quote.ce_gets (gettext_quote (ce_string ("`"), l_quoting_style))
						l_right_quote.ce_gets (gettext_quote (ce_string ("%'"), l_quoting_style))
					end
					if not l_elide_outer_quotes then
						l_quote_string.ce_gets (l_left_quote)
						from
						until
							not (not js.loop_left and then ((l_quote_string[0]).to_boolean))
						loop
							from
							until
								js.loop_left
							loop
								js.reset
								if l_len < a_buffersize then
									a_buffer___0[l_len.to_integer_32] := l_quote_string[0]
								end
								l_len := l_len + 1
								js.break
							end
							js.reset
							l_quote_string.ce_gets (l_quote_string + 1)
						end
					end
					l_backslash_escapes := (1).to_boolean
					l_quote_string.ce_gets (l_right_quote)
					l_quote_string_len := strlen (l_quote_string)
					l_pos := -1 + 9 -- switch 1; break
				when 5 then -- switch 1, case 1
					l_quoting_style := {PC_QUOTING_STYLE}.shell_always_quoting_style
					l_elide_outer_quotes := (1).to_boolean
				when 6 then -- switch 1, case 2
					if not l_elide_outer_quotes then
						from
						until
							js.loop_left
						loop
							js.reset
							if l_len < a_buffersize then
								a_buffer___0[l_len.to_integer_32] := (('%'').code).to_integer_8
							end
							l_len := l_len + 1
							js.break
						end
						js.reset
					end
					l_quote_string.ce_gets (ce_string ("%'"))
					l_quote_string_len := (1).to_natural_32
					l_pos := -1 + 9 -- switch 1; break
				when 7 then -- switch 1, case 0
					l_elide_outer_quotes := (0).to_boolean
					l_pos := -1 + 9 -- switch 1; break
				when 8 then -- switch 1, default:
					abort
				when 9 then -- switch 1, done:
					l_i := (0).to_natural_32
				when 10 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 112 -- skip loop
					end
				when 11 then -- loop body:
						js.reset
						if l_argsize = {NATURAL_32} 4294967295 then
							l_tmp___6 := ((a_arg[l_i.to_integer_32]).to_integer_32 = 0).to_integer
						else
							l_tmp___6 := (l_i = l_argsize).to_integer
						end
						if l_tmp___6.to_boolean then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 100 -- skip if block
						end
				when 12 then -- if:
						l_is_right_quote := (0).to_boolean
						if not l_backslash_escapes then
							l_pos := -1 + 18 -- skip if block
						end
				when 13 then -- if:
						if not (l_quote_string_len.to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 14 then -- if:
						if not (l_i + l_quote_string_len <= l_argsize) then
							l_pos := -1 + 18 -- skip if block
						end
				when 15 then -- if:
						if (memcmp (create {CE_POINTER [ANY]}.make_cast ((a_arg + l_i.to_integer_32)), create {CE_POINTER [ANY]}.make_cast (l_quote_string), l_quote_string_len)) /= 0 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if l_elide_outer_quotes then
							l_pos := -1 + 114 -- goto force_outer_quoting_style
						end
				when 17 then
						l_is_right_quote := (1).to_boolean
				when 18 then -- if done | if done | if done | if done
						l_c := (a_arg[l_i.to_integer_32]).to_natural_8
						inspect l_c.to_integer_32 -- switch 2 head
						when 0 then l_pos := -1 + 19
						when 63 then l_pos := -1 + 25
						when 7 then l_pos := -1 + 38
						when 8 then l_pos := -1 + 39
						when 12 then l_pos := -1 + 40
						when 10 then l_pos := -1 + 41
						when 13 then l_pos := -1 + 42
						when 9 then l_pos := -1 + 43
						when 11 then l_pos := -1 + 44
						when 92 then l_pos := -1 + 45
						when 123 then l_pos := -1 + 49
						when 125 then l_pos := -1 + 49
						when 35 then l_pos := -1 + 50
						when 126 then l_pos := -1 + 50
						when 32 then l_pos := -1 + 51
						when 33 then l_pos := -1 + 51
						when 34 then l_pos := -1 + 51
						when 36 then l_pos := -1 + 51
						when 38 then l_pos := -1 + 51
						when 40 then l_pos := -1 + 51
						when 41 then l_pos := -1 + 51
						when 42 then l_pos := -1 + 51
						when 59 then l_pos := -1 + 51
						when 60 then l_pos := -1 + 51
						when 61 then l_pos := -1 + 51
						when 62 then l_pos := -1 + 51
						when 91 then l_pos := -1 + 51
						when 94 then l_pos := -1 + 51
						when 96 then l_pos := -1 + 51
						when 124 then l_pos := -1 + 51
						when 39 then l_pos := -1 + 53
						when 37 then l_pos := -1 + 57
						when 43 then l_pos := -1 + 57
						when 44 then l_pos := -1 + 57
						when 45 then l_pos := -1 + 57
						when 46 then l_pos := -1 + 57
						when 47 then l_pos := -1 + 57
						when 48 then l_pos := -1 + 57
						when 49 then l_pos := -1 + 57
						when 50 then l_pos := -1 + 57
						when 51 then l_pos := -1 + 57
						when 52 then l_pos := -1 + 57
						when 53 then l_pos := -1 + 57
						when 54 then l_pos := -1 + 57
						when 55 then l_pos := -1 + 57
						when 56 then l_pos := -1 + 57
						when 57 then l_pos := -1 + 57
						when 58 then l_pos := -1 + 57
						when 65 then l_pos := -1 + 57
						when 66 then l_pos := -1 + 57
						when 67 then l_pos := -1 + 57
						when 68 then l_pos := -1 + 57
						when 69 then l_pos := -1 + 57
						when 70 then l_pos := -1 + 57
						when 71 then l_pos := -1 + 57
						when 72 then l_pos := -1 + 57
						when 73 then l_pos := -1 + 57
						when 74 then l_pos := -1 + 57
						when 75 then l_pos := -1 + 57
						when 76 then l_pos := -1 + 57
						when 77 then l_pos := -1 + 57
						when 78 then l_pos := -1 + 57
						when 79 then l_pos := -1 + 57
						when 80 then l_pos := -1 + 57
						when 81 then l_pos := -1 + 57
						when 82 then l_pos := -1 + 57
						when 83 then l_pos := -1 + 57
						when 84 then l_pos := -1 + 57
						when 85 then l_pos := -1 + 57
						when 86 then l_pos := -1 + 57
						when 87 then l_pos := -1 + 57
						when 88 then l_pos := -1 + 57
						when 89 then l_pos := -1 + 57
						when 90 then l_pos := -1 + 57
						when 93 then l_pos := -1 + 57
						when 95 then l_pos := -1 + 57
						when 97 then l_pos := -1 + 57
						when 98 then l_pos := -1 + 57
						when 99 then l_pos := -1 + 57
						when 100 then l_pos := -1 + 57
						when 101 then l_pos := -1 + 57
						when 102 then l_pos := -1 + 57
						when 103 then l_pos := -1 + 57
						when 104 then l_pos := -1 + 57
						when 105 then l_pos := -1 + 57
						when 106 then l_pos := -1 + 57
						when 107 then l_pos := -1 + 57
						when 108 then l_pos := -1 + 57
						when 109 then l_pos := -1 + 57
						when 110 then l_pos := -1 + 57
						when 111 then l_pos := -1 + 57
						when 112 then l_pos := -1 + 57
						when 113 then l_pos := -1 + 57
						when 114 then l_pos := -1 + 57
						when 115 then l_pos := -1 + 57
						when 116 then l_pos := -1 + 57
						when 117 then l_pos := -1 + 57
						when 118 then l_pos := -1 + 57
						when 119 then l_pos := -1 + 57
						when 120 then l_pos := -1 + 57
						when 121 then l_pos := -1 + 57
						when 122 then l_pos := -1 + 57
						else l_pos := -1 + 58
						end
				when 19 then -- switch 2, case 0
						if not l_backslash_escapes then
							l_pos := -1 + 23 -- skip if block
						end
				when 20 then -- if:
						if l_elide_outer_quotes then
							l_pos := -1 + 114 -- goto force_outer_quoting_style
						end
				when 21 then
						from
						until
							js.loop_left
						loop
							js.reset
							if l_len < a_buffersize then
								a_buffer___0[l_len.to_integer_32] := (('\').code).to_integer_8
							end
							l_len := l_len + 1
							js.break
						end
						js.reset
						if l_i + {NATURAL_32} 1 < l_argsize then
							if 48 <= (a_arg[(l_i + {NATURAL_32} 1).to_integer_32]).to_integer_32 then
								if (a_arg[(l_i + {NATURAL_32} 1).to_integer_32]).to_integer_32 <= 57 then
									from
									until
										js.loop_left
									loop
										js.reset
										if l_len < a_buffersize then
											a_buffer___0[l_len.to_integer_32] := (('0').code).to_integer_8
										end
										l_len := l_len + 1
										js.break
									end
									js.reset
									from
									until
										js.loop_left
									loop
										js.reset
										if l_len < a_buffersize then
											a_buffer___0[l_len.to_integer_32] := (('0').code).to_integer_8
										end
										l_len := l_len + 1
										js.break
									end
									js.reset
								end
							end
						end
						l_c := (('0').code).to_natural_8
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else:
						if ((a_flags).bit_and (1)).to_boolean then
							js.continue
						end
				when 24 then -- if done
						l_pos := -1 + 100 -- switch 2; break
				when 25 then -- switch 2, case 63
						inspect l_quoting_style -- switch 3 head
						when 2 then l_pos := -1 + 26
						when 3 then l_pos := -1 + 28
						else l_pos := -1 + 36
						end
				when 26 then -- switch 3, case 2
						if l_elide_outer_quotes then
							l_pos := -1 + 114 -- goto force_outer_quoting_style
						end
				when 27 then
						l_pos := -1 + 37 -- switch 3; break
				when 28 then -- switch 3, case 3
						if not (((a_flags).bit_and (4)).to_boolean) then
							l_pos := -1 + 35 -- skip if block
						end
				when 29 then -- if:
						if not (l_i + {NATURAL_32} 2 < l_argsize) then
							l_pos := -1 + 35 -- skip if block
						end
				when 30 then -- if:
						if (a_arg[(l_i + {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 63 then
							l_pos := -1 + 35 -- skip if block
						end
				when 31 then -- if:
						inspect (a_arg[(l_i + {NATURAL_32} 2).to_integer_32]).to_integer_32 -- switch 4 head
						when 33 then l_pos := -1 + 32
						when 39 then l_pos := -1 + 32
						when 40 then l_pos := -1 + 32
						when 41 then l_pos := -1 + 32
						when 45 then l_pos := -1 + 32
						when 47 then l_pos := -1 + 32
						when 60 then l_pos := -1 + 32
						when 61 then l_pos := -1 + 32
						when 62 then l_pos := -1 + 32
						else l_pos := -1 + 34
						end
				when 32 then -- switch 4, case 33 | switch 4, case 39 | switch 4, case 40 | switch 4, case 41 | switch 4, case 45 | switch 4, case 47 | switch 4, case 60 | switch 4, case 61 | switch 4, case 62
						if l_elide_outer_quotes then
							l_pos := -1 + 114 -- goto force_outer_quoting_style
						end
				when 33 then
						l_c := (a_arg[(l_i + {NATURAL_32} 2).to_integer_32]).to_natural_8
						l_i := l_i + ({NATURAL_32} 2)
						from
						until
							js.loop_left
						loop
							js.reset
							if l_len < a_buffersize then
								a_buffer___0[l_len.to_integer_32] := (('?').code).to_integer_8
							end
							l_len := l_len + 1
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							if l_len < a_buffersize then
								a_buffer___0[l_len.to_integer_32] := (('%"').code).to_integer_8
							end
							l_len := l_len + 1
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							if l_len < a_buffersize then
								a_buffer___0[l_len.to_integer_32] := (('%"').code).to_integer_8
							end
							l_len := l_len + 1
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							if l_len < a_buffersize then
								a_buffer___0[l_len.to_integer_32] := (('?').code).to_integer_8
							end
							l_len := l_len + 1
							js.break
						end
						js.reset
						l_pos := -1 + 35 -- switch 4; break
				when 34 then -- switch 4, default:
						l_pos := -1 + 35 -- switch 4; break
				when 35 then -- switch 4, done: | if done | if done | if done
						l_pos := -1 + 37 -- switch 3; break
				when 36 then -- switch 3, default:
						l_pos := -1 + 37 -- switch 3; break
				when 37 then -- switch 3, done:
						l_pos := -1 + 100 -- switch 2; break
				when 38 then -- switch 2, case 7
						l_esc := (('a').code).to_natural_8
						l_pos := -1 + 47 -- goto c_escape
				when 39 then -- switch 2, case 8
						l_esc := (('b').code).to_natural_8
						l_pos := -1 + 47 -- goto c_escape
				when 40 then -- switch 2, case 12
						l_esc := (('f').code).to_natural_8
						l_pos := -1 + 47 -- goto c_escape
				when 41 then -- switch 2, case 10
						l_esc := (('n').code).to_natural_8
						l_pos := -1 + 46 -- goto c_and_shell_escape
				when 42 then -- switch 2, case 13
						l_esc := (('r').code).to_natural_8
						l_pos := -1 + 46 -- goto c_and_shell_escape
				when 43 then -- switch 2, case 9
						l_esc := (('t').code).to_natural_8
						l_pos := -1 + 46 -- goto c_and_shell_escape
				when 44 then -- switch 2, case 11
						l_esc := (('v').code).to_natural_8
						l_pos := -1 + 47 -- goto c_escape
				when 45 then -- switch 2, case 92
						l_esc := l_c
						if l_backslash_escapes then
							if l_elide_outer_quotes then
								if l_quote_string_len.to_boolean then
									l_pos := -1 + 110 -- goto store_c
								end
							end
						end
				when 46 then -- c_and_shell_escape:
						if l_quoting_style.to_natural_32 = {NATURAL_32} 2 then
							if l_elide_outer_quotes then
								l_pos := -1 + 114 -- goto force_outer_quoting_style
							end
						end
				when 47 then -- c_escape:
						if l_backslash_escapes then
							l_c := l_esc
							l_pos := -1 + 108 -- goto store_escape
						end
				when 48 then
						l_pos := -1 + 100 -- switch 2; break
				when 49 then -- switch 2, case 123 | switch 2, case 125
						if l_argsize = {NATURAL_32} 4294967295 then
							l_tmp___1 := ((a_arg[1]).to_integer_32 = 0).to_integer
						else
							l_tmp___1 := (l_argsize = {NATURAL_32} 1).to_integer
						end
						if not l_tmp___1.to_boolean then
							l_pos := -1 + 100 -- switch 2; break
						end
				when 50 then -- switch 2, case 35 | switch 2, case 126
						if l_i /= {NATURAL_32} 0 then
							l_pos := -1 + 100 -- switch 2; break
						end
				when 51 then -- switch 2, case 32 | switch 2, case 33 | switch 2, case 34 | switch 2, case 36 | switch 2, case 38 | switch 2, case 40 | switch 2, case 41 | switch 2, case 42 | switch 2, case 59 | switch 2, case 60 | switch 2, case 61 | switch 2, case 62 | switch 2, case 91 | switch 2, case 94 | switch 2, case 96 | switch 2, case 124
						if l_quoting_style.to_natural_32 = {NATURAL_32} 2 then
							if l_elide_outer_quotes then
								l_pos := -1 + 114 -- goto force_outer_quoting_style
							end
						end
				when 52 then
						l_pos := -1 + 100 -- switch 2; break
				when 53 then -- switch 2, case 39
						if l_quoting_style.to_natural_32 /= {NATURAL_32} 2 then
							l_pos := -1 + 56 -- skip if block
						end
				when 54 then -- if:
						if l_elide_outer_quotes then
							l_pos := -1 + 114 -- goto force_outer_quoting_style
						end
				when 55 then
						from
						until
							js.loop_left
						loop
							js.reset
							if l_len < a_buffersize then
								a_buffer___0[l_len.to_integer_32] := (('%'').code).to_integer_8
							end
							l_len := l_len + 1
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							if l_len < a_buffersize then
								a_buffer___0[l_len.to_integer_32] := (('\').code).to_integer_8
							end
							l_len := l_len + 1
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							if l_len < a_buffersize then
								a_buffer___0[l_len.to_integer_32] := (('%'').code).to_integer_8
							end
							l_len := l_len + 1
							js.break
						end
						js.reset
				when 56 then -- if done
						l_pos := -1 + 100 -- switch 2; break
				when 57 then -- switch 2, case 37 | switch 2, case 43 | switch 2, case 44 | switch 2, case 45 | switch 2, case 46 | switch 2, case 47 | switch 2, case 48 | switch 2, case 49 | switch 2, case 50 | switch 2, case 51 | switch 2, case 52 | switch 2, case 53 | switch 2, case 54 | switch 2, case 55 | switch 2, case 56 | switch 2, case 57 | switch 2, case 58 | switch 2, case 65 | switch 2, case 66 | switch 2, case 67 | switch 2, case 68 | switch 2, case 69 | switch 2, case 70 | switch 2, case 71 | switch 2, case 72 | switch 2, case 73 | switch 2, case 74 | switch 2, case 75 | switch 2, case 76 | switch 2, case 77 | switch 2, case 78 | switch 2, case 79 | switch 2, case 80 | switch 2, case 81 | switch 2, case 82 | switch 2, case 83 | switch 2, case 84 | switch 2, case 85 | switch 2, case 86 | switch 2, case 87 | switch 2, case 88 | switch 2, case 89 | switch 2, case 90 | switch 2, case 93 | switch 2, case 95 | switch 2, case 97 | switch 2, case 98 | switch 2, case 99 | switch 2, case 100 | switch 2, case 101 | switch 2, case 102 | switch 2, case 103 | switch 2, case 104 | switch 2, case 105 | switch 2, case 106 | switch 2, case 107 | switch 2, case 108 | switch 2, case 109 | switch 2, case 110 | switch 2, case 111 | switch 2, case 112 | switch 2, case 113 | switch 2, case 114 | switch 2, case 115 | switch 2, case 116 | switch 2, case 117 | switch 2, case 118 | switch 2, case 119 | switch 2, case 120 | switch 2, case 121 | switch 2, case 122
						l_pos := -1 + 100 -- switch 2; break
				when 58 then -- switch 2, default:
						if not l_unibyte_locale then
							l_pos := -1 + 61 -- skip if block
						end
				when 59 then -- if:
						l_m := (1).to_natural_32
						l_printable := (((((ctype_b_loc).item[l_c.to_integer_32]).to_integer_32).bit_and (16384)) /= 0)
				when 60 then -- if block done, skip else block:
						l_pos := -1 + 83
				when 61 then -- else:
						memset (create {CE_POINTER [ANY]}.make_cast ((l_mbstate.address)), 0, {SD_MBSTATE_T}.sizeof.to_natural_32).do_nothing
						l_m := (0).to_natural_32
						l_printable := (1).to_boolean
						if l_argsize = {NATURAL_32} 4294967295 then
							l_argsize := strlen (a_arg)
						end
				when 62 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 82 -- skip loop
						end
				when 63 then -- loop body:
						js.reset
						l_bytes := (mbrtowc ((create {CE_POINTER [INTEGER_32]}.make_shared ($l_w)), (a_arg + (l_i + l_m).to_integer_32), l_argsize - (l_i + l_m), l_mbstate.address))
						if l_bytes /= {NATURAL_32} 0 then
							l_pos := -1 + 66 -- skip if block
						end
				when 64 then -- if:
						js.break
				when 65 then -- if block done, skip else block:
						l_pos := -1 + 81
				when 66 then -- else:
						if l_bytes /= {NATURAL_32} 4294967295 then
							l_pos := -1 + 69 -- skip if block
						end
				when 67 then -- if:
						l_printable := (0).to_boolean
						js.break
				when 68 then -- if block done, skip else block:
						l_pos := -1 + 81
				when 69 then -- else:
						if l_bytes /= {NATURAL_32} 4294967294 then
							l_pos := -1 + 72 -- skip if block
						end
				when 70 then -- if:
						l_printable := (0).to_boolean
						from
						until
							js.loop_left
						loop
							js.reset
							if l_i + l_m < l_argsize then
								if not (a_arg[(l_i + l_m).to_integer_32]).to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_m := l_m + 1
							end
						end
						js.reset
						js.break
				when 71 then -- if block done, skip else block:
						l_pos := -1 + 81
				when 72 then -- else:
						if not l_elide_outer_quotes then
							l_pos := -1 + 80 -- skip if block
						end
				when 73 then -- if:
						if l_quoting_style.to_natural_32 /= {NATURAL_32} 2 then
							l_pos := -1 + 80 -- skip if block
						end
				when 74 then -- if:
						l_j := (1).to_natural_32
				when 75 then -- loop condition:
						if not (l_j < l_bytes) then
							l_pos := -1 + 80 -- skip loop
						end
				when 76 then -- loop body:
						inspect (a_arg[((l_i + l_m) + l_j).to_integer_32]).to_integer_32 -- switch 5 head
						when 91 then l_pos := -1 + 77
						when 92 then l_pos := -1 + 77
						when 94 then l_pos := -1 + 77
						when 96 then l_pos := -1 + 77
						when 124 then l_pos := -1 + 77
						else l_pos := -1 + 78
						end
				when 77 then -- switch 5, case 91 | switch 5, case 92 | switch 5, case 94 | switch 5, case 96 | switch 5, case 124
						l_pos := -1 + 114 -- goto force_outer_quoting_style
				when 78 then -- switch 5, default:
						l_pos := -1 + 79 -- switch 5; break
				when 79 then -- switch 5, done:
						l_j := l_j + 1
						l_pos := -1 + 75 -- back to loop condition
				when 80 then -- loop done | if done | if done
						if not (iswprint (l_w.to_natural_32)).to_boolean then
							l_printable := (0).to_boolean
						end
						l_m := l_m + l_bytes
				when 81 then -- if done | if done | if done
						if not js.loop_jumped then
							if (mbsinit ((l_mbstate.address))).to_boolean then
								js.break
							end
						end
						l_pos := -1 + 62 -- back to loop condition
				when 82 then -- loop done
						js.reset
				when 83 then -- if done
						if not ({NATURAL_32} 1 < l_m) then
							l_pos := -1 + 86 -- skip if block
						end
				when 84 then -- if:
						l_pos := -1 + 88 -- goto _L___0
				when 85 then -- if block done, skip else block:
						l_pos := -1 + 100
				when 86 then -- else:
						if not l_backslash_escapes then
							l_pos := -1 + 100 -- skip if block
						end
				when 87 then -- if:
						if l_printable then
							l_pos := -1 + 100 -- skip if block
						end
				when 88 then -- if: | _L___0:
						l_ilim := l_i + l_m
				when 89 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 99 -- skip loop
						end
				when 90 then -- loop body:
						js.reset
						if not l_backslash_escapes then
							l_pos := -1 + 97 -- skip if block
						end
				when 91 then -- if:
						if l_printable then
							l_pos := -1 + 95 -- skip if block
						end
				when 92 then -- if:
						if l_elide_outer_quotes then
							l_pos := -1 + 114 -- goto force_outer_quoting_style
						end
				when 93 then
						from
						until
							js.loop_left
						loop
							js.reset
							if l_len < a_buffersize then
								a_buffer___0[l_len.to_integer_32] := (('\').code).to_integer_8
							end
							l_len := l_len + 1
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							if l_len < a_buffersize then
								a_buffer___0[l_len.to_integer_32] := (48 + ((l_c.to_integer_32).bit_shift_right (6))).to_integer_8
							end
							l_len := l_len + 1
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							if l_len < a_buffersize then
								a_buffer___0[l_len.to_integer_32] := (48 + ((((l_c.to_integer_32).bit_shift_right (3))).bit_and (7))).to_integer_8
							end
							l_len := l_len + 1
							js.break
						end
						js.reset
						l_c := (48 + ((l_c.to_integer_32).bit_and (7))).to_natural_8
				when 94 then -- if block done, skip else block:
						l_pos := -1 + 96
				when 95 then -- else:
						l_pos := -1 + 97 -- goto _L
				when 96 then -- if done | if block done, skip else block:
						l_pos := -1 + 98
				when 97 then -- else: | _L:
						if l_is_right_quote then
							from
							until
								js.loop_left
							loop
								js.reset
								if l_len < a_buffersize then
									a_buffer___0[l_len.to_integer_32] := (('\').code).to_integer_8
								end
								l_len := l_len + 1
								js.break
							end
							js.reset
							l_is_right_quote := (0).to_boolean
						end
				when 98 then
						if l_ilim <= l_i + {NATURAL_32} 1 then
							js.break
						end
						if not js.loop_jumped then
							from
							until
								js.loop_left
							loop
								js.reset
								if l_len < a_buffersize then
									a_buffer___0[l_len.to_integer_32] := l_c.to_integer_8
								end
								l_len := l_len + 1
								js.break
							end
							js.reset
							l_i := l_i + 1
							l_c := (a_arg[l_i.to_integer_32]).to_natural_8
						end
						l_pos := -1 + 89 -- back to loop condition
				when 99 then -- loop done
						js.reset
						l_pos := -1 + 110 -- goto store_c
				when 100 then -- if done | if done | switch 2, done: | if done
						if js.loop_jumped then
							l_pos := -1 + 111 -- skip if block
						end
				when 101 then -- if:
						if not l_backslash_escapes then
							l_pos := -1 + 104 -- skip if block
						end
				when 102 then -- if:
						l_pos := -1 + 105 -- goto _L___3
				when 103 then -- if block done, skip else block:
						l_pos := -1 + 108
				when 104 then -- else:
						if not l_elide_outer_quotes then
							l_pos := -1 + 107 -- skip if block
						end
				when 105 then -- if: | _L___3:
						if ((a_quote_these_too).c_pointer /= default_pointer) then
							if not ((a_quote_these_too[(l_c.to_natural_32 // (Integer_32_bytes.to_natural_32 * {NATURAL_32} 8)).to_integer_32]).bit_and (((1).bit_shift_left ((l_c.to_natural_32 \\ (Integer_32_bytes.to_natural_32 * {NATURAL_32} 8)).to_integer_32)).to_natural_32)).to_boolean then
								l_pos := -1 + 107 -- goto _L___2
							end
						else
							l_pos := -1 + 107 -- goto _L___2
						end
				when 106 then -- if block done, skip else block:
						l_pos := -1 + 108
				when 107 then -- else: | _L___2:
						if not l_is_right_quote then
							l_pos := -1 + 110 -- goto store_c
						end
				when 108 then -- if done | store_escape:
						if l_elide_outer_quotes then
							l_pos := -1 + 114 -- goto force_outer_quoting_style
						end
				when 109 then
						from
						until
							js.loop_left
						loop
							js.reset
							if l_len < a_buffersize then
								a_buffer___0[l_len.to_integer_32] := (('\').code).to_integer_8
							end
							l_len := l_len + 1
							js.break
						end
						js.reset
				when 110 then -- store_c:
						from
						until
							js.loop_left
						loop
							js.reset
							if l_len < a_buffersize then
								a_buffer___0[l_len.to_integer_32] := l_c.to_integer_8
							end
							l_len := l_len + 1
							js.break
						end
						js.reset
				when 111 then -- if done
						if not js.loop_left then
							l_i := l_i + 1
						end
						l_pos := -1 + 10 -- back to loop condition
				when 112 then -- loop done
					js.reset
					if l_len = {NATURAL_32} 0 then
						if l_quoting_style.to_natural_32 = {NATURAL_32} 2 then
							if l_elide_outer_quotes then
								l_pos := -1 + 114 -- goto force_outer_quoting_style
							end
						end
					end
				when 113 then
					if ((l_quote_string).c_pointer /= default_pointer) then
						if not l_elide_outer_quotes then
							from
							until
								not (not js.loop_left and then ((l_quote_string[0]).to_boolean))
							loop
								from
								until
									js.loop_left
								loop
									js.reset
									if l_len < a_buffersize then
										a_buffer___0[l_len.to_integer_32] := l_quote_string[0]
									end
									l_len := l_len + 1
									js.break
								end
								js.reset
								l_quote_string.ce_gets (l_quote_string + 1)
							end
						end
					end
					if l_len < a_buffersize then
						a_buffer___0[l_len.to_integer_32] := (('%/0/').code).to_integer_8
					end
					Result := l_len
					js.return
					if js.return_called then
						l_pos := -1 + 115 -- skip if block
					end
				when 114 then -- if: | force_outer_quoting_style:
						Result := (quotearg_buffer_restyled (a_buffer___0, a_buffersize, a_arg, l_argsize, l_quoting_style, (a_flags).bit_and (-3), create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer), l_left_quote, l_right_quote))
				when 115 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	quotearg_buffer (a_buffer___0: CE_POINTER [INTEGER_8]; a_buffersize: NATURAL_32; a_arg: CE_POINTER [INTEGER_8]; a_argsize: NATURAL_32; a_o: CE_POINTER [PD_QUOTING_OPTIONS]): NATURAL_32
		local
			l_p___0: CE_POINTER [PD_QUOTING_OPTIONS]
			l_tmp: CE_POINTER [PD_QUOTING_OPTIONS]
			l_e: INTEGER_32
			l_r: NATURAL_32
		do
			create l_p___0.make
			create l_tmp.make

			if ((a_o).c_pointer /= default_pointer) then
				l_tmp.ce_gets (a_o)
			else
				l_tmp.ce_gets ((default_quoting_options.address))
			end
			l_p___0.ce_gets (l_tmp)
			l_e := (errno_location).item
			l_r := (quotearg_buffer_restyled (a_buffer___0, a_buffersize, a_arg, a_argsize, l_p___0.item.style, l_p___0.item.flags, create {CE_POINTER [NATURAL_32]}.make_cast ((l_p___0.item.quote_these_too)), l_p___0.item.left_quote, l_p___0.item.right_quote));
			(errno_location).item := l_e
			Result := l_r
		end

	quotearg_alloc (a_arg: CE_POINTER [INTEGER_8]; a_argsize: NATURAL_32; a_o: CE_POINTER [PD_QUOTING_OPTIONS]): CE_POINTER [INTEGER_8]
		do
			Result := (quotearg_alloc_mem (a_arg, a_argsize, create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer), a_o))
		end

	quotearg_alloc_mem (a_arg: CE_POINTER [INTEGER_8]; a_argsize: NATURAL_32; a_size: CE_POINTER [NATURAL_32]; a_o: CE_POINTER [PD_QUOTING_OPTIONS]): CE_POINTER [INTEGER_8]
		local
			l_p___0: CE_POINTER [PD_QUOTING_OPTIONS]
			l_tmp: CE_POINTER [PD_QUOTING_OPTIONS]
			l_e: INTEGER_32
			l_flags: INTEGER_32
			l_tmp___1: INTEGER_32
			l_bufsize___0: NATURAL_32
			l_buf___6: CE_POINTER [INTEGER_8]
		do
			create l_p___0.make
			create l_tmp.make
			create l_buf___6.make

			if ((a_o).c_pointer /= default_pointer) then
				l_tmp.ce_gets (a_o)
			else
				l_tmp.ce_gets ((default_quoting_options.address))
			end
			l_p___0.ce_gets (l_tmp)
			l_e := (errno_location).item
			if ((a_size).c_pointer /= default_pointer) then
				l_tmp___1 := 0
			else
				l_tmp___1 := 1
			end
			l_flags := ((l_p___0.item.flags).bit_or (l_tmp___1))
			l_bufsize___0 := (quotearg_buffer_restyled (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), (0).to_natural_32, a_arg, a_argsize, l_p___0.item.style, l_flags, create {CE_POINTER [NATURAL_32]}.make_cast ((l_p___0.item.quote_these_too)), l_p___0.item.left_quote, l_p___0.item.right_quote)) + {NATURAL_32} 1
			l_buf___6.ce_gets ((xalloc_inst.xcharalloc (l_bufsize___0)))
			quotearg_buffer_restyled (l_buf___6, l_bufsize___0, a_arg, a_argsize, l_p___0.item.style, l_flags, create {CE_POINTER [NATURAL_32]}.make_cast ((l_p___0.item.quote_these_too)), l_p___0.item.left_quote, l_p___0.item.right_quote).do_nothing;
			(errno_location).item := l_e
			if ((a_size).c_pointer /= default_pointer) then
				a_size.item := l_bufsize___0 - {NATURAL_32} 1
			end
			Result := l_buf___6
		end

	quotearg_free
		local
			l_sv: CE_POINTER [PD_SLOTVEC]
			l_i: NATURAL_32
		do
			create l_sv.make

			l_sv.ce_gets (slotvec)
			l_i := {NATURAL_32} 1
			from
			until
				not (l_i < nslots)
			loop
				free (create {CE_POINTER [ANY]}.make_cast ((l_sv + l_i.to_integer_32).item.val))
				l_i := l_i + 1
			end
			if (((l_sv + 0).item.val).c_pointer.to_integer_32).to_natural_32 /= (slot0.c_pointer.to_integer_32).to_natural_32 then
				free (create {CE_POINTER [ANY]}.make_cast ((l_sv + 0).item.val))
				slotvec0.size := (Integer_8_bytes.to_natural_32 * (256).to_natural_32)
				slotvec0.val := slot0
			end
			if (l_sv.c_pointer.to_integer_32).to_natural_32 /= ((slotvec0.address).c_pointer.to_integer_32).to_natural_32 then
				free (create {CE_POINTER [ANY]}.make_cast (l_sv))
				slotvec.ce_gets (slotvec0.address)
			end
			nslots := {NATURAL_32} 1
		end

	quotearg_n_options (a_n: INTEGER_32; a_arg: CE_POINTER [INTEGER_8]; a_argsize: NATURAL_32; a_options___0: CE_POINTER [PD_QUOTING_OPTIONS]): CE_POINTER [INTEGER_8]
		local
			l_e: INTEGER_32
			l_n0: NATURAL_32
			l_sv: CE_POINTER [PD_SLOTVEC]
			l_n1: NATURAL_32
			l_preallocated: BOOLEAN
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [PD_SLOTVEC]
			l_size: NATURAL_32
			l_val: CE_POINTER [INTEGER_8]
			l_flags: INTEGER_32
			l_qsize: NATURAL_32
		do
			create l_sv.make
			create l_tmp___1.make
			create l_val.make

			l_e := (errno_location).item
			l_n0 := a_n.to_natural_32
			l_sv.ce_gets (slotvec)
			if a_n < 0 then
				abort
			end
			if nslots <= l_n0 then
				l_n1 := l_n0 + {NATURAL_32} 1
				l_preallocated := ((l_sv.c_pointer.to_integer_32).to_natural_32 = ((slotvec0.address).c_pointer.to_integer_32).to_natural_32)
				if Integer_32_bytes.to_natural_32 <= Natural_32_bytes.to_natural_32 then
					l_tmp___0 := -1
				else
					l_tmp___0 := -2
				end
				if l_tmp___0.to_natural_32 // {PD_SLOTVEC}.sizeof.to_natural_32 < l_n1 then
					xalloc_die_inst.xalloc_die
				end
				if l_preallocated then
					l_tmp___1.ce_gets (create {CE_POINTER [PD_SLOTVEC]}.make_shared (default_pointer))
				else
					l_tmp___1.ce_gets (l_sv)
				end
				l_sv.ce_gets (create {CE_POINTER [PD_SLOTVEC]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (l_tmp___1), l_n1 * {PD_SLOTVEC}.sizeof.to_natural_32))))
				slotvec.ce_gets (l_sv)
				if l_preallocated then
					l_sv.item := slotvec0
				end
				memset (create {CE_POINTER [ANY]}.make_cast ((l_sv + nslots.to_integer_32)), 0, (l_n1 - nslots) * {PD_SLOTVEC}.sizeof.to_natural_32).do_nothing
				nslots := l_n1
			end
			l_size := (l_sv + a_n).item.size
			l_val.ce_gets ((l_sv + a_n).item.val)
			l_flags := ((a_options___0.item.flags).bit_or (1))
			l_qsize := (quotearg_buffer_restyled (l_val, l_size, a_arg, a_argsize, a_options___0.item.style, l_flags, create {CE_POINTER [NATURAL_32]}.make_cast ((a_options___0.item.quote_these_too)), a_options___0.item.left_quote, a_options___0.item.right_quote))
			if l_size <= l_qsize then
				l_size := l_qsize + {NATURAL_32} 1;
				(l_sv + a_n).item.size := l_size
				if (l_val.c_pointer.to_integer_32).to_natural_32 /= (slot0.c_pointer.to_integer_32).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_val))
				end
				l_val.ce_gets (xalloc_inst.xcharalloc (l_size));
				(l_sv + a_n).item.val := l_val
				quotearg_buffer_restyled (l_val, l_size, a_arg, a_argsize, a_options___0.item.style, l_flags, create {CE_POINTER [NATURAL_32]}.make_cast ((a_options___0.item.quote_these_too)), a_options___0.item.left_quote, a_options___0.item.right_quote).do_nothing
			end
			(errno_location).item := l_e
			Result := l_val
		end

	quotearg_n (a_n: INTEGER_32; a_arg: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			Result := (quotearg_n_options (a_n, a_arg, (-1).to_natural_32, (default_quoting_options.address)))
		end

	quotearg_n_mem (a_n: INTEGER_32; a_arg: CE_POINTER [INTEGER_8]; a_argsize: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			Result := (quotearg_n_options (a_n, a_arg, a_argsize, (default_quoting_options.address)))
		end

	quotearg (a_arg: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			Result := (quotearg_n (0, a_arg))
		end

	quotearg_mem (a_arg: CE_POINTER [INTEGER_8]; a_argsize: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			Result := (quotearg_n_mem (0, a_arg, a_argsize))
		end

	quotearg_n_style (a_n: INTEGER_32; a_s: INTEGER_32; a_arg: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_o: PD_QUOTING_OPTIONS
		do
			create l_o.make

			l_o.ce_gets ((quoting_options_from_style (a_s)))
			Result := (quotearg_n_options (a_n, a_arg, (-1).to_natural_32, (l_o.address)))
		end

	quotearg_n_style_mem (a_n: INTEGER_32; a_s: INTEGER_32; a_arg: CE_POINTER [INTEGER_8]; a_argsize: NATURAL_32): CE_POINTER [INTEGER_8]
		local
			l_o: PD_QUOTING_OPTIONS
		do
			create l_o.make

			l_o.ce_gets ((quoting_options_from_style (a_s)))
			Result := (quotearg_n_options (a_n, a_arg, a_argsize, (l_o.address)))
		end

	quotearg_style (a_s: INTEGER_32; a_arg: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			Result := (quotearg_n_style (0, a_s, a_arg))
		end

	quotearg_style_mem (a_s: INTEGER_32; a_arg: CE_POINTER [INTEGER_8]; a_argsize: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			Result := (quotearg_n_style_mem (0, a_s, a_arg, a_argsize))
		end

	quotearg_char_mem (a_arg: CE_POINTER [INTEGER_8]; a_argsize: NATURAL_32; a_ch: INTEGER_8): CE_POINTER [INTEGER_8]
		local
			l_options___0: PD_QUOTING_OPTIONS
		do
			create l_options___0.make

			l_options___0.ce_gets (default_quoting_options)
			set_char_quoting (l_options___0.address, a_ch, 1).do_nothing
			Result := (quotearg_n_options (0, a_arg, a_argsize, (l_options___0.address)))
		end

	quotearg_char (a_arg: CE_POINTER [INTEGER_8]; a_ch: INTEGER_8): CE_POINTER [INTEGER_8]
		do
			Result := (quotearg_char_mem (a_arg, (-1).to_natural_32, a_ch))
		end

	quotearg_colon (a_arg: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			Result := (quotearg_char (a_arg, ((':').code).to_integer_8))
		end

	quotearg_colon_mem (a_arg: CE_POINTER [INTEGER_8]; a_argsize: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			Result := (quotearg_char_mem (a_arg, a_argsize, ((':').code).to_integer_8))
		end

	quotearg_n_custom (a_n: INTEGER_32; a_left_quote: CE_POINTER [INTEGER_8]; a_right_quote: CE_POINTER [INTEGER_8]; a_arg: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			Result := (quotearg_n_custom_mem (a_n, a_left_quote, a_right_quote, a_arg, (-1).to_natural_32))
		end

	quotearg_n_custom_mem (a_n: INTEGER_32; a_left_quote: CE_POINTER [INTEGER_8]; a_right_quote: CE_POINTER [INTEGER_8]; a_arg: CE_POINTER [INTEGER_8]; a_argsize: NATURAL_32): CE_POINTER [INTEGER_8]
		local
			l_o: PD_QUOTING_OPTIONS
		do
			create l_o.make

			l_o.ce_gets (default_quoting_options)
			set_custom_quoting (l_o.address, a_left_quote, a_right_quote)
			Result := (quotearg_n_options (a_n, a_arg, a_argsize, (l_o.address)))
		end

	quotearg_custom (a_left_quote: CE_POINTER [INTEGER_8]; a_right_quote: CE_POINTER [INTEGER_8]; a_arg: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			Result := (quotearg_n_custom (0, a_left_quote, a_right_quote, a_arg))
		end

	quotearg_custom_mem (a_left_quote: CE_POINTER [INTEGER_8]; a_right_quote: CE_POINTER [INTEGER_8]; a_arg: CE_POINTER [INTEGER_8]; a_argsize: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			Result := (quotearg_n_custom_mem (0, a_left_quote, a_right_quote, a_arg, a_argsize))
		end

end
