class
	P_SPIDER

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create nonexisting_urls_set.make
		end

feature {ANY} -- attributes

	nonexisting_urls_set: CE_POINTER [PD_HASH_TABLE]

feature {ANY} -- routines

	spider_cleanup
		do
			if ((nonexisting_urls_set).c_pointer /= default_pointer) then
				utils_inst.string_set_free (nonexisting_urls_set)
			end
		end

	nonexisting_url (a_url: CE_POINTER [INTEGER_8])
		local
			js: JUMP_STATE
		do
			if (res_inst.is_robots_txt_url (a_url)) then
				js.return
			end
			if not js.return_called then
				if (nonexisting_urls_set).c_pointer = default_pointer then
					nonexisting_urls_set.ce_gets (hash_inst.make_string_hash_table (0))
				end
				utils_inst.string_set_add (nonexisting_urls_set, a_url)
			end
		end

	print_broken_links
		local
			l_iter: PD_HASH_TABLE_ITERATOR
			l_num_elems: INTEGER_32
			l_url: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_iter.make
			create l_url.make

			if (nonexisting_urls_set).c_pointer = default_pointer then
				log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Found no broken links.%N%N")))])
				js.return
			end
			if not js.return_called then
				l_num_elems := hash_inst.hash_table_count (nonexisting_urls_set)
				if not (l_num_elems > 0) then
					assert_fail (ce_string ("num_elems > 0"), ce_string ("spider.c"), {NATURAL_32} 79, ce_string ("print_broken_links"))
				end
				log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (ngettext (ce_string ("Found %%d broken link.%N%N"), ce_string ("Found %%d broken links.%N%N"), l_num_elems.to_natural_32)), l_num_elems])
				hash_inst.hash_table_iterate (nonexisting_urls_set, l_iter.address)
				from
				until
					js.loop_left
				loop
					js.reset
					if not (hash_inst.hash_table_iter_next (l_iter.address)).to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_url.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (l_iter.key))
						log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("%%s%N"))), l_url])
					end
				end
				js.reset
				log_inst.logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%N"))
			end
		end

end
