class
	P_URL

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create supported_schemes.make (<<3>>)
			create urlchr_table.make (<<256>>)
			create seps.make (<<8>>)
			create parse_errors.make (<<9>>)
			create filechr_table.make (<<256>>)
		end

feature {ANY} -- attributes

	supported_schemes: CE_ARRAY [PD_SCHEME_DATA]

	urlchr_table: CE_ARRAY [NATURAL_8]

	seps: CE_ARRAY [INTEGER_8]

	parse_errors: CE_ARRAY [CE_POINTER [INTEGER_8]]

	filechr_table: CE_ARRAY [NATURAL_8]

feature {ANY} -- routines

	url_unescape (a_s: CE_POINTER [INTEGER_8])
		local
			l_t: CE_POINTER [INTEGER_8]
			l_h: CE_POINTER [INTEGER_8]
			l_c: INTEGER_8
			l_tmp___2: INTEGER_32
			l_tmp___4: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_t.make
			create l_h.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_t.ce_gets (a_s)
					l_h.ce_gets (a_s)
				when 1 then -- loop condition:
					if not ((l_h[0]).to_boolean) then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						if (l_h[0]).to_integer_32 = 37 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if: | copychar:
						l_t[0] := l_h[0]
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 5 then -- else:
						if not (l_h[1]).to_boolean then
							l_pos := -1 + 3 -- goto copychar
						elseif not (l_h[2]).to_boolean then
							l_pos := -1 + 3 -- goto copychar
						elseif (c_ctype_inst.c2_isxdigit ((l_h[1]).to_integer_32)) then
							if not (c_ctype_inst.c2_isxdigit ((l_h[2]).to_integer_32)) then
								l_pos := -1 + 3 -- goto copychar
							end
						else
							l_pos := -1 + 3 -- goto copychar
						end
				when 6 then
						if (l_h[1]).to_integer_32 < 65 then
							l_tmp___2 := (l_h[1]).to_integer_32 - 48
						else
							l_tmp___2 := ((c_ctype_inst.c2_toupper ((l_h[1]).to_integer_32)) - 65) + 10
						end
						if (l_h[2]).to_integer_32 < 65 then
							l_tmp___4 := (l_h[2]).to_integer_32 - 48
						else
							l_tmp___4 := ((c_ctype_inst.c2_toupper ((l_h[2]).to_integer_32)) - 65) + 10
						end
						l_c := (((l_tmp___2).bit_shift_left (4)) + l_tmp___4).to_integer_8
						if l_c.to_integer_32 = 0 then
							l_pos := -1 + 3 -- goto copychar
						end
				when 7 then
						l_t[0] := l_c
						l_h.ce_gets (l_h + (2))
				when 8 then -- if done
						l_h.ce_gets (l_h + 1)
						l_t.ce_gets (l_t + 1)
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
					l_t[0] := (('%/0/').code).to_integer_8
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	url_escape_1 (a_s: CE_POINTER [INTEGER_8]; a_mask: NATURAL_8; a_allow_passthrough: BOOLEAN): CE_POINTER [INTEGER_8]
		local
			l_p1: CE_POINTER [INTEGER_8]
			l_p2: CE_POINTER [INTEGER_8]
			l_newstr: CE_POINTER [INTEGER_8]
			l_newlen: INTEGER_32
			l_addition: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_c: NATURAL_8
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_p1.make
			create l_p2.make
			create l_newstr.make
			create l_tmp___0.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___7.make

			l_addition := 0
			l_p1.ce_gets (a_s)
			from
			until
				not ((l_p1[0]).to_boolean)
			loop
				if (((urlchr_table[((l_p1[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (a_mask.to_integer_32)).to_boolean then
					l_addition := l_addition + (2)
				end
				l_p1.ce_gets (l_p1 + 1)
			end
			if not l_addition.to_boolean then
				if a_allow_passthrough then
					l_tmp___0.ce_gets (a_s)
				else
					l_tmp___0.ce_gets ((xmalloc_inst.xstrdup (a_s)))
				end
				Result := l_tmp___0
				js.return
			end
			if not js.return_called then
				l_newlen := (l_p1.distance (a_s)) + l_addition
				l_newstr.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc ((l_newlen + 1).to_natural_32))))
				l_p1.ce_gets (a_s)
				l_p2.ce_gets (l_newstr)
				from
				until
					not ((l_p1[0]).to_boolean)
				loop
					if (((urlchr_table[((l_p1[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (a_mask.to_integer_32)).to_boolean then
						l_tmp___2.ce_gets (l_p1)
						l_p1.ce_gets (l_p1 + 1)
						l_c := (l_tmp___2[0]).to_natural_8
						l_tmp___3.ce_gets (l_p2)
						l_p2.ce_gets (l_p2 + 1)
						l_tmp___3[0] := (('%%').code).to_integer_8
						l_tmp___4.ce_gets (l_p2)
						l_p2.ce_gets (l_p2 + 1)
						l_tmp___4[0] := (ce_string ("0123456789ABCDEF") + ((l_c.to_integer_32).bit_shift_right (4))).item
						l_tmp___5.ce_gets (l_p2)
						l_p2.ce_gets (l_p2 + 1)
						l_tmp___5[0] := (ce_string ("0123456789ABCDEF") + ((l_c.to_integer_32).bit_and (15))).item
					else
						l_tmp___6.ce_gets (l_p2)
						l_p2.ce_gets (l_p2 + 1)
						l_tmp___7.ce_gets (l_p1)
						l_p1.ce_gets (l_p1 + 1)
						l_tmp___6[0] := l_tmp___7[0]
					end
				end
				if l_p2.distance (l_newstr) /= l_newlen then
					assert_fail (ce_string ("p2 - newstr == newlen"), ce_string ("url.c"), {NATURAL_32} 244, ce_string ("url_escape_1"))
				end
				l_p2[0] := (('%/0/').code).to_integer_8
				Result := l_newstr
			end
		end

	url_escape (a_s: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			Result := (url_escape_1 (a_s, (2).to_natural_8, (0).to_boolean))
		end

	url_escape_unsafe_and_reserved (a_s: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			Result := (url_escape_1 (a_s, (3).to_natural_8, (0).to_boolean))
		end

	url_escape_allow_passthrough (a_s: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			Result := (url_escape_1 (a_s, (2).to_natural_8, (1).to_boolean))
		end

	char_needs_escaping (a_p___0: CE_POINTER [INTEGER_8]): BOOLEAN
		do
			if (a_p___0[0]).to_integer_32 = 37 then
				if (c_ctype_inst.c2_isxdigit ((a_p___0[1]).to_integer_32)) then
					if (c_ctype_inst.c2_isxdigit ((a_p___0[2]).to_integer_32)) then
						Result := (0).to_boolean
					else
						Result := (1).to_boolean
					end
				else
					Result := (1).to_boolean
				end
			elseif (((urlchr_table[((a_p___0[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (2)).to_boolean then
				if not (((urlchr_table[((a_p___0[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (1)).to_boolean then
					Result := (1).to_boolean
				else
					Result := (0).to_boolean
				end
			else
				Result := (0).to_boolean
			end
		end

	reencode_escapes (a_s: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_p1: CE_POINTER [INTEGER_8]
			l_newstr: CE_POINTER [INTEGER_8]
			l_p2: CE_POINTER [INTEGER_8]
			l_oldlen: INTEGER_32
			l_newlen: INTEGER_32
			l_encode_count: INTEGER_32
			l_c: NATURAL_8
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_p1.make
			create l_newstr.make
			create l_p2.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make

			l_encode_count := 0
			l_p1.ce_gets (a_s)
			from
			until
				not ((l_p1[0]).to_boolean)
			loop
				if (char_needs_escaping (l_p1)) then
					l_encode_count := l_encode_count + 1
				end
				l_p1.ce_gets (l_p1 + 1)
			end
			if not l_encode_count.to_boolean then
				Result := a_s
				js.return
			end
			if not js.return_called then
				l_oldlen := l_p1.distance (a_s)
				l_newlen := l_oldlen + 2 * l_encode_count
				l_newstr.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc ((l_newlen + 1).to_natural_32))))
				l_p1.ce_gets (a_s)
				l_p2.ce_gets (l_newstr)
				from
				until
					not ((l_p1[0]).to_boolean)
				loop
					if (char_needs_escaping (l_p1)) then
						l_tmp___1.ce_gets (l_p1)
						l_p1.ce_gets (l_p1 + 1)
						l_c := (l_tmp___1[0]).to_natural_8
						l_tmp___2.ce_gets (l_p2)
						l_p2.ce_gets (l_p2 + 1)
						l_tmp___2[0] := (('%%').code).to_integer_8
						l_tmp___3.ce_gets (l_p2)
						l_p2.ce_gets (l_p2 + 1)
						l_tmp___3[0] := (ce_string ("0123456789ABCDEF") + ((l_c.to_integer_32).bit_shift_right (4))).item
						l_tmp___4.ce_gets (l_p2)
						l_p2.ce_gets (l_p2 + 1)
						l_tmp___4[0] := (ce_string ("0123456789ABCDEF") + ((l_c.to_integer_32).bit_and (15))).item
					else
						l_tmp___5.ce_gets (l_p2)
						l_p2.ce_gets (l_p2 + 1)
						l_tmp___6.ce_gets (l_p1)
						l_p1.ce_gets (l_p1 + 1)
						l_tmp___5[0] := l_tmp___6[0]
					end
				end
				l_p2[0] := (('%/0/').code).to_integer_8
				if l_p2.distance (l_newstr) /= l_newlen then
					assert_fail (ce_string ("p2 - newstr == newlen"), ce_string ("url.c"), {NATURAL_32} 419, ce_string ("reencode_escapes"))
				end
				Result := l_newstr
			end
		end

	url_scheme (a_url: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			l_i := 0
			from
			until
				not (not js.loop_left and then ((supported_schemes[l_i].leading_string).c_pointer /= default_pointer))
			loop
				if 0 = (strncasecmp (a_url, supported_schemes[l_i].leading_string, (strlen (supported_schemes[l_i].leading_string)))) then
					if not ((supported_schemes[l_i].flags).bit_and (1)).to_boolean then
						Result := l_i
						js.return
					else
						Result := ({PC_URL_SCHEME}.SCHEME_INVALID)
						js.return
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := ({PC_URL_SCHEME}.SCHEME_INVALID)
			end
		end

	url_has_scheme (a_url: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_p___0: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0.ce_gets (a_url)
			if not (l_p___0[0]).to_boolean then
				Result := (0).to_boolean
				js.return
			elseif not (c_ctype_inst.c2_isalnum ((l_p___0[0]).to_integer_32)) then
				if (l_p___0[0]).to_integer_32 /= 45 then
					if (l_p___0[0]).to_integer_32 /= 43 then
						Result := (0).to_boolean
						js.return
					end
				end
			end
			if not js.return_called then
				l_p___0.ce_gets (l_p___0 + 1)
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_p___0[0]).to_boolean then
						if not (c_ctype_inst.c2_isalnum ((l_p___0[0]).to_integer_32)) then
							if (l_p___0[0]).to_integer_32 /= 45 then
								if (l_p___0[0]).to_integer_32 /= 43 then
									js.break
								end
							end
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_p___0.ce_gets (l_p___0 + 1)
					end
				end
				js.reset
				Result := ((l_p___0[0]).to_integer_32 = 58)
			end
		end

	scheme_default_port (a_scheme: INTEGER_32): INTEGER_32
		do
			Result := (supported_schemes[a_scheme].default_port)
		end

	scheme_disable (a_scheme: INTEGER_32)
		do
			supported_schemes[a_scheme].flags := (supported_schemes[a_scheme].flags).bit_or ((1))
		end

	url_skip_credentials (a_url: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_p___0: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0.ce_gets ((strpbrk (a_url, ce_string ("@/?#;"))))
			if (l_p___0).c_pointer = default_pointer then
				Result := a_url
				js.return
			elseif (l_p___0[0]).to_integer_32 /= 64 then
				Result := a_url
				js.return
			end
			if not js.return_called then
				Result := (l_p___0 + 1)
			end
		end

	parse_credentials (a_beg: CE_POINTER [INTEGER_8]; a_end: CE_POINTER [INTEGER_8]; a_user: CE_POINTER [CE_POINTER [INTEGER_8]]; a_passwd: CE_POINTER [CE_POINTER [INTEGER_8]]): BOOLEAN
		local
			l_colon: CE_POINTER [INTEGER_8]
			l_userend: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_colon.make
			create l_userend.make

			if (a_beg.c_pointer.to_integer_32).to_natural_32 = (a_end.c_pointer.to_integer_32).to_natural_32 then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				l_colon.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((memchr (create {CE_POINTER [ANY]}.make_cast (a_beg), (':').code, (a_end.distance (a_beg)).to_natural_32))))
				if (l_colon.c_pointer.to_integer_32).to_natural_32 = (a_beg.c_pointer.to_integer_32).to_natural_32 then
					Result := (0).to_boolean
					js.return
				end
			end
			if not js.return_called then
				if ((l_colon).c_pointer /= default_pointer) then
					a_passwd.item := utils_inst.strdupdelim ((l_colon + 1), a_end)
					l_userend.ce_gets (l_colon)
					url_unescape (a_passwd.item)
				else
					a_passwd.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_userend.ce_gets (a_end)
				end
				a_user.item := utils_inst.strdupdelim (a_beg, l_userend)
				url_unescape (a_user.item)
				Result := (1).to_boolean
			end
		end

	rewrite_shorthand_url (a_url: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_ret: CE_POINTER [INTEGER_8]
			l_digits: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_ret.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (url_scheme (a_url)).to_natural_32 /= {NATURAL_32} 2 then
						Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						l_p___0.ce_gets ((strpbrk (a_url, ce_string (":/"))))
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (a_url.c_pointer.to_integer_32).to_natural_32 then
							Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							js.return
						end
					end
					if not js.return_called and then ((l_p___0).c_pointer /= default_pointer) then
						if (l_p___0[0]).to_integer_32 = 58 then
							if (l_p___0[1]).to_integer_32 = 47 then
								if (l_p___0[2]).to_integer_32 = 47 then
									Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
									js.return
								end
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						if (l_p___0).c_pointer = default_pointer then
							l_pos := -1 + 8 -- skip if block
						end
				when 2 then -- if:
						if (l_p___0[0]).to_integer_32 /= 58 then
							l_pos := -1 + 6 -- skip if block
						end
				when 3 then -- if:
						l_digits := (strspn (l_p___0 + 1, ce_string ("0123456789"))).to_integer_32
						if l_digits.to_boolean then
							if (l_p___0[(1 + l_digits)]).to_integer_32 = 47 then
								l_pos := -1 + 8 -- goto http
							elseif (l_p___0[(1 + l_digits)]).to_integer_32 = 0 then
								l_pos := -1 + 8 -- goto http
							end
						end
				when 4 then
						l_ret.ce_gets (utils_inst.aprintf ([ce_string ("ftp://%%s"), a_url]))
						l_ret[(6 + (l_p___0.distance (a_url)))] := (('/').code).to_integer_8
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_pos := -1 + 8 -- goto http
				when 7 then -- if done | if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | http:
						l_ret.ce_gets (utils_inst.aprintf ([ce_string ("http://%%s"), a_url]))
				when 9 then
						Result := l_ret
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	strpbrk_or_eos (a_s: CE_POINTER [INTEGER_8]; a_accept___0: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_p___0: CE_POINTER [INTEGER_8]
		do
			create l_p___0.make

			l_p___0.ce_gets ((strpbrk (a_s, a_accept___0)))
			if (l_p___0).c_pointer = default_pointer then
				l_p___0.ce_gets (strchr (a_s, ('%/0/').code))
			end
			Result := l_p___0
		end

	lowercase_str (a_str: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_str: CE_POINTER [INTEGER_8]
			l_changed: BOOLEAN
		do
			create l_str.make

			l_str.ce_gets (a_str)
			l_changed := (0).to_boolean
			from
			until
				not ((l_str[0]).to_boolean)
			loop
				if (c_ctype_inst.c2_isupper ((l_str[0]).to_integer_32)) then
					l_changed := (1).to_boolean
					l_str[0] := (c_ctype_inst.c2_tolower ((l_str[0]).to_integer_32)).to_integer_8
				end
				l_str.ce_gets (l_str + 1)
			end
			Result := l_changed
		end

	init_seps (a_scheme: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_flags: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
		do
			create l_p___0.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make

			l_p___0.ce_gets (seps + 2)
			l_flags := supported_schemes[a_scheme].flags
			if ((l_flags).bit_and (2)).to_boolean then
				l_tmp.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp[0] := ((';').code).to_integer_8
			end
			if ((l_flags).bit_and (4)).to_boolean then
				l_tmp___0.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___0[0] := (('?').code).to_integer_8
			end
			if ((l_flags).bit_and (8)).to_boolean then
				l_tmp___1.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___1[0] := (('#').code).to_integer_8
			end
			l_tmp___2.ce_gets (l_p___0)
			l_p___0.ce_gets (l_p___0 + 1)
			l_tmp___2[0] := (('%/0/').code).to_integer_8
			Result := seps
		end

	url_parse (a_url: CE_POINTER [INTEGER_8]; a_error___0: CE_POINTER [INTEGER_32]; a_iri: CE_POINTER [PD_IRI]; a_percent_encode: BOOLEAN): CE_POINTER [PD_URL]
		local
			l_u: CE_POINTER [PD_URL]
			l_p___0: CE_POINTER [INTEGER_8]
			l_path_modified: BOOLEAN
			l_host_modified: BOOLEAN
			l_scheme: INTEGER_32
			l_seps___0: CE_POINTER [INTEGER_8]
			l_uname_b: CE_POINTER [INTEGER_8]
			l_uname_e: CE_POINTER [INTEGER_8]
			l_host_b: CE_POINTER [INTEGER_8]
			l_host_e: CE_POINTER [INTEGER_8]
			l_path_b: CE_POINTER [INTEGER_8]
			l_path_e: CE_POINTER [INTEGER_8]
			l_params_b: CE_POINTER [INTEGER_8]
			l_params_e: CE_POINTER [INTEGER_8]
			l_query_b: CE_POINTER [INTEGER_8]
			l_query_e: CE_POINTER [INTEGER_8]
			l_fragment_b: CE_POINTER [INTEGER_8]
			l_fragment_e: CE_POINTER [INTEGER_8]
			l_port: INTEGER_32
			l_user: CE_POINTER [INTEGER_8]
			l_passwd: CE_POINTER [INTEGER_8]
			l_url_encoded: CE_POINTER [INTEGER_8]
			l_new_url: CE_POINTER [INTEGER_8]
			l_error_code: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_port_b: CE_POINTER [INTEGER_8]
			l_port_e: CE_POINTER [INTEGER_8]
			l_pp: CE_POINTER [INTEGER_8]
			l_new: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_u.make
			create l_p___0.make
			create l_seps___0.make
			create l_uname_b.make
			create l_uname_e.make
			create l_host_b.make
			create l_host_e.make
			create l_path_b.make
			create l_path_e.make
			create l_params_b.make
			create l_params_e.make
			create l_query_b.make
			create l_query_e.make
			create l_fragment_b.make
			create l_fragment_e.make
			create l_user.make
			create l_passwd.make
			create l_url_encoded.make
			create l_new_url.make
			create l_tmp___0.make
			create l_port_b.make
			create l_port_e.make
			create l_pp.make
			create l_new.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_user.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					l_passwd.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					l_url_encoded.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					l_new_url.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					l_scheme := url_scheme (a_url)
					if l_scheme.to_natural_32 = {NATURAL_32} 2 then
						if (url_has_scheme (a_url)) then
							l_error_code := 1
						else
							l_error_code := 2
						end
						l_pos := -1 + 33 -- goto error
					end
				when 1 then
					if ((a_iri).c_pointer /= default_pointer) then
						if a_iri.item.utf8_encode then
							a_iri.item.utf8_encode := (0).to_boolean
							if not a_iri.item.utf8_encode then
								l_new_url.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								a_iri.item.orig_url := xmalloc_inst.xstrdup (a_url)
							end
						end
					end
					if a_percent_encode then
						if ((l_new_url).c_pointer /= default_pointer) then
							l_tmp___0.ce_gets (l_new_url)
						else
							l_tmp___0.ce_gets (a_url)
						end
						l_url_encoded.ce_gets ((reencode_escapes (l_tmp___0)))
					elseif ((l_new_url).c_pointer /= default_pointer) then
						l_url_encoded.ce_gets (l_new_url)
					else
						l_url_encoded.ce_gets (a_url)
					end
					l_p___0.ce_gets (l_url_encoded)
					if ((l_new_url).c_pointer /= default_pointer) then
						if (l_url_encoded.c_pointer.to_integer_32).to_natural_32 /= (l_new_url.c_pointer.to_integer_32).to_natural_32 then
							free (create {CE_POINTER [ANY]}.make_cast (l_new_url))
						end
					end
					l_p___0.ce_gets (l_p___0 + (strlen (supported_schemes[l_scheme].leading_string)).to_integer_32)
					l_uname_b.ce_gets (l_p___0)
					l_p___0.ce_gets (url_skip_credentials (l_p___0))
					l_uname_e.ce_gets (l_p___0)
					l_path_e.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					l_path_b.ce_gets (l_path_e)
					l_params_e.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					l_params_b.ce_gets (l_params_e)
					l_query_e.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					l_query_b.ce_gets (l_query_e)
					l_fragment_e.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					l_fragment_b.ce_gets (l_fragment_e)
					l_seps___0.ce_gets (init_seps (l_scheme))
					l_host_b.ce_gets (l_p___0)
					if (l_p___0[0]).to_integer_32 /= 91 then
						l_pos := -1 + 6 -- skip if block
					end
				when 2 then -- if:
						l_host_b.ce_gets (l_p___0 + 1)
						l_host_e.ce_gets ((strchr (l_host_b, (']').code)))
						if (l_host_e).c_pointer = default_pointer then
							l_error_code := 6
							l_pos := -1 + 33 -- goto error
						end
				when 3 then
						if not (host_inst.is_valid_ipv6_address (l_host_b, l_host_e)) then
							l_error_code := 8
							l_pos := -1 + 33 -- goto error
						end
				when 4 then
						l_p___0.ce_gets (l_host_e + 1)
						if ((strchr (l_seps___0, (l_p___0[0]).to_integer_32))).c_pointer = default_pointer then
							l_error_code := 3
							l_pos := -1 + 33 -- goto error
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_p___0.ce_gets ((strpbrk_or_eos (l_p___0, l_seps___0)))
						l_host_e.ce_gets (l_p___0)
				when 7 then
					l_seps___0.ce_gets (l_seps___0 + 1)
					if (l_host_b.c_pointer.to_integer_32).to_natural_32 = (l_host_e.c_pointer.to_integer_32).to_natural_32 then
						l_error_code := 3
						l_pos := -1 + 33 -- goto error
					end
				when 8 then
					l_port := scheme_default_port (l_scheme)
					if (l_p___0[0]).to_integer_32 /= 58 then
						l_pos := -1 + 15 -- skip if block
					end
				when 9 then -- if:
						l_p___0.ce_gets (l_p___0 + 1)
						l_port_b.ce_gets (l_p___0)
						l_p___0.ce_gets ((strpbrk_or_eos (l_p___0, l_seps___0)))
						l_port_e.ce_gets (l_p___0)
						if (l_port_b.c_pointer.to_integer_32).to_natural_32 = (l_port_e.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if:
						l_port := 0
						l_pp.ce_gets (l_port_b)
				when 11 then -- loop condition:
						if not ((l_pp.c_pointer.to_integer_32).to_natural_32 < (l_port_e.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 15 -- skip loop
						end
				when 12 then -- loop body:
						if not (c_ctype_inst.c2_isdigit ((l_pp[0]).to_integer_32)) then
							l_error_code := 4
							l_pos := -1 + 33 -- goto error
						end
				when 13 then
						l_port := 10 * l_port + ((l_pp[0]).to_integer_32 - 48)
						if l_port > 65535 then
							l_error_code := 4
							l_pos := -1 + 33 -- goto error
						end
				when 14 then
						l_pp.ce_gets (l_pp + 1)
						l_pos := -1 + 11 -- back to loop condition
				when 15 then -- loop done | if done | if done
						l_seps___0.ce_gets (l_seps___0 + 1)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_p___0[0]).to_integer_32 = 47 then
								l_p___0.ce_gets (l_p___0 + 1)
								l_path_b.ce_gets (l_p___0)
								l_p___0.ce_gets ((strpbrk_or_eos (l_p___0, l_seps___0)))
								l_path_e.ce_gets (l_p___0)
							end
							l_seps___0.ce_gets (l_seps___0 + 1)
							js.break
						end
						js.reset
						if ((supported_schemes[l_scheme].flags).bit_and (2)).to_boolean then
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_p___0[0]).to_integer_32 = 59 then
									l_p___0.ce_gets (l_p___0 + 1)
									l_params_b.ce_gets (l_p___0)
									l_p___0.ce_gets ((strpbrk_or_eos (l_p___0, l_seps___0)))
									l_params_e.ce_gets (l_p___0)
								end
								l_seps___0.ce_gets (l_seps___0 + 1)
								js.break
							end
							js.reset
						end
						if ((supported_schemes[l_scheme].flags).bit_and (4)).to_boolean then
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_p___0[0]).to_integer_32 = 63 then
									l_p___0.ce_gets (l_p___0 + 1)
									l_query_b.ce_gets (l_p___0)
									l_p___0.ce_gets ((strpbrk_or_eos (l_p___0, l_seps___0)))
									l_query_e.ce_gets (l_p___0)
								end
								l_seps___0.ce_gets (l_seps___0 + 1)
								js.break
							end
							js.reset
						end
						if ((supported_schemes[l_scheme].flags).bit_and (8)).to_boolean then
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_p___0[0]).to_integer_32 = 35 then
									l_p___0.ce_gets (l_p___0 + 1)
									l_fragment_b.ce_gets (l_p___0)
									l_p___0.ce_gets ((strpbrk_or_eos (l_p___0, l_seps___0)))
									l_fragment_e.ce_gets (l_p___0)
								end
								l_seps___0.ce_gets (l_seps___0 + 1)
								js.break
							end
							js.reset
						end
						if (l_p___0[0]).to_integer_32 /= 0 then
							assert_fail (ce_string ("*p == 0"), ce_string ("url.c"), {NATURAL_32} 846, ce_string ("url_parse"))
						end
						if (l_uname_b.c_pointer.to_integer_32).to_natural_32 /= (l_uname_e.c_pointer.to_integer_32).to_natural_32 then
							if not (parse_credentials (l_uname_b, l_uname_e - 1, l_user.address, l_passwd.address)) then
								l_error_code := 5
								l_pos := -1 + 33 -- goto error
							end
						end
				when 16 then
						l_u.ce_gets (create {CE_POINTER [PD_URL]}.make_cast ((xmalloc_inst.xcalloc ((1).to_natural_32, {PD_URL}.sizeof.to_natural_32))))
						l_u.item.scheme := l_scheme
						l_u.item.host := utils_inst.strdupdelim (l_host_b, l_host_e)
						l_u.item.port := l_port
						l_u.item.user := l_user
						l_u.item.passwd := l_passwd
						l_u.item.path := utils_inst.strdupdelim (l_path_b, l_path_e)
						l_path_modified := path_simplify (l_scheme, l_u.item.path)
						split_path (l_u.item.path, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (l_u.c_pointer + {PD_URL}.dir_offset), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (l_u.c_pointer + {PD_URL}.file_offset))
						l_host_modified := lowercase_str (l_u.item.host)
						if (((strchr (l_u.item.host, ('%%').code))).c_pointer /= default_pointer) then
							url_unescape (l_u.item.host)
							l_host_modified := (1).to_boolean
							if options_inst.opt.enable_iri then
								if ((a_iri).c_pointer /= default_pointer) then
									l_new.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
									if ((l_new).c_pointer /= default_pointer) then
										free (create {CE_POINTER [ANY]}.make_cast (l_u.item.host))
										l_u.item.host := l_new
										l_host_modified := (1).to_boolean
									end
								end
							end
						end
						if ((l_params_b).c_pointer /= default_pointer) then
							l_u.item.params := utils_inst.strdupdelim (l_params_b, l_params_e)
						end
						if ((l_query_b).c_pointer /= default_pointer) then
							l_u.item.query := utils_inst.strdupdelim (l_query_b, l_query_e)
						end
						if ((l_fragment_b).c_pointer /= default_pointer) then
							l_u.item.fragment := utils_inst.strdupdelim (l_fragment_b, l_fragment_e)
						end
						if not (options_inst.opt.enable_iri) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
							l_pos := -1 + 29 -- goto _L
				when 18 then -- if block done, skip else block:
							l_pos := -1 + 32
				when 19 then -- else:
							if not l_path_modified then
								l_pos := -1 + 22 -- skip if block
							end
				when 20 then -- if:
							l_pos := -1 + 29 -- goto _L
				when 21 then -- if block done, skip else block:
							l_pos := -1 + 32
				when 22 then -- else:
							if (l_u.item.fragment).c_pointer = default_pointer then
								l_pos := -1 + 25 -- skip if block
							end
				when 23 then -- if:
							l_pos := -1 + 29 -- goto _L
				when 24 then -- if block done, skip else block:
							l_pos := -1 + 32
				when 25 then -- else:
							if not l_host_modified then
								l_pos := -1 + 28 -- skip if block
							end
				when 26 then -- if:
							l_pos := -1 + 29 -- goto _L
				when 27 then -- if block done, skip else block:
							l_pos := -1 + 32
				when 28 then -- else:
							if (l_path_b.c_pointer.to_integer_32).to_natural_32 /= (l_path_e.c_pointer.to_integer_32).to_natural_32 then
								l_pos := -1 + 31 -- skip if block
							end
				when 29 then -- if: | _L:
							l_u.item.url := url_string (l_u, {PC_URL_AUTH_MODE}.URL_AUTH_SHOW)
							if (l_url_encoded.c_pointer.to_integer_32).to_natural_32 /= (a_url.c_pointer.to_integer_32).to_natural_32 then
								free (create {CE_POINTER [ANY]}.make_cast (l_url_encoded))
							end
				when 30 then -- if block done, skip else block:
							l_pos := -1 + 32
				when 31 then -- else:
							if (l_url_encoded.c_pointer.to_integer_32).to_natural_32 = (a_url.c_pointer.to_integer_32).to_natural_32 then
								l_u.item.url := xmalloc_inst.xstrdup (a_url)
							else
								l_u.item.url := l_url_encoded
							end
				when 32 then -- if done | if done | if done | if done
							Result := l_u
							js.return
							if js.return_called then
								l_pos := -1 + 34 -- skip if block
							end
				when 33 then -- if: | error:
								if ((l_url_encoded).c_pointer /= default_pointer) then
									if (l_url_encoded.c_pointer.to_integer_32).to_natural_32 /= (a_url.c_pointer.to_integer_32).to_natural_32 then
										free (create {CE_POINTER [ANY]}.make_cast (l_url_encoded))
									end
								end
								if ((a_error___0).c_pointer /= default_pointer) then
									a_error___0.item := l_error_code
								end
								Result := (create {CE_POINTER [PD_URL]}.make_shared (default_pointer))
				when 34 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	url_error (a_url: CE_POINTER [INTEGER_8]; a_error_code: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_error___0: CE_POINTER [INTEGER_8]
			l_p___0: CE_POINTER [INTEGER_8]
			l_scheme: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
		do
			create l_error___0.make
			create l_p___0.make
			create l_scheme.make
			create l_tmp___2.make

			if a_error_code >= 0 then
				if not (a_error_code.to_natural_32 < (Pointer_bytes.to_natural_32 * (9).to_natural_32) // Pointer_bytes.to_natural_32) then
					assert_fail (ce_string ("error_code >= 0 && ((size_t) error_code) < (sizeof (parse_errors) / sizeof ((parse_errors)[0]))"), ce_string ("url.c"), {NATURAL_32} 940, ce_string ("url_error"))
				end
			else
				assert_fail (ce_string ("error_code >= 0 && ((size_t) error_code) < (sizeof (parse_errors) / sizeof ((parse_errors)[0]))"), ce_string ("url.c"), {NATURAL_32} 940, ce_string ("url_error"))
			end
			if a_error_code = 1 then
				l_scheme.ce_gets ((xmalloc_inst.xstrdup (a_url)))
				if not (url_has_scheme (a_url)) then
					assert_fail (ce_string ("url_has_scheme (url)"), ce_string ("url.c"), {NATURAL_32} 946, ce_string ("url_error"))
				end
				l_p___0.ce_gets (strchr (l_scheme, (':').code))
				if ((l_p___0).c_pointer /= default_pointer) then
					l_p___0[0] := (('%/0/').code).to_integer_8
				end
				if (strcasecmp (l_scheme, ce_string ("https"))).to_boolean then
					l_tmp___2.ce_gets (quote_inst.quote (l_scheme))
					l_error___0.ce_gets (utils_inst.aprintf ([(gettext (parse_errors[a_error_code])), l_tmp___2]))
				else
					l_error___0.ce_gets (utils_inst.aprintf ([(gettext (ce_string ("HTTPS support not compiled in")))]))
				end
				free (create {CE_POINTER [ANY]}.make_cast (l_scheme))
				Result := l_error___0
			else
				Result := (xmalloc_inst.xstrdup ((gettext (parse_errors[a_error_code]))))
			end
		end

	split_path (a_path: CE_POINTER [INTEGER_8]; a_dir: CE_POINTER [CE_POINTER [INTEGER_8]]; a_file: CE_POINTER [CE_POINTER [INTEGER_8]])
		local
			l_last_slash: CE_POINTER [INTEGER_8]
		do
			create l_last_slash.make

			l_last_slash.ce_gets ((strrchr (a_path, ('/').code)))
			if (l_last_slash).c_pointer = default_pointer then
				a_dir.item := xmalloc_inst.xstrdup (ce_string (""))
				a_file.item := xmalloc_inst.xstrdup (a_path)
			else
				a_dir.item := utils_inst.strdupdelim (a_path, l_last_slash)
				a_file.item := xmalloc_inst.xstrdup ((l_last_slash + 1))
			end
			url_unescape (a_dir.item)
			url_unescape (a_file.item)
		end

	full_path_length (a_url: CE_POINTER [PD_URL]): INTEGER_32
		local
			l_len: INTEGER_32
		do
			l_len := 0
			if ((a_url.item.path).c_pointer /= default_pointer) then
				l_len := (l_len.to_natural_32 + ({NATURAL_32} 1 + (strlen (a_url.item.path)))).to_integer_32
			end
			if ((a_url.item.params).c_pointer /= default_pointer) then
				l_len := (l_len.to_natural_32 + ({NATURAL_32} 1 + (strlen (a_url.item.params)))).to_integer_32
			end
			if ((a_url.item.query).c_pointer /= default_pointer) then
				l_len := (l_len.to_natural_32 + ({NATURAL_32} 1 + (strlen (a_url.item.query)))).to_integer_32
			end
			Result := l_len
		end

	full_path_write (a_url: CE_POINTER [PD_URL]; a_where: CE_POINTER [INTEGER_8])
		local
			l_where: CE_POINTER [INTEGER_8]
			l_f_el: CE_POINTER [INTEGER_8]
			l_l: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_f_el___0: CE_POINTER [INTEGER_8]
			l_l___0: INTEGER_32
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_f_el___1: CE_POINTER [INTEGER_8]
			l_l___1: INTEGER_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_where.make
			create l_f_el.make
			create l_tmp___0.make
			create l_f_el___0.make
			create l_tmp___2.make
			create l_f_el___1.make
			create l_tmp___4.make

			l_where.ce_gets (a_where)
			from
			until
				js.loop_left
			loop
				js.reset
				l_f_el.ce_gets (a_url.item.path)
				if ((l_f_el).c_pointer /= default_pointer) then
					l_l := (strlen (l_f_el)).to_integer_32
					l_tmp___0.ce_gets (l_where)
					l_where.ce_gets (l_where + 1)
					l_tmp___0[0] := (('/').code).to_integer_8
					memcpy (create {CE_POINTER [ANY]}.make_cast (l_where), create {CE_POINTER [ANY]}.make_cast (l_f_el), l_l.to_natural_32).do_nothing
					l_where.ce_gets (l_where + l_l)
				end
				js.break
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				l_f_el___0.ce_gets (a_url.item.params)
				if ((l_f_el___0).c_pointer /= default_pointer) then
					l_l___0 := (strlen (l_f_el___0)).to_integer_32
					l_tmp___2.ce_gets (l_where)
					l_where.ce_gets (l_where + 1)
					l_tmp___2[0] := ((';').code).to_integer_8
					memcpy (create {CE_POINTER [ANY]}.make_cast (l_where), create {CE_POINTER [ANY]}.make_cast (l_f_el___0), l_l___0.to_natural_32).do_nothing
					l_where.ce_gets (l_where + l_l___0)
				end
				js.break
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				l_f_el___1.ce_gets (a_url.item.query)
				if ((l_f_el___1).c_pointer /= default_pointer) then
					l_l___1 := (strlen (l_f_el___1)).to_integer_32
					l_tmp___4.ce_gets (l_where)
					l_where.ce_gets (l_where + 1)
					l_tmp___4[0] := (('?').code).to_integer_8
					memcpy (create {CE_POINTER [ANY]}.make_cast (l_where), create {CE_POINTER [ANY]}.make_cast (l_f_el___1), l_l___1.to_natural_32).do_nothing
					l_where.ce_gets (l_where + l_l___1)
				end
				js.break
			end
			js.reset
		end

	url_full_path (a_url: CE_POINTER [PD_URL]): CE_POINTER [INTEGER_8]
		local
			l_length: INTEGER_32
			l_full_path: CE_POINTER [INTEGER_8]
		do
			create l_full_path.make

			l_length := (full_path_length (a_url))
			l_full_path.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc ((l_length + 1).to_natural_32))))
			full_path_write (a_url, l_full_path)
			l_full_path[l_length] := (('%/0/').code).to_integer_8
			Result := l_full_path
		end

	unescape_single_char (a_str: CE_POINTER [INTEGER_8]; a_chr: INTEGER_8)
		local
			l_c1: INTEGER_8
			l_c2: INTEGER_8
			l_h: CE_POINTER [INTEGER_8]
			l_t: CE_POINTER [INTEGER_8]
		do
			create l_h.make
			create l_t.make

			l_c1 := (ce_string ("0123456789ABCDEF") + ((a_chr.to_integer_32).bit_shift_right (4))).item
			l_c2 := (ce_string ("0123456789ABCDEF") + ((a_chr.to_integer_32).bit_and (15))).item
			l_h.ce_gets (a_str)
			l_t.ce_gets (a_str)
			from
			until
				not ((l_h[0]).to_boolean)
			loop
				if (l_h[0]).to_integer_32 = 37 then
					if (l_h[1]).to_integer_32 = l_c1.to_integer_32 then
						if (l_h[2]).to_integer_32 = l_c2.to_integer_32 then
							l_t[0] := a_chr
							l_h.ce_gets (l_h + (2))
						else
							l_t[0] := l_h[0]
						end
					else
						l_t[0] := l_h[0]
					end
				else
					l_t[0] := l_h[0]
				end
				l_h.ce_gets (l_h + 1)
				l_t.ce_gets (l_t + 1)
			end
			l_t[0] := (('%/0/').code).to_integer_8
		end

	url_escape_dir (a_dir: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_newdir: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_newdir.make

			l_newdir.ce_gets ((url_escape_1 (a_dir, (3).to_natural_8, (1).to_boolean)))
			if (l_newdir.c_pointer.to_integer_32).to_natural_32 = (a_dir.c_pointer.to_integer_32).to_natural_32 then
				Result := a_dir
				js.return
			end
			if not js.return_called then
				unescape_single_char (l_newdir, (('/').code).to_integer_8)
				Result := l_newdir
			end
		end

	sync_path (a_u: CE_POINTER [PD_URL])
		local
			l_newpath: CE_POINTER [INTEGER_8]
			l_efile: CE_POINTER [INTEGER_8]
			l_edir: CE_POINTER [INTEGER_8]
			l_dirlen: INTEGER_32
			l_filelen: INTEGER_32
			l_p___0: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
		do
			create l_newpath.make
			create l_efile.make
			create l_edir.make
			create l_p___0.make
			create l_tmp___2.make

			free (create {CE_POINTER [ANY]}.make_cast (a_u.item.path))
			l_edir.ce_gets (url_escape_dir (a_u.item.dir))
			l_efile.ce_gets (url_escape_1 (a_u.item.file, (3).to_natural_8, (1).to_boolean))
			if not (l_edir[0]).to_boolean then
				l_newpath.ce_gets (xmalloc_inst.xstrdup (l_efile))
			else
				l_dirlen := (strlen (l_edir)).to_integer_32
				l_filelen := (strlen (l_efile)).to_integer_32
				l_newpath.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc ((((l_dirlen + 1) + l_filelen) + 1).to_natural_32))))
				l_p___0.ce_gets (l_newpath)
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (l_edir), l_dirlen.to_natural_32).do_nothing
				l_p___0.ce_gets (l_p___0 + l_dirlen)
				l_tmp___2.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___2[0] := (('/').code).to_integer_8
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (l_efile), l_filelen.to_natural_32).do_nothing
				l_p___0.ce_gets (l_p___0 + l_filelen)
				l_p___0[0] := (('%/0/').code).to_integer_8
			end
			a_u.item.path := l_newpath
			if (l_edir.c_pointer.to_integer_32).to_natural_32 /= ((a_u.item.dir).c_pointer.to_integer_32).to_natural_32 then
				free (create {CE_POINTER [ANY]}.make_cast (l_edir))
			end
			if (l_efile.c_pointer.to_integer_32).to_natural_32 /= ((a_u.item.file).c_pointer.to_integer_32).to_natural_32 then
				free (create {CE_POINTER [ANY]}.make_cast (l_efile))
			end
			free (create {CE_POINTER [ANY]}.make_cast (a_u.item.url))
			a_u.item.url := url_string (a_u, {PC_URL_AUTH_MODE}.URL_AUTH_SHOW)
		end

	url_set_dir (a_url: CE_POINTER [PD_URL]; a_newdir: CE_POINTER [INTEGER_8])
		do
			free (create {CE_POINTER [ANY]}.make_cast (a_url.item.dir))
			a_url.item.dir := xmalloc_inst.xstrdup (a_newdir)
			sync_path (a_url)
		end

	url_set_file (a_url: CE_POINTER [PD_URL]; a_newfile: CE_POINTER [INTEGER_8])
		do
			free (create {CE_POINTER [ANY]}.make_cast (a_url.item.file))
			a_url.item.file := xmalloc_inst.xstrdup (a_newfile)
			sync_path (a_url)
		end

	url_free (a_url: CE_POINTER [PD_URL])
		do
			free (create {CE_POINTER [ANY]}.make_cast (a_url.item.host))
			free (create {CE_POINTER [ANY]}.make_cast (a_url.item.path))
			free (create {CE_POINTER [ANY]}.make_cast (a_url.item.url))
			if ((a_url.item.params).c_pointer /= default_pointer) then
				free (create {CE_POINTER [ANY]}.make_cast (a_url.item.params))
			end
			if ((a_url.item.query).c_pointer /= default_pointer) then
				free (create {CE_POINTER [ANY]}.make_cast (a_url.item.query))
			end
			if ((a_url.item.fragment).c_pointer /= default_pointer) then
				free (create {CE_POINTER [ANY]}.make_cast (a_url.item.fragment))
			end
			if ((a_url.item.user).c_pointer /= default_pointer) then
				free (create {CE_POINTER [ANY]}.make_cast (a_url.item.user))
			end
			if ((a_url.item.passwd).c_pointer /= default_pointer) then
				free (create {CE_POINTER [ANY]}.make_cast (a_url.item.passwd))
			end
			free (create {CE_POINTER [ANY]}.make_cast (a_url.item.dir))
			free (create {CE_POINTER [ANY]}.make_cast (a_url.item.file))
			free (create {CE_POINTER [ANY]}.make_cast (a_url))
		end

	mkalldirs (a_path: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_t: CE_POINTER [INTEGER_8]
			l_st: SD_STAT
			l_res___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_t.make
			create l_st.make

			l_p___0.ce_gets (a_path + (strlen (a_path)).to_integer_32)
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_p___0[0]).to_integer_32 /= 47 then
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (a_path.c_pointer.to_integer_32).to_natural_32 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_p___0.ce_gets (l_p___0 - 1)
				end
			end
			js.reset
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (a_path.c_pointer.to_integer_32).to_natural_32 then
				if (l_p___0[0]).to_integer_32 /= 47 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_t.ce_gets (utils_inst.strdupdelim (a_path, l_p___0))
				if (stat (l_t, (l_st.address))) = 0 then
					if ((l_st.st_mode).bit_and ({NATURAL_32} 61440)) = {NATURAL_32} 16384 then
						free (create {CE_POINTER [ANY]}.make_cast (l_t))
						Result := 0
						js.return
					else
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("Removing %%s because of directory danger!%N"), l_t])
							end
							js.break
						end
						js.reset
						unlink (l_t).do_nothing
					end
				end
			end
			if not js.return_called then
				l_res___0 := utils_inst.make_directory (l_t)
				if l_res___0 /= 0 then
					log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s"), l_t, (strerror ((errno_location).item))])
				end
				free (create {CE_POINTER [ANY]}.make_cast (l_t))
				Result := l_res___0
			end
		end

	append_string (a_str: CE_POINTER [INTEGER_8]; a_dest: CE_POINTER [PD_GROWABLE])
		local
			l_l: INTEGER_32
			l_G_: CE_POINTER [PD_GROWABLE]
			l_DR_needed_size: INTEGER_32
			l_DR_newsize: INTEGER_32
			js: JUMP_STATE
		do
			create l_G_.make

			l_l := (strlen (a_str)).to_integer_32
			from
			until
				js.loop_left
			loop
				js.reset
				l_G_.ce_gets (a_dest)
				from
				until
					js.loop_left
				loop
					js.reset
					l_DR_needed_size := (l_G_.item.tail + l_l).to_integer_32
					l_DR_newsize := 0
					from
					until
						not ((l_G_.item.size).to_integer_32 < l_DR_needed_size)
					loop
						l_DR_newsize := ((l_G_.item.size).bit_shift_left (1)).to_integer_32
						if l_DR_newsize < 16 then
							l_DR_newsize := 16
						end
						l_G_.item.size := l_DR_newsize.to_integer_32
					end
					if l_DR_newsize.to_boolean then
						l_G_.item.base := create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (l_G_.item.base), (l_DR_newsize.to_natural_32 * (Integer_8_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					js.break
				end
				js.reset
				js.break
			end
			js.reset
			memcpy (create {CE_POINTER [ANY]}.make_cast ((a_dest.item.base + a_dest.item.tail)), create {CE_POINTER [ANY]}.make_cast (a_str), l_l.to_natural_32).do_nothing
			a_dest.item.tail := a_dest.item.tail + l_l
		end

	append_char (a_ch: INTEGER_8; a_dest: CE_POINTER [PD_GROWABLE])
		local
			l_G_: CE_POINTER [PD_GROWABLE]
			l_DR_needed_size: INTEGER_32
			l_DR_newsize: INTEGER_32
			js: JUMP_STATE
		do
			create l_G_.make

			from
			until
				js.loop_left
			loop
				js.reset
				l_G_.ce_gets (a_dest)
				from
				until
					js.loop_left
				loop
					js.reset
					l_DR_needed_size := (l_G_.item.tail + 1).to_integer_32
					l_DR_newsize := 0
					from
					until
						not ((l_G_.item.size).to_integer_32 < l_DR_needed_size)
					loop
						l_DR_newsize := ((l_G_.item.size).bit_shift_left (1)).to_integer_32
						if l_DR_newsize < 16 then
							l_DR_newsize := 16
						end
						l_G_.item.size := l_DR_newsize.to_integer_32
					end
					if l_DR_newsize.to_boolean then
						l_G_.item.base := create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (l_G_.item.base), (l_DR_newsize.to_natural_32 * (Integer_8_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					js.break
				end
				js.reset
				js.break
			end
			js.reset
			a_dest.item.base[a_dest.item.tail] := a_ch
			a_dest.item.tail := (a_dest.item.tail) + 1
		end

	append_uri_pathel (a_b: CE_POINTER [INTEGER_8]; a_e: CE_POINTER [INTEGER_8]; a_escaped: BOOLEAN; a_dest: CE_POINTER [PD_GROWABLE])
		local
			l_b: CE_POINTER [INTEGER_8]
			l_e: CE_POINTER [INTEGER_8]
			l_p___0: CE_POINTER [INTEGER_8]
			l_quoted: INTEGER_32
			l_outlen: INTEGER_32
			l_mask: INTEGER_32
			l_unescaped: CE_POINTER [INTEGER_8]
			l_BTA_beg: CE_POINTER [INTEGER_8]
			l_BTA_len: INTEGER_32
			l_BTA_dest: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_G_: CE_POINTER [PD_GROWABLE]
			l_DR_needed_size: INTEGER_32
			l_DR_newsize: INTEGER_32
			l_q: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_ch: NATURAL_8
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_q___0: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_b.make
			create l_e.make
			create l_p___0.make
			create l_unescaped.make
			create l_BTA_beg.make
			create l_BTA_dest.make
			create l_G_.make
			create l_q.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_q___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_b.ce_gets (a_b)
					l_e.ce_gets (a_e)
					if (options_inst.opt.restrict_files_os).to_natural_32 = {NATURAL_32} 0 then
						l_mask := 1
					else
						l_mask := 2
					end
					if options_inst.opt.restrict_files_ctrl then
						l_mask := (l_mask).bit_or ((4))
					end
					if a_escaped then
						from
						until
							js.loop_left
						loop
							js.reset
							l_BTA_beg.ce_gets (l_b)
							l_BTA_len := l_e.distance (l_BTA_beg)
							l_BTA_dest.ce_gets (l_unescaped.address)
							l_BTA_dest.item := create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new ((l_BTA_len + 1).to_natural_32)))
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_BTA_dest.item), create {CE_POINTER [ANY]}.make_cast (l_BTA_beg), l_BTA_len.to_natural_32).do_nothing
							l_BTA_dest.item[l_BTA_len] := (('%/0/').code).to_integer_8
							js.break
						end
						js.reset
						url_unescape (l_unescaped)
						l_b.ce_gets (l_unescaped)
						l_e.ce_gets ((l_unescaped + (strlen (l_unescaped)).to_integer_32))
					end
					if l_e.distance (l_b) = 2 then
						if (l_b[0]).to_integer_32 = 46 then
							if (l_b[1]).to_integer_32 = 46 then
								l_b.ce_gets (ce_string ("%%2E%%2E"))
								l_e.ce_gets (l_b + 6)
							end
						end
					end
					l_quoted := 0
					l_p___0.ce_gets (l_b)
				when 1 then -- loop condition:
					if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_e.c_pointer.to_integer_32).to_natural_32) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						if not (options_inst.opt.restrict_files_nonascii) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (c_ctype_inst.c2_isascii (((l_p___0[0]).to_natural_8).to_integer_32)) then
							l_pos := -1 + 5 -- goto _L
						else
							l_quoted := l_quoted + 1
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if (((filechr_table[((l_p___0[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (l_mask)).to_boolean then
							l_quoted := l_quoted + 1
						end
				when 6 then
						l_p___0.ce_gets (l_p___0 + 1)
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					l_outlen := (l_e.distance (l_b)) + 2 * l_quoted
					from
					until
						js.loop_left
					loop
						js.reset
						l_G_.ce_gets (a_dest)
						from
						until
							js.loop_left
						loop
							js.reset
							l_DR_needed_size := (l_G_.item.tail + l_outlen).to_integer_32
							l_DR_newsize := 0
							from
							until
								not ((l_G_.item.size).to_integer_32 < l_DR_needed_size)
							loop
								l_DR_newsize := ((l_G_.item.size).bit_shift_left (1)).to_integer_32
								if l_DR_newsize < 16 then
									l_DR_newsize := 16
								end
								l_G_.item.size := l_DR_newsize.to_integer_32
							end
							if l_DR_newsize.to_boolean then
								l_G_.item.base := create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (l_G_.item.base), (l_DR_newsize.to_natural_32 * (Integer_8_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							js.break
						end
						js.reset
						js.break
					end
					js.reset
					if l_quoted.to_boolean then
						l_pos := -1 + 10 -- skip if block
					end
				when 8 then -- if:
						memcpy (create {CE_POINTER [ANY]}.make_cast ((a_dest.item.base + a_dest.item.tail)), create {CE_POINTER [ANY]}.make_cast (l_b), l_outlen.to_natural_32).do_nothing
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 10 then -- else:
						l_q.ce_gets (a_dest.item.base + a_dest.item.tail)
						l_p___0.ce_gets (l_b)
				when 11 then -- loop condition:
						if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_e.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 20 -- skip loop
						end
				when 12 then -- loop body:
						if not (options_inst.opt.restrict_files_nonascii) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if (c_ctype_inst.c2_isascii (((l_p___0[0]).to_natural_8).to_integer_32)) then
							l_pos := -1 + 15 -- goto _L___1
						else
							l_pos := -1 + 16 -- goto _L___0
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 15 then -- else: | _L___1:
						if not ((((filechr_table[((l_p___0[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (l_mask)).to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if: | _L___0:
						l_ch := (l_p___0[0]).to_natural_8
						l_tmp___4.ce_gets (l_q)
						l_q.ce_gets (l_q + 1)
						l_tmp___4[0] := (('%%').code).to_integer_8
						l_tmp___5.ce_gets (l_q)
						l_q.ce_gets (l_q + 1)
						l_tmp___5[0] := (ce_string ("0123456789ABCDEF") + ((l_ch.to_integer_32).bit_shift_right (4))).item
						l_tmp___6.ce_gets (l_q)
						l_q.ce_gets (l_q + 1)
						l_tmp___6[0] := (ce_string ("0123456789ABCDEF") + ((l_ch.to_integer_32).bit_and (15))).item
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						l_tmp___3.ce_gets (l_q)
						l_q.ce_gets (l_q + 1)
						l_tmp___3[0] := l_p___0[0]
				when 19 then -- if done
						l_p___0.ce_gets (l_p___0 + 1)
						l_pos := -1 + 11 -- back to loop condition
				when 20 then -- loop done
						if l_q.distance ((a_dest.item.base + a_dest.item.tail)) /= l_outlen then
							assert_fail (ce_string ("q - ((dest)->base + (dest)->tail) == outlen"), ce_string ("url.c"), {NATURAL_32} 1433, ce_string ("append_uri_pathel"))
						end
				when 21 then -- if done
					if (options_inst.opt.restrict_files_case).to_natural_32 /= {NATURAL_32} 1 then
						l_pos := -1 + 24 -- skip if block
					end
				when 22 then -- if:
						l_pos := -1 + 25 -- goto _L___2
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 24 then -- else:
						if (options_inst.opt.restrict_files_case).to_natural_32 /= {NATURAL_32} 2 then
							l_pos := -1 + 26 -- skip if block
						end
				when 25 then -- if: | _L___2:
						l_q___0.ce_gets (a_dest.item.base + a_dest.item.tail)
						from
						until
							not ((l_q___0.c_pointer.to_integer_32).to_natural_32 < (((a_dest.item.base + a_dest.item.tail) + l_outlen).c_pointer.to_integer_32).to_natural_32)
						loop
							if (options_inst.opt.restrict_files_case).to_natural_32 = {NATURAL_32} 1 then
								l_q___0[0] := (c_ctype_inst.c2_tolower ((l_q___0[0]).to_integer_32)).to_integer_8
							else
								l_q___0[0] := (c_ctype_inst.c2_toupper ((l_q___0[0]).to_integer_32)).to_integer_8
							end
							l_q___0.ce_gets (l_q___0 + 1)
						end
				when 26 then -- if done
						a_dest.item.tail := a_dest.item.tail + l_outlen
				when 27 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	append_dir_structure (a_u: CE_POINTER [PD_URL]; a_dest: CE_POINTER [PD_GROWABLE])
		local
			l_pathel: CE_POINTER [INTEGER_8]
			l_next: CE_POINTER [INTEGER_8]
			l_cut: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_pathel.make
			create l_next.make

			l_cut := options_inst.opt.cut_dirs
			l_pathel.ce_gets (a_u.item.path)
			from
			until
				js.loop_left
			loop
				js.reset
				l_next.ce_gets (strchr (l_pathel, ('/').code))
				if (l_next.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					js.break
				end
				if not js.loop_jumped then
					l_tmp := l_cut
					l_cut := l_cut - 1
					if l_tmp > 0 then
						js.continue
					end
				end
				if not js.loop_jumped and then ((l_pathel.c_pointer.to_integer_32).to_natural_32 = (l_next.c_pointer.to_integer_32).to_natural_32) then
					js.continue
				end
				if not js.loop_jumped then
					if (a_dest.item.tail).to_boolean then
						append_char ((('/').code).to_integer_8, a_dest)
					end
					append_uri_pathel (l_pathel, l_next, (1).to_boolean, a_dest)
				end
				if not js.loop_left then
					l_pathel.ce_gets (l_next + 1)
				end
			end
			js.reset
		end

	url_file_name (a_u: CE_POINTER [PD_URL]): CE_POINTER [INTEGER_8]
		local
			l_fnres: PD_GROWABLE
			l_u_file: CE_POINTER [INTEGER_8]
			l_u_query: CE_POINTER [INTEGER_8]
			l_fname: CE_POINTER [INTEGER_8]
			l_unique: CE_POINTER [INTEGER_8]
			l_index_filename: CE_POINTER [INTEGER_8]
			l_portstr: CE_ARRAY [INTEGER_8]
			l_tmp___0: INTEGER_32
			l_tmp___3: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_fnres.make
			create l_u_file.make
			create l_u_query.make
			create l_fname.make
			create l_unique.make
			create l_index_filename.make
			create l_portstr.make (<<24>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_index_filename.ce_gets (ce_string ("index.html"))
					l_fnres.base := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_fnres.size := 0
					l_fnres.tail := 0
					if ((options_inst.opt.default_page).c_pointer /= default_pointer) then
						l_index_filename.ce_gets (options_inst.opt.default_page)
					end
					if ((options_inst.opt.dir_prefix).c_pointer /= default_pointer) then
						append_string (options_inst.opt.dir_prefix, l_fnres.address)
					end
					if options_inst.opt.dirstruct then
						if options_inst.opt.protocol_directories then
							if (l_fnres.tail).to_boolean then
								append_char ((('/').code).to_integer_8, l_fnres.address)
							end
							append_string (supported_schemes[a_u.item.scheme].name, l_fnres.address)
						end
						if options_inst.opt.add_hostdir then
							if (l_fnres.tail).to_boolean then
								append_char ((('/').code).to_integer_8, l_fnres.address)
							end
							if 0 /= (strcmp (a_u.item.host, ce_string (".."))) then
								append_string (a_u.item.host, l_fnres.address)
							else
								append_string (ce_string ("%%2E%%2E"), l_fnres.address)
							end
							if a_u.item.port /= (scheme_default_port (a_u.item.scheme)) then
								utils_inst.number_to_string (l_portstr, (a_u.item.port).to_integer_64).do_nothing
								if (options_inst.opt.restrict_files_os).to_natural_32 /= {NATURAL_32} 1 then
									l_tmp___0 := (':').code
								else
									l_tmp___0 := ('+').code
								end
								append_char (l_tmp___0.to_integer_8, l_fnres.address)
								append_string (l_portstr, l_fnres.address)
							end
						end
						append_dir_structure (a_u, l_fnres.address)
					end
					if (l_fnres.tail).to_boolean then
						append_char ((('/').code).to_integer_8, l_fnres.address)
					end
					if ((a_u.item.file).item).to_boolean then
						l_u_file.ce_gets (a_u.item.file)
					else
						l_u_file.ce_gets (l_index_filename)
					end
					append_uri_pathel (l_u_file, l_u_file + (strlen (l_u_file)).to_integer_32, (0).to_boolean, l_fnres.address)
					if ((a_u.item.query).c_pointer /= default_pointer) then
						if ((a_u.item.query).item).to_boolean then
							l_u_query.ce_gets (a_u.item.query)
						else
							l_u_query.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
						end
					else
						l_u_query.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					end
					if ((l_u_query).c_pointer /= default_pointer) then
						if (options_inst.opt.restrict_files_os).to_natural_32 /= {NATURAL_32} 1 then
							l_tmp___3 := ('?').code
						else
							l_tmp___3 := ('@').code
						end
						append_char (l_tmp___3.to_integer_8, l_fnres.address)
						append_uri_pathel (l_u_query, l_u_query + (strlen (l_u_query)).to_integer_32, (1).to_boolean, l_fnres.address)
					end
					append_char ((('%/0/').code).to_integer_8, l_fnres.address)
					l_fname.ce_gets (l_fnres.base)
					if not (options_inst.opt.noclobber) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if not (options_inst.opt.always_rest) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if not (options_inst.opt.timestamping) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if not (options_inst.opt.dirstruct) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L___0:
						if (utils_inst.file_exists_p (l_fname)) then
							if (utils_inst.file_non_directory_p (l_fname)) then
								l_unique.ce_gets (l_fname)
							else
								l_pos := -1 + 12 -- goto _L
							end
						else
							l_unique.ce_gets (l_fname)
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						l_unique.ce_gets (utils_inst.unique_name (l_fname, (1).to_boolean))
						if (l_unique.c_pointer.to_integer_32).to_natural_32 /= (l_fname.c_pointer.to_integer_32).to_natural_32 then
							free (create {CE_POINTER [ANY]}.make_cast (l_fname))
						end
				when 13 then -- if done | if done | if done
						Result := l_unique
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	path_simplify (a_scheme: INTEGER_32; a_path: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_h: CE_POINTER [INTEGER_8]
			l_t: CE_POINTER [INTEGER_8]
			l_beg: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_h.make
			create l_t.make
			create l_beg.make
			create l_end.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_h.ce_gets (a_path)
					l_t.ce_gets (a_path)
					l_beg.ce_gets (a_path)
					l_end.ce_gets ((strchr (a_path, ('%/0/').code)))
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_h.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32)) then
						l_pos := -1 + 20 -- skip loop
					end
				when 2 then -- loop body:
						if (l_h[0]).to_integer_32 /= 46 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (l_h[1]).to_integer_32 = 47 then
							l_h.ce_gets (l_h + (2))
						elseif (l_h[1]).to_integer_32 = 0 then
							l_h.ce_gets (l_h + (2))
						else
							l_pos := -1 + 5 -- goto _L___2
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 5 then -- else: | _L___2:
						if (l_h[0]).to_integer_32 /= 46 then
							l_pos := -1 + 18 -- skip if block
						end
				when 6 then -- if:
						if (l_h[1]).to_integer_32 /= 46 then
							l_pos := -1 + 16 -- skip if block
						end
				when 7 then -- if:
						if (l_h[2]).to_integer_32 /= 47 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L___0
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 10 then -- else:
						if (l_h[2]).to_integer_32 /= 0 then
							l_pos := -1 + 14 -- skip if block
						end
				when 11 then -- if: | _L___0:
						if (l_t.c_pointer.to_integer_32).to_natural_32 > (l_beg.c_pointer.to_integer_32).to_natural_32 then
							l_t.ce_gets (l_t - 1)
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_t.c_pointer.to_integer_32).to_natural_32 > (l_beg.c_pointer.to_integer_32).to_natural_32 then
									if (l_t[-1]).to_integer_32 = 47 then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_t.ce_gets (l_t - 1)
								end
							end
							js.reset
						elseif a_scheme.to_natural_32 = {NATURAL_32} 1 then
							l_beg.ce_gets (l_t + 3)
							l_pos := -1 + 18 -- goto regular
						end
				when 12 then
						l_h.ce_gets (l_h + (3))
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						l_pos := -1 + 18 -- goto regular
				when 15 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						l_pos := -1 + 18 -- goto regular
				when 17 then -- if done | if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | regular:
						if (l_t.c_pointer.to_integer_32).to_natural_32 = (l_h.c_pointer.to_integer_32).to_natural_32 then
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_h.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
									if (l_h[0]).to_integer_32 = 47 then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_t.ce_gets (l_t + 1)
									l_h.ce_gets (l_h + 1)
								end
							end
							js.reset
							if (l_h.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
								l_t.ce_gets (l_t + 1)
								l_h.ce_gets (l_h + 1)
							end
						else
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_h.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
									if (l_h[0]).to_integer_32 = 47 then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_tmp___0.ce_gets (l_t)
									l_t.ce_gets (l_t + 1)
									l_tmp___1.ce_gets (l_h)
									l_h.ce_gets (l_h + 1)
									l_tmp___0[0] := l_tmp___1[0]
								end
							end
							js.reset
							if (l_h.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
								l_tmp___2.ce_gets (l_t)
								l_t.ce_gets (l_t + 1)
								l_tmp___3.ce_gets (l_h)
								l_h.ce_gets (l_h + 1)
								l_tmp___2[0] := l_tmp___3[0]
							end
						end
				when 19 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 20 then -- loop done
					if (l_t.c_pointer.to_integer_32).to_natural_32 /= (l_h.c_pointer.to_integer_32).to_natural_32 then
						l_t[0] := (('%/0/').code).to_integer_8
					end
					Result := ((l_t.c_pointer.to_integer_32).to_natural_32 /= (l_h.c_pointer.to_integer_32).to_natural_32)
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	path_end (a_url: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_scheme: INTEGER_32
			l_seps___0: CE_POINTER [INTEGER_8]
		do
			create l_seps___0.make

			l_scheme := (url_scheme (a_url))
			if l_scheme.to_natural_32 = {NATURAL_32} 2 then
				l_scheme := {PC_URL_SCHEME}.SCHEME_HTTP
			end
			l_seps___0.ce_gets ((init_seps (l_scheme)) + 2)
			Result := (strpbrk_or_eos (a_url, l_seps___0))
		end

	uri_merge (a_base: CE_POINTER [INTEGER_8]; a_link___0: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_linklength: INTEGER_32
			l_end: CE_POINTER [INTEGER_8]
			l_merge: CE_POINTER [INTEGER_8]
			l_baselength: INTEGER_32
			l_baselength___0: INTEGER_32
			l_end1: CE_POINTER [INTEGER_8]
			l_span: INTEGER_32
			l_slash: CE_POINTER [INTEGER_8]
			l_start_insert: CE_POINTER [INTEGER_8]
			l_span___0: INTEGER_32
			l_slash___0: CE_POINTER [INTEGER_8]
			l_start_insert___0: CE_POINTER [INTEGER_8]
			l_pos2: CE_POINTER [INTEGER_8]
			l_seen_slash_slash: BOOLEAN
			l_need_explicit_slash: BOOLEAN
			l_span___1: INTEGER_32
			l_start_insert___1: CE_POINTER [INTEGER_8]
			l_last_slash: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_end.make
			create l_merge.make
			create l_end1.make
			create l_slash.make
			create l_start_insert.make
			create l_slash___0.make
			create l_start_insert___0.make
			create l_pos2.make
			create l_start_insert___1.make
			create l_last_slash.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (url_has_scheme (a_link___0)) then
						Result := (xmalloc_inst.xstrdup (a_link___0))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 29 -- skip if block
					end
				when 1 then -- if:
						l_end.ce_gets (path_end (a_base))
						l_linklength := (strlen (a_link___0)).to_integer_32
						if (a_link___0[0]).to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						Result := (xmalloc_inst.xstrdup (a_base))
						js.return
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 4 then -- else:
						if (a_link___0[0]).to_integer_32 /= 63 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_baselength := l_end.distance (a_base)
						l_merge.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc (((l_baselength + l_linklength) + 1).to_natural_32))))
						memcpy (create {CE_POINTER [ANY]}.make_cast (l_merge), create {CE_POINTER [ANY]}.make_cast (a_base), l_baselength.to_natural_32).do_nothing
						memcpy (create {CE_POINTER [ANY]}.make_cast ((l_merge + l_baselength)), create {CE_POINTER [ANY]}.make_cast (a_link___0), l_linklength.to_natural_32).do_nothing
						l_merge[(l_baselength + l_linklength)] := (('%/0/').code).to_integer_8
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 7 then -- else:
						if (a_link___0[0]).to_integer_32 /= 35 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_end1.ce_gets ((strchr (a_base, ('#').code)))
						if (l_end1).c_pointer = default_pointer then
							l_end1.ce_gets (a_base + (strlen (a_base)).to_integer_32)
						end
						l_baselength___0 := l_end1.distance (a_base)
						l_merge.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc (((l_baselength___0 + l_linklength) + 1).to_natural_32))))
						memcpy (create {CE_POINTER [ANY]}.make_cast (l_merge), create {CE_POINTER [ANY]}.make_cast (a_base), l_baselength___0.to_natural_32).do_nothing
						memcpy (create {CE_POINTER [ANY]}.make_cast ((l_merge + l_baselength___0)), create {CE_POINTER [ANY]}.make_cast (a_link___0), l_linklength.to_natural_32).do_nothing
						l_merge[(l_baselength___0 + l_linklength)] := (('%/0/').code).to_integer_8
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 10 then -- else:
						if (a_link___0[0]).to_integer_32 /= 47 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if (a_link___0[1]).to_integer_32 = 47 then
							l_slash.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((memchr (create {CE_POINTER [ANY]}.make_cast (a_base), ('/').code, (l_end.distance (a_base)).to_natural_32))))
							if ((l_slash).c_pointer /= default_pointer) then
								if (l_slash[1]).to_integer_32 = 47 then
									l_start_insert.ce_gets (l_slash)
								else
									l_start_insert.ce_gets (a_base)
								end
							else
								l_start_insert.ce_gets (a_base)
							end
							l_span := l_start_insert.distance (a_base)
							l_merge.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc (((l_span + l_linklength) + 1).to_natural_32))))
							if l_span.to_boolean then
								memcpy (create {CE_POINTER [ANY]}.make_cast (l_merge), create {CE_POINTER [ANY]}.make_cast (a_base), l_span.to_natural_32).do_nothing
							end
							memcpy (create {CE_POINTER [ANY]}.make_cast ((l_merge + l_span)), create {CE_POINTER [ANY]}.make_cast (a_link___0), l_linklength.to_natural_32).do_nothing
							l_merge[(l_span + l_linklength)] := (('%/0/').code).to_integer_8
						else
							l_pos := -1 + 13 -- goto _L___2
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 13 then -- else: | _L___2:
						if (a_link___0[0]).to_integer_32 /= 47 then
							l_pos := -1 + 28 -- skip if block
						end
				when 14 then -- if:
						l_start_insert___0.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
						l_pos2.ce_gets (a_base)
						l_seen_slash_slash := (0).to_boolean
				when 15 then -- again:
						l_slash___0.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((memchr (create {CE_POINTER [ANY]}.make_cast (l_pos2), ('/').code, (l_end.distance (l_pos2)).to_natural_32))))
						if ((l_slash___0).c_pointer /= default_pointer) then
							if not l_seen_slash_slash then
								if (l_slash___0[1]).to_integer_32 = 47 then
									l_pos2.ce_gets (l_slash___0 + 2)
									l_seen_slash_slash := (1).to_boolean
									l_pos := -1 + 15 -- goto again
								end
							end
						end
				when 16 then
						if ((l_slash___0).c_pointer /= default_pointer) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if not l_seen_slash_slash then
							l_start_insert___0.ce_gets (a_base)
						else
							l_pos := -1 + 19 -- goto _L___1
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 19 then -- else: | _L___1:
						if ((l_slash___0).c_pointer /= default_pointer) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if l_seen_slash_slash then
							l_start_insert___0.ce_gets (l_end)
						else
							l_pos := -1 + 22 -- goto _L___0
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 22 then -- else: | _L___0:
						if (l_slash___0).c_pointer = default_pointer then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						if not l_seen_slash_slash then
							l_start_insert___0.ce_gets (a_base)
						else
							l_pos := -1 + 25 -- goto _L
						end
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else: | _L:
						if ((l_slash___0).c_pointer /= default_pointer) then
							if l_seen_slash_slash then
								l_start_insert___0.ce_gets (l_slash___0)
							end
						end
				when 26 then -- if done | if done
						l_span___0 := l_start_insert___0.distance (a_base)
						l_merge.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc (((l_span___0 + l_linklength) + 1).to_natural_32))))
						if l_span___0.to_boolean then
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_merge), create {CE_POINTER [ANY]}.make_cast (a_base), l_span___0.to_natural_32).do_nothing
						end
						memcpy (create {CE_POINTER [ANY]}.make_cast ((l_merge + l_span___0)), create {CE_POINTER [ANY]}.make_cast (a_link___0), l_linklength.to_natural_32).do_nothing
						l_merge[(l_span___0 + l_linklength)] := (('%/0/').code).to_integer_8
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:
						l_need_explicit_slash := (0).to_boolean
						l_last_slash.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((memrchr (create {CE_POINTER [ANY]}.make_cast (a_base), ('/').code, (l_end.distance (a_base)).to_natural_32))))
						if (l_last_slash).c_pointer = default_pointer then
							l_start_insert___1.ce_gets (a_base)
						elseif ((l_last_slash).c_pointer /= default_pointer) then
							if (l_last_slash.c_pointer.to_integer_32).to_natural_32 >= ((a_base + 2).c_pointer.to_integer_32).to_natural_32 then
								if (l_last_slash[-2]).to_integer_32 = 58 then
									if (l_last_slash[-1]).to_integer_32 = 47 then
										l_start_insert___1.ce_gets (l_end + 1)
										l_need_explicit_slash := (1).to_boolean
									else
										l_start_insert___1.ce_gets (l_last_slash + 1)
									end
								else
									l_start_insert___1.ce_gets (l_last_slash + 1)
								end
							else
								l_start_insert___1.ce_gets (l_last_slash + 1)
							end
						else
							l_start_insert___1.ce_gets (l_last_slash + 1)
						end
						l_span___1 := l_start_insert___1.distance (a_base)
						l_merge.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc (((l_span___1 + l_linklength) + 1).to_natural_32))))
						if l_span___1.to_boolean then
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_merge), create {CE_POINTER [ANY]}.make_cast (a_base), l_span___1.to_natural_32).do_nothing
						end
						if l_need_explicit_slash then
							l_merge[(l_span___1 - 1)] := (('/').code).to_integer_8
						end
						memcpy (create {CE_POINTER [ANY]}.make_cast ((l_merge + l_span___1)), create {CE_POINTER [ANY]}.make_cast (a_link___0), l_linklength.to_natural_32).do_nothing
						l_merge[(l_span___1 + l_linklength)] := (('%/0/').code).to_integer_8
				when 29 then -- if done | if done | if done | if done | if done
						if not js.return_called then
							Result := l_merge
						end
				when 30 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	url_string (a_url: CE_POINTER [PD_URL]; a_auth_mode: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_size: INTEGER_32
			l_result: CE_POINTER [INTEGER_8]
			l_p___0: CE_POINTER [INTEGER_8]
			l_quoted_host: CE_POINTER [INTEGER_8]
			l_quoted_user: CE_POINTER [INTEGER_8]
			l_quoted_passwd: CE_POINTER [INTEGER_8]
			l_scheme_port: INTEGER_32
			l_scheme_str: CE_POINTER [INTEGER_8]
			l_fplen: INTEGER_32
			l_brackets_around_host: BOOLEAN
			l_tmp___1: NATURAL_32
			l_tmp___2: NATURAL_32
			l_tmp___3: INTEGER_32
			l_len: INTEGER_32
			l_len___0: INTEGER_32
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_len___1: INTEGER_32
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: CE_POINTER [INTEGER_8]
			l_len___2: INTEGER_32
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___17: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_result.make
			create l_p___0.make
			create l_quoted_host.make
			create l_quoted_user.make
			create l_quoted_passwd.make
			create l_scheme_str.make
			create l_tmp___10.make
			create l_tmp___12.make
			create l_tmp___13.make
			create l_tmp___15.make
			create l_tmp___16.make
			create l_tmp___17.make

			l_quoted_user.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
			l_quoted_passwd.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
			l_scheme_port := supported_schemes[a_url.item.scheme].default_port
			l_scheme_str.ce_gets (supported_schemes[a_url.item.scheme].leading_string)
			l_fplen := (full_path_length (a_url))
			if (l_scheme_str.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				assert_fail (ce_string ("scheme_str != ((void *)0)"), ce_string ("url.c"), {NATURAL_32} 1936, ce_string ("url_string"))
			end
			if ((a_url.item.user).c_pointer /= default_pointer) then
				if a_auth_mode.to_natural_32 /= {NATURAL_32} 2 then
					l_quoted_user.ce_gets (url_escape_allow_passthrough (a_url.item.user))
					if ((a_url.item.passwd).c_pointer /= default_pointer) then
						if a_auth_mode.to_natural_32 = {NATURAL_32} 1 then
							l_quoted_passwd.ce_gets (ce_string ("*password*"))
						else
							l_quoted_passwd.ce_gets (url_escape_allow_passthrough (a_url.item.passwd))
						end
					end
				end
			end
			l_quoted_host.ce_gets (url_escape_allow_passthrough (a_url.item.host))
			if (l_quoted_host.c_pointer.to_integer_32).to_natural_32 /= ((a_url.item.host).c_pointer.to_integer_32).to_natural_32 then
				unescape_single_char (l_quoted_host, ((':').code).to_integer_8)
			end
			l_brackets_around_host := (((strchr (l_quoted_host, (':').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32)
			l_tmp___1 := strlen (l_scheme_str)
			l_tmp___2 := strlen (l_quoted_host)
			if l_brackets_around_host then
				l_tmp___3 := 2
			else
				l_tmp___3 := 0
			end
			l_size := ((((l_tmp___1 + l_tmp___2) + l_tmp___3.to_natural_32) + l_fplen.to_natural_32) + {NATURAL_32} 1).to_integer_32
			if a_url.item.port /= l_scheme_port then
				l_size := l_size + (1 + (utils_inst.numdigit ((a_url.item.port).to_integer_64)))
			end
			if ((l_quoted_user).c_pointer /= default_pointer) then
				l_size := (l_size.to_natural_32 + ({NATURAL_32} 1 + (strlen (l_quoted_user)))).to_integer_32
				if ((l_quoted_passwd).c_pointer /= default_pointer) then
					l_size := (l_size.to_natural_32 + ({NATURAL_32} 1 + (strlen (l_quoted_passwd)))).to_integer_32
				end
			end
			l_result.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc (l_size.to_natural_32))))
			l_p___0.ce_gets (l_result)
			from
			until
				js.loop_left
			loop
				js.reset
				l_len := (strlen (l_scheme_str)).to_integer_32
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (l_scheme_str), l_len.to_natural_32).do_nothing
				l_p___0.ce_gets (l_p___0 + l_len)
				js.break
			end
			js.reset
			if ((l_quoted_user).c_pointer /= default_pointer) then
				from
				until
					js.loop_left
				loop
					js.reset
					l_len___0 := (strlen (l_quoted_user)).to_integer_32
					memcpy (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (l_quoted_user), l_len___0.to_natural_32).do_nothing
					l_p___0.ce_gets (l_p___0 + l_len___0)
					js.break
				end
				js.reset
				if ((l_quoted_passwd).c_pointer /= default_pointer) then
					l_tmp___10.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___10[0] := ((':').code).to_integer_8
					from
					until
						js.loop_left
					loop
						js.reset
						l_len___1 := (strlen (l_quoted_passwd)).to_integer_32
						memcpy (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (l_quoted_passwd), l_len___1.to_natural_32).do_nothing
						l_p___0.ce_gets (l_p___0 + l_len___1)
						js.break
					end
					js.reset
				end
				l_tmp___12.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___12[0] := (('@').code).to_integer_8
			end
			if l_brackets_around_host then
				l_tmp___13.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___13[0] := (('[').code).to_integer_8
			end
			from
			until
				js.loop_left
			loop
				js.reset
				l_len___2 := (strlen (l_quoted_host)).to_integer_32
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (l_quoted_host), l_len___2.to_natural_32).do_nothing
				l_p___0.ce_gets (l_p___0 + l_len___2)
				js.break
			end
			js.reset
			if l_brackets_around_host then
				l_tmp___15.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___15[0] := ((']').code).to_integer_8
			end
			if a_url.item.port /= l_scheme_port then
				l_tmp___16.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___16[0] := ((':').code).to_integer_8
				l_p___0.ce_gets (utils_inst.number_to_string (l_p___0, (a_url.item.port).to_integer_64))
			end
			full_path_write (a_url, l_p___0)
			l_p___0.ce_gets (l_p___0 + l_fplen)
			l_tmp___17.ce_gets (l_p___0)
			l_p___0.ce_gets (l_p___0 + 1)
			l_tmp___17[0] := (('%/0/').code).to_integer_8
			if l_p___0.distance (l_result) /= l_size then
				assert_fail (ce_string ("p - result == size"), ce_string ("url.c"), {NATURAL_32} 2008, ce_string ("url_string"))
			end
			if ((l_quoted_user).c_pointer /= default_pointer) then
				if (l_quoted_user.c_pointer.to_integer_32).to_natural_32 /= ((a_url.item.user).c_pointer.to_integer_32).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_quoted_user))
				end
			end
			if ((l_quoted_passwd).c_pointer /= default_pointer) then
				if a_auth_mode.to_natural_32 = {NATURAL_32} 0 then
					if (l_quoted_passwd.c_pointer.to_integer_32).to_natural_32 /= ((a_url.item.passwd).c_pointer.to_integer_32).to_natural_32 then
						free (create {CE_POINTER [ANY]}.make_cast (l_quoted_passwd))
					end
				end
			end
			if (l_quoted_host.c_pointer.to_integer_32).to_natural_32 /= ((a_url.item.host).c_pointer.to_integer_32).to_natural_32 then
				free (create {CE_POINTER [ANY]}.make_cast (l_quoted_host))
			end
			Result := l_result
		end

	schemes_are_similar_p (a_a: INTEGER_32; a_b: INTEGER_32): BOOLEAN
		local
			js: JUMP_STATE
		do
			if a_a.to_natural_32 = a_b.to_natural_32 then
				Result := (1).to_boolean
				js.return
			end
			if not js.return_called then
				Result := (0).to_boolean
			end
		end

	getchar_from_escaped_string (a_str: CE_POINTER [INTEGER_8]; a_c: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_tmp___0: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0.ce_gets (a_str)
			if ((a_str).c_pointer /= default_pointer) then
				if not (a_str[0]).to_boolean then
					assert_fail (ce_string ("str && *str"), ce_string ("url.c"), {NATURAL_32} 2044, ce_string ("getchar_from_escaped_string"))
				end
			else
				assert_fail (ce_string ("str && *str"), ce_string ("url.c"), {NATURAL_32} 2044, ce_string ("getchar_from_escaped_string"))
			end
			if (a_c).c_pointer = default_pointer then
				assert_fail (ce_string ("c"), ce_string ("url.c"), {NATURAL_32} 2045, ce_string ("getchar_from_escaped_string"))
			end
			if (l_p___0[0]).to_integer_32 = 37 then
				if (c_ctype_inst.c2_isxdigit ((l_p___0[1]).to_integer_32)) then
					if (c_ctype_inst.c2_isxdigit ((l_p___0[2]).to_integer_32)) then
						if (l_p___0[2]).to_integer_32 = 0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							if (l_p___0[1]).to_integer_32 < 65 then
								l_tmp___0 := (l_p___0[1]).to_integer_32 - 48
							else
								l_tmp___0 := (((c_ctype_inst.c2_toupper ((l_p___0[1]).to_integer_32)) - 65) + 10)
							end
							if (l_p___0[2]).to_integer_32 < 65 then
								l_tmp___2 := (l_p___0[2]).to_integer_32 - 48
							else
								l_tmp___2 := (((c_ctype_inst.c2_toupper ((l_p___0[2]).to_integer_32)) - 65) + 10)
							end
							a_c[0] := (((l_tmp___0).bit_shift_left (4)) + l_tmp___2).to_integer_8
							if (((urlchr_table[((a_c[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (1)).to_boolean then
								a_c[0] := (('%%').code).to_integer_8
								Result := 1
								js.return
							else
								Result := 3
								js.return
							end
						end
					else
						a_c[0] := (('%%').code).to_integer_8
						Result := 1
						js.return
					end
				else
					a_c[0] := (('%%').code).to_integer_8
					Result := 1
					js.return
				end
			else
				a_c[0] := l_p___0[0]
			end
			if not js.return_called then
				Result := 1
			end
		end

	are_urls_equal (a_u1: CE_POINTER [INTEGER_8]; a_u2: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_q: CE_POINTER [INTEGER_8]
			l_pp: INTEGER_32
			l_qq: INTEGER_32
			l_ch1: INTEGER_8
			l_ch2: INTEGER_8
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_q.make

			if ((a_u1).c_pointer /= default_pointer) then
				if (a_u2).c_pointer = default_pointer then
					assert_fail (ce_string ("u1 && u2"), ce_string ("url.c"), {NATURAL_32} 2083, ce_string ("are_urls_equal"))
				end
			else
				assert_fail (ce_string ("u1 && u2"), ce_string ("url.c"), {NATURAL_32} 2083, ce_string ("are_urls_equal"))
			end
			l_p___0.ce_gets (a_u1)
			l_q.ce_gets (a_u2)
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_p___0[0]).to_boolean then
					if (l_q[0]).to_boolean then
						l_pp := getchar_from_escaped_string (l_p___0, create {CE_POINTER [INTEGER_8]}.make_shared ($l_ch1))
						if l_pp.to_boolean then
							l_qq := getchar_from_escaped_string (l_q, create {CE_POINTER [INTEGER_8]}.make_shared ($l_ch2))
							if l_qq.to_boolean then
								l_tmp := c_ctype_inst.c2_tolower (l_ch1.to_integer_32)
								if l_tmp /= (c_ctype_inst.c2_tolower (l_ch2.to_integer_32)) then
									js.break
								end
							else
								js.break
							end
						else
							js.break
						end
					else
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_p___0.ce_gets (l_p___0 + l_pp)
					l_q.ce_gets (l_q + l_qq)
				end
			end
			js.reset
			if (l_p___0[0]).to_integer_32 = 0 then
				if (l_q[0]).to_integer_32 = 0 then
					l_tmp___1 := 1
				else
					l_tmp___1 := 0
				end
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1.to_boolean
		end

end
