class
	P_UTILS

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create char_prop.make (<<256>>)
			create output.make (<<32>>)
			create cached_sep.make
			create cached_grouping.make
			create outbuf.make (<<48>>)
			create powers.make (<<6>>)
			create buf___3.make (<<8>>)
			create ring___0.make (<<3, 24>>)
			create tbl.make (<<64>>)
			create base64_char_to_value.make (<<128>>)
			create buf___4.make (<<32>>)
		end

feature {ANY} -- attributes

	char_prop: CE_ARRAY [NATURAL_8]

	output: CE_ARRAY [INTEGER_8]

	cached_sep: CE_POINTER [INTEGER_8]

	cached_grouping: CE_POINTER [INTEGER_8]

	initialized: BOOLEAN assign set_initialized

	set_initialized (a_initialized: BOOLEAN)
		do
			initialized := a_initialized
		end

	outbuf: CE_ARRAY [INTEGER_8]

	powers: CE_ARRAY [INTEGER_8]

	buf___3: CE_ARRAY [INTEGER_8]

	ring___0: CE_ARRAY [CE_ARRAY [INTEGER_8]]

	ringpos___0: INTEGER_32 assign set_ringpos___0

	set_ringpos___0 (a_ringpos___0: INTEGER_32)
		do
			ringpos___0 := a_ringpos___0
		end

	rnd_seeded: INTEGER_32 assign set_rnd_seeded

	set_rnd_seeded (a_rnd_seeded: INTEGER_32)
		do
			rnd_seeded := a_rnd_seeded
		end

	run_with_timeout_env: CE_EXCEPTION assign set_run_with_timeout_env

	set_run_with_timeout_env (a_run_with_timeout_env: CE_EXCEPTION)
		do
			run_with_timeout_env := a_run_with_timeout_env
		end

	tbl: CE_ARRAY [INTEGER_8]

	base64_char_to_value: CE_ARRAY [INTEGER_8]

	buf___4: CE_ARRAY [INTEGER_8]

feature {ANY} -- routines

	memfatal (a_context: CE_POINTER [INTEGER_8]; a_attempted_size: INTEGER_32)
		do
			log_inst.log_set_save_context ((0).to_boolean).do_nothing
			if a_attempted_size = -3 then
				log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_ALWAYS, (gettext (ce_string ("%%s: %%s: Failed to allocate enough memory; memory exhausted.%N"))), wget_inst.exec_name, a_context])
			else
				log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_ALWAYS, (gettext (ce_string ("%%s: %%s: Failed to allocate %%ld bytes; memory exhausted.%N"))), wget_inst.exec_name, a_context, a_attempted_size])
			end
			exit (1)
		end

	xstrdup_lower (a_s: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_copy: CE_POINTER [INTEGER_8]
			l_p___0: CE_POINTER [INTEGER_8]
		do
			create l_copy.make
			create l_p___0.make

			l_copy.ce_gets ((xmalloc_inst.xstrdup (a_s)))
			l_p___0.ce_gets (l_copy)
			from
			until
				not ((l_p___0[0]).to_boolean)
			loop
				l_p___0[0] := (c_ctype_inst.c2_tolower ((l_p___0[0]).to_integer_32)).to_integer_8
				l_p___0.ce_gets (l_p___0 + 1)
			end
			Result := l_copy
		end

	strdupdelim (a_beg: CE_POINTER [INTEGER_8]; a_end: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_res___0: CE_POINTER [INTEGER_8]
		do
			create l_res___0.make

			l_res___0.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc (((a_end.distance (a_beg)) + 1).to_natural_32))))
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_res___0), create {CE_POINTER [ANY]}.make_cast (a_beg), (a_end.distance (a_beg)).to_natural_32).do_nothing
			l_res___0[(a_end.distance (a_beg))] := (('%/0/').code).to_integer_8
			Result := l_res___0
		end

	sepstring (a_s: CE_POINTER [INTEGER_8]): CE_POINTER [CE_POINTER [INTEGER_8]]
		local
			l_s: CE_POINTER [INTEGER_8]
			l_res___0: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_p___0: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make
			create l_res___0.make
			create l_p___0.make

			l_s.ce_gets (a_s)
			l_i := 0
			if (l_s).c_pointer = default_pointer then
				Result := (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer))
				js.return
			elseif not (l_s[0]).to_boolean then
				Result := (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_res___0.ce_gets (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer))
				l_p___0.ce_gets (l_s)
				from
				until
					not (not js.loop_left and then ((l_s[0]).to_boolean))
				loop
					if (l_s[0]).to_integer_32 = 44 then
						l_res___0.ce_gets (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (l_res___0), (l_i + 2).to_natural_32 * Pointer_bytes.to_natural_32))))
						l_res___0[l_i] := strdupdelim (l_p___0, l_s)
						l_i := l_i + 1
						l_res___0[l_i] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						l_s.ce_gets (l_s + 1)
						from
						until
							js.loop_left
						loop
							js.reset
							if not (c_ctype_inst.c2_isspace ((l_s[0]).to_integer_32)) then
								js.break
							end
							if not js.loop_jumped then
								l_s.ce_gets (l_s + 1)
							end
						end
						js.reset
						l_p___0.ce_gets (l_s)
					else
						l_s.ce_gets (l_s + 1)
					end
				end
				l_res___0.ce_gets (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (l_res___0), (l_i + 2).to_natural_32 * Pointer_bytes.to_natural_32))))
				l_res___0[l_i] := strdupdelim (l_p___0, l_s)
				l_res___0[(l_i + 1)] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				Result := l_res___0
			end
		end

	aprintf (a_args: TUPLE [a_fmt: CE_POINTER [INTEGER_8]]): CE_POINTER [INTEGER_8]
		local
			l_ret: INTEGER_32
			l_args: CE_VA_LIST
			l_str: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_str.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					create l_args.make (a_args, 2)
					l_ret := vasprintf ((l_str.address), a_args.a_fmt, l_args)
					if not (l_ret < 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (errno_location).item = 12 then
							memfatal (ce_string ("aprintf"), -3)
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if l_ret < 0 then
							Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							js.return
						end
				when 4 then
					if not js.return_called then
						Result := l_str
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	concat_strings (a_args: TUPLE [a_str0: CE_POINTER [INTEGER_8]]): CE_POINTER [INTEGER_8]
		local
			l_args: CE_VA_LIST
			l_saved_lengths: CE_ARRAY [INTEGER_32]
			l_ret: CE_POINTER [INTEGER_8]
			l_p___0: CE_POINTER [INTEGER_8]
			l_next_str: CE_POINTER [INTEGER_8]
			l_total_length: INTEGER_32
			l_argcount: NATURAL_32
			l_len: INTEGER_32
			l_tmp___0: NATURAL_32
			l_len___0: INTEGER_32
			l_tmp___2: NATURAL_32
		do
			create l_saved_lengths.make (<<5>>)
			create l_ret.make
			create l_p___0.make
			create l_next_str.make

			l_total_length := 0
			l_argcount := (0).to_natural_32
			create l_args.make (a_args, 2)
			l_next_str.ce_gets (a_args.a_str0)
			from
			until
				(l_next_str.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
			loop
				l_len := (strlen (l_next_str)).to_integer_32
				if l_argcount < (Integer_32_bytes.to_natural_32 * (5).to_natural_32) // Integer_32_bytes.to_natural_32 then
					l_tmp___0 := l_argcount
					l_argcount := l_argcount + 1
					l_saved_lengths[l_tmp___0.to_integer_32] := l_len
				end
				l_total_length := l_total_length + l_len
				l_next_str.ce_gets ((create {CE_POINTER [INTEGER_8]}.make_cast (l_args.pointer_item)))
			end
			l_ret.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc ((l_total_length + 1).to_natural_32))))
			l_p___0.ce_gets (l_ret)
			l_argcount := (0).to_natural_32
			create l_args.make (a_args, 2)
			l_next_str.ce_gets (a_args.a_str0)
			from
			until
				(l_next_str.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
			loop
				if l_argcount < (Integer_32_bytes.to_natural_32 * (5).to_natural_32) // Integer_32_bytes.to_natural_32 then
					l_tmp___2 := l_argcount
					l_argcount := l_argcount + 1
					l_len___0 := l_saved_lengths[l_tmp___2.to_integer_32]
				else
					l_len___0 := (strlen (l_next_str)).to_integer_32
				end
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (l_next_str), l_len___0.to_natural_32).do_nothing
				l_p___0.ce_gets (l_p___0 + l_len___0)
				l_next_str.ce_gets ((create {CE_POINTER [INTEGER_8]}.make_cast (l_args.pointer_item)))
			end
			l_p___0[0] := (('%/0/').code).to_integer_8
			Result := l_ret
		end

	fmttime (a_t: INTEGER_32; a_fmt: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_t: INTEGER_32
			l_tm: CE_POINTER [SD_TM]
		do
			create l_tm.make

			l_t := a_t
			l_tm.ce_gets ((localtime ((create {CE_POINTER [INTEGER_32]}.make_shared ($l_t)))))
			if (l_tm).c_pointer = default_pointer then
				abort
			end
			if not (strftime (output, (Integer_8_bytes.to_natural_32 * (32).to_natural_32), a_fmt, l_tm)).to_boolean then
				abort
			end
			Result := output
		end

	time_str (a_t: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			Result := (fmttime (a_t, ce_string ("%%H:%%M:%%S")))
		end

	datetime_str (a_t: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			Result := (fmttime (a_t, ce_string ("%%Y-%%m-%%d %%H:%%M:%%S")))
		end

	fork_to_background
		local
			l_pid: INTEGER_32
			l_logfile_changed: BOOLEAN
			l_new_log_fp: CE_POINTER [SD_IO_FILE]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			create l_new_log_fp.make
			create l_tmp___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_logfile_changed := (0).to_boolean
					if ((options_inst.opt.lfilename).c_pointer /= default_pointer) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if options_inst.opt.quiet then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (options_inst.opt.server_response) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						l_new_log_fp.ce_gets ((unique_create (ce_string ("wget-log"), (0).to_boolean, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (options_inst.opt.c_pointer + {PD_OPTIONS}.lfilename_offset))))
						if ((l_new_log_fp).c_pointer /= default_pointer) then
							l_logfile_changed := (1).to_boolean
							fclose (l_new_log_fp).do_nothing
						end
				when 6 then -- if done | if done
						l_pid := fork
						if l_pid < 0 then
							perror (ce_string ("fork"))
							exit (1)
						elseif l_pid /= 0 then
							printf ([(gettext (ce_string ("Continuing in background, pid %%d.%N"))), l_pid]).do_nothing
							if l_logfile_changed then
								l_tmp___1.ce_gets (quote_inst.quote (options_inst.opt.lfilename))
								printf ([(gettext (ce_string ("Output will be written to %%s.%N"))), l_tmp___1]).do_nothing
							end
							exit (0)
						end
						setsid.do_nothing
						freopen (ce_string ("/dev/null"), ce_string ("r"), (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.input.file_pointer))).do_nothing
						freopen (ce_string ("/dev/null"), ce_string ("w"), (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))).do_nothing
						freopen (ce_string ("/dev/null"), ce_string ("w"), (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer))).do_nothing
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	touch (a_file: CE_POINTER [INTEGER_8]; a_tm: INTEGER_32)
		local
			l_times: SD_UTIMBUF
		do
			create l_times.make

			l_times.modtime := a_tm
			l_times.actime := time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
			if (utime (a_file, (l_times.address))) = -1 then
				log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("utime(%%s): %%s%N"), a_file, (strerror ((errno_location).item))])
			end
		end

	remove_link (a_file: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_err: INTEGER_32
			l_st: SD_STAT
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_st.make
			create l_tmp___1.make
			create l_tmp___2.make

			l_err := 0
			if (lstat (a_file, (l_st.address))) = 0 then
				if ((l_st.st_mode).bit_and ({NATURAL_32} 61440)) = {NATURAL_32} 40960 then
					from
					until
						js.loop_left
					loop
						js.reset
						if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
							log_inst.debug_logprintf ([ce_string ("Unlinking %%s (symlink).%N"), a_file])
						end
						js.break
					end
					js.reset
					l_err := unlink (a_file)
					if l_err /= 0 then
						l_tmp___1.ce_gets (strerror ((errno_location).item))
						l_tmp___2.ce_gets (quote_inst.quote (a_file))
						log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Failed to unlink symlink %%s: %%s%N"))), l_tmp___2, l_tmp___1])
					end
				end
			end
			Result := l_err
		end

	file_exists_p (a_filename: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_buf___6: SD_STAT
		do
			create l_buf___6.make

			Result := ((stat (a_filename, (l_buf___6.address))) >= 0)
		end

	file_non_directory_p (a_path: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_buf___6: SD_STAT
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_buf___6.make

			if (lstat (a_path, (l_buf___6.address))) /= 0 then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				if ((l_buf___6.st_mode).bit_and ({NATURAL_32} 61440)) = {NATURAL_32} 16384 then
					l_tmp___0 := 0
				else
					l_tmp___0 := 1
				end
				Result := l_tmp___0.to_boolean
			end
		end

	file_size (a_filename: CE_POINTER [INTEGER_8]): INTEGER_64
		local
			l_size: INTEGER_64
			l_fp: CE_POINTER [SD_IO_FILE]
			js: JUMP_STATE
		do
			create l_fp.make

			l_fp.ce_gets ((fopen (a_filename, ce_string ("rb"))))
			if (l_fp).c_pointer = default_pointer then
				Result := (-1).to_integer_64
				js.return
			end
			if not js.return_called then
				fseeko (l_fp, (0).to_integer_32, 2).do_nothing
				l_size := (ftello (l_fp)).to_integer_64
				fclose (l_fp).do_nothing
				Result := l_size
			end
		end

	unique_name_1 (a_prefix: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_count: INTEGER_32
			l_plen: INTEGER_32
			l_template: CE_POINTER [INTEGER_8]
			l_template_tail: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_template.make
			create l_template_tail.make
			create l_tmp___1.make

			l_count := 1
			l_plen := (strlen (a_prefix)).to_integer_32
			l_template.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new (((l_plen + 1) + 24).to_natural_32))))
			l_template_tail.ce_gets (l_template + l_plen)
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_template), create {CE_POINTER [ANY]}.make_cast (a_prefix), l_plen.to_natural_32).do_nothing
			l_tmp___1.ce_gets (l_template_tail)
			l_template_tail.ce_gets (l_template_tail + 1)
			l_tmp___1[0] := (('.').code).to_integer_8
			from
			until
				js.loop_left
			loop
				js.reset
				l_tmp___2 := l_count
				l_count := l_count + 1
				number_to_string (l_template_tail, l_tmp___2.to_integer_64).do_nothing
				if not (file_exists_p (l_template)) then
					js.break
				end
			end
			js.reset
			Result := (xmalloc_inst.xstrdup (l_template))
		end

	unique_name (a_file: CE_POINTER [INTEGER_8]; a_allow_passthrough: BOOLEAN): CE_POINTER [INTEGER_8]
		local
			l_tmp___0: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_tmp___0.make

			if not (file_exists_p (a_file)) then
				if a_allow_passthrough then
					l_tmp___0.ce_gets (a_file)
				else
					l_tmp___0.ce_gets ((xmalloc_inst.xstrdup (a_file)))
				end
				Result := l_tmp___0
				js.return
			end
			if not js.return_called then
				Result := (unique_name_1 (a_file))
			end
		end

	unique_create (a_name: CE_POINTER [INTEGER_8]; a_binary: BOOLEAN; a_opened_name: CE_POINTER [CE_POINTER [INTEGER_8]]): CE_POINTER [SD_IO_FILE]
		local
			l_uname: CE_POINTER [INTEGER_8]
			l_fp: CE_POINTER [SD_IO_FILE]
			js: JUMP_STATE
		do
			create l_uname.make
			create l_fp.make

			l_uname.ce_gets ((unique_name (a_name, (0).to_boolean)))
			from
			until
				js.loop_left
			loop
				js.reset
				l_fp.ce_gets (fopen_excl (l_uname, a_binary.to_integer))
				if (l_fp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					if (errno_location).item /= 17 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					free (create {CE_POINTER [ANY]}.make_cast (l_uname))
					l_uname.ce_gets (unique_name (a_name, (0).to_boolean))
				end
			end
			js.reset
			if ((a_opened_name).c_pointer /= default_pointer) then
				if (l_fp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if ((l_fp).c_pointer /= default_pointer) then
						a_opened_name.item := l_uname
					else
						a_opened_name.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						free (create {CE_POINTER [ANY]}.make_cast (l_uname))
					end
				else
					free (create {CE_POINTER [ANY]}.make_cast (l_uname))
				end
			else
				free (create {CE_POINTER [ANY]}.make_cast (l_uname))
			end
			Result := l_fp
		end

	fopen_excl (a_fname: CE_POINTER [INTEGER_8]; a_binary: INTEGER_32): CE_POINTER [SD_IO_FILE]
		local
			l_fd: INTEGER_32
			l_flags: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_tmp.make

			l_flags := 193
			l_fd := open ([a_fname, l_flags, 438])
			if l_fd < 0 then
				Result := (create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				if a_binary.to_boolean then
					l_tmp.ce_gets (ce_string ("wb"))
				else
					l_tmp.ce_gets (ce_string ("w"))
				end
				Result := (fdopen (l_fd, l_tmp))
			end
		end

	make_directory (a_directory: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: INTEGER_32
			l_ret: INTEGER_32
			l_quit: INTEGER_32
			l_dir: CE_POINTER [INTEGER_8]
			l_SA_dest: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_SA_src: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_dir.make
			create l_SA_dest.make
			create l_SA_src.make

			l_quit := 0
			from
			until
				js.loop_left
			loop
				js.reset
				l_SA_dest.ce_gets (l_dir.address)
				l_SA_src.ce_gets (a_directory)
				l_SA_dest.item := create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new ((strlen (l_SA_src)) + {NATURAL_32} 1)))
				strcpy (l_SA_dest.item, l_SA_src).do_nothing
				js.break
			end
			js.reset
			l_i := ((l_dir[0]).to_integer_32 = 47).to_integer
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_dir[l_i]).to_boolean then
						if (l_dir[l_i]).to_integer_32 = 47 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
				js.reset
				if not (l_dir[l_i]).to_boolean then
					l_quit := 1
				end
				l_dir[l_i] := (('%/0/').code).to_integer_8
				if (file_exists_p (l_dir)) then
					l_ret := 0
				else
					l_ret := mkdir (l_dir, (511).to_natural_32)
				end
				if l_quit.to_boolean then
					js.break
				else
					l_dir[l_i] := (('/').code).to_integer_8
				end
				if not js.loop_jumped then
					l_i := l_i + 1
				end
			end
			js.reset
			Result := l_ret
		end

	file_merge (a_base: CE_POINTER [INTEGER_8]; a_file: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_result: CE_POINTER [INTEGER_8]
			l_cut: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_result.make
			create l_cut.make

			l_cut.ce_gets ((strrchr (a_base, ('/').code)))
			if (l_cut).c_pointer = default_pointer then
				Result := (xmalloc_inst.xstrdup (a_file))
				js.return
			end
			if not js.return_called then
				l_result.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc ((((l_cut.distance (a_base)) + 1).to_natural_32 + (strlen (a_file))) + {NATURAL_32} 1))))
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_result), create {CE_POINTER [ANY]}.make_cast (a_base), (l_cut.distance (a_base)).to_natural_32).do_nothing
				l_result[(l_cut.distance (a_base))] := (('/').code).to_integer_8
				strcpy (((l_result + (l_cut.distance (a_base))) + 1), a_file).do_nothing
				Result := l_result
			end
		end

	fnmatch_nocase (a_pattern: CE_POINTER [INTEGER_8]; a_string: CE_POINTER [INTEGER_8]; a_flags: INTEGER_32): INTEGER_32
		do
			Result := (fnmatch (a_pattern, a_string, (a_flags).bit_or (((1).bit_shift_left (4)))))
		end

	fnmatch_nocase_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent fnmatch_nocase)
		end

	acceptable (a_s: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_s: CE_POINTER [INTEGER_8]
			l_l: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make

			l_s.ce_gets (a_s)
			l_l := (strlen (l_s)).to_integer_32
			from
			until
				js.loop_left
			loop
				js.reset
				if l_l.to_boolean then
					if (l_s[l_l]).to_integer_32 = 47 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_l := l_l - 1
				end
			end
			js.reset
			if (l_s[l_l]).to_integer_32 = 47 then
				l_s.ce_gets (l_s + (l_l + 1))
			end
			if ((options_inst.opt.accepts).c_pointer /= default_pointer) then
				if ((options_inst.opt.rejects).c_pointer /= default_pointer) then
					if (in_acclist (options_inst.opt.accepts, l_s, (1).to_boolean)) then
						if (in_acclist (options_inst.opt.rejects, l_s, (1).to_boolean)) then
							l_tmp___2 := 0
						else
							l_tmp___2 := 1
						end
					else
						l_tmp___2 := 0
					end
					Result := l_tmp___2.to_boolean
					js.return
				else
					Result := (in_acclist (options_inst.opt.accepts, l_s, (1).to_boolean))
					js.return
				end
			elseif ((options_inst.opt.rejects).c_pointer /= default_pointer) then
				if (in_acclist (options_inst.opt.rejects, l_s, (1).to_boolean)) then
					l_tmp___5 := 0
				else
					l_tmp___5 := 1
				end
				Result := l_tmp___5.to_boolean
				js.return
			end
			if not js.return_called then
				Result := (1).to_boolean
			end
		end

	subdir_p (a_d1: CE_POINTER [INTEGER_8]; a_d2: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_d1: CE_POINTER [INTEGER_8]
			l_d2: CE_POINTER [INTEGER_8]
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_d1.make
			create l_d2.make

			l_d1.ce_gets (a_d1)
			l_d2.ce_gets (a_d2)
			if (l_d1[0]).to_integer_32 = 0 then
				Result := (1).to_boolean
				js.return
			end
			if not js.return_called then
				if not options_inst.opt.ignore_case then
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_d1[0]).to_boolean then
							if (l_d2[0]).to_boolean then
								if (l_d1[0]).to_integer_32 /= (l_d2[0]).to_integer_32 then
									js.break
								end
							else
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_d1.ce_gets (l_d1 + 1)
							l_d2.ce_gets (l_d2 + 1)
						end
					end
					js.reset
				else
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_d1[0]).to_boolean then
							if (l_d2[0]).to_boolean then
								l_tmp := c_ctype_inst.c2_tolower ((l_d1[0]).to_integer_32)
								if l_tmp /= (c_ctype_inst.c2_tolower ((l_d2[0]).to_integer_32)) then
									js.break
								end
							else
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_d1.ce_gets (l_d1 + 1)
							l_d2.ce_gets (l_d2 + 1)
						end
					end
					js.reset
				end
				if (l_d1[0]).to_integer_32 = 0 then
					if (l_d2[0]).to_integer_32 = 0 then
						l_tmp___1 := 1
					elseif (l_d2[0]).to_integer_32 = 47 then
						l_tmp___1 := 1
					else
						l_tmp___1 := 0
					end
				else
					l_tmp___1 := 0
				end
				Result := l_tmp___1.to_boolean
			end
		end

	dir_matches_p (a_dirlist: CE_POINTER [CE_POINTER [INTEGER_8]]; a_dir: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_x: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_matcher: CE_ROUTINE
			l_tmp: CE_ROUTINE
			l_p___0: CE_POINTER [INTEGER_8]
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
		do
			create l_x.make
			create l_matcher.make
			create l_tmp.make
			create l_p___0.make

			if options_inst.opt.ignore_case then
				l_tmp.ce_gets (fnmatch_nocase_address)
			else
				l_tmp.ce_gets (fnmatch_address)
			end
			l_matcher.ce_gets (l_tmp)
			l_x.ce_gets (a_dirlist)
			from
			until
				not (not js.loop_left and then ((l_x.item).c_pointer /= default_pointer))
			loop
				js.reset
				l_p___0.ce_gets (l_x.item + (((l_x.item).item).to_integer_32 = 47).to_integer)
				if (has_wildcards_p (l_p___0)) then
					if (l_matcher.integer_32_item ([l_p___0, a_dir, 1])) = 0 then
						js.break
					end
				elseif (subdir_p (l_p___0, a_dir)) then
					js.break
				end
				if not js.loop_jumped then
					l_x.ce_gets (l_x + 1)
				end
			end
			js.reset
			if ((l_x.item).c_pointer /= default_pointer) then
				l_tmp___3 := 1
			else
				l_tmp___3 := 0
			end
			Result := l_tmp___3.to_boolean
		end

	accdir (a_directory: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_directory: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_directory.make

			l_directory.ce_gets (a_directory)
			if (l_directory[0]).to_integer_32 = 47 then
				l_directory.ce_gets (l_directory + 1)
			end
			if ((options_inst.opt.includes).c_pointer /= default_pointer) then
				if not (dir_matches_p (options_inst.opt.includes, l_directory)) then
					Result := (0).to_boolean
					js.return
				end
			end
			if not js.return_called and then ((options_inst.opt.excludes).c_pointer /= default_pointer) then
				if (dir_matches_p (options_inst.opt.excludes, l_directory)) then
					Result := (0).to_boolean
					js.return
				end
			end
			if not js.return_called then
				Result := (1).to_boolean
			end
		end

	match_tail (a_string: CE_POINTER [INTEGER_8]; a_tail: CE_POINTER [INTEGER_8]; a_fold_case: BOOLEAN): BOOLEAN
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
		do
			if not a_fold_case then
				l_i := (strlen (a_string)).to_integer_32
				l_j := (strlen (a_tail)).to_integer_32
				from
				until
					js.loop_left
				loop
					js.reset
					if l_i >= 0 then
						if not (l_j >= 0) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped and then ((a_string[l_i]).to_integer_32 /= (a_tail[l_j]).to_integer_32) then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i - 1
						l_j := l_j - 1
					end
				end
				js.reset
			else
				l_i := (strlen (a_string)).to_integer_32
				l_j := (strlen (a_tail)).to_integer_32
				from
				until
					js.loop_left
				loop
					js.reset
					if l_i >= 0 then
						if not (l_j >= 0) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_tmp___3 := c_ctype_inst.c2_tolower ((a_string[l_i]).to_integer_32)
						if l_tmp___3 /= (c_ctype_inst.c2_tolower ((a_tail[l_j]).to_integer_32)) then
							js.break
						end
					end
					if not js.loop_jumped then
						l_i := l_i - 1
						l_j := l_j - 1
					end
				end
				js.reset
			end
			if l_j = -1 then
				Result := (1).to_boolean
			else
				Result := (0).to_boolean
			end
		end

	in_acclist (a_accepts: CE_POINTER [CE_POINTER [INTEGER_8]]; a_s: CE_POINTER [INTEGER_8]; a_backward: BOOLEAN): BOOLEAN
		local
			l_accepts: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_res___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_cmp: INTEGER_32
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
		do
			create l_accepts.make

			l_accepts.ce_gets (a_accepts)
			from
			until
				not (not js.loop_left and then ((l_accepts.item).c_pointer /= default_pointer))
			loop
				if (has_wildcards_p (l_accepts.item)) then
					if options_inst.opt.ignore_case then
						l_tmp___1 := (fnmatch_nocase (l_accepts.item, a_s, 0))
					else
						l_tmp___1 := (fnmatch (l_accepts.item, a_s, 0))
					end
					l_res___0 := l_tmp___1
					if l_res___0 = 0 then
						Result := (1).to_boolean
						js.return
					end
				elseif a_backward then
					if (match_tail (a_s, l_accepts.item, options_inst.opt.ignore_case)) then
						Result := (1).to_boolean
						js.return
					end
				else
					if options_inst.opt.ignore_case then
						l_tmp___5 := (strcasecmp (a_s, l_accepts.item))
					else
						l_tmp___5 := (strcmp (a_s, l_accepts.item))
					end
					l_cmp := l_tmp___5
					if l_cmp = 0 then
						Result := (1).to_boolean
						js.return
					end
				end
				if not js.return_called then
					l_accepts.ce_gets (l_accepts + 1)
				end
			end
			if not js.return_called then
				Result := (0).to_boolean
			end
		end

	suffix (a_str: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_i: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i := (strlen (a_str)).to_integer_32
			from
			until
				js.loop_left
			loop
				js.reset
				if l_i.to_boolean then
					if (a_str[l_i]).to_integer_32 /= 47 then
						if (a_str[l_i]).to_integer_32 = 46 then
							js.break
						end
					else
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_i := l_i - 1
				end
			end
			js.reset
			l_tmp___0 := l_i
			l_i := l_i + 1
			if (a_str[l_tmp___0]).to_integer_32 = 46 then
				Result := (a_str + l_i)
			else
				Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
			end
		end

	has_wildcards_p (a_s: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_s: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_s.make

			l_s.ce_gets (a_s)
			from
			until
				not (not js.loop_left and then ((l_s[0]).to_boolean))
			loop
				if (l_s[0]).to_integer_32 = 42 then
					Result := (1).to_boolean
					js.return
				elseif (l_s[0]).to_integer_32 = 63 then
					Result := (1).to_boolean
					js.return
				elseif (l_s[0]).to_integer_32 = 91 then
					Result := (1).to_boolean
					js.return
				elseif (l_s[0]).to_integer_32 = 93 then
					Result := (1).to_boolean
					js.return
				end
				if not js.return_called then
					l_s.ce_gets (l_s + 1)
				end
			end
			if not js.return_called then
				Result := (0).to_boolean
			end
		end

	has_html_suffix_p (a_fname: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_suf: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_suf.make

			l_suf.ce_gets (suffix (a_fname))
			if (l_suf.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				if not (strcasecmp (l_suf, ce_string ("html"))).to_boolean then
					Result := (1).to_boolean
					js.return
				end
			end
			if not js.return_called then
				if not (strcasecmp (l_suf, ce_string ("htm"))).to_boolean then
					Result := (1).to_boolean
					js.return
				end
			end
			if not js.return_called and then ((l_suf[0]).to_boolean) then
				if not (strcasecmp ((l_suf + 1), ce_string ("html"))).to_boolean then
					Result := (1).to_boolean
					js.return
				end
			end
			if not js.return_called then
				Result := (0).to_boolean
			end
		end

	read_whole_line (a_fp: CE_POINTER [SD_IO_FILE]): CE_POINTER [INTEGER_8]
		local
			l_length: INTEGER_32
			l_bufsize___0: INTEGER_32
			l_line: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_line.make

			l_length := 0
			l_bufsize___0 := 82
			l_line.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc (l_bufsize___0.to_natural_32))))
			from
			until
				js.loop_left
			loop
				js.reset
				if ((fgets ((l_line + l_length), l_bufsize___0 - l_length, a_fp))).c_pointer = default_pointer then
					js.break
				end
				if not js.loop_jumped then
					l_length := (l_length.to_natural_32 + (strlen ((l_line + l_length)))).to_integer_32
					if l_length = 0 then
						js.continue
					end
				end
				if not js.loop_jumped and then ((l_line[(l_length - 1)]).to_integer_32 = 10) then
					js.break
				end
				if not js.loop_jumped then
					l_bufsize___0 := (l_bufsize___0).bit_shift_left ((1))
					l_line.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (l_line), l_bufsize___0.to_natural_32))))
				end
			end
			js.reset
			if l_length = 0 then
				free (create {CE_POINTER [ANY]}.make_cast (l_line))
				Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
				js.return
			elseif (ferror (a_fp)).to_boolean then
				free (create {CE_POINTER [ANY]}.make_cast (l_line))
				Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				if l_length + 1 < l_bufsize___0 then
					l_line.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (l_line), (l_length + 1).to_natural_32))))
				end
				Result := l_line
			end
		end

	read_file (a_file: CE_POINTER [INTEGER_8]): CE_POINTER [PD_FILE_MEMORY]
		local
			l_fd: INTEGER_32
			l_fm: CE_POINTER [PD_FILE_MEMORY]
			l_size: INTEGER_32
			l_inhibit_close: BOOLEAN
			l_buf___6: SD_STAT
			l_nread: INTEGER_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fm.make
			create l_buf___6.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_inhibit_close := (0).to_boolean
					if (a_file[0]).to_integer_32 = 45 then
						if not (a_file[1]).to_boolean then
							l_fd := fileno ((create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.input.file_pointer)))
							l_inhibit_close := (1).to_boolean
						else
							l_fd := open ([a_file, 0])
						end
					else
						l_fd := open ([a_file, 0])
					end
					if l_fd < 0 then
						Result := (create {CE_POINTER [PD_FILE_MEMORY]}.make_shared (default_pointer))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						l_fm.ce_gets (create {CE_POINTER [PD_FILE_MEMORY]}.make_cast ((xmalloc_inst.xmalloc ({PD_FILE_MEMORY}.sizeof.to_natural_32))))
						if (fstat (l_fd, l_buf___6.address)) < 0 then
							l_pos := -1 + 5 -- goto mmap_lose
						end
				when 2 then
						l_fm.item.length := l_buf___6.st_size
						l_fm.item.content := create {CE_POINTER [INTEGER_8]}.make_cast ((mmap (create {CE_POINTER [ANY]}.make_shared (default_pointer), (l_fm.item.length).to_natural_32, 3, 2, l_fd, (0).to_integer_32)))
						if ((l_fm.item.content).c_pointer.to_integer_32).to_natural_32 = (-1).to_natural_32 then
							l_pos := -1 + 5 -- goto mmap_lose
						end
				when 3 then
						if not l_inhibit_close then
							close (l_fd).do_nothing
						end
						l_fm.item.mmap_p := 1
						Result := l_fm
						js.return
				when 4 then -- if done
					if js.return_called then
						l_pos := -1 + 10 -- skip if block
					end
				when 5 then -- if: | mmap_lose:
						l_fm.item.length := 0
						l_size := 512
						l_fm.item.content := create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc (l_size.to_natural_32)))
				when 6 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 9 -- skip loop
						end
				when 7 then -- loop body:
						js.reset
						if l_fm.item.length > l_size // 2 then
							l_size := (l_size).bit_shift_left ((1))
							l_fm.item.content := create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (l_fm.item.content), l_size.to_natural_32)))
						end
						l_nread := (read (l_fd, create {CE_POINTER [ANY]}.make_cast ((l_fm.item.content + l_fm.item.length)), (l_size - l_fm.item.length).to_natural_32)).to_integer_64
						if l_nread > {INTEGER_64} 0 then
							l_fm.item.length := ((l_fm.item.length).to_integer_64 + l_nread).to_integer_32
						elseif l_nread < {INTEGER_64} 0 then
							l_pos := -1 + 11 -- goto lose
						else
							js.break
						end
				when 8 then
						l_pos := -1 + 6 -- back to loop condition
				when 9 then -- loop done
						js.reset
						if not l_inhibit_close then
							close (l_fd).do_nothing
						end
						if l_size > l_fm.item.length then
							if l_fm.item.length /= 0 then
								l_fm.item.content := create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (l_fm.item.content), (l_fm.item.length).to_natural_32)))
							end
						end
						l_fm.item.mmap_p := 0
						Result := l_fm
						js.return
				when 10 then -- if done
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 11 then -- if: | lose:
						if not l_inhibit_close then
							close (l_fd).do_nothing
						end
						free (create {CE_POINTER [ANY]}.make_cast (l_fm.item.content))
						free (create {CE_POINTER [ANY]}.make_cast (l_fm))
						Result := (create {CE_POINTER [PD_FILE_MEMORY]}.make_shared (default_pointer))
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	read_file_free (a_fm: CE_POINTER [PD_FILE_MEMORY])
		do
			if (a_fm.item.mmap_p).to_boolean then
				munmap (create {CE_POINTER [ANY]}.make_cast (a_fm.item.content), (a_fm.item.length).to_natural_32).do_nothing
			else
				free (create {CE_POINTER [ANY]}.make_cast (a_fm.item.content))
			end
			free (create {CE_POINTER [ANY]}.make_cast (a_fm))
		end

	free_vec (a_vec: CE_POINTER [CE_POINTER [INTEGER_8]])
		local
			l_p___0: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_tmp: CE_POINTER [CE_POINTER [INTEGER_8]]
		do
			create l_p___0.make
			create l_tmp.make

			if ((a_vec).c_pointer /= default_pointer) then
				l_p___0.ce_gets (a_vec)
				from
				until
					(l_p___0.item).c_pointer = default_pointer
				loop
					l_tmp.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					free (create {CE_POINTER [ANY]}.make_cast (l_tmp.item))
				end
				free (create {CE_POINTER [ANY]}.make_cast (a_vec))
			end
		end

	merge_vecs (a_v1___0: CE_POINTER [CE_POINTER [INTEGER_8]]; a_v2___0: CE_POINTER [CE_POINTER [INTEGER_8]]): CE_POINTER [CE_POINTER [INTEGER_8]]
		local
			l_v1___0: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_i: INTEGER_32
			l_j: INTEGER_32
			js: JUMP_STATE
		do
			create l_v1___0.make

			l_v1___0.ce_gets (a_v1___0)
			if (l_v1___0).c_pointer = default_pointer then
				Result := a_v2___0
				js.return
			end
			if not js.return_called and then ((a_v2___0).c_pointer = default_pointer) then
				Result := l_v1___0
				js.return
			end
			if not js.return_called and then ((a_v2___0.item).c_pointer = default_pointer) then
				free (create {CE_POINTER [ANY]}.make_cast (a_v2___0))
				Result := l_v1___0
				js.return
			end
			if not js.return_called then
				l_i := 0
				from
				until
					(l_v1___0[l_i]).c_pointer = default_pointer
				loop
					l_i := l_i + 1
				end
				l_j := 0
				from
				until
					(a_v2___0[l_j]).c_pointer = default_pointer
				loop
					l_j := l_j + 1
				end
				l_v1___0.ce_gets (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (l_v1___0), ((l_i + l_j) + 1).to_natural_32 * Pointer_bytes.to_natural_32))))
				memcpy (create {CE_POINTER [ANY]}.make_cast ((l_v1___0 + l_i)), create {CE_POINTER [ANY]}.make_cast (a_v2___0), (l_j + 1).to_natural_32 * Pointer_bytes.to_natural_32).do_nothing
				free (create {CE_POINTER [ANY]}.make_cast (a_v2___0))
				Result := l_v1___0
			end
		end

	vec_append (a_vec: CE_POINTER [CE_POINTER [INTEGER_8]]; a_str: CE_POINTER [INTEGER_8]): CE_POINTER [CE_POINTER [INTEGER_8]]
		local
			l_vec: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_cnt: INTEGER_32
		do
			create l_vec.make

			l_vec.ce_gets (a_vec)
			if (l_vec.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_cnt := 0
				from
				until
					(l_vec[l_cnt]).c_pointer = default_pointer
				loop
					l_cnt := l_cnt + 1
				end
				l_cnt := l_cnt + 1
			else
				l_cnt := 1
			end
			l_vec.ce_gets (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (l_vec), (l_cnt + 1).to_natural_32 * Pointer_bytes.to_natural_32))))
			l_vec[(l_cnt - 1)] := xmalloc_inst.xstrdup (a_str)
			l_vec[l_cnt] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			Result := l_vec
		end

	string_set_add (a_ht: CE_POINTER [PD_HASH_TABLE]; a_s: CE_POINTER [INTEGER_8])
		local
			js: JUMP_STATE
		do
			if (hash_inst.hash_table_contains (a_ht, create {CE_POINTER [ANY]}.make_cast (a_s))).to_boolean then
				js.return
			end
			if not js.return_called then
				hash_inst.hash_table_put (a_ht, create {CE_POINTER [ANY]}.make_cast ((xmalloc_inst.xstrdup (a_s))), create {CE_POINTER [ANY]}.make_cast (ce_string ("1")))
			end
		end

	string_set_contains (a_ht: CE_POINTER [PD_HASH_TABLE]; a_s: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := (hash_inst.hash_table_contains (a_ht, create {CE_POINTER [ANY]}.make_cast (a_s)))
		end

	string_set_to_array (a_ht: CE_POINTER [PD_HASH_TABLE]; a_array: CE_POINTER [CE_POINTER [INTEGER_8]])
		local
			l_array: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_iter: PD_HASH_TABLE_ITERATOR
			l_tmp: CE_POINTER [CE_POINTER [INTEGER_8]]
			js: JUMP_STATE
		do
			create l_array.make
			create l_iter.make
			create l_tmp.make

			l_array.ce_gets (a_array)
			hash_inst.hash_table_iterate (a_ht, l_iter.address)
			from
			until
				js.loop_left
			loop
				js.reset
				if not (hash_inst.hash_table_iter_next (l_iter.address)).to_boolean then
					js.break
				end
				if not js.loop_jumped then
					l_tmp.ce_gets (l_array)
					l_array.ce_gets (l_array + 1)
					l_tmp.item := create {CE_POINTER [INTEGER_8]}.make_cast (l_iter.key)
				end
			end
			js.reset
		end

	string_set_free (a_ht: CE_POINTER [PD_HASH_TABLE])
		local
			l_iter: PD_HASH_TABLE_ITERATOR
			js: JUMP_STATE
		do
			create l_iter.make

			hash_inst.hash_table_iterate (a_ht, l_iter.address)
			from
			until
				js.loop_left
			loop
				js.reset
				if not (hash_inst.hash_table_iter_next (l_iter.address)).to_boolean then
					js.break
				end
				if not js.loop_jumped then
					free (l_iter.key)
				end
			end
			js.reset
			hash_inst.hash_table_destroy (a_ht)
		end

	free_keys_and_values (a_ht: CE_POINTER [PD_HASH_TABLE])
		local
			l_iter: PD_HASH_TABLE_ITERATOR
			js: JUMP_STATE
		do
			create l_iter.make

			hash_inst.hash_table_iterate (a_ht, l_iter.address)
			from
			until
				js.loop_left
			loop
				js.reset
				if not (hash_inst.hash_table_iter_next (l_iter.address)).to_boolean then
					js.break
				end
				if not js.loop_jumped then
					free (l_iter.key)
					free (l_iter.value)
				end
			end
			js.reset
		end

	get_grouping_data (a_sep: CE_POINTER [CE_POINTER [INTEGER_8]]; a_grouping: CE_POINTER [CE_POINTER [INTEGER_8]])
		local
			l_lconv: CE_POINTER [SD_LCONV]
		do
			create l_lconv.make

			if not initialized then
				l_lconv.ce_gets ((localeconv))
				cached_sep.ce_gets (l_lconv.item.thousands_sep)
				cached_grouping.ce_gets (l_lconv.item.grouping)
				if not (cached_sep[0]).to_boolean then
					if ((l_lconv.item.decimal_point).item).to_integer_32 /= 44 then
						cached_sep.ce_gets (ce_string (","))
					else
						cached_sep.ce_gets (ce_string ("."))
					end
					cached_grouping.ce_gets (ce_string ("%/3/"))
				end
				initialized := (1).to_boolean
			end
			a_sep.item := cached_sep
			a_grouping.item := cached_grouping
		end

	with_thousand_seps (a_n: INTEGER_64): CE_POINTER [INTEGER_8]
		local
			l_n: INTEGER_64
			l_p___0: CE_POINTER [INTEGER_8]
			l_grouping: CE_POINTER [INTEGER_8]
			l_sep: CE_POINTER [INTEGER_8]
			l_seplen: INTEGER_32
			l_i: INTEGER_32
			l_groupsize: INTEGER_32
			l_atgroup: CE_POINTER [INTEGER_8]
			l_negative: BOOLEAN
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_grouping.make
			create l_sep.make
			create l_atgroup.make
			create l_tmp___0.make
			create l_tmp___1.make

			l_n := a_n
			l_p___0.ce_gets (outbuf + (Integer_8_bytes.to_natural_32 * (48).to_natural_32).to_integer_32)
			l_i := 0
			l_negative := (l_n < {INTEGER_64} 0)
			get_grouping_data (l_sep.address, l_grouping.address)
			l_seplen := (strlen (l_sep)).to_integer_32
			l_atgroup.ce_gets (l_grouping)
			l_tmp___0.ce_gets (l_atgroup)
			l_atgroup.ce_gets (l_atgroup + 1)
			l_groupsize := (l_tmp___0[0]).to_integer_32
			if l_negative then
				l_n := -l_n
			end
			l_p___0.ce_gets (l_p___0 - 1)
			l_p___0[0] := (('%/0/').code).to_integer_8
			from
			until
				js.loop_left
			loop
				js.reset
				l_p___0.ce_gets (l_p___0 - 1)
				l_p___0[0] := (l_n \\ {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n // ({INTEGER_64} 10)
				if l_n = {INTEGER_64} 0 then
					js.break
				end
				if not js.loop_jumped then
					l_i := l_i + 1
					if l_i = l_groupsize then
						if l_seplen = 1 then
							l_p___0.ce_gets (l_p___0 - 1)
							l_p___0[0] := l_sep[0]
						else
							l_p___0.ce_gets (l_p___0 - l_seplen)
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (l_sep), l_seplen.to_natural_32).do_nothing
						end
						l_i := 0
						if (l_atgroup[0]).to_boolean then
							l_tmp___1.ce_gets (l_atgroup)
							l_atgroup.ce_gets (l_atgroup + 1)
							l_groupsize := (l_tmp___1[0]).to_integer_32
						end
					end
				end
			end
			js.reset
			if l_negative then
				l_p___0.ce_gets (l_p___0 - 1)
				l_p___0[0] := (('-').code).to_integer_8
			end
			Result := l_p___0
		end

	human_readable (a_n: INTEGER_64): CE_POINTER [INTEGER_8]
		local
			l_n: INTEGER_64
			l_i: NATURAL_32
			l_val: REAL_64
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_n := a_n
					if l_n < {INTEGER_64} 1024 then
						snprintf ([buf___3, (Integer_8_bytes.to_natural_32 * (8).to_natural_32), ce_string ("%%d"), l_n.to_integer_32]).do_nothing
						Result := buf___3
						js.return
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						l_i := (0).to_natural_32
				when 2 then -- loop condition:
						if not (not js.loop_left and then (l_i < (Integer_8_bytes.to_natural_32 * (6).to_natural_32) // Integer_8_bytes.to_natural_32)) then
							l_pos := -1 + 9 -- skip loop
						end
				when 3 then -- loop body:
						if not (l_n // {INTEGER_64} 1024 < {INTEGER_64} 1024) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if l_i /= (Integer_8_bytes.to_natural_32 * (6).to_natural_32) // Integer_8_bytes.to_natural_32 - {NATURAL_32} 1 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						l_val := l_n.to_double / 1024.0
						if l_val < (10).to_double then
							l_tmp := 1
						else
							l_tmp := 0
						end
						snprintf ([buf___3, (Integer_8_bytes.to_natural_32 * (8).to_natural_32), ce_string ("%%.*f%%c"), l_tmp, l_val, (powers[l_i.to_integer_32]).to_integer_32]).do_nothing
						Result := buf___3
						js.return
				when 8 then -- if done
						if not js.return_called then
							l_n := l_n // ({INTEGER_64} 1024)
							l_i := l_i + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 9 then -- loop done | if done
						if not js.return_called then
							Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
						end
				when 10 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	numdigit (a_number: INTEGER_64): INTEGER_32
		local
			l_number: INTEGER_64
			l_cnt: INTEGER_32
			js: JUMP_STATE
		do
			l_number := a_number
			l_cnt := 1
			if l_number < {INTEGER_64} 0 then
				l_cnt := l_cnt + 1
			end
			from
			until
				js.loop_left
			loop
				js.reset
				l_number := l_number // ({INTEGER_64} 10)
				if l_number = {INTEGER_64} 0 then
					js.break
				end
				if not js.loop_jumped then
					l_cnt := l_cnt + 1
				end
			end
			js.reset
			Result := l_cnt
		end

	number_to_string (a_buffer___0: CE_POINTER [INTEGER_8]; a_number: INTEGER_64): CE_POINTER [INTEGER_8]
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_n: INTEGER_64
			l_last_digit_char: INTEGER_32
			l_last_digit: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: CE_POINTER [INTEGER_8]
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___17: CE_POINTER [INTEGER_8]
			l_tmp___18: CE_POINTER [INTEGER_8]
			l_tmp___19: CE_POINTER [INTEGER_8]
			l_tmp___20: CE_POINTER [INTEGER_8]
			l_tmp___21: CE_POINTER [INTEGER_8]
			l_tmp___22: CE_POINTER [INTEGER_8]
			l_tmp___23: CE_POINTER [INTEGER_8]
			l_tmp___24: CE_POINTER [INTEGER_8]
			l_tmp___25: CE_POINTER [INTEGER_8]
			l_tmp___26: CE_POINTER [INTEGER_8]
			l_tmp___27: CE_POINTER [INTEGER_8]
			l_tmp___28: CE_POINTER [INTEGER_8]
			l_tmp___29: CE_POINTER [INTEGER_8]
			l_tmp___30: CE_POINTER [INTEGER_8]
			l_tmp___31: CE_POINTER [INTEGER_8]
			l_tmp___32: CE_POINTER [INTEGER_8]
			l_tmp___33: CE_POINTER [INTEGER_8]
			l_tmp___34: CE_POINTER [INTEGER_8]
			l_tmp___35: CE_POINTER [INTEGER_8]
			l_tmp___36: CE_POINTER [INTEGER_8]
			l_tmp___37: CE_POINTER [INTEGER_8]
			l_tmp___38: CE_POINTER [INTEGER_8]
			l_tmp___39: CE_POINTER [INTEGER_8]
			l_tmp___40: CE_POINTER [INTEGER_8]
			l_tmp___41: CE_POINTER [INTEGER_8]
			l_tmp___42: CE_POINTER [INTEGER_8]
			l_tmp___43: CE_POINTER [INTEGER_8]
			l_tmp___44: CE_POINTER [INTEGER_8]
			l_tmp___45: CE_POINTER [INTEGER_8]
			l_tmp___46: CE_POINTER [INTEGER_8]
			l_tmp___47: CE_POINTER [INTEGER_8]
			l_tmp___48: CE_POINTER [INTEGER_8]
			l_tmp___49: CE_POINTER [INTEGER_8]
			l_tmp___50: CE_POINTER [INTEGER_8]
			l_tmp___51: CE_POINTER [INTEGER_8]
			l_tmp___52: CE_POINTER [INTEGER_8]
			l_tmp___53: CE_POINTER [INTEGER_8]
			l_tmp___54: CE_POINTER [INTEGER_8]
			l_tmp___55: CE_POINTER [INTEGER_8]
			l_tmp___56: CE_POINTER [INTEGER_8]
			l_tmp___57: CE_POINTER [INTEGER_8]
			l_tmp___58: CE_POINTER [INTEGER_8]
			l_tmp___59: CE_POINTER [INTEGER_8]
			l_tmp___60: CE_POINTER [INTEGER_8]
			l_tmp___61: CE_POINTER [INTEGER_8]
			l_tmp___62: CE_POINTER [INTEGER_8]
			l_tmp___63: CE_POINTER [INTEGER_8]
			l_tmp___64: CE_POINTER [INTEGER_8]
			l_tmp___65: CE_POINTER [INTEGER_8]
			l_tmp___66: CE_POINTER [INTEGER_8]
			l_tmp___67: CE_POINTER [INTEGER_8]
			l_tmp___68: CE_POINTER [INTEGER_8]
			l_tmp___69: CE_POINTER [INTEGER_8]
			l_tmp___70: CE_POINTER [INTEGER_8]
			l_tmp___71: CE_POINTER [INTEGER_8]
			l_tmp___72: CE_POINTER [INTEGER_8]
			l_tmp___73: CE_POINTER [INTEGER_8]
			l_tmp___74: CE_POINTER [INTEGER_8]
			l_tmp___75: CE_POINTER [INTEGER_8]
			l_tmp___76: CE_POINTER [INTEGER_8]
			l_tmp___77: CE_POINTER [INTEGER_8]
			l_tmp___78: CE_POINTER [INTEGER_8]
			l_tmp___79: CE_POINTER [INTEGER_8]
			l_tmp___80: CE_POINTER [INTEGER_8]
			l_tmp___81: CE_POINTER [INTEGER_8]
			l_tmp___82: CE_POINTER [INTEGER_8]
			l_tmp___83: CE_POINTER [INTEGER_8]
			l_tmp___84: CE_POINTER [INTEGER_8]
			l_tmp___85: CE_POINTER [INTEGER_8]
			l_tmp___86: CE_POINTER [INTEGER_8]
			l_tmp___87: CE_POINTER [INTEGER_8]
			l_tmp___88: CE_POINTER [INTEGER_8]
			l_tmp___89: CE_POINTER [INTEGER_8]
			l_tmp___90: CE_POINTER [INTEGER_8]
			l_tmp___91: CE_POINTER [INTEGER_8]
			l_tmp___92: CE_POINTER [INTEGER_8]
			l_tmp___93: CE_POINTER [INTEGER_8]
			l_tmp___94: CE_POINTER [INTEGER_8]
			l_tmp___95: CE_POINTER [INTEGER_8]
			l_tmp___96: CE_POINTER [INTEGER_8]
			l_tmp___97: CE_POINTER [INTEGER_8]
			l_tmp___98: CE_POINTER [INTEGER_8]
			l_tmp___99: CE_POINTER [INTEGER_8]
			l_tmp___100: CE_POINTER [INTEGER_8]
			l_tmp___101: CE_POINTER [INTEGER_8]
			l_tmp___102: CE_POINTER [INTEGER_8]
			l_tmp___103: CE_POINTER [INTEGER_8]
			l_tmp___104: CE_POINTER [INTEGER_8]
			l_tmp___105: CE_POINTER [INTEGER_8]
			l_tmp___106: CE_POINTER [INTEGER_8]
			l_tmp___107: CE_POINTER [INTEGER_8]
			l_tmp___108: CE_POINTER [INTEGER_8]
			l_tmp___109: CE_POINTER [INTEGER_8]
			l_tmp___110: CE_POINTER [INTEGER_8]
			l_tmp___111: CE_POINTER [INTEGER_8]
			l_tmp___112: CE_POINTER [INTEGER_8]
			l_tmp___113: CE_POINTER [INTEGER_8]
			l_tmp___114: CE_POINTER [INTEGER_8]
			l_tmp___115: CE_POINTER [INTEGER_8]
			l_tmp___116: CE_POINTER [INTEGER_8]
			l_tmp___117: CE_POINTER [INTEGER_8]
			l_tmp___118: CE_POINTER [INTEGER_8]
			l_tmp___119: CE_POINTER [INTEGER_8]
			l_tmp___120: CE_POINTER [INTEGER_8]
			l_tmp___121: CE_POINTER [INTEGER_8]
			l_tmp___122: CE_POINTER [INTEGER_8]
			l_tmp___123: CE_POINTER [INTEGER_8]
			l_tmp___124: CE_POINTER [INTEGER_8]
			l_tmp___125: CE_POINTER [INTEGER_8]
			l_tmp___126: CE_POINTER [INTEGER_8]
			l_tmp___127: CE_POINTER [INTEGER_8]
			l_tmp___128: CE_POINTER [INTEGER_8]
			l_tmp___129: CE_POINTER [INTEGER_8]
			l_tmp___130: CE_POINTER [INTEGER_8]
			l_tmp___131: CE_POINTER [INTEGER_8]
			l_tmp___132: CE_POINTER [INTEGER_8]
			l_tmp___133: CE_POINTER [INTEGER_8]
			l_tmp___134: CE_POINTER [INTEGER_8]
			l_tmp___135: CE_POINTER [INTEGER_8]
			l_tmp___136: CE_POINTER [INTEGER_8]
			l_tmp___137: CE_POINTER [INTEGER_8]
			l_tmp___138: CE_POINTER [INTEGER_8]
			l_tmp___139: CE_POINTER [INTEGER_8]
			l_tmp___140: CE_POINTER [INTEGER_8]
			l_tmp___141: CE_POINTER [INTEGER_8]
			l_tmp___142: CE_POINTER [INTEGER_8]
			l_tmp___143: CE_POINTER [INTEGER_8]
			l_tmp___144: CE_POINTER [INTEGER_8]
			l_tmp___145: CE_POINTER [INTEGER_8]
			l_tmp___146: CE_POINTER [INTEGER_8]
			l_tmp___147: CE_POINTER [INTEGER_8]
			l_tmp___148: CE_POINTER [INTEGER_8]
			l_tmp___149: CE_POINTER [INTEGER_8]
			l_tmp___150: CE_POINTER [INTEGER_8]
			l_tmp___151: CE_POINTER [INTEGER_8]
			l_tmp___152: CE_POINTER [INTEGER_8]
			l_tmp___153: CE_POINTER [INTEGER_8]
			l_tmp___154: CE_POINTER [INTEGER_8]
			l_tmp___155: CE_POINTER [INTEGER_8]
			l_tmp___156: CE_POINTER [INTEGER_8]
			l_tmp___157: CE_POINTER [INTEGER_8]
			l_tmp___158: CE_POINTER [INTEGER_8]
			l_tmp___159: CE_POINTER [INTEGER_8]
			l_tmp___160: CE_POINTER [INTEGER_8]
			l_tmp___161: CE_POINTER [INTEGER_8]
			l_tmp___162: CE_POINTER [INTEGER_8]
			l_tmp___163: CE_POINTER [INTEGER_8]
			l_tmp___164: CE_POINTER [INTEGER_8]
			l_tmp___165: CE_POINTER [INTEGER_8]
			l_tmp___166: CE_POINTER [INTEGER_8]
			l_tmp___167: CE_POINTER [INTEGER_8]
			l_tmp___168: CE_POINTER [INTEGER_8]
			l_tmp___169: CE_POINTER [INTEGER_8]
			l_tmp___170: CE_POINTER [INTEGER_8]
			l_tmp___171: CE_POINTER [INTEGER_8]
			l_tmp___172: CE_POINTER [INTEGER_8]
			l_tmp___173: CE_POINTER [INTEGER_8]
			l_tmp___174: CE_POINTER [INTEGER_8]
			l_tmp___175: CE_POINTER [INTEGER_8]
			l_tmp___176: CE_POINTER [INTEGER_8]
			l_tmp___177: CE_POINTER [INTEGER_8]
			l_tmp___178: CE_POINTER [INTEGER_8]
			l_tmp___179: CE_POINTER [INTEGER_8]
			l_tmp___180: CE_POINTER [INTEGER_8]
			l_tmp___181: CE_POINTER [INTEGER_8]
			l_tmp___182: CE_POINTER [INTEGER_8]
			l_tmp___183: CE_POINTER [INTEGER_8]
			l_tmp___184: CE_POINTER [INTEGER_8]
			l_tmp___185: CE_POINTER [INTEGER_8]
			l_tmp___186: CE_POINTER [INTEGER_8]
			l_tmp___187: CE_POINTER [INTEGER_8]
			l_tmp___188: CE_POINTER [INTEGER_8]
			l_tmp___189: CE_POINTER [INTEGER_8]
			l_tmp___190: CE_POINTER [INTEGER_8]
		do
			create l_p___0.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___7.make
			create l_tmp___8.make
			create l_tmp___9.make
			create l_tmp___10.make
			create l_tmp___11.make
			create l_tmp___12.make
			create l_tmp___13.make
			create l_tmp___14.make
			create l_tmp___15.make
			create l_tmp___16.make
			create l_tmp___17.make
			create l_tmp___18.make
			create l_tmp___19.make
			create l_tmp___20.make
			create l_tmp___21.make
			create l_tmp___22.make
			create l_tmp___23.make
			create l_tmp___24.make
			create l_tmp___25.make
			create l_tmp___26.make
			create l_tmp___27.make
			create l_tmp___28.make
			create l_tmp___29.make
			create l_tmp___30.make
			create l_tmp___31.make
			create l_tmp___32.make
			create l_tmp___33.make
			create l_tmp___34.make
			create l_tmp___35.make
			create l_tmp___36.make
			create l_tmp___37.make
			create l_tmp___38.make
			create l_tmp___39.make
			create l_tmp___40.make
			create l_tmp___41.make
			create l_tmp___42.make
			create l_tmp___43.make
			create l_tmp___44.make
			create l_tmp___45.make
			create l_tmp___46.make
			create l_tmp___47.make
			create l_tmp___48.make
			create l_tmp___49.make
			create l_tmp___50.make
			create l_tmp___51.make
			create l_tmp___52.make
			create l_tmp___53.make
			create l_tmp___54.make
			create l_tmp___55.make
			create l_tmp___56.make
			create l_tmp___57.make
			create l_tmp___58.make
			create l_tmp___59.make
			create l_tmp___60.make
			create l_tmp___61.make
			create l_tmp___62.make
			create l_tmp___63.make
			create l_tmp___64.make
			create l_tmp___65.make
			create l_tmp___66.make
			create l_tmp___67.make
			create l_tmp___68.make
			create l_tmp___69.make
			create l_tmp___70.make
			create l_tmp___71.make
			create l_tmp___72.make
			create l_tmp___73.make
			create l_tmp___74.make
			create l_tmp___75.make
			create l_tmp___76.make
			create l_tmp___77.make
			create l_tmp___78.make
			create l_tmp___79.make
			create l_tmp___80.make
			create l_tmp___81.make
			create l_tmp___82.make
			create l_tmp___83.make
			create l_tmp___84.make
			create l_tmp___85.make
			create l_tmp___86.make
			create l_tmp___87.make
			create l_tmp___88.make
			create l_tmp___89.make
			create l_tmp___90.make
			create l_tmp___91.make
			create l_tmp___92.make
			create l_tmp___93.make
			create l_tmp___94.make
			create l_tmp___95.make
			create l_tmp___96.make
			create l_tmp___97.make
			create l_tmp___98.make
			create l_tmp___99.make
			create l_tmp___100.make
			create l_tmp___101.make
			create l_tmp___102.make
			create l_tmp___103.make
			create l_tmp___104.make
			create l_tmp___105.make
			create l_tmp___106.make
			create l_tmp___107.make
			create l_tmp___108.make
			create l_tmp___109.make
			create l_tmp___110.make
			create l_tmp___111.make
			create l_tmp___112.make
			create l_tmp___113.make
			create l_tmp___114.make
			create l_tmp___115.make
			create l_tmp___116.make
			create l_tmp___117.make
			create l_tmp___118.make
			create l_tmp___119.make
			create l_tmp___120.make
			create l_tmp___121.make
			create l_tmp___122.make
			create l_tmp___123.make
			create l_tmp___124.make
			create l_tmp___125.make
			create l_tmp___126.make
			create l_tmp___127.make
			create l_tmp___128.make
			create l_tmp___129.make
			create l_tmp___130.make
			create l_tmp___131.make
			create l_tmp___132.make
			create l_tmp___133.make
			create l_tmp___134.make
			create l_tmp___135.make
			create l_tmp___136.make
			create l_tmp___137.make
			create l_tmp___138.make
			create l_tmp___139.make
			create l_tmp___140.make
			create l_tmp___141.make
			create l_tmp___142.make
			create l_tmp___143.make
			create l_tmp___144.make
			create l_tmp___145.make
			create l_tmp___146.make
			create l_tmp___147.make
			create l_tmp___148.make
			create l_tmp___149.make
			create l_tmp___150.make
			create l_tmp___151.make
			create l_tmp___152.make
			create l_tmp___153.make
			create l_tmp___154.make
			create l_tmp___155.make
			create l_tmp___156.make
			create l_tmp___157.make
			create l_tmp___158.make
			create l_tmp___159.make
			create l_tmp___160.make
			create l_tmp___161.make
			create l_tmp___162.make
			create l_tmp___163.make
			create l_tmp___164.make
			create l_tmp___165.make
			create l_tmp___166.make
			create l_tmp___167.make
			create l_tmp___168.make
			create l_tmp___169.make
			create l_tmp___170.make
			create l_tmp___171.make
			create l_tmp___172.make
			create l_tmp___173.make
			create l_tmp___174.make
			create l_tmp___175.make
			create l_tmp___176.make
			create l_tmp___177.make
			create l_tmp___178.make
			create l_tmp___179.make
			create l_tmp___180.make
			create l_tmp___181.make
			create l_tmp___182.make
			create l_tmp___183.make
			create l_tmp___184.make
			create l_tmp___185.make
			create l_tmp___186.make
			create l_tmp___187.make
			create l_tmp___188.make
			create l_tmp___189.make
			create l_tmp___190.make

			l_p___0.ce_gets (a_buffer___0)
			l_n := a_number
			l_last_digit_char := 0
			if l_n < {INTEGER_64} 0 then
				if l_n < -((((-{INTEGER_64} 1).bit_shift_left ((Integer_64_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1).to_integer_32))).bit_not) then
					l_last_digit := (l_n \\ {INTEGER_64} 10).to_integer_32
					if l_last_digit < 0 then
						l_last_digit_char := 48 - l_last_digit
					else
						l_last_digit_char := 48 + l_last_digit
					end
					l_n := l_n // ({INTEGER_64} 10)
				end
				l_tmp.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp[0] := (('-').code).to_integer_8
				l_n := -l_n
			end
			if l_n < {INTEGER_64} 10 then
				l_tmp___0.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___0[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 100 then
				l_tmp___1.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___1[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___2.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___2[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 1000 then
				l_tmp___3.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___3[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___4.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___4[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___5.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___5[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 10000 then
				l_tmp___6.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___6[0] := (l_n // {INTEGER_64} 1000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000)
				l_tmp___7.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___7[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___8.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___8[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___9.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___9[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 100000 then
				l_tmp___10.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___10[0] := (l_n // {INTEGER_64} 10000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000)
				l_tmp___11.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___11[0] := (l_n // {INTEGER_64} 1000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000)
				l_tmp___12.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___12[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___13.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___13[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___14.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___14[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 1000000 then
				l_tmp___15.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___15[0] := (l_n // {INTEGER_64} 100000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000)
				l_tmp___16.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___16[0] := (l_n // {INTEGER_64} 10000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000)
				l_tmp___17.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___17[0] := (l_n // {INTEGER_64} 1000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000)
				l_tmp___18.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___18[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___19.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___19[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___20.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___20[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 10000000 then
				l_tmp___21.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___21[0] := (l_n // {INTEGER_64} 1000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000)
				l_tmp___22.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___22[0] := (l_n // {INTEGER_64} 100000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000)
				l_tmp___23.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___23[0] := (l_n // {INTEGER_64} 10000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000)
				l_tmp___24.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___24[0] := (l_n // {INTEGER_64} 1000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000)
				l_tmp___25.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___25[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___26.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___26[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___27.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___27[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 100000000 then
				l_tmp___28.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___28[0] := (l_n // {INTEGER_64} 10000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000)
				l_tmp___29.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___29[0] := (l_n // {INTEGER_64} 1000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000)
				l_tmp___30.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___30[0] := (l_n // {INTEGER_64} 100000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000)
				l_tmp___31.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___31[0] := (l_n // {INTEGER_64} 10000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000)
				l_tmp___32.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___32[0] := (l_n // {INTEGER_64} 1000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000)
				l_tmp___33.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___33[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___34.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___34[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___35.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___35[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 1000000000 then
				l_tmp___36.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___36[0] := (l_n // {INTEGER_64} 100000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000)
				l_tmp___37.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___37[0] := (l_n // {INTEGER_64} 10000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000)
				l_tmp___38.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___38[0] := (l_n // {INTEGER_64} 1000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000)
				l_tmp___39.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___39[0] := (l_n // {INTEGER_64} 100000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000)
				l_tmp___40.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___40[0] := (l_n // {INTEGER_64} 10000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000)
				l_tmp___41.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___41[0] := (l_n // {INTEGER_64} 1000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000)
				l_tmp___42.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___42[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___43.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___43[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___44.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___44[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 10000000000 then
				l_tmp___45.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___45[0] := (l_n // {INTEGER_64} 1000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000000)
				l_tmp___46.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___46[0] := (l_n // {INTEGER_64} 100000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000)
				l_tmp___47.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___47[0] := (l_n // {INTEGER_64} 10000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000)
				l_tmp___48.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___48[0] := (l_n // {INTEGER_64} 1000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000)
				l_tmp___49.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___49[0] := (l_n // {INTEGER_64} 100000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000)
				l_tmp___50.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___50[0] := (l_n // {INTEGER_64} 10000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000)
				l_tmp___51.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___51[0] := (l_n // {INTEGER_64} 1000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000)
				l_tmp___52.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___52[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___53.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___53[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___54.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___54[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 100000000000 then
				l_tmp___55.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___55[0] := (l_n // {INTEGER_64} 10000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000000)
				l_tmp___56.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___56[0] := (l_n // {INTEGER_64} 1000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000000)
				l_tmp___57.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___57[0] := (l_n // {INTEGER_64} 100000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000)
				l_tmp___58.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___58[0] := (l_n // {INTEGER_64} 10000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000)
				l_tmp___59.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___59[0] := (l_n // {INTEGER_64} 1000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000)
				l_tmp___60.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___60[0] := (l_n // {INTEGER_64} 100000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000)
				l_tmp___61.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___61[0] := (l_n // {INTEGER_64} 10000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000)
				l_tmp___62.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___62[0] := (l_n // {INTEGER_64} 1000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000)
				l_tmp___63.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___63[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___64.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___64[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___65.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___65[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 1000000000000 then
				l_tmp___66.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___66[0] := (l_n // {INTEGER_64} 100000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000000)
				l_tmp___67.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___67[0] := (l_n // {INTEGER_64} 10000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000000)
				l_tmp___68.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___68[0] := (l_n // {INTEGER_64} 1000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000000)
				l_tmp___69.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___69[0] := (l_n // {INTEGER_64} 100000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000)
				l_tmp___70.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___70[0] := (l_n // {INTEGER_64} 10000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000)
				l_tmp___71.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___71[0] := (l_n // {INTEGER_64} 1000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000)
				l_tmp___72.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___72[0] := (l_n // {INTEGER_64} 100000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000)
				l_tmp___73.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___73[0] := (l_n // {INTEGER_64} 10000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000)
				l_tmp___74.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___74[0] := (l_n // {INTEGER_64} 1000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000)
				l_tmp___75.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___75[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___76.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___76[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___77.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___77[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 10000000000000 then
				l_tmp___78.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___78[0] := (l_n // {INTEGER_64} 1000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000000000)
				l_tmp___79.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___79[0] := (l_n // {INTEGER_64} 100000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000000)
				l_tmp___80.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___80[0] := (l_n // {INTEGER_64} 10000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000000)
				l_tmp___81.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___81[0] := (l_n // {INTEGER_64} 1000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000000)
				l_tmp___82.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___82[0] := (l_n // {INTEGER_64} 100000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000)
				l_tmp___83.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___83[0] := (l_n // {INTEGER_64} 10000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000)
				l_tmp___84.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___84[0] := (l_n // {INTEGER_64} 1000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000)
				l_tmp___85.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___85[0] := (l_n // {INTEGER_64} 100000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000)
				l_tmp___86.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___86[0] := (l_n // {INTEGER_64} 10000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000)
				l_tmp___87.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___87[0] := (l_n // {INTEGER_64} 1000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000)
				l_tmp___88.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___88[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___89.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___89[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___90.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___90[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 100000000000000 then
				l_tmp___91.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___91[0] := (l_n // {INTEGER_64} 10000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000000000)
				l_tmp___92.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___92[0] := (l_n // {INTEGER_64} 1000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000000000)
				l_tmp___93.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___93[0] := (l_n // {INTEGER_64} 100000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000000)
				l_tmp___94.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___94[0] := (l_n // {INTEGER_64} 10000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000000)
				l_tmp___95.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___95[0] := (l_n // {INTEGER_64} 1000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000000)
				l_tmp___96.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___96[0] := (l_n // {INTEGER_64} 100000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000)
				l_tmp___97.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___97[0] := (l_n // {INTEGER_64} 10000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000)
				l_tmp___98.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___98[0] := (l_n // {INTEGER_64} 1000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000)
				l_tmp___99.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___99[0] := (l_n // {INTEGER_64} 100000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000)
				l_tmp___100.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___100[0] := (l_n // {INTEGER_64} 10000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000)
				l_tmp___101.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___101[0] := (l_n // {INTEGER_64} 1000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000)
				l_tmp___102.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___102[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___103.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___103[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___104.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___104[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 1000000000000000 then
				l_tmp___105.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___105[0] := (l_n // {INTEGER_64} 100000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000000000)
				l_tmp___106.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___106[0] := (l_n // {INTEGER_64} 10000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000000000)
				l_tmp___107.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___107[0] := (l_n // {INTEGER_64} 1000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000000000)
				l_tmp___108.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___108[0] := (l_n // {INTEGER_64} 100000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000000)
				l_tmp___109.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___109[0] := (l_n // {INTEGER_64} 10000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000000)
				l_tmp___110.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___110[0] := (l_n // {INTEGER_64} 1000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000000)
				l_tmp___111.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___111[0] := (l_n // {INTEGER_64} 100000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000)
				l_tmp___112.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___112[0] := (l_n // {INTEGER_64} 10000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000)
				l_tmp___113.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___113[0] := (l_n // {INTEGER_64} 1000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000)
				l_tmp___114.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___114[0] := (l_n // {INTEGER_64} 100000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000)
				l_tmp___115.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___115[0] := (l_n // {INTEGER_64} 10000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000)
				l_tmp___116.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___116[0] := (l_n // {INTEGER_64} 1000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000)
				l_tmp___117.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___117[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___118.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___118[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___119.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___119[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 10000000000000000 then
				l_tmp___120.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___120[0] := (l_n // {INTEGER_64} 1000000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000000000000)
				l_tmp___121.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___121[0] := (l_n // {INTEGER_64} 100000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000000000)
				l_tmp___122.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___122[0] := (l_n // {INTEGER_64} 10000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000000000)
				l_tmp___123.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___123[0] := (l_n // {INTEGER_64} 1000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000000000)
				l_tmp___124.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___124[0] := (l_n // {INTEGER_64} 100000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000000)
				l_tmp___125.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___125[0] := (l_n // {INTEGER_64} 10000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000000)
				l_tmp___126.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___126[0] := (l_n // {INTEGER_64} 1000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000000)
				l_tmp___127.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___127[0] := (l_n // {INTEGER_64} 100000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000)
				l_tmp___128.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___128[0] := (l_n // {INTEGER_64} 10000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000)
				l_tmp___129.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___129[0] := (l_n // {INTEGER_64} 1000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000)
				l_tmp___130.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___130[0] := (l_n // {INTEGER_64} 100000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000)
				l_tmp___131.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___131[0] := (l_n // {INTEGER_64} 10000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000)
				l_tmp___132.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___132[0] := (l_n // {INTEGER_64} 1000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000)
				l_tmp___133.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___133[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___134.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___134[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___135.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___135[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 100000000000000000 then
				l_tmp___136.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___136[0] := (l_n // {INTEGER_64} 10000000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000000000000)
				l_tmp___137.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___137[0] := (l_n // {INTEGER_64} 1000000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000000000000)
				l_tmp___138.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___138[0] := (l_n // {INTEGER_64} 100000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000000000)
				l_tmp___139.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___139[0] := (l_n // {INTEGER_64} 10000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000000000)
				l_tmp___140.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___140[0] := (l_n // {INTEGER_64} 1000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000000000)
				l_tmp___141.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___141[0] := (l_n // {INTEGER_64} 100000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000000)
				l_tmp___142.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___142[0] := (l_n // {INTEGER_64} 10000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000000)
				l_tmp___143.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___143[0] := (l_n // {INTEGER_64} 1000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000000)
				l_tmp___144.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___144[0] := (l_n // {INTEGER_64} 100000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000)
				l_tmp___145.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___145[0] := (l_n // {INTEGER_64} 10000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000)
				l_tmp___146.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___146[0] := (l_n // {INTEGER_64} 1000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000)
				l_tmp___147.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___147[0] := (l_n // {INTEGER_64} 100000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000)
				l_tmp___148.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___148[0] := (l_n // {INTEGER_64} 10000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000)
				l_tmp___149.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___149[0] := (l_n // {INTEGER_64} 1000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000)
				l_tmp___150.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___150[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___151.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___151[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___152.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___152[0] := (l_n + {INTEGER_64} 48).to_integer_8
			elseif l_n < {INTEGER_64} 1000000000000000000 then
				l_tmp___153.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___153[0] := (l_n // {INTEGER_64} 100000000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000000000000)
				l_tmp___154.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___154[0] := (l_n // {INTEGER_64} 10000000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000000000000)
				l_tmp___155.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___155[0] := (l_n // {INTEGER_64} 1000000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000000000000)
				l_tmp___156.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___156[0] := (l_n // {INTEGER_64} 100000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000000000)
				l_tmp___157.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___157[0] := (l_n // {INTEGER_64} 10000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000000000)
				l_tmp___158.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___158[0] := (l_n // {INTEGER_64} 1000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000000000)
				l_tmp___159.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___159[0] := (l_n // {INTEGER_64} 100000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000000)
				l_tmp___160.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___160[0] := (l_n // {INTEGER_64} 10000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000000)
				l_tmp___161.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___161[0] := (l_n // {INTEGER_64} 1000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000000)
				l_tmp___162.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___162[0] := (l_n // {INTEGER_64} 100000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000)
				l_tmp___163.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___163[0] := (l_n // {INTEGER_64} 10000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000)
				l_tmp___164.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___164[0] := (l_n // {INTEGER_64} 1000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000)
				l_tmp___165.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___165[0] := (l_n // {INTEGER_64} 100000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000)
				l_tmp___166.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___166[0] := (l_n // {INTEGER_64} 10000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000)
				l_tmp___167.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___167[0] := (l_n // {INTEGER_64} 1000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000)
				l_tmp___168.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___168[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___169.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___169[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___170.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___170[0] := (l_n + {INTEGER_64} 48).to_integer_8
			else
				l_tmp___171.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___171[0] := (l_n // {INTEGER_64} 1000000000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000000000000000)
				l_tmp___172.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___172[0] := (l_n // {INTEGER_64} 100000000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000000000000)
				l_tmp___173.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___173[0] := (l_n // {INTEGER_64} 10000000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000000000000)
				l_tmp___174.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___174[0] := (l_n // {INTEGER_64} 1000000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000000000000)
				l_tmp___175.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___175[0] := (l_n // {INTEGER_64} 100000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000000000)
				l_tmp___176.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___176[0] := (l_n // {INTEGER_64} 10000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000000000)
				l_tmp___177.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___177[0] := (l_n // {INTEGER_64} 1000000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000000000)
				l_tmp___178.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___178[0] := (l_n // {INTEGER_64} 100000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000000)
				l_tmp___179.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___179[0] := (l_n // {INTEGER_64} 10000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000000)
				l_tmp___180.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___180[0] := (l_n // {INTEGER_64} 1000000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000000)
				l_tmp___181.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___181[0] := (l_n // {INTEGER_64} 100000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000000)
				l_tmp___182.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___182[0] := (l_n // {INTEGER_64} 10000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000000)
				l_tmp___183.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___183[0] := (l_n // {INTEGER_64} 1000000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000000)
				l_tmp___184.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___184[0] := (l_n // {INTEGER_64} 100000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100000)
				l_tmp___185.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___185[0] := (l_n // {INTEGER_64} 10000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10000)
				l_tmp___186.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___186[0] := (l_n // {INTEGER_64} 1000 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 1000)
				l_tmp___187.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___187[0] := (l_n // {INTEGER_64} 100 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 100)
				l_tmp___188.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___188[0] := (l_n // {INTEGER_64} 10 + {INTEGER_64} 48).to_integer_8
				l_n := l_n \\ ({INTEGER_64} 10)
				l_tmp___189.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___189[0] := (l_n + {INTEGER_64} 48).to_integer_8
			end
			if l_last_digit_char.to_boolean then
				l_tmp___190.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___190[0] := l_last_digit_char.to_integer_8
			end
			l_p___0[0] := (('%/0/').code).to_integer_8
			Result := l_p___0
		end

	number_to_static_string (a_number: INTEGER_64): CE_POINTER [INTEGER_8]
		local
			l_buf___6: CE_POINTER [INTEGER_8]
		do
			create l_buf___6.make

			l_buf___6.ce_gets (ring___0[ringpos___0])
			number_to_string (l_buf___6, a_number).do_nothing
			ringpos___0 := (ringpos___0 + 1) \\ 3
			Result := l_buf___6
		end

	determine_screen_width: INTEGER_32
		local
			l_fd: INTEGER_32
			l_wsz: SD_WINSIZE
			js: JUMP_STATE
		do
			create l_wsz.make

			if ((options_inst.opt.lfilename).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_fd := fileno ((create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)))
				if (ioctl ([l_fd, {NATURAL_32} 21523, l_wsz.address])) < 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := (l_wsz.ws_col).to_integer_32
			end
		end

	random_number (a_max: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if not rnd_seeded.to_boolean then
				l_tmp := time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
				srand48 ((l_tmp).bit_xor ((getpid).to_integer_32))
				rnd_seeded := 1
			end
			Result := ((lrand48) \\ a_max.to_integer_32).to_integer_32
		end

	random_float: REAL_64
		local
			l_tmp: INTEGER_32
		do
			if not rnd_seeded.to_boolean then
				l_tmp := time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
				srand48 ((l_tmp).bit_xor ((getpid).to_integer_32))
				rnd_seeded := 1
			end
			Result := (drand48)
		end

	abort_run_with_timeout (a_sig: INTEGER_32)
		do
			if a_sig /= 14 then
				assert_fail (ce_string ("sig == 14"), ce_string ("utils.c"), {NATURAL_32} 1912, ce_string ("abort_run_with_timeout"))
			end
			run_with_timeout_env.raise (-1)
		end

	abort_run_with_timeout_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent abort_run_with_timeout)
		end

	alarm_set (a_timeout: REAL_64)
		local
			l_itv: SD_ITIMERVAL
		do
			create l_itv.make

			memset (create {CE_POINTER [ANY]}.make_cast ((l_itv.address)), ('%/0/').code, {SD_ITIMERVAL}.sizeof.to_natural_32).do_nothing
			l_itv.it_value.tv_sec := a_timeout.truncated_to_integer
			l_itv.it_value.tv_usec := ((1000000).to_double * (a_timeout - (a_timeout.truncated_to_integer).to_double)).truncated_to_integer
			if l_itv.it_value.tv_sec = 0 then
				if l_itv.it_value.tv_usec = 0 then
					l_itv.it_value.tv_usec := (1).to_integer_32
				end
			end
			setitimer ({SC_ITIMER_WHICH}.ITIMER_REAL, (l_itv.address), create {CE_POINTER [SD_ITIMERVAL]}.make_shared (default_pointer)).do_nothing
		end

	alarm_cancel
		local
			l_disable: SD_ITIMERVAL
		do
			create l_disable.make

			memset (create {CE_POINTER [ANY]}.make_cast ((l_disable.address)), ('%/0/').code, {SD_ITIMERVAL}.sizeof.to_natural_32).do_nothing
			setitimer ({SC_ITIMER_WHICH}.ITIMER_REAL, (l_disable.address), create {CE_POINTER [SD_ITIMERVAL]}.make_shared (default_pointer)).do_nothing
		end

	run_with_timeout (a_timeout: REAL_64; a_fun: CE_ROUTINE; a_arg: CE_POINTER [ANY]): BOOLEAN
		local
			l_saved_errno: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_timeout = (0).to_double then
						a_fun.call ([a_arg])
						Result := (0).to_boolean
						js.return
					end
					if js.return_called then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						signal (14, abort_run_with_timeout_address).do_nothing
						run_with_timeout_env := create {CE_EXCEPTION}.make ($run_with_timeout, l_pos, $l_tmp)
				when 2 then -- continue here on raising run_with_timeout_env:
						if l_tmp /= 0 then
							signal (14, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
							Result := (1).to_boolean
							js.return
						end
				when 3 then -- if done
					if not js.return_called then
						alarm_set (a_timeout)
						a_fun.call ([a_arg])
						l_saved_errno := (errno_location).item
						alarm_cancel
						signal (14, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing;
						(errno_location).item := l_saved_errno
						Result := (0).to_boolean
					end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		rescue
			if attached {CE_EXCEPTION} (create {EXCEPTION_MANAGER}).last_exception as ex then
				if ex.routine = $run_with_timeout then
					l_pos := ex.position + 1
					retry
				end
				ex.re_raise
			end
		end

	xsleep (a_seconds: REAL_64)
		local
			l_sleep___0: SD_TIMESPEC
			l_remaining: SD_TIMESPEC
			js: JUMP_STATE
		do
			create l_sleep___0.make
			create l_remaining.make

			l_sleep___0.tv_sec := a_seconds.truncated_to_integer
			l_sleep___0.tv_nsec := ((1000000000).to_double * (a_seconds - (a_seconds.truncated_to_integer).to_double)).truncated_to_integer
			from
			until
				js.loop_left
			loop
				js.reset
				if (nanosleep ((l_sleep___0.address), l_remaining.address)) < 0 then
					if (errno_location).item /= 4 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_sleep___0.ce_gets (l_remaining)
				end
			end
			js.reset
		end

	base64_encode (a_data: CE_POINTER [ANY]; a_length: INTEGER_32; a_dest: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_end: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_end.make
			create l_p___0.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___7.make
			create l_tmp___8.make
			create l_tmp___9.make
			create l_tmp___10.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (a_data))
					l_end.ce_gets ((create {CE_POINTER [NATURAL_8]}.make_cast (a_data) + a_length) - 2)
					l_p___0.ce_gets (a_dest)
					from
					until
						not ((l_s.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32)
					loop
						l_tmp.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp[0] := tbl[((l_s[0]).to_integer_32).bit_shift_right (2)]
						l_tmp___0.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___0[0] := tbl[(((((l_s[0]).to_integer_32).bit_and (3))).bit_shift_left (4)) + (((l_s[1]).to_integer_32).bit_shift_right (4))]
						l_tmp___1.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___1[0] := tbl[(((((l_s[1]).to_integer_32).bit_and (15))).bit_shift_left (2)) + (((l_s[2]).to_integer_32).bit_shift_right (6))]
						l_tmp___2.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___2[0] := tbl[((l_s[2]).to_integer_32).bit_and (63)]
						l_s.ce_gets (l_s + (3))
					end
					inspect a_length \\ 3 -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 1
					l_tmp___3.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___3[0] := tbl[((l_s[0]).to_integer_32).bit_shift_right (2)]
					l_tmp___4.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___4[0] := tbl[((((l_s[0]).to_integer_32).bit_and (3))).bit_shift_left (4)]
					l_tmp___5.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___5[0] := (('=').code).to_integer_8
					l_tmp___6.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___6[0] := (('=').code).to_integer_8
					l_pos := -1 + 3 -- switch 1; break
				when 2 then -- switch 1, case 2
					l_tmp___7.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___7[0] := tbl[((l_s[0]).to_integer_32).bit_shift_right (2)]
					l_tmp___8.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___8[0] := tbl[(((((l_s[0]).to_integer_32).bit_and (3))).bit_shift_left (4)) + (((l_s[1]).to_integer_32).bit_shift_right (4))]
					l_tmp___9.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___9[0] := tbl[((((l_s[1]).to_integer_32).bit_and (15))).bit_shift_left (2)]
					l_tmp___10.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___10[0] := (('=').code).to_integer_8
					l_pos := -1 + 3 -- switch 1; break
				when 3 then -- switch 1, done:
					l_p___0[0] := (('%/0/').code).to_integer_8
					Result := (l_p___0.distance (a_dest))
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	base64_decode (a_base64: CE_POINTER [INTEGER_8]; a_dest: CE_POINTER [ANY]): INTEGER_32
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_q: CE_POINTER [INTEGER_8]
			l_c: NATURAL_8
			l_value: NATURAL_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_q.make
			create l_tmp.make
			create l_tmp___1.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___6.make
			create l_tmp___8.make
			create l_tmp___9.make
			create l_tmp___11.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (a_base64)
					l_q.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (a_dest))
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 33 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_c := (l_tmp[0]).to_natural_8
							if not (c_ctype_inst.c2_isspace (l_c.to_integer_32)) then
								js.break
							end
						end
						js.reset
						if not l_c.to_boolean then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 32 -- skip if block
						end
				when 3 then -- if:
						if l_c.to_integer_32 /= 61 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						Result := (-1)
						js.return
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if ((l_c.to_integer_32).bit_and (128)) /= 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if not ((base64_char_to_value[l_c.to_integer_32]).to_integer_32 >= 0) then
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if l_c.to_integer_32 /= 61 then
							Result := (-1)
							js.return
						end
				when 10 then -- if done
						if not js.return_called then
							l_value := (((base64_char_to_value[l_c.to_integer_32]).to_integer_32).bit_shift_left (18)).to_natural_32
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___1.ce_gets (l_p___0)
								l_p___0.ce_gets (l_p___0 + 1)
								l_c := (l_tmp___1[0]).to_natural_8
								if not (c_ctype_inst.c2_isspace (l_c.to_integer_32)) then
									js.break
								end
							end
							js.reset
							if not l_c.to_boolean then
								Result := (-1)
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 18 -- skip if block
						end
				when 11 then -- if:
						if l_c.to_integer_32 /= 61 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						Result := (-1)
						js.return
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 14 then -- else:
						if ((l_c.to_integer_32).bit_and (128)) /= 0 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if not ((base64_char_to_value[l_c.to_integer_32]).to_integer_32 >= 0) then
							l_pos := -1 + 17 -- goto _L___0
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else: | _L___0:
						if l_c.to_integer_32 /= 61 then
							Result := (-1)
							js.return
						end
				when 18 then -- if done | if done
						if not js.return_called then
							l_value := (l_value).bit_or ((((base64_char_to_value[l_c.to_integer_32]).to_integer_32).bit_shift_left (12)).to_natural_32)
							l_tmp___3.ce_gets (l_q)
							l_q.ce_gets (l_q + 1)
							l_tmp___3[0] := ((l_value).bit_shift_right (16)).to_integer_8
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___4.ce_gets (l_p___0)
								l_p___0.ce_gets (l_p___0 + 1)
								l_c := (l_tmp___4[0]).to_natural_8
								if not (c_ctype_inst.c2_isspace (l_c.to_integer_32)) then
									js.break
								end
							end
							js.reset
							if not l_c.to_boolean then
								Result := (-1)
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 23 -- skip if block
						end
				when 19 then -- if:
						if ((l_c.to_integer_32).bit_and (128)) /= 0 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if not ((base64_char_to_value[l_c.to_integer_32]).to_integer_32 >= 0) then
							l_pos := -1 + 22 -- goto _L___1
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else: | _L___1:
						if l_c.to_integer_32 /= 61 then
							Result := (-1)
							js.return
						end
				when 23 then -- if done
						if js.return_called then
							l_pos := -1 + 32 -- skip if block
						end
				when 24 then -- if:
						if l_c.to_integer_32 = 61 then
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___6.ce_gets (l_p___0)
								l_p___0.ce_gets (l_p___0 + 1)
								l_c := (l_tmp___6[0]).to_natural_8
								if not (c_ctype_inst.c2_isspace (l_c.to_integer_32)) then
									js.break
								end
							end
							js.reset
							if not l_c.to_boolean then
								Result := (-1)
								js.return
							end
							if not js.return_called and then (l_c.to_integer_32 /= 61) then
								Result := (-1)
								js.return
							end
							if not js.return_called then
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 32 -- skip if block
						end
				when 25 then -- if:
						l_value := (l_value).bit_or ((((base64_char_to_value[l_c.to_integer_32]).to_integer_32).bit_shift_left (6)).to_natural_32)
						l_tmp___8.ce_gets (l_q)
						l_q.ce_gets (l_q + 1)
						l_tmp___8[0] := (({NATURAL_32} 255).bit_and (((l_value).bit_shift_right (8)))).to_integer_8
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp___9.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_c := (l_tmp___9[0]).to_natural_8
							if not (c_ctype_inst.c2_isspace (l_c.to_integer_32)) then
								js.break
							end
						end
						js.reset
						if not l_c.to_boolean then
							Result := (-1)
							js.return
						end
						if js.return_called then
							l_pos := -1 + 32 -- skip if block
						end
				when 26 then -- if:
						if l_c.to_integer_32 = 61 then
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 32 -- skip if block
						end
				when 27 then -- if:
						if ((l_c.to_integer_32).bit_and (128)) /= 0 then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						if not ((base64_char_to_value[l_c.to_integer_32]).to_integer_32 >= 0) then
							l_pos := -1 + 30 -- goto _L___2
						end
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else: | _L___2:
						if l_c.to_integer_32 /= 61 then
							Result := (-1)
							js.return
						end
				when 31 then
						if not js.return_called then
							l_value := (l_value).bit_or ((base64_char_to_value[l_c.to_integer_32]).to_natural_32)
							l_tmp___11.ce_gets (l_q)
							l_q.ce_gets (l_q + 1)
							l_tmp___11[0] := (({NATURAL_32} 255).bit_and (l_value)).to_integer_8
						end
				when 32 then -- if done | if done | if done | if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 33 then -- loop done
					js.reset
					if not js.return_called then
						Result := (l_q.distance ((create {CE_POINTER [INTEGER_8]}.make_cast (a_dest))))
					end
				when 34 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mergesort_internal (a_base: CE_POINTER [ANY]; a_temp: CE_POINTER [ANY]; a_size: NATURAL_32; a_from: NATURAL_32; a_to: NATURAL_32; a_cmpfun: CE_ROUTINE)
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_mid: NATURAL_32
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_tmp___2: NATURAL_32
			l_tmp___3: NATURAL_32
			l_tmp___4: NATURAL_32
			l_tmp___5: NATURAL_32
			js: JUMP_STATE
		do
			if a_from < a_to then
				l_mid := (a_to + a_from) // {NATURAL_32} 2
				mergesort_internal (a_base, a_temp, a_size, a_from, l_mid, a_cmpfun)
				mergesort_internal (a_base, a_temp, a_size, l_mid + {NATURAL_32} 1, a_to, a_cmpfun)
				l_i := a_from
				l_j := l_mid + {NATURAL_32} 1
				l_k := a_from
				from
				until
					js.loop_left
				loop
					js.reset
					if l_i <= l_mid then
						if not (l_j <= a_to) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						if (a_cmpfun.integer_32_item ([create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (a_base) + (l_i * a_size).to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (a_base) + (l_j * a_size).to_integer_32))])) <= 0 then
							l_tmp := l_i
							l_i := l_i + 1
							memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (a_temp) + (l_k * a_size).to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (a_base) + (l_tmp * a_size).to_integer_32)), a_size).do_nothing
						else
							l_tmp___0 := l_j
							l_j := l_j + 1
							memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (a_temp) + (l_k * a_size).to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (a_base) + (l_tmp___0 * a_size).to_integer_32)), a_size).do_nothing
						end
						l_k := l_k + 1
					end
				end
				js.reset
				from
				until
					not (l_i <= l_mid)
				loop
					l_tmp___2 := l_i
					l_i := l_i + 1
					l_tmp___3 := l_k
					l_k := l_k + 1
					memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (a_temp) + (l_tmp___3 * a_size).to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (a_base) + (l_tmp___2 * a_size).to_integer_32)), a_size).do_nothing
				end
				from
				until
					not (l_j <= a_to)
				loop
					l_tmp___4 := l_j
					l_j := l_j + 1
					l_tmp___5 := l_k
					l_k := l_k + 1
					memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (a_temp) + (l_tmp___5 * a_size).to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (a_base) + (l_tmp___4 * a_size).to_integer_32)), a_size).do_nothing
				end
				l_k := a_from
				from
				until
					not (l_k <= a_to)
				loop
					memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (a_base) + (l_k * a_size).to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (a_temp) + (l_k * a_size).to_integer_32)), a_size).do_nothing
					l_k := l_k + 1
				end
			end
		end

	stable_sort (a_base: CE_POINTER [ANY]; a_nmemb: NATURAL_32; a_size: NATURAL_32; a_cmpfun: CE_ROUTINE)
		local
			l_temp: CE_POINTER [ANY]
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_temp.make

			if a_size > {NATURAL_32} 1 then
				l_temp.ce_gets ((l_aaf.new ((a_nmemb * a_size) * Pointer_bytes.to_natural_32)))
				mergesort_internal (a_base, l_temp, a_size, (0).to_natural_32, a_nmemb - {NATURAL_32} 1, a_cmpfun)
			end
		end

	print_decimal (a_number: REAL_64): CE_POINTER [INTEGER_8]
		local
			l_n: REAL_64
			l_tmp: REAL_64
		do
			if a_number >= (0).to_double then
				l_tmp := a_number
			else
				l_tmp := -a_number
			end
			l_n := l_tmp
			if l_n >= 9.95 then
				snprintf ([buf___4, (Integer_8_bytes.to_natural_32 * (32).to_natural_32), ce_string ("%%.0f"), a_number]).do_nothing
			elseif l_n >= 0.95 then
				snprintf ([buf___4, (Integer_8_bytes.to_natural_32 * (32).to_natural_32), ce_string ("%%.1f"), a_number]).do_nothing
			elseif l_n >= 0.001 then
				snprintf ([buf___4, (Integer_8_bytes.to_natural_32 * (32).to_natural_32), ce_string ("%%.1g"), a_number]).do_nothing
			elseif l_n >= 0.0005 then
				snprintf ([buf___4, (Integer_8_bytes.to_natural_32 * (32).to_natural_32), ce_string ("%%.3f"), a_number]).do_nothing
			else
				strcpy (buf___4, ce_string ("0")).do_nothing
			end
			Result := buf___4
		end

end
