class
	SD_OPTION

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	has_arg: INTEGER_32 assign set_has_arg
		do
			Result := c_has_arg (c_pointer)
		end

	flag: CE_POINTER [INTEGER_32] assign set_flag
		do
			create Result.make_shared (c_flag (c_pointer))
		end

	val: INTEGER_32 assign set_val
		do
			Result := c_val (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_has_arg (a_has_arg: INTEGER_32)
		do
			c_set_has_arg (c_pointer, a_has_arg)
		end

	set_flag (a_flag: CE_POINTER [INTEGER_32])
		do
			c_set_flag (c_pointer, a_flag.c_pointer)
		end

	set_val (a_val: INTEGER_32)
		do
			c_set_val (c_pointer, a_val)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct option *)$tmp)->name;"
		end

	c_has_arg (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct option *)$tmp)->has_arg;"
		end

	c_flag (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int *)((struct option *)$tmp)->flag;"
		end

	c_val (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct option *)$tmp)->val;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct option *)$tmp)->name = (char const *)$a_name;"
		end

	c_set_has_arg (tmp: POINTER; a_has_arg: INTEGER_32)
		external
			"C inline"
		alias
			"((struct option *)$tmp)->has_arg = $a_has_arg;"
		end

	c_set_flag (tmp: POINTER; a_flag: POINTER)
		external
			"C inline"
		alias
			"((struct option *)$tmp)->flag = (int *)$a_flag;"
		end

	c_set_val (tmp: POINTER; a_val: INTEGER_32)
		external
			"C inline"
		alias
			"((struct option *)$tmp)->val = $a_val;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct option);"
		end

end
