class
	SD_SOCKADDR

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sa_family: NATURAL_16 assign set_sa_family
		do
			Result := c_sa_family (c_pointer)
		end

	sa_data: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_sa_data (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_sa_family (a_sa_family: NATURAL_16)
		do
			c_set_sa_family (c_pointer, a_sa_family)
		end

feature {NONE} -- C getters

	c_sa_family (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct sockaddr *)$tmp)->sa_family;"
		end

	c_sa_data (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct sockaddr *tmp = (struct sockaddr *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->sa_data) / sizeof(tmp->sa_data[0]);
				return tmp->sa_data;
			]"
		end

feature {NONE} -- C setters

	c_set_sa_family (tmp: POINTER; a_sa_family: NATURAL_16)
		external
			"C inline"
		alias
			"((struct sockaddr *)$tmp)->sa_family = $a_sa_family;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct sockaddr);"
		end

end
