class
	SD_SOCKADDR_STORAGE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ss_family: NATURAL_16 assign set_ss_family
		do
			Result := c_ss_family (c_pointer)
		end

	ss_align: NATURAL_32 assign set_ss_align
		do
			Result := c_ss_align (c_pointer)
		end

	ss_padding: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_ss_padding (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_ss_family (a_ss_family: NATURAL_16)
		do
			c_set_ss_family (c_pointer, a_ss_family)
		end

	set_ss_align (a_ss_align: NATURAL_32)
		do
			c_set_ss_align (c_pointer, a_ss_align)
		end

feature {NONE} -- C getters

	c_ss_family (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct sockaddr_storage *)$tmp)->ss_family;"
		end

	c_ss_align (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct sockaddr_storage *)$tmp)->__ss_align;"
		end

	c_ss_padding (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct sockaddr_storage *tmp = (struct sockaddr_storage *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->__ss_padding) / sizeof(tmp->__ss_padding[0]);
				return tmp->__ss_padding;
			]"
		end

feature {NONE} -- C setters

	c_set_ss_family (tmp: POINTER; a_ss_family: NATURAL_16)
		external
			"C inline"
		alias
			"((struct sockaddr_storage *)$tmp)->ss_family = $a_ss_family;"
		end

	c_set_ss_align (tmp: POINTER; a_ss_align: NATURAL_32)
		external
			"C inline"
		alias
			"((struct sockaddr_storage *)$tmp)->__ss_align = $a_ss_align;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct sockaddr_storage);"
		end

end
