deferred class
	S_STDIO

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	snprintf (a_args: TUPLE [a_s: CE_POINTER [INTEGER_8]; a_maxlen: NATURAL_32; a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_snprintf)).integer_32_item (a_args)
		end

	c_snprintf: POINTER
		external
			"C inline use <wget.h>"
		alias
			"return &snprintf;"
		end

	rename2 (a_old: CE_POINTER [INTEGER_8]; a_new: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_rename2 (a_old.c_pointer, a_new.c_pointer)
		end

	c_rename2 (a_old: POINTER; a_new: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return rename($a_old, $a_new);"
		end

	fclose (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fclose (a_stream.c_pointer)
		end

	c_fclose (a_stream: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return fclose($a_stream);"
		end

	fopen (a_filename: CE_POINTER [INTEGER_8]; a_modes: CE_POINTER [INTEGER_8]): CE_POINTER [SD_IO_FILE]
		do
			create Result.make_shared (c_fopen (a_filename.c_pointer, a_modes.c_pointer))
		end

	c_fopen (a_filename: POINTER; a_modes: POINTER): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return fopen($a_filename, $a_modes);"
		end

	sprintf (a_args: TUPLE [a_s: CE_POINTER [INTEGER_8]; a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_sprintf)).integer_32_item (a_args)
		end

	c_sprintf: POINTER
		external
			"C inline use <wget.h>"
		alias
			"return &sprintf;"
		end

	fputs (a_s: CE_POINTER [INTEGER_8]; a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fputs (a_s.c_pointer, a_stream.c_pointer)
		end

	c_fputs (a_s: POINTER; a_stream: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return fputs($a_s, $a_stream);"
		end

	fwrite (a_ptr: CE_POINTER [ANY]; a_size: NATURAL_32; a_n: NATURAL_32; a_s: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fwrite (a_ptr.c_pointer, a_size, a_n, a_s.c_pointer)
		end

	c_fwrite (a_ptr: POINTER; a_size: NATURAL_32; a_n: NATURAL_32; a_s: POINTER): NATURAL_32
		external
			"C inline use <wget.h>"
		alias
			"return fwrite($a_ptr, $a_size, $a_n, $a_s);"
		end

	fprintf (a_args: TUPLE [a_stream: CE_POINTER [SD_IO_FILE]; a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_fprintf)).integer_32_item (a_args)
		end

	c_fprintf: POINTER
		external
			"C inline use <wget.h>"
		alias
			"return &fprintf;"
		end

	sscanf (a_args: TUPLE [a_s: CE_POINTER [INTEGER_8]; a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_sscanf)).integer_32_item (a_args)
		end

	c_sscanf: POINTER
		external
			"C inline use <wget.h>"
		alias
			"return &sscanf;"
		end

	fputc (a_c: INTEGER_32; a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fputc (a_c, a_stream.c_pointer)
		end

	c_fputc (a_c: INTEGER_32; a_stream: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return fputc($a_c, $a_stream);"
		end

	ferror (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_ferror (a_stream.c_pointer)
		end

	c_ferror (a_stream: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return ferror($a_stream);"
		end

	fread (a_ptr: CE_POINTER [ANY]; a_size: NATURAL_32; a_n: NATURAL_32; a_stream: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fread (a_ptr.c_pointer, a_size, a_n, a_stream.c_pointer)
		end

	c_fread (a_ptr: POINTER; a_size: NATURAL_32; a_n: NATURAL_32; a_stream: POINTER): NATURAL_32
		external
			"C inline use <wget.h>"
		alias
			"return fread($a_ptr, $a_size, $a_n, $a_stream);"
		end

	clearerr (a_stream: CE_POINTER [SD_IO_FILE])
		do
			c_clearerr (a_stream.c_pointer)
		end

	c_clearerr (a_stream: POINTER)
		external
			"C inline use <wget.h>"
		alias
			"clearerr($a_stream);"
		end

	fflush (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fflush (a_stream.c_pointer)
		end

	c_fflush (a_stream: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return fflush($a_stream);"
		end

	fgetc (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fgetc (a_stream.c_pointer)
		end

	c_fgetc (a_stream: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return fgetc($a_stream);"
		end

	feof (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_feof (a_stream.c_pointer)
		end

	c_feof (a_stream: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return feof($a_stream);"
		end

	vfprintf (a_s: CE_POINTER [SD_IO_FILE]; a_format: CE_POINTER [INTEGER_8]; a_arg: CE_VA_LIST): INTEGER_32
		do
			Result := c_vfprintf (a_s.c_pointer, a_format.c_pointer, a_arg.c_pointer)
		end

	c_vfprintf (a_s: POINTER; a_format: POINTER; a_arg: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return vfprintf($a_s, $a_format, $a_arg);"
		end

	vsnprintf (a_s: CE_POINTER [INTEGER_8]; a_maxlen: NATURAL_32; a_format: CE_POINTER [INTEGER_8]; a_arg: CE_VA_LIST): INTEGER_32
		do
			Result := c_vsnprintf (a_s.c_pointer, a_maxlen, a_format.c_pointer, a_arg.c_pointer)
		end

	c_vsnprintf (a_s: POINTER; a_maxlen: NATURAL_32; a_format: POINTER; a_arg: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return vsnprintf($a_s, $a_maxlen, $a_format, $a_arg);"
		end

	fileno (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fileno (a_stream.c_pointer)
		end

	c_fileno (a_stream: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return fileno($a_stream);"
		end

	printf (a_args: TUPLE [a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_printf)).integer_32_item (a_args)
		end

	c_printf: POINTER
		external
			"C inline use <wget.h>"
		alias
			"return &printf;"
		end

	perror (a_s: CE_POINTER [INTEGER_8])
		do
			c_perror (a_s.c_pointer)
		end

	c_perror (a_s: POINTER)
		external
			"C inline use <wget.h>"
		alias
			"perror($a_s);"
		end

	freopen (a_filename: CE_POINTER [INTEGER_8]; a_modes: CE_POINTER [INTEGER_8]; a_stream: CE_POINTER [SD_IO_FILE]): CE_POINTER [SD_IO_FILE]
		do
			create Result.make_shared (c_freopen (a_filename.c_pointer, a_modes.c_pointer, a_stream.c_pointer))
		end

	c_freopen (a_filename: POINTER; a_modes: POINTER; a_stream: POINTER): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return freopen($a_filename, $a_modes, $a_stream);"
		end

	fdopen (a_fd: INTEGER_32; a_modes: CE_POINTER [INTEGER_8]): CE_POINTER [SD_IO_FILE]
		do
			create Result.make_shared (c_fdopen (a_fd, a_modes.c_pointer))
		end

	c_fdopen (a_fd: INTEGER_32; a_modes: POINTER): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return fdopen($a_fd, $a_modes);"
		end

	vasprintf (a_ptr: CE_POINTER [CE_POINTER [INTEGER_8]]; a_f: CE_POINTER [INTEGER_8]; a_arg: CE_VA_LIST): INTEGER_32
		do
			Result := c_vasprintf (a_ptr.c_pointer, a_f.c_pointer, a_arg.c_pointer)
		end

	c_vasprintf (a_ptr: POINTER; a_f: POINTER; a_arg: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return vasprintf($a_ptr, $a_f, $a_arg);"
		end

	fgets (a_s: CE_POINTER [INTEGER_8]; a_n: INTEGER_32; a_stream: CE_POINTER [SD_IO_FILE]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_fgets (a_s.c_pointer, a_n, a_stream.c_pointer))
		end

	c_fgets (a_s: POINTER; a_n: INTEGER_32; a_stream: POINTER): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return fgets($a_s, $a_n, $a_stream);"
		end

	fseeko (a_stream: CE_POINTER [SD_IO_FILE]; a_off: INTEGER_32; a_whence: INTEGER_32): INTEGER_32
		do
			Result := c_fseeko (a_stream.c_pointer, a_off, a_whence)
		end

	c_fseeko (a_stream: POINTER; a_off: INTEGER_32; a_whence: INTEGER_32): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return fseeko($a_stream, $a_off, $a_whence);"
		end

	ftello (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_ftello (a_stream.c_pointer)
		end

	c_ftello (a_stream: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return ftello($a_stream);"
		end

	fscanf (a_args: TUPLE [a_stream: CE_POINTER [SD_IO_FILE]; a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_fscanf)).integer_32_item (a_args)
		end

	c_fscanf: POINTER
		external
			"C inline use <wget.h>"
		alias
			"return &fscanf;"
		end

	getc_unlocked (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_getc_unlocked (a_stream.c_pointer)
		end

	c_getc_unlocked (a_stream: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return getc_unlocked($a_stream);"
		end

	ungetc (a_c: INTEGER_32; a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_ungetc (a_c, a_stream.c_pointer)
		end

	c_ungetc (a_c: INTEGER_32; a_stream: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return ungetc($a_c, $a_stream);"
		end

	fflush_unlocked (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fflush_unlocked (a_stream.c_pointer)
		end

	c_fflush_unlocked (a_stream: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return fflush_unlocked($a_stream);"
		end

	putc_unlocked (a_c: INTEGER_32; a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_putc_unlocked (a_c, a_stream.c_pointer)
		end

	c_putc_unlocked (a_c: INTEGER_32; a_stream: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return putc_unlocked($a_c, $a_stream);"
		end

	getline (a_lineptr: CE_POINTER [CE_POINTER [INTEGER_8]]; a_n: CE_POINTER [NATURAL_32]; a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_getline (a_lineptr.c_pointer, a_n.c_pointer, a_stream.c_pointer)
		end

	c_getline (a_lineptr: POINTER; a_n: POINTER; a_stream: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return getline($a_lineptr, $a_n, $a_stream);"
		end

	fputs_unlocked (a_s: CE_POINTER [INTEGER_8]; a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fputs_unlocked (a_s.c_pointer, a_stream.c_pointer)
		end

	c_fputs_unlocked (a_s: POINTER; a_stream: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return fputs_unlocked($a_s, $a_stream);"
		end

	flockfile (a_stream: CE_POINTER [SD_IO_FILE])
		do
			c_flockfile (a_stream.c_pointer)
		end

	c_flockfile (a_stream: POINTER)
		external
			"C inline use <wget.h>"
		alias
			"flockfile($a_stream);"
		end

	funlockfile (a_stream: CE_POINTER [SD_IO_FILE])
		do
			c_funlockfile (a_stream.c_pointer)
		end

	c_funlockfile (a_stream: POINTER)
		external
			"C inline use <wget.h>"
		alias
			"funlockfile($a_stream);"
		end

end
