deferred class
	S_TIME

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	time (a_timer: CE_POINTER [INTEGER_32]): INTEGER_32
		do
			Result := c_time (a_timer.c_pointer)
		end

	c_time (a_timer: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return time($a_timer);"
		end

	mktime (a_tp: CE_POINTER [SD_TM]): INTEGER_32
		do
			Result := c_mktime (a_tp.c_pointer)
		end

	c_mktime (a_tp: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return mktime($a_tp);"
		end

	strptime (a_s: CE_POINTER [INTEGER_8]; a_fmt: CE_POINTER [INTEGER_8]; a_tp: CE_POINTER [SD_TM]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strptime (a_s.c_pointer, a_fmt.c_pointer, a_tp.c_pointer))
		end

	c_strptime (a_s: POINTER; a_fmt: POINTER; a_tp: POINTER): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return strptime($a_s, $a_fmt, $a_tp);"
		end

	localtime (a_timer: CE_POINTER [INTEGER_32]): CE_POINTER [SD_TM]
		do
			create Result.make_shared (c_localtime (a_timer.c_pointer))
		end

	c_localtime (a_timer: POINTER): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return localtime($a_timer);"
		end

	timegm (a_tp: CE_POINTER [SD_TM]): INTEGER_32
		do
			Result := c_timegm (a_tp.c_pointer)
		end

	c_timegm (a_tp: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return timegm($a_tp);"
		end

	clock_getres (a_clock_id: INTEGER_32; a_res: CE_POINTER [SD_TIMESPEC]): INTEGER_32
		do
			Result := c_clock_getres (a_clock_id, a_res.c_pointer)
		end

	c_clock_getres (a_clock_id: INTEGER_32; a_res: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return clock_getres($a_clock_id, $a_res);"
		end

	clock_gettime (a_clock_id: INTEGER_32; a_tp: CE_POINTER [SD_TIMESPEC]): INTEGER_32
		do
			Result := c_clock_gettime (a_clock_id, a_tp.c_pointer)
		end

	c_clock_gettime (a_clock_id: INTEGER_32; a_tp: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return clock_gettime($a_clock_id, $a_tp);"
		end

	strftime (a_s: CE_POINTER [INTEGER_8]; a_maxsize: NATURAL_32; a_format: CE_POINTER [INTEGER_8]; a_tp: CE_POINTER [SD_TM]): NATURAL_32
		do
			Result := c_strftime (a_s.c_pointer, a_maxsize, a_format.c_pointer, a_tp.c_pointer)
		end

	c_strftime (a_s: POINTER; a_maxsize: NATURAL_32; a_format: POINTER; a_tp: POINTER): NATURAL_32
		external
			"C inline use <wget.h>"
		alias
			"return strftime($a_s, $a_maxsize, $a_format, $a_tp);"
		end

	nanosleep (a_requested_time: CE_POINTER [SD_TIMESPEC]; a_remaining: CE_POINTER [SD_TIMESPEC]): INTEGER_32
		do
			Result := c_nanosleep (a_requested_time.c_pointer, a_remaining.c_pointer)
		end

	c_nanosleep (a_requested_time: POINTER; a_remaining: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return nanosleep($a_requested_time, $a_remaining);"
		end

end
