deferred class
	S_UNISTD

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	close (a_fd: INTEGER_32): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return close($a_fd);"
		end

	read (a_fd: INTEGER_32; a_buf: CE_POINTER [ANY]; a_nbytes: NATURAL_32): INTEGER_32
		do
			Result := c_read (a_fd, a_buf.c_pointer, a_nbytes)
		end

	c_read (a_fd: INTEGER_32; a_buf: POINTER; a_nbytes: NATURAL_32): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return read($a_fd, $a_buf, $a_nbytes);"
		end

	write (a_fd: INTEGER_32; a_buf: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		do
			Result := c_write (a_fd, a_buf.c_pointer, a_n)
		end

	c_write (a_fd: INTEGER_32; a_buf: POINTER; a_n: NATURAL_32): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return write($a_fd, $a_buf, $a_n);"
		end

	unlink (a_name: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_unlink (a_name.c_pointer)
		end

	c_unlink (a_name: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return unlink($a_name);"
		end

	symlink (a_from: CE_POINTER [INTEGER_8]; a_to: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_symlink (a_from.c_pointer, a_to.c_pointer)
		end

	c_symlink (a_from: POINTER; a_to: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return symlink($a_from, $a_to);"
		end

	readlink (a_path: CE_POINTER [INTEGER_8]; a_buf: CE_POINTER [INTEGER_8]; a_len: NATURAL_32): INTEGER_32
		do
			Result := c_readlink (a_path.c_pointer, a_buf.c_pointer, a_len)
		end

	c_readlink (a_path: POINTER; a_buf: POINTER; a_len: NATURAL_32): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return readlink($a_path, $a_buf, $a_len);"
		end

	getuid: NATURAL_32
		external
			"C inline use <wget.h>"
		alias
			"return getuid();"
		end

	isatty (a_fd: INTEGER_32): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return isatty($a_fd);"
		end

	sysconf (a_name: INTEGER_32): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sysconf($a_name);"
		end

	getpid: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return getpid();"
		end

	setsid: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return setsid();"
		end

	fork: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return eiffel_fork();"
		end

end
