class
	PD_ALLOC_HEADER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_ALLOC_HEADER] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_ALLOC_HEADER] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	size: INTEGER_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	line: INTEGER_32 assign set_line
		do
			Result := c_line (c_pointer)
		end

	file: CE_POINTER [NATURAL_8] assign set_file
		do
			create Result.make_shared (c_file (c_pointer))
		end

	comment: CE_POINTER [NATURAL_8] assign set_comment
		do
			create Result.make_shared (c_comment (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_ALLOC_HEADER])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_ALLOC_HEADER])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_size (a_size: INTEGER_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_line (a_line: INTEGER_32)
		do
			c_set_line (c_pointer, a_line)
		end

	set_file (a_file: CE_POINTER [NATURAL_8])
		do
			c_set_file (c_pointer, a_file.c_pointer)
		end

	set_comment (a_comment: CE_POINTER [NATURAL_8])
		do
			c_set_comment (c_pointer, a_comment.c_pointer)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct alloc_header *)((struct alloc_header *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct alloc_header *)((struct alloc_header *)$tmp)->prev;"
		end

	c_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct alloc_header *)$tmp)->size;"
		end

	c_line (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct alloc_header *)$tmp)->line;"
		end

	c_file (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct alloc_header *)$tmp)->file;"
		end

	c_comment (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct alloc_header *)$tmp)->comment;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct alloc_header *)$tmp)->next = (struct alloc_header *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct alloc_header *)$tmp)->prev = (struct alloc_header *)$a_prev;"
		end

	c_set_size (tmp: POINTER; a_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct alloc_header *)$tmp)->size = $a_size;"
		end

	c_set_line (tmp: POINTER; a_line: INTEGER_32)
		external
			"C inline"
		alias
			"((struct alloc_header *)$tmp)->line = $a_line;"
		end

	c_set_file (tmp: POINTER; a_file: POINTER)
		external
			"C inline"
		alias
			"((struct alloc_header *)$tmp)->file = (unsigned char *)$a_file;"
		end

	c_set_comment (tmp: POINTER; a_comment: POINTER)
		external
			"C inline"
		alias
			"((struct alloc_header *)$tmp)->comment = (unsigned char *)$a_comment;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct alloc_header);"
		end

end
