class
	PD_ASSOC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_ASSOC] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_ASSOC] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	cnt: NATURAL_32 assign set_cnt
		do
			Result := c_cnt (c_pointer)
		end

	label: CE_POINTER [NATURAL_8] assign set_label
		do
			create Result.make_shared (c_label (c_pointer))
		end

	ct: CE_POINTER [NATURAL_8] assign set_ct
		do
			create Result.make_shared (c_ct (c_pointer))
		end

	prog: CE_POINTER [NATURAL_8] assign set_prog
		do
			create Result.make_shared (c_prog (c_pointer))
		end

	cons: INTEGER_32 assign set_cons
		do
			Result := c_cons (c_pointer)
		end

	cons_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct assoc, cons);"
		end

	xwin: INTEGER_32 assign set_xwin
		do
			Result := c_xwin (c_pointer)
		end

	xwin_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct assoc, xwin);"
		end

	block: INTEGER_32 assign set_block
		do
			Result := c_block (c_pointer)
		end

	block_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct assoc, block);"
		end

	ask: INTEGER_32 assign set_ask
		do
			Result := c_ask (c_pointer)
		end

	ask_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct assoc, ask);"
		end

	system: INTEGER_32 assign set_system
		do
			Result := c_system (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_ASSOC])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_ASSOC])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_cnt (a_cnt: NATURAL_32)
		do
			c_set_cnt (c_pointer, a_cnt)
		end

	set_label (a_label: CE_POINTER [NATURAL_8])
		do
			c_set_label (c_pointer, a_label.c_pointer)
		end

	set_ct (a_ct: CE_POINTER [NATURAL_8])
		do
			c_set_ct (c_pointer, a_ct.c_pointer)
		end

	set_prog (a_prog: CE_POINTER [NATURAL_8])
		do
			c_set_prog (c_pointer, a_prog.c_pointer)
		end

	set_cons (a_cons: INTEGER_32)
		do
			c_set_cons (c_pointer, a_cons)
		end

	set_xwin (a_xwin: INTEGER_32)
		do
			c_set_xwin (c_pointer, a_xwin)
		end

	set_block (a_block: INTEGER_32)
		do
			c_set_block (c_pointer, a_block)
		end

	set_ask (a_ask: INTEGER_32)
		do
			c_set_ask (c_pointer, a_ask)
		end

	set_system (a_system: INTEGER_32)
		do
			c_set_system (c_pointer, a_system)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct assoc *)((struct assoc *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct assoc *)((struct assoc *)$tmp)->prev;"
		end

	c_cnt (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct assoc *)$tmp)->cnt;"
		end

	c_label (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct assoc *)$tmp)->label;"
		end

	c_ct (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct assoc *)$tmp)->ct;"
		end

	c_prog (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct assoc *)$tmp)->prog;"
		end

	c_cons (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct assoc *)$tmp)->cons;"
		end

	c_xwin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct assoc *)$tmp)->xwin;"
		end

	c_block (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct assoc *)$tmp)->block;"
		end

	c_ask (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct assoc *)$tmp)->ask;"
		end

	c_system (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct assoc *)$tmp)->system;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct assoc *)$tmp)->next = (struct assoc *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct assoc *)$tmp)->prev = (struct assoc *)$a_prev;"
		end

	c_set_cnt (tmp: POINTER; a_cnt: NATURAL_32)
		external
			"C inline"
		alias
			"((struct assoc *)$tmp)->cnt = $a_cnt;"
		end

	c_set_label (tmp: POINTER; a_label: POINTER)
		external
			"C inline"
		alias
			"((struct assoc *)$tmp)->label = (unsigned char *)$a_label;"
		end

	c_set_ct (tmp: POINTER; a_ct: POINTER)
		external
			"C inline"
		alias
			"((struct assoc *)$tmp)->ct = (unsigned char *)$a_ct;"
		end

	c_set_prog (tmp: POINTER; a_prog: POINTER)
		external
			"C inline"
		alias
			"((struct assoc *)$tmp)->prog = (unsigned char *)$a_prog;"
		end

	c_set_cons (tmp: POINTER; a_cons: INTEGER_32)
		external
			"C inline"
		alias
			"((struct assoc *)$tmp)->cons = $a_cons;"
		end

	c_set_xwin (tmp: POINTER; a_xwin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct assoc *)$tmp)->xwin = $a_xwin;"
		end

	c_set_block (tmp: POINTER; a_block: INTEGER_32)
		external
			"C inline"
		alias
			"((struct assoc *)$tmp)->block = $a_block;"
		end

	c_set_ask (tmp: POINTER; a_ask: INTEGER_32)
		external
			"C inline"
		alias
			"((struct assoc *)$tmp)->ask = $a_ask;"
		end

	c_set_system (tmp: POINTER; a_system: INTEGER_32)
		external
			"C inline"
		alias
			"((struct assoc *)$tmp)->system = $a_system;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct assoc);"
		end

end
