class
	PD_BLACKLIST_ENTRY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_BLACKLIST_ENTRY] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_BLACKLIST_ENTRY] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	flags: INTEGER_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	host: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_host (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_BLACKLIST_ENTRY])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_BLACKLIST_ENTRY])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_flags (a_flags: INTEGER_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct blacklist_entry *)((struct blacklist_entry *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct blacklist_entry *)((struct blacklist_entry *)$tmp)->prev;"
		end

	c_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct blacklist_entry *)$tmp)->flags;"
		end

	c_host (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct blacklist_entry *tmp = (struct blacklist_entry *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->host) / sizeof(tmp->host[0]);
				return tmp->host;
			]"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct blacklist_entry *)$tmp)->next = (struct blacklist_entry *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct blacklist_entry *)$tmp)->prev = (struct blacklist_entry *)$a_prev;"
		end

	c_set_flags (tmp: POINTER; a_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct blacklist_entry *)$tmp)->flags = $a_flags;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct blacklist_entry);"
		end

end
