class
	PD_BOOKMARK

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_BOOKMARK] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_BOOKMARK] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	id: INTEGER_32 assign set_id
		do
			Result := c_id (c_pointer)
		end

	title: CE_POINTER [NATURAL_8] assign set_title
		do
			create Result.make_shared (c_title (c_pointer))
		end

	url: CE_POINTER [NATURAL_8] assign set_url
		do
			create Result.make_shared (c_url (c_pointer))
		end

	type: NATURAL_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	type_data: CE_POINTER [ANY] assign set_type_data
		do
			create Result.make_shared (c_type_data (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_BOOKMARK])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_BOOKMARK])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_id (a_id: INTEGER_32)
		do
			c_set_id (c_pointer, a_id)
		end

	set_title (a_title: CE_POINTER [NATURAL_8])
		do
			c_set_title (c_pointer, a_title.c_pointer)
		end

	set_url (a_url: CE_POINTER [NATURAL_8])
		do
			c_set_url (c_pointer, a_url.c_pointer)
		end

	set_type (a_type: NATURAL_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_type_data (a_type_data: CE_POINTER [ANY])
		do
			c_set_type_data (c_pointer, a_type_data.c_pointer)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct bookmark *)((struct bookmark *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct bookmark *)((struct bookmark *)$tmp)->prev;"
		end

	c_id (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct bookmark *)$tmp)->id;"
		end

	c_title (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct bookmark *)$tmp)->title;"
		end

	c_url (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct bookmark *)$tmp)->url;"
		end

	c_type (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct bookmark *)$tmp)->type;"
		end

	c_type_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct bookmark *)$tmp)->type_data;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct bookmark *)$tmp)->next = (struct bookmark *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct bookmark *)$tmp)->prev = (struct bookmark *)$a_prev;"
		end

	c_set_id (tmp: POINTER; a_id: INTEGER_32)
		external
			"C inline"
		alias
			"((struct bookmark *)$tmp)->id = $a_id;"
		end

	c_set_title (tmp: POINTER; a_title: POINTER)
		external
			"C inline"
		alias
			"((struct bookmark *)$tmp)->title = (unsigned char *)$a_title;"
		end

	c_set_url (tmp: POINTER; a_url: POINTER)
		external
			"C inline"
		alias
			"((struct bookmark *)$tmp)->url = (unsigned char *)$a_url;"
		end

	c_set_type (tmp: POINTER; a_type: NATURAL_32)
		external
			"C inline"
		alias
			"((struct bookmark *)$tmp)->type = $a_type;"
		end

	c_set_type_data (tmp: POINTER; a_type_data: POINTER)
		external
			"C inline"
		alias
			"((struct bookmark *)$tmp)->type_data = (void *)$a_type_data;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct bookmark);"
		end

end
