class
	PD_BOTTOM_HALF

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_BOTTOM_HALF] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_BOTTOM_HALF] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	fn: CE_ROUTINE assign set_fn
		do
			create Result.make_shared (c_fn (c_pointer))
		end

	data: CE_POINTER [ANY] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_BOTTOM_HALF])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_BOTTOM_HALF])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_fn (a_fn: CE_ROUTINE)
		do
			c_set_fn (c_pointer, a_fn.c_pointer)
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct bottom_half *)((struct bottom_half *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct bottom_half *)((struct bottom_half *)$tmp)->prev;"
		end

	c_fn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void *))((struct bottom_half *)$tmp)->fn;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct bottom_half *)$tmp)->data;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct bottom_half *)$tmp)->next = (struct bottom_half *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct bottom_half *)$tmp)->prev = (struct bottom_half *)$a_prev;"
		end

	c_set_fn (tmp: POINTER; a_fn: POINTER)
		external
			"C inline"
		alias
			"((struct bottom_half *)$tmp)->fn = (void( *)(void *))$a_fn;"
		end

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct bottom_half *)$tmp)->data = (void *)$a_data;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct bottom_half);"
		end

end
