class
	PD_BOX_ITEM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_BOX_ITEM] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_BOX_ITEM] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	text: CE_POINTER [NATURAL_8] assign set_text
		do
			create Result.make_shared (c_text (c_pointer))
		end

	on_hilight: CE_ROUTINE assign set_on_hilight
		do
			create Result.make_shared (c_on_hilight (c_pointer))
		end

	on_selected: CE_ROUTINE assign set_on_selected
		do
			create Result.make_shared (c_on_selected (c_pointer))
		end

	data: CE_POINTER [ANY] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	free_i: INTEGER_32 assign set_free_i
		do
			Result := c_free_i (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_BOX_ITEM])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_BOX_ITEM])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_text (a_text: CE_POINTER [NATURAL_8])
		do
			c_set_text (c_pointer, a_text.c_pointer)
		end

	set_on_hilight (a_on_hilight: CE_ROUTINE)
		do
			c_set_on_hilight (c_pointer, a_on_hilight.c_pointer)
		end

	set_on_selected (a_on_selected: CE_ROUTINE)
		do
			c_set_on_selected (c_pointer, a_on_selected.c_pointer)
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_free_i (a_free_i: INTEGER_32)
		do
			c_set_free_i (c_pointer, a_free_i)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct box_item *)((struct box_item *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct box_item *)((struct box_item *)$tmp)->prev;"
		end

	c_text (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct box_item *)$tmp)->text;"
		end

	c_on_hilight (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct terminal *, struct dlg_data_item_data_box *, struct box_item *))((struct box_item *)$tmp)->on_hilight;"
		end

	c_on_selected (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct terminal *, struct dlg_data_item_data_box *, struct box_item *))((struct box_item *)$tmp)->on_selected;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct box_item *)$tmp)->data;"
		end

	c_free_i (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct box_item *)$tmp)->free_i;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct box_item *)$tmp)->next = (struct box_item *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct box_item *)$tmp)->prev = (struct box_item *)$a_prev;"
		end

	c_set_text (tmp: POINTER; a_text: POINTER)
		external
			"C inline"
		alias
			"((struct box_item *)$tmp)->text = (unsigned char *)$a_text;"
		end

	c_set_on_hilight (tmp: POINTER; a_on_hilight: POINTER)
		external
			"C inline"
		alias
			"((struct box_item *)$tmp)->on_hilight = (void( *)(struct terminal *, struct dlg_data_item_data_box *, struct box_item *))$a_on_hilight;"
		end

	c_set_on_selected (tmp: POINTER; a_on_selected: POINTER)
		external
			"C inline"
		alias
			"((struct box_item *)$tmp)->on_selected = (int( *)(struct terminal *, struct dlg_data_item_data_box *, struct box_item *))$a_on_selected;"
		end

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct box_item *)$tmp)->data = (void *)$a_data;"
		end

	c_set_free_i (tmp: POINTER; a_free_i: INTEGER_32)
		external
			"C inline"
		alias
			"((struct box_item *)$tmp)->free_i = $a_free_i;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct box_item);"
		end

end
