class
	PD_C_SERVER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_C_SERVER] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_C_SERVER] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	accept: INTEGER_32 assign set_accept
		do
			Result := c_accept (c_pointer)
		end

	server: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_server (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_C_SERVER])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_C_SERVER])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_accept (a_accept: INTEGER_32)
		do
			c_set_accept (c_pointer, a_accept)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct c_server *)((struct c_server *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct c_server *)((struct c_server *)$tmp)->prev;"
		end

	c_accept (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct c_server *)$tmp)->accept;"
		end

	c_server (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct c_server *tmp = (struct c_server *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->server) / sizeof(tmp->server[0]);
				return tmp->server;
			]"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct c_server *)$tmp)->next = (struct c_server *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct c_server *)$tmp)->prev = (struct c_server *)$a_prev;"
		end

	c_set_accept (tmp: POINTER; a_accept: INTEGER_32)
		external
			"C inline"
		alias
			"((struct c_server *)$tmp)->accept = $a_accept;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct c_server);"
		end

end
