class
	PD_CACHE_ENTRY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_CACHE_ENTRY] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_CACHE_ENTRY] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	url: CE_POINTER [NATURAL_8] assign set_url
		do
			create Result.make_shared (c_url (c_pointer))
		end

	head: CE_POINTER [NATURAL_8] assign set_head
		do
			create Result.make_shared (c_head (c_pointer))
		end

	head_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct cache_entry, head);"
		end

	redirect: CE_POINTER [NATURAL_8] assign set_redirect
		do
			create Result.make_shared (c_redirect (c_pointer))
		end

	redirect_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct cache_entry, redirect);"
		end

	redirect_get: INTEGER_32 assign set_redirect_get
		do
			Result := c_redirect_get (c_pointer)
		end

	length: INTEGER_32 assign set_length
		do
			Result := c_length (c_pointer)
		end

	incomplete: INTEGER_32 assign set_incomplete
		do
			Result := c_incomplete (c_pointer)
		end

	tgc: INTEGER_32 assign set_tgc
		do
			Result := c_tgc (c_pointer)
		end

	last_modified: CE_POINTER [NATURAL_8] assign set_last_modified
		do
			create Result.make_shared (c_last_modified (c_pointer))
		end

	data_size: INTEGER_32 assign set_data_size
		do
			Result := c_data_size (c_pointer)
		end

	frag: PD_LIST_HEAD assign set_frag
		do
			create Result.make_shared (c_frag (c_pointer))
		end

	frag_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct cache_entry, frag);"
		end

	count: NATURAL_32 assign set_count
		do
			Result := c_count (c_pointer)
		end

	refcount: INTEGER_32 assign set_refcount
		do
			Result := c_refcount (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_CACHE_ENTRY])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_CACHE_ENTRY])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_url (a_url: CE_POINTER [NATURAL_8])
		do
			c_set_url (c_pointer, a_url.c_pointer)
		end

	set_head (a_head: CE_POINTER [NATURAL_8])
		do
			c_set_head (c_pointer, a_head.c_pointer)
		end

	set_redirect (a_redirect: CE_POINTER [NATURAL_8])
		do
			c_set_redirect (c_pointer, a_redirect.c_pointer)
		end

	set_redirect_get (a_redirect_get: INTEGER_32)
		do
			c_set_redirect_get (c_pointer, a_redirect_get)
		end

	set_length (a_length: INTEGER_32)
		do
			c_set_length (c_pointer, a_length)
		end

	set_incomplete (a_incomplete: INTEGER_32)
		do
			c_set_incomplete (c_pointer, a_incomplete)
		end

	set_tgc (a_tgc: INTEGER_32)
		do
			c_set_tgc (c_pointer, a_tgc)
		end

	set_last_modified (a_last_modified: CE_POINTER [NATURAL_8])
		do
			c_set_last_modified (c_pointer, a_last_modified.c_pointer)
		end

	set_data_size (a_data_size: INTEGER_32)
		do
			c_set_data_size (c_pointer, a_data_size)
		end

	set_frag (a_frag: PD_LIST_HEAD)
		do
			frag.ce_gets (a_frag)
		end

	set_count (a_count: NATURAL_32)
		do
			c_set_count (c_pointer, a_count)
		end

	set_refcount (a_refcount: INTEGER_32)
		do
			c_set_refcount (c_pointer, a_refcount)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct cache_entry *)((struct cache_entry *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct cache_entry *)((struct cache_entry *)$tmp)->prev;"
		end

	c_url (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct cache_entry *)$tmp)->url;"
		end

	c_head (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct cache_entry *)$tmp)->head;"
		end

	c_redirect (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct cache_entry *)$tmp)->redirect;"
		end

	c_redirect_get (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cache_entry *)$tmp)->redirect_get;"
		end

	c_length (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct cache_entry *)$tmp)->length;"
		end

	c_incomplete (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cache_entry *)$tmp)->incomplete;"
		end

	c_tgc (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cache_entry *)$tmp)->tgc;"
		end

	c_last_modified (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct cache_entry *)$tmp)->last_modified;"
		end

	c_data_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct cache_entry *)$tmp)->data_size;"
		end

	c_frag (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct list_head *)&((struct cache_entry *)$tmp)->frag;"
		end

	c_count (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct cache_entry *)$tmp)->count;"
		end

	c_refcount (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cache_entry *)$tmp)->refcount;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct cache_entry *)$tmp)->next = (struct cache_entry *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct cache_entry *)$tmp)->prev = (struct cache_entry *)$a_prev;"
		end

	c_set_url (tmp: POINTER; a_url: POINTER)
		external
			"C inline"
		alias
			"((struct cache_entry *)$tmp)->url = (unsigned char *)$a_url;"
		end

	c_set_head (tmp: POINTER; a_head: POINTER)
		external
			"C inline"
		alias
			"((struct cache_entry *)$tmp)->head = (unsigned char *)$a_head;"
		end

	c_set_redirect (tmp: POINTER; a_redirect: POINTER)
		external
			"C inline"
		alias
			"((struct cache_entry *)$tmp)->redirect = (unsigned char *)$a_redirect;"
		end

	c_set_redirect_get (tmp: POINTER; a_redirect_get: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cache_entry *)$tmp)->redirect_get = $a_redirect_get;"
		end

	c_set_length (tmp: POINTER; a_length: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cache_entry *)$tmp)->length = $a_length;"
		end

	c_set_incomplete (tmp: POINTER; a_incomplete: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cache_entry *)$tmp)->incomplete = $a_incomplete;"
		end

	c_set_tgc (tmp: POINTER; a_tgc: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cache_entry *)$tmp)->tgc = $a_tgc;"
		end

	c_set_last_modified (tmp: POINTER; a_last_modified: POINTER)
		external
			"C inline"
		alias
			"((struct cache_entry *)$tmp)->last_modified = (unsigned char *)$a_last_modified;"
		end

	c_set_data_size (tmp: POINTER; a_data_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cache_entry *)$tmp)->data_size = $a_data_size;"
		end

	c_set_count (tmp: POINTER; a_count: NATURAL_32)
		external
			"C inline"
		alias
			"((struct cache_entry *)$tmp)->count = $a_count;"
		end

	c_set_refcount (tmp: POINTER; a_refcount: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cache_entry *)$tmp)->refcount = $a_refcount;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct cache_entry);"
		end

end
