class
	PD_CONN_INFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	func: CE_ROUTINE assign set_func
		do
			create Result.make_shared (c_func (c_pointer))
		end

	sa: SD_SOCKADDR_IN assign set_sa
		do
			create Result.make_shared (c_sa (c_pointer))
		end

	sa_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct conn_info, sa);"
		end

	addr: NATURAL_32 assign set_addr
		do
			Result := c_addr (c_pointer)
		end

	addr_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct conn_info, addr);"
		end

	port: INTEGER_32 assign set_port
		do
			Result := c_port (c_pointer)
		end

	sock: CE_POINTER [INTEGER_32] assign set_sock
		do
			create Result.make_shared (c_sock (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_func (a_func: CE_ROUTINE)
		do
			c_set_func (c_pointer, a_func.c_pointer)
		end

	set_sa (a_sa: SD_SOCKADDR_IN)
		do
			sa.ce_gets (a_sa)
		end

	set_addr (a_addr: NATURAL_32)
		do
			c_set_addr (c_pointer, a_addr)
		end

	set_port (a_port: INTEGER_32)
		do
			c_set_port (c_pointer, a_port)
		end

	set_sock (a_sock: CE_POINTER [INTEGER_32])
		do
			c_set_sock (c_pointer, a_sock.c_pointer)
		end

feature {NONE} -- C getters

	c_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct connection *))((struct conn_info *)$tmp)->func;"
		end

	c_sa (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct sockaddr_in *)&((struct conn_info *)$tmp)->sa;"
		end

	c_addr (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct conn_info *)$tmp)->addr;"
		end

	c_port (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct conn_info *)$tmp)->port;"
		end

	c_sock (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int *)((struct conn_info *)$tmp)->sock;"
		end

feature {NONE} -- C setters

	c_set_func (tmp: POINTER; a_func: POINTER)
		external
			"C inline"
		alias
			"((struct conn_info *)$tmp)->func = (void( *)(struct connection *))$a_func;"
		end

	c_set_addr (tmp: POINTER; a_addr: NATURAL_32)
		external
			"C inline"
		alias
			"((struct conn_info *)$tmp)->addr = $a_addr;"
		end

	c_set_port (tmp: POINTER; a_port: INTEGER_32)
		external
			"C inline"
		alias
			"((struct conn_info *)$tmp)->port = $a_port;"
		end

	c_set_sock (tmp: POINTER; a_sock: POINTER)
		external
			"C inline"
		alias
			"((struct conn_info *)$tmp)->sock = (int *)$a_sock;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct conn_info);"
		end

end
