class
	PD_CONNECTION

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_CONNECTION] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_CONNECTION] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	count: NATURAL_32 assign set_count
		do
			Result := c_count (c_pointer)
		end

	url: CE_POINTER [NATURAL_8] assign set_url
		do
			create Result.make_shared (c_url (c_pointer))
		end

	running: INTEGER_32 assign set_running
		do
			Result := c_running (c_pointer)
		end

	state: INTEGER_32 assign set_state
		do
			Result := c_state (c_pointer)
		end

	prev_error: INTEGER_32 assign set_prev_error
		do
			Result := c_prev_error (c_pointer)
		end

	from2: INTEGER_32 assign set_from2
		do
			Result := c_from2 (c_pointer)
		end

	from2_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct connection, from);"
		end

	pri: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_pri (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	no_cache: INTEGER_32 assign set_no_cache
		do
			Result := c_no_cache (c_pointer)
		end

	sock1: INTEGER_32 assign set_sock1
		do
			Result := c_sock1 (c_pointer)
		end

	sock1_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct connection, sock1);"
		end

	sock2: INTEGER_32 assign set_sock2
		do
			Result := c_sock2 (c_pointer)
		end

	sock2_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct connection, sock2);"
		end

	dnsquery: CE_POINTER [ANY] assign set_dnsquery
		do
			create Result.make_shared (c_dnsquery (c_pointer))
		end

	dnsquery_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct connection, dnsquery);"
		end

	pid: INTEGER_32 assign set_pid
		do
			Result := c_pid (c_pointer)
		end

	tries: INTEGER_32 assign set_tries
		do
			Result := c_tries (c_pointer)
		end

	tries_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct connection, tries);"
		end

	statuss: PD_LIST_HEAD assign set_statuss
		do
			create Result.make_shared (c_statuss (c_pointer))
		end

	statuss_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct connection, statuss);"
		end

	info: CE_POINTER [ANY] assign set_info
		do
			create Result.make_shared (c_info (c_pointer))
		end

	buffer: CE_POINTER [ANY] assign set_buffer
		do
			create Result.make_shared (c_buffer (c_pointer))
		end

	conn_func: CE_ROUTINE assign set_conn_func
		do
			create Result.make_shared (c_conn_func (c_pointer))
		end

	cache: CE_POINTER [PD_CACHE_ENTRY] assign set_cache
		do
			create Result.make_shared (c_cache (c_pointer))
		end

	cache_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct connection, cache);"
		end

	received: INTEGER_32 assign set_received
		do
			Result := c_received (c_pointer)
		end

	est_length: INTEGER_32 assign set_est_length
		do
			Result := c_est_length (c_pointer)
		end

	unrestartable: INTEGER_32 assign set_unrestartable
		do
			Result := c_unrestartable (c_pointer)
		end

	prg: PD_REMAINING_INFO assign set_prg
		do
			create Result.make_shared (c_prg (c_pointer))
		end

	prg_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct connection, prg);"
		end

	timer: INTEGER_32 assign set_timer
		do
			Result := c_timer (c_pointer)
		end

	detached: INTEGER_32 assign set_detached
		do
			Result := c_detached (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_CONNECTION])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_CONNECTION])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_count (a_count: NATURAL_32)
		do
			c_set_count (c_pointer, a_count)
		end

	set_url (a_url: CE_POINTER [NATURAL_8])
		do
			c_set_url (c_pointer, a_url.c_pointer)
		end

	set_running (a_running: INTEGER_32)
		do
			c_set_running (c_pointer, a_running)
		end

	set_state (a_state: INTEGER_32)
		do
			c_set_state (c_pointer, a_state)
		end

	set_prev_error (a_prev_error: INTEGER_32)
		do
			c_set_prev_error (c_pointer, a_prev_error)
		end

	set_from2 (a_from2: INTEGER_32)
		do
			c_set_from2 (c_pointer, a_from2)
		end

	set_no_cache (a_no_cache: INTEGER_32)
		do
			c_set_no_cache (c_pointer, a_no_cache)
		end

	set_sock1 (a_sock1: INTEGER_32)
		do
			c_set_sock1 (c_pointer, a_sock1)
		end

	set_sock2 (a_sock2: INTEGER_32)
		do
			c_set_sock2 (c_pointer, a_sock2)
		end

	set_dnsquery (a_dnsquery: CE_POINTER [ANY])
		do
			c_set_dnsquery (c_pointer, a_dnsquery.c_pointer)
		end

	set_pid (a_pid: INTEGER_32)
		do
			c_set_pid (c_pointer, a_pid)
		end

	set_tries (a_tries: INTEGER_32)
		do
			c_set_tries (c_pointer, a_tries)
		end

	set_statuss (a_statuss: PD_LIST_HEAD)
		do
			statuss.ce_gets (a_statuss)
		end

	set_info (a_info: CE_POINTER [ANY])
		do
			c_set_info (c_pointer, a_info.c_pointer)
		end

	set_buffer (a_buffer: CE_POINTER [ANY])
		do
			c_set_buffer (c_pointer, a_buffer.c_pointer)
		end

	set_conn_func (a_conn_func: CE_ROUTINE)
		do
			c_set_conn_func (c_pointer, a_conn_func.c_pointer)
		end

	set_cache (a_cache: CE_POINTER [PD_CACHE_ENTRY])
		do
			c_set_cache (c_pointer, a_cache.c_pointer)
		end

	set_received (a_received: INTEGER_32)
		do
			c_set_received (c_pointer, a_received)
		end

	set_est_length (a_est_length: INTEGER_32)
		do
			c_set_est_length (c_pointer, a_est_length)
		end

	set_unrestartable (a_unrestartable: INTEGER_32)
		do
			c_set_unrestartable (c_pointer, a_unrestartable)
		end

	set_prg (a_prg: PD_REMAINING_INFO)
		do
			prg.ce_gets (a_prg)
		end

	set_timer (a_timer: INTEGER_32)
		do
			c_set_timer (c_pointer, a_timer)
		end

	set_detached (a_detached: INTEGER_32)
		do
			c_set_detached (c_pointer, a_detached)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct connection *)((struct connection *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct connection *)((struct connection *)$tmp)->prev;"
		end

	c_count (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct connection *)$tmp)->count;"
		end

	c_url (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct connection *)$tmp)->url;"
		end

	c_running (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct connection *)$tmp)->running;"
		end

	c_state (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct connection *)$tmp)->state;"
		end

	c_prev_error (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct connection *)$tmp)->prev_error;"
		end

	c_from2 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct connection *)$tmp)->from;"
		end

	c_pri (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct connection *tmp = (struct connection *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->pri) / sizeof(tmp->pri[0]);
				return tmp->pri;
			]"
		end

	c_no_cache (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct connection *)$tmp)->no_cache;"
		end

	c_sock1 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct connection *)$tmp)->sock1;"
		end

	c_sock2 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct connection *)$tmp)->sock2;"
		end

	c_dnsquery (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct connection *)$tmp)->dnsquery;"
		end

	c_pid (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct connection *)$tmp)->pid;"
		end

	c_tries (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct connection *)$tmp)->tries;"
		end

	c_statuss (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct list_head *)&((struct connection *)$tmp)->statuss;"
		end

	c_info (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct connection *)$tmp)->info;"
		end

	c_buffer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct connection *)$tmp)->buffer;"
		end

	c_conn_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void *))((struct connection *)$tmp)->conn_func;"
		end

	c_cache (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct cache_entry *)((struct connection *)$tmp)->cache;"
		end

	c_received (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct connection *)$tmp)->received;"
		end

	c_est_length (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct connection *)$tmp)->est_length;"
		end

	c_unrestartable (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct connection *)$tmp)->unrestartable;"
		end

	c_prg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct remaining_info *)&((struct connection *)$tmp)->prg;"
		end

	c_timer (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct connection *)$tmp)->timer;"
		end

	c_detached (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct connection *)$tmp)->detached;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct connection *)$tmp)->next = (struct connection *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct connection *)$tmp)->prev = (struct connection *)$a_prev;"
		end

	c_set_count (tmp: POINTER; a_count: NATURAL_32)
		external
			"C inline"
		alias
			"((struct connection *)$tmp)->count = $a_count;"
		end

	c_set_url (tmp: POINTER; a_url: POINTER)
		external
			"C inline"
		alias
			"((struct connection *)$tmp)->url = (unsigned char *)$a_url;"
		end

	c_set_running (tmp: POINTER; a_running: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connection *)$tmp)->running = $a_running;"
		end

	c_set_state (tmp: POINTER; a_state: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connection *)$tmp)->state = $a_state;"
		end

	c_set_prev_error (tmp: POINTER; a_prev_error: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connection *)$tmp)->prev_error = $a_prev_error;"
		end

	c_set_from2 (tmp: POINTER; a_from2: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connection *)$tmp)->from = $a_from2;"
		end

	c_set_no_cache (tmp: POINTER; a_no_cache: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connection *)$tmp)->no_cache = $a_no_cache;"
		end

	c_set_sock1 (tmp: POINTER; a_sock1: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connection *)$tmp)->sock1 = $a_sock1;"
		end

	c_set_sock2 (tmp: POINTER; a_sock2: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connection *)$tmp)->sock2 = $a_sock2;"
		end

	c_set_dnsquery (tmp: POINTER; a_dnsquery: POINTER)
		external
			"C inline"
		alias
			"((struct connection *)$tmp)->dnsquery = (void *)$a_dnsquery;"
		end

	c_set_pid (tmp: POINTER; a_pid: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connection *)$tmp)->pid = $a_pid;"
		end

	c_set_tries (tmp: POINTER; a_tries: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connection *)$tmp)->tries = $a_tries;"
		end

	c_set_info (tmp: POINTER; a_info: POINTER)
		external
			"C inline"
		alias
			"((struct connection *)$tmp)->info = (void *)$a_info;"
		end

	c_set_buffer (tmp: POINTER; a_buffer: POINTER)
		external
			"C inline"
		alias
			"((struct connection *)$tmp)->buffer = (void *)$a_buffer;"
		end

	c_set_conn_func (tmp: POINTER; a_conn_func: POINTER)
		external
			"C inline"
		alias
			"((struct connection *)$tmp)->conn_func = (void( *)(void *))$a_conn_func;"
		end

	c_set_cache (tmp: POINTER; a_cache: POINTER)
		external
			"C inline"
		alias
			"((struct connection *)$tmp)->cache = (struct cache_entry *)$a_cache;"
		end

	c_set_received (tmp: POINTER; a_received: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connection *)$tmp)->received = $a_received;"
		end

	c_set_est_length (tmp: POINTER; a_est_length: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connection *)$tmp)->est_length = $a_est_length;"
		end

	c_set_unrestartable (tmp: POINTER; a_unrestartable: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connection *)$tmp)->unrestartable = $a_unrestartable;"
		end

	c_set_timer (tmp: POINTER; a_timer: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connection *)$tmp)->timer = $a_timer;"
		end

	c_set_detached (tmp: POINTER; a_detached: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connection *)$tmp)->detached = $a_detached;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct connection);"
		end

end
