class
	PD_COOKIE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_COOKIE] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_COOKIE] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	name: CE_POINTER [NATURAL_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	value: CE_POINTER [NATURAL_8] assign set_value
		do
			create Result.make_shared (c_value (c_pointer))
		end

	server: CE_POINTER [NATURAL_8] assign set_server
		do
			create Result.make_shared (c_server (c_pointer))
		end

	path: CE_POINTER [NATURAL_8] assign set_path
		do
			create Result.make_shared (c_path (c_pointer))
		end

	path_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct cookie, path);"
		end

	domain: CE_POINTER [NATURAL_8] assign set_domain
		do
			create Result.make_shared (c_domain (c_pointer))
		end

	expires: INTEGER_32 assign set_expires
		do
			Result := c_expires (c_pointer)
		end

	secure: INTEGER_32 assign set_secure
		do
			Result := c_secure (c_pointer)
		end

	id: INTEGER_32 assign set_id
		do
			Result := c_id (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_COOKIE])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_COOKIE])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_value (a_value: CE_POINTER [NATURAL_8])
		do
			c_set_value (c_pointer, a_value.c_pointer)
		end

	set_server (a_server: CE_POINTER [NATURAL_8])
		do
			c_set_server (c_pointer, a_server.c_pointer)
		end

	set_path (a_path: CE_POINTER [NATURAL_8])
		do
			c_set_path (c_pointer, a_path.c_pointer)
		end

	set_domain (a_domain: CE_POINTER [NATURAL_8])
		do
			c_set_domain (c_pointer, a_domain.c_pointer)
		end

	set_expires (a_expires: INTEGER_32)
		do
			c_set_expires (c_pointer, a_expires)
		end

	set_secure (a_secure: INTEGER_32)
		do
			c_set_secure (c_pointer, a_secure)
		end

	set_id (a_id: INTEGER_32)
		do
			c_set_id (c_pointer, a_id)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct cookie *)((struct cookie *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct cookie *)((struct cookie *)$tmp)->prev;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct cookie *)$tmp)->name;"
		end

	c_value (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct cookie *)$tmp)->value;"
		end

	c_server (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct cookie *)$tmp)->server;"
		end

	c_path (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct cookie *)$tmp)->path;"
		end

	c_domain (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct cookie *)$tmp)->domain;"
		end

	c_expires (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct cookie *)$tmp)->expires;"
		end

	c_secure (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cookie *)$tmp)->secure;"
		end

	c_id (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cookie *)$tmp)->id;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct cookie *)$tmp)->next = (struct cookie *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct cookie *)$tmp)->prev = (struct cookie *)$a_prev;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct cookie *)$tmp)->name = (unsigned char *)$a_name;"
		end

	c_set_value (tmp: POINTER; a_value: POINTER)
		external
			"C inline"
		alias
			"((struct cookie *)$tmp)->value = (unsigned char *)$a_value;"
		end

	c_set_server (tmp: POINTER; a_server: POINTER)
		external
			"C inline"
		alias
			"((struct cookie *)$tmp)->server = (unsigned char *)$a_server;"
		end

	c_set_path (tmp: POINTER; a_path: POINTER)
		external
			"C inline"
		alias
			"((struct cookie *)$tmp)->path = (unsigned char *)$a_path;"
		end

	c_set_domain (tmp: POINTER; a_domain: POINTER)
		external
			"C inline"
		alias
			"((struct cookie *)$tmp)->domain = (unsigned char *)$a_domain;"
		end

	c_set_expires (tmp: POINTER; a_expires: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cookie *)$tmp)->expires = $a_expires;"
		end

	c_set_secure (tmp: POINTER; a_secure: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cookie *)$tmp)->secure = $a_secure;"
		end

	c_set_id (tmp: POINTER; a_id: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cookie *)$tmp)->id = $a_id;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct cookie);"
		end

end
