class
	PD_DIALOG

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	title: CE_POINTER [NATURAL_8] assign set_title
		do
			create Result.make_shared (c_title (c_pointer))
		end

	fn: CE_ROUTINE assign set_fn
		do
			create Result.make_shared (c_fn (c_pointer))
		end

	handle_event: CE_ROUTINE assign set_handle_event
		do
			create Result.make_shared (c_handle_event (c_pointer))
		end

	abort: CE_ROUTINE assign set_abort
		do
			create Result.make_shared (c_abort (c_pointer))
		end

	udata: CE_POINTER [ANY] assign set_udata
		do
			create Result.make_shared (c_udata (c_pointer))
		end

	udata2: CE_POINTER [ANY] assign set_udata2
		do
			create Result.make_shared (c_udata2 (c_pointer))
		end

	align: INTEGER_32 assign set_align
		do
			Result := c_align (c_pointer)
		end

	refresh: CE_ROUTINE assign set_refresh
		do
			create Result.make_shared (c_refresh (c_pointer))
		end

	refresh_data: CE_POINTER [ANY] assign set_refresh_data
		do
			create Result.make_shared (c_refresh_data (c_pointer))
		end

	items: CE_ARRAY [PD_DIALOG_ITEM]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_items (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	items_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct dialog, items);"
		end

feature {ANY} -- Eiffel setters

	set_title (a_title: CE_POINTER [NATURAL_8])
		do
			c_set_title (c_pointer, a_title.c_pointer)
		end

	set_fn (a_fn: CE_ROUTINE)
		do
			c_set_fn (c_pointer, a_fn.c_pointer)
		end

	set_handle_event (a_handle_event: CE_ROUTINE)
		do
			c_set_handle_event (c_pointer, a_handle_event.c_pointer)
		end

	set_abort (a_abort: CE_ROUTINE)
		do
			c_set_abort (c_pointer, a_abort.c_pointer)
		end

	set_udata (a_udata: CE_POINTER [ANY])
		do
			c_set_udata (c_pointer, a_udata.c_pointer)
		end

	set_udata2 (a_udata2: CE_POINTER [ANY])
		do
			c_set_udata2 (c_pointer, a_udata2.c_pointer)
		end

	set_align (a_align: INTEGER_32)
		do
			c_set_align (c_pointer, a_align)
		end

	set_refresh (a_refresh: CE_ROUTINE)
		do
			c_set_refresh (c_pointer, a_refresh.c_pointer)
		end

	set_refresh_data (a_refresh_data: CE_POINTER [ANY])
		do
			c_set_refresh_data (c_pointer, a_refresh_data.c_pointer)
		end

feature {NONE} -- C getters

	c_title (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct dialog *)$tmp)->title;"
		end

	c_fn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct dialog_data *))((struct dialog *)$tmp)->fn;"
		end

	c_handle_event (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct dialog_data *, struct event *))((struct dialog *)$tmp)->handle_event;"
		end

	c_abort (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct dialog_data *))((struct dialog *)$tmp)->abort;"
		end

	c_udata (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct dialog *)$tmp)->udata;"
		end

	c_udata2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct dialog *)$tmp)->udata2;"
		end

	c_align (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dialog *)$tmp)->align;"
		end

	c_refresh (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void *))((struct dialog *)$tmp)->refresh;"
		end

	c_refresh_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct dialog *)$tmp)->refresh_data;"
		end

	c_items (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct dialog *tmp = (struct dialog *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->items) / sizeof(tmp->items[0]);
				return tmp->items;
			]"
		end

feature {NONE} -- C setters

	c_set_title (tmp: POINTER; a_title: POINTER)
		external
			"C inline"
		alias
			"((struct dialog *)$tmp)->title = (unsigned char *)$a_title;"
		end

	c_set_fn (tmp: POINTER; a_fn: POINTER)
		external
			"C inline"
		alias
			"((struct dialog *)$tmp)->fn = (void( *)(struct dialog_data *))$a_fn;"
		end

	c_set_handle_event (tmp: POINTER; a_handle_event: POINTER)
		external
			"C inline"
		alias
			"((struct dialog *)$tmp)->handle_event = (int( *)(struct dialog_data *, struct event *))$a_handle_event;"
		end

	c_set_abort (tmp: POINTER; a_abort: POINTER)
		external
			"C inline"
		alias
			"((struct dialog *)$tmp)->abort = (void( *)(struct dialog_data *))$a_abort;"
		end

	c_set_udata (tmp: POINTER; a_udata: POINTER)
		external
			"C inline"
		alias
			"((struct dialog *)$tmp)->udata = (void *)$a_udata;"
		end

	c_set_udata2 (tmp: POINTER; a_udata2: POINTER)
		external
			"C inline"
		alias
			"((struct dialog *)$tmp)->udata2 = (void *)$a_udata2;"
		end

	c_set_align (tmp: POINTER; a_align: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dialog *)$tmp)->align = $a_align;"
		end

	c_set_refresh (tmp: POINTER; a_refresh: POINTER)
		external
			"C inline"
		alias
			"((struct dialog *)$tmp)->refresh = (void( *)(void *))$a_refresh;"
		end

	c_set_refresh_data (tmp: POINTER; a_refresh_data: POINTER)
		external
			"C inline"
		alias
			"((struct dialog *)$tmp)->refresh_data = (void *)$a_refresh_data;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct dialog);"
		end

end
