class
	PD_DIALOG_DATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	win: CE_POINTER [PD_WINDOW] assign set_win
		do
			create Result.make_shared (c_win (c_pointer))
		end

	dlg: CE_POINTER [PD_DIALOG] assign set_dlg
		do
			create Result.make_shared (c_dlg (c_pointer))
		end

	x: INTEGER_32 assign set_x
		do
			Result := c_x (c_pointer)
		end

	y: INTEGER_32 assign set_y
		do
			Result := c_y (c_pointer)
		end

	xw: INTEGER_32 assign set_xw
		do
			Result := c_xw (c_pointer)
		end

	yw: INTEGER_32 assign set_yw
		do
			Result := c_yw (c_pointer)
		end

	n: INTEGER_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	selected: INTEGER_32 assign set_selected
		do
			Result := c_selected (c_pointer)
		end

	ml: CE_POINTER [PD_MEMORY_LIST] assign set_ml
		do
			create Result.make_shared (c_ml (c_pointer))
		end

	items: CE_ARRAY [PD_DIALOG_ITEM_DATA]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_items (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_win (a_win: CE_POINTER [PD_WINDOW])
		do
			c_set_win (c_pointer, a_win.c_pointer)
		end

	set_dlg (a_dlg: CE_POINTER [PD_DIALOG])
		do
			c_set_dlg (c_pointer, a_dlg.c_pointer)
		end

	set_x (a_x: INTEGER_32)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: INTEGER_32)
		do
			c_set_y (c_pointer, a_y)
		end

	set_xw (a_xw: INTEGER_32)
		do
			c_set_xw (c_pointer, a_xw)
		end

	set_yw (a_yw: INTEGER_32)
		do
			c_set_yw (c_pointer, a_yw)
		end

	set_n (a_n: INTEGER_32)
		do
			c_set_n (c_pointer, a_n)
		end

	set_selected (a_selected: INTEGER_32)
		do
			c_set_selected (c_pointer, a_selected)
		end

	set_ml (a_ml: CE_POINTER [PD_MEMORY_LIST])
		do
			c_set_ml (c_pointer, a_ml.c_pointer)
		end

feature {NONE} -- C getters

	c_win (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct window *)((struct dialog_data *)$tmp)->win;"
		end

	c_dlg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dialog *)((struct dialog_data *)$tmp)->dlg;"
		end

	c_x (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dialog_data *)$tmp)->x;"
		end

	c_y (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dialog_data *)$tmp)->y;"
		end

	c_xw (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dialog_data *)$tmp)->xw;"
		end

	c_yw (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dialog_data *)$tmp)->yw;"
		end

	c_n (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dialog_data *)$tmp)->n;"
		end

	c_selected (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dialog_data *)$tmp)->selected;"
		end

	c_ml (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct memory_list *)((struct dialog_data *)$tmp)->ml;"
		end

	c_items (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct dialog_data *tmp = (struct dialog_data *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->items) / sizeof(tmp->items[0]);
				return tmp->items;
			]"
		end

feature {NONE} -- C setters

	c_set_win (tmp: POINTER; a_win: POINTER)
		external
			"C inline"
		alias
			"((struct dialog_data *)$tmp)->win = (struct window *)$a_win;"
		end

	c_set_dlg (tmp: POINTER; a_dlg: POINTER)
		external
			"C inline"
		alias
			"((struct dialog_data *)$tmp)->dlg = (struct dialog *)$a_dlg;"
		end

	c_set_x (tmp: POINTER; a_x: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dialog_data *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dialog_data *)$tmp)->y = $a_y;"
		end

	c_set_xw (tmp: POINTER; a_xw: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dialog_data *)$tmp)->xw = $a_xw;"
		end

	c_set_yw (tmp: POINTER; a_yw: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dialog_data *)$tmp)->yw = $a_yw;"
		end

	c_set_n (tmp: POINTER; a_n: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dialog_data *)$tmp)->n = $a_n;"
		end

	c_set_selected (tmp: POINTER; a_selected: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dialog_data *)$tmp)->selected = $a_selected;"
		end

	c_set_ml (tmp: POINTER; a_ml: POINTER)
		external
			"C inline"
		alias
			"((struct dialog_data *)$tmp)->ml = (struct memory_list *)$a_ml;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct dialog_data);"
		end

end
