class
	PD_DIALOG_ITEM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	gid: INTEGER_32 assign set_gid
		do
			Result := c_gid (c_pointer)
		end

	gnum: INTEGER_32 assign set_gnum
		do
			Result := c_gnum (c_pointer)
		end

	fn: CE_ROUTINE assign set_fn
		do
			create Result.make_shared (c_fn (c_pointer))
		end

	history: CE_POINTER [PD_HISTORY] assign set_history
		do
			create Result.make_shared (c_history (c_pointer))
		end

	dlen: INTEGER_32 assign set_dlen
		do
			Result := c_dlen (c_pointer)
		end

	data: CE_POINTER [NATURAL_8] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	data_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct dialog_item, data);"
		end

	udata: CE_POINTER [ANY] assign set_udata
		do
			create Result.make_shared (c_udata (c_pointer))
		end

	text: CE_POINTER [NATURAL_8] assign set_text
		do
			create Result.make_shared (c_text (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_gid (a_gid: INTEGER_32)
		do
			c_set_gid (c_pointer, a_gid)
		end

	set_gnum (a_gnum: INTEGER_32)
		do
			c_set_gnum (c_pointer, a_gnum)
		end

	set_fn (a_fn: CE_ROUTINE)
		do
			c_set_fn (c_pointer, a_fn.c_pointer)
		end

	set_history (a_history: CE_POINTER [PD_HISTORY])
		do
			c_set_history (c_pointer, a_history.c_pointer)
		end

	set_dlen (a_dlen: INTEGER_32)
		do
			c_set_dlen (c_pointer, a_dlen)
		end

	set_data (a_data: CE_POINTER [NATURAL_8])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_udata (a_udata: CE_POINTER [ANY])
		do
			c_set_udata (c_pointer, a_udata.c_pointer)
		end

	set_text (a_text: CE_POINTER [NATURAL_8])
		do
			c_set_text (c_pointer, a_text.c_pointer)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dialog_item *)$tmp)->type;"
		end

	c_gid (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dialog_item *)$tmp)->gid;"
		end

	c_gnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dialog_item *)$tmp)->gnum;"
		end

	c_fn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct dialog_data *, struct dialog_item_data *))((struct dialog_item *)$tmp)->fn;"
		end

	c_history (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct history *)((struct dialog_item *)$tmp)->history;"
		end

	c_dlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dialog_item *)$tmp)->dlen;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct dialog_item *)$tmp)->data;"
		end

	c_udata (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct dialog_item *)$tmp)->udata;"
		end

	c_text (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct dialog_item *)$tmp)->text;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dialog_item *)$tmp)->type = $a_type;"
		end

	c_set_gid (tmp: POINTER; a_gid: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dialog_item *)$tmp)->gid = $a_gid;"
		end

	c_set_gnum (tmp: POINTER; a_gnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dialog_item *)$tmp)->gnum = $a_gnum;"
		end

	c_set_fn (tmp: POINTER; a_fn: POINTER)
		external
			"C inline"
		alias
			"((struct dialog_item *)$tmp)->fn = (int( *)(struct dialog_data *, struct dialog_item_data *))$a_fn;"
		end

	c_set_history (tmp: POINTER; a_history: POINTER)
		external
			"C inline"
		alias
			"((struct dialog_item *)$tmp)->history = (struct history *)$a_history;"
		end

	c_set_dlen (tmp: POINTER; a_dlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dialog_item *)$tmp)->dlen = $a_dlen;"
		end

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct dialog_item *)$tmp)->data = (unsigned char *)$a_data;"
		end

	c_set_udata (tmp: POINTER; a_udata: POINTER)
		external
			"C inline"
		alias
			"((struct dialog_item *)$tmp)->udata = (void *)$a_udata;"
		end

	c_set_text (tmp: POINTER; a_text: POINTER)
		external
			"C inline"
		alias
			"((struct dialog_item *)$tmp)->text = (unsigned char *)$a_text;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct dialog_item);"
		end

end
