class
	PD_DIALOG_ITEM_DATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	x: INTEGER_32 assign set_x
		do
			Result := c_x (c_pointer)
		end

	y: INTEGER_32 assign set_y
		do
			Result := c_y (c_pointer)
		end

	l: INTEGER_32 assign set_l
		do
			Result := c_l (c_pointer)
		end

	vpos: INTEGER_32 assign set_vpos
		do
			Result := c_vpos (c_pointer)
		end

	cpos: INTEGER_32 assign set_cpos
		do
			Result := c_cpos (c_pointer)
		end

	checked: INTEGER_32 assign set_checked
		do
			Result := c_checked (c_pointer)
		end

	item: CE_POINTER [PD_DIALOG_ITEM] assign set_item
		do
			create Result.make_shared (c_item (c_pointer))
		end

	history: PD_LIST_HEAD assign set_history
		do
			create Result.make_shared (c_history (c_pointer))
		end

	history_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct dialog_item_data, history);"
		end

	cur_hist: CE_POINTER [PD_HISTORY_ITEM] assign set_cur_hist
		do
			create Result.make_shared (c_cur_hist (c_pointer))
		end

	cdata: CE_POINTER [NATURAL_8] assign set_cdata
		do
			create Result.make_shared (c_cdata (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_x (a_x: INTEGER_32)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: INTEGER_32)
		do
			c_set_y (c_pointer, a_y)
		end

	set_l (a_l: INTEGER_32)
		do
			c_set_l (c_pointer, a_l)
		end

	set_vpos (a_vpos: INTEGER_32)
		do
			c_set_vpos (c_pointer, a_vpos)
		end

	set_cpos (a_cpos: INTEGER_32)
		do
			c_set_cpos (c_pointer, a_cpos)
		end

	set_checked (a_checked: INTEGER_32)
		do
			c_set_checked (c_pointer, a_checked)
		end

	set_item (a_item: CE_POINTER [PD_DIALOG_ITEM])
		do
			c_set_item (c_pointer, a_item.c_pointer)
		end

	set_history (a_history: PD_LIST_HEAD)
		do
			history.ce_gets (a_history)
		end

	set_cur_hist (a_cur_hist: CE_POINTER [PD_HISTORY_ITEM])
		do
			c_set_cur_hist (c_pointer, a_cur_hist.c_pointer)
		end

	set_cdata (a_cdata: CE_POINTER [NATURAL_8])
		do
			c_set_cdata (c_pointer, a_cdata.c_pointer)
		end

feature {NONE} -- C getters

	c_x (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dialog_item_data *)$tmp)->x;"
		end

	c_y (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dialog_item_data *)$tmp)->y;"
		end

	c_l (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dialog_item_data *)$tmp)->l;"
		end

	c_vpos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dialog_item_data *)$tmp)->vpos;"
		end

	c_cpos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dialog_item_data *)$tmp)->cpos;"
		end

	c_checked (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dialog_item_data *)$tmp)->checked;"
		end

	c_item (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dialog_item *)((struct dialog_item_data *)$tmp)->item;"
		end

	c_history (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct list_head *)&((struct dialog_item_data *)$tmp)->history;"
		end

	c_cur_hist (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct history_item *)((struct dialog_item_data *)$tmp)->cur_hist;"
		end

	c_cdata (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct dialog_item_data *)$tmp)->cdata;"
		end

feature {NONE} -- C setters

	c_set_x (tmp: POINTER; a_x: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dialog_item_data *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dialog_item_data *)$tmp)->y = $a_y;"
		end

	c_set_l (tmp: POINTER; a_l: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dialog_item_data *)$tmp)->l = $a_l;"
		end

	c_set_vpos (tmp: POINTER; a_vpos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dialog_item_data *)$tmp)->vpos = $a_vpos;"
		end

	c_set_cpos (tmp: POINTER; a_cpos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dialog_item_data *)$tmp)->cpos = $a_cpos;"
		end

	c_set_checked (tmp: POINTER; a_checked: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dialog_item_data *)$tmp)->checked = $a_checked;"
		end

	c_set_item (tmp: POINTER; a_item: POINTER)
		external
			"C inline"
		alias
			"((struct dialog_item_data *)$tmp)->item = (struct dialog_item *)$a_item;"
		end

	c_set_cur_hist (tmp: POINTER; a_cur_hist: POINTER)
		external
			"C inline"
		alias
			"((struct dialog_item_data *)$tmp)->cur_hist = (struct history_item *)$a_cur_hist;"
		end

	c_set_cdata (tmp: POINTER; a_cdata: POINTER)
		external
			"C inline"
		alias
			"((struct dialog_item_data *)$tmp)->cdata = (unsigned char *)$a_cdata;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct dialog_item_data);"
		end

end
