class
	PD_DNSENTRY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_DNSENTRY] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_DNSENTRY] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	get_time: INTEGER_32 assign set_get_time
		do
			Result := c_get_time (c_pointer)
		end

	addr: NATURAL_32 assign set_addr
		do
			Result := c_addr (c_pointer)
		end

	addr_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct dnsentry, addr);"
		end

	name: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_name (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_DNSENTRY])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_DNSENTRY])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_get_time (a_get_time: INTEGER_32)
		do
			c_set_get_time (c_pointer, a_get_time)
		end

	set_addr (a_addr: NATURAL_32)
		do
			c_set_addr (c_pointer, a_addr)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dnsentry *)((struct dnsentry *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dnsentry *)((struct dnsentry *)$tmp)->prev;"
		end

	c_get_time (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct dnsentry *)$tmp)->get_time;"
		end

	c_addr (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct dnsentry *)$tmp)->addr;"
		end

	c_name (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct dnsentry *tmp = (struct dnsentry *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->name) / sizeof(tmp->name[0]);
				return tmp->name;
			]"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct dnsentry *)$tmp)->next = (struct dnsentry *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct dnsentry *)$tmp)->prev = (struct dnsentry *)$a_prev;"
		end

	c_set_get_time (tmp: POINTER; a_get_time: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dnsentry *)$tmp)->get_time = $a_get_time;"
		end

	c_set_addr (tmp: POINTER; a_addr: NATURAL_32)
		external
			"C inline"
		alias
			"((struct dnsentry *)$tmp)->addr = $a_addr;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct dnsentry);"
		end

end
