class
	PD_DNSQUERY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	fn: CE_ROUTINE assign set_fn
		do
			create Result.make_shared (c_fn (c_pointer))
		end

	data: CE_POINTER [ANY] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	xfn: CE_ROUTINE assign set_xfn
		do
			create Result.make_shared (c_xfn (c_pointer))
		end

	h: INTEGER_32 assign set_h
		do
			Result := c_h (c_pointer)
		end

	s: CE_POINTER [CE_POINTER [PD_DNSQUERY]] assign set_s
		do
			create Result.make_shared (c_s (c_pointer))
		end

	addr: CE_POINTER [NATURAL_32] assign set_addr
		do
			create Result.make_shared (c_addr (c_pointer))
		end

	name: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_name (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_fn (a_fn: CE_ROUTINE)
		do
			c_set_fn (c_pointer, a_fn.c_pointer)
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_xfn (a_xfn: CE_ROUTINE)
		do
			c_set_xfn (c_pointer, a_xfn.c_pointer)
		end

	set_h (a_h: INTEGER_32)
		do
			c_set_h (c_pointer, a_h)
		end

	set_s (a_s: CE_POINTER [CE_POINTER [PD_DNSQUERY]])
		do
			c_set_s (c_pointer, a_s.c_pointer)
		end

	set_addr (a_addr: CE_POINTER [NATURAL_32])
		do
			c_set_addr (c_pointer, a_addr.c_pointer)
		end

feature {NONE} -- C getters

	c_fn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void *, int))((struct dnsquery *)$tmp)->fn;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct dnsquery *)$tmp)->data;"
		end

	c_xfn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct dnsquery *, int))((struct dnsquery *)$tmp)->xfn;"
		end

	c_h (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dnsquery *)$tmp)->h;"
		end

	c_s (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dnsquery * *)((struct dnsquery *)$tmp)->s;"
		end

	c_addr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned int *)((struct dnsquery *)$tmp)->addr;"
		end

	c_name (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct dnsquery *tmp = (struct dnsquery *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->name) / sizeof(tmp->name[0]);
				return tmp->name;
			]"
		end

feature {NONE} -- C setters

	c_set_fn (tmp: POINTER; a_fn: POINTER)
		external
			"C inline"
		alias
			"((struct dnsquery *)$tmp)->fn = (void( *)(void *, int))$a_fn;"
		end

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct dnsquery *)$tmp)->data = (void *)$a_data;"
		end

	c_set_xfn (tmp: POINTER; a_xfn: POINTER)
		external
			"C inline"
		alias
			"((struct dnsquery *)$tmp)->xfn = (void( *)(struct dnsquery *, int))$a_xfn;"
		end

	c_set_h (tmp: POINTER; a_h: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dnsquery *)$tmp)->h = $a_h;"
		end

	c_set_s (tmp: POINTER; a_s: POINTER)
		external
			"C inline"
		alias
			"((struct dnsquery *)$tmp)->s = (struct dnsquery * *)$a_s;"
		end

	c_set_addr (tmp: POINTER; a_addr: POINTER)
		external
			"C inline"
		alias
			"((struct dnsquery *)$tmp)->addr = (unsigned int *)$a_addr;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct dnsquery);"
		end

end
