class
	PD_DOWNLOAD

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_DOWNLOAD] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_DOWNLOAD] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	url: CE_POINTER [NATURAL_8] assign set_url
		do
			create Result.make_shared (c_url (c_pointer))
		end

	stat: PD_STATUS assign set_stat
		do
			create Result.make_shared (c_stat (c_pointer))
		end

	stat_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct download, stat);"
		end

	file: CE_POINTER [NATURAL_8] assign set_file
		do
			create Result.make_shared (c_file (c_pointer))
		end

	last_pos: INTEGER_32 assign set_last_pos
		do
			Result := c_last_pos (c_pointer)
		end

	handle: INTEGER_32 assign set_handle
		do
			Result := c_handle (c_pointer)
		end

	redirect_cnt: INTEGER_32 assign set_redirect_cnt
		do
			Result := c_redirect_cnt (c_pointer)
		end

	prog: CE_POINTER [NATURAL_8] assign set_prog
		do
			create Result.make_shared (c_prog (c_pointer))
		end

	prog_flags: INTEGER_32 assign set_prog_flags
		do
			Result := c_prog_flags (c_pointer)
		end

	remotetime: INTEGER_32 assign set_remotetime
		do
			Result := c_remotetime (c_pointer)
		end

	ses: CE_POINTER [PD_SESSION] assign set_ses
		do
			create Result.make_shared (c_ses (c_pointer))
		end

	win: CE_POINTER [PD_WINDOW] assign set_win
		do
			create Result.make_shared (c_win (c_pointer))
		end

	ask: CE_POINTER [PD_WINDOW] assign set_ask
		do
			create Result.make_shared (c_ask (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_DOWNLOAD])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_DOWNLOAD])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_url (a_url: CE_POINTER [NATURAL_8])
		do
			c_set_url (c_pointer, a_url.c_pointer)
		end

	set_stat (a_stat: PD_STATUS)
		do
			stat.ce_gets (a_stat)
		end

	set_file (a_file: CE_POINTER [NATURAL_8])
		do
			c_set_file (c_pointer, a_file.c_pointer)
		end

	set_last_pos (a_last_pos: INTEGER_32)
		do
			c_set_last_pos (c_pointer, a_last_pos)
		end

	set_handle (a_handle: INTEGER_32)
		do
			c_set_handle (c_pointer, a_handle)
		end

	set_redirect_cnt (a_redirect_cnt: INTEGER_32)
		do
			c_set_redirect_cnt (c_pointer, a_redirect_cnt)
		end

	set_prog (a_prog: CE_POINTER [NATURAL_8])
		do
			c_set_prog (c_pointer, a_prog.c_pointer)
		end

	set_prog_flags (a_prog_flags: INTEGER_32)
		do
			c_set_prog_flags (c_pointer, a_prog_flags)
		end

	set_remotetime (a_remotetime: INTEGER_32)
		do
			c_set_remotetime (c_pointer, a_remotetime)
		end

	set_ses (a_ses: CE_POINTER [PD_SESSION])
		do
			c_set_ses (c_pointer, a_ses.c_pointer)
		end

	set_win (a_win: CE_POINTER [PD_WINDOW])
		do
			c_set_win (c_pointer, a_win.c_pointer)
		end

	set_ask (a_ask: CE_POINTER [PD_WINDOW])
		do
			c_set_ask (c_pointer, a_ask.c_pointer)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct download *)((struct download *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct download *)((struct download *)$tmp)->prev;"
		end

	c_url (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct download *)$tmp)->url;"
		end

	c_stat (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct status *)&((struct download *)$tmp)->stat;"
		end

	c_file (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct download *)$tmp)->file;"
		end

	c_last_pos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct download *)$tmp)->last_pos;"
		end

	c_handle (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct download *)$tmp)->handle;"
		end

	c_redirect_cnt (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct download *)$tmp)->redirect_cnt;"
		end

	c_prog (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct download *)$tmp)->prog;"
		end

	c_prog_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct download *)$tmp)->prog_flags;"
		end

	c_remotetime (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct download *)$tmp)->remotetime;"
		end

	c_ses (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct session *)((struct download *)$tmp)->ses;"
		end

	c_win (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct window *)((struct download *)$tmp)->win;"
		end

	c_ask (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct window *)((struct download *)$tmp)->ask;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct download *)$tmp)->next = (struct download *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct download *)$tmp)->prev = (struct download *)$a_prev;"
		end

	c_set_url (tmp: POINTER; a_url: POINTER)
		external
			"C inline"
		alias
			"((struct download *)$tmp)->url = (unsigned char *)$a_url;"
		end

	c_set_file (tmp: POINTER; a_file: POINTER)
		external
			"C inline"
		alias
			"((struct download *)$tmp)->file = (unsigned char *)$a_file;"
		end

	c_set_last_pos (tmp: POINTER; a_last_pos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct download *)$tmp)->last_pos = $a_last_pos;"
		end

	c_set_handle (tmp: POINTER; a_handle: INTEGER_32)
		external
			"C inline"
		alias
			"((struct download *)$tmp)->handle = $a_handle;"
		end

	c_set_redirect_cnt (tmp: POINTER; a_redirect_cnt: INTEGER_32)
		external
			"C inline"
		alias
			"((struct download *)$tmp)->redirect_cnt = $a_redirect_cnt;"
		end

	c_set_prog (tmp: POINTER; a_prog: POINTER)
		external
			"C inline"
		alias
			"((struct download *)$tmp)->prog = (unsigned char *)$a_prog;"
		end

	c_set_prog_flags (tmp: POINTER; a_prog_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct download *)$tmp)->prog_flags = $a_prog_flags;"
		end

	c_set_remotetime (tmp: POINTER; a_remotetime: INTEGER_32)
		external
			"C inline"
		alias
			"((struct download *)$tmp)->remotetime = $a_remotetime;"
		end

	c_set_ses (tmp: POINTER; a_ses: POINTER)
		external
			"C inline"
		alias
			"((struct download *)$tmp)->ses = (struct session *)$a_ses;"
		end

	c_set_win (tmp: POINTER; a_win: POINTER)
		external
			"C inline"
		alias
			"((struct download *)$tmp)->win = (struct window *)$a_win;"
		end

	c_set_ask (tmp: POINTER; a_ask: POINTER)
		external
			"C inline"
		alias
			"((struct download *)$tmp)->ask = (struct window *)$a_ask;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct download);"
		end

end
