class
	PD_ELEMENT_INFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	func: CE_ROUTINE assign set_func
		do
			create Result.make_shared (c_func (c_pointer))
		end

	linebreak: INTEGER_32 assign set_linebreak
		do
			Result := c_linebreak (c_pointer)
		end

	nopair: INTEGER_32 assign set_nopair
		do
			Result := c_nopair (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_func (a_func: CE_ROUTINE)
		do
			c_set_func (c_pointer, a_func.c_pointer)
		end

	set_linebreak (a_linebreak: INTEGER_32)
		do
			c_set_linebreak (c_pointer, a_linebreak)
		end

	set_nopair (a_nopair: INTEGER_32)
		do
			c_set_nopair (c_pointer, a_nopair)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct element_info *)$tmp)->name;"
		end

	c_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(unsigned char *))((struct element_info *)$tmp)->func;"
		end

	c_linebreak (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct element_info *)$tmp)->linebreak;"
		end

	c_nopair (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct element_info *)$tmp)->nopair;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct element_info *)$tmp)->name = (char *)$a_name;"
		end

	c_set_func (tmp: POINTER; a_func: POINTER)
		external
			"C inline"
		alias
			"((struct element_info *)$tmp)->func = (void( *)(unsigned char *))$a_func;"
		end

	c_set_linebreak (tmp: POINTER; a_linebreak: INTEGER_32)
		external
			"C inline"
		alias
			"((struct element_info *)$tmp)->linebreak = $a_linebreak;"
		end

	c_set_nopair (tmp: POINTER; a_nopair: INTEGER_32)
		external
			"C inline"
		alias
			"((struct element_info *)$tmp)->nopair = $a_nopair;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct element_info);"
		end

end
