class
	PD_EWD

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	fn: CE_ROUTINE assign set_fn
		do
			create Result.make_shared (c_fn (c_pointer))
		end

	data: CE_POINTER [ANY] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	b: INTEGER_32 assign set_b
		do
			Result := c_b (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_fn (a_fn: CE_ROUTINE)
		do
			c_set_fn (c_pointer, a_fn.c_pointer)
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_b (a_b: INTEGER_32)
		do
			c_set_b (c_pointer, a_b)
		end

feature {NONE} -- C getters

	c_fn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void *))((struct ewd *)$tmp)->fn;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct ewd *)$tmp)->data;"
		end

	c_b (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ewd *)$tmp)->b;"
		end

feature {NONE} -- C setters

	c_set_fn (tmp: POINTER; a_fn: POINTER)
		external
			"C inline"
		alias
			"((struct ewd *)$tmp)->fn = (void( *)(void *))$a_fn;"
		end

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct ewd *)$tmp)->data = (void *)$a_data;"
		end

	c_set_b (tmp: POINTER; a_b: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ewd *)$tmp)->b = $a_b;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct ewd);"
		end

end
