class
	PD_EXTENSION

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_EXTENSION] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_EXTENSION] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	cnt: NATURAL_32 assign set_cnt
		do
			Result := c_cnt (c_pointer)
		end

	ext: CE_POINTER [NATURAL_8] assign set_ext
		do
			create Result.make_shared (c_ext (c_pointer))
		end

	ct: CE_POINTER [NATURAL_8] assign set_ct
		do
			create Result.make_shared (c_ct (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_EXTENSION])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_EXTENSION])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_cnt (a_cnt: NATURAL_32)
		do
			c_set_cnt (c_pointer, a_cnt)
		end

	set_ext (a_ext: CE_POINTER [NATURAL_8])
		do
			c_set_ext (c_pointer, a_ext.c_pointer)
		end

	set_ct (a_ct: CE_POINTER [NATURAL_8])
		do
			c_set_ct (c_pointer, a_ct.c_pointer)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct extension *)((struct extension *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct extension *)((struct extension *)$tmp)->prev;"
		end

	c_cnt (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct extension *)$tmp)->cnt;"
		end

	c_ext (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct extension *)$tmp)->ext;"
		end

	c_ct (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct extension *)$tmp)->ct;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct extension *)$tmp)->next = (struct extension *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct extension *)$tmp)->prev = (struct extension *)$a_prev;"
		end

	c_set_cnt (tmp: POINTER; a_cnt: NATURAL_32)
		external
			"C inline"
		alias
			"((struct extension *)$tmp)->cnt = $a_cnt;"
		end

	c_set_ext (tmp: POINTER; a_ext: POINTER)
		external
			"C inline"
		alias
			"((struct extension *)$tmp)->ext = (unsigned char *)$a_ext;"
		end

	c_set_ct (tmp: POINTER; a_ct: POINTER)
		external
			"C inline"
		alias
			"((struct extension *)$tmp)->ct = (unsigned char *)$a_ct;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct extension);"
		end

end
