class
	PD_FILE_TO_LOAD

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_FILE_TO_LOAD] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_FILE_TO_LOAD] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	ses: CE_POINTER [PD_SESSION] assign set_ses
		do
			create Result.make_shared (c_ses (c_pointer))
		end

	req_sent: INTEGER_32 assign set_req_sent
		do
			Result := c_req_sent (c_pointer)
		end

	pri: INTEGER_32 assign set_pri
		do
			Result := c_pri (c_pointer)
		end

	ce: CE_POINTER [PD_CACHE_ENTRY] assign set_ce
		do
			create Result.make_shared (c_ce (c_pointer))
		end

	url: CE_POINTER [NATURAL_8] assign set_url
		do
			create Result.make_shared (c_url (c_pointer))
		end

	stat: PD_STATUS assign set_stat
		do
			create Result.make_shared (c_stat (c_pointer))
		end

	stat_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct file_to_load, stat);"
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_FILE_TO_LOAD])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_FILE_TO_LOAD])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_ses (a_ses: CE_POINTER [PD_SESSION])
		do
			c_set_ses (c_pointer, a_ses.c_pointer)
		end

	set_req_sent (a_req_sent: INTEGER_32)
		do
			c_set_req_sent (c_pointer, a_req_sent)
		end

	set_pri (a_pri: INTEGER_32)
		do
			c_set_pri (c_pointer, a_pri)
		end

	set_ce (a_ce: CE_POINTER [PD_CACHE_ENTRY])
		do
			c_set_ce (c_pointer, a_ce.c_pointer)
		end

	set_url (a_url: CE_POINTER [NATURAL_8])
		do
			c_set_url (c_pointer, a_url.c_pointer)
		end

	set_stat (a_stat: PD_STATUS)
		do
			stat.ce_gets (a_stat)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct file_to_load *)((struct file_to_load *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct file_to_load *)((struct file_to_load *)$tmp)->prev;"
		end

	c_ses (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct session *)((struct file_to_load *)$tmp)->ses;"
		end

	c_req_sent (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_to_load *)$tmp)->req_sent;"
		end

	c_pri (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_to_load *)$tmp)->pri;"
		end

	c_ce (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct cache_entry *)((struct file_to_load *)$tmp)->ce;"
		end

	c_url (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_to_load *)$tmp)->url;"
		end

	c_stat (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct status *)&((struct file_to_load *)$tmp)->stat;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct file_to_load *)$tmp)->next = (struct file_to_load *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct file_to_load *)$tmp)->prev = (struct file_to_load *)$a_prev;"
		end

	c_set_ses (tmp: POINTER; a_ses: POINTER)
		external
			"C inline"
		alias
			"((struct file_to_load *)$tmp)->ses = (struct session *)$a_ses;"
		end

	c_set_req_sent (tmp: POINTER; a_req_sent: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_to_load *)$tmp)->req_sent = $a_req_sent;"
		end

	c_set_pri (tmp: POINTER; a_pri: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_to_load *)$tmp)->pri = $a_pri;"
		end

	c_set_ce (tmp: POINTER; a_ce: POINTER)
		external
			"C inline"
		alias
			"((struct file_to_load *)$tmp)->ce = (struct cache_entry *)$a_ce;"
		end

	c_set_url (tmp: POINTER; a_url: POINTER)
		external
			"C inline"
		alias
			"((struct file_to_load *)$tmp)->url = (unsigned char *)$a_url;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct file_to_load);"
		end

end
