class
	PD_FRAGMENT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_FRAGMENT] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_FRAGMENT] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	offset: INTEGER_32 assign set_offset
		do
			Result := c_offset (c_pointer)
		end

	length: INTEGER_32 assign set_length
		do
			Result := c_length (c_pointer)
		end

	real_length: INTEGER_32 assign set_real_length
		do
			Result := c_real_length (c_pointer)
		end

	data: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_data (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_FRAGMENT])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_FRAGMENT])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_offset (a_offset: INTEGER_32)
		do
			c_set_offset (c_pointer, a_offset)
		end

	set_length (a_length: INTEGER_32)
		do
			c_set_length (c_pointer, a_length)
		end

	set_real_length (a_real_length: INTEGER_32)
		do
			c_set_real_length (c_pointer, a_real_length)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct fragment *)((struct fragment *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct fragment *)((struct fragment *)$tmp)->prev;"
		end

	c_offset (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct fragment *)$tmp)->offset;"
		end

	c_length (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct fragment *)$tmp)->length;"
		end

	c_real_length (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct fragment *)$tmp)->real_length;"
		end

	c_data (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct fragment *tmp = (struct fragment *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->data) / sizeof(tmp->data[0]);
				return tmp->data;
			]"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct fragment *)$tmp)->next = (struct fragment *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct fragment *)$tmp)->prev = (struct fragment *)$a_prev;"
		end

	c_set_offset (tmp: POINTER; a_offset: INTEGER_32)
		external
			"C inline"
		alias
			"((struct fragment *)$tmp)->offset = $a_offset;"
		end

	c_set_length (tmp: POINTER; a_length: INTEGER_32)
		external
			"C inline"
		alias
			"((struct fragment *)$tmp)->length = $a_length;"
		end

	c_set_real_length (tmp: POINTER; a_real_length: INTEGER_32)
		external
			"C inline"
		alias
			"((struct fragment *)$tmp)->real_length = $a_real_length;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct fragment);"
		end

end
