class
	PD_FRAME

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_FRAME] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_FRAME] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	name: CE_POINTER [NATURAL_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	redirect_cnt: INTEGER_32 assign set_redirect_cnt
		do
			Result := c_redirect_cnt (c_pointer)
		end

	vs: PD_VIEW_STATE assign set_vs
		do
			create Result.make_shared (c_vs (c_pointer))
		end

	vs_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct frame, vs);"
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_FRAME])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_FRAME])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_redirect_cnt (a_redirect_cnt: INTEGER_32)
		do
			c_set_redirect_cnt (c_pointer, a_redirect_cnt)
		end

	set_vs (a_vs: PD_VIEW_STATE)
		do
			vs.ce_gets (a_vs)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct frame *)((struct frame *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct frame *)((struct frame *)$tmp)->prev;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct frame *)$tmp)->name;"
		end

	c_redirect_cnt (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct frame *)$tmp)->redirect_cnt;"
		end

	c_vs (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct view_state *)&((struct frame *)$tmp)->vs;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct frame *)$tmp)->next = (struct frame *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct frame *)$tmp)->prev = (struct frame *)$a_prev;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct frame *)$tmp)->name = (unsigned char *)$a_name;"
		end

	c_set_redirect_cnt (tmp: POINTER; a_redirect_cnt: INTEGER_32)
		external
			"C inline"
		alias
			"((struct frame *)$tmp)->redirect_cnt = $a_redirect_cnt;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct frame);"
		end

end
