class
	PD_FRAMESET_DESC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	n: INTEGER_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	x: INTEGER_32 assign set_x
		do
			Result := c_x (c_pointer)
		end

	y: INTEGER_32 assign set_y
		do
			Result := c_y (c_pointer)
		end

	xp: INTEGER_32 assign set_xp
		do
			Result := c_xp (c_pointer)
		end

	yp: INTEGER_32 assign set_yp
		do
			Result := c_yp (c_pointer)
		end

	f: CE_ARRAY [PD_FRAME_DESC]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_f (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_n (a_n: INTEGER_32)
		do
			c_set_n (c_pointer, a_n)
		end

	set_x (a_x: INTEGER_32)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: INTEGER_32)
		do
			c_set_y (c_pointer, a_y)
		end

	set_xp (a_xp: INTEGER_32)
		do
			c_set_xp (c_pointer, a_xp)
		end

	set_yp (a_yp: INTEGER_32)
		do
			c_set_yp (c_pointer, a_yp)
		end

feature {NONE} -- C getters

	c_n (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct frameset_desc *)$tmp)->n;"
		end

	c_x (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct frameset_desc *)$tmp)->x;"
		end

	c_y (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct frameset_desc *)$tmp)->y;"
		end

	c_xp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct frameset_desc *)$tmp)->xp;"
		end

	c_yp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct frameset_desc *)$tmp)->yp;"
		end

	c_f (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct frameset_desc *tmp = (struct frameset_desc *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->f) / sizeof(tmp->f[0]);
				return tmp->f;
			]"
		end

feature {NONE} -- C setters

	c_set_n (tmp: POINTER; a_n: INTEGER_32)
		external
			"C inline"
		alias
			"((struct frameset_desc *)$tmp)->n = $a_n;"
		end

	c_set_x (tmp: POINTER; a_x: INTEGER_32)
		external
			"C inline"
		alias
			"((struct frameset_desc *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: INTEGER_32)
		external
			"C inline"
		alias
			"((struct frameset_desc *)$tmp)->y = $a_y;"
		end

	c_set_xp (tmp: POINTER; a_xp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct frameset_desc *)$tmp)->xp = $a_xp;"
		end

	c_set_yp (tmp: POINTER; a_yp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct frameset_desc *)$tmp)->yp = $a_yp;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct frameset_desc);"
		end

end
