class
	PD_FTP_CONNECTION_INFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	pending_commands: INTEGER_32 assign set_pending_commands
		do
			Result := c_pending_commands (c_pointer)
		end

	opc: INTEGER_32 assign set_opc
		do
			Result := c_opc (c_pointer)
		end

	pasv: INTEGER_32 assign set_pasv
		do
			Result := c_pasv (c_pointer)
		end

	dir: INTEGER_32 assign set_dir
		do
			Result := c_dir (c_pointer)
		end

	rest_sent: INTEGER_32 assign set_rest_sent
		do
			Result := c_rest_sent (c_pointer)
		end

	conn_st: INTEGER_32 assign set_conn_st
		do
			Result := c_conn_st (c_pointer)
		end

	d: INTEGER_32 assign set_d
		do
			Result := c_d (c_pointer)
		end

	dpos: INTEGER_32 assign set_dpos
		do
			Result := c_dpos (c_pointer)
		end

	dpos_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct ftp_connection_info, dpos);"
		end

	buf_pos: INTEGER_32 assign set_buf_pos
		do
			Result := c_buf_pos (c_pointer)
		end

	ftp_buffer: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_ftp_buffer (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	cmdbuf: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_cmdbuf (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_pending_commands (a_pending_commands: INTEGER_32)
		do
			c_set_pending_commands (c_pointer, a_pending_commands)
		end

	set_opc (a_opc: INTEGER_32)
		do
			c_set_opc (c_pointer, a_opc)
		end

	set_pasv (a_pasv: INTEGER_32)
		do
			c_set_pasv (c_pointer, a_pasv)
		end

	set_dir (a_dir: INTEGER_32)
		do
			c_set_dir (c_pointer, a_dir)
		end

	set_rest_sent (a_rest_sent: INTEGER_32)
		do
			c_set_rest_sent (c_pointer, a_rest_sent)
		end

	set_conn_st (a_conn_st: INTEGER_32)
		do
			c_set_conn_st (c_pointer, a_conn_st)
		end

	set_d (a_d: INTEGER_32)
		do
			c_set_d (c_pointer, a_d)
		end

	set_dpos (a_dpos: INTEGER_32)
		do
			c_set_dpos (c_pointer, a_dpos)
		end

	set_buf_pos (a_buf_pos: INTEGER_32)
		do
			c_set_buf_pos (c_pointer, a_buf_pos)
		end

feature {NONE} -- C getters

	c_pending_commands (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ftp_connection_info *)$tmp)->pending_commands;"
		end

	c_opc (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ftp_connection_info *)$tmp)->opc;"
		end

	c_pasv (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ftp_connection_info *)$tmp)->pasv;"
		end

	c_dir (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ftp_connection_info *)$tmp)->dir;"
		end

	c_rest_sent (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ftp_connection_info *)$tmp)->rest_sent;"
		end

	c_conn_st (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ftp_connection_info *)$tmp)->conn_st;"
		end

	c_d (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ftp_connection_info *)$tmp)->d;"
		end

	c_dpos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ftp_connection_info *)$tmp)->dpos;"
		end

	c_buf_pos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ftp_connection_info *)$tmp)->buf_pos;"
		end

	c_ftp_buffer (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct ftp_connection_info *tmp = (struct ftp_connection_info *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->ftp_buffer) / sizeof(tmp->ftp_buffer[0]);
				return tmp->ftp_buffer;
			]"
		end

	c_cmdbuf (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct ftp_connection_info *tmp = (struct ftp_connection_info *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->cmdbuf) / sizeof(tmp->cmdbuf[0]);
				return tmp->cmdbuf;
			]"
		end

feature {NONE} -- C setters

	c_set_pending_commands (tmp: POINTER; a_pending_commands: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ftp_connection_info *)$tmp)->pending_commands = $a_pending_commands;"
		end

	c_set_opc (tmp: POINTER; a_opc: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ftp_connection_info *)$tmp)->opc = $a_opc;"
		end

	c_set_pasv (tmp: POINTER; a_pasv: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ftp_connection_info *)$tmp)->pasv = $a_pasv;"
		end

	c_set_dir (tmp: POINTER; a_dir: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ftp_connection_info *)$tmp)->dir = $a_dir;"
		end

	c_set_rest_sent (tmp: POINTER; a_rest_sent: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ftp_connection_info *)$tmp)->rest_sent = $a_rest_sent;"
		end

	c_set_conn_st (tmp: POINTER; a_conn_st: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ftp_connection_info *)$tmp)->conn_st = $a_conn_st;"
		end

	c_set_d (tmp: POINTER; a_d: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ftp_connection_info *)$tmp)->d = $a_d;"
		end

	c_set_dpos (tmp: POINTER; a_dpos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ftp_connection_info *)$tmp)->dpos = $a_dpos;"
		end

	c_set_buf_pos (tmp: POINTER; a_buf_pos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ftp_connection_info *)$tmp)->buf_pos = $a_buf_pos;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct ftp_connection_info);"
		end

end
