class
	PD_FTP_OPTIONS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	anon_pass: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_anon_pass (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	fast_ftp: INTEGER_32 assign set_fast_ftp
		do
			Result := c_fast_ftp (c_pointer)
		end

	fast_ftp_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct ftp_options, fast_ftp);"
		end

	passive_ftp: INTEGER_32 assign set_passive_ftp
		do
			Result := c_passive_ftp (c_pointer)
		end

	passive_ftp_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct ftp_options, passive_ftp);"
		end

	set_tos: INTEGER_32 assign set_set_tos
		do
			Result := c_set_tos (c_pointer)
		end

	set_tos_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct ftp_options, set_tos);"
		end

feature {ANY} -- Eiffel setters

	set_fast_ftp (a_fast_ftp: INTEGER_32)
		do
			c_set_fast_ftp (c_pointer, a_fast_ftp)
		end

	set_passive_ftp (a_passive_ftp: INTEGER_32)
		do
			c_set_passive_ftp (c_pointer, a_passive_ftp)
		end

	set_set_tos (a_set_tos: INTEGER_32)
		do
			c_set_set_tos (c_pointer, a_set_tos)
		end

feature {NONE} -- C getters

	c_anon_pass (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct ftp_options *tmp = (struct ftp_options *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->anon_pass) / sizeof(tmp->anon_pass[0]);
				return tmp->anon_pass;
			]"
		end

	c_fast_ftp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ftp_options *)$tmp)->fast_ftp;"
		end

	c_passive_ftp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ftp_options *)$tmp)->passive_ftp;"
		end

	c_set_tos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ftp_options *)$tmp)->set_tos;"
		end

feature {NONE} -- C setters

	c_set_fast_ftp (tmp: POINTER; a_fast_ftp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ftp_options *)$tmp)->fast_ftp = $a_fast_ftp;"
		end

	c_set_passive_ftp (tmp: POINTER; a_passive_ftp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ftp_options *)$tmp)->passive_ftp = $a_passive_ftp;"
		end

	c_set_set_tos (tmp: POINTER; a_set_tos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ftp_options *)$tmp)->set_tos = $a_set_tos;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct ftp_options);"
		end

end
