class
	PD_HISTORY_ITEM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_HISTORY_ITEM] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_HISTORY_ITEM] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	d: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_d (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_HISTORY_ITEM])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_HISTORY_ITEM])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct history_item *)((struct history_item *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct history_item *)((struct history_item *)$tmp)->prev;"
		end

	c_d (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct history_item *tmp = (struct history_item *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->d) / sizeof(tmp->d[0]);
				return tmp->d;
			]"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct history_item *)$tmp)->next = (struct history_item *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct history_item *)$tmp)->prev = (struct history_item *)$a_prev;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct history_item);"
		end

end
