class
	PD_HTML_ELEMENT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_HTML_ELEMENT] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_HTML_ELEMENT] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	attr: PD_TEXT_ATTRIB assign set_attr
		do
			create Result.make_shared (c_attr (c_pointer))
		end

	attr_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct html_element, attr);"
		end

	parattr: PD_PAR_ATTRIB assign set_parattr
		do
			create Result.make_shared (c_parattr (c_pointer))
		end

	parattr_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct html_element, parattr);"
		end

	invisible: INTEGER_32 assign set_invisible
		do
			Result := c_invisible (c_pointer)
		end

	name: CE_POINTER [NATURAL_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	namelen: INTEGER_32 assign set_namelen
		do
			Result := c_namelen (c_pointer)
		end

	options: CE_POINTER [NATURAL_8] assign set_options
		do
			create Result.make_shared (c_options (c_pointer))
		end

	linebreak: INTEGER_32 assign set_linebreak
		do
			Result := c_linebreak (c_pointer)
		end

	dontkill: INTEGER_32 assign set_dontkill
		do
			Result := c_dontkill (c_pointer)
		end

	frameset: CE_POINTER [PD_FRAMESET_DESC] assign set_frameset
		do
			create Result.make_shared (c_frameset (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_HTML_ELEMENT])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_HTML_ELEMENT])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_attr (a_attr: PD_TEXT_ATTRIB)
		do
			attr.ce_gets (a_attr)
		end

	set_parattr (a_parattr: PD_PAR_ATTRIB)
		do
			parattr.ce_gets (a_parattr)
		end

	set_invisible (a_invisible: INTEGER_32)
		do
			c_set_invisible (c_pointer, a_invisible)
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_namelen (a_namelen: INTEGER_32)
		do
			c_set_namelen (c_pointer, a_namelen)
		end

	set_options (a_options: CE_POINTER [NATURAL_8])
		do
			c_set_options (c_pointer, a_options.c_pointer)
		end

	set_linebreak (a_linebreak: INTEGER_32)
		do
			c_set_linebreak (c_pointer, a_linebreak)
		end

	set_dontkill (a_dontkill: INTEGER_32)
		do
			c_set_dontkill (c_pointer, a_dontkill)
		end

	set_frameset (a_frameset: CE_POINTER [PD_FRAMESET_DESC])
		do
			c_set_frameset (c_pointer, a_frameset.c_pointer)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct html_element *)((struct html_element *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct html_element *)((struct html_element *)$tmp)->prev;"
		end

	c_attr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct text_attrib *)&((struct html_element *)$tmp)->attr;"
		end

	c_parattr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct par_attrib *)&((struct html_element *)$tmp)->parattr;"
		end

	c_invisible (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct html_element *)$tmp)->invisible;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct html_element *)$tmp)->name;"
		end

	c_namelen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct html_element *)$tmp)->namelen;"
		end

	c_options (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct html_element *)$tmp)->options;"
		end

	c_linebreak (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct html_element *)$tmp)->linebreak;"
		end

	c_dontkill (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct html_element *)$tmp)->dontkill;"
		end

	c_frameset (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct frameset_desc *)((struct html_element *)$tmp)->frameset;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct html_element *)$tmp)->next = (struct html_element *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct html_element *)$tmp)->prev = (struct html_element *)$a_prev;"
		end

	c_set_invisible (tmp: POINTER; a_invisible: INTEGER_32)
		external
			"C inline"
		alias
			"((struct html_element *)$tmp)->invisible = $a_invisible;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct html_element *)$tmp)->name = (unsigned char *)$a_name;"
		end

	c_set_namelen (tmp: POINTER; a_namelen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct html_element *)$tmp)->namelen = $a_namelen;"
		end

	c_set_options (tmp: POINTER; a_options: POINTER)
		external
			"C inline"
		alias
			"((struct html_element *)$tmp)->options = (unsigned char *)$a_options;"
		end

	c_set_linebreak (tmp: POINTER; a_linebreak: INTEGER_32)
		external
			"C inline"
		alias
			"((struct html_element *)$tmp)->linebreak = $a_linebreak;"
		end

	c_set_dontkill (tmp: POINTER; a_dontkill: INTEGER_32)
		external
			"C inline"
		alias
			"((struct html_element *)$tmp)->dontkill = $a_dontkill;"
		end

	c_set_frameset (tmp: POINTER; a_frameset: POINTER)
		external
			"C inline"
		alias
			"((struct html_element *)$tmp)->frameset = (struct frameset_desc *)$a_frameset;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct html_element);"
		end

end
