class
	PD_ITRM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	std_in: INTEGER_32 assign set_std_in
		do
			Result := c_std_in (c_pointer)
		end

	std_out: INTEGER_32 assign set_std_out
		do
			Result := c_std_out (c_pointer)
		end

	sock_in: INTEGER_32 assign set_sock_in
		do
			Result := c_sock_in (c_pointer)
		end

	sock_out: INTEGER_32 assign set_sock_out
		do
			Result := c_sock_out (c_pointer)
		end

	ctl_in: INTEGER_32 assign set_ctl_in
		do
			Result := c_ctl_in (c_pointer)
		end

	blocked: INTEGER_32 assign set_blocked
		do
			Result := c_blocked (c_pointer)
		end

	t: SD_TERMIOS assign set_t
		do
			create Result.make_shared (c_t (c_pointer))
		end

	t_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct itrm, t);"
		end

	flags: INTEGER_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	kqueue: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_kqueue (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	qlen: INTEGER_32 assign set_qlen
		do
			Result := c_qlen (c_pointer)
		end

	tm: INTEGER_32 assign set_tm
		do
			Result := c_tm (c_pointer)
		end

	ev_queue: CE_POINTER [NATURAL_8] assign set_ev_queue
		do
			create Result.make_shared (c_ev_queue (c_pointer))
		end

	eqlen: INTEGER_32 assign set_eqlen
		do
			Result := c_eqlen (c_pointer)
		end

	mouse_h: CE_POINTER [ANY] assign set_mouse_h
		do
			create Result.make_shared (c_mouse_h (c_pointer))
		end

	orig_title: CE_POINTER [NATURAL_8] assign set_orig_title
		do
			create Result.make_shared (c_orig_title (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_std_in (a_std_in: INTEGER_32)
		do
			c_set_std_in (c_pointer, a_std_in)
		end

	set_std_out (a_std_out: INTEGER_32)
		do
			c_set_std_out (c_pointer, a_std_out)
		end

	set_sock_in (a_sock_in: INTEGER_32)
		do
			c_set_sock_in (c_pointer, a_sock_in)
		end

	set_sock_out (a_sock_out: INTEGER_32)
		do
			c_set_sock_out (c_pointer, a_sock_out)
		end

	set_ctl_in (a_ctl_in: INTEGER_32)
		do
			c_set_ctl_in (c_pointer, a_ctl_in)
		end

	set_blocked (a_blocked: INTEGER_32)
		do
			c_set_blocked (c_pointer, a_blocked)
		end

	set_t (a_t: SD_TERMIOS)
		do
			t.ce_gets (a_t)
		end

	set_flags (a_flags: INTEGER_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

	set_qlen (a_qlen: INTEGER_32)
		do
			c_set_qlen (c_pointer, a_qlen)
		end

	set_tm (a_tm: INTEGER_32)
		do
			c_set_tm (c_pointer, a_tm)
		end

	set_ev_queue (a_ev_queue: CE_POINTER [NATURAL_8])
		do
			c_set_ev_queue (c_pointer, a_ev_queue.c_pointer)
		end

	set_eqlen (a_eqlen: INTEGER_32)
		do
			c_set_eqlen (c_pointer, a_eqlen)
		end

	set_mouse_h (a_mouse_h: CE_POINTER [ANY])
		do
			c_set_mouse_h (c_pointer, a_mouse_h.c_pointer)
		end

	set_orig_title (a_orig_title: CE_POINTER [NATURAL_8])
		do
			c_set_orig_title (c_pointer, a_orig_title.c_pointer)
		end

feature {NONE} -- C getters

	c_std_in (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct itrm *)$tmp)->std_in;"
		end

	c_std_out (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct itrm *)$tmp)->std_out;"
		end

	c_sock_in (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct itrm *)$tmp)->sock_in;"
		end

	c_sock_out (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct itrm *)$tmp)->sock_out;"
		end

	c_ctl_in (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct itrm *)$tmp)->ctl_in;"
		end

	c_blocked (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct itrm *)$tmp)->blocked;"
		end

	c_t (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct termios *)&((struct itrm *)$tmp)->t;"
		end

	c_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct itrm *)$tmp)->flags;"
		end

	c_kqueue (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct itrm *tmp = (struct itrm *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->kqueue) / sizeof(tmp->kqueue[0]);
				return tmp->kqueue;
			]"
		end

	c_qlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct itrm *)$tmp)->qlen;"
		end

	c_tm (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct itrm *)$tmp)->tm;"
		end

	c_ev_queue (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct itrm *)$tmp)->ev_queue;"
		end

	c_eqlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct itrm *)$tmp)->eqlen;"
		end

	c_mouse_h (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct itrm *)$tmp)->mouse_h;"
		end

	c_orig_title (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct itrm *)$tmp)->orig_title;"
		end

feature {NONE} -- C setters

	c_set_std_in (tmp: POINTER; a_std_in: INTEGER_32)
		external
			"C inline"
		alias
			"((struct itrm *)$tmp)->std_in = $a_std_in;"
		end

	c_set_std_out (tmp: POINTER; a_std_out: INTEGER_32)
		external
			"C inline"
		alias
			"((struct itrm *)$tmp)->std_out = $a_std_out;"
		end

	c_set_sock_in (tmp: POINTER; a_sock_in: INTEGER_32)
		external
			"C inline"
		alias
			"((struct itrm *)$tmp)->sock_in = $a_sock_in;"
		end

	c_set_sock_out (tmp: POINTER; a_sock_out: INTEGER_32)
		external
			"C inline"
		alias
			"((struct itrm *)$tmp)->sock_out = $a_sock_out;"
		end

	c_set_ctl_in (tmp: POINTER; a_ctl_in: INTEGER_32)
		external
			"C inline"
		alias
			"((struct itrm *)$tmp)->ctl_in = $a_ctl_in;"
		end

	c_set_blocked (tmp: POINTER; a_blocked: INTEGER_32)
		external
			"C inline"
		alias
			"((struct itrm *)$tmp)->blocked = $a_blocked;"
		end

	c_set_flags (tmp: POINTER; a_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct itrm *)$tmp)->flags = $a_flags;"
		end

	c_set_qlen (tmp: POINTER; a_qlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct itrm *)$tmp)->qlen = $a_qlen;"
		end

	c_set_tm (tmp: POINTER; a_tm: INTEGER_32)
		external
			"C inline"
		alias
			"((struct itrm *)$tmp)->tm = $a_tm;"
		end

	c_set_ev_queue (tmp: POINTER; a_ev_queue: POINTER)
		external
			"C inline"
		alias
			"((struct itrm *)$tmp)->ev_queue = (unsigned char *)$a_ev_queue;"
		end

	c_set_eqlen (tmp: POINTER; a_eqlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct itrm *)$tmp)->eqlen = $a_eqlen;"
		end

	c_set_mouse_h (tmp: POINTER; a_mouse_h: POINTER)
		external
			"C inline"
		alias
			"((struct itrm *)$tmp)->mouse_h = (void *)$a_mouse_h;"
		end

	c_set_orig_title (tmp: POINTER; a_orig_title: POINTER)
		external
			"C inline"
		alias
			"((struct itrm *)$tmp)->orig_title = (unsigned char *)$a_orig_title;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct itrm);"
		end

end
