class
	PD_K_CONN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_K_CONN] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_K_CONN] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	protocol: CE_ROUTINE assign set_protocol
		do
			create Result.make_shared (c_protocol (c_pointer))
		end

	host: CE_POINTER [NATURAL_8] assign set_host
		do
			create Result.make_shared (c_host (c_pointer))
		end

	port: INTEGER_32 assign set_port
		do
			Result := c_port (c_pointer)
		end

	conn: INTEGER_32 assign set_conn
		do
			Result := c_conn (c_pointer)
		end

	timeout: INTEGER_32 assign set_timeout
		do
			Result := c_timeout (c_pointer)
		end

	add_time: INTEGER_32 assign set_add_time
		do
			Result := c_add_time (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_K_CONN])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_K_CONN])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_protocol (a_protocol: CE_ROUTINE)
		do
			c_set_protocol (c_pointer, a_protocol.c_pointer)
		end

	set_host (a_host: CE_POINTER [NATURAL_8])
		do
			c_set_host (c_pointer, a_host.c_pointer)
		end

	set_port (a_port: INTEGER_32)
		do
			c_set_port (c_pointer, a_port)
		end

	set_conn (a_conn: INTEGER_32)
		do
			c_set_conn (c_pointer, a_conn)
		end

	set_timeout (a_timeout: INTEGER_32)
		do
			c_set_timeout (c_pointer, a_timeout)
		end

	set_add_time (a_add_time: INTEGER_32)
		do
			c_set_add_time (c_pointer, a_add_time)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct k_conn *)((struct k_conn *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct k_conn *)((struct k_conn *)$tmp)->prev;"
		end

	c_protocol (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct connection *))((struct k_conn *)$tmp)->protocol;"
		end

	c_host (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct k_conn *)$tmp)->host;"
		end

	c_port (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct k_conn *)$tmp)->port;"
		end

	c_conn (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct k_conn *)$tmp)->conn;"
		end

	c_timeout (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct k_conn *)$tmp)->timeout;"
		end

	c_add_time (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct k_conn *)$tmp)->add_time;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct k_conn *)$tmp)->next = (struct k_conn *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct k_conn *)$tmp)->prev = (struct k_conn *)$a_prev;"
		end

	c_set_protocol (tmp: POINTER; a_protocol: POINTER)
		external
			"C inline"
		alias
			"((struct k_conn *)$tmp)->protocol = (void( *)(struct connection *))$a_protocol;"
		end

	c_set_host (tmp: POINTER; a_host: POINTER)
		external
			"C inline"
		alias
			"((struct k_conn *)$tmp)->host = (unsigned char *)$a_host;"
		end

	c_set_port (tmp: POINTER; a_port: INTEGER_32)
		external
			"C inline"
		alias
			"((struct k_conn *)$tmp)->port = $a_port;"
		end

	c_set_conn (tmp: POINTER; a_conn: INTEGER_32)
		external
			"C inline"
		alias
			"((struct k_conn *)$tmp)->conn = $a_conn;"
		end

	c_set_timeout (tmp: POINTER; a_timeout: INTEGER_32)
		external
			"C inline"
		alias
			"((struct k_conn *)$tmp)->timeout = $a_timeout;"
		end

	c_set_add_time (tmp: POINTER; a_add_time: INTEGER_32)
		external
			"C inline"
		alias
			"((struct k_conn *)$tmp)->add_time = $a_add_time;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct k_conn);"
		end

end
