class
	PD_KEYBINDING

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_KEYBINDING] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_KEYBINDING] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	act: INTEGER_32 assign set_act
		do
			Result := c_act (c_pointer)
		end

	x: INTEGER_32 assign set_x
		do
			Result := c_x (c_pointer)
		end

	y: INTEGER_32 assign set_y
		do
			Result := c_y (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_KEYBINDING])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_KEYBINDING])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_act (a_act: INTEGER_32)
		do
			c_set_act (c_pointer, a_act)
		end

	set_x (a_x: INTEGER_32)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: INTEGER_32)
		do
			c_set_y (c_pointer, a_y)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct keybinding *)((struct keybinding *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct keybinding *)((struct keybinding *)$tmp)->prev;"
		end

	c_act (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct keybinding *)$tmp)->act;"
		end

	c_x (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct keybinding *)$tmp)->x;"
		end

	c_y (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct keybinding *)$tmp)->y;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct keybinding *)$tmp)->next = (struct keybinding *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct keybinding *)$tmp)->prev = (struct keybinding *)$a_prev;"
		end

	c_set_act (tmp: POINTER; a_act: INTEGER_32)
		external
			"C inline"
		alias
			"((struct keybinding *)$tmp)->act = $a_act;"
		end

	c_set_x (tmp: POINTER; a_x: INTEGER_32)
		external
			"C inline"
		alias
			"((struct keybinding *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: INTEGER_32)
		external
			"C inline"
		alias
			"((struct keybinding *)$tmp)->y = $a_y;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct keybinding);"
		end

end
