class
	PD_LINE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	l: INTEGER_32 assign set_l
		do
			Result := c_l (c_pointer)
		end

	c: NATURAL_16 assign set_c
		do
			Result := c_c (c_pointer)
		end

	d: CE_POINTER [NATURAL_16] assign set_d
		do
			create Result.make_shared (c_d (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_l (a_l: INTEGER_32)
		do
			c_set_l (c_pointer, a_l)
		end

	set_c (a_c: NATURAL_16)
		do
			c_set_c (c_pointer, a_c)
		end

	set_d (a_d: CE_POINTER [NATURAL_16])
		do
			c_set_d (c_pointer, a_d.c_pointer)
		end

feature {NONE} -- C getters

	c_l (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct line *)$tmp)->l;"
		end

	c_c (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct line *)$tmp)->c;"
		end

	c_d (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned short *)((struct line *)$tmp)->d;"
		end

feature {NONE} -- C setters

	c_set_l (tmp: POINTER; a_l: INTEGER_32)
		external
			"C inline"
		alias
			"((struct line *)$tmp)->l = $a_l;"
		end

	c_set_c (tmp: POINTER; a_c: NATURAL_16)
		external
			"C inline"
		alias
			"((struct line *)$tmp)->c = $a_c;"
		end

	c_set_d (tmp: POINTER; a_d: POINTER)
		external
			"C inline"
		alias
			"((struct line *)$tmp)->d = (unsigned short *)$a_d;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct line);"
		end

end
