class
	PD_LINK

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	num: INTEGER_32 assign set_num
		do
			Result := c_num (c_pointer)
		end

	where: CE_POINTER [NATURAL_8] assign set_where
		do
			create Result.make_shared (c_where (c_pointer))
		end

	target: CE_POINTER [NATURAL_8] assign set_target
		do
			create Result.make_shared (c_target (c_pointer))
		end

	where_img: CE_POINTER [NATURAL_8] assign set_where_img
		do
			create Result.make_shared (c_where_img (c_pointer))
		end

	form: CE_POINTER [PD_FORM_CONTROL] assign set_form
		do
			create Result.make_shared (c_form (c_pointer))
		end

	sel_color: NATURAL_32 assign set_sel_color
		do
			Result := c_sel_color (c_pointer)
		end

	n: INTEGER_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	pos: CE_POINTER [PD_POINT] assign set_pos
		do
			create Result.make_shared (c_pos (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_num (a_num: INTEGER_32)
		do
			c_set_num (c_pointer, a_num)
		end

	set_where (a_where: CE_POINTER [NATURAL_8])
		do
			c_set_where (c_pointer, a_where.c_pointer)
		end

	set_target (a_target: CE_POINTER [NATURAL_8])
		do
			c_set_target (c_pointer, a_target.c_pointer)
		end

	set_where_img (a_where_img: CE_POINTER [NATURAL_8])
		do
			c_set_where_img (c_pointer, a_where_img.c_pointer)
		end

	set_form (a_form: CE_POINTER [PD_FORM_CONTROL])
		do
			c_set_form (c_pointer, a_form.c_pointer)
		end

	set_sel_color (a_sel_color: NATURAL_32)
		do
			c_set_sel_color (c_pointer, a_sel_color)
		end

	set_n (a_n: INTEGER_32)
		do
			c_set_n (c_pointer, a_n)
		end

	set_pos (a_pos: CE_POINTER [PD_POINT])
		do
			c_set_pos (c_pointer, a_pos.c_pointer)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct link *)$tmp)->type;"
		end

	c_num (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct link *)$tmp)->num;"
		end

	c_where (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct link *)$tmp)->where;"
		end

	c_target (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct link *)$tmp)->target;"
		end

	c_where_img (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct link *)$tmp)->where_img;"
		end

	c_form (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct form_control *)((struct link *)$tmp)->form;"
		end

	c_sel_color (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct link *)$tmp)->sel_color;"
		end

	c_n (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct link *)$tmp)->n;"
		end

	c_pos (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct point *)((struct link *)$tmp)->pos;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct link *)$tmp)->type = $a_type;"
		end

	c_set_num (tmp: POINTER; a_num: INTEGER_32)
		external
			"C inline"
		alias
			"((struct link *)$tmp)->num = $a_num;"
		end

	c_set_where (tmp: POINTER; a_where: POINTER)
		external
			"C inline"
		alias
			"((struct link *)$tmp)->where = (unsigned char *)$a_where;"
		end

	c_set_target (tmp: POINTER; a_target: POINTER)
		external
			"C inline"
		alias
			"((struct link *)$tmp)->target = (unsigned char *)$a_target;"
		end

	c_set_where_img (tmp: POINTER; a_where_img: POINTER)
		external
			"C inline"
		alias
			"((struct link *)$tmp)->where_img = (unsigned char *)$a_where_img;"
		end

	c_set_form (tmp: POINTER; a_form: POINTER)
		external
			"C inline"
		alias
			"((struct link *)$tmp)->form = (struct form_control *)$a_form;"
		end

	c_set_sel_color (tmp: POINTER; a_sel_color: NATURAL_32)
		external
			"C inline"
		alias
			"((struct link *)$tmp)->sel_color = $a_sel_color;"
		end

	c_set_n (tmp: POINTER; a_n: INTEGER_32)
		external
			"C inline"
		alias
			"((struct link *)$tmp)->n = $a_n;"
		end

	c_set_pos (tmp: POINTER; a_pos: POINTER)
		external
			"C inline"
		alias
			"((struct link *)$tmp)->pos = (struct point *)$a_pos;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct link);"
		end

end
