class
	PD_LINK_DEF

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	link: CE_POINTER [NATURAL_8] assign set_link
		do
			create Result.make_shared (c_link (c_pointer))
		end

	target: CE_POINTER [NATURAL_8] assign set_target
		do
			create Result.make_shared (c_target (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_link (a_link: CE_POINTER [NATURAL_8])
		do
			c_set_link (c_pointer, a_link.c_pointer)
		end

	set_target (a_target: CE_POINTER [NATURAL_8])
		do
			c_set_target (c_pointer, a_target.c_pointer)
		end

feature {NONE} -- C getters

	c_link (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct link_def *)$tmp)->link;"
		end

	c_target (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct link_def *)$tmp)->target;"
		end

feature {NONE} -- C setters

	c_set_link (tmp: POINTER; a_link: POINTER)
		external
			"C inline"
		alias
			"((struct link_def *)$tmp)->link = (unsigned char *)$a_link;"
		end

	c_set_target (tmp: POINTER; a_target: POINTER)
		external
			"C inline"
		alias
			"((struct link_def *)$tmp)->target = (unsigned char *)$a_target;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct link_def);"
		end

end
