class
	PD_LOCATION

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_LOCATION] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_LOCATION] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	frames: PD_LIST_HEAD assign set_frames
		do
			create Result.make_shared (c_frames (c_pointer))
		end

	frames_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct location, frames);"
		end

	stat: PD_STATUS assign set_stat
		do
			create Result.make_shared (c_stat (c_pointer))
		end

	stat_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct location, stat);"
		end

	vs: PD_VIEW_STATE assign set_vs
		do
			create Result.make_shared (c_vs (c_pointer))
		end

	vs_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct location, vs);"
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_LOCATION])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_LOCATION])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_frames (a_frames: PD_LIST_HEAD)
		do
			frames.ce_gets (a_frames)
		end

	set_stat (a_stat: PD_STATUS)
		do
			stat.ce_gets (a_stat)
		end

	set_vs (a_vs: PD_VIEW_STATE)
		do
			vs.ce_gets (a_vs)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct location *)((struct location *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct location *)((struct location *)$tmp)->prev;"
		end

	c_frames (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct list_head *)&((struct location *)$tmp)->frames;"
		end

	c_stat (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct status *)&((struct location *)$tmp)->stat;"
		end

	c_vs (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct view_state *)&((struct location *)$tmp)->vs;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct location *)$tmp)->next = (struct location *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct location *)$tmp)->prev = (struct location *)$a_prev;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct location);"
		end

end
