class
	PD_MAINMENU

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	selected: INTEGER_32 assign set_selected
		do
			Result := c_selected (c_pointer)
		end

	sp: INTEGER_32 assign set_sp
		do
			Result := c_sp (c_pointer)
		end

	ni: INTEGER_32 assign set_ni
		do
			Result := c_ni (c_pointer)
		end

	data: CE_POINTER [ANY] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	win: CE_POINTER [PD_WINDOW] assign set_win
		do
			create Result.make_shared (c_win (c_pointer))
		end

	items: CE_POINTER [PD_MENU_ITEM] assign set_items
		do
			create Result.make_shared (c_items (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_selected (a_selected: INTEGER_32)
		do
			c_set_selected (c_pointer, a_selected)
		end

	set_sp (a_sp: INTEGER_32)
		do
			c_set_sp (c_pointer, a_sp)
		end

	set_ni (a_ni: INTEGER_32)
		do
			c_set_ni (c_pointer, a_ni)
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_win (a_win: CE_POINTER [PD_WINDOW])
		do
			c_set_win (c_pointer, a_win.c_pointer)
		end

	set_items (a_items: CE_POINTER [PD_MENU_ITEM])
		do
			c_set_items (c_pointer, a_items.c_pointer)
		end

feature {NONE} -- C getters

	c_selected (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct mainmenu *)$tmp)->selected;"
		end

	c_sp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct mainmenu *)$tmp)->sp;"
		end

	c_ni (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct mainmenu *)$tmp)->ni;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct mainmenu *)$tmp)->data;"
		end

	c_win (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct window *)((struct mainmenu *)$tmp)->win;"
		end

	c_items (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct menu_item *)((struct mainmenu *)$tmp)->items;"
		end

feature {NONE} -- C setters

	c_set_selected (tmp: POINTER; a_selected: INTEGER_32)
		external
			"C inline"
		alias
			"((struct mainmenu *)$tmp)->selected = $a_selected;"
		end

	c_set_sp (tmp: POINTER; a_sp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct mainmenu *)$tmp)->sp = $a_sp;"
		end

	c_set_ni (tmp: POINTER; a_ni: INTEGER_32)
		external
			"C inline"
		alias
			"((struct mainmenu *)$tmp)->ni = $a_ni;"
		end

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct mainmenu *)$tmp)->data = (void *)$a_data;"
		end

	c_set_win (tmp: POINTER; a_win: POINTER)
		external
			"C inline"
		alias
			"((struct mainmenu *)$tmp)->win = (struct window *)$a_win;"
		end

	c_set_items (tmp: POINTER; a_items: POINTER)
		external
			"C inline"
		alias
			"((struct mainmenu *)$tmp)->items = (struct menu_item *)$a_items;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct mainmenu);"
		end

end
