class
	PD_MEMORY_LIST

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	n: INTEGER_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	p: CE_ARRAY [CE_POINTER [ANY]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_p (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_n (a_n: INTEGER_32)
		do
			c_set_n (c_pointer, a_n)
		end

feature {NONE} -- C getters

	c_n (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct memory_list *)$tmp)->n;"
		end

	c_p (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct memory_list *tmp = (struct memory_list *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->p) / sizeof(tmp->p[0]);
				return tmp->p;
			]"
		end

feature {NONE} -- C setters

	c_set_n (tmp: POINTER; a_n: INTEGER_32)
		external
			"C inline"
		alias
			"((struct memory_list *)$tmp)->n = $a_n;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct memory_list);"
		end

end
