class
	PD_MENU

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	selected: INTEGER_32 assign set_selected
		do
			Result := c_selected (c_pointer)
		end

	view: INTEGER_32 assign set_view
		do
			Result := c_view (c_pointer)
		end

	xp: INTEGER_32 assign set_xp
		do
			Result := c_xp (c_pointer)
		end

	xp_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct menu, xp);"
		end

	yp: INTEGER_32 assign set_yp
		do
			Result := c_yp (c_pointer)
		end

	yp_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct menu, yp);"
		end

	x: INTEGER_32 assign set_x
		do
			Result := c_x (c_pointer)
		end

	y: INTEGER_32 assign set_y
		do
			Result := c_y (c_pointer)
		end

	xw: INTEGER_32 assign set_xw
		do
			Result := c_xw (c_pointer)
		end

	yw: INTEGER_32 assign set_yw
		do
			Result := c_yw (c_pointer)
		end

	ni: INTEGER_32 assign set_ni
		do
			Result := c_ni (c_pointer)
		end

	data: CE_POINTER [ANY] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	win: CE_POINTER [PD_WINDOW] assign set_win
		do
			create Result.make_shared (c_win (c_pointer))
		end

	items: CE_POINTER [PD_MENU_ITEM] assign set_items
		do
			create Result.make_shared (c_items (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_selected (a_selected: INTEGER_32)
		do
			c_set_selected (c_pointer, a_selected)
		end

	set_view (a_view: INTEGER_32)
		do
			c_set_view (c_pointer, a_view)
		end

	set_xp (a_xp: INTEGER_32)
		do
			c_set_xp (c_pointer, a_xp)
		end

	set_yp (a_yp: INTEGER_32)
		do
			c_set_yp (c_pointer, a_yp)
		end

	set_x (a_x: INTEGER_32)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: INTEGER_32)
		do
			c_set_y (c_pointer, a_y)
		end

	set_xw (a_xw: INTEGER_32)
		do
			c_set_xw (c_pointer, a_xw)
		end

	set_yw (a_yw: INTEGER_32)
		do
			c_set_yw (c_pointer, a_yw)
		end

	set_ni (a_ni: INTEGER_32)
		do
			c_set_ni (c_pointer, a_ni)
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_win (a_win: CE_POINTER [PD_WINDOW])
		do
			c_set_win (c_pointer, a_win.c_pointer)
		end

	set_items (a_items: CE_POINTER [PD_MENU_ITEM])
		do
			c_set_items (c_pointer, a_items.c_pointer)
		end

feature {NONE} -- C getters

	c_selected (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct menu *)$tmp)->selected;"
		end

	c_view (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct menu *)$tmp)->view;"
		end

	c_xp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct menu *)$tmp)->xp;"
		end

	c_yp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct menu *)$tmp)->yp;"
		end

	c_x (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct menu *)$tmp)->x;"
		end

	c_y (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct menu *)$tmp)->y;"
		end

	c_xw (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct menu *)$tmp)->xw;"
		end

	c_yw (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct menu *)$tmp)->yw;"
		end

	c_ni (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct menu *)$tmp)->ni;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct menu *)$tmp)->data;"
		end

	c_win (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct window *)((struct menu *)$tmp)->win;"
		end

	c_items (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct menu_item *)((struct menu *)$tmp)->items;"
		end

feature {NONE} -- C setters

	c_set_selected (tmp: POINTER; a_selected: INTEGER_32)
		external
			"C inline"
		alias
			"((struct menu *)$tmp)->selected = $a_selected;"
		end

	c_set_view (tmp: POINTER; a_view: INTEGER_32)
		external
			"C inline"
		alias
			"((struct menu *)$tmp)->view = $a_view;"
		end

	c_set_xp (tmp: POINTER; a_xp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct menu *)$tmp)->xp = $a_xp;"
		end

	c_set_yp (tmp: POINTER; a_yp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct menu *)$tmp)->yp = $a_yp;"
		end

	c_set_x (tmp: POINTER; a_x: INTEGER_32)
		external
			"C inline"
		alias
			"((struct menu *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: INTEGER_32)
		external
			"C inline"
		alias
			"((struct menu *)$tmp)->y = $a_y;"
		end

	c_set_xw (tmp: POINTER; a_xw: INTEGER_32)
		external
			"C inline"
		alias
			"((struct menu *)$tmp)->xw = $a_xw;"
		end

	c_set_yw (tmp: POINTER; a_yw: INTEGER_32)
		external
			"C inline"
		alias
			"((struct menu *)$tmp)->yw = $a_yw;"
		end

	c_set_ni (tmp: POINTER; a_ni: INTEGER_32)
		external
			"C inline"
		alias
			"((struct menu *)$tmp)->ni = $a_ni;"
		end

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct menu *)$tmp)->data = (void *)$a_data;"
		end

	c_set_win (tmp: POINTER; a_win: POINTER)
		external
			"C inline"
		alias
			"((struct menu *)$tmp)->win = (struct window *)$a_win;"
		end

	c_set_items (tmp: POINTER; a_items: POINTER)
		external
			"C inline"
		alias
			"((struct menu *)$tmp)->items = (struct menu_item *)$a_items;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct menu);"
		end

end
