class
	PD_MENU_ITEM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	text: CE_POINTER [NATURAL_8] assign set_text
		do
			create Result.make_shared (c_text (c_pointer))
		end

	rtext: CE_POINTER [NATURAL_8] assign set_rtext
		do
			create Result.make_shared (c_rtext (c_pointer))
		end

	hotkey: CE_POINTER [NATURAL_8] assign set_hotkey
		do
			create Result.make_shared (c_hotkey (c_pointer))
		end

	func: CE_ROUTINE assign set_func
		do
			create Result.make_shared (c_func (c_pointer))
		end

	data: CE_POINTER [ANY] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	in_m: INTEGER_32 assign set_in_m
		do
			Result := c_in_m (c_pointer)
		end

	free_i: INTEGER_32 assign set_free_i
		do
			Result := c_free_i (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_text (a_text: CE_POINTER [NATURAL_8])
		do
			c_set_text (c_pointer, a_text.c_pointer)
		end

	set_rtext (a_rtext: CE_POINTER [NATURAL_8])
		do
			c_set_rtext (c_pointer, a_rtext.c_pointer)
		end

	set_hotkey (a_hotkey: CE_POINTER [NATURAL_8])
		do
			c_set_hotkey (c_pointer, a_hotkey.c_pointer)
		end

	set_func (a_func: CE_ROUTINE)
		do
			c_set_func (c_pointer, a_func.c_pointer)
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_in_m (a_in_m: INTEGER_32)
		do
			c_set_in_m (c_pointer, a_in_m)
		end

	set_free_i (a_free_i: INTEGER_32)
		do
			c_set_free_i (c_pointer, a_free_i)
		end

feature {NONE} -- C getters

	c_text (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct menu_item *)$tmp)->text;"
		end

	c_rtext (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct menu_item *)$tmp)->rtext;"
		end

	c_hotkey (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct menu_item *)$tmp)->hotkey;"
		end

	c_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct terminal *, void *, void *))((struct menu_item *)$tmp)->func;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct menu_item *)$tmp)->data;"
		end

	c_in_m (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct menu_item *)$tmp)->in_m;"
		end

	c_free_i (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct menu_item *)$tmp)->free_i;"
		end

feature {NONE} -- C setters

	c_set_text (tmp: POINTER; a_text: POINTER)
		external
			"C inline"
		alias
			"((struct menu_item *)$tmp)->text = (unsigned char *)$a_text;"
		end

	c_set_rtext (tmp: POINTER; a_rtext: POINTER)
		external
			"C inline"
		alias
			"((struct menu_item *)$tmp)->rtext = (unsigned char *)$a_rtext;"
		end

	c_set_hotkey (tmp: POINTER; a_hotkey: POINTER)
		external
			"C inline"
		alias
			"((struct menu_item *)$tmp)->hotkey = (unsigned char *)$a_hotkey;"
		end

	c_set_func (tmp: POINTER; a_func: POINTER)
		external
			"C inline"
		alias
			"((struct menu_item *)$tmp)->func = (void( *)(struct terminal *, void *, void *))$a_func;"
		end

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct menu_item *)$tmp)->data = (void *)$a_data;"
		end

	c_set_in_m (tmp: POINTER; a_in_m: INTEGER_32)
		external
			"C inline"
		alias
			"((struct menu_item *)$tmp)->in_m = $a_in_m;"
		end

	c_set_free_i (tmp: POINTER; a_free_i: INTEGER_32)
		external
			"C inline"
		alias
			"((struct menu_item *)$tmp)->free_i = $a_free_i;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct menu_item);"
		end

end
