class
	PD_NODE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_NODE] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_NODE] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	x: INTEGER_32 assign set_x
		do
			Result := c_x (c_pointer)
		end

	y: INTEGER_32 assign set_y
		do
			Result := c_y (c_pointer)
		end

	xw: INTEGER_32 assign set_xw
		do
			Result := c_xw (c_pointer)
		end

	yw: INTEGER_32 assign set_yw
		do
			Result := c_yw (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_NODE])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_NODE])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_x (a_x: INTEGER_32)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: INTEGER_32)
		do
			c_set_y (c_pointer, a_y)
		end

	set_xw (a_xw: INTEGER_32)
		do
			c_set_xw (c_pointer, a_xw)
		end

	set_yw (a_yw: INTEGER_32)
		do
			c_set_yw (c_pointer, a_yw)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct node *)((struct node *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct node *)((struct node *)$tmp)->prev;"
		end

	c_x (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct node *)$tmp)->x;"
		end

	c_y (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct node *)$tmp)->y;"
		end

	c_xw (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct node *)$tmp)->xw;"
		end

	c_yw (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct node *)$tmp)->yw;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct node *)$tmp)->next = (struct node *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct node *)$tmp)->prev = (struct node *)$a_prev;"
		end

	c_set_x (tmp: POINTER; a_x: INTEGER_32)
		external
			"C inline"
		alias
			"((struct node *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: INTEGER_32)
		external
			"C inline"
		alias
			"((struct node *)$tmp)->y = $a_y;"
		end

	c_set_xw (tmp: POINTER; a_xw: INTEGER_32)
		external
			"C inline"
		alias
			"((struct node *)$tmp)->xw = $a_xw;"
		end

	c_set_yw (tmp: POINTER; a_yw: INTEGER_32)
		external
			"C inline"
		alias
			"((struct node *)$tmp)->yw = $a_yw;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct node);"
		end

end
