class
	PD_OPEN_IN_NEW

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	text: CE_POINTER [NATURAL_8] assign set_text
		do
			create Result.make_shared (c_text (c_pointer))
		end

	hk: CE_POINTER [NATURAL_8] assign set_hk
		do
			create Result.make_shared (c_hk (c_pointer))
		end

	fn: CE_ROUTINE assign set_fn
		do
			create Result.make_shared (c_fn (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_text (a_text: CE_POINTER [NATURAL_8])
		do
			c_set_text (c_pointer, a_text.c_pointer)
		end

	set_hk (a_hk: CE_POINTER [NATURAL_8])
		do
			c_set_hk (c_pointer, a_hk.c_pointer)
		end

	set_fn (a_fn: CE_ROUTINE)
		do
			c_set_fn (c_pointer, a_fn.c_pointer)
		end

feature {NONE} -- C getters

	c_text (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct open_in_new *)$tmp)->text;"
		end

	c_hk (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct open_in_new *)$tmp)->hk;"
		end

	c_fn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct terminal * term, unsigned char *, unsigned char *))((struct open_in_new *)$tmp)->fn;"
		end

feature {NONE} -- C setters

	c_set_text (tmp: POINTER; a_text: POINTER)
		external
			"C inline"
		alias
			"((struct open_in_new *)$tmp)->text = (unsigned char *)$a_text;"
		end

	c_set_hk (tmp: POINTER; a_hk: POINTER)
		external
			"C inline"
		alias
			"((struct open_in_new *)$tmp)->hk = (unsigned char *)$a_hk;"
		end

	c_set_fn (tmp: POINTER; a_fn: POINTER)
		external
			"C inline"
		alias
			"((struct open_in_new *)$tmp)->fn = (void( *)(struct terminal * term, unsigned char *, unsigned char *))$a_fn;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct open_in_new);"
		end

end
