class
	PD_PART

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	x: INTEGER_32 assign set_x
		do
			Result := c_x (c_pointer)
		end

	y: INTEGER_32 assign set_y
		do
			Result := c_y (c_pointer)
		end

	xp: INTEGER_32 assign set_xp
		do
			Result := c_xp (c_pointer)
		end

	yp: INTEGER_32 assign set_yp
		do
			Result := c_yp (c_pointer)
		end

	xmax: INTEGER_32 assign set_xmax
		do
			Result := c_xmax (c_pointer)
		end

	xa: INTEGER_32 assign set_xa
		do
			Result := c_xa (c_pointer)
		end

	cx: INTEGER_32 assign set_cx
		do
			Result := c_cx (c_pointer)
		end

	cy: INTEGER_32 assign set_cy
		do
			Result := c_cy (c_pointer)
		end

	data: CE_POINTER [PD_F_DATA] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	bgcolor: INTEGER_32 assign set_bgcolor
		do
			Result := c_bgcolor (c_pointer)
		end

	spaces: CE_POINTER [NATURAL_8] assign set_spaces
		do
			create Result.make_shared (c_spaces (c_pointer))
		end

	spl: INTEGER_32 assign set_spl
		do
			Result := c_spl (c_pointer)
		end

	link_num: INTEGER_32 assign set_link_num
		do
			Result := c_link_num (c_pointer)
		end

	uf: PD_LIST_HEAD assign set_uf
		do
			create Result.make_shared (c_uf (c_pointer))
		end

	uf_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct part, uf);"
		end

feature {ANY} -- Eiffel setters

	set_x (a_x: INTEGER_32)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: INTEGER_32)
		do
			c_set_y (c_pointer, a_y)
		end

	set_xp (a_xp: INTEGER_32)
		do
			c_set_xp (c_pointer, a_xp)
		end

	set_yp (a_yp: INTEGER_32)
		do
			c_set_yp (c_pointer, a_yp)
		end

	set_xmax (a_xmax: INTEGER_32)
		do
			c_set_xmax (c_pointer, a_xmax)
		end

	set_xa (a_xa: INTEGER_32)
		do
			c_set_xa (c_pointer, a_xa)
		end

	set_cx (a_cx: INTEGER_32)
		do
			c_set_cx (c_pointer, a_cx)
		end

	set_cy (a_cy: INTEGER_32)
		do
			c_set_cy (c_pointer, a_cy)
		end

	set_data (a_data: CE_POINTER [PD_F_DATA])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_bgcolor (a_bgcolor: INTEGER_32)
		do
			c_set_bgcolor (c_pointer, a_bgcolor)
		end

	set_spaces (a_spaces: CE_POINTER [NATURAL_8])
		do
			c_set_spaces (c_pointer, a_spaces.c_pointer)
		end

	set_spl (a_spl: INTEGER_32)
		do
			c_set_spl (c_pointer, a_spl)
		end

	set_link_num (a_link_num: INTEGER_32)
		do
			c_set_link_num (c_pointer, a_link_num)
		end

	set_uf (a_uf: PD_LIST_HEAD)
		do
			uf.ce_gets (a_uf)
		end

feature {NONE} -- C getters

	c_x (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct part *)$tmp)->x;"
		end

	c_y (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct part *)$tmp)->y;"
		end

	c_xp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct part *)$tmp)->xp;"
		end

	c_yp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct part *)$tmp)->yp;"
		end

	c_xmax (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct part *)$tmp)->xmax;"
		end

	c_xa (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct part *)$tmp)->xa;"
		end

	c_cx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct part *)$tmp)->cx;"
		end

	c_cy (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct part *)$tmp)->cy;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct f_data *)((struct part *)$tmp)->data;"
		end

	c_bgcolor (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct part *)$tmp)->bgcolor;"
		end

	c_spaces (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct part *)$tmp)->spaces;"
		end

	c_spl (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct part *)$tmp)->spl;"
		end

	c_link_num (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct part *)$tmp)->link_num;"
		end

	c_uf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct list_head *)&((struct part *)$tmp)->uf;"
		end

feature {NONE} -- C setters

	c_set_x (tmp: POINTER; a_x: INTEGER_32)
		external
			"C inline"
		alias
			"((struct part *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: INTEGER_32)
		external
			"C inline"
		alias
			"((struct part *)$tmp)->y = $a_y;"
		end

	c_set_xp (tmp: POINTER; a_xp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct part *)$tmp)->xp = $a_xp;"
		end

	c_set_yp (tmp: POINTER; a_yp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct part *)$tmp)->yp = $a_yp;"
		end

	c_set_xmax (tmp: POINTER; a_xmax: INTEGER_32)
		external
			"C inline"
		alias
			"((struct part *)$tmp)->xmax = $a_xmax;"
		end

	c_set_xa (tmp: POINTER; a_xa: INTEGER_32)
		external
			"C inline"
		alias
			"((struct part *)$tmp)->xa = $a_xa;"
		end

	c_set_cx (tmp: POINTER; a_cx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct part *)$tmp)->cx = $a_cx;"
		end

	c_set_cy (tmp: POINTER; a_cy: INTEGER_32)
		external
			"C inline"
		alias
			"((struct part *)$tmp)->cy = $a_cy;"
		end

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct part *)$tmp)->data = (struct f_data *)$a_data;"
		end

	c_set_bgcolor (tmp: POINTER; a_bgcolor: INTEGER_32)
		external
			"C inline"
		alias
			"((struct part *)$tmp)->bgcolor = $a_bgcolor;"
		end

	c_set_spaces (tmp: POINTER; a_spaces: POINTER)
		external
			"C inline"
		alias
			"((struct part *)$tmp)->spaces = (unsigned char *)$a_spaces;"
		end

	c_set_spl (tmp: POINTER; a_spl: INTEGER_32)
		external
			"C inline"
		alias
			"((struct part *)$tmp)->spl = $a_spl;"
		end

	c_set_link_num (tmp: POINTER; a_link_num: INTEGER_32)
		external
			"C inline"
		alias
			"((struct part *)$tmp)->link_num = $a_link_num;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct part);"
		end

end
