class
	PD_PROTOCOL_PROGRAM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_PROTOCOL_PROGRAM] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_PROTOCOL_PROGRAM] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	prog: CE_POINTER [NATURAL_8] assign set_prog
		do
			create Result.make_shared (c_prog (c_pointer))
		end

	system: INTEGER_32 assign set_system
		do
			Result := c_system (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_PROTOCOL_PROGRAM])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_PROTOCOL_PROGRAM])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_prog (a_prog: CE_POINTER [NATURAL_8])
		do
			c_set_prog (c_pointer, a_prog.c_pointer)
		end

	set_system (a_system: INTEGER_32)
		do
			c_set_system (c_pointer, a_system)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct protocol_program *)((struct protocol_program *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct protocol_program *)((struct protocol_program *)$tmp)->prev;"
		end

	c_prog (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct protocol_program *)$tmp)->prog;"
		end

	c_system (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct protocol_program *)$tmp)->system;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct protocol_program *)$tmp)->next = (struct protocol_program *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct protocol_program *)$tmp)->prev = (struct protocol_program *)$a_prev;"
		end

	c_set_prog (tmp: POINTER; a_prog: POINTER)
		external
			"C inline"
		alias
			"((struct protocol_program *)$tmp)->prog = (unsigned char *)$a_prog;"
		end

	c_set_system (tmp: POINTER; a_system: INTEGER_32)
		external
			"C inline"
		alias
			"((struct protocol_program *)$tmp)->system = $a_system;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct protocol_program);"
		end

end
