class
	PD_PROTOCOLS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	prot: CE_POINTER [NATURAL_8] assign set_prot
		do
			create Result.make_shared (c_prot (c_pointer))
		end

	port: INTEGER_32 assign set_port
		do
			Result := c_port (c_pointer)
		end

	func: CE_ROUTINE assign set_func
		do
			create Result.make_shared (c_func (c_pointer))
		end

	nc_func: CE_ROUTINE assign set_nc_func
		do
			create Result.make_shared (c_nc_func (c_pointer))
		end

	free_syntax: INTEGER_32 assign set_free_syntax
		do
			Result := c_free_syntax (c_pointer)
		end

	need_slashes: INTEGER_32 assign set_need_slashes
		do
			Result := c_need_slashes (c_pointer)
		end

	need_slash_after_host: INTEGER_32 assign set_need_slash_after_host
		do
			Result := c_need_slash_after_host (c_pointer)
		end

	allow_post: INTEGER_32 assign set_allow_post
		do
			Result := c_allow_post (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_prot (a_prot: CE_POINTER [NATURAL_8])
		do
			c_set_prot (c_pointer, a_prot.c_pointer)
		end

	set_port (a_port: INTEGER_32)
		do
			c_set_port (c_pointer, a_port)
		end

	set_func (a_func: CE_ROUTINE)
		do
			c_set_func (c_pointer, a_func.c_pointer)
		end

	set_nc_func (a_nc_func: CE_ROUTINE)
		do
			c_set_nc_func (c_pointer, a_nc_func.c_pointer)
		end

	set_free_syntax (a_free_syntax: INTEGER_32)
		do
			c_set_free_syntax (c_pointer, a_free_syntax)
		end

	set_need_slashes (a_need_slashes: INTEGER_32)
		do
			c_set_need_slashes (c_pointer, a_need_slashes)
		end

	set_need_slash_after_host (a_need_slash_after_host: INTEGER_32)
		do
			c_set_need_slash_after_host (c_pointer, a_need_slash_after_host)
		end

	set_allow_post (a_allow_post: INTEGER_32)
		do
			c_set_allow_post (c_pointer, a_allow_post)
		end

feature {NONE} -- C getters

	c_prot (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_protocols_67 *)$tmp)->prot;"
		end

	c_port (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_protocols_67 *)$tmp)->port;"
		end

	c_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct connection *))((struct __anonstruct_protocols_67 *)$tmp)->func;"
		end

	c_nc_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct session *, unsigned char *))((struct __anonstruct_protocols_67 *)$tmp)->nc_func;"
		end

	c_free_syntax (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_protocols_67 *)$tmp)->free_syntax;"
		end

	c_need_slashes (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_protocols_67 *)$tmp)->need_slashes;"
		end

	c_need_slash_after_host (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_protocols_67 *)$tmp)->need_slash_after_host;"
		end

	c_allow_post (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_protocols_67 *)$tmp)->allow_post;"
		end

feature {NONE} -- C setters

	c_set_prot (tmp: POINTER; a_prot: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_protocols_67 *)$tmp)->prot = (unsigned char *)$a_prot;"
		end

	c_set_port (tmp: POINTER; a_port: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_protocols_67 *)$tmp)->port = $a_port;"
		end

	c_set_func (tmp: POINTER; a_func: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_protocols_67 *)$tmp)->func = (void( *)(struct connection *))$a_func;"
		end

	c_set_nc_func (tmp: POINTER; a_nc_func: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_protocols_67 *)$tmp)->nc_func = (void( *)(struct session *, unsigned char *))$a_nc_func;"
		end

	c_set_free_syntax (tmp: POINTER; a_free_syntax: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_protocols_67 *)$tmp)->free_syntax = $a_free_syntax;"
		end

	c_set_need_slashes (tmp: POINTER; a_need_slashes: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_protocols_67 *)$tmp)->need_slashes = $a_need_slashes;"
		end

	c_set_need_slash_after_host (tmp: POINTER; a_need_slash_after_host: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_protocols_67 *)$tmp)->need_slash_after_host = $a_need_slash_after_host;"
		end

	c_set_allow_post (tmp: POINTER; a_allow_post: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_protocols_67 *)$tmp)->allow_post = $a_allow_post;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct __anonstruct_protocols_67);"
		end

end
