class
	PD_REFRESH

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	term: CE_POINTER [PD_TERMINAL] assign set_term
		do
			create Result.make_shared (c_term (c_pointer))
		end

	win: CE_POINTER [PD_WINDOW] assign set_win
		do
			create Result.make_shared (c_win (c_pointer))
		end

	ses: CE_POINTER [PD_SESSION] assign set_ses
		do
			create Result.make_shared (c_ses (c_pointer))
		end

	fn: CE_ROUTINE assign set_fn
		do
			create Result.make_shared (c_fn (c_pointer))
		end

	data: CE_POINTER [ANY] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	timer: INTEGER_32 assign set_timer
		do
			Result := c_timer (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_term (a_term: CE_POINTER [PD_TERMINAL])
		do
			c_set_term (c_pointer, a_term.c_pointer)
		end

	set_win (a_win: CE_POINTER [PD_WINDOW])
		do
			c_set_win (c_pointer, a_win.c_pointer)
		end

	set_ses (a_ses: CE_POINTER [PD_SESSION])
		do
			c_set_ses (c_pointer, a_ses.c_pointer)
		end

	set_fn (a_fn: CE_ROUTINE)
		do
			c_set_fn (c_pointer, a_fn.c_pointer)
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_timer (a_timer: INTEGER_32)
		do
			c_set_timer (c_pointer, a_timer)
		end

feature {NONE} -- C getters

	c_term (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct terminal *)((struct refresh *)$tmp)->term;"
		end

	c_win (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct window *)((struct refresh *)$tmp)->win;"
		end

	c_ses (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct session *)((struct refresh *)$tmp)->ses;"
		end

	c_fn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct terminal * term, void * d, struct session * ses))((struct refresh *)$tmp)->fn;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct refresh *)$tmp)->data;"
		end

	c_timer (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct refresh *)$tmp)->timer;"
		end

feature {NONE} -- C setters

	c_set_term (tmp: POINTER; a_term: POINTER)
		external
			"C inline"
		alias
			"((struct refresh *)$tmp)->term = (struct terminal *)$a_term;"
		end

	c_set_win (tmp: POINTER; a_win: POINTER)
		external
			"C inline"
		alias
			"((struct refresh *)$tmp)->win = (struct window *)$a_win;"
		end

	c_set_ses (tmp: POINTER; a_ses: POINTER)
		external
			"C inline"
		alias
			"((struct refresh *)$tmp)->ses = (struct session *)$a_ses;"
		end

	c_set_fn (tmp: POINTER; a_fn: POINTER)
		external
			"C inline"
		alias
			"((struct refresh *)$tmp)->fn = (void( *)(struct terminal * term, void * d, struct session * ses))$a_fn;"
		end

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct refresh *)$tmp)->data = (void *)$a_data;"
		end

	c_set_timer (tmp: POINTER; a_timer: INTEGER_32)
		external
			"C inline"
		alias
			"((struct refresh *)$tmp)->timer = $a_timer;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct refresh);"
		end

end
