class
	PD_REMAINING_INFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	valid: INTEGER_32 assign set_valid
		do
			Result := c_valid (c_pointer)
		end

	size: INTEGER_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	loaded: INTEGER_32 assign set_loaded
		do
			Result := c_loaded (c_pointer)
		end

	last_loaded: INTEGER_32 assign set_last_loaded
		do
			Result := c_last_loaded (c_pointer)
		end

	cur_loaded: INTEGER_32 assign set_cur_loaded
		do
			Result := c_cur_loaded (c_pointer)
		end

	pos: INTEGER_32 assign set_pos
		do
			Result := c_pos (c_pointer)
		end

	elapsed: INTEGER_32 assign set_elapsed
		do
			Result := c_elapsed (c_pointer)
		end

	last_time: INTEGER_32 assign set_last_time
		do
			Result := c_last_time (c_pointer)
		end

	dis_b: INTEGER_32 assign set_dis_b
		do
			Result := c_dis_b (c_pointer)
		end

	data_in_secs: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_data_in_secs (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	timer: INTEGER_32 assign set_timer
		do
			Result := c_timer (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_valid (a_valid: INTEGER_32)
		do
			c_set_valid (c_pointer, a_valid)
		end

	set_size (a_size: INTEGER_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_loaded (a_loaded: INTEGER_32)
		do
			c_set_loaded (c_pointer, a_loaded)
		end

	set_last_loaded (a_last_loaded: INTEGER_32)
		do
			c_set_last_loaded (c_pointer, a_last_loaded)
		end

	set_cur_loaded (a_cur_loaded: INTEGER_32)
		do
			c_set_cur_loaded (c_pointer, a_cur_loaded)
		end

	set_pos (a_pos: INTEGER_32)
		do
			c_set_pos (c_pointer, a_pos)
		end

	set_elapsed (a_elapsed: INTEGER_32)
		do
			c_set_elapsed (c_pointer, a_elapsed)
		end

	set_last_time (a_last_time: INTEGER_32)
		do
			c_set_last_time (c_pointer, a_last_time)
		end

	set_dis_b (a_dis_b: INTEGER_32)
		do
			c_set_dis_b (c_pointer, a_dis_b)
		end

	set_timer (a_timer: INTEGER_32)
		do
			c_set_timer (c_pointer, a_timer)
		end

feature {NONE} -- C getters

	c_valid (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct remaining_info *)$tmp)->valid;"
		end

	c_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct remaining_info *)$tmp)->size;"
		end

	c_loaded (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct remaining_info *)$tmp)->loaded;"
		end

	c_last_loaded (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct remaining_info *)$tmp)->last_loaded;"
		end

	c_cur_loaded (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct remaining_info *)$tmp)->cur_loaded;"
		end

	c_pos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct remaining_info *)$tmp)->pos;"
		end

	c_elapsed (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct remaining_info *)$tmp)->elapsed;"
		end

	c_last_time (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct remaining_info *)$tmp)->last_time;"
		end

	c_dis_b (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct remaining_info *)$tmp)->dis_b;"
		end

	c_data_in_secs (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct remaining_info *tmp = (struct remaining_info *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->data_in_secs) / sizeof(tmp->data_in_secs[0]);
				return tmp->data_in_secs;
			]"
		end

	c_timer (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct remaining_info *)$tmp)->timer;"
		end

feature {NONE} -- C setters

	c_set_valid (tmp: POINTER; a_valid: INTEGER_32)
		external
			"C inline"
		alias
			"((struct remaining_info *)$tmp)->valid = $a_valid;"
		end

	c_set_size (tmp: POINTER; a_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct remaining_info *)$tmp)->size = $a_size;"
		end

	c_set_loaded (tmp: POINTER; a_loaded: INTEGER_32)
		external
			"C inline"
		alias
			"((struct remaining_info *)$tmp)->loaded = $a_loaded;"
		end

	c_set_last_loaded (tmp: POINTER; a_last_loaded: INTEGER_32)
		external
			"C inline"
		alias
			"((struct remaining_info *)$tmp)->last_loaded = $a_last_loaded;"
		end

	c_set_cur_loaded (tmp: POINTER; a_cur_loaded: INTEGER_32)
		external
			"C inline"
		alias
			"((struct remaining_info *)$tmp)->cur_loaded = $a_cur_loaded;"
		end

	c_set_pos (tmp: POINTER; a_pos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct remaining_info *)$tmp)->pos = $a_pos;"
		end

	c_set_elapsed (tmp: POINTER; a_elapsed: INTEGER_32)
		external
			"C inline"
		alias
			"((struct remaining_info *)$tmp)->elapsed = $a_elapsed;"
		end

	c_set_last_time (tmp: POINTER; a_last_time: INTEGER_32)
		external
			"C inline"
		alias
			"((struct remaining_info *)$tmp)->last_time = $a_last_time;"
		end

	c_set_dis_b (tmp: POINTER; a_dis_b: INTEGER_32)
		external
			"C inline"
		alias
			"((struct remaining_info *)$tmp)->dis_b = $a_dis_b;"
		end

	c_set_timer (tmp: POINTER; a_timer: INTEGER_32)
		external
			"C inline"
		alias
			"((struct remaining_info *)$tmp)->timer = $a_timer;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct remaining_info);"
		end

end
