class
	PD_RGB

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	r: NATURAL_8 assign set_r
		do
			Result := c_r (c_pointer)
		end

	g: NATURAL_8 assign set_g
		do
			Result := c_g (c_pointer)
		end

	b: NATURAL_8 assign set_b
		do
			Result := c_b (c_pointer)
		end

	pad: NATURAL_8 assign set_pad
		do
			Result := c_pad (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_r (a_r: NATURAL_8)
		do
			c_set_r (c_pointer, a_r)
		end

	set_g (a_g: NATURAL_8)
		do
			c_set_g (c_pointer, a_g)
		end

	set_b (a_b: NATURAL_8)
		do
			c_set_b (c_pointer, a_b)
		end

	set_pad (a_pad: NATURAL_8)
		do
			c_set_pad (c_pointer, a_pad)
		end

feature {NONE} -- C getters

	c_r (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct rgb *)$tmp)->r;"
		end

	c_g (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct rgb *)$tmp)->g;"
		end

	c_b (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct rgb *)$tmp)->b;"
		end

	c_pad (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct rgb *)$tmp)->pad;"
		end

feature {NONE} -- C setters

	c_set_r (tmp: POINTER; a_r: NATURAL_8)
		external
			"C inline"
		alias
			"((struct rgb *)$tmp)->r = $a_r;"
		end

	c_set_g (tmp: POINTER; a_g: NATURAL_8)
		external
			"C inline"
		alias
			"((struct rgb *)$tmp)->g = $a_g;"
		end

	c_set_b (tmp: POINTER; a_b: NATURAL_8)
		external
			"C inline"
		alias
			"((struct rgb *)$tmp)->b = $a_b;"
		end

	c_set_pad (tmp: POINTER; a_pad: NATURAL_8)
		external
			"C inline"
		alias
			"((struct rgb *)$tmp)->pad = $a_pad;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct rgb);"
		end

end
