class
	PD_RGB_CACHE_ENTRY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	color: INTEGER_32 assign set_color
		do
			Result := c_color (c_pointer)
		end

	l: INTEGER_32 assign set_l
		do
			Result := c_l (c_pointer)
		end

	rgb: PD_RGB assign set_rgb
		do
			create Result.make_shared (c_rgb (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_color (a_color: INTEGER_32)
		do
			c_set_color (c_pointer, a_color)
		end

	set_l (a_l: INTEGER_32)
		do
			c_set_l (c_pointer, a_l)
		end

	set_rgb (a_rgb: PD_RGB)
		do
			rgb.ce_gets (a_rgb)
		end

feature {NONE} -- C getters

	c_color (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct rgb_cache_entry *)$tmp)->color;"
		end

	c_l (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct rgb_cache_entry *)$tmp)->l;"
		end

	c_rgb (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct rgb *)&((struct rgb_cache_entry *)$tmp)->rgb;"
		end

feature {NONE} -- C setters

	c_set_color (tmp: POINTER; a_color: INTEGER_32)
		external
			"C inline"
		alias
			"((struct rgb_cache_entry *)$tmp)->color = $a_color;"
		end

	c_set_l (tmp: POINTER; a_l: INTEGER_32)
		external
			"C inline"
		alias
			"((struct rgb_cache_entry *)$tmp)->l = $a_l;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct rgb_cache_entry);"
		end

end
