class
	PD_SESSION

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_SESSION] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_SESSION] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	history: PD_LIST_HEAD assign set_history
		do
			create Result.make_shared (c_history (c_pointer))
		end

	history_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct session, history);"
		end

	term: CE_POINTER [PD_TERMINAL] assign set_term
		do
			create Result.make_shared (c_term (c_pointer))
		end

	win: CE_POINTER [PD_WINDOW] assign set_win
		do
			create Result.make_shared (c_win (c_pointer))
		end

	id: INTEGER_32 assign set_id
		do
			Result := c_id (c_pointer)
		end

	screen: CE_POINTER [PD_F_DATA_C] assign set_screen
		do
			create Result.make_shared (c_screen (c_pointer))
		end

	scrn_frames: PD_LIST_HEAD assign set_scrn_frames
		do
			create Result.make_shared (c_scrn_frames (c_pointer))
		end

	scrn_frames_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct session, scrn_frames);"
		end

	loading: PD_STATUS assign set_loading
		do
			create Result.make_shared (c_loading (c_pointer))
		end

	loading_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct session, loading);"
		end

	wtd: INTEGER_32 assign set_wtd
		do
			Result := c_wtd (c_pointer)
		end

	wtd_target: CE_POINTER [NATURAL_8] assign set_wtd_target
		do
			create Result.make_shared (c_wtd_target (c_pointer))
		end

	loading_url: CE_POINTER [NATURAL_8] assign set_loading_url
		do
			create Result.make_shared (c_loading_url (c_pointer))
		end

	display_timer: INTEGER_32 assign set_display_timer
		do
			Result := c_display_timer (c_pointer)
		end

	more_files: PD_LIST_HEAD assign set_more_files
		do
			create Result.make_shared (c_more_files (c_pointer))
		end

	more_files_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct session, more_files);"
		end

	goto_position: CE_POINTER [NATURAL_8] assign set_goto_position
		do
			create Result.make_shared (c_goto_position (c_pointer))
		end

	imgmap_href_base: CE_POINTER [NATURAL_8] assign set_imgmap_href_base
		do
			create Result.make_shared (c_imgmap_href_base (c_pointer))
		end

	imgmap_target_base: CE_POINTER [NATURAL_8] assign set_imgmap_target_base
		do
			create Result.make_shared (c_imgmap_target_base (c_pointer))
		end

	ds: PD_DOCUMENT_SETUP assign set_ds
		do
			create Result.make_shared (c_ds (c_pointer))
		end

	ds_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct session, ds);"
		end

	kbdprefix: PD_KBDPREFIX assign set_kbdprefix
		do
			create Result.make_shared (c_kbdprefix (c_pointer))
		end

	reloadlevel: INTEGER_32 assign set_reloadlevel
		do
			Result := c_reloadlevel (c_pointer)
		end

	redirect_cnt: INTEGER_32 assign set_redirect_cnt
		do
			Result := c_redirect_cnt (c_pointer)
		end

	tq: PD_STATUS assign set_tq
		do
			create Result.make_shared (c_tq (c_pointer))
		end

	tq_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct session, tq);"
		end

	tq_url: CE_POINTER [NATURAL_8] assign set_tq_url
		do
			create Result.make_shared (c_tq_url (c_pointer))
		end

	tq_ce: CE_POINTER [PD_CACHE_ENTRY] assign set_tq_ce
		do
			create Result.make_shared (c_tq_ce (c_pointer))
		end

	tq_goto_position: CE_POINTER [NATURAL_8] assign set_tq_goto_position
		do
			create Result.make_shared (c_tq_goto_position (c_pointer))
		end

	tq_prog: CE_POINTER [NATURAL_8] assign set_tq_prog
		do
			create Result.make_shared (c_tq_prog (c_pointer))
		end

	tq_prog_flags: INTEGER_32 assign set_tq_prog_flags
		do
			Result := c_tq_prog_flags (c_pointer)
		end

	dn_url: CE_POINTER [NATURAL_8] assign set_dn_url
		do
			create Result.make_shared (c_dn_url (c_pointer))
		end

	dn_url_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct session, dn_url);"
		end

	search_word: CE_POINTER [NATURAL_8] assign set_search_word
		do
			create Result.make_shared (c_search_word (c_pointer))
		end

	search_word_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct session, search_word);"
		end

	last_search_word: CE_POINTER [NATURAL_8] assign set_last_search_word
		do
			create Result.make_shared (c_last_search_word (c_pointer))
		end

	search_direction: INTEGER_32 assign set_search_direction
		do
			Result := c_search_direction (c_pointer)
		end

	exit_query: INTEGER_32 assign set_exit_query
		do
			Result := c_exit_query (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_SESSION])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_SESSION])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_history (a_history: PD_LIST_HEAD)
		do
			history.ce_gets (a_history)
		end

	set_term (a_term: CE_POINTER [PD_TERMINAL])
		do
			c_set_term (c_pointer, a_term.c_pointer)
		end

	set_win (a_win: CE_POINTER [PD_WINDOW])
		do
			c_set_win (c_pointer, a_win.c_pointer)
		end

	set_id (a_id: INTEGER_32)
		do
			c_set_id (c_pointer, a_id)
		end

	set_screen (a_screen: CE_POINTER [PD_F_DATA_C])
		do
			c_set_screen (c_pointer, a_screen.c_pointer)
		end

	set_scrn_frames (a_scrn_frames: PD_LIST_HEAD)
		do
			scrn_frames.ce_gets (a_scrn_frames)
		end

	set_loading (a_loading: PD_STATUS)
		do
			loading.ce_gets (a_loading)
		end

	set_wtd (a_wtd: INTEGER_32)
		do
			c_set_wtd (c_pointer, a_wtd)
		end

	set_wtd_target (a_wtd_target: CE_POINTER [NATURAL_8])
		do
			c_set_wtd_target (c_pointer, a_wtd_target.c_pointer)
		end

	set_loading_url (a_loading_url: CE_POINTER [NATURAL_8])
		do
			c_set_loading_url (c_pointer, a_loading_url.c_pointer)
		end

	set_display_timer (a_display_timer: INTEGER_32)
		do
			c_set_display_timer (c_pointer, a_display_timer)
		end

	set_more_files (a_more_files: PD_LIST_HEAD)
		do
			more_files.ce_gets (a_more_files)
		end

	set_goto_position (a_goto_position: CE_POINTER [NATURAL_8])
		do
			c_set_goto_position (c_pointer, a_goto_position.c_pointer)
		end

	set_imgmap_href_base (a_imgmap_href_base: CE_POINTER [NATURAL_8])
		do
			c_set_imgmap_href_base (c_pointer, a_imgmap_href_base.c_pointer)
		end

	set_imgmap_target_base (a_imgmap_target_base: CE_POINTER [NATURAL_8])
		do
			c_set_imgmap_target_base (c_pointer, a_imgmap_target_base.c_pointer)
		end

	set_ds (a_ds: PD_DOCUMENT_SETUP)
		do
			ds.ce_gets (a_ds)
		end

	set_kbdprefix (a_kbdprefix: PD_KBDPREFIX)
		do
			kbdprefix.ce_gets (a_kbdprefix)
		end

	set_reloadlevel (a_reloadlevel: INTEGER_32)
		do
			c_set_reloadlevel (c_pointer, a_reloadlevel)
		end

	set_redirect_cnt (a_redirect_cnt: INTEGER_32)
		do
			c_set_redirect_cnt (c_pointer, a_redirect_cnt)
		end

	set_tq (a_tq: PD_STATUS)
		do
			tq.ce_gets (a_tq)
		end

	set_tq_url (a_tq_url: CE_POINTER [NATURAL_8])
		do
			c_set_tq_url (c_pointer, a_tq_url.c_pointer)
		end

	set_tq_ce (a_tq_ce: CE_POINTER [PD_CACHE_ENTRY])
		do
			c_set_tq_ce (c_pointer, a_tq_ce.c_pointer)
		end

	set_tq_goto_position (a_tq_goto_position: CE_POINTER [NATURAL_8])
		do
			c_set_tq_goto_position (c_pointer, a_tq_goto_position.c_pointer)
		end

	set_tq_prog (a_tq_prog: CE_POINTER [NATURAL_8])
		do
			c_set_tq_prog (c_pointer, a_tq_prog.c_pointer)
		end

	set_tq_prog_flags (a_tq_prog_flags: INTEGER_32)
		do
			c_set_tq_prog_flags (c_pointer, a_tq_prog_flags)
		end

	set_dn_url (a_dn_url: CE_POINTER [NATURAL_8])
		do
			c_set_dn_url (c_pointer, a_dn_url.c_pointer)
		end

	set_search_word (a_search_word: CE_POINTER [NATURAL_8])
		do
			c_set_search_word (c_pointer, a_search_word.c_pointer)
		end

	set_last_search_word (a_last_search_word: CE_POINTER [NATURAL_8])
		do
			c_set_last_search_word (c_pointer, a_last_search_word.c_pointer)
		end

	set_search_direction (a_search_direction: INTEGER_32)
		do
			c_set_search_direction (c_pointer, a_search_direction)
		end

	set_exit_query (a_exit_query: INTEGER_32)
		do
			c_set_exit_query (c_pointer, a_exit_query)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct session *)((struct session *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct session *)((struct session *)$tmp)->prev;"
		end

	c_history (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct list_head *)&((struct session *)$tmp)->history;"
		end

	c_term (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct terminal *)((struct session *)$tmp)->term;"
		end

	c_win (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct window *)((struct session *)$tmp)->win;"
		end

	c_id (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct session *)$tmp)->id;"
		end

	c_screen (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct f_data_c *)((struct session *)$tmp)->screen;"
		end

	c_scrn_frames (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct list_head *)&((struct session *)$tmp)->scrn_frames;"
		end

	c_loading (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct status *)&((struct session *)$tmp)->loading;"
		end

	c_wtd (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct session *)$tmp)->wtd;"
		end

	c_wtd_target (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct session *)$tmp)->wtd_target;"
		end

	c_loading_url (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct session *)$tmp)->loading_url;"
		end

	c_display_timer (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct session *)$tmp)->display_timer;"
		end

	c_more_files (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct list_head *)&((struct session *)$tmp)->more_files;"
		end

	c_goto_position (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct session *)$tmp)->goto_position;"
		end

	c_imgmap_href_base (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct session *)$tmp)->imgmap_href_base;"
		end

	c_imgmap_target_base (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct session *)$tmp)->imgmap_target_base;"
		end

	c_ds (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct document_setup *)&((struct session *)$tmp)->ds;"
		end

	c_kbdprefix (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct kbdprefix *)&((struct session *)$tmp)->kbdprefix;"
		end

	c_reloadlevel (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct session *)$tmp)->reloadlevel;"
		end

	c_redirect_cnt (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct session *)$tmp)->redirect_cnt;"
		end

	c_tq (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct status *)&((struct session *)$tmp)->tq;"
		end

	c_tq_url (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct session *)$tmp)->tq_url;"
		end

	c_tq_ce (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct cache_entry *)((struct session *)$tmp)->tq_ce;"
		end

	c_tq_goto_position (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct session *)$tmp)->tq_goto_position;"
		end

	c_tq_prog (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct session *)$tmp)->tq_prog;"
		end

	c_tq_prog_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct session *)$tmp)->tq_prog_flags;"
		end

	c_dn_url (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct session *)$tmp)->dn_url;"
		end

	c_search_word (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct session *)$tmp)->search_word;"
		end

	c_last_search_word (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct session *)$tmp)->last_search_word;"
		end

	c_search_direction (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct session *)$tmp)->search_direction;"
		end

	c_exit_query (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct session *)$tmp)->exit_query;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->next = (struct session *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->prev = (struct session *)$a_prev;"
		end

	c_set_term (tmp: POINTER; a_term: POINTER)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->term = (struct terminal *)$a_term;"
		end

	c_set_win (tmp: POINTER; a_win: POINTER)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->win = (struct window *)$a_win;"
		end

	c_set_id (tmp: POINTER; a_id: INTEGER_32)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->id = $a_id;"
		end

	c_set_screen (tmp: POINTER; a_screen: POINTER)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->screen = (struct f_data_c *)$a_screen;"
		end

	c_set_wtd (tmp: POINTER; a_wtd: INTEGER_32)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->wtd = $a_wtd;"
		end

	c_set_wtd_target (tmp: POINTER; a_wtd_target: POINTER)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->wtd_target = (unsigned char *)$a_wtd_target;"
		end

	c_set_loading_url (tmp: POINTER; a_loading_url: POINTER)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->loading_url = (unsigned char *)$a_loading_url;"
		end

	c_set_display_timer (tmp: POINTER; a_display_timer: INTEGER_32)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->display_timer = $a_display_timer;"
		end

	c_set_goto_position (tmp: POINTER; a_goto_position: POINTER)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->goto_position = (unsigned char *)$a_goto_position;"
		end

	c_set_imgmap_href_base (tmp: POINTER; a_imgmap_href_base: POINTER)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->imgmap_href_base = (unsigned char *)$a_imgmap_href_base;"
		end

	c_set_imgmap_target_base (tmp: POINTER; a_imgmap_target_base: POINTER)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->imgmap_target_base = (unsigned char *)$a_imgmap_target_base;"
		end

	c_set_reloadlevel (tmp: POINTER; a_reloadlevel: INTEGER_32)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->reloadlevel = $a_reloadlevel;"
		end

	c_set_redirect_cnt (tmp: POINTER; a_redirect_cnt: INTEGER_32)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->redirect_cnt = $a_redirect_cnt;"
		end

	c_set_tq_url (tmp: POINTER; a_tq_url: POINTER)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->tq_url = (unsigned char *)$a_tq_url;"
		end

	c_set_tq_ce (tmp: POINTER; a_tq_ce: POINTER)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->tq_ce = (struct cache_entry *)$a_tq_ce;"
		end

	c_set_tq_goto_position (tmp: POINTER; a_tq_goto_position: POINTER)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->tq_goto_position = (unsigned char *)$a_tq_goto_position;"
		end

	c_set_tq_prog (tmp: POINTER; a_tq_prog: POINTER)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->tq_prog = (unsigned char *)$a_tq_prog;"
		end

	c_set_tq_prog_flags (tmp: POINTER; a_tq_prog_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->tq_prog_flags = $a_tq_prog_flags;"
		end

	c_set_dn_url (tmp: POINTER; a_dn_url: POINTER)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->dn_url = (unsigned char *)$a_dn_url;"
		end

	c_set_search_word (tmp: POINTER; a_search_word: POINTER)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->search_word = (unsigned char *)$a_search_word;"
		end

	c_set_last_search_word (tmp: POINTER; a_last_search_word: POINTER)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->last_search_word = (unsigned char *)$a_last_search_word;"
		end

	c_set_search_direction (tmp: POINTER; a_search_direction: INTEGER_32)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->search_direction = $a_search_direction;"
		end

	c_set_exit_query (tmp: POINTER; a_exit_query: INTEGER_32)
		external
			"C inline"
		alias
			"((struct session *)$tmp)->exit_query = $a_exit_query;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct session);"
		end

end
