class
	PD_SIGNAL_HANDLER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	fn: CE_ROUTINE assign set_fn
		do
			create Result.make_shared (c_fn (c_pointer))
		end

	data: CE_POINTER [ANY] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	critical: INTEGER_32 assign set_critical
		do
			Result := c_critical (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_fn (a_fn: CE_ROUTINE)
		do
			c_set_fn (c_pointer, a_fn.c_pointer)
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_critical (a_critical: INTEGER_32)
		do
			c_set_critical (c_pointer, a_critical)
		end

feature {NONE} -- C getters

	c_fn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void *))((struct signal_handler *)$tmp)->fn;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct signal_handler *)$tmp)->data;"
		end

	c_critical (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct signal_handler *)$tmp)->critical;"
		end

feature {NONE} -- C setters

	c_set_fn (tmp: POINTER; a_fn: POINTER)
		external
			"C inline"
		alias
			"((struct signal_handler *)$tmp)->fn = (void( *)(void *))$a_fn;"
		end

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct signal_handler *)$tmp)->data = (void *)$a_data;"
		end

	c_set_critical (tmp: POINTER; a_critical: INTEGER_32)
		external
			"C inline"
		alias
			"((struct signal_handler *)$tmp)->critical = $a_critical;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct signal_handler);"
		end

end
