class
	PD_SMB_CONNECTION_INFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	client: INTEGER_32 assign set_client
		do
			Result := c_client (c_pointer)
		end

	list: INTEGER_32 assign set_list
		do
			Result := c_list (c_pointer)
		end

	cl: INTEGER_32 assign set_cl
		do
			Result := c_cl (c_pointer)
		end

	ntext: INTEGER_32 assign set_ntext
		do
			Result := c_ntext (c_pointer)
		end

	text: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_text (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_client (a_client: INTEGER_32)
		do
			c_set_client (c_pointer, a_client)
		end

	set_list (a_list: INTEGER_32)
		do
			c_set_list (c_pointer, a_list)
		end

	set_cl (a_cl: INTEGER_32)
		do
			c_set_cl (c_pointer, a_cl)
		end

	set_ntext (a_ntext: INTEGER_32)
		do
			c_set_ntext (c_pointer, a_ntext)
		end

feature {NONE} -- C getters

	c_client (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct smb_connection_info *)$tmp)->client;"
		end

	c_list (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct smb_connection_info *)$tmp)->list;"
		end

	c_cl (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct smb_connection_info *)$tmp)->cl;"
		end

	c_ntext (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct smb_connection_info *)$tmp)->ntext;"
		end

	c_text (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct smb_connection_info *tmp = (struct smb_connection_info *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->text) / sizeof(tmp->text[0]);
				return tmp->text;
			]"
		end

feature {NONE} -- C setters

	c_set_client (tmp: POINTER; a_client: INTEGER_32)
		external
			"C inline"
		alias
			"((struct smb_connection_info *)$tmp)->client = $a_client;"
		end

	c_set_list (tmp: POINTER; a_list: INTEGER_32)
		external
			"C inline"
		alias
			"((struct smb_connection_info *)$tmp)->list = $a_list;"
		end

	c_set_cl (tmp: POINTER; a_cl: INTEGER_32)
		external
			"C inline"
		alias
			"((struct smb_connection_info *)$tmp)->cl = $a_cl;"
		end

	c_set_ntext (tmp: POINTER; a_ntext: INTEGER_32)
		external
			"C inline"
		alias
			"((struct smb_connection_info *)$tmp)->ntext = $a_ntext;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct smb_connection_info);"
		end

end
