class
	PD_STATUS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_STATUS] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_STATUS] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	c: CE_POINTER [PD_CONNECTION] assign set_c
		do
			create Result.make_shared (c_c (c_pointer))
		end

	ce: CE_POINTER [PD_CACHE_ENTRY] assign set_ce
		do
			create Result.make_shared (c_ce (c_pointer))
		end

	state: INTEGER_32 assign set_state
		do
			Result := c_state (c_pointer)
		end

	prev_error: INTEGER_32 assign set_prev_error
		do
			Result := c_prev_error (c_pointer)
		end

	pri: INTEGER_32 assign set_pri
		do
			Result := c_pri (c_pointer)
		end

	end2: CE_ROUTINE assign set_end2
		do
			create Result.make_shared (c_end2 (c_pointer))
		end

	data: CE_POINTER [ANY] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	prg: CE_POINTER [PD_REMAINING_INFO] assign set_prg
		do
			create Result.make_shared (c_prg (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_STATUS])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_STATUS])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_c (a_c: CE_POINTER [PD_CONNECTION])
		do
			c_set_c (c_pointer, a_c.c_pointer)
		end

	set_ce (a_ce: CE_POINTER [PD_CACHE_ENTRY])
		do
			c_set_ce (c_pointer, a_ce.c_pointer)
		end

	set_state (a_state: INTEGER_32)
		do
			c_set_state (c_pointer, a_state)
		end

	set_prev_error (a_prev_error: INTEGER_32)
		do
			c_set_prev_error (c_pointer, a_prev_error)
		end

	set_pri (a_pri: INTEGER_32)
		do
			c_set_pri (c_pointer, a_pri)
		end

	set_end2 (a_end2: CE_ROUTINE)
		do
			c_set_end2 (c_pointer, a_end2.c_pointer)
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_prg (a_prg: CE_POINTER [PD_REMAINING_INFO])
		do
			c_set_prg (c_pointer, a_prg.c_pointer)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct status *)((struct status *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct status *)((struct status *)$tmp)->prev;"
		end

	c_c (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct connection *)((struct status *)$tmp)->c;"
		end

	c_ce (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct cache_entry *)((struct status *)$tmp)->ce;"
		end

	c_state (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct status *)$tmp)->state;"
		end

	c_prev_error (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct status *)$tmp)->prev_error;"
		end

	c_pri (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct status *)$tmp)->pri;"
		end

	c_end2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct status *, void *))((struct status *)$tmp)->end;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct status *)$tmp)->data;"
		end

	c_prg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct remaining_info *)((struct status *)$tmp)->prg;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct status *)$tmp)->next = (struct status *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct status *)$tmp)->prev = (struct status *)$a_prev;"
		end

	c_set_c (tmp: POINTER; a_c: POINTER)
		external
			"C inline"
		alias
			"((struct status *)$tmp)->c = (struct connection *)$a_c;"
		end

	c_set_ce (tmp: POINTER; a_ce: POINTER)
		external
			"C inline"
		alias
			"((struct status *)$tmp)->ce = (struct cache_entry *)$a_ce;"
		end

	c_set_state (tmp: POINTER; a_state: INTEGER_32)
		external
			"C inline"
		alias
			"((struct status *)$tmp)->state = $a_state;"
		end

	c_set_prev_error (tmp: POINTER; a_prev_error: INTEGER_32)
		external
			"C inline"
		alias
			"((struct status *)$tmp)->prev_error = $a_prev_error;"
		end

	c_set_pri (tmp: POINTER; a_pri: INTEGER_32)
		external
			"C inline"
		alias
			"((struct status *)$tmp)->pri = $a_pri;"
		end

	c_set_end2 (tmp: POINTER; a_end2: POINTER)
		external
			"C inline"
		alias
			"((struct status *)$tmp)->end = (void( *)(struct status *, void *))$a_end2;"
		end

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct status *)$tmp)->data = (void *)$a_data;"
		end

	c_set_prg (tmp: POINTER; a_prg: POINTER)
		external
			"C inline"
		alias
			"((struct status *)$tmp)->prg = (struct remaining_info *)$a_prg;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct status);"
		end

end
