class
	PD_STR2NUM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	str: CE_POINTER [NATURAL_8] assign set_str
		do
			create Result.make_shared (c_str (c_pointer))
		end

	num: INTEGER_32 assign set_num
		do
			Result := c_num (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_str (a_str: CE_POINTER [NATURAL_8])
		do
			c_set_str (c_pointer, a_str.c_pointer)
		end

	set_num (a_num: INTEGER_32)
		do
			c_set_num (c_pointer, a_num)
		end

feature {NONE} -- C getters

	c_str (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct str2num *)$tmp)->str;"
		end

	c_num (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct str2num *)$tmp)->num;"
		end

feature {NONE} -- C setters

	c_set_str (tmp: POINTER; a_str: POINTER)
		external
			"C inline"
		alias
			"((struct str2num *)$tmp)->str = (unsigned char *)$a_str;"
		end

	c_set_num (tmp: POINTER; a_num: INTEGER_32)
		external
			"C inline"
		alias
			"((struct str2num *)$tmp)->num = $a_num;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct str2num);"
		end

end
