class
	PD_TABLE_CACHE_ENTRY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_TABLE_CACHE_ENTRY] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_TABLE_CACHE_ENTRY] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	hash_next: CE_POINTER [PD_TABLE_CACHE_ENTRY] assign set_hash_next
		do
			create Result.make_shared (c_hash_next (c_pointer))
		end

	start: CE_POINTER [NATURAL_8] assign set_start
		do
			create Result.make_shared (c_start (c_pointer))
		end

	end2: CE_POINTER [NATURAL_8] assign set_end2
		do
			create Result.make_shared (c_end2 (c_pointer))
		end

	align: INTEGER_32 assign set_align
		do
			Result := c_align (c_pointer)
		end

	m: INTEGER_32 assign set_m
		do
			Result := c_m (c_pointer)
		end

	width: INTEGER_32 assign set_width
		do
			Result := c_width (c_pointer)
		end

	xs: INTEGER_32 assign set_xs
		do
			Result := c_xs (c_pointer)
		end

	link_num: INTEGER_32 assign set_link_num
		do
			Result := c_link_num (c_pointer)
		end

	p: PD_PART assign set_p
		do
			create Result.make_shared (c_p (c_pointer))
		end

	p_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct table_cache_entry, p);"
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_TABLE_CACHE_ENTRY])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_TABLE_CACHE_ENTRY])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_hash_next (a_hash_next: CE_POINTER [PD_TABLE_CACHE_ENTRY])
		do
			c_set_hash_next (c_pointer, a_hash_next.c_pointer)
		end

	set_start (a_start: CE_POINTER [NATURAL_8])
		do
			c_set_start (c_pointer, a_start.c_pointer)
		end

	set_end2 (a_end2: CE_POINTER [NATURAL_8])
		do
			c_set_end2 (c_pointer, a_end2.c_pointer)
		end

	set_align (a_align: INTEGER_32)
		do
			c_set_align (c_pointer, a_align)
		end

	set_m (a_m: INTEGER_32)
		do
			c_set_m (c_pointer, a_m)
		end

	set_width (a_width: INTEGER_32)
		do
			c_set_width (c_pointer, a_width)
		end

	set_xs (a_xs: INTEGER_32)
		do
			c_set_xs (c_pointer, a_xs)
		end

	set_link_num (a_link_num: INTEGER_32)
		do
			c_set_link_num (c_pointer, a_link_num)
		end

	set_p (a_p: PD_PART)
		do
			p.ce_gets (a_p)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct table_cache_entry *)((struct table_cache_entry *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct table_cache_entry *)((struct table_cache_entry *)$tmp)->prev;"
		end

	c_hash_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct table_cache_entry *)((struct table_cache_entry *)$tmp)->hash_next;"
		end

	c_start (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct table_cache_entry *)$tmp)->start;"
		end

	c_end2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct table_cache_entry *)$tmp)->end;"
		end

	c_align (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cache_entry *)$tmp)->align;"
		end

	c_m (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cache_entry *)$tmp)->m;"
		end

	c_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cache_entry *)$tmp)->width;"
		end

	c_xs (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cache_entry *)$tmp)->xs;"
		end

	c_link_num (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cache_entry *)$tmp)->link_num;"
		end

	c_p (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct part *)&((struct table_cache_entry *)$tmp)->p;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct table_cache_entry *)$tmp)->next = (struct table_cache_entry *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct table_cache_entry *)$tmp)->prev = (struct table_cache_entry *)$a_prev;"
		end

	c_set_hash_next (tmp: POINTER; a_hash_next: POINTER)
		external
			"C inline"
		alias
			"((struct table_cache_entry *)$tmp)->hash_next = (struct table_cache_entry *)$a_hash_next;"
		end

	c_set_start (tmp: POINTER; a_start: POINTER)
		external
			"C inline"
		alias
			"((struct table_cache_entry *)$tmp)->start = (unsigned char *)$a_start;"
		end

	c_set_end2 (tmp: POINTER; a_end2: POINTER)
		external
			"C inline"
		alias
			"((struct table_cache_entry *)$tmp)->end = (unsigned char *)$a_end2;"
		end

	c_set_align (tmp: POINTER; a_align: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cache_entry *)$tmp)->align = $a_align;"
		end

	c_set_m (tmp: POINTER; a_m: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cache_entry *)$tmp)->m = $a_m;"
		end

	c_set_width (tmp: POINTER; a_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cache_entry *)$tmp)->width = $a_width;"
		end

	c_set_xs (tmp: POINTER; a_xs: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cache_entry *)$tmp)->xs = $a_xs;"
		end

	c_set_link_num (tmp: POINTER; a_link_num: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cache_entry *)$tmp)->link_num = $a_link_num;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct table_cache_entry);"
		end

end
