class
	PD_TABLE_CELL

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	used: INTEGER_32 assign set_used
		do
			Result := c_used (c_pointer)
		end

	spanned: INTEGER_32 assign set_spanned
		do
			Result := c_spanned (c_pointer)
		end

	mx: INTEGER_32 assign set_mx
		do
			Result := c_mx (c_pointer)
		end

	my: INTEGER_32 assign set_my
		do
			Result := c_my (c_pointer)
		end

	start: CE_POINTER [NATURAL_8] assign set_start
		do
			create Result.make_shared (c_start (c_pointer))
		end

	end2: CE_POINTER [NATURAL_8] assign set_end2
		do
			create Result.make_shared (c_end2 (c_pointer))
		end

	align: INTEGER_32 assign set_align
		do
			Result := c_align (c_pointer)
		end

	align_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct table_cell, align);"
		end

	valign: INTEGER_32 assign set_valign
		do
			Result := c_valign (c_pointer)
		end

	valign_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct table_cell, valign);"
		end

	b: INTEGER_32 assign set_b
		do
			Result := c_b (c_pointer)
		end

	bgcolor: PD_RGB assign set_bgcolor
		do
			create Result.make_shared (c_bgcolor (c_pointer))
		end

	bgcolor_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct table_cell, bgcolor);"
		end

	group: INTEGER_32 assign set_group
		do
			Result := c_group (c_pointer)
		end

	colspan: INTEGER_32 assign set_colspan
		do
			Result := c_colspan (c_pointer)
		end

	rowspan: INTEGER_32 assign set_rowspan
		do
			Result := c_rowspan (c_pointer)
		end

	min_width: INTEGER_32 assign set_min_width
		do
			Result := c_min_width (c_pointer)
		end

	min_width_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct table_cell, min_width);"
		end

	max_width: INTEGER_32 assign set_max_width
		do
			Result := c_max_width (c_pointer)
		end

	max_width_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct table_cell, max_width);"
		end

	x_width: INTEGER_32 assign set_x_width
		do
			Result := c_x_width (c_pointer)
		end

	x_width_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct table_cell, x_width);"
		end

	height: INTEGER_32 assign set_height
		do
			Result := c_height (c_pointer)
		end

	xpos: INTEGER_32 assign set_xpos
		do
			Result := c_xpos (c_pointer)
		end

	ypos: INTEGER_32 assign set_ypos
		do
			Result := c_ypos (c_pointer)
		end

	xw: INTEGER_32 assign set_xw
		do
			Result := c_xw (c_pointer)
		end

	yw: INTEGER_32 assign set_yw
		do
			Result := c_yw (c_pointer)
		end

	link_num: INTEGER_32 assign set_link_num
		do
			Result := c_link_num (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_used (a_used: INTEGER_32)
		do
			c_set_used (c_pointer, a_used)
		end

	set_spanned (a_spanned: INTEGER_32)
		do
			c_set_spanned (c_pointer, a_spanned)
		end

	set_mx (a_mx: INTEGER_32)
		do
			c_set_mx (c_pointer, a_mx)
		end

	set_my (a_my: INTEGER_32)
		do
			c_set_my (c_pointer, a_my)
		end

	set_start (a_start: CE_POINTER [NATURAL_8])
		do
			c_set_start (c_pointer, a_start.c_pointer)
		end

	set_end2 (a_end2: CE_POINTER [NATURAL_8])
		do
			c_set_end2 (c_pointer, a_end2.c_pointer)
		end

	set_align (a_align: INTEGER_32)
		do
			c_set_align (c_pointer, a_align)
		end

	set_valign (a_valign: INTEGER_32)
		do
			c_set_valign (c_pointer, a_valign)
		end

	set_b (a_b: INTEGER_32)
		do
			c_set_b (c_pointer, a_b)
		end

	set_bgcolor (a_bgcolor: PD_RGB)
		do
			bgcolor.ce_gets (a_bgcolor)
		end

	set_group (a_group: INTEGER_32)
		do
			c_set_group (c_pointer, a_group)
		end

	set_colspan (a_colspan: INTEGER_32)
		do
			c_set_colspan (c_pointer, a_colspan)
		end

	set_rowspan (a_rowspan: INTEGER_32)
		do
			c_set_rowspan (c_pointer, a_rowspan)
		end

	set_min_width (a_min_width: INTEGER_32)
		do
			c_set_min_width (c_pointer, a_min_width)
		end

	set_max_width (a_max_width: INTEGER_32)
		do
			c_set_max_width (c_pointer, a_max_width)
		end

	set_x_width (a_x_width: INTEGER_32)
		do
			c_set_x_width (c_pointer, a_x_width)
		end

	set_height (a_height: INTEGER_32)
		do
			c_set_height (c_pointer, a_height)
		end

	set_xpos (a_xpos: INTEGER_32)
		do
			c_set_xpos (c_pointer, a_xpos)
		end

	set_ypos (a_ypos: INTEGER_32)
		do
			c_set_ypos (c_pointer, a_ypos)
		end

	set_xw (a_xw: INTEGER_32)
		do
			c_set_xw (c_pointer, a_xw)
		end

	set_yw (a_yw: INTEGER_32)
		do
			c_set_yw (c_pointer, a_yw)
		end

	set_link_num (a_link_num: INTEGER_32)
		do
			c_set_link_num (c_pointer, a_link_num)
		end

feature {NONE} -- C getters

	c_used (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cell *)$tmp)->used;"
		end

	c_spanned (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cell *)$tmp)->spanned;"
		end

	c_mx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cell *)$tmp)->mx;"
		end

	c_my (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cell *)$tmp)->my;"
		end

	c_start (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct table_cell *)$tmp)->start;"
		end

	c_end2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct table_cell *)$tmp)->end;"
		end

	c_align (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cell *)$tmp)->align;"
		end

	c_valign (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cell *)$tmp)->valign;"
		end

	c_b (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cell *)$tmp)->b;"
		end

	c_bgcolor (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct rgb *)&((struct table_cell *)$tmp)->bgcolor;"
		end

	c_group (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cell *)$tmp)->group;"
		end

	c_colspan (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cell *)$tmp)->colspan;"
		end

	c_rowspan (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cell *)$tmp)->rowspan;"
		end

	c_min_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cell *)$tmp)->min_width;"
		end

	c_max_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cell *)$tmp)->max_width;"
		end

	c_x_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cell *)$tmp)->x_width;"
		end

	c_height (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cell *)$tmp)->height;"
		end

	c_xpos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cell *)$tmp)->xpos;"
		end

	c_ypos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cell *)$tmp)->ypos;"
		end

	c_xw (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cell *)$tmp)->xw;"
		end

	c_yw (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cell *)$tmp)->yw;"
		end

	c_link_num (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_cell *)$tmp)->link_num;"
		end

feature {NONE} -- C setters

	c_set_used (tmp: POINTER; a_used: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cell *)$tmp)->used = $a_used;"
		end

	c_set_spanned (tmp: POINTER; a_spanned: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cell *)$tmp)->spanned = $a_spanned;"
		end

	c_set_mx (tmp: POINTER; a_mx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cell *)$tmp)->mx = $a_mx;"
		end

	c_set_my (tmp: POINTER; a_my: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cell *)$tmp)->my = $a_my;"
		end

	c_set_start (tmp: POINTER; a_start: POINTER)
		external
			"C inline"
		alias
			"((struct table_cell *)$tmp)->start = (unsigned char *)$a_start;"
		end

	c_set_end2 (tmp: POINTER; a_end2: POINTER)
		external
			"C inline"
		alias
			"((struct table_cell *)$tmp)->end = (unsigned char *)$a_end2;"
		end

	c_set_align (tmp: POINTER; a_align: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cell *)$tmp)->align = $a_align;"
		end

	c_set_valign (tmp: POINTER; a_valign: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cell *)$tmp)->valign = $a_valign;"
		end

	c_set_b (tmp: POINTER; a_b: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cell *)$tmp)->b = $a_b;"
		end

	c_set_group (tmp: POINTER; a_group: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cell *)$tmp)->group = $a_group;"
		end

	c_set_colspan (tmp: POINTER; a_colspan: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cell *)$tmp)->colspan = $a_colspan;"
		end

	c_set_rowspan (tmp: POINTER; a_rowspan: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cell *)$tmp)->rowspan = $a_rowspan;"
		end

	c_set_min_width (tmp: POINTER; a_min_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cell *)$tmp)->min_width = $a_min_width;"
		end

	c_set_max_width (tmp: POINTER; a_max_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cell *)$tmp)->max_width = $a_max_width;"
		end

	c_set_x_width (tmp: POINTER; a_x_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cell *)$tmp)->x_width = $a_x_width;"
		end

	c_set_height (tmp: POINTER; a_height: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cell *)$tmp)->height = $a_height;"
		end

	c_set_xpos (tmp: POINTER; a_xpos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cell *)$tmp)->xpos = $a_xpos;"
		end

	c_set_ypos (tmp: POINTER; a_ypos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cell *)$tmp)->ypos = $a_ypos;"
		end

	c_set_xw (tmp: POINTER; a_xw: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cell *)$tmp)->xw = $a_xw;"
		end

	c_set_yw (tmp: POINTER; a_yw: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cell *)$tmp)->yw = $a_yw;"
		end

	c_set_link_num (tmp: POINTER; a_link_num: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_cell *)$tmp)->link_num = $a_link_num;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct table_cell);"
		end

end
