class
	PD_TERM_SPEC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_TERM_SPEC] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_TERM_SPEC] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	term: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_term (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	mode: INTEGER_32 assign set_mode
		do
			Result := c_mode (c_pointer)
		end

	mode_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct term_spec, mode);"
		end

	m11_hack: INTEGER_32 assign set_m11_hack
		do
			Result := c_m11_hack (c_pointer)
		end

	m11_hack_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct term_spec, m11_hack);"
		end

	restrict_852: INTEGER_32 assign set_restrict_852
		do
			Result := c_restrict_852 (c_pointer)
		end

	restrict_852_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct term_spec, restrict_852);"
		end

	block_cursor: INTEGER_32 assign set_block_cursor
		do
			Result := c_block_cursor (c_pointer)
		end

	block_cursor_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct term_spec, block_cursor);"
		end

	col: INTEGER_32 assign set_col
		do
			Result := c_col (c_pointer)
		end

	col_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct term_spec, col);"
		end

	charset: INTEGER_32 assign set_charset
		do
			Result := c_charset (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_TERM_SPEC])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_TERM_SPEC])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_mode (a_mode: INTEGER_32)
		do
			c_set_mode (c_pointer, a_mode)
		end

	set_m11_hack (a_m11_hack: INTEGER_32)
		do
			c_set_m11_hack (c_pointer, a_m11_hack)
		end

	set_restrict_852 (a_restrict_852: INTEGER_32)
		do
			c_set_restrict_852 (c_pointer, a_restrict_852)
		end

	set_block_cursor (a_block_cursor: INTEGER_32)
		do
			c_set_block_cursor (c_pointer, a_block_cursor)
		end

	set_col (a_col: INTEGER_32)
		do
			c_set_col (c_pointer, a_col)
		end

	set_charset (a_charset: INTEGER_32)
		do
			c_set_charset (c_pointer, a_charset)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct term_spec *)((struct term_spec *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct term_spec *)((struct term_spec *)$tmp)->prev;"
		end

	c_term (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct term_spec *tmp = (struct term_spec *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->term) / sizeof(tmp->term[0]);
				return tmp->term;
			]"
		end

	c_mode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct term_spec *)$tmp)->mode;"
		end

	c_m11_hack (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct term_spec *)$tmp)->m11_hack;"
		end

	c_restrict_852 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct term_spec *)$tmp)->restrict_852;"
		end

	c_block_cursor (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct term_spec *)$tmp)->block_cursor;"
		end

	c_col (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct term_spec *)$tmp)->col;"
		end

	c_charset (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct term_spec *)$tmp)->charset;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct term_spec *)$tmp)->next = (struct term_spec *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct term_spec *)$tmp)->prev = (struct term_spec *)$a_prev;"
		end

	c_set_mode (tmp: POINTER; a_mode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct term_spec *)$tmp)->mode = $a_mode;"
		end

	c_set_m11_hack (tmp: POINTER; a_m11_hack: INTEGER_32)
		external
			"C inline"
		alias
			"((struct term_spec *)$tmp)->m11_hack = $a_m11_hack;"
		end

	c_set_restrict_852 (tmp: POINTER; a_restrict_852: INTEGER_32)
		external
			"C inline"
		alias
			"((struct term_spec *)$tmp)->restrict_852 = $a_restrict_852;"
		end

	c_set_block_cursor (tmp: POINTER; a_block_cursor: INTEGER_32)
		external
			"C inline"
		alias
			"((struct term_spec *)$tmp)->block_cursor = $a_block_cursor;"
		end

	c_set_col (tmp: POINTER; a_col: INTEGER_32)
		external
			"C inline"
		alias
			"((struct term_spec *)$tmp)->col = $a_col;"
		end

	c_set_charset (tmp: POINTER; a_charset: INTEGER_32)
		external
			"C inline"
		alias
			"((struct term_spec *)$tmp)->charset = $a_charset;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct term_spec);"
		end

end
