class
	PD_TERMINAL

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_TERMINAL] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_TERMINAL] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	master: INTEGER_32 assign set_master
		do
			Result := c_master (c_pointer)
		end

	fdin: INTEGER_32 assign set_fdin
		do
			Result := c_fdin (c_pointer)
		end

	fdout: INTEGER_32 assign set_fdout
		do
			Result := c_fdout (c_pointer)
		end

	x: INTEGER_32 assign set_x
		do
			Result := c_x (c_pointer)
		end

	y: INTEGER_32 assign set_y
		do
			Result := c_y (c_pointer)
		end

	environment: INTEGER_32 assign set_environment
		do
			Result := c_environment (c_pointer)
		end

	term: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_term (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	cwd: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_cwd (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	screen: CE_POINTER [NATURAL_32] assign set_screen
		do
			create Result.make_shared (c_screen (c_pointer))
		end

	last_screen: CE_POINTER [NATURAL_32] assign set_last_screen
		do
			create Result.make_shared (c_last_screen (c_pointer))
		end

	spec: CE_POINTER [PD_TERM_SPEC] assign set_spec
		do
			create Result.make_shared (c_spec (c_pointer))
		end

	cx: INTEGER_32 assign set_cx
		do
			Result := c_cx (c_pointer)
		end

	cy: INTEGER_32 assign set_cy
		do
			Result := c_cy (c_pointer)
		end

	lcx: INTEGER_32 assign set_lcx
		do
			Result := c_lcx (c_pointer)
		end

	lcy: INTEGER_32 assign set_lcy
		do
			Result := c_lcy (c_pointer)
		end

	dirty: INTEGER_32 assign set_dirty
		do
			Result := c_dirty (c_pointer)
		end

	redrawing: INTEGER_32 assign set_redrawing
		do
			Result := c_redrawing (c_pointer)
		end

	blocked: INTEGER_32 assign set_blocked
		do
			Result := c_blocked (c_pointer)
		end

	input_queue: CE_POINTER [NATURAL_8] assign set_input_queue
		do
			create Result.make_shared (c_input_queue (c_pointer))
		end

	qlen: INTEGER_32 assign set_qlen
		do
			Result := c_qlen (c_pointer)
		end

	windows: PD_LIST_HEAD assign set_windows
		do
			create Result.make_shared (c_windows (c_pointer))
		end

	windows_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct terminal, windows);"
		end

	title: CE_POINTER [NATURAL_8] assign set_title
		do
			create Result.make_shared (c_title (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_TERMINAL])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_TERMINAL])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_master (a_master: INTEGER_32)
		do
			c_set_master (c_pointer, a_master)
		end

	set_fdin (a_fdin: INTEGER_32)
		do
			c_set_fdin (c_pointer, a_fdin)
		end

	set_fdout (a_fdout: INTEGER_32)
		do
			c_set_fdout (c_pointer, a_fdout)
		end

	set_x (a_x: INTEGER_32)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: INTEGER_32)
		do
			c_set_y (c_pointer, a_y)
		end

	set_environment (a_environment: INTEGER_32)
		do
			c_set_environment (c_pointer, a_environment)
		end

	set_screen (a_screen: CE_POINTER [NATURAL_32])
		do
			c_set_screen (c_pointer, a_screen.c_pointer)
		end

	set_last_screen (a_last_screen: CE_POINTER [NATURAL_32])
		do
			c_set_last_screen (c_pointer, a_last_screen.c_pointer)
		end

	set_spec (a_spec: CE_POINTER [PD_TERM_SPEC])
		do
			c_set_spec (c_pointer, a_spec.c_pointer)
		end

	set_cx (a_cx: INTEGER_32)
		do
			c_set_cx (c_pointer, a_cx)
		end

	set_cy (a_cy: INTEGER_32)
		do
			c_set_cy (c_pointer, a_cy)
		end

	set_lcx (a_lcx: INTEGER_32)
		do
			c_set_lcx (c_pointer, a_lcx)
		end

	set_lcy (a_lcy: INTEGER_32)
		do
			c_set_lcy (c_pointer, a_lcy)
		end

	set_dirty (a_dirty: INTEGER_32)
		do
			c_set_dirty (c_pointer, a_dirty)
		end

	set_redrawing (a_redrawing: INTEGER_32)
		do
			c_set_redrawing (c_pointer, a_redrawing)
		end

	set_blocked (a_blocked: INTEGER_32)
		do
			c_set_blocked (c_pointer, a_blocked)
		end

	set_input_queue (a_input_queue: CE_POINTER [NATURAL_8])
		do
			c_set_input_queue (c_pointer, a_input_queue.c_pointer)
		end

	set_qlen (a_qlen: INTEGER_32)
		do
			c_set_qlen (c_pointer, a_qlen)
		end

	set_windows (a_windows: PD_LIST_HEAD)
		do
			windows.ce_gets (a_windows)
		end

	set_title (a_title: CE_POINTER [NATURAL_8])
		do
			c_set_title (c_pointer, a_title.c_pointer)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct terminal *)((struct terminal *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct terminal *)((struct terminal *)$tmp)->prev;"
		end

	c_master (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct terminal *)$tmp)->master;"
		end

	c_fdin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct terminal *)$tmp)->fdin;"
		end

	c_fdout (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct terminal *)$tmp)->fdout;"
		end

	c_x (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct terminal *)$tmp)->x;"
		end

	c_y (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct terminal *)$tmp)->y;"
		end

	c_environment (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct terminal *)$tmp)->environment;"
		end

	c_term (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct terminal *tmp = (struct terminal *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->term) / sizeof(tmp->term[0]);
				return tmp->term;
			]"
		end

	c_cwd (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct terminal *tmp = (struct terminal *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->cwd) / sizeof(tmp->cwd[0]);
				return tmp->cwd;
			]"
		end

	c_screen (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned int *)((struct terminal *)$tmp)->screen;"
		end

	c_last_screen (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned int *)((struct terminal *)$tmp)->last_screen;"
		end

	c_spec (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct term_spec *)((struct terminal *)$tmp)->spec;"
		end

	c_cx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct terminal *)$tmp)->cx;"
		end

	c_cy (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct terminal *)$tmp)->cy;"
		end

	c_lcx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct terminal *)$tmp)->lcx;"
		end

	c_lcy (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct terminal *)$tmp)->lcy;"
		end

	c_dirty (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct terminal *)$tmp)->dirty;"
		end

	c_redrawing (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct terminal *)$tmp)->redrawing;"
		end

	c_blocked (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct terminal *)$tmp)->blocked;"
		end

	c_input_queue (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct terminal *)$tmp)->input_queue;"
		end

	c_qlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct terminal *)$tmp)->qlen;"
		end

	c_windows (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct list_head *)&((struct terminal *)$tmp)->windows;"
		end

	c_title (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct terminal *)$tmp)->title;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct terminal *)$tmp)->next = (struct terminal *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct terminal *)$tmp)->prev = (struct terminal *)$a_prev;"
		end

	c_set_master (tmp: POINTER; a_master: INTEGER_32)
		external
			"C inline"
		alias
			"((struct terminal *)$tmp)->master = $a_master;"
		end

	c_set_fdin (tmp: POINTER; a_fdin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct terminal *)$tmp)->fdin = $a_fdin;"
		end

	c_set_fdout (tmp: POINTER; a_fdout: INTEGER_32)
		external
			"C inline"
		alias
			"((struct terminal *)$tmp)->fdout = $a_fdout;"
		end

	c_set_x (tmp: POINTER; a_x: INTEGER_32)
		external
			"C inline"
		alias
			"((struct terminal *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: INTEGER_32)
		external
			"C inline"
		alias
			"((struct terminal *)$tmp)->y = $a_y;"
		end

	c_set_environment (tmp: POINTER; a_environment: INTEGER_32)
		external
			"C inline"
		alias
			"((struct terminal *)$tmp)->environment = $a_environment;"
		end

	c_set_screen (tmp: POINTER; a_screen: POINTER)
		external
			"C inline"
		alias
			"((struct terminal *)$tmp)->screen = (unsigned int *)$a_screen;"
		end

	c_set_last_screen (tmp: POINTER; a_last_screen: POINTER)
		external
			"C inline"
		alias
			"((struct terminal *)$tmp)->last_screen = (unsigned int *)$a_last_screen;"
		end

	c_set_spec (tmp: POINTER; a_spec: POINTER)
		external
			"C inline"
		alias
			"((struct terminal *)$tmp)->spec = (struct term_spec *)$a_spec;"
		end

	c_set_cx (tmp: POINTER; a_cx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct terminal *)$tmp)->cx = $a_cx;"
		end

	c_set_cy (tmp: POINTER; a_cy: INTEGER_32)
		external
			"C inline"
		alias
			"((struct terminal *)$tmp)->cy = $a_cy;"
		end

	c_set_lcx (tmp: POINTER; a_lcx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct terminal *)$tmp)->lcx = $a_lcx;"
		end

	c_set_lcy (tmp: POINTER; a_lcy: INTEGER_32)
		external
			"C inline"
		alias
			"((struct terminal *)$tmp)->lcy = $a_lcy;"
		end

	c_set_dirty (tmp: POINTER; a_dirty: INTEGER_32)
		external
			"C inline"
		alias
			"((struct terminal *)$tmp)->dirty = $a_dirty;"
		end

	c_set_redrawing (tmp: POINTER; a_redrawing: INTEGER_32)
		external
			"C inline"
		alias
			"((struct terminal *)$tmp)->redrawing = $a_redrawing;"
		end

	c_set_blocked (tmp: POINTER; a_blocked: INTEGER_32)
		external
			"C inline"
		alias
			"((struct terminal *)$tmp)->blocked = $a_blocked;"
		end

	c_set_input_queue (tmp: POINTER; a_input_queue: POINTER)
		external
			"C inline"
		alias
			"((struct terminal *)$tmp)->input_queue = (unsigned char *)$a_input_queue;"
		end

	c_set_qlen (tmp: POINTER; a_qlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct terminal *)$tmp)->qlen = $a_qlen;"
		end

	c_set_title (tmp: POINTER; a_title: POINTER)
		external
			"C inline"
		alias
			"((struct terminal *)$tmp)->title = (unsigned char *)$a_title;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct terminal);"
		end

end
