class
	PD_THREAD

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	read_func: CE_ROUTINE assign set_read_func
		do
			create Result.make_shared (c_read_func (c_pointer))
		end

	write_func: CE_ROUTINE assign set_write_func
		do
			create Result.make_shared (c_write_func (c_pointer))
		end

	error_func: CE_ROUTINE assign set_error_func
		do
			create Result.make_shared (c_error_func (c_pointer))
		end

	data: CE_POINTER [ANY] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_read_func (a_read_func: CE_ROUTINE)
		do
			c_set_read_func (c_pointer, a_read_func.c_pointer)
		end

	set_write_func (a_write_func: CE_ROUTINE)
		do
			c_set_write_func (c_pointer, a_write_func.c_pointer)
		end

	set_error_func (a_error_func: CE_ROUTINE)
		do
			c_set_error_func (c_pointer, a_error_func.c_pointer)
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

feature {NONE} -- C getters

	c_read_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void *))((struct thread *)$tmp)->read_func;"
		end

	c_write_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void *))((struct thread *)$tmp)->write_func;"
		end

	c_error_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void *))((struct thread *)$tmp)->error_func;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct thread *)$tmp)->data;"
		end

feature {NONE} -- C setters

	c_set_read_func (tmp: POINTER; a_read_func: POINTER)
		external
			"C inline"
		alias
			"((struct thread *)$tmp)->read_func = (void( *)(void *))$a_read_func;"
		end

	c_set_write_func (tmp: POINTER; a_write_func: POINTER)
		external
			"C inline"
		alias
			"((struct thread *)$tmp)->write_func = (void( *)(void *))$a_write_func;"
		end

	c_set_error_func (tmp: POINTER; a_error_func: POINTER)
		external
			"C inline"
		alias
			"((struct thread *)$tmp)->error_func = (void( *)(void *))$a_error_func;"
		end

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct thread *)$tmp)->data = (void *)$a_data;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct thread);"
		end

end
