class
	PD_TIMER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_TIMER] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_TIMER] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	interval: INTEGER_32 assign set_interval
		do
			Result := c_interval (c_pointer)
		end

	func: CE_ROUTINE assign set_func
		do
			create Result.make_shared (c_func (c_pointer))
		end

	data: CE_POINTER [ANY] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	id: INTEGER_32 assign set_id
		do
			Result := c_id (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_TIMER])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_TIMER])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_interval (a_interval: INTEGER_32)
		do
			c_set_interval (c_pointer, a_interval)
		end

	set_func (a_func: CE_ROUTINE)
		do
			c_set_func (c_pointer, a_func.c_pointer)
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_id (a_id: INTEGER_32)
		do
			c_set_id (c_pointer, a_id)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct timer *)((struct timer *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct timer *)((struct timer *)$tmp)->prev;"
		end

	c_interval (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct timer *)$tmp)->interval;"
		end

	c_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void *))((struct timer *)$tmp)->func;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct timer *)$tmp)->data;"
		end

	c_id (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct timer *)$tmp)->id;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct timer *)$tmp)->next = (struct timer *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct timer *)$tmp)->prev = (struct timer *)$a_prev;"
		end

	c_set_interval (tmp: POINTER; a_interval: INTEGER_32)
		external
			"C inline"
		alias
			"((struct timer *)$tmp)->interval = $a_interval;"
		end

	c_set_func (tmp: POINTER; a_func: POINTER)
		external
			"C inline"
		alias
			"((struct timer *)$tmp)->func = (void( *)(void *))$a_func;"
		end

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct timer *)$tmp)->data = (void *)$a_data;"
		end

	c_set_id (tmp: POINTER; a_id: INTEGER_32)
		external
			"C inline"
		alias
			"((struct timer *)$tmp)->id = $a_id;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct timer);"
		end

end
