class
	PD_TRANSLATION

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	code: INTEGER_32 assign set_code
		do
			Result := c_code (c_pointer)
		end

	name: CE_POINTER [NATURAL_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_code (a_code: INTEGER_32)
		do
			c_set_code (c_pointer, a_code)
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

feature {NONE} -- C getters

	c_code (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct translation *)$tmp)->code;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct translation *)$tmp)->name;"
		end

feature {NONE} -- C setters

	c_set_code (tmp: POINTER; a_code: INTEGER_32)
		external
			"C inline"
		alias
			"((struct translation *)$tmp)->code = $a_code;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct translation *)$tmp)->name = (unsigned char *)$a_name;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct translation);"
		end

end
