class
	PD_VIEW_STATE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	view_pos: INTEGER_32 assign set_view_pos
		do
			Result := c_view_pos (c_pointer)
		end

	view_posx: INTEGER_32 assign set_view_posx
		do
			Result := c_view_posx (c_pointer)
		end

	orig_view_pos: INTEGER_32 assign set_orig_view_pos
		do
			Result := c_orig_view_pos (c_pointer)
		end

	orig_view_posx: INTEGER_32 assign set_orig_view_posx
		do
			Result := c_orig_view_posx (c_pointer)
		end

	current_link: INTEGER_32 assign set_current_link
		do
			Result := c_current_link (c_pointer)
		end

	current_link_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct view_state, current_link);"
		end

	orig_link: INTEGER_32 assign set_orig_link
		do
			Result := c_orig_link (c_pointer)
		end

	plain: INTEGER_32 assign set_plain
		do
			Result := c_plain (c_pointer)
		end

	goto_position: CE_POINTER [NATURAL_8] assign set_goto_position
		do
			create Result.make_shared (c_goto_position (c_pointer))
		end

	goto_position_end: CE_POINTER [NATURAL_8] assign set_goto_position_end
		do
			create Result.make_shared (c_goto_position_end (c_pointer))
		end

	form_info: CE_POINTER [PD_FORM_STATE] assign set_form_info
		do
			create Result.make_shared (c_form_info (c_pointer))
		end

	form_info_len: INTEGER_32 assign set_form_info_len
		do
			Result := c_form_info_len (c_pointer)
		end

	url: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_url (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_view_pos (a_view_pos: INTEGER_32)
		do
			c_set_view_pos (c_pointer, a_view_pos)
		end

	set_view_posx (a_view_posx: INTEGER_32)
		do
			c_set_view_posx (c_pointer, a_view_posx)
		end

	set_orig_view_pos (a_orig_view_pos: INTEGER_32)
		do
			c_set_orig_view_pos (c_pointer, a_orig_view_pos)
		end

	set_orig_view_posx (a_orig_view_posx: INTEGER_32)
		do
			c_set_orig_view_posx (c_pointer, a_orig_view_posx)
		end

	set_current_link (a_current_link: INTEGER_32)
		do
			c_set_current_link (c_pointer, a_current_link)
		end

	set_orig_link (a_orig_link: INTEGER_32)
		do
			c_set_orig_link (c_pointer, a_orig_link)
		end

	set_plain (a_plain: INTEGER_32)
		do
			c_set_plain (c_pointer, a_plain)
		end

	set_goto_position (a_goto_position: CE_POINTER [NATURAL_8])
		do
			c_set_goto_position (c_pointer, a_goto_position.c_pointer)
		end

	set_goto_position_end (a_goto_position_end: CE_POINTER [NATURAL_8])
		do
			c_set_goto_position_end (c_pointer, a_goto_position_end.c_pointer)
		end

	set_form_info (a_form_info: CE_POINTER [PD_FORM_STATE])
		do
			c_set_form_info (c_pointer, a_form_info.c_pointer)
		end

	set_form_info_len (a_form_info_len: INTEGER_32)
		do
			c_set_form_info_len (c_pointer, a_form_info_len)
		end

feature {NONE} -- C getters

	c_view_pos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct view_state *)$tmp)->view_pos;"
		end

	c_view_posx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct view_state *)$tmp)->view_posx;"
		end

	c_orig_view_pos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct view_state *)$tmp)->orig_view_pos;"
		end

	c_orig_view_posx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct view_state *)$tmp)->orig_view_posx;"
		end

	c_current_link (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct view_state *)$tmp)->current_link;"
		end

	c_orig_link (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct view_state *)$tmp)->orig_link;"
		end

	c_plain (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct view_state *)$tmp)->plain;"
		end

	c_goto_position (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct view_state *)$tmp)->goto_position;"
		end

	c_goto_position_end (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct view_state *)$tmp)->goto_position_end;"
		end

	c_form_info (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct form_state *)((struct view_state *)$tmp)->form_info;"
		end

	c_form_info_len (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct view_state *)$tmp)->form_info_len;"
		end

	c_url (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct view_state *tmp = (struct view_state *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->url) / sizeof(tmp->url[0]);
				return tmp->url;
			]"
		end

feature {NONE} -- C setters

	c_set_view_pos (tmp: POINTER; a_view_pos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct view_state *)$tmp)->view_pos = $a_view_pos;"
		end

	c_set_view_posx (tmp: POINTER; a_view_posx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct view_state *)$tmp)->view_posx = $a_view_posx;"
		end

	c_set_orig_view_pos (tmp: POINTER; a_orig_view_pos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct view_state *)$tmp)->orig_view_pos = $a_orig_view_pos;"
		end

	c_set_orig_view_posx (tmp: POINTER; a_orig_view_posx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct view_state *)$tmp)->orig_view_posx = $a_orig_view_posx;"
		end

	c_set_current_link (tmp: POINTER; a_current_link: INTEGER_32)
		external
			"C inline"
		alias
			"((struct view_state *)$tmp)->current_link = $a_current_link;"
		end

	c_set_orig_link (tmp: POINTER; a_orig_link: INTEGER_32)
		external
			"C inline"
		alias
			"((struct view_state *)$tmp)->orig_link = $a_orig_link;"
		end

	c_set_plain (tmp: POINTER; a_plain: INTEGER_32)
		external
			"C inline"
		alias
			"((struct view_state *)$tmp)->plain = $a_plain;"
		end

	c_set_goto_position (tmp: POINTER; a_goto_position: POINTER)
		external
			"C inline"
		alias
			"((struct view_state *)$tmp)->goto_position = (unsigned char *)$a_goto_position;"
		end

	c_set_goto_position_end (tmp: POINTER; a_goto_position_end: POINTER)
		external
			"C inline"
		alias
			"((struct view_state *)$tmp)->goto_position_end = (unsigned char *)$a_goto_position_end;"
		end

	c_set_form_info (tmp: POINTER; a_form_info: POINTER)
		external
			"C inline"
		alias
			"((struct view_state *)$tmp)->form_info = (struct form_state *)$a_form_info;"
		end

	c_set_form_info_len (tmp: POINTER; a_form_info_len: INTEGER_32)
		external
			"C inline"
		alias
			"((struct view_state *)$tmp)->form_info_len = $a_form_info_len;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct view_state);"
		end

end
