class
	PD_WINDOW

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_WINDOW] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_WINDOW] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	handler: CE_ROUTINE assign set_handler
		do
			create Result.make_shared (c_handler (c_pointer))
		end

	data: CE_POINTER [ANY] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	xp: INTEGER_32 assign set_xp
		do
			Result := c_xp (c_pointer)
		end

	yp: INTEGER_32 assign set_yp
		do
			Result := c_yp (c_pointer)
		end

	term: CE_POINTER [PD_TERMINAL] assign set_term
		do
			create Result.make_shared (c_term (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_WINDOW])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_WINDOW])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_handler (a_handler: CE_ROUTINE)
		do
			c_set_handler (c_pointer, a_handler.c_pointer)
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_xp (a_xp: INTEGER_32)
		do
			c_set_xp (c_pointer, a_xp)
		end

	set_yp (a_yp: INTEGER_32)
		do
			c_set_yp (c_pointer, a_yp)
		end

	set_term (a_term: CE_POINTER [PD_TERMINAL])
		do
			c_set_term (c_pointer, a_term.c_pointer)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct window *)((struct window *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct window *)((struct window *)$tmp)->prev;"
		end

	c_handler (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct window *, struct event *, int fwd))((struct window *)$tmp)->handler;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct window *)$tmp)->data;"
		end

	c_xp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window *)$tmp)->xp;"
		end

	c_yp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window *)$tmp)->yp;"
		end

	c_term (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct terminal *)((struct window *)$tmp)->term;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct window *)$tmp)->next = (struct window *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct window *)$tmp)->prev = (struct window *)$a_prev;"
		end

	c_set_handler (tmp: POINTER; a_handler: POINTER)
		external
			"C inline"
		alias
			"((struct window *)$tmp)->handler = (void( *)(struct window *, struct event *, int fwd))$a_handler;"
		end

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct window *)$tmp)->data = (void *)$a_data;"
		end

	c_set_xp (tmp: POINTER; a_xp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window *)$tmp)->xp = $a_xp;"
		end

	c_set_yp (tmp: POINTER; a_yp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window *)$tmp)->yp = $a_yp;"
		end

	c_set_term (tmp: POINTER; a_term: POINTER)
		external
			"C inline"
		alias
			"((struct window *)$tmp)->term = (struct terminal *)$a_term;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct window);"
		end

end
