class
	PD_WRITE_BUFFER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sock: INTEGER_32 assign set_sock
		do
			Result := c_sock (c_pointer)
		end

	len: INTEGER_32 assign set_len
		do
			Result := c_len (c_pointer)
		end

	pos: INTEGER_32 assign set_pos
		do
			Result := c_pos (c_pointer)
		end

	done: CE_ROUTINE assign set_done
		do
			create Result.make_shared (c_done (c_pointer))
		end

	data: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_data (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_sock (a_sock: INTEGER_32)
		do
			c_set_sock (c_pointer, a_sock)
		end

	set_len (a_len: INTEGER_32)
		do
			c_set_len (c_pointer, a_len)
		end

	set_pos (a_pos: INTEGER_32)
		do
			c_set_pos (c_pointer, a_pos)
		end

	set_done (a_done: CE_ROUTINE)
		do
			c_set_done (c_pointer, a_done.c_pointer)
		end

feature {NONE} -- C getters

	c_sock (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct write_buffer *)$tmp)->sock;"
		end

	c_len (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct write_buffer *)$tmp)->len;"
		end

	c_pos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct write_buffer *)$tmp)->pos;"
		end

	c_done (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct connection *))((struct write_buffer *)$tmp)->done;"
		end

	c_data (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct write_buffer *tmp = (struct write_buffer *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->data) / sizeof(tmp->data[0]);
				return tmp->data;
			]"
		end

feature {NONE} -- C setters

	c_set_sock (tmp: POINTER; a_sock: INTEGER_32)
		external
			"C inline"
		alias
			"((struct write_buffer *)$tmp)->sock = $a_sock;"
		end

	c_set_len (tmp: POINTER; a_len: INTEGER_32)
		external
			"C inline"
		alias
			"((struct write_buffer *)$tmp)->len = $a_len;"
		end

	c_set_pos (tmp: POINTER; a_pos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct write_buffer *)$tmp)->pos = $a_pos;"
		end

	c_set_done (tmp: POINTER; a_done: POINTER)
		external
			"C inline"
		alias
			"((struct write_buffer *)$tmp)->done = (void( *)(struct connection *))$a_done;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct write_buffer);"
		end

end
