class
	PD_WTD_DATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ses: CE_POINTER [PD_SESSION] assign set_ses
		do
			create Result.make_shared (c_ses (c_pointer))
		end

	url: CE_POINTER [NATURAL_8] assign set_url
		do
			create Result.make_shared (c_url (c_pointer))
		end

	pri: INTEGER_32 assign set_pri
		do
			Result := c_pri (c_pointer)
		end

	cache: INTEGER_32 assign set_cache
		do
			Result := c_cache (c_pointer)
		end

	wtd: INTEGER_32 assign set_wtd
		do
			Result := c_wtd (c_pointer)
		end

	target: CE_POINTER [NATURAL_8] assign set_target
		do
			create Result.make_shared (c_target (c_pointer))
		end

	pos: CE_POINTER [NATURAL_8] assign set_pos
		do
			create Result.make_shared (c_pos (c_pointer))
		end

	fn: CE_ROUTINE assign set_fn
		do
			create Result.make_shared (c_fn (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_ses (a_ses: CE_POINTER [PD_SESSION])
		do
			c_set_ses (c_pointer, a_ses.c_pointer)
		end

	set_url (a_url: CE_POINTER [NATURAL_8])
		do
			c_set_url (c_pointer, a_url.c_pointer)
		end

	set_pri (a_pri: INTEGER_32)
		do
			c_set_pri (c_pointer, a_pri)
		end

	set_cache (a_cache: INTEGER_32)
		do
			c_set_cache (c_pointer, a_cache)
		end

	set_wtd (a_wtd: INTEGER_32)
		do
			c_set_wtd (c_pointer, a_wtd)
		end

	set_target (a_target: CE_POINTER [NATURAL_8])
		do
			c_set_target (c_pointer, a_target.c_pointer)
		end

	set_pos (a_pos: CE_POINTER [NATURAL_8])
		do
			c_set_pos (c_pointer, a_pos.c_pointer)
		end

	set_fn (a_fn: CE_ROUTINE)
		do
			c_set_fn (c_pointer, a_fn.c_pointer)
		end

feature {NONE} -- C getters

	c_ses (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct session *)((struct wtd_data *)$tmp)->ses;"
		end

	c_url (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct wtd_data *)$tmp)->url;"
		end

	c_pri (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct wtd_data *)$tmp)->pri;"
		end

	c_cache (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct wtd_data *)$tmp)->cache;"
		end

	c_wtd (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct wtd_data *)$tmp)->wtd;"
		end

	c_target (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct wtd_data *)$tmp)->target;"
		end

	c_pos (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct wtd_data *)$tmp)->pos;"
		end

	c_fn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct status *, struct session *))((struct wtd_data *)$tmp)->fn;"
		end

feature {NONE} -- C setters

	c_set_ses (tmp: POINTER; a_ses: POINTER)
		external
			"C inline"
		alias
			"((struct wtd_data *)$tmp)->ses = (struct session *)$a_ses;"
		end

	c_set_url (tmp: POINTER; a_url: POINTER)
		external
			"C inline"
		alias
			"((struct wtd_data *)$tmp)->url = (unsigned char *)$a_url;"
		end

	c_set_pri (tmp: POINTER; a_pri: INTEGER_32)
		external
			"C inline"
		alias
			"((struct wtd_data *)$tmp)->pri = $a_pri;"
		end

	c_set_cache (tmp: POINTER; a_cache: INTEGER_32)
		external
			"C inline"
		alias
			"((struct wtd_data *)$tmp)->cache = $a_cache;"
		end

	c_set_wtd (tmp: POINTER; a_wtd: INTEGER_32)
		external
			"C inline"
		alias
			"((struct wtd_data *)$tmp)->wtd = $a_wtd;"
		end

	c_set_target (tmp: POINTER; a_target: POINTER)
		external
			"C inline"
		alias
			"((struct wtd_data *)$tmp)->target = (unsigned char *)$a_target;"
		end

	c_set_pos (tmp: POINTER; a_pos: POINTER)
		external
			"C inline"
		alias
			"((struct wtd_data *)$tmp)->pos = (unsigned char *)$a_pos;"
		end

	c_set_fn (tmp: POINTER; a_fn: POINTER)
		external
			"C inline"
		alias
			"((struct wtd_data *)$tmp)->fn = (void( *)(struct status *, struct session *))$a_fn;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct wtd_data);"
		end

end
