class
	P_AF_UNIX

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create s_unix_acc.make
			create s_unix.make
		end

feature {ANY} -- attributes

	s_unix_acc: CE_POINTER [SD_SOCKADDR]

	s_unix: CE_POINTER [SD_SOCKADDR]

	s_unix_l: NATURAL_32 assign set_s_unix_l

	set_s_unix_l (a_s_unix_l: NATURAL_32)
		do
			s_unix_l := a_s_unix_l
		end

	s_unix_fd: INTEGER_32 assign set_s_unix_fd

	set_s_unix_fd (a_s_unix_fd: INTEGER_32)
		do
			s_unix_fd := a_s_unix_fd
		end

feature {ANY} -- routines

	get_address: INTEGER_32
		local
			l_su: CE_POINTER [SD_SOCKADDR_UN]
			l_path: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_su.make
			create l_path.make

			if (default_inst.links_home).c_pointer = default_pointer then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				l_path.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("af_unix.c")), 34, default_inst.links_home))
				l_su.ce_gets (create {CE_POINTER [SD_SOCKADDR_UN]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("af_unix.c")), 35, ({SD_SOCKADDR_UN}.sizeof.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_path)))) + {NATURAL_32} 1))))
				s_unix_acc.ce_gets (create {CE_POINTER [SD_SOCKADDR]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("af_unix.c")), 36, ({SD_SOCKADDR_UN}.sizeof.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_path)))) + {NATURAL_32} 1))))
				memset (create {CE_POINTER [ANY]}.make_cast (l_su), 0, ({SD_SOCKADDR_UN}.sizeof.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_path)))) + {NATURAL_32} 1).do_nothing
				l_su.item.sun_family := (1).to_natural_16
				links_inst.add_to_strn (l_path.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("socket")))
				strcpy ((l_su.item.sun_path), create {CE_POINTER [INTEGER_8]}.make_cast (l_path)).do_nothing
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("af_unix.c")), 41, create {CE_POINTER [ANY]}.make_cast (l_path))
				s_unix.ce_gets (create {CE_POINTER [SD_SOCKADDR]}.make_cast (l_su))
				s_unix_l := (((create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [CE_ARRAY [INTEGER_8]]}.make_shared (l_su.c_pointer + {SD_SOCKADDR_UN}.sun_path_offset)))).distance ((create {CE_POINTER [INTEGER_8]}.make_cast (l_su)))).to_natural_32 + (strlen ((l_su.item.sun_path)))) + {NATURAL_32} 1
				Result := 1
			end
		end

	unlink_unix
		do
			unlink (((create {CE_POINTER [SD_SOCKADDR_UN]}.make_cast (s_unix)).item.sun_path)).do_nothing
		end

	bind_to_af_unix: INTEGER_32
		local
			l_u: INTEGER_32
			l_a1: INTEGER_32
			l_cnt: INTEGER_32
			l_af: INTEGER_32
			l_tv: SD_TIMEVAL
			l_dummy: SD_FD_SET
			l_d0: INTEGER_32
			l_d1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tv.make
			create l_dummy.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_u := 0
					l_a1 := 1
					l_cnt := 0
					l_af := get_address
					if l_af = -1 then
						Result := (-1)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | again:
						s_unix_fd := socket (l_af, 1, 0)
						if s_unix_fd = -1 then
							Result := (-1)
							js.return
						end
				when 2 then -- if done
					if js.return_called then
						l_pos := -1 + 10 -- skip if block
					end
				when 3 then -- if:
						setsockopt (s_unix_fd, 1, 2, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared ($l_a1))), Integer_32_bytes.to_natural_32).do_nothing
						if not ((bind (s_unix_fd, s_unix, s_unix_l)).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						close (s_unix_fd).do_nothing
						s_unix_fd := socket (l_af, 1, 0)
						if s_unix_fd = -1 then
							Result := (-1)
							js.return
						end
						if js.return_called then
							l_pos := -1 + 9 -- skip if block
						end
				when 5 then -- if:
						setsockopt (s_unix_fd, 1, 2, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared ($l_a1))), Integer_32_bytes.to_natural_32).do_nothing
						if not ((connect (s_unix_fd, s_unix, s_unix_l)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 6 then -- if:
						l_cnt := l_cnt + 1
						if l_cnt < 3 then
							l_tv.tv_sec := (0).to_integer_32
							l_tv.tv_usec := (100000).to_integer_32
							from
							until
								js.loop_left
							loop
								js.reset
								asm1 (create {CE_POINTER [INTEGER_32]}.make_shared ($l_d0), create {CE_POINTER [INTEGER_32]}.make_shared ($l_d1), l_dummy.address)
								js.break
							end
							js.reset
							select2 (0, (l_dummy.address), (l_dummy.address), (l_dummy.address), (l_tv.address)).do_nothing
							close (s_unix_fd).do_nothing
							l_pos := -1 + 1 -- goto again
						end
				when 7 then
						close (s_unix_fd).do_nothing
						s_unix_fd := -1
						if not l_u.to_boolean then
							unlink_unix
							l_u := 1
							l_pos := -1 + 1 -- goto again
						end
				when 8 then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("af_unix.c")), 114, create {CE_POINTER [ANY]}.make_cast (s_unix))
						s_unix.ce_gets (create {CE_POINTER [SD_SOCKADDR]}.make_shared (default_pointer))
						Result := (-1)
						js.return
				when 9 then -- if done | if done
						if not js.return_called then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("af_unix.c")), 117, create {CE_POINTER [ANY]}.make_cast (s_unix))
							s_unix.ce_gets (create {CE_POINTER [SD_SOCKADDR]}.make_shared (default_pointer))
							Result := s_unix_fd
							js.return
						end
				when 10 then -- if done | if done
						if not js.return_called then
							if (listen (s_unix_fd, 100)).to_boolean then
								error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: listen failed: %%d")), (errno_location).item])
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("af_unix.c")), 122, create {CE_POINTER [ANY]}.make_cast (s_unix))
								s_unix.ce_gets (create {CE_POINTER [SD_SOCKADDR]}.make_shared (default_pointer))
								close (s_unix_fd).do_nothing
								s_unix_fd := -1
								Result := (-1)
								js.return
							end
						end
						if not js.return_called then
							select_inst.set_handlers (s_unix_fd, af_unix_connection_address, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer))
							Result := (-1)
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	af_unix_connection (a_xxx: CE_POINTER [ANY])
		local
			l_l: NATURAL_32
			l_ns: INTEGER_32
			js: JUMP_STATE
		do
			l_l := s_unix_l
			memset (create {CE_POINTER [ANY]}.make_cast (s_unix_acc), 0, l_l).do_nothing
			l_ns := accept (s_unix_fd, s_unix_acc, (create {CE_POINTER [NATURAL_32]}.make_shared ($l_l)))
			if l_ns = -1 then
				js.return
			end
			if not js.return_called then
				terminal_inst.init_term (l_ns, l_ns, session_inst.win_func_address).do_nothing
				os_dep_inst.set_highpri
			end
		end

	af_unix_connection_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent af_unix_connection)
		end

	af_unix_close
		do
			if s_unix_fd /= -1 then
				close (s_unix_fd).do_nothing
			end
			if ((s_unix).c_pointer /= default_pointer) then
				unlink_unix
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("af_unix.c")), 144, create {CE_POINTER [ANY]}.make_cast (s_unix))
				s_unix.ce_gets (create {CE_POINTER [SD_SOCKADDR]}.make_shared (default_pointer))
			end
			if ((s_unix_acc).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("af_unix.c")), 145, create {CE_POINTER [ANY]}.make_cast (s_unix_acc))
				s_unix_acc.ce_gets (create {CE_POINTER [SD_SOCKADDR]}.make_shared (default_pointer))
			end
		end

end
