class
	P_BOOKMARK

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create bookmarks.make
			create bookmark_add_msg.make (<<2>>)
			create bookmark_dialog_msg.make (<<1>>)
			create bm_add_msg.make (<<2>>)
		end

feature {ANY} -- attributes

	bookmarks: PD_LIST_HEAD

	next_bookmark_id: INTEGER_32 assign set_next_bookmark_id

	set_next_bookmark_id (a_next_bookmark_id: INTEGER_32)
		do
			next_bookmark_id := a_next_bookmark_id
		end

	bookmark_add_msg: CE_ARRAY [CE_POINTER [NATURAL_8]]

	bookmark_dialog_msg: CE_ARRAY [CE_POINTER [NATURAL_8]]

	bm_add_msg: CE_ARRAY [CE_POINTER [NATURAL_8]]

feature {ANY} -- routines

	free_bookmarks
		local
			l_bm: CE_POINTER [PD_BOOKMARK]
			l_a__: CE_POINTER [PD_XLIST_HEAD]
		do
			create l_bm.make
			create l_a__.make

			l_bm.ce_gets (create {CE_POINTER [PD_BOOKMARK]}.make_cast (bookmarks.next))
			from
			until
				(l_bm.c_pointer.to_integer_32).to_natural_32 = ((bookmarks.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 18, create {CE_POINTER [ANY]}.make_cast (l_bm.item.title))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 19, create {CE_POINTER [ANY]}.make_cast (l_bm.item.url))
				l_bm.ce_gets (l_bm.item.next)
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((bookmarks.address)))
			l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (bookmarks.next))
			from
			until
				(l_a__.c_pointer.to_integer_32).to_natural_32 = ((bookmarks.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__.ce_gets (l_a__.item.next)
			end
			l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (bookmarks.prev))
			from
			until
				(l_a__.c_pointer.to_integer_32).to_natural_32 = ((bookmarks.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__.ce_gets (l_a__.item.prev)
			end
			from
			until
				((bookmarks.next).c_pointer.to_integer_32).to_natural_32 = ((bookmarks.address).c_pointer.to_integer_32).to_natural_32
			loop
				l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (bookmarks.next))
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a__.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a__.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 22, create {CE_POINTER [ANY]}.make_cast (l_a__))
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((bookmarks.address)))
		end

	finalize_bookmarks
		do
			write_bookmarks
			free_bookmarks
		end

	read_bookmarks
		local
			l_in_buffer: CE_ARRAY [NATURAL_8]
			l_file_name: CE_POINTER [NATURAL_8]
			l_title: CE_POINTER [NATURAL_8]
			l_url: CE_POINTER [NATURAL_8]
			l_f: CE_POINTER [SD_IO_FILE]
			js: JUMP_STATE
		do
			create l_in_buffer.make (<<1024>>)
			create l_file_name.make
			create l_title.make
			create l_url.make
			create l_f.make

			l_file_name.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 39, default_inst.links_home))
			if (l_file_name).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				links_inst.add_to_strn (l_file_name.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmarks")))
				l_f.ce_gets (fopen (create {CE_POINTER [INTEGER_8]}.make_cast (l_file_name), ce_string ("r")))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 44, create {CE_POINTER [ANY]}.make_cast (l_file_name))
				if (l_f.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					js.return
				end
			end
			if not js.return_called then
				l_title.ce_gets (l_in_buffer)
				from
				until
					js.loop_left
				loop
					js.reset
					if ((fgets (create {CE_POINTER [INTEGER_8]}.make_cast (l_in_buffer), 1024, l_f))).c_pointer = default_pointer then
						js.break
					end
					if not js.loop_jumped then
						l_url.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_in_buffer), ('|').code))))
						if (l_url.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.continue
						end
					end
					if not js.loop_jumped then
						l_url.item := (('%/0/').code).to_natural_8
						l_url.ce_gets (l_url + 1)
						if (((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_url), ('%N').code))).c_pointer /= default_pointer) then
							(strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_url), ('%N').code))[0] := (('%/0/').code).to_integer_8
						end
						add_bookmark (l_title, l_url)
					end
				end
				js.reset
				fclose (l_f).do_nothing
			end
		end

	write_bookmarks
		local
			l_bm: CE_POINTER [PD_BOOKMARK]
			l_out: CE_POINTER [SD_IO_FILE]
			l_tmp_file_name: CE_POINTER [NATURAL_8]
			l_file_name: CE_POINTER [NATURAL_8]
			l_p: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_bm.make
			create l_out.make
			create l_tmp_file_name.make
			create l_file_name.make
			create l_p.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp_file_name.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 69, default_inst.links_home))
					if (l_tmp_file_name).c_pointer = default_pointer then
						js.return
					end
					if not js.return_called then
						links_inst.add_to_strn (l_tmp_file_name.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmarks.tmp")))
						l_out.ce_gets (fopen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp_file_name), ce_string ("w")))
						if (l_out).c_pointer = default_pointer then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 75, create {CE_POINTER [ANY]}.make_cast (l_tmp_file_name))
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						l_bm.ce_gets (create {CE_POINTER [PD_BOOKMARK]}.make_cast (bookmarks.prev))
						from
						until
							not (not js.loop_left and then ((l_bm.c_pointer.to_integer_32).to_natural_32 /= ((bookmarks.address).c_pointer.to_integer_32).to_natural_32))
						loop
							l_p.ce_gets ((links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 80, l_bm.item.title)))
							l_i := ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p))) - {NATURAL_32} 1).to_integer_32
							from
							until
								not (l_i >= 0)
							loop
								if (l_p[l_i]).to_integer_32 < 32 then
									l_p[l_i] := ((' ').code).to_natural_8
								elseif (l_p[l_i]).to_integer_32 = 124 then
									l_p[l_i] := ((' ').code).to_natural_8
								end
								l_i := l_i - 1
							end
							fputs (create {CE_POINTER [INTEGER_8]}.make_cast (l_p), l_out).do_nothing
							fputc (('|').code, l_out).do_nothing
							fputs (create {CE_POINTER [INTEGER_8]}.make_cast (l_bm.item.url), l_out).do_nothing
							fputc (('%N').code, l_out).do_nothing
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 87, create {CE_POINTER [ANY]}.make_cast (l_p))
							l_bm.ce_gets (l_bm.item.prev)
						end
						if (ferror (l_out)).to_boolean then
							fclose (l_out).do_nothing
							l_pos := -1 + 3 -- goto err
						end
				when 2 then
						if (fclose (l_out)) /= -1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 3 then -- if: | err:
						remove (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp_file_name)).do_nothing
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 97, create {CE_POINTER [ANY]}.make_cast (l_tmp_file_name))
						js.return
				when 4 then -- if done | if done
						if not js.return_called then
							l_file_name.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 101, default_inst.links_home))
							if (l_file_name).c_pointer = default_pointer then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 103, create {CE_POINTER [ANY]}.make_cast (l_tmp_file_name))
								js.return
							end
						end
						if not js.return_called then
							links_inst.add_to_strn (l_file_name.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmarks")))
							rename2 (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp_file_name), create {CE_POINTER [INTEGER_8]}.make_cast (l_file_name)).do_nothing
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 112, create {CE_POINTER [ANY]}.make_cast (l_tmp_file_name))
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 113, create {CE_POINTER [ANY]}.make_cast (l_file_name))
						end
				when 5 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	get_bookmark_by_id (a_id: INTEGER_32): CE_POINTER [PD_BOOKMARK]
		local
			l_bm: CE_POINTER [PD_BOOKMARK]
			js: JUMP_STATE
		do
			create l_bm.make

			if a_id = -1 then
				Result := (create {CE_POINTER [PD_BOOKMARK]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_bm.ce_gets (create {CE_POINTER [PD_BOOKMARK]}.make_cast (bookmarks.next))
				from
				until
					not (not js.loop_left and then ((l_bm.c_pointer.to_integer_32).to_natural_32 /= ((bookmarks.address).c_pointer.to_integer_32).to_natural_32))
				loop
					if a_id = l_bm.item.id then
						Result := l_bm
						js.return
					end
					if not js.return_called then
						l_bm.ce_gets (l_bm.item.next)
					end
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [PD_BOOKMARK]}.make_shared (default_pointer))
			end
		end

	add_bookmark (a_title: CE_POINTER [NATURAL_8]; a_url: CE_POINTER [NATURAL_8])
		local
			l_bm: CE_POINTER [PD_BOOKMARK]
			l_title_size: INTEGER_32
			l_url_size: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
		do
			create l_bm.make

			l_title_size := ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_title))) + {NATURAL_32} 1).to_integer_32
			l_url_size := ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_url))) + {NATURAL_32} 1).to_integer_32
			l_bm.ce_gets (create {CE_POINTER [PD_BOOKMARK]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 143, {PD_BOOKMARK}.sizeof.to_natural_32))))
			l_bm.item.title := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 145, l_title_size.to_natural_32)))
			l_bm.item.url := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 146, l_url_size.to_natural_32)))
			strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_bm.item.title), create {CE_POINTER [INTEGER_8]}.make_cast (a_title)).do_nothing
			strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_bm.item.url), create {CE_POINTER [INTEGER_8]}.make_cast (a_url)).do_nothing
			l_tmp___4 := next_bookmark_id
			next_bookmark_id := next_bookmark_id + 1
			l_bm.item.id := l_tmp___4
			from
			until
				js.loop_left
			loop
				js.reset
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((bookmarks.address)))
				l_bm.item.next := (create {CE_POINTER [PD_BOOKMARK]}.make_cast ((bookmarks.address))).item.next
				l_bm.item.prev := create {CE_POINTER [PD_BOOKMARK]}.make_cast ((bookmarks.address));
				(create {CE_POINTER [PD_BOOKMARK]}.make_cast ((bookmarks.address))).item.next := l_bm;
				(l_bm.item.next).item.prev := l_bm
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((bookmarks.address)))
				js.break
			end
			js.reset
		end

	bookmark_update (a_id: INTEGER_32; a_title: CE_POINTER [NATURAL_8]; a_url: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_bm: CE_POINTER [PD_BOOKMARK]
			js: JUMP_STATE
		do
			create l_bm.make

			l_bm.ce_gets ((get_bookmark_by_id (a_id)))
			if (l_bm.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 0
				js.return
			end
			if not js.return_called then
				if ((a_title).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 173, create {CE_POINTER [ANY]}.make_cast (l_bm.item.title))
					l_bm.item.title := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 174, a_title)
				end
				if ((a_url).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 178, create {CE_POINTER [ANY]}.make_cast (l_bm.item.url))
					l_bm.item.url := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 179, a_url)
				end
				Result := 1
			end
		end

	create_bookmark (a_title: CE_POINTER [NATURAL_8]; a_url: CE_POINTER [NATURAL_8]): CE_POINTER [PD_BOOKMARK]
		local
			l_new_bm: CE_POINTER [PD_BOOKMARK]
			l_title_size: NATURAL_32
			l_url_size: NATURAL_32
		do
			create l_new_bm.make

			l_new_bm.ce_gets (create {CE_POINTER [PD_BOOKMARK]}.make_shared (default_pointer))
			l_title_size := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_title))) + {NATURAL_32} 1
			l_url_size := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_url))) + {NATURAL_32} 1
			if l_title_size > {NATURAL_32} 2147483647 then
				from
				until
					False
				loop
					error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bookmark.c"), 193])
					kbd_inst.fatal_tty_exit
					exit (4)
				end
			end
			if l_url_size > {NATURAL_32} 2147483647 then
				from
				until
					False
				loop
					error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bookmark.c"), 194])
					kbd_inst.fatal_tty_exit
					exit (4)
				end
			end
			l_new_bm.ce_gets (create {CE_POINTER [PD_BOOKMARK]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 196, {PD_BOOKMARK}.sizeof.to_natural_32))))
			l_new_bm.item.title := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 198, l_title_size)))
			l_new_bm.item.url := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 199, l_url_size)))
			strncpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_new_bm.item.title), create {CE_POINTER [INTEGER_8]}.make_cast (a_title), l_title_size).do_nothing
			strncpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_new_bm.item.url), create {CE_POINTER [INTEGER_8]}.make_cast (a_url), l_url_size).do_nothing
			Result := l_new_bm
		end

	delete_bookmark_by_id (a_id: INTEGER_32): INTEGER_32
		local
			l_bm: CE_POINTER [PD_BOOKMARK]
			js: JUMP_STATE
		do
			create l_bm.make

			l_bm.ce_gets (get_bookmark_by_id (a_id))
			if (l_bm.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 0
				js.return
			end
			if not js.return_called then
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_bm));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_bm.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_bm.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_bm.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_bm.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_bm))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 221, create {CE_POINTER [ANY]}.make_cast (l_bm.item.title))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 222, create {CE_POINTER [ANY]}.make_cast (l_bm.item.url))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 224, create {CE_POINTER [ANY]}.make_cast (l_bm))
				Result := 1
			end
		end

	bookmark_dlg_list_clear (a_bm_list: CE_POINTER [PD_LIST_HEAD])
		local
			l_a__: CE_POINTER [PD_XLIST_HEAD]
		do
			create l_a__.make

			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_bm_list))
			l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_bm_list.item.next))
			from
			until
				(l_a__.c_pointer.to_integer_32).to_natural_32 = (a_bm_list.c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__.ce_gets (l_a__.item.next)
			end
			l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_bm_list.item.prev))
			from
			until
				(l_a__.c_pointer.to_integer_32).to_natural_32 = (a_bm_list.c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__.ce_gets (l_a__.item.prev)
			end
			from
			until
				((a_bm_list.item.next).c_pointer.to_integer_32).to_natural_32 = (a_bm_list.c_pointer.to_integer_32).to_natural_32
			loop
				l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_bm_list.item.next))
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a__.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a__.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 256, create {CE_POINTER [ANY]}.make_cast (l_a__))
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_bm_list))
		end

	bookmark_dlg_list_update (a_bm_list: CE_POINTER [PD_LIST_HEAD]): INTEGER_32
		local
			l_bm: CE_POINTER [PD_BOOKMARK]
			l_item: CE_POINTER [PD_BOX_ITEM]
			l_text: CE_POINTER [NATURAL_8]
			l_count: INTEGER_32
			l_id: INTEGER_32
			js: JUMP_STATE
		do
			create l_bm.make
			create l_item.make
			create l_text.make

			l_count := 0
			bookmark_dlg_list_clear (a_bm_list)
			l_bm.ce_gets (create {CE_POINTER [PD_BOOKMARK]}.make_cast (bookmarks.next))
			from
			until
				not (not js.loop_left and then ((l_bm.c_pointer.to_integer_32).to_natural_32 /= ((bookmarks.address).c_pointer.to_integer_32).to_natural_32))
			loop
				l_item.ce_gets (create {CE_POINTER [PD_BOX_ITEM]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 275, ({PD_BOX_ITEM}.sizeof.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_bm.item.title)))) + {NATURAL_32} 1))))
				l_text.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (l_item) + ({PD_BOX_ITEM}.sizeof.to_natural_32).to_integer_32)
				l_item.item.text := l_text
				l_id := l_bm.item.id
				l_item.item.data := create {CE_POINTER [ANY]}.make_shared (default_pointer + l_id)
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_text), create {CE_POINTER [INTEGER_8]}.make_cast (l_bm.item.title)).do_nothing
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_bm_list))
					l_item.item.next := (create {CE_POINTER [PD_BOX_ITEM]}.make_cast (a_bm_list)).item.next
					l_item.item.prev := create {CE_POINTER [PD_BOX_ITEM]}.make_cast (a_bm_list);
					(create {CE_POINTER [PD_BOX_ITEM]}.make_cast (a_bm_list)).item.next := l_item;
					(l_item.item.next).item.prev := l_item
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_bm_list))
					js.break
				end
				js.reset
				l_count := l_count + 1
				l_bm.ce_gets (l_bm.item.next)
			end
			Result := l_count
		end

	bookmark_dlg_box_build (a_box: CE_POINTER [CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]]): CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]
		do
			a_box.item := create {CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 293, {PD_DLG_DATA_ITEM_DATA_BOX}.sizeof.to_natural_32)))
			memset (create {CE_POINTER [ANY]}.make_cast (a_box.item), 0, {PD_DLG_DATA_ITEM_DATA_BOX}.sizeof.to_natural_32).do_nothing
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((a_box.item).c_pointer + {PD_DLG_DATA_ITEM_DATA_BOX}.items_offset))));
			(a_box.item).item.items.next := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((a_box.item).c_pointer + {PD_DLG_DATA_ITEM_DATA_BOX}.items_offset)));
			(a_box.item).item.items.prev := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((a_box.item).c_pointer + {PD_DLG_DATA_ITEM_DATA_BOX}.items_offset)))
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((a_box.item).c_pointer + {PD_DLG_DATA_ITEM_DATA_BOX}.items_offset))));
			(a_box.item).item.list_len := bookmark_dlg_list_update (create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((a_box.item).c_pointer + {PD_DLG_DATA_ITEM_DATA_BOX}.items_offset))
			Result := (a_box.item)
		end

	bookmark_dlg_box_id_get (a_box: CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]): INTEGER_32
		local
			l_citem: CE_POINTER [PD_BOX_ITEM]
			l_sel: INTEGER_32
			js: JUMP_STATE
		do
			create l_citem.make

			l_sel := a_box.item.sel
			if l_sel = -1 then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				l_citem.ce_gets (create {CE_POINTER [PD_BOX_ITEM]}.make_cast (a_box.item.items.next))
				from
				until
					not (not js.loop_left and then ((l_citem.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_box.c_pointer + {PD_DLG_DATA_ITEM_DATA_BOX}.items_offset)).c_pointer.to_integer_32).to_natural_32))
				loop
					if l_sel = 0 then
						Result := ((l_citem.item.data).c_pointer.to_integer_32).to_integer_32
						js.return
					end
					if not js.return_called then
						l_sel := l_sel - 1
						l_citem.ce_gets (l_citem.item.next)
					end
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	bookmark_dialog_abort_handler (a_dlg: CE_POINTER [PD_DIALOG_DATA])
		local
			l_box: CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]
		do
			create l_box.make

			l_box.ce_gets (create {CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast ((a_dlg.item.dlg).item.items[5].data))
			bookmark_dlg_list_clear (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_box.c_pointer + {PD_DLG_DATA_ITEM_DATA_BOX}.items_offset))
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 335, create {CE_POINTER [ANY]}.make_cast (l_box))
		end

	bookmark_dialog_abort_handler_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent bookmark_dialog_abort_handler)
		end

	bookmark_dialog_event_handler (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_ev: CE_POINTER [PD_EVENT]): INTEGER_32
		local
			l_di: CE_POINTER [PD_DIALOG_ITEM_DATA]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_di.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect (a_ev.item.ev).to_integer_32 -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 0 then l_pos := -1 + 15
					when 4 then l_pos := -1 + 15
					when 3 then l_pos := -1 + 15
					when 2 then l_pos := -1 + 15
					when 5 then l_pos := -1 + 15
					else l_pos := -1 + 16
					end
				when 1 then -- switch 1, case 1
					l_di.ce_gets (a_dlg.item.items + a_dlg.item.selected)
					if a_ev.item.x /= 261 then
						l_pos := -1 + 4 -- skip if block
					end
				when 2 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 4 then -- else:
						if a_ev.item.x /= 258 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (a_ev.item.y).to_boolean then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						bfu_inst.display_dlg_item (a_dlg, a_dlg.item.items + a_dlg.item.selected, 0)
						a_dlg.item.selected := (a_dlg.item.selected) + 1
						if a_dlg.item.selected >= 5 then
							a_dlg.item.selected := 0
						end
						bfu_inst.display_dlg_item (a_dlg, a_dlg.item.items + a_dlg.item.selected, 1)
						Result := 0
						js.return
				when 7 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 14 -- skip if block
						end
				when 8 then -- if:
							if a_ev.item.x /= 260 then
								l_pos := -1 + 11 -- skip if block
							end
				when 9 then -- if:
							l_pos := -1 + 13 -- goto _L___0
				when 10 then -- if block done, skip else block:
							l_pos := -1 + 14
				when 11 then -- else:
							if a_ev.item.x /= 258 then
								l_pos := -1 + 14 -- skip if block
							end
				when 12 then -- if:
							if not ((a_ev.item.y).to_boolean) then
								l_pos := -1 + 14 -- skip if block
							end
				when 13 then -- if: | _L___0:
							bfu_inst.display_dlg_item (a_dlg, a_dlg.item.items + a_dlg.item.selected, 0)
							a_dlg.item.selected := (a_dlg.item.selected) - 1
							if a_dlg.item.selected < 0 then
								a_dlg.item.selected := 4
							end
							bfu_inst.display_dlg_item (a_dlg, a_dlg.item.items + a_dlg.item.selected, 1)
							Result := 0
							js.return
				when 14 then -- if done | if done | if done
							if not js.return_called and then (a_ev.item.x = 263) then
								bfu_inst.box_sel_move (a_dlg.item.items + 5, 1)
								bfu_inst.show_dlg_item_box (a_dlg, a_dlg.item.items + 5)
								Result := 0
								js.return
							end
							if not js.return_called and then (a_ev.item.x = 262) then
								bfu_inst.box_sel_move (a_dlg.item.items + 5, -1)
								bfu_inst.show_dlg_item_box (a_dlg, a_dlg.item.items + 5)
								Result := 0
								js.return
							end
							if not js.return_called and then (a_ev.item.x = 269) then
								bfu_inst.box_sel_move (a_dlg.item.items + 5, (a_dlg.item.items[5].item).item.gid // 2)
								bfu_inst.show_dlg_item_box (a_dlg, a_dlg.item.items + 5)
								Result := 0
								js.return
							end
							if not js.return_called and then (a_ev.item.x = 268) then
								bfu_inst.box_sel_move (a_dlg.item.items + 5, (-1 * (a_dlg.item.items[5].item).item.gid) // 2)
								bfu_inst.show_dlg_item_box (a_dlg, a_dlg.item.items + 5)
								Result := 0
								js.return
							end
							l_pos := -1 + 17 -- switch 1; break
				when 15 then -- switch 1, case 0 | switch 1, case 4 | switch 1, case 3 | switch 1, case 2 | switch 1, case 5
							l_pos := -1 + 17 -- switch 1; break
				when 16 then -- switch 1, default:
							from
							until
								False
							loop
								links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")))
								links_inst.errline := 406
								error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Unknown event received: %%d")), a_ev.item.ev])
							end
				when 17 then -- switch 1, done:
							if not js.return_called then
								Result := 1
							end
				when 18 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	bookmark_dialog_event_handler_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent bookmark_dialog_event_handler)
		end

	menu_goto_bookmark (a_term: CE_POINTER [PD_TERMINAL]; a_url: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		do
			session_inst.goto_url (a_ses, create {CE_POINTER [NATURAL_8]}.make_cast (a_url))
		end

	menu_goto_bookmark_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_goto_bookmark)
		end

	bookmark_get_url (a_id: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_bm: CE_POINTER [PD_BOOKMARK]
			js: JUMP_STATE
		do
			create l_bm.make

			l_bm.ce_gets ((get_bookmark_by_id (a_id)))
			if (l_bm.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				Result := (l_bm.item.url)
			end
		end

	bookmark_get_name (a_id: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_bm: CE_POINTER [PD_BOOKMARK]
			js: JUMP_STATE
		do
			create l_bm.make

			l_bm.ce_gets ((get_bookmark_by_id (a_id)))
			if (l_bm.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				Result := (l_bm.item.title)
			end
		end

	bookmark_goto (a_id: INTEGER_32; a_ses: CE_POINTER [PD_SESSION])
		local
			l_bm: CE_POINTER [PD_BOOKMARK]
		do
			create l_bm.make

			l_bm.ce_gets (get_bookmark_by_id (a_id))
			if ((l_bm).c_pointer /= default_pointer) then
				session_inst.goto_url (a_ses, l_bm.item.url)
			end
		end

	bookmark_menu (a_term: CE_POINTER [PD_TERMINAL]; a_ddd: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_bm: CE_POINTER [PD_BOOKMARK]
			l_mi: CE_POINTER [PD_MENU_ITEM]
			js: JUMP_STATE
		do
			create l_bm.make
			create l_mi.make

			l_mi.ce_gets (bfu_inst.new_menu (3))
			if (l_mi).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				l_bm.ce_gets (create {CE_POINTER [PD_BOOKMARK]}.make_cast (bookmarks.next))
				from
				until
					(l_bm.c_pointer.to_integer_32).to_natural_32 = ((bookmarks.address).c_pointer.to_integer_32).to_natural_32
				loop
					bfu_inst.add_to_menu (l_mi.address, (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 485, l_bm.item.title)), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), (menu_goto_bookmark_address), create {CE_POINTER [ANY]}.make_cast (l_bm.item.url), 0)
					l_bm.ce_gets (l_bm.item.next)
				end
				bfu_inst.do_menu (a_term, l_mi, create {CE_POINTER [ANY]}.make_cast (a_ses))
			end
		end

	layout_bookmark_manager (a_dlg: CE_POINTER [PD_DIALOG_DATA])
		local
			l_max: INTEGER_32
			l_min: INTEGER_32
			l_w: INTEGER_32
			l_rw: INTEGER_32
			l_y: INTEGER_32
			l_term: CE_POINTER [PD_TERMINAL]
		do
			create l_term.make

			l_max := 0
			l_min := 0
			l_y := -1
			l_term.ce_gets ((a_dlg.item.win).item.term)
			bfu_inst.max_text_width (l_term, bookmark_dialog_msg[0], create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))
			bfu_inst.min_text_width (l_term, bookmark_dialog_msg[0], create {CE_POINTER [INTEGER_32]}.make_shared ($l_min))
			bfu_inst.max_buttons_width (l_term, a_dlg.item.items + 2, 2, create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))
			bfu_inst.min_buttons_width (l_term, a_dlg.item.items + 2, 2, create {CE_POINTER [INTEGER_32]}.make_shared ($l_min))
			l_w := (l_term.item.x * 9) // 10 - 12
			if l_w > l_max then
				l_w := l_max
			end
			if l_w < l_min then
				l_w := l_min
			end
			if l_w > l_term.item.x - 12 then
				l_w := l_term.item.x - 12
			end
			if l_w < 1 then
				l_w := 1
			end
			l_rw := 50
			l_w := l_rw
			l_y := l_y + 1
			bfu_inst.dlg_format_box (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, a_dlg.item.items + 5, a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0)
			l_y := l_y + 1
			bfu_inst.dlg_format_buttons (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, a_dlg.item.items, 5, 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rw), 1)
			l_w := l_rw
			a_dlg.item.xw := l_w + 12
			a_dlg.item.yw := l_y + 4
			bfu_inst.center_dlg (a_dlg)
			bfu_inst.draw_dlg (a_dlg)
			l_y := a_dlg.item.y + 2
			l_y := l_y + 1
			bfu_inst.dlg_format_box (l_term, l_term, a_dlg.item.items + 5, a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0)
			l_y := l_y + 1
			bfu_inst.dlg_format_buttons (l_term, l_term, a_dlg.item.items + 0, 5, a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 1)
		end

	layout_bookmark_manager_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent layout_bookmark_manager)
		end

	push_add_button (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		do
			launch_bm_add_doc_dialog ((a_dlg.item.win).item.term, a_dlg, create {CE_POINTER [PD_SESSION]}.make_cast ((a_dlg.item.dlg).item.udata))
			Result := 0
		end

	push_add_button_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent push_add_button)
		end

	push_goto_button (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_goto_btn: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		local
			l_id: INTEGER_32
			l_box: CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]
		do
			create l_box.make

			l_box.ce_gets (create {CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast ((a_dlg.item.dlg).item.items[5].data))
			l_id := bookmark_dlg_box_id_get (l_box)
			if l_id /= -1 then
				bookmark_goto (l_id, create {CE_POINTER [PD_SESSION]}.make_cast ((a_goto_btn.item.item).item.udata))
			end
			terminal_inst.delete_window (a_dlg.item.win)
			Result := 0
		end

	push_goto_button_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent push_goto_button)
		end

	bookmark_edit_done (a_d: CE_POINTER [PD_DIALOG])
		local
			l_id: INTEGER_32
			l_parent: CE_POINTER [PD_DIALOG_DATA]
		do
			create l_parent.make

			l_id := ((a_d.item.udata2).c_pointer.to_integer_32).to_integer_32
			bookmark_update (l_id, a_d.item.items[0].data, a_d.item.items[1].data).do_nothing
			l_parent.ce_gets (create {CE_POINTER [PD_DIALOG_DATA]}.make_cast (a_d.item.udata))
			if ((l_parent).c_pointer /= default_pointer) then
				bookmark_dlg_list_update (create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((create {CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast ((l_parent.item.dlg).item.items[5].data)).c_pointer + {PD_DLG_DATA_ITEM_DATA_BOX}.items_offset)).do_nothing
			end
		end

	bookmark_edit_done_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent bookmark_edit_done)
		end

	push_edit_button (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_edit_btn: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		local
			l_id: INTEGER_32
			l_box: CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]
			l_name: CE_POINTER [NATURAL_8]
			l_url: CE_POINTER [NATURAL_8]
		do
			create l_box.make
			create l_name.make
			create l_url.make

			l_box.ce_gets (create {CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast ((a_dlg.item.dlg).item.items[5].data))
			l_id := bookmark_dlg_box_id_get (l_box)
			if l_id /= -1 then
				l_name.ce_gets ((bookmark_get_name (l_id)))
				l_url.ce_gets ((bookmark_get_url (l_id)))
				bookmark_edit_dialog ((a_dlg.item.win).item.term, links_inst.dummyarray + 269, l_name, l_url, create {CE_POINTER [PD_SESSION]}.make_cast ((a_edit_btn.item.item).item.udata), a_dlg, bookmark_edit_done_address, create {CE_POINTER [ANY]}.make_shared (default_pointer + l_id))
			end
			Result := 0
		end

	push_edit_button_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent push_edit_button)
		end

	really_del_bookmark (a_vhop: CE_POINTER [ANY])
		local
			l_hop: CE_POINTER [PD_PUSH_DEL_BUTTON_HOP_STRUCT]
			l_last: INTEGER_32
			js: JUMP_STATE
		do
			create l_hop.make

			l_hop.ce_gets (create {CE_POINTER [PD_PUSH_DEL_BUTTON_HOP_STRUCT]}.make_cast (a_vhop))
			if not (delete_bookmark_by_id (l_hop.item.id)).to_boolean then
				js.return
			end
			if not js.return_called then
				l_last := bookmark_dlg_list_update (create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((l_hop.item.box).c_pointer + {PD_DLG_DATA_ITEM_DATA_BOX}.items_offset))
				if (l_hop.item.box).item.sel >= l_last - 1 then
					(l_hop.item.box).item.sel := l_last - 1
				end
			end
		end

	really_del_bookmark_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent really_del_bookmark)
		end

	push_delete_button (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_some_useless_delete_button: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		local
			l_bm: CE_POINTER [PD_BOOKMARK]
			l_hop: CE_POINTER [PD_PUSH_DEL_BUTTON_HOP_STRUCT]
			l_term: CE_POINTER [PD_TERMINAL]
			l_box: CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]
			js: JUMP_STATE
		do
			create l_bm.make
			create l_hop.make
			create l_term.make
			create l_box.make

			l_term.ce_gets ((a_dlg.item.win).item.term)
			l_box.ce_gets (create {CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast ((a_dlg.item.dlg).item.items[5].data))
			l_bm.ce_gets (get_bookmark_by_id ((bookmark_dlg_box_id_get (l_box))))
			if (l_bm.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_hop.ce_gets (create {CE_POINTER [PD_PUSH_DEL_BUTTON_HOP_STRUCT]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 645, {PD_PUSH_DEL_BUTTON_HOP_STRUCT}.sizeof.to_natural_32))))
				l_hop.item.id := l_bm.item.id
				l_hop.item.dlg := a_dlg.item.dlg
				l_hop.item.box := l_box
				bfu_inst.msg_box ([l_term, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_hop), create {CE_POINTER [ANY]}.make_shared (default_pointer)])), links_inst.dummyarray + 270, 129, links_inst.dummyarray + 270, ce_string (" %""), l_bm.item.title, ce_string ("%" ("), links_inst.dummyarray + 272, ce_string (": %""), l_bm.item.url, ce_string ("%")?"), create {CE_POINTER [ANY]}.make_shared (default_pointer), l_hop, 2, links_inst.dummyarray + 166, really_del_bookmark_address, 1, links_inst.dummyarray + 167, create {CE_POINTER [ANY]}.make_shared (default_pointer), 2])
				Result := 0
			end
		end

	push_delete_button_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent push_delete_button)
		end

	menu_bookmark_manager (a_term: CE_POINTER [PD_TERMINAL]; a_fcp: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_d: CE_POINTER [PD_DIALOG]
		do
			create l_d.make

			l_d.ce_gets (create {CE_POINTER [PD_DIALOG]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 661, (({PD_DIALOG}.sizeof.to_natural_32 + {NATURAL_32} 7 * {PD_DIALOG_ITEM}.sizeof.to_natural_32) + {PD_BOOKMARK}.sizeof.to_natural_32) + {NATURAL_32} 2048))))
			memset (create {CE_POINTER [ANY]}.make_cast (l_d), 0, (({PD_DIALOG}.sizeof.to_natural_32 + {NATURAL_32} 7 * {PD_DIALOG_ITEM}.sizeof.to_natural_32) + {PD_BOOKMARK}.sizeof.to_natural_32) + {NATURAL_32} 2048).do_nothing
			l_d.item.title := links_inst.dummyarray + 271
			l_d.item.fn := layout_bookmark_manager_address
			l_d.item.handle_event := bookmark_dialog_event_handler_address
			l_d.item.abort := bookmark_dialog_abort_handler_address
			l_d.item.udata := create {CE_POINTER [ANY]}.make_cast (a_ses)
			l_d.item.items[0].type := 4
			l_d.item.items[0].gid := 1
			l_d.item.items[0].fn := push_goto_button_address
			l_d.item.items[0].udata := create {CE_POINTER [ANY]}.make_cast (a_ses)
			l_d.item.items[0].text := links_inst.dummyarray + 265
			l_d.item.items[1].type := 4
			l_d.item.items[1].gid := 1
			l_d.item.items[1].fn := push_edit_button_address
			l_d.item.items[1].udata := create {CE_POINTER [ANY]}.make_cast (a_ses)
			l_d.item.items[1].text := links_inst.dummyarray + 266
			l_d.item.items[2].type := 4
			l_d.item.items[2].gid := 1
			l_d.item.items[2].fn := push_delete_button_address
			l_d.item.items[2].text := links_inst.dummyarray + 102
			l_d.item.items[3].type := 4
			l_d.item.items[3].gid := 1
			l_d.item.items[3].fn := push_add_button_address
			l_d.item.items[3].text := links_inst.dummyarray + 100
			l_d.item.items[4].type := 4
			l_d.item.items[4].gid := 2
			l_d.item.items[4].fn := bfu_inst.cancel_dialog_address
			l_d.item.items[4].text := links_inst.dummyarray + 267
			l_d.item.items[5].type := 5
			l_d.item.items[5].gid := 12
			bookmark_dlg_box_build (create {CE_POINTER [CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]]}.make_cast ((create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_d.c_pointer + {PD_DIALOG}.items_offset + {PD_DIALOG_ITEM}.sizeof * (5) + {PD_DIALOG_ITEM}.data_offset)))).do_nothing
			l_d.item.items[6].type := 0
			bfu_inst.do_dialog (a_term, l_d, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_d), create {CE_POINTER [ANY]}.make_shared (default_pointer)])))
		end

	menu_bookmark_manager_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_bookmark_manager)
		end

	bookmark_add_add (a_d: CE_POINTER [PD_DIALOG])
		local
			l_parent: CE_POINTER [PD_DIALOG_DATA]
		do
			create l_parent.make

			add_bookmark (a_d.item.items[0].data, a_d.item.items[1].data)
			l_parent.ce_gets (create {CE_POINTER [PD_DIALOG_DATA]}.make_cast (a_d.item.udata))
			if ((l_parent).c_pointer /= default_pointer) then
				bookmark_dlg_list_update (create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((create {CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast ((l_parent.item.dlg).item.items[5].data)).c_pointer + {PD_DLG_DATA_ITEM_DATA_BOX}.items_offset)).do_nothing
			end
		end

	bookmark_add_add_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent bookmark_add_add)
		end

	launch_bm_add_doc_dialog (a_term: CE_POINTER [PD_TERMINAL]; a_parent: CE_POINTER [PD_DIALOG_DATA]; a_ses: CE_POINTER [PD_SESSION])
		do
			bookmark_edit_dialog (a_term, links_inst.dummyarray + 264, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), a_ses, a_parent, bookmark_add_add_address, create {CE_POINTER [ANY]}.make_shared (default_pointer))
		end

	launch_bm_add_doc_dialog_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent launch_bm_add_doc_dialog)
		end

	launch_bm_add_link_dialog (a_term: CE_POINTER [PD_TERMINAL]; a_parent: CE_POINTER [PD_DIALOG_DATA]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_url: CE_ARRAY [NATURAL_8]
		do
			create l_url.make (<<1024>>)

			bookmark_edit_dialog (a_term, links_inst.dummyarray + 264, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), (session_inst.get_current_link_url (a_ses, l_url, (1024).to_natural_32)), a_ses, a_parent, bookmark_add_add_address, create {CE_POINTER [ANY]}.make_shared (default_pointer))
		end

	layout_add_dialog (a_dlg: CE_POINTER [PD_DIALOG_DATA])
		local
			l_max: INTEGER_32
			l_min: INTEGER_32
			l_w: INTEGER_32
			l_rw: INTEGER_32
			l_y: INTEGER_32
			l_term: CE_POINTER [PD_TERMINAL]
		do
			create l_term.make

			l_max := 0
			l_min := 0
			l_y := -1
			l_term.ce_gets ((a_dlg.item.win).item.term)
			bfu_inst.max_text_width (l_term, bm_add_msg[0], create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))
			bfu_inst.min_text_width (l_term, bm_add_msg[0], create {CE_POINTER [INTEGER_32]}.make_shared ($l_min))
			bfu_inst.max_text_width (l_term, bm_add_msg[1], create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))
			bfu_inst.min_text_width (l_term, bm_add_msg[1], create {CE_POINTER [INTEGER_32]}.make_shared ($l_min))
			bfu_inst.max_buttons_width (l_term, a_dlg.item.items + 2, 2, create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))
			bfu_inst.min_buttons_width (l_term, a_dlg.item.items + 2, 2, create {CE_POINTER [INTEGER_32]}.make_shared ($l_min))
			l_w := (l_term.item.x * 9) // 10 - 12
			if l_w > l_max then
				l_w := l_max
			end
			if l_w < l_min then
				l_w := l_min
			end
			if l_w > l_term.item.x - 12 then
				l_w := l_term.item.x - 12
			end
			if l_w < 1 then
				l_w := 1
			end
			l_rw := 50
			l_w := l_rw
			bfu_inst.dlg_format_text (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, bm_add_msg[0], 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rw), 14336, 0)
			l_y := l_y + (2)
			bfu_inst.dlg_format_text (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, bm_add_msg[1], 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rw), 14336, 0)
			l_y := l_y + (2)
			bfu_inst.dlg_format_buttons (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, a_dlg.item.items + 2, 2, 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rw), 1)
			l_w := l_rw
			a_dlg.item.xw := l_w + 12
			a_dlg.item.yw := l_y + 4
			bfu_inst.center_dlg (a_dlg)
			bfu_inst.draw_dlg (a_dlg)
			l_y := a_dlg.item.y + 2
			bfu_inst.dlg_format_text (l_term, l_term, bm_add_msg[0], a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 14336, 0)
			bfu_inst.dlg_format_field (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, a_dlg.item.items + 0, a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0)
			l_y := l_y + 1
			bfu_inst.dlg_format_text (l_term, l_term, bm_add_msg[1], a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 14336, 0)
			bfu_inst.dlg_format_field (l_term, l_term, a_dlg.item.items + 1, a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0)
			l_y := l_y + 1
			bfu_inst.dlg_format_buttons (l_term, l_term, a_dlg.item.items + 2, 2, a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 1)
		end

	layout_add_dialog_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent layout_add_dialog)
		end

	bookmark_edit_dialog (a_term: CE_POINTER [PD_TERMINAL]; a_title: CE_POINTER [NATURAL_8]; a_src_name: CE_POINTER [NATURAL_8]; a_src_url: CE_POINTER [NATURAL_8]; a_ses: CE_POINTER [PD_SESSION]; a_parent: CE_POINTER [PD_DIALOG_DATA]; a_when_done: CE_ROUTINE; a_done_data: CE_POINTER [ANY])
		local
			l_name: CE_POINTER [NATURAL_8]
			l_url: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [PD_DIALOG]
		do
			create l_name.make
			create l_url.make
			create l_d.make

			l_d.ce_gets (create {CE_POINTER [PD_DIALOG]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bookmark.c")), 822, (({PD_DIALOG}.sizeof.to_natural_32 + {NATURAL_32} 5 * {PD_DIALOG_ITEM}.sizeof.to_natural_32) + {PD_EXTENSION}.sizeof.to_natural_32) + {NATURAL_32} 2048))))
			memset (create {CE_POINTER [ANY]}.make_cast (l_d), 0, (({PD_DIALOG}.sizeof.to_natural_32 + {NATURAL_32} 5 * {PD_DIALOG_ITEM}.sizeof.to_natural_32) + {PD_EXTENSION}.sizeof.to_natural_32) + {NATURAL_32} 2048).do_nothing
			l_name.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((l_d.item.items + 5)))
			l_url.ce_gets (l_name + 1024)
			if (a_src_name.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				session_inst.get_current_title (a_ses, l_name, (1024).to_natural_32).do_nothing
			else
				links_inst.safe_strncpy (l_name, a_src_name, (1024).to_natural_32).do_nothing
			end
			if (a_src_url.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				session_inst.get_current_url (a_ses, l_url, (1024).to_natural_32).do_nothing
			else
				links_inst.safe_strncpy (l_url, a_src_url, (1024).to_natural_32).do_nothing
			end
			l_d.item.title := a_title
			l_d.item.fn := layout_add_dialog_address
			l_d.item.refresh := a_when_done
			l_d.item.refresh_data := create {CE_POINTER [ANY]}.make_cast (l_d)
			l_d.item.udata := create {CE_POINTER [ANY]}.make_cast (a_parent)
			l_d.item.udata2 := a_done_data
			l_d.item.items[0].type := 2
			l_d.item.items[0].dlen := 1024
			l_d.item.items[0].data := l_name
			l_d.item.items[0].fn := bfu_inst.check_nonempty_address
			l_d.item.items[1].type := 2
			l_d.item.items[1].dlen := 1024
			l_d.item.items[1].data := l_url
			l_d.item.items[1].fn := bfu_inst.check_nonempty_address
			l_d.item.items[2].type := 4
			l_d.item.items[2].gid := 1
			l_d.item.items[2].fn := bfu_inst.ok_dialog_address
			l_d.item.items[2].text := links_inst.dummyarray + 14
			l_d.item.items[3].type := 4
			l_d.item.items[3].gid := 2
			l_d.item.items[3].text := links_inst.dummyarray + 6
			l_d.item.items[3].fn := bfu_inst.cancel_dialog_address
			l_d.item.items[4].type := 0
			bfu_inst.do_dialog (a_term, l_d, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_d), create {CE_POINTER [ANY]}.make_shared (default_pointer)])))
		end

end
