class
	P_CONNECT

inherit
	LINKS_DATA
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {ANY} -- routines

	exception (a_c: CE_POINTER [PD_CONNECTION])
		do
			sched_inst.setcstate (a_c, -1002)
			sched_inst.retry_connection (a_c)
		end

	exception_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent exception)
		end

	close_socket (a_s: CE_POINTER [INTEGER_32])
		local
			js: JUMP_STATE
		do
			if a_s.item = -1 then
				js.return
			end
			if not js.return_called then
				close (a_s.item).do_nothing
				select_inst.set_handlers (a_s.item, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer))
				a_s.item := -1
			end
		end

	make_connection (a_c: CE_POINTER [PD_CONNECTION]; a_port: INTEGER_32; a_sock: CE_POINTER [INTEGER_32]; a_func: CE_ROUTINE)
		local
			l_as: INTEGER_32
			l_host: CE_POINTER [NATURAL_8]
			l_b: CE_POINTER [PD_CONN_INFO]
			js: JUMP_STATE
		do
			create l_host.make
			create l_b.make

			l_host.ce_gets (url_inst.get_host_name (a_c.item.url))
			if (l_host).c_pointer = default_pointer then
				sched_inst.setcstate (a_c, -1003)
				sched_inst.abort_connection (a_c)
				js.return
			end
			if not js.return_called then
				l_b.ce_gets (create {CE_POINTER [PD_CONN_INFO]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("connect.c")), 58, {PD_CONN_INFO}.sizeof.to_natural_32))))
				l_b.item.func := a_func
				l_b.item.sock := a_sock
				l_b.item.port := a_port
				a_c.item.buffer := create {CE_POINTER [ANY]}.make_cast (l_b)
				if a_c.item.no_cache >= 3 then
					l_as := dns_inst.find_host_no_cache (l_host, create {CE_POINTER [NATURAL_32]}.make_shared (l_b.c_pointer + {PD_CONN_INFO}.addr_offset), create {CE_POINTER [CE_POINTER [ANY]]}.make_shared (a_c.c_pointer + {PD_CONNECTION}.dnsquery_offset), (dns_found_address), create {CE_POINTER [ANY]}.make_cast (a_c))
				else
					l_as := dns_inst.find_host (l_host, create {CE_POINTER [NATURAL_32]}.make_shared (l_b.c_pointer + {PD_CONN_INFO}.addr_offset), create {CE_POINTER [CE_POINTER [ANY]]}.make_shared (a_c.c_pointer + {PD_CONNECTION}.dnsquery_offset), (dns_found_address), create {CE_POINTER [ANY]}.make_cast (a_c))
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("connect.c")), 68, create {CE_POINTER [ANY]}.make_cast (l_host))
				if l_as.to_boolean then
					sched_inst.setcstate (a_c, 1)
				end
			end
		end

	get_pasv_socket (a_c: CE_POINTER [PD_CONNECTION]; a_cc: INTEGER_32; a_sock: CE_POINTER [INTEGER_32]; a_port: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_s: INTEGER_32
			l_sa: SD_SOCKADDR_IN
			l_sb: SD_SOCKADDR_IN
			l_len: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_sa.make
			create l_sb.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := {SD_SOCKADDR_IN}.sizeof.to_natural_32
					memset (create {CE_POINTER [ANY]}.make_cast ((l_sa.address)), 0, {SD_SOCKADDR_IN}.sizeof.to_natural_32).do_nothing
					memset (create {CE_POINTER [ANY]}.make_cast ((l_sb.address)), 0, {SD_SOCKADDR_IN}.sizeof.to_natural_32).do_nothing
					if not ((getsockname (a_cc, create {CE_POINTER [SD_SOCKADDR]}.make_cast ((l_sa.address)), (create {CE_POINTER [NATURAL_32]}.make_shared ($l_len)))).to_boolean) then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | e:
						sched_inst.setcstate (a_c, -(errno_location).item)
						sched_inst.retry_connection (a_c)
						Result := (-1)
						js.return
				when 2 then -- if done
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 3 then -- if:
						l_s := socket (2, 1, 6)
						if l_s = -1 then
							l_pos := -1 + 1 -- goto e
						end
				when 4 then
						a_sock.item := l_s
						fcntl ([l_s, 4, 2048]).do_nothing
						memcpy (create {CE_POINTER [ANY]}.make_cast ((l_sb.address)), create {CE_POINTER [ANY]}.make_cast ((l_sa.address)), {SD_SOCKADDR_IN}.sizeof.to_natural_32).do_nothing
						l_sb.sin_port := (0).to_natural_16
						if (bind (l_s, create {CE_POINTER [SD_SOCKADDR]}.make_cast ((l_sb.address)), {SD_SOCKADDR_IN}.sizeof.to_natural_32)).to_boolean then
							l_pos := -1 + 1 -- goto e
						end
				when 5 then
						l_len := {SD_SOCKADDR_IN}.sizeof.to_natural_32
						if (getsockname (l_s, create {CE_POINTER [SD_SOCKADDR]}.make_cast ((l_sa.address)), (create {CE_POINTER [NATURAL_32]}.make_shared ($l_len)))).to_boolean then
							l_pos := -1 + 1 -- goto e
						end
				when 6 then
						if (listen (l_s, 1)).to_boolean then
							l_pos := -1 + 1 -- goto e
						end
				when 7 then
						memcpy (create {CE_POINTER [ANY]}.make_cast (a_port), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [NATURAL_32]}.make_shared (l_sa.c_pointer + {SD_SOCKADDR_IN}.sin_addr_offset + {SD_IN_ADDR}.s_addr_offset))), (4).to_natural_32).do_nothing
						memcpy (create {CE_POINTER [ANY]}.make_cast ((a_port + 4)), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [NATURAL_16]}.make_shared (l_sa.c_pointer + {SD_SOCKADDR_IN}.sin_port_offset))), (2).to_natural_32).do_nothing
						Result := 0
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	dns_found (a_c: CE_POINTER [PD_CONNECTION]; a_state: INTEGER_32)
		local
			l_s: INTEGER_32
			l_b: CE_POINTER [PD_CONN_INFO]
			js: JUMP_STATE
		do
			create l_b.make

			l_b.ce_gets (create {CE_POINTER [PD_CONN_INFO]}.make_cast (a_c.item.buffer))
			if a_state.to_boolean then
				sched_inst.setcstate (a_c, -1005)
				sched_inst.abort_connection (a_c)
				js.return
			end
			if not js.return_called then
				l_s := socket (2, 1, 6)
				if l_s = -1 then
					sched_inst.setcstate (a_c, -(errno_location).item)
					sched_inst.retry_connection (a_c)
					js.return
				end
			end
			if not js.return_called then
				(l_b.item.sock).item := l_s
				fcntl ([l_s, 4, 2048]).do_nothing
				memset (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [SD_SOCKADDR_IN]}.make_shared (l_b.c_pointer + {PD_CONN_INFO}.sa_offset))), 0, {SD_SOCKADDR_IN}.sizeof.to_natural_32).do_nothing
				l_b.item.sa.sin_family := (2).to_natural_16
				l_b.item.sa.sin_addr.s_addr := l_b.item.addr
				l_b.item.sa.sin_port := htons ((l_b.item.port).to_natural_16)
				if (connect (l_s, create {CE_POINTER [SD_SOCKADDR]}.make_cast ((create {CE_POINTER [SD_SOCKADDR_IN]}.make_shared (l_b.c_pointer + {PD_CONN_INFO}.sa_offset))), {SD_SOCKADDR_IN}.sizeof.to_natural_32)).to_boolean then
					if (errno_location).item /= 114 then
						if (errno_location).item /= 115 then
							sched_inst.setcstate (a_c, -(errno_location).item)
							sched_inst.retry_connection (a_c)
							js.return
						end
					end
					if not js.return_called then
						select_inst.set_handlers (l_s, create {CE_ROUTINE}.make_shared (default_pointer), (connected_address), (exception_address), create {CE_POINTER [ANY]}.make_cast (a_c))
						sched_inst.setcstate (a_c, 2)
					end
				else
					connected (a_c)
				end
			end
			if not js.return_called then
			end
		end

	dns_found_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dns_found)
		end

	connected (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_b: CE_POINTER [PD_CONN_INFO]
			l_err: INTEGER_32
			l_len: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_b.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_b.ce_gets (create {CE_POINTER [PD_CONN_INFO]}.make_cast (a_c.item.buffer))
					l_err := 0
					l_len := Integer_32_bytes.to_natural_32
					if (getsockopt ((l_b.item.sock).item, 1, 4, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared ($l_err))), (create {CE_POINTER [NATURAL_32]}.make_shared ($l_len)))).to_boolean then
						l_err := (errno_location).item
						if not l_err.to_boolean then
							l_err := 1012
							l_pos := -1 + 2 -- goto bla
						end
					end
				when 1 then
					if l_err >= 10000 then
						l_err := l_err - (10000)
					end
					if not (l_err > 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 2 then -- if: | bla:
						sched_inst.setcstate (a_c, -l_err)
						sched_inst.retry_connection (a_c)
						js.return
				when 3 then -- if done
					if not js.return_called then
						sched_inst.set_timeout (a_c)
						a_c.item.buffer := create {CE_POINTER [ANY]}.make_shared (default_pointer);
						(l_b.item.func).call ([a_c])
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("connect.c")), 206, create {CE_POINTER [ANY]}.make_cast (l_b))
					end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	connected_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent connected)
		end

	write_select (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_wb: CE_POINTER [PD_WRITE_BUFFER]
			l_wr: INTEGER_32
			l_tmp___0: INTEGER_32
			l_f: CE_ROUTINE
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_wb.make
			create l_f.make

			l_wb.ce_gets (create {CE_POINTER [PD_WRITE_BUFFER]}.make_cast (a_c.item.buffer))
			if (l_wb).c_pointer = default_pointer then
				from
				until
					False
				loop
					links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("connect.c")))
					links_inst.errline := 222
					error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("write socket has no buffer"))])
				end
				sched_inst.setcstate (a_c, -1003)
				sched_inst.abort_connection (a_c)
				js.return
			end
			if not js.return_called then
				sched_inst.set_timeout (a_c)
				l_wr := write (l_wb.item.sock, create {CE_POINTER [ANY]}.make_cast ((l_wb.item.data + l_wb.item.pos)), (l_wb.item.len - l_wb.item.pos).to_natural_32)
				if l_wr <= 0 then
					if l_wr.to_boolean then
						l_tmp___0 := -(errno_location).item
					else
						l_tmp___0 := -1006
					end
					sched_inst.setcstate (a_c, l_tmp___0)
					sched_inst.retry_connection (a_c)
					js.return
				end
			end
			if not js.return_called then
				l_tmp___1 := l_wb.item.pos + l_wr
				l_wb.item.pos := l_tmp___1
				if l_tmp___1 = l_wb.item.len then
					l_f.ce_gets (l_wb.item.done)
					a_c.item.buffer := create {CE_POINTER [ANY]}.make_shared (default_pointer)
					select_inst.set_handlers (l_wb.item.sock, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer))
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("connect.c")), 257, create {CE_POINTER [ANY]}.make_cast (l_wb))
					l_f.call ([a_c])
				end
			end
		end

	write_select_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent write_select)
		end

	write_to_socket (a_c: CE_POINTER [PD_CONNECTION]; a_s: INTEGER_32; a_data: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_write_func: CE_ROUTINE)
		local
			l_wb: CE_POINTER [PD_WRITE_BUFFER]
		do
			create l_wb.make

			if a_len.to_natural_32 > {NATURAL_32} 2147483647 - {PD_WRITE_BUFFER}.sizeof.to_natural_32 then
				from
				until
					False
				loop
					error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("connect.c"), 266])
					kbd_inst.fatal_tty_exit
					exit (4)
				end
			end
			l_wb.ce_gets (create {CE_POINTER [PD_WRITE_BUFFER]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("connect.c")), 267, {PD_WRITE_BUFFER}.sizeof.to_natural_32 + a_len.to_natural_32))))
			l_wb.item.sock := a_s
			l_wb.item.len := a_len
			l_wb.item.pos := 0
			l_wb.item.done := a_write_func
			memcpy (create {CE_POINTER [ANY]}.make_cast ((l_wb.item.data)), create {CE_POINTER [ANY]}.make_cast (a_data), a_len.to_natural_32).do_nothing
			if ((a_c.item.buffer).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("connect.c")), 273, a_c.item.buffer)
			end
			a_c.item.buffer := create {CE_POINTER [ANY]}.make_cast (l_wb)
			select_inst.set_handlers (a_s, create {CE_ROUTINE}.make_shared (default_pointer), (write_select_address), (exception_address), create {CE_POINTER [ANY]}.make_cast (a_c))
		end

	read_select (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_rb: CE_POINTER [PD_READ_BUFFER]
			l_rd: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_rb.make

			l_rb.ce_gets (create {CE_POINTER [PD_READ_BUFFER]}.make_cast (a_c.item.buffer))
			if (l_rb).c_pointer = default_pointer then
				from
				until
					False
				loop
					links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("connect.c")))
					links_inst.errline := 285
					error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("read socket has no buffer"))])
				end
				sched_inst.setcstate (a_c, -1003)
				sched_inst.abort_connection (a_c)
				js.return
			end
			if not js.return_called then
				select_inst.set_handlers (l_rb.item.sock, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer))
				if (l_rb.item.len).to_natural_32 > ({NATURAL_32} 2147483647 - {PD_READ_BUFFER}.sizeof.to_natural_32) - {NATURAL_32} 64240 then
					from
					until
						False
					loop
						error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("connect.c"), 291])
						kbd_inst.fatal_tty_exit
						exit (4)
					end
				end
				l_rb.ce_gets (create {CE_POINTER [PD_READ_BUFFER]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("connect.c")), 292, create {CE_POINTER [ANY]}.make_cast (l_rb), ({PD_READ_BUFFER}.sizeof.to_natural_32 + (l_rb.item.len).to_natural_32) + {NATURAL_32} 64240))))
				a_c.item.buffer := create {CE_POINTER [ANY]}.make_cast (l_rb)
				l_rd := read (l_rb.item.sock, create {CE_POINTER [ANY]}.make_cast ((l_rb.item.data + l_rb.item.len)), (64240).to_natural_32)
				if l_rd <= 0 then
					if (l_rb.item.close).to_boolean then
						if not l_rd.to_boolean then
							l_rb.item.close := 2;
							(l_rb.item.done).call ([a_c, l_rb])
							js.return
						end
					end
					if not js.return_called then
						if l_rd.to_boolean then
							l_tmp___1 := -(errno_location).item
						else
							l_tmp___1 := -1007
						end
						sched_inst.setcstate (a_c, l_tmp___1)
						sched_inst.retry_connection (a_c)
						js.return
					end
				end
			end
			if not js.return_called then
				l_rb.item.len := l_rb.item.len + l_rd;
				(l_rb.item.done).call ([a_c, l_rb])
			end
		end

	read_select_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent read_select)
		end

	alloc_read_buffer (a_c: CE_POINTER [PD_CONNECTION]): CE_POINTER [PD_READ_BUFFER]
		local
			l_rb: CE_POINTER [PD_READ_BUFFER]
		do
			create l_rb.make

			l_rb.ce_gets (create {CE_POINTER [PD_READ_BUFFER]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("connect.c")), 335, {PD_READ_BUFFER}.sizeof.to_natural_32 + {NATURAL_32} 64240))))
			memset (create {CE_POINTER [ANY]}.make_cast (l_rb), 0, {PD_READ_BUFFER}.sizeof.to_natural_32).do_nothing
			Result := l_rb
		end

	read_from_socket (a_c: CE_POINTER [PD_CONNECTION]; a_s: INTEGER_32; a_buf___0: CE_POINTER [PD_READ_BUFFER]; a_read_func: CE_ROUTINE)
		do
			a_buf___0.item.done := a_read_func
			a_buf___0.item.sock := a_s
			if ((a_c.item.buffer).c_pointer /= default_pointer) then
				if (a_buf___0.c_pointer.to_integer_32).to_natural_32 /= ((a_c.item.buffer).c_pointer.to_integer_32).to_natural_32 then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("connect.c")), 344, a_c.item.buffer)
				end
			end
			a_c.item.buffer := create {CE_POINTER [ANY]}.make_cast (a_buf___0)
			select_inst.set_handlers (a_s, (read_select_address), create {CE_ROUTINE}.make_shared (default_pointer), (exception_address), create {CE_POINTER [ANY]}.make_cast (a_c))
		end

	kill_buffer_data (a_rb: CE_POINTER [PD_READ_BUFFER]; a_n: INTEGER_32)
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_n > a_rb.item.len) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (a_n < 0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							False
						loop
							links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("connect.c")))
							links_inst.errline := 352
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("called kill_buffer_data with bad value"))])
						end
						a_rb.item.len := 0
						js.return
				when 5 then -- if done
						if not js.return_called then
							memmove (create {CE_POINTER [ANY]}.make_cast ((a_rb.item.data)), create {CE_POINTER [ANY]}.make_cast ((a_rb.item.data + a_n)), (a_rb.item.len - a_n).to_natural_32).do_nothing
							a_rb.item.len := a_rb.item.len - a_n
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
