class
	P_COOKIES

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create cookies.make
			create c2_domains.make
			create c2_servers.make
		end

feature {ANY} -- attributes

	accept_cookies: INTEGER_32 assign set_accept_cookies

	set_accept_cookies (a_accept_cookies: INTEGER_32)
		do
			accept_cookies := a_accept_cookies
		end

	cookie_id: NATURAL_32 assign set_cookie_id

	set_cookie_id (a_cookie_id: NATURAL_32)
		do
			cookie_id := a_cookie_id
		end

	cookies: PD_LIST_HEAD

	c2_domains: PD_LIST_HEAD

	c2_servers: PD_LIST_HEAD

feature {ANY} -- routines

	free_cookie (a_c: CE_POINTER [PD_COOKIE])
		do
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 46, create {CE_POINTER [ANY]}.make_cast (a_c.item.name))
			if ((a_c.item.value).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 47, create {CE_POINTER [ANY]}.make_cast (a_c.item.value))
			end
			if ((a_c.item.server).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 48, create {CE_POINTER [ANY]}.make_cast (a_c.item.server))
			end
			if ((a_c.item.path).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 49, create {CE_POINTER [ANY]}.make_cast (a_c.item.path))
			end
			if ((a_c.item.domain).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 50, create {CE_POINTER [ANY]}.make_cast (a_c.item.domain))
			end
		end

	check_domain_security (a_server: CE_POINTER [NATURAL_8]; a_domain: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_domain: CE_POINTER [NATURAL_8]
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_dl: NATURAL_32
			l_nd: INTEGER_32
			l_tmp___1: NATURAL_8
			l_tld: CE_ARRAY [CE_POINTER [NATURAL_8]]
			js: JUMP_STATE
		do
			create l_domain.make
			create l_tld.make (<<8>>)

			l_domain.ce_gets (a_domain)
			if (l_domain[0]).to_integer_32 = 46 then
				l_domain.ce_gets (l_domain + 1)
			end
			l_dl := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_domain))
			if l_dl > (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_server))) then
				Result := 1
				js.return
			end
			if not js.return_called then
				l_i := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_server))) - l_dl
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then ((a_server[l_i.to_integer_32]).to_boolean))
				loop
					l_tmp___1 := links_inst.upcase (a_server[l_i.to_integer_32])
					if l_tmp___1.to_integer_32 /= (links_inst.upcase (l_domain[l_j.to_integer_32])).to_integer_32 then
						Result := 1
						js.return
					end
					if not js.return_called then
						l_i := l_i + 1
						l_j := l_j + 1
					end
				end
			end
			if not js.return_called then
				l_nd := 2
				if l_dl > {NATURAL_32} 4 then
					if (l_domain[(l_dl - {NATURAL_32} 4).to_integer_32]).to_integer_32 = 46 then
						l_tld[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("com"))
						l_tld[1] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("edu"))
						l_tld[2] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("net"))
						l_tld[3] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("org"))
						l_tld[4] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("gov"))
						l_tld[5] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mil"))
						l_tld[6] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("int"))
						l_tld[7] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						l_i := (0).to_natural_32
						from
						until
							not (not js.loop_left and then ((l_tld[l_i.to_integer_32]).c_pointer /= default_pointer))
						loop
							js.reset
							if not (links_inst.casecmp (l_tld[l_i.to_integer_32], l_domain + (l_dl - {NATURAL_32} 3).to_integer_32, (3).to_natural_32)).to_boolean then
								l_nd := 1
								js.break
							end
							if not js.loop_jumped then
								l_i := l_i + 1
							end
						end
						js.reset
					end
				end
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then ((l_domain[l_i.to_integer_32]).to_boolean))
				loop
					js.reset
					if (l_domain[l_i.to_integer_32]).to_integer_32 = 46 then
						l_nd := l_nd - 1
						if not l_nd.to_boolean then
							js.break
						end
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
				js.reset
				if l_nd > 0 then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	set_cookie (a_term: CE_POINTER [PD_TERMINAL]; a_url: CE_POINTER [NATURAL_8]; a_str: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_noval: INTEGER_32
			l_cookie: CE_POINTER [PD_COOKIE]
			l_cs: CE_POINTER [PD_C_SERVER]
			l_p: CE_POINTER [NATURAL_8]
			l_q: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_server: CE_POINTER [NATURAL_8]
			l_date: CE_POINTER [NATURAL_8]
			l_document: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___6: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_cookie.make
			create l_cs.make
			create l_p.make
			create l_q.make
			create l_s.make
			create l_server.make
			create l_date.make
			create l_document.make
			create l_tmp___2.make
			create l_tmp___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_noval := 0
					if accept_cookies = 0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_p.ce_gets (a_str)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_p.item).to_integer_32 /= 59 then
								if not (l_p.item).to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p.ce_gets (l_p + 1)
							end
						end
						js.reset
						l_q.ce_gets (a_str)
						from
						until
							not (not js.loop_left and then ((l_q.item).to_integer_32 /= 61))
						loop
							js.reset
							if not (l_q.item).to_boolean then
								l_noval := 1
								js.break
							elseif (l_q.c_pointer.to_integer_32).to_natural_32 >= (l_p.c_pointer.to_integer_32).to_natural_32 then
								l_noval := 1
								js.break
							end
							if not js.loop_jumped then
								l_q.ce_gets (l_q + 1)
							end
						end
						js.reset
						if (a_str.c_pointer.to_integer_32).to_natural_32 = (l_q.c_pointer.to_integer_32).to_natural_32 then
							Result := 0
							js.return
						elseif ((l_q + 1).c_pointer.to_integer_32).to_natural_32 = (l_p.c_pointer.to_integer_32).to_natural_32 then
							Result := 0
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						l_cookie.ce_gets (create {CE_POINTER [PD_COOKIE]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 88, {PD_COOKIE}.sizeof.to_natural_32))))
						l_document.ce_gets (url_inst.get_url_data (a_url))
						l_server.ce_gets (url_inst.get_host_name (a_url))
						l_cookie.item.name := links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 91, a_str, l_q.distance (a_str))
						if not l_noval.to_boolean then
							l_cookie.item.value := (links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 92, l_q + 1, (l_p.distance (l_q)) - 1))
						else
							l_cookie.item.value := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						end
						l_cookie.item.server := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 93, l_server)
						l_date.ce_gets (http_inst.parse_header_param (a_str, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("expires"))))
						if ((l_date).c_pointer /= default_pointer) then
							l_cookie.item.expires := session_inst.parse_http_date (create {CE_POINTER [INTEGER_8]}.make_cast (l_date))
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 99, create {CE_POINTER [ANY]}.make_cast (l_date))
						else
							l_cookie.item.expires := (0).to_integer_32
						end
						l_tmp___2.ce_gets (http_inst.parse_header_param (a_str, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("path"))))
						l_cookie.item.path := l_tmp___2
						if ((l_tmp___2).c_pointer /= default_pointer) then
							if (l_cookie.item.path[0]).to_integer_32 /= 47 then
								links_inst.add_to_strn (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_cookie.c_pointer + {PD_COOKIE}.path_offset), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("x")))
								memmove (create {CE_POINTER [ANY]}.make_cast ((l_cookie.item.path + 1)), create {CE_POINTER [ANY]}.make_cast (l_cookie.item.path), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_cookie.item.path))) - {NATURAL_32} 1).do_nothing
								l_cookie.item.path[0] := (('/').code).to_natural_8
							end
						else
							l_cookie.item.path := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 104, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/")))
						end
						l_tmp___3.ce_gets (http_inst.parse_header_param (a_str, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("domain"))))
						l_cookie.item.domain := l_tmp___3
						if (l_tmp___3).c_pointer = default_pointer then
							l_cookie.item.domain := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 124, l_server)
						end
						if (l_cookie.item.domain[0]).to_integer_32 = 46 then
							memmove (create {CE_POINTER [ANY]}.make_cast (l_cookie.item.domain), create {CE_POINTER [ANY]}.make_cast ((l_cookie.item.domain + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_cookie.item.domain)))).do_nothing
						end
						l_s.ce_gets (http_inst.parse_header_param (a_str, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("secure"))))
						if ((l_s).c_pointer /= default_pointer) then
							l_cookie.item.secure := 1
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 128, create {CE_POINTER [ANY]}.make_cast (l_s))
						else
							l_cookie.item.secure := 0
						end
						if (check_domain_security (l_server, l_cookie.item.domain)).to_boolean then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 131, create {CE_POINTER [ANY]}.make_cast (l_cookie.item.domain))
							l_cookie.item.domain := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 132, l_server)
						end
						l_tmp___6 := cookie_id
						cookie_id := cookie_id + 1
						l_cookie.item.id := l_tmp___6.to_integer_32
						l_cs.ce_gets (create {CE_POINTER [PD_C_SERVER]}.make_cast (c2_servers.next))
				when 2 then -- loop condition:
						if not (not js.loop_left and then ((l_cs.c_pointer.to_integer_32).to_natural_32 /= ((c2_servers.address).c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_cs.item.server)), create {CE_POINTER [INTEGER_8]}.make_cast (l_server))).to_boolean then
							if (l_cs.item.accept).to_boolean then
								l_pos := -1 + 6 -- goto ok
							else
								free_cookie (l_cookie)
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 139, create {CE_POINTER [ANY]}.make_cast (l_cookie))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 140, create {CE_POINTER [ANY]}.make_cast (l_server))
								Result := 0
								js.return
							end
						end
				when 4 then
						if not js.return_called then
							l_cs.ce_gets (l_cs.item.next)
						end
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done | if done
						if not js.return_called and then (accept_cookies /= 2) then
							free_cookie (l_cookie)
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 146, create {CE_POINTER [ANY]}.make_cast (l_cookie))
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 147, create {CE_POINTER [ANY]}.make_cast (l_server))
							Result := 1
							js.return
						end
						if js.return_called then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | ok:
							accept_cookie (l_cookie)
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 152, create {CE_POINTER [ANY]}.make_cast (l_server))
							Result := 0
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	accept_cookie (a_c: CE_POINTER [PD_COOKIE])
		local
			l_cd: CE_POINTER [PD_C_DOMAIN]
			l_d: CE_POINTER [PD_COOKIE]
			l_e: CE_POINTER [PD_COOKIE]
			js: JUMP_STATE
		do
			create l_cd.make
			create l_d.make
			create l_e.make

			l_d.ce_gets (create {CE_POINTER [PD_COOKIE]}.make_cast (cookies.next))
			from
			until
				(l_d.c_pointer.to_integer_32).to_natural_32 = ((cookies.address).c_pointer.to_integer_32).to_natural_32
			loop
				if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_d.item.name), create {CE_POINTER [INTEGER_8]}.make_cast (a_c.item.name))).to_boolean then
					if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_d.item.domain), create {CE_POINTER [INTEGER_8]}.make_cast (a_c.item.domain))).to_boolean then
						l_e.ce_gets (l_d)
						l_d.ce_gets (l_d.item.prev)
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_e));
						(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_e.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_e.item.prev);
						(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_e.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_e.item.next)
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_e))
						free_cookie (l_e)
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 165, create {CE_POINTER [ANY]}.make_cast (l_e))
					end
				end
				l_d.ce_gets (l_d.item.next)
			end
			if ((a_c.item.value).c_pointer /= default_pointer) then
				if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_c.item.value), ce_string ("deleted"))).to_boolean then
					free_cookie (a_c)
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 169, create {CE_POINTER [ANY]}.make_cast (a_c))
					js.return
				end
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((cookies.address)))
					a_c.item.next := (create {CE_POINTER [PD_COOKIE]}.make_cast ((cookies.address))).item.next
					a_c.item.prev := create {CE_POINTER [PD_COOKIE]}.make_cast ((cookies.address));
					(create {CE_POINTER [PD_COOKIE]}.make_cast ((cookies.address))).item.next := a_c;
					(a_c.item.next).item.prev := a_c
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((cookies.address)))
					js.break
				end
				js.reset
				l_cd.ce_gets (create {CE_POINTER [PD_C_DOMAIN]}.make_cast (c2_domains.next))
				from
				until
					not (not js.loop_left and then ((l_cd.c_pointer.to_integer_32).to_natural_32 /= ((c2_domains.address).c_pointer.to_integer_32).to_natural_32))
				loop
					if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_cd.item.domain)), create {CE_POINTER [INTEGER_8]}.make_cast (a_c.item.domain))).to_boolean then
						js.return
					end
					if not js.return_called then
						l_cd.ce_gets (l_cd.item.next)
					end
				end
			end
			if not js.return_called then
				l_cd.ce_gets (create {CE_POINTER [PD_C_DOMAIN]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 174, ({PD_C_DOMAIN}.sizeof.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_c.item.domain)))) + {NATURAL_32} 1))))
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_cd.item.domain)), create {CE_POINTER [INTEGER_8]}.make_cast (a_c.item.domain)).do_nothing
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((c2_domains.address)))
					l_cd.item.next := (create {CE_POINTER [PD_C_DOMAIN]}.make_cast ((c2_domains.address))).item.next
					l_cd.item.prev := create {CE_POINTER [PD_C_DOMAIN]}.make_cast ((c2_domains.address));
					(create {CE_POINTER [PD_C_DOMAIN]}.make_cast ((c2_domains.address))).item.next := l_cd;
					(l_cd.item.next).item.prev := l_cd
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((c2_domains.address)))
					js.break
				end
				js.reset
			end
		end

	delete_cookie (a_c: CE_POINTER [PD_COOKIE])
		local
			l_cd: CE_POINTER [PD_C_DOMAIN]
			l_d: CE_POINTER [PD_COOKIE]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_cd.make
			create l_d.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d.ce_gets (create {CE_POINTER [PD_COOKIE]}.make_cast (cookies.next))
				when 1 then -- loop condition:
					if (l_d.c_pointer.to_integer_32).to_natural_32 = ((cookies.address).c_pointer.to_integer_32).to_natural_32 then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_d.item.domain), create {CE_POINTER [INTEGER_8]}.make_cast (a_c.item.domain))).to_boolean then
							l_pos := -1 + 5 -- goto x
						end
				when 3 then
						l_d.ce_gets (l_d.item.next)
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					l_cd.ce_gets (create {CE_POINTER [PD_C_DOMAIN]}.make_cast (c2_domains.next))
					from
					until
						not (not js.loop_left and then ((l_cd.c_pointer.to_integer_32).to_natural_32 /= ((c2_domains.address).c_pointer.to_integer_32).to_natural_32))
					loop
						js.reset
						if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_cd.item.domain)), create {CE_POINTER [INTEGER_8]}.make_cast (a_c.item.domain))).to_boolean then
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_cd));
							(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_cd.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_cd.item.prev);
							(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_cd.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_cd.item.next)
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_cd))
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 186, create {CE_POINTER [ANY]}.make_cast (l_cd))
							js.break
						end
						if not js.loop_jumped then
							l_cd.ce_gets (l_cd.item.next)
						end
					end
					js.reset
				when 5 then -- x:
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_c));
					(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_c.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (a_c.item.prev);
					(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_c.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (a_c.item.next)
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_c))
					free_cookie (a_c)
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 192, create {CE_POINTER [ANY]}.make_cast (a_c))
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	find_cookie_id (a_idp: CE_POINTER [ANY]): CE_POINTER [PD_COOKIE]
		local
			l_id: INTEGER_32
			l_c: CE_POINTER [PD_COOKIE]
			js: JUMP_STATE
		do
			create l_c.make

			l_id := (a_idp.c_pointer.to_integer_32).to_integer_32
			l_c.ce_gets (create {CE_POINTER [PD_COOKIE]}.make_cast (cookies.next))
			from
			until
				not (not js.loop_left and then ((l_c.c_pointer.to_integer_32).to_natural_32 /= ((cookies.address).c_pointer.to_integer_32).to_natural_32))
			loop
				if l_c.item.id = l_id then
					Result := l_c
					js.return
				end
				if not js.return_called then
					l_c.ce_gets (l_c.item.next)
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer))
			end
		end

	reject_cookie (a_idp: CE_POINTER [ANY])
		local
			l_c: CE_POINTER [PD_COOKIE]
			js: JUMP_STATE
		do
			create l_c.make

			l_c.ce_gets (find_cookie_id (a_idp))
			if (l_c).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				delete_cookie (l_c)
			end
		end

	cookie_default (a_idp: CE_POINTER [ANY]; a_a: INTEGER_32)
		local
			l_c: CE_POINTER [PD_COOKIE]
			l_s: CE_POINTER [PD_C_SERVER]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_c.make
			create l_s.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c.ce_gets (find_cookie_id (a_idp))
					if (l_c).c_pointer = default_pointer then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						l_s.ce_gets (create {CE_POINTER [PD_C_SERVER]}.make_cast (c2_servers.next))
				when 2 then -- loop condition:
						if (l_s.c_pointer.to_integer_32).to_natural_32 = ((c2_servers.address).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_s.item.server)), create {CE_POINTER [INTEGER_8]}.make_cast (l_c.item.server))).to_boolean then
							l_pos := -1 + 6 -- goto found
						end
				when 4 then
						l_s.ce_gets (l_s.item.next)
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
						l_s.ce_gets (create {CE_POINTER [PD_C_SERVER]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 216, ({PD_C_SERVER}.sizeof.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_c.item.server)))) + {NATURAL_32} 1))))
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_s.item.server)), create {CE_POINTER [INTEGER_8]}.make_cast (l_c.item.server)).do_nothing
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((c2_servers.address)))
							l_s.item.next := (create {CE_POINTER [PD_C_SERVER]}.make_cast ((c2_servers.address))).item.next
							l_s.item.prev := create {CE_POINTER [PD_C_SERVER]}.make_cast ((c2_servers.address));
							(create {CE_POINTER [PD_C_SERVER]}.make_cast ((c2_servers.address))).item.next := l_s;
							(l_s.item.next).item.prev := l_s
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((c2_servers.address)))
							js.break
						end
						js.reset
				when 6 then -- found:
						l_s.item.accept := a_a
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	accept_cookie_always (a_idp: CE_POINTER [ANY])
		do
			cookie_default (a_idp, 1)
		end

	accept_cookie_never (a_idp: CE_POINTER [ANY])
		do
			cookie_default (a_idp, 0)
			reject_cookie (a_idp)
		end

	is_in_domain (a_d: CE_POINTER [NATURAL_8]; a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_dl: INTEGER_32
			l_sl: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
		do
			l_dl := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_d))).to_integer_32
			l_sl := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_s))).to_integer_32
			if l_dl > l_sl then
				Result := 0
				js.return
			end
			if not js.return_called and then (l_dl = l_sl) then
				if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_d), create {CE_POINTER [INTEGER_8]}.make_cast (a_s))).to_boolean then
					l_tmp___2 := 0
				else
					l_tmp___2 := 1
				end
				Result := l_tmp___2
				js.return
			end
			if not js.return_called and then ((a_s[((l_sl - l_dl) - 1)]).to_integer_32 /= 46) then
				Result := 0
				js.return
			end
			if not js.return_called then
				if (links_inst.casecmp (a_d, (a_s + l_sl) - l_dl, l_dl.to_natural_32)).to_boolean then
					l_tmp___4 := 0
				else
					l_tmp___4 := 1
				end
				Result := l_tmp___4
			end
		end

	is_path_prefix (a_d: CE_POINTER [NATURAL_8]; a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_dl: INTEGER_32
			l_sl: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			l_dl := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_d))).to_integer_32
			l_sl := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_s))).to_integer_32
			if not l_dl.to_boolean then
				Result := 1
				js.return
			end
			if not js.return_called and then (l_dl > l_sl) then
				Result := 0
				js.return
			end
			if not js.return_called then
				if (memcmp (create {CE_POINTER [ANY]}.make_cast (a_d), create {CE_POINTER [ANY]}.make_cast (a_s), l_dl.to_natural_32)).to_boolean then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if (a_d[(l_dl - 1)]).to_integer_32 = 47 then
					l_tmp___2 := 1
				elseif not (a_s[l_dl]).to_boolean then
					l_tmp___2 := 1
				elseif (a_s[l_dl]).to_integer_32 = 47 then
					l_tmp___2 := 1
				elseif (a_s[l_dl]).to_integer_32 = 1 then
					l_tmp___2 := 1
				elseif (a_s[l_dl]).to_integer_32 = 63 then
					l_tmp___2 := 1
				elseif (a_s[l_dl]).to_integer_32 = 38 then
					l_tmp___2 := 1
				else
					l_tmp___2 := 0
				end
				Result := l_tmp___2
			end
		end

	cookie_expired (a_c: CE_POINTER [PD_COOKIE]): INTEGER_32
		do
			Result := 0
		end

	send_cookies (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_url: CE_POINTER [NATURAL_8])
		local
			l_nc: INTEGER_32
			l_cd: CE_POINTER [PD_C_DOMAIN]
			l_c: CE_POINTER [PD_COOKIE]
			l_d: CE_POINTER [PD_COOKIE]
			l_server: CE_POINTER [NATURAL_8]
			l_data: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_cd.make
			create l_c.make
			create l_d.make
			create l_server.make
			create l_data.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_nc := 0
					l_server.ce_gets ((url_inst.get_host_name (a_url)))
					l_data.ce_gets ((url_inst.get_url_data (a_url)))
					if (l_data.c_pointer.to_integer_32).to_natural_32 > (a_url.c_pointer.to_integer_32).to_natural_32 then
						l_data.ce_gets (l_data - 1)
					end
					l_cd.ce_gets (create {CE_POINTER [PD_C_DOMAIN]}.make_cast (c2_domains.next))
				when 1 then -- loop condition:
					if (l_cd.c_pointer.to_integer_32).to_natural_32 = ((c2_domains.address).c_pointer.to_integer_32).to_natural_32 then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if (is_in_domain (l_cd.item.domain, l_server)).to_boolean then
							l_pos := -1 + 5 -- goto ok
						end
				when 3 then
						l_cd.ce_gets (l_cd.item.next)
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 268, create {CE_POINTER [ANY]}.make_cast (l_server))
					js.return
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 5 then -- if: | ok:
						l_c.ce_gets (create {CE_POINTER [PD_COOKIE]}.make_cast (cookies.next))
						from
						until
							(l_c.c_pointer.to_integer_32).to_natural_32 = ((cookies.address).c_pointer.to_integer_32).to_natural_32
						loop
							js.reset
							if (is_in_domain (l_c.item.domain, l_server)).to_boolean then
								if (is_path_prefix (l_c.item.path, l_data)).to_boolean then
									if (cookie_expired (l_c)).to_boolean then
										l_d.ce_gets (l_c)
										l_c.ce_gets (l_c.item.prev)
										error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_d));
										(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_d.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_d.item.prev);
										(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_d.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_d.item.next)
										error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_d))
										free_cookie (l_d)
										error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 277, create {CE_POINTER [ANY]}.make_cast (l_d))
										js.continue
									end
									if not js.loop_jumped and then ((l_c.item.secure).to_boolean) then
										if (links_inst.casecmp (a_url, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("https://")), (8).to_natural_32)).to_boolean then
											js.continue
										end
									end
									if not js.loop_jumped then
										if not l_nc.to_boolean then
											links_inst.add_to_str (a_s, a_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Cookie: ")))
											l_nc := 1
										else
											links_inst.add_to_str (a_s, a_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("; ")))
										end
										links_inst.add_to_str (a_s, a_l, l_c.item.name)
										if ((l_c.item.value).c_pointer /= default_pointer) then
											links_inst.add_to_str (a_s, a_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("=")))
											links_inst.add_to_str (a_s, a_l, l_c.item.value)
										end
									end
								end
							end
							l_c.ce_gets (l_c.item.next)
						end
						if l_nc.to_boolean then
							links_inst.add_to_str (a_s, a_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%N")))
						end
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 290, create {CE_POINTER [ANY]}.make_cast (l_server))
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	init_cookies
		do
		end

	cleanup_cookies
		local
			l_c: CE_POINTER [PD_COOKIE]
			l_a__: CE_POINTER [PD_XLIST_HEAD]
			l_a_____0: CE_POINTER [PD_XLIST_HEAD]
		do
			create l_c.make
			create l_a__.make
			create l_a_____0.make

			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((c2_domains.address)))
			l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (c2_domains.next))
			from
			until
				(l_a__.c_pointer.to_integer_32).to_natural_32 = ((c2_domains.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__.ce_gets (l_a__.item.next)
			end
			l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (c2_domains.prev))
			from
			until
				(l_a__.c_pointer.to_integer_32).to_natural_32 = ((c2_domains.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__.ce_gets (l_a__.item.prev)
			end
			from
			until
				((c2_domains.next).c_pointer.to_integer_32).to_natural_32 = ((c2_domains.address).c_pointer.to_integer_32).to_natural_32
			loop
				l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (c2_domains.next))
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a__.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a__.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 301, create {CE_POINTER [ANY]}.make_cast (l_a__))
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((c2_domains.address)))
			l_c.ce_gets (create {CE_POINTER [PD_COOKIE]}.make_cast (cookies.next))
			from
			until
				(l_c.c_pointer.to_integer_32).to_natural_32 = ((cookies.address).c_pointer.to_integer_32).to_natural_32
			loop
				free_cookie (l_c)
				l_c.ce_gets (l_c.item.next)
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((cookies.address)))
			l_a_____0.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (cookies.next))
			from
			until
				(l_a_____0.c_pointer.to_integer_32).to_natural_32 = ((cookies.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____0))
				l_a_____0.ce_gets (l_a_____0.item.next)
			end
			l_a_____0.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (cookies.prev))
			from
			until
				(l_a_____0.c_pointer.to_integer_32).to_natural_32 = ((cookies.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____0))
				l_a_____0.ce_gets (l_a_____0.item.prev)
			end
			from
			until
				((cookies.next).c_pointer.to_integer_32).to_natural_32 = ((cookies.address).c_pointer.to_integer_32).to_natural_32
			loop
				l_a_____0.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (cookies.next))
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____0));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____0.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a_____0.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____0.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a_____0.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____0))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cookies.c")), 304, create {CE_POINTER [ANY]}.make_cast (l_a_____0))
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((cookies.address)))
		end

end
