class
	P_DEFAULT

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create all_options.make (<<3>>)
			create cfg_buffer.make (<<1024>>)
			create links_home.make
			create dds.make
			create default_fg.make
			create default_bg.make
			create default_link.make
			create default_vlink.make
			create http_proxy.make (<<1024>>)
			create ftp_proxy.make (<<1024>>)
			create download_dir.make (<<1024>>)
			create ftp_options.make
			create http_bugs.make
			create links_options.make (<<48>>)
			create html_options.make (<<9>>)
		end

feature {ANY} -- attributes

	all_options: CE_ARRAY [CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]]

	cfg_buffer: CE_ARRAY [NATURAL_8]

	anonymous: INTEGER_32 assign set_anonymous

	set_anonymous (a_anonymous: INTEGER_32)
		do
			anonymous := a_anonymous
		end

	links_home: CE_POINTER [NATURAL_8]

	first_use: INTEGER_32 assign set_first_use
		do
			Result := first_use_address[0]
		end

	set_first_use (a_first_use: INTEGER_32)
		do
			first_use_address[0] := a_first_use
		end

	first_use_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	created_home: INTEGER_32 assign set_created_home

	set_created_home (a_created_home: INTEGER_32)
		do
			created_home := a_created_home
		end

	no_connect: INTEGER_32 assign set_no_connect

	set_no_connect (a_no_connect: INTEGER_32)
		do
			no_connect := a_no_connect
		end

	base_session: INTEGER_32 assign set_base_session
		do
			Result := base_session_address[0]
		end

	set_base_session (a_base_session: INTEGER_32)
		do
			base_session_address[0] := a_base_session
		end

	base_session_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	dmp: INTEGER_32 assign set_dmp

	set_dmp (a_dmp: INTEGER_32)
		do
			dmp := a_dmp
		end

	force_html: INTEGER_32 assign set_force_html

	set_force_html (a_force_html: INTEGER_32)
		do
			force_html := a_force_html
		end

	async_lookup: INTEGER_32 assign set_async_lookup
		do
			Result := async_lookup_address[0]
		end

	set_async_lookup (a_async_lookup: INTEGER_32)
		do
			async_lookup_address[0] := a_async_lookup
		end

	async_lookup_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	download_utime: INTEGER_32 assign set_download_utime
		do
			Result := download_utime_address[0]
		end

	set_download_utime (a_download_utime: INTEGER_32)
		do
			download_utime_address[0] := a_download_utime
		end

	download_utime_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	max_connections: INTEGER_32 assign set_max_connections
		do
			Result := max_connections_address[0]
		end

	set_max_connections (a_max_connections: INTEGER_32)
		do
			max_connections_address[0] := a_max_connections
		end

	max_connections_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	max_connections_to_host: INTEGER_32 assign set_max_connections_to_host
		do
			Result := max_connections_to_host_address[0]
		end

	set_max_connections_to_host (a_max_connections_to_host: INTEGER_32)
		do
			max_connections_to_host_address[0] := a_max_connections_to_host
		end

	max_connections_to_host_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	max_tries: INTEGER_32 assign set_max_tries
		do
			Result := max_tries_address[0]
		end

	set_max_tries (a_max_tries: INTEGER_32)
		do
			max_tries_address[0] := a_max_tries
		end

	max_tries_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	receive_timeout: INTEGER_32 assign set_receive_timeout
		do
			Result := receive_timeout_address[0]
		end

	set_receive_timeout (a_receive_timeout: INTEGER_32)
		do
			receive_timeout_address[0] := a_receive_timeout
		end

	receive_timeout_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	unrestartable_receive_timeout: INTEGER_32 assign set_unrestartable_receive_timeout
		do
			Result := unrestartable_receive_timeout_address[0]
		end

	set_unrestartable_receive_timeout (a_unrestartable_receive_timeout: INTEGER_32)
		do
			unrestartable_receive_timeout_address[0] := a_unrestartable_receive_timeout
		end

	unrestartable_receive_timeout_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	screen_width: INTEGER_32 assign set_screen_width
		do
			Result := screen_width_address[0]
		end

	set_screen_width (a_screen_width: INTEGER_32)
		do
			screen_width_address[0] := a_screen_width
		end

	screen_width_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	dump_codepage: INTEGER_32 assign set_dump_codepage
		do
			Result := dump_codepage_address[0]
		end

	set_dump_codepage (a_dump_codepage: INTEGER_32)
		do
			dump_codepage_address[0] := a_dump_codepage
		end

	dump_codepage_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	max_format_cache_entries: INTEGER_32 assign set_max_format_cache_entries
		do
			Result := max_format_cache_entries_address[0]
		end

	set_max_format_cache_entries (a_max_format_cache_entries: INTEGER_32)
		do
			max_format_cache_entries_address[0] := a_max_format_cache_entries
		end

	max_format_cache_entries_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	memory_cache_size: INTEGER_32 assign set_memory_cache_size
		do
			Result := memory_cache_size_address[0]
		end

	set_memory_cache_size (a_memory_cache_size: INTEGER_32)
		do
			memory_cache_size_address[0] := a_memory_cache_size
		end

	memory_cache_size_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	enable_html_tables: INTEGER_32 assign set_enable_html_tables

	set_enable_html_tables (a_enable_html_tables: INTEGER_32)
		do
			enable_html_tables := a_enable_html_tables
		end

	enable_html_frames: INTEGER_32 assign set_enable_html_frames

	set_enable_html_frames (a_enable_html_frames: INTEGER_32)
		do
			enable_html_frames := a_enable_html_frames
		end

	display_images: INTEGER_32 assign set_display_images

	set_display_images (a_display_images: INTEGER_32)
		do
			display_images := a_display_images
		end

	dds: PD_DOCUMENT_SETUP

	default_fg: PD_RGB

	default_bg: PD_RGB

	default_link: PD_RGB

	default_vlink: PD_RGB

	default_left_margin: INTEGER_32 assign set_default_left_margin

	set_default_left_margin (a_default_left_margin: INTEGER_32)
		do
			default_left_margin := a_default_left_margin
		end

	http_proxy: CE_ARRAY [NATURAL_8]

	ftp_proxy: CE_ARRAY [NATURAL_8]

	download_dir: CE_ARRAY [NATURAL_8]

	ftp_options: PD_FTP_OPTIONS

	http_bugs: PD_HTTP_BUGS

	links_options: CE_ARRAY [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]

	html_options: CE_ARRAY [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]

feature {ANY} -- routines

	get_system_name
		local
			l_f: CE_POINTER [SD_IO_FILE]
			l_p: CE_POINTER [NATURAL_8]
			l_name: SD_UTSNAME
			l_str: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_f.make
			create l_p.make
			create l_name.make
			create l_str.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					memset (create {CE_POINTER [ANY]}.make_cast ((l_name.address)), 0, {SD_UTSNAME}.sizeof.to_natural_32).do_nothing
					if not (uname (l_name.address)).to_boolean then
						l_str.ce_gets ((links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 11)))
						l_l := 0
						links_inst.add_to_str (l_str.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast ((l_name.sysname)))
						links_inst.add_to_str (l_str.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
						links_inst.add_to_str (l_str.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast ((l_name.release)))
						links_inst.add_to_str (l_str.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
						links_inst.add_to_str (l_str.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast ((l_name.machine)))
						if l_l >= 1024 then
							l_str[1023] := (0).to_natural_8
						end
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (links_inst.system_name), create {CE_POINTER [INTEGER_8]}.make_cast (l_str)).do_nothing
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 20, create {CE_POINTER [ANY]}.make_cast (l_str))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						memset (create {CE_POINTER [ANY]}.make_cast (links_inst.system_name), 0, (1024).to_natural_32).do_nothing
						l_f.ce_gets (popen (ce_string ("uname -srm"), ce_string ("r")))
						if (l_f).c_pointer = default_pointer then
							l_pos := -1 + 5 -- goto fail
						end
				when 2 then
						if (fread (create {CE_POINTER [ANY]}.make_cast (links_inst.system_name), (1).to_natural_32, (1023).to_natural_32, l_f)) <= {NATURAL_32} 0 then
							pclose (l_f).do_nothing
							l_pos := -1 + 5 -- goto fail
						end
				when 3 then
						pclose (l_f).do_nothing
						l_p.ce_gets (links_inst.system_name)
						from
						until
							not (not js.loop_left and then ((l_p.item).to_boolean))
						loop
							js.reset
							if (l_p.item).to_integer_32 < 32 then
								l_p.item := (0).to_natural_8
								js.break
							end
							if not js.loop_jumped then
								l_p.ce_gets (l_p + 1)
							end
						end
						js.reset
						if (links_inst.system_name[0]).to_boolean then
							js.return
						end
				when 4 then -- if done
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 5 then -- if: | fail:
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (links_inst.system_name), ce_string ("Unix")).do_nothing
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	p_arse_options (a_argc: INTEGER_32; a_argv: CE_POINTER [CE_POINTER [NATURAL_8]]; a_opt: CE_POINTER [CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]]): CE_POINTER [NATURAL_8]
		local
			l_argc: INTEGER_32
			l_argv: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_e: CE_POINTER [NATURAL_8]
			l_u: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
			l_options: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]
			l_op: CE_POINTER [CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_argv.make
			create l_e.make
			create l_u.make
			create l_options.make
			create l_op.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_argc := a_argc
					l_argv.ce_gets (a_argv)
					l_u.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_argc.to_boolean)) then
						l_pos := -1 + 19 -- skip loop
					end
				when 2 then -- loop body:
						l_argv.ce_gets (l_argv + 1)
						l_argc := l_argc - 1
						if ((l_argv[-1])[0]).to_integer_32 /= 45 then
							l_pos := -1 + 15 -- skip if block
						end
				when 3 then -- if:
						l_op.ce_gets (a_opt)
				when 4 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 12 -- skip loop
						end
				when 5 then -- loop body:
						js.reset
						l_options.ce_gets (l_op.item)
						if (l_options).c_pointer = default_pointer then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if:
						l_i := 0
				when 7 then -- loop condition:
						if not (not js.loop_left and then (((l_options + l_i).item.p).to_boolean)) then
							l_pos := -1 + 10 -- skip loop
						end
				when 8 then -- loop body:
						if (((l_options + l_i).item.rd_cmd).c_pointer /= default_pointer) then
							if (((l_options + l_i).item.cmd_name).c_pointer /= default_pointer) then
								if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_options + l_i).item.cmd_name), create {CE_POINTER [INTEGER_8]}.make_cast ((l_argv[-1] + 1)))).to_boolean then
									l_e.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (((l_options + l_i).item.rd_cmd).pointer_item ([l_options + l_i, l_argv.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_argc)])))
									if ((l_e).c_pointer /= default_pointer) then
										if (l_e[0]).to_boolean then
											Io.error.put_string ("Error parsing option " + eif_string (create {CE_POINTER [INTEGER_8]}.make_shared ((l_argv[-1]).c_pointer)) + ": " + eif_string (create {CE_POINTER [INTEGER_8]}.make_shared (l_e.c_pointer)) + "%N")
										end
										Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
										js.return
									end
									if not js.return_called then
										l_pos := -1 + 17 -- goto found
									end
								end
							end
						end
				when 9 then
						if not js.return_called then
							l_i := l_i + 1
						end
						l_pos := -1 + 7 -- back to loop condition
				when 10 then -- loop done
						if not js.return_called then
							l_op.ce_gets (l_op + 1)
						end
				when 11 then -- if done
						l_pos := -1 + 4 -- back to loop condition
				when 12 then -- loop done
						js.reset
						if js.return_called then
							l_pos := -1 + 14 -- skip if block
						end
				when 13 then -- if: | uu:
						Io.error.put_string ("Unknown option " + eif_string (create {CE_POINTER [INTEGER_8]}.make_shared ((l_argv[-1]).c_pointer)) + "%N")
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
				when 14 then -- if done | if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						if (l_u).c_pointer = default_pointer then
							l_u.ce_gets (l_argv[-1])
						else
							l_pos := -1 + 13 -- goto uu
						end
				when 16 then
						if js.return_called then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | found:
						
				when 18 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 19 then -- loop done
					if not js.return_called and then ((l_u).c_pointer /= default_pointer) then
						Result := l_u
						js.return
					end
					if not js.return_called then
						Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
					end
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	parse_options (a_argc: INTEGER_32; a_argv: CE_POINTER [CE_POINTER [NATURAL_8]]): CE_POINTER [NATURAL_8]
		do
			Result := (p_arse_options (a_argc, a_argv, all_options))
		end

	get_token (a_line: CE_POINTER [CE_POINTER [NATURAL_8]]): CE_POINTER [NATURAL_8]
		local
			l_s: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_escape: INTEGER_32
			l_quote: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_l := 0
					l_escape := 0
					l_quote := 0
					from
					until
						js.loop_left
					loop
						js.reset
						if ((a_line.item).item).to_integer_32 /= 32 then
							if ((a_line.item).item).to_integer_32 /= 9 then
								js.break
							end
						end
						if not js.loop_jumped then
							a_line.item := (a_line.item) + 1
						end
					end
					js.reset
					if not (((a_line.item).item).to_boolean) then
						l_pos := -1 + 19 -- skip if block
					end
				when 1 then -- if:
						l_s.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 90))
				when 2 then -- loop condition:
						if not (not js.loop_left and then (((a_line.item).item).to_boolean)) then
							l_pos := -1 + 18 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if not (l_escape.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_escape := 0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 6 then -- else:
						if ((a_line.item).item).to_integer_32 /= 92 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_escape := 1
						js.continue
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 9 then -- else:
						if ((a_line.item).item).to_integer_32 /= 34 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_quote := (not l_quote.to_boolean).to_integer
						js.continue
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 12 then -- else:
						if ((a_line.item).item).to_integer_32 /= 32 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 15 then -- else:
						if ((a_line.item).item).to_integer_32 /= 9 then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L:
						if not l_quote.to_boolean then
							js.break
						end
				when 17 then -- if done | if done | if done | if done
						if not js.loop_jumped then
							links_inst.add_chr_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (a_line.item).item)
						end
						if not js.loop_left then
							a_line.item := (a_line.item) + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 18 then -- loop done
						js.reset
				when 19 then -- if done
					Result := l_s
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	parse_config_file (a_name: CE_POINTER [NATURAL_8]; a_file: CE_POINTER [NATURAL_8]; a_opt: CE_POINTER [CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]])
		local
			l_file: CE_POINTER [NATURAL_8]
			l_options: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]
			l_op: CE_POINTER [CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]]
			l_err: INTEGER_32
			l_line: INTEGER_32
			l_e: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
			l_n: CE_POINTER [NATURAL_8]
			l_p: CE_POINTER [NATURAL_8]
			l_tok: CE_POINTER [NATURAL_8]
			l_nl: INTEGER_32
			l_pl: INTEGER_32
			l_o: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_file.make
			create l_options.make
			create l_op.make
			create l_e.make
			create l_n.make
			create l_p.make
			create l_tok.make
			create l_o.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_file.ce_gets (a_file)
					l_err := 0
					l_line := 0
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_file[0]).to_boolean)) then
						l_pos := -1 + 24 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_line := l_line + 1
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_file[0]).to_boolean then
								if (l_file[0]).to_integer_32 /= 32 then
									if (l_file[0]).to_integer_32 /= 9 then
										js.break
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_file.ce_gets (l_file + 1)
							end
						end
						js.reset
						l_n.ce_gets (l_file)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_file[0]).to_boolean then
								if not ((l_file[0]).to_integer_32 > 32) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_file.ce_gets (l_file + 1)
							end
						end
						js.reset
						if (l_file.c_pointer.to_integer_32).to_natural_32 = (l_n.c_pointer.to_integer_32).to_natural_32 then
							if (l_file[0]).to_boolean then
								l_file.ce_gets (l_file + 1)
							end
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 23 -- skip if block
						end
				when 3 then -- if:
						l_nl := l_file.distance (l_n)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_file[0]).to_integer_32 /= 9 then
								if (l_file[0]).to_integer_32 /= 32 then
									js.break
								end
							end
							if not js.loop_jumped then
								l_file.ce_gets (l_file + 1)
							end
						end
						js.reset
						l_p.ce_gets (l_file)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_file[0]).to_boolean then
								if (l_file[0]).to_integer_32 /= 10 then
									if (l_file[0]).to_integer_32 = 13 then
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_file.ce_gets (l_file + 1)
							end
						end
						js.reset
						l_pl := l_file.distance (l_p)
						if not ((l_file[0]).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						if (l_file[1]).to_integer_32 /= 10 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if (l_file[1]).to_integer_32 /= 13 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if (l_file[0]).to_integer_32 /= (l_file[1]).to_integer_32 then
							l_file.ce_gets (l_file + 1)
						end
				when 9 then -- if done
						l_file.ce_gets (l_file + 1)
				when 10 then -- if done
						l_tok.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						if (l_n[0]).to_integer_32 = 35 then
							l_pos := -1 + 22 -- goto f
						end
				when 11 then
						l_tok.ce_gets (get_token (l_n.address))
						if (l_tok).c_pointer = default_pointer then
							l_pos := -1 + 22 -- goto f
						end
				when 12 then
						l_nl := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tok))).to_integer_32
						l_op.ce_gets (a_opt)
				when 13 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 21 -- skip loop
						end
				when 14 then -- loop body:
						js.reset
						l_options.ce_gets (l_op.item)
						if (l_options).c_pointer = default_pointer then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 20 -- skip if block
						end
				when 15 then -- if:
						l_i := 0
				when 16 then -- loop condition:
						if not (((l_options + l_i).item.p).to_boolean) then
							l_pos := -1 + 19 -- skip loop
						end
				when 17 then -- loop body:
						if (((l_options + l_i).item.cfg_name).c_pointer /= default_pointer) then
							if l_nl.to_natural_32 = (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_options + l_i).item.cfg_name))) then
								if not (links_inst.casecmp (l_tok, (l_options + l_i).item.cfg_name, l_nl.to_natural_32)).to_boolean then
									l_o.ce_gets ((links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 144, l_p, l_pl)))
									l_e.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (((l_options + l_i).item.rd_cfg).pointer_item ([l_options + l_i, l_o])))
									if ((l_e).c_pointer /= default_pointer) then
										if (l_e[0]).to_boolean then
											Io.error.put_string ("Error parsing config file " + eif_string (create {CE_POINTER [INTEGER_8]}.make_shared (a_name.c_pointer)) + ", line " + l_line.out + ": " + eif_string (create {CE_POINTER [INTEGER_8]}.make_shared (l_e.c_pointer)) + "%N")
											l_err := 1
										end
									end
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 148, create {CE_POINTER [ANY]}.make_cast (l_o))
									l_pos := -1 + 22 -- goto f
								end
							end
						end
				when 18 then
						l_i := l_i + 1
						l_pos := -1 + 16 -- back to loop condition
				when 19 then -- loop done
						l_op.ce_gets (l_op + 1)
				when 20 then -- if done
						l_pos := -1 + 13 -- back to loop condition
				when 21 then -- loop done
						js.reset
						Io.error.put_string ("Unknown option in config file " + eif_string (create {CE_POINTER [INTEGER_8]}.make_shared (a_name.c_pointer)) + ", line " + l_line.out + "%N")
						l_err := 1
				when 22 then -- f:
						if ((l_tok).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 154, create {CE_POINTER [ANY]}.make_cast (l_tok))
						end
				when 23 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 24 then -- loop done
					if l_err.to_boolean then
						Io.error.put_string ("%/7/")
						sleep ({NATURAL_32} 3).do_nothing
					end
				when 25 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	create_config_string (a_options: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]): CE_POINTER [NATURAL_8]
		local
			l_s: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_i: INTEGER_32
		do
			create l_s.make

			l_s.ce_gets ((links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 161)))
			l_l := 0
			links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("# This file is automatically generated by Links -- please do not edit.")))
			l_i := 0
			from
			until
				not (((a_options + l_i).item.p).to_boolean)
			loop
				if (((a_options + l_i).item.wr_cfg).c_pointer /= default_pointer) then
					((a_options + l_i).item.wr_cfg).call ([a_options + l_i, l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l)])
				end
				l_i := l_i + 1
			end
			links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
			Result := l_s
		end

	read_config_file (a_name: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_h: INTEGER_32
			l_r: INTEGER_32
			l_l: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make

			l_l := 0
			l_h := open ([create {CE_POINTER [INTEGER_8]}.make_cast (a_name), 256])
			if l_h = -1 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				os_dep_inst.set_bin (l_h)
				l_s.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 182))
				from
				until
					js.loop_left
				loop
					js.reset
					l_r := read (l_h, create {CE_POINTER [ANY]}.make_cast (cfg_buffer), (1024).to_natural_32)
					if not (l_r > 0) then
						js.break
					end
					if not js.loop_jumped then
						l_i := 0
						from
						until
							not (l_i < l_r)
						loop
							if not (cfg_buffer[l_i]).to_boolean then
								cfg_buffer[l_i] := ((' ').code).to_natural_8
							end
							l_i := l_i + 1
						end
						links_inst.add_bytes_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), cfg_buffer, l_r)
					end
				end
				js.reset
				if l_r = -1 then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 188, create {CE_POINTER [ANY]}.make_cast (l_s))
					l_s.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				end
				close (l_h).do_nothing
				Result := l_s
			end
		end

	write_to_config_file (a_name: CE_POINTER [NATURAL_8]; a_c: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_rr: INTEGER_32
			l_r: INTEGER_32
			l_h: INTEGER_32
			l_w: INTEGER_32
			l_tmp_name: CE_POINTER [NATURAL_8]
			l_ds: CE_POINTER [NATURAL_8]
			l_dt: CE_POINTER [NATURAL_8]
			l_dot: CE_POINTER [NATURAL_8]
			l_err: INTEGER_32
			l_tmp___5: INTEGER_32
			l_err___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_tmp_name.make
			create l_ds.make
			create l_dt.make
			create l_dot.make

			l_tmp_name.ce_gets ((links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 198, a_name)))
			l_ds.ce_gets (l_tmp_name)
			l_dt.ce_gets (l_ds)
			from
			until
				not ((l_dt.item).to_boolean)
			loop
				if (os_dep_inst.dir_sep ((l_dt.item).to_integer_8)).to_boolean then
					l_ds.ce_gets (l_dt)
				end
				l_dt.ce_gets (l_dt + 1)
			end
			l_dot.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_ds), ('.').code))))
			if ((l_dot).c_pointer /= default_pointer) then
				l_dot.item := (0).to_natural_8
			end
			links_inst.add_to_strn (l_tmp_name.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".tmp")))
			l_h := open ([create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp_name), 833, 438])
			if l_h = -1 then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 204, create {CE_POINTER [ANY]}.make_cast (l_tmp_name))
				Result := ((errno_location).item)
				js.return
			end
			if not js.return_called then
				os_dep_inst.set_bin (l_h)
				l_rr := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_c))).to_integer_32
				l_r := l_rr
				from
				until
					not (not js.loop_left and then (l_r > 0))
				loop
					l_w := write (l_h, create {CE_POINTER [ANY]}.make_cast (((a_c + l_rr) - l_r)), l_r.to_natural_32)
					if l_w <= 0 then
						if not l_w.to_boolean then
							l_tmp___5 := 28
						else
							l_tmp___5 := (errno_location).item
						end
						l_err := l_tmp___5
						close (l_h).do_nothing
						unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp_name)).do_nothing
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 215, create {CE_POINTER [ANY]}.make_cast (l_tmp_name))
						Result := l_err
						js.return
					end
					if not js.return_called then
						l_r := l_r - l_w
					end
				end
			end
			if not js.return_called then
				close (l_h).do_nothing
				if (rename2 (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp_name), create {CE_POINTER [INTEGER_8]}.make_cast (a_name))).to_boolean then
					l_err___0 := (errno_location).item
					unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp_name)).do_nothing
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 227, create {CE_POINTER [ANY]}.make_cast (l_tmp_name))
					Result := l_err___0
					js.return
				end
			end
			if not js.return_called then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 230, create {CE_POINTER [ANY]}.make_cast (l_tmp_name))
				Result := 0
			end
		end

	get_home (a_n: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		local
			l_st: SD_STAT
			l_home___0: CE_POINTER [NATURAL_8]
			l_home_links: CE_POINTER [NATURAL_8]
			l_config_dir: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_st.make
			create l_home___0.make
			create l_home_links.make
			create l_config_dir.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_home___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_config_dir.ce_gets ((links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 239, create {CE_POINTER [NATURAL_8]}.make_cast ((getenv (ce_string ("CONFIG_DIR")))))))
					if ((a_n).c_pointer /= default_pointer) then
						a_n.item := 1
					end
					if (l_home___0).c_pointer = default_pointer then
						l_home___0.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 245, create {CE_POINTER [NATURAL_8]}.make_cast ((getenv (ce_string ("HOME"))))))
					end
					if ((l_home___0).c_pointer /= default_pointer) then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						l_home___0.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 254, links_inst.path_to_exe))
						if (l_home___0).c_pointer = default_pointer then
							if ((l_config_dir).c_pointer /= default_pointer) then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 256, create {CE_POINTER [ANY]}.make_cast (l_config_dir))
							end
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
						if js.return_called then
							l_pos := -1 + 8 -- skip if block
						end
				when 2 then -- if:
						l_i := ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_home___0))) - {NATURAL_32} 1).to_integer_32
				when 3 then -- loop condition:
						if not (l_i >= 0) then
							l_pos := -1 + 6 -- skip loop
						end
				when 4 then -- loop body:
						if (os_dep_inst.dir_sep ((l_home___0[l_i]).to_integer_8)).to_boolean then
							l_home___0[(l_i + 1)] := (0).to_natural_8
							l_pos := -1 + 7 -- goto br
						end
				when 5 then
						l_i := l_i - 1
						l_pos := -1 + 3 -- back to loop condition
				when 6 then -- loop done
						l_home___0[0] := (0).to_natural_8
				when 7 then -- br:
						
				when 8 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 21 -- skip if block
						end
				when 9 then -- if:
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_home___0[0]).to_boolean then
									if not (os_dep_inst.dir_sep ((l_home___0[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_home___0))) - {NATURAL_32} 1).to_integer_32]).to_integer_8)).to_boolean then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_home___0[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_home___0))) - {NATURAL_32} 1).to_integer_32] := (0).to_natural_8
								end
							end
							js.reset
							if (l_home___0[0]).to_boolean then
								links_inst.add_to_strn (l_home___0.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/")))
							end
							l_home_links.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 268, l_home___0))
							if ((l_config_dir).c_pointer /= default_pointer) then
								links_inst.add_to_strn (l_home_links.address, l_config_dir)
								from
								until
									js.loop_left
								loop
									js.reset
									if (l_home_links[0]).to_boolean then
										if not (os_dep_inst.dir_sep ((l_home_links[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_home_links))) - {NATURAL_32} 1).to_integer_32]).to_integer_8)).to_boolean then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_home_links[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_home_links))) - {NATURAL_32} 1).to_integer_32] := (0).to_natural_8
									end
								end
								js.reset
								if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_home_links), (l_st.address))) /= -1 then
									if ((l_st.st_mode).bit_and ({NATURAL_32} 61440)) = {NATURAL_32} 16384 then
										links_inst.add_to_strn (l_home_links.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/links")))
									else
										Io.error.put_string ("CONFIG_DIR set to " + eif_string (create {CE_POINTER [INTEGER_8]}.make_shared (l_config_dir.c_pointer)) + ". But directory " + eif_string (create {CE_POINTER [INTEGER_8]}.make_shared (l_home_links.c_pointer)) + " doesn%'t exist.%N%/7/")
										sleep ({NATURAL_32} 3).do_nothing
										error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 278, create {CE_POINTER [ANY]}.make_cast (l_home_links))
										l_home_links.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 279, l_home___0))
										links_inst.add_to_strn (l_home_links.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".links")))
									end
								else
									Io.error.put_string ("CONFIG_DIR set to " + eif_string (create {CE_POINTER [INTEGER_8]}.make_shared (l_config_dir.c_pointer)) + ". But directory " + eif_string (create {CE_POINTER [INTEGER_8]}.make_shared (l_home_links.c_pointer)) + " doesn%'t exist.%N%/7/")
									sleep ({NATURAL_32} 3).do_nothing
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 278, create {CE_POINTER [ANY]}.make_cast (l_home_links))
									l_home_links.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 279, l_home___0))
									links_inst.add_to_strn (l_home_links.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".links")))
								end
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 282, create {CE_POINTER [ANY]}.make_cast (l_config_dir))
							else
								links_inst.add_to_strn (l_home_links.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".links")))
							end
							if not ((stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_home_links), (l_st.address))).to_boolean) then
								l_pos := -1 + 13 -- skip if block
							end
				when 10 then -- if:
							if not (mkdir (create {CE_POINTER [INTEGER_8]}.make_cast (l_home_links), (511).to_natural_32)).to_boolean then
								l_pos := -1 + 23 -- goto home_creat
							end
				when 11 then
							if ((l_config_dir).c_pointer /= default_pointer) then
								l_pos := -1 + 20 -- goto failed
							end
				when 12 then
							l_pos := -1 + 15 -- goto first_failed
				when 13 then
							if ((l_st.st_mode).bit_and ({NATURAL_32} 61440)) = {NATURAL_32} 16384 then
								l_pos := -1 + 22 -- goto home_ok
							end
				when 14 then
							if not (mkdir (create {CE_POINTER [INTEGER_8]}.make_cast (l_home_links), (511).to_natural_32)).to_boolean then
								l_pos := -1 + 23 -- goto home_creat
							end
				when 15 then -- first_failed:
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 297, create {CE_POINTER [ANY]}.make_cast (l_home_links))
							l_home_links.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 298, l_home___0))
							links_inst.add_to_strn (l_home_links.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("links")))
							if not ((stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_home_links), (l_st.address))).to_boolean) then
								l_pos := -1 + 18 -- skip if block
							end
				when 16 then -- if:
							if not (mkdir (create {CE_POINTER [INTEGER_8]}.make_cast (l_home_links), (511).to_natural_32)).to_boolean then
								l_pos := -1 + 23 -- goto home_creat
							end
				when 17 then
							l_pos := -1 + 20 -- goto failed
				when 18 then
							if ((l_st.st_mode).bit_and ({NATURAL_32} 61440)) = {NATURAL_32} 16384 then
								l_pos := -1 + 22 -- goto home_ok
							end
				when 19 then
							if not (mkdir (create {CE_POINTER [INTEGER_8]}.make_cast (l_home_links), (511).to_natural_32)).to_boolean then
								l_pos := -1 + 23 -- goto home_creat
							end
				when 20 then -- failed:
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 313, create {CE_POINTER [ANY]}.make_cast (l_home_links))
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 314, create {CE_POINTER [ANY]}.make_cast (l_home___0))
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
				when 21 then -- if done
						if js.return_called then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if: | home_ok:
							if ((a_n).c_pointer /= default_pointer) then
								a_n.item := 0
							end
				when 23 then -- home_creat:
							chmod (create {CE_POINTER [INTEGER_8]}.make_cast (l_home_links), (448).to_natural_32).do_nothing
							links_inst.add_to_strn (l_home_links.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/")))
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 324, create {CE_POINTER [ANY]}.make_cast (l_home___0))
							Result := l_home_links
				when 24 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	init_home
		local
			js: JUMP_STATE
		do
			get_system_name
			links_home.ce_gets (get_home (first_use_address))
			if (links_home).c_pointer = default_pointer then
				Io.error.put_string ("Unable to find or create links config directory. Please check, that you have $HOME variable set correctly and that you have write permission to your home directory.%N%/7/")
				sleep ({NATURAL_32} 3).do_nothing
				js.return
			end
			if not js.return_called then
			end
		end

	load_config_file (a_prefix: CE_POINTER [NATURAL_8]; a_name: CE_POINTER [NATURAL_8])
		local
			l_c: CE_POINTER [NATURAL_8]
			l_config_file: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_c.make
			create l_config_file.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_config_file.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 342, a_prefix))
					if (l_config_file).c_pointer = default_pointer then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						links_inst.add_to_strn (l_config_file.address, a_name)
						l_c.ce_gets (read_config_file (l_config_file))
						if ((l_c).c_pointer /= default_pointer) then
							l_pos := -1 + 7 -- goto ok
						end
				when 2 then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 346, create {CE_POINTER [ANY]}.make_cast (l_config_file))
						l_config_file.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 347, a_prefix))
						if (l_config_file).c_pointer = default_pointer then
							js.return
						end
				when 3 then -- if done
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 4 then -- if:
						links_inst.add_to_strn (l_config_file.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".")))
						links_inst.add_to_strn (l_config_file.address, a_name)
						l_c.ce_gets (read_config_file (l_config_file))
						if ((l_c).c_pointer /= default_pointer) then
							l_pos := -1 + 7 -- goto ok
						end
				when 5 then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 352, create {CE_POINTER [ANY]}.make_cast (l_config_file))
						js.return
				when 6 then -- if done
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 7 then -- if: | ok:
						parse_config_file (l_config_file, l_c, all_options)
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 356, create {CE_POINTER [ANY]}.make_cast (l_c))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 357, create {CE_POINTER [ANY]}.make_cast (l_config_file))
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	load_config
		do
			load_config_file (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/etc/")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("links.cfg")))
			load_config_file (links_home, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("links.cfg")))
			load_config_file (links_home, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.cfg")))
			load_config_file (links_home, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("user.cfg")))
		end

	write_config_data (a_prefix: CE_POINTER [NATURAL_8]; a_name: CE_POINTER [NATURAL_8]; a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_term: CE_POINTER [PD_TERMINAL]): INTEGER_32
		local
			l_err: INTEGER_32
			l_c: CE_POINTER [NATURAL_8]
			l_config_file: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_c.make
			create l_config_file.make

			l_c.ce_gets (create_config_string (a_o))
			if (l_c).c_pointer = default_pointer then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				l_config_file.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 375, a_prefix))
				if (l_config_file).c_pointer = default_pointer then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 377, create {CE_POINTER [ANY]}.make_cast (l_c))
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				links_inst.add_to_strn (l_config_file.address, a_name)
				l_err := write_to_config_file (l_config_file, l_c)
				if l_err.to_boolean then
					if ((a_term).c_pointer /= default_pointer) then
						bfu_inst.msg_box ([a_term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 10, 129, links_inst.dummyarray + 11, ce_string (": "), (session_inst.get_err_msg (-l_err)), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
					end
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 383, create {CE_POINTER [ANY]}.make_cast (l_c))
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 384, create {CE_POINTER [ANY]}.make_cast (l_config_file))
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 387, create {CE_POINTER [ANY]}.make_cast (l_c))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 388, create {CE_POINTER [ANY]}.make_cast (l_config_file))
				Result := 0
			end
		end

	write_config (a_term: CE_POINTER [PD_TERMINAL])
		do
			write_config_data (links_home, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("links.cfg")), links_options, a_term).do_nothing
		end

	write_config_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent write_config)
		end

	write_html_config (a_term: CE_POINTER [PD_TERMINAL])
		do
			write_config_data (links_home, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.cfg")), html_options, a_term).do_nothing
		end

	add_nm (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32])
		do
			if (a_l.item).to_boolean then
				links_inst.add_to_str (a_s, a_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
			end
			links_inst.add_to_str (a_s, a_l, a_o.item.cfg_name)
			links_inst.add_to_str (a_s, a_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
		end

	add_quoted_to_str (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_q: CE_POINTER [NATURAL_8])
		local
			l_q: CE_POINTER [NATURAL_8]
		do
			create l_q.make

			l_q.ce_gets (a_q)
			links_inst.add_chr_to_str (a_s, a_l, (('%"').code).to_natural_8)
			from
			until
				not ((l_q.item).to_boolean)
			loop
				if (l_q.item).to_integer_32 = 34 then
					links_inst.add_chr_to_str (a_s, a_l, (('\').code).to_natural_8)
				elseif (l_q.item).to_integer_32 = 92 then
					links_inst.add_chr_to_str (a_s, a_l, (('\').code).to_natural_8)
				end
				links_inst.add_chr_to_str (a_s, a_l, l_q.item)
				l_q.ce_gets (l_q + 1)
			end
			links_inst.add_chr_to_str (a_s, a_l, (('%"').code).to_natural_8)
		end

	num_rd (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_c: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_c: CE_POINTER [NATURAL_8]
			l_tok: CE_POINTER [NATURAL_8]
			l_end: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			js: JUMP_STATE
		do
			create l_c.make
			create l_tok.make
			create l_end.make

			l_c.ce_gets (a_c)
			l_tok.ce_gets ((get_token (l_c.address)))
			if (l_tok).c_pointer = default_pointer then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Missing argument")))
				js.return
			end
			if not js.return_called then
				l_l := links_inst.strtolx (l_tok, l_end.address)
				if (l_end.item).to_boolean then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 428, create {CE_POINTER [ANY]}.make_cast (l_tok))
					Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Number expected")))
					js.return
				end
			end
			if not js.return_called then
				if l_l < (a_o.item.min).to_integer_32 then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 432, create {CE_POINTER [ANY]}.make_cast (l_tok))
					Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Out of range")))
					js.return
				elseif l_l > (a_o.item.max).to_integer_32 then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 432, create {CE_POINTER [ANY]}.make_cast (l_tok))
					Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Out of range")))
					js.return
				end
			end
			if not js.return_called then
				(create {CE_POINTER [INTEGER_32]}.make_cast (a_o.item.ptr)).item := l_l.to_integer_32
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 436, create {CE_POINTER [ANY]}.make_cast (l_tok))
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	num_rd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent num_rd)
		end

	num_wr (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32])
		do
			add_nm (a_o, a_s, a_l)
			links_inst.add_knum_to_str (a_s, a_l, (create {CE_POINTER [INTEGER_32]}.make_cast (a_o.item.ptr)).item)
		end

	num_wr_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent num_wr)
		end

	str_rd (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_c: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_c: CE_POINTER [NATURAL_8]
			l_tok: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_c.make
			create l_tok.make
			create l_e.make

			l_c.ce_gets (a_c)
			l_tok.ce_gets ((get_token (l_c.address)))
			l_e.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			if (l_tok).c_pointer = default_pointer then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tok))) + {NATURAL_32} 1 > (a_o.item.max).to_natural_32 then
					l_e.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("String too long")))
				else
					strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (a_o.item.ptr), create {CE_POINTER [INTEGER_8]}.make_cast (l_tok)).do_nothing
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 453, create {CE_POINTER [ANY]}.make_cast (l_tok))
				Result := l_e
			end
		end

	str_rd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent str_rd)
		end

	str_wr (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32])
		local
			l_s1: CE_POINTER [NATURAL_8]
			l_l1: INTEGER_32
		do
			create l_s1.make

			add_nm (a_o, a_s, a_l)
			if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_o.item.ptr))) + {NATURAL_32} 1 > (a_o.item.max).to_natural_32 then
				l_s1.ce_gets ((links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 461)))
				l_l1 := 0
				links_inst.add_bytes_to_str (l_s1.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l1), create {CE_POINTER [NATURAL_8]}.make_cast (a_o.item.ptr), a_o.item.max - 1)
				add_quoted_to_str (a_s, a_l, l_s1)
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 465, create {CE_POINTER [ANY]}.make_cast (l_s1))
			else
				add_quoted_to_str (a_s, a_l, create {CE_POINTER [NATURAL_8]}.make_cast (a_o.item.ptr))
			end
		end

	str_wr_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent str_wr)
		end

	cp_rd (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_c: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_c: CE_POINTER [NATURAL_8]
			l_tok: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			create l_c.make
			create l_tok.make
			create l_e.make

			l_c.ce_gets (a_c)
			l_tok.ce_gets ((get_token (l_c.address)))
			l_e.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			if (l_tok).c_pointer = default_pointer then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Missing argument")))
				js.return
			end
			if not js.return_called then
				l_i := charsets_inst.get_cp_index (l_tok)
				if l_i = -1 then
					l_e.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Unknown codepage")))
				elseif a_o.item.min = 1 then
					if (charsets_inst.is_cp_special (l_i)).to_boolean then
						l_e.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("UTF-8 can%'t be here")))
					else
						(create {CE_POINTER [INTEGER_32]}.make_cast (a_o.item.ptr)).item := l_i
					end
				else
					(create {CE_POINTER [INTEGER_32]}.make_cast (a_o.item.ptr)).item := l_i
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 479, create {CE_POINTER [ANY]}.make_cast (l_tok))
				Result := l_e
			end
		end

	cp_rd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cp_rd)
		end

	cp_wr (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32])
		local
			l_n: CE_POINTER [NATURAL_8]
		do
			create l_n.make

			l_n.ce_gets ((charsets_inst.get_cp_mime_name ((create {CE_POINTER [INTEGER_32]}.make_cast (a_o.item.ptr)).item)))
			add_nm (a_o, a_s, a_l)
			links_inst.add_to_str (a_s, a_l, l_n)
		end

	cp_wr_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cp_wr)
		end

	lang_rd (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_c: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_c: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
			l_tok: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_c.make
			create l_tok.make

			l_c.ce_gets (a_c)
			l_tok.ce_gets ((get_token (l_c.address)))
			if (l_tok).c_pointer = default_pointer then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Missing argument")))
				js.return
			end
			if not js.return_called then
				l_i := 0
				from
				until
					js.loop_left
				loop
					js.reset
					if not (l_i < (language_inst.n_languages)) then
						js.break
					end
					if not js.loop_jumped then
						if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast ((language_inst.language_name (l_i))), create {CE_POINTER [INTEGER_8]}.make_cast (l_tok))).to_boolean then
							language_inst.set_language (l_i)
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 498, create {CE_POINTER [ANY]}.make_cast (l_tok))
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called then
							l_i := l_i + 1
						end
					end
				end
				js.reset
			end
			if not js.return_called then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 501, create {CE_POINTER [ANY]}.make_cast (l_tok))
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Unknown language")))
			end
		end

	lang_rd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent lang_rd)
		end

	lang_wr (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32])
		do
			add_nm (a_o, a_s, a_l)
			add_quoted_to_str (a_s, a_l, (language_inst.language_name (links_inst.current_language)))
		end

	lang_wr_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent lang_wr)
		end

	getnum (a_s: CE_POINTER [NATURAL_8]; a_n: CE_POINTER [INTEGER_32]; a_r1: INTEGER_32; a_r2: INTEGER_32): INTEGER_32
		local
			l_e: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			js: JUMP_STATE
		do
			create l_e.make

			l_l := (strtol (create {CE_POINTER [INTEGER_8]}.make_cast (a_s), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast ((l_e.address)), 10))
			if (l_e.item).to_boolean then
				Result := (-1)
				js.return
			elseif not (a_s.item).to_boolean then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				if l_l < a_r1.to_integer_32 then
					Result := (-1)
					js.return
				elseif l_l >= a_r2.to_integer_32 then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				a_n.item := l_l.to_integer_32
				Result := 0
			end
		end

	type_rd (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_c: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_c: CE_POINTER [NATURAL_8]
			l_err: CE_POINTER [NATURAL_8]
			l_new: PD_ASSOC
			l_w: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_c.make
			create l_err.make
			create l_new.make
			create l_w.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c.ce_gets (a_c)
					l_err.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Error reading association specification")))
					memset (create {CE_POINTER [ANY]}.make_cast ((l_new.address)), 0, {PD_ASSOC}.sizeof.to_natural_32).do_nothing
					l_new.label := get_token (l_c.address)
					if (l_new.label).c_pointer = default_pointer then
						l_pos := -1 + 8 -- goto err
					end
				when 1 then
					l_new.ct := get_token (l_c.address)
					if (l_new.ct).c_pointer = default_pointer then
						l_pos := -1 + 8 -- goto err
					end
				when 2 then
					l_new.prog := get_token (l_c.address)
					if (l_new.prog).c_pointer = default_pointer then
						l_pos := -1 + 8 -- goto err
					end
				when 3 then
					l_w.ce_gets (get_token (l_c.address))
					if (l_w).c_pointer = default_pointer then
						l_pos := -1 + 8 -- goto err
					end
				when 4 then
					if (getnum (l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n), 0, 32)).to_boolean then
						l_pos := -1 + 9 -- goto err_f
					end
				when 5 then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 533, create {CE_POINTER [ANY]}.make_cast (l_w))
					l_new.cons := (((l_n).bit_and (1)).to_boolean).to_integer
					l_new.xwin := (((l_n).bit_and (2)).to_boolean).to_integer
					l_new.ask := (((l_n).bit_and (4)).to_boolean).to_integer
					if ((l_n).bit_and (8)).to_boolean then
						l_new.block := (((l_n).bit_and (16)).to_boolean).to_integer
					elseif ((l_n).bit_and (16)).to_boolean then
						l_new.block := (((l_n).bit_and (16)).to_boolean).to_integer
					else
						if not (l_new.xwin).to_boolean then
							l_tmp___0 := 1
						elseif (l_new.cons).to_boolean then
							l_tmp___0 := 1
						else
							l_tmp___0 := 0
						end
						l_new.block := l_tmp___0
					end
					l_w.ce_gets (get_token (l_c.address))
					if (l_w).c_pointer = default_pointer then
						l_pos := -1 + 8 -- goto err
					end
				when 6 then
					if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_w))) /= {NATURAL_32} 1 then
						l_pos := -1 + 9 -- goto err_f
					elseif (l_w[0]).to_integer_32 < 48 then
						l_pos := -1 + 9 -- goto err_f
					elseif (l_w[0]).to_integer_32 > 57 then
						l_pos := -1 + 9 -- goto err_f
					end
				when 7 then
					l_new.system := (l_w[0]).to_integer_32 - 48
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 542, create {CE_POINTER [ANY]}.make_cast (l_w))
					types_inst.update_assoc (l_new.address)
					l_err.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				when 8 then -- err:
					if ((l_new.label).c_pointer /= default_pointer) then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 546, create {CE_POINTER [ANY]}.make_cast (l_new.label))
					end
					if ((l_new.ct).c_pointer /= default_pointer) then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 547, create {CE_POINTER [ANY]}.make_cast (l_new.ct))
					end
					if ((l_new.prog).c_pointer /= default_pointer) then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 548, create {CE_POINTER [ANY]}.make_cast (l_new.prog))
					end
					Result := l_err
					js.return
					if js.return_called then
						l_pos := -1 + 10 -- skip if block
					end
				when 9 then -- if: | err_f:
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 551, create {CE_POINTER [ANY]}.make_cast (l_w))
						l_pos := -1 + 8 -- goto err
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	type_rd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent type_rd)
		end

	type_wr (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32])
		local
			l_a: CE_POINTER [PD_ASSOC]
		do
			create l_a.make

			l_a.ce_gets (create {CE_POINTER [PD_ASSOC]}.make_cast (types_inst.assoc.prev))
			from
			until
				(l_a.c_pointer.to_integer_32).to_natural_32 = ((types_inst.assoc.address).c_pointer.to_integer_32).to_natural_32
			loop
				add_nm (a_o, a_s, a_l)
				add_quoted_to_str (a_s, a_l, l_a.item.label)
				links_inst.add_to_str (a_s, a_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
				add_quoted_to_str (a_s, a_l, l_a.item.ct)
				links_inst.add_to_str (a_s, a_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
				add_quoted_to_str (a_s, a_l, l_a.item.prog)
				links_inst.add_to_str (a_s, a_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
				links_inst.add_num_to_str (a_s, a_l, ((((((l_a.item.cons).to_boolean).to_integer + ((l_a.item.xwin).to_boolean).to_integer * 2) + ((l_a.item.ask).to_boolean).to_integer * 4) + (not (l_a.item.block).to_boolean).to_integer * 8) + ((l_a.item.block).to_boolean).to_integer * 16).to_integer_32)
				links_inst.add_to_str (a_s, a_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
				links_inst.add_num_to_str (a_s, a_l, (l_a.item.system).to_integer_32)
				l_a.ce_gets (l_a.item.prev)
			end
		end

	type_wr_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent type_wr)
		end

	ext_rd (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_c: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_c: CE_POINTER [NATURAL_8]
			l_err: CE_POINTER [NATURAL_8]
			l_new: PD_EXTENSION
			l_pos: INTEGER_32
		do
			create l_c.make
			create l_err.make
			create l_new.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c.ce_gets (a_c)
					l_err.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Error reading extension specification")))
					memset (create {CE_POINTER [ANY]}.make_cast ((l_new.address)), 0, {PD_EXTENSION}.sizeof.to_natural_32).do_nothing
					l_new.ext := get_token (l_c.address)
					if (l_new.ext).c_pointer = default_pointer then
						l_pos := -1 + 3 -- goto err
					end
				when 1 then
					l_new.ct := get_token (l_c.address)
					if (l_new.ct).c_pointer = default_pointer then
						l_pos := -1 + 3 -- goto err
					end
				when 2 then
					types_inst.update_ext (l_new.address)
					l_err.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				when 3 then -- err:
					if ((l_new.ext).c_pointer /= default_pointer) then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 582, create {CE_POINTER [ANY]}.make_cast (l_new.ext))
					end
					if ((l_new.ct).c_pointer /= default_pointer) then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 583, create {CE_POINTER [ANY]}.make_cast (l_new.ct))
					end
					Result := l_err
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ext_rd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ext_rd)
		end

	ext_wr (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32])
		local
			l_a: CE_POINTER [PD_EXTENSION]
		do
			create l_a.make

			l_a.ce_gets (create {CE_POINTER [PD_EXTENSION]}.make_cast (types_inst.extensions.prev))
			from
			until
				(l_a.c_pointer.to_integer_32).to_natural_32 = ((types_inst.extensions.address).c_pointer.to_integer_32).to_natural_32
			loop
				add_nm (a_o, a_s, a_l)
				add_quoted_to_str (a_s, a_l, l_a.item.ext)
				links_inst.add_to_str (a_s, a_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
				add_quoted_to_str (a_s, a_l, l_a.item.ct)
				l_a.ce_gets (l_a.item.prev)
			end
		end

	ext_wr_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ext_wr)
		end

	prog_rd (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_c: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_c: CE_POINTER [NATURAL_8]
			l_err: CE_POINTER [NATURAL_8]
			l_prog: CE_POINTER [NATURAL_8]
			l_w: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_c.make
			create l_err.make
			create l_prog.make
			create l_w.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c.ce_gets (a_c)
					l_err.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Error reading program specification")))
					l_prog.ce_gets (get_token (l_c.address))
					if (l_prog).c_pointer = default_pointer then
						l_pos := -1 + 6 -- goto err_1
					end
				when 1 then
					l_w.ce_gets (get_token (l_c.address))
					if (l_w).c_pointer = default_pointer then
						l_pos := -1 + 5 -- goto err_2
					end
				when 2 then
					if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_w))) /= {NATURAL_32} 1 then
						l_pos := -1 + 4 -- goto err_3
					elseif (l_w[0]).to_integer_32 < 48 then
						l_pos := -1 + 4 -- goto err_3
					elseif (l_w[0]).to_integer_32 > 57 then
						l_pos := -1 + 4 -- goto err_3
					end
				when 3 then
					types_inst.update_prog (create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_o.item.ptr), l_prog, (l_w[0]).to_integer_32 - 48)
					l_err.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				when 4 then -- err_3:
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 608, create {CE_POINTER [ANY]}.make_cast (l_w))
				when 5 then -- err_2:
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 610, create {CE_POINTER [ANY]}.make_cast (l_prog))
				when 6 then -- err_1:
					Result := l_err
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	prog_rd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent prog_rd)
		end

	prog_wr (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32])
		local
			l_a: CE_POINTER [PD_PROTOCOL_PROGRAM]
			js: JUMP_STATE
		do
			create l_a.make

			l_a.ce_gets (create {CE_POINTER [PD_PROTOCOL_PROGRAM]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_o.item.ptr)).item.prev))
			from
			until
				(l_a.c_pointer.to_integer_32).to_natural_32 = ((a_o.item.ptr).c_pointer.to_integer_32).to_natural_32
			loop
				js.reset
				if not ((l_a.item.prog).item).to_boolean then
					js.continue
				end
				if not js.loop_jumped then
					add_nm (a_o, a_s, a_l)
					add_quoted_to_str (a_s, a_l, l_a.item.prog)
					links_inst.add_to_str (a_s, a_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
					links_inst.add_num_to_str (a_s, a_l, (l_a.item.system).to_integer_32)
				end
				l_a.ce_gets (l_a.item.prev)
			end
		end

	prog_wr_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent prog_wr)
		end

	term_rd (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_c: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_c: CE_POINTER [NATURAL_8]
			l_ts: CE_POINTER [PD_TERM_SPEC]
			l_w: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_c.make
			create l_ts.make
			create l_w.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c.ce_gets (a_c)
					l_w.ce_gets (get_token (l_c.address))
					if (l_w).c_pointer = default_pointer then
						l_pos := -1 + 13 -- goto err
					end
				when 1 then
					l_ts.ce_gets (terminal_inst.new_term_spec (l_w))
					if (l_ts).c_pointer = default_pointer then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 634, create {CE_POINTER [ANY]}.make_cast (l_w))
						l_pos := -1 + 11 -- goto end
					end
				when 2 then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 637, create {CE_POINTER [ANY]}.make_cast (l_w))
					l_w.ce_gets (get_token (l_c.address))
					if (l_w).c_pointer = default_pointer then
						l_pos := -1 + 13 -- goto err
					end
				when 3 then
					if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_w))) /= {NATURAL_32} 1 then
						l_pos := -1 + 12 -- goto err_f
					elseif (l_w[0]).to_integer_32 < 48 then
						l_pos := -1 + 12 -- goto err_f
					elseif (l_w[0]).to_integer_32 > 52 then
						l_pos := -1 + 12 -- goto err_f
					end
				when 4 then
					l_ts.item.mode := (l_w[0]).to_integer_32 - 48
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 641, create {CE_POINTER [ANY]}.make_cast (l_w))
					l_w.ce_gets (get_token (l_c.address))
					if (l_w).c_pointer = default_pointer then
						l_pos := -1 + 13 -- goto err
					end
				when 5 then
					if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_w))) /= {NATURAL_32} 1 then
						l_pos := -1 + 12 -- goto err_f
					elseif (l_w[0]).to_integer_32 < 48 then
						l_pos := -1 + 12 -- goto err_f
					elseif (l_w[0]).to_integer_32 > 49 then
						l_pos := -1 + 12 -- goto err_f
					end
				when 6 then
					l_ts.item.m11_hack := (l_w[0]).to_integer_32 - 48
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 645, create {CE_POINTER [ANY]}.make_cast (l_w))
					l_w.ce_gets (get_token (l_c.address))
					if (l_w).c_pointer = default_pointer then
						l_pos := -1 + 13 -- goto err
					end
				when 7 then
					if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_w))) /= {NATURAL_32} 1 then
						l_pos := -1 + 12 -- goto err_f
					elseif (l_w[0]).to_integer_32 < 48 then
						l_pos := -1 + 12 -- goto err_f
					elseif (l_w[0]).to_integer_32 > 55 then
						l_pos := -1 + 12 -- goto err_f
					end
				when 8 then
					l_ts.item.col := (((l_w[0]).to_integer_32 - 48)).bit_and (1)
					l_ts.item.restrict_852 := (((((l_w[0]).to_integer_32 - 48)).bit_and (2)).to_boolean).to_integer
					l_ts.item.block_cursor := (((((l_w[0]).to_integer_32 - 48)).bit_and (4)).to_boolean).to_integer
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 651, create {CE_POINTER [ANY]}.make_cast (l_w))
					l_w.ce_gets (get_token (l_c.address))
					if (l_w).c_pointer = default_pointer then
						l_pos := -1 + 13 -- goto err
					end
				when 9 then
					l_i := charsets_inst.get_cp_index (l_w)
					if l_i = -1 then
						l_pos := -1 + 12 -- goto err_f
					elseif (charsets_inst.is_cp_special (l_i)).to_boolean then
						l_pos := -1 + 12 -- goto err_f
					end
				when 10 then
					l_ts.item.charset := l_i
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 655, create {CE_POINTER [ANY]}.make_cast (l_w))
				when 11 then -- end:
					Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					js.return
					if js.return_called then
						l_pos := -1 + 14 -- skip if block
					end
				when 12 then -- if: | err_f:
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 659, create {CE_POINTER [ANY]}.make_cast (l_w))
				when 13 then -- err:
						Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Error reading terminal specification")))
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	term_rd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent term_rd)
		end

	term2_rd (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_c: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_c: CE_POINTER [NATURAL_8]
			l_ts: CE_POINTER [PD_TERM_SPEC]
			l_w: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_c.make
			create l_ts.make
			create l_w.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c.ce_gets (a_c)
					l_w.ce_gets (get_token (l_c.address))
					if (l_w).c_pointer = default_pointer then
						l_pos := -1 + 15 -- goto err
					end
				when 1 then
					l_ts.ce_gets (terminal_inst.new_term_spec (l_w))
					if (l_ts).c_pointer = default_pointer then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 671, create {CE_POINTER [ANY]}.make_cast (l_w))
						l_pos := -1 + 13 -- goto end
					end
				when 2 then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 674, create {CE_POINTER [ANY]}.make_cast (l_w))
					l_w.ce_gets (get_token (l_c.address))
					if (l_w).c_pointer = default_pointer then
						l_pos := -1 + 15 -- goto err
					end
				when 3 then
					if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_w))) /= {NATURAL_32} 1 then
						l_pos := -1 + 14 -- goto err_f
					elseif (l_w[0]).to_integer_32 < 48 then
						l_pos := -1 + 14 -- goto err_f
					elseif (l_w[0]).to_integer_32 > 52 then
						l_pos := -1 + 14 -- goto err_f
					end
				when 4 then
					l_ts.item.mode := (l_w[0]).to_integer_32 - 48
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 678, create {CE_POINTER [ANY]}.make_cast (l_w))
					l_w.ce_gets (get_token (l_c.address))
					if (l_w).c_pointer = default_pointer then
						l_pos := -1 + 15 -- goto err
					end
				when 5 then
					if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_w))) /= {NATURAL_32} 1 then
						l_pos := -1 + 14 -- goto err_f
					elseif (l_w[0]).to_integer_32 < 48 then
						l_pos := -1 + 14 -- goto err_f
					elseif (l_w[0]).to_integer_32 > 49 then
						l_pos := -1 + 14 -- goto err_f
					end
				when 6 then
					l_ts.item.m11_hack := (l_w[0]).to_integer_32 - 48
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 682, create {CE_POINTER [ANY]}.make_cast (l_w))
					l_w.ce_gets (get_token (l_c.address))
					if (l_w).c_pointer = default_pointer then
						l_pos := -1 + 15 -- goto err
					end
				when 7 then
					if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_w))) /= {NATURAL_32} 1 then
						l_pos := -1 + 14 -- goto err_f
					elseif (l_w[0]).to_integer_32 < 48 then
						l_pos := -1 + 14 -- goto err_f
					elseif (l_w[0]).to_integer_32 > 49 then
						l_pos := -1 + 14 -- goto err_f
					end
				when 8 then
					l_ts.item.restrict_852 := (l_w[0]).to_integer_32 - 48
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 686, create {CE_POINTER [ANY]}.make_cast (l_w))
					l_w.ce_gets (get_token (l_c.address))
					if (l_w).c_pointer = default_pointer then
						l_pos := -1 + 15 -- goto err
					end
				when 9 then
					if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_w))) /= {NATURAL_32} 1 then
						l_pos := -1 + 14 -- goto err_f
					elseif (l_w[0]).to_integer_32 < 48 then
						l_pos := -1 + 14 -- goto err_f
					elseif (l_w[0]).to_integer_32 > 49 then
						l_pos := -1 + 14 -- goto err_f
					end
				when 10 then
					l_ts.item.col := (l_w[0]).to_integer_32 - 48
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 690, create {CE_POINTER [ANY]}.make_cast (l_w))
					l_w.ce_gets (get_token (l_c.address))
					if (l_w).c_pointer = default_pointer then
						l_pos := -1 + 15 -- goto err
					end
				when 11 then
					l_i := charsets_inst.get_cp_index (l_w)
					if l_i = -1 then
						l_pos := -1 + 14 -- goto err_f
					elseif (charsets_inst.is_cp_special (l_i)).to_boolean then
						l_pos := -1 + 14 -- goto err_f
					end
				when 12 then
					l_ts.item.charset := l_i
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 694, create {CE_POINTER [ANY]}.make_cast (l_w))
				when 13 then -- end:
					Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					js.return
					if js.return_called then
						l_pos := -1 + 16 -- skip if block
					end
				when 14 then -- if: | err_f:
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 698, create {CE_POINTER [ANY]}.make_cast (l_w))
				when 15 then -- err:
						Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Error reading terminal specification")))
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	term2_rd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent term2_rd)
		end

	term_wr (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32])
		local
			l_ts: CE_POINTER [PD_TERM_SPEC]
		do
			create l_ts.make

			l_ts.ce_gets (create {CE_POINTER [PD_TERM_SPEC]}.make_cast (terminal_inst.term_specs.prev))
			from
			until
				(l_ts.c_pointer.to_integer_32).to_natural_32 = ((terminal_inst.term_specs.address).c_pointer.to_integer_32).to_natural_32
			loop
				add_nm (a_o, a_s, a_l)
				add_quoted_to_str (a_s, a_l, l_ts.item.term)
				links_inst.add_to_str (a_s, a_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
				links_inst.add_num_to_str (a_s, a_l, (l_ts.item.mode).to_integer_32)
				links_inst.add_to_str (a_s, a_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
				links_inst.add_num_to_str (a_s, a_l, (l_ts.item.m11_hack).to_integer_32)
				links_inst.add_to_str (a_s, a_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
				links_inst.add_num_to_str (a_s, a_l, ((((l_ts.item.col).to_boolean).to_integer + ((l_ts.item.restrict_852).to_boolean).to_integer * 2) + ((l_ts.item.block_cursor).to_boolean).to_integer * 4).to_integer_32)
				links_inst.add_to_str (a_s, a_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
				links_inst.add_to_str (a_s, a_l, (charsets_inst.get_cp_mime_name (l_ts.item.charset)))
				l_ts.ce_gets (l_ts.item.prev)
			end
		end

	term_wr_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent term_wr)
		end

	gen_cmd (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_argv: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_argc: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		local
			l_e: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_r: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_e.make
			create l_r.make

			if not (a_argc.item).to_boolean then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Parameter expected")))
				js.return
			end
			if not js.return_called then
				l_e.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 726))
				l_l := 0
				add_quoted_to_str (l_e.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (a_argv.item).item)
				l_r.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((a_o.item.rd_cfg).pointer_item ([a_o, l_e])))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 730, create {CE_POINTER [ANY]}.make_cast (l_e))
				if ((l_r).c_pointer /= default_pointer) then
					Result := l_r
					js.return
				end
			end
			if not js.return_called then
				a_argv.item := (a_argv.item) + 1
				a_argc.item := (a_argc.item) - 1
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	gen_cmd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gen_cmd)
		end

	lookup_cmd (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_argv: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_argc: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		local
			l_addr: NATURAL_32
			l_p: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p.make

			l_p.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [NATURAL_32]}.make_shared ($l_addr))))
			if not (a_argc.item).to_boolean then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Parameter expected")))
				js.return
			end
			if not js.return_called and then (a_argc.item >= 2) then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Too many parameters")))
				js.return
			end
			if not js.return_called then
				a_argv.item := (a_argv.item) + 1
				a_argc.item := (a_argc.item) - 1
				if (dns_inst.do_real_lookup (a_argv.item[-1], create {CE_POINTER [NATURAL_32]}.make_shared ($l_addr))).to_boolean then
					herror (ce_string ("error"))
					Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
					js.return
				end
			end
			if not js.return_called then
				Io.put_string (((l_p[0]).to_integer_32).out + "." + ((l_p[1]).to_integer_32).out + "." + ((l_p[2]).to_integer_32).out + "." + ((l_p[3]).to_integer_32).out + "%N")
				Io.standard_default.flush
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
			end
		end

	lookup_cmd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent lookup_cmd)
		end

	version_cmd (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_argv: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_argc: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		do
			Io.put_string ("Links 1.00%N")
			Io.standard_default.flush
			Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
		end

	version_cmd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent version_cmd)
		end

	no_connect_cmd (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_argv: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_argc: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		do
			no_connect := 1
			Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
		end

	no_connect_cmd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent no_connect_cmd)
		end

	anonymous_cmd (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_argv: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_argc: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		do
			anonymous := 1
			Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
		end

	anonymous_cmd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent anonymous_cmd)
		end

	force_html_cmd (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_argv: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_argc: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		do
			force_html := 1
			Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
		end

	force_html_cmd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent force_html_cmd)
		end

	dump_cmd (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_argv: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_argc: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		local
			js: JUMP_STATE
		do
			if dmp /= a_o.item.min then
				if dmp.to_boolean then
					Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Can%'t use both -dump and -source")))
					js.return
				end
			end
			if not js.return_called then
				dmp := a_o.item.min
				no_connect := 1
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	dump_cmd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dump_cmd)
		end

	printhelp_cmd (a_o: CE_POINTER [PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN]; a_argv: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_argc: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		do
			Io.put_string ("links [options] URL%NOptions are:%N%N -async-dns <0>/<1>%N  Asynchronous DNS resolver on(1)/off(0).%N%N -download-utime <0>/<1>%N  Set time of downloaded files to time from server.%N%N -max-connections <max>%N  Maximum number of concurrent connections.%N  (default: 10)%N%N -max-connections-to-host <max>%N  Maximum number of concurrent connection to a given host.%N  (default: 2)%N%N -retries <retry>%N  Number of retries.%N  (default: 3)%N%N -receive-timeout <sec>%N  Timeout on receive.%N  (default: 120)%N%N -unrestartable-receive-timeout <sec>%N  Timeout on non restartable connections.%N  (default: 600)%N%N -format-cache-size <num>%N  Number of formatted document pages cached.%N  (default: 5)%N%N -memory-cache-size <Kbytes>%N  Cache memory in Kilobytes.%N  (default: 1024)%N%N -http-proxy <host:port>%N  Host and port number of the HTTP proxy, or blank.%N  (default: blank)%N%N -ftp-proxy <host:port>%N  Host and port number of the FTP proxy, or blank.%N  (default: blank)%N%N -download-dir <path>%N  Default download directory.%N  (default: actual dir)%N%N -http-bugs.http10 <0>/<1>%N  %"1%" forces using only HTTP/1.0 protocol.%N%N -http-bugs.allow-blacklist <0>/<1>%N  %"1%" defaults to using list of servers that have broken HTTP/1.1 support.%N  When links finds such server, it will retry the request with HTTP/1.0.%N%N -http-bugs.bug-302-redirect <0>/<1>%N  Process 302 redirect in a way that is incompatible with RFC1945 and RFC2068,%N  but the same as Netscape and MSIE. Many pages depend on it.%N%N -http-bugs.bug-post-no-keepalive <0>/<1>%N  No keepalive connection after post requests. For some buggy servers.%N%N -http-bugs.bug-no-accept-charset <0>/<1>%N  Do not send Accept-Charset field of HTTP header.%N%N -ftp.anonymous-password <string>%N  Use ftp PASV command to bypass firewalls.%N%N -ftp.fast <0>/<1>%N  Send more ftp commands simultaneously. Faster response when%N  browsing ftp directories, but it is incompatible with RFC%N  and some servers don%'t like it.%N%N -ftp.set-iptos <0>/<1>%N  Set IP Type-of-service to high throughput on ftp connections.%N%N -html-assume-codepage <codepage>%N  Use the given codepage when the webpage did not specify%N  its codepage. (default: ISO 8859-1)%N%N -html-tables <0>/<1>%N  Render tables.%N%N -html-frames <0>/<1>%N  Render frames.%N%N -html-images <0>/<1>%N  Display links to images.%N%N -html-numbered-links <0>/<1>%N  Link numbering.%N%N -html-table-order <0>/<1>%N  Walk table by rows (0) or columns (1).%N%N -html-margin <margin>%N  Text margin.%N%N -language <language>%N  User interface language.%N%N -anonymous%N  Restrict links so that it can run on an anonymous account.%N  No local file browsing. No downloads. Executing of viewers%N  is allowed, but user can%'t add or modify entries in%N  association table.%N%N -force-html%N  Treat file as if it had an .html extension.%N%N -source%N  Write the given HTML document in source form to stdout.%N%N -dump%N  Write a plain-text version of the given HTML document to%N  stdout.%N%N -width <size>%N  Size of screen in characters, used in combination with -dump.%N%N -codepage <codepage>%N  Character set of output of -dump.%N%N -no-connect%N  Runs links as a separate instance - instead of connecting to%N  existing instance.%N%N -lookup <host>%N  Do lookup like %"host%" command.%N%N -version%N  Prints the links version number and exit.%N%N -help%N  Prints this help screen%N%N%NKeys:%N %TESC%T display menu%N%T^C%T quit%N%T^P, ^N%T scroll up, down%N%T[, ]%T scroll left, right%N%Tup, down select link%N%T->%T follow link%N%T<-%T go back%N%Tg%T go to url%N%TG%T go to url based on current url%N%T^R%T reload%N%T/%T search%N%T?%T search back%N%Tn%T find next%N%TN%T find previous%N%T=%T document info%N%T\%T document source%N%T|%T HTTP header%N%T*%T toggle displaying of image links%N%Td%T download%N%Ts%T bookmarks%N%Tq%T quit%N%N")
			Io.standard_default.flush
			Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
		end

	printhelp_cmd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent printhelp_cmd)
		end

	end_config
		do
			if ((links_home).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 962, create {CE_POINTER [ANY]}.make_cast (links_home))
			end
		end

	load_url_history
		local
			l_history_file: CE_POINTER [NATURAL_8]
			l_hs: CE_POINTER [NATURAL_8]
			l_hsp: CE_POINTER [NATURAL_8]
			l_hsl: CE_POINTER [NATURAL_8]
			l_hsc: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_history_file.make
			create l_hs.make
			create l_hsp.make
			create l_hsl.make
			create l_hsc.make

			if anonymous.to_boolean then
				js.return
			end
			if not js.return_called and then ((links_home).c_pointer = default_pointer) then
				js.return
			end
			if not js.return_called then
				l_history_file.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 1092, links_home))
				links_inst.add_to_strn (l_history_file.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("links.his")))
				l_hs.ce_gets (read_config_file (l_history_file))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 1095, create {CE_POINTER [ANY]}.make_cast (l_history_file))
				if (l_hs).c_pointer = default_pointer then
					js.return
				end
			end
			if not js.return_called then
				l_hsp.ce_gets (l_hs)
				from
				until
					not (not js.loop_left and then ((l_hsp.item).to_boolean))
				loop
					l_hsl.ce_gets (l_hsp)
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_hsl.item).to_boolean then
							if (l_hsl.item).to_integer_32 /= 10 then
								if (l_hsl.item).to_integer_32 = 13 then
									js.break
								end
							else
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_hsl.ce_gets (l_hsl + 1)
						end
					end
					js.reset
					l_hsc.ce_gets (links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 1100, l_hsp, l_hsl.distance (l_hsp)))
					bfu_inst.add_to_history (menu_inst.goto_url_history.address, l_hsc)
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 1102, create {CE_POINTER [ANY]}.make_cast (l_hsc))
					l_hsp.ce_gets (l_hsl)
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_hsp.item).to_integer_32 /= 10 then
							if (l_hsp.item).to_integer_32 /= 13 then
								js.break
							end
						end
						if not js.loop_jumped then
							l_hsp.ce_gets (l_hsp + 1)
						end
					end
					js.reset
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 1106, create {CE_POINTER [ANY]}.make_cast (l_hs))
			end
		end

	save_url_history
		local
			l_hi: CE_POINTER [PD_HISTORY_ITEM]
			l_history_file: CE_POINTER [NATURAL_8]
			l_hs: CE_POINTER [NATURAL_8]
			l_hsl: INTEGER_32
			l_i: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_hi.make
			create l_history_file.make
			create l_hs.make

			l_hsl := 0
			l_i := 0
			if anonymous.to_boolean then
				js.return
			end
			if not js.return_called and then ((links_home).c_pointer = default_pointer) then
				js.return
			end
			if not js.return_called then
				l_history_file.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 1120, links_home))
				links_inst.add_to_strn (l_history_file.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("links.his")))
				l_hs.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 1122))
				l_hsl := 0
				l_hi.ce_gets (create {CE_POINTER [PD_HISTORY_ITEM]}.make_cast (menu_inst.goto_url_history.items.prev))
				from
				until
					not (not js.loop_left and then ((l_hi.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (menu_inst.goto_url_history.c_pointer + {PD_HISTORY}.items_offset)).c_pointer.to_integer_32).to_natural_32))
				loop
					js.reset
					if not (l_hi.item.d[0]).to_boolean then
						js.continue
					elseif (((strchr (create {CE_POINTER [INTEGER_8]}.make_cast ((l_hi.item.d)), 10))).c_pointer /= default_pointer) then
						js.continue
					elseif (((strchr (create {CE_POINTER [INTEGER_8]}.make_cast ((l_hi.item.d)), 13))).c_pointer /= default_pointer) then
						js.continue
					end
					if not js.loop_jumped then
						l_tmp___1 := l_i
						l_i := l_i + 1
						if l_tmp___1 > 4096 then
							js.break
						else
							links_inst.add_to_str (l_hs.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_hsl), l_hi.item.d)
							links_inst.add_to_str (l_hs.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_hsl), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
						end
					end
					if not js.loop_left then
						l_hi.ce_gets (l_hi.item.prev)
					end
				end
				js.reset
				write_to_config_file (l_history_file, l_hs).do_nothing
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 1134, create {CE_POINTER [ANY]}.make_cast (l_history_file))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default.c")), 1135, create {CE_POINTER [ANY]}.make_cast (l_hs))
			end
		end

end
