class
	P_FINGER

inherit
	LINKS_DATA
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {ANY} -- routines

	finger_func (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_p: INTEGER_32
			js: JUMP_STATE
		do
			l_p := url_inst.get_port (a_c.item.url)
			if l_p = -1 then
				sched_inst.setcstate (a_c, -1003)
				sched_inst.abort_connection (a_c)
				js.return
			end
			if not js.return_called then
				a_c.item.from2 := (0).to_integer_32
				connect_inst.make_connection (a_c, l_p, create {CE_POINTER [INTEGER_32]}.make_shared (a_c.c_pointer + {PD_CONNECTION}.sock1_offset), finger_send_request_address)
			end
		end

	finger_func_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent finger_func)
		end

	finger_send_request (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_req: CE_POINTER [NATURAL_8]
			l_rl: INTEGER_32
			l_user: CE_POINTER [NATURAL_8]
		do
			create l_req.make
			create l_user.make

			l_req.ce_gets ((links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("finger.c")), 22)))
			l_rl := 0
			links_inst.add_to_str (l_req.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rl), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/W")))
			l_user.ce_gets (url_inst.get_user_name (a_c.item.url))
			if ((l_user).c_pointer /= default_pointer) then
				links_inst.add_to_str (l_req.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rl), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
				links_inst.add_to_str (l_req.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rl), l_user)
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("finger.c")), 29, create {CE_POINTER [ANY]}.make_cast (l_user))
			end
			links_inst.add_to_str (l_req.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rl), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%N")))
			connect_inst.write_to_socket (a_c, a_c.item.sock1, l_req, l_rl, finger_sent_request_address)
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("finger.c")), 33, create {CE_POINTER [ANY]}.make_cast (l_req))
			sched_inst.setcstate (a_c, 4)
		end

	finger_send_request_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent finger_send_request)
		end

	finger_sent_request (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_rb: CE_POINTER [PD_READ_BUFFER]
			js: JUMP_STATE
		do
			create l_rb.make

			sched_inst.set_timeout (a_c)
			l_rb.ce_gets (connect_inst.alloc_read_buffer (a_c))
			if (l_rb).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				l_rb.item.close := 1
				connect_inst.read_from_socket (a_c, a_c.item.sock1, l_rb, finger_get_response_address)
			end
		end

	finger_sent_request_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent finger_sent_request)
		end

	finger_get_response (a_c: CE_POINTER [PD_CONNECTION]; a_rb: CE_POINTER [PD_READ_BUFFER])
		local
			l_e: CE_POINTER [PD_CACHE_ENTRY]
			l_l: INTEGER_32
			js: JUMP_STATE
		do
			create l_e.make

			sched_inst.set_timeout (a_c)
			if (cache_inst.get_cache_entry (a_c.item.url, l_e.address)).to_boolean then
				sched_inst.setcstate (a_c, -1004)
				sched_inst.abort_connection (a_c)
				js.return
			end
			if not js.return_called then
				a_c.item.cache := l_e
				if a_rb.item.close = 2 then
					sched_inst.setcstate (a_c, -1000)
					finger_end_request (a_c)
					js.return
				end
			end
			if not js.return_called then
				l_l := a_rb.item.len
				if a_c.item.from2 + l_l.to_integer_32 < 0 then
					sched_inst.setcstate (a_c, -1014)
					sched_inst.abort_connection (a_c)
					js.return
				end
			end
			if not js.return_called then
				a_c.item.received := a_c.item.received + l_l.to_integer_32
				if (cache_inst.add_fragment (a_c.item.cache, a_c.item.from2, a_rb.item.data, l_l.to_integer_32)) = 1 then
					a_c.item.tries := 0
				end
				a_c.item.from2 := a_c.item.from2 + l_l.to_integer_32
				connect_inst.kill_buffer_data (a_rb, l_l)
				connect_inst.read_from_socket (a_c, a_c.item.sock1, a_rb, finger_get_response_address)
				sched_inst.setcstate (a_c, 8)
			end
		end

	finger_get_response_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent finger_get_response)
		end

	finger_end_request (a_c: CE_POINTER [PD_CONNECTION])
		do
			if a_c.item.state = -1000 then
				if ((a_c.item.cache).c_pointer /= default_pointer) then
					cache_inst.truncate_entry (a_c.item.cache, a_c.item.from2, 1);
					(a_c.item.cache).item.incomplete := 0
				end
			end
			sched_inst.abort_connection (a_c)
		end

end
