class
	P_HTML_TBL

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create frame_table.make (<<81>>)
			create hline_table.make (<<3>>)
			create vline_table.make (<<3>>)
		end

feature {ANY} -- attributes

	frame_table: CE_ARRAY [NATURAL_8]

	hline_table: CE_ARRAY [NATURAL_8]

	vline_table: CE_ARRAY [NATURAL_8]

feature {ANY} -- routines

	get_align (a_attr: CE_POINTER [INTEGER_8]; a_a: CE_POINTER [INTEGER_32])
		local
			l_al: CE_POINTER [INTEGER_8]
		do
			create l_al.make

			l_al.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((html_inst.get_attr_val (create {CE_POINTER [NATURAL_8]}.make_cast (a_attr), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("align"))))))
			if ((l_al).c_pointer /= default_pointer) then
				if not (strcasecmp (l_al, ce_string ("left"))).to_boolean then
					a_a.item := 0
				end
				if not (strcasecmp (l_al, ce_string ("right"))).to_boolean then
					a_a.item := 2
				end
				if not (strcasecmp (l_al, ce_string ("center"))).to_boolean then
					a_a.item := 1
				end
				if not (strcasecmp (l_al, ce_string ("justify"))).to_boolean then
					a_a.item := 3
				end
				if not (strcasecmp (l_al, ce_string ("char"))).to_boolean then
					a_a.item := 2
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 37, create {CE_POINTER [ANY]}.make_cast (l_al))
			end
		end

	get_valign (a_attr: CE_POINTER [INTEGER_8]; a_a: CE_POINTER [INTEGER_32])
		local
			l_al: CE_POINTER [INTEGER_8]
		do
			create l_al.make

			l_al.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((html_inst.get_attr_val (create {CE_POINTER [NATURAL_8]}.make_cast (a_attr), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("valign"))))))
			if ((l_al).c_pointer /= default_pointer) then
				if not (strcasecmp (l_al, ce_string ("top"))).to_boolean then
					a_a.item := 0
				end
				if not (strcasecmp (l_al, ce_string ("middle"))).to_boolean then
					a_a.item := 1
				end
				if not (strcasecmp (l_al, ce_string ("bottom"))).to_boolean then
					a_a.item := 2
				end
				if not (strcasecmp (l_al, ce_string ("baseline"))).to_boolean then
					a_a.item := 0
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 49, create {CE_POINTER [ANY]}.make_cast (l_al))
			end
		end

	get_c_width (a_attr: CE_POINTER [INTEGER_8]; a_w: CE_POINTER [INTEGER_32]; a_sh: INTEGER_32)
		local
			l_al: CE_POINTER [INTEGER_8]
			l_en: CE_POINTER [INTEGER_8]
			l_n: NATURAL_32
			l_p: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_al.make
			create l_en.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_al.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((html_inst.get_attr_val (create {CE_POINTER [NATURAL_8]}.make_cast (a_attr), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("width"))))))
					if (l_al).c_pointer = default_pointer then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not ((l_al[0]).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (l_al[((strlen (l_al)) - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 42 then
							l_al[((strlen (l_al)) - {NATURAL_32} 1).to_integer_32] := (0).to_integer_8
							l_n := strtoul (l_al, (l_en.address), 10)
							if l_n < {NATURAL_32} 10000 then
								if not (l_en[0]).to_boolean then
									a_w.item := ({NATURAL_32} 4294967294 - l_n).to_integer_32
								end
							end
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						l_p := (html_inst.get_width (create {CE_POINTER [NATURAL_8]}.make_cast (a_attr), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("width")), a_sh))
						if l_p >= 0 then
							a_w.item := l_p
						end
				when 5 then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 67, create {CE_POINTER [ANY]}.make_cast (l_al))
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	new_table: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]
		local
			l_t: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]
			l_tmp___0: INTEGER_32
		do
			create l_t.make

			l_t.ce_gets (create {CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 144, {PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS}.sizeof.to_natural_32))))
			memset (create {CE_POINTER [ANY]}.make_cast (l_t), 0, {PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS}.sizeof.to_natural_32).do_nothing
			l_t.item.p := create {CE_POINTER [PD_PART]}.make_shared (default_pointer)
			l_tmp___0 := 0
			l_t.item.y := l_tmp___0
			l_t.item.x := l_tmp___0
			l_t.item.rx := 8
			l_t.item.ry := 8
			l_t.item.cells := create {CE_POINTER [PD_TABLE_CELL]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 150, {NATURAL_32} 64 * {PD_TABLE_CELL}.sizeof.to_natural_32)))
			memset (create {CE_POINTER [ANY]}.make_cast (l_t.item.cells), 0, {NATURAL_32} 64 * {PD_TABLE_CELL}.sizeof.to_natural_32).do_nothing
			l_t.item.c := 0
			l_t.item.rc := 8
			l_t.item.cols := create {CE_POINTER [PD_TABLE_COLUMN]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 154, {NATURAL_32} 8 * {PD_TABLE_COLUMN}.sizeof.to_natural_32)))
			memset (create {CE_POINTER [ANY]}.make_cast (l_t.item.cols), 0, {NATURAL_32} 8 * {PD_TABLE_COLUMN}.sizeof.to_natural_32).do_nothing
			l_t.item.xcols := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer + -1)
			l_t.item.xc := 0
			l_t.item.r_heights := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer + -1)
			Result := l_t
		end

	free_table (a_t: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS])
		do
			if ((a_t.item.min_c).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 164, create {CE_POINTER [ANY]}.make_cast (a_t.item.min_c))
			end
			if ((a_t.item.max_c).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 165, create {CE_POINTER [ANY]}.make_cast (a_t.item.max_c))
			end
			if ((a_t.item.w_c).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 166, create {CE_POINTER [ANY]}.make_cast (a_t.item.w_c))
			end
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 167, create {CE_POINTER [ANY]}.make_cast (a_t.item.r_heights))
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 168, create {CE_POINTER [ANY]}.make_cast (a_t.item.cols))
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 169, create {CE_POINTER [ANY]}.make_cast (a_t.item.xcols))
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 170, create {CE_POINTER [ANY]}.make_cast (a_t.item.cells))
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 171, create {CE_POINTER [ANY]}.make_cast (a_t))
		end

	expand_cells (a_t: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]; a_x: INTEGER_32; a_y: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			js: JUMP_STATE
		do
			if a_x >= a_t.item.x then
				if (a_t.item.x).to_boolean then
					l_i := 0
					from
					until
						not (not js.loop_left and then (l_i < a_t.item.y))
					loop
						if (a_t.item.cells + (l_i * a_t.item.rx + (a_t.item.x - 1))).item.colspan = -1 then
							l_j := a_t.item.x
							from
							until
								not (l_j <= a_x)
							loop
								(a_t.item.cells + (l_i * a_t.item.rx + l_j)).item.used := 1;
								(a_t.item.cells + (l_i * a_t.item.rx + l_j)).item.spanned := 1;
								(a_t.item.cells + (l_i * a_t.item.rx + l_j)).item.rowspan := (a_t.item.cells + (l_i * a_t.item.rx + (a_t.item.x - 1))).item.rowspan;
								(a_t.item.cells + (l_i * a_t.item.rx + l_j)).item.colspan := -1;
								(a_t.item.cells + (l_i * a_t.item.rx + l_j)).item.mx := (a_t.item.cells + (l_i * a_t.item.rx + (a_t.item.x - 1))).item.mx;
								(a_t.item.cells + (l_i * a_t.item.rx + l_j)).item.my := (a_t.item.cells + (l_i * a_t.item.rx + (a_t.item.x - 1))).item.my
								l_j := l_j + 1
							end
						end
						l_i := l_i + 1
					end
				end
				a_t.item.x := a_x + 1
			end
			if a_y >= a_t.item.y then
				if (a_t.item.y).to_boolean then
					l_i := 0
					from
					until
						not (not js.loop_left and then (l_i < a_t.item.x))
					loop
						if (a_t.item.cells + ((a_t.item.y - 1) * a_t.item.rx + l_i)).item.rowspan = -1 then
							l_j := a_t.item.y
							from
							until
								not (l_j <= a_y)
							loop
								(a_t.item.cells + (l_j * a_t.item.rx + l_i)).item.used := 1;
								(a_t.item.cells + (l_j * a_t.item.rx + l_i)).item.spanned := 1;
								(a_t.item.cells + (l_j * a_t.item.rx + l_i)).item.rowspan := -1;
								(a_t.item.cells + (l_j * a_t.item.rx + l_i)).item.colspan := (a_t.item.cells + ((a_t.item.y - 1) * a_t.item.rx + l_i)).item.colspan;
								(a_t.item.cells + (l_j * a_t.item.rx + l_i)).item.mx := (a_t.item.cells + ((a_t.item.y - 1) * a_t.item.rx + l_i)).item.mx;
								(a_t.item.cells + (l_j * a_t.item.rx + l_i)).item.my := (a_t.item.cells + ((a_t.item.y - 1) * a_t.item.rx + l_i)).item.my
								l_j := l_j + 1
							end
						end
						l_i := l_i + 1
					end
				end
				a_t.item.y := a_y + 1
			end
		end

	new_cell (a_t: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]; a_x: INTEGER_32; a_y: INTEGER_32): CE_POINTER [PD_TABLE_CELL]
		local
			l_nt: PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS
			l_i: INTEGER_32
			l_j: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_nt.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_x < a_t.item.x then
						if a_y < a_t.item.y then
							l_pos := -1 + 3 -- goto ret
						end
					end
				when 1 then -- rep:
					if a_x < a_t.item.rx then
						if a_y < a_t.item.ry then
							expand_cells (a_t, a_x, a_y)
							l_pos := -1 + 3 -- goto ret
						end
					end
				when 2 then
					l_nt.rx := a_t.item.rx
					l_nt.ry := a_t.item.ry
					from
					until
						not (not js.loop_left and then (a_x >= l_nt.rx))
					loop
						if (l_nt.rx).to_natural_32 > {NATURAL_32} 1073741823 then
							from
							until
								False
							loop
								error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 222])
								kbd_inst.fatal_tty_exit
								exit (4)
							end
						end
						l_nt.rx := l_nt.rx * (2)
					end
					from
					until
						not (not js.loop_left and then (a_y >= l_nt.ry))
					loop
						if (l_nt.ry).to_natural_32 > {NATURAL_32} 1073741823 then
							from
							until
								False
							loop
								error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 226])
								kbd_inst.fatal_tty_exit
								exit (4)
							end
						end
						l_nt.ry := l_nt.ry * (2)
					end
					if ((l_nt.rx).to_natural_32 * (l_nt.ry).to_natural_32) // (l_nt.rx).to_natural_32 /= (l_nt.ry).to_natural_32 then
						from
						until
							False
						loop
							error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 229])
							kbd_inst.fatal_tty_exit
							exit (4)
						end
					end
					if (l_nt.rx).to_natural_32 * (l_nt.ry).to_natural_32 > {NATURAL_32} 2147483647 // {PD_TABLE_CELL}.sizeof.to_natural_32 then
						from
						until
							False
						loop
							error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 230])
							kbd_inst.fatal_tty_exit
							exit (4)
						end
					end
					l_nt.cells := create {CE_POINTER [PD_TABLE_CELL]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 231, (l_nt.rx * l_nt.ry).to_natural_32 * {PD_TABLE_CELL}.sizeof.to_natural_32)))
					memset (create {CE_POINTER [ANY]}.make_cast (l_nt.cells), 0, (l_nt.rx * l_nt.ry).to_natural_32 * {PD_TABLE_CELL}.sizeof.to_natural_32).do_nothing
					l_i := 0
					from
					until
						not (not js.loop_left and then (l_i < a_t.item.x))
					loop
						l_j := 0
						from
						until
							not (l_j < a_t.item.y)
						loop
							memcpy (create {CE_POINTER [ANY]}.make_cast ((l_nt.cells + (l_j * l_nt.rx + l_i))), create {CE_POINTER [ANY]}.make_cast ((a_t.item.cells + (l_j * a_t.item.rx + l_i))), {PD_TABLE_CELL}.sizeof.to_natural_32).do_nothing
							l_j := l_j + 1
						end
						l_i := l_i + 1
					end
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 236, create {CE_POINTER [ANY]}.make_cast (a_t.item.cells))
					a_t.item.cells := l_nt.cells
					a_t.item.rx := l_nt.rx
					a_t.item.ry := l_nt.ry
					l_pos := -1 + 1 -- goto rep
				when 3 then -- ret:
					Result := (a_t.item.cells + (a_y * a_t.item.rx + a_x))
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	new_columns (a_t: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]; a_span: INTEGER_32; a_width: INTEGER_32; a_align: INTEGER_32; a_valign: INTEGER_32; a_group: INTEGER_32)
		local
			l_span: INTEGER_32
			l_group: INTEGER_32
			l_n: INTEGER_32
			l_nc: CE_POINTER [PD_TABLE_COLUMN]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_nc.make

			l_span := a_span
			l_group := a_group
			if (a_t.item.c).to_natural_32 + l_span.to_natural_32 > {NATURAL_32} 2147483647 then
				from
				until
					False
				loop
					error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 248])
					kbd_inst.fatal_tty_exit
					exit (4)
				end
			end
			if a_t.item.c + l_span > a_t.item.rc then
				l_n := a_t.item.rc
				from
				until
					not (not js.loop_left and then (a_t.item.c + l_span > l_n))
				loop
					if l_n.to_natural_32 > {NATURAL_32} 1073741823 then
						from
						until
							False
						loop
							error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 253])
							kbd_inst.fatal_tty_exit
							exit (4)
						end
					end
					l_n := l_n * (2)
				end
				if l_n.to_natural_32 > {NATURAL_32} 2147483647 // {PD_TABLE_COLUMN}.sizeof.to_natural_32 then
					from
					until
						False
					loop
						error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 256])
						kbd_inst.fatal_tty_exit
						exit (4)
					end
				end
				l_nc.ce_gets (create {CE_POINTER [PD_TABLE_COLUMN]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 257, create {CE_POINTER [ANY]}.make_cast (a_t.item.cols), l_n.to_natural_32 * {PD_TABLE_COLUMN}.sizeof.to_natural_32))))
				a_t.item.rc := l_n
				a_t.item.cols := l_nc
			end
			from
			until
				js.loop_left
			loop
				js.reset
				l_tmp___1 := l_span
				l_span := l_span - 1
				if not l_tmp___1.to_boolean then
					js.break
				end
				if not js.loop_jumped then
					(a_t.item.cols + a_t.item.c).item.align := a_align;
					(a_t.item.cols + a_t.item.c).item.valign := a_valign;
					(a_t.item.cols + a_t.item.c).item.width := a_width
					l_tmp___0 := a_t.item.c
					a_t.item.c := (a_t.item.c) + 1;
					(a_t.item.cols + l_tmp___0).item.group := l_group
					l_group := 0
				end
			end
			js.reset
		end

	set_td_width (a_t: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]; a_x: INTEGER_32; a_width: INTEGER_32; a_f: INTEGER_32)
		local
			l_n: INTEGER_32
			l_tmp: INTEGER_32
			l_i: INTEGER_32
			l_nc: CE_POINTER [INTEGER_32]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_nc.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_x >= a_t.item.xc then
						if (a_t.item.xc).to_boolean then
							l_tmp := a_t.item.xc
						else
							l_tmp := 1
						end
						l_n := l_tmp
						from
						until
							not (not js.loop_left and then (a_x >= l_n))
						loop
							if l_n.to_natural_32 > {NATURAL_32} 1073741823 then
								from
								until
									False
								loop
									error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 277])
									kbd_inst.fatal_tty_exit
									exit (4)
								end
							end
							l_n := l_n * (2)
						end
						if l_n.to_natural_32 > {NATURAL_32} 2147483647 // Integer_32_bytes.to_natural_32 then
							from
							until
								False
							loop
								error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 280])
								kbd_inst.fatal_tty_exit
								exit (4)
							end
						end
						l_nc.ce_gets (create {CE_POINTER [INTEGER_32]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 281, create {CE_POINTER [ANY]}.make_cast (a_t.item.xcols), l_n.to_natural_32 * Integer_32_bytes.to_natural_32))))
						l_i := a_t.item.xc
						from
						until
							not (l_i < l_n)
						loop
							l_nc[l_i] := -1
							l_i := l_i + 1
						end
						a_t.item.xc := l_n
						a_t.item.xcols := l_nc
					end
					if a_t.item.xcols[a_x] /= -1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto set
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (a_f.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | set:
						a_t.item.xcols[a_x] := a_width
						js.return
				when 5 then -- if done
						if not js.return_called and then (a_width = -1) then
							js.return
						end
						if js.return_called then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
							if a_width < 0 then
								if a_t.item.xcols[a_x] >= 0 then
									l_pos := -1 + 4 -- goto set
								end
							end
				when 7 then
							if a_width >= 0 then
								if a_t.item.xcols[a_x] < 0 then
									js.return
								end
							end
				when 8 then -- if done
						if not js.return_called then
							a_t.item.xcols[a_x] := (a_t.item.xcols[a_x] + a_width) // 2
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	skip_table (a_html: CE_POINTER [NATURAL_8]; a_eof: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_html: CE_POINTER [NATURAL_8]
			l_level: INTEGER_32
			l_name: CE_POINTER [NATURAL_8]
			l_namelen: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_html.make
			create l_name.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_html.ce_gets (a_html)
					l_level := 1
				when 1 then -- r:
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_html.c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_html.item).to_integer_32 = 60 then
								if not (html_inst.parse_element (l_html, a_eof, l_name.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_namelen), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), l_html.address)).to_boolean then
									js.break
								end
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_html.ce_gets (l_html + 1)
						end
					end
					js.reset
					if (l_html.c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
						Result := a_eof
						js.return
					end
					if not js.return_called then
						if l_namelen = 5 then
							if not (links_inst.casecmp (l_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("TABLE")), (5).to_natural_32)).to_boolean then
								l_level := l_level + 1
							end
						end
						if l_namelen = 6 then
							if not (links_inst.casecmp (l_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/TABLE")), (6).to_natural_32)).to_boolean then
								l_level := l_level - 1
								if not l_level.to_boolean then
									Result := l_html
									js.return
								end
							end
						end
					end
					if not js.return_called then
						l_pos := -1 + 1 -- goto r
					end
				when 2 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	parse_table (a_html: CE_POINTER [NATURAL_8]; a_eof: CE_POINTER [NATURAL_8]; a_end: CE_POINTER [CE_POINTER [NATURAL_8]]; a_bgcolor: CE_POINTER [PD_RGB]; a_sh: INTEGER_32; a_bad_html: CE_POINTER [CE_POINTER [PD_S_E]]; a_bhp: CE_POINTER [INTEGER_32]): CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]
		local
			l_html: CE_POINTER [NATURAL_8]
			l_qqq: INTEGER_32
			l_t: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]
			l_cell: CE_POINTER [PD_TABLE_CELL]
			l_t_name: CE_POINTER [NATURAL_8]
			l_t_attr: CE_POINTER [NATURAL_8]
			l_en: CE_POINTER [NATURAL_8]
			l_t_namelen: INTEGER_32
			l_x: INTEGER_32
			l_y: INTEGER_32
			l_p: INTEGER_32
			l_lbhp: CE_POINTER [NATURAL_8]
			l_l_al: INTEGER_32
			l_l_val: INTEGER_32
			l_csp: INTEGER_32
			l_rsp: INTEGER_32
			l_group: INTEGER_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_l_col: PD_RGB
			l_c_al: INTEGER_32
			l_c_val: INTEGER_32
			l_c_width: INTEGER_32
			l_c_span: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_sp: INTEGER_32
			l_wi: INTEGER_32
			l_al: INTEGER_32
			l_val: INTEGER_32
			l_tmp___17: INTEGER_32
			l_w: INTEGER_32
			l_sc: CE_POINTER [PD_TABLE_CELL]
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			l_sc___0: CE_POINTER [PD_TABLE_CELL]
			l_l: INTEGER_32
			l_m: INTEGER_32
			l_tmp___23: INTEGER_32
			l_tmp___24: INTEGER_32
			l_c: CE_POINTER [PD_TABLE_CELL]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_html.make
			create l_t.make
			create l_cell.make
			create l_t_name.make
			create l_t_attr.make
			create l_en.make
			create l_lbhp.make
			create l_l_col.make
			create l_tmp___1.make
			create l_sc.make
			create l_sc___0.make
			create l_c.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_html.ce_gets (a_html)
					l_x := 0
					l_y := -1
					l_p := 0
					l_lbhp.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_l_al := 0
					l_l_val := 1
					l_group := 0
					l_c_al := -1
					l_c_val := -1
					l_c_width := -1
					l_c_span := 0
					memcpy (create {CE_POINTER [ANY]}.make_cast ((l_l_col.address)), create {CE_POINTER [ANY]}.make_cast (a_bgcolor), {PD_RGB}.sizeof.to_natural_32).do_nothing
					a_end.item := l_html
					if ((a_bad_html).c_pointer /= default_pointer) then
						a_bad_html.item := create {CE_POINTER [PD_S_E]}.make_shared (default_pointer + -1)
						a_bhp.item := 0
					end
					l_t.ce_gets (new_table)
					if (l_t).c_pointer = default_pointer then
						Result := (create {CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]}.make_shared (default_pointer))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 46 -- skip if block
					end
				when 1 then -- if: | se:
						l_en.ce_gets (l_html)
				when 2 then -- see:
						l_html.ce_gets (l_en)
						if ((a_bad_html).c_pointer /= default_pointer) then
							if not l_p.to_boolean then
								if (l_lbhp).c_pointer = default_pointer then
									if not ((a_bhp.item).bit_and (63)).to_boolean then
										if (a_bhp.item).to_natural_32 > {NATURAL_32} 2147483647 // {PD_S_E}.sizeof.to_natural_32 - {NATURAL_32} 64 then
											from
											until
												False
											loop
												error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 344])
												kbd_inst.fatal_tty_exit
												exit (4)
											end
										end
										a_bad_html.item := create {CE_POINTER [PD_S_E]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 345, create {CE_POINTER [ANY]}.make_cast (a_bad_html.item), (a_bhp.item + 64).to_natural_32 * {PD_S_E}.sizeof.to_natural_32)))
									end
									l_tmp___0 := a_bhp.item
									a_bhp.item := (a_bhp.item) + 1
									l_tmp___1.ce_gets (l_html);
									(a_bad_html.item + l_tmp___0).item.s := l_tmp___1
									l_lbhp.ce_gets (l_tmp___1)
								end
							end
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_html.c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32 then
								if (l_html.item).to_integer_32 = 60 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_html.ce_gets (l_html + 1)
							end
						end
						js.reset
						if (l_html.c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if l_p.to_boolean then
								(l_t.item.cells + (l_y * l_t.item.rx + l_x)).item.end2 := l_html
							end
							if ((l_lbhp).c_pointer /= default_pointer) then
								(a_bad_html.item + (a_bhp.item - 1)).item.e := l_html
							end
							l_pos := -1 + 45 -- goto scan_done
						end
				when 3 then
						if ((l_html + 2).c_pointer.to_integer_32).to_natural_32 <= (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_html[1]).to_integer_32 = 33 then
								l_html.ce_gets (html_inst.skip_comment (l_html, a_eof))
								l_pos := -1 + 1 -- goto se
							elseif (l_html[1]).to_integer_32 = 63 then
								l_html.ce_gets (html_inst.skip_comment (l_html, a_eof))
								l_pos := -1 + 1 -- goto se
							end
						end
				when 4 then
						if (html_inst.parse_element (l_html, a_eof, l_t_name.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_t_namelen), l_t_attr.address, l_en.address)).to_boolean then
							l_html.ce_gets (l_html + 1)
							l_pos := -1 + 1 -- goto se
						end
				when 5 then
						if l_t_namelen = 5 then
							if not (links_inst.casecmp (l_t_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("TABLE")), (5).to_natural_32)).to_boolean then
								l_en.ce_gets (skip_table (l_en, a_eof))
								l_pos := -1 + 2 -- goto see
							end
						end
				when 6 then
						if l_t_namelen = 6 then
							if not (links_inst.casecmp (l_t_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/TABLE")), (6).to_natural_32)).to_boolean then
								if l_c_span.to_boolean then
									new_columns (l_t, l_c_span, l_c_width, l_c_al, l_c_val, 1)
								end
								if l_p.to_boolean then
									(l_t.item.cells + (l_y * l_t.item.rx + l_x)).item.end2 := l_html
								end
								if ((l_lbhp).c_pointer /= default_pointer) then
									(a_bad_html.item + (a_bhp.item - 1)).item.e := l_html
								end
								l_pos := -1 + 45 -- goto scan_done
							end
						end
				when 7 then
						if l_t_namelen = 8 then
							if not (links_inst.casecmp (l_t_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("COLGROUP")), (8).to_natural_32)).to_boolean then
								if l_c_span.to_boolean then
									new_columns (l_t, l_c_span, l_c_width, l_c_al, l_c_val, 1)
								end
								if ((l_lbhp).c_pointer /= default_pointer) then
									(a_bad_html.item + (a_bhp.item - 1)).item.e := l_html
									l_lbhp.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								end
								l_c_al := -1
								l_c_val := -1
								l_c_width := -1
								get_align (create {CE_POINTER [INTEGER_8]}.make_cast (l_t_attr), create {CE_POINTER [INTEGER_32]}.make_shared ($l_c_al))
								get_valign (create {CE_POINTER [INTEGER_8]}.make_cast (l_t_attr), create {CE_POINTER [INTEGER_32]}.make_shared ($l_c_val))
								get_c_width (create {CE_POINTER [INTEGER_8]}.make_cast (l_t_attr), create {CE_POINTER [INTEGER_32]}.make_shared ($l_c_width), a_sh)
								l_c_span := html_inst.get_num (l_t_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("span")))
								if l_c_span = -1 then
									l_c_span := 1
								end
								l_pos := -1 + 2 -- goto see
							end
						end
				when 8 then
						if l_t_namelen = 9 then
							if not (links_inst.casecmp (l_t_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/COLGROUP")), (9).to_natural_32)).to_boolean then
								if l_c_span.to_boolean then
									new_columns (l_t, l_c_span, l_c_width, l_c_al, l_c_val, 1)
								end
								if ((l_lbhp).c_pointer /= default_pointer) then
									(a_bad_html.item + (a_bhp.item - 1)).item.e := l_html
									l_lbhp.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								end
								l_c_span := 0
								l_c_al := -1
								l_c_val := -1
								l_c_width := -1
								l_pos := -1 + 2 -- goto see
							end
						end
				when 9 then
						if l_t_namelen = 3 then
							if not (links_inst.casecmp (l_t_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("COL")), (3).to_natural_32)).to_boolean then
								if ((l_lbhp).c_pointer /= default_pointer) then
									(a_bad_html.item + (a_bhp.item - 1)).item.e := l_html
									l_lbhp.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								end
								l_sp := html_inst.get_num (l_t_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("span")))
								if l_sp = -1 then
									l_sp := 1
								end
								l_wi := l_c_width
								l_al := l_c_al
								l_val := l_c_val
								get_align (create {CE_POINTER [INTEGER_8]}.make_cast (l_t_attr), create {CE_POINTER [INTEGER_32]}.make_shared ($l_al))
								get_valign (create {CE_POINTER [INTEGER_8]}.make_cast (l_t_attr), create {CE_POINTER [INTEGER_32]}.make_shared ($l_val))
								get_c_width (create {CE_POINTER [INTEGER_8]}.make_cast (l_t_attr), create {CE_POINTER [INTEGER_32]}.make_shared ($l_wi), a_sh)
								new_columns (l_t, l_sp, l_wi, l_al, l_val, (l_c_span.to_boolean).to_integer)
								l_c_span := 0
								l_pos := -1 + 2 -- goto see
							end
						end
				when 10 then
						if l_t_namelen /= 3 then
							l_pos := -1 + 19 -- skip if block
						end
				when 11 then -- if:
						if not ((links_inst.casecmp (l_t_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/TR")), (3).to_natural_32)).to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 12 then -- if:
						if not ((links_inst.casecmp (l_t_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/TD")), (3).to_natural_32)).to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 13 then -- if:
						if (links_inst.casecmp (l_t_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/TH")), (3).to_natural_32)).to_boolean then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L:
						if l_c_span.to_boolean then
							new_columns (l_t, l_c_span, l_c_width, l_c_al, l_c_val, 1)
						end
						if l_p.to_boolean then
							(l_t.item.cells + (l_y * l_t.item.rx + l_x)).item.end2 := l_html
							l_p := 0
						end
						if ((l_lbhp).c_pointer /= default_pointer) then
							(a_bad_html.item + (a_bhp.item - 1)).item.e := l_html
							l_lbhp.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						end
				when 15 then -- if done | if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						l_pos := -1 + 14 -- goto _L
				when 17 then -- if done | if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						l_pos := -1 + 14 -- goto _L
				when 19 then -- if done
						if l_t_namelen = 2 then
							if not (links_inst.casecmp (l_t_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("TR")), (2).to_natural_32)).to_boolean then
								if l_c_span.to_boolean then
									new_columns (l_t, l_c_span, l_c_width, l_c_al, l_c_val, 1)
								end
								if l_p.to_boolean then
									(l_t.item.cells + (l_y * l_t.item.rx + l_x)).item.end2 := l_html
									l_p := 0
								end
								if ((l_lbhp).c_pointer /= default_pointer) then
									(a_bad_html.item + (a_bhp.item - 1)).item.e := l_html
									l_lbhp.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								end
								if l_group.to_boolean then
									l_group := l_group - 1
								end
								l_l_al := 0
								l_l_val := 1
								memcpy (create {CE_POINTER [ANY]}.make_cast ((l_l_col.address)), create {CE_POINTER [ANY]}.make_cast (a_bgcolor), {PD_RGB}.sizeof.to_natural_32).do_nothing
								get_align (create {CE_POINTER [INTEGER_8]}.make_cast (l_t_attr), create {CE_POINTER [INTEGER_32]}.make_shared ($l_l_al))
								get_valign (create {CE_POINTER [INTEGER_8]}.make_cast (l_t_attr), create {CE_POINTER [INTEGER_32]}.make_shared ($l_l_val))
								html_inst.get_bgcolor (l_t_attr, l_l_col.address).do_nothing
								l_y := l_y + 1
								l_x := 0
								l_pos := -1 + 2 -- goto see
							end
						end
				when 20 then
						if l_t_namelen /= 5 then
							l_pos := -1 + 29 -- skip if block
						end
				when 21 then -- if:
						if not ((links_inst.casecmp (l_t_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("THEAD")), (5).to_natural_32)).to_boolean) then
							l_pos := -1 + 28 -- skip if block
						end
				when 22 then -- if:
						if not ((links_inst.casecmp (l_t_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("TBODY")), (5).to_natural_32)).to_boolean) then
							l_pos := -1 + 26 -- skip if block
						end
				when 23 then -- if:
						if (links_inst.casecmp (l_t_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("TFOOT")), (5).to_natural_32)).to_boolean then
							l_pos := -1 + 25 -- skip if block
						end
				when 24 then -- if: | _L___0:
						if l_c_span.to_boolean then
							new_columns (l_t, l_c_span, l_c_width, l_c_al, l_c_val, 1)
						end
						if ((l_lbhp).c_pointer /= default_pointer) then
							(a_bad_html.item + (a_bhp.item - 1)).item.e := l_html
							l_lbhp.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						end
						l_group := 2
				when 25 then -- if done | if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						l_pos := -1 + 24 -- goto _L___0
				when 27 then -- if done | if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:
						l_pos := -1 + 24 -- goto _L___0
				when 29 then -- if done
						if l_t_namelen /= 2 then
							l_pos := -1 + 2 -- goto see
						elseif (links_inst.casecmp (l_t_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("TD")), (2).to_natural_32)).to_boolean then
							if (links_inst.casecmp (l_t_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("TH")), (2).to_natural_32)).to_boolean then
								l_pos := -1 + 2 -- goto see
							end
						end
				when 30 then
						if l_c_span.to_boolean then
							new_columns (l_t, l_c_span, l_c_width, l_c_al, l_c_val, 1)
						end
						if ((l_lbhp).c_pointer /= default_pointer) then
							(a_bad_html.item + (a_bhp.item - 1)).item.e := l_html
							l_lbhp.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						end
						if l_p.to_boolean then
							(l_t.item.cells + (l_y * l_t.item.rx + l_x)).item.end2 := l_html
							l_p := 0
						end
						if l_y = -1 then
							l_y := 0
							l_x := 0
						end
				when 31 then -- nc:
						l_cell.ce_gets (new_cell (l_t, l_x, l_y))
						if not ((l_cell.item.used).to_boolean) then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						if l_cell.item.colspan = -1 then
							l_pos := -1 + 2 -- goto see
						end
				when 33 then
						l_x := l_x + 1
						l_pos := -1 + 31 -- goto nc
				when 34 then
						l_cell.item.mx := l_x
						l_cell.item.my := l_y
						l_cell.item.used := 1
						l_cell.item.start := l_en
						l_p := 1
						l_cell.item.align := l_l_al
						l_cell.item.valign := l_l_val
						l_tmp___17 := ((links_inst.upcase (l_t_name[1])).to_integer_32 = 72).to_integer
						l_cell.item.b := l_tmp___17
						if l_tmp___17.to_boolean then
							l_cell.item.align := 1
						end
						if l_group = 1 then
							l_cell.item.group := 1
						end
						if l_x < l_t.item.c then
							if (l_t.item.cols + l_x).item.align /= -1 then
								l_cell.item.align := (l_t.item.cols + l_x).item.align
							end
							if (l_t.item.cols + l_x).item.valign /= -1 then
								l_cell.item.valign := (l_t.item.cols + l_x).item.valign
							end
						end
						memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_RGB]}.make_shared (l_cell.c_pointer + {PD_TABLE_CELL}.bgcolor_offset))), create {CE_POINTER [ANY]}.make_cast ((l_l_col.address)), {PD_RGB}.sizeof.to_natural_32).do_nothing
						get_align (create {CE_POINTER [INTEGER_8]}.make_cast (l_t_attr), create {CE_POINTER [INTEGER_32]}.make_shared (l_cell.c_pointer + {PD_TABLE_CELL}.align_offset))
						get_valign (create {CE_POINTER [INTEGER_8]}.make_cast (l_t_attr), create {CE_POINTER [INTEGER_32]}.make_shared (l_cell.c_pointer + {PD_TABLE_CELL}.valign_offset))
						html_inst.get_bgcolor (l_t_attr, create {CE_POINTER [PD_RGB]}.make_shared (l_cell.c_pointer + {PD_TABLE_CELL}.bgcolor_offset)).do_nothing
						l_csp := html_inst.get_num (l_t_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("colspan")))
						if l_csp = -1 then
							l_csp := 1
						end
						if not l_csp.to_boolean then
							l_csp := -1
						end
						l_rsp := html_inst.get_num (l_t_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("rowspan")))
						if l_rsp = -1 then
							l_rsp := 1
						end
						if not l_rsp.to_boolean then
							l_rsp := -1
						end
						if l_csp >= 0 then
							if l_rsp >= 0 then
								if l_csp * l_rsp > 100000 then
									if l_csp > 10 then
										l_csp := -1
									end
									if l_rsp > 10 then
										l_rsp := -1
									end
								end
							end
						end
						l_cell.item.colspan := l_csp
						l_cell.item.rowspan := l_rsp
						if l_csp = 1 then
							l_w := -1
							get_c_width (create {CE_POINTER [INTEGER_8]}.make_cast (l_t_attr), create {CE_POINTER [INTEGER_32]}.make_shared ($l_w), a_sh)
							if l_w /= -1 then
								set_td_width (l_t, l_x, l_w, 0)
							end
						end
						l_qqq := l_t.item.x
						l_i := 1
						from
						until
							js.loop_left
						loop
							js.reset
							if l_csp /= -1 then
								l_tmp___21 := (l_i < l_csp).to_integer
							else
								l_tmp___21 := (l_x + l_i < l_qqq).to_integer
							end
							if not l_tmp___21.to_boolean then
								js.break
							end
							if not js.loop_jumped then
								l_sc.ce_gets ((new_cell (l_t, l_x + l_i, l_y)))
								if (l_sc.item.used).to_boolean then
									l_csp := l_i
									l_k := 0
									from
									until
										not (l_k < l_i)
									loop
										(l_t.item.cells + (l_y * l_t.item.rx + (l_x + l_k))).item.colspan := l_csp
										l_k := l_k + 1
									end
									js.break
								end
							end
							if not js.loop_jumped then
								l_tmp___20 := 1
								l_sc.item.spanned := l_tmp___20
								l_sc.item.used := l_tmp___20
								l_sc.item.rowspan := l_rsp
								l_sc.item.colspan := l_csp
								l_sc.item.mx := l_x
								l_sc.item.my := l_y
								l_i := l_i + 1
							end
						end
						js.reset
						l_qqq := l_t.item.y
						l_j := 1
				when 35 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 43 -- skip loop
						end
				when 36 then -- loop body:
						js.reset
						if l_rsp /= -1 then
							l_tmp___24 := (l_j < l_rsp).to_integer
						else
							l_tmp___24 := (l_y + l_j < l_qqq).to_integer
						end
						if not l_tmp___24.to_boolean then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 42 -- skip if block
						end
				when 37 then -- if:
						l_k := 0
				when 38 then -- loop condition:
						if not (not js.loop_left and then (l_k < l_i)) then
							l_pos := -1 + 41 -- skip loop
						end
				when 39 then -- loop body:
						js.reset
						l_sc___0.ce_gets ((new_cell (l_t, l_x + l_k, l_y + l_j)))
						if (l_sc___0.item.used).to_boolean then
							if l_sc___0.item.mx = l_x then
								if l_sc___0.item.my = l_y then
									js.continue
								end
							end
							if not js.loop_jumped then
								l_l := 0
								from
								until
									not (l_l < l_k)
								loop
									memset (create {CE_POINTER [ANY]}.make_cast ((l_t.item.cells + ((l_y + l_j) * l_t.item.rx + (l_x + l_l)))), 0, {PD_TABLE_CELL}.sizeof.to_natural_32).do_nothing
									l_l := l_l + 1
								end
								l_rsp := l_j
								l_l := 0
								from
								until
									not (not js.loop_left and then (l_l < l_i))
								loop
									l_m := 0
									from
									until
										not (l_m < l_j)
									loop
										(l_t.item.cells + ((l_y + l_m) * l_t.item.rx + (l_x + l_l))).item.rowspan := l_j
										l_m := l_m + 1
									end
									l_l := l_l + 1
								end
								l_pos := -1 + 44 -- goto brk
							end
						end
				when 40 then
						if not js.loop_jumped then
							l_tmp___23 := 1
							l_sc___0.item.spanned := l_tmp___23
							l_sc___0.item.used := l_tmp___23
							l_sc___0.item.rowspan := l_rsp
							l_sc___0.item.colspan := l_csp
							l_sc___0.item.mx := l_x
							l_sc___0.item.my := l_y
						end
						if not js.loop_left then
							l_k := l_k + 1
						end
						l_pos := -1 + 38 -- back to loop condition
				when 41 then -- loop done
						l_j := l_j + 1
				when 42 then -- if done
						l_pos := -1 + 35 -- back to loop condition
				when 43 then -- loop done
						js.reset
				when 44 then -- brk:
						l_pos := -1 + 2 -- goto see
				when 45 then -- scan_done:
						a_end.item := l_html
						l_x := 0
						from
						until
							not (not js.loop_left and then (l_x < l_t.item.x))
						loop
							l_y := 0
							from
							until
								not (l_y < l_t.item.y)
							loop
								l_c.ce_gets (l_t.item.cells + (l_y * l_t.item.rx + l_x))
								if not (l_c.item.spanned).to_boolean then
									if l_c.item.colspan = -1 then
										l_c.item.colspan := l_t.item.x - l_x
									end
									if l_c.item.rowspan = -1 then
										l_c.item.rowspan := l_t.item.y - l_y
									end
								end
								l_y := l_y + 1
							end
							l_x := l_x + 1
						end
						if (l_t.item.y).to_natural_32 > {NATURAL_32} 2147483647 // Integer_32_bytes.to_natural_32 then
							from
							until
								False
							loop
								error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 524])
								kbd_inst.fatal_tty_exit
								exit (4)
							end
						end
						l_t.item.r_heights := create {CE_POINTER [INTEGER_32]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 525, (l_t.item.y).to_natural_32 * Integer_32_bytes.to_natural_32)))
						memset (create {CE_POINTER [ANY]}.make_cast (l_t.item.r_heights), 0, (l_t.item.y).to_natural_32 * Integer_32_bytes.to_natural_32).do_nothing
						l_x := 0
						from
						until
							not (l_x < l_t.item.c)
						loop
							if (l_t.item.cols + l_x).item.width /= -1 then
								set_td_width (l_t, l_x, (l_t.item.cols + l_x).item.width, 1)
							end
							l_x := l_x + 1
						end
						set_td_width (l_t, l_t.item.x, -1, 0)
						Result := l_t
				when 46 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_cell_width (a_start: CE_POINTER [INTEGER_8]; a_end: CE_POINTER [INTEGER_8]; a_cellpd: INTEGER_32; a_w: INTEGER_32; a_a: INTEGER_32; a_min: CE_POINTER [INTEGER_32]; a_max: CE_POINTER [INTEGER_32]; a_n_link: INTEGER_32; a_n_links: CE_POINTER [INTEGER_32])
		local
			l_p: CE_POINTER [PD_PART]
			js: JUMP_STATE
		do
			create l_p.make

			if ((a_min).c_pointer /= default_pointer) then
				a_min.item := -1
			end
			if ((a_max).c_pointer /= default_pointer) then
				a_max.item := -1
			end
			if ((a_n_links).c_pointer /= default_pointer) then
				a_n_links.item := a_n_link
			end
			l_p.ce_gets (html_r_inst.format_html_part (create {CE_POINTER [NATURAL_8]}.make_cast (a_start), create {CE_POINTER [NATURAL_8]}.make_cast (a_end), 0, a_cellpd, a_w, create {CE_POINTER [PD_F_DATA]}.make_shared (default_pointer), (a_a.to_boolean).to_integer, (a_a.to_boolean).to_integer, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), a_n_link))
			if (l_p).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				if ((a_min).c_pointer /= default_pointer) then
					a_min.item := l_p.item.x
				end
				if ((a_max).c_pointer /= default_pointer) then
					a_max.item := l_p.item.xmax
				end
				if ((a_n_links).c_pointer /= default_pointer) then
					a_n_links.item := l_p.item.link_num
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 545, create {CE_POINTER [ANY]}.make_cast (l_p))
			end
		end

	get_cell_widths (a_t: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS])
		local
			l_nl: INTEGER_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_c: CE_POINTER [PD_TABLE_CELL]
			l_c___0: CE_POINTER [PD_TABLE_CELL]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_c.make
			create l_c___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_nl := (a_t.item.p).item.link_num
					if (links_inst.d_opt.item.table_order).to_boolean then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						l_j := 0
				when 2 then -- loop condition:
						if not (not js.loop_left and then (l_j < a_t.item.y)) then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						l_i := 0
				when 4 then -- loop condition:
						if not (not js.loop_left and then (l_i < a_t.item.x)) then
							l_pos := -1 + 9 -- skip loop
						end
				when 5 then -- loop body: | loop condition:
						if js.loop_left then
							l_pos := -1 + 8 -- skip loop
						end
				when 6 then -- loop body:
						js.reset
						l_c.ce_gets (a_t.item.cells + (l_j * a_t.item.rx + l_i))
						if (l_c.item.start).c_pointer = default_pointer then
							js.continue
						end
						if not js.loop_jumped then
							l_c.item.link_num := l_nl
							get_cell_width (create {CE_POINTER [INTEGER_8]}.make_cast (l_c.item.start), create {CE_POINTER [INTEGER_8]}.make_cast (l_c.item.end2), a_t.item.cellpd, 0, 0, create {CE_POINTER [INTEGER_32]}.make_shared (l_c.c_pointer + {PD_TABLE_CELL}.min_width_offset), create {CE_POINTER [INTEGER_32]}.make_shared (l_c.c_pointer + {PD_TABLE_CELL}.max_width_offset), l_nl, create {CE_POINTER [INTEGER_32]}.make_shared ($l_nl))
						end
						if not js.loop_left then
							l_pos := -1 + 8 -- break
						end
				when 7 then
						l_pos := -1 + 5 -- back to loop condition
				when 8 then -- loop done
						js.reset
						l_i := l_i + 1
						l_pos := -1 + 4 -- back to loop condition
				when 9 then -- loop done
						l_j := l_j + 1
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done | if block done, skip else block:
						l_pos := -1 + 20
				when 11 then -- else:
						l_i := 0
				when 12 then -- loop condition:
						if not (not js.loop_left and then (l_i < a_t.item.x)) then
							l_pos := -1 + 20 -- skip loop
						end
				when 13 then -- loop body:
						l_j := 0
				when 14 then -- loop condition:
						if not (not js.loop_left and then (l_j < a_t.item.y)) then
							l_pos := -1 + 19 -- skip loop
						end
				when 15 then -- loop body: | loop condition:
						if js.loop_left then
							l_pos := -1 + 18 -- skip loop
						end
				when 16 then -- loop body:
						js.reset
						l_c___0.ce_gets (a_t.item.cells + (l_j * a_t.item.rx + l_i))
						if (l_c___0.item.start).c_pointer = default_pointer then
							js.continue
						end
						if not js.loop_jumped then
							l_c___0.item.link_num := l_nl
							get_cell_width (create {CE_POINTER [INTEGER_8]}.make_cast (l_c___0.item.start), create {CE_POINTER [INTEGER_8]}.make_cast (l_c___0.item.end2), a_t.item.cellpd, 0, 0, create {CE_POINTER [INTEGER_32]}.make_shared (l_c___0.c_pointer + {PD_TABLE_CELL}.min_width_offset), create {CE_POINTER [INTEGER_32]}.make_shared (l_c___0.c_pointer + {PD_TABLE_CELL}.max_width_offset), l_nl, create {CE_POINTER [INTEGER_32]}.make_shared ($l_nl))
						end
						if not js.loop_left then
							l_pos := -1 + 18 -- break
						end
				when 17 then
						l_pos := -1 + 15 -- back to loop condition
				when 18 then -- loop done
						js.reset
						l_j := l_j + 1
						l_pos := -1 + 14 -- back to loop condition
				when 19 then -- loop done
						l_i := l_i + 1
						l_pos := -1 + 12 -- back to loop condition
				when 20 then -- loop done | if done
						a_t.item.link_num := l_nl
				when 21 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	dst_width (a_p: CE_POINTER [INTEGER_32]; a_n: INTEGER_32; a_w: INTEGER_32; a_lim: CE_POINTER [INTEGER_32])
		local
			l_w: INTEGER_32
			l_lim: CE_POINTER [INTEGER_32]
			l_i: INTEGER_32
			l_s: INTEGER_32
			l_d: INTEGER_32
			l_r: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_lim.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_w := a_w
					l_lim.ce_gets (a_lim)
					l_s := 0
					l_i := 0
					from
					until
						not (l_i < a_n)
					loop
						l_s := l_s + (a_p[l_i])
						l_i := l_i + 1
					end
					if l_s >= l_w then
						js.return
					end
					if not js.return_called and then (not a_n.to_boolean) then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | again:
						l_d := (l_w - l_s) // a_n
						l_r := (l_w - l_s) \\ a_n
						l_w := 0
						l_i := 0
						from
						until
							not (l_i < a_n)
						loop
							a_p[l_i] := a_p[l_i] + (l_d + (l_i < l_r).to_integer)
							if ((l_lim).c_pointer /= default_pointer) then
								if a_p[l_i] > l_lim[l_i] then
									l_w := l_w + (a_p[l_i] - l_lim[l_i])
									a_p[l_i] := l_lim[l_i]
								end
							end
							l_i := l_i + 1
						end
						if l_w.to_boolean then
							l_lim.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
							l_s := 0
							l_pos := -1 + 1 -- goto again
						end
				when 2 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_vline_width (a_t: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]; a_col: INTEGER_32): INTEGER_32
		local
			l_w: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			l_w := 0
			if not a_col.to_boolean then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				if a_t.item.rules = 2 then
					l_w := a_t.item.cellsp
				elseif a_t.item.rules = 3 then
					l_w := a_t.item.cellsp
				elseif a_t.item.rules = 4 then
					if a_col < a_t.item.c then
						if ((a_t.item.cols + a_col).item.group).to_boolean then
							l_tmp := 1
						else
							l_tmp := 0
						end
					else
						l_tmp := 0
					end
					l_w := l_tmp
				end
				if not l_w.to_boolean then
					if (a_t.item.cellpd).to_boolean then
						l_w := -1
					end
				end
				Result := l_w
			end
		end

	get_hline_width (a_t: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]; a_row: INTEGER_32): INTEGER_32
		local
			l_w: INTEGER_32
			l_q: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_w := 0
					if not a_row.to_boolean then
						Result := (-1)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						if a_t.item.rules /= 1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto x
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 4 then -- else:
						if a_t.item.rules /= 3 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | x:
						if (a_t.item.cellsp).to_boolean then
							Result := (a_t.item.cellsp)
							js.return
						elseif (a_t.item.vcellpd).to_boolean then
							Result := (a_t.item.cellsp)
							js.return
						end
						if not js.return_called then
							Result := (-1)
							js.return
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 7 then -- else:
						if a_t.item.rules /= 4 then
							l_pos := -1 + 13 -- skip if block
						end
				when 8 then -- if:
						l_q := 0
				when 9 then -- loop condition:
						if not (l_q < a_t.item.x) then
							l_pos := -1 + 12 -- skip loop
						end
				when 10 then -- loop body:
						if ((a_t.item.cells + (a_row * a_t.item.rx + l_q)).item.group).to_boolean then
							l_pos := -1 + 5 -- goto x
						end
				when 11 then
						l_q := l_q + 1
						l_pos := -1 + 9 -- back to loop condition
				when 12 then -- loop done
						if (a_t.item.vcellpd).to_boolean then
							l_tmp := 0
						else
							l_tmp := -1
						end
						Result := l_tmp
						js.return
				when 13 then -- if done | if done | if done
						if not js.return_called then
							if not l_w.to_boolean then
								if not (a_t.item.vcellpd).to_boolean then
									l_w := -1
								end
							end
							Result := l_w
						end
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	get_column_widths (a_t: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]): INTEGER_32
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_s: INTEGER_32
			l_ns: INTEGER_32
			l_c: CE_POINTER [PD_TABLE_CELL]
			l_k: INTEGER_32
			l_p: INTEGER_32
			l_m: INTEGER_32
			js: JUMP_STATE
		do
			create l_c.make

			if (a_t.item.x).to_natural_32 > {NATURAL_32} 2147483647 // Integer_32_bytes.to_natural_32 then
				from
				until
					False
				loop
					error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 632])
					kbd_inst.fatal_tty_exit
					exit (4)
				end
			end
			if (a_t.item.min_c).c_pointer = default_pointer then
				a_t.item.min_c := create {CE_POINTER [INTEGER_32]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 633, (a_t.item.x).to_natural_32 * Integer_32_bytes.to_natural_32)))
			end
			if (a_t.item.max_c).c_pointer = default_pointer then
				a_t.item.max_c := create {CE_POINTER [INTEGER_32]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 634, (a_t.item.x).to_natural_32 * Integer_32_bytes.to_natural_32)))
			end
			if (a_t.item.w_c).c_pointer = default_pointer then
				a_t.item.w_c := create {CE_POINTER [INTEGER_32]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 635, (a_t.item.x).to_natural_32 * Integer_32_bytes.to_natural_32)))
			end
			memset (create {CE_POINTER [ANY]}.make_cast (a_t.item.min_c), 0, (a_t.item.x).to_natural_32 * Integer_32_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (a_t.item.max_c), 0, (a_t.item.x).to_natural_32 * Integer_32_bytes.to_natural_32).do_nothing
			l_s := 1
			from
			until
				js.loop_left
			loop
				js.reset
				l_ns := 2147483647
				l_i := 0
				from
				until
					not (not js.loop_left and then (l_i < a_t.item.x))
				loop
					l_j := 0
					from
					until
						not (not js.loop_left and then (l_j < a_t.item.y))
					loop
						js.reset
						l_c.ce_gets (a_t.item.cells + (l_j * a_t.item.rx + l_i))
						if (l_c.item.spanned).to_boolean then
							js.continue
						elseif not (l_c.item.used).to_boolean then
							js.continue
						end
						if not js.loop_jumped and then (l_c.item.colspan + l_i > a_t.item.x) then
							js.continue
						end
						if not js.loop_jumped then
							if l_c.item.colspan = l_s then
								l_p := 0
								l_m := 0
								l_k := 1
								from
								until
									not (l_k < l_s)
								loop
									l_p := l_p + ((get_vline_width (a_t, l_i + l_k)) >= 0).to_integer
									l_k := l_k + 1
								end
								dst_width (a_t.item.min_c + l_i, l_s, l_c.item.min_width - l_p, a_t.item.max_c + l_i)
								dst_width (a_t.item.max_c + l_i, l_s, (l_c.item.max_width - l_p) - l_m, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
								l_k := 0
								from
								until
									not (l_k < l_s)
								loop
									if a_t.item.min_c[(l_i + l_k)] > a_t.item.max_c[(l_i + l_k)] then
										a_t.item.max_c[(l_i + l_k)] := a_t.item.min_c[(l_i + l_k)]
									end
									l_k := l_k + 1
								end
							elseif l_c.item.colspan > l_s then
								if l_c.item.colspan < l_ns then
									l_ns := l_c.item.colspan
								end
							end
						end
						if not js.loop_left then
							l_j := l_j + 1
						end
					end
					l_i := l_i + 1
				end
				l_s := l_ns
				if l_s = 2147483647 then
					js.break
				end
			end
			js.reset
			Result := 0
		end

	get_table_width (a_t: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS])
		local
			l_i: INTEGER_32
			l_vl: INTEGER_32
			l_min: INTEGER_32
			l_max: INTEGER_32
		do
			l_min := 0
			l_max := 0
			l_i := 0
			from
			until
				not (l_i < a_t.item.x)
			loop
				l_vl := ((get_vline_width (a_t, l_i)) >= 0).to_integer
				l_min := l_min + l_vl
				l_max := l_max + l_vl
				l_min := l_min + (a_t.item.min_c[l_i])
				if a_t.item.xcols[l_i] > a_t.item.max_c[l_i] then
					l_max := l_max + (a_t.item.xcols[l_i])
				end
				l_max := l_max + (a_t.item.max_c[l_i])
				l_i := l_i + 1
			end
			l_vl := ((((a_t.item.frame).bit_and (4)).to_boolean).to_integer + (((a_t.item.frame).bit_and (8)).to_boolean).to_integer) * ((a_t.item.border).to_boolean).to_integer
			l_min := l_min + l_vl
			l_max := l_max + l_vl
			a_t.item.min_t := l_min
			a_t.item.max_t := l_max
		end

	distribute_widths (a_t: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]; a_width: INTEGER_32)
		local
			l_i: INTEGER_32
			l_d: INTEGER_32
			l_om: INTEGER_32
			l_u: CE_POINTER [INTEGER_8]
			l_w: CE_POINTER [INTEGER_32]
			l_mx: CE_POINTER [INTEGER_32]
			l_mmax_c: INTEGER_32
			l_mss: INTEGER_32
			l_mii: INTEGER_32
			l_p: INTEGER_32
			l_wq: INTEGER_32
			l_dd: INTEGER_32
			l_tmp___2: INTEGER_32
			l_ss: INTEGER_32
			l_q: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_u.make
			create l_w.make
			create l_mx.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d := a_width - a_t.item.min_t
					l_om := 0
					l_mmax_c := 0
					if not (a_t.item.x).to_boolean then
						js.return
					end
					if not js.return_called and then (l_d < 0) then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 25 -- skip if block
					end
				when 1 then -- if:
						l_i := 0
						from
						until
							not (l_i < a_t.item.x)
						loop
							if a_t.item.max_c[l_i] > l_mmax_c then
								l_mmax_c := a_t.item.max_c[l_i]
							end
							l_i := l_i + 1
						end
						memcpy (create {CE_POINTER [ANY]}.make_cast (a_t.item.w_c), create {CE_POINTER [ANY]}.make_cast (a_t.item.min_c), (a_t.item.x).to_natural_32 * Integer_32_bytes.to_natural_32).do_nothing
						a_t.item.rw := a_width
						if (a_t.item.x).to_natural_32 > {NATURAL_32} 2147483647 // Integer_32_bytes.to_natural_32 then
							from
							until
								False
							loop
								error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 711])
								kbd_inst.fatal_tty_exit
								exit (4)
							end
						end
						l_u.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 712, (a_t.item.x).to_natural_32))))
						l_w.ce_gets (create {CE_POINTER [INTEGER_32]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 713, (a_t.item.x).to_natural_32 * Integer_32_bytes.to_natural_32))))
						l_mx.ce_gets (create {CE_POINTER [INTEGER_32]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 714, (a_t.item.x).to_natural_32 * Integer_32_bytes.to_natural_32))))
				when 2 then -- loop condition:
						if not (not js.loop_left and then (l_d.to_boolean)) then
							l_pos := -1 + 24 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						l_p := 0
						memset (create {CE_POINTER [ANY]}.make_cast (l_w), 0, (a_t.item.x).to_natural_32 * Integer_32_bytes.to_natural_32).do_nothing
						memset (create {CE_POINTER [ANY]}.make_cast (l_mx), 0, (a_t.item.x).to_natural_32 * Integer_32_bytes.to_natural_32).do_nothing
						l_i := 0
				when 4 then -- loop condition:
						if not (l_i < a_t.item.x) then
							l_pos := -1 + 20 -- skip loop
						end
				when 5 then -- loop body:
						inspect l_om -- switch 1 head
						when 0 then l_pos := -1 + 6
						when 1 then l_pos := -1 + 7
						when 2 then l_pos := -1 + 8
						when 3 then l_pos := -1 + 8
						when 4 then l_pos := -1 + 15
						when 5 then l_pos := -1 + 16
						when 6 then l_pos := -1 + 17
						else l_pos := -1 + 18
						end
				when 6 then -- switch 1, case 0
						if a_t.item.w_c[l_i] < a_t.item.xcols[l_i] then
							l_w[l_i] := 1
							if a_t.item.xcols[l_i] > a_t.item.max_c[l_i] then
								l_tmp___2 := a_t.item.max_c[l_i]
							else
								l_tmp___2 := a_t.item.xcols[l_i]
							end
							l_mx[l_i] := l_tmp___2 - a_t.item.w_c[l_i]
							if l_mx[l_i] <= 0 then
								l_w[l_i] := 0
							end
						end
						l_pos := -1 + 19 -- switch 1; break
				when 7 then -- switch 1, case 1
						if a_t.item.xcols[l_i] < -1 then
							if a_t.item.xcols[l_i] /= -2 then
								if a_t.item.xcols[l_i] <= -2 then
									l_w[l_i] := -2 - a_t.item.xcols[l_i]
								else
									l_w[l_i] := 1
								end
								l_mx[l_i] := a_t.item.max_c[l_i] - a_t.item.w_c[l_i]
								if l_mx[l_i] <= 0 then
									l_w[l_i] := 0
								end
							end
						end
						l_pos := -1 + 19 -- switch 1; break
				when 8 then -- switch 1, case 2 | switch 1, case 3
						if not (a_t.item.w_c[l_i] < a_t.item.max_c[l_i]) then
							l_pos := -1 + 14 -- skip if block
						end
				when 9 then -- if:
						if l_om /= 3 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 12 then -- else:
						if a_t.item.xcols[l_i] /= -1 then
							l_pos := -1 + 14 -- skip if block
						end
				when 13 then -- if: | _L:
						l_mx[l_i] := a_t.item.max_c[l_i] - a_t.item.w_c[l_i]
						if l_mmax_c.to_boolean then
							l_w[l_i] := 5 + (a_t.item.max_c[l_i] * 10) // l_mmax_c
						else
							l_w[l_i] := 1
						end
				when 14 then -- if done | if done
						l_pos := -1 + 19 -- switch 1; break
				when 15 then -- switch 1, case 4
						if a_t.item.xcols[l_i] >= 0 then
							l_w[l_i] := 1
							l_mx[l_i] := a_t.item.xcols[l_i] - a_t.item.w_c[l_i]
							if l_mx[l_i] <= 0 then
								l_w[l_i] := 0
							end
						end
						l_pos := -1 + 19 -- switch 1; break
				when 16 then -- switch 1, case 5
						if a_t.item.xcols[l_i] < 0 then
							if a_t.item.xcols[l_i] <= -2 then
								l_w[l_i] := -2 - a_t.item.xcols[l_i]
							else
								l_w[l_i] := 1
							end
							l_mx[l_i] := 2147483647
						end
						l_pos := -1 + 19 -- switch 1; break
				when 17 then -- switch 1, case 6
						l_w[l_i] := 1
						l_mx[l_i] := 2147483647
						l_pos := -1 + 19 -- switch 1; break
				when 18 then -- switch 1, default:
						l_pos := -1 + 24 -- goto end2
				when 19 then -- switch 1, done:
						l_p := l_p + (l_w[l_i])
						l_i := l_i + 1
						l_pos := -1 + 4 -- back to loop condition
				when 20 then -- loop done
						if not l_p.to_boolean then
							l_om := l_om + 1
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_wq := 0
						if ((l_u).c_pointer /= default_pointer) then
							memset (create {CE_POINTER [ANY]}.make_cast (l_u), 0, (a_t.item.x).to_natural_32).do_nothing
						end
						l_dd := l_d
				when 22 then -- a:
						l_mss := 0
						l_mii := -1
						l_i := 0
						from
						until
							not (l_i < a_t.item.x)
						loop
							js.reset
							if (l_w[l_i]).to_boolean then
								if ((l_u).c_pointer /= default_pointer) then
									if (l_u[l_i]).to_boolean then
										js.continue
									end
								end
								if not js.loop_jumped then
									l_ss := (l_dd * l_w[l_i]) // l_p
									if not l_ss.to_boolean then
										l_ss := 1
									end
									if l_ss > l_mx[l_i] then
										l_ss := l_mx[l_i]
									end
									if l_ss > l_mss then
										l_mss := l_ss
										l_mii := l_i
									end
								end
							end
							l_i := l_i + 1
						end
						if l_mii /= -1 then
							l_q := a_t.item.w_c[l_mii]
							if ((l_u).c_pointer /= default_pointer) then
								l_u[l_mii] := (1).to_integer_8
							end
							a_t.item.w_c[l_mii] := a_t.item.w_c[l_mii] + l_mss
							l_d := l_d - (a_t.item.w_c[l_mii] - l_q)
							from
							until
								not (l_d < 0)
							loop
								a_t.item.w_c[l_mii] := (a_t.item.w_c[l_mii]) - 1
								l_d := l_d + 1
							end
							if a_t.item.w_c[l_mii] < l_q then
								a_t.item.w_c[l_mii] := l_q
							end
							l_wq := 1
							if l_d.to_boolean then
								l_pos := -1 + 22 -- goto a
							end
						elseif not l_wq.to_boolean then
							l_om := l_om + 1
						end
				when 23 then
						l_pos := -1 + 2 -- back to loop condition
				when 24 then -- end2:
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 794, create {CE_POINTER [ANY]}.make_cast (l_mx))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 795, create {CE_POINTER [ANY]}.make_cast (l_w))
						if ((l_u).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 796, create {CE_POINTER [ANY]}.make_cast (l_u))
						end
				when 25 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_table_widths (a_t: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS])
		local
			l_w: CE_POINTER [INTEGER_32]
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_s: INTEGER_32
			l_ns: INTEGER_32
			l_m: INTEGER_32
			l_mi: INTEGER_32
			l_c: CE_POINTER [PD_TABLE_CELL]
			l_k: INTEGER_32
			l_p: INTEGER_32
			l_c___0: CE_POINTER [PD_TABLE_CELL]
			l_k___0: INTEGER_32
			l_p___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_w.make
			create l_c.make
			create l_c___0.make

			l_mi := 0
			if (a_t.item.x).to_natural_32 > {NATURAL_32} 2147483647 // Integer_32_bytes.to_natural_32 then
				from
				until
					False
				loop
					error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 806])
					kbd_inst.fatal_tty_exit
					exit (4)
				end
			end
			l_w.ce_gets (create {CE_POINTER [INTEGER_32]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 807, (a_t.item.x).to_natural_32 * Integer_32_bytes.to_natural_32))))
			memset (create {CE_POINTER [ANY]}.make_cast (l_w), 0, (a_t.item.x).to_natural_32 * Integer_32_bytes.to_natural_32).do_nothing
			l_j := 0
			from
			until
				not (not js.loop_left and then (l_j < a_t.item.y))
			loop
				l_i := 0
				from
				until
					not (not js.loop_left and then (l_i < a_t.item.x))
				loop
					js.reset
					l_c.ce_gets (a_t.item.cells + (l_j * a_t.item.rx + l_i))
					l_p := 0
					if (l_c.item.start).c_pointer = default_pointer then
						js.continue
					end
					if not js.loop_jumped then
						l_k := 1
						from
						until
							not (l_k < l_c.item.colspan)
						loop
							l_p := l_p + ((get_vline_width (a_t, l_i + l_k)) >= 0).to_integer
							l_k := l_k + 1
						end
						l_k := 0
						from
						until
							not (l_k < l_c.item.colspan)
						loop
							l_p := l_p + (a_t.item.w_c[(l_i + l_k)])
							l_k := l_k + 1
						end
						get_cell_width (create {CE_POINTER [INTEGER_8]}.make_cast (l_c.item.start), create {CE_POINTER [INTEGER_8]}.make_cast (l_c.item.end2), a_t.item.cellpd, l_p, 1, create {CE_POINTER [INTEGER_32]}.make_shared (l_c.c_pointer + {PD_TABLE_CELL}.x_width_offset), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_c.item.link_num, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
						if l_c.item.x_width > l_p then
							l_c.item.x_width := l_p
						end
					end
					if not js.loop_left then
						l_i := l_i + 1
					end
				end
				l_j := l_j + 1
			end
			l_s := 1
			from
			until
				js.loop_left
			loop
				js.reset
				l_ns := 2147483647
				l_i := 0
				from
				until
					not (not js.loop_left and then (l_i < a_t.item.x))
				loop
					l_j := 0
					from
					until
						not (not js.loop_left and then (l_j < a_t.item.y))
					loop
						js.reset
						l_c___0.ce_gets (a_t.item.cells + (l_j * a_t.item.rx + l_i))
						if (l_c___0.item.start).c_pointer = default_pointer then
							js.continue
						end
						if not js.loop_jumped then
							if l_c___0.item.colspan + l_i > a_t.item.x then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 832, create {CE_POINTER [ANY]}.make_cast (l_w))
								js.return
							end
							if not js.return_called then
								if l_c___0.item.colspan = l_s then
									l_p___0 := 0
									l_k___0 := 1
									from
									until
										not (l_k___0 < l_s)
									loop
										l_p___0 := l_p___0 + ((get_vline_width (a_t, l_i + l_k___0)) >= 0).to_integer
										l_k___0 := l_k___0 + 1
									end
									dst_width (l_w + l_i, l_s, l_c___0.item.x_width - l_p___0, a_t.item.max_c + l_i)
								elseif l_c___0.item.colspan > l_s then
									if l_c___0.item.colspan < l_ns then
										l_ns := l_c___0.item.colspan
									end
								end
							end
						end
						if not js.loop_left then
							l_j := l_j + 1
						end
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
				if not js.return_called then
					l_s := l_ns
					if l_s = 2147483647 then
						js.break
					end
				end
			end
			js.reset
			if not js.return_called then
				l_s := 0
				l_ns := 0
				l_i := 0
				from
				until
					not (l_i < a_t.item.x)
				loop
					l_s := l_s + (a_t.item.w_c[l_i])
					l_ns := l_ns + (l_w[l_i])
					l_i := l_i + 1
				end
				if l_ns > l_s then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 865, create {CE_POINTER [ANY]}.make_cast (l_w))
					js.return
				end
			end
			if not js.return_called then
				l_m := -1
				l_i := 0
				from
				until
					not (l_i < a_t.item.x)
				loop
					if a_t.item.max_c[l_i] > l_m then
						l_m := a_t.item.max_c[l_i]
						l_mi := l_i
					end
					l_i := l_i + 1
				end
				if l_m /= -1 then
					l_w[l_mi] := l_w[l_mi] + (l_s - l_ns)
					if l_w[l_mi] <= a_t.item.max_c[l_mi] then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 877, create {CE_POINTER [ANY]}.make_cast (a_t.item.w_c))
						a_t.item.w_c := l_w
						js.return
					end
				end
			end
			if not js.return_called then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 882, create {CE_POINTER [ANY]}.make_cast (l_w))
			end
		end

	get_table_heights (a_t: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS])
		local
			l_s: INTEGER_32
			l_ns: INTEGER_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_cell: CE_POINTER [PD_TABLE_CELL]
			l_p: CE_POINTER [PD_PART]
			l_xw: INTEGER_32
			l_sp: INTEGER_32
			l_cell___0: CE_POINTER [PD_TABLE_CELL]
			l_k: INTEGER_32
			l_p___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_cell.make
			create l_p.make
			create l_cell___0.make

			l_j := 0
			from
			until
				not (not js.loop_left and then (l_j < a_t.item.y))
			loop
				l_i := 0
				from
				until
					not (not js.loop_left and then (l_i < a_t.item.x))
				loop
					js.reset
					l_cell.ce_gets (a_t.item.cells + (l_j * a_t.item.rx + l_i))
					l_xw := 0
					if not (l_cell.item.used).to_boolean then
						js.continue
					elseif (l_cell.item.spanned).to_boolean then
						js.continue
					end
					if not js.loop_jumped then
						l_sp := 0
						from
						until
							not (l_sp < l_cell.item.colspan)
						loop
							l_xw := l_xw + (a_t.item.w_c[(l_i + l_sp)])
							if l_sp < l_cell.item.colspan - 1 then
								l_xw := l_xw + ((get_vline_width (a_t, (l_i + l_sp) + 1)) >= 0).to_integer
							end
							l_sp := l_sp + 1
						end
						l_p.ce_gets (html_r_inst.format_html_part (l_cell.item.start, l_cell.item.end2, l_cell.item.align, a_t.item.cellpd, l_xw, create {CE_POINTER [PD_F_DATA]}.make_shared (default_pointer), 2, 2, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_cell.item.link_num))
						if (l_p).c_pointer = default_pointer then
							js.return
						end
						if not js.return_called then
							l_cell.item.height := l_p.item.y
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 903, create {CE_POINTER [ANY]}.make_cast (l_p))
						end
					end
					if not js.loop_left then
						l_i := l_i + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				l_s := 1
				from
				until
					js.loop_left
				loop
					js.reset
					l_ns := 2147483647
					l_j := 0
					from
					until
						not (not js.loop_left and then (l_j < a_t.item.y))
					loop
						l_i := 0
						from
						until
							not (not js.loop_left and then (l_i < a_t.item.x))
						loop
							js.reset
							l_cell___0.ce_gets (a_t.item.cells + (l_j * a_t.item.rx + l_i))
							if not (l_cell___0.item.used).to_boolean then
								js.continue
							elseif (l_cell___0.item.spanned).to_boolean then
								js.continue
							end
							if not js.loop_jumped then
								if l_cell___0.item.rowspan = l_s then
									l_p___0 := 0
									l_k := 1
									from
									until
										not (l_k < l_s)
									loop
										l_p___0 := l_p___0 + ((get_hline_width (a_t, l_j + l_k)) >= 0).to_integer
										l_k := l_k + 1
									end
									dst_width (a_t.item.r_heights + l_j, l_s, l_cell___0.item.height - l_p___0, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
								elseif l_cell___0.item.rowspan > l_s then
									if l_cell___0.item.rowspan < l_ns then
										l_ns := l_cell___0.item.rowspan
									end
								end
							end
							if not js.loop_left then
								l_i := l_i + 1
							end
						end
						l_j := l_j + 1
					end
					l_s := l_ns
					if l_s = 2147483647 then
						js.break
					end
				end
				js.reset
				a_t.item.rh := ((((a_t.item.frame).bit_and (1)).to_boolean).to_integer + (((a_t.item.frame).bit_and (2)).to_boolean).to_integer) * ((a_t.item.border).to_boolean).to_integer
				l_j := 0
				from
				until
					not (l_j < a_t.item.y)
				loop
					a_t.item.rh := a_t.item.rh + (a_t.item.r_heights[l_j])
					if l_j.to_boolean then
						a_t.item.rh := a_t.item.rh + ((get_hline_width (a_t, l_j)) >= 0).to_integer
					end
					l_j := l_j + 1
				end
			end
		end

	display_complicated_table (a_t: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]; a_x: INTEGER_32; a_y: INTEGER_32; a_yy: CE_POINTER [INTEGER_32])
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_f: CE_POINTER [PD_F_DATA]
			l_yp: INTEGER_32
			l_xp: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_cell: CE_POINTER [PD_TABLE_CELL]
			l_yt: INTEGER_32
			l_p: CE_POINTER [PD_PART]
			l_xw: INTEGER_32
			l_yw: INTEGER_32
			l_s: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_f.make
			create l_cell.make
			create l_p.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_f.ce_gets ((a_t.item.p).item.data)
					if ((a_t.item.frame).bit_and (4)).to_boolean then
						if (a_t.item.border).to_boolean then
							l_tmp := 1
						else
							l_tmp := 0
						end
					else
						l_tmp := 0
					end
					l_xp := a_x + l_tmp
					l_i := 0
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_i < a_t.item.x)) then
						l_pos := -1 + 12 -- skip loop
					end
				when 2 then -- loop body:
						if ((a_t.item.frame).bit_and (1)).to_boolean then
							if (a_t.item.border).to_boolean then
								l_tmp___0 := 1
							else
								l_tmp___0 := 0
							end
						else
							l_tmp___0 := 0
						end
						l_yp := a_y + l_tmp___0
						l_j := 0
				when 3 then -- loop condition:
						if not (not js.loop_left and then (l_j < a_t.item.y)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 4 then -- loop body:
						l_cell.ce_gets (a_t.item.cells + (l_j * a_t.item.rx + l_i))
						if (l_cell.item.start).c_pointer = default_pointer then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						l_p.ce_gets (create {CE_POINTER [PD_PART]}.make_shared (default_pointer))
						l_xw := 0
						l_yw := 0
						l_s := 0
						from
						until
							not (l_s < l_cell.item.colspan)
						loop
							l_xw := l_xw + (a_t.item.w_c[(l_i + l_s)])
							if l_s < l_cell.item.colspan - 1 then
								l_xw := l_xw + ((get_vline_width (a_t, (l_i + l_s) + 1)) >= 0).to_integer
							end
							l_s := l_s + 1
						end
						l_s := 0
						from
						until
							not (l_s < l_cell.item.rowspan)
						loop
							l_yw := l_yw + (a_t.item.r_heights[(l_j + l_s)])
							if l_s < l_cell.item.rowspan - 1 then
								l_yw := l_yw + ((get_hline_width (a_t, (l_j + l_s) + 1)) >= 0).to_integer
							end
							l_s := l_s + 1
						end
						html_inst.html_stack_dup;
						(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.dontkill := 1
						if (l_cell.item.b).to_boolean then
							(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.attr.attr := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.attr.attr).bit_or ((1))
						end
						memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_RGB]}.make_shared ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).c_pointer + {PD_HTML_ELEMENT}.attr_offset + {PD_TEXT_ATTRIB}.bg_offset))), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_RGB]}.make_shared (l_cell.c_pointer + {PD_TABLE_CELL}.bgcolor_offset))), {PD_RGB}.sizeof.to_natural_32).do_nothing
						memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_RGB]}.make_shared ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).c_pointer + {PD_HTML_ELEMENT}.parattr_offset + {PD_PAR_ATTRIB}.bgcolor_offset))), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_RGB]}.make_shared (l_cell.c_pointer + {PD_TABLE_CELL}.bgcolor_offset))), {PD_RGB}.sizeof.to_natural_32).do_nothing
						if l_cell.item.valign = 1 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if l_cell.item.valign /= 2 then
							l_tmp___4 := 0
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if l_cell.item.valign = 1 then
							l_tmp___3 := 2
						else
							l_tmp___3 := 1
						end
						l_tmp___4 := (l_yw - l_cell.item.height) // l_tmp___3
				when 9 then
						l_p.ce_gets (html_r_inst.format_html_part (l_cell.item.start, l_cell.item.end2, l_cell.item.align, a_t.item.cellpd, l_xw, l_f, (a_t.item.p).item.xp + l_xp, ((a_t.item.p).item.yp + l_yp) + l_tmp___4, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_cell.item.link_num))
						l_cell.item.xpos := l_xp
						l_cell.item.ypos := l_yp
						l_cell.item.xw := l_xw
						l_cell.item.yw := l_yw
						l_yt := 0
						from
						until
							not (l_yt < l_p.item.y)
						loop
							html_r_inst.xxpand_lines (a_t.item.p, l_yp + l_yt)
							html_r_inst.xxpand_line (a_t.item.p, l_yp + l_yt, l_xp + a_t.item.w_c[l_i])
							l_yt := l_yt + 1
						end
						html_inst.kill_html_stack_item (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 964, create {CE_POINTER [ANY]}.make_cast (l_p))
				when 10 then -- if done
						l_cell.item.xpos := l_xp
						l_cell.item.ypos := l_yp
						l_cell.item.xw := a_t.item.w_c[l_i]
						l_yp := l_yp + (a_t.item.r_heights[l_j])
						if l_j < a_t.item.y - 1 then
							l_yp := l_yp + ((get_hline_width (a_t, l_j + 1)) >= 0).to_integer
						end
						l_j := l_j + 1
						l_pos := -1 + 3 -- back to loop condition
				when 11 then -- loop done
						if l_i < a_t.item.x - 1 then
							l_xp := l_xp + (a_t.item.w_c[l_i] + ((get_vline_width (a_t, l_i + 1)) >= 0).to_integer)
						end
						l_i := l_i + 1
						l_pos := -1 + 1 -- back to loop condition
				when 12 then -- loop done
					l_yp := a_y
					l_j := 0
					from
					until
						not (l_j < a_t.item.y)
					loop
						l_yp := l_yp + (a_t.item.r_heights[l_j])
						if l_j < a_t.item.y - 1 then
							l_yp := l_yp + ((get_hline_width (a_t, l_j + 1)) >= 0).to_integer
						end
						l_j := l_j + 1
					end
					a_yy.item := l_yp + ((((a_t.item.frame).bit_and (1)).to_boolean).to_integer + (((a_t.item.frame).bit_and (2)).to_boolean).to_integer) * ((a_t.item.border).to_boolean).to_integer
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	display_table_frames (a_t: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]; a_x: INTEGER_32; a_y: INTEGER_32)
		local
			l_fh: CE_POINTER [INTEGER_8]
			l_fv: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_cx: INTEGER_32
			l_cy: INTEGER_32
			l_x___0: INTEGER_32
			l_y___0: INTEGER_32
			l_xsp: INTEGER_32
			l_ysp: INTEGER_32
			l_cell: CE_POINTER [PD_TABLE_CELL]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_w: INTEGER_32
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: INTEGER_32
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___17: INTEGER_32
			l_tmp___18: CE_POINTER [INTEGER_8]
			l_tmp___20: CE_POINTER [INTEGER_8]
			l_tmp___21: INTEGER_32
			l_tmp___22: CE_POINTER [INTEGER_8]
			l_tmp___24: CE_POINTER [INTEGER_8]
			l_tmp___25: INTEGER_32
			l_tmp___26: CE_POINTER [INTEGER_8]
			l_tmp___27: CE_POINTER [INTEGER_8]
			l_tmp___28: CE_POINTER [INTEGER_8]
			l_tmp___29: CE_POINTER [INTEGER_8]
			l_tmp___30: CE_POINTER [INTEGER_8]
			l_qq: INTEGER_32
			l_tmp___32: CE_POINTER [INTEGER_8]
			l_tmp___33: INTEGER_32
			l_tmp___34: CE_POINTER [INTEGER_8]
			l_tmp___35: CE_POINTER [INTEGER_8]
			l_tmp___37: CE_POINTER [INTEGER_8]
			l_tmp___38: INTEGER_32
			l_tmp___39: CE_POINTER [INTEGER_8]
			l_tmp___40: CE_POINTER [INTEGER_8]
			l_tmp___42: CE_POINTER [INTEGER_8]
			l_tmp___43: INTEGER_32
			l_tmp___44: CE_POINTER [INTEGER_8]
			l_tmp___46: CE_POINTER [INTEGER_8]
			l_tmp___47: INTEGER_32
			l_tmp___48: CE_POINTER [INTEGER_8]
			l_tmp___50: CE_POINTER [INTEGER_8]
			l_tmp___51: INTEGER_32
			l_tmp___52: CE_POINTER [INTEGER_8]
			l_tmp___54: CE_POINTER [INTEGER_8]
			l_tmp___55: INTEGER_32
			l_tmp___56: CE_POINTER [INTEGER_8]
			l_tmp___57: CE_POINTER [INTEGER_8]
			l_tmp___58: CE_POINTER [INTEGER_8]
			l_tmp___59: CE_POINTER [INTEGER_8]
			l_tmp___60: CE_POINTER [INTEGER_8]
			l_qq___0: INTEGER_32
			l_tmp___62: CE_POINTER [INTEGER_8]
			l_tmp___63: INTEGER_32
			l_tmp___64: CE_POINTER [INTEGER_8]
			l_tmp___65: CE_POINTER [INTEGER_8]
			l_qq___1: INTEGER_32
			l_tmp___67: CE_POINTER [INTEGER_8]
			l_tmp___68: INTEGER_32
			l_tmp___69: CE_POINTER [INTEGER_8]
			l_tmp___70: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fh.make
			create l_fv.make
			create l_cell.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___7.make
			create l_tmp___8.make
			create l_tmp___9.make
			create l_tmp___10.make
			create l_tmp___12.make
			create l_tmp___14.make
			create l_tmp___16.make
			create l_tmp___18.make
			create l_tmp___20.make
			create l_tmp___22.make
			create l_tmp___24.make
			create l_tmp___26.make
			create l_tmp___27.make
			create l_tmp___28.make
			create l_tmp___29.make
			create l_tmp___30.make
			create l_tmp___32.make
			create l_tmp___34.make
			create l_tmp___35.make
			create l_tmp___37.make
			create l_tmp___39.make
			create l_tmp___40.make
			create l_tmp___42.make
			create l_tmp___44.make
			create l_tmp___46.make
			create l_tmp___48.make
			create l_tmp___50.make
			create l_tmp___52.make
			create l_tmp___54.make
			create l_tmp___56.make
			create l_tmp___57.make
			create l_tmp___58.make
			create l_tmp___59.make
			create l_tmp___60.make
			create l_tmp___62.make
			create l_tmp___64.make
			create l_tmp___65.make
			create l_tmp___67.make
			create l_tmp___69.make
			create l_tmp___70.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_t.item.x).to_natural_32 > {NATURAL_32} 2147483647 then
						from
						until
							False
						loop
							error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 999])
							kbd_inst.fatal_tty_exit
							exit (4)
						end
					end
					if (a_t.item.y).to_natural_32 > {NATURAL_32} 2147483647 then
						from
						until
							False
						loop
							error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 1000])
							kbd_inst.fatal_tty_exit
							exit (4)
						end
					end
					if (((a_t.item.x).to_natural_32 + {NATURAL_32} 2) * ((a_t.item.y).to_natural_32 + {NATURAL_32} 2)) // ((a_t.item.x).to_natural_32 + {NATURAL_32} 2) /= (a_t.item.y).to_natural_32 + {NATURAL_32} 2 then
						from
						until
							False
						loop
							error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 1001])
							kbd_inst.fatal_tty_exit
							exit (4)
						end
					end
					if ((a_t.item.x).to_natural_32 + {NATURAL_32} 2) * ((a_t.item.y).to_natural_32 + {NATURAL_32} 2) > {NATURAL_32} 2147483647 then
						from
						until
							False
						loop
							error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 1002])
							kbd_inst.fatal_tty_exit
							exit (4)
						end
					end
					l_fh.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 1003, ((a_t.item.x + 2) * (a_t.item.y + 1)).to_natural_32))))
					memset (create {CE_POINTER [ANY]}.make_cast (l_fh), -1, ((a_t.item.x + 2) * (a_t.item.y + 1)).to_natural_32).do_nothing
					l_fv.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 1005, ((a_t.item.x + 1) * (a_t.item.y + 2)).to_natural_32))))
					memset (create {CE_POINTER [ANY]}.make_cast (l_fv), -1, ((a_t.item.x + 1) * (a_t.item.y + 2)).to_natural_32).do_nothing
					l_j := 0
					from
					until
						not (not js.loop_left and then (l_j < a_t.item.y))
					loop
						l_i := 0
						from
						until
							not (not js.loop_left and then (l_i < a_t.item.x))
						loop
							js.reset
							l_cell.ce_gets (a_t.item.cells + (l_j * a_t.item.rx + l_i))
							if not (l_cell.item.used).to_boolean then
								js.continue
							elseif (l_cell.item.spanned).to_boolean then
								js.continue
							end
							if not js.loop_jumped then
								l_xsp := l_cell.item.colspan
								if l_xsp = 0 then
									l_xsp := a_t.item.x - l_i
								end
								l_ysp := l_cell.item.rowspan
								if l_ysp = 0 then
									l_ysp := a_t.item.y - l_j
								end
								if a_t.item.rules /= 0 then
									if a_t.item.rules /= 2 then
										l_x___0 := 0
										from
										until
											not (l_x___0 < l_xsp)
										loop
											if l_i + l_x___0 < -1 then
												l_tmp___1.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											elseif l_i + l_x___0 > a_t.item.x + 1 then
												l_tmp___1.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											elseif l_j < 0 then
												l_tmp___1.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											elseif l_j > a_t.item.y then
												l_tmp___1.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											else
												l_tmp___1.ce_gets (l_fh + (((l_i + l_x___0) + 1) + (a_t.item.x + 2) * l_j))
											end
											l_tmp___1[0] := (a_t.item.cellsp).to_integer_8
											if l_i + l_x___0 < -1 then
												l_tmp___2.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											elseif l_i + l_x___0 > a_t.item.x + 1 then
												l_tmp___2.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											elseif l_j + l_ysp < 0 then
												l_tmp___2.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											elseif l_j + l_ysp > a_t.item.y then
												l_tmp___2.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											else
												l_tmp___2.ce_gets (l_fh + (((l_i + l_x___0) + 1) + (a_t.item.x + 2) * (l_j + l_ysp)))
											end
											l_tmp___2[0] := (a_t.item.cellsp).to_integer_8
											l_x___0 := l_x___0 + 1
										end
									end
								end
								if a_t.item.rules /= 0 then
									if a_t.item.rules /= 1 then
										l_y___0 := 0
										from
										until
											not (l_y___0 < l_ysp)
										loop
											if l_i < 0 then
												l_tmp___3.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											elseif l_i > a_t.item.x then
												l_tmp___3.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											elseif l_j + l_y___0 < -1 then
												l_tmp___3.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											elseif l_j + l_y___0 > a_t.item.y + 1 then
												l_tmp___3.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											else
												l_tmp___3.ce_gets (l_fv + (((l_j + l_y___0) + 1) + (a_t.item.y + 2) * l_i))
											end
											l_tmp___3[0] := (a_t.item.cellsp).to_integer_8
											if l_i + l_xsp < 0 then
												l_tmp___4.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											elseif l_i + l_xsp > a_t.item.x then
												l_tmp___4.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											elseif l_j + l_y___0 < -1 then
												l_tmp___4.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											elseif l_j + l_y___0 > a_t.item.y + 1 then
												l_tmp___4.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											else
												l_tmp___4.ce_gets (l_fv + (((l_j + l_y___0) + 1) + (a_t.item.y + 2) * (l_i + l_xsp)))
											end
											l_tmp___4[0] := (a_t.item.cellsp).to_integer_8
											l_y___0 := l_y___0 + 1
										end
									end
								end
							end
							if not js.loop_left then
								l_i := l_i + 1
							end
						end
						l_j := l_j + 1
					end
					if a_t.item.rules /= 4 then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						l_i := 1
						from
						until
							not (not js.loop_left and then (l_i < a_t.item.x))
						loop
							js.reset
							if (a_t.item.xcols[l_i]).to_boolean then
								js.continue
							end
							if not js.loop_jumped then
								l_j := 0
								from
								until
									not (l_j < a_t.item.y)
								loop
									if l_i < 0 then
										l_tmp___5.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
									elseif l_i > a_t.item.x then
										l_tmp___5.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
									elseif l_j < -1 then
										l_tmp___5.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
									elseif l_j > a_t.item.y + 1 then
										l_tmp___5.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
									else
										l_tmp___5.ce_gets (l_fv + ((l_j + 1) + (a_t.item.y + 2) * l_i))
									end
									l_tmp___5[0] := (0).to_integer_8
									l_j := l_j + 1
								end
							end
							if not js.loop_left then
								l_i := l_i + 1
							end
						end
						l_j := 1
				when 2 then -- loop condition:
						if not (not js.loop_left and then (l_j < a_t.item.y)) then
							l_pos := -1 + 9 -- skip loop
						end
				when 3 then -- loop body:
						l_i := 0
				when 4 then -- loop condition:
						if not (l_i < a_t.item.x) then
							l_pos := -1 + 7 -- skip loop
						end
				when 5 then -- loop body:
						if ((a_t.item.cells + (l_j * a_t.item.rx + l_i)).item.group).to_boolean then
							l_pos := -1 + 8 -- goto c
						end
				when 6 then
						l_i := l_i + 1
						l_pos := -1 + 4 -- back to loop condition
				when 7 then -- loop done
						l_i := 0
						from
						until
							not (l_i < a_t.item.x)
						loop
							if l_i < -1 then
								l_tmp___6.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_i > a_t.item.x + 1 then
								l_tmp___6.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j < 0 then
								l_tmp___6.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j > a_t.item.y then
								l_tmp___6.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								l_tmp___6.ce_gets (l_fh + ((l_i + 1) + (a_t.item.x + 2) * l_j))
							end
							l_tmp___6[0] := (0).to_integer_8
							l_i := l_i + 1
						end
				when 8 then -- c:
						l_j := l_j + 1
						l_pos := -1 + 2 -- back to loop condition
				when 9 then -- loop done | if done
						l_i := 0
						from
						until
							not (l_i < a_t.item.x)
						loop
							if l_i < -1 then
								l_tmp___7.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_i > a_t.item.x + 1 then
								l_tmp___7.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif 0 > a_t.item.y then
								l_tmp___7.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								l_tmp___7.ce_gets (l_fh + (l_i + 1))
							end
							l_tmp___7[0] := (a_t.item.border * (((a_t.item.frame).bit_and (1)).to_boolean).to_integer).to_integer_8
							if l_i < -1 then
								l_tmp___8.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_i > a_t.item.x + 1 then
								l_tmp___8.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif a_t.item.y < 0 then
								l_tmp___8.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif a_t.item.y > a_t.item.y then
								l_tmp___8.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								l_tmp___8.ce_gets (l_fh + ((l_i + 1) + (a_t.item.x + 2) * a_t.item.y))
							end
							l_tmp___8[0] := (a_t.item.border * (((a_t.item.frame).bit_and (2)).to_boolean).to_integer).to_integer_8
							l_i := l_i + 1
						end
						l_j := 0
						from
						until
							not (l_j < a_t.item.y)
						loop
							if 0 > a_t.item.x then
								l_tmp___9.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j < -1 then
								l_tmp___9.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j > a_t.item.y + 1 then
								l_tmp___9.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								l_tmp___9.ce_gets (l_fv + (l_j + 1))
							end
							l_tmp___9[0] := (a_t.item.border * (((a_t.item.frame).bit_and (4)).to_boolean).to_integer).to_integer_8
							if a_t.item.x < 0 then
								l_tmp___10.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif a_t.item.x > a_t.item.x then
								l_tmp___10.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j < -1 then
								l_tmp___10.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j > a_t.item.y + 1 then
								l_tmp___10.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								l_tmp___10.ce_gets (l_fv + ((l_j + 1) + (a_t.item.y + 2) * a_t.item.x))
							end
							l_tmp___10[0] := (a_t.item.border * (((a_t.item.frame).bit_and (8)).to_boolean).to_integer).to_integer_8
							l_j := l_j + 1
						end
						l_cy := a_y
						l_j := 0
				when 10 then -- loop condition:
						if not (not js.loop_left and then (l_j <= a_t.item.y)) then
							l_pos := -1 + 71 -- skip loop
						end
				when 11 then -- loop body:
							l_cx := a_x
							if not (l_j > 0) then
								l_pos := -1 + 14 -- skip if block
							end
				when 12 then -- if:
							if l_j < a_t.item.y then
								if (get_hline_width (a_t, l_j)) >= 0 then
									l_pos := -1 + 20 -- goto _L___6
								else
									l_pos := -1 + 14 -- goto _L___12
								end
							else
								l_pos := -1 + 14 -- goto _L___12
							end
				when 13 then -- if block done, skip else block:
							l_pos := -1 + 70
				when 14 then -- else: | _L___12:
							if l_j /= 0 then
								l_pos := -1 + 17 -- skip if block
							end
				when 15 then -- if:
							if (a_t.item.border).to_boolean then
								if ((a_t.item.frame).bit_and (1)).to_boolean then
									l_pos := -1 + 20 -- goto _L___6
								else
									l_pos := -1 + 17 -- goto _L___10
								end
							else
								l_pos := -1 + 17 -- goto _L___10
							end
				when 16 then -- if block done, skip else block:
							l_pos := -1 + 70
				when 17 then -- else: | _L___10:
							if l_j /= a_t.item.y then
								l_pos := -1 + 56 -- skip if block
							end
				when 18 then -- if:
							if not ((a_t.item.border).to_boolean) then
								l_pos := -1 + 54 -- skip if block
							end
				when 19 then -- if:
							if not (((a_t.item.frame).bit_and (2)).to_boolean) then
								l_pos := -1 + 52 -- skip if block
							end
				when 20 then -- if: | _L___6:
							l_i := 0
				when 21 then -- loop condition:
							if not (not js.loop_left and then (l_i < a_t.item.x)) then
								l_pos := -1 + 36 -- skip loop
							end
				when 22 then -- loop body:
							if l_i > 0 then
								l_w := get_vline_width (a_t, l_i)
							elseif (a_t.item.border).to_boolean then
								if ((a_t.item.frame).bit_and (4)).to_boolean then
									l_w := a_t.item.border
								else
									l_w := -1
								end
							else
								l_w := -1
							end
							if not (l_w >= 0) then
								l_pos := -1 + 35 -- skip if block
							end
				when 23 then -- if:
							if l_i - 1 < -1 then
								l_tmp___27.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_i - 1 > a_t.item.x + 1 then
								l_tmp___27.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j < 0 then
								l_tmp___27.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j > a_t.item.y then
								l_tmp___27.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								l_tmp___27.ce_gets (l_fh + (((l_i - 1) + 1) + (a_t.item.x + 2) * l_j))
							end
							if not ((l_tmp___27[0]).to_integer_32 >= 0) then
								l_pos := -1 + 26 -- skip if block
							end
				when 24 then -- if:
							l_pos := -1 + 33 -- goto _L
				when 25 then -- if block done, skip else block:
							l_pos := -1 + 34
				when 26 then -- else:
							if l_i < -1 then
								l_tmp___28.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_i > a_t.item.x + 1 then
								l_tmp___28.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j < 0 then
								l_tmp___28.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j > a_t.item.y then
								l_tmp___28.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								l_tmp___28.ce_gets (l_fh + ((l_i + 1) + (a_t.item.x + 2) * l_j))
							end
							if not ((l_tmp___28[0]).to_integer_32 >= 0) then
								l_pos := -1 + 29 -- skip if block
							end
				when 27 then -- if:
							l_pos := -1 + 33 -- goto _L
				when 28 then -- if block done, skip else block:
							l_pos := -1 + 34
				when 29 then -- else:
							if l_i < 0 then
								l_tmp___29.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_i > a_t.item.x then
								l_tmp___29.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j - 1 < -1 then
								l_tmp___29.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j - 1 > a_t.item.y + 1 then
								l_tmp___29.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								l_tmp___29.ce_gets (l_fv + (((l_j - 1) + 1) + (a_t.item.y + 2) * l_i))
							end
							if not ((l_tmp___29[0]).to_integer_32 >= 0) then
								l_pos := -1 + 32 -- skip if block
							end
				when 30 then -- if:
							l_pos := -1 + 33 -- goto _L
				when 31 then -- if block done, skip else block:
							l_pos := -1 + 34
				when 32 then -- else:
							if l_i < 0 then
								l_tmp___30.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_i > a_t.item.x then
								l_tmp___30.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j < -1 then
								l_tmp___30.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j > a_t.item.y + 1 then
								l_tmp___30.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								l_tmp___30.ce_gets (l_fv + ((l_j + 1) + (a_t.item.y + 2) * l_i))
							end
							if not ((l_tmp___30[0]).to_integer_32 >= 0) then
								l_pos := -1 + 34 -- skip if block
							end
				when 33 then -- if: | _L:
							if l_i < 0 then
								l_tmp___14.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_i > a_t.item.x then
								l_tmp___14.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j - 1 < -1 then
								l_tmp___14.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j - 1 > a_t.item.y + 1 then
								l_tmp___14.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								l_tmp___14.ce_gets (l_fv + (((l_j - 1) + 1) + (a_t.item.y + 2) * l_i))
							end
							if (l_tmp___14[0]).to_integer_32 = -1 then
								l_tmp___13 := 0
							else
								if l_i < 0 then
									l_tmp___12.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_i > a_t.item.x then
									l_tmp___12.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_j - 1 < -1 then
									l_tmp___12.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_j - 1 > a_t.item.y + 1 then
									l_tmp___12.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								else
									l_tmp___12.ce_gets (l_fv + (((l_j - 1) + 1) + (a_t.item.y + 2) * l_i))
								end
								l_tmp___13 := (l_tmp___12[0]).to_integer_32
							end
							if l_i < -1 then
								l_tmp___18.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_i > a_t.item.x + 1 then
								l_tmp___18.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j < 0 then
								l_tmp___18.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j > a_t.item.y then
								l_tmp___18.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								l_tmp___18.ce_gets (l_fh + ((l_i + 1) + (a_t.item.x + 2) * l_j))
							end
							if (l_tmp___18[0]).to_integer_32 = -1 then
								l_tmp___17 := 0
							else
								if l_i < -1 then
									l_tmp___16.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_i > a_t.item.x + 1 then
									l_tmp___16.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_j < 0 then
									l_tmp___16.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_j > a_t.item.y then
									l_tmp___16.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								else
									l_tmp___16.ce_gets (l_fh + ((l_i + 1) + (a_t.item.x + 2) * l_j))
								end
								l_tmp___17 := (l_tmp___16[0]).to_integer_32
							end
							if l_i - 1 < -1 then
								l_tmp___22.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_i - 1 > a_t.item.x + 1 then
								l_tmp___22.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j < 0 then
								l_tmp___22.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j > a_t.item.y then
								l_tmp___22.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								l_tmp___22.ce_gets (l_fh + (((l_i - 1) + 1) + (a_t.item.x + 2) * l_j))
							end
							if (l_tmp___22[0]).to_integer_32 = -1 then
								l_tmp___21 := 0
							else
								if l_i - 1 < -1 then
									l_tmp___20.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_i - 1 > a_t.item.x + 1 then
									l_tmp___20.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_j < 0 then
									l_tmp___20.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_j > a_t.item.y then
									l_tmp___20.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								else
									l_tmp___20.ce_gets (l_fh + (((l_i - 1) + 1) + (a_t.item.x + 2) * l_j))
								end
								l_tmp___21 := (l_tmp___20[0]).to_integer_32
							end
							if l_i < 0 then
								l_tmp___26.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_i > a_t.item.x then
								l_tmp___26.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j < -1 then
								l_tmp___26.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j > a_t.item.y + 1 then
								l_tmp___26.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								l_tmp___26.ce_gets (l_fv + ((l_j + 1) + (a_t.item.y + 2) * l_i))
							end
							if (l_tmp___26[0]).to_integer_32 = -1 then
								l_tmp___25 := 0
							else
								if l_i < 0 then
									l_tmp___24.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_i > a_t.item.x then
									l_tmp___24.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_j < -1 then
									l_tmp___24.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_j > a_t.item.y + 1 then
									l_tmp___24.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								else
									l_tmp___24.ce_gets (l_fv + ((l_j + 1) + (a_t.item.y + 2) * l_i))
								end
								l_tmp___25 := (l_tmp___24[0]).to_integer_32
							end
							html_r_inst.xset_hchar (a_t.item.p, l_cx, l_cy, (((frame_table[((l_tmp___13 + 3 * l_tmp___17) + 9 * l_tmp___21) + 27 * l_tmp___25]).to_integer_32).bit_or (32768)).to_natural_32)
				when 34 then -- if done | if done | if done
							if l_j < a_t.item.y then
								if l_i < 0 then
									l_tmp___35.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_i > a_t.item.x then
									l_tmp___35.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_j < -1 then
									l_tmp___35.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_j > a_t.item.y + 1 then
									l_tmp___35.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								else
									l_tmp___35.ce_gets (l_fv + ((l_j + 1) + (a_t.item.y + 2) * l_i))
								end
								if (l_tmp___35[0]).to_integer_32 >= 0 then
									l_qq := 0
									from
									until
										not (l_qq < a_t.item.r_heights[l_j])
									loop
										if l_i < 0 then
											l_tmp___34.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
										elseif l_i > a_t.item.x then
											l_tmp___34.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
										elseif l_j < -1 then
											l_tmp___34.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
										elseif l_j > a_t.item.y + 1 then
											l_tmp___34.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
										else
											l_tmp___34.ce_gets (l_fv + ((l_j + 1) + (a_t.item.y + 2) * l_i))
										end
										if (l_tmp___34[0]).to_integer_32 = -1 then
											l_tmp___33 := 0
										else
											if l_i < 0 then
												l_tmp___32.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											elseif l_i > a_t.item.x then
												l_tmp___32.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											elseif l_j < -1 then
												l_tmp___32.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											elseif l_j > a_t.item.y + 1 then
												l_tmp___32.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											else
												l_tmp___32.ce_gets (l_fv + ((l_j + 1) + (a_t.item.y + 2) * l_i))
											end
											l_tmp___33 := (l_tmp___32[0]).to_integer_32
										end
										html_r_inst.xset_hchar (a_t.item.p, l_cx, (l_cy + 1) + l_qq, (((vline_table[l_tmp___33]).to_integer_32).bit_or (32768)).to_natural_32)
										l_qq := l_qq + 1
									end
								end
							end
							l_cx := l_cx + 1
				when 35 then -- if done
							l_w := a_t.item.w_c[l_i]
							if l_i < -1 then
								l_tmp___40.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_i > a_t.item.x + 1 then
								l_tmp___40.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j < 0 then
								l_tmp___40.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j > a_t.item.y then
								l_tmp___40.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								l_tmp___40.ce_gets (l_fh + ((l_i + 1) + (a_t.item.x + 2) * l_j))
							end
							if (l_tmp___40[0]).to_integer_32 >= 0 then
								if l_i < -1 then
									l_tmp___39.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_i > a_t.item.x + 1 then
									l_tmp___39.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_j < 0 then
									l_tmp___39.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_j > a_t.item.y then
									l_tmp___39.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								else
									l_tmp___39.ce_gets (l_fh + ((l_i + 1) + (a_t.item.x + 2) * l_j))
								end
								if (l_tmp___39[0]).to_integer_32 = -1 then
									l_tmp___38 := 0
								else
									if l_i < -1 then
										l_tmp___37.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
									elseif l_i > a_t.item.x + 1 then
										l_tmp___37.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
									elseif l_j < 0 then
										l_tmp___37.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
									elseif l_j > a_t.item.y then
										l_tmp___37.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
									else
										l_tmp___37.ce_gets (l_fh + ((l_i + 1) + (a_t.item.x + 2) * l_j))
									end
									l_tmp___38 := (l_tmp___37[0]).to_integer_32
								end
								html_r_inst.xset_hchars (a_t.item.p, l_cx, l_cy, l_w, (((hline_table[l_tmp___38]).to_integer_32).bit_or (32768)).to_natural_32)
							end
							l_cx := l_cx + l_w
							l_i := l_i + 1
							l_pos := -1 + 21 -- back to loop condition
				when 36 then -- loop done
							if not ((a_t.item.border).to_boolean) then
								l_pos := -1 + 50 -- skip if block
							end
				when 37 then -- if:
							if not (((a_t.item.frame).bit_and (8)).to_boolean) then
								l_pos := -1 + 50 -- skip if block
							end
				when 38 then -- if:
							if l_i - 1 < -1 then
								l_tmp___57.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_i - 1 > a_t.item.x + 1 then
								l_tmp___57.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j < 0 then
								l_tmp___57.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j > a_t.item.y then
								l_tmp___57.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								l_tmp___57.ce_gets (l_fh + (((l_i - 1) + 1) + (a_t.item.x + 2) * l_j))
							end
							if not ((l_tmp___57[0]).to_integer_32 >= 0) then
								l_pos := -1 + 41 -- skip if block
							end
				when 39 then -- if:
							l_pos := -1 + 48 -- goto _L___0
				when 40 then -- if block done, skip else block:
							l_pos := -1 + 49
				when 41 then -- else:
							if l_i < -1 then
								l_tmp___58.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_i > a_t.item.x + 1 then
								l_tmp___58.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j < 0 then
								l_tmp___58.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j > a_t.item.y then
								l_tmp___58.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								l_tmp___58.ce_gets (l_fh + ((l_i + 1) + (a_t.item.x + 2) * l_j))
							end
							if not ((l_tmp___58[0]).to_integer_32 >= 0) then
								l_pos := -1 + 44 -- skip if block
							end
				when 42 then -- if:
							l_pos := -1 + 48 -- goto _L___0
				when 43 then -- if block done, skip else block:
							l_pos := -1 + 49
				when 44 then -- else:
							if l_i < 0 then
								l_tmp___59.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_i > a_t.item.x then
								l_tmp___59.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j - 1 < -1 then
								l_tmp___59.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j - 1 > a_t.item.y + 1 then
								l_tmp___59.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								l_tmp___59.ce_gets (l_fv + (((l_j - 1) + 1) + (a_t.item.y + 2) * l_i))
							end
							if not ((l_tmp___59[0]).to_integer_32 >= 0) then
								l_pos := -1 + 47 -- skip if block
							end
				when 45 then -- if:
							l_pos := -1 + 48 -- goto _L___0
				when 46 then -- if block done, skip else block:
							l_pos := -1 + 49
				when 47 then -- else:
							if l_i < 0 then
								l_tmp___60.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_i > a_t.item.x then
								l_tmp___60.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j < -1 then
								l_tmp___60.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j > a_t.item.y + 1 then
								l_tmp___60.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								l_tmp___60.ce_gets (l_fv + ((l_j + 1) + (a_t.item.y + 2) * l_i))
							end
							if not ((l_tmp___60[0]).to_integer_32 >= 0) then
								l_pos := -1 + 49 -- skip if block
							end
				when 48 then -- if: | _L___0:
							if l_i < 0 then
								l_tmp___44.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_i > a_t.item.x then
								l_tmp___44.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j - 1 < -1 then
								l_tmp___44.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j - 1 > a_t.item.y + 1 then
								l_tmp___44.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								l_tmp___44.ce_gets (l_fv + (((l_j - 1) + 1) + (a_t.item.y + 2) * l_i))
							end
							if (l_tmp___44[0]).to_integer_32 = -1 then
								l_tmp___43 := 0
							else
								if l_i < 0 then
									l_tmp___42.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_i > a_t.item.x then
									l_tmp___42.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_j - 1 < -1 then
									l_tmp___42.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_j - 1 > a_t.item.y + 1 then
									l_tmp___42.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								else
									l_tmp___42.ce_gets (l_fv + (((l_j - 1) + 1) + (a_t.item.y + 2) * l_i))
								end
								l_tmp___43 := (l_tmp___42[0]).to_integer_32
							end
							if l_i < -1 then
								l_tmp___48.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_i > a_t.item.x + 1 then
								l_tmp___48.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j < 0 then
								l_tmp___48.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j > a_t.item.y then
								l_tmp___48.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								l_tmp___48.ce_gets (l_fh + ((l_i + 1) + (a_t.item.x + 2) * l_j))
							end
							if (l_tmp___48[0]).to_integer_32 = -1 then
								l_tmp___47 := 0
							else
								if l_i < -1 then
									l_tmp___46.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_i > a_t.item.x + 1 then
									l_tmp___46.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_j < 0 then
									l_tmp___46.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_j > a_t.item.y then
									l_tmp___46.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								else
									l_tmp___46.ce_gets (l_fh + ((l_i + 1) + (a_t.item.x + 2) * l_j))
								end
								l_tmp___47 := (l_tmp___46[0]).to_integer_32
							end
							if l_i - 1 < -1 then
								l_tmp___52.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_i - 1 > a_t.item.x + 1 then
								l_tmp___52.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j < 0 then
								l_tmp___52.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j > a_t.item.y then
								l_tmp___52.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								l_tmp___52.ce_gets (l_fh + (((l_i - 1) + 1) + (a_t.item.x + 2) * l_j))
							end
							if (l_tmp___52[0]).to_integer_32 = -1 then
								l_tmp___51 := 0
							else
								if l_i - 1 < -1 then
									l_tmp___50.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_i - 1 > a_t.item.x + 1 then
									l_tmp___50.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_j < 0 then
									l_tmp___50.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_j > a_t.item.y then
									l_tmp___50.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								else
									l_tmp___50.ce_gets (l_fh + (((l_i - 1) + 1) + (a_t.item.x + 2) * l_j))
								end
								l_tmp___51 := (l_tmp___50[0]).to_integer_32
							end
							if l_i < 0 then
								l_tmp___56.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_i > a_t.item.x then
								l_tmp___56.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j < -1 then
								l_tmp___56.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j > a_t.item.y + 1 then
								l_tmp___56.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								l_tmp___56.ce_gets (l_fv + ((l_j + 1) + (a_t.item.y + 2) * l_i))
							end
							if (l_tmp___56[0]).to_integer_32 = -1 then
								l_tmp___55 := 0
							else
								if l_i < 0 then
									l_tmp___54.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_i > a_t.item.x then
									l_tmp___54.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_j < -1 then
									l_tmp___54.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_j > a_t.item.y + 1 then
									l_tmp___54.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								else
									l_tmp___54.ce_gets (l_fv + ((l_j + 1) + (a_t.item.y + 2) * l_i))
								end
								l_tmp___55 := (l_tmp___54[0]).to_integer_32
							end
							html_r_inst.xset_hchar (a_t.item.p, l_cx, l_cy, (((frame_table[((l_tmp___43 + 3 * l_tmp___47) + 9 * l_tmp___51) + 27 * l_tmp___55]).to_integer_32).bit_or (32768)).to_natural_32)
				when 49 then -- if done | if done | if done
							if l_j < a_t.item.y then
								if l_i < 0 then
									l_tmp___65.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_i > a_t.item.x then
									l_tmp___65.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_j < -1 then
									l_tmp___65.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								elseif l_j > a_t.item.y + 1 then
									l_tmp___65.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								else
									l_tmp___65.ce_gets (l_fv + ((l_j + 1) + (a_t.item.y + 2) * l_i))
								end
								if (l_tmp___65[0]).to_integer_32 >= 0 then
									l_qq___0 := 0
									from
									until
										not (l_qq___0 < a_t.item.r_heights[l_j])
									loop
										if l_i < 0 then
											l_tmp___64.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
										elseif l_i > a_t.item.x then
											l_tmp___64.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
										elseif l_j < -1 then
											l_tmp___64.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
										elseif l_j > a_t.item.y + 1 then
											l_tmp___64.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
										else
											l_tmp___64.ce_gets (l_fv + ((l_j + 1) + (a_t.item.y + 2) * l_i))
										end
										if (l_tmp___64[0]).to_integer_32 = -1 then
											l_tmp___63 := 0
										else
											if l_i < 0 then
												l_tmp___62.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											elseif l_i > a_t.item.x then
												l_tmp___62.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											elseif l_j < -1 then
												l_tmp___62.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											elseif l_j > a_t.item.y + 1 then
												l_tmp___62.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
											else
												l_tmp___62.ce_gets (l_fv + ((l_j + 1) + (a_t.item.y + 2) * l_i))
											end
											l_tmp___63 := (l_tmp___62[0]).to_integer_32
										end
										html_r_inst.xset_hchar (a_t.item.p, l_cx, (l_cy + 1) + l_qq___0, (((vline_table[l_tmp___63]).to_integer_32).bit_or (32768)).to_natural_32)
										l_qq___0 := l_qq___0 + 1
									end
								end
							end
							l_cx := l_cx + 1
				when 50 then -- if done | if done
							l_cy := l_cy + 1
				when 51 then -- if block done, skip else block:
							l_pos := -1 + 53
				when 52 then -- else:
							l_pos := -1 + 56 -- goto _L___8
				when 53 then -- if done | if block done, skip else block:
							l_pos := -1 + 55
				when 54 then -- else:
							l_pos := -1 + 56 -- goto _L___8
				when 55 then -- if done | if block done, skip else block:
							l_pos := -1 + 70
				when 56 then -- else: | _L___8:
							if not (l_j < a_t.item.y) then
								l_pos := -1 + 70 -- skip if block
							end
				when 57 then -- if:
							l_i := 0
				when 58 then -- loop condition:
							if not (not js.loop_left and then (l_i <= a_t.item.x)) then
								l_pos := -1 + 70 -- skip loop
							end
				when 59 then -- loop body:
							if not (l_i > 0) then
								l_pos := -1 + 62 -- skip if block
							end
				when 60 then -- if:
							if l_i < a_t.item.x then
								if (get_vline_width (a_t, l_i)) >= 0 then
									l_pos := -1 + 68 -- goto _L___1
								else
									l_pos := -1 + 62 -- goto _L___5
								end
							else
								l_pos := -1 + 62 -- goto _L___5
							end
				when 61 then -- if block done, skip else block:
							l_pos := -1 + 69
				when 62 then -- else: | _L___5:
							if l_i /= 0 then
								l_pos := -1 + 65 -- skip if block
							end
				when 63 then -- if:
							if (a_t.item.border).to_boolean then
								if ((a_t.item.frame).bit_and (4)).to_boolean then
									l_pos := -1 + 68 -- goto _L___1
								else
									l_pos := -1 + 65 -- goto _L___3
								end
							else
								l_pos := -1 + 65 -- goto _L___3
							end
				when 64 then -- if block done, skip else block:
							l_pos := -1 + 69
				when 65 then -- else: | _L___3:
							if l_i /= a_t.item.x then
								l_pos := -1 + 69 -- skip if block
							end
				when 66 then -- if:
							if not ((a_t.item.border).to_boolean) then
								l_pos := -1 + 69 -- skip if block
							end
				when 67 then -- if:
							if not (((a_t.item.frame).bit_and (8)).to_boolean) then
								l_pos := -1 + 69 -- skip if block
							end
				when 68 then -- if: | _L___1:
							if l_i < 0 then
								l_tmp___70.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_i > a_t.item.x then
								l_tmp___70.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j < -1 then
								l_tmp___70.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							elseif l_j > a_t.item.y + 1 then
								l_tmp___70.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							else
								l_tmp___70.ce_gets (l_fv + ((l_j + 1) + (a_t.item.y + 2) * l_i))
							end
							if (l_tmp___70[0]).to_integer_32 >= 0 then
								l_qq___1 := 0
								from
								until
									not (l_qq___1 < a_t.item.r_heights[l_j])
								loop
									if l_i < 0 then
										l_tmp___69.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
									elseif l_i > a_t.item.x then
										l_tmp___69.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
									elseif l_j < -1 then
										l_tmp___69.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
									elseif l_j > a_t.item.y + 1 then
										l_tmp___69.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
									else
										l_tmp___69.ce_gets (l_fv + ((l_j + 1) + (a_t.item.y + 2) * l_i))
									end
									if (l_tmp___69[0]).to_integer_32 = -1 then
										l_tmp___68 := 0
									else
										if l_i < 0 then
											l_tmp___67.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
										elseif l_i > a_t.item.x then
											l_tmp___67.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
										elseif l_j < -1 then
											l_tmp___67.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
										elseif l_j > a_t.item.y + 1 then
											l_tmp___67.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
										else
											l_tmp___67.ce_gets (l_fv + ((l_j + 1) + (a_t.item.y + 2) * l_i))
										end
										l_tmp___68 := (l_tmp___67[0]).to_integer_32
									end
									html_r_inst.xset_hchar (a_t.item.p, l_cx, l_cy + l_qq___1, (((vline_table[l_tmp___68]).to_integer_32).bit_or (32768)).to_natural_32)
									l_qq___1 := l_qq___1 + 1
								end
							end
							l_cx := l_cx + 1
				when 69 then -- if done | if done | if done | if done
							if l_i < a_t.item.x then
								l_cx := l_cx + (a_t.item.w_c[l_i])
							end
							l_i := l_i + 1
							l_pos := -1 + 58 -- back to loop condition
				when 70 then -- loop done | if done | if done | if done
							if l_j < a_t.item.y then
								l_cy := l_cy + (a_t.item.r_heights[l_j])
							end
							l_j := l_j + 1
							l_pos := -1 + 10 -- back to loop condition
				when 71 then -- loop done
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 1081, create {CE_POINTER [ANY]}.make_cast (l_fh))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 1082, create {CE_POINTER [ANY]}.make_cast (l_fv))
				when 72 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	format_table (a_attr: CE_POINTER [NATURAL_8]; a_html: CE_POINTER [NATURAL_8]; a_eof: CE_POINTER [NATURAL_8]; a_end: CE_POINTER [CE_POINTER [NATURAL_8]]; a_f: CE_POINTER [ANY])
		local
			l_p: CE_POINTER [PD_PART]
			l_border: INTEGER_32
			l_cellsp: INTEGER_32
			l_vcellpd: INTEGER_32
			l_cellpd: INTEGER_32
			l_align: INTEGER_32
			l_frame: INTEGER_32
			l_rules: INTEGER_32
			l_width: INTEGER_32
			l_wf: INTEGER_32
			l_bgcolor: PD_RGB
			l_t: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]
			l_al: CE_POINTER [INTEGER_8]
			l_cye: INTEGER_32
			l_x: INTEGER_32
			l_i: INTEGER_32
			l_bad_html: CE_POINTER [PD_S_E]
			l_bad_html_n: INTEGER_32
			l_n: CE_POINTER [PD_NODE]
			l_nn: CE_POINTER [PD_NODE]
			l_cpd_pass: INTEGER_32
			l_cpd_width: INTEGER_32
			l_cpd_last: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___23: INTEGER_32
			l_tmp___24: INTEGER_32
			l_ww: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p.make
			create l_bgcolor.make
			create l_t.make
			create l_al.make
			create l_bad_html.make
			create l_n.make
			create l_nn.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p.ce_gets (create {CE_POINTER [PD_PART]}.make_cast (a_f))
					links_inst.table_level := links_inst.table_level + 1
					memcpy (create {CE_POINTER [ANY]}.make_cast ((l_bgcolor.address)), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_RGB]}.make_shared ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).c_pointer + {PD_HTML_ELEMENT}.parattr_offset + {PD_PAR_ATTRIB}.bgcolor_offset))), {PD_RGB}.sizeof.to_natural_32).do_nothing
					html_inst.get_bgcolor (a_attr, l_bgcolor.address).do_nothing
					l_border := html_inst.get_num (a_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("border")))
					if l_border = -1 then
						if (html_inst.has_attr (a_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("border")))).to_boolean then
							l_tmp___2 := 1
						elseif (html_inst.has_attr (a_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("rules")))).to_boolean then
							l_tmp___2 := 1
						elseif (html_inst.has_attr (a_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("frame")))).to_boolean then
							l_tmp___2 := 1
						else
							l_tmp___2 := 0
						end
						l_border := l_tmp___2
					end
					l_cellsp := html_inst.get_num (a_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cellspacing")))
					if l_cellsp = -1 then
						l_cellsp := 1
					end
					l_cellpd := html_inst.get_num (a_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cellpadding")))
					if l_cellpd = -1 then
						l_vcellpd := 0
						l_cellpd := (l_border.to_boolean).to_integer
					else
						l_vcellpd := (l_cellpd >= 7).to_integer
						l_cellpd := (l_cellpd >= 4).to_integer
					end
					if not l_border.to_boolean then
						l_cellsp := 0
					elseif not l_cellsp.to_boolean then
						l_cellsp := 1
					end
					if l_border > 2 then
						l_border := 2
					end
					if l_cellsp > 2 then
						l_cellsp := 2
					end
					l_align := (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.align
					if l_align = 4 then
						l_align := 0
					elseif l_align = 3 then
						l_align := 0
					end
					l_al.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((html_inst.get_attr_val (a_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("align"))))))
					if ((l_al).c_pointer /= default_pointer) then
						if not (strcasecmp (l_al, ce_string ("left"))).to_boolean then
							l_align := 0
						end
						if not (strcasecmp (l_al, ce_string ("center"))).to_boolean then
							l_align := 1
						end
						if not (strcasecmp (l_al, ce_string ("right"))).to_boolean then
							l_align := 2
						end
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 1129, create {CE_POINTER [ANY]}.make_cast (l_al))
					end
					l_frame := 15
					l_al.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((html_inst.get_attr_val (a_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("frame"))))))
					if ((l_al).c_pointer /= default_pointer) then
						if not (strcasecmp (l_al, ce_string ("void"))).to_boolean then
							l_frame := 0
						end
						if not (strcasecmp (l_al, ce_string ("above"))).to_boolean then
							l_frame := 1
						end
						if not (strcasecmp (l_al, ce_string ("below"))).to_boolean then
							l_frame := 2
						end
						if not (strcasecmp (l_al, ce_string ("hsides"))).to_boolean then
							l_frame := 3
						end
						if not (strcasecmp (l_al, ce_string ("vsides"))).to_boolean then
							l_frame := 12
						end
						if not (strcasecmp (l_al, ce_string ("lhs"))).to_boolean then
							l_frame := 4
						end
						if not (strcasecmp (l_al, ce_string ("rhs"))).to_boolean then
							l_frame := 8
						end
						if not (strcasecmp (l_al, ce_string ("box"))).to_boolean then
							l_frame := 15
						end
						if not (strcasecmp (l_al, ce_string ("border"))).to_boolean then
							l_frame := 15
						end
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 1142, create {CE_POINTER [ANY]}.make_cast (l_al))
					end
					if l_border.to_boolean then
						l_rules := 3
					else
						l_rules := 0
					end
					l_al.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((html_inst.get_attr_val (a_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("rules"))))))
					if ((l_al).c_pointer /= default_pointer) then
						if not (strcasecmp (l_al, ce_string ("none"))).to_boolean then
							l_rules := 0
						end
						if not (strcasecmp (l_al, ce_string ("groups"))).to_boolean then
							l_rules := 4
						end
						if not (strcasecmp (l_al, ce_string ("rows"))).to_boolean then
							l_rules := 1
						end
						if not (strcasecmp (l_al, ce_string ("cols"))).to_boolean then
							l_rules := 2
						end
						if not (strcasecmp (l_al, ce_string ("all"))).to_boolean then
							l_rules := 3
						end
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 1151, create {CE_POINTER [ANY]}.make_cast (l_al))
					end
					if not l_border.to_boolean then
						l_frame := 0
					end
					l_wf := 0
					if ((l_p.item.data).c_pointer /= default_pointer) then
						l_tmp___23 := 1
					elseif (l_p.item.xp).to_boolean then
						l_tmp___23 := 1
					else
						l_tmp___23 := 0
					end
					l_width := html_inst.get_width (a_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("width")), l_tmp___23)
					if l_width = -1 then
						l_width := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.width - (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.leftmargin) - (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.rightmargin
						if l_width < 0 then
							l_width := 0
						end
						l_wf := 1
					end
					if ((l_p.item.data).c_pointer /= default_pointer) then
						l_tmp___24 := 1
					elseif (l_p.item.xp).to_boolean then
						l_tmp___24 := 1
					else
						l_tmp___24 := 0
					end
					l_t.ce_gets (parse_table (a_html, a_eof, a_end, l_bgcolor.address, l_tmp___24, l_bad_html.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_bad_html_n)))
					if (l_t).c_pointer = default_pointer then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 1161, create {CE_POINTER [ANY]}.make_cast (l_bad_html))
						l_pos := -1 + 10 -- goto ret0
					end
				when 1 then
					l_i := 0
					from
					until
						not (not js.loop_left and then (l_i < l_bad_html_n))
					loop
						from
						until
							js.loop_left
						loop
							js.reset
							if (((l_bad_html + l_i).item.s).c_pointer.to_integer_32).to_natural_32 < (((l_bad_html + l_i).item.e).c_pointer.to_integer_32).to_natural_32 then
								if (((l_bad_html + l_i).item.s).item).to_integer_32 /= 9 then
									if (((l_bad_html + l_i).item.s).item).to_integer_32 /= 10 then
										if (((l_bad_html + l_i).item.s).item).to_integer_32 /= 12 then
											if (((l_bad_html + l_i).item.s).item).to_integer_32 /= 13 then
												if (((l_bad_html + l_i).item.s).item).to_integer_32 /= 32 then
													js.break
												end
											end
										end
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								(l_bad_html + l_i).item.s := ((l_bad_html + l_i).item.s) + 1
							end
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							if (((l_bad_html + l_i).item.s).c_pointer.to_integer_32).to_natural_32 < (((l_bad_html + l_i).item.e).c_pointer.to_integer_32).to_natural_32 then
								if ((l_bad_html + l_i).item.e[-1]).to_integer_32 /= 9 then
									if ((l_bad_html + l_i).item.e[-1]).to_integer_32 /= 10 then
										if ((l_bad_html + l_i).item.e[-1]).to_integer_32 /= 12 then
											if ((l_bad_html + l_i).item.e[-1]).to_integer_32 /= 13 then
												if ((l_bad_html + l_i).item.e[-1]).to_integer_32 /= 32 then
													js.break
												end
											end
										end
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								(l_bad_html + l_i).item.e := ((l_bad_html + l_i).item.e) - 1
							end
						end
						js.reset
						if (((l_bad_html + l_i).item.s).c_pointer.to_integer_32).to_natural_32 < (((l_bad_html + l_i).item.e).c_pointer.to_integer_32).to_natural_32 then
							html_inst.parse_html ((l_bad_html + l_i).item.s, (l_bad_html + l_i).item.e, links_inst.put_chars_f, links_inst.line_break_f, links_inst.special_f, create {CE_POINTER [ANY]}.make_cast (l_p), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						end
						l_i := l_i + 1
					end
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 1169, create {CE_POINTER [ANY]}.make_cast (l_bad_html))
					html_inst.html_stack_dup;
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.dontkill := 1;
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.align := 0
					l_t.item.p := l_p
					l_t.item.border := l_border
					l_t.item.cellpd := l_cellpd
					l_t.item.vcellpd := l_vcellpd
					l_t.item.cellsp := l_cellsp
					l_t.item.frame := l_frame
					l_t.item.rules := l_rules
					l_t.item.width := l_width
					l_t.item.wf := l_wf
					l_cpd_pass := 0
					l_cpd_last := l_t.item.cellpd
					l_cpd_width := 0
				when 2 then -- again:
					get_cell_widths (l_t)
					if (get_column_widths (l_t)).to_boolean then
						l_pos := -1 + 9 -- goto ret2
					end
				when 3 then
					get_table_width (l_t)
					if (l_p.item.data).c_pointer = default_pointer then
						if not (l_p.item.xp).to_boolean then
							if not l_wf.to_boolean then
								if l_t.item.max_t > l_width then
									l_t.item.max_t := l_width
								end
							end
							if l_t.item.max_t < l_t.item.min_t then
								l_t.item.max_t := l_t.item.min_t
							end
							if (l_t.item.max_t + (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.leftmargin) + (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.rightmargin > l_p.item.xmax then
								l_p.item.xmax := (l_t.item.max_t + (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.leftmargin) + (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.rightmargin
							end
							if (l_t.item.min_t + (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.leftmargin) + (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.rightmargin > l_p.item.x then
								l_p.item.x := (l_t.item.min_t + (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.leftmargin) + (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.rightmargin
							end
							l_pos := -1 + 9 -- goto ret2
						end
					end
				when 4 then
					if not l_cpd_pass.to_boolean then
						if l_t.item.min_t > l_width then
							if (l_t.item.cellpd).to_boolean then
								l_t.item.cellpd := 0
								l_cpd_pass := 1
								l_cpd_width := l_t.item.min_t
								l_pos := -1 + 2 -- goto again
							end
						end
					end
				when 5 then
					if l_cpd_pass = 1 then
						if l_t.item.min_t > l_cpd_width then
							l_t.item.cellpd := l_cpd_last
							l_cpd_pass := 2
							l_pos := -1 + 2 -- goto again
						end
					end
				when 6 then
					if l_t.item.min_t >= l_width then
						distribute_widths (l_t, l_t.item.min_t)
					elseif l_t.item.max_t < l_width then
						if l_wf.to_boolean then
							distribute_widths (l_t, l_t.item.max_t)
						else
							distribute_widths (l_t, l_width)
						end
					else
						distribute_widths (l_t, l_width)
					end
					if (l_p.item.data).c_pointer = default_pointer then
						if l_p.item.xp = 1 then
							l_ww := (l_t.item.rw + (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.leftmargin) + (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.rightmargin
							if l_ww > (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.width then
								l_ww := (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.width
							end
							if l_ww < l_t.item.rw then
								l_ww := l_t.item.rw
							end
							if l_ww > l_p.item.x then
								l_p.item.x := l_ww
							end
							l_p.item.cy := l_p.item.cy + (l_t.item.rh)
							l_pos := -1 + 9 -- goto ret2
						end
					end
				when 7 then
					check_table_widths (l_t)
					l_x := (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.leftmargin
					if l_align = 1 then
						l_x := ((((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.width + (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.leftmargin) - (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.rightmargin) - l_t.item.rw) // 2
					end
					if l_align = 2 then
						l_x := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.width - (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.rightmargin) - l_t.item.rw
					end
					if l_x + l_t.item.rw > (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.width then
						l_x := (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.width - l_t.item.rw
					end
					if l_x < 0 then
						l_x := 0
					end
					get_table_heights (l_t)
					if (l_p.item.data).c_pointer = default_pointer then
						if (l_t.item.rw + (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.leftmargin) + (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.rightmargin > l_p.item.x then
							l_p.item.x := (l_t.item.rw + (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.leftmargin) + (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next)).item.parattr.rightmargin
						end
						l_p.item.cy := l_p.item.cy + (l_t.item.rh)
						l_pos := -1 + 9 -- goto ret2
					end
				when 8 then
					l_n.ce_gets (create {CE_POINTER [PD_NODE]}.make_cast ((l_p.item.data).item.nodes.next))
					l_n.item.yw := (l_p.item.yp - l_n.item.y) + l_p.item.cy
					display_complicated_table (l_t, l_x, l_p.item.cy, create {CE_POINTER [INTEGER_32]}.make_shared ($l_cye))
					display_table_frames (l_t, l_x, l_p.item.cy)
					l_nn.ce_gets (create {CE_POINTER [PD_NODE]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tbl.c")), 1238, {PD_NODE}.sizeof.to_natural_32))))
					l_nn.item.x := l_n.item.x
					l_nn.item.y := l_p.item.yp + l_cye
					l_nn.item.xw := l_n.item.xw
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((l_p.item.data).c_pointer + {PD_F_DATA}.nodes_offset))))
						l_nn.item.next := (create {CE_POINTER [PD_NODE]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((l_p.item.data).c_pointer + {PD_F_DATA}.nodes_offset)))).item.next
						l_nn.item.prev := create {CE_POINTER [PD_NODE]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((l_p.item.data).c_pointer + {PD_F_DATA}.nodes_offset)));
						(create {CE_POINTER [PD_NODE]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((l_p.item.data).c_pointer + {PD_F_DATA}.nodes_offset)))).item.next := l_nn;
						(l_nn.item.next).item.prev := l_nn
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((l_p.item.data).c_pointer + {PD_F_DATA}.nodes_offset))))
						js.break
					end
					js.reset
					l_p.item.cy := l_cye
					l_p.item.cx := -1
				when 9 then -- ret2:
					l_p.item.link_num := l_t.item.link_num
					if l_p.item.cy > l_p.item.y then
						l_p.item.y := l_p.item.cy
					end
					free_table (l_t)
					html_inst.kill_html_stack_item (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_inst.html_stack.next))
				when 10 then -- ret0:
					links_inst.table_level := links_inst.table_level - 1
					if not links_inst.table_level.to_boolean then
						html_r_inst.free_table_cache
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
