class
	P_HTTP

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create buggy_servers.make (<<7>>)
			create accept_charset.make
		end

feature {ANY} -- attributes

	buggy_servers: CE_ARRAY [PD_BUGGY_SERVERS]

	accept_charset: CE_POINTER [NATURAL_8]

feature {ANY} -- routines

	parse_http_header (a_head___0: CE_POINTER [NATURAL_8]; a_item: CE_POINTER [NATURAL_8]; a_ptr: CE_POINTER [CE_POINTER [NATURAL_8]]): CE_POINTER [NATURAL_8]
		local
			l_i: CE_POINTER [NATURAL_8]
			l_f: CE_POINTER [NATURAL_8]
			l_g: CE_POINTER [NATURAL_8]
			l_h: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_8
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_i.make
			create l_f.make
			create l_g.make
			create l_h.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_head___0).c_pointer = default_pointer then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						l_h.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						l_f.ce_gets (a_head___0)
				when 2 then -- loop condition:
						if not (not js.loop_left and then ((l_f.item).to_boolean)) then
							l_pos := -1 + 14 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if (l_f.item).to_integer_32 /= 10 then
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 11 -- skip if block
						end
				when 4 then -- if:
						l_f.ce_gets (l_f + 1)
						l_i.ce_gets (a_item)
				when 5 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 10 -- skip loop
						end
				when 6 then -- loop body:
						js.reset
						if (l_i.item).to_boolean then
							if not (l_f.item).to_boolean then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_tmp := links_inst.upcase (l_i.item)
						if l_tmp.to_integer_32 /= (links_inst.upcase (l_f.item)).to_integer_32 then
							l_pos := -1 + 12 -- goto cont
						end
				when 8 then
						l_i.ce_gets (l_i + 1)
						l_f.ce_gets (l_f + 1)
				when 9 then -- if done
						l_pos := -1 + 5 -- back to loop condition
				when 10 then -- loop done
						js.reset
						if not (l_f.item).to_boolean then
							js.break
						end
				when 11 then -- if done
						if not js.loop_jumped and then ((l_f[0]).to_integer_32 = 58) then
							from
							until
								(l_f[1]).to_integer_32 /= 32
							loop
								l_f.ce_gets (l_f + 1)
							end
							l_f.ce_gets (l_f + 1)
							l_g.ce_gets (l_f)
							from
							until
								not ((l_g.item).to_integer_32 >= 32)
							loop
								l_g.ce_gets (l_g + 1)
							end
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_g.c_pointer.to_integer_32).to_natural_32 > (l_f.c_pointer.to_integer_32).to_natural_32 then
									if (l_g[-1]).to_integer_32 /= 32 then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_g.ce_gets (l_g - 1)
								end
							end
							js.reset
							if ((l_h).c_pointer /= default_pointer) then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 27, create {CE_POINTER [ANY]}.make_cast (l_h))
							end
							l_h.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 28, ((l_g.distance (l_f)) + 1).to_natural_32))))
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_h), create {CE_POINTER [ANY]}.make_cast (l_f), (l_g.distance (l_f)).to_natural_32).do_nothing
							l_h[(l_g.distance (l_f))] := (0).to_natural_8
							if ((a_ptr).c_pointer /= default_pointer) then
								a_ptr.item := l_f
								js.break
							end
							if not js.loop_jumped then
								Result := l_h
								js.return
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | cont:
						l_f.ce_gets (l_f - 1)
				when 13 then -- if done
						if not js.loop_left then
							l_f.ce_gets (l_f + 1)
						end
						l_pos := -1 + 2 -- back to loop condition
				when 14 then -- loop done
						js.reset
				when 15 then -- if done
					if not js.return_called then
						Result := l_h
					end
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	parse_header_param (a_x: CE_POINTER [NATURAL_8]; a_e: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_u: NATURAL_8
			l_le: NATURAL_32
			l_lp: INTEGER_32
			l_y: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_y.make
			create l_tmp___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_le := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_e)))
					l_y.ce_gets (a_x)
				when 1 then -- a:
					l_y.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_y), (';').code))))
					if (l_y).c_pointer = default_pointer then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_y.item).to_boolean then
								if (l_y.item).to_integer_32 /= 59 then
									if not ((l_y.item).to_integer_32 <= 32) then
										js.break
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_y.ce_gets (l_y + 1)
							end
						end
						js.reset
						if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_y))) < l_le then
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 4 -- skip if block
					end
				when 2 then -- if:
						if (links_inst.casecmp (l_y, a_e, l_le)).to_boolean then
							l_pos := -1 + 1 -- goto a
						end
				when 3 then
						l_y.ce_gets (l_y + l_le.to_integer_32)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_y.item).to_boolean then
								if not ((l_y.item).to_integer_32 <= 32) then
									if (l_y.item).to_integer_32 /= 61 then
										js.break
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_y.ce_gets (l_y + 1)
							end
						end
						js.reset
						l_u := ((';').code).to_natural_8
						if (l_y.item).to_integer_32 = 39 then
							l_tmp___3.ce_gets (l_y)
							l_y.ce_gets (l_y + 1)
							l_u := l_tmp___3.item
						elseif (l_y.item).to_integer_32 = 34 then
							l_tmp___3.ce_gets (l_y)
							l_y.ce_gets (l_y + 1)
							l_u := l_tmp___3.item
						end
						l_lp := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_y[l_lp]).to_integer_32 >= 32 then
								if (l_y[l_lp]).to_integer_32 = l_u.to_integer_32 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_lp := l_lp + 1
								if l_lp = 2147483647 then
									from
									until
										False
									loop
										error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("http.c"), 61])
										kbd_inst.fatal_tty_exit
										exit (4)
									end
								end
							end
						end
						js.reset
						Result := (links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 63, l_y, l_lp))
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_param (a_e: CE_POINTER [NATURAL_8]; a_name: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_e: CE_POINTER [NATURAL_8]
			l_n: CE_POINTER [NATURAL_8]
			l_start: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: NATURAL_8
			l_tmp___2: NATURAL_8
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_uu: INTEGER_8
			l_tmp___5: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_e.make
			create l_n.make
			create l_start.make
			create l_tmp.make
			create l_tmp___4.make
			create l_tmp___5.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_e.ce_gets (a_e)
					l_i := 0
				when 1 then -- again:
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_e.item).to_boolean then
							l_tmp.ce_gets (l_e)
							l_e.ce_gets (l_e + 1)
							l_tmp___0 := links_inst.upcase (l_tmp.item)
							if l_tmp___0.to_integer_32 = (links_inst.upcase (a_name.item)).to_integer_32 then
								js.break
							end
						else
							js.break
						end
					end
					js.reset
					if not (l_e.item).to_boolean then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 4 -- skip if block
					end
				when 2 then -- if:
						l_n.ce_gets (a_name + 1)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_n.item).to_boolean then
								l_tmp___2 := links_inst.upcase (l_e.item)
								if l_tmp___2.to_integer_32 /= (links_inst.upcase (l_n.item)).to_integer_32 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_e.ce_gets (l_e + 1)
								l_n.ce_gets (l_n + 1)
							end
						end
						js.reset
						if (l_n.item).to_boolean then
							l_pos := -1 + 1 -- goto again
						end
				when 3 then
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_e.item).to_integer_32 /= 9 then
								if (l_e.item).to_integer_32 /= 10 then
									if (l_e.item).to_integer_32 /= 12 then
										if (l_e.item).to_integer_32 /= 13 then
											if (l_e.item).to_integer_32 /= 32 then
												js.break
											end
										end
									end
								end
							end
							if not js.loop_jumped then
								l_e.ce_gets (l_e + 1)
							end
						end
						js.reset
						l_tmp___4.ce_gets (l_e)
						l_e.ce_gets (l_e + 1)
						if (l_tmp___4.item).to_integer_32 /= 61 then
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
				when 4 then -- if done
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 5 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_e.item).to_integer_32 /= 9 then
								if (l_e.item).to_integer_32 /= 10 then
									if (l_e.item).to_integer_32 /= 12 then
										if (l_e.item).to_integer_32 /= 13 then
											if (l_e.item).to_integer_32 /= 32 then
												js.break
											end
										end
									end
								end
							end
							if not js.loop_jumped then
								l_e.ce_gets (l_e + 1)
							end
						end
						js.reset
						l_start.ce_gets (l_e)
						if (l_e.item).to_integer_32 /= 34 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 8 then -- else:
						if (l_e.item).to_integer_32 /= 39 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if: | _L:
						l_tmp___5.ce_gets (l_e)
						l_e.ce_gets (l_e + 1)
						l_uu := (l_tmp___5.item).to_integer_8
						l_start.ce_gets (l_start + 1)
						from
						until
							not (not js.loop_left and then ((l_e.item).to_integer_32 /= l_uu.to_integer_32))
						loop
							if not (l_e.item).to_boolean then
								Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								js.return
							end
							if not js.return_called then
								l_e.ce_gets (l_e + 1)
							end
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_e.item).to_boolean then
								if (l_e.item).to_integer_32 = 9 then
									js.break
								elseif (l_e.item).to_integer_32 = 10 then
									js.break
								elseif (l_e.item).to_integer_32 = 12 then
									js.break
								elseif (l_e.item).to_integer_32 = 13 then
									js.break
								elseif (l_e.item).to_integer_32 = 32 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_e.ce_gets (l_e + 1)
							end
						end
						js.reset
				when 12 then -- if done | if done
						if not js.return_called then
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_start.c_pointer.to_integer_32).to_natural_32 < (l_e.c_pointer.to_integer_32).to_natural_32 then
									if (l_start.item).to_integer_32 /= 32 then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_start.ce_gets (l_start + 1)
								end
							end
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_start.c_pointer.to_integer_32).to_natural_32 < (l_e.c_pointer.to_integer_32).to_natural_32 then
									if (l_e[-1]).to_integer_32 /= 32 then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_e.ce_gets (l_e - 1)
								end
							end
							js.reset
							if (l_start.c_pointer.to_integer_32).to_natural_32 = (l_e.c_pointer.to_integer_32).to_natural_32 then
								Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								js.return
							end
						end
						if not js.return_called then
							l_n.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 99, ((l_e.distance (l_start)) + 1).to_natural_32))))
							from
							until
								not ((l_start.c_pointer.to_integer_32).to_natural_32 < (l_e.c_pointer.to_integer_32).to_natural_32)
							loop
								if (l_start.item).to_integer_32 < 32 then
									l_n[l_i] := (('.').code).to_natural_8
								else
									l_n[l_i] := l_start.item
								end
								l_i := l_i + 1
								l_start.ce_gets (l_start + 1)
							end
							l_n[l_i] := (0).to_natural_8
							Result := l_n
						end
				when 13 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	get_http_code (a_head___0: CE_POINTER [NATURAL_8]; a_code: CE_POINTER [INTEGER_32]; a_version: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_head___0: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_head___0.make
			create l_tmp___3.make

			l_head___0.ce_gets (a_head___0)
			from
			until
				(l_head___0[0]).to_integer_32 /= 32
			loop
				l_head___0.ce_gets (l_head___0 + 1)
			end
			if (links_inst.upcase (l_head___0[0])).to_integer_32 /= 72 then
				Result := (-1)
				js.return
			elseif (links_inst.upcase (l_head___0[1])).to_integer_32 /= 84 then
				Result := (-1)
				js.return
			elseif (links_inst.upcase (l_head___0[2])).to_integer_32 /= 84 then
				Result := (-1)
				js.return
			elseif (links_inst.upcase (l_head___0[3])).to_integer_32 /= 80 then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				if (l_head___0[4]).to_integer_32 = 47 then
					if (l_head___0[5]).to_integer_32 >= 48 then
						if (l_head___0[5]).to_integer_32 <= 57 then
							if (l_head___0[6]).to_integer_32 = 46 then
								if (l_head___0[7]).to_integer_32 >= 48 then
									if (l_head___0[7]).to_integer_32 <= 57 then
										if (l_head___0[8]).to_integer_32 <= 32 then
											a_version.item := (((l_head___0[5]).to_integer_32 - 48) * 10 + (l_head___0[7]).to_integer_32) - 48
										else
											a_version.item := 0
										end
									else
										a_version.item := 0
									end
								else
									a_version.item := 0
								end
							else
								a_version.item := 0
							end
						else
							a_version.item := 0
						end
					else
						a_version.item := 0
					end
				else
					a_version.item := 0
				end
				l_head___0.ce_gets (l_head___0 + (4))
				from
				until
					not ((l_head___0.item).to_integer_32 > 32)
				loop
					l_head___0.ce_gets (l_head___0 + 1)
				end
				l_tmp___3.ce_gets (l_head___0)
				l_head___0.ce_gets (l_head___0 + 1)
				if (l_tmp___3.item).to_integer_32 /= 32 then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				if (l_head___0[0]).to_integer_32 < 49 then
					Result := (-1)
					js.return
				elseif (l_head___0[0]).to_integer_32 > 57 then
					Result := (-1)
					js.return
				elseif (l_head___0[1]).to_integer_32 < 48 then
					Result := (-1)
					js.return
				elseif (l_head___0[1]).to_integer_32 > 57 then
					Result := (-1)
					js.return
				elseif (l_head___0[2]).to_integer_32 < 48 then
					Result := (-1)
					js.return
				elseif (l_head___0[2]).to_integer_32 > 57 then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				a_code.item := ((((l_head___0[0]).to_integer_32 - 48) * 100 + ((l_head___0[1]).to_integer_32 - 48) * 10) + (l_head___0[2]).to_integer_32) - 48
				Result := 0
			end
		end

	check_http_server_bugs (a_url: CE_POINTER [NATURAL_8]; a_info: CE_POINTER [PD_HTTP_CONNECTION_INFO]; a_head___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_server: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
			l_bugs: INTEGER_32
			js: JUMP_STATE
		do
			create l_server.make

			if not (default_inst.http_bugs.allow_blacklist).to_boolean then
				Result := 0
				js.return
			elseif (a_info.item.http10).to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_server.ce_gets (parse_http_header (a_head___0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Server")), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
				if (l_server).c_pointer = default_pointer then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_bugs := 0
				l_i := 0
				from
				until
					(buggy_servers[l_i].name).c_pointer = default_pointer
				loop
					if (((strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_server), create {CE_POINTER [INTEGER_8]}.make_cast (buggy_servers[l_i].name)))).c_pointer /= default_pointer) then
						l_bugs := (l_bugs).bit_or ((buggy_servers[l_i].bugs))
					end
					l_i := l_i + 1
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 147, create {CE_POINTER [ANY]}.make_cast (l_server))
				if l_bugs.to_boolean then
					l_server.ce_gets (url_inst.get_host_name (a_url))
					if ((l_server).c_pointer /= default_pointer) then
						sched_inst.add_blacklist_entry (l_server, l_bugs)
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 150, create {CE_POINTER [ANY]}.make_cast (l_server))
						Result := ((l_bugs).bit_and (-9))
						js.return
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	http_end_request (a_c: CE_POINTER [PD_CONNECTION]; a_notrunc: INTEGER_32)
		do
			if a_c.item.state = -1000 then
				if ((a_c.item.cache).c_pointer /= default_pointer) then
					if not a_notrunc.to_boolean then
						cache_inst.truncate_entry (a_c.item.cache, a_c.item.from2, 1)
					end
					(a_c.item.cache).item.incomplete := 0
				end
			end
			if ((a_c.item.info).c_pointer /= default_pointer) then
				if not ((create {CE_POINTER [PD_HTTP_CONNECTION_INFO]}.make_cast (a_c.item.info)).item.close).to_boolean then
					if not (default_inst.http_bugs.bug_post_no_keepalive).to_boolean then
						sched_inst.add_keepalive_socket (a_c, (60000).to_integer_32)
					elseif (((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (a_c.item.url), 1))).c_pointer /= default_pointer) then
						sched_inst.abort_connection (a_c)
					else
						sched_inst.add_keepalive_socket (a_c, (60000).to_integer_32)
					end
				else
					sched_inst.abort_connection (a_c)
				end
			else
				sched_inst.abort_connection (a_c)
			end
		end

	http_func (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_p: INTEGER_32
			js: JUMP_STATE
		do
			if (sched_inst.get_keepalive_socket (a_c)).to_boolean then
				l_p := url_inst.get_port (a_c.item.url)
				if l_p = -1 then
					sched_inst.setcstate (a_c, -1003)
					sched_inst.abort_connection (a_c)
					js.return
				end
				if not js.return_called then
					connect_inst.make_connection (a_c, l_p, create {CE_POINTER [INTEGER_32]}.make_shared (a_c.c_pointer + {PD_CONNECTION}.sock1_offset), http_send_header_address)
				end
			else
				http_send_header (a_c)
			end
			if not js.return_called then
			end
		end

	http_func_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent http_func)
		end

	proxy_func (a_c: CE_POINTER [PD_CONNECTION])
		do
			http_func (a_c)
		end

	proxy_func_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent proxy_func)
		end

	http_send_header (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_info: CE_POINTER [PD_HTTP_CONNECTION_INFO]
			l_http10: INTEGER_32
			l_e: CE_POINTER [PD_CACHE_ENTRY]
			l_hdr: CE_POINTER [NATURAL_8]
			l_h: CE_POINTER [NATURAL_8]
			l_u: CE_POINTER [NATURAL_8]
			l_uu: CE_POINTER [NATURAL_8]
			l_sp: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_la: INTEGER_32
			l_post: CE_POINTER [NATURAL_8]
			l_host: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_nu: CE_POINTER [NATURAL_8]
			l_t: CE_POINTER [PD_TERMINAL]
			l_i: INTEGER_32
			l_cs: CE_POINTER [NATURAL_8]
			l_ac: CE_POINTER [NATURAL_8]
			l_aclen: INTEGER_32
			l_code: INTEGER_32
			l_vers: INTEGER_32
			l_pd: CE_POINTER [NATURAL_8]
			l_h1: INTEGER_32
			l_h2: INTEGER_32
			l_tmp___18: INTEGER_32
			l_tmp___20: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_info.make
			create l_e.make
			create l_hdr.make
			create l_h.make
			create l_u.make
			create l_uu.make
			create l_sp.make
			create l_post.make
			create l_host.make
			create l_tmp___1.make
			create l_nu.make
			create l_t.make
			create l_cs.make
			create l_ac.make
			create l_pd.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_http10 := default_inst.http_bugs.http10
					l_e.ce_gets (create {CE_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer))
					l_l := 0
					if (links_inst.upcase (a_c.item.url[0])).to_integer_32 /= 80 then
						l_tmp___1.ce_gets (a_c.item.url)
					else
						l_tmp___1.ce_gets ((url_inst.get_url_data (a_c.item.url)))
					end
					l_host.ce_gets (l_tmp___1)
					sched_inst.set_timeout (a_c)
					l_info.ce_gets (create {CE_POINTER [PD_HTTP_CONNECTION_INFO]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 210, {PD_HTTP_CONNECTION_INFO}.sizeof.to_natural_32))))
					memset (create {CE_POINTER [ANY]}.make_cast (l_info), 0, {PD_HTTP_CONNECTION_INFO}.sizeof.to_natural_32).do_nothing
					a_c.item.info := create {CE_POINTER [ANY]}.make_cast (l_info)
					l_h.ce_gets (url_inst.get_host_name (l_host))
					if ((l_h).c_pointer /= default_pointer) then
						l_info.item.bl_flags := sched_inst.get_blacklist_flags (l_h)
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 215, create {CE_POINTER [ANY]}.make_cast (l_h))
					end
					if ((l_info.item.bl_flags).bit_and (1)).to_boolean then
						l_http10 := 1
					end
					l_info.item.http10 := l_http10
					l_post.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (a_c.item.url), 1))))
					if ((l_post).c_pointer /= default_pointer) then
						l_post.ce_gets (l_post + 1)
					end
					l_hdr.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 221))
					if (l_post).c_pointer = default_pointer then
						links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("GET ")))
					else
						links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("POST ")))
						a_c.item.unrestartable := 2
					end
					if (links_inst.upcase (a_c.item.url[0])).to_integer_32 /= 80 then
						links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/")))
					end
					l_u.ce_gets (url_inst.get_url_data (a_c.item.url))
					if (l_u).c_pointer = default_pointer then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 229, create {CE_POINTER [ANY]}.make_cast (l_hdr))
						sched_inst.setcstate (a_c, -1009)
						http_end_request (a_c, 0)
						js.return
					end
					if not js.return_called and then ((l_post).c_pointer /= default_pointer) then
						if (l_post.c_pointer.to_integer_32).to_natural_32 < (l_u.c_pointer.to_integer_32).to_natural_32 then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 235, create {CE_POINTER [ANY]}.make_cast (l_hdr))
							sched_inst.setcstate (a_c, -1009)
							http_end_request (a_c, 0)
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						if (l_post).c_pointer = default_pointer then
							l_uu.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 240, l_u))
						else
							l_uu.ce_gets (links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 241, l_u, (l_post.distance (l_u)) - 1))
						end
				when 2 then -- a:
						l_sp.ce_gets (l_uu)
				when 3 then -- loop condition:
						if not ((l_sp.item).to_boolean) then
							l_pos := -1 + 6 -- skip loop
						end
				when 4 then -- loop body:
						if (l_sp.item).to_integer_32 <= 32 then
							l_nu.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 244, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_uu))) + {NATURAL_32} 3))))
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_nu), create {CE_POINTER [ANY]}.make_cast (l_uu), (l_sp.distance (l_uu)).to_natural_32).do_nothing
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast ((l_nu + (l_sp.distance (l_uu)))), ce_string ("%%%%%%02X"), (l_sp.item).to_integer_32]).do_nothing
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_nu), create {CE_POINTER [INTEGER_8]}.make_cast ((l_sp + 1))).do_nothing
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 248, create {CE_POINTER [ANY]}.make_cast (l_uu))
							l_uu.ce_gets (l_nu)
							l_pos := -1 + 2 -- goto a
						elseif (l_sp.item).to_integer_32 = 92 then
							l_sp.item := (('/').code).to_natural_8
						end
				when 5 then
						l_sp.ce_gets (l_sp + 1)
						l_pos := -1 + 3 -- back to loop condition
				when 6 then -- loop done
						links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_uu)
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 253, create {CE_POINTER [ANY]}.make_cast (l_uu))
						if not l_http10.to_boolean then
							links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" HTTP/1.1%R%N")))
						else
							links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" HTTP/1.0%R%N")))
						end
						l_h.ce_gets (url_inst.get_host_name (l_host))
						if ((l_h).c_pointer /= default_pointer) then
							links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Host: ")))
							links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_h)
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 259, create {CE_POINTER [ANY]}.make_cast (l_h))
							l_h.ce_gets (url_inst.get_port_str (l_host))
							if ((l_h).c_pointer /= default_pointer) then
								links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (":")))
								links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_h)
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 263, create {CE_POINTER [ANY]}.make_cast (l_h))
							end
							links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%N")))
						end
						links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("User-Agent: Links (1.00; ")))
						links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), links_inst.system_name)
						if ((terminal_inst.terminals.next).c_pointer.to_integer_32).to_natural_32 /= ((terminal_inst.terminals.address).c_pointer.to_integer_32).to_natural_32 then
							l_t.ce_gets (create {CE_POINTER [PD_TERMINAL]}.make_cast (terminal_inst.terminals.prev))
							links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("; ")))
							links_inst.add_num_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (l_t.item.x).to_integer_32)
							links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("x")))
							links_inst.add_num_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (l_t.item.y).to_integer_32)
						end
						links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (")%R%N")))
						links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Accept: */*%R%N")))
						if (accept_charset).c_pointer = default_pointer then
							l_aclen := 0
							l_ac.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 282))
							l_i := 0
							from
							until
								js.loop_left
							loop
								js.reset
								l_cs.ce_gets (charsets_inst.get_cp_mime_name (l_i))
								if (l_cs).c_pointer = default_pointer then
									js.break
								end
								if not js.loop_jumped then
									if l_aclen.to_boolean then
										links_inst.add_to_str (l_ac.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_aclen), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (", ")))
									else
										links_inst.add_to_str (l_ac.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_aclen), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Accept-Charset: ")))
									end
									links_inst.add_to_str (l_ac.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_aclen), l_cs)
									l_i := l_i + 1
								end
							end
							js.reset
							if l_aclen.to_boolean then
								links_inst.add_to_str (l_ac.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_aclen), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%N")))
							end
							accept_charset.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((malloc ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ac))) + {NATURAL_32} 1))))
							if ((accept_charset).c_pointer /= default_pointer) then
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (accept_charset), create {CE_POINTER [INTEGER_8]}.make_cast (l_ac)).do_nothing
							else
								accept_charset.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
							end
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 291, create {CE_POINTER [ANY]}.make_cast (l_ac))
						end
						if not ((l_info.item.bl_flags).bit_and (4)).to_boolean then
							if not (default_inst.http_bugs.no_accept_charset).to_boolean then
								links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), accept_charset)
							end
						end
						if not ((l_info.item.bl_flags).bit_and (2)).to_boolean then
							links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Accept-Language: ")))
							l_la := l_l
							links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (language_inst.get_text_translation (links_inst.dummyarray + 3, create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer))))
							links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (", ")))
							if ((strstr (create {CE_POINTER [INTEGER_8]}.make_cast ((l_hdr + l_la)), ce_string ("en,")))).c_pointer = default_pointer then
								if ((strstr (create {CE_POINTER [INTEGER_8]}.make_cast ((l_hdr + l_la)), ce_string ("en;")))).c_pointer = default_pointer then
									links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("en;q=0.2, ")))
								end
							end
							links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("*;q=0.1%R%N")))
						end
						if not l_http10.to_boolean then
							if (links_inst.upcase (a_c.item.url[0])).to_integer_32 /= 80 then
								links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Connection: ")))
							else
								links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Proxy-Connection: ")))
							end
							if (l_post).c_pointer = default_pointer then
								links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Keep-Alive%R%N")))
							elseif not (default_inst.http_bugs.bug_post_no_keepalive).to_boolean then
								links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Keep-Alive%R%N")))
							else
								links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("close%R%N")))
							end
						end
						l_e.ce_gets (a_c.item.cache)
						if (l_e).c_pointer = default_pointer then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if (get_http_code (l_e.item.head, create {CE_POINTER [INTEGER_32]}.make_shared ($l_code), create {CE_POINTER [INTEGER_32]}.make_shared ($l_vers))).to_boolean then
							l_pos := -1 + 15 -- goto skip_ifmod_and_range
						elseif l_code >= 400 then
							l_pos := -1 + 15 -- goto skip_ifmod_and_range
						end
				when 8 then
						if not (l_e.item.incomplete).to_boolean then
							if ((l_e.item.head).c_pointer /= default_pointer) then
								if a_c.item.no_cache <= 2 then
									if ((l_e.item.last_modified).c_pointer /= default_pointer) then
										links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("If-Modified-Since: ")))
										links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_e.item.last_modified)
										links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%N")))
									end
								end
							end
						end
				when 9 then -- if done
						if not ((a_c.item.from2).to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if:
						if a_c.item.est_length /= -1 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 13 then -- else:
						if not (a_c.item.from2 < a_c.item.est_length) then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L:
						if a_c.item.no_cache < 2 then
							if not ((l_info.item.bl_flags).bit_and (8)).to_boolean then
								links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Range: bytes=")))
								links_inst.add_num_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), a_c.item.from2)
								links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("-%R%N")))
							end
						end
				when 15 then -- if done | if done | skip_ifmod_and_range:
						if a_c.item.no_cache >= 4 then
							links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Pragma: no-cache%R%NCache-Control: no-cache%R%N")))
						end
						if ((l_post).c_pointer /= default_pointer) then
							l_pd.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_post), ('%N').code))))
							if ((l_pd).c_pointer /= default_pointer) then
								links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Content-Type: ")))
								links_inst.add_bytes_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_post, l_pd.distance (l_post))
								links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%N")))
								l_post.ce_gets (l_pd + 1)
							end
							links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Content-Length: ")))
							links_inst.add_num_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_post))) // {NATURAL_32} 2).to_integer_32)
							links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%N")))
						end
						cookies_inst.send_cookies (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_host)
						links_inst.add_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%N")))
						if ((l_post).c_pointer /= default_pointer) then
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_post[0]).to_boolean then
									if not (l_post[1]).to_boolean then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									if (l_post[0]).to_integer_32 <= 57 then
										l_h1 := (l_post[0]).to_integer_32 - 48
									else
										if (l_post[0]).to_integer_32 >= 65 then
											l_tmp___18 := ((links_inst.upcase (l_post[0])).to_integer_32 - 65) + 10
										else
											l_tmp___18 := 0
										end
										l_h1 := l_tmp___18
									end
									if l_h1 < 0 then
										l_h1 := 0
									elseif l_h1 >= 16 then
										l_h1 := 0
									end
									if (l_post[1]).to_integer_32 <= 57 then
										l_h2 := (l_post[1]).to_integer_32 - 48
									else
										if (l_post[1]).to_integer_32 >= 65 then
											l_tmp___20 := ((links_inst.upcase (l_post[1])).to_integer_32 - 65) + 10
										else
											l_tmp___20 := 0
										end
										l_h2 := l_tmp___20
									end
									if l_h2 < 0 then
										l_h2 := 0
									elseif l_h2 >= 16 then
										l_h2 := 0
									end
									links_inst.add_chr_to_str (l_hdr.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (l_h1 * 16 + l_h2).to_natural_8)
									l_post.ce_gets (l_post + (2))
								end
							end
							js.reset
						end
						connect_inst.write_to_socket (a_c, a_c.item.sock1, l_hdr, l_l, http_get_header_address)
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 351, create {CE_POINTER [ANY]}.make_cast (l_hdr))
						sched_inst.setcstate (a_c, 4)
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	http_send_header_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent http_send_header)
		end

	is_line_in_buffer (a_rb: CE_POINTER [PD_READ_BUFFER]): INTEGER_32
		local
			l_l: INTEGER_32
			js: JUMP_STATE
		do
			l_l := 0
			from
			until
				not (not js.loop_left and then (l_l < a_rb.item.len))
			loop
				if (a_rb.item.data[l_l]).to_integer_32 = 10 then
					Result := (l_l + 1)
					js.return
				end
				if not js.return_called and then (l_l < a_rb.item.len - 1) then
					if (a_rb.item.data[l_l]).to_integer_32 = 13 then
						if (a_rb.item.data[l_l + 1]).to_integer_32 = 10 then
							Result := (l_l + 2)
							js.return
						end
					end
				end
				if not js.return_called and then (l_l = a_rb.item.len - 1) then
					if (a_rb.item.data[l_l]).to_integer_32 = 13 then
						Result := 0
						js.return
					end
				end
				if not js.return_called and then ((a_rb.item.data[l_l]).to_integer_32 < 32) then
					Result := (-1)
					js.return
				end
				if not js.return_called then
					l_l := l_l + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	read_http_data (a_c: CE_POINTER [PD_CONNECTION]; a_rb: CE_POINTER [PD_READ_BUFFER])
		local
			l_info: CE_POINTER [PD_HTTP_CONNECTION_INFO]
			l_l: INTEGER_32
			l_l___0: INTEGER_32
			l_l___1: INTEGER_32
			l_de: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			l_tmp___0: INTEGER_32
			l_l___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_info.make
			create l_de.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_info.ce_gets (create {CE_POINTER [PD_HTTP_CONNECTION_INFO]}.make_cast (a_c.item.info))
					sched_inst.set_timeout (a_c)
					if a_rb.item.close = 2 then
						sched_inst.setcstate (a_c, -1000)
						http_end_request (a_c, 0)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 20 -- skip if block
					end
				when 1 then -- if:
						if l_info.item.length = -2 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_l := a_rb.item.len
						if l_info.item.length >= 0 then
							if l_info.item.length < l_l then
								l_l := l_info.item.length
							end
						end
						if a_c.item.from2 + l_l.to_integer_32 < 0 then
							sched_inst.setcstate (a_c, -1014)
							sched_inst.abort_connection (a_c)
							js.return
						end
						if not js.return_called then
							a_c.item.received := a_c.item.received + l_l.to_integer_32
							if (cache_inst.add_fragment (a_c.item.cache, a_c.item.from2, a_rb.item.data, l_l.to_integer_32)) = 1 then
								a_c.item.tries := 0
							end
							if l_info.item.length >= 0 then
								l_info.item.length := l_info.item.length - l_l
							end
							a_c.item.from2 := a_c.item.from2 + l_l.to_integer_32
							connect_inst.kill_buffer_data (a_rb, l_l)
							if not (l_info.item.length).to_boolean then
								if not (a_rb.item.close).to_boolean then
									sched_inst.setcstate (a_c, -1000)
									http_end_request (a_c, 0)
									js.return
								end
							end
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 4 then -- else: | next_chunk:
						if l_info.item.chunk_remaining /= -2 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_l___0 := is_line_in_buffer (a_rb)
						if l_l___0.to_boolean then
							if l_l___0 = -1 then
								sched_inst.setcstate (a_c, -1100)
								sched_inst.abort_connection (a_c)
								js.return
							end
							if not js.return_called then
								connect_inst.kill_buffer_data (a_rb, l_l___0)
								if l_l___0 <= 2 then
									sched_inst.setcstate (a_c, -1000)
									http_end_request (a_c, 0)
									js.return
								end
							end
							if not js.return_called then
								l_pos := -1 + 4 -- goto next_chunk
							end
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 7 then -- else:
						if l_info.item.chunk_remaining /= -1 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_l___1 := is_line_in_buffer (a_rb)
						if l_l___1.to_boolean then
							l_n := 0
							if l_l___1 /= -1 then
								l_n := strtol (create {CE_POINTER [INTEGER_8]}.make_cast ((a_rb.item.data)), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast ((l_de.address)), 16)
							end
							if l_l___1 = -1 then
								sched_inst.setcstate (a_c, -1100)
								sched_inst.abort_connection (a_c)
								js.return
							elseif l_n < 0 then
								sched_inst.setcstate (a_c, -1100)
								sched_inst.abort_connection (a_c)
								js.return
							elseif l_n >= 2147483647 then
								sched_inst.setcstate (a_c, -1100)
								sched_inst.abort_connection (a_c)
								js.return
							elseif (l_de.c_pointer.to_integer_32).to_natural_32 = ((a_rb.item.data).c_pointer.to_integer_32).to_natural_32 then
								sched_inst.setcstate (a_c, -1100)
								sched_inst.abort_connection (a_c)
								js.return
							end
							if not js.return_called then
								connect_inst.kill_buffer_data (a_rb, l_l___1)
								l_tmp___0 := l_n.to_integer_32
								l_info.item.chunk_remaining := l_tmp___0
								if not l_tmp___0.to_boolean then
									l_info.item.chunk_remaining := -2
								end
								l_pos := -1 + 4 -- goto next_chunk
							end
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 10 then -- else:
						l_l___2 := l_info.item.chunk_remaining
						if l_l___2 > a_rb.item.len then
							l_l___2 := a_rb.item.len
						end
						if a_c.item.from2 + l_l___2.to_integer_32 < 0 then
							sched_inst.setcstate (a_c, -1014)
							sched_inst.abort_connection (a_c)
							js.return
						end
						if js.return_called then
							l_pos := -1 + 20 -- skip if block
						end
				when 11 then -- if:
						a_c.item.received := a_c.item.received + l_l___2.to_integer_32
						if (cache_inst.add_fragment (a_c.item.cache, a_c.item.from2, a_rb.item.data, l_l___2.to_integer_32)) = 1 then
							a_c.item.tries := 0
						end
						l_info.item.chunk_remaining := l_info.item.chunk_remaining - l_l___2
						a_c.item.from2 := a_c.item.from2 + l_l___2.to_integer_32
						connect_inst.kill_buffer_data (a_rb, l_l___2)
						if (l_info.item.chunk_remaining).to_boolean then
							l_pos := -1 + 20 -- skip if block
						end
				when 12 then -- if:
						if not (a_rb.item.len >= 1) then
							l_pos := -1 + 20 -- skip if block
						end
				when 13 then -- if:
						if (a_rb.item.data[0]).to_integer_32 /= 10 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						connect_inst.kill_buffer_data (a_rb, 1)
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 16 then -- else:
						if (a_rb.item.data[0]).to_integer_32 /= 13 then
							sched_inst.setcstate (a_c, -1100)
							sched_inst.abort_connection (a_c)
							js.return
						elseif a_rb.item.len >= 2 then
							if (a_rb.item.data[1]).to_integer_32 /= 10 then
								sched_inst.setcstate (a_c, -1100)
								sched_inst.abort_connection (a_c)
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if a_rb.item.len < 2 then
							l_pos := -1 + 21 -- goto read_more
						end
				when 18 then
						connect_inst.kill_buffer_data (a_rb, 2)
				when 19 then -- if done | if done
						if not js.return_called then
							l_info.item.chunk_remaining := -1
							l_pos := -1 + 4 -- goto next_chunk
						end
				when 20 then -- if done | if done | if done | if done | if done | if done
						if js.return_called then
							l_pos := -1 + 22 -- skip if block
						end
				when 21 then -- if: | read_more:
							connect_inst.read_from_socket (a_c, a_c.item.sock1, a_rb, read_http_data_address)
							sched_inst.setcstate (a_c, 8)
				when 22 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	read_http_data_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent read_http_data)
		end

	get_header (a_rb: CE_POINTER [PD_READ_BUFFER]): INTEGER_32
		local
			l_i: INTEGER_32
			l_a: NATURAL_8
			js: JUMP_STATE
		do
			l_i := 0
			from
			until
				not (not js.loop_left and then (l_i < a_rb.item.len))
			loop
				l_a := a_rb.item.data[l_i]
				if not l_a.to_boolean then
					Result := (-1)
					js.return
				end
				if not js.return_called and then (l_i < a_rb.item.len - 1) then
					if l_a.to_integer_32 = 10 then
						if (a_rb.item.data[l_i + 1]).to_integer_32 = 10 then
							Result := (l_i + 2)
							js.return
						end
					end
				end
				if not js.return_called and then (l_i < a_rb.item.len - 3) then
					if l_a.to_integer_32 = 13 then
						if (a_rb.item.data[l_i + 1]).to_integer_32 /= 10 then
							Result := (-1)
							js.return
						end
						if not js.return_called and then ((a_rb.item.data[l_i + 2]).to_integer_32 = 13) then
							if (a_rb.item.data[l_i + 3]).to_integer_32 /= 10 then
								Result := (-1)
								js.return
							end
							if not js.return_called then
								Result := (l_i + 4)
								js.return
							end
						end
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	http_got_header (a_c: CE_POINTER [PD_CONNECTION]; a_rb: CE_POINTER [PD_READ_BUFFER])
		local
			l_cf: INTEGER_32
			l_state: INTEGER_32
			l_tmp: INTEGER_32
			l_head___0: CE_POINTER [NATURAL_8]
			l_cookie: CE_POINTER [NATURAL_8]
			l_ch: CE_POINTER [NATURAL_8]
			l_a: INTEGER_32
			l_h: INTEGER_32
			l_version: INTEGER_32
			l_d: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [PD_CACHE_ENTRY]
			l_info: CE_POINTER [PD_HTTP_CONNECTION_INFO]
			l_host: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_h___0: CE_POINTER [NATURAL_8]
			l_host___0: CE_POINTER [NATURAL_8]
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_f: INTEGER_64
			l_ep: CE_POINTER [NATURAL_8]
			l_l: INTEGER_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_head___0.make
			create l_cookie.make
			create l_ch.make
			create l_d.make
			create l_e.make
			create l_info.make
			create l_host.make
			create l_tmp___2.make
			create l_h___0.make
			create l_host___0.make
			create l_tmp___10.make
			create l_ep.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_c.item.state /= 7 then
						l_tmp := 6
					else
						l_tmp := 7
					end
					l_state := l_tmp
					if (links_inst.upcase (a_c.item.url[0])).to_integer_32 /= 80 then
						l_tmp___2.ce_gets (a_c.item.url)
					else
						l_tmp___2.ce_gets ((url_inst.get_url_data (a_c.item.url)))
					end
					l_host.ce_gets (l_tmp___2)
					sched_inst.set_timeout (a_c)
					l_info.ce_gets (create {CE_POINTER [PD_HTTP_CONNECTION_INFO]}.make_cast (a_c.item.info))
					if a_rb.item.close = 2 then
						if not (a_c.item.tries).to_boolean then
							l_h___0.ce_gets (url_inst.get_host_name (l_host))
							if ((l_h___0).c_pointer /= default_pointer) then
								if ((l_info.item.bl_flags).bit_and (4)).to_boolean then
									sched_inst.del_blacklist_entry (l_h___0, 4)
								else
									sched_inst.add_blacklist_entry (l_h___0, 4)
									a_c.item.tries := -1
								end
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 502, create {CE_POINTER [ANY]}.make_cast (l_h___0))
							end
						end
						sched_inst.setcstate (a_c, -1007)
						sched_inst.retry_connection (a_c)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_rb.item.close := 0
				when 2 then -- again:
						l_a := get_header (a_rb)
						if l_a = -1 then
							sched_inst.setcstate (a_c, -1100)
							sched_inst.abort_connection (a_c)
							js.return
						end
				when 3 then -- if done
					if not js.return_called and then (not l_a.to_boolean) then
						connect_inst.read_from_socket (a_c, a_c.item.sock1, a_rb, http_got_header_address)
						sched_inst.setcstate (a_c, l_state)
						js.return
					end
					if not js.return_called then
						if (get_http_code (a_rb.item.data, create {CE_POINTER [INTEGER_32]}.make_shared ($l_h), create {CE_POINTER [INTEGER_32]}.make_shared ($l_version))).to_boolean then
							sched_inst.setcstate (a_c, -1100)
							sched_inst.abort_connection (a_c)
							js.return
						elseif l_h = 101 then
							sched_inst.setcstate (a_c, -1100)
							sched_inst.abort_connection (a_c)
							js.return
						end
					end
					if not js.return_called then
						l_head___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 525, (l_a + 1).to_natural_32))))
						memcpy (create {CE_POINTER [ANY]}.make_cast (l_head___0), create {CE_POINTER [ANY]}.make_cast ((a_rb.item.data)), l_a.to_natural_32).do_nothing
						l_head___0[l_a] := (0).to_natural_8
						if (check_http_server_bugs (l_host, create {CE_POINTER [PD_HTTP_CONNECTION_INFO]}.make_cast (a_c.item.info), l_head___0)).to_boolean then
							if (sched_inst.is_connection_restartable (a_c)).to_boolean then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 528, create {CE_POINTER [ANY]}.make_cast (l_head___0))
								sched_inst.setcstate (a_c, -1011)
								sched_inst.retry_connection (a_c)
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 4 then -- if:
						l_ch.ce_gets (l_head___0)
						from
						until
							js.loop_left
						loop
							js.reset
							l_cookie.ce_gets (parse_http_header (l_ch, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Set-Cookie")), l_ch.address))
							if (l_cookie).c_pointer = default_pointer then
								js.break
							end
							if not js.loop_jumped then
								if (links_inst.upcase (a_c.item.url[0])).to_integer_32 /= 80 then
									l_tmp___10.ce_gets (a_c.item.url)
								else
									l_tmp___10.ce_gets ((url_inst.get_url_data (a_c.item.url)))
								end
								l_host___0.ce_gets (l_tmp___10)
								cookies_inst.set_cookie (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_host___0, l_cookie).do_nothing
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 537, create {CE_POINTER [ANY]}.make_cast (l_cookie))
							end
						end
						js.reset
						if l_h = 100 then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 540, create {CE_POINTER [ANY]}.make_cast (l_head___0))
							l_state := 7
							connect_inst.kill_buffer_data (a_rb, l_a)
							l_pos := -1 + 2 -- goto again
						end
				when 5 then
						if l_h < 200 then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 546, create {CE_POINTER [ANY]}.make_cast (l_head___0))
							sched_inst.setcstate (a_c, -1100)
							sched_inst.abort_connection (a_c)
							js.return
						end
				when 6 then -- if done
					if not js.return_called and then (l_h = 304) then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 552, create {CE_POINTER [ANY]}.make_cast (l_head___0))
						sched_inst.setcstate (a_c, -1000)
						http_end_request (a_c, 1)
						js.return
					end
					if not js.return_called and then (l_h = 204) then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 558, create {CE_POINTER [ANY]}.make_cast (l_head___0))
						sched_inst.setcstate (a_c, -1102)
						http_end_request (a_c, 0)
						js.return
					end
					if not js.return_called and then ((a_c.item.cache).c_pointer = default_pointer) then
						if (cache_inst.get_cache_entry (a_c.item.url, create {CE_POINTER [CE_POINTER [PD_CACHE_ENTRY]]}.make_shared (a_c.c_pointer + {PD_CONNECTION}.cache_offset))).to_boolean then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 564, create {CE_POINTER [ANY]}.make_cast (l_head___0))
							sched_inst.setcstate (a_c, -1004)
							sched_inst.abort_connection (a_c)
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 26 -- skip if block
					end
				when 7 then -- if:
						l_e.ce_gets (a_c.item.cache)
						if ((l_e.item.head).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 570, create {CE_POINTER [ANY]}.make_cast (l_e.item.head))
						end
						l_e.item.head := l_head___0
						if ((l_e.item.redirect).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 584, create {CE_POINTER [ANY]}.make_cast (l_e.item.redirect))
							l_e.item.redirect := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						end
						if l_h /= 301 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 10 then -- else:
						if l_h /= 302 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 13 then -- else:
						if l_h /= 303 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if l_h /= 307 then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L:
						l_d.ce_gets (parse_http_header (l_e.item.head, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Location")), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
						if ((l_d).c_pointer /= default_pointer) then
							if ((l_e.item.redirect).c_pointer /= default_pointer) then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 587, create {CE_POINTER [ANY]}.make_cast (l_e.item.redirect))
							end
							l_e.item.redirect := l_d
							l_e.item.redirect_get := (l_h = 303).to_integer
						end
				when 18 then -- if done | if done | if done
						connect_inst.kill_buffer_data (a_rb, l_a)
						l_info.item.close := 0
						l_info.item.length := -1
						l_info.item.version := l_version
						l_d.ce_gets (parse_http_header (l_e.item.head, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Connection")), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
						if (l_d).c_pointer = default_pointer then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 22 -- goto _L___0
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 21 then -- else:
						l_d.ce_gets (parse_http_header (l_e.item.head, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Proxy-Connection")), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
						if (l_d).c_pointer = default_pointer then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if: | _L___0:
						if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_d), ce_string ("close"))).to_boolean then
							l_info.item.close := 1
						end
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 598, create {CE_POINTER [ANY]}.make_cast (l_d))
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:
						if l_version < 11 then
							l_info.item.close := 1
						end
				when 25 then -- if done
						l_cf := (a_c.item.from2).to_integer_32
						a_c.item.from2 := (0).to_integer_32
						l_d.ce_gets (parse_http_header (l_e.item.head, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Content-Range")), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
						if ((l_d).c_pointer /= default_pointer) then
							if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_d))) > {NATURAL_32} 6 then
								l_d[5] := (0).to_natural_8
								if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_d), ce_string ("bytes"))).to_boolean then
									if (l_d[6]).to_integer_32 >= 48 then
										if (l_d[6]).to_integer_32 <= 57 then
											l_f := (strtoll (create {CE_POINTER [INTEGER_8]}.make_cast ((l_d + 6)), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), 10))
											if l_f >= {INTEGER_64} 0 then
												if l_f.to_integer_32 >= 0 then
													if (l_f.to_integer_32).to_integer_64 = l_f then
														a_c.item.from2 := l_f.to_integer_32
													end
												end
											end
										end
									end
								end
							end
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 617, create {CE_POINTER [ANY]}.make_cast (l_d))
						end
						if l_cf.to_boolean then
							if not (a_c.item.from2).to_boolean then
								if not (a_c.item.unrestartable).to_boolean then
									a_c.item.unrestartable := 1
								end
							end
						end
						if a_c.item.from2 > l_cf.to_integer_32 then
							sched_inst.setcstate (a_c, -1100)
							sched_inst.abort_connection (a_c)
							js.return
						elseif a_c.item.from2 < 0 then
							sched_inst.setcstate (a_c, -1100)
							sched_inst.abort_connection (a_c)
							js.return
						end
				when 26 then -- if done
					if not js.return_called then
						l_d.ce_gets (parse_http_header (l_e.item.head, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Content-Length")), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
						if ((l_d).c_pointer /= default_pointer) then
							l_l := (strtoll (create {CE_POINTER [INTEGER_8]}.make_cast (l_d), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast ((l_ep.address)), 10))
							if not (l_ep.item).to_boolean then
								if l_l >= {INTEGER_64} 0 then
									if l_l.to_integer_32 >= 0 then
										if (l_l.to_integer_32).to_integer_64 = l_l then
											if not (l_info.item.close).to_boolean then
												l_info.item.length := l_l.to_integer_32
											elseif l_version >= 11 then
												l_info.item.length := l_l.to_integer_32
											end
											if (a_c.item.from2).to_natural_32 + l_l.to_natural_32 < {NATURAL_32} 2147483647 then
												a_c.item.est_length := ((a_c.item.from2).to_integer_64 + l_l).to_integer_32
											end
										end
									end
								end
							end
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 639, create {CE_POINTER [ANY]}.make_cast (l_d))
						end
						l_d.ce_gets (parse_http_header (l_e.item.head, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Accept-Ranges")), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
						if ((l_d).c_pointer /= default_pointer) then
							if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_d), ce_string ("none"))).to_boolean then
								if not (a_c.item.unrestartable).to_boolean then
									a_c.item.unrestartable := 1
								end
							end
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 643, create {CE_POINTER [ANY]}.make_cast (l_d))
						elseif not (a_c.item.unrestartable).to_boolean then
							if not (a_c.item.from2).to_boolean then
								a_c.item.unrestartable := 1
							end
						end
						if ((l_info.item.bl_flags).bit_and (8)).to_boolean then
							if not (a_c.item.unrestartable).to_boolean then
								a_c.item.unrestartable := 1
							end
						end
						l_d.ce_gets (parse_http_header (l_e.item.head, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Transfer-Encoding")), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
						if ((l_d).c_pointer /= default_pointer) then
							if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_d), ce_string ("chunked"))).to_boolean then
								l_info.item.length := -2
								l_info.item.chunk_remaining := -1
							end
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 653, create {CE_POINTER [ANY]}.make_cast (l_d))
						end
						if not (l_info.item.close).to_boolean then
							if l_info.item.length = -1 then
								l_info.item.close := 1
							end
						end
						l_d.ce_gets (parse_http_header (l_e.item.head, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Last-Modified")), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
						if ((l_d).c_pointer /= default_pointer) then
							if ((l_e.item.last_modified).c_pointer /= default_pointer) then
								if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_e.item.last_modified), create {CE_POINTER [INTEGER_8]}.make_cast (l_d))).to_boolean then
									cache_inst.delete_entry_content (l_e)
									if (a_c.item.from2).to_boolean then
										a_c.item.from2 := (0).to_integer_32
										error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 661, create {CE_POINTER [ANY]}.make_cast (l_d))
										sched_inst.setcstate (a_c, -1008)
										sched_inst.retry_connection (a_c)
										js.return
									end
								end
							end
							if not js.return_called then
								if (l_e.item.last_modified).c_pointer = default_pointer then
									l_e.item.last_modified := l_d
								else
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http.c")), 668, create {CE_POINTER [ANY]}.make_cast (l_d))
								end
							end
						end
					end
					if not js.return_called then
						if (l_e.item.last_modified).c_pointer = default_pointer then
							l_d.ce_gets (parse_http_header (l_e.item.head, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Date")), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
							if ((l_d).c_pointer /= default_pointer) then
								l_e.item.last_modified := l_d
							end
						end
						if l_info.item.length = -1 then
							a_rb.item.close := 1
						elseif l_version < 11 then
							if (l_info.item.close).to_boolean then
								a_rb.item.close := 1
							end
						end
						read_http_data (a_c, a_rb)
					end
				when 27 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	http_got_header_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent http_got_header)
		end

	http_get_header (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_rb: CE_POINTER [PD_READ_BUFFER]
			js: JUMP_STATE
		do
			create l_rb.make

			sched_inst.set_timeout (a_c)
			l_rb.ce_gets (connect_inst.alloc_read_buffer (a_c))
			if (l_rb).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				l_rb.item.close := 1
				connect_inst.read_from_socket (a_c, a_c.item.sock1, l_rb, http_got_header_address)
			end
		end

	http_get_header_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent http_get_header)
		end

end
