class
	P_LANGUAGE

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create translation_english.make (<<379>>)
			create translation_belarusian.make (<<379>>)
			create translation_brazilian_portuguese.make (<<379>>)
			create translation_bulgarian.make (<<379>>)
			create translation_catalan.make (<<379>>)
			create translation_croatian.make (<<379>>)
			create translation_czech.make (<<379>>)
			create translation_danish.make (<<379>>)
			create translation_dutch.make (<<379>>)
			create translation_estonian.make (<<379>>)
			create translation_finnish.make (<<379>>)
			create translation_french.make (<<379>>)
			create translation_galician.make (<<379>>)
			create translation_german.make (<<379>>)
			create translation_greek.make (<<379>>)
			create translation_hungarian.make (<<379>>)
			create translation_icelandic.make (<<379>>)
			create translation_indonesian.make (<<379>>)
			create translation_italian.make (<<379>>)
			create translation_lithuanian.make (<<379>>)
			create translation_norwegian.make (<<379>>)
			create translation_polish.make (<<379>>)
			create translation_portuguese.make (<<379>>)
			create translation_romanian.make (<<379>>)
			create translation_russian.make (<<379>>)
			create translation_serbian.make (<<379>>)
			create translation_slovak.make (<<379>>)
			create translation_spanish.make (<<379>>)
			create translation_swedish.make (<<379>>)
			create translation_turkish.make (<<379>>)
			create translation_ukrainian.make (<<379>>)
			create translation_upper_sorbian.make (<<379>>)
			create translations.make (<<33>>)
			create translation_array.make (<<32, 27>>)
		end

feature {ANY} -- attributes

	translation_english: CE_ARRAY [PD_TRANSLATION]

	translation_belarusian: CE_ARRAY [PD_TRANSLATION]

	translation_brazilian_portuguese: CE_ARRAY [PD_TRANSLATION]

	translation_bulgarian: CE_ARRAY [PD_TRANSLATION]

	translation_catalan: CE_ARRAY [PD_TRANSLATION]

	translation_croatian: CE_ARRAY [PD_TRANSLATION]

	translation_czech: CE_ARRAY [PD_TRANSLATION]

	translation_danish: CE_ARRAY [PD_TRANSLATION]

	translation_dutch: CE_ARRAY [PD_TRANSLATION]

	translation_estonian: CE_ARRAY [PD_TRANSLATION]

	translation_finnish: CE_ARRAY [PD_TRANSLATION]

	translation_french: CE_ARRAY [PD_TRANSLATION]

	translation_galician: CE_ARRAY [PD_TRANSLATION]

	translation_german: CE_ARRAY [PD_TRANSLATION]

	translation_greek: CE_ARRAY [PD_TRANSLATION]

	translation_hungarian: CE_ARRAY [PD_TRANSLATION]

	translation_icelandic: CE_ARRAY [PD_TRANSLATION]

	translation_indonesian: CE_ARRAY [PD_TRANSLATION]

	translation_italian: CE_ARRAY [PD_TRANSLATION]

	translation_lithuanian: CE_ARRAY [PD_TRANSLATION]

	translation_norwegian: CE_ARRAY [PD_TRANSLATION]

	translation_polish: CE_ARRAY [PD_TRANSLATION]

	translation_portuguese: CE_ARRAY [PD_TRANSLATION]

	translation_romanian: CE_ARRAY [PD_TRANSLATION]

	translation_russian: CE_ARRAY [PD_TRANSLATION]

	translation_serbian: CE_ARRAY [PD_TRANSLATION]

	translation_slovak: CE_ARRAY [PD_TRANSLATION]

	translation_spanish: CE_ARRAY [PD_TRANSLATION]

	translation_swedish: CE_ARRAY [PD_TRANSLATION]

	translation_turkish: CE_ARRAY [PD_TRANSLATION]

	translation_ukrainian: CE_ARRAY [PD_TRANSLATION]

	translation_upper_sorbian: CE_ARRAY [PD_TRANSLATION]

	translations: CE_ARRAY [PD_TRANSLATION_DESC]

	translation_array: CE_ARRAY [CE_ARRAY [CE_POINTER [CE_POINTER [NATURAL_8]]]]

	current_lang_charset: INTEGER_32 assign set_current_lang_charset

	set_current_lang_charset (a_current_lang_charset: INTEGER_32)
		do
			current_lang_charset := a_current_lang_charset
		end

feature {ANY} -- routines

	init_trans
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			js: JUMP_STATE
		do
			l_i := 0
			from
			until
				not (not js.loop_left and then (l_i < 32))
			loop
				l_j := 0
				from
				until
					not (l_j < 27)
				loop
					(translation_array[l_i])[l_j] := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
			links_inst.current_language := 0
			current_lang_charset := 0
		end

	shutdown_trans
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			js: JUMP_STATE
		do
			l_i := 0
			from
			until
				not (not js.loop_left and then (l_i < 32))
			loop
				l_j := 0
				from
				until
					not (not js.loop_left and then (l_j < 27))
				loop
					if (((translation_array[l_i])[l_j]).c_pointer /= default_pointer) then
						l_k := 0
						from
						until
							not (l_k < 378)
						loop
							if ((((translation_array[l_i])[l_j])[l_k]).c_pointer /= default_pointer) then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("language.c")), 37, create {CE_POINTER [ANY]}.make_cast (((translation_array[l_i])[l_j])[l_k]))
							end
							l_k := l_k + 1
						end
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("language.c")), 38, create {CE_POINTER [ANY]}.make_cast ((translation_array[l_i])[l_j]))
					end
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
		end

	get_text_translation (a_text: CE_POINTER [NATURAL_8]; a_term: CE_POINTER [PD_TERMINAL]): CE_POINTER [NATURAL_8]
		local
			l_current_tra: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_conv_table: CE_POINTER [PD_CONV_TABLE]
			l_trn: CE_POINTER [NATURAL_8]
			l_ch: INTEGER_32
			l_tmp: INTEGER_32
			l_tt: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_tmp___3: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_current_tra.make
			create l_conv_table.make
			create l_trn.make
			create l_tt.make
			create l_tmp___1.make
			create l_tmp___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((a_term).c_pointer /= default_pointer) then
						l_tmp := (a_term.item.spec).item.charset
					else
						l_tmp := 0
					end
					l_ch := l_tmp
					if (a_text.c_pointer.to_integer_32).to_natural_32 < (links_inst.dummyarray.c_pointer.to_integer_32).to_natural_32 then
						Result := a_text
						js.return
					elseif (a_text.c_pointer.to_integer_32).to_natural_32 > ((links_inst.dummyarray + 378).c_pointer.to_integer_32).to_natural_32 then
						Result := a_text
						js.return
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						l_current_tra.ce_gets ((translation_array[links_inst.current_language])[l_ch])
						if (l_current_tra).c_pointer = default_pointer then
							l_pos := -1 + 5 -- skip if block
						end
				when 2 then -- if:
						l_trn.ce_gets (l_current_tra[(a_text.distance (links_inst.dummyarray))])
						if ((l_trn).c_pointer /= default_pointer) then
							Result := l_trn
							js.return
						end
						if js.return_called then
							l_pos := -1 + 4 -- skip if block
						end
				when 3 then -- if: | tr:
						l_tt.ce_gets ((translations[links_inst.current_language].t + (a_text.distance (links_inst.dummyarray))).item.name)
						if ((l_tt).c_pointer /= default_pointer) then
							l_conv_table.ce_gets (charsets_inst.get_translation_table (current_lang_charset, l_ch))
							l_trn.ce_gets (charsets_inst.convert_string (l_conv_table, l_tt, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tt))).to_integer_32))
						else
							l_trn.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("language.c")), 54, translation_english[a_text.distance (links_inst.dummyarray)].name))
						end
						l_current_tra[(a_text.distance (links_inst.dummyarray))] := l_trn
				when 4 then -- if done | if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if current_lang_charset.to_boolean then
							if l_ch /= current_lang_charset then
								l_tmp___1.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("language.c")), 62, Pointer_bytes.to_natural_32 * {NATURAL_32} 378))));
								(translation_array[links_inst.current_language])[l_ch] := l_tmp___1
								l_current_tra.ce_gets (l_tmp___1)
								memset (create {CE_POINTER [ANY]}.make_cast (l_current_tra), 0, Pointer_bytes.to_natural_32 * {NATURAL_32} 378).do_nothing
								l_pos := -1 + 3 -- goto tr
							end
						end
				when 6 then
						l_trn.ce_gets ((translations[links_inst.current_language].t + (a_text.distance (links_inst.dummyarray))).item.name)
						if (l_trn).c_pointer = default_pointer then
							l_tmp___3.ce_gets (translation_english[a_text.distance (links_inst.dummyarray)].name);
							(translations[links_inst.current_language].t + (a_text.distance (links_inst.dummyarray))).item.name := l_tmp___3
							l_trn.ce_gets (l_tmp___3)
						end
				when 7 then -- if done | if done
						if not js.return_called then
							Result := l_trn
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	get_english_translation (a_text: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			js: JUMP_STATE
		do
			if (a_text.c_pointer.to_integer_32).to_natural_32 < (links_inst.dummyarray.c_pointer.to_integer_32).to_natural_32 then
				Result := a_text
				js.return
			elseif (a_text.c_pointer.to_integer_32).to_natural_32 > ((links_inst.dummyarray + 378).c_pointer.to_integer_32).to_natural_32 then
				Result := a_text
				js.return
			end
			if not js.return_called then
				Result := (translation_english[a_text.distance (links_inst.dummyarray)].name)
			end
		end

	n_languages: INTEGER_32
		do
			Result := 32
		end

	language_name (a_l: INTEGER_32): CE_POINTER [NATURAL_8]
		do
			Result := ((translations[a_l].t + 2).item.name)
		end

	set_language (a_l: INTEGER_32)
		local
			l_i: INTEGER_32
			l_cp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_cp.make

			l_i := 0
			from
			until
				not (not js.loop_left and then (l_i < 378))
			loop
				if (translations[a_l].t + l_i).item.code /= l_i then
					from
					until
						False
					loop
						links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("language.c")))
						links_inst.errline := 94
						error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bad table for language %%s. Run script synclang.")), (translations[a_l].t + 2).item.name])
					end
					js.return
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				links_inst.current_language := a_l
				l_cp.ce_gets ((translations[a_l].t + 1).item.name)
				l_i := charsets_inst.get_cp_index (l_cp)
				if l_i = -1 then
					from
					until
						False
					loop
						links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("language.c")))
						links_inst.errline := 101
						error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Unknown charset for language %%s.")), (translations[a_l].t + 2).item.name])
					end
					l_i := 0
				end
				current_lang_charset := l_i
			end
		end

end
