class
	P_MAIN

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create terminal_pipe.make (<<2>>)
			create dump_stat.make
		end

feature {ANY} -- attributes

	retval: INTEGER_32 assign set_retval

	set_retval (a_retval: INTEGER_32)
		do
			retval := a_retval
		end

	fg_poll_timer: INTEGER_32 assign set_fg_poll_timer

	set_fg_poll_timer (a_fg_poll_timer: INTEGER_32)
		do
			fg_poll_timer := a_fg_poll_timer
		end

	terminal_pipe: CE_ARRAY [INTEGER_32]

	dump_stat: PD_STATUS

	dump_pos: INTEGER_32 assign set_dump_pos

	set_dump_pos (a_dump_pos: INTEGER_32)
		do
			dump_pos := a_dump_pos
		end

	dump_red_count: INTEGER_32 assign set_dump_red_count

	set_dump_red_count (a_dump_red_count: INTEGER_32)
		do
			dump_red_count := a_dump_red_count
		end

	init_b: INTEGER_32 assign set_init_b

	set_init_b (a_init_b: INTEGER_32)
		do
			init_b := a_init_b
		end

feature {ANY} -- routines

	sig_terminate (a_t: CE_POINTER [PD_TERMINAL])
		do
			unhandle_basic_signals (a_t)
			select_inst.terminate := 1
			retval := 2
		end

	sig_intr (a_t: CE_POINTER [PD_TERMINAL])
		do
			if (a_t).c_pointer = default_pointer then
				unhandle_basic_signals (a_t)
				select_inst.terminate := 1
			else
				unhandle_basic_signals (a_t)
				menu_inst.exit_prog (a_t, create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_POINTER [PD_SESSION]}.make_shared (default_pointer))
			end
		end

	sig_intr_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent sig_intr)
		end

	sig_ctrl_c (a_t: CE_POINTER [PD_TERMINAL])
		do
			if not (kbd_inst.is_blocked).to_boolean then
				kbd_inst.kbd_ctrl_c
			end
		end

	sig_ctrl_c_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent sig_ctrl_c)
		end

	sig_ign (a_x: CE_POINTER [ANY])
		do
		end

	sig_ign_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent sig_ign)
		end

	sig_tstp (a_t: CE_POINTER [PD_TERMINAL])
		local
			l_pid: INTEGER_32
			l_newpid: INTEGER_32
		do
			l_pid := (getpid)
			kbd_inst.block_itrm (1)
			l_newpid := fork
			if not l_newpid.to_boolean then
				from
				until
					False
				loop
					sleep ({NATURAL_32} 1).do_nothing
					kill (l_pid, 18).do_nothing
				end
			end
			raise (19).do_nothing
			if l_newpid /= -1 then
				kill (l_newpid, 9).do_nothing
			end
			if fg_poll_timer /= -1 then
				select_inst.kill_timer (fg_poll_timer)
			end
			fg_poll_timer := select_inst.install_timer ((500).to_integer_32, poll_fg_address, create {CE_POINTER [ANY]}.make_cast (a_t))
		end

	sig_tstp_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent sig_tstp)
		end

	poll_fg (a_t: CE_POINTER [ANY])
		local
			l_r: INTEGER_32
		do
			fg_poll_timer := -1
			l_r := kbd_inst.unblock_itrm (1)
			if l_r = -1 then
				fg_poll_timer := select_inst.install_timer ((500).to_integer_32, poll_fg_address, a_t)
			end
			if l_r = -2 then
				kill (0, 18).do_nothing
			end
		end

	poll_fg_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent poll_fg)
		end

	sig_cont (a_t: CE_POINTER [PD_TERMINAL])
		do
			kbd_inst.unblock_itrm (1).do_nothing
		end

	sig_cont_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent sig_cont)
		end

	handle_basic_signals (a_term: CE_POINTER [PD_TERMINAL])
		do
			select_inst.install_signal_handler (1, (sig_intr_address), create {CE_POINTER [ANY]}.make_cast (a_term), 0)
			select_inst.install_signal_handler (2, (sig_ctrl_c_address), create {CE_POINTER [ANY]}.make_cast (a_term), 0)
			select_inst.install_signal_handler (20, (sig_tstp_address), create {CE_POINTER [ANY]}.make_cast (a_term), 0)
			select_inst.install_signal_handler (21, (sig_tstp_address), create {CE_POINTER [ANY]}.make_cast (a_term), 0)
			select_inst.install_signal_handler (22, sig_ign_address, create {CE_POINTER [ANY]}.make_cast (a_term), 0)
			select_inst.install_signal_handler (18, (sig_cont_address), create {CE_POINTER [ANY]}.make_cast (a_term), 0)
		end

	unhandle_terminal_signals (a_term: CE_POINTER [PD_TERMINAL])
		do
			select_inst.install_signal_handler (1, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
			select_inst.install_signal_handler (2, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
			select_inst.install_signal_handler (20, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
			select_inst.install_signal_handler (21, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
			select_inst.install_signal_handler (22, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
			select_inst.install_signal_handler (18, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
			if fg_poll_timer /= -1 then
				select_inst.kill_timer (fg_poll_timer)
				fg_poll_timer := -1
			end
		end

	unhandle_basic_signals (a_term: CE_POINTER [PD_TERMINAL])
		do
			select_inst.install_signal_handler (1, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
			select_inst.install_signal_handler (2, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
			select_inst.install_signal_handler (20, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
			select_inst.install_signal_handler (21, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
			select_inst.install_signal_handler (22, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
			select_inst.install_signal_handler (18, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
			if fg_poll_timer /= -1 then
				select_inst.kill_timer (fg_poll_timer)
				fg_poll_timer := -1
			end
		end

	attach_terminal (a_in: INTEGER_32; a_out: INTEGER_32; a_ctl: INTEGER_32; a_info: CE_POINTER [ANY]; a_len: INTEGER_32): INTEGER_32
		local
			l_term: CE_POINTER [PD_TERMINAL]
			js: JUMP_STATE
		do
			create l_term.make

			fcntl ([terminal_pipe[0], 4, 2048]).do_nothing
			fcntl ([terminal_pipe[1], 4, 2048]).do_nothing
			kbd_inst.handle_trm (a_in, a_out, a_out, terminal_pipe[1], a_ctl, a_info, a_len)
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("main.c")), 150, a_info)
			l_term.ce_gets (terminal_inst.init_term (terminal_pipe[0], a_out, session_inst.win_func_address))
			if ((l_term).c_pointer /= default_pointer) then
				handle_basic_signals (l_term)
				Result := (terminal_pipe[1])
				js.return
			end
			if not js.return_called then
				close (terminal_pipe[0]).do_nothing
				close (terminal_pipe[1]).do_nothing
				Result := (-1)
			end
		end

	end_dump (a_stat___0: CE_POINTER [PD_STATUS]; a_p: CE_POINTER [ANY])
		local
			l_ce: CE_POINTER [PD_CACHE_ENTRY]
			l_oh: INTEGER_32
			l_u: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_frag: CE_POINTER [PD_FRAGMENT]
			l_l: INTEGER_32
			l_w: INTEGER_32
			l_o: PD_DOCUMENT_OPTIONS
			l_vs: CE_POINTER [PD_VIEW_STATE]
			l_fd: PD_F_DATA_C
			l_m: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ce.make
			create l_u.make
			create l_p___0.make
			create l_frag.make
			create l_o.make
			create l_vs.make
			create l_fd.make
			create l_m.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ce.ce_gets (a_stat___0.item.ce)
					l_oh := (os_dep_inst.get_output_handle)
					if l_oh = -1 then
						js.return
					end
					if not js.return_called and then ((l_ce).c_pointer /= default_pointer) then
						if ((l_ce.item.redirect).c_pointer /= default_pointer) then
							l_tmp___1 := dump_red_count
							dump_red_count := dump_red_count + 1
							if l_tmp___1 < 10 then
								if a_stat___0.item.state >= 0 then
									sched_inst.change_connection (a_stat___0, create {CE_POINTER [PD_STATUS]}.make_shared (default_pointer), 5)
								end
								l_u.ce_gets (url_inst.join_urls (l_ce.item.url, l_ce.item.redirect))
								if not (default_inst.http_bugs.bug_302_redirect).to_boolean then
									if not (l_ce.item.redirect_get).to_boolean then
										l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_ce.item.url), 1))))
										if ((l_p___0).c_pointer /= default_pointer) then
											links_inst.add_to_strn (l_u.address, l_p___0)
										end
									end
								end
								sched_inst.load_url (l_u, a_stat___0, 0, 0).do_nothing
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("main.c")), 176, create {CE_POINTER [ANY]}.make_cast (l_u))
								js.return
							end
						end
					end
					if not js.return_called and then (a_stat___0.item.state >= 0) then
						if a_stat___0.item.state < 8 then
							js.return
						end
					end
					if not js.return_called and then (a_stat___0.item.state >= 8) then
						if default_inst.dmp /= 2 then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						if default_inst.dmp /= 2 then
							l_pos := -1 + 12 -- skip if block
						end
				when 2 then -- if:
						if (l_ce).c_pointer = default_pointer then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if: | nextfrag:
						l_frag.ce_gets (create {CE_POINTER [PD_FRAGMENT]}.make_cast (l_ce.item.frag.next))
				when 4 then -- loop condition:
						if (l_frag.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_ce.c_pointer + {PD_CACHE_ENTRY}.frag_offset)).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 10 -- skip loop
						end
				when 5 then -- loop body:
						if not (l_frag.item.offset <= dump_pos) then
							l_pos := -1 + 9 -- skip if block
						end
				when 6 then -- if:
						if not (l_frag.item.offset + l_frag.item.length > dump_pos) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_l := (l_frag.item.length - (dump_pos - l_frag.item.offset)).to_integer_32
						l_w := (terminal_inst.hard_write (l_oh, (l_frag.item.data + dump_pos) - l_frag.item.offset, l_l))
						if l_w /= l_l then
							sched_inst.detach_connection (a_stat___0, dump_pos)
							if l_w < 0 then
								Io.error.put_string ("Error writing to stdout: " + eif_string ((strerror ((errno_location).item))) + ".%N")
							else
								Io.error.put_string ("Can%'t write to stdout.%N")
							end
							retval := 1
							l_pos := -1 + 15 -- goto terminate
						end
				when 8 then
						dump_pos := dump_pos + l_w.to_integer_32
						sched_inst.detach_connection (a_stat___0, dump_pos)
						l_pos := -1 + 3 -- goto nextfrag
				when 9 then -- if done
						l_frag.ce_gets (l_frag.item.next)
						l_pos := -1 + 4 -- back to loop condition
				when 10 then -- loop done | if done
						if a_stat___0.item.state >= 0 then
							js.return
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						if ((l_ce).c_pointer /= default_pointer) then
							l_vs.ce_gets (create {CE_POINTER [PD_VIEW_STATE]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("main.c")), 205, ({PD_VIEW_STATE}.sizeof.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((a_stat___0.item.ce).item.url)))) + {NATURAL_32} 1))))
							memset (create {CE_POINTER [ANY]}.make_cast ((l_o.address)), 0, {PD_DOCUMENT_OPTIONS}.sizeof.to_natural_32).do_nothing
							memset (create {CE_POINTER [ANY]}.make_cast (l_vs), 0, {PD_VIEW_STATE}.sizeof.to_natural_32).do_nothing
							memset (create {CE_POINTER [ANY]}.make_cast ((l_fd.address)), 0, {PD_F_DATA_C}.sizeof.to_natural_32).do_nothing
							l_o.xp := 0
							l_o.yp := 1
							l_o.xw := default_inst.screen_width
							l_o.yw := 25
							l_o.col := 0
							if default_inst.dump_codepage = -1 then
								l_o.cp := 0
							else
								l_o.cp := default_inst.dump_codepage
							end
							links_inst.ds2do (default_inst.dds.address, l_o.address)
							l_o.plain := 0
							l_o.frames := 0
							memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_RGB]}.make_shared (l_o.c_pointer + {PD_DOCUMENT_OPTIONS}.default_fg_offset))), create {CE_POINTER [ANY]}.make_cast ((default_inst.default_fg.address)), {PD_RGB}.sizeof.to_natural_32).do_nothing
							memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_RGB]}.make_shared (l_o.c_pointer + {PD_DOCUMENT_OPTIONS}.default_bg_offset))), create {CE_POINTER [ANY]}.make_cast ((default_inst.default_bg.address)), {PD_RGB}.sizeof.to_natural_32).do_nothing
							memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_RGB]}.make_shared (l_o.c_pointer + {PD_DOCUMENT_OPTIONS}.default_link_offset))), create {CE_POINTER [ANY]}.make_cast ((default_inst.default_link.address)), {PD_RGB}.sizeof.to_natural_32).do_nothing
							memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_RGB]}.make_shared (l_o.c_pointer + {PD_DOCUMENT_OPTIONS}.default_vlink_offset))), create {CE_POINTER [ANY]}.make_cast ((default_inst.default_vlink.address)), {PD_RGB}.sizeof.to_natural_32).do_nothing
							l_o.framename := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
							view_inst.init_vs (l_vs, (a_stat___0.item.ce).item.url)
							html_r_inst.cached_format_html (l_vs, l_fd.address, l_o.address)
							view_inst.dump_to_file (l_fd.f_data, l_oh).do_nothing
							view_inst.detach_formatted (l_fd.address)
							view_inst.destroy_vs (l_vs)
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("main.c")), 228, create {CE_POINTER [ANY]}.make_cast (l_vs))
						end
				when 13 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
							if a_stat___0.item.state /= -1000 then
								l_m.ce_gets ((session_inst.get_err_msg (a_stat___0.item.state)))
								Io.error.put_string (eif_string (create {CE_POINTER [INTEGER_8]}.make_shared ((language_inst.get_english_translation (l_m)).c_pointer)) + "%N")
								retval := 1
								l_pos := -1 + 15 -- goto terminate
							end
				when 15 then -- terminate:
							select_inst.terminate := 1
				when 16 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	end_dump_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent end_dump)
		end

	init
		local
			l_uh: INTEGER_32
			l_info: CE_POINTER [ANY]
			l_len: INTEGER_32
			l_u: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_uu: CE_POINTER [NATURAL_8]
			l_wd: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_info.make
			create l_u.make
			create l_uu.make
			create l_wd.make
			create l_tmp___7.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					language_inst.init_trans
					select_inst.set_sigcld
					default_inst.init_home
					cache_inst.init_cache
					kbdbind_inst.init_keymaps
					if (os_dep_inst.c2_pipe (terminal_pipe)).to_boolean then
						error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: can%'t create pipe for internal communication"))])
						retval := 4
						l_pos := -1 + 8 -- goto ttt
					end
				when 1 then
					l_u.ce_gets (default_inst.parse_options (links_inst.g_argc - 1, links_inst.g_argv + 1))
					if (l_u).c_pointer = default_pointer then
						retval := 3
						l_pos := -1 + 8 -- goto ttt
					end
				when 2 then
					if default_inst.no_connect.to_boolean then
						l_pos := -1 + 6 -- skip if block
					end
				when 3 then -- if:
						l_uh := af_unix_inst.bind_to_af_unix
						if l_uh = -1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						close (terminal_pipe[0]).do_nothing
						close (terminal_pipe[1]).do_nothing
						l_info.ce_gets (session_inst.create_session_info (default_inst.base_session, l_u, create {CE_POINTER [INTEGER_32]}.make_shared ($l_len)))
						if (l_info).c_pointer = default_pointer then
							retval := 4
							l_pos := -1 + 8 -- goto ttt
						end
				when 5 then
						l_tmp___0 := os_dep_inst.get_ctl_handle
						l_tmp___1 := os_dep_inst.get_output_handle
						kbd_inst.handle_trm ((os_dep_inst.get_input_handle), l_tmp___1, l_uh, l_uh, l_tmp___0, l_info, l_len)
						handle_basic_signals (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("main.c")), 279, l_info)
						js.return
				when 6 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
							default_inst.dds.assume_cp := charsets_inst.get_cp_index (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ISO-8859-1")))
							if default_inst.dds.assume_cp = -1 then
								default_inst.dds.assume_cp := 0
							end
							default_inst.load_config
							init_b := 1
							bookmark_inst.read_bookmarks
							default_inst.load_url_history
							cookies_inst.init_cookies
							l_u.ce_gets (default_inst.parse_options (links_inst.g_argc - 1, links_inst.g_argv + 1))
							if ((l_u).c_pointer /= default_pointer) then
								l_pos := -1 + 9 -- skip if block
							end
				when 8 then -- if: | ttt:
							select_inst.terminate := 1
							js.return
				when 9 then -- if done | if done
							if js.return_called then
								l_pos := -1 + 16 -- skip if block
							end
				when 10 then -- if:
								if default_inst.dmp.to_boolean then
									l_pos := -1 + 13 -- skip if block
								end
				when 11 then -- if:
								l_info.ce_gets (session_inst.create_session_info (default_inst.base_session, l_u, create {CE_POINTER [INTEGER_32]}.make_shared ($l_len)))
								if ((l_info).c_pointer /= default_pointer) then
									l_tmp___3 := os_dep_inst.get_ctl_handle
									l_tmp___4 := os_dep_inst.get_output_handle
									if (attach_terminal ((os_dep_inst.get_input_handle), l_tmp___4, l_tmp___3, l_info, l_len)) = -1 then
										retval := 4
										select_inst.terminate := 1
									end
								else
									retval := 4
									select_inst.terminate := 1
								end
				when 12 then -- if block done, skip else block:
								l_pos := -1 + 16
				when 13 then -- else:
								close (terminal_pipe[0]).do_nothing
								close (terminal_pipe[1]).do_nothing
								if not (l_u.item).to_boolean then
									if default_inst.dmp = 1 then
										l_tmp___7.ce_gets (ce_string ("-dump"))
									else
										l_tmp___7.ce_gets (ce_string ("-source"))
									end
									Io.error.put_string ("URL expected after " + eif_string (l_tmp___7) + "%N.")
									retval := 3
									l_pos := -1 + 8 -- goto ttt
								end
				when 14 then
								dump_stat.end2 := end_dump_address
								dump_pos := (0).to_integer_32
								l_wd.ce_gets (terminal_inst.get_cwd)
								l_uu.ce_gets (url_inst.translate_url (l_u, l_wd))
								if (l_uu).c_pointer = default_pointer then
									l_uu.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("main.c")), 310, l_u))
								end
								if (sched_inst.load_url (l_uu, dump_stat.address, 0, 0)).to_boolean then
									retval := 4
									l_pos := -1 + 8 -- goto ttt
								end
				when 15 then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("main.c")), 315, create {CE_POINTER [ANY]}.make_cast (l_uu))
								if ((l_wd).c_pointer /= default_pointer) then
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("main.c")), 316, create {CE_POINTER [ANY]}.make_cast (l_wd))
								end
				when 16 then -- if done
								l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
					end

	init_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent init)
		end

	terminate_all_subsystems
		do
			af_unix_inst.af_unix_close
			session_inst.destroy_all_sessions
			select_inst.check_bottom_halves
			session_inst.abort_all_downloads
			select_inst.check_bottom_halves
			terminal_inst.destroy_all_terminals
			select_inst.check_bottom_halves
			kbd_inst.free_all_itrms
			sched_inst.abort_all_connections
			shrink_memory (1)
			if init_b.to_boolean then
				default_inst.save_url_history
			end
			menu_inst.free_history_lists
			terminal_inst.free_term_specs
			types_inst.free_types
			if init_b.to_boolean then
				bookmark_inst.finalize_bookmarks
			end
			kbdbind_inst.free_keymaps
			charsets_inst.free_conv_table
			sched_inst.free_blacklist
			if init_b.to_boolean then
				cookies_inst.cleanup_cookies
			end
			select_inst.check_bottom_halves
			default_inst.end_config
			session_inst.free_strerror_buf
			language_inst.shutdown_trans
			os_dep_inst.terminate_osdep
		end

	main (a_argc: INTEGER_32; a_argv: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			links_inst.path_to_exe.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (a_argv[0]))
			links_inst.g_argc := a_argc
			links_inst.g_argv.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (a_argv))
			os_dep_inst.get_path_to_exe
			select_inst.select_loop (init_address)
			terminate_all_subsystems
			if fg_poll_timer /= -1 then
				select_inst.kill_timer (fg_poll_timer)
				fg_poll_timer := -1
			end
			error_inst.check_memory_leaks
			Result := retval
		end

	shrink_memory (a_u: INTEGER_32)
		do
			dns_inst.shrink_dns_cache (a_u)
			html_r_inst.shrink_format_cache (a_u)
			cache_inst.garbage_collection (a_u)
			html_r_inst.delete_unused_format_cache_entries
		end

end
