class
	P_OS_DEP

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create oinw.make (<<4>>)
		end

feature {ANY} -- attributes

	xt: INTEGER_32 assign set_xt

	set_xt (a_xt: INTEGER_32)
		do
			xt := a_xt
		end

	xt___0: INTEGER_32 assign set_xt___0

	set_xt___0 (a_xt___0: INTEGER_32)
		do
			xt___0 := a_xt___0
		end

	resize_count: NATURAL_32 assign set_resize_count

	set_resize_count (a_resize_count: NATURAL_32)
		do
			resize_count := a_resize_count
		end

	oinw: CE_ARRAY [PD_OINW]

feature {ANY} -- routines

	dir_sep (a_x: INTEGER_8): INTEGER_32
		do
			Result := (a_x.to_integer_32 = 47).to_integer
		end

	is_safe_in_shell (a_c: NATURAL_8): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_c.to_integer_32 /= 64 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_tmp := 1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 3 then -- else:
						if a_c.to_integer_32 /= 43 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_tmp := 1
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 6 then -- else:
						if a_c.to_integer_32 /= 45 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_tmp := 1
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 9 then -- else:
						if a_c.to_integer_32 /= 46 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_tmp := 1
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 12 then -- else:
						if a_c.to_integer_32 /= 44 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_tmp := 1
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 15 then -- else:
						if a_c.to_integer_32 /= 61 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_tmp := 1
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 18 then -- else:
						if not (a_c.to_integer_32 >= 48) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if a_c.to_integer_32 <= 57 then
							l_tmp := 1
						else
							l_pos := -1 + 21 -- goto _L___0
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 21 then -- else: | _L___0:
						if not (a_c.to_integer_32 >= 65) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if a_c.to_integer_32 <= 90 then
							l_tmp := 1
						else
							l_pos := -1 + 24 -- goto _L
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else: | _L:
						if a_c.to_integer_32 = 95 then
							l_tmp := 1
						elseif a_c.to_integer_32 >= 97 then
							if a_c.to_integer_32 <= 122 then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
				when 25 then -- if done | if done | if done | if done | if done | if done | if done
						Result := l_tmp
				when 26 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	is_safe_in_url (a_c: NATURAL_8): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (is_safe_in_shell (a_c)).to_boolean then
				l_tmp___0 := 1
			elseif a_c.to_integer_32 = 58 then
				l_tmp___0 := 1
			elseif a_c.to_integer_32 = 47 then
				l_tmp___0 := 1
			elseif a_c.to_integer_32 >= 128 then
				l_tmp___0 := 1
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	check_shell_security (a_cmd: CE_POINTER [CE_POINTER [NATURAL_8]])
		local
			l_c: CE_POINTER [NATURAL_8]
		do
			create l_c.make

			l_c.ce_gets (a_cmd.item)
			from
			until
				not ((l_c.item).to_boolean)
			loop
				if not (is_safe_in_shell (l_c.item)).to_boolean then
					l_c.item := (('_').code).to_natural_8
				end
				l_c.ce_gets (l_c + 1)
			end
		end

	check_shell_url (a_url: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_url: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_url.make

			l_url.ce_gets (a_url)
			from
			until
				not (not js.loop_left and then ((l_url.item).to_boolean))
			loop
				if not (is_safe_in_url (l_url.item)).to_boolean then
					Result := (-1)
					js.return
				end
				if not js.return_called then
					l_url.ce_gets (l_url + 1)
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	escape_path (a_path: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_result: CE_POINTER [NATURAL_8]
			l_i: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_result.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (a_path), ('%"').code))).c_pointer /= default_pointer) then
						Result := (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("os_dep.c")), 47, a_path))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_i := (0).to_natural_32
				when 2 then -- loop condition:
						if not ((a_path[l_i.to_integer_32]).to_boolean) then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						if not (is_safe_in_url (a_path[l_i.to_integer_32])).to_boolean then
							l_pos := -1 + 7 -- goto do_esc
						end
				when 4 then
						l_i := l_i + 1
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
						Result := (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("os_dep.c")), 49, a_path))
						js.return
				when 6 then -- if done
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 7 then -- if: | do_esc:
						l_result.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("os_dep.c")), 51, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%""))))
						links_inst.add_to_strn (l_result.address, a_path)
						links_inst.add_to_strn (l_result.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%"")))
						Result := l_result
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_e (a_env: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_v: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_v.make

			l_v.ce_gets (getenv (a_env))
			if ((l_v).c_pointer /= default_pointer) then
				Result := (atoi (l_v))
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	sigwinch (a_s: CE_POINTER [ANY])
		do
			(create {CE_ROUTINE}.make_cast (a_s)).call ([])
		end

	sigwinch_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent sigwinch)
		end

	handle_terminal_resize (a_fd: INTEGER_32; a_fn: CE_ROUTINE)
		do
			select_inst.install_signal_handler (28, sigwinch_address, create {CE_POINTER [ANY]}.make_cast (a_fn), 0)
		end

	unhandle_terminal_resize (a_fd: INTEGER_32)
		do
			select_inst.install_signal_handler (28, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
		end

	get_terminal_size (a_fd: INTEGER_32; a_x: CE_POINTER [INTEGER_32]; a_y: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_ws: SD_WINSIZE
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
		do
			create l_ws.make

			if (a_x).c_pointer = default_pointer then
				Result := (-1)
				js.return
			elseif (a_y).c_pointer = default_pointer then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				if (ioctl ([1, {NATURAL_32} 21523, l_ws.address])) /= -1 then
					l_tmp := (l_ws.ws_col).to_integer_32
					a_x.item := l_tmp
					if not l_tmp.to_boolean then
						l_tmp___0 := get_e (ce_string ("COLUMNS"))
						a_x.item := l_tmp___0
						if not l_tmp___0.to_boolean then
							a_x.item := 80
						end
					end
					l_tmp___1 := (l_ws.ws_row).to_integer_32
					a_y.item := l_tmp___1
					if not l_tmp___1.to_boolean then
						l_tmp___2 := get_e (ce_string ("LINES"))
						a_y.item := l_tmp___2
						if not l_tmp___2.to_boolean then
							a_y.item := 24
						end
					end
					Result := 0
					js.return
				else
					l_tmp___3 := get_e (ce_string ("COLUMNS"))
					a_x.item := l_tmp___3
					if not l_tmp___3.to_boolean then
						a_x.item := 80
					end
					l_tmp___4 := get_e (ce_string ("LINES"))
					a_y.item := l_tmp___4
					if not l_tmp___4.to_boolean then
						a_y.item := 24
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	set_bin (a_fd: INTEGER_32)
		do
		end

	c2_pipe (a_fd: CE_POINTER [INTEGER_32]): INTEGER_32
		do
			Result := (pipe (a_fd))
		end

	check_file_name (a_file: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := 1
		end

	can_twterm: INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if xt = -1 then
				if (((getenv (ce_string ("TWDISPLAY")))).c_pointer /= default_pointer) then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
				xt := l_tmp___0
			end
			Result := xt
		end

	is_xterm: INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if xt___0 = -1 then
				if (((getenv (ce_string ("DISPLAY")))).c_pointer /= default_pointer) then
					if ((getenv (ce_string ("DISPLAY")))[0]).to_boolean then
						l_tmp___1 := 1
					else
						l_tmp___1 := 0
					end
				else
					l_tmp___1 := 0
				end
				xt___0 := l_tmp___1
			end
			Result := xt___0
		end

	close_fork_tty
		local
			l_t: CE_POINTER [PD_TERMINAL]
			l_d: CE_POINTER [PD_DOWNLOAD]
			l_c: CE_POINTER [PD_CONNECTION]
			l_k: CE_POINTER [PD_K_CONN]
		do
			create l_t.make
			create l_d.make
			create l_c.make
			create l_k.make

			l_t.ce_gets (create {CE_POINTER [PD_TERMINAL]}.make_cast (terminal_inst.terminals.next))
			from
			until
				(l_t.c_pointer.to_integer_32).to_natural_32 = ((terminal_inst.terminals.address).c_pointer.to_integer_32).to_natural_32
			loop
				if l_t.item.fdin > 0 then
					close (l_t.item.fdin).do_nothing
				end
				l_t.ce_gets (l_t.item.next)
			end
			l_d.ce_gets (create {CE_POINTER [PD_DOWNLOAD]}.make_cast (session_inst.downloads.next))
			from
			until
				(l_d.c_pointer.to_integer_32).to_natural_32 = ((session_inst.downloads.address).c_pointer.to_integer_32).to_natural_32
			loop
				if l_d.item.handle > 0 then
					close (l_d.item.handle).do_nothing
				end
				l_d.ce_gets (l_d.item.next)
			end
			l_c.ce_gets (create {CE_POINTER [PD_CONNECTION]}.make_cast (sched_inst.queue.next))
			from
			until
				(l_c.c_pointer.to_integer_32).to_natural_32 = ((sched_inst.queue.address).c_pointer.to_integer_32).to_natural_32
			loop
				connect_inst.close_socket (create {CE_POINTER [INTEGER_32]}.make_shared (l_c.c_pointer + {PD_CONNECTION}.sock1_offset))
				connect_inst.close_socket (create {CE_POINTER [INTEGER_32]}.make_shared (l_c.c_pointer + {PD_CONNECTION}.sock2_offset))
				l_c.ce_gets (l_c.item.next)
			end
			l_k.ce_gets (create {CE_POINTER [PD_K_CONN]}.make_cast (sched_inst.keepalive_connections.next))
			from
			until
				(l_k.c_pointer.to_integer_32).to_natural_32 = ((sched_inst.keepalive_connections.address).c_pointer.to_integer_32).to_natural_32
			loop
				close (l_k.item.conn).do_nothing
				l_k.ce_gets (l_k.item.next)
			end
		end

	get_path_to_exe
		do
			links_inst.path_to_exe.ce_gets (links_inst.g_argv[0])
		end

	exe (a_path: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			signal (20, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
			signal (18, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
			signal (28, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
			Result := (system (a_path))
		end

	get_clipboard_text: CE_POINTER [INTEGER_8]
		do
			Result := (create {CE_POINTER [INTEGER_8]}.make_cast ((links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("os_dep.c")), 470, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))))))
		end

	set_clipboard_text (a_data: CE_POINTER [INTEGER_8])
		do
		end

	set_window_title (a_title: CE_POINTER [NATURAL_8])
		do
		end

	get_window_title: CE_POINTER [NATURAL_8]
		do
			Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
		end

	resize_window (a_x: INTEGER_32; a_y: INTEGER_32): INTEGER_32
		do
			Result := (-1)
		end

	terminate_osdep
		do
		end

	block_stdin
		do
		end

	unblock_stdin
		do
		end

	start_thread (a_fn: CE_ROUTINE; a_ptr: CE_POINTER [ANY]; a_l: INTEGER_32): INTEGER_32
		local
			l_p: CE_ARRAY [INTEGER_32]
			l_f: INTEGER_32
			js: JUMP_STATE
		do
			create l_p.make (<<2>>)

			if (c2_pipe (l_p)) < 0 then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				fcntl ([l_p[0], 4, 2048]).do_nothing
				fcntl ([l_p[1], 4, 2048]).do_nothing
				l_f := fork
				if not l_f.to_boolean then
					close_fork_tty
					close (l_p[0]).do_nothing
					a_fn.call ([a_ptr, l_p[1]])
					write (l_p[1], create {CE_POINTER [ANY]}.make_cast (ce_string ("x")), (1).to_natural_32).do_nothing
					close (l_p[1]).do_nothing
					exit2 (0)
				end
				if l_f = -1 then
					close (l_p[0]).do_nothing
					close (l_p[1]).do_nothing
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				close (l_p[1]).do_nothing
				Result := (l_p[0])
			end
		end

	want_draw
		do
		end

	done_draw
		do
		end

	get_output_handle: INTEGER_32
		do
			Result := 1
		end

	get_ctl_handle: INTEGER_32
		do
			Result := 0
		end

	get_input_handle: INTEGER_32
		do
			Result := 0
		end

	os_cfmakeraw (a_t: CE_POINTER [SD_TERMIOS])
		do
			cfmakeraw (a_t)
			a_t.item.c2_cc[6] := (1).to_natural_8
		end

	handle_mouse (a_cons: INTEGER_32; a_fn: CE_ROUTINE; a_data: CE_POINTER [ANY]): CE_POINTER [ANY]
		do
			Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
		end

	unhandle_mouse (a_data: CE_POINTER [ANY])
		do
		end

	get_system_env: INTEGER_32
		do
			Result := 0
		end

	exec_new_links (a_term: CE_POINTER [PD_TERMINAL]; a_xterm: CE_POINTER [NATURAL_8]; a_exe___0: CE_POINTER [NATURAL_8]; a_param: CE_POINTER [NATURAL_8])
		local
			l_str: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
		do
			create l_str.make

			l_tmp := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_xterm))
			l_tmp___0 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_exe___0))
			l_str.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("os_dep.c")), 1649, ((((l_tmp + {NATURAL_32} 1) + l_tmp___0) + {NATURAL_32} 1) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_param)))) + {NATURAL_32} 1))))
			if (a_xterm.item).to_boolean then
				sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_str), ce_string ("%%s %%s %%s"), a_xterm, a_exe___0, a_param]).do_nothing
			else
				sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_str), ce_string ("%%s %%s"), a_exe___0, a_param]).do_nothing
			end
			terminal_inst.exec_on_terminal (a_term, l_str, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 2)
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("os_dep.c")), 1653, create {CE_POINTER [ANY]}.make_cast (l_str))
		end

	open_in_new_twterm (a_term: CE_POINTER [PD_TERMINAL]; a_exe___0: CE_POINTER [NATURAL_8]; a_param: CE_POINTER [NATURAL_8])
		local
			l_twterm: CE_POINTER [NATURAL_8]
		do
			create l_twterm.make

			l_twterm.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((getenv (ce_string ("LINKS_TWTERM")))))
			if (l_twterm).c_pointer = default_pointer then
				l_twterm.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("twterm -e")))
			end
			exec_new_links (a_term, l_twterm, a_exe___0, a_param)
		end

	open_in_new_twterm_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent open_in_new_twterm)
		end

	open_in_new_xterm (a_term: CE_POINTER [PD_TERMINAL]; a_exe___0: CE_POINTER [NATURAL_8]; a_param: CE_POINTER [NATURAL_8])
		local
			l_xterm: CE_POINTER [NATURAL_8]
		do
			create l_xterm.make

			l_xterm.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((getenv (ce_string ("LINKS_XTERM")))))
			if (l_xterm).c_pointer = default_pointer then
				l_xterm.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("xterm -e")))
			end
			exec_new_links (a_term, l_xterm, a_exe___0, a_param)
		end

	open_in_new_xterm_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent open_in_new_xterm)
		end

	open_in_new_screen (a_term: CE_POINTER [PD_TERMINAL]; a_exe___0: CE_POINTER [NATURAL_8]; a_param: CE_POINTER [NATURAL_8])
		do
			exec_new_links (a_term, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("screen")), a_exe___0, a_param)
		end

	open_in_new_screen_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent open_in_new_screen)
		end

	get_open_in_new (a_environment: INTEGER_32): CE_POINTER [PD_OPEN_IN_NEW]
		local
			l_i: INTEGER_32
			l_oin: CE_POINTER [PD_OPEN_IN_NEW]
			l_noin: INTEGER_32
			js: JUMP_STATE
		do
			create l_oin.make

			l_oin.ce_gets (create {CE_POINTER [PD_OPEN_IN_NEW]}.make_shared (default_pointer + -1))
			l_noin := 0
			if default_inst.anonymous.to_boolean then
				Result := (create {CE_POINTER [PD_OPEN_IN_NEW]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_i := 0
				from
				until
					not (not js.loop_left and then ((oinw[l_i].env).to_boolean))
				loop
					if ((a_environment).bit_and (oinw[l_i].env)) = oinw[l_i].env then
						if l_noin.to_natural_32 > {NATURAL_32} 2147483647 // {PD_OPEN_IN_NEW}.sizeof.to_natural_32 - {NATURAL_32} 2 then
							from
							until
								False
							loop
								error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("os_dep.c"), 1738])
								kbd_inst.fatal_tty_exit
								exit (4)
							end
						end
						l_oin.ce_gets (create {CE_POINTER [PD_OPEN_IN_NEW]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("os_dep.c")), 1739, create {CE_POINTER [ANY]}.make_cast (l_oin), (l_noin + 2).to_natural_32 * {PD_OPEN_IN_NEW}.sizeof.to_natural_32))));
						(l_oin + l_noin).item.text := oinw[l_i].text;
						(l_oin + l_noin).item.hk := oinw[l_i].hk;
						(l_oin + l_noin).item.fn := oinw[l_i].fn
						l_noin := l_noin + 1;
						(l_oin + l_noin).item.text := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer);
						(l_oin + l_noin).item.hk := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer);
						(l_oin + l_noin).item.fn := create {CE_ROUTINE}.make_shared (default_pointer)
					end
					l_i := l_i + 1
				end
				if (l_oin.c_pointer.to_integer_32).to_natural_32 = (-1).to_natural_32 then
					Result := (create {CE_POINTER [PD_OPEN_IN_NEW]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				Result := l_oin
			end
		end

	can_resize_window (a_environment: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if ((a_environment).bit_and (36)).to_boolean then
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	can_open_os_shell (a_environment: INTEGER_32): INTEGER_32
		do
			Result := 1
		end

	set_highpri
		do
		end

end
