class
	P_TYPES

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create mailto_prog.make
			create telnet_prog.make
			create tn3270_prog.make
			create mms_prog.make
			create assoc.make
			create extensions.make
			create ct_msg.make (<<7>>)
			create mi_no_assoc.make (<<2>>)
			create ext_msg.make (<<2>>)
			create mi_no_ext.make (<<2>>)
		end

feature {ANY} -- attributes

	mailto_prog: PD_LIST_HEAD

	telnet_prog: PD_LIST_HEAD

	tn3270_prog: PD_LIST_HEAD

	mms_prog: PD_LIST_HEAD

	assoc: PD_LIST_HEAD

	assoc_cnt: NATURAL_32 assign set_assoc_cnt

	set_assoc_cnt (a_assoc_cnt: NATURAL_32)
		do
			assoc_cnt := a_assoc_cnt
		end

	extensions: PD_LIST_HEAD

	ct_msg: CE_ARRAY [CE_POINTER [NATURAL_8]]

	mi_no_assoc: CE_ARRAY [PD_MENU_ITEM]

	ext_msg: CE_ARRAY [CE_POINTER [NATURAL_8]]

	mi_no_ext: CE_ARRAY [PD_MENU_ITEM]

feature {ANY} -- routines

	get_assoc_cnt: NATURAL_32
		do
			assoc_cnt := assoc_cnt + 1
			if not assoc_cnt.to_boolean then
				assoc_cnt := (1).to_natural_32
			end
			Result := assoc_cnt
		end

	delete_association (a_del: CE_POINTER [PD_ASSOC])
		do
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_del));
			(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_del.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (a_del.item.prev);
			(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_del.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (a_del.item.next)
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_del))
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 22, create {CE_POINTER [ANY]}.make_cast (a_del.item.label))
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 23, create {CE_POINTER [ANY]}.make_cast (a_del.item.ct))
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 24, create {CE_POINTER [ANY]}.make_cast (a_del.item.prog))
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 25, create {CE_POINTER [ANY]}.make_cast (a_del))
		end

	delete_extension (a_del: CE_POINTER [PD_EXTENSION])
		do
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_del));
			(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_del.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (a_del.item.prev);
			(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_del.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (a_del.item.next)
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_del))
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 31, create {CE_POINTER [ANY]}.make_cast (a_del.item.ext))
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 32, create {CE_POINTER [ANY]}.make_cast (a_del.item.ct))
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 33, create {CE_POINTER [ANY]}.make_cast (a_del))
		end

	is_in_list (a_list: CE_POINTER [NATURAL_8]; a_str: CE_POINTER [NATURAL_8]; a_l: INTEGER_32): INTEGER_32
		local
			l_list: CE_POINTER [NATURAL_8]
			l_l2: CE_POINTER [NATURAL_8]
			l_l3: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_list.make
			create l_l2.make
			create l_l3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_list.ce_gets (a_list)
					if not a_l.to_boolean then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | rep:
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_list.item).to_boolean then
								if not ((l_list.item).to_integer_32 <= 32) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_list.ce_gets (l_list + 1)
							end
						end
						js.reset
						if not (l_list.item).to_boolean then
							Result := 0
							js.return
						end
				when 2 then -- if done
					if not js.return_called then
						l_l2.ce_gets (l_list)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_l2.item).to_boolean then
								if (l_l2.item).to_integer_32 = 44 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_l2.ce_gets (l_l2 + 1)
							end
						end
						js.reset
						l_l3.ce_gets (l_l2 - 1)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_l3.c_pointer.to_integer_32).to_natural_32 >= (l_list.c_pointer.to_integer_32).to_natural_32 then
								if not ((l_l3.item).to_integer_32 <= 32) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_l3.ce_gets (l_l3 - 1)
							end
						end
						js.reset
						l_l3.ce_gets (l_l3 + 1)
						if l_l3.distance (l_list) = a_l then
							if not (links_inst.casecmp (a_str, l_list, a_l.to_natural_32)).to_boolean then
								Result := 1
								js.return
							end
						end
					end
					if not js.return_called then
						l_list.ce_gets (l_l2)
						if (l_list.item).to_integer_32 = 44 then
							l_list.ce_gets (l_list + 1)
						end
						l_pos := -1 + 1 -- goto rep
					end
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_content_type (a_head___0: CE_POINTER [NATURAL_8]; a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_e: CE_POINTER [PD_EXTENSION]
			l_a: CE_POINTER [PD_ASSOC]
			l_ct: CE_POINTER [NATURAL_8]
			l_ext: CE_POINTER [NATURAL_8]
			l_exxt: CE_POINTER [NATURAL_8]
			l_extl: INTEGER_32
			l_el: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___14: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_e.make
			create l_a.make
			create l_ct.make
			create l_ext.make
			create l_exxt.make
			create l_s.make
			create l_tmp___6.make
			create l_tmp___14.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((a_head___0).c_pointer /= default_pointer) then
						l_ct.ce_gets (http_inst.parse_http_header (a_head___0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Content-Type")), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
						if ((l_ct).c_pointer /= default_pointer) then
							l_s.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_ct), (';').code))))
							if ((l_s).c_pointer /= default_pointer) then
								l_s.item := (0).to_natural_8
							end
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_ct.item).to_boolean then
									if not ((l_ct[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ct))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 <= 32) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_ct[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ct))) - {NATURAL_32} 1).to_integer_32] := (0).to_natural_8
								end
							end
							js.reset
							Result := l_ct
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						l_ext.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						l_extl := 0
						l_ct.ce_gets (a_url)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_ct.item).to_boolean then
								if (links_inst.end_of_dir (l_ct.item)).to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if (l_ct.item).to_integer_32 = 46 then
									l_ext.ce_gets (l_ct + 1)
								elseif (os_dep_inst.dir_sep ((l_ct.item).to_integer_8)).to_boolean then
									l_ext.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								end
								l_ct.ce_gets (l_ct + 1)
							end
						end
						js.reset
						if ((l_ext).c_pointer /= default_pointer) then
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_ext[l_extl]).to_boolean then
									if (os_dep_inst.dir_sep ((l_ext[l_extl]).to_integer_8)).to_boolean then
										js.break
									elseif (links_inst.end_of_dir (l_ext[l_extl])).to_boolean then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_extl := l_extl + 1
								end
							end
							js.reset
						end
						if l_extl /= 3 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (links_inst.casecmp (l_ext, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("htm")), (3).to_natural_32)).to_boolean then
							l_pos := -1 + 4 -- goto _L
						else
							l_tmp___6.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 70, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("text/html"))))
							Result := l_tmp___6
							js.return
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_extl = 4 then
							if not (links_inst.casecmp (l_ext, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html")), (4).to_natural_32)).to_boolean then
								l_tmp___6.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 70, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("text/html"))))
								Result := l_tmp___6
								js.return
							end
						end
				when 5 then -- if done
						if not js.return_called then
							l_e.ce_gets (create {CE_POINTER [PD_EXTENSION]}.make_cast (extensions.next))
							from
							until
								not (not js.loop_left and then ((l_e.c_pointer.to_integer_32).to_natural_32 /= ((extensions.address).c_pointer.to_integer_32).to_natural_32))
							loop
								if (is_in_list (l_e.item.ext, l_ext, l_extl)).to_boolean then
									Result := (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 71, l_e.item.ct))
									js.return
								end
								if not js.return_called then
									l_e.ce_gets (l_e.item.next)
								end
							end
						end
						if not js.return_called then
							l_exxt.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 72))
							l_el := 0
							links_inst.add_to_str (l_exxt.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_el), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("application/x-")))
							links_inst.add_bytes_to_str (l_exxt.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_el), l_ext, l_extl)
							l_a.ce_gets (create {CE_POINTER [PD_ASSOC]}.make_cast (assoc.next))
							from
							until
								not (not js.loop_left and then ((l_a.c_pointer.to_integer_32).to_natural_32 /= ((assoc.address).c_pointer.to_integer_32).to_natural_32))
							loop
								if (is_in_list (l_a.item.ct, l_exxt, l_el)).to_boolean then
									Result := l_exxt
									js.return
								end
								if not js.return_called then
									l_a.ce_gets (l_a.item.next)
								end
							end
						end
						if not js.return_called then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 76, create {CE_POINTER [ANY]}.make_cast (l_exxt))
							if not default_inst.force_html.to_boolean then
								l_tmp___14.ce_gets ((links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 77, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("text/plain")))))
							else
								l_tmp___14.ce_gets ((links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 77, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("text/html")))))
							end
							Result := l_tmp___14
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	get_type_assoc (a_term: CE_POINTER [PD_TERMINAL]; a_type: CE_POINTER [NATURAL_8]): CE_POINTER [PD_ASSOC]
		local
			l_a: CE_POINTER [PD_ASSOC]
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_a.make

			l_a.ce_gets (create {CE_POINTER [PD_ASSOC]}.make_cast (assoc.next))
			from
			until
				not (not js.loop_left and then ((l_a.c_pointer.to_integer_32).to_natural_32 /= ((assoc.address).c_pointer.to_integer_32).to_natural_32))
			loop
				if l_a.item.system = 1 then
					if ((a_term.item.environment).bit_and (1)).to_boolean then
						l_tmp := l_a.item.xwin
					else
						l_tmp := l_a.item.cons
					end
					if l_tmp.to_boolean then
						if (is_in_list (l_a.item.ct, a_type, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_type))).to_integer_32)).to_boolean then
							Result := l_a
							js.return
						end
					end
				end
				if not js.return_called then
					l_a.ce_gets (l_a.item.next)
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [PD_ASSOC]}.make_shared (default_pointer))
			end
		end

	free_types
		local
			l_a: CE_POINTER [PD_ASSOC]
			l_e: CE_POINTER [PD_EXTENSION]
			l_p: CE_POINTER [PD_PROTOCOL_PROGRAM]
			l_a__: CE_POINTER [PD_XLIST_HEAD]
			l_a_____0: CE_POINTER [PD_XLIST_HEAD]
			l_a_____1: CE_POINTER [PD_XLIST_HEAD]
			l_a_____2: CE_POINTER [PD_XLIST_HEAD]
			l_a_____3: CE_POINTER [PD_XLIST_HEAD]
			l_a_____4: CE_POINTER [PD_XLIST_HEAD]
		do
			create l_a.make
			create l_e.make
			create l_p.make
			create l_a__.make
			create l_a_____0.make
			create l_a_____1.make
			create l_a_____2.make
			create l_a_____3.make
			create l_a_____4.make

			l_a.ce_gets (create {CE_POINTER [PD_ASSOC]}.make_cast (assoc.next))
			from
			until
				(l_a.c_pointer.to_integer_32).to_natural_32 = ((assoc.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 93, create {CE_POINTER [ANY]}.make_cast (l_a.item.ct))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 94, create {CE_POINTER [ANY]}.make_cast (l_a.item.prog))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 95, create {CE_POINTER [ANY]}.make_cast (l_a.item.label))
				l_a.ce_gets (l_a.item.next)
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((assoc.address)))
			l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (assoc.next))
			from
			until
				(l_a__.c_pointer.to_integer_32).to_natural_32 = ((assoc.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__.ce_gets (l_a__.item.next)
			end
			l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (assoc.prev))
			from
			until
				(l_a__.c_pointer.to_integer_32).to_natural_32 = ((assoc.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__.ce_gets (l_a__.item.prev)
			end
			from
			until
				((assoc.next).c_pointer.to_integer_32).to_natural_32 = ((assoc.address).c_pointer.to_integer_32).to_natural_32
			loop
				l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (assoc.next))
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a__.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a__.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 97, create {CE_POINTER [ANY]}.make_cast (l_a__))
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((assoc.address)))
			l_e.ce_gets (create {CE_POINTER [PD_EXTENSION]}.make_cast (extensions.next))
			from
			until
				(l_e.c_pointer.to_integer_32).to_natural_32 = ((extensions.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 99, create {CE_POINTER [ANY]}.make_cast (l_e.item.ext))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 100, create {CE_POINTER [ANY]}.make_cast (l_e.item.ct))
				l_e.ce_gets (l_e.item.next)
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((extensions.address)))
			l_a_____0.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (extensions.next))
			from
			until
				(l_a_____0.c_pointer.to_integer_32).to_natural_32 = ((extensions.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____0))
				l_a_____0.ce_gets (l_a_____0.item.next)
			end
			l_a_____0.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (extensions.prev))
			from
			until
				(l_a_____0.c_pointer.to_integer_32).to_natural_32 = ((extensions.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____0))
				l_a_____0.ce_gets (l_a_____0.item.prev)
			end
			from
			until
				((extensions.next).c_pointer.to_integer_32).to_natural_32 = ((extensions.address).c_pointer.to_integer_32).to_natural_32
			loop
				l_a_____0.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (extensions.next))
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____0));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____0.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a_____0.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____0.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a_____0.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____0))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 102, create {CE_POINTER [ANY]}.make_cast (l_a_____0))
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((extensions.address)))
			l_p.ce_gets (create {CE_POINTER [PD_PROTOCOL_PROGRAM]}.make_cast (mailto_prog.next))
			from
			until
				(l_p.c_pointer.to_integer_32).to_natural_32 = ((mailto_prog.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 103, create {CE_POINTER [ANY]}.make_cast (l_p.item.prog))
				l_p.ce_gets (l_p.item.next)
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((mailto_prog.address)))
			l_a_____1.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (mailto_prog.next))
			from
			until
				(l_a_____1.c_pointer.to_integer_32).to_natural_32 = ((mailto_prog.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____1))
				l_a_____1.ce_gets (l_a_____1.item.next)
			end
			l_a_____1.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (mailto_prog.prev))
			from
			until
				(l_a_____1.c_pointer.to_integer_32).to_natural_32 = ((mailto_prog.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____1))
				l_a_____1.ce_gets (l_a_____1.item.prev)
			end
			from
			until
				((mailto_prog.next).c_pointer.to_integer_32).to_natural_32 = ((mailto_prog.address).c_pointer.to_integer_32).to_natural_32
			loop
				l_a_____1.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (mailto_prog.next))
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____1));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____1.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a_____1.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____1.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a_____1.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____1))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 104, create {CE_POINTER [ANY]}.make_cast (l_a_____1))
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((mailto_prog.address)))
			l_p.ce_gets (create {CE_POINTER [PD_PROTOCOL_PROGRAM]}.make_cast (telnet_prog.next))
			from
			until
				(l_p.c_pointer.to_integer_32).to_natural_32 = ((telnet_prog.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 105, create {CE_POINTER [ANY]}.make_cast (l_p.item.prog))
				l_p.ce_gets (l_p.item.next)
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((telnet_prog.address)))
			l_a_____2.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (telnet_prog.next))
			from
			until
				(l_a_____2.c_pointer.to_integer_32).to_natural_32 = ((telnet_prog.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____2))
				l_a_____2.ce_gets (l_a_____2.item.next)
			end
			l_a_____2.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (telnet_prog.prev))
			from
			until
				(l_a_____2.c_pointer.to_integer_32).to_natural_32 = ((telnet_prog.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____2))
				l_a_____2.ce_gets (l_a_____2.item.prev)
			end
			from
			until
				((telnet_prog.next).c_pointer.to_integer_32).to_natural_32 = ((telnet_prog.address).c_pointer.to_integer_32).to_natural_32
			loop
				l_a_____2.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (telnet_prog.next))
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____2));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____2.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a_____2.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____2.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a_____2.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____2))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 106, create {CE_POINTER [ANY]}.make_cast (l_a_____2))
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((telnet_prog.address)))
			l_p.ce_gets (create {CE_POINTER [PD_PROTOCOL_PROGRAM]}.make_cast (tn3270_prog.next))
			from
			until
				(l_p.c_pointer.to_integer_32).to_natural_32 = ((tn3270_prog.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 107, create {CE_POINTER [ANY]}.make_cast (l_p.item.prog))
				l_p.ce_gets (l_p.item.next)
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((tn3270_prog.address)))
			l_a_____3.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (tn3270_prog.next))
			from
			until
				(l_a_____3.c_pointer.to_integer_32).to_natural_32 = ((tn3270_prog.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____3))
				l_a_____3.ce_gets (l_a_____3.item.next)
			end
			l_a_____3.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (tn3270_prog.prev))
			from
			until
				(l_a_____3.c_pointer.to_integer_32).to_natural_32 = ((tn3270_prog.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____3))
				l_a_____3.ce_gets (l_a_____3.item.prev)
			end
			from
			until
				((tn3270_prog.next).c_pointer.to_integer_32).to_natural_32 = ((tn3270_prog.address).c_pointer.to_integer_32).to_natural_32
			loop
				l_a_____3.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (tn3270_prog.next))
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____3));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____3.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a_____3.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____3.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a_____3.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____3))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 108, create {CE_POINTER [ANY]}.make_cast (l_a_____3))
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((tn3270_prog.address)))
			l_p.ce_gets (create {CE_POINTER [PD_PROTOCOL_PROGRAM]}.make_cast (mms_prog.next))
			from
			until
				(l_p.c_pointer.to_integer_32).to_natural_32 = ((mms_prog.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 109, create {CE_POINTER [ANY]}.make_cast (l_p.item.prog))
				l_p.ce_gets (l_p.item.next)
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((mms_prog.address)))
			l_a_____4.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (mms_prog.next))
			from
			until
				(l_a_____4.c_pointer.to_integer_32).to_natural_32 = ((mms_prog.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____4))
				l_a_____4.ce_gets (l_a_____4.item.next)
			end
			l_a_____4.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (mms_prog.prev))
			from
			until
				(l_a_____4.c_pointer.to_integer_32).to_natural_32 = ((mms_prog.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____4))
				l_a_____4.ce_gets (l_a_____4.item.prev)
			end
			from
			until
				((mms_prog.next).c_pointer.to_integer_32).to_natural_32 = ((mms_prog.address).c_pointer.to_integer_32).to_natural_32
			loop
				l_a_____4.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (mms_prog.next))
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____4));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____4.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a_____4.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____4.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a_____4.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____4))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 110, create {CE_POINTER [ANY]}.make_cast (l_a_____4))
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((mms_prog.address)))
		end

	add_ct_fn (a_dlg: CE_POINTER [PD_DIALOG_DATA])
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_max: INTEGER_32
			l_min: INTEGER_32
			l_w: INTEGER_32
			l_rw: INTEGER_32
			l_y: INTEGER_32
			l_p: INTEGER_32
		do
			create l_term.make

			l_term.ce_gets ((a_dlg.item.win).item.term)
			l_max := 0
			l_min := 0
			l_y := -1
			l_p := 1
			l_p := l_p + 1
			l_p := l_p + (2)
			bfu_inst.max_text_width (l_term, ct_msg[0], create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))
			bfu_inst.min_text_width (l_term, ct_msg[0], create {CE_POINTER [INTEGER_32]}.make_shared ($l_min))
			bfu_inst.max_text_width (l_term, ct_msg[1], create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))
			bfu_inst.min_text_width (l_term, ct_msg[1], create {CE_POINTER [INTEGER_32]}.make_shared ($l_min))
			bfu_inst.max_text_width (l_term, ct_msg[2], create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))
			bfu_inst.min_text_width (l_term, ct_msg[2], create {CE_POINTER [INTEGER_32]}.make_shared ($l_min))
			bfu_inst.max_group_width (l_term, ct_msg + 3, a_dlg.item.items + 3, l_p, create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))
			bfu_inst.min_group_width (l_term, ct_msg + 3, a_dlg.item.items + 3, l_p, create {CE_POINTER [INTEGER_32]}.make_shared ($l_min))
			bfu_inst.max_buttons_width (l_term, (a_dlg.item.items + 3) + l_p, 2, create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))
			bfu_inst.min_buttons_width (l_term, (a_dlg.item.items + 3) + l_p, 2, create {CE_POINTER [INTEGER_32]}.make_shared ($l_min))
			l_w := (l_term.item.x * 9) // 10 - 12
			if l_w > l_max then
				l_w := l_max
			end
			if l_w < l_min then
				l_w := l_min
			end
			if l_w > l_term.item.x - 12 then
				l_w := l_term.item.x - 12
			end
			if l_w < 1 then
				l_w := 1
			end
			l_rw := 0
			bfu_inst.dlg_format_text (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, (language_inst.get_text_translation (ct_msg[0], l_term)), 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rw), 14336, 0)
			l_y := l_y + (2)
			bfu_inst.dlg_format_text (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, (language_inst.get_text_translation (ct_msg[1], l_term)), 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rw), 14336, 0)
			l_y := l_y + (2)
			bfu_inst.dlg_format_text (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, (language_inst.get_text_translation (ct_msg[2], l_term)), 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rw), 14336, 0)
			l_y := l_y + (2)
			bfu_inst.dlg_format_group (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, ct_msg + 3, a_dlg.item.items + 3, l_p, 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rw))
			l_y := l_y + 1
			bfu_inst.dlg_format_buttons (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, (a_dlg.item.items + 3) + l_p, 2, 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rw), 1)
			l_w := l_rw
			a_dlg.item.xw := l_w + 12
			a_dlg.item.yw := l_y + 4
			bfu_inst.center_dlg (a_dlg)
			bfu_inst.draw_dlg (a_dlg)
			l_y := a_dlg.item.y + 2
			bfu_inst.dlg_format_text (l_term, l_term, ct_msg[0], a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 14336, 0)
			bfu_inst.dlg_format_field (l_term, l_term, a_dlg.item.items + 0, a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0)
			l_y := l_y + 1
			bfu_inst.dlg_format_text (l_term, l_term, ct_msg[1], a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 14336, 0)
			bfu_inst.dlg_format_field (l_term, l_term, a_dlg.item.items + 1, a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0)
			l_y := l_y + 1
			bfu_inst.dlg_format_text (l_term, l_term, ct_msg[2], a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 14336, 0)
			bfu_inst.dlg_format_field (l_term, l_term, a_dlg.item.items + 2, a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0)
			l_y := l_y + 1
			bfu_inst.dlg_format_group (l_term, l_term, ct_msg + 3, a_dlg.item.items + 3, l_p, a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
			l_y := l_y + 1
			bfu_inst.dlg_format_buttons (l_term, l_term, a_dlg.item.items + 3 + l_p, 2, a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 1)
		end

	add_ct_fn_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent add_ct_fn)
		end

	update_assoc (a_new: CE_POINTER [PD_ASSOC])
		local
			l_repl: CE_POINTER [PD_ASSOC]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_repl.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_new.item.label[0]).to_boolean then
						js.return
					elseif not (a_new.item.ct[0]).to_boolean then
						js.return
					elseif not (a_new.item.prog[0]).to_boolean then
						js.return
					end
					if not (not js.return_called and then ((a_new.item.cnt).to_boolean)) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_repl.ce_gets (create {CE_POINTER [PD_ASSOC]}.make_cast (assoc.next))
				when 2 then -- loop condition:
						if (l_repl.c_pointer.to_integer_32).to_natural_32 = ((assoc.address).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						if l_repl.item.cnt = a_new.item.cnt then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 191, create {CE_POINTER [ANY]}.make_cast (l_repl.item.label))
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 192, create {CE_POINTER [ANY]}.make_cast (l_repl.item.ct))
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 193, create {CE_POINTER [ANY]}.make_cast (l_repl.item.prog))
							l_pos := -1 + 8 -- goto replace
						end
				when 4 then
						l_repl.ce_gets (l_repl.item.next)
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
						js.return
				when 6 then -- if done
					if not js.return_called then
						l_repl.ce_gets (create {CE_POINTER [PD_ASSOC]}.make_cast (assoc.next))
						from
						until
							not (not js.loop_left and then ((l_repl.c_pointer.to_integer_32).to_natural_32 /= ((assoc.address).c_pointer.to_integer_32).to_natural_32))
						loop
							if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_repl.item.label), create {CE_POINTER [INTEGER_8]}.make_cast (a_new.item.label))).to_boolean then
								if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_repl.item.ct), create {CE_POINTER [INTEGER_8]}.make_cast (a_new.item.ct))).to_boolean then
									if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_repl.item.prog), create {CE_POINTER [INTEGER_8]}.make_cast (a_new.item.prog))).to_boolean then
										if l_repl.item.block = a_new.item.block then
											if l_repl.item.cons = a_new.item.cons then
												if l_repl.item.xwin = a_new.item.xwin then
													if l_repl.item.ask = a_new.item.ask then
														if l_repl.item.system = a_new.item.system then
															error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_repl));
															(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_repl.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_repl.item.prev);
															(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_repl.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_repl.item.next)
															error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_repl))
															from
															until
																js.loop_left
															loop
																js.reset
																error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((assoc.address)))
																l_repl.item.next := (create {CE_POINTER [PD_ASSOC]}.make_cast ((assoc.address))).item.next
																l_repl.item.prev := create {CE_POINTER [PD_ASSOC]}.make_cast ((assoc.address));
																(create {CE_POINTER [PD_ASSOC]}.make_cast ((assoc.address))).item.next := l_repl;
																(l_repl.item.next).item.prev := l_repl
																error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((assoc.address)))
																js.break
															end
															js.reset
															js.return
														end
													end
												end
											end
										end
									end
								end
							end
							if not js.return_called then
								l_repl.ce_gets (l_repl.item.next)
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 7 then -- if:
						a_new.item.cnt := get_assoc_cnt
						l_repl.ce_gets (create {CE_POINTER [PD_ASSOC]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 204, {PD_ASSOC}.sizeof.to_natural_32))))
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((assoc.address)))
							l_repl.item.next := (create {CE_POINTER [PD_ASSOC]}.make_cast ((assoc.address))).item.next
							l_repl.item.prev := create {CE_POINTER [PD_ASSOC]}.make_cast ((assoc.address));
							(create {CE_POINTER [PD_ASSOC]}.make_cast ((assoc.address))).item.next := l_repl;
							(l_repl.item.next).item.prev := l_repl
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((assoc.address)))
							js.break
						end
						js.reset
				when 8 then -- replace:
						l_repl.item.label := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 207, a_new.item.label)
						l_repl.item.ct := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 208, a_new.item.ct)
						l_repl.item.prog := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 209, a_new.item.prog)
						l_repl.item.block := a_new.item.block
						l_repl.item.cons := a_new.item.cons
						l_repl.item.xwin := a_new.item.xwin
						l_repl.item.ask := a_new.item.ask
						l_repl.item.system := a_new.item.system
						l_repl.item.cnt := a_new.item.cnt
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	update_assoc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent update_assoc)
		end

	really_del_ct (a_fcp: CE_POINTER [ANY])
		local
			l_fc: NATURAL_32
			l_del: CE_POINTER [PD_ASSOC]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_del.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fc := (a_fcp.c_pointer.to_integer_32).to_natural_32
					l_del.ce_gets (create {CE_POINTER [PD_ASSOC]}.make_cast (assoc.next))
				when 1 then -- loop condition:
					if (l_del.c_pointer.to_integer_32).to_natural_32 = ((assoc.address).c_pointer.to_integer_32).to_natural_32 then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if l_del.item.cnt = l_fc then
							l_pos := -1 + 5 -- goto ok
						end
				when 3 then
						l_del.ce_gets (l_del.item.next)
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					js.return
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 5 then -- if: | ok:
						delete_association (l_del)
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	really_del_ct_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent really_del_ct)
		end

	menu_del_ct (a_term: CE_POINTER [PD_TERMINAL]; a_fcp: CE_POINTER [ANY]; a_xxx2: CE_POINTER [ANY])
		local
			l_str: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_fc: NATURAL_32
			l_del: CE_POINTER [PD_ASSOC]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_str.make
			create l_del.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fc := (a_fcp.c_pointer.to_integer_32).to_natural_32
					l_del.ce_gets (create {CE_POINTER [PD_ASSOC]}.make_cast (assoc.next))
				when 1 then -- loop condition:
					if (l_del.c_pointer.to_integer_32).to_natural_32 = ((assoc.address).c_pointer.to_integer_32).to_natural_32 then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if l_del.item.cnt = l_fc then
							l_pos := -1 + 5 -- goto ok
						end
				when 3 then
						l_del.ce_gets (l_del.item.next)
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					js.return
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 5 then -- if: | ok:
						l_str.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 237))
						l_l := 0
						links_inst.add_to_str (l_str.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_del.item.ct)
						links_inst.add_to_str (l_str.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" -> ")))
						links_inst.add_to_str (l_str.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_del.item.prog)
						bfu_inst.msg_box ([a_term, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_str), create {CE_POINTER [ANY]}.make_shared (default_pointer)])), links_inst.dummyarray + 197, 129, links_inst.dummyarray + 197, ce_string (": "), l_str, ce_string ("?"), create {CE_POINTER [ANY]}.make_shared (default_pointer), a_fcp, 2, links_inst.dummyarray + 166, really_del_ct_address, 1, links_inst.dummyarray + 167, create {CE_POINTER [ANY]}.make_shared (default_pointer), 2])
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	menu_del_ct_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_del_ct)
		end

	menu_add_ct (a_term: CE_POINTER [PD_TERMINAL]; a_fcp: CE_POINTER [ANY]; a_xxx2: CE_POINTER [ANY])
		local
			l_p: INTEGER_32
			l_fc: NATURAL_32
			l_new: CE_POINTER [PD_ASSOC]
			l_from: CE_POINTER [PD_ASSOC]
			l_label: CE_POINTER [NATURAL_8]
			l_ct: CE_POINTER [NATURAL_8]
			l_prog: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [PD_DIALOG]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_new.make
			create l_from.make
			create l_label.make
			create l_ct.make
			create l_prog.make
			create l_d.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fc := (a_fcp.c_pointer.to_integer_32).to_natural_32
					if not (l_fc.to_boolean) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_from.ce_gets (create {CE_POINTER [PD_ASSOC]}.make_cast (assoc.next))
				when 2 then -- loop condition:
						if (l_from.c_pointer.to_integer_32).to_natural_32 = ((assoc.address).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						if l_from.item.cnt = l_fc then
							l_pos := -1 + 8 -- goto ok
						end
				when 4 then
						l_from.ce_gets (l_from.item.next)
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
						js.return
				when 6 then -- if done
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 7 then -- if:
						l_from.ce_gets (create {CE_POINTER [PD_ASSOC]}.make_shared (default_pointer))
				when 8 then -- ok:
						l_d.ce_gets (create {CE_POINTER [PD_DIALOG]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 259, (({PD_DIALOG}.sizeof.to_natural_32 + {NATURAL_32} 10 * {PD_DIALOG_ITEM}.sizeof.to_natural_32) + {PD_ASSOC}.sizeof.to_natural_32) + {NATURAL_32} 3072))))
						memset (create {CE_POINTER [ANY]}.make_cast (l_d), 0, (({PD_DIALOG}.sizeof.to_natural_32 + {NATURAL_32} 10 * {PD_DIALOG_ITEM}.sizeof.to_natural_32) + {PD_ASSOC}.sizeof.to_natural_32) + {NATURAL_32} 3072).do_nothing
						l_new.ce_gets (create {CE_POINTER [PD_ASSOC]}.make_cast ((l_d.item.items + 10)))
						l_label.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((l_new + 1)))
						l_new.item.label := l_label
						l_ct.ce_gets (l_label + 1024)
						l_new.item.ct := l_ct
						l_prog.ce_gets (l_ct + 1024)
						l_new.item.prog := l_prog
						if ((l_from).c_pointer /= default_pointer) then
							strncpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_label), create {CE_POINTER [INTEGER_8]}.make_cast (l_from.item.label), (1023).to_natural_32).do_nothing
							strncpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_ct), create {CE_POINTER [INTEGER_8]}.make_cast (l_from.item.ct), (1023).to_natural_32).do_nothing
							strncpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_prog), create {CE_POINTER [INTEGER_8]}.make_cast (l_from.item.prog), (1023).to_natural_32).do_nothing
							l_new.item.block := l_from.item.block
							l_new.item.cons := l_from.item.cons
							l_new.item.xwin := l_from.item.xwin
							l_new.item.ask := l_from.item.ask
							l_new.item.system := l_from.item.system
							l_new.item.cnt := l_from.item.cnt
						else
							l_tmp___1 := 1
							l_new.item.cons := l_tmp___1
							l_tmp___0 := l_tmp___1
							l_new.item.xwin := l_tmp___0
							l_new.item.block := l_tmp___0
							l_new.item.ask := 1
							l_new.item.system := 1
						end
						l_d.item.title := links_inst.dummyarray + 198
						l_d.item.fn := add_ct_fn_address
						l_d.item.refresh := (update_assoc_address)
						l_d.item.refresh_data := create {CE_POINTER [ANY]}.make_cast (l_new)
						l_d.item.items[0].type := 2
						l_d.item.items[0].dlen := 1024
						l_d.item.items[0].data := l_label
						l_d.item.items[0].fn := bfu_inst.check_nonempty_address
						l_d.item.items[1].type := 2
						l_d.item.items[1].dlen := 1024
						l_d.item.items[1].data := l_ct
						l_d.item.items[1].fn := bfu_inst.check_nonempty_address
						l_d.item.items[2].type := 2
						l_d.item.items[2].dlen := 1024
						l_d.item.items[2].data := l_prog
						l_d.item.items[2].fn := bfu_inst.check_nonempty_address
						l_p := 3
						l_d.item.items[l_p].type := 1
						l_d.item.items[l_p].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (l_new.c_pointer + {PD_ASSOC}.block_offset)))
						l_tmp___2 := l_p
						l_p := l_p + 1
						l_d.item.items[l_tmp___2].dlen := (Integer_32_bytes.to_natural_32).to_integer_32
						l_d.item.items[l_p].type := 1
						l_d.item.items[l_p].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (l_new.c_pointer + {PD_ASSOC}.cons_offset)))
						l_tmp___3 := l_p
						l_p := l_p + 1
						l_d.item.items[l_tmp___3].dlen := (Integer_32_bytes.to_natural_32).to_integer_32
						l_d.item.items[l_p].type := 1
						l_d.item.items[l_p].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (l_new.c_pointer + {PD_ASSOC}.xwin_offset)))
						l_tmp___4 := l_p
						l_p := l_p + 1
						l_d.item.items[l_tmp___4].dlen := (Integer_32_bytes.to_natural_32).to_integer_32
						l_d.item.items[l_p].type := 1
						l_d.item.items[l_p].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (l_new.c_pointer + {PD_ASSOC}.ask_offset)))
						l_tmp___5 := l_p
						l_p := l_p + 1
						l_d.item.items[l_tmp___5].dlen := (Integer_32_bytes.to_natural_32).to_integer_32
						l_d.item.items[l_p].type := 4
						l_d.item.items[l_p].gid := 1
						l_d.item.items[l_p].fn := bfu_inst.ok_dialog_address
						l_tmp___6 := l_p
						l_p := l_p + 1
						l_d.item.items[l_tmp___6].text := links_inst.dummyarray + 14
						l_d.item.items[l_p].type := 4
						l_d.item.items[l_p].gid := 2
						l_d.item.items[l_p].text := links_inst.dummyarray + 6
						l_tmp___7 := l_p
						l_p := l_p + 1
						l_d.item.items[l_tmp___7].fn := bfu_inst.cancel_dialog_address
						l_tmp___8 := l_p
						l_p := l_p + 1
						l_d.item.items[l_tmp___8].type := 0
						bfu_inst.do_dialog (a_term, l_d, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_d), create {CE_POINTER [ANY]}.make_shared (default_pointer)])))
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	menu_add_ct_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_add_ct)
		end

	menu_list_assoc (a_term: CE_POINTER [PD_TERMINAL]; a_fn: CE_POINTER [ANY]; a_xxx: CE_POINTER [ANY])
		local
			l_a: CE_POINTER [PD_ASSOC]
			l_mi: CE_POINTER [PD_MENU_ITEM]
			l_n: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_a.make
			create l_mi.make
			create l_tmp.make

			l_mi.ce_gets (create {CE_POINTER [PD_MENU_ITEM]}.make_shared (default_pointer))
			l_n := 0
			l_a.ce_gets (create {CE_POINTER [PD_ASSOC]}.make_cast (assoc.prev))
			from
			until
				not (not js.loop_left and then ((l_a.c_pointer.to_integer_32).to_natural_32 /= ((assoc.address).c_pointer.to_integer_32).to_natural_32))
			loop
				if l_a.item.system = 1 then
					if (l_mi).c_pointer = default_pointer then
						l_mi.ce_gets (bfu_inst.new_menu (7))
						if (l_mi).c_pointer = default_pointer then
							js.return
						end
					end
					if not js.return_called then
						l_tmp.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 337, l_a.item.ct))
						bfu_inst.add_to_menu (l_mi.address, (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 337, l_a.item.label)), l_tmp, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), create {CE_ROUTINE}.make_cast (a_fn), create {CE_POINTER [ANY]}.make_shared (default_pointer + (l_a.item.cnt).to_integer_32), 0)
						l_n := l_n + 1
					end
				end
				if not js.return_called then
					l_a.ce_gets (l_a.item.prev)
				end
			end
			if not js.return_called then
				if (l_mi).c_pointer = default_pointer then
					bfu_inst.do_menu (a_term, mi_no_assoc, a_xxx)
				else
					bfu_inst.do_menu (a_term, l_mi, a_xxx)
				end
			end
		end

	menu_list_assoc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_list_assoc)
		end

	add_ext_fn (a_dlg: CE_POINTER [PD_DIALOG_DATA])
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_max: INTEGER_32
			l_min: INTEGER_32
			l_w: INTEGER_32
			l_rw: INTEGER_32
			l_y: INTEGER_32
		do
			create l_term.make

			l_term.ce_gets ((a_dlg.item.win).item.term)
			l_max := 0
			l_min := 0
			l_y := -1
			bfu_inst.max_text_width (l_term, ext_msg[0], create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))
			bfu_inst.min_text_width (l_term, ext_msg[0], create {CE_POINTER [INTEGER_32]}.make_shared ($l_min))
			bfu_inst.max_text_width (l_term, ext_msg[1], create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))
			bfu_inst.min_text_width (l_term, ext_msg[1], create {CE_POINTER [INTEGER_32]}.make_shared ($l_min))
			bfu_inst.max_buttons_width (l_term, a_dlg.item.items + 2, 2, create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))
			bfu_inst.min_buttons_width (l_term, a_dlg.item.items + 2, 2, create {CE_POINTER [INTEGER_32]}.make_shared ($l_min))
			l_w := (l_term.item.x * 9) // 10 - 12
			if l_w > l_max then
				l_w := l_max
			end
			if l_w < l_min then
				l_w := l_min
			end
			if l_w > l_term.item.x - 12 then
				l_w := l_term.item.x - 12
			end
			if l_w < 1 then
				l_w := 1
			end
			l_rw := 0
			bfu_inst.dlg_format_text (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, ext_msg[0], 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rw), 14336, 0)
			l_y := l_y + (2)
			bfu_inst.dlg_format_text (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, ext_msg[1], 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rw), 14336, 0)
			l_y := l_y + (2)
			bfu_inst.dlg_format_buttons (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, a_dlg.item.items + 2, 2, 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rw), 1)
			l_w := l_rw
			a_dlg.item.xw := l_w + 12
			a_dlg.item.yw := l_y + 4
			bfu_inst.center_dlg (a_dlg)
			bfu_inst.draw_dlg (a_dlg)
			l_y := a_dlg.item.y + 2
			bfu_inst.dlg_format_text (l_term, l_term, ext_msg[0], a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 14336, 0)
			bfu_inst.dlg_format_field (l_term, l_term, a_dlg.item.items + 0, a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0)
			l_y := l_y + 1
			bfu_inst.dlg_format_text (l_term, l_term, ext_msg[1], a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 14336, 0)
			bfu_inst.dlg_format_field (l_term, l_term, a_dlg.item.items + 1, a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0)
			l_y := l_y + 1
			bfu_inst.dlg_format_buttons (l_term, l_term, a_dlg.item.items + 2, 2, a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 1)
		end

	add_ext_fn_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent add_ext_fn)
		end

	update_ext (a_new: CE_POINTER [PD_EXTENSION])
		local
			l_repl: CE_POINTER [PD_EXTENSION]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_repl.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_new.item.ext[0]).to_boolean then
						js.return
					elseif not (a_new.item.ct[0]).to_boolean then
						js.return
					end
					if not (not js.return_called and then ((a_new.item.cnt).to_boolean)) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_repl.ce_gets (create {CE_POINTER [PD_EXTENSION]}.make_cast (extensions.next))
				when 2 then -- loop condition:
						if (l_repl.c_pointer.to_integer_32).to_natural_32 = ((extensions.address).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						if l_repl.item.cnt = a_new.item.cnt then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 392, create {CE_POINTER [ANY]}.make_cast (l_repl.item.ext))
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 393, create {CE_POINTER [ANY]}.make_cast (l_repl.item.ct))
							l_pos := -1 + 8 -- goto replace
						end
				when 4 then
						l_repl.ce_gets (l_repl.item.next)
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
						js.return
				when 6 then -- if done
					if not js.return_called then
						l_repl.ce_gets (create {CE_POINTER [PD_EXTENSION]}.make_cast (extensions.next))
						from
						until
							not (not js.loop_left and then ((l_repl.c_pointer.to_integer_32).to_natural_32 /= ((extensions.address).c_pointer.to_integer_32).to_natural_32))
						loop
							if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_repl.item.ext), create {CE_POINTER [INTEGER_8]}.make_cast (a_new.item.ext))).to_boolean then
								if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_repl.item.ct), create {CE_POINTER [INTEGER_8]}.make_cast (a_new.item.ct))).to_boolean then
									error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_repl));
									(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_repl.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_repl.item.prev);
									(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_repl.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_repl.item.next)
									error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_repl))
									from
									until
										js.loop_left
									loop
										js.reset
										error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((extensions.address)))
										l_repl.item.next := (create {CE_POINTER [PD_EXTENSION]}.make_cast ((extensions.address))).item.next
										l_repl.item.prev := create {CE_POINTER [PD_EXTENSION]}.make_cast ((extensions.address));
										(create {CE_POINTER [PD_EXTENSION]}.make_cast ((extensions.address))).item.next := l_repl;
										(l_repl.item.next).item.prev := l_repl
										error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((extensions.address)))
										js.break
									end
									js.reset
									js.return
								end
							end
							if not js.return_called then
								l_repl.ce_gets (l_repl.item.next)
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 7 then -- if:
						a_new.item.cnt := get_assoc_cnt
						l_repl.ce_gets (create {CE_POINTER [PD_EXTENSION]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 404, {PD_EXTENSION}.sizeof.to_natural_32))))
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((extensions.address)))
							l_repl.item.next := (create {CE_POINTER [PD_EXTENSION]}.make_cast ((extensions.address))).item.next
							l_repl.item.prev := create {CE_POINTER [PD_EXTENSION]}.make_cast ((extensions.address));
							(create {CE_POINTER [PD_EXTENSION]}.make_cast ((extensions.address))).item.next := l_repl;
							(l_repl.item.next).item.prev := l_repl
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((extensions.address)))
							js.break
						end
						js.reset
				when 8 then -- replace:
						l_repl.item.ext := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 407, a_new.item.ext)
						l_repl.item.ct := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 408, a_new.item.ct)
						l_repl.item.cnt := a_new.item.cnt
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	update_ext_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent update_ext)
		end

	really_del_ext (a_fcp: CE_POINTER [ANY])
		local
			l_fc: NATURAL_32
			l_del: CE_POINTER [PD_EXTENSION]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_del.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fc := (a_fcp.c_pointer.to_integer_32).to_natural_32
					l_del.ce_gets (create {CE_POINTER [PD_EXTENSION]}.make_cast (extensions.next))
				when 1 then -- loop condition:
					if (l_del.c_pointer.to_integer_32).to_natural_32 = ((extensions.address).c_pointer.to_integer_32).to_natural_32 then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if l_del.item.cnt = l_fc then
							l_pos := -1 + 5 -- goto ok
						end
				when 3 then
						l_del.ce_gets (l_del.item.next)
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					js.return
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 5 then -- if: | ok:
						delete_extension (l_del)
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	really_del_ext_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent really_del_ext)
		end

	menu_del_ext (a_term: CE_POINTER [PD_TERMINAL]; a_fcp: CE_POINTER [ANY]; a_xxx2: CE_POINTER [ANY])
		local
			l_str: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_fc: NATURAL_32
			l_del: CE_POINTER [PD_EXTENSION]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_str.make
			create l_del.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fc := (a_fcp.c_pointer.to_integer_32).to_natural_32
					l_del.ce_gets (create {CE_POINTER [PD_EXTENSION]}.make_cast (extensions.next))
				when 1 then -- loop condition:
					if (l_del.c_pointer.to_integer_32).to_natural_32 = ((extensions.address).c_pointer.to_integer_32).to_natural_32 then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if l_del.item.cnt = l_fc then
							l_pos := -1 + 5 -- goto ok
						end
				when 3 then
						l_del.ce_gets (l_del.item.next)
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					js.return
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 5 then -- if: | ok:
						l_str.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 431))
						l_l := 0
						links_inst.add_to_str (l_str.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_del.item.ext)
						links_inst.add_to_str (l_str.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" -> ")))
						links_inst.add_to_str (l_str.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_del.item.ct)
						bfu_inst.msg_box ([a_term, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_str), create {CE_POINTER [ANY]}.make_shared (default_pointer)])), links_inst.dummyarray + 202, 129, links_inst.dummyarray + 202, ce_string (" "), l_str, ce_string ("?"), create {CE_POINTER [ANY]}.make_shared (default_pointer), a_fcp, 2, links_inst.dummyarray + 166, really_del_ext_address, 1, links_inst.dummyarray + 167, create {CE_POINTER [ANY]}.make_shared (default_pointer), 2])
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	menu_del_ext_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_del_ext)
		end

	menu_add_ext (a_term: CE_POINTER [PD_TERMINAL]; a_fcp: CE_POINTER [ANY]; a_xxx2: CE_POINTER [ANY])
		local
			l_fc: NATURAL_32
			l_new: CE_POINTER [PD_EXTENSION]
			l_from: CE_POINTER [PD_EXTENSION]
			l_ext: CE_POINTER [NATURAL_8]
			l_ct: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [PD_DIALOG]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_new.make
			create l_from.make
			create l_ext.make
			create l_ct.make
			create l_d.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fc := (a_fcp.c_pointer.to_integer_32).to_natural_32
					if not (l_fc.to_boolean) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_from.ce_gets (create {CE_POINTER [PD_EXTENSION]}.make_cast (extensions.next))
				when 2 then -- loop condition:
						if (l_from.c_pointer.to_integer_32).to_natural_32 = ((extensions.address).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						if l_from.item.cnt = l_fc then
							l_pos := -1 + 8 -- goto ok
						end
				when 4 then
						l_from.ce_gets (l_from.item.next)
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
						js.return
				when 6 then -- if done
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 7 then -- if:
						l_from.ce_gets (create {CE_POINTER [PD_EXTENSION]}.make_shared (default_pointer))
				when 8 then -- ok:
						l_d.ce_gets (create {CE_POINTER [PD_DIALOG]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 451, (({PD_DIALOG}.sizeof.to_natural_32 + {NATURAL_32} 5 * {PD_DIALOG_ITEM}.sizeof.to_natural_32) + {PD_EXTENSION}.sizeof.to_natural_32) + {NATURAL_32} 2048))))
						memset (create {CE_POINTER [ANY]}.make_cast (l_d), 0, (({PD_DIALOG}.sizeof.to_natural_32 + {NATURAL_32} 5 * {PD_DIALOG_ITEM}.sizeof.to_natural_32) + {PD_EXTENSION}.sizeof.to_natural_32) + {NATURAL_32} 2048).do_nothing
						l_new.ce_gets (create {CE_POINTER [PD_EXTENSION]}.make_cast ((l_d.item.items + 5)))
						l_ext.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((l_new + 1)))
						l_new.item.ext := l_ext
						l_ct.ce_gets (l_ext + 1024)
						l_new.item.ct := l_ct
						if ((l_from).c_pointer /= default_pointer) then
							strncpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_ext), create {CE_POINTER [INTEGER_8]}.make_cast (l_from.item.ext), (1023).to_natural_32).do_nothing
							strncpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_ct), create {CE_POINTER [INTEGER_8]}.make_cast (l_from.item.ct), (1023).to_natural_32).do_nothing
							l_new.item.cnt := l_from.item.cnt
						end
						l_d.item.title := links_inst.dummyarray + 203
						l_d.item.fn := add_ext_fn_address
						l_d.item.refresh := (update_ext_address)
						l_d.item.refresh_data := create {CE_POINTER [ANY]}.make_cast (l_new)
						l_d.item.items[0].type := 2
						l_d.item.items[0].dlen := 1024
						l_d.item.items[0].data := l_ext
						l_d.item.items[0].fn := bfu_inst.check_nonempty_address
						l_d.item.items[1].type := 2
						l_d.item.items[1].dlen := 1024
						l_d.item.items[1].data := l_ct
						l_d.item.items[1].fn := bfu_inst.check_nonempty_address
						l_d.item.items[2].type := 4
						l_d.item.items[2].gid := 1
						l_d.item.items[2].fn := bfu_inst.ok_dialog_address
						l_d.item.items[2].text := links_inst.dummyarray + 14
						l_d.item.items[3].type := 4
						l_d.item.items[3].gid := 2
						l_d.item.items[3].text := links_inst.dummyarray + 6
						l_d.item.items[3].fn := bfu_inst.cancel_dialog_address
						l_d.item.items[4].type := 0
						bfu_inst.do_dialog (a_term, l_d, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_d), create {CE_POINTER [ANY]}.make_shared (default_pointer)])))
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	menu_add_ext_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_add_ext)
		end

	menu_list_ext (a_term: CE_POINTER [PD_TERMINAL]; a_fn: CE_POINTER [ANY]; a_xxx: CE_POINTER [ANY])
		local
			l_a: CE_POINTER [PD_EXTENSION]
			l_mi: CE_POINTER [PD_MENU_ITEM]
			l_n: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_a.make
			create l_mi.make
			create l_tmp.make

			l_mi.ce_gets (create {CE_POINTER [PD_MENU_ITEM]}.make_shared (default_pointer))
			l_n := 0
			l_a.ce_gets (create {CE_POINTER [PD_EXTENSION]}.make_cast (extensions.prev))
			from
			until
				not (not js.loop_left and then ((l_a.c_pointer.to_integer_32).to_natural_32 /= ((extensions.address).c_pointer.to_integer_32).to_natural_32))
			loop
				if (l_mi).c_pointer = default_pointer then
					l_mi.ce_gets (bfu_inst.new_menu (7))
					if (l_mi).c_pointer = default_pointer then
						js.return
					end
				end
				if not js.return_called then
					l_tmp.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 497, l_a.item.ct))
					bfu_inst.add_to_menu (l_mi.address, (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 497, l_a.item.ext)), l_tmp, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), create {CE_ROUTINE}.make_cast (a_fn), create {CE_POINTER [ANY]}.make_shared (default_pointer + (l_a.item.cnt).to_integer_32), 0)
					l_n := l_n + 1
					l_a.ce_gets (l_a.item.prev)
				end
			end
			if not js.return_called then
				if (l_mi).c_pointer = default_pointer then
					bfu_inst.do_menu (a_term, mi_no_ext, a_xxx)
				else
					bfu_inst.do_menu (a_term, l_mi, a_xxx)
				end
			end
		end

	menu_list_ext_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_list_ext)
		end

	update_prog (a_l: CE_POINTER [PD_LIST_HEAD]; a_p: CE_POINTER [NATURAL_8]; a_s: INTEGER_32)
		local
			l_repl: CE_POINTER [PD_PROTOCOL_PROGRAM]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_repl.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_repl.ce_gets (create {CE_POINTER [PD_PROTOCOL_PROGRAM]}.make_cast (a_l.item.next))
				when 1 then -- loop condition:
					if (l_repl.c_pointer.to_integer_32).to_natural_32 = (a_l.c_pointer.to_integer_32).to_natural_32 then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if l_repl.item.system = a_s then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 507, create {CE_POINTER [ANY]}.make_cast (l_repl.item.prog))
							l_pos := -1 + 5 -- goto ss
						end
				when 3 then
						l_repl.ce_gets (l_repl.item.next)
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					l_repl.ce_gets (create {CE_POINTER [PD_PROTOCOL_PROGRAM]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 510, {PD_PROTOCOL_PROGRAM}.sizeof.to_natural_32))))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_l))
						l_repl.item.next := (create {CE_POINTER [PD_PROTOCOL_PROGRAM]}.make_cast (a_l)).item.next
						l_repl.item.prev := create {CE_POINTER [PD_PROTOCOL_PROGRAM]}.make_cast (a_l);
						(create {CE_POINTER [PD_PROTOCOL_PROGRAM]}.make_cast (a_l)).item.next := l_repl;
						(l_repl.item.next).item.prev := l_repl
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_l))
						js.break
					end
					js.reset
					l_repl.item.system := a_s
				when 5 then -- ss:
					l_repl.item.prog := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("types.c")), 514, (1024).to_natural_32)))
					strncpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_repl.item.prog), create {CE_POINTER [INTEGER_8]}.make_cast (a_p), (1024).to_natural_32).do_nothing
					l_repl.item.prog[1023] := (0).to_natural_8
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_prog (a_l: CE_POINTER [PD_LIST_HEAD]): CE_POINTER [NATURAL_8]
		local
			l_repl: CE_POINTER [PD_PROTOCOL_PROGRAM]
			js: JUMP_STATE
		do
			create l_repl.make

			l_repl.ce_gets (create {CE_POINTER [PD_PROTOCOL_PROGRAM]}.make_cast (a_l.item.next))
			from
			until
				not (not js.loop_left and then ((l_repl.c_pointer.to_integer_32).to_natural_32 /= (a_l.c_pointer.to_integer_32).to_natural_32))
			loop
				if l_repl.item.system = 1 then
					Result := (l_repl.item.prog)
					js.return
				end
				if not js.return_called then
					l_repl.ce_gets (l_repl.item.next)
				end
			end
			if not js.return_called then
				update_prog (a_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 1)
				l_repl.ce_gets (create {CE_POINTER [PD_PROTOCOL_PROGRAM]}.make_cast (a_l.item.next))
				from
				until
					not (not js.loop_left and then ((l_repl.c_pointer.to_integer_32).to_natural_32 /= (a_l.c_pointer.to_integer_32).to_natural_32))
				loop
					if l_repl.item.system = 1 then
						Result := (l_repl.item.prog)
						js.return
					end
					if not js.return_called then
						l_repl.ce_gets (l_repl.item.next)
					end
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	is_html_type (a_ct: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___3: INTEGER_32
		do
			if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_ct), ce_string ("text/html"))).to_boolean then
				if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_ct), ce_string ("text/x-server-parsed-html"))).to_boolean then
					if (links_inst.casecmp (a_ct, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("application/xhtml")), (strlen (ce_string ("application/xhtml"))))).to_boolean then
						l_tmp___3 := 0
					else
						l_tmp___3 := 1
					end
				else
					l_tmp___3 := 1
				end
			else
				l_tmp___3 := 1
			end
			Result := l_tmp___3
		end

end
