class
	SD_GROUP

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	gr_name: CE_POINTER [INTEGER_8] assign set_gr_name
		do
			create Result.make_shared (c_gr_name (c_pointer))
		end

	gr_passwd: CE_POINTER [INTEGER_8] assign set_gr_passwd
		do
			create Result.make_shared (c_gr_passwd (c_pointer))
		end

	gr_gid: NATURAL_32 assign set_gr_gid
		do
			Result := c_gr_gid (c_pointer)
		end

	gr_mem: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_gr_mem
		do
			create Result.make_shared (c_gr_mem (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_gr_name (a_gr_name: CE_POINTER [INTEGER_8])
		do
			c_set_gr_name (c_pointer, a_gr_name.c_pointer)
		end

	set_gr_passwd (a_gr_passwd: CE_POINTER [INTEGER_8])
		do
			c_set_gr_passwd (c_pointer, a_gr_passwd.c_pointer)
		end

	set_gr_gid (a_gr_gid: NATURAL_32)
		do
			c_set_gr_gid (c_pointer, a_gr_gid)
		end

	set_gr_mem (a_gr_mem: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			c_set_gr_mem (c_pointer, a_gr_mem.c_pointer)
		end

feature {NONE} -- C getters

	c_gr_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct group *)$tmp)->gr_name;"
		end

	c_gr_passwd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct group *)$tmp)->gr_passwd;"
		end

	c_gr_gid (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct group *)$tmp)->gr_gid;"
		end

	c_gr_mem (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char * *)((struct group *)$tmp)->gr_mem;"
		end

feature {NONE} -- C setters

	c_set_gr_name (tmp: POINTER; a_gr_name: POINTER)
		external
			"C inline"
		alias
			"((struct group *)$tmp)->gr_name = (char *)$a_gr_name;"
		end

	c_set_gr_passwd (tmp: POINTER; a_gr_passwd: POINTER)
		external
			"C inline"
		alias
			"((struct group *)$tmp)->gr_passwd = (char *)$a_gr_passwd;"
		end

	c_set_gr_gid (tmp: POINTER; a_gr_gid: NATURAL_32)
		external
			"C inline"
		alias
			"((struct group *)$tmp)->gr_gid = $a_gr_gid;"
		end

	c_set_gr_mem (tmp: POINTER; a_gr_mem: POINTER)
		external
			"C inline"
		alias
			"((struct group *)$tmp)->gr_mem = (char * *)$a_gr_mem;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct group);"
		end

end
