class
	SD_SIFIELDS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	pad: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_pad (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	kill: SD_KILL assign set_kill
		do
			create Result.make_shared (c_kill (c_pointer))
		end

	timer: SD_TIMER assign set_timer
		do
			create Result.make_shared (c_timer (c_pointer))
		end

	rt: SD_RT assign set_rt
		do
			create Result.make_shared (c_rt (c_pointer))
		end

	sigchld: SD_SIGCHLD assign set_sigchld
		do
			create Result.make_shared (c_sigchld (c_pointer))
		end

	sigfault: SD_SIGFAULT assign set_sigfault
		do
			create Result.make_shared (c_sigfault (c_pointer))
		end

	sigpoll: SD_SIGPOLL assign set_sigpoll
		do
			create Result.make_shared (c_sigpoll (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_kill (a_kill: SD_KILL)
		do
			kill.ce_gets (a_kill)
		end

	set_timer (a_timer: SD_TIMER)
		do
			timer.ce_gets (a_timer)
		end

	set_rt (a_rt: SD_RT)
		do
			rt.ce_gets (a_rt)
		end

	set_sigchld (a_sigchld: SD_SIGCHLD)
		do
			sigchld.ce_gets (a_sigchld)
		end

	set_sigfault (a_sigfault: SD_SIGFAULT)
		do
			sigfault.ce_gets (a_sigfault)
		end

	set_sigpoll (a_sigpoll: SD_SIGPOLL)
		do
			sigpoll.ce_gets (a_sigpoll)
		end

feature {NONE} -- C getters

	c_pad (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				union __anonunion__sifields_31 *tmp = (union __anonunion__sifields_31 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->_pad) / sizeof(tmp->_pad[0]);
				return tmp->_pad;
			]"
		end

	c_kill (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct__kill_32 *)&((union __anonunion__sifields_31 *)$tmp)->_kill;"
		end

	c_timer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct__timer_33 *)&((union __anonunion__sifields_31 *)$tmp)->_timer;"
		end

	c_rt (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct__rt_34 *)&((union __anonunion__sifields_31 *)$tmp)->_rt;"
		end

	c_sigchld (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct__sigchld_35 *)&((union __anonunion__sifields_31 *)$tmp)->_sigchld;"
		end

	c_sigfault (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct__sigfault_36 *)&((union __anonunion__sifields_31 *)$tmp)->_sigfault;"
		end

	c_sigpoll (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct__sigpoll_37 *)&((union __anonunion__sifields_31 *)$tmp)->_sigpoll;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(union __anonunion__sifields_31);"
		end

end
