class
	SD_SIGACTION_HANDLER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sa_handler: CE_ROUTINE assign set_sa_handler
		do
			create Result.make_shared (c_sa_handler (c_pointer))
		end

	sa_sigaction: CE_ROUTINE assign set_sa_sigaction
		do
			create Result.make_shared (c_sa_sigaction (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_sa_handler (a_sa_handler: CE_ROUTINE)
		do
			c_set_sa_handler (c_pointer, a_sa_handler.c_pointer)
		end

	set_sa_sigaction (a_sa_sigaction: CE_ROUTINE)
		do
			c_set_sa_sigaction (c_pointer, a_sa_sigaction.c_pointer)
		end

feature {NONE} -- C getters

	c_sa_handler (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(int))((union __anonunion___sigaction_handler_49 *)$tmp)->sa_handler;"
		end

	c_sa_sigaction (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(int, struct siginfo *, void *))((union __anonunion___sigaction_handler_49 *)$tmp)->sa_sigaction;"
		end

feature {NONE} -- C setters

	c_set_sa_handler (tmp: POINTER; a_sa_handler: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion___sigaction_handler_49 *)$tmp)->sa_handler = (void( *)(int))$a_sa_handler;"
		end

	c_set_sa_sigaction (tmp: POINTER; a_sa_sigaction: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion___sigaction_handler_49 *)$tmp)->sa_sigaction = (void( *)(int, struct siginfo *, void *))$a_sa_sigaction;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(union __anonunion___sigaction_handler_49);"
		end

end
