class
	SD_SOCKADDR_UN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sun_family: NATURAL_16 assign set_sun_family
		do
			Result := c_sun_family (c_pointer)
		end

	sun_path: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_sun_path (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	sun_path_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct sockaddr_un, sun_path);"
		end

feature {ANY} -- Eiffel setters

	set_sun_family (a_sun_family: NATURAL_16)
		do
			c_set_sun_family (c_pointer, a_sun_family)
		end

feature {NONE} -- C getters

	c_sun_family (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct sockaddr_un *)$tmp)->sun_family;"
		end

	c_sun_path (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct sockaddr_un *tmp = (struct sockaddr_un *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->sun_path) / sizeof(tmp->sun_path[0]);
				return tmp->sun_path;
			]"
		end

feature {NONE} -- C setters

	c_set_sun_family (tmp: POINTER; a_sun_family: NATURAL_16)
		external
			"C inline"
		alias
			"((struct sockaddr_un *)$tmp)->sun_family = $a_sun_family;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct sockaddr_un);"
		end

end
