class
	SD_TERMIOS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	c2_iflag: NATURAL_32 assign set_c2_iflag
		do
			Result := c_c2_iflag (c_pointer)
		end

	c2_oflag: NATURAL_32 assign set_c2_oflag
		do
			Result := c_c2_oflag (c_pointer)
		end

	c2_cflag: NATURAL_32 assign set_c2_cflag
		do
			Result := c_c2_cflag (c_pointer)
		end

	c2_lflag: NATURAL_32 assign set_c2_lflag
		do
			Result := c_c2_lflag (c_pointer)
		end

	c2_line: NATURAL_8 assign set_c2_line
		do
			Result := c_c2_line (c_pointer)
		end

	c2_cc: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_c2_cc (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	c2_ispeed: NATURAL_32 assign set_c2_ispeed
		do
			Result := c_c2_ispeed (c_pointer)
		end

	c2_ospeed: NATURAL_32 assign set_c2_ospeed
		do
			Result := c_c2_ospeed (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_c2_iflag (a_c2_iflag: NATURAL_32)
		do
			c_set_c2_iflag (c_pointer, a_c2_iflag)
		end

	set_c2_oflag (a_c2_oflag: NATURAL_32)
		do
			c_set_c2_oflag (c_pointer, a_c2_oflag)
		end

	set_c2_cflag (a_c2_cflag: NATURAL_32)
		do
			c_set_c2_cflag (c_pointer, a_c2_cflag)
		end

	set_c2_lflag (a_c2_lflag: NATURAL_32)
		do
			c_set_c2_lflag (c_pointer, a_c2_lflag)
		end

	set_c2_line (a_c2_line: NATURAL_8)
		do
			c_set_c2_line (c_pointer, a_c2_line)
		end

	set_c2_ispeed (a_c2_ispeed: NATURAL_32)
		do
			c_set_c2_ispeed (c_pointer, a_c2_ispeed)
		end

	set_c2_ospeed (a_c2_ospeed: NATURAL_32)
		do
			c_set_c2_ospeed (c_pointer, a_c2_ospeed)
		end

feature {NONE} -- C getters

	c_c2_iflag (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct termios *)$tmp)->c_iflag;"
		end

	c_c2_oflag (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct termios *)$tmp)->c_oflag;"
		end

	c_c2_cflag (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct termios *)$tmp)->c_cflag;"
		end

	c_c2_lflag (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct termios *)$tmp)->c_lflag;"
		end

	c_c2_line (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct termios *)$tmp)->c_line;"
		end

	c_c2_cc (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct termios *tmp = (struct termios *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->c_cc) / sizeof(tmp->c_cc[0]);
				return tmp->c_cc;
			]"
		end

	c_c2_ispeed (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct termios *)$tmp)->c_ispeed;"
		end

	c_c2_ospeed (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct termios *)$tmp)->c_ospeed;"
		end

feature {NONE} -- C setters

	c_set_c2_iflag (tmp: POINTER; a_c2_iflag: NATURAL_32)
		external
			"C inline"
		alias
			"((struct termios *)$tmp)->c_iflag = $a_c2_iflag;"
		end

	c_set_c2_oflag (tmp: POINTER; a_c2_oflag: NATURAL_32)
		external
			"C inline"
		alias
			"((struct termios *)$tmp)->c_oflag = $a_c2_oflag;"
		end

	c_set_c2_cflag (tmp: POINTER; a_c2_cflag: NATURAL_32)
		external
			"C inline"
		alias
			"((struct termios *)$tmp)->c_cflag = $a_c2_cflag;"
		end

	c_set_c2_lflag (tmp: POINTER; a_c2_lflag: NATURAL_32)
		external
			"C inline"
		alias
			"((struct termios *)$tmp)->c_lflag = $a_c2_lflag;"
		end

	c_set_c2_line (tmp: POINTER; a_c2_line: NATURAL_8)
		external
			"C inline"
		alias
			"((struct termios *)$tmp)->c_line = $a_c2_line;"
		end

	c_set_c2_ispeed (tmp: POINTER; a_c2_ispeed: NATURAL_32)
		external
			"C inline"
		alias
			"((struct termios *)$tmp)->c_ispeed = $a_c2_ispeed;"
		end

	c_set_c2_ospeed (tmp: POINTER; a_c2_ospeed: NATURAL_32)
		external
			"C inline"
		alias
			"((struct termios *)$tmp)->c_ospeed = $a_c2_ospeed;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct termios);"
		end

end
