class
	SD_TIMEVAL

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	tv_sec: INTEGER_32 assign set_tv_sec
		do
			Result := c_tv_sec (c_pointer)
		end

	tv_usec: INTEGER_32 assign set_tv_usec
		do
			Result := c_tv_usec (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_tv_sec (a_tv_sec: INTEGER_32)
		do
			c_set_tv_sec (c_pointer, a_tv_sec)
		end

	set_tv_usec (a_tv_usec: INTEGER_32)
		do
			c_set_tv_usec (c_pointer, a_tv_usec)
		end

feature {NONE} -- C getters

	c_tv_sec (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct timeval *)$tmp)->tv_sec;"
		end

	c_tv_usec (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct timeval *)$tmp)->tv_usec;"
		end

feature {NONE} -- C setters

	c_set_tv_sec (tmp: POINTER; a_tv_sec: INTEGER_32)
		external
			"C inline"
		alias
			"((struct timeval *)$tmp)->tv_sec = $a_tv_sec;"
		end

	c_set_tv_usec (tmp: POINTER; a_tv_usec: INTEGER_32)
		external
			"C inline"
		alias
			"((struct timeval *)$tmp)->tv_usec = $a_tv_usec;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct timeval);"
		end

end
