deferred class
	S_SIGNAL

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	raise (a_sig: INTEGER_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return raise($a_sig);"
		end

	kill (a_pid: INTEGER_32; a_sig: INTEGER_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return kill($a_pid, $a_sig);"
		end

	signal (a_sig: INTEGER_32; a_handler: CE_ROUTINE): CE_ROUTINE
		do
			create Result.make_shared (c_signal (a_sig, a_handler.c_pointer))
		end

	c_signal (a_sig: INTEGER_32; a_handler: POINTER): POINTER
		external
			"C inline use <links.h>"
		alias
			"return signal($a_sig, $a_handler);"
		end

	sigfillset (a_set: CE_POINTER [SD_SIGSET_T]): INTEGER_32
		do
			Result := c_sigfillset (a_set.c_pointer)
		end

	c_sigfillset (a_set: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sigfillset($a_set);"
		end

	sigaction (a_sig: INTEGER_32; a_act: CE_POINTER [SD_SIGACTION]; a_oact: CE_POINTER [SD_SIGACTION]): INTEGER_32
		do
			Result := c_sigaction (a_sig, a_act.c_pointer, a_oact.c_pointer)
		end

	c_sigaction (a_sig: INTEGER_32; a_act: POINTER; a_oact: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sigaction($a_sig, $a_act, $a_oact);"
		end

end
