deferred class
	S_STDIO

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	remove (a_filename: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_remove (a_filename.c_pointer)
		end

	c_remove (a_filename: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return remove($a_filename);"
		end

	rename2 (a_old: CE_POINTER [INTEGER_8]; a_new: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_rename2 (a_old.c_pointer, a_new.c_pointer)
		end

	c_rename2 (a_old: POINTER; a_new: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return rename($a_old, $a_new);"
		end

	fclose (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fclose (a_stream.c_pointer)
		end

	c_fclose (a_stream: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return fclose($a_stream);"
		end

	fopen (a_filename: CE_POINTER [INTEGER_8]; a_modes: CE_POINTER [INTEGER_8]): CE_POINTER [SD_IO_FILE]
		do
			create Result.make_shared (c_fopen (a_filename.c_pointer, a_modes.c_pointer))
		end

	c_fopen (a_filename: POINTER; a_modes: POINTER): POINTER
		external
			"C inline use <links.h>"
		alias
			"return fopen($a_filename, $a_modes);"
		end

	fputc (a_c: INTEGER_32; a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fputc (a_c, a_stream.c_pointer)
		end

	c_fputc (a_c: INTEGER_32; a_stream: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return fputc($a_c, $a_stream);"
		end

	fgets (a_s: CE_POINTER [INTEGER_8]; a_n: INTEGER_32; a_stream: CE_POINTER [SD_IO_FILE]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_fgets (a_s.c_pointer, a_n, a_stream.c_pointer))
		end

	c_fgets (a_s: POINTER; a_n: INTEGER_32; a_stream: POINTER): POINTER
		external
			"C inline use <links.h>"
		alias
			"return fgets($a_s, $a_n, $a_stream);"
		end

	fputs (a_s: CE_POINTER [INTEGER_8]; a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fputs (a_s.c_pointer, a_stream.c_pointer)
		end

	c_fputs (a_s: POINTER; a_stream: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return fputs($a_s, $a_stream);"
		end

	ferror (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_ferror (a_stream.c_pointer)
		end

	c_ferror (a_stream: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return ferror($a_stream);"
		end

	fflush (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fflush (a_stream.c_pointer)
		end

	c_fflush (a_stream: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return fflush($a_stream);"
		end

	fprintf (a_args: TUPLE [a_stream: CE_POINTER [SD_IO_FILE]; a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_fprintf)).integer_32_item (a_args)
		end

	c_fprintf: POINTER
		external
			"C inline use <links.h>"
		alias
			"return &fprintf;"
		end

	fread (a_ptr: CE_POINTER [ANY]; a_size: NATURAL_32; a_n: NATURAL_32; a_stream: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fread (a_ptr.c_pointer, a_size, a_n, a_stream.c_pointer)
		end

	c_fread (a_ptr: POINTER; a_size: NATURAL_32; a_n: NATURAL_32; a_stream: POINTER): NATURAL_32
		external
			"C inline use <links.h>"
		alias
			"return fread($a_ptr, $a_size, $a_n, $a_stream);"
		end

	popen (a_command: CE_POINTER [INTEGER_8]; a_modes: CE_POINTER [INTEGER_8]): CE_POINTER [SD_IO_FILE]
		do
			create Result.make_shared (c_popen (a_command.c_pointer, a_modes.c_pointer))
		end

	c_popen (a_command: POINTER; a_modes: POINTER): POINTER
		external
			"C inline use <links.h>"
		alias
			"return popen($a_command, $a_modes);"
		end

	pclose (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_pclose (a_stream.c_pointer)
		end

	c_pclose (a_stream: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return pclose($a_stream);"
		end

	sprintf (a_args: TUPLE [a_s: CE_POINTER [INTEGER_8]; a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_sprintf)).integer_32_item (a_args)
		end

	c_sprintf: POINTER
		external
			"C inline use <links.h>"
		alias
			"return &sprintf;"
		end

	vfprintf (a_s: CE_POINTER [SD_IO_FILE]; a_format: CE_POINTER [INTEGER_8]; a_arg: CE_VA_LIST): INTEGER_32
		do
			Result := c_vfprintf (a_s.c_pointer, a_format.c_pointer, a_arg.c_pointer)
		end

	c_vfprintf (a_s: POINTER; a_format: POINTER; a_arg: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return vfprintf($a_s, $a_format, $a_arg);"
		end

	tempnam (a_dir: CE_POINTER [INTEGER_8]; a_pfx: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_tempnam (a_dir.c_pointer, a_pfx.c_pointer))
		end

	c_tempnam (a_dir: POINTER; a_pfx: POINTER): POINTER
		external
			"C inline use <links.h>"
		alias
			"return tempnam($a_dir, $a_pfx);"
		end

end
