deferred class
	S_STDLIB

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	exit (a_status: INTEGER_32)
		external
			"C inline use <links.h>"
		alias
			"exit($a_status);"
		end

	strtol (a_nptr: CE_POINTER [INTEGER_8]; a_endptr: CE_POINTER [CE_POINTER [INTEGER_8]]; a_base: INTEGER_32): INTEGER_32
		do
			Result := c_strtol (a_nptr.c_pointer, a_endptr.c_pointer, a_base)
		end

	c_strtol (a_nptr: POINTER; a_endptr: POINTER; a_base: INTEGER_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return strtol($a_nptr, $a_endptr, $a_base);"
		end

	getenv (a_name: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_getenv (a_name.c_pointer))
		end

	c_getenv (a_name: POINTER): POINTER
		external
			"C inline use <links.h>"
		alias
			"return getenv($a_name);"
		end

	malloc (a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared_with_count (
					default_pointer.memory_alloc (a_size.to_integer_32),
					a_size.to_integer_32
				)
		end

	free (a_ptr: CE_POINTER [ANY])
		do
			c_free (a_ptr.c_pointer)
		end

	c_free (a_ptr: POINTER)
		external
			"C inline use <links.h>"
		alias
			"free($a_ptr);"
		end

	realloc (a_ptr: CE_POINTER [ANY]; a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared_with_count (
					a_ptr.c_pointer.memory_realloc (a_size.to_integer_32),
					a_size.to_integer_32
				)
		end

	qsort (a_base: CE_POINTER [ANY]; a_nmemb: NATURAL_32; a_size: NATURAL_32; a_compar: CE_ROUTINE)
		do
			c_qsort (a_base.c_pointer, a_nmemb, a_size, a_compar.c_pointer)
		end

	c_qsort (a_base: POINTER; a_nmemb: NATURAL_32; a_size: NATURAL_32; a_compar: POINTER)
		external
			"C inline use <links.h>"
		alias
			"qsort($a_base, $a_nmemb, $a_size, $a_compar);"
		end

	strtoul (a_nptr: CE_POINTER [INTEGER_8]; a_endptr: CE_POINTER [CE_POINTER [INTEGER_8]]; a_base: INTEGER_32): NATURAL_32
		do
			Result := c_strtoul (a_nptr.c_pointer, a_endptr.c_pointer, a_base)
		end

	c_strtoul (a_nptr: POINTER; a_endptr: POINTER; a_base: INTEGER_32): NATURAL_32
		external
			"C inline use <links.h>"
		alias
			"return strtoul($a_nptr, $a_endptr, $a_base);"
		end

	strtoll (a_nptr: CE_POINTER [INTEGER_8]; a_endptr: CE_POINTER [CE_POINTER [INTEGER_8]]; a_base: INTEGER_32): INTEGER_64
		do
			Result := c_strtoll (a_nptr.c_pointer, a_endptr.c_pointer, a_base)
		end

	c_strtoll (a_nptr: POINTER; a_endptr: POINTER; a_base: INTEGER_32): INTEGER_64
		external
			"C inline use <links.h>"
		alias
			"return strtoll($a_nptr, $a_endptr, $a_base);"
		end

	atoi (a_nptr: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_atoi (a_nptr.c_pointer)
		end

	c_atoi (a_nptr: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return atoi($a_nptr);"
		end

	system (a_command: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_system (a_command.c_pointer)
		end

	c_system (a_command: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return system($a_command);"
		end

end
