deferred class
	S_STRING

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	memcpy (a_dest: CE_POINTER [ANY]; a_src: CE_POINTER [ANY]; a_n: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_memcpy (a_dest.c_pointer, a_src.c_pointer, a_n))
		end

	c_memcpy (a_dest: POINTER; a_src: POINTER; a_n: NATURAL_32): POINTER
		external
			"C inline use <links.h>"
		alias
			"return memcpy($a_dest, $a_src, $a_n);"
		end

	memset (a_s: CE_POINTER [ANY]; a_c: INTEGER_32; a_n: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_memset (a_s.c_pointer, a_c, a_n))
		end

	c_memset (a_s: POINTER; a_c: INTEGER_32; a_n: NATURAL_32): POINTER
		external
			"C inline use <links.h>"
		alias
			"return memset($a_s, $a_c, $a_n);"
		end

	strcpy (a_dest: CE_POINTER [INTEGER_8]; a_src: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strcpy (a_dest.c_pointer, a_src.c_pointer))
		end

	c_strcpy (a_dest: POINTER; a_src: POINTER): POINTER
		external
			"C inline use <links.h>"
		alias
			"return strcpy($a_dest, $a_src);"
		end

	strcat (a_dest: CE_POINTER [INTEGER_8]; a_src: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strcat (a_dest.c_pointer, a_src.c_pointer))
		end

	c_strcat (a_dest: POINTER; a_src: POINTER): POINTER
		external
			"C inline use <links.h>"
		alias
			"return strcat($a_dest, $a_src);"
		end

	strlen (a_s: CE_POINTER [INTEGER_8]): NATURAL_32
		do
			Result := c_strlen (a_s.c_pointer)
		end

	c_strlen (a_s: POINTER): NATURAL_32
		external
			"C inline use <links.h>"
		alias
			"return strlen($a_s);"
		end

	memmove (a_dest: CE_POINTER [ANY]; a_src: CE_POINTER [ANY]; a_n: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_memmove (a_dest.c_pointer, a_src.c_pointer, a_n))
		end

	c_memmove (a_dest: POINTER; a_src: POINTER; a_n: NATURAL_32): POINTER
		external
			"C inline use <links.h>"
		alias
			"return memmove($a_dest, $a_src, $a_n);"
		end

	strncpy (a_dest: CE_POINTER [INTEGER_8]; a_src: CE_POINTER [INTEGER_8]; a_n: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strncpy (a_dest.c_pointer, a_src.c_pointer, a_n))
		end

	c_strncpy (a_dest: POINTER; a_src: POINTER; a_n: NATURAL_32): POINTER
		external
			"C inline use <links.h>"
		alias
			"return strncpy($a_dest, $a_src, $a_n);"
		end

	strcmp (a_s1: CE_POINTER [INTEGER_8]; a_s2: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_strcmp (a_s1.c_pointer, a_s2.c_pointer)
		end

	c_strcmp (a_s1: POINTER; a_s2: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return strcmp($a_s1, $a_s2);"
		end

	strncmp (a_s1: CE_POINTER [INTEGER_8]; a_s2: CE_POINTER [INTEGER_8]; a_n: NATURAL_32): INTEGER_32
		do
			Result := c_strncmp (a_s1.c_pointer, a_s2.c_pointer, a_n)
		end

	c_strncmp (a_s1: POINTER; a_s2: POINTER; a_n: NATURAL_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return strncmp($a_s1, $a_s2, $a_n);"
		end

	strchr (a_s: CE_POINTER [INTEGER_8]; a_c: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strchr (a_s.c_pointer, a_c))
		end

	c_strchr (a_s: POINTER; a_c: INTEGER_32): POINTER
		external
			"C inline use <links.h>"
		alias
			"return strchr($a_s, $a_c);"
		end

	memcmp (a_s1: CE_POINTER [ANY]; a_s2: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		do
			Result := c_memcmp (a_s1.c_pointer, a_s2.c_pointer, a_n)
		end

	c_memcmp (a_s1: POINTER; a_s2: POINTER; a_n: NATURAL_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return memcmp($a_s1, $a_s2, $a_n);"
		end

	strcasecmp (a_s1: CE_POINTER [INTEGER_8]; a_s2: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_strcasecmp (a_s1.c_pointer, a_s2.c_pointer)
		end

	c_strcasecmp (a_s1: POINTER; a_s2: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return strcasecmp($a_s1, $a_s2);"
		end

	strstr (a_haystack: CE_POINTER [INTEGER_8]; a_needle: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strstr (a_haystack.c_pointer, a_needle.c_pointer))
		end

	c_strstr (a_haystack: POINTER; a_needle: POINTER): POINTER
		external
			"C inline use <links.h>"
		alias
			"return strstr($a_haystack, $a_needle);"
		end

	strerror (a_errnum: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strerror (a_errnum))
		end

	c_strerror (a_errnum: INTEGER_32): POINTER
		external
			"C inline use <links.h>"
		alias
			"return strerror($a_errnum);"
		end

	memchr (a_s: CE_POINTER [ANY]; a_c: INTEGER_32; a_n: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_memchr (a_s.c_pointer, a_c, a_n))
		end

	c_memchr (a_s: POINTER; a_c: INTEGER_32; a_n: NATURAL_32): POINTER
		external
			"C inline use <links.h>"
		alias
			"return memchr($a_s, $a_c, $a_n);"
		end

	strcspn (a_s: CE_POINTER [INTEGER_8]; a_reject: CE_POINTER [INTEGER_8]): NATURAL_32
		do
			Result := c_strcspn (a_s.c_pointer, a_reject.c_pointer)
		end

	c_strcspn (a_s: POINTER; a_reject: POINTER): NATURAL_32
		external
			"C inline use <links.h>"
		alias
			"return strcspn($a_s, $a_reject);"
		end

end
