deferred class
	S_SYS_SOCKET

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	socket (a_domain: INTEGER_32; a_type: INTEGER_32; a_protocol: INTEGER_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return socket($a_domain, $a_type, $a_protocol);"
		end

	bind (a_fd: INTEGER_32; a_addr: CE_POINTER [SD_SOCKADDR]; a_len: NATURAL_32): INTEGER_32
		do
			Result := c_bind (a_fd, a_addr.c_pointer, a_len)
		end

	c_bind (a_fd: INTEGER_32; a_addr: POINTER; a_len: NATURAL_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return bind($a_fd, $a_addr, $a_len);"
		end

	connect (a_fd: INTEGER_32; a_addr: CE_POINTER [SD_SOCKADDR]; a_len: NATURAL_32): INTEGER_32
		do
			Result := c_connect (a_fd, a_addr.c_pointer, a_len)
		end

	c_connect (a_fd: INTEGER_32; a_addr: POINTER; a_len: NATURAL_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return connect($a_fd, $a_addr, $a_len);"
		end

	setsockopt (a_fd: INTEGER_32; a_level: INTEGER_32; a_optname: INTEGER_32; a_optval: CE_POINTER [ANY]; a_optlen: NATURAL_32): INTEGER_32
		do
			Result := c_setsockopt (a_fd, a_level, a_optname, a_optval.c_pointer, a_optlen)
		end

	c_setsockopt (a_fd: INTEGER_32; a_level: INTEGER_32; a_optname: INTEGER_32; a_optval: POINTER; a_optlen: NATURAL_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return setsockopt($a_fd, $a_level, $a_optname, $a_optval, $a_optlen);"
		end

	listen (a_fd: INTEGER_32; a_n: INTEGER_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return listen($a_fd, $a_n);"
		end

	accept (a_fd: INTEGER_32; a_addr: CE_POINTER [SD_SOCKADDR]; a_addr_len: CE_POINTER [NATURAL_32]): INTEGER_32
		do
			Result := c_accept (a_fd, a_addr.c_pointer, a_addr_len.c_pointer)
		end

	c_accept (a_fd: INTEGER_32; a_addr: POINTER; a_addr_len: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return accept($a_fd, $a_addr, $a_addr_len);"
		end

	getsockname (a_fd: INTEGER_32; a_addr: CE_POINTER [SD_SOCKADDR]; a_len: CE_POINTER [NATURAL_32]): INTEGER_32
		do
			Result := c_getsockname (a_fd, a_addr.c_pointer, a_len.c_pointer)
		end

	c_getsockname (a_fd: INTEGER_32; a_addr: POINTER; a_len: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return getsockname($a_fd, $a_addr, $a_len);"
		end

	getsockopt (a_fd: INTEGER_32; a_level: INTEGER_32; a_optname: INTEGER_32; a_optval: CE_POINTER [ANY]; a_optlen: CE_POINTER [NATURAL_32]): INTEGER_32
		do
			Result := c_getsockopt (a_fd, a_level, a_optname, a_optval.c_pointer, a_optlen.c_pointer)
		end

	c_getsockopt (a_fd: INTEGER_32; a_level: INTEGER_32; a_optname: INTEGER_32; a_optval: POINTER; a_optlen: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return getsockopt($a_fd, $a_level, $a_optname, $a_optval, $a_optlen);"
		end

	getpeername (a_fd: INTEGER_32; a_addr: CE_POINTER [SD_SOCKADDR]; a_len: CE_POINTER [NATURAL_32]): INTEGER_32
		do
			Result := c_getpeername (a_fd, a_addr.c_pointer, a_len.c_pointer)
		end

	c_getpeername (a_fd: INTEGER_32; a_addr: POINTER; a_len: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return getpeername($a_fd, $a_addr, $a_len);"
		end

end
