deferred class
	S_UNISTD

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	close (a_fd: INTEGER_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return close($a_fd);"
		end

	unlink (a_name: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_unlink (a_name.c_pointer)
		end

	c_unlink (a_name: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return unlink($a_name);"
		end

	getpagesize: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return getpagesize();"
		end

	read (a_fd: INTEGER_32; a_buf: CE_POINTER [ANY]; a_nbytes: NATURAL_32): INTEGER_32
		do
			Result := c_read (a_fd, a_buf.c_pointer, a_nbytes)
		end

	c_read (a_fd: INTEGER_32; a_buf: POINTER; a_nbytes: NATURAL_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return read($a_fd, $a_buf, $a_nbytes);"
		end

	write (a_fd: INTEGER_32; a_buf: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		do
			Result := c_write (a_fd, a_buf.c_pointer, a_n)
		end

	c_write (a_fd: INTEGER_32; a_buf: POINTER; a_n: NATURAL_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return write($a_fd, $a_buf, $a_n);"
		end

	sleep (a_seconds: NATURAL_32): NATURAL_32
		external
			"C inline use <links.h>"
		alias
			"return sleep($a_seconds);"
		end

	readlink (a_path: CE_POINTER [INTEGER_8]; a_buf: CE_POINTER [INTEGER_8]; a_len: NATURAL_32): INTEGER_32
		do
			Result := c_readlink (a_path.c_pointer, a_buf.c_pointer, a_len)
		end

	c_readlink (a_path: POINTER; a_buf: POINTER; a_len: NATURAL_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return readlink($a_path, $a_buf, $a_len);"
		end

	getpid: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return getpid();"
		end

	fork: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return eiffel_fork();"
		end

	pipe (a_pipedes: CE_POINTER [INTEGER_32]): INTEGER_32
		do
			Result := c_pipe (a_pipedes.c_pointer)
		end

	c_pipe (a_pipedes: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return pipe($a_pipedes);"
		end

	exit2 (a_status: INTEGER_32)
		external
			"C inline use <links.h>"
		alias
			"_exit($a_status);"
		end

	chdir (a_path: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_chdir (a_path.c_pointer)
		end

	c_chdir (a_path: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return chdir($a_path);"
		end

	dup2 (a_fd: INTEGER_32; a_fd2: INTEGER_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return dup2($a_fd, $a_fd2);"
		end

	execvp (a_file: CE_POINTER [INTEGER_8]; a_argv: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := c_execvp (a_file.c_pointer, a_argv.c_pointer)
		end

	c_execvp (a_file: POINTER; a_argv: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return execvp($a_file, $a_argv);"
		end

	getcwd (a_buf: CE_POINTER [INTEGER_8]; a_size: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_getcwd (a_buf.c_pointer, a_size))
		end

	c_getcwd (a_buf: POINTER; a_size: NATURAL_32): POINTER
		external
			"C inline use <links.h>"
		alias
			"return getcwd($a_buf, $a_size);"
		end

	setpgid (a_pid: INTEGER_32; a_pgid: INTEGER_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return setpgid($a_pid, $a_pgid);"
		end

end
