class
	CE_UTILITIES

feature {ANY} -- string utilities

	ce_string (a_s: STRING_8): CE_ARRAY [INTEGER_8]
		require
			a_s /= Void
		local
			l_i: INTEGER_32
		do
			Result := static_string_storage[a_s]
			if Result = Void then
				create Result.make (<<a_s.count + 1>>)
				from
					l_i := 1
				until
					l_i > a_s.count
				loop
					Result[l_i - 1] := a_s[l_i].code.to_integer_8
					l_i := l_i + 1
				end
				static_string_storage[a_s] := Result
			end
		ensure
			Result /= Void
		end

	eif_string (a_p: CE_POINTER [INTEGER_8]): STRING
		require
			a_p /= Void
		do
			create Result.make_from_c (a_p.c_pointer)
		ensure
			Result /= Void
		end

feature {ANY} -- REAL_96 utilities

	Real_96_bytes: INTEGER_32 = 12

	real_96_from_integer_8 (a_value: INTEGER_8): REAL_96
		do
			Result.set_from_integer_8 (a_value)
		end

	real_96_from_integer_16 (a_value: INTEGER_16): REAL_96
		do
			Result.set_from_integer_16 (a_value)
		end

	real_96_from_integer_32 (a_value: INTEGER_32): REAL_96
		do
			Result.set_from_integer_32 (a_value)
		end

	real_96_from_integer_64 (a_value: INTEGER_64): REAL_96
		do
			Result.set_from_integer_64 (a_value)
		end

	real_96_from_natural_8 (a_value: NATURAL_8): REAL_96
		do
			Result.set_from_natural_8 (a_value)
		end

	real_96_from_natural_16 (a_value: NATURAL_16): REAL_96
		do
			Result.set_from_natural_16 (a_value)
		end

	real_96_from_natural_32 (a_value: NATURAL_32): REAL_96
		do
			Result.set_from_natural_32 (a_value)
		end

	real_96_from_natural_64 (a_value: NATURAL_64): REAL_96
		do
			Result.set_from_natural_64 (a_value)
		end

	real_96_from_real_32 (a_value: REAL_32): REAL_96
		do
			Result.set_from_real_32 (a_value)
		end

	real_96_from_real_64 (a_value: REAL_64): REAL_96
		do
			Result.set_from_real_64 (a_value)
		end

feature {NONE}

	static_string_storage: HASH_TABLE [CE_ARRAY [INTEGER_8], STRING_8]
		once ("PROCESS")
			create Result.make (16)
		end

end
