class
	PD_AFFENTRY_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ae_next: CE_POINTER [PD_AFFENTRY_S] assign set_ae_next
		do
			create Result.make_shared (c_ae_next (c_pointer))
		end

	ae_chop: CE_POINTER [NATURAL_8] assign set_ae_chop
		do
			create Result.make_shared (c_ae_chop (c_pointer))
		end

	ae_add: CE_POINTER [NATURAL_8] assign set_ae_add
		do
			create Result.make_shared (c_ae_add (c_pointer))
		end

	ae_flags: CE_POINTER [NATURAL_8] assign set_ae_flags
		do
			create Result.make_shared (c_ae_flags (c_pointer))
		end

	ae_cond: CE_POINTER [NATURAL_8] assign set_ae_cond
		do
			create Result.make_shared (c_ae_cond (c_pointer))
		end

	ae_prog: CE_POINTER [PD_REGPROG_T] assign set_ae_prog
		do
			create Result.make_shared (c_ae_prog (c_pointer))
		end

	ae_compforbid: INTEGER_8 assign set_ae_compforbid
		do
			Result := c_ae_compforbid (c_pointer)
		end

	ae_comppermit: INTEGER_8 assign set_ae_comppermit
		do
			Result := c_ae_comppermit (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_ae_next (a_ae_next: CE_POINTER [PD_AFFENTRY_S])
		do
			c_set_ae_next (c_pointer, a_ae_next.c_pointer)
		end

	set_ae_chop (a_ae_chop: CE_POINTER [NATURAL_8])
		do
			c_set_ae_chop (c_pointer, a_ae_chop.c_pointer)
		end

	set_ae_add (a_ae_add: CE_POINTER [NATURAL_8])
		do
			c_set_ae_add (c_pointer, a_ae_add.c_pointer)
		end

	set_ae_flags (a_ae_flags: CE_POINTER [NATURAL_8])
		do
			c_set_ae_flags (c_pointer, a_ae_flags.c_pointer)
		end

	set_ae_cond (a_ae_cond: CE_POINTER [NATURAL_8])
		do
			c_set_ae_cond (c_pointer, a_ae_cond.c_pointer)
		end

	set_ae_prog (a_ae_prog: CE_POINTER [PD_REGPROG_T])
		do
			c_set_ae_prog (c_pointer, a_ae_prog.c_pointer)
		end

	set_ae_compforbid (a_ae_compforbid: INTEGER_8)
		do
			c_set_ae_compforbid (c_pointer, a_ae_compforbid)
		end

	set_ae_comppermit (a_ae_comppermit: INTEGER_8)
		do
			c_set_ae_comppermit (c_pointer, a_ae_comppermit)
		end

feature {NONE} -- C getters

	c_ae_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct affentry_S *)((struct affentry_S *)$tmp)->ae_next;"
		end

	c_ae_chop (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct affentry_S *)$tmp)->ae_chop;"
		end

	c_ae_add (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct affentry_S *)$tmp)->ae_add;"
		end

	c_ae_flags (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct affentry_S *)$tmp)->ae_flags;"
		end

	c_ae_cond (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct affentry_S *)$tmp)->ae_cond;"
		end

	c_ae_prog (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (regprog_T *)((struct affentry_S *)$tmp)->ae_prog;"
		end

	c_ae_compforbid (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct affentry_S *)$tmp)->ae_compforbid;"
		end

	c_ae_comppermit (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct affentry_S *)$tmp)->ae_comppermit;"
		end

feature {NONE} -- C setters

	c_set_ae_next (tmp: POINTER; a_ae_next: POINTER)
		external
			"C inline"
		alias
			"((struct affentry_S *)$tmp)->ae_next = (struct affentry_S *)$a_ae_next;"
		end

	c_set_ae_chop (tmp: POINTER; a_ae_chop: POINTER)
		external
			"C inline"
		alias
			"((struct affentry_S *)$tmp)->ae_chop = (unsigned char *)$a_ae_chop;"
		end

	c_set_ae_add (tmp: POINTER; a_ae_add: POINTER)
		external
			"C inline"
		alias
			"((struct affentry_S *)$tmp)->ae_add = (unsigned char *)$a_ae_add;"
		end

	c_set_ae_flags (tmp: POINTER; a_ae_flags: POINTER)
		external
			"C inline"
		alias
			"((struct affentry_S *)$tmp)->ae_flags = (unsigned char *)$a_ae_flags;"
		end

	c_set_ae_cond (tmp: POINTER; a_ae_cond: POINTER)
		external
			"C inline"
		alias
			"((struct affentry_S *)$tmp)->ae_cond = (unsigned char *)$a_ae_cond;"
		end

	c_set_ae_prog (tmp: POINTER; a_ae_prog: POINTER)
		external
			"C inline"
		alias
			"((struct affentry_S *)$tmp)->ae_prog = (regprog_T *)$a_ae_prog;"
		end

	c_set_ae_compforbid (tmp: POINTER; a_ae_compforbid: INTEGER_8)
		external
			"C inline"
		alias
			"((struct affentry_S *)$tmp)->ae_compforbid = $a_ae_compforbid;"
		end

	c_set_ae_comppermit (tmp: POINTER; a_ae_comppermit: INTEGER_8)
		external
			"C inline"
		alias
			"((struct affentry_S *)$tmp)->ae_comppermit = $a_ae_comppermit;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct affentry_S);"
		end

end
