class
	PD_AUTOCMD

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	cmd: CE_POINTER [NATURAL_8] assign set_cmd
		do
			create Result.make_shared (c_cmd (c_pointer))
		end

	nested: INTEGER_8 assign set_nested
		do
			Result := c_nested (c_pointer)
		end

	last: INTEGER_8 assign set_last
		do
			Result := c_last (c_pointer)
		end

	scriptID: INTEGER_32 assign set_scriptID
		do
			Result := c_scriptID (c_pointer)
		end

	next: CE_POINTER [PD_AUTOCMD] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	next_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct AutoCmd, next);"
		end

feature {ANY} -- Eiffel setters

	set_cmd (a_cmd: CE_POINTER [NATURAL_8])
		do
			c_set_cmd (c_pointer, a_cmd.c_pointer)
		end

	set_nested (a_nested: INTEGER_8)
		do
			c_set_nested (c_pointer, a_nested)
		end

	set_last (a_last: INTEGER_8)
		do
			c_set_last (c_pointer, a_last)
		end

	set_scriptID (a_scriptID: INTEGER_32)
		do
			c_set_scriptID (c_pointer, a_scriptID)
		end

	set_next (a_next: CE_POINTER [PD_AUTOCMD])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

feature {NONE} -- C getters

	c_cmd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct AutoCmd *)$tmp)->cmd;"
		end

	c_nested (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct AutoCmd *)$tmp)->nested;"
		end

	c_last (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct AutoCmd *)$tmp)->last;"
		end

	c_scriptID (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct AutoCmd *)$tmp)->scriptID;"
		end

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct AutoCmd *)((struct AutoCmd *)$tmp)->next;"
		end

feature {NONE} -- C setters

	c_set_cmd (tmp: POINTER; a_cmd: POINTER)
		external
			"C inline"
		alias
			"((struct AutoCmd *)$tmp)->cmd = (unsigned char *)$a_cmd;"
		end

	c_set_nested (tmp: POINTER; a_nested: INTEGER_8)
		external
			"C inline"
		alias
			"((struct AutoCmd *)$tmp)->nested = $a_nested;"
		end

	c_set_last (tmp: POINTER; a_last: INTEGER_8)
		external
			"C inline"
		alias
			"((struct AutoCmd *)$tmp)->last = $a_last;"
		end

	c_set_scriptID (tmp: POINTER; a_scriptID: INTEGER_32)
		external
			"C inline"
		alias
			"((struct AutoCmd *)$tmp)->scriptID = $a_scriptid;"
		end

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct AutoCmd *)$tmp)->next = (struct AutoCmd *)$a_next;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct AutoCmd);"
		end

end
