class
	PD_AUTOPAT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	group: INTEGER_32 assign set_group
		do
			Result := c_group (c_pointer)
		end

	pat: CE_POINTER [NATURAL_8] assign set_pat
		do
			create Result.make_shared (c_pat (c_pointer))
		end

	patlen: INTEGER_32 assign set_patlen
		do
			Result := c_patlen (c_pointer)
		end

	reg_prog: CE_POINTER [PD_REGPROG_T] assign set_reg_prog
		do
			create Result.make_shared (c_reg_prog (c_pointer))
		end

	allow_dirs: INTEGER_8 assign set_allow_dirs
		do
			Result := c_allow_dirs (c_pointer)
		end

	allow_dirs_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct AutoPat, allow_dirs);"
		end

	last: INTEGER_8 assign set_last
		do
			Result := c_last (c_pointer)
		end

	cmds: CE_POINTER [PD_AUTOCMD] assign set_cmds
		do
			create Result.make_shared (c_cmds (c_pointer))
		end

	cmds_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct AutoPat, cmds);"
		end

	next: CE_POINTER [PD_AUTOPAT] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	next_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct AutoPat, next);"
		end

	buflocal_nr: INTEGER_32 assign set_buflocal_nr
		do
			Result := c_buflocal_nr (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_group (a_group: INTEGER_32)
		do
			c_set_group (c_pointer, a_group)
		end

	set_pat (a_pat: CE_POINTER [NATURAL_8])
		do
			c_set_pat (c_pointer, a_pat.c_pointer)
		end

	set_patlen (a_patlen: INTEGER_32)
		do
			c_set_patlen (c_pointer, a_patlen)
		end

	set_reg_prog (a_reg_prog: CE_POINTER [PD_REGPROG_T])
		do
			c_set_reg_prog (c_pointer, a_reg_prog.c_pointer)
		end

	set_allow_dirs (a_allow_dirs: INTEGER_8)
		do
			c_set_allow_dirs (c_pointer, a_allow_dirs)
		end

	set_last (a_last: INTEGER_8)
		do
			c_set_last (c_pointer, a_last)
		end

	set_cmds (a_cmds: CE_POINTER [PD_AUTOCMD])
		do
			c_set_cmds (c_pointer, a_cmds.c_pointer)
		end

	set_next (a_next: CE_POINTER [PD_AUTOPAT])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_buflocal_nr (a_buflocal_nr: INTEGER_32)
		do
			c_set_buflocal_nr (c_pointer, a_buflocal_nr)
		end

feature {NONE} -- C getters

	c_group (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct AutoPat *)$tmp)->group;"
		end

	c_pat (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct AutoPat *)$tmp)->pat;"
		end

	c_patlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct AutoPat *)$tmp)->patlen;"
		end

	c_reg_prog (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (regprog_T *)((struct AutoPat *)$tmp)->reg_prog;"
		end

	c_allow_dirs (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct AutoPat *)$tmp)->allow_dirs;"
		end

	c_last (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct AutoPat *)$tmp)->last;"
		end

	c_cmds (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct AutoCmd *)((struct AutoPat *)$tmp)->cmds;"
		end

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct AutoPat *)((struct AutoPat *)$tmp)->next;"
		end

	c_buflocal_nr (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct AutoPat *)$tmp)->buflocal_nr;"
		end

feature {NONE} -- C setters

	c_set_group (tmp: POINTER; a_group: INTEGER_32)
		external
			"C inline"
		alias
			"((struct AutoPat *)$tmp)->group = $a_group;"
		end

	c_set_pat (tmp: POINTER; a_pat: POINTER)
		external
			"C inline"
		alias
			"((struct AutoPat *)$tmp)->pat = (unsigned char *)$a_pat;"
		end

	c_set_patlen (tmp: POINTER; a_patlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct AutoPat *)$tmp)->patlen = $a_patlen;"
		end

	c_set_reg_prog (tmp: POINTER; a_reg_prog: POINTER)
		external
			"C inline"
		alias
			"((struct AutoPat *)$tmp)->reg_prog = (regprog_T *)$a_reg_prog;"
		end

	c_set_allow_dirs (tmp: POINTER; a_allow_dirs: INTEGER_8)
		external
			"C inline"
		alias
			"((struct AutoPat *)$tmp)->allow_dirs = $a_allow_dirs;"
		end

	c_set_last (tmp: POINTER; a_last: INTEGER_8)
		external
			"C inline"
		alias
			"((struct AutoPat *)$tmp)->last = $a_last;"
		end

	c_set_cmds (tmp: POINTER; a_cmds: POINTER)
		external
			"C inline"
		alias
			"((struct AutoPat *)$tmp)->cmds = (struct AutoCmd *)$a_cmds;"
		end

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct AutoPat *)$tmp)->next = (struct AutoPat *)$a_next;"
		end

	c_set_buflocal_nr (tmp: POINTER; a_buflocal_nr: INTEGER_32)
		external
			"C inline"
		alias
			"((struct AutoPat *)$tmp)->buflocal_nr = $a_buflocal_nr;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct AutoPat);"
		end

end
