class
	PD_AUTOPATCMD

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	curpat: CE_POINTER [PD_AUTOPAT] assign set_curpat
		do
			create Result.make_shared (c_curpat (c_pointer))
		end

	nextcmd: CE_POINTER [PD_AUTOCMD] assign set_nextcmd
		do
			create Result.make_shared (c_nextcmd (c_pointer))
		end

	group: INTEGER_32 assign set_group
		do
			Result := c_group (c_pointer)
		end

	fname: CE_POINTER [NATURAL_8] assign set_fname
		do
			create Result.make_shared (c_fname (c_pointer))
		end

	sfname: CE_POINTER [NATURAL_8] assign set_sfname
		do
			create Result.make_shared (c_sfname (c_pointer))
		end

	tail: CE_POINTER [NATURAL_8] assign set_tail
		do
			create Result.make_shared (c_tail (c_pointer))
		end

	event: INTEGER_32 assign set_event
		do
			Result := c_event (c_pointer)
		end

	arg_bufnr: INTEGER_32 assign set_arg_bufnr
		do
			Result := c_arg_bufnr (c_pointer)
		end

	next: CE_POINTER [PD_AUTOPATCMD] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_curpat (a_curpat: CE_POINTER [PD_AUTOPAT])
		do
			c_set_curpat (c_pointer, a_curpat.c_pointer)
		end

	set_nextcmd (a_nextcmd: CE_POINTER [PD_AUTOCMD])
		do
			c_set_nextcmd (c_pointer, a_nextcmd.c_pointer)
		end

	set_group (a_group: INTEGER_32)
		do
			c_set_group (c_pointer, a_group)
		end

	set_fname (a_fname: CE_POINTER [NATURAL_8])
		do
			c_set_fname (c_pointer, a_fname.c_pointer)
		end

	set_sfname (a_sfname: CE_POINTER [NATURAL_8])
		do
			c_set_sfname (c_pointer, a_sfname.c_pointer)
		end

	set_tail (a_tail: CE_POINTER [NATURAL_8])
		do
			c_set_tail (c_pointer, a_tail.c_pointer)
		end

	set_event (a_event: INTEGER_32)
		do
			c_set_event (c_pointer, a_event)
		end

	set_arg_bufnr (a_arg_bufnr: INTEGER_32)
		do
			c_set_arg_bufnr (c_pointer, a_arg_bufnr)
		end

	set_next (a_next: CE_POINTER [PD_AUTOPATCMD])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

feature {NONE} -- C getters

	c_curpat (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct AutoPat *)((struct AutoPatCmd *)$tmp)->curpat;"
		end

	c_nextcmd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct AutoCmd *)((struct AutoPatCmd *)$tmp)->nextcmd;"
		end

	c_group (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct AutoPatCmd *)$tmp)->group;"
		end

	c_fname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct AutoPatCmd *)$tmp)->fname;"
		end

	c_sfname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct AutoPatCmd *)$tmp)->sfname;"
		end

	c_tail (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct AutoPatCmd *)$tmp)->tail;"
		end

	c_event (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct AutoPatCmd *)$tmp)->event;"
		end

	c_arg_bufnr (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct AutoPatCmd *)$tmp)->arg_bufnr;"
		end

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct AutoPatCmd *)((struct AutoPatCmd *)$tmp)->next;"
		end

feature {NONE} -- C setters

	c_set_curpat (tmp: POINTER; a_curpat: POINTER)
		external
			"C inline"
		alias
			"((struct AutoPatCmd *)$tmp)->curpat = (struct AutoPat *)$a_curpat;"
		end

	c_set_nextcmd (tmp: POINTER; a_nextcmd: POINTER)
		external
			"C inline"
		alias
			"((struct AutoPatCmd *)$tmp)->nextcmd = (struct AutoCmd *)$a_nextcmd;"
		end

	c_set_group (tmp: POINTER; a_group: INTEGER_32)
		external
			"C inline"
		alias
			"((struct AutoPatCmd *)$tmp)->group = $a_group;"
		end

	c_set_fname (tmp: POINTER; a_fname: POINTER)
		external
			"C inline"
		alias
			"((struct AutoPatCmd *)$tmp)->fname = (unsigned char *)$a_fname;"
		end

	c_set_sfname (tmp: POINTER; a_sfname: POINTER)
		external
			"C inline"
		alias
			"((struct AutoPatCmd *)$tmp)->sfname = (unsigned char *)$a_sfname;"
		end

	c_set_tail (tmp: POINTER; a_tail: POINTER)
		external
			"C inline"
		alias
			"((struct AutoPatCmd *)$tmp)->tail = (unsigned char *)$a_tail;"
		end

	c_set_event (tmp: POINTER; a_event: INTEGER_32)
		external
			"C inline"
		alias
			"((struct AutoPatCmd *)$tmp)->event = $a_event;"
		end

	c_set_arg_bufnr (tmp: POINTER; a_arg_bufnr: INTEGER_32)
		external
			"C inline"
		alias
			"((struct AutoPatCmd *)$tmp)->arg_bufnr = $a_arg_bufnr;"
		end

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct AutoPatCmd *)$tmp)->next = (struct AutoPatCmd *)$a_next;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct AutoPatCmd);"
		end

end
