class
	PD_BLOCK_DEF

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	startspaces: INTEGER_32 assign set_startspaces
		do
			Result := c_startspaces (c_pointer)
		end

	endspaces: INTEGER_32 assign set_endspaces
		do
			Result := c_endspaces (c_pointer)
		end

	textlen: INTEGER_32 assign set_textlen
		do
			Result := c_textlen (c_pointer)
		end

	textstart: CE_POINTER [NATURAL_8] assign set_textstart
		do
			create Result.make_shared (c_textstart (c_pointer))
		end

	textstart_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct block_def, textstart);"
		end

	textcol: INTEGER_32 assign set_textcol
		do
			Result := c_textcol (c_pointer)
		end

	start_vcol: INTEGER_32 assign set_start_vcol
		do
			Result := c_start_vcol (c_pointer)
		end

	end_vcol: INTEGER_32 assign set_end_vcol
		do
			Result := c_end_vcol (c_pointer)
		end

	is_short: INTEGER_32 assign set_is_short
		do
			Result := c_is_short (c_pointer)
		end

	is_MAX: INTEGER_32 assign set_is_MAX
		do
			Result := c_is_MAX (c_pointer)
		end

	is_oneChar: INTEGER_32 assign set_is_oneChar
		do
			Result := c_is_oneChar (c_pointer)
		end

	pre_whitesp: INTEGER_32 assign set_pre_whitesp
		do
			Result := c_pre_whitesp (c_pointer)
		end

	pre_whitesp_c: INTEGER_32 assign set_pre_whitesp_c
		do
			Result := c_pre_whitesp_c (c_pointer)
		end

	end_char_vcols: INTEGER_32 assign set_end_char_vcols
		do
			Result := c_end_char_vcols (c_pointer)
		end

	start_char_vcols: INTEGER_32 assign set_start_char_vcols
		do
			Result := c_start_char_vcols (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_startspaces (a_startspaces: INTEGER_32)
		do
			c_set_startspaces (c_pointer, a_startspaces)
		end

	set_endspaces (a_endspaces: INTEGER_32)
		do
			c_set_endspaces (c_pointer, a_endspaces)
		end

	set_textlen (a_textlen: INTEGER_32)
		do
			c_set_textlen (c_pointer, a_textlen)
		end

	set_textstart (a_textstart: CE_POINTER [NATURAL_8])
		do
			c_set_textstart (c_pointer, a_textstart.c_pointer)
		end

	set_textcol (a_textcol: INTEGER_32)
		do
			c_set_textcol (c_pointer, a_textcol)
		end

	set_start_vcol (a_start_vcol: INTEGER_32)
		do
			c_set_start_vcol (c_pointer, a_start_vcol)
		end

	set_end_vcol (a_end_vcol: INTEGER_32)
		do
			c_set_end_vcol (c_pointer, a_end_vcol)
		end

	set_is_short (a_is_short: INTEGER_32)
		do
			c_set_is_short (c_pointer, a_is_short)
		end

	set_is_MAX (a_is_MAX: INTEGER_32)
		do
			c_set_is_MAX (c_pointer, a_is_MAX)
		end

	set_is_oneChar (a_is_oneChar: INTEGER_32)
		do
			c_set_is_oneChar (c_pointer, a_is_oneChar)
		end

	set_pre_whitesp (a_pre_whitesp: INTEGER_32)
		do
			c_set_pre_whitesp (c_pointer, a_pre_whitesp)
		end

	set_pre_whitesp_c (a_pre_whitesp_c: INTEGER_32)
		do
			c_set_pre_whitesp_c (c_pointer, a_pre_whitesp_c)
		end

	set_end_char_vcols (a_end_char_vcols: INTEGER_32)
		do
			c_set_end_char_vcols (c_pointer, a_end_char_vcols)
		end

	set_start_char_vcols (a_start_char_vcols: INTEGER_32)
		do
			c_set_start_char_vcols (c_pointer, a_start_char_vcols)
		end

feature {NONE} -- C getters

	c_startspaces (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct block_def *)$tmp)->startspaces;"
		end

	c_endspaces (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct block_def *)$tmp)->endspaces;"
		end

	c_textlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct block_def *)$tmp)->textlen;"
		end

	c_textstart (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct block_def *)$tmp)->textstart;"
		end

	c_textcol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct block_def *)$tmp)->textcol;"
		end

	c_start_vcol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct block_def *)$tmp)->start_vcol;"
		end

	c_end_vcol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct block_def *)$tmp)->end_vcol;"
		end

	c_is_short (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct block_def *)$tmp)->is_short;"
		end

	c_is_MAX (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct block_def *)$tmp)->is_MAX;"
		end

	c_is_oneChar (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct block_def *)$tmp)->is_oneChar;"
		end

	c_pre_whitesp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct block_def *)$tmp)->pre_whitesp;"
		end

	c_pre_whitesp_c (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct block_def *)$tmp)->pre_whitesp_c;"
		end

	c_end_char_vcols (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct block_def *)$tmp)->end_char_vcols;"
		end

	c_start_char_vcols (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct block_def *)$tmp)->start_char_vcols;"
		end

feature {NONE} -- C setters

	c_set_startspaces (tmp: POINTER; a_startspaces: INTEGER_32)
		external
			"C inline"
		alias
			"((struct block_def *)$tmp)->startspaces = $a_startspaces;"
		end

	c_set_endspaces (tmp: POINTER; a_endspaces: INTEGER_32)
		external
			"C inline"
		alias
			"((struct block_def *)$tmp)->endspaces = $a_endspaces;"
		end

	c_set_textlen (tmp: POINTER; a_textlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct block_def *)$tmp)->textlen = $a_textlen;"
		end

	c_set_textstart (tmp: POINTER; a_textstart: POINTER)
		external
			"C inline"
		alias
			"((struct block_def *)$tmp)->textstart = (unsigned char *)$a_textstart;"
		end

	c_set_textcol (tmp: POINTER; a_textcol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct block_def *)$tmp)->textcol = $a_textcol;"
		end

	c_set_start_vcol (tmp: POINTER; a_start_vcol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct block_def *)$tmp)->start_vcol = $a_start_vcol;"
		end

	c_set_end_vcol (tmp: POINTER; a_end_vcol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct block_def *)$tmp)->end_vcol = $a_end_vcol;"
		end

	c_set_is_short (tmp: POINTER; a_is_short: INTEGER_32)
		external
			"C inline"
		alias
			"((struct block_def *)$tmp)->is_short = $a_is_short;"
		end

	c_set_is_MAX (tmp: POINTER; a_is_MAX: INTEGER_32)
		external
			"C inline"
		alias
			"((struct block_def *)$tmp)->is_MAX = $a_is_max;"
		end

	c_set_is_oneChar (tmp: POINTER; a_is_oneChar: INTEGER_32)
		external
			"C inline"
		alias
			"((struct block_def *)$tmp)->is_oneChar = $a_is_onechar;"
		end

	c_set_pre_whitesp (tmp: POINTER; a_pre_whitesp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct block_def *)$tmp)->pre_whitesp = $a_pre_whitesp;"
		end

	c_set_pre_whitesp_c (tmp: POINTER; a_pre_whitesp_c: INTEGER_32)
		external
			"C inline"
		alias
			"((struct block_def *)$tmp)->pre_whitesp_c = $a_pre_whitesp_c;"
		end

	c_set_end_char_vcols (tmp: POINTER; a_end_char_vcols: INTEGER_32)
		external
			"C inline"
		alias
			"((struct block_def *)$tmp)->end_char_vcols = $a_end_char_vcols;"
		end

	c_set_start_char_vcols (tmp: POINTER; a_start_char_vcols: INTEGER_32)
		external
			"C inline"
		alias
			"((struct block_def *)$tmp)->start_char_vcols = $a_start_char_vcols;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct block_def);"
		end

end
