class
	PD_BLOCK_HDR

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	bh_next: CE_POINTER [PD_BLOCK_HDR] assign set_bh_next
		do
			create Result.make_shared (c_bh_next (c_pointer))
		end

	bh_prev: CE_POINTER [PD_BLOCK_HDR] assign set_bh_prev
		do
			create Result.make_shared (c_bh_prev (c_pointer))
		end

	bh_hash_next: CE_POINTER [PD_BLOCK_HDR] assign set_bh_hash_next
		do
			create Result.make_shared (c_bh_hash_next (c_pointer))
		end

	bh_hash_prev: CE_POINTER [PD_BLOCK_HDR] assign set_bh_hash_prev
		do
			create Result.make_shared (c_bh_hash_prev (c_pointer))
		end

	bh_bnum: INTEGER_32 assign set_bh_bnum
		do
			Result := c_bh_bnum (c_pointer)
		end

	bh_data: CE_POINTER [NATURAL_8] assign set_bh_data
		do
			create Result.make_shared (c_bh_data (c_pointer))
		end

	bh_page_count: INTEGER_32 assign set_bh_page_count
		do
			Result := c_bh_page_count (c_pointer)
		end

	bh_flags: INTEGER_8 assign set_bh_flags
		do
			Result := c_bh_flags (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_bh_next (a_bh_next: CE_POINTER [PD_BLOCK_HDR])
		do
			c_set_bh_next (c_pointer, a_bh_next.c_pointer)
		end

	set_bh_prev (a_bh_prev: CE_POINTER [PD_BLOCK_HDR])
		do
			c_set_bh_prev (c_pointer, a_bh_prev.c_pointer)
		end

	set_bh_hash_next (a_bh_hash_next: CE_POINTER [PD_BLOCK_HDR])
		do
			c_set_bh_hash_next (c_pointer, a_bh_hash_next.c_pointer)
		end

	set_bh_hash_prev (a_bh_hash_prev: CE_POINTER [PD_BLOCK_HDR])
		do
			c_set_bh_hash_prev (c_pointer, a_bh_hash_prev.c_pointer)
		end

	set_bh_bnum (a_bh_bnum: INTEGER_32)
		do
			c_set_bh_bnum (c_pointer, a_bh_bnum)
		end

	set_bh_data (a_bh_data: CE_POINTER [NATURAL_8])
		do
			c_set_bh_data (c_pointer, a_bh_data.c_pointer)
		end

	set_bh_page_count (a_bh_page_count: INTEGER_32)
		do
			c_set_bh_page_count (c_pointer, a_bh_page_count)
		end

	set_bh_flags (a_bh_flags: INTEGER_8)
		do
			c_set_bh_flags (c_pointer, a_bh_flags)
		end

feature {NONE} -- C getters

	c_bh_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct block_hdr *)((struct block_hdr *)$tmp)->bh_next;"
		end

	c_bh_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct block_hdr *)((struct block_hdr *)$tmp)->bh_prev;"
		end

	c_bh_hash_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct block_hdr *)((struct block_hdr *)$tmp)->bh_hash_next;"
		end

	c_bh_hash_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct block_hdr *)((struct block_hdr *)$tmp)->bh_hash_prev;"
		end

	c_bh_bnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct block_hdr *)$tmp)->bh_bnum;"
		end

	c_bh_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct block_hdr *)$tmp)->bh_data;"
		end

	c_bh_page_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct block_hdr *)$tmp)->bh_page_count;"
		end

	c_bh_flags (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct block_hdr *)$tmp)->bh_flags;"
		end

feature {NONE} -- C setters

	c_set_bh_next (tmp: POINTER; a_bh_next: POINTER)
		external
			"C inline"
		alias
			"((struct block_hdr *)$tmp)->bh_next = (struct block_hdr *)$a_bh_next;"
		end

	c_set_bh_prev (tmp: POINTER; a_bh_prev: POINTER)
		external
			"C inline"
		alias
			"((struct block_hdr *)$tmp)->bh_prev = (struct block_hdr *)$a_bh_prev;"
		end

	c_set_bh_hash_next (tmp: POINTER; a_bh_hash_next: POINTER)
		external
			"C inline"
		alias
			"((struct block_hdr *)$tmp)->bh_hash_next = (struct block_hdr *)$a_bh_hash_next;"
		end

	c_set_bh_hash_prev (tmp: POINTER; a_bh_hash_prev: POINTER)
		external
			"C inline"
		alias
			"((struct block_hdr *)$tmp)->bh_hash_prev = (struct block_hdr *)$a_bh_hash_prev;"
		end

	c_set_bh_bnum (tmp: POINTER; a_bh_bnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct block_hdr *)$tmp)->bh_bnum = $a_bh_bnum;"
		end

	c_set_bh_data (tmp: POINTER; a_bh_data: POINTER)
		external
			"C inline"
		alias
			"((struct block_hdr *)$tmp)->bh_data = (unsigned char *)$a_bh_data;"
		end

	c_set_bh_page_count (tmp: POINTER; a_bh_page_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct block_hdr *)$tmp)->bh_page_count = $a_bh_page_count;"
		end

	c_set_bh_flags (tmp: POINTER; a_bh_flags: INTEGER_8)
		external
			"C inline"
		alias
			"((struct block_hdr *)$tmp)->bh_flags = $a_bh_flags;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct block_hdr);"
		end

end
