class
	PD_BUF_STATE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	bs_idx: INTEGER_32 assign set_bs_idx
		do
			Result := c_bs_idx (c_pointer)
		end

	bs_flags: INTEGER_32 assign set_bs_flags
		do
			Result := c_bs_flags (c_pointer)
		end

	bs_extmatch: CE_POINTER [PD_REG_EXTMATCH_T] assign set_bs_extmatch
		do
			create Result.make_shared (c_bs_extmatch (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_bs_idx (a_bs_idx: INTEGER_32)
		do
			c_set_bs_idx (c_pointer, a_bs_idx)
		end

	set_bs_flags (a_bs_flags: INTEGER_32)
		do
			c_set_bs_flags (c_pointer, a_bs_flags)
		end

	set_bs_extmatch (a_bs_extmatch: CE_POINTER [PD_REG_EXTMATCH_T])
		do
			c_set_bs_extmatch (c_pointer, a_bs_extmatch.c_pointer)
		end

feature {NONE} -- C getters

	c_bs_idx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct buf_state *)$tmp)->bs_idx;"
		end

	c_bs_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct buf_state *)$tmp)->bs_flags;"
		end

	c_bs_extmatch (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (reg_extmatch_T *)((struct buf_state *)$tmp)->bs_extmatch;"
		end

feature {NONE} -- C setters

	c_set_bs_idx (tmp: POINTER; a_bs_idx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct buf_state *)$tmp)->bs_idx = $a_bs_idx;"
		end

	c_set_bs_flags (tmp: POINTER; a_bs_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct buf_state *)$tmp)->bs_flags = $a_bs_flags;"
		end

	c_set_bs_extmatch (tmp: POINTER; a_bs_extmatch: POINTER)
		external
			"C inline"
		alias
			"((struct buf_state *)$tmp)->bs_extmatch = (reg_extmatch_T *)$a_bs_extmatch;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct buf_state);"
		end

end
