class
	PD_BUFFBLOCK

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	b_next: CE_POINTER [PD_BUFFBLOCK] assign set_b_next
		do
			create Result.make_shared (c_b_next (c_pointer))
		end

	b_str: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_b_str (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_b_next (a_b_next: CE_POINTER [PD_BUFFBLOCK])
		do
			c_set_b_next (c_pointer, a_b_next.c_pointer)
		end

feature {NONE} -- C getters

	c_b_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct buffblock *)((struct buffblock *)$tmp)->b_next;"
		end

	c_b_str (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct buffblock *tmp = (struct buffblock *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->b_str) / sizeof(tmp->b_str[0]);
				return tmp->b_str;
			]"
		end

feature {NONE} -- C setters

	c_set_b_next (tmp: POINTER; a_b_next: POINTER)
		external
			"C inline"
		alias
			"((struct buffblock *)$tmp)->b_next = (struct buffblock *)$a_b_next;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct buffblock);"
		end

end
