class
	PD_BUILTIN_TERM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	bt_entry: INTEGER_32 assign set_bt_entry
		do
			Result := c_bt_entry (c_pointer)
		end

	bt_string: CE_POINTER [INTEGER_8] assign set_bt_string
		do
			create Result.make_shared (c_bt_string (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_bt_entry (a_bt_entry: INTEGER_32)
		do
			c_set_bt_entry (c_pointer, a_bt_entry)
		end

	set_bt_string (a_bt_string: CE_POINTER [INTEGER_8])
		do
			c_set_bt_string (c_pointer, a_bt_string.c_pointer)
		end

feature {NONE} -- C getters

	c_bt_entry (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct builtin_term *)$tmp)->bt_entry;"
		end

	c_bt_string (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct builtin_term *)$tmp)->bt_string;"
		end

feature {NONE} -- C setters

	c_set_bt_entry (tmp: POINTER; a_bt_entry: INTEGER_32)
		external
			"C inline"
		alias
			"((struct builtin_term *)$tmp)->bt_entry = $a_bt_entry;"
		end

	c_set_bt_string (tmp: POINTER; a_bt_string: POINTER)
		external
			"C inline"
		alias
			"((struct builtin_term *)$tmp)->bt_string = (char *)$a_bt_string;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct builtin_term);"
		end

end
