class
	PD_BW_INFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	bw_fd: INTEGER_32 assign set_bw_fd
		do
			Result := c_bw_fd (c_pointer)
		end

	bw_buf: CE_POINTER [NATURAL_8] assign set_bw_buf
		do
			create Result.make_shared (c_bw_buf (c_pointer))
		end

	bw_len: INTEGER_32 assign set_bw_len
		do
			Result := c_bw_len (c_pointer)
		end

	bw_flags: INTEGER_32 assign set_bw_flags
		do
			Result := c_bw_flags (c_pointer)
		end

	bw_rest: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_bw_rest (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	bw_restlen: INTEGER_32 assign set_bw_restlen
		do
			Result := c_bw_restlen (c_pointer)
		end

	bw_first: INTEGER_32 assign set_bw_first
		do
			Result := c_bw_first (c_pointer)
		end

	bw_conv_buf: CE_POINTER [NATURAL_8] assign set_bw_conv_buf
		do
			create Result.make_shared (c_bw_conv_buf (c_pointer))
		end

	bw_conv_buflen: INTEGER_32 assign set_bw_conv_buflen
		do
			Result := c_bw_conv_buflen (c_pointer)
		end

	bw_conv_error: INTEGER_32 assign set_bw_conv_error
		do
			Result := c_bw_conv_error (c_pointer)
		end

	bw_conv_error_lnum: INTEGER_32 assign set_bw_conv_error_lnum
		do
			Result := c_bw_conv_error_lnum (c_pointer)
		end

	bw_start_lnum: INTEGER_32 assign set_bw_start_lnum
		do
			Result := c_bw_start_lnum (c_pointer)
		end

	bw_iconv_fd: CE_POINTER [ANY] assign set_bw_iconv_fd
		do
			create Result.make_shared (c_bw_iconv_fd (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_bw_fd (a_bw_fd: INTEGER_32)
		do
			c_set_bw_fd (c_pointer, a_bw_fd)
		end

	set_bw_buf (a_bw_buf: CE_POINTER [NATURAL_8])
		do
			c_set_bw_buf (c_pointer, a_bw_buf.c_pointer)
		end

	set_bw_len (a_bw_len: INTEGER_32)
		do
			c_set_bw_len (c_pointer, a_bw_len)
		end

	set_bw_flags (a_bw_flags: INTEGER_32)
		do
			c_set_bw_flags (c_pointer, a_bw_flags)
		end

	set_bw_restlen (a_bw_restlen: INTEGER_32)
		do
			c_set_bw_restlen (c_pointer, a_bw_restlen)
		end

	set_bw_first (a_bw_first: INTEGER_32)
		do
			c_set_bw_first (c_pointer, a_bw_first)
		end

	set_bw_conv_buf (a_bw_conv_buf: CE_POINTER [NATURAL_8])
		do
			c_set_bw_conv_buf (c_pointer, a_bw_conv_buf.c_pointer)
		end

	set_bw_conv_buflen (a_bw_conv_buflen: INTEGER_32)
		do
			c_set_bw_conv_buflen (c_pointer, a_bw_conv_buflen)
		end

	set_bw_conv_error (a_bw_conv_error: INTEGER_32)
		do
			c_set_bw_conv_error (c_pointer, a_bw_conv_error)
		end

	set_bw_conv_error_lnum (a_bw_conv_error_lnum: INTEGER_32)
		do
			c_set_bw_conv_error_lnum (c_pointer, a_bw_conv_error_lnum)
		end

	set_bw_start_lnum (a_bw_start_lnum: INTEGER_32)
		do
			c_set_bw_start_lnum (c_pointer, a_bw_start_lnum)
		end

	set_bw_iconv_fd (a_bw_iconv_fd: CE_POINTER [ANY])
		do
			c_set_bw_iconv_fd (c_pointer, a_bw_iconv_fd.c_pointer)
		end

feature {NONE} -- C getters

	c_bw_fd (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct bw_info *)$tmp)->bw_fd;"
		end

	c_bw_buf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct bw_info *)$tmp)->bw_buf;"
		end

	c_bw_len (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct bw_info *)$tmp)->bw_len;"
		end

	c_bw_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct bw_info *)$tmp)->bw_flags;"
		end

	c_bw_rest (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct bw_info *tmp = (struct bw_info *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->bw_rest) / sizeof(tmp->bw_rest[0]);
				return tmp->bw_rest;
			]"
		end

	c_bw_restlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct bw_info *)$tmp)->bw_restlen;"
		end

	c_bw_first (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct bw_info *)$tmp)->bw_first;"
		end

	c_bw_conv_buf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct bw_info *)$tmp)->bw_conv_buf;"
		end

	c_bw_conv_buflen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct bw_info *)$tmp)->bw_conv_buflen;"
		end

	c_bw_conv_error (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct bw_info *)$tmp)->bw_conv_error;"
		end

	c_bw_conv_error_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct bw_info *)$tmp)->bw_conv_error_lnum;"
		end

	c_bw_start_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct bw_info *)$tmp)->bw_start_lnum;"
		end

	c_bw_iconv_fd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct bw_info *)$tmp)->bw_iconv_fd;"
		end

feature {NONE} -- C setters

	c_set_bw_fd (tmp: POINTER; a_bw_fd: INTEGER_32)
		external
			"C inline"
		alias
			"((struct bw_info *)$tmp)->bw_fd = $a_bw_fd;"
		end

	c_set_bw_buf (tmp: POINTER; a_bw_buf: POINTER)
		external
			"C inline"
		alias
			"((struct bw_info *)$tmp)->bw_buf = (unsigned char *)$a_bw_buf;"
		end

	c_set_bw_len (tmp: POINTER; a_bw_len: INTEGER_32)
		external
			"C inline"
		alias
			"((struct bw_info *)$tmp)->bw_len = $a_bw_len;"
		end

	c_set_bw_flags (tmp: POINTER; a_bw_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct bw_info *)$tmp)->bw_flags = $a_bw_flags;"
		end

	c_set_bw_restlen (tmp: POINTER; a_bw_restlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct bw_info *)$tmp)->bw_restlen = $a_bw_restlen;"
		end

	c_set_bw_first (tmp: POINTER; a_bw_first: INTEGER_32)
		external
			"C inline"
		alias
			"((struct bw_info *)$tmp)->bw_first = $a_bw_first;"
		end

	c_set_bw_conv_buf (tmp: POINTER; a_bw_conv_buf: POINTER)
		external
			"C inline"
		alias
			"((struct bw_info *)$tmp)->bw_conv_buf = (unsigned char *)$a_bw_conv_buf;"
		end

	c_set_bw_conv_buflen (tmp: POINTER; a_bw_conv_buflen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct bw_info *)$tmp)->bw_conv_buflen = $a_bw_conv_buflen;"
		end

	c_set_bw_conv_error (tmp: POINTER; a_bw_conv_error: INTEGER_32)
		external
			"C inline"
		alias
			"((struct bw_info *)$tmp)->bw_conv_error = $a_bw_conv_error;"
		end

	c_set_bw_conv_error_lnum (tmp: POINTER; a_bw_conv_error_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct bw_info *)$tmp)->bw_conv_error_lnum = $a_bw_conv_error_lnum;"
		end

	c_set_bw_start_lnum (tmp: POINTER; a_bw_start_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct bw_info *)$tmp)->bw_start_lnum = $a_bw_start_lnum;"
		end

	c_set_bw_iconv_fd (tmp: POINTER; a_bw_iconv_fd: POINTER)
		external
			"C inline"
		alias
			"((struct bw_info *)$tmp)->bw_iconv_fd = (void *)$a_bw_iconv_fd;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct bw_info);"
		end

end
