class
	PD_CLEANUP_STUFF

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	pending: INTEGER_32 assign set_pending
		do
			Result := c_pending (c_pointer)
		end

	exception: CE_POINTER [PD_VIM_EXCEPTION] assign set_exception
		do
			create Result.make_shared (c_exception (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_pending (a_pending: INTEGER_32)
		do
			c_set_pending (c_pointer, a_pending)
		end

	set_exception (a_exception: CE_POINTER [PD_VIM_EXCEPTION])
		do
			c_set_exception (c_pointer, a_exception.c_pointer)
		end

feature {NONE} -- C getters

	c_pending (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cleanup_stuff *)$tmp)->pending;"
		end

	c_exception (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct vim_exception *)((struct cleanup_stuff *)$tmp)->exception;"
		end

feature {NONE} -- C setters

	c_set_pending (tmp: POINTER; a_pending: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cleanup_stuff *)$tmp)->pending = $a_pending;"
		end

	c_set_exception (tmp: POINTER; a_exception: POINTER)
		external
			"C inline"
		alias
			"((struct cleanup_stuff *)$tmp)->exception = (struct vim_exception *)$a_exception;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct cleanup_stuff);"
		end

end
