class
	PD_CMDQUEUE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	buffer: CE_POINTER [NATURAL_8] assign set_buffer
		do
			create Result.make_shared (c_buffer (c_pointer))
		end

	next: CE_POINTER [PD_CMDQUEUE] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_CMDQUEUE] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_buffer (a_buffer: CE_POINTER [NATURAL_8])
		do
			c_set_buffer (c_pointer, a_buffer.c_pointer)
		end

	set_next (a_next: CE_POINTER [PD_CMDQUEUE])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_CMDQUEUE])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

feature {NONE} -- C getters

	c_buffer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct cmdqueue *)$tmp)->buffer;"
		end

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct cmdqueue *)((struct cmdqueue *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct cmdqueue *)((struct cmdqueue *)$tmp)->prev;"
		end

feature {NONE} -- C setters

	c_set_buffer (tmp: POINTER; a_buffer: POINTER)
		external
			"C inline"
		alias
			"((struct cmdqueue *)$tmp)->buffer = (unsigned char *)$a_buffer;"
		end

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct cmdqueue *)$tmp)->next = (struct cmdqueue *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct cmdqueue *)$tmp)->prev = (struct cmdqueue *)$a_prev;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct cmdqueue);"
		end

end
