class
	PD_COMPITEM_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ci_key: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_ci_key (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	ci_flag: NATURAL_32 assign set_ci_flag
		do
			Result := c_ci_flag (c_pointer)
		end

	ci_newID: INTEGER_32 assign set_ci_newID
		do
			Result := c_ci_newID (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_ci_flag (a_ci_flag: NATURAL_32)
		do
			c_set_ci_flag (c_pointer, a_ci_flag)
		end

	set_ci_newID (a_ci_newID: INTEGER_32)
		do
			c_set_ci_newID (c_pointer, a_ci_newID)
		end

feature {NONE} -- C getters

	c_ci_key (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct compitem_S *tmp = (struct compitem_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->ci_key) / sizeof(tmp->ci_key[0]);
				return tmp->ci_key;
			]"
		end

	c_ci_flag (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct compitem_S *)$tmp)->ci_flag;"
		end

	c_ci_newID (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct compitem_S *)$tmp)->ci_newID;"
		end

feature {NONE} -- C setters

	c_set_ci_flag (tmp: POINTER; a_ci_flag: NATURAL_32)
		external
			"C inline"
		alias
			"((struct compitem_S *)$tmp)->ci_flag = $a_ci_flag;"
		end

	c_set_ci_newID (tmp: POINTER; a_ci_newID: INTEGER_32)
		external
			"C inline"
		alias
			"((struct compitem_S *)$tmp)->ci_newID = $a_ci_newid;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct compitem_S);"
		end

end
