class
	PD_COMPL_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	cp_next: CE_POINTER [PD_COMPL_S] assign set_cp_next
		do
			create Result.make_shared (c_cp_next (c_pointer))
		end

	cp_prev: CE_POINTER [PD_COMPL_S] assign set_cp_prev
		do
			create Result.make_shared (c_cp_prev (c_pointer))
		end

	cp_str: CE_POINTER [NATURAL_8] assign set_cp_str
		do
			create Result.make_shared (c_cp_str (c_pointer))
		end

	cp_icase: INTEGER_8 assign set_cp_icase
		do
			Result := c_cp_icase (c_pointer)
		end

	cp_text: CE_ARRAY [CE_POINTER [NATURAL_8]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_cp_text (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	cp_fname: CE_POINTER [NATURAL_8] assign set_cp_fname
		do
			create Result.make_shared (c_cp_fname (c_pointer))
		end

	cp_flags: INTEGER_32 assign set_cp_flags
		do
			Result := c_cp_flags (c_pointer)
		end

	cp_number: INTEGER_32 assign set_cp_number
		do
			Result := c_cp_number (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_cp_next (a_cp_next: CE_POINTER [PD_COMPL_S])
		do
			c_set_cp_next (c_pointer, a_cp_next.c_pointer)
		end

	set_cp_prev (a_cp_prev: CE_POINTER [PD_COMPL_S])
		do
			c_set_cp_prev (c_pointer, a_cp_prev.c_pointer)
		end

	set_cp_str (a_cp_str: CE_POINTER [NATURAL_8])
		do
			c_set_cp_str (c_pointer, a_cp_str.c_pointer)
		end

	set_cp_icase (a_cp_icase: INTEGER_8)
		do
			c_set_cp_icase (c_pointer, a_cp_icase)
		end

	set_cp_fname (a_cp_fname: CE_POINTER [NATURAL_8])
		do
			c_set_cp_fname (c_pointer, a_cp_fname.c_pointer)
		end

	set_cp_flags (a_cp_flags: INTEGER_32)
		do
			c_set_cp_flags (c_pointer, a_cp_flags)
		end

	set_cp_number (a_cp_number: INTEGER_32)
		do
			c_set_cp_number (c_pointer, a_cp_number)
		end

feature {NONE} -- C getters

	c_cp_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct compl_S *)((struct compl_S *)$tmp)->cp_next;"
		end

	c_cp_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct compl_S *)((struct compl_S *)$tmp)->cp_prev;"
		end

	c_cp_str (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct compl_S *)$tmp)->cp_str;"
		end

	c_cp_icase (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct compl_S *)$tmp)->cp_icase;"
		end

	c_cp_text (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct compl_S *tmp = (struct compl_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->cp_text) / sizeof(tmp->cp_text[0]);
				return tmp->cp_text;
			]"
		end

	c_cp_fname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct compl_S *)$tmp)->cp_fname;"
		end

	c_cp_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct compl_S *)$tmp)->cp_flags;"
		end

	c_cp_number (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct compl_S *)$tmp)->cp_number;"
		end

feature {NONE} -- C setters

	c_set_cp_next (tmp: POINTER; a_cp_next: POINTER)
		external
			"C inline"
		alias
			"((struct compl_S *)$tmp)->cp_next = (struct compl_S *)$a_cp_next;"
		end

	c_set_cp_prev (tmp: POINTER; a_cp_prev: POINTER)
		external
			"C inline"
		alias
			"((struct compl_S *)$tmp)->cp_prev = (struct compl_S *)$a_cp_prev;"
		end

	c_set_cp_str (tmp: POINTER; a_cp_str: POINTER)
		external
			"C inline"
		alias
			"((struct compl_S *)$tmp)->cp_str = (unsigned char *)$a_cp_str;"
		end

	c_set_cp_icase (tmp: POINTER; a_cp_icase: INTEGER_8)
		external
			"C inline"
		alias
			"((struct compl_S *)$tmp)->cp_icase = $a_cp_icase;"
		end

	c_set_cp_fname (tmp: POINTER; a_cp_fname: POINTER)
		external
			"C inline"
		alias
			"((struct compl_S *)$tmp)->cp_fname = (unsigned char *)$a_cp_fname;"
		end

	c_set_cp_flags (tmp: POINTER; a_cp_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct compl_S *)$tmp)->cp_flags = $a_cp_flags;"
		end

	c_set_cp_number (tmp: POINTER; a_cp_number: INTEGER_32)
		external
			"C inline"
		alias
			"((struct compl_S *)$tmp)->cp_number = $a_cp_number;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct compl_S);"
		end

end
