class
	PD_CONDSTACK

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	cs_flags: CE_ARRAY [INTEGER_16]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_cs_flags (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	cs_pending: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_cs_pending (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	cs_pend: PD_CS_PEND assign set_cs_pend
		do
			create Result.make_shared (c_cs_pend (c_pointer))
		end

	cs_forinfo: CE_ARRAY [CE_POINTER [ANY]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_cs_forinfo (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	cs_line: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_cs_line (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	cs_idx: INTEGER_32 assign set_cs_idx
		do
			Result := c_cs_idx (c_pointer)
		end

	cs_looplevel: INTEGER_32 assign set_cs_looplevel
		do
			Result := c_cs_looplevel (c_pointer)
		end

	cs_looplevel_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct condstack, cs_looplevel);"
		end

	cs_trylevel: INTEGER_32 assign set_cs_trylevel
		do
			Result := c_cs_trylevel (c_pointer)
		end

	cs_trylevel_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct condstack, cs_trylevel);"
		end

	cs_emsg_silent_list: CE_POINTER [PD_ESLIST_ELEM] assign set_cs_emsg_silent_list
		do
			create Result.make_shared (c_cs_emsg_silent_list (c_pointer))
		end

	cs_lflags: INTEGER_8 assign set_cs_lflags
		do
			Result := c_cs_lflags (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_cs_pend (a_cs_pend: PD_CS_PEND)
		do
			cs_pend.ce_gets (a_cs_pend)
		end

	set_cs_idx (a_cs_idx: INTEGER_32)
		do
			c_set_cs_idx (c_pointer, a_cs_idx)
		end

	set_cs_looplevel (a_cs_looplevel: INTEGER_32)
		do
			c_set_cs_looplevel (c_pointer, a_cs_looplevel)
		end

	set_cs_trylevel (a_cs_trylevel: INTEGER_32)
		do
			c_set_cs_trylevel (c_pointer, a_cs_trylevel)
		end

	set_cs_emsg_silent_list (a_cs_emsg_silent_list: CE_POINTER [PD_ESLIST_ELEM])
		do
			c_set_cs_emsg_silent_list (c_pointer, a_cs_emsg_silent_list.c_pointer)
		end

	set_cs_lflags (a_cs_lflags: INTEGER_8)
		do
			c_set_cs_lflags (c_pointer, a_cs_lflags)
		end

feature {NONE} -- C getters

	c_cs_flags (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct condstack *tmp = (struct condstack *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->cs_flags) / sizeof(tmp->cs_flags[0]);
				return tmp->cs_flags;
			]"
		end

	c_cs_pending (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct condstack *tmp = (struct condstack *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->cs_pending) / sizeof(tmp->cs_pending[0]);
				return tmp->cs_pending;
			]"
		end

	c_cs_pend (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_cs_pend_522 *)&((struct condstack *)$tmp)->cs_pend;"
		end

	c_cs_forinfo (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct condstack *tmp = (struct condstack *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->cs_forinfo) / sizeof(tmp->cs_forinfo[0]);
				return tmp->cs_forinfo;
			]"
		end

	c_cs_line (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct condstack *tmp = (struct condstack *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->cs_line) / sizeof(tmp->cs_line[0]);
				return tmp->cs_line;
			]"
		end

	c_cs_idx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct condstack *)$tmp)->cs_idx;"
		end

	c_cs_looplevel (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct condstack *)$tmp)->cs_looplevel;"
		end

	c_cs_trylevel (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct condstack *)$tmp)->cs_trylevel;"
		end

	c_cs_emsg_silent_list (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct eslist_elem *)((struct condstack *)$tmp)->cs_emsg_silent_list;"
		end

	c_cs_lflags (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct condstack *)$tmp)->cs_lflags;"
		end

feature {NONE} -- C setters

	c_set_cs_idx (tmp: POINTER; a_cs_idx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct condstack *)$tmp)->cs_idx = $a_cs_idx;"
		end

	c_set_cs_looplevel (tmp: POINTER; a_cs_looplevel: INTEGER_32)
		external
			"C inline"
		alias
			"((struct condstack *)$tmp)->cs_looplevel = $a_cs_looplevel;"
		end

	c_set_cs_trylevel (tmp: POINTER; a_cs_trylevel: INTEGER_32)
		external
			"C inline"
		alias
			"((struct condstack *)$tmp)->cs_trylevel = $a_cs_trylevel;"
		end

	c_set_cs_emsg_silent_list (tmp: POINTER; a_cs_emsg_silent_list: POINTER)
		external
			"C inline"
		alias
			"((struct condstack *)$tmp)->cs_emsg_silent_list = (struct eslist_elem *)$a_cs_emsg_silent_list;"
		end

	c_set_cs_lflags (tmp: POINTER; a_cs_lflags: INTEGER_8)
		external
			"C inline"
		alias
			"((struct condstack *)$tmp)->cs_lflags = $a_cs_lflags;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct condstack);"
		end

end
