class
	PD_DATA_BLOCK

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	db_id: NATURAL_16 assign set_db_id
		do
			Result := c_db_id (c_pointer)
		end

	db_free: NATURAL_32 assign set_db_free
		do
			Result := c_db_free (c_pointer)
		end

	db_txt_start: NATURAL_32 assign set_db_txt_start
		do
			Result := c_db_txt_start (c_pointer)
		end

	db_txt_end: NATURAL_32 assign set_db_txt_end
		do
			Result := c_db_txt_end (c_pointer)
		end

	db_line_count: INTEGER_32 assign set_db_line_count
		do
			Result := c_db_line_count (c_pointer)
		end

	db_index: CE_ARRAY [NATURAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_db_index (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_db_id (a_db_id: NATURAL_16)
		do
			c_set_db_id (c_pointer, a_db_id)
		end

	set_db_free (a_db_free: NATURAL_32)
		do
			c_set_db_free (c_pointer, a_db_free)
		end

	set_db_txt_start (a_db_txt_start: NATURAL_32)
		do
			c_set_db_txt_start (c_pointer, a_db_txt_start)
		end

	set_db_txt_end (a_db_txt_end: NATURAL_32)
		do
			c_set_db_txt_end (c_pointer, a_db_txt_end)
		end

	set_db_line_count (a_db_line_count: INTEGER_32)
		do
			c_set_db_line_count (c_pointer, a_db_line_count)
		end

feature {NONE} -- C getters

	c_db_id (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct data_block *)$tmp)->db_id;"
		end

	c_db_free (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct data_block *)$tmp)->db_free;"
		end

	c_db_txt_start (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct data_block *)$tmp)->db_txt_start;"
		end

	c_db_txt_end (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct data_block *)$tmp)->db_txt_end;"
		end

	c_db_line_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct data_block *)$tmp)->db_line_count;"
		end

	c_db_index (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct data_block *tmp = (struct data_block *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->db_index) / sizeof(tmp->db_index[0]);
				return tmp->db_index;
			]"
		end

feature {NONE} -- C setters

	c_set_db_id (tmp: POINTER; a_db_id: NATURAL_16)
		external
			"C inline"
		alias
			"((struct data_block *)$tmp)->db_id = $a_db_id;"
		end

	c_set_db_free (tmp: POINTER; a_db_free: NATURAL_32)
		external
			"C inline"
		alias
			"((struct data_block *)$tmp)->db_free = $a_db_free;"
		end

	c_set_db_txt_start (tmp: POINTER; a_db_txt_start: NATURAL_32)
		external
			"C inline"
		alias
			"((struct data_block *)$tmp)->db_txt_start = $a_db_txt_start;"
		end

	c_set_db_txt_end (tmp: POINTER; a_db_txt_end: NATURAL_32)
		external
			"C inline"
		alias
			"((struct data_block *)$tmp)->db_txt_end = $a_db_txt_end;"
		end

	c_set_db_line_count (tmp: POINTER; a_db_line_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct data_block *)$tmp)->db_line_count = $a_db_line_count;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct data_block);"
		end

end
