class
	PD_DBG_STUFF

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	trylevel: INTEGER_32 assign set_trylevel
		do
			Result := c_trylevel (c_pointer)
		end

	force_abort: INTEGER_32 assign set_force_abort
		do
			Result := c_force_abort (c_pointer)
		end

	caught_stack: CE_POINTER [PD_VIM_EXCEPTION] assign set_caught_stack
		do
			create Result.make_shared (c_caught_stack (c_pointer))
		end

	vv_exception: CE_POINTER [NATURAL_8] assign set_vv_exception
		do
			create Result.make_shared (c_vv_exception (c_pointer))
		end

	vv_throwpoint: CE_POINTER [NATURAL_8] assign set_vv_throwpoint
		do
			create Result.make_shared (c_vv_throwpoint (c_pointer))
		end

	did_emsg: INTEGER_32 assign set_did_emsg
		do
			Result := c_did_emsg (c_pointer)
		end

	got_int: INTEGER_32 assign set_got_int
		do
			Result := c_got_int (c_pointer)
		end

	did_throw: INTEGER_32 assign set_did_throw
		do
			Result := c_did_throw (c_pointer)
		end

	need_rethrow: INTEGER_32 assign set_need_rethrow
		do
			Result := c_need_rethrow (c_pointer)
		end

	check_cstack: INTEGER_32 assign set_check_cstack
		do
			Result := c_check_cstack (c_pointer)
		end

	current_exception: CE_POINTER [PD_VIM_EXCEPTION] assign set_current_exception
		do
			create Result.make_shared (c_current_exception (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_trylevel (a_trylevel: INTEGER_32)
		do
			c_set_trylevel (c_pointer, a_trylevel)
		end

	set_force_abort (a_force_abort: INTEGER_32)
		do
			c_set_force_abort (c_pointer, a_force_abort)
		end

	set_caught_stack (a_caught_stack: CE_POINTER [PD_VIM_EXCEPTION])
		do
			c_set_caught_stack (c_pointer, a_caught_stack.c_pointer)
		end

	set_vv_exception (a_vv_exception: CE_POINTER [NATURAL_8])
		do
			c_set_vv_exception (c_pointer, a_vv_exception.c_pointer)
		end

	set_vv_throwpoint (a_vv_throwpoint: CE_POINTER [NATURAL_8])
		do
			c_set_vv_throwpoint (c_pointer, a_vv_throwpoint.c_pointer)
		end

	set_did_emsg (a_did_emsg: INTEGER_32)
		do
			c_set_did_emsg (c_pointer, a_did_emsg)
		end

	set_got_int (a_got_int: INTEGER_32)
		do
			c_set_got_int (c_pointer, a_got_int)
		end

	set_did_throw (a_did_throw: INTEGER_32)
		do
			c_set_did_throw (c_pointer, a_did_throw)
		end

	set_need_rethrow (a_need_rethrow: INTEGER_32)
		do
			c_set_need_rethrow (c_pointer, a_need_rethrow)
		end

	set_check_cstack (a_check_cstack: INTEGER_32)
		do
			c_set_check_cstack (c_pointer, a_check_cstack)
		end

	set_current_exception (a_current_exception: CE_POINTER [PD_VIM_EXCEPTION])
		do
			c_set_current_exception (c_pointer, a_current_exception.c_pointer)
		end

feature {NONE} -- C getters

	c_trylevel (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dbg_stuff *)$tmp)->trylevel;"
		end

	c_force_abort (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dbg_stuff *)$tmp)->force_abort;"
		end

	c_caught_stack (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct vim_exception *)((struct dbg_stuff *)$tmp)->caught_stack;"
		end

	c_vv_exception (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct dbg_stuff *)$tmp)->vv_exception;"
		end

	c_vv_throwpoint (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct dbg_stuff *)$tmp)->vv_throwpoint;"
		end

	c_did_emsg (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dbg_stuff *)$tmp)->did_emsg;"
		end

	c_got_int (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dbg_stuff *)$tmp)->got_int;"
		end

	c_did_throw (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dbg_stuff *)$tmp)->did_throw;"
		end

	c_need_rethrow (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dbg_stuff *)$tmp)->need_rethrow;"
		end

	c_check_cstack (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dbg_stuff *)$tmp)->check_cstack;"
		end

	c_current_exception (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct vim_exception *)((struct dbg_stuff *)$tmp)->current_exception;"
		end

feature {NONE} -- C setters

	c_set_trylevel (tmp: POINTER; a_trylevel: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dbg_stuff *)$tmp)->trylevel = $a_trylevel;"
		end

	c_set_force_abort (tmp: POINTER; a_force_abort: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dbg_stuff *)$tmp)->force_abort = $a_force_abort;"
		end

	c_set_caught_stack (tmp: POINTER; a_caught_stack: POINTER)
		external
			"C inline"
		alias
			"((struct dbg_stuff *)$tmp)->caught_stack = (struct vim_exception *)$a_caught_stack;"
		end

	c_set_vv_exception (tmp: POINTER; a_vv_exception: POINTER)
		external
			"C inline"
		alias
			"((struct dbg_stuff *)$tmp)->vv_exception = (unsigned char *)$a_vv_exception;"
		end

	c_set_vv_throwpoint (tmp: POINTER; a_vv_throwpoint: POINTER)
		external
			"C inline"
		alias
			"((struct dbg_stuff *)$tmp)->vv_throwpoint = (unsigned char *)$a_vv_throwpoint;"
		end

	c_set_did_emsg (tmp: POINTER; a_did_emsg: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dbg_stuff *)$tmp)->did_emsg = $a_did_emsg;"
		end

	c_set_got_int (tmp: POINTER; a_got_int: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dbg_stuff *)$tmp)->got_int = $a_got_int;"
		end

	c_set_did_throw (tmp: POINTER; a_did_throw: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dbg_stuff *)$tmp)->did_throw = $a_did_throw;"
		end

	c_set_need_rethrow (tmp: POINTER; a_need_rethrow: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dbg_stuff *)$tmp)->need_rethrow = $a_need_rethrow;"
		end

	c_set_check_cstack (tmp: POINTER; a_check_cstack: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dbg_stuff *)$tmp)->check_cstack = $a_check_cstack;"
		end

	c_set_current_exception (tmp: POINTER; a_current_exception: POINTER)
		external
			"C inline"
		alias
			"((struct dbg_stuff *)$tmp)->current_exception = (struct vim_exception *)$a_current_exception;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct dbg_stuff);"
		end

end
