class
	PD_DEBUGGY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	dbg_nr: INTEGER_32 assign set_dbg_nr
		do
			Result := c_dbg_nr (c_pointer)
		end

	dbg_type: INTEGER_32 assign set_dbg_type
		do
			Result := c_dbg_type (c_pointer)
		end

	dbg_name: CE_POINTER [NATURAL_8] assign set_dbg_name
		do
			create Result.make_shared (c_dbg_name (c_pointer))
		end

	dbg_prog: CE_POINTER [PD_REGPROG_T] assign set_dbg_prog
		do
			create Result.make_shared (c_dbg_prog (c_pointer))
		end

	dbg_lnum: INTEGER_32 assign set_dbg_lnum
		do
			Result := c_dbg_lnum (c_pointer)
		end

	dbg_forceit: INTEGER_32 assign set_dbg_forceit
		do
			Result := c_dbg_forceit (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_dbg_nr (a_dbg_nr: INTEGER_32)
		do
			c_set_dbg_nr (c_pointer, a_dbg_nr)
		end

	set_dbg_type (a_dbg_type: INTEGER_32)
		do
			c_set_dbg_type (c_pointer, a_dbg_type)
		end

	set_dbg_name (a_dbg_name: CE_POINTER [NATURAL_8])
		do
			c_set_dbg_name (c_pointer, a_dbg_name.c_pointer)
		end

	set_dbg_prog (a_dbg_prog: CE_POINTER [PD_REGPROG_T])
		do
			c_set_dbg_prog (c_pointer, a_dbg_prog.c_pointer)
		end

	set_dbg_lnum (a_dbg_lnum: INTEGER_32)
		do
			c_set_dbg_lnum (c_pointer, a_dbg_lnum)
		end

	set_dbg_forceit (a_dbg_forceit: INTEGER_32)
		do
			c_set_dbg_forceit (c_pointer, a_dbg_forceit)
		end

feature {NONE} -- C getters

	c_dbg_nr (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct debuggy *)$tmp)->dbg_nr;"
		end

	c_dbg_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct debuggy *)$tmp)->dbg_type;"
		end

	c_dbg_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct debuggy *)$tmp)->dbg_name;"
		end

	c_dbg_prog (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (regprog_T *)((struct debuggy *)$tmp)->dbg_prog;"
		end

	c_dbg_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct debuggy *)$tmp)->dbg_lnum;"
		end

	c_dbg_forceit (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct debuggy *)$tmp)->dbg_forceit;"
		end

feature {NONE} -- C setters

	c_set_dbg_nr (tmp: POINTER; a_dbg_nr: INTEGER_32)
		external
			"C inline"
		alias
			"((struct debuggy *)$tmp)->dbg_nr = $a_dbg_nr;"
		end

	c_set_dbg_type (tmp: POINTER; a_dbg_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct debuggy *)$tmp)->dbg_type = $a_dbg_type;"
		end

	c_set_dbg_name (tmp: POINTER; a_dbg_name: POINTER)
		external
			"C inline"
		alias
			"((struct debuggy *)$tmp)->dbg_name = (unsigned char *)$a_dbg_name;"
		end

	c_set_dbg_prog (tmp: POINTER; a_dbg_prog: POINTER)
		external
			"C inline"
		alias
			"((struct debuggy *)$tmp)->dbg_prog = (regprog_T *)$a_dbg_prog;"
		end

	c_set_dbg_lnum (tmp: POINTER; a_dbg_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct debuggy *)$tmp)->dbg_lnum = $a_dbg_lnum;"
		end

	c_set_dbg_forceit (tmp: POINTER; a_dbg_forceit: INTEGER_32)
		external
			"C inline"
		alias
			"((struct debuggy *)$tmp)->dbg_forceit = $a_dbg_forceit;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct debuggy);"
		end

end
