class
	PD_DICTITEM_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	di_tv: PD_TYPVAL_T assign set_di_tv
		do
			create Result.make_shared (c_di_tv (c_pointer))
		end

	di_tv_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct dictitem_S, di_tv);"
		end

	di_flags: NATURAL_8 assign set_di_flags
		do
			Result := c_di_flags (c_pointer)
		end

	di_key: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_di_key (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_di_tv (a_di_tv: PD_TYPVAL_T)
		do
			di_tv.ce_gets (a_di_tv)
		end

	set_di_flags (a_di_flags: NATURAL_8)
		do
			c_set_di_flags (c_pointer, a_di_flags)
		end

feature {NONE} -- C getters

	c_di_tv (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (typval_T *)&((struct dictitem_S *)$tmp)->di_tv;"
		end

	c_di_flags (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct dictitem_S *)$tmp)->di_flags;"
		end

	c_di_key (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct dictitem_S *tmp = (struct dictitem_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->di_key) / sizeof(tmp->di_key[0]);
				return tmp->di_key;
			]"
		end

feature {NONE} -- C setters

	c_set_di_flags (tmp: POINTER; a_di_flags: NATURAL_8)
		external
			"C inline"
		alias
			"((struct dictitem_S *)$tmp)->di_flags = $a_di_flags;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct dictitem_S);"
		end

end
