class
	PD_DICTVAR_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	dv_refcount: INTEGER_32 assign set_dv_refcount
		do
			Result := c_dv_refcount (c_pointer)
		end

	dv_hashtab: PD_HASHTABLE_S assign set_dv_hashtab
		do
			create Result.make_shared (c_dv_hashtab (c_pointer))
		end

	dv_hashtab_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct dictvar_S, dv_hashtab);"
		end

	dv_copyID: INTEGER_32 assign set_dv_copyID
		do
			Result := c_dv_copyID (c_pointer)
		end

	dv_copydict: CE_POINTER [PD_DICTVAR_S] assign set_dv_copydict
		do
			create Result.make_shared (c_dv_copydict (c_pointer))
		end

	dv_lock: INTEGER_8 assign set_dv_lock
		do
			Result := c_dv_lock (c_pointer)
		end

	dv_used_next: CE_POINTER [PD_DICTVAR_S] assign set_dv_used_next
		do
			create Result.make_shared (c_dv_used_next (c_pointer))
		end

	dv_used_prev: CE_POINTER [PD_DICTVAR_S] assign set_dv_used_prev
		do
			create Result.make_shared (c_dv_used_prev (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_dv_refcount (a_dv_refcount: INTEGER_32)
		do
			c_set_dv_refcount (c_pointer, a_dv_refcount)
		end

	set_dv_hashtab (a_dv_hashtab: PD_HASHTABLE_S)
		do
			dv_hashtab.ce_gets (a_dv_hashtab)
		end

	set_dv_copyID (a_dv_copyID: INTEGER_32)
		do
			c_set_dv_copyID (c_pointer, a_dv_copyID)
		end

	set_dv_copydict (a_dv_copydict: CE_POINTER [PD_DICTVAR_S])
		do
			c_set_dv_copydict (c_pointer, a_dv_copydict.c_pointer)
		end

	set_dv_lock (a_dv_lock: INTEGER_8)
		do
			c_set_dv_lock (c_pointer, a_dv_lock)
		end

	set_dv_used_next (a_dv_used_next: CE_POINTER [PD_DICTVAR_S])
		do
			c_set_dv_used_next (c_pointer, a_dv_used_next.c_pointer)
		end

	set_dv_used_prev (a_dv_used_prev: CE_POINTER [PD_DICTVAR_S])
		do
			c_set_dv_used_prev (c_pointer, a_dv_used_prev.c_pointer)
		end

feature {NONE} -- C getters

	c_dv_refcount (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dictvar_S *)$tmp)->dv_refcount;"
		end

	c_dv_hashtab (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct hashtable_S *)&((struct dictvar_S *)$tmp)->dv_hashtab;"
		end

	c_dv_copyID (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dictvar_S *)$tmp)->dv_copyID;"
		end

	c_dv_copydict (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dictvar_S *)((struct dictvar_S *)$tmp)->dv_copydict;"
		end

	c_dv_lock (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct dictvar_S *)$tmp)->dv_lock;"
		end

	c_dv_used_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dictvar_S *)((struct dictvar_S *)$tmp)->dv_used_next;"
		end

	c_dv_used_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dictvar_S *)((struct dictvar_S *)$tmp)->dv_used_prev;"
		end

feature {NONE} -- C setters

	c_set_dv_refcount (tmp: POINTER; a_dv_refcount: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dictvar_S *)$tmp)->dv_refcount = $a_dv_refcount;"
		end

	c_set_dv_copyID (tmp: POINTER; a_dv_copyID: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dictvar_S *)$tmp)->dv_copyID = $a_dv_copyid;"
		end

	c_set_dv_copydict (tmp: POINTER; a_dv_copydict: POINTER)
		external
			"C inline"
		alias
			"((struct dictvar_S *)$tmp)->dv_copydict = (struct dictvar_S *)$a_dv_copydict;"
		end

	c_set_dv_lock (tmp: POINTER; a_dv_lock: INTEGER_8)
		external
			"C inline"
		alias
			"((struct dictvar_S *)$tmp)->dv_lock = $a_dv_lock;"
		end

	c_set_dv_used_next (tmp: POINTER; a_dv_used_next: POINTER)
		external
			"C inline"
		alias
			"((struct dictvar_S *)$tmp)->dv_used_next = (struct dictvar_S *)$a_dv_used_next;"
		end

	c_set_dv_used_prev (tmp: POINTER; a_dv_used_prev: POINTER)
		external
			"C inline"
		alias
			"((struct dictvar_S *)$tmp)->dv_used_prev = (struct dictvar_S *)$a_dv_used_prev;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct dictvar_S);"
		end

end
