class
	PD_DIFFBLOCK_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	df_next: CE_POINTER [PD_DIFFBLOCK_S] assign set_df_next
		do
			create Result.make_shared (c_df_next (c_pointer))
		end

	df_lnum: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_df_lnum (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	df_count: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_df_count (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_df_next (a_df_next: CE_POINTER [PD_DIFFBLOCK_S])
		do
			c_set_df_next (c_pointer, a_df_next.c_pointer)
		end

feature {NONE} -- C getters

	c_df_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct diffblock_S *)((struct diffblock_S *)$tmp)->df_next;"
		end

	c_df_lnum (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct diffblock_S *tmp = (struct diffblock_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->df_lnum) / sizeof(tmp->df_lnum[0]);
				return tmp->df_lnum;
			]"
		end

	c_df_count (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct diffblock_S *tmp = (struct diffblock_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->df_count) / sizeof(tmp->df_count[0]);
				return tmp->df_count;
			]"
		end

feature {NONE} -- C setters

	c_set_df_next (tmp: POINTER; a_df_next: POINTER)
		external
			"C inline"
		alias
			"((struct diffblock_S *)$tmp)->df_next = (struct diffblock_S *)$a_df_next;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct diffblock_S);"
		end

end
