class
	PD_EFM_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	prog: CE_POINTER [PD_REGPROG_T] assign set_prog
		do
			create Result.make_shared (c_prog (c_pointer))
		end

	next: CE_POINTER [PD_EFM_S] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	addr: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_addr (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	prefix2: NATURAL_8 assign set_prefix2
		do
			Result := c_prefix2 (c_pointer)
		end

	flags: NATURAL_8 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	conthere: INTEGER_32 assign set_conthere
		do
			Result := c_conthere (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_prog (a_prog: CE_POINTER [PD_REGPROG_T])
		do
			c_set_prog (c_pointer, a_prog.c_pointer)
		end

	set_next (a_next: CE_POINTER [PD_EFM_S])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prefix2 (a_prefix2: NATURAL_8)
		do
			c_set_prefix2 (c_pointer, a_prefix2)
		end

	set_flags (a_flags: NATURAL_8)
		do
			c_set_flags (c_pointer, a_flags)
		end

	set_conthere (a_conthere: INTEGER_32)
		do
			c_set_conthere (c_pointer, a_conthere)
		end

feature {NONE} -- C getters

	c_prog (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (regprog_T *)((struct efm_S *)$tmp)->prog;"
		end

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct efm_S *)((struct efm_S *)$tmp)->next;"
		end

	c_addr (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct efm_S *tmp = (struct efm_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->addr) / sizeof(tmp->addr[0]);
				return tmp->addr;
			]"
		end

	c_prefix2 (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct efm_S *)$tmp)->prefix;"
		end

	c_flags (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct efm_S *)$tmp)->flags;"
		end

	c_conthere (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct efm_S *)$tmp)->conthere;"
		end

feature {NONE} -- C setters

	c_set_prog (tmp: POINTER; a_prog: POINTER)
		external
			"C inline"
		alias
			"((struct efm_S *)$tmp)->prog = (regprog_T *)$a_prog;"
		end

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct efm_S *)$tmp)->next = (struct efm_S *)$a_next;"
		end

	c_set_prefix2 (tmp: POINTER; a_prefix2: NATURAL_8)
		external
			"C inline"
		alias
			"((struct efm_S *)$tmp)->prefix = $a_prefix2;"
		end

	c_set_flags (tmp: POINTER; a_flags: NATURAL_8)
		external
			"C inline"
		alias
			"((struct efm_S *)$tmp)->flags = $a_flags;"
		end

	c_set_conthere (tmp: POINTER; a_conthere: INTEGER_32)
		external
			"C inline"
		alias
			"((struct efm_S *)$tmp)->conthere = $a_conthere;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct efm_S);"
		end

end
