class
	PD_EXPAND

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	xp_context: INTEGER_32 assign set_xp_context
		do
			Result := c_xp_context (c_pointer)
		end

	xp_context_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct expand, xp_context);"
		end

	xp_pattern: CE_POINTER [NATURAL_8] assign set_xp_pattern
		do
			create Result.make_shared (c_xp_pattern (c_pointer))
		end

	xp_pattern_len: INTEGER_32 assign set_xp_pattern_len
		do
			Result := c_xp_pattern_len (c_pointer)
		end

	xp_arg: CE_POINTER [NATURAL_8] assign set_xp_arg
		do
			create Result.make_shared (c_xp_arg (c_pointer))
		end

	xp_scriptID: INTEGER_32 assign set_xp_scriptID
		do
			Result := c_xp_scriptID (c_pointer)
		end

	xp_backslash: INTEGER_32 assign set_xp_backslash
		do
			Result := c_xp_backslash (c_pointer)
		end

	xp_shell: INTEGER_32 assign set_xp_shell
		do
			Result := c_xp_shell (c_pointer)
		end

	xp_numfiles: INTEGER_32 assign set_xp_numfiles
		do
			Result := c_xp_numfiles (c_pointer)
		end

	xp_numfiles_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct expand, xp_numfiles);"
		end

	xp_files: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_xp_files
		do
			create Result.make_shared (c_xp_files (c_pointer))
		end

	xp_files_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct expand, xp_files);"
		end

feature {ANY} -- Eiffel setters

	set_xp_context (a_xp_context: INTEGER_32)
		do
			c_set_xp_context (c_pointer, a_xp_context)
		end

	set_xp_pattern (a_xp_pattern: CE_POINTER [NATURAL_8])
		do
			c_set_xp_pattern (c_pointer, a_xp_pattern.c_pointer)
		end

	set_xp_pattern_len (a_xp_pattern_len: INTEGER_32)
		do
			c_set_xp_pattern_len (c_pointer, a_xp_pattern_len)
		end

	set_xp_arg (a_xp_arg: CE_POINTER [NATURAL_8])
		do
			c_set_xp_arg (c_pointer, a_xp_arg.c_pointer)
		end

	set_xp_scriptID (a_xp_scriptID: INTEGER_32)
		do
			c_set_xp_scriptID (c_pointer, a_xp_scriptID)
		end

	set_xp_backslash (a_xp_backslash: INTEGER_32)
		do
			c_set_xp_backslash (c_pointer, a_xp_backslash)
		end

	set_xp_shell (a_xp_shell: INTEGER_32)
		do
			c_set_xp_shell (c_pointer, a_xp_shell)
		end

	set_xp_numfiles (a_xp_numfiles: INTEGER_32)
		do
			c_set_xp_numfiles (c_pointer, a_xp_numfiles)
		end

	set_xp_files (a_xp_files: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			c_set_xp_files (c_pointer, a_xp_files.c_pointer)
		end

feature {NONE} -- C getters

	c_xp_context (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct expand *)$tmp)->xp_context;"
		end

	c_xp_pattern (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct expand *)$tmp)->xp_pattern;"
		end

	c_xp_pattern_len (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct expand *)$tmp)->xp_pattern_len;"
		end

	c_xp_arg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct expand *)$tmp)->xp_arg;"
		end

	c_xp_scriptID (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct expand *)$tmp)->xp_scriptID;"
		end

	c_xp_backslash (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct expand *)$tmp)->xp_backslash;"
		end

	c_xp_shell (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct expand *)$tmp)->xp_shell;"
		end

	c_xp_numfiles (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct expand *)$tmp)->xp_numfiles;"
		end

	c_xp_files (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char * *)((struct expand *)$tmp)->xp_files;"
		end

feature {NONE} -- C setters

	c_set_xp_context (tmp: POINTER; a_xp_context: INTEGER_32)
		external
			"C inline"
		alias
			"((struct expand *)$tmp)->xp_context = $a_xp_context;"
		end

	c_set_xp_pattern (tmp: POINTER; a_xp_pattern: POINTER)
		external
			"C inline"
		alias
			"((struct expand *)$tmp)->xp_pattern = (unsigned char *)$a_xp_pattern;"
		end

	c_set_xp_pattern_len (tmp: POINTER; a_xp_pattern_len: INTEGER_32)
		external
			"C inline"
		alias
			"((struct expand *)$tmp)->xp_pattern_len = $a_xp_pattern_len;"
		end

	c_set_xp_arg (tmp: POINTER; a_xp_arg: POINTER)
		external
			"C inline"
		alias
			"((struct expand *)$tmp)->xp_arg = (unsigned char *)$a_xp_arg;"
		end

	c_set_xp_scriptID (tmp: POINTER; a_xp_scriptID: INTEGER_32)
		external
			"C inline"
		alias
			"((struct expand *)$tmp)->xp_scriptID = $a_xp_scriptid;"
		end

	c_set_xp_backslash (tmp: POINTER; a_xp_backslash: INTEGER_32)
		external
			"C inline"
		alias
			"((struct expand *)$tmp)->xp_backslash = $a_xp_backslash;"
		end

	c_set_xp_shell (tmp: POINTER; a_xp_shell: INTEGER_32)
		external
			"C inline"
		alias
			"((struct expand *)$tmp)->xp_shell = $a_xp_shell;"
		end

	c_set_xp_numfiles (tmp: POINTER; a_xp_numfiles: INTEGER_32)
		external
			"C inline"
		alias
			"((struct expand *)$tmp)->xp_numfiles = $a_xp_numfiles;"
		end

	c_set_xp_files (tmp: POINTER; a_xp_files: POINTER)
		external
			"C inline"
		alias
			"((struct expand *)$tmp)->xp_files = (unsigned char * *)$a_xp_files;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct expand);"
		end

end
