class
	PD_EXPGEN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	context: INTEGER_32 assign set_context
		do
			Result := c_context (c_pointer)
		end

	func: CE_ROUTINE assign set_func
		do
			create Result.make_shared (c_func (c_pointer))
		end

	ic: INTEGER_32 assign set_ic
		do
			Result := c_ic (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_context (a_context: INTEGER_32)
		do
			c_set_context (c_pointer, a_context)
		end

	set_func (a_func: CE_ROUTINE)
		do
			c_set_func (c_pointer, a_func.c_pointer)
		end

	set_ic (a_ic: INTEGER_32)
		do
			c_set_ic (c_pointer, a_ic)
		end

feature {NONE} -- C getters

	c_context (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct expgen *)$tmp)->context;"
		end

	c_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *( *)(struct expand *, int))((struct expgen *)$tmp)->func;"
		end

	c_ic (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct expgen *)$tmp)->ic;"
		end

feature {NONE} -- C setters

	c_set_context (tmp: POINTER; a_context: INTEGER_32)
		external
			"C inline"
		alias
			"((struct expgen *)$tmp)->context = $a_context;"
		end

	c_set_func (tmp: POINTER; a_func: POINTER)
		external
			"C inline"
		alias
			"((struct expgen *)$tmp)->func = (unsigned char *( *)(struct expand *, int))$a_func;"
		end

	c_set_ic (tmp: POINTER; a_ic: INTEGER_32)
		external
			"C inline"
		alias
			"((struct expgen *)$tmp)->ic = $a_ic;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct expgen);"
		end

end
