class
	PD_FF_STACK

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ffs_prev: CE_POINTER [PD_FF_STACK] assign set_ffs_prev
		do
			create Result.make_shared (c_ffs_prev (c_pointer))
		end

	ffs_fix_path: CE_POINTER [NATURAL_8] assign set_ffs_fix_path
		do
			create Result.make_shared (c_ffs_fix_path (c_pointer))
		end

	ffs_wc_path: CE_POINTER [NATURAL_8] assign set_ffs_wc_path
		do
			create Result.make_shared (c_ffs_wc_path (c_pointer))
		end

	ffs_filearray: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_ffs_filearray
		do
			create Result.make_shared (c_ffs_filearray (c_pointer))
		end

	ffs_filearray_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct ff_stack, ffs_filearray);"
		end

	ffs_filearray_size: INTEGER_32 assign set_ffs_filearray_size
		do
			Result := c_ffs_filearray_size (c_pointer)
		end

	ffs_filearray_size_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct ff_stack, ffs_filearray_size);"
		end

	ffs_filearray_cur: NATURAL_8 assign set_ffs_filearray_cur
		do
			Result := c_ffs_filearray_cur (c_pointer)
		end

	ffs_stage: INTEGER_32 assign set_ffs_stage
		do
			Result := c_ffs_stage (c_pointer)
		end

	ffs_level: INTEGER_32 assign set_ffs_level
		do
			Result := c_ffs_level (c_pointer)
		end

	ffs_star_star_empty: INTEGER_32 assign set_ffs_star_star_empty
		do
			Result := c_ffs_star_star_empty (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_ffs_prev (a_ffs_prev: CE_POINTER [PD_FF_STACK])
		do
			c_set_ffs_prev (c_pointer, a_ffs_prev.c_pointer)
		end

	set_ffs_fix_path (a_ffs_fix_path: CE_POINTER [NATURAL_8])
		do
			c_set_ffs_fix_path (c_pointer, a_ffs_fix_path.c_pointer)
		end

	set_ffs_wc_path (a_ffs_wc_path: CE_POINTER [NATURAL_8])
		do
			c_set_ffs_wc_path (c_pointer, a_ffs_wc_path.c_pointer)
		end

	set_ffs_filearray (a_ffs_filearray: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			c_set_ffs_filearray (c_pointer, a_ffs_filearray.c_pointer)
		end

	set_ffs_filearray_size (a_ffs_filearray_size: INTEGER_32)
		do
			c_set_ffs_filearray_size (c_pointer, a_ffs_filearray_size)
		end

	set_ffs_filearray_cur (a_ffs_filearray_cur: NATURAL_8)
		do
			c_set_ffs_filearray_cur (c_pointer, a_ffs_filearray_cur)
		end

	set_ffs_stage (a_ffs_stage: INTEGER_32)
		do
			c_set_ffs_stage (c_pointer, a_ffs_stage)
		end

	set_ffs_level (a_ffs_level: INTEGER_32)
		do
			c_set_ffs_level (c_pointer, a_ffs_level)
		end

	set_ffs_star_star_empty (a_ffs_star_star_empty: INTEGER_32)
		do
			c_set_ffs_star_star_empty (c_pointer, a_ffs_star_star_empty)
		end

feature {NONE} -- C getters

	c_ffs_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct ff_stack *)((struct ff_stack *)$tmp)->ffs_prev;"
		end

	c_ffs_fix_path (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct ff_stack *)$tmp)->ffs_fix_path;"
		end

	c_ffs_wc_path (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct ff_stack *)$tmp)->ffs_wc_path;"
		end

	c_ffs_filearray (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char * *)((struct ff_stack *)$tmp)->ffs_filearray;"
		end

	c_ffs_filearray_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ff_stack *)$tmp)->ffs_filearray_size;"
		end

	c_ffs_filearray_cur (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct ff_stack *)$tmp)->ffs_filearray_cur;"
		end

	c_ffs_stage (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ff_stack *)$tmp)->ffs_stage;"
		end

	c_ffs_level (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ff_stack *)$tmp)->ffs_level;"
		end

	c_ffs_star_star_empty (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ff_stack *)$tmp)->ffs_star_star_empty;"
		end

feature {NONE} -- C setters

	c_set_ffs_prev (tmp: POINTER; a_ffs_prev: POINTER)
		external
			"C inline"
		alias
			"((struct ff_stack *)$tmp)->ffs_prev = (struct ff_stack *)$a_ffs_prev;"
		end

	c_set_ffs_fix_path (tmp: POINTER; a_ffs_fix_path: POINTER)
		external
			"C inline"
		alias
			"((struct ff_stack *)$tmp)->ffs_fix_path = (unsigned char *)$a_ffs_fix_path;"
		end

	c_set_ffs_wc_path (tmp: POINTER; a_ffs_wc_path: POINTER)
		external
			"C inline"
		alias
			"((struct ff_stack *)$tmp)->ffs_wc_path = (unsigned char *)$a_ffs_wc_path;"
		end

	c_set_ffs_filearray (tmp: POINTER; a_ffs_filearray: POINTER)
		external
			"C inline"
		alias
			"((struct ff_stack *)$tmp)->ffs_filearray = (unsigned char * *)$a_ffs_filearray;"
		end

	c_set_ffs_filearray_size (tmp: POINTER; a_ffs_filearray_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ff_stack *)$tmp)->ffs_filearray_size = $a_ffs_filearray_size;"
		end

	c_set_ffs_filearray_cur (tmp: POINTER; a_ffs_filearray_cur: NATURAL_8)
		external
			"C inline"
		alias
			"((struct ff_stack *)$tmp)->ffs_filearray_cur = $a_ffs_filearray_cur;"
		end

	c_set_ffs_stage (tmp: POINTER; a_ffs_stage: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ff_stack *)$tmp)->ffs_stage = $a_ffs_stage;"
		end

	c_set_ffs_level (tmp: POINTER; a_ffs_level: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ff_stack *)$tmp)->ffs_level = $a_ffs_level;"
		end

	c_set_ffs_star_star_empty (tmp: POINTER; a_ffs_star_star_empty: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ff_stack *)$tmp)->ffs_star_star_empty = $a_ffs_star_star_empty;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct ff_stack);"
		end

end
