class
	PD_FF_VISITED

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ffv_next: CE_POINTER [PD_FF_VISITED] assign set_ffv_next
		do
			create Result.make_shared (c_ffv_next (c_pointer))
		end

	ffv_wc_path: CE_POINTER [NATURAL_8] assign set_ffv_wc_path
		do
			create Result.make_shared (c_ffv_wc_path (c_pointer))
		end

	ffv_dev_valid: INTEGER_32 assign set_ffv_dev_valid
		do
			Result := c_ffv_dev_valid (c_pointer)
		end

	ffv_dev: NATURAL_64 assign set_ffv_dev
		do
			Result := c_ffv_dev (c_pointer)
		end

	ffv_ino: NATURAL_32 assign set_ffv_ino
		do
			Result := c_ffv_ino (c_pointer)
		end

	ffv_fname: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_ffv_fname (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_ffv_next (a_ffv_next: CE_POINTER [PD_FF_VISITED])
		do
			c_set_ffv_next (c_pointer, a_ffv_next.c_pointer)
		end

	set_ffv_wc_path (a_ffv_wc_path: CE_POINTER [NATURAL_8])
		do
			c_set_ffv_wc_path (c_pointer, a_ffv_wc_path.c_pointer)
		end

	set_ffv_dev_valid (a_ffv_dev_valid: INTEGER_32)
		do
			c_set_ffv_dev_valid (c_pointer, a_ffv_dev_valid)
		end

	set_ffv_dev (a_ffv_dev: NATURAL_64)
		do
			c_set_ffv_dev (c_pointer, a_ffv_dev)
		end

	set_ffv_ino (a_ffv_ino: NATURAL_32)
		do
			c_set_ffv_ino (c_pointer, a_ffv_ino)
		end

feature {NONE} -- C getters

	c_ffv_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct ff_visited *)((struct ff_visited *)$tmp)->ffv_next;"
		end

	c_ffv_wc_path (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct ff_visited *)$tmp)->ffv_wc_path;"
		end

	c_ffv_dev_valid (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ff_visited *)$tmp)->ffv_dev_valid;"
		end

	c_ffv_dev (tmp: POINTER): NATURAL_64
		external
			"C inline"
		alias
			"return (unsigned long long)((struct ff_visited *)$tmp)->ffv_dev;"
		end

	c_ffv_ino (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct ff_visited *)$tmp)->ffv_ino;"
		end

	c_ffv_fname (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct ff_visited *tmp = (struct ff_visited *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->ffv_fname) / sizeof(tmp->ffv_fname[0]);
				return tmp->ffv_fname;
			]"
		end

feature {NONE} -- C setters

	c_set_ffv_next (tmp: POINTER; a_ffv_next: POINTER)
		external
			"C inline"
		alias
			"((struct ff_visited *)$tmp)->ffv_next = (struct ff_visited *)$a_ffv_next;"
		end

	c_set_ffv_wc_path (tmp: POINTER; a_ffv_wc_path: POINTER)
		external
			"C inline"
		alias
			"((struct ff_visited *)$tmp)->ffv_wc_path = (unsigned char *)$a_ffv_wc_path;"
		end

	c_set_ffv_dev_valid (tmp: POINTER; a_ffv_dev_valid: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ff_visited *)$tmp)->ffv_dev_valid = $a_ffv_dev_valid;"
		end

	c_set_ffv_dev (tmp: POINTER; a_ffv_dev: NATURAL_64)
		external
			"C inline"
		alias
			"((struct ff_visited *)$tmp)->ffv_dev = $a_ffv_dev;"
		end

	c_set_ffv_ino (tmp: POINTER; a_ffv_ino: NATURAL_32)
		external
			"C inline"
		alias
			"((struct ff_visited *)$tmp)->ffv_ino = $a_ffv_ino;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct ff_visited);"
		end

end
