class
	PD_FILE_BUFFER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	b_ml: PD_MEMLINE assign set_b_ml
		do
			create Result.make_shared (c_b_ml (c_pointer))
		end

	b_next: CE_POINTER [PD_FILE_BUFFER] assign set_b_next
		do
			create Result.make_shared (c_b_next (c_pointer))
		end

	b_prev: CE_POINTER [PD_FILE_BUFFER] assign set_b_prev
		do
			create Result.make_shared (c_b_prev (c_pointer))
		end

	b_nwindows: INTEGER_32 assign set_b_nwindows
		do
			Result := c_b_nwindows (c_pointer)
		end

	b_flags: INTEGER_32 assign set_b_flags
		do
			Result := c_b_flags (c_pointer)
		end

	b_ffname: CE_POINTER [NATURAL_8] assign set_b_ffname
		do
			create Result.make_shared (c_b_ffname (c_pointer))
		end

	b_ffname_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_ffname);"
		end

	b_sfname: CE_POINTER [NATURAL_8] assign set_b_sfname
		do
			create Result.make_shared (c_b_sfname (c_pointer))
		end

	b_sfname_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_sfname);"
		end

	b_fname: CE_POINTER [NATURAL_8] assign set_b_fname
		do
			create Result.make_shared (c_b_fname (c_pointer))
		end

	b_dev_valid: INTEGER_32 assign set_b_dev_valid
		do
			Result := c_b_dev_valid (c_pointer)
		end

	b_dev: NATURAL_64 assign set_b_dev
		do
			Result := c_b_dev (c_pointer)
		end

	b_ino: NATURAL_32 assign set_b_ino
		do
			Result := c_b_ino (c_pointer)
		end

	b_fnum: INTEGER_32 assign set_b_fnum
		do
			Result := c_b_fnum (c_pointer)
		end

	b_changed: INTEGER_32 assign set_b_changed
		do
			Result := c_b_changed (c_pointer)
		end

	b_changed_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_changed);"
		end

	b_changedtick: INTEGER_32 assign set_b_changedtick
		do
			Result := c_b_changedtick (c_pointer)
		end

	b_saving: INTEGER_32 assign set_b_saving
		do
			Result := c_b_saving (c_pointer)
		end

	b_mod_set: INTEGER_32 assign set_b_mod_set
		do
			Result := c_b_mod_set (c_pointer)
		end

	b_mod_top: INTEGER_32 assign set_b_mod_top
		do
			Result := c_b_mod_top (c_pointer)
		end

	b_mod_bot: INTEGER_32 assign set_b_mod_bot
		do
			Result := c_b_mod_bot (c_pointer)
		end

	b_mod_xlines: INTEGER_32 assign set_b_mod_xlines
		do
			Result := c_b_mod_xlines (c_pointer)
		end

	b_wininfo: CE_POINTER [PD_WININFO_S] assign set_b_wininfo
		do
			create Result.make_shared (c_b_wininfo (c_pointer))
		end

	b_mtime: INTEGER_32 assign set_b_mtime
		do
			Result := c_b_mtime (c_pointer)
		end

	b_mtime_read: INTEGER_32 assign set_b_mtime_read
		do
			Result := c_b_mtime_read (c_pointer)
		end

	b_orig_size: INTEGER_32 assign set_b_orig_size
		do
			Result := c_b_orig_size (c_pointer)
		end

	b_orig_mode: INTEGER_32 assign set_b_orig_mode
		do
			Result := c_b_orig_mode (c_pointer)
		end

	b_namedm: CE_ARRAY [PD_POS_T]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_b_namedm (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	b_namedm_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_namedm);"
		end

	b_visual: PD_VISUALINFO_T assign set_b_visual
		do
			create Result.make_shared (c_b_visual (c_pointer))
		end

	b_visual_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_visual);"
		end

	b_visual_mode_eval: INTEGER_32 assign set_b_visual_mode_eval
		do
			Result := c_b_visual_mode_eval (c_pointer)
		end

	b_last_cursor: PD_POS_T assign set_b_last_cursor
		do
			create Result.make_shared (c_b_last_cursor (c_pointer))
		end

	b_last_cursor_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_last_cursor);"
		end

	b_last_insert: PD_POS_T assign set_b_last_insert
		do
			create Result.make_shared (c_b_last_insert (c_pointer))
		end

	b_last_insert_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_last_insert);"
		end

	b_last_change: PD_POS_T assign set_b_last_change
		do
			create Result.make_shared (c_b_last_change (c_pointer))
		end

	b_last_change_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_last_change);"
		end

	b_changelist: CE_ARRAY [PD_POS_T]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_b_changelist (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	b_changelist_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_changelist);"
		end

	b_changelistlen: INTEGER_32 assign set_b_changelistlen
		do
			Result := c_b_changelistlen (c_pointer)
		end

	b_new_change: INTEGER_32 assign set_b_new_change
		do
			Result := c_b_new_change (c_pointer)
		end

	b_chartab: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_b_chartab (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	b_maphash: CE_ARRAY [CE_POINTER [PD_MAPBLOCK]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_b_maphash (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	b_first_abbr: CE_POINTER [PD_MAPBLOCK] assign set_b_first_abbr
		do
			create Result.make_shared (c_b_first_abbr (c_pointer))
		end

	b_first_abbr_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_first_abbr);"
		end

	b_ucmds: PD_GROWARRAY assign set_b_ucmds
		do
			create Result.make_shared (c_b_ucmds (c_pointer))
		end

	b_ucmds_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_ucmds);"
		end

	b_op_start: PD_POS_T assign set_b_op_start
		do
			create Result.make_shared (c_b_op_start (c_pointer))
		end

	b_op_start_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_op_start);"
		end

	b_op_end: PD_POS_T assign set_b_op_end
		do
			create Result.make_shared (c_b_op_end (c_pointer))
		end

	b_op_end_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_op_end);"
		end

	b_marks_read: INTEGER_32 assign set_b_marks_read
		do
			Result := c_b_marks_read (c_pointer)
		end

	b_u_oldhead: CE_POINTER [PD_U_HEADER] assign set_b_u_oldhead
		do
			create Result.make_shared (c_b_u_oldhead (c_pointer))
		end

	b_u_newhead: CE_POINTER [PD_U_HEADER] assign set_b_u_newhead
		do
			create Result.make_shared (c_b_u_newhead (c_pointer))
		end

	b_u_curhead: CE_POINTER [PD_U_HEADER] assign set_b_u_curhead
		do
			create Result.make_shared (c_b_u_curhead (c_pointer))
		end

	b_u_numhead: INTEGER_32 assign set_b_u_numhead
		do
			Result := c_b_u_numhead (c_pointer)
		end

	b_u_synced: INTEGER_32 assign set_b_u_synced
		do
			Result := c_b_u_synced (c_pointer)
		end

	b_u_seq_last: INTEGER_32 assign set_b_u_seq_last
		do
			Result := c_b_u_seq_last (c_pointer)
		end

	b_u_save_nr_last: INTEGER_32 assign set_b_u_save_nr_last
		do
			Result := c_b_u_save_nr_last (c_pointer)
		end

	b_u_seq_cur: INTEGER_32 assign set_b_u_seq_cur
		do
			Result := c_b_u_seq_cur (c_pointer)
		end

	b_u_time_cur: INTEGER_32 assign set_b_u_time_cur
		do
			Result := c_b_u_time_cur (c_pointer)
		end

	b_u_save_nr_cur: INTEGER_32 assign set_b_u_save_nr_cur
		do
			Result := c_b_u_save_nr_cur (c_pointer)
		end

	b_u_line_ptr: CE_POINTER [NATURAL_8] assign set_b_u_line_ptr
		do
			create Result.make_shared (c_b_u_line_ptr (c_pointer))
		end

	b_u_line_lnum: INTEGER_32 assign set_b_u_line_lnum
		do
			Result := c_b_u_line_lnum (c_pointer)
		end

	b_u_line_colnr: INTEGER_32 assign set_b_u_line_colnr
		do
			Result := c_b_u_line_colnr (c_pointer)
		end

	b_scanned: INTEGER_32 assign set_b_scanned
		do
			Result := c_b_scanned (c_pointer)
		end

	b_p_iminsert: INTEGER_32 assign set_b_p_iminsert
		do
			Result := c_b_p_iminsert (c_pointer)
		end

	b_p_iminsert_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_iminsert);"
		end

	b_p_imsearch: INTEGER_32 assign set_b_p_imsearch
		do
			Result := c_b_p_imsearch (c_pointer)
		end

	b_p_imsearch_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_imsearch);"
		end

	b_p_initialized: INTEGER_32 assign set_b_p_initialized
		do
			Result := c_b_p_initialized (c_pointer)
		end

	b_p_scriptID: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_b_p_scriptID (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	b_p_ai: INTEGER_32 assign set_b_p_ai
		do
			Result := c_b_p_ai (c_pointer)
		end

	b_p_ai_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_ai);"
		end

	b_p_ai_nopaste: INTEGER_32 assign set_b_p_ai_nopaste
		do
			Result := c_b_p_ai_nopaste (c_pointer)
		end

	b_p_ci: INTEGER_32 assign set_b_p_ci
		do
			Result := c_b_p_ci (c_pointer)
		end

	b_p_ci_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_ci);"
		end

	b_p_bin: INTEGER_32 assign set_b_p_bin
		do
			Result := c_b_p_bin (c_pointer)
		end

	b_p_bin_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_bin);"
		end

	b_p_bomb: INTEGER_32 assign set_b_p_bomb
		do
			Result := c_b_p_bomb (c_pointer)
		end

	b_p_bomb_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_bomb);"
		end

	b_p_bh: CE_POINTER [NATURAL_8] assign set_b_p_bh
		do
			create Result.make_shared (c_b_p_bh (c_pointer))
		end

	b_p_bh_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_bh);"
		end

	b_p_bt: CE_POINTER [NATURAL_8] assign set_b_p_bt
		do
			create Result.make_shared (c_b_p_bt (c_pointer))
		end

	b_p_bt_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_bt);"
		end

	b_p_bl: INTEGER_32 assign set_b_p_bl
		do
			Result := c_b_p_bl (c_pointer)
		end

	b_p_bl_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_bl);"
		end

	b_p_cin: INTEGER_32 assign set_b_p_cin
		do
			Result := c_b_p_cin (c_pointer)
		end

	b_p_cin_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_cin);"
		end

	b_p_cino: CE_POINTER [NATURAL_8] assign set_b_p_cino
		do
			create Result.make_shared (c_b_p_cino (c_pointer))
		end

	b_p_cino_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_cino);"
		end

	b_p_cink: CE_POINTER [NATURAL_8] assign set_b_p_cink
		do
			create Result.make_shared (c_b_p_cink (c_pointer))
		end

	b_p_cink_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_cink);"
		end

	b_p_cinw: CE_POINTER [NATURAL_8] assign set_b_p_cinw
		do
			create Result.make_shared (c_b_p_cinw (c_pointer))
		end

	b_p_cinw_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_cinw);"
		end

	b_p_com: CE_POINTER [NATURAL_8] assign set_b_p_com
		do
			create Result.make_shared (c_b_p_com (c_pointer))
		end

	b_p_com_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_com);"
		end

	b_p_cms: CE_POINTER [NATURAL_8] assign set_b_p_cms
		do
			create Result.make_shared (c_b_p_cms (c_pointer))
		end

	b_p_cms_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_cms);"
		end

	b_p_cpt: CE_POINTER [NATURAL_8] assign set_b_p_cpt
		do
			create Result.make_shared (c_b_p_cpt (c_pointer))
		end

	b_p_cpt_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_cpt);"
		end

	b_p_cfu: CE_POINTER [NATURAL_8] assign set_b_p_cfu
		do
			create Result.make_shared (c_b_p_cfu (c_pointer))
		end

	b_p_cfu_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_cfu);"
		end

	b_p_ofu: CE_POINTER [NATURAL_8] assign set_b_p_ofu
		do
			create Result.make_shared (c_b_p_ofu (c_pointer))
		end

	b_p_ofu_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_ofu);"
		end

	b_p_eol: INTEGER_32 assign set_b_p_eol
		do
			Result := c_b_p_eol (c_pointer)
		end

	b_p_eol_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_eol);"
		end

	b_p_et: INTEGER_32 assign set_b_p_et
		do
			Result := c_b_p_et (c_pointer)
		end

	b_p_et_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_et);"
		end

	b_p_et_nobin: INTEGER_32 assign set_b_p_et_nobin
		do
			Result := c_b_p_et_nobin (c_pointer)
		end

	b_p_fenc: CE_POINTER [NATURAL_8] assign set_b_p_fenc
		do
			create Result.make_shared (c_b_p_fenc (c_pointer))
		end

	b_p_fenc_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_fenc);"
		end

	b_p_ff: CE_POINTER [NATURAL_8] assign set_b_p_ff
		do
			create Result.make_shared (c_b_p_ff (c_pointer))
		end

	b_p_ff_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_ff);"
		end

	b_p_ft: CE_POINTER [NATURAL_8] assign set_b_p_ft
		do
			create Result.make_shared (c_b_p_ft (c_pointer))
		end

	b_p_ft_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_ft);"
		end

	b_p_fo: CE_POINTER [NATURAL_8] assign set_b_p_fo
		do
			create Result.make_shared (c_b_p_fo (c_pointer))
		end

	b_p_fo_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_fo);"
		end

	b_p_flp: CE_POINTER [NATURAL_8] assign set_b_p_flp
		do
			create Result.make_shared (c_b_p_flp (c_pointer))
		end

	b_p_flp_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_flp);"
		end

	b_p_inf: INTEGER_32 assign set_b_p_inf
		do
			Result := c_b_p_inf (c_pointer)
		end

	b_p_inf_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_inf);"
		end

	b_p_isk: CE_POINTER [NATURAL_8] assign set_b_p_isk
		do
			create Result.make_shared (c_b_p_isk (c_pointer))
		end

	b_p_isk_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_isk);"
		end

	b_p_def: CE_POINTER [NATURAL_8] assign set_b_p_def
		do
			create Result.make_shared (c_b_p_def (c_pointer))
		end

	b_p_def_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_def);"
		end

	b_p_inc: CE_POINTER [NATURAL_8] assign set_b_p_inc
		do
			create Result.make_shared (c_b_p_inc (c_pointer))
		end

	b_p_inc_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_inc);"
		end

	b_p_inex: CE_POINTER [NATURAL_8] assign set_b_p_inex
		do
			create Result.make_shared (c_b_p_inex (c_pointer))
		end

	b_p_inex_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_inex);"
		end

	b_p_inex_flags: NATURAL_32 assign set_b_p_inex_flags
		do
			Result := c_b_p_inex_flags (c_pointer)
		end

	b_p_inex_flags_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_inex_flags);"
		end

	b_p_inde: CE_POINTER [NATURAL_8] assign set_b_p_inde
		do
			create Result.make_shared (c_b_p_inde (c_pointer))
		end

	b_p_inde_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_inde);"
		end

	b_p_inde_flags: NATURAL_32 assign set_b_p_inde_flags
		do
			Result := c_b_p_inde_flags (c_pointer)
		end

	b_p_inde_flags_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_inde_flags);"
		end

	b_p_indk: CE_POINTER [NATURAL_8] assign set_b_p_indk
		do
			create Result.make_shared (c_b_p_indk (c_pointer))
		end

	b_p_indk_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_indk);"
		end

	b_p_fex: CE_POINTER [NATURAL_8] assign set_b_p_fex
		do
			create Result.make_shared (c_b_p_fex (c_pointer))
		end

	b_p_fex_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_fex);"
		end

	b_p_fex_flags: NATURAL_32 assign set_b_p_fex_flags
		do
			Result := c_b_p_fex_flags (c_pointer)
		end

	b_p_fex_flags_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_fex_flags);"
		end

	b_p_key: CE_POINTER [NATURAL_8] assign set_b_p_key
		do
			create Result.make_shared (c_b_p_key (c_pointer))
		end

	b_p_key_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_key);"
		end

	b_p_kp: CE_POINTER [NATURAL_8] assign set_b_p_kp
		do
			create Result.make_shared (c_b_p_kp (c_pointer))
		end

	b_p_kp_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_kp);"
		end

	b_p_lisp: INTEGER_32 assign set_b_p_lisp
		do
			Result := c_b_p_lisp (c_pointer)
		end

	b_p_lisp_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_lisp);"
		end

	b_p_mps: CE_POINTER [NATURAL_8] assign set_b_p_mps
		do
			create Result.make_shared (c_b_p_mps (c_pointer))
		end

	b_p_mps_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_mps);"
		end

	b_p_ml: INTEGER_32 assign set_b_p_ml
		do
			Result := c_b_p_ml (c_pointer)
		end

	b_p_ml_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_ml);"
		end

	b_p_ml_nobin: INTEGER_32 assign set_b_p_ml_nobin
		do
			Result := c_b_p_ml_nobin (c_pointer)
		end

	b_p_ma: INTEGER_32 assign set_b_p_ma
		do
			Result := c_b_p_ma (c_pointer)
		end

	b_p_ma_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_ma);"
		end

	b_p_nf: CE_POINTER [NATURAL_8] assign set_b_p_nf
		do
			create Result.make_shared (c_b_p_nf (c_pointer))
		end

	b_p_nf_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_nf);"
		end

	b_p_pi: INTEGER_32 assign set_b_p_pi
		do
			Result := c_b_p_pi (c_pointer)
		end

	b_p_pi_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_pi);"
		end

	b_p_qe: CE_POINTER [NATURAL_8] assign set_b_p_qe
		do
			create Result.make_shared (c_b_p_qe (c_pointer))
		end

	b_p_qe_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_qe);"
		end

	b_p_ro: INTEGER_32 assign set_b_p_ro
		do
			Result := c_b_p_ro (c_pointer)
		end

	b_p_ro_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_ro);"
		end

	b_p_sw: INTEGER_32 assign set_b_p_sw
		do
			Result := c_b_p_sw (c_pointer)
		end

	b_p_sw_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_sw);"
		end

	b_p_sn: INTEGER_32 assign set_b_p_sn
		do
			Result := c_b_p_sn (c_pointer)
		end

	b_p_sn_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_sn);"
		end

	b_p_si: INTEGER_32 assign set_b_p_si
		do
			Result := c_b_p_si (c_pointer)
		end

	b_p_si_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_si);"
		end

	b_p_sts: INTEGER_32 assign set_b_p_sts
		do
			Result := c_b_p_sts (c_pointer)
		end

	b_p_sts_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_sts);"
		end

	b_p_sts_nopaste: INTEGER_32 assign set_b_p_sts_nopaste
		do
			Result := c_b_p_sts_nopaste (c_pointer)
		end

	b_p_sua: CE_POINTER [NATURAL_8] assign set_b_p_sua
		do
			create Result.make_shared (c_b_p_sua (c_pointer))
		end

	b_p_sua_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_sua);"
		end

	b_p_swf: INTEGER_32 assign set_b_p_swf
		do
			Result := c_b_p_swf (c_pointer)
		end

	b_p_swf_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_swf);"
		end

	b_p_smc: INTEGER_32 assign set_b_p_smc
		do
			Result := c_b_p_smc (c_pointer)
		end

	b_p_smc_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_smc);"
		end

	b_p_syn: CE_POINTER [NATURAL_8] assign set_b_p_syn
		do
			create Result.make_shared (c_b_p_syn (c_pointer))
		end

	b_p_syn_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_syn);"
		end

	b_p_ts: INTEGER_32 assign set_b_p_ts
		do
			Result := c_b_p_ts (c_pointer)
		end

	b_p_ts_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_ts);"
		end

	b_p_tx: INTEGER_32 assign set_b_p_tx
		do
			Result := c_b_p_tx (c_pointer)
		end

	b_p_tx_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_tx);"
		end

	b_p_tw: INTEGER_32 assign set_b_p_tw
		do
			Result := c_b_p_tw (c_pointer)
		end

	b_p_tw_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_tw);"
		end

	b_p_tw_nobin: INTEGER_32 assign set_b_p_tw_nobin
		do
			Result := c_b_p_tw_nobin (c_pointer)
		end

	b_p_tw_nopaste: INTEGER_32 assign set_b_p_tw_nopaste
		do
			Result := c_b_p_tw_nopaste (c_pointer)
		end

	b_p_wm: INTEGER_32 assign set_b_p_wm
		do
			Result := c_b_p_wm (c_pointer)
		end

	b_p_wm_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_wm);"
		end

	b_p_wm_nobin: INTEGER_32 assign set_b_p_wm_nobin
		do
			Result := c_b_p_wm_nobin (c_pointer)
		end

	b_p_wm_nopaste: INTEGER_32 assign set_b_p_wm_nopaste
		do
			Result := c_b_p_wm_nopaste (c_pointer)
		end

	b_p_gp: CE_POINTER [NATURAL_8] assign set_b_p_gp
		do
			create Result.make_shared (c_b_p_gp (c_pointer))
		end

	b_p_gp_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_gp);"
		end

	b_p_mp: CE_POINTER [NATURAL_8] assign set_b_p_mp
		do
			create Result.make_shared (c_b_p_mp (c_pointer))
		end

	b_p_mp_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_mp);"
		end

	b_p_efm: CE_POINTER [NATURAL_8] assign set_b_p_efm
		do
			create Result.make_shared (c_b_p_efm (c_pointer))
		end

	b_p_efm_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_efm);"
		end

	b_p_ep: CE_POINTER [NATURAL_8] assign set_b_p_ep
		do
			create Result.make_shared (c_b_p_ep (c_pointer))
		end

	b_p_ep_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_ep);"
		end

	b_p_path: CE_POINTER [NATURAL_8] assign set_b_p_path
		do
			create Result.make_shared (c_b_p_path (c_pointer))
		end

	b_p_path_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_path);"
		end

	b_p_ar: INTEGER_32 assign set_b_p_ar
		do
			Result := c_b_p_ar (c_pointer)
		end

	b_p_ar_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_ar);"
		end

	b_p_tags: CE_POINTER [NATURAL_8] assign set_b_p_tags
		do
			create Result.make_shared (c_b_p_tags (c_pointer))
		end

	b_p_tags_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_tags);"
		end

	b_p_dict: CE_POINTER [NATURAL_8] assign set_b_p_dict
		do
			create Result.make_shared (c_b_p_dict (c_pointer))
		end

	b_p_dict_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_dict);"
		end

	b_p_tsr: CE_POINTER [NATURAL_8] assign set_b_p_tsr
		do
			create Result.make_shared (c_b_p_tsr (c_pointer))
		end

	b_p_tsr_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_tsr);"
		end

	b_p_udf: INTEGER_32 assign set_b_p_udf
		do
			Result := c_b_p_udf (c_pointer)
		end

	b_p_udf_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_udf);"
		end

	b_start_eol: INTEGER_32 assign set_b_start_eol
		do
			Result := c_b_start_eol (c_pointer)
		end

	b_start_ffc: INTEGER_32 assign set_b_start_ffc
		do
			Result := c_b_start_ffc (c_pointer)
		end

	b_start_fenc: CE_POINTER [NATURAL_8] assign set_b_start_fenc
		do
			create Result.make_shared (c_b_start_fenc (c_pointer))
		end

	b_bad_char: INTEGER_32 assign set_b_bad_char
		do
			Result := c_b_bad_char (c_pointer)
		end

	b_start_bomb: INTEGER_32 assign set_b_start_bomb
		do
			Result := c_b_start_bomb (c_pointer)
		end

	b_bufvar: PD_DICTITEM_S assign set_b_bufvar
		do
			create Result.make_shared (c_b_bufvar (c_pointer))
		end

	b_bufvar_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_bufvar);"
		end

	b_vars: PD_DICTVAR_S assign set_b_vars
		do
			create Result.make_shared (c_b_vars (c_pointer))
		end

	b_vars_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_vars);"
		end

	b_p_bexpr: CE_POINTER [NATURAL_8] assign set_b_p_bexpr
		do
			create Result.make_shared (c_b_p_bexpr (c_pointer))
		end

	b_p_bexpr_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_bexpr);"
		end

	b_p_bexpr_flags: NATURAL_32 assign set_b_p_bexpr_flags
		do
			Result := c_b_p_bexpr_flags (c_pointer)
		end

	b_p_bexpr_flags_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_bexpr_flags);"
		end

	b_p_cm: CE_POINTER [NATURAL_8] assign set_b_p_cm
		do
			create Result.make_shared (c_b_p_cm (c_pointer))
		end

	b_p_cm_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_p_cm);"
		end

	b_may_swap: INTEGER_32 assign set_b_may_swap
		do
			Result := c_b_may_swap (c_pointer)
		end

	b_did_warn: INTEGER_32 assign set_b_did_warn
		do
			Result := c_b_did_warn (c_pointer)
		end

	b_help: INTEGER_32 assign set_b_help
		do
			Result := c_b_help (c_pointer)
		end

	b_spell: INTEGER_32 assign set_b_spell
		do
			Result := c_b_spell (c_pointer)
		end

	b_shortname: INTEGER_32 assign set_b_shortname
		do
			Result := c_b_shortname (c_pointer)
		end

	b_s: PD_SYNBLOCK_T assign set_b_s
		do
			create Result.make_shared (c_b_s (c_pointer))
		end

	b_s_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_s);"
		end

	b_signlist: CE_POINTER [PD_SIGNLIST] assign set_b_signlist
		do
			create Result.make_shared (c_b_signlist (c_pointer))
		end

	b_signlist_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct file_buffer, b_signlist);"
		end

	b_netbeans_file: INTEGER_32 assign set_b_netbeans_file
		do
			Result := c_b_netbeans_file (c_pointer)
		end

	b_was_netbeans_file: INTEGER_32 assign set_b_was_netbeans_file
		do
			Result := c_b_was_netbeans_file (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_b_ml (a_b_ml: PD_MEMLINE)
		do
			b_ml.ce_gets (a_b_ml)
		end

	set_b_next (a_b_next: CE_POINTER [PD_FILE_BUFFER])
		do
			c_set_b_next (c_pointer, a_b_next.c_pointer)
		end

	set_b_prev (a_b_prev: CE_POINTER [PD_FILE_BUFFER])
		do
			c_set_b_prev (c_pointer, a_b_prev.c_pointer)
		end

	set_b_nwindows (a_b_nwindows: INTEGER_32)
		do
			c_set_b_nwindows (c_pointer, a_b_nwindows)
		end

	set_b_flags (a_b_flags: INTEGER_32)
		do
			c_set_b_flags (c_pointer, a_b_flags)
		end

	set_b_ffname (a_b_ffname: CE_POINTER [NATURAL_8])
		do
			c_set_b_ffname (c_pointer, a_b_ffname.c_pointer)
		end

	set_b_sfname (a_b_sfname: CE_POINTER [NATURAL_8])
		do
			c_set_b_sfname (c_pointer, a_b_sfname.c_pointer)
		end

	set_b_fname (a_b_fname: CE_POINTER [NATURAL_8])
		do
			c_set_b_fname (c_pointer, a_b_fname.c_pointer)
		end

	set_b_dev_valid (a_b_dev_valid: INTEGER_32)
		do
			c_set_b_dev_valid (c_pointer, a_b_dev_valid)
		end

	set_b_dev (a_b_dev: NATURAL_64)
		do
			c_set_b_dev (c_pointer, a_b_dev)
		end

	set_b_ino (a_b_ino: NATURAL_32)
		do
			c_set_b_ino (c_pointer, a_b_ino)
		end

	set_b_fnum (a_b_fnum: INTEGER_32)
		do
			c_set_b_fnum (c_pointer, a_b_fnum)
		end

	set_b_changed (a_b_changed: INTEGER_32)
		do
			c_set_b_changed (c_pointer, a_b_changed)
		end

	set_b_changedtick (a_b_changedtick: INTEGER_32)
		do
			c_set_b_changedtick (c_pointer, a_b_changedtick)
		end

	set_b_saving (a_b_saving: INTEGER_32)
		do
			c_set_b_saving (c_pointer, a_b_saving)
		end

	set_b_mod_set (a_b_mod_set: INTEGER_32)
		do
			c_set_b_mod_set (c_pointer, a_b_mod_set)
		end

	set_b_mod_top (a_b_mod_top: INTEGER_32)
		do
			c_set_b_mod_top (c_pointer, a_b_mod_top)
		end

	set_b_mod_bot (a_b_mod_bot: INTEGER_32)
		do
			c_set_b_mod_bot (c_pointer, a_b_mod_bot)
		end

	set_b_mod_xlines (a_b_mod_xlines: INTEGER_32)
		do
			c_set_b_mod_xlines (c_pointer, a_b_mod_xlines)
		end

	set_b_wininfo (a_b_wininfo: CE_POINTER [PD_WININFO_S])
		do
			c_set_b_wininfo (c_pointer, a_b_wininfo.c_pointer)
		end

	set_b_mtime (a_b_mtime: INTEGER_32)
		do
			c_set_b_mtime (c_pointer, a_b_mtime)
		end

	set_b_mtime_read (a_b_mtime_read: INTEGER_32)
		do
			c_set_b_mtime_read (c_pointer, a_b_mtime_read)
		end

	set_b_orig_size (a_b_orig_size: INTEGER_32)
		do
			c_set_b_orig_size (c_pointer, a_b_orig_size)
		end

	set_b_orig_mode (a_b_orig_mode: INTEGER_32)
		do
			c_set_b_orig_mode (c_pointer, a_b_orig_mode)
		end

	set_b_visual (a_b_visual: PD_VISUALINFO_T)
		do
			b_visual.ce_gets (a_b_visual)
		end

	set_b_visual_mode_eval (a_b_visual_mode_eval: INTEGER_32)
		do
			c_set_b_visual_mode_eval (c_pointer, a_b_visual_mode_eval)
		end

	set_b_last_cursor (a_b_last_cursor: PD_POS_T)
		do
			b_last_cursor.ce_gets (a_b_last_cursor)
		end

	set_b_last_insert (a_b_last_insert: PD_POS_T)
		do
			b_last_insert.ce_gets (a_b_last_insert)
		end

	set_b_last_change (a_b_last_change: PD_POS_T)
		do
			b_last_change.ce_gets (a_b_last_change)
		end

	set_b_changelistlen (a_b_changelistlen: INTEGER_32)
		do
			c_set_b_changelistlen (c_pointer, a_b_changelistlen)
		end

	set_b_new_change (a_b_new_change: INTEGER_32)
		do
			c_set_b_new_change (c_pointer, a_b_new_change)
		end

	set_b_first_abbr (a_b_first_abbr: CE_POINTER [PD_MAPBLOCK])
		do
			c_set_b_first_abbr (c_pointer, a_b_first_abbr.c_pointer)
		end

	set_b_ucmds (a_b_ucmds: PD_GROWARRAY)
		do
			b_ucmds.ce_gets (a_b_ucmds)
		end

	set_b_op_start (a_b_op_start: PD_POS_T)
		do
			b_op_start.ce_gets (a_b_op_start)
		end

	set_b_op_end (a_b_op_end: PD_POS_T)
		do
			b_op_end.ce_gets (a_b_op_end)
		end

	set_b_marks_read (a_b_marks_read: INTEGER_32)
		do
			c_set_b_marks_read (c_pointer, a_b_marks_read)
		end

	set_b_u_oldhead (a_b_u_oldhead: CE_POINTER [PD_U_HEADER])
		do
			c_set_b_u_oldhead (c_pointer, a_b_u_oldhead.c_pointer)
		end

	set_b_u_newhead (a_b_u_newhead: CE_POINTER [PD_U_HEADER])
		do
			c_set_b_u_newhead (c_pointer, a_b_u_newhead.c_pointer)
		end

	set_b_u_curhead (a_b_u_curhead: CE_POINTER [PD_U_HEADER])
		do
			c_set_b_u_curhead (c_pointer, a_b_u_curhead.c_pointer)
		end

	set_b_u_numhead (a_b_u_numhead: INTEGER_32)
		do
			c_set_b_u_numhead (c_pointer, a_b_u_numhead)
		end

	set_b_u_synced (a_b_u_synced: INTEGER_32)
		do
			c_set_b_u_synced (c_pointer, a_b_u_synced)
		end

	set_b_u_seq_last (a_b_u_seq_last: INTEGER_32)
		do
			c_set_b_u_seq_last (c_pointer, a_b_u_seq_last)
		end

	set_b_u_save_nr_last (a_b_u_save_nr_last: INTEGER_32)
		do
			c_set_b_u_save_nr_last (c_pointer, a_b_u_save_nr_last)
		end

	set_b_u_seq_cur (a_b_u_seq_cur: INTEGER_32)
		do
			c_set_b_u_seq_cur (c_pointer, a_b_u_seq_cur)
		end

	set_b_u_time_cur (a_b_u_time_cur: INTEGER_32)
		do
			c_set_b_u_time_cur (c_pointer, a_b_u_time_cur)
		end

	set_b_u_save_nr_cur (a_b_u_save_nr_cur: INTEGER_32)
		do
			c_set_b_u_save_nr_cur (c_pointer, a_b_u_save_nr_cur)
		end

	set_b_u_line_ptr (a_b_u_line_ptr: CE_POINTER [NATURAL_8])
		do
			c_set_b_u_line_ptr (c_pointer, a_b_u_line_ptr.c_pointer)
		end

	set_b_u_line_lnum (a_b_u_line_lnum: INTEGER_32)
		do
			c_set_b_u_line_lnum (c_pointer, a_b_u_line_lnum)
		end

	set_b_u_line_colnr (a_b_u_line_colnr: INTEGER_32)
		do
			c_set_b_u_line_colnr (c_pointer, a_b_u_line_colnr)
		end

	set_b_scanned (a_b_scanned: INTEGER_32)
		do
			c_set_b_scanned (c_pointer, a_b_scanned)
		end

	set_b_p_iminsert (a_b_p_iminsert: INTEGER_32)
		do
			c_set_b_p_iminsert (c_pointer, a_b_p_iminsert)
		end

	set_b_p_imsearch (a_b_p_imsearch: INTEGER_32)
		do
			c_set_b_p_imsearch (c_pointer, a_b_p_imsearch)
		end

	set_b_p_initialized (a_b_p_initialized: INTEGER_32)
		do
			c_set_b_p_initialized (c_pointer, a_b_p_initialized)
		end

	set_b_p_ai (a_b_p_ai: INTEGER_32)
		do
			c_set_b_p_ai (c_pointer, a_b_p_ai)
		end

	set_b_p_ai_nopaste (a_b_p_ai_nopaste: INTEGER_32)
		do
			c_set_b_p_ai_nopaste (c_pointer, a_b_p_ai_nopaste)
		end

	set_b_p_ci (a_b_p_ci: INTEGER_32)
		do
			c_set_b_p_ci (c_pointer, a_b_p_ci)
		end

	set_b_p_bin (a_b_p_bin: INTEGER_32)
		do
			c_set_b_p_bin (c_pointer, a_b_p_bin)
		end

	set_b_p_bomb (a_b_p_bomb: INTEGER_32)
		do
			c_set_b_p_bomb (c_pointer, a_b_p_bomb)
		end

	set_b_p_bh (a_b_p_bh: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_bh (c_pointer, a_b_p_bh.c_pointer)
		end

	set_b_p_bt (a_b_p_bt: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_bt (c_pointer, a_b_p_bt.c_pointer)
		end

	set_b_p_bl (a_b_p_bl: INTEGER_32)
		do
			c_set_b_p_bl (c_pointer, a_b_p_bl)
		end

	set_b_p_cin (a_b_p_cin: INTEGER_32)
		do
			c_set_b_p_cin (c_pointer, a_b_p_cin)
		end

	set_b_p_cino (a_b_p_cino: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_cino (c_pointer, a_b_p_cino.c_pointer)
		end

	set_b_p_cink (a_b_p_cink: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_cink (c_pointer, a_b_p_cink.c_pointer)
		end

	set_b_p_cinw (a_b_p_cinw: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_cinw (c_pointer, a_b_p_cinw.c_pointer)
		end

	set_b_p_com (a_b_p_com: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_com (c_pointer, a_b_p_com.c_pointer)
		end

	set_b_p_cms (a_b_p_cms: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_cms (c_pointer, a_b_p_cms.c_pointer)
		end

	set_b_p_cpt (a_b_p_cpt: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_cpt (c_pointer, a_b_p_cpt.c_pointer)
		end

	set_b_p_cfu (a_b_p_cfu: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_cfu (c_pointer, a_b_p_cfu.c_pointer)
		end

	set_b_p_ofu (a_b_p_ofu: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_ofu (c_pointer, a_b_p_ofu.c_pointer)
		end

	set_b_p_eol (a_b_p_eol: INTEGER_32)
		do
			c_set_b_p_eol (c_pointer, a_b_p_eol)
		end

	set_b_p_et (a_b_p_et: INTEGER_32)
		do
			c_set_b_p_et (c_pointer, a_b_p_et)
		end

	set_b_p_et_nobin (a_b_p_et_nobin: INTEGER_32)
		do
			c_set_b_p_et_nobin (c_pointer, a_b_p_et_nobin)
		end

	set_b_p_fenc (a_b_p_fenc: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_fenc (c_pointer, a_b_p_fenc.c_pointer)
		end

	set_b_p_ff (a_b_p_ff: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_ff (c_pointer, a_b_p_ff.c_pointer)
		end

	set_b_p_ft (a_b_p_ft: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_ft (c_pointer, a_b_p_ft.c_pointer)
		end

	set_b_p_fo (a_b_p_fo: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_fo (c_pointer, a_b_p_fo.c_pointer)
		end

	set_b_p_flp (a_b_p_flp: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_flp (c_pointer, a_b_p_flp.c_pointer)
		end

	set_b_p_inf (a_b_p_inf: INTEGER_32)
		do
			c_set_b_p_inf (c_pointer, a_b_p_inf)
		end

	set_b_p_isk (a_b_p_isk: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_isk (c_pointer, a_b_p_isk.c_pointer)
		end

	set_b_p_def (a_b_p_def: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_def (c_pointer, a_b_p_def.c_pointer)
		end

	set_b_p_inc (a_b_p_inc: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_inc (c_pointer, a_b_p_inc.c_pointer)
		end

	set_b_p_inex (a_b_p_inex: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_inex (c_pointer, a_b_p_inex.c_pointer)
		end

	set_b_p_inex_flags (a_b_p_inex_flags: NATURAL_32)
		do
			c_set_b_p_inex_flags (c_pointer, a_b_p_inex_flags)
		end

	set_b_p_inde (a_b_p_inde: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_inde (c_pointer, a_b_p_inde.c_pointer)
		end

	set_b_p_inde_flags (a_b_p_inde_flags: NATURAL_32)
		do
			c_set_b_p_inde_flags (c_pointer, a_b_p_inde_flags)
		end

	set_b_p_indk (a_b_p_indk: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_indk (c_pointer, a_b_p_indk.c_pointer)
		end

	set_b_p_fex (a_b_p_fex: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_fex (c_pointer, a_b_p_fex.c_pointer)
		end

	set_b_p_fex_flags (a_b_p_fex_flags: NATURAL_32)
		do
			c_set_b_p_fex_flags (c_pointer, a_b_p_fex_flags)
		end

	set_b_p_key (a_b_p_key: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_key (c_pointer, a_b_p_key.c_pointer)
		end

	set_b_p_kp (a_b_p_kp: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_kp (c_pointer, a_b_p_kp.c_pointer)
		end

	set_b_p_lisp (a_b_p_lisp: INTEGER_32)
		do
			c_set_b_p_lisp (c_pointer, a_b_p_lisp)
		end

	set_b_p_mps (a_b_p_mps: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_mps (c_pointer, a_b_p_mps.c_pointer)
		end

	set_b_p_ml (a_b_p_ml: INTEGER_32)
		do
			c_set_b_p_ml (c_pointer, a_b_p_ml)
		end

	set_b_p_ml_nobin (a_b_p_ml_nobin: INTEGER_32)
		do
			c_set_b_p_ml_nobin (c_pointer, a_b_p_ml_nobin)
		end

	set_b_p_ma (a_b_p_ma: INTEGER_32)
		do
			c_set_b_p_ma (c_pointer, a_b_p_ma)
		end

	set_b_p_nf (a_b_p_nf: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_nf (c_pointer, a_b_p_nf.c_pointer)
		end

	set_b_p_pi (a_b_p_pi: INTEGER_32)
		do
			c_set_b_p_pi (c_pointer, a_b_p_pi)
		end

	set_b_p_qe (a_b_p_qe: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_qe (c_pointer, a_b_p_qe.c_pointer)
		end

	set_b_p_ro (a_b_p_ro: INTEGER_32)
		do
			c_set_b_p_ro (c_pointer, a_b_p_ro)
		end

	set_b_p_sw (a_b_p_sw: INTEGER_32)
		do
			c_set_b_p_sw (c_pointer, a_b_p_sw)
		end

	set_b_p_sn (a_b_p_sn: INTEGER_32)
		do
			c_set_b_p_sn (c_pointer, a_b_p_sn)
		end

	set_b_p_si (a_b_p_si: INTEGER_32)
		do
			c_set_b_p_si (c_pointer, a_b_p_si)
		end

	set_b_p_sts (a_b_p_sts: INTEGER_32)
		do
			c_set_b_p_sts (c_pointer, a_b_p_sts)
		end

	set_b_p_sts_nopaste (a_b_p_sts_nopaste: INTEGER_32)
		do
			c_set_b_p_sts_nopaste (c_pointer, a_b_p_sts_nopaste)
		end

	set_b_p_sua (a_b_p_sua: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_sua (c_pointer, a_b_p_sua.c_pointer)
		end

	set_b_p_swf (a_b_p_swf: INTEGER_32)
		do
			c_set_b_p_swf (c_pointer, a_b_p_swf)
		end

	set_b_p_smc (a_b_p_smc: INTEGER_32)
		do
			c_set_b_p_smc (c_pointer, a_b_p_smc)
		end

	set_b_p_syn (a_b_p_syn: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_syn (c_pointer, a_b_p_syn.c_pointer)
		end

	set_b_p_ts (a_b_p_ts: INTEGER_32)
		do
			c_set_b_p_ts (c_pointer, a_b_p_ts)
		end

	set_b_p_tx (a_b_p_tx: INTEGER_32)
		do
			c_set_b_p_tx (c_pointer, a_b_p_tx)
		end

	set_b_p_tw (a_b_p_tw: INTEGER_32)
		do
			c_set_b_p_tw (c_pointer, a_b_p_tw)
		end

	set_b_p_tw_nobin (a_b_p_tw_nobin: INTEGER_32)
		do
			c_set_b_p_tw_nobin (c_pointer, a_b_p_tw_nobin)
		end

	set_b_p_tw_nopaste (a_b_p_tw_nopaste: INTEGER_32)
		do
			c_set_b_p_tw_nopaste (c_pointer, a_b_p_tw_nopaste)
		end

	set_b_p_wm (a_b_p_wm: INTEGER_32)
		do
			c_set_b_p_wm (c_pointer, a_b_p_wm)
		end

	set_b_p_wm_nobin (a_b_p_wm_nobin: INTEGER_32)
		do
			c_set_b_p_wm_nobin (c_pointer, a_b_p_wm_nobin)
		end

	set_b_p_wm_nopaste (a_b_p_wm_nopaste: INTEGER_32)
		do
			c_set_b_p_wm_nopaste (c_pointer, a_b_p_wm_nopaste)
		end

	set_b_p_gp (a_b_p_gp: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_gp (c_pointer, a_b_p_gp.c_pointer)
		end

	set_b_p_mp (a_b_p_mp: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_mp (c_pointer, a_b_p_mp.c_pointer)
		end

	set_b_p_efm (a_b_p_efm: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_efm (c_pointer, a_b_p_efm.c_pointer)
		end

	set_b_p_ep (a_b_p_ep: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_ep (c_pointer, a_b_p_ep.c_pointer)
		end

	set_b_p_path (a_b_p_path: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_path (c_pointer, a_b_p_path.c_pointer)
		end

	set_b_p_ar (a_b_p_ar: INTEGER_32)
		do
			c_set_b_p_ar (c_pointer, a_b_p_ar)
		end

	set_b_p_tags (a_b_p_tags: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_tags (c_pointer, a_b_p_tags.c_pointer)
		end

	set_b_p_dict (a_b_p_dict: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_dict (c_pointer, a_b_p_dict.c_pointer)
		end

	set_b_p_tsr (a_b_p_tsr: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_tsr (c_pointer, a_b_p_tsr.c_pointer)
		end

	set_b_p_udf (a_b_p_udf: INTEGER_32)
		do
			c_set_b_p_udf (c_pointer, a_b_p_udf)
		end

	set_b_start_eol (a_b_start_eol: INTEGER_32)
		do
			c_set_b_start_eol (c_pointer, a_b_start_eol)
		end

	set_b_start_ffc (a_b_start_ffc: INTEGER_32)
		do
			c_set_b_start_ffc (c_pointer, a_b_start_ffc)
		end

	set_b_start_fenc (a_b_start_fenc: CE_POINTER [NATURAL_8])
		do
			c_set_b_start_fenc (c_pointer, a_b_start_fenc.c_pointer)
		end

	set_b_bad_char (a_b_bad_char: INTEGER_32)
		do
			c_set_b_bad_char (c_pointer, a_b_bad_char)
		end

	set_b_start_bomb (a_b_start_bomb: INTEGER_32)
		do
			c_set_b_start_bomb (c_pointer, a_b_start_bomb)
		end

	set_b_bufvar (a_b_bufvar: PD_DICTITEM_S)
		do
			b_bufvar.ce_gets (a_b_bufvar)
		end

	set_b_vars (a_b_vars: PD_DICTVAR_S)
		do
			b_vars.ce_gets (a_b_vars)
		end

	set_b_p_bexpr (a_b_p_bexpr: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_bexpr (c_pointer, a_b_p_bexpr.c_pointer)
		end

	set_b_p_bexpr_flags (a_b_p_bexpr_flags: NATURAL_32)
		do
			c_set_b_p_bexpr_flags (c_pointer, a_b_p_bexpr_flags)
		end

	set_b_p_cm (a_b_p_cm: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_cm (c_pointer, a_b_p_cm.c_pointer)
		end

	set_b_may_swap (a_b_may_swap: INTEGER_32)
		do
			c_set_b_may_swap (c_pointer, a_b_may_swap)
		end

	set_b_did_warn (a_b_did_warn: INTEGER_32)
		do
			c_set_b_did_warn (c_pointer, a_b_did_warn)
		end

	set_b_help (a_b_help: INTEGER_32)
		do
			c_set_b_help (c_pointer, a_b_help)
		end

	set_b_spell (a_b_spell: INTEGER_32)
		do
			c_set_b_spell (c_pointer, a_b_spell)
		end

	set_b_shortname (a_b_shortname: INTEGER_32)
		do
			c_set_b_shortname (c_pointer, a_b_shortname)
		end

	set_b_s (a_b_s: PD_SYNBLOCK_T)
		do
			b_s.ce_gets (a_b_s)
		end

	set_b_signlist (a_b_signlist: CE_POINTER [PD_SIGNLIST])
		do
			c_set_b_signlist (c_pointer, a_b_signlist.c_pointer)
		end

	set_b_netbeans_file (a_b_netbeans_file: INTEGER_32)
		do
			c_set_b_netbeans_file (c_pointer, a_b_netbeans_file)
		end

	set_b_was_netbeans_file (a_b_was_netbeans_file: INTEGER_32)
		do
			c_set_b_was_netbeans_file (c_pointer, a_b_was_netbeans_file)
		end

feature {NONE} -- C getters

	c_b_ml (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct memline *)&((struct file_buffer *)$tmp)->b_ml;"
		end

	c_b_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct file_buffer *)((struct file_buffer *)$tmp)->b_next;"
		end

	c_b_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct file_buffer *)((struct file_buffer *)$tmp)->b_prev;"
		end

	c_b_nwindows (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_nwindows;"
		end

	c_b_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_flags;"
		end

	c_b_ffname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_ffname;"
		end

	c_b_sfname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_sfname;"
		end

	c_b_fname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_fname;"
		end

	c_b_dev_valid (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_dev_valid;"
		end

	c_b_dev (tmp: POINTER): NATURAL_64
		external
			"C inline"
		alias
			"return (unsigned long long)((struct file_buffer *)$tmp)->b_dev;"
		end

	c_b_ino (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct file_buffer *)$tmp)->b_ino;"
		end

	c_b_fnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_fnum;"
		end

	c_b_changed (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_changed;"
		end

	c_b_changedtick (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_changedtick;"
		end

	c_b_saving (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_saving;"
		end

	c_b_mod_set (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_mod_set;"
		end

	c_b_mod_top (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_mod_top;"
		end

	c_b_mod_bot (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_mod_bot;"
		end

	c_b_mod_xlines (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_mod_xlines;"
		end

	c_b_wininfo (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct wininfo_S *)((struct file_buffer *)$tmp)->b_wininfo;"
		end

	c_b_mtime (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_mtime;"
		end

	c_b_mtime_read (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_mtime_read;"
		end

	c_b_orig_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_orig_size;"
		end

	c_b_orig_mode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_orig_mode;"
		end

	c_b_namedm (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct file_buffer *tmp = (struct file_buffer *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->b_namedm) / sizeof(tmp->b_namedm[0]);
				return tmp->b_namedm;
			]"
		end

	c_b_visual (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (visualinfo_T *)&((struct file_buffer *)$tmp)->b_visual;"
		end

	c_b_visual_mode_eval (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_visual_mode_eval;"
		end

	c_b_last_cursor (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (pos_T *)&((struct file_buffer *)$tmp)->b_last_cursor;"
		end

	c_b_last_insert (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (pos_T *)&((struct file_buffer *)$tmp)->b_last_insert;"
		end

	c_b_last_change (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (pos_T *)&((struct file_buffer *)$tmp)->b_last_change;"
		end

	c_b_changelist (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct file_buffer *tmp = (struct file_buffer *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->b_changelist) / sizeof(tmp->b_changelist[0]);
				return tmp->b_changelist;
			]"
		end

	c_b_changelistlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_changelistlen;"
		end

	c_b_new_change (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_new_change;"
		end

	c_b_chartab (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct file_buffer *tmp = (struct file_buffer *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->b_chartab) / sizeof(tmp->b_chartab[0]);
				return tmp->b_chartab;
			]"
		end

	c_b_maphash (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct file_buffer *tmp = (struct file_buffer *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->b_maphash) / sizeof(tmp->b_maphash[0]);
				return tmp->b_maphash;
			]"
		end

	c_b_first_abbr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct mapblock *)((struct file_buffer *)$tmp)->b_first_abbr;"
		end

	c_b_ucmds (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct file_buffer *)$tmp)->b_ucmds;"
		end

	c_b_op_start (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (pos_T *)&((struct file_buffer *)$tmp)->b_op_start;"
		end

	c_b_op_end (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (pos_T *)&((struct file_buffer *)$tmp)->b_op_end;"
		end

	c_b_marks_read (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_marks_read;"
		end

	c_b_u_oldhead (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct u_header *)((struct file_buffer *)$tmp)->b_u_oldhead;"
		end

	c_b_u_newhead (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct u_header *)((struct file_buffer *)$tmp)->b_u_newhead;"
		end

	c_b_u_curhead (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct u_header *)((struct file_buffer *)$tmp)->b_u_curhead;"
		end

	c_b_u_numhead (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_u_numhead;"
		end

	c_b_u_synced (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_u_synced;"
		end

	c_b_u_seq_last (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_u_seq_last;"
		end

	c_b_u_save_nr_last (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_u_save_nr_last;"
		end

	c_b_u_seq_cur (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_u_seq_cur;"
		end

	c_b_u_time_cur (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_u_time_cur;"
		end

	c_b_u_save_nr_cur (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_u_save_nr_cur;"
		end

	c_b_u_line_ptr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_u_line_ptr;"
		end

	c_b_u_line_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_u_line_lnum;"
		end

	c_b_u_line_colnr (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_u_line_colnr;"
		end

	c_b_scanned (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_scanned;"
		end

	c_b_p_iminsert (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_p_iminsert;"
		end

	c_b_p_imsearch (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_p_imsearch;"
		end

	c_b_p_initialized (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_initialized;"
		end

	c_b_p_scriptID (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct file_buffer *tmp = (struct file_buffer *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->b_p_scriptID) / sizeof(tmp->b_p_scriptID[0]);
				return tmp->b_p_scriptID;
			]"
		end

	c_b_p_ai (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_ai;"
		end

	c_b_p_ai_nopaste (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_ai_nopaste;"
		end

	c_b_p_ci (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_ci;"
		end

	c_b_p_bin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_bin;"
		end

	c_b_p_bomb (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_bomb;"
		end

	c_b_p_bh (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_bh;"
		end

	c_b_p_bt (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_bt;"
		end

	c_b_p_bl (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_bl;"
		end

	c_b_p_cin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_cin;"
		end

	c_b_p_cino (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_cino;"
		end

	c_b_p_cink (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_cink;"
		end

	c_b_p_cinw (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_cinw;"
		end

	c_b_p_com (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_com;"
		end

	c_b_p_cms (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_cms;"
		end

	c_b_p_cpt (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_cpt;"
		end

	c_b_p_cfu (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_cfu;"
		end

	c_b_p_ofu (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_ofu;"
		end

	c_b_p_eol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_eol;"
		end

	c_b_p_et (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_et;"
		end

	c_b_p_et_nobin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_et_nobin;"
		end

	c_b_p_fenc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_fenc;"
		end

	c_b_p_ff (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_ff;"
		end

	c_b_p_ft (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_ft;"
		end

	c_b_p_fo (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_fo;"
		end

	c_b_p_flp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_flp;"
		end

	c_b_p_inf (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_inf;"
		end

	c_b_p_isk (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_isk;"
		end

	c_b_p_def (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_def;"
		end

	c_b_p_inc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_inc;"
		end

	c_b_p_inex (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_inex;"
		end

	c_b_p_inex_flags (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct file_buffer *)$tmp)->b_p_inex_flags;"
		end

	c_b_p_inde (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_inde;"
		end

	c_b_p_inde_flags (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct file_buffer *)$tmp)->b_p_inde_flags;"
		end

	c_b_p_indk (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_indk;"
		end

	c_b_p_fex (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_fex;"
		end

	c_b_p_fex_flags (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct file_buffer *)$tmp)->b_p_fex_flags;"
		end

	c_b_p_key (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_key;"
		end

	c_b_p_kp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_kp;"
		end

	c_b_p_lisp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_lisp;"
		end

	c_b_p_mps (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_mps;"
		end

	c_b_p_ml (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_ml;"
		end

	c_b_p_ml_nobin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_ml_nobin;"
		end

	c_b_p_ma (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_ma;"
		end

	c_b_p_nf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_nf;"
		end

	c_b_p_pi (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_pi;"
		end

	c_b_p_qe (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_qe;"
		end

	c_b_p_ro (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_ro;"
		end

	c_b_p_sw (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_p_sw;"
		end

	c_b_p_sn (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_sn;"
		end

	c_b_p_si (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_si;"
		end

	c_b_p_sts (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_p_sts;"
		end

	c_b_p_sts_nopaste (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_p_sts_nopaste;"
		end

	c_b_p_sua (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_sua;"
		end

	c_b_p_swf (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_swf;"
		end

	c_b_p_smc (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_p_smc;"
		end

	c_b_p_syn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_syn;"
		end

	c_b_p_ts (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_p_ts;"
		end

	c_b_p_tx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_tx;"
		end

	c_b_p_tw (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_p_tw;"
		end

	c_b_p_tw_nobin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_p_tw_nobin;"
		end

	c_b_p_tw_nopaste (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_p_tw_nopaste;"
		end

	c_b_p_wm (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_p_wm;"
		end

	c_b_p_wm_nobin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_p_wm_nobin;"
		end

	c_b_p_wm_nopaste (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct file_buffer *)$tmp)->b_p_wm_nopaste;"
		end

	c_b_p_gp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_gp;"
		end

	c_b_p_mp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_mp;"
		end

	c_b_p_efm (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_efm;"
		end

	c_b_p_ep (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_ep;"
		end

	c_b_p_path (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_path;"
		end

	c_b_p_ar (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_ar;"
		end

	c_b_p_tags (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_tags;"
		end

	c_b_p_dict (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_dict;"
		end

	c_b_p_tsr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_tsr;"
		end

	c_b_p_udf (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_p_udf;"
		end

	c_b_start_eol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_start_eol;"
		end

	c_b_start_ffc (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_start_ffc;"
		end

	c_b_start_fenc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_start_fenc;"
		end

	c_b_bad_char (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_bad_char;"
		end

	c_b_start_bomb (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_start_bomb;"
		end

	c_b_bufvar (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dictitem_S *)&((struct file_buffer *)$tmp)->b_bufvar;"
		end

	c_b_vars (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dictvar_S *)&((struct file_buffer *)$tmp)->b_vars;"
		end

	c_b_p_bexpr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_bexpr;"
		end

	c_b_p_bexpr_flags (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct file_buffer *)$tmp)->b_p_bexpr_flags;"
		end

	c_b_p_cm (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct file_buffer *)$tmp)->b_p_cm;"
		end

	c_b_may_swap (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_may_swap;"
		end

	c_b_did_warn (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_did_warn;"
		end

	c_b_help (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_help;"
		end

	c_b_spell (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_spell;"
		end

	c_b_shortname (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_shortname;"
		end

	c_b_s (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (synblock_T *)&((struct file_buffer *)$tmp)->b_s;"
		end

	c_b_signlist (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct signlist *)((struct file_buffer *)$tmp)->b_signlist;"
		end

	c_b_netbeans_file (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_netbeans_file;"
		end

	c_b_was_netbeans_file (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct file_buffer *)$tmp)->b_was_netbeans_file;"
		end

feature {NONE} -- C setters

	c_set_b_next (tmp: POINTER; a_b_next: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_next = (struct file_buffer *)$a_b_next;"
		end

	c_set_b_prev (tmp: POINTER; a_b_prev: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_prev = (struct file_buffer *)$a_b_prev;"
		end

	c_set_b_nwindows (tmp: POINTER; a_b_nwindows: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_nwindows = $a_b_nwindows;"
		end

	c_set_b_flags (tmp: POINTER; a_b_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_flags = $a_b_flags;"
		end

	c_set_b_ffname (tmp: POINTER; a_b_ffname: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_ffname = (unsigned char *)$a_b_ffname;"
		end

	c_set_b_sfname (tmp: POINTER; a_b_sfname: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_sfname = (unsigned char *)$a_b_sfname;"
		end

	c_set_b_fname (tmp: POINTER; a_b_fname: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_fname = (unsigned char *)$a_b_fname;"
		end

	c_set_b_dev_valid (tmp: POINTER; a_b_dev_valid: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_dev_valid = $a_b_dev_valid;"
		end

	c_set_b_dev (tmp: POINTER; a_b_dev: NATURAL_64)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_dev = $a_b_dev;"
		end

	c_set_b_ino (tmp: POINTER; a_b_ino: NATURAL_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_ino = $a_b_ino;"
		end

	c_set_b_fnum (tmp: POINTER; a_b_fnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_fnum = $a_b_fnum;"
		end

	c_set_b_changed (tmp: POINTER; a_b_changed: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_changed = $a_b_changed;"
		end

	c_set_b_changedtick (tmp: POINTER; a_b_changedtick: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_changedtick = $a_b_changedtick;"
		end

	c_set_b_saving (tmp: POINTER; a_b_saving: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_saving = $a_b_saving;"
		end

	c_set_b_mod_set (tmp: POINTER; a_b_mod_set: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_mod_set = $a_b_mod_set;"
		end

	c_set_b_mod_top (tmp: POINTER; a_b_mod_top: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_mod_top = $a_b_mod_top;"
		end

	c_set_b_mod_bot (tmp: POINTER; a_b_mod_bot: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_mod_bot = $a_b_mod_bot;"
		end

	c_set_b_mod_xlines (tmp: POINTER; a_b_mod_xlines: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_mod_xlines = $a_b_mod_xlines;"
		end

	c_set_b_wininfo (tmp: POINTER; a_b_wininfo: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_wininfo = (struct wininfo_S *)$a_b_wininfo;"
		end

	c_set_b_mtime (tmp: POINTER; a_b_mtime: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_mtime = $a_b_mtime;"
		end

	c_set_b_mtime_read (tmp: POINTER; a_b_mtime_read: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_mtime_read = $a_b_mtime_read;"
		end

	c_set_b_orig_size (tmp: POINTER; a_b_orig_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_orig_size = $a_b_orig_size;"
		end

	c_set_b_orig_mode (tmp: POINTER; a_b_orig_mode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_orig_mode = $a_b_orig_mode;"
		end

	c_set_b_visual_mode_eval (tmp: POINTER; a_b_visual_mode_eval: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_visual_mode_eval = $a_b_visual_mode_eval;"
		end

	c_set_b_changelistlen (tmp: POINTER; a_b_changelistlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_changelistlen = $a_b_changelistlen;"
		end

	c_set_b_new_change (tmp: POINTER; a_b_new_change: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_new_change = $a_b_new_change;"
		end

	c_set_b_first_abbr (tmp: POINTER; a_b_first_abbr: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_first_abbr = (struct mapblock *)$a_b_first_abbr;"
		end

	c_set_b_marks_read (tmp: POINTER; a_b_marks_read: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_marks_read = $a_b_marks_read;"
		end

	c_set_b_u_oldhead (tmp: POINTER; a_b_u_oldhead: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_u_oldhead = (struct u_header *)$a_b_u_oldhead;"
		end

	c_set_b_u_newhead (tmp: POINTER; a_b_u_newhead: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_u_newhead = (struct u_header *)$a_b_u_newhead;"
		end

	c_set_b_u_curhead (tmp: POINTER; a_b_u_curhead: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_u_curhead = (struct u_header *)$a_b_u_curhead;"
		end

	c_set_b_u_numhead (tmp: POINTER; a_b_u_numhead: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_u_numhead = $a_b_u_numhead;"
		end

	c_set_b_u_synced (tmp: POINTER; a_b_u_synced: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_u_synced = $a_b_u_synced;"
		end

	c_set_b_u_seq_last (tmp: POINTER; a_b_u_seq_last: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_u_seq_last = $a_b_u_seq_last;"
		end

	c_set_b_u_save_nr_last (tmp: POINTER; a_b_u_save_nr_last: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_u_save_nr_last = $a_b_u_save_nr_last;"
		end

	c_set_b_u_seq_cur (tmp: POINTER; a_b_u_seq_cur: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_u_seq_cur = $a_b_u_seq_cur;"
		end

	c_set_b_u_time_cur (tmp: POINTER; a_b_u_time_cur: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_u_time_cur = $a_b_u_time_cur;"
		end

	c_set_b_u_save_nr_cur (tmp: POINTER; a_b_u_save_nr_cur: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_u_save_nr_cur = $a_b_u_save_nr_cur;"
		end

	c_set_b_u_line_ptr (tmp: POINTER; a_b_u_line_ptr: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_u_line_ptr = (unsigned char *)$a_b_u_line_ptr;"
		end

	c_set_b_u_line_lnum (tmp: POINTER; a_b_u_line_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_u_line_lnum = $a_b_u_line_lnum;"
		end

	c_set_b_u_line_colnr (tmp: POINTER; a_b_u_line_colnr: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_u_line_colnr = $a_b_u_line_colnr;"
		end

	c_set_b_scanned (tmp: POINTER; a_b_scanned: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_scanned = $a_b_scanned;"
		end

	c_set_b_p_iminsert (tmp: POINTER; a_b_p_iminsert: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_iminsert = $a_b_p_iminsert;"
		end

	c_set_b_p_imsearch (tmp: POINTER; a_b_p_imsearch: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_imsearch = $a_b_p_imsearch;"
		end

	c_set_b_p_initialized (tmp: POINTER; a_b_p_initialized: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_initialized = $a_b_p_initialized;"
		end

	c_set_b_p_ai (tmp: POINTER; a_b_p_ai: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_ai = $a_b_p_ai;"
		end

	c_set_b_p_ai_nopaste (tmp: POINTER; a_b_p_ai_nopaste: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_ai_nopaste = $a_b_p_ai_nopaste;"
		end

	c_set_b_p_ci (tmp: POINTER; a_b_p_ci: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_ci = $a_b_p_ci;"
		end

	c_set_b_p_bin (tmp: POINTER; a_b_p_bin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_bin = $a_b_p_bin;"
		end

	c_set_b_p_bomb (tmp: POINTER; a_b_p_bomb: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_bomb = $a_b_p_bomb;"
		end

	c_set_b_p_bh (tmp: POINTER; a_b_p_bh: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_bh = (unsigned char *)$a_b_p_bh;"
		end

	c_set_b_p_bt (tmp: POINTER; a_b_p_bt: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_bt = (unsigned char *)$a_b_p_bt;"
		end

	c_set_b_p_bl (tmp: POINTER; a_b_p_bl: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_bl = $a_b_p_bl;"
		end

	c_set_b_p_cin (tmp: POINTER; a_b_p_cin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_cin = $a_b_p_cin;"
		end

	c_set_b_p_cino (tmp: POINTER; a_b_p_cino: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_cino = (unsigned char *)$a_b_p_cino;"
		end

	c_set_b_p_cink (tmp: POINTER; a_b_p_cink: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_cink = (unsigned char *)$a_b_p_cink;"
		end

	c_set_b_p_cinw (tmp: POINTER; a_b_p_cinw: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_cinw = (unsigned char *)$a_b_p_cinw;"
		end

	c_set_b_p_com (tmp: POINTER; a_b_p_com: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_com = (unsigned char *)$a_b_p_com;"
		end

	c_set_b_p_cms (tmp: POINTER; a_b_p_cms: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_cms = (unsigned char *)$a_b_p_cms;"
		end

	c_set_b_p_cpt (tmp: POINTER; a_b_p_cpt: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_cpt = (unsigned char *)$a_b_p_cpt;"
		end

	c_set_b_p_cfu (tmp: POINTER; a_b_p_cfu: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_cfu = (unsigned char *)$a_b_p_cfu;"
		end

	c_set_b_p_ofu (tmp: POINTER; a_b_p_ofu: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_ofu = (unsigned char *)$a_b_p_ofu;"
		end

	c_set_b_p_eol (tmp: POINTER; a_b_p_eol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_eol = $a_b_p_eol;"
		end

	c_set_b_p_et (tmp: POINTER; a_b_p_et: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_et = $a_b_p_et;"
		end

	c_set_b_p_et_nobin (tmp: POINTER; a_b_p_et_nobin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_et_nobin = $a_b_p_et_nobin;"
		end

	c_set_b_p_fenc (tmp: POINTER; a_b_p_fenc: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_fenc = (unsigned char *)$a_b_p_fenc;"
		end

	c_set_b_p_ff (tmp: POINTER; a_b_p_ff: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_ff = (unsigned char *)$a_b_p_ff;"
		end

	c_set_b_p_ft (tmp: POINTER; a_b_p_ft: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_ft = (unsigned char *)$a_b_p_ft;"
		end

	c_set_b_p_fo (tmp: POINTER; a_b_p_fo: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_fo = (unsigned char *)$a_b_p_fo;"
		end

	c_set_b_p_flp (tmp: POINTER; a_b_p_flp: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_flp = (unsigned char *)$a_b_p_flp;"
		end

	c_set_b_p_inf (tmp: POINTER; a_b_p_inf: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_inf = $a_b_p_inf;"
		end

	c_set_b_p_isk (tmp: POINTER; a_b_p_isk: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_isk = (unsigned char *)$a_b_p_isk;"
		end

	c_set_b_p_def (tmp: POINTER; a_b_p_def: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_def = (unsigned char *)$a_b_p_def;"
		end

	c_set_b_p_inc (tmp: POINTER; a_b_p_inc: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_inc = (unsigned char *)$a_b_p_inc;"
		end

	c_set_b_p_inex (tmp: POINTER; a_b_p_inex: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_inex = (unsigned char *)$a_b_p_inex;"
		end

	c_set_b_p_inex_flags (tmp: POINTER; a_b_p_inex_flags: NATURAL_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_inex_flags = $a_b_p_inex_flags;"
		end

	c_set_b_p_inde (tmp: POINTER; a_b_p_inde: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_inde = (unsigned char *)$a_b_p_inde;"
		end

	c_set_b_p_inde_flags (tmp: POINTER; a_b_p_inde_flags: NATURAL_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_inde_flags = $a_b_p_inde_flags;"
		end

	c_set_b_p_indk (tmp: POINTER; a_b_p_indk: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_indk = (unsigned char *)$a_b_p_indk;"
		end

	c_set_b_p_fex (tmp: POINTER; a_b_p_fex: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_fex = (unsigned char *)$a_b_p_fex;"
		end

	c_set_b_p_fex_flags (tmp: POINTER; a_b_p_fex_flags: NATURAL_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_fex_flags = $a_b_p_fex_flags;"
		end

	c_set_b_p_key (tmp: POINTER; a_b_p_key: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_key = (unsigned char *)$a_b_p_key;"
		end

	c_set_b_p_kp (tmp: POINTER; a_b_p_kp: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_kp = (unsigned char *)$a_b_p_kp;"
		end

	c_set_b_p_lisp (tmp: POINTER; a_b_p_lisp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_lisp = $a_b_p_lisp;"
		end

	c_set_b_p_mps (tmp: POINTER; a_b_p_mps: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_mps = (unsigned char *)$a_b_p_mps;"
		end

	c_set_b_p_ml (tmp: POINTER; a_b_p_ml: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_ml = $a_b_p_ml;"
		end

	c_set_b_p_ml_nobin (tmp: POINTER; a_b_p_ml_nobin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_ml_nobin = $a_b_p_ml_nobin;"
		end

	c_set_b_p_ma (tmp: POINTER; a_b_p_ma: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_ma = $a_b_p_ma;"
		end

	c_set_b_p_nf (tmp: POINTER; a_b_p_nf: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_nf = (unsigned char *)$a_b_p_nf;"
		end

	c_set_b_p_pi (tmp: POINTER; a_b_p_pi: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_pi = $a_b_p_pi;"
		end

	c_set_b_p_qe (tmp: POINTER; a_b_p_qe: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_qe = (unsigned char *)$a_b_p_qe;"
		end

	c_set_b_p_ro (tmp: POINTER; a_b_p_ro: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_ro = $a_b_p_ro;"
		end

	c_set_b_p_sw (tmp: POINTER; a_b_p_sw: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_sw = $a_b_p_sw;"
		end

	c_set_b_p_sn (tmp: POINTER; a_b_p_sn: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_sn = $a_b_p_sn;"
		end

	c_set_b_p_si (tmp: POINTER; a_b_p_si: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_si = $a_b_p_si;"
		end

	c_set_b_p_sts (tmp: POINTER; a_b_p_sts: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_sts = $a_b_p_sts;"
		end

	c_set_b_p_sts_nopaste (tmp: POINTER; a_b_p_sts_nopaste: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_sts_nopaste = $a_b_p_sts_nopaste;"
		end

	c_set_b_p_sua (tmp: POINTER; a_b_p_sua: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_sua = (unsigned char *)$a_b_p_sua;"
		end

	c_set_b_p_swf (tmp: POINTER; a_b_p_swf: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_swf = $a_b_p_swf;"
		end

	c_set_b_p_smc (tmp: POINTER; a_b_p_smc: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_smc = $a_b_p_smc;"
		end

	c_set_b_p_syn (tmp: POINTER; a_b_p_syn: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_syn = (unsigned char *)$a_b_p_syn;"
		end

	c_set_b_p_ts (tmp: POINTER; a_b_p_ts: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_ts = $a_b_p_ts;"
		end

	c_set_b_p_tx (tmp: POINTER; a_b_p_tx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_tx = $a_b_p_tx;"
		end

	c_set_b_p_tw (tmp: POINTER; a_b_p_tw: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_tw = $a_b_p_tw;"
		end

	c_set_b_p_tw_nobin (tmp: POINTER; a_b_p_tw_nobin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_tw_nobin = $a_b_p_tw_nobin;"
		end

	c_set_b_p_tw_nopaste (tmp: POINTER; a_b_p_tw_nopaste: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_tw_nopaste = $a_b_p_tw_nopaste;"
		end

	c_set_b_p_wm (tmp: POINTER; a_b_p_wm: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_wm = $a_b_p_wm;"
		end

	c_set_b_p_wm_nobin (tmp: POINTER; a_b_p_wm_nobin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_wm_nobin = $a_b_p_wm_nobin;"
		end

	c_set_b_p_wm_nopaste (tmp: POINTER; a_b_p_wm_nopaste: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_wm_nopaste = $a_b_p_wm_nopaste;"
		end

	c_set_b_p_gp (tmp: POINTER; a_b_p_gp: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_gp = (unsigned char *)$a_b_p_gp;"
		end

	c_set_b_p_mp (tmp: POINTER; a_b_p_mp: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_mp = (unsigned char *)$a_b_p_mp;"
		end

	c_set_b_p_efm (tmp: POINTER; a_b_p_efm: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_efm = (unsigned char *)$a_b_p_efm;"
		end

	c_set_b_p_ep (tmp: POINTER; a_b_p_ep: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_ep = (unsigned char *)$a_b_p_ep;"
		end

	c_set_b_p_path (tmp: POINTER; a_b_p_path: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_path = (unsigned char *)$a_b_p_path;"
		end

	c_set_b_p_ar (tmp: POINTER; a_b_p_ar: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_ar = $a_b_p_ar;"
		end

	c_set_b_p_tags (tmp: POINTER; a_b_p_tags: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_tags = (unsigned char *)$a_b_p_tags;"
		end

	c_set_b_p_dict (tmp: POINTER; a_b_p_dict: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_dict = (unsigned char *)$a_b_p_dict;"
		end

	c_set_b_p_tsr (tmp: POINTER; a_b_p_tsr: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_tsr = (unsigned char *)$a_b_p_tsr;"
		end

	c_set_b_p_udf (tmp: POINTER; a_b_p_udf: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_udf = $a_b_p_udf;"
		end

	c_set_b_start_eol (tmp: POINTER; a_b_start_eol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_start_eol = $a_b_start_eol;"
		end

	c_set_b_start_ffc (tmp: POINTER; a_b_start_ffc: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_start_ffc = $a_b_start_ffc;"
		end

	c_set_b_start_fenc (tmp: POINTER; a_b_start_fenc: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_start_fenc = (unsigned char *)$a_b_start_fenc;"
		end

	c_set_b_bad_char (tmp: POINTER; a_b_bad_char: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_bad_char = $a_b_bad_char;"
		end

	c_set_b_start_bomb (tmp: POINTER; a_b_start_bomb: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_start_bomb = $a_b_start_bomb;"
		end

	c_set_b_p_bexpr (tmp: POINTER; a_b_p_bexpr: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_bexpr = (unsigned char *)$a_b_p_bexpr;"
		end

	c_set_b_p_bexpr_flags (tmp: POINTER; a_b_p_bexpr_flags: NATURAL_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_bexpr_flags = $a_b_p_bexpr_flags;"
		end

	c_set_b_p_cm (tmp: POINTER; a_b_p_cm: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_p_cm = (unsigned char *)$a_b_p_cm;"
		end

	c_set_b_may_swap (tmp: POINTER; a_b_may_swap: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_may_swap = $a_b_may_swap;"
		end

	c_set_b_did_warn (tmp: POINTER; a_b_did_warn: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_did_warn = $a_b_did_warn;"
		end

	c_set_b_help (tmp: POINTER; a_b_help: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_help = $a_b_help;"
		end

	c_set_b_spell (tmp: POINTER; a_b_spell: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_spell = $a_b_spell;"
		end

	c_set_b_shortname (tmp: POINTER; a_b_shortname: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_shortname = $a_b_shortname;"
		end

	c_set_b_signlist (tmp: POINTER; a_b_signlist: POINTER)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_signlist = (struct signlist *)$a_b_signlist;"
		end

	c_set_b_netbeans_file (tmp: POINTER; a_b_netbeans_file: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_netbeans_file = $a_b_netbeans_file;"
		end

	c_set_b_was_netbeans_file (tmp: POINTER; a_b_was_netbeans_file: INTEGER_32)
		external
			"C inline"
		alias
			"((struct file_buffer *)$tmp)->b_was_netbeans_file = $a_b_was_netbeans_file;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct file_buffer);"
		end

end
