class
	PD_FLAG

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	argtype: INTEGER_32 assign set_argtype
		do
			Result := c_argtype (c_pointer)
		end

	flags: INTEGER_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_argtype (a_argtype: INTEGER_32)
		do
			c_set_argtype (c_pointer, a_argtype)
		end

	set_flags (a_flags: INTEGER_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct flag *)$tmp)->name;"
		end

	c_argtype (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct flag *)$tmp)->argtype;"
		end

	c_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct flag *)$tmp)->flags;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct flag *)$tmp)->name = (char *)$a_name;"
		end

	c_set_argtype (tmp: POINTER; a_argtype: INTEGER_32)
		external
			"C inline"
		alias
			"((struct flag *)$tmp)->argtype = $a_argtype;"
		end

	c_set_flags (tmp: POINTER; a_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct flag *)$tmp)->flags = $a_flags;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct flag);"
		end

end
