class
	PD_FOLD_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	fd_top: INTEGER_32 assign set_fd_top
		do
			Result := c_fd_top (c_pointer)
		end

	fd_len: INTEGER_32 assign set_fd_len
		do
			Result := c_fd_len (c_pointer)
		end

	fd_nested: PD_GROWARRAY assign set_fd_nested
		do
			create Result.make_shared (c_fd_nested (c_pointer))
		end

	fd_nested_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_fold_T_543, fd_nested);"
		end

	fd_flags: INTEGER_8 assign set_fd_flags
		do
			Result := c_fd_flags (c_pointer)
		end

	fd_small: INTEGER_8 assign set_fd_small
		do
			Result := c_fd_small (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_fd_top (a_fd_top: INTEGER_32)
		do
			c_set_fd_top (c_pointer, a_fd_top)
		end

	set_fd_len (a_fd_len: INTEGER_32)
		do
			c_set_fd_len (c_pointer, a_fd_len)
		end

	set_fd_nested (a_fd_nested: PD_GROWARRAY)
		do
			fd_nested.ce_gets (a_fd_nested)
		end

	set_fd_flags (a_fd_flags: INTEGER_8)
		do
			c_set_fd_flags (c_pointer, a_fd_flags)
		end

	set_fd_small (a_fd_small: INTEGER_8)
		do
			c_set_fd_small (c_pointer, a_fd_small)
		end

feature {NONE} -- C getters

	c_fd_top (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_fold_T_543 *)$tmp)->fd_top;"
		end

	c_fd_len (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_fold_T_543 *)$tmp)->fd_len;"
		end

	c_fd_nested (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct __anonstruct_fold_T_543 *)$tmp)->fd_nested;"
		end

	c_fd_flags (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct __anonstruct_fold_T_543 *)$tmp)->fd_flags;"
		end

	c_fd_small (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct __anonstruct_fold_T_543 *)$tmp)->fd_small;"
		end

feature {NONE} -- C setters

	c_set_fd_top (tmp: POINTER; a_fd_top: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_fold_T_543 *)$tmp)->fd_top = $a_fd_top;"
		end

	c_set_fd_len (tmp: POINTER; a_fd_len: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_fold_T_543 *)$tmp)->fd_len = $a_fd_len;"
		end

	c_set_fd_flags (tmp: POINTER; a_fd_flags: INTEGER_8)
		external
			"C inline"
		alias
			"((struct __anonstruct_fold_T_543 *)$tmp)->fd_flags = $a_fd_flags;"
		end

	c_set_fd_small (tmp: POINTER; a_fd_small: INTEGER_8)
		external
			"C inline"
		alias
			"((struct __anonstruct_fold_T_543 *)$tmp)->fd_small = $a_fd_small;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_fold_T_543);"
		end

end
