class
	PD_FRAME_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	fr_layout: INTEGER_8 assign set_fr_layout
		do
			Result := c_fr_layout (c_pointer)
		end

	fr_width: INTEGER_32 assign set_fr_width
		do
			Result := c_fr_width (c_pointer)
		end

	fr_newwidth: INTEGER_32 assign set_fr_newwidth
		do
			Result := c_fr_newwidth (c_pointer)
		end

	fr_height: INTEGER_32 assign set_fr_height
		do
			Result := c_fr_height (c_pointer)
		end

	fr_newheight: INTEGER_32 assign set_fr_newheight
		do
			Result := c_fr_newheight (c_pointer)
		end

	fr_parent: CE_POINTER [PD_FRAME_S] assign set_fr_parent
		do
			create Result.make_shared (c_fr_parent (c_pointer))
		end

	fr_next: CE_POINTER [PD_FRAME_S] assign set_fr_next
		do
			create Result.make_shared (c_fr_next (c_pointer))
		end

	fr_next_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct frame_S, fr_next);"
		end

	fr_prev: CE_POINTER [PD_FRAME_S] assign set_fr_prev
		do
			create Result.make_shared (c_fr_prev (c_pointer))
		end

	fr_child: CE_POINTER [PD_FRAME_S] assign set_fr_child
		do
			create Result.make_shared (c_fr_child (c_pointer))
		end

	fr_child_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct frame_S, fr_child);"
		end

	fr_win: CE_POINTER [PD_WINDOW_S] assign set_fr_win
		do
			create Result.make_shared (c_fr_win (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_fr_layout (a_fr_layout: INTEGER_8)
		do
			c_set_fr_layout (c_pointer, a_fr_layout)
		end

	set_fr_width (a_fr_width: INTEGER_32)
		do
			c_set_fr_width (c_pointer, a_fr_width)
		end

	set_fr_newwidth (a_fr_newwidth: INTEGER_32)
		do
			c_set_fr_newwidth (c_pointer, a_fr_newwidth)
		end

	set_fr_height (a_fr_height: INTEGER_32)
		do
			c_set_fr_height (c_pointer, a_fr_height)
		end

	set_fr_newheight (a_fr_newheight: INTEGER_32)
		do
			c_set_fr_newheight (c_pointer, a_fr_newheight)
		end

	set_fr_parent (a_fr_parent: CE_POINTER [PD_FRAME_S])
		do
			c_set_fr_parent (c_pointer, a_fr_parent.c_pointer)
		end

	set_fr_next (a_fr_next: CE_POINTER [PD_FRAME_S])
		do
			c_set_fr_next (c_pointer, a_fr_next.c_pointer)
		end

	set_fr_prev (a_fr_prev: CE_POINTER [PD_FRAME_S])
		do
			c_set_fr_prev (c_pointer, a_fr_prev.c_pointer)
		end

	set_fr_child (a_fr_child: CE_POINTER [PD_FRAME_S])
		do
			c_set_fr_child (c_pointer, a_fr_child.c_pointer)
		end

	set_fr_win (a_fr_win: CE_POINTER [PD_WINDOW_S])
		do
			c_set_fr_win (c_pointer, a_fr_win.c_pointer)
		end

feature {NONE} -- C getters

	c_fr_layout (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct frame_S *)$tmp)->fr_layout;"
		end

	c_fr_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct frame_S *)$tmp)->fr_width;"
		end

	c_fr_newwidth (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct frame_S *)$tmp)->fr_newwidth;"
		end

	c_fr_height (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct frame_S *)$tmp)->fr_height;"
		end

	c_fr_newheight (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct frame_S *)$tmp)->fr_newheight;"
		end

	c_fr_parent (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct frame_S *)((struct frame_S *)$tmp)->fr_parent;"
		end

	c_fr_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct frame_S *)((struct frame_S *)$tmp)->fr_next;"
		end

	c_fr_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct frame_S *)((struct frame_S *)$tmp)->fr_prev;"
		end

	c_fr_child (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct frame_S *)((struct frame_S *)$tmp)->fr_child;"
		end

	c_fr_win (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct window_S *)((struct frame_S *)$tmp)->fr_win;"
		end

feature {NONE} -- C setters

	c_set_fr_layout (tmp: POINTER; a_fr_layout: INTEGER_8)
		external
			"C inline"
		alias
			"((struct frame_S *)$tmp)->fr_layout = $a_fr_layout;"
		end

	c_set_fr_width (tmp: POINTER; a_fr_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct frame_S *)$tmp)->fr_width = $a_fr_width;"
		end

	c_set_fr_newwidth (tmp: POINTER; a_fr_newwidth: INTEGER_32)
		external
			"C inline"
		alias
			"((struct frame_S *)$tmp)->fr_newwidth = $a_fr_newwidth;"
		end

	c_set_fr_height (tmp: POINTER; a_fr_height: INTEGER_32)
		external
			"C inline"
		alias
			"((struct frame_S *)$tmp)->fr_height = $a_fr_height;"
		end

	c_set_fr_newheight (tmp: POINTER; a_fr_newheight: INTEGER_32)
		external
			"C inline"
		alias
			"((struct frame_S *)$tmp)->fr_newheight = $a_fr_newheight;"
		end

	c_set_fr_parent (tmp: POINTER; a_fr_parent: POINTER)
		external
			"C inline"
		alias
			"((struct frame_S *)$tmp)->fr_parent = (struct frame_S *)$a_fr_parent;"
		end

	c_set_fr_next (tmp: POINTER; a_fr_next: POINTER)
		external
			"C inline"
		alias
			"((struct frame_S *)$tmp)->fr_next = (struct frame_S *)$a_fr_next;"
		end

	c_set_fr_prev (tmp: POINTER; a_fr_prev: POINTER)
		external
			"C inline"
		alias
			"((struct frame_S *)$tmp)->fr_prev = (struct frame_S *)$a_fr_prev;"
		end

	c_set_fr_child (tmp: POINTER; a_fr_child: POINTER)
		external
			"C inline"
		alias
			"((struct frame_S *)$tmp)->fr_child = (struct frame_S *)$a_fr_child;"
		end

	c_set_fr_win (tmp: POINTER; a_fr_win: POINTER)
		external
			"C inline"
		alias
			"((struct frame_S *)$tmp)->fr_win = (struct window_S *)$a_fr_win;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct frame_S);"
		end

end
