class
	PD_FUNCCALL_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	func: CE_POINTER [PD_UFUNC] assign set_func
		do
			create Result.make_shared (c_func (c_pointer))
		end

	linenr: INTEGER_32 assign set_linenr
		do
			Result := c_linenr (c_pointer)
		end

	returned: INTEGER_32 assign set_returned
		do
			Result := c_returned (c_pointer)
		end

	fixvar: CE_ARRAY [PD_FIXVAR]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_fixvar (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	fixvar_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct funccall_S, fixvar);"
		end

	l_vars: PD_DICTVAR_S assign set_l_vars
		do
			create Result.make_shared (c_l_vars (c_pointer))
		end

	l_vars_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct funccall_S, l_vars);"
		end

	l_vars_var: PD_DICTITEM_S assign set_l_vars_var
		do
			create Result.make_shared (c_l_vars_var (c_pointer))
		end

	l_vars_var_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct funccall_S, l_vars_var);"
		end

	l_avars: PD_DICTVAR_S assign set_l_avars
		do
			create Result.make_shared (c_l_avars (c_pointer))
		end

	l_avars_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct funccall_S, l_avars);"
		end

	l_avars_var: PD_DICTITEM_S assign set_l_avars_var
		do
			create Result.make_shared (c_l_avars_var (c_pointer))
		end

	l_avars_var_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct funccall_S, l_avars_var);"
		end

	l_varlist: PD_LISTVAR_S assign set_l_varlist
		do
			create Result.make_shared (c_l_varlist (c_pointer))
		end

	l_varlist_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct funccall_S, l_varlist);"
		end

	l_listitems: CE_ARRAY [PD_LISTITEM_S]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_l_listitems (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	rettv: CE_POINTER [PD_TYPVAL_T] assign set_rettv
		do
			create Result.make_shared (c_rettv (c_pointer))
		end

	breakpoint: INTEGER_32 assign set_breakpoint
		do
			Result := c_breakpoint (c_pointer)
		end

	breakpoint_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct funccall_S, breakpoint);"
		end

	dbg_tick: INTEGER_32 assign set_dbg_tick
		do
			Result := c_dbg_tick (c_pointer)
		end

	dbg_tick_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct funccall_S, dbg_tick);"
		end

	level: INTEGER_32 assign set_level
		do
			Result := c_level (c_pointer)
		end

	caller: CE_POINTER [PD_FUNCCALL_S] assign set_caller
		do
			create Result.make_shared (c_caller (c_pointer))
		end

	caller_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct funccall_S, caller);"
		end

feature {ANY} -- Eiffel setters

	set_func (a_func: CE_POINTER [PD_UFUNC])
		do
			c_set_func (c_pointer, a_func.c_pointer)
		end

	set_linenr (a_linenr: INTEGER_32)
		do
			c_set_linenr (c_pointer, a_linenr)
		end

	set_returned (a_returned: INTEGER_32)
		do
			c_set_returned (c_pointer, a_returned)
		end

	set_l_vars (a_l_vars: PD_DICTVAR_S)
		do
			l_vars.ce_gets (a_l_vars)
		end

	set_l_vars_var (a_l_vars_var: PD_DICTITEM_S)
		do
			l_vars_var.ce_gets (a_l_vars_var)
		end

	set_l_avars (a_l_avars: PD_DICTVAR_S)
		do
			l_avars.ce_gets (a_l_avars)
		end

	set_l_avars_var (a_l_avars_var: PD_DICTITEM_S)
		do
			l_avars_var.ce_gets (a_l_avars_var)
		end

	set_l_varlist (a_l_varlist: PD_LISTVAR_S)
		do
			l_varlist.ce_gets (a_l_varlist)
		end

	set_rettv (a_rettv: CE_POINTER [PD_TYPVAL_T])
		do
			c_set_rettv (c_pointer, a_rettv.c_pointer)
		end

	set_breakpoint (a_breakpoint: INTEGER_32)
		do
			c_set_breakpoint (c_pointer, a_breakpoint)
		end

	set_dbg_tick (a_dbg_tick: INTEGER_32)
		do
			c_set_dbg_tick (c_pointer, a_dbg_tick)
		end

	set_level (a_level: INTEGER_32)
		do
			c_set_level (c_pointer, a_level)
		end

	set_caller (a_caller: CE_POINTER [PD_FUNCCALL_S])
		do
			c_set_caller (c_pointer, a_caller.c_pointer)
		end

feature {NONE} -- C getters

	c_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct ufunc *)((struct funccall_S *)$tmp)->func;"
		end

	c_linenr (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct funccall_S *)$tmp)->linenr;"
		end

	c_returned (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct funccall_S *)$tmp)->returned;"
		end

	c_fixvar (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct funccall_S *tmp = (struct funccall_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->fixvar) / sizeof(tmp->fixvar[0]);
				return tmp->fixvar;
			]"
		end

	c_l_vars (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dictvar_S *)&((struct funccall_S *)$tmp)->l_vars;"
		end

	c_l_vars_var (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dictitem_S *)&((struct funccall_S *)$tmp)->l_vars_var;"
		end

	c_l_avars (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dictvar_S *)&((struct funccall_S *)$tmp)->l_avars;"
		end

	c_l_avars_var (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dictitem_S *)&((struct funccall_S *)$tmp)->l_avars_var;"
		end

	c_l_varlist (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct listvar_S *)&((struct funccall_S *)$tmp)->l_varlist;"
		end

	c_l_listitems (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct funccall_S *tmp = (struct funccall_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->l_listitems) / sizeof(tmp->l_listitems[0]);
				return tmp->l_listitems;
			]"
		end

	c_rettv (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (typval_T *)((struct funccall_S *)$tmp)->rettv;"
		end

	c_breakpoint (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct funccall_S *)$tmp)->breakpoint;"
		end

	c_dbg_tick (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct funccall_S *)$tmp)->dbg_tick;"
		end

	c_level (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct funccall_S *)$tmp)->level;"
		end

	c_caller (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct funccall_S *)((struct funccall_S *)$tmp)->caller;"
		end

feature {NONE} -- C setters

	c_set_func (tmp: POINTER; a_func: POINTER)
		external
			"C inline"
		alias
			"((struct funccall_S *)$tmp)->func = (struct ufunc *)$a_func;"
		end

	c_set_linenr (tmp: POINTER; a_linenr: INTEGER_32)
		external
			"C inline"
		alias
			"((struct funccall_S *)$tmp)->linenr = $a_linenr;"
		end

	c_set_returned (tmp: POINTER; a_returned: INTEGER_32)
		external
			"C inline"
		alias
			"((struct funccall_S *)$tmp)->returned = $a_returned;"
		end

	c_set_rettv (tmp: POINTER; a_rettv: POINTER)
		external
			"C inline"
		alias
			"((struct funccall_S *)$tmp)->rettv = (typval_T *)$a_rettv;"
		end

	c_set_breakpoint (tmp: POINTER; a_breakpoint: INTEGER_32)
		external
			"C inline"
		alias
			"((struct funccall_S *)$tmp)->breakpoint = $a_breakpoint;"
		end

	c_set_dbg_tick (tmp: POINTER; a_dbg_tick: INTEGER_32)
		external
			"C inline"
		alias
			"((struct funccall_S *)$tmp)->dbg_tick = $a_dbg_tick;"
		end

	c_set_level (tmp: POINTER; a_level: INTEGER_32)
		external
			"C inline"
		alias
			"((struct funccall_S *)$tmp)->level = $a_level;"
		end

	c_set_caller (tmp: POINTER; a_caller: POINTER)
		external
			"C inline"
		alias
			"((struct funccall_S *)$tmp)->caller = (struct funccall_S *)$a_caller;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct funccall_S);"
		end

end
