class
	PD_GROWARRAY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ga_len: INTEGER_32 assign set_ga_len
		do
			Result := c_ga_len (c_pointer)
		end

	ga_maxlen: INTEGER_32 assign set_ga_maxlen
		do
			Result := c_ga_maxlen (c_pointer)
		end

	ga_itemsize: INTEGER_32 assign set_ga_itemsize
		do
			Result := c_ga_itemsize (c_pointer)
		end

	ga_growsize: INTEGER_32 assign set_ga_growsize
		do
			Result := c_ga_growsize (c_pointer)
		end

	ga_data: CE_POINTER [ANY] assign set_ga_data
		do
			create Result.make_shared (c_ga_data (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_ga_len (a_ga_len: INTEGER_32)
		do
			c_set_ga_len (c_pointer, a_ga_len)
		end

	set_ga_maxlen (a_ga_maxlen: INTEGER_32)
		do
			c_set_ga_maxlen (c_pointer, a_ga_maxlen)
		end

	set_ga_itemsize (a_ga_itemsize: INTEGER_32)
		do
			c_set_ga_itemsize (c_pointer, a_ga_itemsize)
		end

	set_ga_growsize (a_ga_growsize: INTEGER_32)
		do
			c_set_ga_growsize (c_pointer, a_ga_growsize)
		end

	set_ga_data (a_ga_data: CE_POINTER [ANY])
		do
			c_set_ga_data (c_pointer, a_ga_data.c_pointer)
		end

feature {NONE} -- C getters

	c_ga_len (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct growarray *)$tmp)->ga_len;"
		end

	c_ga_maxlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct growarray *)$tmp)->ga_maxlen;"
		end

	c_ga_itemsize (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct growarray *)$tmp)->ga_itemsize;"
		end

	c_ga_growsize (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct growarray *)$tmp)->ga_growsize;"
		end

	c_ga_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct growarray *)$tmp)->ga_data;"
		end

feature {NONE} -- C setters

	c_set_ga_len (tmp: POINTER; a_ga_len: INTEGER_32)
		external
			"C inline"
		alias
			"((struct growarray *)$tmp)->ga_len = $a_ga_len;"
		end

	c_set_ga_maxlen (tmp: POINTER; a_ga_maxlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct growarray *)$tmp)->ga_maxlen = $a_ga_maxlen;"
		end

	c_set_ga_itemsize (tmp: POINTER; a_ga_itemsize: INTEGER_32)
		external
			"C inline"
		alias
			"((struct growarray *)$tmp)->ga_itemsize = $a_ga_itemsize;"
		end

	c_set_ga_growsize (tmp: POINTER; a_ga_growsize: INTEGER_32)
		external
			"C inline"
		alias
			"((struct growarray *)$tmp)->ga_growsize = $a_ga_growsize;"
		end

	c_set_ga_data (tmp: POINTER; a_ga_data: POINTER)
		external
			"C inline"
		alias
			"((struct growarray *)$tmp)->ga_data = (void *)$a_ga_data;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct growarray);"
		end

end
