class
	PD_GTKFORM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	container: SD_GTKCONTAINER assign set_container
		do
			create Result.make_shared (c_container (c_pointer))
		end

	children: CE_POINTER [SD_GLIST] assign set_children
		do
			create Result.make_shared (c_children (c_pointer))
		end

	width: NATURAL_32 assign set_width
		do
			Result := c_width (c_pointer)
		end

	height: NATURAL_32 assign set_height
		do
			Result := c_height (c_pointer)
		end

	bin_window: CE_POINTER [SD_GDKDRAWABLE] assign set_bin_window
		do
			create Result.make_shared (c_bin_window (c_pointer))
		end

	visibility: INTEGER_32 assign set_visibility
		do
			Result := c_visibility (c_pointer)
		end

	configure_serial: NATURAL_32 assign set_configure_serial
		do
			Result := c_configure_serial (c_pointer)
		end

	freeze_count: INTEGER_32 assign set_freeze_count
		do
			Result := c_freeze_count (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_container (a_container: SD_GTKCONTAINER)
		do
			container.ce_gets (a_container)
		end

	set_children (a_children: CE_POINTER [SD_GLIST])
		do
			c_set_children (c_pointer, a_children.c_pointer)
		end

	set_width (a_width: NATURAL_32)
		do
			c_set_width (c_pointer, a_width)
		end

	set_height (a_height: NATURAL_32)
		do
			c_set_height (c_pointer, a_height)
		end

	set_bin_window (a_bin_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_bin_window (c_pointer, a_bin_window.c_pointer)
		end

	set_visibility (a_visibility: INTEGER_32)
		do
			c_set_visibility (c_pointer, a_visibility)
		end

	set_configure_serial (a_configure_serial: NATURAL_32)
		do
			c_set_configure_serial (c_pointer, a_configure_serial)
		end

	set_freeze_count (a_freeze_count: INTEGER_32)
		do
			c_set_freeze_count (c_pointer, a_freeze_count)
		end

feature {NONE} -- C getters

	c_container (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkContainer *)&((struct _GtkForm *)$tmp)->container;"
		end

	c_children (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GList *)((struct _GtkForm *)$tmp)->children;"
		end

	c_width (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkForm *)$tmp)->width;"
		end

	c_height (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkForm *)$tmp)->height;"
		end

	c_bin_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GtkForm *)$tmp)->bin_window;"
		end

	c_visibility (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkForm *)$tmp)->visibility;"
		end

	c_configure_serial (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct _GtkForm *)$tmp)->configure_serial;"
		end

	c_freeze_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkForm *)$tmp)->freeze_count;"
		end

feature {NONE} -- C setters

	c_set_children (tmp: POINTER; a_children: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkForm *)$tmp)->children = (struct _GList *)$a_children;"
		end

	c_set_width (tmp: POINTER; a_width: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkForm *)$tmp)->width = $a_width;"
		end

	c_set_height (tmp: POINTER; a_height: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkForm *)$tmp)->height = $a_height;"
		end

	c_set_bin_window (tmp: POINTER; a_bin_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkForm *)$tmp)->bin_window = (struct _GdkDrawable *)$a_bin_window;"
		end

	c_set_visibility (tmp: POINTER; a_visibility: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkForm *)$tmp)->visibility = $a_visibility;"
		end

	c_set_configure_serial (tmp: POINTER; a_configure_serial: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkForm *)$tmp)->configure_serial = $a_configure_serial;"
		end

	c_set_freeze_count (tmp: POINTER; a_freeze_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkForm *)$tmp)->freeze_count = $a_freeze_count;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkForm);"
		end

end
