class
	PD_GTKFORMCHILD

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	widget: CE_POINTER [SD_GTKWIDGET] assign set_widget
		do
			create Result.make_shared (c_widget (c_pointer))
		end

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window
		do
			create Result.make_shared (c_window (c_pointer))
		end

	x: INTEGER_32 assign set_x
		do
			Result := c_x (c_pointer)
		end

	y: INTEGER_32 assign set_y
		do
			Result := c_y (c_pointer)
		end

	mapped: INTEGER_32 assign set_mapped
		do
			Result := c_mapped (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_widget (a_widget: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_widget (c_pointer, a_widget.c_pointer)
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_window (c_pointer, a_window.c_pointer)
		end

	set_x (a_x: INTEGER_32)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: INTEGER_32)
		do
			c_set_y (c_pointer, a_y)
		end

	set_mapped (a_mapped: INTEGER_32)
		do
			c_set_mapped (c_pointer, a_mapped)
		end

feature {NONE} -- C getters

	c_widget (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkFormChild *)$tmp)->widget;"
		end

	c_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GtkFormChild *)$tmp)->window;"
		end

	c_x (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkFormChild *)$tmp)->x;"
		end

	c_y (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkFormChild *)$tmp)->y;"
		end

	c_mapped (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkFormChild *)$tmp)->mapped;"
		end

feature {NONE} -- C setters

	c_set_widget (tmp: POINTER; a_widget: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkFormChild *)$tmp)->widget = (struct _GtkWidget *)$a_widget;"
		end

	c_set_window (tmp: POINTER; a_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkFormChild *)$tmp)->window = (struct _GdkDrawable *)$a_window;"
		end

	c_set_x (tmp: POINTER; a_x: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkFormChild *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkFormChild *)$tmp)->y = $a_y;"
		end

	c_set_mapped (tmp: POINTER; a_mapped: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkFormChild *)$tmp)->mapped = $a_mapped;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkFormChild);"
		end

end
