class
	PD_GUI

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	in_focus: INTEGER_32 assign set_in_focus
		do
			Result := c_in_focus (c_pointer)
		end

	in_use: INTEGER_32 assign set_in_use
		do
			Result := c_in_use (c_pointer)
		end

	starting: INTEGER_32 assign set_starting
		do
			Result := c_starting (c_pointer)
		end

	shell_created: INTEGER_32 assign set_shell_created
		do
			Result := c_shell_created (c_pointer)
		end

	dying: INTEGER_32 assign set_dying
		do
			Result := c_dying (c_pointer)
		end

	dofork: INTEGER_32 assign set_dofork
		do
			Result := c_dofork (c_pointer)
		end

	dragged_sb: INTEGER_32 assign set_dragged_sb
		do
			Result := c_dragged_sb (c_pointer)
		end

	dragged_wp: CE_POINTER [PD_WINDOW_S] assign set_dragged_wp
		do
			create Result.make_shared (c_dragged_wp (c_pointer))
		end

	pointer_hidden: INTEGER_32 assign set_pointer_hidden
		do
			Result := c_pointer_hidden (c_pointer)
		end

	col: INTEGER_32 assign set_col
		do
			Result := c_col (c_pointer)
		end

	row: INTEGER_32 assign set_row
		do
			Result := c_row (c_pointer)
		end

	cursor_col: INTEGER_32 assign set_cursor_col
		do
			Result := c_cursor_col (c_pointer)
		end

	cursor_row: INTEGER_32 assign set_cursor_row
		do
			Result := c_cursor_row (c_pointer)
		end

	cursor_is_valid: INTEGER_8 assign set_cursor_is_valid
		do
			Result := c_cursor_is_valid (c_pointer)
		end

	num_cols: INTEGER_32 assign set_num_cols
		do
			Result := c_num_cols (c_pointer)
		end

	num_rows: INTEGER_32 assign set_num_rows
		do
			Result := c_num_rows (c_pointer)
		end

	scroll_region_top: INTEGER_32 assign set_scroll_region_top
		do
			Result := c_scroll_region_top (c_pointer)
		end

	scroll_region_bot: INTEGER_32 assign set_scroll_region_bot
		do
			Result := c_scroll_region_bot (c_pointer)
		end

	scroll_region_left: INTEGER_32 assign set_scroll_region_left
		do
			Result := c_scroll_region_left (c_pointer)
		end

	scroll_region_right: INTEGER_32 assign set_scroll_region_right
		do
			Result := c_scroll_region_right (c_pointer)
		end

	highlight_mask: INTEGER_32 assign set_highlight_mask
		do
			Result := c_highlight_mask (c_pointer)
		end

	scrollbar_width: INTEGER_32 assign set_scrollbar_width
		do
			Result := c_scrollbar_width (c_pointer)
		end

	scrollbar_height: INTEGER_32 assign set_scrollbar_height
		do
			Result := c_scrollbar_height (c_pointer)
		end

	left_sbar_x: INTEGER_32 assign set_left_sbar_x
		do
			Result := c_left_sbar_x (c_pointer)
		end

	right_sbar_x: INTEGER_32 assign set_right_sbar_x
		do
			Result := c_right_sbar_x (c_pointer)
		end

	menu_is_active: INTEGER_8 assign set_menu_is_active
		do
			Result := c_menu_is_active (c_pointer)
		end

	bottom_sbar: PD_GUISCROLLBAR assign set_bottom_sbar
		do
			create Result.make_shared (c_bottom_sbar (c_pointer))
		end

	bottom_sbar_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct Gui, bottom_sbar);"
		end

	which_scrollbars: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_which_scrollbars (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	prev_wrap: INTEGER_32 assign set_prev_wrap
		do
			Result := c_prev_wrap (c_pointer)
		end

	char_width: INTEGER_32 assign set_char_width
		do
			Result := c_char_width (c_pointer)
		end

	char_height: INTEGER_32 assign set_char_height
		do
			Result := c_char_height (c_pointer)
		end

	char_ascent: INTEGER_32 assign set_char_ascent
		do
			Result := c_char_ascent (c_pointer)
		end

	border_width: INTEGER_32 assign set_border_width
		do
			Result := c_border_width (c_pointer)
		end

	border_offset: INTEGER_32 assign set_border_offset
		do
			Result := c_border_offset (c_pointer)
		end

	norm_font: CE_POINTER [ANY] assign set_norm_font
		do
			create Result.make_shared (c_norm_font (c_pointer))
		end

	font_can_bold: INTEGER_32 assign set_font_can_bold
		do
			Result := c_font_can_bold (c_pointer)
		end

	wide_font: CE_POINTER [ANY] assign set_wide_font
		do
			create Result.make_shared (c_wide_font (c_pointer))
		end

	back_pixel: INTEGER_32 assign set_back_pixel
		do
			Result := c_back_pixel (c_pointer)
		end

	back_pixel_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct Gui, back_pixel);"
		end

	norm_pixel: INTEGER_32 assign set_norm_pixel
		do
			Result := c_norm_pixel (c_pointer)
		end

	norm_pixel_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct Gui, norm_pixel);"
		end

	def_back_pixel: INTEGER_32 assign set_def_back_pixel
		do
			Result := c_def_back_pixel (c_pointer)
		end

	def_norm_pixel: INTEGER_32 assign set_def_norm_pixel
		do
			Result := c_def_norm_pixel (c_pointer)
		end

	visibility: INTEGER_32 assign set_visibility
		do
			Result := c_visibility (c_pointer)
		end

	blank_pointer: CE_POINTER [SD_GDKCURSOR] assign set_blank_pointer
		do
			create Result.make_shared (c_blank_pointer (c_pointer))
		end

	geom: CE_POINTER [NATURAL_8] assign set_geom
		do
			create Result.make_shared (c_geom (c_pointer))
		end

	mainwin: CE_POINTER [SD_GTKWIDGET] assign set_mainwin
		do
			create Result.make_shared (c_mainwin (c_pointer))
		end

	formwin: CE_POINTER [SD_GTKWIDGET] assign set_formwin
		do
			create Result.make_shared (c_formwin (c_pointer))
		end

	drawarea: CE_POINTER [SD_GTKWIDGET] assign set_drawarea
		do
			create Result.make_shared (c_drawarea (c_pointer))
		end

	menubar: CE_POINTER [SD_GTKWIDGET] assign set_menubar
		do
			create Result.make_shared (c_menubar (c_pointer))
		end

	toolbar: CE_POINTER [SD_GTKWIDGET] assign set_toolbar
		do
			create Result.make_shared (c_toolbar (c_pointer))
		end

	fgcolor: CE_POINTER [SD_GDKCOLOR] assign set_fgcolor
		do
			create Result.make_shared (c_fgcolor (c_pointer))
		end

	bgcolor: CE_POINTER [SD_GDKCOLOR] assign set_bgcolor
		do
			create Result.make_shared (c_bgcolor (c_pointer))
		end

	spcolor: CE_POINTER [SD_GDKCOLOR] assign set_spcolor
		do
			create Result.make_shared (c_spcolor (c_pointer))
		end

	text_gc: CE_POINTER [SD_GDKGC] assign set_text_gc
		do
			create Result.make_shared (c_text_gc (c_pointer))
		end

	text_context: CE_POINTER [ANY] assign set_text_context
		do
			create Result.make_shared (c_text_context (c_pointer))
		end

	ascii_font: CE_POINTER [ANY] assign set_ascii_font
		do
			create Result.make_shared (c_ascii_font (c_pointer))
		end

	ascii_glyphs: CE_POINTER [SD_PANGOGLYPHSTRING] assign set_ascii_glyphs
		do
			create Result.make_shared (c_ascii_glyphs (c_pointer))
		end

	tabline: CE_POINTER [SD_GTKWIDGET] assign set_tabline
		do
			create Result.make_shared (c_tabline (c_pointer))
		end

	accel_group: CE_POINTER [SD_GTKACCELGROUP] assign set_accel_group
		do
			create Result.make_shared (c_accel_group (c_pointer))
		end

	filedlg: CE_POINTER [SD_GTKWIDGET] assign set_filedlg
		do
			create Result.make_shared (c_filedlg (c_pointer))
		end

	browse_fname: CE_POINTER [NATURAL_8] assign set_browse_fname
		do
			create Result.make_shared (c_browse_fname (c_pointer))
		end

	rsrc_input_method: CE_POINTER [INTEGER_8] assign set_rsrc_input_method
		do
			create Result.make_shared (c_rsrc_input_method (c_pointer))
		end

	rsrc_preedit_type_name: CE_POINTER [INTEGER_8] assign set_rsrc_preedit_type_name
		do
			create Result.make_shared (c_rsrc_preedit_type_name (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_in_focus (a_in_focus: INTEGER_32)
		do
			c_set_in_focus (c_pointer, a_in_focus)
		end

	set_in_use (a_in_use: INTEGER_32)
		do
			c_set_in_use (c_pointer, a_in_use)
		end

	set_starting (a_starting: INTEGER_32)
		do
			c_set_starting (c_pointer, a_starting)
		end

	set_shell_created (a_shell_created: INTEGER_32)
		do
			c_set_shell_created (c_pointer, a_shell_created)
		end

	set_dying (a_dying: INTEGER_32)
		do
			c_set_dying (c_pointer, a_dying)
		end

	set_dofork (a_dofork: INTEGER_32)
		do
			c_set_dofork (c_pointer, a_dofork)
		end

	set_dragged_sb (a_dragged_sb: INTEGER_32)
		do
			c_set_dragged_sb (c_pointer, a_dragged_sb)
		end

	set_dragged_wp (a_dragged_wp: CE_POINTER [PD_WINDOW_S])
		do
			c_set_dragged_wp (c_pointer, a_dragged_wp.c_pointer)
		end

	set_pointer_hidden (a_pointer_hidden: INTEGER_32)
		do
			c_set_pointer_hidden (c_pointer, a_pointer_hidden)
		end

	set_col (a_col: INTEGER_32)
		do
			c_set_col (c_pointer, a_col)
		end

	set_row (a_row: INTEGER_32)
		do
			c_set_row (c_pointer, a_row)
		end

	set_cursor_col (a_cursor_col: INTEGER_32)
		do
			c_set_cursor_col (c_pointer, a_cursor_col)
		end

	set_cursor_row (a_cursor_row: INTEGER_32)
		do
			c_set_cursor_row (c_pointer, a_cursor_row)
		end

	set_cursor_is_valid (a_cursor_is_valid: INTEGER_8)
		do
			c_set_cursor_is_valid (c_pointer, a_cursor_is_valid)
		end

	set_num_cols (a_num_cols: INTEGER_32)
		do
			c_set_num_cols (c_pointer, a_num_cols)
		end

	set_num_rows (a_num_rows: INTEGER_32)
		do
			c_set_num_rows (c_pointer, a_num_rows)
		end

	set_scroll_region_top (a_scroll_region_top: INTEGER_32)
		do
			c_set_scroll_region_top (c_pointer, a_scroll_region_top)
		end

	set_scroll_region_bot (a_scroll_region_bot: INTEGER_32)
		do
			c_set_scroll_region_bot (c_pointer, a_scroll_region_bot)
		end

	set_scroll_region_left (a_scroll_region_left: INTEGER_32)
		do
			c_set_scroll_region_left (c_pointer, a_scroll_region_left)
		end

	set_scroll_region_right (a_scroll_region_right: INTEGER_32)
		do
			c_set_scroll_region_right (c_pointer, a_scroll_region_right)
		end

	set_highlight_mask (a_highlight_mask: INTEGER_32)
		do
			c_set_highlight_mask (c_pointer, a_highlight_mask)
		end

	set_scrollbar_width (a_scrollbar_width: INTEGER_32)
		do
			c_set_scrollbar_width (c_pointer, a_scrollbar_width)
		end

	set_scrollbar_height (a_scrollbar_height: INTEGER_32)
		do
			c_set_scrollbar_height (c_pointer, a_scrollbar_height)
		end

	set_left_sbar_x (a_left_sbar_x: INTEGER_32)
		do
			c_set_left_sbar_x (c_pointer, a_left_sbar_x)
		end

	set_right_sbar_x (a_right_sbar_x: INTEGER_32)
		do
			c_set_right_sbar_x (c_pointer, a_right_sbar_x)
		end

	set_menu_is_active (a_menu_is_active: INTEGER_8)
		do
			c_set_menu_is_active (c_pointer, a_menu_is_active)
		end

	set_bottom_sbar (a_bottom_sbar: PD_GUISCROLLBAR)
		do
			bottom_sbar.ce_gets (a_bottom_sbar)
		end

	set_prev_wrap (a_prev_wrap: INTEGER_32)
		do
			c_set_prev_wrap (c_pointer, a_prev_wrap)
		end

	set_char_width (a_char_width: INTEGER_32)
		do
			c_set_char_width (c_pointer, a_char_width)
		end

	set_char_height (a_char_height: INTEGER_32)
		do
			c_set_char_height (c_pointer, a_char_height)
		end

	set_char_ascent (a_char_ascent: INTEGER_32)
		do
			c_set_char_ascent (c_pointer, a_char_ascent)
		end

	set_border_width (a_border_width: INTEGER_32)
		do
			c_set_border_width (c_pointer, a_border_width)
		end

	set_border_offset (a_border_offset: INTEGER_32)
		do
			c_set_border_offset (c_pointer, a_border_offset)
		end

	set_norm_font (a_norm_font: CE_POINTER [ANY])
		do
			c_set_norm_font (c_pointer, a_norm_font.c_pointer)
		end

	set_font_can_bold (a_font_can_bold: INTEGER_32)
		do
			c_set_font_can_bold (c_pointer, a_font_can_bold)
		end

	set_wide_font (a_wide_font: CE_POINTER [ANY])
		do
			c_set_wide_font (c_pointer, a_wide_font.c_pointer)
		end

	set_back_pixel (a_back_pixel: INTEGER_32)
		do
			c_set_back_pixel (c_pointer, a_back_pixel)
		end

	set_norm_pixel (a_norm_pixel: INTEGER_32)
		do
			c_set_norm_pixel (c_pointer, a_norm_pixel)
		end

	set_def_back_pixel (a_def_back_pixel: INTEGER_32)
		do
			c_set_def_back_pixel (c_pointer, a_def_back_pixel)
		end

	set_def_norm_pixel (a_def_norm_pixel: INTEGER_32)
		do
			c_set_def_norm_pixel (c_pointer, a_def_norm_pixel)
		end

	set_visibility (a_visibility: INTEGER_32)
		do
			c_set_visibility (c_pointer, a_visibility)
		end

	set_blank_pointer (a_blank_pointer: CE_POINTER [SD_GDKCURSOR])
		do
			c_set_blank_pointer (c_pointer, a_blank_pointer.c_pointer)
		end

	set_geom (a_geom: CE_POINTER [NATURAL_8])
		do
			c_set_geom (c_pointer, a_geom.c_pointer)
		end

	set_mainwin (a_mainwin: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_mainwin (c_pointer, a_mainwin.c_pointer)
		end

	set_formwin (a_formwin: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_formwin (c_pointer, a_formwin.c_pointer)
		end

	set_drawarea (a_drawarea: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_drawarea (c_pointer, a_drawarea.c_pointer)
		end

	set_menubar (a_menubar: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_menubar (c_pointer, a_menubar.c_pointer)
		end

	set_toolbar (a_toolbar: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_toolbar (c_pointer, a_toolbar.c_pointer)
		end

	set_fgcolor (a_fgcolor: CE_POINTER [SD_GDKCOLOR])
		do
			c_set_fgcolor (c_pointer, a_fgcolor.c_pointer)
		end

	set_bgcolor (a_bgcolor: CE_POINTER [SD_GDKCOLOR])
		do
			c_set_bgcolor (c_pointer, a_bgcolor.c_pointer)
		end

	set_spcolor (a_spcolor: CE_POINTER [SD_GDKCOLOR])
		do
			c_set_spcolor (c_pointer, a_spcolor.c_pointer)
		end

	set_text_gc (a_text_gc: CE_POINTER [SD_GDKGC])
		do
			c_set_text_gc (c_pointer, a_text_gc.c_pointer)
		end

	set_text_context (a_text_context: CE_POINTER [ANY])
		do
			c_set_text_context (c_pointer, a_text_context.c_pointer)
		end

	set_ascii_font (a_ascii_font: CE_POINTER [ANY])
		do
			c_set_ascii_font (c_pointer, a_ascii_font.c_pointer)
		end

	set_ascii_glyphs (a_ascii_glyphs: CE_POINTER [SD_PANGOGLYPHSTRING])
		do
			c_set_ascii_glyphs (c_pointer, a_ascii_glyphs.c_pointer)
		end

	set_tabline (a_tabline: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_tabline (c_pointer, a_tabline.c_pointer)
		end

	set_accel_group (a_accel_group: CE_POINTER [SD_GTKACCELGROUP])
		do
			c_set_accel_group (c_pointer, a_accel_group.c_pointer)
		end

	set_filedlg (a_filedlg: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_filedlg (c_pointer, a_filedlg.c_pointer)
		end

	set_browse_fname (a_browse_fname: CE_POINTER [NATURAL_8])
		do
			c_set_browse_fname (c_pointer, a_browse_fname.c_pointer)
		end

	set_rsrc_input_method (a_rsrc_input_method: CE_POINTER [INTEGER_8])
		do
			c_set_rsrc_input_method (c_pointer, a_rsrc_input_method.c_pointer)
		end

	set_rsrc_preedit_type_name (a_rsrc_preedit_type_name: CE_POINTER [INTEGER_8])
		do
			c_set_rsrc_preedit_type_name (c_pointer, a_rsrc_preedit_type_name.c_pointer)
		end

feature {NONE} -- C getters

	c_in_focus (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->in_focus;"
		end

	c_in_use (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->in_use;"
		end

	c_starting (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->starting;"
		end

	c_shell_created (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->shell_created;"
		end

	c_dying (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->dying;"
		end

	c_dofork (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->dofork;"
		end

	c_dragged_sb (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->dragged_sb;"
		end

	c_dragged_wp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct window_S *)((struct Gui *)$tmp)->dragged_wp;"
		end

	c_pointer_hidden (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->pointer_hidden;"
		end

	c_col (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->col;"
		end

	c_row (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->row;"
		end

	c_cursor_col (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->cursor_col;"
		end

	c_cursor_row (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->cursor_row;"
		end

	c_cursor_is_valid (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct Gui *)$tmp)->cursor_is_valid;"
		end

	c_num_cols (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->num_cols;"
		end

	c_num_rows (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->num_rows;"
		end

	c_scroll_region_top (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->scroll_region_top;"
		end

	c_scroll_region_bot (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->scroll_region_bot;"
		end

	c_scroll_region_left (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->scroll_region_left;"
		end

	c_scroll_region_right (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->scroll_region_right;"
		end

	c_highlight_mask (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->highlight_mask;"
		end

	c_scrollbar_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->scrollbar_width;"
		end

	c_scrollbar_height (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->scrollbar_height;"
		end

	c_left_sbar_x (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->left_sbar_x;"
		end

	c_right_sbar_x (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->right_sbar_x;"
		end

	c_menu_is_active (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct Gui *)$tmp)->menu_is_active;"
		end

	c_bottom_sbar (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct GuiScrollbar *)&((struct Gui *)$tmp)->bottom_sbar;"
		end

	c_which_scrollbars (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct Gui *tmp = (struct Gui *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->which_scrollbars) / sizeof(tmp->which_scrollbars[0]);
				return tmp->which_scrollbars;
			]"
		end

	c_prev_wrap (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->prev_wrap;"
		end

	c_char_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->char_width;"
		end

	c_char_height (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->char_height;"
		end

	c_char_ascent (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->char_ascent;"
		end

	c_border_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->border_width;"
		end

	c_border_offset (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->border_offset;"
		end

	c_norm_font (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct Gui *)$tmp)->norm_font;"
		end

	c_font_can_bold (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->font_can_bold;"
		end

	c_wide_font (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct Gui *)$tmp)->wide_font;"
		end

	c_back_pixel (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct Gui *)$tmp)->back_pixel;"
		end

	c_norm_pixel (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct Gui *)$tmp)->norm_pixel;"
		end

	c_def_back_pixel (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct Gui *)$tmp)->def_back_pixel;"
		end

	c_def_norm_pixel (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct Gui *)$tmp)->def_norm_pixel;"
		end

	c_visibility (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Gui *)$tmp)->visibility;"
		end

	c_blank_pointer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkCursor *)((struct Gui *)$tmp)->blank_pointer;"
		end

	c_geom (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct Gui *)$tmp)->geom;"
		end

	c_mainwin (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct Gui *)$tmp)->mainwin;"
		end

	c_formwin (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct Gui *)$tmp)->formwin;"
		end

	c_drawarea (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct Gui *)$tmp)->drawarea;"
		end

	c_menubar (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct Gui *)$tmp)->menubar;"
		end

	c_toolbar (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct Gui *)$tmp)->toolbar;"
		end

	c_fgcolor (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkColor *)((struct Gui *)$tmp)->fgcolor;"
		end

	c_bgcolor (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkColor *)((struct Gui *)$tmp)->bgcolor;"
		end

	c_spcolor (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkColor *)((struct Gui *)$tmp)->spcolor;"
		end

	c_text_gc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkGC *)((struct Gui *)$tmp)->text_gc;"
		end

	c_text_context (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct Gui *)$tmp)->text_context;"
		end

	c_ascii_font (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct Gui *)$tmp)->ascii_font;"
		end

	c_ascii_glyphs (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _PangoGlyphString *)((struct Gui *)$tmp)->ascii_glyphs;"
		end

	c_tabline (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct Gui *)$tmp)->tabline;"
		end

	c_accel_group (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkAccelGroup *)((struct Gui *)$tmp)->accel_group;"
		end

	c_filedlg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct Gui *)$tmp)->filedlg;"
		end

	c_browse_fname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct Gui *)$tmp)->browse_fname;"
		end

	c_rsrc_input_method (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct Gui *)$tmp)->rsrc_input_method;"
		end

	c_rsrc_preedit_type_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct Gui *)$tmp)->rsrc_preedit_type_name;"
		end

feature {NONE} -- C setters

	c_set_in_focus (tmp: POINTER; a_in_focus: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->in_focus = $a_in_focus;"
		end

	c_set_in_use (tmp: POINTER; a_in_use: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->in_use = $a_in_use;"
		end

	c_set_starting (tmp: POINTER; a_starting: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->starting = $a_starting;"
		end

	c_set_shell_created (tmp: POINTER; a_shell_created: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->shell_created = $a_shell_created;"
		end

	c_set_dying (tmp: POINTER; a_dying: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->dying = $a_dying;"
		end

	c_set_dofork (tmp: POINTER; a_dofork: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->dofork = $a_dofork;"
		end

	c_set_dragged_sb (tmp: POINTER; a_dragged_sb: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->dragged_sb = $a_dragged_sb;"
		end

	c_set_dragged_wp (tmp: POINTER; a_dragged_wp: POINTER)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->dragged_wp = (struct window_S *)$a_dragged_wp;"
		end

	c_set_pointer_hidden (tmp: POINTER; a_pointer_hidden: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->pointer_hidden = $a_pointer_hidden;"
		end

	c_set_col (tmp: POINTER; a_col: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->col = $a_col;"
		end

	c_set_row (tmp: POINTER; a_row: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->row = $a_row;"
		end

	c_set_cursor_col (tmp: POINTER; a_cursor_col: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->cursor_col = $a_cursor_col;"
		end

	c_set_cursor_row (tmp: POINTER; a_cursor_row: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->cursor_row = $a_cursor_row;"
		end

	c_set_cursor_is_valid (tmp: POINTER; a_cursor_is_valid: INTEGER_8)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->cursor_is_valid = $a_cursor_is_valid;"
		end

	c_set_num_cols (tmp: POINTER; a_num_cols: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->num_cols = $a_num_cols;"
		end

	c_set_num_rows (tmp: POINTER; a_num_rows: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->num_rows = $a_num_rows;"
		end

	c_set_scroll_region_top (tmp: POINTER; a_scroll_region_top: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->scroll_region_top = $a_scroll_region_top;"
		end

	c_set_scroll_region_bot (tmp: POINTER; a_scroll_region_bot: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->scroll_region_bot = $a_scroll_region_bot;"
		end

	c_set_scroll_region_left (tmp: POINTER; a_scroll_region_left: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->scroll_region_left = $a_scroll_region_left;"
		end

	c_set_scroll_region_right (tmp: POINTER; a_scroll_region_right: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->scroll_region_right = $a_scroll_region_right;"
		end

	c_set_highlight_mask (tmp: POINTER; a_highlight_mask: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->highlight_mask = $a_highlight_mask;"
		end

	c_set_scrollbar_width (tmp: POINTER; a_scrollbar_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->scrollbar_width = $a_scrollbar_width;"
		end

	c_set_scrollbar_height (tmp: POINTER; a_scrollbar_height: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->scrollbar_height = $a_scrollbar_height;"
		end

	c_set_left_sbar_x (tmp: POINTER; a_left_sbar_x: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->left_sbar_x = $a_left_sbar_x;"
		end

	c_set_right_sbar_x (tmp: POINTER; a_right_sbar_x: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->right_sbar_x = $a_right_sbar_x;"
		end

	c_set_menu_is_active (tmp: POINTER; a_menu_is_active: INTEGER_8)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->menu_is_active = $a_menu_is_active;"
		end

	c_set_prev_wrap (tmp: POINTER; a_prev_wrap: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->prev_wrap = $a_prev_wrap;"
		end

	c_set_char_width (tmp: POINTER; a_char_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->char_width = $a_char_width;"
		end

	c_set_char_height (tmp: POINTER; a_char_height: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->char_height = $a_char_height;"
		end

	c_set_char_ascent (tmp: POINTER; a_char_ascent: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->char_ascent = $a_char_ascent;"
		end

	c_set_border_width (tmp: POINTER; a_border_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->border_width = $a_border_width;"
		end

	c_set_border_offset (tmp: POINTER; a_border_offset: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->border_offset = $a_border_offset;"
		end

	c_set_norm_font (tmp: POINTER; a_norm_font: POINTER)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->norm_font = (void *)$a_norm_font;"
		end

	c_set_font_can_bold (tmp: POINTER; a_font_can_bold: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->font_can_bold = $a_font_can_bold;"
		end

	c_set_wide_font (tmp: POINTER; a_wide_font: POINTER)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->wide_font = (void *)$a_wide_font;"
		end

	c_set_back_pixel (tmp: POINTER; a_back_pixel: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->back_pixel = $a_back_pixel;"
		end

	c_set_norm_pixel (tmp: POINTER; a_norm_pixel: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->norm_pixel = $a_norm_pixel;"
		end

	c_set_def_back_pixel (tmp: POINTER; a_def_back_pixel: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->def_back_pixel = $a_def_back_pixel;"
		end

	c_set_def_norm_pixel (tmp: POINTER; a_def_norm_pixel: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->def_norm_pixel = $a_def_norm_pixel;"
		end

	c_set_visibility (tmp: POINTER; a_visibility: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->visibility = $a_visibility;"
		end

	c_set_blank_pointer (tmp: POINTER; a_blank_pointer: POINTER)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->blank_pointer = (struct _GdkCursor *)$a_blank_pointer;"
		end

	c_set_geom (tmp: POINTER; a_geom: POINTER)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->geom = (unsigned char *)$a_geom;"
		end

	c_set_mainwin (tmp: POINTER; a_mainwin: POINTER)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->mainwin = (struct _GtkWidget *)$a_mainwin;"
		end

	c_set_formwin (tmp: POINTER; a_formwin: POINTER)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->formwin = (struct _GtkWidget *)$a_formwin;"
		end

	c_set_drawarea (tmp: POINTER; a_drawarea: POINTER)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->drawarea = (struct _GtkWidget *)$a_drawarea;"
		end

	c_set_menubar (tmp: POINTER; a_menubar: POINTER)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->menubar = (struct _GtkWidget *)$a_menubar;"
		end

	c_set_toolbar (tmp: POINTER; a_toolbar: POINTER)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->toolbar = (struct _GtkWidget *)$a_toolbar;"
		end

	c_set_fgcolor (tmp: POINTER; a_fgcolor: POINTER)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->fgcolor = (struct _GdkColor *)$a_fgcolor;"
		end

	c_set_bgcolor (tmp: POINTER; a_bgcolor: POINTER)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->bgcolor = (struct _GdkColor *)$a_bgcolor;"
		end

	c_set_spcolor (tmp: POINTER; a_spcolor: POINTER)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->spcolor = (struct _GdkColor *)$a_spcolor;"
		end

	c_set_text_gc (tmp: POINTER; a_text_gc: POINTER)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->text_gc = (struct _GdkGC *)$a_text_gc;"
		end

	c_set_text_context (tmp: POINTER; a_text_context: POINTER)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->text_context = (void *)$a_text_context;"
		end

	c_set_ascii_font (tmp: POINTER; a_ascii_font: POINTER)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->ascii_font = (void *)$a_ascii_font;"
		end

	c_set_ascii_glyphs (tmp: POINTER; a_ascii_glyphs: POINTER)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->ascii_glyphs = (struct _PangoGlyphString *)$a_ascii_glyphs;"
		end

	c_set_tabline (tmp: POINTER; a_tabline: POINTER)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->tabline = (struct _GtkWidget *)$a_tabline;"
		end

	c_set_accel_group (tmp: POINTER; a_accel_group: POINTER)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->accel_group = (struct _GtkAccelGroup *)$a_accel_group;"
		end

	c_set_filedlg (tmp: POINTER; a_filedlg: POINTER)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->filedlg = (struct _GtkWidget *)$a_filedlg;"
		end

	c_set_browse_fname (tmp: POINTER; a_browse_fname: POINTER)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->browse_fname = (unsigned char *)$a_browse_fname;"
		end

	c_set_rsrc_input_method (tmp: POINTER; a_rsrc_input_method: POINTER)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->rsrc_input_method = (char *)$a_rsrc_input_method;"
		end

	c_set_rsrc_preedit_type_name (tmp: POINTER; a_rsrc_preedit_type_name: POINTER)
		external
			"C inline"
		alias
			"((struct Gui *)$tmp)->rsrc_preedit_type_name = (char *)$a_rsrc_preedit_type_name;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct Gui);"
		end

end
