class
	PD_HASHITEM_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	hi_hash: NATURAL_32 assign set_hi_hash
		do
			Result := c_hi_hash (c_pointer)
		end

	hi_key: CE_POINTER [NATURAL_8] assign set_hi_key
		do
			create Result.make_shared (c_hi_key (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_hi_hash (a_hi_hash: NATURAL_32)
		do
			c_set_hi_hash (c_pointer, a_hi_hash)
		end

	set_hi_key (a_hi_key: CE_POINTER [NATURAL_8])
		do
			c_set_hi_key (c_pointer, a_hi_key.c_pointer)
		end

feature {NONE} -- C getters

	c_hi_hash (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct hashitem_S *)$tmp)->hi_hash;"
		end

	c_hi_key (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct hashitem_S *)$tmp)->hi_key;"
		end

feature {NONE} -- C setters

	c_set_hi_hash (tmp: POINTER; a_hi_hash: NATURAL_32)
		external
			"C inline"
		alias
			"((struct hashitem_S *)$tmp)->hi_hash = $a_hi_hash;"
		end

	c_set_hi_key (tmp: POINTER; a_hi_key: POINTER)
		external
			"C inline"
		alias
			"((struct hashitem_S *)$tmp)->hi_key = (unsigned char *)$a_hi_key;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct hashitem_S);"
		end

end
