class
	PD_HASHTABLE_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ht_mask: NATURAL_32 assign set_ht_mask
		do
			Result := c_ht_mask (c_pointer)
		end

	ht_used: NATURAL_32 assign set_ht_used
		do
			Result := c_ht_used (c_pointer)
		end

	ht_filled: NATURAL_32 assign set_ht_filled
		do
			Result := c_ht_filled (c_pointer)
		end

	ht_locked: INTEGER_32 assign set_ht_locked
		do
			Result := c_ht_locked (c_pointer)
		end

	ht_error: INTEGER_32 assign set_ht_error
		do
			Result := c_ht_error (c_pointer)
		end

	ht_array: CE_POINTER [PD_HASHITEM_S] assign set_ht_array
		do
			create Result.make_shared (c_ht_array (c_pointer))
		end

	ht_smallarray: CE_ARRAY [PD_HASHITEM_S]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_ht_smallarray (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_ht_mask (a_ht_mask: NATURAL_32)
		do
			c_set_ht_mask (c_pointer, a_ht_mask)
		end

	set_ht_used (a_ht_used: NATURAL_32)
		do
			c_set_ht_used (c_pointer, a_ht_used)
		end

	set_ht_filled (a_ht_filled: NATURAL_32)
		do
			c_set_ht_filled (c_pointer, a_ht_filled)
		end

	set_ht_locked (a_ht_locked: INTEGER_32)
		do
			c_set_ht_locked (c_pointer, a_ht_locked)
		end

	set_ht_error (a_ht_error: INTEGER_32)
		do
			c_set_ht_error (c_pointer, a_ht_error)
		end

	set_ht_array (a_ht_array: CE_POINTER [PD_HASHITEM_S])
		do
			c_set_ht_array (c_pointer, a_ht_array.c_pointer)
		end

feature {NONE} -- C getters

	c_ht_mask (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct hashtable_S *)$tmp)->ht_mask;"
		end

	c_ht_used (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct hashtable_S *)$tmp)->ht_used;"
		end

	c_ht_filled (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct hashtable_S *)$tmp)->ht_filled;"
		end

	c_ht_locked (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct hashtable_S *)$tmp)->ht_locked;"
		end

	c_ht_error (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct hashtable_S *)$tmp)->ht_error;"
		end

	c_ht_array (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct hashitem_S *)((struct hashtable_S *)$tmp)->ht_array;"
		end

	c_ht_smallarray (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct hashtable_S *tmp = (struct hashtable_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->ht_smallarray) / sizeof(tmp->ht_smallarray[0]);
				return tmp->ht_smallarray;
			]"
		end

feature {NONE} -- C setters

	c_set_ht_mask (tmp: POINTER; a_ht_mask: NATURAL_32)
		external
			"C inline"
		alias
			"((struct hashtable_S *)$tmp)->ht_mask = $a_ht_mask;"
		end

	c_set_ht_used (tmp: POINTER; a_ht_used: NATURAL_32)
		external
			"C inline"
		alias
			"((struct hashtable_S *)$tmp)->ht_used = $a_ht_used;"
		end

	c_set_ht_filled (tmp: POINTER; a_ht_filled: NATURAL_32)
		external
			"C inline"
		alias
			"((struct hashtable_S *)$tmp)->ht_filled = $a_ht_filled;"
		end

	c_set_ht_locked (tmp: POINTER; a_ht_locked: INTEGER_32)
		external
			"C inline"
		alias
			"((struct hashtable_S *)$tmp)->ht_locked = $a_ht_locked;"
		end

	c_set_ht_error (tmp: POINTER; a_ht_error: INTEGER_32)
		external
			"C inline"
		alias
			"((struct hashtable_S *)$tmp)->ht_error = $a_ht_error;"
		end

	c_set_ht_array (tmp: POINTER; a_ht_array: POINTER)
		external
			"C inline"
		alias
			"((struct hashtable_S *)$tmp)->ht_array = (struct hashitem_S *)$a_ht_array;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct hashtable_S);"
		end

end
