class
	PD_KEYENTRY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ke_next: CE_POINTER [PD_KEYENTRY] assign set_ke_next
		do
			create Result.make_shared (c_ke_next (c_pointer))
		end

	k_syn: PD_SP_SYN assign set_k_syn
		do
			create Result.make_shared (c_k_syn (c_pointer))
		end

	k_syn_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct keyentry, k_syn);"
		end

	next_list: CE_POINTER [INTEGER_16] assign set_next_list
		do
			create Result.make_shared (c_next_list (c_pointer))
		end

	flags: INTEGER_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	k_char: INTEGER_32 assign set_k_char
		do
			Result := c_k_char (c_pointer)
		end

	keyword: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_keyword (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_ke_next (a_ke_next: CE_POINTER [PD_KEYENTRY])
		do
			c_set_ke_next (c_pointer, a_ke_next.c_pointer)
		end

	set_k_syn (a_k_syn: PD_SP_SYN)
		do
			k_syn.ce_gets (a_k_syn)
		end

	set_next_list (a_next_list: CE_POINTER [INTEGER_16])
		do
			c_set_next_list (c_pointer, a_next_list.c_pointer)
		end

	set_flags (a_flags: INTEGER_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

	set_k_char (a_k_char: INTEGER_32)
		do
			c_set_k_char (c_pointer, a_k_char)
		end

feature {NONE} -- C getters

	c_ke_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct keyentry *)((struct keyentry *)$tmp)->ke_next;"
		end

	c_k_syn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct sp_syn *)&((struct keyentry *)$tmp)->k_syn;"
		end

	c_next_list (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (short *)((struct keyentry *)$tmp)->next_list;"
		end

	c_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct keyentry *)$tmp)->flags;"
		end

	c_k_char (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct keyentry *)$tmp)->k_char;"
		end

	c_keyword (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct keyentry *tmp = (struct keyentry *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->keyword) / sizeof(tmp->keyword[0]);
				return tmp->keyword;
			]"
		end

feature {NONE} -- C setters

	c_set_ke_next (tmp: POINTER; a_ke_next: POINTER)
		external
			"C inline"
		alias
			"((struct keyentry *)$tmp)->ke_next = (struct keyentry *)$a_ke_next;"
		end

	c_set_next_list (tmp: POINTER; a_next_list: POINTER)
		external
			"C inline"
		alias
			"((struct keyentry *)$tmp)->next_list = (short *)$a_next_list;"
		end

	c_set_flags (tmp: POINTER; a_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct keyentry *)$tmp)->flags = $a_flags;"
		end

	c_set_k_char (tmp: POINTER; a_k_char: INTEGER_32)
		external
			"C inline"
		alias
			"((struct keyentry *)$tmp)->k_char = $a_k_char;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct keyentry);"
		end

end
