class
	PD_KEYQUEUE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	keystr: CE_POINTER [NATURAL_8] assign set_keystr
		do
			create Result.make_shared (c_keystr (c_pointer))
		end

	next: CE_POINTER [PD_KEYQUEUE] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_KEYQUEUE] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_keystr (a_keystr: CE_POINTER [NATURAL_8])
		do
			c_set_keystr (c_pointer, a_keystr.c_pointer)
		end

	set_next (a_next: CE_POINTER [PD_KEYQUEUE])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_KEYQUEUE])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

feature {NONE} -- C getters

	c_keystr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct keyqueue *)$tmp)->keystr;"
		end

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct keyqueue *)((struct keyqueue *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct keyqueue *)((struct keyqueue *)$tmp)->prev;"
		end

feature {NONE} -- C setters

	c_set_keystr (tmp: POINTER; a_keystr: POINTER)
		external
			"C inline"
		alias
			"((struct keyqueue *)$tmp)->keystr = (unsigned char *)$a_keystr;"
		end

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct keyqueue *)$tmp)->next = (struct keyqueue *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct keyqueue *)$tmp)->prev = (struct keyqueue *)$a_prev;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct keyqueue);"
		end

end
