class
	PD_LANGP_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	lp_slang: CE_POINTER [PD_SLANG_S] assign set_lp_slang
		do
			create Result.make_shared (c_lp_slang (c_pointer))
		end

	lp_sallang: CE_POINTER [PD_SLANG_S] assign set_lp_sallang
		do
			create Result.make_shared (c_lp_sallang (c_pointer))
		end

	lp_replang: CE_POINTER [PD_SLANG_S] assign set_lp_replang
		do
			create Result.make_shared (c_lp_replang (c_pointer))
		end

	lp_region: INTEGER_32 assign set_lp_region
		do
			Result := c_lp_region (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_lp_slang (a_lp_slang: CE_POINTER [PD_SLANG_S])
		do
			c_set_lp_slang (c_pointer, a_lp_slang.c_pointer)
		end

	set_lp_sallang (a_lp_sallang: CE_POINTER [PD_SLANG_S])
		do
			c_set_lp_sallang (c_pointer, a_lp_sallang.c_pointer)
		end

	set_lp_replang (a_lp_replang: CE_POINTER [PD_SLANG_S])
		do
			c_set_lp_replang (c_pointer, a_lp_replang.c_pointer)
		end

	set_lp_region (a_lp_region: INTEGER_32)
		do
			c_set_lp_region (c_pointer, a_lp_region)
		end

feature {NONE} -- C getters

	c_lp_slang (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct slang_S *)((struct langp_S *)$tmp)->lp_slang;"
		end

	c_lp_sallang (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct slang_S *)((struct langp_S *)$tmp)->lp_sallang;"
		end

	c_lp_replang (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct slang_S *)((struct langp_S *)$tmp)->lp_replang;"
		end

	c_lp_region (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct langp_S *)$tmp)->lp_region;"
		end

feature {NONE} -- C setters

	c_set_lp_slang (tmp: POINTER; a_lp_slang: POINTER)
		external
			"C inline"
		alias
			"((struct langp_S *)$tmp)->lp_slang = (struct slang_S *)$a_lp_slang;"
		end

	c_set_lp_sallang (tmp: POINTER; a_lp_sallang: POINTER)
		external
			"C inline"
		alias
			"((struct langp_S *)$tmp)->lp_sallang = (struct slang_S *)$a_lp_sallang;"
		end

	c_set_lp_replang (tmp: POINTER; a_lp_replang: POINTER)
		external
			"C inline"
		alias
			"((struct langp_S *)$tmp)->lp_replang = (struct slang_S *)$a_lp_replang;"
		end

	c_set_lp_region (tmp: POINTER; a_lp_region: INTEGER_32)
		external
			"C inline"
		alias
			"((struct langp_S *)$tmp)->lp_region = $a_lp_region;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct langp_S);"
		end

end
