class
	PD_LOOP_COOKIE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	lines_gap: CE_POINTER [PD_GROWARRAY] assign set_lines_gap
		do
			create Result.make_shared (c_lines_gap (c_pointer))
		end

	current_line: INTEGER_32 assign set_current_line
		do
			Result := c_current_line (c_pointer)
		end

	repeating: INTEGER_32 assign set_repeating
		do
			Result := c_repeating (c_pointer)
		end

	getline: CE_ROUTINE assign set_getline
		do
			create Result.make_shared (c_getline (c_pointer))
		end

	cookie: CE_POINTER [ANY] assign set_cookie
		do
			create Result.make_shared (c_cookie (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_lines_gap (a_lines_gap: CE_POINTER [PD_GROWARRAY])
		do
			c_set_lines_gap (c_pointer, a_lines_gap.c_pointer)
		end

	set_current_line (a_current_line: INTEGER_32)
		do
			c_set_current_line (c_pointer, a_current_line)
		end

	set_repeating (a_repeating: INTEGER_32)
		do
			c_set_repeating (c_pointer, a_repeating)
		end

	set_getline (a_getline: CE_ROUTINE)
		do
			c_set_getline (c_pointer, a_getline.c_pointer)
		end

	set_cookie (a_cookie: CE_POINTER [ANY])
		do
			c_set_cookie (c_pointer, a_cookie.c_pointer)
		end

feature {NONE} -- C getters

	c_lines_gap (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)((struct loop_cookie *)$tmp)->lines_gap;"
		end

	c_current_line (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct loop_cookie *)$tmp)->current_line;"
		end

	c_repeating (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct loop_cookie *)$tmp)->repeating;"
		end

	c_getline (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *( *)(int, void *, int))((struct loop_cookie *)$tmp)->getline;"
		end

	c_cookie (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct loop_cookie *)$tmp)->cookie;"
		end

feature {NONE} -- C setters

	c_set_lines_gap (tmp: POINTER; a_lines_gap: POINTER)
		external
			"C inline"
		alias
			"((struct loop_cookie *)$tmp)->lines_gap = (struct growarray *)$a_lines_gap;"
		end

	c_set_current_line (tmp: POINTER; a_current_line: INTEGER_32)
		external
			"C inline"
		alias
			"((struct loop_cookie *)$tmp)->current_line = $a_current_line;"
		end

	c_set_repeating (tmp: POINTER; a_repeating: INTEGER_32)
		external
			"C inline"
		alias
			"((struct loop_cookie *)$tmp)->repeating = $a_repeating;"
		end

	c_set_getline (tmp: POINTER; a_getline: POINTER)
		external
			"C inline"
		alias
			"((struct loop_cookie *)$tmp)->getline = (unsigned char *( *)(int, void *, int))$a_getline;"
		end

	c_set_cookie (tmp: POINTER; a_cookie: POINTER)
		external
			"C inline"
		alias
			"((struct loop_cookie *)$tmp)->cookie = (void *)$a_cookie;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct loop_cookie);"
		end

end
