class
	PD_MAPBLOCK

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	m_next: CE_POINTER [PD_MAPBLOCK] assign set_m_next
		do
			create Result.make_shared (c_m_next (c_pointer))
		end

	m_next_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct mapblock, m_next);"
		end

	m_keys: CE_POINTER [NATURAL_8] assign set_m_keys
		do
			create Result.make_shared (c_m_keys (c_pointer))
		end

	m_keylen: INTEGER_32 assign set_m_keylen
		do
			Result := c_m_keylen (c_pointer)
		end

	m_str: CE_POINTER [NATURAL_8] assign set_m_str
		do
			create Result.make_shared (c_m_str (c_pointer))
		end

	m_mode: INTEGER_32 assign set_m_mode
		do
			Result := c_m_mode (c_pointer)
		end

	m_noremap: INTEGER_32 assign set_m_noremap
		do
			Result := c_m_noremap (c_pointer)
		end

	m_silent: INTEGER_8 assign set_m_silent
		do
			Result := c_m_silent (c_pointer)
		end

	m_expr: INTEGER_8 assign set_m_expr
		do
			Result := c_m_expr (c_pointer)
		end

	m_script_ID: INTEGER_32 assign set_m_script_ID
		do
			Result := c_m_script_ID (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_m_next (a_m_next: CE_POINTER [PD_MAPBLOCK])
		do
			c_set_m_next (c_pointer, a_m_next.c_pointer)
		end

	set_m_keys (a_m_keys: CE_POINTER [NATURAL_8])
		do
			c_set_m_keys (c_pointer, a_m_keys.c_pointer)
		end

	set_m_keylen (a_m_keylen: INTEGER_32)
		do
			c_set_m_keylen (c_pointer, a_m_keylen)
		end

	set_m_str (a_m_str: CE_POINTER [NATURAL_8])
		do
			c_set_m_str (c_pointer, a_m_str.c_pointer)
		end

	set_m_mode (a_m_mode: INTEGER_32)
		do
			c_set_m_mode (c_pointer, a_m_mode)
		end

	set_m_noremap (a_m_noremap: INTEGER_32)
		do
			c_set_m_noremap (c_pointer, a_m_noremap)
		end

	set_m_silent (a_m_silent: INTEGER_8)
		do
			c_set_m_silent (c_pointer, a_m_silent)
		end

	set_m_expr (a_m_expr: INTEGER_8)
		do
			c_set_m_expr (c_pointer, a_m_expr)
		end

	set_m_script_ID (a_m_script_ID: INTEGER_32)
		do
			c_set_m_script_ID (c_pointer, a_m_script_ID)
		end

feature {NONE} -- C getters

	c_m_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct mapblock *)((struct mapblock *)$tmp)->m_next;"
		end

	c_m_keys (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct mapblock *)$tmp)->m_keys;"
		end

	c_m_keylen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct mapblock *)$tmp)->m_keylen;"
		end

	c_m_str (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct mapblock *)$tmp)->m_str;"
		end

	c_m_mode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct mapblock *)$tmp)->m_mode;"
		end

	c_m_noremap (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct mapblock *)$tmp)->m_noremap;"
		end

	c_m_silent (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct mapblock *)$tmp)->m_silent;"
		end

	c_m_expr (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct mapblock *)$tmp)->m_expr;"
		end

	c_m_script_ID (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct mapblock *)$tmp)->m_script_ID;"
		end

feature {NONE} -- C setters

	c_set_m_next (tmp: POINTER; a_m_next: POINTER)
		external
			"C inline"
		alias
			"((struct mapblock *)$tmp)->m_next = (struct mapblock *)$a_m_next;"
		end

	c_set_m_keys (tmp: POINTER; a_m_keys: POINTER)
		external
			"C inline"
		alias
			"((struct mapblock *)$tmp)->m_keys = (unsigned char *)$a_m_keys;"
		end

	c_set_m_keylen (tmp: POINTER; a_m_keylen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct mapblock *)$tmp)->m_keylen = $a_m_keylen;"
		end

	c_set_m_str (tmp: POINTER; a_m_str: POINTER)
		external
			"C inline"
		alias
			"((struct mapblock *)$tmp)->m_str = (unsigned char *)$a_m_str;"
		end

	c_set_m_mode (tmp: POINTER; a_m_mode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct mapblock *)$tmp)->m_mode = $a_m_mode;"
		end

	c_set_m_noremap (tmp: POINTER; a_m_noremap: INTEGER_32)
		external
			"C inline"
		alias
			"((struct mapblock *)$tmp)->m_noremap = $a_m_noremap;"
		end

	c_set_m_silent (tmp: POINTER; a_m_silent: INTEGER_8)
		external
			"C inline"
		alias
			"((struct mapblock *)$tmp)->m_silent = $a_m_silent;"
		end

	c_set_m_expr (tmp: POINTER; a_m_expr: INTEGER_8)
		external
			"C inline"
		alias
			"((struct mapblock *)$tmp)->m_expr = $a_m_expr;"
		end

	c_set_m_script_ID (tmp: POINTER; a_m_script_ID: INTEGER_32)
		external
			"C inline"
		alias
			"((struct mapblock *)$tmp)->m_script_ID = $a_m_script_id;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct mapblock);"
		end

end
