class
	PD_MATCH_FOUND

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	len: INTEGER_32 assign set_len
		do
			Result := c_len (c_pointer)
		end

	match: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_match (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_len (a_len: INTEGER_32)
		do
			c_set_len (c_pointer, a_len)
		end

feature {NONE} -- C getters

	c_len (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct match_found *)$tmp)->len;"
		end

	c_match (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct match_found *tmp = (struct match_found *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->match) / sizeof(tmp->match[0]);
				return tmp->match;
			]"
		end

feature {NONE} -- C setters

	c_set_len (tmp: POINTER; a_len: INTEGER_32)
		external
			"C inline"
		alias
			"((struct match_found *)$tmp)->len = $a_len;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct match_found);"
		end

end
