class
	PD_MATCHITEM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_MATCHITEM] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	id: INTEGER_32 assign set_id
		do
			Result := c_id (c_pointer)
		end

	priority: INTEGER_32 assign set_priority
		do
			Result := c_priority (c_pointer)
		end

	pattern: CE_POINTER [NATURAL_8] assign set_pattern
		do
			create Result.make_shared (c_pattern (c_pointer))
		end

	hlg_id: INTEGER_32 assign set_hlg_id
		do
			Result := c_hlg_id (c_pointer)
		end

	match: PD_REGMMATCH_T assign set_match
		do
			create Result.make_shared (c_match (c_pointer))
		end

	hl: PD_MATCH_T assign set_hl
		do
			create Result.make_shared (c_hl (c_pointer))
		end

	hl_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct matchitem, hl);"
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_MATCHITEM])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_id (a_id: INTEGER_32)
		do
			c_set_id (c_pointer, a_id)
		end

	set_priority (a_priority: INTEGER_32)
		do
			c_set_priority (c_pointer, a_priority)
		end

	set_pattern (a_pattern: CE_POINTER [NATURAL_8])
		do
			c_set_pattern (c_pointer, a_pattern.c_pointer)
		end

	set_hlg_id (a_hlg_id: INTEGER_32)
		do
			c_set_hlg_id (c_pointer, a_hlg_id)
		end

	set_match (a_match: PD_REGMMATCH_T)
		do
			match.ce_gets (a_match)
		end

	set_hl (a_hl: PD_MATCH_T)
		do
			hl.ce_gets (a_hl)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct matchitem *)((struct matchitem *)$tmp)->next;"
		end

	c_id (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct matchitem *)$tmp)->id;"
		end

	c_priority (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct matchitem *)$tmp)->priority;"
		end

	c_pattern (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct matchitem *)$tmp)->pattern;"
		end

	c_hlg_id (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct matchitem *)$tmp)->hlg_id;"
		end

	c_match (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (regmmatch_T *)&((struct matchitem *)$tmp)->match;"
		end

	c_hl (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (match_T *)&((struct matchitem *)$tmp)->hl;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct matchitem *)$tmp)->next = (struct matchitem *)$a_next;"
		end

	c_set_id (tmp: POINTER; a_id: INTEGER_32)
		external
			"C inline"
		alias
			"((struct matchitem *)$tmp)->id = $a_id;"
		end

	c_set_priority (tmp: POINTER; a_priority: INTEGER_32)
		external
			"C inline"
		alias
			"((struct matchitem *)$tmp)->priority = $a_priority;"
		end

	c_set_pattern (tmp: POINTER; a_pattern: POINTER)
		external
			"C inline"
		alias
			"((struct matchitem *)$tmp)->pattern = (unsigned char *)$a_pattern;"
		end

	c_set_hlg_id (tmp: POINTER; a_hlg_id: INTEGER_32)
		external
			"C inline"
		alias
			"((struct matchitem *)$tmp)->hlg_id = $a_hlg_id;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct matchitem);"
		end

end
