class
	PD_MEMFILE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	mf_fname: CE_POINTER [NATURAL_8] assign set_mf_fname
		do
			create Result.make_shared (c_mf_fname (c_pointer))
		end

	mf_ffname: CE_POINTER [NATURAL_8] assign set_mf_ffname
		do
			create Result.make_shared (c_mf_ffname (c_pointer))
		end

	mf_fd: INTEGER_32 assign set_mf_fd
		do
			Result := c_mf_fd (c_pointer)
		end

	mf_free_first: CE_POINTER [PD_BLOCK_HDR] assign set_mf_free_first
		do
			create Result.make_shared (c_mf_free_first (c_pointer))
		end

	mf_used_first: CE_POINTER [PD_BLOCK_HDR] assign set_mf_used_first
		do
			create Result.make_shared (c_mf_used_first (c_pointer))
		end

	mf_used_last: CE_POINTER [PD_BLOCK_HDR] assign set_mf_used_last
		do
			create Result.make_shared (c_mf_used_last (c_pointer))
		end

	mf_used_count: NATURAL_32 assign set_mf_used_count
		do
			Result := c_mf_used_count (c_pointer)
		end

	mf_used_count_max: NATURAL_32 assign set_mf_used_count_max
		do
			Result := c_mf_used_count_max (c_pointer)
		end

	mf_hash: CE_ARRAY [CE_POINTER [PD_BLOCK_HDR]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_mf_hash (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	mf_trans: CE_ARRAY [CE_POINTER [PD_NR_TRANS]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_mf_trans (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	mf_blocknr_max: INTEGER_32 assign set_mf_blocknr_max
		do
			Result := c_mf_blocknr_max (c_pointer)
		end

	mf_blocknr_min: INTEGER_32 assign set_mf_blocknr_min
		do
			Result := c_mf_blocknr_min (c_pointer)
		end

	mf_neg_count: INTEGER_32 assign set_mf_neg_count
		do
			Result := c_mf_neg_count (c_pointer)
		end

	mf_infile_count: INTEGER_32 assign set_mf_infile_count
		do
			Result := c_mf_infile_count (c_pointer)
		end

	mf_page_size: NATURAL_32 assign set_mf_page_size
		do
			Result := c_mf_page_size (c_pointer)
		end

	mf_dirty: INTEGER_32 assign set_mf_dirty
		do
			Result := c_mf_dirty (c_pointer)
		end

	mf_buffer: CE_POINTER [PD_FILE_BUFFER] assign set_mf_buffer
		do
			create Result.make_shared (c_mf_buffer (c_pointer))
		end

	mf_seed: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_mf_seed (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	mf_old_key: CE_POINTER [NATURAL_8] assign set_mf_old_key
		do
			create Result.make_shared (c_mf_old_key (c_pointer))
		end

	mf_old_cm: INTEGER_32 assign set_mf_old_cm
		do
			Result := c_mf_old_cm (c_pointer)
		end

	mf_old_seed: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_mf_old_seed (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_mf_fname (a_mf_fname: CE_POINTER [NATURAL_8])
		do
			c_set_mf_fname (c_pointer, a_mf_fname.c_pointer)
		end

	set_mf_ffname (a_mf_ffname: CE_POINTER [NATURAL_8])
		do
			c_set_mf_ffname (c_pointer, a_mf_ffname.c_pointer)
		end

	set_mf_fd (a_mf_fd: INTEGER_32)
		do
			c_set_mf_fd (c_pointer, a_mf_fd)
		end

	set_mf_free_first (a_mf_free_first: CE_POINTER [PD_BLOCK_HDR])
		do
			c_set_mf_free_first (c_pointer, a_mf_free_first.c_pointer)
		end

	set_mf_used_first (a_mf_used_first: CE_POINTER [PD_BLOCK_HDR])
		do
			c_set_mf_used_first (c_pointer, a_mf_used_first.c_pointer)
		end

	set_mf_used_last (a_mf_used_last: CE_POINTER [PD_BLOCK_HDR])
		do
			c_set_mf_used_last (c_pointer, a_mf_used_last.c_pointer)
		end

	set_mf_used_count (a_mf_used_count: NATURAL_32)
		do
			c_set_mf_used_count (c_pointer, a_mf_used_count)
		end

	set_mf_used_count_max (a_mf_used_count_max: NATURAL_32)
		do
			c_set_mf_used_count_max (c_pointer, a_mf_used_count_max)
		end

	set_mf_blocknr_max (a_mf_blocknr_max: INTEGER_32)
		do
			c_set_mf_blocknr_max (c_pointer, a_mf_blocknr_max)
		end

	set_mf_blocknr_min (a_mf_blocknr_min: INTEGER_32)
		do
			c_set_mf_blocknr_min (c_pointer, a_mf_blocknr_min)
		end

	set_mf_neg_count (a_mf_neg_count: INTEGER_32)
		do
			c_set_mf_neg_count (c_pointer, a_mf_neg_count)
		end

	set_mf_infile_count (a_mf_infile_count: INTEGER_32)
		do
			c_set_mf_infile_count (c_pointer, a_mf_infile_count)
		end

	set_mf_page_size (a_mf_page_size: NATURAL_32)
		do
			c_set_mf_page_size (c_pointer, a_mf_page_size)
		end

	set_mf_dirty (a_mf_dirty: INTEGER_32)
		do
			c_set_mf_dirty (c_pointer, a_mf_dirty)
		end

	set_mf_buffer (a_mf_buffer: CE_POINTER [PD_FILE_BUFFER])
		do
			c_set_mf_buffer (c_pointer, a_mf_buffer.c_pointer)
		end

	set_mf_old_key (a_mf_old_key: CE_POINTER [NATURAL_8])
		do
			c_set_mf_old_key (c_pointer, a_mf_old_key.c_pointer)
		end

	set_mf_old_cm (a_mf_old_cm: INTEGER_32)
		do
			c_set_mf_old_cm (c_pointer, a_mf_old_cm)
		end

feature {NONE} -- C getters

	c_mf_fname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct memfile *)$tmp)->mf_fname;"
		end

	c_mf_ffname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct memfile *)$tmp)->mf_ffname;"
		end

	c_mf_fd (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct memfile *)$tmp)->mf_fd;"
		end

	c_mf_free_first (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct block_hdr *)((struct memfile *)$tmp)->mf_free_first;"
		end

	c_mf_used_first (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct block_hdr *)((struct memfile *)$tmp)->mf_used_first;"
		end

	c_mf_used_last (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct block_hdr *)((struct memfile *)$tmp)->mf_used_last;"
		end

	c_mf_used_count (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct memfile *)$tmp)->mf_used_count;"
		end

	c_mf_used_count_max (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct memfile *)$tmp)->mf_used_count_max;"
		end

	c_mf_hash (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct memfile *tmp = (struct memfile *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->mf_hash) / sizeof(tmp->mf_hash[0]);
				return tmp->mf_hash;
			]"
		end

	c_mf_trans (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct memfile *tmp = (struct memfile *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->mf_trans) / sizeof(tmp->mf_trans[0]);
				return tmp->mf_trans;
			]"
		end

	c_mf_blocknr_max (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct memfile *)$tmp)->mf_blocknr_max;"
		end

	c_mf_blocknr_min (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct memfile *)$tmp)->mf_blocknr_min;"
		end

	c_mf_neg_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct memfile *)$tmp)->mf_neg_count;"
		end

	c_mf_infile_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct memfile *)$tmp)->mf_infile_count;"
		end

	c_mf_page_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct memfile *)$tmp)->mf_page_size;"
		end

	c_mf_dirty (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct memfile *)$tmp)->mf_dirty;"
		end

	c_mf_buffer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct file_buffer *)((struct memfile *)$tmp)->mf_buffer;"
		end

	c_mf_seed (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct memfile *tmp = (struct memfile *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->mf_seed) / sizeof(tmp->mf_seed[0]);
				return tmp->mf_seed;
			]"
		end

	c_mf_old_key (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct memfile *)$tmp)->mf_old_key;"
		end

	c_mf_old_cm (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct memfile *)$tmp)->mf_old_cm;"
		end

	c_mf_old_seed (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct memfile *tmp = (struct memfile *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->mf_old_seed) / sizeof(tmp->mf_old_seed[0]);
				return tmp->mf_old_seed;
			]"
		end

feature {NONE} -- C setters

	c_set_mf_fname (tmp: POINTER; a_mf_fname: POINTER)
		external
			"C inline"
		alias
			"((struct memfile *)$tmp)->mf_fname = (unsigned char *)$a_mf_fname;"
		end

	c_set_mf_ffname (tmp: POINTER; a_mf_ffname: POINTER)
		external
			"C inline"
		alias
			"((struct memfile *)$tmp)->mf_ffname = (unsigned char *)$a_mf_ffname;"
		end

	c_set_mf_fd (tmp: POINTER; a_mf_fd: INTEGER_32)
		external
			"C inline"
		alias
			"((struct memfile *)$tmp)->mf_fd = $a_mf_fd;"
		end

	c_set_mf_free_first (tmp: POINTER; a_mf_free_first: POINTER)
		external
			"C inline"
		alias
			"((struct memfile *)$tmp)->mf_free_first = (struct block_hdr *)$a_mf_free_first;"
		end

	c_set_mf_used_first (tmp: POINTER; a_mf_used_first: POINTER)
		external
			"C inline"
		alias
			"((struct memfile *)$tmp)->mf_used_first = (struct block_hdr *)$a_mf_used_first;"
		end

	c_set_mf_used_last (tmp: POINTER; a_mf_used_last: POINTER)
		external
			"C inline"
		alias
			"((struct memfile *)$tmp)->mf_used_last = (struct block_hdr *)$a_mf_used_last;"
		end

	c_set_mf_used_count (tmp: POINTER; a_mf_used_count: NATURAL_32)
		external
			"C inline"
		alias
			"((struct memfile *)$tmp)->mf_used_count = $a_mf_used_count;"
		end

	c_set_mf_used_count_max (tmp: POINTER; a_mf_used_count_max: NATURAL_32)
		external
			"C inline"
		alias
			"((struct memfile *)$tmp)->mf_used_count_max = $a_mf_used_count_max;"
		end

	c_set_mf_blocknr_max (tmp: POINTER; a_mf_blocknr_max: INTEGER_32)
		external
			"C inline"
		alias
			"((struct memfile *)$tmp)->mf_blocknr_max = $a_mf_blocknr_max;"
		end

	c_set_mf_blocknr_min (tmp: POINTER; a_mf_blocknr_min: INTEGER_32)
		external
			"C inline"
		alias
			"((struct memfile *)$tmp)->mf_blocknr_min = $a_mf_blocknr_min;"
		end

	c_set_mf_neg_count (tmp: POINTER; a_mf_neg_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct memfile *)$tmp)->mf_neg_count = $a_mf_neg_count;"
		end

	c_set_mf_infile_count (tmp: POINTER; a_mf_infile_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct memfile *)$tmp)->mf_infile_count = $a_mf_infile_count;"
		end

	c_set_mf_page_size (tmp: POINTER; a_mf_page_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct memfile *)$tmp)->mf_page_size = $a_mf_page_size;"
		end

	c_set_mf_dirty (tmp: POINTER; a_mf_dirty: INTEGER_32)
		external
			"C inline"
		alias
			"((struct memfile *)$tmp)->mf_dirty = $a_mf_dirty;"
		end

	c_set_mf_buffer (tmp: POINTER; a_mf_buffer: POINTER)
		external
			"C inline"
		alias
			"((struct memfile *)$tmp)->mf_buffer = (struct file_buffer *)$a_mf_buffer;"
		end

	c_set_mf_old_key (tmp: POINTER; a_mf_old_key: POINTER)
		external
			"C inline"
		alias
			"((struct memfile *)$tmp)->mf_old_key = (unsigned char *)$a_mf_old_key;"
		end

	c_set_mf_old_cm (tmp: POINTER; a_mf_old_cm: INTEGER_32)
		external
			"C inline"
		alias
			"((struct memfile *)$tmp)->mf_old_cm = $a_mf_old_cm;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct memfile);"
		end

end
