class
	PD_MEMLINE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ml_line_count: INTEGER_32 assign set_ml_line_count
		do
			Result := c_ml_line_count (c_pointer)
		end

	ml_mfp: CE_POINTER [PD_MEMFILE] assign set_ml_mfp
		do
			create Result.make_shared (c_ml_mfp (c_pointer))
		end

	ml_flags: INTEGER_32 assign set_ml_flags
		do
			Result := c_ml_flags (c_pointer)
		end

	ml_stack: CE_POINTER [PD_INFO_POINTER] assign set_ml_stack
		do
			create Result.make_shared (c_ml_stack (c_pointer))
		end

	ml_stack_top: INTEGER_32 assign set_ml_stack_top
		do
			Result := c_ml_stack_top (c_pointer)
		end

	ml_stack_size: INTEGER_32 assign set_ml_stack_size
		do
			Result := c_ml_stack_size (c_pointer)
		end

	ml_line_lnum: INTEGER_32 assign set_ml_line_lnum
		do
			Result := c_ml_line_lnum (c_pointer)
		end

	ml_line_ptr: CE_POINTER [NATURAL_8] assign set_ml_line_ptr
		do
			create Result.make_shared (c_ml_line_ptr (c_pointer))
		end

	ml_locked: CE_POINTER [PD_BLOCK_HDR] assign set_ml_locked
		do
			create Result.make_shared (c_ml_locked (c_pointer))
		end

	ml_locked_low: INTEGER_32 assign set_ml_locked_low
		do
			Result := c_ml_locked_low (c_pointer)
		end

	ml_locked_high: INTEGER_32 assign set_ml_locked_high
		do
			Result := c_ml_locked_high (c_pointer)
		end

	ml_locked_lineadd: INTEGER_32 assign set_ml_locked_lineadd
		do
			Result := c_ml_locked_lineadd (c_pointer)
		end

	ml_chunksize: CE_POINTER [PD_ML_CHUNKSIZE] assign set_ml_chunksize
		do
			create Result.make_shared (c_ml_chunksize (c_pointer))
		end

	ml_numchunks: INTEGER_32 assign set_ml_numchunks
		do
			Result := c_ml_numchunks (c_pointer)
		end

	ml_usedchunks: INTEGER_32 assign set_ml_usedchunks
		do
			Result := c_ml_usedchunks (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_ml_line_count (a_ml_line_count: INTEGER_32)
		do
			c_set_ml_line_count (c_pointer, a_ml_line_count)
		end

	set_ml_mfp (a_ml_mfp: CE_POINTER [PD_MEMFILE])
		do
			c_set_ml_mfp (c_pointer, a_ml_mfp.c_pointer)
		end

	set_ml_flags (a_ml_flags: INTEGER_32)
		do
			c_set_ml_flags (c_pointer, a_ml_flags)
		end

	set_ml_stack (a_ml_stack: CE_POINTER [PD_INFO_POINTER])
		do
			c_set_ml_stack (c_pointer, a_ml_stack.c_pointer)
		end

	set_ml_stack_top (a_ml_stack_top: INTEGER_32)
		do
			c_set_ml_stack_top (c_pointer, a_ml_stack_top)
		end

	set_ml_stack_size (a_ml_stack_size: INTEGER_32)
		do
			c_set_ml_stack_size (c_pointer, a_ml_stack_size)
		end

	set_ml_line_lnum (a_ml_line_lnum: INTEGER_32)
		do
			c_set_ml_line_lnum (c_pointer, a_ml_line_lnum)
		end

	set_ml_line_ptr (a_ml_line_ptr: CE_POINTER [NATURAL_8])
		do
			c_set_ml_line_ptr (c_pointer, a_ml_line_ptr.c_pointer)
		end

	set_ml_locked (a_ml_locked: CE_POINTER [PD_BLOCK_HDR])
		do
			c_set_ml_locked (c_pointer, a_ml_locked.c_pointer)
		end

	set_ml_locked_low (a_ml_locked_low: INTEGER_32)
		do
			c_set_ml_locked_low (c_pointer, a_ml_locked_low)
		end

	set_ml_locked_high (a_ml_locked_high: INTEGER_32)
		do
			c_set_ml_locked_high (c_pointer, a_ml_locked_high)
		end

	set_ml_locked_lineadd (a_ml_locked_lineadd: INTEGER_32)
		do
			c_set_ml_locked_lineadd (c_pointer, a_ml_locked_lineadd)
		end

	set_ml_chunksize (a_ml_chunksize: CE_POINTER [PD_ML_CHUNKSIZE])
		do
			c_set_ml_chunksize (c_pointer, a_ml_chunksize.c_pointer)
		end

	set_ml_numchunks (a_ml_numchunks: INTEGER_32)
		do
			c_set_ml_numchunks (c_pointer, a_ml_numchunks)
		end

	set_ml_usedchunks (a_ml_usedchunks: INTEGER_32)
		do
			c_set_ml_usedchunks (c_pointer, a_ml_usedchunks)
		end

feature {NONE} -- C getters

	c_ml_line_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct memline *)$tmp)->ml_line_count;"
		end

	c_ml_mfp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct memfile *)((struct memline *)$tmp)->ml_mfp;"
		end

	c_ml_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct memline *)$tmp)->ml_flags;"
		end

	c_ml_stack (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct info_pointer *)((struct memline *)$tmp)->ml_stack;"
		end

	c_ml_stack_top (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct memline *)$tmp)->ml_stack_top;"
		end

	c_ml_stack_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct memline *)$tmp)->ml_stack_size;"
		end

	c_ml_line_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct memline *)$tmp)->ml_line_lnum;"
		end

	c_ml_line_ptr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct memline *)$tmp)->ml_line_ptr;"
		end

	c_ml_locked (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct block_hdr *)((struct memline *)$tmp)->ml_locked;"
		end

	c_ml_locked_low (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct memline *)$tmp)->ml_locked_low;"
		end

	c_ml_locked_high (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct memline *)$tmp)->ml_locked_high;"
		end

	c_ml_locked_lineadd (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct memline *)$tmp)->ml_locked_lineadd;"
		end

	c_ml_chunksize (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct ml_chunksize *)((struct memline *)$tmp)->ml_chunksize;"
		end

	c_ml_numchunks (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct memline *)$tmp)->ml_numchunks;"
		end

	c_ml_usedchunks (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct memline *)$tmp)->ml_usedchunks;"
		end

feature {NONE} -- C setters

	c_set_ml_line_count (tmp: POINTER; a_ml_line_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct memline *)$tmp)->ml_line_count = $a_ml_line_count;"
		end

	c_set_ml_mfp (tmp: POINTER; a_ml_mfp: POINTER)
		external
			"C inline"
		alias
			"((struct memline *)$tmp)->ml_mfp = (struct memfile *)$a_ml_mfp;"
		end

	c_set_ml_flags (tmp: POINTER; a_ml_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct memline *)$tmp)->ml_flags = $a_ml_flags;"
		end

	c_set_ml_stack (tmp: POINTER; a_ml_stack: POINTER)
		external
			"C inline"
		alias
			"((struct memline *)$tmp)->ml_stack = (struct info_pointer *)$a_ml_stack;"
		end

	c_set_ml_stack_top (tmp: POINTER; a_ml_stack_top: INTEGER_32)
		external
			"C inline"
		alias
			"((struct memline *)$tmp)->ml_stack_top = $a_ml_stack_top;"
		end

	c_set_ml_stack_size (tmp: POINTER; a_ml_stack_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct memline *)$tmp)->ml_stack_size = $a_ml_stack_size;"
		end

	c_set_ml_line_lnum (tmp: POINTER; a_ml_line_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct memline *)$tmp)->ml_line_lnum = $a_ml_line_lnum;"
		end

	c_set_ml_line_ptr (tmp: POINTER; a_ml_line_ptr: POINTER)
		external
			"C inline"
		alias
			"((struct memline *)$tmp)->ml_line_ptr = (unsigned char *)$a_ml_line_ptr;"
		end

	c_set_ml_locked (tmp: POINTER; a_ml_locked: POINTER)
		external
			"C inline"
		alias
			"((struct memline *)$tmp)->ml_locked = (struct block_hdr *)$a_ml_locked;"
		end

	c_set_ml_locked_low (tmp: POINTER; a_ml_locked_low: INTEGER_32)
		external
			"C inline"
		alias
			"((struct memline *)$tmp)->ml_locked_low = $a_ml_locked_low;"
		end

	c_set_ml_locked_high (tmp: POINTER; a_ml_locked_high: INTEGER_32)
		external
			"C inline"
		alias
			"((struct memline *)$tmp)->ml_locked_high = $a_ml_locked_high;"
		end

	c_set_ml_locked_lineadd (tmp: POINTER; a_ml_locked_lineadd: INTEGER_32)
		external
			"C inline"
		alias
			"((struct memline *)$tmp)->ml_locked_lineadd = $a_ml_locked_lineadd;"
		end

	c_set_ml_chunksize (tmp: POINTER; a_ml_chunksize: POINTER)
		external
			"C inline"
		alias
			"((struct memline *)$tmp)->ml_chunksize = (struct ml_chunksize *)$a_ml_chunksize;"
		end

	c_set_ml_numchunks (tmp: POINTER; a_ml_numchunks: INTEGER_32)
		external
			"C inline"
		alias
			"((struct memline *)$tmp)->ml_numchunks = $a_ml_numchunks;"
		end

	c_set_ml_usedchunks (tmp: POINTER; a_ml_usedchunks: INTEGER_32)
		external
			"C inline"
		alias
			"((struct memline *)$tmp)->ml_usedchunks = $a_ml_usedchunks;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct memline);"
		end

end
