class
	PD_MPARM_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	argc: INTEGER_32 assign set_argc
		do
			Result := c_argc (c_pointer)
		end

	argc_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_mparm_T_543, argc);"
		end

	argv: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_argv
		do
			create Result.make_shared (c_argv (c_pointer))
		end

	evim_mode: INTEGER_32 assign set_evim_mode
		do
			Result := c_evim_mode (c_pointer)
		end

	use_vimrc: CE_POINTER [NATURAL_8] assign set_use_vimrc
		do
			create Result.make_shared (c_use_vimrc (c_pointer))
		end

	n_commands: INTEGER_32 assign set_n_commands
		do
			Result := c_n_commands (c_pointer)
		end

	commands: CE_ARRAY [CE_POINTER [NATURAL_8]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_commands (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	cmds_tofree: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_cmds_tofree (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	n_pre_commands: INTEGER_32 assign set_n_pre_commands
		do
			Result := c_n_pre_commands (c_pointer)
		end

	pre_commands: CE_ARRAY [CE_POINTER [NATURAL_8]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_pre_commands (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	edit_type: INTEGER_32 assign set_edit_type
		do
			Result := c_edit_type (c_pointer)
		end

	tagname: CE_POINTER [NATURAL_8] assign set_tagname
		do
			create Result.make_shared (c_tagname (c_pointer))
		end

	use_ef: CE_POINTER [NATURAL_8] assign set_use_ef
		do
			create Result.make_shared (c_use_ef (c_pointer))
		end

	want_full_screen: INTEGER_32 assign set_want_full_screen
		do
			Result := c_want_full_screen (c_pointer)
		end

	stdout_isatty: INTEGER_32 assign set_stdout_isatty
		do
			Result := c_stdout_isatty (c_pointer)
		end

	term: CE_POINTER [NATURAL_8] assign set_term
		do
			create Result.make_shared (c_term (c_pointer))
		end

	ask_for_key: INTEGER_32 assign set_ask_for_key
		do
			Result := c_ask_for_key (c_pointer)
		end

	no_swap_file: INTEGER_32 assign set_no_swap_file
		do
			Result := c_no_swap_file (c_pointer)
		end

	use_debug_break_level: INTEGER_32 assign set_use_debug_break_level
		do
			Result := c_use_debug_break_level (c_pointer)
		end

	window_count: INTEGER_32 assign set_window_count
		do
			Result := c_window_count (c_pointer)
		end

	window_layout: INTEGER_32 assign set_window_layout
		do
			Result := c_window_layout (c_pointer)
		end

	serverArg: INTEGER_32 assign set_serverArg
		do
			Result := c_serverArg (c_pointer)
		end

	serverName_arg: CE_POINTER [NATURAL_8] assign set_serverName_arg
		do
			create Result.make_shared (c_serverName_arg (c_pointer))
		end

	serverStr: CE_POINTER [NATURAL_8] assign set_serverStr
		do
			create Result.make_shared (c_serverStr (c_pointer))
		end

	serverStr_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_mparm_T_543, serverStr);"
		end

	serverStrEnc: CE_POINTER [NATURAL_8] assign set_serverStrEnc
		do
			create Result.make_shared (c_serverStrEnc (c_pointer))
		end

	servername: CE_POINTER [NATURAL_8] assign set_servername
		do
			create Result.make_shared (c_servername (c_pointer))
		end

	diff_mode: INTEGER_32 assign set_diff_mode
		do
			Result := c_diff_mode (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_argc (a_argc: INTEGER_32)
		do
			c_set_argc (c_pointer, a_argc)
		end

	set_argv (a_argv: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			c_set_argv (c_pointer, a_argv.c_pointer)
		end

	set_evim_mode (a_evim_mode: INTEGER_32)
		do
			c_set_evim_mode (c_pointer, a_evim_mode)
		end

	set_use_vimrc (a_use_vimrc: CE_POINTER [NATURAL_8])
		do
			c_set_use_vimrc (c_pointer, a_use_vimrc.c_pointer)
		end

	set_n_commands (a_n_commands: INTEGER_32)
		do
			c_set_n_commands (c_pointer, a_n_commands)
		end

	set_n_pre_commands (a_n_pre_commands: INTEGER_32)
		do
			c_set_n_pre_commands (c_pointer, a_n_pre_commands)
		end

	set_edit_type (a_edit_type: INTEGER_32)
		do
			c_set_edit_type (c_pointer, a_edit_type)
		end

	set_tagname (a_tagname: CE_POINTER [NATURAL_8])
		do
			c_set_tagname (c_pointer, a_tagname.c_pointer)
		end

	set_use_ef (a_use_ef: CE_POINTER [NATURAL_8])
		do
			c_set_use_ef (c_pointer, a_use_ef.c_pointer)
		end

	set_want_full_screen (a_want_full_screen: INTEGER_32)
		do
			c_set_want_full_screen (c_pointer, a_want_full_screen)
		end

	set_stdout_isatty (a_stdout_isatty: INTEGER_32)
		do
			c_set_stdout_isatty (c_pointer, a_stdout_isatty)
		end

	set_term (a_term: CE_POINTER [NATURAL_8])
		do
			c_set_term (c_pointer, a_term.c_pointer)
		end

	set_ask_for_key (a_ask_for_key: INTEGER_32)
		do
			c_set_ask_for_key (c_pointer, a_ask_for_key)
		end

	set_no_swap_file (a_no_swap_file: INTEGER_32)
		do
			c_set_no_swap_file (c_pointer, a_no_swap_file)
		end

	set_use_debug_break_level (a_use_debug_break_level: INTEGER_32)
		do
			c_set_use_debug_break_level (c_pointer, a_use_debug_break_level)
		end

	set_window_count (a_window_count: INTEGER_32)
		do
			c_set_window_count (c_pointer, a_window_count)
		end

	set_window_layout (a_window_layout: INTEGER_32)
		do
			c_set_window_layout (c_pointer, a_window_layout)
		end

	set_serverArg (a_serverArg: INTEGER_32)
		do
			c_set_serverArg (c_pointer, a_serverArg)
		end

	set_serverName_arg (a_serverName_arg: CE_POINTER [NATURAL_8])
		do
			c_set_serverName_arg (c_pointer, a_serverName_arg.c_pointer)
		end

	set_serverStr (a_serverStr: CE_POINTER [NATURAL_8])
		do
			c_set_serverStr (c_pointer, a_serverStr.c_pointer)
		end

	set_serverStrEnc (a_serverStrEnc: CE_POINTER [NATURAL_8])
		do
			c_set_serverStrEnc (c_pointer, a_serverStrEnc.c_pointer)
		end

	set_servername (a_servername: CE_POINTER [NATURAL_8])
		do
			c_set_servername (c_pointer, a_servername.c_pointer)
		end

	set_diff_mode (a_diff_mode: INTEGER_32)
		do
			c_set_diff_mode (c_pointer, a_diff_mode)
		end

feature {NONE} -- C getters

	c_argc (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_mparm_T_543 *)$tmp)->argc;"
		end

	c_argv (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char * *)((struct __anonstruct_mparm_T_543 *)$tmp)->argv;"
		end

	c_evim_mode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_mparm_T_543 *)$tmp)->evim_mode;"
		end

	c_use_vimrc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_mparm_T_543 *)$tmp)->use_vimrc;"
		end

	c_n_commands (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_mparm_T_543 *)$tmp)->n_commands;"
		end

	c_commands (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_mparm_T_543 *tmp = (struct __anonstruct_mparm_T_543 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->commands) / sizeof(tmp->commands[0]);
				return tmp->commands;
			]"
		end

	c_cmds_tofree (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_mparm_T_543 *tmp = (struct __anonstruct_mparm_T_543 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->cmds_tofree) / sizeof(tmp->cmds_tofree[0]);
				return tmp->cmds_tofree;
			]"
		end

	c_n_pre_commands (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_mparm_T_543 *)$tmp)->n_pre_commands;"
		end

	c_pre_commands (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_mparm_T_543 *tmp = (struct __anonstruct_mparm_T_543 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->pre_commands) / sizeof(tmp->pre_commands[0]);
				return tmp->pre_commands;
			]"
		end

	c_edit_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_mparm_T_543 *)$tmp)->edit_type;"
		end

	c_tagname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_mparm_T_543 *)$tmp)->tagname;"
		end

	c_use_ef (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_mparm_T_543 *)$tmp)->use_ef;"
		end

	c_want_full_screen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_mparm_T_543 *)$tmp)->want_full_screen;"
		end

	c_stdout_isatty (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_mparm_T_543 *)$tmp)->stdout_isatty;"
		end

	c_term (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_mparm_T_543 *)$tmp)->term;"
		end

	c_ask_for_key (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_mparm_T_543 *)$tmp)->ask_for_key;"
		end

	c_no_swap_file (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_mparm_T_543 *)$tmp)->no_swap_file;"
		end

	c_use_debug_break_level (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_mparm_T_543 *)$tmp)->use_debug_break_level;"
		end

	c_window_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_mparm_T_543 *)$tmp)->window_count;"
		end

	c_window_layout (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_mparm_T_543 *)$tmp)->window_layout;"
		end

	c_serverArg (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_mparm_T_543 *)$tmp)->serverArg;"
		end

	c_serverName_arg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_mparm_T_543 *)$tmp)->serverName_arg;"
		end

	c_serverStr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_mparm_T_543 *)$tmp)->serverStr;"
		end

	c_serverStrEnc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_mparm_T_543 *)$tmp)->serverStrEnc;"
		end

	c_servername (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_mparm_T_543 *)$tmp)->servername;"
		end

	c_diff_mode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_mparm_T_543 *)$tmp)->diff_mode;"
		end

feature {NONE} -- C setters

	c_set_argc (tmp: POINTER; a_argc: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_mparm_T_543 *)$tmp)->argc = $a_argc;"
		end

	c_set_argv (tmp: POINTER; a_argv: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_mparm_T_543 *)$tmp)->argv = (char * *)$a_argv;"
		end

	c_set_evim_mode (tmp: POINTER; a_evim_mode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_mparm_T_543 *)$tmp)->evim_mode = $a_evim_mode;"
		end

	c_set_use_vimrc (tmp: POINTER; a_use_vimrc: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_mparm_T_543 *)$tmp)->use_vimrc = (unsigned char *)$a_use_vimrc;"
		end

	c_set_n_commands (tmp: POINTER; a_n_commands: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_mparm_T_543 *)$tmp)->n_commands = $a_n_commands;"
		end

	c_set_n_pre_commands (tmp: POINTER; a_n_pre_commands: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_mparm_T_543 *)$tmp)->n_pre_commands = $a_n_pre_commands;"
		end

	c_set_edit_type (tmp: POINTER; a_edit_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_mparm_T_543 *)$tmp)->edit_type = $a_edit_type;"
		end

	c_set_tagname (tmp: POINTER; a_tagname: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_mparm_T_543 *)$tmp)->tagname = (unsigned char *)$a_tagname;"
		end

	c_set_use_ef (tmp: POINTER; a_use_ef: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_mparm_T_543 *)$tmp)->use_ef = (unsigned char *)$a_use_ef;"
		end

	c_set_want_full_screen (tmp: POINTER; a_want_full_screen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_mparm_T_543 *)$tmp)->want_full_screen = $a_want_full_screen;"
		end

	c_set_stdout_isatty (tmp: POINTER; a_stdout_isatty: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_mparm_T_543 *)$tmp)->stdout_isatty = $a_stdout_isatty;"
		end

	c_set_term (tmp: POINTER; a_term: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_mparm_T_543 *)$tmp)->term = (unsigned char *)$a_term;"
		end

	c_set_ask_for_key (tmp: POINTER; a_ask_for_key: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_mparm_T_543 *)$tmp)->ask_for_key = $a_ask_for_key;"
		end

	c_set_no_swap_file (tmp: POINTER; a_no_swap_file: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_mparm_T_543 *)$tmp)->no_swap_file = $a_no_swap_file;"
		end

	c_set_use_debug_break_level (tmp: POINTER; a_use_debug_break_level: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_mparm_T_543 *)$tmp)->use_debug_break_level = $a_use_debug_break_level;"
		end

	c_set_window_count (tmp: POINTER; a_window_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_mparm_T_543 *)$tmp)->window_count = $a_window_count;"
		end

	c_set_window_layout (tmp: POINTER; a_window_layout: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_mparm_T_543 *)$tmp)->window_layout = $a_window_layout;"
		end

	c_set_serverArg (tmp: POINTER; a_serverArg: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_mparm_T_543 *)$tmp)->serverArg = $a_serverarg;"
		end

	c_set_serverName_arg (tmp: POINTER; a_serverName_arg: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_mparm_T_543 *)$tmp)->serverName_arg = (unsigned char *)$a_servername_arg;"
		end

	c_set_serverStr (tmp: POINTER; a_serverStr: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_mparm_T_543 *)$tmp)->serverStr = (unsigned char *)$a_serverstr;"
		end

	c_set_serverStrEnc (tmp: POINTER; a_serverStrEnc: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_mparm_T_543 *)$tmp)->serverStrEnc = (unsigned char *)$a_serverstrenc;"
		end

	c_set_servername (tmp: POINTER; a_servername: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_mparm_T_543 *)$tmp)->servername = (unsigned char *)$a_servername;"
		end

	c_set_diff_mode (tmp: POINTER; a_diff_mode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_mparm_T_543 *)$tmp)->diff_mode = $a_diff_mode;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_mparm_T_543);"
		end

end
