class
	PD_MSGCHUNK_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sb_next: CE_POINTER [PD_MSGCHUNK_S] assign set_sb_next
		do
			create Result.make_shared (c_sb_next (c_pointer))
		end

	sb_prev: CE_POINTER [PD_MSGCHUNK_S] assign set_sb_prev
		do
			create Result.make_shared (c_sb_prev (c_pointer))
		end

	sb_eol: INTEGER_8 assign set_sb_eol
		do
			Result := c_sb_eol (c_pointer)
		end

	sb_msg_col: INTEGER_32 assign set_sb_msg_col
		do
			Result := c_sb_msg_col (c_pointer)
		end

	sb_attr: INTEGER_32 assign set_sb_attr
		do
			Result := c_sb_attr (c_pointer)
		end

	sb_text: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_sb_text (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_sb_next (a_sb_next: CE_POINTER [PD_MSGCHUNK_S])
		do
			c_set_sb_next (c_pointer, a_sb_next.c_pointer)
		end

	set_sb_prev (a_sb_prev: CE_POINTER [PD_MSGCHUNK_S])
		do
			c_set_sb_prev (c_pointer, a_sb_prev.c_pointer)
		end

	set_sb_eol (a_sb_eol: INTEGER_8)
		do
			c_set_sb_eol (c_pointer, a_sb_eol)
		end

	set_sb_msg_col (a_sb_msg_col: INTEGER_32)
		do
			c_set_sb_msg_col (c_pointer, a_sb_msg_col)
		end

	set_sb_attr (a_sb_attr: INTEGER_32)
		do
			c_set_sb_attr (c_pointer, a_sb_attr)
		end

feature {NONE} -- C getters

	c_sb_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct msgchunk_S *)((struct msgchunk_S *)$tmp)->sb_next;"
		end

	c_sb_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct msgchunk_S *)((struct msgchunk_S *)$tmp)->sb_prev;"
		end

	c_sb_eol (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct msgchunk_S *)$tmp)->sb_eol;"
		end

	c_sb_msg_col (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct msgchunk_S *)$tmp)->sb_msg_col;"
		end

	c_sb_attr (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct msgchunk_S *)$tmp)->sb_attr;"
		end

	c_sb_text (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct msgchunk_S *tmp = (struct msgchunk_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->sb_text) / sizeof(tmp->sb_text[0]);
				return tmp->sb_text;
			]"
		end

feature {NONE} -- C setters

	c_set_sb_next (tmp: POINTER; a_sb_next: POINTER)
		external
			"C inline"
		alias
			"((struct msgchunk_S *)$tmp)->sb_next = (struct msgchunk_S *)$a_sb_next;"
		end

	c_set_sb_prev (tmp: POINTER; a_sb_prev: POINTER)
		external
			"C inline"
		alias
			"((struct msgchunk_S *)$tmp)->sb_prev = (struct msgchunk_S *)$a_sb_prev;"
		end

	c_set_sb_eol (tmp: POINTER; a_sb_eol: INTEGER_8)
		external
			"C inline"
		alias
			"((struct msgchunk_S *)$tmp)->sb_eol = $a_sb_eol;"
		end

	c_set_sb_msg_col (tmp: POINTER; a_sb_msg_col: INTEGER_32)
		external
			"C inline"
		alias
			"((struct msgchunk_S *)$tmp)->sb_msg_col = $a_sb_msg_col;"
		end

	c_set_sb_attr (tmp: POINTER; a_sb_attr: INTEGER_32)
		external
			"C inline"
		alias
			"((struct msgchunk_S *)$tmp)->sb_attr = $a_sb_attr;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct msgchunk_S);"
		end

end
