class
	PD_MSGLIST

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	msg: CE_POINTER [NATURAL_8] assign set_msg
		do
			create Result.make_shared (c_msg (c_pointer))
		end

	throw_msg: CE_POINTER [NATURAL_8] assign set_throw_msg
		do
			create Result.make_shared (c_throw_msg (c_pointer))
		end

	next: CE_POINTER [PD_MSGLIST] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	next_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct msglist, next);"
		end

feature {ANY} -- Eiffel setters

	set_msg (a_msg: CE_POINTER [NATURAL_8])
		do
			c_set_msg (c_pointer, a_msg.c_pointer)
		end

	set_throw_msg (a_throw_msg: CE_POINTER [NATURAL_8])
		do
			c_set_throw_msg (c_pointer, a_throw_msg.c_pointer)
		end

	set_next (a_next: CE_POINTER [PD_MSGLIST])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

feature {NONE} -- C getters

	c_msg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct msglist *)$tmp)->msg;"
		end

	c_throw_msg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct msglist *)$tmp)->throw_msg;"
		end

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct msglist *)((struct msglist *)$tmp)->next;"
		end

feature {NONE} -- C setters

	c_set_msg (tmp: POINTER; a_msg: POINTER)
		external
			"C inline"
		alias
			"((struct msglist *)$tmp)->msg = (unsigned char *)$a_msg;"
		end

	c_set_throw_msg (tmp: POINTER; a_throw_msg: POINTER)
		external
			"C inline"
		alias
			"((struct msglist *)$tmp)->throw_msg = (unsigned char *)$a_throw_msg;"
		end

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct msglist *)$tmp)->next = (struct msglist *)$a_next;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct msglist);"
		end

end
