class
	PD_POINTER_BLOCK

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	pb_id: NATURAL_16 assign set_pb_id
		do
			Result := c_pb_id (c_pointer)
		end

	pb_count: NATURAL_16 assign set_pb_count
		do
			Result := c_pb_count (c_pointer)
		end

	pb_count_max: NATURAL_16 assign set_pb_count_max
		do
			Result := c_pb_count_max (c_pointer)
		end

	pb_pointer: CE_ARRAY [PD_POINTER_ENTRY]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_pb_pointer (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_pb_id (a_pb_id: NATURAL_16)
		do
			c_set_pb_id (c_pointer, a_pb_id)
		end

	set_pb_count (a_pb_count: NATURAL_16)
		do
			c_set_pb_count (c_pointer, a_pb_count)
		end

	set_pb_count_max (a_pb_count_max: NATURAL_16)
		do
			c_set_pb_count_max (c_pointer, a_pb_count_max)
		end

feature {NONE} -- C getters

	c_pb_id (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct pointer_block *)$tmp)->pb_id;"
		end

	c_pb_count (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct pointer_block *)$tmp)->pb_count;"
		end

	c_pb_count_max (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct pointer_block *)$tmp)->pb_count_max;"
		end

	c_pb_pointer (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct pointer_block *tmp = (struct pointer_block *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->pb_pointer) / sizeof(tmp->pb_pointer[0]);
				return tmp->pb_pointer;
			]"
		end

feature {NONE} -- C setters

	c_set_pb_id (tmp: POINTER; a_pb_id: NATURAL_16)
		external
			"C inline"
		alias
			"((struct pointer_block *)$tmp)->pb_id = $a_pb_id;"
		end

	c_set_pb_count (tmp: POINTER; a_pb_count: NATURAL_16)
		external
			"C inline"
		alias
			"((struct pointer_block *)$tmp)->pb_count = $a_pb_count;"
		end

	c_set_pb_count_max (tmp: POINTER; a_pb_count_max: NATURAL_16)
		external
			"C inline"
		alias
			"((struct pointer_block *)$tmp)->pb_count_max = $a_pb_count_max;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct pointer_block);"
		end

end
