class
	PD_PRT_PS_CHARSET_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	charset: CE_POINTER [INTEGER_8] assign set_charset
		do
			create Result.make_shared (c_charset (c_pointer))
		end

	cmap_charset: CE_POINTER [INTEGER_8] assign set_cmap_charset
		do
			create Result.make_shared (c_cmap_charset (c_pointer))
		end

	has_charset: INTEGER_32 assign set_has_charset
		do
			Result := c_has_charset (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_charset (a_charset: CE_POINTER [INTEGER_8])
		do
			c_set_charset (c_pointer, a_charset.c_pointer)
		end

	set_cmap_charset (a_cmap_charset: CE_POINTER [INTEGER_8])
		do
			c_set_cmap_charset (c_pointer, a_cmap_charset.c_pointer)
		end

	set_has_charset (a_has_charset: INTEGER_32)
		do
			c_set_has_charset (c_pointer, a_has_charset)
		end

feature {NONE} -- C getters

	c_charset (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct prt_ps_charset_S *)$tmp)->charset;"
		end

	c_cmap_charset (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct prt_ps_charset_S *)$tmp)->cmap_charset;"
		end

	c_has_charset (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct prt_ps_charset_S *)$tmp)->has_charset;"
		end

feature {NONE} -- C setters

	c_set_charset (tmp: POINTER; a_charset: POINTER)
		external
			"C inline"
		alias
			"((struct prt_ps_charset_S *)$tmp)->charset = (char *)$a_charset;"
		end

	c_set_cmap_charset (tmp: POINTER; a_cmap_charset: POINTER)
		external
			"C inline"
		alias
			"((struct prt_ps_charset_S *)$tmp)->cmap_charset = (char *)$a_cmap_charset;"
		end

	c_set_has_charset (tmp: POINTER; a_has_charset: INTEGER_32)
		external
			"C inline"
		alias
			"((struct prt_ps_charset_S *)$tmp)->has_charset = $a_has_charset;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct prt_ps_charset_S);"
		end

end
