class
	PD_PRT_PS_FONT_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	wx: INTEGER_32 assign set_wx
		do
			Result := c_wx (c_pointer)
		end

	uline_offset: INTEGER_32 assign set_uline_offset
		do
			Result := c_uline_offset (c_pointer)
		end

	uline_width: INTEGER_32 assign set_uline_width
		do
			Result := c_uline_width (c_pointer)
		end

	bbox_min_y: INTEGER_32 assign set_bbox_min_y
		do
			Result := c_bbox_min_y (c_pointer)
		end

	bbox_max_y: INTEGER_32 assign set_bbox_max_y
		do
			Result := c_bbox_max_y (c_pointer)
		end

	ps_fontname: CE_ARRAY [CE_POINTER [INTEGER_8]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_ps_fontname (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_wx (a_wx: INTEGER_32)
		do
			c_set_wx (c_pointer, a_wx)
		end

	set_uline_offset (a_uline_offset: INTEGER_32)
		do
			c_set_uline_offset (c_pointer, a_uline_offset)
		end

	set_uline_width (a_uline_width: INTEGER_32)
		do
			c_set_uline_width (c_pointer, a_uline_width)
		end

	set_bbox_min_y (a_bbox_min_y: INTEGER_32)
		do
			c_set_bbox_min_y (c_pointer, a_bbox_min_y)
		end

	set_bbox_max_y (a_bbox_max_y: INTEGER_32)
		do
			c_set_bbox_max_y (c_pointer, a_bbox_max_y)
		end

feature {NONE} -- C getters

	c_wx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct prt_ps_font_S *)$tmp)->wx;"
		end

	c_uline_offset (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct prt_ps_font_S *)$tmp)->uline_offset;"
		end

	c_uline_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct prt_ps_font_S *)$tmp)->uline_width;"
		end

	c_bbox_min_y (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct prt_ps_font_S *)$tmp)->bbox_min_y;"
		end

	c_bbox_max_y (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct prt_ps_font_S *)$tmp)->bbox_max_y;"
		end

	c_ps_fontname (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct prt_ps_font_S *tmp = (struct prt_ps_font_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->ps_fontname) / sizeof(tmp->ps_fontname[0]);
				return tmp->ps_fontname;
			]"
		end

feature {NONE} -- C setters

	c_set_wx (tmp: POINTER; a_wx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct prt_ps_font_S *)$tmp)->wx = $a_wx;"
		end

	c_set_uline_offset (tmp: POINTER; a_uline_offset: INTEGER_32)
		external
			"C inline"
		alias
			"((struct prt_ps_font_S *)$tmp)->uline_offset = $a_uline_offset;"
		end

	c_set_uline_width (tmp: POINTER; a_uline_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct prt_ps_font_S *)$tmp)->uline_width = $a_uline_width;"
		end

	c_set_bbox_min_y (tmp: POINTER; a_bbox_min_y: INTEGER_32)
		external
			"C inline"
		alias
			"((struct prt_ps_font_S *)$tmp)->bbox_min_y = $a_bbox_min_y;"
		end

	c_set_bbox_max_y (tmp: POINTER; a_bbox_max_y: INTEGER_32)
		external
			"C inline"
		alias
			"((struct prt_ps_font_S *)$tmp)->bbox_max_y = $a_bbox_max_y;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct prt_ps_font_S);"
		end

end
