class
	PD_PRT_PS_MBFONT_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	num_encodings: INTEGER_32 assign set_num_encodings
		do
			Result := c_num_encodings (c_pointer)
		end

	encodings: CE_POINTER [PD_PRT_PS_ENCODING_S] assign set_encodings
		do
			create Result.make_shared (c_encodings (c_pointer))
		end

	num_charsets: INTEGER_32 assign set_num_charsets
		do
			Result := c_num_charsets (c_pointer)
		end

	charsets: CE_POINTER [PD_PRT_PS_CHARSET_S] assign set_charsets
		do
			create Result.make_shared (c_charsets (c_pointer))
		end

	ascii_enc: CE_POINTER [INTEGER_8] assign set_ascii_enc
		do
			create Result.make_shared (c_ascii_enc (c_pointer))
		end

	defcs: CE_POINTER [INTEGER_8] assign set_defcs
		do
			create Result.make_shared (c_defcs (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_num_encodings (a_num_encodings: INTEGER_32)
		do
			c_set_num_encodings (c_pointer, a_num_encodings)
		end

	set_encodings (a_encodings: CE_POINTER [PD_PRT_PS_ENCODING_S])
		do
			c_set_encodings (c_pointer, a_encodings.c_pointer)
		end

	set_num_charsets (a_num_charsets: INTEGER_32)
		do
			c_set_num_charsets (c_pointer, a_num_charsets)
		end

	set_charsets (a_charsets: CE_POINTER [PD_PRT_PS_CHARSET_S])
		do
			c_set_charsets (c_pointer, a_charsets.c_pointer)
		end

	set_ascii_enc (a_ascii_enc: CE_POINTER [INTEGER_8])
		do
			c_set_ascii_enc (c_pointer, a_ascii_enc.c_pointer)
		end

	set_defcs (a_defcs: CE_POINTER [INTEGER_8])
		do
			c_set_defcs (c_pointer, a_defcs.c_pointer)
		end

feature {NONE} -- C getters

	c_num_encodings (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct prt_ps_mbfont_S *)$tmp)->num_encodings;"
		end

	c_encodings (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct prt_ps_encoding_S *)((struct prt_ps_mbfont_S *)$tmp)->encodings;"
		end

	c_num_charsets (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct prt_ps_mbfont_S *)$tmp)->num_charsets;"
		end

	c_charsets (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct prt_ps_charset_S *)((struct prt_ps_mbfont_S *)$tmp)->charsets;"
		end

	c_ascii_enc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct prt_ps_mbfont_S *)$tmp)->ascii_enc;"
		end

	c_defcs (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct prt_ps_mbfont_S *)$tmp)->defcs;"
		end

feature {NONE} -- C setters

	c_set_num_encodings (tmp: POINTER; a_num_encodings: INTEGER_32)
		external
			"C inline"
		alias
			"((struct prt_ps_mbfont_S *)$tmp)->num_encodings = $a_num_encodings;"
		end

	c_set_encodings (tmp: POINTER; a_encodings: POINTER)
		external
			"C inline"
		alias
			"((struct prt_ps_mbfont_S *)$tmp)->encodings = (struct prt_ps_encoding_S *)$a_encodings;"
		end

	c_set_num_charsets (tmp: POINTER; a_num_charsets: INTEGER_32)
		external
			"C inline"
		alias
			"((struct prt_ps_mbfont_S *)$tmp)->num_charsets = $a_num_charsets;"
		end

	c_set_charsets (tmp: POINTER; a_charsets: POINTER)
		external
			"C inline"
		alias
			"((struct prt_ps_mbfont_S *)$tmp)->charsets = (struct prt_ps_charset_S *)$a_charsets;"
		end

	c_set_ascii_enc (tmp: POINTER; a_ascii_enc: POINTER)
		external
			"C inline"
		alias
			"((struct prt_ps_mbfont_S *)$tmp)->ascii_enc = (char *)$a_ascii_enc;"
		end

	c_set_defcs (tmp: POINTER; a_defcs: POINTER)
		external
			"C inline"
		alias
			"((struct prt_ps_mbfont_S *)$tmp)->defcs = (char *)$a_defcs;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct prt_ps_mbfont_S);"
		end

end
