class
	PD_PRT_RESFILE_BUFFER_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	buffer: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_buffer (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	len: INTEGER_32 assign set_len
		do
			Result := c_len (c_pointer)
		end

	line_start: INTEGER_32 assign set_line_start
		do
			Result := c_line_start (c_pointer)
		end

	line_end: INTEGER_32 assign set_line_end
		do
			Result := c_line_end (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_len (a_len: INTEGER_32)
		do
			c_set_len (c_pointer, a_len)
		end

	set_line_start (a_line_start: INTEGER_32)
		do
			c_set_line_start (c_pointer, a_line_start)
		end

	set_line_end (a_line_end: INTEGER_32)
		do
			c_set_line_end (c_pointer, a_line_end)
		end

feature {NONE} -- C getters

	c_buffer (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct prt_resfile_buffer_S *tmp = (struct prt_resfile_buffer_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->buffer) / sizeof(tmp->buffer[0]);
				return tmp->buffer;
			]"
		end

	c_len (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct prt_resfile_buffer_S *)$tmp)->len;"
		end

	c_line_start (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct prt_resfile_buffer_S *)$tmp)->line_start;"
		end

	c_line_end (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct prt_resfile_buffer_S *)$tmp)->line_end;"
		end

feature {NONE} -- C setters

	c_set_len (tmp: POINTER; a_len: INTEGER_32)
		external
			"C inline"
		alias
			"((struct prt_resfile_buffer_S *)$tmp)->len = $a_len;"
		end

	c_set_line_start (tmp: POINTER; a_line_start: INTEGER_32)
		external
			"C inline"
		alias
			"((struct prt_resfile_buffer_S *)$tmp)->line_start = $a_line_start;"
		end

	c_set_line_end (tmp: POINTER; a_line_end: INTEGER_32)
		external
			"C inline"
		alias
			"((struct prt_resfile_buffer_S *)$tmp)->line_end = $a_line_end;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct prt_resfile_buffer_S);"
		end

end
