class
	PD_PRT_SETTINGS_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	n_collated_copies: INTEGER_32 assign set_n_collated_copies
		do
			Result := c_n_collated_copies (c_pointer)
		end

	n_uncollated_copies: INTEGER_32 assign set_n_uncollated_copies
		do
			Result := c_n_uncollated_copies (c_pointer)
		end

	duplex: INTEGER_32 assign set_duplex
		do
			Result := c_duplex (c_pointer)
		end

	chars_per_line: INTEGER_32 assign set_chars_per_line
		do
			Result := c_chars_per_line (c_pointer)
		end

	lines_per_page: INTEGER_32 assign set_lines_per_page
		do
			Result := c_lines_per_page (c_pointer)
		end

	has_color: INTEGER_32 assign set_has_color
		do
			Result := c_has_color (c_pointer)
		end

	number: PD_PRT_TEXT_ATTR_T assign set_number
		do
			create Result.make_shared (c_number (c_pointer))
		end

	number_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_prt_settings_T_539, number);"
		end

	modec: INTEGER_32 assign set_modec
		do
			Result := c_modec (c_pointer)
		end

	do_syntax: INTEGER_32 assign set_do_syntax
		do
			Result := c_do_syntax (c_pointer)
		end

	user_abort: INTEGER_32 assign set_user_abort
		do
			Result := c_user_abort (c_pointer)
		end

	jobname: CE_POINTER [NATURAL_8] assign set_jobname
		do
			create Result.make_shared (c_jobname (c_pointer))
		end

	outfile: CE_POINTER [NATURAL_8] assign set_outfile
		do
			create Result.make_shared (c_outfile (c_pointer))
		end

	arguments: CE_POINTER [NATURAL_8] assign set_arguments
		do
			create Result.make_shared (c_arguments (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_n_collated_copies (a_n_collated_copies: INTEGER_32)
		do
			c_set_n_collated_copies (c_pointer, a_n_collated_copies)
		end

	set_n_uncollated_copies (a_n_uncollated_copies: INTEGER_32)
		do
			c_set_n_uncollated_copies (c_pointer, a_n_uncollated_copies)
		end

	set_duplex (a_duplex: INTEGER_32)
		do
			c_set_duplex (c_pointer, a_duplex)
		end

	set_chars_per_line (a_chars_per_line: INTEGER_32)
		do
			c_set_chars_per_line (c_pointer, a_chars_per_line)
		end

	set_lines_per_page (a_lines_per_page: INTEGER_32)
		do
			c_set_lines_per_page (c_pointer, a_lines_per_page)
		end

	set_has_color (a_has_color: INTEGER_32)
		do
			c_set_has_color (c_pointer, a_has_color)
		end

	set_number (a_number: PD_PRT_TEXT_ATTR_T)
		do
			number.ce_gets (a_number)
		end

	set_modec (a_modec: INTEGER_32)
		do
			c_set_modec (c_pointer, a_modec)
		end

	set_do_syntax (a_do_syntax: INTEGER_32)
		do
			c_set_do_syntax (c_pointer, a_do_syntax)
		end

	set_user_abort (a_user_abort: INTEGER_32)
		do
			c_set_user_abort (c_pointer, a_user_abort)
		end

	set_jobname (a_jobname: CE_POINTER [NATURAL_8])
		do
			c_set_jobname (c_pointer, a_jobname.c_pointer)
		end

	set_outfile (a_outfile: CE_POINTER [NATURAL_8])
		do
			c_set_outfile (c_pointer, a_outfile.c_pointer)
		end

	set_arguments (a_arguments: CE_POINTER [NATURAL_8])
		do
			c_set_arguments (c_pointer, a_arguments.c_pointer)
		end

feature {NONE} -- C getters

	c_n_collated_copies (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_prt_settings_T_539 *)$tmp)->n_collated_copies;"
		end

	c_n_uncollated_copies (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_prt_settings_T_539 *)$tmp)->n_uncollated_copies;"
		end

	c_duplex (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_prt_settings_T_539 *)$tmp)->duplex;"
		end

	c_chars_per_line (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_prt_settings_T_539 *)$tmp)->chars_per_line;"
		end

	c_lines_per_page (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_prt_settings_T_539 *)$tmp)->lines_per_page;"
		end

	c_has_color (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_prt_settings_T_539 *)$tmp)->has_color;"
		end

	c_number (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (prt_text_attr_T *)&((struct __anonstruct_prt_settings_T_539 *)$tmp)->number;"
		end

	c_modec (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_prt_settings_T_539 *)$tmp)->modec;"
		end

	c_do_syntax (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_prt_settings_T_539 *)$tmp)->do_syntax;"
		end

	c_user_abort (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_prt_settings_T_539 *)$tmp)->user_abort;"
		end

	c_jobname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_prt_settings_T_539 *)$tmp)->jobname;"
		end

	c_outfile (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_prt_settings_T_539 *)$tmp)->outfile;"
		end

	c_arguments (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_prt_settings_T_539 *)$tmp)->arguments;"
		end

feature {NONE} -- C setters

	c_set_n_collated_copies (tmp: POINTER; a_n_collated_copies: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_settings_T_539 *)$tmp)->n_collated_copies = $a_n_collated_copies;"
		end

	c_set_n_uncollated_copies (tmp: POINTER; a_n_uncollated_copies: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_settings_T_539 *)$tmp)->n_uncollated_copies = $a_n_uncollated_copies;"
		end

	c_set_duplex (tmp: POINTER; a_duplex: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_settings_T_539 *)$tmp)->duplex = $a_duplex;"
		end

	c_set_chars_per_line (tmp: POINTER; a_chars_per_line: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_settings_T_539 *)$tmp)->chars_per_line = $a_chars_per_line;"
		end

	c_set_lines_per_page (tmp: POINTER; a_lines_per_page: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_settings_T_539 *)$tmp)->lines_per_page = $a_lines_per_page;"
		end

	c_set_has_color (tmp: POINTER; a_has_color: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_settings_T_539 *)$tmp)->has_color = $a_has_color;"
		end

	c_set_modec (tmp: POINTER; a_modec: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_settings_T_539 *)$tmp)->modec = $a_modec;"
		end

	c_set_do_syntax (tmp: POINTER; a_do_syntax: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_settings_T_539 *)$tmp)->do_syntax = $a_do_syntax;"
		end

	c_set_user_abort (tmp: POINTER; a_user_abort: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_settings_T_539 *)$tmp)->user_abort = $a_user_abort;"
		end

	c_set_jobname (tmp: POINTER; a_jobname: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_settings_T_539 *)$tmp)->jobname = (unsigned char *)$a_jobname;"
		end

	c_set_outfile (tmp: POINTER; a_outfile: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_settings_T_539 *)$tmp)->outfile = (unsigned char *)$a_outfile;"
		end

	c_set_arguments (tmp: POINTER; a_arguments: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_settings_T_539 *)$tmp)->arguments = (unsigned char *)$a_arguments;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_prt_settings_T_539);"
		end

end
