class
	PD_QF_INFO_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	qf_refcount: INTEGER_32 assign set_qf_refcount
		do
			Result := c_qf_refcount (c_pointer)
		end

	qf_listcount: INTEGER_32 assign set_qf_listcount
		do
			Result := c_qf_listcount (c_pointer)
		end

	qf_curlist: INTEGER_32 assign set_qf_curlist
		do
			Result := c_qf_curlist (c_pointer)
		end

	qf_lists: CE_ARRAY [PD_QF_LIST_S]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_qf_lists (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_qf_refcount (a_qf_refcount: INTEGER_32)
		do
			c_set_qf_refcount (c_pointer, a_qf_refcount)
		end

	set_qf_listcount (a_qf_listcount: INTEGER_32)
		do
			c_set_qf_listcount (c_pointer, a_qf_listcount)
		end

	set_qf_curlist (a_qf_curlist: INTEGER_32)
		do
			c_set_qf_curlist (c_pointer, a_qf_curlist)
		end

feature {NONE} -- C getters

	c_qf_refcount (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct qf_info_S *)$tmp)->qf_refcount;"
		end

	c_qf_listcount (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct qf_info_S *)$tmp)->qf_listcount;"
		end

	c_qf_curlist (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct qf_info_S *)$tmp)->qf_curlist;"
		end

	c_qf_lists (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct qf_info_S *tmp = (struct qf_info_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->qf_lists) / sizeof(tmp->qf_lists[0]);
				return tmp->qf_lists;
			]"
		end

feature {NONE} -- C setters

	c_set_qf_refcount (tmp: POINTER; a_qf_refcount: INTEGER_32)
		external
			"C inline"
		alias
			"((struct qf_info_S *)$tmp)->qf_refcount = $a_qf_refcount;"
		end

	c_set_qf_listcount (tmp: POINTER; a_qf_listcount: INTEGER_32)
		external
			"C inline"
		alias
			"((struct qf_info_S *)$tmp)->qf_listcount = $a_qf_listcount;"
		end

	c_set_qf_curlist (tmp: POINTER; a_qf_curlist: INTEGER_32)
		external
			"C inline"
		alias
			"((struct qf_info_S *)$tmp)->qf_curlist = $a_qf_curlist;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct qf_info_S);"
		end

end
