class
	PD_REGBEHIND_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	save_after: PD_REGSAVE_T assign set_save_after
		do
			create Result.make_shared (c_save_after (c_pointer))
		end

	save_after_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct regbehind_S, save_after);"
		end

	save_behind: PD_REGSAVE_T assign set_save_behind
		do
			create Result.make_shared (c_save_behind (c_pointer))
		end

	save_need_clear_subexpr: INTEGER_32 assign set_save_need_clear_subexpr
		do
			Result := c_save_need_clear_subexpr (c_pointer)
		end

	save_start: CE_ARRAY [PD_SAVE_SE_T]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_save_start (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	save_end: CE_ARRAY [PD_SAVE_SE_T]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_save_end (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_save_after (a_save_after: PD_REGSAVE_T)
		do
			save_after.ce_gets (a_save_after)
		end

	set_save_behind (a_save_behind: PD_REGSAVE_T)
		do
			save_behind.ce_gets (a_save_behind)
		end

	set_save_need_clear_subexpr (a_save_need_clear_subexpr: INTEGER_32)
		do
			c_set_save_need_clear_subexpr (c_pointer, a_save_need_clear_subexpr)
		end

feature {NONE} -- C getters

	c_save_after (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (regsave_T *)&((struct regbehind_S *)$tmp)->save_after;"
		end

	c_save_behind (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (regsave_T *)&((struct regbehind_S *)$tmp)->save_behind;"
		end

	c_save_need_clear_subexpr (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct regbehind_S *)$tmp)->save_need_clear_subexpr;"
		end

	c_save_start (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct regbehind_S *tmp = (struct regbehind_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->save_start) / sizeof(tmp->save_start[0]);
				return tmp->save_start;
			]"
		end

	c_save_end (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct regbehind_S *tmp = (struct regbehind_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->save_end) / sizeof(tmp->save_end[0]);
				return tmp->save_end;
			]"
		end

feature {NONE} -- C setters

	c_set_save_need_clear_subexpr (tmp: POINTER; a_save_need_clear_subexpr: INTEGER_32)
		external
			"C inline"
		alias
			"((struct regbehind_S *)$tmp)->save_need_clear_subexpr = $a_save_need_clear_subexpr;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct regbehind_S);"
		end

end
