class
	PD_REGITEM_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	rs_state: INTEGER_32 assign set_rs_state
		do
			Result := c_rs_state (c_pointer)
		end

	rs_scan: CE_POINTER [NATURAL_8] assign set_rs_scan
		do
			create Result.make_shared (c_rs_scan (c_pointer))
		end

	rs_un: PD_RS_UN assign set_rs_un
		do
			create Result.make_shared (c_rs_un (c_pointer))
		end

	rs_un_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct regitem_S, rs_un);"
		end

	rs_no: INTEGER_16 assign set_rs_no
		do
			Result := c_rs_no (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_rs_state (a_rs_state: INTEGER_32)
		do
			c_set_rs_state (c_pointer, a_rs_state)
		end

	set_rs_scan (a_rs_scan: CE_POINTER [NATURAL_8])
		do
			c_set_rs_scan (c_pointer, a_rs_scan.c_pointer)
		end

	set_rs_un (a_rs_un: PD_RS_UN)
		do
			rs_un.ce_gets (a_rs_un)
		end

	set_rs_no (a_rs_no: INTEGER_16)
		do
			c_set_rs_no (c_pointer, a_rs_no)
		end

feature {NONE} -- C getters

	c_rs_state (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct regitem_S *)$tmp)->rs_state;"
		end

	c_rs_scan (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct regitem_S *)$tmp)->rs_scan;"
		end

	c_rs_un (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_rs_un_547 *)&((struct regitem_S *)$tmp)->rs_un;"
		end

	c_rs_no (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct regitem_S *)$tmp)->rs_no;"
		end

feature {NONE} -- C setters

	c_set_rs_state (tmp: POINTER; a_rs_state: INTEGER_32)
		external
			"C inline"
		alias
			"((struct regitem_S *)$tmp)->rs_state = $a_rs_state;"
		end

	c_set_rs_scan (tmp: POINTER; a_rs_scan: POINTER)
		external
			"C inline"
		alias
			"((struct regitem_S *)$tmp)->rs_scan = (unsigned char *)$a_rs_scan;"
		end

	c_set_rs_no (tmp: POINTER; a_rs_no: INTEGER_16)
		external
			"C inline"
		alias
			"((struct regitem_S *)$tmp)->rs_no = $a_rs_no;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct regitem_S);"
		end

end
