class
	PD_REGPROG_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	regstart: INTEGER_32 assign set_regstart
		do
			Result := c_regstart (c_pointer)
		end

	reganch: NATURAL_8 assign set_reganch
		do
			Result := c_reganch (c_pointer)
		end

	regmust: CE_POINTER [NATURAL_8] assign set_regmust
		do
			create Result.make_shared (c_regmust (c_pointer))
		end

	regmlen: INTEGER_32 assign set_regmlen
		do
			Result := c_regmlen (c_pointer)
		end

	regmlen_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_regprog_T_65, regmlen);"
		end

	regflags: NATURAL_32 assign set_regflags
		do
			Result := c_regflags (c_pointer)
		end

	reghasz: NATURAL_8 assign set_reghasz
		do
			Result := c_reghasz (c_pointer)
		end

	program: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_program (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_regstart (a_regstart: INTEGER_32)
		do
			c_set_regstart (c_pointer, a_regstart)
		end

	set_reganch (a_reganch: NATURAL_8)
		do
			c_set_reganch (c_pointer, a_reganch)
		end

	set_regmust (a_regmust: CE_POINTER [NATURAL_8])
		do
			c_set_regmust (c_pointer, a_regmust.c_pointer)
		end

	set_regmlen (a_regmlen: INTEGER_32)
		do
			c_set_regmlen (c_pointer, a_regmlen)
		end

	set_regflags (a_regflags: NATURAL_32)
		do
			c_set_regflags (c_pointer, a_regflags)
		end

	set_reghasz (a_reghasz: NATURAL_8)
		do
			c_set_reghasz (c_pointer, a_reghasz)
		end

feature {NONE} -- C getters

	c_regstart (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_regprog_T_65 *)$tmp)->regstart;"
		end

	c_reganch (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct __anonstruct_regprog_T_65 *)$tmp)->reganch;"
		end

	c_regmust (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_regprog_T_65 *)$tmp)->regmust;"
		end

	c_regmlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_regprog_T_65 *)$tmp)->regmlen;"
		end

	c_regflags (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_regprog_T_65 *)$tmp)->regflags;"
		end

	c_reghasz (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct __anonstruct_regprog_T_65 *)$tmp)->reghasz;"
		end

	c_program (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_regprog_T_65 *tmp = (struct __anonstruct_regprog_T_65 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->program) / sizeof(tmp->program[0]);
				return tmp->program;
			]"
		end

feature {NONE} -- C setters

	c_set_regstart (tmp: POINTER; a_regstart: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_regprog_T_65 *)$tmp)->regstart = $a_regstart;"
		end

	c_set_reganch (tmp: POINTER; a_reganch: NATURAL_8)
		external
			"C inline"
		alias
			"((struct __anonstruct_regprog_T_65 *)$tmp)->reganch = $a_reganch;"
		end

	c_set_regmust (tmp: POINTER; a_regmust: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_regprog_T_65 *)$tmp)->regmust = (unsigned char *)$a_regmust;"
		end

	c_set_regmlen (tmp: POINTER; a_regmlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_regprog_T_65 *)$tmp)->regmlen = $a_regmlen;"
		end

	c_set_regflags (tmp: POINTER; a_regflags: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_regprog_T_65 *)$tmp)->regflags = $a_regflags;"
		end

	c_set_reghasz (tmp: POINTER; a_reghasz: NATURAL_8)
		external
			"C inline"
		alias
			"((struct __anonstruct_regprog_T_65 *)$tmp)->reghasz = $a_reghasz;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_regprog_T_65);"
		end

end
