class
	PD_SBLOCK_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sb_used: INTEGER_32 assign set_sb_used
		do
			Result := c_sb_used (c_pointer)
		end

	sb_next: CE_POINTER [PD_SBLOCK_S] assign set_sb_next
		do
			create Result.make_shared (c_sb_next (c_pointer))
		end

	sb_data: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_sb_data (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_sb_used (a_sb_used: INTEGER_32)
		do
			c_set_sb_used (c_pointer, a_sb_used)
		end

	set_sb_next (a_sb_next: CE_POINTER [PD_SBLOCK_S])
		do
			c_set_sb_next (c_pointer, a_sb_next.c_pointer)
		end

feature {NONE} -- C getters

	c_sb_used (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct sblock_S *)$tmp)->sb_used;"
		end

	c_sb_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct sblock_S *)((struct sblock_S *)$tmp)->sb_next;"
		end

	c_sb_data (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct sblock_S *tmp = (struct sblock_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->sb_data) / sizeof(tmp->sb_data[0]);
				return tmp->sb_data;
			]"
		end

feature {NONE} -- C setters

	c_set_sb_used (tmp: POINTER; a_sb_used: INTEGER_32)
		external
			"C inline"
		alias
			"((struct sblock_S *)$tmp)->sb_used = $a_sb_used;"
		end

	c_set_sb_next (tmp: POINTER; a_sb_next: POINTER)
		external
			"C inline"
		alias
			"((struct sblock_S *)$tmp)->sb_next = (struct sblock_S *)$a_sb_next;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct sblock_S);"
		end

end
