class
	PD_SEARCHEDFILE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	fp: CE_POINTER [SD_IO_FILE] assign set_fp
		do
			create Result.make_shared (c_fp (c_pointer))
		end

	name: CE_POINTER [NATURAL_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	lnum: INTEGER_32 assign set_lnum
		do
			Result := c_lnum (c_pointer)
		end

	lnum_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct SearchedFile, lnum);"
		end

	matched: INTEGER_32 assign set_matched
		do
			Result := c_matched (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_fp (a_fp: CE_POINTER [SD_IO_FILE])
		do
			c_set_fp (c_pointer, a_fp.c_pointer)
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_lnum (a_lnum: INTEGER_32)
		do
			c_set_lnum (c_pointer, a_lnum)
		end

	set_matched (a_matched: INTEGER_32)
		do
			c_set_matched (c_pointer, a_matched)
		end

feature {NONE} -- C getters

	c_fp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _IO_FILE *)((struct SearchedFile *)$tmp)->fp;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct SearchedFile *)$tmp)->name;"
		end

	c_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct SearchedFile *)$tmp)->lnum;"
		end

	c_matched (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct SearchedFile *)$tmp)->matched;"
		end

feature {NONE} -- C setters

	c_set_fp (tmp: POINTER; a_fp: POINTER)
		external
			"C inline"
		alias
			"((struct SearchedFile *)$tmp)->fp = (struct _IO_FILE *)$a_fp;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct SearchedFile *)$tmp)->name = (unsigned char *)$a_name;"
		end

	c_set_lnum (tmp: POINTER; a_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct SearchedFile *)$tmp)->lnum = $a_lnum;"
		end

	c_set_matched (tmp: POINTER; a_matched: INTEGER_32)
		external
			"C inline"
		alias
			"((struct SearchedFile *)$tmp)->matched = $a_matched;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct SearchedFile);"
		end

end
