class
	PD_SIGNLIST

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	id: INTEGER_32 assign set_id
		do
			Result := c_id (c_pointer)
		end

	lnum: INTEGER_32 assign set_lnum
		do
			Result := c_lnum (c_pointer)
		end

	typenr: INTEGER_32 assign set_typenr
		do
			Result := c_typenr (c_pointer)
		end

	next: CE_POINTER [PD_SIGNLIST] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	next_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct signlist, next);"
		end

	prev: CE_POINTER [PD_SIGNLIST] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_id (a_id: INTEGER_32)
		do
			c_set_id (c_pointer, a_id)
		end

	set_lnum (a_lnum: INTEGER_32)
		do
			c_set_lnum (c_pointer, a_lnum)
		end

	set_typenr (a_typenr: INTEGER_32)
		do
			c_set_typenr (c_pointer, a_typenr)
		end

	set_next (a_next: CE_POINTER [PD_SIGNLIST])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_SIGNLIST])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

feature {NONE} -- C getters

	c_id (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct signlist *)$tmp)->id;"
		end

	c_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct signlist *)$tmp)->lnum;"
		end

	c_typenr (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct signlist *)$tmp)->typenr;"
		end

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct signlist *)((struct signlist *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct signlist *)((struct signlist *)$tmp)->prev;"
		end

feature {NONE} -- C setters

	c_set_id (tmp: POINTER; a_id: INTEGER_32)
		external
			"C inline"
		alias
			"((struct signlist *)$tmp)->id = $a_id;"
		end

	c_set_lnum (tmp: POINTER; a_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct signlist *)$tmp)->lnum = $a_lnum;"
		end

	c_set_typenr (tmp: POINTER; a_typenr: INTEGER_32)
		external
			"C inline"
		alias
			"((struct signlist *)$tmp)->typenr = $a_typenr;"
		end

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct signlist *)$tmp)->next = (struct signlist *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct signlist *)$tmp)->prev = (struct signlist *)$a_prev;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct signlist);"
		end

end
