class
	PD_SLANG_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sl_next: CE_POINTER [PD_SLANG_S] assign set_sl_next
		do
			create Result.make_shared (c_sl_next (c_pointer))
		end

	sl_name: CE_POINTER [NATURAL_8] assign set_sl_name
		do
			create Result.make_shared (c_sl_name (c_pointer))
		end

	sl_fname: CE_POINTER [NATURAL_8] assign set_sl_fname
		do
			create Result.make_shared (c_sl_fname (c_pointer))
		end

	sl_add: INTEGER_32 assign set_sl_add
		do
			Result := c_sl_add (c_pointer)
		end

	sl_fbyts: CE_POINTER [NATURAL_8] assign set_sl_fbyts
		do
			create Result.make_shared (c_sl_fbyts (c_pointer))
		end

	sl_fbyts_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct slang_S, sl_fbyts);"
		end

	sl_fidxs: CE_POINTER [INTEGER_32] assign set_sl_fidxs
		do
			create Result.make_shared (c_sl_fidxs (c_pointer))
		end

	sl_fidxs_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct slang_S, sl_fidxs);"
		end

	sl_kbyts: CE_POINTER [NATURAL_8] assign set_sl_kbyts
		do
			create Result.make_shared (c_sl_kbyts (c_pointer))
		end

	sl_kbyts_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct slang_S, sl_kbyts);"
		end

	sl_kidxs: CE_POINTER [INTEGER_32] assign set_sl_kidxs
		do
			create Result.make_shared (c_sl_kidxs (c_pointer))
		end

	sl_kidxs_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct slang_S, sl_kidxs);"
		end

	sl_pbyts: CE_POINTER [NATURAL_8] assign set_sl_pbyts
		do
			create Result.make_shared (c_sl_pbyts (c_pointer))
		end

	sl_pbyts_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct slang_S, sl_pbyts);"
		end

	sl_pidxs: CE_POINTER [INTEGER_32] assign set_sl_pidxs
		do
			create Result.make_shared (c_sl_pidxs (c_pointer))
		end

	sl_pidxs_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct slang_S, sl_pidxs);"
		end

	sl_info: CE_POINTER [NATURAL_8] assign set_sl_info
		do
			create Result.make_shared (c_sl_info (c_pointer))
		end

	sl_regions: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_sl_regions (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	sl_midword: CE_POINTER [NATURAL_8] assign set_sl_midword
		do
			create Result.make_shared (c_sl_midword (c_pointer))
		end

	sl_wordcount: PD_HASHTABLE_S assign set_sl_wordcount
		do
			create Result.make_shared (c_sl_wordcount (c_pointer))
		end

	sl_wordcount_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct slang_S, sl_wordcount);"
		end

	sl_compmax: INTEGER_32 assign set_sl_compmax
		do
			Result := c_sl_compmax (c_pointer)
		end

	sl_compminlen: INTEGER_32 assign set_sl_compminlen
		do
			Result := c_sl_compminlen (c_pointer)
		end

	sl_compsylmax: INTEGER_32 assign set_sl_compsylmax
		do
			Result := c_sl_compsylmax (c_pointer)
		end

	sl_compoptions: INTEGER_32 assign set_sl_compoptions
		do
			Result := c_sl_compoptions (c_pointer)
		end

	sl_comppat: PD_GROWARRAY assign set_sl_comppat
		do
			create Result.make_shared (c_sl_comppat (c_pointer))
		end

	sl_comppat_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct slang_S, sl_comppat);"
		end

	sl_compprog: CE_POINTER [PD_REGPROG_T] assign set_sl_compprog
		do
			create Result.make_shared (c_sl_compprog (c_pointer))
		end

	sl_comprules: CE_POINTER [NATURAL_8] assign set_sl_comprules
		do
			create Result.make_shared (c_sl_comprules (c_pointer))
		end

	sl_compstartflags: CE_POINTER [NATURAL_8] assign set_sl_compstartflags
		do
			create Result.make_shared (c_sl_compstartflags (c_pointer))
		end

	sl_compallflags: CE_POINTER [NATURAL_8] assign set_sl_compallflags
		do
			create Result.make_shared (c_sl_compallflags (c_pointer))
		end

	sl_nobreak: NATURAL_8 assign set_sl_nobreak
		do
			Result := c_sl_nobreak (c_pointer)
		end

	sl_syllable: CE_POINTER [NATURAL_8] assign set_sl_syllable
		do
			create Result.make_shared (c_sl_syllable (c_pointer))
		end

	sl_syl_items: PD_GROWARRAY assign set_sl_syl_items
		do
			create Result.make_shared (c_sl_syl_items (c_pointer))
		end

	sl_syl_items_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct slang_S, sl_syl_items);"
		end

	sl_prefixcnt: INTEGER_32 assign set_sl_prefixcnt
		do
			Result := c_sl_prefixcnt (c_pointer)
		end

	sl_prefprog: CE_POINTER [CE_POINTER [PD_REGPROG_T]] assign set_sl_prefprog
		do
			create Result.make_shared (c_sl_prefprog (c_pointer))
		end

	sl_rep: PD_GROWARRAY assign set_sl_rep
		do
			create Result.make_shared (c_sl_rep (c_pointer))
		end

	sl_rep_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct slang_S, sl_rep);"
		end

	sl_rep_first: CE_ARRAY [INTEGER_16]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_sl_rep_first (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	sl_sal: PD_GROWARRAY assign set_sl_sal
		do
			create Result.make_shared (c_sl_sal (c_pointer))
		end

	sl_sal_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct slang_S, sl_sal);"
		end

	sl_sal_first: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_sl_sal_first (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	sl_followup: INTEGER_32 assign set_sl_followup
		do
			Result := c_sl_followup (c_pointer)
		end

	sl_collapse: INTEGER_32 assign set_sl_collapse
		do
			Result := c_sl_collapse (c_pointer)
		end

	sl_rem_accents: INTEGER_32 assign set_sl_rem_accents
		do
			Result := c_sl_rem_accents (c_pointer)
		end

	sl_sofo: INTEGER_32 assign set_sl_sofo
		do
			Result := c_sl_sofo (c_pointer)
		end

	sl_repsal: PD_GROWARRAY assign set_sl_repsal
		do
			create Result.make_shared (c_sl_repsal (c_pointer))
		end

	sl_repsal_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct slang_S, sl_repsal);"
		end

	sl_repsal_first: CE_ARRAY [INTEGER_16]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_sl_repsal_first (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	sl_nosplitsugs: INTEGER_32 assign set_sl_nosplitsugs
		do
			Result := c_sl_nosplitsugs (c_pointer)
		end

	sl_sugtime: INTEGER_32 assign set_sl_sugtime
		do
			Result := c_sl_sugtime (c_pointer)
		end

	sl_sbyts: CE_POINTER [NATURAL_8] assign set_sl_sbyts
		do
			create Result.make_shared (c_sl_sbyts (c_pointer))
		end

	sl_sbyts_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct slang_S, sl_sbyts);"
		end

	sl_sidxs: CE_POINTER [INTEGER_32] assign set_sl_sidxs
		do
			create Result.make_shared (c_sl_sidxs (c_pointer))
		end

	sl_sidxs_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct slang_S, sl_sidxs);"
		end

	sl_sugbuf: CE_POINTER [PD_FILE_BUFFER] assign set_sl_sugbuf
		do
			create Result.make_shared (c_sl_sugbuf (c_pointer))
		end

	sl_sugloaded: INTEGER_32 assign set_sl_sugloaded
		do
			Result := c_sl_sugloaded (c_pointer)
		end

	sl_has_map: INTEGER_32 assign set_sl_has_map
		do
			Result := c_sl_has_map (c_pointer)
		end

	sl_map_hash: PD_HASHTABLE_S assign set_sl_map_hash
		do
			create Result.make_shared (c_sl_map_hash (c_pointer))
		end

	sl_map_hash_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct slang_S, sl_map_hash);"
		end

	sl_map_array: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_sl_map_array (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	sl_sounddone: PD_HASHTABLE_S assign set_sl_sounddone
		do
			create Result.make_shared (c_sl_sounddone (c_pointer))
		end

	sl_sounddone_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct slang_S, sl_sounddone);"
		end

feature {ANY} -- Eiffel setters

	set_sl_next (a_sl_next: CE_POINTER [PD_SLANG_S])
		do
			c_set_sl_next (c_pointer, a_sl_next.c_pointer)
		end

	set_sl_name (a_sl_name: CE_POINTER [NATURAL_8])
		do
			c_set_sl_name (c_pointer, a_sl_name.c_pointer)
		end

	set_sl_fname (a_sl_fname: CE_POINTER [NATURAL_8])
		do
			c_set_sl_fname (c_pointer, a_sl_fname.c_pointer)
		end

	set_sl_add (a_sl_add: INTEGER_32)
		do
			c_set_sl_add (c_pointer, a_sl_add)
		end

	set_sl_fbyts (a_sl_fbyts: CE_POINTER [NATURAL_8])
		do
			c_set_sl_fbyts (c_pointer, a_sl_fbyts.c_pointer)
		end

	set_sl_fidxs (a_sl_fidxs: CE_POINTER [INTEGER_32])
		do
			c_set_sl_fidxs (c_pointer, a_sl_fidxs.c_pointer)
		end

	set_sl_kbyts (a_sl_kbyts: CE_POINTER [NATURAL_8])
		do
			c_set_sl_kbyts (c_pointer, a_sl_kbyts.c_pointer)
		end

	set_sl_kidxs (a_sl_kidxs: CE_POINTER [INTEGER_32])
		do
			c_set_sl_kidxs (c_pointer, a_sl_kidxs.c_pointer)
		end

	set_sl_pbyts (a_sl_pbyts: CE_POINTER [NATURAL_8])
		do
			c_set_sl_pbyts (c_pointer, a_sl_pbyts.c_pointer)
		end

	set_sl_pidxs (a_sl_pidxs: CE_POINTER [INTEGER_32])
		do
			c_set_sl_pidxs (c_pointer, a_sl_pidxs.c_pointer)
		end

	set_sl_info (a_sl_info: CE_POINTER [NATURAL_8])
		do
			c_set_sl_info (c_pointer, a_sl_info.c_pointer)
		end

	set_sl_midword (a_sl_midword: CE_POINTER [NATURAL_8])
		do
			c_set_sl_midword (c_pointer, a_sl_midword.c_pointer)
		end

	set_sl_wordcount (a_sl_wordcount: PD_HASHTABLE_S)
		do
			sl_wordcount.ce_gets (a_sl_wordcount)
		end

	set_sl_compmax (a_sl_compmax: INTEGER_32)
		do
			c_set_sl_compmax (c_pointer, a_sl_compmax)
		end

	set_sl_compminlen (a_sl_compminlen: INTEGER_32)
		do
			c_set_sl_compminlen (c_pointer, a_sl_compminlen)
		end

	set_sl_compsylmax (a_sl_compsylmax: INTEGER_32)
		do
			c_set_sl_compsylmax (c_pointer, a_sl_compsylmax)
		end

	set_sl_compoptions (a_sl_compoptions: INTEGER_32)
		do
			c_set_sl_compoptions (c_pointer, a_sl_compoptions)
		end

	set_sl_comppat (a_sl_comppat: PD_GROWARRAY)
		do
			sl_comppat.ce_gets (a_sl_comppat)
		end

	set_sl_compprog (a_sl_compprog: CE_POINTER [PD_REGPROG_T])
		do
			c_set_sl_compprog (c_pointer, a_sl_compprog.c_pointer)
		end

	set_sl_comprules (a_sl_comprules: CE_POINTER [NATURAL_8])
		do
			c_set_sl_comprules (c_pointer, a_sl_comprules.c_pointer)
		end

	set_sl_compstartflags (a_sl_compstartflags: CE_POINTER [NATURAL_8])
		do
			c_set_sl_compstartflags (c_pointer, a_sl_compstartflags.c_pointer)
		end

	set_sl_compallflags (a_sl_compallflags: CE_POINTER [NATURAL_8])
		do
			c_set_sl_compallflags (c_pointer, a_sl_compallflags.c_pointer)
		end

	set_sl_nobreak (a_sl_nobreak: NATURAL_8)
		do
			c_set_sl_nobreak (c_pointer, a_sl_nobreak)
		end

	set_sl_syllable (a_sl_syllable: CE_POINTER [NATURAL_8])
		do
			c_set_sl_syllable (c_pointer, a_sl_syllable.c_pointer)
		end

	set_sl_syl_items (a_sl_syl_items: PD_GROWARRAY)
		do
			sl_syl_items.ce_gets (a_sl_syl_items)
		end

	set_sl_prefixcnt (a_sl_prefixcnt: INTEGER_32)
		do
			c_set_sl_prefixcnt (c_pointer, a_sl_prefixcnt)
		end

	set_sl_prefprog (a_sl_prefprog: CE_POINTER [CE_POINTER [PD_REGPROG_T]])
		do
			c_set_sl_prefprog (c_pointer, a_sl_prefprog.c_pointer)
		end

	set_sl_rep (a_sl_rep: PD_GROWARRAY)
		do
			sl_rep.ce_gets (a_sl_rep)
		end

	set_sl_sal (a_sl_sal: PD_GROWARRAY)
		do
			sl_sal.ce_gets (a_sl_sal)
		end

	set_sl_followup (a_sl_followup: INTEGER_32)
		do
			c_set_sl_followup (c_pointer, a_sl_followup)
		end

	set_sl_collapse (a_sl_collapse: INTEGER_32)
		do
			c_set_sl_collapse (c_pointer, a_sl_collapse)
		end

	set_sl_rem_accents (a_sl_rem_accents: INTEGER_32)
		do
			c_set_sl_rem_accents (c_pointer, a_sl_rem_accents)
		end

	set_sl_sofo (a_sl_sofo: INTEGER_32)
		do
			c_set_sl_sofo (c_pointer, a_sl_sofo)
		end

	set_sl_repsal (a_sl_repsal: PD_GROWARRAY)
		do
			sl_repsal.ce_gets (a_sl_repsal)
		end

	set_sl_nosplitsugs (a_sl_nosplitsugs: INTEGER_32)
		do
			c_set_sl_nosplitsugs (c_pointer, a_sl_nosplitsugs)
		end

	set_sl_sugtime (a_sl_sugtime: INTEGER_32)
		do
			c_set_sl_sugtime (c_pointer, a_sl_sugtime)
		end

	set_sl_sbyts (a_sl_sbyts: CE_POINTER [NATURAL_8])
		do
			c_set_sl_sbyts (c_pointer, a_sl_sbyts.c_pointer)
		end

	set_sl_sidxs (a_sl_sidxs: CE_POINTER [INTEGER_32])
		do
			c_set_sl_sidxs (c_pointer, a_sl_sidxs.c_pointer)
		end

	set_sl_sugbuf (a_sl_sugbuf: CE_POINTER [PD_FILE_BUFFER])
		do
			c_set_sl_sugbuf (c_pointer, a_sl_sugbuf.c_pointer)
		end

	set_sl_sugloaded (a_sl_sugloaded: INTEGER_32)
		do
			c_set_sl_sugloaded (c_pointer, a_sl_sugloaded)
		end

	set_sl_has_map (a_sl_has_map: INTEGER_32)
		do
			c_set_sl_has_map (c_pointer, a_sl_has_map)
		end

	set_sl_map_hash (a_sl_map_hash: PD_HASHTABLE_S)
		do
			sl_map_hash.ce_gets (a_sl_map_hash)
		end

	set_sl_sounddone (a_sl_sounddone: PD_HASHTABLE_S)
		do
			sl_sounddone.ce_gets (a_sl_sounddone)
		end

feature {NONE} -- C getters

	c_sl_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct slang_S *)((struct slang_S *)$tmp)->sl_next;"
		end

	c_sl_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct slang_S *)$tmp)->sl_name;"
		end

	c_sl_fname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct slang_S *)$tmp)->sl_fname;"
		end

	c_sl_add (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct slang_S *)$tmp)->sl_add;"
		end

	c_sl_fbyts (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct slang_S *)$tmp)->sl_fbyts;"
		end

	c_sl_fidxs (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int *)((struct slang_S *)$tmp)->sl_fidxs;"
		end

	c_sl_kbyts (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct slang_S *)$tmp)->sl_kbyts;"
		end

	c_sl_kidxs (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int *)((struct slang_S *)$tmp)->sl_kidxs;"
		end

	c_sl_pbyts (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct slang_S *)$tmp)->sl_pbyts;"
		end

	c_sl_pidxs (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int *)((struct slang_S *)$tmp)->sl_pidxs;"
		end

	c_sl_info (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct slang_S *)$tmp)->sl_info;"
		end

	c_sl_regions (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct slang_S *tmp = (struct slang_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->sl_regions) / sizeof(tmp->sl_regions[0]);
				return tmp->sl_regions;
			]"
		end

	c_sl_midword (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct slang_S *)$tmp)->sl_midword;"
		end

	c_sl_wordcount (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct hashtable_S *)&((struct slang_S *)$tmp)->sl_wordcount;"
		end

	c_sl_compmax (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct slang_S *)$tmp)->sl_compmax;"
		end

	c_sl_compminlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct slang_S *)$tmp)->sl_compminlen;"
		end

	c_sl_compsylmax (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct slang_S *)$tmp)->sl_compsylmax;"
		end

	c_sl_compoptions (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct slang_S *)$tmp)->sl_compoptions;"
		end

	c_sl_comppat (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct slang_S *)$tmp)->sl_comppat;"
		end

	c_sl_compprog (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (regprog_T *)((struct slang_S *)$tmp)->sl_compprog;"
		end

	c_sl_comprules (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct slang_S *)$tmp)->sl_comprules;"
		end

	c_sl_compstartflags (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct slang_S *)$tmp)->sl_compstartflags;"
		end

	c_sl_compallflags (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct slang_S *)$tmp)->sl_compallflags;"
		end

	c_sl_nobreak (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct slang_S *)$tmp)->sl_nobreak;"
		end

	c_sl_syllable (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct slang_S *)$tmp)->sl_syllable;"
		end

	c_sl_syl_items (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct slang_S *)$tmp)->sl_syl_items;"
		end

	c_sl_prefixcnt (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct slang_S *)$tmp)->sl_prefixcnt;"
		end

	c_sl_prefprog (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (regprog_T * *)((struct slang_S *)$tmp)->sl_prefprog;"
		end

	c_sl_rep (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct slang_S *)$tmp)->sl_rep;"
		end

	c_sl_rep_first (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct slang_S *tmp = (struct slang_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->sl_rep_first) / sizeof(tmp->sl_rep_first[0]);
				return tmp->sl_rep_first;
			]"
		end

	c_sl_sal (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct slang_S *)$tmp)->sl_sal;"
		end

	c_sl_sal_first (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct slang_S *tmp = (struct slang_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->sl_sal_first) / sizeof(tmp->sl_sal_first[0]);
				return tmp->sl_sal_first;
			]"
		end

	c_sl_followup (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct slang_S *)$tmp)->sl_followup;"
		end

	c_sl_collapse (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct slang_S *)$tmp)->sl_collapse;"
		end

	c_sl_rem_accents (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct slang_S *)$tmp)->sl_rem_accents;"
		end

	c_sl_sofo (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct slang_S *)$tmp)->sl_sofo;"
		end

	c_sl_repsal (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct slang_S *)$tmp)->sl_repsal;"
		end

	c_sl_repsal_first (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct slang_S *tmp = (struct slang_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->sl_repsal_first) / sizeof(tmp->sl_repsal_first[0]);
				return tmp->sl_repsal_first;
			]"
		end

	c_sl_nosplitsugs (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct slang_S *)$tmp)->sl_nosplitsugs;"
		end

	c_sl_sugtime (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct slang_S *)$tmp)->sl_sugtime;"
		end

	c_sl_sbyts (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct slang_S *)$tmp)->sl_sbyts;"
		end

	c_sl_sidxs (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int *)((struct slang_S *)$tmp)->sl_sidxs;"
		end

	c_sl_sugbuf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct file_buffer *)((struct slang_S *)$tmp)->sl_sugbuf;"
		end

	c_sl_sugloaded (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct slang_S *)$tmp)->sl_sugloaded;"
		end

	c_sl_has_map (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct slang_S *)$tmp)->sl_has_map;"
		end

	c_sl_map_hash (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct hashtable_S *)&((struct slang_S *)$tmp)->sl_map_hash;"
		end

	c_sl_map_array (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct slang_S *tmp = (struct slang_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->sl_map_array) / sizeof(tmp->sl_map_array[0]);
				return tmp->sl_map_array;
			]"
		end

	c_sl_sounddone (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct hashtable_S *)&((struct slang_S *)$tmp)->sl_sounddone;"
		end

feature {NONE} -- C setters

	c_set_sl_next (tmp: POINTER; a_sl_next: POINTER)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_next = (struct slang_S *)$a_sl_next;"
		end

	c_set_sl_name (tmp: POINTER; a_sl_name: POINTER)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_name = (unsigned char *)$a_sl_name;"
		end

	c_set_sl_fname (tmp: POINTER; a_sl_fname: POINTER)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_fname = (unsigned char *)$a_sl_fname;"
		end

	c_set_sl_add (tmp: POINTER; a_sl_add: INTEGER_32)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_add = $a_sl_add;"
		end

	c_set_sl_fbyts (tmp: POINTER; a_sl_fbyts: POINTER)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_fbyts = (unsigned char *)$a_sl_fbyts;"
		end

	c_set_sl_fidxs (tmp: POINTER; a_sl_fidxs: POINTER)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_fidxs = (int *)$a_sl_fidxs;"
		end

	c_set_sl_kbyts (tmp: POINTER; a_sl_kbyts: POINTER)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_kbyts = (unsigned char *)$a_sl_kbyts;"
		end

	c_set_sl_kidxs (tmp: POINTER; a_sl_kidxs: POINTER)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_kidxs = (int *)$a_sl_kidxs;"
		end

	c_set_sl_pbyts (tmp: POINTER; a_sl_pbyts: POINTER)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_pbyts = (unsigned char *)$a_sl_pbyts;"
		end

	c_set_sl_pidxs (tmp: POINTER; a_sl_pidxs: POINTER)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_pidxs = (int *)$a_sl_pidxs;"
		end

	c_set_sl_info (tmp: POINTER; a_sl_info: POINTER)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_info = (unsigned char *)$a_sl_info;"
		end

	c_set_sl_midword (tmp: POINTER; a_sl_midword: POINTER)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_midword = (unsigned char *)$a_sl_midword;"
		end

	c_set_sl_compmax (tmp: POINTER; a_sl_compmax: INTEGER_32)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_compmax = $a_sl_compmax;"
		end

	c_set_sl_compminlen (tmp: POINTER; a_sl_compminlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_compminlen = $a_sl_compminlen;"
		end

	c_set_sl_compsylmax (tmp: POINTER; a_sl_compsylmax: INTEGER_32)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_compsylmax = $a_sl_compsylmax;"
		end

	c_set_sl_compoptions (tmp: POINTER; a_sl_compoptions: INTEGER_32)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_compoptions = $a_sl_compoptions;"
		end

	c_set_sl_compprog (tmp: POINTER; a_sl_compprog: POINTER)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_compprog = (regprog_T *)$a_sl_compprog;"
		end

	c_set_sl_comprules (tmp: POINTER; a_sl_comprules: POINTER)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_comprules = (unsigned char *)$a_sl_comprules;"
		end

	c_set_sl_compstartflags (tmp: POINTER; a_sl_compstartflags: POINTER)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_compstartflags = (unsigned char *)$a_sl_compstartflags;"
		end

	c_set_sl_compallflags (tmp: POINTER; a_sl_compallflags: POINTER)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_compallflags = (unsigned char *)$a_sl_compallflags;"
		end

	c_set_sl_nobreak (tmp: POINTER; a_sl_nobreak: NATURAL_8)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_nobreak = $a_sl_nobreak;"
		end

	c_set_sl_syllable (tmp: POINTER; a_sl_syllable: POINTER)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_syllable = (unsigned char *)$a_sl_syllable;"
		end

	c_set_sl_prefixcnt (tmp: POINTER; a_sl_prefixcnt: INTEGER_32)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_prefixcnt = $a_sl_prefixcnt;"
		end

	c_set_sl_prefprog (tmp: POINTER; a_sl_prefprog: POINTER)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_prefprog = (regprog_T * *)$a_sl_prefprog;"
		end

	c_set_sl_followup (tmp: POINTER; a_sl_followup: INTEGER_32)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_followup = $a_sl_followup;"
		end

	c_set_sl_collapse (tmp: POINTER; a_sl_collapse: INTEGER_32)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_collapse = $a_sl_collapse;"
		end

	c_set_sl_rem_accents (tmp: POINTER; a_sl_rem_accents: INTEGER_32)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_rem_accents = $a_sl_rem_accents;"
		end

	c_set_sl_sofo (tmp: POINTER; a_sl_sofo: INTEGER_32)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_sofo = $a_sl_sofo;"
		end

	c_set_sl_nosplitsugs (tmp: POINTER; a_sl_nosplitsugs: INTEGER_32)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_nosplitsugs = $a_sl_nosplitsugs;"
		end

	c_set_sl_sugtime (tmp: POINTER; a_sl_sugtime: INTEGER_32)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_sugtime = $a_sl_sugtime;"
		end

	c_set_sl_sbyts (tmp: POINTER; a_sl_sbyts: POINTER)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_sbyts = (unsigned char *)$a_sl_sbyts;"
		end

	c_set_sl_sidxs (tmp: POINTER; a_sl_sidxs: POINTER)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_sidxs = (int *)$a_sl_sidxs;"
		end

	c_set_sl_sugbuf (tmp: POINTER; a_sl_sugbuf: POINTER)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_sugbuf = (struct file_buffer *)$a_sl_sugbuf;"
		end

	c_set_sl_sugloaded (tmp: POINTER; a_sl_sugloaded: INTEGER_32)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_sugloaded = $a_sl_sugloaded;"
		end

	c_set_sl_has_map (tmp: POINTER; a_sl_has_map: INTEGER_32)
		external
			"C inline"
		alias
			"((struct slang_S *)$tmp)->sl_has_map = $a_sl_has_map;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct slang_S);"
		end

end
