class
	PD_SOURCE_COOKIE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	fp: CE_POINTER [SD_IO_FILE] assign set_fp
		do
			create Result.make_shared (c_fp (c_pointer))
		end

	nextline: CE_POINTER [NATURAL_8] assign set_nextline
		do
			create Result.make_shared (c_nextline (c_pointer))
		end

	finished: INTEGER_32 assign set_finished
		do
			Result := c_finished (c_pointer)
		end

	breakpoint: INTEGER_32 assign set_breakpoint
		do
			Result := c_breakpoint (c_pointer)
		end

	breakpoint_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct source_cookie, breakpoint);"
		end

	fname: CE_POINTER [NATURAL_8] assign set_fname
		do
			create Result.make_shared (c_fname (c_pointer))
		end

	dbg_tick: INTEGER_32 assign set_dbg_tick
		do
			Result := c_dbg_tick (c_pointer)
		end

	dbg_tick_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct source_cookie, dbg_tick);"
		end

	level: INTEGER_32 assign set_level
		do
			Result := c_level (c_pointer)
		end

	conv: PD_VIMCONV_T assign set_conv
		do
			create Result.make_shared (c_conv (c_pointer))
		end

	conv_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct source_cookie, conv);"
		end

feature {ANY} -- Eiffel setters

	set_fp (a_fp: CE_POINTER [SD_IO_FILE])
		do
			c_set_fp (c_pointer, a_fp.c_pointer)
		end

	set_nextline (a_nextline: CE_POINTER [NATURAL_8])
		do
			c_set_nextline (c_pointer, a_nextline.c_pointer)
		end

	set_finished (a_finished: INTEGER_32)
		do
			c_set_finished (c_pointer, a_finished)
		end

	set_breakpoint (a_breakpoint: INTEGER_32)
		do
			c_set_breakpoint (c_pointer, a_breakpoint)
		end

	set_fname (a_fname: CE_POINTER [NATURAL_8])
		do
			c_set_fname (c_pointer, a_fname.c_pointer)
		end

	set_dbg_tick (a_dbg_tick: INTEGER_32)
		do
			c_set_dbg_tick (c_pointer, a_dbg_tick)
		end

	set_level (a_level: INTEGER_32)
		do
			c_set_level (c_pointer, a_level)
		end

	set_conv (a_conv: PD_VIMCONV_T)
		do
			conv.ce_gets (a_conv)
		end

feature {NONE} -- C getters

	c_fp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _IO_FILE *)((struct source_cookie *)$tmp)->fp;"
		end

	c_nextline (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct source_cookie *)$tmp)->nextline;"
		end

	c_finished (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct source_cookie *)$tmp)->finished;"
		end

	c_breakpoint (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct source_cookie *)$tmp)->breakpoint;"
		end

	c_fname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct source_cookie *)$tmp)->fname;"
		end

	c_dbg_tick (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct source_cookie *)$tmp)->dbg_tick;"
		end

	c_level (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct source_cookie *)$tmp)->level;"
		end

	c_conv (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (vimconv_T *)&((struct source_cookie *)$tmp)->conv;"
		end

feature {NONE} -- C setters

	c_set_fp (tmp: POINTER; a_fp: POINTER)
		external
			"C inline"
		alias
			"((struct source_cookie *)$tmp)->fp = (struct _IO_FILE *)$a_fp;"
		end

	c_set_nextline (tmp: POINTER; a_nextline: POINTER)
		external
			"C inline"
		alias
			"((struct source_cookie *)$tmp)->nextline = (unsigned char *)$a_nextline;"
		end

	c_set_finished (tmp: POINTER; a_finished: INTEGER_32)
		external
			"C inline"
		alias
			"((struct source_cookie *)$tmp)->finished = $a_finished;"
		end

	c_set_breakpoint (tmp: POINTER; a_breakpoint: INTEGER_32)
		external
			"C inline"
		alias
			"((struct source_cookie *)$tmp)->breakpoint = $a_breakpoint;"
		end

	c_set_fname (tmp: POINTER; a_fname: POINTER)
		external
			"C inline"
		alias
			"((struct source_cookie *)$tmp)->fname = (unsigned char *)$a_fname;"
		end

	c_set_dbg_tick (tmp: POINTER; a_dbg_tick: INTEGER_32)
		external
			"C inline"
		alias
			"((struct source_cookie *)$tmp)->dbg_tick = $a_dbg_tick;"
		end

	c_set_level (tmp: POINTER; a_level: INTEGER_32)
		external
			"C inline"
		alias
			"((struct source_cookie *)$tmp)->level = $a_level;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct source_cookie);"
		end

end
