class
	PD_SPAT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	pat: CE_POINTER [NATURAL_8] assign set_pat
		do
			create Result.make_shared (c_pat (c_pointer))
		end

	magic: INTEGER_32 assign set_magic
		do
			Result := c_magic (c_pointer)
		end

	no_scs: INTEGER_32 assign set_no_scs
		do
			Result := c_no_scs (c_pointer)
		end

	off: PD_SOFFSET assign set_off
		do
			create Result.make_shared (c_off (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_pat (a_pat: CE_POINTER [NATURAL_8])
		do
			c_set_pat (c_pointer, a_pat.c_pointer)
		end

	set_magic (a_magic: INTEGER_32)
		do
			c_set_magic (c_pointer, a_magic)
		end

	set_no_scs (a_no_scs: INTEGER_32)
		do
			c_set_no_scs (c_pointer, a_no_scs)
		end

	set_off (a_off: PD_SOFFSET)
		do
			off.ce_gets (a_off)
		end

feature {NONE} -- C getters

	c_pat (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct spat *)$tmp)->pat;"
		end

	c_magic (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct spat *)$tmp)->magic;"
		end

	c_no_scs (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct spat *)$tmp)->no_scs;"
		end

	c_off (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct soffset *)&((struct spat *)$tmp)->off;"
		end

feature {NONE} -- C setters

	c_set_pat (tmp: POINTER; a_pat: POINTER)
		external
			"C inline"
		alias
			"((struct spat *)$tmp)->pat = (unsigned char *)$a_pat;"
		end

	c_set_magic (tmp: POINTER; a_magic: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spat *)$tmp)->magic = $a_magic;"
		end

	c_set_no_scs (tmp: POINTER; a_no_scs: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spat *)$tmp)->no_scs = $a_no_scs;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct spat);"
		end

end
