class
	PD_SPELLOAD_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sl_lang: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_sl_lang (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	sl_slang: CE_POINTER [PD_SLANG_S] assign set_sl_slang
		do
			create Result.make_shared (c_sl_slang (c_pointer))
		end

	sl_nobreak: INTEGER_32 assign set_sl_nobreak
		do
			Result := c_sl_nobreak (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_sl_slang (a_sl_slang: CE_POINTER [PD_SLANG_S])
		do
			c_set_sl_slang (c_pointer, a_sl_slang.c_pointer)
		end

	set_sl_nobreak (a_sl_nobreak: INTEGER_32)
		do
			c_set_sl_nobreak (c_pointer, a_sl_nobreak)
		end

feature {NONE} -- C getters

	c_sl_lang (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct spelload_S *tmp = (struct spelload_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->sl_lang) / sizeof(tmp->sl_lang[0]);
				return tmp->sl_lang;
			]"
		end

	c_sl_slang (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct slang_S *)((struct spelload_S *)$tmp)->sl_slang;"
		end

	c_sl_nobreak (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct spelload_S *)$tmp)->sl_nobreak;"
		end

feature {NONE} -- C setters

	c_set_sl_slang (tmp: POINTER; a_sl_slang: POINTER)
		external
			"C inline"
		alias
			"((struct spelload_S *)$tmp)->sl_slang = (struct slang_S *)$a_sl_slang;"
		end

	c_set_sl_nobreak (tmp: POINTER; a_sl_nobreak: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spelload_S *)$tmp)->sl_nobreak = $a_sl_nobreak;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct spelload_S);"
		end

end
