class
	PD_SST_UNION

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sst_stack: CE_ARRAY [PD_BUF_STATE]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_sst_stack (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	sst_ga: PD_GROWARRAY assign set_sst_ga
		do
			create Result.make_shared (c_sst_ga (c_pointer))
		end

	sst_ga_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(union __anonunion_sst_union_523, sst_ga);"
		end

feature {ANY} -- Eiffel setters

	set_sst_ga (a_sst_ga: PD_GROWARRAY)
		do
			sst_ga.ce_gets (a_sst_ga)
		end

feature {NONE} -- C getters

	c_sst_stack (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				union __anonunion_sst_union_523 *tmp = (union __anonunion_sst_union_523 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->sst_stack) / sizeof(tmp->sst_stack[0]);
				return tmp->sst_stack;
			]"
		end

	c_sst_ga (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((union __anonunion_sst_union_523 *)$tmp)->sst_ga;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(union __anonunion_sst_union_523);"
		end

end
