class
	PD_STATE_ITEM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	si_idx: INTEGER_32 assign set_si_idx
		do
			Result := c_si_idx (c_pointer)
		end

	si_id: INTEGER_32 assign set_si_id
		do
			Result := c_si_id (c_pointer)
		end

	si_trans_id: INTEGER_32 assign set_si_trans_id
		do
			Result := c_si_trans_id (c_pointer)
		end

	si_m_lnum: INTEGER_32 assign set_si_m_lnum
		do
			Result := c_si_m_lnum (c_pointer)
		end

	si_m_startcol: INTEGER_32 assign set_si_m_startcol
		do
			Result := c_si_m_startcol (c_pointer)
		end

	si_m_endpos: PD_LPOS_T assign set_si_m_endpos
		do
			create Result.make_shared (c_si_m_endpos (c_pointer))
		end

	si_m_endpos_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct state_item, si_m_endpos);"
		end

	si_h_startpos: PD_LPOS_T assign set_si_h_startpos
		do
			create Result.make_shared (c_si_h_startpos (c_pointer))
		end

	si_h_endpos: PD_LPOS_T assign set_si_h_endpos
		do
			create Result.make_shared (c_si_h_endpos (c_pointer))
		end

	si_h_endpos_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct state_item, si_h_endpos);"
		end

	si_eoe_pos: PD_LPOS_T assign set_si_eoe_pos
		do
			create Result.make_shared (c_si_eoe_pos (c_pointer))
		end

	si_eoe_pos_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct state_item, si_eoe_pos);"
		end

	si_end_idx: INTEGER_32 assign set_si_end_idx
		do
			Result := c_si_end_idx (c_pointer)
		end

	si_ends: INTEGER_32 assign set_si_ends
		do
			Result := c_si_ends (c_pointer)
		end

	si_attr: INTEGER_32 assign set_si_attr
		do
			Result := c_si_attr (c_pointer)
		end

	si_flags: INTEGER_32 assign set_si_flags
		do
			Result := c_si_flags (c_pointer)
		end

	si_flags_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct state_item, si_flags);"
		end

	si_cont_list: CE_POINTER [INTEGER_16] assign set_si_cont_list
		do
			create Result.make_shared (c_si_cont_list (c_pointer))
		end

	si_next_list: CE_POINTER [INTEGER_16] assign set_si_next_list
		do
			create Result.make_shared (c_si_next_list (c_pointer))
		end

	si_extmatch: CE_POINTER [PD_REG_EXTMATCH_T] assign set_si_extmatch
		do
			create Result.make_shared (c_si_extmatch (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_si_idx (a_si_idx: INTEGER_32)
		do
			c_set_si_idx (c_pointer, a_si_idx)
		end

	set_si_id (a_si_id: INTEGER_32)
		do
			c_set_si_id (c_pointer, a_si_id)
		end

	set_si_trans_id (a_si_trans_id: INTEGER_32)
		do
			c_set_si_trans_id (c_pointer, a_si_trans_id)
		end

	set_si_m_lnum (a_si_m_lnum: INTEGER_32)
		do
			c_set_si_m_lnum (c_pointer, a_si_m_lnum)
		end

	set_si_m_startcol (a_si_m_startcol: INTEGER_32)
		do
			c_set_si_m_startcol (c_pointer, a_si_m_startcol)
		end

	set_si_m_endpos (a_si_m_endpos: PD_LPOS_T)
		do
			si_m_endpos.ce_gets (a_si_m_endpos)
		end

	set_si_h_startpos (a_si_h_startpos: PD_LPOS_T)
		do
			si_h_startpos.ce_gets (a_si_h_startpos)
		end

	set_si_h_endpos (a_si_h_endpos: PD_LPOS_T)
		do
			si_h_endpos.ce_gets (a_si_h_endpos)
		end

	set_si_eoe_pos (a_si_eoe_pos: PD_LPOS_T)
		do
			si_eoe_pos.ce_gets (a_si_eoe_pos)
		end

	set_si_end_idx (a_si_end_idx: INTEGER_32)
		do
			c_set_si_end_idx (c_pointer, a_si_end_idx)
		end

	set_si_ends (a_si_ends: INTEGER_32)
		do
			c_set_si_ends (c_pointer, a_si_ends)
		end

	set_si_attr (a_si_attr: INTEGER_32)
		do
			c_set_si_attr (c_pointer, a_si_attr)
		end

	set_si_flags (a_si_flags: INTEGER_32)
		do
			c_set_si_flags (c_pointer, a_si_flags)
		end

	set_si_cont_list (a_si_cont_list: CE_POINTER [INTEGER_16])
		do
			c_set_si_cont_list (c_pointer, a_si_cont_list.c_pointer)
		end

	set_si_next_list (a_si_next_list: CE_POINTER [INTEGER_16])
		do
			c_set_si_next_list (c_pointer, a_si_next_list.c_pointer)
		end

	set_si_extmatch (a_si_extmatch: CE_POINTER [PD_REG_EXTMATCH_T])
		do
			c_set_si_extmatch (c_pointer, a_si_extmatch.c_pointer)
		end

feature {NONE} -- C getters

	c_si_idx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct state_item *)$tmp)->si_idx;"
		end

	c_si_id (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct state_item *)$tmp)->si_id;"
		end

	c_si_trans_id (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct state_item *)$tmp)->si_trans_id;"
		end

	c_si_m_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct state_item *)$tmp)->si_m_lnum;"
		end

	c_si_m_startcol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct state_item *)$tmp)->si_m_startcol;"
		end

	c_si_m_endpos (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (lpos_T *)&((struct state_item *)$tmp)->si_m_endpos;"
		end

	c_si_h_startpos (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (lpos_T *)&((struct state_item *)$tmp)->si_h_startpos;"
		end

	c_si_h_endpos (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (lpos_T *)&((struct state_item *)$tmp)->si_h_endpos;"
		end

	c_si_eoe_pos (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (lpos_T *)&((struct state_item *)$tmp)->si_eoe_pos;"
		end

	c_si_end_idx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct state_item *)$tmp)->si_end_idx;"
		end

	c_si_ends (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct state_item *)$tmp)->si_ends;"
		end

	c_si_attr (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct state_item *)$tmp)->si_attr;"
		end

	c_si_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct state_item *)$tmp)->si_flags;"
		end

	c_si_cont_list (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (short *)((struct state_item *)$tmp)->si_cont_list;"
		end

	c_si_next_list (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (short *)((struct state_item *)$tmp)->si_next_list;"
		end

	c_si_extmatch (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (reg_extmatch_T *)((struct state_item *)$tmp)->si_extmatch;"
		end

feature {NONE} -- C setters

	c_set_si_idx (tmp: POINTER; a_si_idx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct state_item *)$tmp)->si_idx = $a_si_idx;"
		end

	c_set_si_id (tmp: POINTER; a_si_id: INTEGER_32)
		external
			"C inline"
		alias
			"((struct state_item *)$tmp)->si_id = $a_si_id;"
		end

	c_set_si_trans_id (tmp: POINTER; a_si_trans_id: INTEGER_32)
		external
			"C inline"
		alias
			"((struct state_item *)$tmp)->si_trans_id = $a_si_trans_id;"
		end

	c_set_si_m_lnum (tmp: POINTER; a_si_m_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct state_item *)$tmp)->si_m_lnum = $a_si_m_lnum;"
		end

	c_set_si_m_startcol (tmp: POINTER; a_si_m_startcol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct state_item *)$tmp)->si_m_startcol = $a_si_m_startcol;"
		end

	c_set_si_end_idx (tmp: POINTER; a_si_end_idx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct state_item *)$tmp)->si_end_idx = $a_si_end_idx;"
		end

	c_set_si_ends (tmp: POINTER; a_si_ends: INTEGER_32)
		external
			"C inline"
		alias
			"((struct state_item *)$tmp)->si_ends = $a_si_ends;"
		end

	c_set_si_attr (tmp: POINTER; a_si_attr: INTEGER_32)
		external
			"C inline"
		alias
			"((struct state_item *)$tmp)->si_attr = $a_si_attr;"
		end

	c_set_si_flags (tmp: POINTER; a_si_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct state_item *)$tmp)->si_flags = $a_si_flags;"
		end

	c_set_si_cont_list (tmp: POINTER; a_si_cont_list: POINTER)
		external
			"C inline"
		alias
			"((struct state_item *)$tmp)->si_cont_list = (short *)$a_si_cont_list;"
		end

	c_set_si_next_list (tmp: POINTER; a_si_next_list: POINTER)
		external
			"C inline"
		alias
			"((struct state_item *)$tmp)->si_next_list = (short *)$a_si_next_list;"
		end

	c_set_si_extmatch (tmp: POINTER; a_si_extmatch: POINTER)
		external
			"C inline"
		alias
			"((struct state_item *)$tmp)->si_extmatch = (reg_extmatch_T *)$a_si_extmatch;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct state_item);"
		end

end
