class
	PD_SUBCOMMAND

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	func: CE_ROUTINE assign set_func
		do
			create Result.make_shared (c_func (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_func (a_func: CE_ROUTINE)
		do
			c_set_func (c_pointer, a_func.c_pointer)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct subcommand *)$tmp)->name;"
		end

	c_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct exarg *, int))((struct subcommand *)$tmp)->func;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct subcommand *)$tmp)->name = (char *)$a_name;"
		end

	c_set_func (tmp: POINTER; a_func: POINTER)
		external
			"C inline"
		alias
			"((struct subcommand *)$tmp)->func = (void( *)(struct exarg *, int))$a_func;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct subcommand);"
		end

end
