class
	PD_SUGINFO_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	su_ga: PD_GROWARRAY assign set_su_ga
		do
			create Result.make_shared (c_su_ga (c_pointer))
		end

	su_ga_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct suginfo_S, su_ga);"
		end

	su_maxcount: INTEGER_32 assign set_su_maxcount
		do
			Result := c_su_maxcount (c_pointer)
		end

	su_maxscore: INTEGER_32 assign set_su_maxscore
		do
			Result := c_su_maxscore (c_pointer)
		end

	su_sfmaxscore: INTEGER_32 assign set_su_sfmaxscore
		do
			Result := c_su_sfmaxscore (c_pointer)
		end

	su_sga: PD_GROWARRAY assign set_su_sga
		do
			create Result.make_shared (c_su_sga (c_pointer))
		end

	su_sga_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct suginfo_S, su_sga);"
		end

	su_badptr: CE_POINTER [NATURAL_8] assign set_su_badptr
		do
			create Result.make_shared (c_su_badptr (c_pointer))
		end

	su_badlen: INTEGER_32 assign set_su_badlen
		do
			Result := c_su_badlen (c_pointer)
		end

	su_badflags: INTEGER_32 assign set_su_badflags
		do
			Result := c_su_badflags (c_pointer)
		end

	su_badword: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_su_badword (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	su_fbadword: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_su_fbadword (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	su_sal_badword: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_su_sal_badword (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	su_banned: PD_HASHTABLE_S assign set_su_banned
		do
			create Result.make_shared (c_su_banned (c_pointer))
		end

	su_banned_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct suginfo_S, su_banned);"
		end

	su_sallang: CE_POINTER [PD_SLANG_S] assign set_su_sallang
		do
			create Result.make_shared (c_su_sallang (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_su_ga (a_su_ga: PD_GROWARRAY)
		do
			su_ga.ce_gets (a_su_ga)
		end

	set_su_maxcount (a_su_maxcount: INTEGER_32)
		do
			c_set_su_maxcount (c_pointer, a_su_maxcount)
		end

	set_su_maxscore (a_su_maxscore: INTEGER_32)
		do
			c_set_su_maxscore (c_pointer, a_su_maxscore)
		end

	set_su_sfmaxscore (a_su_sfmaxscore: INTEGER_32)
		do
			c_set_su_sfmaxscore (c_pointer, a_su_sfmaxscore)
		end

	set_su_sga (a_su_sga: PD_GROWARRAY)
		do
			su_sga.ce_gets (a_su_sga)
		end

	set_su_badptr (a_su_badptr: CE_POINTER [NATURAL_8])
		do
			c_set_su_badptr (c_pointer, a_su_badptr.c_pointer)
		end

	set_su_badlen (a_su_badlen: INTEGER_32)
		do
			c_set_su_badlen (c_pointer, a_su_badlen)
		end

	set_su_badflags (a_su_badflags: INTEGER_32)
		do
			c_set_su_badflags (c_pointer, a_su_badflags)
		end

	set_su_banned (a_su_banned: PD_HASHTABLE_S)
		do
			su_banned.ce_gets (a_su_banned)
		end

	set_su_sallang (a_su_sallang: CE_POINTER [PD_SLANG_S])
		do
			c_set_su_sallang (c_pointer, a_su_sallang.c_pointer)
		end

feature {NONE} -- C getters

	c_su_ga (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct suginfo_S *)$tmp)->su_ga;"
		end

	c_su_maxcount (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct suginfo_S *)$tmp)->su_maxcount;"
		end

	c_su_maxscore (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct suginfo_S *)$tmp)->su_maxscore;"
		end

	c_su_sfmaxscore (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct suginfo_S *)$tmp)->su_sfmaxscore;"
		end

	c_su_sga (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct suginfo_S *)$tmp)->su_sga;"
		end

	c_su_badptr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct suginfo_S *)$tmp)->su_badptr;"
		end

	c_su_badlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct suginfo_S *)$tmp)->su_badlen;"
		end

	c_su_badflags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct suginfo_S *)$tmp)->su_badflags;"
		end

	c_su_badword (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct suginfo_S *tmp = (struct suginfo_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->su_badword) / sizeof(tmp->su_badword[0]);
				return tmp->su_badword;
			]"
		end

	c_su_fbadword (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct suginfo_S *tmp = (struct suginfo_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->su_fbadword) / sizeof(tmp->su_fbadword[0]);
				return tmp->su_fbadword;
			]"
		end

	c_su_sal_badword (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct suginfo_S *tmp = (struct suginfo_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->su_sal_badword) / sizeof(tmp->su_sal_badword[0]);
				return tmp->su_sal_badword;
			]"
		end

	c_su_banned (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct hashtable_S *)&((struct suginfo_S *)$tmp)->su_banned;"
		end

	c_su_sallang (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct slang_S *)((struct suginfo_S *)$tmp)->su_sallang;"
		end

feature {NONE} -- C setters

	c_set_su_maxcount (tmp: POINTER; a_su_maxcount: INTEGER_32)
		external
			"C inline"
		alias
			"((struct suginfo_S *)$tmp)->su_maxcount = $a_su_maxcount;"
		end

	c_set_su_maxscore (tmp: POINTER; a_su_maxscore: INTEGER_32)
		external
			"C inline"
		alias
			"((struct suginfo_S *)$tmp)->su_maxscore = $a_su_maxscore;"
		end

	c_set_su_sfmaxscore (tmp: POINTER; a_su_sfmaxscore: INTEGER_32)
		external
			"C inline"
		alias
			"((struct suginfo_S *)$tmp)->su_sfmaxscore = $a_su_sfmaxscore;"
		end

	c_set_su_badptr (tmp: POINTER; a_su_badptr: POINTER)
		external
			"C inline"
		alias
			"((struct suginfo_S *)$tmp)->su_badptr = (unsigned char *)$a_su_badptr;"
		end

	c_set_su_badlen (tmp: POINTER; a_su_badlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct suginfo_S *)$tmp)->su_badlen = $a_su_badlen;"
		end

	c_set_su_badflags (tmp: POINTER; a_su_badflags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct suginfo_S *)$tmp)->su_badflags = $a_su_badflags;"
		end

	c_set_su_sallang (tmp: POINTER; a_su_sallang: POINTER)
		external
			"C inline"
		alias
			"((struct suginfo_S *)$tmp)->su_sallang = (struct slang_S *)$a_su_sallang;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct suginfo_S);"
		end

end
