class
	PD_SYL_ITEM_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sy_chars: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_sy_chars (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	sy_len: INTEGER_32 assign set_sy_len
		do
			Result := c_sy_len (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_sy_len (a_sy_len: INTEGER_32)
		do
			c_set_sy_len (c_pointer, a_sy_len)
		end

feature {NONE} -- C getters

	c_sy_chars (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct syl_item_S *tmp = (struct syl_item_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->sy_chars) / sizeof(tmp->sy_chars[0]);
				return tmp->sy_chars;
			]"
		end

	c_sy_len (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct syl_item_S *)$tmp)->sy_len;"
		end

feature {NONE} -- C setters

	c_set_sy_len (tmp: POINTER; a_sy_len: INTEGER_32)
		external
			"C inline"
		alias
			"((struct syl_item_S *)$tmp)->sy_len = $a_sy_len;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct syl_item_S);"
		end

end
