class
	PD_SYN_PATTERN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sp_type: INTEGER_8 assign set_sp_type
		do
			Result := c_sp_type (c_pointer)
		end

	sp_syncing: INTEGER_8 assign set_sp_syncing
		do
			Result := c_sp_syncing (c_pointer)
		end

	sp_flags: INTEGER_32 assign set_sp_flags
		do
			Result := c_sp_flags (c_pointer)
		end

	sp_syn: PD_SP_SYN assign set_sp_syn
		do
			create Result.make_shared (c_sp_syn (c_pointer))
		end

	sp_syn_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct syn_pattern, sp_syn);"
		end

	sp_syn_match_id: INTEGER_16 assign set_sp_syn_match_id
		do
			Result := c_sp_syn_match_id (c_pointer)
		end

	sp_pattern: CE_POINTER [NATURAL_8] assign set_sp_pattern
		do
			create Result.make_shared (c_sp_pattern (c_pointer))
		end

	sp_prog: CE_POINTER [PD_REGPROG_T] assign set_sp_prog
		do
			create Result.make_shared (c_sp_prog (c_pointer))
		end

	sp_ic: INTEGER_32 assign set_sp_ic
		do
			Result := c_sp_ic (c_pointer)
		end

	sp_off_flags: INTEGER_16 assign set_sp_off_flags
		do
			Result := c_sp_off_flags (c_pointer)
		end

	sp_offsets: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_sp_offsets (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	sp_cont_list: CE_POINTER [INTEGER_16] assign set_sp_cont_list
		do
			create Result.make_shared (c_sp_cont_list (c_pointer))
		end

	sp_next_list: CE_POINTER [INTEGER_16] assign set_sp_next_list
		do
			create Result.make_shared (c_sp_next_list (c_pointer))
		end

	sp_sync_idx: INTEGER_32 assign set_sp_sync_idx
		do
			Result := c_sp_sync_idx (c_pointer)
		end

	sp_line_id: INTEGER_32 assign set_sp_line_id
		do
			Result := c_sp_line_id (c_pointer)
		end

	sp_startcol: INTEGER_32 assign set_sp_startcol
		do
			Result := c_sp_startcol (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_sp_type (a_sp_type: INTEGER_8)
		do
			c_set_sp_type (c_pointer, a_sp_type)
		end

	set_sp_syncing (a_sp_syncing: INTEGER_8)
		do
			c_set_sp_syncing (c_pointer, a_sp_syncing)
		end

	set_sp_flags (a_sp_flags: INTEGER_32)
		do
			c_set_sp_flags (c_pointer, a_sp_flags)
		end

	set_sp_syn (a_sp_syn: PD_SP_SYN)
		do
			sp_syn.ce_gets (a_sp_syn)
		end

	set_sp_syn_match_id (a_sp_syn_match_id: INTEGER_16)
		do
			c_set_sp_syn_match_id (c_pointer, a_sp_syn_match_id)
		end

	set_sp_pattern (a_sp_pattern: CE_POINTER [NATURAL_8])
		do
			c_set_sp_pattern (c_pointer, a_sp_pattern.c_pointer)
		end

	set_sp_prog (a_sp_prog: CE_POINTER [PD_REGPROG_T])
		do
			c_set_sp_prog (c_pointer, a_sp_prog.c_pointer)
		end

	set_sp_ic (a_sp_ic: INTEGER_32)
		do
			c_set_sp_ic (c_pointer, a_sp_ic)
		end

	set_sp_off_flags (a_sp_off_flags: INTEGER_16)
		do
			c_set_sp_off_flags (c_pointer, a_sp_off_flags)
		end

	set_sp_cont_list (a_sp_cont_list: CE_POINTER [INTEGER_16])
		do
			c_set_sp_cont_list (c_pointer, a_sp_cont_list.c_pointer)
		end

	set_sp_next_list (a_sp_next_list: CE_POINTER [INTEGER_16])
		do
			c_set_sp_next_list (c_pointer, a_sp_next_list.c_pointer)
		end

	set_sp_sync_idx (a_sp_sync_idx: INTEGER_32)
		do
			c_set_sp_sync_idx (c_pointer, a_sp_sync_idx)
		end

	set_sp_line_id (a_sp_line_id: INTEGER_32)
		do
			c_set_sp_line_id (c_pointer, a_sp_line_id)
		end

	set_sp_startcol (a_sp_startcol: INTEGER_32)
		do
			c_set_sp_startcol (c_pointer, a_sp_startcol)
		end

feature {NONE} -- C getters

	c_sp_type (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct syn_pattern *)$tmp)->sp_type;"
		end

	c_sp_syncing (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct syn_pattern *)$tmp)->sp_syncing;"
		end

	c_sp_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct syn_pattern *)$tmp)->sp_flags;"
		end

	c_sp_syn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct sp_syn *)&((struct syn_pattern *)$tmp)->sp_syn;"
		end

	c_sp_syn_match_id (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct syn_pattern *)$tmp)->sp_syn_match_id;"
		end

	c_sp_pattern (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct syn_pattern *)$tmp)->sp_pattern;"
		end

	c_sp_prog (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (regprog_T *)((struct syn_pattern *)$tmp)->sp_prog;"
		end

	c_sp_ic (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct syn_pattern *)$tmp)->sp_ic;"
		end

	c_sp_off_flags (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct syn_pattern *)$tmp)->sp_off_flags;"
		end

	c_sp_offsets (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct syn_pattern *tmp = (struct syn_pattern *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->sp_offsets) / sizeof(tmp->sp_offsets[0]);
				return tmp->sp_offsets;
			]"
		end

	c_sp_cont_list (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (short *)((struct syn_pattern *)$tmp)->sp_cont_list;"
		end

	c_sp_next_list (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (short *)((struct syn_pattern *)$tmp)->sp_next_list;"
		end

	c_sp_sync_idx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct syn_pattern *)$tmp)->sp_sync_idx;"
		end

	c_sp_line_id (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct syn_pattern *)$tmp)->sp_line_id;"
		end

	c_sp_startcol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct syn_pattern *)$tmp)->sp_startcol;"
		end

feature {NONE} -- C setters

	c_set_sp_type (tmp: POINTER; a_sp_type: INTEGER_8)
		external
			"C inline"
		alias
			"((struct syn_pattern *)$tmp)->sp_type = $a_sp_type;"
		end

	c_set_sp_syncing (tmp: POINTER; a_sp_syncing: INTEGER_8)
		external
			"C inline"
		alias
			"((struct syn_pattern *)$tmp)->sp_syncing = $a_sp_syncing;"
		end

	c_set_sp_flags (tmp: POINTER; a_sp_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct syn_pattern *)$tmp)->sp_flags = $a_sp_flags;"
		end

	c_set_sp_syn_match_id (tmp: POINTER; a_sp_syn_match_id: INTEGER_16)
		external
			"C inline"
		alias
			"((struct syn_pattern *)$tmp)->sp_syn_match_id = $a_sp_syn_match_id;"
		end

	c_set_sp_pattern (tmp: POINTER; a_sp_pattern: POINTER)
		external
			"C inline"
		alias
			"((struct syn_pattern *)$tmp)->sp_pattern = (unsigned char *)$a_sp_pattern;"
		end

	c_set_sp_prog (tmp: POINTER; a_sp_prog: POINTER)
		external
			"C inline"
		alias
			"((struct syn_pattern *)$tmp)->sp_prog = (regprog_T *)$a_sp_prog;"
		end

	c_set_sp_ic (tmp: POINTER; a_sp_ic: INTEGER_32)
		external
			"C inline"
		alias
			"((struct syn_pattern *)$tmp)->sp_ic = $a_sp_ic;"
		end

	c_set_sp_off_flags (tmp: POINTER; a_sp_off_flags: INTEGER_16)
		external
			"C inline"
		alias
			"((struct syn_pattern *)$tmp)->sp_off_flags = $a_sp_off_flags;"
		end

	c_set_sp_cont_list (tmp: POINTER; a_sp_cont_list: POINTER)
		external
			"C inline"
		alias
			"((struct syn_pattern *)$tmp)->sp_cont_list = (short *)$a_sp_cont_list;"
		end

	c_set_sp_next_list (tmp: POINTER; a_sp_next_list: POINTER)
		external
			"C inline"
		alias
			"((struct syn_pattern *)$tmp)->sp_next_list = (short *)$a_sp_next_list;"
		end

	c_set_sp_sync_idx (tmp: POINTER; a_sp_sync_idx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct syn_pattern *)$tmp)->sp_sync_idx = $a_sp_sync_idx;"
		end

	c_set_sp_line_id (tmp: POINTER; a_sp_line_id: INTEGER_32)
		external
			"C inline"
		alias
			"((struct syn_pattern *)$tmp)->sp_line_id = $a_sp_line_id;"
		end

	c_set_sp_startcol (tmp: POINTER; a_sp_startcol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct syn_pattern *)$tmp)->sp_startcol = $a_sp_startcol;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct syn_pattern);"
		end

end
