class
	PD_SYN_STATE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sst_next: CE_POINTER [PD_SYN_STATE] assign set_sst_next
		do
			create Result.make_shared (c_sst_next (c_pointer))
		end

	sst_lnum: INTEGER_32 assign set_sst_lnum
		do
			Result := c_sst_lnum (c_pointer)
		end

	sst_union: PD_SST_UNION assign set_sst_union
		do
			create Result.make_shared (c_sst_union (c_pointer))
		end

	sst_union_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct syn_state, sst_union);"
		end

	sst_next_flags: INTEGER_32 assign set_sst_next_flags
		do
			Result := c_sst_next_flags (c_pointer)
		end

	sst_stacksize: INTEGER_32 assign set_sst_stacksize
		do
			Result := c_sst_stacksize (c_pointer)
		end

	sst_next_list: CE_POINTER [INTEGER_16] assign set_sst_next_list
		do
			create Result.make_shared (c_sst_next_list (c_pointer))
		end

	sst_tick: NATURAL_16 assign set_sst_tick
		do
			Result := c_sst_tick (c_pointer)
		end

	sst_change_lnum: INTEGER_32 assign set_sst_change_lnum
		do
			Result := c_sst_change_lnum (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_sst_next (a_sst_next: CE_POINTER [PD_SYN_STATE])
		do
			c_set_sst_next (c_pointer, a_sst_next.c_pointer)
		end

	set_sst_lnum (a_sst_lnum: INTEGER_32)
		do
			c_set_sst_lnum (c_pointer, a_sst_lnum)
		end

	set_sst_union (a_sst_union: PD_SST_UNION)
		do
			sst_union.ce_gets (a_sst_union)
		end

	set_sst_next_flags (a_sst_next_flags: INTEGER_32)
		do
			c_set_sst_next_flags (c_pointer, a_sst_next_flags)
		end

	set_sst_stacksize (a_sst_stacksize: INTEGER_32)
		do
			c_set_sst_stacksize (c_pointer, a_sst_stacksize)
		end

	set_sst_next_list (a_sst_next_list: CE_POINTER [INTEGER_16])
		do
			c_set_sst_next_list (c_pointer, a_sst_next_list.c_pointer)
		end

	set_sst_tick (a_sst_tick: NATURAL_16)
		do
			c_set_sst_tick (c_pointer, a_sst_tick)
		end

	set_sst_change_lnum (a_sst_change_lnum: INTEGER_32)
		do
			c_set_sst_change_lnum (c_pointer, a_sst_change_lnum)
		end

feature {NONE} -- C getters

	c_sst_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct syn_state *)((struct syn_state *)$tmp)->sst_next;"
		end

	c_sst_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct syn_state *)$tmp)->sst_lnum;"
		end

	c_sst_union (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_sst_union_523 *)&((struct syn_state *)$tmp)->sst_union;"
		end

	c_sst_next_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct syn_state *)$tmp)->sst_next_flags;"
		end

	c_sst_stacksize (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct syn_state *)$tmp)->sst_stacksize;"
		end

	c_sst_next_list (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (short *)((struct syn_state *)$tmp)->sst_next_list;"
		end

	c_sst_tick (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct syn_state *)$tmp)->sst_tick;"
		end

	c_sst_change_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct syn_state *)$tmp)->sst_change_lnum;"
		end

feature {NONE} -- C setters

	c_set_sst_next (tmp: POINTER; a_sst_next: POINTER)
		external
			"C inline"
		alias
			"((struct syn_state *)$tmp)->sst_next = (struct syn_state *)$a_sst_next;"
		end

	c_set_sst_lnum (tmp: POINTER; a_sst_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct syn_state *)$tmp)->sst_lnum = $a_sst_lnum;"
		end

	c_set_sst_next_flags (tmp: POINTER; a_sst_next_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct syn_state *)$tmp)->sst_next_flags = $a_sst_next_flags;"
		end

	c_set_sst_stacksize (tmp: POINTER; a_sst_stacksize: INTEGER_32)
		external
			"C inline"
		alias
			"((struct syn_state *)$tmp)->sst_stacksize = $a_sst_stacksize;"
		end

	c_set_sst_next_list (tmp: POINTER; a_sst_next_list: POINTER)
		external
			"C inline"
		alias
			"((struct syn_state *)$tmp)->sst_next_list = (short *)$a_sst_next_list;"
		end

	c_set_sst_tick (tmp: POINTER; a_sst_tick: NATURAL_16)
		external
			"C inline"
		alias
			"((struct syn_state *)$tmp)->sst_tick = $a_sst_tick;"
		end

	c_set_sst_change_lnum (tmp: POINTER; a_sst_change_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct syn_state *)$tmp)->sst_change_lnum = $a_sst_change_lnum;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct syn_state);"
		end

end
