class
	PD_TABPAGE_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	tp_next: CE_POINTER [PD_TABPAGE_S] assign set_tp_next
		do
			create Result.make_shared (c_tp_next (c_pointer))
		end

	tp_topframe: CE_POINTER [PD_FRAME_S] assign set_tp_topframe
		do
			create Result.make_shared (c_tp_topframe (c_pointer))
		end

	tp_curwin: CE_POINTER [PD_WINDOW_S] assign set_tp_curwin
		do
			create Result.make_shared (c_tp_curwin (c_pointer))
		end

	tp_prevwin: CE_POINTER [PD_WINDOW_S] assign set_tp_prevwin
		do
			create Result.make_shared (c_tp_prevwin (c_pointer))
		end

	tp_firstwin: CE_POINTER [PD_WINDOW_S] assign set_tp_firstwin
		do
			create Result.make_shared (c_tp_firstwin (c_pointer))
		end

	tp_lastwin: CE_POINTER [PD_WINDOW_S] assign set_tp_lastwin
		do
			create Result.make_shared (c_tp_lastwin (c_pointer))
		end

	tp_old_Rows: INTEGER_32 assign set_tp_old_Rows
		do
			Result := c_tp_old_Rows (c_pointer)
		end

	tp_old_Columns: INTEGER_32 assign set_tp_old_Columns
		do
			Result := c_tp_old_Columns (c_pointer)
		end

	tp_ch_used: INTEGER_32 assign set_tp_ch_used
		do
			Result := c_tp_ch_used (c_pointer)
		end

	tp_prev_which_scrollbars: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_tp_prev_which_scrollbars (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	tp_first_diff: CE_POINTER [PD_DIFFBLOCK_S] assign set_tp_first_diff
		do
			create Result.make_shared (c_tp_first_diff (c_pointer))
		end

	tp_diffbuf: CE_ARRAY [CE_POINTER [PD_FILE_BUFFER]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_tp_diffbuf (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	tp_diff_invalid: INTEGER_32 assign set_tp_diff_invalid
		do
			Result := c_tp_diff_invalid (c_pointer)
		end

	tp_snapshot: CE_ARRAY [CE_POINTER [PD_FRAME_S]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_tp_snapshot (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	tp_winvar: PD_DICTITEM_S assign set_tp_winvar
		do
			create Result.make_shared (c_tp_winvar (c_pointer))
		end

	tp_winvar_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct tabpage_S, tp_winvar);"
		end

	tp_vars: PD_DICTVAR_S assign set_tp_vars
		do
			create Result.make_shared (c_tp_vars (c_pointer))
		end

	tp_vars_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct tabpage_S, tp_vars);"
		end

feature {ANY} -- Eiffel setters

	set_tp_next (a_tp_next: CE_POINTER [PD_TABPAGE_S])
		do
			c_set_tp_next (c_pointer, a_tp_next.c_pointer)
		end

	set_tp_topframe (a_tp_topframe: CE_POINTER [PD_FRAME_S])
		do
			c_set_tp_topframe (c_pointer, a_tp_topframe.c_pointer)
		end

	set_tp_curwin (a_tp_curwin: CE_POINTER [PD_WINDOW_S])
		do
			c_set_tp_curwin (c_pointer, a_tp_curwin.c_pointer)
		end

	set_tp_prevwin (a_tp_prevwin: CE_POINTER [PD_WINDOW_S])
		do
			c_set_tp_prevwin (c_pointer, a_tp_prevwin.c_pointer)
		end

	set_tp_firstwin (a_tp_firstwin: CE_POINTER [PD_WINDOW_S])
		do
			c_set_tp_firstwin (c_pointer, a_tp_firstwin.c_pointer)
		end

	set_tp_lastwin (a_tp_lastwin: CE_POINTER [PD_WINDOW_S])
		do
			c_set_tp_lastwin (c_pointer, a_tp_lastwin.c_pointer)
		end

	set_tp_old_Rows (a_tp_old_Rows: INTEGER_32)
		do
			c_set_tp_old_Rows (c_pointer, a_tp_old_Rows)
		end

	set_tp_old_Columns (a_tp_old_Columns: INTEGER_32)
		do
			c_set_tp_old_Columns (c_pointer, a_tp_old_Columns)
		end

	set_tp_ch_used (a_tp_ch_used: INTEGER_32)
		do
			c_set_tp_ch_used (c_pointer, a_tp_ch_used)
		end

	set_tp_first_diff (a_tp_first_diff: CE_POINTER [PD_DIFFBLOCK_S])
		do
			c_set_tp_first_diff (c_pointer, a_tp_first_diff.c_pointer)
		end

	set_tp_diff_invalid (a_tp_diff_invalid: INTEGER_32)
		do
			c_set_tp_diff_invalid (c_pointer, a_tp_diff_invalid)
		end

	set_tp_winvar (a_tp_winvar: PD_DICTITEM_S)
		do
			tp_winvar.ce_gets (a_tp_winvar)
		end

	set_tp_vars (a_tp_vars: PD_DICTVAR_S)
		do
			tp_vars.ce_gets (a_tp_vars)
		end

feature {NONE} -- C getters

	c_tp_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct tabpage_S *)((struct tabpage_S *)$tmp)->tp_next;"
		end

	c_tp_topframe (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct frame_S *)((struct tabpage_S *)$tmp)->tp_topframe;"
		end

	c_tp_curwin (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct window_S *)((struct tabpage_S *)$tmp)->tp_curwin;"
		end

	c_tp_prevwin (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct window_S *)((struct tabpage_S *)$tmp)->tp_prevwin;"
		end

	c_tp_firstwin (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct window_S *)((struct tabpage_S *)$tmp)->tp_firstwin;"
		end

	c_tp_lastwin (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct window_S *)((struct tabpage_S *)$tmp)->tp_lastwin;"
		end

	c_tp_old_Rows (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct tabpage_S *)$tmp)->tp_old_Rows;"
		end

	c_tp_old_Columns (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct tabpage_S *)$tmp)->tp_old_Columns;"
		end

	c_tp_ch_used (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct tabpage_S *)$tmp)->tp_ch_used;"
		end

	c_tp_prev_which_scrollbars (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct tabpage_S *tmp = (struct tabpage_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->tp_prev_which_scrollbars) / sizeof(tmp->tp_prev_which_scrollbars[0]);
				return tmp->tp_prev_which_scrollbars;
			]"
		end

	c_tp_first_diff (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct diffblock_S *)((struct tabpage_S *)$tmp)->tp_first_diff;"
		end

	c_tp_diffbuf (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct tabpage_S *tmp = (struct tabpage_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->tp_diffbuf) / sizeof(tmp->tp_diffbuf[0]);
				return tmp->tp_diffbuf;
			]"
		end

	c_tp_diff_invalid (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tabpage_S *)$tmp)->tp_diff_invalid;"
		end

	c_tp_snapshot (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct tabpage_S *tmp = (struct tabpage_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->tp_snapshot) / sizeof(tmp->tp_snapshot[0]);
				return tmp->tp_snapshot;
			]"
		end

	c_tp_winvar (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dictitem_S *)&((struct tabpage_S *)$tmp)->tp_winvar;"
		end

	c_tp_vars (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dictvar_S *)&((struct tabpage_S *)$tmp)->tp_vars;"
		end

feature {NONE} -- C setters

	c_set_tp_next (tmp: POINTER; a_tp_next: POINTER)
		external
			"C inline"
		alias
			"((struct tabpage_S *)$tmp)->tp_next = (struct tabpage_S *)$a_tp_next;"
		end

	c_set_tp_topframe (tmp: POINTER; a_tp_topframe: POINTER)
		external
			"C inline"
		alias
			"((struct tabpage_S *)$tmp)->tp_topframe = (struct frame_S *)$a_tp_topframe;"
		end

	c_set_tp_curwin (tmp: POINTER; a_tp_curwin: POINTER)
		external
			"C inline"
		alias
			"((struct tabpage_S *)$tmp)->tp_curwin = (struct window_S *)$a_tp_curwin;"
		end

	c_set_tp_prevwin (tmp: POINTER; a_tp_prevwin: POINTER)
		external
			"C inline"
		alias
			"((struct tabpage_S *)$tmp)->tp_prevwin = (struct window_S *)$a_tp_prevwin;"
		end

	c_set_tp_firstwin (tmp: POINTER; a_tp_firstwin: POINTER)
		external
			"C inline"
		alias
			"((struct tabpage_S *)$tmp)->tp_firstwin = (struct window_S *)$a_tp_firstwin;"
		end

	c_set_tp_lastwin (tmp: POINTER; a_tp_lastwin: POINTER)
		external
			"C inline"
		alias
			"((struct tabpage_S *)$tmp)->tp_lastwin = (struct window_S *)$a_tp_lastwin;"
		end

	c_set_tp_old_Rows (tmp: POINTER; a_tp_old_Rows: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tabpage_S *)$tmp)->tp_old_Rows = $a_tp_old_rows;"
		end

	c_set_tp_old_Columns (tmp: POINTER; a_tp_old_Columns: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tabpage_S *)$tmp)->tp_old_Columns = $a_tp_old_columns;"
		end

	c_set_tp_ch_used (tmp: POINTER; a_tp_ch_used: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tabpage_S *)$tmp)->tp_ch_used = $a_tp_ch_used;"
		end

	c_set_tp_first_diff (tmp: POINTER; a_tp_first_diff: POINTER)
		external
			"C inline"
		alias
			"((struct tabpage_S *)$tmp)->tp_first_diff = (struct diffblock_S *)$a_tp_first_diff;"
		end

	c_set_tp_diff_invalid (tmp: POINTER; a_tp_diff_invalid: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tabpage_S *)$tmp)->tp_diff_invalid = $a_tp_diff_invalid;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct tabpage_S);"
		end

end
