class
	PD_TAGGY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	tagname: CE_POINTER [NATURAL_8] assign set_tagname
		do
			create Result.make_shared (c_tagname (c_pointer))
		end

	fmark: PD_FILEMARK assign set_fmark
		do
			create Result.make_shared (c_fmark (c_pointer))
		end

	fmark_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct taggy, fmark);"
		end

	cur_match: INTEGER_32 assign set_cur_match
		do
			Result := c_cur_match (c_pointer)
		end

	cur_fnum: INTEGER_32 assign set_cur_fnum
		do
			Result := c_cur_fnum (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_tagname (a_tagname: CE_POINTER [NATURAL_8])
		do
			c_set_tagname (c_pointer, a_tagname.c_pointer)
		end

	set_fmark (a_fmark: PD_FILEMARK)
		do
			fmark.ce_gets (a_fmark)
		end

	set_cur_match (a_cur_match: INTEGER_32)
		do
			c_set_cur_match (c_pointer, a_cur_match)
		end

	set_cur_fnum (a_cur_fnum: INTEGER_32)
		do
			c_set_cur_fnum (c_pointer, a_cur_fnum)
		end

feature {NONE} -- C getters

	c_tagname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct taggy *)$tmp)->tagname;"
		end

	c_fmark (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct filemark *)&((struct taggy *)$tmp)->fmark;"
		end

	c_cur_match (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct taggy *)$tmp)->cur_match;"
		end

	c_cur_fnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct taggy *)$tmp)->cur_fnum;"
		end

feature {NONE} -- C setters

	c_set_tagname (tmp: POINTER; a_tagname: POINTER)
		external
			"C inline"
		alias
			"((struct taggy *)$tmp)->tagname = (unsigned char *)$a_tagname;"
		end

	c_set_cur_match (tmp: POINTER; a_cur_match: INTEGER_32)
		external
			"C inline"
		alias
			"((struct taggy *)$tmp)->cur_match = $a_cur_match;"
		end

	c_set_cur_fnum (tmp: POINTER; a_cur_fnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct taggy *)$tmp)->cur_fnum = $a_cur_fnum;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct taggy);"
		end

end
