class
	PD_TERMCODE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_name (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	code: CE_POINTER [NATURAL_8] assign set_code
		do
			create Result.make_shared (c_code (c_pointer))
		end

	len: INTEGER_32 assign set_len
		do
			Result := c_len (c_pointer)
		end

	modlen: INTEGER_32 assign set_modlen
		do
			Result := c_modlen (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_code (a_code: CE_POINTER [NATURAL_8])
		do
			c_set_code (c_pointer, a_code.c_pointer)
		end

	set_len (a_len: INTEGER_32)
		do
			c_set_len (c_pointer, a_len)
		end

	set_modlen (a_modlen: INTEGER_32)
		do
			c_set_modlen (c_pointer, a_modlen)
		end

feature {NONE} -- C getters

	c_name (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct termcode *tmp = (struct termcode *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->name) / sizeof(tmp->name[0]);
				return tmp->name;
			]"
		end

	c_code (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct termcode *)$tmp)->code;"
		end

	c_len (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct termcode *)$tmp)->len;"
		end

	c_modlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct termcode *)$tmp)->modlen;"
		end

feature {NONE} -- C setters

	c_set_code (tmp: POINTER; a_code: POINTER)
		external
			"C inline"
		alias
			"((struct termcode *)$tmp)->code = (unsigned char *)$a_code;"
		end

	c_set_len (tmp: POINTER; a_len: INTEGER_32)
		external
			"C inline"
		alias
			"((struct termcode *)$tmp)->len = $a_len;"
		end

	c_set_modlen (tmp: POINTER; a_modlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct termcode *)$tmp)->modlen = $a_modlen;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct termcode);"
		end

end
