class
	PD_U_ENTRY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ue_next: CE_POINTER [PD_U_ENTRY] assign set_ue_next
		do
			create Result.make_shared (c_ue_next (c_pointer))
		end

	ue_top: INTEGER_32 assign set_ue_top
		do
			Result := c_ue_top (c_pointer)
		end

	ue_bot: INTEGER_32 assign set_ue_bot
		do
			Result := c_ue_bot (c_pointer)
		end

	ue_lcount: INTEGER_32 assign set_ue_lcount
		do
			Result := c_ue_lcount (c_pointer)
		end

	ue_array: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_ue_array
		do
			create Result.make_shared (c_ue_array (c_pointer))
		end

	ue_size: INTEGER_32 assign set_ue_size
		do
			Result := c_ue_size (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_ue_next (a_ue_next: CE_POINTER [PD_U_ENTRY])
		do
			c_set_ue_next (c_pointer, a_ue_next.c_pointer)
		end

	set_ue_top (a_ue_top: INTEGER_32)
		do
			c_set_ue_top (c_pointer, a_ue_top)
		end

	set_ue_bot (a_ue_bot: INTEGER_32)
		do
			c_set_ue_bot (c_pointer, a_ue_bot)
		end

	set_ue_lcount (a_ue_lcount: INTEGER_32)
		do
			c_set_ue_lcount (c_pointer, a_ue_lcount)
		end

	set_ue_array (a_ue_array: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			c_set_ue_array (c_pointer, a_ue_array.c_pointer)
		end

	set_ue_size (a_ue_size: INTEGER_32)
		do
			c_set_ue_size (c_pointer, a_ue_size)
		end

feature {NONE} -- C getters

	c_ue_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct u_entry *)((struct u_entry *)$tmp)->ue_next;"
		end

	c_ue_top (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct u_entry *)$tmp)->ue_top;"
		end

	c_ue_bot (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct u_entry *)$tmp)->ue_bot;"
		end

	c_ue_lcount (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct u_entry *)$tmp)->ue_lcount;"
		end

	c_ue_array (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char * *)((struct u_entry *)$tmp)->ue_array;"
		end

	c_ue_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct u_entry *)$tmp)->ue_size;"
		end

feature {NONE} -- C setters

	c_set_ue_next (tmp: POINTER; a_ue_next: POINTER)
		external
			"C inline"
		alias
			"((struct u_entry *)$tmp)->ue_next = (struct u_entry *)$a_ue_next;"
		end

	c_set_ue_top (tmp: POINTER; a_ue_top: INTEGER_32)
		external
			"C inline"
		alias
			"((struct u_entry *)$tmp)->ue_top = $a_ue_top;"
		end

	c_set_ue_bot (tmp: POINTER; a_ue_bot: INTEGER_32)
		external
			"C inline"
		alias
			"((struct u_entry *)$tmp)->ue_bot = $a_ue_bot;"
		end

	c_set_ue_lcount (tmp: POINTER; a_ue_lcount: INTEGER_32)
		external
			"C inline"
		alias
			"((struct u_entry *)$tmp)->ue_lcount = $a_ue_lcount;"
		end

	c_set_ue_array (tmp: POINTER; a_ue_array: POINTER)
		external
			"C inline"
		alias
			"((struct u_entry *)$tmp)->ue_array = (unsigned char * *)$a_ue_array;"
		end

	c_set_ue_size (tmp: POINTER; a_ue_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct u_entry *)$tmp)->ue_size = $a_ue_size;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct u_entry);"
		end

end
