class
	PD_U_HEADER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	uh_next: PD_UH_NEXT assign set_uh_next
		do
			create Result.make_shared (c_uh_next (c_pointer))
		end

	uh_prev: PD_UH_PREV assign set_uh_prev
		do
			create Result.make_shared (c_uh_prev (c_pointer))
		end

	uh_alt_next: PD_UH_ALT_NEXT assign set_uh_alt_next
		do
			create Result.make_shared (c_uh_alt_next (c_pointer))
		end

	uh_alt_prev: PD_UH_ALT_PREV assign set_uh_alt_prev
		do
			create Result.make_shared (c_uh_alt_prev (c_pointer))
		end

	uh_seq: INTEGER_32 assign set_uh_seq
		do
			Result := c_uh_seq (c_pointer)
		end

	uh_walk: INTEGER_32 assign set_uh_walk
		do
			Result := c_uh_walk (c_pointer)
		end

	uh_entry: CE_POINTER [PD_U_ENTRY] assign set_uh_entry
		do
			create Result.make_shared (c_uh_entry (c_pointer))
		end

	uh_getbot_entry: CE_POINTER [PD_U_ENTRY] assign set_uh_getbot_entry
		do
			create Result.make_shared (c_uh_getbot_entry (c_pointer))
		end

	uh_cursor: PD_POS_T assign set_uh_cursor
		do
			create Result.make_shared (c_uh_cursor (c_pointer))
		end

	uh_cursor_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct u_header, uh_cursor);"
		end

	uh_cursor_vcol: INTEGER_32 assign set_uh_cursor_vcol
		do
			Result := c_uh_cursor_vcol (c_pointer)
		end

	uh_flags: INTEGER_32 assign set_uh_flags
		do
			Result := c_uh_flags (c_pointer)
		end

	uh_namedm: CE_ARRAY [PD_POS_T]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_uh_namedm (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	uh_visual: PD_VISUALINFO_T assign set_uh_visual
		do
			create Result.make_shared (c_uh_visual (c_pointer))
		end

	uh_visual_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct u_header, uh_visual);"
		end

	uh_time: INTEGER_32 assign set_uh_time
		do
			Result := c_uh_time (c_pointer)
		end

	uh_save_nr: INTEGER_32 assign set_uh_save_nr
		do
			Result := c_uh_save_nr (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_uh_next (a_uh_next: PD_UH_NEXT)
		do
			uh_next.ce_gets (a_uh_next)
		end

	set_uh_prev (a_uh_prev: PD_UH_PREV)
		do
			uh_prev.ce_gets (a_uh_prev)
		end

	set_uh_alt_next (a_uh_alt_next: PD_UH_ALT_NEXT)
		do
			uh_alt_next.ce_gets (a_uh_alt_next)
		end

	set_uh_alt_prev (a_uh_alt_prev: PD_UH_ALT_PREV)
		do
			uh_alt_prev.ce_gets (a_uh_alt_prev)
		end

	set_uh_seq (a_uh_seq: INTEGER_32)
		do
			c_set_uh_seq (c_pointer, a_uh_seq)
		end

	set_uh_walk (a_uh_walk: INTEGER_32)
		do
			c_set_uh_walk (c_pointer, a_uh_walk)
		end

	set_uh_entry (a_uh_entry: CE_POINTER [PD_U_ENTRY])
		do
			c_set_uh_entry (c_pointer, a_uh_entry.c_pointer)
		end

	set_uh_getbot_entry (a_uh_getbot_entry: CE_POINTER [PD_U_ENTRY])
		do
			c_set_uh_getbot_entry (c_pointer, a_uh_getbot_entry.c_pointer)
		end

	set_uh_cursor (a_uh_cursor: PD_POS_T)
		do
			uh_cursor.ce_gets (a_uh_cursor)
		end

	set_uh_cursor_vcol (a_uh_cursor_vcol: INTEGER_32)
		do
			c_set_uh_cursor_vcol (c_pointer, a_uh_cursor_vcol)
		end

	set_uh_flags (a_uh_flags: INTEGER_32)
		do
			c_set_uh_flags (c_pointer, a_uh_flags)
		end

	set_uh_visual (a_uh_visual: PD_VISUALINFO_T)
		do
			uh_visual.ce_gets (a_uh_visual)
		end

	set_uh_time (a_uh_time: INTEGER_32)
		do
			c_set_uh_time (c_pointer, a_uh_time)
		end

	set_uh_save_nr (a_uh_save_nr: INTEGER_32)
		do
			c_set_uh_save_nr (c_pointer, a_uh_save_nr)
		end

feature {NONE} -- C getters

	c_uh_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_uh_next_517 *)&((struct u_header *)$tmp)->uh_next;"
		end

	c_uh_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_uh_prev_518 *)&((struct u_header *)$tmp)->uh_prev;"
		end

	c_uh_alt_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_uh_alt_next_519 *)&((struct u_header *)$tmp)->uh_alt_next;"
		end

	c_uh_alt_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_uh_alt_prev_520 *)&((struct u_header *)$tmp)->uh_alt_prev;"
		end

	c_uh_seq (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct u_header *)$tmp)->uh_seq;"
		end

	c_uh_walk (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct u_header *)$tmp)->uh_walk;"
		end

	c_uh_entry (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct u_entry *)((struct u_header *)$tmp)->uh_entry;"
		end

	c_uh_getbot_entry (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct u_entry *)((struct u_header *)$tmp)->uh_getbot_entry;"
		end

	c_uh_cursor (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (pos_T *)&((struct u_header *)$tmp)->uh_cursor;"
		end

	c_uh_cursor_vcol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct u_header *)$tmp)->uh_cursor_vcol;"
		end

	c_uh_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct u_header *)$tmp)->uh_flags;"
		end

	c_uh_namedm (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct u_header *tmp = (struct u_header *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->uh_namedm) / sizeof(tmp->uh_namedm[0]);
				return tmp->uh_namedm;
			]"
		end

	c_uh_visual (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (visualinfo_T *)&((struct u_header *)$tmp)->uh_visual;"
		end

	c_uh_time (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct u_header *)$tmp)->uh_time;"
		end

	c_uh_save_nr (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct u_header *)$tmp)->uh_save_nr;"
		end

feature {NONE} -- C setters

	c_set_uh_seq (tmp: POINTER; a_uh_seq: INTEGER_32)
		external
			"C inline"
		alias
			"((struct u_header *)$tmp)->uh_seq = $a_uh_seq;"
		end

	c_set_uh_walk (tmp: POINTER; a_uh_walk: INTEGER_32)
		external
			"C inline"
		alias
			"((struct u_header *)$tmp)->uh_walk = $a_uh_walk;"
		end

	c_set_uh_entry (tmp: POINTER; a_uh_entry: POINTER)
		external
			"C inline"
		alias
			"((struct u_header *)$tmp)->uh_entry = (struct u_entry *)$a_uh_entry;"
		end

	c_set_uh_getbot_entry (tmp: POINTER; a_uh_getbot_entry: POINTER)
		external
			"C inline"
		alias
			"((struct u_header *)$tmp)->uh_getbot_entry = (struct u_entry *)$a_uh_getbot_entry;"
		end

	c_set_uh_cursor_vcol (tmp: POINTER; a_uh_cursor_vcol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct u_header *)$tmp)->uh_cursor_vcol = $a_uh_cursor_vcol;"
		end

	c_set_uh_flags (tmp: POINTER; a_uh_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct u_header *)$tmp)->uh_flags = $a_uh_flags;"
		end

	c_set_uh_time (tmp: POINTER; a_uh_time: INTEGER_32)
		external
			"C inline"
		alias
			"((struct u_header *)$tmp)->uh_time = $a_uh_time;"
		end

	c_set_uh_save_nr (tmp: POINTER; a_uh_save_nr: INTEGER_32)
		external
			"C inline"
		alias
			"((struct u_header *)$tmp)->uh_save_nr = $a_uh_save_nr;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct u_header);"
		end

end
