class
	PD_UFUNC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	uf_varargs: INTEGER_32 assign set_uf_varargs
		do
			Result := c_uf_varargs (c_pointer)
		end

	uf_flags: INTEGER_32 assign set_uf_flags
		do
			Result := c_uf_flags (c_pointer)
		end

	uf_calls: INTEGER_32 assign set_uf_calls
		do
			Result := c_uf_calls (c_pointer)
		end

	uf_args: PD_GROWARRAY assign set_uf_args
		do
			create Result.make_shared (c_uf_args (c_pointer))
		end

	uf_args_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct ufunc, uf_args);"
		end

	uf_lines: PD_GROWARRAY assign set_uf_lines
		do
			create Result.make_shared (c_uf_lines (c_pointer))
		end

	uf_lines_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct ufunc, uf_lines);"
		end

	uf_script_ID: INTEGER_32 assign set_uf_script_ID
		do
			Result := c_uf_script_ID (c_pointer)
		end

	uf_refcount: INTEGER_32 assign set_uf_refcount
		do
			Result := c_uf_refcount (c_pointer)
		end

	uf_name: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_uf_name (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_uf_varargs (a_uf_varargs: INTEGER_32)
		do
			c_set_uf_varargs (c_pointer, a_uf_varargs)
		end

	set_uf_flags (a_uf_flags: INTEGER_32)
		do
			c_set_uf_flags (c_pointer, a_uf_flags)
		end

	set_uf_calls (a_uf_calls: INTEGER_32)
		do
			c_set_uf_calls (c_pointer, a_uf_calls)
		end

	set_uf_args (a_uf_args: PD_GROWARRAY)
		do
			uf_args.ce_gets (a_uf_args)
		end

	set_uf_lines (a_uf_lines: PD_GROWARRAY)
		do
			uf_lines.ce_gets (a_uf_lines)
		end

	set_uf_script_ID (a_uf_script_ID: INTEGER_32)
		do
			c_set_uf_script_ID (c_pointer, a_uf_script_ID)
		end

	set_uf_refcount (a_uf_refcount: INTEGER_32)
		do
			c_set_uf_refcount (c_pointer, a_uf_refcount)
		end

feature {NONE} -- C getters

	c_uf_varargs (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ufunc *)$tmp)->uf_varargs;"
		end

	c_uf_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ufunc *)$tmp)->uf_flags;"
		end

	c_uf_calls (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ufunc *)$tmp)->uf_calls;"
		end

	c_uf_args (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct ufunc *)$tmp)->uf_args;"
		end

	c_uf_lines (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct ufunc *)$tmp)->uf_lines;"
		end

	c_uf_script_ID (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ufunc *)$tmp)->uf_script_ID;"
		end

	c_uf_refcount (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ufunc *)$tmp)->uf_refcount;"
		end

	c_uf_name (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct ufunc *tmp = (struct ufunc *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->uf_name) / sizeof(tmp->uf_name[0]);
				return tmp->uf_name;
			]"
		end

feature {NONE} -- C setters

	c_set_uf_varargs (tmp: POINTER; a_uf_varargs: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ufunc *)$tmp)->uf_varargs = $a_uf_varargs;"
		end

	c_set_uf_flags (tmp: POINTER; a_uf_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ufunc *)$tmp)->uf_flags = $a_uf_flags;"
		end

	c_set_uf_calls (tmp: POINTER; a_uf_calls: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ufunc *)$tmp)->uf_calls = $a_uf_calls;"
		end

	c_set_uf_script_ID (tmp: POINTER; a_uf_script_ID: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ufunc *)$tmp)->uf_script_ID = $a_uf_script_id;"
		end

	c_set_uf_refcount (tmp: POINTER; a_uf_refcount: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ufunc *)$tmp)->uf_refcount = $a_uf_refcount;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct ufunc);"
		end

end
