class
	PD_VIM_EXCEPTION

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	value: CE_POINTER [NATURAL_8] assign set_value
		do
			create Result.make_shared (c_value (c_pointer))
		end

	messages: CE_POINTER [PD_MSGLIST] assign set_messages
		do
			create Result.make_shared (c_messages (c_pointer))
		end

	throw_name: CE_POINTER [NATURAL_8] assign set_throw_name
		do
			create Result.make_shared (c_throw_name (c_pointer))
		end

	throw_lnum: INTEGER_32 assign set_throw_lnum
		do
			Result := c_throw_lnum (c_pointer)
		end

	caught: CE_POINTER [PD_VIM_EXCEPTION] assign set_caught
		do
			create Result.make_shared (c_caught (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_value (a_value: CE_POINTER [NATURAL_8])
		do
			c_set_value (c_pointer, a_value.c_pointer)
		end

	set_messages (a_messages: CE_POINTER [PD_MSGLIST])
		do
			c_set_messages (c_pointer, a_messages.c_pointer)
		end

	set_throw_name (a_throw_name: CE_POINTER [NATURAL_8])
		do
			c_set_throw_name (c_pointer, a_throw_name.c_pointer)
		end

	set_throw_lnum (a_throw_lnum: INTEGER_32)
		do
			c_set_throw_lnum (c_pointer, a_throw_lnum)
		end

	set_caught (a_caught: CE_POINTER [PD_VIM_EXCEPTION])
		do
			c_set_caught (c_pointer, a_caught.c_pointer)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct vim_exception *)$tmp)->type;"
		end

	c_value (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct vim_exception *)$tmp)->value;"
		end

	c_messages (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct msglist *)((struct vim_exception *)$tmp)->messages;"
		end

	c_throw_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct vim_exception *)$tmp)->throw_name;"
		end

	c_throw_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct vim_exception *)$tmp)->throw_lnum;"
		end

	c_caught (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct vim_exception *)((struct vim_exception *)$tmp)->caught;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct vim_exception *)$tmp)->type = $a_type;"
		end

	c_set_value (tmp: POINTER; a_value: POINTER)
		external
			"C inline"
		alias
			"((struct vim_exception *)$tmp)->value = (unsigned char *)$a_value;"
		end

	c_set_messages (tmp: POINTER; a_messages: POINTER)
		external
			"C inline"
		alias
			"((struct vim_exception *)$tmp)->messages = (struct msglist *)$a_messages;"
		end

	c_set_throw_name (tmp: POINTER; a_throw_name: POINTER)
		external
			"C inline"
		alias
			"((struct vim_exception *)$tmp)->throw_name = (unsigned char *)$a_throw_name;"
		end

	c_set_throw_lnum (tmp: POINTER; a_throw_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct vim_exception *)$tmp)->throw_lnum = $a_throw_lnum;"
		end

	c_set_caught (tmp: POINTER; a_caught: POINTER)
		external
			"C inline"
		alias
			"((struct vim_exception *)$tmp)->caught = (struct vim_exception *)$a_caught;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct vim_exception);"
		end

end
