class
	PD_VIMCLIPBOARD

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	available: INTEGER_32 assign set_available
		do
			Result := c_available (c_pointer)
		end

	owned: INTEGER_32 assign set_owned
		do
			Result := c_owned (c_pointer)
		end

	start: PD_POS_T assign set_start
		do
			create Result.make_shared (c_start (c_pointer))
		end

	end2: PD_POS_T assign set_end2
		do
			create Result.make_shared (c_end2 (c_pointer))
		end

	vmode: INTEGER_32 assign set_vmode
		do
			Result := c_vmode (c_pointer)
		end

	origin_row: NATURAL_16 assign set_origin_row
		do
			Result := c_origin_row (c_pointer)
		end

	origin_start_col: NATURAL_16 assign set_origin_start_col
		do
			Result := c_origin_start_col (c_pointer)
		end

	origin_end_col: NATURAL_16 assign set_origin_end_col
		do
			Result := c_origin_end_col (c_pointer)
		end

	word_start_col: NATURAL_16 assign set_word_start_col
		do
			Result := c_word_start_col (c_pointer)
		end

	word_end_col: NATURAL_16 assign set_word_end_col
		do
			Result := c_word_end_col (c_pointer)
		end

	prev: PD_POS_T assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	state: NATURAL_16 assign set_state
		do
			Result := c_state (c_pointer)
		end

	mode: NATURAL_16 assign set_mode
		do
			Result := c_mode (c_pointer)
		end

	sel_atom: NATURAL_32 assign set_sel_atom
		do
			Result := c_sel_atom (c_pointer)
		end

	gtk_sel_atom: CE_POINTER [ANY] assign set_gtk_sel_atom
		do
			create Result.make_shared (c_gtk_sel_atom (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_available (a_available: INTEGER_32)
		do
			c_set_available (c_pointer, a_available)
		end

	set_owned (a_owned: INTEGER_32)
		do
			c_set_owned (c_pointer, a_owned)
		end

	set_start (a_start: PD_POS_T)
		do
			start.ce_gets (a_start)
		end

	set_end2 (a_end2: PD_POS_T)
		do
			end2.ce_gets (a_end2)
		end

	set_vmode (a_vmode: INTEGER_32)
		do
			c_set_vmode (c_pointer, a_vmode)
		end

	set_origin_row (a_origin_row: NATURAL_16)
		do
			c_set_origin_row (c_pointer, a_origin_row)
		end

	set_origin_start_col (a_origin_start_col: NATURAL_16)
		do
			c_set_origin_start_col (c_pointer, a_origin_start_col)
		end

	set_origin_end_col (a_origin_end_col: NATURAL_16)
		do
			c_set_origin_end_col (c_pointer, a_origin_end_col)
		end

	set_word_start_col (a_word_start_col: NATURAL_16)
		do
			c_set_word_start_col (c_pointer, a_word_start_col)
		end

	set_word_end_col (a_word_end_col: NATURAL_16)
		do
			c_set_word_end_col (c_pointer, a_word_end_col)
		end

	set_prev (a_prev: PD_POS_T)
		do
			prev.ce_gets (a_prev)
		end

	set_state (a_state: NATURAL_16)
		do
			c_set_state (c_pointer, a_state)
		end

	set_mode (a_mode: NATURAL_16)
		do
			c_set_mode (c_pointer, a_mode)
		end

	set_sel_atom (a_sel_atom: NATURAL_32)
		do
			c_set_sel_atom (c_pointer, a_sel_atom)
		end

	set_gtk_sel_atom (a_gtk_sel_atom: CE_POINTER [ANY])
		do
			c_set_gtk_sel_atom (c_pointer, a_gtk_sel_atom.c_pointer)
		end

feature {NONE} -- C getters

	c_available (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct VimClipboard *)$tmp)->available;"
		end

	c_owned (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct VimClipboard *)$tmp)->owned;"
		end

	c_start (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (pos_T *)&((struct VimClipboard *)$tmp)->start;"
		end

	c_end2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (pos_T *)&((struct VimClipboard *)$tmp)->end;"
		end

	c_vmode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct VimClipboard *)$tmp)->vmode;"
		end

	c_origin_row (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct VimClipboard *)$tmp)->origin_row;"
		end

	c_origin_start_col (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct VimClipboard *)$tmp)->origin_start_col;"
		end

	c_origin_end_col (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct VimClipboard *)$tmp)->origin_end_col;"
		end

	c_word_start_col (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct VimClipboard *)$tmp)->word_start_col;"
		end

	c_word_end_col (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct VimClipboard *)$tmp)->word_end_col;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (pos_T *)&((struct VimClipboard *)$tmp)->prev;"
		end

	c_state (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct VimClipboard *)$tmp)->state;"
		end

	c_mode (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct VimClipboard *)$tmp)->mode;"
		end

	c_sel_atom (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct VimClipboard *)$tmp)->sel_atom;"
		end

	c_gtk_sel_atom (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct VimClipboard *)$tmp)->gtk_sel_atom;"
		end

feature {NONE} -- C setters

	c_set_available (tmp: POINTER; a_available: INTEGER_32)
		external
			"C inline"
		alias
			"((struct VimClipboard *)$tmp)->available = $a_available;"
		end

	c_set_owned (tmp: POINTER; a_owned: INTEGER_32)
		external
			"C inline"
		alias
			"((struct VimClipboard *)$tmp)->owned = $a_owned;"
		end

	c_set_vmode (tmp: POINTER; a_vmode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct VimClipboard *)$tmp)->vmode = $a_vmode;"
		end

	c_set_origin_row (tmp: POINTER; a_origin_row: NATURAL_16)
		external
			"C inline"
		alias
			"((struct VimClipboard *)$tmp)->origin_row = $a_origin_row;"
		end

	c_set_origin_start_col (tmp: POINTER; a_origin_start_col: NATURAL_16)
		external
			"C inline"
		alias
			"((struct VimClipboard *)$tmp)->origin_start_col = $a_origin_start_col;"
		end

	c_set_origin_end_col (tmp: POINTER; a_origin_end_col: NATURAL_16)
		external
			"C inline"
		alias
			"((struct VimClipboard *)$tmp)->origin_end_col = $a_origin_end_col;"
		end

	c_set_word_start_col (tmp: POINTER; a_word_start_col: NATURAL_16)
		external
			"C inline"
		alias
			"((struct VimClipboard *)$tmp)->word_start_col = $a_word_start_col;"
		end

	c_set_word_end_col (tmp: POINTER; a_word_end_col: NATURAL_16)
		external
			"C inline"
		alias
			"((struct VimClipboard *)$tmp)->word_end_col = $a_word_end_col;"
		end

	c_set_state (tmp: POINTER; a_state: NATURAL_16)
		external
			"C inline"
		alias
			"((struct VimClipboard *)$tmp)->state = $a_state;"
		end

	c_set_mode (tmp: POINTER; a_mode: NATURAL_16)
		external
			"C inline"
		alias
			"((struct VimClipboard *)$tmp)->mode = $a_mode;"
		end

	c_set_sel_atom (tmp: POINTER; a_sel_atom: NATURAL_32)
		external
			"C inline"
		alias
			"((struct VimClipboard *)$tmp)->sel_atom = $a_sel_atom;"
		end

	c_set_gtk_sel_atom (tmp: POINTER; a_gtk_sel_atom: POINTER)
		external
			"C inline"
		alias
			"((struct VimClipboard *)$tmp)->gtk_sel_atom = (void *)$a_gtk_sel_atom;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct VimClipboard);"
		end

end
