class
	PD_VIMMENU

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	modes: INTEGER_32 assign set_modes
		do
			Result := c_modes (c_pointer)
		end

	enabled: INTEGER_32 assign set_enabled
		do
			Result := c_enabled (c_pointer)
		end

	name: CE_POINTER [NATURAL_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	dname: CE_POINTER [NATURAL_8] assign set_dname
		do
			create Result.make_shared (c_dname (c_pointer))
		end

	en_name: CE_POINTER [NATURAL_8] assign set_en_name
		do
			create Result.make_shared (c_en_name (c_pointer))
		end

	en_dname: CE_POINTER [NATURAL_8] assign set_en_dname
		do
			create Result.make_shared (c_en_dname (c_pointer))
		end

	mnemonic: INTEGER_32 assign set_mnemonic
		do
			Result := c_mnemonic (c_pointer)
		end

	mnemonic_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct VimMenu, mnemonic);"
		end

	actext: CE_POINTER [NATURAL_8] assign set_actext
		do
			create Result.make_shared (c_actext (c_pointer))
		end

	actext_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct VimMenu, actext);"
		end

	priority: INTEGER_32 assign set_priority
		do
			Result := c_priority (c_pointer)
		end

	cb: CE_ROUTINE assign set_cb
		do
			create Result.make_shared (c_cb (c_pointer))
		end

	iconfile: CE_POINTER [NATURAL_8] assign set_iconfile
		do
			create Result.make_shared (c_iconfile (c_pointer))
		end

	iconidx: INTEGER_32 assign set_iconidx
		do
			Result := c_iconidx (c_pointer)
		end

	icon_builtin: INTEGER_32 assign set_icon_builtin
		do
			Result := c_icon_builtin (c_pointer)
		end

	strings: CE_ARRAY [CE_POINTER [NATURAL_8]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_strings (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	noremap: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_noremap (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	silent: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_silent (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	children: CE_POINTER [PD_VIMMENU] assign set_children
		do
			create Result.make_shared (c_children (c_pointer))
		end

	children_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct VimMenu, children);"
		end

	parent: CE_POINTER [PD_VIMMENU] assign set_parent
		do
			create Result.make_shared (c_parent (c_pointer))
		end

	next: CE_POINTER [PD_VIMMENU] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	next_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct VimMenu, next);"
		end

	id: CE_POINTER [SD_GTKWIDGET] assign set_id
		do
			create Result.make_shared (c_id (c_pointer))
		end

	submenu_id: CE_POINTER [SD_GTKWIDGET] assign set_submenu_id
		do
			create Result.make_shared (c_submenu_id (c_pointer))
		end

	tearoff_handle: CE_POINTER [SD_GTKWIDGET] assign set_tearoff_handle
		do
			create Result.make_shared (c_tearoff_handle (c_pointer))
		end

	label: CE_POINTER [SD_GTKWIDGET] assign set_label
		do
			create Result.make_shared (c_label (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_modes (a_modes: INTEGER_32)
		do
			c_set_modes (c_pointer, a_modes)
		end

	set_enabled (a_enabled: INTEGER_32)
		do
			c_set_enabled (c_pointer, a_enabled)
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_dname (a_dname: CE_POINTER [NATURAL_8])
		do
			c_set_dname (c_pointer, a_dname.c_pointer)
		end

	set_en_name (a_en_name: CE_POINTER [NATURAL_8])
		do
			c_set_en_name (c_pointer, a_en_name.c_pointer)
		end

	set_en_dname (a_en_dname: CE_POINTER [NATURAL_8])
		do
			c_set_en_dname (c_pointer, a_en_dname.c_pointer)
		end

	set_mnemonic (a_mnemonic: INTEGER_32)
		do
			c_set_mnemonic (c_pointer, a_mnemonic)
		end

	set_actext (a_actext: CE_POINTER [NATURAL_8])
		do
			c_set_actext (c_pointer, a_actext.c_pointer)
		end

	set_priority (a_priority: INTEGER_32)
		do
			c_set_priority (c_pointer, a_priority)
		end

	set_cb (a_cb: CE_ROUTINE)
		do
			c_set_cb (c_pointer, a_cb.c_pointer)
		end

	set_iconfile (a_iconfile: CE_POINTER [NATURAL_8])
		do
			c_set_iconfile (c_pointer, a_iconfile.c_pointer)
		end

	set_iconidx (a_iconidx: INTEGER_32)
		do
			c_set_iconidx (c_pointer, a_iconidx)
		end

	set_icon_builtin (a_icon_builtin: INTEGER_32)
		do
			c_set_icon_builtin (c_pointer, a_icon_builtin)
		end

	set_children (a_children: CE_POINTER [PD_VIMMENU])
		do
			c_set_children (c_pointer, a_children.c_pointer)
		end

	set_parent (a_parent: CE_POINTER [PD_VIMMENU])
		do
			c_set_parent (c_pointer, a_parent.c_pointer)
		end

	set_next (a_next: CE_POINTER [PD_VIMMENU])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_id (a_id: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_id (c_pointer, a_id.c_pointer)
		end

	set_submenu_id (a_submenu_id: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_submenu_id (c_pointer, a_submenu_id.c_pointer)
		end

	set_tearoff_handle (a_tearoff_handle: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_tearoff_handle (c_pointer, a_tearoff_handle.c_pointer)
		end

	set_label (a_label: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_label (c_pointer, a_label.c_pointer)
		end

feature {NONE} -- C getters

	c_modes (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct VimMenu *)$tmp)->modes;"
		end

	c_enabled (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct VimMenu *)$tmp)->enabled;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct VimMenu *)$tmp)->name;"
		end

	c_dname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct VimMenu *)$tmp)->dname;"
		end

	c_en_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct VimMenu *)$tmp)->en_name;"
		end

	c_en_dname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct VimMenu *)$tmp)->en_dname;"
		end

	c_mnemonic (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct VimMenu *)$tmp)->mnemonic;"
		end

	c_actext (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct VimMenu *)$tmp)->actext;"
		end

	c_priority (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct VimMenu *)$tmp)->priority;"
		end

	c_cb (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct VimMenu *))((struct VimMenu *)$tmp)->cb;"
		end

	c_iconfile (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct VimMenu *)$tmp)->iconfile;"
		end

	c_iconidx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct VimMenu *)$tmp)->iconidx;"
		end

	c_icon_builtin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct VimMenu *)$tmp)->icon_builtin;"
		end

	c_strings (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct VimMenu *tmp = (struct VimMenu *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->strings) / sizeof(tmp->strings[0]);
				return tmp->strings;
			]"
		end

	c_noremap (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct VimMenu *tmp = (struct VimMenu *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->noremap) / sizeof(tmp->noremap[0]);
				return tmp->noremap;
			]"
		end

	c_silent (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct VimMenu *tmp = (struct VimMenu *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->silent) / sizeof(tmp->silent[0]);
				return tmp->silent;
			]"
		end

	c_children (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct VimMenu *)((struct VimMenu *)$tmp)->children;"
		end

	c_parent (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct VimMenu *)((struct VimMenu *)$tmp)->parent;"
		end

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct VimMenu *)((struct VimMenu *)$tmp)->next;"
		end

	c_id (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct VimMenu *)$tmp)->id;"
		end

	c_submenu_id (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct VimMenu *)$tmp)->submenu_id;"
		end

	c_tearoff_handle (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct VimMenu *)$tmp)->tearoff_handle;"
		end

	c_label (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct VimMenu *)$tmp)->label;"
		end

feature {NONE} -- C setters

	c_set_modes (tmp: POINTER; a_modes: INTEGER_32)
		external
			"C inline"
		alias
			"((struct VimMenu *)$tmp)->modes = $a_modes;"
		end

	c_set_enabled (tmp: POINTER; a_enabled: INTEGER_32)
		external
			"C inline"
		alias
			"((struct VimMenu *)$tmp)->enabled = $a_enabled;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct VimMenu *)$tmp)->name = (unsigned char *)$a_name;"
		end

	c_set_dname (tmp: POINTER; a_dname: POINTER)
		external
			"C inline"
		alias
			"((struct VimMenu *)$tmp)->dname = (unsigned char *)$a_dname;"
		end

	c_set_en_name (tmp: POINTER; a_en_name: POINTER)
		external
			"C inline"
		alias
			"((struct VimMenu *)$tmp)->en_name = (unsigned char *)$a_en_name;"
		end

	c_set_en_dname (tmp: POINTER; a_en_dname: POINTER)
		external
			"C inline"
		alias
			"((struct VimMenu *)$tmp)->en_dname = (unsigned char *)$a_en_dname;"
		end

	c_set_mnemonic (tmp: POINTER; a_mnemonic: INTEGER_32)
		external
			"C inline"
		alias
			"((struct VimMenu *)$tmp)->mnemonic = $a_mnemonic;"
		end

	c_set_actext (tmp: POINTER; a_actext: POINTER)
		external
			"C inline"
		alias
			"((struct VimMenu *)$tmp)->actext = (unsigned char *)$a_actext;"
		end

	c_set_priority (tmp: POINTER; a_priority: INTEGER_32)
		external
			"C inline"
		alias
			"((struct VimMenu *)$tmp)->priority = $a_priority;"
		end

	c_set_cb (tmp: POINTER; a_cb: POINTER)
		external
			"C inline"
		alias
			"((struct VimMenu *)$tmp)->cb = (void( *)(struct VimMenu *))$a_cb;"
		end

	c_set_iconfile (tmp: POINTER; a_iconfile: POINTER)
		external
			"C inline"
		alias
			"((struct VimMenu *)$tmp)->iconfile = (unsigned char *)$a_iconfile;"
		end

	c_set_iconidx (tmp: POINTER; a_iconidx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct VimMenu *)$tmp)->iconidx = $a_iconidx;"
		end

	c_set_icon_builtin (tmp: POINTER; a_icon_builtin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct VimMenu *)$tmp)->icon_builtin = $a_icon_builtin;"
		end

	c_set_children (tmp: POINTER; a_children: POINTER)
		external
			"C inline"
		alias
			"((struct VimMenu *)$tmp)->children = (struct VimMenu *)$a_children;"
		end

	c_set_parent (tmp: POINTER; a_parent: POINTER)
		external
			"C inline"
		alias
			"((struct VimMenu *)$tmp)->parent = (struct VimMenu *)$a_parent;"
		end

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct VimMenu *)$tmp)->next = (struct VimMenu *)$a_next;"
		end

	c_set_id (tmp: POINTER; a_id: POINTER)
		external
			"C inline"
		alias
			"((struct VimMenu *)$tmp)->id = (struct _GtkWidget *)$a_id;"
		end

	c_set_submenu_id (tmp: POINTER; a_submenu_id: POINTER)
		external
			"C inline"
		alias
			"((struct VimMenu *)$tmp)->submenu_id = (struct _GtkWidget *)$a_submenu_id;"
		end

	c_set_tearoff_handle (tmp: POINTER; a_tearoff_handle: POINTER)
		external
			"C inline"
		alias
			"((struct VimMenu *)$tmp)->tearoff_handle = (struct _GtkWidget *)$a_tearoff_handle;"
		end

	c_set_label (tmp: POINTER; a_label: POINTER)
		external
			"C inline"
		alias
			"((struct VimMenu *)$tmp)->label = (struct _GtkWidget *)$a_label;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct VimMenu);"
		end

end
