class
	PD_VIMOPTION

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	fullname: CE_POINTER [INTEGER_8] assign set_fullname
		do
			create Result.make_shared (c_fullname (c_pointer))
		end

	shortname: CE_POINTER [INTEGER_8] assign set_shortname
		do
			create Result.make_shared (c_shortname (c_pointer))
		end

	flags: NATURAL_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	flags_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct vimoption, flags);"
		end

	var: CE_POINTER [NATURAL_8] assign set_var
		do
			create Result.make_shared (c_var (c_pointer))
		end

	indir: INTEGER_32 assign set_indir
		do
			Result := c_indir (c_pointer)
		end

	def_val: CE_ARRAY [CE_POINTER [NATURAL_8]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_def_val (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	scriptID: INTEGER_32 assign set_scriptID
		do
			Result := c_scriptID (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_fullname (a_fullname: CE_POINTER [INTEGER_8])
		do
			c_set_fullname (c_pointer, a_fullname.c_pointer)
		end

	set_shortname (a_shortname: CE_POINTER [INTEGER_8])
		do
			c_set_shortname (c_pointer, a_shortname.c_pointer)
		end

	set_flags (a_flags: NATURAL_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

	set_var (a_var: CE_POINTER [NATURAL_8])
		do
			c_set_var (c_pointer, a_var.c_pointer)
		end

	set_indir (a_indir: INTEGER_32)
		do
			c_set_indir (c_pointer, a_indir)
		end

	set_scriptID (a_scriptID: INTEGER_32)
		do
			c_set_scriptID (c_pointer, a_scriptID)
		end

feature {NONE} -- C getters

	c_fullname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct vimoption *)$tmp)->fullname;"
		end

	c_shortname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct vimoption *)$tmp)->shortname;"
		end

	c_flags (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct vimoption *)$tmp)->flags;"
		end

	c_var (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct vimoption *)$tmp)->var;"
		end

	c_indir (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct vimoption *)$tmp)->indir;"
		end

	c_def_val (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct vimoption *tmp = (struct vimoption *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->def_val) / sizeof(tmp->def_val[0]);
				return tmp->def_val;
			]"
		end

	c_scriptID (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct vimoption *)$tmp)->scriptID;"
		end

feature {NONE} -- C setters

	c_set_fullname (tmp: POINTER; a_fullname: POINTER)
		external
			"C inline"
		alias
			"((struct vimoption *)$tmp)->fullname = (char *)$a_fullname;"
		end

	c_set_shortname (tmp: POINTER; a_shortname: POINTER)
		external
			"C inline"
		alias
			"((struct vimoption *)$tmp)->shortname = (char *)$a_shortname;"
		end

	c_set_flags (tmp: POINTER; a_flags: NATURAL_32)
		external
			"C inline"
		alias
			"((struct vimoption *)$tmp)->flags = $a_flags;"
		end

	c_set_var (tmp: POINTER; a_var: POINTER)
		external
			"C inline"
		alias
			"((struct vimoption *)$tmp)->var = (unsigned char *)$a_var;"
		end

	c_set_indir (tmp: POINTER; a_indir: INTEGER_32)
		external
			"C inline"
		alias
			"((struct vimoption *)$tmp)->indir = $a_indir;"
		end

	c_set_scriptID (tmp: POINTER; a_scriptID: INTEGER_32)
		external
			"C inline"
		alias
			"((struct vimoption *)$tmp)->scriptID = $a_scriptid;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct vimoption);"
		end

end
