class
	PD_VIMVAR

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	vv_name: CE_POINTER [INTEGER_8] assign set_vv_name
		do
			create Result.make_shared (c_vv_name (c_pointer))
		end

	vv_di: PD_DICTITEM_S assign set_vv_di
		do
			create Result.make_shared (c_vv_di (c_pointer))
		end

	vv_di_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct vimvar, vv_di);"
		end

	vv_filler: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_vv_filler (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	vv_flags: INTEGER_8 assign set_vv_flags
		do
			Result := c_vv_flags (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_vv_name (a_vv_name: CE_POINTER [INTEGER_8])
		do
			c_set_vv_name (c_pointer, a_vv_name.c_pointer)
		end

	set_vv_di (a_vv_di: PD_DICTITEM_S)
		do
			vv_di.ce_gets (a_vv_di)
		end

	set_vv_flags (a_vv_flags: INTEGER_8)
		do
			c_set_vv_flags (c_pointer, a_vv_flags)
		end

feature {NONE} -- C getters

	c_vv_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct vimvar *)$tmp)->vv_name;"
		end

	c_vv_di (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dictitem_S *)&((struct vimvar *)$tmp)->vv_di;"
		end

	c_vv_filler (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct vimvar *tmp = (struct vimvar *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->vv_filler) / sizeof(tmp->vv_filler[0]);
				return tmp->vv_filler;
			]"
		end

	c_vv_flags (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct vimvar *)$tmp)->vv_flags;"
		end

feature {NONE} -- C setters

	c_set_vv_name (tmp: POINTER; a_vv_name: POINTER)
		external
			"C inline"
		alias
			"((struct vimvar *)$tmp)->vv_name = (char *)$a_vv_name;"
		end

	c_set_vv_flags (tmp: POINTER; a_vv_flags: INTEGER_8)
		external
			"C inline"
		alias
			"((struct vimvar *)$tmp)->vv_flags = $a_vv_flags;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct vimvar);"
		end

end
