class
	PD_VVAL

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	v_number: INTEGER_32 assign set_v_number
		do
			Result := c_v_number (c_pointer)
		end

	v_float: REAL_64 assign set_v_float
		do
			Result := c_v_float (c_pointer)
		end

	v_float_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(union __anonunion_vval_533, v_float);"
		end

	v_string: CE_POINTER [NATURAL_8] assign set_v_string
		do
			create Result.make_shared (c_v_string (c_pointer))
		end

	v_string_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(union __anonunion_vval_533, v_string);"
		end

	v_list: CE_POINTER [PD_LISTVAR_S] assign set_v_list
		do
			create Result.make_shared (c_v_list (c_pointer))
		end

	v_dict: CE_POINTER [PD_DICTVAR_S] assign set_v_dict
		do
			create Result.make_shared (c_v_dict (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_v_number (a_v_number: INTEGER_32)
		do
			c_set_v_number (c_pointer, a_v_number)
		end

	set_v_float (a_v_float: REAL_64)
		do
			c_set_v_float (c_pointer, a_v_float)
		end

	set_v_string (a_v_string: CE_POINTER [NATURAL_8])
		do
			c_set_v_string (c_pointer, a_v_string.c_pointer)
		end

	set_v_list (a_v_list: CE_POINTER [PD_LISTVAR_S])
		do
			c_set_v_list (c_pointer, a_v_list.c_pointer)
		end

	set_v_dict (a_v_dict: CE_POINTER [PD_DICTVAR_S])
		do
			c_set_v_dict (c_pointer, a_v_dict.c_pointer)
		end

feature {NONE} -- C getters

	c_v_number (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union __anonunion_vval_533 *)$tmp)->v_number;"
		end

	c_v_float (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((union __anonunion_vval_533 *)$tmp)->v_float;"
		end

	c_v_string (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((union __anonunion_vval_533 *)$tmp)->v_string;"
		end

	c_v_list (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct listvar_S *)((union __anonunion_vval_533 *)$tmp)->v_list;"
		end

	c_v_dict (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dictvar_S *)((union __anonunion_vval_533 *)$tmp)->v_dict;"
		end

feature {NONE} -- C setters

	c_set_v_number (tmp: POINTER; a_v_number: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_vval_533 *)$tmp)->v_number = $a_v_number;"
		end

	c_set_v_float (tmp: POINTER; a_v_float: REAL_64)
		external
			"C inline"
		alias
			"((union __anonunion_vval_533 *)$tmp)->v_float = $a_v_float;"
		end

	c_set_v_string (tmp: POINTER; a_v_string: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_vval_533 *)$tmp)->v_string = (unsigned char *)$a_v_string;"
		end

	c_set_v_list (tmp: POINTER; a_v_list: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_vval_533 *)$tmp)->v_list = (struct listvar_S *)$a_v_list;"
		end

	c_set_v_dict (tmp: POINTER; a_v_dict: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_vval_533 *)$tmp)->v_dict = (struct dictvar_S *)$a_v_dict;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(union __anonunion_vval_533);"
		end

end
