class
	PD_WININFO_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	wi_next: CE_POINTER [PD_WININFO_S] assign set_wi_next
		do
			create Result.make_shared (c_wi_next (c_pointer))
		end

	wi_prev: CE_POINTER [PD_WININFO_S] assign set_wi_prev
		do
			create Result.make_shared (c_wi_prev (c_pointer))
		end

	wi_win: CE_POINTER [PD_WINDOW_S] assign set_wi_win
		do
			create Result.make_shared (c_wi_win (c_pointer))
		end

	wi_fpos: PD_POS_T assign set_wi_fpos
		do
			create Result.make_shared (c_wi_fpos (c_pointer))
		end

	wi_fpos_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct wininfo_S, wi_fpos);"
		end

	wi_optset: INTEGER_32 assign set_wi_optset
		do
			Result := c_wi_optset (c_pointer)
		end

	wi_opt: PD_WINOPT_T assign set_wi_opt
		do
			create Result.make_shared (c_wi_opt (c_pointer))
		end

	wi_opt_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct wininfo_S, wi_opt);"
		end

	wi_fold_manual: INTEGER_32 assign set_wi_fold_manual
		do
			Result := c_wi_fold_manual (c_pointer)
		end

	wi_folds: PD_GROWARRAY assign set_wi_folds
		do
			create Result.make_shared (c_wi_folds (c_pointer))
		end

	wi_folds_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct wininfo_S, wi_folds);"
		end

feature {ANY} -- Eiffel setters

	set_wi_next (a_wi_next: CE_POINTER [PD_WININFO_S])
		do
			c_set_wi_next (c_pointer, a_wi_next.c_pointer)
		end

	set_wi_prev (a_wi_prev: CE_POINTER [PD_WININFO_S])
		do
			c_set_wi_prev (c_pointer, a_wi_prev.c_pointer)
		end

	set_wi_win (a_wi_win: CE_POINTER [PD_WINDOW_S])
		do
			c_set_wi_win (c_pointer, a_wi_win.c_pointer)
		end

	set_wi_fpos (a_wi_fpos: PD_POS_T)
		do
			wi_fpos.ce_gets (a_wi_fpos)
		end

	set_wi_optset (a_wi_optset: INTEGER_32)
		do
			c_set_wi_optset (c_pointer, a_wi_optset)
		end

	set_wi_opt (a_wi_opt: PD_WINOPT_T)
		do
			wi_opt.ce_gets (a_wi_opt)
		end

	set_wi_fold_manual (a_wi_fold_manual: INTEGER_32)
		do
			c_set_wi_fold_manual (c_pointer, a_wi_fold_manual)
		end

	set_wi_folds (a_wi_folds: PD_GROWARRAY)
		do
			wi_folds.ce_gets (a_wi_folds)
		end

feature {NONE} -- C getters

	c_wi_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct wininfo_S *)((struct wininfo_S *)$tmp)->wi_next;"
		end

	c_wi_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct wininfo_S *)((struct wininfo_S *)$tmp)->wi_prev;"
		end

	c_wi_win (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct window_S *)((struct wininfo_S *)$tmp)->wi_win;"
		end

	c_wi_fpos (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (pos_T *)&((struct wininfo_S *)$tmp)->wi_fpos;"
		end

	c_wi_optset (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct wininfo_S *)$tmp)->wi_optset;"
		end

	c_wi_opt (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (winopt_T *)&((struct wininfo_S *)$tmp)->wi_opt;"
		end

	c_wi_fold_manual (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct wininfo_S *)$tmp)->wi_fold_manual;"
		end

	c_wi_folds (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct wininfo_S *)$tmp)->wi_folds;"
		end

feature {NONE} -- C setters

	c_set_wi_next (tmp: POINTER; a_wi_next: POINTER)
		external
			"C inline"
		alias
			"((struct wininfo_S *)$tmp)->wi_next = (struct wininfo_S *)$a_wi_next;"
		end

	c_set_wi_prev (tmp: POINTER; a_wi_prev: POINTER)
		external
			"C inline"
		alias
			"((struct wininfo_S *)$tmp)->wi_prev = (struct wininfo_S *)$a_wi_prev;"
		end

	c_set_wi_win (tmp: POINTER; a_wi_win: POINTER)
		external
			"C inline"
		alias
			"((struct wininfo_S *)$tmp)->wi_win = (struct window_S *)$a_wi_win;"
		end

	c_set_wi_optset (tmp: POINTER; a_wi_optset: INTEGER_32)
		external
			"C inline"
		alias
			"((struct wininfo_S *)$tmp)->wi_optset = $a_wi_optset;"
		end

	c_set_wi_fold_manual (tmp: POINTER; a_wi_fold_manual: INTEGER_32)
		external
			"C inline"
		alias
			"((struct wininfo_S *)$tmp)->wi_fold_manual = $a_wi_fold_manual;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct wininfo_S);"
		end

end
