class
	PD_WORDCOUNT_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	wc_count: NATURAL_16 assign set_wc_count
		do
			Result := c_wc_count (c_pointer)
		end

	wc_word: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_wc_word (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_wc_count (a_wc_count: NATURAL_16)
		do
			c_set_wc_count (c_pointer, a_wc_count)
		end

feature {NONE} -- C getters

	c_wc_count (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct wordcount_S *)$tmp)->wc_count;"
		end

	c_wc_word (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct wordcount_S *tmp = (struct wordcount_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->wc_word) / sizeof(tmp->wc_word[0]);
				return tmp->wc_word;
			]"
		end

feature {NONE} -- C setters

	c_set_wc_count (tmp: POINTER; a_wc_count: NATURAL_16)
		external
			"C inline"
		alias
			"((struct wordcount_S *)$tmp)->wc_count = $a_wc_count;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct wordcount_S);"
		end

end
