class
	P_BLOWFISH

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create pax.make (<<18>>)
			create ipa.make (<<18>>)
			create sbx.make (<<4, 256>>)
			create sbi.make (<<4, 256>>)
			create bf_test_data.make (<<1>>)
			create ofb_buffer.make (<<64>>)
			create save_ofb_buffer.make (<<64>>)
			create save_pax.make (<<18>>)
			create save_sbx.make (<<4, 256>>)
		end

feature {ANY} -- attributes

	pax: CE_ARRAY [NATURAL_32]

	ipa: CE_ARRAY [NATURAL_32]

	sbx: CE_ARRAY [CE_ARRAY [NATURAL_32]]

	sbi: CE_ARRAY [CE_ARRAY [NATURAL_32]]

	bf_test_data: CE_ARRAY [PD_STRUCT_BF_TEST_DATA]

	randbyte_offset: INTEGER_32 assign set_randbyte_offset

	set_randbyte_offset (a_randbyte_offset: INTEGER_32)
		do
			randbyte_offset := a_randbyte_offset
		end

	update_offset: INTEGER_32 assign set_update_offset

	set_update_offset (a_update_offset: INTEGER_32)
		do
			update_offset := a_update_offset
		end

	ofb_buffer: CE_ARRAY [NATURAL_8]

	save_randbyte_offset: INTEGER_32 assign set_save_randbyte_offset

	set_save_randbyte_offset (a_save_randbyte_offset: INTEGER_32)
		do
			save_randbyte_offset := a_save_randbyte_offset
		end

	save_update_offset: INTEGER_32 assign set_save_update_offset

	set_save_update_offset (a_save_update_offset: INTEGER_32)
		do
			save_update_offset := a_save_update_offset
		end

	save_ofb_buffer: CE_ARRAY [NATURAL_8]

	save_pax: CE_ARRAY [NATURAL_32]

	save_sbx: CE_ARRAY [CE_ARRAY [NATURAL_32]]

feature {ANY} -- routines

	bf_e_block (a_p_xl: CE_POINTER [NATURAL_32]; a_p_xr: CE_POINTER [NATURAL_32])
		local
			l_temp: NATURAL_32
			l_xl: NATURAL_32
			l_xr: NATURAL_32
		do
			l_xl := a_p_xl.item
			l_xr := a_p_xr.item
			l_xl := (l_xl).bit_xor ((pax[0]))
			l_xr := (l_xr).bit_xor ((((((sbx[0])[((l_xl).bit_shift_right (24)).to_integer_32] + (sbx[1])[((((l_xl).bit_and ({NATURAL_32} 16711680))).bit_shift_right (16)).to_integer_32])).bit_xor ((sbx[2])[((((l_xl).bit_and ({NATURAL_32} 65280))).bit_shift_right (8)).to_integer_32])) + (sbx[3])[((l_xl).bit_and ({NATURAL_32} 255)).to_integer_32]))
			l_xr := (l_xr).bit_xor ((pax[1]))
			l_xl := (l_xl).bit_xor ((((((sbx[0])[((l_xr).bit_shift_right (24)).to_integer_32] + (sbx[1])[((((l_xr).bit_and ({NATURAL_32} 16711680))).bit_shift_right (16)).to_integer_32])).bit_xor ((sbx[2])[((((l_xr).bit_and ({NATURAL_32} 65280))).bit_shift_right (8)).to_integer_32])) + (sbx[3])[((l_xr).bit_and ({NATURAL_32} 255)).to_integer_32]))
			l_xl := (l_xl).bit_xor ((pax[2]))
			l_xr := (l_xr).bit_xor ((((((sbx[0])[((l_xl).bit_shift_right (24)).to_integer_32] + (sbx[1])[((((l_xl).bit_and ({NATURAL_32} 16711680))).bit_shift_right (16)).to_integer_32])).bit_xor ((sbx[2])[((((l_xl).bit_and ({NATURAL_32} 65280))).bit_shift_right (8)).to_integer_32])) + (sbx[3])[((l_xl).bit_and ({NATURAL_32} 255)).to_integer_32]))
			l_xr := (l_xr).bit_xor ((pax[3]))
			l_xl := (l_xl).bit_xor ((((((sbx[0])[((l_xr).bit_shift_right (24)).to_integer_32] + (sbx[1])[((((l_xr).bit_and ({NATURAL_32} 16711680))).bit_shift_right (16)).to_integer_32])).bit_xor ((sbx[2])[((((l_xr).bit_and ({NATURAL_32} 65280))).bit_shift_right (8)).to_integer_32])) + (sbx[3])[((l_xr).bit_and ({NATURAL_32} 255)).to_integer_32]))
			l_xl := (l_xl).bit_xor ((pax[4]))
			l_xr := (l_xr).bit_xor ((((((sbx[0])[((l_xl).bit_shift_right (24)).to_integer_32] + (sbx[1])[((((l_xl).bit_and ({NATURAL_32} 16711680))).bit_shift_right (16)).to_integer_32])).bit_xor ((sbx[2])[((((l_xl).bit_and ({NATURAL_32} 65280))).bit_shift_right (8)).to_integer_32])) + (sbx[3])[((l_xl).bit_and ({NATURAL_32} 255)).to_integer_32]))
			l_xr := (l_xr).bit_xor ((pax[5]))
			l_xl := (l_xl).bit_xor ((((((sbx[0])[((l_xr).bit_shift_right (24)).to_integer_32] + (sbx[1])[((((l_xr).bit_and ({NATURAL_32} 16711680))).bit_shift_right (16)).to_integer_32])).bit_xor ((sbx[2])[((((l_xr).bit_and ({NATURAL_32} 65280))).bit_shift_right (8)).to_integer_32])) + (sbx[3])[((l_xr).bit_and ({NATURAL_32} 255)).to_integer_32]))
			l_xl := (l_xl).bit_xor ((pax[6]))
			l_xr := (l_xr).bit_xor ((((((sbx[0])[((l_xl).bit_shift_right (24)).to_integer_32] + (sbx[1])[((((l_xl).bit_and ({NATURAL_32} 16711680))).bit_shift_right (16)).to_integer_32])).bit_xor ((sbx[2])[((((l_xl).bit_and ({NATURAL_32} 65280))).bit_shift_right (8)).to_integer_32])) + (sbx[3])[((l_xl).bit_and ({NATURAL_32} 255)).to_integer_32]))
			l_xr := (l_xr).bit_xor ((pax[7]))
			l_xl := (l_xl).bit_xor ((((((sbx[0])[((l_xr).bit_shift_right (24)).to_integer_32] + (sbx[1])[((((l_xr).bit_and ({NATURAL_32} 16711680))).bit_shift_right (16)).to_integer_32])).bit_xor ((sbx[2])[((((l_xr).bit_and ({NATURAL_32} 65280))).bit_shift_right (8)).to_integer_32])) + (sbx[3])[((l_xr).bit_and ({NATURAL_32} 255)).to_integer_32]))
			l_xl := (l_xl).bit_xor ((pax[8]))
			l_xr := (l_xr).bit_xor ((((((sbx[0])[((l_xl).bit_shift_right (24)).to_integer_32] + (sbx[1])[((((l_xl).bit_and ({NATURAL_32} 16711680))).bit_shift_right (16)).to_integer_32])).bit_xor ((sbx[2])[((((l_xl).bit_and ({NATURAL_32} 65280))).bit_shift_right (8)).to_integer_32])) + (sbx[3])[((l_xl).bit_and ({NATURAL_32} 255)).to_integer_32]))
			l_xr := (l_xr).bit_xor ((pax[9]))
			l_xl := (l_xl).bit_xor ((((((sbx[0])[((l_xr).bit_shift_right (24)).to_integer_32] + (sbx[1])[((((l_xr).bit_and ({NATURAL_32} 16711680))).bit_shift_right (16)).to_integer_32])).bit_xor ((sbx[2])[((((l_xr).bit_and ({NATURAL_32} 65280))).bit_shift_right (8)).to_integer_32])) + (sbx[3])[((l_xr).bit_and ({NATURAL_32} 255)).to_integer_32]))
			l_xl := (l_xl).bit_xor ((pax[10]))
			l_xr := (l_xr).bit_xor ((((((sbx[0])[((l_xl).bit_shift_right (24)).to_integer_32] + (sbx[1])[((((l_xl).bit_and ({NATURAL_32} 16711680))).bit_shift_right (16)).to_integer_32])).bit_xor ((sbx[2])[((((l_xl).bit_and ({NATURAL_32} 65280))).bit_shift_right (8)).to_integer_32])) + (sbx[3])[((l_xl).bit_and ({NATURAL_32} 255)).to_integer_32]))
			l_xr := (l_xr).bit_xor ((pax[11]))
			l_xl := (l_xl).bit_xor ((((((sbx[0])[((l_xr).bit_shift_right (24)).to_integer_32] + (sbx[1])[((((l_xr).bit_and ({NATURAL_32} 16711680))).bit_shift_right (16)).to_integer_32])).bit_xor ((sbx[2])[((((l_xr).bit_and ({NATURAL_32} 65280))).bit_shift_right (8)).to_integer_32])) + (sbx[3])[((l_xr).bit_and ({NATURAL_32} 255)).to_integer_32]))
			l_xl := (l_xl).bit_xor ((pax[12]))
			l_xr := (l_xr).bit_xor ((((((sbx[0])[((l_xl).bit_shift_right (24)).to_integer_32] + (sbx[1])[((((l_xl).bit_and ({NATURAL_32} 16711680))).bit_shift_right (16)).to_integer_32])).bit_xor ((sbx[2])[((((l_xl).bit_and ({NATURAL_32} 65280))).bit_shift_right (8)).to_integer_32])) + (sbx[3])[((l_xl).bit_and ({NATURAL_32} 255)).to_integer_32]))
			l_xr := (l_xr).bit_xor ((pax[13]))
			l_xl := (l_xl).bit_xor ((((((sbx[0])[((l_xr).bit_shift_right (24)).to_integer_32] + (sbx[1])[((((l_xr).bit_and ({NATURAL_32} 16711680))).bit_shift_right (16)).to_integer_32])).bit_xor ((sbx[2])[((((l_xr).bit_and ({NATURAL_32} 65280))).bit_shift_right (8)).to_integer_32])) + (sbx[3])[((l_xr).bit_and ({NATURAL_32} 255)).to_integer_32]))
			l_xl := (l_xl).bit_xor ((pax[14]))
			l_xr := (l_xr).bit_xor ((((((sbx[0])[((l_xl).bit_shift_right (24)).to_integer_32] + (sbx[1])[((((l_xl).bit_and ({NATURAL_32} 16711680))).bit_shift_right (16)).to_integer_32])).bit_xor ((sbx[2])[((((l_xl).bit_and ({NATURAL_32} 65280))).bit_shift_right (8)).to_integer_32])) + (sbx[3])[((l_xl).bit_and ({NATURAL_32} 255)).to_integer_32]))
			l_xr := (l_xr).bit_xor ((pax[15]))
			l_xl := (l_xl).bit_xor ((((((sbx[0])[((l_xr).bit_shift_right (24)).to_integer_32] + (sbx[1])[((((l_xr).bit_and ({NATURAL_32} 16711680))).bit_shift_right (16)).to_integer_32])).bit_xor ((sbx[2])[((((l_xr).bit_and ({NATURAL_32} 65280))).bit_shift_right (8)).to_integer_32])) + (sbx[3])[((l_xr).bit_and ({NATURAL_32} 255)).to_integer_32]))
			l_xl := (l_xl).bit_xor ((pax[16]))
			l_xr := (l_xr).bit_xor ((pax[17]))
			l_temp := l_xl
			l_xl := l_xr
			l_xr := l_temp
			a_p_xl.item := l_xl
			a_p_xr.item := l_xr
		end

	bf_e_cblock (a_block: CE_POINTER [NATURAL_8])
		local
			l_bk: PD_BLOCK8
		do
			create l_bk.make

			memcpy (create {CE_POINTER [ANY]}.make_cast ((l_bk.uc)), create {CE_POINTER [ANY]}.make_cast (a_block), (8).to_natural_32).do_nothing
			bf_e_block (l_bk.ul + 0, l_bk.ul + 1)
			memcpy (create {CE_POINTER [ANY]}.make_cast (a_block), create {CE_POINTER [ANY]}.make_cast ((l_bk.uc)), (8).to_natural_32).do_nothing
		end

	bf_key_init (a_password: CE_POINTER [NATURAL_8]; a_salt: CE_POINTER [NATURAL_8]; a_salt_len: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_keypos: INTEGER_32
			l_val___0: NATURAL_32
			l_data_l: NATURAL_32
			l_data_r: NATURAL_32
			l_key: CE_POINTER [NATURAL_8]
			l_keylen: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_key.make

			l_keypos := 0
			l_key.ce_gets (sha256_inst.sha256_key (a_password, a_salt, a_salt_len))
			l_i___0 := 0
			from
			until
				not (l_i___0 < 1000)
			loop
				l_key.ce_gets (sha256_inst.sha256_key (l_key, a_salt, a_salt_len))
				l_i___0 := l_i___0 + 1
			end
			l_keylen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_key))).to_integer_32 // 2
			if l_keylen = 0 then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E831: bf_key_init() called with empty password"))))).do_nothing
				js.return
			end
			if not js.return_called then
				l_i___0 := 0
				from
				until
					not (l_i___0 < l_keylen)
				loop
					sscanf ([create {CE_POINTER [INTEGER_8]}.make_cast ((l_key + l_i___0 * 2)), ce_string ("%%2x"), create {CE_POINTER [INTEGER_32]}.make_shared ($l_j)]).do_nothing
					l_key[l_i___0] := l_j.to_natural_8
					l_i___0 := l_i___0 + 1
				end
				memmove (create {CE_POINTER [ANY]}.make_cast (sbx), create {CE_POINTER [ANY]}.make_cast (sbi), (4096).to_natural_32).do_nothing
				l_i___0 := 0
				from
				until
					not (not js.loop_left and then (l_i___0 < 18))
				loop
					l_val___0 := (0).to_natural_32
					l_j := 0
					from
					until
						not (l_j < 4)
					loop
						l_tmp___1 := l_keypos
						l_keypos := l_keypos + 1
						l_val___0 := (((l_val___0).bit_shift_left (8))).bit_or ((l_key[l_tmp___1 \\ l_keylen]).to_natural_32)
						l_j := l_j + 1
					end
					pax[l_i___0] := (ipa[l_i___0]).bit_xor (l_val___0)
					l_i___0 := l_i___0 + 1
				end
				l_data_r := (0).to_natural_32
				l_data_l := l_data_r
				l_i___0 := 0
				from
				until
					not (l_i___0 < 18)
				loop
					bf_e_block (create {CE_POINTER [NATURAL_32]}.make_shared ($l_data_l), create {CE_POINTER [NATURAL_32]}.make_shared ($l_data_r))
					pax[l_i___0] := l_data_l
					pax[l_i___0 + 1] := l_data_r
					l_i___0 := l_i___0 + (2)
				end
				l_i___0 := 0
				from
				until
					not (not js.loop_left and then (l_i___0 < 4))
				loop
					l_j := 0
					from
					until
						not (l_j < 256)
					loop
						bf_e_block (create {CE_POINTER [NATURAL_32]}.make_shared ($l_data_l), create {CE_POINTER [NATURAL_32]}.make_shared ($l_data_r));
						(sbx[l_i___0])[l_j] := l_data_l;
						(sbx[l_i___0])[l_j + 1] := l_data_r
						l_j := l_j + (2)
					end
					l_i___0 := l_i___0 + 1
				end
			end
		end

	bf_check_tables (a_a_ipa: CE_POINTER [NATURAL_32]; a_a_sbi: CE_POINTER [CE_ARRAY [NATURAL_32]]; a_val___0: NATURAL_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_c: NATURAL_32
			js: JUMP_STATE
		do
			l_c := (0).to_natural_32
			l_i___0 := 0
			from
			until
				not (l_i___0 < 18)
			loop
				l_c := (l_c).bit_xor ((a_a_ipa[l_i___0]))
				l_i___0 := l_i___0 + 1
			end
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (l_i___0 < 4))
			loop
				l_j := 0
				from
				until
					not (l_j < 256)
				loop
					l_c := (l_c).bit_xor (((a_a_sbi[l_i___0])[l_j]))
					l_j := l_j + 1
				end
				l_i___0 := l_i___0 + 1
			end
			Result := (l_c = a_val___0).to_integer
		end

	bf_self_test: INTEGER_32
		local
			l_i___0: INTEGER_32
			l_bn: INTEGER_32
			l_err: INTEGER_32
			l_bk: PD_BLOCK8
			l_ui: NATURAL_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___6: INTEGER_32
		do
			create l_bk.make
			create l_tmp.make

			l_err := 0
			l_ui := ({NATURAL_32} 4294967295).to_natural_32
			if l_ui.to_natural_32 /= {NATURAL_32} 4294967295 then
				l_err := l_err + 1
				l_tmp.ce_gets (gettext (ce_string ("E820: sizeof(uint32_t) != 4")))
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
			elseif l_ui + {NATURAL_32} 1 /= {NATURAL_32} 0 then
				l_err := l_err + 1
				l_tmp.ce_gets (gettext (ce_string ("E820: sizeof(uint32_t) != 4")))
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
			end
			if not (bf_check_tables (create {CE_POINTER [NATURAL_32]}.make_cast (ipa), create {CE_POINTER [CE_ARRAY [NATURAL_32]]}.make_cast (sbi), (1878675978).to_natural_32)).to_boolean then
				l_err := l_err + 1
			end
			l_bn := (({PD_STRUCT_BF_TEST_DATA}.sizeof.to_natural_32 * (1).to_natural_32) // {PD_STRUCT_BF_TEST_DATA}.sizeof.to_natural_32).to_integer_32
			l_i___0 := 0
			from
			until
				not (l_i___0 < l_bn)
			loop
				bf_key_init (bf_test_data[l_i___0].password, bf_test_data[l_i___0].salt, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((bf_test_data[l_i___0].salt)))).to_integer_32)
				if not (bf_check_tables (create {CE_POINTER [NATURAL_32]}.make_cast (pax), create {CE_POINTER [CE_ARRAY [NATURAL_32]]}.make_cast (sbx), bf_test_data[l_i___0].keysum)).to_boolean then
					l_err := l_err + 1
				end
				memcpy (create {CE_POINTER [ANY]}.make_cast ((l_bk.uc)), create {CE_POINTER [ANY]}.make_cast ((bf_test_data[l_i___0].plaintxt)), (8).to_natural_32).do_nothing
				bf_e_cblock (l_bk.uc)
				if (memcmp (create {CE_POINTER [ANY]}.make_cast ((l_bk.uc)), create {CE_POINTER [ANY]}.make_cast ((bf_test_data[l_i___0].cryptxt)), (8).to_natural_32)) /= 0 then
					if l_err = 0 then
						if (memcmp (create {CE_POINTER [ANY]}.make_cast ((l_bk.uc)), create {CE_POINTER [ANY]}.make_cast ((bf_test_data[l_i___0].badcryptxt)), (8).to_natural_32)) = 0 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E817: Blowfish big/little endian use wrong"))))).do_nothing
						end
					end
					l_err := l_err + 1
				end
				l_i___0 := l_i___0 + 1
			end
			if l_err > 0 then
				l_tmp___6 := 0
			else
				l_tmp___6 := 1
			end
			Result := l_tmp___6
		end

	bf_ofb_init (a_iv: CE_POINTER [NATURAL_8]; a_iv_len: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_mi: INTEGER_32
		do
			update_offset := 0
			randbyte_offset := update_offset
			memset (create {CE_POINTER [ANY]}.make_cast (ofb_buffer), 0, (64).to_natural_32).do_nothing
			if a_iv_len > 0 then
				if a_iv_len > 64 then
					l_mi := a_iv_len
				else
					l_mi := 64
				end
				l_i___0 := 0
				from
				until
					not (l_i___0 < l_mi)
				loop
					ofb_buffer[l_i___0 \\ 64] := (((ofb_buffer[l_i___0 \\ 64]).to_integer_32).bit_xor ((a_iv[l_i___0 \\ a_iv_len]).to_integer_32)).to_natural_8
					l_i___0 := l_i___0 + 1
				end
			end
		end

	bf_crypt_encode (a_from: CE_POINTER [NATURAL_8]; a_len: NATURAL_32; a_to: CE_POINTER [NATURAL_8])
		local
			l_i___0: NATURAL_32
			l_ztemp: INTEGER_32
			l_t: INTEGER_32
		do
			l_i___0 := (0).to_natural_32
			from
			until
				not (l_i___0 < a_len)
			loop
				l_ztemp := (a_from[l_i___0.to_integer_32]).to_integer_32
				if ((randbyte_offset).bit_and (7)) = 0 then
					bf_e_cblock (ofb_buffer + randbyte_offset)
				end
				l_t := (ofb_buffer[randbyte_offset]).to_integer_32
				randbyte_offset := randbyte_offset + 1
				if randbyte_offset = 64 then
					randbyte_offset := 0
				end
				ofb_buffer[update_offset] := (((ofb_buffer[update_offset]).to_integer_32).bit_xor ((l_ztemp.to_natural_8).to_integer_32)).to_natural_8
				update_offset := update_offset + 1
				if update_offset = 64 then
					update_offset := 0
				end
				a_to[l_i___0.to_integer_32] := ((l_t).bit_xor (l_ztemp)).to_natural_8
				l_i___0 := l_i___0 + 1
			end
		end

	bf_crypt_decode (a_ptr: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_t: INTEGER_32
		do
			create l_p___0.make

			l_p___0.ce_gets (a_ptr)
			from
			until
				not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((a_ptr + a_len).c_pointer.to_integer_32).to_natural_32)
			loop
				if ((randbyte_offset).bit_and (7)) = 0 then
					bf_e_cblock (ofb_buffer + randbyte_offset)
				end
				l_t := (ofb_buffer[randbyte_offset]).to_integer_32
				randbyte_offset := randbyte_offset + 1
				if randbyte_offset = 64 then
					randbyte_offset := 0
				end
				l_p___0.item := (((l_p___0.item).to_integer_32).bit_xor (l_t)).to_natural_8
				ofb_buffer[update_offset] := (((ofb_buffer[update_offset]).to_integer_32).bit_xor ((l_p___0.item).to_integer_32)).to_natural_8
				update_offset := update_offset + 1
				if update_offset = 64 then
					update_offset := 0
				end
				l_p___0.ce_gets (l_p___0 + 1)
			end
		end

	bf_crypt_init_keys (a_passwd: CE_POINTER [NATURAL_8])
		local
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make

			l_p___0.ce_gets (a_passwd)
			from
			until
				(l_p___0.item).to_integer_32 = 0
			loop
				ofb_buffer[update_offset] := (((ofb_buffer[update_offset]).to_integer_32).bit_xor ((l_p___0.item).to_integer_32)).to_natural_8
				update_offset := update_offset + 1
				if update_offset = 64 then
					update_offset := 0
				end
				l_p___0.ce_gets (l_p___0 + 1)
			end
		end

	bf_crypt_save
		do
			save_randbyte_offset := randbyte_offset
			save_update_offset := update_offset
			memmove (create {CE_POINTER [ANY]}.make_cast (save_ofb_buffer), create {CE_POINTER [ANY]}.make_cast (ofb_buffer), (64).to_natural_32).do_nothing
			memmove (create {CE_POINTER [ANY]}.make_cast (save_pax), create {CE_POINTER [ANY]}.make_cast (pax), (72).to_natural_32).do_nothing
			memmove (create {CE_POINTER [ANY]}.make_cast (save_sbx), create {CE_POINTER [ANY]}.make_cast (sbx), (4096).to_natural_32).do_nothing
		end

	bf_crypt_restore
		do
			randbyte_offset := save_randbyte_offset
			update_offset := save_update_offset
			memmove (create {CE_POINTER [ANY]}.make_cast (ofb_buffer), create {CE_POINTER [ANY]}.make_cast (save_ofb_buffer), (64).to_natural_32).do_nothing
			memmove (create {CE_POINTER [ANY]}.make_cast (pax), create {CE_POINTER [ANY]}.make_cast (save_pax), (72).to_natural_32).do_nothing
			memmove (create {CE_POINTER [ANY]}.make_cast (sbx), create {CE_POINTER [ANY]}.make_cast (save_sbx), (4096).to_natural_32).do_nothing
		end

	blowfish_self_test: INTEGER_32
		local
			js: JUMP_STATE
		do
			if (sha256_inst.sha256_self_test) = 0 then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E818: sha256 test failed"))))).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				if (bf_self_test) = 0 then
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E819: Blowfish test failed"))))).do_nothing
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

end
