class
	P_CHARSET

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create transchar_buf.make (<<7>>)
			create latin1flags.make (<<257>>)
			create latin1upper.make (<<257>>)
			create latin1lower.make (<<257>>)
		end

feature {ANY} -- attributes

	chartab_initialized: INTEGER_32 assign set_chartab_initialized

	set_chartab_initialized (a_chartab_initialized: INTEGER_32)
		do
			chartab_initialized := a_chartab_initialized
		end

	transchar_buf: CE_ARRAY [NATURAL_8]

	latin1flags: CE_ARRAY [NATURAL_8]

	latin1upper: CE_ARRAY [NATURAL_8]

	latin1lower: CE_ARRAY [NATURAL_8]

feature {ANY} -- routines

	init_chartab: INTEGER_32
		do
			Result := (buf_init_chartab (globals_inst.curbuf, 1))
		end

	buf_init_chartab (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_global: INTEGER_32): INTEGER_32
		local
			l_c: INTEGER_32
			l_c2: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_tilde: INTEGER_32
			l_do_isalpha: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_tmp___6.make
			create l_tmp___8.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_global.to_boolean) then
						l_pos := -1 + 24 -- skip if block
					end
				when 1 then -- if:
						l_c := 0
						from
						until
							not (l_c < 32)
						loop
							l_tmp := l_c
							l_c := l_c + 1
							if ((option_inst.dy_flags).bit_and ({NATURAL_32} 2)).to_boolean then
								globals_inst.chartab[l_tmp] := (4).to_natural_8
							else
								globals_inst.chartab[l_tmp] := (2).to_natural_8
							end
						end
						from
						until
							not (l_c <= 126)
						loop
							l_tmp___0 := l_c
							l_c := l_c + 1
							globals_inst.chartab[l_tmp___0] := (17).to_natural_8
						end
				when 2 then -- loop condition:
						if not (l_c < 256) then
							l_pos := -1 + 14 -- skip loop
						end
				when 3 then -- loop body:
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_c >= 160 then
							l_tmp___1 := l_c
							l_c := l_c + 1
							globals_inst.chartab[l_tmp___1] := (17).to_natural_8
						else
							l_pos := -1 + 6 -- goto _L___1
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else: | _L___1:
						if globals_inst.enc_dbcs /= 9932 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_c = 142 then
							l_tmp___2 := l_c
							l_c := l_c + 1
							globals_inst.chartab[l_tmp___2] := (17).to_natural_8
						else
							l_pos := -1 + 9 -- goto _L___0
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else: | _L___0:
						if globals_inst.enc_dbcs = 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if (globals_inst.mb_bytelen_tab[l_c]).to_integer_32 = 2 then
							l_tmp___3 := l_c
							l_c := l_c + 1
							globals_inst.chartab[l_tmp___3] := (18).to_natural_8
						else
							l_pos := -1 + 12 -- goto _L
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						l_tmp___4 := l_c
						l_c := l_c + 1
						if ((option_inst.dy_flags).bit_and ({NATURAL_32} 2)).to_boolean then
							globals_inst.chartab[l_tmp___4] := (4).to_natural_8
						else
							globals_inst.chartab[l_tmp___4] := (2).to_natural_8
						end
				when 13 then -- if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 14 then -- loop done
						l_c := 1
				when 15 then -- loop condition:
						if not (l_c < 256) then
							l_pos := -1 + 24 -- skip loop
						end
				when 16 then -- loop body:
						if globals_inst.enc_dbcs = 0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if (globals_inst.mb_bytelen_tab[l_c]).to_integer_32 > 1 then
							globals_inst.chartab[l_c] := (((globals_inst.chartab[l_c]).to_integer_32).bit_or (64)).to_natural_8
						else
							l_pos := -1 + 19 -- goto _L___3
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 19 then -- else: | _L___3:
						if globals_inst.enc_dbcs /= 9932 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if l_c = 142 then
							globals_inst.chartab[l_c] := (((globals_inst.chartab[l_c]).to_integer_32).bit_or (64)).to_natural_8
						else
							l_pos := -1 + 22 -- goto _L___2
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else: | _L___2:
						if globals_inst.enc_utf8.to_boolean then
							if l_c >= 160 then
								globals_inst.chartab[l_c] := (((globals_inst.chartab[l_c]).to_integer_32).bit_or (64)).to_natural_8
							end
						end
				when 23 then -- if done
						l_c := l_c + 1
						l_pos := -1 + 15 -- back to loop condition
				when 24 then -- loop done | if done
						memset (create {CE_POINTER [ANY]}.make_cast ((a_buf___6.item.b_chartab)), 0, (32).to_natural_32).do_nothing
						if globals_inst.enc_dbcs /= 0 then
							l_c := 0
							from
							until
								not (l_c < 256)
							loop
								if (globals_inst.mb_bytelen_tab[l_c]).to_integer_32 = 2 then
									a_buf___6.item.b_chartab[((l_c.to_natural_32).bit_shift_right (3)).to_integer_32] := (((a_buf___6.item.b_chartab[((l_c.to_natural_32).bit_shift_right (3)).to_integer_32]).to_integer_32).bit_or (((1).bit_shift_left (((l_c).bit_and (7)))))).to_natural_8
								end
								l_c := l_c + 1
							end
						end
						if (a_buf___6.item.b_p_lisp).to_boolean then
							a_buf___6.item.b_chartab[(({NATURAL_32} 45).bit_shift_right (3)).to_integer_32] := (((a_buf___6.item.b_chartab[(({NATURAL_32} 45).bit_shift_right (3)).to_integer_32]).to_integer_32).bit_or (((1).bit_shift_left (5)))).to_natural_8
						end
						if a_global.to_boolean then
							l_i___0 := 0
						else
							l_i___0 := 3
						end
				when 25 then -- loop condition:
						if not (not js.loop_left and then (l_i___0 <= 3)) then
							l_pos := -1 + 76 -- skip loop
						end
				when 26 then -- loop body:
							if l_i___0 = 0 then
								l_p___0.ce_gets (option_inst.p_isi)
							elseif l_i___0 = 1 then
								l_p___0.ce_gets (option_inst.p_isp)
							elseif l_i___0 = 2 then
								l_p___0.ce_gets (option_inst.p_isf)
							else
								l_p___0.ce_gets (a_buf___6.item.b_p_isk)
							end
				when 27 then -- loop condition:
							if not (not js.loop_left and then ((l_p___0.item).to_boolean)) then
								l_pos := -1 + 75 -- skip loop
							end
				when 28 then -- loop body:
							l_tilde := 0
							l_do_isalpha := 0
							if (l_p___0.item).to_integer_32 = 94 then
								if (l_p___0[1]).to_integer_32 /= 0 then
									l_tilde := 1
									l_p___0.ce_gets (l_p___0 + 1)
								end
							end
							if not ((l_p___0.item).to_integer_32 >= 48) then
								l_pos := -1 + 31 -- skip if block
							end
				when 29 then -- if:
							if (l_p___0.item).to_integer_32 <= 57 then
								l_c := (getdigits (l_p___0.address)).to_integer_32
							else
								l_pos := -1 + 31 -- goto _L___4
							end
				when 30 then -- if block done, skip else block:
							l_pos := -1 + 32
				when 31 then -- else: | _L___4:
							if globals_inst.has_mbyte.to_boolean then
								l_c := mbyte_inst.mb_ptr2char_adv (l_p___0.address)
							else
								l_tmp___6.ce_gets (l_p___0)
								l_p___0.ce_gets (l_p___0 + 1)
								l_c := (l_tmp___6.item).to_integer_32
							end
				when 32 then
							l_c2 := -1
							if (l_p___0.item).to_integer_32 /= 45 then
								l_pos := -1 + 38 -- skip if block
							end
				when 33 then -- if:
							if (l_p___0[1]).to_integer_32 = 0 then
								l_pos := -1 + 38 -- skip if block
							end
				when 34 then -- if:
							l_p___0.ce_gets (l_p___0 + 1)
							if not ((l_p___0.item).to_integer_32 >= 48) then
								l_pos := -1 + 37 -- skip if block
							end
				when 35 then -- if:
							if (l_p___0.item).to_integer_32 <= 57 then
								l_c2 := (getdigits (l_p___0.address)).to_integer_32
							else
								l_pos := -1 + 37 -- goto _L___5
							end
				when 36 then -- if block done, skip else block:
							l_pos := -1 + 38
				when 37 then -- else: | _L___5:
							if globals_inst.has_mbyte.to_boolean then
								l_c2 := mbyte_inst.mb_ptr2char_adv (l_p___0.address)
							else
								l_tmp___8.ce_gets (l_p___0)
								l_p___0.ce_gets (l_p___0 + 1)
								l_c2 := (l_tmp___8.item).to_integer_32
							end
				when 38 then -- if done | if done
							if not (l_c <= 0) then
								l_pos := -1 + 41 -- skip if block
							end
				when 39 then -- if:
							Result := 0
							js.return
				when 40 then -- if block done, skip else block:
							l_pos := -1 + 48
				when 41 then -- else:
							if not (l_c >= 256) then
								l_pos := -1 + 44 -- skip if block
							end
				when 42 then -- if:
							Result := 0
							js.return
				when 43 then -- if block done, skip else block:
							l_pos := -1 + 48
				when 44 then -- else:
							if not (l_c2 < l_c) then
								l_pos := -1 + 47 -- skip if block
							end
				when 45 then -- if:
							if l_c2 /= -1 then
								Result := 0
								js.return
							else
								l_pos := -1 + 47 -- goto _L___6
							end
				when 46 then -- if block done, skip else block:
							l_pos := -1 + 48
				when 47 then -- else: | _L___6:
							if l_c2 >= 256 then
								Result := 0
								js.return
							elseif (l_p___0.item).to_integer_32 /= 0 then
								if (l_p___0.item).to_integer_32 /= 44 then
									Result := 0
									js.return
								end
							end
				when 48 then -- if done | if done
							if js.return_called then
								l_pos := -1 + 74 -- skip if block
							end
				when 49 then -- if:
							if l_c2 = -1 then
								if l_c = 64 then
									l_do_isalpha := 1
									l_c := 1
									l_c2 := 255
								else
									l_c2 := l_c
								end
							end
				when 50 then -- loop condition:
							if not (l_c <= l_c2) then
								l_pos := -1 + 73 -- skip loop
							end
				when 51 then -- loop body:
							if l_do_isalpha.to_boolean then
								l_pos := -1 + 54 -- skip if block
							end
				when 52 then -- if:
							l_pos := -1 + 58 -- goto _L___9
				when 53 then -- if block done, skip else block:
							l_pos := -1 + 72
				when 54 then -- else:
							if not ((vim_islower (l_c)).to_boolean) then
								l_pos := -1 + 57 -- skip if block
							end
				when 55 then -- if:
							l_pos := -1 + 58 -- goto _L___9
				when 56 then -- if block done, skip else block:
							l_pos := -1 + 72
				when 57 then -- else:
							if not ((vim_isupper (l_c)).to_boolean) then
								l_pos := -1 + 72 -- skip if block
							end
				when 58 then -- if: | _L___9:
							if l_i___0 /= 0 then
								l_pos := -1 + 61 -- skip if block
							end
				when 59 then -- if:
							if l_tilde.to_boolean then
								globals_inst.chartab[l_c] := (((globals_inst.chartab[l_c]).to_integer_32).bit_and (-33)).to_natural_8
							else
								globals_inst.chartab[l_c] := (((globals_inst.chartab[l_c]).to_integer_32).bit_or (32)).to_natural_8
							end
				when 60 then -- if block done, skip else block:
							l_pos := -1 + 72
				when 61 then -- else:
							if l_i___0 /= 1 then
								l_pos := -1 + 71 -- skip if block
							end
				when 62 then -- if:
							if not (l_c < 32) then
								l_pos := -1 + 65 -- skip if block
							end
				when 63 then -- if:
							l_pos := -1 + 66 -- goto _L___8
				when 64 then -- if block done, skip else block:
							l_pos := -1 + 70
				when 65 then -- else:
							if not (l_c > 126) then
								l_pos := -1 + 70 -- skip if block
							end
				when 66 then -- if: | _L___8:
							if not (globals_inst.enc_dbcs.to_boolean) then
								l_pos := -1 + 69 -- skip if block
							end
				when 67 then -- if:
							if (globals_inst.mb_bytelen_tab[l_c]).to_integer_32 /= 2 then
								l_pos := -1 + 69 -- goto _L___7
							end
				when 68 then -- if block done, skip else block:
							l_pos := -1 + 70
				when 69 then -- else: | _L___7:
							if l_tilde.to_boolean then
								if ((option_inst.dy_flags).bit_and ({NATURAL_32} 2)).to_boolean then
									l_tmp___9 := 4
								else
									l_tmp___9 := 2
								end
								globals_inst.chartab[l_c] := ((((globals_inst.chartab[l_c]).to_integer_32).bit_and (-8)) + l_tmp___9).to_natural_8
								globals_inst.chartab[l_c] := (((globals_inst.chartab[l_c]).to_integer_32).bit_and (-17)).to_natural_8
							else
								globals_inst.chartab[l_c] := ((((globals_inst.chartab[l_c]).to_integer_32).bit_and (-8)) + 1).to_natural_8
								globals_inst.chartab[l_c] := (((globals_inst.chartab[l_c]).to_integer_32).bit_or (16)).to_natural_8
							end
				when 70 then -- if done | if done | if done | if block done, skip else block:
							l_pos := -1 + 72
				when 71 then -- else:
							if l_i___0 = 2 then
								if l_tilde.to_boolean then
									globals_inst.chartab[l_c] := (((globals_inst.chartab[l_c]).to_integer_32).bit_and (-65)).to_natural_8
								else
									globals_inst.chartab[l_c] := (((globals_inst.chartab[l_c]).to_integer_32).bit_or (64)).to_natural_8
								end
							elseif l_tilde.to_boolean then
								a_buf___6.item.b_chartab[((l_c.to_natural_32).bit_shift_right (3)).to_integer_32] := (((a_buf___6.item.b_chartab[((l_c.to_natural_32).bit_shift_right (3)).to_integer_32]).to_integer_32).bit_and ((((1).bit_shift_left (((l_c).bit_and (7))))).bit_not)).to_natural_8
							else
								a_buf___6.item.b_chartab[((l_c.to_natural_32).bit_shift_right (3)).to_integer_32] := (((a_buf___6.item.b_chartab[((l_c.to_natural_32).bit_shift_right (3)).to_integer_32]).to_integer_32).bit_or (((1).bit_shift_left (((l_c).bit_and (7)))))).to_natural_8
							end
				when 72 then -- if done | if done | if done | if done
							l_c := l_c + 1
							l_pos := -1 + 50 -- back to loop condition
				when 73 then -- loop done
							l_p___0.ce_gets (misc1_inst.skip_to_option_part (l_p___0))
				when 74 then -- if done
							l_pos := -1 + 27 -- back to loop condition
				when 75 then -- loop done
							if not js.return_called then
								l_i___0 := l_i___0 + 1
							end
							l_pos := -1 + 25 -- back to loop condition
				when 76 then -- loop done
						if not js.return_called then
							chartab_initialized := 1
							Result := 1
						end
				when 77 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	trans_characters (a_buf___6: CE_POINTER [NATURAL_8]; a_bufsize: INTEGER_32)
		local
			l_buf___6: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_room: INTEGER_32
			l_trs: CE_POINTER [NATURAL_8]
			l_trs_len: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___6.make
			create l_trs.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buf___6.ce_gets (a_buf___6)
					l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6))).to_integer_32
					l_room := a_bufsize - l_len
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_buf___6.item).to_integer_32 /= 0)) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						if not (globals_inst.has_mbyte.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_trs_len := globals_inst.mb_ptr2len.integer_32_item ([l_buf___6])
						if l_trs_len > 1 then
							l_len := l_len - l_trs_len
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						l_trs.ce_gets (transchar_byte ((l_buf___6.item).to_integer_32))
						l_trs_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_trs))).to_integer_32
						if l_trs_len > 1 then
							l_room := l_room - (l_trs_len - 1)
							if l_room <= 0 then
								js.return
							end
							if not js.return_called then
								memmove (create {CE_POINTER [ANY]}.make_cast ((l_buf___6 + l_trs_len)), create {CE_POINTER [ANY]}.make_cast ((l_buf___6 + 1)), l_len.to_natural_32).do_nothing
							end
						end
						if not js.return_called then
							memmove (create {CE_POINTER [ANY]}.make_cast (l_buf___6), create {CE_POINTER [ANY]}.make_cast (l_trs), l_trs_len.to_natural_32).do_nothing
							l_len := l_len - 1
						end
				when 6 then
						if not js.return_called then
							l_buf___6.ce_gets (l_buf___6 + l_trs_len)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					if not js.return_called then
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	transstr (a_s: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_res: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_len: INTEGER_32
			l_c: INTEGER_32
			l_hexbuf: CE_ARRAY [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
		do
			create l_res.make
			create l_p___0.make
			create l_hexbuf.make (<<11>>)
			create l_tmp___1.make
			create l_tmp___5.make
			create l_tmp___6.make

			if globals_inst.has_mbyte.to_boolean then
				l_len := 0
				l_p___0.ce_gets (a_s)
				from
				until
					(l_p___0.item).to_integer_32 = 0
				loop
					l_l := globals_inst.mb_ptr2len.integer_32_item ([l_p___0])
					if l_l > 1 then
						l_c := globals_inst.mb_ptr2char.integer_32_item ([l_p___0])
						l_p___0.ce_gets (l_p___0 + l_l)
						if (vim_isprintc (l_c)).to_boolean then
							l_len := l_len + l_l
						else
							transchar_hex (l_hexbuf, l_c)
							l_len := l_len + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_hexbuf))).to_integer_32
						end
					else
						l_tmp___1.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_l := byte2cells ((l_tmp___1.item).to_integer_32)
						if l_l > 0 then
							l_len := l_len + l_l
						else
							l_len := l_len + (4)
						end
					end
				end
				l_res.ce_gets (misc2_inst.alloc ((l_len + 1).to_natural_32))
			else
				l_res.ce_gets (misc2_inst.alloc (((vim_strsize (a_s)) + 1).to_natural_32))
			end
			if (l_res.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_res.item := (('%/0/').code).to_natural_8
				l_p___0.ce_gets (a_s)
				from
				until
					(l_p___0.item).to_integer_32 = 0
				loop
					if globals_inst.has_mbyte.to_boolean then
						l_l := globals_inst.mb_ptr2len.integer_32_item ([l_p___0])
						if l_l > 1 then
							l_c := globals_inst.mb_ptr2char.integer_32_item ([l_p___0])
							if (vim_isprintc (l_c)).to_boolean then
								strncat (create {CE_POINTER [INTEGER_8]}.make_cast (l_res), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), l_l.to_natural_32).do_nothing
							else
								transchar_hex (l_res + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_res))).to_integer_32, l_c)
							end
							l_p___0.ce_gets (l_p___0 + l_l)
						else
							l_tmp___5.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___6.ce_gets (transchar_byte ((l_tmp___5.item).to_integer_32))
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_res), create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___6)).do_nothing
						end
					else
						l_tmp___5.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___6.ce_gets (transchar_byte ((l_tmp___5.item).to_integer_32))
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_res), create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___6)).do_nothing
					end
				end
			end
			Result := l_res
		end

	str_foldcase (a_str___1: CE_POINTER [NATURAL_8]; a_orglen: INTEGER_32; a_buf___6: CE_POINTER [NATURAL_8]; a_buflen: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_ga: PD_GROWARRAY
			l_i___0: INTEGER_32
			l_len: INTEGER_32
			l_c: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_ol: INTEGER_32
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_lc: INTEGER_32
			l_nl: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___11: CE_POINTER [NATURAL_8]
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ga.make
			create l_tmp___0.make
			create l_tmp___2.make
			create l_tmp___10.make
			create l_tmp___11.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := a_orglen
					if (a_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						misc2_inst.ga_init2 (l_ga.address, 1, 10)
						if (misc2_inst.ga_grow (l_ga.address, l_len + 1)) = 0 then
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called then
							memmove (l_ga.ga_data, create {CE_POINTER [ANY]}.make_cast (a_str___1), l_len.to_natural_32).do_nothing
							l_ga.ga_len := l_len
						end
					else
						if l_len >= a_buflen then
							l_len := a_buflen - 1
						end
						memmove (create {CE_POINTER [ANY]}.make_cast (a_buf___6), create {CE_POINTER [ANY]}.make_cast (a_str___1), l_len.to_natural_32).do_nothing
					end
					if js.return_called then
						l_pos := -1 + 22 -- skip if block
					end
				when 1 then -- if:
						if (a_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.ga_data)[l_len] := (('%/0/').code).to_natural_8
						else
							a_buf___6[l_len] := (('%/0/').code).to_natural_8
						end
						l_i___0 := 0
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 21 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if (a_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_tmp___16 := (create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.ga_data)[l_i___0]).to_integer_32
						else
							l_tmp___16 := (a_buf___6[l_i___0]).to_integer_32
						end
						if l_tmp___16 = 0 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 20 -- skip if block
						end
				when 4 then -- if:
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 9 -- goto _L___0
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 7 then -- else:
						if not (globals_inst.has_mbyte.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 8 then -- if:
						if (a_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_tmp___15 := (create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.ga_data)[l_i___0]).to_integer_32
						else
							l_tmp___15 := (a_buf___6[l_i___0]).to_integer_32
						end
						if not ((globals_inst.mb_bytelen_tab[l_tmp___15]).to_integer_32 > 1) then
							l_pos := -1 + 17 -- skip if block
						end
				when 9 then -- if: | _L___0:
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if:
						if (a_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_tmp___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.ga_data) + l_i___0)
						else
							l_tmp___0.ce_gets (a_buf___6 + l_i___0)
						end
						l_c := (mbyte_inst.utf_ptr2char (l_tmp___0))
						if (a_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_tmp___2.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.ga_data) + l_i___0)
						else
							l_tmp___2.ce_gets (a_buf___6 + l_i___0)
						end
						l_ol := (mbyte_inst.utf_ptr2len (l_tmp___2))
						l_lc := (mbyte_inst.utf_tolower (l_c))
						if not (l_c < 128) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 13 then -- else:
						if not (l_ol > 1) then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L:
						if l_c /= l_lc then
							l_nl := (mbyte_inst.utf_char2len (l_lc))
							if l_ol /= l_nl then
								if l_nl > l_ol then
									if (a_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										l_tmp___7 := ((misc2_inst.ga_grow (l_ga.address, (l_nl - l_ol) + 1)) = 0).to_integer
									else
										l_tmp___7 := ((l_len + l_nl) - l_ol >= a_buflen).to_integer
									end
									if l_tmp___7.to_boolean then
										l_lc := l_c
										l_nl := l_ol
									end
								end
								if l_ol /= l_nl then
									if (a_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										memmove (create {CE_POINTER [ANY]}.make_cast (((create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.ga_data) + l_i___0) + l_nl)), create {CE_POINTER [ANY]}.make_cast (((create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.ga_data) + l_i___0) + l_ol)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (((create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.ga_data) + l_i___0) + l_ol)))) + {NATURAL_32} 1).do_nothing
										l_ga.ga_len := l_ga.ga_len + (l_nl - l_ol)
									else
										memmove (create {CE_POINTER [ANY]}.make_cast (((a_buf___6 + l_i___0) + l_nl)), create {CE_POINTER [ANY]}.make_cast (((a_buf___6 + l_i___0) + l_ol)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (((a_buf___6 + l_i___0) + l_ol)))) + {NATURAL_32} 1).do_nothing
										l_len := l_len + (l_nl - l_ol)
									end
								end
							end
							if (a_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_tmp___10.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.ga_data) + l_i___0)
							else
								l_tmp___10.ce_gets (a_buf___6 + l_i___0)
							end
							mbyte_inst.utf_char2bytes (l_lc, l_tmp___10).do_nothing
						end
				when 15 then -- if done | if done
						if (a_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_tmp___11.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.ga_data) + l_i___0)
						else
							l_tmp___11.ce_gets (a_buf___6 + l_i___0)
						end
						l_i___0 := l_i___0 + (globals_inst.mb_ptr2len.integer_32_item ([l_tmp___11]))
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						l_pos := -1 + 19 -- goto _L___1
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L___1:
						if (a_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.ga_data)[l_i___0] := (tolower ((create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.ga_data)[l_i___0]).to_integer_32)).to_natural_8
						else
							a_buf___6[l_i___0] := (tolower ((a_buf___6[l_i___0]).to_integer_32)).to_natural_8
						end
						l_i___0 := l_i___0 + 1
				when 20 then -- if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 21 then -- loop done
						js.reset
						if (a_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							Result := (create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.ga_data))
							js.return
						end
				when 22 then -- if done
					if not js.return_called then
						Result := a_buf___6
					end
				when 23 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	transchar (a_c: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_c: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := a_c
					l_i___0 := 0
					if l_c < 0 then
						transchar_buf[0] := (('~').code).to_natural_8
						transchar_buf[1] := (('@').code).to_natural_8
						l_i___0 := 2
						if l_c = 128 then
							l_c := 254
						else
							if l_c = 0 then
								l_tmp := 255
							else
								l_tmp := (-l_c).bit_and (255)
							end
							l_c := l_tmp
						end
					end
					if chartab_initialized.to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_c >= 32 then
							if l_c <= 126 then
								transchar_buf[l_i___0] := l_c.to_natural_8
								transchar_buf[l_i___0 + 1] := (('%/0/').code).to_natural_8
							else
								l_pos := -1 + 3 -- goto _L
							end
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if l_c < 256 then
							if (vim_isprintc_strict (l_c)).to_boolean then
								transchar_buf[l_i___0] := l_c.to_natural_8
								transchar_buf[l_i___0 + 1] := (('%/0/').code).to_natural_8
							else
								transchar_nonprint (transchar_buf + l_i___0, l_c)
							end
						else
							transchar_nonprint (transchar_buf + l_i___0, l_c)
						end
				when 4 then
					Result := transchar_buf
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	transchar_byte (a_c: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			js: JUMP_STATE
		do
			if globals_inst.enc_utf8.to_boolean then
				if a_c >= 128 then
					transchar_nonprint (transchar_buf, a_c)
					Result := transchar_buf
					js.return
				end
			end
			if not js.return_called then
				Result := (transchar (a_c))
			end
		end

	transchar_nonprint (a_buf___6: CE_POINTER [NATURAL_8]; a_c: INTEGER_32)
		local
			l_c: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := a_c
					if l_c = 10 then
						l_c := ('%/0/').code
					elseif l_c = 13 then
						if (misc2_inst.get_fileformat (globals_inst.curbuf)) = 2 then
							l_c := ('%N').code
						end
					end
					if not (((option_inst.dy_flags).bit_and ({NATURAL_32} 2)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						transchar_hex (a_buf___6, l_c)
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if not (l_c <= 127) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						a_buf___6[0] := (('^').code).to_natural_8
						a_buf___6[1] := ((l_c).bit_xor (64)).to_natural_8
						a_buf___6[2] := (('%/0/').code).to_natural_8
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not (globals_inst.enc_utf8.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_c >= 128 then
							transchar_hex (a_buf___6, l_c)
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if l_c >= 160 then
							if l_c <= 254 then
								a_buf___6[0] := (('|').code).to_natural_8
								a_buf___6[1] := (l_c - 128).to_natural_8
								a_buf___6[2] := (('%/0/').code).to_natural_8
							else
								a_buf___6[0] := (('~').code).to_natural_8
								a_buf___6[1] := (((l_c - 128)).bit_xor (64)).to_natural_8
								a_buf___6[2] := (('%/0/').code).to_natural_8
							end
						else
							a_buf___6[0] := (('~').code).to_natural_8
							a_buf___6[1] := (((l_c - 128)).bit_xor (64)).to_natural_8
							a_buf___6[2] := (('%/0/').code).to_natural_8
						end
				when 10 then -- if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	transchar_hex (a_buf___6: CE_POINTER [NATURAL_8]; a_c: INTEGER_32)
		local
			l_i___0: INTEGER_32
		do
			l_i___0 := 0
			a_buf___6[0] := (('<').code).to_natural_8
			if a_c > 255 then
				l_i___0 := l_i___0 + 1
				a_buf___6[l_i___0] := (nr2hex ((a_c.to_natural_32).bit_shift_right (12))).to_natural_8
				l_i___0 := l_i___0 + 1
				a_buf___6[l_i___0] := (nr2hex ((a_c.to_natural_32).bit_shift_right (8))).to_natural_8
			end
			l_i___0 := l_i___0 + 1
			a_buf___6[l_i___0] := (nr2hex ((a_c.to_natural_32).bit_shift_right (4))).to_natural_8
			l_i___0 := l_i___0 + 1
			a_buf___6[l_i___0] := (nr2hex (a_c.to_natural_32)).to_natural_8
			l_i___0 := l_i___0 + 1
			a_buf___6[l_i___0] := (('>').code).to_natural_8
			l_i___0 := l_i___0 + 1
			a_buf___6[l_i___0] := (('%/0/').code).to_natural_8
		end

	nr2hex (a_c: NATURAL_32): NATURAL_32
		local
			js: JUMP_STATE
		do
			if ((a_c).bit_and ({NATURAL_32} 15)) <= {NATURAL_32} 9 then
				Result := (((a_c).bit_and ({NATURAL_32} 15)) + {NATURAL_32} 48)
				js.return
			end
			if not js.return_called then
				Result := ((((a_c).bit_and ({NATURAL_32} 15)) - {NATURAL_32} 10) + {NATURAL_32} 97)
			end
		end

	byte2cells (a_b: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if globals_inst.enc_utf8.to_boolean then
				if a_b >= 128 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := (((globals_inst.chartab[a_b]).to_integer_32).bit_and (7))
			end
		end

	char2cells (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			if a_c < 0 then
				if a_c = 128 then
					l_tmp___0 := 254
				else
					if a_c = 0 then
						l_tmp := 255
					else
						l_tmp := (-a_c).bit_and (255)
					end
					l_tmp___0 := l_tmp
				end
				Result := ((char2cells (l_tmp___0)) + 2)
				js.return
			end
			if not js.return_called and then (a_c >= 128) then
				if globals_inst.enc_utf8.to_boolean then
					Result := (mbyte_inst.utf_char2cells (a_c))
					js.return
				end
				if not js.return_called and then (globals_inst.enc_dbcs /= 0) then
					if a_c >= 256 then
						if globals_inst.enc_dbcs = 9932 then
							if (a_c.to_natural_32).bit_shift_right (8) = {NATURAL_32} 142 then
								Result := 1
								js.return
							end
						end
						if not js.return_called then
							Result := 2
							js.return
						end
					end
				end
			end
			if not js.return_called then
				Result := (((globals_inst.chartab[(a_c).bit_and (255)]).to_integer_32).bit_and (7))
			end
		end

	ptr2cells (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if globals_inst.enc_utf8.to_boolean then
				if (a_p___0.item).to_integer_32 >= 128 then
					Result := (mbyte_inst.utf_ptr2cells (a_p___0))
					js.return
				end
			end
			if not js.return_called then
				Result := (((globals_inst.chartab[(a_p___0.item).to_integer_32]).to_integer_32).bit_and (7))
			end
		end

	vim_strsize (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := (vim_strnsize (a_s, 2147483647))
		end

	vim_strnsize (a_s: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_size: INTEGER_32
			l_l: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_s.make
			create l_tmp___1.make

			l_s.ce_gets (a_s)
			l_len := a_len
			l_size := 0
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_s.item).to_integer_32 /= 0 then
					l_len := l_len - 1
					if not (l_len >= 0) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if globals_inst.has_mbyte.to_boolean then
						l_l := (globals_inst.mb_ptr2len.integer_32_item ([l_s]))
						l_size := l_size + (ptr2cells (l_s))
						l_s.ce_gets (l_s + l_l)
						l_len := l_len - (l_l - 1)
					else
						l_tmp___1.ce_gets (l_s)
						l_s.ce_gets (l_s + 1)
						l_size := l_size + (byte2cells ((l_tmp___1.item).to_integer_32))
					end
				end
			end
			js.reset
			Result := l_size
		end

	chartabsize (a_p___0: CE_POINTER [NATURAL_8]; a_col: INTEGER_32): INTEGER_32
		local
			l_ts: INTEGER_32
			l_tmp: INTEGER_32
		do
			if (a_p___0.item).to_integer_32 = 9 then
				if not (globals_inst.curwin.item.w_onebuf_opt.wo_list).to_boolean then
					l_ts := (globals_inst.curbuf.item.b_p_ts).to_integer_32
					Result := (l_ts - a_col \\ l_ts)
				elseif globals_inst.lcs_tab1.to_boolean then
					l_ts := (globals_inst.curbuf.item.b_p_ts).to_integer_32
					Result := (l_ts - a_col \\ l_ts)
				else
					l_tmp := ptr2cells (a_p___0)
					Result := l_tmp
				end
			else
				l_tmp := ptr2cells (a_p___0)
				Result := l_tmp
			end
		end

	win_chartabsize (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_p___0: CE_POINTER [NATURAL_8]; a_col: INTEGER_32): INTEGER_32
		local
			l_ts: INTEGER_32
			l_tmp: INTEGER_32
		do
			if (a_p___0.item).to_integer_32 = 9 then
				if not (a_wp___0.item.w_onebuf_opt.wo_list).to_boolean then
					l_ts := ((a_wp___0.item.w_buffer).item.b_p_ts).to_integer_32
					Result := (l_ts - a_col \\ l_ts)
				elseif globals_inst.lcs_tab1.to_boolean then
					l_ts := ((a_wp___0.item.w_buffer).item.b_p_ts).to_integer_32
					Result := (l_ts - a_col \\ l_ts)
				else
					l_tmp := ptr2cells (a_p___0)
					Result := l_tmp
				end
			else
				l_tmp := ptr2cells (a_p___0)
				Result := l_tmp
			end
		end

	linetabsize (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := (linetabsize_col (0, a_s))
		end

	linetabsize_col (a_startcol: INTEGER_32; a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_col: INTEGER_32
		do
			create l_s.make

			l_s.ce_gets (a_s)
			l_col := a_startcol
			from
			until
				(l_s.item).to_integer_32 = 0
			loop
				l_col := l_col + (lbr_chartabsize_adv (l_s.address, l_col))
			end
			Result := l_col
		end

	win_linetabsize (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_p___0: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		local
			l_col: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make

			l_col := 0
			l_s.ce_gets (a_p___0)
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_s.item).to_integer_32 /= 0 then
					if a_len.to_integer_32 /= 2147483647 then
						if not ((l_s.c_pointer.to_integer_32).to_natural_32 < ((a_p___0 + a_len).c_pointer.to_integer_32).to_natural_32) then
							js.break
						end
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_col := l_col + (win_lbr_chartabsize (a_wp___0, l_s, l_col, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
					if globals_inst.has_mbyte.to_boolean then
						l_tmp___0 := (globals_inst.mb_ptr2len.integer_32_item ([l_s]))
					else
						l_tmp___0 := 1
					end
					l_s.ce_gets (l_s + l_tmp___0)
				end
			end
			js.reset
			Result := l_col
		end

	vim_isIDc (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if a_c > 0 then
				if a_c < 256 then
					if (((globals_inst.chartab[a_c]).to_integer_32).bit_and (32)).to_boolean then
						l_tmp := 1
					else
						l_tmp := 0
					end
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	vim_iswordc (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			if a_c >= 256 then
				if globals_inst.enc_dbcs /= 0 then
					Result := ((mbyte_inst.dbcs_class ((a_c.to_natural_32).bit_shift_right (8), ((a_c).bit_and (255)).to_natural_32)) >= 2).to_integer
					js.return
				end
				if not js.return_called and then (globals_inst.enc_utf8.to_boolean) then
					Result := ((mbyte_inst.utf_class (a_c)) >= 2).to_integer
					js.return
				end
			end
			if not js.return_called then
				if a_c > 0 then
					if a_c < 256 then
						if (((globals_inst.curbuf.item.b_chartab[((a_c.to_natural_32).bit_shift_right (3)).to_integer_32]).to_integer_32).bit_and (((1).bit_shift_left (((a_c).bit_and (7)))))) /= 0 then
							l_tmp___1 := 1
						else
							l_tmp___1 := 0
						end
					else
						l_tmp___1 := 0
					end
				else
					l_tmp___1 := 0
				end
				Result := l_tmp___1
			end
		end

	vim_iswordp (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if globals_inst.has_mbyte.to_boolean then
				if (globals_inst.mb_bytelen_tab[(a_p___0.item).to_integer_32]).to_integer_32 > 1 then
					Result := ((mbyte_inst.mb_get_class (a_p___0)) >= 2).to_integer
					js.return
				end
			end
			if not js.return_called then
				Result := ((((globals_inst.curbuf.item.b_chartab[(((a_p___0.item).to_natural_32).bit_shift_right (3)).to_integer_32]).to_integer_32).bit_and (((1).bit_shift_left ((((a_p___0.item).to_integer_32).bit_and (7)))))) /= 0).to_integer
			end
		end

	vim_iswordc_buf (a_p___0: CE_POINTER [NATURAL_8]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if globals_inst.has_mbyte.to_boolean then
				if (globals_inst.mb_bytelen_tab[(a_p___0.item).to_integer_32]).to_integer_32 > 1 then
					Result := ((mbyte_inst.mb_get_class (a_p___0)) >= 2).to_integer
					js.return
				end
			end
			if not js.return_called then
				Result := ((((a_buf___6.item.b_chartab[(((a_p___0.item).to_natural_32).bit_shift_right (3)).to_integer_32]).to_integer_32).bit_and (((1).bit_shift_left ((((a_p___0.item).to_integer_32).bit_and (7)))))) /= 0).to_integer
			end
		end

	vim_isfilec (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if a_c >= 256 then
				l_tmp := 1
			elseif a_c > 0 then
				if (((globals_inst.chartab[a_c]).to_integer_32).bit_and (64)).to_boolean then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	vim_isfilec_or_wc (a_c: INTEGER_32): INTEGER_32
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_tmp___1: INTEGER_32
		do
			create l_buf___6.make (<<2>>)

			l_buf___6[0] := a_c.to_natural_8
			l_buf___6[1] := (('%/0/').code).to_natural_8
			if (vim_isfilec (a_c)).to_boolean then
				l_tmp___1 := 1
			elseif a_c = 93 then
				l_tmp___1 := 1
			elseif (os_unix_inst.mch_has_wildcard (l_buf___6)).to_boolean then
				l_tmp___1 := 1
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	vim_isprintc (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			if globals_inst.enc_utf8.to_boolean then
				if a_c >= 256 then
					Result := (mbyte_inst.utf_printable (a_c))
					js.return
				end
			end
			if not js.return_called then
				if a_c >= 256 then
					l_tmp___0 := 1
				elseif a_c > 0 then
					if (((globals_inst.chartab[a_c]).to_integer_32).bit_and (16)).to_boolean then
						l_tmp___0 := 1
					else
						l_tmp___0 := 0
					end
				else
					l_tmp___0 := 0
				end
				Result := l_tmp___0
			end
		end

	vim_isprintc_strict (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			if globals_inst.enc_dbcs /= 0 then
				if a_c < 256 then
					if (globals_inst.mb_bytelen_tab[a_c]).to_integer_32 > 1 then
						Result := 0
						js.return
					end
				end
			end
			if not js.return_called and then (globals_inst.enc_utf8.to_boolean) then
				if a_c >= 256 then
					Result := (mbyte_inst.utf_printable (a_c))
					js.return
				end
			end
			if not js.return_called then
				if a_c >= 256 then
					l_tmp___0 := 1
				elseif a_c > 0 then
					if (((globals_inst.chartab[a_c]).to_integer_32).bit_and (16)).to_boolean then
						l_tmp___0 := 1
					else
						l_tmp___0 := 0
					end
				else
					l_tmp___0 := 0
				end
				Result := l_tmp___0
			end
		end

	lbr_chartabsize (a_s: CE_POINTER [NATURAL_8]; a_col: INTEGER_32): INTEGER_32
		local
			l_ts: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			if not (globals_inst.curwin.item.w_onebuf_opt.wo_lbr).to_boolean then
				if (option_inst.p_sbr.item).to_integer_32 = 0 then
					if (globals_inst.curwin.item.w_onebuf_opt.wo_wrap).to_boolean then
						Result := (win_nolbr_chartabsize (globals_inst.curwin, a_s, a_col, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
						js.return
					end
					if not js.return_called then
						if (a_s.item).to_integer_32 = 9 then
							if not (globals_inst.curwin.item.w_onebuf_opt.wo_list).to_boolean then
								l_ts := (globals_inst.curbuf.item.b_p_ts).to_integer_32
								Result := (l_ts - a_col \\ l_ts)
								js.return
							elseif globals_inst.lcs_tab1.to_boolean then
								l_ts := (globals_inst.curbuf.item.b_p_ts).to_integer_32
								Result := (l_ts - a_col \\ l_ts)
								js.return
							else
								l_tmp___0 := ptr2cells (a_s)
								Result := l_tmp___0
								js.return
							end
						else
							l_tmp___0 := ptr2cells (a_s)
							Result := l_tmp___0
							js.return
						end
					end
				end
			end
			if not js.return_called then
				Result := (win_lbr_chartabsize (globals_inst.curwin, a_s, a_col, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
			end
		end

	lbr_chartabsize_adv (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_col: INTEGER_32): INTEGER_32
		local
			l_retval: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			l_retval := lbr_chartabsize (a_s.item, a_col)
			if globals_inst.has_mbyte.to_boolean then
				l_tmp___0 := (globals_inst.mb_ptr2len.integer_32_item ([a_s.item]))
			else
				l_tmp___0 := 1
			end
			a_s.item := a_s.item + l_tmp___0
			Result := l_retval
		end

	win_lbr_chartabsize (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_s: CE_POINTER [NATURAL_8]; a_col: INTEGER_32; a_headp: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_col: INTEGER_32
			l_c: INTEGER_32
			l_size: INTEGER_32
			l_col2: INTEGER_32
			l_colmax: INTEGER_32
			l_added: INTEGER_32
			l_mb_added: INTEGER_32
			l_numberextra: INTEGER_32
			l_ps: CE_POINTER [NATURAL_8]
			l_tab_corr: INTEGER_32
			l_n: INTEGER_32
			l_ts: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_ps.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s.ce_gets (a_s)
					l_col := a_col
					l_mb_added := 0
					l_tab_corr := ((l_s.item).to_integer_32 = 9).to_integer
					if not (a_wp___0.item.w_onebuf_opt.wo_lbr).to_boolean then
						if (option_inst.p_sbr.item).to_integer_32 = 0 then
							if (a_wp___0.item.w_onebuf_opt.wo_wrap).to_boolean then
								Result := (win_nolbr_chartabsize (a_wp___0, l_s, l_col, a_headp))
								js.return
							end
							if not js.return_called then
								if (l_s.item).to_integer_32 = 9 then
									if not (a_wp___0.item.w_onebuf_opt.wo_list).to_boolean then
										l_ts := ((a_wp___0.item.w_buffer).item.b_p_ts).to_integer_32
										Result := (l_ts - l_col \\ l_ts)
										js.return
									elseif globals_inst.lcs_tab1.to_boolean then
										l_ts := ((a_wp___0.item.w_buffer).item.b_p_ts).to_integer_32
										Result := (l_ts - l_col \\ l_ts)
										js.return
									else
										l_tmp___0 := ptr2cells (l_s)
										Result := l_tmp___0
										js.return
									end
								else
									l_tmp___0 := ptr2cells (l_s)
									Result := l_tmp___0
									js.return
								end
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						l_size := win_chartabsize (a_wp___0, l_s, l_col)
						l_c := (l_s.item).to_integer_32
						if not ((a_wp___0.item.w_onebuf_opt.wo_lbr).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (globals_inst.breakat_flags[(l_c.to_natural_8).to_integer_32]).to_boolean then
							if not (globals_inst.breakat_flags[(l_s[1]).to_integer_32]).to_boolean then
								if not (a_wp___0.item.w_onebuf_opt.wo_list).to_boolean then
									if (a_wp___0.item.w_onebuf_opt.wo_wrap).to_boolean then
										if a_wp___0.item.w_width /= 0 then
											l_numberextra := move_inst.win_col_off (a_wp___0)
											l_col2 := l_col
											l_colmax := a_wp___0.item.w_width - l_numberextra
											if l_col >= l_colmax then
												l_n := l_colmax + (move_inst.win_col_off2 (a_wp___0))
												if l_n > 0 then
													l_colmax := l_colmax + (((l_col - l_colmax) // l_n + 1) * l_n)
												end
											end
											from
											until
												js.loop_left
											loop
												js.reset
												l_ps.ce_gets (l_s)
												if globals_inst.has_mbyte.to_boolean then
													l_tmp___3 := (globals_inst.mb_ptr2len.integer_32_item ([l_s]))
												else
													l_tmp___3 := 1
												end
												l_s.ce_gets (l_s + l_tmp___3)
												l_c := (l_s.item).to_integer_32
												if l_c /= 0 then
													if not (globals_inst.breakat_flags[(l_c.to_natural_8).to_integer_32]).to_boolean then
														if not (globals_inst.breakat_flags[(l_c.to_natural_8).to_integer_32]).to_boolean then
															if l_col2 /= l_col then
																if (globals_inst.breakat_flags[(l_ps.item).to_integer_32]).to_boolean then
																	js.break
																end
															end
														else
															js.break
														end
													end
												else
													js.break
												end
												if not js.loop_jumped then
													l_col2 := l_col2 + (win_chartabsize (a_wp___0, l_s, l_col2))
													if l_col2 >= l_colmax then
														l_size := l_colmax - l_col
														l_tab_corr := 0
														js.break
													end
												end
											end
											js.reset
										else
											l_pos := -1 + 4 -- goto _L___3
										end
									else
										l_pos := -1 + 4 -- goto _L___3
									end
								else
									l_pos := -1 + 4 -- goto _L___3
								end
							else
								l_pos := -1 + 4 -- goto _L___3
							end
						else
							l_pos := -1 + 4 -- goto _L___3
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L___3:
						if globals_inst.has_mbyte.to_boolean then
							if l_size = 2 then
								if (globals_inst.mb_bytelen_tab[(l_s.item).to_integer_32]).to_integer_32 > 1 then
									if (a_wp___0.item.w_onebuf_opt.wo_wrap).to_boolean then
										if (in_win_border (a_wp___0, l_col)).to_boolean then
											l_size := l_size + 1
											l_mb_added := 1
										end
									end
								end
							end
						end
				when 5 then
						l_added := 0
						if (option_inst.p_sbr.item).to_integer_32 = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 6 then -- if:
						if not ((a_wp___0.item.w_onebuf_opt.wo_wrap).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 7 then -- if:
						if l_col = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 8 then -- if:
						l_numberextra := move_inst.win_col_off (a_wp___0)
						l_col := l_col + (l_numberextra + l_mb_added)
						if l_col >= a_wp___0.item.w_width then
							l_col := l_col - (a_wp___0.item.w_width)
							l_numberextra := a_wp___0.item.w_width - (l_numberextra - (move_inst.win_col_off2 (a_wp___0)))
							if l_numberextra > 0 then
								l_col := l_col \\ l_numberextra
							end
						end
						if l_col /= 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L___4
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if not (l_col + l_size > a_wp___0.item.w_width) then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L___4:
						l_added := vim_strsize (option_inst.p_sbr)
						if l_tab_corr.to_boolean then
							l_size := (l_size.to_integer_32 + (l_added.to_integer_32 // (a_wp___0.item.w_buffer).item.b_p_ts) * (a_wp___0.item.w_buffer).item.b_p_ts).to_integer_32
						else
							l_size := l_size + l_added
						end
						if l_col /= 0 then
							l_added := 0
						end
				when 13 then -- if done | if done | if done | if done
						if (a_headp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							a_headp.item := l_added + l_mb_added
						end
						Result := l_size
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	win_nolbr_chartabsize (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_s: CE_POINTER [NATURAL_8]; a_col: INTEGER_32; a_headp: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			if (a_s.item).to_integer_32 = 9 then
				if not (a_wp___0.item.w_onebuf_opt.wo_list).to_boolean then
					l_n := ((a_wp___0.item.w_buffer).item.b_p_ts).to_integer_32
					Result := (l_n - a_col \\ l_n)
					js.return
				elseif globals_inst.lcs_tab1.to_boolean then
					l_n := ((a_wp___0.item.w_buffer).item.b_p_ts).to_integer_32
					Result := (l_n - a_col \\ l_n)
					js.return
				end
			end
			if not js.return_called then
				l_n := ptr2cells (a_s)
				if l_n = 2 then
					if (globals_inst.mb_bytelen_tab[(a_s.item).to_integer_32]).to_integer_32 > 1 then
						if (in_win_border (a_wp___0, a_col)).to_boolean then
							if (a_headp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								a_headp.item := 1
							end
							Result := 3
							js.return
						end
					end
				end
			end
			if not js.return_called then
				Result := l_n
			end
		end

	in_win_border (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_vcol: INTEGER_32): INTEGER_32
		local
			l_width1: INTEGER_32
			l_width2: INTEGER_32
			js: JUMP_STATE
		do
			if a_wp___0.item.w_width = 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_width1 := a_wp___0.item.w_width - (move_inst.win_col_off (a_wp___0))
				if a_vcol < l_width1 - 1 then
					Result := 0
					js.return
				end
			end
			if not js.return_called and then (a_vcol = l_width1 - 1) then
				Result := 1
				js.return
			end
			if not js.return_called then
				l_width2 := l_width1 + (move_inst.win_col_off2 (a_wp___0))
				if l_width2 <= 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := ((a_vcol - l_width1) \\ l_width2 = l_width2 - 1).to_integer
			end
		end

	getvcol (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_pos___3: CE_POINTER [PD_POS_T]; a_start___1: CE_POINTER [INTEGER_32]; a_cursor: CE_POINTER [INTEGER_32]; a_end: CE_POINTER [INTEGER_32])
		local
			l_vcol: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_posptr: CE_POINTER [NATURAL_8]
			l_incr: INTEGER_32
			l_head___0: INTEGER_32
			l_ts: INTEGER_32
			l_c: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ptr.make
			create l_posptr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ts := ((a_wp___0.item.w_buffer).item.b_p_ts).to_integer_32
					l_vcol := 0
					l_ptr.ce_gets (memline_inst.ml_get_buf (a_wp___0.item.w_buffer, a_pos___3.item.lnum, 0))
					if (a_pos___3.item.col).to_integer_32 = 2147483647 then
						l_posptr.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					else
						l_posptr.ce_gets (l_ptr + a_pos___3.item.col)
					end
					if (a_wp___0.item.w_onebuf_opt.wo_list).to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if globals_inst.lcs_tab1 = 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L___1:
						if not (a_wp___0.item.w_onebuf_opt.wo_lbr).to_boolean then
							if (option_inst.p_sbr.item).to_integer_32 = 0 then
								from
								until
									js.loop_left
								loop
									js.reset
									l_head___0 := 0
									l_c := (l_ptr.item).to_integer_32
									if l_c = 0 then
										l_incr := 1
										js.break
									end
									if not js.loop_jumped then
										if l_c = 9 then
											l_incr := l_ts - l_vcol \\ l_ts
										elseif globals_inst.has_mbyte.to_boolean then
											if globals_inst.enc_utf8.to_boolean then
												if l_c >= 128 then
													l_incr := mbyte_inst.utf_ptr2cells (l_ptr)
												else
													l_incr := ((globals_inst.chartab[l_c]).to_integer_32).bit_and (7)
												end
											else
												l_incr := ((globals_inst.chartab[l_c]).to_integer_32).bit_and (7)
											end
											if l_incr = 2 then
												if (a_wp___0.item.w_onebuf_opt.wo_wrap).to_boolean then
													if (globals_inst.mb_bytelen_tab[(l_ptr.item).to_integer_32]).to_integer_32 > 1 then
														if (in_win_border (a_wp___0, l_vcol)).to_boolean then
															l_incr := l_incr + 1
															l_head___0 := 1
														end
													end
												end
											end
										else
											l_incr := ((globals_inst.chartab[l_c]).to_integer_32).bit_and (7)
										end
										if (l_posptr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
											if (l_ptr.c_pointer.to_integer_32).to_natural_32 >= (l_posptr.c_pointer.to_integer_32).to_natural_32 then
												js.break
											end
										end
									end
									if not js.loop_jumped then
										l_vcol := l_vcol + l_incr
										if globals_inst.has_mbyte.to_boolean then
											l_tmp___1 := (globals_inst.mb_ptr2len.integer_32_item ([l_ptr]))
										else
											l_tmp___1 := 1
										end
										l_ptr.ce_gets (l_ptr + l_tmp___1)
									end
								end
								js.reset
							else
								l_pos := -1 + 6 -- goto _L___0
							end
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							l_head___0 := 0
							l_incr := win_lbr_chartabsize (a_wp___0, l_ptr, l_vcol, create {CE_POINTER [INTEGER_32]}.make_shared ($l_head___0))
							if (l_ptr.item).to_integer_32 = 0 then
								l_incr := 1
								js.break
							end
							if not js.loop_jumped and then ((l_posptr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32) then
								if (l_ptr.c_pointer.to_integer_32).to_natural_32 >= (l_posptr.c_pointer.to_integer_32).to_natural_32 then
									js.break
								end
							end
							if not js.loop_jumped then
								l_vcol := l_vcol + l_incr
								if globals_inst.has_mbyte.to_boolean then
									l_tmp___3 := (globals_inst.mb_ptr2len.integer_32_item ([l_ptr]))
								else
									l_tmp___3 := 1
								end
								l_ptr.ce_gets (l_ptr + l_tmp___3)
							end
						end
						js.reset
				when 7 then -- if done
						if (a_start___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							a_start___1.item := l_vcol + l_head___0
						end
						if (a_end.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							a_end.item := (l_vcol + l_incr) - 1
						end
						if (a_cursor.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (l_ptr.item).to_integer_32 = 9 then
								if ((globals_inst.State).bit_and (1)).to_boolean then
									if not (a_wp___0.item.w_onebuf_opt.wo_list).to_boolean then
										if (misc2_inst.virtual_active).to_boolean then
											a_cursor.item := l_vcol + l_head___0
										elseif globals_inst.VIsual_active.to_boolean then
											if (option_inst.p_sel.item).to_integer_32 = 101 then
												a_cursor.item := l_vcol + l_head___0
											else
												if a_pos___3.item.lnum /= globals_inst.VIsual.lnum then
													l_tmp___6 := (a_pos___3.item.lnum < globals_inst.VIsual.lnum).to_integer
												else
													if a_pos___3.item.col /= globals_inst.VIsual.col then
														l_tmp___5 := (a_pos___3.item.col < globals_inst.VIsual.col).to_integer
													else
														l_tmp___5 := (a_pos___3.item.coladd < globals_inst.VIsual.coladd).to_integer
													end
													l_tmp___6 := l_tmp___5
												end
												if l_tmp___6.to_boolean then
													a_cursor.item := l_vcol + l_head___0
												elseif a_pos___3.item.lnum = globals_inst.VIsual.lnum then
													if a_pos___3.item.col = globals_inst.VIsual.col then
														if a_pos___3.item.coladd = globals_inst.VIsual.coladd then
															a_cursor.item := l_vcol + l_head___0
														else
															a_cursor.item := (l_vcol + l_incr) - 1
														end
													else
														a_cursor.item := (l_vcol + l_incr) - 1
													end
												else
													a_cursor.item := (l_vcol + l_incr) - 1
												end
											end
										else
											a_cursor.item := (l_vcol + l_incr) - 1
										end
									else
										a_cursor.item := l_vcol + l_head___0
									end
								else
									a_cursor.item := l_vcol + l_head___0
								end
							else
								a_cursor.item := l_vcol + l_head___0
							end
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	getvcol_nolist (a_posp: CE_POINTER [PD_POS_T]): INTEGER_32
		local
			l_list_save: INTEGER_32
			l_vcol: INTEGER_32
		do
			l_list_save := globals_inst.curwin.item.w_onebuf_opt.wo_list
			globals_inst.curwin.item.w_onebuf_opt.wo_list := 0
			getvcol (globals_inst.curwin, a_posp, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_vcol), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
			globals_inst.curwin.item.w_onebuf_opt.wo_list := l_list_save
			Result := l_vcol
		end

	getvvcol (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_pos___3: CE_POINTER [PD_POS_T]; a_start___1: CE_POINTER [INTEGER_32]; a_cursor: CE_POINTER [INTEGER_32]; a_end: CE_POINTER [INTEGER_32])
		local
			l_col: INTEGER_32
			l_coladd: INTEGER_32
			l_endadd: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
		do
			create l_ptr.make

			if (misc2_inst.virtual_active).to_boolean then
				getvcol (a_wp___0, a_pos___3, create {CE_POINTER [INTEGER_32]}.make_shared ($l_col), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
				l_coladd := a_pos___3.item.coladd
				l_endadd := 0
				l_ptr.ce_gets (memline_inst.ml_get_buf (a_wp___0.item.w_buffer, a_pos___3.item.lnum, 0))
				if a_pos___3.item.col < (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr))).to_integer_32 then
					l_c := (globals_inst.mb_ptr2char.integer_32_item ([l_ptr + a_pos___3.item.col]))
					if l_c /= 9 then
						if (vim_isprintc (l_c)).to_boolean then
							l_endadd := (char2cells (l_c)) - 1
							if l_coladd > l_endadd then
								l_endadd := 0
							else
								l_coladd := 0
							end
						end
					end
				end
				l_col := l_col + l_coladd
				if (a_start___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					a_start___1.item := l_col
				end
				if (a_cursor.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					a_cursor.item := l_col
				end
				if (a_end.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					a_end.item := l_col + l_endadd
				end
			else
				getvcol (a_wp___0, a_pos___3, a_start___1, a_cursor, a_end)
			end
		end

	getvcols (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_pos1: CE_POINTER [PD_POS_T]; a_pos2: CE_POINTER [PD_POS_T]; a_left: CE_POINTER [INTEGER_32]; a_right: CE_POINTER [INTEGER_32])
		local
			l_from1: INTEGER_32
			l_from2: INTEGER_32
			l_to1: INTEGER_32
			l_to2: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			if a_pos1.item.lnum /= a_pos2.item.lnum then
				l_tmp___0 := (a_pos1.item.lnum < a_pos2.item.lnum).to_integer
			else
				if a_pos1.item.col /= a_pos2.item.col then
					l_tmp := (a_pos1.item.col < a_pos2.item.col).to_integer
				else
					l_tmp := (a_pos1.item.coladd < a_pos2.item.coladd).to_integer
				end
				l_tmp___0 := l_tmp
			end
			if l_tmp___0.to_boolean then
				getvvcol (a_wp___0, a_pos1, create {CE_POINTER [INTEGER_32]}.make_shared ($l_from1), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_to1))
				getvvcol (a_wp___0, a_pos2, create {CE_POINTER [INTEGER_32]}.make_shared ($l_from2), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_to2))
			else
				getvvcol (a_wp___0, a_pos2, create {CE_POINTER [INTEGER_32]}.make_shared ($l_from1), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_to1))
				getvvcol (a_wp___0, a_pos1, create {CE_POINTER [INTEGER_32]}.make_shared ($l_from2), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_to2))
			end
			if l_from2 < l_from1 then
				a_left.item := l_from2
			else
				a_left.item := l_from1
			end
			if l_to2 > l_to1 then
				if (option_inst.p_sel.item).to_integer_32 = 101 then
					if l_from2 - 1 >= l_to1 then
						a_right.item := l_from2 - 1
					else
						a_right.item := l_to2
					end
				else
					a_right.item := l_to2
				end
			else
				a_right.item := l_to1
			end
		end

	skipwhite (a_q: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0.ce_gets (a_q)
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_p___0.item).to_integer_32 /= 32 then
					if (l_p___0.item).to_integer_32 /= 9 then
						js.break
					end
				end
				if not js.loop_jumped then
					l_p___0.ce_gets (l_p___0 + 1)
				end
			end
			js.reset
			Result := l_p___0
		end

	skipdigits (a_q: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0.ce_gets (a_q)
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_p___0.item).to_integer_32 >= 48 then
					if not ((l_p___0.item).to_integer_32 <= 57) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_p___0.ce_gets (l_p___0 + 1)
				end
			end
			js.reset
			Result := l_p___0
		end

	skiphex (a_q: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0.ce_gets (a_q)
			from
			until
				js.loop_left
			loop
				js.reset
				if not (vim_isxdigit ((l_p___0.item).to_integer_32)).to_boolean then
					js.break
				end
				if not js.loop_jumped then
					l_p___0.ce_gets (l_p___0 + 1)
				end
			end
			js.reset
			Result := l_p___0
		end

	skiptodigit (a_q: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0.ce_gets (a_q)
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_p___0.item).to_integer_32 /= 0 then
					if (l_p___0.item).to_integer_32 >= 48 then
						if (l_p___0.item).to_integer_32 <= 57 then
							js.break
						end
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_p___0.ce_gets (l_p___0 + 1)
				end
			end
			js.reset
			Result := l_p___0
		end

	skiptohex (a_q: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0.ce_gets (a_q)
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_p___0.item).to_integer_32 /= 0 then
					if (vim_isxdigit ((l_p___0.item).to_integer_32)).to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_p___0.ce_gets (l_p___0 + 1)
				end
			end
			js.reset
			Result := l_p___0
		end

	vim_isdigit (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if a_c >= 48 then
				if a_c <= 57 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	vim_isxdigit (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_c >= 48) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_c <= 57 then
							l_tmp := 1
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else: | _L___0:
						if not (a_c >= 97) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_c <= 102 then
							l_tmp := 1
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if a_c >= 65 then
							if a_c <= 70 then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
				when 7 then -- if done
						Result := l_tmp
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	vim_islower (a_c: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_c <= 64 then
				Result := 0
				js.return
			end
			if not js.return_called and then (a_c >= 128) then
				if globals_inst.enc_utf8.to_boolean then
					Result := (mbyte_inst.utf_islower (a_c))
					js.return
				end
				if not js.return_called and then (a_c >= 256) then
					Result := 0
					js.return
				end
				if not js.return_called and then (globals_inst.enc_latin1like.to_boolean) then
					Result := ((((latin1flags[a_c]).to_integer_32).bit_and (108)) = 108).to_integer
					js.return
				end
			end
			if not js.return_called then
				Result := ((((ctype_b_loc).item[a_c]).to_integer_32).bit_and (512))
			end
		end

	vim_isupper (a_c: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_c <= 64 then
				Result := 0
				js.return
			end
			if not js.return_called and then (a_c >= 128) then
				if globals_inst.enc_utf8.to_boolean then
					Result := (mbyte_inst.utf_isupper (a_c))
					js.return
				end
				if not js.return_called and then (a_c >= 256) then
					if globals_inst.has_mbyte.to_boolean then
						Result := (iswupper (a_c.to_natural_32))
						js.return
					end
					if not js.return_called then
						Result := 0
						js.return
					end
				end
				if not js.return_called and then (globals_inst.enc_latin1like.to_boolean) then
					Result := ((((latin1flags[a_c]).to_integer_32).bit_and (85)) = 85).to_integer
					js.return
				end
			end
			if not js.return_called then
				Result := ((((ctype_b_loc).item[a_c]).to_integer_32).bit_and (256))
			end
		end

	vim_toupper (a_c: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_c <= 64 then
				Result := a_c
				js.return
			end
			if not js.return_called and then (a_c >= 128) then
				if globals_inst.enc_utf8.to_boolean then
					Result := (mbyte_inst.utf_toupper (a_c))
					js.return
				end
				if not js.return_called and then (a_c >= 256) then
					if globals_inst.has_mbyte.to_boolean then
						Result := (towupper (a_c.to_natural_32)).to_integer_32
						js.return
					end
					if not js.return_called then
						Result := a_c
						js.return
					end
				end
				if not js.return_called and then (globals_inst.enc_latin1like.to_boolean) then
					Result := (latin1upper[a_c]).to_integer_32
					js.return
				end
			end
			if not js.return_called then
				Result := (toupper (a_c))
			end
		end

	vim_tolower (a_c: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_c <= 64 then
				Result := a_c
				js.return
			end
			if not js.return_called and then (a_c >= 128) then
				if globals_inst.enc_utf8.to_boolean then
					Result := (mbyte_inst.utf_tolower (a_c))
					js.return
				end
				if not js.return_called and then (a_c >= 256) then
					if globals_inst.has_mbyte.to_boolean then
						Result := (towlower (a_c.to_natural_32)).to_integer_32
						js.return
					end
					if not js.return_called then
						Result := a_c
						js.return
					end
				end
				if not js.return_called and then (globals_inst.enc_latin1like.to_boolean) then
					Result := (latin1lower[a_c]).to_integer_32
					js.return
				end
			end
			if not js.return_called then
				Result := (tolower (a_c))
			end
		end

	skiptowhite (a_p___0: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0.ce_gets (a_p___0)
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_p___0.item).to_integer_32 /= 32 then
					if (l_p___0.item).to_integer_32 /= 9 then
						if (l_p___0.item).to_integer_32 = 0 then
							js.break
						end
					else
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_p___0.ce_gets (l_p___0 + 1)
				end
			end
			js.reset
			Result := l_p___0
		end

	skiptowhite_esc (a_p___0: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (a_p___0)
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if (l_p___0.item).to_integer_32 /= 32 then
							if (l_p___0.item).to_integer_32 /= 9 then
								if (l_p___0.item).to_integer_32 = 0 then
									js.break
								end
							else
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						if (l_p___0.item).to_integer_32 /= 92 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if (l_p___0.item).to_integer_32 /= 22 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						if (l_p___0[1]).to_integer_32 /= 0 then
							l_p___0.ce_gets (l_p___0 + 1)
						end
				when 8 then -- if done
						l_p___0.ce_gets (l_p___0 + 1)
				when 9 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					js.reset
					Result := l_p___0
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	getdigits (a_pp: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
		do
			create l_p___0.make

			l_p___0.ce_gets (a_pp.item)
			l_retval := atol (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))
			if (l_p___0.item).to_integer_32 = 45 then
				l_p___0.ce_gets (l_p___0 + 1)
			end
			l_p___0.ce_gets (skipdigits (l_p___0))
			a_pp.item := l_p___0
			Result := l_retval
		end

	vim_isblankline (a_lbuf: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
		do
			create l_p___0.make

			l_p___0.ce_gets (skipwhite (a_lbuf))
			if (l_p___0.item).to_integer_32 = 0 then
				l_tmp := 1
			elseif (l_p___0.item).to_integer_32 = 13 then
				l_tmp := 1
			elseif (l_p___0.item).to_integer_32 = 10 then
				l_tmp := 1
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	vim_str2nr (a_start___1: CE_POINTER [NATURAL_8]; a_hexp: CE_POINTER [INTEGER_32]; a_len: CE_POINTER [INTEGER_32]; a_dooct: INTEGER_32; a_dohex: INTEGER_32; a_nptr: CE_POINTER [INTEGER_32]; a_unptr: CE_POINTER [NATURAL_32])
		local
			l_ptr: CE_POINTER [NATURAL_8]
			l_hex: INTEGER_32
			l_negative: INTEGER_32
			l_un: NATURAL_32
			l_n: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ptr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ptr.ce_gets (a_start___1)
					l_hex := 0
					l_negative := 0
					l_un := {NATURAL_32} 0
					if (l_ptr[0]).to_integer_32 = 45 then
						l_negative := 1
						l_ptr.ce_gets (l_ptr + 1)
					end
					if (l_ptr[0]).to_integer_32 /= 48 then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						if (l_ptr[1]).to_integer_32 = 56 then
							l_pos := -1 + 13 -- skip if block
						end
				when 2 then -- if:
						if (l_ptr[1]).to_integer_32 = 57 then
							l_pos := -1 + 13 -- skip if block
						end
				when 3 then -- if:
						l_hex := (l_ptr[1]).to_integer_32
						if not (a_dohex.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if l_hex /= 88 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L___1
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if l_hex /= 120 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L___1:
						if (vim_isxdigit ((l_ptr[2]).to_integer_32)).to_boolean then
							l_ptr.ce_gets (l_ptr + (2))
						else
							l_pos := -1 + 12 -- goto _L___0
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_pos := -1 + 12 -- goto _L___0
				when 11 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___0:
						l_hex := 0
						if a_dooct.to_boolean then
							l_n := 1
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_ptr[l_n]).to_integer_32 >= 48 then
									if not ((l_ptr[l_n]).to_integer_32 <= 57) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped and then ((l_ptr[l_n]).to_integer_32 > 55) then
									l_hex := 0
									js.break
								end
								if not js.loop_jumped then
									if (l_ptr[l_n]).to_integer_32 > 48 then
										l_hex := ('0').code
									end
									l_n := l_n + 1
								end
							end
							js.reset
						end
				when 13 then -- if done | if done | if done
						if l_hex /= 48 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
							l_pos := -1 + 17 -- goto _L___3
				when 15 then -- if block done, skip else block:
							l_pos := -1 + 26
				when 16 then -- else:
							if not (a_dooct > 1) then
								l_pos := -1 + 19 -- skip if block
							end
				when 17 then -- if: | _L___3:
							from
							until
								js.loop_left
							loop
								js.reset
								if 48 <= (l_ptr.item).to_integer_32 then
									if not ((l_ptr.item).to_integer_32 <= 55) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_un := {NATURAL_32} 8 * l_un + ((l_ptr.item).to_integer_32 - 48).to_natural_32
									l_ptr.ce_gets (l_ptr + 1)
								end
							end
							js.reset
				when 18 then -- if block done, skip else block:
							l_pos := -1 + 26
				when 19 then -- else:
							if l_hex = 0 then
								l_pos := -1 + 22 -- skip if block
							end
				when 20 then -- if:
							l_pos := -1 + 23 -- goto _L___2
				when 21 then -- if block done, skip else block:
							l_pos := -1 + 26
				when 22 then -- else:
							if not (a_dohex > 1) then
								l_pos := -1 + 25 -- skip if block
							end
				when 23 then -- if: | _L___2:
							from
							until
								js.loop_left
							loop
								js.reset
								if not (vim_isxdigit ((l_ptr.item).to_integer_32)).to_boolean then
									js.break
								end
								if not js.loop_jumped then
									l_un := {NATURAL_32} 16 * l_un + (hex2nr ((l_ptr.item).to_integer_32)).to_natural_32
									l_ptr.ce_gets (l_ptr + 1)
								end
							end
							js.reset
				when 24 then -- if block done, skip else block:
							l_pos := -1 + 26
				when 25 then -- else:
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_ptr.item).to_integer_32 >= 48 then
									if not ((l_ptr.item).to_integer_32 <= 57) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_un := {NATURAL_32} 10 * l_un + ((l_ptr.item).to_integer_32 - 48).to_natural_32
									l_ptr.ce_gets (l_ptr + 1)
								end
							end
							js.reset
				when 26 then -- if done | if done | if done
							if (a_hexp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								a_hexp.item := l_hex
							end
							if (a_len.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								a_len.item := l_ptr.distance (a_start___1)
							end
							if (a_nptr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if l_negative.to_boolean then
									a_nptr.item := -l_un.to_integer_32
								else
									a_nptr.item := l_un.to_integer_32
								end
							end
							if (a_unptr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								a_unptr.item := l_un
							end
				when 27 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	hex2nr (a_c: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_c >= 97 then
				if a_c <= 102 then
					Result := ((a_c - 97) + 10)
					js.return
				end
			end
			if not js.return_called and then (a_c >= 65) then
				if a_c <= 70 then
					Result := ((a_c - 65) + 10)
					js.return
				end
			end
			if not js.return_called then
				Result := (a_c - 48)
			end
		end

	hexhex2nr (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			if (vim_isxdigit ((a_p___0[0]).to_integer_32)).to_boolean then
				if not (vim_isxdigit ((a_p___0[1]).to_integer_32)).to_boolean then
					Result := (-1)
					js.return
				end
			else
				Result := (-1)
				js.return
			end
			if not js.return_called then
				l_tmp___1 := hex2nr ((a_p___0[0]).to_integer_32)
				Result := (((l_tmp___1).bit_shift_left (4)) + (hex2nr ((a_p___0[1]).to_integer_32)))
			end
		end

	rem_backslash (a_str___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if (a_str___1[0]).to_integer_32 = 92 then
				if (a_str___1[1]).to_integer_32 /= 0 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	backslash_halve (a_p___0: CE_POINTER [NATURAL_8])
		local
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make

			l_p___0.ce_gets (a_p___0)
			from
			until
				not ((l_p___0.item).to_boolean)
			loop
				if (rem_backslash (l_p___0)).to_boolean then
					memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 1)))) + {NATURAL_32} 1).do_nothing
				end
				l_p___0.ce_gets (l_p___0 + 1)
			end
		end

	backslash_halve_save (a_p___0: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_res: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_res.make

			l_res.ce_gets (misc2_inst.vim_strsave (a_p___0))
			if (l_res.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := a_p___0
				js.return
			end
			if not js.return_called then
				backslash_halve (l_res)
				Result := l_res
			end
		end

end
