class
	P_DIGRAPH

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create user_digraphs.make
			create digraphdefault.make (<<1355>>)
		end

feature {ANY} -- attributes

	user_digraphs: PD_GROWARRAY

	digraphdefault: CE_ARRAY [PD_DIGRAPH]

	backspaced: INTEGER_32 assign set_backspaced

	set_backspaced (a_backspaced: INTEGER_32)
		do
			backspaced := a_backspaced
		end

	lastchar: INTEGER_32 assign set_lastchar

	set_lastchar (a_lastchar: INTEGER_32)
		do
			lastchar := a_lastchar
		end

feature {ANY} -- routines

	do_digraph (a_c: INTEGER_32): INTEGER_32
		local
			l_c: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := a_c
					if l_c /= -1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						backspaced := -1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 3 then -- else:
						if not (option_inst.p_dg.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if backspaced >= 0 then
							l_c := getdigraph (backspaced, l_c, 0)
						end
						backspaced := -1
						if l_c /= -(107 + ((98).bit_shift_left (8))) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if l_c /= 8 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if lastchar >= 0 then
							backspaced := lastchar
						end
				when 9 then -- if done | if done | if done
						lastchar := l_c
						Result := l_c
				when 10 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	get_digraph (a_cmdline: INTEGER_32): INTEGER_32
		local
			l_c: INTEGER_32
			l_cc___0: INTEGER_32
			js: JUMP_STATE
		do
			globals_inst.no_mapping := globals_inst.no_mapping + 1
			globals_inst.allow_keys := globals_inst.allow_keys + 1
			l_c := getchar_inst.plain_vgetc
			globals_inst.no_mapping := globals_inst.no_mapping - 1
			globals_inst.allow_keys := globals_inst.allow_keys - 1
			if l_c /= 27 then
				if l_c < 0 then
					Result := l_c
					js.return
				end
				if not js.return_called then
					if a_cmdline.to_boolean then
						if (charset_inst.char2cells (l_c)) = 1 then
							if globals_inst.cmdline_star = 0 then
								ex_getln_inst.putcmdline (l_c, 1)
							end
						end
					else
						normal_inst.add_to_showcmd (l_c).do_nothing
					end
					globals_inst.no_mapping := globals_inst.no_mapping + 1
					globals_inst.allow_keys := globals_inst.allow_keys + 1
					l_cc___0 := getchar_inst.plain_vgetc
					globals_inst.no_mapping := globals_inst.no_mapping - 1
					globals_inst.allow_keys := globals_inst.allow_keys - 1
					if l_cc___0 /= 27 then
						Result := (getdigraph (l_c, l_cc___0, 1))
						js.return
					end
				end
			end
			if not js.return_called then
				Result := (('%/0/').code)
			end
		end

	getexactdigraph (a_char1: INTEGER_32; a_char2: INTEGER_32; a_meta: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_retval: INTEGER_32
			l_dp: CE_POINTER [PD_DIGRAPH]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_to: CE_POINTER [NATURAL_8]
			l_vc: PD_VIMCONV_T
			js: JUMP_STATE
		do
			create l_dp.make
			create l_buf___6.make (<<6>>)
			create l_to.make
			create l_vc.make

			l_retval := 0
			if a_char1 < 0 then
				Result := a_char2
				js.return
			elseif a_char2 < 0 then
				Result := a_char2
				js.return
			end
			if not js.return_called then
				l_dp.ce_gets (create {CE_POINTER [PD_DIGRAPH]}.make_cast (user_digraphs.ga_data))
				l_i___0 := 0
				from
				until
					not (not js.loop_left and then (l_i___0 < user_digraphs.ga_len))
				loop
					js.reset
					if (l_dp.item.char1).to_integer_32 = a_char1 then
						if (l_dp.item.char2).to_integer_32 = a_char2 then
							l_retval := l_dp.item.result2
							js.break
						end
					end
					if not js.loop_jumped then
						l_dp.ce_gets (l_dp + 1)
						l_i___0 := l_i___0 + 1
					end
				end
				js.reset
				if l_retval = 0 then
					l_dp.ce_gets (digraphdefault)
					l_i___0 := 0
					from
					until
						not (not js.loop_left and then ((l_dp.item.char1).to_integer_32 /= 0))
					loop
						js.reset
						if (l_dp.item.char1).to_integer_32 = a_char1 then
							if (l_dp.item.char2).to_integer_32 = a_char2 then
								l_retval := l_dp.item.result2
								js.break
							end
						end
						if not js.loop_jumped then
							l_dp.ce_gets (l_dp + 1)
							l_i___0 := l_i___0 + 1
						end
					end
					js.reset
				end
				if l_retval /= 0 then
					if not globals_inst.enc_utf8.to_boolean then
						l_i___0 := mbyte_inst.utf_char2bytes (l_retval, l_buf___6)
						l_retval := 0
						l_vc.vc_type := 0
						if (mbyte_inst.convert_setup (l_vc.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("utf-8")), option_inst.p_enc)) = 1 then
							l_vc.vc_fail := 1
							l_to.ce_gets (mbyte_inst.string_convert (l_vc.address, l_buf___6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_i___0)))
							if (l_to.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_retval := globals_inst.mb_ptr2char.integer_32_item ([l_to])
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_to))
							end
							mbyte_inst.convert_setup (l_vc.address, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
						end
					end
				end
				if not globals_inst.has_mbyte.to_boolean then
					if l_retval > 255 then
						l_retval := 0
					end
				end
				if l_retval = 0 then
					if a_char1 = 32 then
						if a_meta.to_boolean then
							Result := ((a_char2).bit_or (128))
							js.return
						end
					end
					if not js.return_called then
						Result := a_char2
						js.return
					end
				end
			end
			if not js.return_called then
				Result := l_retval
			end
		end

	getdigraph (a_char1: INTEGER_32; a_char2: INTEGER_32; a_meta: INTEGER_32): INTEGER_32
		local
			l_retval: INTEGER_32
			js: JUMP_STATE
		do
			l_retval := getexactdigraph (a_char1, a_char2, a_meta)
			if l_retval = a_char2 then
				if a_char1 /= a_char2 then
					l_retval := getexactdigraph (a_char2, a_char1, a_meta)
					if l_retval = a_char1 then
						Result := a_char2
						js.return
					end
				end
			end
			if not js.return_called then
				Result := l_retval
			end
		end

	putdigraph (a_str___1: CE_POINTER [NATURAL_8])
		local
			l_str___1: CE_POINTER [NATURAL_8]
			l_char1: INTEGER_32
			l_char2: INTEGER_32
			l_n: INTEGER_32
			l_i___0: INTEGER_32
			l_dp: CE_POINTER [PD_DIGRAPH]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_str___1.make
			create l_dp.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___2.make
			create l_tmp___3.make

			l_str___1.ce_gets (a_str___1)
			from
			until
				not (not js.loop_left and then ((l_str___1.item).to_integer_32 /= 0))
			loop
				l_str___1.ce_gets (charset_inst.skipwhite (l_str___1))
				if (l_str___1.item).to_integer_32 = 0 then
					js.return
				end
				if not js.return_called then
					l_tmp.ce_gets (l_str___1)
					l_str___1.ce_gets (l_str___1 + 1)
					l_char1 := (l_tmp.item).to_integer_32
					l_tmp___0.ce_gets (l_str___1)
					l_str___1.ce_gets (l_str___1 + 1)
					l_char2 := (l_tmp___0.item).to_integer_32
					if l_char2 = 0 then
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg))))).do_nothing
						js.return
					end
				end
				if not js.return_called then
					if l_char1 = 27 then
						l_tmp___2.ce_gets (gettext (ce_string ("E104: Escape not allowed in digraph")))
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___2)).do_nothing
						js.return
					elseif l_char2 = 27 then
						l_tmp___2.ce_gets (gettext (ce_string ("E104: Escape not allowed in digraph")))
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___2)).do_nothing
						js.return
					end
				end
				if not js.return_called then
					l_str___1.ce_gets (charset_inst.skipwhite (l_str___1))
					if (l_str___1.item).to_integer_32 >= 48 then
						if not ((l_str___1.item).to_integer_32 <= 57) then
							l_tmp___3.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_number_exp)))
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___3)).do_nothing
							js.return
						end
					else
						l_tmp___3.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_number_exp)))
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___3)).do_nothing
						js.return
					end
				end
				if not js.return_called then
					l_n := (charset_inst.getdigits (l_str___1.address)).to_integer_32
					l_dp.ce_gets (create {CE_POINTER [PD_DIGRAPH]}.make_cast (user_digraphs.ga_data))
					l_i___0 := 0
					from
					until
						not (not js.loop_left and then (l_i___0 < user_digraphs.ga_len))
					loop
						js.reset
						if (l_dp.item.char1).to_integer_32 = l_char1 then
							if (l_dp.item.char2).to_integer_32 = l_char2 then
								l_dp.item.result2 := l_n
								js.break
							end
						end
						if not js.loop_jumped then
							l_dp.ce_gets (l_dp + 1)
							l_i___0 := l_i___0 + 1
						end
					end
					js.reset
					if l_i___0 = user_digraphs.ga_len then
						if (misc2_inst.ga_grow (user_digraphs.address, 1)) = 1 then
							l_dp.ce_gets (create {CE_POINTER [PD_DIGRAPH]}.make_cast (user_digraphs.ga_data) + user_digraphs.ga_len)
							l_dp.item.char1 := l_char1.to_natural_8
							l_dp.item.char2 := l_char2.to_natural_8
							l_dp.item.result2 := l_n
							user_digraphs.ga_len := (user_digraphs.ga_len) + 1
						end
					end
				end
			end
			if not js.return_called then
			end
		end

	listdigraphs
		local
			l_i___0: INTEGER_32
			l_dp: CE_POINTER [PD_DIGRAPH]
			l_tmp: PD_DIGRAPH
			js: JUMP_STATE
		do
			create l_dp.make
			create l_tmp.make

			message_inst.msg_putchar (('%N').code)
			l_dp.ce_gets (digraphdefault)
			l_i___0 := 0
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_dp.item.char1).to_integer_32 /= 0 then
					if globals_inst.got_int.to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_tmp.char1 := l_dp.item.char1
					l_tmp.char2 := l_dp.item.char2
					l_tmp.result2 := getexactdigraph ((l_tmp.char1).to_integer_32, (l_tmp.char2).to_integer_32, 0)
					if l_tmp.result2 /= 0 then
						if l_tmp.result2 /= (l_tmp.char2).to_integer_32 then
							if globals_inst.has_mbyte.to_boolean then
								printdigraph (l_tmp.address)
							elseif l_tmp.result2 <= 255 then
								printdigraph (l_tmp.address)
							end
						end
					end
					l_dp.ce_gets (l_dp + 1)
					ui_inst.ui_breakcheck
					l_i___0 := l_i___0 + 1
				end
			end
			js.reset
			l_dp.ce_gets (create {CE_POINTER [PD_DIGRAPH]}.make_cast (user_digraphs.ga_data))
			l_i___0 := 0
			from
			until
				js.loop_left
			loop
				js.reset
				if l_i___0 < user_digraphs.ga_len then
					if globals_inst.got_int.to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					printdigraph (l_dp)
					ui_inst.ui_breakcheck
					l_dp.ce_gets (l_dp + 1)
					l_i___0 := l_i___0 + 1
				end
			end
			js.reset
			globals_inst.must_redraw := 50
		end

	printdigraph (a_dp: CE_POINTER [PD_DIGRAPH])
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_list_width: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
		do
			create l_buf___6.make (<<30>>)
			create l_p___0.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___5.make
			create l_tmp___6.make

			if ((option_inst.dy_flags).bit_and ({NATURAL_32} 2)).to_boolean then
				l_list_width := 13
			elseif globals_inst.has_mbyte.to_boolean then
				l_list_width := 13
			else
				l_list_width := 11
			end
			if a_dp.item.result2 /= 0 then
				if globals_inst.msg_col.to_integer_32 > globals_inst.Columns - l_list_width.to_integer_32 then
					message_inst.msg_putchar (('%N').code)
				end
				if globals_inst.msg_col.to_boolean then
					from
					until
						globals_inst.msg_col \\ l_list_width = 0
					loop
						message_inst.msg_putchar ((' ').code)
					end
				end
				l_p___0.ce_gets (l_buf___6)
				l_tmp.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp.item := a_dp.item.char1
				l_tmp___0.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___0.item := a_dp.item.char2
				l_tmp___1.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___1.item := ((' ').code).to_natural_8
				if globals_inst.has_mbyte.to_boolean then
					if globals_inst.enc_utf8.to_boolean then
						if (mbyte_inst.utf_iscomposing (a_dp.item.result2)).to_boolean then
							l_tmp___2.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___2.item := ((' ').code).to_natural_8
						end
					end
					l_p___0.ce_gets (l_p___0 + (globals_inst.mb_char2bytes.integer_32_item ([a_dp.item.result2, l_p___0])))
				else
					l_tmp___5.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___5.item := (a_dp.item.result2).to_natural_8
				end
				if (charset_inst.char2cells (a_dp.item.result2)) = 1 then
					l_tmp___6.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___6.item := ((' ').code).to_natural_8
				end
				message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), (Natural_8_bytes.to_natural_32 * (30).to_natural_32) - (l_p___0.distance (l_buf___6)).to_natural_32, ce_string (" %%3d"), a_dp.item.result2]).do_nothing
				message_inst.msg_outtrans (l_buf___6).do_nothing
			end
		end

end
