class
	P_EX_CMDS2

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create script_items.make
			create debug_breakpoint_name.make
			create debug_skipped_name.make
			create dbg_breakp.make
			create buf.make (<<50>>)
		end

feature {ANY} -- attributes

	script_items: PD_GROWARRAY

	debug_greedy: INTEGER_32 assign set_debug_greedy

	set_debug_greedy (a_debug_greedy: INTEGER_32)
		do
			debug_greedy := a_debug_greedy
		end

	last_cmd: INTEGER_32 assign set_last_cmd

	set_last_cmd (a_last_cmd: INTEGER_32)
		do
			last_cmd := a_last_cmd
		end

	debug_breakpoint_name: CE_POINTER [NATURAL_8]

	debug_breakpoint_lnum: INTEGER_32 assign set_debug_breakpoint_lnum

	set_debug_breakpoint_lnum (a_debug_breakpoint_lnum: INTEGER_32)
		do
			debug_breakpoint_lnum := a_debug_breakpoint_lnum
		end

	debug_skipped: INTEGER_32 assign set_debug_skipped

	set_debug_skipped (a_debug_skipped: INTEGER_32)
		do
			debug_skipped := a_debug_skipped
		end

	debug_skipped_name: CE_POINTER [NATURAL_8]

	dbg_breakp: PD_GROWARRAY

	last_breakp: INTEGER_32 assign set_last_breakp

	set_last_breakp (a_last_breakp: INTEGER_32)
		do
			last_breakp := a_last_breakp
		end

	buf: CE_ARRAY [INTEGER_8]

	last_current_SID: INTEGER_32 assign set_last_current_SID

	set_last_current_SID (a_last_current_SID: INTEGER_32)
		do
			last_current_SID := a_last_current_SID
		end

	nl_msg_cat_cntr: INTEGER_32 assign set_nl_msg_cat_cntr
		external
			"C inline use <vim.h>"
		alias
			"return _nl_msg_cat_cntr;"
		end

	set_nl_msg_cat_cntr (a_nl_msg_cat_cntr: INTEGER_32)
		external
			"C inline"
		alias
			"_nl_msg_cat_cntr = $a_nl_msg_cat_cntr;"
		end

feature {ANY} -- routines

	do_debug (a_cmd: CE_POINTER [NATURAL_8])
		local
			l_save_msg_scroll: INTEGER_32
			l_save_State: INTEGER_32
			l_save_did_emsg: INTEGER_32
			l_save_cmd_silent: INTEGER_32
			l_save_msg_silent: INTEGER_32
			l_save_emsg_silent: INTEGER_32
			l_save_redir_off: INTEGER_32
			l_typeaheadbuf: PD_TASAVE_T
			l_typeahead_saved: INTEGER_32
			l_save_ignore_script: INTEGER_32
			l_save_ex_normal_busy: INTEGER_32
			l_n: INTEGER_32
			l_cmdline: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tail: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_typeaheadbuf.make
			create l_cmdline.make
			create l_p___0.make
			create l_tail.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_save_msg_scroll := globals_inst.msg_scroll
					l_save_State := globals_inst.State
					l_save_did_emsg := globals_inst.did_emsg
					l_save_cmd_silent := globals_inst.cmd_silent
					l_save_msg_silent := globals_inst.msg_silent
					l_save_emsg_silent := globals_inst.emsg_silent
					l_save_redir_off := globals_inst.redir_off
					l_typeahead_saved := 0
					l_save_ignore_script := 0
					l_cmdline.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_tail.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					term_inst.settmode (2)
					term_inst.starttermcap
					globals_inst.RedrawingDisabled := globals_inst.RedrawingDisabled + 1
					globals_inst.no_wait_return := globals_inst.no_wait_return + 1
					globals_inst.did_emsg := 0
					globals_inst.cmd_silent := 0
					globals_inst.msg_silent := 0
					globals_inst.emsg_silent := 0
					globals_inst.redir_off := 1
					globals_inst.State := 1
					if not globals_inst.debug_did_msg.to_boolean then
						message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Entering Debug mode.  Type %"cont%" to continue."))))).do_nothing
					end
					if (globals_inst.sourcing_name.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						message_inst.msg (globals_inst.sourcing_name).do_nothing
					end
					if globals_inst.sourcing_lnum /= 0 then
						message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("line %%ld: %%s")))), globals_inst.sourcing_lnum, a_cmd]).do_nothing
					else
						message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("cmd: %%s")))), a_cmd]).do_nothing
					end
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 24 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						globals_inst.msg_scroll := 1
						globals_inst.need_wait_return := 0
						l_save_ex_normal_busy := globals_inst.ex_normal_busy
						globals_inst.ex_normal_busy := 0
						if not debug_greedy.to_boolean then
							getchar_inst.save_typeahead (l_typeaheadbuf.address)
							l_typeahead_saved := 1
							l_save_ignore_script := globals_inst.ignore_script
							globals_inst.ignore_script := 1
						end
						l_cmdline.ce_gets (ex_getln_inst.getcmdline_prompt (('>').code, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, 0, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)))
						if l_typeahead_saved.to_boolean then
							getchar_inst.restore_typeahead (l_typeaheadbuf.address)
							globals_inst.ignore_script := l_save_ignore_script
						end
						globals_inst.ex_normal_busy := l_save_ex_normal_busy
						globals_inst.cmdline_row := globals_inst.msg_row
						if (l_cmdline.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 23 -- skip if block
						end
				when 3 then -- if:
						l_p___0.ce_gets (charset_inst.skipwhite (l_cmdline))
						if (l_p___0.item).to_integer_32 = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 4 then -- if:
						inspect (l_p___0.item).to_integer_32 -- switch 1 head
						when 99 then l_pos := -1 + 5
						when 110 then l_pos := -1 + 6
						when 115 then l_pos := -1 + 7
						when 102 then l_pos := -1 + 8
						when 113 then l_pos := -1 + 9
						when 105 then l_pos := -1 + 10
						else l_pos := -1 + 11
						end
				when 5 then -- switch 1, case 99
						last_cmd := 1
						l_tail.ce_gets (ce_string ("ont"))
						l_pos := -1 + 12 -- switch 1; break
				when 6 then -- switch 1, case 110
						last_cmd := 2
						l_tail.ce_gets (ce_string ("ext"))
						l_pos := -1 + 12 -- switch 1; break
				when 7 then -- switch 1, case 115
						last_cmd := 3
						l_tail.ce_gets (ce_string ("tep"))
						l_pos := -1 + 12 -- switch 1; break
				when 8 then -- switch 1, case 102
						last_cmd := 4
						l_tail.ce_gets (ce_string ("inish"))
						l_pos := -1 + 12 -- switch 1; break
				when 9 then -- switch 1, case 113
						last_cmd := 5
						l_tail.ce_gets (ce_string ("uit"))
						l_pos := -1 + 12 -- switch 1; break
				when 10 then -- switch 1, case 105
						last_cmd := 6
						l_tail.ce_gets (ce_string ("nterrupt"))
						l_pos := -1 + 12 -- switch 1; break
				when 11 then -- switch 1, default:
						last_cmd := 0
				when 12 then -- switch 1, done:
						if last_cmd /= 0 then
							l_p___0.ce_gets (l_p___0 + 1)
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_p___0.item).to_integer_32 /= 0 then
									if (l_p___0.item).to_integer_32 /= (l_tail[0]).to_integer_32 then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_p___0.ce_gets (l_p___0 + 1)
									l_tail.ce_gets (l_tail + 1)
								end
							end
							js.reset
							if (l_p___0.item).to_integer_32 < 127 then
								if ((((ctype_b_loc).item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (1024)).to_boolean then
									last_cmd := 0
								end
							end
						end
				when 13 then -- if done
						if last_cmd = 0 then
							l_pos := -1 + 22 -- skip if block
						end
				when 14 then -- if:
						inspect last_cmd -- switch 2 head
						when 1 then l_pos := -1 + 15
						when 2 then l_pos := -1 + 16
						when 3 then l_pos := -1 + 17
						when 4 then l_pos := -1 + 18
						when 5 then l_pos := -1 + 19
						when 6 then l_pos := -1 + 20
						else l_pos := -1 + 21
						end
				when 15 then -- switch 2, case 1
						globals_inst.debug_break_level := -1
						l_pos := -1 + 21 -- switch 2; break
				when 16 then -- switch 2, case 2
						globals_inst.debug_break_level := globals_inst.ex_nesting_level
						l_pos := -1 + 21 -- switch 2; break
				when 17 then -- switch 2, case 3
						globals_inst.debug_break_level := 9999
						l_pos := -1 + 21 -- switch 2; break
				when 18 then -- switch 2, case 4
						globals_inst.debug_break_level := globals_inst.ex_nesting_level - 1
						l_pos := -1 + 21 -- switch 2; break
				when 19 then -- switch 2, case 5
						globals_inst.got_int := 1
						globals_inst.debug_break_level := -1
						l_pos := -1 + 21 -- switch 2; break
				when 20 then -- switch 2, case 6
						globals_inst.got_int := 1
						globals_inst.debug_break_level := 9999
						last_cmd := 3
						l_pos := -1 + 21 -- switch 2; break
				when 21 then -- switch 2, done:
						js.break
				when 22 then -- if done
						if not js.loop_jumped then
							l_n := globals_inst.debug_break_level
							globals_inst.debug_break_level := -1
							ex_docmd_inst.do_cmdline (l_cmdline, ex_getln_inst.getexline_address, create {CE_POINTER [ANY]}.make_shared (default_pointer), 17).do_nothing
							globals_inst.debug_break_level := l_n
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cmdline))
						end
				when 23 then -- if done
						if not js.loop_jumped then
							globals_inst.lines_left := (globals_inst.Rows - 1).to_integer_32
						end
						l_pos := -1 + 1 -- back to loop condition
				when 24 then -- loop done
					js.reset
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cmdline))
					globals_inst.RedrawingDisabled := globals_inst.RedrawingDisabled - 1
					globals_inst.no_wait_return := globals_inst.no_wait_return - 1
					screen_inst.redraw_all_later (40)
					globals_inst.need_wait_return := 0
					globals_inst.msg_scroll := l_save_msg_scroll
					globals_inst.lines_left := (globals_inst.Rows - 1).to_integer_32
					globals_inst.State := l_save_State
					globals_inst.did_emsg := l_save_did_emsg
					globals_inst.cmd_silent := l_save_cmd_silent
					globals_inst.msg_silent := l_save_msg_silent
					globals_inst.emsg_silent := l_save_emsg_silent
					globals_inst.redir_off := l_save_redir_off
					globals_inst.debug_did_msg := 1
				when 25 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_debug (a_eap: CE_POINTER [PD_EXARG])
		local
			l_debug_break_level_save: INTEGER_32
		do
			l_debug_break_level_save := globals_inst.debug_break_level
			globals_inst.debug_break_level := 9999
			ex_docmd_inst.do_cmdline_cmd (a_eap.item.arg).do_nothing
			globals_inst.debug_break_level := l_debug_break_level_save
		end

	ex_debug_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_debug)
		end

	dbg_check_breakpoint (a_eap: CE_POINTER [PD_EXARG])
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
		do
			create l_p___0.make

			debug_skipped := 0
			if (debug_breakpoint_name.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if not (a_eap.item.skip).to_boolean then
					if (debug_breakpoint_name[0]).to_integer_32 = 128 then
						if (debug_breakpoint_name[1]).to_integer_32 = 253 then
							if (debug_breakpoint_name[2]).to_integer_32 = 82 then
								l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<SNR>")))
							else
								l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
							end
						else
							l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
						end
					else
						l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
					end
					if (l_p___0.item).to_integer_32 = 0 then
						l_tmp := 0
					else
						l_tmp := 3
					end
					message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Breakpoint in %"%%s%%s%" line %%ld")))), l_p___0, debug_breakpoint_name + l_tmp, debug_breakpoint_lnum]).do_nothing
					debug_breakpoint_name.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					do_debug (a_eap.item.cmd)
				else
					debug_skipped := 1
					debug_skipped_name.ce_gets (debug_breakpoint_name)
					debug_breakpoint_name.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				end
			elseif globals_inst.ex_nesting_level <= globals_inst.debug_break_level then
				if not (a_eap.item.skip).to_boolean then
					do_debug (a_eap.item.cmd)
				else
					debug_skipped := 1
					debug_skipped_name.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				end
			end
		end

	dbg_check_skipped (a_eap: CE_POINTER [PD_EXARG]): INTEGER_32
		local
			l_prev_got_int: INTEGER_32
			js: JUMP_STATE
		do
			if debug_skipped.to_boolean then
				l_prev_got_int := globals_inst.got_int
				globals_inst.got_int := 0
				debug_breakpoint_name.ce_gets (debug_skipped_name)
				a_eap.item.skip := 0
				dbg_check_breakpoint (a_eap)
				a_eap.item.skip := 1
				globals_inst.got_int := (globals_inst.got_int).bit_or (l_prev_got_int)
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	dbg_parsearg (a_arg: CE_POINTER [NATURAL_8]; a_gap: CE_POINTER [PD_GROWARRAY]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_q: CE_POINTER [NATURAL_8]
			l_bp___0: CE_POINTER [PD_DEBUGGY]
			l_here: INTEGER_32
			l_tmp___5: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_q.make
			create l_bp___0.make
			create l_tmp___5.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (a_arg)
					l_here := 0
					if (misc2_inst.ga_grow (a_gap, 1)) = 0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_bp___0.ce_gets (create {CE_POINTER [PD_DEBUGGY]}.make_cast (a_gap.item.ga_data) + a_gap.item.ga_len)
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("func"), (4).to_natural_32)) = 0 then
							l_bp___0.item.dbg_type := 1
						elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("file"), (4).to_natural_32)) = 0 then
							l_bp___0.item.dbg_type := 2
						elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("here"), (4).to_natural_32)) = 0 then
							if ((globals_inst.curbuf.item.b_ffname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_noname))))).do_nothing
								Result := 0
								js.return
							end
							if not js.return_called then
								l_bp___0.item.dbg_type := 2
								l_here := 1
							end
						else
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg2)))), l_p___0).do_nothing
							Result := 0
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						l_p___0.ce_gets (charset_inst.skipwhite (l_p___0 + 4))
						if l_here.to_boolean then
							l_bp___0.item.dbg_lnum := globals_inst.curwin.item.w_cursor.lnum
						elseif (l_p___0.item).to_integer_32 >= 48 then
							if (l_p___0.item).to_integer_32 <= 57 then
								l_bp___0.item.dbg_lnum := charset_inst.getdigits (l_p___0.address)
								l_p___0.ce_gets (charset_inst.skipwhite (l_p___0))
							else
								l_bp___0.item.dbg_lnum := (0).to_integer_32
							end
						else
							l_bp___0.item.dbg_lnum := (0).to_integer_32
						end
						if l_here.to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (l_p___0.item).to_integer_32 = 0 then
							l_tmp___5.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg2)))
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___5), a_arg).do_nothing
							Result := 0
							js.return
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if not (l_here.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (l_p___0.item).to_integer_32 /= 0 then
							l_tmp___5.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg2)))
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___5), a_arg).do_nothing
							Result := 0
							js.return
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if l_bp___0.item.dbg_type = 1 then
							if ((strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("()"))).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_tmp___5.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg2)))
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___5), a_arg).do_nothing
								Result := 0
								js.return
							end
						end
				when 8 then -- if done | if done
						if not js.return_called then
							if l_bp___0.item.dbg_type = 1 then
								l_bp___0.item.dbg_name := misc2_inst.vim_strsave (l_p___0)
							elseif l_here.to_boolean then
								l_bp___0.item.dbg_name := misc2_inst.vim_strsave (globals_inst.curbuf.item.b_ffname)
							else
								l_q.ce_gets (misc1_inst.expand_env_save (l_p___0))
								if (l_q.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									Result := 0
									js.return
								end
								if not js.return_called then
									l_p___0.ce_gets (misc1_inst.expand_env_save (l_q))
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_q))
									if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										Result := 0
										js.return
									end
								end
								if not js.return_called then
									if (l_p___0.item).to_integer_32 /= 42 then
										l_bp___0.item.dbg_name := buffer_inst.fix_fname (l_p___0)
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
									else
										l_bp___0.item.dbg_name := l_p___0
									end
								end
							end
						end
						if not js.return_called and then (((l_bp___0.item.dbg_name).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32) then
							Result := 0
							js.return
						end
						if not js.return_called then
							Result := 1
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_breakadd (a_eap: CE_POINTER [PD_EXARG])
		local
			l_bp___0: CE_POINTER [PD_DEBUGGY]
			l_pat: CE_POINTER [NATURAL_8]
			l_gap: CE_POINTER [PD_GROWARRAY]
		do
			create l_bp___0.make
			create l_pat.make
			create l_gap.make

			l_gap.ce_gets (dbg_breakp.address)
			if (dbg_parsearg (a_eap.item.arg, l_gap)) = 1 then
				l_bp___0.ce_gets (create {CE_POINTER [PD_DEBUGGY]}.make_cast (l_gap.item.ga_data) + l_gap.item.ga_len)
				l_bp___0.item.dbg_forceit := a_eap.item.forceit
				l_pat.ce_gets (fileio_inst.file_pat_to_reg_pat (l_bp___0.item.dbg_name, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), 0))
				if (l_pat.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					l_bp___0.item.dbg_prog := regexp_inst.vim_regcomp (l_pat, 3)
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pat))
				end
				if (l_pat.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_bp___0.item.dbg_name))
				elseif ((l_bp___0.item.dbg_prog).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_bp___0.item.dbg_name))
				else
					if l_bp___0.item.dbg_lnum = 0 then
						l_bp___0.item.dbg_lnum := (1).to_integer_32
					end
					last_breakp := last_breakp + 1;
					(create {CE_POINTER [PD_DEBUGGY]}.make_cast (l_gap.item.ga_data) + l_gap.item.ga_len).item.dbg_nr := last_breakp
					globals_inst.debug_tick := globals_inst.debug_tick + 1
					l_gap.item.ga_len := (l_gap.item.ga_len) + 1
				end
			end
		end

	ex_breakadd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_breakadd)
		end

	ex_debuggreedy (a_eap: CE_POINTER [PD_EXARG])
		do
			if a_eap.item.addr_count = 0 then
				debug_greedy := 1
			elseif a_eap.item.line2 /= 0 then
				debug_greedy := 1
			else
				debug_greedy := 0
			end
		end

	ex_debuggreedy_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_debuggreedy)
		end

	ex_breakdel (a_eap: CE_POINTER [PD_EXARG])
		local
			l_bp___0: CE_POINTER [PD_DEBUGGY]
			l_bpi: CE_POINTER [PD_DEBUGGY]
			l_nr: INTEGER_32
			l_todel: INTEGER_32
			l_del_all: INTEGER_32
			l_i___0: INTEGER_32
			l_best_lnum: INTEGER_32
			l_gap: CE_POINTER [PD_GROWARRAY]
			js: JUMP_STATE
		do
			create l_bp___0.make
			create l_bpi.make
			create l_gap.make

			l_todel := -1
			l_del_all := 0
			l_best_lnum := (0).to_integer_32
			l_gap.ce_gets (dbg_breakp.address)
			if (charset_inst.vim_isdigit (((a_eap.item.arg).item).to_integer_32)).to_boolean then
				l_nr := (atol (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg))).to_integer_32
				l_i___0 := 0
				from
				until
					not (not js.loop_left and then (l_i___0 < l_gap.item.ga_len))
				loop
					js.reset
					if (create {CE_POINTER [PD_DEBUGGY]}.make_cast (l_gap.item.ga_data) + l_i___0).item.dbg_nr = l_nr then
						l_todel := l_i___0
						js.break
					end
					if not js.loop_jumped then
						l_i___0 := l_i___0 + 1
					end
				end
				js.reset
			elseif ((a_eap.item.arg).item).to_integer_32 = 42 then
				l_todel := 0
				l_del_all := 1
			else
				if (dbg_parsearg (a_eap.item.arg, l_gap)) = 0 then
					js.return
				end
				if not js.return_called then
					l_bp___0.ce_gets (create {CE_POINTER [PD_DEBUGGY]}.make_cast (l_gap.item.ga_data) + l_gap.item.ga_len)
					l_i___0 := 0
					from
					until
						not (l_i___0 < l_gap.item.ga_len)
					loop
						l_bpi.ce_gets (create {CE_POINTER [PD_DEBUGGY]}.make_cast (l_gap.item.ga_data) + l_i___0)
						if l_bp___0.item.dbg_type = l_bpi.item.dbg_type then
							if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_bp___0.item.dbg_name), create {CE_POINTER [INTEGER_8]}.make_cast (l_bpi.item.dbg_name))) = 0 then
								if l_bp___0.item.dbg_lnum = l_bpi.item.dbg_lnum then
									l_todel := l_i___0
									l_best_lnum := l_bpi.item.dbg_lnum
								elseif l_bp___0.item.dbg_lnum = 0 then
									if l_best_lnum = 0 then
										l_todel := l_i___0
										l_best_lnum := l_bpi.item.dbg_lnum
									elseif l_bpi.item.dbg_lnum < l_best_lnum then
										l_todel := l_i___0
										l_best_lnum := l_bpi.item.dbg_lnum
									end
								end
							end
						end
						l_i___0 := l_i___0 + 1
					end
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_bp___0.item.dbg_name))
				end
			end
			if not js.return_called then
				if l_todel < 0 then
					message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E161: Breakpoint not found: %%s")))), a_eap.item.arg).do_nothing
				else
					from
					until
						not (not js.loop_left and then (l_gap.item.ga_len > 0))
					loop
						js.reset
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_DEBUGGY]}.make_cast (l_gap.item.ga_data) + l_todel).item.dbg_name))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_DEBUGGY]}.make_cast (l_gap.item.ga_data) + l_todel).item.dbg_prog))
						l_gap.item.ga_len := (l_gap.item.ga_len) - 1
						if l_todel < l_gap.item.ga_len then
							memmove (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_DEBUGGY]}.make_cast (l_gap.item.ga_data) + l_todel)), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_DEBUGGY]}.make_cast (l_gap.item.ga_data) + (l_todel + 1))), (l_gap.item.ga_len - l_todel).to_natural_32 * {PD_DEBUGGY}.sizeof.to_natural_32).do_nothing
						end
						globals_inst.debug_tick := globals_inst.debug_tick + 1
						if not l_del_all.to_boolean then
							js.break
						end
					end
					js.reset
					if l_gap.item.ga_len = 0 then
						misc2_inst.ga_clear (l_gap)
					end
				end
			end
		end

	ex_breakdel_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_breakdel)
		end

	ex_breaklist (a_eap: CE_POINTER [PD_EXARG])
		local
			l_bp___0: CE_POINTER [PD_DEBUGGY]
			l_i___0: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
		do
			create l_bp___0.make
			create l_tmp___0.make

			if dbg_breakp.ga_len = 0 then
				message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("No breakpoints defined"))))).do_nothing
			else
				l_i___0 := 0
				from
				until
					not (l_i___0 < dbg_breakp.ga_len)
				loop
					l_bp___0.ce_gets (create {CE_POINTER [PD_DEBUGGY]}.make_cast (dbg_breakp.ga_data) + l_i___0)
					if l_bp___0.item.dbg_type = 1 then
						l_tmp___0.ce_gets (ce_string ("func"))
					else
						l_tmp___0.ce_gets (ce_string ("file"))
					end
					message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%%3d  %%s %%s  line %%ld")))), l_bp___0.item.dbg_nr, l_tmp___0, l_bp___0.item.dbg_name, l_bp___0.item.dbg_lnum]).do_nothing
					l_i___0 := l_i___0 + 1
				end
			end
		end

	ex_breaklist_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_breaklist)
		end

	dbg_find_breakpoint (a_file: INTEGER_32; a_fname: CE_POINTER [NATURAL_8]; a_after: INTEGER_32): INTEGER_32
		do
			Result := (debuggy_find (a_file, a_fname, a_after, dbg_breakp.address, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
		end

	debuggy_find (a_file: INTEGER_32; a_fname: CE_POINTER [NATURAL_8]; a_after: INTEGER_32; a_gap: CE_POINTER [PD_GROWARRAY]; a_fp: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_bp___0: CE_POINTER [PD_DEBUGGY]
			l_i___0: INTEGER_32
			l_lnum: INTEGER_32
			l_regmatch___0: PD_REGMATCH_T
			l_name___1: CE_POINTER [NATURAL_8]
			l_prev_got_int: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_bp___0.make
			create l_regmatch___0.make
			create l_name___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lnum := (0).to_integer_32
					l_name___1.ce_gets (a_fname)
					if a_gap.item.ga_len = 0 then
						Result := (0).to_integer_32
						js.return
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if not a_file.to_boolean then
							if (a_fname[0]).to_integer_32 = 128 then
								l_name___1.ce_gets (misc2_inst.alloc ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_fname))) + {NATURAL_32} 3))
								if (l_name___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_name___1.ce_gets (a_fname)
								else
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_name___1), ce_string ("<SNR>")).do_nothing
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_name___1 + 5)), create {CE_POINTER [INTEGER_8]}.make_cast ((a_fname + 3))).do_nothing
								end
							end
						end
						l_i___0 := 0
				when 2 then -- loop condition:
						if not (l_i___0 < a_gap.item.ga_len) then
							l_pos := -1 + 11 -- skip loop
						end
				when 3 then -- loop body:
						l_bp___0.ce_gets (create {CE_POINTER [PD_DEBUGGY]}.make_cast (a_gap.item.ga_data) + l_i___0)
						if (l_bp___0.item.dbg_type = 2) /= a_file.to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						if not (l_bp___0.item.dbg_lnum > a_after) then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if l_lnum /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if not (l_bp___0.item.dbg_lnum < l_lnum) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						l_regmatch___0.regprog := l_bp___0.item.dbg_prog
						l_regmatch___0.rm_ic := 0
						l_prev_got_int := globals_inst.got_int
						globals_inst.got_int := 0
						if (regexp_inst.vim_regexec (l_regmatch___0.address, l_name___1, 0)).to_boolean then
							l_lnum := l_bp___0.item.dbg_lnum
							if (a_fp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								a_fp.item := l_bp___0.item.dbg_forceit
							end
						end
						globals_inst.got_int := (globals_inst.got_int).bit_or (l_prev_got_int)
				when 10 then -- if done | if done | if done
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 2 -- back to loop condition
				when 11 then -- loop done
						if (l_name___1.c_pointer.to_integer_32).to_natural_32 /= (a_fname.c_pointer.to_integer_32).to_natural_32 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_name___1))
						end
						Result := l_lnum
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	dbg_breakpoint (a_name___1: CE_POINTER [NATURAL_8]; a_lnum: INTEGER_32)
		do
			debug_breakpoint_name.ce_gets (a_name___1)
			debug_breakpoint_lnum := a_lnum
		end

	profile_start (a_tm: CE_POINTER [SD_TIMEVAL])
		do
			gettimeofday (a_tm, create {CE_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
		end

	profile_end (a_tm: CE_POINTER [SD_TIMEVAL])
		local
			l_now: SD_TIMEVAL
		do
			create l_now.make

			gettimeofday ((l_now.address), create {CE_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
			a_tm.item.tv_usec := l_now.tv_usec - a_tm.item.tv_usec
			a_tm.item.tv_sec := l_now.tv_sec - a_tm.item.tv_sec
			if a_tm.item.tv_usec < 0 then
				a_tm.item.tv_usec := a_tm.item.tv_usec + (1000000)
				a_tm.item.tv_sec := (a_tm.item.tv_sec) - 1
			end
		end

	profile_sub (a_tm: CE_POINTER [SD_TIMEVAL]; a_tm2: CE_POINTER [SD_TIMEVAL])
		do
			a_tm.item.tv_usec := a_tm.item.tv_usec - (a_tm2.item.tv_usec)
			a_tm.item.tv_sec := a_tm.item.tv_sec - (a_tm2.item.tv_sec)
			if a_tm.item.tv_usec < 0 then
				a_tm.item.tv_usec := a_tm.item.tv_usec + (1000000)
				a_tm.item.tv_sec := (a_tm.item.tv_sec) - 1
			end
		end

	profile_msg (a_tm: CE_POINTER [SD_TIMEVAL]): CE_POINTER [INTEGER_8]
		do
			sprintf ([buf, ce_string ("%%3ld.%%06ld"), a_tm.item.tv_sec, a_tm.item.tv_usec]).do_nothing
			Result := buf
		end

	profile_setlimit (a_msec: INTEGER_32; a_tm: CE_POINTER [SD_TIMEVAL])
		local
			l_usec: INTEGER_32
		do
			if a_msec <= 0 then
				profile_zero (a_tm)
			else
				gettimeofday (a_tm, create {CE_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
				l_usec := a_tm.item.tv_usec + a_msec * 1000
				a_tm.item.tv_usec := l_usec \\ 1000000
				a_tm.item.tv_sec := a_tm.item.tv_sec + (l_usec // 1000000)
			end
		end

	profile_passed_limit (a_tm: CE_POINTER [SD_TIMEVAL]): INTEGER_32
		local
			l_now: SD_TIMEVAL
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_now.make

			if a_tm.item.tv_sec = 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				gettimeofday ((l_now.address), create {CE_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
				if l_now.tv_sec > a_tm.item.tv_sec then
					l_tmp := 1
				elseif l_now.tv_sec = a_tm.item.tv_sec then
					if l_now.tv_usec > a_tm.item.tv_usec then
						l_tmp := 1
					else
						l_tmp := 0
					end
				else
					l_tmp := 0
				end
				Result := l_tmp
			end
		end

	profile_zero (a_tm: CE_POINTER [SD_TIMEVAL])
		do
			a_tm.item.tv_usec := (0).to_integer_32
			a_tm.item.tv_sec := (0).to_integer_32
		end

	autowrite (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_forceit: INTEGER_32): INTEGER_32
		local
			l_r: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (option_inst.p_aw.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 3 then -- else:
						if not (option_inst.p_awa.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 4 then -- if: | _L___0:
						if option_inst.p_write.to_boolean then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						Result := 0
						js.return
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 7 then -- else:
						if not ((quickfix_inst.bt_dontwrite (a_buf___6)).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						Result := 0
						js.return
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if a_forceit.to_boolean then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if (a_buf___6.item.b_p_ro).to_boolean then
							Result := 0
							js.return
						else
							l_pos := -1 + 13 -- goto _L
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L:
						if ((a_buf___6.item.b_ffname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							Result := 0
							js.return
						end
				when 14 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						Result := 0
						js.return
				when 16 then -- if done
						if not js.return_called then
							l_r := buf_write_all (a_buf___6, a_forceit)
							if (buffer_inst.buf_valid (a_buf___6)).to_boolean then
								if (undo_inst.bufIsChanged (a_buf___6)).to_boolean then
									l_r := 0
								end
							end
							Result := l_r
						end
				when 17 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	autowrite_all
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___6.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (option_inst.p_aw.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (option_inst.p_awa.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						if not option_inst.p_write.to_boolean then
							js.return
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						js.return
				when 7 then -- if done
						if not js.return_called then
							l_buf___6.ce_gets (globals_inst.firstbuf)
							from
							until
								(l_buf___6).c_pointer = default_pointer
							loop
								if (undo_inst.bufIsChanged (l_buf___6)).to_boolean then
									if not (l_buf___6.item.b_p_ro).to_boolean then
										buf_write_all (l_buf___6, 0).do_nothing
										if not (buffer_inst.buf_valid (l_buf___6)).to_boolean then
											l_buf___6.ce_gets (globals_inst.firstbuf)
										end
									end
								end
								l_buf___6.ce_gets (l_buf___6.item.b_next)
							end
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	check_changed (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_checkaw: INTEGER_32; a_mult_win: INTEGER_32; a_forceit: INTEGER_32; a_allbuf: INTEGER_32): INTEGER_32
		local
			l_buf2: CE_POINTER [PD_FILE_BUFFER]
			l_count___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_forceit.to_boolean then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						if not ((undo_inst.bufIsChanged (a_buf___6)).to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 2 then -- if:
						if not (a_mult_win.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L___1
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 5 then -- else:
						if not (a_buf___6.item.b_nwindows <= 1) then
							l_pos := -1 + 16 -- skip if block
						end
				when 6 then -- if: | _L___1:
						if a_checkaw.to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 9 then -- else:
						if (autowrite (a_buf___6, a_forceit)) /= 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 10 then -- if: | _L___0:
						if not (option_inst.p_confirm.to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 13 then -- else:
						if not ((globals_inst.cmdmod.confirm).to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L:
						if option_inst.p_write.to_boolean then
							l_count___2 := 0
							if a_allbuf.to_boolean then
								l_buf2.ce_gets (globals_inst.firstbuf)
								from
								until
									(l_buf2.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
								loop
									if (undo_inst.bufIsChanged (l_buf2)).to_boolean then
										if ((l_buf2.item.b_ffname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
											l_count___2 := l_count___2 + 1
										elseif (globals_inst.cmdmod.browse).to_boolean then
											l_count___2 := l_count___2 + 1
										end
									end
									l_buf2.ce_gets (l_buf2.item.b_next)
								end
							end
							if not (buffer_inst.buf_valid (a_buf___6)).to_boolean then
								Result := 0
								js.return
							end
							if not js.return_called then
								dialog_changed (a_buf___6, (l_count___2 > 1).to_integer)
								if not (buffer_inst.buf_valid (a_buf___6)).to_boolean then
									Result := 0
									js.return
								end
							end
							if not js.return_called then
								Result := (undo_inst.bufIsChanged (a_buf___6))
								js.return
							end
						end
				when 15 then -- if done
						if not js.return_called then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_nowrtmsg))))).do_nothing
							Result := 1
							js.return
						end
				when 16 then -- if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 17 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	browse_save_fname (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		local
			l_fname: CE_POINTER [NATURAL_8]
		do
			create l_fname.make

			if ((a_buf___6.item.b_fname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_fname.ce_gets (message_inst.do_browse (1, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Save As")))), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), a_buf___6))
				if (l_fname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if (buffer_inst.setfname (a_buf___6, l_fname, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 1)) = 1 then
						a_buf___6.item.b_flags := (a_buf___6.item.b_flags).bit_or ((8))
					end
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fname))
				end
			end
		end

	dialog_changed (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_checkall: INTEGER_32)
		local
			l_buff: CE_ARRAY [NATURAL_8]
			l_ret: INTEGER_32
			l_buf2: CE_POINTER [PD_FILE_BUFFER]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_buff.make (<<1025>>)
			create l_buf2.make
			create l_tmp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((a_buf___6.item.b_fname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_tmp___0.ce_gets (a_buf___6.item.b_fname)
					else
						l_tmp___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Untitled")))))
					end
					ex_docmd_inst.dialog_msg (l_buff, (gettext (ce_string ("Save changes to %"%%s%"?"))), l_tmp___0)
					if a_checkall.to_boolean then
						l_ret := message_inst.vim_dialog_yesnoallcancel (4, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_buff, 1)
					else
						l_ret := message_inst.vim_dialog_yesnocancel (4, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_buff, 1)
					end
					if l_ret /= 2 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						browse_save_fname (a_buf___6)
						if ((a_buf___6.item.b_fname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							buf_write_all (a_buf___6, 0).do_nothing
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 3 then -- else:
						if l_ret /= 3 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						misc1_inst.unchanged (a_buf___6, 1)
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 6 then -- else:
						if l_ret /= 5 then
							l_pos := -1 + 17 -- skip if block
						end
				when 7 then -- if:
						l_buf2.ce_gets (globals_inst.firstbuf)
				when 8 then -- loop condition:
						if (l_buf2.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 16 -- skip loop
						end
				when 9 then -- loop body:
						if not ((undo_inst.bufIsChanged (l_buf2)).to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if:
						if ((l_buf2.item.b_ffname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 13 then -- else:
						if not ((globals_inst.cmdmod.browse).to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L:
						if not (l_buf2.item.b_p_ro).to_boolean then
							browse_save_fname (l_buf2)
							if ((l_buf2.item.b_fname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								buf_write_all (l_buf2, 0).do_nothing
							end
							if not (buffer_inst.buf_valid (l_buf2)).to_boolean then
								l_buf2.ce_gets (globals_inst.firstbuf)
							end
						end
				when 15 then -- if done | if done
						l_buf2.ce_gets (l_buf2.item.b_next)
						l_pos := -1 + 8 -- back to loop condition
				when 16 then -- loop done | if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						if l_ret = 6 then
							l_buf2.ce_gets (globals_inst.firstbuf)
							from
							until
								(l_buf2.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
							loop
								misc1_inst.unchanged (l_buf2, 1)
								l_buf2.ce_gets (l_buf2.item.b_next)
							end
						end
				when 18 then -- if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	can_abandon (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_forceit: INTEGER_32): INTEGER_32
		local
			l_tmp___2: INTEGER_32
		do
			if (quickfix_inst.buf_hide (a_buf___6)).to_boolean then
				l_tmp___2 := 1
			elseif (undo_inst.bufIsChanged (a_buf___6)).to_boolean then
				if a_buf___6.item.b_nwindows > 1 then
					l_tmp___2 := 1
				elseif (autowrite (a_buf___6, a_forceit)) = 1 then
					l_tmp___2 := 1
				elseif a_forceit.to_boolean then
					l_tmp___2 := 1
				else
					l_tmp___2 := 0
				end
			else
				l_tmp___2 := 1
			end
			Result := l_tmp___2
		end

	check_changed_any (a_hidden: INTEGER_32): INTEGER_32
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_save___0: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_tmp___5: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___6.make
			create l_wp___0.make
			create l_tmp___5.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if js.loop_left then
						l_pos := -1 + 14 -- skip loop
					end
				when 1 then -- loop body:
						js.reset
						if a_hidden.to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (undo_inst.curbufIsChanged).to_boolean then
							l_buf___6.ce_gets (globals_inst.curbuf)
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 4 then -- else: | _L___0:
						l_buf___6.ce_gets (globals_inst.firstbuf)
				when 5 then -- loop condition:
						if not (not js.loop_left and then ((l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32)) then
							l_pos := -1 + 12 -- skip loop
						end
				when 6 then -- loop body:
						js.reset
						if a_hidden.to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if l_buf___6.item.b_nwindows /= 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						if (undo_inst.bufIsChanged (l_buf___6)).to_boolean then
							js.break
						end
				when 11 then -- if done
						if not js.loop_jumped then
							l_buf___6.ce_gets (l_buf___6.item.b_next)
						end
						l_pos := -1 + 5 -- back to loop condition
				when 12 then -- loop done
						js.reset
				when 13 then
						if (l_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							Result := 0
							js.return
						end
						if not js.return_called then
							if (check_changed (l_buf___6, option_inst.p_awa, 1, 0, 1)).to_boolean then
								if (buffer_inst.buf_valid (l_buf___6)).to_boolean then
									js.break
								end
							end
						end
						l_pos := -1 + 0 -- back to loop condition
				when 14 then -- loop done
					js.reset
					if not js.return_called then
						globals_inst.exiting := 0
						if not option_inst.p_confirm.to_boolean then
							if not (globals_inst.cmdmod.confirm).to_boolean then
								if globals_inst.vgetc_busy > 0 then
									globals_inst.msg_row := globals_inst.cmdline_row
									globals_inst.msg_col := 0
									globals_inst.msg_didout := 0
								end
								if ((buffer_inst.buf_spname (l_buf___6)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_tmp___5.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((buffer_inst.buf_spname (l_buf___6))))
								else
									l_tmp___5.ce_gets (l_buf___6.item.b_fname)
								end
								if (message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E162: No write since last change for buffer %"%%s%"")))), l_tmp___5)).to_boolean then
									l_save___0 := globals_inst.no_wait_return
									globals_inst.no_wait_return := 0
									message_inst.wait_return (0)
									globals_inst.no_wait_return := l_save___0
								end
							end
						end
						if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 then
							l_wp___0.ce_gets (globals_inst.firstwin)
							from
							until
								not (not js.loop_left and then ((l_wp___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
							loop
								js.reset
								if ((l_wp___0.item.w_buffer).c_pointer.to_integer_32).to_natural_32 = (l_buf___6.c_pointer.to_integer_32).to_natural_32 then
									window_inst.win_goto (l_wp___0)
									if not (buffer_inst.buf_valid (l_buf___6)).to_boolean then
										Result := 1
										js.return
									end
									if not js.return_called then
										js.break
									end
								end
								if not js.loop_jumped then
									l_wp___0.ce_gets (l_wp___0.item.w_next)
								end
							end
							js.reset
						end
					end
					if not js.return_called then
						if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 then
							buffer_inst.set_curbuf (l_buf___6, 0)
						end
						Result := 1
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_fname: INTEGER_32
		local
			js: JUMP_STATE
		do
			if ((globals_inst.curbuf.item.b_ffname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_noname))))).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 1
			end
		end

	buf_write_all (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_forceit: INTEGER_32): INTEGER_32
		local
			l_retval: INTEGER_32
			l_old_curbuf: CE_POINTER [PD_FILE_BUFFER]
		do
			create l_old_curbuf.make

			l_old_curbuf.ce_gets (globals_inst.curbuf)
			l_retval := fileio_inst.buf_write (a_buf___6, a_buf___6.item.b_ffname, a_buf___6.item.b_fname, (1).to_integer_32, a_buf___6.item.b_ml.ml_line_count, create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer), 0, a_forceit, 1, 0)
			if (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 /= (l_old_curbuf.c_pointer.to_integer_32).to_natural_32 then
				message_inst.msg_source (globals_inst.highlight_attr[17])
				message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Warning: Entered other buffer unexpectedly (check autocommands)"))))).do_nothing
			end
			Result := l_retval
		end

	do_one_arg (a_str___1: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_str___1: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_inbacktick: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_str___1.make
			create l_p___0.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___3.make

			l_str___1.ce_gets (a_str___1)
			l_inbacktick := 0
			l_p___0.ce_gets (l_str___1)
			from
			until
				not (not js.loop_left and then ((l_str___1.item).to_boolean))
			loop
				js.reset
				if (charset_inst.rem_backslash (l_str___1)).to_boolean then
					l_tmp.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___0.ce_gets (l_str___1)
					l_str___1.ce_gets (l_str___1 + 1)
					l_tmp.item := l_tmp___0.item
					l_tmp___1.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___1.item := l_str___1.item
				else
					if not l_inbacktick.to_boolean then
						if (misc2_inst.vim_isspace ((l_str___1.item).to_integer_32)).to_boolean then
							js.break
						end
					end
					if not js.loop_jumped then
						if (l_str___1.item).to_integer_32 = 96 then
							l_inbacktick := (l_inbacktick).bit_xor ((1))
						end
						l_tmp___3.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___3.item := l_str___1.item
					end
				end
				if not js.loop_jumped then
					l_str___1.ce_gets (l_str___1 + 1)
				end
			end
			js.reset
			l_str___1.ce_gets (charset_inst.skipwhite (l_str___1))
			l_p___0.item := (('%/0/').code).to_natural_8
			Result := l_str___1
		end

	get_arglist (a_gap: CE_POINTER [PD_GROWARRAY]; a_str___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_str___1: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_str___1.make

			l_str___1.ce_gets (a_str___1)
			misc2_inst.ga_init2 (a_gap, (Pointer_bytes.to_natural_32).to_integer_32, 20)
			from
			until
				not (not js.loop_left and then ((l_str___1.item).to_integer_32 /= 0))
			loop
				if (misc2_inst.ga_grow (a_gap, 1)) = 0 then
					misc2_inst.ga_clear (a_gap)
					Result := 0
					js.return
				end
				if not js.return_called then
					l_tmp___0 := a_gap.item.ga_len
					a_gap.item.ga_len := (a_gap.item.ga_len) + 1
					create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (a_gap.item.ga_data)[l_tmp___0] := l_str___1
					l_str___1.ce_gets (do_one_arg (l_str___1))
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	get_arglist_exp (a_str___1: CE_POINTER [NATURAL_8]; a_fcountp: CE_POINTER [INTEGER_32]; a_fnamesp: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]): INTEGER_32
		local
			l_ga: PD_GROWARRAY
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_ga.make

			if (get_arglist (l_ga.address, a_str___1)) = 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_i___0 := misc1_inst.gen_expand_wildcards (l_ga.ga_len, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_ga.ga_data), a_fcountp, a_fnamesp, 6)
				misc2_inst.ga_clear (l_ga.address)
				Result := l_i___0
			end
		end

	set_arglist (a_str___1: CE_POINTER [NATURAL_8])
		do
			do_arglist (a_str___1, 1, 0).do_nothing
		end

	do_arglist (a_str___1: CE_POINTER [NATURAL_8]; a_what: INTEGER_32; a_after: INTEGER_32): INTEGER_32
		local
			l_new_ga: PD_GROWARRAY
			l_exp_count: INTEGER_32
			l_exp_files: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_match: INTEGER_32
			l_regmatch___0: PD_REGMATCH_T
			l_didone: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_new_ga.make
			create l_exp_files.make
			create l_p___0.make
			create l_regmatch___0.make

			if (get_arglist (l_new_ga.address, a_str___1)) = 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				if a_what = 3 then
					l_regmatch___0.rm_ic := 0
					l_i___0 := 0
					from
					until
						js.loop_left
					loop
						js.reset
						if l_i___0 < l_new_ga.ga_len then
							if globals_inst.got_int.to_boolean then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_p___0.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_new_ga.ga_data)[l_i___0])
							l_p___0.ce_gets (fileio_inst.file_pat_to_reg_pat (l_p___0, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), 0))
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.break
							end
						end
						if not js.loop_jumped then
							if option_inst.p_magic.to_boolean then
								l_tmp___0 := 1
							else
								l_tmp___0 := 0
							end
							l_regmatch___0.regprog := regexp_inst.vim_regcomp (l_p___0, l_tmp___0)
							if ((l_regmatch___0.regprog).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
								js.break
							end
						end
						if not js.loop_jumped then
							l_didone := 0
							l_match := 0
							from
							until
								not (l_match < (globals_inst.curwin.item.w_alist).item.al_ga.ga_len)
							loop
								if (regexp_inst.vim_regexec (l_regmatch___0.address, (buffer_inst.alist_name (create {CE_POINTER [PD_ARGENTRY]}.make_cast ((globals_inst.curwin.item.w_alist).item.al_ga.ga_data) + l_match)), 0)).to_boolean then
									l_didone := 1
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_ARGENTRY]}.make_cast ((globals_inst.curwin.item.w_alist).item.al_ga.ga_data) + l_match).item.ae_fname))
									memmove (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_ARGENTRY]}.make_cast ((globals_inst.curwin.item.w_alist).item.al_ga.ga_data) + l_match)), create {CE_POINTER [ANY]}.make_cast (((create {CE_POINTER [PD_ARGENTRY]}.make_cast ((globals_inst.curwin.item.w_alist).item.al_ga.ga_data) + l_match) + 1)), (((globals_inst.curwin.item.w_alist).item.al_ga.ga_len - l_match) - 1).to_natural_32 * {PD_ARGENTRY}.sizeof.to_natural_32).do_nothing;
									(globals_inst.curwin.item.w_alist).item.al_ga.ga_len := ((globals_inst.curwin.item.w_alist).item.al_ga.ga_len) - 1
									if globals_inst.curwin.item.w_arg_idx > l_match then
										globals_inst.curwin.item.w_arg_idx := (globals_inst.curwin.item.w_arg_idx) - 1
									end
									l_match := l_match - 1
								end
								l_match := l_match + 1
							end
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_regmatch___0.regprog))
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
							if not l_didone.to_boolean then
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_nomatch2)))), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_new_ga.ga_data)[l_i___0]).do_nothing
							end
							l_i___0 := l_i___0 + 1
						end
					end
					js.reset
					misc2_inst.ga_clear (l_new_ga.address)
				else
					l_i___0 := misc1_inst.expand_wildcards (l_new_ga.ga_len, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_new_ga.ga_data), create {CE_POINTER [INTEGER_32]}.make_shared ($l_exp_count), l_exp_files.address, 15)
					misc2_inst.ga_clear (l_new_ga.address)
					if l_i___0 = 0 then
						Result := 0
						js.return
					end
					if not js.return_called and then (l_exp_count = 0) then
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_nomatch))))).do_nothing
						Result := 0
						js.return
					end
					if not js.return_called then
						if a_what = 2 then
							alist_add_list (l_exp_count, l_exp_files, a_after).do_nothing
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_exp_files))
						else
							ex_docmd_inst.alist_set (globals_inst.curwin.item.w_alist, l_exp_count, l_exp_files, 0, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0)
						end
					end
				end
			end
			if not js.return_called then
				alist_check_arg_idx
				Result := 1
			end
		end

	alist_check_arg_idx
		local
			l_win: CE_POINTER [PD_WINDOW_S]
			l_tp: CE_POINTER [PD_TABPAGE_S]
			js: JUMP_STATE
		do
			create l_win.make
			create l_tp.make

			l_tp.ce_gets (globals_inst.first_tabpage)
			from
			until
				not (not js.loop_left and then ((l_tp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				if (l_tp.c_pointer.to_integer_32).to_natural_32 = (globals_inst.curtab.c_pointer.to_integer_32).to_natural_32 then
					l_win.ce_gets (globals_inst.firstwin)
				else
					l_win.ce_gets (l_tp.item.tp_firstwin)
				end
				from
				until
					(l_win).c_pointer = default_pointer
				loop
					if ((l_win.item.w_alist).c_pointer.to_integer_32).to_natural_32 = ((globals_inst.curwin.item.w_alist).c_pointer.to_integer_32).to_natural_32 then
						check_arg_idx (l_win)
					end
					l_win.ce_gets (l_win.item.w_next)
				end
				l_tp.ce_gets (l_tp.item.tp_next)
			end
		end

	editing_arg_idx (a_win: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if a_win.item.w_arg_idx >= (a_win.item.w_alist).item.al_ga.ga_len then
				l_tmp___1 := 0
			elseif (a_win.item.w_buffer).item.b_fnum /= (create {CE_POINTER [PD_ARGENTRY]}.make_cast ((a_win.item.w_alist).item.al_ga.ga_data) + a_win.item.w_arg_idx).item.ae_fnum then
				if (((a_win.item.w_buffer).item.b_ffname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_tmp___1 := 0
				elseif (((misc1_inst.fullpathcmp ((buffer_inst.alist_name (create {CE_POINTER [PD_ARGENTRY]}.make_cast ((a_win.item.w_alist).item.al_ga.ga_data) + a_win.item.w_arg_idx)), (a_win.item.w_buffer).item.b_ffname, 1))).bit_and (1)).to_boolean then
					l_tmp___1 := 1
				else
					l_tmp___1 := 0
				end
			else
				l_tmp___1 := 1
			end
			Result := l_tmp___1
		end

	check_arg_idx (a_win: CE_POINTER [PD_WINDOW_S])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((a_win.item.w_alist).item.al_ga.ga_len > 1) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (editing_arg_idx (a_win)).to_boolean then
							l_pos := -1 + 3 -- goto _L
						else
							a_win.item.w_arg_idx_invalid := 1
							if a_win.item.w_arg_idx /= (a_win.item.w_alist).item.al_ga.ga_len - 1 then
								if globals_inst.arg_had_last = 0 then
									if ((a_win.item.w_alist).c_pointer.to_integer_32).to_natural_32 = ((globals_inst.global_alist.address).c_pointer.to_integer_32).to_natural_32 then
										if globals_inst.global_alist.al_ga.ga_len > 0 then
											if a_win.item.w_arg_idx < globals_inst.global_alist.al_ga.ga_len then
												if (a_win.item.w_buffer).item.b_fnum = (create {CE_POINTER [PD_ARGENTRY]}.make_cast (globals_inst.global_alist.al_ga.ga_data) + (globals_inst.global_alist.al_ga.ga_len - 1)).item.ae_fnum then
													globals_inst.arg_had_last := 1
												elseif (((a_win.item.w_buffer).item.b_ffname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
													if (((misc1_inst.fullpathcmp ((buffer_inst.alist_name (create {CE_POINTER [PD_ARGENTRY]}.make_cast (globals_inst.global_alist.al_ga.ga_data) + (globals_inst.global_alist.al_ga.ga_len - 1))), (a_win.item.w_buffer).item.b_ffname, 1))).bit_and (1)).to_boolean then
														globals_inst.arg_had_last := 1
													end
												end
											end
										end
									end
								end
							end
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						a_win.item.w_arg_idx_invalid := 0
						if a_win.item.w_arg_idx = (a_win.item.w_alist).item.al_ga.ga_len - 1 then
							if ((a_win.item.w_alist).c_pointer.to_integer_32).to_natural_32 = ((globals_inst.global_alist.address).c_pointer.to_integer_32).to_natural_32 then
								globals_inst.arg_had_last := 1
							end
						end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_args (a_eap: CE_POINTER [PD_EXARG])
		local
			l_i___0: INTEGER_32
			l_gap: CE_POINTER [PD_GROWARRAY]
		do
			create l_gap.make

			if a_eap.item.cmdidx /= 7 then
				ex_docmd_inst.alist_unlink (globals_inst.curwin.item.w_alist)
				if a_eap.item.cmdidx = 12 then
					globals_inst.curwin.item.w_alist := globals_inst.global_alist.address
				else
					ex_docmd_inst.alist_new
				end
			end
			if (ex_docmd_inst.ends_excmd (((a_eap.item.arg).item).to_integer_32)).to_boolean then
				if a_eap.item.cmdidx = 7 then
					if (globals_inst.curwin.item.w_alist).item.al_ga.ga_len > 0 then
						ex_getln_inst.gotocmdline (1)
						l_i___0 := 0
						from
						until
							not (l_i___0 < (globals_inst.curwin.item.w_alist).item.al_ga.ga_len)
						loop
							if l_i___0 = globals_inst.curwin.item.w_arg_idx then
								message_inst.msg_putchar (('[').code)
							end
							message_inst.msg_outtrans ((buffer_inst.alist_name (create {CE_POINTER [PD_ARGENTRY]}.make_cast ((globals_inst.curwin.item.w_alist).item.al_ga.ga_data) + l_i___0))).do_nothing
							if l_i___0 = globals_inst.curwin.item.w_arg_idx then
								message_inst.msg_putchar ((']').code)
							end
							message_inst.msg_putchar ((' ').code)
							l_i___0 := l_i___0 + 1
						end
					end
				elseif a_eap.item.cmdidx = 13 then
					l_gap.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared ((globals_inst.curwin.item.w_alist).c_pointer + {PD_ARGLIST}.al_ga_offset))
					if (misc2_inst.ga_grow (l_gap, globals_inst.global_alist.al_ga.ga_len)) = 1 then
						l_i___0 := 0
						from
						until
							not (l_i___0 < globals_inst.global_alist.al_ga.ga_len)
						loop
							if (((create {CE_POINTER [PD_ARGENTRY]}.make_cast (globals_inst.global_alist.al_ga.ga_data) + l_i___0).item.ae_fname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								(create {CE_POINTER [PD_ARGENTRY]}.make_cast ((globals_inst.curwin.item.w_alist).item.al_ga.ga_data) + l_gap.item.ga_len).item.ae_fname := misc2_inst.vim_strsave ((create {CE_POINTER [PD_ARGENTRY]}.make_cast (globals_inst.global_alist.al_ga.ga_data) + l_i___0).item.ae_fname);
								(create {CE_POINTER [PD_ARGENTRY]}.make_cast ((globals_inst.curwin.item.w_alist).item.al_ga.ga_data) + l_gap.item.ga_len).item.ae_fnum := (create {CE_POINTER [PD_ARGENTRY]}.make_cast (globals_inst.global_alist.al_ga.ga_data) + l_i___0).item.ae_fnum
								l_gap.item.ga_len := (l_gap.item.ga_len) + 1
							end
							l_i___0 := l_i___0 + 1
						end
					end
				end
			else
				ex_next (a_eap)
			end
		end

	ex_args_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_args)
		end

	ex_previous (a_eap: CE_POINTER [PD_EXARG])
		do
			if globals_inst.curwin.item.w_arg_idx - (a_eap.item.line2).to_integer_32 >= (globals_inst.curwin.item.w_alist).item.al_ga.ga_len then
				do_argfile (a_eap, (globals_inst.curwin.item.w_alist).item.al_ga.ga_len - 1)
			else
				do_argfile (a_eap, globals_inst.curwin.item.w_arg_idx - (a_eap.item.line2).to_integer_32)
			end
		end

	ex_previous_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_previous)
		end

	ex_rewind (a_eap: CE_POINTER [PD_EXARG])
		do
			do_argfile (a_eap, 0)
		end

	ex_rewind_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_rewind)
		end

	ex_last (a_eap: CE_POINTER [PD_EXARG])
		do
			do_argfile (a_eap, (globals_inst.curwin.item.w_alist).item.al_ga.ga_len - 1)
		end

	ex_last_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_last)
		end

	ex_argument (a_eap: CE_POINTER [PD_EXARG])
		local
			l_i___0: INTEGER_32
		do
			if a_eap.item.addr_count > 0 then
				l_i___0 := (a_eap.item.line2 - 1).to_integer_32
			else
				l_i___0 := globals_inst.curwin.item.w_arg_idx
			end
			do_argfile (a_eap, l_i___0)
		end

	ex_argument_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_argument)
		end

	do_argfile (a_eap: CE_POINTER [PD_EXARG]; a_argn: INTEGER_32)
		local
			l_other: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_old_arg_idx: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___10: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_old_arg_idx := globals_inst.curwin.item.w_arg_idx
					if not (a_argn < 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 3 then -- else:
						if not (a_argn >= (globals_inst.curwin.item.w_alist).item.al_ga.ga_len) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L___1:
						if (globals_inst.curwin.item.w_alist).item.al_ga.ga_len <= 1 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E163: There is only one file to edit"))))).do_nothing
						elseif a_argn < 0 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E164: Cannot go before first file"))))).do_nothing
						else
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E165: Cannot go beyond last file"))))).do_nothing
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 6 then -- else:
						mark_inst.setpcmark
						globals_inst.need_mouse_correct := 1
						if ((a_eap.item.cmd).item).to_integer_32 /= 115 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 9 then -- else:
						if globals_inst.cmdmod.tab = 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L___0:
						if (window_inst.win_split (0, 0)) = 0 then
							js.return
						end
						if not js.return_called then
							globals_inst.curwin.item.w_onebuf_opt.wo_scb := 0
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 12 then -- else:
						l_other := 1
						if (quickfix_inst.buf_hide (globals_inst.curbuf)).to_boolean then
							l_p___0.ce_gets (buffer_inst.fix_fname ((buffer_inst.alist_name (create {CE_POINTER [PD_ARGENTRY]}.make_cast ((globals_inst.curwin.item.w_alist).item.al_ga.ga_data) + a_argn))))
							l_other := buffer_inst.otherfile (l_p___0)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
						end
						if not ((quickfix_inst.buf_hide (globals_inst.curbuf)).to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 13 then -- if:
						if l_other.to_boolean then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L:
						if (check_changed (globals_inst.curbuf, 1, (not l_other.to_boolean).to_integer, a_eap.item.forceit, 0)).to_boolean then
							js.return
						end
				when 15 then -- if done | if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						l_pos := -1 + 14 -- goto _L
				when 17 then -- if done | if done
						if not js.return_called then
							globals_inst.curwin.item.w_arg_idx := a_argn
							if a_argn = (globals_inst.curwin.item.w_alist).item.al_ga.ga_len - 1 then
								if ((globals_inst.curwin.item.w_alist).c_pointer.to_integer_32).to_natural_32 = ((globals_inst.global_alist.address).c_pointer.to_integer_32).to_natural_32 then
									globals_inst.arg_had_last := 1
								end
							end
							if (quickfix_inst.buf_hide (globals_inst.curwin.item.w_buffer)).to_boolean then
								l_tmp___8 := 1
							else
								l_tmp___8 := 0
							end
							if (a_eap.item.forceit).to_boolean then
								l_tmp___10 := 8
							else
								l_tmp___10 := 0
							end
							if (ex_cmds_inst.do_ecmd (0, (buffer_inst.alist_name (create {CE_POINTER [PD_ARGENTRY]}.make_cast ((globals_inst.curwin.item.w_alist).item.al_ga.ga_data) + globals_inst.curwin.item.w_arg_idx)), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), a_eap, (-1).to_integer_32, l_tmp___8 + l_tmp___10, globals_inst.curwin)) = 0 then
								globals_inst.curwin.item.w_arg_idx := l_old_arg_idx
							elseif a_eap.item.cmdidx /= 10 then
								mark_inst.setmark (('%'').code).do_nothing
							end
						end
				when 18 then -- if done
						if not js.return_called then
						end
				when 19 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_next (a_eap: CE_POINTER [PD_EXARG])
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((quickfix_inst.buf_hide (globals_inst.curbuf)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if a_eap.item.cmdidx /= 383 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if (check_changed (globals_inst.curbuf, 1, 0, a_eap.item.forceit, 0)).to_boolean then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						if ((a_eap.item.arg).item).to_integer_32 /= 0 then
							if (do_arglist (a_eap.item.arg, 1, 0)) = 0 then
								js.return
							end
							if not js.return_called then
								l_i___0 := 0
							end
						else
							l_i___0 := globals_inst.curwin.item.w_arg_idx + (a_eap.item.line2).to_integer_32
						end
						if not js.return_called then
							do_argfile (a_eap, l_i___0)
						end
				when 8 then -- if done | if done
						if not js.return_called then
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_next_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_next)
		end

	ex_argedit (a_eap: CE_POINTER [PD_EXARG])
		local
			l_fnum___0: INTEGER_32
			l_i___0: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make

			l_fnum___0 := buffer_inst.buflist_add (a_eap.item.arg, 2)
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (l_i___0 < (globals_inst.curwin.item.w_alist).item.al_ga.ga_len))
			loop
				js.reset
				if (create {CE_POINTER [PD_ARGENTRY]}.make_cast ((globals_inst.curwin.item.w_alist).item.al_ga.ga_data) + l_i___0).item.ae_fnum = l_fnum___0 then
					js.break
				end
				if not js.loop_jumped then
					l_i___0 := l_i___0 + 1
				end
			end
			js.reset
			if l_i___0 = (globals_inst.curwin.item.w_alist).item.al_ga.ga_len then
				l_s.ce_gets (misc2_inst.vim_strsave (a_eap.item.arg))
				if (l_s.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					js.return
				end
				if not js.return_called then
					if a_eap.item.addr_count > 0 then
						l_tmp := (a_eap.item.line2).to_integer_32
					else
						l_tmp := globals_inst.curwin.item.w_arg_idx + 1
					end
					l_i___0 := alist_add_list (1, l_s.address, l_tmp)
					if l_i___0 < 0 then
						js.return
					end
				end
				if not js.return_called then
					globals_inst.curwin.item.w_arg_idx := l_i___0
				end
			end
			if not js.return_called then
				alist_check_arg_idx
				do_argfile (a_eap, l_i___0)
			end
		end

	ex_argedit_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_argedit)
		end

	ex_argadd (a_eap: CE_POINTER [PD_EXARG])
		local
			l_tmp: INTEGER_32
		do
			if a_eap.item.addr_count > 0 then
				l_tmp := (a_eap.item.line2).to_integer_32
			else
				l_tmp := globals_inst.curwin.item.w_arg_idx + 1
			end
			do_arglist (a_eap.item.arg, 2, l_tmp).do_nothing
			buffer_inst.maketitle
		end

	ex_argadd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_argadd)
		end

	ex_argdelete (a_eap: CE_POINTER [PD_EXARG])
		local
			l_i___0: INTEGER_32
			l_n: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
		do
			create l_tmp.make

			if a_eap.item.addr_count > 0 then
				if a_eap.item.line2 > ((globals_inst.curwin.item.w_alist).item.al_ga.ga_len).to_integer_32 then
					a_eap.item.line2 := ((globals_inst.curwin.item.w_alist).item.al_ga.ga_len).to_integer_32
				end
				l_n := ((a_eap.item.line2 - a_eap.item.line1) + 1).to_integer_32
				if ((a_eap.item.arg).item).to_integer_32 /= 0 then
					l_tmp.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg)))
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
				elseif l_n <= 0 then
					l_tmp.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg)))
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
				else
					l_i___0 := (a_eap.item.line1).to_integer_32
					from
					until
						not (l_i___0.to_integer_32 <= a_eap.item.line2)
					loop
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_ARGENTRY]}.make_cast ((globals_inst.curwin.item.w_alist).item.al_ga.ga_data) + (l_i___0 - 1)).item.ae_fname))
						l_i___0 := l_i___0 + 1
					end
					memmove (create {CE_POINTER [ANY]}.make_cast (((create {CE_POINTER [PD_ARGENTRY]}.make_cast ((globals_inst.curwin.item.w_alist).item.al_ga.ga_data) + a_eap.item.line1) - 1)), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_ARGENTRY]}.make_cast ((globals_inst.curwin.item.w_alist).item.al_ga.ga_data) + a_eap.item.line2)), ((((globals_inst.curwin.item.w_alist).item.al_ga.ga_len).to_integer_32 - a_eap.item.line2).to_natural_32 * ({PD_ARGENTRY}.sizeof.to_natural_32).to_natural_32).to_natural_32).do_nothing;
					(globals_inst.curwin.item.w_alist).item.al_ga.ga_len := (globals_inst.curwin.item.w_alist).item.al_ga.ga_len - l_n
					if (globals_inst.curwin.item.w_arg_idx).to_integer_32 >= a_eap.item.line2 then
						globals_inst.curwin.item.w_arg_idx := globals_inst.curwin.item.w_arg_idx - l_n
					elseif (globals_inst.curwin.item.w_arg_idx).to_integer_32 > a_eap.item.line1 then
						globals_inst.curwin.item.w_arg_idx := (a_eap.item.line1).to_integer_32
					end
				end
			elseif ((a_eap.item.arg).item).to_integer_32 = 0 then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_argreq))))).do_nothing
			else
				do_arglist (a_eap.item.arg, 3, 0).do_nothing
			end
			buffer_inst.maketitle
		end

	ex_argdelete_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_argdelete)
		end

	ex_listdo (a_eap: CE_POINTER [PD_EXARG])
		local
			l_i___0: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_next_fnum: INTEGER_32
			l_save_ei: CE_POINTER [NATURAL_8]
			l_p_shm_save: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_wp___0.make
			create l_tp.make
			create l_buf___6.make
			create l_save_ei.make
			create l_p_shm_save.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_next_fnum := 0
					l_save_ei.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					if a_eap.item.cmdidx /= 485 then
						if a_eap.item.cmdidx /= 421 then
							l_save_ei.ce_gets (fileio_inst.au_event_disable (ce_string (",Syntax")))
						end
					end
					if a_eap.item.cmdidx /= 485 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 3 then -- else:
						if a_eap.item.cmdidx /= 421 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 6 then -- else:
						if not ((quickfix_inst.buf_hide (globals_inst.curbuf)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if (check_changed (globals_inst.curbuf, 1, 0, a_eap.item.forceit, 0)).to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						l_i___0 := 0
						l_wp___0.ce_gets (globals_inst.firstwin)
						l_tp.ce_gets (globals_inst.first_tabpage)
						if a_eap.item.cmdidx = 39 then
							buffer_inst.goto_buffer (a_eap, 1, 1, 0)
						else
							mark_inst.setpcmark
						end
						globals_inst.listcmd_busy := 1
						from
						until
							not (not js.loop_left and then (not globals_inst.got_int.to_boolean))
						loop
							js.reset
							if a_eap.item.cmdidx = 10 then
								if l_i___0 = (globals_inst.curwin.item.w_alist).item.al_ga.ga_len then
									js.break
								end
								if not js.loop_jumped then
									if globals_inst.curwin.item.w_arg_idx /= l_i___0 then
										l_p_shm_save.ce_gets (misc2_inst.vim_strsave (option_inst.p_shm))
										option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("shm")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 0)
										do_argfile (a_eap, l_i___0)
										option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("shm")), 0, l_p_shm_save, 0)
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p_shm_save))
									elseif not (editing_arg_idx (globals_inst.curwin)).to_boolean then
										l_p_shm_save.ce_gets (misc2_inst.vim_strsave (option_inst.p_shm))
										option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("shm")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 0)
										do_argfile (a_eap, l_i___0)
										option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("shm")), 0, l_p_shm_save, 0)
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p_shm_save))
									end
									if globals_inst.curwin.item.w_arg_idx /= l_i___0 then
										js.break
									end
								end
								if not js.loop_jumped then
									l_i___0 := l_i___0 + 1
								end
							elseif a_eap.item.cmdidx = 485 then
								if not (window_inst.win_valid (l_wp___0)).to_boolean then
									js.break
								end
								if not js.loop_jumped then
									window_inst.win_goto (l_wp___0)
									if (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 /= (l_wp___0.c_pointer.to_integer_32).to_natural_32 then
										js.break
									end
								end
								if not js.loop_jumped then
									l_wp___0.ce_gets (globals_inst.curwin.item.w_next)
								end
							elseif a_eap.item.cmdidx = 421 then
								if not (window_inst.valid_tabpage (l_tp)).to_boolean then
									js.break
								end
								if not js.loop_jumped then
									window_inst.goto_tabpage_tp (l_tp)
									l_tp.ce_gets (l_tp.item.tp_next)
								end
							elseif a_eap.item.cmdidx = 39 then
								l_next_fnum := -1
								l_buf___6.ce_gets (globals_inst.curbuf.item.b_next)
								from
								until
									not (not js.loop_left and then ((l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
								loop
									js.reset
									if (l_buf___6.item.b_p_bl).to_boolean then
										l_next_fnum := l_buf___6.item.b_fnum
										js.break
									end
									if not js.loop_jumped then
										l_buf___6.ce_gets (l_buf___6.item.b_next)
									end
								end
								js.reset
							end
							if not js.loop_jumped then
								ex_docmd_inst.do_cmdline (a_eap.item.arg, a_eap.item.getline, a_eap.item.cookie, 3).do_nothing
								if a_eap.item.cmdidx = 39 then
									if l_next_fnum < 0 then
										js.break
									end
									if not js.loop_jumped then
										l_buf___6.ce_gets (globals_inst.firstbuf)
										from
										until
											not (not js.loop_left and then ((l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
										loop
											js.reset
											if l_buf___6.item.b_fnum = l_next_fnum then
												js.break
											end
											if not js.loop_jumped then
												l_buf___6.ce_gets (l_buf___6.item.b_next)
											end
										end
										js.reset
										if (l_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
											js.break
										end
									end
									if not js.loop_jumped then
										l_p_shm_save.ce_gets (misc2_inst.vim_strsave (option_inst.p_shm))
										option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("shm")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 0)
										buffer_inst.goto_buffer (a_eap, 1, 1, l_next_fnum)
										option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("shm")), 0, l_p_shm_save, 0)
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p_shm_save))
										if globals_inst.curbuf.item.b_fnum /= l_next_fnum then
											js.break
										end
									end
								end
							end
							if not js.loop_jumped and then (a_eap.item.cmdidx = 485) then
								move_inst.validate_cursor
								if (globals_inst.curwin.item.w_onebuf_opt.wo_scb).to_boolean then
									normal_inst.do_check_scrollbind (1)
								end
							end
						end
						js.reset
						globals_inst.listcmd_busy := 0
				when 11 then -- if done | if done | if done
						if (l_save_ei.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							fileio_inst.au_event_restore (l_save_ei)
							fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_SYNTAX, globals_inst.curbuf.item.b_p_syn, globals_inst.curbuf.item.b_fname, 1, globals_inst.curbuf).do_nothing
						end
				when 12 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_listdo_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_listdo)
		end

	alist_add_list (a_count___2: INTEGER_32; a_files: CE_POINTER [CE_POINTER [NATURAL_8]]; a_after: INTEGER_32): INTEGER_32
		local
			l_after: INTEGER_32
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_after := a_after
			if (misc2_inst.ga_grow (create {CE_POINTER [PD_GROWARRAY]}.make_shared ((globals_inst.curwin.item.w_alist).c_pointer + {PD_ARGLIST}.al_ga_offset), a_count___2)) = 1 then
				if l_after < 0 then
					l_after := 0
				end
				if l_after > (globals_inst.curwin.item.w_alist).item.al_ga.ga_len then
					l_after := (globals_inst.curwin.item.w_alist).item.al_ga.ga_len
				end
				if l_after < (globals_inst.curwin.item.w_alist).item.al_ga.ga_len then
					memmove (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_ARGENTRY]}.make_cast ((globals_inst.curwin.item.w_alist).item.al_ga.ga_data) + (l_after + a_count___2))), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_ARGENTRY]}.make_cast ((globals_inst.curwin.item.w_alist).item.al_ga.ga_data) + l_after)), ((globals_inst.curwin.item.w_alist).item.al_ga.ga_len - l_after).to_natural_32 * {PD_ARGENTRY}.sizeof.to_natural_32).do_nothing
				end
				l_i___0 := 0
				from
				until
					not (l_i___0 < a_count___2)
				loop
					(create {CE_POINTER [PD_ARGENTRY]}.make_cast ((globals_inst.curwin.item.w_alist).item.al_ga.ga_data) + (l_after + l_i___0)).item.ae_fname := a_files[l_i___0];
					(create {CE_POINTER [PD_ARGENTRY]}.make_cast ((globals_inst.curwin.item.w_alist).item.al_ga.ga_data) + (l_after + l_i___0)).item.ae_fnum := buffer_inst.buflist_add (a_files[l_i___0], 2)
					l_i___0 := l_i___0 + 1
				end
				(globals_inst.curwin.item.w_alist).item.al_ga.ga_len := (globals_inst.curwin.item.w_alist).item.al_ga.ga_len + a_count___2
				if globals_inst.curwin.item.w_arg_idx >= l_after then
					globals_inst.curwin.item.w_arg_idx := (globals_inst.curwin.item.w_arg_idx) + 1
				end
				Result := l_after
				js.return
			end
			if not js.return_called then
				l_i___0 := 0
				from
				until
					not (l_i___0 < a_count___2)
				loop
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_files[l_i___0]))
					l_i___0 := l_i___0 + 1
				end
				Result := (-1)
			end
		end

	ex_compiler (a_eap: CE_POINTER [PD_EXARG])
		local
			l_buf___6: CE_POINTER [NATURAL_8]
			l_old_cur_comp: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_buf___6.make
			create l_old_cur_comp.make
			create l_p___0.make

			l_old_cur_comp.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			if ((a_eap.item.arg).item).to_integer_32 = 0 then
				ex_docmd_inst.do_cmdline_cmd (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("echo globpath(&rtp, %'compiler/*.vim%')"))).do_nothing
			else
				l_buf___6.ce_gets (misc2_inst.alloc ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg))) + {NATURAL_32} 14))
				if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if (a_eap.item.forceit).to_boolean then
						ex_docmd_inst.do_cmdline_cmd (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("command -nargs=* CompilerSet set <args>"))).do_nothing
					else
						l_old_cur_comp.ce_gets (eval_inst.get_var_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("g:current_compiler"))))
						if (l_old_cur_comp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_old_cur_comp.ce_gets (misc2_inst.vim_strsave (l_old_cur_comp))
						end
						ex_docmd_inst.do_cmdline_cmd (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("command -nargs=* CompilerSet setlocal <args>"))).do_nothing
					end
					eval_inst.do_unlet (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("g:current_compiler")), 1).do_nothing
					eval_inst.do_unlet (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("b:current_compiler")), 1).do_nothing
					sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("compiler/%%s.vim"), a_eap.item.arg]).do_nothing
					if (source_runtime (l_buf___6, 1)) = 0 then
						message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E666: compiler not supported: %%s")))), a_eap.item.arg).do_nothing
					end
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
					ex_docmd_inst.do_cmdline_cmd (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (":delcommand CompilerSet"))).do_nothing
					l_p___0.ce_gets (eval_inst.get_var_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("g:current_compiler"))))
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						eval_inst.set_internal_string_var (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("b:current_compiler")), l_p___0)
					end
					if not (a_eap.item.forceit).to_boolean then
						if (l_old_cur_comp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							eval_inst.set_internal_string_var (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("g:current_compiler")), l_old_cur_comp)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_old_cur_comp))
						else
							eval_inst.do_unlet (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("g:current_compiler")), 1).do_nothing
						end
					end
				end
			end
		end

	ex_compiler_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_compiler)
		end

	ex_runtime (a_eap: CE_POINTER [PD_EXARG])
		do
			source_runtime (a_eap.item.arg, a_eap.item.forceit).do_nothing
		end

	ex_runtime_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_runtime)
		end

	source_callback (a_fname: CE_POINTER [NATURAL_8]; a_cookie: CE_POINTER [ANY])
		do
			do_source (a_fname, 0, 0).do_nothing
		end

	source_callback_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent source_callback)
		end

	source_runtime (a_name___1: CE_POINTER [NATURAL_8]; a_all: INTEGER_32): INTEGER_32
		do
			Result := (do_in_runtimepath (a_name___1, a_all, source_callback_address, create {CE_POINTER [ANY]}.make_shared (default_pointer)))
		end

	do_in_runtimepath (a_name___1: CE_POINTER [NATURAL_8]; a_all: INTEGER_32; a_callback: CE_ROUTINE; a_cookie: CE_POINTER [ANY]): INTEGER_32
		local
			l_rtp: CE_POINTER [NATURAL_8]
			l_np: CE_POINTER [NATURAL_8]
			l_buf___6: CE_POINTER [NATURAL_8]
			l_rtp_copy: CE_POINTER [NATURAL_8]
			l_tail: CE_POINTER [NATURAL_8]
			l_num_files: INTEGER_32
			l_files: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_i___0: INTEGER_32
			l_did_one: INTEGER_32
			l_tmp___3: NATURAL_32
			l_tmp___6: INTEGER_32
			js: JUMP_STATE
		do
			create l_rtp.make
			create l_np.make
			create l_buf___6.make
			create l_rtp_copy.make
			create l_tail.make
			create l_files.make

			l_did_one := 0
			l_rtp_copy.ce_gets (misc2_inst.vim_strsave (option_inst.p_rtp))
			l_buf___6.ce_gets (misc2_inst.alloc ({NATURAL_32} 4096))
			if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (l_rtp_copy.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if option_inst.p_verbose > 1 then
						message_inst.verbose_enter
						message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Searching for %"%%s%" in %"%%s%"")))), create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_rtp)]).do_nothing
						message_inst.verbose_leave
					end
					l_rtp.ce_gets (l_rtp_copy)
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_rtp.item).to_integer_32 /= 0 then
							if not a_all.to_boolean then
								if l_did_one.to_boolean then
									js.break
								end
							end
						else
							js.break
						end
						if not js.loop_jumped then
							misc2_inst.copy_option_part (l_rtp.address, l_buf___6, 4096, ce_string (",")).do_nothing
							l_tmp___3 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6))
							if (l_tmp___3 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1)))) + {NATURAL_32} 2 < {NATURAL_32} 4096 then
								misc1_inst.add_pathsep (l_buf___6)
								l_tail.ce_gets (l_buf___6 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6))).to_integer_32)
								l_np.ce_gets (a_name___1)
								from
								until
									js.loop_left
								loop
									js.reset
									if (l_np.item).to_integer_32 /= 0 then
										if not a_all.to_boolean then
											if l_did_one.to_boolean then
												js.break
											end
										end
									else
										js.break
									end
									if not js.loop_jumped then
										misc2_inst.copy_option_part (l_np.address, l_tail, 4096 - (l_tail.distance (l_buf___6)), ce_string ("%T ")).do_nothing
										if option_inst.p_verbose > 2 then
											message_inst.verbose_enter
											message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Searching for %"%%s%"")))), l_buf___6]).do_nothing
											message_inst.verbose_leave
										end
										if (misc1_inst.gen_expand_wildcards (1, l_buf___6.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_num_files), l_files.address, 2)) = 1 then
											l_i___0 := 0
											from
											until
												not (not js.loop_left and then (l_i___0 < l_num_files))
											loop
												js.reset
												a_callback.call ([l_files[l_i___0], a_cookie])
												l_did_one := 1
												if not a_all.to_boolean then
													js.break
												end
												if not js.loop_jumped then
													l_i___0 := l_i___0 + 1
												end
											end
											js.reset
											misc1_inst.FreeWild (l_num_files, l_files)
										end
									end
								end
								js.reset
							end
						end
					end
					js.reset
				end
			end
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_rtp_copy))
			if option_inst.p_verbose > 0 then
				if not l_did_one.to_boolean then
					message_inst.verbose_enter
					message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("not found in %'runtimepath%': %"%%s%"")))), a_name___1]).do_nothing
					message_inst.verbose_leave
				end
			end
			if l_did_one.to_boolean then
				l_tmp___6 := 1
			else
				l_tmp___6 := 0
			end
			Result := l_tmp___6
		end

	ex_options (a_eap: CE_POINTER [PD_EXARG])
		do
			cmd_source (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("$VIMRUNTIME/optwin.vim")), create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer))
		end

	ex_options_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_options)
		end

	ex_source (a_eap: CE_POINTER [PD_EXARG])
		local
			l_fname: CE_POINTER [NATURAL_8]
		do
			create l_fname.make

			if (globals_inst.cmdmod.browse).to_boolean then
				l_fname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				l_fname.ce_gets (message_inst.do_browse (0, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Source Vim script")))), a_eap.item.arg, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vim macro files (*.vim)%T*.vim%NAll Files (*)%T*%N")), create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)))
				if (l_fname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					cmd_source (l_fname, a_eap)
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fname))
				end
			else
				cmd_source (a_eap.item.arg, a_eap)
			end
		end

	ex_source_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_source)
		end

	cmd_source (a_fname: CE_POINTER [NATURAL_8]; a_eap: CE_POINTER [PD_EXARG])
		local
			l_tmp___0: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_fname.item).to_integer_32 /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_argreq))))).do_nothing
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if (a_eap.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (a_eap.item.forceit).to_boolean then
							if globals_inst.global_busy.to_boolean then
								l_tmp___0 := 1
							elseif globals_inst.listcmd_busy.to_boolean then
								l_tmp___0 := 1
							elseif ((a_eap.item.nextcmd).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_tmp___0 := 1
							elseif (a_eap.item.cstack).item.cs_idx >= 0 then
								l_tmp___0 := 1
							else
								l_tmp___0 := 0
							end
							getchar_inst.openscript (a_fname, l_tmp___0)
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if (do_source (a_fname, 0, 0)) = 0 then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notopen)))), a_fname).do_nothing
						end
				when 7 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	source_breakpoint (a_cookie: CE_POINTER [ANY]): CE_POINTER [INTEGER_32]
		do
			Result := (create {CE_POINTER [INTEGER_32]}.make_shared ((create {CE_POINTER [PD_SOURCE_COOKIE]}.make_cast (a_cookie)).c_pointer + {PD_SOURCE_COOKIE}.breakpoint_offset))
		end

	source_dbg_tick (a_cookie: CE_POINTER [ANY]): CE_POINTER [INTEGER_32]
		do
			Result := (create {CE_POINTER [INTEGER_32]}.make_shared ((create {CE_POINTER [PD_SOURCE_COOKIE]}.make_cast (a_cookie)).c_pointer + {PD_SOURCE_COOKIE}.dbg_tick_offset))
		end

	source_level (a_cookie: CE_POINTER [ANY]): INTEGER_32
		do
			Result := ((create {CE_POINTER [PD_SOURCE_COOKIE]}.make_cast (a_cookie)).item.level)
		end

	fopen_noinh_readbin (a_filename: CE_POINTER [INTEGER_8]): CE_POINTER [SD_IO_FILE]
		local
			l_fd_tmp: INTEGER_32
			l_fdflags: INTEGER_32
			js: JUMP_STATE
		do
			l_fd_tmp := (open ([a_filename, 0, 0]))
			if l_fd_tmp = -1 then
				Result := (create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_fdflags := (fcntl ([l_fd_tmp, 1]))
				if l_fdflags >= 0 then
					if ((l_fdflags).bit_and (1)) = 0 then
						fcntl ([l_fd_tmp, 2, (l_fdflags).bit_or (1)]).do_nothing
					end
				end
				Result := (fdopen (l_fd_tmp, ce_string ("r")))
			end
		end

	do_source (a_fname: CE_POINTER [NATURAL_8]; a_check_other: INTEGER_32; a_is_vimrc: INTEGER_32): INTEGER_32
		local
			l_cookie: PD_SOURCE_COOKIE
			l_save_sourcing_name: CE_POINTER [NATURAL_8]
			l_save_sourcing_lnum: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_fname_exp: CE_POINTER [NATURAL_8]
			l_firstline: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
			l_save_current_SID: INTEGER_32
			l_save_funccalp: CE_POINTER [ANY]
			l_save_debug_break_level: INTEGER_32
			l_si: CE_POINTER [PD_SCRIPTITEM_S]
			l_st: SD_STAT
			l_stat_ok: INTEGER_32
			l_tv_rel: SD_TIMEVAL
			l_tv_start: SD_TIMEVAL
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_cookie.make
			create l_save_sourcing_name.make
			create l_p___0.make
			create l_fname_exp.make
			create l_firstline.make
			create l_save_funccalp.make
			create l_si.make
			create l_st.make
			create l_tv_rel.make
			create l_tv_start.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_firstline.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_retval := 0
					l_save_debug_break_level := globals_inst.debug_break_level
					l_si.ce_gets (create {CE_POINTER [PD_SCRIPTITEM_S]}.make_shared (default_pointer))
					l_p___0.ce_gets (misc1_inst.expand_env_save (a_fname))
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := l_retval
						js.return
					end
					if not js.return_called then
						l_fname_exp.ce_gets (buffer_inst.fix_fname (l_p___0))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
						if (l_fname_exp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							Result := l_retval
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 32 -- skip if block
					end
				when 1 then -- if:
						if (os_unix_inst.mch_isdir (l_fname_exp)).to_boolean then
							message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Cannot source a directory: %"%%s%"")))), a_fname]).do_nothing
							l_pos := -1 + 31 -- goto theend
						end
				when 2 then
						if (fileio_inst.has_autocmd ({PC_AUTO_EVENT}.EVENT_SOURCECMD, l_fname_exp, create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))).to_boolean then
							if (fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_SOURCECMD, l_fname_exp, l_fname_exp, 0, globals_inst.curbuf)).to_boolean then
								if (ex_eval_inst.aborting).to_boolean then
									l_retval := 0
								else
									l_retval := 1
								end
								l_pos := -1 + 31 -- goto theend
							end
						end
				when 3 then
						fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_SOURCEPRE, l_fname_exp, l_fname_exp, 0, globals_inst.curbuf).do_nothing
						l_cookie.fp := fopen_noinh_readbin (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname_exp))
						if ((l_cookie.fp).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 17 -- skip if block
						end
				when 4 then -- if:
						if not (a_check_other.to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 5 then -- if:
						l_p___0.ce_gets (misc1_inst.gettail (l_fname_exp))
						if (l_p___0.item).to_integer_32 /= 46 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L___0
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 8 then -- else:
						if (l_p___0.item).to_integer_32 /= 95 then
							l_pos := -1 + 17 -- skip if block
						end
				when 9 then -- if: | _L___0:
						if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 1)), ce_string ("vimrc"))) /= 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 12 then -- else:
						if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 1)), ce_string ("gvimrc"))) /= 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 15 then -- else:
						if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 1)), ce_string ("exrc"))) /= 0 then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L:
						if (l_p___0.item).to_integer_32 = 95 then
							l_p___0.item := (('.').code).to_natural_8
						else
							l_p___0.item := (('_').code).to_natural_8
						end
						l_cookie.fp := fopen_noinh_readbin (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname_exp))
				when 17 then -- if done | if done | if done | if done | if done | if done
						if ((l_cookie.fp).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if option_inst.p_verbose > 0 then
								message_inst.verbose_enter
								if (globals_inst.sourcing_name.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("could not source %"%%s%"")))), a_fname]).do_nothing
								else
									message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("line %%ld: could not source %"%%s%"")))), globals_inst.sourcing_lnum, a_fname]).do_nothing
								end
								message_inst.verbose_leave
							end
							l_pos := -1 + 31 -- goto theend
						end
				when 18 then
						if option_inst.p_verbose > 1 then
							message_inst.verbose_enter
							if (globals_inst.sourcing_name.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("sourcing %"%%s%"")))), a_fname]).do_nothing
							else
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("line %%ld: sourcing %"%%s%"")))), globals_inst.sourcing_lnum, a_fname]).do_nothing
							end
							message_inst.verbose_leave
						end
						if a_is_vimrc = 1 then
							option_inst.vimrc_found (l_fname_exp, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("MYVIMRC")))
						elseif a_is_vimrc = 2 then
							option_inst.vimrc_found (l_fname_exp, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("MYGVIMRC")))
						end
						l_cookie.nextline := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						l_cookie.finished := 0
						l_cookie.breakpoint := dbg_find_breakpoint (1, l_fname_exp, (0).to_integer_32)
						l_cookie.fname := l_fname_exp
						l_cookie.dbg_tick := globals_inst.debug_tick
						l_cookie.level := globals_inst.ex_nesting_level
						l_save_sourcing_name.ce_gets (globals_inst.sourcing_name)
						globals_inst.sourcing_name.ce_gets (l_fname_exp)
						l_save_sourcing_lnum := globals_inst.sourcing_lnum
						globals_inst.sourcing_lnum := (0).to_integer_32
						l_cookie.conv.vc_type := 0
						l_firstline.ce_gets (getsourceline (0, create {CE_POINTER [ANY]}.make_cast ((l_cookie.address)), 0))
						if (l_firstline.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_firstline))) >= {NATURAL_32} 3 then
								if (l_firstline[0]).to_integer_32 = 239 then
									if (l_firstline[1]).to_integer_32 = 187 then
										if (l_firstline[2]).to_integer_32 = 191 then
											mbyte_inst.convert_setup (create {CE_POINTER [PD_VIMCONV_T]}.make_shared (l_cookie.c_pointer + {PD_SOURCE_COOKIE}.conv_offset), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("utf-8")), option_inst.p_enc).do_nothing
											l_p___0.ce_gets (mbyte_inst.string_convert (create {CE_POINTER [PD_VIMCONV_T]}.make_shared (l_cookie.c_pointer + {PD_SOURCE_COOKIE}.conv_offset), l_firstline + 3, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
											if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
												l_p___0.ce_gets (misc2_inst.vim_strsave (l_firstline + 3))
											end
											if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
												misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_firstline))
												l_firstline.ce_gets (l_p___0)
											end
										end
									end
								end
							end
						end
						if (globals_inst.time_fd.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							main_inst.time_push (create {CE_POINTER [ANY]}.make_cast ((l_tv_rel.address)), create {CE_POINTER [ANY]}.make_cast ((l_tv_start.address)))
						end
						l_save_funccalp.ce_gets (eval_inst.save_funccal)
						l_save_current_SID := globals_inst.current_SID
						l_stat_ok := ((stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname_exp), (l_st.address))) >= 0).to_integer
						globals_inst.current_SID := script_items.ga_len
				when 19 then -- loop condition:
						if not (not js.loop_left and then (globals_inst.current_SID > 0)) then
							l_pos := -1 + 26 -- skip loop
						end
				when 20 then -- loop body:
						js.reset
						l_si.ce_gets (create {CE_POINTER [PD_SCRIPTITEM_S]}.make_cast (script_items.ga_data) + (globals_inst.current_SID - 1))
						if ((l_si.item.sn_name).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 25 -- skip if block
						end
				when 21 then -- if:
						if not (l_stat_ok.to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if (l_si.item.sn_dev_valid).to_boolean then
							if l_si.item.sn_dev = l_st.st_dev then
								if l_si.item.sn_ino = l_st.st_ino then
									js.break
								else
									l_pos := -1 + 24 -- goto _L___2
								end
							else
								l_pos := -1 + 24 -- goto _L___2
							end
						else
							l_pos := -1 + 24 -- goto _L___2
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else: | _L___2:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_si.item.sn_name), create {CE_POINTER [INTEGER_8]}.make_cast (l_fname_exp))) = 0 then
							js.break
						end
				when 25 then -- if done
						if not js.loop_jumped then
							globals_inst.current_SID := globals_inst.current_SID - 1
						end
						l_pos := -1 + 19 -- back to loop condition
				when 26 then -- loop done
						js.reset
						if globals_inst.current_SID /= 0 then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						last_current_SID := last_current_SID + 1
						globals_inst.current_SID := last_current_SID
						if (misc2_inst.ga_grow (script_items.address, globals_inst.current_SID - script_items.ga_len)) = 0 then
							l_pos := -1 + 30 -- goto almosttheend
						end
				when 28 then
						from
						until
							not (script_items.ga_len < globals_inst.current_SID)
						loop
							script_items.ga_len := (script_items.ga_len) + 1;
							(create {CE_POINTER [PD_SCRIPTITEM_S]}.make_cast (script_items.ga_data) + (script_items.ga_len - 1)).item.sn_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						end
						l_si.ce_gets (create {CE_POINTER [PD_SCRIPTITEM_S]}.make_cast (script_items.ga_data) + (globals_inst.current_SID - 1))
						l_si.item.sn_name := l_fname_exp
						l_fname_exp.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						if l_stat_ok.to_boolean then
							l_si.item.sn_dev_valid := 1
							l_si.item.sn_dev := l_st.st_dev
							l_si.item.sn_ino := l_st.st_ino
						else
							l_si.item.sn_dev_valid := 0
						end
						eval_inst.new_script_vars (globals_inst.current_SID)
				when 29 then -- if done
						ex_docmd_inst.do_cmdline (l_firstline, getsourceline_address, create {CE_POINTER [ANY]}.make_cast ((l_cookie.address)), 7).do_nothing
						l_retval := 1
						if globals_inst.got_int.to_boolean then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_interr))))).do_nothing
						end
						globals_inst.sourcing_name.ce_gets (l_save_sourcing_name)
						globals_inst.sourcing_lnum := l_save_sourcing_lnum
						if option_inst.p_verbose > 1 then
							message_inst.verbose_enter
							message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("finished sourcing %%s")))), a_fname]).do_nothing
							if (globals_inst.sourcing_name.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("continuing in %%s")))), globals_inst.sourcing_name]).do_nothing
							end
							message_inst.verbose_leave
						end
						if (globals_inst.time_fd.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1025).to_natural_32, ce_string ("sourcing %%s"), a_fname]).do_nothing
							main_inst.time_msg (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), create {CE_POINTER [ANY]}.make_cast ((l_tv_start.address)))
							main_inst.time_pop (create {CE_POINTER [ANY]}.make_cast ((l_tv_rel.address)))
						end
						if l_save_debug_break_level > globals_inst.ex_nesting_level then
							if globals_inst.debug_break_level = globals_inst.ex_nesting_level then
								globals_inst.debug_break_level := globals_inst.debug_break_level + 1
							end
						end
				when 30 then -- almosttheend:
						globals_inst.current_SID := l_save_current_SID
						eval_inst.restore_funccal (l_save_funccalp)
						fclose (l_cookie.fp).do_nothing
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cookie.nextline))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_firstline))
						mbyte_inst.convert_setup (create {CE_POINTER [PD_VIMCONV_T]}.make_shared (l_cookie.c_pointer + {PD_SOURCE_COOKIE}.conv_offset), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
				when 31 then -- theend:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fname_exp))
						Result := l_retval
				when 32 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_scriptnames (a_eap: CE_POINTER [PD_EXARG])
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 1
			from
			until
				js.loop_left
			loop
				js.reset
				if l_i___0 <= script_items.ga_len then
					if globals_inst.got_int.to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if (((create {CE_POINTER [PD_SCRIPTITEM_S]}.make_cast (script_items.ga_data) + (l_i___0 - 1)).item.sn_name).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%%3d: %%s")), l_i___0, (create {CE_POINTER [PD_SCRIPTITEM_S]}.make_cast (script_items.ga_data) + (l_i___0 - 1)).item.sn_name]).do_nothing
					end
					l_i___0 := l_i___0 + 1
				end
			end
			js.reset
		end

	ex_scriptnames_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_scriptnames)
		end

	get_scriptname (a_id: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			js: JUMP_STATE
		do
			if a_id = -1 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("modeline")))))
				js.return
			end
			if not js.return_called and then (a_id = -2) then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("--cmd argument")))))
				js.return
			end
			if not js.return_called and then (a_id = -3) then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("-c argument")))))
				js.return
			end
			if not js.return_called and then (a_id = -4) then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("environment variable")))))
				js.return
			end
			if not js.return_called and then (a_id = -5) then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("error handler")))))
				js.return
			end
			if not js.return_called then
				Result := ((create {CE_POINTER [PD_SCRIPTITEM_S]}.make_cast (script_items.ga_data) + (a_id - 1)).item.sn_name)
			end
		end

	getsourceline (a_c: INTEGER_32; a_cookie: CE_POINTER [ANY]; a_indent: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_sp: CE_POINTER [PD_SOURCE_COOKIE]
			l_line: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_sp.make
			create l_line.make
			create l_p___0.make
			create l_s.make

			l_sp.ce_gets (create {CE_POINTER [PD_SOURCE_COOKIE]}.make_cast (a_cookie))
			if l_sp.item.dbg_tick < globals_inst.debug_tick then
				l_sp.item.breakpoint := dbg_find_breakpoint (1, l_sp.item.fname, globals_inst.sourcing_lnum)
				l_sp.item.dbg_tick := globals_inst.debug_tick
			end
			if (l_sp.item.finished).to_boolean then
				l_line.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			elseif ((l_sp.item.nextline).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_line.ce_gets (get_one_sourceline (l_sp))
			else
				l_line.ce_gets (l_sp.item.nextline)
				l_sp.item.nextline := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				globals_inst.sourcing_lnum := globals_inst.sourcing_lnum + 1
			end
			if (l_line.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('C').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					globals_inst.sourcing_lnum := globals_inst.sourcing_lnum - 1
					from
					until
						js.loop_left
					loop
						js.reset
						l_sp.item.nextline := get_one_sourceline (l_sp)
						if ((l_sp.item.nextline).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						end
						if not js.loop_jumped then
							l_p___0.ce_gets (charset_inst.skipwhite (l_sp.item.nextline))
							if (l_p___0.item).to_integer_32 /= 92 then
								js.break
							end
						end
						if not js.loop_jumped then
							l_tmp := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_line))
							l_s.ce_gets (misc2_inst.alloc (l_tmp + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0)))))
							if (l_s.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.break
							end
						end
						if not js.loop_jumped then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), create {CE_POINTER [INTEGER_8]}.make_cast (l_line)).do_nothing
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 1))).do_nothing
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_line))
							l_line.ce_gets (l_s)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_sp.item.nextline))
						end
					end
					js.reset
				end
			end
			if (l_line.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if l_sp.item.conv.vc_type /= 0 then
					l_s.ce_gets (mbyte_inst.string_convert (create {CE_POINTER [PD_VIMCONV_T]}.make_shared (l_sp.c_pointer + {PD_SOURCE_COOKIE}.conv_offset), l_line, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
					if (l_s.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_line))
						l_line.ce_gets (l_s)
					end
				end
			end
			if l_sp.item.breakpoint /= 0 then
				if l_sp.item.breakpoint <= globals_inst.sourcing_lnum then
					dbg_breakpoint (l_sp.item.fname, globals_inst.sourcing_lnum)
					l_sp.item.breakpoint := dbg_find_breakpoint (1, l_sp.item.fname, globals_inst.sourcing_lnum)
					l_sp.item.dbg_tick := globals_inst.debug_tick
				end
			end
			Result := l_line
		end

	getsourceline_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent getsourceline)
		end

	get_one_sourceline (a_sp: CE_POINTER [PD_SOURCE_COOKIE]): CE_POINTER [NATURAL_8]
		local
			l_ga: PD_GROWARRAY
			l_len: INTEGER_32
			l_c: INTEGER_32
			l_buf___6: CE_POINTER [NATURAL_8]
			l_have_read: INTEGER_32
			js: JUMP_STATE
		do
			create l_ga.make
			create l_buf___6.make

			l_have_read := 0
			misc2_inst.ga_init2 (l_ga.address, 1, 250)
			globals_inst.sourcing_lnum := globals_inst.sourcing_lnum + 1
			from
			until
				js.loop_left
			loop
				js.reset
				if (misc2_inst.ga_grow (l_ga.address, 120)) = 0 then
					js.break
				end
				if not js.loop_jumped then
					l_buf___6.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.ga_data))
					if ((fgets ((create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6) + l_ga.ga_len), l_ga.ga_maxlen - l_ga.ga_len, a_sp.item.fp)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.break
					end
				end
				if not js.loop_jumped then
					l_len := l_ga.ga_len + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_buf___6 + l_ga.ga_len)))).to_integer_32
					l_have_read := 1
					l_ga.ga_len := l_len
					if l_ga.ga_maxlen - l_ga.ga_len = 1 then
						if (l_buf___6[(l_len - 1)]).to_integer_32 /= 10 then
							js.continue
						end
					end
				end
				if not js.loop_jumped and then (l_len >= 1) then
					if (l_buf___6[(l_len - 1)]).to_integer_32 = 10 then
						l_c := l_len - 2
						from
						until
							js.loop_left
						loop
							js.reset
							if l_c >= 0 then
								if (l_buf___6[l_c]).to_integer_32 /= 22 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_c := l_c - 1
							end
						end
						js.reset
						if ((l_len).bit_and (1)) /= ((l_c).bit_and (1)) then
							globals_inst.sourcing_lnum := globals_inst.sourcing_lnum + 1
							js.continue
						end
						if not js.loop_jumped then
							l_buf___6[(l_len - 1)] := (('%/0/').code).to_natural_8
						end
					end
				end
				if not js.loop_jumped then
					misc1_inst.line_breakcheck
					js.break
				end
				if not js.loop_left then
					
				end
			end
			js.reset
			if l_have_read.to_boolean then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.ga_data))
				js.return
			end
			if not js.return_called then
				misc2_inst.vim_free (l_ga.ga_data)
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	ex_scriptencoding (a_eap: CE_POINTER [PD_EXARG])
		local
			l_sp: CE_POINTER [PD_SOURCE_COOKIE]
			l_name___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_sp.make
			create l_name___1.make

			if not (ex_docmd_inst.getline_equal (a_eap.item.getline, a_eap.item.cookie, getsourceline_address)).to_boolean then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E167: :scriptencoding used outside of a sourced file"))))).do_nothing
				js.return
			end
			if not js.return_called then
				if ((a_eap.item.arg).item).to_integer_32 /= 0 then
					l_name___1.ce_gets (mbyte_inst.enc_canonize (a_eap.item.arg))
					if (l_name___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.return
					end
				else
					l_name___1.ce_gets (a_eap.item.arg)
				end
			end
			if not js.return_called then
				l_sp.ce_gets (create {CE_POINTER [PD_SOURCE_COOKIE]}.make_cast ((ex_docmd_inst.getline_cookie (a_eap.item.getline, a_eap.item.cookie))))
				mbyte_inst.convert_setup (create {CE_POINTER [PD_VIMCONV_T]}.make_shared (l_sp.c_pointer + {PD_SOURCE_COOKIE}.conv_offset), l_name___1, option_inst.p_enc).do_nothing
				if (l_name___1.c_pointer.to_integer_32).to_natural_32 /= ((a_eap.item.arg).c_pointer.to_integer_32).to_natural_32 then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_name___1))
				end
			end
		end

	ex_scriptencoding_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_scriptencoding)
		end

	ex_finish (a_eap: CE_POINTER [PD_EXARG])
		do
			if (ex_docmd_inst.getline_equal (a_eap.item.getline, a_eap.item.cookie, getsourceline_address)).to_boolean then
				do_finish (a_eap, 0)
			else
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E168: :finish used outside of a sourced file"))))).do_nothing
			end
		end

	ex_finish_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_finish)
		end

	do_finish (a_eap: CE_POINTER [PD_EXARG]; a_reanimate: INTEGER_32)
		local
			l_idx: INTEGER_32
		do
			if a_reanimate.to_boolean then
				(create {CE_POINTER [PD_SOURCE_COOKIE]}.make_cast ((ex_docmd_inst.getline_cookie (a_eap.item.getline, a_eap.item.cookie)))).item.finished := 0
			end
			l_idx := ex_eval_inst.cleanup_conditionals (a_eap.item.cstack, 0, 1)
			if l_idx >= 0 then
				(a_eap.item.cstack).item.cs_pending[l_idx] := (32).to_integer_8
				ex_eval_inst.report_make_pending (32, create {CE_POINTER [ANY]}.make_shared (default_pointer))
			else
				(create {CE_POINTER [PD_SOURCE_COOKIE]}.make_cast ((ex_docmd_inst.getline_cookie (a_eap.item.getline, a_eap.item.cookie)))).item.finished := 1
			end
		end

	source_finished (a_fgetline: CE_ROUTINE; a_cookie: CE_POINTER [ANY]): INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if (ex_docmd_inst.getline_equal (a_fgetline, a_cookie, getsourceline_address)).to_boolean then
				if ((create {CE_POINTER [PD_SOURCE_COOKIE]}.make_cast ((ex_docmd_inst.getline_cookie (a_fgetline, a_cookie)))).item.finished).to_boolean then
					l_tmp___1 := 1
				else
					l_tmp___1 := 0
				end
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	ex_checktime (a_eap: CE_POINTER [PD_EXARG])
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_save_no_check_timestamps: INTEGER_32
		do
			create l_buf___6.make

			l_save_no_check_timestamps := globals_inst.no_check_timestamps
			globals_inst.no_check_timestamps := 0
			if a_eap.item.addr_count = 0 then
				fileio_inst.check_timestamps (0).do_nothing
			else
				l_buf___6.ce_gets (buffer_inst.buflist_findnr ((a_eap.item.line2).to_integer_32))
				if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					fileio_inst.buf_check_timestamp (l_buf___6, 0).do_nothing
				end
			end
			globals_inst.no_check_timestamps := l_save_no_check_timestamps
		end

	ex_checktime_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_checktime)
		end

	get_locale_val (a_what: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_loc: CE_POINTER [INTEGER_8]
		do
			create l_loc.make

			l_loc.ce_gets (setlocale (a_what, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)))
			Result := l_loc
		end

	get_mess_lang: CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make

			l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((get_locale_val (5))))
			Result := l_p___0
		end

	set_lang_var
		local
			l_loc: CE_POINTER [NATURAL_8]
		do
			create l_loc.make

			l_loc.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((get_locale_val (0))))
			eval_inst.set_vim_var_string (14, l_loc, -1)
			l_loc.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((get_locale_val (5))))
			eval_inst.set_vim_var_string (12, l_loc, -1)
			l_loc.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((get_locale_val (2))))
			eval_inst.set_vim_var_string (13, l_loc, -1)
		end

	ex_language (a_eap: CE_POINTER [PD_EXARG])
		local
			l_loc: CE_POINTER [INTEGER_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_name___1: CE_POINTER [NATURAL_8]
			l_what: INTEGER_32
			l_whatstr: CE_POINTER [INTEGER_8]
			l_mname: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_loc.make
			create l_p___0.make
			create l_name___1.make
			create l_whatstr.make
			create l_mname.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_what := 6
					l_whatstr.ce_gets (ce_string (""))
					l_name___1.ce_gets (a_eap.item.arg)
					l_p___0.ce_gets (charset_inst.skiptowhite (a_eap.item.arg))
					if (l_p___0.item).to_integer_32 /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if (l_p___0.item).to_integer_32 /= 32 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if (l_p___0.item).to_integer_32 /= 9 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L___0:
						if l_p___0.distance ((a_eap.item.arg)) >= 3 then
							if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg), ce_string ("messages"), (l_p___0.distance ((a_eap.item.arg))).to_natural_32)) = 0 then
								l_what := 5
								l_name___1.ce_gets (charset_inst.skipwhite (l_p___0))
								l_whatstr.ce_gets (ce_string ("messages "))
							elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg), ce_string ("ctype"), (l_p___0.distance ((a_eap.item.arg))).to_natural_32)) = 0 then
								l_what := 0
								l_name___1.ce_gets (charset_inst.skipwhite (l_p___0))
								l_whatstr.ce_gets (ce_string ("ctype "))
							elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg), ce_string ("time"), (l_p___0.distance ((a_eap.item.arg))).to_natural_32)) = 0 then
								l_what := 2
								l_name___1.ce_gets (charset_inst.skipwhite (l_p___0))
								l_whatstr.ce_gets (ce_string ("time "))
							end
						end
				when 8 then -- if done | if done
						if (l_name___1.item).to_integer_32 = 0 then
							l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((setlocale (l_what, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)))))
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Unknown")))
							elseif (l_p___0.item).to_integer_32 = 0 then
								l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Unknown")))
							end
							message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Current %%slanguage: %"%%s%"")))), l_whatstr, l_p___0]).do_nothing
						else
							l_loc.ce_gets (setlocale (l_what, create {CE_POINTER [INTEGER_8]}.make_cast (l_name___1)))
							setlocale (1, ce_string ("C")).do_nothing
							if (l_loc.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E197: Cannot set language to %"%%s%"")))), l_name___1).do_nothing
							else
								Current.nl_msg_cat_cntr := nl_msg_cat_cntr + 1
								misc1_inst.vim_setenv (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("LC_ALL")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
								if l_what /= 2 then
									if l_what = 6 then
										misc1_inst.vim_setenv (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("LANG")), l_name___1)
									end
									if l_what /= 0 then
										l_mname.ce_gets (l_name___1)
										misc1_inst.vim_setenv (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("LC_MESSAGES")), l_mname)
										option_inst.set_helplang_default (l_mname)
									end
								end
								set_lang_var
							end
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_language_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_language)
		end

	get_lang_arg (a_xp: CE_POINTER [PD_EXPAND]; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			js: JUMP_STATE
		do
			if a_idx = 0 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("messages")))
				js.return
			end
			if not js.return_called and then (a_idx = 1) then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ctype")))
				js.return
			end
			if not js.return_called and then (a_idx = 2) then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("time")))
				js.return
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	get_lang_arg_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent get_lang_arg)
		end

end
