class
	P_FOLD

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create e_nofold.make
			create foldendmarker.make
		end

feature {ANY} -- attributes

	e_nofold: CE_POINTER [INTEGER_8]

	invalid_top: INTEGER_32 assign set_invalid_top

	set_invalid_top (a_invalid_top: INTEGER_32)
		do
			invalid_top := a_invalid_top
		end

	invalid_bot: INTEGER_32 assign set_invalid_bot

	set_invalid_bot (a_invalid_bot: INTEGER_32)
		do
			invalid_bot := a_invalid_bot
		end

	prev_lnum___0: INTEGER_32 assign set_prev_lnum___0

	set_prev_lnum___0 (a_prev_lnum___0: INTEGER_32)
		do
			prev_lnum___0 := a_prev_lnum___0
		end

	prev_lnum_lvl: INTEGER_32 assign set_prev_lnum_lvl

	set_prev_lnum_lvl (a_prev_lnum_lvl: INTEGER_32)
		do
			prev_lnum_lvl := a_prev_lnum_lvl
		end

	foldstartmarkerlen: INTEGER_32 assign set_foldstartmarkerlen

	set_foldstartmarkerlen (a_foldstartmarkerlen: INTEGER_32)
		do
			foldstartmarkerlen := a_foldstartmarkerlen
		end

	foldendmarker: CE_POINTER [NATURAL_8]

	foldendmarkerlen: INTEGER_32 assign set_foldendmarkerlen

	set_foldendmarkerlen (a_foldendmarkerlen: INTEGER_32)
		do
			foldendmarkerlen := a_foldendmarkerlen
		end

	fold_changed: INTEGER_32 assign set_fold_changed

	set_fold_changed (a_fold_changed: INTEGER_32)
		do
			fold_changed := a_fold_changed
		end

feature {ANY} -- routines

	copyFoldingState (a_wp_from: CE_POINTER [PD_WINDOW_S]; a_wp_to: CE_POINTER [PD_WINDOW_S])
		do
			a_wp_to.item.w_fold_manual := a_wp_from.item.w_fold_manual
			a_wp_to.item.w_foldinvalid := a_wp_from.item.w_foldinvalid
			cloneFoldGrowArray (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_wp_from.c_pointer + {PD_WINDOW_S}.w_folds_offset), create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_wp_to.c_pointer + {PD_WINDOW_S}.w_folds_offset))
		end

	hasAnyFolding (a_win: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (a_win.item.w_onebuf_opt.wo_fen).to_boolean then
				if (foldmethodIsManual (a_win)).to_boolean then
					if a_win.item.w_folds.ga_len > 0 then
						l_tmp___0 := 1
					else
						l_tmp___0 := 0
					end
				else
					l_tmp___0 := 1
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	hasFolding (a_lnum: INTEGER_32; a_firstp: CE_POINTER [INTEGER_32]; a_lastp: CE_POINTER [INTEGER_32]): INTEGER_32
		do
			Result := (hasFoldingWin (globals_inst.curwin, a_lnum, a_firstp, a_lastp, 1, create {CE_POINTER [PD_FOLDINFO]}.make_shared (default_pointer)))
		end

	hasFoldingWin (a_win: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32; a_firstp: CE_POINTER [INTEGER_32]; a_lastp: CE_POINTER [INTEGER_32]; a_cache: INTEGER_32; a_infop: CE_POINTER [PD_FOLDINFO]): INTEGER_32
		local
			l_had_folded: INTEGER_32
			l_first___0: INTEGER_32
			l_last: INTEGER_32
			l_lnum_rel: INTEGER_32
			l_x___0: INTEGER_32
			l_fp: CE_POINTER [PD_FOLD_T]
			l_level: INTEGER_32
			l_use_level: INTEGER_32
			l_maybe_small: INTEGER_32
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_low_level: INTEGER_32
			js: JUMP_STATE
		do
			create l_fp.make
			create l_gap.make

			l_had_folded := 0
			l_first___0 := (0).to_integer_32
			l_last := (0).to_integer_32
			l_lnum_rel := a_lnum
			l_level := 0
			l_use_level := 0
			l_maybe_small := 0
			l_low_level := 0
			checkupdate (a_win)
			if not (hasAnyFolding (a_win)).to_boolean then
				if (a_infop.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					a_infop.item.fi_level := 0
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				if a_cache.to_boolean then
					l_x___0 := find_wl_entry (a_win, a_lnum)
					if l_x___0 >= 0 then
						l_first___0 := (a_win.item.w_lines + l_x___0).item.wl_lnum
						l_last := (a_win.item.w_lines + l_x___0).item.wl_lastlnum
						l_had_folded := ((a_win.item.w_lines + l_x___0).item.wl_folded).to_integer_32
					end
				end
				if l_first___0 = 0 then
					l_gap.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_win.c_pointer + {PD_WINDOW_S}.w_folds_offset))
					from
					until
						js.loop_left
					loop
						js.reset
						if not (foldFind (l_gap, l_lnum_rel, l_fp.address)).to_boolean then
							js.break
						end
						if not js.loop_jumped then
							if l_lnum_rel = l_fp.item.fd_top then
								if l_low_level = 0 then
									l_low_level := l_level + 1
								end
							end
							l_first___0 := l_first___0 + (l_fp.item.fd_top)
							l_last := l_last + (l_fp.item.fd_top)
							l_had_folded := check_closed (a_win, l_fp, create {CE_POINTER [INTEGER_32]}.make_shared ($l_use_level), l_level, create {CE_POINTER [INTEGER_32]}.make_shared ($l_maybe_small), a_lnum - l_lnum_rel)
							if l_had_folded.to_boolean then
								l_last := l_last + (l_fp.item.fd_len - 1)
								js.break
							end
						end
						if not js.loop_jumped then
							l_gap.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + {PD_FOLD_T}.fd_nested_offset))
							l_lnum_rel := l_lnum_rel - (l_fp.item.fd_top)
							l_level := l_level + 1
						end
					end
					js.reset
				end
				if not l_had_folded.to_boolean then
					if (a_infop.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						a_infop.item.fi_level := l_level
						a_infop.item.fi_lnum := (a_lnum - l_lnum_rel).to_integer_32
						if l_low_level = 0 then
							a_infop.item.fi_low_level := l_level
						else
							a_infop.item.fi_low_level := l_low_level
						end
					end
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if (a_lastp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					a_lastp.item := l_last
				end
				if (a_firstp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					a_firstp.item := l_first___0
				end
				if (a_infop.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					a_infop.item.fi_level := l_level + 1
					a_infop.item.fi_lnum := l_first___0.to_integer_32
					if l_low_level = 0 then
						a_infop.item.fi_low_level := l_level + 1
					else
						a_infop.item.fi_low_level := l_low_level
					end
				end
				Result := 1
			end
		end

	foldLevel (a_lnum: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if invalid_top /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						checkupdate (globals_inst.curwin)
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_lnum /= prev_lnum___0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if prev_lnum_lvl >= 0 then
							Result := prev_lnum_lvl
							js.return
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if a_lnum >= invalid_top then
							if a_lnum <= invalid_bot then
								Result := (-1)
								js.return
							end
						end
				when 7 then -- if done
						if not js.return_called then
							if not (hasAnyFolding (globals_inst.curwin)).to_boolean then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							Result := (foldLevelWin (globals_inst.curwin, a_lnum))
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	lineFolded (a_win: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32): INTEGER_32
		do
			Result := ((foldedCount (a_win, a_lnum, create {CE_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))) /= 0).to_integer
		end

	foldedCount (a_win: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32; a_infop: CE_POINTER [PD_FOLDINFO]): INTEGER_32
		local
			l_last: INTEGER_32
			js: JUMP_STATE
		do
			if (hasFoldingWin (a_win, a_lnum, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_last), 0, a_infop)).to_boolean then
				Result := ((l_last - a_lnum) + 1)
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	foldmethodIsManual (a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		do
			Result := ((a_wp___0.item.w_onebuf_opt.wo_fdm[3]).to_integer_32 = 117).to_integer
		end

	foldmethodIsIndent (a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		do
			Result := ((a_wp___0.item.w_onebuf_opt.wo_fdm[0]).to_integer_32 = 105).to_integer
		end

	foldmethodIsExpr (a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		do
			Result := ((a_wp___0.item.w_onebuf_opt.wo_fdm[1]).to_integer_32 = 120).to_integer
		end

	foldmethodIsMarker (a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		do
			Result := ((a_wp___0.item.w_onebuf_opt.wo_fdm[2]).to_integer_32 = 114).to_integer
		end

	foldmethodIsSyntax (a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		do
			Result := ((a_wp___0.item.w_onebuf_opt.wo_fdm[0]).to_integer_32 = 115).to_integer
		end

	foldmethodIsDiff (a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		do
			Result := ((a_wp___0.item.w_onebuf_opt.wo_fdm[0]).to_integer_32 = 100).to_integer
		end

	closeFold (a_lnum: INTEGER_32; a_count___2: INTEGER_32)
		do
			setFoldRepeat (a_lnum, a_count___2, 0)
		end

	closeFoldRecurse (a_lnum: INTEGER_32)
		do
			setManualFold (a_lnum, 0, 1, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)).do_nothing
		end

	opFoldRange (a_first___0: INTEGER_32; a_last: INTEGER_32; a_opening: INTEGER_32; a_recurse___2: INTEGER_32; a_had_visual: INTEGER_32)
		local
			l_done___2: INTEGER_32
			l_lnum: INTEGER_32
			l_lnum_next: INTEGER_32
		do
			l_done___2 := 0
			l_lnum := a_first___0
			from
			until
				not (l_lnum <= a_last)
			loop
				l_lnum_next := l_lnum
				if a_opening.to_boolean then
					if not a_recurse___2.to_boolean then
						hasFolding (l_lnum, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_lnum_next)).do_nothing
					end
				end
				setManualFold (l_lnum, a_opening, a_recurse___2, create {CE_POINTER [INTEGER_32]}.make_shared ($l_done___2)).do_nothing
				if not a_opening.to_boolean then
					if not a_recurse___2.to_boolean then
						hasFolding (l_lnum, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_lnum_next)).do_nothing
					end
				end
				l_lnum := l_lnum_next + 1
			end
			if l_done___2 = 0 then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (e_nofold)))).do_nothing
			end
			if a_had_visual.to_boolean then
				screen_inst.redraw_curbuf_later (20)
			end
		end

	openFold (a_lnum: INTEGER_32; a_count___2: INTEGER_32)
		do
			setFoldRepeat (a_lnum, a_count___2, 1)
		end

	openFoldRecurse (a_lnum: INTEGER_32)
		do
			setManualFold (a_lnum, 1, 1, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)).do_nothing
		end

	foldOpenCursor
		local
			l_done___2: INTEGER_32
			js: JUMP_STATE
		do
			checkupdate (globals_inst.curwin)
			if (hasAnyFolding (globals_inst.curwin)).to_boolean then
				from
				until
					js.loop_left
				loop
					js.reset
					l_done___2 := 0
					setManualFold (globals_inst.curwin.item.w_cursor.lnum, 1, 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_done___2)).do_nothing
					if not ((l_done___2).bit_and (1)).to_boolean then
						js.break
					end
				end
				js.reset
			end
		end

	newFoldLevel
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
		do
			create l_wp___0.make

			newFoldLevelWin (globals_inst.curwin)
			if (foldmethodIsDiff (globals_inst.curwin)).to_boolean then
				if (globals_inst.curwin.item.w_onebuf_opt.wo_scb).to_boolean then
					l_wp___0.ce_gets (globals_inst.firstwin)
					from
					until
						(l_wp___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
					loop
						if (l_wp___0.c_pointer.to_integer_32).to_natural_32 /= (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 then
							if (foldmethodIsDiff (l_wp___0)).to_boolean then
								if (l_wp___0.item.w_onebuf_opt.wo_scb).to_boolean then
									l_wp___0.item.w_onebuf_opt.wo_fdl := globals_inst.curwin.item.w_onebuf_opt.wo_fdl
									newFoldLevelWin (l_wp___0)
								end
							end
						end
						l_wp___0.ce_gets (l_wp___0.item.w_next)
					end
				end
			end
		end

	newFoldLevelWin (a_wp___0: CE_POINTER [PD_WINDOW_S])
		local
			l_fp: CE_POINTER [PD_FOLD_T]
			l_i___0: INTEGER_32
		do
			create l_fp.make

			checkupdate (a_wp___0)
			if (a_wp___0.item.w_fold_manual).to_boolean then
				l_fp.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_cast (a_wp___0.item.w_folds.ga_data))
				l_i___0 := 0
				from
				until
					not (l_i___0 < a_wp___0.item.w_folds.ga_len)
				loop
					(l_fp + l_i___0).item.fd_flags := (2).to_integer_8
					l_i___0 := l_i___0 + 1
				end
				a_wp___0.item.w_fold_manual := (0).to_integer_8
			end
			move_inst.changed_window_setting_win (a_wp___0)
		end

	foldCheckClose
		do
			if (option_inst.p_fcl.item).to_integer_32 /= 0 then
				checkupdate (globals_inst.curwin)
				if (checkCloseRec (create {CE_POINTER [PD_GROWARRAY]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_folds_offset), globals_inst.curwin.item.w_cursor.lnum, (globals_inst.curwin.item.w_onebuf_opt.wo_fdl).to_integer_32)).to_boolean then
					move_inst.changed_window_setting
				end
			end
		end

	checkCloseRec (a_gap: CE_POINTER [PD_GROWARRAY]; a_lnum: INTEGER_32; a_level: INTEGER_32): INTEGER_32
		local
			l_fp: CE_POINTER [PD_FOLD_T]
			l_retval: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
		do
			create l_fp.make

			l_retval := 0
			l_fp.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data))
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_gap.item.ga_len)
			loop
				if ((l_fp + l_i___0).item.fd_flags).to_integer_32 = 0 then
					if a_level <= 0 then
						if a_lnum < (l_fp + l_i___0).item.fd_top then
							(l_fp + l_i___0).item.fd_flags := (2).to_integer_8
							l_retval := 1
						elseif a_lnum >= (l_fp + l_i___0).item.fd_top + (l_fp + l_i___0).item.fd_len then
							(l_fp + l_i___0).item.fd_flags := (2).to_integer_8
							l_retval := 1
						else
							l_tmp := checkCloseRec (create {CE_POINTER [PD_GROWARRAY]}.make_shared ((l_fp + l_i___0).c_pointer + {PD_FOLD_T}.fd_nested_offset), a_lnum - (l_fp + l_i___0).item.fd_top, a_level - 1)
							l_retval := (l_retval).bit_or (l_tmp)
						end
					else
						l_tmp := checkCloseRec (create {CE_POINTER [PD_GROWARRAY]}.make_shared ((l_fp + l_i___0).c_pointer + {PD_FOLD_T}.fd_nested_offset), a_lnum - (l_fp + l_i___0).item.fd_top, a_level - 1)
						l_retval := (l_retval).bit_or (l_tmp)
					end
				end
				l_i___0 := l_i___0 + 1
			end
			Result := l_retval
		end

	foldManualAllowed (a_create: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (foldmethodIsManual (globals_inst.curwin)).to_boolean then
				Result := 1
				js.return
			elseif (foldmethodIsMarker (globals_inst.curwin)).to_boolean then
				Result := 1
				js.return
			end
			if not js.return_called then
				if a_create.to_boolean then
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E350: Cannot create fold with current %'foldmethod%'"))))).do_nothing
				else
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E351: Cannot delete fold with current %'foldmethod%'"))))).do_nothing
				end
				Result := 0
			end
		end

	foldCreate (a_start___1: INTEGER_32; a_end: INTEGER_32)
		local
			l_start___1: INTEGER_32
			l_end: INTEGER_32
			l_fp: CE_POINTER [PD_FOLD_T]
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_fold_ga: PD_GROWARRAY
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_cont: INTEGER_32
			l_use_level: INTEGER_32
			l_closed: INTEGER_32
			l_level: INTEGER_32
			l_start_rel: INTEGER_32
			l_end_rel: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fp.make
			create l_gap.make
			create l_fold_ga.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_start___1 := a_start___1
					l_end := a_end
					l_use_level := 0
					l_closed := 0
					l_level := 0
					l_start_rel := l_start___1
					l_end_rel := l_end
					if l_start___1 > l_end then
						l_end := l_start_rel
						l_start___1 := l_end_rel
						l_start_rel := l_start___1
						l_end_rel := l_end
					end
					if (foldmethodIsMarker (globals_inst.curwin)).to_boolean then
						foldCreateMarkers (l_start___1, l_end)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 17 -- skip if block
					end
				when 1 then -- if:
						checkupdate (globals_inst.curwin)
						l_gap.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_folds_offset))
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 16 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if not (foldFind (l_gap, l_start_rel, l_fp.address)).to_boolean then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 15 -- skip if block
						end
				when 4 then -- if:
						if not (l_fp.item.fd_top + l_fp.item.fd_len > l_end_rel) then
							l_pos := -1 + 14 -- skip if block
						end
				when 5 then -- if:
						l_gap.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + {PD_FOLD_T}.fd_nested_offset))
						l_start_rel := l_start_rel - (l_fp.item.fd_top)
						l_end_rel := l_end_rel - (l_fp.item.fd_top)
						if not (l_use_level.to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 8 then -- else:
						if (l_fp.item.fd_flags).to_integer_32 /= 2 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if: | _L:
						l_use_level := 1
						if l_level.to_integer_32 >= globals_inst.curwin.item.w_onebuf_opt.wo_fdl then
							l_closed := 1
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						if (l_fp.item.fd_flags).to_integer_32 = 1 then
							l_closed := 1
						end
				when 12 then -- if done
						l_level := l_level + 1
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						js.break
				when 15 then -- if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 16 then -- loop done
						js.reset
						l_i___0 := l_fp.distance ((create {CE_POINTER [PD_FOLD_T]}.make_cast (l_gap.item.ga_data)))
						if (misc2_inst.ga_grow (l_gap, 1)) = 1 then
							l_fp.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_cast (l_gap.item.ga_data) + l_i___0)
							misc2_inst.ga_init2 (l_fold_ga.address, ({PD_FOLD_T}.sizeof.to_natural_32).to_integer_32, 10)
							l_cont := 0
							from
							until
								not (not js.loop_left and then (l_i___0 + l_cont < l_gap.item.ga_len))
							loop
								js.reset
								if (l_fp + l_cont).item.fd_top > l_end_rel then
									js.break
								end
								if not js.loop_jumped then
									l_cont := l_cont + 1
								end
							end
							js.reset
							if l_cont > 0 then
								if (misc2_inst.ga_grow (l_fold_ga.address, l_cont)) = 1 then
									if l_start_rel > l_fp.item.fd_top then
										l_start_rel := l_fp.item.fd_top
									end
									if l_end_rel < ((l_fp + (l_cont - 1)).item.fd_top + (l_fp + (l_cont - 1)).item.fd_len) - 1 then
										l_end_rel := ((l_fp + (l_cont - 1)).item.fd_top + (l_fp + (l_cont - 1)).item.fd_len) - 1
									end
									memmove (l_fold_ga.ga_data, create {CE_POINTER [ANY]}.make_cast (l_fp), {PD_FOLD_T}.sizeof.to_natural_32 * l_cont.to_natural_32).do_nothing
									l_fold_ga.ga_len := l_fold_ga.ga_len + l_cont
									l_i___0 := l_i___0 + l_cont
									l_j := 0
									from
									until
										not (l_j < l_cont)
									loop
										(create {CE_POINTER [PD_FOLD_T]}.make_cast (l_fold_ga.ga_data) + l_j).item.fd_top := (create {CE_POINTER [PD_FOLD_T]}.make_cast (l_fold_ga.ga_data) + l_j).item.fd_top - l_start_rel
										l_j := l_j + 1
									end
								end
							end
							if l_i___0 < l_gap.item.ga_len then
								memmove (create {CE_POINTER [ANY]}.make_cast ((l_fp + 1)), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_FOLD_T]}.make_cast (l_gap.item.ga_data) + l_i___0)), {PD_FOLD_T}.sizeof.to_natural_32 * (l_gap.item.ga_len - l_i___0).to_natural_32).do_nothing
							end
							l_gap.item.ga_len := (l_gap.item.ga_len + 1) - l_cont
							l_fp.item.fd_nested := l_fold_ga
							l_fp.item.fd_top := l_start_rel
							l_fp.item.fd_len := (l_end_rel - l_start_rel) + 1
							if l_use_level.to_boolean then
								if not l_closed.to_boolean then
									if l_level.to_integer_32 < globals_inst.curwin.item.w_onebuf_opt.wo_fdl then
										closeFold (l_start___1, 1)
									end
								end
							end
							if not l_use_level.to_boolean then
								globals_inst.curwin.item.w_fold_manual := (1).to_integer_8
							end
							l_fp.item.fd_flags := (1).to_integer_8
							l_fp.item.fd_small := (2).to_integer_8
							move_inst.changed_window_setting
						end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	deleteFold (a_start___1: INTEGER_32; a_end: INTEGER_32; a_recursive___12: INTEGER_32; a_had_visual: INTEGER_32)
		local
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_fp: CE_POINTER [PD_FOLD_T]
			l_found_ga: CE_POINTER [PD_GROWARRAY]
			l_found_fp: CE_POINTER [PD_FOLD_T]
			l_found_off: INTEGER_32
			l_use_level: INTEGER_32
			l_maybe_small: INTEGER_32
			l_level: INTEGER_32
			l_lnum: INTEGER_32
			l_lnum_off: INTEGER_32
			l_did_one: INTEGER_32
			l_first_lnum: INTEGER_32
			l_last_lnum: INTEGER_32
			js: JUMP_STATE
		do
			create l_gap.make
			create l_fp.make
			create l_found_ga.make
			create l_found_fp.make

			l_found_fp.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_shared (default_pointer))
			l_found_off := (0).to_integer_32
			l_maybe_small := 0
			l_level := 0
			l_lnum := a_start___1
			l_did_one := 0
			l_first_lnum := 2147483647
			l_last_lnum := (0).to_integer_32
			checkupdate (globals_inst.curwin)
			from
			until
				not (not js.loop_left and then (l_lnum <= a_end))
			loop
				l_gap.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_folds_offset))
				l_found_ga.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared (default_pointer))
				l_lnum_off := (0).to_integer_32
				l_use_level := 0
				from
				until
					js.loop_left
				loop
					js.reset
					if not (foldFind (l_gap, l_lnum - l_lnum_off, l_fp.address)).to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_found_ga.ce_gets (l_gap)
						l_found_fp.ce_gets (l_fp)
						l_found_off := l_lnum_off
						if (check_closed (globals_inst.curwin, l_fp, create {CE_POINTER [INTEGER_32]}.make_shared ($l_use_level), l_level, create {CE_POINTER [INTEGER_32]}.make_shared ($l_maybe_small), l_lnum_off)).to_boolean then
							js.break
						end
					end
					if not js.loop_jumped then
						l_gap.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + {PD_FOLD_T}.fd_nested_offset))
						l_lnum_off := l_lnum_off + (l_fp.item.fd_top)
						l_level := l_level + 1
					end
				end
				js.reset
				if (l_found_ga.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_lnum := l_lnum + 1
				else
					l_lnum := (l_found_fp.item.fd_top + l_found_fp.item.fd_len) + l_found_off
					if (foldmethodIsManual (globals_inst.curwin)).to_boolean then
						deleteFoldEntry (l_found_ga, l_found_fp.distance ((create {CE_POINTER [PD_FOLD_T]}.make_cast (l_found_ga.item.ga_data))), a_recursive___12)
					else
						if l_first_lnum > l_found_fp.item.fd_top + l_found_off then
							l_first_lnum := l_found_fp.item.fd_top + l_found_off
						end
						if l_last_lnum < l_lnum then
							l_last_lnum := l_lnum
						end
						if not l_did_one.to_boolean then
							parseMarker (globals_inst.curwin)
						end
						deleteFoldMarkers (l_found_fp, a_recursive___12, l_found_off)
					end
					l_did_one := 1
					move_inst.changed_window_setting
				end
			end
			if not l_did_one.to_boolean then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (e_nofold)))).do_nothing
				if a_had_visual.to_boolean then
					screen_inst.redraw_curbuf_later (20)
				end
			else
				misc2_inst.check_cursor_col
			end
			if l_last_lnum > 0 then
				misc1_inst.changed_lines (l_first_lnum, 0, l_last_lnum, 0)
			end
		end

	clearFolding (a_win: CE_POINTER [PD_WINDOW_S])
		do
			deleteFoldRecurse (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_win.c_pointer + {PD_WINDOW_S}.w_folds_offset))
			a_win.item.w_foldinvalid := (0).to_integer_8
		end

	foldUpdate (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_top: INTEGER_32; a_bot: INTEGER_32)
		local
			l_fp: CE_POINTER [PD_FOLD_T]
			l_save_got_int: INTEGER_32
			js: JUMP_STATE
		do
			create l_fp.make

			foldFind (create {CE_POINTER [PD_GROWARRAY]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_folds_offset), a_top, l_fp.address).do_nothing
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_fp.c_pointer.to_integer_32).to_natural_32 < ((create {CE_POINTER [PD_FOLD_T]}.make_cast (globals_inst.curwin.item.w_folds.ga_data) + globals_inst.curwin.item.w_folds.ga_len).c_pointer.to_integer_32).to_natural_32 then
					if not (l_fp.item.fd_top < a_bot) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_fp.item.fd_small := (2).to_integer_8
					l_fp.ce_gets (l_fp + 1)
				end
			end
			js.reset
			if (foldmethodIsIndent (a_wp___0)).to_boolean then
				l_save_got_int := globals_inst.got_int
				globals_inst.got_int := 0
				foldUpdateIEMS (a_wp___0, a_top, a_bot)
				globals_inst.got_int := (globals_inst.got_int).bit_or (l_save_got_int)
			elseif (foldmethodIsExpr (a_wp___0)).to_boolean then
				l_save_got_int := globals_inst.got_int
				globals_inst.got_int := 0
				foldUpdateIEMS (a_wp___0, a_top, a_bot)
				globals_inst.got_int := (globals_inst.got_int).bit_or (l_save_got_int)
			elseif (foldmethodIsMarker (a_wp___0)).to_boolean then
				l_save_got_int := globals_inst.got_int
				globals_inst.got_int := 0
				foldUpdateIEMS (a_wp___0, a_top, a_bot)
				globals_inst.got_int := (globals_inst.got_int).bit_or (l_save_got_int)
			elseif (foldmethodIsDiff (a_wp___0)).to_boolean then
				l_save_got_int := globals_inst.got_int
				globals_inst.got_int := 0
				foldUpdateIEMS (a_wp___0, a_top, a_bot)
				globals_inst.got_int := (globals_inst.got_int).bit_or (l_save_got_int)
			elseif (foldmethodIsSyntax (a_wp___0)).to_boolean then
				l_save_got_int := globals_inst.got_int
				globals_inst.got_int := 0
				foldUpdateIEMS (a_wp___0, a_top, a_bot)
				globals_inst.got_int := (globals_inst.got_int).bit_or (l_save_got_int)
			end
		end

	foldUpdateAll (a_win: CE_POINTER [PD_WINDOW_S])
		do
			a_win.item.w_foldinvalid := (1).to_integer_8
			screen_inst.redraw_win_later (a_win, 40)
		end

	foldMoveTo (a_updown: INTEGER_32; a_dir___0: INTEGER_32; a_count___2: INTEGER_32): INTEGER_32
		local
			l_n: INTEGER_32
			l_retval: INTEGER_32
			l_lnum_off: INTEGER_32
			l_lnum_found: INTEGER_32
			l_lnum: INTEGER_32
			l_use_level: INTEGER_32
			l_maybe_small: INTEGER_32
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_fp: CE_POINTER [PD_FOLD_T]
			l_level: INTEGER_32
			l_last: INTEGER_32
			js: JUMP_STATE
		do
			create l_gap.make
			create l_fp.make

			l_retval := 0
			checkupdate (globals_inst.curwin)
			l_n := 0
			from
			until
				not (not js.loop_left and then (l_n < a_count___2))
			loop
				js.reset
				l_lnum_off := (0).to_integer_32
				l_gap.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_folds_offset))
				l_use_level := 0
				l_maybe_small := 0
				l_lnum_found := globals_inst.curwin.item.w_cursor.lnum
				l_level := 0
				l_last := 0
				from
				until
					js.loop_left
				loop
					js.reset
					if not (foldFind (l_gap, globals_inst.curwin.item.w_cursor.lnum - l_lnum_off, l_fp.address)).to_boolean then
						if not a_updown.to_boolean then
							js.break
						end
						if not js.loop_jumped then
							if a_dir___0 = 1 then
								if l_fp.distance ((create {CE_POINTER [PD_FOLD_T]}.make_cast (l_gap.item.ga_data))) >= l_gap.item.ga_len then
									js.break
								end
								if not js.loop_jumped then
									l_fp.ce_gets (l_fp - 1)
								end
							elseif (l_fp.c_pointer.to_integer_32).to_natural_32 = ((l_gap.item.ga_data).c_pointer.to_integer_32).to_natural_32 then
								js.break
							end
						end
						if not js.loop_jumped then
							l_last := 1
						end
					end
					if not js.loop_jumped and then (not l_last.to_boolean) then
						if (check_closed (globals_inst.curwin, l_fp, create {CE_POINTER [INTEGER_32]}.make_shared ($l_use_level), l_level, create {CE_POINTER [INTEGER_32]}.make_shared ($l_maybe_small), l_lnum_off)).to_boolean then
							l_last := 1
						end
						if l_last.to_boolean then
							if not a_updown.to_boolean then
								js.break
							end
						end
					end
					if not js.loop_jumped then
						if a_updown.to_boolean then
							if a_dir___0 = 1 then
								if (l_fp + 1).distance ((create {CE_POINTER [PD_FOLD_T]}.make_cast (l_gap.item.ga_data))) < l_gap.item.ga_len then
									l_lnum := (l_fp + 1).item.fd_top + l_lnum_off
									if l_lnum > globals_inst.curwin.item.w_cursor.lnum then
										l_lnum_found := l_lnum
									end
								end
							elseif (l_fp.c_pointer.to_integer_32).to_natural_32 > ((l_gap.item.ga_data).c_pointer.to_integer_32).to_natural_32 then
								l_lnum := (((l_fp + -1).item.fd_top + l_lnum_off) + (l_fp + -1).item.fd_len) - 1
								if l_lnum < globals_inst.curwin.item.w_cursor.lnum then
									l_lnum_found := l_lnum
								end
							end
						elseif a_dir___0 = 1 then
							l_lnum := ((l_fp.item.fd_top + l_lnum_off) + l_fp.item.fd_len) - 1
							if l_lnum > globals_inst.curwin.item.w_cursor.lnum then
								l_lnum_found := l_lnum
							end
						else
							l_lnum := l_fp.item.fd_top + l_lnum_off
							if l_lnum < globals_inst.curwin.item.w_cursor.lnum then
								l_lnum_found := l_lnum
							end
						end
						if l_last.to_boolean then
							js.break
						end
					end
					if not js.loop_jumped then
						l_gap.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + {PD_FOLD_T}.fd_nested_offset))
						l_lnum_off := l_lnum_off + (l_fp.item.fd_top)
						l_level := l_level + 1
					end
				end
				js.reset
				if l_lnum_found /= globals_inst.curwin.item.w_cursor.lnum then
					if l_retval = 0 then
						mark_inst.setpcmark
					end
					globals_inst.curwin.item.w_cursor.lnum := l_lnum_found
					globals_inst.curwin.item.w_cursor.col := 0
					l_retval := 1
				else
					js.break
				end
				if not js.loop_jumped then
					l_n := l_n + 1
				end
			end
			js.reset
			Result := l_retval
		end

	foldInitWin (a_newwin: CE_POINTER [PD_WINDOW_S])
		do
			misc2_inst.ga_init2 (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_newwin.c_pointer + {PD_WINDOW_S}.w_folds_offset), ({PD_FOLD_T}.sizeof.to_natural_32).to_integer_32, 10)
		end

	find_wl_entry (a_win: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (l_i___0 < a_win.item.w_lines_valid))
			loop
				if ((a_win.item.w_lines + l_i___0).item.wl_valid).to_boolean then
					if a_lnum < (a_win.item.w_lines + l_i___0).item.wl_lnum then
						Result := (-1)
						js.return
					end
					if not js.return_called and then (a_lnum <= (a_win.item.w_lines + l_i___0).item.wl_lastlnum) then
						Result := l_i___0
						js.return
					end
				end
				if not js.return_called then
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	foldAdjustVisual
		local
			l_start___1: CE_POINTER [PD_POS_T]
			l_end: CE_POINTER [PD_POS_T]
			l_ptr: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_start___1.make
			create l_end.make
			create l_ptr.make

			if not globals_inst.VIsual_active.to_boolean then
				js.return
			elseif not (hasAnyFolding (globals_inst.curwin)).to_boolean then
				js.return
			end
			if not js.return_called then
				if globals_inst.VIsual.lnum /= globals_inst.curwin.item.w_cursor.lnum then
					l_tmp___1 := (globals_inst.VIsual.lnum < globals_inst.curwin.item.w_cursor.lnum).to_integer
				else
					if globals_inst.VIsual.col /= globals_inst.curwin.item.w_cursor.col then
						l_tmp___0 := (globals_inst.VIsual.col < globals_inst.curwin.item.w_cursor.col).to_integer
					else
						l_tmp___0 := (globals_inst.VIsual.coladd < globals_inst.curwin.item.w_cursor.coladd).to_integer
					end
					l_tmp___1 := l_tmp___0
				end
				if l_tmp___1.to_boolean then
					l_start___1.ce_gets (globals_inst.VIsual.address)
					l_end.ce_gets (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset))
				elseif globals_inst.VIsual.lnum = globals_inst.curwin.item.w_cursor.lnum then
					if globals_inst.VIsual.col = globals_inst.curwin.item.w_cursor.col then
						if globals_inst.VIsual.coladd = globals_inst.curwin.item.w_cursor.coladd then
							l_start___1.ce_gets (globals_inst.VIsual.address)
							l_end.ce_gets (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset))
						else
							l_start___1.ce_gets (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset))
							l_end.ce_gets (globals_inst.VIsual.address)
						end
					else
						l_start___1.ce_gets (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset))
						l_end.ce_gets (globals_inst.VIsual.address)
					end
				else
					l_start___1.ce_gets (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset))
					l_end.ce_gets (globals_inst.VIsual.address)
				end
				if (hasFolding (l_start___1.item.lnum, create {CE_POINTER [INTEGER_32]}.make_shared (l_start___1.c_pointer + {PD_POS_T}.lnum_offset), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))).to_boolean then
					l_start___1.item.col := 0
				end
				if (hasFolding (l_end.item.lnum, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (l_end.c_pointer + {PD_POS_T}.lnum_offset))).to_boolean then
					l_ptr.ce_gets (memline_inst.ml_get (l_end.item.lnum))
					l_end.item.col := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr))).to_integer_32
					if l_end.item.col > 0 then
						if (option_inst.p_sel.item).to_integer_32 = 111 then
							l_end.item.col := (l_end.item.col) - 1
						end
					end
					if globals_inst.has_mbyte.to_boolean then
						mbyte_inst.mb_adjust_cursor
					end
				end
			end
		end

	foldAdjustCursor
		do
			hasFolding (globals_inst.curwin.item.w_cursor.lnum, create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset + {PD_POS_T}.lnum_offset), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)).do_nothing
		end

	cloneFoldGrowArray (a_from: CE_POINTER [PD_GROWARRAY]; a_to: CE_POINTER [PD_GROWARRAY])
		local
			l_i___0: INTEGER_32
			l_from_p: CE_POINTER [PD_FOLD_T]
			l_to_p: CE_POINTER [PD_FOLD_T]
			js: JUMP_STATE
		do
			create l_from_p.make
			create l_to_p.make

			misc2_inst.ga_init2 (a_to, a_from.item.ga_itemsize, a_from.item.ga_growsize)
			if a_from.item.ga_len = 0 then
				js.return
			elseif (misc2_inst.ga_grow (a_to, a_from.item.ga_len)) = 0 then
				js.return
			end
			if not js.return_called then
				l_from_p.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_cast (a_from.item.ga_data))
				l_to_p.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_cast (a_to.item.ga_data))
				l_i___0 := 0
				from
				until
					not (l_i___0 < a_from.item.ga_len)
				loop
					l_to_p.item.fd_top := l_from_p.item.fd_top
					l_to_p.item.fd_len := l_from_p.item.fd_len
					l_to_p.item.fd_flags := l_from_p.item.fd_flags
					l_to_p.item.fd_small := l_from_p.item.fd_small
					cloneFoldGrowArray (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_from_p.c_pointer + {PD_FOLD_T}.fd_nested_offset), create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_to_p.c_pointer + {PD_FOLD_T}.fd_nested_offset))
					a_to.item.ga_len := (a_to.item.ga_len) + 1
					l_from_p.ce_gets (l_from_p + 1)
					l_to_p.ce_gets (l_to_p + 1)
					l_i___0 := l_i___0 + 1
				end
			end
		end

	foldFind (a_gap: CE_POINTER [PD_GROWARRAY]; a_lnum: INTEGER_32; a_fpp: CE_POINTER [CE_POINTER [PD_FOLD_T]]): INTEGER_32
		local
			l_low: INTEGER_32
			l_high: INTEGER_32
			l_fp: CE_POINTER [PD_FOLD_T]
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_fp.make

			l_fp.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data))
			l_low := (0).to_integer_32
			l_high := (a_gap.item.ga_len - 1).to_integer_32
			from
			until
				not (not js.loop_left and then (l_low <= l_high))
			loop
				l_i___0 := ((l_low + l_high) // 2).to_integer_32
				if (l_fp + l_i___0).item.fd_top > a_lnum then
					l_high := (l_i___0 - 1).to_integer_32
				elseif (l_fp + l_i___0).item.fd_top + (l_fp + l_i___0).item.fd_len <= a_lnum then
					l_low := (l_i___0 + 1).to_integer_32
				else
					a_fpp.item := l_fp + l_i___0
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				a_fpp.item := l_fp + l_low
				Result := 0
			end
		end

	foldLevelWin (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32): INTEGER_32
		local
			l_fp: CE_POINTER [PD_FOLD_T]
			l_lnum_rel: INTEGER_32
			l_level: INTEGER_32
			l_gap: CE_POINTER [PD_GROWARRAY]
			js: JUMP_STATE
		do
			create l_fp.make
			create l_gap.make

			l_lnum_rel := a_lnum
			l_level := 0
			l_gap.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_wp___0.c_pointer + {PD_WINDOW_S}.w_folds_offset))
			from
			until
				js.loop_left
			loop
				js.reset
				if not (foldFind (l_gap, l_lnum_rel, l_fp.address)).to_boolean then
					js.break
				end
				if not js.loop_jumped then
					l_gap.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + {PD_FOLD_T}.fd_nested_offset))
					l_lnum_rel := l_lnum_rel - (l_fp.item.fd_top)
					l_level := l_level + 1
				end
			end
			js.reset
			Result := l_level
		end

	checkupdate (a_wp___0: CE_POINTER [PD_WINDOW_S])
		do
			if (a_wp___0.item.w_foldinvalid).to_boolean then
				foldUpdate (a_wp___0, (1).to_integer_32, 2147483647)
				a_wp___0.item.w_foldinvalid := (0).to_integer_8
			end
		end

	setFoldRepeat (a_lnum: INTEGER_32; a_count___2: INTEGER_32; a_do_open: INTEGER_32)
		local
			l_done___2: INTEGER_32
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			l_n := 0
			from
			until
				not (not js.loop_left and then (l_n < a_count___2))
			loop
				js.reset
				l_done___2 := 0
				setManualFold (a_lnum, a_do_open, 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_done___2)).do_nothing
				if not ((l_done___2).bit_and (1)).to_boolean then
					if l_n = 0 then
						if not ((l_done___2).bit_and (2)).to_boolean then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (e_nofold)))).do_nothing
						end
					end
					js.break
				end
				if not js.loop_jumped then
					l_n := l_n + 1
				end
			end
			js.reset
		end

	setManualFold (a_lnum: INTEGER_32; a_opening: INTEGER_32; a_recurse___2: INTEGER_32; a_donep: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_dlnum: INTEGER_32
		do
			create l_wp___0.make

			if (foldmethodIsDiff (globals_inst.curwin)).to_boolean then
				if (globals_inst.curwin.item.w_onebuf_opt.wo_scb).to_boolean then
					l_wp___0.ce_gets (globals_inst.firstwin)
					from
					until
						(l_wp___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
					loop
						if (l_wp___0.c_pointer.to_integer_32).to_natural_32 /= (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 then
							if (foldmethodIsDiff (l_wp___0)).to_boolean then
								if (l_wp___0.item.w_onebuf_opt.wo_scb).to_boolean then
									l_dlnum := diff_inst.diff_lnum_win (globals_inst.curwin.item.w_cursor.lnum, l_wp___0)
									if l_dlnum /= 0 then
										setManualFoldWin (l_wp___0, l_dlnum, a_opening, a_recurse___2, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)).do_nothing
									end
								end
							end
						end
						l_wp___0.ce_gets (l_wp___0.item.w_next)
					end
				end
			end
			Result := (setManualFoldWin (globals_inst.curwin, a_lnum, a_opening, a_recurse___2, a_donep))
		end

	setManualFoldWin (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32; a_opening: INTEGER_32; a_recurse___2: INTEGER_32; a_donep: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_lnum: INTEGER_32
			l_fp: CE_POINTER [PD_FOLD_T]
			l_fp2: CE_POINTER [PD_FOLD_T]
			l_found: CE_POINTER [PD_FOLD_T]
			l_j: INTEGER_32
			l_level: INTEGER_32
			l_use_level: INTEGER_32
			l_found_fold: INTEGER_32
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_next: INTEGER_32
			l_off___0: INTEGER_32
			l_done___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fp.make
			create l_fp2.make
			create l_found.make
			create l_gap.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lnum := a_lnum
					l_found.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_shared (default_pointer))
					l_level := 0
					l_use_level := 0
					l_found_fold := 0
					l_next := 2147483647
					l_off___0 := (0).to_integer_32
					l_done___2 := 0
					checkupdate (a_wp___0)
					l_gap.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_wp___0.c_pointer + {PD_WINDOW_S}.w_folds_offset))
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 13 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if not (foldFind (l_gap, l_lnum, l_fp.address)).to_boolean then
							if (l_fp.c_pointer.to_integer_32).to_natural_32 < ((create {CE_POINTER [PD_FOLD_T]}.make_cast (l_gap.item.ga_data) + l_gap.item.ga_len).c_pointer.to_integer_32).to_natural_32 then
								l_next := l_fp.item.fd_top + l_off___0
							end
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 12 -- skip if block
						end
				when 3 then -- if:
						l_found_fold := 1
						if ((l_fp + 1).c_pointer.to_integer_32).to_natural_32 < ((create {CE_POINTER [PD_FOLD_T]}.make_cast (l_gap.item.ga_data) + l_gap.item.ga_len).c_pointer.to_integer_32).to_natural_32 then
							l_next := (l_fp + 1).item.fd_top + l_off___0
						end
						if not (l_use_level.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if (l_fp.item.fd_flags).to_integer_32 /= 2 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						l_use_level := 1
						if l_level.to_integer_32 >= a_wp___0.item.w_onebuf_opt.wo_fdl then
							l_fp.item.fd_flags := (1).to_integer_8
						else
							l_fp.item.fd_flags := (0).to_integer_8
						end
						l_fp2.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_cast (l_fp.item.fd_nested.ga_data))
						l_j := 0
						from
						until
							not (l_j < l_fp.item.fd_nested.ga_len)
						loop
							(l_fp2 + l_j).item.fd_flags := (2).to_integer_8
							l_j := l_j + 1
						end
				when 8 then -- if done
						if a_opening.to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if a_recurse___2.to_boolean then
							if (l_fp.item.fd_flags).to_integer_32 /= 1 then
								l_done___2 := (l_done___2).bit_or ((1))
								l_fp.item.fd_flags := (1).to_integer_8
							end
						else
							l_pos := -1 + 11 -- goto _L___0
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L___0:
						if (l_fp.item.fd_flags).to_integer_32 = 1 then
							if a_opening.to_boolean then
								l_fp.item.fd_flags := (0).to_integer_8
								l_done___2 := (l_done___2).bit_or ((1))
								if a_recurse___2.to_boolean then
									foldOpenNested (l_fp)
								end
							end
							js.break
						end
				when 12 then -- if done
						if not js.loop_jumped then
							l_found.ce_gets (l_fp)
							l_gap.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + {PD_FOLD_T}.fd_nested_offset))
							l_lnum := l_lnum - (l_fp.item.fd_top)
							l_off___0 := l_off___0 + (l_fp.item.fd_top)
							l_level := l_level + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 13 then -- loop done
					js.reset
					if l_found_fold.to_boolean then
						if not a_opening.to_boolean then
							if (l_found.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_found.item.fd_flags := (1).to_integer_8
								l_done___2 := (l_done___2).bit_or ((1))
							end
						end
						a_wp___0.item.w_fold_manual := (1).to_integer_8
						if ((l_done___2).bit_and (1)).to_boolean then
							move_inst.changed_window_setting_win (a_wp___0)
						end
						l_done___2 := (l_done___2).bit_or ((2))
					elseif (a_donep.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						if (a_wp___0.c_pointer.to_integer_32).to_natural_32 = (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (e_nofold)))).do_nothing
						end
					end
					if (a_donep.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						a_donep.item := (a_donep.item).bit_or (l_done___2)
					end
					Result := l_next
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	foldOpenNested (a_fpr: CE_POINTER [PD_FOLD_T])
		local
			l_i___0: INTEGER_32
			l_fp: CE_POINTER [PD_FOLD_T]
		do
			create l_fp.make

			l_fp.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_cast (a_fpr.item.fd_nested.ga_data))
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_fpr.item.fd_nested.ga_len)
			loop
				foldOpenNested (l_fp + l_i___0);
				(l_fp + l_i___0).item.fd_flags := (0).to_integer_8
				l_i___0 := l_i___0 + 1
			end
		end

	deleteFoldEntry (a_gap: CE_POINTER [PD_GROWARRAY]; a_idx: INTEGER_32; a_recursive___12: INTEGER_32)
		local
			l_fp: CE_POINTER [PD_FOLD_T]
			l_i___0: INTEGER_32
			l_moved: INTEGER_32
			l_nfp: CE_POINTER [PD_FOLD_T]
			l_pos: INTEGER_32
		do
			create l_fp.make
			create l_nfp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fp.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + a_idx)
					if not (a_recursive___12.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if l_fp.item.fd_nested.ga_len /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						deleteFoldRecurse (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + {PD_FOLD_T}.fd_nested_offset))
						a_gap.item.ga_len := (a_gap.item.ga_len) - 1
						if a_idx < a_gap.item.ga_len then
							memmove (create {CE_POINTER [ANY]}.make_cast (l_fp), create {CE_POINTER [ANY]}.make_cast ((l_fp + 1)), {PD_FOLD_T}.sizeof.to_natural_32 * (a_gap.item.ga_len - a_idx).to_natural_32).do_nothing
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_moved := (l_fp.item.fd_nested.ga_len).to_integer_32
						if (misc2_inst.ga_grow (a_gap, (l_moved - 1).to_integer_32)) = 1 then
							l_nfp.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_cast (l_fp.item.fd_nested.ga_data))
							l_i___0 := 0
							from
							until
								not (l_i___0.to_integer_32 < l_moved)
							loop
								(l_nfp + l_i___0).item.fd_top := (l_nfp + l_i___0).item.fd_top + (l_fp.item.fd_top)
								if (l_fp.item.fd_flags).to_integer_32 = 2 then
									(l_nfp + l_i___0).item.fd_flags := (2).to_integer_8
								end
								if (l_fp.item.fd_small).to_integer_32 = 2 then
									(l_nfp + l_i___0).item.fd_small := (2).to_integer_8
								end
								l_i___0 := l_i___0 + 1
							end
							if a_idx < a_gap.item.ga_len then
								memmove (create {CE_POINTER [ANY]}.make_cast ((l_fp + l_moved)), create {CE_POINTER [ANY]}.make_cast ((l_fp + 1)), {PD_FOLD_T}.sizeof.to_natural_32 * (a_gap.item.ga_len - a_idx).to_natural_32).do_nothing
							end
							memmove (create {CE_POINTER [ANY]}.make_cast (l_fp), create {CE_POINTER [ANY]}.make_cast (l_nfp), (({PD_FOLD_T}.sizeof.to_natural_32).to_natural_32 * l_moved.to_natural_32).to_natural_32).do_nothing
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_nfp))
							a_gap.item.ga_len := ((a_gap.item.ga_len).to_integer_32 + (l_moved - 1)).to_integer_32
						end
				when 7 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	deleteFoldRecurse (a_gap: CE_POINTER [PD_GROWARRAY])
		local
			l_i___0: INTEGER_32
		do
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_gap.item.ga_len)
			loop
				deleteFoldRecurse (create {CE_POINTER [PD_GROWARRAY]}.make_shared ((create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + l_i___0).c_pointer + {PD_FOLD_T}.fd_nested_offset))
				l_i___0 := l_i___0 + 1
			end
			misc2_inst.ga_clear (a_gap)
		end

	foldMarkAdjust (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_line1: INTEGER_32; a_line2: INTEGER_32; a_amount: INTEGER_32; a_amount_after: INTEGER_32)
		local
			l_line1: INTEGER_32
			l_line2: INTEGER_32
		do
			l_line1 := a_line1
			l_line2 := a_line2
			if a_amount = 2147483647 then
				if l_line2 >= l_line1 then
					if l_line2 - l_line1 >= -a_amount_after then
						l_line2 := (l_line1 - a_amount_after) - 1
					end
				end
			end
			if ((globals_inst.State).bit_and (16)).to_boolean then
				if a_amount = 1 then
					if l_line2 = 2147483647 then
						l_line1 := l_line1 - 1
					end
				end
			end
			foldMarkAdjustRecurse (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_wp___0.c_pointer + {PD_WINDOW_S}.w_folds_offset), l_line1, l_line2, a_amount, a_amount_after)
		end

	foldMarkAdjustRecurse (a_gap: CE_POINTER [PD_GROWARRAY]; a_line1: INTEGER_32; a_line2: INTEGER_32; a_amount: INTEGER_32; a_amount_after: INTEGER_32)
		local
			l_fp: CE_POINTER [PD_FOLD_T]
			l_i___0: INTEGER_32
			l_last: INTEGER_32
			l_top: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((globals_inst.State).bit_and (16)).to_boolean then
						if a_amount = 1 then
							if a_line2 = 2147483647 then
								l_top := a_line1 + 1
							else
								l_top := a_line1
							end
						else
							l_top := a_line1
						end
					else
						l_top := a_line1
					end
					foldFind (a_gap, a_line1, l_fp.address).do_nothing
					l_i___0 := l_fp.distance ((create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data)))
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_i___0 < a_gap.item.ga_len)) then
						l_pos := -1 + 11 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_last := (l_fp.item.fd_top + l_fp.item.fd_len) - 1
						if l_last < a_line1 then
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if:
						if not (l_fp.item.fd_top > a_line2) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_amount_after = 0 then
							js.break
						end
						if not js.loop_jumped then
							l_fp.item.fd_top := l_fp.item.fd_top + a_amount_after
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not (l_fp.item.fd_top >= l_top) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_last <= a_line2 then
							if a_amount = 2147483647 then
								deleteFoldEntry (a_gap, l_i___0, 1)
								l_i___0 := l_i___0 - 1
								l_fp.ce_gets (l_fp - 1)
							else
								l_fp.item.fd_top := l_fp.item.fd_top + a_amount
							end
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if l_fp.item.fd_top < l_top then
							foldMarkAdjustRecurse (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + {PD_FOLD_T}.fd_nested_offset), a_line1 - l_fp.item.fd_top, a_line2 - l_fp.item.fd_top, a_amount, a_amount_after)
							if l_last <= a_line2 then
								if a_amount = 2147483647 then
									l_fp.item.fd_len := a_line1 - l_fp.item.fd_top
								else
									l_fp.item.fd_len := l_fp.item.fd_len + a_amount
								end
							else
								l_fp.item.fd_len := l_fp.item.fd_len + a_amount_after
							end
						else
							foldMarkAdjustRecurse (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + {PD_FOLD_T}.fd_nested_offset), a_line1 - l_fp.item.fd_top, a_line2 - l_fp.item.fd_top, a_amount, a_amount_after + (l_fp.item.fd_top - l_top))
							if a_amount = 2147483647 then
								l_fp.item.fd_len := l_fp.item.fd_len - ((a_line2 - l_fp.item.fd_top) + 1)
								l_fp.item.fd_top := a_line1
							else
								l_fp.item.fd_len := l_fp.item.fd_len + (a_amount_after - a_amount)
								l_fp.item.fd_top := l_fp.item.fd_top + a_amount
							end
						end
				when 10 then -- if done | if done
						if not js.loop_left then
							l_i___0 := l_i___0 + 1
							l_fp.ce_gets (l_fp + 1)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 11 then -- loop done
					js.reset
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	getDeepestNesting: INTEGER_32
		do
			checkupdate (globals_inst.curwin)
			Result := (getDeepestNestingRecurse (create {CE_POINTER [PD_GROWARRAY]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_folds_offset)))
		end

	getDeepestNestingRecurse (a_gap: CE_POINTER [PD_GROWARRAY]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_level: INTEGER_32
			l_maxlevel: INTEGER_32
			l_fp: CE_POINTER [PD_FOLD_T]
		do
			create l_fp.make

			l_maxlevel := 0
			l_fp.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data))
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_gap.item.ga_len)
			loop
				l_level := (getDeepestNestingRecurse (create {CE_POINTER [PD_GROWARRAY]}.make_shared ((l_fp + l_i___0).c_pointer + {PD_FOLD_T}.fd_nested_offset))) + 1
				if l_level > l_maxlevel then
					l_maxlevel := l_level
				end
				l_i___0 := l_i___0 + 1
			end
			Result := l_maxlevel
		end

	check_closed (a_win: CE_POINTER [PD_WINDOW_S]; a_fp: CE_POINTER [PD_FOLD_T]; a_use_levelp: CE_POINTER [INTEGER_32]; a_level: INTEGER_32; a_maybe_smallp: CE_POINTER [INTEGER_32]; a_lnum_off: INTEGER_32): INTEGER_32
		local
			l_closed: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_closed := 0
					if not ((a_use_levelp.item).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if (a_fp.item.fd_flags).to_integer_32 /= 2 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						a_use_levelp.item := 1
						if a_level.to_integer_32 >= a_win.item.w_onebuf_opt.wo_fdl then
							l_closed := 1
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if (a_fp.item.fd_flags).to_integer_32 = 1 then
							l_closed := 1
						end
				when 7 then -- if done
						if (a_fp.item.fd_small).to_integer_32 = 2 then
							a_maybe_smallp.item := 1
						end
						if l_closed.to_boolean then
							if (a_maybe_smallp.item).to_boolean then
								a_fp.item.fd_small := (2).to_integer_8
							end
							checkSmall (a_win, a_fp, a_lnum_off)
							if (a_fp.item.fd_small).to_integer_32 = 1 then
								l_closed := 0
							end
						end
						Result := l_closed
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	checkSmall (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_fp: CE_POINTER [PD_FOLD_T]; a_lnum_off: INTEGER_32)
		local
			l_count___2: INTEGER_32
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			if (a_fp.item.fd_small).to_integer_32 = 2 then
				setSmallMaybe (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_fp.c_pointer + {PD_FOLD_T}.fd_nested_offset))
				if a_fp.item.fd_len > globals_inst.curwin.item.w_onebuf_opt.wo_fml then
					a_fp.item.fd_small := (0).to_integer_8
				else
					l_count___2 := 0
					l_n := 0
					from
					until
						not (not js.loop_left and then (l_n.to_integer_32 < a_fp.item.fd_len))
					loop
						l_count___2 := l_count___2 + (misc1_inst.plines_win_nofold (a_wp___0, (a_fp.item.fd_top + a_lnum_off) + l_n.to_integer_32))
						if l_count___2.to_integer_32 > globals_inst.curwin.item.w_onebuf_opt.wo_fml then
							a_fp.item.fd_small := (0).to_integer_8
							js.return
						end
						if not js.return_called then
							l_n := l_n + 1
						end
					end
					if not js.return_called then
						a_fp.item.fd_small := (1).to_integer_8
					end
				end
			end
			if not js.return_called then
			end
		end

	setSmallMaybe (a_gap: CE_POINTER [PD_GROWARRAY])
		local
			l_i___0: INTEGER_32
			l_fp: CE_POINTER [PD_FOLD_T]
		do
			create l_fp.make

			l_fp.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data))
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_gap.item.ga_len)
			loop
				(l_fp + l_i___0).item.fd_small := (2).to_integer_8
				l_i___0 := l_i___0 + 1
			end
		end

	foldCreateMarkers (a_start___1: INTEGER_32; a_end: INTEGER_32)
		local
			js: JUMP_STATE
		do
			if not (globals_inst.curbuf.item.b_p_ma).to_boolean then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_modifiable))))).do_nothing
				js.return
			end
			if not js.return_called then
				parseMarker (globals_inst.curwin)
				foldAddMarker (a_start___1, globals_inst.curwin.item.w_onebuf_opt.wo_fmr, foldstartmarkerlen)
				foldAddMarker (a_end, foldendmarker, foldendmarkerlen)
				misc1_inst.changed_lines (a_start___1, 0, a_end, 0)
			end
		end

	foldAddMarker (a_lnum: INTEGER_32; a_marker: CE_POINTER [NATURAL_8]; a_markerlen: INTEGER_32)
		local
			l_cms: CE_POINTER [NATURAL_8]
			l_line: CE_POINTER [NATURAL_8]
			l_line_len: INTEGER_32
			l_newline: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_cms.make
			create l_line.make
			create l_newline.make
			create l_p___0.make

			l_cms.ce_gets (globals_inst.curbuf.item.b_p_cms)
			l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strstr (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.curbuf.item.b_p_cms), ce_string ("%%s")))))
			l_line.ce_gets (memline_inst.ml_get (a_lnum))
			l_line_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_line))).to_integer_32
			if (undo_inst.u_save (a_lnum - 1, a_lnum + 1)) = 1 then
				l_newline.ce_gets (misc2_inst.alloc (((l_line_len + a_markerlen).to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_cms)))) + {NATURAL_32} 1))
				if (l_newline.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					js.return
				end
				if not js.return_called then
					strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_newline), create {CE_POINTER [INTEGER_8]}.make_cast (l_line)).do_nothing
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						misc2_inst.vim_strncpy (l_newline + l_line_len, a_marker, a_markerlen.to_natural_32)
					else
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_newline + l_line_len)), create {CE_POINTER [INTEGER_8]}.make_cast (l_cms)).do_nothing
						strncpy (create {CE_POINTER [INTEGER_8]}.make_cast (((l_newline + l_line_len) + (l_p___0.distance (l_cms)))), create {CE_POINTER [INTEGER_8]}.make_cast (a_marker), a_markerlen.to_natural_32).do_nothing
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((((l_newline + l_line_len) + (l_p___0.distance (l_cms))) + a_markerlen)), create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 2))).do_nothing
					end
					memline_inst.ml_replace (a_lnum, l_newline, 0).do_nothing
				end
			end
			if not js.return_called then
			end
		end

	deleteFoldMarkers (a_fp: CE_POINTER [PD_FOLD_T]; a_recursive___12: INTEGER_32; a_lnum_off: INTEGER_32)
		local
			l_i___0: INTEGER_32
		do
			if a_recursive___12.to_boolean then
				l_i___0 := 0
				from
				until
					not (l_i___0 < a_fp.item.fd_nested.ga_len)
				loop
					deleteFoldMarkers (create {CE_POINTER [PD_FOLD_T]}.make_cast (a_fp.item.fd_nested.ga_data) + l_i___0, 1, a_lnum_off + a_fp.item.fd_top)
					l_i___0 := l_i___0 + 1
				end
			end
			foldDelMarker (a_fp.item.fd_top + a_lnum_off, globals_inst.curwin.item.w_onebuf_opt.wo_fmr, foldstartmarkerlen)
			foldDelMarker (((a_fp.item.fd_top + a_lnum_off) + a_fp.item.fd_len) - 1, foldendmarker, foldendmarkerlen)
		end

	foldDelMarker (a_lnum: INTEGER_32; a_marker: CE_POINTER [NATURAL_8]; a_markerlen: INTEGER_32)
		local
			l_line: CE_POINTER [NATURAL_8]
			l_newline: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_cms: CE_POINTER [NATURAL_8]
			l_cms2: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_line.make
			create l_newline.make
			create l_p___0.make
			create l_cms.make
			create l_cms2.make

			l_cms.ce_gets (globals_inst.curbuf.item.b_p_cms)
			l_line.ce_gets (memline_inst.ml_get (a_lnum))
			l_p___0.ce_gets (l_line)
			from
			until
				not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0))
			loop
				js.reset
				if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), create {CE_POINTER [INTEGER_8]}.make_cast (a_marker), a_markerlen.to_natural_32)) = 0 then
					l_len := a_markerlen
					if (l_p___0[l_len]).to_integer_32 >= 48 then
						if (l_p___0[l_len]).to_integer_32 <= 57 then
							l_len := l_len + 1
						end
					end
					if (l_cms.item).to_integer_32 /= 0 then
						l_cms2.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_cms), ce_string ("%%s")))))
						if l_p___0.distance (l_line) >= l_cms2.distance (l_cms) then
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 - (l_cms2.distance (l_cms)))), create {CE_POINTER [INTEGER_8]}.make_cast (l_cms), (l_cms2.distance (l_cms)).to_natural_32)) = 0 then
								if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + l_len)), create {CE_POINTER [INTEGER_8]}.make_cast ((l_cms2 + 2)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_cms2 + 2)))))) = 0 then
									l_p___0.ce_gets (l_p___0 - (l_cms2.distance (l_cms)))
									l_len := l_len + ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_cms))).to_integer_32 - 2)
								end
							end
						end
					end
					if (undo_inst.u_save (a_lnum - 1, a_lnum + 1)) = 1 then
						l_newline.ce_gets (misc2_inst.alloc (((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_line))) - l_len.to_natural_32) + {NATURAL_32} 1))
						if (l_newline.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							strncpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_newline), create {CE_POINTER [INTEGER_8]}.make_cast (l_line), (l_p___0.distance (l_line)).to_natural_32).do_nothing
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_newline + (l_p___0.distance (l_line)))), create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + l_len))).do_nothing
							memline_inst.ml_replace (a_lnum, l_newline, 0).do_nothing
						end
					end
					js.break
				end
				if not js.loop_jumped then
					l_p___0.ce_gets (l_p___0 + 1)
				end
			end
			js.reset
		end

	get_foldtext (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32; a_lnume: INTEGER_32; a_foldinfo: CE_POINTER [PD_FOLDINFO]; a_buf___6: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_text: CE_POINTER [NATURAL_8]
			l_dashes: CE_ARRAY [NATURAL_8]
			l_save_curwin: CE_POINTER [PD_WINDOW_S]
			l_level: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_text.make
			create l_dashes.make (<<22>>)
			create l_save_curwin.make
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_text.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					if ((a_wp___0.item.w_onebuf_opt.wo_fdt).item).to_integer_32 = 0 then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						eval_inst.set_vim_var_nr (22, a_lnum)
						eval_inst.set_vim_var_nr (23, a_lnume)
						l_level := a_foldinfo.item.fi_level
						if l_level > (Natural_8_bytes.to_natural_32 * (22).to_natural_32).to_integer_32 - 1 then
							l_level := (Natural_8_bytes.to_natural_32 * (22).to_natural_32).to_integer_32 - 1
						end
						memset (create {CE_POINTER [ANY]}.make_cast (l_dashes), ('-').code, l_level.to_natural_32).do_nothing
						l_dashes[l_level] := (('%/0/').code).to_natural_8
						eval_inst.set_vim_var_string (24, l_dashes, -1)
						eval_inst.set_vim_var_nr (25, l_level.to_integer_32)
						l_save_curwin.ce_gets (globals_inst.curwin)
						globals_inst.curwin.ce_gets (a_wp___0)
						globals_inst.curbuf.ce_gets (a_wp___0.item.w_buffer)
						globals_inst.emsg_off := globals_inst.emsg_off + 1
						l_text.ce_gets (eval_inst.eval_to_string_safe (a_wp___0.item.w_onebuf_opt.wo_fdt, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), (option_inst.was_set_insecurely (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("foldtext")), 4))))
						globals_inst.emsg_off := globals_inst.emsg_off - 1
						globals_inst.curwin.ce_gets (l_save_curwin)
						globals_inst.curbuf.ce_gets (globals_inst.curwin.item.w_buffer)
						eval_inst.set_vim_var_string (24, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), -1)
						if (l_text.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						l_p___0.ce_gets (l_text)
				when 3 then -- loop condition:
						if not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0)) then
							l_pos := -1 + 9 -- skip loop
						end
				when 4 then -- loop body:
						js.reset
						if not (globals_inst.has_mbyte.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_len := globals_inst.mb_ptr2len.integer_32_item ([l_p___0])
						if l_len > 1 then
							if not (charset_inst.vim_isprintc ((globals_inst.mb_ptr2char.integer_32_item ([l_p___0])))).to_boolean then
								js.break
							end
							if not js.loop_jumped then
								l_p___0.ce_gets (l_p___0 + (l_len - 1))
							end
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if (l_p___0.item).to_integer_32 = 9 then
							l_p___0.item := ((' ').code).to_natural_8
						elseif (charset_inst.ptr2cells (l_p___0)) > 1 then
							js.break
						end
				when 8 then
						if not js.loop_jumped then
							l_p___0.ce_gets (l_p___0 + 1)
						end
						l_pos := -1 + 3 -- back to loop condition
				when 9 then -- loop done
						js.reset
						if (l_p___0.item).to_integer_32 /= 0 then
							l_p___0.ce_gets (charset_inst.transstr (l_text))
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_text))
							l_text.ce_gets (l_p___0)
						end
				when 10 then -- if done | if done
						if (l_text.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6), (gettext (ce_string ("+--%%3ld lines folded "))), (a_lnume - a_lnum) + 1]).do_nothing
							l_text.ce_gets (a_buf___6)
						end
						Result := l_text
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	foldtext_cleanup (a_str___1: CE_POINTER [NATURAL_8])
		local
			l_cms_start: CE_POINTER [NATURAL_8]
			l_cms_slen: INTEGER_32
			l_cms_end: CE_POINTER [NATURAL_8]
			l_cms_elen: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_did1: INTEGER_32
			l_did2: INTEGER_32
			l_tmp___8: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_cms_start.make
			create l_cms_end.make
			create l_s.make
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_cms_slen := 0
					l_cms_elen := 0
					l_did1 := 0
					l_did2 := 0
					l_cms_start.ce_gets (charset_inst.skipwhite (globals_inst.curbuf.item.b_p_cms))
					l_cms_slen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_cms_start))).to_integer_32
					from
					until
						js.loop_left
					loop
						js.reset
						if l_cms_slen > 0 then
							if (l_cms_start[(l_cms_slen - 1)]).to_integer_32 /= 32 then
								if (l_cms_start[(l_cms_slen - 1)]).to_integer_32 /= 9 then
									js.break
								end
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_cms_slen := l_cms_slen - 1
						end
					end
					js.reset
					l_cms_end.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_cms_start), ce_string ("%%s")))))
					if (l_cms_end.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_cms_elen := l_cms_slen - (l_cms_end.distance (l_cms_start))
						l_cms_slen := l_cms_end.distance (l_cms_start)
						from
						until
							js.loop_left
						loop
							js.reset
							if l_cms_slen > 0 then
								if (l_cms_start[(l_cms_slen - 1)]).to_integer_32 /= 32 then
									if (l_cms_start[(l_cms_slen - 1)]).to_integer_32 /= 9 then
										js.break
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_cms_slen := l_cms_slen - 1
							end
						end
						js.reset
						l_s.ce_gets (charset_inst.skipwhite (l_cms_end + 2))
						l_cms_elen := l_cms_elen - (l_s.distance (l_cms_end))
						l_cms_end.ce_gets (l_s)
					end
					parseMarker (globals_inst.curwin)
					l_s.ce_gets (a_str___1)
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_s.item).to_integer_32 /= 0)) then
						l_pos := -1 + 11 -- skip loop
					end
				when 2 then -- loop body:
						l_len := 0
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.curwin.item.w_onebuf_opt.wo_fmr), foldstartmarkerlen.to_natural_32)) = 0 then
							l_len := foldstartmarkerlen
						elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), create {CE_POINTER [INTEGER_8]}.make_cast (foldendmarker), foldendmarkerlen.to_natural_32)) = 0 then
							l_len := foldendmarkerlen
						end
						if not (l_len > 0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (l_s[l_len]).to_integer_32 >= 48 then
							if (l_s[l_len]).to_integer_32 <= 57 then
								l_len := l_len + 1
							end
						end
						l_p___0.ce_gets (l_s)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (a_str___1.c_pointer.to_integer_32).to_natural_32 then
								if (l_p___0[-1]).to_integer_32 /= 32 then
									if (l_p___0[-1]).to_integer_32 /= 9 then
										js.break
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0.ce_gets (l_p___0 - 1)
							end
						end
						js.reset
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= ((a_str___1 + l_cms_slen).c_pointer.to_integer_32).to_natural_32 then
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 - l_cms_slen)), create {CE_POINTER [INTEGER_8]}.make_cast (l_cms_start), l_cms_slen.to_natural_32)) = 0 then
								l_len := l_len + ((l_s.distance (l_p___0)) + l_cms_slen)
								l_s.ce_gets (l_p___0 - l_cms_slen)
							end
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 5 then -- else:
						if (l_cms_end.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 10 -- skip if block
						end
				when 6 then -- if:
						if l_did1.to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_cms_slen > 0 then
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), create {CE_POINTER [INTEGER_8]}.make_cast (l_cms_start), l_cms_slen.to_natural_32)) = 0 then
								l_len := l_cms_slen
								l_did1 := 1
							else
								l_pos := -1 + 9 -- goto _L___0
							end
						else
							l_pos := -1 + 9 -- goto _L___0
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L___0:
						if not l_did2.to_boolean then
							if l_cms_elen > 0 then
								if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), create {CE_POINTER [INTEGER_8]}.make_cast (l_cms_end), l_cms_elen.to_natural_32)) = 0 then
									l_len := l_cms_elen
									l_did2 := 1
								end
							end
						end
				when 10 then -- if done | if done
						if l_len /= 0 then
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_s[l_len]).to_integer_32 /= 32 then
									if (l_s[l_len]).to_integer_32 /= 9 then
										js.break
									end
								end
								if not js.loop_jumped then
									l_len := l_len + 1
								end
							end
							js.reset
							memmove (create {CE_POINTER [ANY]}.make_cast (l_s), create {CE_POINTER [ANY]}.make_cast ((l_s + l_len)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_s + l_len)))) + {NATURAL_32} 1).do_nothing
						else
							if globals_inst.has_mbyte.to_boolean then
								l_tmp___8 := (globals_inst.mb_ptr2len.integer_32_item ([l_s]))
							else
								l_tmp___8 := 1
							end
							l_s.ce_gets (l_s + l_tmp___8)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	foldUpdateIEMS (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_top: INTEGER_32; a_bot: INTEGER_32)
		local
			l_top: INTEGER_32
			l_bot: INTEGER_32
			l_start___1: INTEGER_32
			l_end: INTEGER_32
			l_fline: PD_FLINE_T
			l_getlevel: CE_ROUTINE
			l_level: INTEGER_32
			l_fp: CE_POINTER [PD_FOLD_T]
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_fpn: CE_POINTER [PD_FOLD_T]
			l_current_fdl: INTEGER_32
			l_fold_start_lnum: INTEGER_32
			l_lnum_rel: INTEGER_32
			l_fold_end_lnum: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fline.make
			create l_getlevel.make
			create l_fp.make
			create l_gap.make
			create l_fpn.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_top := a_top
					l_bot := a_bot
					if invalid_top /= 0 then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						if (a_wp___0.item.w_foldinvalid).to_boolean then
							l_top := (1).to_integer_32
							l_bot := (a_wp___0.item.w_buffer).item.b_ml.ml_line_count
							a_wp___0.item.w_foldinvalid := (0).to_integer_8
							setSmallMaybe (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_wp___0.c_pointer + {PD_WINDOW_S}.w_folds_offset))
						end
						if (foldmethodIsDiff (a_wp___0)).to_boolean then
							if l_top > globals_inst.diff_context.to_integer_32 then
								l_top := l_top - globals_inst.diff_context.to_integer_32
							else
								l_top := (1).to_integer_32
							end
							l_bot := l_bot + globals_inst.diff_context.to_integer_32
						end
						if l_top > (a_wp___0.item.w_buffer).item.b_ml.ml_line_count then
							l_top := (a_wp___0.item.w_buffer).item.b_ml.ml_line_count
						end
						fold_changed := 0
						l_fline.wp := a_wp___0
						l_fline.off := (0).to_integer_32
						l_fline.lvl := 0
						l_fline.lvl_next := -1
						l_fline.start := 0
						l_fline.end2 := 21
						l_fline.had_end := 21
						invalid_top := l_top
						invalid_bot := l_bot
						if (foldmethodIsMarker (a_wp___0)).to_boolean then
							l_getlevel.ce_gets (foldlevelMarker_address)
							parseMarker (a_wp___0)
							if l_top > 1 then
								l_level := foldLevelWin (a_wp___0, l_top - 1)
								l_fline.lnum := l_top - 1
								l_fline.lvl := l_level
								l_getlevel.call ([l_fline.address])
								if l_fline.lvl > l_level then
									l_fline.lvl := l_level - (l_fline.lvl - l_fline.lvl_next)
								else
									l_fline.lvl := l_fline.lvl_next
								end
							end
							l_fline.lnum := l_top
							l_getlevel.call ([l_fline.address])
						else
							l_fline.lnum := l_top
							if (foldmethodIsExpr (a_wp___0)).to_boolean then
								l_getlevel.ce_gets (foldlevelExpr_address)
								if l_top > 1 then
									l_fline.lnum := (l_fline.lnum) - 1
								end
							elseif (foldmethodIsSyntax (a_wp___0)).to_boolean then
								l_getlevel.ce_gets (foldlevelSyntax_address)
							elseif (foldmethodIsDiff (a_wp___0)).to_boolean then
								l_getlevel.ce_gets (foldlevelDiff_address)
							else
								l_getlevel.ce_gets (foldlevelIndent_address)
							end
							l_fline.lvl := -1
							from
							until
								not (not js.loop_left and then (not globals_inst.got_int.to_boolean))
							loop
								js.reset
								l_fline.lvl_next := -1
								l_getlevel.call ([l_fline.address])
								if l_fline.lvl >= 0 then
									js.break
								end
								if not js.loop_jumped then
									l_fline.lnum := (l_fline.lnum) - 1
								end
							end
							js.reset
						end
						if ((foldlevelSyntax_address).c_pointer.to_integer_32).to_natural_32 = (l_getlevel.c_pointer.to_integer_32).to_natural_32 then
							l_gap.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_wp___0.c_pointer + {PD_WINDOW_S}.w_folds_offset))
							l_fpn.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_shared (default_pointer))
							l_current_fdl := 0
							l_fold_start_lnum := (0).to_integer_32
							l_lnum_rel := l_fline.lnum
							from
							until
								not (not js.loop_left and then (l_current_fdl < l_fline.lvl))
							loop
								js.reset
								if not (foldFind (l_gap, l_lnum_rel, l_fpn.address)).to_boolean then
									js.break
								end
								if not js.loop_jumped then
									l_current_fdl := l_current_fdl + 1
									l_fold_start_lnum := l_fold_start_lnum + (l_fpn.item.fd_top)
									l_gap.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fpn.c_pointer + {PD_FOLD_T}.fd_nested_offset))
									l_lnum_rel := l_lnum_rel - (l_fpn.item.fd_top)
								end
							end
							js.reset
							if (l_fpn.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if l_current_fdl = l_fline.lvl then
									l_fold_end_lnum := l_fold_start_lnum + l_fpn.item.fd_len
									if l_fold_end_lnum > l_bot then
										l_bot := l_fold_end_lnum
									end
								end
							end
						end
						l_start___1 := l_fline.lnum
						l_end := l_bot
						if l_start___1 > l_end then
							if l_end < (a_wp___0.item.w_buffer).item.b_ml.ml_line_count then
								l_end := l_start___1
							end
						end
				when 2 then -- loop condition:
						if not (not js.loop_left and then (not globals_inst.got_int.to_boolean)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if l_fline.lnum > (a_wp___0.item.w_buffer).item.b_ml.ml_line_count then
							js.break
						end
						if not (not js.loop_jumped and then (l_fline.lnum > l_end)) then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if (l_getlevel.c_pointer.to_integer_32).to_natural_32 /= ((foldlevelMarker_address).c_pointer.to_integer_32).to_natural_32 then
							if (l_getlevel.c_pointer.to_integer_32).to_natural_32 /= ((foldlevelSyntax_address).c_pointer.to_integer_32).to_natural_32 then
								if (l_getlevel.c_pointer.to_integer_32).to_natural_32 /= ((foldlevelExpr_address).c_pointer.to_integer_32).to_natural_32 then
									js.break
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 12 -- skip if block
						end
				when 5 then -- if:
						if not (l_start___1 <= l_end) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (foldFind (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_wp___0.c_pointer + {PD_WINDOW_S}.w_folds_offset), l_end, l_fp.address)).to_boolean then
							if (l_fp.item.fd_top + l_fp.item.fd_len) - 1 > l_end then
								l_end := (l_fp.item.fd_top + l_fp.item.fd_len) - 1
							else
								l_pos := -1 + 8 -- goto _L___2
							end
						else
							l_pos := -1 + 8 -- goto _L___2
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 8 then -- else: | _L___2:
						if l_fline.lvl /= 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if (foldFind (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_wp___0.c_pointer + {PD_WINDOW_S}.w_folds_offset), l_fline.lnum, l_fp.address)).to_boolean then
							if l_fp.item.fd_top < l_fline.lnum then
								l_end := (l_fp.item.fd_top + l_fp.item.fd_len) - 1
							else
								l_pos := -1 + 11 -- goto _L___0
							end
						else
							l_pos := -1 + 11 -- goto _L___0
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L___0:
						if (l_getlevel.c_pointer.to_integer_32).to_natural_32 = ((foldlevelSyntax_address).c_pointer.to_integer_32).to_natural_32 then
							if (foldLevelWin (a_wp___0, l_fline.lnum)) /= l_fline.lvl then
								l_end := l_fline.lnum
							else
								js.break
							end
						else
							js.break
						end
				when 12 then -- if done | if done | if done
						if not js.loop_jumped then
							if l_fline.lvl > 0 then
								invalid_top := l_fline.lnum
								invalid_bot := l_end
								l_end := foldUpdateIEMSRecurse (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_wp___0.c_pointer + {PD_WINDOW_S}.w_folds_offset), 1, l_start___1, l_fline.address, l_getlevel, l_end, 2)
								l_start___1 := l_fline.lnum
							else
								if l_fline.lnum = (a_wp___0.item.w_buffer).item.b_ml.ml_line_count then
									js.break
								end
								if not js.loop_jumped then
									l_fline.lnum := (l_fline.lnum) + 1
									l_fline.lvl := l_fline.lvl_next
									l_getlevel.call ([l_fline.address])
								end
							end
						end
						l_pos := -1 + 2 -- back to loop condition
				when 13 then -- loop done
						js.reset
						foldRemove (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_wp___0.c_pointer + {PD_WINDOW_S}.w_folds_offset), l_start___1, l_end)
						if fold_changed.to_boolean then
							if (a_wp___0.item.w_onebuf_opt.wo_fen).to_boolean then
								move_inst.changed_window_setting_win (a_wp___0)
							end
						end
						if l_end /= l_bot then
							if a_wp___0.item.w_redraw_top = 0 then
								a_wp___0.item.w_redraw_top := l_top
							elseif a_wp___0.item.w_redraw_top > l_top then
								a_wp___0.item.w_redraw_top := l_top
							end
							if a_wp___0.item.w_redraw_bot < l_end then
								a_wp___0.item.w_redraw_bot := l_end
							end
						end
						invalid_top := (0).to_integer_32
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	foldUpdateIEMSRecurse (a_gap: CE_POINTER [PD_GROWARRAY]; a_level: INTEGER_32; a_startlnum: INTEGER_32; a_flp: CE_POINTER [PD_FLINE_T]; a_getlevel: CE_ROUTINE; a_bot: INTEGER_32; a_topflags: INTEGER_32): INTEGER_32
		local
			l_bot: INTEGER_32
			l_ll: INTEGER_32
			l_fp: CE_POINTER [PD_FOLD_T]
			l_fp2: CE_POINTER [PD_FOLD_T]
			l_lvl: INTEGER_32
			l_startlnum2: INTEGER_32
			l_firstlnum: INTEGER_32
			l_i___0: INTEGER_32
			l_finish: INTEGER_32
			l_linecount: INTEGER_32
			l_concat: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fp.make
			create l_fp2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_bot := a_bot
					l_fp.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_shared (default_pointer))
					l_lvl := a_level
					l_startlnum2 := a_startlnum
					l_firstlnum := a_flp.item.lnum
					l_finish := 0
					l_linecount := ((a_flp.item.wp).item.w_buffer).item.b_ml.ml_line_count - a_flp.item.off
					if (a_getlevel.c_pointer.to_integer_32).to_natural_32 = ((foldlevelMarker_address).c_pointer.to_integer_32).to_natural_32 then
						if a_flp.item.start <= a_flp.item.lvl - a_level then
							if a_flp.item.lvl > 0 then
								foldFind (a_gap, a_startlnum - 1, l_fp.address).do_nothing
								if (l_fp.c_pointer.to_integer_32).to_natural_32 >= ((create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + a_gap.item.ga_len).c_pointer.to_integer_32).to_natural_32 then
									l_fp.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_shared (default_pointer))
								elseif l_fp.item.fd_top >= a_startlnum then
									l_fp.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_shared (default_pointer))
								end
							end
						end
					end
					a_flp.item.lnum_save := a_flp.item.lnum
				when 1 then -- loop condition:
					if not (not js.loop_left and then (not globals_inst.got_int.to_boolean)) then
						l_pos := -1 + 55 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						misc1_inst.line_breakcheck
						l_lvl := a_flp.item.lvl
						if l_lvl > 20 then
							l_lvl := 20
						end
						if a_flp.item.lnum > l_firstlnum then
							if a_level > l_lvl - a_flp.item.start then
								l_lvl := 0
							elseif a_level >= a_flp.item.had_end then
								l_lvl := 0
							end
						end
						if a_flp.item.lnum > l_bot then
							if not l_finish.to_boolean then
								if (l_fp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if (a_getlevel.c_pointer.to_integer_32).to_natural_32 /= ((foldlevelMarker_address).c_pointer.to_integer_32).to_natural_32 then
										if (a_getlevel.c_pointer.to_integer_32).to_natural_32 /= ((foldlevelExpr_address).c_pointer.to_integer_32).to_natural_32 then
											if (a_getlevel.c_pointer.to_integer_32).to_natural_32 /= ((foldlevelSyntax_address).c_pointer.to_integer_32).to_natural_32 then
												js.break
											end
										end
									end
									if not js.loop_jumped then
										l_i___0 := 0
										l_fp2.ce_gets (l_fp)
										if l_lvl >= a_level then
											l_ll := a_flp.item.lnum - l_fp.item.fd_top
											from
											until
												js.loop_left
											loop
												js.reset
												if not (foldFind (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp2.c_pointer + {PD_FOLD_T}.fd_nested_offset), l_ll, l_fp2.address)).to_boolean then
													js.break
												end
												if not js.loop_jumped then
													l_i___0 := l_i___0 + 1
													l_ll := l_ll - (l_fp2.item.fd_top)
												end
											end
											js.reset
										end
										if l_lvl < a_level + l_i___0 then
											foldFind (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + {PD_FOLD_T}.fd_nested_offset), a_flp.item.lnum - l_fp.item.fd_top, l_fp2.address).do_nothing
											if (l_fp2.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
												l_bot := ((l_fp2.item.fd_top + l_fp2.item.fd_len) - 1) + l_fp.item.fd_top
											end
										elseif l_fp.item.fd_top + l_fp.item.fd_len <= a_flp.item.lnum then
											if l_lvl >= a_level then
												l_finish := 1
											else
												js.break
											end
										else
											js.break
										end
									end
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 54 -- skip if block
						end
				when 3 then -- if:
						if (l_fp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 48 -- skip if block
						end
				when 4 then -- if:
						if l_lvl = a_level then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 17 -- goto _L___5
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 7 then -- else:
						if not (a_flp.item.lnum_save >= l_bot) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 17 -- goto _L___5
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 10 then -- else:
						if a_flp.item.start = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 17 -- goto _L___5
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 13 then -- else:
						if not (a_flp.item.had_end <= 20) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___5
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 16 then -- else:
						if a_flp.item.lnum /= l_linecount then
							l_pos := -1 + 48 -- skip if block
						end
				when 17 then -- if: | _L___5:
						if not (not js.loop_left and then (not globals_inst.got_int.to_boolean)) then
							l_pos := -1 + 47 -- skip loop
						end
				when 18 then -- loop body:
						js.reset
						if a_flp.item.start /= 0 then
							l_concat := 0
						elseif a_flp.item.had_end <= 20 then
							l_concat := 0
						else
							l_concat := 1
						end
						if not ((foldFind (a_gap, a_startlnum, l_fp.address)).to_boolean) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 33 -- goto _L___2
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 21 then -- else:
						if not ((l_fp.c_pointer.to_integer_32).to_natural_32 < ((create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + a_gap.item.ga_len).c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if l_fp.item.fd_top <= l_firstlnum then
							l_pos := -1 + 33 -- goto _L___2
						else
							l_pos := -1 + 24 -- goto _L___4
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 24 then -- else: | _L___4:
						if not ((foldFind (a_gap, l_firstlnum - l_concat.to_integer_32, l_fp.address)).to_boolean) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 33 -- goto _L___2
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 27 then -- else:
						if not ((l_fp.c_pointer.to_integer_32).to_natural_32 < ((create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + a_gap.item.ga_len).c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 45 -- skip if block
						end
				when 28 then -- if:
						if not (l_lvl < a_level) then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						if l_fp.item.fd_top < a_flp.item.lnum then
							l_pos := -1 + 33 -- goto _L___2
						else
							l_pos := -1 + 31 -- goto _L___3
						end
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 31 then -- else: | _L___3:
						if not (l_lvl >= a_level) then
							l_pos := -1 + 43 -- skip if block
						end
				when 32 then -- if:
						if not (l_fp.item.fd_top <= a_flp.item.lnum_save) then
							l_pos := -1 + 41 -- skip if block
						end
				when 33 then -- if: | _L___2:
						if not ((l_fp.item.fd_top + l_fp.item.fd_len) + l_concat.to_integer_32 > l_firstlnum) then
							l_pos := -1 + 39 -- skip if block
						end
				when 34 then -- if:
						if not (l_fp.item.fd_top >= a_startlnum) then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						if l_fp.item.fd_top /= l_firstlnum then
							if l_fp.item.fd_top > l_firstlnum then
								foldMarkAdjustRecurse (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + {PD_FOLD_T}.fd_nested_offset), (0).to_integer_32, 2147483647, l_fp.item.fd_top - l_firstlnum, 0)
							else
								foldMarkAdjustRecurse (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + {PD_FOLD_T}.fd_nested_offset), (0).to_integer_32, (l_firstlnum - l_fp.item.fd_top) - 1, 2147483647, l_fp.item.fd_top - l_firstlnum)
							end
							l_fp.item.fd_len := l_fp.item.fd_len + (l_fp.item.fd_top - l_firstlnum)
							l_fp.item.fd_top := l_firstlnum
							fold_changed := 1
						else
							l_pos := -1 + 37 -- goto _L
						end
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 37 then -- else: | _L:
						if a_flp.item.start /= 0 then
							if l_lvl = a_level then
								if l_fp.item.fd_top /= l_firstlnum then
									foldRemove (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + {PD_FOLD_T}.fd_nested_offset), a_flp.item.lnum - l_fp.item.fd_top, a_flp.item.lnum - l_fp.item.fd_top)
									l_i___0 := l_fp.distance ((create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data)))
									foldSplit (a_gap, l_i___0, a_flp.item.lnum, a_flp.item.lnum - 1)
									l_fp.ce_gets ((create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + l_i___0) + 1)
									if (a_getlevel.c_pointer.to_integer_32).to_natural_32 = ((foldlevelMarker_address).c_pointer.to_integer_32).to_natural_32 then
										l_finish := 1
									elseif (a_getlevel.c_pointer.to_integer_32).to_natural_32 = ((foldlevelExpr_address).c_pointer.to_integer_32).to_natural_32 then
										l_finish := 1
									elseif (a_getlevel.c_pointer.to_integer_32).to_natural_32 = ((foldlevelSyntax_address).c_pointer.to_integer_32).to_natural_32 then
										l_finish := 1
									end
								end
							end
						end
				when 38 then
						js.break
				when 39 then -- if done
						if not js.loop_jumped then
							if l_fp.item.fd_top >= a_startlnum then
								deleteFoldEntry (a_gap, l_fp.distance ((create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data))), 1)
							else
								l_fp.item.fd_len := a_startlnum - l_fp.item.fd_top
								foldMarkAdjustRecurse (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + {PD_FOLD_T}.fd_nested_offset), l_fp.item.fd_len, 2147483647, 2147483647, 0)
								fold_changed := 1
							end
						end
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else:
						l_pos := -1 + 45 -- goto _L___1
				when 42 then -- if done | if block done, skip else block:
						l_pos := -1 + 44
				when 43 then -- else:
						l_pos := -1 + 45 -- goto _L___1
				when 44 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 46
				when 45 then -- else: | _L___1:
						l_i___0 := l_fp.distance ((create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data)))
						if (foldInsert (a_gap, l_i___0)) /= 1 then
							Result := l_bot
							js.return
						end
						if not js.return_called then
							l_fp.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + l_i___0)
							l_fp.item.fd_top := l_firstlnum
							l_fp.item.fd_len := (l_bot - l_firstlnum) + 1
							if a_topflags = 0 then
								(a_flp.item.wp).item.w_fold_manual := (1).to_integer_8
								l_fp.item.fd_flags := (0).to_integer_8
							elseif l_i___0 <= 0 then
								l_fp.item.fd_flags := a_topflags.to_integer_8
								if a_topflags /= 2 then
									(a_flp.item.wp).item.w_fold_manual := (1).to_integer_8
								end
							else
								l_fp.item.fd_flags := (l_fp - 1).item.fd_flags
							end
							l_fp.item.fd_small := (2).to_integer_8
							if (a_getlevel.c_pointer.to_integer_32).to_natural_32 = ((foldlevelMarker_address).c_pointer.to_integer_32).to_natural_32 then
								l_finish := 1
							elseif (a_getlevel.c_pointer.to_integer_32).to_natural_32 = ((foldlevelExpr_address).c_pointer.to_integer_32).to_natural_32 then
								l_finish := 1
							elseif (a_getlevel.c_pointer.to_integer_32).to_natural_32 = ((foldlevelSyntax_address).c_pointer.to_integer_32).to_natural_32 then
								l_finish := 1
							end
							fold_changed := 1
							js.break
						end
				when 46 then -- if done | if done | if done
						l_pos := -1 + 17 -- back to loop condition
				when 47 then -- loop done
						js.reset
				when 48 then -- if done | if done | if done | if done | if done
						if js.return_called then
							l_pos := -1 + 54 -- skip if block
						end
				when 49 then -- if:
						if l_lvl < a_level then
							js.break
						elseif a_flp.item.lnum > l_linecount then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 54 -- skip if block
						end
				when 50 then -- if:
						if not (l_lvl > a_level) then
							l_pos := -1 + 53 -- skip if block
						end
				when 51 then -- if:
						if (l_fp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if l_bot < a_flp.item.lnum then
								l_bot := a_flp.item.lnum
							end
							a_flp.item.lnum := a_flp.item.lnum_save - l_fp.item.fd_top
							a_flp.item.off := a_flp.item.off + (l_fp.item.fd_top)
							l_i___0 := l_fp.distance ((create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data)))
							l_bot := foldUpdateIEMSRecurse (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + {PD_FOLD_T}.fd_nested_offset), a_level + 1, l_startlnum2 - l_fp.item.fd_top, a_flp, a_getlevel, l_bot - l_fp.item.fd_top, (l_fp.item.fd_flags).to_integer_32)
							l_fp.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + l_i___0)
							a_flp.item.lnum := a_flp.item.lnum + (l_fp.item.fd_top)
							a_flp.item.lnum_save := a_flp.item.lnum_save + (l_fp.item.fd_top)
							a_flp.item.off := a_flp.item.off - (l_fp.item.fd_top)
							l_bot := l_bot + (l_fp.item.fd_top)
							l_startlnum2 := a_flp.item.lnum
						else
							l_pos := -1 + 53 -- goto _L___6
						end
				when 52 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 53 then -- else: | _L___6:
						a_flp.item.lnum := a_flp.item.lnum_save
						l_ll := a_flp.item.lnum + 1
						from
						until
							not (not js.loop_left and then (not globals_inst.got_int.to_boolean))
						loop
							js.reset
							prev_lnum___0 := a_flp.item.lnum
							prev_lnum_lvl := a_flp.item.lvl
							a_flp.item.lnum := (a_flp.item.lnum) + 1
							if a_flp.item.lnum > l_linecount then
								js.break
							end
							if not js.loop_jumped then
								a_flp.item.lvl := a_flp.item.lvl_next
								a_getlevel.call ([a_flp])
								if a_flp.item.lvl >= 0 then
									js.break
								elseif a_flp.item.had_end <= 20 then
									js.break
								end
							end
						end
						js.reset
						prev_lnum___0 := (0).to_integer_32
						if a_flp.item.lnum > l_linecount then
							js.break
						end
						if not js.loop_jumped then
							a_flp.item.lnum_save := a_flp.item.lnum
							a_flp.item.lnum := l_ll
						end
				when 54 then -- if done | if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 55 then -- loop done
					js.reset
					if not js.return_called and then ((l_fp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32) then
						Result := l_bot
						js.return
					end
					if not js.return_called then
						if l_fp.item.fd_len < a_flp.item.lnum - l_fp.item.fd_top then
							l_fp.item.fd_len := a_flp.item.lnum - l_fp.item.fd_top
							l_fp.item.fd_small := (2).to_integer_8
							fold_changed := 1
						end
						foldRemove (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + {PD_FOLD_T}.fd_nested_offset), l_startlnum2 - l_fp.item.fd_top, (a_flp.item.lnum - 1) - l_fp.item.fd_top)
						if l_lvl < a_level then
							if l_fp.item.fd_len /= a_flp.item.lnum - l_fp.item.fd_top then
								if l_fp.item.fd_top + l_fp.item.fd_len > l_bot + 1 then
									if (a_getlevel.c_pointer.to_integer_32).to_natural_32 = ((foldlevelMarker_address).c_pointer.to_integer_32).to_natural_32 then
										l_bot := (l_fp.item.fd_top + l_fp.item.fd_len) - 1
										l_fp.item.fd_len := a_flp.item.lnum - l_fp.item.fd_top
									elseif (a_getlevel.c_pointer.to_integer_32).to_natural_32 = ((foldlevelExpr_address).c_pointer.to_integer_32).to_natural_32 then
										l_bot := (l_fp.item.fd_top + l_fp.item.fd_len) - 1
										l_fp.item.fd_len := a_flp.item.lnum - l_fp.item.fd_top
									elseif (a_getlevel.c_pointer.to_integer_32).to_natural_32 = ((foldlevelSyntax_address).c_pointer.to_integer_32).to_natural_32 then
										l_bot := (l_fp.item.fd_top + l_fp.item.fd_len) - 1
										l_fp.item.fd_len := a_flp.item.lnum - l_fp.item.fd_top
									else
										l_i___0 := l_fp.distance ((create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data)))
										foldSplit (a_gap, l_i___0, a_flp.item.lnum, l_bot)
										l_fp.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + l_i___0)
									end
								else
									l_fp.item.fd_len := a_flp.item.lnum - l_fp.item.fd_top
								end
								fold_changed := 1
							end
						end
						from
						until
							js.loop_left
						loop
							js.reset
							l_fp2.ce_gets (l_fp + 1)
							if (l_fp2.c_pointer.to_integer_32).to_natural_32 >= ((create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + a_gap.item.ga_len).c_pointer.to_integer_32).to_natural_32 then
								js.break
							elseif l_fp2.item.fd_top > a_flp.item.lnum then
								js.break
							end
							if not js.loop_jumped and then (l_fp2.item.fd_top + l_fp2.item.fd_len > a_flp.item.lnum) then
								if l_fp2.item.fd_top < a_flp.item.lnum then
									foldMarkAdjustRecurse (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp2.c_pointer + {PD_FOLD_T}.fd_nested_offset), (0).to_integer_32, (a_flp.item.lnum - l_fp2.item.fd_top) - 1, 2147483647, l_fp2.item.fd_top - a_flp.item.lnum)
									l_fp2.item.fd_len := l_fp2.item.fd_len - (a_flp.item.lnum - l_fp2.item.fd_top)
									l_fp2.item.fd_top := a_flp.item.lnum
									fold_changed := 1
								end
								if l_lvl >= a_level then
									foldMerge (l_fp, a_gap, l_fp2)
								end
								js.break
							end
							if not js.loop_jumped then
								fold_changed := 1
								deleteFoldEntry (a_gap, l_fp2.distance ((create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data))), 1)
							end
						end
						js.reset
						if l_bot < a_flp.item.lnum - 1 then
							l_bot := a_flp.item.lnum - 1
						end
						Result := l_bot
					end
				when 56 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	foldInsert (a_gap: CE_POINTER [PD_GROWARRAY]; a_i___0: INTEGER_32): INTEGER_32
		local
			l_fp: CE_POINTER [PD_FOLD_T]
			js: JUMP_STATE
		do
			create l_fp.make

			if (misc2_inst.ga_grow (a_gap, 1)) /= 1 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_fp.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + a_i___0)
				if a_i___0 < a_gap.item.ga_len then
					memmove (create {CE_POINTER [ANY]}.make_cast ((l_fp + 1)), create {CE_POINTER [ANY]}.make_cast (l_fp), {PD_FOLD_T}.sizeof.to_natural_32 * (a_gap.item.ga_len - a_i___0).to_natural_32).do_nothing
				end
				a_gap.item.ga_len := (a_gap.item.ga_len) + 1
				misc2_inst.ga_init2 (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + {PD_FOLD_T}.fd_nested_offset), ({PD_FOLD_T}.sizeof.to_natural_32).to_integer_32, 10)
				Result := 1
			end
		end

	foldSplit (a_gap: CE_POINTER [PD_GROWARRAY]; a_i___0: INTEGER_32; a_top: INTEGER_32; a_bot: INTEGER_32)
		local
			l_fp: CE_POINTER [PD_FOLD_T]
			l_fp2: CE_POINTER [PD_FOLD_T]
			l_gap1: CE_POINTER [PD_GROWARRAY]
			l_gap2: CE_POINTER [PD_GROWARRAY]
			l_idx: INTEGER_32
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			create l_fp.make
			create l_fp2.make
			create l_gap1.make
			create l_gap2.make

			if (foldInsert (a_gap, a_i___0 + 1)) = 0 then
				js.return
			end
			if not js.return_called then
				l_fp.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + a_i___0);
				(l_fp + 1).item.fd_top := a_bot + 1;
				(l_fp + 1).item.fd_len := l_fp.item.fd_len - ((l_fp + 1).item.fd_top - l_fp.item.fd_top);
				(l_fp + 1).item.fd_flags := l_fp.item.fd_flags;
				(l_fp + 1).item.fd_small := (2).to_integer_8
				l_fp.item.fd_small := (2).to_integer_8
				l_gap1.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + {PD_FOLD_T}.fd_nested_offset))
				l_gap2.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared ((l_fp + 1).c_pointer + {PD_FOLD_T}.fd_nested_offset))
				foldFind (l_gap1, (a_bot + 1) - l_fp.item.fd_top, l_fp2.address).do_nothing
				l_len := (create {CE_POINTER [PD_FOLD_T]}.make_cast (l_gap1.item.ga_data) + l_gap1.item.ga_len).distance (l_fp2)
				if l_len > 0 then
					if (misc2_inst.ga_grow (l_gap2, l_len)) = 1 then
						l_idx := 0
						from
						until
							not (l_idx < l_len)
						loop
							create {CE_POINTER [PD_FOLD_T]}.make_cast (l_gap2.item.ga_data)[l_idx] := l_fp2[l_idx];
							(create {CE_POINTER [PD_FOLD_T]}.make_cast (l_gap2.item.ga_data) + l_idx).item.fd_top := (create {CE_POINTER [PD_FOLD_T]}.make_cast (l_gap2.item.ga_data) + l_idx).item.fd_top - ((l_fp + 1).item.fd_top - l_fp.item.fd_top)
							l_idx := l_idx + 1
						end
						l_gap2.item.ga_len := l_len
						l_gap1.item.ga_len := l_gap1.item.ga_len - l_len
					end
				end
				l_fp.item.fd_len := a_top - l_fp.item.fd_top
				fold_changed := 1
			end
		end

	foldRemove (a_gap: CE_POINTER [PD_GROWARRAY]; a_top: INTEGER_32; a_bot: INTEGER_32)
		local
			l_fp: CE_POINTER [PD_FOLD_T]
			js: JUMP_STATE
		do
			create l_fp.make

			l_fp.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_shared (default_pointer))
			if a_bot < a_top then
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					if (foldFind (a_gap, a_top, l_fp.address)).to_boolean then
						if l_fp.item.fd_top < a_top then
							foldRemove (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + {PD_FOLD_T}.fd_nested_offset), a_top - l_fp.item.fd_top, a_bot - l_fp.item.fd_top)
							if l_fp.item.fd_top + l_fp.item.fd_len > a_bot + 1 then
								foldSplit (a_gap, l_fp.distance ((create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data))), a_top, a_bot)
							else
								l_fp.item.fd_len := a_top - l_fp.item.fd_top
							end
							fold_changed := 1
							js.continue
						end
					end
					if not js.loop_jumped then
						if (l_fp.c_pointer.to_integer_32).to_natural_32 >= ((create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + a_gap.item.ga_len).c_pointer.to_integer_32).to_natural_32 then
							js.break
						elseif l_fp.item.fd_top > a_bot then
							js.break
						end
					end
					if not js.loop_jumped and then (l_fp.item.fd_top >= a_top) then
						fold_changed := 1
						if (l_fp.item.fd_top + l_fp.item.fd_len) - 1 > a_bot then
							foldMarkAdjustRecurse (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + {PD_FOLD_T}.fd_nested_offset), (0).to_integer_32, a_bot - l_fp.item.fd_top, 2147483647, (l_fp.item.fd_top - a_bot) - 1)
							l_fp.item.fd_len := l_fp.item.fd_len - ((a_bot - l_fp.item.fd_top) + 1)
							l_fp.item.fd_top := a_bot + 1
							js.break
						end
						if not js.loop_jumped then
							deleteFoldEntry (a_gap, l_fp.distance ((create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data))), 1)
						end
					end
					if not js.loop_left then
						
					end
				end
				js.reset
			end
		end

	foldMerge (a_fp1: CE_POINTER [PD_FOLD_T]; a_gap: CE_POINTER [PD_GROWARRAY]; a_fp2: CE_POINTER [PD_FOLD_T])
		local
			l_fp3: CE_POINTER [PD_FOLD_T]
			l_fp4: CE_POINTER [PD_FOLD_T]
			l_idx: INTEGER_32
			l_gap1: CE_POINTER [PD_GROWARRAY]
			l_gap2: CE_POINTER [PD_GROWARRAY]
		do
			create l_fp3.make
			create l_fp4.make
			create l_gap1.make
			create l_gap2.make

			l_gap1.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_fp1.c_pointer + {PD_FOLD_T}.fd_nested_offset))
			l_gap2.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_fp2.c_pointer + {PD_FOLD_T}.fd_nested_offset))
			if (foldFind (l_gap1, a_fp1.item.fd_len - 1, l_fp3.address)).to_boolean then
				if (foldFind (l_gap2, 0, l_fp4.address)).to_boolean then
					foldMerge (l_fp3, l_gap2, l_fp4)
				end
			end
			if l_gap2.item.ga_len > 0 then
				if (misc2_inst.ga_grow (l_gap1, l_gap2.item.ga_len)) = 1 then
					l_idx := 0
					from
					until
						not (l_idx < l_gap2.item.ga_len)
					loop
						create {CE_POINTER [PD_FOLD_T]}.make_cast (l_gap1.item.ga_data)[l_gap1.item.ga_len] := create {CE_POINTER [PD_FOLD_T]}.make_cast (l_gap2.item.ga_data)[l_idx];
						(create {CE_POINTER [PD_FOLD_T]}.make_cast (l_gap1.item.ga_data) + l_gap1.item.ga_len).item.fd_top := (create {CE_POINTER [PD_FOLD_T]}.make_cast (l_gap1.item.ga_data) + l_gap1.item.ga_len).item.fd_top + (a_fp1.item.fd_len)
						l_gap1.item.ga_len := (l_gap1.item.ga_len) + 1
						l_idx := l_idx + 1
					end
					l_gap2.item.ga_len := 0
				end
			end
			a_fp1.item.fd_len := a_fp1.item.fd_len + (a_fp2.item.fd_len)
			deleteFoldEntry (a_gap, a_fp2.distance ((create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data))), 1)
			fold_changed := 1
		end

	foldlevelIndent (a_flp: CE_POINTER [PD_FLINE_T])
		local
			l_s: CE_POINTER [NATURAL_8]
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_lnum: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_buf___6.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lnum := a_flp.item.lnum + a_flp.item.off
					l_buf___6.ce_gets ((a_flp.item.wp).item.w_buffer)
					l_s.ce_gets (charset_inst.skipwhite ((memline_inst.ml_get_buf (l_buf___6, l_lnum, 0))))
					if (l_s.item).to_integer_32 /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if ((misc2_inst.vim_strchr ((a_flp.item.wp).item.w_onebuf_opt.wo_fdi, (l_s.item).to_integer_32)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						if l_lnum = 1 then
							a_flp.item.lvl := 0
						elseif l_lnum = l_buf___6.item.b_ml.ml_line_count then
							a_flp.item.lvl := 0
						else
							a_flp.item.lvl := -1
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						a_flp.item.lvl := ((misc1_inst.get_indent_buf (l_buf___6, l_lnum)).to_integer_32 // l_buf___6.item.b_p_sw).to_integer_32
				when 7 then -- if done
						if (a_flp.item.lvl).to_integer_32 > (a_flp.item.wp).item.w_onebuf_opt.wo_fdn then
							a_flp.item.lvl := ((a_flp.item.wp).item.w_onebuf_opt.wo_fdn).to_integer_32
							if a_flp.item.lvl < 0 then
								a_flp.item.lvl := 0
							end
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	foldlevelIndent_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent foldlevelIndent)
		end

	foldlevelDiff (a_flp: CE_POINTER [PD_FLINE_T])
		do
			if (diff_inst.diff_infold (a_flp.item.wp, a_flp.item.lnum + a_flp.item.off)).to_boolean then
				a_flp.item.lvl := 1
			else
				a_flp.item.lvl := 0
			end
		end

	foldlevelDiff_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent foldlevelDiff)
		end

	foldlevelExpr (a_flp: CE_POINTER [PD_FLINE_T])
		local
			l_win: CE_POINTER [PD_WINDOW_S]
			l_n: INTEGER_32
			l_c: INTEGER_32
			l_lnum: INTEGER_32
			l_save_keytyped: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_win.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lnum := a_flp.item.lnum + a_flp.item.off
					l_win.ce_gets (globals_inst.curwin)
					globals_inst.curwin.ce_gets (a_flp.item.wp)
					globals_inst.curbuf.ce_gets ((a_flp.item.wp).item.w_buffer)
					eval_inst.set_vim_var_nr (9, l_lnum)
					a_flp.item.start := 0
					a_flp.item.had_end := a_flp.item.end2
					a_flp.item.end2 := 21
					if l_lnum <= 1 then
						a_flp.item.lvl := 0
					end
					l_save_keytyped := globals_inst.KeyTyped
					l_n := eval_inst.eval_foldexpr ((a_flp.item.wp).item.w_onebuf_opt.wo_fde, create {CE_POINTER [INTEGER_32]}.make_shared ($l_c))
					globals_inst.KeyTyped := l_save_keytyped
					inspect l_c -- switch 1 head
					when 97 then l_pos := -1 + 1
					when 115 then l_pos := -1 + 2
					when 62 then l_pos := -1 + 3
					when 60 then l_pos := -1 + 4
					when 61 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 1 then -- switch 1, case 97
					if a_flp.item.lvl >= 0 then
						a_flp.item.lvl := a_flp.item.lvl + l_n
						a_flp.item.lvl_next := a_flp.item.lvl
					end
					a_flp.item.start := l_n
					l_pos := -1 + 7 -- switch 1; break
				when 2 then -- switch 1, case 115
					if a_flp.item.lvl >= 0 then
						if l_n > a_flp.item.lvl then
							a_flp.item.lvl_next := 0
						else
							a_flp.item.lvl_next := a_flp.item.lvl - l_n
						end
						a_flp.item.end2 := a_flp.item.lvl_next + 1
					end
					l_pos := -1 + 7 -- switch 1; break
				when 3 then -- switch 1, case 62
					a_flp.item.lvl := l_n
					a_flp.item.lvl_next := l_n
					a_flp.item.start := 1
					l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 60
					a_flp.item.lvl_next := l_n - 1
					a_flp.item.end2 := l_n
					l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 61
					a_flp.item.lvl_next := a_flp.item.lvl
					l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, default:
					if l_n < 0 then
						a_flp.item.lvl_next := a_flp.item.lvl
					else
						a_flp.item.lvl_next := l_n
					end
					a_flp.item.lvl := l_n
					l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
					if a_flp.item.lvl < 0 then
						if l_lnum <= 1 then
							a_flp.item.lvl := 0
							a_flp.item.lvl_next := 0
						end
						if l_lnum = globals_inst.curbuf.item.b_ml.ml_line_count then
							a_flp.item.lvl_next := 0
						end
					end
					globals_inst.curwin.ce_gets (l_win)
					globals_inst.curbuf.ce_gets (globals_inst.curwin.item.w_buffer)
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	foldlevelExpr_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent foldlevelExpr)
		end

	parseMarker (a_wp___0: CE_POINTER [PD_WINDOW_S])
		local
			l_tmp: CE_POINTER [NATURAL_8]
		do
			create l_tmp.make

			foldendmarker.ce_gets (misc2_inst.vim_strchr (a_wp___0.item.w_onebuf_opt.wo_fmr, (',').code))
			l_tmp.ce_gets (foldendmarker)
			foldendmarker.ce_gets (foldendmarker + 1)
			foldstartmarkerlen := l_tmp.distance ((a_wp___0.item.w_onebuf_opt.wo_fmr))
			foldendmarkerlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (foldendmarker))).to_integer_32
		end

	foldlevelMarker (a_flp: CE_POINTER [PD_FLINE_T])
		local
			l_startmarker: CE_POINTER [NATURAL_8]
			l_cstart: INTEGER_32
			l_cend: INTEGER_32
			l_start_lvl: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			l_tmp___0: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_startmarker.make
			create l_s.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_start_lvl := a_flp.item.lvl
					l_startmarker.ce_gets ((a_flp.item.wp).item.w_onebuf_opt.wo_fmr)
					l_cstart := (l_startmarker.item).to_integer_32
					l_startmarker.ce_gets (l_startmarker + 1)
					l_cend := (foldendmarker.item).to_integer_32
					a_flp.item.start := 0
					a_flp.item.lvl_next := a_flp.item.lvl
					l_s.ce_gets (memline_inst.ml_get_buf ((a_flp.item.wp).item.w_buffer, a_flp.item.lnum + a_flp.item.off, 0))
				when 1 then -- loop condition:
					if not ((l_s.item).to_boolean) then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						if (l_s.item).to_integer_32 /= l_cstart then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_s + 1)), create {CE_POINTER [INTEGER_8]}.make_cast (l_startmarker), (foldstartmarkerlen - 1).to_natural_32)) = 0 then
							l_s.ce_gets (l_s + foldstartmarkerlen)
							if (l_s.item).to_integer_32 >= 48 then
								if (l_s.item).to_integer_32 <= 57 then
									l_n := atoi (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))
									if l_n > 0 then
										a_flp.item.lvl := l_n
										a_flp.item.lvl_next := l_n
										if l_n <= l_start_lvl then
											a_flp.item.start := 1
										else
											a_flp.item.start := l_n - l_start_lvl
										end
									end
								else
									a_flp.item.lvl := (a_flp.item.lvl) + 1
									a_flp.item.lvl_next := (a_flp.item.lvl_next) + 1
									a_flp.item.start := (a_flp.item.start) + 1
								end
							else
								a_flp.item.lvl := (a_flp.item.lvl) + 1
								a_flp.item.lvl_next := (a_flp.item.lvl_next) + 1
								a_flp.item.start := (a_flp.item.start) + 1
							end
						else
							l_pos := -1 + 5 -- goto _L___0
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else: | _L___0:
						if (l_s.item).to_integer_32 /= l_cend then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_s + 1)), create {CE_POINTER [INTEGER_8]}.make_cast ((foldendmarker + 1)), (foldendmarkerlen - 1).to_natural_32)) = 0 then
							l_s.ce_gets (l_s + foldendmarkerlen)
							if (l_s.item).to_integer_32 >= 48 then
								if (l_s.item).to_integer_32 <= 57 then
									l_n := atoi (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))
									if l_n > 0 then
										a_flp.item.lvl := l_n
										a_flp.item.lvl_next := l_n - 1
										if a_flp.item.lvl_next > l_start_lvl then
											a_flp.item.lvl_next := l_start_lvl
										end
									end
								else
									a_flp.item.lvl_next := (a_flp.item.lvl_next) - 1
								end
							else
								a_flp.item.lvl_next := (a_flp.item.lvl_next) - 1
							end
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if globals_inst.has_mbyte.to_boolean then
							l_tmp___0 := (globals_inst.mb_ptr2len.integer_32_item ([l_s]))
						else
							l_tmp___0 := 1
						end
						l_s.ce_gets (l_s + l_tmp___0)
				when 9 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					if a_flp.item.lvl_next < 0 then
						a_flp.item.lvl_next := 0
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	foldlevelMarker_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent foldlevelMarker)
		end

	foldlevelSyntax (a_flp: CE_POINTER [PD_FLINE_T])
		local
			l_lnum: INTEGER_32
			l_n: INTEGER_32
		do
			l_lnum := a_flp.item.lnum + a_flp.item.off
			a_flp.item.lvl := syntax_inst.syn_get_foldlevel (a_flp.item.wp, l_lnum)
			a_flp.item.start := 0
			if l_lnum < ((a_flp.item.wp).item.w_buffer).item.b_ml.ml_line_count then
				l_n := syntax_inst.syn_get_foldlevel (a_flp.item.wp, l_lnum + 1)
				if l_n > a_flp.item.lvl then
					a_flp.item.start := l_n - a_flp.item.lvl
					a_flp.item.lvl := l_n
				end
			end
		end

	foldlevelSyntax_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent foldlevelSyntax)
		end

	put_folds (a_fd: CE_POINTER [SD_IO_FILE]; a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (foldmethodIsManual (a_wp___0)).to_boolean then
				if (ex_docmd_inst.put_line (a_fd, ce_string ("silent! normal! zE"))) = 0 then
					Result := 0
					js.return
				elseif (put_folds_recurse (a_fd, create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_wp___0.c_pointer + {PD_WINDOW_S}.w_folds_offset), (0).to_integer_32)) = 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called and then ((a_wp___0.item.w_fold_manual).to_boolean) then
				Result := (put_foldopen_recurse (a_fd, create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_wp___0.c_pointer + {PD_WINDOW_S}.w_folds_offset), (0).to_integer_32))
				js.return
			end
			if not js.return_called then
				Result := 1
			end
		end

	put_folds_recurse (a_fd: CE_POINTER [SD_IO_FILE]; a_gap: CE_POINTER [PD_GROWARRAY]; a_off___0: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_fp: CE_POINTER [PD_FOLD_T]
			js: JUMP_STATE
		do
			create l_fp.make

			l_fp.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data))
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (l_i___0 < a_gap.item.ga_len))
			loop
				if (put_folds_recurse (a_fd, create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + {PD_FOLD_T}.fd_nested_offset), a_off___0 + l_fp.item.fd_top)) = 0 then
					Result := 0
					js.return
				end
				if not js.return_called then
					if (fprintf ([a_fd, ce_string ("%%ld,%%ldfold"), l_fp.item.fd_top + a_off___0, ((l_fp.item.fd_top + a_off___0) + l_fp.item.fd_len) - 1])) < 0 then
						Result := 0
						js.return
					elseif (ex_docmd_inst.put_eol (a_fd)) = 0 then
						Result := 0
						js.return
					end
				end
				if not js.return_called then
					l_fp.ce_gets (l_fp + 1)
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	put_foldopen_recurse (a_fd: CE_POINTER [SD_IO_FILE]; a_gap: CE_POINTER [PD_GROWARRAY]; a_off___0: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_fp: CE_POINTER [PD_FOLD_T]
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
		do
			create l_fp.make

			l_fp.ce_gets (create {CE_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data))
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (l_i___0 < a_gap.item.ga_len))
			loop
				if (l_fp.item.fd_flags).to_integer_32 /= 2 then
					if l_fp.item.fd_nested.ga_len > 0 then
						if (fprintf ([a_fd, ce_string ("%%ld"), l_fp.item.fd_top + a_off___0])) < 0 then
							Result := 0
							js.return
						elseif (ex_docmd_inst.put_eol (a_fd)) = 0 then
							Result := 0
							js.return
						elseif (ex_docmd_inst.put_line (a_fd, ce_string ("normal zo"))) = 0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							if (put_foldopen_recurse (a_fd, create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + {PD_FOLD_T}.fd_nested_offset), a_off___0 + l_fp.item.fd_top)) = 0 then
								Result := 0
								js.return
							end
						end
					end
					if not js.return_called then
						if (fprintf ([a_fd, ce_string ("%%ld"), l_fp.item.fd_top + a_off___0])) < 0 then
							Result := 0
							js.return
						elseif (ex_docmd_inst.put_eol (a_fd)) = 0 then
							Result := 0
							js.return
						else
							if (l_fp.item.fd_flags).to_integer_32 = 1 then
								l_tmp___5 := ('c').code
							else
								l_tmp___5 := ('o').code
							end
							if (fprintf ([a_fd, ce_string ("normal z%%c"), l_tmp___5])) < 0 then
								Result := 0
								js.return
							elseif (ex_docmd_inst.put_eol (a_fd)) = 0 then
								Result := 0
								js.return
							end
						end
					end
				end
				if not js.return_called then
					l_fp.ce_gets (l_fp + 1)
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

end
