class
	P_IF_XCMDSRV

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create pendingCommands.make
			create serverReply.make
			create empty_prop.make
		end

feature {ANY} -- attributes

	pendingCommands: CE_POINTER [PD_PENDINGCOMMAND]

	serverReply: PD_GROWARRAY

	registryProperty: NATURAL_32 assign set_registryProperty

	set_registryProperty (a_registryProperty: NATURAL_32)
		do
			registryProperty := a_registryProperty
		end

	vimProperty: NATURAL_32 assign set_vimProperty

	set_vimProperty (a_vimProperty: NATURAL_32)
		do
			vimProperty := a_vimProperty
		end

	got_x_error: INTEGER_32 assign set_got_x_error

	set_got_x_error (a_got_x_error: INTEGER_32)
		do
			got_x_error := a_got_x_error
		end

	empty_prop: CE_POINTER [NATURAL_8]

	serial: INTEGER_32 assign set_serial

	set_serial (a_serial: INTEGER_32)
		do
			serial := a_serial
		end

feature {ANY} -- routines

	serverRegisterName (a_dpy: CE_POINTER [ANY]; a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_res: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_res := DoRegisterName (a_dpy, a_name___1)
					if not (l_res < 0) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_i___0 := 1
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if l_res < -1 then
							l_tmp.ce_gets (gettext (ce_string ("Unable to register a command server name")))
							message_inst.msg_attr (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp), globals_inst.highlight_attr[17]).do_nothing
							Result := 0
							js.return
						elseif l_i___0 >= 1000 then
							l_tmp.ce_gets (gettext (ce_string ("Unable to register a command server name")))
							message_inst.msg_attr (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp), globals_inst.highlight_attr[17]).do_nothing
							Result := 0
							js.return
						end
						if not js.return_called then
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_p___0.ce_gets (misc2_inst.alloc ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1))) + {NATURAL_32} 10))
							end
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_res := -10
								js.continue
							end
							if not js.loop_jumped then
								l_tmp___1 := l_i___0
								l_i___0 := l_i___0 + 1
								sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("%%s%%d"), a_name___1, l_tmp___1]).do_nothing
								l_res := DoRegisterName (a_dpy, l_p___0)
							end
							if not js.loop_left and then (not (l_res < 0)) then
								l_pos := -1 + 5 -- break
							end
						end
				when 4 then
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
						js.reset
						if not js.return_called then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
						end
				when 6 then -- if done
					if not js.return_called then
						Result := 1
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	DoRegisterName (a_dpy: CE_POINTER [ANY]; a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_w: NATURAL_32
			l_old_handler: CE_ROUTINE
			l_propInfo: CE_ARRAY [NATURAL_8]
			l_status: INTEGER_32
			l_dummyInt: INTEGER_32
			l_dummyUns: NATURAL_32
			l_dummyWin: NATURAL_32
			js: JUMP_STATE
		do
			create l_old_handler.make
			create l_propInfo.make (<<120>>)

			if globals_inst.commProperty = {NATURAL_32} 0 then
				if (SendInit (a_dpy)) < 0 then
					Result := (-2)
					js.return
				end
			end
			if not js.return_called then
				XGrabServer (a_dpy).do_nothing
				l_w := LookupName (a_dpy, a_name___1, 0, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))
				if l_w /= {NATURAL_32} 0 then
					l_old_handler.ce_gets (XSetErrorHandler (x_error_check_address))
					l_status := XGetGeometry (a_dpy, l_w, create {CE_POINTER [NATURAL_32]}.make_shared ($l_dummyWin), create {CE_POINTER [INTEGER_32]}.make_shared ($l_dummyInt), create {CE_POINTER [INTEGER_32]}.make_shared ($l_dummyInt), create {CE_POINTER [NATURAL_32]}.make_shared ($l_dummyUns), create {CE_POINTER [NATURAL_32]}.make_shared ($l_dummyUns), create {CE_POINTER [NATURAL_32]}.make_shared ($l_dummyUns), create {CE_POINTER [NATURAL_32]}.make_shared ($l_dummyUns))
					XSetErrorHandler (l_old_handler).do_nothing
					if l_status /= 0 then
						if l_w /= globals_inst.commWindow then
							XUngrabServer (a_dpy).do_nothing
							XFlush (a_dpy).do_nothing
							Result := (-1)
							js.return
						end
					end
					if not js.return_called then
						LookupName (a_dpy, a_name___1, 1, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)).do_nothing
					end
				end
			end
			if not js.return_called then
				sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_propInfo), ce_string ("%%x %%.*s"), globals_inst.commWindow.to_natural_32, 100, a_name___1]).do_nothing
				l_old_handler.ce_gets (XSetErrorHandler (x_error_check_address))
				got_x_error := 0
				XChangeProperty (a_dpy, ((create {CE_POINTER [SD_XPRIVDISPLAY]}.make_cast (a_dpy)).item.screens + 0).item.root, registryProperty, (31).to_natural_32, 8, 2, create {CE_POINTER [NATURAL_8]}.make_cast (l_propInfo), ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_propInfo))) + {NATURAL_32} 1).to_integer_32).do_nothing
				XUngrabServer (a_dpy).do_nothing
				XSync (a_dpy, 0).do_nothing
				XSetErrorHandler (l_old_handler).do_nothing
				if not got_x_error.to_boolean then
					eval_inst.set_vim_var_string (27, a_name___1, -1)
					globals_inst.serverName.ce_gets (misc2_inst.vim_strsave (a_name___1))
					globals_inst.need_maketitle := 1
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := (-2)
			end
		end

	serverChangeRegisteredWindow (a_dpy: CE_POINTER [ANY]; a_newwin: NATURAL_32)
		local
			l_propInfo: CE_ARRAY [NATURAL_8]
			js: JUMP_STATE
		do
			create l_propInfo.make (<<120>>)

			globals_inst.commWindow := a_newwin
			if (SendInit (a_dpy)) < 0 then
				js.return
			end
			if not js.return_called then
				XGrabServer (a_dpy).do_nothing
				DeleteAnyLingerer (a_dpy, a_newwin)
				if (globals_inst.serverName.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					LookupName (a_dpy, globals_inst.serverName, 1, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)).do_nothing
					sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_propInfo), ce_string ("%%x %%.*s"), a_newwin.to_natural_32, 100, globals_inst.serverName]).do_nothing
					XChangeProperty (a_dpy, ((create {CE_POINTER [SD_XPRIVDISPLAY]}.make_cast (a_dpy)).item.screens + 0).item.root, registryProperty, (31).to_natural_32, 8, 2, create {CE_POINTER [NATURAL_8]}.make_cast (l_propInfo), ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_propInfo))) + {NATURAL_32} 1).to_integer_32).do_nothing
				end
				XUngrabServer (a_dpy).do_nothing
			end
		end

	serverSendToVim (a_dpy: CE_POINTER [ANY]; a_name___1: CE_POINTER [NATURAL_8]; a_cmd: CE_POINTER [NATURAL_8]; a_result___2: CE_POINTER [CE_POINTER [NATURAL_8]]; a_server: CE_POINTER [NATURAL_32]; a_asExpr: INTEGER_32; a_localLoop: INTEGER_32; a_silent: INTEGER_32): INTEGER_32
		local
			l_name___1: CE_POINTER [NATURAL_8]
			l_w: NATURAL_32
			l_property: CE_POINTER [NATURAL_8]
			l_length: INTEGER_32
			l_res: INTEGER_32
			l_pending: PD_PENDINGCOMMAND
			l_loosename: CE_POINTER [NATURAL_8]
			l_ret: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___6: NATURAL_32
			l_tmp___7: NATURAL_32
			l_tmp___10: INTEGER_32
			l_pcPtr: CE_POINTER [PD_PENDINGCOMMAND]
			l_tmp___13: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_name___1.make
			create l_property.make
			create l_pending.make
			create l_loosename.make
			create l_ret.make
			create l_tmp___3.make
			create l_pcPtr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_name___1.ce_gets (a_name___1)
					l_loosename.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					if (a_result___2.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						a_result___2.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
					if (l_name___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_name___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("GVIM")))
					elseif (l_name___1.item).to_integer_32 = 0 then
						l_name___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("GVIM")))
					end
					if globals_inst.commProperty = {NATURAL_32} 0 then
						if (a_dpy.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (SendInit (a_dpy)) < 0 then
								Result := (-1)
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if (a_dpy.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 4 then -- else:
						if (globals_inst.serverName.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_name___1), create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.serverName))) /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						if a_asExpr.to_boolean then
							l_ret.ce_gets (main_inst.eval_client_expr_to_string (a_cmd))
							if (a_result___2.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if (l_ret.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									a_result___2.item := misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invexprmsg)))))
								else
									a_result___2.item := l_ret
								end
							else
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ret))
							end
							if (l_ret.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_tmp___1 := -1
							else
								l_tmp___1 := 0
							end
							Result := l_tmp___1
							js.return
						else
							main_inst.server_to_input_buf (a_cmd)
						end
						if not js.return_called then
							Result := 0
							js.return
						end
				when 7 then -- if done | if done | if done
						if not js.return_called then
							from
							until
								js.loop_left
							loop
								js.reset
								l_w := LookupName (a_dpy, l_name___1, 0, l_loosename.address)
								if l_w /= {NATURAL_32} 0 then
									if not (WindowValid (a_dpy, l_w)).to_boolean then
										if ((l_loosename).c_pointer /= default_pointer) then
											l_tmp___3.ce_gets (l_loosename)
										else
											l_tmp___3.ce_gets (l_name___1)
										end
										LookupName (a_dpy, l_tmp___3, 1, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)).do_nothing
										js.continue
									end
								end
								if not js.loop_jumped then
									js.break
								end
							end
							js.reset
							if l_w = {NATURAL_32} 0 then
								if not a_silent.to_boolean then
									message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_noserver)))), l_name___1).do_nothing
								end
								Result := (-1)
								js.return
							elseif (l_loosename.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_name___1.ce_gets (l_loosename)
							end
						end
						if not js.return_called then
							if (a_server.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								a_server.item := l_w
							end
							l_tmp___6 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_name___1))
							l_tmp___7 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_enc))
							l_length := (((l_tmp___6 + l_tmp___7) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd)))) + {NATURAL_32} 14).to_integer_32
							l_property.ce_gets ((misc2_inst.alloc (l_length.to_natural_32 + {NATURAL_32} 30)))
							if a_asExpr.to_boolean then
								l_tmp___10 := ('c').code
							else
								l_tmp___10 := ('k').code
							end
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_property), ce_string ("%%c%%c%%c-n %%s%%c-E %%s%%c-s %%s"), 0, l_tmp___10, 0, l_name___1, 0, option_inst.p_enc, 0, a_cmd]).do_nothing
							if (l_name___1.c_pointer.to_integer_32).to_natural_32 = (l_loosename.c_pointer.to_integer_32).to_natural_32 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_loosename))
							end
							serial := serial + 1
							sprintf ([(create {CE_POINTER [INTEGER_8]}.make_cast (l_property) + l_length), ce_string ("%%c-r %%x %%d"), 0, globals_inst.commWindow.to_natural_32, serial]).do_nothing
							l_length := (l_length.to_natural_32 + ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (((l_property + l_length) + 1)))) + {NATURAL_32} 1)).to_integer_32
							l_res := AppendPropCarefully (a_dpy, l_w, globals_inst.commProperty, l_property, l_length + 1)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_property))
							if l_res < 0 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E248: Failed to send command to the destination program"))))).do_nothing
								Result := (-1)
								js.return
							end
						end
						if not js.return_called and then (not a_asExpr.to_boolean) then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_pending.serial := serial
							l_pending.code := 0
							l_pending.result2 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							l_pending.nextPtr := pendingCommands
							pendingCommands.ce_gets (l_pending.address)
							ServerWait (a_dpy, l_w, WaitForPend_address, create {CE_POINTER [ANY]}.make_cast ((l_pending.address)), a_localLoop, 600)
							if (pendingCommands.c_pointer.to_integer_32).to_natural_32 = ((l_pending.address).c_pointer.to_integer_32).to_natural_32 then
								pendingCommands.ce_gets (l_pending.nextPtr)
							else
								l_pcPtr.ce_gets (pendingCommands)
								from
								until
									not (not js.loop_left and then ((l_pcPtr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
								loop
									js.reset
									if ((l_pcPtr.item.nextPtr).c_pointer.to_integer_32).to_natural_32 = ((l_pending.address).c_pointer.to_integer_32).to_natural_32 then
										l_pcPtr.item.nextPtr := l_pending.nextPtr
										js.break
									end
									if not js.loop_jumped then
										l_pcPtr.ce_gets (l_pcPtr.item.nextPtr)
									end
								end
								js.reset
							end
							if (a_result___2.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								a_result___2.item := l_pending.result2
							else
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_pending.result2))
							end
							if l_pending.code = 0 then
								l_tmp___13 := 0
							else
								l_tmp___13 := -1
							end
							Result := l_tmp___13
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	WaitForPend (a_p___0: CE_POINTER [ANY]): INTEGER_32
		local
			l_pending: CE_POINTER [PD_PENDINGCOMMAND]
		do
			create l_pending.make

			l_pending.ce_gets (create {CE_POINTER [PD_PENDINGCOMMAND]}.make_cast (a_p___0))
			Result := (((l_pending.item.result2).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
		end

	WaitForPend_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent WaitForPend)
		end

	WindowValid (a_dpy: CE_POINTER [ANY]; a_w: NATURAL_32): INTEGER_32
		local
			l_old_handler: CE_ROUTINE
			l_plist: CE_POINTER [NATURAL_32]
			l_numProp: INTEGER_32
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_old_handler.make
			create l_plist.make

			l_old_handler.ce_gets (XSetErrorHandler (x_error_check_address))
			got_x_error := 0
			l_plist.ce_gets (XListProperties (a_dpy, a_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_numProp)))
			XSync (a_dpy, 0).do_nothing
			XSetErrorHandler (l_old_handler).do_nothing
			if (l_plist.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 0
				js.return
			elseif got_x_error.to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_i___0 := 0
				from
				until
					not (not js.loop_left and then (l_i___0 < l_numProp))
				loop
					if l_plist[l_i___0] = vimProperty then
						XFree (create {CE_POINTER [ANY]}.make_cast (l_plist)).do_nothing
						Result := 1
						js.return
					end
					if not js.return_called then
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not js.return_called then
				XFree (create {CE_POINTER [ANY]}.make_cast (l_plist)).do_nothing
				Result := 0
			end
		end

	ServerWait (a_dpy: CE_POINTER [ANY]; a_w: NATURAL_32; a_endCond: CE_ROUTINE; a_endData: CE_POINTER [ANY]; a_localLoop: INTEGER_32; a_seconds: INTEGER_32)
		local
			l_start___1: INTEGER_32
			l_now: INTEGER_32
			l_lastChk: INTEGER_32
			l_event: SD_XEVENT
			l_e: CE_POINTER [SD_XPROPERTYEVENT]
			l_fds: SD_FD_SET
			l_tv: SD_TIMEVAL
			l_d0: INTEGER_32
			l_d1: INTEGER_32
			js: JUMP_STATE
		do
			create l_event.make
			create l_e.make
			create l_fds.make
			create l_tv.make

			l_lastChk := (0).to_integer_32
			l_e.ce_gets (create {CE_POINTER [SD_XPROPERTYEVENT]}.make_cast ((l_event.address)))
			time (create {CE_POINTER [INTEGER_32]}.make_shared ($l_start___1)).do_nothing
			from
			until
				js.loop_left
			loop
				js.reset
				if (a_endCond.integer_32_item ([a_endData])) /= 0 then
					js.break
				end
				if not js.loop_jumped then
					time (create {CE_POINTER [INTEGER_32]}.make_shared ($l_now)).do_nothing
					if a_seconds >= 0 then
						if l_now - l_start___1 >= a_seconds.to_integer_32 then
							js.break
						end
					end
				end
				if not js.loop_jumped and then (l_now /= l_lastChk) then
					l_lastChk := l_now
					if not (WindowValid (a_dpy, a_w)).to_boolean then
						js.break
					end
					if not js.loop_jumped then
						serverEventProc (a_dpy, create {CE_POINTER [SD_XEVENT]}.make_shared (default_pointer))
					end
				end
				if not js.loop_jumped then
					if a_localLoop.to_boolean then
						l_tv.tv_sec := (0).to_integer_32
						l_tv.tv_usec := (50000).to_integer_32
						from
						until
							js.loop_left
						loop
							js.reset
							asm1 (create {CE_POINTER [INTEGER_32]}.make_shared ($l_d0), create {CE_POINTER [INTEGER_32]}.make_shared ($l_d1), l_fds.address)
							js.break
						end
						js.reset
						asm2 (l_fds.address, a_dpy.address)
						if (select2 ((create {CE_POINTER [SD_XPRIVDISPLAY]}.make_cast (a_dpy)).item.fd + 1, (l_fds.address), create {CE_POINTER [SD_FD_SET]}.make_shared (default_pointer), create {CE_POINTER [SD_FD_SET]}.make_shared (default_pointer), (l_tv.address))) < 0 then
							js.break
						end
						if not js.loop_jumped then
							from
							until
								js.loop_left
							loop
								js.reset
								if not ((XEventsQueued (a_dpy, 1)) > 0) then
									js.break
								end
								if not js.loop_jumped then
									XNextEvent (a_dpy, l_event.address).do_nothing
									if l_event.type = 28 then
										if l_e.item.window = globals_inst.commWindow then
											serverEventProc (a_dpy, l_event.address)
										end
									end
								end
							end
							js.reset
						end
					else
						if globals_inst.got_int.to_boolean then
							js.break
						end
						if not js.loop_jumped then
							ui_inst.ui_delay (50, 1)
							ui_inst.ui_breakcheck
						end
					end
				end
			end
			js.reset
		end

	serverGetVimNames (a_dpy: CE_POINTER [ANY]): CE_POINTER [NATURAL_8]
		local
			l_regProp: CE_POINTER [NATURAL_8]
			l_entry: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_numItems: NATURAL_32
			l_w: NATURAL_32
			l_ga: PD_GROWARRAY
			js: JUMP_STATE
		do
			create l_regProp.make
			create l_entry.make
			create l_p___0.make
			create l_ga.make

			if registryProperty = {NATURAL_32} 0 then
				if (SendInit (a_dpy)) < 0 then
					Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				misc2_inst.ga_init2 (l_ga.address, 1, 100)
				if (GetRegProp (a_dpy, l_regProp.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_numItems), 1)) = 0 then
					Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				misc2_inst.ga_init2 (l_ga.address, 1, 100)
				l_p___0.ce_gets (l_regProp)
				from
				until
					not (not js.loop_left and then ((l_p___0.distance (l_regProp)).to_natural_32 < l_numItems))
				loop
					l_entry.ce_gets (l_p___0)
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_p___0.item).to_integer_32 /= 0 then
							if ((((ctype_b_loc).item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (8192)).to_boolean then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_p___0.ce_gets (l_p___0 + 1)
						end
					end
					js.reset
					if (l_p___0.item).to_integer_32 /= 0 then
						l_w := (0).to_natural_32
						sscanf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_entry), ce_string ("%%x"), create {CE_POINTER [NATURAL_32]}.make_shared ($l_w)]).do_nothing
						if (WindowValid (a_dpy, l_w.to_natural_32)).to_boolean then
							misc2_inst.ga_concat (l_ga.address, l_p___0 + 1)
							misc2_inst.ga_concat (l_ga.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
						end
						from
						until
							(l_p___0.item).to_integer_32 = 0
						loop
							l_p___0.ce_gets (l_p___0 + 1)
						end
					end
					l_p___0.ce_gets (l_p___0 + 1)
				end
				if (l_regProp.c_pointer.to_integer_32).to_natural_32 /= (empty_prop.c_pointer.to_integer_32).to_natural_32 then
					XFree (create {CE_POINTER [ANY]}.make_cast (l_regProp)).do_nothing
				end
				misc2_inst.ga_append (l_ga.address, ('%/0/').code)
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.ga_data))
			end
		end

	ServerReplyFind (a_w: NATURAL_32; a_op: INTEGER_32): CE_POINTER [PD_SERVERREPLY]
		local
			l_p___0: CE_POINTER [PD_SERVERREPLY]
			l_e: PD_SERVERREPLY
			l_i___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_e.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (create {CE_POINTER [PD_SERVERREPLY]}.make_cast (serverReply.ga_data))
					l_i___0 := 0
					from
					until
						not (not js.loop_left and then (l_i___0 < serverReply.ga_len))
					loop
						js.reset
						if l_p___0.item.id = a_w then
							js.break
						end
						if not js.loop_jumped then
							l_i___0 := l_i___0 + 1
							l_p___0.ce_gets (l_p___0 + 1)
						end
					end
					js.reset
					if l_i___0 >= serverReply.ga_len then
						l_p___0.ce_gets (create {CE_POINTER [PD_SERVERREPLY]}.make_shared (default_pointer))
					end
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_op.to_natural_32 = {NATURAL_32} 1 then
							if serverReply.ga_growsize = 0 then
								misc2_inst.ga_init2 (serverReply.address, ({PD_SERVERREPLY}.sizeof.to_natural_32).to_integer_32, 1)
							end
							if (misc2_inst.ga_grow (serverReply.address, 1)) = 1 then
								l_p___0.ce_gets (create {CE_POINTER [PD_SERVERREPLY]}.make_cast (serverReply.ga_data) + serverReply.ga_len)
								l_e.id := a_w
								misc2_inst.ga_init2 (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_e.c_pointer + {PD_SERVERREPLY}.strings_offset), 1, 100)
								memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_e.address)), {PD_SERVERREPLY}.sizeof.to_natural_32).do_nothing
								serverReply.ga_len := (serverReply.ga_len) + 1
							end
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if a_op.to_natural_32 = {NATURAL_32} 2 then
								misc2_inst.ga_clear (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_p___0.c_pointer + {PD_SERVERREPLY}.strings_offset))
								memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 1)), ((serverReply.ga_len - l_i___0) - 1).to_natural_32 * {PD_SERVERREPLY}.sizeof.to_natural_32).do_nothing
								serverReply.ga_len := (serverReply.ga_len) - 1
							end
						end
				when 4 then
					Result := l_p___0
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	serverStrToWin (a_str___1: CE_POINTER [NATURAL_8]): NATURAL_32
		local
			l_id: NATURAL_32
		do
			l_id := {NATURAL_32} 0
			sscanf ([create {CE_POINTER [INTEGER_8]}.make_cast (a_str___1), ce_string ("0x%%x"), create {CE_POINTER [NATURAL_32]}.make_shared ($l_id)]).do_nothing
			if l_id.to_natural_32 = {NATURAL_32} 0 then
				message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E573: Invalid server id used: %%s")))), a_str___1).do_nothing
			end
			Result := l_id.to_natural_32
		end

	serverSendReply (a_name___1: CE_POINTER [NATURAL_8]; a_str___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_property: CE_POINTER [NATURAL_8]
			l_length: INTEGER_32
			l_res: INTEGER_32
			l_dpy: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [ANY]
			l_win: NATURAL_32
			l_tmp___4: NATURAL_32
			js: JUMP_STATE
		do
			create l_property.make
			create l_dpy.make
			create l_tmp___0.make

			if (gui_inst.gui.in_use).to_boolean then
				l_tmp___0.ce_gets ((gui_gtk_x11_inst.gui_mch_get_display))
			else
				l_tmp___0.ce_gets (globals_inst.xterm_dpy)
			end
			l_dpy.ce_gets (l_tmp___0)
			l_win := (serverStrToWin (a_name___1))
			if globals_inst.commProperty = {NATURAL_32} 0 then
				if (SendInit (l_dpy)) < 0 then
					Result := (-2)
					js.return
				end
			end
			if not js.return_called then
				if not (WindowValid (l_dpy, l_win)).to_boolean then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				l_tmp___4 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_enc))
				l_length := ((l_tmp___4 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_str___1)))) + {NATURAL_32} 14).to_integer_32
				l_property.ce_gets ((misc2_inst.alloc (l_length.to_natural_32 + {NATURAL_32} 30)))
				if (l_property.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_property), ce_string ("%%cn%%c-E %%s%%c-n %%s%%c-w %%x"), 0, 0, option_inst.p_enc, 0, a_str___1, 0, globals_inst.commWindow.to_natural_32]).do_nothing
					l_length := (l_length.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_property + l_length))))).to_integer_32
					l_res := AppendPropCarefully (l_dpy, l_win, globals_inst.commProperty, l_property, l_length + 1)
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_property))
					Result := l_res
					js.return
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	WaitForReply (a_p___0: CE_POINTER [ANY]): INTEGER_32
		local
			l_w: CE_POINTER [NATURAL_32]
		do
			create l_w.make

			l_w.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (a_p___0))
			Result := (((ServerReplyFind (l_w.item, {PC_SERVERREPLYOP}.SROP_Find)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
		end

	WaitForReply_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent WaitForReply)
		end

	serverReadReply (a_dpy: CE_POINTER [ANY]; a_win: NATURAL_32; a_str___1: CE_POINTER [CE_POINTER [NATURAL_8]]; a_localLoop: INTEGER_32): INTEGER_32
		local
			l_win: NATURAL_32
			l_len: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [PD_SERVERREPLY]
			js: JUMP_STATE
		do
			create l_s.make
			create l_p___0.make

			l_win := a_win
			ServerWait (a_dpy, l_win, WaitForReply_address, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [NATURAL_32]}.make_shared ($l_win))), a_localLoop, -1)
			l_p___0.ce_gets (ServerReplyFind (l_win, {PC_SERVERREPLYOP}.SROP_Find))
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if l_p___0.item.strings.ga_len > 0 then
					a_str___1.item := misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (l_p___0.item.strings.ga_data))
					l_len := ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_str___1.item))) + {NATURAL_32} 1).to_integer_32
					if l_len < l_p___0.item.strings.ga_len then
						l_s.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (l_p___0.item.strings.ga_data))
						memmove (create {CE_POINTER [ANY]}.make_cast (l_s), create {CE_POINTER [ANY]}.make_cast ((l_s + l_len)), (l_p___0.item.strings.ga_len - l_len).to_natural_32).do_nothing
						l_p___0.item.strings.ga_len := l_p___0.item.strings.ga_len - l_len
					else
						misc2_inst.ga_clear (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_p___0.c_pointer + {PD_SERVERREPLY}.strings_offset))
						ServerReplyFind (l_win, {PC_SERVERREPLYOP}.SROP_Delete).do_nothing
					end
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	serverPeekReply (a_dpy: CE_POINTER [ANY]; a_win: NATURAL_32; a_str___1: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_p___0: CE_POINTER [PD_SERVERREPLY]
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0.ce_gets (ServerReplyFind (a_win, {PC_SERVERREPLYOP}.SROP_Find))
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if l_p___0.item.strings.ga_len > 0 then
					if (a_str___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						a_str___1.item := create {CE_POINTER [NATURAL_8]}.make_cast (l_p___0.item.strings.ga_data)
					end
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				if not (WindowValid (a_dpy, a_win)).to_boolean then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	SendInit (a_dpy: CE_POINTER [ANY]): INTEGER_32
		local
			l_old_handler: CE_ROUTINE
			l_tmp: INTEGER_32
			l_tmp___2: INTEGER_32
		do
			create l_old_handler.make

			l_old_handler.ce_gets (XSetErrorHandler (x_error_check_address))
			got_x_error := 0
			if globals_inst.commProperty = {NATURAL_32} 0 then
				globals_inst.commProperty := XInternAtom (a_dpy, ce_string ("Comm"), 0)
			end
			if vimProperty = {NATURAL_32} 0 then
				vimProperty := XInternAtom (a_dpy, ce_string ("Vim"), 0)
			end
			if registryProperty = {NATURAL_32} 0 then
				registryProperty := XInternAtom (a_dpy, ce_string ("VimRegistry"), 0)
			end
			if globals_inst.commWindow = {NATURAL_32} 0 then
				l_tmp := getpid
				globals_inst.commWindow := XCreateSimpleWindow (a_dpy, (XDefaultRootWindow (a_dpy)), l_tmp, 0, {NATURAL_32} 10, {NATURAL_32} 10, {NATURAL_32} 0, ((create {CE_POINTER [SD_XPRIVDISPLAY]}.make_cast (a_dpy)).item.screens + (create {CE_POINTER [SD_XPRIVDISPLAY]}.make_cast (a_dpy)).item.default_screen).item.white_pixel, ((create {CE_POINTER [SD_XPRIVDISPLAY]}.make_cast (a_dpy)).item.screens + (create {CE_POINTER [SD_XPRIVDISPLAY]}.make_cast (a_dpy)).item.default_screen).item.white_pixel)
				XSelectInput (a_dpy, globals_inst.commWindow, (1).bit_shift_left (22)).do_nothing
				XGrabServer (a_dpy).do_nothing
				DeleteAnyLingerer (a_dpy, globals_inst.commWindow)
				XUngrabServer (a_dpy).do_nothing
			end
			XChangeProperty (a_dpy, globals_inst.commWindow, vimProperty, (31).to_natural_32, 8, 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("7.3")), (strlen (ce_string ("7.3"))).to_integer_32 + 1).do_nothing
			XSync (a_dpy, 0).do_nothing
			XSetErrorHandler (l_old_handler).do_nothing
			if got_x_error.to_boolean then
				l_tmp___2 := -1
			else
				l_tmp___2 := 0
			end
			Result := l_tmp___2
		end

	LookupName (a_dpy: CE_POINTER [ANY]; a_name___1: CE_POINTER [NATURAL_8]; a_delete: INTEGER_32; a_loose: CE_POINTER [CE_POINTER [NATURAL_8]]): NATURAL_32
		local
			l_regProp: CE_POINTER [NATURAL_8]
			l_entry: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_numItems: NATURAL_32
			l_returnValue: NATURAL_32
			l_count___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_regProp.make
			create l_entry.make
			create l_p___0.make

			if (GetRegProp (a_dpy, l_regProp.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_numItems), 0)) = 0 then
				Result := (0).to_natural_32
				js.return
			end
			if not js.return_called then
				l_returnValue := (0).to_natural_32
				l_entry.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				l_p___0.ce_gets (l_regProp)
				from
				until
					not (not js.loop_left and then ((l_p___0.distance (l_regProp)).to_natural_32 < l_numItems))
				loop
					js.reset
					l_entry.ce_gets (l_p___0)
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_p___0.item).to_integer_32 /= 0 then
							if ((((ctype_b_loc).item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (8192)).to_boolean then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_p___0.ce_gets (l_p___0 + 1)
						end
					end
					js.reset
					if (l_p___0.item).to_integer_32 /= 0 then
						if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 1)))) = 0 then
							sscanf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_entry), ce_string ("%%x"), create {CE_POINTER [NATURAL_32]}.make_shared ($l_returnValue)]).do_nothing
							js.break
						end
					end
					if not js.loop_jumped then
						from
						until
							(l_p___0.item).to_integer_32 = 0
						loop
							l_p___0.ce_gets (l_p___0 + 1)
						end
						l_p___0.ce_gets (l_p___0 + 1)
					end
				end
				js.reset
				if (a_loose.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if l_returnValue = {NATURAL_32} 0 then
						if not (IsSerialName (a_name___1)).to_boolean then
							l_p___0.ce_gets (l_regProp)
							from
							until
								not (not js.loop_left and then ((l_p___0.distance (l_regProp)).to_natural_32 < l_numItems))
							loop
								js.reset
								l_entry.ce_gets (l_p___0)
								from
								until
									js.loop_left
								loop
									js.reset
									if (l_p___0.item).to_integer_32 /= 0 then
										if ((((ctype_b_loc).item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (8192)).to_boolean then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_p___0.ce_gets (l_p___0 + 1)
									end
								end
								js.reset
								if (l_p___0.item).to_integer_32 /= 0 then
									if (IsSerialName (l_p___0 + 1)).to_boolean then
										if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1))))) = 0 then
											sscanf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_entry), ce_string ("%%x"), create {CE_POINTER [NATURAL_32]}.make_shared ($l_returnValue)]).do_nothing
											a_loose.item := misc2_inst.vim_strsave (l_p___0 + 1)
											js.break
										end
									end
								end
								if not js.loop_jumped then
									from
									until
										(l_p___0.item).to_integer_32 = 0
									loop
										l_p___0.ce_gets (l_p___0 + 1)
									end
									l_p___0.ce_gets (l_p___0 + 1)
								end
							end
							js.reset
						end
					end
				end
				if a_delete.to_boolean then
					if l_returnValue /= {NATURAL_32} 0 then
						from
						until
							(l_p___0.item).to_integer_32 = 0
						loop
							l_p___0.ce_gets (l_p___0 + 1)
						end
						l_p___0.ce_gets (l_p___0 + 1)
						l_count___2 := (l_numItems - (l_p___0.distance (l_regProp)).to_natural_32).to_integer_32
						if l_count___2 > 0 then
							memmove (create {CE_POINTER [ANY]}.make_cast (l_entry), create {CE_POINTER [ANY]}.make_cast (l_p___0), l_count___2.to_natural_32).do_nothing
						end
						XChangeProperty (a_dpy, ((create {CE_POINTER [SD_XPRIVDISPLAY]}.make_cast (a_dpy)).item.screens + 0).item.root, registryProperty, (31).to_natural_32, 8, 0, l_regProp, (l_numItems - (l_p___0.distance (l_entry)).to_natural_32).to_integer_32).do_nothing
						XSync (a_dpy, 0).do_nothing
					end
				end
				if (l_regProp.c_pointer.to_integer_32).to_natural_32 /= (empty_prop.c_pointer.to_integer_32).to_natural_32 then
					XFree (create {CE_POINTER [ANY]}.make_cast (l_regProp)).do_nothing
				end
				Result := l_returnValue.to_natural_32
			end
		end

	DeleteAnyLingerer (a_dpy: CE_POINTER [ANY]; a_win: NATURAL_32)
		local
			l_regProp: CE_POINTER [NATURAL_8]
			l_entry: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_numItems: NATURAL_32
			l_wwin: NATURAL_32
			l_lastHalf: INTEGER_32
			js: JUMP_STATE
		do
			create l_regProp.make
			create l_entry.make
			create l_p___0.make

			l_entry.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			if (GetRegProp (a_dpy, l_regProp.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_numItems), 0)) = 0 then
				js.return
			end
			if not js.return_called then
				l_p___0.ce_gets (l_regProp)
				from
				until
					not (not js.loop_left and then ((l_p___0.distance (l_regProp)).to_natural_32 < l_numItems))
				loop
					js.reset
					if (l_p___0.item).to_integer_32 /= 0 then
						sscanf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("%%x"), create {CE_POINTER [NATURAL_32]}.make_shared ($l_wwin)]).do_nothing
						if l_wwin.to_natural_32 = a_win then
							l_entry.ce_gets (l_p___0)
							from
							until
								(l_p___0.item).to_integer_32 = 0
							loop
								l_p___0.ce_gets (l_p___0 + 1)
							end
							l_p___0.ce_gets (l_p___0 + 1)
							l_lastHalf := (l_numItems - (l_p___0.distance (l_regProp)).to_natural_32).to_integer_32
							if l_lastHalf > 0 then
								memmove (create {CE_POINTER [ANY]}.make_cast (l_entry), create {CE_POINTER [ANY]}.make_cast (l_p___0), l_lastHalf.to_natural_32).do_nothing
							end
							l_numItems := ((l_entry.distance (l_regProp)) + l_lastHalf).to_natural_32
							l_p___0.ce_gets (l_entry)
							js.continue
						end
					end
					if not js.loop_jumped then
						from
						until
							(l_p___0.item).to_integer_32 = 0
						loop
							l_p___0.ce_gets (l_p___0 + 1)
						end
						l_p___0.ce_gets (l_p___0 + 1)
					end
					if not js.loop_left then
						
					end
				end
				if (l_entry.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					XChangeProperty (a_dpy, ((create {CE_POINTER [SD_XPRIVDISPLAY]}.make_cast (a_dpy)).item.screens + 0).item.root, registryProperty, (31).to_natural_32, 8, 0, l_regProp, l_p___0.distance (l_regProp)).do_nothing
					XSync (a_dpy, 0).do_nothing
				end
				if (l_regProp.c_pointer.to_integer_32).to_natural_32 /= (empty_prop.c_pointer.to_integer_32).to_natural_32 then
					XFree (create {CE_POINTER [ANY]}.make_cast (l_regProp)).do_nothing
				end
			end
		end

	GetRegProp (a_dpy: CE_POINTER [ANY]; a_regPropp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_numItemsp: CE_POINTER [NATURAL_32]; a_domsg: INTEGER_32): INTEGER_32
		local
			l_result___2: INTEGER_32
			l_actualFormat: INTEGER_32
			l_bytesAfter: NATURAL_32
			l_actualType: NATURAL_32
			l_old_handler: CE_ROUTINE
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_old_handler.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					a_regPropp.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_old_handler.ce_gets (XSetErrorHandler (x_error_check_address))
					got_x_error := 0
					l_result___2 := XGetWindowProperty (a_dpy, ((create {CE_POINTER [SD_XPRIVDISPLAY]}.make_cast (a_dpy)).item.screens + 0).item.root, registryProperty, 0, 100000, 0, (31).to_natural_32, create {CE_POINTER [NATURAL_32]}.make_shared ($l_actualType), create {CE_POINTER [INTEGER_32]}.make_shared ($l_actualFormat), a_numItemsp, create {CE_POINTER [NATURAL_32]}.make_shared ($l_bytesAfter), a_regPropp)
					XSync (a_dpy, 0).do_nothing
					XSetErrorHandler (l_old_handler).do_nothing
					if got_x_error.to_boolean then
						Result := 0
						js.return
					end
					if not js.return_called and then (l_actualType = {NATURAL_32} 0) then
						a_numItemsp.item := (0).to_natural_32
						a_regPropp.item := empty_prop
						Result := 1
						js.return
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if l_result___2 = 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 4 then -- else:
						if l_actualFormat = 8 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if l_actualType = {NATURAL_32} 31 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if ((a_regPropp.item).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							XFree (create {CE_POINTER [ANY]}.make_cast (a_regPropp.item)).do_nothing
						end
						XDeleteProperty (a_dpy, ((create {CE_POINTER [SD_XPRIVDISPLAY]}.make_cast (a_dpy)).item.screens + 0).item.root, registryProperty).do_nothing
						if a_domsg.to_boolean then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E251: VIM instance registry property is badly formed.  Deleted!"))))).do_nothing
						end
						Result := 0
						js.return
				when 9 then -- if done | if done | if done
						if not js.return_called then
							Result := 1
						end
				when 10 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	serverEventProc (a_dpy: CE_POINTER [ANY]; a_eventPtr: CE_POINTER [SD_XEVENT])
		local
			l_propInfo: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_result___2: INTEGER_32
			l_actualFormat: INTEGER_32
			l_code: INTEGER_32
			l_numItems: NATURAL_32
			l_bytesAfter: NATURAL_32
			l_actualType: NATURAL_32
			l_tofree: CE_POINTER [NATURAL_8]
			l_resWindow: NATURAL_32
			l_name___1: CE_POINTER [NATURAL_8]
			l_script: CE_POINTER [NATURAL_8]
			l_serial___0: CE_POINTER [NATURAL_8]
			l_end: CE_POINTER [NATURAL_8]
			l_res: CE_POINTER [NATURAL_8]
			l_asKeys: INTEGER_32
			l_reply: PD_GROWARRAY
			l_enc: CE_POINTER [NATURAL_8]
			l_tmp___2: NATURAL_32
			l_serial___1: INTEGER_32
			l_gotSerial: INTEGER_32
			l_res___0: CE_POINTER [NATURAL_8]
			l_pcPtr: CE_POINTER [PD_PENDINGCOMMAND]
			l_enc___0: CE_POINTER [NATURAL_8]
			l_win: NATURAL_32
			l_u: NATURAL_32
			l_gotWindow: INTEGER_32
			l_str___1: CE_POINTER [NATURAL_8]
			l_r: CE_POINTER [PD_SERVERREPLY]
			l_enc___1: CE_POINTER [NATURAL_8]
			l_winstr: CE_ARRAY [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_propInfo.make
			create l_p___0.make
			create l_tofree.make
			create l_name___1.make
			create l_script.make
			create l_serial___0.make
			create l_end.make
			create l_res.make
			create l_reply.make
			create l_enc.make
			create l_res___0.make
			create l_pcPtr.make
			create l_enc___0.make
			create l_str___1.make
			create l_r.make
			create l_enc___1.make
			create l_winstr.make (<<30>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_eventPtr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						if a_eventPtr.item.xproperty.atom /= globals_inst.commProperty then
							js.return
						elseif a_eventPtr.item.xproperty.state /= 0 then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						l_propInfo.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						l_result___2 := XGetWindowProperty (a_dpy, globals_inst.commWindow, globals_inst.commProperty, 0, 100000, 1, (31).to_natural_32, create {CE_POINTER [NATURAL_32]}.make_shared ($l_actualType), create {CE_POINTER [INTEGER_32]}.make_shared ($l_actualFormat), create {CE_POINTER [NATURAL_32]}.make_shared ($l_numItems), create {CE_POINTER [NATURAL_32]}.make_shared ($l_bytesAfter), l_propInfo.address)
						if l_result___2 = 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 4 then -- else:
						if l_actualType = {NATURAL_32} 31 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if l_actualFormat = 8 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if (l_propInfo.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							XFree (create {CE_POINTER [ANY]}.make_cast (l_propInfo)).do_nothing
						end
						js.return
				when 9 then -- if done | if done | if done
						if js.return_called then
							l_pos := -1 + 66 -- skip if block
						end
				when 10 then -- if:
							l_p___0.ce_gets (l_propInfo)
				when 11 then -- loop condition:
							if not (not js.loop_left and then ((l_p___0.distance (l_propInfo)).to_natural_32 < l_numItems)) then
								l_pos := -1 + 65 -- skip loop
							end
				when 12 then -- loop body:
							js.reset
							if (l_p___0.item).to_integer_32 = 0 then
								l_p___0.ce_gets (l_p___0 + 1)
								js.continue
							end
							if js.loop_jumped then
								l_pos := -1 + 64 -- skip if block
							end
				when 13 then -- if:
							if (l_p___0.item).to_integer_32 /= 99 then
								l_pos := -1 + 16 -- skip if block
							end
				when 14 then -- if:
							l_pos := -1 + 17 -- goto _L___3
				when 15 then -- if block done, skip else block:
							l_pos := -1 + 64
				when 16 then -- else:
							if (l_p___0.item).to_integer_32 /= 107 then
								l_pos := -1 + 32 -- skip if block
							end
				when 17 then -- if: | _L___3:
							if (l_p___0[1]).to_integer_32 /= 0 then
								l_pos := -1 + 30 -- skip if block
							end
				when 18 then -- if:
							l_asKeys := ((l_p___0.item).to_integer_32 = 107).to_integer
							l_p___0.ce_gets (l_p___0 + (2))
							l_name___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							l_resWindow := (0).to_natural_32
							l_serial___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
							l_script.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							l_enc.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				when 19 then -- loop condition:
							if js.loop_left then
								l_pos := -1 + 28 -- skip loop
							end
				when 20 then -- loop body:
							js.reset
							if (l_p___0.distance (l_propInfo)).to_natural_32 < l_numItems then
								if (l_p___0.item).to_integer_32 /= 45 then
									js.break
								end
							else
								js.break
							end
							if js.loop_jumped then
								l_pos := -1 + 27 -- skip if block
							end
				when 21 then -- if:
							inspect (l_p___0[1]).to_integer_32 -- switch 1 head
							when 114 then l_pos := -1 + 22
							when 110 then l_pos := -1 + 23
							when 115 then l_pos := -1 + 24
							when 69 then l_pos := -1 + 25
							else l_pos := -1 + 26
							end
				when 22 then -- switch 1, case 114
							l_end.ce_gets (charset_inst.skipwhite (l_p___0 + 2))
							l_resWindow := (0).to_natural_32
							from
							until
								js.loop_left
							loop
								js.reset
								if not (charset_inst.vim_isxdigit ((l_end.item).to_integer_32)).to_boolean then
									js.break
								end
								if not js.loop_jumped then
									l_resWindow := {NATURAL_32} 16 * l_resWindow + (charset_inst.hex2nr ((l_end.item).to_integer_32)).to_natural_32
									l_end.ce_gets (l_end + 1)
								end
							end
							js.reset
							if (l_end.c_pointer.to_integer_32).to_natural_32 = ((l_p___0 + 2).c_pointer.to_integer_32).to_natural_32 then
								l_resWindow := (0).to_natural_32
							elseif (l_end.item).to_integer_32 /= 32 then
								l_resWindow := (0).to_natural_32
							else
								l_serial___0.ce_gets (l_end + 1)
								l_p___0.ce_gets (l_serial___0)
								globals_inst.clientWindow := l_resWindow
							end
							l_pos := -1 + 26 -- switch 1; break
				when 23 then -- switch 1, case 110
							if (l_p___0[2]).to_integer_32 = 32 then
								l_name___1.ce_gets (l_p___0 + 3)
							end
							l_pos := -1 + 26 -- switch 1; break
				when 24 then -- switch 1, case 115
							if (l_p___0[2]).to_integer_32 = 32 then
								l_script.ce_gets (l_p___0 + 3)
							end
							l_pos := -1 + 26 -- switch 1; break
				when 25 then -- switch 1, case 69
							if (l_p___0[2]).to_integer_32 = 32 then
								l_enc.ce_gets (l_p___0 + 3)
							end
							l_pos := -1 + 26 -- switch 1; break
				when 26 then -- switch 1, done:
							from
							until
								(l_p___0.item).to_integer_32 = 0
							loop
								l_p___0.ce_gets (l_p___0 + 1)
							end
							l_p___0.ce_gets (l_p___0 + 1)
				when 27 then -- if done
							l_pos := -1 + 19 -- back to loop condition
				when 28 then -- loop done
							js.reset
							if (l_script.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.continue
							elseif (l_name___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.continue
							end
							if not js.loop_jumped then
								if l_resWindow /= {NATURAL_32} 0 then
									misc2_inst.ga_init2 (l_reply.address, 1, 100)
									misc2_inst.ga_grow (l_reply.address, ({NATURAL_32} 50 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_enc)))).to_integer_32).do_nothing
									sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_reply.ga_data), ce_string ("%%cr%%c-E %%s%%c-s %%s%%c-r "), 0, 0, option_inst.p_enc, 0, l_serial___0, 0]).do_nothing
									l_tmp___2 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_enc))
									l_reply.ga_len := (({NATURAL_32} 14 + l_tmp___2) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_serial___0)))).to_integer_32
								end
								l_res.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								if (globals_inst.serverName.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_name___1), create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.serverName))) = 0 then
										l_script.ce_gets (main_inst.serverConvert (l_enc, l_script, l_tofree.address))
										if l_asKeys.to_boolean then
											main_inst.server_to_input_buf (l_script)
										else
											l_res.ce_gets (main_inst.eval_client_expr_to_string (l_script))
										end
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tofree))
									end
								end
								if l_resWindow /= {NATURAL_32} 0 then
									if (l_res.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										misc2_inst.ga_concat (l_reply.address, l_res)
									elseif l_asKeys = 0 then
										misc2_inst.ga_concat (l_reply.address, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invexprmsg)))))
										misc2_inst.ga_append (l_reply.address, 0)
										misc2_inst.ga_concat (l_reply.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("-c 1")))
									end
									misc2_inst.ga_append (l_reply.address, ('%/0/').code)
									AppendPropCarefully (a_dpy, l_resWindow, globals_inst.commProperty, create {CE_POINTER [NATURAL_8]}.make_cast (l_reply.ga_data), l_reply.ga_len).do_nothing
									misc2_inst.ga_clear (l_reply.address)
								end
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_res))
							end
				when 29 then -- if block done, skip else block:
							l_pos := -1 + 31
				when 30 then -- else:
							l_pos := -1 + 32 -- goto _L___2
				when 31 then -- if done | if block done, skip else block:
							l_pos := -1 + 64
				when 32 then -- else: | _L___2:
							if (l_p___0.item).to_integer_32 /= 114 then
								l_pos := -1 + 48 -- skip if block
							end
				when 33 then -- if:
							if (l_p___0[1]).to_integer_32 /= 0 then
								l_pos := -1 + 46 -- skip if block
							end
				when 34 then -- if:
							l_p___0.ce_gets (l_p___0 + (2))
							l_gotSerial := 0
							l_res___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
							l_code := 0
							l_enc___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				when 35 then -- loop condition:
							if js.loop_left then
								l_pos := -1 + 44 -- skip loop
							end
				when 36 then -- loop body:
							js.reset
							if (l_p___0.distance (l_propInfo)).to_natural_32 < l_numItems then
								if (l_p___0.item).to_integer_32 /= 45 then
									js.break
								end
							else
								js.break
							end
							if js.loop_jumped then
								l_pos := -1 + 43 -- skip if block
							end
				when 37 then -- if:
							inspect (l_p___0[1]).to_integer_32 -- switch 2 head
							when 114 then l_pos := -1 + 38
							when 69 then l_pos := -1 + 39
							when 115 then l_pos := -1 + 40
							when 99 then l_pos := -1 + 41
							else l_pos := -1 + 42
							end
				when 38 then -- switch 2, case 114
							if (l_p___0[2]).to_integer_32 = 32 then
								l_res___0.ce_gets (l_p___0 + 3)
							end
							l_pos := -1 + 42 -- switch 2; break
				when 39 then -- switch 2, case 69
							if (l_p___0[2]).to_integer_32 = 32 then
								l_enc___0.ce_gets (l_p___0 + 3)
							end
							l_pos := -1 + 42 -- switch 2; break
				when 40 then -- switch 2, case 115
							if (sscanf ([(create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0) + 2), ce_string (" %%d"), create {CE_POINTER [INTEGER_32]}.make_shared ($l_serial___1)])) = 1 then
								l_gotSerial := 1
							end
							l_pos := -1 + 42 -- switch 2; break
				when 41 then -- switch 2, case 99
							if (sscanf ([(create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0) + 2), ce_string (" %%d"), create {CE_POINTER [INTEGER_32]}.make_shared ($l_code)])) /= 1 then
								l_code := 0
							end
							l_pos := -1 + 42 -- switch 2; break
				when 42 then -- switch 2, done:
							from
							until
								(l_p___0.item).to_integer_32 = 0
							loop
								l_p___0.ce_gets (l_p___0 + 1)
							end
							l_p___0.ce_gets (l_p___0 + 1)
				when 43 then -- if done
							l_pos := -1 + 35 -- back to loop condition
				when 44 then -- loop done
							js.reset
							if not l_gotSerial.to_boolean then
								js.continue
							end
							if not js.loop_jumped then
								l_pcPtr.ce_gets (pendingCommands)
								from
								until
									not (not js.loop_left and then ((l_pcPtr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
								loop
									js.reset
									if l_serial___1 /= l_pcPtr.item.serial then
										js.continue
									elseif ((l_pcPtr.item.result2).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										js.continue
									end
									if not js.loop_jumped then
										l_pcPtr.item.code := l_code
										if (l_res___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
											l_res___0.ce_gets (main_inst.serverConvert (l_enc___0, l_res___0, l_tofree.address))
											if (l_tofree.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
												l_res___0.ce_gets (misc2_inst.vim_strsave (l_res___0))
											end
											l_pcPtr.item.result2 := l_res___0
										else
											l_pcPtr.item.result2 := misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
										end
										js.break
									end
									if not js.loop_left then
										l_pcPtr.ce_gets (l_pcPtr.item.nextPtr)
									end
								end
								js.reset
							end
				when 45 then -- if block done, skip else block:
							l_pos := -1 + 47
				when 46 then -- else:
							l_pos := -1 + 48 -- goto _L___1
				when 47 then -- if done | if block done, skip else block:
							l_pos := -1 + 64
				when 48 then -- else: | _L___1:
							if (l_p___0.item).to_integer_32 /= 110 then
								l_pos := -1 + 63 -- skip if block
							end
				when 49 then -- if:
							if (l_p___0[1]).to_integer_32 /= 0 then
								l_pos := -1 + 61 -- skip if block
							end
				when 50 then -- if:
							l_win := (0).to_natural_32
							l_p___0.ce_gets (l_p___0 + (2))
							l_gotWindow := 0
							l_str___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
							l_enc___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				when 51 then -- loop condition:
							if js.loop_left then
								l_pos := -1 + 59 -- skip loop
							end
				when 52 then -- loop body:
							js.reset
							if (l_p___0.distance (l_propInfo)).to_natural_32 < l_numItems then
								if (l_p___0.item).to_integer_32 /= 45 then
									js.break
								end
							else
								js.break
							end
							if js.loop_jumped then
								l_pos := -1 + 58 -- skip if block
							end
				when 53 then -- if:
							inspect (l_p___0[1]).to_integer_32 -- switch 3 head
							when 110 then l_pos := -1 + 54
							when 69 then l_pos := -1 + 55
							when 119 then l_pos := -1 + 56
							else l_pos := -1 + 57
							end
				when 54 then -- switch 3, case 110
							if (l_p___0[2]).to_integer_32 = 32 then
								l_str___1.ce_gets (l_p___0 + 3)
							end
							l_pos := -1 + 57 -- switch 3; break
				when 55 then -- switch 3, case 69
							if (l_p___0[2]).to_integer_32 = 32 then
								l_enc___1.ce_gets (l_p___0 + 3)
							end
							l_pos := -1 + 57 -- switch 3; break
				when 56 then -- switch 3, case 119
							if (sscanf ([(create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0) + 2), ce_string (" %%x"), create {CE_POINTER [NATURAL_32]}.make_shared ($l_u)])) = 1 then
								l_win := l_u.to_natural_32
								l_gotWindow := 1
							end
							l_pos := -1 + 57 -- switch 3; break
				when 57 then -- switch 3, done:
							from
							until
								(l_p___0.item).to_integer_32 = 0
							loop
								l_p___0.ce_gets (l_p___0 + 1)
							end
							l_p___0.ce_gets (l_p___0 + 1)
				when 58 then -- if done
							l_pos := -1 + 51 -- back to loop condition
				when 59 then -- loop done
							js.reset
							if not l_gotWindow.to_boolean then
								js.continue
							end
							if not js.loop_jumped then
								l_str___1.ce_gets (main_inst.serverConvert (l_enc___1, l_str___1, l_tofree.address))
								l_r.ce_gets (ServerReplyFind (l_win, {PC_SERVERREPLYOP}.SROP_Add))
								if (l_r.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									misc2_inst.ga_concat (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_r.c_pointer + {PD_SERVERREPLY}.strings_offset), l_str___1)
									misc2_inst.ga_append (create {CE_POINTER [PD_GROWARRAY]}.make_shared (l_r.c_pointer + {PD_SERVERREPLY}.strings_offset), ('%/0/').code)
								end
								sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_winstr), ce_string ("0x%%x"), l_win.to_natural_32]).do_nothing
								fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_REMOTEREPLY, l_winstr, l_str___1, 1, globals_inst.curbuf).do_nothing
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tofree))
							end
				when 60 then -- if block done, skip else block:
							l_pos := -1 + 62
				when 61 then -- else:
							l_pos := -1 + 63 -- goto _L___0
				when 62 then -- if done | if block done, skip else block:
							l_pos := -1 + 64
				when 63 then -- else: | _L___0:
							from
							until
								(l_p___0.item).to_integer_32 = 0
							loop
								l_p___0.ce_gets (l_p___0 + 1)
							end
							l_p___0.ce_gets (l_p___0 + 1)
				when 64 then -- if done | if done | if done | if done
							if not js.loop_left then
								
							end
							l_pos := -1 + 11 -- back to loop condition
				when 65 then -- loop done
							XFree (create {CE_POINTER [ANY]}.make_cast (l_propInfo)).do_nothing
				when 66 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	AppendPropCarefully (a_dpy: CE_POINTER [ANY]; a_window: NATURAL_32; a_property: NATURAL_32; a_value: CE_POINTER [NATURAL_8]; a_length: INTEGER_32): INTEGER_32
		local
			l_old_handler: CE_ROUTINE
			l_tmp: INTEGER_32
		do
			create l_old_handler.make

			l_old_handler.ce_gets (XSetErrorHandler (x_error_check_address))
			got_x_error := 0
			XChangeProperty (a_dpy, a_window, a_property, (31).to_natural_32, 8, 2, a_value, a_length).do_nothing
			XSync (a_dpy, 0).do_nothing
			XSetErrorHandler (l_old_handler).do_nothing
			if got_x_error.to_boolean then
				l_tmp := -1
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	x_error_check (a_dpy: CE_POINTER [ANY]; a_error_event: CE_POINTER [SD_XERROREVENT]): INTEGER_32
		do
			got_x_error := 1
			Result := 0
		end

	x_error_check_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent x_error_check)
		end

	IsSerialName (a_str___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_len: INTEGER_32
			l_tmp___1: INTEGER_32
		do
			l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_str___1))).to_integer_32
			if l_len > 1 then
				if (charset_inst.vim_isdigit ((a_str___1[(l_len - 1)]).to_integer_32)).to_boolean then
					l_tmp___1 := 1
				else
					l_tmp___1 := 0
				end
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

end
