class
	P_MENU

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create menu_mode_chars.make (<<7>>)
			create e_notsubmenu.make (<<45>>)
			create e_othermode.make (<<39>>)
			create e_nomenu.make (<<19>>)
			create toolbar_names.make (<<32>>)
			create expand_menu.make
			create menu.make
			create menu___0.make
			create tbuffer.make (<<256>>)
			create menutrans_ga.make
		end

feature {ANY} -- attributes

	menu_mode_chars: CE_ARRAY [NATURAL_8]

	e_notsubmenu: CE_ARRAY [NATURAL_8]

	e_othermode: CE_ARRAY [NATURAL_8]

	e_nomenu: CE_ARRAY [NATURAL_8]

	toolbar_names: CE_ARRAY [CE_POINTER [INTEGER_8]]

	expand_menu: CE_POINTER [PD_VIMMENU]

	expand_modes: INTEGER_32 assign set_expand_modes

	set_expand_modes (a_expand_modes: INTEGER_32)
		do
			expand_modes := a_expand_modes
		end

	expand_emenu: INTEGER_32 assign set_expand_emenu

	set_expand_emenu (a_expand_emenu: INTEGER_32)
		do
			expand_emenu := a_expand_emenu
		end

	menu: CE_POINTER [PD_VIMMENU]

	should_advance: INTEGER_32 assign set_should_advance

	set_should_advance (a_should_advance: INTEGER_32)
		do
			should_advance := a_should_advance
		end

	menu___0: CE_POINTER [PD_VIMMENU]

	tbuffer: CE_ARRAY [NATURAL_8]

	should_advance___0: INTEGER_32 assign set_should_advance___0

	set_should_advance___0 (a_should_advance___0: INTEGER_32)
		do
			should_advance___0 := a_should_advance___0
		end

	prev_mode: INTEGER_32 assign set_prev_mode

	set_prev_mode (a_prev_mode: INTEGER_32)
		do
			prev_mode := a_prev_mode
		end

	menutrans_ga: PD_GROWARRAY

feature {ANY} -- routines

	ex_menu (a_eap: CE_POINTER [PD_EXARG])
		local
			l_menu_path: CE_POINTER [NATURAL_8]
			l_modes: INTEGER_32
			l_map_to: CE_POINTER [NATURAL_8]
			l_noremap: INTEGER_32
			l_silent: INTEGER_32
			l_special: INTEGER_32
			l_unmenu: INTEGER_32
			l_map_buf: CE_POINTER [NATURAL_8]
			l_arg: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_pri_tab: CE_ARRAY [INTEGER_32]
			l_enable: INTEGER_32
			l_icon: CE_POINTER [NATURAL_8]
			l_menuarg: PD_VIMMENU
			l_tmp___4: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___8: INTEGER_32
			l_tmp___16: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_menu_path.make
			create l_map_to.make
			create l_map_buf.make
			create l_arg.make
			create l_p___0.make
			create l_pri_tab.make (<<11>>)
			create l_icon.make
			create l_menuarg.make
			create l_tmp___5.make
			create l_tmp___16.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_silent := 0
					l_special := 0
					l_enable := 2
					l_icon.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_modes := get_menu_cmd_modes (a_eap.item.cmd, a_eap.item.forceit, create {CE_POINTER [INTEGER_32]}.make_shared ($l_noremap), create {CE_POINTER [INTEGER_32]}.make_shared ($l_unmenu))
					l_arg.ce_gets (a_eap.item.arg)
					from
					until
						js.loop_left
					loop
						js.reset
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("<script>"), (8).to_natural_32)) = 0 then
							l_noremap := -2
							l_arg.ce_gets (charset_inst.skipwhite (l_arg + 8))
							js.continue
						end
						if not js.loop_jumped then
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("<silent>"), (8).to_natural_32)) = 0 then
								l_silent := 1
								l_arg.ce_gets (charset_inst.skipwhite (l_arg + 8))
								js.continue
							end
						end
						if not js.loop_jumped then
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("<special>"), (9).to_natural_32)) = 0 then
								l_special := 1
								l_arg.ce_gets (charset_inst.skipwhite (l_arg + 9))
								js.continue
							end
						end
						if not js.loop_jumped then
							js.break
						end
						if not js.loop_left then
							
						end
					end
					js.reset
					if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("icon="), (5).to_natural_32)) = 0 then
						l_arg.ce_gets (l_arg + (5))
						l_icon.ce_gets (l_arg)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_arg.item).to_integer_32 /= 0 then
								if (l_arg.item).to_integer_32 = 32 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if (l_arg.item).to_integer_32 = 92 then
									memmove (create {CE_POINTER [ANY]}.make_cast (l_arg), create {CE_POINTER [ANY]}.make_cast ((l_arg + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_arg + 1)))) + {NATURAL_32} 1).do_nothing
								end
								if globals_inst.has_mbyte.to_boolean then
									l_tmp___4 := (globals_inst.mb_ptr2len.integer_32_item ([l_arg]))
								else
									l_tmp___4 := 1
								end
								l_arg.ce_gets (l_arg + l_tmp___4)
							end
						end
						js.reset
						if (l_arg.item).to_integer_32 /= 0 then
							l_tmp___5.ce_gets (l_arg)
							l_arg.ce_gets (l_arg + 1)
							l_tmp___5.item := (('%/0/').code).to_natural_8
							l_arg.ce_gets (charset_inst.skipwhite (l_arg))
						end
					end
					l_p___0.ce_gets (l_arg)
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_p___0.item).to_boolean)) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if not ((l_p___0.item).to_integer_32 >= 48) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if not ((l_p___0.item).to_integer_32 <= 57) then
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if (l_p___0.item).to_integer_32 /= 46 then
							js.break
						end
				when 6 then
						if not js.loop_jumped then
							l_p___0.ce_gets (l_p___0 + 1)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					js.reset
					if (l_p___0.item).to_integer_32 /= 32 then
						l_pos := -1 + 10 -- skip if block
					end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L___0
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if (l_p___0.item).to_integer_32 /= 9 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if: | _L___0:
						l_i___0 := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if l_i___0 < 10 then
								if (l_arg.item).to_integer_32 = 32 then
									js.break
								elseif (l_arg.item).to_integer_32 = 9 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_pri_tab[l_i___0] := (charset_inst.getdigits (l_arg.address)).to_integer_32
								if l_pri_tab[l_i___0] = 0 then
									l_pri_tab[l_i___0] := 500
								end
								if (l_arg.item).to_integer_32 = 46 then
									l_arg.ce_gets (l_arg + 1)
								end
								l_i___0 := l_i___0 + 1
							end
						end
						js.reset
						l_arg.ce_gets (charset_inst.skipwhite (l_arg))
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						if (a_eap.item.addr_count).to_boolean then
							if a_eap.item.line2 /= 0 then
								l_pri_tab[0] := (a_eap.item.line2).to_integer_32
								l_i___0 := 1
							else
								l_i___0 := 0
							end
						else
							l_i___0 := 0
						end
				when 14 then -- if done
						from
						until
							not (l_i___0 < 10)
						loop
							l_tmp___8 := l_i___0
							l_i___0 := l_i___0 + 1
							l_pri_tab[l_tmp___8] := 500
						end
						l_pri_tab[10] := -1
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("enable"), (6).to_natural_32)) /= 0 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
							if (l_arg[6]).to_integer_32 = 32 then
								l_enable := 1
								l_arg.ce_gets (charset_inst.skipwhite (l_arg + 6))
							elseif (l_arg[6]).to_integer_32 = 9 then
								l_enable := 1
								l_arg.ce_gets (charset_inst.skipwhite (l_arg + 6))
							else
								l_pos := -1 + 17 -- goto _L___1
							end
				when 16 then -- if block done, skip else block:
							l_pos := -1 + 18
				when 17 then -- else: | _L___1:
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("disable"), (7).to_natural_32)) = 0 then
								if (l_arg[7]).to_integer_32 = 32 then
									l_enable := 0
									l_arg.ce_gets (charset_inst.skipwhite (l_arg + 7))
								elseif (l_arg[7]).to_integer_32 = 9 then
									l_enable := 0
									l_arg.ce_gets (charset_inst.skipwhite (l_arg + 7))
								end
							end
				when 18 then
						if (l_arg.item).to_integer_32 = 0 then
							show_menus (l_arg, l_modes).do_nothing
							js.return
						end
						if js.return_called then
							l_pos := -1 + 26 -- skip if block
						end
				when 19 then -- if:
							l_menuarg.iconidx := -1
							l_menuarg.icon_builtin := 0
							if (menu_is_toolbar (l_arg)).to_boolean then
								l_menu_path.ce_gets (menu_skip_part (l_arg))
								if (l_menu_path.item).to_integer_32 = 46 then
									l_menu_path.ce_gets (l_menu_path + 1)
									l_p___0.ce_gets (menu_skip_part (l_menu_path))
									if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_menu_path), ce_string ("BuiltIn"), (7).to_natural_32)) = 0 then
										if ((charset_inst.skipdigits (l_menu_path + 7)).c_pointer.to_integer_32).to_natural_32 = (l_p___0.c_pointer.to_integer_32).to_natural_32 then
											l_menuarg.iconidx := atoi ((create {CE_POINTER [INTEGER_8]}.make_cast (l_menu_path) + 7))
											if l_menuarg.iconidx >= ((Pointer_bytes.to_natural_32 * (32).to_natural_32) // Pointer_bytes.to_natural_32).to_integer_32 then
												l_menuarg.iconidx := -1
											else
												l_menuarg.icon_builtin := 1
											end
										end
									else
										l_i___0 := 0
										from
										until
											not (not js.loop_left and then (l_i___0 < ((Pointer_bytes.to_natural_32 * (32).to_natural_32) // Pointer_bytes.to_natural_32).to_integer_32))
										loop
											js.reset
											if (strncmp (toolbar_names[l_i___0], create {CE_POINTER [INTEGER_8]}.make_cast (l_menu_path), (l_p___0.distance (l_menu_path)).to_natural_32)) = 0 then
												l_menuarg.iconidx := l_i___0
												js.break
											end
											if not js.loop_jumped then
												l_i___0 := l_i___0 + 1
											end
										end
										js.reset
									end
								end
							end
							l_menu_path.ce_gets (l_arg)
							if (l_menu_path.item).to_integer_32 = 46 then
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg2)))), l_menu_path).do_nothing
								l_pos := -1 + 25 -- goto theend
							end
				when 20 then
							l_map_to.ce_gets (menu_translate_tab_and_shift (l_arg))
							if (l_map_to.item).to_integer_32 /= 0 then
								l_pos := -1 + 23 -- skip if block
							end
				when 21 then -- if:
							if not l_unmenu.to_boolean then
								if l_enable = 2 then
									show_menus (l_menu_path, l_modes).do_nothing
									l_pos := -1 + 25 -- goto theend
								else
									l_pos := -1 + 23 -- goto _L___3
								end
							else
								l_pos := -1 + 23 -- goto _L___3
							end
				when 22 then -- if block done, skip else block:
							l_pos := -1 + 24
				when 23 then -- else: | _L___3:
							if (l_map_to.item).to_integer_32 /= 0 then
								if l_unmenu.to_boolean then
									l_tmp___16.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_trailing)))
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___16)).do_nothing
									l_pos := -1 + 25 -- goto theend
								elseif l_enable /= 2 then
									l_tmp___16.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_trailing)))
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___16)).do_nothing
									l_pos := -1 + 25 -- goto theend
								end
							end
				when 24 then
							if l_enable /= 2 then
								if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_menu_path), ce_string ("*"))) = 0 then
									l_menu_path.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
								end
								if (menu_is_popup (l_menu_path)).to_boolean then
									l_i___0 := 0
									from
									until
										not (l_i___0 < 6)
									loop
										if ((l_modes).bit_and (((1).bit_shift_left (l_i___0)))).to_boolean then
											l_p___0.ce_gets (popup_mode_name (l_menu_path, l_i___0))
											if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
												menu_nable_recurse (globals_inst.root_menu, l_p___0, ((1).bit_shift_left (6)) - 1, l_enable).do_nothing
												misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
											end
										end
										l_i___0 := l_i___0 + 1
									end
								end
								menu_nable_recurse (globals_inst.root_menu, l_menu_path, l_modes, l_enable).do_nothing
							elseif l_unmenu.to_boolean then
								if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_menu_path), ce_string ("*"))) = 0 then
									l_menu_path.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
								end
								if (menu_is_popup (l_menu_path)).to_boolean then
									l_i___0 := 0
									from
									until
										not (l_i___0 < 6)
									loop
										if ((l_modes).bit_and (((1).bit_shift_left (l_i___0)))).to_boolean then
											l_p___0.ce_gets (popup_mode_name (l_menu_path, l_i___0))
											if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
												remove_menu (globals_inst.root_menu.address, l_p___0, ((1).bit_shift_left (6)) - 1, 1).do_nothing
												misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
											end
										end
										l_i___0 := l_i___0 + 1
									end
								end
								remove_menu (globals_inst.root_menu.address, l_menu_path, l_modes, 0).do_nothing
							else
								if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_map_to), ce_string ("<nop>"))) = 0 then
									l_map_to.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
									l_map_buf.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								elseif ((l_modes).bit_and (((1).bit_shift_left (6)))).to_boolean then
									l_map_buf.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								else
									l_map_to.ce_gets (term_inst.replace_termcodes (l_map_to, l_map_buf.address, 0, 1, l_special))
								end
								l_menuarg.modes := l_modes
								l_menuarg.iconfile := l_icon
								l_menuarg.noremap[0] := l_noremap
								l_menuarg.silent[0] := l_silent.to_integer_8
								add_menu_path (l_menu_path, l_menuarg.address, l_pri_tab, l_map_to).do_nothing
								if (menu_is_popup (l_menu_path)).to_boolean then
									l_i___0 := 0
									from
									until
										not (l_i___0 < 6)
									loop
										if ((l_modes).bit_and (((1).bit_shift_left (l_i___0)))).to_boolean then
											l_p___0.ce_gets (popup_mode_name (l_menu_path, l_i___0))
											if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
												l_menuarg.modes := l_modes
												l_menuarg.iconfile := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
												l_menuarg.iconidx := -1
												l_menuarg.icon_builtin := 0
												add_menu_path (l_p___0, l_menuarg.address, l_pri_tab, l_map_to).do_nothing
												misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
											end
										end
										l_i___0 := l_i___0 + 1
									end
								end
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_map_buf))
							end
				when 25 then -- theend:
							
				when 26 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_menu_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_menu)
		end

	add_menu_path (a_menu_path: CE_POINTER [NATURAL_8]; a_menuarg: CE_POINTER [PD_VIMMENU]; a_pri_tab: CE_POINTER [INTEGER_32]; a_call_data: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_path_name: CE_POINTER [NATURAL_8]
			l_modes: INTEGER_32
			l_menup: CE_POINTER [CE_POINTER [PD_VIMMENU]]
			l_menu___1: CE_POINTER [PD_VIMMENU]
			l_parent: CE_POINTER [PD_VIMMENU]
			l_lower_pri: CE_POINTER [CE_POINTER [PD_VIMMENU]]
			l_p___0: CE_POINTER [NATURAL_8]
			l_name___1: CE_POINTER [NATURAL_8]
			l_dname: CE_POINTER [NATURAL_8]
			l_next_name: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_c: INTEGER_32
			l_d: INTEGER_32
			l_idx: INTEGER_32
			l_new_idx: INTEGER_32
			l_pri_idx: INTEGER_32
			l_old_modes: INTEGER_32
			l_amenu: INTEGER_32
			l_en_name: CE_POINTER [NATURAL_8]
			l_map_to: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_path_name.make
			create l_menup.make
			create l_menu___1.make
			create l_parent.make
			create l_lower_pri.make
			create l_p___0.make
			create l_name___1.make
			create l_dname.make
			create l_next_name.make
			create l_en_name.make
			create l_map_to.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_modes := a_menuarg.item.modes
					l_menu___1.ce_gets (create {CE_POINTER [PD_VIMMENU]}.make_shared (default_pointer))
					l_pri_idx := 0
					l_old_modes := 0
					l_map_to.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_path_name.ce_gets (misc2_inst.vim_strsave (a_menu_path))
					if (l_path_name.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 45 -- skip if block
					end
				when 1 then -- if:
						l_menup.ce_gets (globals_inst.root_menu.address)
						l_parent.ce_gets (create {CE_POINTER [PD_VIMMENU]}.make_shared (default_pointer))
						l_name___1.ce_gets (l_path_name)
				when 2 then -- loop condition:
						if not (not js.loop_left and then ((l_name___1.item).to_boolean)) then
							l_pos := -1 + 30 -- skip loop
						end
				when 3 then -- loop body:
						l_next_name.ce_gets (menu_name_skip (l_name___1))
						l_map_to.ce_gets (menutrans_lookup (l_name___1, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_name___1))).to_integer_32))
						if (l_map_to.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_en_name.ce_gets (l_name___1)
							l_name___1.ce_gets (l_map_to)
						else
							l_en_name.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						end
						l_dname.ce_gets (menu_text (l_name___1, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
						if (l_dname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 46 -- goto erret
						end
				when 4 then
						if (l_dname.item).to_integer_32 = 0 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E792: Empty menu name"))))).do_nothing
							l_pos := -1 + 46 -- goto erret
						end
				when 5 then
						l_lower_pri.ce_gets (l_menup)
						l_idx := 0
						l_new_idx := 0
						l_menu___1.ce_gets (l_menup.item)
				when 6 then -- loop condition:
						if not (not js.loop_left and then ((l_menu___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32)) then
							l_pos := -1 + 22 -- skip loop
						end
				when 7 then -- loop body:
						js.reset
						if not ((menu_name_equal (l_name___1, l_menu___1)).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if not ((menu_name_equal (l_dname, l_menu___1)).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 11 then -- if: | _L:
						if (l_next_name.item).to_integer_32 = 0 then
							if ((l_menu___1.item.children).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if not globals_inst.sys_menu.to_boolean then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E330: Menu path must not lead to a sub-menu"))))).do_nothing
								end
								l_pos := -1 + 46 -- goto erret
							end
						end
				when 12 then
						if (l_next_name.item).to_integer_32 /= 0 then
							if ((l_menu___1.item.children).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								if not globals_inst.sys_menu.to_boolean then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (e_notsubmenu))))).do_nothing
								end
								l_pos := -1 + 46 -- goto erret
							end
						end
				when 13 then
						js.break
				when 14 then -- if done
						if js.loop_jumped then
							l_pos := -1 + 21 -- skip if block
						end
				when 15 then -- if:
						l_menup.ce_gets (create {CE_POINTER [CE_POINTER [PD_VIMMENU]]}.make_shared (l_menu___1.c_pointer + {PD_VIMMENU}.next_offset))
						if (l_parent.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 19 -- goto _L___0
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 18 then -- else:
						if not ((menu_is_menubar (l_menu___1.item.name)).to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 19 then -- if: | _L___0:
						l_idx := l_idx + 1
						if l_menu___1.item.priority <= a_pri_tab[l_pri_idx] then
							l_lower_pri.ce_gets (l_menup)
							l_new_idx := l_idx
						end
				when 20 then -- if done
						l_menu___1.ce_gets (l_menu___1.item.next)
				when 21 then -- if done
						l_pos := -1 + 6 -- back to loop condition
				when 22 then -- loop done
						js.reset
						if (l_menu___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 28 -- skip if block
						end
				when 23 then -- if:
						if (l_next_name.item).to_integer_32 = 0 then
							if (l_parent.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E331: Must not add menu items directly to menu bar"))))).do_nothing
								l_pos := -1 + 46 -- goto erret
							end
						end
				when 24 then
						if (menu_is_separator (l_dname)).to_boolean then
							if (l_next_name.item).to_integer_32 /= 0 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E332: Separator cannot be part of a menu path"))))).do_nothing
								l_pos := -1 + 46 -- goto erret
							end
						end
				when 25 then
						l_menu___1.ce_gets (create {CE_POINTER [PD_VIMMENU]}.make_cast ((misc2_inst.alloc_clear ({PD_VIMMENU}.sizeof.to_natural_32))))
						if (l_menu___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 46 -- goto erret
						end
				when 26 then
						l_menu___1.item.modes := l_modes
						l_menu___1.item.enabled := ((1).bit_shift_left (6)) - 1
						l_menu___1.item.name := misc2_inst.vim_strsave (l_name___1)
						l_menu___1.item.dname := menu_text (l_name___1, create {CE_POINTER [INTEGER_32]}.make_shared (l_menu___1.c_pointer + {PD_VIMMENU}.mnemonic_offset), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_menu___1.c_pointer + {PD_VIMMENU}.actext_offset))
						if (l_en_name.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_menu___1.item.en_name := misc2_inst.vim_strsave (l_en_name)
							l_menu___1.item.en_dname := menu_text (l_en_name, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))
						else
							l_menu___1.item.en_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							l_menu___1.item.en_dname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						end
						l_menu___1.item.priority := a_pri_tab[l_pri_idx]
						l_menu___1.item.parent := l_parent
						l_menu___1.item.next := l_lower_pri.item
						l_lower_pri.item := l_menu___1
						l_old_modes := 0
						l_menu___1.item.iconidx := a_menuarg.item.iconidx
						l_menu___1.item.icon_builtin := a_menuarg.item.icon_builtin
						if (l_next_name.item).to_integer_32 = 0 then
							if ((a_menuarg.item.iconfile).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_menu___1.item.iconfile := misc2_inst.vim_strsave (a_menuarg.item.iconfile)
							end
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:
						l_old_modes := l_menu___1.item.modes
						l_menu___1.item.modes := (l_menu___1.item.modes).bit_or (l_modes)
						l_menu___1.item.enabled := (l_menu___1.item.enabled).bit_or (l_modes)
				when 29 then -- if done
						if ((l_old_modes).bit_and ((((1).bit_shift_left (6)) - 1))) = 0 then
							if ((l_menu___1.item.modes).bit_and ((((1).bit_shift_left (6)) - 1))) /= 0 then
								if (gui_inst.gui.in_use).to_boolean then
									if (l_next_name.item).to_integer_32 = 0 then
										gui_gtk_inst.gui_mch_add_menu_item (l_menu___1, l_new_idx)
										globals_inst.force_menu_update := 1
									else
										gui_gtk_inst.gui_mch_add_menu (l_menu___1, l_new_idx)
									end
								end
							end
						end
						l_menup.ce_gets (create {CE_POINTER [CE_POINTER [PD_VIMMENU]]}.make_shared (l_menu___1.c_pointer + {PD_VIMMENU}.children_offset))
						l_parent.ce_gets (l_menu___1)
						l_name___1.ce_gets (l_next_name)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_dname))
						l_dname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						if a_pri_tab[(l_pri_idx + 1)] /= -1 then
							l_pri_idx := l_pri_idx + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 30 then -- loop done
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_path_name))
						l_amenu := (((l_modes).bit_and (((1).bit_or (((1).bit_shift_left (4)))))) = ((1).bit_or (((1).bit_shift_left (4))))).to_integer
						if globals_inst.sys_menu.to_boolean then
							l_modes := (l_modes).bit_and (((l_old_modes).bit_not))
						end
						if (l_menu___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 44 -- skip if block
						end
				when 31 then -- if:
						if not (l_modes.to_boolean) then
							l_pos := -1 + 44 -- skip if block
						end
				when 32 then -- if:
						l_menu___1.item.cb := gui_inst.gui_menu_cb_address
						if (a_call_data.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						else
							l_p___0.ce_gets ((misc2_inst.vim_strsave (a_call_data)))
						end
						l_i___0 := 0
				when 33 then -- loop condition:
						if not (l_i___0 < 7) then
							l_pos := -1 + 43 -- skip loop
						end
				when 34 then -- loop body:
						if not (((l_modes).bit_and (((1).bit_shift_left (l_i___0)))).to_boolean) then
							l_pos := -1 + 42 -- skip if block
						end
				when 35 then -- if:
						free_menu_string (l_menu___1, l_i___0)
						l_c := 0
						l_d := 0
						if not (l_amenu.to_boolean) then
							l_pos := -1 + 41 -- skip if block
						end
				when 36 then -- if:
						if (a_call_data.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 41 -- skip if block
						end
				when 37 then -- if:
						if (a_call_data.item).to_integer_32 = 0 then
							l_pos := -1 + 41 -- skip if block
						end
				when 38 then -- if:
						inspect (1).bit_shift_left (l_i___0) -- switch 1 head
						when 2 then l_pos := -1 + 39 -- (1).bit_shift_left (1)
						when 4 then l_pos := -1 + 39 -- (1).bit_shift_left (2)
						when 8 then l_pos := -1 + 39 -- (1).bit_shift_left (3)
						when 32 then l_pos := -1 + 39 -- (1).bit_shift_left (5)
						when 16 then l_pos := -1 + 40 -- (1).bit_shift_left (4)
						else l_pos := -1 + 41
						end
				when 39 then -- switch 1, case 1 << 1 | switch 1, case 1 << 2 | switch 1, case 1 << 3 | switch 1, case 1 << 5
						l_c := 3
						l_pos := -1 + 41 -- switch 1; break
				when 40 then -- switch 1, case 1 << 4
						l_c := 28
						l_d := 15
						l_pos := -1 + 41 -- switch 1; break
				when 41 then -- switch 1, done: | if done | if done | if done
						if l_c /= 0 then
							l_menu___1.item.strings[l_i___0] := misc2_inst.alloc ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_call_data))) + {NATURAL_32} 5)
							if ((l_menu___1.item.strings[l_i___0]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								(l_menu___1.item.strings[l_i___0])[0] := l_c.to_natural_8
								if l_d = 0 then
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_menu___1.item.strings[l_i___0] + 1)), create {CE_POINTER [INTEGER_8]}.make_cast (a_call_data)).do_nothing
								else
									(l_menu___1.item.strings[l_i___0])[1] := l_d.to_natural_8
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_menu___1.item.strings[l_i___0] + 2)), create {CE_POINTER [INTEGER_8]}.make_cast (a_call_data)).do_nothing
								end
								if l_c = 3 then
									l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_menu___1.item.strings[l_i___0]))).to_integer_32;
									(l_menu___1.item.strings[l_i___0])[l_len] := (28).to_natural_8;
									(l_menu___1.item.strings[l_i___0])[(l_len + 1)] := (7).to_natural_8;
									(l_menu___1.item.strings[l_i___0])[(l_len + 2)] := (('%/0/').code).to_natural_8
								end
							end
						else
							l_menu___1.item.strings[l_i___0] := l_p___0
						end
						l_menu___1.item.noremap[l_i___0] := a_menuarg.item.noremap[0]
						l_menu___1.item.silent[l_i___0] := a_menuarg.item.silent[0]
				when 42 then -- if done
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 33 -- back to loop condition
				when 43 then -- loop done
						if ((l_modes).bit_and (((1).bit_shift_left (6)))).to_boolean then
							gui_gtk_inst.gui_mch_menu_set_tip (l_menu___1)
						end
				when 44 then -- if done | if done
						Result := 1
						js.return
				when 45 then -- if done
					if js.return_called then
						l_pos := -1 + 47 -- skip if block
					end
				when 46 then -- if: | erret:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_path_name))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_dname))
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_parent.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if ((l_parent.item.children).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if ((l_parent.item.parent).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_menup.ce_gets (globals_inst.root_menu.address)
								else
									l_menup.ce_gets (create {CE_POINTER [CE_POINTER [PD_VIMMENU]]}.make_shared ((l_parent.item.parent).c_pointer + {PD_VIMMENU}.children_offset))
								end
								from
								until
									js.loop_left
								loop
									js.reset
									if ((l_menup.item).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										if ((l_menup.item).c_pointer.to_integer_32).to_natural_32 = (l_parent.c_pointer.to_integer_32).to_natural_32 then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_menup.ce_gets (create {CE_POINTER [CE_POINTER [PD_VIMMENU]]}.make_shared ((l_menup.item).c_pointer + {PD_VIMMENU}.next_offset))
									end
								end
								js.reset
								if ((l_menup.item).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									js.break
								end
							end
							if not js.loop_jumped then
								l_parent.ce_gets (l_parent.item.parent)
								free_menu (l_menup)
							end
						end
						js.reset
						Result := 0
				when 47 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	menu_nable_recurse (a_menu___1: CE_POINTER [PD_VIMMENU]; a_name___1: CE_POINTER [NATURAL_8]; a_modes: INTEGER_32; a_enable: INTEGER_32): INTEGER_32
		local
			l_menu___1: CE_POINTER [PD_VIMMENU]
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_menu___1.make
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_menu___1.ce_gets (a_menu___1)
					if (l_menu___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := 1
						js.return
					end
					if js.return_called then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						l_p___0.ce_gets (menu_name_skip (a_name___1))
				when 2 then -- loop condition:
						if not (not js.loop_left and then ((l_menu___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32)) then
							l_pos := -1 + 12 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if (a_name___1.item).to_integer_32 /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 6 then -- else:
						if (a_name___1.item).to_integer_32 /= 42 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if not ((menu_name_equal (a_name___1, l_menu___1)).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						if (l_p___0.item).to_integer_32 /= 0 then
							if ((l_menu___1.item.children).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (e_notsubmenu))))).do_nothing
								Result := 0
								js.return
							end
							if not js.return_called then
								if (menu_nable_recurse (l_menu___1.item.children, l_p___0, a_modes, a_enable)) = 0 then
									Result := 0
									js.return
								end
							end
						elseif a_enable.to_boolean then
							l_menu___1.item.enabled := (l_menu___1.item.enabled).bit_or (a_modes)
						else
							l_menu___1.item.enabled := (l_menu___1.item.enabled).bit_and (((a_modes).bit_not))
						end
						if not js.return_called and then ((a_name___1.item).to_integer_32 /= 0) then
							if (a_name___1.item).to_integer_32 /= 42 then
								js.break
							end
						end
				when 11 then -- if done | if done
						if not js.loop_jumped then
							l_menu___1.ce_gets (l_menu___1.item.next)
						end
						l_pos := -1 + 2 -- back to loop condition
				when 12 then -- loop done
						js.reset
				when 13 then -- if done
					if not js.return_called and then ((a_name___1.item).to_integer_32 /= 0) then
						if (a_name___1.item).to_integer_32 /= 42 then
							if (l_menu___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (e_nomenu)))), a_name___1).do_nothing
								Result := 0
								js.return
							end
						end
					end
					if not js.return_called then
						globals_inst.force_menu_update := 1
						Result := 1
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	remove_menu (a_menup: CE_POINTER [CE_POINTER [PD_VIMMENU]]; a_name___1: CE_POINTER [NATURAL_8]; a_modes: INTEGER_32; a_silent: INTEGER_32): INTEGER_32
		local
			l_menup: CE_POINTER [CE_POINTER [PD_VIMMENU]]
			l_menu___1: CE_POINTER [PD_VIMMENU]
			l_child: CE_POINTER [PD_VIMMENU]
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_menup.make
			create l_menu___1.make
			create l_child.make
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_menup.ce_gets (a_menup)
					if ((l_menup.item).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := 1
						js.return
					end
					if js.return_called then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						l_p___0.ce_gets (menu_name_skip (a_name___1))
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 12 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						l_menu___1.ce_gets (l_menup.item)
						if (l_menu___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 11 -- skip if block
						end
				when 4 then -- if:
						if (a_name___1.item).to_integer_32 /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if not ((menu_name_equal (a_name___1, l_menu___1)).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L:
						if (l_p___0.item).to_integer_32 /= 0 then
							if ((l_menu___1.item.children).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								if not a_silent.to_boolean then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (e_notsubmenu))))).do_nothing
								end
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							if ((l_menu___1.item.modes).bit_and (a_modes)) /= 0 then
								if (remove_menu (create {CE_POINTER [CE_POINTER [PD_VIMMENU]]}.make_shared (l_menu___1.c_pointer + {PD_VIMMENU}.children_offset), l_p___0, a_modes, a_silent)) = 0 then
									Result := 0
									js.return
								end
							elseif (a_name___1.item).to_integer_32 /= 0 then
								if not a_silent.to_boolean then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (e_othermode))))).do_nothing
								end
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							if (a_name___1.item).to_integer_32 /= 0 then
								js.break
							end
							if not js.loop_jumped then
								l_menu___1.item.modes := (l_menu___1.item.modes).bit_and (((a_modes).bit_not))
								if ((a_modes).bit_and (((1).bit_shift_left (6)))).to_boolean then
									free_menu_string (l_menu___1, 6)
								end
								if ((l_menu___1.item.modes).bit_and ((((1).bit_shift_left (6)) - 1))) = 0 then
									free_menu (l_menup)
								else
									l_menup.ce_gets (create {CE_POINTER [CE_POINTER [PD_VIMMENU]]}.make_shared (l_menu___1.c_pointer + {PD_VIMMENU}.next_offset))
								end
							end
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_menup.ce_gets (create {CE_POINTER [CE_POINTER [PD_VIMMENU]]}.make_shared (l_menu___1.c_pointer + {PD_VIMMENU}.next_offset))
				when 11 then -- if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 12 then -- loop done
						js.reset
				when 13 then -- if done
					if not js.return_called and then ((a_name___1.item).to_integer_32 /= 0) then
						if (l_menu___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if not a_silent.to_boolean then
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (e_nomenu)))), a_name___1).do_nothing
							end
							Result := 0
							js.return
						end
						if not js.return_called then
							l_menu___1.item.modes := (l_menu___1.item.modes).bit_and (((a_modes).bit_not))
							l_child.ce_gets (l_menu___1.item.children)
							from
							until
								(l_child.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
							loop
								l_menu___1.item.modes := (l_menu___1.item.modes).bit_or ((l_child.item.modes))
								l_child.ce_gets (l_child.item.next)
							end
							if ((a_modes).bit_and (((1).bit_shift_left (6)))).to_boolean then
								free_menu_string (l_menu___1, 6)
								if (gui_inst.gui.in_use).to_boolean then
									gui_gtk_inst.gui_mch_menu_set_tip (l_menu___1)
								end
							end
							if ((l_menu___1.item.modes).bit_and ((((1).bit_shift_left (6)) - 1))) = 0 then
								l_menup.item := l_menu___1
								free_menu (l_menup)
							end
						end
					end
					if not js.return_called then
						Result := 1
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	free_menu (a_menup: CE_POINTER [CE_POINTER [PD_VIMMENU]])
		local
			l_i___0: INTEGER_32
			l_menu___1: CE_POINTER [PD_VIMMENU]
		do
			create l_menu___1.make

			l_menu___1.ce_gets (a_menup.item)
			if (gui_inst.gui.in_use).to_boolean then
				gui_gtk_inst.gui_mch_destroy_menu (l_menu___1)
			end
			a_menup.item := l_menu___1.item.next
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_menu___1.item.name))
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_menu___1.item.dname))
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_menu___1.item.en_name))
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_menu___1.item.en_dname))
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_menu___1.item.actext))
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_menu___1.item.iconfile))
			l_i___0 := 0
			from
			until
				not (l_i___0 < 7)
			loop
				free_menu_string (l_menu___1, l_i___0)
				l_i___0 := l_i___0 + 1
			end
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_menu___1))
			globals_inst.force_menu_update := 1
		end

	free_menu_string (a_menu___1: CE_POINTER [PD_VIMMENU]; a_idx: INTEGER_32)
		local
			l_count___2: INTEGER_32
			l_i___0: INTEGER_32
		do
			l_count___2 := 0
			l_i___0 := 0
			from
			until
				not (l_i___0 < 7)
			loop
				if ((a_menu___1.item.strings[l_i___0]).c_pointer.to_integer_32).to_natural_32 = ((a_menu___1.item.strings[a_idx]).c_pointer.to_integer_32).to_natural_32 then
					l_count___2 := l_count___2 + 1
				end
				l_i___0 := l_i___0 + 1
			end
			if l_count___2 = 1 then
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_menu___1.item.strings[a_idx]))
			end
			a_menu___1.item.strings[a_idx] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
		end

	show_menus (a_path_name: CE_POINTER [NATURAL_8]; a_modes: INTEGER_32): INTEGER_32
		local
			l_path_name: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_name___1: CE_POINTER [NATURAL_8]
			l_menu___1: CE_POINTER [PD_VIMMENU]
			l_parent: CE_POINTER [PD_VIMMENU]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_path_name.make
			create l_p___0.make
			create l_name___1.make
			create l_menu___1.make
			create l_parent.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_path_name.ce_gets (a_path_name)
					l_parent.ce_gets (create {CE_POINTER [PD_VIMMENU]}.make_shared (default_pointer))
					l_menu___1.ce_gets (globals_inst.root_menu)
					l_path_name.ce_gets (misc2_inst.vim_strsave (l_path_name))
					l_name___1.ce_gets (l_path_name)
					if (l_path_name.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if not (not js.loop_left and then ((l_name___1.item).to_boolean)) then
							l_pos := -1 + 12 -- skip loop
						end
				when 2 then -- loop body:
						l_p___0.ce_gets (menu_name_skip (l_name___1))
				when 3 then -- loop condition:
						if not (not js.loop_left and then ((l_menu___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 4 then -- loop body:
						js.reset
						if not ((menu_name_equal (l_name___1, l_menu___1)).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if (l_p___0.item).to_integer_32 = 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if ((l_menu___1.item.children).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (e_notsubmenu))))).do_nothing
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_path_name))
							Result := 0
							js.return
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if ((l_menu___1.item.modes).bit_and (a_modes)) = 0 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (e_othermode))))).do_nothing
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_path_name))
							Result := 0
							js.return
						end
				when 9 then
						if not js.return_called then
							js.break
						end
				when 10 then -- if done
						if not js.loop_jumped then
							l_menu___1.ce_gets (l_menu___1.item.next)
						end
						l_pos := -1 + 3 -- back to loop condition
				when 11 then -- loop done
						js.reset
						if not js.return_called and then ((l_menu___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32) then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (e_nomenu)))), l_name___1).do_nothing
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_path_name))
							Result := 0
							js.return
						end
						if not js.return_called then
							l_name___1.ce_gets (l_p___0)
							l_parent.ce_gets (l_menu___1)
							l_menu___1.ce_gets (l_menu___1.item.children)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 12 then -- loop done | if done
						if not js.return_called then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_path_name))
							message_inst.msg_puts_title (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%N--- Menus ---")))))
							show_menus_recursive (l_parent, a_modes, 0)
							Result := 1
						end
				when 13 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	show_menus_recursive (a_menu___1: CE_POINTER [PD_VIMMENU]; a_modes: INTEGER_32; a_depth___1: INTEGER_32)
		local
			l_menu___1: CE_POINTER [PD_VIMMENU]
			l_depth___1: INTEGER_32
			l_i___0: INTEGER_32
			l_bit: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_menu___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_menu___1.ce_gets (a_menu___1)
					l_depth___1 := a_depth___1
					if (l_menu___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						if ((l_menu___1.item.modes).bit_and (a_modes)) = 0 then
							js.return
						end
					end
					if not js.return_called and then ((l_menu___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32) then
						message_inst.msg_putchar (('%N').code)
						if globals_inst.got_int.to_boolean then
							js.return
						end
						if not js.return_called then
							l_i___0 := 0
							from
							until
								not (l_i___0 < l_depth___1)
							loop
								message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("  ")))
								l_i___0 := l_i___0 + 1
							end
							if (l_menu___1.item.priority).to_boolean then
								message_inst.msg_outnum ((l_menu___1.item.priority).to_integer_32)
								message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
							end
							message_inst.msg_outtrans_attr (l_menu___1.item.name, globals_inst.highlight_attr[2]).do_nothing
						end
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if (l_menu___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if ((l_menu___1.item.children).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_bit := 0
							from
							until
								not (not js.loop_left and then (l_bit < 7))
							loop
								if ((((l_menu___1.item.modes).bit_and (a_modes))).bit_and (((1).bit_shift_left (l_bit)))) /= 0 then
									message_inst.msg_putchar (('%N').code)
									if globals_inst.got_int.to_boolean then
										js.return
									end
									if not js.return_called then
										l_i___0 := 0
										from
										until
											not (l_i___0 < l_depth___1 + 2)
										loop
											message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("  ")))
											l_i___0 := l_i___0 + 1
										end
										message_inst.msg_putchar ((menu_mode_chars[l_bit]).to_integer_32)
										if l_menu___1.item.noremap[l_bit] = -1 then
											message_inst.msg_putchar (('*').code)
										elseif l_menu___1.item.noremap[l_bit] = -2 then
											message_inst.msg_putchar (('&').code)
										else
											message_inst.msg_putchar ((' ').code)
										end
										if (l_menu___1.item.silent[l_bit]).to_boolean then
											message_inst.msg_putchar (('s').code)
										else
											message_inst.msg_putchar ((' ').code)
										end
										if ((((l_menu___1.item.modes).bit_and (l_menu___1.item.enabled))).bit_and (((1).bit_shift_left (l_bit)))) = 0 then
											message_inst.msg_putchar (('-').code)
										else
											message_inst.msg_putchar ((' ').code)
										end
										message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
										if ((l_menu___1.item.strings[l_bit]).item).to_integer_32 = 0 then
											message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<Nop>")), globals_inst.highlight_attr[0])
										else
											message_inst.msg_outtrans_special (l_menu___1.item.strings[l_bit], 0).do_nothing
										end
									end
								end
								if not js.return_called then
									l_bit := l_bit + 1
								end
							end
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if (l_menu___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_menu___1.ce_gets (globals_inst.root_menu)
							l_depth___1 := l_depth___1 - 1
						else
							l_menu___1.ce_gets (l_menu___1.item.children)
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_menu___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if globals_inst.got_int.to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if not (menu_is_hidden (l_menu___1.item.dname)).to_boolean then
									show_menus_recursive (l_menu___1, a_modes, l_depth___1 + 1)
								end
								l_menu___1.ce_gets (l_menu___1.item.next)
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	set_context_in_menu_cmd (a_xp: CE_POINTER [PD_EXPAND]; a_cmd: CE_POINTER [NATURAL_8]; a_arg: CE_POINTER [NATURAL_8]; a_forceit: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_arg: CE_POINTER [NATURAL_8]
			l_after_dot: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_path_name: CE_POINTER [NATURAL_8]
			l_name___1: CE_POINTER [NATURAL_8]
			l_unmenu: INTEGER_32
			l_menu___1: CE_POINTER [PD_VIMMENU]
			l_expand_menus: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_arg.make
			create l_after_dot.make
			create l_p___0.make
			create l_path_name.make
			create l_name___1.make
			create l_menu___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_arg.ce_gets (a_arg)
					l_path_name.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					a_xp.item.xp_context := -2
					l_p___0.ce_gets (l_arg)
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_p___0.item).to_boolean)) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if not ((l_p___0.item).to_integer_32 >= 48) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if not ((l_p___0.item).to_integer_32 <= 57) then
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if (l_p___0.item).to_integer_32 /= 46 then
							js.break
						end
				when 6 then
						if not js.loop_jumped then
							l_p___0.ce_gets (l_p___0 + 1)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					js.reset
					if ((l_p___0.item).to_integer_32 = 32) then
						l_pos := -1 + 13 -- skip if block
					end
				when 8 then -- if:
						if ((l_p___0.item).to_integer_32 = 9) then
							l_pos := -1 + 13 -- skip if block
						end
				when 9 then -- if:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("enable"), (6).to_natural_32)) /= 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if (l_arg[6]).to_integer_32 = 0 then
							l_p___0.ce_gets (l_arg + 6)
						elseif (l_arg[6]).to_integer_32 = 32 then
							l_p___0.ce_gets (l_arg + 6)
						elseif (l_arg[6]).to_integer_32 = 9 then
							l_p___0.ce_gets (l_arg + 6)
						else
							l_pos := -1 + 12 -- goto _L___0
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___0:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("disable"), (7).to_natural_32)) = 0 then
							if (l_arg[7]).to_integer_32 = 0 then
								l_p___0.ce_gets (l_arg + 7)
							elseif (l_arg[7]).to_integer_32 = 32 then
								l_p___0.ce_gets (l_arg + 7)
							elseif (l_arg[7]).to_integer_32 = 9 then
								l_p___0.ce_gets (l_arg + 7)
							else
								l_p___0.ce_gets (l_arg)
							end
						else
							l_p___0.ce_gets (l_arg)
						end
				when 13 then -- if done | if done
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_p___0.item).to_integer_32 /= 0 then
								if (l_p___0.item).to_integer_32 /= 32 then
									if (l_p___0.item).to_integer_32 /= 9 then
										js.break
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0.ce_gets (l_p___0 + 1)
							end
						end
						js.reset
						l_after_dot.ce_gets (l_p___0)
						l_arg.ce_gets (l_after_dot)
				when 14 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 25 -- skip loop
						end
				when 15 then -- loop body:
							js.reset
							if (l_p___0.item).to_boolean then
								if (l_p___0.item).to_integer_32 = 32 then
									js.break
								elseif (l_p___0.item).to_integer_32 = 9 then
									js.break
								end
							else
								js.break
							end
							if js.loop_jumped then
								l_pos := -1 + 24 -- skip if block
							end
				when 16 then -- if:
							if (l_p___0.item).to_integer_32 /= 92 then
								l_pos := -1 + 19 -- skip if block
							end
				when 17 then -- if:
							l_pos := -1 + 20 -- goto _L___2
				when 18 then -- if block done, skip else block:
							l_pos := -1 + 23
				when 19 then -- else:
							if (l_p___0.item).to_integer_32 /= 22 then
								l_pos := -1 + 22 -- skip if block
							end
				when 20 then -- if: | _L___2:
							if (l_p___0[1]).to_integer_32 /= 0 then
								l_p___0.ce_gets (l_p___0 + 1)
							else
								l_pos := -1 + 22 -- goto _L___1
							end
				when 21 then -- if block done, skip else block:
							l_pos := -1 + 23
				when 22 then -- else: | _L___1:
							if (l_p___0.item).to_integer_32 = 46 then
								l_after_dot.ce_gets (l_p___0 + 1)
							end
				when 23 then -- if done
							l_p___0.ce_gets (l_p___0 + 1)
				when 24 then -- if done
							l_pos := -1 + 14 -- back to loop condition
				when 25 then -- loop done
						js.reset
						if (a_cmd.item).to_integer_32 /= 116 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
							if (a_cmd[1]).to_integer_32 = 101 then
								l_tmp___1 := 0
							else
								l_pos := -1 + 28 -- goto _L___3
							end
				when 27 then -- if block done, skip else block:
							l_pos := -1 + 29
				when 28 then -- else: | _L___3:
							if (a_cmd.item).to_integer_32 = 112 then
								l_tmp___1 := 0
							else
								l_tmp___1 := 1
							end
				when 29 then
						l_expand_menus := l_tmp___1
						expand_emenu := ((a_cmd.item).to_integer_32 = 101).to_integer
						if l_expand_menus.to_boolean then
							if (l_p___0.item).to_integer_32 = 32 then
								Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								js.return
							elseif (l_p___0.item).to_integer_32 = 9 then
								Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 50 -- skip if block
						end
				when 30 then -- if:
							if (l_p___0.item).to_integer_32 /= 0 then
								l_pos := -1 + 49 -- skip if block
							end
				when 31 then -- if:
							expand_modes := get_menu_cmd_modes (a_cmd, a_forceit, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_unmenu))
							if not l_unmenu.to_boolean then
								expand_modes := ((1).bit_shift_left (6)) - 1
							end
							l_menu___1.ce_gets (globals_inst.root_menu)
							if (l_after_dot.c_pointer.to_integer_32).to_natural_32 /= (l_arg.c_pointer.to_integer_32).to_natural_32 then
								l_path_name.ce_gets (misc2_inst.alloc ((l_after_dot.distance (l_arg)).to_natural_32))
								if (l_path_name.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
									js.return
								end
								if not js.return_called then
									misc2_inst.vim_strncpy (l_path_name, l_arg, ((l_after_dot.distance (l_arg)) - 1).to_natural_32)
								end
							end
							if js.return_called then
								l_pos := -1 + 47 -- skip if block
							end
				when 32 then -- if:
							l_name___1.ce_gets (l_path_name)
				when 33 then -- loop condition:
							if js.loop_left then
								l_pos := -1 + 46 -- skip loop
							end
				when 34 then -- loop body:
							js.reset
							if (l_name___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if not (l_name___1.item).to_boolean then
									js.break
								end
							else
								js.break
							end
							if js.loop_jumped then
								l_pos := -1 + 45 -- skip if block
							end
				when 35 then -- if:
							l_p___0.ce_gets (menu_name_skip (l_name___1))
				when 36 then -- loop condition:
							if not (not js.loop_left and then ((l_menu___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32)) then
								l_pos := -1 + 44 -- skip loop
							end
				when 37 then -- loop body:
							js.reset
							if not ((menu_name_equal (l_name___1, l_menu___1)).to_boolean) then
								l_pos := -1 + 43 -- skip if block
							end
				when 38 then -- if:
							if (l_p___0.item).to_integer_32 = 0 then
								l_pos := -1 + 41 -- skip if block
							end
				when 39 then -- if:
							if ((l_menu___1.item.children).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_path_name))
								Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								js.return
							else
								l_pos := -1 + 41 -- goto _L___4
							end
				when 40 then -- if block done, skip else block:
							l_pos := -1 + 42
				when 41 then -- else: | _L___4:
							if ((l_menu___1.item.modes).bit_and (expand_modes)) = 0 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_path_name))
								Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								js.return
							end
				when 42 then
							if not js.return_called then
								js.break
							end
				when 43 then -- if done
							if not js.loop_jumped then
								l_menu___1.ce_gets (l_menu___1.item.next)
							end
							l_pos := -1 + 36 -- back to loop condition
				when 44 then -- loop done
							js.reset
							if not js.return_called and then ((l_menu___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32) then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_path_name))
								Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								js.return
							end
							if not js.return_called then
								l_name___1.ce_gets (l_p___0)
								l_menu___1.ce_gets (l_menu___1.item.children)
							end
				when 45 then -- if done
							l_pos := -1 + 33 -- back to loop condition
				when 46 then -- loop done
							js.reset
				when 47 then -- if done
							if not js.return_called then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_path_name))
								if l_expand_menus.to_boolean then
									a_xp.item.xp_context := 21
								else
									a_xp.item.xp_context := 11
								end
								a_xp.item.xp_pattern := l_after_dot
								expand_menu.ce_gets (l_menu___1)
							end
				when 48 then -- if block done, skip else block:
							l_pos := -1 + 50
				when 49 then -- else:
							a_xp.item.xp_context := 0
				when 50 then -- if done | if done
							if not js.return_called then
								Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							end
				when 51 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	get_menu_name (a_xp: CE_POINTER [PD_EXPAND]; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_str___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_str___1.make

			if a_idx = 0 then
				menu.ce_gets (expand_menu)
				should_advance := 0
			end
			from
			until
				js.loop_left
			loop
				js.reset
				if (menu.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if not (menu_is_hidden (menu.item.dname)).to_boolean then
						if not (menu_is_separator (menu.item.dname)).to_boolean then
							if not (menu_is_tearoff (menu.item.dname)).to_boolean then
								if ((menu.item.children).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									js.break
								end
							end
						end
					end
				else
					js.break
				end
				if not js.loop_jumped then
					menu.ce_gets (menu.item.next)
				end
			end
			js.reset
			if (menu.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				if ((menu.item.modes).bit_and (expand_modes)).to_boolean then
					if should_advance.to_boolean then
						l_str___1.ce_gets (menu.item.en_dname)
					else
						l_str___1.ce_gets (menu.item.dname)
						if ((menu.item.en_dname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							should_advance := 1
						end
					end
				else
					l_str___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
				end
				if should_advance.to_boolean then
					menu.ce_gets (menu.item.next)
				end
				should_advance := (not should_advance.to_boolean).to_integer
				Result := l_str___1
			end
		end

	get_menu_name_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent get_menu_name)
		end

	get_menu_names (a_xp: CE_POINTER [PD_EXPAND]; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_str___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_str___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_idx = 0 then
						menu___0.ce_gets (expand_menu)
						should_advance___0 := 0
					end
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 11 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if (menu___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						if (menu_is_hidden (menu___0.item.dname)).to_boolean then
							l_pos := -1 + 8 -- skip if block
						end
				when 4 then -- if:
						if not (expand_emenu.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if not (menu_is_separator (menu___0.item.dname)).to_boolean then
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if not (menu_is_tearoff (menu___0.item.dname)).to_boolean then
							js.break
						end
				when 8 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						js.break
				when 10 then
						if not js.loop_jumped then
							menu___0.ce_gets (menu___0.item.next)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 11 then -- loop done
					js.reset
					if (menu___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						if ((menu___0.item.modes).bit_and (expand_modes)).to_boolean then
							if ((menu___0.item.children).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if should_advance___0.to_boolean then
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (tbuffer), create {CE_POINTER [INTEGER_8]}.make_cast (menu___0.item.en_dname)).do_nothing
								else
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (tbuffer), create {CE_POINTER [INTEGER_8]}.make_cast (menu___0.item.dname)).do_nothing
									if ((menu___0.item.en_dname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										should_advance___0 := 1
									end
								end
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (tbuffer), ce_string ("%/1/")).do_nothing
								l_str___1.ce_gets (tbuffer)
							elseif should_advance___0.to_boolean then
								l_str___1.ce_gets (menu___0.item.en_dname)
							else
								l_str___1.ce_gets (menu___0.item.dname)
								if ((menu___0.item.en_dname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									should_advance___0 := 1
								end
							end
						else
							l_str___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
						end
						if should_advance___0.to_boolean then
							menu___0.ce_gets (menu___0.item.next)
						end
						should_advance___0 := (not should_advance___0.to_boolean).to_integer
						Result := l_str___1
					end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_menu_names_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent get_menu_names)
		end

	menu_name_skip (a_name___1: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___2: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (a_name___1)
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if (l_p___0.item).to_boolean then
							if (l_p___0.item).to_integer_32 = 46 then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if (l_p___0.item).to_integer_32 /= 92 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if (l_p___0.item).to_integer_32 /= 22 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 1)))) + {NATURAL_32} 1).do_nothing
						if (l_p___0.item).to_integer_32 = 0 then
							js.break
						end
				when 8 then -- if done | if done
						if not js.loop_jumped then
							if globals_inst.has_mbyte.to_boolean then
								l_tmp___0 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
							else
								l_tmp___0 := 1
							end
							l_p___0.ce_gets (l_p___0 + l_tmp___0)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
					js.reset
					if (l_p___0.item).to_boolean then
						l_tmp___2.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___2.item := (('%/0/').code).to_natural_8
					end
					Result := l_p___0
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	menu_name_equal (a_name___1: CE_POINTER [NATURAL_8]; a_menu___1: CE_POINTER [PD_VIMMENU]): INTEGER_32
		local
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
		do
			if ((a_menu___1.item.en_name).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (menu_namecmp (a_name___1, a_menu___1.item.en_name)).to_boolean then
					Result := 1
					js.return
				elseif (menu_namecmp (a_name___1, a_menu___1.item.en_dname)).to_boolean then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				if (menu_namecmp (a_name___1, a_menu___1.item.name)).to_boolean then
					l_tmp___3 := 1
				elseif (menu_namecmp (a_name___1, a_menu___1.item.dname)).to_boolean then
					l_tmp___3 := 1
				else
					l_tmp___3 := 0
				end
				Result := l_tmp___3
			end
		end

	menu_namecmp (a_name___1: CE_POINTER [NATURAL_8]; a_mname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_i___0 := 0
					from
					until
						js.loop_left
					loop
						js.reset
						if (a_name___1[l_i___0]).to_integer_32 /= 0 then
							if (a_name___1[l_i___0]).to_integer_32 = 9 then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped and then ((a_name___1[l_i___0]).to_integer_32 /= (a_mname[l_i___0]).to_integer_32) then
							js.break
						end
						if not js.loop_jumped then
							l_i___0 := l_i___0 + 1
						end
					end
					js.reset
					if (a_name___1[l_i___0]).to_integer_32 /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if (a_name___1[l_i___0]).to_integer_32 /= 9 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						if (a_mname[l_i___0]).to_integer_32 = 0 then
							l_tmp := 1
						elseif (a_mname[l_i___0]).to_integer_32 = 9 then
							l_tmp := 1
						else
							l_tmp := 0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tmp := 0
				when 7 then -- if done
						Result := l_tmp
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	get_menu_cmd_modes (a_cmd: CE_POINTER [NATURAL_8]; a_forceit: INTEGER_32; a_noremap: CE_POINTER [INTEGER_32]; a_unmenu: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_cmd: CE_POINTER [NATURAL_8]
			l_modes: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_cmd.make
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_cmd.ce_gets (a_cmd)
					l_tmp.ce_gets (l_cmd)
					l_cmd.ce_gets (l_cmd + 1)
					inspect (l_tmp.item).to_integer_32 -- switch 1 head
					when 118 then l_pos := -1 + 1
					when 120 then l_pos := -1 + 2
					when 115 then l_pos := -1 + 3
					when 111 then l_pos := -1 + 4
					when 105 then l_pos := -1 + 5
					when 116 then l_pos := -1 + 6
					when 99 then l_pos := -1 + 7
					when 97 then l_pos := -1 + 8
					when 110 then l_pos := -1 + 9
					else l_pos := -1 + 10
					end
				when 1 then -- switch 1, case 118
					l_modes := (((1).bit_shift_left (1))).bit_or (((1).bit_shift_left (2)))
					l_pos := -1 + 11 -- switch 1; break
				when 2 then -- switch 1, case 120
					l_modes := (1).bit_shift_left (1)
					l_pos := -1 + 11 -- switch 1; break
				when 3 then -- switch 1, case 115
					l_modes := (1).bit_shift_left (2)
					l_pos := -1 + 11 -- switch 1; break
				when 4 then -- switch 1, case 111
					l_modes := (1).bit_shift_left (3)
					l_pos := -1 + 11 -- switch 1; break
				when 5 then -- switch 1, case 105
					l_modes := (1).bit_shift_left (4)
					l_pos := -1 + 11 -- switch 1; break
				when 6 then -- switch 1, case 116
					l_modes := (1).bit_shift_left (6)
					l_pos := -1 + 11 -- switch 1; break
				when 7 then -- switch 1, case 99
					l_modes := (1).bit_shift_left (5)
					l_pos := -1 + 11 -- switch 1; break
				when 8 then -- switch 1, case 97
					l_modes := (((((((((((1).bit_shift_left (4))).bit_or (((1).bit_shift_left (5))))).bit_or (1))).bit_or (((1).bit_shift_left (1))))).bit_or (((1).bit_shift_left (2))))).bit_or (((1).bit_shift_left (3)))
					l_pos := -1 + 11 -- switch 1; break
				when 9 then -- switch 1, case 110
					if (l_cmd.item).to_integer_32 /= 111 then
						l_modes := 1
						l_pos := -1 + 11 -- switch 1; break
					end
				when 10 then -- switch 1, default:
					l_cmd.ce_gets (l_cmd - 1)
					if a_forceit.to_boolean then
						l_modes := (((1).bit_shift_left (4))).bit_or (((1).bit_shift_left (5)))
					else
						l_modes := (((((1).bit_or (((1).bit_shift_left (1))))).bit_or (((1).bit_shift_left (2))))).bit_or (((1).bit_shift_left (3)))
					end
				when 11 then -- switch 1, done:
					if (a_noremap.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						if (l_cmd.item).to_integer_32 = 110 then
							a_noremap.item := -1
						else
							a_noremap.item := 0
						end
					end
					if (a_unmenu.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						a_unmenu.item := ((l_cmd.item).to_integer_32 = 117).to_integer
					end
					Result := l_modes
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	popup_mode_name (a_name___1: CE_POINTER [NATURAL_8]; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
		do
			create l_p___0.make

			l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1))).to_integer_32
			l_p___0.ce_gets (misc2_inst.vim_strnsave (a_name___1, l_len + 1))
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				memmove (create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 6)), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 5)), (l_len - 4).to_natural_32).do_nothing
				l_p___0[5] := menu_mode_chars[a_idx]
			end
			Result := l_p___0
		end

	get_menu_index (a_menu___1: CE_POINTER [PD_VIMMENU]; a_state: INTEGER_32): INTEGER_32
		local
			l_idx: INTEGER_32
		do
			if ((a_state).bit_and (16)).to_boolean then
				l_idx := 4
			elseif ((a_state).bit_and (8)).to_boolean then
				l_idx := 5
			elseif globals_inst.VIsual_active.to_boolean then
				if globals_inst.VIsual_select.to_boolean then
					l_idx := 2
				else
					l_idx := 1
				end
			elseif a_state = 513 then
				l_idx := 5
			elseif a_state = 768 then
				l_idx := 5
			elseif globals_inst.finish_op.to_boolean then
				l_idx := 3
			elseif ((a_state).bit_and (1)).to_boolean then
				l_idx := 0
			else
				l_idx := -1
			end
			if l_idx /= -1 then
				if ((a_menu___1.item.strings[l_idx]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_idx := -1
				end
			end
			Result := l_idx
		end

	menu_text (a_str___1: CE_POINTER [NATURAL_8]; a_mnemonic: CE_POINTER [INTEGER_32]; a_actext: CE_POINTER [CE_POINTER [NATURAL_8]]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_text: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_text.make

			l_p___0.ce_gets (misc2_inst.vim_strchr (a_str___1, ('%T').code))
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (a_actext.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					a_actext.item := misc2_inst.vim_strsave (l_p___0 + 1)
				end
				l_text.ce_gets (misc2_inst.vim_strnsave (a_str___1, l_p___0.distance (a_str___1)))
			else
				l_text.ce_gets (misc2_inst.vim_strsave (a_str___1))
			end
			l_p___0.ce_gets (l_text)
			from
			until
				not (not js.loop_left and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				js.reset
				l_p___0.ce_gets (misc2_inst.vim_strchr (l_p___0, ('&').code))
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if (l_p___0[1]).to_integer_32 = 0 then
						js.break
					end
					if not js.loop_jumped then
						if (a_mnemonic.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (l_p___0[1]).to_integer_32 /= 38 then
								a_mnemonic.item := (l_p___0[1]).to_integer_32
							end
						end
						memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 1)))) + {NATURAL_32} 1).do_nothing
						l_p___0.ce_gets (l_p___0 + 1)
					end
				end
			end
			js.reset
			Result := l_text
		end

	menu_is_menubar (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if (menu_is_popup (a_name___1)).to_boolean then
				l_tmp___1 := 0
			elseif (menu_is_toolbar (a_name___1)).to_boolean then
				l_tmp___1 := 0
			elseif (a_name___1.item).to_integer_32 /= 93 then
				l_tmp___1 := 1
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	menu_is_popup (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := ((strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("PopUp"), (5).to_natural_32)) = 0).to_integer
		end

	menu_is_toolbar (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := ((strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("ToolBar"), (7).to_natural_32)) = 0).to_integer
		end

	menu_is_separator (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (a_name___1[0]).to_integer_32 = 45 then
				if (a_name___1[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 45 then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	menu_is_hidden (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (a_name___1[0]).to_integer_32 = 93 then
				l_tmp___0 := 1
			elseif (menu_is_popup (a_name___1)).to_boolean then
				if (a_name___1[5]).to_integer_32 /= 0 then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	menu_is_tearoff (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := ((strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("-->Detach"))) = 0).to_integer
		end

	get_menu_mode: INTEGER_32
		local
			js: JUMP_STATE
		do
			if globals_inst.VIsual_active.to_boolean then
				if globals_inst.VIsual_select.to_boolean then
					Result := 2
					js.return
				end
				if not js.return_called then
					Result := 1
					js.return
				end
			end
			if not js.return_called and then (((globals_inst.State).bit_and (16)).to_boolean) then
				Result := 4
				js.return
			end
			if not js.return_called then
				if ((globals_inst.State).bit_and (8)).to_boolean then
					Result := 5
					js.return
				elseif globals_inst.State = 768 then
					Result := 5
					js.return
				elseif globals_inst.State = 513 then
					Result := 5
					js.return
				end
			end
			if not js.return_called and then (globals_inst.finish_op.to_boolean) then
				Result := 3
				js.return
			end
			if not js.return_called and then (((globals_inst.State).bit_and (1)).to_boolean) then
				Result := 0
				js.return
			end
			if not js.return_called and then (((globals_inst.State).bit_and (32)).to_boolean) then
				Result := 4
				js.return
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	check_menu_pointer (a_root: CE_POINTER [PD_VIMMENU]; a_menu_to_check: CE_POINTER [PD_VIMMENU]): INTEGER_32
		local
			l_p___0: CE_POINTER [PD_VIMMENU]
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0.ce_gets (a_root)
			from
			until
				not (not js.loop_left and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (a_menu_to_check.c_pointer.to_integer_32).to_natural_32 then
					Result := 1
					js.return
				elseif ((l_p___0.item.children).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if (check_menu_pointer (l_p___0.item.children, a_menu_to_check)) = 1 then
						Result := 1
						js.return
					end
				end
				if not js.return_called then
					l_p___0.ce_gets (l_p___0.item.next)
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gui_create_initial_menus (a_menu___1: CE_POINTER [PD_VIMMENU])
		local
			l_menu___1: CE_POINTER [PD_VIMMENU]
			l_idx: INTEGER_32
		do
			create l_menu___1.make

			l_menu___1.ce_gets (a_menu___1)
			l_idx := 0
			from
			until
				(l_menu___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
			loop
				if ((l_menu___1.item.modes).bit_and ((((1).bit_shift_left (6)) - 1))).to_boolean then
					if ((l_menu___1.item.children).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						gui_gtk_inst.gui_mch_add_menu (l_menu___1, l_idx)
						gui_create_initial_menus (l_menu___1.item.children)
					else
						gui_gtk_inst.gui_mch_add_menu_item (l_menu___1, l_idx)
					end
				end
				l_menu___1.ce_gets (l_menu___1.item.next)
				l_idx := l_idx + 1
			end
		end

	gui_update_menus_recurse (a_menu___1: CE_POINTER [PD_VIMMENU]; a_mode: INTEGER_32)
		local
			l_menu___1: CE_POINTER [PD_VIMMENU]
			l_grey: INTEGER_32
		do
			create l_menu___1.make

			l_menu___1.ce_gets (a_menu___1)
			from
			until
				(l_menu___1).c_pointer = default_pointer
			loop
				if ((((l_menu___1.item.modes).bit_and (l_menu___1.item.enabled))).bit_and (a_mode)).to_boolean then
					l_grey := 0
				else
					l_grey := 1
				end
				if ((misc2_inst.vim_strchr (option_inst.p_go, ('g').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					gui_gtk_x11_inst.gui_mch_menu_grey (l_menu___1, l_grey)
				elseif ((l_menu___1.item.parent).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					gui_gtk_x11_inst.gui_mch_menu_grey (l_menu___1, l_grey)
				elseif (menu_is_toolbar ((l_menu___1.item.parent).item.name)).to_boolean then
					gui_gtk_x11_inst.gui_mch_menu_grey (l_menu___1, l_grey)
				else
					gui_gtk_x11_inst.gui_mch_menu_hidden (l_menu___1, l_grey)
				end
				gui_update_menus_recurse (l_menu___1.item.children, a_mode)
				l_menu___1.ce_gets (l_menu___1.item.next)
			end
		end

	gui_update_menus (a_modes: INTEGER_32)
		local
			l_mode: INTEGER_32
		do
			l_mode := 0
			if a_modes /= 0 then
				l_mode := a_modes
			else
				l_mode := get_menu_mode
				if l_mode = -1 then
					l_mode := 0
				else
					l_mode := (1).bit_shift_left (l_mode)
				end
			end
			if globals_inst.force_menu_update.to_boolean then
				gui_update_menus_recurse (globals_inst.root_menu, l_mode)
				gui_gtk_x11_inst.gui_mch_draw_menubar
				prev_mode := l_mode
				globals_inst.force_menu_update := 0
			elseif l_mode /= prev_mode then
				gui_update_menus_recurse (globals_inst.root_menu, l_mode)
				gui_gtk_x11_inst.gui_mch_draw_menubar
				prev_mode := l_mode
				globals_inst.force_menu_update := 0
			end
		end

	gui_is_menu_shortcut (a_key: INTEGER_32): INTEGER_32
		local
			l_key: INTEGER_32
			l_menu___1: CE_POINTER [PD_VIMMENU]
			js: JUMP_STATE
		do
			create l_menu___1.make

			l_key := a_key
			if l_key < 256 then
				l_key := tolower (l_key)
			end
			l_menu___1.ce_gets (globals_inst.root_menu)
			from
			until
				not (not js.loop_left and then ((l_menu___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				if l_menu___1.item.mnemonic = l_key then
					Result := 1
					js.return
				elseif l_menu___1.item.mnemonic < 256 then
					if (tolower (l_menu___1.item.mnemonic)) = l_key then
						Result := 1
						js.return
					end
				end
				if not js.return_called then
					l_menu___1.ce_gets (l_menu___1.item.next)
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gui_show_popupmenu
		local
			l_menu___1: CE_POINTER [PD_VIMMENU]
			l_mode: INTEGER_32
			l_ename: CE_ARRAY [NATURAL_8]
			js: JUMP_STATE
		do
			create l_menu___1.make
			create l_ename.make (<<2>>)

			l_mode := get_menu_mode
			if l_mode = -1 then
				js.return
			end
			if not js.return_called then
				l_mode := (menu_mode_chars[l_mode]).to_integer_32
				l_ename[0] := l_mode.to_natural_8
				l_ename[1] := (('%/0/').code).to_natural_8
				fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_MENUPOPUP, l_ename, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
				l_menu___1.ce_gets (globals_inst.root_menu)
				from
				until
					not (not js.loop_left and then ((l_menu___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
				loop
					js.reset
					if (strncmp (ce_string ("PopUp"), create {CE_POINTER [INTEGER_8]}.make_cast (l_menu___1.item.name), (5).to_natural_32)) = 0 then
						if (l_menu___1.item.name[5]).to_integer_32 = l_mode then
							js.break
						end
					end
					if not js.loop_jumped then
						l_menu___1.ce_gets (l_menu___1.item.next)
					end
				end
				js.reset
				if (l_menu___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if ((l_menu___1.item.children).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						gui_gtk_inst.gui_mch_show_popupmenu (l_menu___1)
					end
				end
			end
		end

	ex_emenu (a_eap: CE_POINTER [PD_EXARG])
		local
			l_menu___1: CE_POINTER [PD_VIMMENU]
			l_name___1: CE_POINTER [NATURAL_8]
			l_saved_name: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_idx: INTEGER_32
			l_mode: CE_POINTER [NATURAL_8]
			l_tpos: PD_POS_T
			l_tmp___4: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_menu___1.make
			create l_name___1.make
			create l_saved_name.make
			create l_p___0.make
			create l_mode.make
			create l_tpos.make
			create l_tmp___4.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_saved_name.ce_gets (misc2_inst.vim_strsave (a_eap.item.arg))
					if (l_saved_name.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						l_menu___1.ce_gets (globals_inst.root_menu)
						l_name___1.ce_gets (l_saved_name)
				when 2 then -- loop condition:
						if not (not js.loop_left and then ((l_name___1.item).to_boolean)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						l_p___0.ce_gets (menu_name_skip (l_name___1))
				when 4 then -- loop condition:
						if not (not js.loop_left and then ((l_menu___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32)) then
							l_pos := -1 + 12 -- skip loop
						end
				when 5 then -- loop body:
						js.reset
						if not ((menu_name_equal (l_name___1, l_menu___1)).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if:
						if (l_p___0.item).to_integer_32 /= 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if ((l_menu___1.item.children).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E333: Menu path must lead to a menu item"))))).do_nothing
							l_menu___1.ce_gets (create {CE_POINTER [PD_VIMMENU]}.make_shared (default_pointer))
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if (l_p___0.item).to_integer_32 /= 0 then
							if ((l_menu___1.item.children).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (e_notsubmenu))))).do_nothing
								l_menu___1.ce_gets (create {CE_POINTER [PD_VIMMENU]}.make_shared (default_pointer))
							end
						end
				when 10 then
						js.break
				when 11 then -- if done
						if not js.loop_jumped then
							l_menu___1.ce_gets (l_menu___1.item.next)
						end
						l_pos := -1 + 4 -- back to loop condition
				when 12 then -- loop done
						js.reset
						if (l_menu___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						elseif (l_p___0.item).to_integer_32 = 0 then
							js.break
						end
						if not js.loop_jumped then
							l_menu___1.ce_gets (l_menu___1.item.children)
							l_name___1.ce_gets (l_p___0)
						end
						l_pos := -1 + 2 -- back to loop condition
				when 13 then -- loop done
						js.reset
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_saved_name))
						if (l_menu___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E334: Menu not found: %%s")))), a_eap.item.arg).do_nothing
							js.return
						end
				when 14 then -- if done
					if js.return_called then
						l_pos := -1 + 27 -- skip if block
					end
				when 15 then -- if:
						if not (globals_inst.restart_edit.to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if not globals_inst.current_SID.to_boolean then
							l_mode.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Insert")))
							l_idx := 4
						else
							l_pos := -1 + 18 -- goto _L___1
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 18 then -- else: | _L___1:
						if not ((a_eap.item.addr_count).to_boolean) then
							l_pos := -1 + 25 -- skip if block
						end
				when 19 then -- if:
						l_mode.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Visual")))
						l_idx := 1
						if globals_inst.curbuf.item.b_visual.vi_start.lnum /= a_eap.item.line1 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if globals_inst.curbuf.item.b_visual.vi_end.lnum = a_eap.item.line2 then
							globals_inst.VIsual_mode := globals_inst.curbuf.item.b_visual.vi_mode
							l_tpos.ce_gets (globals_inst.curbuf.item.b_visual.vi_end)
							globals_inst.curwin.item.w_cursor := globals_inst.curbuf.item.b_visual.vi_start
							globals_inst.curwin.item.w_curswant := globals_inst.curbuf.item.b_visual.vi_curswant
						else
							l_pos := -1 + 22 -- goto _L___0
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else: | _L___0:
						globals_inst.VIsual_mode := ('V').code
						globals_inst.curwin.item.w_cursor.lnum := a_eap.item.line1
						globals_inst.curwin.item.w_cursor.col := 1
						l_tpos.lnum := a_eap.item.line2
						l_tpos.col := (2147483647).to_integer_32
						l_tpos.coladd := 0
				when 23 then
						globals_inst.VIsual_active := 1
						globals_inst.VIsual_reselect := 1
						misc2_inst.check_cursor
						globals_inst.VIsual.ce_gets (globals_inst.curwin.item.w_cursor)
						globals_inst.curwin.item.w_cursor := l_tpos
						misc2_inst.check_cursor
						if (option_inst.p_sel.item).to_integer_32 = 101 then
							if (misc1_inst.gchar_cursor) /= 0 then
								globals_inst.curwin.item.w_cursor.col := (globals_inst.curwin.item.w_cursor.col) + 1
							end
						end
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else:
						l_mode.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Normal")))
						l_idx := 0
				when 26 then -- if done
						if l_idx /= -1 then
							if ((l_menu___1.item.strings[l_idx]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if globals_inst.current_SID /= 0 then
									ex_docmd_inst.exec_normal_cmd (l_menu___1.item.strings[l_idx], l_menu___1.item.noremap[l_idx], (l_menu___1.item.silent[l_idx]).to_integer_32)
								else
									getchar_inst.ins_typebuf (l_menu___1.item.strings[l_idx], l_menu___1.item.noremap[l_idx], 0, 1, (l_menu___1.item.silent[l_idx]).to_integer_32).do_nothing
								end
							else
								l_tmp___4.ce_gets (gettext (ce_string ("E335: Menu not defined for %%s mode")))
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___4), l_mode).do_nothing
							end
						else
							l_tmp___4.ce_gets (gettext (ce_string ("E335: Menu not defined for %%s mode")))
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___4), l_mode).do_nothing
						end
				when 27 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_emenu_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_emenu)
		end

	gui_find_menu (a_path_name: CE_POINTER [NATURAL_8]): CE_POINTER [PD_VIMMENU]
		local
			l_menu___1: CE_POINTER [PD_VIMMENU]
			l_name___1: CE_POINTER [NATURAL_8]
			l_saved_name: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_menu___1.make
			create l_name___1.make
			create l_saved_name.make
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_menu___1.ce_gets (create {CE_POINTER [PD_VIMMENU]}.make_shared (default_pointer))
					l_menu___1.ce_gets (globals_inst.root_menu)
					l_saved_name.ce_gets (misc2_inst.vim_strsave (a_path_name))
					if (l_saved_name.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := (create {CE_POINTER [PD_VIMMENU]}.make_shared (default_pointer))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						l_name___1.ce_gets (l_saved_name)
				when 2 then -- loop condition:
						if not (not js.loop_left and then ((l_name___1.item).to_boolean)) then
							l_pos := -1 + 14 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						l_p___0.ce_gets (menu_name_skip (l_name___1))
				when 4 then -- loop condition:
						if not (not js.loop_left and then ((l_menu___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 5 then -- loop body:
						js.reset
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_name___1), create {CE_POINTER [INTEGER_8]}.make_cast (l_menu___1.item.name))) /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 8 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_name___1), create {CE_POINTER [INTEGER_8]}.make_cast (l_menu___1.item.dname))) /= 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 9 then -- if: | _L:
						if ((l_menu___1.item.children).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if (l_p___0.item).to_integer_32 = 0 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E336: Menu path must lead to a sub-menu"))))).do_nothing
							else
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (e_notsubmenu))))).do_nothing
							end
							l_menu___1.ce_gets (create {CE_POINTER [PD_VIMMENU]}.make_shared (default_pointer))
							l_pos := -1 + 15 -- goto theend
						end
				when 10 then
						if (l_p___0.item).to_integer_32 = 0 then
							l_pos := -1 + 15 -- goto theend
						end
				when 11 then
						js.break
				when 12 then -- if done
						if not js.loop_jumped then
							l_menu___1.ce_gets (l_menu___1.item.next)
						end
						l_pos := -1 + 4 -- back to loop condition
				when 13 then -- loop done
						js.reset
						if (l_menu___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						end
						if not js.loop_jumped then
							l_menu___1.ce_gets (l_menu___1.item.children)
							l_name___1.ce_gets (l_p___0)
						end
						l_pos := -1 + 2 -- back to loop condition
				when 14 then -- loop done
						js.reset
						if (l_menu___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E337: Menu not found - check menu names"))))).do_nothing
						end
				when 15 then -- theend:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_saved_name))
						Result := l_menu___1
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_menutranslate (a_eap: CE_POINTER [PD_EXARG])
		local
			l_arg: CE_POINTER [NATURAL_8]
			l_tp: CE_POINTER [PD_MENUTRANS_T]
			l_i___0: INTEGER_32
			l_from: CE_POINTER [NATURAL_8]
			l_from_noamp: CE_POINTER [NATURAL_8]
			l_to: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_arg.make
			create l_tp.make
			create l_from.make
			create l_from_noamp.make
			create l_to.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_arg.ce_gets (a_eap.item.arg)
					if menutrans_ga.ga_itemsize = 0 then
						misc2_inst.ga_init2 (menutrans_ga.address, ({PD_MENUTRANS_T}.sizeof.to_natural_32).to_integer_32, 5)
					end
					if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("clear"), (5).to_natural_32)) /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (ex_docmd_inst.ends_excmd (((charset_inst.skipwhite (l_arg + 5)).item).to_integer_32)).to_boolean then
							l_tp.ce_gets (create {CE_POINTER [PD_MENUTRANS_T]}.make_cast (menutrans_ga.ga_data))
							l_i___0 := 0
							from
							until
								not (l_i___0 < menutrans_ga.ga_len)
							loop
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((l_tp + l_i___0).item.from2))
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((l_tp + l_i___0).item.from_noamp))
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((l_tp + l_i___0).item.to))
								l_i___0 := l_i___0 + 1
							end
							misc2_inst.ga_clear (menutrans_ga.address)
							eval_inst.del_menutrans_vars
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						l_from.ce_gets (l_arg)
						l_arg.ce_gets (menu_skip_part (l_arg))
						l_to.ce_gets (charset_inst.skipwhite (l_arg))
						l_arg.item := (('%/0/').code).to_natural_8
						l_arg.ce_gets (menu_skip_part (l_to))
						if (l_arg.c_pointer.to_integer_32).to_natural_32 = (l_to.c_pointer.to_integer_32).to_natural_32 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg))))).do_nothing
						elseif (misc2_inst.ga_grow (menutrans_ga.address, 1)) = 1 then
							l_tp.ce_gets (create {CE_POINTER [PD_MENUTRANS_T]}.make_cast (menutrans_ga.ga_data))
							l_from.ce_gets (misc2_inst.vim_strsave (l_from))
							if (l_from.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_from_noamp.ce_gets (menu_text (l_from, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
								l_to.ce_gets (misc2_inst.vim_strnsave (l_to, l_arg.distance (l_to)))
								if (l_from_noamp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if (l_to.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										menu_translate_tab_and_shift (l_from).do_nothing
										menu_translate_tab_and_shift (l_to).do_nothing
										menu_unescape_name (l_from)
										menu_unescape_name (l_to);
										(l_tp + menutrans_ga.ga_len).item.from2 := l_from;
										(l_tp + menutrans_ga.ga_len).item.from_noamp := l_from_noamp;
										(l_tp + menutrans_ga.ga_len).item.to := l_to
										menutrans_ga.ga_len := (menutrans_ga.ga_len) + 1
									else
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_from))
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_from_noamp))
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_to))
									end
								else
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_from))
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_from_noamp))
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_to))
								end
							end
						end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_menutranslate_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_menutranslate)
		end

	menu_skip_part (a_p___0: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (a_p___0)
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if (l_p___0.item).to_integer_32 /= 0 then
							if (l_p___0.item).to_integer_32 /= 46 then
								if (l_p___0.item).to_integer_32 = 32 then
									js.break
								elseif (l_p___0.item).to_integer_32 = 9 then
									js.break
								end
							else
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						if (l_p___0.item).to_integer_32 /= 92 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if (l_p___0.item).to_integer_32 /= 22 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						if (l_p___0[1]).to_integer_32 /= 0 then
							l_p___0.ce_gets (l_p___0 + 1)
						end
				when 8 then -- if done
						l_p___0.ce_gets (l_p___0 + 1)
				when 9 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					js.reset
					Result := l_p___0
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	menutrans_lookup (a_name___1: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_tp: CE_POINTER [PD_MENUTRANS_T]
			l_i___0: INTEGER_32
			l_dname: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_tp.make
			create l_dname.make

			l_tp.ce_gets (create {CE_POINTER [PD_MENUTRANS_T]}.make_cast (menutrans_ga.ga_data))
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (l_i___0 < menutrans_ga.ga_len))
			loop
				if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), create {CE_POINTER [INTEGER_8]}.make_cast ((l_tp + l_i___0).item.from2), a_len.to_natural_32)) = 0 then
					if ((l_tp + l_i___0).item.from2[a_len]).to_integer_32 = 0 then
						Result := ((l_tp + l_i___0).item.to)
						js.return
					end
				end
				if not js.return_called then
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				l_i___0 := (a_name___1[a_len]).to_integer_32
				a_name___1[a_len] := (('%/0/').code).to_natural_8
				l_dname.ce_gets (menu_text (a_name___1, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
				a_name___1[a_len] := l_i___0.to_natural_8
				if (l_dname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					l_i___0 := 0
					from
					until
						not (not js.loop_left and then (l_i___0 < menutrans_ga.ga_len))
					loop
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_dname), create {CE_POINTER [INTEGER_8]}.make_cast ((l_tp + l_i___0).item.from_noamp))) = 0 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_dname))
							Result := ((l_tp + l_i___0).item.to)
							js.return
						end
						if not js.return_called then
							l_i___0 := l_i___0 + 1
						end
					end
					if not js.return_called then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_dname))
					end
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	menu_unescape_name (a_name___1: CE_POINTER [NATURAL_8])
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0.ce_gets (a_name___1)
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_p___0.item).to_boolean then
					if (l_p___0.item).to_integer_32 = 46 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if (l_p___0.item).to_integer_32 = 92 then
						memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 1)))) + {NATURAL_32} 1).do_nothing
					end
					if globals_inst.has_mbyte.to_boolean then
						l_tmp___0 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
					else
						l_tmp___0 := 1
					end
					l_p___0.ce_gets (l_p___0 + l_tmp___0)
				end
			end
			js.reset
		end

	menu_translate_tab_and_shift (a_arg_start: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_arg: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_arg.make
			create l_tmp___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_arg.ce_gets (a_arg_start)
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 12 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if (l_arg.item).to_boolean then
							if (l_arg.item).to_integer_32 = 32 then
								js.break
							elseif (l_arg.item).to_integer_32 = 9 then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						if (l_arg.item).to_integer_32 /= 92 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if (l_arg.item).to_integer_32 /= 22 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___0:
						if (l_arg[1]).to_integer_32 /= 0 then
							l_arg.ce_gets (l_arg + 1)
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("<TAB>"), (5).to_natural_32)) = 0 then
							l_arg.item := (('%T').code).to_natural_8
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_arg + 1)), create {CE_POINTER [ANY]}.make_cast ((l_arg + 5)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_arg + 5)))) + {NATURAL_32} 1).do_nothing
						end
				when 10 then -- if done
						l_arg.ce_gets (l_arg + 1)
				when 11 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 12 then -- loop done
					js.reset
					if (l_arg.item).to_integer_32 /= 0 then
						l_tmp___1.ce_gets (l_arg)
						l_arg.ce_gets (l_arg + 1)
						l_tmp___1.item := (('%/0/').code).to_natural_8
					end
					l_arg.ce_gets (charset_inst.skipwhite (l_arg))
					Result := l_arg
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
