class
	P_POPUPMNU

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create pum_array.make
		end

feature {ANY} -- attributes

	pum_array: CE_POINTER [PD_PUMITEM_T]

	pum_size: INTEGER_32 assign set_pum_size

	set_pum_size (a_pum_size: INTEGER_32)
		do
			pum_size := a_pum_size
		end

	pum_selected: INTEGER_32 assign set_pum_selected

	set_pum_selected (a_pum_selected: INTEGER_32)
		do
			pum_selected := a_pum_selected
		end

	pum_first: INTEGER_32 assign set_pum_first

	set_pum_first (a_pum_first: INTEGER_32)
		do
			pum_first := a_pum_first
		end

	pum_height: INTEGER_32 assign set_pum_height

	set_pum_height (a_pum_height: INTEGER_32)
		do
			pum_height := a_pum_height
		end

	pum_width: INTEGER_32 assign set_pum_width

	set_pum_width (a_pum_width: INTEGER_32)
		do
			pum_width := a_pum_width
		end

	pum_base_width: INTEGER_32 assign set_pum_base_width

	set_pum_base_width (a_pum_base_width: INTEGER_32)
		do
			pum_base_width := a_pum_base_width
		end

	pum_kind_width: INTEGER_32 assign set_pum_kind_width

	set_pum_kind_width (a_pum_kind_width: INTEGER_32)
		do
			pum_kind_width := a_pum_kind_width
		end

	pum_scrollbar: INTEGER_32 assign set_pum_scrollbar

	set_pum_scrollbar (a_pum_scrollbar: INTEGER_32)
		do
			pum_scrollbar := a_pum_scrollbar
		end

	pum_row: INTEGER_32 assign set_pum_row

	set_pum_row (a_pum_row: INTEGER_32)
		do
			pum_row := a_pum_row
		end

	pum_col: INTEGER_32 assign set_pum_col

	set_pum_col (a_pum_col: INTEGER_32)
		do
			pum_col := a_pum_col
		end

	pum_do_redraw: INTEGER_32 assign set_pum_do_redraw

	set_pum_do_redraw (a_pum_do_redraw: INTEGER_32)
		do
			pum_do_redraw := a_pum_do_redraw
		end

feature {ANY} -- routines

	pum_display (a_array: CE_POINTER [PD_PUMITEM_T]; a_size: INTEGER_32; a_selected: INTEGER_32)
		local
			l_w: INTEGER_32
			l_def_width: INTEGER_32
			l_max_width: INTEGER_32
			l_kind_width: INTEGER_32
			l_extra_width: INTEGER_32
			l_i___0: INTEGER_32
			l_top_clear: INTEGER_32
			l_row: INTEGER_32
			l_context_lines: INTEGER_32
			l_col: INTEGER_32
			l_above_row: INTEGER_32
			l_redo_count: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_above_row := globals_inst.cmdline_row
					l_redo_count := 0
				when 1 then -- redo:
					l_def_width := 15
					l_max_width := 0
					l_kind_width := 0
					l_extra_width := 0
					pum_array.ce_gets (create {CE_POINTER [PD_PUMITEM_T]}.make_shared (default_pointer + 1))
					move_inst.validate_cursor_col
					pum_array.ce_gets (create {CE_POINTER [PD_PUMITEM_T]}.make_shared (default_pointer))
					l_row := globals_inst.curwin.item.w_wrow + globals_inst.curwin.item.w_winrow
					if (globals_inst.firstwin.item.w_onebuf_opt.wo_pvw).to_boolean then
						l_top_clear := globals_inst.firstwin.item.w_height
					else
						l_top_clear := 0
					end
					if (globals_inst.lastwin.item.w_onebuf_opt.wo_pvw).to_boolean then
						l_above_row := l_above_row - ((globals_inst.lastwin.item.w_height + globals_inst.lastwin.item.w_status_height) + 1)
					end
					if a_size < 10 then
						pum_height := a_size
					else
						pum_height := 10
					end
					if option_inst.p_ph > 0 then
						if pum_height.to_integer_32 > option_inst.p_ph then
							pum_height := option_inst.p_ph.to_integer_32
						end
					end
					if not (l_row + 2 >= l_above_row - pum_height) then
						l_pos := -1 + 4 -- skip if block
					end
				when 2 then -- if:
						if l_row > (l_above_row - l_top_clear) // 2 then
							if globals_inst.curwin.item.w_wrow - globals_inst.curwin.item.w_cline_row >= 2 then
								l_context_lines := 2
							else
								l_context_lines := globals_inst.curwin.item.w_wrow - globals_inst.curwin.item.w_cline_row
							end
							if l_row >= a_size + l_context_lines then
								pum_row := (l_row - a_size) - l_context_lines
								pum_height := a_size
							else
								pum_row := 0
								pum_height := l_row - l_context_lines
							end
							if option_inst.p_ph > 0 then
								if pum_height.to_integer_32 > option_inst.p_ph then
									pum_row := (pum_row.to_integer_32 + (pum_height.to_integer_32 - option_inst.p_ph)).to_integer_32
									pum_height := option_inst.p_ph.to_integer_32
								end
							end
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if (globals_inst.curwin.item.w_cline_row + globals_inst.curwin.item.w_cline_height) - globals_inst.curwin.item.w_wrow >= 3 then
							l_context_lines := 3
						else
							l_context_lines := (globals_inst.curwin.item.w_cline_row + globals_inst.curwin.item.w_cline_height) - globals_inst.curwin.item.w_wrow
						end
						pum_row := l_row + l_context_lines
						if a_size > l_above_row - pum_row then
							pum_height := l_above_row - pum_row
						else
							pum_height := a_size
						end
						if option_inst.p_ph > 0 then
							if pum_height.to_integer_32 > option_inst.p_ph then
								pum_height := option_inst.p_ph.to_integer_32
							end
						end
				when 5 then
					if pum_height < 1 then
						js.return
					elseif pum_height = 1 then
						if a_size > 1 then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 14 -- skip if block
					end
				when 6 then -- if:
						if (globals_inst.firstwin.item.w_onebuf_opt.wo_pvw).to_boolean then
							if pum_row < globals_inst.firstwin.item.w_height then
								if pum_height > globals_inst.firstwin.item.w_height + 4 then
									pum_row := pum_row + (globals_inst.firstwin.item.w_height)
									pum_height := pum_height - (globals_inst.firstwin.item.w_height)
								end
							end
						end
						l_i___0 := 0
						from
						until
							not (l_i___0 < a_size)
						loop
							l_w := charset_inst.vim_strsize ((a_array + l_i___0).item.pum_text)
							if l_max_width < l_w then
								l_max_width := l_w
							end
							if (((a_array + l_i___0).item.pum_kind).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_w := (charset_inst.vim_strsize ((a_array + l_i___0).item.pum_kind)) + 1
								if l_kind_width < l_w then
									l_kind_width := l_w
								end
							end
							if (((a_array + l_i___0).item.pum_extra).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_w := (charset_inst.vim_strsize ((a_array + l_i___0).item.pum_extra)) + 1
								if l_extra_width < l_w then
									l_extra_width := l_w
								end
							end
							l_i___0 := l_i___0 + 1
						end
						pum_base_width := l_max_width
						pum_kind_width := l_kind_width
						l_col := globals_inst.curwin.item.w_wincol + globals_inst.curwin.item.w_wcol
						if pum_height < a_size then
							pum_scrollbar := 1
							l_max_width := l_max_width + 1
						else
							pum_scrollbar := 0
						end
						if l_def_width < l_max_width then
							l_def_width := l_max_width
						end
						if not (l_col.to_integer_32 < globals_inst.Columns - 15) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if not (l_col.to_integer_32 < globals_inst.Columns - l_max_width.to_integer_32) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L___0:
						pum_col := l_col
						pum_width := ((globals_inst.Columns - pum_col.to_integer_32) - pum_scrollbar.to_integer_32).to_integer_32
						if pum_width > ((l_max_width + l_kind_width) + l_extra_width) + 1 then
							if pum_width > 15 then
								pum_width := ((l_max_width + l_kind_width) + l_extra_width) + 1
								if pum_width < 15 then
									pum_width := 15
								end
							end
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						if globals_inst.Columns < l_def_width.to_integer_32 then
							pum_col := 0
							pum_width := (globals_inst.Columns - 1).to_integer_32
						else
							if l_max_width > 15 then
								l_max_width := 15
							end
							pum_col := (globals_inst.Columns - l_max_width.to_integer_32).to_integer_32
							pum_width := l_max_width - pum_scrollbar
						end
				when 13 then -- if done
						pum_array.ce_gets (a_array)
						pum_size := a_size
						if (pum_set_selected (a_selected, l_redo_count)).to_boolean then
							l_redo_count := l_redo_count + 1
							if l_redo_count <= 2 then
								l_pos := -1 + 1 -- goto redo
							end
						end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	pum_redraw
		local
			l_row: INTEGER_32
			l_col: INTEGER_32
			l_attr_norm: INTEGER_32
			l_attr_select: INTEGER_32
			l_attr_scroll: INTEGER_32
			l_attr_thumb: INTEGER_32
			l_attr: INTEGER_32
			l_i___0: INTEGER_32
			l_idx: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_totwidth: INTEGER_32
			l_width: INTEGER_32
			l_w: INTEGER_32
			l_thumb_pos: INTEGER_32
			l_thumb_heigth: INTEGER_32
			l_round: INTEGER_32
			l_n: INTEGER_32
			l_tmp___0: INTEGER_32
			l_st: CE_POINTER [NATURAL_8]
			l_saved: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_p___0.make
			create l_st.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_row := pum_row
					l_attr_norm := globals_inst.highlight_attr[31]
					l_attr_select := globals_inst.highlight_attr[32]
					l_attr_scroll := globals_inst.highlight_attr[33]
					l_attr_thumb := globals_inst.highlight_attr[34]
					l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_thumb_pos := 0
					l_thumb_heigth := 1
					if pum_scrollbar.to_boolean then
						l_thumb_heigth := (pum_height * pum_height) // pum_size
						if l_thumb_heigth = 0 then
							l_thumb_heigth := 1
						end
						l_thumb_pos := (pum_first * (pum_height - l_thumb_heigth) + (pum_size - pum_height) // 2) // (pum_size - pum_height)
					end
					l_i___0 := 0
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_i___0 < pum_height)) then
						l_pos := -1 + 34 -- skip loop
					end
				when 2 then -- loop body:
						l_idx := l_i___0 + pum_first
						if l_idx = pum_selected then
							l_attr := l_attr_select
						else
							l_attr := l_attr_norm
						end
						if pum_col > 0 then
							screen_inst.screen_putchar ((' ').code, l_row, pum_col - 1, l_attr)
						end
						l_col := pum_col
						l_totwidth := 0
						l_round := 1
				when 3 then -- loop condition:
						if not (not js.loop_left and then (l_round <= 3)) then
							l_pos := -1 + 33 -- skip loop
						end
				when 4 then -- loop body:
						js.reset
						l_width := 0
						l_s.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						inspect l_round -- switch 1 head
						when 1 then l_pos := -1 + 5
						when 2 then l_pos := -1 + 6
						when 3 then l_pos := -1 + 7
						else l_pos := -1 + 8
						end
				when 5 then -- switch 1, case 1
						l_p___0.ce_gets ((pum_array + l_idx).item.pum_text)
						l_pos := -1 + 8 -- switch 1; break
				when 6 then -- switch 1, case 2
						l_p___0.ce_gets ((pum_array + l_idx).item.pum_kind)
						l_pos := -1 + 8 -- switch 1; break
				when 7 then -- switch 1, case 3
						l_p___0.ce_gets ((pum_array + l_idx).item.pum_extra)
						l_pos := -1 + 8 -- switch 1; break
				when 8 then -- switch 1, done:
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 22 -- skip if block
						end
				when 9 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 21 -- skip loop
						end
				when 10 then -- loop body:
						js.reset
						if (l_s.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_s.ce_gets (l_p___0)
						end
						l_w := charset_inst.ptr2cells (l_p___0)
						if (l_p___0.item).to_integer_32 /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else:
						if (l_p___0.item).to_integer_32 /= 9 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 16 then -- else:
						if not (l_totwidth + l_w > pum_width) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if: | _L:
						l_saved := (l_p___0.item).to_integer_32
						l_p___0.item := (('%/0/').code).to_natural_8
						l_st.ce_gets (charset_inst.transstr (l_s))
						l_p___0.item := l_saved.to_natural_8
						if (l_st.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							screen_inst.screen_puts_len (l_st, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_st))).to_integer_32, l_row, l_col, l_attr)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_st))
						end
						l_col := l_col + l_width
						if (l_p___0.item).to_integer_32 /= 9 then
							js.break
						end
						if not js.loop_jumped then
							screen_inst.screen_puts_len (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("  ")), 2, l_row, l_col, l_attr)
							l_col := l_col + (2)
							l_totwidth := l_totwidth + (2)
							l_s.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							l_width := 0
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:
						l_width := l_width + l_w
				when 20 then -- if done | if done
						if not js.loop_jumped then
							if globals_inst.has_mbyte.to_boolean then
								l_tmp___0 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
							else
								l_tmp___0 := 1
							end
							l_p___0.ce_gets (l_p___0 + l_tmp___0)
						end
						l_pos := -1 + 9 -- back to loop condition
				when 21 then -- loop done
						js.reset
				when 22 then -- if done
						if l_round > 1 then
							l_n := pum_kind_width + 1
						else
							l_n := 1
						end
						if l_round /= 3 then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						js.break
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 25 then -- else:
						if l_round /= 2 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						if (((pum_array + l_idx).item.pum_extra).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						else
							l_pos := -1 + 28 -- goto _L___2
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 28 then -- else: | _L___2:
						if l_round /= 1 then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						if (((pum_array + l_idx).item.pum_kind).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if (((pum_array + l_idx).item.pum_extra).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.break
							else
								l_pos := -1 + 31 -- goto _L___1
							end
						else
							l_pos := -1 + 31 -- goto _L___1
						end
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 31 then -- else: | _L___1:
						if pum_base_width + l_n >= pum_width then
							js.break
						end
				when 32 then -- if done | if done
						if not js.loop_jumped then
							screen_inst.screen_fill (l_row, l_row + 1, l_col, (pum_col + pum_base_width) + l_n, (' ').code, (' ').code, l_attr)
							l_col := (pum_col + pum_base_width) + l_n
							l_totwidth := pum_base_width + l_n
							l_round := l_round + 1
						end
						l_pos := -1 + 3 -- back to loop condition
				when 33 then -- loop done
						js.reset
						screen_inst.screen_fill (l_row, l_row + 1, l_col, pum_col + pum_width, (' ').code, (' ').code, l_attr)
						if pum_scrollbar > 0 then
							if l_i___0 >= l_thumb_pos then
								if l_i___0 < l_thumb_pos + l_thumb_heigth then
									l_tmp___2 := l_attr_thumb
								else
									l_tmp___2 := l_attr_scroll
								end
							else
								l_tmp___2 := l_attr_scroll
							end
							screen_inst.screen_putchar ((' ').code, l_row, pum_col + pum_width, l_tmp___2)
						end
						l_row := l_row + 1
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 1 -- back to loop condition
				when 34 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	pum_set_selected (a_n: INTEGER_32; a_repeat: INTEGER_32): INTEGER_32
		local
			l_resized: INTEGER_32
			l_context: INTEGER_32
			l_curwin_save: CE_POINTER [PD_WINDOW_S]
			l_res: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [NATURAL_8]
			l_lnum: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_curwin_save.make
			create l_p___0.make
			create l_e.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_resized := 0
					l_context := pum_height // 2
					pum_selected := a_n
					if not (pum_selected >= 0) then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if not (pum_selected < pum_size) then
							l_pos := -1 + 12 -- skip if block
						end
				when 2 then -- if:
						if pum_first > pum_selected - 4 then
							if pum_first > pum_selected - 2 then
								pum_first := pum_first - (pum_height - 2)
								if pum_first < 0 then
									pum_first := 0
								elseif pum_first > pum_selected then
									pum_first := pum_selected
								end
							else
								pum_first := pum_selected
							end
						elseif pum_first < (pum_selected - pum_height) + 5 then
							if pum_first < ((pum_selected - pum_height) + 1) + 2 then
								pum_first := pum_first + (pum_height - 2)
								if pum_first < (pum_selected - pum_height) + 1 then
									pum_first := (pum_selected - pum_height) + 1
								end
							else
								pum_first := (pum_selected - pum_height) + 1
							end
						end
						if l_context > 3 then
							l_context := 3
						end
						if pum_height > 2 then
							if pum_first > pum_selected - l_context then
								pum_first := pum_selected - l_context
								if pum_first < 0 then
									pum_first := 0
								end
							elseif pum_first < ((pum_selected + l_context) - pum_height) + 1 then
								pum_first := ((pum_selected + l_context) - pum_height) + 1
							end
						end
						if (((pum_array + pum_selected).item.pum_info).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 12 -- skip if block
						end
				when 3 then -- if:
						if not (globals_inst.Rows > 10) then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if not (a_repeat <= 1) then
							l_pos := -1 + 12 -- skip if block
						end
				when 5 then -- if:
						if ((misc2_inst.vim_strchr (option_inst.p_cot, ('p').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 12 -- skip if block
						end
				when 6 then -- if:
						l_curwin_save.ce_gets (globals_inst.curwin)
						l_res := 1
						globals_inst.g_do_tagpreview := 3
						l_resized := ex_cmds_inst.prepare_tagpreview (0)
						globals_inst.g_do_tagpreview := 0
						if not ((globals_inst.curwin.item.w_onebuf_opt.wo_pvw).to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						if ((globals_inst.curbuf.item.b_fname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if (globals_inst.curbuf.item.b_p_bt[0]).to_integer_32 = 110 then
							if (globals_inst.curbuf.item.b_p_bt[2]).to_integer_32 = 102 then
								if (globals_inst.curbuf.item.b_p_bh[0]).to_integer_32 = 119 then
									from
									until
										js.loop_left
									loop
										js.reset
										if globals_inst.curbuf.item.b_ml.ml_line_count = 1 then
											if ((memline_inst.ml_get ((1).to_integer_32)).item).to_integer_32 = 0 then
												js.break
											end
										end
										if not js.loop_jumped then
											memline_inst.ml_delete ((1).to_integer_32, 0).do_nothing
										end
									end
									js.reset
								else
									l_pos := -1 + 10 -- goto _L___1
								end
							else
								l_pos := -1 + 10 -- goto _L___1
							end
						else
							l_pos := -1 + 10 -- goto _L___1
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L___1:
						globals_inst.no_u_sync := globals_inst.no_u_sync + 1
						l_res := ex_cmds_inst.do_ecmd (0, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer), (1).to_integer_32, 0, create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
						globals_inst.no_u_sync := globals_inst.no_u_sync - 1
						if l_res = 1 then
							option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("swf")), 0, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 4)
							option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bt")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("nofile")), 4)
							option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bh")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("wipe")), 4)
							option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("diff")), 0, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 4)
						end
				when 11 then
						if l_res = 1 then
							l_lnum := (0).to_integer_32
							l_p___0.ce_gets ((pum_array + pum_selected).item.pum_info)
							from
							until
								not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0))
							loop
								js.reset
								l_e.ce_gets (misc2_inst.vim_strchr (l_p___0, ('%N').code))
								if (l_e.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_tmp___0 := l_lnum
									l_lnum := l_lnum + 1
									memline_inst.ml_append (l_tmp___0, l_p___0, 0, 0).do_nothing
									js.break
								else
									l_e.item := (('%/0/').code).to_natural_8
									l_tmp___1 := l_lnum
									l_lnum := l_lnum + 1
									memline_inst.ml_append (l_tmp___1, l_p___0, (l_e.distance (l_p___0)) + 1, 0).do_nothing
									l_e.item := (('%N').code).to_natural_8
									l_p___0.ce_gets (l_e + 1)
								end
							end
							js.reset
							if a_repeat = 0 then
								if l_lnum > option_inst.p_pvh then
									l_lnum := option_inst.p_pvh
								end
								if (globals_inst.curwin.item.w_height).to_integer_32 < l_lnum then
									window_inst.win_setheight (l_lnum.to_integer_32)
									l_resized := 1
								end
							end
							globals_inst.curbuf.item.b_changed := 0
							globals_inst.curbuf.item.b_p_ma := 0
							globals_inst.curwin.item.w_cursor.lnum := (1).to_integer_32
							globals_inst.curwin.item.w_cursor.col := 0
							if (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 /= (l_curwin_save.c_pointer.to_integer_32).to_natural_32 then
								if (window_inst.win_valid (l_curwin_save)).to_boolean then
									move_inst.validate_cursor
									screen_inst.redraw_later (35)
									if l_resized.to_boolean then
										window_inst.win_enter (l_curwin_save, 1)
										move_inst.update_topline
									end
									pum_do_redraw := 1
									screen_inst.update_screen (0)
									pum_do_redraw := 0
									if not l_resized.to_boolean then
										if (window_inst.win_valid (l_curwin_save)).to_boolean then
											window_inst.win_enter (l_curwin_save, 1)
										end
									end
									pum_do_redraw := 1
									screen_inst.update_screen (0)
									pum_do_redraw := 0
								end
							end
						end
				when 12 then -- if done | if done | if done | if done | if done | if done | if done
						if pum_first > pum_size - pum_height then
							pum_first := pum_size - pum_height
						end
						if not l_resized.to_boolean then
							pum_redraw
						end
						Result := l_resized
				when 13 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	pum_undisplay
		do
			pum_array.ce_gets (create {CE_POINTER [PD_PUMITEM_T]}.make_shared (default_pointer))
			screen_inst.redraw_all_later (35)
			globals_inst.redraw_tabline := 1
			screen_inst.status_redraw_all
		end

	pum_clear
		do
			pum_first := 0
		end

	pum_visible: INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if not pum_do_redraw.to_boolean then
				if (pum_array.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	pum_get_height: INTEGER_32
		do
			Result := pum_height
		end

end
