class
	P_UI

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create ta_str.make
			create inbuf.make (<<4102>>)
			create rest.make
			create dragwin.make
		end

feature {ANY} -- attributes

	ta_str: CE_POINTER [NATURAL_8]

	ta_off: INTEGER_32 assign set_ta_off

	set_ta_off (a_ta_off: INTEGER_32)
		do
			ta_off := a_ta_off
		end

	ta_len: INTEGER_32 assign set_ta_len

	set_ta_len (a_ta_len: INTEGER_32)
		do
			ta_len := a_ta_len
		end

	count___1: INTEGER_32 assign set_count___1

	set_count___1 (a_count___1: INTEGER_32)
		do
			count___1 := a_count___1
		end

	inbuf: CE_ARRAY [NATURAL_8]

	inbufcount: INTEGER_32 assign set_inbufcount

	set_inbufcount (a_inbufcount: INTEGER_32)
		do
			inbufcount := a_inbufcount
		end

	did_read_something: INTEGER_32 assign set_did_read_something

	set_did_read_something (a_did_read_something: INTEGER_32)
		do
			did_read_something := a_did_read_something
		end

	rest: CE_POINTER [NATURAL_8]

	restlen: INTEGER_32 assign set_restlen
		do
			Result := restlen_address[0]
		end

	set_restlen (a_restlen: INTEGER_32)
		do
			restlen_address[0] := a_restlen
		end

	restlen_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	vim_atom: NATURAL_32 assign set_vim_atom

	set_vim_atom (a_vim_atom: NATURAL_32)
		do
			vim_atom := a_vim_atom
		end

	vimenc_atom: NATURAL_32 assign set_vimenc_atom

	set_vimenc_atom (a_vimenc_atom: NATURAL_32)
		do
			vimenc_atom := a_vimenc_atom
		end

	compound_text_atom: NATURAL_32 assign set_compound_text_atom

	set_compound_text_atom (a_compound_text_atom: NATURAL_32)
		do
			compound_text_atom := a_compound_text_atom
		end

	text_atom: NATURAL_32 assign set_text_atom

	set_text_atom (a_text_atom: NATURAL_32)
		do
			text_atom := a_text_atom
		end

	targets_atom: NATURAL_32 assign set_targets_atom

	set_targets_atom (a_targets_atom: NATURAL_32)
		do
			targets_atom := a_targets_atom
		end

	timestamp_atom: NATURAL_32 assign set_timestamp_atom

	set_timestamp_atom (a_timestamp_atom: NATURAL_32)
		do
			timestamp_atom := a_timestamp_atom
		end

	success: INTEGER_32 assign set_success
		do
			Result := success_address[0]
		end

	set_success (a_success: INTEGER_32)
		do
			success_address[0] := a_success
		end

	success_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	on_status_line: INTEGER_32 assign set_on_status_line

	set_on_status_line (a_on_status_line: INTEGER_32)
		do
			on_status_line := a_on_status_line
		end

	on_sep_line: INTEGER_32 assign set_on_sep_line

	set_on_sep_line (a_on_sep_line: INTEGER_32)
		do
			on_sep_line := a_on_sep_line
		end

	prev_row___0: INTEGER_32 assign set_prev_row___0

	set_prev_row___0 (a_prev_row___0: INTEGER_32)
		do
			prev_row___0 := a_prev_row___0
		end

	prev_col___0: INTEGER_32 assign set_prev_col___0

	set_prev_col___0 (a_prev_col___0: INTEGER_32)
		do
			prev_col___0 := a_prev_col___0
		end

	dragwin: CE_POINTER [PD_WINDOW_S]

	did_drag: INTEGER_32 assign set_did_drag

	set_did_drag (a_did_drag: INTEGER_32)
		do
			did_drag := a_did_drag
		end

	last_time: INTEGER_32 assign set_last_time

	set_last_time (a_last_time: INTEGER_32)
		do
			last_time := a_last_time
		end

feature {ANY} -- routines

	ui_write (a_s: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_s: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tofree: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_tofree.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s.ce_gets (a_s)
					l_len := a_len
					if (gui_inst.gui.in_use).to_boolean then
						if not (gui_inst.gui.dying).to_boolean then
							if not (gui_inst.gui.starting).to_boolean then
								gui_inst.gui_write (l_s, l_len)
								if option_inst.p_wd.to_boolean then
									gui_inst.gui_wait_for_chars (option_inst.p_wd).do_nothing
								end
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if not (globals_inst.silent_mode.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if option_inst.p_verbose /= 0 then
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						l_tofree.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						if globals_inst.output_conv.vc_type /= 0 then
							l_tofree.ce_gets (mbyte_inst.string_convert (globals_inst.output_conv.address, l_s, create {CE_POINTER [INTEGER_32]}.make_shared ($l_len)))
							if (l_tofree.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_s.ce_gets (l_tofree)
							end
						end
						os_unix_inst.mch_write (l_s, l_len)
						if globals_inst.output_conv.vc_type /= 0 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tofree))
						end
				when 5 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ui_inchar_undo (a_s: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_new: CE_POINTER [NATURAL_8]
			l_newlen: INTEGER_32
		do
			create l_new.make

			l_newlen := a_len
			if (ta_str.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_newlen := l_newlen + (ta_len - ta_off)
			end
			l_new.ce_gets (misc2_inst.alloc (l_newlen.to_natural_32))
			if (l_new.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (ta_str.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					memmove (create {CE_POINTER [ANY]}.make_cast (l_new), create {CE_POINTER [ANY]}.make_cast ((ta_str + ta_off)), (ta_len - ta_off).to_natural_32).do_nothing
					memmove (create {CE_POINTER [ANY]}.make_cast (((l_new + ta_len) - ta_off)), create {CE_POINTER [ANY]}.make_cast (a_s), a_len.to_natural_32).do_nothing
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (ta_str))
				else
					memmove (create {CE_POINTER [ANY]}.make_cast (l_new), create {CE_POINTER [ANY]}.make_cast (a_s), a_len.to_natural_32).do_nothing
				end
				ta_str.ce_gets (l_new)
				ta_len := l_newlen
				ta_off := 0
			end
		end

	ui_inchar (a_buf___6: CE_POINTER [NATURAL_8]; a_maxlen: INTEGER_32; a_wtime: INTEGER_32; a_tb_change_cnt: INTEGER_32): INTEGER_32
		local
			l_retval: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_retval := 0
					if (ta_str.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						if a_maxlen >= ta_len - ta_off then
							memmove (create {CE_POINTER [ANY]}.make_cast (a_buf___6), create {CE_POINTER [ANY]}.make_cast ((ta_str + ta_off)), ta_len.to_natural_32).do_nothing
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (ta_str))
							ta_str.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							Result := ta_len
							js.return
						end
						if not js.return_called then
							memmove (create {CE_POINTER [ANY]}.make_cast (a_buf___6), create {CE_POINTER [ANY]}.make_cast ((ta_str + ta_off)), a_maxlen.to_natural_32).do_nothing
							ta_off := ta_off + a_maxlen
							Result := a_maxlen
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						if not ((gui_inst.no_console_input).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if a_wtime >= 0 then
							if a_wtime < 10 then
								l_tmp := 10
							else
								l_tmp := a_wtime
							end
						else
							l_tmp := a_wtime
						end
						l_retval := os_unix_inst.mch_inchar (a_buf___6, a_maxlen, l_tmp, a_tb_change_cnt)
						if l_retval > 0 then
							l_pos := -1 + 10 -- goto theend
						elseif (getchar_inst.typebuf_changed (a_tb_change_cnt)).to_boolean then
							l_pos := -1 + 10 -- goto theend
						elseif a_wtime >= 0 then
							l_pos := -1 + 10 -- goto theend
						end
				when 3 then
						if a_wtime = -1 then
							count___1 := count___1 + 1
							if count___1 = 1000 then
								read_error_exit
							end
						end
						a_buf___6[0] := (('%R').code).to_natural_8
						l_retval := 1
						l_pos := -1 + 10 -- goto theend
				when 4 then
						if a_wtime /= -1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if not (a_wtime > 100) then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						os_unix_inst.vim_handle_signal (-2).do_nothing
						if globals_inst.mapped_ctrl_c.to_boolean then
							globals_inst.ctrl_c_interrupts := 0
						end
				when 9 then -- if done
						if (gui_inst.gui.in_use).to_boolean then
							if (gui_inst.gui_wait_for_chars (a_wtime)).to_boolean then
								if not (getchar_inst.typebuf_changed (a_tb_change_cnt)).to_boolean then
									l_retval := read_from_input_buf (a_buf___6, a_maxlen.to_integer_32)
								end
							end
						else
							l_retval := os_unix_inst.mch_inchar (a_buf___6, a_maxlen, a_wtime, a_tb_change_cnt)
						end
						if a_wtime = -1 then
							os_unix_inst.vim_handle_signal (-1).do_nothing
						elseif a_wtime > 100 then
							os_unix_inst.vim_handle_signal (-1).do_nothing
						end
						globals_inst.ctrl_c_interrupts := 1
				when 10 then -- theend:
						Result := l_retval
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ui_char_avail: INTEGER_32
		local
			js: JUMP_STATE
		do
			if (gui_inst.gui.in_use).to_boolean then
				gui_gtk_x11_inst.gui_mch_update
				Result := (getchar_inst.input_available)
				js.return
			end
			if not js.return_called then
				if (gui_inst.no_console_input).to_boolean then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := (os_unix_inst.mch_char_avail)
			end
		end

	ui_delay (a_msec: INTEGER_32; a_ignoreinput: INTEGER_32)
		do
			if (gui_inst.gui.in_use).to_boolean then
				if not a_ignoreinput.to_boolean then
					gui_inst.gui_wait_for_chars (a_msec).do_nothing
				else
					os_unix_inst.mch_delay (a_msec, a_ignoreinput)
				end
			else
				os_unix_inst.mch_delay (a_msec, a_ignoreinput)
			end
		end

	ui_suspend
		local
			js: JUMP_STATE
		do
			if (gui_inst.gui.in_use).to_boolean then
				gui_gtk_x11_inst.gui_mch_iconify
				js.return
			end
			if not js.return_called then
				os_unix_inst.mch_suspend
			end
		end

	ui_get_shellsize: INTEGER_32
		local
			l_retval: INTEGER_32
		do
			if (gui_inst.gui.in_use).to_boolean then
				l_retval := gui_inst.gui_get_shellsize
			else
				l_retval := os_unix_inst.mch_get_shellsize
			end
			term_inst.check_shellsize
			if l_retval = 1 then
				option_inst.set_number_default (ce_string ("lines"), globals_inst.Rows)
				option_inst.set_number_default (ce_string ("columns"), globals_inst.Columns)
			end
			Result := l_retval
		end

	ui_set_shellsize (a_mustset: INTEGER_32)
		do
			if (gui_inst.gui.in_use).to_boolean then
				gui_inst.gui_set_shellsize (a_mustset, 0, 15)
			else
				os_unix_inst.mch_set_shellsize
			end
		end

	ui_new_shellsize
		do
			if globals_inst.full_screen.to_boolean then
				if not globals_inst.exiting.to_boolean then
					if (gui_inst.gui.in_use).to_boolean then
						gui_inst.gui_new_shellsize
					else
						os_unix_inst.mch_new_shellsize
					end
				end
			end
		end

	ui_breakcheck
		do
			if (gui_inst.gui.in_use).to_boolean then
				gui_gtk_x11_inst.gui_mch_update
			else
				os_unix_inst.mch_breakcheck
			end
		end

	clip_init (a_can_use: INTEGER_32)
		local
			l_cb: CE_POINTER [PD_VIMCLIPBOARD]
			js: JUMP_STATE
		do
			create l_cb.make

			l_cb.ce_gets (globals_inst.clip_star.address)
			from
			until
				js.loop_left
			loop
				js.reset
				l_cb.item.available := a_can_use
				l_cb.item.owned := 0
				l_cb.item.start.lnum := (0).to_integer_32
				l_cb.item.start.col := 0
				l_cb.item.end2.lnum := (0).to_integer_32
				l_cb.item.end2.col := 0
				l_cb.item.state := (0).to_natural_16
				if (l_cb.c_pointer.to_integer_32).to_natural_32 = ((globals_inst.clip_plus.address).c_pointer.to_integer_32).to_natural_32 then
					js.break
				end
				if not js.loop_jumped then
					l_cb.ce_gets (globals_inst.clip_plus.address)
				end
			end
			js.reset
		end

	clip_update_selection
		local
			l_start___1: PD_POS_T
			l_end: PD_POS_T
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_start___1.make
			create l_end.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if globals_inst.redo_VIsual_busy.to_boolean then
						l_pos := -1 + 23 -- skip if block
					end
				when 1 then -- if:
						if not (globals_inst.VIsual_active.to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 2 then -- if:
						if not (((globals_inst.State).bit_and (1)).to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 3 then -- if:
						if globals_inst.VIsual.lnum /= globals_inst.curwin.item.w_cursor.lnum then
							l_tmp___2 := (globals_inst.VIsual.lnum < globals_inst.curwin.item.w_cursor.lnum).to_integer
						else
							if globals_inst.VIsual.col /= globals_inst.curwin.item.w_cursor.col then
								l_tmp___1 := (globals_inst.VIsual.col < globals_inst.curwin.item.w_cursor.col).to_integer
							else
								l_tmp___1 := (globals_inst.VIsual.coladd < globals_inst.curwin.item.w_cursor.coladd).to_integer
							end
							l_tmp___2 := l_tmp___1
						end
						if l_tmp___2.to_boolean then
							l_start___1.ce_gets (globals_inst.VIsual)
							l_end.ce_gets (globals_inst.curwin.item.w_cursor)
							if globals_inst.has_mbyte.to_boolean then
								l_end.col := l_end.col + ((globals_inst.mb_ptr2len.integer_32_item ([(memline_inst.ml_get_cursor)])) - 1)
							end
						else
							l_start___1.ce_gets (globals_inst.curwin.item.w_cursor)
							l_end.ce_gets (globals_inst.VIsual)
						end
						if globals_inst.clip_star.start.lnum /= l_start___1.lnum then
							l_pos := -1 + 22 -- skip if block
						end
				when 4 then -- if:
						if globals_inst.clip_star.start.col /= l_start___1.col then
							l_pos := -1 + 20 -- skip if block
						end
				when 5 then -- if:
						if globals_inst.clip_star.start.coladd /= l_start___1.coladd then
							l_pos := -1 + 18 -- skip if block
						end
				when 6 then -- if:
						if globals_inst.clip_star.end2.lnum /= l_end.lnum then
							l_pos := -1 + 16 -- skip if block
						end
				when 7 then -- if:
						if globals_inst.clip_star.end2.col /= l_end.col then
							l_pos := -1 + 14 -- skip if block
						end
				when 8 then -- if:
						if globals_inst.clip_star.end2.coladd /= l_end.coladd then
							l_pos := -1 + 12 -- skip if block
						end
				when 9 then -- if:
						if globals_inst.clip_star.vmode = globals_inst.VIsual_mode then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						clip_clear_selection
						globals_inst.clip_star.start := l_start___1
						globals_inst.clip_star.end2 := l_end
						globals_inst.clip_star.vmode := globals_inst.VIsual_mode
						ops_inst.clip_free_selection (globals_inst.clip_star.address)
						clip_own_selection (globals_inst.clip_star.address)
						clip_gen_set_selection (globals_inst.clip_star.address)
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						l_pos := -1 + 10 -- goto _L
				when 13 then -- if done | if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						l_pos := -1 + 10 -- goto _L
				when 15 then -- if done | if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						l_pos := -1 + 10 -- goto _L
				when 17 then -- if done | if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						l_pos := -1 + 10 -- goto _L
				when 19 then -- if done | if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						l_pos := -1 + 10 -- goto _L
				when 21 then -- if done | if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:
						l_pos := -1 + 10 -- goto _L
				when 23 then -- if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	clip_own_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		local
			l_was_owned: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((a_cbd.item.available).to_boolean) then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						l_was_owned := a_cbd.item.owned
						a_cbd.item.owned := ((clip_gen_own_selection (a_cbd)) = 1).to_integer
						if l_was_owned.to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 2 then -- if:
						if (a_cbd.c_pointer.to_integer_32).to_natural_32 /= ((globals_inst.clip_star.address).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						if not ((a_cbd.item.owned).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if (misc2_inst.get_real_state) /= 2 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if (misc2_inst.get_real_state) /= 4096 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if (clip_isautosel).to_boolean then
							if globals_inst.highlight_attr[15] /= globals_inst.highlight_attr[16] then
								screen_inst.redraw_curbuf_later (25)
							end
						end
				when 9 then -- if done | if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	clip_lose_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		local
			l_was_owned: INTEGER_32
			l_visual_selection: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_was_owned := a_cbd.item.owned
					l_visual_selection := ((a_cbd.c_pointer.to_integer_32).to_natural_32 = ((globals_inst.clip_star.address).c_pointer.to_integer_32).to_natural_32).to_integer
					ops_inst.clip_free_selection (a_cbd)
					a_cbd.item.owned := 0
					if l_visual_selection.to_boolean then
						clip_clear_selection
					end
					clip_gen_lose_selection (a_cbd)
					if not (l_visual_selection.to_boolean) then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if not (l_was_owned.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if (misc2_inst.get_real_state) /= 2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if (misc2_inst.get_real_state) /= 4096 then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						if (clip_isautosel).to_boolean then
							if globals_inst.highlight_attr[15] /= globals_inst.highlight_attr[16] then
								screen_inst.update_curbuf (25)
								screen_inst.setcursor
								term_inst.cursor_on
								term_inst.out_flush
								if (gui_inst.gui.in_use).to_boolean then
									gui_inst.gui_update_cursor (1, 0)
								end
							end
						end
				when 7 then -- if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	clip_copy_selection
		do
			if globals_inst.VIsual_active.to_boolean then
				if ((globals_inst.State).bit_and (1)).to_boolean then
					if (globals_inst.clip_star.available).to_boolean then
						if (clip_isautosel).to_boolean then
							clip_update_selection
						end
						ops_inst.clip_free_selection (globals_inst.clip_star.address)
						clip_own_selection (globals_inst.clip_star.address)
						if (globals_inst.clip_star.owned).to_boolean then
							ops_inst.clip_get_selection (globals_inst.clip_star.address)
						end
						clip_gen_set_selection (globals_inst.clip_star.address)
					end
				end
			end
		end

	clip_auto_select
		do
			if (clip_isautosel).to_boolean then
				clip_copy_selection
			end
		end

	clip_isautosel: INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (gui_inst.gui.in_use).to_boolean then
				l_tmp___0 := (((misc2_inst.vim_strchr (option_inst.p_go, ('a').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
			else
				l_tmp___0 := globals_inst.clip_autoselect
			end
			Result := l_tmp___0
		end

	clip_modeless (a_button: INTEGER_32; a_is_click: INTEGER_32; a_is_drag: INTEGER_32)
		local
			l_repeat: INTEGER_32
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (globals_inst.clip_star.mode).to_integer_32 /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if (globals_inst.clip_star.mode).to_integer_32 /= 2 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L___0:
						if ((globals_inst.mod_mask).bit_and (32)).to_boolean then
							l_tmp := 1
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if (globals_inst.clip_star.mode).to_integer_32 = 1 then
							if ((globals_inst.mod_mask).bit_and (64)).to_boolean then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
				when 7 then -- if done
						l_repeat := l_tmp
						if not (a_is_click.to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
							if a_button = 2 then
								if (globals_inst.clip_star.state).to_integer_32 = 0 then
									clip_start_selection (globals_inst.mouse_col, globals_inst.mouse_row, 0)
								end
								clip_process_selection (a_button, globals_inst.mouse_col, globals_inst.mouse_row, l_repeat.to_natural_32)
							else
								l_pos := -1 + 10 -- goto _L___1
							end
				when 9 then -- if block done, skip else block:
							l_pos := -1 + 11
				when 10 then -- else: | _L___1:
							if a_is_click.to_boolean then
								clip_start_selection (globals_inst.mouse_col, globals_inst.mouse_row, l_repeat)
							elseif a_is_drag.to_boolean then
								if (globals_inst.clip_star.state).to_integer_32 /= 0 then
									clip_process_selection (a_button, globals_inst.mouse_col, globals_inst.mouse_row, l_repeat.to_natural_32)
								end
							else
								clip_process_selection (3, globals_inst.mouse_col, globals_inst.mouse_row, (0).to_natural_32)
							end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	clip_compare_pos (a_row1: INTEGER_32; a_col1: INTEGER_32; a_row2: INTEGER_32; a_col2: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_row1 > a_row2 then
				Result := 1
				js.return
			end
			if not js.return_called and then (a_row1 < a_row2) then
				Result := (-1)
				js.return
			end
			if not js.return_called and then (a_col1 > a_col2) then
				Result := 1
				js.return
			end
			if not js.return_called and then (a_col1 < a_col2) then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	clip_start_selection (a_col: INTEGER_32; a_row: INTEGER_32; a_repeated_click: INTEGER_32)
		local
			l_col: INTEGER_32
			l_row: INTEGER_32
			l_cb: CE_POINTER [PD_VIMCLIPBOARD]
			l_pos: INTEGER_32
		do
			create l_cb.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_col := a_col
					l_row := a_row
					l_cb.ce_gets (globals_inst.clip_star.address)
					if (l_cb.item.state).to_integer_32 = 2 then
						clip_clear_selection
					end
					l_row := check_row (l_row)
					l_col := check_col (l_col)
					l_col := mbyte_inst.mb_fix_col (l_col, l_row)
					l_cb.item.start.lnum := l_row.to_integer_32
					l_cb.item.start.col := l_col
					l_cb.item.end2 := l_cb.item.start
					l_cb.item.origin_row := (l_cb.item.start.lnum).to_natural_16
					l_cb.item.state := (1).to_natural_16
					if a_repeated_click.to_boolean then
						l_cb.item.mode := ((l_cb.item.mode).to_integer_32 + 1).to_natural_16
						if l_cb.item.mode > 2 then
							l_cb.item.mode := (0).to_natural_16
						end
					else
						l_cb.item.mode := (0).to_natural_16
					end
					if (gui_inst.gui.in_use).to_boolean then
						gui_inst.gui_undraw_cursor
					end
					inspect (l_cb.item.mode).to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 0
					l_cb.item.origin_start_col := (l_cb.item.start.col).to_natural_16
					l_cb.item.word_end_col := (clip_get_line_end ((l_cb.item.start.lnum).to_integer_32)).to_natural_16
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 1
					clip_get_word_boundaries (l_cb, (l_cb.item.start.lnum).to_integer_32, l_cb.item.start.col)
					l_cb.item.origin_start_col := l_cb.item.word_start_col
					l_cb.item.origin_end_col := l_cb.item.word_end_col
					clip_invert_area ((l_cb.item.start.lnum).to_integer_32, (l_cb.item.word_start_col).to_integer_32, (l_cb.item.end2.lnum).to_integer_32, (l_cb.item.word_end_col).to_integer_32, 2)
					l_cb.item.start.col := (l_cb.item.word_start_col).to_integer_32
					l_cb.item.end2.col := (l_cb.item.word_end_col).to_integer_32
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, case 2
					clip_invert_area ((l_cb.item.start.lnum).to_integer_32, 0, (l_cb.item.start.lnum).to_integer_32, globals_inst.Columns.to_integer_32, 2)
					l_cb.item.start.col := 0
					l_cb.item.end2.col := globals_inst.Columns.to_integer_32
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					l_cb.item.prev := l_cb.item.start
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	clip_process_selection (a_button: INTEGER_32; a_col: INTEGER_32; a_row: INTEGER_32; a_repeated_click: NATURAL_32)
		local
			l_col: INTEGER_32
			l_row: INTEGER_32
			l_cb: CE_POINTER [PD_VIMCLIPBOARD]
			l_diff: INTEGER_32
			l_slen: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_cb.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_col := a_col
					l_row := a_row
					l_cb.ce_gets (globals_inst.clip_star.address)
					l_slen := 1
					if a_button = 3 then
						if l_cb.item.start.lnum = l_cb.item.end2.lnum then
							if l_cb.item.start.col = l_cb.item.end2.col then
								if (gui_inst.gui.in_use).to_boolean then
									gui_inst.gui_update_cursor (0, 0)
								end
								l_cb.item.state := (0).to_natural_16
								js.return
							end
						end
						if not js.return_called then
							if (clip_isautosel).to_boolean then
								clip_copy_modeless_selection (0)
							else
								if (gui_inst.gui.in_use).to_boolean then
									l_tmp___1 := (((misc2_inst.vim_strchr (option_inst.p_go, ('A').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
								else
									l_tmp___1 := globals_inst.clip_autoselectml
								end
								if l_tmp___1.to_boolean then
									clip_copy_modeless_selection (0)
								end
							end
							if (gui_inst.gui.in_use).to_boolean then
								gui_inst.gui_update_cursor (0, 0)
							end
							l_cb.item.state := (2).to_natural_16
							js.return
						end
					end
					if not js.return_called then
						l_row := check_row (l_row)
						l_col := check_col (l_col)
						l_col := mbyte_inst.mb_fix_col (l_col, l_row)
						if l_col = l_cb.item.prev.col then
							if l_row.to_integer_32 = l_cb.item.prev.lnum then
								if not a_repeated_click.to_boolean then
									js.return
								end
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 18 -- skip if block
					end
				when 1 then -- if:
						if (l_cb.item.state).to_integer_32 /= 2 then
							l_pos := -1 + 14 -- skip if block
						end
				when 2 then -- if:
						if a_button /= 2 then
							l_pos := -1 + 14 -- skip if block
						end
				when 3 then -- if:
						if not ((clip_compare_pos (l_row, l_col, (l_cb.item.start.lnum).to_integer_32, l_cb.item.start.col)) < 0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_cb.item.origin_row := (l_cb.item.end2.lnum).to_natural_16
						l_cb.item.origin_start_col := (l_cb.item.end2.col - 1).to_natural_16
						l_cb.item.origin_end_col := (l_cb.item.end2.col).to_natural_16
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if not ((clip_compare_pos (l_row, l_col, (l_cb.item.end2.lnum).to_integer_32, l_cb.item.end2.col)) < 0) then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						if l_cb.item.start.lnum /= l_cb.item.end2.lnum then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_cb.item.end2.col - l_col > l_col - l_cb.item.start.col then
							l_cb.item.origin_row := (l_cb.item.end2.lnum).to_natural_16
							l_cb.item.origin_start_col := (l_cb.item.end2.col - 1).to_natural_16
							l_cb.item.origin_end_col := (l_cb.item.end2.col).to_natural_16
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						l_diff := ((l_cb.item.end2.lnum - l_row.to_integer_32) - (l_row.to_integer_32 - l_cb.item.start.lnum)).to_integer_32
						if l_diff > 0 then
							l_cb.item.origin_row := (l_cb.item.end2.lnum).to_natural_16
							l_cb.item.origin_start_col := (l_cb.item.end2.col - 1).to_natural_16
							l_cb.item.origin_end_col := (l_cb.item.end2.col).to_natural_16
						elseif l_diff = 0 then
							if l_col < (l_cb.item.start.col + l_cb.item.end2.col) // 2 then
								l_cb.item.origin_row := (l_cb.item.end2.lnum).to_natural_16
								l_cb.item.origin_start_col := (l_cb.item.end2.col - 1).to_natural_16
								l_cb.item.origin_end_col := (l_cb.item.end2.col).to_natural_16
							else
								l_cb.item.origin_row := (l_cb.item.start.lnum).to_natural_16
								l_cb.item.origin_start_col := (l_cb.item.start.col).to_natural_16
								l_cb.item.origin_end_col := (l_cb.item.start.col).to_natural_16
							end
						else
							l_cb.item.origin_row := (l_cb.item.start.lnum).to_natural_16
							l_cb.item.origin_start_col := (l_cb.item.start.col).to_natural_16
							l_cb.item.origin_end_col := (l_cb.item.start.col).to_natural_16
						end
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						l_cb.item.origin_row := (l_cb.item.start.lnum).to_natural_16
						l_cb.item.origin_start_col := (l_cb.item.start.col).to_natural_16
						l_cb.item.origin_end_col := (l_cb.item.start.col).to_natural_16
				when 13 then -- if done
						if (l_cb.item.mode).to_integer_32 = 1 then
							if not a_repeated_click.to_boolean then
								l_cb.item.mode := (0).to_natural_16
							end
						end
				when 14 then -- if done | if done
						l_cb.item.state := (1).to_natural_16
						if a_repeated_click.to_boolean then
							l_cb.item.mode := ((l_cb.item.mode).to_integer_32 + 1).to_natural_16
							if l_cb.item.mode > 2 then
								l_cb.item.mode := (0).to_natural_16
							end
						end
						inspect (l_cb.item.mode).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 15
						when 1 then l_pos := -1 + 16
						when 2 then l_pos := -1 + 17
						else l_pos := -1 + 18
						end
				when 15 then -- switch 1, case 0
						if l_row.to_integer_32 /= l_cb.item.prev.lnum then
							l_cb.item.word_end_col := (clip_get_line_end (l_row)).to_natural_16
						end
						if (clip_compare_pos (l_row, l_col, (l_cb.item.origin_row).to_integer_32, (l_cb.item.origin_start_col).to_integer_32)) >= 0 then
							if l_col >= (l_cb.item.word_end_col).to_integer_32 then
								clip_update_modeless_selection (l_cb, (l_cb.item.origin_row).to_integer_32, (l_cb.item.origin_start_col).to_integer_32, l_row, globals_inst.Columns.to_integer_32)
							else
								if globals_inst.has_mbyte.to_boolean then
									if (mbyte_inst.mb_lefthalve (l_row, l_col)).to_boolean then
										l_slen := 2
									end
								end
								clip_update_modeless_selection (l_cb, (l_cb.item.origin_row).to_integer_32, (l_cb.item.origin_start_col).to_integer_32, l_row, l_col + l_slen)
							end
						else
							if globals_inst.has_mbyte.to_boolean then
								if (mbyte_inst.mb_lefthalve ((l_cb.item.origin_row).to_integer_32, (l_cb.item.origin_start_col).to_integer_32)).to_boolean then
									l_slen := 2
								end
							end
							if l_col >= (l_cb.item.word_end_col).to_integer_32 then
								clip_update_modeless_selection (l_cb, l_row, (l_cb.item.word_end_col).to_integer_32, (l_cb.item.origin_row).to_integer_32, (l_cb.item.origin_start_col).to_integer_32 + l_slen)
							else
								clip_update_modeless_selection (l_cb, l_row, l_col, (l_cb.item.origin_row).to_integer_32, (l_cb.item.origin_start_col).to_integer_32 + l_slen)
							end
						end
						l_pos := -1 + 18 -- switch 1; break
				when 16 then -- switch 1, case 1
						if l_row.to_integer_32 = l_cb.item.prev.lnum then
							if l_col >= (l_cb.item.word_start_col).to_integer_32 then
								if l_col < (l_cb.item.word_end_col).to_integer_32 then
									if not a_repeated_click.to_boolean then
										js.return
									end
								end
							end
						end
						if not js.return_called then
							clip_get_word_boundaries (l_cb, l_row, l_col)
							if (clip_compare_pos (l_row, l_col, (l_cb.item.origin_row).to_integer_32, (l_cb.item.origin_start_col).to_integer_32)) >= 0 then
								clip_update_modeless_selection (l_cb, (l_cb.item.origin_row).to_integer_32, (l_cb.item.origin_start_col).to_integer_32, l_row, (l_cb.item.word_end_col).to_integer_32)
							else
								clip_update_modeless_selection (l_cb, l_row, (l_cb.item.word_start_col).to_integer_32, (l_cb.item.origin_row).to_integer_32, (l_cb.item.origin_end_col).to_integer_32)
							end
						end
						l_pos := -1 + 18 -- switch 1; break
				when 17 then -- switch 1, case 2
						if l_row.to_integer_32 = l_cb.item.prev.lnum then
							if not a_repeated_click.to_boolean then
								js.return
							end
						end
						if not js.return_called then
							if (clip_compare_pos (l_row, l_col, (l_cb.item.origin_row).to_integer_32, (l_cb.item.origin_start_col).to_integer_32)) >= 0 then
								clip_update_modeless_selection (l_cb, (l_cb.item.origin_row).to_integer_32, 0, l_row, globals_inst.Columns.to_integer_32)
							else
								clip_update_modeless_selection (l_cb, l_row, 0, (l_cb.item.origin_row).to_integer_32, globals_inst.Columns.to_integer_32)
							end
						end
						l_pos := -1 + 18 -- switch 1; break
				when 18 then -- switch 1, done: | if done
						if not js.return_called then
							l_cb.item.prev.lnum := l_row.to_integer_32
							l_cb.item.prev.col := l_col
						end
				when 19 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	clip_may_redraw_selection (a_row: INTEGER_32; a_col: INTEGER_32; a_len: INTEGER_32)
		local
			l_start___1: INTEGER_32
			l_end: INTEGER_32
		do
			l_start___1 := a_col
			l_end := a_col + a_len
			if (globals_inst.clip_star.state).to_integer_32 /= 0 then
				if a_row.to_integer_32 >= globals_inst.clip_star.start.lnum then
					if a_row.to_integer_32 <= globals_inst.clip_star.end2.lnum then
						if a_row.to_integer_32 = globals_inst.clip_star.start.lnum then
							if l_start___1 < globals_inst.clip_star.start.col then
								l_start___1 := globals_inst.clip_star.start.col
							end
						end
						if a_row.to_integer_32 = globals_inst.clip_star.end2.lnum then
							if l_end > globals_inst.clip_star.end2.col then
								l_end := globals_inst.clip_star.end2.col
							end
						end
						if l_end > l_start___1 then
							clip_invert_area (a_row, l_start___1, a_row, l_end, 0)
						end
					end
				end
			end
		end

	clip_clear_selection
		local
			l_cb: CE_POINTER [PD_VIMCLIPBOARD]
			js: JUMP_STATE
		do
			create l_cb.make

			l_cb.ce_gets (globals_inst.clip_star.address)
			if (l_cb.item.state).to_integer_32 = 0 then
				js.return
			end
			if not js.return_called then
				clip_invert_area ((l_cb.item.start.lnum).to_integer_32, l_cb.item.start.col, (l_cb.item.end2.lnum).to_integer_32, l_cb.item.end2.col, 1)
				l_cb.item.state := (0).to_natural_16
			end
		end

	clip_may_clear_selection (a_row1: INTEGER_32; a_row2: INTEGER_32)
		do
			if (globals_inst.clip_star.state).to_integer_32 = 2 then
				if a_row2.to_integer_32 >= globals_inst.clip_star.start.lnum then
					if a_row1.to_integer_32 <= globals_inst.clip_star.end2.lnum then
						clip_clear_selection
					end
				end
			end
		end

	clip_scroll_selection (a_rows: INTEGER_32)
		local
			l_lnum: INTEGER_32
			js: JUMP_STATE
		do
			if (globals_inst.clip_star.state).to_integer_32 = 0 then
				js.return
			end
			if not js.return_called then
				l_lnum := (globals_inst.clip_star.start.lnum - a_rows.to_integer_32).to_integer_32
				if l_lnum <= 0 then
					globals_inst.clip_star.start.lnum := (0).to_integer_32
				elseif l_lnum >= globals_inst.screen_Rows then
					globals_inst.clip_star.state := (0).to_natural_16
				else
					globals_inst.clip_star.start.lnum := l_lnum.to_integer_32
				end
				l_lnum := (globals_inst.clip_star.end2.lnum - a_rows.to_integer_32).to_integer_32
				if l_lnum < 0 then
					globals_inst.clip_star.state := (0).to_natural_16
				elseif l_lnum >= globals_inst.screen_Rows then
					globals_inst.clip_star.end2.lnum := (globals_inst.screen_Rows - 1).to_integer_32
				else
					globals_inst.clip_star.end2.lnum := l_lnum.to_integer_32
				end
			end
		end

	clip_invert_area (a_row1: INTEGER_32; a_col1: INTEGER_32; a_row2: INTEGER_32; a_col2: INTEGER_32; a_how: INTEGER_32)
		local
			l_row1: INTEGER_32
			l_col1: INTEGER_32
			l_row2: INTEGER_32
			l_col2: INTEGER_32
			l_invert: INTEGER_32
			l_tmp_row: INTEGER_32
			l_tmp_col: INTEGER_32
		do
			l_row1 := a_row1
			l_col1 := a_col1
			l_row2 := a_row2
			l_col2 := a_col2
			l_invert := 0
			if a_how = 2 then
				l_invert := 1
			end
			if (clip_compare_pos (l_row1, l_col1, l_row2, l_col2)) > 0 then
				l_tmp_row := l_row1
				l_tmp_col := l_col1
				l_row1 := l_row2
				l_col1 := l_col2
				l_row2 := l_tmp_row
				l_col2 := l_tmp_col
			elseif a_how = 3 then
				l_invert := 1
			end
			if l_row1 = l_row2 then
				clip_invert_rectangle (l_row1, l_col1, 1, l_col2 - l_col1, l_invert)
			else
				if l_col1 > 0 then
					clip_invert_rectangle (l_row1, l_col1, 1, globals_inst.Columns.to_integer_32 - l_col1, l_invert)
					l_row1 := l_row1 + 1
				end
				if l_col2.to_integer_32 < globals_inst.Columns - 1 then
					clip_invert_rectangle (l_row2, 0, 1, l_col2, l_invert)
					l_row2 := l_row2 - 1
				end
				if l_row2 >= l_row1 then
					clip_invert_rectangle (l_row1, 0, (l_row2 - l_row1) + 1, globals_inst.Columns.to_integer_32, l_invert)
				end
			end
		end

	clip_invert_rectangle (a_row: INTEGER_32; a_col: INTEGER_32; a_height: INTEGER_32; a_width: INTEGER_32; a_invert: INTEGER_32)
		do
			if (gui_inst.gui.in_use).to_boolean then
				gui_gtk_x11_inst.gui_mch_invert_rectangle (a_row, a_col, a_height, a_width)
			else
				screen_inst.screen_draw_rectangle (a_row, a_col, a_height, a_width, a_invert)
			end
		end

	clip_copy_modeless_selection (a_both: INTEGER_32)
		local
			l_buffer: CE_POINTER [NATURAL_8]
			l_bufp: CE_POINTER [NATURAL_8]
			l_row: INTEGER_32
			l_start_col: INTEGER_32
			l_end_col: INTEGER_32
			l_line_end_col: INTEGER_32
			l_add_newline_flag: INTEGER_32
			l_len: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_row1: INTEGER_32
			l_col1: INTEGER_32
			l_row2: INTEGER_32
			l_col2: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_off___0: INTEGER_32
			l_i___1: INTEGER_32
			l_ci: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buffer.make
			create l_bufp.make
			create l_p___0.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___8.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_add_newline_flag := 0
					l_row1 := (globals_inst.clip_star.start.lnum).to_integer_32
					l_col1 := globals_inst.clip_star.start.col
					l_row2 := (globals_inst.clip_star.end2.lnum).to_integer_32
					l_col2 := globals_inst.clip_star.end2.col
					if (globals_inst.ScreenLines.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.return
					end
					if not js.return_called then
						if l_row1 > l_row2 then
							l_row := l_row1
							l_row1 := l_row2
							l_row2 := l_row
							l_row := l_col1
							l_col1 := l_col2
							l_col2 := l_row
						elseif l_row1 = l_row2 then
							if l_col1 > l_col2 then
								l_row := l_col1
								l_col1 := l_col2
								l_col2 := l_row
							end
						end
						l_p___0.ce_gets (globals_inst.ScreenLines + (globals_inst.LineOffset[l_row1]).to_integer_32)
						if globals_inst.enc_dbcs /= 0 then
							l_col1 := l_col1 - (globals_inst.mb_head_off.integer_32_item ([l_p___0, l_p___0 + l_col1]))
						elseif globals_inst.enc_utf8.to_boolean then
							if (l_p___0[l_col1]).to_integer_32 = 0 then
								l_col1 := l_col1 - 1
							end
						end
						l_len := (((l_row2 - l_row1) + 1).to_integer_32 * globals_inst.Columns + 1).to_integer_32
						if globals_inst.enc_dbcs /= 0 then
							l_len := l_len * (2)
						elseif globals_inst.enc_utf8.to_boolean then
							l_len := l_len * (21)
						end
						l_buffer.ce_gets (misc2_inst.lalloc (l_len.to_natural_32, 1))
						if (l_buffer.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 23 -- skip if block
					end
				when 1 then -- if:
						l_bufp.ce_gets (l_buffer)
						l_row := l_row1
				when 2 then -- loop condition:
						if not (not js.loop_left and then (l_row <= l_row2)) then
							l_pos := -1 + 22 -- skip loop
						end
				when 3 then -- loop body:
						if l_row = l_row1 then
							l_start_col := l_col1
						else
							l_start_col := 0
						end
						if l_row = l_row2 then
							l_end_col := l_col2
						else
							l_end_col := globals_inst.Columns.to_integer_32
						end
						l_line_end_col := clip_get_line_end (l_row)
						if not (l_end_col.to_integer_32 >= globals_inst.Columns) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if not (l_row < l_row2) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if not (l_end_col > l_line_end_col) then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						l_end_col := l_line_end_col
						if l_end_col < l_start_col then
							l_end_col := l_start_col
						end
						if l_row = l_row2 then
							l_add_newline_flag := 1
						end
				when 9 then -- if done | if done
						if l_row > l_row1 then
							if not (globals_inst.LineWraps[(l_row - 1)]).to_boolean then
								l_tmp___0.ce_gets (l_bufp)
								l_bufp.ce_gets (l_bufp + 1)
								l_tmp___0.item := (('%N').code).to_natural_8
							end
						end
						if not (l_row < globals_inst.screen_Rows) then
							l_pos := -1 + 21 -- skip if block
						end
				when 10 then -- if:
						if not (l_end_col <= globals_inst.screen_Columns) then
							l_pos := -1 + 21 -- skip if block
						end
				when 11 then -- if:
						if globals_inst.enc_dbcs = 0 then
							l_pos := -1 + 20 -- skip if block
						end
				when 12 then -- if:
						l_p___0.ce_gets (globals_inst.ScreenLines + (globals_inst.LineOffset[l_row]).to_integer_32)
						l_i___0 := l_start_col
				when 13 then -- loop condition:
						if not (l_i___0 < l_end_col) then
							l_pos := -1 + 19 -- skip loop
						end
				when 14 then -- loop body:
						if globals_inst.enc_dbcs /= 9932 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if (l_p___0[l_i___0]).to_integer_32 = 142 then
							l_tmp___1.ce_gets (l_bufp)
							l_bufp.ce_gets (l_bufp + 1)
							l_tmp___1.item := (142).to_natural_8
							l_tmp___2.ce_gets (l_bufp)
							l_bufp.ce_gets (l_bufp + 1)
							l_tmp___2.item := globals_inst.ScreenLines2[(globals_inst.LineOffset[l_row] + l_i___0.to_natural_32).to_integer_32]
						else
							l_pos := -1 + 17 -- goto _L___0
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else: | _L___0:
						l_tmp___3.ce_gets (l_bufp)
						l_bufp.ce_gets (l_bufp + 1)
						l_tmp___3.item := l_p___0[l_i___0]
						if (globals_inst.mb_bytelen_tab[(l_p___0[l_i___0]).to_integer_32]).to_integer_32 = 2 then
							l_tmp___4.ce_gets (l_bufp)
							l_bufp.ce_gets (l_bufp + 1)
							l_i___0 := l_i___0 + 1
							l_tmp___4.item := l_p___0[l_i___0]
						end
				when 18 then
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 13 -- back to loop condition
				when 19 then -- loop done | if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						if globals_inst.enc_utf8.to_boolean then
							l_off___0 := (globals_inst.LineOffset[l_row]).to_integer_32
							l_i___1 := l_start_col
							from
							until
								not (not js.loop_left and then (l_i___1 < l_end_col))
							loop
								if globals_inst.ScreenLinesUC[(l_off___0 + l_i___1)] = {NATURAL_32} 0 then
									l_tmp___5.ce_gets (l_bufp)
									l_bufp.ce_gets (l_bufp + 1)
									l_tmp___5.item := globals_inst.ScreenLines[(l_off___0 + l_i___1)]
								else
									l_bufp.ce_gets (l_bufp + (mbyte_inst.utf_char2bytes ((globals_inst.ScreenLinesUC[(l_off___0 + l_i___1)]).to_integer_32, l_bufp)))
									l_ci := 0
									from
									until
										not (not js.loop_left and then (l_ci < globals_inst.Screen_mco))
									loop
										js.reset
										if (globals_inst.ScreenLinesC[l_ci])[(l_off___0 + l_i___1)] = {NATURAL_32} 0 then
											js.break
										end
										if not js.loop_jumped then
											l_bufp.ce_gets (l_bufp + (mbyte_inst.utf_char2bytes (((globals_inst.ScreenLinesC[l_ci])[(l_off___0 + l_i___1)]).to_integer_32, l_bufp)))
											l_ci := l_ci + 1
										end
									end
									js.reset
								end
								if (globals_inst.ScreenLines[((l_off___0 + l_i___1) + 1)]).to_integer_32 = 0 then
									l_i___1 := l_i___1 + 1
								end
								l_i___1 := l_i___1 + 1
							end
						else
							strncpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_bufp), create {CE_POINTER [INTEGER_8]}.make_cast (((globals_inst.ScreenLines + (globals_inst.LineOffset[l_row]).to_integer_32) + l_start_col)), (l_end_col - l_start_col).to_natural_32).do_nothing
							l_bufp.ce_gets (l_bufp + (l_end_col - l_start_col))
						end
				when 21 then -- if done | if done | if done
						l_row := l_row + 1
						l_pos := -1 + 2 -- back to loop condition
				when 22 then -- loop done
						if l_add_newline_flag.to_boolean then
							l_tmp___8.ce_gets (l_bufp)
							l_bufp.ce_gets (l_bufp + 1)
							l_tmp___8.item := (('%N').code).to_natural_8
						end
						ops_inst.clip_free_selection (globals_inst.clip_star.address)
						clip_own_selection (globals_inst.clip_star.address)
						ops_inst.clip_yank_selection (0, l_buffer, (l_bufp.distance (l_buffer)).to_integer_32, globals_inst.clip_star.address)
						clip_gen_set_selection (globals_inst.clip_star.address)
						if a_both.to_boolean then
							ops_inst.clip_free_selection (globals_inst.clip_plus.address)
							clip_own_selection (globals_inst.clip_plus.address)
							ops_inst.clip_yank_selection (0, l_buffer, (l_bufp.distance (l_buffer)).to_integer_32, globals_inst.clip_plus.address)
							clip_gen_set_selection (globals_inst.clip_plus.address)
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buffer))
				when 23 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	clip_get_word_boundaries (a_cb: CE_POINTER [PD_VIMCLIPBOARD]; a_row: INTEGER_32; a_col: INTEGER_32)
		local
			l_col: INTEGER_32
			l_start_class: INTEGER_32
			l_temp_col: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_mboff: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_col := a_col
					if a_row >= globals_inst.screen_Rows then
						js.return
					elseif l_col >= globals_inst.screen_Columns then
						js.return
					elseif (globals_inst.ScreenLines.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						l_p___0.ce_gets (globals_inst.ScreenLines + (globals_inst.LineOffset[a_row]).to_integer_32)
						if globals_inst.enc_dbcs /= 0 then
							l_col := l_col - (mbyte_inst.dbcs_screen_head_off (l_p___0, l_p___0 + l_col))
						elseif globals_inst.enc_utf8.to_boolean then
							if (l_p___0[l_col]).to_integer_32 = 0 then
								l_col := l_col - 1
							end
						end
						if (l_p___0[l_col]).to_integer_32 <= 32 then
							l_start_class := (' ').code
						else
							l_start_class := (charset_inst.vim_iswordc ((l_p___0[l_col]).to_integer_32))
						end
						l_temp_col := l_col
				when 2 then -- loop condition:
						if not (not js.loop_left and then (l_temp_col > 0)) then
							l_pos := -1 + 8 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if globals_inst.enc_dbcs = 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_mboff := mbyte_inst.dbcs_screen_head_off (l_p___0, (l_p___0 + l_temp_col) - 1)
						if l_mboff > 0 then
							l_temp_col := l_temp_col - l_mboff
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if (l_p___0[(l_temp_col - 1)]).to_integer_32 <= 32 then
							l_tmp___2 := (' ').code
						else
							l_tmp___2 := (charset_inst.vim_iswordc ((l_p___0[(l_temp_col - 1)]).to_integer_32))
						end
						if l_tmp___2 /= l_start_class then
							if globals_inst.enc_utf8.to_boolean then
								if (l_p___0[(l_temp_col - 1)]).to_integer_32 /= 0 then
									js.break
								end
							else
								js.break
							end
						end
				when 7 then
						if not js.loop_jumped then
							l_temp_col := l_temp_col - 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 8 then -- loop done
						js.reset
						a_cb.item.word_start_col := l_temp_col.to_natural_16
						l_temp_col := l_col
				when 9 then -- loop condition:
						if not (not js.loop_left and then (l_temp_col < globals_inst.screen_Columns)) then
							l_pos := -1 + 15 -- skip loop
						end
				when 10 then -- loop body:
						js.reset
						if globals_inst.enc_dbcs = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if (mbyte_inst.dbcs_ptr2cells (l_p___0 + l_temp_col)) = 2 then
							l_temp_col := l_temp_col + 1
						else
							l_pos := -1 + 13 -- goto _L___0
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L___0:
						if (l_p___0[l_temp_col]).to_integer_32 <= 32 then
							l_tmp___4 := (' ').code
						else
							l_tmp___4 := (charset_inst.vim_iswordc ((l_p___0[l_temp_col]).to_integer_32))
						end
						if l_tmp___4 /= l_start_class then
							if globals_inst.enc_utf8.to_boolean then
								if (l_p___0[l_temp_col]).to_integer_32 /= 0 then
									js.break
								end
							else
								js.break
							end
						end
				when 14 then
						if not js.loop_jumped then
							l_temp_col := l_temp_col + 1
						end
						l_pos := -1 + 9 -- back to loop condition
				when 15 then -- loop done
						js.reset
						a_cb.item.word_end_col := l_temp_col.to_natural_16
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	clip_get_line_end (a_row: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			if a_row >= globals_inst.screen_Rows then
				Result := 0
				js.return
			elseif (globals_inst.ScreenLines.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_i___0 := globals_inst.screen_Columns
				from
				until
					not (not js.loop_left and then (l_i___0 > 0))
				loop
					js.reset
					if (globals_inst.ScreenLines[((globals_inst.LineOffset[a_row] + l_i___0.to_natural_32) - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 32 then
						js.break
					end
					if not js.loop_jumped then
						l_i___0 := l_i___0 - 1
					end
				end
				js.reset
				Result := l_i___0
			end
		end

	clip_update_modeless_selection (a_cb: CE_POINTER [PD_VIMCLIPBOARD]; a_row1: INTEGER_32; a_col1: INTEGER_32; a_row2: INTEGER_32; a_col2: INTEGER_32)
		do
			if a_row1.to_integer_32 /= a_cb.item.start.lnum then
				clip_invert_area (a_row1, a_col1, (a_cb.item.start.lnum).to_integer_32, a_cb.item.start.col, 3)
				a_cb.item.start.lnum := a_row1.to_integer_32
				a_cb.item.start.col := a_col1
			elseif a_col1 /= a_cb.item.start.col then
				clip_invert_area (a_row1, a_col1, (a_cb.item.start.lnum).to_integer_32, a_cb.item.start.col, 3)
				a_cb.item.start.lnum := a_row1.to_integer_32
				a_cb.item.start.col := a_col1
			end
			if a_row2.to_integer_32 /= a_cb.item.end2.lnum then
				clip_invert_area ((a_cb.item.end2.lnum).to_integer_32, a_cb.item.end2.col, a_row2, a_col2, 3)
				a_cb.item.end2.lnum := a_row2.to_integer_32
				a_cb.item.end2.col := a_col2
			elseif a_col2 /= a_cb.item.end2.col then
				clip_invert_area ((a_cb.item.end2.lnum).to_integer_32, a_cb.item.end2.col, a_row2, a_col2, 3)
				a_cb.item.end2.lnum := a_row2.to_integer_32
				a_cb.item.end2.col := a_col2
			end
		end

	clip_gen_own_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD]): INTEGER_32
		do
			if (gui_inst.gui.in_use).to_boolean then
				Result := (gui_gtk_x11_inst.clip_mch_own_selection (a_cbd))
			else
				Result := (os_unix_inst.clip_xterm_own_selection (a_cbd))
			end
		end

	clip_gen_lose_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		do
			if (gui_inst.gui.in_use).to_boolean then
				gui_gtk_x11_inst.clip_mch_lose_selection (a_cbd)
			else
				os_unix_inst.clip_xterm_lose_selection (a_cbd)
			end
		end

	clip_gen_set_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		do
			if (gui_inst.gui.in_use).to_boolean then
				gui_gtk_x11_inst.clip_mch_set_selection (a_cbd)
			else
				os_unix_inst.clip_xterm_set_selection (a_cbd)
			end
		end

	clip_gen_request_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		do
			if (gui_inst.gui.in_use).to_boolean then
				gui_gtk_x11_inst.clip_mch_request_selection (a_cbd)
			else
				os_unix_inst.clip_xterm_request_selection (a_cbd)
			end
		end

	vim_is_input_buf_full: INTEGER_32
		do
			Result := (inbufcount >= 4096).to_integer
		end

	vim_is_input_buf_empty: INTEGER_32
		do
			Result := (inbufcount = 0).to_integer
		end

	vim_used_in_input_buf: INTEGER_32
		do
			Result := inbufcount
		end

	get_input_buf: CE_POINTER [NATURAL_8]
		local
			l_gap: CE_POINTER [PD_GROWARRAY]
		do
			create l_gap.make

			l_gap.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_cast ((misc2_inst.alloc ({PD_GROWARRAY}.sizeof.to_natural_32))))
			if (l_gap.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_gap.item.ga_data := create {CE_POINTER [ANY]}.make_cast ((misc2_inst.alloc (inbufcount.to_natural_32 + {NATURAL_32} 1)))
				if ((l_gap.item.ga_data).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					memmove (l_gap.item.ga_data, create {CE_POINTER [ANY]}.make_cast (inbuf), inbufcount.to_natural_32).do_nothing
				end
				l_gap.item.ga_len := inbufcount
			end
			trash_input_buf
			Result := (create {CE_POINTER [NATURAL_8]}.make_cast (l_gap))
		end

	set_input_buf (a_p___0: CE_POINTER [NATURAL_8])
		local
			l_gap: CE_POINTER [PD_GROWARRAY]
		do
			create l_gap.make

			l_gap.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_cast (a_p___0))
			if (l_gap.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if ((l_gap.item.ga_data).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					memmove (create {CE_POINTER [ANY]}.make_cast (inbuf), l_gap.item.ga_data, (l_gap.item.ga_len).to_natural_32).do_nothing
					inbufcount := l_gap.item.ga_len
					misc2_inst.vim_free (l_gap.item.ga_data)
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_gap))
			end
		end

	add_to_input_buf (a_s: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_s: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make
			create l_tmp___0.make

			l_s.ce_gets (a_s)
			l_len := a_len
			if inbufcount + l_len > 4102 then
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_tmp___1 := l_len
					l_len := l_len - 1
					if not l_tmp___1.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_tmp := inbufcount
						inbufcount := inbufcount + 1
						l_tmp___0.ce_gets (l_s)
						l_s.ce_gets (l_s + 1)
						inbuf[l_tmp] := l_tmp___0.item
					end
				end
				js.reset
			end
		end

	add_to_input_buf_csi (a_str___1: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_buf___6: CE_ARRAY [NATURAL_8]
		do
			create l_buf___6.make (<<2>>)

			l_i___0 := 0
			from
			until
				not (l_i___0 < a_len)
			loop
				add_to_input_buf (a_str___1 + l_i___0, 1)
				if (a_str___1[l_i___0]).to_integer_32 = 155 then
					l_buf___6[0] := (253).to_natural_8
					l_buf___6[1] := (81).to_natural_8
					add_to_input_buf (l_buf___6, 2)
				end
				l_i___0 := l_i___0 + 1
			end
		end

	trash_input_buf
		do
			inbufcount := 0
		end

	read_from_input_buf (a_buf___6: CE_POINTER [NATURAL_8]; a_maxlen: INTEGER_32): INTEGER_32
		local
			l_maxlen: INTEGER_32
		do
			l_maxlen := a_maxlen
			if inbufcount = 0 then
				fill_input_buf (1)
			end
			if l_maxlen > inbufcount.to_integer_32 then
				l_maxlen := inbufcount.to_integer_32
			end
			memmove (create {CE_POINTER [ANY]}.make_cast (a_buf___6), create {CE_POINTER [ANY]}.make_cast (inbuf), l_maxlen.to_natural_32).do_nothing
			inbufcount := (inbufcount.to_integer_32 - l_maxlen).to_integer_32
			if inbufcount.to_boolean then
				memmove (create {CE_POINTER [ANY]}.make_cast (inbuf), create {CE_POINTER [ANY]}.make_cast ((inbuf + l_maxlen)), inbufcount.to_natural_32).do_nothing
			end
			Result := l_maxlen.to_integer_32
		end

	fill_input_buf (a_exit_on_error: INTEGER_32)
		local
			l_len: INTEGER_32
			l_try: INTEGER_32
			l_unconverted: INTEGER_32
			l_m: INTEGER_32
			l_tmp___2: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
		do
			create l_tmp___2.make

			if (gui_inst.gui.in_use).to_boolean then
				if not (gui_inst.no_console_input).to_boolean then
					gui_gtk_x11_inst.gui_mch_update
					js.return
				end
			end
			if not js.return_called then
				if (vim_is_input_buf_full).to_boolean then
					js.return
				end
			end
			if not js.return_called then
				if (rest.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if restlen > 4096 - inbufcount then
						l_unconverted := 4096 - inbufcount
					else
						l_unconverted := restlen
					end
					memmove (create {CE_POINTER [ANY]}.make_cast ((inbuf + inbufcount)), create {CE_POINTER [ANY]}.make_cast (rest), l_unconverted.to_natural_32).do_nothing
					if l_unconverted = restlen then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (rest))
						rest.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					else
						Current.restlen := restlen - l_unconverted
						memmove (create {CE_POINTER [ANY]}.make_cast (rest), create {CE_POINTER [ANY]}.make_cast ((rest + l_unconverted)), restlen.to_natural_32).do_nothing
					end
					inbufcount := inbufcount + l_unconverted
				else
					l_unconverted := 0
				end
				l_len := 0
				l_try := 0
				from
				until
					not (not js.loop_left and then (l_try < 100))
				loop
					js.reset
					l_len := read (globals_inst.read_cmd_fd, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (inbuf) + inbufcount)), ((4096 - inbufcount) // globals_inst.input_conv.vc_factor).to_natural_32)
					if l_len > 0 then
						js.break
					elseif globals_inst.got_int.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						if not did_read_something.to_boolean then
							if not (isatty (globals_inst.read_cmd_fd)).to_boolean then
								if globals_inst.read_cmd_fd = 0 then
									l_m := globals_inst.cur_tmode
									term_inst.settmode (0)
									close (0).do_nothing
									globals_inst.ignored := dup (2)
									term_inst.settmode (l_m)
								end
							end
						end
						if not a_exit_on_error.to_boolean then
							js.return
						end
						if not js.return_called then
							l_try := l_try + 1
						end
					end
				end
				js.reset
			end
			if not js.return_called then
				if l_len <= 0 then
					if not globals_inst.got_int.to_boolean then
						read_error_exit
					end
				end
				if l_len > 0 then
					did_read_something := 1
				end
				if globals_inst.got_int.to_boolean then
					inbuf[0] := (3).to_natural_8
					inbufcount := 1
				else
					if globals_inst.input_conv.vc_type /= 0 then
						inbufcount := inbufcount - l_unconverted
						if (rest.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_tmp___2.ce_gets (rest.address)
						else
							l_tmp___2.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))
						end
						l_len := mbyte_inst.convert_input_safe (inbuf + inbufcount, l_len + l_unconverted, 4096 - inbufcount, l_tmp___2, restlen_address)
					end
					from
					until
						js.loop_left
					loop
						js.reset
						l_tmp___3 := l_len
						l_len := l_len - 1
						if not (l_tmp___3 > 0) then
							js.break
						end
						if not js.loop_jumped then
							if (inbuf[inbufcount]).to_integer_32 = 3 then
								if globals_inst.ctrl_c_interrupts.to_boolean then
									memmove (create {CE_POINTER [ANY]}.make_cast (inbuf), create {CE_POINTER [ANY]}.make_cast ((inbuf + inbufcount)), (l_len + 1).to_natural_32).do_nothing
									inbufcount := 0
									globals_inst.got_int := 1
								end
							end
							inbufcount := inbufcount + 1
						end
					end
					js.reset
				end
			end
		end

	read_error_exit
		do
			if globals_inst.silent_mode.to_boolean then
				main_inst.getout (0)
			end
			strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("Vim: Error reading input, exiting...%N")))).do_nothing
			misc1_inst.preserve_exit
		end

	ui_cursor_shape
		do
			if (gui_inst.gui.in_use).to_boolean then
				gui_inst.gui_update_cursor_later
			else
				term_inst.term_cursor_shape
			end
		end

	check_col (a_col: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_col < 0 then
				Result := 0
				js.return
			end
			if not js.return_called and then (a_col >= globals_inst.screen_Columns) then
				Result := (globals_inst.screen_Columns - 1)
				js.return
			end
			if not js.return_called then
				Result := a_col
			end
		end

	check_row (a_row: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_row < 0 then
				Result := 0
				js.return
			end
			if not js.return_called and then (a_row >= globals_inst.screen_Rows) then
				Result := (globals_inst.screen_Rows - 1)
				js.return
			end
			if not js.return_called then
				Result := a_row
			end
		end

	open_app_context
		do
			if (globals_inst.app_context.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				XtToolkitInitialize
				globals_inst.app_context.ce_gets (XtCreateApplicationContext)
			end
		end

	x11_setup_atoms (a_dpy: CE_POINTER [ANY])
		do
			vim_atom := XInternAtom (a_dpy, ce_string ("_VIM_TEXT"), 0)
			vimenc_atom := XInternAtom (a_dpy, ce_string ("_VIMENC_TEXT"), 0)
			compound_text_atom := XInternAtom (a_dpy, ce_string ("COMPOUND_TEXT"), 0)
			text_atom := XInternAtom (a_dpy, ce_string ("TEXT"), 0)
			targets_atom := XInternAtom (a_dpy, ce_string ("TARGETS"), 0)
			globals_inst.clip_star.sel_atom := (1).to_natural_32
			globals_inst.clip_plus.sel_atom := XInternAtom (a_dpy, ce_string ("CLIPBOARD"), 0)
			timestamp_atom := XInternAtom (a_dpy, ce_string ("TIMESTAMP"), 0)
		end

	clip_x11_timestamp_cb (a_w: CE_POINTER [ANY]; a_n: CE_POINTER [ANY]; a_event: CE_POINTER [SD_XEVENT]; a_cont: CE_POINTER [INTEGER_8])
		local
			l_actual_type: NATURAL_32
			l_format: INTEGER_32
			l_nitems: NATURAL_32
			l_bytes_after: NATURAL_32
			l_prop: CE_POINTER [NATURAL_8]
			l_xproperty: CE_POINTER [SD_XPROPERTYEVENT]
			js: JUMP_STATE
		do
			create l_prop.make
			create l_xproperty.make

			l_prop.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			l_xproperty.ce_gets (create {CE_POINTER [SD_XPROPERTYEVENT]}.make_shared (a_event.c_pointer + {SD_XEVENT}.xproperty_offset))
			if a_event.item.type /= 28 then
				js.return
			elseif (l_xproperty.item.state).to_boolean then
				js.return
			elseif l_xproperty.item.atom /= globals_inst.clip_star.sel_atom then
				if l_xproperty.item.atom /= globals_inst.clip_plus.sel_atom then
					js.return
				end
			end
			if not js.return_called then
				if (XGetWindowProperty (l_xproperty.item.display, l_xproperty.item.window, l_xproperty.item.atom, 0, 0, 0, timestamp_atom, create {CE_POINTER [NATURAL_32]}.make_shared ($l_actual_type), create {CE_POINTER [INTEGER_32]}.make_shared ($l_format), create {CE_POINTER [NATURAL_32]}.make_shared ($l_nitems), create {CE_POINTER [NATURAL_32]}.make_shared ($l_bytes_after), l_prop.address)).to_boolean then
					js.return
				end
			end
			if not js.return_called then
				if ((l_prop).c_pointer /= default_pointer) then
					XFree (create {CE_POINTER [ANY]}.make_cast (l_prop)).do_nothing
				end
				if l_actual_type /= timestamp_atom then
					js.return
				elseif l_format /= 32 then
					js.return
				end
			end
			if not js.return_called then
				XtOwnSelection (a_w, l_xproperty.item.atom, l_xproperty.item.time, clip_x11_convert_selection_cb_address, clip_x11_lose_ownership_cb_address, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
			end
		end

	clip_x11_timestamp_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent clip_x11_timestamp_cb)
		end

	x11_setup_selection (a_w: CE_POINTER [ANY])
		do
			XtAddEventHandler (a_w, ((1).bit_shift_left (22)).to_natural_32, (0).to_integer_8, clip_x11_timestamp_cb_address, create {CE_POINTER [ANY]}.make_shared (default_pointer))
		end

	clip_x11_request_selection_cb (a_w: CE_POINTER [ANY]; a_success___0: CE_POINTER [ANY]; a_sel_atom: CE_POINTER [NATURAL_32]; a_type: CE_POINTER [NATURAL_32]; a_value: CE_POINTER [ANY]; a_length: CE_POINTER [NATURAL_32]; a_format: CE_POINTER [INTEGER_32])
		local
			l_motion_type: INTEGER_32
			l_len: NATURAL_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_text_list: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_cbd: CE_POINTER [PD_VIMCLIPBOARD]
			l_tmpbuf: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_enc: CE_POINTER [NATURAL_8]
			l_conv: PD_VIMCONV_T
			l_convlen: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_text_prop: SD_XTEXTPROPERTY
			l_n_text: INTEGER_32
			l_status: INTEGER_32
			l_tmp___3: CE_POINTER [ANY]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_text_list.make
			create l_cbd.make
			create l_tmpbuf.make
			create l_tmp.make
			create l_enc.make
			create l_conv.make
			create l_tmp___0.make
			create l_text_prop.make
			create l_tmp___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_text_list.ce_gets (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer))
					l_tmpbuf.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					if a_sel_atom.item = globals_inst.clip_plus.sel_atom then
						l_cbd.ce_gets (globals_inst.clip_plus.address)
					else
						l_cbd.ce_gets (globals_inst.clip_star.address)
					end
					if (a_value.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						ops_inst.clip_free_selection (l_cbd);
						(create {CE_POINTER [INTEGER_32]}.make_cast (a_success___0)).item := 0
						js.return
					elseif a_length.item = {NATURAL_32} 0 then
						ops_inst.clip_free_selection (l_cbd);
						(create {CE_POINTER [INTEGER_32]}.make_cast (a_success___0)).item := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						l_motion_type := 0
						l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (a_value))
						l_len := a_length.item
						if a_type.item /= vim_atom then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_tmp.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_motion_type := (l_tmp.item).to_integer_32
						l_len := l_len - 1
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 4 then -- else:
						if a_type.item /= vimenc_atom then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_tmp___0.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_motion_type := (l_tmp___0.item).to_integer_32
						l_len := l_len - 1
						l_enc.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))) + {NATURAL_32} 1).to_integer_32)
						l_len := l_len - (l_p___0.distance (l_enc)).to_natural_32
						l_conv.vc_type := 0
						mbyte_inst.convert_setup (l_conv.address, l_enc, option_inst.p_enc).do_nothing
						if l_conv.vc_type /= 0 then
							l_convlen := l_len.to_integer_32
							l_tmpbuf.ce_gets (mbyte_inst.string_convert (l_conv.address, l_p___0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_convlen)))
							l_len := l_convlen.to_natural_32
							if (l_tmpbuf.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_p___0.ce_gets (l_tmpbuf)
							end
							mbyte_inst.convert_setup (l_conv.address, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 7 then -- else:
						if a_type.item /= compound_text_atom then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 10 then -- else:
						if globals_inst.enc_dbcs = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if a_type.item /= text_atom then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L:
						l_n_text := 0
						l_text_prop.value := create {CE_POINTER [NATURAL_8]}.make_cast (a_value)
						l_text_prop.encoding := a_type.item
						l_text_prop.format := a_format.item
						l_text_prop.nitems := l_len
						if (gui_inst.gui.in_use).to_boolean then
							l_tmp___3.ce_gets ((gui_gtk_x11_inst.gui_mch_get_display))
						else
							l_tmp___3.ce_gets (globals_inst.xterm_dpy)
						end
						l_status := XmbTextPropertyToTextList (l_tmp___3, (l_text_prop.address), l_text_list.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n_text))
						if l_status /= 0 then
							(create {CE_POINTER [INTEGER_32]}.make_cast (a_success___0)).item := 0
							js.return
						elseif l_n_text < 1 then
							(create {CE_POINTER [INTEGER_32]}.make_cast (a_success___0)).item := 0
							js.return
						end
						if not js.return_called then
							l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (l_text_list[0]))
							l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_natural_32
						end
				when 13 then -- if done | if done | if done | if done | if done
						if not js.return_called then
							ops_inst.clip_yank_selection (l_motion_type, l_p___0, l_len.to_integer_32, l_cbd)
							if (l_text_list.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								XFreeStringList (l_text_list)
							end
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tmpbuf))
							XtFree (create {CE_POINTER [INTEGER_8]}.make_cast (a_value));
							(create {CE_POINTER [INTEGER_32]}.make_cast (a_success___0)).item := 1
						end
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	clip_x11_request_selection_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent clip_x11_request_selection_cb)
		end

	clip_x11_request_selection (a_myShell: CE_POINTER [ANY]; a_dpy: CE_POINTER [ANY]; a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		local
			l_event: SD_XEVENT
			l_type: NATURAL_32
			l_i___0: INTEGER_32
			l_start_time: INTEGER_32
			l_timed_out___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_event.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_timed_out___0 := 0
					l_i___0 := 0
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_i___0 < 5)) then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						inspect l_i___0 -- switch 1 head
						when 0 then l_pos := -1 + 3
						when 1 then l_pos := -1 + 4
						when 2 then l_pos := -1 + 5
						when 3 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 3 then -- switch 1, case 0
						l_type := vimenc_atom
						l_pos := -1 + 8 -- switch 1; break
				when 4 then -- switch 1, case 1
						l_type := vim_atom
						l_pos := -1 + 8 -- switch 1; break
				when 5 then -- switch 1, case 2
						l_type := compound_text_atom
						l_pos := -1 + 8 -- switch 1; break
				when 6 then -- switch 1, case 3
						l_type := text_atom
						l_pos := -1 + 8 -- switch 1; break
				when 7 then -- switch 1, default:
						l_type := (31).to_natural_32
				when 8 then -- switch 1, done:
						Current.success := 2
						XtGetSelectionValue (a_myShell, a_cbd.item.sel_atom, l_type, clip_x11_request_selection_cb_address, create {CE_POINTER [ANY]}.make_cast ((success_address)), (0).to_natural_32)
						XFlush (a_dpy).do_nothing
						l_start_time := time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
						from
						until
							not (not js.loop_left and then (success = 2))
						loop
							js.reset
							if (XCheckTypedEvent (a_dpy, 31, l_event.address)).to_boolean then
								XtDispatchEvent (l_event.address).do_nothing
								js.continue
							elseif (XCheckTypedEvent (a_dpy, 30, l_event.address)).to_boolean then
								XtDispatchEvent (l_event.address).do_nothing
								js.continue
							elseif (XCheckTypedEvent (a_dpy, 28, l_event.address)).to_boolean then
								XtDispatchEvent (l_event.address).do_nothing
								js.continue
							end
							if not js.loop_jumped then
								if (time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))) > l_start_time + 2 then
									l_timed_out___0 := 1
									js.break
								end
							end
							if not js.loop_jumped then
								XSync (a_dpy, 0).do_nothing
								ui_delay (1, 1)
							end
						end
						js.reset
						if success = 1 then
							js.return
						end
						if not js.return_called then
							if l_timed_out___0.to_boolean then
								js.break
							end
							if not js.loop_jumped then
								l_i___0 := l_i___0 + 1
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
					js.reset
					if not js.return_called then
						yank_cut_buffer0 (a_dpy, a_cbd)
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	clip_x11_convert_selection_cb (a_w: CE_POINTER [ANY]; a_sel_atom: CE_POINTER [NATURAL_32]; a_target: CE_POINTER [NATURAL_32]; a_type: CE_POINTER [NATURAL_32]; a_value: CE_POINTER [CE_POINTER [ANY]]; a_length: CE_POINTER [NATURAL_32]; a_format: CE_POINTER [INTEGER_32]): INTEGER_8
		local
			l_string___0: CE_POINTER [NATURAL_8]
			l_result___2: CE_POINTER [NATURAL_8]
			l_motion_type: INTEGER_32
			l_cbd: CE_POINTER [PD_VIMCLIPBOARD]
			l_i___0: INTEGER_32
			l_array: CE_POINTER [NATURAL_32]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_text_prop: SD_XTEXTPROPERTY
			l_string_nt: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [ANY]
			l_l: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_string___0.make
			create l_result___2.make
			create l_cbd.make
			create l_array.make
			create l_text_prop.make
			create l_string_nt.make
			create l_tmp___10.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_sel_atom.item = globals_inst.clip_plus.sel_atom then
						l_cbd.ce_gets (globals_inst.clip_plus.address)
					else
						l_cbd.ce_gets (globals_inst.clip_star.address)
					end
					if not (l_cbd.item.owned).to_boolean then
						Result := (0).to_integer_8
						js.return
					end
					if not js.return_called and then (a_target.item = targets_atom) then
						l_array.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((XtMalloc (Natural_32_bytes.to_natural_32 * {NATURAL_32} 6))))
						if (l_array.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							Result := (0).to_integer_8
							js.return
						end
						if not js.return_called then
							a_value.item := create {CE_POINTER [ANY]}.make_cast (l_array)
							l_i___0 := 0
							l_tmp___0 := l_i___0
							l_i___0 := l_i___0 + 1
							l_array[l_tmp___0] := (31).to_natural_32
							l_tmp___1 := l_i___0
							l_i___0 := l_i___0 + 1
							l_array[l_tmp___1] := targets_atom
							l_tmp___2 := l_i___0
							l_i___0 := l_i___0 + 1
							l_array[l_tmp___2] := vimenc_atom
							l_tmp___3 := l_i___0
							l_i___0 := l_i___0 + 1
							l_array[l_tmp___3] := vim_atom
							l_tmp___4 := l_i___0
							l_i___0 := l_i___0 + 1
							l_array[l_tmp___4] := text_atom
							l_tmp___5 := l_i___0
							l_i___0 := l_i___0 + 1
							l_array[l_tmp___5] := compound_text_atom
							a_type.item := (4).to_natural_32
							a_format.item := 32
							a_length.item := l_i___0.to_natural_32
							Result := (1).to_integer_8
							js.return
						end
					end
					if not js.return_called and then (a_target.item /= {NATURAL_32} 31) then
						if a_target.item /= vimenc_atom then
							if a_target.item /= vim_atom then
								if a_target.item /= text_atom then
									if a_target.item /= compound_text_atom then
										Result := (0).to_integer_8
										js.return
									end
								end
							end
						end
					end
					if not js.return_called then
						ops_inst.clip_get_selection (l_cbd)
						l_motion_type := ops_inst.clip_convert_selection (l_string___0.address, a_length, l_cbd)
						if l_motion_type < 0 then
							Result := (0).to_integer_8
							js.return
						end
					end
					if not js.return_called then
						if a_target.item = vim_atom then
							a_length.item := (a_length.item) + 1
						end
						if a_target.item = vimenc_atom then
							a_length.item := a_length.item + ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_enc))) + {NATURAL_32} 2).to_natural_32
						end
						a_value.item := create {CE_POINTER [ANY]}.make_cast ((XtMalloc ((a_length.item).to_natural_32)))
						l_result___2.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (a_value.item))
						if (l_result___2.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_string___0))
							Result := (0).to_integer_8
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if a_target.item /= {NATURAL_32} 31 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						memmove (create {CE_POINTER [ANY]}.make_cast (l_result___2), create {CE_POINTER [ANY]}.make_cast (l_string___0), (a_length.item).to_natural_32).do_nothing
						a_type.item := (31).to_natural_32
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else:
						if a_target.item /= compound_text_atom then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if a_target.item /= text_atom then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L:
						l_string_nt.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((misc2_inst.alloc ((a_length.item).to_natural_32 + {NATURAL_32} 1))))
						memmove (create {CE_POINTER [ANY]}.make_cast (l_string_nt), create {CE_POINTER [ANY]}.make_cast (l_string___0), (a_length.item).to_natural_32).do_nothing
						l_string_nt[(a_length.item).to_integer_32] := (('%/0/').code).to_integer_8
						if (gui_inst.gui.in_use).to_boolean then
							l_tmp___10.ce_gets ((gui_gtk_x11_inst.gui_mch_get_display))
						else
							l_tmp___10.ce_gets (globals_inst.xterm_dpy)
						end
						XmbTextListToTextProperty (l_tmp___10, l_string_nt.address, 1, {SC_XICCENCODINGSTYLE}.XCompoundTextStyle, l_text_prop.address).do_nothing
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_string_nt))
						XtFree (create {CE_POINTER [INTEGER_8]}.make_cast (a_value.item))
						a_value.item := create {CE_POINTER [ANY]}.make_cast (l_text_prop.value)
						a_length.item := l_text_prop.nitems
						a_type.item := compound_text_atom
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						if a_target.item = vimenc_atom then
							l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_enc))).to_integer_32
							l_result___2[0] := l_motion_type.to_natural_8
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_result___2 + 1)), create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_enc)).do_nothing
							memmove (create {CE_POINTER [ANY]}.make_cast (((l_result___2 + l_l) + 2)), create {CE_POINTER [ANY]}.make_cast (l_string___0), ((a_length.item - l_l.to_natural_32) - {NATURAL_32} 2).to_natural_32).do_nothing
							a_type.item := vimenc_atom
						else
							l_result___2[0] := l_motion_type.to_natural_8
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_result___2 + 1)), create {CE_POINTER [ANY]}.make_cast (l_string___0), (a_length.item - {NATURAL_32} 1).to_natural_32).do_nothing
							a_type.item := vim_atom
						end
				when 11 then -- if done | if done
						a_format.item := 8
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_string___0))
						Result := (1).to_integer_8
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	clip_x11_convert_selection_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent clip_x11_convert_selection_cb)
		end

	clip_x11_lose_ownership_cb (a_w: CE_POINTER [ANY]; a_sel_atom: CE_POINTER [NATURAL_32])
		do
			if a_sel_atom.item = globals_inst.clip_plus.sel_atom then
				clip_lose_selection (globals_inst.clip_plus.address)
			else
				clip_lose_selection (globals_inst.clip_star.address)
			end
		end

	clip_x11_lose_ownership_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent clip_x11_lose_ownership_cb)
		end

	clip_x11_lose_selection (a_myShell: CE_POINTER [ANY]; a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		do
			XtDisownSelection (a_myShell, a_cbd.item.sel_atom, (0).to_natural_32)
		end

	clip_x11_own_selection (a_myShell: CE_POINTER [ANY]; a_cbd: CE_POINTER [PD_VIMCLIPBOARD]): INTEGER_32
		local
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			l_tmp := XtWindow (a_myShell)
			if not (XChangeProperty ((XtDisplay (a_myShell)), l_tmp, a_cbd.item.sel_atom, timestamp_atom, 32, 2, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0)).to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				XFlush ((XtDisplay (a_myShell))).do_nothing
				Result := 1
			end
		end

	clip_x11_set_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		do
		end

	yank_cut_buffer0 (a_dpy: CE_POINTER [ANY]; a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		local
			l_nbytes: INTEGER_32
			l_buffer: CE_POINTER [NATURAL_8]
			l_done___2: INTEGER_32
			l_conv_buf: CE_POINTER [NATURAL_8]
			l_vc: PD_VIMCONV_T
		do
			create l_buffer.make
			create l_conv_buf.make
			create l_vc.make

			l_nbytes := 0
			l_buffer.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((XFetchBuffer (a_dpy, create {CE_POINTER [INTEGER_32]}.make_shared ($l_nbytes), 0))))
			if l_nbytes > 0 then
				l_done___2 := 0
				if globals_inst.has_mbyte.to_boolean then
					l_vc.vc_type := 0
					if (mbyte_inst.convert_setup (l_vc.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("latin1")), option_inst.p_enc)) = 1 then
						l_conv_buf.ce_gets (mbyte_inst.string_convert (l_vc.address, l_buffer, create {CE_POINTER [INTEGER_32]}.make_shared ($l_nbytes)))
						if (l_conv_buf.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							ops_inst.clip_yank_selection (0, l_conv_buf, l_nbytes.to_integer_32, a_cbd)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_conv_buf))
							l_done___2 := 1
						end
						mbyte_inst.convert_setup (l_vc.address, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
					end
				end
				if not l_done___2.to_boolean then
					ops_inst.clip_yank_selection (0, l_buffer, l_nbytes.to_integer_32, a_cbd)
				end
				XFree (create {CE_POINTER [ANY]}.make_cast (l_buffer)).do_nothing
				if option_inst.p_verbose > 0 then
					message_inst.verbose_enter
					message_inst.verb_msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Used CUT_BUFFER0 instead of empty selection"))))).do_nothing
					message_inst.verbose_leave
				end
			end
		end

	jump_to_mouse (a_flags___0: INTEGER_32; a_inclusive: CE_POINTER [INTEGER_32]; a_which_button: INTEGER_32): INTEGER_32
		local
			l_flags___0: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_old_curwin___1: CE_POINTER [PD_WINDOW_S]
			l_old_cursor: PD_POS_T
			l_count___2: INTEGER_32
			l_first___0: INTEGER_32
			l_row: INTEGER_32
			l_col: INTEGER_32
			l_mouse_char: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___6: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_wp___0.make
			create l_old_curwin___1.make
			create l_old_cursor.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_flags___0 := a_flags___0
					l_row := globals_inst.mouse_row
					l_col := globals_inst.mouse_col
					globals_inst.mouse_past_bottom := 0
					globals_inst.mouse_past_eol := 0
					if ((l_flags___0).bit_and (32)).to_boolean then
						if (dragwin.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if not did_drag.to_boolean then
								l_flags___0 := (l_flags___0).bit_and ((-6))
							end
						end
						dragwin.ce_gets (create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
						did_drag := 0
					end
					if not (((l_flags___0).bit_and (4)).to_boolean) then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						if prev_row___0 /= globals_inst.mouse_row then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if prev_col___0 /= globals_inst.mouse_col then
							l_pos := -1 + 4 -- skip if block
						end
				when 3 then -- if: | retnomove:
						if on_status_line.to_boolean then
							Result := 2
							js.return
						end
						if not js.return_called and then (on_sep_line.to_boolean) then
							Result := 4
							js.return
						end
						if not js.return_called then
							if ((l_flags___0).bit_and (16)).to_boolean then
								normal_inst.end_visual_mode
								screen_inst.redraw_curbuf_later (20)
							end
							if globals_inst.cmdwin_type /= 0 then
								if l_row < globals_inst.curwin.item.w_winrow then
									Result := 8
									js.return
								end
							end
						end
						if not js.return_called then
							Result := 1
							js.return
						end
				when 4 then -- if done | if done | if done
						if js.return_called then
							l_pos := -1 + 16 -- skip if block
						end
				when 5 then -- if:
							prev_row___0 := globals_inst.mouse_row
							prev_col___0 := globals_inst.mouse_col
							if ((l_flags___0).bit_and (8)).to_boolean then
								l_pos := -1 + 3 -- goto retnomove
							end
				when 6 then
							if l_row >= 0 then
								if l_row.to_integer_32 < globals_inst.Rows then
									if l_col >= 0 then
										if l_col.to_integer_32 <= globals_inst.Columns then
											if (globals_inst.ScreenLines.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
												l_mouse_char := (globals_inst.ScreenLines[(globals_inst.LineOffset[l_row] + l_col.to_natural_32).to_integer_32]).to_integer_32
											else
												l_mouse_char := (' ').code
											end
										else
											l_mouse_char := (' ').code
										end
									else
										l_mouse_char := (' ').code
									end
								else
									l_mouse_char := (' ').code
								end
							else
								l_mouse_char := (' ').code
							end
							l_old_curwin___1.ce_gets (globals_inst.curwin)
							l_old_cursor.ce_gets (globals_inst.curwin.item.w_cursor)
							if ((l_flags___0).bit_and (1)).to_boolean then
								l_pos := -1 + 9 -- skip if block
							end
				when 7 then -- if:
							if l_row < 0 then
								Result := 0
								js.return
							elseif l_col < 0 then
								Result := 0
								js.return
							end
							if not js.return_called then
								l_wp___0.ce_gets (mouse_find_win (create {CE_POINTER [INTEGER_32]}.make_shared ($l_row), create {CE_POINTER [INTEGER_32]}.make_shared ($l_col)))
								dragwin.ce_gets (create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
								if l_row >= l_wp___0.item.w_height then
									on_status_line := (l_row - l_wp___0.item.w_height) + 1
									dragwin.ce_gets (l_wp___0)
								else
									on_status_line := 0
								end
								if l_col >= l_wp___0.item.w_width then
									on_sep_line := (l_col - l_wp___0.item.w_width) + 1
									dragwin.ce_gets (l_wp___0)
								else
									on_sep_line := 0
								end
								if on_status_line.to_boolean then
									if on_sep_line.to_boolean then
										if (screen_inst.stl_connected (l_wp___0)).to_boolean then
											on_sep_line := 0
										else
											on_status_line := 0
										end
									end
								end
								if globals_inst.VIsual_active.to_boolean then
									if ((l_wp___0.item.w_buffer).c_pointer.to_integer_32).to_natural_32 /= ((globals_inst.curwin.item.w_buffer).c_pointer.to_integer_32).to_natural_32 then
										normal_inst.end_visual_mode
										screen_inst.redraw_curbuf_later (20)
									elseif not on_status_line.to_boolean then
										if not on_sep_line.to_boolean then
											if globals_inst.cmdwin_type = 0 then
												if (l_wp___0.c_pointer.to_integer_32).to_natural_32 = (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 then
													l_tmp___0 := 0
												else
													l_tmp___0 := 1
												end
											else
												l_tmp___0 := 1
											end
											if l_col.to_integer_32 >= l_wp___0.item.w_onebuf_opt.wo_fdc + l_tmp___0.to_integer_32 then
												if ((l_flags___0).bit_and (16)).to_boolean then
													normal_inst.end_visual_mode
													screen_inst.redraw_curbuf_later (20)
												end
											end
										end
									end
								end
								if globals_inst.cmdwin_type /= 0 then
									if (l_wp___0.c_pointer.to_integer_32).to_natural_32 /= (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 then
										on_sep_line := 0
										if on_status_line.to_boolean then
											Result := 2
											js.return
										end
										if not js.return_called then
											Result := 8
											js.return
										end
									end
								end
							end
							if not js.return_called then
								if (dragwin.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									window_inst.win_enter (l_wp___0, 1)
								elseif ((l_flags___0).bit_and (32)).to_boolean then
									window_inst.win_enter (l_wp___0, 1)
								end
								if (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 /= (l_old_curwin___1.c_pointer.to_integer_32).to_natural_32 then
									term_inst.set_mouse_topline (globals_inst.curwin)
								end
								if on_status_line.to_boolean then
									if (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 = (l_old_curwin___1.c_pointer.to_integer_32).to_natural_32 then
										Result := 2
										js.return
									else
										Result := 258
										js.return
									end
								end
							end
							if not js.return_called and then (on_sep_line.to_boolean) then
								if (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 = (l_old_curwin___1.c_pointer.to_integer_32).to_natural_32 then
									Result := 4
									js.return
								else
									Result := 260
									js.return
								end
							end
							if not js.return_called then
								globals_inst.curwin.item.w_cursor.lnum := globals_inst.curwin.item.w_topline
								globals_inst.gui_prev_topline := globals_inst.curwin.item.w_topline
								globals_inst.gui_prev_topfill := globals_inst.curwin.item.w_topfill
							end
				when 8 then -- if block done, skip else block:
							l_pos := -1 + 16
				when 9 then -- else:
							if not (on_status_line.to_boolean) then
								l_pos := -1 + 12 -- skip if block
							end
				when 10 then -- if:
							if a_which_button = 0 then
								if (dragwin.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_count___2 := (((l_row - dragwin.item.w_winrow) - dragwin.item.w_height) + 1) - on_status_line
									window_inst.win_drag_status_line (dragwin, l_count___2)
									did_drag := (did_drag).bit_or (l_count___2)
								end
								Result := 2
								js.return
							else
								l_pos := -1 + 12 -- goto _L___0
							end
				when 11 then -- if block done, skip else block:
							l_pos := -1 + 16
				when 12 then -- else: | _L___0:
							if not (on_sep_line.to_boolean) then
								l_pos := -1 + 15 -- skip if block
							end
				when 13 then -- if:
							if a_which_button = 0 then
								if (dragwin.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_count___2 := (((l_col - dragwin.item.w_wincol) - dragwin.item.w_width) + 1) - on_sep_line
									window_inst.win_drag_vsep_line (dragwin, l_count___2)
									did_drag := (did_drag).bit_or (l_count___2)
								end
								Result := 4
								js.return
							else
								l_pos := -1 + 15 -- goto _L
							end
				when 14 then -- if block done, skip else block:
							l_pos := -1 + 16
				when 15 then -- else: | _L:
							if ((l_flags___0).bit_and (16)).to_boolean then
								normal_inst.end_visual_mode
								screen_inst.redraw_curbuf_later (20)
							end
							if globals_inst.cmdwin_type /= 0 then
								if l_row < globals_inst.curwin.item.w_winrow then
									Result := 8
									js.return
								end
							end
							if not js.return_called then
								l_row := l_row - (globals_inst.curwin.item.w_winrow)
								l_col := l_col - (globals_inst.curwin.item.w_wincol)
								if l_row < 0 then
									l_count___2 := 0
									l_first___0 := 1
									from
									until
										not (not js.loop_left and then (globals_inst.curwin.item.w_topline > 1))
									loop
										js.reset
										if globals_inst.curwin.item.w_topfill < (diff_inst.diff_check (globals_inst.curwin, globals_inst.curwin.item.w_topline)) then
											l_count___2 := l_count___2 + 1
										else
											l_count___2 := l_count___2 + (misc1_inst.plines (globals_inst.curwin.item.w_topline - 1))
										end
										if not l_first___0.to_boolean then
											if l_count___2 > -l_row then
												js.break
											end
										end
										if not js.loop_jumped then
											l_first___0 := 0
											fold_inst.hasFolding (globals_inst.curwin.item.w_topline, create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_topline_offset), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)).do_nothing
											if globals_inst.curwin.item.w_topfill < (diff_inst.diff_check (globals_inst.curwin, globals_inst.curwin.item.w_topline)) then
												globals_inst.curwin.item.w_topfill := (globals_inst.curwin.item.w_topfill) + 1
											else
												globals_inst.curwin.item.w_topline := (globals_inst.curwin.item.w_topline) - 1
												globals_inst.curwin.item.w_topfill := 0
											end
										end
									end
									js.reset
									move_inst.check_topfill (globals_inst.curwin, 0)
									globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-114))
									screen_inst.redraw_later (10)
									l_row := 0
								elseif l_row >= globals_inst.curwin.item.w_height then
									l_count___2 := 0
									l_first___0 := 1
									from
									until
										not (not js.loop_left and then (globals_inst.curwin.item.w_topline < globals_inst.curbuf.item.b_ml.ml_line_count))
									loop
										js.reset
										if globals_inst.curwin.item.w_topfill > 0 then
											l_count___2 := l_count___2 + 1
										else
											l_count___2 := l_count___2 + (misc1_inst.plines (globals_inst.curwin.item.w_topline))
										end
										if not l_first___0.to_boolean then
											if l_count___2 > (l_row - globals_inst.curwin.item.w_height) + 1 then
												js.break
											end
										end
										if not js.loop_jumped then
											l_first___0 := 0
											if (fold_inst.hasFolding (globals_inst.curwin.item.w_topline, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_topline_offset))).to_boolean then
												if globals_inst.curwin.item.w_topline = globals_inst.curbuf.item.b_ml.ml_line_count then
													js.break
												end
											end
										end
										if not js.loop_jumped then
											if globals_inst.curwin.item.w_topfill > 0 then
												globals_inst.curwin.item.w_topfill := (globals_inst.curwin.item.w_topfill) - 1
											else
												globals_inst.curwin.item.w_topline := (globals_inst.curwin.item.w_topline) + 1
												globals_inst.curwin.item.w_topfill := diff_inst.diff_check_fill (globals_inst.curwin, globals_inst.curwin.item.w_topline)
											end
										end
									end
									js.reset
									move_inst.check_topfill (globals_inst.curwin, 0)
									screen_inst.redraw_later (10)
									globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-114))
									l_row := globals_inst.curwin.item.w_height - 1
								elseif l_row = 0 then
									if globals_inst.mouse_dragging > 0 then
										if globals_inst.curwin.item.w_cursor.lnum = (globals_inst.curwin.item.w_buffer).item.b_ml.ml_line_count then
											if globals_inst.curwin.item.w_cursor.lnum = globals_inst.curwin.item.w_topline then
												globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-129))
											end
										end
									end
								end
							end
				when 16 then -- if done | if done | if done
							if not js.return_called then
								if globals_inst.cmdwin_type = 0 then
									l_tmp___6 := 0
								else
									l_tmp___6 := 1
								end
								if l_col.to_integer_32 >= globals_inst.curwin.item.w_onebuf_opt.wo_fdc + l_tmp___6.to_integer_32 then
									l_mouse_char := (' ').code
								end
								if (mouse_comp_pos (globals_inst.curwin, create {CE_POINTER [INTEGER_32]}.make_shared ($l_row), create {CE_POINTER [INTEGER_32]}.make_shared ($l_col), create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset + {PD_POS_T}.lnum_offset))).to_boolean then
									globals_inst.mouse_past_bottom := 1
								end
								if ((l_flags___0).bit_and (2)).to_boolean then
									if not globals_inst.VIsual_active.to_boolean then
										normal_inst.check_visual_highlight
										globals_inst.VIsual.ce_gets (l_old_cursor)
										globals_inst.VIsual_active := 1
										globals_inst.VIsual_reselect := 1
										normal_inst.may_start_select (('o').code)
										term_inst.setmouse
										if option_inst.p_smd.to_boolean then
											if globals_inst.msg_silent = 0 then
												globals_inst.redraw_cmdline := 1
											end
										end
									end
								end
								globals_inst.curwin.item.w_curswant := l_col
								globals_inst.curwin.item.w_set_curswant := 0
								if (misc2_inst.coladvance (l_col)) = 0 then
									if (a_inclusive.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										a_inclusive.item := 1
									end
									globals_inst.mouse_past_eol := 1
								elseif (a_inclusive.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									a_inclusive.item := 0
								end
								l_count___2 := 1
								if (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 /= (l_old_curwin___1.c_pointer.to_integer_32).to_natural_32 then
									l_count___2 := (l_count___2).bit_or ((256))
								elseif globals_inst.curwin.item.w_cursor.lnum /= l_old_cursor.lnum then
									l_count___2 := (l_count___2).bit_or ((256))
								elseif globals_inst.curwin.item.w_cursor.col /= l_old_cursor.col then
									l_count___2 := (l_count___2).bit_or ((256))
								end
								if l_mouse_char = 43 then
									l_count___2 := (l_count___2).bit_or ((1024))
								elseif l_mouse_char /= 32 then
									l_count___2 := (l_count___2).bit_or ((512))
								end
								Result := l_count___2
							end
				when 17 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	mouse_comp_pos (a_win: CE_POINTER [PD_WINDOW_S]; a_rowp: CE_POINTER [INTEGER_32]; a_colp: CE_POINTER [INTEGER_32]; a_lnump: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_col: INTEGER_32
			l_row: INTEGER_32
			l_lnum: INTEGER_32
			l_retval: INTEGER_32
			l_off___0: INTEGER_32
			l_count___2: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			l_col := a_colp.item
			l_row := a_rowp.item
			l_retval := 0
			l_lnum := a_win.item.w_topline
			from
			until
				not (not js.loop_left and then (l_row > 0))
			loop
				js.reset
				if (a_win.item.w_onebuf_opt.wo_diff).to_boolean then
					if (fold_inst.hasFoldingWin (a_win, l_lnum, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 1, create {CE_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))).to_boolean then
						l_count___2 := misc1_inst.plines_win (a_win, l_lnum, 1)
					else
						if l_lnum = a_win.item.w_topline then
							l_row := l_row - (a_win.item.w_topfill)
						else
							l_row := l_row - (diff_inst.diff_check_fill (a_win, l_lnum))
						end
						l_count___2 := misc1_inst.plines_win_nofill (a_win, l_lnum, 1)
					end
				else
					l_count___2 := misc1_inst.plines_win (a_win, l_lnum, 1)
				end
				if l_count___2 > l_row then
					js.break
				end
				if not js.loop_jumped then
					fold_inst.hasFoldingWin (a_win, l_lnum, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_lnum), 1, create {CE_POINTER [PD_FOLDINFO]}.make_shared (default_pointer)).do_nothing
					if l_lnum = (a_win.item.w_buffer).item.b_ml.ml_line_count then
						l_retval := 1
						js.break
					end
				end
				if not js.loop_jumped then
					l_row := l_row - l_count___2
					l_lnum := l_lnum + 1
				end
			end
			js.reset
			if not l_retval.to_boolean then
				l_tmp___1 := move_inst.win_col_off (a_win)
				l_off___0 := l_tmp___1 - (move_inst.win_col_off2 (a_win))
				if l_col < l_off___0 then
					l_col := l_off___0
				end
				l_col := l_col + (l_row * (a_win.item.w_width - l_off___0))
				l_col := l_col + (a_win.item.w_skipcol)
			end
			if not (a_win.item.w_onebuf_opt.wo_wrap).to_boolean then
				l_col := l_col + (a_win.item.w_leftcol)
			end
			l_col := l_col - (move_inst.win_col_off (a_win))
			if l_col < 0 then
				netbeans_inst.netbeans_gutter_click (l_lnum)
				l_col := 0
			end
			a_colp.item := l_col
			a_rowp.item := l_row
			a_lnump.item := l_lnum
			Result := l_retval
		end

	mouse_find_win (a_rowp: CE_POINTER [INTEGER_32]; a_colp: CE_POINTER [INTEGER_32]): CE_POINTER [PD_WINDOW_S]
		local
			l_fp: CE_POINTER [PD_FRAME_S]
			js: JUMP_STATE
		do
			create l_fp.make

			l_fp.ce_gets (globals_inst.topframe)
			a_rowp.item := a_rowp.item - (globals_inst.firstwin.item.w_winrow)
			from
			until
				not (not js.loop_left and then ((l_fp.item.fr_layout).to_integer_32 /= 0))
			loop
				if (l_fp.item.fr_layout).to_integer_32 = 1 then
					l_fp.ce_gets (l_fp.item.fr_child)
					from
					until
						not (not js.loop_left and then (((l_fp.item.fr_next).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
					loop
						js.reset
						if a_colp.item < l_fp.item.fr_width then
							js.break
						end
						if not js.loop_jumped then
							a_colp.item := a_colp.item - (l_fp.item.fr_width)
							l_fp.ce_gets (l_fp.item.fr_next)
						end
					end
					js.reset
				else
					l_fp.ce_gets (l_fp.item.fr_child)
					from
					until
						not (not js.loop_left and then (((l_fp.item.fr_next).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
					loop
						js.reset
						if a_rowp.item < l_fp.item.fr_height then
							js.break
						end
						if not js.loop_jumped then
							a_rowp.item := a_rowp.item - (l_fp.item.fr_height)
							l_fp.ce_gets (l_fp.item.fr_next)
						end
					end
					js.reset
				end
			end
			Result := (l_fp.item.fr_win)
		end

	get_fpos_of_mouse (a_mpos: CE_POINTER [PD_POS_T]): INTEGER_32
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_row: INTEGER_32
			l_col: INTEGER_32
			js: JUMP_STATE
		do
			create l_wp___0.make

			l_row := globals_inst.mouse_row
			l_col := globals_inst.mouse_col
			if l_row < 0 then
				Result := 0
				js.return
			elseif l_col < 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_wp___0.ce_gets (mouse_find_win (create {CE_POINTER [INTEGER_32]}.make_shared ($l_row), create {CE_POINTER [INTEGER_32]}.make_shared ($l_col)))
				if l_row >= l_wp___0.item.w_height then
					Result := 2
					js.return
				end
			end
			if not js.return_called and then (l_col >= l_wp___0.item.w_width) then
				Result := 4
				js.return
			end
			if not js.return_called and then ((l_wp___0.c_pointer.to_integer_32).to_natural_32 /= (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32) then
				Result := 0
				js.return
			end
			if not js.return_called then
				if (mouse_comp_pos (globals_inst.curwin, create {CE_POINTER [INTEGER_32]}.make_shared ($l_row), create {CE_POINTER [INTEGER_32]}.make_shared ($l_col), create {CE_POINTER [INTEGER_32]}.make_shared (a_mpos.c_pointer + {PD_POS_T}.lnum_offset))).to_boolean then
					Result := 2
					js.return
				end
			end
			if not js.return_called then
				a_mpos.item.col := vcol2col (l_wp___0, a_mpos.item.lnum, l_col)
				if a_mpos.item.col > 0 then
					a_mpos.item.col := (a_mpos.item.col) - 1
				end
				a_mpos.item.coladd := 0
				Result := 1
			end
		end

	vcol2col (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32; a_vcol: INTEGER_32): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_start___1: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_ptr.make
			create l_start___1.make

			l_count___2 := 0
			l_ptr.ce_gets (memline_inst.ml_get_buf (a_wp___0.item.w_buffer, a_lnum, 0))
			l_start___1.ce_gets (l_ptr)
			from
			until
				js.loop_left
			loop
				js.reset
				if l_count___2 <= a_vcol then
					if (l_ptr.item).to_integer_32 = 0 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_count___2 := l_count___2 + (charset_inst.win_lbr_chartabsize (a_wp___0, l_ptr, l_count___2, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
					if globals_inst.has_mbyte.to_boolean then
						l_tmp___1 := (globals_inst.mb_ptr2len.integer_32_item ([l_ptr]))
					else
						l_tmp___1 := 1
					end
					l_ptr.ce_gets (l_ptr + l_tmp___1)
				end
			end
			js.reset
			Result := (l_ptr.distance (l_start___1))
		end

	ui_focus_change (a_in_focus: INTEGER_32)
		local
			l_need_redraw: INTEGER_32
			l_tmp___0: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_need_redraw := 0
					if a_in_focus.to_boolean then
						if last_time + 2 < (time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))) then
							l_need_redraw := fileio_inst.check_timestamps (gui_inst.gui.in_use)
							last_time := time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
						end
					end
					if a_in_focus.to_boolean then
						l_tmp___0 := 39
					else
						l_tmp___0 := 40
					end
					l_need_redraw := (l_need_redraw).bit_or ((fileio_inst.apply_autocmds (l_tmp___0, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf)))
					if not (l_need_redraw.to_boolean) then
						l_pos := -1 + 28 -- skip if block
					end
				when 1 then -- if:
						globals_inst.need_wait_return := 0
						if not (((globals_inst.State).bit_and (8)).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						ex_getln_inst.redrawcmdline
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 4 then -- else:
						if globals_inst.State /= 513 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						message_inst.repeat_message
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 7 then -- else:
						if globals_inst.State /= 1024 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						message_inst.repeat_message
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 10 then -- else:
						if globals_inst.State /= 768 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						message_inst.repeat_message
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 13 then -- else:
						if globals_inst.State /= 1536 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						message_inst.repeat_message
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 16 then -- else:
						if globals_inst.State /= 2048 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						message_inst.repeat_message
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 19 then -- else:
						if not (globals_inst.exmode_active.to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						message_inst.repeat_message
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 22 then -- else:
						if not (((globals_inst.State).bit_and (1)).to_boolean) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 26 -- goto _L
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 25 then -- else:
						if not (((globals_inst.State).bit_and (16)).to_boolean) then
							l_pos := -1 + 27 -- skip if block
						end
				when 26 then -- if: | _L:
						if globals_inst.must_redraw /= 0 then
							screen_inst.update_screen (0)
						end
						screen_inst.setcursor
				when 27 then -- if done | if done | if done | if done | if done | if done | if done | if done
						term_inst.cursor_on
						term_inst.out_flush
						if (gui_inst.gui.in_use).to_boolean then
							gui_inst.gui_update_cursor (0, 1)
							gui_inst.gui_update_scrollbars (0)
						end
				when 28 then -- if done
					if globals_inst.need_maketitle.to_boolean then
						buffer_inst.maketitle
					end
				when 29 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	im_save_status (a_psave: CE_POINTER [INTEGER_32])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if option_inst.p_imdisable.to_boolean then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if not (globals_inst.KeyTyped.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 2 then -- if:
						if globals_inst.KeyStuffed.to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						if (globals_inst.xic.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if (gui_inst.gui.in_use).to_boolean then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if not ((gui_inst.gui.in_focus).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if globals_inst.vgetc_im_active.to_boolean then
							a_psave.item := 2
						elseif a_psave.item = 2 then
							a_psave.item := 0
						end
				when 9 then -- if done | if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
