class
	P_UNDO

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create e_not_open.make (<<44>>)
		end

feature {ANY} -- attributes

	u_newcount: INTEGER_32 assign set_u_newcount

	set_u_newcount (a_u_newcount: INTEGER_32)
		do
			u_newcount := a_u_newcount
		end

	u_oldcount: INTEGER_32 assign set_u_oldcount

	set_u_oldcount (a_u_oldcount: INTEGER_32)
		do
			u_oldcount := a_u_oldcount
		end

	undo_undoes: INTEGER_32 assign set_undo_undoes

	set_undo_undoes (a_undo_undoes: INTEGER_32)
		do
			undo_undoes := a_undo_undoes
		end

	lastmark: INTEGER_32 assign set_lastmark

	set_lastmark (a_lastmark: INTEGER_32)
		do
			lastmark := a_lastmark
		end

	e_not_open: CE_ARRAY [NATURAL_8]

feature {ANY} -- routines

	u_save_cursor: INTEGER_32
		do
			Result := (u_save (globals_inst.curwin.item.w_cursor.lnum - 1, globals_inst.curwin.item.w_cursor.lnum + 1))
		end

	u_save (a_top: INTEGER_32; a_bot: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if globals_inst.undo_off.to_boolean then
				Result := 1
				js.return
			end
			if not js.return_called then
				if a_top > globals_inst.curbuf.item.b_ml.ml_line_count then
					Result := 0
					js.return
				elseif a_top >= a_bot then
					Result := 0
					js.return
				elseif a_bot > globals_inst.curbuf.item.b_ml.ml_line_count + 1 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if a_top + 2 = a_bot then
					u_saveline (a_top + 1)
				end
				Result := (u_savecommon (a_top, a_bot, (0).to_integer_32, 0))
			end
		end

	u_savesub (a_lnum: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if globals_inst.undo_off.to_boolean then
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := (u_savecommon (a_lnum - 1, a_lnum + 1, a_lnum + 1, 0))
			end
		end

	u_inssub (a_lnum: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if globals_inst.undo_off.to_boolean then
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := (u_savecommon (a_lnum - 1, a_lnum, a_lnum + 1, 0))
			end
		end

	u_savedel (a_lnum: INTEGER_32; a_nlines: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			if globals_inst.undo_off.to_boolean then
				Result := 1
				js.return
			end
			if not js.return_called then
				if a_nlines = globals_inst.curbuf.item.b_ml.ml_line_count then
					l_tmp := (2).to_integer_32
				else
					l_tmp := a_lnum
				end
				Result := (u_savecommon (a_lnum - 1, a_lnum + a_nlines, l_tmp, 0))
			end
		end

	undo_allowed: INTEGER_32
		local
			js: JUMP_STATE
		do
			if not (globals_inst.curbuf.item.b_p_ma).to_boolean then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_modifiable))))).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called and then (globals_inst.sandbox /= 0) then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_sandbox))))).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called and then (globals_inst.textlock /= 0) then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_secure))))).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 1
			end
		end

	u_savecommon (a_top: INTEGER_32; a_bot: INTEGER_32; a_newbot: INTEGER_32; a_reload: INTEGER_32): INTEGER_32
		local
			l_lnum: INTEGER_32
			l_i___0: INTEGER_32
			l_uhp: CE_POINTER [PD_U_HEADER]
			l_old_curhead: CE_POINTER [PD_U_HEADER]
			l_uep: CE_POINTER [PD_U_ENTRY]
			l_prev_uep: CE_POINTER [PD_U_ENTRY]
			l_size: INTEGER_32
			l_uhfree: CE_POINTER [PD_U_HEADER]
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___13: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_tmp___15: CE_POINTER [NATURAL_8]
			l_tmp___16: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_uhp.make
			create l_old_curhead.make
			create l_uep.make
			create l_prev_uep.make
			create l_uhfree.make
			create l_tmp___13.make
			create l_tmp___15.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not a_reload.to_boolean then
						if not (undo_allowed).to_boolean then
							Result := 0
							js.return
						end
						if not js.return_called then
							if (netbeans_inst.netbeans_active).to_boolean then
								if (netbeans_inst.netbeans_is_guarded (a_top, a_bot)).to_boolean then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_guarded))))).do_nothing
									Result := 0
									js.return
								end
								if not js.return_called and then ((globals_inst.curbuf.item.b_p_ro).to_boolean) then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_nbreadonly))))).do_nothing
									Result := 0
									js.return
								end
							end
						end
						if not js.return_called then
							misc1_inst.change_warning (0)
							if a_bot > globals_inst.curbuf.item.b_ml.ml_line_count + 1 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E834: Line count changed unexpectedly"))))).do_nothing
								Result := 0
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_size := (a_bot - a_top) - 1
						if not ((globals_inst.curbuf.item.b_u_synced).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 2 then -- if:
						globals_inst.curbuf.item.b_new_change := 1
						if option_inst.p_ul >= 0 then
							l_uhp.ce_gets (create {CE_POINTER [PD_U_HEADER]}.make_cast ((misc2_inst.lalloc (({PD_U_HEADER}.sizeof.to_natural_32).to_natural_32, 0))))
							if (l_uhp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_pos := -1 + 19 -- goto nomem
							end
						else
							l_uhp.ce_gets (create {CE_POINTER [PD_U_HEADER]}.make_shared (default_pointer))
						end
				when 3 then
						l_old_curhead.ce_gets (globals_inst.curbuf.item.b_u_curhead)
						if (l_old_curhead.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							globals_inst.curbuf.item.b_u_newhead := l_old_curhead.item.uh_next.ptr
							globals_inst.curbuf.item.b_u_curhead := create {CE_POINTER [PD_U_HEADER]}.make_shared (default_pointer)
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if (globals_inst.curbuf.item.b_u_numhead).to_integer_32 > option_inst.p_ul then
								if ((globals_inst.curbuf.item.b_u_oldhead).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_uhfree.ce_gets (globals_inst.curbuf.item.b_u_oldhead)
								if (l_uhfree.c_pointer.to_integer_32).to_natural_32 = (l_old_curhead.c_pointer.to_integer_32).to_natural_32 then
									u_freebranch (globals_inst.curbuf, l_uhfree, l_old_curhead.address)
								elseif ((l_uhfree.item.uh_alt_next.ptr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									u_freeheader (globals_inst.curbuf, l_uhfree, l_old_curhead.address)
								else
									from
									until
										((l_uhfree.item.uh_alt_next.ptr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
									loop
										l_uhfree.ce_gets (l_uhfree.item.uh_alt_next.ptr)
									end
									u_freebranch (globals_inst.curbuf, l_uhfree, l_old_curhead.address)
								end
							end
						end
						js.reset
						if (l_uhp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if (l_old_curhead.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								u_freebranch (globals_inst.curbuf, l_old_curhead, create {CE_POINTER [CE_POINTER [PD_U_HEADER]]}.make_shared (default_pointer))
							end
							globals_inst.curbuf.item.b_u_synced := 0
							Result := 1
							js.return
						end
						if not js.return_called then
							l_uhp.item.uh_prev.ptr := create {CE_POINTER [PD_U_HEADER]}.make_shared (default_pointer)
							l_uhp.item.uh_next.ptr := globals_inst.curbuf.item.b_u_newhead
							l_uhp.item.uh_alt_next.ptr := l_old_curhead
							if (l_old_curhead.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_uhp.item.uh_alt_prev.ptr := l_old_curhead.item.uh_alt_prev.ptr
								if ((l_uhp.item.uh_alt_prev.ptr).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									(l_uhp.item.uh_alt_prev.ptr).item.uh_alt_next.ptr := l_uhp
								end
								l_old_curhead.item.uh_alt_prev.ptr := l_uhp
								if ((globals_inst.curbuf.item.b_u_oldhead).c_pointer.to_integer_32).to_natural_32 = (l_old_curhead.c_pointer.to_integer_32).to_natural_32 then
									globals_inst.curbuf.item.b_u_oldhead := l_uhp
								end
							else
								l_uhp.item.uh_alt_prev.ptr := create {CE_POINTER [PD_U_HEADER]}.make_shared (default_pointer)
							end
							if ((globals_inst.curbuf.item.b_u_newhead).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								(globals_inst.curbuf.item.b_u_newhead).item.uh_prev.ptr := l_uhp
							end
							globals_inst.curbuf.item.b_u_seq_last := (globals_inst.curbuf.item.b_u_seq_last) + 1
							l_uhp.item.uh_seq := globals_inst.curbuf.item.b_u_seq_last
							globals_inst.curbuf.item.b_u_seq_cur := l_uhp.item.uh_seq
							l_uhp.item.uh_time := time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
							l_uhp.item.uh_save_nr := 0
							globals_inst.curbuf.item.b_u_time_cur := l_uhp.item.uh_time + 1
							l_uhp.item.uh_walk := 0
							l_uhp.item.uh_entry := create {CE_POINTER [PD_U_ENTRY]}.make_shared (default_pointer)
							l_uhp.item.uh_getbot_entry := create {CE_POINTER [PD_U_ENTRY]}.make_shared (default_pointer)
							l_uhp.item.uh_cursor := globals_inst.curwin.item.w_cursor
							if (misc2_inst.virtual_active).to_boolean then
								if globals_inst.curwin.item.w_cursor.coladd > 0 then
									l_uhp.item.uh_cursor_vcol := (misc2_inst.getviscol).to_integer_32
								else
									l_uhp.item.uh_cursor_vcol := -1
								end
							else
								l_uhp.item.uh_cursor_vcol := -1
							end
							if (globals_inst.curbuf.item.b_changed).to_boolean then
								l_tmp___8 := 1
							else
								l_tmp___8 := 0
							end
							if ((globals_inst.curbuf.item.b_ml.ml_flags).bit_and (1)).to_boolean then
								l_tmp___9 := 2
							else
								l_tmp___9 := 0
							end
							l_uhp.item.uh_flags := l_tmp___8 + l_tmp___9
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_uhp.item.uh_namedm)), create {CE_POINTER [ANY]}.make_cast ((globals_inst.curbuf.item.b_namedm)), {PD_POS_T}.sizeof.to_natural_32 * {NATURAL_32} 26).do_nothing
							l_uhp.item.uh_visual := globals_inst.curbuf.item.b_visual
							globals_inst.curbuf.item.b_u_newhead := l_uhp
							if ((globals_inst.curbuf.item.b_u_oldhead).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								globals_inst.curbuf.item.b_u_oldhead := l_uhp
							end
							globals_inst.curbuf.item.b_u_numhead := (globals_inst.curbuf.item.b_u_numhead) + 1
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else:
						if option_inst.p_ul < 0 then
							Result := 1
							js.return
						end
						if not js.return_called and then (l_size = 1) then
							l_uep.ce_gets (u_get_headentry)
							l_prev_uep.ce_gets (create {CE_POINTER [PD_U_ENTRY]}.make_shared (default_pointer))
							l_i___0 := 0
							from
							until
								not (not js.loop_left and then (l_i___0 < 10))
							loop
								js.reset
								if (l_uep.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									js.break
								end
								if not js.loop_jumped then
									if (((globals_inst.curbuf.item.b_u_newhead).item.uh_getbot_entry).c_pointer.to_integer_32).to_natural_32 /= (l_uep.c_pointer.to_integer_32).to_natural_32 then
										if l_uep.item.ue_bot = 0 then
											l_tmp___10 := globals_inst.curbuf.item.b_ml.ml_line_count + 1
										else
											l_tmp___10 := l_uep.item.ue_bot
										end
										l_tmp___11 := ((l_uep.item.ue_top + l_uep.item.ue_size) + 1 /= l_tmp___10).to_integer
									else
										l_tmp___11 := (l_uep.item.ue_lcount /= globals_inst.curbuf.item.b_ml.ml_line_count).to_integer
									end
									if l_tmp___11.to_boolean then
										js.break
									elseif l_uep.item.ue_size > 1 then
										if a_top >= l_uep.item.ue_top then
											if a_top + 2 <= (l_uep.item.ue_top + l_uep.item.ue_size) + 1 then
												js.break
											end
										end
									end
								end
								if not js.loop_jumped then
									if l_uep.item.ue_size = 1 then
										if l_uep.item.ue_top = a_top then
											if l_i___0 > 0 then
												u_getbot
												globals_inst.curbuf.item.b_u_synced := 0
												l_prev_uep.item.ue_next := l_uep.item.ue_next
												l_uep.item.ue_next := (globals_inst.curbuf.item.b_u_newhead).item.uh_entry;
												(globals_inst.curbuf.item.b_u_newhead).item.uh_entry := l_uep
											end
											if a_newbot /= 0 then
												l_uep.item.ue_bot := a_newbot
											elseif a_bot > globals_inst.curbuf.item.b_ml.ml_line_count then
												l_uep.item.ue_bot := (0).to_integer_32
											else
												l_uep.item.ue_lcount := globals_inst.curbuf.item.b_ml.ml_line_count;
												(globals_inst.curbuf.item.b_u_newhead).item.uh_getbot_entry := l_uep
											end
											Result := 1
											js.return
										end
									end
									if not js.return_called then
										l_prev_uep.ce_gets (l_uep)
										l_uep.ce_gets (l_uep.item.ue_next)
										l_i___0 := l_i___0 + 1
									end
								end
							end
							js.reset
						end
						if not js.return_called then
							u_getbot
						end
				when 6 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 18 -- skip if block
						end
				when 7 then -- if:
							l_uep.ce_gets (create {CE_POINTER [PD_U_ENTRY]}.make_cast ((misc2_inst.lalloc (({PD_U_ENTRY}.sizeof.to_natural_32).to_natural_32, 0))))
							if (l_uep.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_pos := -1 + 19 -- goto nomem
							end
				when 8 then
							memset (create {CE_POINTER [ANY]}.make_cast (l_uep), 0, {PD_U_ENTRY}.sizeof.to_natural_32).do_nothing
							l_uep.item.ue_size := l_size
							l_uep.item.ue_top := a_top
							if a_newbot /= 0 then
								l_uep.item.ue_bot := a_newbot
							elseif a_bot > globals_inst.curbuf.item.b_ml.ml_line_count then
								l_uep.item.ue_bot := (0).to_integer_32
							else
								l_uep.item.ue_lcount := globals_inst.curbuf.item.b_ml.ml_line_count;
								(globals_inst.curbuf.item.b_u_newhead).item.uh_getbot_entry := l_uep
							end
							if not (l_size > 0) then
								l_pos := -1 + 17 -- skip if block
							end
				when 9 then -- if:
							l_tmp___13.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((misc2_inst.lalloc ((Pointer_bytes.to_natural_32).to_natural_32 * l_size.to_natural_32, 0))))
							l_uep.item.ue_array := l_tmp___13
							if (l_tmp___13.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								u_freeentry (l_uep, 0)
								l_pos := -1 + 19 -- goto nomem
							end
				when 10 then
							l_i___0 := 0
							l_lnum := a_top + 1
				when 11 then -- loop condition:
							if not (not js.loop_left and then (l_i___0 < l_size)) then
								l_pos := -1 + 16 -- skip loop
							end
				when 12 then -- loop body:
							misc1_inst.fast_breakcheck
							if globals_inst.got_int.to_boolean then
								u_freeentry (l_uep, l_i___0)
								Result := 0
								js.return
							end
							if js.return_called then
								l_pos := -1 + 15 -- skip if block
							end
				when 13 then -- if:
							l_tmp___16 := l_lnum
							l_lnum := l_lnum + 1
							l_tmp___15.ce_gets (u_save_line (l_tmp___16))
							l_uep.item.ue_array[l_i___0] := l_tmp___15
							if (l_tmp___15.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								u_freeentry (l_uep, l_i___0)
								l_pos := -1 + 19 -- goto nomem
							end
				when 14 then
							l_i___0 := l_i___0 + 1
				when 15 then -- if done
							l_pos := -1 + 11 -- back to loop condition
				when 16 then -- loop done | if block done, skip else block:
							l_pos := -1 + 18
				when 17 then -- else:
							l_uep.item.ue_array := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
				when 18 then -- if done | if done
							if not js.return_called then
								l_uep.item.ue_next := (globals_inst.curbuf.item.b_u_newhead).item.uh_entry;
								(globals_inst.curbuf.item.b_u_newhead).item.uh_entry := l_uep
								globals_inst.curbuf.item.b_u_synced := 0
								undo_undoes := 0
								Result := 1
								js.return
							end
							if js.return_called then
								l_pos := -1 + 20 -- skip if block
							end
				when 19 then -- if: | nomem:
								globals_inst.msg_silent := 0
								if (misc1_inst.ask_yesno (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("No undo possible; continue anyway")))), 1)) = 121 then
									globals_inst.undo_off := 1
									Result := 1
									js.return
								end
				when 20 then -- if done
							if not js.return_called then
								misc2_inst.do_outofmem_msg ((0).to_natural_32)
								Result := 0
							end
				when 21 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	u_compute_hash (a_hash: CE_POINTER [NATURAL_8])
		local
			l_ctx: PD_CONTEXT_SHA256_T
			l_lnum: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_ctx.make
			create l_p___0.make

			sha256_inst.sha256_start (l_ctx.address)
			l_lnum := (1).to_integer_32
			from
			until
				not (l_lnum < globals_inst.curbuf.item.b_ml.ml_line_count)
			loop
				l_p___0.ce_gets (memline_inst.ml_get (l_lnum))
				sha256_inst.sha256_update (l_ctx.address, l_p___0, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))) + {NATURAL_32} 1)
				l_lnum := l_lnum + 1
			end
			sha256_inst.sha256_finish (l_ctx.address, a_hash)
		end

	u_get_undo_file_name (a_buf_ffname: CE_POINTER [NATURAL_8]; a_reading: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_dirp: CE_POINTER [NATURAL_8]
			l_dir_name: CE_ARRAY [NATURAL_8]
			l_munged_name: CE_POINTER [NATURAL_8]
			l_undo_file_name: CE_POINTER [NATURAL_8]
			l_dir_len: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_st: SD_STAT
			l_ffname: CE_POINTER [NATURAL_8]
			l_fname_buf: CE_ARRAY [NATURAL_8]
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_dirp.make
			create l_dir_name.make (<<1026>>)
			create l_munged_name.make
			create l_undo_file_name.make
			create l_p___0.make
			create l_st.make
			create l_ffname.make
			create l_fname_buf.make (<<4096>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_munged_name.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_undo_file_name.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_ffname.ce_gets (a_buf_ffname)
					if (l_ffname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if (memline_inst.resolve_symlink (l_ffname, l_fname_buf)) = 1 then
							l_ffname.ce_gets (l_fname_buf)
						end
						l_dirp.ce_gets (option_inst.p_udir)
				when 2 then -- loop condition:
						if not (not js.loop_left and then ((l_dirp.item).to_integer_32 /= 0)) then
							l_pos := -1 + 8 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						l_dir_len := misc2_inst.copy_option_part (l_dirp.address, l_dir_name, 1025, ce_string (","))
						if l_dir_len /= 1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (l_dir_name[0]).to_integer_32 = 46 then
							l_undo_file_name.ce_gets (misc2_inst.vim_strnsave (l_ffname, ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ffname))) + {NATURAL_32} 5).to_integer_32))
							if (l_undo_file_name.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.break
							end
							if not js.loop_jumped then
								l_p___0.ce_gets (misc1_inst.gettail (l_undo_file_name))
								memmove (create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 1)), create {CE_POINTER [ANY]}.make_cast (l_p___0), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))) + {NATURAL_32} 1).do_nothing
								l_p___0.item := (('.').code).to_natural_8
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string (".un~")).do_nothing
							end
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						l_dir_name[l_dir_len] := (('%/0/').code).to_natural_8
						if (os_unix_inst.mch_isdir (l_dir_name)).to_boolean then
							if (l_munged_name.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_munged_name.ce_gets (misc2_inst.vim_strsave (l_ffname))
								if (l_munged_name.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
									js.return
								end
								if not js.return_called then
									l_p___0.ce_gets (l_munged_name)
									from
									until
										(l_p___0.item).to_integer_32 = 0
									loop
										if (misc1_inst.vim_ispathsep ((l_p___0.item).to_integer_32)).to_boolean then
											l_p___0.item := (('%%').code).to_natural_8
										end
										if globals_inst.has_mbyte.to_boolean then
											l_tmp___3 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
										else
											l_tmp___3 := 1
										end
										l_p___0.ce_gets (l_p___0 + l_tmp___3)
									end
								end
							end
							if not js.return_called then
								l_undo_file_name.ce_gets (misc1_inst.concat_fnames (l_dir_name, l_munged_name, 1))
							end
						end
				when 7 then
						if not js.loop_jumped and then ((l_undo_file_name.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32) then
							if not a_reading.to_boolean then
								js.break
							elseif (stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_undo_file_name), (l_st.address))) >= 0 then
								js.break
							end
						end
						if not js.loop_jumped then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_undo_file_name))
							l_undo_file_name.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						end
						l_pos := -1 + 2 -- back to loop condition
				when 8 then -- loop done
						js.reset
				when 9 then -- if done
					if not js.return_called then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_munged_name))
						Result := l_undo_file_name
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	corruption_error (a_mesg: CE_POINTER [INTEGER_8]; a_file_name: CE_POINTER [NATURAL_8])
		do
			misc2_inst.emsg3 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E825: Corrupted undo file (%%s): %%s")))), create {CE_POINTER [NATURAL_8]}.make_cast (a_mesg), a_file_name).do_nothing
		end

	u_free_uhp (a_uhp: CE_POINTER [PD_U_HEADER])
		local
			l_nuep: CE_POINTER [PD_U_ENTRY]
			l_uep: CE_POINTER [PD_U_ENTRY]
		do
			create l_nuep.make
			create l_uep.make

			l_uep.ce_gets (a_uhp.item.uh_entry)
			from
			until
				(l_uep.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
			loop
				l_nuep.ce_gets (l_uep.item.ue_next)
				u_freeentry (l_uep, l_uep.item.ue_size)
				l_uep.ce_gets (l_nuep)
			end
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_uhp))
		end

	fwrite_crypt (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_ptr: CE_POINTER [NATURAL_8]; a_len: NATURAL_32; a_fp: CE_POINTER [SD_IO_FILE]): NATURAL_32
		local
			l_copy: CE_POINTER [NATURAL_8]
			l_small_buf: CE_ARRAY [NATURAL_8]
			l_i___0: NATURAL_32
			js: JUMP_STATE
		do
			create l_copy.make
			create l_small_buf.make (<<100>>)

			if ((a_buf___6.item.b_p_key).item).to_integer_32 = 0 then
				Result := (fwrite (create {CE_POINTER [ANY]}.make_cast (a_ptr), a_len, (1).to_natural_32, a_fp))
				js.return
			end
			if not js.return_called then
				if a_len < {NATURAL_32} 100 then
					l_copy.ce_gets (l_small_buf)
				else
					l_copy.ce_gets (misc2_inst.lalloc (a_len.to_natural_32, 0))
					if (l_copy.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := (0).to_natural_32
						js.return
					end
				end
			end
			if not js.return_called then
				misc2_inst.crypt_encode (a_ptr, a_len, l_copy)
				l_i___0 := fwrite (create {CE_POINTER [ANY]}.make_cast (l_copy), a_len, (1).to_natural_32, a_fp)
				if (l_copy.c_pointer.to_integer_32).to_natural_32 /= (l_small_buf.c_pointer.to_integer_32).to_natural_32 then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_copy))
				end
				Result := l_i___0
			end
		end

	read_string_decrypt (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_fd: CE_POINTER [SD_IO_FILE]; a_len: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_ptr: CE_POINTER [NATURAL_8]
		do
			create l_ptr.make

			l_ptr.ce_gets (misc2_inst.read_string (a_fd, a_len))
			if (l_ptr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if ((a_buf___6.item.b_p_key).item).to_integer_32 /= 0 then
					misc2_inst.crypt_decode (l_ptr, a_len.to_integer_32)
				end
			end
			Result := l_ptr
		end

	serialize_header (a_fp: CE_POINTER [SD_IO_FILE]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_hash: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_len: INTEGER_32
			l_header: CE_POINTER [NATURAL_8]
			l_header_len: INTEGER_32
			js: JUMP_STATE
		do
			create l_header.make

			if (fwrite (create {CE_POINTER [ANY]}.make_cast (ce_string ("Vim%/159/UnDo%/229/")), (9).to_natural_32, (1).to_natural_32, a_fp)) /= {NATURAL_32} 1 then
				Result := 0
				js.return
			end
			if not js.return_called then
				if ((a_buf___6.item.b_p_key).item).to_integer_32 /= 0 then
					misc2_inst.put_bytes (a_fp, (32770).to_natural_32, 2).do_nothing
					l_header.ce_gets (fileio_inst.prepare_crypt_write (a_buf___6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_header_len)))
					if (l_header.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_len := (fwrite (create {CE_POINTER [ANY]}.make_cast (l_header), l_header_len.to_natural_32, (1).to_natural_32, a_fp)).to_integer_32
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_header))
						if l_len /= 1 then
							misc2_inst.crypt_pop_state
							Result := 0
							js.return
						end
					end
				else
					misc2_inst.put_bytes (a_fp, (2).to_natural_32, 2).do_nothing
				end
			end
			if not js.return_called then
				if (fwrite (create {CE_POINTER [ANY]}.make_cast (a_hash), (32).to_natural_32, (1).to_natural_32, a_fp)) /= {NATURAL_32} 1 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				misc2_inst.put_bytes (a_fp, (a_buf___6.item.b_ml.ml_line_count).to_natural_32, 4).do_nothing
				if ((a_buf___6.item.b_u_line_ptr).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6.item.b_u_line_ptr))).to_integer_32
				else
					l_len := 0
				end
				misc2_inst.put_bytes (a_fp, l_len.to_natural_32, 4).do_nothing
				if l_len > 0 then
					if (fwrite_crypt (a_buf___6, a_buf___6.item.b_u_line_ptr, l_len.to_natural_32, a_fp)) /= {NATURAL_32} 1 then
						Result := 0
						js.return
					end
				end
			end
			if not js.return_called then
				misc2_inst.put_bytes (a_fp, (a_buf___6.item.b_u_line_lnum).to_natural_32, 4).do_nothing
				misc2_inst.put_bytes (a_fp, (a_buf___6.item.b_u_line_colnr).to_natural_32, 4).do_nothing
				put_header_ptr (a_fp, a_buf___6.item.b_u_oldhead)
				put_header_ptr (a_fp, a_buf___6.item.b_u_newhead)
				put_header_ptr (a_fp, a_buf___6.item.b_u_curhead)
				misc2_inst.put_bytes (a_fp, (a_buf___6.item.b_u_numhead).to_natural_32, 4).do_nothing
				misc2_inst.put_bytes (a_fp, (a_buf___6.item.b_u_seq_last).to_natural_32, 4).do_nothing
				misc2_inst.put_bytes (a_fp, (a_buf___6.item.b_u_seq_cur).to_natural_32, 4).do_nothing
				misc2_inst.put_time (a_fp, a_buf___6.item.b_u_time_cur)
				IO_putc (4, a_fp).do_nothing
				IO_putc (1, a_fp).do_nothing
				misc2_inst.put_bytes (a_fp, (a_buf___6.item.b_u_save_nr_last).to_natural_32, 4).do_nothing
				IO_putc (0, a_fp).do_nothing
				Result := 1
			end
		end

	serialize_uhp (a_fp: CE_POINTER [SD_IO_FILE]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_uhp: CE_POINTER [PD_U_HEADER]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_uep: CE_POINTER [PD_U_ENTRY]
			js: JUMP_STATE
		do
			create l_uep.make

			if (misc2_inst.put_bytes (a_fp, (24528).to_natural_32, 2)) = 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				put_header_ptr (a_fp, a_uhp.item.uh_next.ptr)
				put_header_ptr (a_fp, a_uhp.item.uh_prev.ptr)
				put_header_ptr (a_fp, a_uhp.item.uh_alt_next.ptr)
				put_header_ptr (a_fp, a_uhp.item.uh_alt_prev.ptr)
				misc2_inst.put_bytes (a_fp, (a_uhp.item.uh_seq).to_natural_32, 4).do_nothing
				serialize_pos (a_uhp.item.uh_cursor, a_fp)
				misc2_inst.put_bytes (a_fp, (a_uhp.item.uh_cursor_vcol).to_natural_32, 4).do_nothing
				misc2_inst.put_bytes (a_fp, (a_uhp.item.uh_flags).to_natural_32, 2).do_nothing
				l_i___0 := 0
				from
				until
					not (l_i___0 < 26)
				loop
					serialize_pos (a_uhp.item.uh_namedm[l_i___0], a_fp)
					l_i___0 := l_i___0 + 1
				end
				serialize_visualinfo (create {CE_POINTER [PD_VISUALINFO_T]}.make_shared (a_uhp.c_pointer + {PD_U_HEADER}.uh_visual_offset), a_fp)
				misc2_inst.put_time (a_fp, a_uhp.item.uh_time)
				IO_putc (4, a_fp).do_nothing
				IO_putc (1, a_fp).do_nothing
				misc2_inst.put_bytes (a_fp, (a_uhp.item.uh_save_nr).to_natural_32, 4).do_nothing
				IO_putc (0, a_fp).do_nothing
				l_uep.ce_gets (a_uhp.item.uh_entry)
				from
				until
					not (not js.loop_left and then ((l_uep.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
				loop
					misc2_inst.put_bytes (a_fp, (62744).to_natural_32, 2).do_nothing
					if (serialize_uep (a_fp, a_buf___6, l_uep)) = 0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_uep.ce_gets (l_uep.item.ue_next)
					end
				end
			end
			if not js.return_called then
				misc2_inst.put_bytes (a_fp, (13697).to_natural_32, 2).do_nothing
				Result := 1
			end
		end

	unserialize_uhp (a_fp: CE_POINTER [SD_IO_FILE]; a_file_name: CE_POINTER [NATURAL_8]): CE_POINTER [PD_U_HEADER]
		local
			l_uhp: CE_POINTER [PD_U_HEADER]
			l_i___0: INTEGER_32
			l_uep: CE_POINTER [PD_U_ENTRY]
			l_last_uep: CE_POINTER [PD_U_ENTRY]
			l_c: INTEGER_32
			l_error: INTEGER_32
			l_len: INTEGER_32
			l_what: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_uhp.make
			create l_uep.make
			create l_last_uep.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_uhp.ce_gets (create {CE_POINTER [PD_U_HEADER]}.make_cast ((misc2_inst.lalloc (({PD_U_HEADER}.sizeof.to_natural_32).to_natural_32, 0))))
					if (l_uhp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := (create {CE_POINTER [PD_U_HEADER]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						memset (create {CE_POINTER [ANY]}.make_cast (l_uhp), 0, {PD_U_HEADER}.sizeof.to_natural_32).do_nothing
						l_uhp.item.uh_next.seq := (misc2_inst.get4c (a_fp)).to_integer_32
						l_uhp.item.uh_prev.seq := (misc2_inst.get4c (a_fp)).to_integer_32
						l_uhp.item.uh_alt_next.seq := (misc2_inst.get4c (a_fp)).to_integer_32
						l_uhp.item.uh_alt_prev.seq := (misc2_inst.get4c (a_fp)).to_integer_32
						l_uhp.item.uh_seq := (misc2_inst.get4c (a_fp)).to_integer_32
						if l_uhp.item.uh_seq <= 0 then
							corruption_error (ce_string ("uh_seq"), a_file_name)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_uhp))
							Result := (create {CE_POINTER [PD_U_HEADER]}.make_shared (default_pointer))
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						unserialize_pos (create {CE_POINTER [PD_POS_T]}.make_shared (l_uhp.c_pointer + {PD_U_HEADER}.uh_cursor_offset), a_fp)
						l_uhp.item.uh_cursor_vcol := (misc2_inst.get4c (a_fp)).to_integer_32
						l_uhp.item.uh_flags := misc2_inst.get2c (a_fp)
						l_i___0 := 0
						from
						until
							not (l_i___0 < 26)
						loop
							unserialize_pos (l_uhp.item.uh_namedm + l_i___0, a_fp)
							l_i___0 := l_i___0 + 1
						end
						unserialize_visualinfo (create {CE_POINTER [PD_VISUALINFO_T]}.make_shared (l_uhp.c_pointer + {PD_U_HEADER}.uh_visual_offset), a_fp)
						l_uhp.item.uh_time := misc2_inst.get8ctime (a_fp)
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 8 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						l_len := (IO_getc (a_fp))
						if l_len = 0 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 7 -- skip if block
						end
				when 4 then -- if:
						l_what := IO_getc (a_fp)
						inspect l_what -- switch 1 head
						when 1 then l_pos := -1 + 5
						else l_pos := -1 + 6
						end
				when 5 then -- switch 1, case 1
						l_uhp.item.uh_save_nr := (misc2_inst.get4c (a_fp)).to_integer_32
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, default:
						from
						until
							js.loop_left
						loop
							js.reset
							l_len := l_len - 1
							if not (l_len >= 0) then
								js.break
							end
							if not js.loop_jumped then
								IO_getc (a_fp).do_nothing
							end
						end
						js.reset
				when 7 then -- switch 1, done: | if done
						l_pos := -1 + 2 -- back to loop condition
				when 8 then -- loop done
						js.reset
						l_last_uep.ce_gets (create {CE_POINTER [PD_U_ENTRY]}.make_shared (default_pointer))
						from
						until
							js.loop_left
						loop
							js.reset
							l_c := misc2_inst.get2c (a_fp)
							if l_c /= 62744 then
								js.break
							end
							if not js.loop_jumped then
								l_error := 0
								l_uep.ce_gets (unserialize_uep (a_fp, create {CE_POINTER [INTEGER_32]}.make_shared ($l_error), a_file_name))
								if (l_last_uep.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_uhp.item.uh_entry := l_uep
								else
									l_last_uep.item.ue_next := l_uep
								end
								l_last_uep.ce_gets (l_uep)
								if (l_uep.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									u_free_uhp (l_uhp)
									Result := (create {CE_POINTER [PD_U_HEADER]}.make_shared (default_pointer))
									js.return
								elseif l_error.to_boolean then
									u_free_uhp (l_uhp)
									Result := (create {CE_POINTER [PD_U_HEADER]}.make_shared (default_pointer))
									js.return
								end
							end
						end
						js.reset
				when 9 then -- if done
					if not js.return_called and then (l_c /= 13697) then
						corruption_error (ce_string ("entry end"), a_file_name)
						u_free_uhp (l_uhp)
						Result := (create {CE_POINTER [PD_U_HEADER]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						Result := l_uhp
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	serialize_uep (a_fp: CE_POINTER [SD_IO_FILE]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_uep: CE_POINTER [PD_U_ENTRY]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_len: NATURAL_32
			js: JUMP_STATE
		do
			misc2_inst.put_bytes (a_fp, (a_uep.item.ue_top).to_natural_32, 4).do_nothing
			misc2_inst.put_bytes (a_fp, (a_uep.item.ue_bot).to_natural_32, 4).do_nothing
			misc2_inst.put_bytes (a_fp, (a_uep.item.ue_lcount).to_natural_32, 4).do_nothing
			misc2_inst.put_bytes (a_fp, (a_uep.item.ue_size).to_natural_32, 4).do_nothing
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (l_i___0.to_integer_32 < a_uep.item.ue_size))
			loop
				l_len := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_uep.item.ue_array[l_i___0]))
				if (misc2_inst.put_bytes (a_fp, l_len.to_natural_32, 4)) = 0 then
					Result := 0
					js.return
				end
				if not js.return_called and then (l_len > {NATURAL_32} 0) then
					if (fwrite_crypt (a_buf___6, a_uep.item.ue_array[l_i___0], l_len, a_fp)) /= {NATURAL_32} 1 then
						Result := 0
						js.return
					end
				end
				if not js.return_called then
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	unserialize_uep (a_fp: CE_POINTER [SD_IO_FILE]; a_error: CE_POINTER [INTEGER_32]; a_file_name: CE_POINTER [NATURAL_8]): CE_POINTER [PD_U_ENTRY]
		local
			l_i___0: INTEGER_32
			l_uep: CE_POINTER [PD_U_ENTRY]
			l_array: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_line: CE_POINTER [NATURAL_8]
			l_line_len: INTEGER_32
			js: JUMP_STATE
		do
			create l_uep.make
			create l_array.make
			create l_line.make

			l_uep.ce_gets (create {CE_POINTER [PD_U_ENTRY]}.make_cast ((misc2_inst.lalloc (({PD_U_ENTRY}.sizeof.to_natural_32).to_natural_32, 0))))
			if (l_uep.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (create {CE_POINTER [PD_U_ENTRY]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				memset (create {CE_POINTER [ANY]}.make_cast (l_uep), 0, {PD_U_ENTRY}.sizeof.to_natural_32).do_nothing
				l_uep.item.ue_top := (misc2_inst.get4c (a_fp)).to_integer_32
				l_uep.item.ue_bot := (misc2_inst.get4c (a_fp)).to_integer_32
				l_uep.item.ue_lcount := (misc2_inst.get4c (a_fp)).to_integer_32
				l_uep.item.ue_size := (misc2_inst.get4c (a_fp)).to_integer_32
				if l_uep.item.ue_size > 0 then
					l_array.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((misc2_inst.lalloc ((Pointer_bytes.to_natural_32).to_natural_32 * (l_uep.item.ue_size).to_natural_32, 0))))
					if (l_array.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						a_error.item := 1
						Result := l_uep
						js.return
					end
					if not js.return_called then
						memset (create {CE_POINTER [ANY]}.make_cast (l_array), 0, ((Pointer_bytes.to_natural_32).to_natural_32 * (l_uep.item.ue_size).to_natural_32).to_natural_32).do_nothing
					end
				else
					l_array.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))
				end
			end
			if not js.return_called then
				l_uep.item.ue_array := l_array
				l_i___0 := 0
				from
				until
					not (not js.loop_left and then (l_i___0.to_integer_32 < l_uep.item.ue_size))
				loop
					l_line_len := misc2_inst.get4c (a_fp)
					if l_line_len >= 0 then
						l_line.ce_gets (read_string_decrypt (globals_inst.curbuf, a_fp, l_line_len))
					else
						l_line.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						corruption_error (ce_string ("line length"), a_file_name)
					end
					if (l_line.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						a_error.item := 1
						Result := l_uep
						js.return
					end
					if not js.return_called then
						l_array[l_i___0] := l_line
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not js.return_called then
				Result := l_uep
			end
		end

	serialize_pos (a_pos___3: PD_POS_T; a_fp: CE_POINTER [SD_IO_FILE])
		do
			misc2_inst.put_bytes (a_fp, (a_pos___3.lnum).to_natural_32, 4).do_nothing
			misc2_inst.put_bytes (a_fp, (a_pos___3.col).to_natural_32, 4).do_nothing
			misc2_inst.put_bytes (a_fp, (a_pos___3.coladd).to_natural_32, 4).do_nothing
		end

	unserialize_pos (a_pos___3: CE_POINTER [PD_POS_T]; a_fp: CE_POINTER [SD_IO_FILE])
		do
			a_pos___3.item.lnum := (misc2_inst.get4c (a_fp)).to_integer_32
			if a_pos___3.item.lnum < 0 then
				a_pos___3.item.lnum := (0).to_integer_32
			end
			a_pos___3.item.col := misc2_inst.get4c (a_fp)
			if a_pos___3.item.col < 0 then
				a_pos___3.item.col := 0
			end
			a_pos___3.item.coladd := misc2_inst.get4c (a_fp)
			if a_pos___3.item.coladd < 0 then
				a_pos___3.item.coladd := 0
			end
		end

	serialize_visualinfo (a_info: CE_POINTER [PD_VISUALINFO_T]; a_fp: CE_POINTER [SD_IO_FILE])
		do
			serialize_pos (a_info.item.vi_start, a_fp)
			serialize_pos (a_info.item.vi_end, a_fp)
			misc2_inst.put_bytes (a_fp, (a_info.item.vi_mode).to_natural_32, 4).do_nothing
			misc2_inst.put_bytes (a_fp, (a_info.item.vi_curswant).to_natural_32, 4).do_nothing
		end

	unserialize_visualinfo (a_info: CE_POINTER [PD_VISUALINFO_T]; a_fp: CE_POINTER [SD_IO_FILE])
		do
			unserialize_pos (create {CE_POINTER [PD_POS_T]}.make_shared (a_info.c_pointer + {PD_VISUALINFO_T}.vi_start_offset), a_fp)
			unserialize_pos (create {CE_POINTER [PD_POS_T]}.make_shared (a_info.c_pointer + {PD_VISUALINFO_T}.vi_end_offset), a_fp)
			a_info.item.vi_mode := misc2_inst.get4c (a_fp)
			a_info.item.vi_curswant := misc2_inst.get4c (a_fp)
		end

	put_header_ptr (a_fp: CE_POINTER [SD_IO_FILE]; a_uhp: CE_POINTER [PD_U_HEADER])
		local
			l_tmp: INTEGER_32
		do
			if (a_uhp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_tmp := a_uhp.item.uh_seq
			else
				l_tmp := 0
			end
			misc2_inst.put_bytes (a_fp, l_tmp.to_natural_32, 4).do_nothing
		end

	u_write_undo (a_name___1: CE_POINTER [NATURAL_8]; a_forceit: INTEGER_32; a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_hash: CE_POINTER [NATURAL_8])
		local
			l_uhp: CE_POINTER [PD_U_HEADER]
			l_file_name: CE_POINTER [NATURAL_8]
			l_mark: INTEGER_32
			l_fd: INTEGER_32
			l_fp: CE_POINTER [SD_IO_FILE]
			l_perm: INTEGER_32
			l_write_ok: INTEGER_32
			l_st_old_valid: INTEGER_32
			l_st_old: SD_STAT
			l_st_new: SD_STAT
			l_do_crypt: INTEGER_32
			l_mbuf: CE_ARRAY [NATURAL_8]
			l_len: INTEGER_32
			l_acl: CE_POINTER [ANY]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_uhp.make
			create l_file_name.make
			create l_fp.make
			create l_st_old.make
			create l_st_new.make
			create l_mbuf.make (<<9>>)
			create l_acl.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fp.ce_gets (create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer))
					l_write_ok := 0
					l_st_old_valid := 0
					l_do_crypt := 0
					if (a_name___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_file_name.ce_gets (u_get_undo_file_name (a_buf___6.item.b_ffname, 0))
						if (l_file_name.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if option_inst.p_verbose > 0 then
								message_inst.verbose_enter
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Cannot write undo file in any directory in %'undodir%'"))))]).do_nothing
								message_inst.verbose_leave
							end
							js.return
						end
					else
						l_file_name.ce_gets (a_name___1)
					end
					if js.return_called then
						l_pos := -1 + 46 -- skip if block
					end
				when 1 then -- if:
						l_perm := 384
						if ((a_buf___6.item.b_ffname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6.item.b_ffname), (l_st_old.address))) >= 0 then
								l_perm := (l_st_old.st_mode).to_integer_32
								l_st_old_valid := 1
							end
						end
						l_perm := (l_perm).bit_and ((511))
						if not ((os_unix_inst.mch_getperm (l_file_name)) >= 0) then
							l_pos := -1 + 25 -- skip if block
						end
				when 2 then -- if:
						if (a_name___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L___2
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 5 then -- else:
						if a_forceit.to_boolean then
							l_pos := -1 + 24 -- skip if block
						end
				when 6 then -- if: | _L___2:
						l_fd := open ([create {CE_POINTER [INTEGER_8]}.make_cast (l_file_name), 0, 0])
						if not (l_fd < 0) then
							l_pos := -1 + 14 -- skip if block
						end
				when 7 then -- if:
						if (a_name___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else:
						if not (option_inst.p_verbose > 0) then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L:
						if (a_name___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							message_inst.verbose_enter
						end
						message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Will not overwrite with undo file, cannot read: %%s")))), l_file_name]).do_nothing
						if (a_name___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							message_inst.verbose_leave
						end
				when 12 then -- if done
						l_pos := -1 + 45 -- goto theend
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 14 then -- else:
						l_len := read (l_fd, create {CE_POINTER [ANY]}.make_cast (l_mbuf), (9).to_natural_32)
						close (l_fd).do_nothing
						if not (l_len < 9) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 18 -- goto _L___1
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 17 then -- else:
						if (memcmp (create {CE_POINTER [ANY]}.make_cast (l_mbuf), create {CE_POINTER [ANY]}.make_cast (ce_string ("Vim%/159/UnDo%/229/")), (9).to_natural_32)) = 0 then
							l_pos := -1 + 24 -- skip if block
						end
				when 18 then -- if: | _L___1:
						if (a_name___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 22 -- goto _L___0
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 21 then -- else:
						if not (option_inst.p_verbose > 0) then
							l_pos := -1 + 23 -- skip if block
						end
				when 22 then -- if: | _L___0:
						if (a_name___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							message_inst.verbose_enter
						end
						message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Will not overwrite, this is not an undo file: %%s")))), l_file_name]).do_nothing
						if (a_name___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							message_inst.verbose_leave
						end
				when 23 then -- if done
						l_pos := -1 + 45 -- goto theend
				when 24 then -- if done | if done | if done | if done
						unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_file_name)).do_nothing
				when 25 then -- if done
						if a_buf___6.item.b_u_numhead = 0 then
							if ((a_buf___6.item.b_u_line_ptr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								if option_inst.p_verbose > 0 then
									message_inst.verb_msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Skipping undo file write, nothing to undo"))))).do_nothing
								end
								l_pos := -1 + 45 -- goto theend
							end
						end
				when 26 then
						l_fd := open ([create {CE_POINTER [INTEGER_8]}.make_cast (l_file_name), 131265, l_perm])
						if l_fd < 0 then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (e_not_open)))), l_file_name).do_nothing
							l_pos := -1 + 45 -- goto theend
						end
				when 27 then
						os_unix_inst.mch_setperm (l_file_name, l_perm.to_integer_32).do_nothing
						if option_inst.p_verbose > 0 then
							message_inst.verbose_enter
							message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Writing undo file: %%s")))), l_file_name]).do_nothing
							message_inst.verbose_leave
						end
						if l_st_old_valid.to_boolean then
							if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_file_name), (l_st_new.address))) >= 0 then
								if l_st_new.st_gid /= l_st_old.st_gid then
									if (fchown (l_fd, (-1).to_natural_32, l_st_old.st_gid)) /= 0 then
										os_unix_inst.mch_setperm (l_file_name, ((((l_perm).bit_and (455))).bit_or (((((l_perm).bit_and (7))).bit_shift_left (3)))).to_integer_32).do_nothing
									end
								end
							end
						end
						l_fp.ce_gets (fdopen (l_fd, ce_string ("w")))
						if (l_fp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (e_not_open)))), l_file_name).do_nothing
							close (l_fd).do_nothing
							unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_file_name)).do_nothing
							l_pos := -1 + 45 -- goto theend
						end
				when 28 then
						u_sync (1)
						if (serialize_header (l_fp, a_buf___6, a_hash)) = 0 then
							l_pos := -1 + 44 -- goto write_error
						end
				when 29 then
						if ((a_buf___6.item.b_p_key).item).to_integer_32 /= 0 then
							l_do_crypt := 1
						end
						lastmark := lastmark + 1
						l_mark := lastmark
						l_uhp.ce_gets (a_buf___6.item.b_u_oldhead)
				when 30 then -- loop condition:
						if (l_uhp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 43 -- skip loop
						end
				when 31 then -- loop body:
						if l_uhp.item.uh_walk /= l_mark then
							l_uhp.item.uh_walk := l_mark
							if (serialize_uhp (l_fp, a_buf___6, l_uhp)) = 0 then
								l_pos := -1 + 44 -- goto write_error
							end
						end
				when 32 then
						if ((l_uhp.item.uh_prev.ptr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						if (l_uhp.item.uh_prev.ptr).item.uh_walk /= l_mark then
							l_uhp.ce_gets (l_uhp.item.uh_prev.ptr)
						else
							l_pos := -1 + 35 -- goto _L___6
						end
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 35 then -- else: | _L___6:
						if ((l_uhp.item.uh_alt_next.ptr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if:
						if (l_uhp.item.uh_alt_next.ptr).item.uh_walk /= l_mark then
							l_uhp.ce_gets (l_uhp.item.uh_alt_next.ptr)
						else
							l_pos := -1 + 38 -- goto _L___5
						end
				when 37 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 38 then -- else: | _L___5:
						if ((l_uhp.item.uh_next.ptr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						if ((l_uhp.item.uh_alt_prev.ptr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if (l_uhp.item.uh_next.ptr).item.uh_walk /= l_mark then
								l_uhp.ce_gets (l_uhp.item.uh_next.ptr)
							else
								l_pos := -1 + 41 -- goto _L___4
							end
						else
							l_pos := -1 + 41 -- goto _L___4
						end
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else: | _L___4:
						if ((l_uhp.item.uh_alt_prev.ptr).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_uhp.ce_gets (l_uhp.item.uh_alt_prev.ptr)
						else
							l_uhp.ce_gets (l_uhp.item.uh_next.ptr)
						end
				when 42 then -- if done | if done
						l_pos := -1 + 30 -- back to loop condition
				when 43 then -- loop done
						if (misc2_inst.put_bytes (l_fp, (59306).to_natural_32, 2)) = 1 then
							l_write_ok := 1
						end
				when 44 then -- write_error:
						fclose (l_fp).do_nothing
						if not l_write_ok.to_boolean then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E829: write error in undo file: %%s")))), l_file_name).do_nothing
						end
						if ((a_buf___6.item.b_ffname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_acl.ce_gets (os_unix_inst.mch_get_acl (a_buf___6.item.b_ffname))
							os_unix_inst.mch_set_acl (l_file_name, l_acl)
						end
				when 45 then -- theend:
						if l_do_crypt.to_boolean then
							misc2_inst.crypt_pop_state
						end
						if (l_file_name.c_pointer.to_integer_32).to_natural_32 /= (a_name___1.c_pointer.to_integer_32).to_natural_32 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_file_name))
						end
				when 46 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	u_read_undo (a_name___1: CE_POINTER [NATURAL_8]; a_hash: CE_POINTER [NATURAL_8]; a_orig_name: CE_POINTER [NATURAL_8])
		local
			l_file_name: CE_POINTER [NATURAL_8]
			l_fp: CE_POINTER [SD_IO_FILE]
			l_version: INTEGER_32
			l_str_len: INTEGER_32
			l_line_ptr: CE_POINTER [NATURAL_8]
			l_line_lnum: INTEGER_32
			l_line_colnr: INTEGER_32
			l_line_count: INTEGER_32
			l_num_head: INTEGER_32
			l_old_header_seq: INTEGER_32
			l_new_header_seq: INTEGER_32
			l_cur_header_seq: INTEGER_32
			l_seq_last: INTEGER_32
			l_seq_cur: INTEGER_32
			l_last_save_nr: INTEGER_32
			l_old_idx: INTEGER_16
			l_new_idx: INTEGER_16
			l_cur_idx: INTEGER_16
			l_num_read_uhps: INTEGER_32
			l_seq_time: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_c: INTEGER_32
			l_uhp: CE_POINTER [PD_U_HEADER]
			l_uhp_table: CE_POINTER [CE_POINTER [PD_U_HEADER]]
			l_read_hash: CE_ARRAY [NATURAL_8]
			l_magic_buf: CE_ARRAY [NATURAL_8]
			l_st_orig: SD_STAT
			l_st_undo: SD_STAT
			l_do_decrypt: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_len: INTEGER_32
			l_what: INTEGER_32
			l_tmp___27: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_file_name.make
			create l_fp.make
			create l_line_ptr.make
			create l_uhp.make
			create l_uhp_table.make
			create l_read_hash.make (<<32>>)
			create l_magic_buf.make (<<9>>)
			create l_st_orig.make
			create l_st_undo.make
			create l_tmp___3.make
			create l_tmp___4.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_line_ptr.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_num_head := 0
					l_last_save_nr := 0
					l_old_idx := (-1).to_integer_16
					l_new_idx := (-1).to_integer_16
					l_cur_idx := (-1).to_integer_16
					l_num_read_uhps := 0
					l_uhp_table.ce_gets (create {CE_POINTER [CE_POINTER [PD_U_HEADER]]}.make_shared (default_pointer))
					l_do_decrypt := 0
					if (a_name___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_file_name.ce_gets (u_get_undo_file_name (globals_inst.curbuf.item.b_ffname, 1))
						if (l_file_name.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.return
						end
						if not js.return_called then
							if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (a_orig_name), (l_st_orig.address))) >= 0 then
								if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_file_name), (l_st_undo.address))) >= 0 then
									if l_st_orig.st_uid /= l_st_undo.st_uid then
										if option_inst.p_verbose > 0 then
											message_inst.verbose_enter
											message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Not reading undo file, owner differs: %%s")))), l_file_name]).do_nothing
											message_inst.verbose_leave
										end
										js.return
									end
								end
							end
						end
					else
						l_file_name.ce_gets (a_name___1)
					end
					if js.return_called then
						l_pos := -1 + 50 -- skip if block
					end
				when 1 then -- if:
						if option_inst.p_verbose > 0 then
							message_inst.verbose_enter
							message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Reading undo file: %%s")))), l_file_name]).do_nothing
							message_inst.verbose_leave
						end
						l_fp.ce_gets (fopen (create {CE_POINTER [INTEGER_8]}.make_cast (l_file_name), ce_string ("r")))
						if (l_fp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if (a_name___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_tmp___3.ce_gets (gettext (ce_string ("E822: Cannot open undo file for reading: %%s")))
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___3), l_file_name).do_nothing
							elseif option_inst.p_verbose > 0 then
								l_tmp___3.ce_gets (gettext (ce_string ("E822: Cannot open undo file for reading: %%s")))
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___3), l_file_name).do_nothing
							end
							l_pos := -1 + 48 -- goto error
						end
				when 2 then
						if (fread (create {CE_POINTER [ANY]}.make_cast (l_magic_buf), (9).to_natural_32, (1).to_natural_32, l_fp)) /= {NATURAL_32} 1 then
							l_tmp___4.ce_gets (gettext (ce_string ("E823: Not an undo file: %%s")))
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___4), l_file_name).do_nothing
							l_pos := -1 + 48 -- goto error
						elseif (memcmp (create {CE_POINTER [ANY]}.make_cast (l_magic_buf), create {CE_POINTER [ANY]}.make_cast (ce_string ("Vim%/159/UnDo%/229/")), (9).to_natural_32)) /= 0 then
							l_tmp___4.ce_gets (gettext (ce_string ("E823: Not an undo file: %%s")))
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___4), l_file_name).do_nothing
							l_pos := -1 + 48 -- goto error
						end
				when 3 then
						l_version := (misc2_inst.get2c (l_fp)).to_integer_32
						if l_version /= 32770 then
							l_pos := -1 + 8 -- skip if block
						end
				when 4 then -- if:
						if ((globals_inst.curbuf.item.b_p_key).item).to_integer_32 = 0 then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E832: Non-encrypted file has encrypted undo file: %%s")))), l_file_name).do_nothing
							l_pos := -1 + 48 -- goto error
						end
				when 5 then
						if (fileio_inst.prepare_crypt_read (l_fp)) = 0 then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E826: Undo file decryption failed: %%s")))), l_file_name).do_nothing
							l_pos := -1 + 48 -- goto error
						end
				when 6 then
						l_do_decrypt := 1
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						if l_version /= 2 then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E824: Incompatible undo file: %%s")))), l_file_name).do_nothing
							l_pos := -1 + 48 -- goto error
						end
				when 9 then
						if (fread (create {CE_POINTER [ANY]}.make_cast (l_read_hash), (32).to_natural_32, (1).to_natural_32, l_fp)) /= {NATURAL_32} 1 then
							corruption_error (ce_string ("hash"), l_file_name)
							l_pos := -1 + 48 -- goto error
						end
				when 10 then
						l_line_count := (misc2_inst.get4c (l_fp)).to_integer_32
						if (memcmp (create {CE_POINTER [ANY]}.make_cast (a_hash), create {CE_POINTER [ANY]}.make_cast (l_read_hash), (32).to_natural_32)) = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L___0
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else:
						if l_line_count = globals_inst.curbuf.item.b_ml.ml_line_count then
							l_pos := -1 + 20 -- skip if block
						end
				when 14 then -- if: | _L___0:
						if not (option_inst.p_verbose > 0) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 18 -- goto _L
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 17 then -- else:
						if (a_name___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 19 -- skip if block
						end
				when 18 then -- if: | _L:
						if (a_name___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							message_inst.verbose_enter
						end
						message_inst.give_warning (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("File contents changed, cannot use undo info")))), 1)
						if (a_name___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							message_inst.verbose_leave
						end
				when 19 then -- if done
						l_pos := -1 + 48 -- goto error
				when 20 then -- if done
						l_str_len := (misc2_inst.get4c (l_fp)).to_integer_32
						if l_str_len < 0 then
							l_pos := -1 + 48 -- goto error
						end
				when 21 then
						if l_str_len > 0 then
							l_line_ptr.ce_gets (read_string_decrypt (globals_inst.curbuf, l_fp, l_str_len.to_integer_32))
						end
						l_line_lnum := (misc2_inst.get4c (l_fp)).to_integer_32
						l_line_colnr := (misc2_inst.get4c (l_fp))
						if l_line_lnum < 0 then
							corruption_error (ce_string ("line lnum/col"), l_file_name)
							l_pos := -1 + 48 -- goto error
						elseif l_line_colnr < 0 then
							corruption_error (ce_string ("line lnum/col"), l_file_name)
							l_pos := -1 + 48 -- goto error
						end
				when 22 then
						l_old_header_seq := (misc2_inst.get4c (l_fp)).to_integer_32
						l_new_header_seq := (misc2_inst.get4c (l_fp)).to_integer_32
						l_cur_header_seq := (misc2_inst.get4c (l_fp)).to_integer_32
						l_num_head := misc2_inst.get4c (l_fp)
						l_seq_last := (misc2_inst.get4c (l_fp)).to_integer_32
						l_seq_cur := (misc2_inst.get4c (l_fp)).to_integer_32
						l_seq_time := misc2_inst.get8ctime (l_fp)
				when 23 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 29 -- skip loop
						end
				when 24 then -- loop body:
						js.reset
						l_len := (IO_getc (l_fp))
						if l_len = 0 then
							js.break
						elseif l_len = -1 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 28 -- skip if block
						end
				when 25 then -- if:
						l_what := IO_getc (l_fp)
						inspect l_what -- switch 1 head
						when 1 then l_pos := -1 + 26
						else l_pos := -1 + 27
						end
				when 26 then -- switch 1, case 1
						l_last_save_nr := (misc2_inst.get4c (l_fp)).to_integer_32
						l_pos := -1 + 28 -- switch 1; break
				when 27 then -- switch 1, default:
						from
						until
							js.loop_left
						loop
							js.reset
							l_len := l_len - 1
							if not (l_len >= 0) then
								js.break
							end
							if not js.loop_jumped then
								IO_getc (l_fp).do_nothing
							end
						end
						js.reset
				when 28 then -- switch 1, done: | if done
						l_pos := -1 + 23 -- back to loop condition
				when 29 then -- loop done
						js.reset
						if l_num_head > 0 then
							l_uhp_table.ce_gets (create {CE_POINTER [CE_POINTER [PD_U_HEADER]]}.make_cast ((misc2_inst.lalloc ((l_num_head.to_natural_32 * Pointer_bytes.to_natural_32).to_natural_32, 0))))
							if (l_uhp_table.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_pos := -1 + 48 -- goto error
							end
						end
				when 30 then
						if js.loop_left then
							l_pos := -1 + 36 -- skip loop
						end
				when 31 then -- loop body:
						js.reset
						l_c := misc2_inst.get2c (l_fp)
						if l_c /= 24528 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 35 -- skip if block
						end
				when 32 then -- if:
						if l_num_read_uhps >= l_num_head.to_integer_32 then
							corruption_error (ce_string ("num_head too small"), l_file_name)
							l_pos := -1 + 48 -- goto error
						end
				when 33 then
						l_uhp.ce_gets (unserialize_uhp (l_fp, l_file_name))
						if (l_uhp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 48 -- goto error
						end
				when 34 then
						l_tmp___27 := l_num_read_uhps
						l_num_read_uhps := l_num_read_uhps + 1
						l_uhp_table[l_tmp___27] := l_uhp
				when 35 then -- if done
						l_pos := -1 + 30 -- back to loop condition
				when 36 then -- loop done
						js.reset
						if l_num_read_uhps /= l_num_head.to_integer_32 then
							corruption_error (ce_string ("num_head"), l_file_name)
							l_pos := -1 + 48 -- goto error
						end
				when 37 then
						if l_c /= 59306 then
							corruption_error (ce_string ("end marker"), l_file_name)
							l_pos := -1 + 48 -- goto error
						end
				when 38 then
						l_i___0 := 0
				when 39 then -- loop condition:
						if not (not js.loop_left and then (l_i___0 < l_num_head)) then
							l_pos := -1 + 47 -- skip loop
						end
				when 40 then -- loop body:
						js.reset
						l_uhp.ce_gets (l_uhp_table[l_i___0])
						if (l_uhp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 46 -- skip if block
						end
				when 41 then -- if:
						l_j := 0
				when 42 then -- loop condition:
						if not (l_j < l_num_head) then
							l_pos := -1 + 45 -- skip loop
						end
				when 43 then -- loop body:
						if ((l_uhp_table[l_j]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if l_i___0 /= l_j then
								if (l_uhp_table[l_i___0]).item.uh_seq = (l_uhp_table[l_j]).item.uh_seq then
									corruption_error (ce_string ("duplicate uh_seq"), l_file_name)
									l_pos := -1 + 48 -- goto error
								end
							end
						end
				when 44 then
						l_j := l_j + 1
						l_pos := -1 + 42 -- back to loop condition
				when 45 then -- loop done
						l_j := 0
						from
						until
							not (not js.loop_left and then (l_j < l_num_head))
						loop
							js.reset
							if ((l_uhp_table[l_j]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if (l_uhp_table[l_j]).item.uh_seq = l_uhp.item.uh_next.seq then
									l_uhp.item.uh_next.ptr := l_uhp_table[l_j]
									js.break
								end
							end
							if not js.loop_jumped then
								l_j := l_j + 1
							end
						end
						js.reset
						l_j := 0
						from
						until
							not (not js.loop_left and then (l_j < l_num_head))
						loop
							js.reset
							if ((l_uhp_table[l_j]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if (l_uhp_table[l_j]).item.uh_seq = l_uhp.item.uh_prev.seq then
									l_uhp.item.uh_prev.ptr := l_uhp_table[l_j]
									js.break
								end
							end
							if not js.loop_jumped then
								l_j := l_j + 1
							end
						end
						js.reset
						l_j := 0
						from
						until
							not (not js.loop_left and then (l_j < l_num_head))
						loop
							js.reset
							if ((l_uhp_table[l_j]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if (l_uhp_table[l_j]).item.uh_seq = l_uhp.item.uh_alt_next.seq then
									l_uhp.item.uh_alt_next.ptr := l_uhp_table[l_j]
									js.break
								end
							end
							if not js.loop_jumped then
								l_j := l_j + 1
							end
						end
						js.reset
						l_j := 0
						from
						until
							not (not js.loop_left and then (l_j < l_num_head))
						loop
							js.reset
							if ((l_uhp_table[l_j]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if (l_uhp_table[l_j]).item.uh_seq = l_uhp.item.uh_alt_prev.seq then
									l_uhp.item.uh_alt_prev.ptr := l_uhp_table[l_j]
									js.break
								end
							end
							if not js.loop_jumped then
								l_j := l_j + 1
							end
						end
						js.reset
						if l_old_header_seq > 0 then
							if l_old_idx.to_integer_32 < 0 then
								if l_uhp.item.uh_seq = l_old_header_seq then
									l_old_idx := l_i___0.to_integer_16
								end
							end
						end
						if l_new_header_seq > 0 then
							if l_new_idx.to_integer_32 < 0 then
								if l_uhp.item.uh_seq = l_new_header_seq then
									l_new_idx := l_i___0.to_integer_16
								end
							end
						end
						if l_cur_header_seq > 0 then
							if l_cur_idx.to_integer_32 < 0 then
								if l_uhp.item.uh_seq = l_cur_header_seq then
									l_cur_idx := l_i___0.to_integer_16
								end
							end
						end
				when 46 then -- if done
						if not js.loop_left then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 39 -- back to loop condition
				when 47 then -- loop done
						u_blockfree (globals_inst.curbuf)
						if l_old_idx.to_integer_32 < 0 then
							globals_inst.curbuf.item.b_u_oldhead := create {CE_POINTER [PD_U_HEADER]}.make_shared (default_pointer)
						else
							globals_inst.curbuf.item.b_u_oldhead := l_uhp_table[l_old_idx.to_integer_32]
						end
						if l_new_idx.to_integer_32 < 0 then
							globals_inst.curbuf.item.b_u_newhead := create {CE_POINTER [PD_U_HEADER]}.make_shared (default_pointer)
						else
							globals_inst.curbuf.item.b_u_newhead := l_uhp_table[l_new_idx.to_integer_32]
						end
						if l_cur_idx.to_integer_32 < 0 then
							globals_inst.curbuf.item.b_u_curhead := create {CE_POINTER [PD_U_HEADER]}.make_shared (default_pointer)
						else
							globals_inst.curbuf.item.b_u_curhead := l_uhp_table[l_cur_idx.to_integer_32]
						end
						globals_inst.curbuf.item.b_u_line_ptr := l_line_ptr
						globals_inst.curbuf.item.b_u_line_lnum := l_line_lnum
						globals_inst.curbuf.item.b_u_line_colnr := l_line_colnr
						globals_inst.curbuf.item.b_u_numhead := l_num_head
						globals_inst.curbuf.item.b_u_seq_last := l_seq_last
						globals_inst.curbuf.item.b_u_seq_cur := l_seq_cur
						globals_inst.curbuf.item.b_u_time_cur := l_seq_time
						globals_inst.curbuf.item.b_u_save_nr_last := l_last_save_nr
						globals_inst.curbuf.item.b_u_synced := 1
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_uhp_table))
						if (a_name___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Finished reading undo file %%s")))), l_file_name]).do_nothing
						end
						l_pos := -1 + 49 -- goto theend
				when 48 then -- error:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_line_ptr))
						if (l_uhp_table.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_i___0 := 0
							from
							until
								not (l_i___0.to_integer_32 < l_num_read_uhps)
							loop
								if ((l_uhp_table[l_i___0]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									u_free_uhp (l_uhp_table[l_i___0])
								end
								l_i___0 := l_i___0 + 1
							end
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_uhp_table))
						end
				when 49 then -- theend:
						if l_do_decrypt.to_boolean then
							misc2_inst.crypt_pop_state
						end
						if (l_fp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							fclose (l_fp).do_nothing
						end
						if (l_file_name.c_pointer.to_integer_32).to_natural_32 /= (a_name___1.c_pointer.to_integer_32).to_natural_32 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_file_name))
						end
				when 50 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	u_undo (a_count___2: INTEGER_32)
		local
			l_count___2: INTEGER_32
		do
			l_count___2 := a_count___2
			if globals_inst.curbuf.item.b_u_synced = 0 then
				u_sync (1)
				l_count___2 := 1
			end
			if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('u').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				undo_undoes := 1
			else
				undo_undoes := (not undo_undoes.to_boolean).to_integer
			end
			u_doit (l_count___2)
		end

	u_redo (a_count___2: INTEGER_32)
		do
			if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('u').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				undo_undoes := 0
			end
			u_doit (a_count___2)
		end

	u_doit (a_startcount: INTEGER_32)
		local
			l_count___2: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2 := a_startcount
					if not (undo_allowed).to_boolean then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 20 -- skip if block
					end
				when 1 then -- if:
						u_newcount := 0
						u_oldcount := 0
						if ((globals_inst.curbuf.item.b_ml.ml_flags).bit_and (1)).to_boolean then
							u_oldcount := -1
						end
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 19 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						l_tmp___2 := l_count___2
						l_count___2 := l_count___2 - 1
						if not l_tmp___2.to_boolean then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 18 -- skip if block
						end
				when 4 then -- if:
						misc1_inst.change_warning (0)
						if not (undo_undoes.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 5 then -- if:
						if ((globals_inst.curbuf.item.b_u_curhead).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							globals_inst.curbuf.item.b_u_curhead := globals_inst.curbuf.item.b_u_newhead
						elseif option_inst.p_ul > 0 then
							globals_inst.curbuf.item.b_u_curhead := (globals_inst.curbuf.item.b_u_curhead).item.uh_next.ptr
						end
						if globals_inst.curbuf.item.b_u_numhead /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if ((globals_inst.curbuf.item.b_u_curhead).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						globals_inst.curbuf.item.b_u_curhead := globals_inst.curbuf.item.b_u_oldhead
						misc1_inst.beep_flush
						if l_count___2 = a_startcount - 1 then
							message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Already at oldest change"))))).do_nothing
							js.return
						end
						if not js.return_called then
							js.break
						end
				when 10 then -- if done
						if not js.loop_jumped then
							u_undoredo (1)
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 12 then -- else:
						if ((globals_inst.curbuf.item.b_u_curhead).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L___0
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 15 then -- else:
						if not (option_inst.p_ul <= 0) then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L___0:
						misc1_inst.beep_flush
						if l_count___2 = a_startcount - 1 then
							message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Already at newest change"))))).do_nothing
							js.return
						end
						if not js.return_called then
							js.break
						end
				when 17 then -- if done
						if not js.loop_jumped then
							u_undoredo (0)
							if (((globals_inst.curbuf.item.b_u_curhead).item.uh_prev.ptr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								globals_inst.curbuf.item.b_u_newhead := globals_inst.curbuf.item.b_u_curhead
							end
							globals_inst.curbuf.item.b_u_curhead := (globals_inst.curbuf.item.b_u_curhead).item.uh_prev.ptr
						end
				when 18 then -- if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 19 then -- loop done
						js.reset
				when 20 then -- if done
					if not js.return_called then
						u_undo_end (undo_undoes, 0)
					end
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	undo_time (a_step: INTEGER_32; a_sec: INTEGER_32; a_file: INTEGER_32; a_absolute: INTEGER_32)
		local
			l_target: INTEGER_32
			l_closest: INTEGER_32
			l_closest_start: INTEGER_32
			l_closest_seq: INTEGER_32
			l_val___0: INTEGER_32
			l_uhp: CE_POINTER [PD_U_HEADER]
			l_last: CE_POINTER [PD_U_HEADER]
			l_mark: INTEGER_32
			l_nomark: INTEGER_32
			l_round: INTEGER_32
			l_dosec: INTEGER_32
			l_dofile: INTEGER_32
			l_above: INTEGER_32
			l_did_undo: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___10: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_uhp.make
			create l_last.make
			create l_tmp___10.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_closest_seq := 0
					l_dosec := a_sec
					l_dofile := a_file
					l_above := 0
					l_did_undo := 1
					if globals_inst.curbuf.item.b_u_synced = 0 then
						u_sync (1)
					end
					u_newcount := 0
					u_oldcount := 0
					if ((globals_inst.curbuf.item.b_ml.ml_flags).bit_and (1)).to_boolean then
						u_oldcount := -1
					end
					if a_absolute.to_boolean then
						l_target := a_step
						l_closest := -1
					else
						if l_dosec.to_boolean then
							l_target := (globals_inst.curbuf.item.b_u_time_cur - globals_inst.starttime) + a_step
						elseif l_dofile.to_boolean then
							if a_step < 0 then
								l_uhp.ce_gets (globals_inst.curbuf.item.b_u_curhead)
								if (l_uhp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_uhp.ce_gets (l_uhp.item.uh_next.ptr)
								else
									l_uhp.ce_gets (globals_inst.curbuf.item.b_u_newhead)
								end
								if (l_uhp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if l_uhp.item.uh_save_nr /= 0 then
										l_target := globals_inst.curbuf.item.b_u_save_nr_cur + a_step
									else
										l_target := (globals_inst.curbuf.item.b_u_save_nr_cur + a_step) + 1
									end
								else
									l_target := (globals_inst.curbuf.item.b_u_save_nr_cur + a_step) + 1
								end
								if l_target <= 0 then
									l_dofile := 0
								end
							else
								l_target := globals_inst.curbuf.item.b_u_save_nr_cur + a_step
								if l_target > globals_inst.curbuf.item.b_u_save_nr_last then
									l_target := globals_inst.curbuf.item.b_u_seq_last + 1
									l_dofile := 0
								end
							end
						else
							l_target := globals_inst.curbuf.item.b_u_seq_cur + a_step
						end
						if a_step < 0 then
							if l_target < 0 then
								l_target := 0
							end
							l_closest := -1
						else
							if l_dosec.to_boolean then
								l_closest := ((time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))) - globals_inst.starttime) + 1
							elseif l_dofile.to_boolean then
								l_closest := globals_inst.curbuf.item.b_u_save_nr_last + 2
							else
								l_closest := globals_inst.curbuf.item.b_u_seq_last + 2
							end
							if l_target >= l_closest then
								l_target := l_closest - 1
							end
						end
					end
					l_closest_start := l_closest
					l_closest_seq := globals_inst.curbuf.item.b_u_seq_cur
					l_round := 1
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_round <= 2)) then
						l_pos := -1 + 27 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						lastmark := lastmark + 1
						l_mark := lastmark
						lastmark := lastmark + 1
						l_nomark := lastmark
						if ((globals_inst.curbuf.item.b_u_curhead).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_uhp.ce_gets (globals_inst.curbuf.item.b_u_newhead)
						else
							l_uhp.ce_gets (globals_inst.curbuf.item.b_u_curhead)
						end
				when 3 then -- loop condition:
						if not (not js.loop_left and then ((l_uhp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32)) then
							l_pos := -1 + 26 -- skip loop
						end
				when 4 then -- loop body:
						js.reset
						l_uhp.item.uh_walk := l_mark
						if l_dosec.to_boolean then
							l_val___0 := l_uhp.item.uh_time - globals_inst.starttime
						elseif l_dofile.to_boolean then
							l_val___0 := l_uhp.item.uh_save_nr
						else
							l_val___0 := l_uhp.item.uh_seq
						end
						if l_round /= 1 then
							l_pos := -1 + 14 -- skip if block
						end
				when 5 then -- if:
						if not (l_dofile.to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if l_val___0 /= 0 then
							l_pos := -1 + 8 -- goto _L___0
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 8 then -- else: | _L___0:
						if a_step < 0 then
							l_tmp___0 := (l_uhp.item.uh_seq <= globals_inst.curbuf.item.b_u_seq_cur).to_integer
						else
							l_tmp___0 := (l_uhp.item.uh_seq > globals_inst.curbuf.item.b_u_seq_cur).to_integer
						end
						if not (l_tmp___0.to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 9 then -- if:
						if not (l_dosec.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if l_val___0 = l_closest then
							if a_step < 0 then
								l_tmp___1 := (l_uhp.item.uh_seq < l_closest_seq).to_integer
							else
								l_tmp___1 := (l_uhp.item.uh_seq > l_closest_seq).to_integer
							end
							l_tmp___6 := l_tmp___1
						else
							l_pos := -1 + 12 -- goto _L
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						if l_closest = l_closest_start then
							l_tmp___5 := 1
						else
							if l_val___0 > l_target then
								if l_closest > l_target then
									l_tmp___2 := (l_val___0 - l_target <= l_closest - l_target).to_integer
								else
									l_tmp___2 := (l_val___0 - l_target <= l_target - l_closest).to_integer
								end
								l_tmp___4 := l_tmp___2
							else
								if l_closest > l_target then
									l_tmp___3 := (l_target - l_val___0 <= l_closest - l_target).to_integer
								else
									l_tmp___3 := (l_target - l_val___0 <= l_target - l_closest).to_integer
								end
								l_tmp___4 := l_tmp___3
							end
							if l_tmp___4.to_boolean then
								l_tmp___5 := 1
							else
								l_tmp___5 := 0
							end
						end
						l_tmp___6 := l_tmp___5
				when 13 then
						if l_tmp___6.to_boolean then
							l_closest := l_val___0
							l_closest_seq := l_uhp.item.uh_seq
						end
				when 14 then -- if done | if done
						if l_target = l_val___0 then
							if not l_dosec.to_boolean then
								l_target := l_uhp.item.uh_seq
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 25 -- skip if block
						end
				when 15 then -- if:
						if ((l_uhp.item.uh_prev.ptr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if (l_uhp.item.uh_prev.ptr).item.uh_walk /= l_nomark then
							if (l_uhp.item.uh_prev.ptr).item.uh_walk /= l_mark then
								l_uhp.ce_gets (l_uhp.item.uh_prev.ptr)
							else
								l_pos := -1 + 18 -- goto _L___7
							end
						else
							l_pos := -1 + 18 -- goto _L___7
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 18 then -- else: | _L___7:
						if ((l_uhp.item.uh_alt_next.ptr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if (l_uhp.item.uh_alt_next.ptr).item.uh_walk /= l_nomark then
							if (l_uhp.item.uh_alt_next.ptr).item.uh_walk /= l_mark then
								l_uhp.ce_gets (l_uhp.item.uh_alt_next.ptr)
							else
								l_pos := -1 + 21 -- goto _L___5
							end
						else
							l_pos := -1 + 21 -- goto _L___5
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 21 then -- else: | _L___5:
						if ((l_uhp.item.uh_next.ptr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if ((l_uhp.item.uh_alt_prev.ptr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if (l_uhp.item.uh_next.ptr).item.uh_walk /= l_nomark then
								if (l_uhp.item.uh_next.ptr).item.uh_walk /= l_mark then
									if (l_uhp.c_pointer.to_integer_32).to_natural_32 = ((globals_inst.curbuf.item.b_u_curhead).c_pointer.to_integer_32).to_natural_32 then
										l_uhp.item.uh_walk := l_nomark
									end
									l_uhp.ce_gets (l_uhp.item.uh_next.ptr)
								else
									l_pos := -1 + 24 -- goto _L___3
								end
							else
								l_pos := -1 + 24 -- goto _L___3
							end
						else
							l_pos := -1 + 24 -- goto _L___3
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else: | _L___3:
						l_uhp.item.uh_walk := l_nomark
						if ((l_uhp.item.uh_alt_prev.ptr).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_uhp.ce_gets (l_uhp.item.uh_alt_prev.ptr)
						else
							l_uhp.ce_gets (l_uhp.item.uh_next.ptr)
						end
				when 25 then -- if done | if done | if done
						l_pos := -1 + 3 -- back to loop condition
				when 26 then -- loop done
						js.reset
						if (l_uhp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							js.break
						end
						if not js.loop_jumped then
							if a_absolute.to_boolean then
								misc2_inst.emsgn (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E830: Undo number %%ld not found")))), a_step).do_nothing
								js.return
							end
							if not js.return_called and then (l_closest = l_closest_start) then
								if a_step < 0 then
									message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Already at oldest change"))))).do_nothing
								else
									message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Already at newest change"))))).do_nothing
								end
								js.return
							end
							if not js.return_called then
								l_target := l_closest_seq
								l_dosec := 0
								l_dofile := 0
								if a_step < 0 then
									l_above := 1
								end
								l_round := l_round + 1
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 27 then -- loop done
					js.reset
					if not js.return_called then
						if (l_uhp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							from
							until
								not (not js.loop_left and then (not globals_inst.got_int.to_boolean))
							loop
								js.reset
								misc1_inst.change_warning (0)
								l_uhp.ce_gets (globals_inst.curbuf.item.b_u_curhead)
								if (l_uhp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_uhp.ce_gets (globals_inst.curbuf.item.b_u_newhead)
								else
									l_uhp.ce_gets (l_uhp.item.uh_next.ptr)
								end
								if (l_uhp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									js.break
								elseif l_uhp.item.uh_walk /= l_mark then
									js.break
								elseif l_uhp.item.uh_seq = l_target then
									if not l_above.to_boolean then
										js.break
									end
								end
								if not js.loop_jumped then
									globals_inst.curbuf.item.b_u_curhead := l_uhp
									u_undoredo (1)
									l_uhp.item.uh_walk := l_nomark
								end
							end
							js.reset
							from
							until
								not (not js.loop_left and then (not globals_inst.got_int.to_boolean))
							loop
								js.reset
								misc1_inst.change_warning (0)
								l_uhp.ce_gets (globals_inst.curbuf.item.b_u_curhead)
								if (l_uhp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									js.break
								end
								if not js.loop_jumped then
									from
									until
										js.loop_left
									loop
										js.reset
										if ((l_uhp.item.uh_alt_prev.ptr).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
											if (l_uhp.item.uh_alt_prev.ptr).item.uh_walk /= l_mark then
												js.break
											end
										else
											js.break
										end
										if not js.loop_jumped then
											l_uhp.ce_gets (l_uhp.item.uh_alt_prev.ptr)
										end
									end
									js.reset
									l_last.ce_gets (l_uhp)
									from
									until
										js.loop_left
									loop
										js.reset
										if ((l_last.item.uh_alt_next.ptr).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
											if (l_last.item.uh_alt_next.ptr).item.uh_walk /= l_mark then
												js.break
											end
										else
											js.break
										end
										if not js.loop_jumped then
											l_last.ce_gets (l_last.item.uh_alt_next.ptr)
										end
									end
									js.reset
									if (l_last.c_pointer.to_integer_32).to_natural_32 /= (l_uhp.c_pointer.to_integer_32).to_natural_32 then
										from
										until
											((l_uhp.item.uh_alt_prev.ptr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
										loop
											l_uhp.ce_gets (l_uhp.item.uh_alt_prev.ptr)
										end
										if ((l_last.item.uh_alt_next.ptr).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
											(l_last.item.uh_alt_next.ptr).item.uh_alt_prev.ptr := l_last.item.uh_alt_prev.ptr
										end
										(l_last.item.uh_alt_prev.ptr).item.uh_alt_next.ptr := l_last.item.uh_alt_next.ptr
										l_last.item.uh_alt_prev.ptr := create {CE_POINTER [PD_U_HEADER]}.make_shared (default_pointer)
										l_last.item.uh_alt_next.ptr := l_uhp
										l_uhp.item.uh_alt_prev.ptr := l_last
										if ((globals_inst.curbuf.item.b_u_oldhead).c_pointer.to_integer_32).to_natural_32 = (l_uhp.c_pointer.to_integer_32).to_natural_32 then
											globals_inst.curbuf.item.b_u_oldhead := l_last
										end
										l_uhp.ce_gets (l_last)
										if ((l_uhp.item.uh_next.ptr).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
											(l_uhp.item.uh_next.ptr).item.uh_prev.ptr := l_uhp
										end
									end
									globals_inst.curbuf.item.b_u_curhead := l_uhp
									if l_uhp.item.uh_walk /= l_mark then
										js.break
									end
								end
								if not js.loop_jumped and then (l_uhp.item.uh_seq = l_target) then
									if l_above.to_boolean then
										globals_inst.curbuf.item.b_u_seq_cur := l_target - 1
										js.break
									end
								end
								if not js.loop_jumped then
									u_undoredo (0)
									if ((l_uhp.item.uh_prev.ptr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										globals_inst.curbuf.item.b_u_newhead := l_uhp
									end
									globals_inst.curbuf.item.b_u_curhead := l_uhp.item.uh_prev.ptr
									l_did_undo := 0
									if l_uhp.item.uh_seq = l_target then
										js.break
									end
								end
								if not js.loop_jumped then
									l_uhp.ce_gets (l_uhp.item.uh_prev.ptr)
									if (l_uhp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										l_tmp___10.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_intern2)))
										message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___10), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("undo_time()"))).do_nothing
										js.break
									elseif l_uhp.item.uh_walk /= l_mark then
										l_tmp___10.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_intern2)))
										message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___10), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("undo_time()"))).do_nothing
										js.break
									end
								end
							end
							js.reset
						end
						u_undo_end (l_did_undo, a_absolute)
					end
				when 28 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	u_undoredo (a_undo: INTEGER_32)
		local
			l_newarray: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_oldsize: INTEGER_32
			l_newsize: INTEGER_32
			l_top: INTEGER_32
			l_bot: INTEGER_32
			l_lnum: INTEGER_32
			l_newlnum: INTEGER_32
			l_i___0: INTEGER_32
			l_uep: CE_POINTER [PD_U_ENTRY]
			l_nuep: CE_POINTER [PD_U_ENTRY]
			l_newlist: CE_POINTER [PD_U_ENTRY]
			l_old_flags: INTEGER_32
			l_new_flags: INTEGER_32
			l_namedm: CE_ARRAY [PD_POS_T]
			l_visualinfo: PD_VISUALINFO_T
			l_empty_buffer: INTEGER_32
			l_curhead: CE_POINTER [PD_U_HEADER]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_newarray.make
			create l_uep.make
			create l_nuep.make
			create l_newlist.make
			create l_namedm.make (<<26>>)
			create l_visualinfo.make
			create l_curhead.make
			create l_tmp___1.make
			create l_tmp___5.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_newarray.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))
					l_newlnum := 2147483647
					l_newlist.ce_gets (create {CE_POINTER [PD_U_ENTRY]}.make_shared (default_pointer))
					l_curhead.ce_gets (globals_inst.curbuf.item.b_u_curhead)
					fileio_inst.block_autocmds
					l_old_flags := l_curhead.item.uh_flags
					if (globals_inst.curbuf.item.b_changed).to_boolean then
						l_tmp := 1
					else
						l_tmp := 0
					end
					if ((globals_inst.curbuf.item.b_ml.ml_flags).bit_and (1)).to_boolean then
						l_tmp___0 := 2
					else
						l_tmp___0 := 0
					end
					l_new_flags := l_tmp + l_tmp___0
					mark_inst.setpcmark
					memmove (create {CE_POINTER [ANY]}.make_cast (l_namedm), create {CE_POINTER [ANY]}.make_cast ((globals_inst.curbuf.item.b_namedm)), {PD_POS_T}.sizeof.to_natural_32 * {NATURAL_32} 26).do_nothing
					l_visualinfo.ce_gets (globals_inst.curbuf.item.b_visual)
					globals_inst.curbuf.item.b_op_start.lnum := globals_inst.curbuf.item.b_ml.ml_line_count
					globals_inst.curbuf.item.b_op_start.col := 0
					globals_inst.curbuf.item.b_op_end.lnum := (0).to_integer_32
					globals_inst.curbuf.item.b_op_end.col := 0
					l_uep.ce_gets (l_curhead.item.uh_entry)
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_uep.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32)) then
						l_pos := -1 + 18 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_top := l_uep.item.ue_top
						l_bot := l_uep.item.ue_bot
						if l_bot = 0 then
							l_bot := globals_inst.curbuf.item.b_ml.ml_line_count + 1
						end
						if l_top > globals_inst.curbuf.item.b_ml.ml_line_count then
							fileio_inst.unblock_autocmds
							l_tmp___1.ce_gets (gettext (ce_string ("E438: u_undo: line numbers wrong")))
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___1)).do_nothing
							misc1_inst.changed
							js.return
						elseif l_top >= l_bot then
							fileio_inst.unblock_autocmds
							l_tmp___1.ce_gets (gettext (ce_string ("E438: u_undo: line numbers wrong")))
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___1)).do_nothing
							misc1_inst.changed
							js.return
						elseif l_bot > globals_inst.curbuf.item.b_ml.ml_line_count + 1 then
							fileio_inst.unblock_autocmds
							l_tmp___1.ce_gets (gettext (ce_string ("E438: u_undo: line numbers wrong")))
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___1)).do_nothing
							misc1_inst.changed
							js.return
						end
						if js.return_called then
							l_pos := -1 + 17 -- skip if block
						end
				when 3 then -- if:
						l_oldsize := (l_bot - l_top) - 1
						l_newsize := l_uep.item.ue_size
						if not (l_top < l_newlnum) then
							l_pos := -1 + 11 -- skip if block
						end
				when 4 then -- if:
						l_lnum := l_curhead.item.uh_cursor.lnum
						if not (l_lnum >= l_top) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_lnum <= (l_top + l_newsize) + 1 then
							globals_inst.curwin.item.w_cursor := l_curhead.item.uh_cursor
							l_newlnum := globals_inst.curwin.item.w_cursor.lnum - 1
						else
							l_pos := -1 + 7 -- goto _L___1
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else: | _L___1:
						l_i___0 := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if l_i___0 < l_newsize then
								if not (l_i___0 < l_oldsize) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_uep.item.ue_array[l_i___0]), create {CE_POINTER [INTEGER_8]}.make_cast ((memline_inst.ml_get ((l_top + 1) + l_i___0))))) /= 0 then
									js.break
								end
							end
							if not js.loop_jumped then
								l_i___0 := l_i___0 + 1
							end
						end
						js.reset
						if l_i___0 /= l_newsize then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_newlnum = 2147483647 then
							if ((l_uep.item.ue_next).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_newlnum := l_top
								globals_inst.curwin.item.w_cursor.lnum := l_newlnum + 1
							else
								l_pos := -1 + 10 -- goto _L___0
							end
						else
							l_pos := -1 + 10 -- goto _L___0
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L___0:
						if l_i___0 < l_newsize then
							l_newlnum := l_top + l_i___0
							globals_inst.curwin.item.w_cursor.lnum := l_newlnum + 1
						end
				when 11 then -- if done | if done
						l_empty_buffer := 0
						if l_oldsize > 0 then
							l_newarray.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((misc2_inst.lalloc ((Pointer_bytes.to_natural_32).to_natural_32 * l_oldsize.to_natural_32, 0))))
							if (l_newarray.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								misc2_inst.do_outofmem_msg ((Pointer_bytes.to_natural_32).to_natural_32 * l_oldsize.to_natural_32)
								from
								until
									(l_uep.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
								loop
									l_nuep.ce_gets (l_uep.item.ue_next)
									u_freeentry (l_uep, l_uep.item.ue_size)
									l_uep.ce_gets (l_nuep)
								end
								js.break
							end
							if not js.loop_jumped then
								l_lnum := l_bot - 1
								l_i___0 := l_oldsize
								from
								until
									js.loop_left
								loop
									js.reset
									l_i___0 := l_i___0 - 1
									if not (l_i___0 >= 0) then
										js.break
									end
									if not js.loop_jumped then
										l_tmp___5.ce_gets (u_save_line (l_lnum))
										l_newarray[l_i___0] := l_tmp___5
										if (l_tmp___5.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
											misc2_inst.do_outofmem_msg ((0).to_natural_32)
										end
										if globals_inst.curbuf.item.b_ml.ml_line_count = 1 then
											l_empty_buffer := 1
										end
										memline_inst.ml_delete (l_lnum, 0).do_nothing
										l_lnum := l_lnum - 1
									end
								end
								js.reset
							end
						else
							l_newarray.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))
						end
						if js.loop_jumped then
							l_pos := -1 + 17 -- skip if block
						end
				when 12 then -- if:
						if l_newsize.to_boolean then
							l_lnum := l_top
							l_i___0 := 0
							from
							until
								not (l_i___0 < l_newsize)
							loop
								if l_empty_buffer.to_boolean then
									if l_lnum = 0 then
										memline_inst.ml_replace ((1).to_integer_32, l_uep.item.ue_array[l_i___0], 1).do_nothing
									else
										memline_inst.ml_append (l_lnum, l_uep.item.ue_array[l_i___0], 0, 0).do_nothing
									end
								else
									memline_inst.ml_append (l_lnum, l_uep.item.ue_array[l_i___0], 0, 0).do_nothing
								end
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_uep.item.ue_array[l_i___0]))
								l_i___0 := l_i___0 + 1
								l_lnum := l_lnum + 1
							end
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_uep.item.ue_array))
						end
						if l_oldsize /= l_newsize then
							mark_inst.mark_adjust (l_top + 1, l_top + l_oldsize, 2147483647, l_newsize - l_oldsize)
							if globals_inst.curbuf.item.b_op_start.lnum > l_top + l_oldsize then
								globals_inst.curbuf.item.b_op_start.lnum := globals_inst.curbuf.item.b_op_start.lnum + (l_newsize - l_oldsize)
							end
							if globals_inst.curbuf.item.b_op_end.lnum > l_top + l_oldsize then
								globals_inst.curbuf.item.b_op_end.lnum := globals_inst.curbuf.item.b_op_end.lnum + (l_newsize - l_oldsize)
							end
						end
						misc1_inst.changed_lines (l_top + 1, 0, l_bot, l_newsize - l_oldsize)
						if l_top + 1 < globals_inst.curbuf.item.b_op_start.lnum then
							globals_inst.curbuf.item.b_op_start.lnum := l_top + 1
						end
						if l_newsize /= 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if l_top + 1 > globals_inst.curbuf.item.b_op_end.lnum then
							globals_inst.curbuf.item.b_op_end.lnum := l_top + 1
						else
							l_pos := -1 + 15 -- goto _L___2
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else: | _L___2:
						if l_top + l_newsize > globals_inst.curbuf.item.b_op_end.lnum then
							globals_inst.curbuf.item.b_op_end.lnum := l_top + l_newsize
						end
				when 16 then
						u_newcount := u_newcount + l_newsize
						u_oldcount := u_oldcount + l_oldsize
						l_uep.item.ue_size := l_oldsize
						l_uep.item.ue_array := l_newarray
						l_uep.item.ue_bot := (l_top + l_newsize) + 1
						l_nuep.ce_gets (l_uep.item.ue_next)
						l_uep.item.ue_next := l_newlist
						l_newlist.ce_gets (l_uep)
						l_uep.ce_gets (l_nuep)
				when 17 then -- if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 18 then -- loop done
					js.reset
					if not js.return_called then
						l_curhead.item.uh_entry := l_newlist
						l_curhead.item.uh_flags := l_new_flags
						if ((l_old_flags).bit_and (2)).to_boolean then
							if globals_inst.curbuf.item.b_ml.ml_line_count = 1 then
								if ((memline_inst.ml_get ((1).to_integer_32)).item).to_integer_32 = 0 then
									globals_inst.curbuf.item.b_ml.ml_flags := (globals_inst.curbuf.item.b_ml.ml_flags).bit_or ((1))
								end
							end
						end
						if ((l_old_flags).bit_and (1)).to_boolean then
							misc1_inst.changed
						elseif not (netbeans_inst.isNetbeansModified (globals_inst.curbuf)).to_boolean then
							misc1_inst.unchanged (globals_inst.curbuf, 0)
						end
						l_i___0 := 0
						from
						until
							not (l_i___0 < 26)
						loop
							if l_curhead.item.uh_namedm[l_i___0].lnum /= 0 then
								globals_inst.curbuf.item.b_namedm[l_i___0] := l_curhead.item.uh_namedm[l_i___0]
								l_curhead.item.uh_namedm[l_i___0] := l_namedm[l_i___0]
							end
							l_i___0 := l_i___0 + 1
						end
						if l_curhead.item.uh_visual.vi_start.lnum /= 0 then
							globals_inst.curbuf.item.b_visual := l_curhead.item.uh_visual
							l_curhead.item.uh_visual := l_visualinfo
						end
						if l_curhead.item.uh_cursor.lnum + 1 = globals_inst.curwin.item.w_cursor.lnum then
							if globals_inst.curwin.item.w_cursor.lnum > 1 then
								globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) - 1
							end
						end
						if globals_inst.curwin.item.w_cursor.lnum <= globals_inst.curbuf.item.b_ml.ml_line_count then
							if l_curhead.item.uh_cursor.lnum = globals_inst.curwin.item.w_cursor.lnum then
								globals_inst.curwin.item.w_cursor.col := l_curhead.item.uh_cursor.col
								if (misc2_inst.virtual_active).to_boolean then
									if l_curhead.item.uh_cursor_vcol >= 0 then
										misc2_inst.coladvance ((l_curhead.item.uh_cursor_vcol).to_integer_32).do_nothing
									else
										globals_inst.curwin.item.w_cursor.coladd := 0
									end
								else
									globals_inst.curwin.item.w_cursor.coladd := 0
								end
							else
								edit_inst.beginline (6)
							end
						else
							globals_inst.curwin.item.w_cursor.col := 0
							globals_inst.curwin.item.w_cursor.coladd := 0
						end
						misc2_inst.check_cursor
						globals_inst.curbuf.item.b_u_seq_cur := l_curhead.item.uh_seq
						if a_undo.to_boolean then
							globals_inst.curbuf.item.b_u_seq_cur := (globals_inst.curbuf.item.b_u_seq_cur) - 1
						end
						if l_curhead.item.uh_save_nr /= 0 then
							if a_undo.to_boolean then
								globals_inst.curbuf.item.b_u_save_nr_cur := l_curhead.item.uh_save_nr - 1
							else
								globals_inst.curbuf.item.b_u_save_nr_cur := l_curhead.item.uh_save_nr
							end
						end
						globals_inst.curbuf.item.b_u_time_cur := l_curhead.item.uh_time
						fileio_inst.unblock_autocmds
					end
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	u_undo_end (a_did_undo: INTEGER_32; a_absolute: INTEGER_32)
		local
			l_did_undo: INTEGER_32
			l_msgstr: CE_POINTER [INTEGER_8]
			l_uhp: CE_POINTER [PD_U_HEADER]
			l_msgbuf: CE_ARRAY [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_msgstr.make
			create l_uhp.make
			create l_msgbuf.make (<<80>>)
			create l_tmp___3.make
			create l_tmp___4.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_did_undo := a_did_undo
					if ((option_inst.fdo_flags).bit_and ({NATURAL_32} 512)).to_boolean then
						if globals_inst.KeyTyped.to_boolean then
							fold_inst.foldOpenCursor
						end
					end
					if globals_inst.global_busy.to_boolean then
						js.return
					elseif not (screen_inst.messaging).to_boolean then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if ((globals_inst.curbuf.item.b_ml.ml_flags).bit_and (1)).to_boolean then
							u_newcount := u_newcount - 1
						end
						u_oldcount := u_oldcount - u_newcount
						if u_oldcount = -1 then
							l_msgstr.ce_gets (ce_string ("more line"))
						elseif u_oldcount < 0 then
							l_msgstr.ce_gets (ce_string ("more lines"))
						elseif u_oldcount = 1 then
							l_msgstr.ce_gets (ce_string ("line less"))
						elseif u_oldcount > 1 then
							l_msgstr.ce_gets (ce_string ("fewer lines"))
						else
							u_oldcount := u_newcount
							if u_newcount = 1 then
								l_msgstr.ce_gets (ce_string ("change"))
							else
								l_msgstr.ce_gets (ce_string ("changes"))
							end
						end
						if ((globals_inst.curbuf.item.b_u_curhead).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if not (a_absolute.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (((globals_inst.curbuf.item.b_u_curhead).item.uh_next.ptr).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_uhp.ce_gets ((globals_inst.curbuf.item.b_u_curhead).item.uh_next.ptr)
							l_did_undo := 0
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if l_did_undo.to_boolean then
							l_uhp.ce_gets (globals_inst.curbuf.item.b_u_curhead)
						else
							l_uhp.ce_gets ((globals_inst.curbuf.item.b_u_curhead).item.uh_next.ptr)
						end
				when 6 then -- if done | if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_uhp.ce_gets (globals_inst.curbuf.item.b_u_newhead)
				when 8 then
						if (l_uhp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_msgbuf[0] := (('%/0/').code).to_natural_8
						else
							u_add_time (l_msgbuf, (Natural_8_bytes.to_natural_32 * (80).to_natural_32), l_uhp.item.uh_time)
						end
						if (l_uhp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_tmp___0 := 0
						else
							l_tmp___0 := l_uhp.item.uh_seq
						end
						if l_did_undo.to_boolean then
							l_tmp___3.ce_gets ((gettext (ce_string ("before"))))
						else
							l_tmp___3.ce_gets ((gettext (ce_string ("after"))))
						end
						l_tmp___4.ce_gets (gettext (l_msgstr))
						if u_oldcount < 0 then
							l_tmp___5 := -u_oldcount
						else
							l_tmp___5 := u_oldcount
						end
						message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%%ld %%s; %%s #%%ld  %%s")))), l_tmp___5, l_tmp___4, l_tmp___3, l_tmp___0, l_msgbuf]).do_nothing
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	u_sync (a_force: INTEGER_32)
		local
			js: JUMP_STATE
		do
			if (globals_inst.curbuf.item.b_u_synced).to_boolean then
				js.return
			elseif not a_force.to_boolean then
				if globals_inst.no_u_sync > 0 then
					js.return
				end
			end
			if not js.return_called then
				if (mbyte_inst.im_is_preediting).to_boolean then
					js.return
				end
			end
			if not js.return_called then
				if option_inst.p_ul < 0 then
					globals_inst.curbuf.item.b_u_synced := 1
				else
					u_getbot
					globals_inst.curbuf.item.b_u_curhead := create {CE_POINTER [PD_U_HEADER]}.make_shared (default_pointer)
				end
			end
		end

	ex_undolist (a_eap: CE_POINTER [PD_EXARG])
		local
			l_ga: PD_GROWARRAY
			l_uhp: CE_POINTER [PD_U_HEADER]
			l_mark: INTEGER_32
			l_nomark: INTEGER_32
			l_changes: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp___0: NATURAL_32
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ga.make
			create l_uhp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_changes := 1
					lastmark := lastmark + 1
					l_mark := lastmark
					lastmark := lastmark + 1
					l_nomark := lastmark
					misc2_inst.ga_init2 (l_ga.address, (Pointer_bytes.to_natural_32).to_integer_32, 20)
					l_uhp.ce_gets (globals_inst.curbuf.item.b_u_oldhead)
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_uhp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32)) then
						l_pos := -1 + 14 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if ((l_uhp.item.uh_prev.ptr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if l_uhp.item.uh_walk /= l_nomark then
								if l_uhp.item.uh_walk /= l_mark then
									if (misc2_inst.ga_grow (l_ga.address, 1)) = 0 then
										js.break
									end
									if not js.loop_jumped then
										message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1025).to_natural_32, ce_string ("%%6ld %%7ld  "), l_uhp.item.uh_seq, l_changes]).do_nothing
										l_tmp___0 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff))
										u_add_time (globals_inst.IObuff + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff))).to_integer_32, {NATURAL_32} 1025 - l_tmp___0, l_uhp.item.uh_time)
										if l_uhp.item.uh_save_nr > 0 then
											from
											until
												js.loop_left
											loop
												js.reset
												if not ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff))) < {NATURAL_32} 32) then
													js.break
												end
												if not js.loop_jumped then
													strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), ce_string (" ")).do_nothing
												end
											end
											js.reset
											message_inst.vim_snprintf_add ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1025).to_natural_32, ce_string ("  %%3ld"), l_uhp.item.uh_save_nr]).do_nothing
										end
										l_tmp___3 := l_ga.ga_len
										l_ga.ga_len := (l_ga.ga_len) + 1
										create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_ga.ga_data)[l_tmp___3] := misc2_inst.vim_strsave (globals_inst.IObuff)
									end
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 13 -- skip if block
						end
				when 3 then -- if:
						l_uhp.item.uh_walk := l_mark
						if ((l_uhp.item.uh_prev.ptr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (l_uhp.item.uh_prev.ptr).item.uh_walk /= l_nomark then
							if (l_uhp.item.uh_prev.ptr).item.uh_walk /= l_mark then
								l_uhp.ce_gets (l_uhp.item.uh_prev.ptr)
								l_changes := l_changes + 1
							else
								l_pos := -1 + 6 -- goto _L___5
							end
						else
							l_pos := -1 + 6 -- goto _L___5
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else: | _L___5:
						if ((l_uhp.item.uh_alt_next.ptr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if (l_uhp.item.uh_alt_next.ptr).item.uh_walk /= l_nomark then
							if (l_uhp.item.uh_alt_next.ptr).item.uh_walk /= l_mark then
								l_uhp.ce_gets (l_uhp.item.uh_alt_next.ptr)
							else
								l_pos := -1 + 9 -- goto _L___3
							end
						else
							l_pos := -1 + 9 -- goto _L___3
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else: | _L___3:
						if ((l_uhp.item.uh_next.ptr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if ((l_uhp.item.uh_alt_prev.ptr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if (l_uhp.item.uh_next.ptr).item.uh_walk /= l_nomark then
								if (l_uhp.item.uh_next.ptr).item.uh_walk /= l_mark then
									l_uhp.ce_gets (l_uhp.item.uh_next.ptr)
									l_changes := l_changes - 1
								else
									l_pos := -1 + 12 -- goto _L___1
								end
							else
								l_pos := -1 + 12 -- goto _L___1
							end
						else
							l_pos := -1 + 12 -- goto _L___1
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___1:
						l_uhp.item.uh_walk := l_nomark
						if ((l_uhp.item.uh_alt_prev.ptr).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_uhp.ce_gets (l_uhp.item.uh_alt_prev.ptr)
						else
							l_uhp.ce_gets (l_uhp.item.uh_next.ptr)
							l_changes := l_changes - 1
						end
				when 13 then -- if done | if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 14 then -- loop done
					js.reset
					if l_ga.ga_len = 0 then
						message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Nothing to undo"))))).do_nothing
					else
						misc2_inst.sort_strings (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_ga.ga_data), l_ga.ga_len)
						message_inst.msg_start
						message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("number changes  time            saved")))), globals_inst.highlight_attr[14])
						l_i___0 := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if l_i___0 < l_ga.ga_len then
								if globals_inst.got_int.to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								message_inst.msg_putchar (('%N').code)
								if globals_inst.got_int.to_boolean then
									js.break
								end
							end
							if not js.loop_jumped then
								message_inst.msg_puts (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_ga.ga_data)[l_i___0])
								l_i___0 := l_i___0 + 1
							end
						end
						js.reset
						message_inst.msg_end.do_nothing
						misc2_inst.ga_clear_strings (l_ga.address)
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_undolist_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_undolist)
		end

	u_add_time (a_buf___6: CE_POINTER [NATURAL_8]; a_buflen: NATURAL_32; a_tt: INTEGER_32)
		local
			l_tt: INTEGER_32
			l_curtime: CE_POINTER [SD_TM]
			l_tmp: INTEGER_32
		do
			create l_curtime.make

			l_tt := a_tt
			if (time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))) - l_tt >= 100 then
				l_curtime.ce_gets (localtime ((create {CE_POINTER [INTEGER_32]}.make_shared ($l_tt))))
				strftime (create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6), a_buflen, ce_string ("%%H:%%M:%%S"), l_curtime).do_nothing
			else
				l_tmp := time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
				message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6), a_buflen, (gettext (ce_string ("%%ld seconds ago"))), l_tmp - l_tt]).do_nothing
			end
		end

	ex_undojoin (a_eap: CE_POINTER [PD_EXARG])
		local
			js: JUMP_STATE
		do
			if ((globals_inst.curbuf.item.b_u_newhead).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called and then (((globals_inst.curbuf.item.b_u_curhead).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32) then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E790: undojoin is not allowed after undo"))))).do_nothing
				js.return
			end
			if not js.return_called and then (not (globals_inst.curbuf.item.b_u_synced).to_boolean) then
				js.return
			end
			if not js.return_called then
				if option_inst.p_ul < 0 then
					js.return
				else
					globals_inst.curbuf.item.b_u_curhead := globals_inst.curbuf.item.b_u_newhead
					globals_inst.curbuf.item.b_u_synced := 0
				end
			end
			if not js.return_called then
			end
		end

	ex_undojoin_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_undojoin)
		end

	u_unchanged (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		do
			u_unch_branch (a_buf___6.item.b_u_oldhead)
			a_buf___6.item.b_did_warn := 0
		end

	u_find_first_changed
		local
			l_uhp: CE_POINTER [PD_U_HEADER]
			l_uep: CE_POINTER [PD_U_ENTRY]
			l_lnum: INTEGER_32
			js: JUMP_STATE
		do
			create l_uhp.make
			create l_uep.make

			l_uhp.ce_gets (globals_inst.curbuf.item.b_u_newhead)
			if ((globals_inst.curbuf.item.b_u_curhead).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				js.return
			elseif (l_uhp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				l_uep.ce_gets (l_uhp.item.uh_entry)
				if l_uep.item.ue_top /= 0 then
					js.return
				elseif l_uep.item.ue_bot /= 0 then
					js.return
				end
			end
			if not js.return_called then
				l_lnum := (1).to_integer_32
				from
				until
					js.loop_left
				loop
					js.reset
					if l_lnum < globals_inst.curbuf.item.b_ml.ml_line_count then
						if not (l_lnum <= l_uep.item.ue_size) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast ((memline_inst.ml_get_buf (globals_inst.curbuf, l_lnum, 0))), create {CE_POINTER [INTEGER_8]}.make_cast (l_uep.item.ue_array[(l_lnum - 1)]))) /= 0 then
							l_uhp.item.uh_cursor.lnum := (0).to_integer_32
							l_uhp.item.uh_cursor.col := 0
							l_uhp.item.uh_cursor.coladd := 0
							l_uhp.item.uh_cursor.lnum := l_lnum
							js.return
						end
						if not js.return_called then
							l_lnum := l_lnum + 1
						end
					end
				end
				js.reset
			end
			if not js.return_called and then (globals_inst.curbuf.item.b_ml.ml_line_count /= l_uep.item.ue_size) then
				l_uhp.item.uh_cursor.lnum := (0).to_integer_32
				l_uhp.item.uh_cursor.col := 0
				l_uhp.item.uh_cursor.coladd := 0
				l_uhp.item.uh_cursor.lnum := l_lnum
			end
		end

	u_update_save_nr (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		local
			l_uhp: CE_POINTER [PD_U_HEADER]
		do
			create l_uhp.make

			a_buf___6.item.b_u_save_nr_last := (a_buf___6.item.b_u_save_nr_last) + 1
			a_buf___6.item.b_u_save_nr_cur := a_buf___6.item.b_u_save_nr_last
			l_uhp.ce_gets (a_buf___6.item.b_u_curhead)
			if (l_uhp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_uhp.ce_gets (l_uhp.item.uh_next.ptr)
			else
				l_uhp.ce_gets (a_buf___6.item.b_u_newhead)
			end
			if (l_uhp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_uhp.item.uh_save_nr := a_buf___6.item.b_u_save_nr_last
			end
		end

	u_unch_branch (a_uhp: CE_POINTER [PD_U_HEADER])
		local
			l_uh: CE_POINTER [PD_U_HEADER]
		do
			create l_uh.make

			l_uh.ce_gets (a_uhp)
			from
			until
				(l_uh.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
			loop
				l_uh.item.uh_flags := (l_uh.item.uh_flags).bit_or ((1))
				if ((l_uh.item.uh_alt_next.ptr).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					u_unch_branch (l_uh.item.uh_alt_next.ptr)
				end
				l_uh.ce_gets (l_uh.item.uh_prev.ptr)
			end
		end

	u_get_headentry: CE_POINTER [PD_U_ENTRY]
		local
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_tmp.make

			if ((globals_inst.curbuf.item.b_u_newhead).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_tmp.ce_gets (gettext (ce_string ("E439: undo list corrupt")))
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
				Result := (create {CE_POINTER [PD_U_ENTRY]}.make_shared (default_pointer))
				js.return
			elseif (((globals_inst.curbuf.item.b_u_newhead).item.uh_entry).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_tmp.ce_gets (gettext (ce_string ("E439: undo list corrupt")))
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
				Result := (create {CE_POINTER [PD_U_ENTRY]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				Result := ((globals_inst.curbuf.item.b_u_newhead).item.uh_entry)
			end
		end

	u_getbot
		local
			l_uep: CE_POINTER [PD_U_ENTRY]
			l_extra: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_uep.make
			create l_tmp.make

			l_uep.ce_gets (u_get_headentry)
			if (l_uep.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				l_uep.ce_gets ((globals_inst.curbuf.item.b_u_newhead).item.uh_getbot_entry)
				if (l_uep.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					l_extra := globals_inst.curbuf.item.b_ml.ml_line_count - l_uep.item.ue_lcount
					l_uep.item.ue_bot := ((l_uep.item.ue_top + l_uep.item.ue_size) + 1) + l_extra
					if l_uep.item.ue_bot < 1 then
						l_tmp.ce_gets (gettext (ce_string ("E440: undo line missing")))
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
						l_uep.item.ue_bot := l_uep.item.ue_top + 1
					elseif l_uep.item.ue_bot > globals_inst.curbuf.item.b_ml.ml_line_count then
						l_tmp.ce_gets (gettext (ce_string ("E440: undo line missing")))
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
						l_uep.item.ue_bot := l_uep.item.ue_top + 1
					end
					(globals_inst.curbuf.item.b_u_newhead).item.uh_getbot_entry := create {CE_POINTER [PD_U_ENTRY]}.make_shared (default_pointer)
				end
				globals_inst.curbuf.item.b_u_synced := 1
			end
		end

	u_freeheader (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_uhp: CE_POINTER [PD_U_HEADER]; a_uhpp: CE_POINTER [CE_POINTER [PD_U_HEADER]])
		local
			l_uhap: CE_POINTER [PD_U_HEADER]
		do
			create l_uhap.make

			if ((a_uhp.item.uh_alt_next.ptr).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				u_freebranch (a_buf___6, a_uhp.item.uh_alt_next.ptr, a_uhpp)
			end
			if ((a_uhp.item.uh_alt_prev.ptr).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				(a_uhp.item.uh_alt_prev.ptr).item.uh_alt_next.ptr := create {CE_POINTER [PD_U_HEADER]}.make_shared (default_pointer)
			end
			if ((a_uhp.item.uh_next.ptr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				a_buf___6.item.b_u_oldhead := a_uhp.item.uh_prev.ptr
			else
				(a_uhp.item.uh_next.ptr).item.uh_prev.ptr := a_uhp.item.uh_prev.ptr
			end
			if ((a_uhp.item.uh_prev.ptr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				a_buf___6.item.b_u_newhead := a_uhp.item.uh_next.ptr
			else
				l_uhap.ce_gets (a_uhp.item.uh_prev.ptr)
				from
				until
					(l_uhap.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
				loop
					l_uhap.item.uh_next.ptr := a_uhp.item.uh_next.ptr
					l_uhap.ce_gets (l_uhap.item.uh_alt_next.ptr)
				end
			end
			u_freeentries (a_buf___6, a_uhp, a_uhpp)
		end

	u_freebranch (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_uhp: CE_POINTER [PD_U_HEADER]; a_uhpp: CE_POINTER [CE_POINTER [PD_U_HEADER]])
		local
			l_tofree: CE_POINTER [PD_U_HEADER]
			l_next: CE_POINTER [PD_U_HEADER]
			js: JUMP_STATE
		do
			create l_tofree.make
			create l_next.make

			if (a_uhp.c_pointer.to_integer_32).to_natural_32 = ((a_buf___6.item.b_u_oldhead).c_pointer.to_integer_32).to_natural_32 then
				u_freeheader (a_buf___6, a_uhp, a_uhpp)
				js.return
			end
			if not js.return_called then
				if ((a_uhp.item.uh_alt_prev.ptr).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					(a_uhp.item.uh_alt_prev.ptr).item.uh_alt_next.ptr := create {CE_POINTER [PD_U_HEADER]}.make_shared (default_pointer)
				end
				l_next.ce_gets (a_uhp)
				from
				until
					(l_next.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
				loop
					l_tofree.ce_gets (l_next)
					if ((l_tofree.item.uh_alt_next.ptr).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						u_freebranch (a_buf___6, l_tofree.item.uh_alt_next.ptr, a_uhpp)
					end
					l_next.ce_gets (l_tofree.item.uh_prev.ptr)
					u_freeentries (a_buf___6, l_tofree, a_uhpp)
				end
			end
		end

	u_freeentries (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_uhp: CE_POINTER [PD_U_HEADER]; a_uhpp: CE_POINTER [CE_POINTER [PD_U_HEADER]])
		local
			l_uep: CE_POINTER [PD_U_ENTRY]
			l_nuep: CE_POINTER [PD_U_ENTRY]
		do
			create l_uep.make
			create l_nuep.make

			if ((a_buf___6.item.b_u_curhead).c_pointer.to_integer_32).to_natural_32 = (a_uhp.c_pointer.to_integer_32).to_natural_32 then
				a_buf___6.item.b_u_curhead := create {CE_POINTER [PD_U_HEADER]}.make_shared (default_pointer)
			end
			if ((a_buf___6.item.b_u_newhead).c_pointer.to_integer_32).to_natural_32 = (a_uhp.c_pointer.to_integer_32).to_natural_32 then
				a_buf___6.item.b_u_newhead := create {CE_POINTER [PD_U_HEADER]}.make_shared (default_pointer)
			end
			if (a_uhpp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (a_uhp.c_pointer.to_integer_32).to_natural_32 = ((a_uhpp.item).c_pointer.to_integer_32).to_natural_32 then
					a_uhpp.item := create {CE_POINTER [PD_U_HEADER]}.make_shared (default_pointer)
				end
			end
			l_uep.ce_gets (a_uhp.item.uh_entry)
			from
			until
				(l_uep.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
			loop
				l_nuep.ce_gets (l_uep.item.ue_next)
				u_freeentry (l_uep, l_uep.item.ue_size)
				l_uep.ce_gets (l_nuep)
			end
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_uhp))
			a_buf___6.item.b_u_numhead := (a_buf___6.item.b_u_numhead) - 1
		end

	u_freeentry (a_uep: CE_POINTER [PD_U_ENTRY]; a_n: INTEGER_32)
		local
			l_n: INTEGER_32
		do
			l_n := a_n
			from
			until
				not (l_n > 0)
			loop
				l_n := l_n - 1
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_uep.item.ue_array[l_n]))
			end
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_uep.item.ue_array))
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_uep))
		end

	u_clearall (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		local
			l_tmp: CE_POINTER [PD_U_HEADER]
			l_tmp___0: CE_POINTER [PD_U_HEADER]
		do
			create l_tmp.make
			create l_tmp___0.make

			l_tmp___0.ce_gets (create {CE_POINTER [PD_U_HEADER]}.make_shared (default_pointer))
			a_buf___6.item.b_u_curhead := l_tmp___0
			l_tmp.ce_gets (l_tmp___0)
			a_buf___6.item.b_u_oldhead := l_tmp
			a_buf___6.item.b_u_newhead := l_tmp
			a_buf___6.item.b_u_synced := 1
			a_buf___6.item.b_u_numhead := 0
			a_buf___6.item.b_u_line_ptr := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			a_buf___6.item.b_u_line_lnum := (0).to_integer_32
		end

	u_saveline (a_lnum: INTEGER_32)
		local
			l_tmp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_tmp.make

			if a_lnum = globals_inst.curbuf.item.b_u_line_lnum then
				js.return
			end
			if not js.return_called then
				if a_lnum < 1 then
					js.return
				elseif a_lnum > globals_inst.curbuf.item.b_ml.ml_line_count then
					js.return
				end
			end
			if not js.return_called then
				u_clearline
				globals_inst.curbuf.item.b_u_line_lnum := a_lnum
				if globals_inst.curwin.item.w_cursor.lnum = a_lnum then
					globals_inst.curbuf.item.b_u_line_colnr := globals_inst.curwin.item.w_cursor.col
				else
					globals_inst.curbuf.item.b_u_line_colnr := 0
				end
				l_tmp.ce_gets (u_save_line (a_lnum))
				globals_inst.curbuf.item.b_u_line_ptr := l_tmp
				if (l_tmp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					misc2_inst.do_outofmem_msg ((0).to_natural_32)
				end
			end
		end

	u_clearline
		do
			if ((globals_inst.curbuf.item.b_u_line_ptr).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.curbuf.item.b_u_line_ptr))
				globals_inst.curbuf.item.b_u_line_ptr := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				globals_inst.curbuf.item.b_u_line_lnum := (0).to_integer_32
			end
		end

	u_undoline
		local
			l_t: INTEGER_32
			l_oldp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_oldp.make

			if globals_inst.undo_off.to_boolean then
				js.return
			end
			if not js.return_called then
				if ((globals_inst.curbuf.item.b_u_line_ptr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					misc1_inst.beep_flush
					js.return
				elseif globals_inst.curbuf.item.b_u_line_lnum > globals_inst.curbuf.item.b_ml.ml_line_count then
					misc1_inst.beep_flush
					js.return
				end
			end
			if not js.return_called then
				if (u_savecommon (globals_inst.curbuf.item.b_u_line_lnum - 1, globals_inst.curbuf.item.b_u_line_lnum + 1, (0).to_integer_32, 0)) = 0 then
					js.return
				end
			end
			if not js.return_called then
				l_oldp.ce_gets (u_save_line (globals_inst.curbuf.item.b_u_line_lnum))
				if (l_oldp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					misc2_inst.do_outofmem_msg ((0).to_natural_32)
					js.return
				end
			end
			if not js.return_called then
				memline_inst.ml_replace (globals_inst.curbuf.item.b_u_line_lnum, globals_inst.curbuf.item.b_u_line_ptr, 1).do_nothing
				misc1_inst.changed_bytes (globals_inst.curbuf.item.b_u_line_lnum, 0)
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.curbuf.item.b_u_line_ptr))
				globals_inst.curbuf.item.b_u_line_ptr := l_oldp
				l_t := globals_inst.curbuf.item.b_u_line_colnr
				if globals_inst.curwin.item.w_cursor.lnum = globals_inst.curbuf.item.b_u_line_lnum then
					globals_inst.curbuf.item.b_u_line_colnr := globals_inst.curwin.item.w_cursor.col
				end
				globals_inst.curwin.item.w_cursor.col := l_t
				globals_inst.curwin.item.w_cursor.lnum := globals_inst.curbuf.item.b_u_line_lnum
				misc2_inst.check_cursor_col
			end
		end

	u_blockfree (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		do
			from
			until
				((a_buf___6.item.b_u_oldhead).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
			loop
				u_freeheader (a_buf___6, a_buf___6.item.b_u_oldhead, create {CE_POINTER [CE_POINTER [PD_U_HEADER]]}.make_shared (default_pointer))
			end
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_buf___6.item.b_u_line_ptr))
		end

	u_save_line (a_lnum: INTEGER_32): CE_POINTER [NATURAL_8]
		do
			Result := (misc2_inst.vim_strsave ((memline_inst.ml_get (a_lnum))))
		end

	bufIsChanged (a_buf___6: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if (quickfix_inst.bt_dontwrite (a_buf___6)).to_boolean then
				l_tmp___1 := 0
			elseif (a_buf___6.item.b_changed).to_boolean then
				l_tmp___1 := 1
			elseif (option_inst.file_ff_differs (a_buf___6)).to_boolean then
				l_tmp___1 := 1
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	curbufIsChanged: INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if (quickfix_inst.bt_dontwrite (globals_inst.curbuf)).to_boolean then
				l_tmp___1 := 0
			elseif (globals_inst.curbuf.item.b_changed).to_boolean then
				l_tmp___1 := 1
			elseif (option_inst.file_ff_differs (globals_inst.curbuf)).to_boolean then
				l_tmp___1 := 1
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	u_eval_tree (a_first_uhp: CE_POINTER [PD_U_HEADER]; a_list: CE_POINTER [PD_LISTVAR_S])
		local
			l_uhp: CE_POINTER [PD_U_HEADER]
			l_dict: CE_POINTER [PD_DICTVAR_S]
			l_alt_list: CE_POINTER [PD_LISTVAR_S]
			js: JUMP_STATE
		do
			create l_uhp.make
			create l_dict.make
			create l_alt_list.make

			l_uhp.ce_gets (a_first_uhp)
			from
			until
				not (not js.loop_left and then ((l_uhp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				l_dict.ce_gets (eval_inst.dict_alloc)
				if (l_dict.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					js.return
				end
				if not js.return_called then
					eval_inst.dict_add_nr_str (l_dict, ce_string ("seq"), l_uhp.item.uh_seq, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
					eval_inst.dict_add_nr_str (l_dict, ce_string ("time"), l_uhp.item.uh_time, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
					if (l_uhp.c_pointer.to_integer_32).to_natural_32 = ((globals_inst.curbuf.item.b_u_newhead).c_pointer.to_integer_32).to_natural_32 then
						eval_inst.dict_add_nr_str (l_dict, ce_string ("newhead"), 1, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
					end
					if (l_uhp.c_pointer.to_integer_32).to_natural_32 = ((globals_inst.curbuf.item.b_u_curhead).c_pointer.to_integer_32).to_natural_32 then
						eval_inst.dict_add_nr_str (l_dict, ce_string ("curhead"), 1, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
					end
					if l_uhp.item.uh_save_nr > 0 then
						eval_inst.dict_add_nr_str (l_dict, ce_string ("save"), l_uhp.item.uh_save_nr, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
					end
					if ((l_uhp.item.uh_alt_next.ptr).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_alt_list.ce_gets ((eval_inst.list_alloc))
						if (l_alt_list.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							u_eval_tree (l_uhp.item.uh_alt_next.ptr, l_alt_list)
							eval_inst.dict_add_list (l_dict, ce_string ("alt"), l_alt_list).do_nothing
						end
					end
					eval_inst.list_append_dict (a_list, l_dict).do_nothing
					l_uhp.ce_gets (l_uhp.item.uh_prev.ptr)
				end
			end
			if not js.return_called then
			end
		end

end
