class
	P_VERSION

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create Version.make
			create mediumVersion.make
			create longVersion.make
			create features.make (<<110>>)
			create included_patches.make (<<1>>)
			create extra_patches.make (<<1>>)
			create lines.make (<<17>>)
			create gui_lines.make (<<17>>)
		end

feature {ANY} -- attributes

	Version: CE_POINTER [INTEGER_8]

	mediumVersion: CE_POINTER [INTEGER_8]

	longVersion: CE_POINTER [INTEGER_8]

	features: CE_ARRAY [CE_POINTER [INTEGER_8]]

	included_patches: CE_ARRAY [INTEGER_32]

	extra_patches: CE_ARRAY [CE_POINTER [INTEGER_8]]

	lines: CE_ARRAY [CE_POINTER [INTEGER_8]]

	gui_lines: CE_ARRAY [CE_POINTER [INTEGER_8]]

feature {ANY} -- routines

	highest_patch: INTEGER_32
		local
			l_i___0: INTEGER_32
			l_h: INTEGER_32
		do
			l_h := 0
			l_i___0 := 0
			from
			until
				included_patches[l_i___0] = 0
			loop
				if included_patches[l_i___0] > l_h then
					l_h := included_patches[l_i___0]
				end
				l_i___0 := l_i___0 + 1
			end
			Result := l_h
		end

	has_patch (a_n: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (included_patches[l_i___0] /= 0))
			loop
				if included_patches[l_i___0] = a_n then
					Result := 1
					js.return
				end
				if not js.return_called then
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	ex_version (a_eap: CE_POINTER [PD_EXARG])
		do
			if ((a_eap.item.arg).item).to_integer_32 = 0 then
				message_inst.msg_putchar (('%N').code)
				list_version
			end
		end

	ex_version_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_version)
		end

	list_version
		local
			l_i___0: INTEGER_32
			l_first___0: INTEGER_32
			l_s: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s.ce_gets (ce_string (""))
					message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast (longVersion)).do_nothing
					if included_patches[0] = 0 then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%NIncluded patches: ")))))
						l_first___0 := -1
						l_i___0 := 0
						from
						until
							included_patches[l_i___0] = 0
						loop
							l_i___0 := l_i___0 + 1
						end
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						l_i___0 := l_i___0 - 1
						if not (l_i___0 >= 0) then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if l_first___0 < 0 then
							l_first___0 := included_patches[l_i___0]
						end
						if l_i___0 /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if included_patches[l_i___0 - 1] = included_patches[l_i___0] + 1 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (l_s))
						l_s.ce_gets (ce_string (", "))
						message_inst.msg_outnum (l_first___0.to_integer_32)
						if l_first___0 /= included_patches[l_i___0] then
							message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("-")))
							message_inst.msg_outnum ((included_patches[l_i___0]).to_integer_32)
						end
						l_first___0 := -1
				when 9 then -- if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						js.reset
				when 11 then -- if done
					if ((extra_patches[0]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%NExtra patches: ")))))
						l_s.ce_gets (ce_string (""))
						l_i___0 := 0
						from
						until
							((extra_patches[l_i___0]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
						loop
							message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (l_s))
							l_s.ce_gets (ce_string (", "))
							message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (extra_patches[l_i___0]))
							l_i___0 := l_i___0 + 1
						end
					end
					if (auto_pathdef_inst.compiled_user.item).to_integer_32 = 0 then
						l_pos := -1 + 14 -- skip if block
					end
				when 12 then -- if:
						l_pos := -1 + 15 -- goto _L___0
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 14 then -- else:
						if (auto_pathdef_inst.compiled_sys.item).to_integer_32 = 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 15 then -- if: | _L___0:
						message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%NCompiled ")))))
						if (auto_pathdef_inst.compiled_user.item).to_integer_32 /= 0 then
							message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("by ")))))
							message_inst.msg_puts (auto_pathdef_inst.compiled_user)
						end
						if (auto_pathdef_inst.compiled_sys.item).to_integer_32 /= 0 then
							message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("@")))
							message_inst.msg_puts (auto_pathdef_inst.compiled_sys)
						end
				when 16 then -- if done
						message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%NNormal version ")))))
						message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("with GTK2 GUI.")))))
						version_msg ((gettext (ce_string ("  Features included (+) or not (-):%N"))))
						l_i___0 := 0
						from
						until
							((features[l_i___0]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
						loop
							version_msg (features[l_i___0])
							if globals_inst.msg_col > 0 then
								version_msg (ce_string (" "))
							end
							l_i___0 := l_i___0 + 1
						end
						version_msg (ce_string ("%N"))
						version_msg ((gettext (ce_string ("   system vimrc file: %""))))
						version_msg (ce_string ("$VIM/vimrc"))
						version_msg (ce_string ("%"%N"))
						version_msg ((gettext (ce_string ("     user vimrc file: %""))))
						version_msg (ce_string ("$HOME/.vimrc"))
						version_msg (ce_string ("%"%N"))
						version_msg ((gettext (ce_string ("      user exrc file: %""))))
						version_msg (ce_string ("$HOME/.exrc"))
						version_msg (ce_string ("%"%N"))
						version_msg ((gettext (ce_string ("  system gvimrc file: %""))))
						version_msg (ce_string ("$VIM/gvimrc"))
						version_msg (ce_string ("%"%N"))
						version_msg ((gettext (ce_string ("    user gvimrc file: %""))))
						version_msg (ce_string ("$HOME/.gvimrc"))
						version_msg (ce_string ("%"%N"))
						version_msg ((gettext (ce_string ("    system menu file: %""))))
						version_msg (ce_string ("$VIMRUNTIME/menu.vim"))
						version_msg (ce_string ("%"%N"))
						if (auto_pathdef_inst.default_vim_dir.item).to_integer_32 /= 0 then
							version_msg ((gettext (ce_string ("  fall-back for $VIM: %""))))
							version_msg (create {CE_POINTER [INTEGER_8]}.make_cast (auto_pathdef_inst.default_vim_dir))
							version_msg (ce_string ("%"%N"))
						end
						if (auto_pathdef_inst.default_vimruntime_dir.item).to_integer_32 /= 0 then
							version_msg ((gettext (ce_string (" f-b for $VIMRUNTIME: %""))))
							version_msg (create {CE_POINTER [INTEGER_8]}.make_cast (auto_pathdef_inst.default_vimruntime_dir))
							version_msg (ce_string ("%"%N"))
						end
						version_msg ((gettext (ce_string ("Compilation: "))))
						version_msg (create {CE_POINTER [INTEGER_8]}.make_cast (auto_pathdef_inst.all_cflags))
						version_msg (ce_string ("%N"))
						version_msg ((gettext (ce_string ("Linking: "))))
						version_msg (create {CE_POINTER [INTEGER_8]}.make_cast (auto_pathdef_inst.all_lflags))
				when 17 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	version_msg (a_s: CE_POINTER [INTEGER_8])
		local
			l_len: INTEGER_32
		do
			l_len := (strlen (a_s)).to_integer_32
			if not globals_inst.got_int.to_boolean then
				if l_len < globals_inst.Columns.to_integer_32 then
					if globals_inst.msg_col + l_len >= globals_inst.Columns.to_integer_32 then
						if (a_s[0]).to_integer_32 /= 10 then
							message_inst.msg_putchar (('%N').code)
						end
					end
				end
			end
			if not globals_inst.got_int.to_boolean then
				message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (a_s))
			end
		end

	intro_message (a_colon: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_row: INTEGER_32
			l_blanklines: INTEGER_32
			l_sponsor: INTEGER_32
			l_p___0: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_blanklines := (globals_inst.Rows.to_natural_32 - ((Pointer_bytes.to_natural_32 * (17).to_natural_32) // Pointer_bytes.to_natural_32 - {NATURAL_32} 1)).to_integer_32
					if not option_inst.p_cp.to_boolean then
						l_blanklines := l_blanklines + (4)
					end
					if option_inst.p_ls > 1 then
						l_blanklines := (l_blanklines.to_integer_32 - (globals_inst.Rows - (globals_inst.topframe.item.fr_height).to_integer_32)).to_integer_32
					end
					if l_blanklines < 0 then
						l_blanklines := 0
					end
					l_sponsor := (time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))).to_integer_32
					l_sponsor := (((l_sponsor).bit_and (2)) = 0).to_integer - (((l_sponsor).bit_and (4)) = 0).to_integer
					l_row := l_blanklines // 2
					if not (l_row >= 2) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if globals_inst.Columns >= 50 then
							l_pos := -1 + 4 -- goto _L
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else: | _L___0:
						if not (a_colon.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_i___0 := 0
						from
						until
							not (not js.loop_left and then (l_i___0 < ((Pointer_bytes.to_natural_32 * (17).to_natural_32) // Pointer_bytes.to_natural_32).to_integer_32))
						loop
							js.reset
							l_p___0.ce_gets (lines[l_i___0])
							if option_inst.p_im.to_boolean then
								if (gui_inst.gui.in_use).to_boolean then
									if ((gui_lines[l_i___0]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										l_p___0.ce_gets (gui_lines[l_i___0])
									end
								end
							end
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								if not option_inst.p_cp.to_boolean then
									js.break
								end
								if not js.loop_jumped then
									js.continue
								end
							end
							if not js.loop_jumped then
								if l_sponsor /= 0 then
									if ((strstr (l_p___0, ce_string ("children"))).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										if l_sponsor < 0 then
											l_p___0.ce_gets (ce_string ("Sponsor Vim development!"))
										else
											l_p___0.ce_gets (ce_string ("Become a registered Vim user!"))
										end
									elseif ((strstr (l_p___0, ce_string ("iccf"))).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										if l_sponsor < 0 then
											l_p___0.ce_gets (ce_string ("type  :help sponsor<Enter>    for information "))
										else
											l_p___0.ce_gets (ce_string ("type  :help register<Enter>   for information "))
										end
									elseif ((strstr (l_p___0, ce_string ("Orphans"))).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										l_p___0.ce_gets (ce_string ("menu  Help->Sponsor/Register  for information    "))
									end
								end
								if (l_p___0[0]).to_integer_32 /= 0 then
									do_intro_line (l_row, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (l_p___0))), (l_i___0 = 2).to_integer, 0)
								end
								l_row := l_row + 1
							end
							if not js.loop_left then
								l_i___0 := l_i___0 + 1
							end
						end
						js.reset
				when 5 then -- if done
						if a_colon.to_boolean then
							globals_inst.msg_row := l_row
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	do_intro_line (a_row: INTEGER_32; a_mesg: CE_POINTER [NATURAL_8]; a_add_version: INTEGER_32; a_attr: INTEGER_32)
		local
			l_vers: CE_ARRAY [NATURAL_8]
			l_col: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_clen: INTEGER_32
			l_tmp___9: INTEGER_32
			js: JUMP_STATE
		do
			create l_vers.make (<<20>>)
			create l_p___0.make

			l_col := charset_inst.vim_strsize (a_mesg)
			if a_add_version.to_boolean then
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_vers), mediumVersion).do_nothing
				if (highest_patch).to_boolean then
					if ((((ctype_b_loc).item[(mediumVersion[3]).to_integer_32]).to_integer_32).bit_and (1024)).to_boolean then
						if ((((ctype_b_loc).item[(mediumVersion[4]).to_integer_32]).to_integer_32).bit_and (1024)).to_boolean then
							sprintf ([(create {CE_POINTER [INTEGER_8]}.make_cast (l_vers) + 5), ce_string (".%%d%%s"), (highest_patch), mediumVersion + 5]).do_nothing
						else
							sprintf ([(create {CE_POINTER [INTEGER_8]}.make_cast (l_vers) + 4), ce_string (".%%d%%s"), (highest_patch), mediumVersion + 4]).do_nothing
						end
					else
						sprintf ([(create {CE_POINTER [INTEGER_8]}.make_cast (l_vers) + 3), ce_string (".%%d"), (highest_patch)]).do_nothing
					end
				end
				l_col := l_col + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_vers))).to_integer_32
			end
			l_col := ((globals_inst.Columns - l_col.to_integer_32) // 2).to_integer_32
			if l_col < 0 then
				l_col := 0
			end
			l_p___0.ce_gets (a_mesg)
			from
			until
				not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0))
			loop
				l_clen := 0
				l_l := 0
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_p___0[l_l]).to_integer_32 /= 0 then
						if l_l /= 0 then
							if (l_p___0[l_l]).to_integer_32 /= 60 then
								if (l_p___0[(l_l - 1)]).to_integer_32 = 62 then
									js.break
								end
							else
								js.break
							end
						end
					else
						js.break
					end
					if not js.loop_jumped then
						if globals_inst.has_mbyte.to_boolean then
							l_clen := l_clen + (charset_inst.ptr2cells (l_p___0 + l_l))
							l_l := l_l + ((globals_inst.mb_ptr2len.integer_32_item ([l_p___0 + l_l])) - 1)
						else
							l_clen := l_clen + (charset_inst.byte2cells ((l_p___0[l_l]).to_integer_32))
						end
						l_l := l_l + 1
					end
				end
				js.reset
				if (l_p___0.item).to_integer_32 = 60 then
					l_tmp___9 := globals_inst.highlight_attr[0]
				else
					l_tmp___9 := a_attr
				end
				screen_inst.screen_puts_len (l_p___0, l_l, a_row, l_col, l_tmp___9)
				l_col := l_col + l_clen
				l_p___0.ce_gets (l_p___0 + l_l)
			end
			if a_add_version.to_boolean then
				screen_inst.screen_puts (l_vers, a_row, l_col, 0)
			end
		end

	ex_intro (a_eap: CE_POINTER [PD_EXARG])
		do
			screen_inst.screenclear
			intro_message (1)
			message_inst.wait_return (1)
		end

	ex_intro_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_intro)
		end

end
