class
	SD_ATKOBJECT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent: SD_GOBJECT assign set_parent
		do
			create Result.make_shared (c_parent (c_pointer))
		end

	description: CE_POINTER [INTEGER_8] assign set_description
		do
			create Result.make_shared (c_description (c_pointer))
		end

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	accessible_parent: CE_POINTER [SD_ATKOBJECT] assign set_accessible_parent
		do
			create Result.make_shared (c_accessible_parent (c_pointer))
		end

	role: INTEGER_32 assign set_role
		do
			Result := c_role (c_pointer)
		end

	relation_set: CE_POINTER [SD_ATKRELATIONSET] assign set_relation_set
		do
			create Result.make_shared (c_relation_set (c_pointer))
		end

	layer: INTEGER_32 assign set_layer
		do
			Result := c_layer (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_parent (a_parent: SD_GOBJECT)
		do
			parent.ce_gets (a_parent)
		end

	set_description (a_description: CE_POINTER [INTEGER_8])
		do
			c_set_description (c_pointer, a_description.c_pointer)
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_accessible_parent (a_accessible_parent: CE_POINTER [SD_ATKOBJECT])
		do
			c_set_accessible_parent (c_pointer, a_accessible_parent.c_pointer)
		end

	set_role (a_role: INTEGER_32)
		do
			c_set_role (c_pointer, a_role)
		end

	set_relation_set (a_relation_set: CE_POINTER [SD_ATKRELATIONSET])
		do
			c_set_relation_set (c_pointer, a_relation_set.c_pointer)
		end

	set_layer (a_layer: INTEGER_32)
		do
			c_set_layer (c_pointer, a_layer)
		end

feature {NONE} -- C getters

	c_parent (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GObject *)&((struct _AtkObject *)$tmp)->parent;"
		end

	c_description (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _AtkObject *)$tmp)->description;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _AtkObject *)$tmp)->name;"
		end

	c_accessible_parent (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _AtkObject *)((struct _AtkObject *)$tmp)->accessible_parent;"
		end

	c_role (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _AtkObject *)$tmp)->role;"
		end

	c_relation_set (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _AtkRelationSet *)((struct _AtkObject *)$tmp)->relation_set;"
		end

	c_layer (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _AtkObject *)$tmp)->layer;"
		end

feature {NONE} -- C setters

	c_set_description (tmp: POINTER; a_description: POINTER)
		external
			"C inline"
		alias
			"((struct _AtkObject *)$tmp)->description = (char *)$a_description;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct _AtkObject *)$tmp)->name = (char *)$a_name;"
		end

	c_set_accessible_parent (tmp: POINTER; a_accessible_parent: POINTER)
		external
			"C inline"
		alias
			"((struct _AtkObject *)$tmp)->accessible_parent = (struct _AtkObject *)$a_accessible_parent;"
		end

	c_set_role (tmp: POINTER; a_role: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _AtkObject *)$tmp)->role = $a_role;"
		end

	c_set_relation_set (tmp: POINTER; a_relation_set: POINTER)
		external
			"C inline"
		alias
			"((struct _AtkObject *)$tmp)->relation_set = (struct _AtkRelationSet *)$a_relation_set;"
		end

	c_set_layer (tmp: POINTER; a_layer: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _AtkObject *)$tmp)->layer = $a_layer;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _AtkObject);"
		end

end
