class
	SD_D

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	char_data: INTEGER_8 assign set_char_data
		do
			Result := c_char_data (c_pointer)
		end

	uchar_data: NATURAL_8 assign set_uchar_data
		do
			Result := c_uchar_data (c_pointer)
		end

	bool_data: INTEGER_32 assign set_bool_data
		do
			Result := c_bool_data (c_pointer)
		end

	int_data: INTEGER_32 assign set_int_data
		do
			Result := c_int_data (c_pointer)
		end

	uint_data: NATURAL_32 assign set_uint_data
		do
			Result := c_uint_data (c_pointer)
		end

	long_data: INTEGER_32 assign set_long_data
		do
			Result := c_long_data (c_pointer)
		end

	ulong_data: NATURAL_32 assign set_ulong_data
		do
			Result := c_ulong_data (c_pointer)
		end

	float_data: REAL_32 assign set_float_data
		do
			Result := c_float_data (c_pointer)
		end

	double_data: REAL_64 assign set_double_data
		do
			Result := c_double_data (c_pointer)
		end

	string_data: CE_POINTER [INTEGER_8] assign set_string_data
		do
			create Result.make_shared (c_string_data (c_pointer))
		end

	object_data: CE_POINTER [SD_GTKOBJECT] assign set_object_data
		do
			create Result.make_shared (c_object_data (c_pointer))
		end

	pointer_data: CE_POINTER [ANY] assign set_pointer_data
		do
			create Result.make_shared (c_pointer_data (c_pointer))
		end

	signal_data: SD_SIGNAL_DATA assign set_signal_data
		do
			create Result.make_shared (c_signal_data (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_char_data (a_char_data: INTEGER_8)
		do
			c_set_char_data (c_pointer, a_char_data)
		end

	set_uchar_data (a_uchar_data: NATURAL_8)
		do
			c_set_uchar_data (c_pointer, a_uchar_data)
		end

	set_bool_data (a_bool_data: INTEGER_32)
		do
			c_set_bool_data (c_pointer, a_bool_data)
		end

	set_int_data (a_int_data: INTEGER_32)
		do
			c_set_int_data (c_pointer, a_int_data)
		end

	set_uint_data (a_uint_data: NATURAL_32)
		do
			c_set_uint_data (c_pointer, a_uint_data)
		end

	set_long_data (a_long_data: INTEGER_32)
		do
			c_set_long_data (c_pointer, a_long_data)
		end

	set_ulong_data (a_ulong_data: NATURAL_32)
		do
			c_set_ulong_data (c_pointer, a_ulong_data)
		end

	set_float_data (a_float_data: REAL_32)
		do
			c_set_float_data (c_pointer, a_float_data)
		end

	set_double_data (a_double_data: REAL_64)
		do
			c_set_double_data (c_pointer, a_double_data)
		end

	set_string_data (a_string_data: CE_POINTER [INTEGER_8])
		do
			c_set_string_data (c_pointer, a_string_data.c_pointer)
		end

	set_object_data (a_object_data: CE_POINTER [SD_GTKOBJECT])
		do
			c_set_object_data (c_pointer, a_object_data.c_pointer)
		end

	set_pointer_data (a_pointer_data: CE_POINTER [ANY])
		do
			c_set_pointer_data (c_pointer, a_pointer_data.c_pointer)
		end

	set_signal_data (a_signal_data: SD_SIGNAL_DATA)
		do
			signal_data.ce_gets (a_signal_data)
		end

feature {NONE} -- C getters

	c_char_data (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((union __anonunion_d_306 *)$tmp)->char_data;"
		end

	c_uchar_data (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((union __anonunion_d_306 *)$tmp)->uchar_data;"
		end

	c_bool_data (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union __anonunion_d_306 *)$tmp)->bool_data;"
		end

	c_int_data (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union __anonunion_d_306 *)$tmp)->int_data;"
		end

	c_uint_data (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((union __anonunion_d_306 *)$tmp)->uint_data;"
		end

	c_long_data (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((union __anonunion_d_306 *)$tmp)->long_data;"
		end

	c_ulong_data (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((union __anonunion_d_306 *)$tmp)->ulong_data;"
		end

	c_float_data (tmp: POINTER): REAL_32
		external
			"C inline"
		alias
			"return (float)((union __anonunion_d_306 *)$tmp)->float_data;"
		end

	c_double_data (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((union __anonunion_d_306 *)$tmp)->double_data;"
		end

	c_string_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((union __anonunion_d_306 *)$tmp)->string_data;"
		end

	c_object_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkObject *)((union __anonunion_d_306 *)$tmp)->object_data;"
		end

	c_pointer_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((union __anonunion_d_306 *)$tmp)->pointer_data;"
		end

	c_signal_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct_signal_data_307 *)&((union __anonunion_d_306 *)$tmp)->signal_data;"
		end

feature {NONE} -- C setters

	c_set_char_data (tmp: POINTER; a_char_data: INTEGER_8)
		external
			"C inline"
		alias
			"((union __anonunion_d_306 *)$tmp)->char_data = $a_char_data;"
		end

	c_set_uchar_data (tmp: POINTER; a_uchar_data: NATURAL_8)
		external
			"C inline"
		alias
			"((union __anonunion_d_306 *)$tmp)->uchar_data = $a_uchar_data;"
		end

	c_set_bool_data (tmp: POINTER; a_bool_data: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_d_306 *)$tmp)->bool_data = $a_bool_data;"
		end

	c_set_int_data (tmp: POINTER; a_int_data: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_d_306 *)$tmp)->int_data = $a_int_data;"
		end

	c_set_uint_data (tmp: POINTER; a_uint_data: NATURAL_32)
		external
			"C inline"
		alias
			"((union __anonunion_d_306 *)$tmp)->uint_data = $a_uint_data;"
		end

	c_set_long_data (tmp: POINTER; a_long_data: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_d_306 *)$tmp)->long_data = $a_long_data;"
		end

	c_set_ulong_data (tmp: POINTER; a_ulong_data: NATURAL_32)
		external
			"C inline"
		alias
			"((union __anonunion_d_306 *)$tmp)->ulong_data = $a_ulong_data;"
		end

	c_set_float_data (tmp: POINTER; a_float_data: REAL_32)
		external
			"C inline"
		alias
			"((union __anonunion_d_306 *)$tmp)->float_data = $a_float_data;"
		end

	c_set_double_data (tmp: POINTER; a_double_data: REAL_64)
		external
			"C inline"
		alias
			"((union __anonunion_d_306 *)$tmp)->double_data = $a_double_data;"
		end

	c_set_string_data (tmp: POINTER; a_string_data: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_d_306 *)$tmp)->string_data = (char *)$a_string_data;"
		end

	c_set_object_data (tmp: POINTER; a_object_data: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_d_306 *)$tmp)->object_data = (struct _GtkObject *)$a_object_data;"
		end

	c_set_pointer_data (tmp: POINTER; a_pointer_data: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_d_306 *)$tmp)->pointer_data = (void *)$a_pointer_data;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(union __anonunion_d_306);"
		end

end
