class
	SD_DATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	v_int: INTEGER_32 assign set_v_int
		do
			Result := c_v_int (c_pointer)
		end

	v_uint: NATURAL_32 assign set_v_uint
		do
			Result := c_v_uint (c_pointer)
		end

	v_long: INTEGER_32 assign set_v_long
		do
			Result := c_v_long (c_pointer)
		end

	v_ulong: NATURAL_32 assign set_v_ulong
		do
			Result := c_v_ulong (c_pointer)
		end

	v_int64: INTEGER_64 assign set_v_int64
		do
			Result := c_v_int64 (c_pointer)
		end

	v_uint64: NATURAL_64 assign set_v_uint64
		do
			Result := c_v_uint64 (c_pointer)
		end

	v_float: REAL_32 assign set_v_float
		do
			Result := c_v_float (c_pointer)
		end

	v_double: REAL_64 assign set_v_double
		do
			Result := c_v_double (c_pointer)
		end

	v_pointer: CE_POINTER [ANY] assign set_v_pointer
		do
			create Result.make_shared (c_v_pointer (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_v_int (a_v_int: INTEGER_32)
		do
			c_set_v_int (c_pointer, a_v_int)
		end

	set_v_uint (a_v_uint: NATURAL_32)
		do
			c_set_v_uint (c_pointer, a_v_uint)
		end

	set_v_long (a_v_long: INTEGER_32)
		do
			c_set_v_long (c_pointer, a_v_long)
		end

	set_v_ulong (a_v_ulong: NATURAL_32)
		do
			c_set_v_ulong (c_pointer, a_v_ulong)
		end

	set_v_int64 (a_v_int64: INTEGER_64)
		do
			c_set_v_int64 (c_pointer, a_v_int64)
		end

	set_v_uint64 (a_v_uint64: NATURAL_64)
		do
			c_set_v_uint64 (c_pointer, a_v_uint64)
		end

	set_v_float (a_v_float: REAL_32)
		do
			c_set_v_float (c_pointer, a_v_float)
		end

	set_v_double (a_v_double: REAL_64)
		do
			c_set_v_double (c_pointer, a_v_double)
		end

	set_v_pointer (a_v_pointer: CE_POINTER [ANY])
		do
			c_set_v_pointer (c_pointer, a_v_pointer.c_pointer)
		end

feature {NONE} -- C getters

	c_v_int (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union __anonunion_data_127 *)$tmp)->v_int;"
		end

	c_v_uint (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((union __anonunion_data_127 *)$tmp)->v_uint;"
		end

	c_v_long (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((union __anonunion_data_127 *)$tmp)->v_long;"
		end

	c_v_ulong (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((union __anonunion_data_127 *)$tmp)->v_ulong;"
		end

	c_v_int64 (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((union __anonunion_data_127 *)$tmp)->v_int64;"
		end

	c_v_uint64 (tmp: POINTER): NATURAL_64
		external
			"C inline"
		alias
			"return (unsigned long long)((union __anonunion_data_127 *)$tmp)->v_uint64;"
		end

	c_v_float (tmp: POINTER): REAL_32
		external
			"C inline"
		alias
			"return (float)((union __anonunion_data_127 *)$tmp)->v_float;"
		end

	c_v_double (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((union __anonunion_data_127 *)$tmp)->v_double;"
		end

	c_v_pointer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((union __anonunion_data_127 *)$tmp)->v_pointer;"
		end

feature {NONE} -- C setters

	c_set_v_int (tmp: POINTER; a_v_int: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_data_127 *)$tmp)->v_int = $a_v_int;"
		end

	c_set_v_uint (tmp: POINTER; a_v_uint: NATURAL_32)
		external
			"C inline"
		alias
			"((union __anonunion_data_127 *)$tmp)->v_uint = $a_v_uint;"
		end

	c_set_v_long (tmp: POINTER; a_v_long: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_data_127 *)$tmp)->v_long = $a_v_long;"
		end

	c_set_v_ulong (tmp: POINTER; a_v_ulong: NATURAL_32)
		external
			"C inline"
		alias
			"((union __anonunion_data_127 *)$tmp)->v_ulong = $a_v_ulong;"
		end

	c_set_v_int64 (tmp: POINTER; a_v_int64: INTEGER_64)
		external
			"C inline"
		alias
			"((union __anonunion_data_127 *)$tmp)->v_int64 = $a_v_int64;"
		end

	c_set_v_uint64 (tmp: POINTER; a_v_uint64: NATURAL_64)
		external
			"C inline"
		alias
			"((union __anonunion_data_127 *)$tmp)->v_uint64 = $a_v_uint64;"
		end

	c_set_v_float (tmp: POINTER; a_v_float: REAL_32)
		external
			"C inline"
		alias
			"((union __anonunion_data_127 *)$tmp)->v_float = $a_v_float;"
		end

	c_set_v_double (tmp: POINTER; a_v_double: REAL_64)
		external
			"C inline"
		alias
			"((union __anonunion_data_127 *)$tmp)->v_double = $a_v_double;"
		end

	c_set_v_pointer (tmp: POINTER; a_v_pointer: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_data_127 *)$tmp)->v_pointer = (void *)$a_v_pointer;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(union __anonunion_data_127);"
		end

end
