class
	SD_GARRAY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	data: CE_POINTER [INTEGER_8] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	len: NATURAL_32 assign set_len
		do
			Result := c_len (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_data (a_data: CE_POINTER [INTEGER_8])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_len (a_len: NATURAL_32)
		do
			c_set_len (c_pointer, a_len)
		end

feature {NONE} -- C getters

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GArray *)$tmp)->data;"
		end

	c_len (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GArray *)$tmp)->len;"
		end

feature {NONE} -- C setters

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct _GArray *)$tmp)->data = (char *)$a_data;"
		end

	c_set_len (tmp: POINTER; a_len: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GArray *)$tmp)->len = $a_len;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GArray);"
		end

end
