class
	SD_GCLOSURE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ref_count: NATURAL_32 assign set_ref_count
		do
			Result := c_ref_count (c_pointer)
		end

	meta_marshal: NATURAL_32 assign set_meta_marshal
		do
			Result := c_meta_marshal (c_pointer)
		end

	n_guards: NATURAL_32 assign set_n_guards
		do
			Result := c_n_guards (c_pointer)
		end

	n_fnotifiers: NATURAL_32 assign set_n_fnotifiers
		do
			Result := c_n_fnotifiers (c_pointer)
		end

	n_inotifiers: NATURAL_32 assign set_n_inotifiers
		do
			Result := c_n_inotifiers (c_pointer)
		end

	in_inotify: NATURAL_32 assign set_in_inotify
		do
			Result := c_in_inotify (c_pointer)
		end

	floating: NATURAL_32 assign set_floating
		do
			Result := c_floating (c_pointer)
		end

	derivative_flag: NATURAL_32 assign set_derivative_flag
		do
			Result := c_derivative_flag (c_pointer)
		end

	in_marshal: NATURAL_32 assign set_in_marshal
		do
			Result := c_in_marshal (c_pointer)
		end

	is_invalid: NATURAL_32 assign set_is_invalid
		do
			Result := c_is_invalid (c_pointer)
		end

	marshal: CE_ROUTINE assign set_marshal
		do
			create Result.make_shared (c_marshal (c_pointer))
		end

	data: CE_POINTER [ANY] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	notifiers: CE_POINTER [SD_GCLOSURENOTIFYDATA] assign set_notifiers
		do
			create Result.make_shared (c_notifiers (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_ref_count (a_ref_count: NATURAL_32)
		do
			c_set_ref_count (c_pointer, a_ref_count)
		end

	set_meta_marshal (a_meta_marshal: NATURAL_32)
		do
			c_set_meta_marshal (c_pointer, a_meta_marshal)
		end

	set_n_guards (a_n_guards: NATURAL_32)
		do
			c_set_n_guards (c_pointer, a_n_guards)
		end

	set_n_fnotifiers (a_n_fnotifiers: NATURAL_32)
		do
			c_set_n_fnotifiers (c_pointer, a_n_fnotifiers)
		end

	set_n_inotifiers (a_n_inotifiers: NATURAL_32)
		do
			c_set_n_inotifiers (c_pointer, a_n_inotifiers)
		end

	set_in_inotify (a_in_inotify: NATURAL_32)
		do
			c_set_in_inotify (c_pointer, a_in_inotify)
		end

	set_floating (a_floating: NATURAL_32)
		do
			c_set_floating (c_pointer, a_floating)
		end

	set_derivative_flag (a_derivative_flag: NATURAL_32)
		do
			c_set_derivative_flag (c_pointer, a_derivative_flag)
		end

	set_in_marshal (a_in_marshal: NATURAL_32)
		do
			c_set_in_marshal (c_pointer, a_in_marshal)
		end

	set_is_invalid (a_is_invalid: NATURAL_32)
		do
			c_set_is_invalid (c_pointer, a_is_invalid)
		end

	set_marshal (a_marshal: CE_ROUTINE)
		do
			c_set_marshal (c_pointer, a_marshal.c_pointer)
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_notifiers (a_notifiers: CE_POINTER [SD_GCLOSURENOTIFYDATA])
		do
			c_set_notifiers (c_pointer, a_notifiers.c_pointer)
		end

feature {NONE} -- C getters

	c_ref_count (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GClosure *)$tmp)->ref_count;"
		end

	c_meta_marshal (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GClosure *)$tmp)->meta_marshal;"
		end

	c_n_guards (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GClosure *)$tmp)->n_guards;"
		end

	c_n_fnotifiers (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GClosure *)$tmp)->n_fnotifiers;"
		end

	c_n_inotifiers (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GClosure *)$tmp)->n_inotifiers;"
		end

	c_in_inotify (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GClosure *)$tmp)->in_inotify;"
		end

	c_floating (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GClosure *)$tmp)->floating;"
		end

	c_derivative_flag (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GClosure *)$tmp)->derivative_flag;"
		end

	c_in_marshal (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GClosure *)$tmp)->in_marshal;"
		end

	c_is_invalid (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GClosure *)$tmp)->is_invalid;"
		end

	c_marshal (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _GClosure * closure, struct _GValue * return_value, unsigned int n_param_values, struct _GValue * param_values, void * invocation_hint, void * marshal_data))((struct _GClosure *)$tmp)->marshal;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GClosure *)$tmp)->data;"
		end

	c_notifiers (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GClosureNotifyData *)((struct _GClosure *)$tmp)->notifiers;"
		end

feature {NONE} -- C setters

	c_set_ref_count (tmp: POINTER; a_ref_count: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GClosure *)$tmp)->ref_count = $a_ref_count;"
		end

	c_set_meta_marshal (tmp: POINTER; a_meta_marshal: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GClosure *)$tmp)->meta_marshal = $a_meta_marshal;"
		end

	c_set_n_guards (tmp: POINTER; a_n_guards: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GClosure *)$tmp)->n_guards = $a_n_guards;"
		end

	c_set_n_fnotifiers (tmp: POINTER; a_n_fnotifiers: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GClosure *)$tmp)->n_fnotifiers = $a_n_fnotifiers;"
		end

	c_set_n_inotifiers (tmp: POINTER; a_n_inotifiers: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GClosure *)$tmp)->n_inotifiers = $a_n_inotifiers;"
		end

	c_set_in_inotify (tmp: POINTER; a_in_inotify: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GClosure *)$tmp)->in_inotify = $a_in_inotify;"
		end

	c_set_floating (tmp: POINTER; a_floating: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GClosure *)$tmp)->floating = $a_floating;"
		end

	c_set_derivative_flag (tmp: POINTER; a_derivative_flag: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GClosure *)$tmp)->derivative_flag = $a_derivative_flag;"
		end

	c_set_in_marshal (tmp: POINTER; a_in_marshal: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GClosure *)$tmp)->in_marshal = $a_in_marshal;"
		end

	c_set_is_invalid (tmp: POINTER; a_is_invalid: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GClosure *)$tmp)->is_invalid = $a_is_invalid;"
		end

	c_set_marshal (tmp: POINTER; a_marshal: POINTER)
		external
			"C inline"
		alias
			"((struct _GClosure *)$tmp)->marshal = (void( *)(struct _GClosure * closure, struct _GValue * return_value, unsigned int n_param_values, struct _GValue * param_values, void * invocation_hint, void * marshal_data))$a_marshal;"
		end

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct _GClosure *)$tmp)->data = (void *)$a_data;"
		end

	c_set_notifiers (tmp: POINTER; a_notifiers: POINTER)
		external
			"C inline"
		alias
			"((struct _GClosure *)$tmp)->notifiers = (struct _GClosureNotifyData *)$a_notifiers;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GClosure);"
		end

end
