class
	SD_GDKCOLORMAP

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent_instance: SD_GOBJECT assign set_parent_instance
		do
			create Result.make_shared (c_parent_instance (c_pointer))
		end

	size: INTEGER_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	colors: CE_POINTER [SD_GDKCOLOR] assign set_colors
		do
			create Result.make_shared (c_colors (c_pointer))
		end

	visual: CE_POINTER [SD_GDKVISUAL] assign set_visual
		do
			create Result.make_shared (c_visual (c_pointer))
		end

	windowing_data: CE_POINTER [ANY] assign set_windowing_data
		do
			create Result.make_shared (c_windowing_data (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance.ce_gets (a_parent_instance)
		end

	set_size (a_size: INTEGER_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_colors (a_colors: CE_POINTER [SD_GDKCOLOR])
		do
			c_set_colors (c_pointer, a_colors.c_pointer)
		end

	set_visual (a_visual: CE_POINTER [SD_GDKVISUAL])
		do
			c_set_visual (c_pointer, a_visual.c_pointer)
		end

	set_windowing_data (a_windowing_data: CE_POINTER [ANY])
		do
			c_set_windowing_data (c_pointer, a_windowing_data.c_pointer)
		end

feature {NONE} -- C getters

	c_parent_instance (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GObject *)&((struct _GdkColormap *)$tmp)->parent_instance;"
		end

	c_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkColormap *)$tmp)->size;"
		end

	c_colors (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkColor *)((struct _GdkColormap *)$tmp)->colors;"
		end

	c_visual (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkVisual *)((struct _GdkColormap *)$tmp)->visual;"
		end

	c_windowing_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GdkColormap *)$tmp)->windowing_data;"
		end

feature {NONE} -- C setters

	c_set_size (tmp: POINTER; a_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkColormap *)$tmp)->size = $a_size;"
		end

	c_set_colors (tmp: POINTER; a_colors: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkColormap *)$tmp)->colors = (struct _GdkColor *)$a_colors;"
		end

	c_set_visual (tmp: POINTER; a_visual: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkColormap *)$tmp)->visual = (struct _GdkVisual *)$a_visual;"
		end

	c_set_windowing_data (tmp: POINTER; a_windowing_data: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkColormap *)$tmp)->windowing_data = (void *)$a_windowing_data;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkColormap);"
		end

end
