class
	SD_GDKDISPLAY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent_instance: SD_GOBJECT assign set_parent_instance
		do
			create Result.make_shared (c_parent_instance (c_pointer))
		end

	queued_events: CE_POINTER [SD_GLIST] assign set_queued_events
		do
			create Result.make_shared (c_queued_events (c_pointer))
		end

	queued_tail: CE_POINTER [SD_GLIST] assign set_queued_tail
		do
			create Result.make_shared (c_queued_tail (c_pointer))
		end

	button_click_time: CE_ARRAY [NATURAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_button_click_time (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	button_window: CE_ARRAY [CE_POINTER [SD_GDKDRAWABLE]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_button_window (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	button_number: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_button_number (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	double_click_time: NATURAL_32 assign set_double_click_time
		do
			Result := c_double_click_time (c_pointer)
		end

	core_pointer: CE_POINTER [SD_GDKDEVICE] assign set_core_pointer
		do
			create Result.make_shared (c_core_pointer (c_pointer))
		end

	pointer_hooks: CE_POINTER [SD_GDKDISPLAYPOINTERHOOKS] assign set_pointer_hooks
		do
			create Result.make_shared (c_pointer_hooks (c_pointer))
		end

	closed: NATURAL_32 assign set_closed
		do
			Result := c_closed (c_pointer)
		end

	ignore_core_events: NATURAL_32 assign set_ignore_core_events
		do
			Result := c_ignore_core_events (c_pointer)
		end

	double_click_distance: NATURAL_32 assign set_double_click_distance
		do
			Result := c_double_click_distance (c_pointer)
		end

	button_x: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_button_x (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	button_y: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_button_y (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	pointer_grabs: CE_POINTER [SD_GLIST] assign set_pointer_grabs
		do
			create Result.make_shared (c_pointer_grabs (c_pointer))
		end

	keyboard_grab: SD_GDKKEYBOARDGRABINFO assign set_keyboard_grab
		do
			create Result.make_shared (c_keyboard_grab (c_pointer))
		end

	pointer_info: SD_GDKPOINTERWINDOWINFO assign set_pointer_info
		do
			create Result.make_shared (c_pointer_info (c_pointer))
		end

	last_event_time: NATURAL_32 assign set_last_event_time
		do
			Result := c_last_event_time (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance.ce_gets (a_parent_instance)
		end

	set_queued_events (a_queued_events: CE_POINTER [SD_GLIST])
		do
			c_set_queued_events (c_pointer, a_queued_events.c_pointer)
		end

	set_queued_tail (a_queued_tail: CE_POINTER [SD_GLIST])
		do
			c_set_queued_tail (c_pointer, a_queued_tail.c_pointer)
		end

	set_double_click_time (a_double_click_time: NATURAL_32)
		do
			c_set_double_click_time (c_pointer, a_double_click_time)
		end

	set_core_pointer (a_core_pointer: CE_POINTER [SD_GDKDEVICE])
		do
			c_set_core_pointer (c_pointer, a_core_pointer.c_pointer)
		end

	set_pointer_hooks (a_pointer_hooks: CE_POINTER [SD_GDKDISPLAYPOINTERHOOKS])
		do
			c_set_pointer_hooks (c_pointer, a_pointer_hooks.c_pointer)
		end

	set_closed (a_closed: NATURAL_32)
		do
			c_set_closed (c_pointer, a_closed)
		end

	set_ignore_core_events (a_ignore_core_events: NATURAL_32)
		do
			c_set_ignore_core_events (c_pointer, a_ignore_core_events)
		end

	set_double_click_distance (a_double_click_distance: NATURAL_32)
		do
			c_set_double_click_distance (c_pointer, a_double_click_distance)
		end

	set_pointer_grabs (a_pointer_grabs: CE_POINTER [SD_GLIST])
		do
			c_set_pointer_grabs (c_pointer, a_pointer_grabs.c_pointer)
		end

	set_keyboard_grab (a_keyboard_grab: SD_GDKKEYBOARDGRABINFO)
		do
			keyboard_grab.ce_gets (a_keyboard_grab)
		end

	set_pointer_info (a_pointer_info: SD_GDKPOINTERWINDOWINFO)
		do
			pointer_info.ce_gets (a_pointer_info)
		end

	set_last_event_time (a_last_event_time: NATURAL_32)
		do
			c_set_last_event_time (c_pointer, a_last_event_time)
		end

feature {NONE} -- C getters

	c_parent_instance (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GObject *)&((struct _GdkDisplay *)$tmp)->parent_instance;"
		end

	c_queued_events (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GList *)((struct _GdkDisplay *)$tmp)->queued_events;"
		end

	c_queued_tail (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GList *)((struct _GdkDisplay *)$tmp)->queued_tail;"
		end

	c_button_click_time (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GdkDisplay *tmp = (struct _GdkDisplay *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->button_click_time) / sizeof(tmp->button_click_time[0]);
				return tmp->button_click_time;
			]"
		end

	c_button_window (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GdkDisplay *tmp = (struct _GdkDisplay *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->button_window) / sizeof(tmp->button_window[0]);
				return tmp->button_window;
			]"
		end

	c_button_number (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GdkDisplay *tmp = (struct _GdkDisplay *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->button_number) / sizeof(tmp->button_number[0]);
				return tmp->button_number;
			]"
		end

	c_double_click_time (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkDisplay *)$tmp)->double_click_time;"
		end

	c_core_pointer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDevice *)((struct _GdkDisplay *)$tmp)->core_pointer;"
		end

	c_pointer_hooks (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDisplayPointerHooks *)((struct _GdkDisplay *)$tmp)->pointer_hooks;"
		end

	c_closed (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkDisplay *)$tmp)->closed;"
		end

	c_ignore_core_events (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkDisplay *)$tmp)->ignore_core_events;"
		end

	c_double_click_distance (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkDisplay *)$tmp)->double_click_distance;"
		end

	c_button_x (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GdkDisplay *tmp = (struct _GdkDisplay *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->button_x) / sizeof(tmp->button_x[0]);
				return tmp->button_x;
			]"
		end

	c_button_y (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GdkDisplay *tmp = (struct _GdkDisplay *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->button_y) / sizeof(tmp->button_y[0]);
				return tmp->button_y;
			]"
		end

	c_pointer_grabs (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GList *)((struct _GdkDisplay *)$tmp)->pointer_grabs;"
		end

	c_keyboard_grab (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (GdkKeyboardGrabInfo *)&((struct _GdkDisplay *)$tmp)->keyboard_grab;"
		end

	c_pointer_info (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (GdkPointerWindowInfo *)&((struct _GdkDisplay *)$tmp)->pointer_info;"
		end

	c_last_event_time (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkDisplay *)$tmp)->last_event_time;"
		end

feature {NONE} -- C setters

	c_set_queued_events (tmp: POINTER; a_queued_events: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkDisplay *)$tmp)->queued_events = (struct _GList *)$a_queued_events;"
		end

	c_set_queued_tail (tmp: POINTER; a_queued_tail: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkDisplay *)$tmp)->queued_tail = (struct _GList *)$a_queued_tail;"
		end

	c_set_double_click_time (tmp: POINTER; a_double_click_time: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkDisplay *)$tmp)->double_click_time = $a_double_click_time;"
		end

	c_set_core_pointer (tmp: POINTER; a_core_pointer: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkDisplay *)$tmp)->core_pointer = (struct _GdkDevice *)$a_core_pointer;"
		end

	c_set_pointer_hooks (tmp: POINTER; a_pointer_hooks: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkDisplay *)$tmp)->pointer_hooks = (struct _GdkDisplayPointerHooks *)$a_pointer_hooks;"
		end

	c_set_closed (tmp: POINTER; a_closed: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkDisplay *)$tmp)->closed = $a_closed;"
		end

	c_set_ignore_core_events (tmp: POINTER; a_ignore_core_events: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkDisplay *)$tmp)->ignore_core_events = $a_ignore_core_events;"
		end

	c_set_double_click_distance (tmp: POINTER; a_double_click_distance: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkDisplay *)$tmp)->double_click_distance = $a_double_click_distance;"
		end

	c_set_pointer_grabs (tmp: POINTER; a_pointer_grabs: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkDisplay *)$tmp)->pointer_grabs = (struct _GList *)$a_pointer_grabs;"
		end

	c_set_last_event_time (tmp: POINTER; a_last_event_time: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkDisplay *)$tmp)->last_event_time = $a_last_event_time;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkDisplay);"
		end

end
