class
	SD_GDKDISPLAYPOINTERHOOKS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	get_pointer: CE_ROUTINE assign set_get_pointer
		do
			create Result.make_shared (c_get_pointer (c_pointer))
		end

	window_get_pointer: CE_ROUTINE assign set_window_get_pointer
		do
			create Result.make_shared (c_window_get_pointer (c_pointer))
		end

	window_at_pointer: CE_ROUTINE assign set_window_at_pointer
		do
			create Result.make_shared (c_window_at_pointer (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_get_pointer (a_get_pointer: CE_ROUTINE)
		do
			c_set_get_pointer (c_pointer, a_get_pointer.c_pointer)
		end

	set_window_get_pointer (a_window_get_pointer: CE_ROUTINE)
		do
			c_set_window_get_pointer (c_pointer, a_window_get_pointer.c_pointer)
		end

	set_window_at_pointer (a_window_at_pointer: CE_ROUTINE)
		do
			c_set_window_at_pointer (c_pointer, a_window_at_pointer.c_pointer)
		end

feature {NONE} -- C getters

	c_get_pointer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _GdkDisplay * display, struct _GdkScreen * * screen, int * x, int * y, int * mask))((struct _GdkDisplayPointerHooks *)$tmp)->get_pointer;"
		end

	c_window_get_pointer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *( *)(struct _GdkDisplay * display, struct _GdkDrawable * window, int * x, int * y, int * mask))((struct _GdkDisplayPointerHooks *)$tmp)->window_get_pointer;"
		end

	c_window_at_pointer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *( *)(struct _GdkDisplay * display, int * win_x, int * win_y))((struct _GdkDisplayPointerHooks *)$tmp)->window_at_pointer;"
		end

feature {NONE} -- C setters

	c_set_get_pointer (tmp: POINTER; a_get_pointer: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkDisplayPointerHooks *)$tmp)->get_pointer = (void( *)(struct _GdkDisplay * display, struct _GdkScreen * * screen, int * x, int * y, int * mask))$a_get_pointer;"
		end

	c_set_window_get_pointer (tmp: POINTER; a_window_get_pointer: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkDisplayPointerHooks *)$tmp)->window_get_pointer = (struct _GdkDrawable *( *)(struct _GdkDisplay * display, struct _GdkDrawable * window, int * x, int * y, int * mask))$a_window_get_pointer;"
		end

	c_set_window_at_pointer (tmp: POINTER; a_window_at_pointer: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkDisplayPointerHooks *)$tmp)->window_at_pointer = (struct _GdkDrawable *( *)(struct _GdkDisplay * display, int * win_x, int * win_y))$a_window_at_pointer;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkDisplayPointerHooks);"
		end

end
