class
	SD_GDKEVENTEXPOSE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window
		do
			create Result.make_shared (c_window (c_pointer))
		end

	send_event: INTEGER_8 assign set_send_event
		do
			Result := c_send_event (c_pointer)
		end

	area: SD_GDKRECTANGLE assign set_area
		do
			create Result.make_shared (c_area (c_pointer))
		end

	area_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct _GdkEventExpose, area);"
		end

	region: CE_POINTER [ANY] assign set_region
		do
			create Result.make_shared (c_region (c_pointer))
		end

	count: INTEGER_32 assign set_count
		do
			Result := c_count (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_window (c_pointer, a_window.c_pointer)
		end

	set_send_event (a_send_event: INTEGER_8)
		do
			c_set_send_event (c_pointer, a_send_event)
		end

	set_area (a_area: SD_GDKRECTANGLE)
		do
			area.ce_gets (a_area)
		end

	set_region (a_region: CE_POINTER [ANY])
		do
			c_set_region (c_pointer, a_region.c_pointer)
		end

	set_count (a_count: INTEGER_32)
		do
			c_set_count (c_pointer, a_count)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkEventExpose *)$tmp)->type;"
		end

	c_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GdkEventExpose *)$tmp)->window;"
		end

	c_send_event (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct _GdkEventExpose *)$tmp)->send_event;"
		end

	c_area (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkRectangle *)&((struct _GdkEventExpose *)$tmp)->area;"
		end

	c_region (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GdkEventExpose *)$tmp)->region;"
		end

	c_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkEventExpose *)$tmp)->count;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkEventExpose *)$tmp)->type = $a_type;"
		end

	c_set_window (tmp: POINTER; a_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventExpose *)$tmp)->window = (struct _GdkDrawable *)$a_window;"
		end

	c_set_send_event (tmp: POINTER; a_send_event: INTEGER_8)
		external
			"C inline"
		alias
			"((struct _GdkEventExpose *)$tmp)->send_event = $a_send_event;"
		end

	c_set_region (tmp: POINTER; a_region: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventExpose *)$tmp)->region = (void *)$a_region;"
		end

	c_set_count (tmp: POINTER; a_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkEventExpose *)$tmp)->count = $a_count;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkEventExpose);"
		end

end
