class
	SD_GDKEVENTPROPERTY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window
		do
			create Result.make_shared (c_window (c_pointer))
		end

	send_event: INTEGER_8 assign set_send_event
		do
			Result := c_send_event (c_pointer)
		end

	atom: CE_POINTER [ANY] assign set_atom
		do
			create Result.make_shared (c_atom (c_pointer))
		end

	time: NATURAL_32 assign set_time
		do
			Result := c_time (c_pointer)
		end

	state: NATURAL_32 assign set_state
		do
			Result := c_state (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_window (c_pointer, a_window.c_pointer)
		end

	set_send_event (a_send_event: INTEGER_8)
		do
			c_set_send_event (c_pointer, a_send_event)
		end

	set_atom (a_atom: CE_POINTER [ANY])
		do
			c_set_atom (c_pointer, a_atom.c_pointer)
		end

	set_time (a_time: NATURAL_32)
		do
			c_set_time (c_pointer, a_time)
		end

	set_state (a_state: NATURAL_32)
		do
			c_set_state (c_pointer, a_state)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkEventProperty *)$tmp)->type;"
		end

	c_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GdkEventProperty *)$tmp)->window;"
		end

	c_send_event (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct _GdkEventProperty *)$tmp)->send_event;"
		end

	c_atom (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GdkEventProperty *)$tmp)->atom;"
		end

	c_time (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkEventProperty *)$tmp)->time;"
		end

	c_state (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkEventProperty *)$tmp)->state;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkEventProperty *)$tmp)->type = $a_type;"
		end

	c_set_window (tmp: POINTER; a_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventProperty *)$tmp)->window = (struct _GdkDrawable *)$a_window;"
		end

	c_set_send_event (tmp: POINTER; a_send_event: INTEGER_8)
		external
			"C inline"
		alias
			"((struct _GdkEventProperty *)$tmp)->send_event = $a_send_event;"
		end

	c_set_atom (tmp: POINTER; a_atom: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventProperty *)$tmp)->atom = (void *)$a_atom;"
		end

	c_set_time (tmp: POINTER; a_time: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkEventProperty *)$tmp)->time = $a_time;"
		end

	c_set_state (tmp: POINTER; a_state: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkEventProperty *)$tmp)->state = $a_state;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkEventProperty);"
		end

end
