class
	SD_GDKSCREEN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent_instance: SD_GOBJECT assign set_parent_instance
		do
			create Result.make_shared (c_parent_instance (c_pointer))
		end

	closed: NATURAL_32 assign set_closed
		do
			Result := c_closed (c_pointer)
		end

	normal_gcs: CE_ARRAY [CE_POINTER [SD_GDKGC]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_normal_gcs (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	exposure_gcs: CE_ARRAY [CE_POINTER [SD_GDKGC]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_exposure_gcs (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	subwindow_gcs: CE_ARRAY [CE_POINTER [SD_GDKGC]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_subwindow_gcs (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	font_options: CE_POINTER [ANY] assign set_font_options
		do
			create Result.make_shared (c_font_options (c_pointer))
		end

	resolution: REAL_64 assign set_resolution
		do
			Result := c_resolution (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance.ce_gets (a_parent_instance)
		end

	set_closed (a_closed: NATURAL_32)
		do
			c_set_closed (c_pointer, a_closed)
		end

	set_font_options (a_font_options: CE_POINTER [ANY])
		do
			c_set_font_options (c_pointer, a_font_options.c_pointer)
		end

	set_resolution (a_resolution: REAL_64)
		do
			c_set_resolution (c_pointer, a_resolution)
		end

feature {NONE} -- C getters

	c_parent_instance (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GObject *)&((struct _GdkScreen *)$tmp)->parent_instance;"
		end

	c_closed (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkScreen *)$tmp)->closed;"
		end

	c_normal_gcs (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GdkScreen *tmp = (struct _GdkScreen *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->normal_gcs) / sizeof(tmp->normal_gcs[0]);
				return tmp->normal_gcs;
			]"
		end

	c_exposure_gcs (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GdkScreen *tmp = (struct _GdkScreen *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->exposure_gcs) / sizeof(tmp->exposure_gcs[0]);
				return tmp->exposure_gcs;
			]"
		end

	c_subwindow_gcs (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GdkScreen *tmp = (struct _GdkScreen *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->subwindow_gcs) / sizeof(tmp->subwindow_gcs[0]);
				return tmp->subwindow_gcs;
			]"
		end

	c_font_options (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GdkScreen *)$tmp)->font_options;"
		end

	c_resolution (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _GdkScreen *)$tmp)->resolution;"
		end

feature {NONE} -- C setters

	c_set_closed (tmp: POINTER; a_closed: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkScreen *)$tmp)->closed = $a_closed;"
		end

	c_set_font_options (tmp: POINTER; a_font_options: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkScreen *)$tmp)->font_options = (void *)$a_font_options;"
		end

	c_set_resolution (tmp: POINTER; a_resolution: REAL_64)
		external
			"C inline"
		alias
			"((struct _GdkScreen *)$tmp)->resolution = $a_resolution;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkScreen);"
		end

end
