class
	SD_GERROR

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	domain: NATURAL_32 assign set_domain
		do
			Result := c_domain (c_pointer)
		end

	code: INTEGER_32 assign set_code
		do
			Result := c_code (c_pointer)
		end

	message: CE_POINTER [INTEGER_8] assign set_message
		do
			create Result.make_shared (c_message (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_domain (a_domain: NATURAL_32)
		do
			c_set_domain (c_pointer, a_domain)
		end

	set_code (a_code: INTEGER_32)
		do
			c_set_code (c_pointer, a_code)
		end

	set_message (a_message: CE_POINTER [INTEGER_8])
		do
			c_set_message (c_pointer, a_message.c_pointer)
		end

feature {NONE} -- C getters

	c_domain (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GError *)$tmp)->domain;"
		end

	c_code (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GError *)$tmp)->code;"
		end

	c_message (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GError *)$tmp)->message;"
		end

feature {NONE} -- C setters

	c_set_domain (tmp: POINTER; a_domain: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GError *)$tmp)->domain = $a_domain;"
		end

	c_set_code (tmp: POINTER; a_code: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GError *)$tmp)->code = $a_code;"
		end

	c_set_message (tmp: POINTER; a_message: POINTER)
		external
			"C inline"
		alias
			"((struct _GError *)$tmp)->message = (char *)$a_message;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GError);"
		end

end
