class
	SD_GIOCHANNEL

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ref_count: INTEGER_32 assign set_ref_count
		do
			Result := c_ref_count (c_pointer)
		end

	funcs: CE_POINTER [SD_GIOFUNCS] assign set_funcs
		do
			create Result.make_shared (c_funcs (c_pointer))
		end

	encoding: CE_POINTER [INTEGER_8] assign set_encoding
		do
			create Result.make_shared (c_encoding (c_pointer))
		end

	read_cd: CE_POINTER [ANY] assign set_read_cd
		do
			create Result.make_shared (c_read_cd (c_pointer))
		end

	write_cd: CE_POINTER [ANY] assign set_write_cd
		do
			create Result.make_shared (c_write_cd (c_pointer))
		end

	line_term: CE_POINTER [INTEGER_8] assign set_line_term
		do
			create Result.make_shared (c_line_term (c_pointer))
		end

	line_term_len: NATURAL_32 assign set_line_term_len
		do
			Result := c_line_term_len (c_pointer)
		end

	buf_size: NATURAL_32 assign set_buf_size
		do
			Result := c_buf_size (c_pointer)
		end

	read_buf: CE_POINTER [SD_GSTRING] assign set_read_buf
		do
			create Result.make_shared (c_read_buf (c_pointer))
		end

	encoded_read_buf: CE_POINTER [SD_GSTRING] assign set_encoded_read_buf
		do
			create Result.make_shared (c_encoded_read_buf (c_pointer))
		end

	write_buf: CE_POINTER [SD_GSTRING] assign set_write_buf
		do
			create Result.make_shared (c_write_buf (c_pointer))
		end

	partial_write_buf: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_partial_write_buf (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	use_buffer: NATURAL_32 assign set_use_buffer
		do
			Result := c_use_buffer (c_pointer)
		end

	do_encode: NATURAL_32 assign set_do_encode
		do
			Result := c_do_encode (c_pointer)
		end

	close_on_unref: NATURAL_32 assign set_close_on_unref
		do
			Result := c_close_on_unref (c_pointer)
		end

	is_readable: NATURAL_32 assign set_is_readable
		do
			Result := c_is_readable (c_pointer)
		end

	is_writeable: NATURAL_32 assign set_is_writeable
		do
			Result := c_is_writeable (c_pointer)
		end

	is_seekable: NATURAL_32 assign set_is_seekable
		do
			Result := c_is_seekable (c_pointer)
		end

	reserved1: CE_POINTER [ANY] assign set_reserved1
		do
			create Result.make_shared (c_reserved1 (c_pointer))
		end

	reserved2: CE_POINTER [ANY] assign set_reserved2
		do
			create Result.make_shared (c_reserved2 (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_ref_count (a_ref_count: INTEGER_32)
		do
			c_set_ref_count (c_pointer, a_ref_count)
		end

	set_funcs (a_funcs: CE_POINTER [SD_GIOFUNCS])
		do
			c_set_funcs (c_pointer, a_funcs.c_pointer)
		end

	set_encoding (a_encoding: CE_POINTER [INTEGER_8])
		do
			c_set_encoding (c_pointer, a_encoding.c_pointer)
		end

	set_read_cd (a_read_cd: CE_POINTER [ANY])
		do
			c_set_read_cd (c_pointer, a_read_cd.c_pointer)
		end

	set_write_cd (a_write_cd: CE_POINTER [ANY])
		do
			c_set_write_cd (c_pointer, a_write_cd.c_pointer)
		end

	set_line_term (a_line_term: CE_POINTER [INTEGER_8])
		do
			c_set_line_term (c_pointer, a_line_term.c_pointer)
		end

	set_line_term_len (a_line_term_len: NATURAL_32)
		do
			c_set_line_term_len (c_pointer, a_line_term_len)
		end

	set_buf_size (a_buf_size: NATURAL_32)
		do
			c_set_buf_size (c_pointer, a_buf_size)
		end

	set_read_buf (a_read_buf: CE_POINTER [SD_GSTRING])
		do
			c_set_read_buf (c_pointer, a_read_buf.c_pointer)
		end

	set_encoded_read_buf (a_encoded_read_buf: CE_POINTER [SD_GSTRING])
		do
			c_set_encoded_read_buf (c_pointer, a_encoded_read_buf.c_pointer)
		end

	set_write_buf (a_write_buf: CE_POINTER [SD_GSTRING])
		do
			c_set_write_buf (c_pointer, a_write_buf.c_pointer)
		end

	set_use_buffer (a_use_buffer: NATURAL_32)
		do
			c_set_use_buffer (c_pointer, a_use_buffer)
		end

	set_do_encode (a_do_encode: NATURAL_32)
		do
			c_set_do_encode (c_pointer, a_do_encode)
		end

	set_close_on_unref (a_close_on_unref: NATURAL_32)
		do
			c_set_close_on_unref (c_pointer, a_close_on_unref)
		end

	set_is_readable (a_is_readable: NATURAL_32)
		do
			c_set_is_readable (c_pointer, a_is_readable)
		end

	set_is_writeable (a_is_writeable: NATURAL_32)
		do
			c_set_is_writeable (c_pointer, a_is_writeable)
		end

	set_is_seekable (a_is_seekable: NATURAL_32)
		do
			c_set_is_seekable (c_pointer, a_is_seekable)
		end

	set_reserved1 (a_reserved1: CE_POINTER [ANY])
		do
			c_set_reserved1 (c_pointer, a_reserved1.c_pointer)
		end

	set_reserved2 (a_reserved2: CE_POINTER [ANY])
		do
			c_set_reserved2 (c_pointer, a_reserved2.c_pointer)
		end

feature {NONE} -- C getters

	c_ref_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GIOChannel *)$tmp)->ref_count;"
		end

	c_funcs (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GIOFuncs *)((struct _GIOChannel *)$tmp)->funcs;"
		end

	c_encoding (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GIOChannel *)$tmp)->encoding;"
		end

	c_read_cd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GIOChannel *)$tmp)->read_cd;"
		end

	c_write_cd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GIOChannel *)$tmp)->write_cd;"
		end

	c_line_term (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GIOChannel *)$tmp)->line_term;"
		end

	c_line_term_len (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GIOChannel *)$tmp)->line_term_len;"
		end

	c_buf_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GIOChannel *)$tmp)->buf_size;"
		end

	c_read_buf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GString *)((struct _GIOChannel *)$tmp)->read_buf;"
		end

	c_encoded_read_buf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GString *)((struct _GIOChannel *)$tmp)->encoded_read_buf;"
		end

	c_write_buf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GString *)((struct _GIOChannel *)$tmp)->write_buf;"
		end

	c_partial_write_buf (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GIOChannel *tmp = (struct _GIOChannel *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->partial_write_buf) / sizeof(tmp->partial_write_buf[0]);
				return tmp->partial_write_buf;
			]"
		end

	c_use_buffer (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GIOChannel *)$tmp)->use_buffer;"
		end

	c_do_encode (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GIOChannel *)$tmp)->do_encode;"
		end

	c_close_on_unref (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GIOChannel *)$tmp)->close_on_unref;"
		end

	c_is_readable (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GIOChannel *)$tmp)->is_readable;"
		end

	c_is_writeable (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GIOChannel *)$tmp)->is_writeable;"
		end

	c_is_seekable (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GIOChannel *)$tmp)->is_seekable;"
		end

	c_reserved1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GIOChannel *)$tmp)->reserved1;"
		end

	c_reserved2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GIOChannel *)$tmp)->reserved2;"
		end

feature {NONE} -- C setters

	c_set_ref_count (tmp: POINTER; a_ref_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GIOChannel *)$tmp)->ref_count = $a_ref_count;"
		end

	c_set_funcs (tmp: POINTER; a_funcs: POINTER)
		external
			"C inline"
		alias
			"((struct _GIOChannel *)$tmp)->funcs = (struct _GIOFuncs *)$a_funcs;"
		end

	c_set_encoding (tmp: POINTER; a_encoding: POINTER)
		external
			"C inline"
		alias
			"((struct _GIOChannel *)$tmp)->encoding = (char *)$a_encoding;"
		end

	c_set_read_cd (tmp: POINTER; a_read_cd: POINTER)
		external
			"C inline"
		alias
			"((struct _GIOChannel *)$tmp)->read_cd = (void *)$a_read_cd;"
		end

	c_set_write_cd (tmp: POINTER; a_write_cd: POINTER)
		external
			"C inline"
		alias
			"((struct _GIOChannel *)$tmp)->write_cd = (void *)$a_write_cd;"
		end

	c_set_line_term (tmp: POINTER; a_line_term: POINTER)
		external
			"C inline"
		alias
			"((struct _GIOChannel *)$tmp)->line_term = (char *)$a_line_term;"
		end

	c_set_line_term_len (tmp: POINTER; a_line_term_len: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GIOChannel *)$tmp)->line_term_len = $a_line_term_len;"
		end

	c_set_buf_size (tmp: POINTER; a_buf_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GIOChannel *)$tmp)->buf_size = $a_buf_size;"
		end

	c_set_read_buf (tmp: POINTER; a_read_buf: POINTER)
		external
			"C inline"
		alias
			"((struct _GIOChannel *)$tmp)->read_buf = (struct _GString *)$a_read_buf;"
		end

	c_set_encoded_read_buf (tmp: POINTER; a_encoded_read_buf: POINTER)
		external
			"C inline"
		alias
			"((struct _GIOChannel *)$tmp)->encoded_read_buf = (struct _GString *)$a_encoded_read_buf;"
		end

	c_set_write_buf (tmp: POINTER; a_write_buf: POINTER)
		external
			"C inline"
		alias
			"((struct _GIOChannel *)$tmp)->write_buf = (struct _GString *)$a_write_buf;"
		end

	c_set_use_buffer (tmp: POINTER; a_use_buffer: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GIOChannel *)$tmp)->use_buffer = $a_use_buffer;"
		end

	c_set_do_encode (tmp: POINTER; a_do_encode: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GIOChannel *)$tmp)->do_encode = $a_do_encode;"
		end

	c_set_close_on_unref (tmp: POINTER; a_close_on_unref: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GIOChannel *)$tmp)->close_on_unref = $a_close_on_unref;"
		end

	c_set_is_readable (tmp: POINTER; a_is_readable: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GIOChannel *)$tmp)->is_readable = $a_is_readable;"
		end

	c_set_is_writeable (tmp: POINTER; a_is_writeable: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GIOChannel *)$tmp)->is_writeable = $a_is_writeable;"
		end

	c_set_is_seekable (tmp: POINTER; a_is_seekable: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GIOChannel *)$tmp)->is_seekable = $a_is_seekable;"
		end

	c_set_reserved1 (tmp: POINTER; a_reserved1: POINTER)
		external
			"C inline"
		alias
			"((struct _GIOChannel *)$tmp)->reserved1 = (void *)$a_reserved1;"
		end

	c_set_reserved2 (tmp: POINTER; a_reserved2: POINTER)
		external
			"C inline"
		alias
			"((struct _GIOChannel *)$tmp)->reserved2 = (void *)$a_reserved2;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GIOChannel);"
		end

end
