class
	SD_GIOFUNCS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	io_read: CE_ROUTINE assign set_io_read
		do
			create Result.make_shared (c_io_read (c_pointer))
		end

	io_write: CE_ROUTINE assign set_io_write
		do
			create Result.make_shared (c_io_write (c_pointer))
		end

	io_seek: CE_ROUTINE assign set_io_seek
		do
			create Result.make_shared (c_io_seek (c_pointer))
		end

	io_close: CE_ROUTINE assign set_io_close
		do
			create Result.make_shared (c_io_close (c_pointer))
		end

	io_create_watch: CE_ROUTINE assign set_io_create_watch
		do
			create Result.make_shared (c_io_create_watch (c_pointer))
		end

	io_free: CE_ROUTINE assign set_io_free
		do
			create Result.make_shared (c_io_free (c_pointer))
		end

	io_set_flags: CE_ROUTINE assign set_io_set_flags
		do
			create Result.make_shared (c_io_set_flags (c_pointer))
		end

	io_get_flags: CE_ROUTINE assign set_io_get_flags
		do
			create Result.make_shared (c_io_get_flags (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_io_read (a_io_read: CE_ROUTINE)
		do
			c_set_io_read (c_pointer, a_io_read.c_pointer)
		end

	set_io_write (a_io_write: CE_ROUTINE)
		do
			c_set_io_write (c_pointer, a_io_write.c_pointer)
		end

	set_io_seek (a_io_seek: CE_ROUTINE)
		do
			c_set_io_seek (c_pointer, a_io_seek.c_pointer)
		end

	set_io_close (a_io_close: CE_ROUTINE)
		do
			c_set_io_close (c_pointer, a_io_close.c_pointer)
		end

	set_io_create_watch (a_io_create_watch: CE_ROUTINE)
		do
			c_set_io_create_watch (c_pointer, a_io_create_watch.c_pointer)
		end

	set_io_free (a_io_free: CE_ROUTINE)
		do
			c_set_io_free (c_pointer, a_io_free.c_pointer)
		end

	set_io_set_flags (a_io_set_flags: CE_ROUTINE)
		do
			c_set_io_set_flags (c_pointer, a_io_set_flags.c_pointer)
		end

	set_io_get_flags (a_io_get_flags: CE_ROUTINE)
		do
			c_set_io_get_flags (c_pointer, a_io_get_flags.c_pointer)
		end

feature {NONE} -- C getters

	c_io_read (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct _GIOChannel * channel, char * buf, unsigned int count, unsigned int * bytes_read, struct _GError * * err))((struct _GIOFuncs *)$tmp)->io_read;"
		end

	c_io_write (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct _GIOChannel * channel, char * buf, unsigned int count, unsigned int * bytes_written, struct _GError * * err))((struct _GIOFuncs *)$tmp)->io_write;"
		end

	c_io_seek (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct _GIOChannel * channel, long long offset, int type, struct _GError * * err))((struct _GIOFuncs *)$tmp)->io_seek;"
		end

	c_io_close (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct _GIOChannel * channel, struct _GError * * err))((struct _GIOFuncs *)$tmp)->io_close;"
		end

	c_io_create_watch (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GSource *( *)(struct _GIOChannel * channel, int condition))((struct _GIOFuncs *)$tmp)->io_create_watch;"
		end

	c_io_free (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _GIOChannel * channel))((struct _GIOFuncs *)$tmp)->io_free;"
		end

	c_io_set_flags (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct _GIOChannel * channel, int flags, struct _GError * * err))((struct _GIOFuncs *)$tmp)->io_set_flags;"
		end

	c_io_get_flags (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct _GIOChannel * channel))((struct _GIOFuncs *)$tmp)->io_get_flags;"
		end

feature {NONE} -- C setters

	c_set_io_read (tmp: POINTER; a_io_read: POINTER)
		external
			"C inline"
		alias
			"((struct _GIOFuncs *)$tmp)->io_read = (int( *)(struct _GIOChannel * channel, char * buf, unsigned int count, unsigned int * bytes_read, struct _GError * * err))$a_io_read;"
		end

	c_set_io_write (tmp: POINTER; a_io_write: POINTER)
		external
			"C inline"
		alias
			"((struct _GIOFuncs *)$tmp)->io_write = (int( *)(struct _GIOChannel * channel, char * buf, unsigned int count, unsigned int * bytes_written, struct _GError * * err))$a_io_write;"
		end

	c_set_io_seek (tmp: POINTER; a_io_seek: POINTER)
		external
			"C inline"
		alias
			"((struct _GIOFuncs *)$tmp)->io_seek = (int( *)(struct _GIOChannel * channel, long long offset, int type, struct _GError * * err))$a_io_seek;"
		end

	c_set_io_close (tmp: POINTER; a_io_close: POINTER)
		external
			"C inline"
		alias
			"((struct _GIOFuncs *)$tmp)->io_close = (int( *)(struct _GIOChannel * channel, struct _GError * * err))$a_io_close;"
		end

	c_set_io_create_watch (tmp: POINTER; a_io_create_watch: POINTER)
		external
			"C inline"
		alias
			"((struct _GIOFuncs *)$tmp)->io_create_watch = (struct _GSource *( *)(struct _GIOChannel * channel, int condition))$a_io_create_watch;"
		end

	c_set_io_free (tmp: POINTER; a_io_free: POINTER)
		external
			"C inline"
		alias
			"((struct _GIOFuncs *)$tmp)->io_free = (void( *)(struct _GIOChannel * channel))$a_io_free;"
		end

	c_set_io_set_flags (tmp: POINTER; a_io_set_flags: POINTER)
		external
			"C inline"
		alias
			"((struct _GIOFuncs *)$tmp)->io_set_flags = (int( *)(struct _GIOChannel * channel, int flags, struct _GError * * err))$a_io_set_flags;"
		end

	c_set_io_get_flags (tmp: POINTER; a_io_get_flags: POINTER)
		external
			"C inline"
		alias
			"((struct _GIOFuncs *)$tmp)->io_get_flags = (int( *)(struct _GIOChannel * channel))$a_io_get_flags;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GIOFuncs);"
		end

end
