class
	SD_GOBJECTCLASS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	g_type_class: SD_GTYPECLASS assign set_g_type_class
		do
			create Result.make_shared (c_g_type_class (c_pointer))
		end

	construct_properties: CE_POINTER [SD_GSLIST] assign set_construct_properties
		do
			create Result.make_shared (c_construct_properties (c_pointer))
		end

	constructor: CE_ROUTINE assign set_constructor
		do
			create Result.make_shared (c_constructor (c_pointer))
		end

	set_property: CE_ROUTINE assign set_set_property
		do
			create Result.make_shared (c_set_property (c_pointer))
		end

	get_property: CE_ROUTINE assign set_get_property
		do
			create Result.make_shared (c_get_property (c_pointer))
		end

	dispose: CE_ROUTINE assign set_dispose
		do
			create Result.make_shared (c_dispose (c_pointer))
		end

	finalize: CE_ROUTINE assign set_finalize
		do
			create Result.make_shared (c_finalize (c_pointer))
		end

	dispatch_properties_changed: CE_ROUTINE assign set_dispatch_properties_changed
		do
			create Result.make_shared (c_dispatch_properties_changed (c_pointer))
		end

	notify: CE_ROUTINE assign set_notify
		do
			create Result.make_shared (c_notify (c_pointer))
		end

	constructed: CE_ROUTINE assign set_constructed
		do
			create Result.make_shared (c_constructed (c_pointer))
		end

	flags: NATURAL_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	pdummy: CE_ARRAY [CE_POINTER [ANY]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_pdummy (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_g_type_class (a_g_type_class: SD_GTYPECLASS)
		do
			g_type_class.ce_gets (a_g_type_class)
		end

	set_construct_properties (a_construct_properties: CE_POINTER [SD_GSLIST])
		do
			c_set_construct_properties (c_pointer, a_construct_properties.c_pointer)
		end

	set_constructor (a_constructor: CE_ROUTINE)
		do
			c_set_constructor (c_pointer, a_constructor.c_pointer)
		end

	set_set_property (a_set_property: CE_ROUTINE)
		do
			c_set_set_property (c_pointer, a_set_property.c_pointer)
		end

	set_get_property (a_get_property: CE_ROUTINE)
		do
			c_set_get_property (c_pointer, a_get_property.c_pointer)
		end

	set_dispose (a_dispose: CE_ROUTINE)
		do
			c_set_dispose (c_pointer, a_dispose.c_pointer)
		end

	set_finalize (a_finalize: CE_ROUTINE)
		do
			c_set_finalize (c_pointer, a_finalize.c_pointer)
		end

	set_dispatch_properties_changed (a_dispatch_properties_changed: CE_ROUTINE)
		do
			c_set_dispatch_properties_changed (c_pointer, a_dispatch_properties_changed.c_pointer)
		end

	set_notify (a_notify: CE_ROUTINE)
		do
			c_set_notify (c_pointer, a_notify.c_pointer)
		end

	set_constructed (a_constructed: CE_ROUTINE)
		do
			c_set_constructed (c_pointer, a_constructed.c_pointer)
		end

	set_flags (a_flags: NATURAL_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

feature {NONE} -- C getters

	c_g_type_class (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GTypeClass *)&((struct _GObjectClass *)$tmp)->g_type_class;"
		end

	c_construct_properties (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GSList *)((struct _GObjectClass *)$tmp)->construct_properties;"
		end

	c_constructor (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GObject *( *)(unsigned int type, unsigned int n_construct_properties, struct _GObjectConstructParam * construct_properties))((struct _GObjectClass *)$tmp)->constructor;"
		end

	c_set_property (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _GObject * object, unsigned int property_id, struct _GValue * value, struct _GParamSpec * pspec))((struct _GObjectClass *)$tmp)->set_property;"
		end

	c_get_property (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _GObject * object, unsigned int property_id, struct _GValue * value, struct _GParamSpec * pspec))((struct _GObjectClass *)$tmp)->get_property;"
		end

	c_dispose (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _GObject * object))((struct _GObjectClass *)$tmp)->dispose;"
		end

	c_finalize (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _GObject * object))((struct _GObjectClass *)$tmp)->finalize;"
		end

	c_dispatch_properties_changed (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _GObject * object, unsigned int n_pspecs, struct _GParamSpec * * pspecs))((struct _GObjectClass *)$tmp)->dispatch_properties_changed;"
		end

	c_notify (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _GObject * object, struct _GParamSpec * pspec))((struct _GObjectClass *)$tmp)->notify;"
		end

	c_constructed (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _GObject * object))((struct _GObjectClass *)$tmp)->constructed;"
		end

	c_flags (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GObjectClass *)$tmp)->flags;"
		end

	c_pdummy (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GObjectClass *tmp = (struct _GObjectClass *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->pdummy) / sizeof(tmp->pdummy[0]);
				return tmp->pdummy;
			]"
		end

feature {NONE} -- C setters

	c_set_construct_properties (tmp: POINTER; a_construct_properties: POINTER)
		external
			"C inline"
		alias
			"((struct _GObjectClass *)$tmp)->construct_properties = (struct _GSList *)$a_construct_properties;"
		end

	c_set_constructor (tmp: POINTER; a_constructor: POINTER)
		external
			"C inline"
		alias
			"((struct _GObjectClass *)$tmp)->constructor = (struct _GObject *( *)(unsigned int type, unsigned int n_construct_properties, struct _GObjectConstructParam * construct_properties))$a_constructor;"
		end

	c_set_set_property (tmp: POINTER; a_set_property: POINTER)
		external
			"C inline"
		alias
			"((struct _GObjectClass *)$tmp)->set_property = (void( *)(struct _GObject * object, unsigned int property_id, struct _GValue * value, struct _GParamSpec * pspec))$a_set_property;"
		end

	c_set_get_property (tmp: POINTER; a_get_property: POINTER)
		external
			"C inline"
		alias
			"((struct _GObjectClass *)$tmp)->get_property = (void( *)(struct _GObject * object, unsigned int property_id, struct _GValue * value, struct _GParamSpec * pspec))$a_get_property;"
		end

	c_set_dispose (tmp: POINTER; a_dispose: POINTER)
		external
			"C inline"
		alias
			"((struct _GObjectClass *)$tmp)->dispose = (void( *)(struct _GObject * object))$a_dispose;"
		end

	c_set_finalize (tmp: POINTER; a_finalize: POINTER)
		external
			"C inline"
		alias
			"((struct _GObjectClass *)$tmp)->finalize = (void( *)(struct _GObject * object))$a_finalize;"
		end

	c_set_dispatch_properties_changed (tmp: POINTER; a_dispatch_properties_changed: POINTER)
		external
			"C inline"
		alias
			"((struct _GObjectClass *)$tmp)->dispatch_properties_changed = (void( *)(struct _GObject * object, unsigned int n_pspecs, struct _GParamSpec * * pspecs))$a_dispatch_properties_changed;"
		end

	c_set_notify (tmp: POINTER; a_notify: POINTER)
		external
			"C inline"
		alias
			"((struct _GObjectClass *)$tmp)->notify = (void( *)(struct _GObject * object, struct _GParamSpec * pspec))$a_notify;"
		end

	c_set_constructed (tmp: POINTER; a_constructed: POINTER)
		external
			"C inline"
		alias
			"((struct _GObjectClass *)$tmp)->constructed = (void( *)(struct _GObject * object))$a_constructed;"
		end

	c_set_flags (tmp: POINTER; a_flags: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GObjectClass *)$tmp)->flags = $a_flags;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GObjectClass);"
		end

end
