class
	SD_GPTRARRAY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	pdata: CE_POINTER [CE_POINTER [ANY]] assign set_pdata
		do
			create Result.make_shared (c_pdata (c_pointer))
		end

	len: NATURAL_32 assign set_len
		do
			Result := c_len (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_pdata (a_pdata: CE_POINTER [CE_POINTER [ANY]])
		do
			c_set_pdata (c_pointer, a_pdata.c_pointer)
		end

	set_len (a_len: NATURAL_32)
		do
			c_set_len (c_pointer, a_len)
		end

feature {NONE} -- C getters

	c_pdata (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void * *)((struct _GPtrArray *)$tmp)->pdata;"
		end

	c_len (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GPtrArray *)$tmp)->len;"
		end

feature {NONE} -- C setters

	c_set_pdata (tmp: POINTER; a_pdata: POINTER)
		external
			"C inline"
		alias
			"((struct _GPtrArray *)$tmp)->pdata = (void * *)$a_pdata;"
		end

	c_set_len (tmp: POINTER; a_len: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GPtrArray *)$tmp)->len = $a_len;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GPtrArray);"
		end

end
