class
	SD_GSOURCE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	callback_data: CE_POINTER [ANY] assign set_callback_data
		do
			create Result.make_shared (c_callback_data (c_pointer))
		end

	callback_funcs: CE_POINTER [SD_GSOURCECALLBACKFUNCS] assign set_callback_funcs
		do
			create Result.make_shared (c_callback_funcs (c_pointer))
		end

	source_funcs: CE_POINTER [SD_GSOURCEFUNCS] assign set_source_funcs
		do
			create Result.make_shared (c_source_funcs (c_pointer))
		end

	ref_count: NATURAL_32 assign set_ref_count
		do
			Result := c_ref_count (c_pointer)
		end

	context: CE_POINTER [ANY] assign set_context
		do
			create Result.make_shared (c_context (c_pointer))
		end

	priority: INTEGER_32 assign set_priority
		do
			Result := c_priority (c_pointer)
		end

	flags: NATURAL_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	source_id: NATURAL_32 assign set_source_id
		do
			Result := c_source_id (c_pointer)
		end

	poll_fds: CE_POINTER [SD_GSLIST] assign set_poll_fds
		do
			create Result.make_shared (c_poll_fds (c_pointer))
		end

	prev: CE_POINTER [SD_GSOURCE] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	next: CE_POINTER [SD_GSOURCE] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	priv: CE_POINTER [ANY] assign set_priv
		do
			create Result.make_shared (c_priv (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_callback_data (a_callback_data: CE_POINTER [ANY])
		do
			c_set_callback_data (c_pointer, a_callback_data.c_pointer)
		end

	set_callback_funcs (a_callback_funcs: CE_POINTER [SD_GSOURCECALLBACKFUNCS])
		do
			c_set_callback_funcs (c_pointer, a_callback_funcs.c_pointer)
		end

	set_source_funcs (a_source_funcs: CE_POINTER [SD_GSOURCEFUNCS])
		do
			c_set_source_funcs (c_pointer, a_source_funcs.c_pointer)
		end

	set_ref_count (a_ref_count: NATURAL_32)
		do
			c_set_ref_count (c_pointer, a_ref_count)
		end

	set_context (a_context: CE_POINTER [ANY])
		do
			c_set_context (c_pointer, a_context.c_pointer)
		end

	set_priority (a_priority: INTEGER_32)
		do
			c_set_priority (c_pointer, a_priority)
		end

	set_flags (a_flags: NATURAL_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

	set_source_id (a_source_id: NATURAL_32)
		do
			c_set_source_id (c_pointer, a_source_id)
		end

	set_poll_fds (a_poll_fds: CE_POINTER [SD_GSLIST])
		do
			c_set_poll_fds (c_pointer, a_poll_fds.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [SD_GSOURCE])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_next (a_next: CE_POINTER [SD_GSOURCE])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_priv (a_priv: CE_POINTER [ANY])
		do
			c_set_priv (c_pointer, a_priv.c_pointer)
		end

feature {NONE} -- C getters

	c_callback_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GSource *)$tmp)->callback_data;"
		end

	c_callback_funcs (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GSourceCallbackFuncs *)((struct _GSource *)$tmp)->callback_funcs;"
		end

	c_source_funcs (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GSourceFuncs *)((struct _GSource *)$tmp)->source_funcs;"
		end

	c_ref_count (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GSource *)$tmp)->ref_count;"
		end

	c_context (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GSource *)$tmp)->context;"
		end

	c_priority (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GSource *)$tmp)->priority;"
		end

	c_flags (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GSource *)$tmp)->flags;"
		end

	c_source_id (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GSource *)$tmp)->source_id;"
		end

	c_poll_fds (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GSList *)((struct _GSource *)$tmp)->poll_fds;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GSource *)((struct _GSource *)$tmp)->prev;"
		end

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GSource *)((struct _GSource *)$tmp)->next;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GSource *)$tmp)->name;"
		end

	c_priv (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GSource *)$tmp)->priv;"
		end

feature {NONE} -- C setters

	c_set_callback_data (tmp: POINTER; a_callback_data: POINTER)
		external
			"C inline"
		alias
			"((struct _GSource *)$tmp)->callback_data = (void *)$a_callback_data;"
		end

	c_set_callback_funcs (tmp: POINTER; a_callback_funcs: POINTER)
		external
			"C inline"
		alias
			"((struct _GSource *)$tmp)->callback_funcs = (struct _GSourceCallbackFuncs *)$a_callback_funcs;"
		end

	c_set_source_funcs (tmp: POINTER; a_source_funcs: POINTER)
		external
			"C inline"
		alias
			"((struct _GSource *)$tmp)->source_funcs = (struct _GSourceFuncs *)$a_source_funcs;"
		end

	c_set_ref_count (tmp: POINTER; a_ref_count: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GSource *)$tmp)->ref_count = $a_ref_count;"
		end

	c_set_context (tmp: POINTER; a_context: POINTER)
		external
			"C inline"
		alias
			"((struct _GSource *)$tmp)->context = (void *)$a_context;"
		end

	c_set_priority (tmp: POINTER; a_priority: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GSource *)$tmp)->priority = $a_priority;"
		end

	c_set_flags (tmp: POINTER; a_flags: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GSource *)$tmp)->flags = $a_flags;"
		end

	c_set_source_id (tmp: POINTER; a_source_id: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GSource *)$tmp)->source_id = $a_source_id;"
		end

	c_set_poll_fds (tmp: POINTER; a_poll_fds: POINTER)
		external
			"C inline"
		alias
			"((struct _GSource *)$tmp)->poll_fds = (struct _GSList *)$a_poll_fds;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct _GSource *)$tmp)->prev = (struct _GSource *)$a_prev;"
		end

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct _GSource *)$tmp)->next = (struct _GSource *)$a_next;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct _GSource *)$tmp)->name = (char *)$a_name;"
		end

	c_set_priv (tmp: POINTER; a_priv: POINTER)
		external
			"C inline"
		alias
			"((struct _GSource *)$tmp)->priv = (void *)$a_priv;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GSource);"
		end

end
