class
	SD_GSOURCECALLBACKFUNCS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ref: CE_ROUTINE assign set_ref
		do
			create Result.make_shared (c_ref (c_pointer))
		end

	unref: CE_ROUTINE assign set_unref
		do
			create Result.make_shared (c_unref (c_pointer))
		end

	get: CE_ROUTINE assign set_get
		do
			create Result.make_shared (c_get (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_ref (a_ref: CE_ROUTINE)
		do
			c_set_ref (c_pointer, a_ref.c_pointer)
		end

	set_unref (a_unref: CE_ROUTINE)
		do
			c_set_unref (c_pointer, a_unref.c_pointer)
		end

	set_get (a_get: CE_ROUTINE)
		do
			c_set_get (c_pointer, a_get.c_pointer)
		end

feature {NONE} -- C getters

	c_ref (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void * cb_data))((struct _GSourceCallbackFuncs *)$tmp)->ref;"
		end

	c_unref (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void * cb_data))((struct _GSourceCallbackFuncs *)$tmp)->unref;"
		end

	c_get (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void * cb_data, struct _GSource * source, int( * * func)(void * data), void * * data))((struct _GSourceCallbackFuncs *)$tmp)->get;"
		end

feature {NONE} -- C setters

	c_set_ref (tmp: POINTER; a_ref: POINTER)
		external
			"C inline"
		alias
			"((struct _GSourceCallbackFuncs *)$tmp)->ref = (void( *)(void * cb_data))$a_ref;"
		end

	c_set_unref (tmp: POINTER; a_unref: POINTER)
		external
			"C inline"
		alias
			"((struct _GSourceCallbackFuncs *)$tmp)->unref = (void( *)(void * cb_data))$a_unref;"
		end

	c_set_get (tmp: POINTER; a_get: POINTER)
		external
			"C inline"
		alias
			"((struct _GSourceCallbackFuncs *)$tmp)->get = (void( *)(void * cb_data, struct _GSource * source, int( * * func)(void * data), void * * data))$a_get;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GSourceCallbackFuncs);"
		end

end
