class
	SD_GSOURCEFUNCS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	prepare: CE_ROUTINE assign set_prepare
		do
			create Result.make_shared (c_prepare (c_pointer))
		end

	check2: CE_ROUTINE assign set_check2
		do
			create Result.make_shared (c_check2 (c_pointer))
		end

	dispatch: CE_ROUTINE assign set_dispatch
		do
			create Result.make_shared (c_dispatch (c_pointer))
		end

	finalize: CE_ROUTINE assign set_finalize
		do
			create Result.make_shared (c_finalize (c_pointer))
		end

	closure_callback: CE_ROUTINE assign set_closure_callback
		do
			create Result.make_shared (c_closure_callback (c_pointer))
		end

	closure_marshal: CE_ROUTINE assign set_closure_marshal
		do
			create Result.make_shared (c_closure_marshal (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_prepare (a_prepare: CE_ROUTINE)
		do
			c_set_prepare (c_pointer, a_prepare.c_pointer)
		end

	set_check2 (a_check2: CE_ROUTINE)
		do
			c_set_check2 (c_pointer, a_check2.c_pointer)
		end

	set_dispatch (a_dispatch: CE_ROUTINE)
		do
			c_set_dispatch (c_pointer, a_dispatch.c_pointer)
		end

	set_finalize (a_finalize: CE_ROUTINE)
		do
			c_set_finalize (c_pointer, a_finalize.c_pointer)
		end

	set_closure_callback (a_closure_callback: CE_ROUTINE)
		do
			c_set_closure_callback (c_pointer, a_closure_callback.c_pointer)
		end

	set_closure_marshal (a_closure_marshal: CE_ROUTINE)
		do
			c_set_closure_marshal (c_pointer, a_closure_marshal.c_pointer)
		end

feature {NONE} -- C getters

	c_prepare (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct _GSource * source, int * timeout_))((struct _GSourceFuncs *)$tmp)->prepare;"
		end

	c_check2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct _GSource * source))((struct _GSourceFuncs *)$tmp)->check;"
		end

	c_dispatch (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct _GSource * source, int( * callback)(void * data), void * user_data))((struct _GSourceFuncs *)$tmp)->dispatch;"
		end

	c_finalize (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _GSource * source))((struct _GSourceFuncs *)$tmp)->finalize;"
		end

	c_closure_callback (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * data))((struct _GSourceFuncs *)$tmp)->closure_callback;"
		end

	c_closure_marshal (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)())((struct _GSourceFuncs *)$tmp)->closure_marshal;"
		end

feature {NONE} -- C setters

	c_set_prepare (tmp: POINTER; a_prepare: POINTER)
		external
			"C inline"
		alias
			"((struct _GSourceFuncs *)$tmp)->prepare = (int( *)(struct _GSource * source, int * timeout_))$a_prepare;"
		end

	c_set_check2 (tmp: POINTER; a_check2: POINTER)
		external
			"C inline"
		alias
			"((struct _GSourceFuncs *)$tmp)->check = (int( *)(struct _GSource * source))$a_check2;"
		end

	c_set_dispatch (tmp: POINTER; a_dispatch: POINTER)
		external
			"C inline"
		alias
			"((struct _GSourceFuncs *)$tmp)->dispatch = (int( *)(struct _GSource * source, int( * callback)(void * data), void * user_data))$a_dispatch;"
		end

	c_set_finalize (tmp: POINTER; a_finalize: POINTER)
		external
			"C inline"
		alias
			"((struct _GSourceFuncs *)$tmp)->finalize = (void( *)(struct _GSource * source))$a_finalize;"
		end

	c_set_closure_callback (tmp: POINTER; a_closure_callback: POINTER)
		external
			"C inline"
		alias
			"((struct _GSourceFuncs *)$tmp)->closure_callback = (int( *)(void * data))$a_closure_callback;"
		end

	c_set_closure_marshal (tmp: POINTER; a_closure_marshal: POINTER)
		external
			"C inline"
		alias
			"((struct _GSourceFuncs *)$tmp)->closure_marshal = (void( *)())$a_closure_marshal;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GSourceFuncs);"
		end

end
