class
	SD_GSTRING

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	str: CE_POINTER [INTEGER_8] assign set_str
		do
			create Result.make_shared (c_str (c_pointer))
		end

	len: NATURAL_32 assign set_len
		do
			Result := c_len (c_pointer)
		end

	allocated_len: NATURAL_32 assign set_allocated_len
		do
			Result := c_allocated_len (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_str (a_str: CE_POINTER [INTEGER_8])
		do
			c_set_str (c_pointer, a_str.c_pointer)
		end

	set_len (a_len: NATURAL_32)
		do
			c_set_len (c_pointer, a_len)
		end

	set_allocated_len (a_allocated_len: NATURAL_32)
		do
			c_set_allocated_len (c_pointer, a_allocated_len)
		end

feature {NONE} -- C getters

	c_str (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GString *)$tmp)->str;"
		end

	c_len (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GString *)$tmp)->len;"
		end

	c_allocated_len (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GString *)$tmp)->allocated_len;"
		end

feature {NONE} -- C setters

	c_set_str (tmp: POINTER; a_str: POINTER)
		external
			"C inline"
		alias
			"((struct _GString *)$tmp)->str = (char *)$a_str;"
		end

	c_set_len (tmp: POINTER; a_len: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GString *)$tmp)->len = $a_len;"
		end

	c_set_allocated_len (tmp: POINTER; a_allocated_len: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GString *)$tmp)->allocated_len = $a_allocated_len;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GString);"
		end

end
