class
	SD_GTKACCELGROUP

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent: SD_GOBJECT assign set_parent
		do
			create Result.make_shared (c_parent (c_pointer))
		end

	lock_count: NATURAL_32 assign set_lock_count
		do
			Result := c_lock_count (c_pointer)
		end

	modifier_mask: INTEGER_32 assign set_modifier_mask
		do
			Result := c_modifier_mask (c_pointer)
		end

	acceleratables: CE_POINTER [SD_GSLIST] assign set_acceleratables
		do
			create Result.make_shared (c_acceleratables (c_pointer))
		end

	n_accels: NATURAL_32 assign set_n_accels
		do
			Result := c_n_accels (c_pointer)
		end

	priv_accels: CE_POINTER [SD_GTKACCELGROUPENTRY] assign set_priv_accels
		do
			create Result.make_shared (c_priv_accels (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_parent (a_parent: SD_GOBJECT)
		do
			parent.ce_gets (a_parent)
		end

	set_lock_count (a_lock_count: NATURAL_32)
		do
			c_set_lock_count (c_pointer, a_lock_count)
		end

	set_modifier_mask (a_modifier_mask: INTEGER_32)
		do
			c_set_modifier_mask (c_pointer, a_modifier_mask)
		end

	set_acceleratables (a_acceleratables: CE_POINTER [SD_GSLIST])
		do
			c_set_acceleratables (c_pointer, a_acceleratables.c_pointer)
		end

	set_n_accels (a_n_accels: NATURAL_32)
		do
			c_set_n_accels (c_pointer, a_n_accels)
		end

	set_priv_accels (a_priv_accels: CE_POINTER [SD_GTKACCELGROUPENTRY])
		do
			c_set_priv_accels (c_pointer, a_priv_accels.c_pointer)
		end

feature {NONE} -- C getters

	c_parent (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GObject *)&((struct _GtkAccelGroup *)$tmp)->parent;"
		end

	c_lock_count (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkAccelGroup *)$tmp)->lock_count;"
		end

	c_modifier_mask (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkAccelGroup *)$tmp)->modifier_mask;"
		end

	c_acceleratables (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GSList *)((struct _GtkAccelGroup *)$tmp)->acceleratables;"
		end

	c_n_accels (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkAccelGroup *)$tmp)->n_accels;"
		end

	c_priv_accels (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkAccelGroupEntry *)((struct _GtkAccelGroup *)$tmp)->priv_accels;"
		end

feature {NONE} -- C setters

	c_set_lock_count (tmp: POINTER; a_lock_count: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkAccelGroup *)$tmp)->lock_count = $a_lock_count;"
		end

	c_set_modifier_mask (tmp: POINTER; a_modifier_mask: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkAccelGroup *)$tmp)->modifier_mask = $a_modifier_mask;"
		end

	c_set_acceleratables (tmp: POINTER; a_acceleratables: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkAccelGroup *)$tmp)->acceleratables = (struct _GSList *)$a_acceleratables;"
		end

	c_set_n_accels (tmp: POINTER; a_n_accels: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkAccelGroup *)$tmp)->n_accels = $a_n_accels;"
		end

	c_set_priv_accels (tmp: POINTER; a_priv_accels: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkAccelGroup *)$tmp)->priv_accels = (struct _GtkAccelGroupEntry *)$a_priv_accels;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkAccelGroup);"
		end

end
