class
	SD_GTKACCELGROUPENTRY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	key: SD_GTKACCELKEY assign set_key
		do
			create Result.make_shared (c_key (c_pointer))
		end

	closure: CE_POINTER [SD_GCLOSURE] assign set_closure
		do
			create Result.make_shared (c_closure (c_pointer))
		end

	accel_path_quark: NATURAL_32 assign set_accel_path_quark
		do
			Result := c_accel_path_quark (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_key (a_key: SD_GTKACCELKEY)
		do
			key.ce_gets (a_key)
		end

	set_closure (a_closure: CE_POINTER [SD_GCLOSURE])
		do
			c_set_closure (c_pointer, a_closure.c_pointer)
		end

	set_accel_path_quark (a_accel_path_quark: NATURAL_32)
		do
			c_set_accel_path_quark (c_pointer, a_accel_path_quark)
		end

feature {NONE} -- C getters

	c_key (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkAccelKey *)&((struct _GtkAccelGroupEntry *)$tmp)->key;"
		end

	c_closure (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GClosure *)((struct _GtkAccelGroupEntry *)$tmp)->closure;"
		end

	c_accel_path_quark (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkAccelGroupEntry *)$tmp)->accel_path_quark;"
		end

feature {NONE} -- C setters

	c_set_closure (tmp: POINTER; a_closure: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkAccelGroupEntry *)$tmp)->closure = (struct _GClosure *)$a_closure;"
		end

	c_set_accel_path_quark (tmp: POINTER; a_accel_path_quark: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkAccelGroupEntry *)$tmp)->accel_path_quark = $a_accel_path_quark;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkAccelGroupEntry);"
		end

end
