class
	SD_GTKBOX

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	container: SD_GTKCONTAINER assign set_container
		do
			create Result.make_shared (c_container (c_pointer))
		end

	children: CE_POINTER [SD_GLIST] assign set_children
		do
			create Result.make_shared (c_children (c_pointer))
		end

	spacing: INTEGER_16 assign set_spacing
		do
			Result := c_spacing (c_pointer)
		end

	homogeneous: NATURAL_32 assign set_homogeneous
		do
			Result := c_homogeneous (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_container (a_container: SD_GTKCONTAINER)
		do
			container.ce_gets (a_container)
		end

	set_children (a_children: CE_POINTER [SD_GLIST])
		do
			c_set_children (c_pointer, a_children.c_pointer)
		end

	set_spacing (a_spacing: INTEGER_16)
		do
			c_set_spacing (c_pointer, a_spacing)
		end

	set_homogeneous (a_homogeneous: NATURAL_32)
		do
			c_set_homogeneous (c_pointer, a_homogeneous)
		end

feature {NONE} -- C getters

	c_container (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkContainer *)&((struct _GtkBox *)$tmp)->container;"
		end

	c_children (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GList *)((struct _GtkBox *)$tmp)->children;"
		end

	c_spacing (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct _GtkBox *)$tmp)->spacing;"
		end

	c_homogeneous (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkBox *)$tmp)->homogeneous;"
		end

feature {NONE} -- C setters

	c_set_children (tmp: POINTER; a_children: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkBox *)$tmp)->children = (struct _GList *)$a_children;"
		end

	c_set_spacing (tmp: POINTER; a_spacing: INTEGER_16)
		external
			"C inline"
		alias
			"((struct _GtkBox *)$tmp)->spacing = $a_spacing;"
		end

	c_set_homogeneous (tmp: POINTER; a_homogeneous: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkBox *)$tmp)->homogeneous = $a_homogeneous;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkBox);"
		end

end
