class
	SD_GTKCONTAINER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	widget: SD_GTKWIDGET assign set_widget
		do
			create Result.make_shared (c_widget (c_pointer))
		end

	focus_child: CE_POINTER [SD_GTKWIDGET] assign set_focus_child
		do
			create Result.make_shared (c_focus_child (c_pointer))
		end

	border_width: NATURAL_32 assign set_border_width
		do
			Result := c_border_width (c_pointer)
		end

	need_resize: NATURAL_32 assign set_need_resize
		do
			Result := c_need_resize (c_pointer)
		end

	resize_mode: NATURAL_32 assign set_resize_mode
		do
			Result := c_resize_mode (c_pointer)
		end

	reallocate_redraws: NATURAL_32 assign set_reallocate_redraws
		do
			Result := c_reallocate_redraws (c_pointer)
		end

	has_focus_chain: NATURAL_32 assign set_has_focus_chain
		do
			Result := c_has_focus_chain (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_widget (a_widget: SD_GTKWIDGET)
		do
			widget.ce_gets (a_widget)
		end

	set_focus_child (a_focus_child: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_focus_child (c_pointer, a_focus_child.c_pointer)
		end

	set_border_width (a_border_width: NATURAL_32)
		do
			c_set_border_width (c_pointer, a_border_width)
		end

	set_need_resize (a_need_resize: NATURAL_32)
		do
			c_set_need_resize (c_pointer, a_need_resize)
		end

	set_resize_mode (a_resize_mode: NATURAL_32)
		do
			c_set_resize_mode (c_pointer, a_resize_mode)
		end

	set_reallocate_redraws (a_reallocate_redraws: NATURAL_32)
		do
			c_set_reallocate_redraws (c_pointer, a_reallocate_redraws)
		end

	set_has_focus_chain (a_has_focus_chain: NATURAL_32)
		do
			c_set_has_focus_chain (c_pointer, a_has_focus_chain)
		end

feature {NONE} -- C getters

	c_widget (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)&((struct _GtkContainer *)$tmp)->widget;"
		end

	c_focus_child (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkContainer *)$tmp)->focus_child;"
		end

	c_border_width (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkContainer *)$tmp)->border_width;"
		end

	c_need_resize (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkContainer *)$tmp)->need_resize;"
		end

	c_resize_mode (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkContainer *)$tmp)->resize_mode;"
		end

	c_reallocate_redraws (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkContainer *)$tmp)->reallocate_redraws;"
		end

	c_has_focus_chain (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkContainer *)$tmp)->has_focus_chain;"
		end

feature {NONE} -- C setters

	c_set_focus_child (tmp: POINTER; a_focus_child: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkContainer *)$tmp)->focus_child = (struct _GtkWidget *)$a_focus_child;"
		end

	c_set_border_width (tmp: POINTER; a_border_width: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkContainer *)$tmp)->border_width = $a_border_width;"
		end

	c_set_need_resize (tmp: POINTER; a_need_resize: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkContainer *)$tmp)->need_resize = $a_need_resize;"
		end

	c_set_resize_mode (tmp: POINTER; a_resize_mode: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkContainer *)$tmp)->resize_mode = $a_resize_mode;"
		end

	c_set_reallocate_redraws (tmp: POINTER; a_reallocate_redraws: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkContainer *)$tmp)->reallocate_redraws = $a_reallocate_redraws;"
		end

	c_set_has_focus_chain (tmp: POINTER; a_has_focus_chain: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkContainer *)$tmp)->has_focus_chain = $a_has_focus_chain;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkContainer);"
		end

end
