class
	SD_GTKDIALOG

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	window: SD_GTKWINDOW assign set_window
		do
			create Result.make_shared (c_window (c_pointer))
		end

	vbox: CE_POINTER [SD_GTKWIDGET] assign set_vbox
		do
			create Result.make_shared (c_vbox (c_pointer))
		end

	action_area: CE_POINTER [SD_GTKWIDGET] assign set_action_area
		do
			create Result.make_shared (c_action_area (c_pointer))
		end

	separator: CE_POINTER [SD_GTKWIDGET] assign set_separator
		do
			create Result.make_shared (c_separator (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_window (a_window: SD_GTKWINDOW)
		do
			window.ce_gets (a_window)
		end

	set_vbox (a_vbox: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_vbox (c_pointer, a_vbox.c_pointer)
		end

	set_action_area (a_action_area: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_action_area (c_pointer, a_action_area.c_pointer)
		end

	set_separator (a_separator: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_separator (c_pointer, a_separator.c_pointer)
		end

feature {NONE} -- C getters

	c_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWindow *)&((struct _GtkDialog *)$tmp)->window;"
		end

	c_vbox (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkDialog *)$tmp)->vbox;"
		end

	c_action_area (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkDialog *)$tmp)->action_area;"
		end

	c_separator (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkDialog *)$tmp)->separator;"
		end

feature {NONE} -- C setters

	c_set_vbox (tmp: POINTER; a_vbox: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkDialog *)$tmp)->vbox = (struct _GtkWidget *)$a_vbox;"
		end

	c_set_action_area (tmp: POINTER; a_action_area: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkDialog *)$tmp)->action_area = (struct _GtkWidget *)$a_action_area;"
		end

	c_set_separator (tmp: POINTER; a_separator: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkDialog *)$tmp)->separator = (struct _GtkWidget *)$a_separator;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkDialog);"
		end

end
