class
	SD_GTKIMAGEANIMATIONDATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	anim: CE_POINTER [ANY] assign set_anim
		do
			create Result.make_shared (c_anim (c_pointer))
		end

	iter: CE_POINTER [ANY] assign set_iter
		do
			create Result.make_shared (c_iter (c_pointer))
		end

	frame_timeout: NATURAL_32 assign set_frame_timeout
		do
			Result := c_frame_timeout (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_anim (a_anim: CE_POINTER [ANY])
		do
			c_set_anim (c_pointer, a_anim.c_pointer)
		end

	set_iter (a_iter: CE_POINTER [ANY])
		do
			c_set_iter (c_pointer, a_iter.c_pointer)
		end

	set_frame_timeout (a_frame_timeout: NATURAL_32)
		do
			c_set_frame_timeout (c_pointer, a_frame_timeout)
		end

feature {NONE} -- C getters

	c_anim (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkImageAnimationData *)$tmp)->anim;"
		end

	c_iter (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkImageAnimationData *)$tmp)->iter;"
		end

	c_frame_timeout (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkImageAnimationData *)$tmp)->frame_timeout;"
		end

feature {NONE} -- C setters

	c_set_anim (tmp: POINTER; a_anim: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkImageAnimationData *)$tmp)->anim = (void *)$a_anim;"
		end

	c_set_iter (tmp: POINTER; a_iter: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkImageAnimationData *)$tmp)->iter = (void *)$a_iter;"
		end

	c_set_frame_timeout (tmp: POINTER; a_frame_timeout: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkImageAnimationData *)$tmp)->frame_timeout = $a_frame_timeout;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkImageAnimationData);"
		end

end
