class
	SD_GTKIMAGEGICONDATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	icon: CE_POINTER [ANY] assign set_icon
		do
			create Result.make_shared (c_icon (c_pointer))
		end

	pixbuf: CE_POINTER [ANY] assign set_pixbuf
		do
			create Result.make_shared (c_pixbuf (c_pointer))
		end

	theme_change_id: NATURAL_32 assign set_theme_change_id
		do
			Result := c_theme_change_id (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_icon (a_icon: CE_POINTER [ANY])
		do
			c_set_icon (c_pointer, a_icon.c_pointer)
		end

	set_pixbuf (a_pixbuf: CE_POINTER [ANY])
		do
			c_set_pixbuf (c_pointer, a_pixbuf.c_pointer)
		end

	set_theme_change_id (a_theme_change_id: NATURAL_32)
		do
			c_set_theme_change_id (c_pointer, a_theme_change_id)
		end

feature {NONE} -- C getters

	c_icon (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkImageGIconData *)$tmp)->icon;"
		end

	c_pixbuf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkImageGIconData *)$tmp)->pixbuf;"
		end

	c_theme_change_id (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkImageGIconData *)$tmp)->theme_change_id;"
		end

feature {NONE} -- C setters

	c_set_icon (tmp: POINTER; a_icon: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkImageGIconData *)$tmp)->icon = (void *)$a_icon;"
		end

	c_set_pixbuf (tmp: POINTER; a_pixbuf: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkImageGIconData *)$tmp)->pixbuf = (void *)$a_pixbuf;"
		end

	c_set_theme_change_id (tmp: POINTER; a_theme_change_id: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkImageGIconData *)$tmp)->theme_change_id = $a_theme_change_id;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkImageGIconData);"
		end

end
