class
	SD_GTKMENUITEM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	item: SD_GTKITEM assign set_item
		do
			create Result.make_shared (c_item (c_pointer))
		end

	submenu: CE_POINTER [SD_GTKWIDGET] assign set_submenu
		do
			create Result.make_shared (c_submenu (c_pointer))
		end

	event_window: CE_POINTER [SD_GDKDRAWABLE] assign set_event_window
		do
			create Result.make_shared (c_event_window (c_pointer))
		end

	toggle_size: NATURAL_16 assign set_toggle_size
		do
			Result := c_toggle_size (c_pointer)
		end

	accelerator_width: NATURAL_16 assign set_accelerator_width
		do
			Result := c_accelerator_width (c_pointer)
		end

	accel_path: CE_POINTER [INTEGER_8] assign set_accel_path
		do
			create Result.make_shared (c_accel_path (c_pointer))
		end

	show_submenu_indicator: NATURAL_32 assign set_show_submenu_indicator
		do
			Result := c_show_submenu_indicator (c_pointer)
		end

	submenu_placement: NATURAL_32 assign set_submenu_placement
		do
			Result := c_submenu_placement (c_pointer)
		end

	submenu_direction: NATURAL_32 assign set_submenu_direction
		do
			Result := c_submenu_direction (c_pointer)
		end

	right_justify: NATURAL_32 assign set_right_justify
		do
			Result := c_right_justify (c_pointer)
		end

	timer_from_keypress: NATURAL_32 assign set_timer_from_keypress
		do
			Result := c_timer_from_keypress (c_pointer)
		end

	from_menubar: NATURAL_32 assign set_from_menubar
		do
			Result := c_from_menubar (c_pointer)
		end

	timer: NATURAL_32 assign set_timer
		do
			Result := c_timer (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_item (a_item: SD_GTKITEM)
		do
			item.ce_gets (a_item)
		end

	set_submenu (a_submenu: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_submenu (c_pointer, a_submenu.c_pointer)
		end

	set_event_window (a_event_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_event_window (c_pointer, a_event_window.c_pointer)
		end

	set_toggle_size (a_toggle_size: NATURAL_16)
		do
			c_set_toggle_size (c_pointer, a_toggle_size)
		end

	set_accelerator_width (a_accelerator_width: NATURAL_16)
		do
			c_set_accelerator_width (c_pointer, a_accelerator_width)
		end

	set_accel_path (a_accel_path: CE_POINTER [INTEGER_8])
		do
			c_set_accel_path (c_pointer, a_accel_path.c_pointer)
		end

	set_show_submenu_indicator (a_show_submenu_indicator: NATURAL_32)
		do
			c_set_show_submenu_indicator (c_pointer, a_show_submenu_indicator)
		end

	set_submenu_placement (a_submenu_placement: NATURAL_32)
		do
			c_set_submenu_placement (c_pointer, a_submenu_placement)
		end

	set_submenu_direction (a_submenu_direction: NATURAL_32)
		do
			c_set_submenu_direction (c_pointer, a_submenu_direction)
		end

	set_right_justify (a_right_justify: NATURAL_32)
		do
			c_set_right_justify (c_pointer, a_right_justify)
		end

	set_timer_from_keypress (a_timer_from_keypress: NATURAL_32)
		do
			c_set_timer_from_keypress (c_pointer, a_timer_from_keypress)
		end

	set_from_menubar (a_from_menubar: NATURAL_32)
		do
			c_set_from_menubar (c_pointer, a_from_menubar)
		end

	set_timer (a_timer: NATURAL_32)
		do
			c_set_timer (c_pointer, a_timer)
		end

feature {NONE} -- C getters

	c_item (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkItem *)&((struct _GtkMenuItem *)$tmp)->item;"
		end

	c_submenu (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkMenuItem *)$tmp)->submenu;"
		end

	c_event_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GtkMenuItem *)$tmp)->event_window;"
		end

	c_toggle_size (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GtkMenuItem *)$tmp)->toggle_size;"
		end

	c_accelerator_width (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GtkMenuItem *)$tmp)->accelerator_width;"
		end

	c_accel_path (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GtkMenuItem *)$tmp)->accel_path;"
		end

	c_show_submenu_indicator (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenuItem *)$tmp)->show_submenu_indicator;"
		end

	c_submenu_placement (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenuItem *)$tmp)->submenu_placement;"
		end

	c_submenu_direction (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenuItem *)$tmp)->submenu_direction;"
		end

	c_right_justify (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenuItem *)$tmp)->right_justify;"
		end

	c_timer_from_keypress (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenuItem *)$tmp)->timer_from_keypress;"
		end

	c_from_menubar (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenuItem *)$tmp)->from_menubar;"
		end

	c_timer (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenuItem *)$tmp)->timer;"
		end

feature {NONE} -- C setters

	c_set_submenu (tmp: POINTER; a_submenu: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkMenuItem *)$tmp)->submenu = (struct _GtkWidget *)$a_submenu;"
		end

	c_set_event_window (tmp: POINTER; a_event_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkMenuItem *)$tmp)->event_window = (struct _GdkDrawable *)$a_event_window;"
		end

	c_set_toggle_size (tmp: POINTER; a_toggle_size: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GtkMenuItem *)$tmp)->toggle_size = $a_toggle_size;"
		end

	c_set_accelerator_width (tmp: POINTER; a_accelerator_width: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GtkMenuItem *)$tmp)->accelerator_width = $a_accelerator_width;"
		end

	c_set_accel_path (tmp: POINTER; a_accel_path: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkMenuItem *)$tmp)->accel_path = (char *)$a_accel_path;"
		end

	c_set_show_submenu_indicator (tmp: POINTER; a_show_submenu_indicator: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenuItem *)$tmp)->show_submenu_indicator = $a_show_submenu_indicator;"
		end

	c_set_submenu_placement (tmp: POINTER; a_submenu_placement: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenuItem *)$tmp)->submenu_placement = $a_submenu_placement;"
		end

	c_set_submenu_direction (tmp: POINTER; a_submenu_direction: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenuItem *)$tmp)->submenu_direction = $a_submenu_direction;"
		end

	c_set_right_justify (tmp: POINTER; a_right_justify: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenuItem *)$tmp)->right_justify = $a_right_justify;"
		end

	c_set_timer_from_keypress (tmp: POINTER; a_timer_from_keypress: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenuItem *)$tmp)->timer_from_keypress = $a_timer_from_keypress;"
		end

	c_set_from_menubar (tmp: POINTER; a_from_menubar: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenuItem *)$tmp)->from_menubar = $a_from_menubar;"
		end

	c_set_timer (tmp: POINTER; a_timer: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenuItem *)$tmp)->timer = $a_timer;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkMenuItem);"
		end

end
