class
	SD_GTKMENUSHELL

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	container: SD_GTKCONTAINER assign set_container
		do
			create Result.make_shared (c_container (c_pointer))
		end

	children: CE_POINTER [SD_GLIST] assign set_children
		do
			create Result.make_shared (c_children (c_pointer))
		end

	active_menu_item: CE_POINTER [SD_GTKWIDGET] assign set_active_menu_item
		do
			create Result.make_shared (c_active_menu_item (c_pointer))
		end

	parent_menu_shell: CE_POINTER [SD_GTKWIDGET] assign set_parent_menu_shell
		do
			create Result.make_shared (c_parent_menu_shell (c_pointer))
		end

	button: NATURAL_32 assign set_button
		do
			Result := c_button (c_pointer)
		end

	activate_time: NATURAL_32 assign set_activate_time
		do
			Result := c_activate_time (c_pointer)
		end

	active: NATURAL_32 assign set_active
		do
			Result := c_active (c_pointer)
		end

	have_grab: NATURAL_32 assign set_have_grab
		do
			Result := c_have_grab (c_pointer)
		end

	have_xgrab: NATURAL_32 assign set_have_xgrab
		do
			Result := c_have_xgrab (c_pointer)
		end

	ignore_leave: NATURAL_32 assign set_ignore_leave
		do
			Result := c_ignore_leave (c_pointer)
		end

	menu_flag: NATURAL_32 assign set_menu_flag
		do
			Result := c_menu_flag (c_pointer)
		end

	ignore_enter: NATURAL_32 assign set_ignore_enter
		do
			Result := c_ignore_enter (c_pointer)
		end

	keyboard_mode: NATURAL_32 assign set_keyboard_mode
		do
			Result := c_keyboard_mode (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_container (a_container: SD_GTKCONTAINER)
		do
			container.ce_gets (a_container)
		end

	set_children (a_children: CE_POINTER [SD_GLIST])
		do
			c_set_children (c_pointer, a_children.c_pointer)
		end

	set_active_menu_item (a_active_menu_item: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_active_menu_item (c_pointer, a_active_menu_item.c_pointer)
		end

	set_parent_menu_shell (a_parent_menu_shell: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_parent_menu_shell (c_pointer, a_parent_menu_shell.c_pointer)
		end

	set_button (a_button: NATURAL_32)
		do
			c_set_button (c_pointer, a_button)
		end

	set_activate_time (a_activate_time: NATURAL_32)
		do
			c_set_activate_time (c_pointer, a_activate_time)
		end

	set_active (a_active: NATURAL_32)
		do
			c_set_active (c_pointer, a_active)
		end

	set_have_grab (a_have_grab: NATURAL_32)
		do
			c_set_have_grab (c_pointer, a_have_grab)
		end

	set_have_xgrab (a_have_xgrab: NATURAL_32)
		do
			c_set_have_xgrab (c_pointer, a_have_xgrab)
		end

	set_ignore_leave (a_ignore_leave: NATURAL_32)
		do
			c_set_ignore_leave (c_pointer, a_ignore_leave)
		end

	set_menu_flag (a_menu_flag: NATURAL_32)
		do
			c_set_menu_flag (c_pointer, a_menu_flag)
		end

	set_ignore_enter (a_ignore_enter: NATURAL_32)
		do
			c_set_ignore_enter (c_pointer, a_ignore_enter)
		end

	set_keyboard_mode (a_keyboard_mode: NATURAL_32)
		do
			c_set_keyboard_mode (c_pointer, a_keyboard_mode)
		end

feature {NONE} -- C getters

	c_container (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkContainer *)&((struct _GtkMenuShell *)$tmp)->container;"
		end

	c_children (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GList *)((struct _GtkMenuShell *)$tmp)->children;"
		end

	c_active_menu_item (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkMenuShell *)$tmp)->active_menu_item;"
		end

	c_parent_menu_shell (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkMenuShell *)$tmp)->parent_menu_shell;"
		end

	c_button (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenuShell *)$tmp)->button;"
		end

	c_activate_time (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenuShell *)$tmp)->activate_time;"
		end

	c_active (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenuShell *)$tmp)->active;"
		end

	c_have_grab (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenuShell *)$tmp)->have_grab;"
		end

	c_have_xgrab (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenuShell *)$tmp)->have_xgrab;"
		end

	c_ignore_leave (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenuShell *)$tmp)->ignore_leave;"
		end

	c_menu_flag (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenuShell *)$tmp)->menu_flag;"
		end

	c_ignore_enter (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenuShell *)$tmp)->ignore_enter;"
		end

	c_keyboard_mode (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenuShell *)$tmp)->keyboard_mode;"
		end

feature {NONE} -- C setters

	c_set_children (tmp: POINTER; a_children: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkMenuShell *)$tmp)->children = (struct _GList *)$a_children;"
		end

	c_set_active_menu_item (tmp: POINTER; a_active_menu_item: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkMenuShell *)$tmp)->active_menu_item = (struct _GtkWidget *)$a_active_menu_item;"
		end

	c_set_parent_menu_shell (tmp: POINTER; a_parent_menu_shell: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkMenuShell *)$tmp)->parent_menu_shell = (struct _GtkWidget *)$a_parent_menu_shell;"
		end

	c_set_button (tmp: POINTER; a_button: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenuShell *)$tmp)->button = $a_button;"
		end

	c_set_activate_time (tmp: POINTER; a_activate_time: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenuShell *)$tmp)->activate_time = $a_activate_time;"
		end

	c_set_active (tmp: POINTER; a_active: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenuShell *)$tmp)->active = $a_active;"
		end

	c_set_have_grab (tmp: POINTER; a_have_grab: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenuShell *)$tmp)->have_grab = $a_have_grab;"
		end

	c_set_have_xgrab (tmp: POINTER; a_have_xgrab: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenuShell *)$tmp)->have_xgrab = $a_have_xgrab;"
		end

	c_set_ignore_leave (tmp: POINTER; a_ignore_leave: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenuShell *)$tmp)->ignore_leave = $a_ignore_leave;"
		end

	c_set_menu_flag (tmp: POINTER; a_menu_flag: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenuShell *)$tmp)->menu_flag = $a_menu_flag;"
		end

	c_set_ignore_enter (tmp: POINTER; a_ignore_enter: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenuShell *)$tmp)->ignore_enter = $a_ignore_enter;"
		end

	c_set_keyboard_mode (tmp: POINTER; a_keyboard_mode: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenuShell *)$tmp)->keyboard_mode = $a_keyboard_mode;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkMenuShell);"
		end

end
