class
	SD_GTKOBJECTCLASS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent_class: SD_GOBJECTCLASS assign set_parent_class
		do
			create Result.make_shared (c_parent_class (c_pointer))
		end

	set_arg: CE_ROUTINE assign set_set_arg
		do
			create Result.make_shared (c_set_arg (c_pointer))
		end

	get_arg: CE_ROUTINE assign set_get_arg
		do
			create Result.make_shared (c_get_arg (c_pointer))
		end

	destroy: CE_ROUTINE assign set_destroy
		do
			create Result.make_shared (c_destroy (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_parent_class (a_parent_class: SD_GOBJECTCLASS)
		do
			parent_class.ce_gets (a_parent_class)
		end

	set_set_arg (a_set_arg: CE_ROUTINE)
		do
			c_set_set_arg (c_pointer, a_set_arg.c_pointer)
		end

	set_get_arg (a_get_arg: CE_ROUTINE)
		do
			c_set_get_arg (c_pointer, a_get_arg.c_pointer)
		end

	set_destroy (a_destroy: CE_ROUTINE)
		do
			c_set_destroy (c_pointer, a_destroy.c_pointer)
		end

feature {NONE} -- C getters

	c_parent_class (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GObjectClass *)&((struct _GtkObjectClass *)$tmp)->parent_class;"
		end

	c_set_arg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _GtkObject * object, struct _GtkArg * arg, unsigned int arg_id))((struct _GtkObjectClass *)$tmp)->set_arg;"
		end

	c_get_arg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _GtkObject * object, struct _GtkArg * arg, unsigned int arg_id))((struct _GtkObjectClass *)$tmp)->get_arg;"
		end

	c_destroy (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _GtkObject * object))((struct _GtkObjectClass *)$tmp)->destroy;"
		end

feature {NONE} -- C setters

	c_set_set_arg (tmp: POINTER; a_set_arg: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkObjectClass *)$tmp)->set_arg = (void( *)(struct _GtkObject * object, struct _GtkArg * arg, unsigned int arg_id))$a_set_arg;"
		end

	c_set_get_arg (tmp: POINTER; a_get_arg: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkObjectClass *)$tmp)->get_arg = (void( *)(struct _GtkObject * object, struct _GtkArg * arg, unsigned int arg_id))$a_get_arg;"
		end

	c_set_destroy (tmp: POINTER; a_destroy: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkObjectClass *)$tmp)->destroy = (void( *)(struct _GtkObject * object))$a_destroy;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkObjectClass);"
		end

end
