class
	SD_GTKPLUG

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	window: SD_GTKWINDOW assign set_window
		do
			create Result.make_shared (c_window (c_pointer))
		end

	socket_window: CE_POINTER [SD_GDKDRAWABLE] assign set_socket_window
		do
			create Result.make_shared (c_socket_window (c_pointer))
		end

	modality_window: CE_POINTER [SD_GTKWIDGET] assign set_modality_window
		do
			create Result.make_shared (c_modality_window (c_pointer))
		end

	modality_group: CE_POINTER [SD_GTKWINDOWGROUP] assign set_modality_group
		do
			create Result.make_shared (c_modality_group (c_pointer))
		end

	grabbed_keys: CE_POINTER [ANY] assign set_grabbed_keys
		do
			create Result.make_shared (c_grabbed_keys (c_pointer))
		end

	same_app: NATURAL_32 assign set_same_app
		do
			Result := c_same_app (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_window (a_window: SD_GTKWINDOW)
		do
			window.ce_gets (a_window)
		end

	set_socket_window (a_socket_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_socket_window (c_pointer, a_socket_window.c_pointer)
		end

	set_modality_window (a_modality_window: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_modality_window (c_pointer, a_modality_window.c_pointer)
		end

	set_modality_group (a_modality_group: CE_POINTER [SD_GTKWINDOWGROUP])
		do
			c_set_modality_group (c_pointer, a_modality_group.c_pointer)
		end

	set_grabbed_keys (a_grabbed_keys: CE_POINTER [ANY])
		do
			c_set_grabbed_keys (c_pointer, a_grabbed_keys.c_pointer)
		end

	set_same_app (a_same_app: NATURAL_32)
		do
			c_set_same_app (c_pointer, a_same_app)
		end

feature {NONE} -- C getters

	c_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWindow *)&((struct _GtkPlug *)$tmp)->window;"
		end

	c_socket_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GtkPlug *)$tmp)->socket_window;"
		end

	c_modality_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkPlug *)$tmp)->modality_window;"
		end

	c_modality_group (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWindowGroup *)((struct _GtkPlug *)$tmp)->modality_group;"
		end

	c_grabbed_keys (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkPlug *)$tmp)->grabbed_keys;"
		end

	c_same_app (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkPlug *)$tmp)->same_app;"
		end

feature {NONE} -- C setters

	c_set_socket_window (tmp: POINTER; a_socket_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkPlug *)$tmp)->socket_window = (struct _GdkDrawable *)$a_socket_window;"
		end

	c_set_modality_window (tmp: POINTER; a_modality_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkPlug *)$tmp)->modality_window = (struct _GtkWidget *)$a_modality_window;"
		end

	c_set_modality_group (tmp: POINTER; a_modality_group: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkPlug *)$tmp)->modality_group = (struct _GtkWindowGroup *)$a_modality_group;"
		end

	c_set_grabbed_keys (tmp: POINTER; a_grabbed_keys: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkPlug *)$tmp)->grabbed_keys = (void *)$a_grabbed_keys;"
		end

	c_set_same_app (tmp: POINTER; a_same_app: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkPlug *)$tmp)->same_app = $a_same_app;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkPlug);"
		end

end
