class
	SD_GTKRCSTYLE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent_instance: SD_GOBJECT assign set_parent_instance
		do
			create Result.make_shared (c_parent_instance (c_pointer))
		end

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	bg_pixmap_name: CE_ARRAY [CE_POINTER [INTEGER_8]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_bg_pixmap_name (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	font_desc: CE_POINTER [ANY] assign set_font_desc
		do
			create Result.make_shared (c_font_desc (c_pointer))
		end

	color_flags: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_color_flags (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	fg: CE_ARRAY [SD_GDKCOLOR]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_fg (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	bg: CE_ARRAY [SD_GDKCOLOR]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_bg (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	text: CE_ARRAY [SD_GDKCOLOR]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_text (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	base: CE_ARRAY [SD_GDKCOLOR]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_base (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	xthickness: INTEGER_32 assign set_xthickness
		do
			Result := c_xthickness (c_pointer)
		end

	ythickness: INTEGER_32 assign set_ythickness
		do
			Result := c_ythickness (c_pointer)
		end

	rc_properties: CE_POINTER [SD_GARRAY] assign set_rc_properties
		do
			create Result.make_shared (c_rc_properties (c_pointer))
		end

	rc_style_lists: CE_POINTER [SD_GSLIST] assign set_rc_style_lists
		do
			create Result.make_shared (c_rc_style_lists (c_pointer))
		end

	icon_factories: CE_POINTER [SD_GSLIST] assign set_icon_factories
		do
			create Result.make_shared (c_icon_factories (c_pointer))
		end

	engine_specified: NATURAL_32 assign set_engine_specified
		do
			Result := c_engine_specified (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance.ce_gets (a_parent_instance)
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_font_desc (a_font_desc: CE_POINTER [ANY])
		do
			c_set_font_desc (c_pointer, a_font_desc.c_pointer)
		end

	set_xthickness (a_xthickness: INTEGER_32)
		do
			c_set_xthickness (c_pointer, a_xthickness)
		end

	set_ythickness (a_ythickness: INTEGER_32)
		do
			c_set_ythickness (c_pointer, a_ythickness)
		end

	set_rc_properties (a_rc_properties: CE_POINTER [SD_GARRAY])
		do
			c_set_rc_properties (c_pointer, a_rc_properties.c_pointer)
		end

	set_rc_style_lists (a_rc_style_lists: CE_POINTER [SD_GSLIST])
		do
			c_set_rc_style_lists (c_pointer, a_rc_style_lists.c_pointer)
		end

	set_icon_factories (a_icon_factories: CE_POINTER [SD_GSLIST])
		do
			c_set_icon_factories (c_pointer, a_icon_factories.c_pointer)
		end

	set_engine_specified (a_engine_specified: NATURAL_32)
		do
			c_set_engine_specified (c_pointer, a_engine_specified)
		end

feature {NONE} -- C getters

	c_parent_instance (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GObject *)&((struct _GtkRcStyle *)$tmp)->parent_instance;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GtkRcStyle *)$tmp)->name;"
		end

	c_bg_pixmap_name (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GtkRcStyle *tmp = (struct _GtkRcStyle *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->bg_pixmap_name) / sizeof(tmp->bg_pixmap_name[0]);
				return tmp->bg_pixmap_name;
			]"
		end

	c_font_desc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkRcStyle *)$tmp)->font_desc;"
		end

	c_color_flags (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GtkRcStyle *tmp = (struct _GtkRcStyle *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->color_flags) / sizeof(tmp->color_flags[0]);
				return tmp->color_flags;
			]"
		end

	c_fg (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GtkRcStyle *tmp = (struct _GtkRcStyle *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->fg) / sizeof(tmp->fg[0]);
				return tmp->fg;
			]"
		end

	c_bg (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GtkRcStyle *tmp = (struct _GtkRcStyle *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->bg) / sizeof(tmp->bg[0]);
				return tmp->bg;
			]"
		end

	c_text (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GtkRcStyle *tmp = (struct _GtkRcStyle *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->text) / sizeof(tmp->text[0]);
				return tmp->text;
			]"
		end

	c_base (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GtkRcStyle *tmp = (struct _GtkRcStyle *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->base) / sizeof(tmp->base[0]);
				return tmp->base;
			]"
		end

	c_xthickness (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkRcStyle *)$tmp)->xthickness;"
		end

	c_ythickness (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkRcStyle *)$tmp)->ythickness;"
		end

	c_rc_properties (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GArray *)((struct _GtkRcStyle *)$tmp)->rc_properties;"
		end

	c_rc_style_lists (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GSList *)((struct _GtkRcStyle *)$tmp)->rc_style_lists;"
		end

	c_icon_factories (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GSList *)((struct _GtkRcStyle *)$tmp)->icon_factories;"
		end

	c_engine_specified (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkRcStyle *)$tmp)->engine_specified;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkRcStyle *)$tmp)->name = (char *)$a_name;"
		end

	c_set_font_desc (tmp: POINTER; a_font_desc: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkRcStyle *)$tmp)->font_desc = (void *)$a_font_desc;"
		end

	c_set_xthickness (tmp: POINTER; a_xthickness: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkRcStyle *)$tmp)->xthickness = $a_xthickness;"
		end

	c_set_ythickness (tmp: POINTER; a_ythickness: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkRcStyle *)$tmp)->ythickness = $a_ythickness;"
		end

	c_set_rc_properties (tmp: POINTER; a_rc_properties: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkRcStyle *)$tmp)->rc_properties = (struct _GArray *)$a_rc_properties;"
		end

	c_set_rc_style_lists (tmp: POINTER; a_rc_style_lists: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkRcStyle *)$tmp)->rc_style_lists = (struct _GSList *)$a_rc_style_lists;"
		end

	c_set_icon_factories (tmp: POINTER; a_icon_factories: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkRcStyle *)$tmp)->icon_factories = (struct _GSList *)$a_icon_factories;"
		end

	c_set_engine_specified (tmp: POINTER; a_engine_specified: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkRcStyle *)$tmp)->engine_specified = $a_engine_specified;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkRcStyle);"
		end

end
