class
	SD_GTKSELECTIONDATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	selection: CE_POINTER [ANY] assign set_selection
		do
			create Result.make_shared (c_selection (c_pointer))
		end

	target: CE_POINTER [ANY] assign set_target
		do
			create Result.make_shared (c_target (c_pointer))
		end

	type: CE_POINTER [ANY] assign set_type
		do
			create Result.make_shared (c_type (c_pointer))
		end

	format: INTEGER_32 assign set_format
		do
			Result := c_format (c_pointer)
		end

	data: CE_POINTER [NATURAL_8] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	length: INTEGER_32 assign set_length
		do
			Result := c_length (c_pointer)
		end

	display: CE_POINTER [SD_GDKDISPLAY] assign set_display
		do
			create Result.make_shared (c_display (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_selection (a_selection: CE_POINTER [ANY])
		do
			c_set_selection (c_pointer, a_selection.c_pointer)
		end

	set_target (a_target: CE_POINTER [ANY])
		do
			c_set_target (c_pointer, a_target.c_pointer)
		end

	set_type (a_type: CE_POINTER [ANY])
		do
			c_set_type (c_pointer, a_type.c_pointer)
		end

	set_format (a_format: INTEGER_32)
		do
			c_set_format (c_pointer, a_format)
		end

	set_data (a_data: CE_POINTER [NATURAL_8])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_length (a_length: INTEGER_32)
		do
			c_set_length (c_pointer, a_length)
		end

	set_display (a_display: CE_POINTER [SD_GDKDISPLAY])
		do
			c_set_display (c_pointer, a_display.c_pointer)
		end

feature {NONE} -- C getters

	c_selection (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkSelectionData *)$tmp)->selection;"
		end

	c_target (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkSelectionData *)$tmp)->target;"
		end

	c_type (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkSelectionData *)$tmp)->type;"
		end

	c_format (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkSelectionData *)$tmp)->format;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct _GtkSelectionData *)$tmp)->data;"
		end

	c_length (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkSelectionData *)$tmp)->length;"
		end

	c_display (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDisplay *)((struct _GtkSelectionData *)$tmp)->display;"
		end

feature {NONE} -- C setters

	c_set_selection (tmp: POINTER; a_selection: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkSelectionData *)$tmp)->selection = (void *)$a_selection;"
		end

	c_set_target (tmp: POINTER; a_target: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkSelectionData *)$tmp)->target = (void *)$a_target;"
		end

	c_set_type (tmp: POINTER; a_type: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkSelectionData *)$tmp)->type = (void *)$a_type;"
		end

	c_set_format (tmp: POINTER; a_format: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkSelectionData *)$tmp)->format = $a_format;"
		end

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkSelectionData *)$tmp)->data = (unsigned char *)$a_data;"
		end

	c_set_length (tmp: POINTER; a_length: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkSelectionData *)$tmp)->length = $a_length;"
		end

	c_set_display (tmp: POINTER; a_display: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkSelectionData *)$tmp)->display = (struct _GdkDisplay *)$a_display;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkSelectionData);"
		end

end
