class
	SD_GTKSETTINGS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent_instance: SD_GOBJECT assign set_parent_instance
		do
			create Result.make_shared (c_parent_instance (c_pointer))
		end

	queued_settings: CE_POINTER [ANY] assign set_queued_settings
		do
			create Result.make_shared (c_queued_settings (c_pointer))
		end

	property_values: CE_POINTER [ANY] assign set_property_values
		do
			create Result.make_shared (c_property_values (c_pointer))
		end

	rc_context: CE_POINTER [ANY] assign set_rc_context
		do
			create Result.make_shared (c_rc_context (c_pointer))
		end

	screen: CE_POINTER [SD_GDKSCREEN] assign set_screen
		do
			create Result.make_shared (c_screen (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance.ce_gets (a_parent_instance)
		end

	set_queued_settings (a_queued_settings: CE_POINTER [ANY])
		do
			c_set_queued_settings (c_pointer, a_queued_settings.c_pointer)
		end

	set_property_values (a_property_values: CE_POINTER [ANY])
		do
			c_set_property_values (c_pointer, a_property_values.c_pointer)
		end

	set_rc_context (a_rc_context: CE_POINTER [ANY])
		do
			c_set_rc_context (c_pointer, a_rc_context.c_pointer)
		end

	set_screen (a_screen: CE_POINTER [SD_GDKSCREEN])
		do
			c_set_screen (c_pointer, a_screen.c_pointer)
		end

feature {NONE} -- C getters

	c_parent_instance (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GObject *)&((struct _GtkSettings *)$tmp)->parent_instance;"
		end

	c_queued_settings (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkSettings *)$tmp)->queued_settings;"
		end

	c_property_values (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkSettings *)$tmp)->property_values;"
		end

	c_rc_context (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkSettings *)$tmp)->rc_context;"
		end

	c_screen (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkScreen *)((struct _GtkSettings *)$tmp)->screen;"
		end

feature {NONE} -- C setters

	c_set_queued_settings (tmp: POINTER; a_queued_settings: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkSettings *)$tmp)->queued_settings = (void *)$a_queued_settings;"
		end

	c_set_property_values (tmp: POINTER; a_property_values: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkSettings *)$tmp)->property_values = (void *)$a_property_values;"
		end

	c_set_rc_context (tmp: POINTER; a_rc_context: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkSettings *)$tmp)->rc_context = (void *)$a_rc_context;"
		end

	c_set_screen (tmp: POINTER; a_screen: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkSettings *)$tmp)->screen = (struct _GdkScreen *)$a_screen;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkSettings);"
		end

end
