class
	SD_GTKTABLE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	container: SD_GTKCONTAINER assign set_container
		do
			create Result.make_shared (c_container (c_pointer))
		end

	children: CE_POINTER [SD_GLIST] assign set_children
		do
			create Result.make_shared (c_children (c_pointer))
		end

	rows: CE_POINTER [SD_GTKTABLEROWCOL] assign set_rows
		do
			create Result.make_shared (c_rows (c_pointer))
		end

	cols: CE_POINTER [SD_GTKTABLEROWCOL] assign set_cols
		do
			create Result.make_shared (c_cols (c_pointer))
		end

	nrows: NATURAL_16 assign set_nrows
		do
			Result := c_nrows (c_pointer)
		end

	ncols: NATURAL_16 assign set_ncols
		do
			Result := c_ncols (c_pointer)
		end

	column_spacing: NATURAL_16 assign set_column_spacing
		do
			Result := c_column_spacing (c_pointer)
		end

	row_spacing: NATURAL_16 assign set_row_spacing
		do
			Result := c_row_spacing (c_pointer)
		end

	homogeneous: NATURAL_32 assign set_homogeneous
		do
			Result := c_homogeneous (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_container (a_container: SD_GTKCONTAINER)
		do
			container.ce_gets (a_container)
		end

	set_children (a_children: CE_POINTER [SD_GLIST])
		do
			c_set_children (c_pointer, a_children.c_pointer)
		end

	set_rows (a_rows: CE_POINTER [SD_GTKTABLEROWCOL])
		do
			c_set_rows (c_pointer, a_rows.c_pointer)
		end

	set_cols (a_cols: CE_POINTER [SD_GTKTABLEROWCOL])
		do
			c_set_cols (c_pointer, a_cols.c_pointer)
		end

	set_nrows (a_nrows: NATURAL_16)
		do
			c_set_nrows (c_pointer, a_nrows)
		end

	set_ncols (a_ncols: NATURAL_16)
		do
			c_set_ncols (c_pointer, a_ncols)
		end

	set_column_spacing (a_column_spacing: NATURAL_16)
		do
			c_set_column_spacing (c_pointer, a_column_spacing)
		end

	set_row_spacing (a_row_spacing: NATURAL_16)
		do
			c_set_row_spacing (c_pointer, a_row_spacing)
		end

	set_homogeneous (a_homogeneous: NATURAL_32)
		do
			c_set_homogeneous (c_pointer, a_homogeneous)
		end

feature {NONE} -- C getters

	c_container (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkContainer *)&((struct _GtkTable *)$tmp)->container;"
		end

	c_children (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GList *)((struct _GtkTable *)$tmp)->children;"
		end

	c_rows (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkTableRowCol *)((struct _GtkTable *)$tmp)->rows;"
		end

	c_cols (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkTableRowCol *)((struct _GtkTable *)$tmp)->cols;"
		end

	c_nrows (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GtkTable *)$tmp)->nrows;"
		end

	c_ncols (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GtkTable *)$tmp)->ncols;"
		end

	c_column_spacing (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GtkTable *)$tmp)->column_spacing;"
		end

	c_row_spacing (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GtkTable *)$tmp)->row_spacing;"
		end

	c_homogeneous (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkTable *)$tmp)->homogeneous;"
		end

feature {NONE} -- C setters

	c_set_children (tmp: POINTER; a_children: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkTable *)$tmp)->children = (struct _GList *)$a_children;"
		end

	c_set_rows (tmp: POINTER; a_rows: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkTable *)$tmp)->rows = (struct _GtkTableRowCol *)$a_rows;"
		end

	c_set_cols (tmp: POINTER; a_cols: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkTable *)$tmp)->cols = (struct _GtkTableRowCol *)$a_cols;"
		end

	c_set_nrows (tmp: POINTER; a_nrows: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GtkTable *)$tmp)->nrows = $a_nrows;"
		end

	c_set_ncols (tmp: POINTER; a_ncols: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GtkTable *)$tmp)->ncols = $a_ncols;"
		end

	c_set_column_spacing (tmp: POINTER; a_column_spacing: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GtkTable *)$tmp)->column_spacing = $a_column_spacing;"
		end

	c_set_row_spacing (tmp: POINTER; a_row_spacing: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GtkTable *)$tmp)->row_spacing = $a_row_spacing;"
		end

	c_set_homogeneous (tmp: POINTER; a_homogeneous: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkTable *)$tmp)->homogeneous = $a_homogeneous;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkTable);"
		end

end
