class
	SD_GTKTOOLTIPSDATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	tooltips: CE_POINTER [SD_GTKTOOLTIPS] assign set_tooltips
		do
			create Result.make_shared (c_tooltips (c_pointer))
		end

	widget: CE_POINTER [SD_GTKWIDGET] assign set_widget
		do
			create Result.make_shared (c_widget (c_pointer))
		end

	tip_text: CE_POINTER [INTEGER_8] assign set_tip_text
		do
			create Result.make_shared (c_tip_text (c_pointer))
		end

	tip_private: CE_POINTER [INTEGER_8] assign set_tip_private
		do
			create Result.make_shared (c_tip_private (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_tooltips (a_tooltips: CE_POINTER [SD_GTKTOOLTIPS])
		do
			c_set_tooltips (c_pointer, a_tooltips.c_pointer)
		end

	set_widget (a_widget: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_widget (c_pointer, a_widget.c_pointer)
		end

	set_tip_text (a_tip_text: CE_POINTER [INTEGER_8])
		do
			c_set_tip_text (c_pointer, a_tip_text.c_pointer)
		end

	set_tip_private (a_tip_private: CE_POINTER [INTEGER_8])
		do
			c_set_tip_private (c_pointer, a_tip_private.c_pointer)
		end

feature {NONE} -- C getters

	c_tooltips (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkTooltips *)((struct _GtkTooltipsData *)$tmp)->tooltips;"
		end

	c_widget (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkTooltipsData *)$tmp)->widget;"
		end

	c_tip_text (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GtkTooltipsData *)$tmp)->tip_text;"
		end

	c_tip_private (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GtkTooltipsData *)$tmp)->tip_private;"
		end

feature {NONE} -- C setters

	c_set_tooltips (tmp: POINTER; a_tooltips: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkTooltipsData *)$tmp)->tooltips = (struct _GtkTooltips *)$a_tooltips;"
		end

	c_set_widget (tmp: POINTER; a_widget: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkTooltipsData *)$tmp)->widget = (struct _GtkWidget *)$a_widget;"
		end

	c_set_tip_text (tmp: POINTER; a_tip_text: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkTooltipsData *)$tmp)->tip_text = (char *)$a_tip_text;"
		end

	c_set_tip_private (tmp: POINTER; a_tip_private: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkTooltipsData *)$tmp)->tip_private = (char *)$a_tip_private;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkTooltipsData);"
		end

end
