class
	SD_GTKTYPEINFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type_name: CE_POINTER [INTEGER_8] assign set_type_name
		do
			create Result.make_shared (c_type_name (c_pointer))
		end

	object_size: NATURAL_32 assign set_object_size
		do
			Result := c_object_size (c_pointer)
		end

	class_size: NATURAL_32 assign set_class_size
		do
			Result := c_class_size (c_pointer)
		end

	class_init_func: CE_ROUTINE assign set_class_init_func
		do
			create Result.make_shared (c_class_init_func (c_pointer))
		end

	object_init_func: CE_ROUTINE assign set_object_init_func
		do
			create Result.make_shared (c_object_init_func (c_pointer))
		end

	reserved_1: CE_POINTER [ANY] assign set_reserved_1
		do
			create Result.make_shared (c_reserved_1 (c_pointer))
		end

	reserved_2: CE_POINTER [ANY] assign set_reserved_2
		do
			create Result.make_shared (c_reserved_2 (c_pointer))
		end

	base_class_init_func: CE_ROUTINE assign set_base_class_init_func
		do
			create Result.make_shared (c_base_class_init_func (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_type_name (a_type_name: CE_POINTER [INTEGER_8])
		do
			c_set_type_name (c_pointer, a_type_name.c_pointer)
		end

	set_object_size (a_object_size: NATURAL_32)
		do
			c_set_object_size (c_pointer, a_object_size)
		end

	set_class_size (a_class_size: NATURAL_32)
		do
			c_set_class_size (c_pointer, a_class_size)
		end

	set_class_init_func (a_class_init_func: CE_ROUTINE)
		do
			c_set_class_init_func (c_pointer, a_class_init_func.c_pointer)
		end

	set_object_init_func (a_object_init_func: CE_ROUTINE)
		do
			c_set_object_init_func (c_pointer, a_object_init_func.c_pointer)
		end

	set_reserved_1 (a_reserved_1: CE_POINTER [ANY])
		do
			c_set_reserved_1 (c_pointer, a_reserved_1.c_pointer)
		end

	set_reserved_2 (a_reserved_2: CE_POINTER [ANY])
		do
			c_set_reserved_2 (c_pointer, a_reserved_2.c_pointer)
		end

	set_base_class_init_func (a_base_class_init_func: CE_ROUTINE)
		do
			c_set_base_class_init_func (c_pointer, a_base_class_init_func.c_pointer)
		end

feature {NONE} -- C getters

	c_type_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GtkTypeInfo *)$tmp)->type_name;"
		end

	c_object_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkTypeInfo *)$tmp)->object_size;"
		end

	c_class_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkTypeInfo *)$tmp)->class_size;"
		end

	c_class_init_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void * g_class))((struct _GtkTypeInfo *)$tmp)->class_init_func;"
		end

	c_object_init_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _GTypeInstance * instance, void * g_class))((struct _GtkTypeInfo *)$tmp)->object_init_func;"
		end

	c_reserved_1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkTypeInfo *)$tmp)->reserved_1;"
		end

	c_reserved_2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkTypeInfo *)$tmp)->reserved_2;"
		end

	c_base_class_init_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void * g_class))((struct _GtkTypeInfo *)$tmp)->base_class_init_func;"
		end

feature {NONE} -- C setters

	c_set_type_name (tmp: POINTER; a_type_name: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkTypeInfo *)$tmp)->type_name = (char *)$a_type_name;"
		end

	c_set_object_size (tmp: POINTER; a_object_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkTypeInfo *)$tmp)->object_size = $a_object_size;"
		end

	c_set_class_size (tmp: POINTER; a_class_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkTypeInfo *)$tmp)->class_size = $a_class_size;"
		end

	c_set_class_init_func (tmp: POINTER; a_class_init_func: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkTypeInfo *)$tmp)->class_init_func = (void( *)(void * g_class))$a_class_init_func;"
		end

	c_set_object_init_func (tmp: POINTER; a_object_init_func: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkTypeInfo *)$tmp)->object_init_func = (void( *)(struct _GTypeInstance * instance, void * g_class))$a_object_init_func;"
		end

	c_set_reserved_1 (tmp: POINTER; a_reserved_1: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkTypeInfo *)$tmp)->reserved_1 = (void *)$a_reserved_1;"
		end

	c_set_reserved_2 (tmp: POINTER; a_reserved_2: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkTypeInfo *)$tmp)->reserved_2 = (void *)$a_reserved_2;"
		end

	c_set_base_class_init_func (tmp: POINTER; a_base_class_init_func: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkTypeInfo *)$tmp)->base_class_init_func = (void( *)(void * g_class))$a_base_class_init_func;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkTypeInfo);"
		end

end
