class
	SD_GTKWIDGET

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	object: SD_GTKOBJECT assign set_object
		do
			create Result.make_shared (c_object (c_pointer))
		end

	private_flags: NATURAL_16 assign set_private_flags
		do
			Result := c_private_flags (c_pointer)
		end

	state: NATURAL_8 assign set_state
		do
			Result := c_state (c_pointer)
		end

	saved_state: NATURAL_8 assign set_saved_state
		do
			Result := c_saved_state (c_pointer)
		end

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	style: CE_POINTER [SD_GTKSTYLE] assign set_style
		do
			create Result.make_shared (c_style (c_pointer))
		end

	requisition: SD_GTKREQUISITION assign set_requisition
		do
			create Result.make_shared (c_requisition (c_pointer))
		end

	allocation: SD_GDKRECTANGLE assign set_allocation
		do
			create Result.make_shared (c_allocation (c_pointer))
		end

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window
		do
			create Result.make_shared (c_window (c_pointer))
		end

	parent: CE_POINTER [SD_GTKWIDGET] assign set_parent
		do
			create Result.make_shared (c_parent (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_object (a_object: SD_GTKOBJECT)
		do
			object.ce_gets (a_object)
		end

	set_private_flags (a_private_flags: NATURAL_16)
		do
			c_set_private_flags (c_pointer, a_private_flags)
		end

	set_state (a_state: NATURAL_8)
		do
			c_set_state (c_pointer, a_state)
		end

	set_saved_state (a_saved_state: NATURAL_8)
		do
			c_set_saved_state (c_pointer, a_saved_state)
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_style (a_style: CE_POINTER [SD_GTKSTYLE])
		do
			c_set_style (c_pointer, a_style.c_pointer)
		end

	set_requisition (a_requisition: SD_GTKREQUISITION)
		do
			requisition.ce_gets (a_requisition)
		end

	set_allocation (a_allocation: SD_GDKRECTANGLE)
		do
			allocation.ce_gets (a_allocation)
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_window (c_pointer, a_window.c_pointer)
		end

	set_parent (a_parent: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_parent (c_pointer, a_parent.c_pointer)
		end

feature {NONE} -- C getters

	c_object (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkObject *)&((struct _GtkWidget *)$tmp)->object;"
		end

	c_private_flags (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GtkWidget *)$tmp)->private_flags;"
		end

	c_state (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct _GtkWidget *)$tmp)->state;"
		end

	c_saved_state (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct _GtkWidget *)$tmp)->saved_state;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GtkWidget *)$tmp)->name;"
		end

	c_style (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkStyle *)((struct _GtkWidget *)$tmp)->style;"
		end

	c_requisition (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkRequisition *)&((struct _GtkWidget *)$tmp)->requisition;"
		end

	c_allocation (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkRectangle *)&((struct _GtkWidget *)$tmp)->allocation;"
		end

	c_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GtkWidget *)$tmp)->window;"
		end

	c_parent (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkWidget *)$tmp)->parent;"
		end

feature {NONE} -- C setters

	c_set_private_flags (tmp: POINTER; a_private_flags: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GtkWidget *)$tmp)->private_flags = $a_private_flags;"
		end

	c_set_state (tmp: POINTER; a_state: NATURAL_8)
		external
			"C inline"
		alias
			"((struct _GtkWidget *)$tmp)->state = $a_state;"
		end

	c_set_saved_state (tmp: POINTER; a_saved_state: NATURAL_8)
		external
			"C inline"
		alias
			"((struct _GtkWidget *)$tmp)->saved_state = $a_saved_state;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkWidget *)$tmp)->name = (char *)$a_name;"
		end

	c_set_style (tmp: POINTER; a_style: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkWidget *)$tmp)->style = (struct _GtkStyle *)$a_style;"
		end

	c_set_window (tmp: POINTER; a_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkWidget *)$tmp)->window = (struct _GdkDrawable *)$a_window;"
		end

	c_set_parent (tmp: POINTER; a_parent: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkWidget *)$tmp)->parent = (struct _GtkWidget *)$a_parent;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkWidget);"
		end

end
