class
	SD_GVALUE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	g_type: NATURAL_32 assign set_g_type
		do
			Result := c_g_type (c_pointer)
		end

	data: CE_ARRAY [SD_DATA]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_data (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_g_type (a_g_type: NATURAL_32)
		do
			c_set_g_type (c_pointer, a_g_type)
		end

feature {NONE} -- C getters

	c_g_type (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GValue *)$tmp)->g_type;"
		end

	c_data (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GValue *tmp = (struct _GValue *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->data) / sizeof(tmp->data[0]);
				return tmp->data;
			]"
		end

feature {NONE} -- C setters

	c_set_g_type (tmp: POINTER; a_g_type: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GValue *)$tmp)->g_type = $a_g_type;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GValue);"
		end

end
