class
	SD_PANGOANALYSIS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	shape_engine: CE_POINTER [ANY] assign set_shape_engine
		do
			create Result.make_shared (c_shape_engine (c_pointer))
		end

	lang_engine: CE_POINTER [ANY] assign set_lang_engine
		do
			create Result.make_shared (c_lang_engine (c_pointer))
		end

	font: CE_POINTER [ANY] assign set_font
		do
			create Result.make_shared (c_font (c_pointer))
		end

	level: NATURAL_8 assign set_level
		do
			Result := c_level (c_pointer)
		end

	gravity: NATURAL_8 assign set_gravity
		do
			Result := c_gravity (c_pointer)
		end

	flags: NATURAL_8 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	script: NATURAL_8 assign set_script
		do
			Result := c_script (c_pointer)
		end

	language: CE_POINTER [ANY] assign set_language
		do
			create Result.make_shared (c_language (c_pointer))
		end

	extra_attrs: CE_POINTER [SD_GSLIST] assign set_extra_attrs
		do
			create Result.make_shared (c_extra_attrs (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_shape_engine (a_shape_engine: CE_POINTER [ANY])
		do
			c_set_shape_engine (c_pointer, a_shape_engine.c_pointer)
		end

	set_lang_engine (a_lang_engine: CE_POINTER [ANY])
		do
			c_set_lang_engine (c_pointer, a_lang_engine.c_pointer)
		end

	set_font (a_font: CE_POINTER [ANY])
		do
			c_set_font (c_pointer, a_font.c_pointer)
		end

	set_level (a_level: NATURAL_8)
		do
			c_set_level (c_pointer, a_level)
		end

	set_gravity (a_gravity: NATURAL_8)
		do
			c_set_gravity (c_pointer, a_gravity)
		end

	set_flags (a_flags: NATURAL_8)
		do
			c_set_flags (c_pointer, a_flags)
		end

	set_script (a_script: NATURAL_8)
		do
			c_set_script (c_pointer, a_script)
		end

	set_language (a_language: CE_POINTER [ANY])
		do
			c_set_language (c_pointer, a_language.c_pointer)
		end

	set_extra_attrs (a_extra_attrs: CE_POINTER [SD_GSLIST])
		do
			c_set_extra_attrs (c_pointer, a_extra_attrs.c_pointer)
		end

feature {NONE} -- C getters

	c_shape_engine (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _PangoAnalysis *)$tmp)->shape_engine;"
		end

	c_lang_engine (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _PangoAnalysis *)$tmp)->lang_engine;"
		end

	c_font (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _PangoAnalysis *)$tmp)->font;"
		end

	c_level (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct _PangoAnalysis *)$tmp)->level;"
		end

	c_gravity (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct _PangoAnalysis *)$tmp)->gravity;"
		end

	c_flags (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct _PangoAnalysis *)$tmp)->flags;"
		end

	c_script (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct _PangoAnalysis *)$tmp)->script;"
		end

	c_language (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _PangoAnalysis *)$tmp)->language;"
		end

	c_extra_attrs (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GSList *)((struct _PangoAnalysis *)$tmp)->extra_attrs;"
		end

feature {NONE} -- C setters

	c_set_shape_engine (tmp: POINTER; a_shape_engine: POINTER)
		external
			"C inline"
		alias
			"((struct _PangoAnalysis *)$tmp)->shape_engine = (void *)$a_shape_engine;"
		end

	c_set_lang_engine (tmp: POINTER; a_lang_engine: POINTER)
		external
			"C inline"
		alias
			"((struct _PangoAnalysis *)$tmp)->lang_engine = (void *)$a_lang_engine;"
		end

	c_set_font (tmp: POINTER; a_font: POINTER)
		external
			"C inline"
		alias
			"((struct _PangoAnalysis *)$tmp)->font = (void *)$a_font;"
		end

	c_set_level (tmp: POINTER; a_level: NATURAL_8)
		external
			"C inline"
		alias
			"((struct _PangoAnalysis *)$tmp)->level = $a_level;"
		end

	c_set_gravity (tmp: POINTER; a_gravity: NATURAL_8)
		external
			"C inline"
		alias
			"((struct _PangoAnalysis *)$tmp)->gravity = $a_gravity;"
		end

	c_set_flags (tmp: POINTER; a_flags: NATURAL_8)
		external
			"C inline"
		alias
			"((struct _PangoAnalysis *)$tmp)->flags = $a_flags;"
		end

	c_set_script (tmp: POINTER; a_script: NATURAL_8)
		external
			"C inline"
		alias
			"((struct _PangoAnalysis *)$tmp)->script = $a_script;"
		end

	c_set_language (tmp: POINTER; a_language: POINTER)
		external
			"C inline"
		alias
			"((struct _PangoAnalysis *)$tmp)->language = (void *)$a_language;"
		end

	c_set_extra_attrs (tmp: POINTER; a_extra_attrs: POINTER)
		external
			"C inline"
		alias
			"((struct _PangoAnalysis *)$tmp)->extra_attrs = (struct _GSList *)$a_extra_attrs;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _PangoAnalysis);"
		end

end
