class
	SD_PANGOGLYPHINFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	glyph: NATURAL_32 assign set_glyph
		do
			Result := c_glyph (c_pointer)
		end

	geometry: SD_PANGOGLYPHGEOMETRY assign set_geometry
		do
			create Result.make_shared (c_geometry (c_pointer))
		end

	geometry_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct _PangoGlyphInfo, geometry);"
		end

	attr: SD_PANGOGLYPHVISATTR assign set_attr
		do
			create Result.make_shared (c_attr (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_glyph (a_glyph: NATURAL_32)
		do
			c_set_glyph (c_pointer, a_glyph)
		end

	set_geometry (a_geometry: SD_PANGOGLYPHGEOMETRY)
		do
			geometry.ce_gets (a_geometry)
		end

	set_attr (a_attr: SD_PANGOGLYPHVISATTR)
		do
			attr.ce_gets (a_attr)
		end

feature {NONE} -- C getters

	c_glyph (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _PangoGlyphInfo *)$tmp)->glyph;"
		end

	c_geometry (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _PangoGlyphGeometry *)&((struct _PangoGlyphInfo *)$tmp)->geometry;"
		end

	c_attr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _PangoGlyphVisAttr *)&((struct _PangoGlyphInfo *)$tmp)->attr;"
		end

feature {NONE} -- C setters

	c_set_glyph (tmp: POINTER; a_glyph: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _PangoGlyphInfo *)$tmp)->glyph = $a_glyph;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _PangoGlyphInfo);"
		end

end
