class
	SD_PANGOGLYPHSTRING

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	num_glyphs: INTEGER_32 assign set_num_glyphs
		do
			Result := c_num_glyphs (c_pointer)
		end

	glyphs: CE_POINTER [SD_PANGOGLYPHINFO] assign set_glyphs
		do
			create Result.make_shared (c_glyphs (c_pointer))
		end

	log_clusters: CE_POINTER [INTEGER_32] assign set_log_clusters
		do
			create Result.make_shared (c_log_clusters (c_pointer))
		end

	space: INTEGER_32 assign set_space
		do
			Result := c_space (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_num_glyphs (a_num_glyphs: INTEGER_32)
		do
			c_set_num_glyphs (c_pointer, a_num_glyphs)
		end

	set_glyphs (a_glyphs: CE_POINTER [SD_PANGOGLYPHINFO])
		do
			c_set_glyphs (c_pointer, a_glyphs.c_pointer)
		end

	set_log_clusters (a_log_clusters: CE_POINTER [INTEGER_32])
		do
			c_set_log_clusters (c_pointer, a_log_clusters.c_pointer)
		end

	set_space (a_space: INTEGER_32)
		do
			c_set_space (c_pointer, a_space)
		end

feature {NONE} -- C getters

	c_num_glyphs (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _PangoGlyphString *)$tmp)->num_glyphs;"
		end

	c_glyphs (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _PangoGlyphInfo *)((struct _PangoGlyphString *)$tmp)->glyphs;"
		end

	c_log_clusters (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int *)((struct _PangoGlyphString *)$tmp)->log_clusters;"
		end

	c_space (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _PangoGlyphString *)$tmp)->space;"
		end

feature {NONE} -- C setters

	c_set_num_glyphs (tmp: POINTER; a_num_glyphs: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _PangoGlyphString *)$tmp)->num_glyphs = $a_num_glyphs;"
		end

	c_set_glyphs (tmp: POINTER; a_glyphs: POINTER)
		external
			"C inline"
		alias
			"((struct _PangoGlyphString *)$tmp)->glyphs = (struct _PangoGlyphInfo *)$a_glyphs;"
		end

	c_set_log_clusters (tmp: POINTER; a_log_clusters: POINTER)
		external
			"C inline"
		alias
			"((struct _PangoGlyphString *)$tmp)->log_clusters = (int *)$a_log_clusters;"
		end

	c_set_space (tmp: POINTER; a_space: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _PangoGlyphString *)$tmp)->space = $a_space;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _PangoGlyphString);"
		end

end
