class
	SD_PANGOITEM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	offset: INTEGER_32 assign set_offset
		do
			Result := c_offset (c_pointer)
		end

	length: INTEGER_32 assign set_length
		do
			Result := c_length (c_pointer)
		end

	num_chars: INTEGER_32 assign set_num_chars
		do
			Result := c_num_chars (c_pointer)
		end

	analysis: SD_PANGOANALYSIS assign set_analysis
		do
			create Result.make_shared (c_analysis (c_pointer))
		end

	analysis_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct _PangoItem, analysis);"
		end

feature {ANY} -- Eiffel setters

	set_offset (a_offset: INTEGER_32)
		do
			c_set_offset (c_pointer, a_offset)
		end

	set_length (a_length: INTEGER_32)
		do
			c_set_length (c_pointer, a_length)
		end

	set_num_chars (a_num_chars: INTEGER_32)
		do
			c_set_num_chars (c_pointer, a_num_chars)
		end

	set_analysis (a_analysis: SD_PANGOANALYSIS)
		do
			analysis.ce_gets (a_analysis)
		end

feature {NONE} -- C getters

	c_offset (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _PangoItem *)$tmp)->offset;"
		end

	c_length (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _PangoItem *)$tmp)->length;"
		end

	c_num_chars (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _PangoItem *)$tmp)->num_chars;"
		end

	c_analysis (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _PangoAnalysis *)&((struct _PangoItem *)$tmp)->analysis;"
		end

feature {NONE} -- C setters

	c_set_offset (tmp: POINTER; a_offset: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _PangoItem *)$tmp)->offset = $a_offset;"
		end

	c_set_length (tmp: POINTER; a_length: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _PangoItem *)$tmp)->length = $a_length;"
		end

	c_set_num_chars (tmp: POINTER; a_num_chars: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _PangoItem *)$tmp)->num_chars = $a_num_chars;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _PangoItem);"
		end

end
