class
	SD_SIGACTION

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sigaction_handler: SD_SIGACTION_HANDLER assign set_sigaction_handler
		do
			create Result.make_shared (c_sigaction_handler (c_pointer))
		end

	sa_mask: SD_SIGSET_T assign set_sa_mask
		do
			create Result.make_shared (c_sa_mask (c_pointer))
		end

	sa_mask_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct sigaction, sa_mask);"
		end

	sa_flags: INTEGER_32 assign set_sa_flags
		do
			Result := c_sa_flags (c_pointer)
		end

	sa_restorer: CE_ROUTINE assign set_sa_restorer
		do
			create Result.make_shared (c_sa_restorer (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_sigaction_handler (a_sigaction_handler: SD_SIGACTION_HANDLER)
		do
			sigaction_handler.ce_gets (a_sigaction_handler)
		end

	set_sa_mask (a_sa_mask: SD_SIGSET_T)
		do
			sa_mask.ce_gets (a_sa_mask)
		end

	set_sa_flags (a_sa_flags: INTEGER_32)
		do
			c_set_sa_flags (c_pointer, a_sa_flags)
		end

	set_sa_restorer (a_sa_restorer: CE_ROUTINE)
		do
			c_set_sa_restorer (c_pointer, a_sa_restorer.c_pointer)
		end

feature {NONE} -- C getters

	c_sigaction_handler (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion___sigaction_handler_50 *)&((struct sigaction *)$tmp)->__sigaction_handler;"
		end

	c_sa_mask (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (sigset_t *)&((struct sigaction *)$tmp)->sa_mask;"
		end

	c_sa_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct sigaction *)$tmp)->sa_flags;"
		end

	c_sa_restorer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)())((struct sigaction *)$tmp)->sa_restorer;"
		end

feature {NONE} -- C setters

	c_set_sa_flags (tmp: POINTER; a_sa_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct sigaction *)$tmp)->sa_flags = $a_sa_flags;"
		end

	c_set_sa_restorer (tmp: POINTER; a_sa_restorer: POINTER)
		external
			"C inline"
		alias
			"((struct sigaction *)$tmp)->sa_restorer = (void( *)())$a_sa_restorer;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct sigaction);"
		end

end
