class
	SD_SIGALTSTACK

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ss_sp: CE_POINTER [ANY] assign set_ss_sp
		do
			create Result.make_shared (c_ss_sp (c_pointer))
		end

	ss_flags: INTEGER_32 assign set_ss_flags
		do
			Result := c_ss_flags (c_pointer)
		end

	ss_size: NATURAL_32 assign set_ss_size
		do
			Result := c_ss_size (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_ss_sp (a_ss_sp: CE_POINTER [ANY])
		do
			c_set_ss_sp (c_pointer, a_ss_sp.c_pointer)
		end

	set_ss_flags (a_ss_flags: INTEGER_32)
		do
			c_set_ss_flags (c_pointer, a_ss_flags)
		end

	set_ss_size (a_ss_size: NATURAL_32)
		do
			c_set_ss_size (c_pointer, a_ss_size)
		end

feature {NONE} -- C getters

	c_ss_sp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct sigaltstack *)$tmp)->ss_sp;"
		end

	c_ss_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct sigaltstack *)$tmp)->ss_flags;"
		end

	c_ss_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct sigaltstack *)$tmp)->ss_size;"
		end

feature {NONE} -- C setters

	c_set_ss_sp (tmp: POINTER; a_ss_sp: POINTER)
		external
			"C inline"
		alias
			"((struct sigaltstack *)$tmp)->ss_sp = (void *)$a_ss_sp;"
		end

	c_set_ss_flags (tmp: POINTER; a_ss_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct sigaltstack *)$tmp)->ss_flags = $a_ss_flags;"
		end

	c_set_ss_size (tmp: POINTER; a_ss_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct sigaltstack *)$tmp)->ss_size = $a_ss_size;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct sigaltstack);"
		end

end
