class
	SD_SIGINFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	si_signo: INTEGER_32 assign set_si_signo
		do
			Result := c_si_signo (c_pointer)
		end

	si_errno: INTEGER_32 assign set_si_errno
		do
			Result := c_si_errno (c_pointer)
		end

	si_code: INTEGER_32 assign set_si_code
		do
			Result := c_si_code (c_pointer)
		end

	sifields: SD_SIFIELDS assign set_sifields
		do
			create Result.make_shared (c_sifields (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_si_signo (a_si_signo: INTEGER_32)
		do
			c_set_si_signo (c_pointer, a_si_signo)
		end

	set_si_errno (a_si_errno: INTEGER_32)
		do
			c_set_si_errno (c_pointer, a_si_errno)
		end

	set_si_code (a_si_code: INTEGER_32)
		do
			c_set_si_code (c_pointer, a_si_code)
		end

	set_sifields (a_sifields: SD_SIFIELDS)
		do
			sifields.ce_gets (a_sifields)
		end

feature {NONE} -- C getters

	c_si_signo (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct siginfo *)$tmp)->si_signo;"
		end

	c_si_errno (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct siginfo *)$tmp)->si_errno;"
		end

	c_si_code (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct siginfo *)$tmp)->si_code;"
		end

	c_sifields (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion__sifields_32 *)&((struct siginfo *)$tmp)->_sifields;"
		end

feature {NONE} -- C setters

	c_set_si_signo (tmp: POINTER; a_si_signo: INTEGER_32)
		external
			"C inline"
		alias
			"((struct siginfo *)$tmp)->si_signo = $a_si_signo;"
		end

	c_set_si_errno (tmp: POINTER; a_si_errno: INTEGER_32)
		external
			"C inline"
		alias
			"((struct siginfo *)$tmp)->si_errno = $a_si_errno;"
		end

	c_set_si_code (tmp: POINTER; a_si_code: INTEGER_32)
		external
			"C inline"
		alias
			"((struct siginfo *)$tmp)->si_code = $a_si_code;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct siginfo);"
		end

end
