class
	SD_SOCKADDR_IN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sin_family: NATURAL_16 assign set_sin_family
		do
			Result := c_sin_family (c_pointer)
		end

	sin_port: NATURAL_16 assign set_sin_port
		do
			Result := c_sin_port (c_pointer)
		end

	sin_addr: SD_IN_ADDR assign set_sin_addr
		do
			create Result.make_shared (c_sin_addr (c_pointer))
		end

	sin_addr_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct sockaddr_in, sin_addr);"
		end

	sin_zero: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_sin_zero (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_sin_family (a_sin_family: NATURAL_16)
		do
			c_set_sin_family (c_pointer, a_sin_family)
		end

	set_sin_port (a_sin_port: NATURAL_16)
		do
			c_set_sin_port (c_pointer, a_sin_port)
		end

	set_sin_addr (a_sin_addr: SD_IN_ADDR)
		do
			sin_addr.ce_gets (a_sin_addr)
		end

feature {NONE} -- C getters

	c_sin_family (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct sockaddr_in *)$tmp)->sin_family;"
		end

	c_sin_port (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct sockaddr_in *)$tmp)->sin_port;"
		end

	c_sin_addr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct in_addr *)&((struct sockaddr_in *)$tmp)->sin_addr;"
		end

	c_sin_zero (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct sockaddr_in *tmp = (struct sockaddr_in *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->sin_zero) / sizeof(tmp->sin_zero[0]);
				return tmp->sin_zero;
			]"
		end

feature {NONE} -- C setters

	c_set_sin_family (tmp: POINTER; a_sin_family: NATURAL_16)
		external
			"C inline"
		alias
			"((struct sockaddr_in *)$tmp)->sin_family = $a_sin_family;"
		end

	c_set_sin_port (tmp: POINTER; a_sin_port: NATURAL_16)
		external
			"C inline"
		alias
			"((struct sockaddr_in *)$tmp)->sin_port = $a_sin_port;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct sockaddr_in);"
		end

end
