class
	SD_SYSINFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	uptime: INTEGER_32 assign set_uptime
		do
			Result := c_uptime (c_pointer)
		end

	loads: CE_ARRAY [NATURAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_loads (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	totalram: NATURAL_32 assign set_totalram
		do
			Result := c_totalram (c_pointer)
		end

	freeram: NATURAL_32 assign set_freeram
		do
			Result := c_freeram (c_pointer)
		end

	sharedram: NATURAL_32 assign set_sharedram
		do
			Result := c_sharedram (c_pointer)
		end

	bufferram: NATURAL_32 assign set_bufferram
		do
			Result := c_bufferram (c_pointer)
		end

	totalswap: NATURAL_32 assign set_totalswap
		do
			Result := c_totalswap (c_pointer)
		end

	freeswap: NATURAL_32 assign set_freeswap
		do
			Result := c_freeswap (c_pointer)
		end

	procs: NATURAL_16 assign set_procs
		do
			Result := c_procs (c_pointer)
		end

	pad: NATURAL_16 assign set_pad
		do
			Result := c_pad (c_pointer)
		end

	totalhigh: NATURAL_32 assign set_totalhigh
		do
			Result := c_totalhigh (c_pointer)
		end

	freehigh: NATURAL_32 assign set_freehigh
		do
			Result := c_freehigh (c_pointer)
		end

	mem_unit: NATURAL_32 assign set_mem_unit
		do
			Result := c_mem_unit (c_pointer)
		end

	f: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_f (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_uptime (a_uptime: INTEGER_32)
		do
			c_set_uptime (c_pointer, a_uptime)
		end

	set_totalram (a_totalram: NATURAL_32)
		do
			c_set_totalram (c_pointer, a_totalram)
		end

	set_freeram (a_freeram: NATURAL_32)
		do
			c_set_freeram (c_pointer, a_freeram)
		end

	set_sharedram (a_sharedram: NATURAL_32)
		do
			c_set_sharedram (c_pointer, a_sharedram)
		end

	set_bufferram (a_bufferram: NATURAL_32)
		do
			c_set_bufferram (c_pointer, a_bufferram)
		end

	set_totalswap (a_totalswap: NATURAL_32)
		do
			c_set_totalswap (c_pointer, a_totalswap)
		end

	set_freeswap (a_freeswap: NATURAL_32)
		do
			c_set_freeswap (c_pointer, a_freeswap)
		end

	set_procs (a_procs: NATURAL_16)
		do
			c_set_procs (c_pointer, a_procs)
		end

	set_pad (a_pad: NATURAL_16)
		do
			c_set_pad (c_pointer, a_pad)
		end

	set_totalhigh (a_totalhigh: NATURAL_32)
		do
			c_set_totalhigh (c_pointer, a_totalhigh)
		end

	set_freehigh (a_freehigh: NATURAL_32)
		do
			c_set_freehigh (c_pointer, a_freehigh)
		end

	set_mem_unit (a_mem_unit: NATURAL_32)
		do
			c_set_mem_unit (c_pointer, a_mem_unit)
		end

feature {NONE} -- C getters

	c_uptime (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct sysinfo *)$tmp)->uptime;"
		end

	c_loads (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct sysinfo *tmp = (struct sysinfo *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->loads) / sizeof(tmp->loads[0]);
				return tmp->loads;
			]"
		end

	c_totalram (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct sysinfo *)$tmp)->totalram;"
		end

	c_freeram (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct sysinfo *)$tmp)->freeram;"
		end

	c_sharedram (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct sysinfo *)$tmp)->sharedram;"
		end

	c_bufferram (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct sysinfo *)$tmp)->bufferram;"
		end

	c_totalswap (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct sysinfo *)$tmp)->totalswap;"
		end

	c_freeswap (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct sysinfo *)$tmp)->freeswap;"
		end

	c_procs (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct sysinfo *)$tmp)->procs;"
		end

	c_pad (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct sysinfo *)$tmp)->pad;"
		end

	c_totalhigh (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct sysinfo *)$tmp)->totalhigh;"
		end

	c_freehigh (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct sysinfo *)$tmp)->freehigh;"
		end

	c_mem_unit (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct sysinfo *)$tmp)->mem_unit;"
		end

	c_f (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct sysinfo *tmp = (struct sysinfo *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->_f) / sizeof(tmp->_f[0]);
				return tmp->_f;
			]"
		end

feature {NONE} -- C setters

	c_set_uptime (tmp: POINTER; a_uptime: INTEGER_32)
		external
			"C inline"
		alias
			"((struct sysinfo *)$tmp)->uptime = $a_uptime;"
		end

	c_set_totalram (tmp: POINTER; a_totalram: NATURAL_32)
		external
			"C inline"
		alias
			"((struct sysinfo *)$tmp)->totalram = $a_totalram;"
		end

	c_set_freeram (tmp: POINTER; a_freeram: NATURAL_32)
		external
			"C inline"
		alias
			"((struct sysinfo *)$tmp)->freeram = $a_freeram;"
		end

	c_set_sharedram (tmp: POINTER; a_sharedram: NATURAL_32)
		external
			"C inline"
		alias
			"((struct sysinfo *)$tmp)->sharedram = $a_sharedram;"
		end

	c_set_bufferram (tmp: POINTER; a_bufferram: NATURAL_32)
		external
			"C inline"
		alias
			"((struct sysinfo *)$tmp)->bufferram = $a_bufferram;"
		end

	c_set_totalswap (tmp: POINTER; a_totalswap: NATURAL_32)
		external
			"C inline"
		alias
			"((struct sysinfo *)$tmp)->totalswap = $a_totalswap;"
		end

	c_set_freeswap (tmp: POINTER; a_freeswap: NATURAL_32)
		external
			"C inline"
		alias
			"((struct sysinfo *)$tmp)->freeswap = $a_freeswap;"
		end

	c_set_procs (tmp: POINTER; a_procs: NATURAL_16)
		external
			"C inline"
		alias
			"((struct sysinfo *)$tmp)->procs = $a_procs;"
		end

	c_set_pad (tmp: POINTER; a_pad: NATURAL_16)
		external
			"C inline"
		alias
			"((struct sysinfo *)$tmp)->pad = $a_pad;"
		end

	c_set_totalhigh (tmp: POINTER; a_totalhigh: NATURAL_32)
		external
			"C inline"
		alias
			"((struct sysinfo *)$tmp)->totalhigh = $a_totalhigh;"
		end

	c_set_freehigh (tmp: POINTER; a_freehigh: NATURAL_32)
		external
			"C inline"
		alias
			"((struct sysinfo *)$tmp)->freehigh = $a_freehigh;"
		end

	c_set_mem_unit (tmp: POINTER; a_mem_unit: NATURAL_32)
		external
			"C inline"
		alias
			"((struct sysinfo *)$tmp)->mem_unit = $a_mem_unit;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct sysinfo);"
		end

end
