class
	SD_XEVENT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	xany: SD_XANYEVENT assign set_xany
		do
			create Result.make_shared (c_xany (c_pointer))
		end

	xkey: SD_XKEYEVENT assign set_xkey
		do
			create Result.make_shared (c_xkey (c_pointer))
		end

	xbutton: SD_XBUTTONEVENT assign set_xbutton
		do
			create Result.make_shared (c_xbutton (c_pointer))
		end

	xmotion: SD_XMOTIONEVENT assign set_xmotion
		do
			create Result.make_shared (c_xmotion (c_pointer))
		end

	xcrossing: SD_XCROSSINGEVENT assign set_xcrossing
		do
			create Result.make_shared (c_xcrossing (c_pointer))
		end

	xfocus: SD_XFOCUSCHANGEEVENT assign set_xfocus
		do
			create Result.make_shared (c_xfocus (c_pointer))
		end

	xexpose: SD_XEXPOSEEVENT assign set_xexpose
		do
			create Result.make_shared (c_xexpose (c_pointer))
		end

	xgraphicsexpose: SD_XGRAPHICSEXPOSEEVENT assign set_xgraphicsexpose
		do
			create Result.make_shared (c_xgraphicsexpose (c_pointer))
		end

	xnoexpose: SD_XNOEXPOSEEVENT assign set_xnoexpose
		do
			create Result.make_shared (c_xnoexpose (c_pointer))
		end

	xvisibility: SD_XVISIBILITYEVENT assign set_xvisibility
		do
			create Result.make_shared (c_xvisibility (c_pointer))
		end

	xcreatewindow: SD_XCREATEWINDOWEVENT assign set_xcreatewindow
		do
			create Result.make_shared (c_xcreatewindow (c_pointer))
		end

	xdestroywindow: SD_XDESTROYWINDOWEVENT assign set_xdestroywindow
		do
			create Result.make_shared (c_xdestroywindow (c_pointer))
		end

	xunmap: SD_XUNMAPEVENT assign set_xunmap
		do
			create Result.make_shared (c_xunmap (c_pointer))
		end

	xmap: SD_XMAPEVENT assign set_xmap
		do
			create Result.make_shared (c_xmap (c_pointer))
		end

	xmaprequest: SD_XMAPREQUESTEVENT assign set_xmaprequest
		do
			create Result.make_shared (c_xmaprequest (c_pointer))
		end

	xreparent: SD_XREPARENTEVENT assign set_xreparent
		do
			create Result.make_shared (c_xreparent (c_pointer))
		end

	xconfigure: SD_XCONFIGUREEVENT assign set_xconfigure
		do
			create Result.make_shared (c_xconfigure (c_pointer))
		end

	xgravity: SD_XGRAVITYEVENT assign set_xgravity
		do
			create Result.make_shared (c_xgravity (c_pointer))
		end

	xresizerequest: SD_XRESIZEREQUESTEVENT assign set_xresizerequest
		do
			create Result.make_shared (c_xresizerequest (c_pointer))
		end

	xconfigurerequest: SD_XCONFIGUREREQUESTEVENT assign set_xconfigurerequest
		do
			create Result.make_shared (c_xconfigurerequest (c_pointer))
		end

	xcirculate: SD_XCIRCULATEEVENT assign set_xcirculate
		do
			create Result.make_shared (c_xcirculate (c_pointer))
		end

	xcirculaterequest: SD_XCIRCULATEREQUESTEVENT assign set_xcirculaterequest
		do
			create Result.make_shared (c_xcirculaterequest (c_pointer))
		end

	xproperty: SD_XPROPERTYEVENT assign set_xproperty
		do
			create Result.make_shared (c_xproperty (c_pointer))
		end

	xproperty_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(union _XEvent, xproperty);"
		end

	xselectionclear: SD_XSELECTIONCLEAREVENT assign set_xselectionclear
		do
			create Result.make_shared (c_xselectionclear (c_pointer))
		end

	xselectionrequest: SD_XSELECTIONREQUESTEVENT assign set_xselectionrequest
		do
			create Result.make_shared (c_xselectionrequest (c_pointer))
		end

	xselection: SD_XSELECTIONEVENT assign set_xselection
		do
			create Result.make_shared (c_xselection (c_pointer))
		end

	xcolormap: SD_XCOLORMAPEVENT assign set_xcolormap
		do
			create Result.make_shared (c_xcolormap (c_pointer))
		end

	xclient: SD_XCLIENTMESSAGEEVENT assign set_xclient
		do
			create Result.make_shared (c_xclient (c_pointer))
		end

	xmapping: SD_XMAPPINGEVENT assign set_xmapping
		do
			create Result.make_shared (c_xmapping (c_pointer))
		end

	xerror: SD_XERROREVENT assign set_xerror
		do
			create Result.make_shared (c_xerror (c_pointer))
		end

	xkeymap: SD_XKEYMAPEVENT assign set_xkeymap
		do
			create Result.make_shared (c_xkeymap (c_pointer))
		end

	xgeneric: SD_XGENERICEVENT assign set_xgeneric
		do
			create Result.make_shared (c_xgeneric (c_pointer))
		end

	xcookie: SD_XGENERICEVENTCOOKIE assign set_xcookie
		do
			create Result.make_shared (c_xcookie (c_pointer))
		end

	pad: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_pad (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_xany (a_xany: SD_XANYEVENT)
		do
			xany.ce_gets (a_xany)
		end

	set_xkey (a_xkey: SD_XKEYEVENT)
		do
			xkey.ce_gets (a_xkey)
		end

	set_xbutton (a_xbutton: SD_XBUTTONEVENT)
		do
			xbutton.ce_gets (a_xbutton)
		end

	set_xmotion (a_xmotion: SD_XMOTIONEVENT)
		do
			xmotion.ce_gets (a_xmotion)
		end

	set_xcrossing (a_xcrossing: SD_XCROSSINGEVENT)
		do
			xcrossing.ce_gets (a_xcrossing)
		end

	set_xfocus (a_xfocus: SD_XFOCUSCHANGEEVENT)
		do
			xfocus.ce_gets (a_xfocus)
		end

	set_xexpose (a_xexpose: SD_XEXPOSEEVENT)
		do
			xexpose.ce_gets (a_xexpose)
		end

	set_xgraphicsexpose (a_xgraphicsexpose: SD_XGRAPHICSEXPOSEEVENT)
		do
			xgraphicsexpose.ce_gets (a_xgraphicsexpose)
		end

	set_xnoexpose (a_xnoexpose: SD_XNOEXPOSEEVENT)
		do
			xnoexpose.ce_gets (a_xnoexpose)
		end

	set_xvisibility (a_xvisibility: SD_XVISIBILITYEVENT)
		do
			xvisibility.ce_gets (a_xvisibility)
		end

	set_xcreatewindow (a_xcreatewindow: SD_XCREATEWINDOWEVENT)
		do
			xcreatewindow.ce_gets (a_xcreatewindow)
		end

	set_xdestroywindow (a_xdestroywindow: SD_XDESTROYWINDOWEVENT)
		do
			xdestroywindow.ce_gets (a_xdestroywindow)
		end

	set_xunmap (a_xunmap: SD_XUNMAPEVENT)
		do
			xunmap.ce_gets (a_xunmap)
		end

	set_xmap (a_xmap: SD_XMAPEVENT)
		do
			xmap.ce_gets (a_xmap)
		end

	set_xmaprequest (a_xmaprequest: SD_XMAPREQUESTEVENT)
		do
			xmaprequest.ce_gets (a_xmaprequest)
		end

	set_xreparent (a_xreparent: SD_XREPARENTEVENT)
		do
			xreparent.ce_gets (a_xreparent)
		end

	set_xconfigure (a_xconfigure: SD_XCONFIGUREEVENT)
		do
			xconfigure.ce_gets (a_xconfigure)
		end

	set_xgravity (a_xgravity: SD_XGRAVITYEVENT)
		do
			xgravity.ce_gets (a_xgravity)
		end

	set_xresizerequest (a_xresizerequest: SD_XRESIZEREQUESTEVENT)
		do
			xresizerequest.ce_gets (a_xresizerequest)
		end

	set_xconfigurerequest (a_xconfigurerequest: SD_XCONFIGUREREQUESTEVENT)
		do
			xconfigurerequest.ce_gets (a_xconfigurerequest)
		end

	set_xcirculate (a_xcirculate: SD_XCIRCULATEEVENT)
		do
			xcirculate.ce_gets (a_xcirculate)
		end

	set_xcirculaterequest (a_xcirculaterequest: SD_XCIRCULATEREQUESTEVENT)
		do
			xcirculaterequest.ce_gets (a_xcirculaterequest)
		end

	set_xproperty (a_xproperty: SD_XPROPERTYEVENT)
		do
			xproperty.ce_gets (a_xproperty)
		end

	set_xselectionclear (a_xselectionclear: SD_XSELECTIONCLEAREVENT)
		do
			xselectionclear.ce_gets (a_xselectionclear)
		end

	set_xselectionrequest (a_xselectionrequest: SD_XSELECTIONREQUESTEVENT)
		do
			xselectionrequest.ce_gets (a_xselectionrequest)
		end

	set_xselection (a_xselection: SD_XSELECTIONEVENT)
		do
			xselection.ce_gets (a_xselection)
		end

	set_xcolormap (a_xcolormap: SD_XCOLORMAPEVENT)
		do
			xcolormap.ce_gets (a_xcolormap)
		end

	set_xclient (a_xclient: SD_XCLIENTMESSAGEEVENT)
		do
			xclient.ce_gets (a_xclient)
		end

	set_xmapping (a_xmapping: SD_XMAPPINGEVENT)
		do
			xmapping.ce_gets (a_xmapping)
		end

	set_xerror (a_xerror: SD_XERROREVENT)
		do
			xerror.ce_gets (a_xerror)
		end

	set_xkeymap (a_xkeymap: SD_XKEYMAPEVENT)
		do
			xkeymap.ce_gets (a_xkeymap)
		end

	set_xgeneric (a_xgeneric: SD_XGENERICEVENT)
		do
			xgeneric.ce_gets (a_xgeneric)
		end

	set_xcookie (a_xcookie: SD_XGENERICEVENTCOOKIE)
		do
			xcookie.ce_gets (a_xcookie)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union _XEvent *)$tmp)->type;"
		end

	c_xany (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XAnyEvent *)&((union _XEvent *)$tmp)->xany;"
		end

	c_xkey (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XKeyEvent *)&((union _XEvent *)$tmp)->xkey;"
		end

	c_xbutton (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XButtonEvent *)&((union _XEvent *)$tmp)->xbutton;"
		end

	c_xmotion (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XMotionEvent *)&((union _XEvent *)$tmp)->xmotion;"
		end

	c_xcrossing (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XCrossingEvent *)&((union _XEvent *)$tmp)->xcrossing;"
		end

	c_xfocus (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XFocusChangeEvent *)&((union _XEvent *)$tmp)->xfocus;"
		end

	c_xexpose (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XExposeEvent *)&((union _XEvent *)$tmp)->xexpose;"
		end

	c_xgraphicsexpose (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XGraphicsExposeEvent *)&((union _XEvent *)$tmp)->xgraphicsexpose;"
		end

	c_xnoexpose (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XNoExposeEvent *)&((union _XEvent *)$tmp)->xnoexpose;"
		end

	c_xvisibility (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XVisibilityEvent *)&((union _XEvent *)$tmp)->xvisibility;"
		end

	c_xcreatewindow (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XCreateWindowEvent *)&((union _XEvent *)$tmp)->xcreatewindow;"
		end

	c_xdestroywindow (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XDestroyWindowEvent *)&((union _XEvent *)$tmp)->xdestroywindow;"
		end

	c_xunmap (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XUnmapEvent *)&((union _XEvent *)$tmp)->xunmap;"
		end

	c_xmap (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XMapEvent *)&((union _XEvent *)$tmp)->xmap;"
		end

	c_xmaprequest (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XMapRequestEvent *)&((union _XEvent *)$tmp)->xmaprequest;"
		end

	c_xreparent (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XReparentEvent *)&((union _XEvent *)$tmp)->xreparent;"
		end

	c_xconfigure (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XConfigureEvent *)&((union _XEvent *)$tmp)->xconfigure;"
		end

	c_xgravity (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XGravityEvent *)&((union _XEvent *)$tmp)->xgravity;"
		end

	c_xresizerequest (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XResizeRequestEvent *)&((union _XEvent *)$tmp)->xresizerequest;"
		end

	c_xconfigurerequest (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XConfigureRequestEvent *)&((union _XEvent *)$tmp)->xconfigurerequest;"
		end

	c_xcirculate (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XCirculateEvent *)&((union _XEvent *)$tmp)->xcirculate;"
		end

	c_xcirculaterequest (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XCirculateRequestEvent *)&((union _XEvent *)$tmp)->xcirculaterequest;"
		end

	c_xproperty (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XPropertyEvent *)&((union _XEvent *)$tmp)->xproperty;"
		end

	c_xselectionclear (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XSelectionClearEvent *)&((union _XEvent *)$tmp)->xselectionclear;"
		end

	c_xselectionrequest (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XSelectionRequestEvent *)&((union _XEvent *)$tmp)->xselectionrequest;"
		end

	c_xselection (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XSelectionEvent *)&((union _XEvent *)$tmp)->xselection;"
		end

	c_xcolormap (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XColormapEvent *)&((union _XEvent *)$tmp)->xcolormap;"
		end

	c_xclient (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XClientMessageEvent *)&((union _XEvent *)$tmp)->xclient;"
		end

	c_xmapping (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XMappingEvent *)&((union _XEvent *)$tmp)->xmapping;"
		end

	c_xerror (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XErrorEvent *)&((union _XEvent *)$tmp)->xerror;"
		end

	c_xkeymap (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XKeymapEvent *)&((union _XEvent *)$tmp)->xkeymap;"
		end

	c_xgeneric (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XGenericEvent *)&((union _XEvent *)$tmp)->xgeneric;"
		end

	c_xcookie (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (XGenericEventCookie *)&((union _XEvent *)$tmp)->xcookie;"
		end

	c_pad (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				union _XEvent *tmp = (union _XEvent *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->pad) / sizeof(tmp->pad[0]);
				return tmp->pad;
			]"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((union _XEvent *)$tmp)->type = $a_type;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(union _XEvent);"
		end

end
