class
	SD_XEXTDATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	number: INTEGER_32 assign set_number
		do
			Result := c_number (c_pointer)
		end

	next: CE_POINTER [SD_XEXTDATA] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	free_private: CE_ROUTINE assign set_free_private
		do
			create Result.make_shared (c_free_private (c_pointer))
		end

	private_data: CE_POINTER [INTEGER_8] assign set_private_data
		do
			create Result.make_shared (c_private_data (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_number (a_number: INTEGER_32)
		do
			c_set_number (c_pointer, a_number)
		end

	set_next (a_next: CE_POINTER [SD_XEXTDATA])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_free_private (a_free_private: CE_ROUTINE)
		do
			c_set_free_private (c_pointer, a_free_private.c_pointer)
		end

	set_private_data (a_private_data: CE_POINTER [INTEGER_8])
		do
			c_set_private_data (c_pointer, a_private_data.c_pointer)
		end

feature {NONE} -- C getters

	c_number (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _XExtData *)$tmp)->number;"
		end

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _XExtData *)((struct _XExtData *)$tmp)->next;"
		end

	c_free_private (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct _XExtData * extension))((struct _XExtData *)$tmp)->free_private;"
		end

	c_private_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _XExtData *)$tmp)->private_data;"
		end

feature {NONE} -- C setters

	c_set_number (tmp: POINTER; a_number: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _XExtData *)$tmp)->number = $a_number;"
		end

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct _XExtData *)$tmp)->next = (struct _XExtData *)$a_next;"
		end

	c_set_free_private (tmp: POINTER; a_free_private: POINTER)
		external
			"C inline"
		alias
			"((struct _XExtData *)$tmp)->free_private = (int( *)(struct _XExtData * extension))$a_free_private;"
		end

	c_set_private_data (tmp: POINTER; a_private_data: POINTER)
		external
			"C inline"
		alias
			"((struct _XExtData *)$tmp)->private_data = (char *)$a_private_data;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _XExtData);"
		end

end
