deferred class
	S_GLIB

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- attributes

	g_utf8_skip: CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_g_utf8_skip)
		end

			c_g_utf8_skip: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return g_utf8_skip;"
		end

feature {ANY} -- routines

	g_free (a_mem: CE_POINTER [ANY])
		do
			c_g_free (a_mem.c_pointer)
		end

	c_g_free (a_mem: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"g_free($a_mem);"
		end

	g_return_if_fail_warning (a_log_domain: CE_POINTER [INTEGER_8]; a_pretty_function: CE_POINTER [INTEGER_8]; a_expression: CE_POINTER [INTEGER_8])
		do
			c_g_return_if_fail_warning (a_log_domain.c_pointer, a_pretty_function.c_pointer, a_expression.c_pointer)
		end

	c_g_return_if_fail_warning (a_log_domain: POINTER; a_pretty_function: POINTER; a_expression: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"g_return_if_fail_warning($a_log_domain, $a_pretty_function, $a_expression);"
		end

	g_unichar_tolower (a_c: NATURAL_32): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return g_unichar_tolower($a_c);"
		end

	g_utf8_get_char (a_p: CE_POINTER [INTEGER_8]): NATURAL_32
		do
			Result := c_g_utf8_get_char (a_p.c_pointer)
		end

	c_g_utf8_get_char (a_p: POINTER): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return g_utf8_get_char($a_p);"
		end

	g_strdup (a_str: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_g_strdup (a_str.c_pointer))
		end

	c_g_strdup (a_str: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return g_strdup($a_str);"
		end

	g_error_free (a_error: CE_POINTER [SD_GERROR])
		do
			c_g_error_free (a_error.c_pointer)
		end

	c_g_error_free (a_error: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"g_error_free($a_error);"
		end

	g_set_application_name (a_application_name: CE_POINTER [INTEGER_8])
		do
			c_g_set_application_name (a_application_name.c_pointer)
		end

	c_g_set_application_name (a_application_name: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"g_set_application_name($a_application_name);"
		end

	g_malloc0_n (a_n_blocks: NATURAL_32; a_n_block_bytes: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_g_malloc0_n (a_n_blocks, a_n_block_bytes))
		end

	c_g_malloc0_n (a_n_blocks: NATURAL_32; a_n_block_bytes: NATURAL_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return g_malloc0_n($a_n_blocks, $a_n_block_bytes);"
		end

	g_list_free (a_list: CE_POINTER [SD_GLIST])
		do
			c_g_list_free (a_list.c_pointer)
		end

	c_g_list_free (a_list: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"g_list_free($a_list);"
		end

	g_list_prepend (a_list: CE_POINTER [SD_GLIST]; a_data: CE_POINTER [ANY]): CE_POINTER [SD_GLIST]
		do
			create Result.make_shared (c_g_list_prepend (a_list.c_pointer, a_data.c_pointer))
		end

	c_g_list_prepend (a_list: POINTER; a_data: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return g_list_prepend($a_list, $a_data);"
		end

	g_list_delete_link (a_list: CE_POINTER [SD_GLIST]; a_link_: CE_POINTER [SD_GLIST]): CE_POINTER [SD_GLIST]
		do
			create Result.make_shared (c_g_list_delete_link (a_list.c_pointer, a_link_.c_pointer))
		end

	c_g_list_delete_link (a_list: POINTER; a_link_: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return g_list_delete_link($a_list, $a_link_);"
		end

	g_list_foreach (a_list: CE_POINTER [SD_GLIST]; a_func: CE_ROUTINE; a_user_data: CE_POINTER [ANY])
		do
			c_g_list_foreach (a_list.c_pointer, a_func.c_pointer, a_user_data.c_pointer)
		end

	c_g_list_foreach (a_list: POINTER; a_func: POINTER; a_user_data: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"g_list_foreach($a_list, $a_func, $a_user_data);"
		end

	g_main_context_iteration (a_context: CE_POINTER [ANY]; a_may_block: INTEGER_32): INTEGER_32
		do
			Result := c_g_main_context_iteration (a_context.c_pointer, a_may_block)
		end

	c_g_main_context_iteration (a_context: POINTER; a_may_block: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return g_main_context_iteration($a_context, $a_may_block);"
		end

	g_main_context_pending (a_context: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_g_main_context_pending (a_context.c_pointer)
		end

	c_g_main_context_pending (a_context: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return g_main_context_pending($a_context);"
		end

	g_timeout_add (a_interval: NATURAL_32; a_function: CE_ROUTINE; a_data: CE_POINTER [ANY]): NATURAL_32
		do
			Result := c_g_timeout_add (a_interval, a_function.c_pointer, a_data.c_pointer)
		end

	c_g_timeout_add (a_interval: NATURAL_32; a_function: POINTER; a_data: POINTER): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return g_timeout_add($a_interval, $a_function, $a_data);"
		end

	g_utf8_validate (a_str: CE_POINTER [INTEGER_8]; a_max_len: INTEGER_32; a_end: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := c_g_utf8_validate (a_str.c_pointer, a_max_len, a_end.c_pointer)
		end

	c_g_utf8_validate (a_str: POINTER; a_max_len: INTEGER_32; a_end: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return g_utf8_validate($a_str, $a_max_len, $a_end);"
		end

	g_io_channel_unref (a_channel: CE_POINTER [SD_GIOCHANNEL])
		do
			c_g_io_channel_unref (a_channel.c_pointer)
		end

	c_g_io_channel_unref (a_channel: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"g_io_channel_unref($a_channel);"
		end

	g_io_add_watch (a_channel: CE_POINTER [SD_GIOCHANNEL]; a_condition: INTEGER_32; a_func: CE_ROUTINE; a_user_data: CE_POINTER [ANY]): NATURAL_32
		do
			Result := c_g_io_add_watch (a_channel.c_pointer, a_condition, a_func.c_pointer, a_user_data.c_pointer)
		end

	c_g_io_add_watch (a_channel: POINTER; a_condition: INTEGER_32; a_func: POINTER; a_user_data: POINTER): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return g_io_add_watch($a_channel, $a_condition, $a_func, $a_user_data);"
		end

	g_io_channel_unix_new (a_fd: INTEGER_32): CE_POINTER [SD_GIOCHANNEL]
		do
			create Result.make_shared (c_g_io_channel_unix_new (a_fd))
		end

	c_g_io_channel_unix_new (a_fd: INTEGER_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return g_io_channel_unix_new($a_fd);"
		end

	g_log (a_args: TUPLE [a_log_domain: CE_POINTER [INTEGER_8]; a_log_level: INTEGER_32; a_format: CE_POINTER [INTEGER_8]])
		do
			(create {CE_ROUTINE}.make_shared (c_g_log)).call (a_args)
		end

	c_g_log: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return &g_log;"
		end

	g_random_int: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return g_random_int();"
		end

	g_strdup_printf (a_args: TUPLE [a_format: CE_POINTER [INTEGER_8]]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared ((create {CE_ROUTINE}.make_shared (c_g_strdup_printf)).pointer_item (a_args).c_pointer)
		end

	c_g_strdup_printf: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return &g_strdup_printf;"
		end

	g_malloc_n (a_n_blocks: NATURAL_32; a_n_block_bytes: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_g_malloc_n (a_n_blocks, a_n_block_bytes))
		end

	c_g_malloc_n (a_n_blocks: NATURAL_32; a_n_block_bytes: NATURAL_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return g_malloc_n($a_n_blocks, $a_n_block_bytes);"
		end

	g_list_free_1 (a_list: CE_POINTER [SD_GLIST])
		do
			c_g_list_free_1 (a_list.c_pointer)
		end

	c_g_list_free_1 (a_list: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"g_list_free_1($a_list);"
		end

	g_list_append (a_list: CE_POINTER [SD_GLIST]; a_data: CE_POINTER [ANY]): CE_POINTER [SD_GLIST]
		do
			create Result.make_shared (c_g_list_append (a_list.c_pointer, a_data.c_pointer))
		end

	c_g_list_append (a_list: POINTER; a_data: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return g_list_append($a_list, $a_data);"
		end

	g_list_remove_link (a_list: CE_POINTER [SD_GLIST]; a_llink: CE_POINTER [SD_GLIST]): CE_POINTER [SD_GLIST]
		do
			create Result.make_shared (c_g_list_remove_link (a_list.c_pointer, a_llink.c_pointer))
		end

	c_g_list_remove_link (a_list: POINTER; a_llink: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return g_list_remove_link($a_list, $a_llink);"
		end

end
