deferred class
	S_SIGNAL

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	signal (a_sig: INTEGER_32; a_handler: CE_ROUTINE): CE_ROUTINE
		do
			create Result.make_shared (c_signal (a_sig, a_handler.c_pointer))
		end

	c_signal (a_sig: INTEGER_32; a_handler: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return signal($a_sig, $a_handler);"
		end

	kill (a_pid: INTEGER_32; a_sig: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return kill($a_pid, $a_sig);"
		end

	sigemptyset (a_set: CE_POINTER [SD_SIGSET_T]): INTEGER_32
		do
			Result := c_sigemptyset (a_set.c_pointer)
		end

	c_sigemptyset (a_set: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sigemptyset($a_set);"
		end

	sigaction (a_sig: INTEGER_32; a_act: CE_POINTER [SD_SIGACTION]; a_oact: CE_POINTER [SD_SIGACTION]): INTEGER_32
		do
			Result := c_sigaction (a_sig, a_act.c_pointer, a_oact.c_pointer)
		end

	c_sigaction (a_sig: INTEGER_32; a_act: POINTER; a_oact: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sigaction($a_sig, $a_act, $a_oact);"
		end

	sigaltstack (a_ss: CE_POINTER [SD_SIGALTSTACK]; a_oss: CE_POINTER [SD_SIGALTSTACK]): INTEGER_32
		do
			Result := c_sigaltstack (a_ss.c_pointer, a_oss.c_pointer)
		end

	c_sigaltstack (a_ss: POINTER; a_oss: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sigaltstack($a_ss, $a_oss);"
		end

	sigset (a_sig: INTEGER_32; a_func: CE_ROUTINE): CE_ROUTINE
		do
			create Result.make_shared (c_sigset (a_sig, a_func.c_pointer))
		end

	c_sigset (a_sig: INTEGER_32; a_func: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return sigset($a_sig, $a_func);"
		end

end
