deferred class
	S_STDLIB

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	atoi (a_nptr: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_atoi (a_nptr.c_pointer)
		end

	c_atoi (a_nptr: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return atoi($a_nptr);"
		end

	atol (a_nptr: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_atol (a_nptr.c_pointer)
		end

	c_atol (a_nptr: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return atol($a_nptr);"
		end

	abs (a_x: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return abs($a_x);"
		end

	getenv (a_name: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_getenv (a_name.c_pointer))
		end

	c_getenv (a_name: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return getenv($a_name);"
		end

	strtod (a_nptr: CE_POINTER [INTEGER_8]; a_endptr: CE_POINTER [CE_POINTER [INTEGER_8]]): REAL_64
		do
			Result := c_strtod (a_nptr.c_pointer, a_endptr.c_pointer)
		end

	c_strtod (a_nptr: POINTER; a_endptr: POINTER): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return strtod($a_nptr, $a_endptr);"
		end

	qsort (a_base: CE_POINTER [ANY]; a_nmemb: NATURAL_32; a_size: NATURAL_32; a_compar: CE_ROUTINE)
		do
			c_qsort (a_base.c_pointer, a_nmemb, a_size, a_compar.c_pointer)
		end

	c_qsort (a_base: POINTER; a_nmemb: NATURAL_32; a_size: NATURAL_32; a_compar: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"qsort($a_base, $a_nmemb, $a_size, $a_compar);"
		end

	mkdtemp (a_template: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_mkdtemp (a_template.c_pointer))
		end

	c_mkdtemp (a_template: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return mkdtemp($a_template);"
		end

	exit (a_status: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"exit($a_status);"
		end

	realloc (a_ptr: CE_POINTER [ANY]; a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared_with_count (
					a_ptr.c_pointer.memory_realloc (a_size.to_integer_32),
					a_size.to_integer_32
				)
		end

	setenv (a_name: CE_POINTER [INTEGER_8]; a_value: CE_POINTER [INTEGER_8]; a_replace: INTEGER_32): INTEGER_32
		do
			Result := c_setenv (a_name.c_pointer, a_value.c_pointer, a_replace)
		end

	c_setenv (a_name: POINTER; a_value: POINTER; a_replace: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return setenv($a_name, $a_value, $a_replace);"
		end

	strtol (a_nptr: CE_POINTER [INTEGER_8]; a_endptr: CE_POINTER [CE_POINTER [INTEGER_8]]; a_base: INTEGER_32): INTEGER_32
		do
			Result := c_strtol (a_nptr.c_pointer, a_endptr.c_pointer, a_base)
		end

	c_strtol (a_nptr: POINTER; a_endptr: POINTER; a_base: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return strtol($a_nptr, $a_endptr, $a_base);"
		end

	malloc (a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared_with_count (
					default_pointer.memory_alloc (a_size.to_integer_32),
					a_size.to_integer_32
				)
		end

	free (a_ptr: CE_POINTER [ANY])
		do
			c_free (a_ptr.c_pointer)
		end

	c_free (a_ptr: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"free($a_ptr);"
		end

	mblen (a_s: CE_POINTER [INTEGER_8]; a_n: NATURAL_32): INTEGER_32
		do
			Result := c_mblen (a_s.c_pointer, a_n)
		end

	c_mblen (a_s: POINTER; a_n: NATURAL_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return mblen($a_s, $a_n);"
		end

	rand: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return rand();"
		end

	srand (a_seed: NATURAL_32)
		external
			"C inline use <vim.h>"
		alias
			"srand($a_seed);"
		end

	grantpt (a_fd: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return grantpt($a_fd);"
		end

	unlockpt (a_fd: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return unlockpt($a_fd);"
		end

	ptsname (a_fd: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_ptsname (a_fd))
		end

	c_ptsname (a_fd: INTEGER_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return ptsname($a_fd);"
		end

end
