deferred class
	S_TERMCAP

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- attributes

	PC: INTEGER_8 assign set_PC
		external
			"C inline use <vim.h>"
		alias
			"return PC;"
		end

	set_PC (a_PC: INTEGER_8)
		external
			"C inline"
		alias
			"PC = $a_pc;"
		end

	UP: CE_POINTER [INTEGER_8] assign set_UP
		do
			create Result.make_shared (c_UP)
		end

			c_UP: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return UP;"
		end

	set_UP (a_UP: CE_POINTER [INTEGER_8])
		do
			c_set_UP (a_UP.c_pointer)
		end

	c_set_UP (a_UP: POINTER)
		external
			"C inline"
		alias
			"UP = (char *)$a_up;"
		end

	BC: CE_POINTER [INTEGER_8] assign set_BC
		do
			create Result.make_shared (c_BC)
		end

			c_BC: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return BC;"
		end

	set_BC (a_BC: CE_POINTER [INTEGER_8])
		do
			c_set_BC (a_BC.c_pointer)
		end

	c_set_BC (a_BC: POINTER)
		external
			"C inline"
		alias
			"BC = (char *)$a_bc;"
		end

	ospeed: NATURAL_32 assign set_ospeed
		external
			"C inline use <vim.h>"
		alias
			"return ospeed;"
		end

	set_ospeed (a_ospeed: NATURAL_32)
		external
			"C inline"
		alias
			"ospeed = $a_ospeed;"
		end

feature {ANY} -- routines

	tgoto (a_arg1: CE_POINTER [INTEGER_8]; a_arg2: INTEGER_32; a_arg3: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_tgoto (a_arg1.c_pointer, a_arg2, a_arg3))
		end

	c_tgoto (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: INTEGER_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return tgoto($a_arg1, $a_arg2, $a_arg3);"
		end

	tgetent (a_arg1: CE_POINTER [INTEGER_8]; a_arg2: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_tgetent (a_arg1.c_pointer, a_arg2.c_pointer)
		end

	c_tgetent (a_arg1: POINTER; a_arg2: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return tgetent($a_arg1, $a_arg2);"
		end

	tgetflag (a_arg1: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_tgetflag (a_arg1.c_pointer)
		end

	c_tgetflag (a_arg1: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return tgetflag($a_arg1);"
		end

	tgetnum (a_arg1: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_tgetnum (a_arg1.c_pointer)
		end

	c_tgetnum (a_arg1: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return tgetnum($a_arg1);"
		end

	tputs (a_arg1: CE_POINTER [INTEGER_8]; a_arg2: INTEGER_32; a_arg3: CE_ROUTINE): INTEGER_32
		do
			Result := c_tputs (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer)
		end

	c_tputs (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return tputs($a_arg1, $a_arg2, $a_arg3);"
		end

end
