deferred class
	S_UNISTD

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- attributes

	environ: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_environ
		do
			create Result.make_shared (c_environ)
		end

			c_environ: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return environ;"
		end

	set_environ (a_environ: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			c_set_environ (a_environ.c_pointer)
		end

	c_set_environ (a_environ: POINTER)
		external
			"C inline"
		alias
			"environ = (char * *)$a_environ;"
		end

feature {ANY} -- routines

	unlink (a_name: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_unlink (a_name.c_pointer)
		end

	c_unlink (a_name: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return unlink($a_name);"
		end

	close (a_fd: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return close($a_fd);"
		end

	readlink (a_path: CE_POINTER [INTEGER_8]; a_buf: CE_POINTER [INTEGER_8]; a_len: NATURAL_32): INTEGER_32
		do
			Result := c_readlink (a_path.c_pointer, a_buf.c_pointer, a_len)
		end

	c_readlink (a_path: POINTER; a_buf: POINTER; a_len: NATURAL_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return readlink($a_path, $a_buf, $a_len);"
		end

	fchown (a_fd: INTEGER_32; a_owner: NATURAL_32; a_group: NATURAL_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return fchown($a_fd, $a_owner, $a_group);"
		end

	getuid: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return getuid();"
		end

	getgid: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return getgid();"
		end

	access (a_name: CE_POINTER [INTEGER_8]; a_type: INTEGER_32): INTEGER_32
		do
			Result := c_access (a_name.c_pointer, a_type)
		end

	c_access (a_name: POINTER; a_type: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return access($a_name, $a_type);"
		end

	lseek (a_fd: INTEGER_32; a_offset: INTEGER_32; a_whence: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return lseek($a_fd, $a_offset, $a_whence);"
		end

	read (a_fd: INTEGER_32; a_buf: CE_POINTER [ANY]; a_nbytes: NATURAL_32): INTEGER_32
		do
			Result := c_read (a_fd, a_buf.c_pointer, a_nbytes)
		end

	c_read (a_fd: INTEGER_32; a_buf: POINTER; a_nbytes: NATURAL_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return read($a_fd, $a_buf, $a_nbytes);"
		end

	write (a_fd: INTEGER_32; a_buf: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		do
			Result := c_write (a_fd, a_buf.c_pointer, a_n)
		end

	c_write (a_fd: INTEGER_32; a_buf: POINTER; a_n: NATURAL_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return write($a_fd, $a_buf, $a_n);"
		end

	dup (a_fd: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return dup($a_fd);"
		end

	rmdir (a_path: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_rmdir (a_path.c_pointer)
		end

	c_rmdir (a_path: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return rmdir($a_path);"
		end

	fsync (a_fd: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return fsync($a_fd);"
		end

	getpid: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return getpid();"
		end

	isatty (a_fd: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return isatty($a_fd);"
		end

	sync
		external
			"C inline use <vim.h>"
		alias
			"sync();"
		end

	pipe (a_pipedes: CE_POINTER [INTEGER_32]): INTEGER_32
		do
			Result := c_pipe (a_pipedes.c_pointer)
		end

	c_pipe (a_pipedes: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return pipe($a_pipedes);"
		end

	chdir (a_path: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_chdir (a_path.c_pointer)
		end

	c_chdir (a_path: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return chdir($a_path);"
		end

	fchdir (a_fd: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return fchdir($a_fd);"
		end

	getcwd (a_buf: CE_POINTER [INTEGER_8]; a_size: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_getcwd (a_buf.c_pointer, a_size))
		end

	c_getcwd (a_buf: POINTER; a_size: NATURAL_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return getcwd($a_buf, $a_size);"
		end

	execvp (a_file: CE_POINTER [INTEGER_8]; a_argv: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := c_execvp (a_file.c_pointer, a_argv.c_pointer)
		end

	c_execvp (a_file: POINTER; a_argv: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return execvp($a_file, $a_argv);"
		end

	exit2 (a_status: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"_exit($a_status);"
		end

	sysconf (a_name: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sysconf($a_name);"
		end

	setsid: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return setsid();"
		end

	fork: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return eiffel_fork();"
		end

	sleep (a_seconds: NATURAL_32): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return sleep($a_seconds);"
		end

end
