class
	PD_ASPRINTF

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	buffer: CE_POINTER [INTEGER_8] assign set_buffer
		do
			create Result.make_shared (c_buffer (c_pointer))
		end

	len: NATURAL_32 assign set_len
		do
			Result := c_len (c_pointer)
		end

	alloc: NATURAL_32 assign set_alloc
		do
			Result := c_alloc (c_pointer)
		end

	fail: INTEGER_32 assign set_fail
		do
			Result := c_fail (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_buffer (a_buffer: CE_POINTER [INTEGER_8])
		do
			c_set_buffer (c_pointer, a_buffer.c_pointer)
		end

	set_len (a_len: NATURAL_32)
		do
			c_set_len (c_pointer, a_len)
		end

	set_alloc (a_alloc: NATURAL_32)
		do
			c_set_alloc (c_pointer, a_alloc)
		end

	set_fail (a_fail: INTEGER_32)
		do
			c_set_fail (c_pointer, a_fail)
		end

feature {NONE} -- C getters

	c_buffer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct asprintf *)$tmp)->buffer;"
		end

	c_len (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct asprintf *)$tmp)->len;"
		end

	c_alloc (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct asprintf *)$tmp)->alloc;"
		end

	c_fail (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct asprintf *)$tmp)->fail;"
		end

feature {NONE} -- C setters

	c_set_buffer (tmp: POINTER; a_buffer: POINTER)
		external
			"C inline"
		alias
			"((struct asprintf *)$tmp)->buffer = (char *)$a_buffer;"
		end

	c_set_len (tmp: POINTER; a_len: NATURAL_32)
		external
			"C inline"
		alias
			"((struct asprintf *)$tmp)->len = $a_len;"
		end

	c_set_alloc (tmp: POINTER; a_alloc: NATURAL_32)
		external
			"C inline"
		alias
			"((struct asprintf *)$tmp)->alloc = $a_alloc;"
		end

	c_set_fail (tmp: POINTER; a_fail: INTEGER_32)
		external
			"C inline"
		alias
			"((struct asprintf *)$tmp)->fail = $a_fail;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct asprintf);"
		end

end
