class
	PD_BACK

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	fread_func: CE_ROUTINE assign set_fread_func
		do
			create Result.make_shared (c_fread_func (c_pointer))
		end

	fread_in: CE_POINTER [ANY] assign set_fread_in
		do
			create Result.make_shared (c_fread_in (c_pointer))
		end

	postdata: CE_POINTER [INTEGER_8] assign set_postdata
		do
			create Result.make_shared (c_postdata (c_pointer))
		end

	postsize: INTEGER_64 assign set_postsize
		do
			Result := c_postsize (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_fread_func (a_fread_func: CE_ROUTINE)
		do
			c_set_fread_func (c_pointer, a_fread_func.c_pointer)
		end

	set_fread_in (a_fread_in: CE_POINTER [ANY])
		do
			c_set_fread_in (c_pointer, a_fread_in.c_pointer)
		end

	set_postdata (a_postdata: CE_POINTER [INTEGER_8])
		do
			c_set_postdata (c_pointer, a_postdata.c_pointer)
		end

	set_postsize (a_postsize: INTEGER_64)
		do
			c_set_postsize (c_pointer, a_postsize)
		end

feature {NONE} -- C getters

	c_fread_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned int( *)(char * buffer, unsigned int size, unsigned int nitems, void * instream))((struct back *)$tmp)->fread_func;"
		end

	c_fread_in (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct back *)$tmp)->fread_in;"
		end

	c_postdata (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct back *)$tmp)->postdata;"
		end

	c_postsize (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct back *)$tmp)->postsize;"
		end

feature {NONE} -- C setters

	c_set_fread_func (tmp: POINTER; a_fread_func: POINTER)
		external
			"C inline"
		alias
			"((struct back *)$tmp)->fread_func = (unsigned int( *)(char * buffer, unsigned int size, unsigned int nitems, void * instream))$a_fread_func;"
		end

	c_set_fread_in (tmp: POINTER; a_fread_in: POINTER)
		external
			"C inline"
		alias
			"((struct back *)$tmp)->fread_in = (void *)$a_fread_in;"
		end

	c_set_postdata (tmp: POINTER; a_postdata: POINTER)
		external
			"C inline"
		alias
			"((struct back *)$tmp)->postdata = (char const *)$a_postdata;"
		end

	c_set_postsize (tmp: POINTER; a_postsize: INTEGER_64)
		external
			"C inline"
		alias
			"((struct back *)$tmp)->postsize = $a_postsize;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct back);"
		end

end
