class
	PD_BACKUP

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	write_function: CE_ROUTINE assign set_write_function
		do
			create Result.make_shared (c_write_function (c_pointer))
		end

	file_descriptor: CE_POINTER [SD_IO_FILE] assign set_file_descriptor
		do
			create Result.make_shared (c_file_descriptor (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_write_function (a_write_function: CE_ROUTINE)
		do
			c_set_write_function (c_pointer, a_write_function.c_pointer)
		end

	set_file_descriptor (a_file_descriptor: CE_POINTER [SD_IO_FILE])
		do
			c_set_file_descriptor (c_pointer, a_file_descriptor.c_pointer)
		end

feature {NONE} -- C getters

	c_write_function (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned int( *)(char * buffer, unsigned int size, unsigned int nitems, void * outstream))((struct __anonstruct_backup_81 *)$tmp)->write_function;"
		end

	c_file_descriptor (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _IO_FILE *)((struct __anonstruct_backup_81 *)$tmp)->file_descriptor;"
		end

feature {NONE} -- C setters

	c_set_write_function (tmp: POINTER; a_write_function: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_backup_81 *)$tmp)->write_function = (unsigned int( *)(char * buffer, unsigned int size, unsigned int nitems, void * outstream))$a_write_function;"
		end

	c_set_file_descriptor (tmp: POINTER; a_file_descriptor: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_backup_81 *)$tmp)->file_descriptor = (struct _IO_FILE *)$a_file_descriptor;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct __anonstruct_backup_81);"
		end

end
