class
	PD_CLOSURE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_CLOSURE] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	easy_handle: CE_POINTER [PD_SESSIONHANDLE] assign set_easy_handle
		do
			create Result.make_shared (c_easy_handle (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_CLOSURE])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_easy_handle (a_easy_handle: CE_POINTER [PD_SESSIONHANDLE])
		do
			c_set_easy_handle (c_pointer, a_easy_handle.c_pointer)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct closure *)((struct closure *)$tmp)->next;"
		end

	c_easy_handle (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct SessionHandle *)((struct closure *)$tmp)->easy_handle;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct closure *)$tmp)->next = (struct closure *)$a_next;"
		end

	c_set_easy_handle (tmp: POINTER; a_easy_handle: POINTER)
		external
			"C inline"
		alias
			"((struct closure *)$tmp)->easy_handle = (struct SessionHandle *)$a_easy_handle;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct closure);"
		end

end
