class
	PD_CONNCACHE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	connects: CE_POINTER [CE_POINTER [PD_CONNECTDATA]] assign set_connects
		do
			create Result.make_shared (c_connects (c_pointer))
		end

	num: INTEGER_32 assign set_num
		do
			Result := c_num (c_pointer)
		end

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_connects (a_connects: CE_POINTER [CE_POINTER [PD_CONNECTDATA]])
		do
			c_set_connects (c_pointer, a_connects.c_pointer)
		end

	set_num (a_num: INTEGER_32)
		do
			c_set_num (c_pointer, a_num)
		end

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

feature {NONE} -- C getters

	c_connects (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct connectdata * *)((struct conncache *)$tmp)->connects;"
		end

	c_num (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct conncache *)$tmp)->num;"
		end

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct conncache *)$tmp)->type;"
		end

feature {NONE} -- C setters

	c_set_connects (tmp: POINTER; a_connects: POINTER)
		external
			"C inline"
		alias
			"((struct conncache *)$tmp)->connects = (struct connectdata * *)$a_connects;"
		end

	c_set_num (tmp: POINTER; a_num: INTEGER_32)
		external
			"C inline"
		alias
			"((struct conncache *)$tmp)->num = $a_num;"
		end

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct conncache *)$tmp)->type = $a_type;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct conncache);"
		end

end
