class
	PD_CONNECTDATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	data: CE_POINTER [PD_SESSIONHANDLE] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	chunk: PD_CURL_CHUNKER assign set_chunk
		do
			create Result.make_shared (c_chunk (c_pointer))
		end

	chunk_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct connectdata, chunk);"
		end

	inuse: BOOLEAN assign set_inuse
		do
			Result := c_inuse (c_pointer)
		end

	connectindex: INTEGER_32 assign set_connectindex
		do
			Result := c_connectindex (c_pointer)
		end

	protocol: INTEGER_32 assign set_protocol
		do
			Result := c_protocol (c_pointer)
		end

	dns_entry: CE_POINTER [PD_CURL_DNS_ENTRY] assign set_dns_entry
		do
			create Result.make_shared (c_dns_entry (c_pointer))
		end

	ip_addr: CE_POINTER [PD_CURL_ADDRINFO] assign set_ip_addr
		do
			create Result.make_shared (c_ip_addr (c_pointer))
		end

	ip_addr_str: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_ip_addr_str (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	scope: NATURAL_32 assign set_scope
		do
			Result := c_scope (c_pointer)
		end

	socktype: INTEGER_32 assign set_socktype
		do
			Result := c_socktype (c_pointer)
		end

	host: PD_HOSTNAME assign set_host
		do
			create Result.make_shared (c_host (c_pointer))
		end

	host_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct connectdata, host);"
		end

	proxy: PD_HOSTNAME assign set_proxy
		do
			create Result.make_shared (c_proxy (c_pointer))
		end

	proxy_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct connectdata, proxy);"
		end

	port: INTEGER_32 assign set_port
		do
			Result := c_port (c_pointer)
		end

	remote_port: NATURAL_16 assign set_remote_port
		do
			Result := c_remote_port (c_pointer)
		end

	user: CE_POINTER [INTEGER_8] assign set_user
		do
			create Result.make_shared (c_user (c_pointer))
		end

	passwd: CE_POINTER [INTEGER_8] assign set_passwd
		do
			create Result.make_shared (c_passwd (c_pointer))
		end

	proxyuser: CE_POINTER [INTEGER_8] assign set_proxyuser
		do
			create Result.make_shared (c_proxyuser (c_pointer))
		end

	proxypasswd: CE_POINTER [INTEGER_8] assign set_proxypasswd
		do
			create Result.make_shared (c_proxypasswd (c_pointer))
		end

	proxytype: INTEGER_32 assign set_proxytype
		do
			Result := c_proxytype (c_pointer)
		end

	httpversion: INTEGER_32 assign set_httpversion
		do
			Result := c_httpversion (c_pointer)
		end

	httpversion_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct connectdata, httpversion);"
		end

	rtspversion: INTEGER_32 assign set_rtspversion
		do
			Result := c_rtspversion (c_pointer)
		end

	rtspversion_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct connectdata, rtspversion);"
		end

	now: SD_TIMEVAL assign set_now
		do
			create Result.make_shared (c_now (c_pointer))
		end

	created: SD_TIMEVAL assign set_created
		do
			create Result.make_shared (c_created (c_pointer))
		end

	sock: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_sock (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	recv: CE_ARRAY [CE_ROUTINE]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_recv (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	send: CE_ARRAY [CE_ROUTINE]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_send (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	ssl: CE_ARRAY [PD_SSL_CONNECT_DATA]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_ssl (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	ssl_config: PD_SSL_CONFIG_DATA assign set_ssl_config
		do
			create Result.make_shared (c_ssl_config (c_pointer))
		end

	ssl_config_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct connectdata, ssl_config);"
		end

	bits: PD_CONNECTBITS assign set_bits
		do
			create Result.make_shared (c_bits (c_pointer))
		end

	handler: CE_POINTER [PD_CURL_HANDLER] assign set_handler
		do
			create Result.make_shared (c_handler (c_pointer))
		end

	sockfd: INTEGER_32 assign set_sockfd
		do
			Result := c_sockfd (c_pointer)
		end

	writesockfd: INTEGER_32 assign set_writesockfd
		do
			Result := c_writesockfd (c_pointer)
		end

	allocptr: PD_DYNAMICALLY_ALLOCATED_DATA assign set_allocptr
		do
			create Result.make_shared (c_allocptr (c_pointer))
		end

	allocptr_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct connectdata, allocptr);"
		end

	sec_complete: INTEGER_32 assign set_sec_complete
		do
			Result := c_sec_complete (c_pointer)
		end

	readchannel_inuse: BOOLEAN assign set_readchannel_inuse
		do
			Result := c_readchannel_inuse (c_pointer)
		end

	writechannel_inuse: BOOLEAN assign set_writechannel_inuse
		do
			Result := c_writechannel_inuse (c_pointer)
		end

	server_supports_pipelining: BOOLEAN assign set_server_supports_pipelining
		do
			Result := c_server_supports_pipelining (c_pointer)
		end

	send_pipe: CE_POINTER [PD_CURL_LLIST] assign set_send_pipe
		do
			create Result.make_shared (c_send_pipe (c_pointer))
		end

	recv_pipe: CE_POINTER [PD_CURL_LLIST] assign set_recv_pipe
		do
			create Result.make_shared (c_recv_pipe (c_pointer))
		end

	pend_pipe: CE_POINTER [PD_CURL_LLIST] assign set_pend_pipe
		do
			create Result.make_shared (c_pend_pipe (c_pointer))
		end

	done_pipe: CE_POINTER [PD_CURL_LLIST] assign set_done_pipe
		do
			create Result.make_shared (c_done_pipe (c_pointer))
		end

	master_buffer: CE_POINTER [INTEGER_8] assign set_master_buffer
		do
			create Result.make_shared (c_master_buffer (c_pointer))
		end

	read_pos: NATURAL_32 assign set_read_pos
		do
			Result := c_read_pos (c_pointer)
		end

	buf_len: NATURAL_32 assign set_buf_len
		do
			Result := c_buf_len (c_pointer)
		end

	seek_func: CE_ROUTINE assign set_seek_func
		do
			create Result.make_shared (c_seek_func (c_pointer))
		end

	seek_client: CE_POINTER [ANY] assign set_seek_client
		do
			create Result.make_shared (c_seek_client (c_pointer))
		end

	fread_func: CE_ROUTINE assign set_fread_func
		do
			create Result.make_shared (c_fread_func (c_pointer))
		end

	fread_in: CE_POINTER [ANY] assign set_fread_in
		do
			create Result.make_shared (c_fread_in (c_pointer))
		end

	ntlm: PD_NTLMDATA assign set_ntlm
		do
			create Result.make_shared (c_ntlm (c_pointer))
		end

	proxyntlm: PD_NTLMDATA assign set_proxyntlm
		do
			create Result.make_shared (c_proxyntlm (c_pointer))
		end

	syserr_buf: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_syserr_buf (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	trailer: CE_POINTER [INTEGER_8] assign set_trailer
		do
			create Result.make_shared (c_trailer (c_pointer))
		end

	trlMax: INTEGER_32 assign set_trlMax
		do
			Result := c_trlMax (c_pointer)
		end

	trlPos: INTEGER_32 assign set_trlPos
		do
			Result := c_trlPos (c_pointer)
		end

	proto: PD_PROTO assign set_proto
		do
			create Result.make_shared (c_proto (c_pointer))
		end

	proto_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct connectdata, proto);"
		end

	cselect_bits: INTEGER_32 assign set_cselect_bits
		do
			Result := c_cselect_bits (c_pointer)
		end

	waitfor: INTEGER_32 assign set_waitfor
		do
			Result := c_waitfor (c_pointer)
		end

	verifypeer: INTEGER_32 assign set_verifypeer
		do
			Result := c_verifypeer (c_pointer)
		end

	verifyhost: INTEGER_32 assign set_verifyhost
		do
			Result := c_verifyhost (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_data (a_data: CE_POINTER [PD_SESSIONHANDLE])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_chunk (a_chunk: PD_CURL_CHUNKER)
		do
			chunk.ce_gets (a_chunk)
		end

	set_inuse (a_inuse: BOOLEAN)
		do
			c_set_inuse (c_pointer, a_inuse)
		end

	set_connectindex (a_connectindex: INTEGER_32)
		do
			c_set_connectindex (c_pointer, a_connectindex)
		end

	set_protocol (a_protocol: INTEGER_32)
		do
			c_set_protocol (c_pointer, a_protocol)
		end

	set_dns_entry (a_dns_entry: CE_POINTER [PD_CURL_DNS_ENTRY])
		do
			c_set_dns_entry (c_pointer, a_dns_entry.c_pointer)
		end

	set_ip_addr (a_ip_addr: CE_POINTER [PD_CURL_ADDRINFO])
		do
			c_set_ip_addr (c_pointer, a_ip_addr.c_pointer)
		end

	set_scope (a_scope: NATURAL_32)
		do
			c_set_scope (c_pointer, a_scope)
		end

	set_socktype (a_socktype: INTEGER_32)
		do
			c_set_socktype (c_pointer, a_socktype)
		end

	set_host (a_host: PD_HOSTNAME)
		do
			host.ce_gets (a_host)
		end

	set_proxy (a_proxy: PD_HOSTNAME)
		do
			proxy.ce_gets (a_proxy)
		end

	set_port (a_port: INTEGER_32)
		do
			c_set_port (c_pointer, a_port)
		end

	set_remote_port (a_remote_port: NATURAL_16)
		do
			c_set_remote_port (c_pointer, a_remote_port)
		end

	set_user (a_user: CE_POINTER [INTEGER_8])
		do
			c_set_user (c_pointer, a_user.c_pointer)
		end

	set_passwd (a_passwd: CE_POINTER [INTEGER_8])
		do
			c_set_passwd (c_pointer, a_passwd.c_pointer)
		end

	set_proxyuser (a_proxyuser: CE_POINTER [INTEGER_8])
		do
			c_set_proxyuser (c_pointer, a_proxyuser.c_pointer)
		end

	set_proxypasswd (a_proxypasswd: CE_POINTER [INTEGER_8])
		do
			c_set_proxypasswd (c_pointer, a_proxypasswd.c_pointer)
		end

	set_proxytype (a_proxytype: INTEGER_32)
		do
			c_set_proxytype (c_pointer, a_proxytype)
		end

	set_httpversion (a_httpversion: INTEGER_32)
		do
			c_set_httpversion (c_pointer, a_httpversion)
		end

	set_rtspversion (a_rtspversion: INTEGER_32)
		do
			c_set_rtspversion (c_pointer, a_rtspversion)
		end

	set_now (a_now: SD_TIMEVAL)
		do
			now.ce_gets (a_now)
		end

	set_created (a_created: SD_TIMEVAL)
		do
			created.ce_gets (a_created)
		end

	set_ssl_config (a_ssl_config: PD_SSL_CONFIG_DATA)
		do
			ssl_config.ce_gets (a_ssl_config)
		end

	set_bits (a_bits: PD_CONNECTBITS)
		do
			bits.ce_gets (a_bits)
		end

	set_handler (a_handler: CE_POINTER [PD_CURL_HANDLER])
		do
			c_set_handler (c_pointer, a_handler.c_pointer)
		end

	set_sockfd (a_sockfd: INTEGER_32)
		do
			c_set_sockfd (c_pointer, a_sockfd)
		end

	set_writesockfd (a_writesockfd: INTEGER_32)
		do
			c_set_writesockfd (c_pointer, a_writesockfd)
		end

	set_allocptr (a_allocptr: PD_DYNAMICALLY_ALLOCATED_DATA)
		do
			allocptr.ce_gets (a_allocptr)
		end

	set_sec_complete (a_sec_complete: INTEGER_32)
		do
			c_set_sec_complete (c_pointer, a_sec_complete)
		end

	set_readchannel_inuse (a_readchannel_inuse: BOOLEAN)
		do
			c_set_readchannel_inuse (c_pointer, a_readchannel_inuse)
		end

	set_writechannel_inuse (a_writechannel_inuse: BOOLEAN)
		do
			c_set_writechannel_inuse (c_pointer, a_writechannel_inuse)
		end

	set_server_supports_pipelining (a_server_supports_pipelining: BOOLEAN)
		do
			c_set_server_supports_pipelining (c_pointer, a_server_supports_pipelining)
		end

	set_send_pipe (a_send_pipe: CE_POINTER [PD_CURL_LLIST])
		do
			c_set_send_pipe (c_pointer, a_send_pipe.c_pointer)
		end

	set_recv_pipe (a_recv_pipe: CE_POINTER [PD_CURL_LLIST])
		do
			c_set_recv_pipe (c_pointer, a_recv_pipe.c_pointer)
		end

	set_pend_pipe (a_pend_pipe: CE_POINTER [PD_CURL_LLIST])
		do
			c_set_pend_pipe (c_pointer, a_pend_pipe.c_pointer)
		end

	set_done_pipe (a_done_pipe: CE_POINTER [PD_CURL_LLIST])
		do
			c_set_done_pipe (c_pointer, a_done_pipe.c_pointer)
		end

	set_master_buffer (a_master_buffer: CE_POINTER [INTEGER_8])
		do
			c_set_master_buffer (c_pointer, a_master_buffer.c_pointer)
		end

	set_read_pos (a_read_pos: NATURAL_32)
		do
			c_set_read_pos (c_pointer, a_read_pos)
		end

	set_buf_len (a_buf_len: NATURAL_32)
		do
			c_set_buf_len (c_pointer, a_buf_len)
		end

	set_seek_func (a_seek_func: CE_ROUTINE)
		do
			c_set_seek_func (c_pointer, a_seek_func.c_pointer)
		end

	set_seek_client (a_seek_client: CE_POINTER [ANY])
		do
			c_set_seek_client (c_pointer, a_seek_client.c_pointer)
		end

	set_fread_func (a_fread_func: CE_ROUTINE)
		do
			c_set_fread_func (c_pointer, a_fread_func.c_pointer)
		end

	set_fread_in (a_fread_in: CE_POINTER [ANY])
		do
			c_set_fread_in (c_pointer, a_fread_in.c_pointer)
		end

	set_ntlm (a_ntlm: PD_NTLMDATA)
		do
			ntlm.ce_gets (a_ntlm)
		end

	set_proxyntlm (a_proxyntlm: PD_NTLMDATA)
		do
			proxyntlm.ce_gets (a_proxyntlm)
		end

	set_trailer (a_trailer: CE_POINTER [INTEGER_8])
		do
			c_set_trailer (c_pointer, a_trailer.c_pointer)
		end

	set_trlMax (a_trlMax: INTEGER_32)
		do
			c_set_trlMax (c_pointer, a_trlMax)
		end

	set_trlPos (a_trlPos: INTEGER_32)
		do
			c_set_trlPos (c_pointer, a_trlPos)
		end

	set_proto (a_proto: PD_PROTO)
		do
			proto.ce_gets (a_proto)
		end

	set_cselect_bits (a_cselect_bits: INTEGER_32)
		do
			c_set_cselect_bits (c_pointer, a_cselect_bits)
		end

	set_waitfor (a_waitfor: INTEGER_32)
		do
			c_set_waitfor (c_pointer, a_waitfor)
		end

	set_verifypeer (a_verifypeer: INTEGER_32)
		do
			c_set_verifypeer (c_pointer, a_verifypeer)
		end

	set_verifyhost (a_verifyhost: INTEGER_32)
		do
			c_set_verifyhost (c_pointer, a_verifyhost)
		end

feature {NONE} -- C getters

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct SessionHandle *)((struct connectdata *)$tmp)->data;"
		end

	c_chunk (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Curl_chunker *)&((struct connectdata *)$tmp)->chunk;"
		end

	c_inuse (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct connectdata *)$tmp)->inuse;"
		end

	c_connectindex (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct connectdata *)$tmp)->connectindex;"
		end

	c_protocol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct connectdata *)$tmp)->protocol;"
		end

	c_dns_entry (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Curl_dns_entry *)((struct connectdata *)$tmp)->dns_entry;"
		end

	c_ip_addr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Curl_addrinfo *)((struct connectdata *)$tmp)->ip_addr;"
		end

	c_ip_addr_str (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct connectdata *tmp = (struct connectdata *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->ip_addr_str) / sizeof(tmp->ip_addr_str[0]);
				return tmp->ip_addr_str;
			]"
		end

	c_scope (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct connectdata *)$tmp)->scope;"
		end

	c_socktype (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct connectdata *)$tmp)->socktype;"
		end

	c_host (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct hostname *)&((struct connectdata *)$tmp)->host;"
		end

	c_proxy (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct hostname *)&((struct connectdata *)$tmp)->proxy;"
		end

	c_port (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct connectdata *)$tmp)->port;"
		end

	c_remote_port (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct connectdata *)$tmp)->remote_port;"
		end

	c_user (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct connectdata *)$tmp)->user;"
		end

	c_passwd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct connectdata *)$tmp)->passwd;"
		end

	c_proxyuser (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct connectdata *)$tmp)->proxyuser;"
		end

	c_proxypasswd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct connectdata *)$tmp)->proxypasswd;"
		end

	c_proxytype (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct connectdata *)$tmp)->proxytype;"
		end

	c_httpversion (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct connectdata *)$tmp)->httpversion;"
		end

	c_rtspversion (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct connectdata *)$tmp)->rtspversion;"
		end

	c_now (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct timeval *)&((struct connectdata *)$tmp)->now;"
		end

	c_created (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct timeval *)&((struct connectdata *)$tmp)->created;"
		end

	c_sock (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct connectdata *tmp = (struct connectdata *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->sock) / sizeof(tmp->sock[0]);
				return tmp->sock;
			]"
		end

	c_recv (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct connectdata *tmp = (struct connectdata *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->recv) / sizeof(tmp->recv[0]);
				return tmp->recv;
			]"
		end

	c_send (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct connectdata *tmp = (struct connectdata *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->send) / sizeof(tmp->send[0]);
				return tmp->send;
			]"
		end

	c_ssl (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct connectdata *tmp = (struct connectdata *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->ssl) / sizeof(tmp->ssl[0]);
				return tmp->ssl;
			]"
		end

	c_ssl_config (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct ssl_config_data *)&((struct connectdata *)$tmp)->ssl_config;"
		end

	c_bits (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct ConnectBits *)&((struct connectdata *)$tmp)->bits;"
		end

	c_handler (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Curl_handler *)((struct connectdata *)$tmp)->handler;"
		end

	c_sockfd (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct connectdata *)$tmp)->sockfd;"
		end

	c_writesockfd (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct connectdata *)$tmp)->writesockfd;"
		end

	c_allocptr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dynamically_allocated_data *)&((struct connectdata *)$tmp)->allocptr;"
		end

	c_sec_complete (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct connectdata *)$tmp)->sec_complete;"
		end

	c_readchannel_inuse (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct connectdata *)$tmp)->readchannel_inuse;"
		end

	c_writechannel_inuse (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct connectdata *)$tmp)->writechannel_inuse;"
		end

	c_server_supports_pipelining (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct connectdata *)$tmp)->server_supports_pipelining;"
		end

	c_send_pipe (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_llist *)((struct connectdata *)$tmp)->send_pipe;"
		end

	c_recv_pipe (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_llist *)((struct connectdata *)$tmp)->recv_pipe;"
		end

	c_pend_pipe (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_llist *)((struct connectdata *)$tmp)->pend_pipe;"
		end

	c_done_pipe (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_llist *)((struct connectdata *)$tmp)->done_pipe;"
		end

	c_master_buffer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct connectdata *)$tmp)->master_buffer;"
		end

	c_read_pos (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct connectdata *)$tmp)->read_pos;"
		end

	c_buf_len (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct connectdata *)$tmp)->buf_len;"
		end

	c_seek_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * instream, long long offset, int origin))((struct connectdata *)$tmp)->seek_func;"
		end

	c_seek_client (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct connectdata *)$tmp)->seek_client;"
		end

	c_fread_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned int( *)(char * buffer, unsigned int size, unsigned int nitems, void * instream))((struct connectdata *)$tmp)->fread_func;"
		end

	c_fread_in (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct connectdata *)$tmp)->fread_in;"
		end

	c_ntlm (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct ntlmdata *)&((struct connectdata *)$tmp)->ntlm;"
		end

	c_proxyntlm (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct ntlmdata *)&((struct connectdata *)$tmp)->proxyntlm;"
		end

	c_syserr_buf (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct connectdata *tmp = (struct connectdata *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->syserr_buf) / sizeof(tmp->syserr_buf[0]);
				return tmp->syserr_buf;
			]"
		end

	c_trailer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct connectdata *)$tmp)->trailer;"
		end

	c_trlMax (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct connectdata *)$tmp)->trlMax;"
		end

	c_trlPos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct connectdata *)$tmp)->trlPos;"
		end

	c_proto (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_proto_96 *)&((struct connectdata *)$tmp)->proto;"
		end

	c_cselect_bits (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct connectdata *)$tmp)->cselect_bits;"
		end

	c_waitfor (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct connectdata *)$tmp)->waitfor;"
		end

	c_verifypeer (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct connectdata *)$tmp)->verifypeer;"
		end

	c_verifyhost (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct connectdata *)$tmp)->verifyhost;"
		end

feature {NONE} -- C setters

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->data = (struct SessionHandle *)$a_data;"
		end

	c_set_inuse (tmp: POINTER; a_inuse: BOOLEAN)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->inuse = $a_inuse;"
		end

	c_set_connectindex (tmp: POINTER; a_connectindex: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->connectindex = $a_connectindex;"
		end

	c_set_protocol (tmp: POINTER; a_protocol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->protocol = $a_protocol;"
		end

	c_set_dns_entry (tmp: POINTER; a_dns_entry: POINTER)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->dns_entry = (struct Curl_dns_entry *)$a_dns_entry;"
		end

	c_set_ip_addr (tmp: POINTER; a_ip_addr: POINTER)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->ip_addr = (struct Curl_addrinfo *)$a_ip_addr;"
		end

	c_set_scope (tmp: POINTER; a_scope: NATURAL_32)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->scope = $a_scope;"
		end

	c_set_socktype (tmp: POINTER; a_socktype: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->socktype = $a_socktype;"
		end

	c_set_port (tmp: POINTER; a_port: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->port = $a_port;"
		end

	c_set_remote_port (tmp: POINTER; a_remote_port: NATURAL_16)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->remote_port = $a_remote_port;"
		end

	c_set_user (tmp: POINTER; a_user: POINTER)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->user = (char *)$a_user;"
		end

	c_set_passwd (tmp: POINTER; a_passwd: POINTER)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->passwd = (char *)$a_passwd;"
		end

	c_set_proxyuser (tmp: POINTER; a_proxyuser: POINTER)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->proxyuser = (char *)$a_proxyuser;"
		end

	c_set_proxypasswd (tmp: POINTER; a_proxypasswd: POINTER)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->proxypasswd = (char *)$a_proxypasswd;"
		end

	c_set_proxytype (tmp: POINTER; a_proxytype: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->proxytype = $a_proxytype;"
		end

	c_set_httpversion (tmp: POINTER; a_httpversion: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->httpversion = $a_httpversion;"
		end

	c_set_rtspversion (tmp: POINTER; a_rtspversion: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->rtspversion = $a_rtspversion;"
		end

	c_set_handler (tmp: POINTER; a_handler: POINTER)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->handler = (struct Curl_handler const *)$a_handler;"
		end

	c_set_sockfd (tmp: POINTER; a_sockfd: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->sockfd = $a_sockfd;"
		end

	c_set_writesockfd (tmp: POINTER; a_writesockfd: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->writesockfd = $a_writesockfd;"
		end

	c_set_sec_complete (tmp: POINTER; a_sec_complete: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->sec_complete = $a_sec_complete;"
		end

	c_set_readchannel_inuse (tmp: POINTER; a_readchannel_inuse: BOOLEAN)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->readchannel_inuse = $a_readchannel_inuse;"
		end

	c_set_writechannel_inuse (tmp: POINTER; a_writechannel_inuse: BOOLEAN)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->writechannel_inuse = $a_writechannel_inuse;"
		end

	c_set_server_supports_pipelining (tmp: POINTER; a_server_supports_pipelining: BOOLEAN)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->server_supports_pipelining = $a_server_supports_pipelining;"
		end

	c_set_send_pipe (tmp: POINTER; a_send_pipe: POINTER)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->send_pipe = (struct curl_llist *)$a_send_pipe;"
		end

	c_set_recv_pipe (tmp: POINTER; a_recv_pipe: POINTER)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->recv_pipe = (struct curl_llist *)$a_recv_pipe;"
		end

	c_set_pend_pipe (tmp: POINTER; a_pend_pipe: POINTER)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->pend_pipe = (struct curl_llist *)$a_pend_pipe;"
		end

	c_set_done_pipe (tmp: POINTER; a_done_pipe: POINTER)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->done_pipe = (struct curl_llist *)$a_done_pipe;"
		end

	c_set_master_buffer (tmp: POINTER; a_master_buffer: POINTER)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->master_buffer = (char *)$a_master_buffer;"
		end

	c_set_read_pos (tmp: POINTER; a_read_pos: NATURAL_32)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->read_pos = $a_read_pos;"
		end

	c_set_buf_len (tmp: POINTER; a_buf_len: NATURAL_32)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->buf_len = $a_buf_len;"
		end

	c_set_seek_func (tmp: POINTER; a_seek_func: POINTER)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->seek_func = (int( *)(void * instream, long long offset, int origin))$a_seek_func;"
		end

	c_set_seek_client (tmp: POINTER; a_seek_client: POINTER)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->seek_client = (void *)$a_seek_client;"
		end

	c_set_fread_func (tmp: POINTER; a_fread_func: POINTER)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->fread_func = (unsigned int( *)(char * buffer, unsigned int size, unsigned int nitems, void * instream))$a_fread_func;"
		end

	c_set_fread_in (tmp: POINTER; a_fread_in: POINTER)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->fread_in = (void *)$a_fread_in;"
		end

	c_set_trailer (tmp: POINTER; a_trailer: POINTER)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->trailer = (char *)$a_trailer;"
		end

	c_set_trlMax (tmp: POINTER; a_trlMax: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->trlMax = $a_trlmax;"
		end

	c_set_trlPos (tmp: POINTER; a_trlPos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->trlPos = $a_trlpos;"
		end

	c_set_cselect_bits (tmp: POINTER; a_cselect_bits: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->cselect_bits = $a_cselect_bits;"
		end

	c_set_waitfor (tmp: POINTER; a_waitfor: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->waitfor = $a_waitfor;"
		end

	c_set_verifypeer (tmp: POINTER; a_verifypeer: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->verifypeer = $a_verifypeer;"
		end

	c_set_verifyhost (tmp: POINTER; a_verifyhost: INTEGER_32)
		external
			"C inline"
		alias
			"((struct connectdata *)$tmp)->verifyhost = $a_verifyhost;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct connectdata);"
		end

end
