class
	PD_CONTENTTYPE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	extension: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_extension (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	type: CE_POINTER [INTEGER_8] assign set_type
		do
			create Result.make_shared (c_type (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: CE_POINTER [INTEGER_8])
		do
			c_set_type (c_pointer, a_type.c_pointer)
		end

feature {NONE} -- C getters

	c_extension (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct ContentType *tmp = (struct ContentType *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->extension) / sizeof(tmp->extension[0]);
				return tmp->extension;
			]"
		end

	c_type (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct ContentType *)$tmp)->type;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: POINTER)
		external
			"C inline"
		alias
			"((struct ContentType *)$tmp)->type = (char const *)$a_type;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct ContentType);"
		end

end
