class
	PD_COOKIE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_COOKIE] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	value: CE_POINTER [INTEGER_8] assign set_value
		do
			create Result.make_shared (c_value (c_pointer))
		end

	path: CE_POINTER [INTEGER_8] assign set_path
		do
			create Result.make_shared (c_path (c_pointer))
		end

	path_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct Cookie, path);"
		end

	domain: CE_POINTER [INTEGER_8] assign set_domain
		do
			create Result.make_shared (c_domain (c_pointer))
		end

	domain_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct Cookie, domain);"
		end

	expires: INTEGER_64 assign set_expires
		do
			Result := c_expires (c_pointer)
		end

	expirestr: CE_POINTER [INTEGER_8] assign set_expirestr
		do
			create Result.make_shared (c_expirestr (c_pointer))
		end

	expirestr_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct Cookie, expirestr);"
		end

	tailmatch: BOOLEAN assign set_tailmatch
		do
			Result := c_tailmatch (c_pointer)
		end

	version: CE_POINTER [INTEGER_8] assign set_version
		do
			create Result.make_shared (c_version (c_pointer))
		end

	version_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct Cookie, version);"
		end

	maxage: CE_POINTER [INTEGER_8] assign set_maxage
		do
			create Result.make_shared (c_maxage (c_pointer))
		end

	maxage_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct Cookie, maxage);"
		end

	secure: BOOLEAN assign set_secure
		do
			Result := c_secure (c_pointer)
		end

	livecookie: BOOLEAN assign set_livecookie
		do
			Result := c_livecookie (c_pointer)
		end

	httponly: BOOLEAN assign set_httponly
		do
			Result := c_httponly (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_COOKIE])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_value (a_value: CE_POINTER [INTEGER_8])
		do
			c_set_value (c_pointer, a_value.c_pointer)
		end

	set_path (a_path: CE_POINTER [INTEGER_8])
		do
			c_set_path (c_pointer, a_path.c_pointer)
		end

	set_domain (a_domain: CE_POINTER [INTEGER_8])
		do
			c_set_domain (c_pointer, a_domain.c_pointer)
		end

	set_expires (a_expires: INTEGER_64)
		do
			c_set_expires (c_pointer, a_expires)
		end

	set_expirestr (a_expirestr: CE_POINTER [INTEGER_8])
		do
			c_set_expirestr (c_pointer, a_expirestr.c_pointer)
		end

	set_tailmatch (a_tailmatch: BOOLEAN)
		do
			c_set_tailmatch (c_pointer, a_tailmatch)
		end

	set_version (a_version: CE_POINTER [INTEGER_8])
		do
			c_set_version (c_pointer, a_version.c_pointer)
		end

	set_maxage (a_maxage: CE_POINTER [INTEGER_8])
		do
			c_set_maxage (c_pointer, a_maxage.c_pointer)
		end

	set_secure (a_secure: BOOLEAN)
		do
			c_set_secure (c_pointer, a_secure)
		end

	set_livecookie (a_livecookie: BOOLEAN)
		do
			c_set_livecookie (c_pointer, a_livecookie)
		end

	set_httponly (a_httponly: BOOLEAN)
		do
			c_set_httponly (c_pointer, a_httponly)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Cookie *)((struct Cookie *)$tmp)->next;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct Cookie *)$tmp)->name;"
		end

	c_value (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct Cookie *)$tmp)->value;"
		end

	c_path (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct Cookie *)$tmp)->path;"
		end

	c_domain (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct Cookie *)$tmp)->domain;"
		end

	c_expires (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct Cookie *)$tmp)->expires;"
		end

	c_expirestr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct Cookie *)$tmp)->expirestr;"
		end

	c_tailmatch (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct Cookie *)$tmp)->tailmatch;"
		end

	c_version (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct Cookie *)$tmp)->version;"
		end

	c_maxage (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct Cookie *)$tmp)->maxage;"
		end

	c_secure (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct Cookie *)$tmp)->secure;"
		end

	c_livecookie (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct Cookie *)$tmp)->livecookie;"
		end

	c_httponly (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct Cookie *)$tmp)->httponly;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct Cookie *)$tmp)->next = (struct Cookie *)$a_next;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct Cookie *)$tmp)->name = (char *)$a_name;"
		end

	c_set_value (tmp: POINTER; a_value: POINTER)
		external
			"C inline"
		alias
			"((struct Cookie *)$tmp)->value = (char *)$a_value;"
		end

	c_set_path (tmp: POINTER; a_path: POINTER)
		external
			"C inline"
		alias
			"((struct Cookie *)$tmp)->path = (char *)$a_path;"
		end

	c_set_domain (tmp: POINTER; a_domain: POINTER)
		external
			"C inline"
		alias
			"((struct Cookie *)$tmp)->domain = (char *)$a_domain;"
		end

	c_set_expires (tmp: POINTER; a_expires: INTEGER_64)
		external
			"C inline"
		alias
			"((struct Cookie *)$tmp)->expires = $a_expires;"
		end

	c_set_expirestr (tmp: POINTER; a_expirestr: POINTER)
		external
			"C inline"
		alias
			"((struct Cookie *)$tmp)->expirestr = (char *)$a_expirestr;"
		end

	c_set_tailmatch (tmp: POINTER; a_tailmatch: BOOLEAN)
		external
			"C inline"
		alias
			"((struct Cookie *)$tmp)->tailmatch = $a_tailmatch;"
		end

	c_set_version (tmp: POINTER; a_version: POINTER)
		external
			"C inline"
		alias
			"((struct Cookie *)$tmp)->version = (char *)$a_version;"
		end

	c_set_maxage (tmp: POINTER; a_maxage: POINTER)
		external
			"C inline"
		alias
			"((struct Cookie *)$tmp)->maxage = (char *)$a_maxage;"
		end

	c_set_secure (tmp: POINTER; a_secure: BOOLEAN)
		external
			"C inline"
		alias
			"((struct Cookie *)$tmp)->secure = $a_secure;"
		end

	c_set_livecookie (tmp: POINTER; a_livecookie: BOOLEAN)
		external
			"C inline"
		alias
			"((struct Cookie *)$tmp)->livecookie = $a_livecookie;"
		end

	c_set_httponly (tmp: POINTER; a_httponly: BOOLEAN)
		external
			"C inline"
		alias
			"((struct Cookie *)$tmp)->httponly = $a_httponly;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct Cookie);"
		end

end
