class
	PD_COOKIEINFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	cookies: CE_POINTER [PD_COOKIE] assign set_cookies
		do
			create Result.make_shared (c_cookies (c_pointer))
		end

	filename: CE_POINTER [INTEGER_8] assign set_filename
		do
			create Result.make_shared (c_filename (c_pointer))
		end

	running: BOOLEAN assign set_running
		do
			Result := c_running (c_pointer)
		end

	numcookies: INTEGER_32 assign set_numcookies
		do
			Result := c_numcookies (c_pointer)
		end

	newsession: BOOLEAN assign set_newsession
		do
			Result := c_newsession (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_cookies (a_cookies: CE_POINTER [PD_COOKIE])
		do
			c_set_cookies (c_pointer, a_cookies.c_pointer)
		end

	set_filename (a_filename: CE_POINTER [INTEGER_8])
		do
			c_set_filename (c_pointer, a_filename.c_pointer)
		end

	set_running (a_running: BOOLEAN)
		do
			c_set_running (c_pointer, a_running)
		end

	set_numcookies (a_numcookies: INTEGER_32)
		do
			c_set_numcookies (c_pointer, a_numcookies)
		end

	set_newsession (a_newsession: BOOLEAN)
		do
			c_set_newsession (c_pointer, a_newsession)
		end

feature {NONE} -- C getters

	c_cookies (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Cookie *)((struct CookieInfo *)$tmp)->cookies;"
		end

	c_filename (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct CookieInfo *)$tmp)->filename;"
		end

	c_running (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct CookieInfo *)$tmp)->running;"
		end

	c_numcookies (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct CookieInfo *)$tmp)->numcookies;"
		end

	c_newsession (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct CookieInfo *)$tmp)->newsession;"
		end

feature {NONE} -- C setters

	c_set_cookies (tmp: POINTER; a_cookies: POINTER)
		external
			"C inline"
		alias
			"((struct CookieInfo *)$tmp)->cookies = (struct Cookie *)$a_cookies;"
		end

	c_set_filename (tmp: POINTER; a_filename: POINTER)
		external
			"C inline"
		alias
			"((struct CookieInfo *)$tmp)->filename = (char *)$a_filename;"
		end

	c_set_running (tmp: POINTER; a_running: BOOLEAN)
		external
			"C inline"
		alias
			"((struct CookieInfo *)$tmp)->running = $a_running;"
		end

	c_set_numcookies (tmp: POINTER; a_numcookies: INTEGER_32)
		external
			"C inline"
		alias
			"((struct CookieInfo *)$tmp)->numcookies = $a_numcookies;"
		end

	c_set_newsession (tmp: POINTER; a_newsession: BOOLEAN)
		external
			"C inline"
		alias
			"((struct CookieInfo *)$tmp)->newsession = $a_newsession;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct CookieInfo);"
		end

end
