class
	PD_CURL_ADDRINFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ai_flags: INTEGER_32 assign set_ai_flags
		do
			Result := c_ai_flags (c_pointer)
		end

	ai_family: INTEGER_32 assign set_ai_family
		do
			Result := c_ai_family (c_pointer)
		end

	ai_socktype: INTEGER_32 assign set_ai_socktype
		do
			Result := c_ai_socktype (c_pointer)
		end

	ai_protocol: INTEGER_32 assign set_ai_protocol
		do
			Result := c_ai_protocol (c_pointer)
		end

	ai_addrlen: NATURAL_32 assign set_ai_addrlen
		do
			Result := c_ai_addrlen (c_pointer)
		end

	ai_canonname: CE_POINTER [INTEGER_8] assign set_ai_canonname
		do
			create Result.make_shared (c_ai_canonname (c_pointer))
		end

	ai_addr: CE_POINTER [SD_SOCKADDR] assign set_ai_addr
		do
			create Result.make_shared (c_ai_addr (c_pointer))
		end

	ai_next: CE_POINTER [PD_CURL_ADDRINFO] assign set_ai_next
		do
			create Result.make_shared (c_ai_next (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_ai_flags (a_ai_flags: INTEGER_32)
		do
			c_set_ai_flags (c_pointer, a_ai_flags)
		end

	set_ai_family (a_ai_family: INTEGER_32)
		do
			c_set_ai_family (c_pointer, a_ai_family)
		end

	set_ai_socktype (a_ai_socktype: INTEGER_32)
		do
			c_set_ai_socktype (c_pointer, a_ai_socktype)
		end

	set_ai_protocol (a_ai_protocol: INTEGER_32)
		do
			c_set_ai_protocol (c_pointer, a_ai_protocol)
		end

	set_ai_addrlen (a_ai_addrlen: NATURAL_32)
		do
			c_set_ai_addrlen (c_pointer, a_ai_addrlen)
		end

	set_ai_canonname (a_ai_canonname: CE_POINTER [INTEGER_8])
		do
			c_set_ai_canonname (c_pointer, a_ai_canonname.c_pointer)
		end

	set_ai_addr (a_ai_addr: CE_POINTER [SD_SOCKADDR])
		do
			c_set_ai_addr (c_pointer, a_ai_addr.c_pointer)
		end

	set_ai_next (a_ai_next: CE_POINTER [PD_CURL_ADDRINFO])
		do
			c_set_ai_next (c_pointer, a_ai_next.c_pointer)
		end

feature {NONE} -- C getters

	c_ai_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Curl_addrinfo *)$tmp)->ai_flags;"
		end

	c_ai_family (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Curl_addrinfo *)$tmp)->ai_family;"
		end

	c_ai_socktype (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Curl_addrinfo *)$tmp)->ai_socktype;"
		end

	c_ai_protocol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Curl_addrinfo *)$tmp)->ai_protocol;"
		end

	c_ai_addrlen (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct Curl_addrinfo *)$tmp)->ai_addrlen;"
		end

	c_ai_canonname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct Curl_addrinfo *)$tmp)->ai_canonname;"
		end

	c_ai_addr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct sockaddr *)((struct Curl_addrinfo *)$tmp)->ai_addr;"
		end

	c_ai_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Curl_addrinfo *)((struct Curl_addrinfo *)$tmp)->ai_next;"
		end

feature {NONE} -- C setters

	c_set_ai_flags (tmp: POINTER; a_ai_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Curl_addrinfo *)$tmp)->ai_flags = $a_ai_flags;"
		end

	c_set_ai_family (tmp: POINTER; a_ai_family: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Curl_addrinfo *)$tmp)->ai_family = $a_ai_family;"
		end

	c_set_ai_socktype (tmp: POINTER; a_ai_socktype: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Curl_addrinfo *)$tmp)->ai_socktype = $a_ai_socktype;"
		end

	c_set_ai_protocol (tmp: POINTER; a_ai_protocol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Curl_addrinfo *)$tmp)->ai_protocol = $a_ai_protocol;"
		end

	c_set_ai_addrlen (tmp: POINTER; a_ai_addrlen: NATURAL_32)
		external
			"C inline"
		alias
			"((struct Curl_addrinfo *)$tmp)->ai_addrlen = $a_ai_addrlen;"
		end

	c_set_ai_canonname (tmp: POINTER; a_ai_canonname: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_addrinfo *)$tmp)->ai_canonname = (char *)$a_ai_canonname;"
		end

	c_set_ai_addr (tmp: POINTER; a_ai_addr: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_addrinfo *)$tmp)->ai_addr = (struct sockaddr *)$a_ai_addr;"
		end

	c_set_ai_next (tmp: POINTER; a_ai_next: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_addrinfo *)$tmp)->ai_next = (struct Curl_addrinfo *)$a_ai_next;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct Curl_addrinfo);"
		end

end
