class
	PD_CURL_CHUNKER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	hexbuffer: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_hexbuffer (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	hexindex: INTEGER_32 assign set_hexindex
		do
			Result := c_hexindex (c_pointer)
		end

	state: INTEGER_32 assign set_state
		do
			Result := c_state (c_pointer)
		end

	datasize: NATURAL_32 assign set_datasize
		do
			Result := c_datasize (c_pointer)
		end

	dataleft: NATURAL_32 assign set_dataleft
		do
			Result := c_dataleft (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_hexindex (a_hexindex: INTEGER_32)
		do
			c_set_hexindex (c_pointer, a_hexindex)
		end

	set_state (a_state: INTEGER_32)
		do
			c_set_state (c_pointer, a_state)
		end

	set_datasize (a_datasize: NATURAL_32)
		do
			c_set_datasize (c_pointer, a_datasize)
		end

	set_dataleft (a_dataleft: NATURAL_32)
		do
			c_set_dataleft (c_pointer, a_dataleft)
		end

feature {NONE} -- C getters

	c_hexbuffer (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct Curl_chunker *tmp = (struct Curl_chunker *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->hexbuffer) / sizeof(tmp->hexbuffer[0]);
				return tmp->hexbuffer;
			]"
		end

	c_hexindex (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Curl_chunker *)$tmp)->hexindex;"
		end

	c_state (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Curl_chunker *)$tmp)->state;"
		end

	c_datasize (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct Curl_chunker *)$tmp)->datasize;"
		end

	c_dataleft (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct Curl_chunker *)$tmp)->dataleft;"
		end

feature {NONE} -- C setters

	c_set_hexindex (tmp: POINTER; a_hexindex: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Curl_chunker *)$tmp)->hexindex = $a_hexindex;"
		end

	c_set_state (tmp: POINTER; a_state: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Curl_chunker *)$tmp)->state = $a_state;"
		end

	c_set_datasize (tmp: POINTER; a_datasize: NATURAL_32)
		external
			"C inline"
		alias
			"((struct Curl_chunker *)$tmp)->datasize = $a_datasize;"
		end

	c_set_dataleft (tmp: POINTER; a_dataleft: NATURAL_32)
		external
			"C inline"
		alias
			"((struct Curl_chunker *)$tmp)->dataleft = $a_dataleft;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct Curl_chunker);"
		end

end
