class
	PD_CURL_DNS_ENTRY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	addr: CE_POINTER [PD_CURL_ADDRINFO] assign set_addr
		do
			create Result.make_shared (c_addr (c_pointer))
		end

	timestamp: INTEGER_32 assign set_timestamp
		do
			Result := c_timestamp (c_pointer)
		end

	timestamp_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct Curl_dns_entry, timestamp);"
		end

	inuse: INTEGER_32 assign set_inuse
		do
			Result := c_inuse (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_addr (a_addr: CE_POINTER [PD_CURL_ADDRINFO])
		do
			c_set_addr (c_pointer, a_addr.c_pointer)
		end

	set_timestamp (a_timestamp: INTEGER_32)
		do
			c_set_timestamp (c_pointer, a_timestamp)
		end

	set_inuse (a_inuse: INTEGER_32)
		do
			c_set_inuse (c_pointer, a_inuse)
		end

feature {NONE} -- C getters

	c_addr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Curl_addrinfo *)((struct Curl_dns_entry *)$tmp)->addr;"
		end

	c_timestamp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct Curl_dns_entry *)$tmp)->timestamp;"
		end

	c_inuse (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct Curl_dns_entry *)$tmp)->inuse;"
		end

feature {NONE} -- C setters

	c_set_addr (tmp: POINTER; a_addr: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_dns_entry *)$tmp)->addr = (struct Curl_addrinfo *)$a_addr;"
		end

	c_set_timestamp (tmp: POINTER; a_timestamp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Curl_dns_entry *)$tmp)->timestamp = $a_timestamp;"
		end

	c_set_inuse (tmp: POINTER; a_inuse: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Curl_dns_entry *)$tmp)->inuse = $a_inuse;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct Curl_dns_entry);"
		end

end
