class
	PD_CURL_FILEINFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	filename: CE_POINTER [INTEGER_8] assign set_filename
		do
			create Result.make_shared (c_filename (c_pointer))
		end

	filetype: INTEGER_32 assign set_filetype
		do
			Result := c_filetype (c_pointer)
		end

	time: INTEGER_32 assign set_time
		do
			Result := c_time (c_pointer)
		end

	perm: NATURAL_32 assign set_perm
		do
			Result := c_perm (c_pointer)
		end

	uid: INTEGER_32 assign set_uid
		do
			Result := c_uid (c_pointer)
		end

	gid: INTEGER_32 assign set_gid
		do
			Result := c_gid (c_pointer)
		end

	size: INTEGER_64 assign set_size
		do
			Result := c_size (c_pointer)
		end

	hardlinks: INTEGER_32 assign set_hardlinks
		do
			Result := c_hardlinks (c_pointer)
		end

	strings: PD_STRINGS assign set_strings
		do
			create Result.make_shared (c_strings (c_pointer))
		end

	flags: NATURAL_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	b_data: CE_POINTER [INTEGER_8] assign set_b_data
		do
			create Result.make_shared (c_b_data (c_pointer))
		end

	b_size: NATURAL_32 assign set_b_size
		do
			Result := c_b_size (c_pointer)
		end

	b_used: NATURAL_32 assign set_b_used
		do
			Result := c_b_used (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_filename (a_filename: CE_POINTER [INTEGER_8])
		do
			c_set_filename (c_pointer, a_filename.c_pointer)
		end

	set_filetype (a_filetype: INTEGER_32)
		do
			c_set_filetype (c_pointer, a_filetype)
		end

	set_time (a_time: INTEGER_32)
		do
			c_set_time (c_pointer, a_time)
		end

	set_perm (a_perm: NATURAL_32)
		do
			c_set_perm (c_pointer, a_perm)
		end

	set_uid (a_uid: INTEGER_32)
		do
			c_set_uid (c_pointer, a_uid)
		end

	set_gid (a_gid: INTEGER_32)
		do
			c_set_gid (c_pointer, a_gid)
		end

	set_size (a_size: INTEGER_64)
		do
			c_set_size (c_pointer, a_size)
		end

	set_hardlinks (a_hardlinks: INTEGER_32)
		do
			c_set_hardlinks (c_pointer, a_hardlinks)
		end

	set_strings (a_strings: PD_STRINGS)
		do
			strings.ce_gets (a_strings)
		end

	set_flags (a_flags: NATURAL_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

	set_b_data (a_b_data: CE_POINTER [INTEGER_8])
		do
			c_set_b_data (c_pointer, a_b_data.c_pointer)
		end

	set_b_size (a_b_size: NATURAL_32)
		do
			c_set_b_size (c_pointer, a_b_size)
		end

	set_b_used (a_b_used: NATURAL_32)
		do
			c_set_b_used (c_pointer, a_b_used)
		end

feature {NONE} -- C getters

	c_filename (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct curl_fileinfo *)$tmp)->filename;"
		end

	c_filetype (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct curl_fileinfo *)$tmp)->filetype;"
		end

	c_time (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct curl_fileinfo *)$tmp)->time;"
		end

	c_perm (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct curl_fileinfo *)$tmp)->perm;"
		end

	c_uid (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct curl_fileinfo *)$tmp)->uid;"
		end

	c_gid (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct curl_fileinfo *)$tmp)->gid;"
		end

	c_size (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct curl_fileinfo *)$tmp)->size;"
		end

	c_hardlinks (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct curl_fileinfo *)$tmp)->hardlinks;"
		end

	c_strings (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct_strings_44 *)&((struct curl_fileinfo *)$tmp)->strings;"
		end

	c_flags (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct curl_fileinfo *)$tmp)->flags;"
		end

	c_b_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct curl_fileinfo *)$tmp)->b_data;"
		end

	c_b_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct curl_fileinfo *)$tmp)->b_size;"
		end

	c_b_used (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct curl_fileinfo *)$tmp)->b_used;"
		end

feature {NONE} -- C setters

	c_set_filename (tmp: POINTER; a_filename: POINTER)
		external
			"C inline"
		alias
			"((struct curl_fileinfo *)$tmp)->filename = (char *)$a_filename;"
		end

	c_set_filetype (tmp: POINTER; a_filetype: INTEGER_32)
		external
			"C inline"
		alias
			"((struct curl_fileinfo *)$tmp)->filetype = $a_filetype;"
		end

	c_set_time (tmp: POINTER; a_time: INTEGER_32)
		external
			"C inline"
		alias
			"((struct curl_fileinfo *)$tmp)->time = $a_time;"
		end

	c_set_perm (tmp: POINTER; a_perm: NATURAL_32)
		external
			"C inline"
		alias
			"((struct curl_fileinfo *)$tmp)->perm = $a_perm;"
		end

	c_set_uid (tmp: POINTER; a_uid: INTEGER_32)
		external
			"C inline"
		alias
			"((struct curl_fileinfo *)$tmp)->uid = $a_uid;"
		end

	c_set_gid (tmp: POINTER; a_gid: INTEGER_32)
		external
			"C inline"
		alias
			"((struct curl_fileinfo *)$tmp)->gid = $a_gid;"
		end

	c_set_size (tmp: POINTER; a_size: INTEGER_64)
		external
			"C inline"
		alias
			"((struct curl_fileinfo *)$tmp)->size = $a_size;"
		end

	c_set_hardlinks (tmp: POINTER; a_hardlinks: INTEGER_32)
		external
			"C inline"
		alias
			"((struct curl_fileinfo *)$tmp)->hardlinks = $a_hardlinks;"
		end

	c_set_flags (tmp: POINTER; a_flags: NATURAL_32)
		external
			"C inline"
		alias
			"((struct curl_fileinfo *)$tmp)->flags = $a_flags;"
		end

	c_set_b_data (tmp: POINTER; a_b_data: POINTER)
		external
			"C inline"
		alias
			"((struct curl_fileinfo *)$tmp)->b_data = (char *)$a_b_data;"
		end

	c_set_b_size (tmp: POINTER; a_b_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct curl_fileinfo *)$tmp)->b_size = $a_b_size;"
		end

	c_set_b_used (tmp: POINTER; a_b_used: NATURAL_32)
		external
			"C inline"
		alias
			"((struct curl_fileinfo *)$tmp)->b_used = $a_b_used;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct curl_fileinfo);"
		end

end
