class
	PD_CURL_HANDLER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	scheme: CE_POINTER [INTEGER_8] assign set_scheme
		do
			create Result.make_shared (c_scheme (c_pointer))
		end

	setup_connection: CE_ROUTINE assign set_setup_connection
		do
			create Result.make_shared (c_setup_connection (c_pointer))
		end

	do_it: CE_ROUTINE assign set_do_it
		do
			create Result.make_shared (c_do_it (c_pointer))
		end

	done: CE_ROUTINE assign set_done
		do
			create Result.make_shared (c_done (c_pointer))
		end

	do_more: CE_ROUTINE assign set_do_more
		do
			create Result.make_shared (c_do_more (c_pointer))
		end

	connect_it: CE_ROUTINE assign set_connect_it
		do
			create Result.make_shared (c_connect_it (c_pointer))
		end

	connecting: CE_ROUTINE assign set_connecting
		do
			create Result.make_shared (c_connecting (c_pointer))
		end

	doing: CE_ROUTINE assign set_doing
		do
			create Result.make_shared (c_doing (c_pointer))
		end

	proto_getsock: CE_ROUTINE assign set_proto_getsock
		do
			create Result.make_shared (c_proto_getsock (c_pointer))
		end

	doing_getsock: CE_ROUTINE assign set_doing_getsock
		do
			create Result.make_shared (c_doing_getsock (c_pointer))
		end

	perform_getsock: CE_ROUTINE assign set_perform_getsock
		do
			create Result.make_shared (c_perform_getsock (c_pointer))
		end

	disconnect: CE_ROUTINE assign set_disconnect
		do
			create Result.make_shared (c_disconnect (c_pointer))
		end

	defport: INTEGER_32 assign set_defport
		do
			Result := c_defport (c_pointer)
		end

	protocol: INTEGER_32 assign set_protocol
		do
			Result := c_protocol (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_scheme (a_scheme: CE_POINTER [INTEGER_8])
		do
			c_set_scheme (c_pointer, a_scheme.c_pointer)
		end

	set_setup_connection (a_setup_connection: CE_ROUTINE)
		do
			c_set_setup_connection (c_pointer, a_setup_connection.c_pointer)
		end

	set_do_it (a_do_it: CE_ROUTINE)
		do
			c_set_do_it (c_pointer, a_do_it.c_pointer)
		end

	set_done (a_done: CE_ROUTINE)
		do
			c_set_done (c_pointer, a_done.c_pointer)
		end

	set_do_more (a_do_more: CE_ROUTINE)
		do
			c_set_do_more (c_pointer, a_do_more.c_pointer)
		end

	set_connect_it (a_connect_it: CE_ROUTINE)
		do
			c_set_connect_it (c_pointer, a_connect_it.c_pointer)
		end

	set_connecting (a_connecting: CE_ROUTINE)
		do
			c_set_connecting (c_pointer, a_connecting.c_pointer)
		end

	set_doing (a_doing: CE_ROUTINE)
		do
			c_set_doing (c_pointer, a_doing.c_pointer)
		end

	set_proto_getsock (a_proto_getsock: CE_ROUTINE)
		do
			c_set_proto_getsock (c_pointer, a_proto_getsock.c_pointer)
		end

	set_doing_getsock (a_doing_getsock: CE_ROUTINE)
		do
			c_set_doing_getsock (c_pointer, a_doing_getsock.c_pointer)
		end

	set_perform_getsock (a_perform_getsock: CE_ROUTINE)
		do
			c_set_perform_getsock (c_pointer, a_perform_getsock.c_pointer)
		end

	set_disconnect (a_disconnect: CE_ROUTINE)
		do
			c_set_disconnect (c_pointer, a_disconnect.c_pointer)
		end

	set_defport (a_defport: INTEGER_32)
		do
			c_set_defport (c_pointer, a_defport)
		end

	set_protocol (a_protocol: INTEGER_32)
		do
			c_set_protocol (c_pointer, a_protocol)
		end

feature {NONE} -- C getters

	c_scheme (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct Curl_handler *)$tmp)->scheme;"
		end

	c_setup_connection (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct connectdata *))((struct Curl_handler *)$tmp)->setup_connection;"
		end

	c_do_it (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct connectdata *, _Bool * done))((struct Curl_handler *)$tmp)->do_it;"
		end

	c_done (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct connectdata *, int, _Bool))((struct Curl_handler *)$tmp)->done;"
		end

	c_do_more (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct connectdata *))((struct Curl_handler *)$tmp)->do_more;"
		end

	c_connect_it (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct connectdata *, _Bool * done))((struct Curl_handler *)$tmp)->connect_it;"
		end

	c_connecting (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct connectdata *, _Bool * done))((struct Curl_handler *)$tmp)->connecting;"
		end

	c_doing (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct connectdata *, _Bool * done))((struct Curl_handler *)$tmp)->doing;"
		end

	c_proto_getsock (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct connectdata * conn, int * socks, int numsocks))((struct Curl_handler *)$tmp)->proto_getsock;"
		end

	c_doing_getsock (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct connectdata * conn, int * socks, int numsocks))((struct Curl_handler *)$tmp)->doing_getsock;"
		end

	c_perform_getsock (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct connectdata * conn, int * socks, int numsocks))((struct Curl_handler *)$tmp)->perform_getsock;"
		end

	c_disconnect (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct connectdata *))((struct Curl_handler *)$tmp)->disconnect;"
		end

	c_defport (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct Curl_handler *)$tmp)->defport;"
		end

	c_protocol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct Curl_handler *)$tmp)->protocol;"
		end

feature {NONE} -- C setters

	c_set_scheme (tmp: POINTER; a_scheme: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_handler *)$tmp)->scheme = (char const *)$a_scheme;"
		end

	c_set_setup_connection (tmp: POINTER; a_setup_connection: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_handler *)$tmp)->setup_connection = (int( *)(struct connectdata *))$a_setup_connection;"
		end

	c_set_do_it (tmp: POINTER; a_do_it: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_handler *)$tmp)->do_it = (int( *)(struct connectdata *, _Bool * done))$a_do_it;"
		end

	c_set_done (tmp: POINTER; a_done: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_handler *)$tmp)->done = (int( *)(struct connectdata *, int, _Bool))$a_done;"
		end

	c_set_do_more (tmp: POINTER; a_do_more: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_handler *)$tmp)->do_more = (int( *)(struct connectdata *))$a_do_more;"
		end

	c_set_connect_it (tmp: POINTER; a_connect_it: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_handler *)$tmp)->connect_it = (int( *)(struct connectdata *, _Bool * done))$a_connect_it;"
		end

	c_set_connecting (tmp: POINTER; a_connecting: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_handler *)$tmp)->connecting = (int( *)(struct connectdata *, _Bool * done))$a_connecting;"
		end

	c_set_doing (tmp: POINTER; a_doing: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_handler *)$tmp)->doing = (int( *)(struct connectdata *, _Bool * done))$a_doing;"
		end

	c_set_proto_getsock (tmp: POINTER; a_proto_getsock: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_handler *)$tmp)->proto_getsock = (int( *)(struct connectdata * conn, int * socks, int numsocks))$a_proto_getsock;"
		end

	c_set_doing_getsock (tmp: POINTER; a_doing_getsock: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_handler *)$tmp)->doing_getsock = (int( *)(struct connectdata * conn, int * socks, int numsocks))$a_doing_getsock;"
		end

	c_set_perform_getsock (tmp: POINTER; a_perform_getsock: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_handler *)$tmp)->perform_getsock = (int( *)(struct connectdata const * conn, int * socks, int numsocks))$a_perform_getsock;"
		end

	c_set_disconnect (tmp: POINTER; a_disconnect: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_handler *)$tmp)->disconnect = (int( *)(struct connectdata *))$a_disconnect;"
		end

	c_set_defport (tmp: POINTER; a_defport: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Curl_handler *)$tmp)->defport = $a_defport;"
		end

	c_set_protocol (tmp: POINTER; a_protocol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Curl_handler *)$tmp)->protocol = $a_protocol;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct Curl_handler);"
		end

end
