class
	PD_CURL_HASH

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	table: CE_POINTER [CE_POINTER [PD_CURL_LLIST]] assign set_table
		do
			create Result.make_shared (c_table (c_pointer))
		end

	hash_func: CE_ROUTINE assign set_hash_func
		do
			create Result.make_shared (c_hash_func (c_pointer))
		end

	comp_func: CE_ROUTINE assign set_comp_func
		do
			create Result.make_shared (c_comp_func (c_pointer))
		end

	dtor: CE_ROUTINE assign set_dtor
		do
			create Result.make_shared (c_dtor (c_pointer))
		end

	slots: INTEGER_32 assign set_slots
		do
			Result := c_slots (c_pointer)
		end

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_table (a_table: CE_POINTER [CE_POINTER [PD_CURL_LLIST]])
		do
			c_set_table (c_pointer, a_table.c_pointer)
		end

	set_hash_func (a_hash_func: CE_ROUTINE)
		do
			c_set_hash_func (c_pointer, a_hash_func.c_pointer)
		end

	set_comp_func (a_comp_func: CE_ROUTINE)
		do
			c_set_comp_func (c_pointer, a_comp_func.c_pointer)
		end

	set_dtor (a_dtor: CE_ROUTINE)
		do
			c_set_dtor (c_pointer, a_dtor.c_pointer)
		end

	set_slots (a_slots: INTEGER_32)
		do
			c_set_slots (c_pointer, a_slots)
		end

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

feature {NONE} -- C getters

	c_table (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_llist * *)((struct curl_hash *)$tmp)->table;"
		end

	c_hash_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned int( *)(void * key, unsigned int key_length, unsigned int slots_num))((struct curl_hash *)$tmp)->hash_func;"
		end

	c_comp_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned int( *)(void * key1, unsigned int key1_len, void * key2, unsigned int key2_len))((struct curl_hash *)$tmp)->comp_func;"
		end

	c_dtor (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void *))((struct curl_hash *)$tmp)->dtor;"
		end

	c_slots (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct curl_hash *)$tmp)->slots;"
		end

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct curl_hash *)$tmp)->size;"
		end

feature {NONE} -- C setters

	c_set_table (tmp: POINTER; a_table: POINTER)
		external
			"C inline"
		alias
			"((struct curl_hash *)$tmp)->table = (struct curl_llist * *)$a_table;"
		end

	c_set_hash_func (tmp: POINTER; a_hash_func: POINTER)
		external
			"C inline"
		alias
			"((struct curl_hash *)$tmp)->hash_func = (unsigned int( *)(void * key, unsigned int key_length, unsigned int slots_num))$a_hash_func;"
		end

	c_set_comp_func (tmp: POINTER; a_comp_func: POINTER)
		external
			"C inline"
		alias
			"((struct curl_hash *)$tmp)->comp_func = (unsigned int( *)(void * key1, unsigned int key1_len, void * key2, unsigned int key2_len))$a_comp_func;"
		end

	c_set_dtor (tmp: POINTER; a_dtor: POINTER)
		external
			"C inline"
		alias
			"((struct curl_hash *)$tmp)->dtor = (void( *)(void *))$a_dtor;"
		end

	c_set_slots (tmp: POINTER; a_slots: INTEGER_32)
		external
			"C inline"
		alias
			"((struct curl_hash *)$tmp)->slots = $a_slots;"
		end

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct curl_hash *)$tmp)->size = $a_size;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct curl_hash);"
		end

end
