class
	PD_CURL_HASH_ELEMENT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ptr: CE_POINTER [ANY] assign set_ptr
		do
			create Result.make_shared (c_ptr (c_pointer))
		end

	key: CE_POINTER [INTEGER_8] assign set_key
		do
			create Result.make_shared (c_key (c_pointer))
		end

	key_len: NATURAL_32 assign set_key_len
		do
			Result := c_key_len (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_ptr (a_ptr: CE_POINTER [ANY])
		do
			c_set_ptr (c_pointer, a_ptr.c_pointer)
		end

	set_key (a_key: CE_POINTER [INTEGER_8])
		do
			c_set_key (c_pointer, a_key.c_pointer)
		end

	set_key_len (a_key_len: NATURAL_32)
		do
			c_set_key_len (c_pointer, a_key_len)
		end

feature {NONE} -- C getters

	c_ptr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct curl_hash_element *)$tmp)->ptr;"
		end

	c_key (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct curl_hash_element *)$tmp)->key;"
		end

	c_key_len (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct curl_hash_element *)$tmp)->key_len;"
		end

feature {NONE} -- C setters

	c_set_ptr (tmp: POINTER; a_ptr: POINTER)
		external
			"C inline"
		alias
			"((struct curl_hash_element *)$tmp)->ptr = (void *)$a_ptr;"
		end

	c_set_key (tmp: POINTER; a_key: POINTER)
		external
			"C inline"
		alias
			"((struct curl_hash_element *)$tmp)->key = (char *)$a_key;"
		end

	c_set_key_len (tmp: POINTER; a_key_len: NATURAL_32)
		external
			"C inline"
		alias
			"((struct curl_hash_element *)$tmp)->key_len = $a_key_len;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct curl_hash_element);"
		end

end
