class
	PD_CURL_LLIST

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	head: CE_POINTER [PD_CURL_LLIST_ELEMENT] assign set_head
		do
			create Result.make_shared (c_head (c_pointer))
		end

	tail: CE_POINTER [PD_CURL_LLIST_ELEMENT] assign set_tail
		do
			create Result.make_shared (c_tail (c_pointer))
		end

	dtor: CE_ROUTINE assign set_dtor
		do
			create Result.make_shared (c_dtor (c_pointer))
		end

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_head (a_head: CE_POINTER [PD_CURL_LLIST_ELEMENT])
		do
			c_set_head (c_pointer, a_head.c_pointer)
		end

	set_tail (a_tail: CE_POINTER [PD_CURL_LLIST_ELEMENT])
		do
			c_set_tail (c_pointer, a_tail.c_pointer)
		end

	set_dtor (a_dtor: CE_ROUTINE)
		do
			c_set_dtor (c_pointer, a_dtor.c_pointer)
		end

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

feature {NONE} -- C getters

	c_head (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_llist_element *)((struct curl_llist *)$tmp)->head;"
		end

	c_tail (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_llist_element *)((struct curl_llist *)$tmp)->tail;"
		end

	c_dtor (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void *, void *))((struct curl_llist *)$tmp)->dtor;"
		end

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct curl_llist *)$tmp)->size;"
		end

feature {NONE} -- C setters

	c_set_head (tmp: POINTER; a_head: POINTER)
		external
			"C inline"
		alias
			"((struct curl_llist *)$tmp)->head = (struct curl_llist_element *)$a_head;"
		end

	c_set_tail (tmp: POINTER; a_tail: POINTER)
		external
			"C inline"
		alias
			"((struct curl_llist *)$tmp)->tail = (struct curl_llist_element *)$a_tail;"
		end

	c_set_dtor (tmp: POINTER; a_dtor: POINTER)
		external
			"C inline"
		alias
			"((struct curl_llist *)$tmp)->dtor = (void( *)(void *, void *))$a_dtor;"
		end

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct curl_llist *)$tmp)->size = $a_size;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct curl_llist);"
		end

end
