class
	PD_CURL_MULTI

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	easy: PD_CURL_ONE_EASY assign set_easy
		do
			create Result.make_shared (c_easy (c_pointer))
		end

	easy_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct Curl_multi, easy);"
		end

	num_easy: INTEGER_32 assign set_num_easy
		do
			Result := c_num_easy (c_pointer)
		end

	num_alive: INTEGER_32 assign set_num_alive
		do
			Result := c_num_alive (c_pointer)
		end

	msglist: CE_POINTER [PD_CURL_LLIST] assign set_msglist
		do
			create Result.make_shared (c_msglist (c_pointer))
		end

	socket_cb: CE_ROUTINE assign set_socket_cb
		do
			create Result.make_shared (c_socket_cb (c_pointer))
		end

	socket_userp: CE_POINTER [ANY] assign set_socket_userp
		do
			create Result.make_shared (c_socket_userp (c_pointer))
		end

	hostcache: CE_POINTER [PD_CURL_HASH] assign set_hostcache
		do
			create Result.make_shared (c_hostcache (c_pointer))
		end

	timetree: CE_POINTER [PD_CURL_TREE] assign set_timetree
		do
			create Result.make_shared (c_timetree (c_pointer))
		end

	timetree_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct Curl_multi, timetree);"
		end

	sockhash: CE_POINTER [PD_CURL_HASH] assign set_sockhash
		do
			create Result.make_shared (c_sockhash (c_pointer))
		end

	pipelining_enabled: BOOLEAN assign set_pipelining_enabled
		do
			Result := c_pipelining_enabled (c_pointer)
		end

	connc: CE_POINTER [PD_CONNCACHE] assign set_connc
		do
			create Result.make_shared (c_connc (c_pointer))
		end

	maxconnects: INTEGER_32 assign set_maxconnects
		do
			Result := c_maxconnects (c_pointer)
		end

	closure: CE_POINTER [PD_CLOSURE] assign set_closure
		do
			create Result.make_shared (c_closure (c_pointer))
		end

	timer_cb: CE_ROUTINE assign set_timer_cb
		do
			create Result.make_shared (c_timer_cb (c_pointer))
		end

	timer_userp: CE_POINTER [ANY] assign set_timer_userp
		do
			create Result.make_shared (c_timer_userp (c_pointer))
		end

	timer_lastcall: SD_TIMEVAL assign set_timer_lastcall
		do
			create Result.make_shared (c_timer_lastcall (c_pointer))
		end

	timer_lastcall_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct Curl_multi, timer_lastcall);"
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_easy (a_easy: PD_CURL_ONE_EASY)
		do
			easy.ce_gets (a_easy)
		end

	set_num_easy (a_num_easy: INTEGER_32)
		do
			c_set_num_easy (c_pointer, a_num_easy)
		end

	set_num_alive (a_num_alive: INTEGER_32)
		do
			c_set_num_alive (c_pointer, a_num_alive)
		end

	set_msglist (a_msglist: CE_POINTER [PD_CURL_LLIST])
		do
			c_set_msglist (c_pointer, a_msglist.c_pointer)
		end

	set_socket_cb (a_socket_cb: CE_ROUTINE)
		do
			c_set_socket_cb (c_pointer, a_socket_cb.c_pointer)
		end

	set_socket_userp (a_socket_userp: CE_POINTER [ANY])
		do
			c_set_socket_userp (c_pointer, a_socket_userp.c_pointer)
		end

	set_hostcache (a_hostcache: CE_POINTER [PD_CURL_HASH])
		do
			c_set_hostcache (c_pointer, a_hostcache.c_pointer)
		end

	set_timetree (a_timetree: CE_POINTER [PD_CURL_TREE])
		do
			c_set_timetree (c_pointer, a_timetree.c_pointer)
		end

	set_sockhash (a_sockhash: CE_POINTER [PD_CURL_HASH])
		do
			c_set_sockhash (c_pointer, a_sockhash.c_pointer)
		end

	set_pipelining_enabled (a_pipelining_enabled: BOOLEAN)
		do
			c_set_pipelining_enabled (c_pointer, a_pipelining_enabled)
		end

	set_connc (a_connc: CE_POINTER [PD_CONNCACHE])
		do
			c_set_connc (c_pointer, a_connc.c_pointer)
		end

	set_maxconnects (a_maxconnects: INTEGER_32)
		do
			c_set_maxconnects (c_pointer, a_maxconnects)
		end

	set_closure (a_closure: CE_POINTER [PD_CLOSURE])
		do
			c_set_closure (c_pointer, a_closure.c_pointer)
		end

	set_timer_cb (a_timer_cb: CE_ROUTINE)
		do
			c_set_timer_cb (c_pointer, a_timer_cb.c_pointer)
		end

	set_timer_userp (a_timer_userp: CE_POINTER [ANY])
		do
			c_set_timer_userp (c_pointer, a_timer_userp.c_pointer)
		end

	set_timer_lastcall (a_timer_lastcall: SD_TIMEVAL)
		do
			timer_lastcall.ce_gets (a_timer_lastcall)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct Curl_multi *)$tmp)->type;"
		end

	c_easy (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Curl_one_easy *)&((struct Curl_multi *)$tmp)->easy;"
		end

	c_num_easy (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Curl_multi *)$tmp)->num_easy;"
		end

	c_num_alive (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Curl_multi *)$tmp)->num_alive;"
		end

	c_msglist (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_llist *)((struct Curl_multi *)$tmp)->msglist;"
		end

	c_socket_cb (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * easy, int s, int what, void * userp, void * socketp))((struct Curl_multi *)$tmp)->socket_cb;"
		end

	c_socket_userp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct Curl_multi *)$tmp)->socket_userp;"
		end

	c_hostcache (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_hash *)((struct Curl_multi *)$tmp)->hostcache;"
		end

	c_timetree (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Curl_tree *)((struct Curl_multi *)$tmp)->timetree;"
		end

	c_sockhash (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_hash *)((struct Curl_multi *)$tmp)->sockhash;"
		end

	c_pipelining_enabled (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct Curl_multi *)$tmp)->pipelining_enabled;"
		end

	c_connc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct conncache *)((struct Curl_multi *)$tmp)->connc;"
		end

	c_maxconnects (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct Curl_multi *)$tmp)->maxconnects;"
		end

	c_closure (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct closure *)((struct Curl_multi *)$tmp)->closure;"
		end

	c_timer_cb (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * multi, long timeout_ms, void * userp))((struct Curl_multi *)$tmp)->timer_cb;"
		end

	c_timer_userp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct Curl_multi *)$tmp)->timer_userp;"
		end

	c_timer_lastcall (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct timeval *)&((struct Curl_multi *)$tmp)->timer_lastcall;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Curl_multi *)$tmp)->type = $a_type;"
		end

	c_set_num_easy (tmp: POINTER; a_num_easy: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Curl_multi *)$tmp)->num_easy = $a_num_easy;"
		end

	c_set_num_alive (tmp: POINTER; a_num_alive: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Curl_multi *)$tmp)->num_alive = $a_num_alive;"
		end

	c_set_msglist (tmp: POINTER; a_msglist: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_multi *)$tmp)->msglist = (struct curl_llist *)$a_msglist;"
		end

	c_set_socket_cb (tmp: POINTER; a_socket_cb: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_multi *)$tmp)->socket_cb = (int( *)(void * easy, int s, int what, void * userp, void * socketp))$a_socket_cb;"
		end

	c_set_socket_userp (tmp: POINTER; a_socket_userp: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_multi *)$tmp)->socket_userp = (void *)$a_socket_userp;"
		end

	c_set_hostcache (tmp: POINTER; a_hostcache: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_multi *)$tmp)->hostcache = (struct curl_hash *)$a_hostcache;"
		end

	c_set_timetree (tmp: POINTER; a_timetree: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_multi *)$tmp)->timetree = (struct Curl_tree *)$a_timetree;"
		end

	c_set_sockhash (tmp: POINTER; a_sockhash: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_multi *)$tmp)->sockhash = (struct curl_hash *)$a_sockhash;"
		end

	c_set_pipelining_enabled (tmp: POINTER; a_pipelining_enabled: BOOLEAN)
		external
			"C inline"
		alias
			"((struct Curl_multi *)$tmp)->pipelining_enabled = $a_pipelining_enabled;"
		end

	c_set_connc (tmp: POINTER; a_connc: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_multi *)$tmp)->connc = (struct conncache *)$a_connc;"
		end

	c_set_maxconnects (tmp: POINTER; a_maxconnects: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Curl_multi *)$tmp)->maxconnects = $a_maxconnects;"
		end

	c_set_closure (tmp: POINTER; a_closure: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_multi *)$tmp)->closure = (struct closure *)$a_closure;"
		end

	c_set_timer_cb (tmp: POINTER; a_timer_cb: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_multi *)$tmp)->timer_cb = (int( *)(void * multi, long timeout_ms, void * userp))$a_timer_cb;"
		end

	c_set_timer_userp (tmp: POINTER; a_timer_userp: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_multi *)$tmp)->timer_userp = (void *)$a_timer_userp;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct Curl_multi);"
		end

end
