class
	PD_CURL_ONE_EASY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_CURL_ONE_EASY] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_CURL_ONE_EASY] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	easy_handle: CE_POINTER [PD_SESSIONHANDLE] assign set_easy_handle
		do
			create Result.make_shared (c_easy_handle (c_pointer))
		end

	easy_conn: CE_POINTER [PD_CONNECTDATA] assign set_easy_conn
		do
			create Result.make_shared (c_easy_conn (c_pointer))
		end

	easy_conn_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct Curl_one_easy, easy_conn);"
		end

	state: INTEGER_32 assign set_state
		do
			Result := c_state (c_pointer)
		end

	result2: INTEGER_32 assign set_result2
		do
			Result := c_result2 (c_pointer)
		end

	msg: PD_CURL_MESSAGE assign set_msg
		do
			create Result.make_shared (c_msg (c_pointer))
		end

	msg_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct Curl_one_easy, msg);"
		end

	sockets: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_sockets (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	numsocks: INTEGER_32 assign set_numsocks
		do
			Result := c_numsocks (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_CURL_ONE_EASY])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_CURL_ONE_EASY])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_easy_handle (a_easy_handle: CE_POINTER [PD_SESSIONHANDLE])
		do
			c_set_easy_handle (c_pointer, a_easy_handle.c_pointer)
		end

	set_easy_conn (a_easy_conn: CE_POINTER [PD_CONNECTDATA])
		do
			c_set_easy_conn (c_pointer, a_easy_conn.c_pointer)
		end

	set_state (a_state: INTEGER_32)
		do
			c_set_state (c_pointer, a_state)
		end

	set_result2 (a_result2: INTEGER_32)
		do
			c_set_result2 (c_pointer, a_result2)
		end

	set_msg (a_msg: PD_CURL_MESSAGE)
		do
			msg.ce_gets (a_msg)
		end

	set_numsocks (a_numsocks: INTEGER_32)
		do
			c_set_numsocks (c_pointer, a_numsocks)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Curl_one_easy *)((struct Curl_one_easy *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Curl_one_easy *)((struct Curl_one_easy *)$tmp)->prev;"
		end

	c_easy_handle (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct SessionHandle *)((struct Curl_one_easy *)$tmp)->easy_handle;"
		end

	c_easy_conn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct connectdata *)((struct Curl_one_easy *)$tmp)->easy_conn;"
		end

	c_state (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Curl_one_easy *)$tmp)->state;"
		end

	c_result2 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Curl_one_easy *)$tmp)->result;"
		end

	c_msg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Curl_message *)&((struct Curl_one_easy *)$tmp)->msg;"
		end

	c_sockets (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct Curl_one_easy *tmp = (struct Curl_one_easy *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->sockets) / sizeof(tmp->sockets[0]);
				return tmp->sockets;
			]"
		end

	c_numsocks (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Curl_one_easy *)$tmp)->numsocks;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_one_easy *)$tmp)->next = (struct Curl_one_easy *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_one_easy *)$tmp)->prev = (struct Curl_one_easy *)$a_prev;"
		end

	c_set_easy_handle (tmp: POINTER; a_easy_handle: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_one_easy *)$tmp)->easy_handle = (struct SessionHandle *)$a_easy_handle;"
		end

	c_set_easy_conn (tmp: POINTER; a_easy_conn: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_one_easy *)$tmp)->easy_conn = (struct connectdata *)$a_easy_conn;"
		end

	c_set_state (tmp: POINTER; a_state: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Curl_one_easy *)$tmp)->state = $a_state;"
		end

	c_set_result2 (tmp: POINTER; a_result2: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Curl_one_easy *)$tmp)->result = $a_result2;"
		end

	c_set_numsocks (tmp: POINTER; a_numsocks: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Curl_one_easy *)$tmp)->numsocks = $a_numsocks;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct Curl_one_easy);"
		end

end
