class
	PD_CURL_SEND_BUFFER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	buffer: CE_POINTER [INTEGER_8] assign set_buffer
		do
			create Result.make_shared (c_buffer (c_pointer))
		end

	size_max: NATURAL_32 assign set_size_max
		do
			Result := c_size_max (c_pointer)
		end

	size_used: NATURAL_32 assign set_size_used
		do
			Result := c_size_used (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_buffer (a_buffer: CE_POINTER [INTEGER_8])
		do
			c_set_buffer (c_pointer, a_buffer.c_pointer)
		end

	set_size_max (a_size_max: NATURAL_32)
		do
			c_set_size_max (c_pointer, a_size_max)
		end

	set_size_used (a_size_used: NATURAL_32)
		do
			c_set_size_used (c_pointer, a_size_used)
		end

feature {NONE} -- C getters

	c_buffer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct Curl_send_buffer *)$tmp)->buffer;"
		end

	c_size_max (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct Curl_send_buffer *)$tmp)->size_max;"
		end

	c_size_used (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct Curl_send_buffer *)$tmp)->size_used;"
		end

feature {NONE} -- C setters

	c_set_buffer (tmp: POINTER; a_buffer: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_send_buffer *)$tmp)->buffer = (char *)$a_buffer;"
		end

	c_set_size_max (tmp: POINTER; a_size_max: NATURAL_32)
		external
			"C inline"
		alias
			"((struct Curl_send_buffer *)$tmp)->size_max = $a_size_max;"
		end

	c_set_size_used (tmp: POINTER; a_size_used: NATURAL_32)
		external
			"C inline"
		alias
			"((struct Curl_send_buffer *)$tmp)->size_used = $a_size_used;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct Curl_send_buffer);"
		end

end
