class
	PD_CURL_SH_ENTRY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	easy: CE_POINTER [PD_SESSIONHANDLE] assign set_easy
		do
			create Result.make_shared (c_easy (c_pointer))
		end

	timestamp: INTEGER_32 assign set_timestamp
		do
			Result := c_timestamp (c_pointer)
		end

	action: INTEGER_32 assign set_action
		do
			Result := c_action (c_pointer)
		end

	socket: INTEGER_32 assign set_socket
		do
			Result := c_socket (c_pointer)
		end

	socketp: CE_POINTER [ANY] assign set_socketp
		do
			create Result.make_shared (c_socketp (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_easy (a_easy: CE_POINTER [PD_SESSIONHANDLE])
		do
			c_set_easy (c_pointer, a_easy.c_pointer)
		end

	set_timestamp (a_timestamp: INTEGER_32)
		do
			c_set_timestamp (c_pointer, a_timestamp)
		end

	set_action (a_action: INTEGER_32)
		do
			c_set_action (c_pointer, a_action)
		end

	set_socket (a_socket: INTEGER_32)
		do
			c_set_socket (c_pointer, a_socket)
		end

	set_socketp (a_socketp: CE_POINTER [ANY])
		do
			c_set_socketp (c_pointer, a_socketp.c_pointer)
		end

feature {NONE} -- C getters

	c_easy (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct SessionHandle *)((struct Curl_sh_entry *)$tmp)->easy;"
		end

	c_timestamp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct Curl_sh_entry *)$tmp)->timestamp;"
		end

	c_action (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Curl_sh_entry *)$tmp)->action;"
		end

	c_socket (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Curl_sh_entry *)$tmp)->socket;"
		end

	c_socketp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct Curl_sh_entry *)$tmp)->socketp;"
		end

feature {NONE} -- C setters

	c_set_easy (tmp: POINTER; a_easy: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_sh_entry *)$tmp)->easy = (struct SessionHandle *)$a_easy;"
		end

	c_set_timestamp (tmp: POINTER; a_timestamp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Curl_sh_entry *)$tmp)->timestamp = $a_timestamp;"
		end

	c_set_action (tmp: POINTER; a_action: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Curl_sh_entry *)$tmp)->action = $a_action;"
		end

	c_set_socket (tmp: POINTER; a_socket: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Curl_sh_entry *)$tmp)->socket = $a_socket;"
		end

	c_set_socketp (tmp: POINTER; a_socketp: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_sh_entry *)$tmp)->socketp = (void *)$a_socketp;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct Curl_sh_entry);"
		end

end
