class
	PD_CURL_SHARE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	specifier: NATURAL_32 assign set_specifier
		do
			Result := c_specifier (c_pointer)
		end

	dirty: NATURAL_32 assign set_dirty
		do
			Result := c_dirty (c_pointer)
		end

	lockfunc: CE_ROUTINE assign set_lockfunc
		do
			create Result.make_shared (c_lockfunc (c_pointer))
		end

	unlockfunc: CE_ROUTINE assign set_unlockfunc
		do
			create Result.make_shared (c_unlockfunc (c_pointer))
		end

	clientdata: CE_POINTER [ANY] assign set_clientdata
		do
			create Result.make_shared (c_clientdata (c_pointer))
		end

	hostcache: CE_POINTER [PD_CURL_HASH] assign set_hostcache
		do
			create Result.make_shared (c_hostcache (c_pointer))
		end

	cookies: CE_POINTER [PD_COOKIEINFO] assign set_cookies
		do
			create Result.make_shared (c_cookies (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_specifier (a_specifier: NATURAL_32)
		do
			c_set_specifier (c_pointer, a_specifier)
		end

	set_dirty (a_dirty: NATURAL_32)
		do
			c_set_dirty (c_pointer, a_dirty)
		end

	set_lockfunc (a_lockfunc: CE_ROUTINE)
		do
			c_set_lockfunc (c_pointer, a_lockfunc.c_pointer)
		end

	set_unlockfunc (a_unlockfunc: CE_ROUTINE)
		do
			c_set_unlockfunc (c_pointer, a_unlockfunc.c_pointer)
		end

	set_clientdata (a_clientdata: CE_POINTER [ANY])
		do
			c_set_clientdata (c_pointer, a_clientdata.c_pointer)
		end

	set_hostcache (a_hostcache: CE_POINTER [PD_CURL_HASH])
		do
			c_set_hostcache (c_pointer, a_hostcache.c_pointer)
		end

	set_cookies (a_cookies: CE_POINTER [PD_COOKIEINFO])
		do
			c_set_cookies (c_pointer, a_cookies.c_pointer)
		end

feature {NONE} -- C getters

	c_specifier (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct Curl_share *)$tmp)->specifier;"
		end

	c_dirty (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct Curl_share *)$tmp)->dirty;"
		end

	c_lockfunc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void * handle, int data, int locktype, void * userptr))((struct Curl_share *)$tmp)->lockfunc;"
		end

	c_unlockfunc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void * handle, int data, void * userptr))((struct Curl_share *)$tmp)->unlockfunc;"
		end

	c_clientdata (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct Curl_share *)$tmp)->clientdata;"
		end

	c_hostcache (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_hash *)((struct Curl_share *)$tmp)->hostcache;"
		end

	c_cookies (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct CookieInfo *)((struct Curl_share *)$tmp)->cookies;"
		end

feature {NONE} -- C setters

	c_set_specifier (tmp: POINTER; a_specifier: NATURAL_32)
		external
			"C inline"
		alias
			"((struct Curl_share *)$tmp)->specifier = $a_specifier;"
		end

	c_set_dirty (tmp: POINTER; a_dirty: NATURAL_32)
		external
			"C inline"
		alias
			"((struct Curl_share *)$tmp)->dirty = $a_dirty;"
		end

	c_set_lockfunc (tmp: POINTER; a_lockfunc: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_share *)$tmp)->lockfunc = (void( *)(void * handle, int data, int locktype, void * userptr))$a_lockfunc;"
		end

	c_set_unlockfunc (tmp: POINTER; a_unlockfunc: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_share *)$tmp)->unlockfunc = (void( *)(void * handle, int data, void * userptr))$a_unlockfunc;"
		end

	c_set_clientdata (tmp: POINTER; a_clientdata: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_share *)$tmp)->clientdata = (void *)$a_clientdata;"
		end

	c_set_hostcache (tmp: POINTER; a_hostcache: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_share *)$tmp)->hostcache = (struct curl_hash *)$a_hostcache;"
		end

	c_set_cookies (tmp: POINTER; a_cookies: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_share *)$tmp)->cookies = (struct CookieInfo *)$a_cookies;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct Curl_share);"
		end

end
