class
	PD_CURL_SOCKADDR

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	family: INTEGER_32 assign set_family
		do
			Result := c_family (c_pointer)
		end

	socktype: INTEGER_32 assign set_socktype
		do
			Result := c_socktype (c_pointer)
		end

	protocol: INTEGER_32 assign set_protocol
		do
			Result := c_protocol (c_pointer)
		end

	addrlen: NATURAL_32 assign set_addrlen
		do
			Result := c_addrlen (c_pointer)
		end

	addr: SD_SOCKADDR assign set_addr
		do
			create Result.make_shared (c_addr (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_family (a_family: INTEGER_32)
		do
			c_set_family (c_pointer, a_family)
		end

	set_socktype (a_socktype: INTEGER_32)
		do
			c_set_socktype (c_pointer, a_socktype)
		end

	set_protocol (a_protocol: INTEGER_32)
		do
			c_set_protocol (c_pointer, a_protocol)
		end

	set_addrlen (a_addrlen: NATURAL_32)
		do
			c_set_addrlen (c_pointer, a_addrlen)
		end

	set_addr (a_addr: SD_SOCKADDR)
		do
			addr.ce_gets (a_addr)
		end

feature {NONE} -- C getters

	c_family (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct curl_sockaddr *)$tmp)->family;"
		end

	c_socktype (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct curl_sockaddr *)$tmp)->socktype;"
		end

	c_protocol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct curl_sockaddr *)$tmp)->protocol;"
		end

	c_addrlen (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct curl_sockaddr *)$tmp)->addrlen;"
		end

	c_addr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct sockaddr *)&((struct curl_sockaddr *)$tmp)->addr;"
		end

feature {NONE} -- C setters

	c_set_family (tmp: POINTER; a_family: INTEGER_32)
		external
			"C inline"
		alias
			"((struct curl_sockaddr *)$tmp)->family = $a_family;"
		end

	c_set_socktype (tmp: POINTER; a_socktype: INTEGER_32)
		external
			"C inline"
		alias
			"((struct curl_sockaddr *)$tmp)->socktype = $a_socktype;"
		end

	c_set_protocol (tmp: POINTER; a_protocol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct curl_sockaddr *)$tmp)->protocol = $a_protocol;"
		end

	c_set_addrlen (tmp: POINTER; a_addrlen: NATURAL_32)
		external
			"C inline"
		alias
			"((struct curl_sockaddr *)$tmp)->addrlen = $a_addrlen;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct curl_sockaddr);"
		end

end
