class
	PD_CURL_SSL_SESSION

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	sessionid: CE_POINTER [ANY] assign set_sessionid
		do
			create Result.make_shared (c_sessionid (c_pointer))
		end

	idsize: NATURAL_32 assign set_idsize
		do
			Result := c_idsize (c_pointer)
		end

	age: INTEGER_32 assign set_age
		do
			Result := c_age (c_pointer)
		end

	remote_port: NATURAL_16 assign set_remote_port
		do
			Result := c_remote_port (c_pointer)
		end

	ssl_config: PD_SSL_CONFIG_DATA assign set_ssl_config
		do
			create Result.make_shared (c_ssl_config (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_sessionid (a_sessionid: CE_POINTER [ANY])
		do
			c_set_sessionid (c_pointer, a_sessionid.c_pointer)
		end

	set_idsize (a_idsize: NATURAL_32)
		do
			c_set_idsize (c_pointer, a_idsize)
		end

	set_age (a_age: INTEGER_32)
		do
			c_set_age (c_pointer, a_age)
		end

	set_remote_port (a_remote_port: NATURAL_16)
		do
			c_set_remote_port (c_pointer, a_remote_port)
		end

	set_ssl_config (a_ssl_config: PD_SSL_CONFIG_DATA)
		do
			ssl_config.ce_gets (a_ssl_config)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct curl_ssl_session *)$tmp)->name;"
		end

	c_sessionid (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct curl_ssl_session *)$tmp)->sessionid;"
		end

	c_idsize (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct curl_ssl_session *)$tmp)->idsize;"
		end

	c_age (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct curl_ssl_session *)$tmp)->age;"
		end

	c_remote_port (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct curl_ssl_session *)$tmp)->remote_port;"
		end

	c_ssl_config (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct ssl_config_data *)&((struct curl_ssl_session *)$tmp)->ssl_config;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct curl_ssl_session *)$tmp)->name = (char *)$a_name;"
		end

	c_set_sessionid (tmp: POINTER; a_sessionid: POINTER)
		external
			"C inline"
		alias
			"((struct curl_ssl_session *)$tmp)->sessionid = (void *)$a_sessionid;"
		end

	c_set_idsize (tmp: POINTER; a_idsize: NATURAL_32)
		external
			"C inline"
		alias
			"((struct curl_ssl_session *)$tmp)->idsize = $a_idsize;"
		end

	c_set_age (tmp: POINTER; a_age: INTEGER_32)
		external
			"C inline"
		alias
			"((struct curl_ssl_session *)$tmp)->age = $a_age;"
		end

	c_set_remote_port (tmp: POINTER; a_remote_port: NATURAL_16)
		external
			"C inline"
		alias
			"((struct curl_ssl_session *)$tmp)->remote_port = $a_remote_port;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct curl_ssl_session);"
		end

end
