class
	PD_CURL_TREE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	smaller: CE_POINTER [PD_CURL_TREE] assign set_smaller
		do
			create Result.make_shared (c_smaller (c_pointer))
		end

	larger: CE_POINTER [PD_CURL_TREE] assign set_larger
		do
			create Result.make_shared (c_larger (c_pointer))
		end

	same: CE_POINTER [PD_CURL_TREE] assign set_same
		do
			create Result.make_shared (c_same (c_pointer))
		end

	key: SD_TIMEVAL assign set_key
		do
			create Result.make_shared (c_key (c_pointer))
		end

	payload: CE_POINTER [ANY] assign set_payload
		do
			create Result.make_shared (c_payload (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_smaller (a_smaller: CE_POINTER [PD_CURL_TREE])
		do
			c_set_smaller (c_pointer, a_smaller.c_pointer)
		end

	set_larger (a_larger: CE_POINTER [PD_CURL_TREE])
		do
			c_set_larger (c_pointer, a_larger.c_pointer)
		end

	set_same (a_same: CE_POINTER [PD_CURL_TREE])
		do
			c_set_same (c_pointer, a_same.c_pointer)
		end

	set_key (a_key: SD_TIMEVAL)
		do
			key.ce_gets (a_key)
		end

	set_payload (a_payload: CE_POINTER [ANY])
		do
			c_set_payload (c_pointer, a_payload.c_pointer)
		end

feature {NONE} -- C getters

	c_smaller (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Curl_tree *)((struct Curl_tree *)$tmp)->smaller;"
		end

	c_larger (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Curl_tree *)((struct Curl_tree *)$tmp)->larger;"
		end

	c_same (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Curl_tree *)((struct Curl_tree *)$tmp)->same;"
		end

	c_key (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct timeval *)&((struct Curl_tree *)$tmp)->key;"
		end

	c_payload (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct Curl_tree *)$tmp)->payload;"
		end

feature {NONE} -- C setters

	c_set_smaller (tmp: POINTER; a_smaller: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_tree *)$tmp)->smaller = (struct Curl_tree *)$a_smaller;"
		end

	c_set_larger (tmp: POINTER; a_larger: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_tree *)$tmp)->larger = (struct Curl_tree *)$a_larger;"
		end

	c_set_same (tmp: POINTER; a_same: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_tree *)$tmp)->same = (struct Curl_tree *)$a_same;"
		end

	c_set_payload (tmp: POINTER; a_payload: POINTER)
		external
			"C inline"
		alias
			"((struct Curl_tree *)$tmp)->payload = (void *)$a_payload;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct Curl_tree);"
		end

end
