class
	PD_CURLMSG

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	msg: INTEGER_32 assign set_msg
		do
			Result := c_msg (c_pointer)
		end

	easy_handle: CE_POINTER [ANY] assign set_easy_handle
		do
			create Result.make_shared (c_easy_handle (c_pointer))
		end

	data: PD_DATA2 assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_msg (a_msg: INTEGER_32)
		do
			c_set_msg (c_pointer, a_msg)
		end

	set_easy_handle (a_easy_handle: CE_POINTER [ANY])
		do
			c_set_easy_handle (c_pointer, a_easy_handle.c_pointer)
		end

	set_data (a_data: PD_DATA2)
		do
			data.ce_gets (a_data)
		end

feature {NONE} -- C getters

	c_msg (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct CURLMsg *)$tmp)->msg;"
		end

	c_easy_handle (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct CURLMsg *)$tmp)->easy_handle;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_data_67 *)&((struct CURLMsg *)$tmp)->data;"
		end

feature {NONE} -- C setters

	c_set_msg (tmp: POINTER; a_msg: INTEGER_32)
		external
			"C inline"
		alias
			"((struct CURLMsg *)$tmp)->msg = $a_msg;"
		end

	c_set_easy_handle (tmp: POINTER; a_easy_handle: POINTER)
		external
			"C inline"
		alias
			"((struct CURLMsg *)$tmp)->easy_handle = (void *)$a_easy_handle;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct CURLMsg);"
		end

end
