class
	PD_DATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	str: CE_POINTER [INTEGER_8] assign set_str
		do
			create Result.make_shared (c_str (c_pointer))
		end

	ptr: CE_POINTER [ANY] assign set_ptr
		do
			create Result.make_shared (c_ptr (c_pointer))
		end

	num: PD_NUM assign set_num
		do
			create Result.make_shared (c_num (c_pointer))
		end

	dnum: REAL_64 assign set_dnum
		do
			Result := c_dnum (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_str (a_str: CE_POINTER [INTEGER_8])
		do
			c_set_str (c_pointer, a_str.c_pointer)
		end

	set_ptr (a_ptr: CE_POINTER [ANY])
		do
			c_set_ptr (c_pointer, a_ptr.c_pointer)
		end

	set_num (a_num: PD_NUM)
		do
			num.ce_gets (a_num)
		end

	set_dnum (a_dnum: REAL_64)
		do
			c_set_dnum (c_pointer, a_dnum)
		end

feature {NONE} -- C getters

	c_str (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((union __anonunion_data_69 *)$tmp)->str;"
		end

	c_ptr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((union __anonunion_data_69 *)$tmp)->ptr;"
		end

	c_num (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_num_70 *)&((union __anonunion_data_69 *)$tmp)->num;"
		end

	c_dnum (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((union __anonunion_data_69 *)$tmp)->dnum;"
		end

feature {NONE} -- C setters

	c_set_str (tmp: POINTER; a_str: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_data_69 *)$tmp)->str = (char *)$a_str;"
		end

	c_set_ptr (tmp: POINTER; a_ptr: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_data_69 *)$tmp)->ptr = (void *)$a_ptr;"
		end

	c_set_dnum (tmp: POINTER; a_dnum: REAL_64)
		external
			"C inline"
		alias
			"((union __anonunion_data_69 *)$tmp)->dnum = $a_dnum;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(union __anonunion_data_69);"
		end

end
