class
	PD_DIGESTDATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	nonce: CE_POINTER [INTEGER_8] assign set_nonce
		do
			create Result.make_shared (c_nonce (c_pointer))
		end

	cnonce: CE_POINTER [INTEGER_8] assign set_cnonce
		do
			create Result.make_shared (c_cnonce (c_pointer))
		end

	realm: CE_POINTER [INTEGER_8] assign set_realm
		do
			create Result.make_shared (c_realm (c_pointer))
		end

	algo: INTEGER_32 assign set_algo
		do
			Result := c_algo (c_pointer)
		end

	stale: BOOLEAN assign set_stale
		do
			Result := c_stale (c_pointer)
		end

	opaque: CE_POINTER [INTEGER_8] assign set_opaque
		do
			create Result.make_shared (c_opaque (c_pointer))
		end

	qop: CE_POINTER [INTEGER_8] assign set_qop
		do
			create Result.make_shared (c_qop (c_pointer))
		end

	algorithm: CE_POINTER [INTEGER_8] assign set_algorithm
		do
			create Result.make_shared (c_algorithm (c_pointer))
		end

	nc: INTEGER_32 assign set_nc
		do
			Result := c_nc (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_nonce (a_nonce: CE_POINTER [INTEGER_8])
		do
			c_set_nonce (c_pointer, a_nonce.c_pointer)
		end

	set_cnonce (a_cnonce: CE_POINTER [INTEGER_8])
		do
			c_set_cnonce (c_pointer, a_cnonce.c_pointer)
		end

	set_realm (a_realm: CE_POINTER [INTEGER_8])
		do
			c_set_realm (c_pointer, a_realm.c_pointer)
		end

	set_algo (a_algo: INTEGER_32)
		do
			c_set_algo (c_pointer, a_algo)
		end

	set_stale (a_stale: BOOLEAN)
		do
			c_set_stale (c_pointer, a_stale)
		end

	set_opaque (a_opaque: CE_POINTER [INTEGER_8])
		do
			c_set_opaque (c_pointer, a_opaque.c_pointer)
		end

	set_qop (a_qop: CE_POINTER [INTEGER_8])
		do
			c_set_qop (c_pointer, a_qop.c_pointer)
		end

	set_algorithm (a_algorithm: CE_POINTER [INTEGER_8])
		do
			c_set_algorithm (c_pointer, a_algorithm.c_pointer)
		end

	set_nc (a_nc: INTEGER_32)
		do
			c_set_nc (c_pointer, a_nc)
		end

feature {NONE} -- C getters

	c_nonce (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct digestdata *)$tmp)->nonce;"
		end

	c_cnonce (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct digestdata *)$tmp)->cnonce;"
		end

	c_realm (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct digestdata *)$tmp)->realm;"
		end

	c_algo (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct digestdata *)$tmp)->algo;"
		end

	c_stale (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct digestdata *)$tmp)->stale;"
		end

	c_opaque (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct digestdata *)$tmp)->opaque;"
		end

	c_qop (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct digestdata *)$tmp)->qop;"
		end

	c_algorithm (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct digestdata *)$tmp)->algorithm;"
		end

	c_nc (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct digestdata *)$tmp)->nc;"
		end

feature {NONE} -- C setters

	c_set_nonce (tmp: POINTER; a_nonce: POINTER)
		external
			"C inline"
		alias
			"((struct digestdata *)$tmp)->nonce = (char *)$a_nonce;"
		end

	c_set_cnonce (tmp: POINTER; a_cnonce: POINTER)
		external
			"C inline"
		alias
			"((struct digestdata *)$tmp)->cnonce = (char *)$a_cnonce;"
		end

	c_set_realm (tmp: POINTER; a_realm: POINTER)
		external
			"C inline"
		alias
			"((struct digestdata *)$tmp)->realm = (char *)$a_realm;"
		end

	c_set_algo (tmp: POINTER; a_algo: INTEGER_32)
		external
			"C inline"
		alias
			"((struct digestdata *)$tmp)->algo = $a_algo;"
		end

	c_set_stale (tmp: POINTER; a_stale: BOOLEAN)
		external
			"C inline"
		alias
			"((struct digestdata *)$tmp)->stale = $a_stale;"
		end

	c_set_opaque (tmp: POINTER; a_opaque: POINTER)
		external
			"C inline"
		alias
			"((struct digestdata *)$tmp)->opaque = (char *)$a_opaque;"
		end

	c_set_qop (tmp: POINTER; a_qop: POINTER)
		external
			"C inline"
		alias
			"((struct digestdata *)$tmp)->qop = (char *)$a_qop;"
		end

	c_set_algorithm (tmp: POINTER; a_algorithm: POINTER)
		external
			"C inline"
		alias
			"((struct digestdata *)$tmp)->algorithm = (char *)$a_algorithm;"
		end

	c_set_nc (tmp: POINTER; a_nc: INTEGER_32)
		external
			"C inline"
		alias
			"((struct digestdata *)$tmp)->nc = $a_nc;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct digestdata);"
		end

end
