class
	PD_DYNAMICSTATIC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	url: CE_POINTER [INTEGER_8] assign set_url
		do
			create Result.make_shared (c_url (c_pointer))
		end

	url_alloc: BOOLEAN assign set_url_alloc
		do
			Result := c_url_alloc (c_pointer)
		end

	referer: CE_POINTER [INTEGER_8] assign set_referer
		do
			create Result.make_shared (c_referer (c_pointer))
		end

	referer_alloc: BOOLEAN assign set_referer_alloc
		do
			Result := c_referer_alloc (c_pointer)
		end

	cookielist: CE_POINTER [PD_CURL_SLIST] assign set_cookielist
		do
			create Result.make_shared (c_cookielist (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_url (a_url: CE_POINTER [INTEGER_8])
		do
			c_set_url (c_pointer, a_url.c_pointer)
		end

	set_url_alloc (a_url_alloc: BOOLEAN)
		do
			c_set_url_alloc (c_pointer, a_url_alloc)
		end

	set_referer (a_referer: CE_POINTER [INTEGER_8])
		do
			c_set_referer (c_pointer, a_referer.c_pointer)
		end

	set_referer_alloc (a_referer_alloc: BOOLEAN)
		do
			c_set_referer_alloc (c_pointer, a_referer_alloc)
		end

	set_cookielist (a_cookielist: CE_POINTER [PD_CURL_SLIST])
		do
			c_set_cookielist (c_pointer, a_cookielist.c_pointer)
		end

feature {NONE} -- C getters

	c_url (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct DynamicStatic *)$tmp)->url;"
		end

	c_url_alloc (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct DynamicStatic *)$tmp)->url_alloc;"
		end

	c_referer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct DynamicStatic *)$tmp)->referer;"
		end

	c_referer_alloc (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct DynamicStatic *)$tmp)->referer_alloc;"
		end

	c_cookielist (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_slist *)((struct DynamicStatic *)$tmp)->cookielist;"
		end

feature {NONE} -- C setters

	c_set_url (tmp: POINTER; a_url: POINTER)
		external
			"C inline"
		alias
			"((struct DynamicStatic *)$tmp)->url = (char *)$a_url;"
		end

	c_set_url_alloc (tmp: POINTER; a_url_alloc: BOOLEAN)
		external
			"C inline"
		alias
			"((struct DynamicStatic *)$tmp)->url_alloc = $a_url_alloc;"
		end

	c_set_referer (tmp: POINTER; a_referer: POINTER)
		external
			"C inline"
		alias
			"((struct DynamicStatic *)$tmp)->referer = (char *)$a_referer;"
		end

	c_set_referer_alloc (tmp: POINTER; a_referer_alloc: BOOLEAN)
		external
			"C inline"
		alias
			"((struct DynamicStatic *)$tmp)->referer_alloc = $a_referer_alloc;"
		end

	c_set_cookielist (tmp: POINTER; a_cookielist: POINTER)
		external
			"C inline"
		alias
			"((struct DynamicStatic *)$tmp)->cookielist = (struct curl_slist *)$a_cookielist;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct DynamicStatic);"
		end

end
