class
	PD_FILEPROTO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	path: CE_POINTER [INTEGER_8] assign set_path
		do
			create Result.make_shared (c_path (c_pointer))
		end

	freepath: CE_POINTER [INTEGER_8] assign set_freepath
		do
			create Result.make_shared (c_freepath (c_pointer))
		end

	fd: INTEGER_32 assign set_fd
		do
			Result := c_fd (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_path (a_path: CE_POINTER [INTEGER_8])
		do
			c_set_path (c_pointer, a_path.c_pointer)
		end

	set_freepath (a_freepath: CE_POINTER [INTEGER_8])
		do
			c_set_freepath (c_pointer, a_freepath.c_pointer)
		end

	set_fd (a_fd: INTEGER_32)
		do
			c_set_fd (c_pointer, a_fd)
		end

feature {NONE} -- C getters

	c_path (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct FILEPROTO *)$tmp)->path;"
		end

	c_freepath (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct FILEPROTO *)$tmp)->freepath;"
		end

	c_fd (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct FILEPROTO *)$tmp)->fd;"
		end

feature {NONE} -- C setters

	c_set_path (tmp: POINTER; a_path: POINTER)
		external
			"C inline"
		alias
			"((struct FILEPROTO *)$tmp)->path = (char *)$a_path;"
		end

	c_set_freepath (tmp: POINTER; a_freepath: POINTER)
		external
			"C inline"
		alias
			"((struct FILEPROTO *)$tmp)->freepath = (char *)$a_freepath;"
		end

	c_set_fd (tmp: POINTER; a_fd: INTEGER_32)
		external
			"C inline"
		alias
			"((struct FILEPROTO *)$tmp)->fd = $a_fd;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct FILEPROTO);"
		end

end
