class
	PD_FORM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	data: CE_POINTER [PD_FORMDATA] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	sent: NATURAL_32 assign set_sent
		do
			Result := c_sent (c_pointer)
		end

	fp: CE_POINTER [SD_IO_FILE] assign set_fp
		do
			create Result.make_shared (c_fp (c_pointer))
		end

	fread_func: CE_ROUTINE assign set_fread_func
		do
			create Result.make_shared (c_fread_func (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_data (a_data: CE_POINTER [PD_FORMDATA])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_sent (a_sent: NATURAL_32)
		do
			c_set_sent (c_pointer, a_sent)
		end

	set_fp (a_fp: CE_POINTER [SD_IO_FILE])
		do
			c_set_fp (c_pointer, a_fp.c_pointer)
		end

	set_fread_func (a_fread_func: CE_ROUTINE)
		do
			c_set_fread_func (c_pointer, a_fread_func.c_pointer)
		end

feature {NONE} -- C getters

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct FormData *)((struct Form *)$tmp)->data;"
		end

	c_sent (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct Form *)$tmp)->sent;"
		end

	c_fp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _IO_FILE *)((struct Form *)$tmp)->fp;"
		end

	c_fread_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned int( *)(char * buffer, unsigned int size, unsigned int nitems, void * instream))((struct Form *)$tmp)->fread_func;"
		end

feature {NONE} -- C setters

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct Form *)$tmp)->data = (struct FormData *)$a_data;"
		end

	c_set_sent (tmp: POINTER; a_sent: NATURAL_32)
		external
			"C inline"
		alias
			"((struct Form *)$tmp)->sent = $a_sent;"
		end

	c_set_fp (tmp: POINTER; a_fp: POINTER)
		external
			"C inline"
		alias
			"((struct Form *)$tmp)->fp = (struct _IO_FILE *)$a_fp;"
		end

	c_set_fread_func (tmp: POINTER; a_fread_func: POINTER)
		external
			"C inline"
		alias
			"((struct Form *)$tmp)->fread_func = (unsigned int( *)(char * buffer, unsigned int size, unsigned int nitems, void * instream))$a_fread_func;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct Form);"
		end

end
