class
	PD_FORMDATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_FORMDATA] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	line: CE_POINTER [INTEGER_8] assign set_line
		do
			create Result.make_shared (c_line (c_pointer))
		end

	length: NATURAL_32 assign set_length
		do
			Result := c_length (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_FORMDATA])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_line (a_line: CE_POINTER [INTEGER_8])
		do
			c_set_line (c_pointer, a_line.c_pointer)
		end

	set_length (a_length: NATURAL_32)
		do
			c_set_length (c_pointer, a_length)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct FormData *)((struct FormData *)$tmp)->next;"
		end

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct FormData *)$tmp)->type;"
		end

	c_line (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct FormData *)$tmp)->line;"
		end

	c_length (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct FormData *)$tmp)->length;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct FormData *)$tmp)->next = (struct FormData *)$a_next;"
		end

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct FormData *)$tmp)->type = $a_type;"
		end

	c_set_line (tmp: POINTER; a_line: POINTER)
		external
			"C inline"
		alias
			"((struct FormData *)$tmp)->line = (char *)$a_line;"
		end

	c_set_length (tmp: POINTER; a_length: NATURAL_32)
		external
			"C inline"
		alias
			"((struct FormData *)$tmp)->length = $a_length;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct FormData);"
		end

end
