class
	PD_FTP

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	bytecountp: CE_POINTER [INTEGER_64] assign set_bytecountp
		do
			create Result.make_shared (c_bytecountp (c_pointer))
		end

	user: CE_POINTER [INTEGER_8] assign set_user
		do
			create Result.make_shared (c_user (c_pointer))
		end

	passwd: CE_POINTER [INTEGER_8] assign set_passwd
		do
			create Result.make_shared (c_passwd (c_pointer))
		end

	transfer: INTEGER_32 assign set_transfer
		do
			Result := c_transfer (c_pointer)
		end

	downloadsize: INTEGER_64 assign set_downloadsize
		do
			Result := c_downloadsize (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_bytecountp (a_bytecountp: CE_POINTER [INTEGER_64])
		do
			c_set_bytecountp (c_pointer, a_bytecountp.c_pointer)
		end

	set_user (a_user: CE_POINTER [INTEGER_8])
		do
			c_set_user (c_pointer, a_user.c_pointer)
		end

	set_passwd (a_passwd: CE_POINTER [INTEGER_8])
		do
			c_set_passwd (c_pointer, a_passwd.c_pointer)
		end

	set_transfer (a_transfer: INTEGER_32)
		do
			c_set_transfer (c_pointer, a_transfer)
		end

	set_downloadsize (a_downloadsize: INTEGER_64)
		do
			c_set_downloadsize (c_pointer, a_downloadsize)
		end

feature {NONE} -- C getters

	c_bytecountp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (long long *)((struct FTP *)$tmp)->bytecountp;"
		end

	c_user (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct FTP *)$tmp)->user;"
		end

	c_passwd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct FTP *)$tmp)->passwd;"
		end

	c_transfer (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct FTP *)$tmp)->transfer;"
		end

	c_downloadsize (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct FTP *)$tmp)->downloadsize;"
		end

feature {NONE} -- C setters

	c_set_bytecountp (tmp: POINTER; a_bytecountp: POINTER)
		external
			"C inline"
		alias
			"((struct FTP *)$tmp)->bytecountp = (long long *)$a_bytecountp;"
		end

	c_set_user (tmp: POINTER; a_user: POINTER)
		external
			"C inline"
		alias
			"((struct FTP *)$tmp)->user = (char *)$a_user;"
		end

	c_set_passwd (tmp: POINTER; a_passwd: POINTER)
		external
			"C inline"
		alias
			"((struct FTP *)$tmp)->passwd = (char *)$a_passwd;"
		end

	c_set_transfer (tmp: POINTER; a_transfer: INTEGER_32)
		external
			"C inline"
		alias
			"((struct FTP *)$tmp)->transfer = $a_transfer;"
		end

	c_set_downloadsize (tmp: POINTER; a_downloadsize: INTEGER_64)
		external
			"C inline"
		alias
			"((struct FTP *)$tmp)->downloadsize = $a_downloadsize;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct FTP);"
		end

end
