class
	PD_FTP_CONN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	pp: PD_PINGPONG assign set_pp
		do
			create Result.make_shared (c_pp (c_pointer))
		end

	pp_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct ftp_conn, pp);"
		end

	entrypath: CE_POINTER [INTEGER_8] assign set_entrypath
		do
			create Result.make_shared (c_entrypath (c_pointer))
		end

	dirs: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_dirs
		do
			create Result.make_shared (c_dirs (c_pointer))
		end

	dirdepth: INTEGER_32 assign set_dirdepth
		do
			Result := c_dirdepth (c_pointer)
		end

	diralloc: INTEGER_32 assign set_diralloc
		do
			Result := c_diralloc (c_pointer)
		end

	file: CE_POINTER [INTEGER_8] assign set_file
		do
			create Result.make_shared (c_file (c_pointer))
		end

	dont_check: BOOLEAN assign set_dont_check
		do
			Result := c_dont_check (c_pointer)
		end

	ctl_valid: BOOLEAN assign set_ctl_valid
		do
			Result := c_ctl_valid (c_pointer)
		end

	cwddone: BOOLEAN assign set_cwddone
		do
			Result := c_cwddone (c_pointer)
		end

	cwdfail: BOOLEAN assign set_cwdfail
		do
			Result := c_cwdfail (c_pointer)
		end

	prevpath: CE_POINTER [INTEGER_8] assign set_prevpath
		do
			create Result.make_shared (c_prevpath (c_pointer))
		end

	transfertype: INTEGER_8 assign set_transfertype
		do
			Result := c_transfertype (c_pointer)
		end

	count1: INTEGER_32 assign set_count1
		do
			Result := c_count1 (c_pointer)
		end

	count2: INTEGER_32 assign set_count2
		do
			Result := c_count2 (c_pointer)
		end

	count3: INTEGER_32 assign set_count3
		do
			Result := c_count3 (c_pointer)
		end

	state: INTEGER_32 assign set_state
		do
			Result := c_state (c_pointer)
		end

	server_os: CE_POINTER [INTEGER_8] assign set_server_os
		do
			create Result.make_shared (c_server_os (c_pointer))
		end

	known_filesize: INTEGER_64 assign set_known_filesize
		do
			Result := c_known_filesize (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_pp (a_pp: PD_PINGPONG)
		do
			pp.ce_gets (a_pp)
		end

	set_entrypath (a_entrypath: CE_POINTER [INTEGER_8])
		do
			c_set_entrypath (c_pointer, a_entrypath.c_pointer)
		end

	set_dirs (a_dirs: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			c_set_dirs (c_pointer, a_dirs.c_pointer)
		end

	set_dirdepth (a_dirdepth: INTEGER_32)
		do
			c_set_dirdepth (c_pointer, a_dirdepth)
		end

	set_diralloc (a_diralloc: INTEGER_32)
		do
			c_set_diralloc (c_pointer, a_diralloc)
		end

	set_file (a_file: CE_POINTER [INTEGER_8])
		do
			c_set_file (c_pointer, a_file.c_pointer)
		end

	set_dont_check (a_dont_check: BOOLEAN)
		do
			c_set_dont_check (c_pointer, a_dont_check)
		end

	set_ctl_valid (a_ctl_valid: BOOLEAN)
		do
			c_set_ctl_valid (c_pointer, a_ctl_valid)
		end

	set_cwddone (a_cwddone: BOOLEAN)
		do
			c_set_cwddone (c_pointer, a_cwddone)
		end

	set_cwdfail (a_cwdfail: BOOLEAN)
		do
			c_set_cwdfail (c_pointer, a_cwdfail)
		end

	set_prevpath (a_prevpath: CE_POINTER [INTEGER_8])
		do
			c_set_prevpath (c_pointer, a_prevpath.c_pointer)
		end

	set_transfertype (a_transfertype: INTEGER_8)
		do
			c_set_transfertype (c_pointer, a_transfertype)
		end

	set_count1 (a_count1: INTEGER_32)
		do
			c_set_count1 (c_pointer, a_count1)
		end

	set_count2 (a_count2: INTEGER_32)
		do
			c_set_count2 (c_pointer, a_count2)
		end

	set_count3 (a_count3: INTEGER_32)
		do
			c_set_count3 (c_pointer, a_count3)
		end

	set_state (a_state: INTEGER_32)
		do
			c_set_state (c_pointer, a_state)
		end

	set_server_os (a_server_os: CE_POINTER [INTEGER_8])
		do
			c_set_server_os (c_pointer, a_server_os.c_pointer)
		end

	set_known_filesize (a_known_filesize: INTEGER_64)
		do
			c_set_known_filesize (c_pointer, a_known_filesize)
		end

feature {NONE} -- C getters

	c_pp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct pingpong *)&((struct ftp_conn *)$tmp)->pp;"
		end

	c_entrypath (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct ftp_conn *)$tmp)->entrypath;"
		end

	c_dirs (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char * *)((struct ftp_conn *)$tmp)->dirs;"
		end

	c_dirdepth (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ftp_conn *)$tmp)->dirdepth;"
		end

	c_diralloc (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ftp_conn *)$tmp)->diralloc;"
		end

	c_file (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct ftp_conn *)$tmp)->file;"
		end

	c_dont_check (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ftp_conn *)$tmp)->dont_check;"
		end

	c_ctl_valid (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ftp_conn *)$tmp)->ctl_valid;"
		end

	c_cwddone (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ftp_conn *)$tmp)->cwddone;"
		end

	c_cwdfail (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ftp_conn *)$tmp)->cwdfail;"
		end

	c_prevpath (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct ftp_conn *)$tmp)->prevpath;"
		end

	c_transfertype (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct ftp_conn *)$tmp)->transfertype;"
		end

	c_count1 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ftp_conn *)$tmp)->count1;"
		end

	c_count2 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ftp_conn *)$tmp)->count2;"
		end

	c_count3 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ftp_conn *)$tmp)->count3;"
		end

	c_state (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ftp_conn *)$tmp)->state;"
		end

	c_server_os (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct ftp_conn *)$tmp)->server_os;"
		end

	c_known_filesize (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct ftp_conn *)$tmp)->known_filesize;"
		end

feature {NONE} -- C setters

	c_set_entrypath (tmp: POINTER; a_entrypath: POINTER)
		external
			"C inline"
		alias
			"((struct ftp_conn *)$tmp)->entrypath = (char *)$a_entrypath;"
		end

	c_set_dirs (tmp: POINTER; a_dirs: POINTER)
		external
			"C inline"
		alias
			"((struct ftp_conn *)$tmp)->dirs = (char * *)$a_dirs;"
		end

	c_set_dirdepth (tmp: POINTER; a_dirdepth: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ftp_conn *)$tmp)->dirdepth = $a_dirdepth;"
		end

	c_set_diralloc (tmp: POINTER; a_diralloc: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ftp_conn *)$tmp)->diralloc = $a_diralloc;"
		end

	c_set_file (tmp: POINTER; a_file: POINTER)
		external
			"C inline"
		alias
			"((struct ftp_conn *)$tmp)->file = (char *)$a_file;"
		end

	c_set_dont_check (tmp: POINTER; a_dont_check: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ftp_conn *)$tmp)->dont_check = $a_dont_check;"
		end

	c_set_ctl_valid (tmp: POINTER; a_ctl_valid: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ftp_conn *)$tmp)->ctl_valid = $a_ctl_valid;"
		end

	c_set_cwddone (tmp: POINTER; a_cwddone: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ftp_conn *)$tmp)->cwddone = $a_cwddone;"
		end

	c_set_cwdfail (tmp: POINTER; a_cwdfail: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ftp_conn *)$tmp)->cwdfail = $a_cwdfail;"
		end

	c_set_prevpath (tmp: POINTER; a_prevpath: POINTER)
		external
			"C inline"
		alias
			"((struct ftp_conn *)$tmp)->prevpath = (char *)$a_prevpath;"
		end

	c_set_transfertype (tmp: POINTER; a_transfertype: INTEGER_8)
		external
			"C inline"
		alias
			"((struct ftp_conn *)$tmp)->transfertype = $a_transfertype;"
		end

	c_set_count1 (tmp: POINTER; a_count1: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ftp_conn *)$tmp)->count1 = $a_count1;"
		end

	c_set_count2 (tmp: POINTER; a_count2: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ftp_conn *)$tmp)->count2 = $a_count2;"
		end

	c_set_count3 (tmp: POINTER; a_count3: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ftp_conn *)$tmp)->count3 = $a_count3;"
		end

	c_set_state (tmp: POINTER; a_state: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ftp_conn *)$tmp)->state = $a_state;"
		end

	c_set_server_os (tmp: POINTER; a_server_os: POINTER)
		external
			"C inline"
		alias
			"((struct ftp_conn *)$tmp)->server_os = (char *)$a_server_os;"
		end

	c_set_known_filesize (tmp: POINTER; a_known_filesize: INTEGER_64)
		external
			"C inline"
		alias
			"((struct ftp_conn *)$tmp)->known_filesize = $a_known_filesize;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct ftp_conn);"
		end

end
