class
	PD_FTP_PARSELIST_DATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	os_type: INTEGER_32 assign set_os_type
		do
			Result := c_os_type (c_pointer)
		end

	state: PD_STATE assign set_state
		do
			create Result.make_shared (c_state (c_pointer))
		end

	error: INTEGER_32 assign set_error
		do
			Result := c_error (c_pointer)
		end

	file_data: CE_POINTER [PD_CURL_FILEINFO] assign set_file_data
		do
			create Result.make_shared (c_file_data (c_pointer))
		end

	item_length: NATURAL_32 assign set_item_length
		do
			Result := c_item_length (c_pointer)
		end

	item_offset: NATURAL_32 assign set_item_offset
		do
			Result := c_item_offset (c_pointer)
		end

	offsets: PD_OFFSETS assign set_offsets
		do
			create Result.make_shared (c_offsets (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_os_type (a_os_type: INTEGER_32)
		do
			c_set_os_type (c_pointer, a_os_type)
		end

	set_state (a_state: PD_STATE)
		do
			state.ce_gets (a_state)
		end

	set_error (a_error: INTEGER_32)
		do
			c_set_error (c_pointer, a_error)
		end

	set_file_data (a_file_data: CE_POINTER [PD_CURL_FILEINFO])
		do
			c_set_file_data (c_pointer, a_file_data.c_pointer)
		end

	set_item_length (a_item_length: NATURAL_32)
		do
			c_set_item_length (c_pointer, a_item_length)
		end

	set_item_offset (a_item_offset: NATURAL_32)
		do
			c_set_item_offset (c_pointer, a_item_offset)
		end

	set_offsets (a_offsets: PD_OFFSETS)
		do
			offsets.ce_gets (a_offsets)
		end

feature {NONE} -- C getters

	c_os_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ftp_parselist_data *)$tmp)->os_type;"
		end

	c_state (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_state_111 *)&((struct ftp_parselist_data *)$tmp)->state;"
		end

	c_error (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ftp_parselist_data *)$tmp)->error;"
		end

	c_file_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_fileinfo *)((struct ftp_parselist_data *)$tmp)->file_data;"
		end

	c_item_length (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct ftp_parselist_data *)$tmp)->item_length;"
		end

	c_item_offset (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct ftp_parselist_data *)$tmp)->item_offset;"
		end

	c_offsets (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct_offsets_114 *)&((struct ftp_parselist_data *)$tmp)->offsets;"
		end

feature {NONE} -- C setters

	c_set_os_type (tmp: POINTER; a_os_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ftp_parselist_data *)$tmp)->os_type = $a_os_type;"
		end

	c_set_error (tmp: POINTER; a_error: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ftp_parselist_data *)$tmp)->error = $a_error;"
		end

	c_set_file_data (tmp: POINTER; a_file_data: POINTER)
		external
			"C inline"
		alias
			"((struct ftp_parselist_data *)$tmp)->file_data = (struct curl_fileinfo *)$a_file_data;"
		end

	c_set_item_length (tmp: POINTER; a_item_length: NATURAL_32)
		external
			"C inline"
		alias
			"((struct ftp_parselist_data *)$tmp)->item_length = $a_item_length;"
		end

	c_set_item_offset (tmp: POINTER; a_item_offset: NATURAL_32)
		external
			"C inline"
		alias
			"((struct ftp_parselist_data *)$tmp)->item_offset = $a_item_offset;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct ftp_parselist_data);"
		end

end
