class
	PD_HOSTCACHE_PRUNE_DATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	cache_timeout: INTEGER_32 assign set_cache_timeout
		do
			Result := c_cache_timeout (c_pointer)
		end

	now: INTEGER_32 assign set_now
		do
			Result := c_now (c_pointer)
		end

	now_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct hostcache_prune_data, now);"
		end

feature {ANY} -- Eiffel setters

	set_cache_timeout (a_cache_timeout: INTEGER_32)
		do
			c_set_cache_timeout (c_pointer, a_cache_timeout)
		end

	set_now (a_now: INTEGER_32)
		do
			c_set_now (c_pointer, a_now)
		end

feature {NONE} -- C getters

	c_cache_timeout (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct hostcache_prune_data *)$tmp)->cache_timeout;"
		end

	c_now (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct hostcache_prune_data *)$tmp)->now;"
		end

feature {NONE} -- C setters

	c_set_cache_timeout (tmp: POINTER; a_cache_timeout: INTEGER_32)
		external
			"C inline"
		alias
			"((struct hostcache_prune_data *)$tmp)->cache_timeout = $a_cache_timeout;"
		end

	c_set_now (tmp: POINTER; a_now: INTEGER_32)
		external
			"C inline"
		alias
			"((struct hostcache_prune_data *)$tmp)->now = $a_now;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct hostcache_prune_data);"
		end

end
