class
	PD_HOSTNAME

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	rawalloc: CE_POINTER [INTEGER_8] assign set_rawalloc
		do
			create Result.make_shared (c_rawalloc (c_pointer))
		end

	encalloc: CE_POINTER [INTEGER_8] assign set_encalloc
		do
			create Result.make_shared (c_encalloc (c_pointer))
		end

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	dispname: CE_POINTER [INTEGER_8] assign set_dispname
		do
			create Result.make_shared (c_dispname (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_rawalloc (a_rawalloc: CE_POINTER [INTEGER_8])
		do
			c_set_rawalloc (c_pointer, a_rawalloc.c_pointer)
		end

	set_encalloc (a_encalloc: CE_POINTER [INTEGER_8])
		do
			c_set_encalloc (c_pointer, a_encalloc.c_pointer)
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_dispname (a_dispname: CE_POINTER [INTEGER_8])
		do
			c_set_dispname (c_pointer, a_dispname.c_pointer)
		end

feature {NONE} -- C getters

	c_rawalloc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct hostname *)$tmp)->rawalloc;"
		end

	c_encalloc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct hostname *)$tmp)->encalloc;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct hostname *)$tmp)->name;"
		end

	c_dispname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct hostname *)$tmp)->dispname;"
		end

feature {NONE} -- C setters

	c_set_rawalloc (tmp: POINTER; a_rawalloc: POINTER)
		external
			"C inline"
		alias
			"((struct hostname *)$tmp)->rawalloc = (char *)$a_rawalloc;"
		end

	c_set_encalloc (tmp: POINTER; a_encalloc: POINTER)
		external
			"C inline"
		alias
			"((struct hostname *)$tmp)->encalloc = (char *)$a_encalloc;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct hostname *)$tmp)->name = (char *)$a_name;"
		end

	c_set_dispname (tmp: POINTER; a_dispname: POINTER)
		external
			"C inline"
		alias
			"((struct hostname *)$tmp)->dispname = (char const *)$a_dispname;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct hostname);"
		end

end
