class
	PD_HTTP

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sendit: CE_POINTER [PD_FORMDATA] assign set_sendit
		do
			create Result.make_shared (c_sendit (c_pointer))
		end

	sendit_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct HTTP, sendit);"
		end

	postsize: INTEGER_64 assign set_postsize
		do
			Result := c_postsize (c_pointer)
		end

	postsize_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct HTTP, postsize);"
		end

	postdata: CE_POINTER [INTEGER_8] assign set_postdata
		do
			create Result.make_shared (c_postdata (c_pointer))
		end

	postdata_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct HTTP, postdata);"
		end

	p_pragma: CE_POINTER [INTEGER_8] assign set_p_pragma
		do
			create Result.make_shared (c_p_pragma (c_pointer))
		end

	p_accept: CE_POINTER [INTEGER_8] assign set_p_accept
		do
			create Result.make_shared (c_p_accept (c_pointer))
		end

	readbytecount: INTEGER_64 assign set_readbytecount
		do
			Result := c_readbytecount (c_pointer)
		end

	readbytecount_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct HTTP, readbytecount);"
		end

	writebytecount: INTEGER_64 assign set_writebytecount
		do
			Result := c_writebytecount (c_pointer)
		end

	writebytecount_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct HTTP, writebytecount);"
		end

	form: PD_FORM assign set_form
		do
			create Result.make_shared (c_form (c_pointer))
		end

	form_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct HTTP, form);"
		end

	backup: PD_BACK assign set_backup
		do
			create Result.make_shared (c_backup (c_pointer))
		end

	sending: INTEGER_32 assign set_sending
		do
			Result := c_sending (c_pointer)
		end

	send_buffer: CE_POINTER [ANY] assign set_send_buffer
		do
			create Result.make_shared (c_send_buffer (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_sendit (a_sendit: CE_POINTER [PD_FORMDATA])
		do
			c_set_sendit (c_pointer, a_sendit.c_pointer)
		end

	set_postsize (a_postsize: INTEGER_64)
		do
			c_set_postsize (c_pointer, a_postsize)
		end

	set_postdata (a_postdata: CE_POINTER [INTEGER_8])
		do
			c_set_postdata (c_pointer, a_postdata.c_pointer)
		end

	set_p_pragma (a_p_pragma: CE_POINTER [INTEGER_8])
		do
			c_set_p_pragma (c_pointer, a_p_pragma.c_pointer)
		end

	set_p_accept (a_p_accept: CE_POINTER [INTEGER_8])
		do
			c_set_p_accept (c_pointer, a_p_accept.c_pointer)
		end

	set_readbytecount (a_readbytecount: INTEGER_64)
		do
			c_set_readbytecount (c_pointer, a_readbytecount)
		end

	set_writebytecount (a_writebytecount: INTEGER_64)
		do
			c_set_writebytecount (c_pointer, a_writebytecount)
		end

	set_form (a_form: PD_FORM)
		do
			form.ce_gets (a_form)
		end

	set_backup (a_backup: PD_BACK)
		do
			backup.ce_gets (a_backup)
		end

	set_sending (a_sending: INTEGER_32)
		do
			c_set_sending (c_pointer, a_sending)
		end

	set_send_buffer (a_send_buffer: CE_POINTER [ANY])
		do
			c_set_send_buffer (c_pointer, a_send_buffer.c_pointer)
		end

feature {NONE} -- C getters

	c_sendit (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct FormData *)((struct HTTP *)$tmp)->sendit;"
		end

	c_postsize (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct HTTP *)$tmp)->postsize;"
		end

	c_postdata (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct HTTP *)$tmp)->postdata;"
		end

	c_p_pragma (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct HTTP *)$tmp)->p_pragma;"
		end

	c_p_accept (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct HTTP *)$tmp)->p_accept;"
		end

	c_readbytecount (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct HTTP *)$tmp)->readbytecount;"
		end

	c_writebytecount (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct HTTP *)$tmp)->writebytecount;"
		end

	c_form (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Form *)&((struct HTTP *)$tmp)->form;"
		end

	c_backup (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct back *)&((struct HTTP *)$tmp)->backup;"
		end

	c_sending (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct HTTP *)$tmp)->sending;"
		end

	c_send_buffer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct HTTP *)$tmp)->send_buffer;"
		end

feature {NONE} -- C setters

	c_set_sendit (tmp: POINTER; a_sendit: POINTER)
		external
			"C inline"
		alias
			"((struct HTTP *)$tmp)->sendit = (struct FormData *)$a_sendit;"
		end

	c_set_postsize (tmp: POINTER; a_postsize: INTEGER_64)
		external
			"C inline"
		alias
			"((struct HTTP *)$tmp)->postsize = $a_postsize;"
		end

	c_set_postdata (tmp: POINTER; a_postdata: POINTER)
		external
			"C inline"
		alias
			"((struct HTTP *)$tmp)->postdata = (char const *)$a_postdata;"
		end

	c_set_p_pragma (tmp: POINTER; a_p_pragma: POINTER)
		external
			"C inline"
		alias
			"((struct HTTP *)$tmp)->p_pragma = (char const *)$a_p_pragma;"
		end

	c_set_p_accept (tmp: POINTER; a_p_accept: POINTER)
		external
			"C inline"
		alias
			"((struct HTTP *)$tmp)->p_accept = (char const *)$a_p_accept;"
		end

	c_set_readbytecount (tmp: POINTER; a_readbytecount: INTEGER_64)
		external
			"C inline"
		alias
			"((struct HTTP *)$tmp)->readbytecount = $a_readbytecount;"
		end

	c_set_writebytecount (tmp: POINTER; a_writebytecount: INTEGER_64)
		external
			"C inline"
		alias
			"((struct HTTP *)$tmp)->writebytecount = $a_writebytecount;"
		end

	c_set_sending (tmp: POINTER; a_sending: INTEGER_32)
		external
			"C inline"
		alias
			"((struct HTTP *)$tmp)->sending = $a_sending;"
		end

	c_set_send_buffer (tmp: POINTER; a_send_buffer: POINTER)
		external
			"C inline"
		alias
			"((struct HTTP *)$tmp)->send_buffer = (void *)$a_send_buffer;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct HTTP);"
		end

end
