class
	PD_IMAP_CONN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	pp: PD_PINGPONG assign set_pp
		do
			create Result.make_shared (c_pp (c_pointer))
		end

	pp_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct imap_conn, pp);"
		end

	mailbox: CE_POINTER [INTEGER_8] assign set_mailbox
		do
			create Result.make_shared (c_mailbox (c_pointer))
		end

	state: INTEGER_32 assign set_state
		do
			Result := c_state (c_pointer)
		end

	cmdid: INTEGER_32 assign set_cmdid
		do
			Result := c_cmdid (c_pointer)
		end

	idstr: CE_POINTER [INTEGER_8] assign set_idstr
		do
			create Result.make_shared (c_idstr (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_pp (a_pp: PD_PINGPONG)
		do
			pp.ce_gets (a_pp)
		end

	set_mailbox (a_mailbox: CE_POINTER [INTEGER_8])
		do
			c_set_mailbox (c_pointer, a_mailbox.c_pointer)
		end

	set_state (a_state: INTEGER_32)
		do
			c_set_state (c_pointer, a_state)
		end

	set_cmdid (a_cmdid: INTEGER_32)
		do
			c_set_cmdid (c_pointer, a_cmdid)
		end

	set_idstr (a_idstr: CE_POINTER [INTEGER_8])
		do
			c_set_idstr (c_pointer, a_idstr.c_pointer)
		end

feature {NONE} -- C getters

	c_pp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct pingpong *)&((struct imap_conn *)$tmp)->pp;"
		end

	c_mailbox (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct imap_conn *)$tmp)->mailbox;"
		end

	c_state (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct imap_conn *)$tmp)->state;"
		end

	c_cmdid (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct imap_conn *)$tmp)->cmdid;"
		end

	c_idstr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct imap_conn *)$tmp)->idstr;"
		end

feature {NONE} -- C setters

	c_set_mailbox (tmp: POINTER; a_mailbox: POINTER)
		external
			"C inline"
		alias
			"((struct imap_conn *)$tmp)->mailbox = (char *)$a_mailbox;"
		end

	c_set_state (tmp: POINTER; a_state: INTEGER_32)
		external
			"C inline"
		alias
			"((struct imap_conn *)$tmp)->state = $a_state;"
		end

	c_set_cmdid (tmp: POINTER; a_cmdid: INTEGER_32)
		external
			"C inline"
		alias
			"((struct imap_conn *)$tmp)->cmdid = $a_cmdid;"
		end

	c_set_idstr (tmp: POINTER; a_idstr: POINTER)
		external
			"C inline"
		alias
			"((struct imap_conn *)$tmp)->idstr = (char const *)$a_idstr;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct imap_conn);"
		end

end
