class
	PD_MD5_CTX

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	state: CE_ARRAY [NATURAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_state (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	count: CE_ARRAY [NATURAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_count (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	buffer: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_buffer (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {NONE} -- C getters

	c_state (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct md5_ctx *tmp = (struct md5_ctx *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->state) / sizeof(tmp->state[0]);
				return tmp->state;
			]"
		end

	c_count (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct md5_ctx *tmp = (struct md5_ctx *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->count) / sizeof(tmp->count[0]);
				return tmp->count;
			]"
		end

	c_buffer (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct md5_ctx *tmp = (struct md5_ctx *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->buffer) / sizeof(tmp->buffer[0]);
				return tmp->buffer;
			]"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct md5_ctx);"
		end

end
