class
	PD_NAMEBUFF

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	hostentry: SD_HOSTENT assign set_hostentry
		do
			create Result.make_shared (c_hostentry (c_pointer))
		end

	hostentry_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct namebuff, hostentry);"
		end

	addrentry: PD_ADDRENTRY assign set_addrentry
		do
			create Result.make_shared (c_addrentry (c_pointer))
		end

	addrentry_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct namebuff, addrentry);"
		end

	h_addr_list: CE_ARRAY [CE_POINTER [INTEGER_8]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_h_addr_list (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_hostentry (a_hostentry: SD_HOSTENT)
		do
			hostentry.ce_gets (a_hostentry)
		end

	set_addrentry (a_addrentry: PD_ADDRENTRY)
		do
			addrentry.ce_gets (a_addrentry)
		end

feature {NONE} -- C getters

	c_hostentry (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct hostent *)&((struct namebuff *)$tmp)->hostentry;"
		end

	c_addrentry (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_addrentry_72 *)&((struct namebuff *)$tmp)->addrentry;"
		end

	c_h_addr_list (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct namebuff *tmp = (struct namebuff *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->h_addr_list) / sizeof(tmp->h_addr_list[0]);
				return tmp->h_addr_list;
			]"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct namebuff);"
		end

end
