class
	PD_NSPRINTF

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	buffer: CE_POINTER [INTEGER_8] assign set_buffer
		do
			create Result.make_shared (c_buffer (c_pointer))
		end

	length: NATURAL_32 assign set_length
		do
			Result := c_length (c_pointer)
		end

	max: NATURAL_32 assign set_max
		do
			Result := c_max (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_buffer (a_buffer: CE_POINTER [INTEGER_8])
		do
			c_set_buffer (c_pointer, a_buffer.c_pointer)
		end

	set_length (a_length: NATURAL_32)
		do
			c_set_length (c_pointer, a_length)
		end

	set_max (a_max: NATURAL_32)
		do
			c_set_max (c_pointer, a_max)
		end

feature {NONE} -- C getters

	c_buffer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct nsprintf *)$tmp)->buffer;"
		end

	c_length (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct nsprintf *)$tmp)->length;"
		end

	c_max (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct nsprintf *)$tmp)->max;"
		end

feature {NONE} -- C setters

	c_set_buffer (tmp: POINTER; a_buffer: POINTER)
		external
			"C inline"
		alias
			"((struct nsprintf *)$tmp)->buffer = (char *)$a_buffer;"
		end

	c_set_length (tmp: POINTER; a_length: NATURAL_32)
		external
			"C inline"
		alias
			"((struct nsprintf *)$tmp)->length = $a_length;"
		end

	c_set_max (tmp: POINTER; a_max: NATURAL_32)
		external
			"C inline"
		alias
			"((struct nsprintf *)$tmp)->max = $a_max;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct nsprintf);"
		end

end
