class
	PD_NTLMDATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	state: INTEGER_32 assign set_state
		do
			Result := c_state (c_pointer)
		end

	flags: NATURAL_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	nonce: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_nonce (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_state (a_state: INTEGER_32)
		do
			c_set_state (c_pointer, a_state)
		end

	set_flags (a_flags: NATURAL_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

feature {NONE} -- C getters

	c_state (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ntlmdata *)$tmp)->state;"
		end

	c_flags (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct ntlmdata *)$tmp)->flags;"
		end

	c_nonce (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct ntlmdata *tmp = (struct ntlmdata *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->nonce) / sizeof(tmp->nonce[0]);
				return tmp->nonce;
			]"
		end

feature {NONE} -- C setters

	c_set_state (tmp: POINTER; a_state: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ntlmdata *)$tmp)->state = $a_state;"
		end

	c_set_flags (tmp: POINTER; a_flags: NATURAL_32)
		external
			"C inline"
		alias
			"((struct ntlmdata *)$tmp)->flags = $a_flags;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct ntlmdata);"
		end

end
