class
	PD_PINGPONG

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	cache: CE_POINTER [INTEGER_8] assign set_cache
		do
			create Result.make_shared (c_cache (c_pointer))
		end

	cache_size: NATURAL_32 assign set_cache_size
		do
			Result := c_cache_size (c_pointer)
		end

	nread_resp: NATURAL_32 assign set_nread_resp
		do
			Result := c_nread_resp (c_pointer)
		end

	linestart_resp: CE_POINTER [INTEGER_8] assign set_linestart_resp
		do
			create Result.make_shared (c_linestart_resp (c_pointer))
		end

	pending_resp: BOOLEAN assign set_pending_resp
		do
			Result := c_pending_resp (c_pointer)
		end

	sendthis: CE_POINTER [INTEGER_8] assign set_sendthis
		do
			create Result.make_shared (c_sendthis (c_pointer))
		end

	sendleft: NATURAL_32 assign set_sendleft
		do
			Result := c_sendleft (c_pointer)
		end

	sendsize: NATURAL_32 assign set_sendsize
		do
			Result := c_sendsize (c_pointer)
		end

	response: SD_TIMEVAL assign set_response
		do
			create Result.make_shared (c_response (c_pointer))
		end

	response_time: INTEGER_32 assign set_response_time
		do
			Result := c_response_time (c_pointer)
		end

	conn: CE_POINTER [PD_CONNECTDATA] assign set_conn
		do
			create Result.make_shared (c_conn (c_pointer))
		end

	statemach_act: CE_ROUTINE assign set_statemach_act
		do
			create Result.make_shared (c_statemach_act (c_pointer))
		end

	endofresp: CE_ROUTINE assign set_endofresp
		do
			create Result.make_shared (c_endofresp (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_cache (a_cache: CE_POINTER [INTEGER_8])
		do
			c_set_cache (c_pointer, a_cache.c_pointer)
		end

	set_cache_size (a_cache_size: NATURAL_32)
		do
			c_set_cache_size (c_pointer, a_cache_size)
		end

	set_nread_resp (a_nread_resp: NATURAL_32)
		do
			c_set_nread_resp (c_pointer, a_nread_resp)
		end

	set_linestart_resp (a_linestart_resp: CE_POINTER [INTEGER_8])
		do
			c_set_linestart_resp (c_pointer, a_linestart_resp.c_pointer)
		end

	set_pending_resp (a_pending_resp: BOOLEAN)
		do
			c_set_pending_resp (c_pointer, a_pending_resp)
		end

	set_sendthis (a_sendthis: CE_POINTER [INTEGER_8])
		do
			c_set_sendthis (c_pointer, a_sendthis.c_pointer)
		end

	set_sendleft (a_sendleft: NATURAL_32)
		do
			c_set_sendleft (c_pointer, a_sendleft)
		end

	set_sendsize (a_sendsize: NATURAL_32)
		do
			c_set_sendsize (c_pointer, a_sendsize)
		end

	set_response (a_response: SD_TIMEVAL)
		do
			response.ce_gets (a_response)
		end

	set_response_time (a_response_time: INTEGER_32)
		do
			c_set_response_time (c_pointer, a_response_time)
		end

	set_conn (a_conn: CE_POINTER [PD_CONNECTDATA])
		do
			c_set_conn (c_pointer, a_conn.c_pointer)
		end

	set_statemach_act (a_statemach_act: CE_ROUTINE)
		do
			c_set_statemach_act (c_pointer, a_statemach_act.c_pointer)
		end

	set_endofresp (a_endofresp: CE_ROUTINE)
		do
			c_set_endofresp (c_pointer, a_endofresp.c_pointer)
		end

feature {NONE} -- C getters

	c_cache (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct pingpong *)$tmp)->cache;"
		end

	c_cache_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct pingpong *)$tmp)->cache_size;"
		end

	c_nread_resp (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct pingpong *)$tmp)->nread_resp;"
		end

	c_linestart_resp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct pingpong *)$tmp)->linestart_resp;"
		end

	c_pending_resp (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct pingpong *)$tmp)->pending_resp;"
		end

	c_sendthis (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct pingpong *)$tmp)->sendthis;"
		end

	c_sendleft (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct pingpong *)$tmp)->sendleft;"
		end

	c_sendsize (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct pingpong *)$tmp)->sendsize;"
		end

	c_response (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct timeval *)&((struct pingpong *)$tmp)->response;"
		end

	c_response_time (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct pingpong *)$tmp)->response_time;"
		end

	c_conn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct connectdata *)((struct pingpong *)$tmp)->conn;"
		end

	c_statemach_act (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct connectdata * conn))((struct pingpong *)$tmp)->statemach_act;"
		end

	c_endofresp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct pingpong * pp, int * code))((struct pingpong *)$tmp)->endofresp;"
		end

feature {NONE} -- C setters

	c_set_cache (tmp: POINTER; a_cache: POINTER)
		external
			"C inline"
		alias
			"((struct pingpong *)$tmp)->cache = (char *)$a_cache;"
		end

	c_set_cache_size (tmp: POINTER; a_cache_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct pingpong *)$tmp)->cache_size = $a_cache_size;"
		end

	c_set_nread_resp (tmp: POINTER; a_nread_resp: NATURAL_32)
		external
			"C inline"
		alias
			"((struct pingpong *)$tmp)->nread_resp = $a_nread_resp;"
		end

	c_set_linestart_resp (tmp: POINTER; a_linestart_resp: POINTER)
		external
			"C inline"
		alias
			"((struct pingpong *)$tmp)->linestart_resp = (char *)$a_linestart_resp;"
		end

	c_set_pending_resp (tmp: POINTER; a_pending_resp: BOOLEAN)
		external
			"C inline"
		alias
			"((struct pingpong *)$tmp)->pending_resp = $a_pending_resp;"
		end

	c_set_sendthis (tmp: POINTER; a_sendthis: POINTER)
		external
			"C inline"
		alias
			"((struct pingpong *)$tmp)->sendthis = (char *)$a_sendthis;"
		end

	c_set_sendleft (tmp: POINTER; a_sendleft: NATURAL_32)
		external
			"C inline"
		alias
			"((struct pingpong *)$tmp)->sendleft = $a_sendleft;"
		end

	c_set_sendsize (tmp: POINTER; a_sendsize: NATURAL_32)
		external
			"C inline"
		alias
			"((struct pingpong *)$tmp)->sendsize = $a_sendsize;"
		end

	c_set_response_time (tmp: POINTER; a_response_time: INTEGER_32)
		external
			"C inline"
		alias
			"((struct pingpong *)$tmp)->response_time = $a_response_time;"
		end

	c_set_conn (tmp: POINTER; a_conn: POINTER)
		external
			"C inline"
		alias
			"((struct pingpong *)$tmp)->conn = (struct connectdata *)$a_conn;"
		end

	c_set_statemach_act (tmp: POINTER; a_statemach_act: POINTER)
		external
			"C inline"
		alias
			"((struct pingpong *)$tmp)->statemach_act = (int( *)(struct connectdata * conn))$a_statemach_act;"
		end

	c_set_endofresp (tmp: POINTER; a_endofresp: POINTER)
		external
			"C inline"
		alias
			"((struct pingpong *)$tmp)->endofresp = (int( *)(struct pingpong * pp, int * code))$a_endofresp;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct pingpong);"
		end

end
