class
	PD_POP3_CONN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	pp: PD_PINGPONG assign set_pp
		do
			create Result.make_shared (c_pp (c_pointer))
		end

	pp_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct pop3_conn, pp);"
		end

	mailbox: CE_POINTER [INTEGER_8] assign set_mailbox
		do
			create Result.make_shared (c_mailbox (c_pointer))
		end

	eob: NATURAL_32 assign set_eob
		do
			Result := c_eob (c_pointer)
		end

	state: INTEGER_32 assign set_state
		do
			Result := c_state (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_pp (a_pp: PD_PINGPONG)
		do
			pp.ce_gets (a_pp)
		end

	set_mailbox (a_mailbox: CE_POINTER [INTEGER_8])
		do
			c_set_mailbox (c_pointer, a_mailbox.c_pointer)
		end

	set_eob (a_eob: NATURAL_32)
		do
			c_set_eob (c_pointer, a_eob)
		end

	set_state (a_state: INTEGER_32)
		do
			c_set_state (c_pointer, a_state)
		end

feature {NONE} -- C getters

	c_pp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct pingpong *)&((struct pop3_conn *)$tmp)->pp;"
		end

	c_mailbox (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct pop3_conn *)$tmp)->mailbox;"
		end

	c_eob (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct pop3_conn *)$tmp)->eob;"
		end

	c_state (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct pop3_conn *)$tmp)->state;"
		end

feature {NONE} -- C setters

	c_set_mailbox (tmp: POINTER; a_mailbox: POINTER)
		external
			"C inline"
		alias
			"((struct pop3_conn *)$tmp)->mailbox = (char *)$a_mailbox;"
		end

	c_set_eob (tmp: POINTER; a_eob: NATURAL_32)
		external
			"C inline"
		alias
			"((struct pop3_conn *)$tmp)->eob = $a_eob;"
		end

	c_set_state (tmp: POINTER; a_state: INTEGER_32)
		external
			"C inline"
		alias
			"((struct pop3_conn *)$tmp)->state = $a_state;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct pop3_conn);"
		end

end
