class
	PD_PROGRESS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	lastshow: INTEGER_32 assign set_lastshow
		do
			Result := c_lastshow (c_pointer)
		end

	size_dl: INTEGER_64 assign set_size_dl
		do
			Result := c_size_dl (c_pointer)
		end

	size_ul: INTEGER_64 assign set_size_ul
		do
			Result := c_size_ul (c_pointer)
		end

	downloaded: INTEGER_64 assign set_downloaded
		do
			Result := c_downloaded (c_pointer)
		end

	uploaded: INTEGER_64 assign set_uploaded
		do
			Result := c_uploaded (c_pointer)
		end

	current_speed: INTEGER_64 assign set_current_speed
		do
			Result := c_current_speed (c_pointer)
		end

	callback: BOOLEAN assign set_callback
		do
			Result := c_callback (c_pointer)
		end

	width: INTEGER_32 assign set_width
		do
			Result := c_width (c_pointer)
		end

	flags: INTEGER_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	timespent: REAL_64 assign set_timespent
		do
			Result := c_timespent (c_pointer)
		end

	dlspeed: INTEGER_64 assign set_dlspeed
		do
			Result := c_dlspeed (c_pointer)
		end

	ulspeed: INTEGER_64 assign set_ulspeed
		do
			Result := c_ulspeed (c_pointer)
		end

	t_nslookup: REAL_64 assign set_t_nslookup
		do
			Result := c_t_nslookup (c_pointer)
		end

	t_connect: REAL_64 assign set_t_connect
		do
			Result := c_t_connect (c_pointer)
		end

	t_appconnect: REAL_64 assign set_t_appconnect
		do
			Result := c_t_appconnect (c_pointer)
		end

	t_pretransfer: REAL_64 assign set_t_pretransfer
		do
			Result := c_t_pretransfer (c_pointer)
		end

	t_starttransfer: REAL_64 assign set_t_starttransfer
		do
			Result := c_t_starttransfer (c_pointer)
		end

	t_redirect: REAL_64 assign set_t_redirect
		do
			Result := c_t_redirect (c_pointer)
		end

	start: SD_TIMEVAL assign set_start
		do
			create Result.make_shared (c_start (c_pointer))
		end

	t_startsingle: SD_TIMEVAL assign set_t_startsingle
		do
			create Result.make_shared (c_t_startsingle (c_pointer))
		end

	speeder: CE_ARRAY [INTEGER_64]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_speeder (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	speeder_time: CE_ARRAY [SD_TIMEVAL]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_speeder_time (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	speeder_c: INTEGER_32 assign set_speeder_c
		do
			Result := c_speeder_c (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_lastshow (a_lastshow: INTEGER_32)
		do
			c_set_lastshow (c_pointer, a_lastshow)
		end

	set_size_dl (a_size_dl: INTEGER_64)
		do
			c_set_size_dl (c_pointer, a_size_dl)
		end

	set_size_ul (a_size_ul: INTEGER_64)
		do
			c_set_size_ul (c_pointer, a_size_ul)
		end

	set_downloaded (a_downloaded: INTEGER_64)
		do
			c_set_downloaded (c_pointer, a_downloaded)
		end

	set_uploaded (a_uploaded: INTEGER_64)
		do
			c_set_uploaded (c_pointer, a_uploaded)
		end

	set_current_speed (a_current_speed: INTEGER_64)
		do
			c_set_current_speed (c_pointer, a_current_speed)
		end

	set_callback (a_callback: BOOLEAN)
		do
			c_set_callback (c_pointer, a_callback)
		end

	set_width (a_width: INTEGER_32)
		do
			c_set_width (c_pointer, a_width)
		end

	set_flags (a_flags: INTEGER_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

	set_timespent (a_timespent: REAL_64)
		do
			c_set_timespent (c_pointer, a_timespent)
		end

	set_dlspeed (a_dlspeed: INTEGER_64)
		do
			c_set_dlspeed (c_pointer, a_dlspeed)
		end

	set_ulspeed (a_ulspeed: INTEGER_64)
		do
			c_set_ulspeed (c_pointer, a_ulspeed)
		end

	set_t_nslookup (a_t_nslookup: REAL_64)
		do
			c_set_t_nslookup (c_pointer, a_t_nslookup)
		end

	set_t_connect (a_t_connect: REAL_64)
		do
			c_set_t_connect (c_pointer, a_t_connect)
		end

	set_t_appconnect (a_t_appconnect: REAL_64)
		do
			c_set_t_appconnect (c_pointer, a_t_appconnect)
		end

	set_t_pretransfer (a_t_pretransfer: REAL_64)
		do
			c_set_t_pretransfer (c_pointer, a_t_pretransfer)
		end

	set_t_starttransfer (a_t_starttransfer: REAL_64)
		do
			c_set_t_starttransfer (c_pointer, a_t_starttransfer)
		end

	set_t_redirect (a_t_redirect: REAL_64)
		do
			c_set_t_redirect (c_pointer, a_t_redirect)
		end

	set_start (a_start: SD_TIMEVAL)
		do
			start.ce_gets (a_start)
		end

	set_t_startsingle (a_t_startsingle: SD_TIMEVAL)
		do
			t_startsingle.ce_gets (a_t_startsingle)
		end

	set_speeder_c (a_speeder_c: INTEGER_32)
		do
			c_set_speeder_c (c_pointer, a_speeder_c)
		end

feature {NONE} -- C getters

	c_lastshow (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct Progress *)$tmp)->lastshow;"
		end

	c_size_dl (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct Progress *)$tmp)->size_dl;"
		end

	c_size_ul (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct Progress *)$tmp)->size_ul;"
		end

	c_downloaded (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct Progress *)$tmp)->downloaded;"
		end

	c_uploaded (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct Progress *)$tmp)->uploaded;"
		end

	c_current_speed (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct Progress *)$tmp)->current_speed;"
		end

	c_callback (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct Progress *)$tmp)->callback;"
		end

	c_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Progress *)$tmp)->width;"
		end

	c_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Progress *)$tmp)->flags;"
		end

	c_timespent (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct Progress *)$tmp)->timespent;"
		end

	c_dlspeed (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct Progress *)$tmp)->dlspeed;"
		end

	c_ulspeed (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct Progress *)$tmp)->ulspeed;"
		end

	c_t_nslookup (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct Progress *)$tmp)->t_nslookup;"
		end

	c_t_connect (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct Progress *)$tmp)->t_connect;"
		end

	c_t_appconnect (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct Progress *)$tmp)->t_appconnect;"
		end

	c_t_pretransfer (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct Progress *)$tmp)->t_pretransfer;"
		end

	c_t_starttransfer (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct Progress *)$tmp)->t_starttransfer;"
		end

	c_t_redirect (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct Progress *)$tmp)->t_redirect;"
		end

	c_start (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct timeval *)&((struct Progress *)$tmp)->start;"
		end

	c_t_startsingle (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct timeval *)&((struct Progress *)$tmp)->t_startsingle;"
		end

	c_speeder (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct Progress *tmp = (struct Progress *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->speeder) / sizeof(tmp->speeder[0]);
				return tmp->speeder;
			]"
		end

	c_speeder_time (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct Progress *tmp = (struct Progress *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->speeder_time) / sizeof(tmp->speeder_time[0]);
				return tmp->speeder_time;
			]"
		end

	c_speeder_c (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Progress *)$tmp)->speeder_c;"
		end

feature {NONE} -- C setters

	c_set_lastshow (tmp: POINTER; a_lastshow: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Progress *)$tmp)->lastshow = $a_lastshow;"
		end

	c_set_size_dl (tmp: POINTER; a_size_dl: INTEGER_64)
		external
			"C inline"
		alias
			"((struct Progress *)$tmp)->size_dl = $a_size_dl;"
		end

	c_set_size_ul (tmp: POINTER; a_size_ul: INTEGER_64)
		external
			"C inline"
		alias
			"((struct Progress *)$tmp)->size_ul = $a_size_ul;"
		end

	c_set_downloaded (tmp: POINTER; a_downloaded: INTEGER_64)
		external
			"C inline"
		alias
			"((struct Progress *)$tmp)->downloaded = $a_downloaded;"
		end

	c_set_uploaded (tmp: POINTER; a_uploaded: INTEGER_64)
		external
			"C inline"
		alias
			"((struct Progress *)$tmp)->uploaded = $a_uploaded;"
		end

	c_set_current_speed (tmp: POINTER; a_current_speed: INTEGER_64)
		external
			"C inline"
		alias
			"((struct Progress *)$tmp)->current_speed = $a_current_speed;"
		end

	c_set_callback (tmp: POINTER; a_callback: BOOLEAN)
		external
			"C inline"
		alias
			"((struct Progress *)$tmp)->callback = $a_callback;"
		end

	c_set_width (tmp: POINTER; a_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Progress *)$tmp)->width = $a_width;"
		end

	c_set_flags (tmp: POINTER; a_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Progress *)$tmp)->flags = $a_flags;"
		end

	c_set_timespent (tmp: POINTER; a_timespent: REAL_64)
		external
			"C inline"
		alias
			"((struct Progress *)$tmp)->timespent = $a_timespent;"
		end

	c_set_dlspeed (tmp: POINTER; a_dlspeed: INTEGER_64)
		external
			"C inline"
		alias
			"((struct Progress *)$tmp)->dlspeed = $a_dlspeed;"
		end

	c_set_ulspeed (tmp: POINTER; a_ulspeed: INTEGER_64)
		external
			"C inline"
		alias
			"((struct Progress *)$tmp)->ulspeed = $a_ulspeed;"
		end

	c_set_t_nslookup (tmp: POINTER; a_t_nslookup: REAL_64)
		external
			"C inline"
		alias
			"((struct Progress *)$tmp)->t_nslookup = $a_t_nslookup;"
		end

	c_set_t_connect (tmp: POINTER; a_t_connect: REAL_64)
		external
			"C inline"
		alias
			"((struct Progress *)$tmp)->t_connect = $a_t_connect;"
		end

	c_set_t_appconnect (tmp: POINTER; a_t_appconnect: REAL_64)
		external
			"C inline"
		alias
			"((struct Progress *)$tmp)->t_appconnect = $a_t_appconnect;"
		end

	c_set_t_pretransfer (tmp: POINTER; a_t_pretransfer: REAL_64)
		external
			"C inline"
		alias
			"((struct Progress *)$tmp)->t_pretransfer = $a_t_pretransfer;"
		end

	c_set_t_starttransfer (tmp: POINTER; a_t_starttransfer: REAL_64)
		external
			"C inline"
		alias
			"((struct Progress *)$tmp)->t_starttransfer = $a_t_starttransfer;"
		end

	c_set_t_redirect (tmp: POINTER; a_t_redirect: REAL_64)
		external
			"C inline"
		alias
			"((struct Progress *)$tmp)->t_redirect = $a_t_redirect;"
		end

	c_set_speeder_c (tmp: POINTER; a_speeder_c: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Progress *)$tmp)->speeder_c = $a_speeder_c;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct Progress);"
		end

end
