class
	PD_PROTO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ftpc: PD_FTP_CONN assign set_ftpc
		do
			create Result.make_shared (c_ftpc (c_pointer))
		end

	ftpc_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(union __anonunion_proto_96, ftpc);"
		end

	sshc: PD_SSH_CONN assign set_sshc
		do
			create Result.make_shared (c_sshc (c_pointer))
		end

	tftpc: CE_POINTER [PD_TFTP_STATE_DATA] assign set_tftpc
		do
			create Result.make_shared (c_tftpc (c_pointer))
		end

	imapc: PD_IMAP_CONN assign set_imapc
		do
			create Result.make_shared (c_imapc (c_pointer))
		end

	imapc_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(union __anonunion_proto_96, imapc);"
		end

	pop3c: PD_POP3_CONN assign set_pop3c
		do
			create Result.make_shared (c_pop3c (c_pointer))
		end

	pop3c_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(union __anonunion_proto_96, pop3c);"
		end

	smtpc: PD_SMTP_CONN assign set_smtpc
		do
			create Result.make_shared (c_smtpc (c_pointer))
		end

	smtpc_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(union __anonunion_proto_96, smtpc);"
		end

	rtspc: PD_RTSP_CONN assign set_rtspc
		do
			create Result.make_shared (c_rtspc (c_pointer))
		end

	rtspc_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(union __anonunion_proto_96, rtspc);"
		end

	generic: CE_POINTER [ANY] assign set_generic
		do
			create Result.make_shared (c_generic (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_ftpc (a_ftpc: PD_FTP_CONN)
		do
			ftpc.ce_gets (a_ftpc)
		end

	set_sshc (a_sshc: PD_SSH_CONN)
		do
			sshc.ce_gets (a_sshc)
		end

	set_tftpc (a_tftpc: CE_POINTER [PD_TFTP_STATE_DATA])
		do
			c_set_tftpc (c_pointer, a_tftpc.c_pointer)
		end

	set_imapc (a_imapc: PD_IMAP_CONN)
		do
			imapc.ce_gets (a_imapc)
		end

	set_pop3c (a_pop3c: PD_POP3_CONN)
		do
			pop3c.ce_gets (a_pop3c)
		end

	set_smtpc (a_smtpc: PD_SMTP_CONN)
		do
			smtpc.ce_gets (a_smtpc)
		end

	set_rtspc (a_rtspc: PD_RTSP_CONN)
		do
			rtspc.ce_gets (a_rtspc)
		end

	set_generic (a_generic: CE_POINTER [ANY])
		do
			c_set_generic (c_pointer, a_generic.c_pointer)
		end

feature {NONE} -- C getters

	c_ftpc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct ftp_conn *)&((union __anonunion_proto_96 *)$tmp)->ftpc;"
		end

	c_sshc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct ssh_conn *)&((union __anonunion_proto_96 *)$tmp)->sshc;"
		end

	c_tftpc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct tftp_state_data *)((union __anonunion_proto_96 *)$tmp)->tftpc;"
		end

	c_imapc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct imap_conn *)&((union __anonunion_proto_96 *)$tmp)->imapc;"
		end

	c_pop3c (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct pop3_conn *)&((union __anonunion_proto_96 *)$tmp)->pop3c;"
		end

	c_smtpc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct smtp_conn *)&((union __anonunion_proto_96 *)$tmp)->smtpc;"
		end

	c_rtspc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct rtsp_conn *)&((union __anonunion_proto_96 *)$tmp)->rtspc;"
		end

	c_generic (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((union __anonunion_proto_96 *)$tmp)->generic;"
		end

feature {NONE} -- C setters

	c_set_tftpc (tmp: POINTER; a_tftpc: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_proto_96 *)$tmp)->tftpc = (struct tftp_state_data *)$a_tftpc;"
		end

	c_set_generic (tmp: POINTER; a_generic: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_proto_96 *)$tmp)->generic = (void *)$a_generic;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(union __anonunion_proto_96);"
		end

end
