class
	PD_PROTO2

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	http: CE_POINTER [PD_HTTP] assign set_http
		do
			create Result.make_shared (c_http (c_pointer))
		end

	https: CE_POINTER [PD_HTTP] assign set_https
		do
			create Result.make_shared (c_https (c_pointer))
		end

	rtsp: CE_POINTER [PD_RTSP] assign set_rtsp
		do
			create Result.make_shared (c_rtsp (c_pointer))
		end

	ftp: CE_POINTER [PD_FTP] assign set_ftp
		do
			create Result.make_shared (c_ftp (c_pointer))
		end

	file: CE_POINTER [PD_FILEPROTO] assign set_file
		do
			create Result.make_shared (c_file (c_pointer))
		end

	telnet: CE_POINTER [ANY] assign set_telnet
		do
			create Result.make_shared (c_telnet (c_pointer))
		end

	generic: CE_POINTER [ANY] assign set_generic
		do
			create Result.make_shared (c_generic (c_pointer))
		end

	ssh: CE_POINTER [PD_SSHPROTO] assign set_ssh
		do
			create Result.make_shared (c_ssh (c_pointer))
		end

	imap: CE_POINTER [PD_FTP] assign set_imap
		do
			create Result.make_shared (c_imap (c_pointer))
		end

	pop3: CE_POINTER [PD_FTP] assign set_pop3
		do
			create Result.make_shared (c_pop3 (c_pointer))
		end

	smtp: CE_POINTER [PD_FTP] assign set_smtp
		do
			create Result.make_shared (c_smtp (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_http (a_http: CE_POINTER [PD_HTTP])
		do
			c_set_http (c_pointer, a_http.c_pointer)
		end

	set_https (a_https: CE_POINTER [PD_HTTP])
		do
			c_set_https (c_pointer, a_https.c_pointer)
		end

	set_rtsp (a_rtsp: CE_POINTER [PD_RTSP])
		do
			c_set_rtsp (c_pointer, a_rtsp.c_pointer)
		end

	set_ftp (a_ftp: CE_POINTER [PD_FTP])
		do
			c_set_ftp (c_pointer, a_ftp.c_pointer)
		end

	set_file (a_file: CE_POINTER [PD_FILEPROTO])
		do
			c_set_file (c_pointer, a_file.c_pointer)
		end

	set_telnet (a_telnet: CE_POINTER [ANY])
		do
			c_set_telnet (c_pointer, a_telnet.c_pointer)
		end

	set_generic (a_generic: CE_POINTER [ANY])
		do
			c_set_generic (c_pointer, a_generic.c_pointer)
		end

	set_ssh (a_ssh: CE_POINTER [PD_SSHPROTO])
		do
			c_set_ssh (c_pointer, a_ssh.c_pointer)
		end

	set_imap (a_imap: CE_POINTER [PD_FTP])
		do
			c_set_imap (c_pointer, a_imap.c_pointer)
		end

	set_pop3 (a_pop3: CE_POINTER [PD_FTP])
		do
			c_set_pop3 (c_pointer, a_pop3.c_pointer)
		end

	set_smtp (a_smtp: CE_POINTER [PD_FTP])
		do
			c_set_smtp (c_pointer, a_smtp.c_pointer)
		end

feature {NONE} -- C getters

	c_http (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct HTTP *)((union __anonunion_proto_101 *)$tmp)->http;"
		end

	c_https (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct HTTP *)((union __anonunion_proto_101 *)$tmp)->https;"
		end

	c_rtsp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct RTSP *)((union __anonunion_proto_101 *)$tmp)->rtsp;"
		end

	c_ftp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct FTP *)((union __anonunion_proto_101 *)$tmp)->ftp;"
		end

	c_file (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct FILEPROTO *)((union __anonunion_proto_101 *)$tmp)->file;"
		end

	c_telnet (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((union __anonunion_proto_101 *)$tmp)->telnet;"
		end

	c_generic (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((union __anonunion_proto_101 *)$tmp)->generic;"
		end

	c_ssh (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct SSHPROTO *)((union __anonunion_proto_101 *)$tmp)->ssh;"
		end

	c_imap (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct FTP *)((union __anonunion_proto_101 *)$tmp)->imap;"
		end

	c_pop3 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct FTP *)((union __anonunion_proto_101 *)$tmp)->pop3;"
		end

	c_smtp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct FTP *)((union __anonunion_proto_101 *)$tmp)->smtp;"
		end

feature {NONE} -- C setters

	c_set_http (tmp: POINTER; a_http: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_proto_101 *)$tmp)->http = (struct HTTP *)$a_http;"
		end

	c_set_https (tmp: POINTER; a_https: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_proto_101 *)$tmp)->https = (struct HTTP *)$a_https;"
		end

	c_set_rtsp (tmp: POINTER; a_rtsp: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_proto_101 *)$tmp)->rtsp = (struct RTSP *)$a_rtsp;"
		end

	c_set_ftp (tmp: POINTER; a_ftp: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_proto_101 *)$tmp)->ftp = (struct FTP *)$a_ftp;"
		end

	c_set_file (tmp: POINTER; a_file: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_proto_101 *)$tmp)->file = (struct FILEPROTO *)$a_file;"
		end

	c_set_telnet (tmp: POINTER; a_telnet: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_proto_101 *)$tmp)->telnet = (void *)$a_telnet;"
		end

	c_set_generic (tmp: POINTER; a_generic: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_proto_101 *)$tmp)->generic = (void *)$a_generic;"
		end

	c_set_ssh (tmp: POINTER; a_ssh: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_proto_101 *)$tmp)->ssh = (struct SSHPROTO *)$a_ssh;"
		end

	c_set_imap (tmp: POINTER; a_imap: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_proto_101 *)$tmp)->imap = (struct FTP *)$a_imap;"
		end

	c_set_pop3 (tmp: POINTER; a_pop3: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_proto_101 *)$tmp)->pop3 = (struct FTP *)$a_pop3;"
		end

	c_set_smtp (tmp: POINTER; a_smtp: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_proto_101 *)$tmp)->smtp = (struct FTP *)$a_smtp;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(union __anonunion_proto_101);"
		end

end
