class
	PD_PUREINFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	httpcode: INTEGER_32 assign set_httpcode
		do
			Result := c_httpcode (c_pointer)
		end

	httpproxycode: INTEGER_32 assign set_httpproxycode
		do
			Result := c_httpproxycode (c_pointer)
		end

	httpversion: INTEGER_32 assign set_httpversion
		do
			Result := c_httpversion (c_pointer)
		end

	filetime: INTEGER_32 assign set_filetime
		do
			Result := c_filetime (c_pointer)
		end

	timecond: BOOLEAN assign set_timecond
		do
			Result := c_timecond (c_pointer)
		end

	header_size: INTEGER_32 assign set_header_size
		do
			Result := c_header_size (c_pointer)
		end

	request_size: INTEGER_32 assign set_request_size
		do
			Result := c_request_size (c_pointer)
		end

	request_size_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct PureInfo, request_size);"
		end

	proxyauthavail: INTEGER_32 assign set_proxyauthavail
		do
			Result := c_proxyauthavail (c_pointer)
		end

	proxyauthavail_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct PureInfo, proxyauthavail);"
		end

	httpauthavail: INTEGER_32 assign set_httpauthavail
		do
			Result := c_httpauthavail (c_pointer)
		end

	httpauthavail_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct PureInfo, httpauthavail);"
		end

	numconnects: INTEGER_32 assign set_numconnects
		do
			Result := c_numconnects (c_pointer)
		end

	contenttype: CE_POINTER [INTEGER_8] assign set_contenttype
		do
			create Result.make_shared (c_contenttype (c_pointer))
		end

	wouldredirect: CE_POINTER [INTEGER_8] assign set_wouldredirect
		do
			create Result.make_shared (c_wouldredirect (c_pointer))
		end

	ip: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_ip (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	port: INTEGER_32 assign set_port
		do
			Result := c_port (c_pointer)
		end

	port_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct PureInfo, port);"
		end

	localip: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_localip (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	localport: INTEGER_32 assign set_localport
		do
			Result := c_localport (c_pointer)
		end

	localport_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct PureInfo, localport);"
		end

	certs: PD_CURL_CERTINFO assign set_certs
		do
			create Result.make_shared (c_certs (c_pointer))
		end

	certs_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct PureInfo, certs);"
		end

feature {ANY} -- Eiffel setters

	set_httpcode (a_httpcode: INTEGER_32)
		do
			c_set_httpcode (c_pointer, a_httpcode)
		end

	set_httpproxycode (a_httpproxycode: INTEGER_32)
		do
			c_set_httpproxycode (c_pointer, a_httpproxycode)
		end

	set_httpversion (a_httpversion: INTEGER_32)
		do
			c_set_httpversion (c_pointer, a_httpversion)
		end

	set_filetime (a_filetime: INTEGER_32)
		do
			c_set_filetime (c_pointer, a_filetime)
		end

	set_timecond (a_timecond: BOOLEAN)
		do
			c_set_timecond (c_pointer, a_timecond)
		end

	set_header_size (a_header_size: INTEGER_32)
		do
			c_set_header_size (c_pointer, a_header_size)
		end

	set_request_size (a_request_size: INTEGER_32)
		do
			c_set_request_size (c_pointer, a_request_size)
		end

	set_proxyauthavail (a_proxyauthavail: INTEGER_32)
		do
			c_set_proxyauthavail (c_pointer, a_proxyauthavail)
		end

	set_httpauthavail (a_httpauthavail: INTEGER_32)
		do
			c_set_httpauthavail (c_pointer, a_httpauthavail)
		end

	set_numconnects (a_numconnects: INTEGER_32)
		do
			c_set_numconnects (c_pointer, a_numconnects)
		end

	set_contenttype (a_contenttype: CE_POINTER [INTEGER_8])
		do
			c_set_contenttype (c_pointer, a_contenttype.c_pointer)
		end

	set_wouldredirect (a_wouldredirect: CE_POINTER [INTEGER_8])
		do
			c_set_wouldredirect (c_pointer, a_wouldredirect.c_pointer)
		end

	set_port (a_port: INTEGER_32)
		do
			c_set_port (c_pointer, a_port)
		end

	set_localport (a_localport: INTEGER_32)
		do
			c_set_localport (c_pointer, a_localport)
		end

	set_certs (a_certs: PD_CURL_CERTINFO)
		do
			certs.ce_gets (a_certs)
		end

feature {NONE} -- C getters

	c_httpcode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct PureInfo *)$tmp)->httpcode;"
		end

	c_httpproxycode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct PureInfo *)$tmp)->httpproxycode;"
		end

	c_httpversion (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct PureInfo *)$tmp)->httpversion;"
		end

	c_filetime (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct PureInfo *)$tmp)->filetime;"
		end

	c_timecond (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct PureInfo *)$tmp)->timecond;"
		end

	c_header_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct PureInfo *)$tmp)->header_size;"
		end

	c_request_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct PureInfo *)$tmp)->request_size;"
		end

	c_proxyauthavail (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct PureInfo *)$tmp)->proxyauthavail;"
		end

	c_httpauthavail (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct PureInfo *)$tmp)->httpauthavail;"
		end

	c_numconnects (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct PureInfo *)$tmp)->numconnects;"
		end

	c_contenttype (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct PureInfo *)$tmp)->contenttype;"
		end

	c_wouldredirect (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct PureInfo *)$tmp)->wouldredirect;"
		end

	c_ip (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct PureInfo *tmp = (struct PureInfo *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->ip) / sizeof(tmp->ip[0]);
				return tmp->ip;
			]"
		end

	c_port (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct PureInfo *)$tmp)->port;"
		end

	c_localip (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct PureInfo *tmp = (struct PureInfo *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->localip) / sizeof(tmp->localip[0]);
				return tmp->localip;
			]"
		end

	c_localport (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct PureInfo *)$tmp)->localport;"
		end

	c_certs (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_certinfo *)&((struct PureInfo *)$tmp)->certs;"
		end

feature {NONE} -- C setters

	c_set_httpcode (tmp: POINTER; a_httpcode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct PureInfo *)$tmp)->httpcode = $a_httpcode;"
		end

	c_set_httpproxycode (tmp: POINTER; a_httpproxycode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct PureInfo *)$tmp)->httpproxycode = $a_httpproxycode;"
		end

	c_set_httpversion (tmp: POINTER; a_httpversion: INTEGER_32)
		external
			"C inline"
		alias
			"((struct PureInfo *)$tmp)->httpversion = $a_httpversion;"
		end

	c_set_filetime (tmp: POINTER; a_filetime: INTEGER_32)
		external
			"C inline"
		alias
			"((struct PureInfo *)$tmp)->filetime = $a_filetime;"
		end

	c_set_timecond (tmp: POINTER; a_timecond: BOOLEAN)
		external
			"C inline"
		alias
			"((struct PureInfo *)$tmp)->timecond = $a_timecond;"
		end

	c_set_header_size (tmp: POINTER; a_header_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct PureInfo *)$tmp)->header_size = $a_header_size;"
		end

	c_set_request_size (tmp: POINTER; a_request_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct PureInfo *)$tmp)->request_size = $a_request_size;"
		end

	c_set_proxyauthavail (tmp: POINTER; a_proxyauthavail: INTEGER_32)
		external
			"C inline"
		alias
			"((struct PureInfo *)$tmp)->proxyauthavail = $a_proxyauthavail;"
		end

	c_set_httpauthavail (tmp: POINTER; a_httpauthavail: INTEGER_32)
		external
			"C inline"
		alias
			"((struct PureInfo *)$tmp)->httpauthavail = $a_httpauthavail;"
		end

	c_set_numconnects (tmp: POINTER; a_numconnects: INTEGER_32)
		external
			"C inline"
		alias
			"((struct PureInfo *)$tmp)->numconnects = $a_numconnects;"
		end

	c_set_contenttype (tmp: POINTER; a_contenttype: POINTER)
		external
			"C inline"
		alias
			"((struct PureInfo *)$tmp)->contenttype = (char *)$a_contenttype;"
		end

	c_set_wouldredirect (tmp: POINTER; a_wouldredirect: POINTER)
		external
			"C inline"
		alias
			"((struct PureInfo *)$tmp)->wouldredirect = (char *)$a_wouldredirect;"
		end

	c_set_port (tmp: POINTER; a_port: INTEGER_32)
		external
			"C inline"
		alias
			"((struct PureInfo *)$tmp)->port = $a_port;"
		end

	c_set_localport (tmp: POINTER; a_localport: INTEGER_32)
		external
			"C inline"
		alias
			"((struct PureInfo *)$tmp)->localport = $a_localport;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct PureInfo);"
		end

end
