class
	PD_RTSP

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	http_wrapper: PD_HTTP assign set_http_wrapper
		do
			create Result.make_shared (c_http_wrapper (c_pointer))
		end

	http_wrapper_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct RTSP, http_wrapper);"
		end

	CSeq_sent: INTEGER_32 assign set_CSeq_sent
		do
			Result := c_CSeq_sent (c_pointer)
		end

	CSeq_recv: INTEGER_32 assign set_CSeq_recv
		do
			Result := c_CSeq_recv (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_http_wrapper (a_http_wrapper: PD_HTTP)
		do
			http_wrapper.ce_gets (a_http_wrapper)
		end

	set_CSeq_sent (a_CSeq_sent: INTEGER_32)
		do
			c_set_CSeq_sent (c_pointer, a_CSeq_sent)
		end

	set_CSeq_recv (a_CSeq_recv: INTEGER_32)
		do
			c_set_CSeq_recv (c_pointer, a_CSeq_recv)
		end

feature {NONE} -- C getters

	c_http_wrapper (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct HTTP *)&((struct RTSP *)$tmp)->http_wrapper;"
		end

	c_CSeq_sent (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct RTSP *)$tmp)->CSeq_sent;"
		end

	c_CSeq_recv (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct RTSP *)$tmp)->CSeq_recv;"
		end

feature {NONE} -- C setters

	c_set_CSeq_sent (tmp: POINTER; a_CSeq_sent: INTEGER_32)
		external
			"C inline"
		alias
			"((struct RTSP *)$tmp)->CSeq_sent = $a_cseq_sent;"
		end

	c_set_CSeq_recv (tmp: POINTER; a_CSeq_recv: INTEGER_32)
		external
			"C inline"
		alias
			"((struct RTSP *)$tmp)->CSeq_recv = $a_cseq_recv;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct RTSP);"
		end

end
