class
	PD_RTSP_CONN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	rtp_buf: CE_POINTER [INTEGER_8] assign set_rtp_buf
		do
			create Result.make_shared (c_rtp_buf (c_pointer))
		end

	rtp_bufsize: INTEGER_32 assign set_rtp_bufsize
		do
			Result := c_rtp_bufsize (c_pointer)
		end

	rtp_channel: INTEGER_32 assign set_rtp_channel
		do
			Result := c_rtp_channel (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_rtp_buf (a_rtp_buf: CE_POINTER [INTEGER_8])
		do
			c_set_rtp_buf (c_pointer, a_rtp_buf.c_pointer)
		end

	set_rtp_bufsize (a_rtp_bufsize: INTEGER_32)
		do
			c_set_rtp_bufsize (c_pointer, a_rtp_bufsize)
		end

	set_rtp_channel (a_rtp_channel: INTEGER_32)
		do
			c_set_rtp_channel (c_pointer, a_rtp_channel)
		end

feature {NONE} -- C getters

	c_rtp_buf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct rtsp_conn *)$tmp)->rtp_buf;"
		end

	c_rtp_bufsize (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct rtsp_conn *)$tmp)->rtp_bufsize;"
		end

	c_rtp_channel (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct rtsp_conn *)$tmp)->rtp_channel;"
		end

feature {NONE} -- C setters

	c_set_rtp_buf (tmp: POINTER; a_rtp_buf: POINTER)
		external
			"C inline"
		alias
			"((struct rtsp_conn *)$tmp)->rtp_buf = (char *)$a_rtp_buf;"
		end

	c_set_rtp_bufsize (tmp: POINTER; a_rtp_bufsize: INTEGER_32)
		external
			"C inline"
		alias
			"((struct rtsp_conn *)$tmp)->rtp_bufsize = $a_rtp_bufsize;"
		end

	c_set_rtp_channel (tmp: POINTER; a_rtp_channel: INTEGER_32)
		external
			"C inline"
		alias
			"((struct rtsp_conn *)$tmp)->rtp_channel = $a_rtp_channel;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct rtsp_conn);"
		end

end
