class
	PD_SESSIONHANDLE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	dns: PD_NAMES assign set_dns
		do
			create Result.make_shared (c_dns (c_pointer))
		end

	multi: CE_POINTER [PD_CURL_MULTI] assign set_multi
		do
			create Result.make_shared (c_multi (c_pointer))
		end

	multi_pos: CE_POINTER [PD_CURL_ONE_EASY] assign set_multi_pos
		do
			create Result.make_shared (c_multi_pos (c_pointer))
		end

	share: CE_POINTER [PD_CURL_SHARE] assign set_share
		do
			create Result.make_shared (c_share (c_pointer))
		end

	req: PD_SINGLEREQUEST assign set_req
		do
			create Result.make_shared (c_req (c_pointer))
		end

	req_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct SessionHandle, req);"
		end

	set: PD_USERDEFINED assign set_set
		do
			create Result.make_shared (c_set (c_pointer))
		end

	set_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct SessionHandle, set);"
		end

	change: PD_DYNAMICSTATIC assign set_change
		do
			create Result.make_shared (c_change (c_pointer))
		end

	cookies: CE_POINTER [PD_COOKIEINFO] assign set_cookies
		do
			create Result.make_shared (c_cookies (c_pointer))
		end

	progress: PD_PROGRESS assign set_progress
		do
			create Result.make_shared (c_progress (c_pointer))
		end

	progress_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct SessionHandle, progress);"
		end

	state: PD_URLSTATE assign set_state
		do
			create Result.make_shared (c_state (c_pointer))
		end

	state_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct SessionHandle, state);"
		end

	wildcard: PD_WILDCARDDATA assign set_wildcard
		do
			create Result.make_shared (c_wildcard (c_pointer))
		end

	wildcard_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct SessionHandle, wildcard);"
		end

	info: PD_PUREINFO assign set_info
		do
			create Result.make_shared (c_info (c_pointer))
		end

	info_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct SessionHandle, info);"
		end

	magic: NATURAL_32 assign set_magic
		do
			Result := c_magic (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_dns (a_dns: PD_NAMES)
		do
			dns.ce_gets (a_dns)
		end

	set_multi (a_multi: CE_POINTER [PD_CURL_MULTI])
		do
			c_set_multi (c_pointer, a_multi.c_pointer)
		end

	set_multi_pos (a_multi_pos: CE_POINTER [PD_CURL_ONE_EASY])
		do
			c_set_multi_pos (c_pointer, a_multi_pos.c_pointer)
		end

	set_share (a_share: CE_POINTER [PD_CURL_SHARE])
		do
			c_set_share (c_pointer, a_share.c_pointer)
		end

	set_req (a_req: PD_SINGLEREQUEST)
		do
			req.ce_gets (a_req)
		end

	set_set (a_set: PD_USERDEFINED)
		do
			set.ce_gets (a_set)
		end

	set_change (a_change: PD_DYNAMICSTATIC)
		do
			change.ce_gets (a_change)
		end

	set_cookies (a_cookies: CE_POINTER [PD_COOKIEINFO])
		do
			c_set_cookies (c_pointer, a_cookies.c_pointer)
		end

	set_progress (a_progress: PD_PROGRESS)
		do
			progress.ce_gets (a_progress)
		end

	set_state (a_state: PD_URLSTATE)
		do
			state.ce_gets (a_state)
		end

	set_wildcard (a_wildcard: PD_WILDCARDDATA)
		do
			wildcard.ce_gets (a_wildcard)
		end

	set_info (a_info: PD_PUREINFO)
		do
			info.ce_gets (a_info)
		end

	set_magic (a_magic: NATURAL_32)
		do
			c_set_magic (c_pointer, a_magic)
		end

feature {NONE} -- C getters

	c_dns (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Names *)&((struct SessionHandle *)$tmp)->dns;"
		end

	c_multi (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Curl_multi *)((struct SessionHandle *)$tmp)->multi;"
		end

	c_multi_pos (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Curl_one_easy *)((struct SessionHandle *)$tmp)->multi_pos;"
		end

	c_share (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Curl_share *)((struct SessionHandle *)$tmp)->share;"
		end

	c_req (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct SingleRequest *)&((struct SessionHandle *)$tmp)->req;"
		end

	c_set (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct UserDefined *)&((struct SessionHandle *)$tmp)->set;"
		end

	c_change (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct DynamicStatic *)&((struct SessionHandle *)$tmp)->change;"
		end

	c_cookies (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct CookieInfo *)((struct SessionHandle *)$tmp)->cookies;"
		end

	c_progress (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Progress *)&((struct SessionHandle *)$tmp)->progress;"
		end

	c_state (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct UrlState *)&((struct SessionHandle *)$tmp)->state;"
		end

	c_wildcard (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct WildcardData *)&((struct SessionHandle *)$tmp)->wildcard;"
		end

	c_info (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct PureInfo *)&((struct SessionHandle *)$tmp)->info;"
		end

	c_magic (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct SessionHandle *)$tmp)->magic;"
		end

feature {NONE} -- C setters

	c_set_multi (tmp: POINTER; a_multi: POINTER)
		external
			"C inline"
		alias
			"((struct SessionHandle *)$tmp)->multi = (struct Curl_multi *)$a_multi;"
		end

	c_set_multi_pos (tmp: POINTER; a_multi_pos: POINTER)
		external
			"C inline"
		alias
			"((struct SessionHandle *)$tmp)->multi_pos = (struct Curl_one_easy *)$a_multi_pos;"
		end

	c_set_share (tmp: POINTER; a_share: POINTER)
		external
			"C inline"
		alias
			"((struct SessionHandle *)$tmp)->share = (struct Curl_share *)$a_share;"
		end

	c_set_cookies (tmp: POINTER; a_cookies: POINTER)
		external
			"C inline"
		alias
			"((struct SessionHandle *)$tmp)->cookies = (struct CookieInfo *)$a_cookies;"
		end

	c_set_magic (tmp: POINTER; a_magic: NATURAL_32)
		external
			"C inline"
		alias
			"((struct SessionHandle *)$tmp)->magic = $a_magic;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct SessionHandle);"
		end

end
