class
	PD_SINGLEREQUEST

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	size: INTEGER_64 assign set_size
		do
			Result := c_size (c_pointer)
		end

	bytecountp: CE_POINTER [INTEGER_64] assign set_bytecountp
		do
			create Result.make_shared (c_bytecountp (c_pointer))
		end

	maxdownload: INTEGER_64 assign set_maxdownload
		do
			Result := c_maxdownload (c_pointer)
		end

	writebytecountp: CE_POINTER [INTEGER_64] assign set_writebytecountp
		do
			create Result.make_shared (c_writebytecountp (c_pointer))
		end

	bytecount: INTEGER_64 assign set_bytecount
		do
			Result := c_bytecount (c_pointer)
		end

	bytecount_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct SingleRequest, bytecount);"
		end

	writebytecount: INTEGER_64 assign set_writebytecount
		do
			Result := c_writebytecount (c_pointer)
		end

	headerbytecount: INTEGER_32 assign set_headerbytecount
		do
			Result := c_headerbytecount (c_pointer)
		end

	deductheadercount: INTEGER_32 assign set_deductheadercount
		do
			Result := c_deductheadercount (c_pointer)
		end

	start: SD_TIMEVAL assign set_start
		do
			create Result.make_shared (c_start (c_pointer))
		end

	now: SD_TIMEVAL assign set_now
		do
			create Result.make_shared (c_now (c_pointer))
		end

	now_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct SingleRequest, now);"
		end

	header: BOOLEAN assign set_header
		do
			Result := c_header (c_pointer)
		end

	badheader: INTEGER_32 assign set_badheader
		do
			Result := c_badheader (c_pointer)
		end

	headerline: INTEGER_32 assign set_headerline
		do
			Result := c_headerline (c_pointer)
		end

	hbufp: CE_POINTER [INTEGER_8] assign set_hbufp
		do
			create Result.make_shared (c_hbufp (c_pointer))
		end

	hbuflen: NATURAL_32 assign set_hbuflen
		do
			Result := c_hbuflen (c_pointer)
		end

	str: CE_POINTER [INTEGER_8] assign set_str
		do
			create Result.make_shared (c_str (c_pointer))
		end

	str_start: CE_POINTER [INTEGER_8] assign set_str_start
		do
			create Result.make_shared (c_str_start (c_pointer))
		end

	end_ptr: CE_POINTER [INTEGER_8] assign set_end_ptr
		do
			create Result.make_shared (c_end_ptr (c_pointer))
		end

	p: CE_POINTER [INTEGER_8] assign set_p
		do
			create Result.make_shared (c_p (c_pointer))
		end

	content_range: BOOLEAN assign set_content_range
		do
			Result := c_content_range (c_pointer)
		end

	offset: INTEGER_64 assign set_offset
		do
			Result := c_offset (c_pointer)
		end

	httpcode: INTEGER_32 assign set_httpcode
		do
			Result := c_httpcode (c_pointer)
		end

	httpcode_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct SingleRequest, httpcode);"
		end

	start100: SD_TIMEVAL assign set_start100
		do
			create Result.make_shared (c_start100 (c_pointer))
		end

	exp100: INTEGER_32 assign set_exp100
		do
			Result := c_exp100 (c_pointer)
		end

	content_encoding: INTEGER_32 assign set_content_encoding
		do
			Result := c_content_encoding (c_pointer)
		end

	timeofdoc: INTEGER_32 assign set_timeofdoc
		do
			Result := c_timeofdoc (c_pointer)
		end

	bodywrites: INTEGER_32 assign set_bodywrites
		do
			Result := c_bodywrites (c_pointer)
		end

	buf: CE_POINTER [INTEGER_8] assign set_buf
		do
			create Result.make_shared (c_buf (c_pointer))
		end

	uploadbuf: CE_POINTER [INTEGER_8] assign set_uploadbuf
		do
			create Result.make_shared (c_uploadbuf (c_pointer))
		end

	maxfd: INTEGER_32 assign set_maxfd
		do
			Result := c_maxfd (c_pointer)
		end

	keepon: INTEGER_32 assign set_keepon
		do
			Result := c_keepon (c_pointer)
		end

	upload_done: BOOLEAN assign set_upload_done
		do
			Result := c_upload_done (c_pointer)
		end

	ignorebody: BOOLEAN assign set_ignorebody
		do
			Result := c_ignorebody (c_pointer)
		end

	ignorecl: BOOLEAN assign set_ignorecl
		do
			Result := c_ignorecl (c_pointer)
		end

	location: CE_POINTER [INTEGER_8] assign set_location
		do
			create Result.make_shared (c_location (c_pointer))
		end

	newurl: CE_POINTER [INTEGER_8] assign set_newurl
		do
			create Result.make_shared (c_newurl (c_pointer))
		end

	upload_present: INTEGER_32 assign set_upload_present
		do
			Result := c_upload_present (c_pointer)
		end

	upload_fromhere: CE_POINTER [INTEGER_8] assign set_upload_fromhere
		do
			create Result.make_shared (c_upload_fromhere (c_pointer))
		end

	chunk: BOOLEAN assign set_chunk
		do
			Result := c_chunk (c_pointer)
		end

	upload_chunky: BOOLEAN assign set_upload_chunky
		do
			Result := c_upload_chunky (c_pointer)
		end

	getheader: BOOLEAN assign set_getheader
		do
			Result := c_getheader (c_pointer)
		end

	forbidchunk: BOOLEAN assign set_forbidchunk
		do
			Result := c_forbidchunk (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_size (a_size: INTEGER_64)
		do
			c_set_size (c_pointer, a_size)
		end

	set_bytecountp (a_bytecountp: CE_POINTER [INTEGER_64])
		do
			c_set_bytecountp (c_pointer, a_bytecountp.c_pointer)
		end

	set_maxdownload (a_maxdownload: INTEGER_64)
		do
			c_set_maxdownload (c_pointer, a_maxdownload)
		end

	set_writebytecountp (a_writebytecountp: CE_POINTER [INTEGER_64])
		do
			c_set_writebytecountp (c_pointer, a_writebytecountp.c_pointer)
		end

	set_bytecount (a_bytecount: INTEGER_64)
		do
			c_set_bytecount (c_pointer, a_bytecount)
		end

	set_writebytecount (a_writebytecount: INTEGER_64)
		do
			c_set_writebytecount (c_pointer, a_writebytecount)
		end

	set_headerbytecount (a_headerbytecount: INTEGER_32)
		do
			c_set_headerbytecount (c_pointer, a_headerbytecount)
		end

	set_deductheadercount (a_deductheadercount: INTEGER_32)
		do
			c_set_deductheadercount (c_pointer, a_deductheadercount)
		end

	set_start (a_start: SD_TIMEVAL)
		do
			start.ce_gets (a_start)
		end

	set_now (a_now: SD_TIMEVAL)
		do
			now.ce_gets (a_now)
		end

	set_header (a_header: BOOLEAN)
		do
			c_set_header (c_pointer, a_header)
		end

	set_badheader (a_badheader: INTEGER_32)
		do
			c_set_badheader (c_pointer, a_badheader)
		end

	set_headerline (a_headerline: INTEGER_32)
		do
			c_set_headerline (c_pointer, a_headerline)
		end

	set_hbufp (a_hbufp: CE_POINTER [INTEGER_8])
		do
			c_set_hbufp (c_pointer, a_hbufp.c_pointer)
		end

	set_hbuflen (a_hbuflen: NATURAL_32)
		do
			c_set_hbuflen (c_pointer, a_hbuflen)
		end

	set_str (a_str: CE_POINTER [INTEGER_8])
		do
			c_set_str (c_pointer, a_str.c_pointer)
		end

	set_str_start (a_str_start: CE_POINTER [INTEGER_8])
		do
			c_set_str_start (c_pointer, a_str_start.c_pointer)
		end

	set_end_ptr (a_end_ptr: CE_POINTER [INTEGER_8])
		do
			c_set_end_ptr (c_pointer, a_end_ptr.c_pointer)
		end

	set_p (a_p: CE_POINTER [INTEGER_8])
		do
			c_set_p (c_pointer, a_p.c_pointer)
		end

	set_content_range (a_content_range: BOOLEAN)
		do
			c_set_content_range (c_pointer, a_content_range)
		end

	set_offset (a_offset: INTEGER_64)
		do
			c_set_offset (c_pointer, a_offset)
		end

	set_httpcode (a_httpcode: INTEGER_32)
		do
			c_set_httpcode (c_pointer, a_httpcode)
		end

	set_start100 (a_start100: SD_TIMEVAL)
		do
			start100.ce_gets (a_start100)
		end

	set_exp100 (a_exp100: INTEGER_32)
		do
			c_set_exp100 (c_pointer, a_exp100)
		end

	set_content_encoding (a_content_encoding: INTEGER_32)
		do
			c_set_content_encoding (c_pointer, a_content_encoding)
		end

	set_timeofdoc (a_timeofdoc: INTEGER_32)
		do
			c_set_timeofdoc (c_pointer, a_timeofdoc)
		end

	set_bodywrites (a_bodywrites: INTEGER_32)
		do
			c_set_bodywrites (c_pointer, a_bodywrites)
		end

	set_buf (a_buf: CE_POINTER [INTEGER_8])
		do
			c_set_buf (c_pointer, a_buf.c_pointer)
		end

	set_uploadbuf (a_uploadbuf: CE_POINTER [INTEGER_8])
		do
			c_set_uploadbuf (c_pointer, a_uploadbuf.c_pointer)
		end

	set_maxfd (a_maxfd: INTEGER_32)
		do
			c_set_maxfd (c_pointer, a_maxfd)
		end

	set_keepon (a_keepon: INTEGER_32)
		do
			c_set_keepon (c_pointer, a_keepon)
		end

	set_upload_done (a_upload_done: BOOLEAN)
		do
			c_set_upload_done (c_pointer, a_upload_done)
		end

	set_ignorebody (a_ignorebody: BOOLEAN)
		do
			c_set_ignorebody (c_pointer, a_ignorebody)
		end

	set_ignorecl (a_ignorecl: BOOLEAN)
		do
			c_set_ignorecl (c_pointer, a_ignorecl)
		end

	set_location (a_location: CE_POINTER [INTEGER_8])
		do
			c_set_location (c_pointer, a_location.c_pointer)
		end

	set_newurl (a_newurl: CE_POINTER [INTEGER_8])
		do
			c_set_newurl (c_pointer, a_newurl.c_pointer)
		end

	set_upload_present (a_upload_present: INTEGER_32)
		do
			c_set_upload_present (c_pointer, a_upload_present)
		end

	set_upload_fromhere (a_upload_fromhere: CE_POINTER [INTEGER_8])
		do
			c_set_upload_fromhere (c_pointer, a_upload_fromhere.c_pointer)
		end

	set_chunk (a_chunk: BOOLEAN)
		do
			c_set_chunk (c_pointer, a_chunk)
		end

	set_upload_chunky (a_upload_chunky: BOOLEAN)
		do
			c_set_upload_chunky (c_pointer, a_upload_chunky)
		end

	set_getheader (a_getheader: BOOLEAN)
		do
			c_set_getheader (c_pointer, a_getheader)
		end

	set_forbidchunk (a_forbidchunk: BOOLEAN)
		do
			c_set_forbidchunk (c_pointer, a_forbidchunk)
		end

feature {NONE} -- C getters

	c_size (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct SingleRequest *)$tmp)->size;"
		end

	c_bytecountp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (long long *)((struct SingleRequest *)$tmp)->bytecountp;"
		end

	c_maxdownload (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct SingleRequest *)$tmp)->maxdownload;"
		end

	c_writebytecountp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (long long *)((struct SingleRequest *)$tmp)->writebytecountp;"
		end

	c_bytecount (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct SingleRequest *)$tmp)->bytecount;"
		end

	c_writebytecount (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct SingleRequest *)$tmp)->writebytecount;"
		end

	c_headerbytecount (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct SingleRequest *)$tmp)->headerbytecount;"
		end

	c_deductheadercount (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct SingleRequest *)$tmp)->deductheadercount;"
		end

	c_start (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct timeval *)&((struct SingleRequest *)$tmp)->start;"
		end

	c_now (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct timeval *)&((struct SingleRequest *)$tmp)->now;"
		end

	c_header (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct SingleRequest *)$tmp)->header;"
		end

	c_badheader (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct SingleRequest *)$tmp)->badheader;"
		end

	c_headerline (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct SingleRequest *)$tmp)->headerline;"
		end

	c_hbufp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct SingleRequest *)$tmp)->hbufp;"
		end

	c_hbuflen (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct SingleRequest *)$tmp)->hbuflen;"
		end

	c_str (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct SingleRequest *)$tmp)->str;"
		end

	c_str_start (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct SingleRequest *)$tmp)->str_start;"
		end

	c_end_ptr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct SingleRequest *)$tmp)->end_ptr;"
		end

	c_p (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct SingleRequest *)$tmp)->p;"
		end

	c_content_range (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct SingleRequest *)$tmp)->content_range;"
		end

	c_offset (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct SingleRequest *)$tmp)->offset;"
		end

	c_httpcode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct SingleRequest *)$tmp)->httpcode;"
		end

	c_start100 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct timeval *)&((struct SingleRequest *)$tmp)->start100;"
		end

	c_exp100 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct SingleRequest *)$tmp)->exp100;"
		end

	c_content_encoding (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct SingleRequest *)$tmp)->content_encoding;"
		end

	c_timeofdoc (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct SingleRequest *)$tmp)->timeofdoc;"
		end

	c_bodywrites (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct SingleRequest *)$tmp)->bodywrites;"
		end

	c_buf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct SingleRequest *)$tmp)->buf;"
		end

	c_uploadbuf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct SingleRequest *)$tmp)->uploadbuf;"
		end

	c_maxfd (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct SingleRequest *)$tmp)->maxfd;"
		end

	c_keepon (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct SingleRequest *)$tmp)->keepon;"
		end

	c_upload_done (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct SingleRequest *)$tmp)->upload_done;"
		end

	c_ignorebody (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct SingleRequest *)$tmp)->ignorebody;"
		end

	c_ignorecl (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct SingleRequest *)$tmp)->ignorecl;"
		end

	c_location (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct SingleRequest *)$tmp)->location;"
		end

	c_newurl (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct SingleRequest *)$tmp)->newurl;"
		end

	c_upload_present (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct SingleRequest *)$tmp)->upload_present;"
		end

	c_upload_fromhere (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct SingleRequest *)$tmp)->upload_fromhere;"
		end

	c_chunk (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct SingleRequest *)$tmp)->chunk;"
		end

	c_upload_chunky (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct SingleRequest *)$tmp)->upload_chunky;"
		end

	c_getheader (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct SingleRequest *)$tmp)->getheader;"
		end

	c_forbidchunk (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct SingleRequest *)$tmp)->forbidchunk;"
		end

feature {NONE} -- C setters

	c_set_size (tmp: POINTER; a_size: INTEGER_64)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->size = $a_size;"
		end

	c_set_bytecountp (tmp: POINTER; a_bytecountp: POINTER)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->bytecountp = (long long *)$a_bytecountp;"
		end

	c_set_maxdownload (tmp: POINTER; a_maxdownload: INTEGER_64)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->maxdownload = $a_maxdownload;"
		end

	c_set_writebytecountp (tmp: POINTER; a_writebytecountp: POINTER)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->writebytecountp = (long long *)$a_writebytecountp;"
		end

	c_set_bytecount (tmp: POINTER; a_bytecount: INTEGER_64)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->bytecount = $a_bytecount;"
		end

	c_set_writebytecount (tmp: POINTER; a_writebytecount: INTEGER_64)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->writebytecount = $a_writebytecount;"
		end

	c_set_headerbytecount (tmp: POINTER; a_headerbytecount: INTEGER_32)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->headerbytecount = $a_headerbytecount;"
		end

	c_set_deductheadercount (tmp: POINTER; a_deductheadercount: INTEGER_32)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->deductheadercount = $a_deductheadercount;"
		end

	c_set_header (tmp: POINTER; a_header: BOOLEAN)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->header = $a_header;"
		end

	c_set_badheader (tmp: POINTER; a_badheader: INTEGER_32)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->badheader = $a_badheader;"
		end

	c_set_headerline (tmp: POINTER; a_headerline: INTEGER_32)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->headerline = $a_headerline;"
		end

	c_set_hbufp (tmp: POINTER; a_hbufp: POINTER)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->hbufp = (char *)$a_hbufp;"
		end

	c_set_hbuflen (tmp: POINTER; a_hbuflen: NATURAL_32)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->hbuflen = $a_hbuflen;"
		end

	c_set_str (tmp: POINTER; a_str: POINTER)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->str = (char *)$a_str;"
		end

	c_set_str_start (tmp: POINTER; a_str_start: POINTER)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->str_start = (char *)$a_str_start;"
		end

	c_set_end_ptr (tmp: POINTER; a_end_ptr: POINTER)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->end_ptr = (char *)$a_end_ptr;"
		end

	c_set_p (tmp: POINTER; a_p: POINTER)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->p = (char *)$a_p;"
		end

	c_set_content_range (tmp: POINTER; a_content_range: BOOLEAN)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->content_range = $a_content_range;"
		end

	c_set_offset (tmp: POINTER; a_offset: INTEGER_64)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->offset = $a_offset;"
		end

	c_set_httpcode (tmp: POINTER; a_httpcode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->httpcode = $a_httpcode;"
		end

	c_set_exp100 (tmp: POINTER; a_exp100: INTEGER_32)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->exp100 = $a_exp100;"
		end

	c_set_content_encoding (tmp: POINTER; a_content_encoding: INTEGER_32)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->content_encoding = $a_content_encoding;"
		end

	c_set_timeofdoc (tmp: POINTER; a_timeofdoc: INTEGER_32)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->timeofdoc = $a_timeofdoc;"
		end

	c_set_bodywrites (tmp: POINTER; a_bodywrites: INTEGER_32)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->bodywrites = $a_bodywrites;"
		end

	c_set_buf (tmp: POINTER; a_buf: POINTER)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->buf = (char *)$a_buf;"
		end

	c_set_uploadbuf (tmp: POINTER; a_uploadbuf: POINTER)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->uploadbuf = (char *)$a_uploadbuf;"
		end

	c_set_maxfd (tmp: POINTER; a_maxfd: INTEGER_32)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->maxfd = $a_maxfd;"
		end

	c_set_keepon (tmp: POINTER; a_keepon: INTEGER_32)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->keepon = $a_keepon;"
		end

	c_set_upload_done (tmp: POINTER; a_upload_done: BOOLEAN)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->upload_done = $a_upload_done;"
		end

	c_set_ignorebody (tmp: POINTER; a_ignorebody: BOOLEAN)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->ignorebody = $a_ignorebody;"
		end

	c_set_ignorecl (tmp: POINTER; a_ignorecl: BOOLEAN)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->ignorecl = $a_ignorecl;"
		end

	c_set_location (tmp: POINTER; a_location: POINTER)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->location = (char *)$a_location;"
		end

	c_set_newurl (tmp: POINTER; a_newurl: POINTER)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->newurl = (char *)$a_newurl;"
		end

	c_set_upload_present (tmp: POINTER; a_upload_present: INTEGER_32)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->upload_present = $a_upload_present;"
		end

	c_set_upload_fromhere (tmp: POINTER; a_upload_fromhere: POINTER)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->upload_fromhere = (char *)$a_upload_fromhere;"
		end

	c_set_chunk (tmp: POINTER; a_chunk: BOOLEAN)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->chunk = $a_chunk;"
		end

	c_set_upload_chunky (tmp: POINTER; a_upload_chunky: BOOLEAN)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->upload_chunky = $a_upload_chunky;"
		end

	c_set_getheader (tmp: POINTER; a_getheader: BOOLEAN)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->getheader = $a_getheader;"
		end

	c_set_forbidchunk (tmp: POINTER; a_forbidchunk: BOOLEAN)
		external
			"C inline"
		alias
			"((struct SingleRequest *)$tmp)->forbidchunk = $a_forbidchunk;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct SingleRequest);"
		end

end
