class
	PD_SMTP_CONN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	pp: PD_PINGPONG assign set_pp
		do
			create Result.make_shared (c_pp (c_pointer))
		end

	pp_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct smtp_conn, pp);"
		end

	domain: CE_POINTER [INTEGER_8] assign set_domain
		do
			create Result.make_shared (c_domain (c_pointer))
		end

	eob: NATURAL_32 assign set_eob
		do
			Result := c_eob (c_pointer)
		end

	authmechs: NATURAL_32 assign set_authmechs
		do
			Result := c_authmechs (c_pointer)
		end

	state: INTEGER_32 assign set_state
		do
			Result := c_state (c_pointer)
		end

	rcpt: CE_POINTER [PD_CURL_SLIST] assign set_rcpt
		do
			create Result.make_shared (c_rcpt (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_pp (a_pp: PD_PINGPONG)
		do
			pp.ce_gets (a_pp)
		end

	set_domain (a_domain: CE_POINTER [INTEGER_8])
		do
			c_set_domain (c_pointer, a_domain.c_pointer)
		end

	set_eob (a_eob: NATURAL_32)
		do
			c_set_eob (c_pointer, a_eob)
		end

	set_authmechs (a_authmechs: NATURAL_32)
		do
			c_set_authmechs (c_pointer, a_authmechs)
		end

	set_state (a_state: INTEGER_32)
		do
			c_set_state (c_pointer, a_state)
		end

	set_rcpt (a_rcpt: CE_POINTER [PD_CURL_SLIST])
		do
			c_set_rcpt (c_pointer, a_rcpt.c_pointer)
		end

feature {NONE} -- C getters

	c_pp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct pingpong *)&((struct smtp_conn *)$tmp)->pp;"
		end

	c_domain (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct smtp_conn *)$tmp)->domain;"
		end

	c_eob (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct smtp_conn *)$tmp)->eob;"
		end

	c_authmechs (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct smtp_conn *)$tmp)->authmechs;"
		end

	c_state (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct smtp_conn *)$tmp)->state;"
		end

	c_rcpt (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_slist *)((struct smtp_conn *)$tmp)->rcpt;"
		end

feature {NONE} -- C setters

	c_set_domain (tmp: POINTER; a_domain: POINTER)
		external
			"C inline"
		alias
			"((struct smtp_conn *)$tmp)->domain = (char *)$a_domain;"
		end

	c_set_eob (tmp: POINTER; a_eob: NATURAL_32)
		external
			"C inline"
		alias
			"((struct smtp_conn *)$tmp)->eob = $a_eob;"
		end

	c_set_authmechs (tmp: POINTER; a_authmechs: NATURAL_32)
		external
			"C inline"
		alias
			"((struct smtp_conn *)$tmp)->authmechs = $a_authmechs;"
		end

	c_set_state (tmp: POINTER; a_state: INTEGER_32)
		external
			"C inline"
		alias
			"((struct smtp_conn *)$tmp)->state = $a_state;"
		end

	c_set_rcpt (tmp: POINTER; a_rcpt: POINTER)
		external
			"C inline"
		alias
			"((struct smtp_conn *)$tmp)->rcpt = (struct curl_slist *)$a_rcpt;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct smtp_conn);"
		end

end
