class
	PD_SSL_CONFIG_DATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	version: INTEGER_32 assign set_version
		do
			Result := c_version (c_pointer)
		end

	certverifyresult: INTEGER_32 assign set_certverifyresult
		do
			Result := c_certverifyresult (c_pointer)
		end

	verifypeer: INTEGER_32 assign set_verifypeer
		do
			Result := c_verifypeer (c_pointer)
		end

	verifyhost: INTEGER_32 assign set_verifyhost
		do
			Result := c_verifyhost (c_pointer)
		end

	CApath: CE_POINTER [INTEGER_8] assign set_CApath
		do
			create Result.make_shared (c_CApath (c_pointer))
		end

	CAfile: CE_POINTER [INTEGER_8] assign set_CAfile
		do
			create Result.make_shared (c_CAfile (c_pointer))
		end

	CRLfile: CE_POINTER [INTEGER_8] assign set_CRLfile
		do
			create Result.make_shared (c_CRLfile (c_pointer))
		end

	issuercert: CE_POINTER [INTEGER_8] assign set_issuercert
		do
			create Result.make_shared (c_issuercert (c_pointer))
		end

	random_file: CE_POINTER [INTEGER_8] assign set_random_file
		do
			create Result.make_shared (c_random_file (c_pointer))
		end

	egdsocket: CE_POINTER [INTEGER_8] assign set_egdsocket
		do
			create Result.make_shared (c_egdsocket (c_pointer))
		end

	cipher_list: CE_POINTER [INTEGER_8] assign set_cipher_list
		do
			create Result.make_shared (c_cipher_list (c_pointer))
		end

	numsessions: INTEGER_32 assign set_numsessions
		do
			Result := c_numsessions (c_pointer)
		end

	fsslctx: CE_ROUTINE assign set_fsslctx
		do
			create Result.make_shared (c_fsslctx (c_pointer))
		end

	fsslctxp: CE_POINTER [ANY] assign set_fsslctxp
		do
			create Result.make_shared (c_fsslctxp (c_pointer))
		end

	sessionid: BOOLEAN assign set_sessionid
		do
			Result := c_sessionid (c_pointer)
		end

	certinfo: BOOLEAN assign set_certinfo
		do
			Result := c_certinfo (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_version (a_version: INTEGER_32)
		do
			c_set_version (c_pointer, a_version)
		end

	set_certverifyresult (a_certverifyresult: INTEGER_32)
		do
			c_set_certverifyresult (c_pointer, a_certverifyresult)
		end

	set_verifypeer (a_verifypeer: INTEGER_32)
		do
			c_set_verifypeer (c_pointer, a_verifypeer)
		end

	set_verifyhost (a_verifyhost: INTEGER_32)
		do
			c_set_verifyhost (c_pointer, a_verifyhost)
		end

	set_CApath (a_CApath: CE_POINTER [INTEGER_8])
		do
			c_set_CApath (c_pointer, a_CApath.c_pointer)
		end

	set_CAfile (a_CAfile: CE_POINTER [INTEGER_8])
		do
			c_set_CAfile (c_pointer, a_CAfile.c_pointer)
		end

	set_CRLfile (a_CRLfile: CE_POINTER [INTEGER_8])
		do
			c_set_CRLfile (c_pointer, a_CRLfile.c_pointer)
		end

	set_issuercert (a_issuercert: CE_POINTER [INTEGER_8])
		do
			c_set_issuercert (c_pointer, a_issuercert.c_pointer)
		end

	set_random_file (a_random_file: CE_POINTER [INTEGER_8])
		do
			c_set_random_file (c_pointer, a_random_file.c_pointer)
		end

	set_egdsocket (a_egdsocket: CE_POINTER [INTEGER_8])
		do
			c_set_egdsocket (c_pointer, a_egdsocket.c_pointer)
		end

	set_cipher_list (a_cipher_list: CE_POINTER [INTEGER_8])
		do
			c_set_cipher_list (c_pointer, a_cipher_list.c_pointer)
		end

	set_numsessions (a_numsessions: INTEGER_32)
		do
			c_set_numsessions (c_pointer, a_numsessions)
		end

	set_fsslctx (a_fsslctx: CE_ROUTINE)
		do
			c_set_fsslctx (c_pointer, a_fsslctx.c_pointer)
		end

	set_fsslctxp (a_fsslctxp: CE_POINTER [ANY])
		do
			c_set_fsslctxp (c_pointer, a_fsslctxp.c_pointer)
		end

	set_sessionid (a_sessionid: BOOLEAN)
		do
			c_set_sessionid (c_pointer, a_sessionid)
		end

	set_certinfo (a_certinfo: BOOLEAN)
		do
			c_set_certinfo (c_pointer, a_certinfo)
		end

feature {NONE} -- C getters

	c_version (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct ssl_config_data *)$tmp)->version;"
		end

	c_certverifyresult (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct ssl_config_data *)$tmp)->certverifyresult;"
		end

	c_verifypeer (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct ssl_config_data *)$tmp)->verifypeer;"
		end

	c_verifyhost (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct ssl_config_data *)$tmp)->verifyhost;"
		end

	c_CApath (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct ssl_config_data *)$tmp)->CApath;"
		end

	c_CAfile (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct ssl_config_data *)$tmp)->CAfile;"
		end

	c_CRLfile (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct ssl_config_data *)$tmp)->CRLfile;"
		end

	c_issuercert (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct ssl_config_data *)$tmp)->issuercert;"
		end

	c_random_file (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct ssl_config_data *)$tmp)->random_file;"
		end

	c_egdsocket (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct ssl_config_data *)$tmp)->egdsocket;"
		end

	c_cipher_list (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct ssl_config_data *)$tmp)->cipher_list;"
		end

	c_numsessions (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct ssl_config_data *)$tmp)->numsessions;"
		end

	c_fsslctx (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * curl, void * ssl_ctx, void * userptr))((struct ssl_config_data *)$tmp)->fsslctx;"
		end

	c_fsslctxp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct ssl_config_data *)$tmp)->fsslctxp;"
		end

	c_sessionid (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ssl_config_data *)$tmp)->sessionid;"
		end

	c_certinfo (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ssl_config_data *)$tmp)->certinfo;"
		end

feature {NONE} -- C setters

	c_set_version (tmp: POINTER; a_version: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ssl_config_data *)$tmp)->version = $a_version;"
		end

	c_set_certverifyresult (tmp: POINTER; a_certverifyresult: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ssl_config_data *)$tmp)->certverifyresult = $a_certverifyresult;"
		end

	c_set_verifypeer (tmp: POINTER; a_verifypeer: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ssl_config_data *)$tmp)->verifypeer = $a_verifypeer;"
		end

	c_set_verifyhost (tmp: POINTER; a_verifyhost: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ssl_config_data *)$tmp)->verifyhost = $a_verifyhost;"
		end

	c_set_CApath (tmp: POINTER; a_CApath: POINTER)
		external
			"C inline"
		alias
			"((struct ssl_config_data *)$tmp)->CApath = (char *)$a_capath;"
		end

	c_set_CAfile (tmp: POINTER; a_CAfile: POINTER)
		external
			"C inline"
		alias
			"((struct ssl_config_data *)$tmp)->CAfile = (char *)$a_cafile;"
		end

	c_set_CRLfile (tmp: POINTER; a_CRLfile: POINTER)
		external
			"C inline"
		alias
			"((struct ssl_config_data *)$tmp)->CRLfile = (char const *)$a_crlfile;"
		end

	c_set_issuercert (tmp: POINTER; a_issuercert: POINTER)
		external
			"C inline"
		alias
			"((struct ssl_config_data *)$tmp)->issuercert = (char const *)$a_issuercert;"
		end

	c_set_random_file (tmp: POINTER; a_random_file: POINTER)
		external
			"C inline"
		alias
			"((struct ssl_config_data *)$tmp)->random_file = (char *)$a_random_file;"
		end

	c_set_egdsocket (tmp: POINTER; a_egdsocket: POINTER)
		external
			"C inline"
		alias
			"((struct ssl_config_data *)$tmp)->egdsocket = (char *)$a_egdsocket;"
		end

	c_set_cipher_list (tmp: POINTER; a_cipher_list: POINTER)
		external
			"C inline"
		alias
			"((struct ssl_config_data *)$tmp)->cipher_list = (char *)$a_cipher_list;"
		end

	c_set_numsessions (tmp: POINTER; a_numsessions: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ssl_config_data *)$tmp)->numsessions = $a_numsessions;"
		end

	c_set_fsslctx (tmp: POINTER; a_fsslctx: POINTER)
		external
			"C inline"
		alias
			"((struct ssl_config_data *)$tmp)->fsslctx = (int( *)(void * curl, void * ssl_ctx, void * userptr))$a_fsslctx;"
		end

	c_set_fsslctxp (tmp: POINTER; a_fsslctxp: POINTER)
		external
			"C inline"
		alias
			"((struct ssl_config_data *)$tmp)->fsslctxp = (void *)$a_fsslctxp;"
		end

	c_set_sessionid (tmp: POINTER; a_sessionid: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ssl_config_data *)$tmp)->sessionid = $a_sessionid;"
		end

	c_set_certinfo (tmp: POINTER; a_certinfo: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ssl_config_data *)$tmp)->certinfo = $a_certinfo;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct ssl_config_data);"
		end

end
