class
	PD_TFTP_STATE_DATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	state: INTEGER_32 assign set_state
		do
			Result := c_state (c_pointer)
		end

	mode: INTEGER_32 assign set_mode
		do
			Result := c_mode (c_pointer)
		end

	error: INTEGER_32 assign set_error
		do
			Result := c_error (c_pointer)
		end

	event: INTEGER_32 assign set_event
		do
			Result := c_event (c_pointer)
		end

	conn: CE_POINTER [PD_CONNECTDATA] assign set_conn
		do
			create Result.make_shared (c_conn (c_pointer))
		end

	sockfd: INTEGER_32 assign set_sockfd
		do
			Result := c_sockfd (c_pointer)
		end

	retries: INTEGER_32 assign set_retries
		do
			Result := c_retries (c_pointer)
		end

	retry_time: INTEGER_32 assign set_retry_time
		do
			Result := c_retry_time (c_pointer)
		end

	retry_max: INTEGER_32 assign set_retry_max
		do
			Result := c_retry_max (c_pointer)
		end

	start_time: INTEGER_32 assign set_start_time
		do
			Result := c_start_time (c_pointer)
		end

	start_time_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct tftp_state_data, start_time);"
		end

	max_time: INTEGER_32 assign set_max_time
		do
			Result := c_max_time (c_pointer)
		end

	rx_time: INTEGER_32 assign set_rx_time
		do
			Result := c_rx_time (c_pointer)
		end

	rx_time_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct tftp_state_data, rx_time);"
		end

	block: NATURAL_16 assign set_block
		do
			Result := c_block (c_pointer)
		end

	local_addr: PD_CURL_SOCKADDR_STORAGE assign set_local_addr
		do
			create Result.make_shared (c_local_addr (c_pointer))
		end

	local_addr_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct tftp_state_data, local_addr);"
		end

	remote_addr: PD_CURL_SOCKADDR_STORAGE assign set_remote_addr
		do
			create Result.make_shared (c_remote_addr (c_pointer))
		end

	remote_addr_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct tftp_state_data, remote_addr);"
		end

	remote_addrlen: NATURAL_32 assign set_remote_addrlen
		do
			Result := c_remote_addrlen (c_pointer)
		end

	rbytes: INTEGER_32 assign set_rbytes
		do
			Result := c_rbytes (c_pointer)
		end

	sbytes: INTEGER_32 assign set_sbytes
		do
			Result := c_sbytes (c_pointer)
		end

	sbytes_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct tftp_state_data, sbytes);"
		end

	blksize: INTEGER_32 assign set_blksize
		do
			Result := c_blksize (c_pointer)
		end

	requested_blksize: INTEGER_32 assign set_requested_blksize
		do
			Result := c_requested_blksize (c_pointer)
		end

	rpacket: PD_TFTP_PACKET assign set_rpacket
		do
			create Result.make_shared (c_rpacket (c_pointer))
		end

	rpacket_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct tftp_state_data, rpacket);"
		end

	spacket: PD_TFTP_PACKET assign set_spacket
		do
			create Result.make_shared (c_spacket (c_pointer))
		end

	spacket_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct tftp_state_data, spacket);"
		end

feature {ANY} -- Eiffel setters

	set_state (a_state: INTEGER_32)
		do
			c_set_state (c_pointer, a_state)
		end

	set_mode (a_mode: INTEGER_32)
		do
			c_set_mode (c_pointer, a_mode)
		end

	set_error (a_error: INTEGER_32)
		do
			c_set_error (c_pointer, a_error)
		end

	set_event (a_event: INTEGER_32)
		do
			c_set_event (c_pointer, a_event)
		end

	set_conn (a_conn: CE_POINTER [PD_CONNECTDATA])
		do
			c_set_conn (c_pointer, a_conn.c_pointer)
		end

	set_sockfd (a_sockfd: INTEGER_32)
		do
			c_set_sockfd (c_pointer, a_sockfd)
		end

	set_retries (a_retries: INTEGER_32)
		do
			c_set_retries (c_pointer, a_retries)
		end

	set_retry_time (a_retry_time: INTEGER_32)
		do
			c_set_retry_time (c_pointer, a_retry_time)
		end

	set_retry_max (a_retry_max: INTEGER_32)
		do
			c_set_retry_max (c_pointer, a_retry_max)
		end

	set_start_time (a_start_time: INTEGER_32)
		do
			c_set_start_time (c_pointer, a_start_time)
		end

	set_max_time (a_max_time: INTEGER_32)
		do
			c_set_max_time (c_pointer, a_max_time)
		end

	set_rx_time (a_rx_time: INTEGER_32)
		do
			c_set_rx_time (c_pointer, a_rx_time)
		end

	set_block (a_block: NATURAL_16)
		do
			c_set_block (c_pointer, a_block)
		end

	set_local_addr (a_local_addr: PD_CURL_SOCKADDR_STORAGE)
		do
			local_addr.ce_gets (a_local_addr)
		end

	set_remote_addr (a_remote_addr: PD_CURL_SOCKADDR_STORAGE)
		do
			remote_addr.ce_gets (a_remote_addr)
		end

	set_remote_addrlen (a_remote_addrlen: NATURAL_32)
		do
			c_set_remote_addrlen (c_pointer, a_remote_addrlen)
		end

	set_rbytes (a_rbytes: INTEGER_32)
		do
			c_set_rbytes (c_pointer, a_rbytes)
		end

	set_sbytes (a_sbytes: INTEGER_32)
		do
			c_set_sbytes (c_pointer, a_sbytes)
		end

	set_blksize (a_blksize: INTEGER_32)
		do
			c_set_blksize (c_pointer, a_blksize)
		end

	set_requested_blksize (a_requested_blksize: INTEGER_32)
		do
			c_set_requested_blksize (c_pointer, a_requested_blksize)
		end

	set_rpacket (a_rpacket: PD_TFTP_PACKET)
		do
			rpacket.ce_gets (a_rpacket)
		end

	set_spacket (a_spacket: PD_TFTP_PACKET)
		do
			spacket.ce_gets (a_spacket)
		end

feature {NONE} -- C getters

	c_state (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tftp_state_data *)$tmp)->state;"
		end

	c_mode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tftp_state_data *)$tmp)->mode;"
		end

	c_error (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tftp_state_data *)$tmp)->error;"
		end

	c_event (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tftp_state_data *)$tmp)->event;"
		end

	c_conn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct connectdata *)((struct tftp_state_data *)$tmp)->conn;"
		end

	c_sockfd (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tftp_state_data *)$tmp)->sockfd;"
		end

	c_retries (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tftp_state_data *)$tmp)->retries;"
		end

	c_retry_time (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tftp_state_data *)$tmp)->retry_time;"
		end

	c_retry_max (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tftp_state_data *)$tmp)->retry_max;"
		end

	c_start_time (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct tftp_state_data *)$tmp)->start_time;"
		end

	c_max_time (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct tftp_state_data *)$tmp)->max_time;"
		end

	c_rx_time (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct tftp_state_data *)$tmp)->rx_time;"
		end

	c_block (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct tftp_state_data *)$tmp)->block;"
		end

	c_local_addr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Curl_sockaddr_storage *)&((struct tftp_state_data *)$tmp)->local_addr;"
		end

	c_remote_addr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Curl_sockaddr_storage *)&((struct tftp_state_data *)$tmp)->remote_addr;"
		end

	c_remote_addrlen (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct tftp_state_data *)$tmp)->remote_addrlen;"
		end

	c_rbytes (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tftp_state_data *)$tmp)->rbytes;"
		end

	c_sbytes (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tftp_state_data *)$tmp)->sbytes;"
		end

	c_blksize (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tftp_state_data *)$tmp)->blksize;"
		end

	c_requested_blksize (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tftp_state_data *)$tmp)->requested_blksize;"
		end

	c_rpacket (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct tftp_packet *)&((struct tftp_state_data *)$tmp)->rpacket;"
		end

	c_spacket (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct tftp_packet *)&((struct tftp_state_data *)$tmp)->spacket;"
		end

feature {NONE} -- C setters

	c_set_state (tmp: POINTER; a_state: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tftp_state_data *)$tmp)->state = $a_state;"
		end

	c_set_mode (tmp: POINTER; a_mode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tftp_state_data *)$tmp)->mode = $a_mode;"
		end

	c_set_error (tmp: POINTER; a_error: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tftp_state_data *)$tmp)->error = $a_error;"
		end

	c_set_event (tmp: POINTER; a_event: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tftp_state_data *)$tmp)->event = $a_event;"
		end

	c_set_conn (tmp: POINTER; a_conn: POINTER)
		external
			"C inline"
		alias
			"((struct tftp_state_data *)$tmp)->conn = (struct connectdata *)$a_conn;"
		end

	c_set_sockfd (tmp: POINTER; a_sockfd: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tftp_state_data *)$tmp)->sockfd = $a_sockfd;"
		end

	c_set_retries (tmp: POINTER; a_retries: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tftp_state_data *)$tmp)->retries = $a_retries;"
		end

	c_set_retry_time (tmp: POINTER; a_retry_time: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tftp_state_data *)$tmp)->retry_time = $a_retry_time;"
		end

	c_set_retry_max (tmp: POINTER; a_retry_max: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tftp_state_data *)$tmp)->retry_max = $a_retry_max;"
		end

	c_set_start_time (tmp: POINTER; a_start_time: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tftp_state_data *)$tmp)->start_time = $a_start_time;"
		end

	c_set_max_time (tmp: POINTER; a_max_time: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tftp_state_data *)$tmp)->max_time = $a_max_time;"
		end

	c_set_rx_time (tmp: POINTER; a_rx_time: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tftp_state_data *)$tmp)->rx_time = $a_rx_time;"
		end

	c_set_block (tmp: POINTER; a_block: NATURAL_16)
		external
			"C inline"
		alias
			"((struct tftp_state_data *)$tmp)->block = $a_block;"
		end

	c_set_remote_addrlen (tmp: POINTER; a_remote_addrlen: NATURAL_32)
		external
			"C inline"
		alias
			"((struct tftp_state_data *)$tmp)->remote_addrlen = $a_remote_addrlen;"
		end

	c_set_rbytes (tmp: POINTER; a_rbytes: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tftp_state_data *)$tmp)->rbytes = $a_rbytes;"
		end

	c_set_sbytes (tmp: POINTER; a_sbytes: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tftp_state_data *)$tmp)->sbytes = $a_sbytes;"
		end

	c_set_blksize (tmp: POINTER; a_blksize: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tftp_state_data *)$tmp)->blksize = $a_blksize;"
		end

	c_set_requested_blksize (tmp: POINTER; a_requested_blksize: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tftp_state_data *)$tmp)->requested_blksize = $a_requested_blksize;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct tftp_state_data);"
		end

end
