class
	PD_TZINFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_name (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	offset: INTEGER_32 assign set_offset
		do
			Result := c_offset (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_offset (a_offset: INTEGER_32)
		do
			c_set_offset (c_pointer, a_offset)
		end

feature {NONE} -- C getters

	c_name (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct tzinfo *tmp = (struct tzinfo *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->name) / sizeof(tmp->name[0]);
				return tmp->name;
			]"
		end

	c_offset (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tzinfo *)$tmp)->offset;"
		end

feature {NONE} -- C setters

	c_set_offset (tmp: POINTER; a_offset: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tzinfo *)$tmp)->offset = $a_offset;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct tzinfo);"
		end

end
