class
	PD_URLSTATE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	used_interface: INTEGER_32 assign set_used_interface
		do
			Result := c_used_interface (c_pointer)
		end

	connc: CE_POINTER [PD_CONNCACHE] assign set_connc
		do
			create Result.make_shared (c_connc (c_pointer))
		end

	keeps_speed: SD_TIMEVAL assign set_keeps_speed
		do
			create Result.make_shared (c_keeps_speed (c_pointer))
		end

	keeps_speed_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct UrlState, keeps_speed);"
		end

	lastconnect: INTEGER_32 assign set_lastconnect
		do
			Result := c_lastconnect (c_pointer)
		end

	headerbuff: CE_POINTER [INTEGER_8] assign set_headerbuff
		do
			create Result.make_shared (c_headerbuff (c_pointer))
		end

	headersize: NATURAL_32 assign set_headersize
		do
			Result := c_headersize (c_pointer)
		end

	buffer: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_buffer (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	uploadbuffer: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_uploadbuffer (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	current_speed: INTEGER_64 assign set_current_speed
		do
			Result := c_current_speed (c_pointer)
		end

	this_is_a_follow: BOOLEAN assign set_this_is_a_follow
		do
			Result := c_this_is_a_follow (c_pointer)
		end

	first_host: CE_POINTER [INTEGER_8] assign set_first_host
		do
			create Result.make_shared (c_first_host (c_pointer))
		end

	session: CE_POINTER [PD_CURL_SSL_SESSION] assign set_session
		do
			create Result.make_shared (c_session (c_pointer))
		end

	sessionage: INTEGER_32 assign set_sessionage
		do
			Result := c_sessionage (c_pointer)
		end

	tempwrite: CE_POINTER [INTEGER_8] assign set_tempwrite
		do
			create Result.make_shared (c_tempwrite (c_pointer))
		end

	tempwritesize: NATURAL_32 assign set_tempwritesize
		do
			Result := c_tempwritesize (c_pointer)
		end

	tempwritetype: INTEGER_32 assign set_tempwritetype
		do
			Result := c_tempwritetype (c_pointer)
		end

	scratch: CE_POINTER [INTEGER_8] assign set_scratch
		do
			create Result.make_shared (c_scratch (c_pointer))
		end

	errorbuf: BOOLEAN assign set_errorbuf
		do
			Result := c_errorbuf (c_pointer)
		end

	os_errno: INTEGER_32 assign set_os_errno
		do
			Result := c_os_errno (c_pointer)
		end

	prev_signal: CE_ROUTINE assign set_prev_signal
		do
			create Result.make_shared (c_prev_signal (c_pointer))
		end

	allow_port: BOOLEAN assign set_allow_port
		do
			Result := c_allow_port (c_pointer)
		end

	digest: PD_DIGESTDATA assign set_digest
		do
			create Result.make_shared (c_digest (c_pointer))
		end

	digest_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct UrlState, digest);"
		end

	proxydigest: PD_DIGESTDATA assign set_proxydigest
		do
			create Result.make_shared (c_proxydigest (c_pointer))
		end

	proxydigest_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct UrlState, proxydigest);"
		end

	authhost: PD_AUTH assign set_authhost
		do
			create Result.make_shared (c_authhost (c_pointer))
		end

	authhost_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct UrlState, authhost);"
		end

	authproxy: PD_AUTH assign set_authproxy
		do
			create Result.make_shared (c_authproxy (c_pointer))
		end

	authproxy_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct UrlState, authproxy);"
		end

	authproblem: BOOLEAN assign set_authproblem
		do
			Result := c_authproblem (c_pointer)
		end

	expiretime: SD_TIMEVAL assign set_expiretime
		do
			create Result.make_shared (c_expiretime (c_pointer))
		end

	expiretime_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct UrlState, expiretime);"
		end

	timenode: PD_CURL_TREE assign set_timenode
		do
			create Result.make_shared (c_timenode (c_pointer))
		end

	timenode_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct UrlState, timenode);"
		end

	timeoutlist: CE_POINTER [PD_CURL_LLIST] assign set_timeoutlist
		do
			create Result.make_shared (c_timeoutlist (c_pointer))
		end

	most_recent_ftp_entrypath: CE_POINTER [INTEGER_8] assign set_most_recent_ftp_entrypath
		do
			create Result.make_shared (c_most_recent_ftp_entrypath (c_pointer))
		end

	ftp_trying_alternative: BOOLEAN assign set_ftp_trying_alternative
		do
			Result := c_ftp_trying_alternative (c_pointer)
		end

	httpversion: INTEGER_32 assign set_httpversion
		do
			Result := c_httpversion (c_pointer)
		end

	expect100header: BOOLEAN assign set_expect100header
		do
			Result := c_expect100header (c_pointer)
		end

	pipe_broke: BOOLEAN assign set_pipe_broke
		do
			Result := c_pipe_broke (c_pointer)
		end

	prev_block_had_trailing_cr: BOOLEAN assign set_prev_block_had_trailing_cr
		do
			Result := c_prev_block_had_trailing_cr (c_pointer)
		end

	crlf_conversions: INTEGER_64 assign set_crlf_conversions
		do
			Result := c_crlf_conversions (c_pointer)
		end

	shared_conn: CE_POINTER [ANY] assign set_shared_conn
		do
			create Result.make_shared (c_shared_conn (c_pointer))
		end

	closed: BOOLEAN assign set_closed
		do
			Result := c_closed (c_pointer)
		end

	pathbuffer: CE_POINTER [INTEGER_8] assign set_pathbuffer
		do
			create Result.make_shared (c_pathbuffer (c_pointer))
		end

	path: CE_POINTER [INTEGER_8] assign set_path
		do
			create Result.make_shared (c_path (c_pointer))
		end

	slash_removed: BOOLEAN assign set_slash_removed
		do
			Result := c_slash_removed (c_pointer)
		end

	use_range: BOOLEAN assign set_use_range
		do
			Result := c_use_range (c_pointer)
		end

	rangestringalloc: BOOLEAN assign set_rangestringalloc
		do
			Result := c_rangestringalloc (c_pointer)
		end

	range: CE_POINTER [INTEGER_8] assign set_range
		do
			create Result.make_shared (c_range (c_pointer))
		end

	resume_from: INTEGER_64 assign set_resume_from
		do
			Result := c_resume_from (c_pointer)
		end

	rtsp_next_client_CSeq: INTEGER_32 assign set_rtsp_next_client_CSeq
		do
			Result := c_rtsp_next_client_CSeq (c_pointer)
		end

	rtsp_next_server_CSeq: INTEGER_32 assign set_rtsp_next_server_CSeq
		do
			Result := c_rtsp_next_server_CSeq (c_pointer)
		end

	rtsp_CSeq_recv: INTEGER_32 assign set_rtsp_CSeq_recv
		do
			Result := c_rtsp_CSeq_recv (c_pointer)
		end

	proto: PD_PROTO2 assign set_proto
		do
			create Result.make_shared (c_proto (c_pointer))
		end

	current_conn: CE_POINTER [PD_CONNECTDATA] assign set_current_conn
		do
			create Result.make_shared (c_current_conn (c_pointer))
		end

	ssl_connect_retry: BOOLEAN assign set_ssl_connect_retry
		do
			Result := c_ssl_connect_retry (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_used_interface (a_used_interface: INTEGER_32)
		do
			c_set_used_interface (c_pointer, a_used_interface)
		end

	set_connc (a_connc: CE_POINTER [PD_CONNCACHE])
		do
			c_set_connc (c_pointer, a_connc.c_pointer)
		end

	set_keeps_speed (a_keeps_speed: SD_TIMEVAL)
		do
			keeps_speed.ce_gets (a_keeps_speed)
		end

	set_lastconnect (a_lastconnect: INTEGER_32)
		do
			c_set_lastconnect (c_pointer, a_lastconnect)
		end

	set_headerbuff (a_headerbuff: CE_POINTER [INTEGER_8])
		do
			c_set_headerbuff (c_pointer, a_headerbuff.c_pointer)
		end

	set_headersize (a_headersize: NATURAL_32)
		do
			c_set_headersize (c_pointer, a_headersize)
		end

	set_current_speed (a_current_speed: INTEGER_64)
		do
			c_set_current_speed (c_pointer, a_current_speed)
		end

	set_this_is_a_follow (a_this_is_a_follow: BOOLEAN)
		do
			c_set_this_is_a_follow (c_pointer, a_this_is_a_follow)
		end

	set_first_host (a_first_host: CE_POINTER [INTEGER_8])
		do
			c_set_first_host (c_pointer, a_first_host.c_pointer)
		end

	set_session (a_session: CE_POINTER [PD_CURL_SSL_SESSION])
		do
			c_set_session (c_pointer, a_session.c_pointer)
		end

	set_sessionage (a_sessionage: INTEGER_32)
		do
			c_set_sessionage (c_pointer, a_sessionage)
		end

	set_tempwrite (a_tempwrite: CE_POINTER [INTEGER_8])
		do
			c_set_tempwrite (c_pointer, a_tempwrite.c_pointer)
		end

	set_tempwritesize (a_tempwritesize: NATURAL_32)
		do
			c_set_tempwritesize (c_pointer, a_tempwritesize)
		end

	set_tempwritetype (a_tempwritetype: INTEGER_32)
		do
			c_set_tempwritetype (c_pointer, a_tempwritetype)
		end

	set_scratch (a_scratch: CE_POINTER [INTEGER_8])
		do
			c_set_scratch (c_pointer, a_scratch.c_pointer)
		end

	set_errorbuf (a_errorbuf: BOOLEAN)
		do
			c_set_errorbuf (c_pointer, a_errorbuf)
		end

	set_os_errno (a_os_errno: INTEGER_32)
		do
			c_set_os_errno (c_pointer, a_os_errno)
		end

	set_prev_signal (a_prev_signal: CE_ROUTINE)
		do
			c_set_prev_signal (c_pointer, a_prev_signal.c_pointer)
		end

	set_allow_port (a_allow_port: BOOLEAN)
		do
			c_set_allow_port (c_pointer, a_allow_port)
		end

	set_digest (a_digest: PD_DIGESTDATA)
		do
			digest.ce_gets (a_digest)
		end

	set_proxydigest (a_proxydigest: PD_DIGESTDATA)
		do
			proxydigest.ce_gets (a_proxydigest)
		end

	set_authhost (a_authhost: PD_AUTH)
		do
			authhost.ce_gets (a_authhost)
		end

	set_authproxy (a_authproxy: PD_AUTH)
		do
			authproxy.ce_gets (a_authproxy)
		end

	set_authproblem (a_authproblem: BOOLEAN)
		do
			c_set_authproblem (c_pointer, a_authproblem)
		end

	set_expiretime (a_expiretime: SD_TIMEVAL)
		do
			expiretime.ce_gets (a_expiretime)
		end

	set_timenode (a_timenode: PD_CURL_TREE)
		do
			timenode.ce_gets (a_timenode)
		end

	set_timeoutlist (a_timeoutlist: CE_POINTER [PD_CURL_LLIST])
		do
			c_set_timeoutlist (c_pointer, a_timeoutlist.c_pointer)
		end

	set_most_recent_ftp_entrypath (a_most_recent_ftp_entrypath: CE_POINTER [INTEGER_8])
		do
			c_set_most_recent_ftp_entrypath (c_pointer, a_most_recent_ftp_entrypath.c_pointer)
		end

	set_ftp_trying_alternative (a_ftp_trying_alternative: BOOLEAN)
		do
			c_set_ftp_trying_alternative (c_pointer, a_ftp_trying_alternative)
		end

	set_httpversion (a_httpversion: INTEGER_32)
		do
			c_set_httpversion (c_pointer, a_httpversion)
		end

	set_expect100header (a_expect100header: BOOLEAN)
		do
			c_set_expect100header (c_pointer, a_expect100header)
		end

	set_pipe_broke (a_pipe_broke: BOOLEAN)
		do
			c_set_pipe_broke (c_pointer, a_pipe_broke)
		end

	set_prev_block_had_trailing_cr (a_prev_block_had_trailing_cr: BOOLEAN)
		do
			c_set_prev_block_had_trailing_cr (c_pointer, a_prev_block_had_trailing_cr)
		end

	set_crlf_conversions (a_crlf_conversions: INTEGER_64)
		do
			c_set_crlf_conversions (c_pointer, a_crlf_conversions)
		end

	set_shared_conn (a_shared_conn: CE_POINTER [ANY])
		do
			c_set_shared_conn (c_pointer, a_shared_conn.c_pointer)
		end

	set_closed (a_closed: BOOLEAN)
		do
			c_set_closed (c_pointer, a_closed)
		end

	set_pathbuffer (a_pathbuffer: CE_POINTER [INTEGER_8])
		do
			c_set_pathbuffer (c_pointer, a_pathbuffer.c_pointer)
		end

	set_path (a_path: CE_POINTER [INTEGER_8])
		do
			c_set_path (c_pointer, a_path.c_pointer)
		end

	set_slash_removed (a_slash_removed: BOOLEAN)
		do
			c_set_slash_removed (c_pointer, a_slash_removed)
		end

	set_use_range (a_use_range: BOOLEAN)
		do
			c_set_use_range (c_pointer, a_use_range)
		end

	set_rangestringalloc (a_rangestringalloc: BOOLEAN)
		do
			c_set_rangestringalloc (c_pointer, a_rangestringalloc)
		end

	set_range (a_range: CE_POINTER [INTEGER_8])
		do
			c_set_range (c_pointer, a_range.c_pointer)
		end

	set_resume_from (a_resume_from: INTEGER_64)
		do
			c_set_resume_from (c_pointer, a_resume_from)
		end

	set_rtsp_next_client_CSeq (a_rtsp_next_client_CSeq: INTEGER_32)
		do
			c_set_rtsp_next_client_CSeq (c_pointer, a_rtsp_next_client_CSeq)
		end

	set_rtsp_next_server_CSeq (a_rtsp_next_server_CSeq: INTEGER_32)
		do
			c_set_rtsp_next_server_CSeq (c_pointer, a_rtsp_next_server_CSeq)
		end

	set_rtsp_CSeq_recv (a_rtsp_CSeq_recv: INTEGER_32)
		do
			c_set_rtsp_CSeq_recv (c_pointer, a_rtsp_CSeq_recv)
		end

	set_proto (a_proto: PD_PROTO2)
		do
			proto.ce_gets (a_proto)
		end

	set_current_conn (a_current_conn: CE_POINTER [PD_CONNECTDATA])
		do
			c_set_current_conn (c_pointer, a_current_conn.c_pointer)
		end

	set_ssl_connect_retry (a_ssl_connect_retry: BOOLEAN)
		do
			c_set_ssl_connect_retry (c_pointer, a_ssl_connect_retry)
		end

feature {NONE} -- C getters

	c_used_interface (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct UrlState *)$tmp)->used_interface;"
		end

	c_connc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct conncache *)((struct UrlState *)$tmp)->connc;"
		end

	c_keeps_speed (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct timeval *)&((struct UrlState *)$tmp)->keeps_speed;"
		end

	c_lastconnect (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UrlState *)$tmp)->lastconnect;"
		end

	c_headerbuff (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct UrlState *)$tmp)->headerbuff;"
		end

	c_headersize (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct UrlState *)$tmp)->headersize;"
		end

	c_buffer (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct UrlState *tmp = (struct UrlState *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->buffer) / sizeof(tmp->buffer[0]);
				return tmp->buffer;
			]"
		end

	c_uploadbuffer (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct UrlState *tmp = (struct UrlState *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->uploadbuffer) / sizeof(tmp->uploadbuffer[0]);
				return tmp->uploadbuffer;
			]"
		end

	c_current_speed (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct UrlState *)$tmp)->current_speed;"
		end

	c_this_is_a_follow (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UrlState *)$tmp)->this_is_a_follow;"
		end

	c_first_host (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct UrlState *)$tmp)->first_host;"
		end

	c_session (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_ssl_session *)((struct UrlState *)$tmp)->session;"
		end

	c_sessionage (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UrlState *)$tmp)->sessionage;"
		end

	c_tempwrite (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct UrlState *)$tmp)->tempwrite;"
		end

	c_tempwritesize (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct UrlState *)$tmp)->tempwritesize;"
		end

	c_tempwritetype (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct UrlState *)$tmp)->tempwritetype;"
		end

	c_scratch (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct UrlState *)$tmp)->scratch;"
		end

	c_errorbuf (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UrlState *)$tmp)->errorbuf;"
		end

	c_os_errno (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct UrlState *)$tmp)->os_errno;"
		end

	c_prev_signal (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(int sig))((struct UrlState *)$tmp)->prev_signal;"
		end

	c_allow_port (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UrlState *)$tmp)->allow_port;"
		end

	c_digest (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct digestdata *)&((struct UrlState *)$tmp)->digest;"
		end

	c_proxydigest (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct digestdata *)&((struct UrlState *)$tmp)->proxydigest;"
		end

	c_authhost (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct auth *)&((struct UrlState *)$tmp)->authhost;"
		end

	c_authproxy (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct auth *)&((struct UrlState *)$tmp)->authproxy;"
		end

	c_authproblem (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UrlState *)$tmp)->authproblem;"
		end

	c_expiretime (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct timeval *)&((struct UrlState *)$tmp)->expiretime;"
		end

	c_timenode (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Curl_tree *)&((struct UrlState *)$tmp)->timenode;"
		end

	c_timeoutlist (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_llist *)((struct UrlState *)$tmp)->timeoutlist;"
		end

	c_most_recent_ftp_entrypath (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct UrlState *)$tmp)->most_recent_ftp_entrypath;"
		end

	c_ftp_trying_alternative (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UrlState *)$tmp)->ftp_trying_alternative;"
		end

	c_httpversion (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct UrlState *)$tmp)->httpversion;"
		end

	c_expect100header (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UrlState *)$tmp)->expect100header;"
		end

	c_pipe_broke (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UrlState *)$tmp)->pipe_broke;"
		end

	c_prev_block_had_trailing_cr (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UrlState *)$tmp)->prev_block_had_trailing_cr;"
		end

	c_crlf_conversions (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct UrlState *)$tmp)->crlf_conversions;"
		end

	c_shared_conn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct UrlState *)$tmp)->shared_conn;"
		end

	c_closed (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UrlState *)$tmp)->closed;"
		end

	c_pathbuffer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct UrlState *)$tmp)->pathbuffer;"
		end

	c_path (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct UrlState *)$tmp)->path;"
		end

	c_slash_removed (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UrlState *)$tmp)->slash_removed;"
		end

	c_use_range (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UrlState *)$tmp)->use_range;"
		end

	c_rangestringalloc (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UrlState *)$tmp)->rangestringalloc;"
		end

	c_range (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct UrlState *)$tmp)->range;"
		end

	c_resume_from (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct UrlState *)$tmp)->resume_from;"
		end

	c_rtsp_next_client_CSeq (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UrlState *)$tmp)->rtsp_next_client_CSeq;"
		end

	c_rtsp_next_server_CSeq (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UrlState *)$tmp)->rtsp_next_server_CSeq;"
		end

	c_rtsp_CSeq_recv (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UrlState *)$tmp)->rtsp_CSeq_recv;"
		end

	c_proto (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_proto_101 *)&((struct UrlState *)$tmp)->proto;"
		end

	c_current_conn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct connectdata *)((struct UrlState *)$tmp)->current_conn;"
		end

	c_ssl_connect_retry (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UrlState *)$tmp)->ssl_connect_retry;"
		end

feature {NONE} -- C setters

	c_set_used_interface (tmp: POINTER; a_used_interface: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->used_interface = $a_used_interface;"
		end

	c_set_connc (tmp: POINTER; a_connc: POINTER)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->connc = (struct conncache *)$a_connc;"
		end

	c_set_lastconnect (tmp: POINTER; a_lastconnect: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->lastconnect = $a_lastconnect;"
		end

	c_set_headerbuff (tmp: POINTER; a_headerbuff: POINTER)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->headerbuff = (char *)$a_headerbuff;"
		end

	c_set_headersize (tmp: POINTER; a_headersize: NATURAL_32)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->headersize = $a_headersize;"
		end

	c_set_current_speed (tmp: POINTER; a_current_speed: INTEGER_64)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->current_speed = $a_current_speed;"
		end

	c_set_this_is_a_follow (tmp: POINTER; a_this_is_a_follow: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->this_is_a_follow = $a_this_is_a_follow;"
		end

	c_set_first_host (tmp: POINTER; a_first_host: POINTER)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->first_host = (char *)$a_first_host;"
		end

	c_set_session (tmp: POINTER; a_session: POINTER)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->session = (struct curl_ssl_session *)$a_session;"
		end

	c_set_sessionage (tmp: POINTER; a_sessionage: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->sessionage = $a_sessionage;"
		end

	c_set_tempwrite (tmp: POINTER; a_tempwrite: POINTER)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->tempwrite = (char *)$a_tempwrite;"
		end

	c_set_tempwritesize (tmp: POINTER; a_tempwritesize: NATURAL_32)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->tempwritesize = $a_tempwritesize;"
		end

	c_set_tempwritetype (tmp: POINTER; a_tempwritetype: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->tempwritetype = $a_tempwritetype;"
		end

	c_set_scratch (tmp: POINTER; a_scratch: POINTER)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->scratch = (char *)$a_scratch;"
		end

	c_set_errorbuf (tmp: POINTER; a_errorbuf: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->errorbuf = $a_errorbuf;"
		end

	c_set_os_errno (tmp: POINTER; a_os_errno: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->os_errno = $a_os_errno;"
		end

	c_set_prev_signal (tmp: POINTER; a_prev_signal: POINTER)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->prev_signal = (void( *)(int sig))$a_prev_signal;"
		end

	c_set_allow_port (tmp: POINTER; a_allow_port: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->allow_port = $a_allow_port;"
		end

	c_set_authproblem (tmp: POINTER; a_authproblem: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->authproblem = $a_authproblem;"
		end

	c_set_timeoutlist (tmp: POINTER; a_timeoutlist: POINTER)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->timeoutlist = (struct curl_llist *)$a_timeoutlist;"
		end

	c_set_most_recent_ftp_entrypath (tmp: POINTER; a_most_recent_ftp_entrypath: POINTER)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->most_recent_ftp_entrypath = (char *)$a_most_recent_ftp_entrypath;"
		end

	c_set_ftp_trying_alternative (tmp: POINTER; a_ftp_trying_alternative: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->ftp_trying_alternative = $a_ftp_trying_alternative;"
		end

	c_set_httpversion (tmp: POINTER; a_httpversion: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->httpversion = $a_httpversion;"
		end

	c_set_expect100header (tmp: POINTER; a_expect100header: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->expect100header = $a_expect100header;"
		end

	c_set_pipe_broke (tmp: POINTER; a_pipe_broke: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->pipe_broke = $a_pipe_broke;"
		end

	c_set_prev_block_had_trailing_cr (tmp: POINTER; a_prev_block_had_trailing_cr: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->prev_block_had_trailing_cr = $a_prev_block_had_trailing_cr;"
		end

	c_set_crlf_conversions (tmp: POINTER; a_crlf_conversions: INTEGER_64)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->crlf_conversions = $a_crlf_conversions;"
		end

	c_set_shared_conn (tmp: POINTER; a_shared_conn: POINTER)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->shared_conn = (void *)$a_shared_conn;"
		end

	c_set_closed (tmp: POINTER; a_closed: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->closed = $a_closed;"
		end

	c_set_pathbuffer (tmp: POINTER; a_pathbuffer: POINTER)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->pathbuffer = (char *)$a_pathbuffer;"
		end

	c_set_path (tmp: POINTER; a_path: POINTER)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->path = (char *)$a_path;"
		end

	c_set_slash_removed (tmp: POINTER; a_slash_removed: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->slash_removed = $a_slash_removed;"
		end

	c_set_use_range (tmp: POINTER; a_use_range: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->use_range = $a_use_range;"
		end

	c_set_rangestringalloc (tmp: POINTER; a_rangestringalloc: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->rangestringalloc = $a_rangestringalloc;"
		end

	c_set_range (tmp: POINTER; a_range: POINTER)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->range = (char *)$a_range;"
		end

	c_set_resume_from (tmp: POINTER; a_resume_from: INTEGER_64)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->resume_from = $a_resume_from;"
		end

	c_set_rtsp_next_client_CSeq (tmp: POINTER; a_rtsp_next_client_CSeq: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->rtsp_next_client_CSeq = $a_rtsp_next_client_cseq;"
		end

	c_set_rtsp_next_server_CSeq (tmp: POINTER; a_rtsp_next_server_CSeq: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->rtsp_next_server_CSeq = $a_rtsp_next_server_cseq;"
		end

	c_set_rtsp_CSeq_recv (tmp: POINTER; a_rtsp_CSeq_recv: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->rtsp_CSeq_recv = $a_rtsp_cseq_recv;"
		end

	c_set_current_conn (tmp: POINTER; a_current_conn: POINTER)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->current_conn = (struct connectdata *)$a_current_conn;"
		end

	c_set_ssl_connect_retry (tmp: POINTER; a_ssl_connect_retry: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UrlState *)$tmp)->ssl_connect_retry = $a_ssl_connect_retry;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct UrlState);"
		end

end
