class
	PD_WILDCARDDATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	state: INTEGER_32 assign set_state
		do
			Result := c_state (c_pointer)
		end

	path: CE_POINTER [INTEGER_8] assign set_path
		do
			create Result.make_shared (c_path (c_pointer))
		end

	pattern: CE_POINTER [INTEGER_8] assign set_pattern
		do
			create Result.make_shared (c_pattern (c_pointer))
		end

	filelist: CE_POINTER [PD_CURL_LLIST] assign set_filelist
		do
			create Result.make_shared (c_filelist (c_pointer))
		end

	tmp: CE_POINTER [ANY] assign set_tmp
		do
			create Result.make_shared (c_tmp (c_pointer))
		end

	tmp_dtor: CE_ROUTINE assign set_tmp_dtor
		do
			create Result.make_shared (c_tmp_dtor (c_pointer))
		end

	customptr: CE_POINTER [ANY] assign set_customptr
		do
			create Result.make_shared (c_customptr (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_state (a_state: INTEGER_32)
		do
			c_set_state (c_pointer, a_state)
		end

	set_path (a_path: CE_POINTER [INTEGER_8])
		do
			c_set_path (c_pointer, a_path.c_pointer)
		end

	set_pattern (a_pattern: CE_POINTER [INTEGER_8])
		do
			c_set_pattern (c_pointer, a_pattern.c_pointer)
		end

	set_filelist (a_filelist: CE_POINTER [PD_CURL_LLIST])
		do
			c_set_filelist (c_pointer, a_filelist.c_pointer)
		end

	set_tmp (a_tmp: CE_POINTER [ANY])
		do
			c_set_tmp (c_pointer, a_tmp.c_pointer)
		end

	set_tmp_dtor (a_tmp_dtor: CE_ROUTINE)
		do
			c_set_tmp_dtor (c_pointer, a_tmp_dtor.c_pointer)
		end

	set_customptr (a_customptr: CE_POINTER [ANY])
		do
			c_set_customptr (c_pointer, a_customptr.c_pointer)
		end

feature {NONE} -- C getters

	c_state (tmp2: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct WildcardData *)$tmp2)->state;"
		end

	c_path (tmp2: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct WildcardData *)$tmp2)->path;"
		end

	c_pattern (tmp2: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct WildcardData *)$tmp2)->pattern;"
		end

	c_filelist (tmp2: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_llist *)((struct WildcardData *)$tmp2)->filelist;"
		end

	c_tmp (tmp2: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct WildcardData *)$tmp2)->tmp;"
		end

	c_tmp_dtor (tmp2: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void * ptr))((struct WildcardData *)$tmp2)->tmp_dtor;"
		end

	c_customptr (tmp2: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct WildcardData *)$tmp2)->customptr;"
		end

feature {NONE} -- C setters

	c_set_state (tmp2: POINTER; a_state: INTEGER_32)
		external
			"C inline"
		alias
			"((struct WildcardData *)$tmp2)->state = $a_state;"
		end

	c_set_path (tmp2: POINTER; a_path: POINTER)
		external
			"C inline"
		alias
			"((struct WildcardData *)$tmp2)->path = (char *)$a_path;"
		end

	c_set_pattern (tmp2: POINTER; a_pattern: POINTER)
		external
			"C inline"
		alias
			"((struct WildcardData *)$tmp2)->pattern = (char *)$a_pattern;"
		end

	c_set_filelist (tmp2: POINTER; a_filelist: POINTER)
		external
			"C inline"
		alias
			"((struct WildcardData *)$tmp2)->filelist = (struct curl_llist *)$a_filelist;"
		end

	c_set_tmp (tmp2: POINTER; a_tmp: POINTER)
		external
			"C inline"
		alias
			"((struct WildcardData *)$tmp2)->tmp = (void *)$a_tmp;"
		end

	c_set_tmp_dtor (tmp2: POINTER; a_tmp_dtor: POINTER)
		external
			"C inline"
		alias
			"((struct WildcardData *)$tmp2)->tmp_dtor = (void( *)(void * ptr))$a_tmp_dtor;"
		end

	c_set_customptr (tmp2: POINTER; a_customptr: POINTER)
		external
			"C inline"
		alias
			"((struct WildcardData *)$tmp2)->customptr = (void *)$a_customptr;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct WildcardData);"
		end

end
