#ifndef LIBCURL_H
#define LIBCURL_H

#include <ffi.h>
#include <time.h>
#include <sys/socket.h>
#include <libio.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <bits/sigset.h>
#include <netinet/in.h>
#include <signal.h>
#include <ifaddrs.h>
#include <sys/poll.h>
#include <pwd.h>
#include <sys/un.h>
#include <sys/select.h>
#include <netdb.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <libgen.h>
#include <bits/errno.h>

#undef tv_sec
#undef tv_nsec
#undef tv_usec
#undef sa_family
#undef sa_data
#undef next
#undef sbuf
#undef pos
#undef flags
#undef IO_read_ptr
#undef IO_read_end
#undef IO_read_base
#undef IO_write_base
#undef IO_write_ptr
#undef IO_write_end
#undef IO_buf_base
#undef IO_buf_end
#undef IO_save_base
#undef IO_backup_base
#undef IO_save_end
#undef markers
#undef chain
#undef fileno
#undef flags2
#undef old_offset
#undef cur_column
#undef vtable_offset
#undef shortbuf
#undef lock
#undef offset
#undef pad1
#undef pad2
#undef pad3
#undef pad4
#undef pad5
#undef mode
#undef unused2
#undef st_dev
#undef st_ino
#undef st_mode
#undef st_nlink
#undef st_uid
#undef st_gid
#undef st_rdev
#undef st_size
#undef st_blksize
#undef st_blocks
#undef st_atim
#undef st_mtim
#undef st_ctim
#undef unused4
#undef unused5
#undef tm_sec
#undef tm_min
#undef tm_hour
#undef tm_mday
#undef tm_mon
#undef tm_year
#undef tm_wday
#undef tm_yday
#undef tm_isdst
#undef tm_gmtoff
#undef tm_zone
#undef name
#undef namelength
#undef contents
#undef contentslength
#undef buffer
#undef bufferlength
#undef contenttype
#undef contentheader
#undef more
#undef showfilename
#undef userp
#undef family
#undef socktype
#undef protocol
#undef addrlen
#undef addr
#undef key
#undef len
#undef keytype
#undef data
#undef num_of_certs
#undef certinfo
#undef value
#undef path
#undef domain
#undef expires
#undef expirestr
#undef tailmatch
#undef version
#undef maxage
#undef secure
#undef livecookie
#undef httponly
#undef cookies
#undef filename
#undef running
#undef numcookies
#undef newsession
#undef type
#undef line
#undef length
#undef sent
#undef fp
#undef fread_func
#undef hexbuffer
#undef hexindex
#undef state
#undef datasize
#undef dataleft
#undef ptr
#undef prev
#undef head
#undef tail
#undef dtor
#undef size
#undef table
#undef hash_func
#undef comp_func
#undef slots
#undef ai_flags
#undef ai_family
#undef ai_socktype
#undef ai_protocol
#undef ai_addrlen
#undef ai_canonname
#undef ai_addr
#undef ai_next
#undef timestamp
#undef inuse
#undef smaller
#undef larger
#undef same
#undef payload
#undef cache
#undef cache_size
#undef nread_resp
#undef linestart_resp
#undef pending_resp
#undef sendthis
#undef sendleft
#undef sendsize
#undef response
#undef response_time
#undef conn
#undef statemach_act
#undef endofresp
#undef pp
#undef mailbox
#undef cmdid
#undef idstr
#undef eob
#undef authmechs
#undef rcpt
#undef bytecountp
#undef user
#undef passwd
#undef transfer
#undef downloadsize
#undef entrypath
#undef dirs
#undef dirdepth
#undef diralloc
#undef file
#undef dont_check
#undef ctl_valid
#undef cwddone
#undef cwdfail
#undef prevpath
#undef transfertype
#undef count1
#undef count2
#undef count3
#undef server_os
#undef known_filesize
#undef freepath
#undef fd
#undef authlist
#undef fread_in
#undef postdata
#undef postsize
#undef sendit
#undef p_pragma
#undef p_accept
#undef readbytecount
#undef writebytecount
#undef form
#undef backup
#undef sending
#undef send_buffer
#undef rtp_buf
#undef rtp_bufsize
#undef rtp_channel
#undef http_wrapper
#undef CSeq_sent
#undef CSeq_recv
#undef pattern
#undef filelist
#undef tmp
#undef tmp_dtor
#undef customptr
#undef use
#undef certverifyresult
#undef verifypeer
#undef verifyhost
#undef CApath
#undef CAfile
#undef CRLfile
#undef issuercert
#undef random_file
#undef egdsocket
#undef cipher_list
#undef numsessions
#undef fsslctx
#undef fsslctxp
#undef sessionid
#undef idsize
#undef age
#undef remote_port
#undef ssl_config
#undef nonce
#undef cnonce
#undef realm
#undef algo
#undef stale
#undef opaque
#undef qop
#undef algorithm
#undef nc
#undef close
#undef reuse
#undef proxy
#undef httpproxy
#undef user_passwd
#undef proxy_user_passwd
#undef ipv6_ip
#undef ipv6
#undef do_more
#undef tcpconnect
#undef protoconnstart
#undef retry2
#undef tunnel_proxy
#undef tunnel_connecting
#undef authneg
#undef rewindaftersend
#undef ftp_use_epsv
#undef ftp_use_eprt
#undef netrc
#undef userpwd_in_url
#undef done
#undef stream_was_rewound
#undef proxy_connect_closed
#undef bound
#undef type_set
#undef rawalloc
#undef encalloc
#undef dispname
#undef maxdownload
#undef writebytecountp
#undef bytecount
#undef headerbytecount
#undef deductheadercount
#undef start
#undef now
#undef header
#undef badheader
#undef headerline
#undef hbufp
#undef hbuflen
#undef str
#undef str_start
#undef end_ptr
#undef p
#undef content_range
#undef httpcode
#undef start100
#undef exp100
#undef content_encoding
#undef timeofdoc
#undef bodywrites
#undef buf
#undef uploadbuf
#undef maxfd
#undef keepon
#undef upload_done
#undef ignorebody
#undef ignorecl
#undef location
#undef newurl
#undef upload_present
#undef upload_fromhere
#undef chunk
#undef upload_chunky
#undef getheader
#undef forbidchunk
#undef scheme
#undef setup_connection
#undef do_it
#undef connect_it
#undef connecting
#undef doing
#undef proto_getsock
#undef doing_getsock
#undef perform_getsock
#undef disconnect
#undef defport
#undef proxyuserpwd
#undef uagent
#undef accept_encoding
#undef userpwd
#undef rangeline
#undef ref
#undef host
#undef cookiehost
#undef rtsp_transport
#undef ftpc
#undef sshc
#undef tftpc
#undef imapc
#undef pop3c
#undef smtpc
#undef rtspc
#undef generic
#undef connectindex
#undef dns_entry
#undef ip_addr
#undef ip_addr_str
#undef scope
#undef port
#undef proxyuser
#undef proxypasswd
#undef proxytype
#undef httpversion
#undef rtspversion
#undef created
#undef sock
#undef recv
#undef send
#undef ssl
#undef bits
#undef handler
#undef sockfd
#undef writesockfd
#undef allocptr
#undef sec_complete
#undef readchannel_inuse
#undef writechannel_inuse
#undef server_supports_pipelining
#undef send_pipe
#undef recv_pipe
#undef pend_pipe
#undef done_pipe
#undef master_buffer
#undef read_pos
#undef buf_len
#undef seek_func
#undef seek_client
#undef ntlm
#undef proxyntlm
#undef syserr_buf
#undef trailer
#undef trlMax
#undef trlPos
#undef proto
#undef cselect_bits
#undef waitfor
#undef httpproxycode
#undef filetime
#undef timecond
#undef header_size
#undef request_size
#undef proxyauthavail
#undef httpauthavail
#undef numconnects
#undef wouldredirect
#undef ip
#undef localip
#undef localport
#undef certs
#undef lastshow
#undef size_dl
#undef size_ul
#undef downloaded
#undef uploaded
#undef current_speed
#undef callback
#undef width
#undef timespent
#undef dlspeed
#undef ulspeed
#undef t_nslookup
#undef t_connect
#undef t_appconnect
#undef t_pretransfer
#undef t_starttransfer
#undef t_redirect
#undef t_startsingle
#undef speeder
#undef speeder_time
#undef speeder_c
#undef want
#undef picked
#undef avail
#undef multi
#undef iestyle
#undef connects
#undef num
#undef http
#undef https
#undef rtsp
#undef ftp
#undef telnet
#undef ssh
#undef imap
#undef pop3
#undef smtp
#undef used_interface
#undef connc
#undef keeps_speed
#undef lastconnect
#undef headerbuff
#undef headersize
#undef uploadbuffer
#undef this_is_a_follow
#undef first_host
#undef session
#undef sessionage
#undef tempwrite
#undef tempwritesize
#undef tempwritetype
#undef scratch
#undef errorbuf
#undef os_errno
#undef prev_signal
#undef allow_port
#undef digest
#undef proxydigest
#undef authhost
#undef authproxy
#undef authproblem
#undef expiretime
#undef timenode
#undef timeoutlist
#undef most_recent_ftp_entrypath
#undef ftp_trying_alternative
#undef expect100header
#undef pipe_broke
#undef prev_block_had_trailing_cr
#undef crlf_conversions
#undef shared_conn
#undef closed
#undef pathbuffer
#undef slash_removed
#undef use_range
#undef rangestringalloc
#undef range
#undef resume_from
#undef rtsp_next_client_CSeq
#undef rtsp_next_server_CSeq
#undef rtsp_CSeq_recv
#undef current_conn
#undef ssl_connect_retry
#undef url
#undef url_alloc
#undef referer
#undef referer_alloc
#undef cookielist
#undef err
#undef debugdata
#undef errorbuffer
#undef proxyport
#undef out2
#undef in
#undef writeheader
#undef rtp_out
#undef use_port
#undef httpauth
#undef proxyauth
#undef followlocation
#undef maxredirs
#undef post301
#undef post302
#undef free_referer
#undef postfields
#undef postfieldsize
#undef localportrange
#undef fwrite_func
#undef fwrite_header
#undef fwrite_rtp
#undef is_fread_set
#undef is_fwrite_set
#undef fprogress
#undef fdebug
#undef ioctl_func
#undef fsockopt
#undef sockopt_client
#undef fopensocket
#undef opensocket_client
#undef convfromnetwork
#undef convtonetwork
#undef convfromutf8
#undef progress_client
#undef ioctl_client
#undef timeout
#undef connecttimeout
#undef server_response_timeout
#undef tftp_blksize
#undef infilesize
#undef low_speed_limit
#undef low_speed_time
#undef max_send_speed
#undef max_recv_speed
#undef set_resume_from
#undef headers
#undef httppost
#undef cookiesession
#undef crlf
#undef quote
#undef postquote
#undef prequote
#undef source_quote
#undef source_prequote
#undef source_postquote
#undef telnet_options
#undef timecondition
#undef timevalue
#undef httpreq
#undef dns_cache_timeout
#undef buffer_size
#undef private_data
#undef one_easy
#undef http200aliases
#undef ip_version
#undef max_filesize
#undef ftp_filemethod
#undef ftp_create_missing_dirs
#undef ssh_keyfunc
#undef ssh_keyfunc_userp
#undef printhost
#undef get_filetime
#undef tunnel_thru_httpproxy
#undef prefer_ascii
#undef ftp_append
#undef ftp_list_only
#undef ftp_use_port
#undef hide_progress
#undef http_fail_on_error
#undef http_follow_location
#undef http_disable_hostname_check_before_authentication
#undef include_header
#undef http_set_referer
#undef http_auto_referer
#undef opt_no_body
#undef set_port
#undef upload
#undef use_netrc
#undef verbose
#undef krb
#undef reuse_forbid
#undef reuse_fresh
#undef ftp_use_pret
#undef ftp_ssl
#undef ftpsslauth
#undef ftp_ccc
#undef no_signal
#undef global_dns_cache
#undef tcp_nodelay
#undef ftp_skip_ip
#undef connect_only
#undef ssh_auth_types
#undef http_te_skip
#undef http_ce_skip
#undef new_file_perms
#undef new_directory_perms
#undef proxy_transfer_mode
#undef allowed_protocols
#undef redir_protocols
#undef mail_rcpt
#undef rtspreq
#undef wildcardmatch
#undef chunk_bgn
#undef chunk_end
#undef fnmatch
#undef fnmatch_data
#undef hostcache
#undef hostcachetype
#undef dns
#undef multi_pos
#undef share
#undef req
#undef set
#undef change
#undef progress
#undef wildcard
#undef info
#undef magic
#undef tz_minuteswest
#undef tz_dsttime
#undef val
#undef s_addr
#undef u6_addr8
#undef u6_addr16
#undef u6_addr32
#undef in6_u
#undef sin_family
#undef sin_port
#undef sin_addr
#undef sin_zero
#undef sin6_family
#undef sin6_port
#undef sin6_flowinfo
#undef sin6_addr
#undef sin6_scope_id
#undef sival_int
#undef sival_ptr
#undef si_pid
#undef si_uid
#undef si_tid
#undef si_overrun
#undef si_sigval
#undef si_status
#undef si_utime
#undef si_stime
#undef si_addr
#undef si_band
#undef si_fd
#undef pad
#undef kill
#undef timer
#undef rt
#undef sigchld
#undef sigfault
#undef sigpoll
#undef si_signo
#undef si_errno
#undef si_code
#undef sifields
#undef sa_handler
#undef sa_sigaction
#undef sigaction_handler
#undef sa_mask
#undef sa_flags
#undef sa_restorer
#undef specifier
#undef dirty
#undef lockfunc
#undef unlockfunc
#undef clientdata
#undef cache_timeout
#undef option
#undef name_alloc
#undef value_alloc
#undef contenttype_alloc
#undef showfilename_alloc
#undef extension
#undef size_max
#undef size_used
#undef ss_family
#undef ss_align
#undef ss_padding
#undef time
#undef perm
#undef group
#undef target
#undef filetype
#undef uid
#undef gid
#undef hardlinks
#undef strings
#undef b_data
#undef b_size
#undef b_used
#undef write_function
#undef file_descriptor
#undef parser
#undef ifu_broadaddr
#undef ifu_dstaddr
#undef ifa_next
#undef ifa_name
#undef ifa_flags
#undef ifa_addr
#undef ifa_netmask
#undef ifa_ifu
#undef ifa_data
#undef version_num
#undef features
#undef ssl_version
#undef ssl_version_num
#undef libz_version
#undef protocols
#undef ares
#undef ares_num
#undef libidn
#undef iconv_ver_num
#undef libssh_version
#undef as_signed
#undef as_unsigned
#undef dnum
#undef precision
#undef max
#undef alloc
#undef fail
#undef events
#undef revents
#undef please_negotiate
#undef already_negotiated
#undef us
#undef usq
#undef us_preferred
#undef him
#undef himq
#undef him_preferred
#undef subopt_ttype
#undef subopt_xdisploc
#undef telnet_vars
#undef subbuffer
#undef subpointer
#undef subend
#undef telrcv_state
#undef pw_name
#undef pw_passwd
#undef pw_uid
#undef pw_gid
#undef pw_gecos
#undef pw_dir
#undef pw_shell
#undef to_certinfo
#undef to_slist
#undef sig
#undef uns
#undef total_dirsize
#undef hlinks
#undef symlink
#undef dirorsize
#undef main
#undef sub
#undef UNIX
#undef NT
#undef symlink_target
#undef os_type
#undef error
#undef file_data
#undef item_length
#undef item_offset
#undef offsets
#undef sun_family
#undef sun_path
#undef buff
#undef sa_ex_u
#undef key_len
#undef fds_bits
#undef whatever
#undef result2
#undef msg
#undef easy_handle
#undef extmsg
#undef easy_conn
#undef sockets
#undef numsocks
#undef easy
#undef num_easy
#undef num_alive
#undef msglist
#undef socket_cb
#undef socket_userp
#undef timetree
#undef sockhash
#undef pipelining_enabled
#undef maxconnects
#undef closure
#undef timer_cb
#undef timer_userp
#undef timer_lastcall
#undef action
#undef socket
#undef socketp
#undef hmac_hinit
#undef hmac_hupdate
#undef hmac_hfinal
#undef hmac_ctxtsize
#undef hmac_maxkeylen
#undef hmac_resultlen
#undef count
#undef h_name
#undef h_aliases
#undef h_addrtype
#undef h_length
#undef h_addr_list
#undef event
#undef retries
#undef retry_time
#undef retry_max
#undef start_time
#undef max_time
#undef rx_time
#undef block
#undef local_addr
#undef remote_addr
#undef remote_addrlen
#undef rbytes
#undef sbytes
#undef blksize
#undef requested_blksize
#undef rpacket
#undef spacket
#undef ina4
#undef ina6
#undef hostentry
#undef addrentry
#undef hmac_hash
#undef hmac_hashctxt1
#undef hmac_hashctxt2
#undef fclose
#undef __stream
#undef fopen
#undef __filename
#undef __modes
#undef fwrite
#undef __ptr
#undef __size
#undef __n
#undef __s
#undef stream
#undef strtoll
#undef __nptr
#undef __endptr
#undef __base
#undef strchr
#undef __c
#undef ctype_b_loc
#undef fstat
#undef __fd
#undef __buf
#undef gmtime_r
#undef __timer
#undef __tp
#undef lseek
#undef __offset
#undef __whence
#undef read
#undef __nbytes
#undef open
#undef __file
#undef __oflag
#undef gettimeofday
#undef __tv
#undef __tz
#undef clock_gettime
#undef __clock_id
#undef strlen
#undef inet_ntop
#undef __af
#undef __cp
#undef __len
#undef alarm
#undef __seconds
#undef sigaction
#undef __sig
#undef __act
#undef __oact
#undef fflush
#undef strcpy
#undef __dest
#undef __src
#undef fread
#undef memcpy
#undef stat
#undef xpg_basename
#undef __path
#undef sscanf
#undef __format
#undef fgets
#undef fputs
#undef atoi
#undef qsort
#undef __nmemb
#undef __compar
#undef strcmp
#undef __s1
#undef __s2
#undef strncmp
#undef strrchr
#undef strtok_r
#undef __delim
#undef __save_ptr
#undef memchr
#undef strstr
#undef __haystack
#undef __needle
#undef __flags
#undef errno_location
#undef memmove
#undef memcmp
#undef __domain
#undef __type
#undef __protocol
#undef bind
#undef __addr
#undef getsockname
#undef listen
#undef accept
#undef __addr_len
#undef strtoul
#undef memset
#undef strncpy
#undef strcat
#undef ntohs
#undef __netshort
#undef htons
#undef __hostshort
#undef inet_pton
#undef tolower
#undef malloc
#undef free
#undef getifaddrs
#undef __ifap
#undef freeifaddrs
#undef __ifa
#undef getenv
#undef __name
#undef sprintf
#undef fputc
#undef strtol
#undef geteuid
#undef getpwuid
#undef __uid
#undef fseek
#undef __off
#undef strcasecmp
#undef strncasecmp
#undef calloc
#undef realloc
#undef strdup
#undef connect
#undef getpeername
#undef getsockopt
#undef __level
#undef __optname
#undef __optval
#undef __optlen
#undef setsockopt
#undef strerror_r
#undef __errnum
#undef __buflen
#undef poll
#undef __fds
#undef __nfds
#undef __timeout
#undef sendto
#undef recvfrom
#undef getaddrinfo
#undef __service
#undef __req
#undef __pai
#undef freeaddrinfo
#undef __ai
#undef fcntl
#undef __cmd
#undef gethostname

enum PC_CURLSOCKTYPE {
	CURLSOCKTYPE_IPCXN = 0,
	CURLSOCKTYPE_LAST = 1
};
enum PC_CURLIOERR {
	CURLIOE_OK = 0,
	CURLIOE_UNKNOWNCMD = 1,
	CURLIOE_FAILRESTART = 2,
	CURLIOE_LAST = 3
};
enum PC_CURL_INFOTYPE {
	CURLINFO_TEXT = 0,
	CURLINFO_HEADER_IN = 1,
	CURLINFO_HEADER_OUT = 2,
	CURLINFO_DATA_IN = 3,
	CURLINFO_DATA_OUT = 4,
	CURLINFO_SSL_DATA_IN = 5,
	CURLINFO_SSL_DATA_OUT = 6,
	CURLINFO_END = 7
};
enum PC_CURLCODE {
	CURLE_OK = 0,
	CURLE_UNSUPPORTED_PROTOCOL = 1,
	CURLE_FAILED_INIT = 2,
	CURLE_URL_MALFORMAT = 3,
	CURLE_OBSOLETE4 = 4,
	CURLE_COULDNT_RESOLVE_PROXY = 5,
	CURLE_COULDNT_RESOLVE_HOST = 6,
	CURLE_COULDNT_CONNECT = 7,
	CURLE_FTP_WEIRD_SERVER_REPLY = 8,
	CURLE_REMOTE_ACCESS_DENIED = 9,
	CURLE_OBSOLETE10 = 10,
	CURLE_FTP_WEIRD_PASS_REPLY = 11,
	CURLE_OBSOLETE12 = 12,
	CURLE_FTP_WEIRD_PASV_REPLY = 13,
	CURLE_FTP_WEIRD_227_FORMAT = 14,
	CURLE_FTP_CANT_GET_HOST = 15,
	CURLE_OBSOLETE16 = 16,
	CURLE_FTP_COULDNT_SET_TYPE = 17,
	CURLE_PARTIAL_FILE = 18,
	CURLE_FTP_COULDNT_RETR_FILE = 19,
	CURLE_OBSOLETE20 = 20,
	CURLE_QUOTE_ERROR = 21,
	CURLE_HTTP_RETURNED_ERROR = 22,
	CURLE_WRITE_ERROR = 23,
	CURLE_OBSOLETE24 = 24,
	CURLE_UPLOAD_FAILED = 25,
	CURLE_READ_ERROR = 26,
	CURLE_OUT_OF_MEMORY = 27,
	CURLE_OPERATION_TIMEDOUT = 28,
	CURLE_OBSOLETE29 = 29,
	CURLE_FTP_PORT_FAILED = 30,
	CURLE_FTP_COULDNT_USE_REST = 31,
	CURLE_OBSOLETE32 = 32,
	CURLE_RANGE_ERROR = 33,
	CURLE_HTTP_POST_ERROR = 34,
	CURLE_SSL_CONNECT_ERROR = 35,
	CURLE_BAD_DOWNLOAD_RESUME = 36,
	CURLE_FILE_COULDNT_READ_FILE = 37,
	CURLE_LDAP_CANNOT_BIND = 38,
	CURLE_LDAP_SEARCH_FAILED = 39,
	CURLE_OBSOLETE40 = 40,
	CURLE_FUNCTION_NOT_FOUND = 41,
	CURLE_ABORTED_BY_CALLBACK = 42,
	CURLE_BAD_FUNCTION_ARGUMENT = 43,
	CURLE_OBSOLETE44 = 44,
	CURLE_INTERFACE_FAILED = 45,
	CURLE_OBSOLETE46 = 46,
	CURLE_TOO_MANY_REDIRECTS = 47,
	CURLE_UNKNOWN_TELNET_OPTION = 48,
	CURLE_TELNET_OPTION_SYNTAX = 49,
	CURLE_OBSOLETE50 = 50,
	CURLE_PEER_FAILED_VERIFICATION = 51,
	CURLE_GOT_NOTHING = 52,
	CURLE_SSL_ENGINE_NOTFOUND = 53,
	CURLE_SSL_ENGINE_SETFAILED = 54,
	CURLE_SEND_ERROR = 55,
	CURLE_RECV_ERROR = 56,
	CURLE_OBSOLETE57 = 57,
	CURLE_SSL_CERTPROBLEM = 58,
	CURLE_SSL_CIPHER = 59,
	CURLE_SSL_CACERT = 60,
	CURLE_BAD_CONTENT_ENCODING = 61,
	CURLE_LDAP_INVALID_URL = 62,
	CURLE_FILESIZE_EXCEEDED = 63,
	CURLE_USE_SSL_FAILED = 64,
	CURLE_SEND_FAIL_REWIND = 65,
	CURLE_SSL_ENGINE_INITFAILED = 66,
	CURLE_LOGIN_DENIED = 67,
	CURLE_TFTP_NOTFOUND = 68,
	CURLE_TFTP_PERM = 69,
	CURLE_REMOTE_DISK_FULL = 70,
	CURLE_TFTP_ILLEGAL = 71,
	CURLE_TFTP_UNKNOWNID = 72,
	CURLE_REMOTE_FILE_EXISTS = 73,
	CURLE_TFTP_NOSUCHUSER = 74,
	CURLE_CONV_FAILED = 75,
	CURLE_CONV_REQD = 76,
	CURLE_SSL_CACERT_BADFILE = 77,
	CURLE_REMOTE_FILE_NOT_FOUND = 78,
	CURLE_SSH = 79,
	CURLE_SSL_SHUTDOWN_FAILED = 80,
	CURLE_AGAIN = 81,
	CURLE_SSL_CRL_BADFILE = 82,
	CURLE_SSL_ISSUER_ERROR = 83,
	CURLE_FTP_PRET_FAILED = 84,
	CURLE_RTSP_CSEQ_ERROR = 85,
	CURLE_RTSP_SESSION_ERROR = 86,
	CURLE_FTP_BAD_FILE_LIST = 87,
	CURLE_CHUNK_FAILED = 88,
	CURL_LAST = 89
};
enum PC_CURL_PROXYTYPE {
	CURLPROXY_HTTP = 0,
	CURLPROXY_HTTP_1_0 = 1,
	CURLPROXY_SOCKS4 = 4,
	CURLPROXY_SOCKS5 = 5,
	CURLPROXY_SOCKS4A = 6,
	CURLPROXY_SOCKS5_HOSTNAME = 7
};
enum PC_TYPE {
	CURLKHTYPE_UNKNOWN = 0,
	CURLKHTYPE_RSA1 = 1,
	CURLKHTYPE_RSA = 2,
	CURLKHTYPE_DSS = 3
};
enum PC_CURL_KHMATCH {
	CURLKHMATCH_OK = 0,
	CURLKHMATCH_MISMATCH = 1,
	CURLKHMATCH_MISSING = 2,
	CURLKHMATCH_LAST = 3
};
enum PC_CURL_USESSL {
	CURLUSESSL_NONE = 0,
	CURLUSESSL_TRY = 1,
	CURLUSESSL_CONTROL = 2,
	CURLUSESSL_ALL = 3,
	CURLUSESSL_LAST = 4
};
enum PC_CURL_FTPCCC {
	CURLFTPSSL_CCC_NONE = 0,
	CURLFTPSSL_CCC_PASSIVE = 1,
	CURLFTPSSL_CCC_ACTIVE = 2,
	CURLFTPSSL_CCC_LAST = 3
};
enum PC_CURL_FTPAUTH {
	CURLFTPAUTH_DEFAULT = 0,
	CURLFTPAUTH_SSL = 1,
	CURLFTPAUTH_TLS = 2,
	CURLFTPAUTH_LAST = 3
};
enum PC_CURL_NETRC_OPTION {
	CURL_NETRC_IGNORED = 0,
	CURL_NETRC_OPTIONAL = 1,
	CURL_NETRC_REQUIRED = 2,
	CURL_NETRC_LAST = 3
};
enum PC_CURL_TIMECOND {
	CURL_TIMECOND_NONE = 0,
	CURL_TIMECOND_IFMODSINCE = 1,
	CURL_TIMECOND_IFUNMODSINCE = 2,
	CURL_TIMECOND_LASTMOD = 3,
	CURL_TIMECOND_LAST = 4
};
enum PC_FORMTYPE {
	FORM_DATA = 0,
	FORM_CONTENT = 1,
	FORM_CALLBACK = 2,
	FORM_FILE = 3
};
enum PC_CHUNKYSTATE {
	CHUNK_FIRST = 0,
	CHUNK_HEX = 1,
	CHUNK_POSTHEX = 2,
	CHUNK_CR = 3,
	CHUNK_DATA = 4,
	CHUNK_POSTCR = 5,
	CHUNK_POSTLF = 6,
	CHUNK_STOPCR = 7,
	CHUNK_STOP = 8,
	CHUNK_TRAILER = 9,
	CHUNK_TRAILER_CR = 10,
	CHUNK_TRAILER_POSTCR = 11,
	CHUNK_LAST = 12
};
enum PC_IMAPSTATE {
	IMAP_STOP = 0,
	IMAP_SERVERGREET = 1,
	IMAP_LOGIN = 2,
	IMAP_STARTTLS = 3,
	IMAP_SELECT = 4,
	IMAP_FETCH = 5,
	IMAP_LOGOUT = 6,
	IMAP_LAST = 7
};
enum PC_POP3STATE {
	POP3_STOP = 0,
	POP3_SERVERGREET = 1,
	POP3_USER = 2,
	POP3_PASS = 3,
	POP3_STARTTLS = 4,
	POP3_LIST = 5,
	POP3_RETR = 6,
	POP3_QUIT = 7,
	POP3_LAST = 8
};
enum PC_SMTPSTATE {
	SMTP_STOP = 0,
	SMTP_SERVERGREET = 1,
	SMTP_EHLO = 2,
	SMTP_HELO = 3,
	SMTP_STARTTLS = 4,
	SMTP_AUTHPLAIN = 5,
	SMTP_AUTHLOGIN = 6,
	SMTP_AUTHPASSWD = 7,
	SMTP_AUTHCRAM = 8,
	SMTP_AUTH = 9,
	SMTP_MAIL = 10,
	SMTP_RCPT = 11,
	SMTP_DATA = 12,
	SMTP_POSTDATA = 13,
	SMTP_QUIT = 14,
	SMTP_LAST = 15
};
enum PC_FTPSTATE {
	FTP_STOP = 0,
	FTP_WAIT220 = 1,
	FTP_AUTH = 2,
	FTP_USER = 3,
	FTP_PASS = 4,
	FTP_ACCT = 5,
	FTP_PBSZ = 6,
	FTP_PROT = 7,
	FTP_CCC = 8,
	FTP_PWD = 9,
	FTP_SYST = 10,
	FTP_NAMEFMT = 11,
	FTP_QUOTE = 12,
	FTP_RETR_PREQUOTE = 13,
	FTP_STOR_PREQUOTE = 14,
	FTP_POSTQUOTE = 15,
	FTP_CWD = 16,
	FTP_MKD = 17,
	FTP_MDTM = 18,
	FTP_TYPE = 19,
	FTP_LIST_TYPE = 20,
	FTP_RETR_TYPE = 21,
	FTP_STOR_TYPE = 22,
	FTP_SIZE = 23,
	FTP_RETR_SIZE = 24,
	FTP_STOR_SIZE = 25,
	FTP_REST = 26,
	FTP_RETR_REST = 27,
	FTP_PORT = 28,
	FTP_PRET = 29,
	FTP_PASV = 30,
	FTP_LIST = 31,
	FTP_RETR = 32,
	FTP_STOR = 33,
	FTP_QUIT = 34,
	FTP_LAST = 35
};
enum PC_CURL_FTPFILE {
	FTPFILE_MULTICWD = 1,
	FTPFILE_NOCWD = 2,
	FTPFILE_SINGLECWD = 3
};
enum PC_CURL_FTPTRANSFER {
	FTPTRANSFER_BODY = 0,
	FTPTRANSFER_INFO = 1,
	FTPTRANSFER_NONE = 2,
	FTPTRANSFER_LAST = 3
};
enum PC_SENDING {
	HTTPSEND_NADA = 0,
	HTTPSEND_REQUEST = 1,
	HTTPSEND_BODY = 2,
	HTTPSEND_LAST = 3
};
enum PC_CURL_WILDCARD_STATES {
	CURLWC_INIT = 0,
	CURLWC_MATCHING = 1,
	CURLWC_DOWNLOADING = 2,
	CURLWC_CLEAN = 3,
	CURLWC_SKIP = 4,
	CURLWC_ERROR = 5,
	CURLWC_DONE = 6
};
enum PC_SSL_CONNECTION_STATE {
	ssl_connection_none = 0,
	ssl_connection_negotiating = 1,
	ssl_connection_complete = 2
};
enum PC_CURLNTLM {
	NTLMSTATE_NONE = 0,
	NTLMSTATE_TYPE1 = 1,
	NTLMSTATE_TYPE2 = 2,
	NTLMSTATE_TYPE3 = 3,
	NTLMSTATE_LAST = 4
};
enum PC_EXPECT100 {
	EXP100_SEND_DATA = 0,
	EXP100_AWAITING_CONTINUE = 1,
	EXP100_SENDING_REQUEST = 2,
	EXP100_FAILED = 3
};
enum PC_BADHEADER {
	HEADER_NORMAL = 0,
	HEADER_PARTHEADER = 1,
	HEADER_ALLBAD = 2
};
enum PC_CURL_HTTPREQ {
	HTTPREQ_NONE = 0,
	HTTPREQ_GET = 1,
	HTTPREQ_POST = 2,
	HTTPREQ_POST_FORM = 3,
	HTTPREQ_PUT = 4,
	HTTPREQ_HEAD = 5,
	HTTPREQ_CUSTOM = 6,
	HTTPREQ_LAST = 7
};
enum PC_CURL_RTSPREQ {
	RTSPREQ_NONE = 0,
	RTSPREQ_OPTIONS = 1,
	RTSPREQ_DESCRIBE = 2,
	RTSPREQ_ANNOUNCE = 3,
	RTSPREQ_SETUP = 4,
	RTSPREQ_PLAY = 5,
	RTSPREQ_PAUSE = 6,
	RTSPREQ_TEARDOWN = 7,
	RTSPREQ_GET_PARAMETER = 8,
	RTSPREQ_SET_PARAMETER = 9,
	RTSPREQ_RECORD = 10,
	RTSPREQ_RECEIVE = 11,
	RTSPREQ_LAST = 12
};
enum PC_TYPE2 {
	CONNCACHE_PRIVATE = 0,
	CONNCACHE_MULTI = 1
};
enum PC_USED_INTERFACE {
	Curl_if_none = 0,
	Curl_if_easy = 1,
	Curl_if_multi = 2
};
enum PC_HOSTCACHETYPE {
	HCACHE_NONE = 0,
	HCACHE_PRIVATE = 1,
	HCACHE_GLOBAL = 2,
	HCACHE_MULTI = 3,
	HCACHE_SHARED = 4
};
enum PC_TIMERID {
	TIMER_NONE = 0,
	TIMER_NAMELOOKUP = 1,
	TIMER_CONNECT = 2,
	TIMER_APPCONNECT = 3,
	TIMER_PRETRANSFER = 4,
	TIMER_STARTTRANSFER = 5,
	TIMER_POSTRANSFER = 6,
	TIMER_STARTSINGLE = 7,
	TIMER_REDIRECT = 8,
	TIMER_LAST = 9
};
enum PC_CURL_LOCK_DATA {
	CURL_LOCK_DATA_NONE = 0,
	CURL_LOCK_DATA_SHARE = 1,
	CURL_LOCK_DATA_COOKIE = 2,
	CURL_LOCK_DATA_DNS = 3,
	CURL_LOCK_DATA_SSL_SESSION = 4,
	CURL_LOCK_DATA_CONNECT = 5,
	CURL_LOCK_DATA_LAST = 6
};
enum PC_CURL_LOCK_ACCESS {
	CURL_LOCK_ACCESS_NONE = 0,
	CURL_LOCK_ACCESS_SHARED = 1,
	CURL_LOCK_ACCESS_SINGLE = 2,
	CURL_LOCK_ACCESS_LAST = 3
};
enum PC_CURLSHCODE {
	CURLSHE_OK = 0,
	CURLSHE_BAD_OPTION = 1,
	CURLSHE_IN_USE = 2,
	CURLSHE_INVALID = 3,
	CURLSHE_NOMEM = 4,
	CURLSHE_LAST = 5
};
enum PC_CURLFORMOPTION {
	CURLFORM_NOTHING = 0,
	CURLFORM_COPYNAME = 1,
	CURLFORM_PTRNAME = 2,
	CURLFORM_NAMELENGTH = 3,
	CURLFORM_COPYCONTENTS = 4,
	CURLFORM_PTRCONTENTS = 5,
	CURLFORM_CONTENTSLENGTH = 6,
	CURLFORM_FILECONTENT = 7,
	CURLFORM_ARRAY = 8,
	CURLFORM_OBSOLETE = 9,
	CURLFORM_FILE = 10,
	CURLFORM_BUFFER = 11,
	CURLFORM_BUFFERPTR = 12,
	CURLFORM_BUFFERLENGTH = 13,
	CURLFORM_CONTENTTYPE = 14,
	CURLFORM_CONTENTHEADER = 15,
	CURLFORM_FILENAME = 16,
	CURLFORM_END = 17,
	CURLFORM_OBSOLETE2 = 18,
	CURLFORM_STREAM = 19,
	CURLFORM_LASTENTRY = 20
};
enum PC_CURLFORMCODE {
	CURL_FORMADD_OK = 0,
	CURL_FORMADD_MEMORY = 1,
	CURL_FORMADD_OPTION_TWICE = 2,
	CURL_FORMADD_NULL = 3,
	CURL_FORMADD_UNKNOWN_OPTION = 4,
	CURL_FORMADD_INCOMPLETE = 5,
	CURL_FORMADD_ILLEGAL_ARRAY = 6,
	CURL_FORMADD_DISABLED = 7,
	CURL_FORMADD_LAST = 8
};
enum PC_CHUNKCODE {
	CHUNKE_STOP = -1,
	CHUNKE_OK = 0,
	CHUNKE_TOO_LONG_HEX = 1,
	CHUNKE_ILLEGAL_HEX = 2,
	CHUNKE_BAD_CHUNK = 3,
	CHUNKE_WRITE_ERROR = 4,
	CHUNKE_STATE_ERROR = 5,
	CHUNKE_BAD_ENCODING = 6,
	CHUNKE_OUT_OF_MEMORY = 7,
	CHUNKE_LAST = 8
};
enum PC_CURLDIGEST {
	CURLDIGEST_NONE = 0,
	CURLDIGEST_BAD = 1,
	CURLDIGEST_BADALGO = 2,
	CURLDIGEST_NOMEM = 3,
	CURLDIGEST_FINE = 4,
	CURLDIGEST_LAST = 5
};
enum PC_CURLFILETYPE {
	CURLFILETYPE_FILE = 0,
	CURLFILETYPE_DIRECTORY = 1,
	CURLFILETYPE_SYMLINK = 2,
	CURLFILETYPE_DEVICE_BLOCK = 3,
	CURLFILETYPE_DEVICE_CHAR = 4,
	CURLFILETYPE_NAMEDPIPE = 5,
	CURLFILETYPE_SOCKET = 6,
	CURLFILETYPE_DOOR = 7,
	CURLFILETYPE_UNKNOWN = 8
};
enum PC_FTPPORT {
	EPRT = 0,
	PORT = 1,
	DONE = 2
};
enum PC_CURLOPTION {
	CURLOPT_FILE = 10001,
	CURLOPT_URL = 10002,
	CURLOPT_PORT = 3,
	CURLOPT_PROXY = 10004,
	CURLOPT_USERPWD = 10005,
	CURLOPT_PROXYUSERPWD = 10006,
	CURLOPT_RANGE = 10007,
	CURLOPT_INFILE = 10009,
	CURLOPT_ERRORBUFFER = 10010,
	CURLOPT_WRITEFUNCTION = 20011,
	CURLOPT_READFUNCTION = 20012,
	CURLOPT_TIMEOUT = 13,
	CURLOPT_INFILESIZE = 14,
	CURLOPT_POSTFIELDS = 10015,
	CURLOPT_REFERER = 10016,
	CURLOPT_FTPPORT = 10017,
	CURLOPT_USERAGENT = 10018,
	CURLOPT_LOW_SPEED_LIMIT = 19,
	CURLOPT_LOW_SPEED_TIME = 20,
	CURLOPT_RESUME_FROM = 21,
	CURLOPT_COOKIE = 10022,
	CURLOPT_HTTPHEADER = 10023,
	CURLOPT_HTTPPOST = 10024,
	CURLOPT_SSLCERT = 10025,
	CURLOPT_KEYPASSWD = 10026,
	CURLOPT_CRLF = 27,
	CURLOPT_QUOTE = 10028,
	CURLOPT_WRITEHEADER = 10029,
	CURLOPT_COOKIEFILE = 10031,
	CURLOPT_SSLVERSION = 32,
	CURLOPT_TIMECONDITION = 33,
	CURLOPT_TIMEVALUE = 34,
	CURLOPT_CUSTOMREQUEST = 10036,
	CURLOPT_STDERR = 10037,
	CURLOPT_POSTQUOTE = 10039,
	CURLOPT_WRITEINFO = 10040,
	CURLOPT_VERBOSE = 41,
	CURLOPT_HEADER = 42,
	CURLOPT_NOPROGRESS = 43,
	CURLOPT_NOBODY = 44,
	CURLOPT_FAILONERROR = 45,
	CURLOPT_UPLOAD = 46,
	CURLOPT_POST = 47,
	CURLOPT_DIRLISTONLY = 48,
	CURLOPT_APPEND = 50,
	CURLOPT_NETRC = 51,
	CURLOPT_FOLLOWLOCATION = 52,
	CURLOPT_TRANSFERTEXT = 53,
	CURLOPT_PUT = 54,
	CURLOPT_PROGRESSFUNCTION = 20056,
	CURLOPT_PROGRESSDATA = 10057,
	CURLOPT_AUTOREFERER = 58,
	CURLOPT_PROXYPORT = 59,
	CURLOPT_POSTFIELDSIZE = 60,
	CURLOPT_HTTPPROXYTUNNEL = 61,
	CURLOPT_INTERFACE = 10062,
	CURLOPT_KRBLEVEL = 10063,
	CURLOPT_SSL_VERIFYPEER = 64,
	CURLOPT_CAINFO = 10065,
	CURLOPT_MAXREDIRS = 68,
	CURLOPT_FILETIME = 69,
	CURLOPT_TELNETOPTIONS = 10070,
	CURLOPT_MAXCONNECTS = 71,
	CURLOPT_CLOSEPOLICY = 72,
	CURLOPT_FRESH_CONNECT = 74,
	CURLOPT_FORBID_REUSE = 75,
	CURLOPT_RANDOM_FILE = 10076,
	CURLOPT_EGDSOCKET = 10077,
	CURLOPT_CONNECTTIMEOUT = 78,
	CURLOPT_HEADERFUNCTION = 20079,
	CURLOPT_HTTPGET = 80,
	CURLOPT_SSL_VERIFYHOST = 81,
	CURLOPT_COOKIEJAR = 10082,
	CURLOPT_SSL_CIPHER_LIST = 10083,
	CURLOPT_HTTP_VERSION = 84,
	CURLOPT_FTP_USE_EPSV = 85,
	CURLOPT_SSLCERTTYPE = 10086,
	CURLOPT_SSLKEY = 10087,
	CURLOPT_SSLKEYTYPE = 10088,
	CURLOPT_SSLENGINE = 10089,
	CURLOPT_SSLENGINE_DEFAULT = 90,
	CURLOPT_DNS_USE_GLOBAL_CACHE = 91,
	CURLOPT_DNS_CACHE_TIMEOUT = 92,
	CURLOPT_PREQUOTE = 10093,
	CURLOPT_DEBUGFUNCTION = 20094,
	CURLOPT_DEBUGDATA = 10095,
	CURLOPT_COOKIESESSION = 96,
	CURLOPT_CAPATH = 10097,
	CURLOPT_BUFFERSIZE = 98,
	CURLOPT_NOSIGNAL = 99,
	CURLOPT_SHARE = 10100,
	CURLOPT_PROXYTYPE = 101,
	CURLOPT_ENCODING = 10102,
	CURLOPT_PRIVATE = 10103,
	CURLOPT_HTTP200ALIASES = 10104,
	CURLOPT_UNRESTRICTED_AUTH = 105,
	CURLOPT_FTP_USE_EPRT = 106,
	CURLOPT_HTTPAUTH = 107,
	CURLOPT_SSL_CTX_FUNCTION = 20108,
	CURLOPT_SSL_CTX_DATA = 10109,
	CURLOPT_FTP_CREATE_MISSING_DIRS = 110,
	CURLOPT_PROXYAUTH = 111,
	CURLOPT_FTP_RESPONSE_TIMEOUT = 112,
	CURLOPT_IPRESOLVE = 113,
	CURLOPT_MAXFILESIZE = 114,
	CURLOPT_INFILESIZE_LARGE = 30115,
	CURLOPT_RESUME_FROM_LARGE = 30116,
	CURLOPT_MAXFILESIZE_LARGE = 30117,
	CURLOPT_NETRC_FILE = 10118,
	CURLOPT_USE_SSL = 119,
	CURLOPT_POSTFIELDSIZE_LARGE = 30120,
	CURLOPT_TCP_NODELAY = 121,
	CURLOPT_FTPSSLAUTH = 129,
	CURLOPT_IOCTLFUNCTION = 20130,
	CURLOPT_IOCTLDATA = 10131,
	CURLOPT_FTP_ACCOUNT = 10134,
	CURLOPT_COOKIELIST = 10135,
	CURLOPT_IGNORE_CONTENT_LENGTH = 136,
	CURLOPT_FTP_SKIP_PASV_IP = 137,
	CURLOPT_FTP_FILEMETHOD = 138,
	CURLOPT_LOCALPORT = 139,
	CURLOPT_LOCALPORTRANGE = 140,
	CURLOPT_CONNECT_ONLY = 141,
	CURLOPT_CONV_FROM_NETWORK_FUNCTION = 20142,
	CURLOPT_CONV_TO_NETWORK_FUNCTION = 20143,
	CURLOPT_CONV_FROM_UTF8_FUNCTION = 20144,
	CURLOPT_MAX_SEND_SPEED_LARGE = 30145,
	CURLOPT_MAX_RECV_SPEED_LARGE = 30146,
	CURLOPT_FTP_ALTERNATIVE_TO_USER = 10147,
	CURLOPT_SOCKOPTFUNCTION = 20148,
	CURLOPT_SOCKOPTDATA = 10149,
	CURLOPT_SSL_SESSIONID_CACHE = 150,
	CURLOPT_SSH_AUTH_TYPES = 151,
	CURLOPT_SSH_PUBLIC_KEYFILE = 10152,
	CURLOPT_SSH_PRIVATE_KEYFILE = 10153,
	CURLOPT_FTP_SSL_CCC = 154,
	CURLOPT_TIMEOUT_MS = 155,
	CURLOPT_CONNECTTIMEOUT_MS = 156,
	CURLOPT_HTTP_TRANSFER_DECODING = 157,
	CURLOPT_HTTP_CONTENT_DECODING = 158,
	CURLOPT_NEW_FILE_PERMS = 159,
	CURLOPT_NEW_DIRECTORY_PERMS = 160,
	CURLOPT_POSTREDIR = 161,
	CURLOPT_SSH_HOST_PUBLIC_KEY_MD5 = 10162,
	CURLOPT_OPENSOCKETFUNCTION = 20163,
	CURLOPT_OPENSOCKETDATA = 10164,
	CURLOPT_COPYPOSTFIELDS = 10165,
	CURLOPT_PROXY_TRANSFER_MODE = 166,
	CURLOPT_SEEKFUNCTION = 20167,
	CURLOPT_SEEKDATA = 10168,
	CURLOPT_CRLFILE = 10169,
	CURLOPT_ISSUERCERT = 10170,
	CURLOPT_ADDRESS_SCOPE = 171,
	CURLOPT_CERTINFO = 172,
	CURLOPT_USERNAME = 10173,
	CURLOPT_PASSWORD = 10174,
	CURLOPT_PROXYUSERNAME = 10175,
	CURLOPT_PROXYPASSWORD = 10176,
	CURLOPT_NOPROXY = 10177,
	CURLOPT_TFTP_BLKSIZE = 178,
	CURLOPT_SOCKS5_GSSAPI_SERVICE = 10179,
	CURLOPT_SOCKS5_GSSAPI_NEC = 180,
	CURLOPT_PROTOCOLS = 181,
	CURLOPT_REDIR_PROTOCOLS = 182,
	CURLOPT_SSH_KNOWNHOSTS = 10183,
	CURLOPT_SSH_KEYFUNCTION = 20184,
	CURLOPT_SSH_KEYDATA = 10185,
	CURLOPT_MAIL_FROM = 10186,
	CURLOPT_MAIL_RCPT = 10187,
	CURLOPT_FTP_USE_PRET = 188,
	CURLOPT_RTSP_REQUEST = 189,
	CURLOPT_RTSP_SESSION_ID = 10190,
	CURLOPT_RTSP_STREAM_URI = 10191,
	CURLOPT_RTSP_TRANSPORT = 10192,
	CURLOPT_RTSP_CLIENT_CSEQ = 193,
	CURLOPT_RTSP_SERVER_CSEQ = 194,
	CURLOPT_INTERLEAVEDATA = 10195,
	CURLOPT_INTERLEAVEFUNCTION = 20196,
	CURLOPT_WILDCARDMATCH = 197,
	CURLOPT_CHUNK_BGN_FUNCTION = 20198,
	CURLOPT_CHUNK_END_FUNCTION = 20199,
	CURLOPT_FNMATCH_FUNCTION = 20200,
	CURLOPT_CHUNK_DATA = 10201,
	CURLOPT_FNMATCH_DATA = 10202,
	CURLOPT_LASTENTRY = 10203
};
enum PC_CURLMCODE {
	CURLM_CALL_MULTI_PERFORM = -1,
	CURLM_OK = 0,
	CURLM_BAD_HANDLE = 1,
	CURLM_BAD_EASY_HANDLE = 2,
	CURLM_OUT_OF_MEMORY = 3,
	CURLM_INTERNAL_ERROR = 4,
	CURLM_BAD_SOCKET = 5,
	CURLM_UNKNOWN_OPTION = 6,
	CURLM_LAST = 7
};
enum PC_DUPSTRING {
	STRING_CERT = 0,
	STRING_CERT_TYPE = 1,
	STRING_COOKIE = 2,
	STRING_COOKIEJAR = 3,
	STRING_CUSTOMREQUEST = 4,
	STRING_DEVICE = 5,
	STRING_ENCODING = 6,
	STRING_FTP_ACCOUNT = 7,
	STRING_FTP_ALTERNATIVE_TO_USER = 8,
	STRING_FTPPORT = 9,
	STRING_KEY = 10,
	STRING_KEY_PASSWD = 11,
	STRING_KEY_TYPE = 12,
	STRING_KRB_LEVEL = 13,
	STRING_NETRC_FILE = 14,
	STRING_COPYPOSTFIELDS = 15,
	STRING_PROXY = 16,
	STRING_SET_RANGE = 17,
	STRING_SET_REFERER = 18,
	STRING_SET_URL = 19,
	STRING_SSL_CAPATH = 20,
	STRING_SSL_CAFILE = 21,
	STRING_SSL_CIPHER_LIST = 22,
	STRING_SSL_EGDSOCKET = 23,
	STRING_SSL_RANDOM_FILE = 24,
	STRING_USERAGENT = 25,
	STRING_SSL_CRLFILE = 26,
	STRING_SSL_ISSUERCERT = 27,
	STRING_USERNAME = 28,
	STRING_PASSWORD = 29,
	STRING_PROXYUSERNAME = 30,
	STRING_PROXYPASSWORD = 31,
	STRING_NOPROXY = 32,
	STRING_RTSP_SESSION_ID = 33,
	STRING_RTSP_STREAM_URI = 34,
	STRING_RTSP_TRANSPORT = 35,
	STRING_MAIL_FROM = 36,
	STRING_LAST = 37
};
enum PC_CURLVERSION {
	CURLVERSION_FIRST = 0,
	CURLVERSION_SECOND = 1,
	CURLVERSION_THIRD = 2,
	CURLVERSION_FOURTH = 3,
	CURLVERSION_LAST = 4
};
enum PC_FORMATTYPE {
	FORMAT_UNKNOWN = 0,
	FORMAT_STRING = 1,
	FORMAT_PTR = 2,
	FORMAT_INT = 3,
	FORMAT_INTPTR = 4,
	FORMAT_LONG = 5,
	FORMAT_LONGLONG = 6,
	FORMAT_DOUBLE = 7,
	FORMAT_LONGDOUBLE = 8,
	FORMAT_WIDTH = 9
};
enum PC_TELNETRECEIVE {
	CURL_TS_DATA = 0,
	CURL_TS_IAC = 1,
	CURL_TS_WILL = 2,
	CURL_TS_WONT = 3,
	CURL_TS_DO = 4,
	CURL_TS_DONT = 5,
	CURL_TS_CR = 6,
	CURL_TS_SB = 7,
	CURL_TS_SE = 8
};
enum PC_CURLINFO {
	CURLINFO_NONE = 0,
	CURLINFO_EFFECTIVE_URL = 1048577,
	CURLINFO_RESPONSE_CODE = 2097154,
	CURLINFO_TOTAL_TIME = 3145731,
	CURLINFO_NAMELOOKUP_TIME = 3145732,
	CURLINFO_CONNECT_TIME = 3145733,
	CURLINFO_PRETRANSFER_TIME = 3145734,
	CURLINFO_SIZE_UPLOAD = 3145735,
	CURLINFO_SIZE_DOWNLOAD = 3145736,
	CURLINFO_SPEED_DOWNLOAD = 3145737,
	CURLINFO_SPEED_UPLOAD = 3145738,
	CURLINFO_HEADER_SIZE = 2097163,
	CURLINFO_REQUEST_SIZE = 2097164,
	CURLINFO_SSL_VERIFYRESULT = 2097165,
	CURLINFO_FILETIME = 2097166,
	CURLINFO_CONTENT_LENGTH_DOWNLOAD = 3145743,
	CURLINFO_CONTENT_LENGTH_UPLOAD = 3145744,
	CURLINFO_STARTTRANSFER_TIME = 3145745,
	CURLINFO_CONTENT_TYPE = 1048594,
	CURLINFO_REDIRECT_TIME = 3145747,
	CURLINFO_REDIRECT_COUNT = 2097172,
	CURLINFO_PRIVATE = 1048597,
	CURLINFO_HTTP_CONNECTCODE = 2097174,
	CURLINFO_HTTPAUTH_AVAIL = 2097175,
	CURLINFO_PROXYAUTH_AVAIL = 2097176,
	CURLINFO_OS_ERRNO = 2097177,
	CURLINFO_NUM_CONNECTS = 2097178,
	CURLINFO_SSL_ENGINES = 4194331,
	CURLINFO_COOKIELIST = 4194332,
	CURLINFO_LASTSOCKET = 2097181,
	CURLINFO_FTP_ENTRY_PATH = 1048606,
	CURLINFO_REDIRECT_URL = 1048607,
	CURLINFO_PRIMARY_IP = 1048608,
	CURLINFO_APPCONNECT_TIME = 3145761,
	CURLINFO_CERTINFO = 4194338,
	CURLINFO_CONDITION_UNMET = 2097187,
	CURLINFO_RTSP_SESSION_ID = 1048612,
	CURLINFO_RTSP_CLIENT_CSEQ = 2097189,
	CURLINFO_RTSP_SERVER_CSEQ = 2097190,
	CURLINFO_RTSP_CSEQ_RECV = 2097191,
	CURLINFO_PRIMARY_PORT = 2097192,
	CURLINFO_LOCAL_IP = 1048617,
	CURLINFO_LOCAL_PORT = 2097194,
	CURLINFO_LASTONE = 42
};
enum PC_FOLLOWTYPE {
	FOLLOW_NONE = 0,
	FOLLOW_FAKE = 1,
	FOLLOW_RETRY = 2,
	FOLLOW_REDIR = 3,
	FOLLOW_LAST = 4
};
enum PC_LOOP_STATE {
	CURLFNM_LOOP_DEFAULT = 0,
	CURLFNM_LOOP_BACKSLASH = 1
};
enum PC_SETCHARSET_STATE {
	CURLFNM_SCHS_DEFAULT = 0,
	CURLFNM_SCHS_MAYRANGE = 1,
	CURLFNM_SCHS_MAYRANGE2 = 2,
	CURLFNM_SCHS_RIGHTBR = 3,
	CURLFNM_SCHS_RIGHTBRLEFTBR = 4
};
enum PC_PARSEKEY_STATE {
	CURLFNM_PKW_INIT = 0,
	CURLFNM_PKW_DDOT = 1
};
enum PC_PL_UNIX_MAINSTATE {
	PL_UNIX_TOTALSIZE = 0,
	PL_UNIX_FILETYPE = 1,
	PL_UNIX_PERMISSION = 2,
	PL_UNIX_HLINKS = 3,
	PL_UNIX_USER = 4,
	PL_UNIX_GROUP = 5,
	PL_UNIX_SIZE = 6,
	PL_UNIX_TIME = 7,
	PL_UNIX_FILENAME = 8,
	PL_UNIX_SYMLINK = 9
};
enum PC_TOTAL_DIRSIZE {
	PL_UNIX_TOTALSIZE_INIT = 0,
	PL_UNIX_TOTALSIZE_READING = 1
};
enum PC_HLINKS {
	PL_UNIX_HLINKS_PRESPACE = 0,
	PL_UNIX_HLINKS_NUMBER = 1
};
enum PC_USER {
	PL_UNIX_USER_PRESPACE = 0,
	PL_UNIX_USER_PARSING = 1
};
enum PC_GROUP {
	PL_UNIX_GROUP_PRESPACE = 0,
	PL_UNIX_GROUP_NAME = 1
};
enum PC_SIZE {
	PL_UNIX_SIZE_PRESPACE = 0,
	PL_UNIX_SIZE_NUMBER = 1
};
enum PC_TIME {
	PL_UNIX_TIME_PREPART1 = 0,
	PL_UNIX_TIME_PART1 = 1,
	PL_UNIX_TIME_PREPART2 = 2,
	PL_UNIX_TIME_PART2 = 3,
	PL_UNIX_TIME_PREPART3 = 4,
	PL_UNIX_TIME_PART3 = 5
};
enum PC_FILENAME {
	PL_UNIX_FILENAME_PRESPACE = 0,
	PL_UNIX_FILENAME_NAME = 1,
	PL_UNIX_FILENAME_WINDOWSEOL = 2
};
enum PC_SYMLINK {
	PL_UNIX_SYMLINK_PRESPACE = 0,
	PL_UNIX_SYMLINK_NAME = 1,
	PL_UNIX_SYMLINK_PRETARGET1 = 2,
	PL_UNIX_SYMLINK_PRETARGET2 = 3,
	PL_UNIX_SYMLINK_PRETARGET3 = 4,
	PL_UNIX_SYMLINK_PRETARGET4 = 5,
	PL_UNIX_SYMLINK_TARGET = 6,
	PL_UNIX_SYMLINK_WINDOWSEOL = 7
};
enum PC_PL_WINNT_MAINSTATE {
	PL_WINNT_DATE = 0,
	PL_WINNT_TIME = 1,
	PL_WINNT_DIRORSIZE = 2,
	PL_WINNT_FILENAME = 3
};
enum PC_TIME2 {
	PL_WINNT_TIME_PRESPACE = 0,
	PL_WINNT_TIME_TIME = 1
};
enum PC_DIRORSIZE {
	PL_WINNT_DIRORSIZE_PRESPACE = 0,
	PL_WINNT_DIRORSIZE_CONTENT = 1
};
enum PC_FILENAME2 {
	PL_WINNT_FILENAME_PRESPACE = 0,
	PL_WINNT_FILENAME_CONTENT = 1,
	PL_WINNT_FILENAME_WINEOL = 2
};
enum PC_OS_TYPE {
	OS_TYPE_UNKNOWN = 0,
	OS_TYPE_UNIX = 1,
	OS_TYPE_WIN_NT = 2
};
enum PC_CURLMSG {
	CURLMSG_NONE = 0,
	CURLMSG_DONE = 1,
	CURLMSG_LAST = 2
};
enum PC_CURLMOPTION {
	CURLMOPT_SOCKETFUNCTION = 20001,
	CURLMOPT_SOCKETDATA = 10002,
	CURLMOPT_PIPELINING = 3,
	CURLMOPT_TIMERFUNCTION = 20004,
	CURLMOPT_TIMERDATA = 10005,
	CURLMOPT_MAXCONNECTS = 6,
	CURLMOPT_LASTENTRY = 7
};
enum PC_CURLMSTATE {
	CURLM_STATE_INIT = 0,
	CURLM_STATE_CONNECT = 1,
	CURLM_STATE_WAITRESOLVE = 2,
	CURLM_STATE_WAITCONNECT = 3,
	CURLM_STATE_WAITPROXYCONNECT = 4,
	CURLM_STATE_PROTOCONNECT = 5,
	CURLM_STATE_WAITDO = 6,
	CURLM_STATE_DO = 7,
	CURLM_STATE_DOING = 8,
	CURLM_STATE_DO_MORE = 9,
	CURLM_STATE_DO_DONE = 10,
	CURLM_STATE_WAITPERFORM = 11,
	CURLM_STATE_PERFORM = 12,
	CURLM_STATE_TOOFAST = 13,
	CURLM_STATE_DONE = 14,
	CURLM_STATE_COMPLETED = 15,
	CURLM_STATE_MSGSENT = 16,
	CURLM_STATE_LAST = 17
};
enum PC_CURLSHOPTION {
	CURLSHOPT_NONE = 0,
	CURLSHOPT_SHARE = 1,
	CURLSHOPT_UNSHARE = 2,
	CURLSHOPT_LOCKFUNC = 3,
	CURLSHOPT_UNLOCKFUNC = 4,
	CURLSHOPT_USERDATA = 5,
	CURLSHOPT_LAST = 6
};
enum PC_ASSUME {
	DATE_MDAY = 0,
	DATE_YEAR = 1,
	DATE_TIME = 2
};
enum PC_TFTP_MODE_T {
	TFTP_MODE_NETASCII = 0,
	TFTP_MODE_OCTET = 1
};
enum PC_TFTP_STATE_T {
	TFTP_STATE_START = 0,
	TFTP_STATE_RX = 1,
	TFTP_STATE_TX = 2,
	TFTP_STATE_FIN = 3
};
enum PC_TFTP_EVENT_T {
	TFTP_EVENT_NONE = -1,
	TFTP_EVENT_INIT = 0,
	TFTP_EVENT_RRQ = 1,
	TFTP_EVENT_WRQ = 2,
	TFTP_EVENT_DATA = 3,
	TFTP_EVENT_ACK = 4,
	TFTP_EVENT_ERROR = 5,
	TFTP_EVENT_OACK = 6,
	TFTP_EVENT_TIMEOUT = 7
};
enum PC_TFTP_ERROR_T {
	TFTP_ERR_UNDEF = 0,
	TFTP_ERR_NOTFOUND = 1,
	TFTP_ERR_PERM = 2,
	TFTP_ERR_DISKFULL = 3,
	TFTP_ERR_ILLEGAL = 4,
	TFTP_ERR_UNKNOWNID = 5,
	TFTP_ERR_EXISTS = 6,
	TFTP_ERR_NOSUCHUSER = 7,
	TFTP_ERR_NONE = -100,
	TFTP_ERR_TIMEOUT = -99,
	TFTP_ERR_NORESPONSE = -98
};

struct curl_httppost;
struct curl_sockaddr;
struct curl_khkey;
struct curl_slist;
struct curl_certinfo;
struct Cookie;
struct CookieInfo;
struct FormData;
struct Form;
struct Curl_chunker;
struct curl_llist_element;
struct curl_llist;
struct curl_hash;
struct Curl_addrinfo;
struct Curl_dns_entry;
struct Curl_tree;
struct pingpong;
struct imap_conn;
struct pop3_conn;
struct smtp_conn;
struct FTP;
struct ftp_conn;
struct FILEPROTO;
struct SSHPROTO;
struct ssh_conn;
struct back;
struct HTTP;
struct rtsp_conn;
struct RTSP;
struct WildcardData;
struct ssl_connect_data;
struct ssl_config_data;
struct curl_ssl_session;
struct digestdata;
struct ntlmdata;
struct ConnectBits;
struct hostname;
struct SingleRequest;
struct Curl_handler;
struct dynamically_allocated_data;
union __anonunion_proto_96;
struct connectdata;
struct PureInfo;
struct Progress;
struct auth;
struct conncache;
union __anonunion_proto_101;
struct UrlState;
struct DynamicStatic;
struct UserDefined;
struct Names;
struct SessionHandle;
struct __anonstruct___sigset_t_2;
union __anonunion___in6_u_36;
struct __anonstruct__kill_44;
struct __anonstruct__timer_45;
struct __anonstruct__rt_46;
struct __anonstruct__sigchld_47;
struct __anonstruct__sigfault_48;
struct __anonstruct__sigpoll_49;
union __anonunion__sifields_43;
union __anonunion___sigaction_handler_58;
struct Curl_share;
struct hostcache_prune_data;
struct curl_forms;
struct FormInfo;
struct ContentType;
struct Curl_send_buffer;
struct __anonstruct_strings_44;
struct curl_fileinfo;
struct __anonstruct_backup_81;
struct ftp_wc_tmpdata;
struct Curl_sockaddr_storage;
union __anonunion_ifa_ifu_48;
struct __anonstruct_curl_version_info_data_61;
union __anonunion_num_70;
union __anonunion_data_69;
struct __anonstruct_va_stack_t_68;
struct nsprintf;
struct asprintf;
struct TELNET;
union __anonunion_ptr_96;
union __anonunion_dlen_66;
union __anonunion_pl_unix_substate_96;
union __anonunion_pl_winNT_substate_106;
struct __anonstruct_UNIX_112;
struct __anonstruct_NT_113;
union __anonunion_state_111;
struct __anonstruct_offsets_114;
struct ftp_parselist_data;
union __anonunion__sa_ex_u_100;
struct Curl_sockaddr_ex;
struct curl_hash_element;
struct __anonstruct_fd_set_3;
union __anonunion_data_67;
struct CURLMsg;
struct Curl_message;
struct closure;
struct Curl_one_easy;
struct Curl_multi;
struct Curl_sh_entry;
struct __anonstruct_HMAC_params_34;
struct md5_ctx;
struct tzinfo;
struct my_tm;
struct tftp_packet;
struct tftp_state_data;
union __anonunion_addrentry_72;
struct namebuff;
struct __anonstruct_HMAC_context_101;

typedef struct __anonstruct_curl_version_info_data_61 curl_version_info_data;
typedef struct __anonstruct_va_stack_t_68 va_stack_t;
typedef union __anonunion_pl_unix_substate_96 pl_unix_substate;
typedef union __anonunion_pl_winNT_substate_106 pl_winNT_substate;
typedef struct __anonstruct_HMAC_params_34 HMAC_params;
typedef struct __anonstruct_HMAC_context_101 HMAC_context;

struct curl_httppost {
	struct curl_httppost * next;
	char * name;
	long namelength;
	char * contents;
	long contentslength;
	char * buffer;
	long bufferlength;
	char * contenttype;
	struct curl_slist * contentheader;
	struct curl_httppost * more;
	long flags;
	char * showfilename;
	void * userp;
};
struct curl_sockaddr {
	int family;
	int socktype;
	int protocol;
	unsigned int addrlen;
	struct sockaddr addr;
};
struct curl_khkey {
	char const * key;
	unsigned int len;
	int keytype;
};
struct curl_slist {
	char * data;
	struct curl_slist * next;
};
struct curl_certinfo {
	int num_of_certs;
	struct curl_slist * * certinfo;
};
struct Cookie {
	struct Cookie * next;
	char * name;
	char * value;
	char * path;
	char * domain;
	long long expires;
	char * expirestr;
	_Bool tailmatch;
	char * version;
	char * maxage;
	_Bool secure;
	_Bool livecookie;
	_Bool httponly;
};
struct CookieInfo {
	struct Cookie * cookies;
	char * filename;
	_Bool running;
	long numcookies;
	_Bool newsession;
};
struct FormData {
	struct FormData * next;
	int type;
	char * line;
	unsigned int length;
};
struct Form {
	struct FormData * data;
	unsigned int sent;
	struct _IO_FILE * fp;
	unsigned int( * fread_func)(char * buffer, unsigned int size, unsigned int nitems, void * instream);
};
struct Curl_chunker {
	char hexbuffer[17];
	int hexindex;
	int state;
	unsigned int datasize;
	unsigned int dataleft;
};
struct curl_llist_element {
	void * ptr;
	struct curl_llist_element * prev;
	struct curl_llist_element * next;
};
struct curl_llist {
	struct curl_llist_element * head;
	struct curl_llist_element * tail;
	void( * dtor)(void *, void *);
	unsigned int size;
};
struct curl_hash {
	struct curl_llist * * table;
	unsigned int( * hash_func)(void * key, unsigned int key_length, unsigned int slots_num);
	unsigned int( * comp_func)(void * key1, unsigned int key1_len, void * key2, unsigned int key2_len);
	void( * dtor)(void *);
	int slots;
	unsigned int size;
};
struct Curl_addrinfo {
	int ai_flags;
	int ai_family;
	int ai_socktype;
	int ai_protocol;
	unsigned int ai_addrlen;
	char * ai_canonname;
	struct sockaddr * ai_addr;
	struct Curl_addrinfo * ai_next;
};
struct Curl_dns_entry {
	struct Curl_addrinfo * addr;
	long timestamp;
	long inuse;
};
struct Curl_tree {
	struct Curl_tree * smaller;
	struct Curl_tree * larger;
	struct Curl_tree * same;
	struct timeval key;
	void * payload;
};
struct pingpong {
	char * cache;
	unsigned int cache_size;
	unsigned int nread_resp;
	char * linestart_resp;
	_Bool pending_resp;
	char * sendthis;
	unsigned int sendleft;
	unsigned int sendsize;
	struct timeval response;
	long response_time;
	struct connectdata * conn;
	int( * statemach_act)(struct connectdata * conn);
	int( * endofresp)(struct pingpong * pp, int * code);
};
struct imap_conn {
	struct pingpong pp;
	char * mailbox;
	int state;
	int cmdid;
	char const * idstr;
};
struct pop3_conn {
	struct pingpong pp;
	char * mailbox;
	unsigned int eob;
	int state;
};
struct smtp_conn {
	struct pingpong pp;
	char * domain;
	unsigned int eob;
	unsigned int authmechs;
	int state;
	struct curl_slist * rcpt;
};
struct FTP {
	long long * bytecountp;
	char * user;
	char * passwd;
	int transfer;
	long long downloadsize;
};
struct ftp_conn {
	struct pingpong pp;
	char * entrypath;
	char * * dirs;
	int dirdepth;
	int diralloc;
	char * file;
	_Bool dont_check;
	_Bool ctl_valid;
	_Bool cwddone;
	_Bool cwdfail;
	char * prevpath;
	char transfertype;
	int count1;
	int count2;
	int count3;
	int state;
	char * server_os;
	long long known_filesize;
};
struct FILEPROTO {
	char * path;
	char * freepath;
	int fd;
};
struct SSHPROTO {
	char * path;
};
struct ssh_conn {
	char const * authlist;
};
struct back {
	unsigned int( * fread_func)(char * buffer, unsigned int size, unsigned int nitems, void * instream);
	void * fread_in;
	char const * postdata;
	long long postsize;
};
struct HTTP {
	struct FormData * sendit;
	long long postsize;
	char const * postdata;
	char const * p_pragma;
	char const * p_accept;
	long long readbytecount;
	long long writebytecount;
	struct Form form;
	struct back backup;
	int sending;
	void * send_buffer;
};
struct rtsp_conn {
	char * rtp_buf;
	int rtp_bufsize;
	int rtp_channel;
};
struct RTSP {
	struct HTTP http_wrapper;
	long CSeq_sent;
	long CSeq_recv;
};
struct WildcardData {
	int state;
	char * path;
	char * pattern;
	struct curl_llist * filelist;
	void * tmp;
	void( * tmp_dtor)(void * ptr);
	void * customptr;
};
struct ssl_connect_data {
	_Bool use;
	int state;
};
struct ssl_config_data {
	long version;
	long certverifyresult;
	long verifypeer;
	long verifyhost;
	char * CApath;
	char * CAfile;
	char const * CRLfile;
	char const * issuercert;
	char * random_file;
	char * egdsocket;
	char * cipher_list;
	long numsessions;
	int( * fsslctx)(void * curl, void * ssl_ctx, void * userptr);
	void * fsslctxp;
	_Bool sessionid;
	_Bool certinfo;
};
struct curl_ssl_session {
	char * name;
	void * sessionid;
	unsigned int idsize;
	long age;
	unsigned short remote_port;
	struct ssl_config_data ssl_config;
};
struct digestdata {
	char * nonce;
	char * cnonce;
	char * realm;
	int algo;
	_Bool stale;
	char * opaque;
	char * qop;
	char * algorithm;
	int nc;
};
struct ntlmdata {
	int state;
	unsigned int flags;
	unsigned char nonce[8];
};
struct ConnectBits {
	_Bool close;
	_Bool reuse;
	_Bool proxy;
	_Bool httpproxy;
	_Bool user_passwd;
	_Bool proxy_user_passwd;
	_Bool ipv6_ip;
	_Bool ipv6;
	_Bool do_more;
	_Bool tcpconnect;
	_Bool protoconnstart;
	_Bool retry;
	_Bool tunnel_proxy;
	_Bool tunnel_connecting;
	_Bool authneg;
	_Bool rewindaftersend;
	_Bool ftp_use_epsv;
	_Bool ftp_use_eprt;
	_Bool netrc;
	_Bool userpwd_in_url;
	_Bool done;
	_Bool stream_was_rewound;
	_Bool proxy_connect_closed;
	_Bool bound;
	_Bool type_set;
};
struct hostname {
	char * rawalloc;
	char * encalloc;
	char * name;
	char const * dispname;
};
struct SingleRequest {
	long long size;
	long long * bytecountp;
	long long maxdownload;
	long long * writebytecountp;
	long long bytecount;
	long long writebytecount;
	long headerbytecount;
	long deductheadercount;
	struct timeval start;
	struct timeval now;
	_Bool header;
	int badheader;
	int headerline;
	char * hbufp;
	unsigned int hbuflen;
	char * str;
	char * str_start;
	char * end_ptr;
	char * p;
	_Bool content_range;
	long long offset;
	int httpcode;
	struct timeval start100;
	int exp100;
	int content_encoding;
	long timeofdoc;
	long bodywrites;
	char * buf;
	char * uploadbuf;
	int maxfd;
	int keepon;
	_Bool upload_done;
	_Bool ignorebody;
	_Bool ignorecl;
	char * location;
	char * newurl;
	int upload_present;
	char * upload_fromhere;
	_Bool chunk;
	_Bool upload_chunky;
	_Bool getheader;
	_Bool forbidchunk;
};
struct Curl_handler {
	char const * scheme;
	int( * setup_connection)(struct connectdata *);
	int( * do_it)(struct connectdata *, _Bool * done);
	int( * done)(struct connectdata *, int, _Bool);
	int( * do_more)(struct connectdata *);
	int( * connect_it)(struct connectdata *, _Bool * done);
	int( * connecting)(struct connectdata *, _Bool * done);
	int( * doing)(struct connectdata *, _Bool * done);
	int( * proto_getsock)(struct connectdata * conn, int * socks, int numsocks);
	int( * doing_getsock)(struct connectdata * conn, int * socks, int numsocks);
	int( * perform_getsock)(struct connectdata const * conn, int * socks, int numsocks);
	int( * disconnect)(struct connectdata *);
	long defport;
	long protocol;
};
struct dynamically_allocated_data {
	char * proxyuserpwd;
	char * uagent;
	char * accept_encoding;
	char * userpwd;
	char * rangeline;
	char * ref;
	char * host;
	char * cookiehost;
	char * rtsp_transport;
};
union __anonunion_proto_96 {
	struct ftp_conn ftpc;
	struct ssh_conn sshc;
	struct tftp_state_data * tftpc;
	struct imap_conn imapc;
	struct pop3_conn pop3c;
	struct smtp_conn smtpc;
	struct rtsp_conn rtspc;
	void * generic;
};
struct connectdata {
	struct SessionHandle * data;
	struct Curl_chunker chunk;
	_Bool inuse;
	long connectindex;
	long protocol;
	struct Curl_dns_entry * dns_entry;
	struct Curl_addrinfo * ip_addr;
	char ip_addr_str[sizeof("ffff:ffff:ffff:ffff:ffff:ffff:255.255.255.255")];
	unsigned int scope;
	int socktype;
	struct hostname host;
	struct hostname proxy;
	long port;
	unsigned short remote_port;
	char * user;
	char * passwd;
	char * proxyuser;
	char * proxypasswd;
	int proxytype;
	int httpversion;
	int rtspversion;
	struct timeval now;
	struct timeval created;
	int sock[2];
	int( * recv[2])(struct connectdata * conn, int sockindex, char * buf, unsigned int len, int * err);
	int( * send[2])(struct connectdata * conn, int sockindex, void const * buf, unsigned int len, int * err);
	struct ssl_connect_data ssl[2];
	struct ssl_config_data ssl_config;
	struct ConnectBits bits;
	struct Curl_handler const * handler;
	int sockfd;
	int writesockfd;
	struct dynamically_allocated_data allocptr;
	int sec_complete;
	_Bool readchannel_inuse;
	_Bool writechannel_inuse;
	_Bool server_supports_pipelining;
	struct curl_llist * send_pipe;
	struct curl_llist * recv_pipe;
	struct curl_llist * pend_pipe;
	struct curl_llist * done_pipe;
	char * master_buffer;
	unsigned int read_pos;
	unsigned int buf_len;
	int( * seek_func)(void * instream, long long offset, int origin);
	void * seek_client;
	unsigned int( * fread_func)(char * buffer, unsigned int size, unsigned int nitems, void * instream);
	void * fread_in;
	struct ntlmdata ntlm;
	struct ntlmdata proxyntlm;
	char syserr_buf[256];
	char * trailer;
	int trlMax;
	int trlPos;
	union __anonunion_proto_96 proto;
	int cselect_bits;
	int waitfor;
	long verifypeer;
	long verifyhost;
};
struct PureInfo {
	int httpcode;
	int httpproxycode;
	int httpversion;
	long filetime;
	_Bool timecond;
	long header_size;
	long request_size;
	long proxyauthavail;
	long httpauthavail;
	long numconnects;
	char * contenttype;
	char * wouldredirect;
	char ip[sizeof("ffff:ffff:ffff:ffff:ffff:ffff:255.255.255.255")];
	long port;
	char localip[sizeof("ffff:ffff:ffff:ffff:ffff:ffff:255.255.255.255")];
	long localport;
	struct curl_certinfo certs;
};
struct Progress {
	long lastshow;
	long long size_dl;
	long long size_ul;
	long long downloaded;
	long long uploaded;
	long long current_speed;
	_Bool callback;
	int width;
	int flags;
	double timespent;
	long long dlspeed;
	long long ulspeed;
	double t_nslookup;
	double t_connect;
	double t_appconnect;
	double t_pretransfer;
	double t_starttransfer;
	double t_redirect;
	struct timeval start;
	struct timeval t_startsingle;
	long long speeder[6];
	struct timeval speeder_time[6];
	int speeder_c;
};
struct auth {
	long want;
	long picked;
	long avail;
	_Bool done;
	_Bool multi;
	_Bool iestyle;
};
struct conncache {
	struct connectdata * * connects;
	long num;
	int type;
};
union __anonunion_proto_101 {
	struct HTTP * http;
	struct HTTP * https;
	struct RTSP * rtsp;
	struct FTP * ftp;
	struct FILEPROTO * file;
	void * telnet;
	void * generic;
	struct SSHPROTO * ssh;
	struct FTP * imap;
	struct FTP * pop3;
	struct FTP * smtp;
};
struct UrlState {
	int used_interface;
	struct conncache * connc;
	struct timeval keeps_speed;
	long lastconnect;
	char * headerbuff;
	unsigned int headersize;
	char buffer[16385];
	char uploadbuffer[16385];
	long long current_speed;
	_Bool this_is_a_follow;
	char * first_host;
	struct curl_ssl_session * session;
	long sessionage;
	char * tempwrite;
	unsigned int tempwritesize;
	int tempwritetype;
	char * scratch;
	_Bool errorbuf;
	int os_errno;
	void( * prev_signal)(int sig);
	_Bool allow_port;
	struct digestdata digest;
	struct digestdata proxydigest;
	struct auth authhost;
	struct auth authproxy;
	_Bool authproblem;
	struct timeval expiretime;
	struct Curl_tree timenode;
	struct curl_llist * timeoutlist;
	char * most_recent_ftp_entrypath;
	_Bool ftp_trying_alternative;
	int httpversion;
	_Bool expect100header;
	_Bool pipe_broke;
	_Bool prev_block_had_trailing_cr;
	long long crlf_conversions;
	void * shared_conn;
	_Bool closed;
	char * pathbuffer;
	char * path;
	_Bool slash_removed;
	_Bool use_range;
	_Bool rangestringalloc;
	char * range;
	long long resume_from;
	long rtsp_next_client_CSeq;
	long rtsp_next_server_CSeq;
	long rtsp_CSeq_recv;
	union __anonunion_proto_101 proto;
	struct connectdata * current_conn;
	_Bool ssl_connect_retry;
};
struct DynamicStatic {
	char * url;
	_Bool url_alloc;
	char * referer;
	_Bool referer_alloc;
	struct curl_slist * cookielist;
};
struct UserDefined {
	struct _IO_FILE * err;
	void * debugdata;
	char * errorbuffer;
	long proxyport;
	void * out;
	void * in;
	void * writeheader;
	void * rtp_out;
	long use_port;
	long httpauth;
	long proxyauth;
	long followlocation;
	long maxredirs;
	_Bool post301;
	_Bool post302;
	_Bool free_referer;
	void * postfields;
	int( * seek_func)(void * instream, long long offset, int origin);
	long long postfieldsize;
	unsigned short localport;
	int localportrange;
	unsigned int( * fwrite_func)(char * buffer, unsigned int size, unsigned int nitems, void * outstream);
	unsigned int( * fwrite_header)(char * buffer, unsigned int size, unsigned int nitems, void * outstream);
	unsigned int( * fwrite_rtp)(char * buffer, unsigned int size, unsigned int nitems, void * outstream);
	unsigned int( * fread_func)(char * buffer, unsigned int size, unsigned int nitems, void * instream);
	int is_fread_set;
	int is_fwrite_set;
	int( * fprogress)(void * clientp, double dltotal, double dlnow, double ultotal, double ulnow);
	int( * fdebug)(void * handle, int type, char * data, unsigned int size, void * userptr);
	int( * ioctl_func)(void * handle, int cmd, void * clientp);
	int( * fsockopt)(void * clientp, int curlfd, int purpose);
	void * sockopt_client;
	int( * fopensocket)(void * clientp, int purpose, struct curl_sockaddr * address);
	void * opensocket_client;
	void * seek_client;
	int( * convfromnetwork)(char * buffer, unsigned int length);
	int( * convtonetwork)(char * buffer, unsigned int length);
	int( * convfromutf8)(char * buffer, unsigned int length);
	void * progress_client;
	void * ioctl_client;
	long timeout;
	long connecttimeout;
	long server_response_timeout;
	long tftp_blksize;
	long long infilesize;
	long low_speed_limit;
	long low_speed_time;
	long long max_send_speed;
	long long max_recv_speed;
	long long set_resume_from;
	struct curl_slist * headers;
	struct curl_httppost * httppost;
	_Bool cookiesession;
	_Bool crlf;
	struct curl_slist * quote;
	struct curl_slist * postquote;
	struct curl_slist * prequote;
	struct curl_slist * source_quote;
	struct curl_slist * source_prequote;
	struct curl_slist * source_postquote;
	struct curl_slist * telnet_options;
	int timecondition;
	long timevalue;
	int httpreq;
	long httpversion;
	struct ssl_config_data ssl;
	int proxytype;
	long dns_cache_timeout;
	long buffer_size;
	void * private_data;
	struct Curl_one_easy * one_easy;
	struct curl_slist * http200aliases;
	long ip_version;
	long long max_filesize;
	int ftp_filemethod;
	int ftp_create_missing_dirs;
	int( * ssh_keyfunc)(void * easy, struct curl_khkey const * knownkey, struct curl_khkey const * foundkey, int, void * clientp);
	void * ssh_keyfunc_userp;
	_Bool printhost;
	_Bool get_filetime;
	_Bool tunnel_thru_httpproxy;
	_Bool prefer_ascii;
	_Bool ftp_append;
	_Bool ftp_list_only;
	_Bool ftp_use_port;
	_Bool hide_progress;
	_Bool http_fail_on_error;
	_Bool http_follow_location;
	_Bool http_disable_hostname_check_before_authentication;
	_Bool include_header;
	_Bool http_set_referer;
	_Bool http_auto_referer;
	_Bool opt_no_body;
	_Bool set_port;
	_Bool upload;
	int use_netrc;
	_Bool verbose;
	_Bool krb;
	_Bool reuse_forbid;
	_Bool reuse_fresh;
	_Bool ftp_use_epsv;
	_Bool ftp_use_eprt;
	_Bool ftp_use_pret;
	int ftp_ssl;
	int ftpsslauth;
	int ftp_ccc;
	_Bool no_signal;
	_Bool global_dns_cache;
	_Bool tcp_nodelay;
	_Bool ignorecl;
	_Bool ftp_skip_ip;
	_Bool connect_only;
	long ssh_auth_types;
	_Bool http_te_skip;
	_Bool http_ce_skip;
	long new_file_perms;
	long new_directory_perms;
	_Bool proxy_transfer_mode;
	char * str[37];
	unsigned int scope;
	long allowed_protocols;
	long redir_protocols;
	struct curl_slist * mail_rcpt;
	int rtspreq;
	long rtspversion;
	_Bool wildcardmatch;
	long( * chunk_bgn)(void const * transfer_info, void * ptr, int remains);
	long( * chunk_end)(void * ptr);
	int( * fnmatch)(void * ptr, char const * pattern, char const * string);
	void * fnmatch_data;
};
struct Names {
	struct curl_hash * hostcache;
	int hostcachetype;
};
struct SessionHandle {
	struct Names dns;
	struct Curl_multi * multi;
	struct Curl_one_easy * multi_pos;
	struct Curl_share * share;
	struct SingleRequest req;
	struct UserDefined set;
	struct DynamicStatic change;
	struct CookieInfo * cookies;
	struct Progress progress;
	struct UrlState state;
	struct WildcardData wildcard;
	struct PureInfo info;
	unsigned int magic;
};
struct __anonstruct___sigset_t_2 {
	unsigned long __val[1024u / (8u * sizeof(unsigned long))];
};
union __anonunion___in6_u_36 {
	unsigned char __u6_addr8[16];
	unsigned short __u6_addr16[8];
	unsigned int __u6_addr32[4];
};
struct __anonstruct__kill_44 {
	int si_pid;
	unsigned int si_uid;
};
struct __anonstruct__timer_45 {
	int si_tid;
	int si_overrun;
	union sigval si_sigval;
};
struct __anonstruct__rt_46 {
	int si_pid;
	unsigned int si_uid;
	union sigval si_sigval;
};
struct __anonstruct__sigchld_47 {
	int si_pid;
	unsigned int si_uid;
	int si_status;
	long si_utime;
	long si_stime;
};
struct __anonstruct__sigfault_48 {
	void * si_addr;
};
struct __anonstruct__sigpoll_49 {
	long si_band;
	int si_fd;
};
union __anonunion__sifields_43 {
	int _pad[128u / sizeof(int) - 3u];
	struct __anonstruct__kill_44 _kill;
	struct __anonstruct__timer_45 _timer;
	struct __anonstruct__rt_46 _rt;
	struct __anonstruct__sigchld_47 _sigchld;
	struct __anonstruct__sigfault_48 _sigfault;
	struct __anonstruct__sigpoll_49 _sigpoll;
};
union __anonunion___sigaction_handler_58 {
	void( * sa_handler)(int);
	void( * sa_sigaction)(int, struct siginfo *, void *);
};
struct Curl_share {
	unsigned int specifier;
	unsigned int volatile dirty;
	void( * lockfunc)(void * handle, int data, int locktype, void * userptr);
	void( * unlockfunc)(void * handle, int data, void * userptr);
	void * clientdata;
	struct curl_hash * hostcache;
	struct CookieInfo * cookies;
};
struct hostcache_prune_data {
	long cache_timeout;
	long now;
};
struct curl_forms {
	int option;
	char const * value;
};
struct FormInfo {
	char * name;
	_Bool name_alloc;
	unsigned int namelength;
	char * value;
	_Bool value_alloc;
	unsigned int contentslength;
	char * contenttype;
	_Bool contenttype_alloc;
	long flags;
	char * buffer;
	unsigned int bufferlength;
	char * showfilename;
	_Bool showfilename_alloc;
	char * userp;
	struct curl_slist * contentheader;
	struct FormInfo * more;
};
struct ContentType {
	char extension[6];
	char const * type;
};
struct Curl_send_buffer {
	char * buffer;
	unsigned int size_max;
	unsigned int size_used;
};
struct __anonstruct_strings_44 {
	char * time;
	char * perm;
	char * user;
	char * group;
	char * target;
};
struct curl_fileinfo {
	char * filename;
	int filetype;
	long time;
	unsigned int perm;
	int uid;
	int gid;
	long long size;
	long hardlinks;
	struct __anonstruct_strings_44 strings;
	unsigned int flags;
	char * b_data;
	unsigned int b_size;
	unsigned int b_used;
};
struct __anonstruct_backup_81 {
	unsigned int( * write_function)(char * buffer, unsigned int size, unsigned int nitems, void * outstream);
	struct _IO_FILE * file_descriptor;
};
struct ftp_wc_tmpdata {
	struct ftp_parselist_data * parser;
	struct __anonstruct_backup_81 backup;
};
struct Curl_sockaddr_storage {
	struct sockaddr_storage buffer;
};
union __anonunion_ifa_ifu_48 {
	struct sockaddr * ifu_broadaddr;
	struct sockaddr * ifu_dstaddr;
};
struct __anonstruct_curl_version_info_data_61 {
	int age;
	char const * version;
	unsigned int version_num;
	char const * host;
	int features;
	char const * ssl_version;
	long ssl_version_num;
	char const * libz_version;
	char const * const * protocols;
	char const * ares;
	int ares_num;
	char const * libidn;
	int iconv_ver_num;
	char const * libssh_version;
};
union __anonunion_num_70 {
	long long as_signed;
	unsigned long long as_unsigned;
};
union __anonunion_data_69 {
	char * str;
	void * ptr;
	union __anonunion_num_70 num;
	double dnum;
};
struct __anonstruct_va_stack_t_68 {
	int type;
	int flags;
	long width;
	long precision;
	union __anonunion_data_69 data;
};
struct nsprintf {
	char * buffer;
	unsigned int length;
	unsigned int max;
};
struct asprintf {
	char * buffer;
	unsigned int len;
	unsigned int alloc;
	int fail;
};
struct TELNET {
	int please_negotiate;
	int already_negotiated;
	int us[256];
	int usq[256];
	int us_preferred[256];
	int him[256];
	int himq[256];
	int him_preferred[256];
	char subopt_ttype[32];
	char subopt_xdisploc[128];
	struct curl_slist * telnet_vars;
	unsigned char subbuffer[512];
	unsigned char * subpointer;
	unsigned char * subend;
	int telrcv_state;
};
union __anonunion_ptr_96 {
	struct curl_certinfo * to_certinfo;
	struct curl_slist * to_slist;
};
union __anonunion_dlen_66 {
	int sig;
	unsigned int uns;
};
union __anonunion_pl_unix_substate_96 {
	int total_dirsize;
	int hlinks;
	int user;
	int group;
	int size;
	int time;
	int filename;
	int symlink;
};
union __anonunion_pl_winNT_substate_106 {
	int time;
	int dirorsize;
	int filename;
};
struct __anonstruct_UNIX_112 {
	int main;
	pl_unix_substate sub;
};
struct __anonstruct_NT_113 {
	int main;
	pl_winNT_substate sub;
};
union __anonunion_state_111 {
	struct __anonstruct_UNIX_112 UNIX;
	struct __anonstruct_NT_113 NT;
};
struct __anonstruct_offsets_114 {
	unsigned int filename;
	unsigned int user;
	unsigned int group;
	unsigned int time;
	unsigned int perm;
	unsigned int symlink_target;
};
struct ftp_parselist_data {
	int os_type;
	union __anonunion_state_111 state;
	int error;
	struct curl_fileinfo * file_data;
	unsigned int item_length;
	unsigned int item_offset;
	struct __anonstruct_offsets_114 offsets;
};
union __anonunion__sa_ex_u_100 {
	struct sockaddr addr;
	struct Curl_sockaddr_storage buff;
};
struct Curl_sockaddr_ex {
	int family;
	int socktype;
	int protocol;
	unsigned int addrlen;
	union __anonunion__sa_ex_u_100 _sa_ex_u;
};
struct curl_hash_element {
	void * ptr;
	char * key;
	unsigned int key_len;
};
struct __anonstruct_fd_set_3 {
	long fds_bits[1024 / (8 * (int)sizeof(long))];
};
union __anonunion_data_67 {
	void * whatever;
	int result;
};
struct CURLMsg {
	int msg;
	void * easy_handle;
	union __anonunion_data_67 data;
};
struct Curl_message {
	struct CURLMsg extmsg;
};
struct closure {
	struct closure * next;
	struct SessionHandle * easy_handle;
};
struct Curl_one_easy {
	struct Curl_one_easy * next;
	struct Curl_one_easy * prev;
	struct SessionHandle * easy_handle;
	struct connectdata * easy_conn;
	int state;
	int result;
	struct Curl_message msg;
	int sockets[5];
	int numsocks;
};
struct Curl_multi {
	long type;
	struct Curl_one_easy easy;
	int num_easy;
	int num_alive;
	struct curl_llist * msglist;
	int( * socket_cb)(void * easy, int s, int what, void * userp, void * socketp);
	void * socket_userp;
	struct curl_hash * hostcache;
	struct Curl_tree * timetree;
	struct curl_hash * sockhash;
	_Bool pipelining_enabled;
	struct conncache * connc;
	long maxconnects;
	struct closure * closure;
	int( * timer_cb)(void * multi, long timeout_ms, void * userp);
	void * timer_userp;
	struct timeval timer_lastcall;
};
struct Curl_sh_entry {
	struct SessionHandle * easy;
	long timestamp;
	int action;
	int socket;
	void * socketp;
};
struct __anonstruct_HMAC_params_34 {
	void( * hmac_hinit)(void * context);
	void( * hmac_hupdate)(void * context, unsigned char const * data, unsigned int len);
	void( * hmac_hfinal)(unsigned char * result, void * context);
	unsigned int hmac_ctxtsize;
	unsigned int hmac_maxkeylen;
	unsigned int hmac_resultlen;
};
struct md5_ctx {
	unsigned int state[4];
	unsigned int count[2];
	unsigned char buffer[64];
};
struct tzinfo {
	char name[5];
	int offset;
};
struct my_tm {
	int tm_sec;
	int tm_min;
	int tm_hour;
	int tm_mday;
	int tm_mon;
	int tm_year;
};
struct tftp_packet {
	unsigned char * data;
};
struct tftp_state_data {
	int state;
	int mode;
	int error;
	int event;
	struct connectdata * conn;
	int sockfd;
	int retries;
	int retry_time;
	int retry_max;
	long start_time;
	long max_time;
	long rx_time;
	unsigned short block;
	struct Curl_sockaddr_storage local_addr;
	struct Curl_sockaddr_storage remote_addr;
	unsigned int remote_addrlen;
	int rbytes;
	int sbytes;
	int blksize;
	int requested_blksize;
	struct tftp_packet rpacket;
	struct tftp_packet spacket;
};
union __anonunion_addrentry_72 {
	struct in_addr ina4;
	struct in6_addr ina6;
};
struct namebuff {
	struct hostent hostentry;
	union __anonunion_addrentry_72 addrentry;
	char * h_addr_list[2];
};
struct __anonstruct_HMAC_context_101 {
	HMAC_params * hmac_hash;
	void * hmac_hashctxt1;
	void * hmac_hashctxt2;
};

#endif
