class
	P_BASE64

inherit
	LIBCURL_DATA
		redefine
			default_create
		end
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create table64.make (<<65>>)
		end

feature {ANY} -- attributes

	table64: CE_ARRAY [INTEGER_8]

feature {ANY} -- routines

	decodeQuantum (a_dest: CE_POINTER [NATURAL_8]; a_src: CE_POINTER [INTEGER_8])
		local
			l_s: CE_POINTER [INTEGER_8]
			l_p: CE_POINTER [INTEGER_8]
			l_i: NATURAL_32
			l_v: NATURAL_32
			l_x: NATURAL_32
			js: JUMP_STATE
		do
			create l_s.make
			create l_p.make

			l_x := {NATURAL_32} 0
			l_i := {NATURAL_32} 0
			l_s.ce_gets (a_src)
			from
			until
				not (not js.loop_left and then (l_i < {NATURAL_32} 4))
			loop
				l_v := {NATURAL_32} 0
				l_p.ce_gets (table64)
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_p[0]).to_boolean then
						if (l_p[0]).to_integer_32 = (l_s[0]).to_integer_32 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_v := l_v + 1
						l_p.ce_gets (l_p + 1)
					end
				end
				js.reset
				if (l_p[0]).to_integer_32 = (l_s[0]).to_integer_32 then
					l_x := ((l_x).bit_shift_left (6)) + l_v
				elseif (l_s[0]).to_integer_32 = 61 then
					l_x := (l_x).bit_shift_left ((6))
				end
				l_i := l_i + 1
				l_s.ce_gets (l_s + 1)
			end
			a_dest[2] := warnless_inst.curlx_ultouc (l_x)
			l_x := (l_x).bit_shift_right ((8))
			a_dest[1] := warnless_inst.curlx_ultouc (l_x)
			l_x := (l_x).bit_shift_right ((8))
			a_dest[0] := warnless_inst.curlx_ultouc (l_x)
		end

	Curl_base64_decode (a_src: CE_POINTER [INTEGER_8]; a_outptr: CE_POINTER [CE_POINTER [NATURAL_8]]): NATURAL_32
		local
			l_src: CE_POINTER [INTEGER_8]
			l_length: NATURAL_32
			l_equalsTerm: NATURAL_32
			l_i: NATURAL_32
			l_numQuantums: NATURAL_32
			l_lastQuantum: CE_ARRAY [NATURAL_8]
			l_rawlen: NATURAL_32
			l_newstr: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_src.make
			create l_lastQuantum.make (<<3>>)
			create l_newstr.make

			l_src.ce_gets (a_src)
			l_length := (0).to_natural_32
			l_equalsTerm := (0).to_natural_32
			l_rawlen := (0).to_natural_32
			a_outptr.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_src[l_length.to_integer_32]).to_integer_32 /= 61 then
					if not (l_src[l_length.to_integer_32]).to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_length := l_length + 1
				end
			end
			js.reset
			if (l_src[l_length.to_integer_32]).to_integer_32 = 61 then
				l_equalsTerm := l_equalsTerm + 1
				if (l_src[(l_length + l_equalsTerm).to_integer_32]).to_integer_32 = 61 then
					l_equalsTerm := l_equalsTerm + 1
				end
			end
			l_numQuantums := (l_length + l_equalsTerm) // {NATURAL_32} 4
			if l_numQuantums = {NATURAL_32} 0 then
				Result := (0).to_natural_32
				js.return
			end
			if not js.return_called then
				l_rawlen := l_numQuantums * {NATURAL_32} 3 - l_equalsTerm
				l_newstr.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([l_rawlen + {NATURAL_32} 4])))))
				if (l_newstr).c_pointer = default_pointer then
					Result := (0).to_natural_32
					js.return
				end
			end
			if not js.return_called then
				a_outptr.item := l_newstr
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_numQuantums - {NATURAL_32} 1)
				loop
					decodeQuantum (l_newstr, l_src)
					l_newstr.ce_gets (l_newstr + (3))
					l_src.ce_gets (l_src + (4))
					l_i := l_i + 1
				end
				decodeQuantum (l_lastQuantum, l_src)
				l_i := (0).to_natural_32
				from
				until
					not (l_i < {NATURAL_32} 3 - l_equalsTerm)
				loop
					l_newstr[l_i.to_integer_32] := l_lastQuantum[l_i.to_integer_32]
					l_i := l_i + 1
				end
				l_newstr[l_i.to_integer_32] := (('%/0/').code).to_natural_8
				Result := l_rawlen
			end
		end

	Curl_base64_encode (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_inputbuff: CE_POINTER [INTEGER_8]; a_insize: NATURAL_32; a_outptr: CE_POINTER [CE_POINTER [INTEGER_8]]): NATURAL_32
		local
			l_insize: NATURAL_32
			l_ibuf: CE_ARRAY [NATURAL_8]
			l_obuf: CE_ARRAY [NATURAL_8]
			l_i: INTEGER_32
			l_inputparts: INTEGER_32
			l_output: CE_POINTER [INTEGER_8]
			l_base64data: CE_POINTER [INTEGER_8]
			l_indata: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ibuf.make (<<3>>)
			create l_obuf.make (<<4>>)
			create l_output.make
			create l_base64data.make
			create l_indata.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_insize := a_insize
					l_indata.ce_gets (a_inputbuff)
					a_outptr.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					if {NATURAL_32} 0 = l_insize then
						l_insize := strlen (l_indata)
					end
					l_output.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([(l_insize * {NATURAL_32} 4) // {NATURAL_32} 3 + {NATURAL_32} 4])))))
					l_base64data.ce_gets (l_output)
					if (0).to_natural_32 = (l_output.c_pointer.to_integer_32).to_natural_32 then
						Result := (0).to_natural_32
						js.return
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if not (not js.loop_left and then (l_insize > {NATURAL_32} 0)) then
							l_pos := -1 + 7 -- skip loop
						end
				when 2 then -- loop body:
						l_inputparts := 0
						l_i := l_inputparts
						from
						until
							not (l_i < 3)
						loop
							if l_insize > {NATURAL_32} 0 then
								l_inputparts := l_inputparts + 1
								l_ibuf[l_i] := (l_indata[0]).to_natural_8
								l_indata.ce_gets (l_indata + 1)
								l_insize := l_insize - 1
							else
								l_ibuf[l_i] := (0).to_natural_8
							end
							l_i := l_i + 1
						end
						l_obuf[0] := (((((l_ibuf[0]).to_integer_32).bit_and (252))).bit_shift_right (2)).to_natural_8
						l_obuf[1] := (((((((l_ibuf[0]).to_integer_32).bit_and (3))).bit_shift_left (4))).bit_or ((((((l_ibuf[1]).to_integer_32).bit_and (240))).bit_shift_right (4)))).to_natural_8
						l_obuf[2] := (((((((l_ibuf[1]).to_integer_32).bit_and (15))).bit_shift_left (2))).bit_or ((((((l_ibuf[2]).to_integer_32).bit_and (192))).bit_shift_right (6)))).to_natural_8
						l_obuf[3] := (((l_ibuf[2]).to_integer_32).bit_and (63)).to_natural_8
						inspect l_inputparts -- switch 1 head
						when 1 then l_pos := -1 + 3
						when 2 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 3 then -- switch 1, case 1
						mprintf_inst.curl_msnprintf ([l_output, (5).to_natural_32, ce_string ("%%c%%c=="), (table64[(l_obuf[0]).to_integer_32]).to_integer_32, (table64[(l_obuf[1]).to_integer_32]).to_integer_32]).do_nothing
						l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 2
						mprintf_inst.curl_msnprintf ([l_output, (5).to_natural_32, ce_string ("%%c%%c%%c="), (table64[(l_obuf[0]).to_integer_32]).to_integer_32, (table64[(l_obuf[1]).to_integer_32]).to_integer_32, (table64[(l_obuf[2]).to_integer_32]).to_integer_32]).do_nothing
						l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, default:
						mprintf_inst.curl_msnprintf ([l_output, (5).to_natural_32, ce_string ("%%c%%c%%c%%c"), (table64[(l_obuf[0]).to_integer_32]).to_integer_32, (table64[(l_obuf[1]).to_integer_32]).to_integer_32, (table64[(l_obuf[2]).to_integer_32]).to_integer_32, (table64[(l_obuf[3]).to_integer_32]).to_integer_32]).do_nothing
						l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done:
						l_output.ce_gets (l_output + (4))
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
						l_output[0] := (0).to_integer_8
						a_outptr.item := l_base64data
						Result := (strlen (l_base64data))
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
