class
	P_COOKIE

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	freecookie (a_co: CE_POINTER [PD_COOKIE])
		do
			if ((a_co.item.expirestr).c_pointer /= default_pointer) then
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_co.item.expirestr)])
			end
			if ((a_co.item.domain).c_pointer /= default_pointer) then
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_co.item.domain)])
			end
			if ((a_co.item.path).c_pointer /= default_pointer) then
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_co.item.path)])
			end
			if ((a_co.item.name).c_pointer /= default_pointer) then
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_co.item.name)])
			end
			if ((a_co.item.value).c_pointer /= default_pointer) then
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_co.item.value)])
			end
			if ((a_co.item.maxage).c_pointer /= default_pointer) then
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_co.item.maxage)])
			end
			if ((a_co.item.version).c_pointer /= default_pointer) then
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_co.item.version)])
			end
			easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_co)])
		end

	tailmatch (a_little: CE_POINTER [INTEGER_8]; a_bigone: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_littlelen: NATURAL_32
			l_biglen: NATURAL_32
			js: JUMP_STATE
		do
			l_littlelen := (strlen (a_little))
			l_biglen := (strlen (a_bigone))
			if l_littlelen > l_biglen then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				Result := (rawstr_inst.Curl_raw_equal (a_little, (a_bigone + l_biglen.to_integer_32) - l_littlelen.to_integer_32)).to_boolean
			end
		end

	Curl_cookie_loadfiles (a_data: CE_POINTER [PD_SESSIONHANDLE])
		local
			l_list: CE_POINTER [PD_CURL_SLIST]
		do
			create l_list.make

			l_list.ce_gets (a_data.item.change.cookielist)
			if ((l_list).c_pointer /= default_pointer) then
				share_inst.Curl_share_lock (a_data, {PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_COOKIE, {PC_CURL_LOCK_ACCESS}.CURL_LOCK_ACCESS_SINGLE).do_nothing
				from
				until
					(l_list).c_pointer = default_pointer
				loop
					a_data.item.cookies := Curl_cookie_init (a_data, l_list.item.data, a_data.item.cookies, a_data.item.set.cookiesession)
					l_list.ce_gets (l_list.item.next)
				end
				share_inst.Curl_share_unlock (a_data, {PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_COOKIE).do_nothing
				slist_inst.curl_slist_free_all (a_data.item.change.cookielist)
				a_data.item.change.cookielist := create {CE_POINTER [PD_CURL_SLIST]}.make_shared (default_pointer)
			end
		end

	strstore (a_str: CE_POINTER [CE_POINTER [INTEGER_8]]; a_newstr: CE_POINTER [INTEGER_8])
		do
			if ((a_str.item).c_pointer /= default_pointer) then
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_str.item)])
			end
			a_str.item := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([a_newstr]))
		end

	Curl_cookie_add (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_c: CE_POINTER [PD_COOKIEINFO]; a_httpheader: BOOLEAN; a_lineptr: CE_POINTER [INTEGER_8]; a_domain: CE_POINTER [INTEGER_8]; a_path: CE_POINTER [INTEGER_8]): CE_POINTER [PD_COOKIE]
		local
			l_lineptr: CE_POINTER [INTEGER_8]
			l_clist: CE_POINTER [PD_COOKIE]
			l_name: CE_ARRAY [INTEGER_8]
			l_co: CE_POINTER [PD_COOKIE]
			l_lastc: CE_POINTER [PD_COOKIE]
			l_now: INTEGER_32
			l_replace_old: BOOLEAN
			l_badcookie: BOOLEAN
			l_ptr: CE_POINTER [INTEGER_8]
			l_sep: CE_POINTER [INTEGER_8]
			l_semiptr: CE_POINTER [INTEGER_8]
			l_what: CE_POINTER [INTEGER_8]
			l_tmp___3: INTEGER_32
			l_tmp___5: INTEGER_8
			l_whatptr: CE_POINTER [INTEGER_8]
			l_len: NATURAL_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_domptr: CE_POINTER [INTEGER_8]
			l_dotcount: INTEGER_32
			l_tailptr: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___23: INTEGER_32
			l_queryp: CE_POINTER [INTEGER_8]
			l_endslash: CE_POINTER [INTEGER_8]
			l_pathlen: NATURAL_32
			l_ptr___0: CE_POINTER [INTEGER_8]
			l_firstptr: CE_POINTER [INTEGER_8]
			l_tok_buf: CE_POINTER [INTEGER_8]
			l_fields: INTEGER_32
			l_tmp___38: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_lineptr.make
			create l_clist.make
			create l_name.make (<<1024>>)
			create l_co.make
			create l_lastc.make
			create l_ptr.make
			create l_sep.make
			create l_semiptr.make
			create l_what.make
			create l_whatptr.make
			create l_domptr.make
			create l_tailptr.make
			create l_tmp___11.make
			create l_queryp.make
			create l_endslash.make
			create l_ptr___0.make
			create l_firstptr.make
			create l_tok_buf.make
			create l_tmp___38.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lineptr.ce_gets (a_lineptr)
					l_lastc.ce_gets (create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer))
					l_now := (time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
					l_replace_old := (0).to_boolean
					l_badcookie := (0).to_boolean
					l_co.ce_gets (create {CE_POINTER [PD_COOKIE]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(1).to_natural_32, {PD_COOKIE}.sizeof.to_natural_32])))))
					if (l_co).c_pointer = default_pointer then
						Result := (create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 51 -- skip if block
					end
				when 1 then -- if:
						if not a_httpheader then
							l_pos := -1 + 35 -- skip if block
						end
				when 2 then -- if:
						l_what.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([(5000).to_natural_32])))))
						if (l_what).c_pointer = default_pointer then
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_co)])
							Result := (create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer))
							js.return
						end
						if js.return_called then
							l_pos := -1 + 34 -- skip if block
						end
				when 3 then -- if:
						l_semiptr.ce_gets ((strchr (l_lineptr, (';').code)))
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_lineptr[0]).to_boolean then
								if ((l_lineptr[0]).to_natural_8).to_integer_32 = 32 then
									l_tmp___3 := 1
								elseif ((l_lineptr[0]).to_natural_8).to_integer_32 = 9 then
									l_tmp___3 := 1
								else
									l_tmp___3 := 0
								end
								if not l_tmp___3.to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_lineptr.ce_gets (l_lineptr + 1)
							end
						end
						js.reset
						l_ptr.ce_gets (l_lineptr)
				when 4 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 33 -- skip loop
						end
				when 5 then -- loop body:
						js.reset
						l_sep.ce_gets ((strchr (l_ptr, ('=').code)))
						if (l_sep).c_pointer = default_pointer then
							l_pos := -1 + 30 -- skip if block
						end
				when 6 then -- if:
						if ((l_semiptr).c_pointer /= default_pointer) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___1
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 9 then -- else:
						if not ((l_semiptr.c_pointer.to_integer_32).to_natural_32 > (l_sep.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 28 -- skip if block
						end
				when 10 then -- if: | _L___1:
						l_tmp___5 := (0).to_integer_8
						l_what[0] := l_tmp___5
						l_name[0] := l_tmp___5
						if not (1 <= (sscanf ([l_ptr, ce_string ("%%1023[^;=]=%%4999[^;%R%N]"), l_name, l_what]))) then
							l_pos := -1 + 27 -- skip if block
						end
				when 11 then -- if:
						l_len := (strlen (l_what))
						from
						until
							js.loop_left
						loop
							js.reset
							if l_len.to_boolean then
								if ((l_what[(l_len - {NATURAL_32} 1).to_integer_32]).to_natural_8).to_integer_32 = 32 then
									l_tmp___7 := 1
								elseif ((l_what[(l_len - {NATURAL_32} 1).to_integer_32]).to_natural_8).to_integer_32 = 9 then
									l_tmp___7 := 1
								else
									l_tmp___7 := 0
								end
								if not l_tmp___7.to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_what[(l_len - {NATURAL_32} 1).to_integer_32] := (0).to_integer_8
								l_len := l_len - 1
							end
						end
						js.reset
						l_whatptr.ce_gets (l_what)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_whatptr[0]).to_boolean then
								if ((l_whatptr[0]).to_natural_8).to_integer_32 = 32 then
									l_tmp___8 := 1
								elseif ((l_whatptr[0]).to_natural_8).to_integer_32 = 9 then
									l_tmp___8 := 1
								else
									l_tmp___8 := 0
								end
								if not l_tmp___8.to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_whatptr.ce_gets (l_whatptr + 1)
							end
						end
						js.reset
						if not ((rawstr_inst.Curl_raw_equal (ce_string ("path"), l_name)).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						strstore (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (l_co.c_pointer + {PD_COOKIE}.path_offset), l_whatptr)
						if (l_co.item.path).c_pointer = default_pointer then
							l_badcookie := (1).to_boolean
							js.break
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 14 then -- else:
						if not ((rawstr_inst.Curl_raw_equal (ce_string ("domain"), l_name)).to_boolean) then
							l_pos := -1 + 26 -- skip if block
						end
				when 15 then -- if:
						l_domptr.ce_gets (l_whatptr)
						l_dotcount := 1
						if 46 = (l_whatptr[0]).to_integer_32 then
							l_domptr.ce_gets (l_domptr + 1)
						end
						from
						until
							js.loop_left
						loop
							js.reset
							l_domptr.ce_gets ((strchr (l_domptr, ('.').code)))
							if ((l_domptr).c_pointer /= default_pointer) then
								l_domptr.ce_gets (l_domptr + 1)
								l_dotcount := l_dotcount + 1
							end
							if (l_domptr).c_pointer = default_pointer then
								js.break
							end
						end
						js.reset
						if not (l_dotcount < 2) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_badcookie := (1).to_boolean
						sendf_inst.Curl_infof ([a_data, ce_string ("skipped cookie with illegal dotcount domain: %%s%N"), l_whatptr])
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 18 then -- else:
						if 46 = (l_whatptr[0]).to_integer_32 then
							l_whatptr.ce_gets (l_whatptr + 1)
						end
						if ((a_domain).c_pointer /= default_pointer) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 22 -- goto _L
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 21 then -- else:
						if not (tailmatch (l_whatptr, a_domain)) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if: | _L:
						l_tailptr.ce_gets (l_whatptr)
						if (l_tailptr[0]).to_integer_32 = 46 then
							l_tailptr.ce_gets (l_tailptr + 1)
						end
						strstore (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (l_co.c_pointer + {PD_COOKIE}.domain_offset), l_tailptr)
						if (l_co.item.domain).c_pointer = default_pointer then
							l_badcookie := (1).to_boolean
							js.break
						end
						if not js.loop_jumped then
							l_co.item.tailmatch := (1).to_boolean
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:
						l_badcookie := (1).to_boolean
						sendf_inst.Curl_infof ([a_data, ce_string ("skipped cookie with bad tailmatch domain: %%s%N"), l_whatptr])
				when 25 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						if (rawstr_inst.Curl_raw_equal (ce_string ("version"), l_name)).to_boolean then
							strstore (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (l_co.c_pointer + {PD_COOKIE}.version_offset), l_whatptr)
							if (l_co.item.version).c_pointer = default_pointer then
								l_badcookie := (1).to_boolean
								js.break
							end
						elseif (rawstr_inst.Curl_raw_equal (ce_string ("max-age"), l_name)).to_boolean then
							strstore (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (l_co.c_pointer + {PD_COOKIE}.maxage_offset), l_whatptr)
							if (l_co.item.maxage).c_pointer = default_pointer then
								l_badcookie := (1).to_boolean
								js.break
							end
							if not js.loop_jumped then
								if ((l_co.item.maxage).item).to_integer_32 = 34 then
									l_tmp___11.ce_gets (l_co.item.maxage + 1)
								else
									l_tmp___11.ce_gets (l_co.item.maxage + 0)
								end
								l_co.item.expires := ((atoi (l_tmp___11)).to_integer_32 + l_now).to_integer_64
							end
						elseif (rawstr_inst.Curl_raw_equal (ce_string ("expires"), l_name)).to_boolean then
							strstore (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (l_co.c_pointer + {PD_COOKIE}.expirestr_offset), l_whatptr)
							if (l_co.item.expirestr).c_pointer = default_pointer then
								l_badcookie := (1).to_boolean
								js.break
							end
							if not js.loop_jumped then
								l_co.item.expires := (parsedate_inst.curl_getdate (l_what, (create {CE_POINTER [INTEGER_32]}.make_shared ($l_now)))).to_integer_64
								if l_co.item.expires = {INTEGER_64} 0 then
									l_co.item.expires := (1).to_integer_64
								elseif l_co.item.expires < {INTEGER_64} 0 then
									l_co.item.expires := (0).to_integer_64
								end
							end
						elseif (l_co.item.name).c_pointer = default_pointer then
							l_co.item.name := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_name]))
							l_co.item.value := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_whatptr]))
							if (l_co.item.name).c_pointer = default_pointer then
								l_badcookie := (1).to_boolean
								js.break
							elseif (l_co.item.value).c_pointer = default_pointer then
								l_badcookie := (1).to_boolean
								js.break
							end
						end
				when 27 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:
						l_pos := -1 + 30 -- goto _L___0
				when 29 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else: | _L___0:
						if (sscanf ([l_ptr, ce_string ("%%4999[^;%R%N]"), l_what])).to_boolean then
							if (rawstr_inst.Curl_raw_equal (ce_string ("secure"), l_what)).to_boolean then
								l_co.item.secure := (1).to_boolean
							elseif (rawstr_inst.Curl_raw_equal (ce_string ("httponly"), l_what)).to_boolean then
								l_co.item.httponly := (1).to_boolean
							end
						end
				when 31 then
						if not js.loop_jumped then
							if (l_semiptr).c_pointer = default_pointer then
								l_semiptr.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								js.continue
							elseif not (l_semiptr[0]).to_boolean then
								l_semiptr.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								js.continue
							end
						end
						if not js.loop_jumped then
							l_ptr.ce_gets (l_semiptr + 1)
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_ptr[0]).to_boolean then
									if ((l_ptr[0]).to_natural_8).to_integer_32 = 32 then
										l_tmp___23 := 1
									elseif ((l_ptr[0]).to_natural_8).to_integer_32 = 9 then
										l_tmp___23 := 1
									else
										l_tmp___23 := 0
									end
									if not l_tmp___23.to_boolean then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_ptr.ce_gets (l_ptr + 1)
								end
							end
							js.reset
							l_semiptr.ce_gets ((strchr (l_ptr, (';').code)))
							if (l_semiptr).c_pointer = default_pointer then
								if (l_ptr[0]).to_boolean then
									l_semiptr.ce_gets ((strchr (l_ptr, ('%/0/').code)))
								end
							end
						end
						if not js.loop_left and then ((l_semiptr).c_pointer = default_pointer) then
							l_pos := -1 + 33 -- break
						end
				when 32 then
						l_pos := -1 + 4 -- back to loop condition
				when 33 then -- loop done
						js.reset
						if not l_badcookie then
							if (l_co.item.domain).c_pointer = default_pointer then
								if ((a_domain).c_pointer /= default_pointer) then
									l_co.item.domain := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([a_domain]))
									if (l_co.item.domain).c_pointer = default_pointer then
										l_badcookie := (1).to_boolean
									end
								end
							end
						end
						if not l_badcookie then
							if (l_co.item.path).c_pointer = default_pointer then
								if ((a_path).c_pointer /= default_pointer) then
									l_queryp.ce_gets ((strchr (a_path, ('?').code)))
									if (l_queryp).c_pointer = default_pointer then
										l_endslash.ce_gets (strrchr (a_path, ('/').code))
									else
										l_endslash.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((curl_memrchr_inst.Curl_memrchr (create {CE_POINTER [ANY]}.make_cast (a_path), ('/').code, (l_queryp.distance (a_path)).to_natural_32))))
									end
									if ((l_endslash).c_pointer /= default_pointer) then
										l_pathlen := ((l_endslash.distance (a_path)) + 1).to_natural_32
										l_co.item.path := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([l_pathlen + {NATURAL_32} 1]))))
										if ((l_co.item.path).c_pointer /= default_pointer) then
											memcpy (create {CE_POINTER [ANY]}.make_cast (l_co.item.path), create {CE_POINTER [ANY]}.make_cast (a_path), l_pathlen).do_nothing
											l_co.item.path[l_pathlen.to_integer_32] := (0).to_integer_8
										else
											l_badcookie := (1).to_boolean
										end
									end
								end
							end
						end
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_what)])
						if l_badcookie then
							freecookie (l_co)
							Result := (create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer))
							js.return
						elseif (l_co.item.name).c_pointer = default_pointer then
							freecookie (l_co)
							Result := (create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer))
							js.return
						end
				when 34 then -- if done | if block done, skip else block:
						l_pos := -1 + 51
				when 35 then -- else:
						l_tok_buf.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
						if (strncmp (l_lineptr, ce_string ("#HttpOnly_"), (10).to_natural_32)) = 0 then
							l_lineptr.ce_gets (l_lineptr + (10))
							l_co.item.httponly := (1).to_boolean
						end
						if (l_lineptr[0]).to_integer_32 = 35 then
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_co)])
							Result := (create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called then
							l_ptr___0.ce_gets (strchr (l_lineptr, ('%R').code))
							if ((l_ptr___0).c_pointer /= default_pointer) then
								l_ptr___0[0] := (0).to_integer_8
							end
							l_ptr___0.ce_gets (strchr (l_lineptr, ('%N').code))
							if ((l_ptr___0).c_pointer /= default_pointer) then
								l_ptr___0[0] := (0).to_integer_8
							end
							l_firstptr.ce_gets (strtok_r (l_lineptr, ce_string ("%T"), (l_tok_buf.address)))
							if (l_firstptr).c_pointer = default_pointer then
								easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_co)])
								Result := (create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer))
								js.return
							elseif (((strchr (l_firstptr, (':').code))).c_pointer /= default_pointer) then
								easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_co)])
								Result := (create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer))
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 51 -- skip if block
						end
				when 36 then -- if:
						l_ptr___0.ce_gets (l_firstptr)
						l_fields := 0
				when 37 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 50 -- skip loop
						end
				when 38 then -- loop body:
						js.reset
						if ((l_ptr___0).c_pointer /= default_pointer) then
							if l_badcookie then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 49 -- skip if block
						end
				when 39 then -- if:
						inspect l_fields -- switch 1 head
						when 0 then l_pos := -1 + 40
						when 1 then l_pos := -1 + 41
						when 2 then l_pos := -1 + 42
						when 3 then l_pos := -1 + 44
						when 4 then l_pos := -1 + 45
						when 5 then l_pos := -1 + 46
						when 6 then l_pos := -1 + 47
						else l_pos := -1 + 48
						end
				when 40 then -- switch 1, case 0
						if (l_ptr___0[0]).to_integer_32 = 46 then
							l_ptr___0.ce_gets (l_ptr___0 + 1)
						end
						l_co.item.domain := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_ptr___0]))
						if (l_co.item.domain).c_pointer = default_pointer then
							l_badcookie := (1).to_boolean
						end
						l_pos := -1 + 48 -- switch 1; break
				when 41 then -- switch 1, case 1
						l_co.item.tailmatch := (rawstr_inst.Curl_raw_equal (l_ptr___0, ce_string ("TRUE"))).to_boolean
						l_pos := -1 + 48 -- switch 1; break
				when 42 then -- switch 1, case 2
						if (strcmp (ce_string ("TRUE"), l_ptr___0)).to_boolean then
							if (strcmp (ce_string ("FALSE"), l_ptr___0)).to_boolean then
								l_co.item.path := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_ptr___0]))
								if (l_co.item.path).c_pointer = default_pointer then
									l_badcookie := (1).to_boolean
								end
								l_pos := -1 + 48 -- switch 1; break
							end
						end
				when 43 then
						l_co.item.path := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([ce_string ("/")]))
						if (l_co.item.path).c_pointer = default_pointer then
							l_badcookie := (1).to_boolean
						end
						l_fields := l_fields + 1
				when 44 then -- switch 1, case 3
						l_co.item.secure := (rawstr_inst.Curl_raw_equal (l_ptr___0, ce_string ("TRUE"))).to_boolean
						l_pos := -1 + 48 -- switch 1; break
				when 45 then -- switch 1, case 4
						l_co.item.expires := strtoll (l_ptr___0, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), 10)
						l_pos := -1 + 48 -- switch 1; break
				when 46 then -- switch 1, case 5
						l_co.item.name := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_ptr___0]))
						if (l_co.item.name).c_pointer = default_pointer then
							l_badcookie := (1).to_boolean
						end
						l_pos := -1 + 48 -- switch 1; break
				when 47 then -- switch 1, case 6
						l_co.item.value := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_ptr___0]))
						if (l_co.item.value).c_pointer = default_pointer then
							l_badcookie := (1).to_boolean
						end
						l_pos := -1 + 48 -- switch 1; break
				when 48 then -- switch 1, done:
						l_ptr___0.ce_gets (strtok_r (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("%T"), (l_tok_buf.address)))
						l_fields := l_fields + 1
				when 49 then -- if done
						l_pos := -1 + 37 -- back to loop condition
				when 50 then -- loop done
						js.reset
						if 6 = l_fields then
							l_co.item.value := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([ce_string ("")]))
							if (l_co.item.value).c_pointer = default_pointer then
								l_badcookie := (1).to_boolean
							else
								l_fields := l_fields + 1
							end
						end
						if not l_badcookie then
							if 7 /= l_fields then
								l_badcookie := (1).to_boolean
							end
						end
						if l_badcookie then
							freecookie (l_co)
							Result := (create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer))
							js.return
						end
				when 51 then -- if done | if done | if done
						if not js.return_called and then (not a_c.item.running) then
							if a_c.item.newsession then
								if not (l_co.item.expires).to_boolean then
									freecookie (l_co)
									Result := (create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer))
									js.return
								end
							end
						end
						if js.return_called then
							l_pos := -1 + 67 -- skip if block
						end
				when 52 then -- if:
							l_co.item.livecookie := a_c.item.running
							l_clist.ce_gets (a_c.item.cookies)
							l_replace_old := (0).to_boolean
				when 53 then -- loop condition:
							if not (not js.loop_left and then ((l_clist).c_pointer /= default_pointer)) then
								l_pos := -1 + 66 -- skip loop
							end
				when 54 then -- loop body:
							js.reset
							if not ((rawstr_inst.Curl_raw_equal (l_clist.item.name, l_co.item.name)).to_boolean) then
								l_pos := -1 + 65 -- skip if block
							end
				when 55 then -- if:
							if (l_clist.item.domain).c_pointer = default_pointer then
								l_pos := -1 + 58 -- skip if block
							end
				when 56 then -- if:
							if ((l_co.item.domain).c_pointer /= default_pointer) then
								if (rawstr_inst.Curl_raw_equal (l_clist.item.domain, l_co.item.domain)).to_boolean then
									l_replace_old := (1).to_boolean
								end
							else
								l_pos := -1 + 58 -- goto _L___2
							end
				when 57 then -- if block done, skip else block:
							l_pos := -1 + 59
				when 58 then -- else: | _L___2:
							if (l_clist.item.domain).c_pointer = default_pointer then
								if (l_co.item.domain).c_pointer = default_pointer then
									l_replace_old := (1).to_boolean
								end
							end
				when 59 then
							if not l_replace_old then
								l_pos := -1 + 64 -- skip if block
							end
				when 60 then -- if:
							if (l_clist.item.path).c_pointer = default_pointer then
								l_pos := -1 + 63 -- skip if block
							end
				when 61 then -- if:
							if ((l_co.item.path).c_pointer /= default_pointer) then
								if (rawstr_inst.Curl_raw_equal (l_clist.item.path, l_co.item.path)).to_boolean then
									l_replace_old := (1).to_boolean
								else
									l_replace_old := (0).to_boolean
								end
							else
								l_pos := -1 + 63 -- goto _L___3
							end
				when 62 then -- if block done, skip else block:
							l_pos := -1 + 64
				when 63 then -- else: | _L___3:
							if (l_clist.item.path).c_pointer = default_pointer then
								if (l_co.item.path).c_pointer = default_pointer then
									l_replace_old := (1).to_boolean
								else
									l_replace_old := (0).to_boolean
								end
							else
								l_replace_old := (0).to_boolean
							end
				when 64 then -- if done
							if l_replace_old then
								if not l_co.item.livecookie then
									if l_clist.item.livecookie then
										freecookie (l_co)
										Result := (create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer))
										js.return
									end
								end
							end
							if not js.return_called and then l_replace_old then
								l_co.item.next := l_clist.item.next
								easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_clist.item.name)])
								if ((l_clist.item.value).c_pointer /= default_pointer) then
									easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_clist.item.value)])
								end
								if ((l_clist.item.domain).c_pointer /= default_pointer) then
									easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_clist.item.domain)])
								end
								if ((l_clist.item.path).c_pointer /= default_pointer) then
									easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_clist.item.path)])
								end
								if ((l_clist.item.expirestr).c_pointer /= default_pointer) then
									easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_clist.item.expirestr)])
								end
								if ((l_clist.item.version).c_pointer /= default_pointer) then
									easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_clist.item.version)])
								end
								if ((l_clist.item.maxage).c_pointer /= default_pointer) then
									easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_clist.item.maxage)])
								end
								l_clist.item := l_co.item
								easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_co)])
								l_co.ce_gets (l_clist)
								from
								until
									js.loop_left
								loop
									js.reset
									l_lastc.ce_gets (l_clist)
									l_clist.ce_gets (l_clist.item.next)
									if (l_clist).c_pointer = default_pointer then
										js.break
									end
								end
								js.reset
								js.break
							end
				when 65 then -- if done
							if not js.loop_jumped then
								l_lastc.ce_gets (l_clist)
								l_clist.ce_gets (l_clist.item.next)
							end
							l_pos := -1 + 53 -- back to loop condition
				when 66 then -- loop done
							js.reset
				when 67 then -- if done
						if not js.return_called then
							if a_c.item.running then
								if l_replace_old then
									l_tmp___38.ce_gets (ce_string ("Replaced"))
								else
									l_tmp___38.ce_gets (ce_string ("Added"))
								end
								sendf_inst.Curl_infof ([a_data, ce_string ("%%s cookie %%s=%"%%s%" for domain %%s, path %%s, expire %%lld%N"), l_tmp___38, l_co.item.name, l_co.item.value, l_co.item.domain, l_co.item.path, l_co.item.expires])
							end
							if not l_replace_old then
								if ((l_lastc).c_pointer /= default_pointer) then
									l_lastc.item.next := l_co
								else
									a_c.item.cookies := l_co
								end
							end
							a_c.item.numcookies := (a_c.item.numcookies) + 1
							Result := l_co
						end
				when 68 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	Curl_cookie_init (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_file: CE_POINTER [INTEGER_8]; a_inc: CE_POINTER [PD_COOKIEINFO]; a_newsession: BOOLEAN): CE_POINTER [PD_COOKIEINFO]
		local
			l_c: CE_POINTER [PD_COOKIEINFO]
			l_fp: CE_POINTER [SD_IO_FILE]
			l_fromfile: BOOLEAN
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_lineptr: CE_POINTER [INTEGER_8]
			l_headerline: BOOLEAN
			l_line: CE_POINTER [INTEGER_8]
			l_tmp___6: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_c.make
			create l_fp.make
			create l_tmp___0.make
			create l_lineptr.make
			create l_line.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fromfile := (1).to_boolean
					if (0).to_natural_32 = (a_inc.c_pointer.to_integer_32).to_natural_32 then
						l_c.ce_gets (create {CE_POINTER [PD_COOKIEINFO]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(1).to_natural_32, {PD_COOKIEINFO}.sizeof.to_natural_32])))))
						if (l_c).c_pointer = default_pointer then
							Result := (create {CE_POINTER [PD_COOKIEINFO]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called then
							if ((a_file).c_pointer /= default_pointer) then
								l_tmp___0.ce_gets (a_file)
							else
								l_tmp___0.ce_gets (ce_string ("none"))
							end
							l_c.item.filename := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_tmp___0]))
						end
					else
						l_c.ce_gets (a_inc)
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						l_c.item.running := (0).to_boolean
						if (a_file).c_pointer = default_pointer then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (strequal_inst.curl_strequal (a_file, ce_string ("-"))).to_boolean then
							l_fp.ce_gets ((create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.input.file_pointer)))
							l_fromfile := (0).to_boolean
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if (a_file).c_pointer = default_pointer then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if not (a_file[0]).to_boolean then
							l_fp.ce_gets (create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer))
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if ((a_file).c_pointer /= default_pointer) then
							l_fp.ce_gets ((fopen (a_file, ce_string ("r"))))
						else
							l_fp.ce_gets (create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer))
						end
				when 8 then -- if done
						l_c.item.newsession := a_newsession
						if ((l_fp).c_pointer /= default_pointer) then
							l_line.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([(5000).to_natural_32])))))
							if ((l_line).c_pointer /= default_pointer) then
								from
								until
									js.loop_left
								loop
									js.reset
									if ((fgets (l_line, 5000, l_fp))).c_pointer = default_pointer then
										js.break
									end
									if not js.loop_jumped then
										if (rawstr_inst.Curl_raw_nequal (ce_string ("Set-Cookie:"), l_line, (strlen (ce_string ("Set-Cookie:"))))).to_boolean then
											l_lineptr.ce_gets (l_line + 11)
											l_headerline := (1).to_boolean
										else
											l_lineptr.ce_gets (l_line)
											l_headerline := (0).to_boolean
										end
										from
										until
											js.loop_left
										loop
											js.reset
											if (l_lineptr[0]).to_boolean then
												if ((l_lineptr[0]).to_natural_8).to_integer_32 = 32 then
													l_tmp___6 := 1
												elseif ((l_lineptr[0]).to_natural_8).to_integer_32 = 9 then
													l_tmp___6 := 1
												else
													l_tmp___6 := 0
												end
												if not l_tmp___6.to_boolean then
													js.break
												end
											else
												js.break
											end
											if not js.loop_jumped then
												l_lineptr.ce_gets (l_lineptr + 1)
											end
										end
										js.reset
										Curl_cookie_add (a_data, l_c, l_headerline, l_lineptr, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)).do_nothing
									end
								end
								js.reset
								easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_line)])
							end
							if l_fromfile then
								fclose (l_fp).do_nothing
							end
						end
						l_c.item.running := (1).to_boolean
						Result := l_c
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cookie_sort (a_p1: CE_POINTER [ANY]; a_p2: CE_POINTER [ANY]): INTEGER_32
		local
			l_c1: CE_POINTER [PD_COOKIE]
			l_c2: CE_POINTER [PD_COOKIE]
			l_l1: NATURAL_32
			l_tmp___0: NATURAL_32
			l_l2: NATURAL_32
			l_tmp___2: NATURAL_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
		do
			create l_c1.make
			create l_c2.make

			l_c1.ce_gets ((create {CE_POINTER [CE_POINTER [PD_COOKIE]]}.make_cast (a_p1)).item)
			l_c2.ce_gets ((create {CE_POINTER [CE_POINTER [PD_COOKIE]]}.make_cast (a_p2)).item)
			if ((l_c1.item.path).c_pointer /= default_pointer) then
				l_tmp___0 := (strlen (l_c1.item.path))
			else
				l_tmp___0 := (0).to_natural_32
			end
			l_l1 := l_tmp___0
			if ((l_c2.item.path).c_pointer /= default_pointer) then
				l_tmp___2 := (strlen (l_c2.item.path))
			else
				l_tmp___2 := (0).to_natural_32
			end
			l_l2 := l_tmp___2
			if l_l2 > l_l1 then
				l_tmp___4 := 1
			else
				if l_l2 < l_l1 then
					l_tmp___3 := -1
				else
					l_tmp___3 := 0
				end
				l_tmp___4 := l_tmp___3
			end
			Result := l_tmp___4
		end

	cookie_sort_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cookie_sort)
		end

	Curl_cookie_getlist (a_c: CE_POINTER [PD_COOKIEINFO]; a_host: CE_POINTER [INTEGER_8]; a_path: CE_POINTER [INTEGER_8]; a_secure: BOOLEAN): CE_POINTER [PD_COOKIE]
		local
			l_newco: CE_POINTER [PD_COOKIE]
			l_co: CE_POINTER [PD_COOKIE]
			l_now: INTEGER_32
			l_mainco: CE_POINTER [PD_COOKIE]
			l_matches: NATURAL_32
			l_tmp___5: INTEGER_32
			l_array: CE_POINTER [CE_POINTER [PD_COOKIE]]
			l_i: NATURAL_32
			l_tmp___7: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_newco.make
			create l_co.make
			create l_mainco.make
			create l_array.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_now := (time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
					l_mainco.ce_gets (create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer))
					l_matches := (0).to_natural_32
					if (a_c).c_pointer = default_pointer then
						Result := (create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer))
						js.return
					elseif (a_c.item.cookies).c_pointer = default_pointer then
						Result := (create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 25 -- skip if block
					end
				when 1 then -- if:
						l_co.ce_gets (a_c.item.cookies)
				when 2 then -- loop condition:
						if not (not js.loop_left and then ((l_co).c_pointer /= default_pointer)) then
							l_pos := -1 + 25 -- skip loop
						end
				when 3 then -- loop body:
						if (l_co.item.expires).to_boolean then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___2
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 6 then -- else:
						if not (l_co.item.expires > l_now.to_integer_64) then
							l_pos := -1 + 24 -- skip if block
						end
				when 7 then -- if: | _L___2:
						if l_co.item.secure then
							l_tmp___5 := a_secure.to_integer
						else
							l_tmp___5 := 1
						end
						if not (l_tmp___5.to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 8 then -- if:
						if ((l_co.item.domain).c_pointer /= default_pointer) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 16 -- goto _L___0
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 11 then -- else:
						if not (l_co.item.tailmatch) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if (tailmatch (l_co.item.domain, a_host)) then
							l_pos := -1 + 16 -- goto _L___0
						else
							l_pos := -1 + 14 -- goto _L___1
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 14 then -- else: | _L___1:
						if l_co.item.tailmatch then
							l_pos := -1 + 24 -- skip if block
						end
				when 15 then -- if:
						if not ((rawstr_inst.Curl_raw_equal (a_host, l_co.item.domain)).to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 16 then -- if: | _L___0:
						if ((l_co.item.path).c_pointer /= default_pointer) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 19 then -- else:
						if (strncmp (l_co.item.path, a_path, (strlen (l_co.item.path)))).to_boolean then
							l_pos := -1 + 24 -- skip if block
						end
				when 20 then -- if: | _L:
						l_newco.ce_gets (create {CE_POINTER [PD_COOKIE]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([{PD_COOKIE}.sizeof.to_natural_32])))))
						if (l_newco).c_pointer = default_pointer then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						memcpy (create {CE_POINTER [ANY]}.make_cast (l_newco), create {CE_POINTER [ANY]}.make_cast (l_co), {PD_COOKIE}.sizeof.to_natural_32).do_nothing
						l_newco.item.next := l_mainco
						l_mainco.ce_gets (l_newco)
						l_matches := l_matches + 1
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else: | fail:
						from
						until
							(l_mainco).c_pointer = default_pointer
						loop
							l_co.ce_gets (l_mainco.item.next)
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_mainco)])
							l_mainco.ce_gets (l_co)
						end
						Result := (create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer))
						js.return
				when 24 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done
						if not js.return_called then
							l_co.ce_gets (l_co.item.next)
						end
						l_pos := -1 + 2 -- back to loop condition
				when 25 then -- loop done | if done
						if js.return_called then
							l_pos := -1 + 30 -- skip if block
						end
				when 26 then -- if:
							if not (l_matches.to_boolean) then
								l_pos := -1 + 29 -- skip if block
							end
				when 27 then -- if:
							l_array.ce_gets (create {CE_POINTER [CE_POINTER [PD_COOKIE]]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([Pointer_bytes.to_natural_32 * l_matches])))))
							if (l_array).c_pointer = default_pointer then
								l_pos := -1 + 23 -- goto fail
							end
				when 28 then
							l_co.ce_gets (l_mainco)
							l_i := (0).to_natural_32
							from
							until
								(l_co).c_pointer = default_pointer
							loop
								l_tmp___7 := l_i
								l_i := l_i + 1
								l_array[l_tmp___7.to_integer_32] := l_co
								l_co.ce_gets (l_co.item.next)
							end
							qsort (create {CE_POINTER [ANY]}.make_cast (l_array), l_matches, Pointer_bytes.to_natural_32, cookie_sort_address)
							l_mainco.ce_gets (l_array[0])
							l_i := (0).to_natural_32
							from
							until
								not (l_i < l_matches - {NATURAL_32} 1)
							loop
								(l_array[l_i.to_integer_32]).item.next := l_array[(l_i + {NATURAL_32} 1).to_integer_32]
								l_i := l_i + 1
							end
							(l_array[(l_matches - {NATURAL_32} 1).to_integer_32]).item.next := create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer)
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_array)])
				when 29 then -- if done
							Result := l_mainco
				when 30 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	Curl_cookie_clearall (a_cookies: CE_POINTER [PD_COOKIEINFO])
		do
			if ((a_cookies).c_pointer /= default_pointer) then
				Curl_cookie_freelist (a_cookies.item.cookies, (1).to_boolean)
				a_cookies.item.cookies := create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer)
				a_cookies.item.numcookies := 0
			end
		end

	Curl_cookie_freelist (a_co: CE_POINTER [PD_COOKIE]; a_cookiestoo: BOOLEAN)
		local
			l_co: CE_POINTER [PD_COOKIE]
			l_next: CE_POINTER [PD_COOKIE]
		do
			create l_co.make
			create l_next.make

			l_co.ce_gets (a_co)
			if ((l_co).c_pointer /= default_pointer) then
				from
				until
					(l_co).c_pointer = default_pointer
				loop
					l_next.ce_gets (l_co.item.next)
					if a_cookiestoo then
						freecookie (l_co)
					else
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_co)])
					end
					l_co.ce_gets (l_next)
				end
			end
		end

	Curl_cookie_clearsess (a_cookies: CE_POINTER [PD_COOKIEINFO])
		local
			l_first: CE_POINTER [PD_COOKIE]
			l_curr: CE_POINTER [PD_COOKIE]
			l_next: CE_POINTER [PD_COOKIE]
			l_prev: CE_POINTER [PD_COOKIE]
			js: JUMP_STATE
		do
			create l_first.make
			create l_curr.make
			create l_next.make
			create l_prev.make

			l_prev.ce_gets (create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer))
			if (a_cookies).c_pointer = default_pointer then
				js.return
			elseif (a_cookies.item.cookies).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				l_prev.ce_gets (a_cookies.item.cookies)
				l_curr.ce_gets (l_prev)
				l_first.ce_gets (l_curr)
				from
				until
					(l_curr).c_pointer = default_pointer
				loop
					l_next.ce_gets (l_curr.item.next)
					if not (l_curr.item.expires).to_boolean then
						if (l_first.c_pointer.to_integer_32).to_natural_32 = (l_curr.c_pointer.to_integer_32).to_natural_32 then
							l_first.ce_gets (l_next)
						end
						if (l_prev.c_pointer.to_integer_32).to_natural_32 = (l_curr.c_pointer.to_integer_32).to_natural_32 then
							l_prev.ce_gets (l_next)
						else
							l_prev.item.next := l_next
						end
						freecookie (l_curr)
						a_cookies.item.numcookies := (a_cookies.item.numcookies) - 1
					else
						l_prev.ce_gets (l_curr)
					end
					l_curr.ce_gets (l_next)
				end
				a_cookies.item.cookies := l_first
			end
		end

	Curl_cookie_cleanup (a_c: CE_POINTER [PD_COOKIEINFO])
		local
			l_co: CE_POINTER [PD_COOKIE]
			l_next: CE_POINTER [PD_COOKIE]
		do
			create l_co.make
			create l_next.make

			if ((a_c).c_pointer /= default_pointer) then
				if ((a_c.item.filename).c_pointer /= default_pointer) then
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_c.item.filename)])
				end
				l_co.ce_gets (a_c.item.cookies)
				from
				until
					(l_co).c_pointer = default_pointer
				loop
					l_next.ce_gets (l_co.item.next)
					freecookie (l_co)
					l_co.ce_gets (l_next)
				end
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_c)])
			end
		end

	get_netscape_format (a_co: CE_POINTER [PD_COOKIE]): CE_POINTER [INTEGER_8]
		local
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
		do
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make

			if ((a_co.item.value).c_pointer /= default_pointer) then
				l_tmp.ce_gets (a_co.item.value)
			else
				l_tmp.ce_gets (ce_string (""))
			end
			if a_co.item.secure then
				l_tmp___0.ce_gets (ce_string ("TRUE"))
			else
				l_tmp___0.ce_gets (ce_string ("FALSE"))
			end
			if ((a_co.item.path).c_pointer /= default_pointer) then
				l_tmp___1.ce_gets (a_co.item.path)
			else
				l_tmp___1.ce_gets (ce_string ("/"))
			end
			if a_co.item.tailmatch then
				l_tmp___2.ce_gets (ce_string ("TRUE"))
			else
				l_tmp___2.ce_gets (ce_string ("FALSE"))
			end
			if ((a_co.item.domain).c_pointer /= default_pointer) then
				l_tmp___3.ce_gets (a_co.item.domain)
			else
				l_tmp___3.ce_gets (ce_string ("unknown"))
			end
			if a_co.item.tailmatch then
				if ((a_co.item.domain).c_pointer /= default_pointer) then
					if (a_co.item.domain[0]).to_integer_32 /= 46 then
						l_tmp___4.ce_gets (ce_string ("."))
					else
						l_tmp___4.ce_gets (ce_string (""))
					end
				else
					l_tmp___4.ce_gets (ce_string (""))
				end
			else
				l_tmp___4.ce_gets (ce_string (""))
			end
			if a_co.item.httponly then
				l_tmp___5.ce_gets (ce_string ("#HttpOnly_"))
			else
				l_tmp___5.ce_gets (ce_string (""))
			end
			Result := (mprintf_inst.curl_maprintf ([ce_string ("%%s%%s%%s%T%%s%T%%s%T%%s%T%%lld%T%%s%T%%s"), l_tmp___5, l_tmp___4, l_tmp___3, l_tmp___2, l_tmp___1, l_tmp___0, a_co.item.expires, a_co.item.name, l_tmp]))
		end

	Curl_cookie_output (a_c: CE_POINTER [PD_COOKIEINFO]; a_dumphere: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_co: CE_POINTER [PD_COOKIE]
			l_out: CE_POINTER [SD_IO_FILE]
			l_use_stdout: BOOLEAN
			l_format_ptr: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_co.make
			create l_out.make
			create l_format_ptr.make

			l_use_stdout := (0).to_boolean
			if (0).to_natural_32 = (a_c.c_pointer.to_integer_32).to_natural_32 then
				Result := 0
				js.return
			elseif 0 = a_c.item.numcookies then
				Result := 0
				js.return
			end
			if not js.return_called then
				if (strequal_inst.curl_strequal (ce_string ("-"), a_dumphere)).to_boolean then
					l_out.ce_gets ((create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer)))
					l_use_stdout := (1).to_boolean
				else
					l_out.ce_gets (fopen (a_dumphere, ce_string ("w")))
					if (l_out).c_pointer = default_pointer then
						Result := 1
						js.return
					end
				end
			end
			if not js.return_called and then ((a_c).c_pointer /= default_pointer) then
				fputs (ce_string ("# Netscape HTTP Cookie File%N# http://curl.haxx.se/rfc/cookie_spec.html%N# This file was generated by libcurl! Edit at your own risk.%N%N"), l_out).do_nothing
				l_co.ce_gets (a_c.item.cookies)
				from
				until
					not (not js.loop_left and then ((l_co).c_pointer /= default_pointer))
				loop
					l_format_ptr.ce_gets (get_netscape_format (l_co))
					if (l_format_ptr.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						mprintf_inst.curl_mfprintf ([l_out, ce_string ("#%N# Fatal libcurl error%N")]).do_nothing
						if not l_use_stdout then
							fclose (l_out).do_nothing
						end
						Result := 1
						js.return
					end
					if not js.return_called then
						mprintf_inst.curl_mfprintf ([l_out, ce_string ("%%s%N"), l_format_ptr]).do_nothing
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_format_ptr)])
						l_co.ce_gets (l_co.item.next)
					end
				end
			end
			if not js.return_called then
				if not l_use_stdout then
					fclose (l_out).do_nothing
				end
				Result := 0
			end
		end

	Curl_cookie_list (a_data: CE_POINTER [PD_SESSIONHANDLE]): CE_POINTER [PD_CURL_SLIST]
		local
			l_list: CE_POINTER [PD_CURL_SLIST]
			l_beg: CE_POINTER [PD_CURL_SLIST]
			l_c: CE_POINTER [PD_COOKIE]
			l_line: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_list.make
			create l_beg.make
			create l_c.make
			create l_line.make

			l_list.ce_gets (create {CE_POINTER [PD_CURL_SLIST]}.make_shared (default_pointer))
			if ((a_data.item.cookies).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (create {CE_POINTER [PD_CURL_SLIST]}.make_shared (default_pointer))
				js.return
			elseif (a_data.item.cookies).item.numcookies = 0 then
				Result := (create {CE_POINTER [PD_CURL_SLIST]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_c.ce_gets ((a_data.item.cookies).item.cookies)
				l_beg.ce_gets (l_list)
				from
				until
					not (not js.loop_left and then ((l_c).c_pointer /= default_pointer))
				loop
					l_line.ce_gets (get_netscape_format (l_c))
					if (l_line.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						slist_inst.curl_slist_free_all (l_beg)
						Result := (create {CE_POINTER [PD_CURL_SLIST]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						l_list.ce_gets (slist_inst.curl_slist_append (l_list, l_line))
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_line)])
						if (l_list.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							slist_inst.curl_slist_free_all (l_beg)
							Result := (create {CE_POINTER [PD_CURL_SLIST]}.make_shared (default_pointer))
							js.return
						elseif (l_beg.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_beg.ce_gets (l_list)
						end
					end
					if not js.return_called then
						l_c.ce_gets (l_c.item.next)
					end
				end
			end
			if not js.return_called then
				Result := l_list
			end
		end

end
