class
	P_EASY

inherit
	LIBCURL_DATA
		redefine
			default_create
		end
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create Curl_cmalloc.make
			create Curl_cfree.make
			create Curl_crealloc.make
			create Curl_cstrdup.make
			create Curl_ccalloc.make
		end

feature {ANY} -- attributes

	initialized: NATURAL_32 assign set_initialized

	set_initialized (a_initialized: NATURAL_32)
		do
			initialized := a_initialized
		end

	init_flags: INTEGER_32 assign set_init_flags

	set_init_flags (a_init_flags: INTEGER_32)
		do
			init_flags := a_init_flags
		end

	Curl_cmalloc: CE_ROUTINE

	Curl_cfree: CE_ROUTINE

	Curl_crealloc: CE_ROUTINE

	Curl_cstrdup: CE_ROUTINE

	Curl_ccalloc: CE_ROUTINE

feature {ANY} -- routines

	win32_cleanup
		do
		end

	win32_init: INTEGER_32
		do
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	curl_global_init (a_flags: INTEGER_32): INTEGER_32
		local
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			l_tmp := initialized
			initialized := initialized + 1
			if l_tmp.to_boolean then
				Result := ({PC_CURLCODE}.CURLE_OK)
				js.return
			end
			if not js.return_called then
				Curl_cmalloc.ce_gets (malloc_address)
				Curl_cfree.ce_gets (free_address)
				Curl_crealloc.ce_gets (realloc_address)
				Curl_cstrdup.ce_gets (strdup_address)
				Curl_ccalloc.ce_gets (calloc_address)
				if ((a_flags).bit_and (((1).bit_shift_left (1)).to_integer_32)).to_boolean then
					if (win32_init).to_natural_32 /= {NATURAL_32} 0 then
						Result := ({PC_CURLCODE}.CURLE_FAILED_INIT)
						js.return
					end
				end
			end
			if not js.return_called then
				init_flags := a_flags
				curl_rand_inst.Curl_srand
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	curl_global_init_mem (a_flags: INTEGER_32; a_m: CE_ROUTINE; a_f: CE_ROUTINE; a_r: CE_ROUTINE; a_s: CE_ROUTINE; a_c: CE_ROUTINE): INTEGER_32
		local
			l_code: INTEGER_32
			js: JUMP_STATE
		do
			l_code := {PC_CURLCODE}.CURLE_OK
			if (a_m).c_pointer = default_pointer then
				Result := ({PC_CURLCODE}.CURLE_FAILED_INIT)
				js.return
			elseif (a_f).c_pointer = default_pointer then
				Result := ({PC_CURLCODE}.CURLE_FAILED_INIT)
				js.return
			elseif (a_r).c_pointer = default_pointer then
				Result := ({PC_CURLCODE}.CURLE_FAILED_INIT)
				js.return
			elseif (a_s).c_pointer = default_pointer then
				Result := ({PC_CURLCODE}.CURLE_FAILED_INIT)
				js.return
			elseif (a_c).c_pointer = default_pointer then
				Result := ({PC_CURLCODE}.CURLE_FAILED_INIT)
				js.return
			end
			if not js.return_called and then (initialized.to_boolean) then
				Result := ({PC_CURLCODE}.CURLE_OK)
				js.return
			end
			if not js.return_called then
				l_code := curl_global_init (a_flags)
				if l_code.to_natural_32 = {NATURAL_32} 0 then
					Curl_cmalloc.ce_gets (a_m)
					Curl_cfree.ce_gets (a_f)
					Curl_cstrdup.ce_gets (a_s)
					Curl_crealloc.ce_gets (a_r)
					Curl_ccalloc.ce_gets (a_c)
				end
				Result := l_code
			end
		end

	curl_global_cleanup
		local
			js: JUMP_STATE
		do
			if not initialized.to_boolean then
				js.return
			end
			if not js.return_called then
				initialized := initialized - 1
				if initialized.to_boolean then
					js.return
				end
			end
			if not js.return_called then
				hostip_inst.Curl_global_host_cache_dtor
				if ((init_flags).bit_and (1)).to_boolean then
				end
				if ((init_flags).bit_and (((1).bit_shift_left (1)).to_integer_32)).to_boolean then
					win32_cleanup
				end
				init_flags := 0
			end
		end

	curl_easy_init: CE_POINTER [ANY]
		local
			l_res: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
		do
			create l_data.make

			if not initialized.to_boolean then
				l_res := curl_global_init (((1).bit_or (((1).bit_shift_left (1)))).to_integer_32)
				if l_res.to_boolean then
					Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				l_res := url_inst.Curl_open (l_data.address)
				if l_res.to_natural_32 /= {NATURAL_32} 0 then
					Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [ANY]}.make_cast (l_data))
			end
		end

	curl_easy_setopt (a_args: TUPLE [a_curl: CE_POINTER [ANY]; a_tag: INTEGER_32]): INTEGER_32
		local
			l_arg: CE_VA_LIST
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_ret: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_data.ce_gets (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_args.a_curl))
			if (a_args.a_curl).c_pointer = default_pointer then
				Result := ({PC_CURLCODE}.CURLE_BAD_FUNCTION_ARGUMENT)
				js.return
			end
			if not js.return_called then
				create l_arg.make (a_args, 3)
				l_ret := url_inst.Curl_setopt (l_data, a_args.a_tag, l_arg)
				Result := l_ret
			end
		end

	curl_easy_perform (a_curl: CE_POINTER [ANY]): INTEGER_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_ptr: CE_POINTER [PD_CURL_HASH]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make
			create l_ptr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data.ce_gets (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_curl))
					if (l_data).c_pointer = default_pointer then
						Result := ({PC_CURLCODE}.CURLE_BAD_FUNCTION_ARGUMENT)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if (l_data.item.share).c_pointer = default_pointer then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if ((l_data.item.share).item.hostcache).c_pointer = default_pointer then
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_data.item.set.global_dns_cache then
							if (l_data.item.dns.hostcachetype).to_natural_32 /= {NATURAL_32} 2 then
								if (l_data.item.dns.hostcachetype).to_natural_32 = {NATURAL_32} 1 then
									hash_inst.Curl_hash_destroy (l_data.item.dns.hostcache)
									l_data.item.dns.hostcachetype := {PC_HOSTCACHETYPE}.HCACHE_NONE
									l_data.item.dns.hostcache := create {CE_POINTER [PD_CURL_HASH]}.make_shared (default_pointer)
								end
								l_ptr.ce_gets (hostip_inst.Curl_global_host_cache_init)
								if ((l_ptr).c_pointer /= default_pointer) then
									l_data.item.dns.hostcache := l_ptr
									l_data.item.dns.hostcachetype := {PC_HOSTCACHETYPE}.HCACHE_GLOBAL
								end
							end
						end
						if (l_data.item.dns.hostcache).c_pointer = default_pointer then
							l_data.item.dns.hostcachetype := {PC_HOSTCACHETYPE}.HCACHE_PRIVATE
							l_data.item.dns.hostcache := hostip_inst.Curl_mk_dnscache
							if (l_data.item.dns.hostcache).c_pointer = default_pointer then
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								js.return
							end
						end
				when 5 then -- if done
						if not js.return_called and then ((l_data.item.state.connc).c_pointer = default_pointer) then
							l_data.item.state.connc := url_inst.Curl_mk_connc (0, -1)
							if (l_data.item.state.connc).c_pointer = default_pointer then
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								js.return
							end
						end
						if not js.return_called then
							Result := (transfer_inst.Curl_perform (l_data))
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	curl_easy_cleanup (a_curl: CE_POINTER [ANY])
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
		do
			create l_data.make

			l_data.ce_gets (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_curl))
			if (l_data).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				url_inst.Curl_close (l_data).do_nothing
			end
		end

	Curl_easy_addmulti (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_multi: CE_POINTER [ANY])
		do
			a_data.item.multi := create {CE_POINTER [PD_CURL_MULTI]}.make_cast (a_multi)
			if (a_multi.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				a_data.item.state.used_interface := {PC_USED_INTERFACE}.Curl_if_none
			end
		end

	Curl_easy_initHandleData (a_data: CE_POINTER [PD_SESSIONHANDLE])
		do
			memset (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_SINGLEREQUEST]}.make_shared (a_data.c_pointer + {PD_SESSIONHANDLE}.req_offset))), 0, {PD_SINGLEREQUEST}.sizeof.to_natural_32).do_nothing
			a_data.item.req.maxdownload := (-1).to_integer_64
		end

	curl_easy_getinfo (a_args: TUPLE [a_curl: CE_POINTER [ANY]; a_info: INTEGER_32]): INTEGER_32
		local
			l_arg: CE_VA_LIST
			l_paramp: CE_POINTER [ANY]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			create l_paramp.make
			create l_data.make

			l_data.ce_gets (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_args.a_curl))
			create l_arg.make (a_args, 3)
			l_paramp.ce_gets ((create {CE_POINTER [ANY]}.make_cast (l_arg.pointer_item)))
			Result := (getinfo_inst.Curl_getinfo ([l_data, a_args.a_info, l_paramp]))
		end

	curl_easy_duphandle (a_incurl: CE_POINTER [ANY]): CE_POINTER [ANY]
		local
			l_fail: BOOLEAN
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_outcurl: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
		do
			create l_data.make
			create l_outcurl.make

			l_fail := (1).to_boolean
			l_data.ce_gets (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_incurl))
			l_outcurl.ce_gets (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (Curl_ccalloc.pointer_item ([(1).to_natural_32, {PD_SESSIONHANDLE}.sizeof.to_natural_32])))))
			if (0).to_natural_32 = (l_outcurl.c_pointer.to_integer_32).to_natural_32 then
				Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_outcurl.item.state.headerbuff := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (Curl_cmalloc.pointer_item ([(256).to_natural_32]))))
					if (l_outcurl.item.state.headerbuff).c_pointer = default_pointer then
						js.break
					end
					if not js.loop_jumped then
						l_outcurl.item.state.headersize := (256).to_natural_32
						if (url_inst.Curl_dupset (l_outcurl, l_data)).to_natural_32 /= {NATURAL_32} 0 then
							js.break
						end
					end
					if not js.loop_jumped then
						l_outcurl.item.state.connc := create {CE_POINTER [PD_CONNCACHE]}.make_shared (default_pointer)
						l_outcurl.item.state.lastconnect := -1
						l_outcurl.item.progress.flags := l_data.item.progress.flags
						l_outcurl.item.progress.callback := l_data.item.progress.callback
						if ((l_data.item.cookies).c_pointer /= default_pointer) then
							l_outcurl.item.cookies := cookie_inst.Curl_cookie_init (l_data, (l_data.item.cookies).item.filename, l_outcurl.item.cookies, l_data.item.set.cookiesession)
							if (l_outcurl.item.cookies).c_pointer = default_pointer then
								js.break
							end
						end
					end
					if not js.loop_jumped and then ((l_data.item.change.cookielist).c_pointer /= default_pointer) then
						l_outcurl.item.change.cookielist := slist_inst.Curl_slist_duplicate (l_data.item.change.cookielist)
						if (l_outcurl.item.change.cookielist).c_pointer = default_pointer then
							js.break
						end
					end
					if not js.loop_jumped and then ((l_data.item.change.url).c_pointer /= default_pointer) then
						l_outcurl.item.change.url := create {CE_POINTER [INTEGER_8]}.make_cast (Curl_cstrdup.pointer_item ([l_data.item.change.url]))
						if (l_outcurl.item.change.url).c_pointer = default_pointer then
							js.break
						end
						if not js.loop_jumped then
							l_outcurl.item.change.url_alloc := (1).to_boolean
						end
					end
					if not js.loop_jumped and then ((l_data.item.change.referer).c_pointer /= default_pointer) then
						l_outcurl.item.change.referer := create {CE_POINTER [INTEGER_8]}.make_cast (Curl_cstrdup.pointer_item ([l_data.item.change.referer]))
						if (l_outcurl.item.change.referer).c_pointer = default_pointer then
							js.break
						end
						if not js.loop_jumped then
							l_outcurl.item.change.referer_alloc := (1).to_boolean
						end
					end
					if not js.loop_jumped then
						Curl_easy_initHandleData (l_outcurl)
						l_outcurl.item.magic := {NATURAL_32} 3235830701
						l_fail := (0).to_boolean
						js.break
					end
				end
				js.reset
				if l_fail then
					if ((l_outcurl).c_pointer /= default_pointer) then
						if ((l_outcurl.item.state.connc).c_pointer /= default_pointer) then
							if ((l_outcurl.item.state.connc).item.type).to_natural_32 = {NATURAL_32} 0 then
								url_inst.Curl_rm_connc (l_outcurl.item.state.connc)
							end
						end
						if ((l_outcurl.item.state.headerbuff).c_pointer /= default_pointer) then
							Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_outcurl.item.state.headerbuff)])
						end
						if ((l_outcurl.item.change.cookielist).c_pointer /= default_pointer) then
							slist_inst.curl_slist_free_all (l_outcurl.item.change.cookielist)
						end
						if ((l_outcurl.item.change.url).c_pointer /= default_pointer) then
							Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_outcurl.item.change.url)])
						end
						if ((l_outcurl.item.change.referer).c_pointer /= default_pointer) then
							Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_outcurl.item.change.referer)])
						end
						url_inst.Curl_freeset (l_outcurl)
						Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_outcurl)])
						l_outcurl.ce_gets (create {CE_POINTER [PD_SESSIONHANDLE]}.make_shared (default_pointer))
					end
				end
				Result := (create {CE_POINTER [ANY]}.make_cast (l_outcurl))
			end
		end

	curl_easy_reset (a_curl: CE_POINTER [ANY])
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			create l_data.make

			l_data.ce_gets (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_curl))
			url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (l_data.item.state.pathbuffer))
			l_data.item.state.pathbuffer := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			url_inst.Curl_safefree (l_data.item.state.proto.generic)
			l_data.item.state.proto.generic := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			url_inst.Curl_freeset (l_data)
			memset (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_USERDEFINED]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.set_offset))), 0, {PD_USERDEFINED}.sizeof.to_natural_32).do_nothing
			url_inst.Curl_init_userdefined (create {CE_POINTER [PD_USERDEFINED]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.set_offset)).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_PROGRESS]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.progress_offset))), 0, {PD_PROGRESS}.sizeof.to_natural_32).do_nothing
			Curl_easy_initHandleData (l_data)
			l_data.item.progress.flags := (l_data.item.progress.flags).bit_or (((1).bit_shift_left (4)))
			l_data.item.state.current_speed := (-1).to_integer_64
		end

	curl_easy_pause (a_curl: CE_POINTER [ANY]; a_action: INTEGER_32): INTEGER_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_result: INTEGER_32
			l_newstate: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tempwrite: CE_POINTER [INTEGER_8]
			l_freewrite: CE_POINTER [INTEGER_8]
			l_tempsize: NATURAL_32
			l_temptype: INTEGER_32
			l_chunklen: NATURAL_32
			l_newptr: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_data.make
			create l_k.make
			create l_tempwrite.make
			create l_freewrite.make
			create l_newptr.make

			l_data.ce_gets (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_curl))
			l_k.ce_gets (create {CE_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.req_offset))
			l_result := {PC_CURLCODE}.CURLE_OK
			l_newstate := (l_k.item.keepon).bit_and ((((((1).bit_shift_left (4))).bit_or (((1).bit_shift_left (5))))).bit_not)
			if ((a_action).bit_and (1)).to_boolean then
				l_tmp := (1).bit_shift_left (4)
			else
				l_tmp := 0
			end
			if ((a_action).bit_and (((1).bit_shift_left (2)))).to_boolean then
				l_tmp___0 := (1).bit_shift_left (5)
			else
				l_tmp___0 := 0
			end
			l_newstate := (l_newstate).bit_or (((l_tmp).bit_or (l_tmp___0)))
			l_k.item.keepon := l_newstate
			if not ((l_newstate).bit_and (((1).bit_shift_left (4)))).to_boolean then
				if ((l_data.item.state.tempwrite).c_pointer /= default_pointer) then
					l_tempwrite.ce_gets (l_data.item.state.tempwrite)
					l_freewrite.ce_gets (l_tempwrite)
					l_tempsize := l_data.item.state.tempwritesize
					l_temptype := l_data.item.state.tempwritetype
					l_data.item.state.tempwrite := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					from
					until
						js.loop_left
					loop
						js.reset
						if l_tempsize > {NATURAL_32} 16384 then
							l_chunklen := (16384).to_natural_32
						else
							l_chunklen := l_tempsize
						end
						l_result := sendf_inst.Curl_client_write (l_data.item.state.current_conn, l_temptype, l_tempwrite, l_chunklen)
						if l_result.to_boolean then
							js.break
						end
						if not js.loop_jumped then
							if ((l_data.item.state.tempwrite).c_pointer /= default_pointer) then
								if (l_tempsize - l_chunklen).to_boolean then
									l_newptr.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (Curl_crealloc.pointer_item ([create {CE_POINTER [ANY]}.make_cast (l_data.item.state.tempwrite), l_tempsize])))))
									if (l_newptr).c_pointer = default_pointer then
										Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_data.item.state.tempwrite)])
										l_data.item.state.tempwrite := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
										l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
										js.break
									end
									if not js.loop_jumped then
										l_data.item.state.tempwrite := l_newptr
										memcpy (create {CE_POINTER [ANY]}.make_cast (l_newptr), create {CE_POINTER [ANY]}.make_cast (l_tempwrite), l_tempsize).do_nothing
										l_data.item.state.tempwritesize := l_tempsize
										js.break
									end
								else
									l_tempsize := l_tempsize - l_chunklen
									l_tempwrite.ce_gets (l_tempwrite + l_chunklen.to_integer_32)
								end
							else
								l_tempsize := l_tempsize - l_chunklen
								l_tempwrite.ce_gets (l_tempwrite + l_chunklen.to_integer_32)
							end
						end
						if not js.loop_jumped then
							if l_result.to_natural_32 = {NATURAL_32} 0 then
								if not l_tempsize.to_boolean then
									js.break
								end
							else
								js.break
							end
						end
					end
					js.reset
					Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_freewrite)])
				end
			end
			Result := l_result
		end

	easy_connection (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_sfd: CE_POINTER [INTEGER_32]; a_connp: CE_POINTER [CE_POINTER [PD_CONNECTDATA]]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (a_data.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := ({PC_CURLCODE}.CURLE_BAD_FUNCTION_ARGUMENT)
				js.return
			end
			if not js.return_called and then (not a_data.item.set.connect_only) then
				sendf_inst.Curl_failf ([a_data, ce_string ("CONNECT_ONLY is required!")])
				Result := ({PC_CURLCODE}.CURLE_UNSUPPORTED_PROTOCOL)
				js.return
			end
			if not js.return_called then
				a_sfd.item := connect_inst.Curl_getconnectinfo (a_data, a_connp)
				if a_sfd.item = -1 then
					sendf_inst.Curl_failf ([a_data, ce_string ("Failed to get recent socket")])
					Result := ({PC_CURLCODE}.CURLE_UNSUPPORTED_PROTOCOL)
					js.return
				end
			end
			if not js.return_called then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	curl_easy_recv (a_curl: CE_POINTER [ANY]; a_buffer: CE_POINTER [ANY]; a_buflen: NATURAL_32; a_n: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_sfd: INTEGER_32
			l_ret: INTEGER_32
			l_n1: INTEGER_32
			l_c: CE_POINTER [PD_CONNECTDATA]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
		do
			create l_c.make
			create l_data.make

			l_data.ce_gets (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_curl))
			l_ret := easy_connection (l_data, create {CE_POINTER [INTEGER_32]}.make_shared ($l_sfd), l_c.address)
			if l_ret.to_boolean then
				Result := l_ret
				js.return
			end
			if not js.return_called then
				a_n.item := (0).to_natural_32
				l_ret := sendf_inst.Curl_read (l_c, l_sfd, create {CE_POINTER [INTEGER_8]}.make_cast (a_buffer), a_buflen, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n1))
				if l_ret.to_natural_32 /= {NATURAL_32} 0 then
					Result := l_ret
					js.return
				end
			end
			if not js.return_called then
				a_n.item := l_n1.to_natural_32
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	curl_easy_send (a_curl: CE_POINTER [ANY]; a_buffer: CE_POINTER [ANY]; a_buflen: NATURAL_32; a_n: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_sfd: INTEGER_32
			l_ret: INTEGER_32
			l_n1: INTEGER_32
			l_c: CE_POINTER [PD_CONNECTDATA]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
		do
			create l_c.make
			create l_data.make

			l_c.ce_gets (create {CE_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer))
			l_data.ce_gets (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_curl))
			l_ret := easy_connection (l_data, create {CE_POINTER [INTEGER_32]}.make_shared ($l_sfd), l_c.address)
			if l_ret.to_boolean then
				Result := l_ret
				js.return
			end
			if not js.return_called then
				a_n.item := (0).to_natural_32
				l_ret := sendf_inst.Curl_write (l_c, l_sfd, a_buffer, a_buflen, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n1))
				if l_n1 = -1 then
					Result := ({PC_CURLCODE}.CURLE_SEND_ERROR)
					js.return
				end
			end
			if not js.return_called and then ({NATURAL_32} 0 = l_ret.to_natural_32) then
				if 0 = l_n1 then
					Result := ({PC_CURLCODE}.CURLE_AGAIN)
					js.return
				end
			end
			if not js.return_called then
				a_n.item := l_n1.to_natural_32
				Result := l_ret
			end
		end

end
