class
	P_HTTP

inherit
	LIBCURL_DATA
		redefine
			default_create
		end
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create Curl_handler_http.make
		end

feature {ANY} -- attributes

	Curl_handler_http: PD_CURL_HANDLER

feature {ANY} -- routines

	Curl_checkheaders (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_thisheader: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_head: CE_POINTER [PD_CURL_SLIST]
			l_thislen: NATURAL_32
			js: JUMP_STATE
		do
			create l_head.make

			l_thislen := (strlen (a_thisheader))
			l_head.ce_gets (a_data.item.set.headers)
			from
			until
				not (not js.loop_left and then ((l_head).c_pointer /= default_pointer))
			loop
				if (rawstr_inst.Curl_raw_nequal (l_head.item.data, a_thisheader, l_thislen)).to_boolean then
					Result := (l_head.item.data)
					js.return
				end
				if not js.return_called then
					l_head.ce_gets (l_head.item.next)
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
			end
		end

	Curl_copy_header_value (a_h: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_h: CE_POINTER [INTEGER_8]
			l_start: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			l_value: CE_POINTER [INTEGER_8]
			l_len: NATURAL_32
			js: JUMP_STATE
		do
			create l_h.make
			create l_start.make
			create l_end.make
			create l_value.make

			l_h.ce_gets (a_h)
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_h[0]).to_boolean then
					if (l_h[0]).to_integer_32 = 58 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_h.ce_gets (l_h + 1)
				end
			end
			js.reset
			if (l_h[0]).to_boolean then
				l_h.ce_gets (l_h + 1)
			end
			l_start.ce_gets (l_h)
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_start[0]).to_boolean then
					if not ((((ctype_b_loc).item[((l_start[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (8192)).to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_start.ce_gets (l_start + 1)
				end
			end
			js.reset
			l_end.ce_gets ((strchr (l_start, ('%R').code)))
			if (l_end).c_pointer = default_pointer then
				l_end.ce_gets ((strchr (l_start, ('%N').code)))
			end
			if (l_end).c_pointer = default_pointer then
				l_end.ce_gets ((strchr (l_start, ('%/0/').code)))
			end
			if (l_end).c_pointer = default_pointer then
				Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_end.c_pointer.to_integer_32).to_natural_32 > (l_start.c_pointer.to_integer_32).to_natural_32 then
						if not ((((ctype_b_loc).item[((l_end[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (8192)).to_boolean then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_end.ce_gets (l_end - 1)
					end
				end
				js.reset
				l_len := ((l_end.distance (l_start)) + 1).to_natural_32
				l_value.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([l_len + {NATURAL_32} 1])))))
				if (l_value).c_pointer = default_pointer then
					Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_value), create {CE_POINTER [ANY]}.make_cast (l_start), l_len).do_nothing
				l_value[l_len.to_integer_32] := (0).to_integer_8
				Result := l_value
			end
		end

	http_output_basic (a_conn: CE_POINTER [PD_CONNECTDATA]; a_proxy: BOOLEAN): INTEGER_32
		local
			l_authorization: CE_POINTER [INTEGER_8]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_userp: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_user: CE_POINTER [INTEGER_8]
			l_pwd: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_authorization.make
			create l_data.make
			create l_userp.make
			create l_user.make
			create l_pwd.make
			create l_tmp.make

			l_data.ce_gets (a_conn.item.data)
			if a_proxy then
				l_userp.ce_gets (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (a_conn.c_pointer + {PD_CONNECTDATA}.allocptr_offset + {PD_DYNAMICALLY_ALLOCATED_DATA}.proxyuserpwd_offset))
				l_user.ce_gets (a_conn.item.proxyuser)
				l_pwd.ce_gets (a_conn.item.proxypasswd)
			else
				l_userp.ce_gets (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (a_conn.c_pointer + {PD_CONNECTDATA}.allocptr_offset + {PD_DYNAMICALLY_ALLOCATED_DATA}.userpwd_offset))
				l_user.ce_gets (a_conn.item.user)
				l_pwd.ce_gets (a_conn.item.passwd)
			end
			mprintf_inst.curl_msnprintf ([l_data.item.state.buffer, (Integer_8_bytes.to_natural_32 * (16385).to_natural_32), ce_string ("%%s:%%s"), l_user, l_pwd]).do_nothing
			if (base64_inst.Curl_base64_encode (l_data, (l_data.item.state.buffer), (strlen ((l_data.item.state.buffer))), l_authorization.address)) > {NATURAL_32} 0 then
				if ((l_userp.item).c_pointer /= default_pointer) then
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_userp.item)])
				end
				if a_proxy then
					l_tmp.ce_gets (ce_string ("Proxy-"))
				else
					l_tmp.ce_gets (ce_string (""))
				end
				l_userp.item := mprintf_inst.curl_maprintf ([ce_string ("%%sAuthorization: Basic %%s%R%N"), l_tmp, l_authorization])
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_authorization)])
				if (l_userp.item).c_pointer = default_pointer then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				end
			else
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				js.return
			end
			if not js.return_called then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	pickoneauth (a_pick: CE_POINTER [PD_AUTH]): BOOLEAN
		local
			l_picked: BOOLEAN
			l_avail: INTEGER_32
		do
			l_avail := (a_pick.item.avail).bit_and (a_pick.item.want)
			l_picked := (1).to_boolean
			if ((l_avail).bit_and (((1).bit_shift_left (2)).to_integer_32)).to_boolean then
				a_pick.item.picked := ((1).bit_shift_left (2)).to_integer_32
			elseif ((l_avail).bit_and (((1).bit_shift_left (1)).to_integer_32)).to_boolean then
				a_pick.item.picked := ((1).bit_shift_left (1)).to_integer_32
			elseif ((l_avail).bit_and (((1).bit_shift_left (3)).to_integer_32)).to_boolean then
				a_pick.item.picked := ((1).bit_shift_left (3)).to_integer_32
			elseif ((l_avail).bit_and (1)).to_boolean then
				a_pick.item.picked := 1
			else
				a_pick.item.picked := ((1).bit_shift_left (30)).to_integer_32
				l_picked := (0).to_boolean
			end
			a_pick.item.avail := 0
			Result := l_picked
		end

	Curl_http_perhapsrewind (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_http: CE_POINTER [PD_HTTP]
			l_bytessent: INTEGER_64
			l_expectsend: INTEGER_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make
			create l_http.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data.ce_gets (a_conn.item.data)
					l_http.ce_gets (l_data.item.state.proto.http)
					l_expectsend := (-1).to_integer_64
					if (l_http).c_pointer = default_pointer then
						Result := ({PC_CURLCODE}.CURLE_OK)
						js.return
					elseif not ((a_conn.item.protocol).bit_and (1)).to_boolean then
						Result := ({PC_CURLCODE}.CURLE_OK)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						inspect l_data.item.set.httpreq -- switch 1 head
						when 1 then l_pos := -1 + 2
						when 5 then l_pos := -1 + 2
						else l_pos := -1 + 3
						end
				when 2 then -- switch 1, case 1 | switch 1, case 5
						Result := ({PC_CURLCODE}.CURLE_OK)
						js.return
				when 3 then -- switch 1, default:
						l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done: | if done
						if js.return_called then
							l_pos := -1 + 28 -- skip if block
						end
				when 5 then -- if:
							l_bytessent := l_http.item.writebytecount
							if not (a_conn.item.bits.authneg) then
								l_pos := -1 + 8 -- skip if block
							end
				when 6 then -- if:
							l_expectsend := (0).to_integer_64
				when 7 then -- if block done, skip else block:
							l_pos := -1 + 13
				when 8 then -- else:
							inspect l_data.item.set.httpreq -- switch 2 head
							when 2 then l_pos := -1 + 9
							when 4 then l_pos := -1 + 10
							when 3 then l_pos := -1 + 11
							else l_pos := -1 + 12
							end
				when 9 then -- switch 2, case 2
							if l_data.item.set.postfieldsize /= -{INTEGER_64} 1 then
								l_expectsend := l_data.item.set.postfieldsize
							elseif ((l_data.item.set.postfields).c_pointer /= default_pointer) then
								l_expectsend := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_data.item.set.postfields))).to_integer_64
							end
							l_pos := -1 + 13 -- switch 2; break
				when 10 then -- switch 2, case 4
							if l_data.item.set.infilesize /= -{INTEGER_64} 1 then
								l_expectsend := l_data.item.set.infilesize
							end
							l_pos := -1 + 13 -- switch 2; break
				when 11 then -- switch 2, case 3
							l_expectsend := l_http.item.postsize
							l_pos := -1 + 13 -- switch 2; break
				when 12 then -- switch 2, default:
							l_pos := -1 + 13 -- switch 2; break
				when 13 then -- switch 2, done: | if done
							a_conn.item.bits.rewindaftersend := (0).to_boolean
							if l_expectsend /= -{INTEGER_64} 1 then
								l_pos := -1 + 16 -- skip if block
							end
				when 14 then -- if:
							l_pos := -1 + 17 -- goto _L___1
				when 15 then -- if block done, skip else block:
							l_pos := -1 + 28
				when 16 then -- else:
							if not (l_expectsend > l_bytessent) then
								l_pos := -1 + 28 -- skip if block
							end
				when 17 then -- if: | _L___1:
							if l_data.item.state.authproxy.picked /= ((1).bit_shift_left (3)).to_integer_32 then
								l_pos := -1 + 20 -- skip if block
							end
				when 18 then -- if:
							l_pos := -1 + 21 -- goto _L___0
				when 19 then -- if block done, skip else block:
							l_pos := -1 + 27
				when 20 then -- else:
							if l_data.item.state.authhost.picked /= ((1).bit_shift_left (3)).to_integer_32 then
								l_pos := -1 + 27 -- skip if block
							end
				when 21 then -- if: | _L___0:
							if not (l_expectsend - l_bytessent < {INTEGER_64} 2000) then
								l_pos := -1 + 24 -- skip if block
							end
				when 22 then -- if:
							l_pos := -1 + 25 -- goto _L
				when 23 then -- if block done, skip else block:
							l_pos := -1 + 26
				when 24 then -- else:
							if (a_conn.item.ntlm.state).to_natural_32 = {NATURAL_32} 0 then
								l_pos := -1 + 26 -- skip if block
							end
				when 25 then -- if: | _L:
							if not a_conn.item.bits.authneg then
								a_conn.item.bits.rewindaftersend := (1).to_boolean
							end
							Result := ({PC_CURLCODE}.CURLE_OK)
							js.return
				when 26 then -- if done
							if not js.return_called and then (a_conn.item.bits.close) then
								Result := ({PC_CURLCODE}.CURLE_OK)
								js.return
							end
							if not js.return_called then
								sendf_inst.Curl_infof ([l_data, ce_string ("NTLM send, close instead of sending %%lld bytes%N"), l_expectsend - l_bytessent])
							end
				when 27 then -- if done
							if not js.return_called then
								a_conn.item.bits.close := (1).to_boolean
								l_data.item.req.size := (0).to_integer_64
							end
				when 28 then -- if done | if done
							if not js.return_called and then (l_bytessent.to_boolean) then
								Result := (transfer_inst.Curl_readrewind (a_conn))
								js.return
							end
							if not js.return_called then
								Result := ({PC_CURLCODE}.CURLE_OK)
							end
				when 29 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	Curl_http_auth_act (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pickhost: BOOLEAN
			l_pickproxy: BOOLEAN
			l_code: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data.ce_gets (a_conn.item.data)
					l_pickhost := (0).to_boolean
					l_pickproxy := (0).to_boolean
					l_code := {PC_CURLCODE}.CURLE_OK
					if 100 <= l_data.item.req.httpcode then
						if 199 >= l_data.item.req.httpcode then
							Result := ({PC_CURLCODE}.CURLE_OK)
							js.return
						end
					end
					if not js.return_called and then (l_data.item.state.authproblem) then
						if l_data.item.set.http_fail_on_error then
							l_tmp := 22
						else
							l_tmp := 0
						end
						Result := l_tmp
						js.return
					end
					if js.return_called then
						l_pos := -1 + 22 -- skip if block
					end
				when 1 then -- if:
						if not (a_conn.item.bits.user_passwd) then
							l_pos := -1 + 8 -- skip if block
						end
				when 2 then -- if:
						if l_data.item.req.httpcode /= 401 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 5 then -- else:
						if not (a_conn.item.bits.authneg) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if not (l_data.item.req.httpcode < 300) then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						l_pickhost := pickoneauth (create {CE_POINTER [PD_AUTH]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.state_offset + {PD_URLSTATE}.authhost_offset))
						if not l_pickhost then
							l_data.item.state.authproblem := (1).to_boolean
						end
				when 8 then -- if done | if done | if done
						if not (a_conn.item.bits.proxy_user_passwd) then
							l_pos := -1 + 15 -- skip if block
						end
				when 9 then -- if:
						if l_data.item.req.httpcode /= 407 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 14 -- goto _L___0
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 12 then -- else:
						if not (a_conn.item.bits.authneg) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if not (l_data.item.req.httpcode < 300) then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L___0:
						l_pickproxy := pickoneauth (create {CE_POINTER [PD_AUTH]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.state_offset + {PD_URLSTATE}.authproxy_offset))
						if not l_pickproxy then
							l_data.item.state.authproblem := (1).to_boolean
						end
				when 15 then -- if done | if done | if done
						if not l_pickhost then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 19 -- goto _L___1
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 18 then -- else:
						if not l_pickproxy then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if: | _L___1:
						url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (l_data.item.req.newurl))
						l_data.item.req.newurl := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_data.item.change.url]))
						if (l_data.item.req.newurl).c_pointer = default_pointer then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
						if not js.return_called and then ((l_data.item.set.httpreq).to_natural_32 /= {NATURAL_32} 1) then
							if (l_data.item.set.httpreq).to_natural_32 /= {NATURAL_32} 5 then
								if not a_conn.item.bits.rewindaftersend then
									l_code := Curl_http_perhapsrewind (a_conn)
									if l_code.to_boolean then
										Result := l_code
										js.return
									end
								end
							end
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						if l_data.item.req.httpcode < 300 then
							if not l_data.item.state.authhost.done then
								if a_conn.item.bits.authneg then
									if (l_data.item.set.httpreq).to_natural_32 /= {NATURAL_32} 1 then
										if (l_data.item.set.httpreq).to_natural_32 /= {NATURAL_32} 5 then
											l_data.item.req.newurl := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_data.item.change.url]))
											if (l_data.item.req.newurl).c_pointer = default_pointer then
												Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
												js.return
											end
											if not js.return_called then
												l_data.item.state.authhost.done := (1).to_boolean
											end
										end
									end
								end
							end
						end
				when 22 then -- if done | if done
						if not js.return_called then
							if (Curl_http_should_fail (a_conn)).to_boolean then
								sendf_inst.Curl_failf ([l_data, ce_string ("The requested URL returned error: %%d"), l_data.item.req.httpcode])
								l_code := {PC_CURLCODE}.CURLE_HTTP_RETURNED_ERROR
							end
							Result := l_code
						end
				when 23 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	output_auth_headers (a_conn: CE_POINTER [PD_CONNECTDATA]; a_authstatus: CE_POINTER [PD_AUTH]; a_request: CE_POINTER [INTEGER_8]; a_path: CE_POINTER [INTEGER_8]; a_proxy: BOOLEAN): INTEGER_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_auth: CE_POINTER [INTEGER_8]
			l_result: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make
			create l_auth.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data.ce_gets (a_conn.item.data)
					l_auth.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					l_result := {PC_CURLCODE}.CURLE_OK
					if a_authstatus.item.picked /= ((1).bit_shift_left (1)).to_integer_32 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_auth.ce_gets (ce_string ("Digest"))
						l_result := http_digest_inst.Curl_output_digest (a_conn, a_proxy, create {CE_POINTER [NATURAL_8]}.make_cast (a_request), create {CE_POINTER [NATURAL_8]}.make_cast (a_path))
						if l_result.to_boolean then
							Result := l_result
							js.return
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 3 then -- else:
						if a_authstatus.item.picked /= 1 then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if not a_proxy then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if a_conn.item.bits.proxy_user_passwd then
							if (((Curl_checkheaders (l_data, ce_string ("Proxy-authorization:")))).c_pointer /= default_pointer) then
								l_pos := -1 + 7 -- goto _L___1
							else
								l_pos := -1 + 10 -- goto _L
							end
						else
							l_pos := -1 + 7 -- goto _L___1
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else: | _L___1:
						if a_proxy then
							l_pos := -1 + 11 -- skip if block
						end
				when 8 then -- if:
						if not (a_conn.item.bits.user_passwd) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if (((Curl_checkheaders (l_data, ce_string ("Authorization:")))).c_pointer /= default_pointer) then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						l_auth.ce_gets (ce_string ("Basic"))
						l_result := http_output_basic (a_conn, a_proxy)
						if l_result.to_boolean then
							Result := l_result
							js.return
						end
				when 11 then -- if done | if done | if done
						if not js.return_called then
							a_authstatus.item.done := (1).to_boolean
						end
				when 12 then -- if done | if done
						if not js.return_called then
							if ((l_auth).c_pointer /= default_pointer) then
								if a_proxy then
									if ((a_conn.item.proxyuser).c_pointer /= default_pointer) then
										l_tmp___1.ce_gets (a_conn.item.proxyuser)
									else
										l_tmp___1.ce_gets (ce_string (""))
									end
									l_tmp___3.ce_gets (l_tmp___1)
								else
									if ((a_conn.item.user).c_pointer /= default_pointer) then
										l_tmp___2.ce_gets (a_conn.item.user)
									else
										l_tmp___2.ce_gets (ce_string (""))
									end
									l_tmp___3.ce_gets (l_tmp___2)
								end
								if a_proxy then
									l_tmp___4.ce_gets (ce_string ("Proxy"))
								else
									l_tmp___4.ce_gets (ce_string ("Server"))
								end
								sendf_inst.Curl_infof ([l_data, ce_string ("%%s auth using %%s with user %'%%s%'%N"), l_tmp___4, l_auth, l_tmp___3])
								a_authstatus.item.multi := (not a_authstatus.item.done)
							else
								a_authstatus.item.multi := (0).to_boolean
							end
							Result := ({PC_CURLCODE}.CURLE_OK)
						end
				when 13 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	http_output_auth (a_conn: CE_POINTER [PD_CONNECTDATA]; a_request: CE_POINTER [INTEGER_8]; a_path: CE_POINTER [INTEGER_8]; a_proxytunnel: BOOLEAN): INTEGER_32
		local
			l_result: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_authhost: CE_POINTER [PD_AUTH]
			l_authproxy: CE_POINTER [PD_AUTH]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make
			create l_authhost.make
			create l_authproxy.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := {PC_CURLCODE}.CURLE_OK
					l_data.ce_gets (a_conn.item.data)
					l_authhost.ce_gets (create {CE_POINTER [PD_AUTH]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.state_offset + {PD_URLSTATE}.authhost_offset))
					l_authproxy.ce_gets (create {CE_POINTER [PD_AUTH]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.state_offset + {PD_URLSTATE}.authproxy_offset))
					if not (a_conn.item.bits.httpproxy) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if not a_conn.item.bits.proxy_user_passwd then
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if not a_conn.item.bits.user_passwd then
							l_authhost.item.done := (1).to_boolean
							l_authproxy.item.done := (1).to_boolean
							Result := ({PC_CURLCODE}.CURLE_OK)
							js.return
						end
				when 4 then
					if not js.return_called then
						if (l_authhost.item.want).to_boolean then
							if not (l_authhost.item.picked).to_boolean then
								l_authhost.item.picked := l_authhost.item.want
							end
						end
						if (l_authproxy.item.want).to_boolean then
							if not (l_authproxy.item.picked).to_boolean then
								l_authproxy.item.picked := l_authproxy.item.want
							end
						end
						if a_conn.item.bits.httpproxy then
							if (a_conn.item.bits.tunnel_proxy).to_integer = a_proxytunnel.to_integer then
								l_result := output_auth_headers (a_conn, l_authproxy, a_request, a_path, (1).to_boolean)
								if l_result.to_boolean then
									Result := l_result
									js.return
								end
							else
								l_authproxy.item.done := (1).to_boolean
							end
						else
							l_authproxy.item.done := (1).to_boolean
						end
					end
					if not js.return_called then
						if not l_data.item.state.this_is_a_follow then
							l_result := output_auth_headers (a_conn, l_authhost, a_request, a_path, (0).to_boolean)
						elseif a_conn.item.bits.netrc then
							l_result := output_auth_headers (a_conn, l_authhost, a_request, a_path, (0).to_boolean)
						elseif (l_data.item.state.first_host).c_pointer = default_pointer then
							l_result := output_auth_headers (a_conn, l_authhost, a_request, a_path, (0).to_boolean)
						elseif l_data.item.set.http_disable_hostname_check_before_authentication then
							l_result := output_auth_headers (a_conn, l_authhost, a_request, a_path, (0).to_boolean)
						elseif (rawstr_inst.Curl_raw_equal (l_data.item.state.first_host, a_conn.item.host.name)).to_boolean then
							l_result := output_auth_headers (a_conn, l_authhost, a_request, a_path, (0).to_boolean)
						else
							l_authhost.item.done := (1).to_boolean
						end
						Result := l_result
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_http_input_auth (a_conn: CE_POINTER [PD_CONNECTDATA]; a_httpcode: INTEGER_32; a_header: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_availp: CE_POINTER [INTEGER_32]
			l_start: CE_POINTER [INTEGER_8]
			l_authp: CE_POINTER [PD_AUTH]
			l_dig: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_availp.make
			create l_start.make
			create l_authp.make

			l_data.ce_gets (a_conn.item.data)
			if a_httpcode = 407 then
				l_start.ce_gets (a_header + (strlen (ce_string ("Proxy-authenticate:"))).to_integer_32)
				l_availp.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.info_offset + {PD_PUREINFO}.proxyauthavail_offset))
				l_authp.ce_gets (create {CE_POINTER [PD_AUTH]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.state_offset + {PD_URLSTATE}.authproxy_offset))
			else
				l_start.ce_gets (a_header + (strlen (ce_string ("WWW-Authenticate:"))).to_integer_32)
				l_availp.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.info_offset + {PD_PUREINFO}.httpauthavail_offset))
				l_authp.ce_gets (create {CE_POINTER [PD_AUTH]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.state_offset + {PD_URLSTATE}.authhost_offset))
			end
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_start[0]).to_boolean then
					if not ((((ctype_b_loc).item[((l_start[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (8192)).to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_start.ce_gets (l_start + 1)
				end
			end
			js.reset
			if (rawstr_inst.Curl_raw_nequal (ce_string ("Digest"), l_start, (strlen (ce_string ("Digest"))))).to_boolean then
				if ((l_authp.item.avail).bit_and (((1).bit_shift_left (1)).to_integer_32)) /= 0 then
					sendf_inst.Curl_infof ([l_data, ce_string ("Ignoring duplicate digest auth header.%N")])
				else
					l_availp.item := (l_availp.item).bit_or (((1).bit_shift_left (1)).to_integer_32)
					l_authp.item.avail := (l_authp.item.avail).bit_or (((1).bit_shift_left (1)).to_integer_32)
					l_dig := http_digest_inst.Curl_input_digest (a_conn, (a_httpcode = 407), l_start)
					if {NATURAL_32} 4 /= l_dig.to_natural_32 then
						sendf_inst.Curl_infof ([l_data, ce_string ("Authentication problem. Ignoring this.%N")])
						l_data.item.state.authproblem := (1).to_boolean
					end
				end
			elseif (rawstr_inst.Curl_raw_nequal (ce_string ("Basic"), l_start, (strlen (ce_string ("Basic"))))).to_boolean then
				l_availp.item := (l_availp.item).bit_or ((1))
				l_authp.item.avail := (l_authp.item.avail).bit_or ((1))
				if l_authp.item.picked = 1 then
					l_authp.item.avail := 0
					sendf_inst.Curl_infof ([l_data, ce_string ("Authentication problem. Ignoring this.%N")])
					l_data.item.state.authproblem := (1).to_boolean
				end
			end
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	Curl_http_should_fail (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_httpcode: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_data.ce_gets (a_conn.item.data)
			l_httpcode := l_data.item.req.httpcode
			if not l_data.item.set.http_fail_on_error then
				Result := 0
				js.return
			end
			if not js.return_called and then (l_httpcode < 400) then
				Result := 0
				js.return
			end
			if not js.return_called and then ((l_data.item.state.resume_from).to_boolean) then
				if (l_data.item.set.httpreq).to_natural_32 = {NATURAL_32} 1 then
					if l_httpcode = 416 then
						Result := 0
						js.return
					end
				end
			end
			if not js.return_called and then (l_httpcode /= 401) then
				if l_httpcode /= 407 then
					Result := 1
					js.return
				end
			end
			if not js.return_called and then (l_httpcode = 401) then
				if not a_conn.item.bits.user_passwd then
					Result := 1
					js.return
				end
			end
			if not js.return_called and then (l_httpcode = 407) then
				if not a_conn.item.bits.proxy_user_passwd then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				Result := (l_data.item.state.authproblem).to_integer
			end
		end

	readmoredata (a_buffer: CE_POINTER [INTEGER_8]; a_size: NATURAL_32; a_nitems: NATURAL_32; a_userp: CE_POINTER [ANY]): NATURAL_32
		local
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_http: CE_POINTER [PD_HTTP]
			l_fullsize: NATURAL_32
			js: JUMP_STATE
		do
			create l_conn.make
			create l_http.make

			l_conn.ce_gets (create {CE_POINTER [PD_CONNECTDATA]}.make_cast (a_userp))
			l_http.ce_gets ((l_conn.item.data).item.state.proto.http)
			l_fullsize := a_size * a_nitems
			if {INTEGER_64} 0 = l_http.item.postsize then
				Result := (0).to_natural_32
				js.return
			end
			if not js.return_called then
				(l_conn.item.data).item.req.forbidchunk := ((l_http.item.sending).to_natural_32 = {NATURAL_32} 1)
				if l_http.item.postsize <= l_fullsize.to_integer_64 then
					memcpy (create {CE_POINTER [ANY]}.make_cast (a_buffer), create {CE_POINTER [ANY]}.make_cast (l_http.item.postdata), (l_http.item.postsize).to_natural_32).do_nothing
					l_fullsize := (l_http.item.postsize).to_natural_32
					if (l_http.item.backup.postsize).to_boolean then
						l_http.item.postdata := l_http.item.backup.postdata
						l_http.item.postsize := l_http.item.backup.postsize
						l_conn.item.fread_func := l_http.item.backup.fread_func
						l_conn.item.fread_in := l_http.item.backup.fread_in
						l_http.item.sending := ((l_http.item.sending).to_natural_32 + {NATURAL_32} 1).to_integer_32
						l_http.item.backup.postsize := (0).to_integer_64
					else
						l_http.item.postsize := (0).to_integer_64
					end
					Result := l_fullsize
					js.return
				end
			end
			if not js.return_called then
				memcpy (create {CE_POINTER [ANY]}.make_cast (a_buffer), create {CE_POINTER [ANY]}.make_cast (l_http.item.postdata), l_fullsize).do_nothing
				l_http.item.postdata := l_http.item.postdata + l_fullsize.to_integer_32
				l_http.item.postsize := l_http.item.postsize - l_fullsize.to_integer_64
				Result := l_fullsize
			end
		end

	readmoredata_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent readmoredata)
		end

	Curl_add_buffer_init: CE_POINTER [PD_CURL_SEND_BUFFER]
		do
			Result := (create {CE_POINTER [PD_CURL_SEND_BUFFER]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(1).to_natural_32, {PD_CURL_SEND_BUFFER}.sizeof.to_natural_32])))))
		end

	Curl_add_buffer_send (a_in: CE_POINTER [PD_CURL_SEND_BUFFER]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_bytes_written: CE_POINTER [INTEGER_32]; a_included_body_bytes: NATURAL_32; a_socketindex: INTEGER_32): INTEGER_32
		local
			l_amount: INTEGER_32
			l_res: INTEGER_32
			l_ptr: CE_POINTER [INTEGER_8]
			l_size: NATURAL_32
			l_http: CE_POINTER [PD_HTTP]
			l_sendsize: NATURAL_32
			l_sockfd: INTEGER_32
			l_headersize: NATURAL_32
			l_headlen: NATURAL_32
			l_tmp: NATURAL_32
			l_bodylen: NATURAL_32
			js: JUMP_STATE
		do
			create l_ptr.make
			create l_http.make

			l_http.ce_gets ((a_conn.item.data).item.state.proto.http)
			l_sockfd := a_conn.item.sock[a_socketindex]
			l_ptr.ce_gets (a_in.item.buffer)
			l_size := a_in.item.size_used
			l_headersize := l_size - a_included_body_bytes
			if ((a_conn.item.protocol).bit_and (((1).bit_shift_left (1)).to_integer_32)).to_boolean then
				if l_size > {NATURAL_32} 16384 then
					l_sendsize := (16384).to_natural_32
				else
					l_sendsize := l_size
				end
				memcpy (create {CE_POINTER [ANY]}.make_cast (((a_conn.item.data).item.state.uploadbuffer)), create {CE_POINTER [ANY]}.make_cast (l_ptr), l_sendsize).do_nothing
				l_ptr.ce_gets ((a_conn.item.data).item.state.uploadbuffer)
			else
				l_sendsize := l_size
			end
			l_res := sendf_inst.Curl_write (a_conn, l_sockfd, create {CE_POINTER [ANY]}.make_cast (l_ptr), l_sendsize, create {CE_POINTER [INTEGER_32]}.make_shared ($l_amount))
			if {NATURAL_32} 0 = l_res.to_natural_32 then
				if l_amount.to_natural_32 > l_headersize then
					l_tmp := l_headersize
				else
					l_tmp := l_amount.to_natural_32
				end
				l_headlen := l_tmp
				l_bodylen := l_amount.to_natural_32 - l_headlen
				if (a_conn.item.data).item.set.verbose then
					sendf_inst.Curl_debug (a_conn.item.data, {PC_CURL_INFOTYPE}.CURLINFO_HEADER_OUT, l_ptr, l_headlen, a_conn).do_nothing
					if l_amount.to_natural_32 > l_headlen then
						sendf_inst.Curl_debug (a_conn.item.data, {PC_CURL_INFOTYPE}.CURLINFO_DATA_OUT, l_ptr + l_headlen.to_integer_32, l_bodylen, a_conn).do_nothing
					end
				end
				if l_bodylen.to_boolean then
					l_http.item.writebytecount := l_http.item.writebytecount + l_bodylen.to_integer_64
				end
				a_bytes_written.item := a_bytes_written.item + l_amount.to_integer_32
				if ((l_http).c_pointer /= default_pointer) then
					if l_amount.to_natural_32 /= l_size then
						l_size := l_size - l_amount.to_natural_32
						l_ptr.ce_gets (a_in.item.buffer + l_amount)
						l_http.item.backup.fread_func := a_conn.item.fread_func
						l_http.item.backup.fread_in := a_conn.item.fread_in
						l_http.item.backup.postdata := l_http.item.postdata
						l_http.item.backup.postsize := l_http.item.postsize
						a_conn.item.fread_func := readmoredata_address
						a_conn.item.fread_in := create {CE_POINTER [ANY]}.make_cast (a_conn)
						l_http.item.postdata := l_ptr
						l_http.item.postsize := l_size.to_integer_64
						l_http.item.send_buffer := create {CE_POINTER [ANY]}.make_cast (a_in)
						l_http.item.sending := {PC_SENDING}.HTTPSEND_REQUEST
						Result := ({PC_CURLCODE}.CURLE_OK)
						js.return
					end
					if not js.return_called then
						l_http.item.sending := {PC_SENDING}.HTTPSEND_BODY
					end
				elseif l_amount.to_natural_32 /= l_size then
					Result := ({PC_CURLCODE}.CURLE_SEND_ERROR)
					js.return
				else
					a_conn.item.writechannel_inuse := (0).to_boolean
				end
			end
			if not js.return_called then
				if ((a_in.item.buffer).c_pointer /= default_pointer) then
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_in.item.buffer)])
				end
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_in)])
				Result := l_res
			end
		end

	Curl_add_bufferf (a_args: TUPLE [a_in: CE_POINTER [PD_CURL_SEND_BUFFER]; a_fmt: CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_s: CE_POINTER [INTEGER_8]
			l_ap: CE_VA_LIST
			l_result: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make

			create l_ap.make (a_args, 3)
			l_s.ce_gets (mprintf_inst.curl_mvaprintf (a_args.a_fmt, l_ap))
			if ((l_s).c_pointer /= default_pointer) then
				l_result := (Curl_add_buffer (a_args.a_in, create {CE_POINTER [ANY]}.make_cast (l_s), (strlen (l_s))))
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_s)])
				Result := l_result
				js.return
			end
			if not js.return_called then
				if ((a_args.a_in.item.buffer).c_pointer /= default_pointer) then
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_args.a_in.item.buffer)])
				end
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_args.a_in)])
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
			end
		end

	Curl_add_buffer (a_in: CE_POINTER [PD_CURL_SEND_BUFFER]; a_inptr: CE_POINTER [ANY]; a_size: NATURAL_32): INTEGER_32
		local
			l_new_rb: CE_POINTER [INTEGER_8]
			l_new_size: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_new_rb.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_size).bit_not < a_in.item.size_used then
						url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_in.item.buffer))
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_in)])
						Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if ((a_in.item.buffer).c_pointer /= default_pointer) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_in.item.size_used + a_size > a_in.item.size_max - {NATURAL_32} 1) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if a_size > {NATURAL_32} 2147483647 then
							l_new_size := (-1).to_natural_32
						elseif a_in.item.size_used > {NATURAL_32} 2147483647 then
							l_new_size := (-1).to_natural_32
						elseif ((a_size * {NATURAL_32} 2)).bit_not < a_in.item.size_used * {NATURAL_32} 2 then
							l_new_size := (-1).to_natural_32
						else
							l_new_size := (a_in.item.size_used + a_size) * {NATURAL_32} 2
						end
						if ((a_in.item.buffer).c_pointer /= default_pointer) then
							l_new_rb.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_crealloc.pointer_item ([create {CE_POINTER [ANY]}.make_cast (a_in.item.buffer), l_new_size])))))
						else
							l_new_rb.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([l_new_size])))))
						end
						if (l_new_rb).c_pointer = default_pointer then
							url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_in.item.buffer))
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_in)])
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
						if not js.return_called then
							a_in.item.buffer := l_new_rb
							a_in.item.size_max := l_new_size
						end
				when 6 then -- if done | if done
						if not js.return_called then
							memcpy (create {CE_POINTER [ANY]}.make_cast ((a_in.item.buffer + (a_in.item.size_used).to_integer_32)), a_inptr, a_size).do_nothing
							a_in.item.size_used := a_in.item.size_used + a_size
							Result := ({PC_CURLCODE}.CURLE_OK)
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	Curl_compareheader (a_headerline: CE_POINTER [INTEGER_8]; a_header: CE_POINTER [INTEGER_8]; a_content: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_hlen: NATURAL_32
			l_clen: NATURAL_32
			l_len: NATURAL_32
			l_start: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_start.make
			create l_end.make

			l_hlen := (strlen (a_header))
			if not (rawstr_inst.Curl_raw_nequal (a_headerline, a_header, l_hlen)).to_boolean then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				l_start.ce_gets (a_headerline + l_hlen.to_integer_32)
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_start[0]).to_boolean then
						if not ((((ctype_b_loc).item[((l_start[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (8192)).to_boolean then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_start.ce_gets (l_start + 1)
					end
				end
				js.reset
				l_end.ce_gets ((strchr (l_start, ('%R').code)))
				if (l_end).c_pointer = default_pointer then
					l_end.ce_gets ((strchr (l_start, ('%N').code)))
					if (l_end).c_pointer = default_pointer then
						l_end.ce_gets ((strchr (l_start, ('%/0/').code)))
					end
				end
				l_len := (l_end.distance (l_start)).to_natural_32
				l_clen := strlen (a_content)
				from
				until
					not (not js.loop_left and then (l_len >= l_clen))
				loop
					if (rawstr_inst.Curl_raw_nequal (l_start, a_content, l_clen)).to_boolean then
						Result := (1).to_boolean
						js.return
					end
					if not js.return_called then
						l_len := l_len - 1
						l_start.ce_gets (l_start + 1)
					end
				end
			end
			if not js.return_called then
				Result := (0).to_boolean
			end
		end

	Curl_proxyCONNECT (a_conn: CE_POINTER [PD_CONNECTDATA]; a_sockindex: INTEGER_32; a_hostname: CE_POINTER [INTEGER_8]; a_remote_port: NATURAL_16): INTEGER_32
		local
			l_subversion: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_result: INTEGER_32
			l_timeout: INTEGER_32
			l_tmp: INTEGER_32
			l_tunnelsocket: INTEGER_32
			l_cl: INTEGER_64
			l_closeConnection: BOOLEAN
			l_chunked_encoding: BOOLEAN
			l_check: INTEGER_32
			l_error: INTEGER_32
			l_host_port: CE_POINTER [INTEGER_8]
			l_req_buffer: CE_POINTER [PD_CURL_SEND_BUFFER]
			l_host: CE_POINTER [INTEGER_8]
			l_proxyconn: CE_POINTER [INTEGER_8]
			l_useragent: CE_POINTER [INTEGER_8]
			l_http: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_nread: NATURAL_32
			l_perline: INTEGER_32
			l_keepon: INTEGER_32
			l_gotbytes: INTEGER_32
			l_ptr: CE_POINTER [INTEGER_8]
			l_line_start: CE_POINTER [INTEGER_8]
			l_tmp___10: INTEGER_32
			l_i: INTEGER_32
			l_r: INTEGER_32
			l_tookcareof: INTEGER_32
			l_letter: INTEGER_8
			l_writetype: INTEGER_32
			l_r___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make
			create l_k.make
			create l_host_port.make
			create l_req_buffer.make
			create l_host.make
			create l_proxyconn.make
			create l_useragent.make
			create l_http.make
			create l_tmp___0.make
			create l_tmp___4.make
			create l_ptr.make
			create l_line_start.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_subversion := 0
					l_data.ce_gets (a_conn.item.data)
					l_k.ce_gets (create {CE_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.req_offset))
					if (l_data.item.set.timeout).to_boolean then
						l_tmp := l_data.item.set.timeout
					else
						l_tmp := 3600000
					end
					l_timeout := l_tmp
					l_tunnelsocket := a_conn.item.sock[a_sockindex]
					l_cl := (0).to_integer_64
					l_closeConnection := (0).to_boolean
					l_chunked_encoding := (0).to_boolean
					l_error := 0
					a_conn.item.bits.proxy_connect_closed := (0).to_boolean
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 48 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if not a_conn.item.bits.tunnel_connecting then
							sendf_inst.Curl_infof ([l_data, ce_string ("Establish HTTP proxy tunnel to %%s:%%hu%N"), a_hostname, a_remote_port.to_integer_32])
							if ((l_data.item.req.newurl).c_pointer /= default_pointer) then
								easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_data.item.req.newurl)])
								l_data.item.req.newurl := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							end
							l_req_buffer.ce_gets (Curl_add_buffer_init)
							if (l_req_buffer).c_pointer = default_pointer then
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								js.return
							end
							if not js.return_called then
								l_host_port.ce_gets (mprintf_inst.curl_maprintf ([ce_string ("%%s:%%hu"), a_hostname, a_remote_port.to_integer_32]))
								if (l_host_port).c_pointer = default_pointer then
									easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_req_buffer)])
									Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
									js.return
								end
							end
							if not js.return_called then
								l_result := http_output_auth (a_conn, ce_string ("CONNECT"), l_host_port, (1).to_boolean)
								if {NATURAL_32} 0 = l_result.to_natural_32 then
									l_host.ce_gets (ce_string (""))
									l_proxyconn.ce_gets (ce_string (""))
									l_useragent.ce_gets (ce_string (""))
									if (a_conn.item.proxytype).to_natural_32 = {NATURAL_32} 1 then
										l_tmp___0.ce_gets (ce_string ("1.0"))
									else
										l_tmp___0.ce_gets (ce_string ("1.1"))
									end
									l_http.ce_gets (l_tmp___0)
									if ((Curl_checkheaders (l_data, ce_string ("Host:")))).c_pointer = default_pointer then
										l_host.ce_gets (mprintf_inst.curl_maprintf ([ce_string ("Host: %%s%R%N"), l_host_port]))
										if (l_host).c_pointer = default_pointer then
											easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_req_buffer)])
											easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_host_port)])
											Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
											js.return
										end
									end
									if not js.return_called then
										if ((Curl_checkheaders (l_data, ce_string ("Proxy-Connection:")))).c_pointer = default_pointer then
											l_proxyconn.ce_gets (ce_string ("Proxy-Connection: Keep-Alive%R%N"))
										end
										if ((Curl_checkheaders (l_data, ce_string ("User-Agent:")))).c_pointer = default_pointer then
											if ((l_data.item.set.str[25]).c_pointer /= default_pointer) then
												l_useragent.ce_gets (a_conn.item.allocptr.uagent)
											end
										end
										if ((a_conn.item.allocptr.proxyuserpwd).c_pointer /= default_pointer) then
											l_tmp___4.ce_gets (a_conn.item.allocptr.proxyuserpwd)
										else
											l_tmp___4.ce_gets (ce_string (""))
										end
										l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("CONNECT %%s:%%hu HTTP/%%s%R%N%%s%%s%%s%%s"), a_hostname, a_remote_port.to_integer_32, l_http, l_host, l_tmp___4, l_useragent, l_proxyconn])
										if ((l_host).c_pointer /= default_pointer) then
											if (l_host[0]).to_boolean then
												easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_host)])
											end
										end
										if {NATURAL_32} 0 = l_result.to_natural_32 then
											l_result := Curl_add_custom_headers (a_conn, l_req_buffer)
										end
										if {NATURAL_32} 0 = l_result.to_natural_32 then
											l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("%R%N")])
										end
										if {NATURAL_32} 0 = l_result.to_natural_32 then
											l_result := Curl_add_buffer_send (l_req_buffer, a_conn, create {CE_POINTER [INTEGER_32]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.info_offset + {PD_PUREINFO}.request_size_offset), (0).to_natural_32, a_sockindex)
										end
										l_req_buffer.ce_gets (create {CE_POINTER [PD_CURL_SEND_BUFFER]}.make_shared (default_pointer))
										if l_result.to_boolean then
											sendf_inst.Curl_failf ([l_data, ce_string ("Failed sending CONNECT to proxy")])
										end
									end
								end
							end
							if not js.return_called then
								easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_host_port)])
								url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (l_req_buffer))
								if l_result.to_boolean then
									Result := l_result
									js.return
								end
							end
							if not js.return_called then
								a_conn.item.bits.tunnel_connecting := (1).to_boolean
							end
						end
						if not js.return_called then
							l_check := l_timeout - (timeval_inst.curlx_tvdiff ((timeval_inst.curlx_tvnow), a_conn.item.now))
							if l_check <= 0 then
								sendf_inst.Curl_failf ([l_data, ce_string ("Proxy CONNECT aborted due to timeout")])
								Result := ({PC_CURLCODE}.CURLE_RECV_ERROR)
								js.return
							end
						end
						if not js.return_called then
							if {NATURAL_32} 2 = (l_data.item.state.used_interface).to_natural_32 then
								if 0 = (select_inst.Curl_socket_ready (l_tunnelsocket, -1, 0)) then
									Result := ({PC_CURLCODE}.CURLE_OK)
									js.return
								else
								end
							else
							end
						end
						if js.return_called then
							l_pos := -1 + 47 -- skip if block
						end
				when 3 then -- if:
						a_conn.item.bits.tunnel_connecting := (0).to_boolean
						l_keepon := 1
						l_ptr.ce_gets (l_data.item.state.buffer)
						l_line_start.ce_gets (l_ptr)
						l_nread := (0).to_natural_32
						l_perline := 0
						l_keepon := 1
				when 4 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 46 -- skip loop
						end
				when 5 then -- loop body:
						js.reset
						if l_nread < {NATURAL_32} 16384 then
							if l_keepon.to_boolean then
								if l_error.to_boolean then
									js.break
								end
							else
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_check := l_timeout - (timeval_inst.curlx_tvdiff ((timeval_inst.curlx_tvnow), a_conn.item.now))
							if l_check <= 0 then
								sendf_inst.Curl_failf ([l_data, ce_string ("Proxy CONNECT aborted due to timeout")])
								l_error := 2
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 45 -- skip if block
						end
				when 6 then -- if:
						if l_check < 1000 then
							l_tmp___10 := l_check.to_integer_32
						else
							l_tmp___10 := 1000
						end
						inspect (select_inst.Curl_socket_ready (l_tunnelsocket, -1, l_tmp___10)) -- switch 1 head
						when -1 then l_pos := -1 + 7
						when 0 then l_pos := -1 + 8
						else l_pos := -1 + 9
						end
				when 7 then -- switch 1, case -1
						l_error := 1
						sendf_inst.Curl_failf ([l_data, ce_string ("Proxy CONNECT aborted due to select/poll error")])
						l_pos := -1 + 45 -- switch 1; break
				when 8 then -- switch 1, case 0
						l_pos := -1 + 45 -- switch 1; break
				when 9 then -- switch 1, default:
						l_result := sendf_inst.Curl_read (a_conn, l_tunnelsocket, l_ptr, {NATURAL_32} 16384 - l_nread, create {CE_POINTER [INTEGER_32]}.make_shared ($l_gotbytes))
						if l_result.to_natural_32 /= {NATURAL_32} 81 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						js.continue
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 12 then -- else:
						if not (l_result.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_keepon := 0
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 15 then -- else:
						if not (l_gotbytes <= 0) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_keepon := 0
						if (l_data.item.set.proxyauth).to_boolean then
							if (l_data.item.state.authproxy.avail).to_boolean then
								a_conn.item.bits.proxy_connect_closed := (1).to_boolean
							else
								l_error := 1
								sendf_inst.Curl_failf ([l_data, ce_string ("Proxy CONNECT aborted")])
							end
						else
							l_error := 1
							sendf_inst.Curl_failf ([l_data, ce_string ("Proxy CONNECT aborted")])
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 18 then -- else:
						l_nread := l_nread + l_gotbytes.to_natural_32
						if not (l_keepon > 1) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_nread := (0).to_natural_32
						l_ptr.ce_gets (l_data.item.state.buffer)
						if l_cl.to_boolean then
							l_cl := l_cl - l_gotbytes.to_integer_64
							if l_cl <= {INTEGER_64} 0 then
								l_keepon := 0
								l_pos := -1 + 45 -- switch 1; break
							end
						else
							l_tookcareof := 0
							l_r := http_chunks_inst.Curl_httpchunk_read (a_conn, l_ptr, l_gotbytes, create {CE_POINTER [INTEGER_32]}.make_shared ($l_tookcareof))
							if l_r = -1 then
								sendf_inst.Curl_infof ([l_data, ce_string ("chunk reading DONE%N")])
								l_keepon := 0
							else
								sendf_inst.Curl_infof ([l_data, ce_string ("Read %%zd bytes of chunk, continue%N"), l_tookcareof])
							end
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 21 then -- else:
						l_i := 0
				when 22 then -- loop condition:
						if not (not js.loop_left and then (l_i < l_gotbytes)) then
							l_pos := -1 + 43 -- skip loop
						end
				when 23 then -- loop body:
						js.reset
						l_perline := l_perline + 1
						if (l_ptr[0]).to_integer_32 /= 10 then
							l_pos := -1 + 42 -- skip if block
						end
				when 24 then -- if:
						if l_data.item.set.verbose then
							sendf_inst.Curl_debug (l_data, {PC_CURL_INFOTYPE}.CURLINFO_HEADER_IN, l_line_start, l_perline.to_natural_32, a_conn).do_nothing
						end
						l_writetype := (1).bit_shift_left (1)
						if l_data.item.set.include_header then
							l_writetype := (l_writetype).bit_or ((1))
						end
						l_result := sendf_inst.Curl_client_write (a_conn, l_writetype, l_line_start, l_perline.to_natural_32)
						if l_result.to_boolean then
							Result := l_result
							js.return
						end
						if js.return_called then
							l_pos := -1 + 42 -- skip if block
						end
				when 25 then -- if:
						if 13 /= (l_line_start[0]).to_integer_32 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_pos := -1 + 29 -- goto _L
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 28 then -- else:
						if 10 /= (l_line_start[0]).to_integer_32 then
							l_pos := -1 + 30 -- skip if block
						end
				when 29 then -- if: | _L:
						l_nread := (0).to_natural_32
						l_ptr.ce_gets (l_data.item.state.buffer)
						if 407 = l_k.item.httpcode then
							if not l_data.item.state.authproblem then
								l_keepon := 2
								if l_cl.to_boolean then
									sendf_inst.Curl_infof ([l_data, ce_string ("Ignore %%lld bytes of response-body%N"), l_cl])
									l_cl := l_cl - (l_gotbytes - l_i).to_integer_64
									if l_cl <= {INTEGER_64} 0 then
										l_keepon := 0
									end
								elseif l_chunked_encoding then
									l_k.item.ignorebody := (1).to_boolean
									sendf_inst.Curl_infof ([l_data, ce_string ("%%zd bytes of chunk left%N"), l_gotbytes - l_i])
									if (l_line_start[1]).to_integer_32 = 10 then
										l_line_start.ce_gets (l_line_start + 1)
										l_i := l_i + 1
									end
									l_r___0 := http_chunks_inst.Curl_httpchunk_read (a_conn, l_line_start + 1, l_gotbytes - l_i, create {CE_POINTER [INTEGER_32]}.make_shared ($l_gotbytes))
									if l_r___0 = -1 then
										sendf_inst.Curl_infof ([l_data, ce_string ("chunk reading DONE%N")])
										l_keepon := 0
									else
										sendf_inst.Curl_infof ([l_data, ce_string ("Read %%zd bytes of chunk, continue%N"), l_gotbytes])
									end
								else
									l_keepon := 0
								end
							else
								l_keepon := 0
							end
						else
							l_keepon := 0
						end
						js.break
				when 30 then -- if done
						if js.loop_jumped then
							l_pos := -1 + 42 -- skip if block
						end
				when 31 then -- if:
						l_letter := l_line_start[l_perline]
						l_line_start[l_perline] := (0).to_integer_8
						if not ((rawstr_inst.Curl_raw_nequal (ce_string ("WWW-Authenticate:"), l_line_start, (strlen (ce_string ("WWW-Authenticate:"))))).to_boolean) then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						if 401 = l_k.item.httpcode then
							l_pos := -1 + 36 -- goto _L___0
						else
							l_pos := -1 + 34 -- goto _L___2
						end
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 34 then -- else: | _L___2:
						if not ((rawstr_inst.Curl_raw_nequal (ce_string ("Proxy-authenticate:"), l_line_start, (strlen (ce_string ("Proxy-authenticate:"))))).to_boolean) then
							l_pos := -1 + 40 -- skip if block
						end
				when 35 then -- if:
						if 407 /= l_k.item.httpcode then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if: | _L___0:
						l_result := Curl_http_input_auth (a_conn, l_k.item.httpcode, l_line_start)
						if l_result.to_boolean then
							Result := l_result
							js.return
						end
				when 37 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 38 then -- else:
						l_pos := -1 + 40 -- goto _L___1
				when 39 then -- if done | if block done, skip else block:
						l_pos := -1 + 41
				when 40 then -- else: | _L___1:
						if (rawstr_inst.Curl_raw_nequal (ce_string ("Content-Length:"), l_line_start, (strlen (ce_string ("Content-Length:"))))).to_boolean then
							l_cl := strtoll ((l_line_start + (strlen (ce_string ("Content-Length:"))).to_integer_32), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), 10)
						elseif (Curl_compareheader (l_line_start, ce_string ("Connection:"), ce_string ("close"))) then
							l_closeConnection := (1).to_boolean
						elseif (Curl_compareheader (l_line_start, ce_string ("Transfer-Encoding:"), ce_string ("chunked"))) then
							sendf_inst.Curl_infof ([l_data, ce_string ("CONNECT responded chunked%N")])
							l_chunked_encoding := (1).to_boolean
							http_chunks_inst.Curl_httpchunk_init (a_conn)
						elseif (Curl_compareheader (l_line_start, ce_string ("Proxy-Connection:"), ce_string ("close"))) then
							l_closeConnection := (1).to_boolean
						elseif 2 = (sscanf ([l_line_start, ce_string ("HTTP/1.%%d %%d"), create {CE_POINTER [INTEGER_32]}.make_shared ($l_subversion), create {CE_POINTER [INTEGER_32]}.make_shared (l_k.c_pointer + {PD_SINGLEREQUEST}.httpcode_offset)])) then
							l_data.item.info.httpproxycode := l_k.item.httpcode
						end
				when 41 then -- if done
						if not js.return_called then
							l_line_start[l_perline] := l_letter
							l_perline := 0
							l_line_start.ce_gets (l_ptr + 1)
						end
				when 42 then -- if done | if done | if done
						if not js.loop_jumped then
							l_ptr.ce_gets (l_ptr + 1)
							l_i := l_i + 1
						end
						l_pos := -1 + 22 -- back to loop condition
				when 43 then -- loop done
						js.reset
				when 44 then -- if done | if done | if done
						l_pos := -1 + 45 -- switch 1; break
				when 45 then -- switch 1, done: | if done
						if not js.loop_jumped then
							if (progress_inst.Curl_pgrsUpdate (a_conn)).to_boolean then
								Result := ({PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK)
								js.return
							end
						end
						l_pos := -1 + 4 -- back to loop condition
				when 46 then -- loop done
						js.reset
				when 47 then -- if done
						if not js.return_called and then (l_error.to_boolean) then
							Result := ({PC_CURLCODE}.CURLE_RECV_ERROR)
							js.return
						end
						if not js.return_called and then (l_data.item.info.httpproxycode /= 200) then
							l_result := Curl_http_auth_act (a_conn)
							if l_result.to_boolean then
								Result := l_result
								js.return
							end
							if not js.return_called and then (a_conn.item.bits.close) then
								l_closeConnection := (1).to_boolean
							end
						end
						if not js.return_called then
							if l_closeConnection then
								if ((l_data.item.req.newurl).c_pointer /= default_pointer) then
									close (a_conn.item.sock[a_sockindex]).do_nothing
									a_conn.item.sock[a_sockindex] := -1
									js.break
								end
							end
							if not js.loop_jumped and then ((l_data.item.req.newurl).c_pointer = default_pointer) then
								js.break
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 48 then -- loop done
					js.reset
					if not js.return_called and then (200 /= l_data.item.req.httpcode) then
						sendf_inst.Curl_failf ([l_data, ce_string ("Received HTTP code %%d from proxy after CONNECT"), l_data.item.req.httpcode])
						if l_closeConnection then
							if ((l_data.item.req.newurl).c_pointer /= default_pointer) then
								a_conn.item.bits.proxy_connect_closed := (1).to_boolean
							end
						end
						Result := ({PC_CURLCODE}.CURLE_RECV_ERROR)
						js.return
					end
					if not js.return_called then
						url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.proxyuserpwd))
						a_conn.item.allocptr.proxyuserpwd := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						l_data.item.state.authproxy.done := (1).to_boolean
						sendf_inst.Curl_infof ([l_data, ce_string ("Proxy replied OK to CONNECT request%N")])
						l_data.item.req.ignorebody := (0).to_boolean
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 49 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_http_connect (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): INTEGER_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_result: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_data.ce_gets (a_conn.item.data)
			a_conn.item.bits.close := (0).to_boolean
			if a_conn.item.bits.tunnel_proxy then
				if a_conn.item.bits.httpproxy then
					l_result := Curl_proxyCONNECT (a_conn, 0, a_conn.item.host.name, a_conn.item.remote_port)
					if {NATURAL_32} 0 /= l_result.to_natural_32 then
						Result := l_result
						js.return
					end
				end
			end
			if not js.return_called and then (a_conn.item.bits.tunnel_connecting) then
				Result := ({PC_CURLCODE}.CURLE_OK)
				js.return
			end
			if not js.return_called then
				if ((a_conn.item.protocol).bit_and (((1).bit_shift_left (1)).to_integer_32)).to_boolean then
					if (l_data.item.state.used_interface).to_natural_32 = {NATURAL_32} 2 then
						l_result := {PC_CURLCODE}.CURLE_COULDNT_CONNECT
						if l_result.to_boolean then
							Result := l_result
							js.return
						end
					else
						l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
						if l_result.to_boolean then
							Result := l_result
							js.return
						end
						if not js.return_called then
							a_done.item := (1).to_boolean
						end
					end
				else
					a_done.item := (1).to_boolean
				end
			end
			if not js.return_called then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_http_connect_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent Curl_http_connect)
		end

	http_getsock_do (a_conn: CE_POINTER [PD_CONNECTDATA]; a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		do
			a_socks[0] := a_conn.item.sock[0]
			Result := ((1).bit_shift_left (16))
		end

	http_getsock_do_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent http_getsock_do)
		end

	Curl_http_done (a_conn: CE_POINTER [PD_CONNECTDATA]; a_status: INTEGER_32; a_premature: BOOLEAN): INTEGER_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_http: CE_POINTER [PD_HTTP]
			l_buff: CE_POINTER [PD_CURL_SEND_BUFFER]
			js: JUMP_STATE
		do
			create l_data.make
			create l_http.make
			create l_buff.make

			l_data.ce_gets (a_conn.item.data)
			l_http.ce_gets (l_data.item.state.proto.http)
			a_conn.item.fread_func := l_data.item.set.fread_func
			a_conn.item.fread_in := l_data.item.set.in
			a_conn.item.seek_func := l_data.item.set.seek_func
			a_conn.item.seek_client := l_data.item.set.seek_client
			if (l_http.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := ({PC_CURLCODE}.CURLE_OK)
				js.return
			end
			if not js.return_called then
				if ((l_http.item.send_buffer).c_pointer /= default_pointer) then
					l_buff.ce_gets (create {CE_POINTER [PD_CURL_SEND_BUFFER]}.make_cast (l_http.item.send_buffer))
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_buff.item.buffer)])
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_buff)])
					l_http.item.send_buffer := create {CE_POINTER [ANY]}.make_shared (default_pointer)
				end
				if {NATURAL_32} 3 = (l_data.item.set.httpreq).to_natural_32 then
					l_data.item.req.bytecount := l_http.item.readbytecount + l_http.item.writebytecount
					formdata_inst.Curl_formclean (create {CE_POINTER [CE_POINTER [PD_FORMDATA]]}.make_shared (l_http.c_pointer + {PD_HTTP}.sendit_offset))
					if ((l_http.item.form.fp).c_pointer /= default_pointer) then
						fclose (l_http.item.form.fp).do_nothing
						l_http.item.form.fp := create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
					end
				elseif {NATURAL_32} 4 = (l_data.item.set.httpreq).to_natural_32 then
					l_data.item.req.bytecount := l_http.item.readbytecount + l_http.item.writebytecount
				end
				if a_status.to_natural_32 /= {NATURAL_32} 0 then
					Result := a_status
					js.return
				end
			end
			if not js.return_called and then (not a_premature) then
				if not a_conn.item.bits.retry2 then
					if (l_http.item.readbytecount + (l_data.item.req.headerbytecount).to_integer_64) - (l_data.item.req.deductheadercount).to_integer_64 <= {INTEGER_64} 0 then
						sendf_inst.Curl_failf ([l_data, ce_string ("Empty reply from server")])
						Result := ({PC_CURLCODE}.CURLE_GOT_NOTHING)
						js.return
					end
				end
			end
			if not js.return_called then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_http_done_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent Curl_http_done)
		end

	use_http_1_1 (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]): BOOLEAN
		local
			l_tmp: INTEGER_32
		do
			if a_data.item.set.httpversion = 2 then
				l_tmp := 1
			elseif a_data.item.set.httpversion /= 1 then
				if a_conn.item.httpversion = 11 then
					l_tmp := 1
				elseif a_conn.item.httpversion /= 10 then
					if a_data.item.state.httpversion /= 10 then
						l_tmp := 1
					else
						l_tmp := 0
					end
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp.to_boolean
		end

	expect100 (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_req_buffer: CE_POINTER [PD_CURL_SEND_BUFFER]): INTEGER_32
		local
			l_result: INTEGER_32
			l_ptr: CE_POINTER [INTEGER_8]
		do
			create l_ptr.make

			l_result := {PC_CURLCODE}.CURLE_OK
			a_data.item.state.expect100header := (0).to_boolean
			if (use_http_1_1 (a_data, a_conn)) then
				l_ptr.ce_gets ((Curl_checkheaders (a_data, ce_string ("Expect:"))))
				if ((l_ptr).c_pointer /= default_pointer) then
					a_data.item.state.expect100header := Curl_compareheader (l_ptr, ce_string ("Expect:"), ce_string ("100-continue"))
				else
					l_result := Curl_add_bufferf ([a_req_buffer, ce_string ("Expect: 100-continue%R%N")])
					if l_result.to_natural_32 = {NATURAL_32} 0 then
						a_data.item.state.expect100header := (1).to_boolean
					end
				end
			end
			Result := l_result
		end

	Curl_add_custom_headers (a_conn: CE_POINTER [PD_CONNECTDATA]; a_req_buffer: CE_POINTER [PD_CURL_SEND_BUFFER]): INTEGER_32
		local
			l_ptr: CE_POINTER [INTEGER_8]
			l_headers: CE_POINTER [PD_CURL_SLIST]
			l_result: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ptr.make
			create l_headers.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_headers.ce_gets ((a_conn.item.data).item.set.headers)
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_headers).c_pointer /= default_pointer)) then
						l_pos := -1 + 15 -- skip loop
					end
				when 2 then -- loop body:
						l_ptr.ce_gets (strchr (l_headers.item.data, (':').code))
						if (l_ptr).c_pointer = default_pointer then
							l_pos := -1 + 14 -- skip if block
						end
				when 3 then -- if:
						l_ptr.ce_gets (l_ptr + 1)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_ptr[0]).to_boolean then
								if not ((((ctype_b_loc).item[((l_ptr[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (8192)).to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_ptr.ce_gets (l_ptr + 1)
							end
						end
						js.reset
						if not ((l_ptr[0]).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 4 then -- if:
						if (a_conn.item.allocptr.host).c_pointer = default_pointer then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if not (rawstr_inst.Curl_raw_nequal (ce_string ("Host:"), l_headers.item.data, (strlen (ce_string ("Host:"))))).to_boolean then
							l_pos := -1 + 7 -- goto _L___1
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 7 then -- else: | _L___1:
						if ((a_conn.item.data).item.set.httpreq).to_natural_32 /= {NATURAL_32} 3 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if not (rawstr_inst.Curl_raw_nequal (ce_string ("Content-Type:"), l_headers.item.data, (strlen (ce_string ("Content-Type:"))))).to_boolean then
							l_pos := -1 + 10 -- goto _L___0
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else: | _L___0:
						if not (a_conn.item.bits.authneg) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if not (rawstr_inst.Curl_raw_nequal (ce_string ("Content-Length"), l_headers.item.data, (strlen (ce_string ("Content-Length"))))).to_boolean then
							l_pos := -1 + 13 -- goto _L
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L:
						l_result := (Curl_add_bufferf ([a_req_buffer, ce_string ("%%s%R%N"), l_headers.item.data]))
						if l_result.to_boolean then
							Result := l_result
							js.return
						end
				when 14 then -- if done | if done | if done | if done
						if not js.return_called then
							l_headers.ce_gets (l_headers.item.next)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 15 then -- loop done
					if not js.return_called then
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_add_timecondition (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_req_buffer: CE_POINTER [PD_CURL_SEND_BUFFER]): INTEGER_32
		local
			l_tm: CE_POINTER [SD_TM]
			l_buf: CE_POINTER [INTEGER_8]
			l_result: INTEGER_32
			l_keeptime: SD_TM
			l_tmp___0: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_tm.make
			create l_buf.make
			create l_keeptime.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buf.ce_gets (a_data.item.state.buffer)
					l_result := {PC_CURLCODE}.CURLE_OK
					l_tm.ce_gets ((gmtime_r ((create {CE_POINTER [INTEGER_32]}.make_shared (a_data.c_pointer + {PD_SESSIONHANDLE}.set_offset + {PD_USERDEFINED}.timevalue_offset)), (l_keeptime.address))))
					if (l_tm.item.tm_wday).to_boolean then
						l_tmp___0 := l_tm.item.tm_wday - 1
					else
						l_tmp___0 := 6
					end
					mprintf_inst.curl_msnprintf ([l_buf, (16383).to_natural_32, ce_string ("%%s, %%02d %%s %%4d %%02d:%%02d:%%02d GMT"), parsedate_inst.Curl_wkday[l_tmp___0], l_tm.item.tm_mday, parsedate_inst.Curl_month[l_tm.item.tm_mon], l_tm.item.tm_year + 1900, l_tm.item.tm_hour, l_tm.item.tm_min, l_tm.item.tm_sec]).do_nothing
					inspect a_data.item.set.timecondition -- switch 1 head
					when 2 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					else l_pos := -1 + 1
					end
				when 1 then -- switch 1, default:
					l_result := Curl_add_bufferf ([a_req_buffer, ce_string ("If-Modified-Since: %%s%R%N"), l_buf])
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 2
					l_result := Curl_add_bufferf ([a_req_buffer, ce_string ("If-Unmodified-Since: %%s%R%N"), l_buf])
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, case 3
					l_result := Curl_add_bufferf ([a_req_buffer, ce_string ("Last-Modified: %%s%R%N"), l_buf])
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					Result := l_result
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_http (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): INTEGER_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_result: INTEGER_32
			l_http: CE_POINTER [PD_HTTP]
			l_ppath: CE_POINTER [INTEGER_8]
			l_paste_ftp_userpwd: BOOLEAN
			l_ftp_typecode: CE_ARRAY [INTEGER_8]
			l_host: CE_POINTER [INTEGER_8]
			l_te: CE_POINTER [INTEGER_8]
			l_ptr: CE_POINTER [INTEGER_8]
			l_request: CE_POINTER [INTEGER_8]
			l_httpreq: INTEGER_32
			l_addcookies: CE_POINTER [INTEGER_8]
			l_included_body: INTEGER_64
			l_httpstring: CE_POINTER [INTEGER_8]
			l_req_buffer: CE_POINTER [PD_CURL_SEND_BUFFER]
			l_postsize: INTEGER_64
			l_seekerr: INTEGER_32
			l_cookiehost: CE_POINTER [INTEGER_8]
			l_colon: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_url: CE_POINTER [INTEGER_8]
			l_currlen: NATURAL_32
			l_newlen: NATURAL_32
			l_urllen: NATURAL_32
			l_newurl: CE_POINTER [INTEGER_8]
			l_type: CE_POINTER [INTEGER_8]
			l_p: CE_POINTER [INTEGER_8]
			l_tmp___21: CE_POINTER [INTEGER_8]
			l_tmp___23: INTEGER_32
			l_passed: INTEGER_64
			l_readthisamountnow: NATURAL_32
			l_actuallyread: NATURAL_32
			l_total_expected_size: INTEGER_64
			l_tmp___35: CE_POINTER [INTEGER_8]
			l_tmp___37: CE_POINTER [INTEGER_8]
			l_tmp___38: CE_POINTER [INTEGER_8]
			l_tmp___39: CE_POINTER [INTEGER_8]
			l_tmp___40: CE_POINTER [INTEGER_8]
			l_tmp___41: CE_POINTER [INTEGER_8]
			l_tmp___42: CE_POINTER [INTEGER_8]
			l_tmp___43: CE_POINTER [INTEGER_8]
			l_tmp___44: CE_POINTER [INTEGER_8]
			l_co: CE_POINTER [PD_COOKIE]
			l_count: INTEGER_32
			l_tmp___45: INTEGER_32
			l_tmp___46: CE_POINTER [INTEGER_8]
			l_store: CE_POINTER [PD_COOKIE]
			l_tmp___47: CE_POINTER [INTEGER_8]
			l_tmp___48: CE_POINTER [INTEGER_8]
			l_contentType: CE_POINTER [INTEGER_8]
			l_linelength: NATURAL_32
			l_tmp___50: CE_POINTER [INTEGER_64]
			l_tmp___51: INTEGER_32
			l_tmp___53: INTEGER_64
			l_tmp___57: INTEGER_64
			l_tmp___58: CE_POINTER [INTEGER_64]
			l_tmp___59: INTEGER_32
			l_tmp___60: CE_POINTER [INTEGER_64]
			l_tmp___61: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make
			create l_http.make
			create l_ppath.make
			create l_ftp_typecode.make (<<((("/;type=?").count + 1).to_natural_32).to_integer_32>>)
			create l_host.make
			create l_te.make
			create l_ptr.make
			create l_request.make
			create l_addcookies.make
			create l_httpstring.make
			create l_req_buffer.make
			create l_cookiehost.make
			create l_colon.make
			create l_tmp___9.make
			create l_tmp___10.make
			create l_tmp___11.make
			create l_tmp___12.make
			create l_url.make
			create l_newurl.make
			create l_type.make
			create l_p.make
			create l_tmp___21.make
			create l_tmp___35.make
			create l_tmp___37.make
			create l_tmp___38.make
			create l_tmp___39.make
			create l_tmp___40.make
			create l_tmp___41.make
			create l_tmp___42.make
			create l_tmp___43.make
			create l_tmp___44.make
			create l_co.make
			create l_tmp___46.make
			create l_store.make
			create l_tmp___47.make
			create l_tmp___48.make
			create l_contentType.make
			create l_tmp___50.make
			create l_tmp___58.make
			create l_tmp___60.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data.ce_gets (a_conn.item.data)
					l_result := {PC_CURLCODE}.CURLE_OK
					l_ppath.ce_gets (l_data.item.state.path)
					l_paste_ftp_userpwd := (0).to_boolean
					l_ftp_typecode[0] := (('%/0/').code).to_integer_8
					l_ftp_typecode[1] := (0).to_integer_8
					l_ftp_typecode[2] := (0).to_integer_8
					l_ftp_typecode[3] := (0).to_integer_8
					l_ftp_typecode[4] := (0).to_integer_8
					l_ftp_typecode[5] := (0).to_integer_8
					l_ftp_typecode[6] := (0).to_integer_8
					l_ftp_typecode[7] := (0).to_integer_8
					l_ftp_typecode[8] := (0).to_integer_8
					l_host.ce_gets (a_conn.item.host.name)
					l_te.ce_gets (ce_string (""))
					l_httpreq := l_data.item.set.httpreq
					l_addcookies.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					l_included_body := (0).to_integer_64
					l_seekerr := 0
					a_done.item := (1).to_boolean
					url_inst.Curl_reset_reqproto (a_conn)
					if (l_data.item.state.proto.http).c_pointer = default_pointer then
						l_http.ce_gets (create {CE_POINTER [PD_HTTP]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(1).to_natural_32, {PD_HTTP}.sizeof.to_natural_32])))))
						if (l_http).c_pointer = default_pointer then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
						if not js.return_called then
							l_data.item.state.proto.http := l_http
						end
					else
						l_http.ce_gets (l_data.item.state.proto.http)
					end
					if not js.return_called and then (not l_data.item.state.this_is_a_follow) then
						if ((l_data.item.state.first_host).c_pointer /= default_pointer) then
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_data.item.state.first_host)])
						end
						l_data.item.state.first_host := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([a_conn.item.host.name]))
						if (l_data.item.state.first_host).c_pointer = default_pointer then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						if ((a_conn.item.protocol).bit_and (((1).bit_or (((1).bit_shift_left (2)))).to_integer_32)).to_boolean then
							if l_data.item.set.upload then
								l_httpreq := {PC_CURL_HTTPREQ}.HTTPREQ_PUT
							end
						end
						if (l_data.item.set.str[4]).c_pointer = default_pointer then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_request.ce_gets (l_data.item.set.str[4])
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 4 then -- else:
						if not (l_data.item.set.opt_no_body) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_request.ce_gets (ce_string ("HEAD"))
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 7 then -- else:
						inspect l_httpreq -- switch 1 head
						when 2 then l_pos := -1 + 8
						when 3 then l_pos := -1 + 8
						when 4 then l_pos := -1 + 9
						when 5 then l_pos := -1 + 11
						else l_pos := -1 + 10
						end
				when 8 then -- switch 1, case 2 | switch 1, case 3
						l_request.ce_gets (ce_string ("POST"))
						l_pos := -1 + 12 -- switch 1; break
				when 9 then -- switch 1, case 4
						l_request.ce_gets (ce_string ("PUT"))
						l_pos := -1 + 12 -- switch 1; break
				when 10 then -- switch 1, default:
						l_request.ce_gets (ce_string ("GET"))
						l_pos := -1 + 12 -- switch 1; break
				when 11 then -- switch 1, case 5
						l_request.ce_gets (ce_string ("HEAD"))
						l_pos := -1 + 12 -- switch 1; break
				when 12 then -- switch 1, done: | if done | if done
						if (((Curl_checkheaders (l_data, ce_string ("User-Agent:")))).c_pointer /= default_pointer) then
							if ((a_conn.item.allocptr.uagent).c_pointer /= default_pointer) then
								easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.uagent)])
								a_conn.item.allocptr.uagent := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							end
						end
						l_result := http_output_auth (a_conn, l_request, l_ppath, (0).to_boolean)
						if l_result.to_boolean then
							Result := l_result
							js.return
						end
				when 13 then -- if done
					if js.return_called then
						l_pos := -1 + 22 -- skip if block
					end
				when 14 then -- if:
						if not (l_data.item.state.authhost.multi) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 18 -- goto _L
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 17 then -- else:
						if not (l_data.item.state.authproxy.multi) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if: | _L:
						if l_httpreq.to_natural_32 /= {NATURAL_32} 1 then
							if l_httpreq.to_natural_32 /= {NATURAL_32} 5 then
								a_conn.item.bits.authneg := (1).to_boolean
							else
								a_conn.item.bits.authneg := (0).to_boolean
							end
						else
							a_conn.item.bits.authneg := (0).to_boolean
						end
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						a_conn.item.bits.authneg := (0).to_boolean
				when 21 then -- if done
						url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.ref))
						if ((l_data.item.change.referer).c_pointer /= default_pointer) then
							if (((Curl_checkheaders (l_data, ce_string ("Referer:")))).c_pointer /= default_pointer) then
								a_conn.item.allocptr.ref := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							else
								a_conn.item.allocptr.ref := mprintf_inst.curl_maprintf ([ce_string ("Referer: %%s%R%N"), l_data.item.change.referer])
							end
						else
							a_conn.item.allocptr.ref := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						end
						if ((l_data.item.set.str[2]).c_pointer /= default_pointer) then
							if ((Curl_checkheaders (l_data, ce_string ("Cookie:")))).c_pointer = default_pointer then
								l_addcookies.ce_gets (l_data.item.set.str[2])
							end
						end
						if ((Curl_checkheaders (l_data, ce_string ("Accept-Encoding:")))).c_pointer = default_pointer then
							if ((l_data.item.set.str[6]).c_pointer /= default_pointer) then
								url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.accept_encoding))
								a_conn.item.allocptr.accept_encoding := mprintf_inst.curl_maprintf ([ce_string ("Accept-Encoding: %%s%R%N"), l_data.item.set.str[6]])
								if (a_conn.item.allocptr.accept_encoding).c_pointer = default_pointer then
									Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
									js.return
								end
							end
						end
				when 22 then -- if done
					if not js.return_called then
						l_ptr.ce_gets ((Curl_checkheaders (l_data, ce_string ("Transfer-Encoding:"))))
						if ((l_ptr).c_pointer /= default_pointer) then
							l_data.item.req.upload_chunky := Curl_compareheader (l_ptr, ce_string ("Transfer-Encoding:"), ce_string ("chunked"))
						else
							if ((a_conn.item.protocol).bit_and (1)).to_boolean then
								if l_data.item.set.upload then
									if l_data.item.set.infilesize = -{INTEGER_64} 1 then
										if not a_conn.item.bits.authneg then
											if (use_http_1_1 (l_data, a_conn)) then
												l_data.item.req.upload_chunky := (1).to_boolean
											else
												sendf_inst.Curl_failf ([l_data, ce_string ("Chunky upload is not supported by HTTP 1.0")])
												Result := ({PC_CURLCODE}.CURLE_UPLOAD_FAILED)
												js.return
											end
										end
									else
										l_data.item.req.upload_chunky := (0).to_boolean
									end
								else
									l_data.item.req.upload_chunky := (0).to_boolean
								end
							else
								l_data.item.req.upload_chunky := (0).to_boolean
							end
							if not js.return_called and then (l_data.item.req.upload_chunky) then
								l_te.ce_gets (ce_string ("Transfer-Encoding: chunked%R%N"))
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 43 -- skip if block
					end
				when 23 then -- if:
						url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.host))
						l_ptr.ce_gets ((Curl_checkheaders (l_data, ce_string ("Host:"))))
						if (l_ptr).c_pointer = default_pointer then
							l_pos := -1 + 32 -- skip if block
						end
				when 24 then -- if:
						if l_data.item.state.this_is_a_follow then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 28 -- goto _L___4
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 27 then -- else:
						if not ((rawstr_inst.Curl_raw_equal (l_data.item.state.first_host, a_conn.item.host.name)).to_boolean) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if: | _L___4:
						l_cookiehost.ce_gets ((Curl_copy_header_value (l_ptr)))
						if (l_cookiehost).c_pointer = default_pointer then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
						if not js.return_called then
							if not (l_cookiehost[0]).to_boolean then
								easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_cookiehost)])
							else
								l_colon.ce_gets ((strchr (l_cookiehost, (':').code)))
								if ((l_colon).c_pointer /= default_pointer) then
									l_colon[0] := (0).to_integer_8
								end
								url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.cookiehost))
								a_conn.item.allocptr.cookiehost := l_cookiehost
							end
							a_conn.item.allocptr.host := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						end
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else:
						l_pos := -1 + 32 -- goto _L___3
				when 31 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 43
				when 32 then -- else: | _L___3:
						if not (((a_conn.item.protocol).bit_and (((1).bit_shift_left (1)).to_integer_32)).to_boolean) then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						if (a_conn.item.remote_port).to_integer_32 = 443 then
							l_pos := -1 + 37 -- goto _L___0
						else
							l_pos := -1 + 35 -- goto _L___2
						end
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 35 then -- else: | _L___2:
						if ((a_conn.item.protocol).bit_and (((1).bit_shift_left (1)).to_integer_32)).to_boolean then
							l_pos := -1 + 41 -- skip if block
						end
				when 36 then -- if:
						if (a_conn.item.remote_port).to_integer_32 /= 80 then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if: | _L___0:
						if a_conn.item.bits.ipv6_ip then
							l_tmp___9.ce_gets (ce_string ("]"))
						else
							l_tmp___9.ce_gets (ce_string (""))
						end
						if a_conn.item.bits.ipv6_ip then
							l_tmp___10.ce_gets (ce_string ("["))
						else
							l_tmp___10.ce_gets (ce_string (""))
						end
						a_conn.item.allocptr.host := mprintf_inst.curl_maprintf ([ce_string ("Host: %%s%%s%%s%R%N"), l_tmp___10, l_host, l_tmp___9])
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 39 then -- else:
						l_pos := -1 + 41 -- goto _L___1
				when 40 then -- if done | if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else: | _L___1:
						if a_conn.item.bits.ipv6_ip then
							l_tmp___11.ce_gets (ce_string ("]"))
						else
							l_tmp___11.ce_gets (ce_string (""))
						end
						if a_conn.item.bits.ipv6_ip then
							l_tmp___12.ce_gets (ce_string ("["))
						else
							l_tmp___12.ce_gets (ce_string (""))
						end
						a_conn.item.allocptr.host := mprintf_inst.curl_maprintf ([ce_string ("Host: %%s%%s%%s:%%hu%R%N"), l_tmp___12, l_host, l_tmp___11, (a_conn.item.remote_port).to_integer_32])
				when 42 then -- if done
						if (a_conn.item.allocptr.host).c_pointer = default_pointer then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
				when 43 then -- if done
						if not (not js.return_called and then (a_conn.item.bits.httpproxy)) then
							l_pos := -1 + 56 -- skip if block
						end
				when 44 then -- if:
							if a_conn.item.bits.tunnel_proxy then
								l_pos := -1 + 56 -- skip if block
							end
				when 45 then -- if:
							if ((a_conn.item.host.dispname).c_pointer.to_integer_32).to_natural_32 /= ((a_conn.item.host.name).c_pointer.to_integer_32).to_natural_32 then
								l_url.ce_gets (l_data.item.change.url)
								l_ptr.ce_gets ((strstr (l_url, a_conn.item.host.dispname)))
								if ((l_ptr).c_pointer /= default_pointer) then
									l_currlen := (strlen (a_conn.item.host.dispname))
									l_newlen := (strlen (a_conn.item.host.name))
									l_urllen := (strlen (l_url))
									l_newurl.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([((l_urllen + l_newlen) - l_currlen) + {NATURAL_32} 1])))))
									if ((l_newurl).c_pointer /= default_pointer) then
										memcpy (create {CE_POINTER [ANY]}.make_cast (l_newurl), create {CE_POINTER [ANY]}.make_cast (l_url), (l_ptr.distance (l_url)).to_natural_32).do_nothing
										memcpy (create {CE_POINTER [ANY]}.make_cast ((l_newurl + (l_ptr.distance (l_url)))), create {CE_POINTER [ANY]}.make_cast (a_conn.item.host.name), l_newlen).do_nothing
										memcpy (create {CE_POINTER [ANY]}.make_cast (((l_newurl + l_newlen.to_integer_32) + (l_ptr.distance (l_url)))), create {CE_POINTER [ANY]}.make_cast ((l_ptr + l_currlen.to_integer_32)), ((l_urllen - (l_ptr.distance (l_url)).to_natural_32) - l_currlen) + {NATURAL_32} 1).do_nothing
										if l_data.item.change.url_alloc then
											easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_data.item.change.url)])
										end
										l_data.item.change.url := l_newurl
										l_data.item.change.url_alloc := (1).to_boolean
									else
										Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
										js.return
									end
								end
							end
							if js.return_called then
								l_pos := -1 + 56 -- skip if block
							end
				when 46 then -- if:
							l_ppath.ce_gets (l_data.item.change.url)
							if not ((rawstr_inst.Curl_raw_nequal (ce_string ("ftp://"), l_ppath, (strlen (ce_string ("ftp://"))))).to_boolean) then
								l_pos := -1 + 56 -- skip if block
							end
				when 47 then -- if:
							if not (l_data.item.set.proxy_transfer_mode) then
								l_pos := -1 + 55 -- skip if block
							end
				when 48 then -- if:
							l_type.ce_gets ((strstr (l_ppath, ce_string (";type="))))
							if (l_type).c_pointer = default_pointer then
								l_pos := -1 + 54 -- skip if block
							end
				when 49 then -- if:
							if not ((l_type[6]).to_boolean) then
								l_pos := -1 + 54 -- skip if block
							end
				when 50 then -- if:
							if (l_type[7]).to_integer_32 /= 0 then
								l_pos := -1 + 54 -- skip if block
							end
				when 51 then -- if:
							inspect (rawstr_inst.Curl_raw_toupper (l_type[6])).to_integer_32 -- switch 2 head
							when 65 then l_pos := -1 + 52
							when 68 then l_pos := -1 + 52
							when 73 then l_pos := -1 + 52
							else l_pos := -1 + 53
							end
				when 52 then -- switch 2, case 65 | switch 2, case 68 | switch 2, case 73
							l_pos := -1 + 54 -- switch 2; break
				when 53 then -- switch 2, default:
							l_type.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
				when 54 then -- switch 2, done: | if done | if done | if done
							if (l_type).c_pointer = default_pointer then
								l_p.ce_gets (l_ftp_typecode)
								if not ((l_data.item.state.path).item).to_boolean then
									if (l_ppath[((strlen (l_ppath)) - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 47 then
										l_tmp___21.ce_gets (l_p)
										l_p.ce_gets (l_p + 1)
										l_tmp___21[0] := (('/').code).to_integer_8
									end
								end
								if l_data.item.set.prefer_ascii then
									l_tmp___23 := ('a').code
								else
									l_tmp___23 := ('i').code
								end
								mprintf_inst.curl_msnprintf ([l_p, (Integer_8_bytes.to_natural_32 * (("/;type=?").count + 1).to_natural_32) - {NATURAL_32} 1, ce_string (";type=%%c"), l_tmp___23]).do_nothing
							end
				when 55 then -- if done
							if a_conn.item.bits.user_passwd then
								if not a_conn.item.bits.userpwd_in_url then
									l_paste_ftp_userpwd := (1).to_boolean
								end
							end
				when 56 then -- if done | if done | if done | if done
							if not js.return_called and then ({NATURAL_32} 3 = l_httpreq.to_natural_32) then
								l_result := formdata_inst.Curl_getFormData (create {CE_POINTER [CE_POINTER [PD_FORMDATA]]}.make_shared (l_http.c_pointer + {PD_HTTP}.sendit_offset), l_data.item.set.httppost, (Curl_checkheaders (l_data, ce_string ("Content-Type:"))), create {CE_POINTER [INTEGER_64]}.make_shared (l_http.c_pointer + {PD_HTTP}.postsize_offset))
								if {NATURAL_32} 0 /= l_result.to_natural_32 then
									sendf_inst.Curl_failf ([l_data, ce_string ("failed creating formpost data")])
									Result := l_result
									js.return
								end
							end
							if js.return_called then
								l_pos := -1 + 65 -- skip if block
							end
				when 57 then -- if:
								if (((Curl_checkheaders (l_data, ce_string ("Accept:")))).c_pointer /= default_pointer) then
									l_http.item.p_accept := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
								else
									l_http.item.p_accept := ce_string ("Accept: */*%R%N")
								end
								if {NATURAL_32} 2 /= l_httpreq.to_natural_32 then
									l_pos := -1 + 60 -- skip if block
								end
				when 58 then -- if:
								l_pos := -1 + 64 -- goto _L___5
				when 59 then -- if block done, skip else block:
								l_pos := -1 + 65
				when 60 then -- else:
								if {NATURAL_32} 3 /= l_httpreq.to_natural_32 then
									l_pos := -1 + 63 -- skip if block
								end
				when 61 then -- if:
								l_pos := -1 + 64 -- goto _L___5
				when 62 then -- if block done, skip else block:
								l_pos := -1 + 65
				when 63 then -- else:
								if {NATURAL_32} 4 /= l_httpreq.to_natural_32 then
									l_pos := -1 + 65 -- skip if block
								end
				when 64 then -- if: | _L___5:
								if (l_data.item.state.resume_from).to_boolean then
									if l_data.item.state.resume_from < {INTEGER_64} 0 then
										l_data.item.state.resume_from := (0).to_integer_64
									end
									if (l_data.item.state.resume_from).to_boolean then
										if not l_data.item.state.this_is_a_follow then
											if ((a_conn.item.seek_func).c_pointer /= default_pointer) then
												l_seekerr := (a_conn.item.seek_func).integer_32_item ([a_conn.item.seek_client, l_data.item.state.resume_from, 0])
											end
											if l_seekerr /= 0 then
												if l_seekerr /= 2 then
													sendf_inst.Curl_failf ([l_data, ce_string ("Could not seek stream")])
													Result := ({PC_CURLCODE}.CURLE_READ_ERROR)
													js.return
												else
													l_passed := (0).to_integer_64
													from
													until
														js.loop_left
													loop
														js.reset
														l_readthisamountnow := (l_data.item.state.resume_from - l_passed).to_natural_32
														if l_readthisamountnow > {NATURAL_32} 16384 then
															l_readthisamountnow := (16384).to_natural_32
														end
														l_actuallyread := (l_data.item.set.fread_func).natural_32_item ([l_data.item.state.buffer, (1).to_natural_32, l_readthisamountnow, l_data.item.set.in])
														l_passed := l_passed + l_actuallyread.to_integer_64
														if l_actuallyread /= l_readthisamountnow then
															sendf_inst.Curl_failf ([l_data, ce_string ("Could only read %%lld bytes from the input"), l_passed])
															Result := ({PC_CURLCODE}.CURLE_READ_ERROR)
															js.return
														end
														if not js.return_called and then (l_passed = l_data.item.state.resume_from) then
															js.break
														end
													end
													js.reset
												end
											end
											if not js.return_called and then (l_data.item.set.infilesize > {INTEGER_64} 0) then
												l_data.item.set.infilesize := l_data.item.set.infilesize - (l_data.item.state.resume_from)
												if l_data.item.set.infilesize <= {INTEGER_64} 0 then
													sendf_inst.Curl_failf ([l_data, ce_string ("File already completely uploaded")])
													Result := ({PC_CURLCODE}.CURLE_PARTIAL_FILE)
													js.return
												end
											end
										end
									end
								end
				when 65 then -- if done | if done | if done
								if not (not js.return_called and then (l_data.item.state.use_range)) then
									l_pos := -1 + 73 -- skip if block
								end
				when 66 then -- if:
									if l_httpreq.to_natural_32 /= {NATURAL_32} 1 then
										l_pos := -1 + 69 -- skip if block
									end
				when 67 then -- if:
									l_pos := -1 + 70 -- goto _L___7
				when 68 then -- if block done, skip else block:
									l_pos := -1 + 73
				when 69 then -- else:
									if l_httpreq.to_natural_32 /= {NATURAL_32} 5 then
										l_pos := -1 + 72 -- skip if block
									end
				when 70 then -- if: | _L___7:
									if (((Curl_checkheaders (l_data, ce_string ("Range:")))).c_pointer /= default_pointer) then
										l_pos := -1 + 72 -- goto _L___6
									else
										if ((a_conn.item.allocptr.rangeline).c_pointer /= default_pointer) then
											easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.rangeline)])
										end
										a_conn.item.allocptr.rangeline := mprintf_inst.curl_maprintf ([ce_string ("Range: bytes=%%s%R%N"), l_data.item.state.range])
									end
				when 71 then -- if block done, skip else block:
									l_pos := -1 + 73
				when 72 then -- else: | _L___6:
									if l_httpreq.to_natural_32 /= {NATURAL_32} 1 then
										if ((Curl_checkheaders (l_data, ce_string ("Content-Range:")))).c_pointer = default_pointer then
											if ((a_conn.item.allocptr.rangeline).c_pointer /= default_pointer) then
												easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.rangeline)])
											end
											if l_data.item.set.set_resume_from < {INTEGER_64} 0 then
												a_conn.item.allocptr.rangeline := mprintf_inst.curl_maprintf ([ce_string ("Content-Range: bytes 0-%%lld/%%lld%R%N"), l_data.item.set.infilesize - {INTEGER_64} 1, l_data.item.set.infilesize])
											elseif (l_data.item.state.resume_from).to_boolean then
												l_total_expected_size := l_data.item.state.resume_from + l_data.item.set.infilesize
												a_conn.item.allocptr.rangeline := mprintf_inst.curl_maprintf ([ce_string ("Content-Range: bytes %%s%%lld/%%lld%R%N"), l_data.item.state.range, l_total_expected_size - {INTEGER_64} 1, l_total_expected_size])
											else
												a_conn.item.allocptr.rangeline := mprintf_inst.curl_maprintf ([ce_string ("Content-Range: bytes %%s/%%lld%R%N"), l_data.item.state.range, l_data.item.set.infilesize])
											end
											if (a_conn.item.allocptr.rangeline).c_pointer = default_pointer then
												Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
												js.return
											end
										end
									end
				when 73 then -- if done | if done
									if not js.return_called then
										if (use_http_1_1 (l_data, a_conn)) then
											l_httpstring.ce_gets (ce_string ("1.1"))
										else
											l_httpstring.ce_gets (ce_string ("1.0"))
										end
										l_req_buffer.ce_gets (Curl_add_buffer_init)
										if (l_req_buffer).c_pointer = default_pointer then
											Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
											js.return
										end
									end
									if not js.return_called then
										l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("%%s "), l_request])
										if l_result.to_boolean then
											Result := l_result
											js.return
										end
									end
									if not js.return_called then
										if l_paste_ftp_userpwd then
											l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("ftp://%%s:%%s@%%s"), a_conn.item.user, a_conn.item.passwd, (l_ppath + ((("ftp://").count + 1).to_natural_32).to_integer_32) - 1])
										else
											l_result := Curl_add_buffer (l_req_buffer, create {CE_POINTER [ANY]}.make_cast (l_ppath), (strlen (l_ppath)))
										end
										if l_result.to_boolean then
											Result := l_result
											js.return
										end
									end
									if not js.return_called then
										if a_conn.item.bits.httpproxy then
											if not a_conn.item.bits.tunnel_proxy then
												if (((Curl_checkheaders (l_data, ce_string ("Proxy-Connection:")))).c_pointer /= default_pointer) then
													l_tmp___35.ce_gets (ce_string (""))
												else
													l_tmp___35.ce_gets (ce_string ("Proxy-Connection: Keep-Alive%R%N"))
												end
											else
												l_tmp___35.ce_gets (ce_string (""))
											end
										else
											l_tmp___35.ce_gets (ce_string (""))
										end
										if ((l_data.item.change.referer).c_pointer /= default_pointer) then
											if ((a_conn.item.allocptr.ref).c_pointer /= default_pointer) then
												l_tmp___37.ce_gets (a_conn.item.allocptr.ref)
											else
												l_tmp___37.ce_gets (ce_string (""))
											end
										else
											l_tmp___37.ce_gets (ce_string (""))
										end
										if ((l_data.item.set.str[6]).c_pointer /= default_pointer) then
											if ((l_data.item.set.str[6]).item).to_boolean then
												if ((a_conn.item.allocptr.accept_encoding).c_pointer /= default_pointer) then
													l_tmp___38.ce_gets (a_conn.item.allocptr.accept_encoding)
												else
													l_tmp___38.ce_gets (ce_string (""))
												end
											else
												l_tmp___38.ce_gets (ce_string (""))
											end
										else
											l_tmp___38.ce_gets (ce_string (""))
										end
										if ((l_http.item.p_accept).c_pointer /= default_pointer) then
											l_tmp___39.ce_gets (l_http.item.p_accept)
										else
											l_tmp___39.ce_gets (ce_string (""))
										end
										if ((a_conn.item.allocptr.host).c_pointer /= default_pointer) then
											l_tmp___40.ce_gets (a_conn.item.allocptr.host)
										else
											l_tmp___40.ce_gets (ce_string (""))
										end
										if ((l_data.item.set.str[25]).c_pointer /= default_pointer) then
											if ((l_data.item.set.str[25]).item).to_boolean then
												if ((a_conn.item.allocptr.uagent).c_pointer /= default_pointer) then
													l_tmp___41.ce_gets (a_conn.item.allocptr.uagent)
												else
													l_tmp___41.ce_gets (ce_string (""))
												end
											else
												l_tmp___41.ce_gets (ce_string (""))
											end
										else
											l_tmp___41.ce_gets (ce_string (""))
										end
										if l_data.item.state.use_range then
											if ((a_conn.item.allocptr.rangeline).c_pointer /= default_pointer) then
												l_tmp___42.ce_gets (a_conn.item.allocptr.rangeline)
											else
												l_tmp___42.ce_gets (ce_string (""))
											end
										else
											l_tmp___42.ce_gets (ce_string (""))
										end
										if ((a_conn.item.allocptr.userpwd).c_pointer /= default_pointer) then
											l_tmp___43.ce_gets (a_conn.item.allocptr.userpwd)
										else
											l_tmp___43.ce_gets (ce_string (""))
										end
										if ((a_conn.item.allocptr.proxyuserpwd).c_pointer /= default_pointer) then
											l_tmp___44.ce_gets (a_conn.item.allocptr.proxyuserpwd)
										else
											l_tmp___44.ce_gets (ce_string (""))
										end
										l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("%%s HTTP/%%s%R%N%%s%%s%%s%%s%%s%%s%%s%%s%%s%%s"), l_ftp_typecode, l_httpstring, l_tmp___44, l_tmp___43, l_tmp___42, l_tmp___41, l_tmp___40, l_tmp___39, l_tmp___38, l_tmp___37, l_tmp___35, l_te])
										url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_conn.item.allocptr.userpwd))
										a_conn.item.allocptr.userpwd := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
										if l_result.to_boolean then
											Result := l_result
											js.return
										end
									end
									if js.return_called then
										l_pos := -1 + 79 -- skip if block
									end
				when 74 then -- if:
										if (l_data.item.cookies).c_pointer = default_pointer then
											l_pos := -1 + 77 -- skip if block
										end
				when 75 then -- if:
										l_pos := -1 + 78 -- goto _L___8
				when 76 then -- if block done, skip else block:
										l_pos := -1 + 79
				when 77 then -- else:
										if (l_addcookies).c_pointer = default_pointer then
											l_pos := -1 + 79 -- skip if block
										end
				when 78 then -- if: | _L___8:
										l_co.ce_gets (create {CE_POINTER [PD_COOKIE]}.make_shared (default_pointer))
										l_count := 0
										if ((l_data.item.cookies).c_pointer /= default_pointer) then
											share_inst.Curl_share_lock (l_data, {PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_COOKIE, {PC_CURL_LOCK_ACCESS}.CURL_LOCK_ACCESS_SINGLE).do_nothing
											if ((a_conn.item.protocol).bit_and (((1).bit_shift_left (1)).to_integer_32)).to_boolean then
												l_tmp___45 := 1
											else
												l_tmp___45 := 0
											end
											if ((a_conn.item.allocptr.cookiehost).c_pointer /= default_pointer) then
												l_tmp___46.ce_gets (a_conn.item.allocptr.cookiehost)
											else
												l_tmp___46.ce_gets (l_host)
											end
											l_co.ce_gets (cookie_inst.Curl_cookie_getlist (l_data.item.cookies, l_tmp___46, l_data.item.state.path, l_tmp___45.to_boolean))
											share_inst.Curl_share_unlock (l_data, {PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_COOKIE).do_nothing
										end
										if ((l_co).c_pointer /= default_pointer) then
											l_store.ce_gets (l_co)
											from
											until
												not (not js.loop_left and then ((l_co).c_pointer /= default_pointer))
											loop
												js.reset
												if ((l_co.item.value).c_pointer /= default_pointer) then
													if 0 = l_count then
														l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("Cookie: ")])
														if l_result.to_boolean then
															js.break
														end
													end
													if not js.loop_jumped then
														if l_count.to_boolean then
															l_tmp___47.ce_gets (ce_string ("; "))
														else
															l_tmp___47.ce_gets (ce_string (""))
														end
														l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("%%s%%s=%%s"), l_tmp___47, l_co.item.name, l_co.item.value])
														if l_result.to_boolean then
															js.break
														end
													end
													if not js.loop_jumped then
														l_count := l_count + 1
													end
												end
												if not js.loop_jumped then
													l_co.ce_gets (l_co.item.next)
												end
											end
											js.reset
											cookie_inst.Curl_cookie_freelist (l_store, (0).to_boolean)
										end
										if ((l_addcookies).c_pointer /= default_pointer) then
											if {NATURAL_32} 0 = l_result.to_natural_32 then
												if not l_count.to_boolean then
													l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("Cookie: ")])
												end
												if {NATURAL_32} 0 = l_result.to_natural_32 then
													if l_count.to_boolean then
														l_tmp___48.ce_gets (ce_string ("; "))
													else
														l_tmp___48.ce_gets (ce_string (""))
													end
													l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("%%s%%s"), l_tmp___48, l_addcookies])
													l_count := l_count + 1
												end
											end
										end
										if l_count.to_boolean then
											if {NATURAL_32} 0 = l_result.to_natural_32 then
												l_result := Curl_add_buffer (l_req_buffer, create {CE_POINTER [ANY]}.make_cast (ce_string ("%R%N")), (2).to_natural_32)
											end
										end
										if l_result.to_boolean then
											Result := l_result
											js.return
										end
				when 79 then -- if done | if done
										if not js.return_called and then ((l_data.item.set.timecondition).to_boolean) then
											l_result := Curl_add_timecondition (l_data, l_req_buffer)
											if l_result.to_boolean then
												Result := l_result
												js.return
											end
										end
										if not js.return_called then
											l_result := Curl_add_custom_headers (a_conn, l_req_buffer)
											if l_result.to_boolean then
												Result := l_result
												js.return
											end
										end
										if js.return_called then
											l_pos := -1 + 119 -- skip if block
										end
				when 80 then -- if:
											l_http.item.postdata := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
											progress_inst.Curl_pgrsSetUploadSize (l_data, (0).to_integer_64)
											inspect l_httpreq -- switch 3 head
											when 3 then l_pos := -1 + 81
											when 4 then l_pos := -1 + 87
											when 2 then l_pos := -1 + 88
											else l_pos := -1 + 118
											end
				when 81 then -- switch 3, case 3
											if ((l_http.item.sendit).c_pointer /= default_pointer) then
												l_pos := -1 + 84 -- skip if block
											end
				when 82 then -- if:
											l_pos := -1 + 85 -- goto _L___9
				when 83 then -- if block done, skip else block:
											l_pos := -1 + 86
				when 84 then -- else:
											if not (a_conn.item.bits.authneg) then
												l_pos := -1 + 86 -- skip if block
											end
				when 85 then -- if: | _L___9:
											l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("Content-Length: 0%R%N%R%N")])
											if l_result.to_boolean then
												Result := l_result
												js.return
											end
											if not js.return_called then
												l_result := Curl_add_buffer_send (l_req_buffer, a_conn, create {CE_POINTER [INTEGER_32]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.info_offset + {PD_PUREINFO}.request_size_offset), (0).to_natural_32, 0)
												if l_result.to_boolean then
													sendf_inst.Curl_failf ([l_data, ce_string ("Failed sending POST request")])
												else
													transfer_inst.Curl_setup_transfer (a_conn, 0, (-1).to_integer_64, (1).to_boolean, create {CE_POINTER [INTEGER_64]}.make_shared (l_http.c_pointer + {PD_HTTP}.readbytecount_offset), -1, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer))
												end
											end
											l_pos := -1 + 119 -- switch 3; break
				when 86 then -- if done
											if not js.return_called then
												if (formdata_inst.Curl_FormInit (create {CE_POINTER [PD_FORM]}.make_shared (l_http.c_pointer + {PD_HTTP}.form_offset), l_http.item.sendit)).to_boolean then
													sendf_inst.Curl_failf ([l_data, ce_string ("Internal HTTP POST error!")])
													Result := ({PC_CURLCODE}.CURLE_HTTP_POST_ERROR)
													js.return
												end
											end
											if not js.return_called then
												l_http.item.form.fread_func := a_conn.item.fread_func
												a_conn.item.fread_func := (formdata_inst.Curl_FormReader_address)
												a_conn.item.fread_in := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_FORM]}.make_shared (l_http.c_pointer + {PD_HTTP}.form_offset)))
												l_http.item.sending := {PC_SENDING}.HTTPSEND_BODY
												if not l_data.item.req.upload_chunky then
													l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("Content-Length: %%lld%R%N"), l_http.item.postsize])
													if l_result.to_boolean then
														Result := l_result
														js.return
													end
												end
											end
											if not js.return_called then
												l_result := expect100 (l_data, a_conn, l_req_buffer)
												if l_result.to_boolean then
													Result := l_result
													js.return
												end
											end
											if not js.return_called then
												l_linelength := (0).to_natural_32
												l_contentType.ce_gets (formdata_inst.Curl_formpostheader (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_FORM]}.make_shared (l_http.c_pointer + {PD_HTTP}.form_offset))), create {CE_POINTER [NATURAL_32]}.make_shared ($l_linelength)))
												if (l_contentType).c_pointer = default_pointer then
													sendf_inst.Curl_failf ([l_data, ce_string ("Could not get Content-Type header line!")])
													Result := ({PC_CURLCODE}.CURLE_HTTP_POST_ERROR)
													js.return
												end
											end
											if not js.return_called then
												l_result := Curl_add_buffer (l_req_buffer, create {CE_POINTER [ANY]}.make_cast (l_contentType), l_linelength)
												if l_result.to_boolean then
													Result := l_result
													js.return
												end
											end
											if not js.return_called then
												l_result := Curl_add_buffer (l_req_buffer, create {CE_POINTER [ANY]}.make_cast (ce_string ("%R%N")), (2).to_natural_32)
												if l_result.to_boolean then
													Result := l_result
													js.return
												end
											end
											if not js.return_called then
												progress_inst.Curl_pgrsSetUploadSize (l_data, l_http.item.postsize)
												l_result := Curl_add_buffer_send (l_req_buffer, a_conn, create {CE_POINTER [INTEGER_32]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.info_offset + {PD_PUREINFO}.request_size_offset), (0).to_natural_32, 0)
												if l_result.to_boolean then
													sendf_inst.Curl_failf ([l_data, ce_string ("Failed sending POST request")])
												else
													transfer_inst.Curl_setup_transfer (a_conn, 0, (-1).to_integer_64, (1).to_boolean, create {CE_POINTER [INTEGER_64]}.make_shared (l_http.c_pointer + {PD_HTTP}.readbytecount_offset), 0, create {CE_POINTER [INTEGER_64]}.make_shared (l_http.c_pointer + {PD_HTTP}.writebytecount_offset))
												end
												if l_result.to_boolean then
													formdata_inst.Curl_formclean (create {CE_POINTER [CE_POINTER [PD_FORMDATA]]}.make_shared (l_http.c_pointer + {PD_HTTP}.sendit_offset))
													Result := l_result
													js.return
												end
											end
											l_pos := -1 + 119 -- switch 3; break
				when 87 then -- switch 3, case 4
											if a_conn.item.bits.authneg then
												l_postsize := (0).to_integer_64
											else
												l_postsize := l_data.item.set.infilesize
											end
											if l_postsize /= -{INTEGER_64} 1 then
												if not l_data.item.req.upload_chunky then
													l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("Content-Length: %%lld%R%N"), l_postsize])
													if l_result.to_boolean then
														Result := l_result
														js.return
													end
												end
											end
											if not js.return_called then
												l_result := expect100 (l_data, a_conn, l_req_buffer)
												if l_result.to_boolean then
													Result := l_result
													js.return
												end
											end
											if not js.return_called then
												l_result := Curl_add_buffer (l_req_buffer, create {CE_POINTER [ANY]}.make_cast (ce_string ("%R%N")), (2).to_natural_32)
												if l_result.to_boolean then
													Result := l_result
													js.return
												end
											end
											if not js.return_called then
												progress_inst.Curl_pgrsSetUploadSize (l_data, l_postsize)
												l_result := Curl_add_buffer_send (l_req_buffer, a_conn, create {CE_POINTER [INTEGER_32]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.info_offset + {PD_PUREINFO}.request_size_offset), (0).to_natural_32, 0)
												if l_result.to_boolean then
													sendf_inst.Curl_failf ([l_data, ce_string ("Failed sending PUT request")])
												else
													if l_postsize.to_boolean then
														l_tmp___50.ce_gets (create {CE_POINTER [INTEGER_64]}.make_shared (l_http.c_pointer + {PD_HTTP}.writebytecount_offset))
													else
														l_tmp___50.ce_gets (create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer))
													end
													if l_postsize.to_boolean then
														l_tmp___51 := 0
													else
														l_tmp___51 := -1
													end
													transfer_inst.Curl_setup_transfer (a_conn, 0, (-1).to_integer_64, (1).to_boolean, create {CE_POINTER [INTEGER_64]}.make_shared (l_http.c_pointer + {PD_HTTP}.readbytecount_offset), l_tmp___51, l_tmp___50)
												end
												if l_result.to_boolean then
													Result := l_result
													js.return
												end
											end
											l_pos := -1 + 119 -- switch 3; break
				when 88 then -- switch 3, case 2
											if a_conn.item.bits.authneg then
												l_postsize := (0).to_integer_64
											elseif l_data.item.set.postfieldsize /= -{INTEGER_64} 1 then
												l_postsize := l_data.item.set.postfieldsize
											else
												if ((l_data.item.set.postfields).c_pointer /= default_pointer) then
													l_tmp___53 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_data.item.set.postfields))).to_integer_64
												else
													l_tmp___53 := (-1).to_integer_64
												end
												l_postsize := l_tmp___53
											end
											if l_data.item.req.upload_chunky then
												l_pos := -1 + 94 -- skip if block
											end
				when 89 then -- if:
											if not (a_conn.item.bits.authneg) then
												l_pos := -1 + 92 -- skip if block
											end
				when 90 then -- if:
											l_pos := -1 + 93 -- goto _L___10
				when 91 then -- if block done, skip else block:
											l_pos := -1 + 94
				when 92 then -- else:
											if (((Curl_checkheaders (l_data, ce_string ("Content-Length:")))).c_pointer /= default_pointer) then
												l_pos := -1 + 94 -- skip if block
											end
				when 93 then -- if: | _L___10:
											l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("Content-Length: %%lld%R%N"), l_postsize])
											if l_result.to_boolean then
												Result := l_result
												js.return
											end
				when 94 then -- if done | if done
											if not js.return_called then
												if ((Curl_checkheaders (l_data, ce_string ("Content-Type:")))).c_pointer = default_pointer then
													l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("Content-Type: application/x-www-form-urlencoded%R%N")])
													if l_result.to_boolean then
														Result := l_result
														js.return
													end
												end
											end
											if js.return_called then
												l_pos := -1 + 105 -- skip if block
											end
				when 95 then -- if:
											l_ptr.ce_gets ((Curl_checkheaders (l_data, ce_string ("Expect:"))))
											if (l_ptr).c_pointer = default_pointer then
												l_pos := -1 + 98 -- skip if block
											end
				when 96 then -- if:
											l_data.item.state.expect100header := Curl_compareheader (l_ptr, ce_string ("Expect:"), ce_string ("100-continue"))
				when 97 then -- if block done, skip else block:
											l_pos := -1 + 105
				when 98 then -- else:
											if not (l_postsize > {INTEGER_64} 1024) then
												l_pos := -1 + 101 -- skip if block
											end
				when 99 then -- if:
											l_pos := -1 + 102 -- goto _L___11
				when 100 then -- if block done, skip else block:
											l_pos := -1 + 105
				when 101 then -- else:
											if not (l_postsize < {INTEGER_64} 0) then
												l_pos := -1 + 104 -- skip if block
											end
				when 102 then -- if: | _L___11:
											l_result := expect100 (l_data, a_conn, l_req_buffer)
											if l_result.to_boolean then
												Result := l_result
												js.return
											end
				when 103 then -- if block done, skip else block:
											l_pos := -1 + 105
				when 104 then -- else:
											l_data.item.state.expect100header := (0).to_boolean
				when 105 then -- if done | if done | if done
											if js.return_called then
												l_pos := -1 + 117 -- skip if block
											end
				when 106 then -- if:
											if (l_data.item.set.postfields).c_pointer = default_pointer then
												l_pos := -1 + 112 -- skip if block
											end
				when 107 then -- if:
											if l_data.item.state.expect100header then
												l_pos := -1 + 110 -- skip if block
											end
				when 108 then -- if:
											if l_postsize < {INTEGER_64} 65536 then
												l_result := Curl_add_buffer (l_req_buffer, create {CE_POINTER [ANY]}.make_cast (ce_string ("%R%N")), (2).to_natural_32)
												if l_result.to_boolean then
													Result := l_result
													js.return
												end
												if not js.return_called then
													if not l_data.item.req.upload_chunky then
														l_result := Curl_add_buffer (l_req_buffer, l_data.item.set.postfields, l_postsize.to_natural_32)
														l_included_body := l_postsize
													else
														l_result := Curl_add_bufferf ([l_req_buffer, ce_string ("%%x%R%N"), l_postsize.to_integer_32])
														if {NATURAL_32} 0 = l_result.to_natural_32 then
															l_result := Curl_add_buffer (l_req_buffer, l_data.item.set.postfields, l_postsize.to_natural_32)
														end
														if {NATURAL_32} 0 = l_result.to_natural_32 then
															l_result := Curl_add_buffer (l_req_buffer, create {CE_POINTER [ANY]}.make_cast (ce_string ("%R%N0%R%N%R%N")), (7).to_natural_32)
														end
														l_included_body := l_postsize + {INTEGER_64} 7
													end
													if l_result.to_boolean then
														Result := l_result
														js.return
													end
												end
												if not js.return_called then
													progress_inst.Curl_pgrsSetUploadSize (l_data, l_postsize)
												end
											else
												l_pos := -1 + 110 -- goto _L___12
											end
				when 109 then -- if block done, skip else block:
											l_pos := -1 + 111
				when 110 then -- else: | _L___12:
											l_http.item.postsize := l_postsize
											l_http.item.postdata := create {CE_POINTER [INTEGER_8]}.make_cast (l_data.item.set.postfields)
											l_http.item.sending := {PC_SENDING}.HTTPSEND_BODY
											a_conn.item.fread_func := readmoredata_address
											a_conn.item.fread_in := create {CE_POINTER [ANY]}.make_cast (a_conn)
											progress_inst.Curl_pgrsSetUploadSize (l_data, l_http.item.postsize)
											l_result := Curl_add_buffer (l_req_buffer, create {CE_POINTER [ANY]}.make_cast (ce_string ("%R%N")), (2).to_natural_32)
											if l_result.to_boolean then
												Result := l_result
												js.return
											end
				when 111 then -- if done | if block done, skip else block:
											l_pos := -1 + 117
				when 112 then -- else:
											l_result := Curl_add_buffer (l_req_buffer, create {CE_POINTER [ANY]}.make_cast (ce_string ("%R%N")), (2).to_natural_32)
											if l_result.to_boolean then
												Result := l_result
												js.return
											end
											if js.return_called then
												l_pos := -1 + 117 -- skip if block
											end
				when 113 then -- if:
											if not (l_data.item.req.upload_chunky) then
												l_pos := -1 + 116 -- skip if block
											end
				when 114 then -- if:
											if a_conn.item.bits.authneg then
												l_result := Curl_add_buffer (l_req_buffer, create {CE_POINTER [ANY]}.make_cast (ce_string ("%R%N0%R%N%R%N")), (7).to_natural_32)
												if l_result.to_boolean then
													Result := l_result
													js.return
												end
											else
												l_pos := -1 + 116 -- goto _L___13
											end
				when 115 then -- if block done, skip else block:
											l_pos := -1 + 117
				when 116 then -- else: | _L___13:
											if (l_data.item.set.postfieldsize).to_boolean then
												if l_postsize.to_boolean then
													l_tmp___57 := l_postsize
												else
													l_tmp___57 := (-1).to_integer_64
												end
												progress_inst.Curl_pgrsSetUploadSize (l_data, l_tmp___57)
												if not a_conn.item.bits.authneg then
													l_http.item.postdata := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (l_http.c_pointer + {PD_HTTP}.postdata_offset)))
													l_http.item.postsize := l_postsize
												end
											end
				when 117 then -- if done | if done | if done
											if not js.return_called then
												l_result := Curl_add_buffer_send (l_req_buffer, a_conn, create {CE_POINTER [INTEGER_32]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.info_offset + {PD_PUREINFO}.request_size_offset), l_included_body.to_natural_32, 0)
												if l_result.to_boolean then
													sendf_inst.Curl_failf ([l_data, ce_string ("Failed sending HTTP POST request")])
												else
													if ((l_http.item.postdata).c_pointer /= default_pointer) then
														l_tmp___58.ce_gets (create {CE_POINTER [INTEGER_64]}.make_shared (l_http.c_pointer + {PD_HTTP}.writebytecount_offset))
													else
														l_tmp___58.ce_gets (create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer))
													end
													if ((l_http.item.postdata).c_pointer /= default_pointer) then
														l_tmp___59 := 0
													else
														l_tmp___59 := -1
													end
													transfer_inst.Curl_setup_transfer (a_conn, 0, (-1).to_integer_64, (1).to_boolean, create {CE_POINTER [INTEGER_64]}.make_shared (l_http.c_pointer + {PD_HTTP}.readbytecount_offset), l_tmp___59, l_tmp___58)
												end
											end
											l_pos := -1 + 119 -- switch 3; break
				when 118 then -- switch 3, default:
											l_result := Curl_add_buffer (l_req_buffer, create {CE_POINTER [ANY]}.make_cast (ce_string ("%R%N")), (2).to_natural_32)
											if l_result.to_boolean then
												Result := l_result
												js.return
											end
											if not js.return_called then
												l_result := Curl_add_buffer_send (l_req_buffer, a_conn, create {CE_POINTER [INTEGER_32]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.info_offset + {PD_PUREINFO}.request_size_offset), (0).to_natural_32, 0)
												if l_result.to_boolean then
													sendf_inst.Curl_failf ([l_data, ce_string ("Failed sending HTTP request")])
												else
													if ((l_http.item.postdata).c_pointer /= default_pointer) then
														l_tmp___60.ce_gets (create {CE_POINTER [INTEGER_64]}.make_shared (l_http.c_pointer + {PD_HTTP}.writebytecount_offset))
													else
														l_tmp___60.ce_gets (create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer))
													end
													if ((l_http.item.postdata).c_pointer /= default_pointer) then
														l_tmp___61 := 0
													else
														l_tmp___61 := -1
													end
													transfer_inst.Curl_setup_transfer (a_conn, 0, (-1).to_integer_64, (1).to_boolean, create {CE_POINTER [INTEGER_64]}.make_shared (l_http.c_pointer + {PD_HTTP}.readbytecount_offset), l_tmp___61, l_tmp___60)
												end
											end
				when 119 then -- switch 3, done: | if done
											if not js.return_called and then (l_result.to_boolean) then
												Result := l_result
												js.return
											end
											if not js.return_called then
												if (l_http.item.writebytecount).to_boolean then
													progress_inst.Curl_pgrsSetUploadCounter (l_data, l_http.item.writebytecount)
													if (progress_inst.Curl_pgrsUpdate (a_conn)).to_boolean then
														l_result := {PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK
													end
												end
												Result := l_result
											end
				when 120 then
											l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
								end

	Curl_http_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent Curl_http)
		end

	checkhttpprefix (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_s: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_head: CE_POINTER [PD_CURL_SLIST]
			l_rc: BOOLEAN
			js: JUMP_STATE
		do
			create l_head.make

			l_head.ce_gets (a_data.item.set.http200aliases)
			l_rc := (0).to_boolean
			from
			until
				not (not js.loop_left and then ((l_head).c_pointer /= default_pointer))
			loop
				js.reset
				if (rawstr_inst.Curl_raw_nequal (l_head.item.data, a_s, (strlen (l_head.item.data)))).to_boolean then
					l_rc := (1).to_boolean
					js.break
				end
				if not js.loop_jumped then
					l_head.ce_gets (l_head.item.next)
				end
			end
			js.reset
			if l_rc.to_integer /= 1 then
				if (rawstr_inst.Curl_raw_nequal (ce_string ("HTTP/"), a_s, (strlen (ce_string ("HTTP/"))))).to_boolean then
					l_rc := (1).to_boolean
				end
			end
			Result := l_rc
		end

	checkrtspprefix (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_s: CE_POINTER [INTEGER_8]): BOOLEAN
		do
			if (rawstr_inst.Curl_raw_nequal (ce_string ("RTSP/"), a_s, (strlen (ce_string ("RTSP/"))))).to_boolean then
				Result := (1).to_boolean
			else
				Result := (0).to_boolean
			end
		end

	checkprotoprefix (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_s: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			js: JUMP_STATE
		do
			if ((a_conn.item.protocol).bit_and (((1).bit_shift_left (18)).to_integer_32)).to_boolean then
				Result := (checkrtspprefix (a_data, a_s))
				js.return
			end
			if not js.return_called then
				Result := (checkhttpprefix (a_data, a_s))
			end
		end

	header_append (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_k: CE_POINTER [PD_SINGLEREQUEST]; a_length: NATURAL_32): INTEGER_32
		local
			l_newbuff: CE_POINTER [INTEGER_8]
			l_hbufp_index: NATURAL_32
			l_newsize: NATURAL_32
			js: JUMP_STATE
		do
			create l_newbuff.make

			if a_k.item.hbuflen + a_length >= a_data.item.state.headersize then
				if a_k.item.hbuflen + a_length > {NATURAL_32} 102400 then
					sendf_inst.Curl_failf ([a_data, ce_string ("Avoided giant realloc for header (max is %%d)!"), 102400])
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				end
				if not js.return_called then
					if ((a_k.item.hbuflen + a_length) * {NATURAL_32} 3) // {NATURAL_32} 2 > a_data.item.state.headersize * {NATURAL_32} 2 then
						l_newsize := ((a_k.item.hbuflen + a_length) * {NATURAL_32} 3) // {NATURAL_32} 2
					else
						l_newsize := a_data.item.state.headersize * {NATURAL_32} 2
					end
					l_hbufp_index := ((a_k.item.hbufp).distance ((a_data.item.state.headerbuff))).to_natural_32
					l_newbuff.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_crealloc.pointer_item ([create {CE_POINTER [ANY]}.make_cast (a_data.item.state.headerbuff), l_newsize])))))
					if (l_newbuff).c_pointer = default_pointer then
						sendf_inst.Curl_failf ([a_data, ce_string ("Failed to alloc memory for big header!")])
						Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
						js.return
					end
				end
				if not js.return_called then
					a_data.item.state.headersize := l_newsize
					a_data.item.state.headerbuff := l_newbuff
					a_k.item.hbufp := a_data.item.state.headerbuff + l_hbufp_index.to_integer_32
				end
			end
			if not js.return_called then
				memcpy (create {CE_POINTER [ANY]}.make_cast (a_k.item.hbufp), create {CE_POINTER [ANY]}.make_cast (a_k.item.str_start), a_length).do_nothing
				a_k.item.hbufp := a_k.item.hbufp + a_length.to_integer_32
				a_k.item.hbuflen := a_k.item.hbuflen + a_length;
				(a_k.item.hbufp).item := (0).to_integer_8
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_http_readwrite_headers (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]; a_nread: CE_POINTER [INTEGER_32]; a_stop_reading: CE_POINTER [BOOLEAN]): INTEGER_32
		local
			l_result: INTEGER_32
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_rest_length: NATURAL_32
			l_full_length: NATURAL_32
			l_writetype: INTEGER_32
			l_headerlen: NATURAL_32
			l_tmp___3: INTEGER_64
			l_httpversion_major: INTEGER_32
			l_rtspversion_major: INTEGER_32
			l_nc: INTEGER_32
			l_tmp___5: INTEGER_32
			l_contentlength: INTEGER_64
			l_contenttype: CE_POINTER [INTEGER_8]
			l_start: CE_POINTER [INTEGER_8]
			l_ptr: CE_POINTER [INTEGER_8]
			l_tmp___22: CE_POINTER [INTEGER_8]
			l_secs: INTEGER_32
			l_location: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_k.make
			create l_contenttype.make
			create l_start.make
			create l_ptr.make
			create l_tmp___22.make
			create l_location.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_k.ce_gets (create {CE_POINTER [PD_SINGLEREQUEST]}.make_shared (a_data.c_pointer + {PD_SESSIONHANDLE}.req_offset))
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 91 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_k.item.str_start := l_k.item.str
						l_k.item.end_ptr := create {CE_POINTER [INTEGER_8]}.make_cast ((memchr (create {CE_POINTER [ANY]}.make_cast (l_k.item.str_start), 10, (a_nread.item).to_natural_32)))
						if (l_k.item.end_ptr).c_pointer = default_pointer then
							l_result := header_append (a_data, l_k, (a_nread.item).to_natural_32)
							if l_result.to_boolean then
								Result := l_result
								js.return
							end
							if not js.return_called then
								if not (l_k.item.headerline).to_boolean then
									if l_k.item.hbuflen > {NATURAL_32} 5 then
										if not (checkprotoprefix (a_data, a_conn, a_data.item.state.headerbuff)) then
											l_k.item.header := (0).to_boolean
											l_k.item.badheader := {PC_BADHEADER}.HEADER_ALLBAD
											js.break
										end
									end
								end
								if not js.loop_jumped then
									js.break
								end
							end
						end
						if js.return_called then
							l_pos := -1 + 90 -- skip if block
						end
				when 3 then -- if:
						if js.loop_jumped then
							l_pos := -1 + 89 -- skip if block
						end
				when 4 then -- if:
						l_rest_length := (((l_k.item.end_ptr).distance ((l_k.item.str))) + 1).to_natural_32
						a_nread.item := a_nread.item - l_rest_length.to_integer_32
						l_k.item.str := l_k.item.end_ptr + 1
						l_full_length := ((l_k.item.str).distance ((l_k.item.str_start))).to_natural_32
						l_result := header_append (a_data, l_k, l_full_length)
						if l_result.to_boolean then
							Result := l_result
							js.return
						end
						if js.return_called then
							l_pos := -1 + 89 -- skip if block
						end
				when 5 then -- if:
						l_k.item.end_ptr := l_k.item.hbufp
						l_k.item.p := a_data.item.state.headerbuff
						if not (l_k.item.headerline).to_boolean then
							if l_k.item.hbuflen > {NATURAL_32} 5 then
								if not (checkprotoprefix (a_data, a_conn, a_data.item.state.headerbuff)) then
									l_k.item.header := (0).to_boolean
									if (a_nread.item).to_boolean then
										l_k.item.badheader := {PC_BADHEADER}.HEADER_PARTHEADER
									else
										l_k.item.badheader := {PC_BADHEADER}.HEADER_ALLBAD
										a_nread.item := l_rest_length.to_integer_32
									end
									js.break
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 15 -- skip if block
						end
				when 6 then -- if:
						if 10 /= ((l_k.item.p).item).to_integer_32 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 9 then -- else:
						if 13 /= ((l_k.item.p).item).to_integer_32 then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if: | _L___0:
						if 13 = ((l_k.item.p).item).to_integer_32 then
							l_k.item.p := (l_k.item.p) + 1
						end
						if 10 = ((l_k.item.p).item).to_integer_32 then
							l_k.item.p := (l_k.item.p) + 1
						end
						if not (100 <= l_k.item.httpcode) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if 199 >= l_k.item.httpcode then
							l_k.item.header := (1).to_boolean
							l_k.item.headerline := 0
							if (l_k.item.exp100).to_boolean then
								l_k.item.exp100 := {PC_EXPECT100}.EXP100_SEND_DATA
								l_k.item.keepon := (l_k.item.keepon).bit_or (((1).bit_shift_left (1)))
							end
						else
							l_pos := -1 + 13 -- goto _L
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L:
						l_k.item.header := (0).to_boolean
						if l_k.item.size = -{INTEGER_64} 1 then
							if not l_k.item.chunk then
								if not a_conn.item.bits.close then
									if a_conn.item.httpversion >= 11 then
										if not ((a_conn.item.protocol).bit_and (((1).bit_shift_left (18)).to_integer_32)).to_boolean then
											sendf_inst.Curl_infof ([a_data, ce_string ("no chunk, no close, no size. Assume close to signal end%N")])
											a_conn.item.bits.close := (1).to_boolean
										end
									end
								end
							end
						end
				when 14 then
						if 417 = l_k.item.httpcode then
							l_k.item.exp100 := {PC_EXPECT100}.EXP100_FAILED
							l_k.item.keepon := (l_k.item.keepon).bit_and (((((1).bit_shift_left (1))).bit_not))
						end
						if (Curl_http_should_fail (a_conn)).to_boolean then
							sendf_inst.Curl_failf ([a_data, ce_string ("The requested URL returned error: %%d"), l_k.item.httpcode])
							Result := ({PC_CURLCODE}.CURLE_HTTP_RETURNED_ERROR)
							js.return
						end
						if not js.return_called then
							l_writetype := (1).bit_shift_left (1)
							if a_data.item.set.include_header then
								l_writetype := (l_writetype).bit_or ((1))
							end
							l_headerlen := ((l_k.item.p).distance ((a_data.item.state.headerbuff))).to_natural_32
							l_result := sendf_inst.Curl_client_write (a_conn, l_writetype, a_data.item.state.headerbuff, l_headerlen)
							if l_result.to_boolean then
								Result := l_result
								js.return
							end
						end
						if not js.return_called then
							a_data.item.info.header_size := a_data.item.info.header_size + l_headerlen.to_integer_32
							a_data.item.req.headerbytecount := a_data.item.req.headerbytecount + l_headerlen.to_integer_32
							if 100 <= l_k.item.httpcode then
								if 199 >= l_k.item.httpcode then
									a_data.item.req.deductheadercount := a_data.item.req.headerbytecount
								else
									a_data.item.req.deductheadercount := 0
								end
							else
								a_data.item.req.deductheadercount := 0
							end
							if not a_stop_reading.item then
								l_result := Curl_http_auth_act (a_conn)
								if l_result.to_boolean then
									Result := l_result
									js.return
								end
								if not js.return_called and then (a_conn.item.bits.rewindaftersend) then
									sendf_inst.Curl_infof ([a_data, ce_string ("Keep sending data to get tossed away!%N")])
									l_k.item.keepon := (l_k.item.keepon).bit_or (((1).bit_shift_left (1)))
								end
							end
						end
						if not js.return_called then
							if not l_k.item.header then
								if a_data.item.set.opt_no_body then
									a_stop_reading.item := (1).to_boolean
								elseif l_k.item.chunk then
									l_tmp___3 := (-1).to_integer_64
									l_k.item.size := l_tmp___3
									l_k.item.maxdownload := l_tmp___3
								end
								if -{INTEGER_64} 1 /= l_k.item.size then
									progress_inst.Curl_pgrsSetDownloadSize (a_data, l_k.item.size)
									l_k.item.maxdownload := l_k.item.size
								end
								if {INTEGER_64} 0 = l_k.item.maxdownload then
									a_stop_reading.item := (1).to_boolean
								end
								if a_stop_reading.item then
									l_k.item.keepon := (l_k.item.keepon).bit_and ((-2))
								end
								if a_data.item.set.verbose then
									sendf_inst.Curl_debug (a_data, {PC_CURL_INFOTYPE}.CURLINFO_HEADER_IN, l_k.item.str_start, l_headerlen, a_conn).do_nothing
								end
								js.break
							end
							if not js.loop_jumped then
								l_k.item.hbufp := a_data.item.state.headerbuff
								l_k.item.hbuflen := (0).to_natural_32
								js.continue
							end
						end
				when 15 then -- if done | if done
						if js.loop_jumped then
							l_pos := -1 + 35 -- skip if block
						end
				when 16 then -- if:
						l_tmp___5 := l_k.item.headerline
						l_k.item.headerline := (l_k.item.headerline) + 1
						if l_tmp___5.to_boolean then
							l_pos := -1 + 35 -- skip if block
						end
				when 17 then -- if:
						l_nc := 0
						if ((a_conn.item.protocol).bit_and (1)).to_boolean then
							l_nc := sscanf ([l_k.item.p, ce_string (" HTTP/%%d.%%d %%3d"), create {CE_POINTER [INTEGER_32]}.make_shared ($l_httpversion_major), create {CE_POINTER [INTEGER_32]}.make_shared (a_conn.c_pointer + {PD_CONNECTDATA}.httpversion_offset), create {CE_POINTER [INTEGER_32]}.make_shared (l_k.c_pointer + {PD_SINGLEREQUEST}.httpcode_offset)])
							if l_nc = 3 then
								a_conn.item.httpversion := a_conn.item.httpversion + (10 * l_httpversion_major)
							else
								l_nc := sscanf ([l_k.item.p, ce_string (" HTTP %%3d"), create {CE_POINTER [INTEGER_32]}.make_shared (l_k.c_pointer + {PD_SINGLEREQUEST}.httpcode_offset)])
								a_conn.item.httpversion := 10
								if not l_nc.to_boolean then
									if (checkhttpprefix (a_data, l_k.item.p)) then
										l_nc := 1
										l_k.item.httpcode := 200
										a_conn.item.httpversion := 10
									end
								end
							end
						elseif ((a_conn.item.protocol).bit_and (((1).bit_shift_left (18)).to_integer_32)).to_boolean then
							l_nc := sscanf ([l_k.item.p, ce_string (" RTSP/%%d.%%d %%3d"), create {CE_POINTER [INTEGER_32]}.make_shared ($l_rtspversion_major), create {CE_POINTER [INTEGER_32]}.make_shared (a_conn.c_pointer + {PD_CONNECTDATA}.rtspversion_offset), create {CE_POINTER [INTEGER_32]}.make_shared (l_k.c_pointer + {PD_SINGLEREQUEST}.httpcode_offset)])
							if l_nc = 3 then
								a_conn.item.rtspversion := a_conn.item.rtspversion + (10 * l_rtspversion_major)
								a_conn.item.httpversion := 11
							else
								l_nc := 0
							end
						end
						if not (l_nc.to_boolean) then
							l_pos := -1 + 34 -- skip if block
						end
				when 18 then -- if:
						a_data.item.info.httpcode := l_k.item.httpcode
						a_data.item.info.httpversion := a_conn.item.httpversion
						if not (a_data.item.state.httpversion).to_boolean then
							a_data.item.state.httpversion := a_conn.item.httpversion
						elseif a_data.item.state.httpversion > a_conn.item.httpversion then
							a_data.item.state.httpversion := a_conn.item.httpversion
						end
						if not (a_data.item.set.http_fail_on_error) then
							l_pos := -1 + 29 -- skip if block
						end
				when 19 then -- if:
						if not (l_k.item.httpcode >= 400) then
							l_pos := -1 + 29 -- skip if block
						end
				when 20 then -- if:
						if l_k.item.httpcode = 401 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 24 -- goto _L___2
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 23 then -- else:
						if a_conn.item.bits.user_passwd then
							l_pos := -1 + 29 -- skip if block
						end
				when 24 then -- if: | _L___2:
						if l_k.item.httpcode = 407 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 28 -- goto _L___1
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 27 then -- else:
						if a_conn.item.bits.proxy_user_passwd then
							l_pos := -1 + 29 -- skip if block
						end
				when 28 then -- if: | _L___1:
						if (a_data.item.state.resume_from).to_boolean then
							if (a_data.item.set.httpreq).to_natural_32 = {NATURAL_32} 1 then
								if l_k.item.httpcode /= 416 then
									sendf_inst.Curl_failf ([a_data, ce_string ("The requested URL returned error: %%d"), l_k.item.httpcode])
									Result := ({PC_CURLCODE}.CURLE_HTTP_RETURNED_ERROR)
									js.return
								end
							else
								sendf_inst.Curl_failf ([a_data, ce_string ("The requested URL returned error: %%d"), l_k.item.httpcode])
								Result := ({PC_CURLCODE}.CURLE_HTTP_RETURNED_ERROR)
								js.return
							end
						else
							sendf_inst.Curl_failf ([a_data, ce_string ("The requested URL returned error: %%d"), l_k.item.httpcode])
							Result := ({PC_CURLCODE}.CURLE_HTTP_RETURNED_ERROR)
							js.return
						end
				when 29 then -- if done | if done | if done | if done | if done
						if js.return_called then
							l_pos := -1 + 33 -- skip if block
						end
				when 30 then -- if:
						if a_conn.item.httpversion = 10 then
							sendf_inst.Curl_infof ([a_data, ce_string ("HTTP 1.0, assume close after body%N")])
							a_conn.item.bits.close := (1).to_boolean
						elseif a_conn.item.httpversion >= 11 then
							if not a_conn.item.bits.close then
								a_conn.item.server_supports_pipelining := (1).to_boolean
							end
						end
						inspect l_k.item.httpcode -- switch 1 head
						when 204 then l_pos := -1 + 31
						when 304 then l_pos := -1 + 31
						else l_pos := -1 + 32
						end
				when 31 then -- switch 1, case 204 | switch 1, case 304
						if (a_data.item.set.timecondition).to_boolean then
							a_data.item.info.timecond := (1).to_boolean
						end
						l_k.item.size := (0).to_integer_64
						l_k.item.maxdownload := (0).to_integer_64
						l_k.item.ignorecl := (1).to_boolean
						l_pos := -1 + 33 -- switch 1; break
				when 32 then -- switch 1, default:
						l_pos := -1 + 33 -- switch 1; break
				when 33 then -- switch 1, done: | if done | if block done, skip else block:
						l_pos := -1 + 35
				when 34 then -- else:
						l_k.item.header := (0).to_boolean
						js.break
				when 35 then -- if done | if done | if done
						if js.loop_jumped then
							l_pos := -1 + 89 -- skip if block
						end
				when 36 then -- if:
						if l_k.item.ignorecl then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						if not a_data.item.set.ignorecl then
							if (rawstr_inst.Curl_raw_nequal (ce_string ("Content-Length:"), l_k.item.p, (strlen (ce_string ("Content-Length:"))))).to_boolean then
								l_contentlength := (strtoll ((l_k.item.p + 15), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), 10))
								if (a_data.item.set.max_filesize).to_boolean then
									if l_contentlength > a_data.item.set.max_filesize then
										sendf_inst.Curl_failf ([a_data, ce_string ("Maximum file size exceeded")])
										Result := ({PC_CURLCODE}.CURLE_FILESIZE_EXCEEDED)
										js.return
									end
								end
								if not js.return_called then
									if l_contentlength >= {INTEGER_64} 0 then
										l_k.item.size := l_contentlength
										l_k.item.maxdownload := l_k.item.size
										progress_inst.Curl_pgrsSetDownloadSize (a_data, l_k.item.size)
									else
										a_conn.item.bits.close := (1).to_boolean
										sendf_inst.Curl_infof ([a_data, ce_string ("Negative content-length: %%lld, closing after transfer%N"), l_contentlength])
									end
								end
							else
								l_pos := -1 + 39 -- goto _L___19
							end
						else
							l_pos := -1 + 39 -- goto _L___19
						end
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 39 then -- else: | _L___19:
						if not ((rawstr_inst.Curl_raw_nequal (ce_string ("Content-Type:"), l_k.item.p, (strlen (ce_string ("Content-Type:"))))).to_boolean) then
							l_pos := -1 + 42 -- skip if block
						end
				when 40 then -- if:
						l_contenttype.ce_gets ((Curl_copy_header_value (l_k.item.p)))
						if (l_contenttype).c_pointer = default_pointer then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
						if not js.return_called then
							if not (l_contenttype[0]).to_boolean then
								easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_contenttype)])
							else
								url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_data.item.info.contenttype))
								a_data.item.info.contenttype := l_contenttype
							end
						end
				when 41 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 42 then -- else:
						if a_conn.item.httpversion /= 10 then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if:
						if a_conn.item.bits.httpproxy then
							if (Curl_compareheader (l_k.item.p, ce_string ("Proxy-Connection:"), ce_string ("keep-alive"))) then
								a_conn.item.bits.close := (0).to_boolean
								sendf_inst.Curl_infof ([a_data, ce_string ("HTTP/1.0 proxy connection set to keep alive!%N")])
							else
								l_pos := -1 + 45 -- goto _L___17
							end
						else
							l_pos := -1 + 45 -- goto _L___17
						end
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 45 then -- else: | _L___17:
						if a_conn.item.httpversion /= 11 then
							l_pos := -1 + 48 -- skip if block
						end
				when 46 then -- if:
						if a_conn.item.bits.httpproxy then
							if (Curl_compareheader (l_k.item.p, ce_string ("Proxy-Connection:"), ce_string ("close"))) then
								a_conn.item.bits.close := (1).to_boolean
								sendf_inst.Curl_infof ([a_data, ce_string ("HTTP/1.1 proxy connection set close!%N")])
							else
								l_pos := -1 + 48 -- goto _L___15
							end
						else
							l_pos := -1 + 48 -- goto _L___15
						end
				when 47 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 48 then -- else: | _L___15:
						if a_conn.item.httpversion /= 10 then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:
						if (Curl_compareheader (l_k.item.p, ce_string ("Connection:"), ce_string ("keep-alive"))) then
							a_conn.item.bits.close := (0).to_boolean
							sendf_inst.Curl_infof ([a_data, ce_string ("HTTP/1.0 connection set to keep alive!%N")])
						else
							l_pos := -1 + 51 -- goto _L___13
						end
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 51 then -- else: | _L___13:
						if not (Curl_compareheader (l_k.item.p, ce_string ("Connection:"), ce_string ("close"))) then
							l_pos := -1 + 54 -- skip if block
						end
				when 52 then -- if:
						a_conn.item.bits.close := (1).to_boolean
				when 53 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 54 then -- else:
						if not (Curl_compareheader (l_k.item.p, ce_string ("Transfer-Encoding:"), ce_string ("chunked"))) then
							l_pos := -1 + 57 -- skip if block
						end
				when 55 then -- if:
						if not ((a_conn.item.protocol).bit_and (((1).bit_shift_left (18)).to_integer_32)).to_boolean then
							l_k.item.chunk := (1).to_boolean
							http_chunks_inst.Curl_httpchunk_init (a_conn)
						else
							l_pos := -1 + 57 -- goto _L___12
						end
				when 56 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 57 then -- else: | _L___12:
						if not ((rawstr_inst.Curl_raw_nequal (ce_string ("Content-Encoding:"), l_k.item.p, (strlen (ce_string ("Content-Encoding:"))))).to_boolean) then
							l_pos := -1 + 60 -- skip if block
						end
				when 58 then -- if:
						if ((a_data.item.set.str[6]).c_pointer /= default_pointer) then
							l_start.ce_gets (l_k.item.p + 17)
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_start[0]).to_boolean then
									if not ((((ctype_b_loc).item[((l_start[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (8192)).to_boolean then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_start.ce_gets (l_start + 1)
								end
							end
							js.reset
							if (rawstr_inst.Curl_raw_nequal (ce_string ("identity"), l_start, (strlen (ce_string ("identity"))))).to_boolean then
								l_k.item.content_encoding := 0
							elseif (rawstr_inst.Curl_raw_nequal (ce_string ("deflate"), l_start, (strlen (ce_string ("deflate"))))).to_boolean then
								l_k.item.content_encoding := 1
							elseif (rawstr_inst.Curl_raw_nequal (ce_string ("gzip"), l_start, (strlen (ce_string ("gzip"))))).to_boolean then
								l_k.item.content_encoding := 2
							elseif (rawstr_inst.Curl_raw_nequal (ce_string ("x-gzip"), l_start, (strlen (ce_string ("x-gzip"))))).to_boolean then
								l_k.item.content_encoding := 2
							elseif (rawstr_inst.Curl_raw_nequal (ce_string ("compress"), l_start, (strlen (ce_string ("compress"))))).to_boolean then
								l_k.item.content_encoding := 3
							elseif (rawstr_inst.Curl_raw_nequal (ce_string ("x-compress"), l_start, (strlen (ce_string ("x-compress"))))).to_boolean then
								l_k.item.content_encoding := 3
							end
						else
							l_pos := -1 + 60 -- goto _L___11
						end
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 60 then -- else: | _L___11:
						if not ((rawstr_inst.Curl_raw_nequal (ce_string ("Content-Range:"), l_k.item.p, (strlen (ce_string ("Content-Range:"))))).to_boolean) then
							l_pos := -1 + 63 -- skip if block
						end
				when 61 then -- if:
						l_ptr.ce_gets (l_k.item.p + 14)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_ptr[0]).to_boolean then
								if ((((ctype_b_loc).item[((l_ptr[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (2048)).to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_ptr.ce_gets (l_ptr + 1)
							end
						end
						js.reset
						l_k.item.offset := strtoll (l_ptr, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), 10)
						if a_data.item.state.resume_from = l_k.item.offset then
							l_k.item.content_range := (1).to_boolean
						end
				when 62 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 63 then -- else:
						if (a_data.item.cookies).c_pointer = default_pointer then
							l_pos := -1 + 66 -- skip if block
						end
				when 64 then -- if:
						if (rawstr_inst.Curl_raw_nequal (ce_string ("Set-Cookie:"), l_k.item.p, (strlen (ce_string ("Set-Cookie:"))))).to_boolean then
							share_inst.Curl_share_lock (a_data, {PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_COOKIE, {PC_CURL_LOCK_ACCESS}.CURL_LOCK_ACCESS_SINGLE).do_nothing
							if ((a_conn.item.allocptr.cookiehost).c_pointer /= default_pointer) then
								l_tmp___22.ce_gets (a_conn.item.allocptr.cookiehost)
							else
								l_tmp___22.ce_gets (a_conn.item.host.name)
							end
							cookie_inst.Curl_cookie_add (a_data, a_data.item.cookies, (1).to_boolean, l_k.item.p + 11, l_tmp___22, a_data.item.state.path).do_nothing
							share_inst.Curl_share_unlock (a_data, {PC_CURL_LOCK_DATA}.CURL_LOCK_DATA_COOKIE).do_nothing
						else
							l_pos := -1 + 66 -- goto _L___10
						end
				when 65 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 66 then -- else: | _L___10:
						if not ((rawstr_inst.Curl_raw_nequal (ce_string ("Last-Modified:"), l_k.item.p, (strlen (ce_string ("Last-Modified:"))))).to_boolean) then
							l_pos := -1 + 75 -- skip if block
						end
				when 67 then -- if:
						if not ((a_data.item.set.timecondition).to_boolean) then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if:
						l_pos := -1 + 71 -- goto _L___9
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 74
				when 70 then -- else:
						if not (a_data.item.set.get_filetime) then
							l_pos := -1 + 73 -- skip if block
						end
				when 71 then -- if: | _L___9:
						l_secs := (time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
						l_k.item.timeofdoc := parsedate_inst.curl_getdate ((l_k.item.p + (strlen (ce_string ("Last-Modified:"))).to_integer_32), (create {CE_POINTER [INTEGER_32]}.make_shared ($l_secs)))
						if a_data.item.set.get_filetime then
							a_data.item.info.filetime := l_k.item.timeofdoc
						end
				when 72 then -- if block done, skip else block:
						l_pos := -1 + 74
				when 73 then -- else:
						l_pos := -1 + 75 -- goto _L___8
				when 74 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 88
				when 75 then -- else: | _L___8:
						if not ((rawstr_inst.Curl_raw_nequal (ce_string ("WWW-Authenticate:"), l_k.item.p, (strlen (ce_string ("WWW-Authenticate:"))))).to_boolean) then
							l_pos := -1 + 78 -- skip if block
						end
				when 76 then -- if:
						if 401 = l_k.item.httpcode then
							l_pos := -1 + 80 -- goto _L___5
						else
							l_pos := -1 + 78 -- goto _L___7
						end
				when 77 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 78 then -- else: | _L___7:
						if not ((rawstr_inst.Curl_raw_nequal (ce_string ("Proxy-authenticate:"), l_k.item.p, (strlen (ce_string ("Proxy-authenticate:"))))).to_boolean) then
							l_pos := -1 + 84 -- skip if block
						end
				when 79 then -- if:
						if 407 /= l_k.item.httpcode then
							l_pos := -1 + 82 -- skip if block
						end
				when 80 then -- if: | _L___5:
						l_result := Curl_http_input_auth (a_conn, l_k.item.httpcode, l_k.item.p)
						if l_result.to_boolean then
							Result := l_result
							js.return
						end
				when 81 then -- if block done, skip else block:
						l_pos := -1 + 83
				when 82 then -- else:
						l_pos := -1 + 84 -- goto _L___6
				when 83 then -- if done | if block done, skip else block:
						l_pos := -1 + 88
				when 84 then -- else: | _L___6:
						if not (l_k.item.httpcode >= 300) then
							l_pos := -1 + 87 -- skip if block
						end
				when 85 then -- if:
						if l_k.item.httpcode < 400 then
							if (rawstr_inst.Curl_raw_nequal (ce_string ("Location:"), l_k.item.p, (strlen (ce_string ("Location:"))))).to_boolean then
								l_location.ce_gets ((Curl_copy_header_value (l_k.item.p)))
								if (l_location).c_pointer = default_pointer then
									Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
									js.return
								end
								if not js.return_called then
									if not (l_location[0]).to_boolean then
										easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_location)])
									else
										a_data.item.req.location := l_location
										if a_data.item.set.http_follow_location then
											a_data.item.req.newurl := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([a_data.item.req.location]))
											if (a_data.item.req.newurl).c_pointer = default_pointer then
												Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
												js.return
											end
											if not js.return_called then
												l_result := Curl_http_perhapsrewind (a_conn)
												if l_result.to_boolean then
													Result := l_result
													js.return
												end
											end
										end
									end
								end
							else
								l_pos := -1 + 87 -- goto _L___4
							end
						else
							l_pos := -1 + 87 -- goto _L___4
						end
				when 86 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 87 then -- else: | _L___4:
						if ((a_conn.item.protocol).bit_and (((1).bit_shift_left (18)).to_integer_32)).to_boolean then
							l_result := rtsp_inst.Curl_rtsp_parseheader (a_conn, l_k.item.p)
							if l_result.to_boolean then
								Result := l_result
								js.return
							end
						end
				when 88 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
						if not js.return_called then
							l_writetype := (1).bit_shift_left (1)
							if a_data.item.set.include_header then
								l_writetype := (l_writetype).bit_or ((1))
							end
							if a_data.item.set.verbose then
								sendf_inst.Curl_debug (a_data, {PC_CURL_INFOTYPE}.CURLINFO_HEADER_IN, l_k.item.p, l_k.item.hbuflen, a_conn).do_nothing
							end
							l_result := sendf_inst.Curl_client_write (a_conn, l_writetype, l_k.item.p, l_k.item.hbuflen)
							if l_result.to_boolean then
								Result := l_result
								js.return
							end
						end
						if not js.return_called then
							a_data.item.info.header_size := a_data.item.info.header_size + (l_k.item.hbuflen).to_integer_32
							a_data.item.req.headerbytecount := a_data.item.req.headerbytecount + (l_k.item.hbuflen).to_integer_32
							l_k.item.hbufp := a_data.item.state.headerbuff
							l_k.item.hbuflen := (0).to_natural_32
						end
				when 89 then -- if done | if done | if done
						if not js.loop_left then
							if not a_stop_reading.item then
								if not ((l_k.item.str).item).to_boolean then
									l_pos := -1 + 91 -- break
								end
							else
								l_pos := -1 + 91 -- break
							end
						end
				when 90 then
						l_pos := -1 + 1 -- back to loop condition
				when 91 then -- loop done
					js.reset
					if not js.return_called then
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 92 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
