class
	P_IMAP

inherit
	LIBCURL_DATA
		redefine
			default_create
		end
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create Curl_handler_imap.make
			create Curl_handler_imap_proxy.make
			create ids.make (<<4>>)
		end

feature {ANY} -- attributes

	Curl_handler_imap: PD_CURL_HANDLER

	Curl_handler_imap_proxy: PD_CURL_HANDLER

	ids: CE_ARRAY [CE_POINTER [INTEGER_8]]

feature {ANY} -- routines

	imapsendf (a_args: TUPLE [a_conn: CE_POINTER [PD_CONNECTDATA]; a_idstr: CE_POINTER [INTEGER_8]; a_fmt: CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_res: INTEGER_32
			l_imapc: CE_POINTER [PD_IMAP_CONN]
			l_ap: CE_VA_LIST
		do
			create l_imapc.make

			l_imapc.ce_gets (create {CE_POINTER [PD_IMAP_CONN]}.make_shared (a_args.a_conn.c_pointer + {PD_CONNECTDATA}.proto_offset + {PD_PROTO}.imapc_offset))
			create l_ap.make (a_args, 4)
			l_imapc.item.idstr := a_args.a_idstr
			l_res := pingpong_inst.Curl_pp_vsendf (create {CE_POINTER [PD_PINGPONG]}.make_shared (l_imapc.c_pointer + {PD_IMAP_CONN}.pp_offset), a_args.a_fmt, l_ap)
			Result := l_res
		end

	getcmdid (a_conn: CE_POINTER [PD_CONNECTDATA]): CE_POINTER [INTEGER_8]
		local
			l_imapc: CE_POINTER [PD_IMAP_CONN]
		do
			create l_imapc.make

			l_imapc.ce_gets (create {CE_POINTER [PD_IMAP_CONN]}.make_shared (a_conn.c_pointer + {PD_CONNECTDATA}.proto_offset + {PD_PROTO}.imapc_offset))
			l_imapc.item.cmdid := ((l_imapc.item.cmdid + 1).to_natural_32 \\ ((Pointer_bytes.to_natural_32 * (4).to_natural_32) // Pointer_bytes.to_natural_32)).to_integer_32
			Result := (ids[l_imapc.item.cmdid])
		end

	imap_getsock (a_conn: CE_POINTER [PD_CONNECTDATA]; a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		do
			Result := (pingpong_inst.Curl_pp_getsock (create {CE_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + {PD_CONNECTDATA}.proto_offset + {PD_PROTO}.imapc_offset + {PD_IMAP_CONN}.pp_offset), a_socks, a_numsocks))
		end

	imap_getsock_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent imap_getsock)
		end

	imap_endofresp (a_pp: CE_POINTER [PD_PINGPONG]; a_resp: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_line: CE_POINTER [INTEGER_8]
			l_len: NATURAL_32
			l_imapc: CE_POINTER [PD_IMAP_CONN]
			l_id: CE_POINTER [INTEGER_8]
			l_id_len: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_line.make
			create l_imapc.make
			create l_id.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_line.ce_gets (a_pp.item.linestart_resp)
					l_len := a_pp.item.nread_resp
					l_imapc.ce_gets (create {CE_POINTER [PD_IMAP_CONN]}.make_shared ((a_pp.item.conn).c_pointer + {PD_CONNECTDATA}.proto_offset + {PD_PROTO}.imapc_offset))
					l_id.ce_gets (l_imapc.item.idstr)
					l_id_len := (strlen (l_id))
					if not (l_len >= l_id_len + {NATURAL_32} 3) then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if not ((memcmp (create {CE_POINTER [ANY]}.make_cast (l_id), create {CE_POINTER [ANY]}.make_cast (l_line), l_id_len)).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if: | _L:
						if (l_imapc.item.state).to_natural_32 = {NATURAL_32} 5 then
							if not (memcmp (create {CE_POINTER [ANY]}.make_cast (ce_string ("* ")), create {CE_POINTER [ANY]}.make_cast (l_line), (2).to_natural_32)).to_boolean then
								a_resp.item := ('*').code
								Result := 1
								js.return
							end
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else:
						if (l_line[l_id_len.to_integer_32]).to_integer_32 = 32 then
							a_resp.item := (l_line[(l_id_len + {NATURAL_32} 1).to_integer_32]).to_integer_32
							Result := 1
							js.return
						else
							l_pos := -1 + 2 -- goto _L
						end
				when 5 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	imap_endofresp_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent imap_endofresp)
		end

	state___0 (a_conn: CE_POINTER [PD_CONNECTDATA]; a_newstate: INTEGER_32)
		local
			l_imapc: CE_POINTER [PD_IMAP_CONN]
		do
			create l_imapc.make

			l_imapc.ce_gets (create {CE_POINTER [PD_IMAP_CONN]}.make_shared (a_conn.c_pointer + {PD_CONNECTDATA}.proto_offset + {PD_PROTO}.imapc_offset))
			l_imapc.item.state := a_newstate
		end

	imap_state_login (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_result: INTEGER_32
			l_imap: CE_POINTER [PD_FTP]
			l_str: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_imap.make
			create l_str.make
			create l_tmp.make
			create l_tmp___0.make

			l_imap.ce_gets ((a_conn.item.data).item.state.proto.imap)
			l_str.ce_gets (getcmdid (a_conn))
			if ((l_imap.item.passwd).c_pointer /= default_pointer) then
				l_tmp.ce_gets (l_imap.item.passwd)
			else
				l_tmp.ce_gets (ce_string (""))
			end
			if ((l_imap.item.user).c_pointer /= default_pointer) then
				l_tmp___0.ce_gets (l_imap.item.user)
			else
				l_tmp___0.ce_gets (ce_string (""))
			end
			l_result := imapsendf ([a_conn, l_str, ce_string ("%%s LOGIN %%s %%s"), l_str, l_tmp___0, l_tmp])
			if l_result.to_boolean then
				Result := l_result
				js.return
			end
			if not js.return_called then
				state___0 (a_conn, {PC_IMAPSTATE}.IMAP_LOGIN)
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	imap_state_starttls_resp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_imapcode: INTEGER_32; a_instate: INTEGER_32): INTEGER_32
		local
			l_result: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			create l_data.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data.ce_gets (a_conn.item.data)
			if a_imapcode /= 79 then
				sendf_inst.Curl_failf ([l_data, ce_string ("STARTTLS denied. %%c"), a_imapcode])
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
			else
				l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
				if {NATURAL_32} 0 = l_result.to_natural_32 then
					a_conn.item.protocol := (a_conn.item.protocol).bit_or (((1).bit_shift_left (13)).to_integer_32)
					l_result := imap_state_login (a_conn)
				end
			end
			state___0 (a_conn, {PC_IMAPSTATE}.IMAP_STOP)
			Result := l_result
		end

	imap_state_login_resp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_imapcode: INTEGER_32; a_instate: INTEGER_32): INTEGER_32
		local
			l_result: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			create l_data.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data.ce_gets (a_conn.item.data)
			if a_imapcode /= 79 then
				sendf_inst.Curl_failf ([l_data, ce_string ("Access denied. %%c"), a_imapcode])
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
			end
			state___0 (a_conn, {PC_IMAPSTATE}.IMAP_STOP)
			Result := l_result
		end

	imap_state_fetch_resp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_imapcode: INTEGER_32; a_instate: INTEGER_32): INTEGER_32
		local
			l_result: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_imapc: CE_POINTER [PD_IMAP_CONN]
			l_imap: CE_POINTER [PD_FTP]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_ptr: CE_POINTER [INTEGER_8]
			l_filesize: INTEGER_64
			l_chunk: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_imapc.make
			create l_imap.make
			create l_pp.make
			create l_ptr.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data.ce_gets (a_conn.item.data)
			l_imapc.ce_gets (create {CE_POINTER [PD_IMAP_CONN]}.make_shared (a_conn.c_pointer + {PD_CONNECTDATA}.proto_offset + {PD_PROTO}.imapc_offset))
			l_imap.ce_gets (l_data.item.state.proto.imap)
			l_pp.ce_gets (create {CE_POINTER [PD_PINGPONG]}.make_shared (l_imapc.c_pointer + {PD_IMAP_CONN}.pp_offset))
			l_ptr.ce_gets ((l_data.item.state.buffer))
			if 42 /= a_imapcode then
				progress_inst.Curl_pgrsSetDownloadSize (l_data, (0).to_integer_64)
				state___0 (a_conn, {PC_IMAPSTATE}.IMAP_STOP)
				Result := ({PC_CURLCODE}.CURLE_OK)
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_ptr[0]).to_boolean then
						if (l_ptr[0]).to_integer_32 = 123 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_ptr.ce_gets (l_ptr + 1)
					end
				end
				js.reset
				if (l_ptr[0]).to_integer_32 = 123 then
					l_filesize := (strtoll ((l_ptr + 1), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), 10))
					if l_filesize.to_boolean then
						progress_inst.Curl_pgrsSetDownloadSize (l_data, l_filesize)
					end
					sendf_inst.Curl_infof ([l_data, ce_string ("Found %%llu bytes to download%N"), l_filesize])
					if ((l_pp.item.cache).c_pointer /= default_pointer) then
						l_chunk := l_pp.item.cache_size
						if l_chunk > l_filesize.to_natural_32 then
							l_chunk := l_filesize.to_natural_32
						end
						l_result := sendf_inst.Curl_client_write (a_conn, 1, l_pp.item.cache, l_chunk)
						if l_result.to_boolean then
							Result := l_result
							js.return
						end
						if not js.return_called then
							l_filesize := l_filesize - l_chunk.to_integer_64
							if l_pp.item.cache_size > l_chunk then
								memmove (create {CE_POINTER [ANY]}.make_cast (l_pp.item.cache), create {CE_POINTER [ANY]}.make_cast ((l_pp.item.cache + l_chunk.to_integer_32)), l_pp.item.cache_size - l_chunk).do_nothing
								l_pp.item.cache_size := l_pp.item.cache_size - l_chunk
							else
								easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_pp.item.cache)])
								l_pp.item.cache := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
								l_pp.item.cache_size := (0).to_natural_32
							end
						end
					end
					if not js.return_called then
						sendf_inst.Curl_infof ([l_data, ce_string ("Filesize left: %%lld%N"), l_filesize])
						if not l_filesize.to_boolean then
							transfer_inst.Curl_setup_transfer (a_conn, -1, (-1).to_integer_64, (0).to_boolean, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer), -1, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer))
						else
							transfer_inst.Curl_setup_transfer (a_conn, 0, l_filesize, (0).to_boolean, l_imap.item.bytecountp, -1, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer))
						end
						l_data.item.req.maxdownload := l_filesize
					end
				else
					l_result := {PC_CURLCODE}.CURLE_FTP_WEIRD_SERVER_REPLY
				end
			end
			if not js.return_called then
				state___0 (a_conn, {PC_IMAPSTATE}.IMAP_STOP)
				Result := l_result
			end
		end

	imap_select (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_result: INTEGER_32
			l_imapc: CE_POINTER [PD_IMAP_CONN]
			l_str: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_imapc.make
			create l_str.make
			create l_tmp.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_imapc.ce_gets (create {CE_POINTER [PD_IMAP_CONN]}.make_shared (a_conn.c_pointer + {PD_CONNECTDATA}.proto_offset + {PD_PROTO}.imapc_offset))
			l_str.ce_gets (getcmdid (a_conn))
			if ((l_imapc.item.mailbox).c_pointer /= default_pointer) then
				l_tmp.ce_gets (l_imapc.item.mailbox)
			else
				l_tmp.ce_gets (ce_string (""))
			end
			l_result := imapsendf ([a_conn, l_str, ce_string ("%%s SELECT %%s"), l_str, l_tmp])
			if l_result.to_boolean then
				Result := l_result
				js.return
			end
			if not js.return_called then
				state___0 (a_conn, {PC_IMAPSTATE}.IMAP_SELECT)
				Result := l_result
			end
		end

	imap_fetch (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_result: INTEGER_32
			l_str: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_str.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_str.ce_gets (getcmdid (a_conn))
			l_result := imapsendf ([a_conn, l_str, ce_string ("%%s FETCH 1 BODY[TEXT]"), l_str])
			if l_result.to_boolean then
				Result := l_result
				js.return
			end
			if not js.return_called then
				state___0 (a_conn, {PC_IMAPSTATE}.IMAP_FETCH)
				Result := l_result
			end
		end

	imap_state_select_resp (a_conn: CE_POINTER [PD_CONNECTDATA]; a_imapcode: INTEGER_32; a_instate: INTEGER_32): INTEGER_32
		local
			l_result: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			create l_data.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_data.ce_gets (a_conn.item.data)
			if a_imapcode /= 79 then
				sendf_inst.Curl_failf ([l_data, ce_string ("Select failed")])
				l_result := {PC_CURLCODE}.CURLE_LOGIN_DENIED
			else
				l_result := imap_fetch (a_conn)
			end
			Result := l_result
		end

	imap_statemach_act (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_result: INTEGER_32
			l_sock: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_imapcode: INTEGER_32
			l_imapc: CE_POINTER [PD_IMAP_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_nread: NATURAL_32
			l_str: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make
			create l_imapc.make
			create l_pp.make
			create l_str.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sock := a_conn.item.sock[0]
					l_data.ce_gets (a_conn.item.data)
					l_imapc.ce_gets (create {CE_POINTER [PD_IMAP_CONN]}.make_shared (a_conn.c_pointer + {PD_CONNECTDATA}.proto_offset + {PD_PROTO}.imapc_offset))
					l_pp.ce_gets (create {CE_POINTER [PD_PINGPONG]}.make_shared (l_imapc.c_pointer + {PD_IMAP_CONN}.pp_offset))
					l_nread := (0).to_natural_32
					if (l_pp.item.sendleft).to_boolean then
						Result := (pingpong_inst.Curl_pp_flushsend (l_pp))
						js.return
					end
					if not js.return_called then
						l_result := pingpong_inst.Curl_pp_readresp (l_sock, l_pp, create {CE_POINTER [INTEGER_32]}.make_shared ($l_imapcode), create {CE_POINTER [NATURAL_32]}.make_shared ($l_nread))
						if l_result.to_boolean then
							Result := l_result
							js.return
						end
					end
					if not (not js.return_called and then (l_imapcode.to_boolean)) then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						inspect l_imapc.item.state -- switch 1 head
						when 1 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 4
						when 5 then l_pos := -1 + 5
						when 4 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 2 then -- switch 1, case 1
						if l_imapcode /= 79 then
							sendf_inst.Curl_failf ([l_data, ce_string ("Got unexpected imap-server response")])
							Result := ({PC_CURLCODE}.CURLE_FTP_WEIRD_SERVER_REPLY)
							js.return
						end
						if not js.return_called then
							if (l_data.item.set.ftp_ssl).to_boolean then
								if not a_conn.item.ssl[0].use then
									l_str.ce_gets (getcmdid (a_conn))
									l_result := imapsendf ([a_conn, l_str, ce_string ("%%s STARTTLS"), l_str])
									state___0 (a_conn, {PC_IMAPSTATE}.IMAP_STARTTLS)
								else
									l_result := imap_state_login (a_conn)
								end
							else
								l_result := imap_state_login (a_conn)
							end
							if l_result.to_boolean then
								Result := l_result
								js.return
							end
						end
						l_pos := -1 + 8 -- switch 1; break
				when 3 then -- switch 1, case 2
						l_result := imap_state_login_resp (a_conn, l_imapcode, l_imapc.item.state)
						l_pos := -1 + 8 -- switch 1; break
				when 4 then -- switch 1, case 3
						l_result := imap_state_starttls_resp (a_conn, l_imapcode, l_imapc.item.state)
						l_pos := -1 + 8 -- switch 1; break
				when 5 then -- switch 1, case 5
						l_result := imap_state_fetch_resp (a_conn, l_imapcode, l_imapc.item.state)
						l_pos := -1 + 8 -- switch 1; break
				when 6 then -- switch 1, case 4
						l_result := imap_state_select_resp (a_conn, l_imapcode, l_imapc.item.state)
						l_pos := -1 + 8 -- switch 1; break
				when 7 then -- switch 1, default:
						state___0 (a_conn, {PC_IMAPSTATE}.IMAP_STOP)
						l_pos := -1 + 8 -- switch 1; break
				when 8 then -- switch 1, done: | if done
						if not js.return_called then
							Result := l_result
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	imap_statemach_act_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent imap_statemach_act)
		end

	imap_multi_statemach (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): INTEGER_32
		local
			l_imapc: CE_POINTER [PD_IMAP_CONN]
			l_result: INTEGER_32
		do
			create l_imapc.make

			l_imapc.ce_gets (create {CE_POINTER [PD_IMAP_CONN]}.make_shared (a_conn.c_pointer + {PD_CONNECTDATA}.proto_offset + {PD_PROTO}.imapc_offset))
			l_result := (pingpong_inst.Curl_pp_multi_statemach (create {CE_POINTER [PD_PINGPONG]}.make_shared (l_imapc.c_pointer + {PD_IMAP_CONN}.pp_offset)))
			a_done.item := ((l_imapc.item.state).to_natural_32 = {NATURAL_32} 0)
			Result := l_result
		end

	imap_multi_statemach_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent imap_multi_statemach)
		end

	imap_easy_statemach (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_imapc: CE_POINTER [PD_IMAP_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_result: INTEGER_32
			js: JUMP_STATE
		do
			create l_imapc.make
			create l_pp.make

			l_imapc.ce_gets (create {CE_POINTER [PD_IMAP_CONN]}.make_shared (a_conn.c_pointer + {PD_CONNECTDATA}.proto_offset + {PD_PROTO}.imapc_offset))
			l_pp.ce_gets (create {CE_POINTER [PD_PINGPONG]}.make_shared (l_imapc.c_pointer + {PD_IMAP_CONN}.pp_offset))
			l_result := {PC_CURLCODE}.CURLE_OK
			from
			until
				not (not js.loop_left and then ((l_imapc.item.state).to_natural_32 /= {NATURAL_32} 0))
			loop
				js.reset
				l_result := pingpong_inst.Curl_pp_easy_statemach (l_pp)
				if l_result.to_boolean then
					js.break
				end
			end
			js.reset
			Result := l_result
		end

	imap_init (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_imap: CE_POINTER [PD_FTP]
			l_tmp: CE_POINTER [PD_FTP]
			js: JUMP_STATE
		do
			create l_data.make
			create l_imap.make
			create l_tmp.make

			l_data.ce_gets (a_conn.item.data)
			l_imap.ce_gets (l_data.item.state.proto.imap)
			if (l_imap).c_pointer = default_pointer then
				l_tmp.ce_gets (create {CE_POINTER [PD_FTP]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([{PD_FTP}.sizeof.to_natural_32, (1).to_natural_32])))))
				l_data.item.state.proto.imap := l_tmp
				l_imap.ce_gets (l_tmp)
				if (l_imap).c_pointer = default_pointer then
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				end
			end
			if not js.return_called then
				l_imap.item.bytecountp := create {CE_POINTER [INTEGER_64]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.req_offset + {PD_SINGLEREQUEST}.bytecount_offset)
				l_imap.item.user := a_conn.item.user
				l_imap.item.passwd := a_conn.item.passwd
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	imap_connect (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): INTEGER_32
		local
			l_result: INTEGER_32
			l_imapc: CE_POINTER [PD_IMAP_CONN]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_http_proxy: PD_HTTP
			l_imap_save: CE_POINTER [PD_FTP]
			js: JUMP_STATE
		do
			create l_imapc.make
			create l_data.make
			create l_pp.make
			create l_http_proxy.make
			create l_imap_save.make

			l_imapc.ce_gets (create {CE_POINTER [PD_IMAP_CONN]}.make_shared (a_conn.c_pointer + {PD_CONNECTDATA}.proto_offset + {PD_PROTO}.imapc_offset))
			l_data.ce_gets (a_conn.item.data)
			l_pp.ce_gets (create {CE_POINTER [PD_PINGPONG]}.make_shared (l_imapc.c_pointer + {PD_IMAP_CONN}.pp_offset))
			a_done.item := (0).to_boolean
			url_inst.Curl_reset_reqproto (a_conn)
			l_result := imap_init (a_conn)
			if {NATURAL_32} 0 /= l_result.to_natural_32 then
				Result := l_result
				js.return
			end
			if not js.return_called then
				a_conn.item.bits.close := (0).to_boolean
				l_pp.item.response_time := 1800000
				l_pp.item.statemach_act := imap_statemach_act_address
				l_pp.item.endofresp := imap_endofresp_address
				l_pp.item.conn := a_conn
				if a_conn.item.bits.tunnel_proxy then
					if a_conn.item.bits.httpproxy then
						l_imap_save.ce_gets (l_data.item.state.proto.imap)
						memset (create {CE_POINTER [ANY]}.make_cast ((l_http_proxy.address)), 0, {PD_HTTP}.sizeof.to_natural_32).do_nothing
						l_data.item.state.proto.http := l_http_proxy.address
						l_result := http_inst.Curl_proxyCONNECT (a_conn, 0, a_conn.item.host.name, a_conn.item.remote_port)
						l_data.item.state.proto.imap := l_imap_save
						if {NATURAL_32} 0 /= l_result.to_natural_32 then
							Result := l_result
							js.return
						end
					end
				end
			end
			if not js.return_called and then (((a_conn.item.protocol).bit_and (((1).bit_shift_left (13)).to_integer_32)).to_boolean) then
				l_result := {PC_CURLCODE}.CURLE_FAILED_INIT
				if l_result.to_boolean then
					Result := l_result
					js.return
				end
			end
			if not js.return_called then
				pingpong_inst.Curl_pp_init (l_pp)
				state___0 (a_conn, {PC_IMAPSTATE}.IMAP_SERVERGREET)
				l_imapc.item.idstr := ce_string ("*")
				if (l_data.item.state.used_interface).to_natural_32 = {NATURAL_32} 2 then
					l_result := imap_multi_statemach (a_conn, a_done)
				else
					l_result := imap_easy_statemach (a_conn)
					if not l_result.to_boolean then
						a_done.item := (1).to_boolean
					end
				end
				Result := l_result
			end
		end

	imap_connect_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent imap_connect)
		end

	imap_done (a_conn: CE_POINTER [PD_CONNECTDATA]; a_status: INTEGER_32; a_premature: BOOLEAN): INTEGER_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_imap: CE_POINTER [PD_FTP]
			l_result: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make
			create l_imap.make

			l_data.ce_gets (a_conn.item.data)
			l_imap.ce_gets (l_data.item.state.proto.imap)
			l_result := {PC_CURLCODE}.CURLE_OK
			if (l_imap).c_pointer = default_pointer then
				Result := ({PC_CURLCODE}.CURLE_OK)
				js.return
			end
			if not js.return_called then
				if a_status.to_boolean then
					a_conn.item.bits.close := (1).to_boolean
					l_result := a_status
				end
				l_imap.item.transfer := {PC_CURL_FTPTRANSFER}.FTPTRANSFER_BODY
				Result := l_result
			end
		end

	imap_done_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent imap_done)
		end

	imap_perform (a_conn: CE_POINTER [PD_CONNECTDATA]; a_connected: CE_POINTER [BOOLEAN]; a_dophase_done: CE_POINTER [BOOLEAN]): INTEGER_32
		local
			l_result: INTEGER_32
			l_imap: CE_POINTER [PD_FTP]
			js: JUMP_STATE
		do
			create l_imap.make

			l_result := {PC_CURLCODE}.CURLE_OK
			if (a_conn.item.data).item.set.opt_no_body then
				l_imap.ce_gets ((a_conn.item.data).item.state.proto.imap)
				l_imap.item.transfer := {PC_CURL_FTPTRANSFER}.FTPTRANSFER_INFO
			end
			a_dophase_done.item := (0).to_boolean
			l_result := imap_select (a_conn)
			if l_result.to_boolean then
				Result := l_result
				js.return
			end
			if not js.return_called then
				if ((a_conn.item.data).item.state.used_interface).to_natural_32 = {NATURAL_32} 2 then
					l_result := imap_multi_statemach (a_conn, a_dophase_done)
				else
					l_result := imap_easy_statemach (a_conn)
					a_dophase_done.item := (1).to_boolean
				end
				a_connected.item := a_conn.item.bits.tcpconnect
				if a_dophase_done.item then
				end
				Result := l_result
			end
		end

	imap_do (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): INTEGER_32
		local
			l_retcode: INTEGER_32
			js: JUMP_STATE
		do
			l_retcode := {PC_CURLCODE}.CURLE_OK
			a_done.item := (0).to_boolean
			url_inst.Curl_reset_reqproto (a_conn)
			l_retcode := imap_init (a_conn)
			if l_retcode.to_boolean then
				Result := l_retcode
				js.return
			end
			if not js.return_called then
				l_retcode := imap_parse_url_path (a_conn)
				if l_retcode.to_boolean then
					Result := l_retcode
					js.return
				end
			end
			if not js.return_called then
				l_retcode := imap_regular_transfer (a_conn, a_done)
				Result := l_retcode
			end
		end

	imap_do_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent imap_do)
		end

	imap_logout (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_result: INTEGER_32
			l_str: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_str.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_str.ce_gets (getcmdid (a_conn))
			l_result := imapsendf ([a_conn, l_str, ce_string ("%%s LOGOUT"), l_str, create {CE_POINTER [ANY]}.make_shared (default_pointer)])
			if l_result.to_boolean then
				Result := l_result
				js.return
			end
			if not js.return_called then
				state___0 (a_conn, {PC_IMAPSTATE}.IMAP_LOGOUT)
				l_result := imap_easy_statemach (a_conn)
				Result := l_result
			end
		end

	imap_disconnect (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_imapc: CE_POINTER [PD_IMAP_CONN]
		do
			create l_imapc.make

			l_imapc.ce_gets (create {CE_POINTER [PD_IMAP_CONN]}.make_shared (a_conn.c_pointer + {PD_CONNECTDATA}.proto_offset + {PD_PROTO}.imapc_offset))
			if ((l_imapc.item.pp.conn).c_pointer /= default_pointer) then
				imap_logout (a_conn).do_nothing
			end
			pingpong_inst.Curl_pp_disconnect (create {CE_POINTER [PD_PINGPONG]}.make_shared (l_imapc.c_pointer + {PD_IMAP_CONN}.pp_offset)).do_nothing
			url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (l_imapc.item.mailbox))
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	imap_disconnect_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent imap_disconnect)
		end

	imap_parse_url_path (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_imapc: CE_POINTER [PD_IMAP_CONN]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_path: CE_POINTER [INTEGER_8]
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			create l_imapc.make
			create l_data.make
			create l_path.make

			l_imapc.ce_gets (create {CE_POINTER [PD_IMAP_CONN]}.make_shared (a_conn.c_pointer + {PD_CONNECTDATA}.proto_offset + {PD_PROTO}.imapc_offset))
			l_data.ce_gets (a_conn.item.data)
			l_path.ce_gets (l_data.item.state.path)
			if not (l_path[0]).to_boolean then
				l_path.ce_gets (ce_string ("INBOX"))
			end
			l_imapc.item.mailbox := escape_inst.curl_easy_unescape (create {CE_POINTER [ANY]}.make_cast (l_data), l_path, 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_len))
			if (l_imapc.item.mailbox).c_pointer = default_pointer then
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				js.return
			end
			if not js.return_called then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	imap_dophase_done (a_conn: CE_POINTER [PD_CONNECTDATA]; a_connected: BOOLEAN): INTEGER_32
		local
			l_imap: CE_POINTER [PD_FTP]
		do
			create l_imap.make

			l_imap.ce_gets ((a_conn.item.data).item.state.proto.imap)
			if (l_imap.item.transfer).to_natural_32 /= {NATURAL_32} 0 then
				transfer_inst.Curl_setup_transfer (a_conn, -1, (-1).to_integer_64, (0).to_boolean, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer), -1, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer))
			end
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	imap_doing (a_conn: CE_POINTER [PD_CONNECTDATA]; a_dophase_done: CE_POINTER [BOOLEAN]): INTEGER_32
		local
			l_result: INTEGER_32
		do
			l_result := imap_multi_statemach (a_conn, a_dophase_done)
			if a_dophase_done.item then
				l_result := imap_dophase_done (a_conn, (0).to_boolean)
			end
			Result := l_result
		end

	imap_doing_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent imap_doing)
		end

	imap_regular_transfer (a_conn: CE_POINTER [PD_CONNECTDATA]; a_dophase_done: CE_POINTER [BOOLEAN]): INTEGER_32
		local
			l_result: INTEGER_32
			l_connected: BOOLEAN
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
		do
			create l_data.make

			l_result := {PC_CURLCODE}.CURLE_OK
			l_connected := (0).to_boolean
			l_data.ce_gets (a_conn.item.data)
			l_data.item.req.size := (-1).to_integer_64
			progress_inst.Curl_pgrsSetUploadCounter (l_data, (0).to_integer_64)
			progress_inst.Curl_pgrsSetDownloadCounter (l_data, (0).to_integer_64)
			progress_inst.Curl_pgrsSetUploadSize (l_data, (0).to_integer_64)
			progress_inst.Curl_pgrsSetDownloadSize (l_data, (0).to_integer_64)
			l_result := imap_perform (a_conn, create {CE_POINTER [BOOLEAN]}.make_shared ($l_connected), a_dophase_done)
			if {NATURAL_32} 0 = l_result.to_natural_32 then
				if not a_dophase_done.item then
					Result := ({PC_CURLCODE}.CURLE_OK)
					js.return
				end
				if not js.return_called then
					l_result := imap_dophase_done (a_conn, l_connected)
					if l_result.to_boolean then
						Result := l_result
						js.return
					end
				end
			end
			if not js.return_called then
				Result := l_result
			end
		end

	imap_setup_connection (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			js: JUMP_STATE
		do
			create l_data.make

			l_data.ce_gets (a_conn.item.data)
			if a_conn.item.bits.httpproxy then
				if not l_data.item.set.tunnel_thru_httpproxy then
					if ((a_conn.item.handler).c_pointer.to_integer_32).to_natural_32 = ((Curl_handler_imap.address).c_pointer.to_integer_32).to_natural_32 then
						a_conn.item.handler := Curl_handler_imap_proxy.address
					else
						sendf_inst.Curl_failf ([l_data, ce_string ("IMAPS not supported!")])
						Result := ({PC_CURLCODE}.CURLE_UNSUPPORTED_PROTOCOL)
						js.return
					end
					if not js.return_called then
						a_conn.item.bits.close := (0).to_boolean
					end
				end
			end
			if not js.return_called then
				l_data.item.state.path := (l_data.item.state.path) + 1
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	imap_setup_connection_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent imap_setup_connection)
		end

end
