class
	P_MULTI

inherit
	LIBCURL_DATA
		redefine
			default_create
		end
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create tv_zero.make
			create none.make
		end

feature {ANY} -- attributes

	tv_zero: SD_TIMEVAL

	none: SD_TIMEVAL

feature {ANY} -- routines

	multistate (a_easy: CE_POINTER [PD_CURL_ONE_EASY]; a_state___3: INTEGER_32)
		local
			l_oldstate: INTEGER_32
			js: JUMP_STATE
		do
			l_oldstate := a_easy.item.state
			if l_oldstate.to_natural_32 = a_state___3.to_natural_32 then
				js.return
			end
			if not js.return_called then
				a_easy.item.state := a_state___3
				if a_state___3.to_natural_32 = {NATURAL_32} 15 then
					((a_easy.item.easy_handle).item.multi).item.num_alive := (((a_easy.item.easy_handle).item.multi).item.num_alive) - 1
				end
			end
		end

	sh_addentry (a_sh: CE_POINTER [PD_CURL_HASH]; a_s: INTEGER_32; a_data: CE_POINTER [PD_SESSIONHANDLE]): CE_POINTER [PD_CURL_SH_ENTRY]
		local
			l_s: INTEGER_32
			l_there: CE_POINTER [PD_CURL_SH_ENTRY]
			l_check: CE_POINTER [PD_CURL_SH_ENTRY]
			js: JUMP_STATE
		do
			create l_there.make
			create l_check.make

			l_s := a_s
			l_there.ce_gets (create {CE_POINTER [PD_CURL_SH_ENTRY]}.make_cast ((hash_inst.Curl_hash_pick (a_sh, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared ($l_s))), Integer_32_bytes.to_natural_32))))
			if ((l_there).c_pointer /= default_pointer) then
				Result := l_there
				js.return
			end
			if not js.return_called then
				l_check.ce_gets (create {CE_POINTER [PD_CURL_SH_ENTRY]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(1).to_natural_32, {PD_CURL_SH_ENTRY}.sizeof.to_natural_32])))))
				if (l_check).c_pointer = default_pointer then
					Result := (create {CE_POINTER [PD_CURL_SH_ENTRY]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				l_check.item.easy := a_data
				l_check.item.socket := l_s
				if (0).to_natural_32 = ((hash_inst.Curl_hash_add (a_sh, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared ($l_s))), Integer_32_bytes.to_natural_32, create {CE_POINTER [ANY]}.make_cast (l_check))).c_pointer.to_integer_32).to_natural_32 then
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_check)])
					Result := (create {CE_POINTER [PD_CURL_SH_ENTRY]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				Result := l_check
			end
		end

	sh_delentry (a_sh: CE_POINTER [PD_CURL_HASH]; a_s: INTEGER_32)
		local
			l_s: INTEGER_32
			l_there: CE_POINTER [PD_CURL_SH_ENTRY]
		do
			create l_there.make

			l_s := a_s
			l_there.ce_gets (create {CE_POINTER [PD_CURL_SH_ENTRY]}.make_cast ((hash_inst.Curl_hash_pick (a_sh, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared ($l_s))), Integer_32_bytes.to_natural_32))))
			if ((l_there).c_pointer /= default_pointer) then
				hash_inst.Curl_hash_delete (a_sh, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared ($l_s))), Integer_32_bytes.to_natural_32).do_nothing
			end
		end

	sh_freeentry (a_freethis: CE_POINTER [ANY])
		local
			l_p: CE_POINTER [PD_CURL_SH_ENTRY]
		do
			create l_p.make

			l_p.ce_gets (create {CE_POINTER [PD_CURL_SH_ENTRY]}.make_cast (a_freethis))
			if ((l_p).c_pointer /= default_pointer) then
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_p)])
			end
		end

	sh_freeentry_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent sh_freeentry)
		end

	fd_key_compare (a_k1: CE_POINTER [ANY]; a_k1_len: NATURAL_32; a_k2: CE_POINTER [ANY]; a_k2_len: NATURAL_32): NATURAL_32
		do
			Result := ((create {CE_POINTER [INTEGER_32]}.make_cast (a_k1)).item = (create {CE_POINTER [INTEGER_32]}.make_cast (a_k2)).item).to_integer.to_natural_32
		end

	fd_key_compare_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent fd_key_compare)
		end

	hash_fd (a_key: CE_POINTER [ANY]; a_key_length: NATURAL_32; a_slots_num: NATURAL_32): NATURAL_32
		local
			l_fd: INTEGER_32
		do
			l_fd := (create {CE_POINTER [INTEGER_32]}.make_cast (a_key)).item
			Result := (l_fd \\ a_slots_num.to_integer_32).to_natural_32
		end

	hash_fd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent hash_fd)
		end

	sh_init: CE_POINTER [PD_CURL_HASH]
		do
			Result := (hash_inst.Curl_hash_alloc (911, hash_fd_address, fd_key_compare_address, sh_freeentry_address))
		end

	multi_addmsg (a_multi: CE_POINTER [PD_CURL_MULTI]; a_msg: CE_POINTER [PD_CURL_MESSAGE]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if not (llist_inst.Curl_llist_insert_next (a_multi.item.msglist, (a_multi.item.msglist).item.tail, create {CE_POINTER [ANY]}.make_cast (a_msg))).to_boolean then
				Result := ({PC_CURLMCODE}.CURLM_OUT_OF_MEMORY)
				js.return
			end
			if not js.return_called then
				Result := ({PC_CURLMCODE}.CURLM_OK)
			end
		end

	multi_freeamsg (a_a: CE_POINTER [ANY]; a_b: CE_POINTER [ANY])
		do
		end

	multi_freeamsg_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent multi_freeamsg)
		end

	curl_multi_init: CE_POINTER [ANY]
		local
			l_multi: CE_POINTER [PD_CURL_MULTI]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_multi.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_multi.ce_gets (create {CE_POINTER [PD_CURL_MULTI]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(1).to_natural_32, {PD_CURL_MULTI}.sizeof.to_natural_32])))))
					if (l_multi).c_pointer = default_pointer then
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_multi.item.type := 764702
						l_multi.item.hostcache := hostip_inst.Curl_mk_dnscache
						if (l_multi.item.hostcache).c_pointer = default_pointer then
							l_pos := -1 + 7 -- goto error
						end
				when 2 then
						l_multi.item.sockhash := sh_init
						if (l_multi.item.sockhash).c_pointer = default_pointer then
							l_pos := -1 + 7 -- goto error
						end
				when 3 then
						l_multi.item.connc := url_inst.Curl_mk_connc (1, -1)
						if (l_multi.item.connc).c_pointer = default_pointer then
							l_pos := -1 + 7 -- goto error
						end
				when 4 then
						l_multi.item.msglist := llist_inst.Curl_llist_alloc (multi_freeamsg_address)
						if (l_multi.item.msglist).c_pointer = default_pointer then
							l_pos := -1 + 7 -- goto error
						end
				when 5 then
						l_multi.item.easy.next := create {CE_POINTER [PD_CURL_ONE_EASY]}.make_shared (l_multi.c_pointer + {PD_CURL_MULTI}.easy_offset)
						l_multi.item.easy.prev := create {CE_POINTER [PD_CURL_ONE_EASY]}.make_shared (l_multi.c_pointer + {PD_CURL_MULTI}.easy_offset)
						Result := (create {CE_POINTER [ANY]}.make_cast (l_multi))
						js.return
				when 6 then -- if done
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 7 then -- if: | error:
						if ((l_multi.item.sockhash).c_pointer /= default_pointer) then
							hash_inst.Curl_hash_destroy (l_multi.item.sockhash)
						end
						if ((l_multi.item.hostcache).c_pointer /= default_pointer) then
							hash_inst.Curl_hash_destroy (l_multi.item.hostcache)
						end
						if ((l_multi.item.connc).c_pointer /= default_pointer) then
							url_inst.Curl_rm_connc (l_multi.item.connc)
						end
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_multi)])
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	curl_multi_add_handle (a_multi_handle: CE_POINTER [ANY]; a_easy_handle: CE_POINTER [ANY]): INTEGER_32
		local
			l_multi: CE_POINTER [PD_CURL_MULTI]
			l_easy: CE_POINTER [PD_CURL_ONE_EASY]
			l_cl: CE_POINTER [PD_CLOSURE]
			l_prev: CE_POINTER [PD_CLOSURE]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_next: CE_POINTER [PD_CLOSURE]
			l_newmax: INTEGER_32
			l_res: INTEGER_32
			js: JUMP_STATE
		do
			create l_multi.make
			create l_easy.make
			create l_cl.make
			create l_prev.make
			create l_data.make
			create l_next.make

			l_multi.ce_gets (create {CE_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle))
			l_prev.ce_gets (create {CE_POINTER [PD_CLOSURE]}.make_shared (default_pointer))
			l_data.ce_gets (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_easy_handle))
			if ((l_multi).c_pointer /= default_pointer) then
				if l_multi.item.type /= 764702 then
					Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
					js.return
				end
			else
				Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
				js.return
			end
			if not js.return_called and then ((create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_easy_handle)).item.magic /= {NATURAL_32} 3235830701) then
				Result := ({PC_CURLMCODE}.CURLM_BAD_EASY_HANDLE)
				js.return
			end
			if not js.return_called and then (((create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_easy_handle)).item.multi).c_pointer /= default_pointer) then
				Result := ({PC_CURLMCODE}.CURLM_BAD_EASY_HANDLE)
				js.return
			end
			if not js.return_called then
				l_data.item.state.timeoutlist := llist_inst.Curl_llist_alloc (multi_freetimeout_address)
				if (l_data.item.state.timeoutlist).c_pointer = default_pointer then
					Result := ({PC_CURLMCODE}.CURLM_OUT_OF_MEMORY)
					js.return
				end
			end
			if not js.return_called then
				l_easy.ce_gets (create {CE_POINTER [PD_CURL_ONE_EASY]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(1).to_natural_32, {PD_CURL_ONE_EASY}.sizeof.to_natural_32])))))
				if (l_easy).c_pointer = default_pointer then
					Result := ({PC_CURLMCODE}.CURLM_OUT_OF_MEMORY)
					js.return
				end
			end
			if not js.return_called then
				l_cl.ce_gets (l_multi.item.closure)
				from
				until
					not (not js.loop_left and then ((l_cl).c_pointer /= default_pointer))
				loop
					js.reset
					l_next.ce_gets (l_cl.item.next)
					if ((l_cl.item.easy_handle).c_pointer.to_integer_32).to_natural_32 = (a_easy_handle.c_pointer.to_integer_32).to_natural_32 then
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_cl)])
						if ((l_prev).c_pointer /= default_pointer) then
							l_prev.item.next := l_next
						else
							l_multi.item.closure := l_next
						end
						js.break
					end
					if not js.loop_jumped then
						l_prev.ce_gets (l_cl)
						l_cl.ce_gets (l_next)
					end
				end
				js.reset
				l_easy.item.easy_handle := create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_easy_handle)
				multistate (l_easy, {PC_CURLMSTATE}.CURLM_STATE_INIT);
				(l_easy.item.easy_handle).item.multi_pos := l_easy
				if (((l_easy.item.easy_handle).item.dns.hostcache).c_pointer /= default_pointer) then
					if ((l_easy.item.easy_handle).item.dns.hostcachetype).to_natural_32 = {NATURAL_32} 1 then
						hash_inst.Curl_hash_destroy ((l_easy.item.easy_handle).item.dns.hostcache);
						(l_easy.item.easy_handle).item.dns.hostcache := create {CE_POINTER [PD_CURL_HASH]}.make_shared (default_pointer);
						(l_easy.item.easy_handle).item.dns.hostcachetype := {PC_HOSTCACHETYPE}.HCACHE_NONE
					end
				end
				if ((l_easy.item.easy_handle).item.dns.hostcache).c_pointer = default_pointer then
					(l_easy.item.easy_handle).item.dns.hostcache := l_multi.item.hostcache;
					(l_easy.item.easy_handle).item.dns.hostcachetype := {PC_HOSTCACHETYPE}.HCACHE_MULTI
				elseif ((l_easy.item.easy_handle).item.dns.hostcachetype).to_natural_32 = {NATURAL_32} 0 then
					(l_easy.item.easy_handle).item.dns.hostcache := l_multi.item.hostcache;
					(l_easy.item.easy_handle).item.dns.hostcachetype := {PC_HOSTCACHETYPE}.HCACHE_MULTI
				end
				if (((l_easy.item.easy_handle).item.state.connc).c_pointer /= default_pointer) then
					if (((l_easy.item.easy_handle).item.state.connc).item.type).to_natural_32 = {NATURAL_32} 0 then
						url_inst.Curl_rm_connc ((l_easy.item.easy_handle).item.state.connc);
						(l_easy.item.easy_handle).item.state.connc := l_multi.item.connc
					end
				else
					(l_easy.item.easy_handle).item.state.connc := l_multi.item.connc
				end
				((l_easy.item.easy_handle).item.state.connc).item.type := {PC_TYPE2}.CONNCACHE_MULTI
				l_easy.item.next := create {CE_POINTER [PD_CURL_ONE_EASY]}.make_shared (l_multi.c_pointer + {PD_CURL_MULTI}.easy_offset)
				l_easy.item.prev := l_multi.item.easy.prev
				l_multi.item.easy.prev := l_easy;
				(l_easy.item.prev).item.next := l_easy
				easy_inst.Curl_easy_addmulti (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_easy_handle), a_multi_handle);
				(l_easy.item.easy_handle).item.set.one_easy := l_easy
				Curl_expire (l_easy.item.easy_handle, 1)
				l_multi.item.num_easy := (l_multi.item.num_easy) + 1
				if (l_multi.item.num_easy * 4).to_integer_32 > (l_multi.item.connc).item.num then
					l_newmax := (l_multi.item.num_easy * 4).to_integer_32
					if (l_multi.item.maxconnects).to_boolean then
						if l_multi.item.maxconnects < l_newmax then
							l_newmax := l_multi.item.maxconnects
						end
					end
					if l_newmax > (l_multi.item.connc).item.num then
						l_res := (url_inst.Curl_ch_connc (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_easy_handle), l_multi.item.connc, l_newmax))
						if l_res.to_natural_32 /= {NATURAL_32} 0 then
							curl_multi_remove_handle (a_multi_handle, a_easy_handle).do_nothing
							Result := ({PC_CURLMCODE}.CURLM_OUT_OF_MEMORY)
							js.return
						end
					end
				end
			end
			if not js.return_called then
				l_multi.item.num_alive := (l_multi.item.num_alive) + 1
				memset (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [SD_TIMEVAL]}.make_shared (l_multi.c_pointer + {PD_CURL_MULTI}.timer_lastcall_offset))), 0, {SD_TIMEVAL}.sizeof.to_natural_32).do_nothing
				update_timer (l_multi).do_nothing
				Result := ({PC_CURLMCODE}.CURLM_OK)
			end
		end

	curl_multi_remove_handle (a_multi_handle: CE_POINTER [ANY]; a_curl_handle: CE_POINTER [ANY]): INTEGER_32
		local
			l_multi: CE_POINTER [PD_CURL_MULTI]
			l_easy: CE_POINTER [PD_CURL_ONE_EASY]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_premature: BOOLEAN
			l_easy_owns_conn: BOOLEAN
			l_tmp: INTEGER_32
			l_e: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_msg: CE_POINTER [PD_CURL_MESSAGE]
			js: JUMP_STATE
		do
			create l_multi.make
			create l_easy.make
			create l_data.make
			create l_e.make
			create l_msg.make

			l_multi.ce_gets (create {CE_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle))
			l_data.ce_gets (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_curl_handle))
			if ((l_multi).c_pointer /= default_pointer) then
				if l_multi.item.type /= 764702 then
					Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
					js.return
				end
			else
				Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
				js.return
			end
			if not js.return_called and then ((create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (a_curl_handle)).item.magic /= {NATURAL_32} 3235830701) then
				Result := ({PC_CURLMCODE}.CURLM_BAD_EASY_HANDLE)
				js.return
			end
			if not js.return_called then
				l_easy.ce_gets (l_data.item.multi_pos)
				if ((l_easy).c_pointer /= default_pointer) then
					l_premature := ((l_easy.item.state).to_natural_32 < {NATURAL_32} 15)
					if ((l_easy.item.easy_conn).c_pointer /= default_pointer) then
						if (((l_easy.item.easy_conn).item.data).c_pointer.to_integer_32).to_natural_32 = ((l_easy.item.easy_handle).c_pointer.to_integer_32).to_natural_32 then
							l_tmp := 1
						else
							l_tmp := 0
						end
					else
						l_tmp := 0
					end
					l_easy_owns_conn := l_tmp.to_boolean
					if l_premature then
						l_multi.item.num_alive := (l_multi.item.num_alive) - 1
					end
					if ((l_easy.item.easy_conn).c_pointer /= default_pointer) then
						if ((l_easy.item.easy_conn).item.send_pipe).item.size + ((l_easy.item.easy_conn).item.recv_pipe).item.size > {NATURAL_32} 1 then
							if (l_easy.item.state).to_natural_32 > {NATURAL_32} 6 then
								if (l_easy.item.state).to_natural_32 < {NATURAL_32} 15 then
									(l_easy.item.easy_conn).item.bits.close := (1).to_boolean;
									(l_easy.item.easy_conn).item.data := l_easy.item.easy_handle
								end
							end
						end
					end
					Curl_expire (l_easy.item.easy_handle, 0)
					if ((l_data.item.state.timeoutlist).c_pointer /= default_pointer) then
						llist_inst.Curl_llist_destroy (l_data.item.state.timeoutlist, create {CE_POINTER [ANY]}.make_shared (default_pointer))
						l_data.item.state.timeoutlist := create {CE_POINTER [PD_CURL_LLIST]}.make_shared (default_pointer)
					end
					if ((l_easy.item.easy_handle).item.dns.hostcachetype).to_natural_32 = {NATURAL_32} 3 then
						(l_easy.item.easy_handle).item.dns.hostcache := create {CE_POINTER [PD_CURL_HASH]}.make_shared (default_pointer);
						(l_easy.item.easy_handle).item.dns.hostcachetype := {PC_HOSTCACHETYPE}.HCACHE_NONE
					end
					if ((l_easy.item.easy_conn).c_pointer /= default_pointer) then
						if l_easy_owns_conn then
							url_inst.Curl_done (create {CE_POINTER [CE_POINTER [PD_CONNECTDATA]]}.make_shared (l_easy.c_pointer + {PD_CURL_ONE_EASY}.easy_conn_offset), l_easy.item.result2, l_premature).do_nothing
							if ((l_easy.item.easy_conn).c_pointer /= default_pointer) then
								(l_easy.item.easy_conn).item.data := l_easy.item.easy_handle
							end
						else
							url_inst.Curl_getoff_all_pipelines (l_easy.item.easy_handle, l_easy.item.easy_conn)
						end
					end
					multi_connc_remove_handle (l_multi, l_easy.item.easy_handle)
					if (((l_easy.item.easy_handle).item.state.connc).item.type).to_natural_32 = {NATURAL_32} 1 then
						(l_easy.item.easy_handle).item.state.connc := create {CE_POINTER [PD_CONNCACHE]}.make_shared (default_pointer);
						(l_easy.item.easy_handle).item.state.lastconnect := -1
						if ((l_easy.item.easy_conn).c_pointer /= default_pointer) then
							if l_easy_owns_conn then
								if ((l_easy.item.easy_conn).item.send_pipe).item.size + ((l_easy.item.easy_conn).item.recv_pipe).item.size = {NATURAL_32} 0 then
									(l_easy.item.easy_conn).item.connectindex := -1
								end
							end
						end
					end
					l_easy.item.state := {PC_CURLMSTATE}.CURLM_STATE_COMPLETED
					singlesocket (l_multi, l_easy)
					easy_inst.Curl_easy_addmulti (l_easy.item.easy_handle, create {CE_POINTER [ANY]}.make_shared (default_pointer))
					l_e.ce_gets ((l_multi.item.msglist).item.head)
					from
					until
						not (not js.loop_left and then ((l_e).c_pointer /= default_pointer))
					loop
						js.reset
						l_msg.ce_gets (create {CE_POINTER [PD_CURL_MESSAGE]}.make_cast (l_e.item.ptr))
						if ((l_msg.item.extmsg.easy_handle).c_pointer.to_integer_32).to_natural_32 = ((l_easy.item.easy_handle).c_pointer.to_integer_32).to_natural_32 then
							llist_inst.Curl_llist_remove (l_multi.item.msglist, l_e, create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
							js.break
						end
						if not js.loop_jumped then
							l_e.ce_gets (l_e.item.next)
						end
					end
					js.reset
					if ((l_easy.item.prev).c_pointer /= default_pointer) then
						(l_easy.item.prev).item.next := l_easy.item.next
					end
					if ((l_easy.item.next).c_pointer /= default_pointer) then
						(l_easy.item.next).item.prev := l_easy.item.prev
					end
					(l_easy.item.easy_handle).item.set.one_easy := create {CE_POINTER [PD_CURL_ONE_EASY]}.make_shared (default_pointer);
					(l_easy.item.easy_handle).item.multi_pos := create {CE_POINTER [PD_CURL_ONE_EASY]}.make_shared (default_pointer)
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_easy)])
					l_multi.item.num_easy := (l_multi.item.num_easy) - 1
					update_timer (l_multi).do_nothing
					Result := ({PC_CURLMCODE}.CURLM_OK)
				else
					Result := ({PC_CURLMCODE}.CURLM_BAD_EASY_HANDLE)
				end
			end
		end

	Curl_multi_canPipeline (a_multi: CE_POINTER [PD_CURL_MULTI]): BOOLEAN
		do
			Result := (a_multi.item.pipelining_enabled)
		end

	Curl_multi_handlePipeBreak (a_data: CE_POINTER [PD_SESSIONHANDLE])
		local
			l_one_easy: CE_POINTER [PD_CURL_ONE_EASY]
		do
			create l_one_easy.make

			l_one_easy.ce_gets (a_data.item.set.one_easy)
			if ((l_one_easy).c_pointer /= default_pointer) then
				l_one_easy.item.easy_conn := create {CE_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
			end
		end

	waitconnect_getsock (a_conn: CE_POINTER [PD_CONNECTDATA]; a_sock: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if not a_numsocks.to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				a_sock[0] := a_conn.item.sock[0]
				if a_conn.item.bits.tunnel_connecting then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				Result := ((1).bit_shift_left (16))
			end
		end

	domore_getsock (a_conn: CE_POINTER [PD_CONNECTDATA]; a_sock: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if not a_numsocks.to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				a_sock[0] := a_conn.item.sock[1]
				Result := ((1).bit_shift_left (16))
			end
		end

	multi_getsock (a_easy: CE_POINTER [PD_CURL_ONE_EASY]; a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_easy.item.easy_handle).item.state.pipe_broke then
						Result := 0
						js.return
					elseif (a_easy.item.easy_conn).c_pointer = default_pointer then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if (a_easy.item.state).to_natural_32 > {NATURAL_32} 1 then
							if (a_easy.item.state).to_natural_32 < {NATURAL_32} 15 then
								(a_easy.item.easy_conn).item.data := a_easy.item.easy_handle
							end
						end
						inspect a_easy.item.state -- switch 1 head
						when 2 then l_pos := -1 + 3
						when 5 then l_pos := -1 + 4
						when 7 then l_pos := -1 + 5
						when 8 then l_pos := -1 + 5
						when 4 then l_pos := -1 + 6
						when 3 then l_pos := -1 + 6
						when 9 then l_pos := -1 + 7
						when 10 then l_pos := -1 + 8
						when 12 then l_pos := -1 + 8
						when 11 then l_pos := -1 + 8
						else l_pos := -1 + 2
						end
				when 2 then -- switch 1, default:
						Result := 0
						js.return
				when 3 then -- switch 1, case 2
						if not js.return_called then
							Result := (hostsyn_inst.Curl_resolv_getsock (a_easy.item.easy_conn, a_socks, a_numsocks))
							js.return
						end
				when 4 then -- switch 1, case 5
						if not js.return_called then
							Result := (url_inst.Curl_protocol_getsock (a_easy.item.easy_conn, a_socks, a_numsocks))
							js.return
						end
				when 5 then -- switch 1, case 7 | switch 1, case 8
						if not js.return_called then
							Result := (url_inst.Curl_doing_getsock (a_easy.item.easy_conn, a_socks, a_numsocks))
							js.return
						end
				when 6 then -- switch 1, case 4 | switch 1, case 3
						if not js.return_called then
							Result := (waitconnect_getsock (a_easy.item.easy_conn, a_socks, a_numsocks))
							js.return
						end
				when 7 then -- switch 1, case 9
						if not js.return_called then
							Result := (domore_getsock (a_easy.item.easy_conn, a_socks, a_numsocks))
							js.return
						end
				when 8 then -- switch 1, case 10 | switch 1, case 12 | switch 1, case 11
						if not js.return_called then
							Result := (transfer_inst.Curl_single_getsock (a_easy.item.easy_conn, a_socks, a_numsocks))
						end
				when 9 then -- switch 1, done:
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	curl_multi_fdset (a_multi_handle: CE_POINTER [ANY]; a_read_fd_set: CE_POINTER [SD_FD_SET]; a_write_fd_set: CE_POINTER [SD_FD_SET]; a_exc_fd_set: CE_POINTER [SD_FD_SET]; a_max_fd: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_multi: CE_POINTER [PD_CURL_MULTI]
			l_easy: CE_POINTER [PD_CURL_ONE_EASY]
			l_this_max_fd: INTEGER_32
			l_sockbunch: CE_ARRAY [INTEGER_32]
			l_bitmap: INTEGER_32
			l_i: INTEGER_32
			l_s: INTEGER_32
			js: JUMP_STATE
		do
			create l_multi.make
			create l_easy.make
			create l_sockbunch.make (<<5>>)

			l_multi.ce_gets (create {CE_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle))
			l_this_max_fd := -1
			if ((l_multi).c_pointer /= default_pointer) then
				if l_multi.item.type /= 764702 then
					Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
					js.return
				end
			else
				Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
				js.return
			end
			if not js.return_called then
				l_easy.ce_gets (l_multi.item.easy.next)
				from
				until
					not (not js.loop_left and then ((l_easy.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_CURL_ONE_EASY]}.make_shared (l_multi.c_pointer + {PD_CURL_MULTI}.easy_offset)).c_pointer.to_integer_32).to_natural_32))
				loop
					l_bitmap := multi_getsock (l_easy, l_sockbunch, 5)
					l_i := 0
					from
					until
						not (not js.loop_left and then (l_i < 5))
					loop
						js.reset
						l_s := -1
						if ((l_bitmap).bit_and (((1).bit_shift_left (l_i)))).to_boolean then
							asm1 (a_read_fd_set.address, l_sockbunch.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_i))
							l_s := l_sockbunch[l_i]
						end
						if ((l_bitmap).bit_and (((1).bit_shift_left ((16 + l_i))))).to_boolean then
							asm2 (a_write_fd_set.address, l_sockbunch.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_i))
							l_s := l_sockbunch[l_i]
						end
						if l_s = -1 then
							js.break
						elseif l_s > l_this_max_fd then
							l_this_max_fd := l_s
						end
						if not js.loop_jumped then
							l_i := l_i + 1
						end
					end
					js.reset
					l_easy.ce_gets (l_easy.item.next)
				end
				a_max_fd.item := l_this_max_fd
				Result := ({PC_CURLMCODE}.CURLM_OK)
			end
		end

	multi_runsingle (a_multi: CE_POINTER [PD_CURL_MULTI]; a_now: SD_TIMEVAL; a_easy: CE_POINTER [PD_CURL_ONE_EASY]): INTEGER_32
		local
			l_now: SD_TIMEVAL
			l_msg: CE_POINTER [PD_CURL_MESSAGE]
			l_connected: BOOLEAN
			l_async: BOOLEAN
			l_protocol_connect: BOOLEAN
			l_dophase_done: BOOLEAN
			l_done: BOOLEAN
			l_result: INTEGER_32
			l_k: CE_POINTER [PD_SINGLEREQUEST]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_timeout_ms: INTEGER_32
			l_disconnect_conn: BOOLEAN
			l_tmp___2: INTEGER_32
			l_dns: CE_POINTER [PD_CURL_DNS_ENTRY]
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_wc: CE_POINTER [PD_WILDCARDDATA]
			l_newurl: CE_POINTER [INTEGER_8]
			l_follow: INTEGER_32
			l_drc: INTEGER_32
			l_retry: BOOLEAN
			l_tmp___7: INTEGER_32
			l_buffersize: INTEGER_32
			l_tmp___9: INTEGER_32
			l_buffersize___0: INTEGER_32
			l_tmp___10: INTEGER_32
			l_newurl___0: CE_POINTER [INTEGER_8]
			l_retry___0: BOOLEAN
			l_follow___0: INTEGER_32
			l_tmp___11: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_now.make
			create l_msg.make
			create l_k.make
			create l_data.make
			create l_dns.make
			create l_wc.make
			create l_newurl.make
			create l_newurl___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_now.ce_gets (a_now)
					l_msg.ce_gets (create {CE_POINTER [PD_CURL_MESSAGE]}.make_shared (default_pointer))
					l_protocol_connect := (0).to_boolean
					l_done := (0).to_boolean
					l_result := {PC_CURLMCODE}.CURLM_OK
					if (a_easy.item.easy_handle).item.magic /= {NATURAL_32} 3235830701 then
						Result := ({PC_CURLMCODE}.CURLM_BAD_EASY_HANDLE)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 77 -- skip if block
					end
				when 1 then -- if:
						l_data.ce_gets (a_easy.item.easy_handle)
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 76 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						l_disconnect_conn := (0).to_boolean
						if l_data.item.state.pipe_broke then
							sendf_inst.Curl_infof ([l_data, ce_string ("Pipe broke: handle 0x%%p, url = %%s%N"), a_easy, l_data.item.state.path])
							if (a_easy.item.state).to_natural_32 < {NATURAL_32} 15 then
								multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_CONNECT)
								l_result := -1
								a_easy.item.result2 := {PC_CURLCODE}.CURLE_OK
							end
							l_data.item.state.pipe_broke := (0).to_boolean
							a_easy.item.easy_conn := create {CE_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
							js.break
						end
						if not js.loop_jumped then
							if ((a_easy.item.easy_conn).c_pointer /= default_pointer) then
								if (a_easy.item.state).to_natural_32 > {NATURAL_32} 1 then
									if (a_easy.item.state).to_natural_32 < {NATURAL_32} 15 then
										(a_easy.item.easy_conn).item.data := l_data
									end
								end
							end
							if ((a_easy.item.easy_conn).c_pointer /= default_pointer) then
								if (a_easy.item.state).to_natural_32 >= {NATURAL_32} 1 then
									l_timeout_ms := connect_inst.Curl_timeleft (a_easy.item.easy_conn, l_now.address, ((a_easy.item.state).to_natural_32 <= {NATURAL_32} 6))
									if l_timeout_ms < 0 then
										if (a_easy.item.state).to_natural_32 = {NATURAL_32} 2 then
											sendf_inst.Curl_failf ([l_data, ce_string ("Resolving timed out after %%ld milliseconds"), (timeval_inst.curlx_tvdiff (l_now, l_data.item.progress.t_startsingle))])
										elseif (a_easy.item.state).to_natural_32 = {NATURAL_32} 3 then
											sendf_inst.Curl_failf ([l_data, ce_string ("Connection timed out after %%ld milliseconds"), (timeval_inst.curlx_tvdiff (l_now, l_data.item.progress.t_startsingle))])
										else
											l_k.ce_gets (create {CE_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.req_offset))
											sendf_inst.Curl_failf ([l_data, ce_string ("Operation timed out after %%ld milliseconds with %%lld out of %%lld bytes received"), (timeval_inst.curlx_tvdiff (l_now, l_data.item.progress.t_startsingle)), l_k.item.bytecount, l_k.item.size])
										end
										a_easy.item.result2 := {PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT
										multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_COMPLETED)
										js.break
									end
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 75 -- skip if block
						end
				when 4 then -- if:
						inspect a_easy.item.state -- switch 1 head
						when 0 then l_pos := -1 + 5
						when 1 then l_pos := -1 + 6
						when 2 then l_pos := -1 + 7
						when 4 then l_pos := -1 + 9
						when 3 then l_pos := -1 + 10
						when 5 then l_pos := -1 + 12
						when 6 then l_pos := -1 + 17
						when 7 then l_pos := -1 + 18
						when 8 then l_pos := -1 + 45
						when 9 then l_pos := -1 + 46
						when 10 then l_pos := -1 + 47
						when 11 then l_pos := -1 + 48
						when 13 then l_pos := -1 + 49
						when 12 then l_pos := -1 + 55
						when 14 then l_pos := -1 + 69
						when 15 then l_pos := -1 + 71
						when 16 then l_pos := -1 + 72
						else l_pos := -1 + 73
						end
				when 5 then -- switch 1, case 0
						a_easy.item.result2 := transfer_inst.Curl_pretransfer (l_data)
						if {NATURAL_32} 0 = (a_easy.item.result2).to_natural_32 then
							multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_CONNECT)
							l_result := -1
							l_data.item.state.used_interface := {PC_USED_INTERFACE}.Curl_if_multi
						end
						l_pos := -1 + 74 -- switch 1; break
				when 6 then -- switch 1, case 1
						progress_inst.Curl_pgrsTime (l_data, {PC_TIMERID}.TIMER_STARTSINGLE)
						a_easy.item.result2 := url_inst.Curl_connect (l_data, create {CE_POINTER [CE_POINTER [PD_CONNECTDATA]]}.make_shared (a_easy.c_pointer + {PD_CURL_ONE_EASY}.easy_conn_offset), create {CE_POINTER [BOOLEAN]}.make_shared ($l_async), create {CE_POINTER [BOOLEAN]}.make_shared ($l_protocol_connect))
						if {NATURAL_32} 0 = (a_easy.item.result2).to_natural_32 then
							a_easy.item.result2 := addHandleToSendOrPendPipeline (l_data, a_easy.item.easy_conn)
							if {NATURAL_32} 0 = (a_easy.item.result2).to_natural_32 then
								if l_async then
									multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_WAITRESOLVE)
								else
									l_result := -1
									if l_protocol_connect then
										if a_multi.item.pipelining_enabled then
											l_tmp___2 := 6
										else
											l_tmp___2 := 7
										end
										multistate (a_easy, l_tmp___2)
									elseif (a_easy.item.easy_conn).item.bits.tunnel_connecting then
										multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_WAITPROXYCONNECT)
									else
										multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_WAITCONNECT)
									end
								end
							end
						end
						l_pos := -1 + 74 -- switch 1; break
				when 7 then -- switch 1, case 2
						l_dns.ce_gets (create {CE_POINTER [PD_CURL_DNS_ENTRY]}.make_shared (default_pointer))
						a_easy.item.result2 := hostsyn_inst.Curl_is_resolved (a_easy.item.easy_conn, l_dns.address)
						if ((l_dns).c_pointer /= default_pointer) then
							singlesocket (a_multi, a_easy)
							a_easy.item.result2 := url_inst.Curl_async_resolved (a_easy.item.easy_conn, create {CE_POINTER [BOOLEAN]}.make_shared ($l_protocol_connect))
							if {NATURAL_32} 0 /= (a_easy.item.result2).to_natural_32 then
								a_easy.item.easy_conn := create {CE_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
							else
								l_result := -1
								if l_protocol_connect then
									if a_multi.item.pipelining_enabled then
										l_tmp___3 := 6
									else
										l_tmp___3 := 7
									end
									multistate (a_easy, l_tmp___3)
								elseif (a_easy.item.easy_conn).item.bits.tunnel_connecting then
									multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_WAITPROXYCONNECT)
								else
									multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_WAITCONNECT)
								end
							end
						end
						if {NATURAL_32} 0 /= (a_easy.item.result2).to_natural_32 then
							l_disconnect_conn := (1).to_boolean
							l_pos := -1 + 74 -- switch 1; break
						end
				when 8 then
						l_pos := -1 + 74 -- switch 1; break
				when 9 then -- switch 1, case 4
						a_easy.item.result2 := http_inst.Curl_http_connect (a_easy.item.easy_conn, create {CE_POINTER [BOOLEAN]}.make_shared ($l_protocol_connect))
						if (a_easy.item.easy_conn).item.bits.proxy_connect_closed then
							if ((l_data.item.set.errorbuffer).c_pointer /= default_pointer) then
								l_data.item.set.errorbuffer[0] := (('%/0/').code).to_integer_8
							end
							l_data.item.state.errorbuf := (0).to_boolean
							a_easy.item.result2 := {PC_CURLCODE}.CURLE_OK
							l_result := -1
							multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_CONNECT)
						elseif {NATURAL_32} 0 = (a_easy.item.result2).to_natural_32 then
							if not (a_easy.item.easy_conn).item.bits.tunnel_connecting then
								multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_WAITCONNECT)
							end
						end
						l_pos := -1 + 74 -- switch 1; break
				when 10 then -- switch 1, case 3
						a_easy.item.result2 := connect_inst.Curl_is_connected (a_easy.item.easy_conn, 0, create {CE_POINTER [BOOLEAN]}.make_shared ($l_connected))
						if l_connected then
							a_easy.item.result2 := url_inst.Curl_connected_proxy (a_easy.item.easy_conn)
							if not (a_easy.item.result2).to_boolean then
								a_easy.item.result2 := url_inst.Curl_protocol_connect (a_easy.item.easy_conn, create {CE_POINTER [BOOLEAN]}.make_shared ($l_protocol_connect))
							end
						end
						if {NATURAL_32} 0 /= (a_easy.item.result2).to_natural_32 then
							l_disconnect_conn := (1).to_boolean
							l_pos := -1 + 74 -- switch 1; break
						end
				when 11 then
						if l_connected then
							if not l_protocol_connect then
								if (a_easy.item.easy_conn).item.bits.tunnel_connecting then
									multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_WAITPROXYCONNECT)
								else
									multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_PROTOCONNECT)
								end
							else
								if a_multi.item.pipelining_enabled then
									l_tmp___4 := 6
								else
									l_tmp___4 := 7
								end
								multistate (a_easy, l_tmp___4)
							end
							l_result := -1
						end
						l_pos := -1 + 74 -- switch 1; break
				when 12 then -- switch 1, case 5
						a_easy.item.result2 := url_inst.Curl_protocol_connecting (a_easy.item.easy_conn, create {CE_POINTER [BOOLEAN]}.make_shared ($l_protocol_connect))
						if (a_easy.item.result2).to_natural_32 /= {NATURAL_32} 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if l_protocol_connect then
							if a_multi.item.pipelining_enabled then
								l_tmp___5 := 6
							else
								l_tmp___5 := 7
							end
							multistate (a_easy, l_tmp___5)
							l_result := -1
						else
							l_pos := -1 + 15 -- goto _L
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else: | _L:
						if (a_easy.item.result2).to_boolean then
							transfer_inst.Curl_posttransfer (l_data).do_nothing
							url_inst.Curl_done (create {CE_POINTER [CE_POINTER [PD_CONNECTDATA]]}.make_shared (a_easy.c_pointer + {PD_CURL_ONE_EASY}.easy_conn_offset), a_easy.item.result2, (0).to_boolean).do_nothing
							l_disconnect_conn := (1).to_boolean
						end
				when 16 then
						l_pos := -1 + 74 -- switch 1; break
				when 17 then -- switch 1, case 6
						if not (a_easy.item.easy_conn).item.writechannel_inuse then
							if (isHandleAtHead (l_data, (a_easy.item.easy_conn).item.send_pipe)) then
								(a_easy.item.easy_conn).item.writechannel_inuse := (1).to_boolean
								multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_DO)
								l_result := -1
							end
						end
						l_pos := -1 + 74 -- switch 1; break
				when 18 then -- switch 1, case 7
						if not (l_data.item.set.connect_only) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:;
						(a_easy.item.easy_conn).item.bits.close := (0).to_boolean
						multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_DONE)
						a_easy.item.result2 := {PC_CURLCODE}.CURLE_OK
						l_result := {PC_CURLMCODE}.CURLM_OK
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 21 then -- else:
						a_easy.item.result2 := url_inst.Curl_do (create {CE_POINTER [CE_POINTER [PD_CONNECTDATA]]}.make_shared (a_easy.c_pointer + {PD_CURL_ONE_EASY}.easy_conn_offset), create {CE_POINTER [BOOLEAN]}.make_shared ($l_dophase_done))
						if {NATURAL_32} 0 /= (a_easy.item.result2).to_natural_32 then
							l_pos := -1 + 28 -- skip if block
						end
				when 22 then -- if:
						if l_dophase_done then
							l_pos := -1 + 26 -- skip if block
						end
				when 23 then -- if:
						if l_data.item.set.wildcardmatch then
							l_wc.ce_gets (create {CE_POINTER [PD_WILDCARDDATA]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.wildcard_offset))
							if (l_wc.item.state).to_natural_32 = {NATURAL_32} 6 then
								url_inst.Curl_done (create {CE_POINTER [CE_POINTER [PD_CONNECTDATA]]}.make_shared (a_easy.c_pointer + {PD_CURL_ONE_EASY}.easy_conn_offset), {PC_CURLCODE}.CURLE_OK, (0).to_boolean).do_nothing
								multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_DONE)
								l_result := -1
								l_pos := -1 + 74 -- switch 1; break
							elseif (l_wc.item.state).to_natural_32 = {NATURAL_32} 4 then
								url_inst.Curl_done (create {CE_POINTER [CE_POINTER [PD_CONNECTDATA]]}.make_shared (a_easy.c_pointer + {PD_CURL_ONE_EASY}.easy_conn_offset), {PC_CURLCODE}.CURLE_OK, (0).to_boolean).do_nothing
								multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_DONE)
								l_result := -1
								l_pos := -1 + 74 -- switch 1; break
							end
						end
				when 24 then
						multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_DOING)
						l_result := {PC_CURLMCODE}.CURLM_OK
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						if (a_easy.item.easy_conn).item.bits.do_more then
							multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_DO_MORE)
							l_result := {PC_CURLMCODE}.CURLM_OK
						else
							multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_DO_DONE)
							l_result := -1
						end
				when 27 then -- if done | if block done, skip else block:
						l_pos := -1 + 44
				when 28 then -- else:
						if {NATURAL_32} 55 /= (a_easy.item.result2).to_natural_32 then
							l_pos := -1 + 43 -- skip if block
						end
				when 29 then -- if:
						if not ((a_easy.item.easy_conn).item.bits.reuse) then
							l_pos := -1 + 41 -- skip if block
						end
				when 30 then -- if:
						l_newurl.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
						l_follow := {PC_FOLLOWTYPE}.FOLLOW_NONE
						l_retry := (0).to_boolean
						l_drc := transfer_inst.Curl_retry_request (a_easy.item.easy_conn, l_newurl.address)
						if l_drc.to_boolean then
							a_easy.item.result2 := l_drc
							l_disconnect_conn := (1).to_boolean
						else
							if ((l_newurl).c_pointer /= default_pointer) then
								l_tmp___7 := 1
							else
								l_tmp___7 := 0
							end
							l_retry := l_tmp___7.to_boolean
						end
						transfer_inst.Curl_posttransfer (l_data).do_nothing
						l_drc := url_inst.Curl_done (create {CE_POINTER [CE_POINTER [PD_CONNECTDATA]]}.make_shared (a_easy.c_pointer + {PD_CURL_ONE_EASY}.easy_conn_offset), a_easy.item.result2, (0).to_boolean)
						if not l_retry then
							l_pos := -1 + 39 -- skip if block
						end
				when 31 then -- if:
						if l_drc.to_natural_32 /= {NATURAL_32} 0 then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						l_pos := -1 + 35 -- goto _L___0
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 34 then -- else:
						if l_drc.to_natural_32 /= {NATURAL_32} 55 then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if: | _L___0:
						l_follow := {PC_FOLLOWTYPE}.FOLLOW_RETRY
						l_drc := transfer_inst.Curl_follow (l_data, l_newurl, l_follow)
						if l_drc.to_natural_32 = {NATURAL_32} 0 then
							multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_CONNECT)
							l_result := -1
							a_easy.item.result2 := {PC_CURLCODE}.CURLE_OK
						else
							a_easy.item.result2 := l_drc
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_newurl)])
						end
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 37 then -- else:
						a_easy.item.result2 := l_drc
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_newurl)])
				when 38 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 40
				when 39 then -- else:
						l_disconnect_conn := (1).to_boolean
				when 40 then -- if done | if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else:
						transfer_inst.Curl_posttransfer (l_data).do_nothing
						url_inst.Curl_done (create {CE_POINTER [CE_POINTER [PD_CONNECTDATA]]}.make_shared (a_easy.c_pointer + {PD_CURL_ONE_EASY}.easy_conn_offset), a_easy.item.result2, (0).to_boolean).do_nothing
						l_disconnect_conn := (1).to_boolean
				when 42 then -- if done | if block done, skip else block:
						l_pos := -1 + 44
				when 43 then -- else:
						transfer_inst.Curl_posttransfer (l_data).do_nothing
						url_inst.Curl_done (create {CE_POINTER [CE_POINTER [PD_CONNECTDATA]]}.make_shared (a_easy.c_pointer + {PD_CURL_ONE_EASY}.easy_conn_offset), a_easy.item.result2, (0).to_boolean).do_nothing
						l_disconnect_conn := (1).to_boolean
				when 44 then -- if done | if done
						l_pos := -1 + 74 -- switch 1; break
				when 45 then -- switch 1, case 8
						a_easy.item.result2 := url_inst.Curl_protocol_doing (a_easy.item.easy_conn, create {CE_POINTER [BOOLEAN]}.make_shared ($l_dophase_done))
						if {NATURAL_32} 0 = (a_easy.item.result2).to_natural_32 then
							if l_dophase_done then
								if (a_easy.item.easy_conn).item.bits.do_more then
									multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_DO_MORE)
									l_result := {PC_CURLMCODE}.CURLM_OK
								else
									multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_DO_DONE)
									l_result := -1
								end
							end
						else
							transfer_inst.Curl_posttransfer (l_data).do_nothing
							url_inst.Curl_done (create {CE_POINTER [CE_POINTER [PD_CONNECTDATA]]}.make_shared (a_easy.c_pointer + {PD_CURL_ONE_EASY}.easy_conn_offset), a_easy.item.result2, (0).to_boolean).do_nothing
							l_disconnect_conn := (1).to_boolean
						end
						l_pos := -1 + 74 -- switch 1; break
				when 46 then -- switch 1, case 9
						a_easy.item.result2 := connect_inst.Curl_is_connected (a_easy.item.easy_conn, 1, create {CE_POINTER [BOOLEAN]}.make_shared ($l_connected))
						if l_connected then
							a_easy.item.result2 := url_inst.Curl_do_more (a_easy.item.easy_conn)
							if {NATURAL_32} 0 = (a_easy.item.result2).to_natural_32 then
								multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_DO_DONE)
								l_result := -1
							else
								transfer_inst.Curl_posttransfer (l_data).do_nothing
								url_inst.Curl_done (create {CE_POINTER [CE_POINTER [PD_CONNECTDATA]]}.make_shared (a_easy.c_pointer + {PD_CURL_ONE_EASY}.easy_conn_offset), a_easy.item.result2, (0).to_boolean).do_nothing
								l_disconnect_conn := (1).to_boolean
							end
						end
						l_pos := -1 + 74 -- switch 1; break
				when 47 then -- switch 1, case 10
						moveHandleFromSendToRecvPipeline (l_data, a_easy.item.easy_conn)
						checkPendPipeline (a_easy.item.easy_conn).do_nothing
						multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_WAITPERFORM)
						l_result := -1
						l_pos := -1 + 74 -- switch 1; break
				when 48 then -- switch 1, case 11
						if not (a_easy.item.easy_conn).item.readchannel_inuse then
							if (isHandleAtHead (l_data, (a_easy.item.easy_conn).item.recv_pipe)) then
								(a_easy.item.easy_conn).item.readchannel_inuse := (1).to_boolean
								multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_PERFORM)
								l_result := -1
							end
						end
						l_pos := -1 + 74 -- switch 1; break
				when 49 then -- switch 1, case 13
						if l_data.item.set.max_send_speed /= {INTEGER_64} 0 then
							l_pos := -1 + 52 -- skip if block
						end
				when 50 then -- if:
						l_pos := -1 + 53 -- goto _L___1
				when 51 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 52 then -- else:
						if not (l_data.item.progress.ulspeed < l_data.item.set.max_send_speed) then
							l_pos := -1 + 54 -- skip if block
						end
				when 53 then -- if: | _L___1:
						if l_data.item.set.max_recv_speed = {INTEGER_64} 0 then
							multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_PERFORM)
						elseif l_data.item.progress.dlspeed < l_data.item.set.max_recv_speed then
							multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_PERFORM)
						end
				when 54 then -- if done
						l_pos := -1 + 74 -- switch 1; break
				when 55 then -- switch 1, case 12
						if l_data.item.set.max_send_speed > {INTEGER_64} 0 then
							if l_data.item.progress.ulspeed > l_data.item.set.max_send_speed then
								multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_TOOFAST)
								if (l_data.item.set.buffer_size).to_boolean then
									l_tmp___9 := l_data.item.set.buffer_size
								else
									l_tmp___9 := 16384
								end
								l_buffersize := l_tmp___9.to_integer_32
								l_timeout_ms := transfer_inst.Curl_sleep_time (l_data.item.set.max_send_speed, l_data.item.progress.ulspeed, l_buffersize)
								Curl_expire (l_data, l_timeout_ms)
								l_pos := -1 + 74 -- switch 1; break
							end
						end
				when 56 then
						if l_data.item.set.max_recv_speed > {INTEGER_64} 0 then
							if l_data.item.progress.dlspeed > l_data.item.set.max_recv_speed then
								multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_TOOFAST)
								if (l_data.item.set.buffer_size).to_boolean then
									l_tmp___10 := l_data.item.set.buffer_size
								else
									l_tmp___10 := 16384
								end
								l_buffersize___0 := l_tmp___10.to_integer_32
								l_timeout_ms := transfer_inst.Curl_sleep_time (l_data.item.set.max_recv_speed, l_data.item.progress.dlspeed, l_buffersize___0)
								Curl_expire (l_data, l_timeout_ms)
								l_pos := -1 + 74 -- switch 1; break
							end
						end
				when 57 then
						a_easy.item.result2 := transfer_inst.Curl_readwrite (a_easy.item.easy_conn, create {CE_POINTER [BOOLEAN]}.make_shared ($l_done))
						l_k.ce_gets (create {CE_POINTER [PD_SINGLEREQUEST]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.req_offset))
						if not ((l_k.item.keepon).bit_and (1)).to_boolean then
							(a_easy.item.easy_conn).item.readchannel_inuse := (0).to_boolean
						end
						if not ((l_k.item.keepon).bit_and (((1).bit_shift_left (1)))).to_boolean then
							(a_easy.item.easy_conn).item.writechannel_inuse := (0).to_boolean
						end
						if not ((a_easy.item.result2).to_boolean) then
							l_pos := -1 + 60 -- skip if block
						end
				when 58 then -- if:
						if not (((a_easy.item.easy_conn).item.protocol).bit_and (((1).bit_shift_left (2)).to_integer_32)).to_boolean then
							(a_easy.item.easy_conn).item.bits.close := (1).to_boolean
						end
						transfer_inst.Curl_posttransfer (l_data).do_nothing
						url_inst.Curl_done (create {CE_POINTER [CE_POINTER [PD_CONNECTDATA]]}.make_shared (a_easy.c_pointer + {PD_CURL_ONE_EASY}.easy_conn_offset), a_easy.item.result2, (0).to_boolean).do_nothing
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 68
				when 60 then -- else:
						if 1 /= l_done.to_integer then
							l_pos := -1 + 68 -- skip if block
						end
				when 61 then -- if:
						l_newurl___0.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
						l_retry___0 := (0).to_boolean
						l_follow___0 := {PC_FOLLOWTYPE}.FOLLOW_NONE
						a_easy.item.result2 := transfer_inst.Curl_retry_request (a_easy.item.easy_conn, l_newurl___0.address)
						if not (a_easy.item.result2).to_boolean then
							if ((l_newurl___0).c_pointer /= default_pointer) then
								l_tmp___11 := 1
							else
								l_tmp___11 := 0
							end
							l_retry___0 := l_tmp___11.to_boolean
						end
						transfer_inst.Curl_posttransfer (l_data).do_nothing
						moveHandleFromRecvToDonePipeline (l_data, a_easy.item.easy_conn)
						if ((((a_easy.item.easy_conn).item.recv_pipe).item.head).c_pointer /= default_pointer) then
							Curl_expire (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast ((((a_easy.item.easy_conn).item.recv_pipe).item.head).item.ptr), 1)
						end
						checkPendPipeline (a_easy.item.easy_conn).do_nothing
						if (l_data.item.req.newurl).c_pointer = default_pointer then
							l_pos := -1 + 64 -- skip if block
						end
				when 62 then -- if:
						l_pos := -1 + 65 -- goto _L___2
				when 63 then -- if block done, skip else block:
						l_pos := -1 + 68
				when 64 then -- else:
						if not l_retry___0 then
							l_pos := -1 + 67 -- skip if block
						end
				when 65 then -- if: | _L___2:
						if not l_retry___0 then
							l_newurl___0.ce_gets (l_data.item.req.newurl)
							l_data.item.req.newurl := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							l_follow___0 := {PC_FOLLOWTYPE}.FOLLOW_REDIR
						else
							l_follow___0 := {PC_FOLLOWTYPE}.FOLLOW_RETRY
						end
						a_easy.item.result2 := url_inst.Curl_done (create {CE_POINTER [CE_POINTER [PD_CONNECTDATA]]}.make_shared (a_easy.c_pointer + {PD_CURL_ONE_EASY}.easy_conn_offset), {PC_CURLCODE}.CURLE_OK, (0).to_boolean)
						if (a_easy.item.result2).to_natural_32 = {NATURAL_32} 0 then
							a_easy.item.result2 := transfer_inst.Curl_follow (l_data, l_newurl___0, l_follow___0)
						end
						if {NATURAL_32} 0 = (a_easy.item.result2).to_natural_32 then
							multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_CONNECT)
							l_result := -1
						elseif ((l_newurl___0).c_pointer /= default_pointer) then
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_newurl___0)])
						end
				when 66 then -- if block done, skip else block:
						l_pos := -1 + 68
				when 67 then -- else:
						if ((l_data.item.req.location).c_pointer /= default_pointer) then
							l_newurl___0.ce_gets (l_data.item.req.location)
							l_data.item.req.location := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							a_easy.item.result2 := transfer_inst.Curl_follow (l_data, l_newurl___0, {PC_FOLLOWTYPE}.FOLLOW_FAKE)
							if (a_easy.item.result2).to_boolean then
								easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_newurl___0)])
							end
						end
						multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_DONE)
						l_result := -1
				when 68 then -- if done | if done | if done
						l_pos := -1 + 74 -- switch 1; break
				when 69 then -- switch 1, case 14
						if ((a_easy.item.easy_conn).c_pointer /= default_pointer) then
							url_inst.Curl_removeHandleFromPipeline (l_data, (a_easy.item.easy_conn).item.recv_pipe).do_nothing
							url_inst.Curl_removeHandleFromPipeline (l_data, (a_easy.item.easy_conn).item.done_pipe).do_nothing
							checkPendPipeline (a_easy.item.easy_conn).do_nothing
							if (a_easy.item.easy_conn).item.bits.stream_was_rewound then
								l_result := -1
							end
							a_easy.item.result2 := url_inst.Curl_done (create {CE_POINTER [CE_POINTER [PD_CONNECTDATA]]}.make_shared (a_easy.c_pointer + {PD_CURL_ONE_EASY}.easy_conn_offset), {PC_CURLCODE}.CURLE_OK, (0).to_boolean)
							if ((a_easy.item.easy_conn).c_pointer /= default_pointer) then
								a_easy.item.easy_conn := create {CE_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
							end
						end
						if l_data.item.set.wildcardmatch then
							if (l_data.item.wildcard.state).to_natural_32 /= {NATURAL_32} 6 then
								l_result := -1
								multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_INIT)
								l_pos := -1 + 74 -- switch 1; break
							end
						end
				when 70 then
						multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_COMPLETED)
						l_pos := -1 + 74 -- switch 1; break
				when 71 then -- switch 1, case 15
						a_easy.item.easy_conn := create {CE_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
						Curl_expire (l_data, 0)
						l_pos := -1 + 74 -- switch 1; break
				when 72 then -- switch 1, case 16
						Result := ({PC_CURLMCODE}.CURLM_OK)
						js.return
				when 73 then -- switch 1, default:
						if not js.return_called then
							Result := ({PC_CURLMCODE}.CURLM_INTERNAL_ERROR)
							js.return
						end
				when 74 then -- switch 1, done:
						if not js.return_called then
							if {NATURAL_32} 15 > (a_easy.item.state).to_natural_32 then
								if {NATURAL_32} 0 /= (a_easy.item.result2).to_natural_32 then
									l_data.item.state.pipe_broke := (0).to_boolean
									if ((a_easy.item.easy_conn).c_pointer /= default_pointer) then
										(a_easy.item.easy_conn).item.writechannel_inuse := (0).to_boolean;
										(a_easy.item.easy_conn).item.readchannel_inuse := (0).to_boolean
										url_inst.Curl_removeHandleFromPipeline (l_data, (a_easy.item.easy_conn).item.send_pipe).do_nothing
										url_inst.Curl_removeHandleFromPipeline (l_data, (a_easy.item.easy_conn).item.recv_pipe).do_nothing
										url_inst.Curl_removeHandleFromPipeline (l_data, (a_easy.item.easy_conn).item.done_pipe).do_nothing
										checkPendPipeline (a_easy.item.easy_conn).do_nothing
									end
									if l_disconnect_conn then
										url_inst.Curl_disconnect (a_easy.item.easy_conn).do_nothing
										a_easy.item.easy_conn := create {CE_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
									end
									multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_COMPLETED)
								elseif ((a_easy.item.easy_conn).c_pointer /= default_pointer) then
									if (progress_inst.Curl_pgrsUpdate (a_easy.item.easy_conn)).to_boolean then
										a_easy.item.result2 := {PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK
									end
								end
							end
							js.break
						end
				when 75 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 76 then -- loop done
						js.reset
				when 77 then -- if done
					if not js.return_called then
						if {NATURAL_32} 15 = (a_easy.item.state).to_natural_32 then
							if (l_data.item.dns.hostcachetype).to_natural_32 = {NATURAL_32} 3 then
								l_data.item.dns.hostcache := create {CE_POINTER [PD_CURL_HASH]}.make_shared (default_pointer)
								l_data.item.dns.hostcachetype := {PC_HOSTCACHETYPE}.HCACHE_NONE
							end
							l_msg.ce_gets (create {CE_POINTER [PD_CURL_MESSAGE]}.make_shared (a_easy.c_pointer + {PD_CURL_ONE_EASY}.msg_offset))
							l_msg.item.extmsg.msg := {PC_CURLMSG}.CURLMSG_DONE
							l_msg.item.extmsg.easy_handle := create {CE_POINTER [ANY]}.make_cast (l_data)
							l_msg.item.extmsg.data.result2 := a_easy.item.result2
							l_result := multi_addmsg (a_multi, l_msg)
							multistate (a_easy, {PC_CURLMSTATE}.CURLM_STATE_MSGSENT)
						end
						Result := l_result
					end
				when 78 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	curl_multi_perform (a_multi_handle: CE_POINTER [ANY]; a_running_handles: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_multi: CE_POINTER [PD_CURL_MULTI]
			l_easy: CE_POINTER [PD_CURL_ONE_EASY]
			l_returncode: INTEGER_32
			l_t: CE_POINTER [PD_CURL_TREE]
			l_now: SD_TIMEVAL
			l_result: INTEGER_32
			l_wc: CE_POINTER [PD_WILDCARDDATA]
			l_ret: INTEGER_32
			js: JUMP_STATE
		do
			create l_multi.make
			create l_easy.make
			create l_t.make
			create l_now.make
			create l_wc.make

			l_multi.ce_gets (create {CE_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle))
			l_returncode := {PC_CURLMCODE}.CURLM_OK
			l_now.ce_gets ((timeval_inst.curlx_tvnow))
			if ((l_multi).c_pointer /= default_pointer) then
				if l_multi.item.type /= 764702 then
					Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
					js.return
				end
			else
				Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
				js.return
			end
			if not js.return_called then
				l_easy.ce_gets (l_multi.item.easy.next)
				from
				until
					not (not js.loop_left and then ((l_easy.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_CURL_ONE_EASY]}.make_shared (l_multi.c_pointer + {PD_CURL_MULTI}.easy_offset)).c_pointer.to_integer_32).to_natural_32))
				loop
					l_wc.ce_gets (create {CE_POINTER [PD_WILDCARDDATA]}.make_shared ((l_easy.item.easy_handle).c_pointer + {PD_SESSIONHANDLE}.wildcard_offset))
					if (l_easy.item.easy_handle).item.set.wildcardmatch then
						if (l_wc.item.filelist).c_pointer = default_pointer then
							l_ret := (wildcard_inst.Curl_wildcard_init (l_wc))
							if l_ret.to_boolean then
								Result := ({PC_CURLMCODE}.CURLM_OUT_OF_MEMORY)
								js.return
							end
						end
					end
					if not js.return_called then
						from
						until
							js.loop_left
						loop
							js.reset
							l_result := multi_runsingle (l_multi, l_now, l_easy)
							if -1 /= l_result then
								js.break
							end
						end
						js.reset
						if (l_easy.item.easy_handle).item.set.wildcardmatch then
							if (l_wc.item.state).to_natural_32 = {NATURAL_32} 6 then
								wildcard_inst.Curl_wildcard_dtor (l_wc)
							elseif l_result.to_boolean then
								wildcard_inst.Curl_wildcard_dtor (l_wc)
							end
						end
						if l_result.to_boolean then
							l_returncode := l_result
						end
						l_easy.ce_gets (l_easy.item.next)
					end
				end
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_multi.item.timetree := splay_inst.Curl_splaygetbest (l_now, l_multi.item.timetree, l_t.address)
					if ((l_t).c_pointer /= default_pointer) then
						add_next_timeout (l_now, l_multi, create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (l_t.item.payload)).do_nothing
					end
					if (l_t).c_pointer = default_pointer then
						js.break
					end
				end
				js.reset
				a_running_handles.item := l_multi.item.num_alive
				if 0 >= l_returncode then
					update_timer (l_multi).do_nothing
				end
				Result := l_returncode
			end
		end

	curl_multi_cleanup (a_multi_handle: CE_POINTER [ANY]): INTEGER_32
		local
			l_multi: CE_POINTER [PD_CURL_MULTI]
			l_easy: CE_POINTER [PD_CURL_ONE_EASY]
			l_nexteasy: CE_POINTER [PD_CURL_ONE_EASY]
			l_i: INTEGER_32
			l_cl: CE_POINTER [PD_CLOSURE]
			l_n: CE_POINTER [PD_CLOSURE]
		do
			create l_multi.make
			create l_easy.make
			create l_nexteasy.make
			create l_cl.make
			create l_n.make

			l_multi.ce_gets (create {CE_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle))
			if ((l_multi).c_pointer /= default_pointer) then
				if l_multi.item.type = 764702 then
					l_multi.item.type := 0
					hash_inst.Curl_hash_destroy (l_multi.item.hostcache)
					hash_inst.Curl_hash_destroy (l_multi.item.sockhash)
					l_multi.item.hostcache := create {CE_POINTER [PD_CURL_HASH]}.make_shared (default_pointer)
					l_multi.item.sockhash := create {CE_POINTER [PD_CURL_HASH]}.make_shared (default_pointer)
					l_i := 0
					from
					until
						not (l_i.to_integer_32 < (l_multi.item.connc).item.num)
					loop
						if (((l_multi.item.connc).item.connects[l_i]).c_pointer /= default_pointer) then
							if ((((l_multi.item.connc).item.connects[l_i]).item.protocol).bit_and (((((((1).bit_shift_left (2))).bit_or (((1).bit_shift_left (12))))).bit_or (((1).bit_shift_left (14)))).to_integer_32)).to_boolean then
								url_inst.Curl_disconnect ((l_multi.item.connc).item.connects[l_i]).do_nothing;
								(l_multi.item.connc).item.connects[l_i] := create {CE_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
							end
						end
						l_i := l_i + 1
					end
					l_cl.ce_gets (l_multi.item.closure)
					from
					until
						(l_cl).c_pointer = default_pointer
					loop
						(l_cl.item.easy_handle).item.state.shared_conn := create {CE_POINTER [ANY]}.make_shared (default_pointer)
						if (l_cl.item.easy_handle).item.state.closed then
							url_inst.Curl_close (l_cl.item.easy_handle).do_nothing
						end
						l_n.ce_gets (l_cl.item.next)
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_cl)])
						l_cl.ce_gets (l_n)
					end
					url_inst.Curl_rm_connc (l_multi.item.connc)
					llist_inst.Curl_llist_destroy (l_multi.item.msglist, create {CE_POINTER [ANY]}.make_shared (default_pointer))
					l_easy.ce_gets (l_multi.item.easy.next)
					from
					until
						(l_easy.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_CURL_ONE_EASY]}.make_shared (l_multi.c_pointer + {PD_CURL_MULTI}.easy_offset)).c_pointer.to_integer_32).to_natural_32
					loop
						l_nexteasy.ce_gets (l_easy.item.next)
						if ((l_easy.item.easy_handle).item.dns.hostcachetype).to_natural_32 = {NATURAL_32} 3 then
							(l_easy.item.easy_handle).item.dns.hostcache := create {CE_POINTER [PD_CURL_HASH]}.make_shared (default_pointer);
							(l_easy.item.easy_handle).item.dns.hostcachetype := {PC_HOSTCACHETYPE}.HCACHE_NONE
						end
						(l_easy.item.easy_handle).item.state.connc := create {CE_POINTER [PD_CONNCACHE]}.make_shared (default_pointer)
						easy_inst.Curl_easy_addmulti (l_easy.item.easy_handle, create {CE_POINTER [ANY]}.make_shared (default_pointer))
						easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_easy)])
						l_easy.ce_gets (l_nexteasy)
					end
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_multi)])
					Result := ({PC_CURLMCODE}.CURLM_OK)
				else
					Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
				end
			else
				Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
			end
		end

	curl_multi_info_read (a_multi_handle: CE_POINTER [ANY]; a_msgs_in_queue: CE_POINTER [INTEGER_32]): CE_POINTER [PD_CURLMSG]
		local
			l_multi: CE_POINTER [PD_CURL_MULTI]
			l_msg: CE_POINTER [PD_CURL_MESSAGE]
			l_e: CE_POINTER [PD_CURL_LLIST_ELEMENT]
		do
			create l_multi.make
			create l_msg.make
			create l_e.make

			l_multi.ce_gets (create {CE_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle))
			a_msgs_in_queue.item := 0
			if ((l_multi).c_pointer /= default_pointer) then
				if l_multi.item.type = 764702 then
					if (llist_inst.Curl_llist_count (l_multi.item.msglist)).to_boolean then
						l_e.ce_gets ((l_multi.item.msglist).item.head)
						l_msg.ce_gets (create {CE_POINTER [PD_CURL_MESSAGE]}.make_cast (l_e.item.ptr))
						llist_inst.Curl_llist_remove (l_multi.item.msglist, l_e, create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
						a_msgs_in_queue.item := (llist_inst.Curl_llist_count (l_multi.item.msglist)).to_integer_32
						Result := (create {CE_POINTER [PD_CURLMSG]}.make_shared (l_msg.c_pointer + {PD_CURL_MESSAGE}.extmsg_offset))
					else
						Result := (create {CE_POINTER [PD_CURLMSG]}.make_shared (default_pointer))
					end
				else
					Result := (create {CE_POINTER [PD_CURLMSG]}.make_shared (default_pointer))
				end
			else
				Result := (create {CE_POINTER [PD_CURLMSG]}.make_shared (default_pointer))
			end
		end

	singlesocket (a_multi: CE_POINTER [PD_CURL_MULTI]; a_easy: CE_POINTER [PD_CURL_ONE_EASY])
		local
			l_socks: CE_ARRAY [INTEGER_32]
			l_i: INTEGER_32
			l_entry: CE_POINTER [PD_CURL_SH_ENTRY]
			l_s: INTEGER_32
			l_num: INTEGER_32
			l_curraction: NATURAL_32
			l_easy_by_hash: CE_POINTER [PD_CURL_ONE_EASY]
			l_remove_sock_from_hash: BOOLEAN
			l_action: INTEGER_32
			l_j: INTEGER_32
			l_easy_conn: CE_POINTER [PD_CONNECTDATA]
			l_tmp___4: CE_POINTER [ANY]
			js: JUMP_STATE
		do
			create l_socks.make (<<5>>)
			create l_entry.make
			create l_easy_by_hash.make
			create l_easy_conn.make
			create l_tmp___4.make

			l_i := 0
			from
			until
				not (l_i < 5)
			loop
				l_socks[l_i] := -1
				l_i := l_i + 1
			end
			l_curraction := (multi_getsock (a_easy, l_socks, 5)).to_natural_32
			l_i := 0
			from
			until
				js.loop_left
			loop
				js.reset
				if l_i < 5 then
					if not ((l_curraction).bit_and (((((1).bit_shift_left (l_i))).bit_or (((1).bit_shift_left ((16 + l_i))))).to_natural_32)).to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_action := 0
					l_s := l_socks[l_i]
					l_entry.ce_gets (create {CE_POINTER [PD_CURL_SH_ENTRY]}.make_cast ((hash_inst.Curl_hash_pick (a_multi.item.sockhash, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared ($l_s))), Integer_32_bytes.to_natural_32))))
					if ((l_curraction).bit_and (((1).bit_shift_left (l_i)).to_natural_32)).to_boolean then
						l_action := (l_action).bit_or ((1))
					end
					if ((l_curraction).bit_and (((1).bit_shift_left ((16 + l_i))).to_natural_32)).to_boolean then
						l_action := (l_action).bit_or ((2))
					end
					if ((l_entry).c_pointer /= default_pointer) then
						if l_entry.item.action = l_action then
							js.continue
						end
					else
						l_entry.ce_gets (sh_addentry (a_multi.item.sockhash, l_s, a_easy.item.easy_handle))
						if (l_entry).c_pointer = default_pointer then
							js.return
						end
					end
				end
				if not js.loop_jumped then
					(a_multi.item.socket_cb).call ([create {CE_POINTER [ANY]}.make_cast (a_easy.item.easy_handle), l_s, l_action, a_multi.item.socket_userp, l_entry.item.socketp])
					l_entry.item.action := l_action
				end
				if not js.loop_left then
					l_i := l_i + 1
				end
			end
			js.reset
			if not js.return_called then
				l_num := l_i
				l_i := 0
				from
				until
					not (not js.loop_left and then (l_i < a_easy.item.numsocks))
				loop
					l_s := a_easy.item.sockets[l_i]
					l_j := 0
					from
					until
						not (not js.loop_left and then (l_j < l_num))
					loop
						js.reset
						if l_s = l_socks[l_j] then
							l_s := -1
							js.break
						end
						if not js.loop_jumped then
							l_j := l_j + 1
						end
					end
					js.reset
					if l_s /= -1 then
						l_remove_sock_from_hash := (1).to_boolean
						l_entry.ce_gets (create {CE_POINTER [PD_CURL_SH_ENTRY]}.make_cast ((hash_inst.Curl_hash_pick (a_multi.item.sockhash, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared ($l_s))), Integer_32_bytes.to_natural_32))))
						if ((l_entry).c_pointer /= default_pointer) then
							l_easy_by_hash.ce_gets ((l_entry.item.easy).item.multi_pos)
							l_easy_conn.ce_gets (l_easy_by_hash.item.easy_conn)
							if ((l_easy_conn).c_pointer /= default_pointer) then
								if ((l_easy_conn.item.recv_pipe).c_pointer /= default_pointer) then
									if (l_easy_conn.item.recv_pipe).item.size > {NATURAL_32} 1 then
										l_remove_sock_from_hash := (0).to_boolean
										if ((l_entry.item.easy).c_pointer.to_integer_32).to_natural_32 = ((a_easy.item.easy_handle).c_pointer.to_integer_32).to_natural_32 then
											if (isHandleAtHead (a_easy.item.easy_handle, l_easy_conn.item.recv_pipe)) then
												l_entry.item.easy := create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast ((((l_easy_conn.item.recv_pipe).item.head).item.next).item.ptr)
											else
												l_entry.item.easy := create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (((l_easy_conn.item.recv_pipe).item.head).item.ptr)
											end
										end
									end
								end
								if ((l_easy_conn.item.send_pipe).c_pointer /= default_pointer) then
									if (l_easy_conn.item.send_pipe).item.size > {NATURAL_32} 1 then
										l_remove_sock_from_hash := (0).to_boolean
										if ((l_entry.item.easy).c_pointer.to_integer_32).to_natural_32 = ((a_easy.item.easy_handle).c_pointer.to_integer_32).to_natural_32 then
											if (isHandleAtHead (a_easy.item.easy_handle, l_easy_conn.item.send_pipe)) then
												l_entry.item.easy := create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast ((((l_easy_conn.item.send_pipe).item.head).item.next).item.ptr)
											else
												l_entry.item.easy := create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (((l_easy_conn.item.send_pipe).item.head).item.ptr)
											end
										end
									end
								end
							end
						else
							l_remove_sock_from_hash := (0).to_boolean
						end
						if l_remove_sock_from_hash then
							if ((l_entry).c_pointer /= default_pointer) then
								l_tmp___4.ce_gets (l_entry.item.socketp)
							else
								l_tmp___4.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer))
							end
							(a_multi.item.socket_cb).call ([create {CE_POINTER [ANY]}.make_cast (a_easy.item.easy_handle), l_s, 4, a_multi.item.socket_userp, l_tmp___4])
							sh_delentry (a_multi.item.sockhash, l_s)
						end
					end
					l_i := l_i + 1
				end
				memcpy (create {CE_POINTER [ANY]}.make_cast ((a_easy.item.sockets)), create {CE_POINTER [ANY]}.make_cast (l_socks), l_num.to_natural_32 * Integer_32_bytes.to_natural_32).do_nothing
				a_easy.item.numsocks := l_num
			end
		end

	add_next_timeout (a_now: SD_TIMEVAL; a_multi: CE_POINTER [PD_CURL_MULTI]; a_d: CE_POINTER [PD_SESSIONHANDLE]): INTEGER_32
		local
			l_tv: CE_POINTER [SD_TIMEVAL]
			l_list: CE_POINTER [PD_CURL_LLIST]
			l_e: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_n: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_diff: INTEGER_32
			js: JUMP_STATE
		do
			create l_tv.make
			create l_list.make
			create l_e.make
			create l_n.make

			l_tv.ce_gets (create {CE_POINTER [SD_TIMEVAL]}.make_shared (a_d.c_pointer + {PD_SESSIONHANDLE}.state_offset + {PD_URLSTATE}.expiretime_offset))
			l_list.ce_gets (a_d.item.state.timeoutlist)
			l_e.ce_gets (l_list.item.head)
			from
			until
				not (not js.loop_left and then ((l_e).c_pointer /= default_pointer))
			loop
				js.reset
				l_n.ce_gets (l_e.item.next)
				l_diff := (timeval_inst.curlx_tvdiff ((create {CE_POINTER [SD_TIMEVAL]}.make_cast (l_e.item.ptr)).item, a_now))
				if l_diff <= 0 then
					llist_inst.Curl_llist_remove (l_list, l_e, create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
				else
					js.break
				end
				if not js.loop_jumped then
					l_e.ce_gets (l_n)
				end
			end
			js.reset
			if not (l_list.item.size).to_boolean then
				l_tv.item.tv_sec := (0).to_integer_32
				l_tv.item.tv_usec := (0).to_integer_32
			else
				l_e.ce_gets (l_list.item.head)
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_tv), l_e.item.ptr, {SD_TIMEVAL}.sizeof.to_natural_32).do_nothing
				llist_inst.Curl_llist_remove (l_list, l_e, create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
				a_multi.item.timetree := splay_inst.Curl_splayinsert (l_tv.item, a_multi.item.timetree, create {CE_POINTER [PD_CURL_TREE]}.make_shared (a_d.c_pointer + {PD_SESSIONHANDLE}.state_offset + {PD_URLSTATE}.timenode_offset))
			end
			Result := ({PC_CURLMCODE}.CURLM_OK)
		end

	multi_socket (a_multi: CE_POINTER [PD_CURL_MULTI]; a_checkall: BOOLEAN; a_s: INTEGER_32; a_ev_bitmask: INTEGER_32; a_running_handles: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_s: INTEGER_32
			l_result: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_t: CE_POINTER [PD_CURL_TREE]
			l_now: SD_TIMEVAL
			l_easyp: CE_POINTER [PD_CURL_ONE_EASY]
			l_entry: CE_POINTER [PD_CURL_SH_ENTRY]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make
			create l_t.make
			create l_now.make
			create l_easyp.make
			create l_entry.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_s
					l_result := {PC_CURLMCODE}.CURLM_OK
					l_data.ce_gets (create {CE_POINTER [PD_SESSIONHANDLE]}.make_shared (default_pointer))
					l_now.ce_gets ((timeval_inst.curlx_tvnow))
					if not a_checkall then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_result := curl_multi_perform (create {CE_POINTER [ANY]}.make_cast (a_multi), a_running_handles)
						l_easyp.ce_gets (a_multi.item.easy.next)
						from
						until
							(l_easyp.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_CURL_ONE_EASY]}.make_shared (a_multi.c_pointer + {PD_CURL_MULTI}.easy_offset)).c_pointer.to_integer_32).to_natural_32
						loop
							singlesocket (a_multi, l_easyp)
							l_easyp.ce_gets (l_easyp.item.next)
						end
						Result := l_result
						js.return
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 3 then -- else:
						if l_s = -1 then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						l_entry.ce_gets (create {CE_POINTER [PD_CURL_SH_ENTRY]}.make_cast ((hash_inst.Curl_hash_pick (a_multi.item.sockhash, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared ($l_s))), Integer_32_bytes.to_natural_32))))
						if ((l_entry).c_pointer = default_pointer) then
							l_pos := -1 + 12 -- skip if block
						end
				when 5 then -- if:
						l_data.ce_gets (l_entry.item.easy)
						if l_data.item.magic /= {NATURAL_32} 3235830701 then
							Result := ({PC_CURLMCODE}.CURLM_INTERNAL_ERROR)
							js.return
						end
						if js.return_called then
							l_pos := -1 + 12 -- skip if block
						end
				when 6 then -- if:
						if ((l_data.item.set.one_easy).item.easy_conn).c_pointer = default_pointer then
							l_pos := -1 + 11 -- skip if block
						end
				when 7 then -- if:
						if not (((a_ev_bitmask).bit_and (2)).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if ((((l_data.item.set.one_easy).item.easy_conn).item.send_pipe).c_pointer /= default_pointer) then
							if (((((l_data.item.set.one_easy).item.easy_conn).item.send_pipe).item.head).c_pointer /= default_pointer) then
								l_data.ce_gets (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (((((l_data.item.set.one_easy).item.easy_conn).item.send_pipe).item.head).item.ptr))
							else
								l_pos := -1 + 10 -- goto _L___0
							end
						else
							l_pos := -1 + 10 -- goto _L___0
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L___0:
						if ((a_ev_bitmask).bit_and (1)).to_boolean then
							if ((((l_data.item.set.one_easy).item.easy_conn).item.recv_pipe).c_pointer /= default_pointer) then
								if (((((l_data.item.set.one_easy).item.easy_conn).item.recv_pipe).item.head).c_pointer /= default_pointer) then
									l_data.ce_gets (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (((((l_data.item.set.one_easy).item.easy_conn).item.recv_pipe).item.head).item.ptr))
								end
							end
						end
				when 11 then -- if done
						if (((l_data.item.set.one_easy).item.easy_conn).c_pointer /= default_pointer) then
							((l_data.item.set.one_easy).item.easy_conn).item.cselect_bits := a_ev_bitmask
						end
						from
						until
							js.loop_left
						loop
							js.reset
							l_result := multi_runsingle (a_multi, l_now, l_data.item.set.one_easy)
							if -1 /= l_result then
								js.break
							end
						end
						js.reset
						if (((l_data.item.set.one_easy).item.easy_conn).c_pointer /= default_pointer) then
							((l_data.item.set.one_easy).item.easy_conn).item.cselect_bits := 0
						end
						if 0 >= l_result then
							singlesocket (a_multi, l_data.item.set.one_easy)
						end
						l_data.ce_gets (create {CE_POINTER [PD_SESSIONHANDLE]}.make_shared (default_pointer))
				when 12 then -- if done | if done | if done | if done
						if not js.return_called then
							l_now.tv_usec := l_now.tv_usec + (40000)
							if l_now.tv_usec > 1000000 then
								l_now.tv_sec := (l_now.tv_sec) + 1
								l_now.tv_usec := l_now.tv_usec - (1000000)
							end
							from
							until
								js.loop_left
							loop
								js.reset
								if ((l_data).c_pointer /= default_pointer) then
									from
									until
										js.loop_left
									loop
										js.reset
										l_result := multi_runsingle (a_multi, l_now, l_data.item.set.one_easy)
										if -1 /= l_result then
											js.break
										end
									end
									js.reset
									if 0 >= l_result then
										singlesocket (a_multi, l_data.item.set.one_easy)
									end
								end
								a_multi.item.timetree := splay_inst.Curl_splaygetbest (l_now, a_multi.item.timetree, l_t.address)
								if ((l_t).c_pointer /= default_pointer) then
									l_data.ce_gets (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (l_t.item.payload))
									add_next_timeout (l_now, a_multi, create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (l_t.item.payload)).do_nothing
								end
								if (l_t).c_pointer = default_pointer then
									js.break
								end
							end
							js.reset
							a_running_handles.item := a_multi.item.num_alive
							Result := l_result
						end
				when 13 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	curl_multi_setopt (a_args: TUPLE [a_multi_handle: CE_POINTER [ANY]; a_option: INTEGER_32]): INTEGER_32
		local
			l_multi: CE_POINTER [PD_CURL_MULTI]
			l_res: INTEGER_32
			l_param: CE_VA_LIST
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_multi.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_multi.ce_gets (create {CE_POINTER [PD_CURL_MULTI]}.make_cast (a_args.a_multi_handle))
					l_res := {PC_CURLMCODE}.CURLM_OK
					if ((l_multi).c_pointer /= default_pointer) then
						if l_multi.item.type /= 764702 then
							Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
							js.return
						end
					else
						Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						create l_param.make (a_args, 3)
						inspect a_args.a_option -- switch 1 head
						when 20001 then l_pos := -1 + 2
						when 10002 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 4
						when 20004 then l_pos := -1 + 5
						when 10005 then l_pos := -1 + 6
						when 6 then l_pos := -1 + 7
						else l_pos := -1 + 8
						end
				when 2 then -- switch 1, case 20001
						l_multi.item.socket_cb := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
						l_pos := -1 + 9 -- switch 1; break
				when 3 then -- switch 1, case 10002
						l_multi.item.socket_userp := (create {CE_POINTER [ANY]}.make_cast (l_param.pointer_item))
						l_pos := -1 + 9 -- switch 1; break
				when 4 then -- switch 1, case 3
						l_multi.item.pipelining_enabled := (0 /= (l_param.integer_32_item))
						l_pos := -1 + 9 -- switch 1; break
				when 5 then -- switch 1, case 20004
						l_multi.item.timer_cb := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
						l_pos := -1 + 9 -- switch 1; break
				when 6 then -- switch 1, case 10005
						l_multi.item.timer_userp := (create {CE_POINTER [ANY]}.make_cast (l_param.pointer_item))
						l_pos := -1 + 9 -- switch 1; break
				when 7 then -- switch 1, case 6
						l_multi.item.maxconnects := l_param.integer_32_item
						l_pos := -1 + 9 -- switch 1; break
				when 8 then -- switch 1, default:
						l_res := {PC_CURLMCODE}.CURLM_UNKNOWN_OPTION
						l_pos := -1 + 9 -- switch 1; break
				when 9 then -- switch 1, done:
						Result := l_res
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	curl_multi_socket (a_multi_handle: CE_POINTER [ANY]; a_s: INTEGER_32; a_running_handles: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_result: INTEGER_32
		do
			l_result := (multi_socket (create {CE_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle), (0).to_boolean, a_s, 0, a_running_handles))
			if 0 >= l_result then
				update_timer (create {CE_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle)).do_nothing
			end
			Result := l_result
		end

	curl_multi_socket_action (a_multi_handle: CE_POINTER [ANY]; a_s: INTEGER_32; a_ev_bitmask: INTEGER_32; a_running_handles: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_result: INTEGER_32
		do
			l_result := (multi_socket (create {CE_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle), (0).to_boolean, a_s, a_ev_bitmask, a_running_handles))
			if 0 >= l_result then
				update_timer (create {CE_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle)).do_nothing
			end
			Result := l_result
		end

	curl_multi_socket_all (a_multi_handle: CE_POINTER [ANY]; a_running_handles: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_result: INTEGER_32
		do
			l_result := (multi_socket (create {CE_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle), (1).to_boolean, -1, 0, a_running_handles))
			if 0 >= l_result then
				update_timer (create {CE_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle)).do_nothing
			end
			Result := l_result
		end

	multi_timeout (a_multi: CE_POINTER [PD_CURL_MULTI]; a_timeout_ms: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_now: SD_TIMEVAL
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
		do
			create l_now.make

			if ((a_multi.item.timetree).c_pointer /= default_pointer) then
				l_now.ce_gets ((timeval_inst.curlx_tvnow))
				a_multi.item.timetree := splay_inst.Curl_splay (tv_zero, a_multi.item.timetree)
				if (a_multi.item.timetree).item.key.tv_sec < l_now.tv_sec then
					l_tmp___3 := -1
				else
					if (a_multi.item.timetree).item.key.tv_sec > l_now.tv_sec then
						l_tmp___2 := 1
					else
						if (a_multi.item.timetree).item.key.tv_usec < l_now.tv_usec then
							l_tmp___1 := -1
						else
							if (a_multi.item.timetree).item.key.tv_usec > l_now.tv_usec then
								l_tmp___0 := 1
							else
								l_tmp___0 := 0
							end
							l_tmp___1 := l_tmp___0
						end
						l_tmp___2 := l_tmp___1
					end
					l_tmp___3 := l_tmp___2
				end
				if l_tmp___3 > 0 then
					a_timeout_ms.item := timeval_inst.curlx_tvdiff ((a_multi.item.timetree).item.key, l_now)
					if not (a_timeout_ms.item).to_boolean then
						a_timeout_ms.item := 1
					end
				else
					a_timeout_ms.item := 0
				end
			else
				a_timeout_ms.item := -1
			end
			Result := ({PC_CURLMCODE}.CURLM_OK)
		end

	curl_multi_timeout (a_multi_handle: CE_POINTER [ANY]; a_timeout_ms: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_multi: CE_POINTER [PD_CURL_MULTI]
			js: JUMP_STATE
		do
			create l_multi.make

			l_multi.ce_gets (create {CE_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle))
			if ((l_multi).c_pointer /= default_pointer) then
				if l_multi.item.type /= 764702 then
					Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
					js.return
				end
			else
				Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
				js.return
			end
			if not js.return_called then
				Result := (multi_timeout (l_multi, a_timeout_ms))
			end
		end

	update_timer (a_multi: CE_POINTER [PD_CURL_MULTI]): INTEGER_32
		local
			l_timeout_ms: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			js: JUMP_STATE
		do
			if (a_multi.item.timer_cb).c_pointer = default_pointer then
				Result := 0
				js.return
			end
			if not js.return_called then
				if (multi_timeout (a_multi, create {CE_POINTER [INTEGER_32]}.make_shared ($l_timeout_ms))).to_boolean then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called and then (l_timeout_ms < 0) then
				if none.tv_sec < a_multi.item.timer_lastcall.tv_sec then
					l_tmp___4 := -1
				else
					if none.tv_sec > a_multi.item.timer_lastcall.tv_sec then
						l_tmp___3 := 1
					else
						if none.tv_usec < a_multi.item.timer_lastcall.tv_usec then
							l_tmp___2 := -1
						else
							if none.tv_usec > a_multi.item.timer_lastcall.tv_usec then
								l_tmp___1 := 1
							else
								l_tmp___1 := 0
							end
							l_tmp___2 := l_tmp___1
						end
						l_tmp___3 := l_tmp___2
					end
					l_tmp___4 := l_tmp___3
				end
				if l_tmp___4.to_boolean then
					a_multi.item.timer_lastcall := none
					Result := ((a_multi.item.timer_cb).integer_32_item ([create {CE_POINTER [ANY]}.make_cast (a_multi), -1, a_multi.item.timer_userp]))
					js.return
				end
				if not js.return_called then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if (a_multi.item.timetree).item.key.tv_sec < a_multi.item.timer_lastcall.tv_sec then
					l_tmp___8 := -1
				else
					if (a_multi.item.timetree).item.key.tv_sec > a_multi.item.timer_lastcall.tv_sec then
						l_tmp___7 := 1
					else
						if (a_multi.item.timetree).item.key.tv_usec < a_multi.item.timer_lastcall.tv_usec then
							l_tmp___6 := -1
						else
							if (a_multi.item.timetree).item.key.tv_usec > a_multi.item.timer_lastcall.tv_usec then
								l_tmp___5 := 1
							else
								l_tmp___5 := 0
							end
							l_tmp___6 := l_tmp___5
						end
						l_tmp___7 := l_tmp___6
					end
					l_tmp___8 := l_tmp___7
				end
				if l_tmp___8 = 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				a_multi.item.timer_lastcall := (a_multi.item.timetree).item.key
				Result := ((a_multi.item.timer_cb).integer_32_item ([create {CE_POINTER [ANY]}.make_cast (a_multi), l_timeout_ms, a_multi.item.timer_userp]))
			end
		end

	addHandleToSendOrPendPipeline (a_handle: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_pipeLen: NATURAL_32
			l_sendhead: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_pipeline: CE_POINTER [PD_CURL_LLIST]
			l_rc: INTEGER_32
		do
			create l_sendhead.make
			create l_pipeline.make

			l_pipeLen := (a_conn.item.send_pipe).item.size + (a_conn.item.recv_pipe).item.size
			l_sendhead.ce_gets ((a_conn.item.send_pipe).item.head)
			if (url_inst.Curl_isPipeliningEnabled (a_handle)) then
				if l_pipeLen = {NATURAL_32} 0 then
					l_pipeline.ce_gets (a_conn.item.send_pipe)
				elseif a_conn.item.server_supports_pipelining then
					if l_pipeLen < {NATURAL_32} 5 then
						l_pipeline.ce_gets (a_conn.item.send_pipe)
					else
						l_pipeline.ce_gets (a_conn.item.pend_pipe)
					end
				else
					l_pipeline.ce_gets (a_conn.item.pend_pipe)
				end
			else
				l_pipeline.ce_gets (a_conn.item.send_pipe)
			end
			l_rc := url_inst.Curl_addHandleToPipeline (a_handle, l_pipeline)
			if (l_pipeline.c_pointer.to_integer_32).to_natural_32 = ((a_conn.item.send_pipe).c_pointer.to_integer_32).to_natural_32 then
				if (l_sendhead.c_pointer.to_integer_32).to_natural_32 /= (((a_conn.item.send_pipe).item.head).c_pointer.to_integer_32).to_natural_32 then
					a_conn.item.writechannel_inuse := (0).to_boolean
					sendf_inst.Curl_infof ([a_conn.item.data, ce_string ("%%p is at send pipe head!%N"), ((a_conn.item.send_pipe).item.head).item.ptr])
					Curl_expire (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (((a_conn.item.send_pipe).item.head).item.ptr), 1)
				end
			end
			Result := l_rc
		end

	checkPendPipeline (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_result: INTEGER_32
			l_sendhead: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_pipeLen: NATURAL_32
			l_curr: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_maxPipeLen: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_sendhead.make
			create l_curr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := 0
					l_sendhead.ce_gets ((a_conn.item.send_pipe).item.head)
					l_pipeLen := (a_conn.item.send_pipe).item.size + (a_conn.item.recv_pipe).item.size
					if not (a_conn.item.server_supports_pipelining) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_pipeLen /= {NATURAL_32} 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_curr.ce_gets ((a_conn.item.pend_pipe).item.head)
						if a_conn.item.server_supports_pipelining then
							l_tmp := 5
						else
							l_tmp := 1
						end
						l_maxPipeLen := l_tmp.to_natural_32
						from
						until
							js.loop_left
						loop
							js.reset
							if l_pipeLen < l_maxPipeLen then
								if (l_curr).c_pointer = default_pointer then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								llist_inst.Curl_llist_move (a_conn.item.pend_pipe, l_curr, a_conn.item.send_pipe, (a_conn.item.send_pipe).item.tail).do_nothing
								progress_inst.Curl_pgrsTime (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (l_curr.item.ptr), {PC_TIMERID}.TIMER_PRETRANSFER)
								l_result := l_result + 1
								l_curr.ce_gets ((a_conn.item.pend_pipe).item.head)
								l_pipeLen := l_pipeLen + 1
							end
						end
						js.reset
				when 5 then -- if done
						if l_result.to_boolean then
							a_conn.item.now := timeval_inst.curlx_tvnow
							if (l_sendhead.c_pointer.to_integer_32).to_natural_32 /= (((a_conn.item.send_pipe).item.head).c_pointer.to_integer_32).to_natural_32 then
								a_conn.item.writechannel_inuse := (0).to_boolean
								sendf_inst.Curl_infof ([a_conn.item.data, ce_string ("%%p is at send pipe head!%N"), ((a_conn.item.send_pipe).item.head).item.ptr])
								Curl_expire (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (((a_conn.item.send_pipe).item.head).item.ptr), 1)
							end
						end
						Result := l_result
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	moveHandleFromSendToRecvPipeline (a_handle: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA])
		local
			l_curr: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			js: JUMP_STATE
		do
			create l_curr.make

			l_curr.ce_gets ((a_conn.item.send_pipe).item.head)
			from
			until
				not (not js.loop_left and then ((l_curr).c_pointer /= default_pointer))
			loop
				js.reset
				if ((l_curr.item.ptr).c_pointer.to_integer_32).to_natural_32 = (a_handle.c_pointer.to_integer_32).to_natural_32 then
					llist_inst.Curl_llist_move (a_conn.item.send_pipe, l_curr, a_conn.item.recv_pipe, (a_conn.item.recv_pipe).item.tail).do_nothing
					if (((a_conn.item.send_pipe).item.head).c_pointer /= default_pointer) then
						a_conn.item.writechannel_inuse := (0).to_boolean
						sendf_inst.Curl_infof ([a_conn.item.data, ce_string ("%%p is at send pipe head B!%N"), ((a_conn.item.send_pipe).item.head).item.ptr])
						Curl_expire (create {CE_POINTER [PD_SESSIONHANDLE]}.make_cast (((a_conn.item.send_pipe).item.head).item.ptr), 1)
					end
					js.break
				end
				if not js.loop_jumped then
					l_curr.ce_gets (l_curr.item.next)
				end
			end
			js.reset
		end

	moveHandleFromRecvToDonePipeline (a_handle: CE_POINTER [PD_SESSIONHANDLE]; a_conn: CE_POINTER [PD_CONNECTDATA])
		local
			l_curr: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			js: JUMP_STATE
		do
			create l_curr.make

			l_curr.ce_gets ((a_conn.item.recv_pipe).item.head)
			from
			until
				not (not js.loop_left and then ((l_curr).c_pointer /= default_pointer))
			loop
				js.reset
				if ((l_curr.item.ptr).c_pointer.to_integer_32).to_natural_32 = (a_handle.c_pointer.to_integer_32).to_natural_32 then
					llist_inst.Curl_llist_move (a_conn.item.recv_pipe, l_curr, a_conn.item.done_pipe, (a_conn.item.done_pipe).item.tail).do_nothing
					js.break
				end
				if not js.loop_jumped then
					l_curr.ce_gets (l_curr.item.next)
				end
			end
			js.reset
		end

	isHandleAtHead (a_handle: CE_POINTER [PD_SESSIONHANDLE]; a_pipeline: CE_POINTER [PD_CURL_LLIST]): BOOLEAN
		local
			l_curr: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			js: JUMP_STATE
		do
			create l_curr.make

			l_curr.ce_gets (a_pipeline.item.head)
			if ((l_curr).c_pointer /= default_pointer) then
				Result := (((l_curr.item.ptr).c_pointer.to_integer_32).to_natural_32 = (a_handle.c_pointer.to_integer_32).to_natural_32)
				js.return
			end
			if not js.return_called then
				Result := (0).to_boolean
			end
		end

	multi_freetimeout (a_user: CE_POINTER [ANY]; a_entryptr: CE_POINTER [ANY])
		do
			easy_inst.Curl_cfree.call ([a_entryptr])
		end

	multi_freetimeout_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent multi_freetimeout)
		end

	multi_addtimeout (a_timeoutlist: CE_POINTER [PD_CURL_LLIST]; a_stamp: CE_POINTER [SD_TIMEVAL]): INTEGER_32
		local
			l_e: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_timedup: CE_POINTER [SD_TIMEVAL]
			l_prev: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_checktime: CE_POINTER [SD_TIMEVAL]
			l_diff: INTEGER_32
			js: JUMP_STATE
		do
			create l_e.make
			create l_timedup.make
			create l_prev.make
			create l_checktime.make

			l_prev.ce_gets (create {CE_POINTER [PD_CURL_LLIST_ELEMENT]}.make_shared (default_pointer))
			l_timedup.ce_gets (create {CE_POINTER [SD_TIMEVAL]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([{SD_TIMEVAL}.sizeof.to_natural_32])))))
			if (l_timedup).c_pointer = default_pointer then
				Result := ({PC_CURLMCODE}.CURLM_OUT_OF_MEMORY)
				js.return
			end
			if not js.return_called then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_timedup), create {CE_POINTER [ANY]}.make_cast (a_stamp), {SD_TIMEVAL}.sizeof.to_natural_32).do_nothing
				if (llist_inst.Curl_llist_count (a_timeoutlist)).to_boolean then
					l_e.ce_gets (a_timeoutlist.item.head)
					from
					until
						not (not js.loop_left and then ((l_e).c_pointer /= default_pointer))
					loop
						js.reset
						l_checktime.ce_gets (create {CE_POINTER [SD_TIMEVAL]}.make_cast (l_e.item.ptr))
						l_diff := (timeval_inst.curlx_tvdiff (l_checktime.item, l_timedup.item))
						if l_diff > 0 then
							js.break
						end
						if not js.loop_jumped then
							l_prev.ce_gets (l_e)
							l_e.ce_gets (l_e.item.next)
						end
					end
					js.reset
				end
				if not (llist_inst.Curl_llist_insert_next (a_timeoutlist, l_prev, create {CE_POINTER [ANY]}.make_cast (l_timedup))).to_boolean then
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_timedup)])
					Result := ({PC_CURLMCODE}.CURLM_OUT_OF_MEMORY)
					js.return
				end
			end
			if not js.return_called then
				Result := ({PC_CURLMCODE}.CURLM_OK)
			end
		end

	Curl_expire (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_milli: INTEGER_32)
		local
			l_multi: CE_POINTER [PD_CURL_MULTI]
			l_nowp: CE_POINTER [SD_TIMEVAL]
			l_rc: INTEGER_32
			l_list: CE_POINTER [PD_CURL_LLIST]
			l_set: SD_TIMEVAL
			l_rest: INTEGER_32
			l_diff: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_multi.make
			create l_nowp.make
			create l_list.make
			create l_set.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_multi.ce_gets (a_data.item.multi)
					l_nowp.ce_gets (create {CE_POINTER [SD_TIMEVAL]}.make_shared (a_data.c_pointer + {PD_SESSIONHANDLE}.state_offset + {PD_URLSTATE}.expiretime_offset))
					if (l_multi).c_pointer = default_pointer then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						if a_milli.to_boolean then
							l_pos := -1 + 8 -- skip if block
						end
				when 2 then -- if:
						if not ((l_nowp.item.tv_sec).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if not ((l_nowp.item.tv_usec).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						l_list.ce_gets (a_data.item.state.timeoutlist)
						l_rc := splay_inst.Curl_splayremovebyaddr (l_multi.item.timetree, create {CE_POINTER [PD_CURL_TREE]}.make_shared (a_data.c_pointer + {PD_SESSIONHANDLE}.state_offset + {PD_URLSTATE}.timenode_offset), create {CE_POINTER [CE_POINTER [PD_CURL_TREE]]}.make_shared (l_multi.c_pointer + {PD_CURL_MULTI}.timetree_offset))
						if l_rc.to_boolean then
							sendf_inst.Curl_infof ([a_data, ce_string ("Internal error clearing splay node = %%d%N"), l_rc])
						end
						from
						until
							not (l_list.item.size > {NATURAL_32} 0)
						loop
							llist_inst.Curl_llist_remove (l_list, l_list.item.tail, create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
						end
						sendf_inst.Curl_infof ([a_data, ce_string ("Expire cleared%N")])
						l_nowp.item.tv_sec := (0).to_integer_32
						l_nowp.item.tv_usec := (0).to_integer_32
				when 7 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 14
				when 8 then -- else:
						l_set.ce_gets (timeval_inst.curlx_tvnow)
						l_set.tv_sec := l_set.tv_sec + (a_milli // 1000)
						l_set.tv_usec := l_set.tv_usec + ((a_milli \\ 1000) * 1000)
						l_rest := (l_set.tv_usec - 1000000).to_integer_32
						if l_rest > 0 then
							l_set.tv_sec := (l_set.tv_sec) + 1
							l_set.tv_usec := l_set.tv_usec - (1000000)
						end
						if not ((l_nowp.item.tv_sec).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L___0
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if not ((l_nowp.item.tv_usec).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L___0:
						l_diff := (timeval_inst.curlx_tvdiff (l_set, l_nowp.item))
						if l_diff > 0 then
							multi_addtimeout (a_data.item.state.timeoutlist, l_set.address).do_nothing
							js.return
						end
						if not js.return_called then
							multi_addtimeout (a_data.item.state.timeoutlist, l_nowp).do_nothing
							l_rc := splay_inst.Curl_splayremovebyaddr (l_multi.item.timetree, create {CE_POINTER [PD_CURL_TREE]}.make_shared (a_data.c_pointer + {PD_SESSIONHANDLE}.state_offset + {PD_URLSTATE}.timenode_offset), create {CE_POINTER [CE_POINTER [PD_CURL_TREE]]}.make_shared (l_multi.c_pointer + {PD_CURL_MULTI}.timetree_offset))
							if l_rc.to_boolean then
								sendf_inst.Curl_infof ([a_data, ce_string ("Internal error removing splay node = %%d%N"), l_rc])
							end
						end
				when 13 then -- if done
						if not js.return_called then
							l_nowp.item := l_set
							a_data.item.state.timenode.payload := create {CE_POINTER [ANY]}.make_cast (a_data)
							l_multi.item.timetree := splay_inst.Curl_splayinsert (l_nowp.item, l_multi.item.timetree, create {CE_POINTER [PD_CURL_TREE]}.make_shared (a_data.c_pointer + {PD_SESSIONHANDLE}.state_offset + {PD_URLSTATE}.timenode_offset))
						end
				when 14 then -- if done
						if not js.return_called then
						end
				when 15 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	curl_multi_assign (a_multi_handle: CE_POINTER [ANY]; a_s: INTEGER_32; a_hashp: CE_POINTER [ANY]): INTEGER_32
		local
			l_s: INTEGER_32
			l_there: CE_POINTER [PD_CURL_SH_ENTRY]
			l_multi: CE_POINTER [PD_CURL_MULTI]
			js: JUMP_STATE
		do
			create l_there.make
			create l_multi.make

			l_s := a_s
			l_there.ce_gets (create {CE_POINTER [PD_CURL_SH_ENTRY]}.make_shared (default_pointer))
			l_multi.ce_gets (create {CE_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle))
			if l_s /= -1 then
				l_there.ce_gets (create {CE_POINTER [PD_CURL_SH_ENTRY]}.make_cast ((hash_inst.Curl_hash_pick (l_multi.item.sockhash, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared ($l_s))), Integer_32_bytes.to_natural_32))))
			end
			if (l_there).c_pointer = default_pointer then
				Result := ({PC_CURLMCODE}.CURLM_BAD_SOCKET)
				js.return
			end
			if not js.return_called then
				l_there.item.socketp := a_hashp
				Result := ({PC_CURLMCODE}.CURLM_OK)
			end
		end

	multi_connc_remove_handle (a_multi: CE_POINTER [PD_CURL_MULTI]; a_data: CE_POINTER [PD_SESSIONHANDLE])
		local
			l_i: INTEGER_32
			l_conn: CE_POINTER [PD_CONNECTDATA]
		do
			create l_conn.make

			l_i := 0
			from
			until
				not (l_i.to_integer_32 < (a_multi.item.connc).item.num)
			loop
				l_conn.ce_gets ((a_multi.item.connc).item.connects[l_i])
				if ((l_conn).c_pointer /= default_pointer) then
					if ((l_conn.item.data).c_pointer.to_integer_32).to_natural_32 = (a_data.c_pointer.to_integer_32).to_natural_32 then
						if ((l_conn.item.protocol).bit_and (((((((1).bit_shift_left (2))).bit_or (((1).bit_shift_left (12))))).bit_or (((1).bit_shift_left (14)))).to_integer_32)).to_boolean then
							if (add_closure (a_multi, a_data)) = 0 then
								a_data.item.state.shared_conn := create {CE_POINTER [ANY]}.make_cast (a_multi)
							else
								url_inst.Curl_disconnect (l_conn).do_nothing;
								(a_multi.item.connc).item.connects[l_i] := create {CE_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
							end
						else
							l_conn.item.data := create {CE_POINTER [PD_SESSIONHANDLE]}.make_shared (default_pointer)
						end
					end
				end
				l_i := l_i + 1
			end
		end

	add_closure (a_multi: CE_POINTER [PD_CURL_MULTI]; a_data: CE_POINTER [PD_SESSIONHANDLE]): INTEGER_32
		local
			l_cl: CE_POINTER [PD_CLOSURE]
			l_p: CE_POINTER [PD_CLOSURE]
			l_add: BOOLEAN
			l_n: CE_POINTER [PD_CLOSURE]
			l_inuse: BOOLEAN
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			create l_cl.make
			create l_p.make
			create l_n.make

			l_cl.ce_gets (a_multi.item.closure)
			l_p.ce_gets (create {CE_POINTER [PD_CLOSURE]}.make_shared (default_pointer))
			l_add := (1).to_boolean
			from
			until
				not (not js.loop_left and then ((l_cl).c_pointer /= default_pointer))
			loop
				l_inuse := (0).to_boolean
				l_i := 0
				from
				until
					not (not js.loop_left and then (l_i.to_integer_32 < (a_multi.item.connc).item.num))
				loop
					js.reset
					if (((a_multi.item.connc).item.connects[l_i]).c_pointer /= default_pointer) then
						if ((((a_multi.item.connc).item.connects[l_i]).item.data).c_pointer.to_integer_32).to_natural_32 = ((l_cl.item.easy_handle).c_pointer.to_integer_32).to_natural_32 then
							l_inuse := (1).to_boolean
							js.break
						end
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
				js.reset
				l_n.ce_gets (l_cl.item.next)
				if not l_inuse then
					(l_cl.item.easy_handle).item.state.shared_conn := create {CE_POINTER [ANY]}.make_shared (default_pointer)
					if (l_cl.item.easy_handle).item.state.closed then
						sendf_inst.Curl_infof ([a_data, ce_string ("Delayed kill of easy handle %%p%N"), l_cl.item.easy_handle])
						url_inst.Curl_close (l_cl.item.easy_handle).do_nothing
					end
					if ((l_p).c_pointer /= default_pointer) then
						l_p.item.next := l_n
					else
						a_multi.item.closure := l_n
					end
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_cl)])
				else
					if ((l_cl.item.easy_handle).c_pointer.to_integer_32).to_natural_32 = (a_data.c_pointer.to_integer_32).to_natural_32 then
						l_add := (0).to_boolean
					end
					l_p.ce_gets (l_cl)
				end
				l_cl.ce_gets (l_n)
			end
			if l_add then
				l_cl.ce_gets (create {CE_POINTER [PD_CLOSURE]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(1).to_natural_32, {PD_CLOSURE}.sizeof.to_natural_32])))))
				if (l_cl).c_pointer = default_pointer then
					Result := ({PC_CURLMCODE}.CURLM_OUT_OF_MEMORY)
					js.return
				end
				if not js.return_called then
					l_cl.item.easy_handle := a_data
					l_cl.item.next := a_multi.item.closure
					a_multi.item.closure := l_cl
				end
			end
			if not js.return_called then
				Result := ({PC_CURLMCODE}.CURLM_OK)
			end
		end

end
