class
	P_PARSEDATE

inherit
	LIBCURL_DATA
		redefine
			default_create
		end
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create Curl_wkday.make (<<7>>)
			create weekday.make (<<7>>)
			create Curl_month.make (<<12>>)
			create tz.make (<<68>>)
			create month_days_cumulative.make (<<12>>)
		end

feature {ANY} -- attributes

	Curl_wkday: CE_ARRAY [CE_POINTER [INTEGER_8]]

	weekday: CE_ARRAY [CE_POINTER [INTEGER_8]]

	Curl_month: CE_ARRAY [CE_POINTER [INTEGER_8]]

	tz: CE_ARRAY [PD_TZINFO]

	month_days_cumulative: CE_ARRAY [INTEGER_32]

feature {ANY} -- routines

	checkday (a_check: CE_POINTER [INTEGER_8]; a_len: NATURAL_32): INTEGER_32
		local
			l_i: INTEGER_32
			l_what: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_found: BOOLEAN
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_what.make

			l_found := (0).to_boolean
			if a_len > {NATURAL_32} 3 then
				l_what.ce_gets (weekday + 0)
			else
				l_what.ce_gets (Curl_wkday + 0)
			end
			l_i := 0
			from
			until
				not (not js.loop_left and then (l_i < 7))
			loop
				js.reset
				if (rawstr_inst.Curl_raw_equal (a_check, l_what[0])).to_boolean then
					l_found := (1).to_boolean
					js.break
				end
				if not js.loop_jumped then
					l_what.ce_gets (l_what + 1)
					l_i := l_i + 1
				end
			end
			js.reset
			if l_found then
				l_tmp___0 := l_i
			else
				l_tmp___0 := -1
			end
			Result := l_tmp___0
		end

	checkmonth (a_check: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: INTEGER_32
			l_what: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_found: BOOLEAN
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_what.make

			l_found := (0).to_boolean
			l_what.ce_gets (Curl_month + 0)
			l_i := 0
			from
			until
				not (not js.loop_left and then (l_i < 12))
			loop
				js.reset
				if (rawstr_inst.Curl_raw_equal (a_check, l_what[0])).to_boolean then
					l_found := (1).to_boolean
					js.break
				end
				if not js.loop_jumped then
					l_what.ce_gets (l_what + 1)
					l_i := l_i + 1
				end
			end
			js.reset
			if l_found then
				l_tmp___0 := l_i
			else
				l_tmp___0 := -1
			end
			Result := l_tmp___0
		end

	checktz (a_check: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_what: CE_POINTER [PD_TZINFO]
			l_found: BOOLEAN
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_what.make

			l_found := (0).to_boolean
			l_what.ce_gets (tz)
			l_i := {NATURAL_32} 0
			from
			until
				not (not js.loop_left and then (l_i < ({PD_TZINFO}.sizeof.to_natural_32 * (68).to_natural_32) // {PD_TZINFO}.sizeof.to_natural_32))
			loop
				js.reset
				if (rawstr_inst.Curl_raw_equal (a_check, (l_what.item.name))).to_boolean then
					l_found := (1).to_boolean
					js.break
				end
				if not js.loop_jumped then
					l_what.ce_gets (l_what + 1)
					l_i := l_i + 1
				end
			end
			js.reset
			if l_found then
				l_tmp___0 := l_what.item.offset * 60
			else
				l_tmp___0 := -1
			end
			Result := l_tmp___0
		end

	skip (a_date: CE_POINTER [CE_POINTER [INTEGER_8]])
		local
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				if ((a_date.item).item).to_boolean then
					if ((((ctype_b_loc).item[(((a_date.item).item).to_natural_8).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					a_date.item := (a_date.item) + 1
				end
			end
			js.reset
		end

	my_timegm (a_tm: CE_POINTER [PD_MY_TM]): INTEGER_32
		local
			l_month: INTEGER_32
			l_year: INTEGER_32
			l_leap_days: INTEGER_32
			js: JUMP_STATE
		do
			if a_tm.item.tm_year < 70 then
				Result := (-1).to_integer_32
				js.return
			end
			if not js.return_called then
				l_year := a_tm.item.tm_year + 1900
				l_month := a_tm.item.tm_mon
				if l_month < 0 then
					l_year := l_year + ((11 - l_month) // 12)
					l_month := 11 - (11 - l_month) \\ 12
				elseif l_month >= 12 then
					l_year := l_year - (l_month // 12)
					l_month := l_month \\ (12)
				end
				l_leap_days := l_year - (a_tm.item.tm_mon <= 1).to_integer
				l_leap_days := ((((l_leap_days // 4 - l_leap_days // 100) + l_leap_days // 400) - 492) + 19) - 4
				Result := ((((((((l_year - 1970).to_integer_32 * 365 + l_leap_days.to_integer_32) + (month_days_cumulative[l_month]).to_integer_32) + (a_tm.item.tm_mday).to_integer_32) - 1) * 24 + (a_tm.item.tm_hour).to_integer_32) * 60 + (a_tm.item.tm_min).to_integer_32) * 60 + (a_tm.item.tm_sec).to_integer_32)
			end
		end

	Curl_parsedate (a_date: CE_POINTER [INTEGER_8]; a_output: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_date: CE_POINTER [INTEGER_8]
			l_t: INTEGER_32
			l_wdaynum: INTEGER_32
			l_monnum: INTEGER_32
			l_mdaynum: INTEGER_32
			l_hournum: INTEGER_32
			l_minnum: INTEGER_32
			l_secnum: INTEGER_32
			l_yearnum: INTEGER_32
			l_tzoff: INTEGER_32
			l_tm: PD_MY_TM
			l_dignext: INTEGER_32
			l_indate: CE_POINTER [INTEGER_8]
			l_part: INTEGER_32
			l_found: BOOLEAN
			l_buf: CE_ARRAY [INTEGER_8]
			l_len: NATURAL_32
			l_val: INTEGER_32
			l_end: CE_POINTER [INTEGER_8]
			l_delta: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_date.make
			create l_tm.make
			create l_indate.make
			create l_buf.make (<<32>>)
			create l_end.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_date.ce_gets (a_date)
					l_t := (0).to_integer_32
					l_wdaynum := -1
					l_monnum := -1
					l_mdaynum := -1
					l_hournum := -1
					l_minnum := -1
					l_secnum := -1
					l_yearnum := -1
					l_tzoff := -1
					l_dignext := {PC_ASSUME}.DATE_MDAY
					l_indate.ce_gets (l_date)
					l_part := 0
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 25 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if (l_date[0]).to_boolean then
							if not (l_part < 6) then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 24 -- skip if block
						end
				when 3 then -- if:
						l_found := (0).to_boolean
						skip (l_date.address)
						if not (((((ctype_b_loc).item[((l_date[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (1024)).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_buf[0] := (('%/0/').code).to_integer_8
						sscanf ([l_date, ce_string ("%%31[ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz]"), l_buf]).do_nothing
						l_len := strlen (l_buf)
						if l_wdaynum = -1 then
							l_wdaynum := checkday (l_buf, l_len)
							if l_wdaynum /= -1 then
								l_found := (1).to_boolean
							end
						end
						if not l_found then
							if l_monnum = -1 then
								l_monnum := checkmonth (l_buf)
								if l_monnum /= -1 then
									l_found := (1).to_boolean
								end
							end
						end
						if not l_found then
							if l_tzoff = -1 then
								l_tzoff := checktz (l_buf)
								if l_tzoff /= -1 then
									l_found := (1).to_boolean
								end
							end
						end
						if not l_found then
							Result := (-1)
							js.return
						end
						if not js.return_called then
							l_date.ce_gets (l_date + l_len.to_integer_32)
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 6 then -- else:
						if not (((((ctype_b_loc).item[((l_date[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (2048)).to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 7 then -- if:
						if l_secnum /= -1 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if 3 = (sscanf ([l_date, ce_string ("%%02d:%%02d:%%02d"), create {CE_POINTER [INTEGER_32]}.make_shared ($l_hournum), create {CE_POINTER [INTEGER_32]}.make_shared ($l_minnum), create {CE_POINTER [INTEGER_32]}.make_shared ($l_secnum)])) then
							l_date.ce_gets (l_date + (8))
						else
							l_pos := -1 + 10 -- goto _L___1
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 10 then -- else: | _L___1:
						if l_secnum /= -1 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if 2 = (sscanf ([l_date, ce_string ("%%02d:%%02d"), create {CE_POINTER [INTEGER_32]}.make_shared ($l_hournum), create {CE_POINTER [INTEGER_32]}.make_shared ($l_minnum)])) then
							l_date.ce_gets (l_date + (5))
							l_secnum := 0
						else
							l_pos := -1 + 13 -- goto _L___0
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 13 then -- else: | _L___0:
						l_val := (strtol (l_date, (l_end.address), 10)).to_integer_32
						if l_tzoff /= -1 then
							l_pos := -1 + 22 -- skip if block
						end
				when 14 then -- if:
						if l_end.distance (l_date) /= 4 then
							l_pos := -1 + 22 -- skip if block
						end
				when 15 then -- if:
						if not (l_val <= 1400) then
							l_pos := -1 + 22 -- skip if block
						end
				when 16 then -- if:
						if not ((l_indate.c_pointer.to_integer_32).to_natural_32 < (l_date.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 22 -- skip if block
						end
				when 17 then -- if:
						if (l_date[-1]).to_integer_32 /= 43 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 21 -- goto _L
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 20 then -- else:
						if (l_date[-1]).to_integer_32 /= 45 then
							l_pos := -1 + 22 -- skip if block
						end
				when 21 then -- if: | _L:
						l_found := (1).to_boolean
						l_tzoff := ((l_val // 100) * 60 + l_val \\ 100) * 60
						if (l_date[-1]).to_integer_32 = 43 then
							l_tzoff := -l_tzoff
						else
							l_tzoff := l_tzoff
						end
				when 22 then -- if done | if done | if done | if done | if done
						if l_end.distance (l_date) = 8 then
							if l_yearnum = -1 then
								if l_monnum = -1 then
									if l_mdaynum = -1 then
										l_found := (1).to_boolean
										l_yearnum := l_val // 10000
										l_monnum := (l_val \\ 10000) // 100 - 1
										l_mdaynum := l_val \\ 100
									end
								end
							end
						end
						if not l_found then
							if l_dignext.to_natural_32 = {NATURAL_32} 0 then
								if l_mdaynum = -1 then
									if l_val > 0 then
										if l_val < 32 then
											l_mdaynum := l_val
											l_found := (1).to_boolean
										end
									end
									l_dignext := {PC_ASSUME}.DATE_YEAR
								end
							end
						end
						if not l_found then
							if l_dignext.to_natural_32 = {NATURAL_32} 1 then
								if l_yearnum = -1 then
									l_yearnum := l_val
									l_found := (1).to_boolean
									if l_yearnum < 1900 then
										if l_yearnum > 70 then
											l_yearnum := l_yearnum + (1900)
										else
											l_yearnum := l_yearnum + (2000)
										end
									end
									if l_mdaynum = -1 then
										l_dignext := {PC_ASSUME}.DATE_MDAY
									end
								end
							end
						end
						if not l_found then
							Result := (-1)
							js.return
						end
						if not js.return_called then
							l_date.ce_gets (l_end)
						end
				when 23 then -- if done | if done | if done
						if not js.return_called then
							l_part := l_part + 1
						end
				when 24 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 25 then -- loop done
					js.reset
					if not js.return_called then
						if -1 = l_secnum then
							l_hournum := 0
							l_minnum := l_hournum
							l_secnum := l_minnum
						end
						if -1 = l_mdaynum then
							Result := (-1)
							js.return
						elseif -1 = l_monnum then
							Result := (-1)
							js.return
						elseif -1 = l_yearnum then
							Result := (-1)
							js.return
						end
					end
					if not js.return_called and then (l_yearnum > 2037) then
						a_output.item := (2147483647).to_integer_32
						Result := 1
						js.return
					end
					if not js.return_called and then (l_yearnum < 1970) then
						a_output.item := (0).to_integer_32
						Result := 2
						js.return
					end
					if not js.return_called then
						l_tm.tm_sec := l_secnum
						l_tm.tm_min := l_minnum
						l_tm.tm_hour := l_hournum
						l_tm.tm_mday := l_mdaynum
						l_tm.tm_mon := l_monnum
						l_tm.tm_year := l_yearnum - 1900
						l_t := my_timegm (l_tm.address)
						if -1 /= l_t.to_integer_32 then
							if l_tzoff /= -1 then
								l_tmp___4 := l_tzoff
							else
								l_tmp___4 := 0
							end
							l_delta := l_tmp___4.to_integer_32
							if l_delta > 0 then
								if l_t + l_delta < l_t then
									Result := (-1)
									js.return
								end
							end
							if not js.return_called then
								l_t := l_t + l_delta
							end
						end
					end
					if not js.return_called then
						a_output.item := l_t
						Result := 0
					end
				when 26 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	curl_getdate (a_p: CE_POINTER [INTEGER_8]; a_now: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_parsed: INTEGER_32
			l_rc: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_rc := (Curl_parsedate (a_p, create {CE_POINTER [INTEGER_32]}.make_shared ($l_parsed)))
					inspect l_rc -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 1
					else l_pos := -1 + 2
					end
				when 1 then -- switch 1, case 0 | switch 1, case 1 | switch 1, case 2
					Result := l_parsed
					js.return
				when 2 then -- switch 1, done:
					if not js.return_called then
						Result := (-1).to_integer_32
					end
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
