class
	P_PINGPONG

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_pp_state_timeout (a_pp: CE_POINTER [PD_PINGPONG]): INTEGER_32
		local
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_timeout_ms: INTEGER_32
			l_timeout2_ms: INTEGER_32
			l_response_time: INTEGER_32
			l_tmp: INTEGER_32
		do
			create l_conn.make
			create l_data.make

			l_conn.ce_gets (a_pp.item.conn)
			l_data.ce_gets (l_conn.item.data)
			if (l_data.item.set.server_response_timeout).to_boolean then
				l_tmp := l_data.item.set.server_response_timeout
			else
				l_tmp := a_pp.item.response_time
			end
			l_response_time := l_tmp
			l_timeout_ms := l_response_time - (timeval_inst.curlx_tvdiff ((timeval_inst.curlx_tvnow), a_pp.item.response))
			if (l_data.item.set.timeout).to_boolean then
				l_timeout2_ms := l_data.item.set.timeout - (timeval_inst.curlx_tvdiff ((timeval_inst.curlx_tvnow), l_conn.item.now))
				if l_timeout_ms < l_timeout2_ms then
					l_timeout_ms := l_timeout_ms
				else
					l_timeout_ms := l_timeout2_ms
				end
			end
			Result := l_timeout_ms
		end

	Curl_pp_multi_statemach (a_pp: CE_POINTER [PD_PINGPONG]): INTEGER_32
		local
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_sock: INTEGER_32
			l_rc: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_result: INTEGER_32
			l_timeout_ms: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_conn.make
			create l_data.make

			l_conn.ce_gets (a_pp.item.conn)
			l_sock := l_conn.item.sock[0]
			l_data.ce_gets (l_conn.item.data)
			l_result := {PC_CURLCODE}.CURLE_OK
			l_timeout_ms := (Curl_pp_state_timeout (a_pp))
			if l_timeout_ms <= 0 then
				sendf_inst.Curl_failf ([l_data, ce_string ("server response timeout")])
				Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
				js.return
			end
			if not js.return_called then
				if (a_pp.item.sendleft).to_boolean then
					l_tmp___0 := l_sock
				else
					l_tmp___0 := -1
				end
				if (a_pp.item.sendleft).to_boolean then
					l_tmp___1 := -1
				else
					l_tmp___1 := l_sock
				end
				l_rc := select_inst.Curl_socket_ready (l_tmp___1, l_tmp___0, 0)
				if l_rc = -1 then
					sendf_inst.Curl_failf ([l_data, ce_string ("select/poll error")])
					Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
					js.return
				elseif l_rc /= 0 then
					l_result := (a_pp.item.statemach_act).integer_32_item ([l_conn])
				end
			end
			if not js.return_called then
				Result := l_result
			end
		end

	Curl_pp_easy_statemach (a_pp: CE_POINTER [PD_PINGPONG]): INTEGER_32
		local
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_sock: INTEGER_32
			l_rc: INTEGER_32
			l_interval_ms: INTEGER_32
			l_timeout_ms: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_result: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_conn.make
			create l_data.make

			l_conn.ce_gets (a_pp.item.conn)
			l_sock := l_conn.item.sock[0]
			l_timeout_ms := (Curl_pp_state_timeout (a_pp))
			l_data.ce_gets (l_conn.item.data)
			if l_timeout_ms <= 0 then
				sendf_inst.Curl_failf ([l_data, ce_string ("server response timeout")])
				Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
				js.return
			end
			if not js.return_called then
				l_interval_ms := 1000
				if l_timeout_ms < l_interval_ms then
					l_interval_ms := l_timeout_ms
				end
				if (a_pp.item.sendleft).to_boolean then
					l_tmp___0 := l_sock
				else
					l_tmp___0 := -1
				end
				if (a_pp.item.sendleft).to_boolean then
					l_tmp___1 := -1
				else
					l_tmp___1 := l_sock
				end
				l_rc := select_inst.Curl_socket_ready (l_tmp___1, l_tmp___0, l_interval_ms.to_integer_32)
				if (progress_inst.Curl_pgrsUpdate (l_conn)).to_boolean then
					l_result := {PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK
				else
					l_result := speedcheck_inst.Curl_speedcheck (l_data, (timeval_inst.curlx_tvnow))
				end
				if not l_result.to_boolean then
					if l_rc = -1 then
						sendf_inst.Curl_failf ([l_data, ce_string ("select/poll error")])
						l_result := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
					elseif l_rc.to_boolean then
						l_result := (a_pp.item.statemach_act).integer_32_item ([l_conn])
					end
				end
				Result := l_result
			end
		end

	Curl_pp_init (a_pp: CE_POINTER [PD_PINGPONG])
		local
			l_conn: CE_POINTER [PD_CONNECTDATA]
		do
			create l_conn.make

			l_conn.ce_gets (a_pp.item.conn)
			a_pp.item.nread_resp := (0).to_natural_32
			a_pp.item.linestart_resp := (l_conn.item.data).item.state.buffer
			a_pp.item.pending_resp := (1).to_boolean
			a_pp.item.response := timeval_inst.curlx_tvnow
		end

	Curl_pp_vsendf (a_pp: CE_POINTER [PD_PINGPONG]; a_fmt: CE_POINTER [INTEGER_8]; a_args: CE_VA_LIST): INTEGER_32
		local
			l_args: CE_VA_LIST
			l_bytes_written: INTEGER_32
			l_s: CE_ARRAY [INTEGER_8]
			l_write_len: NATURAL_32
			l_sptr: CE_POINTER [INTEGER_8]
			l_res: INTEGER_32
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_tmp___0: NATURAL_32
			js: JUMP_STATE
		do
			create l_s.make (<<1024>>)
			create l_sptr.make
			create l_conn.make
			create l_data.make

			create l_args.make_copy (a_args)
			l_sptr.ce_gets (l_s)
			l_res := {PC_CURLCODE}.CURLE_OK
			l_conn.ce_gets (a_pp.item.conn)
			l_data.ce_gets (l_conn.item.data)
			mprintf_inst.curl_mvsnprintf (l_s, (1021).to_natural_32, a_fmt, l_args).do_nothing
			strcat (l_s, ce_string ("%R%N")).do_nothing
			l_bytes_written := 0
			l_write_len := strlen (l_s)
			Curl_pp_init (a_pp)
			l_res := sendf_inst.Curl_write (l_conn, l_conn.item.sock[0], create {CE_POINTER [ANY]}.make_cast (l_sptr), l_write_len, create {CE_POINTER [INTEGER_32]}.make_shared ($l_bytes_written))
			if {NATURAL_32} 0 /= l_res.to_natural_32 then
				Result := l_res
				js.return
			end
			if not js.return_called then
				if (l_conn.item.data).item.set.verbose then
					sendf_inst.Curl_debug (l_conn.item.data, {PC_CURL_INFOTYPE}.CURLINFO_HEADER_OUT, l_sptr, l_bytes_written.to_natural_32, l_conn).do_nothing
				end
				if l_bytes_written /= l_write_len.to_integer_32 then
					l_write_len := l_write_len - l_bytes_written.to_natural_32
					l_sptr.ce_gets (l_sptr + l_bytes_written)
					a_pp.item.sendthis := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([l_write_len]))))
					if ((a_pp.item.sendthis).c_pointer /= default_pointer) then
						memcpy (create {CE_POINTER [ANY]}.make_cast (a_pp.item.sendthis), create {CE_POINTER [ANY]}.make_cast (l_sptr), l_write_len).do_nothing
						l_tmp___0 := l_write_len
						a_pp.item.sendleft := l_tmp___0
						a_pp.item.sendsize := l_tmp___0
					else
						sendf_inst.Curl_failf ([l_data, ce_string ("out of memory")])
						l_res := {PC_CURLCODE}.CURLE_OUT_OF_MEMORY
					end
				else
					a_pp.item.response := timeval_inst.curlx_tvnow
				end
				Result := l_res
			end
		end

	Curl_pp_sendf (a_args: TUPLE [a_pp: CE_POINTER [PD_PINGPONG]; a_fmt: CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_res: INTEGER_32
			l_ap: CE_VA_LIST
		do
			create l_ap.make (a_args, 3)
			l_res := Curl_pp_vsendf (a_args.a_pp, a_args.a_fmt, l_ap)
			Result := l_res
		end

	Curl_pp_readresp (a_sockfd: INTEGER_32; a_pp: CE_POINTER [PD_PINGPONG]; a_code: CE_POINTER [INTEGER_32]; a_size: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_perline: INTEGER_32
			l_keepon: BOOLEAN
			l_gotbytes: INTEGER_32
			l_ptr: CE_POINTER [INTEGER_8]
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_buf: CE_POINTER [INTEGER_8]
			l_result: INTEGER_32
			l_res: INTEGER_32
			l_i: INTEGER_32
			l_clipamount: INTEGER_32
			l_restart: BOOLEAN
			l_meow: CE_POINTER [INTEGER_8]
			l_n: INTEGER_32
			l_tmp___2: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ptr.make
			create l_conn.make
			create l_data.make
			create l_buf.make
			create l_meow.make
			create l_tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_keepon := (1).to_boolean
					l_conn.ce_gets (a_pp.item.conn)
					l_data.ce_gets (l_conn.item.data)
					l_buf.ce_gets (l_data.item.state.buffer)
					l_result := {PC_CURLCODE}.CURLE_OK
					a_code.item := 0
					a_size.item := (0).to_natural_32
					l_ptr.ce_gets (l_buf + (a_pp.item.nread_resp).to_integer_32)
					l_perline := l_ptr.distance ((a_pp.item.linestart_resp))
					l_keepon := (1).to_boolean
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 21 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if a_pp.item.nread_resp < {NATURAL_32} 16384 then
							if l_keepon then
								if l_result.to_boolean then
									js.break
								end
							else
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 20 -- skip if block
						end
				when 3 then -- if:
						if ((a_pp.item.cache).c_pointer /= default_pointer) then
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_ptr), create {CE_POINTER [ANY]}.make_cast (a_pp.item.cache), a_pp.item.cache_size).do_nothing
							l_gotbytes := (a_pp.item.cache_size).to_integer_32
							easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_pp.item.cache)])
							a_pp.item.cache := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							a_pp.item.cache_size := (0).to_natural_32
						else
							l_res := (sendf_inst.Curl_read (l_conn, a_sockfd, l_ptr, {NATURAL_32} 16384 - a_pp.item.nread_resp, create {CE_POINTER [INTEGER_32]}.make_shared ($l_gotbytes)))
							if l_res = 81 then
								Result := ({PC_CURLCODE}.CURLE_OK)
								js.return
							end
							if not js.return_called and then (0 /= l_res) then
								l_result := l_res
								l_keepon := (0).to_boolean
							end
						end
						if not (not js.return_called and then (l_keepon)) then
							l_pos := -1 + 20 -- skip if block
						end
				when 4 then -- if:
						if not (l_gotbytes <= 0) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_keepon := (0).to_boolean
						l_result := {PC_CURLCODE}.CURLE_RECV_ERROR
						sendf_inst.Curl_failf ([l_data, ce_string ("FTP response reading failed")])
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 7 then -- else:
						l_clipamount := 0
						l_restart := (0).to_boolean
						l_data.item.req.headerbytecount := l_data.item.req.headerbytecount + l_gotbytes.to_integer_32
						a_pp.item.nread_resp := a_pp.item.nread_resp + l_gotbytes.to_natural_32
						l_i := 0
						from
						until
							not (not js.loop_left and then (l_i < l_gotbytes))
						loop
							js.reset
							l_perline := l_perline + 1
							if (l_ptr[0]).to_integer_32 = 10 then
								if l_data.item.set.verbose then
									sendf_inst.Curl_debug (l_data, {PC_CURL_INFOTYPE}.CURLINFO_HEADER_IN, a_pp.item.linestart_resp, l_perline.to_natural_32, l_conn).do_nothing
								end
								l_result := sendf_inst.Curl_client_write (l_conn, (1).bit_shift_left (1), a_pp.item.linestart_resp, l_perline.to_natural_32)
								if l_result.to_boolean then
									Result := l_result
									js.return
								end
								if not js.return_called then
									if ((a_pp.item.endofresp).integer_32_item ([a_pp, a_code])).to_boolean then
										l_meow.ce_gets (a_pp.item.linestart_resp)
										l_n := 0
										from
										until
											not ((l_meow.c_pointer.to_integer_32).to_natural_32 < (l_ptr.c_pointer.to_integer_32).to_natural_32)
										loop
											l_buf[l_n] := l_meow[0]
											l_meow.ce_gets (l_meow + 1)
											l_n := l_n + 1
										end
										l_meow[0] := (0).to_integer_8
										l_keepon := (0).to_boolean
										a_pp.item.linestart_resp := l_ptr + 1
										l_i := l_i + 1
										a_size.item := a_pp.item.nread_resp
										a_pp.item.nread_resp := (0).to_natural_32
										js.break
									end
									if not js.loop_jumped then
										l_perline := 0
										a_pp.item.linestart_resp := l_ptr + 1
									end
								end
							end
							if not js.loop_jumped then
								l_ptr.ce_gets (l_ptr + 1)
								l_i := l_i + 1
							end
						end
						js.reset
						if js.return_called then
							l_pos := -1 + 19 -- skip if block
						end
				when 8 then -- if:
						if l_keepon then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if l_i /= l_gotbytes then
							l_clipamount := l_gotbytes - l_i
							l_restart := (1).to_boolean
						else
							l_pos := -1 + 11 -- goto _L___0
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 11 then -- else: | _L___0:
						if not l_keepon then
							l_pos := -1 + 17 -- skip if block
						end
				when 12 then -- if:
						if l_perline /= l_gotbytes then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if l_gotbytes > 8192 then
							sendf_inst.Curl_infof ([l_data, ce_string ("Excessive server response line length received, %%zd bytes. Stripping%N"), l_gotbytes])
							l_restart := (1).to_boolean
							l_clipamount := 40
						else
							l_pos := -1 + 15 -- goto _L
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else: | _L:
						if a_pp.item.nread_resp > {NATURAL_32} 8192 then
							l_clipamount := l_perline
							l_restart := (1).to_boolean
						end
				when 16 then -- if done | if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						if l_i = l_gotbytes then
							l_restart := (1).to_boolean
						end
				when 18 then -- if done
						if l_clipamount.to_boolean then
							a_pp.item.cache_size := l_clipamount.to_natural_32
							a_pp.item.cache := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([a_pp.item.cache_size]))))
							if ((a_pp.item.cache).c_pointer /= default_pointer) then
								memcpy (create {CE_POINTER [ANY]}.make_cast (a_pp.item.cache), create {CE_POINTER [ANY]}.make_cast (a_pp.item.linestart_resp), a_pp.item.cache_size).do_nothing
							else
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								js.return
							end
						end
				when 19 then -- if done
						if not js.return_called and then l_restart then
							a_pp.item.nread_resp := (0).to_natural_32
							l_tmp___2.ce_gets (l_buf)
							a_pp.item.linestart_resp := l_tmp___2
							l_ptr.ce_gets (l_tmp___2)
							l_perline := 0
						end
				when 20 then -- if done | if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 21 then -- loop done
					js.reset
					if not js.return_called then
						a_pp.item.pending_resp := (0).to_boolean
						Result := l_result
					end
				when 22 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_pp_getsock (a_pp: CE_POINTER [PD_PINGPONG]; a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		local
			l_conn: CE_POINTER [PD_CONNECTDATA]
			js: JUMP_STATE
		do
			create l_conn.make

			l_conn.ce_gets (a_pp.item.conn)
			if not a_numsocks.to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				a_socks[0] := l_conn.item.sock[0]
				if (a_pp.item.sendleft).to_boolean then
					Result := ((1).bit_shift_left (16))
					js.return
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	Curl_pp_flushsend (a_pp: CE_POINTER [PD_PINGPONG]): INTEGER_32
		local
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_written: INTEGER_32
			l_result: INTEGER_32
			l_sock: INTEGER_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_conn.make

			l_conn.ce_gets (a_pp.item.conn)
			l_result := {PC_CURLCODE}.CURLE_OK
			l_sock := l_conn.item.sock[0]
			l_result := sendf_inst.Curl_write (l_conn, l_sock, create {CE_POINTER [ANY]}.make_cast (((a_pp.item.sendthis + (a_pp.item.sendsize).to_integer_32) - (a_pp.item.sendleft).to_integer_32)), a_pp.item.sendleft, create {CE_POINTER [INTEGER_32]}.make_shared ($l_written))
			if l_result.to_boolean then
				Result := l_result
				js.return
			end
			if not js.return_called then
				if l_written /= (a_pp.item.sendleft).to_integer_32 then
					a_pp.item.sendleft := a_pp.item.sendleft - l_written.to_natural_32
				else
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_pp.item.sendthis)])
					a_pp.item.sendthis := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_tmp := (0).to_natural_32
					a_pp.item.sendsize := l_tmp
					a_pp.item.sendleft := l_tmp
					a_pp.item.response := timeval_inst.curlx_tvnow
				end
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	Curl_pp_disconnect (a_pp: CE_POINTER [PD_PINGPONG]): INTEGER_32
		do
			if ((a_pp.item.cache).c_pointer /= default_pointer) then
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (a_pp.item.cache)])
				a_pp.item.cache := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			end
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

end
