class
	P_PROGRESS

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	time2str (a_r: CE_POINTER [INTEGER_8]; a_seconds: INTEGER_64)
		local
			l_d: INTEGER_64
			l_h: INTEGER_64
			l_m: INTEGER_64
			l_s: INTEGER_64
			js: JUMP_STATE
		do
			if a_seconds <= {INTEGER_64} 0 then
				strcpy (a_r, ce_string ("--:--:--")).do_nothing
				js.return
			end
			if not js.return_called then
				l_h := a_seconds // {INTEGER_64} 3600
				if l_h <= {INTEGER_64} 99 then
					l_m := (a_seconds - l_h * {INTEGER_64} 3600) // {INTEGER_64} 60
					l_s := (a_seconds - l_h * {INTEGER_64} 3600) - l_m * {INTEGER_64} 60
					mprintf_inst.curl_msnprintf ([a_r, (9).to_natural_32, ce_string ("%%2lld:%%02lld:%%02lld"), l_h, l_m, l_s]).do_nothing
				else
					l_d := a_seconds // {INTEGER_64} 86400
					l_h := (a_seconds - l_d * {INTEGER_64} 86400) // {INTEGER_64} 3600
					if l_d <= {INTEGER_64} 999 then
						mprintf_inst.curl_msnprintf ([a_r, (9).to_natural_32, ce_string ("%%3lldd %%02lldh"), l_d, l_h]).do_nothing
					else
						mprintf_inst.curl_msnprintf ([a_r, (9).to_natural_32, ce_string ("%%7lldd"), l_d]).do_nothing
					end
				end
			end
		end

	max5data (a_bytes: INTEGER_64; a_max5: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			if a_bytes < {INTEGER_64} 100000 then
				mprintf_inst.curl_msnprintf ([a_max5, (6).to_natural_32, ce_string ("%%5lld"), a_bytes]).do_nothing
			elseif a_bytes < {INTEGER_64} 10240000 then
				mprintf_inst.curl_msnprintf ([a_max5, (6).to_natural_32, ce_string ("%%4lldk"), a_bytes // {INTEGER_64} 1024]).do_nothing
			elseif a_bytes < {INTEGER_64} 104857600 then
				mprintf_inst.curl_msnprintf ([a_max5, (6).to_natural_32, ce_string ("%%2lld.%%0lldM"), a_bytes // {INTEGER_64} 1048576, (a_bytes \\ {INTEGER_64} 1048576) // {INTEGER_64} 104857]).do_nothing
			elseif a_bytes < {INTEGER_64} 10485760000 then
				mprintf_inst.curl_msnprintf ([a_max5, (6).to_natural_32, ce_string ("%%4lldM"), a_bytes // {INTEGER_64} 1048576]).do_nothing
			elseif a_bytes < {INTEGER_64} 107374182400 then
				mprintf_inst.curl_msnprintf ([a_max5, (6).to_natural_32, ce_string ("%%2lld.%%0lldG"), a_bytes // {INTEGER_64} 1073741824, (a_bytes \\ {INTEGER_64} 1073741824) // {INTEGER_64} 107374182]).do_nothing
			elseif a_bytes < {INTEGER_64} 10737418240000 then
				mprintf_inst.curl_msnprintf ([a_max5, (6).to_natural_32, ce_string ("%%4lldG"), a_bytes // {INTEGER_64} 1073741824]).do_nothing
			elseif a_bytes < {INTEGER_64} 10995116277760000 then
				mprintf_inst.curl_msnprintf ([a_max5, (6).to_natural_32, ce_string ("%%4lldT"), a_bytes // {INTEGER_64} 1099511627776]).do_nothing
			else
				mprintf_inst.curl_msnprintf ([a_max5, (6).to_natural_32, ce_string ("%%4lldP"), a_bytes // {INTEGER_64} 1125899906842624]).do_nothing
			end
			Result := a_max5
		end

	Curl_pgrsDone (a_conn: CE_POINTER [PD_CONNECTDATA])
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			create l_data.make

			l_data.ce_gets (a_conn.item.data)
			l_data.item.progress.lastshow := 0
			Curl_pgrsUpdate (a_conn).do_nothing
			l_data.item.progress.speeder_c := 0
		end

	Curl_pgrsResetTimes (a_data: CE_POINTER [PD_SESSIONHANDLE])
		do
			a_data.item.progress.t_nslookup := 0.0
			a_data.item.progress.t_connect := 0.0
			a_data.item.progress.t_pretransfer := 0.0
			a_data.item.progress.t_starttransfer := 0.0
		end

	Curl_pgrsTime (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_timer: INTEGER_32)
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_timer -- switch 1 head
					when 7 then l_pos := -1 + 2
					when 1 then l_pos := -1 + 3
					when 2 then l_pos := -1 + 4
					when 3 then l_pos := -1 + 5
					when 4 then l_pos := -1 + 6
					when 5 then l_pos := -1 + 7
					when 6 then l_pos := -1 + 8
					when 8 then l_pos := -1 + 9
					else l_pos := -1 + 1
					end
				when 1 then -- switch 1, default:
					l_pos := -1 + 10 -- switch 1; break
				when 2 then -- switch 1, case 7
					a_data.item.progress.t_startsingle := timeval_inst.curlx_tvnow
					l_pos := -1 + 10 -- switch 1; break
				when 3 then -- switch 1, case 1
					a_data.item.progress.t_nslookup := timeval_inst.curlx_tvdiff_secs ((timeval_inst.curlx_tvnow), a_data.item.progress.t_startsingle)
					l_pos := -1 + 10 -- switch 1; break
				when 4 then -- switch 1, case 2
					a_data.item.progress.t_connect := timeval_inst.curlx_tvdiff_secs ((timeval_inst.curlx_tvnow), a_data.item.progress.t_startsingle)
					l_pos := -1 + 10 -- switch 1; break
				when 5 then -- switch 1, case 3
					a_data.item.progress.t_appconnect := timeval_inst.curlx_tvdiff_secs ((timeval_inst.curlx_tvnow), a_data.item.progress.t_startsingle)
					l_pos := -1 + 10 -- switch 1; break
				when 6 then -- switch 1, case 4
					a_data.item.progress.t_pretransfer := timeval_inst.curlx_tvdiff_secs ((timeval_inst.curlx_tvnow), a_data.item.progress.t_startsingle)
					l_pos := -1 + 10 -- switch 1; break
				when 7 then -- switch 1, case 5
					a_data.item.progress.t_starttransfer := timeval_inst.curlx_tvdiff_secs ((timeval_inst.curlx_tvnow), a_data.item.progress.t_startsingle)
					l_pos := -1 + 10 -- switch 1; break
				when 8 then -- switch 1, case 6
					l_pos := -1 + 10 -- switch 1; break
				when 9 then -- switch 1, case 8
					a_data.item.progress.t_redirect := timeval_inst.curlx_tvdiff_secs ((timeval_inst.curlx_tvnow), a_data.item.progress.start)
					l_pos := -1 + 10 -- switch 1; break
				when 10 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_pgrsStartNow (a_data: CE_POINTER [PD_SESSIONHANDLE])
		do
			a_data.item.progress.speeder_c := 0
			a_data.item.progress.start := timeval_inst.curlx_tvnow
		end

	Curl_pgrsSetDownloadCounter (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_size: INTEGER_64)
		do
			a_data.item.progress.downloaded := a_size
		end

	Curl_pgrsSetUploadCounter (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_size: INTEGER_64)
		do
			a_data.item.progress.uploaded := a_size
		end

	Curl_pgrsSetDownloadSize (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_size: INTEGER_64)
		do
			a_data.item.progress.size_dl := a_size
			if a_size >= {INTEGER_64} 0 then
				a_data.item.progress.flags := (a_data.item.progress.flags).bit_or (((1).bit_shift_left (6)))
			else
				a_data.item.progress.flags := (a_data.item.progress.flags).bit_and (((((1).bit_shift_left (6))).bit_not))
			end
		end

	Curl_pgrsSetUploadSize (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_size: INTEGER_64)
		do
			a_data.item.progress.size_ul := a_size
			if a_size >= {INTEGER_64} 0 then
				a_data.item.progress.flags := (a_data.item.progress.flags).bit_or (((1).bit_shift_left (5)))
			else
				a_data.item.progress.flags := (a_data.item.progress.flags).bit_and (((((1).bit_shift_left (5))).bit_not))
			end
		end

	Curl_pgrsUpdate (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_now: SD_TIMEVAL
			l_result: INTEGER_32
			l_max5: CE_ARRAY [CE_ARRAY [INTEGER_8]]
			l_dlpercen: INTEGER_64
			l_ulpercen: INTEGER_64
			l_total_percen: INTEGER_64
			l_total_transfer: INTEGER_64
			l_total_expected_transfer: INTEGER_64
			l_timespent: INTEGER_64
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_nowindex: INTEGER_32
			l_checkindex: INTEGER_32
			l_countindex: INTEGER_32
			l_time_left: CE_ARRAY [INTEGER_8]
			l_time_total: CE_ARRAY [INTEGER_8]
			l_time_spent: CE_ARRAY [INTEGER_8]
			l_ulestimate: INTEGER_64
			l_dlestimate: INTEGER_64
			l_total_estimate: INTEGER_64
			l_shownow: BOOLEAN
			l_tmp: REAL_64
			l_tmp___0: REAL_64
			l_tmp___1: INTEGER_32
			l_span_ms: INTEGER_32
			l_amount: INTEGER_64
			l_tmp___2: INTEGER_64
			l_tmp___3: INTEGER_64
			l_tmp___4: INTEGER_64
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_now.make
			create l_max5.make (<<6, 10>>)
			create l_data.make
			create l_time_left.make (<<10>>)
			create l_time_total.make (<<10>>)
			create l_time_spent.make (<<10>>)
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___7.make
			create l_tmp___8.make
			create l_tmp___9.make

			l_dlpercen := (0).to_integer_64
			l_ulpercen := (0).to_integer_64
			l_total_percen := (0).to_integer_64
			l_data.ce_gets (a_conn.item.data)
			l_nowindex := l_data.item.progress.speeder_c \\ 6
			l_ulestimate := (0).to_integer_64
			l_dlestimate := (0).to_integer_64
			l_shownow := (0).to_boolean
			l_now.ce_gets (timeval_inst.curlx_tvnow)
			l_data.item.progress.timespent := (l_now.tv_sec - l_data.item.progress.start.tv_sec).to_double + (l_now.tv_usec - l_data.item.progress.start.tv_usec).to_double / 1000000.0
			l_timespent := (l_data.item.progress.timespent).truncated_to_integer_64
			if l_data.item.progress.timespent > (0).to_double then
				l_tmp := l_data.item.progress.timespent
			else
				l_tmp := (1).to_double
			end
			l_data.item.progress.dlspeed := ((l_data.item.progress.downloaded).to_double / l_tmp).truncated_to_integer_64
			if l_data.item.progress.timespent > (0).to_double then
				l_tmp___0 := l_data.item.progress.timespent
			else
				l_tmp___0 := (1).to_double
			end
			l_data.item.progress.ulspeed := ((l_data.item.progress.uploaded).to_double / l_tmp___0).truncated_to_integer_64
			if l_data.item.progress.lastshow /= l_now.tv_sec then
				l_shownow := (1).to_boolean
				l_data.item.progress.lastshow := l_now.tv_sec
				if l_data.item.progress.downloaded > l_data.item.progress.uploaded then
					l_data.item.progress.speeder[l_nowindex] := l_data.item.progress.downloaded
				else
					l_data.item.progress.speeder[l_nowindex] := l_data.item.progress.uploaded
				end
				l_data.item.progress.speeder_time[l_nowindex] := l_now
				l_data.item.progress.speeder_c := (l_data.item.progress.speeder_c) + 1
				if l_data.item.progress.speeder_c >= 6 then
					l_tmp___1 := 6
				else
					l_tmp___1 := l_data.item.progress.speeder_c
				end
				l_countindex := l_tmp___1 - 1
				if l_countindex.to_boolean then
					if l_data.item.progress.speeder_c >= 6 then
						l_checkindex := l_data.item.progress.speeder_c \\ 6
					else
						l_checkindex := 0
					end
					l_span_ms := timeval_inst.curlx_tvdiff (l_now, l_data.item.progress.speeder_time[l_checkindex])
					if 0 = l_span_ms then
						l_span_ms := 1
					end
					l_amount := l_data.item.progress.speeder[l_nowindex] - l_data.item.progress.speeder[l_checkindex]
					if l_amount > {INTEGER_64} 4294967 then
						l_data.item.progress.current_speed := (l_amount.to_double / (l_span_ms.to_double / 1000.0)).truncated_to_integer_64
					else
						l_data.item.progress.current_speed := (l_amount * {INTEGER_64} 1000) // l_span_ms.to_integer_64
					end
				elseif l_data.item.progress.ulspeed > l_data.item.progress.dlspeed then
					l_data.item.progress.current_speed := l_data.item.progress.ulspeed
				else
					l_data.item.progress.current_speed := l_data.item.progress.dlspeed
				end
			end
			if not ((l_data.item.progress.flags).bit_and (((1).bit_shift_left (4)))).to_boolean then
				if ((l_data.item.set.fprogress).c_pointer /= default_pointer) then
					l_result := (l_data.item.set.fprogress).integer_32_item ([l_data.item.set.progress_client, (l_data.item.progress.size_dl).to_double, (l_data.item.progress.downloaded).to_double, (l_data.item.progress.size_ul).to_double, (l_data.item.progress.uploaded).to_double])
					if l_result.to_boolean then
						sendf_inst.Curl_failf ([l_data, ce_string ("Callback aborted")])
					end
					Result := l_result
					js.return
				end
				if not js.return_called and then (not l_shownow) then
					Result := 0
					js.return
				end
				if not js.return_called then
					if not ((l_data.item.progress.flags).bit_and (((1).bit_shift_left (7)))).to_boolean then
						if (l_data.item.state.resume_from).to_boolean then
							mprintf_inst.curl_mfprintf ([l_data.item.set.err, ce_string ("** Resuming transfer from byte position %%lld%N"), l_data.item.state.resume_from]).do_nothing
						end
						mprintf_inst.curl_mfprintf ([l_data.item.set.err, ce_string ("  %%%% Total    %%%% Received %%%% Xferd  Average Speed   Time    Time     Time  Current%N                                 Dload  Upload   Total   Spent    Left  Speed%N")]).do_nothing
						l_data.item.progress.flags := (l_data.item.progress.flags).bit_or (((1).bit_shift_left (7)))
					end
					if ((l_data.item.progress.flags).bit_and (((1).bit_shift_left (5)))).to_boolean then
						if l_data.item.progress.ulspeed > {INTEGER_64} 0 then
							l_ulestimate := l_data.item.progress.size_ul // l_data.item.progress.ulspeed
							if l_data.item.progress.size_ul > {INTEGER_64} 10000 then
								l_ulpercen := l_data.item.progress.uploaded // (l_data.item.progress.size_ul // {INTEGER_64} 100)
							elseif l_data.item.progress.size_ul > {INTEGER_64} 0 then
								l_ulpercen := (l_data.item.progress.uploaded * {INTEGER_64} 100) // l_data.item.progress.size_ul
							end
						end
					end
					if ((l_data.item.progress.flags).bit_and (((1).bit_shift_left (6)))).to_boolean then
						if l_data.item.progress.dlspeed > {INTEGER_64} 0 then
							l_dlestimate := l_data.item.progress.size_dl // l_data.item.progress.dlspeed
							if l_data.item.progress.size_dl > {INTEGER_64} 10000 then
								l_dlpercen := l_data.item.progress.downloaded // (l_data.item.progress.size_dl // {INTEGER_64} 100)
							elseif l_data.item.progress.size_dl > {INTEGER_64} 0 then
								l_dlpercen := (l_data.item.progress.downloaded * {INTEGER_64} 100) // l_data.item.progress.size_dl
							end
						end
					end
					if l_ulestimate > l_dlestimate then
						l_total_estimate := l_ulestimate
					else
						l_total_estimate := l_dlestimate
					end
					if l_total_estimate > {INTEGER_64} 0 then
						l_tmp___2 := l_total_estimate - l_timespent
					else
						l_tmp___2 := (0).to_integer_64
					end
					time2str (l_time_left, l_tmp___2)
					time2str (l_time_total, l_total_estimate)
					time2str (l_time_spent, l_timespent)
					if ((l_data.item.progress.flags).bit_and (((1).bit_shift_left (5)))).to_boolean then
						l_tmp___3 := l_data.item.progress.size_ul
					else
						l_tmp___3 := l_data.item.progress.uploaded
					end
					if ((l_data.item.progress.flags).bit_and (((1).bit_shift_left (6)))).to_boolean then
						l_tmp___4 := l_data.item.progress.size_dl
					else
						l_tmp___4 := l_data.item.progress.downloaded
					end
					l_total_expected_transfer := l_tmp___3 + l_tmp___4
					l_total_transfer := l_data.item.progress.downloaded + l_data.item.progress.uploaded
					if l_total_expected_transfer > {INTEGER_64} 10000 then
						l_total_percen := l_total_transfer // (l_total_expected_transfer // {INTEGER_64} 100)
					elseif l_total_expected_transfer > {INTEGER_64} 0 then
						l_total_percen := (l_total_transfer * {INTEGER_64} 100) // l_total_expected_transfer
					end
					l_tmp___5.ce_gets (max5data (l_data.item.progress.current_speed, l_max5[5]))
					l_tmp___6.ce_gets (max5data (l_data.item.progress.ulspeed, l_max5[4]))
					l_tmp___7.ce_gets (max5data (l_data.item.progress.dlspeed, l_max5[3]))
					l_tmp___8.ce_gets (max5data (l_data.item.progress.uploaded, l_max5[1]))
					l_tmp___9.ce_gets (max5data (l_data.item.progress.downloaded, l_max5[0]))
					mprintf_inst.curl_mfprintf ([l_data.item.set.err, ce_string ("%R%%3lld %%s  %%3lld %%s  %%3lld %%s  %%s  %%s %%s %%s %%s %%s"), l_total_percen, (max5data (l_total_expected_transfer, l_max5[2])), l_dlpercen, l_tmp___9, l_ulpercen, l_tmp___8, l_tmp___7, l_tmp___6, l_time_total, l_time_spent, l_time_left, l_tmp___5]).do_nothing
					fflush (l_data.item.set.err).do_nothing
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

end
