class
	P_SPEEDCHECK

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_speedinit (a_data: CE_POINTER [PD_SESSIONHANDLE])
		do
			memset (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [SD_TIMEVAL]}.make_shared (a_data.c_pointer + {PD_SESSIONHANDLE}.state_offset + {PD_URLSTATE}.keeps_speed_offset))), 0, {SD_TIMEVAL}.sizeof.to_natural_32).do_nothing
		end

	Curl_speedcheck (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_now: SD_TIMEVAL): INTEGER_32
		local
			l_howlong: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_data.item.progress.current_speed >= {INTEGER_64} 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (a_data.item.set.low_speed_time).to_boolean then
							if (timeval_inst.Curl_tvlong (a_data.item.state.keeps_speed)) /= 0 then
								if a_data.item.progress.current_speed < (a_data.item.set.low_speed_limit).to_integer_64 then
									l_howlong := (timeval_inst.curlx_tvdiff (a_now, a_data.item.state.keeps_speed))
									if l_howlong // 1000 > a_data.item.set.low_speed_time then
										sendf_inst.Curl_failf ([a_data, ce_string ("Operation too slow. Less than %%ld bytes/sec transfered the last %%ld seconds"), a_data.item.set.low_speed_limit, a_data.item.set.low_speed_time])
										Result := ({PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT)
										js.return
									end
									if not js.return_called then
										multi_inst.Curl_expire (a_data, l_howlong)
									end
								else
									l_pos := -1 + 3 -- goto _L___1
								end
							else
								l_pos := -1 + 3 -- goto _L___1
							end
						else
							l_pos := -1 + 3 -- goto _L___1
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___1:
						a_data.item.state.keeps_speed := a_now
						if (a_data.item.set.low_speed_limit).to_boolean then
							multi_inst.Curl_expire (a_data, a_data.item.set.low_speed_time * 1000)
						end
				when 4 then
					if not js.return_called then
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
