class
	P_SPLAY

inherit
	LIBCURL_DATA
		redefine
			default_create
		end
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create KEY_NOTUSED.make
			create KEY_NOTUSED___0.make
		end

feature {ANY} -- attributes

	KEY_NOTUSED: SD_TIMEVAL

	KEY_NOTUSED___0: SD_TIMEVAL

feature {ANY} -- routines

	Curl_splay (a_i: SD_TIMEVAL; a_t: CE_POINTER [PD_CURL_TREE]): CE_POINTER [PD_CURL_TREE]
		local
			l_t: CE_POINTER [PD_CURL_TREE]
			l_N: PD_CURL_TREE
			l_l: CE_POINTER [PD_CURL_TREE]
			l_r: CE_POINTER [PD_CURL_TREE]
			l_y: CE_POINTER [PD_CURL_TREE]
			l_comp: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			js: JUMP_STATE
		do
			create l_t.make
			create l_N.make
			create l_l.make
			create l_r.make
			create l_y.make

			l_t.ce_gets (a_t)
			if (l_t.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := l_t
				js.return
			end
			if not js.return_called then
				l_N.larger := create {CE_POINTER [PD_CURL_TREE]}.make_shared (default_pointer)
				l_N.smaller := l_N.larger
				l_r.ce_gets (l_N.address)
				l_l.ce_gets (l_r)
				from
				until
					js.loop_left
				loop
					js.reset
					if a_i.tv_sec < l_t.item.key.tv_sec then
						l_comp := -1
					else
						if a_i.tv_sec > l_t.item.key.tv_sec then
							l_tmp___1 := 1
						else
							if a_i.tv_usec < l_t.item.key.tv_usec then
								l_tmp___0 := -1
							else
								if a_i.tv_usec > l_t.item.key.tv_usec then
									l_tmp := 1
								else
									l_tmp := 0
								end
								l_tmp___0 := l_tmp
							end
							l_tmp___1 := l_tmp___0
						end
						l_comp := l_tmp___1.to_integer_32
					end
					if l_comp < 0 then
						if ((l_t.item.smaller).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						end
						if not js.loop_jumped then
							if a_i.tv_sec < (l_t.item.smaller).item.key.tv_sec then
								l_tmp___5 := -1
							else
								if a_i.tv_sec > (l_t.item.smaller).item.key.tv_sec then
									l_tmp___4 := 1
								else
									if a_i.tv_usec < (l_t.item.smaller).item.key.tv_usec then
										l_tmp___3 := -1
									else
										if a_i.tv_usec > (l_t.item.smaller).item.key.tv_usec then
											l_tmp___2 := 1
										else
											l_tmp___2 := 0
										end
										l_tmp___3 := l_tmp___2
									end
									l_tmp___4 := l_tmp___3
								end
								l_tmp___5 := l_tmp___4
							end
							if l_tmp___5 < 0 then
								l_y.ce_gets (l_t.item.smaller)
								l_t.item.smaller := l_y.item.larger
								l_y.item.larger := l_t
								l_t.ce_gets (l_y)
								if ((l_t.item.smaller).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									js.break
								end
							end
						end
						if not js.loop_jumped then
							l_r.item.smaller := l_t
							l_r.ce_gets (l_t)
							l_t.ce_gets (l_t.item.smaller)
						end
					elseif l_comp > 0 then
						if ((l_t.item.larger).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						end
						if not js.loop_jumped then
							if a_i.tv_sec < (l_t.item.larger).item.key.tv_sec then
								l_tmp___9 := -1
							else
								if a_i.tv_sec > (l_t.item.larger).item.key.tv_sec then
									l_tmp___8 := 1
								else
									if a_i.tv_usec < (l_t.item.larger).item.key.tv_usec then
										l_tmp___7 := -1
									else
										if a_i.tv_usec > (l_t.item.larger).item.key.tv_usec then
											l_tmp___6 := 1
										else
											l_tmp___6 := 0
										end
										l_tmp___7 := l_tmp___6
									end
									l_tmp___8 := l_tmp___7
								end
								l_tmp___9 := l_tmp___8
							end
							if l_tmp___9 > 0 then
								l_y.ce_gets (l_t.item.larger)
								l_t.item.larger := l_y.item.smaller
								l_y.item.smaller := l_t
								l_t.ce_gets (l_y)
								if ((l_t.item.larger).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									js.break
								end
							end
						end
						if not js.loop_jumped then
							l_l.item.larger := l_t
							l_l.ce_gets (l_t)
							l_t.ce_gets (l_t.item.larger)
						end
					else
						js.break
					end
				end
				js.reset
				l_l.item.larger := l_t.item.smaller
				l_r.item.smaller := l_t.item.larger
				l_t.item.smaller := l_N.larger
				l_t.item.larger := l_N.smaller
				Result := l_t
			end
		end

	Curl_splayinsert (a_i: SD_TIMEVAL; a_t: CE_POINTER [PD_CURL_TREE]; a_node: CE_POINTER [PD_CURL_TREE]): CE_POINTER [PD_CURL_TREE]
		local
			l_t: CE_POINTER [PD_CURL_TREE]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: CE_POINTER [PD_CURL_TREE]
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			js: JUMP_STATE
		do
			create l_t.make
			create l_tmp___3.make

			l_t.ce_gets (a_t)
			if (a_node.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := l_t
				js.return
			end
			if not js.return_called and then ((l_t.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32) then
				l_t.ce_gets (Curl_splay (a_i, l_t))
				if a_i.tv_sec < l_t.item.key.tv_sec then
					l_tmp___2 := -1
				else
					if a_i.tv_sec > l_t.item.key.tv_sec then
						l_tmp___1 := 1
					else
						if a_i.tv_usec < l_t.item.key.tv_usec then
							l_tmp___0 := -1
						else
							if a_i.tv_usec > l_t.item.key.tv_usec then
								l_tmp := 1
							else
								l_tmp := 0
							end
							l_tmp___0 := l_tmp
						end
						l_tmp___1 := l_tmp___0
					end
					l_tmp___2 := l_tmp___1
				end
				if l_tmp___2 = 0 then
					a_node.item.same := l_t
					a_node.item.key := a_i
					a_node.item.smaller := l_t.item.smaller
					a_node.item.larger := l_t.item.larger
					l_t.item.smaller := a_node
					l_t.item.key := KEY_NOTUSED
					Result := a_node
					js.return
				end
			end
			if not js.return_called then
				if (l_t.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_tmp___3.ce_gets (create {CE_POINTER [PD_CURL_TREE]}.make_shared (default_pointer))
					a_node.item.larger := l_tmp___3
					a_node.item.smaller := l_tmp___3
				else
					if a_i.tv_sec < l_t.item.key.tv_sec then
						l_tmp___7 := -1
					else
						if a_i.tv_sec > l_t.item.key.tv_sec then
							l_tmp___6 := 1
						else
							if a_i.tv_usec < l_t.item.key.tv_usec then
								l_tmp___5 := -1
							else
								if a_i.tv_usec > l_t.item.key.tv_usec then
									l_tmp___4 := 1
								else
									l_tmp___4 := 0
								end
								l_tmp___5 := l_tmp___4
							end
							l_tmp___6 := l_tmp___5
						end
						l_tmp___7 := l_tmp___6
					end
					if l_tmp___7 < 0 then
						a_node.item.smaller := l_t.item.smaller
						a_node.item.larger := l_t
						l_t.item.smaller := create {CE_POINTER [PD_CURL_TREE]}.make_shared (default_pointer)
					else
						a_node.item.larger := l_t.item.larger
						a_node.item.smaller := l_t
						l_t.item.larger := create {CE_POINTER [PD_CURL_TREE]}.make_shared (default_pointer)
					end
				end
				a_node.item.key := a_i
				a_node.item.same := create {CE_POINTER [PD_CURL_TREE]}.make_shared (default_pointer)
				Result := a_node
			end
		end

	Curl_splaygetbest (a_i: SD_TIMEVAL; a_t: CE_POINTER [PD_CURL_TREE]; a_removed: CE_POINTER [CE_POINTER [PD_CURL_TREE]]): CE_POINTER [PD_CURL_TREE]
		local
			l_t: CE_POINTER [PD_CURL_TREE]
			l_x: CE_POINTER [PD_CURL_TREE]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			js: JUMP_STATE
		do
			create l_t.make
			create l_x.make

			l_t.ce_gets (a_t)
			if (l_t).c_pointer = default_pointer then
				a_removed.item := create {CE_POINTER [PD_CURL_TREE]}.make_shared (default_pointer)
				Result := (create {CE_POINTER [PD_CURL_TREE]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_t.ce_gets (Curl_splay (a_i, l_t))
				if a_i.tv_sec < l_t.item.key.tv_sec then
					l_tmp___2 := -1
				else
					if a_i.tv_sec > l_t.item.key.tv_sec then
						l_tmp___1 := 1
					else
						if a_i.tv_usec < l_t.item.key.tv_usec then
							l_tmp___0 := -1
						else
							if a_i.tv_usec > l_t.item.key.tv_usec then
								l_tmp := 1
							else
								l_tmp := 0
							end
							l_tmp___0 := l_tmp
						end
						l_tmp___1 := l_tmp___0
					end
					l_tmp___2 := l_tmp___1
				end
				if l_tmp___2 < 0 then
					if ((l_t.item.smaller).c_pointer /= default_pointer) then
						l_t.ce_gets (Curl_splay ((l_t.item.smaller).item.key, l_t))
					else
						a_removed.item := create {CE_POINTER [PD_CURL_TREE]}.make_shared (default_pointer)
						Result := l_t
						js.return
					end
				end
			end
			if not js.return_called then
				if a_i.tv_sec < l_t.item.key.tv_sec then
					l_tmp___6 := -1
				else
					if a_i.tv_sec > l_t.item.key.tv_sec then
						l_tmp___5 := 1
					else
						if a_i.tv_usec < l_t.item.key.tv_usec then
							l_tmp___4 := -1
						else
							if a_i.tv_usec > l_t.item.key.tv_usec then
								l_tmp___3 := 1
							else
								l_tmp___3 := 0
							end
							l_tmp___4 := l_tmp___3
						end
						l_tmp___5 := l_tmp___4
					end
					l_tmp___6 := l_tmp___5
				end
				if l_tmp___6 >= 0 then
					l_x.ce_gets (l_t.item.same)
					if ((l_x).c_pointer /= default_pointer) then
						l_x.item.key := l_t.item.key
						l_x.item.larger := l_t.item.larger
						l_x.item.smaller := l_t.item.smaller
						a_removed.item := l_t
						Result := l_x
						js.return
					end
					if not js.return_called then
						if ((l_t.item.smaller).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_x.ce_gets (l_t.item.larger)
						else
							l_x.ce_gets (Curl_splay (a_i, l_t.item.smaller))
							l_x.item.larger := l_t.item.larger
						end
						a_removed.item := l_t
						Result := l_x
					end
				else
					a_removed.item := create {CE_POINTER [PD_CURL_TREE]}.make_shared (default_pointer)
					Result := l_t
				end
			end
		end

	Curl_splayremovebyaddr (a_t: CE_POINTER [PD_CURL_TREE]; a_removenode: CE_POINTER [PD_CURL_TREE]; a_newroot: CE_POINTER [CE_POINTER [PD_CURL_TREE]]): INTEGER_32
		local
			l_t: CE_POINTER [PD_CURL_TREE]
			l_x: CE_POINTER [PD_CURL_TREE]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_t.make
			create l_x.make

			l_t.ce_gets (a_t)
			if (l_t).c_pointer = default_pointer then
				Result := 1
				js.return
			elseif (a_removenode).c_pointer = default_pointer then
				Result := 1
				js.return
			end
			if not js.return_called then
				if KEY_NOTUSED___0.tv_sec < a_removenode.item.key.tv_sec then
					l_tmp___2 := -1
				else
					if KEY_NOTUSED___0.tv_sec > a_removenode.item.key.tv_sec then
						l_tmp___1 := 1
					else
						if KEY_NOTUSED___0.tv_usec < a_removenode.item.key.tv_usec then
							l_tmp___0 := -1
						else
							if KEY_NOTUSED___0.tv_usec > a_removenode.item.key.tv_usec then
								l_tmp := 1
							else
								l_tmp := 0
							end
							l_tmp___0 := l_tmp
						end
						l_tmp___1 := l_tmp___0
					end
					l_tmp___2 := l_tmp___1
				end
				if l_tmp___2 = 0 then
					if ((a_removenode.item.smaller).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := 3
						js.return
					end
					if not js.return_called then
						(a_removenode.item.smaller).item.same := a_removenode.item.same
						if ((a_removenode.item.same).c_pointer /= default_pointer) then
							(a_removenode.item.same).item.smaller := a_removenode.item.smaller
						end
						a_removenode.item.smaller := create {CE_POINTER [PD_CURL_TREE]}.make_shared (default_pointer)
						a_newroot.item := l_t
						Result := 0
						js.return
					end
				end
			end
			if not js.return_called then
				l_t.ce_gets (Curl_splay (a_removenode.item.key, l_t))
				if (l_t.c_pointer.to_integer_32).to_natural_32 /= (a_removenode.c_pointer.to_integer_32).to_natural_32 then
					Result := 2
					js.return
				end
			end
			if not js.return_called then
				l_x.ce_gets (l_t.item.same)
				if ((l_x).c_pointer /= default_pointer) then
					l_x.item.key := l_t.item.key
					l_x.item.larger := l_t.item.larger
					l_x.item.smaller := l_t.item.smaller
				elseif ((l_t.item.smaller).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_x.ce_gets (l_t.item.larger)
				else
					l_x.ce_gets (Curl_splay (a_removenode.item.key, l_t.item.smaller))
					l_x.item.larger := l_t.item.larger
				end
				a_newroot.item := l_x
				Result := 0
			end
		end

end
