class
	P_SSLGEN

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	safe_strequal (a_str1: CE_POINTER [INTEGER_8]; a_str2: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_tmp___0: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_str1).c_pointer = default_pointer then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if ((a_str2).c_pointer /= default_pointer) then
							Result := (0 /= (rawstr_inst.Curl_raw_equal (a_str1, a_str2)))
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if (a_str1).c_pointer = default_pointer then
							if (a_str2).c_pointer = default_pointer then
								l_tmp___0 := 1
							else
								l_tmp___0 := 0
							end
						else
							l_tmp___0 := 0
						end
						Result := l_tmp___0.to_boolean
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_ssl_config_matches (a_data: CE_POINTER [PD_SSL_CONFIG_DATA]; a_needle: CE_POINTER [PD_SSL_CONFIG_DATA]): BOOLEAN
		local
			js: JUMP_STATE
		do
			if a_data.item.version = a_needle.item.version then
				if a_data.item.verifypeer = a_needle.item.verifypeer then
					if a_data.item.verifyhost = a_needle.item.verifyhost then
						if (safe_strequal (a_data.item.CApath, a_needle.item.CApath)) then
							if (safe_strequal (a_data.item.CAfile, a_needle.item.CAfile)) then
								if (safe_strequal (a_data.item.random_file, a_needle.item.random_file)) then
									if (safe_strequal (a_data.item.egdsocket, a_needle.item.egdsocket)) then
										if (safe_strequal (a_data.item.cipher_list, a_needle.item.cipher_list)) then
											Result := (1).to_boolean
											js.return
										end
									end
								end
							end
						end
					end
				end
			end
			if not js.return_called then
				Result := (0).to_boolean
			end
		end

	Curl_clone_ssl_config (a_source: CE_POINTER [PD_SSL_CONFIG_DATA]; a_dest: CE_POINTER [PD_SSL_CONFIG_DATA]): BOOLEAN
		local
			js: JUMP_STATE
		do
			a_dest.item.sessionid := a_source.item.sessionid
			a_dest.item.verifyhost := a_source.item.verifyhost
			a_dest.item.verifypeer := a_source.item.verifypeer
			a_dest.item.version := a_source.item.version
			if ((a_source.item.CAfile).c_pointer /= default_pointer) then
				a_dest.item.CAfile := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([a_source.item.CAfile]))
				if (a_dest.item.CAfile).c_pointer = default_pointer then
					Result := (0).to_boolean
					js.return
				end
			else
				a_dest.item.CAfile := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			end
			if not js.return_called then
				if ((a_source.item.CApath).c_pointer /= default_pointer) then
					a_dest.item.CApath := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([a_source.item.CApath]))
					if (a_dest.item.CApath).c_pointer = default_pointer then
						Result := (0).to_boolean
						js.return
					end
				else
					a_dest.item.CApath := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				end
			end
			if not js.return_called then
				if ((a_source.item.cipher_list).c_pointer /= default_pointer) then
					a_dest.item.cipher_list := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([a_source.item.cipher_list]))
					if (a_dest.item.cipher_list).c_pointer = default_pointer then
						Result := (0).to_boolean
						js.return
					end
				else
					a_dest.item.cipher_list := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				end
			end
			if not js.return_called then
				if ((a_source.item.egdsocket).c_pointer /= default_pointer) then
					a_dest.item.egdsocket := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([a_source.item.egdsocket]))
					if (a_dest.item.egdsocket).c_pointer = default_pointer then
						Result := (0).to_boolean
						js.return
					end
				else
					a_dest.item.egdsocket := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				end
			end
			if not js.return_called then
				if ((a_source.item.random_file).c_pointer /= default_pointer) then
					a_dest.item.random_file := create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([a_source.item.random_file]))
					if (a_dest.item.random_file).c_pointer = default_pointer then
						Result := (0).to_boolean
						js.return
					end
				else
					a_dest.item.random_file := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				end
			end
			if not js.return_called then
				Result := (1).to_boolean
			end
		end

	Curl_free_ssl_config (a_sslc: CE_POINTER [PD_SSL_CONFIG_DATA])
		do
			url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_sslc.item.CAfile))
			url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_sslc.item.CApath))
			url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_sslc.item.cipher_list))
			url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_sslc.item.egdsocket))
			url_inst.Curl_safefree (create {CE_POINTER [ANY]}.make_cast (a_sslc.item.random_file))
		end

end
