class
	P_TELNET

inherit
	LIBCURL_DATA
		redefine
			default_create
		end
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create Curl_handler_telnet.make
		end

feature {ANY} -- attributes

	Curl_handler_telnet: PD_CURL_HANDLER

feature {ANY} -- routines

	init_telnet (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_tn: CE_POINTER [PD_TELNET]
			js: JUMP_STATE
		do
			create l_tn.make

			l_tn.ce_gets (create {CE_POINTER [PD_TELNET]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_ccalloc.pointer_item ([(1).to_natural_32, {PD_TELNET}.sizeof.to_natural_32])))))
			if (l_tn).c_pointer = default_pointer then
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				js.return
			end
			if not js.return_called then
				(a_conn.item.data).item.state.proto.telnet := create {CE_POINTER [ANY]}.make_cast (l_tn)
				l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_DATA
				l_tn.item.subpointer := l_tn.item.subbuffer
				l_tn.item.us_preferred[0] := 1
				l_tn.item.us_preferred[3] := 1
				l_tn.item.him_preferred[0] := 1
				l_tn.item.him_preferred[3] := 1
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	negotiate (a_conn: CE_POINTER [PD_CONNECTDATA])
		local
			l_i: INTEGER_32
			l_tn: CE_POINTER [PD_TELNET]
		do
			create l_tn.make

			l_tn.ce_gets (create {CE_POINTER [PD_TELNET]}.make_cast ((a_conn.item.data).item.state.proto.telnet))
			l_i := 0
			from
			until
				not (l_i < 40)
			loop
				if l_tn.item.us_preferred[l_i] = 1 then
					set_local_option (a_conn, l_i, 1)
				end
				if l_tn.item.him_preferred[l_i] = 1 then
					set_remote_option (a_conn, l_i, 1)
				end
				l_i := l_i + 1
			end
		end

	printoption (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_direction: CE_POINTER [INTEGER_8]; a_cmd: INTEGER_32; a_option: INTEGER_32)
		local
			l_fmt: CE_POINTER [INTEGER_8]
			l_opt: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
		do
			create l_fmt.make
			create l_opt.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make

			if a_data.item.set.verbose then
				if a_cmd = 255 then
					if a_option.to_natural_32 >= {NATURAL_32} 236 then
						if a_option.to_natural_32 <= {NATURAL_32} 255 then
							sendf_inst.Curl_infof ([a_data, ce_string ("%%s IAC %%s%N"), a_direction, arpa_telnet_inst.telnetcmds[a_option - 236]])
						else
							sendf_inst.Curl_infof ([a_data, ce_string ("%%s IAC %%d%N"), a_direction, a_option])
						end
					else
						sendf_inst.Curl_infof ([a_data, ce_string ("%%s IAC %%d%N"), a_direction, a_option])
					end
				else
					if a_cmd = 251 then
						l_fmt.ce_gets (ce_string ("WILL"))
					else
						if a_cmd = 252 then
							l_tmp___1.ce_gets (ce_string ("WONT"))
						else
							if a_cmd = 253 then
								l_tmp___0.ce_gets (ce_string ("DO"))
							else
								if a_cmd = 254 then
									l_tmp.ce_gets (ce_string ("DONT"))
								else
									l_tmp.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								end
								l_tmp___0.ce_gets (l_tmp)
							end
							l_tmp___1.ce_gets (l_tmp___0)
						end
						l_fmt.ce_gets (l_tmp___1)
					end
					if ((l_fmt).c_pointer /= default_pointer) then
						if a_option <= 39 then
							l_opt.ce_gets (arpa_telnet_inst.telnetoptions[a_option])
						elseif a_option = 255 then
							l_opt.ce_gets (ce_string ("EXOPL"))
						else
							l_opt.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
						end
						if ((l_opt).c_pointer /= default_pointer) then
							sendf_inst.Curl_infof ([a_data, ce_string ("%%s %%s %%s%N"), a_direction, l_fmt, l_opt])
						else
							sendf_inst.Curl_infof ([a_data, ce_string ("%%s %%s %%d%N"), a_direction, l_fmt, a_option])
						end
					else
						sendf_inst.Curl_infof ([a_data, ce_string ("%%s %%d %%d%N"), a_direction, a_cmd, a_option])
					end
				end
			end
		end

	send_negotiation (a_conn: CE_POINTER [PD_CONNECTDATA]; a_cmd: INTEGER_32; a_option: INTEGER_32)
		local
			l_buf: CE_ARRAY [NATURAL_8]
			l_bytes_written: INTEGER_32
			l_err: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
		do
			create l_buf.make (<<3>>)
			create l_data.make

			l_data.ce_gets (a_conn.item.data)
			l_buf[0] := (255).to_natural_8
			l_buf[1] := a_cmd.to_natural_8
			l_buf[2] := a_option.to_natural_8
			l_bytes_written := (send (a_conn.item.sock[0], create {CE_POINTER [ANY]}.make_cast (l_buf), (3).to_natural_32, 16384))
			if l_bytes_written < 0 then
				l_err := (errno_location).item
				sendf_inst.Curl_failf ([l_data, ce_string ("Sending data failed (%%d)"), l_err])
			end
			printoption (a_conn.item.data, ce_string ("SENT"), a_cmd, a_option)
		end

	set_remote_option (a_conn: CE_POINTER [PD_CONNECTDATA]; a_option: INTEGER_32; a_newstate: INTEGER_32)
		local
			l_tn: CE_POINTER [PD_TELNET]
			l_pos: INTEGER_32
		do
			create l_tn.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tn.ce_gets (create {CE_POINTER [PD_TELNET]}.make_cast ((a_conn.item.data).item.state.proto.telnet))
					if a_newstate /= 1 then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						inspect l_tn.item.him[a_option] -- switch 1 head
						when 0 then l_pos := -1 + 2
						when 1 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 4
						when 2 then l_pos := -1 + 8
						else l_pos := -1 + 12
						end
				when 2 then -- switch 1, case 0
						l_tn.item.him[a_option] := 2
						send_negotiation (a_conn, 253, a_option)
						l_pos := -1 + 12 -- switch 1; break
				when 3 then -- switch 1, case 1
						l_pos := -1 + 12 -- switch 1; break
				when 4 then -- switch 1, case 3
						inspect l_tn.item.himq[a_option] -- switch 2 head
						when 0 then l_pos := -1 + 5
						when 1 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 5 then -- switch 2, case 0
						l_tn.item.himq[a_option] := 1
						l_pos := -1 + 7 -- switch 2; break
				when 6 then -- switch 2, case 1
						l_pos := -1 + 7 -- switch 2; break
				when 7 then -- switch 2, done:
						l_pos := -1 + 12 -- switch 1; break
				when 8 then -- switch 1, case 2
						inspect l_tn.item.himq[a_option] -- switch 3 head
						when 0 then l_pos := -1 + 9
						when 1 then l_pos := -1 + 10
						else l_pos := -1 + 11
						end
				when 9 then -- switch 3, case 0
						l_pos := -1 + 11 -- switch 3; break
				when 10 then -- switch 3, case 1
						l_tn.item.himq[a_option] := 0
						l_pos := -1 + 11 -- switch 3; break
				when 11 then -- switch 3, done:
						l_pos := -1 + 12 -- switch 1; break
				when 12 then -- switch 1, done: | if block done, skip else block:
						l_pos := -1 + 24
				when 13 then -- else:
						inspect l_tn.item.him[a_option] -- switch 4 head
						when 0 then l_pos := -1 + 14
						when 1 then l_pos := -1 + 15
						when 3 then l_pos := -1 + 16
						when 2 then l_pos := -1 + 20
						else l_pos := -1 + 24
						end
				when 14 then -- switch 4, case 0
						l_pos := -1 + 24 -- switch 4; break
				when 15 then -- switch 4, case 1
						l_tn.item.him[a_option] := 3
						send_negotiation (a_conn, 254, a_option)
						l_pos := -1 + 24 -- switch 4; break
				when 16 then -- switch 4, case 3
						inspect l_tn.item.himq[a_option] -- switch 5 head
						when 0 then l_pos := -1 + 17
						when 1 then l_pos := -1 + 18
						else l_pos := -1 + 19
						end
				when 17 then -- switch 5, case 0
						l_pos := -1 + 19 -- switch 5; break
				when 18 then -- switch 5, case 1
						l_tn.item.himq[a_option] := 0
						l_pos := -1 + 19 -- switch 5; break
				when 19 then -- switch 5, done:
						l_pos := -1 + 24 -- switch 4; break
				when 20 then -- switch 4, case 2
						inspect l_tn.item.himq[a_option] -- switch 6 head
						when 0 then l_pos := -1 + 21
						when 1 then l_pos := -1 + 22
						else l_pos := -1 + 23
						end
				when 21 then -- switch 6, case 0
						l_tn.item.himq[a_option] := 1
						l_pos := -1 + 23 -- switch 6; break
				when 22 then -- switch 6, case 1
						l_pos := -1 + 23 -- switch 6; break
				when 23 then -- switch 6, done:
						l_pos := -1 + 24 -- switch 4; break
				when 24 then -- switch 4, done:
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	rec_will (a_conn: CE_POINTER [PD_CONNECTDATA]; a_option: INTEGER_32)
		local
			l_tn: CE_POINTER [PD_TELNET]
			l_pos: INTEGER_32
		do
			create l_tn.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tn.ce_gets (create {CE_POINTER [PD_TELNET]}.make_cast ((a_conn.item.data).item.state.proto.telnet))
					inspect l_tn.item.him[a_option] -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					when 2 then l_pos := -1 + 7
					else l_pos := -1 + 11
					end
				when 1 then -- switch 1, case 0
					if l_tn.item.him_preferred[a_option] = 1 then
						l_tn.item.him[a_option] := 1
						send_negotiation (a_conn, 253, a_option)
					else
						send_negotiation (a_conn, 254, a_option)
					end
					l_pos := -1 + 11 -- switch 1; break
				when 2 then -- switch 1, case 1
					l_pos := -1 + 11 -- switch 1; break
				when 3 then -- switch 1, case 3
					inspect l_tn.item.himq[a_option] -- switch 2 head
					when 0 then l_pos := -1 + 4
					when 1 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 4 then -- switch 2, case 0
					l_tn.item.him[a_option] := 0
					l_pos := -1 + 6 -- switch 2; break
				when 5 then -- switch 2, case 1
					l_tn.item.him[a_option] := 1
					l_tn.item.himq[a_option] := 0
					l_pos := -1 + 6 -- switch 2; break
				when 6 then -- switch 2, done:
					l_pos := -1 + 11 -- switch 1; break
				when 7 then -- switch 1, case 2
					inspect l_tn.item.himq[a_option] -- switch 3 head
					when 0 then l_pos := -1 + 8
					when 1 then l_pos := -1 + 9
					else l_pos := -1 + 10
					end
				when 8 then -- switch 3, case 0
					l_tn.item.him[a_option] := 1
					l_pos := -1 + 10 -- switch 3; break
				when 9 then -- switch 3, case 1
					l_tn.item.him[a_option] := 3
					l_tn.item.himq[a_option] := 0
					send_negotiation (a_conn, 254, a_option)
					l_pos := -1 + 10 -- switch 3; break
				when 10 then -- switch 3, done:
					l_pos := -1 + 11 -- switch 1; break
				when 11 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	rec_wont (a_conn: CE_POINTER [PD_CONNECTDATA]; a_option: INTEGER_32)
		local
			l_tn: CE_POINTER [PD_TELNET]
			l_pos: INTEGER_32
		do
			create l_tn.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tn.ce_gets (create {CE_POINTER [PD_TELNET]}.make_cast ((a_conn.item.data).item.state.proto.telnet))
					inspect l_tn.item.him[a_option] -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					when 2 then l_pos := -1 + 7
					else l_pos := -1 + 11
					end
				when 1 then -- switch 1, case 0
					l_pos := -1 + 11 -- switch 1; break
				when 2 then -- switch 1, case 1
					l_tn.item.him[a_option] := 0
					send_negotiation (a_conn, 254, a_option)
					l_pos := -1 + 11 -- switch 1; break
				when 3 then -- switch 1, case 3
					inspect l_tn.item.himq[a_option] -- switch 2 head
					when 0 then l_pos := -1 + 4
					when 1 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 4 then -- switch 2, case 0
					l_tn.item.him[a_option] := 0
					l_pos := -1 + 6 -- switch 2; break
				when 5 then -- switch 2, case 1
					l_tn.item.him[a_option] := 2
					l_tn.item.himq[a_option] := 0
					send_negotiation (a_conn, 253, a_option)
					l_pos := -1 + 6 -- switch 2; break
				when 6 then -- switch 2, done:
					l_pos := -1 + 11 -- switch 1; break
				when 7 then -- switch 1, case 2
					inspect l_tn.item.himq[a_option] -- switch 3 head
					when 0 then l_pos := -1 + 8
					when 1 then l_pos := -1 + 9
					else l_pos := -1 + 10
					end
				when 8 then -- switch 3, case 0
					l_tn.item.him[a_option] := 0
					l_pos := -1 + 10 -- switch 3; break
				when 9 then -- switch 3, case 1
					l_tn.item.him[a_option] := 0
					l_tn.item.himq[a_option] := 0
					l_pos := -1 + 10 -- switch 3; break
				when 10 then -- switch 3, done:
					l_pos := -1 + 11 -- switch 1; break
				when 11 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_local_option (a_conn: CE_POINTER [PD_CONNECTDATA]; a_option: INTEGER_32; a_newstate: INTEGER_32)
		local
			l_tn: CE_POINTER [PD_TELNET]
			l_pos: INTEGER_32
		do
			create l_tn.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tn.ce_gets (create {CE_POINTER [PD_TELNET]}.make_cast ((a_conn.item.data).item.state.proto.telnet))
					if a_newstate /= 1 then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						inspect l_tn.item.us[a_option] -- switch 1 head
						when 0 then l_pos := -1 + 2
						when 1 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 4
						when 2 then l_pos := -1 + 8
						else l_pos := -1 + 12
						end
				when 2 then -- switch 1, case 0
						l_tn.item.us[a_option] := 2
						send_negotiation (a_conn, 251, a_option)
						l_pos := -1 + 12 -- switch 1; break
				when 3 then -- switch 1, case 1
						l_pos := -1 + 12 -- switch 1; break
				when 4 then -- switch 1, case 3
						inspect l_tn.item.usq[a_option] -- switch 2 head
						when 0 then l_pos := -1 + 5
						when 1 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 5 then -- switch 2, case 0
						l_tn.item.usq[a_option] := 1
						l_pos := -1 + 7 -- switch 2; break
				when 6 then -- switch 2, case 1
						l_pos := -1 + 7 -- switch 2; break
				when 7 then -- switch 2, done:
						l_pos := -1 + 12 -- switch 1; break
				when 8 then -- switch 1, case 2
						inspect l_tn.item.usq[a_option] -- switch 3 head
						when 0 then l_pos := -1 + 9
						when 1 then l_pos := -1 + 10
						else l_pos := -1 + 11
						end
				when 9 then -- switch 3, case 0
						l_pos := -1 + 11 -- switch 3; break
				when 10 then -- switch 3, case 1
						l_tn.item.usq[a_option] := 0
						l_pos := -1 + 11 -- switch 3; break
				when 11 then -- switch 3, done:
						l_pos := -1 + 12 -- switch 1; break
				when 12 then -- switch 1, done: | if block done, skip else block:
						l_pos := -1 + 24
				when 13 then -- else:
						inspect l_tn.item.us[a_option] -- switch 4 head
						when 0 then l_pos := -1 + 14
						when 1 then l_pos := -1 + 15
						when 3 then l_pos := -1 + 16
						when 2 then l_pos := -1 + 20
						else l_pos := -1 + 24
						end
				when 14 then -- switch 4, case 0
						l_pos := -1 + 24 -- switch 4; break
				when 15 then -- switch 4, case 1
						l_tn.item.us[a_option] := 3
						send_negotiation (a_conn, 252, a_option)
						l_pos := -1 + 24 -- switch 4; break
				when 16 then -- switch 4, case 3
						inspect l_tn.item.usq[a_option] -- switch 5 head
						when 0 then l_pos := -1 + 17
						when 1 then l_pos := -1 + 18
						else l_pos := -1 + 19
						end
				when 17 then -- switch 5, case 0
						l_pos := -1 + 19 -- switch 5; break
				when 18 then -- switch 5, case 1
						l_tn.item.usq[a_option] := 0
						l_pos := -1 + 19 -- switch 5; break
				when 19 then -- switch 5, done:
						l_pos := -1 + 24 -- switch 4; break
				when 20 then -- switch 4, case 2
						inspect l_tn.item.usq[a_option] -- switch 6 head
						when 0 then l_pos := -1 + 21
						when 1 then l_pos := -1 + 22
						else l_pos := -1 + 23
						end
				when 21 then -- switch 6, case 0
						l_tn.item.usq[a_option] := 1
						l_pos := -1 + 23 -- switch 6; break
				when 22 then -- switch 6, case 1
						l_pos := -1 + 23 -- switch 6; break
				when 23 then -- switch 6, done:
						l_pos := -1 + 24 -- switch 4; break
				when 24 then -- switch 4, done:
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	rec_do (a_conn: CE_POINTER [PD_CONNECTDATA]; a_option: INTEGER_32)
		local
			l_tn: CE_POINTER [PD_TELNET]
			l_pos: INTEGER_32
		do
			create l_tn.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tn.ce_gets (create {CE_POINTER [PD_TELNET]}.make_cast ((a_conn.item.data).item.state.proto.telnet))
					inspect l_tn.item.us[a_option] -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					when 2 then l_pos := -1 + 7
					else l_pos := -1 + 11
					end
				when 1 then -- switch 1, case 0
					if l_tn.item.us_preferred[a_option] = 1 then
						l_tn.item.us[a_option] := 1
						send_negotiation (a_conn, 251, a_option)
					else
						send_negotiation (a_conn, 252, a_option)
					end
					l_pos := -1 + 11 -- switch 1; break
				when 2 then -- switch 1, case 1
					l_pos := -1 + 11 -- switch 1; break
				when 3 then -- switch 1, case 3
					inspect l_tn.item.usq[a_option] -- switch 2 head
					when 0 then l_pos := -1 + 4
					when 1 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 4 then -- switch 2, case 0
					l_tn.item.us[a_option] := 0
					l_pos := -1 + 6 -- switch 2; break
				when 5 then -- switch 2, case 1
					l_tn.item.us[a_option] := 1
					l_tn.item.usq[a_option] := 0
					l_pos := -1 + 6 -- switch 2; break
				when 6 then -- switch 2, done:
					l_pos := -1 + 11 -- switch 1; break
				when 7 then -- switch 1, case 2
					inspect l_tn.item.usq[a_option] -- switch 3 head
					when 0 then l_pos := -1 + 8
					when 1 then l_pos := -1 + 9
					else l_pos := -1 + 10
					end
				when 8 then -- switch 3, case 0
					l_tn.item.us[a_option] := 1
					l_pos := -1 + 10 -- switch 3; break
				when 9 then -- switch 3, case 1
					l_tn.item.us[a_option] := 3
					l_tn.item.himq[a_option] := 0
					send_negotiation (a_conn, 252, a_option)
					l_pos := -1 + 10 -- switch 3; break
				when 10 then -- switch 3, done:
					l_pos := -1 + 11 -- switch 1; break
				when 11 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	rec_dont (a_conn: CE_POINTER [PD_CONNECTDATA]; a_option: INTEGER_32)
		local
			l_tn: CE_POINTER [PD_TELNET]
			l_pos: INTEGER_32
		do
			create l_tn.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tn.ce_gets (create {CE_POINTER [PD_TELNET]}.make_cast ((a_conn.item.data).item.state.proto.telnet))
					inspect l_tn.item.us[a_option] -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					when 2 then l_pos := -1 + 7
					else l_pos := -1 + 11
					end
				when 1 then -- switch 1, case 0
					l_pos := -1 + 11 -- switch 1; break
				when 2 then -- switch 1, case 1
					l_tn.item.us[a_option] := 0
					send_negotiation (a_conn, 252, a_option)
					l_pos := -1 + 11 -- switch 1; break
				when 3 then -- switch 1, case 3
					inspect l_tn.item.usq[a_option] -- switch 2 head
					when 0 then l_pos := -1 + 4
					when 1 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 4 then -- switch 2, case 0
					l_tn.item.us[a_option] := 0
					l_pos := -1 + 6 -- switch 2; break
				when 5 then -- switch 2, case 1
					l_tn.item.us[a_option] := 2
					l_tn.item.usq[a_option] := 0
					send_negotiation (a_conn, 251, a_option)
					l_pos := -1 + 6 -- switch 2; break
				when 6 then -- switch 2, done:
					l_pos := -1 + 11 -- switch 1; break
				when 7 then -- switch 1, case 2
					inspect l_tn.item.usq[a_option] -- switch 3 head
					when 0 then l_pos := -1 + 8
					when 1 then l_pos := -1 + 9
					else l_pos := -1 + 10
					end
				when 8 then -- switch 3, case 0
					l_tn.item.us[a_option] := 0
					l_pos := -1 + 10 -- switch 3; break
				when 9 then -- switch 3, case 1
					l_tn.item.us[a_option] := 0
					l_tn.item.usq[a_option] := 0
					l_pos := -1 + 10 -- switch 3; break
				when 10 then -- switch 3, done:
					l_pos := -1 + 11 -- switch 1; break
				when 11 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	printsub (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_direction: INTEGER_32; a_pointer: CE_POINTER [NATURAL_8]; a_length: NATURAL_32)
		local
			l_length: NATURAL_32
			l_i: NATURAL_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_j: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_length := a_length
					l_i := {NATURAL_32} 0
					if not (a_data.item.set.verbose) then
						l_pos := -1 + 34 -- skip if block
					end
				when 1 then -- if:
						if not (a_direction.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 2 then -- if:
						if a_direction = 60 then
							l_tmp.ce_gets (ce_string ("RCVD"))
						else
							l_tmp.ce_gets (ce_string ("SENT"))
						end
						sendf_inst.Curl_infof ([a_data, ce_string ("%%s IAC SB "), l_tmp])
						if not (l_length >= {NATURAL_32} 3) then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						l_i := (a_pointer[(l_length - {NATURAL_32} 2).to_integer_32]).to_natural_32
						l_j := (a_pointer[(l_length - {NATURAL_32} 1).to_integer_32]).to_integer_32
						if l_i = {NATURAL_32} 255 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if l_j = 240 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						sendf_inst.Curl_infof ([a_data, ce_string ("(terminated by ")])
						if l_i <= {NATURAL_32} 39 then
							sendf_inst.Curl_infof ([a_data, ce_string ("%%s "), arpa_telnet_inst.telnetoptions[l_i.to_integer_32]])
						elseif l_i >= {NATURAL_32} 236 then
							if l_i <= {NATURAL_32} 255 then
								sendf_inst.Curl_infof ([a_data, ce_string ("%%s "), arpa_telnet_inst.telnetcmds[(l_i - {NATURAL_32} 236).to_integer_32]])
							else
								sendf_inst.Curl_infof ([a_data, ce_string ("%%u "), l_i])
							end
						else
							sendf_inst.Curl_infof ([a_data, ce_string ("%%u "), l_i])
						end
						if l_j <= 39 then
							sendf_inst.Curl_infof ([a_data, ce_string ("%%s"), arpa_telnet_inst.telnetoptions[l_j]])
						elseif l_j.to_natural_32 >= {NATURAL_32} 236 then
							if l_j.to_natural_32 <= {NATURAL_32} 255 then
								sendf_inst.Curl_infof ([a_data, ce_string ("%%s"), arpa_telnet_inst.telnetcmds[l_j - 236]])
							else
								sendf_inst.Curl_infof ([a_data, ce_string ("%%d"), l_j])
							end
						else
							sendf_inst.Curl_infof ([a_data, ce_string ("%%d"), l_j])
						end
						sendf_inst.Curl_infof ([a_data, ce_string (", not IAC SE!) ")])
				when 8 then -- if done | if done
						l_length := l_length - ({NATURAL_32} 2)
				when 9 then -- if done
						if l_length < {NATURAL_32} 1 then
							sendf_inst.Curl_infof ([a_data, ce_string ("(Empty suboption?)")])
							js.return
						end
						if js.return_called then
							l_pos := -1 + 34 -- skip if block
						end
				when 10 then -- if:
						if not ((a_pointer[0]).to_integer_32 <= 39) then
							l_pos := -1 + 15 -- skip if block
						end
				when 11 then -- if:
						inspect (a_pointer[0]).to_integer_32 -- switch 1 head
						when 24 then l_pos := -1 + 12
						when 35 then l_pos := -1 + 12
						when 39 then l_pos := -1 + 12
						else l_pos := -1 + 13
						end
				when 12 then -- switch 1, case 24 | switch 1, case 35 | switch 1, case 39
						sendf_inst.Curl_infof ([a_data, ce_string ("%%s"), arpa_telnet_inst.telnetoptions[(a_pointer[0]).to_integer_32]])
						l_pos := -1 + 14 -- switch 1; break
				when 13 then -- switch 1, default:
						sendf_inst.Curl_infof ([a_data, ce_string ("%%s (unsupported)"), arpa_telnet_inst.telnetoptions[(a_pointer[0]).to_integer_32]])
						l_pos := -1 + 14 -- switch 1; break
				when 14 then -- switch 1, done: | if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						sendf_inst.Curl_infof ([a_data, ce_string ("%%d (unknown)"), (a_pointer[l_i.to_integer_32]).to_integer_32])
				when 16 then -- if done
						inspect (a_pointer[1]).to_integer_32 -- switch 2 head
						when 0 then l_pos := -1 + 17
						when 1 then l_pos := -1 + 18
						when 2 then l_pos := -1 + 19
						when 3 then l_pos := -1 + 20
						else l_pos := -1 + 21
						end
				when 17 then -- switch 2, case 0
						sendf_inst.Curl_infof ([a_data, ce_string (" IS")])
						l_pos := -1 + 21 -- switch 2; break
				when 18 then -- switch 2, case 1
						sendf_inst.Curl_infof ([a_data, ce_string (" SEND")])
						l_pos := -1 + 21 -- switch 2; break
				when 19 then -- switch 2, case 2
						sendf_inst.Curl_infof ([a_data, ce_string (" INFO/REPLY")])
						l_pos := -1 + 21 -- switch 2; break
				when 20 then -- switch 2, case 3
						sendf_inst.Curl_infof ([a_data, ce_string (" NAME")])
						l_pos := -1 + 21 -- switch 2; break
				when 21 then -- switch 2, done:
						inspect (a_pointer[0]).to_integer_32 -- switch 3 head
						when 24 then l_pos := -1 + 22
						when 35 then l_pos := -1 + 22
						when 39 then l_pos := -1 + 23
						else l_pos := -1 + 32
						end
				when 22 then -- switch 3, case 24 | switch 3, case 35
						a_pointer[l_length.to_integer_32] := (0).to_natural_8
						sendf_inst.Curl_infof ([a_data, ce_string (" %"%%s%""), a_pointer + 2])
						l_pos := -1 + 33 -- switch 3; break
				when 23 then -- switch 3, case 39
						if (a_pointer[1]).to_integer_32 /= 0 then
							l_pos := -1 + 31 -- skip if block
						end
				when 24 then -- if:
						sendf_inst.Curl_infof ([a_data, ce_string (" ")])
						l_i := {NATURAL_32} 3
				when 25 then -- loop condition:
						if not (l_i < l_length) then
							l_pos := -1 + 31 -- skip loop
						end
				when 26 then -- loop body:
						inspect (a_pointer[l_i.to_integer_32]).to_integer_32 -- switch 4 head
						when 0 then l_pos := -1 + 27
						when 1 then l_pos := -1 + 28
						else l_pos := -1 + 29
						end
				when 27 then -- switch 4, case 0
						sendf_inst.Curl_infof ([a_data, ce_string (", ")])
						l_pos := -1 + 30 -- switch 4; break
				when 28 then -- switch 4, case 1
						sendf_inst.Curl_infof ([a_data, ce_string (" = ")])
						l_pos := -1 + 30 -- switch 4; break
				when 29 then -- switch 4, default:
						sendf_inst.Curl_infof ([a_data, ce_string ("%%c"), (a_pointer[l_i.to_integer_32]).to_integer_32])
						l_pos := -1 + 30 -- switch 4; break
				when 30 then -- switch 4, done:
						l_i := l_i + 1
						l_pos := -1 + 25 -- back to loop condition
				when 31 then -- loop done | if done
						l_pos := -1 + 33 -- switch 3; break
				when 32 then -- switch 3, default:
						l_i := {NATURAL_32} 2
						from
						until
							not (l_i < l_length)
						loop
							sendf_inst.Curl_infof ([a_data, ce_string (" %%.2x"), (a_pointer[l_i.to_integer_32]).to_integer_32])
							l_i := l_i + 1
						end
						l_pos := -1 + 33 -- switch 3; break
				when 33 then -- switch 3, done:
						if a_direction.to_boolean then
							sendf_inst.Curl_infof ([a_data, ce_string ("%N")])
						end
				when 34 then -- if done | if done
						if not js.return_called then
						end
				when 35 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	check_telnet_options (a_conn: CE_POINTER [PD_CONNECTDATA]): INTEGER_32
		local
			l_head: CE_POINTER [PD_CURL_SLIST]
			l_option_keyword: CE_ARRAY [INTEGER_8]
			l_option_arg: CE_ARRAY [INTEGER_8]
			l_buf: CE_POINTER [INTEGER_8]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_tn: CE_POINTER [PD_TELNET]
			js: JUMP_STATE
		do
			create l_head.make
			create l_option_keyword.make (<<128>>)
			create l_option_arg.make (<<256>>)
			create l_buf.make
			create l_data.make
			create l_tn.make

			l_data.ce_gets (a_conn.item.data)
			l_tn.ce_gets (create {CE_POINTER [PD_TELNET]}.make_cast ((a_conn.item.data).item.state.proto.telnet))
			if a_conn.item.bits.user_passwd then
				mprintf_inst.curl_msnprintf ([l_option_arg, (Integer_8_bytes.to_natural_32 * (256).to_natural_32), ce_string ("USER,%%s"), a_conn.item.user]).do_nothing
				l_tn.item.telnet_vars := slist_inst.curl_slist_append (l_tn.item.telnet_vars, l_option_arg)
				l_tn.item.us_preferred[39] := 1
			end
			l_head.ce_gets (l_data.item.set.telnet_options)
			from
			until
				not (not js.loop_left and then ((l_head).c_pointer /= default_pointer))
			loop
				js.reset
				if (sscanf ([l_head.item.data, ce_string ("%%127[^= ]%%*[ =]%%255s"), l_option_keyword, l_option_arg])) = 2 then
					if (rawstr_inst.Curl_raw_equal (l_option_keyword, ce_string ("TTYPE"))).to_boolean then
						strncpy ((l_tn.item.subopt_ttype), l_option_arg, (31).to_natural_32).do_nothing
						l_tn.item.subopt_ttype[31] := (0).to_integer_8
						l_tn.item.us_preferred[24] := 1
						js.continue
					end
					if not js.loop_jumped then
						if (rawstr_inst.Curl_raw_equal (l_option_keyword, ce_string ("XDISPLOC"))).to_boolean then
							strncpy ((l_tn.item.subopt_xdisploc), l_option_arg, (127).to_natural_32).do_nothing
							l_tn.item.subopt_xdisploc[127] := (0).to_integer_8
							l_tn.item.us_preferred[35] := 1
							js.continue
						end
					end
					if not js.loop_jumped then
						if (rawstr_inst.Curl_raw_equal (l_option_keyword, ce_string ("NEW_ENV"))).to_boolean then
							l_buf.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (easy_inst.Curl_cstrdup.pointer_item ([l_option_arg])))
							if (l_buf).c_pointer = default_pointer then
								Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
								js.return
							end
							if not js.return_called then
								l_tn.item.telnet_vars := slist_inst.curl_slist_append (l_tn.item.telnet_vars, l_buf)
								l_tn.item.us_preferred[39] := 1
								js.continue
							end
						end
					end
					if not js.loop_jumped then
						sendf_inst.Curl_failf ([l_data, ce_string ("Unknown telnet option %%s"), l_head.item.data])
						Result := ({PC_CURLCODE}.CURLE_UNKNOWN_TELNET_OPTION)
						js.return
					end
				else
					sendf_inst.Curl_failf ([l_data, ce_string ("Syntax error in telnet option: %%s"), l_head.item.data])
					Result := ({PC_CURLCODE}.CURLE_TELNET_OPTION_SYNTAX)
					js.return
				end
				if not js.loop_left then
					l_head.ce_gets (l_head.item.next)
				end
			end
			if not js.return_called then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

	suboption (a_conn: CE_POINTER [PD_CONNECTDATA])
		local
			l_v: CE_POINTER [PD_CURL_SLIST]
			l_temp: CE_ARRAY [NATURAL_8]
			l_bytes_written: INTEGER_32
			l_len: NATURAL_32
			l_tmplen: NATURAL_32
			l_err: INTEGER_32
			l_varname: CE_ARRAY [INTEGER_8]
			l_varval: CE_ARRAY [INTEGER_8]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_tn: CE_POINTER [PD_TELNET]
			l_tmp: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_v.make
			create l_temp.make (<<2048>>)
			create l_varname.make (<<128>>)
			create l_varval.make (<<128>>)
			create l_data.make
			create l_tn.make
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data.ce_gets (a_conn.item.data)
					l_tn.ce_gets (create {CE_POINTER [PD_TELNET]}.make_cast (l_data.item.state.proto.telnet))
					printsub (l_data, ('<').code, l_tn.item.subbuffer, (((l_tn.item.subend).distance ((l_tn.item.subpointer))) + 2).to_natural_32)
					l_tmp.ce_gets (l_tn.item.subpointer)
					l_tn.item.subpointer := (l_tn.item.subpointer) + 1
					inspect ((l_tmp.item).to_integer_32).bit_and (255) -- switch 1 head
					when 24 then l_pos := -1 + 1
					when 35 then l_pos := -1 + 2
					when 39 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 24
					l_len := ((strlen ((l_tn.item.subopt_ttype))) + {NATURAL_32} 4) + {NATURAL_32} 2
					mprintf_inst.curl_msnprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_temp), (Natural_8_bytes.to_natural_32 * (2048).to_natural_32), ce_string ("%%c%%c%%c%%c%%s%%c%%c"), 255, 250, 24, 0, l_tn.item.subopt_ttype, 255, 240]).do_nothing
					l_bytes_written := (send (a_conn.item.sock[0], create {CE_POINTER [ANY]}.make_cast (l_temp), l_len, 16384))
					if l_bytes_written < 0 then
						l_err := (errno_location).item
						sendf_inst.Curl_failf ([l_data, ce_string ("Sending data failed (%%d)"), l_err])
					end
					printsub (l_data, ('>').code, l_temp + 2, l_len - {NATURAL_32} 2)
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 35
					l_len := ((strlen ((l_tn.item.subopt_xdisploc))) + {NATURAL_32} 4) + {NATURAL_32} 2
					mprintf_inst.curl_msnprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_temp), (Natural_8_bytes.to_natural_32 * (2048).to_natural_32), ce_string ("%%c%%c%%c%%c%%s%%c%%c"), 255, 250, 35, 0, l_tn.item.subopt_xdisploc, 255, 240]).do_nothing
					l_bytes_written := (send (a_conn.item.sock[0], create {CE_POINTER [ANY]}.make_cast (l_temp), l_len, 16384))
					if l_bytes_written < 0 then
						l_err := (errno_location).item
						sendf_inst.Curl_failf ([l_data, ce_string ("Sending data failed (%%d)"), l_err])
					end
					printsub (l_data, ('>').code, l_temp + 2, l_len - {NATURAL_32} 2)
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, case 39
					mprintf_inst.curl_msnprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_temp), (Natural_8_bytes.to_natural_32 * (2048).to_natural_32), ce_string ("%%c%%c%%c%%c"), 255, 250, 39, 0]).do_nothing
					l_len := (4).to_natural_32
					l_v.ce_gets (l_tn.item.telnet_vars)
					from
					until
						(l_v).c_pointer = default_pointer
					loop
						l_tmplen := (strlen (l_v.item.data)) + {NATURAL_32} 1
						if l_len + l_tmplen < ((Natural_8_bytes.to_natural_32 * (2048).to_natural_32).to_integer_32 - 6).to_natural_32 then
							sscanf ([l_v.item.data, ce_string ("%%127[^,],%%127s"), l_varname, l_varval]).do_nothing
							mprintf_inst.curl_msnprintf ([create {CE_POINTER [INTEGER_8]}.make_cast ((l_temp + l_len.to_integer_32)), (Natural_8_bytes.to_natural_32 * (2048).to_natural_32) - l_len, ce_string ("%%c%%s%%c%%s"), 0, l_varname, 1, l_varval]).do_nothing
							l_len := l_len + l_tmplen
						end
						l_v.ce_gets (l_v.item.next)
					end
					mprintf_inst.curl_msnprintf ([create {CE_POINTER [INTEGER_8]}.make_cast ((l_temp + l_len.to_integer_32)), (Natural_8_bytes.to_natural_32 * (2048).to_natural_32) - l_len, ce_string ("%%c%%c"), 255, 240]).do_nothing
					l_len := l_len + ({NATURAL_32} 2)
					l_bytes_written := (send (a_conn.item.sock[0], create {CE_POINTER [ANY]}.make_cast (l_temp), l_len, 16384))
					if l_bytes_written < 0 then
						l_err := (errno_location).item
						sendf_inst.Curl_failf ([l_data, ce_string ("Sending data failed (%%d)"), l_err])
					end
					printsub (l_data, ('>').code, l_temp + 2, l_len - {NATURAL_32} 2)
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	telrcv (a_conn: CE_POINTER [PD_CONNECTDATA]; a_inbuf: CE_POINTER [NATURAL_8]; a_count: INTEGER_32): INTEGER_32
		local
			l_count: INTEGER_32
			l_c: NATURAL_8
			l_result: INTEGER_32
			l_in: INTEGER_32
			l_startwrite: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_tn: CE_POINTER [PD_TELNET]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make
			create l_tn.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count := a_count
					l_in := 0
					l_startwrite := -1
					l_data.ce_gets (a_conn.item.data)
					l_tn.ce_gets (create {CE_POINTER [PD_TELNET]}.make_cast (l_data.item.state.proto.telnet))
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 30 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_tmp___5 := l_count
						l_count := l_count - 1
						if not l_tmp___5.to_boolean then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 29 -- skip if block
						end
				when 3 then -- if:
						l_c := a_inbuf[l_in]
						inspect l_tn.item.telrcv_state -- switch 1 head
						when 6 then l_pos := -1 + 4
						when 0 then l_pos := -1 + 6
						when 1 then l_pos := -1 + 8
						when 2 then l_pos := -1 + 17
						when 3 then l_pos := -1 + 18
						when 4 then l_pos := -1 + 19
						when 5 then l_pos := -1 + 20
						when 7 then l_pos := -1 + 21
						when 8 then l_pos := -1 + 22
						else l_pos := -1 + 28
						end
				when 4 then -- switch 1, case 6
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_DATA
						if l_c.to_integer_32 = 0 then
							if l_startwrite >= 0 then
								l_result := sendf_inst.Curl_client_write (a_conn, 1, create {CE_POINTER [INTEGER_8]}.make_cast ((a_inbuf + l_startwrite)), (l_in - l_startwrite).to_natural_32)
								if l_result.to_natural_32 /= {NATURAL_32} 0 then
									Result := l_result
									js.return
								end
							end
							if not js.return_called then
								l_startwrite := -1
							end
							l_pos := -1 + 28 -- switch 1; break
						end
				when 5 then
						if not js.return_called and then (l_startwrite < 0) then
							l_startwrite := l_in
						end
						l_pos := -1 + 28 -- switch 1; break
				when 6 then -- switch 1, case 0
						if l_c.to_integer_32 = 255 then
							l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_IAC
							if l_startwrite >= 0 then
								l_result := sendf_inst.Curl_client_write (a_conn, 1, create {CE_POINTER [INTEGER_8]}.make_cast ((a_inbuf + l_startwrite)), (l_in - l_startwrite).to_natural_32)
								if l_result.to_natural_32 /= {NATURAL_32} 0 then
									Result := l_result
									js.return
								end
							end
							if not js.return_called then
								l_startwrite := -1
							end
							l_pos := -1 + 28 -- switch 1; break
						elseif l_c.to_integer_32 = 13 then
							l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_CR
						end
				when 7 then
						if not js.return_called and then (l_startwrite < 0) then
							l_startwrite := l_in
						end
						l_pos := -1 + 28 -- switch 1; break
				when 8 then -- process_iac: | switch 1, case 1
						inspect l_c.to_integer_32 -- switch 2 head
						when 251 then l_pos := -1 + 9
						when 252 then l_pos := -1 + 10
						when 253 then l_pos := -1 + 11
						when 254 then l_pos := -1 + 12
						when 250 then l_pos := -1 + 13
						when 255 then l_pos := -1 + 14
						else l_pos := -1 + 15
						end
				when 9 then -- switch 2, case 251
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_WILL
						l_pos := -1 + 16 -- switch 2; break
				when 10 then -- switch 2, case 252
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_WONT
						l_pos := -1 + 16 -- switch 2; break
				when 11 then -- switch 2, case 253
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_DO
						l_pos := -1 + 16 -- switch 2; break
				when 12 then -- switch 2, case 254
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_DONT
						l_pos := -1 + 16 -- switch 2; break
				when 13 then -- switch 2, case 250
						l_tn.item.subpointer := l_tn.item.subbuffer
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_SB
						l_pos := -1 + 16 -- switch 2; break
				when 14 then -- switch 2, case 255
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_DATA
						if l_startwrite < 0 then
							l_startwrite := l_in
						end
						l_pos := -1 + 16 -- switch 2; break
				when 15 then -- switch 2, default:
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_DATA
						printoption (l_data, ce_string ("RCVD"), 255, l_c.to_integer_32)
						l_pos := -1 + 16 -- switch 2; break
				when 16 then -- switch 2, done:
						l_pos := -1 + 28 -- switch 1; break
				when 17 then -- switch 1, case 2
						printoption (l_data, ce_string ("RCVD"), 251, l_c.to_integer_32)
						l_tn.item.please_negotiate := 1
						rec_will (a_conn, l_c.to_integer_32)
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_DATA
						l_pos := -1 + 28 -- switch 1; break
				when 18 then -- switch 1, case 3
						printoption (l_data, ce_string ("RCVD"), 252, l_c.to_integer_32)
						l_tn.item.please_negotiate := 1
						rec_wont (a_conn, l_c.to_integer_32)
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_DATA
						l_pos := -1 + 28 -- switch 1; break
				when 19 then -- switch 1, case 4
						printoption (l_data, ce_string ("RCVD"), 253, l_c.to_integer_32)
						l_tn.item.please_negotiate := 1
						rec_do (a_conn, l_c.to_integer_32)
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_DATA
						l_pos := -1 + 28 -- switch 1; break
				when 20 then -- switch 1, case 5
						printoption (l_data, ce_string ("RCVD"), 254, l_c.to_integer_32)
						l_tn.item.please_negotiate := 1
						rec_dont (a_conn, l_c.to_integer_32)
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_DATA
						l_pos := -1 + 28 -- switch 1; break
				when 21 then -- switch 1, case 7
						if l_c.to_integer_32 = 255 then
							l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_SE
						elseif ((l_tn.item.subpointer).c_pointer.to_integer_32).to_natural_32 < ((l_tn.item.subbuffer + (Natural_8_bytes.to_natural_32 * (512).to_natural_32).to_integer_32).c_pointer.to_integer_32).to_natural_32 then
							l_tmp.ce_gets (l_tn.item.subpointer)
							l_tn.item.subpointer := (l_tn.item.subpointer) + 1
							l_tmp.item := l_c
						end
						l_pos := -1 + 28 -- switch 1; break
				when 22 then -- switch 1, case 8
						if l_c.to_integer_32 = 240 then
							l_pos := -1 + 26 -- skip if block
						end
				when 23 then -- if:
						if l_c.to_integer_32 /= 255 then
							if ((l_tn.item.subpointer).c_pointer.to_integer_32).to_natural_32 < ((l_tn.item.subbuffer + (Natural_8_bytes.to_natural_32 * (512).to_natural_32).to_integer_32).c_pointer.to_integer_32).to_natural_32 then
								l_tmp___0.ce_gets (l_tn.item.subpointer)
								l_tn.item.subpointer := (l_tn.item.subpointer) + 1
								l_tmp___0.item := (255).to_natural_8
							end
							if ((l_tn.item.subpointer).c_pointer.to_integer_32).to_natural_32 < ((l_tn.item.subbuffer + (Natural_8_bytes.to_natural_32 * (512).to_natural_32).to_integer_32).c_pointer.to_integer_32).to_natural_32 then
								l_tmp___1.ce_gets (l_tn.item.subpointer)
								l_tn.item.subpointer := (l_tn.item.subpointer) + 1
								l_tmp___1.item := l_c
							end
							l_tn.item.subpointer := l_tn.item.subpointer - (2)
							l_tn.item.subend := l_tn.item.subpointer
							l_tn.item.subpointer := l_tn.item.subbuffer
							printoption (l_data, ce_string ("In SUBOPTION processing, RCVD"), 255, l_c.to_integer_32)
							suboption (a_conn)
							l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_IAC
							l_pos := -1 + 8 -- goto process_iac
						end
				when 24 then
						if ((l_tn.item.subpointer).c_pointer.to_integer_32).to_natural_32 < ((l_tn.item.subbuffer + (Natural_8_bytes.to_natural_32 * (512).to_natural_32).to_integer_32).c_pointer.to_integer_32).to_natural_32 then
							l_tmp___2.ce_gets (l_tn.item.subpointer)
							l_tn.item.subpointer := (l_tn.item.subpointer) + 1
							l_tmp___2.item := l_c
						end
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_SB
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						if ((l_tn.item.subpointer).c_pointer.to_integer_32).to_natural_32 < ((l_tn.item.subbuffer + (Natural_8_bytes.to_natural_32 * (512).to_natural_32).to_integer_32).c_pointer.to_integer_32).to_natural_32 then
							l_tmp___3.ce_gets (l_tn.item.subpointer)
							l_tn.item.subpointer := (l_tn.item.subpointer) + 1
							l_tmp___3.item := (255).to_natural_8
						end
						if ((l_tn.item.subpointer).c_pointer.to_integer_32).to_natural_32 < ((l_tn.item.subbuffer + (Natural_8_bytes.to_natural_32 * (512).to_natural_32).to_integer_32).c_pointer.to_integer_32).to_natural_32 then
							l_tmp___4.ce_gets (l_tn.item.subpointer)
							l_tn.item.subpointer := (l_tn.item.subpointer) + 1
							l_tmp___4.item := (240).to_natural_8
						end
						l_tn.item.subpointer := l_tn.item.subpointer - (2)
						l_tn.item.subend := l_tn.item.subpointer
						l_tn.item.subpointer := l_tn.item.subbuffer
						suboption (a_conn)
						l_tn.item.telrcv_state := {PC_TELNETRECEIVE}.CURL_TS_DATA
				when 27 then -- if done
						l_pos := -1 + 28 -- switch 1; break
				when 28 then -- switch 1, done:
						if not js.return_called then
							l_in := l_in + 1
						end
				when 29 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 30 then -- loop done
					js.reset
					if not js.return_called and then (l_startwrite >= 0) then
						l_result := sendf_inst.Curl_client_write (a_conn, 1, create {CE_POINTER [INTEGER_8]}.make_cast ((a_inbuf + l_startwrite)), (l_in - l_startwrite).to_natural_32)
						if l_result.to_natural_32 /= {NATURAL_32} 0 then
							Result := l_result
							js.return
						end
					end
					if not js.return_called then
						l_startwrite := -1
						Result := ({PC_CURLCODE}.CURLE_OK)
					end
				when 31 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	send_telnet_data (a_conn: CE_POINTER [PD_CONNECTDATA]; a_buffer: CE_POINTER [INTEGER_8]; a_nread: INTEGER_32): INTEGER_32
		local
			l_buffer: CE_POINTER [INTEGER_8]
			l_nread: INTEGER_32
			l_outbuf: CE_ARRAY [NATURAL_8]
			l_bytes_written: INTEGER_32
			l_total_written: INTEGER_32
			l_out_count: INTEGER_32
			l_rc: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: INTEGER_32
			l_pfd: CE_ARRAY [SD_POLLFD]
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buffer.make
			create l_outbuf.make (<<2>>)
			create l_tmp.make
			create l_pfd.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buffer.ce_gets (a_buffer)
					l_nread := a_nread
					l_rc := {PC_CURLCODE}.CURLE_OK
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 11 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if l_rc.to_natural_32 = {NATURAL_32} 0 then
							l_tmp___2 := l_nread
							l_nread := l_nread - 1
							if not l_tmp___2.to_boolean then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if:
						l_tmp.ce_gets (l_buffer)
						l_buffer.ce_gets (l_buffer + 1)
						l_outbuf[0] := (l_tmp[0]).to_natural_8
						l_out_count := 1
						if (l_outbuf[0]).to_integer_32 = 255 then
							l_tmp___0 := l_out_count
							l_out_count := l_out_count + 1
							l_outbuf[l_tmp___0] := (255).to_natural_8
						end
						l_total_written := 0
				when 4 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 9 -- skip loop
						end
				when 5 then -- loop body:
						js.reset
						l_pfd[0].fd := a_conn.item.sock[0]
						l_pfd[0].events := (4).to_integer_16
						inspect (select_inst.Curl_poll (l_pfd, {NATURAL_32} 1, -1)) -- switch 1 head
						when -1 then l_pos := -1 + 6
						when 0 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 6 then -- switch 1, case -1 | switch 1, case 0
						l_rc := {PC_CURLCODE}.CURLE_SEND_ERROR
						l_pos := -1 + 8 -- switch 1; break
				when 7 then -- switch 1, default:
						l_bytes_written := 0
						l_rc := sendf_inst.Curl_write (a_conn, a_conn.item.sock[0], create {CE_POINTER [ANY]}.make_cast ((l_outbuf + l_total_written)), (l_out_count - l_total_written).to_natural_32, create {CE_POINTER [INTEGER_32]}.make_shared ($l_bytes_written))
						l_total_written := l_total_written + l_bytes_written
						l_pos := -1 + 8 -- switch 1; break
				when 8 then -- switch 1, done:
						if l_rc.to_natural_32 = {NATURAL_32} 0 then
							if not (l_total_written < l_out_count) then
								js.break
							end
						else
							js.break
						end
						l_pos := -1 + 4 -- back to loop condition
				when 9 then -- loop done
						js.reset
				when 10 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 11 then -- loop done
					js.reset
					Result := l_rc
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	telnet_done (a_conn: CE_POINTER [PD_CONNECTDATA]; a_status: INTEGER_32; a_premature: BOOLEAN): INTEGER_32
		local
			l_tn: CE_POINTER [PD_TELNET]
		do
			create l_tn.make

			l_tn.ce_gets (create {CE_POINTER [PD_TELNET]}.make_cast ((a_conn.item.data).item.state.proto.telnet))
			slist_inst.curl_slist_free_all (l_tn.item.telnet_vars)
			easy_inst.Curl_cfree.call ([(a_conn.item.data).item.state.proto.telnet]);
			(a_conn.item.data).item.state.proto.telnet := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	telnet_done_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent telnet_done)
		end

	telnet_do (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): INTEGER_32
		local
			l_code: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_sockfd: INTEGER_32
			l_interval_ms: INTEGER_32
			l_pfd: CE_ARRAY [SD_POLLFD]
			l_poll_cnt: INTEGER_32
			l_total_dl: INTEGER_64
			l_total_ul: INTEGER_64
			l_nread: INTEGER_32
			l_now: SD_TIMEVAL
			l_keepon: BOOLEAN
			l_buf: CE_POINTER [INTEGER_8]
			l_tn: CE_POINTER [PD_TELNET]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_data.make
			create l_pfd.make (<<2>>)
			create l_now.make
			create l_buf.make
			create l_tn.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data.ce_gets (a_conn.item.data)
					l_sockfd := a_conn.item.sock[0]
					l_total_dl := (0).to_integer_64
					l_total_ul := (0).to_integer_64
					l_keepon := (1).to_boolean
					l_buf.ce_gets (l_data.item.state.buffer)
					a_done.item := (1).to_boolean
					l_code := init_telnet (a_conn)
					if l_code.to_boolean then
						Result := l_code
						js.return
					end
					if not js.return_called then
						l_tn.ce_gets (create {CE_POINTER [PD_TELNET]}.make_cast (l_data.item.state.proto.telnet))
						l_code := check_telnet_options (a_conn)
						if l_code.to_boolean then
							Result := l_code
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 24 -- skip if block
					end
				when 1 then -- if:
						l_pfd[0].fd := l_sockfd
						l_pfd[0].events := (1).to_integer_16
						if (l_data.item.set.is_fread_set).to_boolean then
							l_poll_cnt := 1
							l_interval_ms := 100
						else
							l_pfd[1].fd := 0
							l_pfd[1].events := (1).to_integer_16
							l_poll_cnt := 2
							l_interval_ms := 1000
						end
				when 2 then -- loop condition:
						if not (not js.loop_left and then l_keepon) then
							l_pos := -1 + 23 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						inspect (select_inst.Curl_poll (l_pfd, l_poll_cnt.to_natural_32, l_interval_ms)) -- switch 1 head
						when -1 then l_pos := -1 + 4
						when 0 then l_pos := -1 + 5
						else l_pos := -1 + 6
						end
				when 4 then -- switch 1, case -1
						l_keepon := (0).to_boolean
						js.continue
				when 5 then -- switch 1, case 0
						if not js.loop_jumped then
							l_pfd[0].revents := (0).to_integer_16
							l_pfd[1].revents := (0).to_integer_16
						end
				when 6 then -- switch 1, default:
						if js.loop_jumped then
							l_pos := -1 + 21 -- skip if block
						end
				when 7 then -- if:
						if not ((((l_pfd[0].revents).to_integer_32).bit_and (1)).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 8 then -- if:
						l_code := sendf_inst.Curl_read (a_conn, l_sockfd, l_buf, (16383).to_natural_32, create {CE_POINTER [INTEGER_32]}.make_shared ($l_nread))
						if l_code.to_natural_32 = {NATURAL_32} 81 then
							l_pos := -1 + 22 -- switch 1; break
						elseif l_code.to_boolean then
							l_keepon := (0).to_boolean
							l_pos := -1 + 22 -- switch 1; break
						elseif l_nread <= 0 then
							l_keepon := (0).to_boolean
							l_pos := -1 + 22 -- switch 1; break
						end
				when 9 then
						l_total_dl := l_total_dl + l_nread.to_integer_64
						progress_inst.Curl_pgrsSetDownloadCounter (l_data, l_total_dl)
						l_code := telrcv (a_conn, create {CE_POINTER [NATURAL_8]}.make_cast (l_buf), l_nread)
						if l_code.to_boolean then
							l_keepon := (0).to_boolean
							l_pos := -1 + 22 -- switch 1; break
						end
				when 10 then
						if (l_tn.item.please_negotiate).to_boolean then
							if not (l_tn.item.already_negotiated).to_boolean then
								negotiate (a_conn)
								l_tn.item.already_negotiated := 1
							end
						end
				when 11 then -- if done
						l_nread := 0
						if l_poll_cnt /= 2 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if (((l_pfd[1].revents).to_integer_32).bit_and (1)).to_boolean then
							l_nread := read (0, create {CE_POINTER [ANY]}.make_cast (l_buf), (16383).to_natural_32)
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 14 then -- else:
						l_nread := ((a_conn.item.fread_func).natural_32_item ([l_buf, (1).to_natural_32, (16383).to_natural_32, a_conn.item.fread_in])).to_integer_32
						if l_nread = 268435456 then
							l_keepon := (0).to_boolean
							l_pos := -1 + 22 -- switch 1; break
						end
				when 15 then
						if l_nread = 268435457 then
							l_pos := -1 + 22 -- switch 1; break
						end
				when 16 then
						if not (l_nread > 0) then
							l_pos := -1 + 20 -- skip if block
						end
				when 17 then -- if:
						l_code := send_telnet_data (a_conn, l_buf, l_nread)
						if l_code.to_boolean then
							l_keepon := (0).to_boolean
							l_pos := -1 + 22 -- switch 1; break
						end
				when 18 then
						l_total_ul := l_total_ul + l_nread.to_integer_64
						progress_inst.Curl_pgrsSetUploadCounter (l_data, l_total_ul)
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						if l_nread < 0 then
							l_keepon := (0).to_boolean
						end
				when 21 then -- if done | if done
						l_pos := -1 + 22 -- switch 1; break
				when 22 then -- switch 1, done:
						if not js.loop_jumped then
							if (l_data.item.set.timeout).to_boolean then
								l_now.ce_gets (timeval_inst.curlx_tvnow)
								if (timeval_inst.curlx_tvdiff (l_now, a_conn.item.created)) >= l_data.item.set.timeout then
									sendf_inst.Curl_failf ([l_data, ce_string ("Time-out")])
									l_code := {PC_CURLCODE}.CURLE_OPERATION_TIMEDOUT
									l_keepon := (0).to_boolean
								end
							end
							if (progress_inst.Curl_pgrsUpdate (a_conn)).to_boolean then
								l_code := {PC_CURLCODE}.CURLE_ABORTED_BY_CALLBACK
								js.break
							end
						end
						l_pos := -1 + 2 -- back to loop condition
				when 23 then -- loop done
						js.reset
						transfer_inst.Curl_setup_transfer (a_conn, -1, (-1).to_integer_64, (0).to_boolean, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer), -1, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer))
						Result := l_code
				when 24 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	telnet_do_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent telnet_do)
		end

end
