class
	P_TIMEVAL

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	curlx_tvnow: SD_TIMEVAL
		local
			l_now: SD_TIMEVAL
			l_tsnow: SD_TIMESPEC
		do
			create l_now.make
			create l_tsnow.make

			if 0 = (clock_gettime (1, l_tsnow.address)) then
				l_now.tv_sec := l_tsnow.tv_sec
				l_now.tv_usec := l_tsnow.tv_nsec // 1000
			else
				gettimeofday ((l_now.address), create {CE_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
			end
			Result := l_now
		end

	curlx_tvdiff (a_newer: SD_TIMEVAL; a_older: SD_TIMEVAL): INTEGER_32
		do
			Result := ((a_newer.tv_sec - a_older.tv_sec) * 1000 + (a_newer.tv_usec - a_older.tv_usec) // 1000)
		end

	curlx_tvdiff_secs (a_newer: SD_TIMEVAL; a_older: SD_TIMEVAL): REAL_64
		do
			Result := ((a_newer.tv_sec - a_older.tv_sec).to_double + (a_newer.tv_usec - a_older.tv_usec).to_double / 1000000.0)
		end

	Curl_tvlong (a_t1: SD_TIMEVAL): INTEGER_32
		do
			Result := (a_t1.tv_sec)
		end

end
