class
	SD_HOSTENT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	h_name: CE_POINTER [INTEGER_8] assign set_h_name
		do
			create Result.make_shared (c_h_name (c_pointer))
		end

	h_aliases: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_h_aliases
		do
			create Result.make_shared (c_h_aliases (c_pointer))
		end

	h_addrtype: INTEGER_32 assign set_h_addrtype
		do
			Result := c_h_addrtype (c_pointer)
		end

	h_length: INTEGER_32 assign set_h_length
		do
			Result := c_h_length (c_pointer)
		end

	h_addr_list: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_h_addr_list
		do
			create Result.make_shared (c_h_addr_list (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_h_name (a_h_name: CE_POINTER [INTEGER_8])
		do
			c_set_h_name (c_pointer, a_h_name.c_pointer)
		end

	set_h_aliases (a_h_aliases: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			c_set_h_aliases (c_pointer, a_h_aliases.c_pointer)
		end

	set_h_addrtype (a_h_addrtype: INTEGER_32)
		do
			c_set_h_addrtype (c_pointer, a_h_addrtype)
		end

	set_h_length (a_h_length: INTEGER_32)
		do
			c_set_h_length (c_pointer, a_h_length)
		end

	set_h_addr_list (a_h_addr_list: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			c_set_h_addr_list (c_pointer, a_h_addr_list.c_pointer)
		end

feature {NONE} -- C getters

	c_h_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct hostent *)$tmp)->h_name;"
		end

	c_h_aliases (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char * *)((struct hostent *)$tmp)->h_aliases;"
		end

	c_h_addrtype (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct hostent *)$tmp)->h_addrtype;"
		end

	c_h_length (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct hostent *)$tmp)->h_length;"
		end

	c_h_addr_list (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char * *)((struct hostent *)$tmp)->h_addr_list;"
		end

feature {NONE} -- C setters

	c_set_h_name (tmp: POINTER; a_h_name: POINTER)
		external
			"C inline"
		alias
			"((struct hostent *)$tmp)->h_name = (char *)$a_h_name;"
		end

	c_set_h_aliases (tmp: POINTER; a_h_aliases: POINTER)
		external
			"C inline"
		alias
			"((struct hostent *)$tmp)->h_aliases = (char * *)$a_h_aliases;"
		end

	c_set_h_addrtype (tmp: POINTER; a_h_addrtype: INTEGER_32)
		external
			"C inline"
		alias
			"((struct hostent *)$tmp)->h_addrtype = $a_h_addrtype;"
		end

	c_set_h_length (tmp: POINTER; a_h_length: INTEGER_32)
		external
			"C inline"
		alias
			"((struct hostent *)$tmp)->h_length = $a_h_length;"
		end

	c_set_h_addr_list (tmp: POINTER; a_h_addr_list: POINTER)
		external
			"C inline"
		alias
			"((struct hostent *)$tmp)->h_addr_list = (char * *)$a_h_addr_list;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct hostent);"
		end

end
