class
	SD_IFA_IFU

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ifu_broadaddr: CE_POINTER [SD_SOCKADDR] assign set_ifu_broadaddr
		do
			create Result.make_shared (c_ifu_broadaddr (c_pointer))
		end

	ifu_dstaddr: CE_POINTER [SD_SOCKADDR] assign set_ifu_dstaddr
		do
			create Result.make_shared (c_ifu_dstaddr (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_ifu_broadaddr (a_ifu_broadaddr: CE_POINTER [SD_SOCKADDR])
		do
			c_set_ifu_broadaddr (c_pointer, a_ifu_broadaddr.c_pointer)
		end

	set_ifu_dstaddr (a_ifu_dstaddr: CE_POINTER [SD_SOCKADDR])
		do
			c_set_ifu_dstaddr (c_pointer, a_ifu_dstaddr.c_pointer)
		end

feature {NONE} -- C getters

	c_ifu_broadaddr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct sockaddr *)((union __anonunion_ifa_ifu_48 *)$tmp)->ifu_broadaddr;"
		end

	c_ifu_dstaddr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct sockaddr *)((union __anonunion_ifa_ifu_48 *)$tmp)->ifu_dstaddr;"
		end

feature {NONE} -- C setters

	c_set_ifu_broadaddr (tmp: POINTER; a_ifu_broadaddr: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_ifa_ifu_48 *)$tmp)->ifu_broadaddr = (struct sockaddr *)$a_ifu_broadaddr;"
		end

	c_set_ifu_dstaddr (tmp: POINTER; a_ifu_dstaddr: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_ifa_ifu_48 *)$tmp)->ifu_dstaddr = (struct sockaddr *)$a_ifu_dstaddr;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(union __anonunion_ifa_ifu_48);"
		end

end
