class
	SD_IFADDRS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ifa_next: CE_POINTER [SD_IFADDRS] assign set_ifa_next
		do
			create Result.make_shared (c_ifa_next (c_pointer))
		end

	ifa_name: CE_POINTER [INTEGER_8] assign set_ifa_name
		do
			create Result.make_shared (c_ifa_name (c_pointer))
		end

	ifa_flags: NATURAL_32 assign set_ifa_flags
		do
			Result := c_ifa_flags (c_pointer)
		end

	ifa_addr: CE_POINTER [SD_SOCKADDR] assign set_ifa_addr
		do
			create Result.make_shared (c_ifa_addr (c_pointer))
		end

	ifa_netmask: CE_POINTER [SD_SOCKADDR] assign set_ifa_netmask
		do
			create Result.make_shared (c_ifa_netmask (c_pointer))
		end

	ifa_ifu: SD_IFA_IFU assign set_ifa_ifu
		do
			create Result.make_shared (c_ifa_ifu (c_pointer))
		end

	ifa_data: CE_POINTER [ANY] assign set_ifa_data
		do
			create Result.make_shared (c_ifa_data (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_ifa_next (a_ifa_next: CE_POINTER [SD_IFADDRS])
		do
			c_set_ifa_next (c_pointer, a_ifa_next.c_pointer)
		end

	set_ifa_name (a_ifa_name: CE_POINTER [INTEGER_8])
		do
			c_set_ifa_name (c_pointer, a_ifa_name.c_pointer)
		end

	set_ifa_flags (a_ifa_flags: NATURAL_32)
		do
			c_set_ifa_flags (c_pointer, a_ifa_flags)
		end

	set_ifa_addr (a_ifa_addr: CE_POINTER [SD_SOCKADDR])
		do
			c_set_ifa_addr (c_pointer, a_ifa_addr.c_pointer)
		end

	set_ifa_netmask (a_ifa_netmask: CE_POINTER [SD_SOCKADDR])
		do
			c_set_ifa_netmask (c_pointer, a_ifa_netmask.c_pointer)
		end

	set_ifa_ifu (a_ifa_ifu: SD_IFA_IFU)
		do
			ifa_ifu.ce_gets (a_ifa_ifu)
		end

	set_ifa_data (a_ifa_data: CE_POINTER [ANY])
		do
			c_set_ifa_data (c_pointer, a_ifa_data.c_pointer)
		end

feature {NONE} -- C getters

	c_ifa_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct ifaddrs *)((struct ifaddrs *)$tmp)->ifa_next;"
		end

	c_ifa_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct ifaddrs *)$tmp)->ifa_name;"
		end

	c_ifa_flags (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct ifaddrs *)$tmp)->ifa_flags;"
		end

	c_ifa_addr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct sockaddr *)((struct ifaddrs *)$tmp)->ifa_addr;"
		end

	c_ifa_netmask (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct sockaddr *)((struct ifaddrs *)$tmp)->ifa_netmask;"
		end

	c_ifa_ifu (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_ifa_ifu_48 *)&((struct ifaddrs *)$tmp)->ifa_ifu;"
		end

	c_ifa_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct ifaddrs *)$tmp)->ifa_data;"
		end

feature {NONE} -- C setters

	c_set_ifa_next (tmp: POINTER; a_ifa_next: POINTER)
		external
			"C inline"
		alias
			"((struct ifaddrs *)$tmp)->ifa_next = (struct ifaddrs *)$a_ifa_next;"
		end

	c_set_ifa_name (tmp: POINTER; a_ifa_name: POINTER)
		external
			"C inline"
		alias
			"((struct ifaddrs *)$tmp)->ifa_name = (char *)$a_ifa_name;"
		end

	c_set_ifa_flags (tmp: POINTER; a_ifa_flags: NATURAL_32)
		external
			"C inline"
		alias
			"((struct ifaddrs *)$tmp)->ifa_flags = $a_ifa_flags;"
		end

	c_set_ifa_addr (tmp: POINTER; a_ifa_addr: POINTER)
		external
			"C inline"
		alias
			"((struct ifaddrs *)$tmp)->ifa_addr = (struct sockaddr *)$a_ifa_addr;"
		end

	c_set_ifa_netmask (tmp: POINTER; a_ifa_netmask: POINTER)
		external
			"C inline"
		alias
			"((struct ifaddrs *)$tmp)->ifa_netmask = (struct sockaddr *)$a_ifa_netmask;"
		end

	c_set_ifa_data (tmp: POINTER; a_ifa_data: POINTER)
		external
			"C inline"
		alias
			"((struct ifaddrs *)$tmp)->ifa_data = (void *)$a_ifa_data;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct ifaddrs);"
		end

end
