class
	SD_PASSWD

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	pw_name: CE_POINTER [INTEGER_8] assign set_pw_name
		do
			create Result.make_shared (c_pw_name (c_pointer))
		end

	pw_passwd: CE_POINTER [INTEGER_8] assign set_pw_passwd
		do
			create Result.make_shared (c_pw_passwd (c_pointer))
		end

	pw_uid: NATURAL_32 assign set_pw_uid
		do
			Result := c_pw_uid (c_pointer)
		end

	pw_gid: NATURAL_32 assign set_pw_gid
		do
			Result := c_pw_gid (c_pointer)
		end

	pw_gecos: CE_POINTER [INTEGER_8] assign set_pw_gecos
		do
			create Result.make_shared (c_pw_gecos (c_pointer))
		end

	pw_dir: CE_POINTER [INTEGER_8] assign set_pw_dir
		do
			create Result.make_shared (c_pw_dir (c_pointer))
		end

	pw_shell: CE_POINTER [INTEGER_8] assign set_pw_shell
		do
			create Result.make_shared (c_pw_shell (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_pw_name (a_pw_name: CE_POINTER [INTEGER_8])
		do
			c_set_pw_name (c_pointer, a_pw_name.c_pointer)
		end

	set_pw_passwd (a_pw_passwd: CE_POINTER [INTEGER_8])
		do
			c_set_pw_passwd (c_pointer, a_pw_passwd.c_pointer)
		end

	set_pw_uid (a_pw_uid: NATURAL_32)
		do
			c_set_pw_uid (c_pointer, a_pw_uid)
		end

	set_pw_gid (a_pw_gid: NATURAL_32)
		do
			c_set_pw_gid (c_pointer, a_pw_gid)
		end

	set_pw_gecos (a_pw_gecos: CE_POINTER [INTEGER_8])
		do
			c_set_pw_gecos (c_pointer, a_pw_gecos.c_pointer)
		end

	set_pw_dir (a_pw_dir: CE_POINTER [INTEGER_8])
		do
			c_set_pw_dir (c_pointer, a_pw_dir.c_pointer)
		end

	set_pw_shell (a_pw_shell: CE_POINTER [INTEGER_8])
		do
			c_set_pw_shell (c_pointer, a_pw_shell.c_pointer)
		end

feature {NONE} -- C getters

	c_pw_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct passwd *)$tmp)->pw_name;"
		end

	c_pw_passwd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct passwd *)$tmp)->pw_passwd;"
		end

	c_pw_uid (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct passwd *)$tmp)->pw_uid;"
		end

	c_pw_gid (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct passwd *)$tmp)->pw_gid;"
		end

	c_pw_gecos (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct passwd *)$tmp)->pw_gecos;"
		end

	c_pw_dir (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct passwd *)$tmp)->pw_dir;"
		end

	c_pw_shell (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct passwd *)$tmp)->pw_shell;"
		end

feature {NONE} -- C setters

	c_set_pw_name (tmp: POINTER; a_pw_name: POINTER)
		external
			"C inline"
		alias
			"((struct passwd *)$tmp)->pw_name = (char *)$a_pw_name;"
		end

	c_set_pw_passwd (tmp: POINTER; a_pw_passwd: POINTER)
		external
			"C inline"
		alias
			"((struct passwd *)$tmp)->pw_passwd = (char *)$a_pw_passwd;"
		end

	c_set_pw_uid (tmp: POINTER; a_pw_uid: NATURAL_32)
		external
			"C inline"
		alias
			"((struct passwd *)$tmp)->pw_uid = $a_pw_uid;"
		end

	c_set_pw_gid (tmp: POINTER; a_pw_gid: NATURAL_32)
		external
			"C inline"
		alias
			"((struct passwd *)$tmp)->pw_gid = $a_pw_gid;"
		end

	c_set_pw_gecos (tmp: POINTER; a_pw_gecos: POINTER)
		external
			"C inline"
		alias
			"((struct passwd *)$tmp)->pw_gecos = (char *)$a_pw_gecos;"
		end

	c_set_pw_dir (tmp: POINTER; a_pw_dir: POINTER)
		external
			"C inline"
		alias
			"((struct passwd *)$tmp)->pw_dir = (char *)$a_pw_dir;"
		end

	c_set_pw_shell (tmp: POINTER; a_pw_shell: POINTER)
		external
			"C inline"
		alias
			"((struct passwd *)$tmp)->pw_shell = (char *)$a_pw_shell;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct passwd);"
		end

end
