class
	SD_POLLFD

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	fd: INTEGER_32 assign set_fd
		do
			Result := c_fd (c_pointer)
		end

	events: INTEGER_16 assign set_events
		do
			Result := c_events (c_pointer)
		end

	revents: INTEGER_16 assign set_revents
		do
			Result := c_revents (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_fd (a_fd: INTEGER_32)
		do
			c_set_fd (c_pointer, a_fd)
		end

	set_events (a_events: INTEGER_16)
		do
			c_set_events (c_pointer, a_events)
		end

	set_revents (a_revents: INTEGER_16)
		do
			c_set_revents (c_pointer, a_revents)
		end

feature {NONE} -- C getters

	c_fd (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct pollfd *)$tmp)->fd;"
		end

	c_events (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct pollfd *)$tmp)->events;"
		end

	c_revents (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct pollfd *)$tmp)->revents;"
		end

feature {NONE} -- C setters

	c_set_fd (tmp: POINTER; a_fd: INTEGER_32)
		external
			"C inline"
		alias
			"((struct pollfd *)$tmp)->fd = $a_fd;"
		end

	c_set_events (tmp: POINTER; a_events: INTEGER_16)
		external
			"C inline"
		alias
			"((struct pollfd *)$tmp)->events = $a_events;"
		end

	c_set_revents (tmp: POINTER; a_revents: INTEGER_16)
		external
			"C inline"
		alias
			"((struct pollfd *)$tmp)->revents = $a_revents;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct pollfd);"
		end

end
