class
	SD_SIGVAL

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sival_int: INTEGER_32 assign set_sival_int
		do
			Result := c_sival_int (c_pointer)
		end

	sival_ptr: CE_POINTER [ANY] assign set_sival_ptr
		do
			create Result.make_shared (c_sival_ptr (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_sival_int (a_sival_int: INTEGER_32)
		do
			c_set_sival_int (c_pointer, a_sival_int)
		end

	set_sival_ptr (a_sival_ptr: CE_POINTER [ANY])
		do
			c_set_sival_ptr (c_pointer, a_sival_ptr.c_pointer)
		end

feature {NONE} -- C getters

	c_sival_int (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union sigval *)$tmp)->sival_int;"
		end

	c_sival_ptr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((union sigval *)$tmp)->sival_ptr;"
		end

feature {NONE} -- C setters

	c_set_sival_int (tmp: POINTER; a_sival_int: INTEGER_32)
		external
			"C inline"
		alias
			"((union sigval *)$tmp)->sival_int = $a_sival_int;"
		end

	c_set_sival_ptr (tmp: POINTER; a_sival_ptr: POINTER)
		external
			"C inline"
		alias
			"((union sigval *)$tmp)->sival_ptr = (void *)$a_sival_ptr;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(union sigval);"
		end

end
