class
	SD_SOCKADDR_IN6

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sin6_family: NATURAL_16 assign set_sin6_family
		do
			Result := c_sin6_family (c_pointer)
		end

	sin6_port: NATURAL_16 assign set_sin6_port
		do
			Result := c_sin6_port (c_pointer)
		end

	sin6_flowinfo: NATURAL_32 assign set_sin6_flowinfo
		do
			Result := c_sin6_flowinfo (c_pointer)
		end

	sin6_addr: SD_IN6_ADDR assign set_sin6_addr
		do
			create Result.make_shared (c_sin6_addr (c_pointer))
		end

	sin6_addr_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct sockaddr_in6, sin6_addr);"
		end

	sin6_scope_id: NATURAL_32 assign set_sin6_scope_id
		do
			Result := c_sin6_scope_id (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_sin6_family (a_sin6_family: NATURAL_16)
		do
			c_set_sin6_family (c_pointer, a_sin6_family)
		end

	set_sin6_port (a_sin6_port: NATURAL_16)
		do
			c_set_sin6_port (c_pointer, a_sin6_port)
		end

	set_sin6_flowinfo (a_sin6_flowinfo: NATURAL_32)
		do
			c_set_sin6_flowinfo (c_pointer, a_sin6_flowinfo)
		end

	set_sin6_addr (a_sin6_addr: SD_IN6_ADDR)
		do
			sin6_addr.ce_gets (a_sin6_addr)
		end

	set_sin6_scope_id (a_sin6_scope_id: NATURAL_32)
		do
			c_set_sin6_scope_id (c_pointer, a_sin6_scope_id)
		end

feature {NONE} -- C getters

	c_sin6_family (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct sockaddr_in6 *)$tmp)->sin6_family;"
		end

	c_sin6_port (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct sockaddr_in6 *)$tmp)->sin6_port;"
		end

	c_sin6_flowinfo (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct sockaddr_in6 *)$tmp)->sin6_flowinfo;"
		end

	c_sin6_addr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct in6_addr *)&((struct sockaddr_in6 *)$tmp)->sin6_addr;"
		end

	c_sin6_scope_id (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct sockaddr_in6 *)$tmp)->sin6_scope_id;"
		end

feature {NONE} -- C setters

	c_set_sin6_family (tmp: POINTER; a_sin6_family: NATURAL_16)
		external
			"C inline"
		alias
			"((struct sockaddr_in6 *)$tmp)->sin6_family = $a_sin6_family;"
		end

	c_set_sin6_port (tmp: POINTER; a_sin6_port: NATURAL_16)
		external
			"C inline"
		alias
			"((struct sockaddr_in6 *)$tmp)->sin6_port = $a_sin6_port;"
		end

	c_set_sin6_flowinfo (tmp: POINTER; a_sin6_flowinfo: NATURAL_32)
		external
			"C inline"
		alias
			"((struct sockaddr_in6 *)$tmp)->sin6_flowinfo = $a_sin6_flowinfo;"
		end

	c_set_sin6_scope_id (tmp: POINTER; a_sin6_scope_id: NATURAL_32)
		external
			"C inline"
		alias
			"((struct sockaddr_in6 *)$tmp)->sin6_scope_id = $a_sin6_scope_id;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct sockaddr_in6);"
		end

end
