class
	SD_TIMESPEC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	tv_sec: INTEGER_32 assign set_tv_sec
		do
			Result := c_tv_sec (c_pointer)
		end

	tv_nsec: INTEGER_32 assign set_tv_nsec
		do
			Result := c_tv_nsec (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_tv_sec (a_tv_sec: INTEGER_32)
		do
			c_set_tv_sec (c_pointer, a_tv_sec)
		end

	set_tv_nsec (a_tv_nsec: INTEGER_32)
		do
			c_set_tv_nsec (c_pointer, a_tv_nsec)
		end

feature {NONE} -- C getters

	c_tv_sec (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct timespec *)$tmp)->tv_sec;"
		end

	c_tv_nsec (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct timespec *)$tmp)->tv_nsec;"
		end

feature {NONE} -- C setters

	c_set_tv_sec (tmp: POINTER; a_tv_sec: INTEGER_32)
		external
			"C inline"
		alias
			"((struct timespec *)$tmp)->tv_sec = $a_tv_sec;"
		end

	c_set_tv_nsec (tmp: POINTER; a_tv_nsec: INTEGER_32)
		external
			"C inline"
		alias
			"((struct timespec *)$tmp)->tv_nsec = $a_tv_nsec;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct timespec);"
		end

end
