class
	SD_TM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	tm_sec: INTEGER_32 assign set_tm_sec
		do
			Result := c_tm_sec (c_pointer)
		end

	tm_min: INTEGER_32 assign set_tm_min
		do
			Result := c_tm_min (c_pointer)
		end

	tm_hour: INTEGER_32 assign set_tm_hour
		do
			Result := c_tm_hour (c_pointer)
		end

	tm_mday: INTEGER_32 assign set_tm_mday
		do
			Result := c_tm_mday (c_pointer)
		end

	tm_mon: INTEGER_32 assign set_tm_mon
		do
			Result := c_tm_mon (c_pointer)
		end

	tm_year: INTEGER_32 assign set_tm_year
		do
			Result := c_tm_year (c_pointer)
		end

	tm_wday: INTEGER_32 assign set_tm_wday
		do
			Result := c_tm_wday (c_pointer)
		end

	tm_yday: INTEGER_32 assign set_tm_yday
		do
			Result := c_tm_yday (c_pointer)
		end

	tm_isdst: INTEGER_32 assign set_tm_isdst
		do
			Result := c_tm_isdst (c_pointer)
		end

	tm_gmtoff: INTEGER_32 assign set_tm_gmtoff
		do
			Result := c_tm_gmtoff (c_pointer)
		end

	tm_zone: CE_POINTER [INTEGER_8] assign set_tm_zone
		do
			create Result.make_shared (c_tm_zone (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_tm_sec (a_tm_sec: INTEGER_32)
		do
			c_set_tm_sec (c_pointer, a_tm_sec)
		end

	set_tm_min (a_tm_min: INTEGER_32)
		do
			c_set_tm_min (c_pointer, a_tm_min)
		end

	set_tm_hour (a_tm_hour: INTEGER_32)
		do
			c_set_tm_hour (c_pointer, a_tm_hour)
		end

	set_tm_mday (a_tm_mday: INTEGER_32)
		do
			c_set_tm_mday (c_pointer, a_tm_mday)
		end

	set_tm_mon (a_tm_mon: INTEGER_32)
		do
			c_set_tm_mon (c_pointer, a_tm_mon)
		end

	set_tm_year (a_tm_year: INTEGER_32)
		do
			c_set_tm_year (c_pointer, a_tm_year)
		end

	set_tm_wday (a_tm_wday: INTEGER_32)
		do
			c_set_tm_wday (c_pointer, a_tm_wday)
		end

	set_tm_yday (a_tm_yday: INTEGER_32)
		do
			c_set_tm_yday (c_pointer, a_tm_yday)
		end

	set_tm_isdst (a_tm_isdst: INTEGER_32)
		do
			c_set_tm_isdst (c_pointer, a_tm_isdst)
		end

	set_tm_gmtoff (a_tm_gmtoff: INTEGER_32)
		do
			c_set_tm_gmtoff (c_pointer, a_tm_gmtoff)
		end

	set_tm_zone (a_tm_zone: CE_POINTER [INTEGER_8])
		do
			c_set_tm_zone (c_pointer, a_tm_zone.c_pointer)
		end

feature {NONE} -- C getters

	c_tm_sec (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tm *)$tmp)->tm_sec;"
		end

	c_tm_min (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tm *)$tmp)->tm_min;"
		end

	c_tm_hour (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tm *)$tmp)->tm_hour;"
		end

	c_tm_mday (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tm *)$tmp)->tm_mday;"
		end

	c_tm_mon (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tm *)$tmp)->tm_mon;"
		end

	c_tm_year (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tm *)$tmp)->tm_year;"
		end

	c_tm_wday (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tm *)$tmp)->tm_wday;"
		end

	c_tm_yday (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tm *)$tmp)->tm_yday;"
		end

	c_tm_isdst (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tm *)$tmp)->tm_isdst;"
		end

	c_tm_gmtoff (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct tm *)$tmp)->tm_gmtoff;"
		end

	c_tm_zone (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct tm *)$tmp)->tm_zone;"
		end

feature {NONE} -- C setters

	c_set_tm_sec (tmp: POINTER; a_tm_sec: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tm *)$tmp)->tm_sec = $a_tm_sec;"
		end

	c_set_tm_min (tmp: POINTER; a_tm_min: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tm *)$tmp)->tm_min = $a_tm_min;"
		end

	c_set_tm_hour (tmp: POINTER; a_tm_hour: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tm *)$tmp)->tm_hour = $a_tm_hour;"
		end

	c_set_tm_mday (tmp: POINTER; a_tm_mday: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tm *)$tmp)->tm_mday = $a_tm_mday;"
		end

	c_set_tm_mon (tmp: POINTER; a_tm_mon: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tm *)$tmp)->tm_mon = $a_tm_mon;"
		end

	c_set_tm_year (tmp: POINTER; a_tm_year: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tm *)$tmp)->tm_year = $a_tm_year;"
		end

	c_set_tm_wday (tmp: POINTER; a_tm_wday: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tm *)$tmp)->tm_wday = $a_tm_wday;"
		end

	c_set_tm_yday (tmp: POINTER; a_tm_yday: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tm *)$tmp)->tm_yday = $a_tm_yday;"
		end

	c_set_tm_isdst (tmp: POINTER; a_tm_isdst: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tm *)$tmp)->tm_isdst = $a_tm_isdst;"
		end

	c_set_tm_gmtoff (tmp: POINTER; a_tm_gmtoff: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tm *)$tmp)->tm_gmtoff = $a_tm_gmtoff;"
		end

	c_set_tm_zone (tmp: POINTER; a_tm_zone: POINTER)
		external
			"C inline"
		alias
			"((struct tm *)$tmp)->tm_zone = (char const *)$a_tm_zone;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct tm);"
		end

end
