deferred class
	S_STDIO

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	fclose (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fclose (a_stream.c_pointer)
		end

	c_fclose (a_stream: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return fclose($a_stream);"
		end

	fopen (a_filename: CE_POINTER [INTEGER_8]; a_modes: CE_POINTER [INTEGER_8]): CE_POINTER [SD_IO_FILE]
		do
			create Result.make_shared (c_fopen (a_filename.c_pointer, a_modes.c_pointer))
		end

	c_fopen (a_filename: POINTER; a_modes: POINTER): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return fopen($a_filename, $a_modes);"
		end

	fwrite (a_ptr: CE_POINTER [ANY]; a_size: NATURAL_32; a_n: NATURAL_32; a_s: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fwrite (a_ptr.c_pointer, a_size, a_n, a_s.c_pointer)
		end

	c_fwrite (a_ptr: POINTER; a_size: NATURAL_32; a_n: NATURAL_32; a_s: POINTER): NATURAL_32
		external
			"C inline use <libcurl.h>"
		alias
			"return fwrite($a_ptr, $a_size, $a_n, $a_s);"
		end

	fwrite_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent fwrite)
		end

	fileno (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fileno (a_stream.c_pointer)
		end

	c_fileno (a_stream: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return fileno($a_stream);"
		end

	fflush (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fflush (a_stream.c_pointer)
		end

	c_fflush (a_stream: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return fflush($a_stream);"
		end

	fread (a_ptr: CE_POINTER [ANY]; a_size: NATURAL_32; a_n: NATURAL_32; a_stream: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fread (a_ptr.c_pointer, a_size, a_n, a_stream.c_pointer)
		end

	c_fread (a_ptr: POINTER; a_size: NATURAL_32; a_n: NATURAL_32; a_stream: POINTER): NATURAL_32
		external
			"C inline use <libcurl.h>"
		alias
			"return fread($a_ptr, $a_size, $a_n, $a_stream);"
		end

	fread_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent fread)
		end

	sscanf (a_args: TUPLE [a_s: CE_POINTER [INTEGER_8]; a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_sscanf)).integer_32_item (a_args)
		end

	c_sscanf: POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return &sscanf;"
		end

	fgets (a_s: CE_POINTER [INTEGER_8]; a_n: INTEGER_32; a_stream: CE_POINTER [SD_IO_FILE]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_fgets (a_s.c_pointer, a_n, a_stream.c_pointer))
		end

	c_fgets (a_s: POINTER; a_n: INTEGER_32; a_stream: POINTER): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return fgets($a_s, $a_n, $a_stream);"
		end

	fputs (a_s: CE_POINTER [INTEGER_8]; a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fputs (a_s.c_pointer, a_stream.c_pointer)
		end

	c_fputs (a_s: POINTER; a_stream: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return fputs($a_s, $a_stream);"
		end

	sprintf (a_args: TUPLE [a_s: CE_POINTER [INTEGER_8]; a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_sprintf)).integer_32_item (a_args)
		end

	c_sprintf: POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return &sprintf;"
		end

	fputc (a_c: INTEGER_32; a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fputc (a_c, a_stream.c_pointer)
		end

	c_fputc (a_c: INTEGER_32; a_stream: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return fputc($a_c, $a_stream);"
		end

	fputc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent fputc)
		end

	fseek (a_stream: CE_POINTER [SD_IO_FILE]; a_off: INTEGER_32; a_whence: INTEGER_32): INTEGER_32
		do
			Result := c_fseek (a_stream.c_pointer, a_off, a_whence)
		end

	c_fseek (a_stream: POINTER; a_off: INTEGER_32; a_whence: INTEGER_32): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return fseek($a_stream, $a_off, $a_whence);"
		end

end
