deferred class
	S_STRING

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	strchr (a_s: CE_POINTER [INTEGER_8]; a_c: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strchr (a_s.c_pointer, a_c))
		end

	c_strchr (a_s: POINTER; a_c: INTEGER_32): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return strchr($a_s, $a_c);"
		end

	strlen (a_s: CE_POINTER [INTEGER_8]): NATURAL_32
		do
			Result := c_strlen (a_s.c_pointer)
		end

	c_strlen (a_s: POINTER): NATURAL_32
		external
			"C inline use <libcurl.h>"
		alias
			"return strlen($a_s);"
		end

	strcpy (a_dest: CE_POINTER [INTEGER_8]; a_src: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strcpy (a_dest.c_pointer, a_src.c_pointer))
		end

	c_strcpy (a_dest: POINTER; a_src: POINTER): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return strcpy($a_dest, $a_src);"
		end

	memcpy (a_dest: CE_POINTER [ANY]; a_src: CE_POINTER [ANY]; a_n: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_memcpy (a_dest.c_pointer, a_src.c_pointer, a_n))
		end

	c_memcpy (a_dest: POINTER; a_src: POINTER; a_n: NATURAL_32): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return memcpy($a_dest, $a_src, $a_n);"
		end

	strcmp (a_s1: CE_POINTER [INTEGER_8]; a_s2: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_strcmp (a_s1.c_pointer, a_s2.c_pointer)
		end

	c_strcmp (a_s1: POINTER; a_s2: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return strcmp($a_s1, $a_s2);"
		end

	strncmp (a_s1: CE_POINTER [INTEGER_8]; a_s2: CE_POINTER [INTEGER_8]; a_n: NATURAL_32): INTEGER_32
		do
			Result := c_strncmp (a_s1.c_pointer, a_s2.c_pointer, a_n)
		end

	c_strncmp (a_s1: POINTER; a_s2: POINTER; a_n: NATURAL_32): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return strncmp($a_s1, $a_s2, $a_n);"
		end

	strrchr (a_s: CE_POINTER [INTEGER_8]; a_c: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strrchr (a_s.c_pointer, a_c))
		end

	c_strrchr (a_s: POINTER; a_c: INTEGER_32): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return strrchr($a_s, $a_c);"
		end

	strtok_r (a_s: CE_POINTER [INTEGER_8]; a_delim: CE_POINTER [INTEGER_8]; a_save_ptr: CE_POINTER [CE_POINTER [INTEGER_8]]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strtok_r (a_s.c_pointer, a_delim.c_pointer, a_save_ptr.c_pointer))
		end

	c_strtok_r (a_s: POINTER; a_delim: POINTER; a_save_ptr: POINTER): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return strtok_r($a_s, $a_delim, $a_save_ptr);"
		end

	memchr (a_s: CE_POINTER [ANY]; a_c: INTEGER_32; a_n: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_memchr (a_s.c_pointer, a_c, a_n))
		end

	c_memchr (a_s: POINTER; a_c: INTEGER_32; a_n: NATURAL_32): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return memchr($a_s, $a_c, $a_n);"
		end

	strstr (a_haystack: CE_POINTER [INTEGER_8]; a_needle: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strstr (a_haystack.c_pointer, a_needle.c_pointer))
		end

	c_strstr (a_haystack: POINTER; a_needle: POINTER): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return strstr($a_haystack, $a_needle);"
		end

	memmove (a_dest: CE_POINTER [ANY]; a_src: CE_POINTER [ANY]; a_n: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_memmove (a_dest.c_pointer, a_src.c_pointer, a_n))
		end

	c_memmove (a_dest: POINTER; a_src: POINTER; a_n: NATURAL_32): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return memmove($a_dest, $a_src, $a_n);"
		end

	memcmp (a_s1: CE_POINTER [ANY]; a_s2: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		do
			Result := c_memcmp (a_s1.c_pointer, a_s2.c_pointer, a_n)
		end

	c_memcmp (a_s1: POINTER; a_s2: POINTER; a_n: NATURAL_32): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return memcmp($a_s1, $a_s2, $a_n);"
		end

	memset (a_s: CE_POINTER [ANY]; a_c: INTEGER_32; a_n: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_memset (a_s.c_pointer, a_c, a_n))
		end

	c_memset (a_s: POINTER; a_c: INTEGER_32; a_n: NATURAL_32): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return memset($a_s, $a_c, $a_n);"
		end

	strncpy (a_dest: CE_POINTER [INTEGER_8]; a_src: CE_POINTER [INTEGER_8]; a_n: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strncpy (a_dest.c_pointer, a_src.c_pointer, a_n))
		end

	c_strncpy (a_dest: POINTER; a_src: POINTER; a_n: NATURAL_32): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return strncpy($a_dest, $a_src, $a_n);"
		end

	strcat (a_dest: CE_POINTER [INTEGER_8]; a_src: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strcat (a_dest.c_pointer, a_src.c_pointer))
		end

	c_strcat (a_dest: POINTER; a_src: POINTER): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return strcat($a_dest, $a_src);"
		end

	strcasecmp (a_s1: CE_POINTER [INTEGER_8]; a_s2: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_strcasecmp (a_s1.c_pointer, a_s2.c_pointer)
		end

	c_strcasecmp (a_s1: POINTER; a_s2: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return strcasecmp($a_s1, $a_s2);"
		end

	strncasecmp (a_s1: CE_POINTER [INTEGER_8]; a_s2: CE_POINTER [INTEGER_8]; a_n: NATURAL_32): INTEGER_32
		do
			Result := c_strncasecmp (a_s1.c_pointer, a_s2.c_pointer, a_n)
		end

	c_strncasecmp (a_s1: POINTER; a_s2: POINTER; a_n: NATURAL_32): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return strncasecmp($a_s1, $a_s2, $a_n);"
		end

	strdup (a_s: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strdup (a_s.c_pointer))
		end

	c_strdup (a_s: POINTER): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return strdup($a_s);"
		end

	strdup_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent strdup)
		end

	strerror_r (a_errnum: INTEGER_32; a_buf: CE_POINTER [INTEGER_8]; a_buflen: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strerror_r (a_errnum, a_buf.c_pointer, a_buflen))
		end

	c_strerror_r (a_errnum: INTEGER_32; a_buf: POINTER; a_buflen: NATURAL_32): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return strerror_r($a_errnum, $a_buf, $a_buflen);"
		end

end
