deferred class
	S_UNISTD

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	lseek (a_fd: INTEGER_32; a_offset: INTEGER_32; a_whence: INTEGER_32): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return lseek($a_fd, $a_offset, $a_whence);"
		end

	close (a_fd: INTEGER_32): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return close($a_fd);"
		end

	read (a_fd: INTEGER_32; a_buf: CE_POINTER [ANY]; a_nbytes: NATURAL_32): INTEGER_32
		do
			Result := c_read (a_fd, a_buf.c_pointer, a_nbytes)
		end

	c_read (a_fd: INTEGER_32; a_buf: POINTER; a_nbytes: NATURAL_32): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return read($a_fd, $a_buf, $a_nbytes);"
		end

	alarm (a_seconds: NATURAL_32): NATURAL_32
		external
			"C inline use <libcurl.h>"
		alias
			"return alarm($a_seconds);"
		end

	geteuid: NATURAL_32
		external
			"C inline use <libcurl.h>"
		alias
			"return geteuid();"
		end

	gethostname (a_name: CE_POINTER [INTEGER_8]; a_len: NATURAL_32): INTEGER_32
		do
			Result := c_gethostname (a_name.c_pointer, a_len)
		end

	c_gethostname (a_name: POINTER; a_len: NATURAL_32): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return gethostname($a_name, $a_len);"
		end

end
