class
	PD_BASES

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	chars_per_limb: INTEGER_32 assign set_chars_per_limb
		do
			Result := c_chars_per_limb (c_pointer)
		end

	chars_per_bit_exactly: REAL_64 assign set_chars_per_bit_exactly
		do
			Result := c_chars_per_bit_exactly (c_pointer)
		end

	big_base: NATURAL_32 assign set_big_base
		do
			Result := c_big_base (c_pointer)
		end

	big_base_inverted: NATURAL_32 assign set_big_base_inverted
		do
			Result := c_big_base_inverted (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_chars_per_limb (a_chars_per_limb: INTEGER_32)
		do
			c_set_chars_per_limb (c_pointer, a_chars_per_limb)
		end

	set_chars_per_bit_exactly (a_chars_per_bit_exactly: REAL_64)
		do
			c_set_chars_per_bit_exactly (c_pointer, a_chars_per_bit_exactly)
		end

	set_big_base (a_big_base: NATURAL_32)
		do
			c_set_big_base (c_pointer, a_big_base)
		end

	set_big_base_inverted (a_big_base_inverted: NATURAL_32)
		do
			c_set_big_base_inverted (c_pointer, a_big_base_inverted)
		end

feature {NONE} -- C getters

	c_chars_per_limb (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct bases *)$tmp)->chars_per_limb;"
		end

	c_chars_per_bit_exactly (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct bases *)$tmp)->chars_per_bit_exactly;"
		end

	c_big_base (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct bases *)$tmp)->big_base;"
		end

	c_big_base_inverted (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct bases *)$tmp)->big_base_inverted;"
		end

feature {NONE} -- C setters

	c_set_chars_per_limb (tmp: POINTER; a_chars_per_limb: INTEGER_32)
		external
			"C inline"
		alias
			"((struct bases *)$tmp)->chars_per_limb = $a_chars_per_limb;"
		end

	c_set_chars_per_bit_exactly (tmp: POINTER; a_chars_per_bit_exactly: REAL_64)
		external
			"C inline"
		alias
			"((struct bases *)$tmp)->chars_per_bit_exactly = $a_chars_per_bit_exactly;"
		end

	c_set_big_base (tmp: POINTER; a_big_base: NATURAL_32)
		external
			"C inline"
		alias
			"((struct bases *)$tmp)->big_base = $a_big_base;"
		end

	c_set_big_base_inverted (tmp: POINTER; a_big_base_inverted: NATURAL_32)
		external
			"C inline"
		alias
			"((struct bases *)$tmp)->big_base_inverted = $a_big_base_inverted;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct bases);"
		end

end
