class
	PD_GMP_DOSCAN_FUNS_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	scan: CE_ROUTINE assign set_scan
		do
			create Result.make_shared (c_scan (c_pointer))
		end

	step: CE_ROUTINE assign set_step
		do
			create Result.make_shared (c_step (c_pointer))
		end

	get: CE_ROUTINE assign set_get
		do
			create Result.make_shared (c_get (c_pointer))
		end

	unget: CE_ROUTINE assign set_unget
		do
			create Result.make_shared (c_unget (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_scan (a_scan: CE_ROUTINE)
		do
			c_set_scan (c_pointer, a_scan.c_pointer)
		end

	set_step (a_step: CE_ROUTINE)
		do
			c_set_step (c_pointer, a_step.c_pointer)
		end

	set_get (a_get: CE_ROUTINE)
		do
			c_set_get (c_pointer, a_get.c_pointer)
		end

	set_unget (a_unget: CE_ROUTINE)
		do
			c_set_unget (c_pointer, a_unget.c_pointer)
		end

feature {NONE} -- C getters

	c_scan (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void *, char *, ...))((struct gmp_doscan_funs_t *)$tmp)->scan;"
		end

	c_step (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *( *)(void *, int))((struct gmp_doscan_funs_t *)$tmp)->step;"
		end

	c_get (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void *))((struct gmp_doscan_funs_t *)$tmp)->get;"
		end

	c_unget (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(int, void *))((struct gmp_doscan_funs_t *)$tmp)->unget;"
		end

feature {NONE} -- C setters

	c_set_scan (tmp: POINTER; a_scan: POINTER)
		external
			"C inline"
		alias
			"((struct gmp_doscan_funs_t *)$tmp)->scan = (int( *)(void *, char const *, ...))$a_scan;"
		end

	c_set_step (tmp: POINTER; a_step: POINTER)
		external
			"C inline"
		alias
			"((struct gmp_doscan_funs_t *)$tmp)->step = (void *( *)(void *, int))$a_step;"
		end

	c_set_get (tmp: POINTER; a_get: POINTER)
		external
			"C inline"
		alias
			"((struct gmp_doscan_funs_t *)$tmp)->get = (int( *)(void *))$a_get;"
		end

	c_set_unget (tmp: POINTER; a_unget: POINTER)
		external
			"C inline"
		alias
			"((struct gmp_doscan_funs_t *)$tmp)->unget = (int( *)(int, void *))$a_unget;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct gmp_doscan_funs_t);"
		end

end
