class
	PD_GMP_PRIMES_PTAB

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ppp: NATURAL_32 assign set_ppp
		do
			Result := c_ppp (c_pointer)
		end

	cps: CE_ARRAY [NATURAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_cps (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	idx: NATURAL_32 assign set_idx
		do
			Result := c_idx (c_pointer)
		end

	np: NATURAL_32 assign set_np
		do
			Result := c_np (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_ppp (a_ppp: NATURAL_32)
		do
			c_set_ppp (c_pointer, a_ppp)
		end

	set_idx (a_idx: NATURAL_32)
		do
			c_set_idx (c_pointer, a_idx)
		end

	set_np (a_np: NATURAL_32)
		do
			c_set_np (c_pointer, a_np)
		end

feature {NONE} -- C getters

	c_ppp (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct gmp_primes_ptab *)$tmp)->ppp;"
		end

	c_cps (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct gmp_primes_ptab *tmp = (struct gmp_primes_ptab *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->cps) / sizeof(tmp->cps[0]);
				return tmp->cps;
			]"
		end

	c_idx (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct gmp_primes_ptab *)$tmp)->idx;"
		end

	c_np (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct gmp_primes_ptab *)$tmp)->np;"
		end

feature {NONE} -- C setters

	c_set_ppp (tmp: POINTER; a_ppp: NATURAL_32)
		external
			"C inline"
		alias
			"((struct gmp_primes_ptab *)$tmp)->ppp = $a_ppp;"
		end

	c_set_idx (tmp: POINTER; a_idx: NATURAL_32)
		external
			"C inline"
		alias
			"((struct gmp_primes_ptab *)$tmp)->idx = $a_idx;"
		end

	c_set_np (tmp: POINTER; a_np: NATURAL_32)
		external
			"C inline"
		alias
			"((struct gmp_primes_ptab *)$tmp)->np = $a_np;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct gmp_primes_ptab);"
		end

end
