class
	PD_GMP_PRIMESIEVE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	d: NATURAL_32 assign set_d
		do
			Result := c_d (c_pointer)
		end

	s0: NATURAL_32 assign set_s0
		do
			Result := c_s0 (c_pointer)
		end

	sqrt_s0: NATURAL_32 assign set_sqrt_s0
		do
			Result := c_sqrt_s0 (c_pointer)
		end

	s: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_s (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_d (a_d: NATURAL_32)
		do
			c_set_d (c_pointer, a_d)
		end

	set_s0 (a_s0: NATURAL_32)
		do
			c_set_s0 (c_pointer, a_s0)
		end

	set_sqrt_s0 (a_sqrt_s0: NATURAL_32)
		do
			c_set_sqrt_s0 (c_pointer, a_sqrt_s0)
		end

feature {NONE} -- C getters

	c_d (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_gmp_primesieve_t_12 *)$tmp)->d;"
		end

	c_s0 (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_gmp_primesieve_t_12 *)$tmp)->s0;"
		end

	c_sqrt_s0 (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_gmp_primesieve_t_12 *)$tmp)->sqrt_s0;"
		end

	c_s (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_gmp_primesieve_t_12 *tmp = (struct __anonstruct_gmp_primesieve_t_12 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->s) / sizeof(tmp->s[0]);
				return tmp->s;
			]"
		end

feature {NONE} -- C setters

	c_set_d (tmp: POINTER; a_d: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gmp_primesieve_t_12 *)$tmp)->d = $a_d;"
		end

	c_set_s0 (tmp: POINTER; a_s0: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gmp_primesieve_t_12 *)$tmp)->s0 = $a_s0;"
		end

	c_set_sqrt_s0 (tmp: POINTER; a_sqrt_s0: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gmp_primesieve_t_12 *)$tmp)->sqrt_s0 = $a_sqrt_s0;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct __anonstruct_gmp_primesieve_t_12);"
		end

end
