class
	PD_GMP_RAND_LC_STRUCT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	mp_seed: CE_ARRAY [PD_MPZ_STRUCT]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_mp_seed (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	mp_a: CE_ARRAY [PD_MPZ_STRUCT]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_mp_a (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	cn: INTEGER_32 assign set_cn
		do
			Result := c_cn (c_pointer)
		end

	cp: CE_ARRAY [NATURAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_cp (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	mp_m2exp: NATURAL_32 assign set_mp_m2exp
		do
			Result := c_mp_m2exp (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_cn (a_cn: INTEGER_32)
		do
			c_set_cn (c_pointer, a_cn)
		end

	set_mp_m2exp (a_mp_m2exp: NATURAL_32)
		do
			c_set_mp_m2exp (c_pointer, a_mp_m2exp)
		end

feature {NONE} -- C getters

	c_mp_seed (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_gmp_rand_lc_struct_14 *tmp = (struct __anonstruct_gmp_rand_lc_struct_14 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->_mp_seed) / sizeof(tmp->_mp_seed[0]);
				return tmp->_mp_seed;
			]"
		end

	c_mp_a (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_gmp_rand_lc_struct_14 *tmp = (struct __anonstruct_gmp_rand_lc_struct_14 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->_mp_a) / sizeof(tmp->_mp_a[0]);
				return tmp->_mp_a;
			]"
		end

	c_cn (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_gmp_rand_lc_struct_14 *)$tmp)->_cn;"
		end

	c_cp (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_gmp_rand_lc_struct_14 *tmp = (struct __anonstruct_gmp_rand_lc_struct_14 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->_cp) / sizeof(tmp->_cp[0]);
				return tmp->_cp;
			]"
		end

	c_mp_m2exp (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_gmp_rand_lc_struct_14 *)$tmp)->_mp_m2exp;"
		end

feature {NONE} -- C setters

	c_set_cn (tmp: POINTER; a_cn: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gmp_rand_lc_struct_14 *)$tmp)->_cn = $a_cn;"
		end

	c_set_mp_m2exp (tmp: POINTER; a_mp_m2exp: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gmp_rand_lc_struct_14 *)$tmp)->_mp_m2exp = $a_mp_m2exp;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct __anonstruct_gmp_rand_lc_struct_14);"
		end

end
