class
	PD_GMP_RANDFNPTR_T2

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	randseed_fn: CE_ROUTINE assign set_randseed_fn
		do
			create Result.make_shared (c_randseed_fn (c_pointer))
		end

	randget_fn: CE_ROUTINE assign set_randget_fn
		do
			create Result.make_shared (c_randget_fn (c_pointer))
		end

	randclear_fn: CE_ROUTINE assign set_randclear_fn
		do
			create Result.make_shared (c_randclear_fn (c_pointer))
		end

	randiset_fn: CE_ROUTINE assign set_randiset_fn
		do
			create Result.make_shared (c_randiset_fn (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_randseed_fn (a_randseed_fn: CE_ROUTINE)
		do
			c_set_randseed_fn (c_pointer, a_randseed_fn.c_pointer)
		end

	set_randget_fn (a_randget_fn: CE_ROUTINE)
		do
			c_set_randget_fn (c_pointer, a_randget_fn.c_pointer)
		end

	set_randclear_fn (a_randclear_fn: CE_ROUTINE)
		do
			c_set_randclear_fn (c_pointer, a_randclear_fn.c_pointer)
		end

	set_randiset_fn (a_randiset_fn: CE_ROUTINE)
		do
			c_set_randiset_fn (c_pointer, a_randiset_fn.c_pointer)
		end

feature {NONE} -- C getters

	c_randseed_fn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(__gmp_randstate_struct *, __mpz_struct *))((struct __anonstruct_gmp_randfnptr_t_16 *)$tmp)->randseed_fn;"
		end

	c_randget_fn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(__gmp_randstate_struct *, unsigned long *, unsigned long))((struct __anonstruct_gmp_randfnptr_t_16 *)$tmp)->randget_fn;"
		end

	c_randclear_fn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(__gmp_randstate_struct *))((struct __anonstruct_gmp_randfnptr_t_16 *)$tmp)->randclear_fn;"
		end

	c_randiset_fn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(__gmp_randstate_struct *, __gmp_randstate_struct *))((struct __anonstruct_gmp_randfnptr_t_16 *)$tmp)->randiset_fn;"
		end

feature {NONE} -- C setters

	c_set_randseed_fn (tmp: POINTER; a_randseed_fn: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gmp_randfnptr_t_16 *)$tmp)->randseed_fn = (void( *)(__gmp_randstate_struct *, __mpz_struct *))$a_randseed_fn;"
		end

	c_set_randget_fn (tmp: POINTER; a_randget_fn: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gmp_randfnptr_t_16 *)$tmp)->randget_fn = (void( *)(__gmp_randstate_struct *, unsigned long *, unsigned long))$a_randget_fn;"
		end

	c_set_randclear_fn (tmp: POINTER; a_randclear_fn: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gmp_randfnptr_t_16 *)$tmp)->randclear_fn = (void( *)(__gmp_randstate_struct *))$a_randclear_fn;"
		end

	c_set_randiset_fn (tmp: POINTER; a_randiset_fn: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gmp_randfnptr_t_16 *)$tmp)->randiset_fn = (void( *)(__gmp_randstate_struct *, __gmp_randstate_struct *))$a_randiset_fn;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct __anonstruct_gmp_randfnptr_t_16);"
		end

end
