class
	PD_GMP_RANDSTATE_STRUCT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	mp_seed: CE_ARRAY [PD_MPZ_STRUCT]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_mp_seed (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	mp_alg: INTEGER_32 assign set_mp_alg
		do
			Result := c_mp_alg (c_pointer)
		end

	mp_algdata: PD_MP_ALGDATA assign set_mp_algdata
		do
			create Result.make_shared (c_mp_algdata (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_mp_alg (a_mp_alg: INTEGER_32)
		do
			c_set_mp_alg (c_pointer, a_mp_alg)
		end

	set_mp_algdata (a_mp_algdata: PD_MP_ALGDATA)
		do
			mp_algdata.ce_gets (a_mp_algdata)
		end

feature {NONE} -- C getters

	c_mp_seed (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct___gmp_randstate_struct_10 *tmp = (struct __anonstruct___gmp_randstate_struct_10 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->_mp_seed) / sizeof(tmp->_mp_seed[0]);
				return tmp->_mp_seed;
			]"
		end

	c_mp_alg (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct___gmp_randstate_struct_10 *)$tmp)->_mp_alg;"
		end

	c_mp_algdata (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion__mp_algdata_11 *)&((struct __anonstruct___gmp_randstate_struct_10 *)$tmp)->_mp_algdata;"
		end

feature {NONE} -- C setters

	c_set_mp_alg (tmp: POINTER; a_mp_alg: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct___gmp_randstate_struct_10 *)$tmp)->_mp_alg = $a_mp_alg;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct __anonstruct___gmp_randstate_struct_10);"
		end

end
