class
	PD_GMP_SNPRINTF_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	buf: CE_POINTER [INTEGER_8] assign set_buf
		do
			create Result.make_shared (c_buf (c_pointer))
		end

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_buf (a_buf: CE_POINTER [INTEGER_8])
		do
			c_set_buf (c_pointer, a_buf.c_pointer)
		end

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

feature {NONE} -- C getters

	c_buf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct gmp_snprintf_t *)$tmp)->buf;"
		end

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct gmp_snprintf_t *)$tmp)->size;"
		end

feature {NONE} -- C setters

	c_set_buf (tmp: POINTER; a_buf: POINTER)
		external
			"C inline"
		alias
			"((struct gmp_snprintf_t *)$tmp)->buf = (char *)$a_buf;"
		end

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct gmp_snprintf_t *)$tmp)->size = $a_size;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct gmp_snprintf_t);"
		end

end
