class
	PD_HGCD_MATRIX

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	alloc: INTEGER_32 assign set_alloc
		do
			Result := c_alloc (c_pointer)
		end

	n: INTEGER_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	p: CE_ARRAY [CE_ARRAY [CE_POINTER [NATURAL_32]]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 2)
			create Result.make_shared (c_p (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_alloc (a_alloc: INTEGER_32)
		do
			c_set_alloc (c_pointer, a_alloc)
		end

	set_n (a_n: INTEGER_32)
		do
			c_set_n (c_pointer, a_n)
		end

feature {NONE} -- C getters

	c_alloc (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct hgcd_matrix *)$tmp)->alloc;"
		end

	c_n (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct hgcd_matrix *)$tmp)->n;"
		end

	c_p (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct hgcd_matrix *tmp = (struct hgcd_matrix *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->p) / sizeof(tmp->p[0]);
				((int *)$tmp_dimensions)[1] = sizeof(tmp->p[0]) / sizeof(tmp->p[0][0]);
				return tmp->p;
			]"
		end

feature {NONE} -- C setters

	c_set_alloc (tmp: POINTER; a_alloc: INTEGER_32)
		external
			"C inline"
		alias
			"((struct hgcd_matrix *)$tmp)->alloc = $a_alloc;"
		end

	c_set_n (tmp: POINTER; a_n: INTEGER_32)
		external
			"C inline"
		alias
			"((struct hgcd_matrix *)$tmp)->n = $a_n;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct hgcd_matrix);"
		end

end
