class
	PD_MPF_STRUCT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	mp_prec: INTEGER_32 assign set_mp_prec
		do
			Result := c_mp_prec (c_pointer)
		end

	mp_size: INTEGER_32 assign set_mp_size
		do
			Result := c_mp_size (c_pointer)
		end

	mp_exp: INTEGER_32 assign set_mp_exp
		do
			Result := c_mp_exp (c_pointer)
		end

	mp_d: CE_POINTER [NATURAL_32] assign set_mp_d
		do
			create Result.make_shared (c_mp_d (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_mp_prec (a_mp_prec: INTEGER_32)
		do
			c_set_mp_prec (c_pointer, a_mp_prec)
		end

	set_mp_size (a_mp_size: INTEGER_32)
		do
			c_set_mp_size (c_pointer, a_mp_size)
		end

	set_mp_exp (a_mp_exp: INTEGER_32)
		do
			c_set_mp_exp (c_pointer, a_mp_exp)
		end

	set_mp_d (a_mp_d: CE_POINTER [NATURAL_32])
		do
			c_set_mp_d (c_pointer, a_mp_d.c_pointer)
		end

feature {NONE} -- C getters

	c_mp_prec (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct___mpf_struct_3 *)$tmp)->_mp_prec;"
		end

	c_mp_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct___mpf_struct_3 *)$tmp)->_mp_size;"
		end

	c_mp_exp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct___mpf_struct_3 *)$tmp)->_mp_exp;"
		end

	c_mp_d (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned long *)((struct __anonstruct___mpf_struct_3 *)$tmp)->_mp_d;"
		end

feature {NONE} -- C setters

	c_set_mp_prec (tmp: POINTER; a_mp_prec: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct___mpf_struct_3 *)$tmp)->_mp_prec = $a_mp_prec;"
		end

	c_set_mp_size (tmp: POINTER; a_mp_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct___mpf_struct_3 *)$tmp)->_mp_size = $a_mp_size;"
		end

	c_set_mp_exp (tmp: POINTER; a_mp_exp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct___mpf_struct_3 *)$tmp)->_mp_exp = $a_mp_exp;"
		end

	c_set_mp_d (tmp: POINTER; a_mp_d: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct___mpf_struct_3 *)$tmp)->_mp_d = (unsigned long *)$a_mp_d;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct __anonstruct___mpf_struct_3);"
		end

end
