class
	PD_MPZ_STRUCT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	mp_alloc: INTEGER_32 assign set_mp_alloc
		do
			Result := c_mp_alloc (c_pointer)
		end

	mp_size: INTEGER_32 assign set_mp_size
		do
			Result := c_mp_size (c_pointer)
		end

	mp_d: CE_POINTER [NATURAL_32] assign set_mp_d
		do
			create Result.make_shared (c_mp_d (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_mp_alloc (a_mp_alloc: INTEGER_32)
		do
			c_set_mp_alloc (c_pointer, a_mp_alloc)
		end

	set_mp_size (a_mp_size: INTEGER_32)
		do
			c_set_mp_size (c_pointer, a_mp_size)
		end

	set_mp_d (a_mp_d: CE_POINTER [NATURAL_32])
		do
			c_set_mp_d (c_pointer, a_mp_d.c_pointer)
		end

feature {NONE} -- C getters

	c_mp_alloc (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct___mpz_struct_23 *)$tmp)->_mp_alloc;"
		end

	c_mp_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct___mpz_struct_23 *)$tmp)->_mp_size;"
		end

	c_mp_d (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned long *)((struct __anonstruct___mpz_struct_23 *)$tmp)->_mp_d;"
		end

feature {NONE} -- C setters

	c_set_mp_alloc (tmp: POINTER; a_mp_alloc: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct___mpz_struct_23 *)$tmp)->_mp_alloc = $a_mp_alloc;"
		end

	c_set_mp_size (tmp: POINTER; a_mp_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct___mpz_struct_23 *)$tmp)->_mp_size = $a_mp_size;"
		end

	c_set_mp_d (tmp: POINTER; a_mp_d: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct___mpz_struct_23 *)$tmp)->_mp_d = (unsigned long *)$a_mp_d;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct __anonstruct___mpz_struct_23);"
		end

end
