class
	PD_POWERS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	p: CE_POINTER [NATURAL_32] assign set_p
		do
			create Result.make_shared (c_p (c_pointer))
		end

	n: INTEGER_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	shift: INTEGER_32 assign set_shift
		do
			Result := c_shift (c_pointer)
		end

	digits_in_base: NATURAL_32 assign set_digits_in_base
		do
			Result := c_digits_in_base (c_pointer)
		end

	base: INTEGER_32 assign set_base
		do
			Result := c_base (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_p (a_p: CE_POINTER [NATURAL_32])
		do
			c_set_p (c_pointer, a_p.c_pointer)
		end

	set_n (a_n: INTEGER_32)
		do
			c_set_n (c_pointer, a_n)
		end

	set_shift (a_shift: INTEGER_32)
		do
			c_set_shift (c_pointer, a_shift)
		end

	set_digits_in_base (a_digits_in_base: NATURAL_32)
		do
			c_set_digits_in_base (c_pointer, a_digits_in_base)
		end

	set_base (a_base: INTEGER_32)
		do
			c_set_base (c_pointer, a_base)
		end

feature {NONE} -- C getters

	c_p (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned long *)((struct powers *)$tmp)->p;"
		end

	c_n (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct powers *)$tmp)->n;"
		end

	c_shift (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct powers *)$tmp)->shift;"
		end

	c_digits_in_base (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct powers *)$tmp)->digits_in_base;"
		end

	c_base (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct powers *)$tmp)->base;"
		end

feature {NONE} -- C setters

	c_set_p (tmp: POINTER; a_p: POINTER)
		external
			"C inline"
		alias
			"((struct powers *)$tmp)->p = (unsigned long *)$a_p;"
		end

	c_set_n (tmp: POINTER; a_n: INTEGER_32)
		external
			"C inline"
		alias
			"((struct powers *)$tmp)->n = $a_n;"
		end

	c_set_shift (tmp: POINTER; a_shift: INTEGER_32)
		external
			"C inline"
		alias
			"((struct powers *)$tmp)->shift = $a_shift;"
		end

	c_set_digits_in_base (tmp: POINTER; a_digits_in_base: NATURAL_32)
		external
			"C inline"
		alias
			"((struct powers *)$tmp)->digits_in_base = $a_digits_in_base;"
		end

	c_set_base (tmp: POINTER; a_base: INTEGER_32)
		external
			"C inline"
		alias
			"((struct powers *)$tmp)->base = $a_base;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct powers);"
		end

end
