#ifndef LIBGMP_H
#define LIBGMP_H

#include <ffi.h>
#include <libio.h>
#include <obstack.h>
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <string.h>
#include <ctype.h>
#include <langinfo.h>

#undef next
#undef sbuf
#undef pos
#undef flags
#undef IO_read_ptr
#undef IO_read_end
#undef IO_read_base
#undef IO_write_base
#undef IO_write_ptr
#undef IO_write_end
#undef IO_buf_base
#undef IO_buf_end
#undef IO_save_base
#undef IO_backup_base
#undef IO_save_end
#undef markers
#undef chain
#undef fileno
#undef flags2
#undef old_offset
#undef cur_column
#undef vtable_offset
#undef shortbuf
#undef lock
#undef offset
#undef pad1
#undef pad2
#undef pad3
#undef pad4
#undef pad5
#undef mode
#undef unused2
#undef mp_alloc
#undef mp_size
#undef mp_d
#undef mp_num
#undef mp_den
#undef manl
#undef manh
#undef exp
#undef sig
#undef s
#undef d
#undef mp_lc
#undef mp_seed
#undef mp_alg
#undef mp_algdata
#undef randseed_fn
#undef randget_fn
#undef randclear_fn
#undef randiset_fn
#undef m2exp
#undef astr
#undef c
#undef size
#undef mp_a
#undef cn
#undef cp
#undef mp_m2exp
#undef mt
#undef mti
#undef s0
#undef sqrt_s0
#undef l
#undef p
#undef mp_prec
#undef mp_exp
#undef chars_per_limb
#undef chars_per_bit_exactly
#undef big_base
#undef big_base_inverted
#undef n
#undef k
#undef shift
#undef digits_in_base
#undef base
#undef alloc
#undef u
#undef inv32
#undef binv
#undef lim
#undef ppp
#undef cps
#undef idx
#undef np
#undef result2
#undef buf
#undef conv
#undef expfmt
#undef exptimes4
#undef fill
#undef justify
#undef prec
#undef showbase
#undef showpoint
#undef showtrailing
#undef sign
#undef width
#undef format
#undef memory
#undef reps
#undef final
#undef limit
#undef prev
#undef contents
#undef tempint
#undef tempptr
#undef chunk_size
#undef chunk
#undef object_base
#undef next_free
#undef chunk_limit
#undef temp
#undef alignment_mask
#undef chunkfun
#undef freefun
#undef extra_arg
#undef use_extra_arg
#undef maybe_empty_object
#undef alloc_failed
#undef scan
#undef step
#undef get
#undef unget
#undef builtin_expect
#undef ignore
#undef type
#undef fprintf
#undef __stream
#undef __format
#undef abort
#undef gmpn_add_n
#undef gmpn_popcount
#undef gmpn_sub_n
#undef gmpn_divrem_1
#undef gmpn_bdiv_dbm1c
#undef raise
#undef __sig
#undef malloc
#undef __size
#undef realloc
#undef __ptr
#undef free
#undef gmpn_lshift
#undef gmpn_rshift
#undef gmpn_copyi
#undef builtin_clzl
#undef memset
#undef __s
#undef __c
#undef __n
#undef strlen
#undef ctype_b_loc
#undef nl_langinfo
#undef __item
#undef gmpn_mul_1
#undef gmpn_copyd
#undef printf
#undef IO_getc
#undef __fp
#undef ungetc
#undef IO_putc
#undef fputc
#undef fwrite
#undef ferror
#undef gmpn_addmul_1
#undef gmpn_submul_1
#undef gmpn_divexact_1
#undef builtin_ctzl
#undef gmpn_modexact_1c_odd
#undef gmpn_modexact_1_odd
#undef gmpn_hamdist
#undef fread
#undef memcpy
#undef __dest
#undef __src
#undef strchr
#undef gmpn_divrem_2
#undef gmpn_mod_1s_4p_cps
#undef gmpn_mod_1s_4p
#undef gmpn_invert_limb
#undef gmpn_mul_basecase
#undef gmpn_sqr_basecase
#undef gmpn_preinv_divrem_1
#undef gmpn_mod_34lsub1
#undef gmpn_add_nc
#undef gmpn_sub_nc
#undef strcpy
#undef snprintf
#undef __maxlen
#undef obstack_vprintf
#undef __obstack
#undef __args
#undef obstack_newchunk
#undef vfprintf
#undef __arg
#undef vsnprintf
#undef vsprintf
#undef strtol
#undef __nptr
#undef __endptr
#undef __base
#undef fscanf
#undef fgetc
#undef sscanf

enum PC_GMP_RANDALG_T {
	GMP_RAND_ALG_DEFAULT = 0,
	GMP_RAND_ALG_LC = 0
};
enum PC_TOOM6_FLAGS {
	toom6_all_pos = 0,
	toom6_vm1_neg = 1,
	toom6_vm2_neg = 2
};
enum PC_TOOM7_FLAGS {
	toom7_w1_neg = 1,
	toom7_w3_neg = 2
};

struct __anonstruct___mpz_struct_23;
struct __anonstruct___mpq_struct_24;
struct __anonstruct_s_13;
union ieee_double_extract;
union __anonunion__mp_algdata_11;
struct __anonstruct___gmp_randstate_struct_10;
struct __anonstruct_gmp_randfnptr_t_11;
struct __gmp_rand_lc_scheme_struct;
struct tmp_reentrant_t;
struct __anonstruct_gmp_randfnptr_t_11___0;
struct __anonstruct_gmp_rand_lc_struct_14;
struct __anonstruct_gmp_randfnptr_t_16;
struct __anonstruct_gmp_rand_mt_struct_19;
struct __anonstruct_gmp_randfnptr_t_11___1;
struct __anonstruct_gmp_primesieve_t_12;
union tmp_align_t;
struct __anonstruct___mpf_struct_3;
struct bases;
struct fft_table_nk;
struct powers;
struct hgcd_matrix;
struct hgcd_matrix1;
struct __anonstruct_gmp_pi1_t_9;
struct gmp_primes_dtab;
struct gmp_primes_ptab;
struct gmp_asprintf_t;
struct doprnt_params_t;
struct doprnt_funs_t;
union __anonunion_temp_1;
struct gmp_snprintf_t;
struct gmp_doscan_funs_t;
struct gmp_doscan_params_t;

typedef struct __anonstruct___mpz_struct_23 __mpz_struct;
typedef struct __anonstruct___mpq_struct_24 __mpq_struct;
typedef struct __anonstruct___gmp_randstate_struct_10 __gmp_randstate_struct;
typedef struct __anonstruct_gmp_randfnptr_t_11 gmp_randfnptr_t;
typedef struct __anonstruct_gmp_rand_lc_struct_14 gmp_rand_lc_struct;
typedef struct __anonstruct_gmp_rand_mt_struct_19 gmp_rand_mt_struct;
typedef struct __anonstruct_gmp_primesieve_t_12 gmp_primesieve_t;
typedef struct __anonstruct___mpf_struct_3 __mpf_struct;
typedef struct __anonstruct_gmp_pi1_t_9 gmp_pi1_t;

struct __anonstruct___mpz_struct_23 {
	int _mp_alloc;
	int _mp_size;
	unsigned long * _mp_d;
};
struct __anonstruct___mpq_struct_24 {
	__mpz_struct _mp_num;
	__mpz_struct _mp_den;
};
struct __anonstruct_s_13 {
	unsigned int manl : 32;
	unsigned int manh : 20;
	unsigned int exp : 11;
	unsigned int sig : 1;
};
union ieee_double_extract {
	struct __anonstruct_s_13 s;
	double d;
};
union __anonunion__mp_algdata_11 {
	void * _mp_lc;
};
struct __anonstruct___gmp_randstate_struct_10 {
	__mpz_struct _mp_seed[1];
	int _mp_alg;
	union __anonunion__mp_algdata_11 _mp_algdata;
};
struct __anonstruct_gmp_randfnptr_t_11 {
	void( * randseed_fn)(__gmp_randstate_struct *, __mpz_struct *);
	void( * randget_fn)(__gmp_randstate_struct *, unsigned long *, unsigned long);
	void( * randclear_fn)(__gmp_randstate_struct *);
	void( * randiset_fn)(__gmp_randstate_struct *, __gmp_randstate_struct *);
};
struct __gmp_rand_lc_scheme_struct {
	unsigned long m2exp;
	char const * astr;
	unsigned long c;
};
struct tmp_reentrant_t {
	struct tmp_reentrant_t * next;
	unsigned int size;
};
struct __anonstruct_gmp_randfnptr_t_11___0 {
	void( * randseed_fn)(__gmp_randstate_struct *, __mpz_struct *);
	void( * randget_fn)(__gmp_randstate_struct *, unsigned long *, unsigned long);
	void( * randclear_fn)(__gmp_randstate_struct *);
	void( * randiset_fn)(__gmp_randstate_struct *, __gmp_randstate_struct *);
};
struct __anonstruct_gmp_rand_lc_struct_14 {
	__mpz_struct _mp_seed[1];
	__mpz_struct _mp_a[1];
	long _cn;
	unsigned long _cp[1];
	unsigned long _mp_m2exp;
};
struct __anonstruct_gmp_randfnptr_t_16 {
	void( * randseed_fn)(__gmp_randstate_struct *, __mpz_struct *);
	void( * randget_fn)(__gmp_randstate_struct *, unsigned long *, unsigned long);
	void( * randclear_fn)(__gmp_randstate_struct *);
	void( * randiset_fn)(__gmp_randstate_struct *, __gmp_randstate_struct *);
};
struct __anonstruct_gmp_rand_mt_struct_19 {
	unsigned int mt[624];
	int mti;
};
struct __anonstruct_gmp_randfnptr_t_11___1 {
	void( * randseed_fn)(__gmp_randstate_struct *, __mpz_struct *);
	void( * randget_fn)(__gmp_randstate_struct *, unsigned long *, unsigned long);
	void( * randclear_fn)(__gmp_randstate_struct *);
	void( * randiset_fn)(__gmp_randstate_struct *, __gmp_randstate_struct *);
};
struct __anonstruct_gmp_primesieve_t_12 {
	unsigned long d;
	unsigned long s0;
	unsigned long sqrt_s0;
	unsigned char s[513];
};
union tmp_align_t {
	unsigned long l;
	char * p;
};
struct __anonstruct___mpf_struct_3 {
	int _mp_prec;
	int _mp_size;
	long _mp_exp;
	unsigned long * _mp_d;
};
struct bases {
	int chars_per_limb;
	double chars_per_bit_exactly;
	unsigned long big_base;
	unsigned long big_base_inverted;
};
struct fft_table_nk {
	unsigned int n : 27;
	unsigned int k : 5;
};
struct powers {
	unsigned long * p;
	long n;
	long shift;
	unsigned int digits_in_base;
	int base;
};
struct hgcd_matrix {
	long alloc;
	long n;
	unsigned long * p[2][2];
};
struct hgcd_matrix1 {
	unsigned long u[2][2];
};
struct __anonstruct_gmp_pi1_t_9 {
	unsigned long inv32;
};
struct gmp_primes_dtab {
	unsigned long binv;
	unsigned long lim;
};
struct gmp_primes_ptab {
	unsigned long ppp;
	unsigned long cps[7];
	unsigned int idx : 24;
	unsigned int np : 8;
};
struct gmp_asprintf_t {
	char * * result;
	char * buf;
	unsigned int size;
	unsigned int alloc;
};
struct doprnt_params_t {
	int base;
	int conv;
	char const * expfmt;
	int exptimes4;
	char fill;
	int justify;
	int prec;
	int showbase;
	int showpoint;
	int showtrailing;
	char sign;
	int width;
};
struct doprnt_funs_t {
	int( * format)(void *, char const *, __builtin_va_list);
	int( * memory)(void *, char const *, unsigned int);
	int( * reps)(void *, int, int);
	int( * final)(void *);
};
union __anonunion_temp_1 {
	int tempint;
	void * tempptr;
};
struct gmp_snprintf_t {
	char * buf;
	unsigned int size;
};
struct gmp_doscan_funs_t {
	int( * scan)(void *, char const *, ...);
	void *( * step)(void *, int);
	int( * get)(void *);
	int( * unget)(int, void *);
};
struct gmp_doscan_params_t {
	int base;
	int ignore;
	char type;
	int width;
};

extern unsigned long __gmpn_add_n(unsigned long *, unsigned long *, unsigned long *, long);
extern unsigned long __gmpn_popcount(unsigned long *, long);
extern unsigned long __gmpn_sub_n(unsigned long *, unsigned long *, unsigned long *, long);
extern unsigned long __gmpn_divrem_1(unsigned long *, long, unsigned long *, long, unsigned long);
extern unsigned long __gmpn_bdiv_dbm1c(unsigned long *, unsigned long *, long, unsigned long, unsigned long);
extern unsigned char const __gmp_binvert_limb_table[128];
extern unsigned long __gmpn_lshift(unsigned long *, unsigned long *, long, unsigned int);
extern unsigned long __gmpn_rshift(unsigned long *, unsigned long *, long, unsigned int);
extern void __gmpn_copyi(unsigned long *, unsigned long *, long);
extern unsigned long __gmpn_mul_1(unsigned long *, unsigned long *, long, unsigned long);
extern void __gmpn_copyd(unsigned long *, unsigned long *, long);
extern unsigned long __gmpn_addmul_1(unsigned long *, unsigned long *, long, unsigned long);
extern unsigned long __gmpn_submul_1(unsigned long *, unsigned long *, long, unsigned long);
extern void __gmpn_divexact_1(unsigned long *, unsigned long *, long, unsigned long);
extern unsigned long __gmpn_modexact_1c_odd(unsigned long *, long, unsigned long, unsigned long);
extern unsigned long __gmpn_modexact_1_odd(unsigned long *, long, unsigned long);
extern unsigned long __gmpn_hamdist(unsigned long *, unsigned long *, long);
extern unsigned long __gmpn_divrem_2(unsigned long *, long, unsigned long *, long, unsigned long *);
extern void __gmpn_mod_1s_4p_cps(unsigned long *, unsigned long);
extern unsigned long __gmpn_mod_1s_4p(unsigned long *, long, unsigned long, unsigned long *);
extern unsigned long __gmpn_invert_limb(unsigned long);
extern void __gmpn_mul_basecase(unsigned long *, unsigned long *, long, unsigned long *, long);
extern void __gmpn_sqr_basecase(unsigned long *, unsigned long *, long);
extern unsigned long __gmpn_preinv_divrem_1(unsigned long *, long, unsigned long *, long, unsigned long, unsigned long, int);
extern unsigned long __gmpn_mod_34lsub1(unsigned long *, long);
extern unsigned long __gmpn_add_nc(unsigned long *, unsigned long *, unsigned long *, long, unsigned long);
extern unsigned long __gmpn_sub_nc(unsigned long *, unsigned long *, unsigned long *, long, unsigned long);

#endif
