class
	P_ADD

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_add (a_r: CE_POINTER [PD_MPF_STRUCT]; a_u: CE_POINTER [PD_MPF_STRUCT]; a_v: CE_POINTER [PD_MPF_STRUCT])
		local
			l_u: CE_POINTER [PD_MPF_STRUCT]
			l_v: CE_POINTER [PD_MPF_STRUCT]
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_rsize: INTEGER_32
			l_prec: INTEGER_32
			l_uexp: INTEGER_32
			l_ediff: INTEGER_32
			l_cy: NATURAL_32
			l_negate: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_v_negated: PD_MPF_STRUCT
			l_t: CE_POINTER [PD_MPF_STRUCT]
			l_tmp___2: CE_POINTER [ANY]
			l_size: INTEGER_32
			l_size___0: INTEGER_32
			l_size___1: INTEGER_32
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_u.make
			create l_v.make
			create l_up.make
			create l_vp.make
			create l_rp.make
			create l_tp.make
			create l_tmp_marker.make
			create l_v_negated.make
			create l_t.make
			create l_tmp___2.make
			create l_dst.make
			create l_tmp___4.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_u.ce_gets (a_u)
					l_v.ce_gets (a_v)
					l_usize := (l_u.item.mp_size).to_integer_32
					l_vsize := (l_v.item.mp_size).to_integer_32
					if l_usize /= 0 then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | set_r_v_maybe:
						if (a_r.c_pointer.to_integer_32).to_natural_32 /= (l_v.c_pointer.to_integer_32).to_natural_32 then
							set_inst.gmpf_set (a_r, l_v)
						end
						js.return
				when 2 then -- if done
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 3 then -- if:
						if l_vsize = 0 then
							l_v.ce_gets (l_u)
							l_pos := -1 + 1 -- goto set_r_v_maybe
						end
				when 4 then
						if ((l_usize).bit_xor (l_vsize)) < 0 then
							l_v_negated.mp_size := (-l_vsize).to_integer_32
							l_v_negated.mp_exp := l_v.item.mp_exp
							l_v_negated.mp_d := l_v.item.mp_d
							sub_inst.gmpf_sub (a_r, l_u, (l_v_negated.address))
							js.return
						end
				when 5 then -- if done
					if not js.return_called then
						l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
						l_negate := (l_usize < 0).to_integer
						if l_u.item.mp_exp < l_v.item.mp_exp then
							l_t.ce_gets (l_u)
							l_u.ce_gets (l_v)
							l_v.ce_gets (l_t)
							l_usize := (l_u.item.mp_size).to_integer_32
							l_vsize := (l_v.item.mp_size).to_integer_32
						end
						if l_usize >= 0 then
							l_usize := l_usize
						else
							l_usize := -l_usize
						end
						if l_vsize >= 0 then
							l_vsize := l_vsize
						else
							l_vsize := -l_vsize
						end
						l_up.ce_gets (l_u.item.mp_d)
						l_vp.ce_gets (l_v.item.mp_d)
						l_rp.ce_gets (a_r.item.mp_d)
						l_prec := (a_r.item.mp_prec).to_integer_32
						l_uexp := l_u.item.mp_exp
						l_ediff := (l_u.item.mp_exp - l_v.item.mp_exp)
						if l_usize > l_prec then
							l_up.ce_gets (l_up + (l_usize - l_prec))
							l_usize := l_prec
						end
						if l_vsize + l_ediff > l_prec then
							l_vp.ce_gets (l_vp + ((l_vsize + l_ediff) - l_prec))
							l_vsize := l_prec - l_ediff
						end
						if (builtin_expect ((l_prec.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___2.ce_gets ((l_aaf.new ((l_prec.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___2.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_prec.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2))
						if l_ediff >= l_prec then
							if (l_rp.c_pointer.to_integer_32).to_natural_32 /= (l_up.c_pointer.to_integer_32).to_natural_32 then
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_rp, l_up, l_usize)
									js.break
								end
								js.reset
							end
							l_rsize := l_usize
						else
							if l_usize > l_ediff then
								if l_vsize + l_ediff <= l_usize then
									l_size := (l_usize - l_ediff) - l_vsize
									from
									until
										js.loop_left
									loop
										js.reset
										from
										until
											js.loop_left
										loop
											js.reset
											gmp_inst.gmpn_copyi (l_tp, l_up, l_size)
											js.break
										end
										js.reset
										js.break
									end
									js.reset
									l_cy := gmp_inst.gmpn_add (l_tp + l_size, l_up + l_size, l_usize - l_size, l_vp, l_vsize)
									l_rsize := l_usize
								else
									l_size___0 := (l_vsize + l_ediff) - l_usize
									from
									until
										js.loop_left
									loop
										js.reset
										from
										until
											js.loop_left
										loop
											js.reset
											gmp_inst.gmpn_copyi (l_tp, l_vp, l_size___0)
											js.break
										end
										js.reset
										js.break
									end
									js.reset
									l_cy := gmp_inst.gmpn_add (l_tp + l_size___0, l_up, l_usize, l_vp + l_size___0, l_usize - l_ediff)
									l_rsize := l_vsize + l_ediff
								end
							else
								l_size___1 := (l_vsize + l_ediff) - l_usize
								from
								until
									js.loop_left
								loop
									js.reset
									from
									until
										js.loop_left
									loop
										js.reset
										gmp_inst.gmpn_copyi (l_tp, l_vp, l_vsize)
										js.break
									end
									js.reset
									js.break
								end
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									if l_ediff - l_usize /= 0 then
										l_dst.ce_gets (l_tp + l_vsize)
										l_n := l_ediff - l_usize
										from
										until
											js.loop_left
										loop
											js.reset
											l_tmp___4.ce_gets (l_dst)
											l_dst.ce_gets (l_dst + 1)
											l_tmp___4.item := (0).to_natural_32
											l_n := l_n - 1
											if not l_n.to_boolean then
												js.break
											end
										end
										js.reset
									end
									js.break
								end
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									from
									until
										js.loop_left
									loop
										js.reset
										gmp_inst.gmpn_copyi (l_tp + l_size___1, l_up, l_usize)
										js.break
									end
									js.reset
									js.break
								end
								js.reset
								l_cy := (0).to_natural_32
								l_rsize := l_size___1 + l_usize
							end
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_rp, l_tp, l_rsize)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
							l_rp[l_rsize] := l_cy
							l_rsize := (l_rsize.to_natural_32 + l_cy).to_integer_32
							l_uexp := (l_uexp.to_natural_32 + l_cy).to_integer_32
						end
						if l_negate.to_boolean then
							a_r.item.mp_size := (-l_rsize).to_integer_32
						else
							a_r.item.mp_size := l_rsize.to_integer_32
						end
						a_r.item.mp_exp := l_uexp
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
							end
							js.break
						end
						js.reset
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
