class
	P_AORSMUL

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_aorsmul (a_sub: INTEGER_32; a_w: CE_POINTER [PD_MPZ_STRUCT]; a_x___2: CE_POINTER [PD_MPZ_STRUCT]; a_y: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_sub: INTEGER_32
			l_x___2: CE_POINTER [PD_MPZ_STRUCT]
			l_y: CE_POINTER [PD_MPZ_STRUCT]
			l_xsize: INTEGER_32
			l_ysize: INTEGER_32
			l_tsize: INTEGER_32
			l_wsize: INTEGER_32
			l_wsize_signed: INTEGER_32
			l_wp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_c: NATURAL_32
			l_high: NATURAL_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_mpz_srcptr_swap__tmp: CE_POINTER [PD_MPZ_STRUCT]
			l_mp_size_t_swap__tmp: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___7: CE_POINTER [ANY]
			l_up: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_up___0: CE_POINTER [NATURAL_32]
			l_usize___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_x___2.make
			create l_y.make
			create l_wp.make
			create l_tp.make
			create l_tmp_marker.make
			create l_mpz_srcptr_swap__tmp.make
			create l_tmp___7.make
			create l_up.make
			create l_up___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sub := a_sub
					l_x___2.ce_gets (a_x___2)
					l_y.ce_gets (a_y)
					l_xsize := (l_x___2.item.mp_size).to_integer_32
					l_ysize := (l_y.item.mp_size).to_integer_32
					if l_xsize = 0 then
						js.return
					elseif l_ysize = 0 then
						js.return
					end
					if not js.return_called then
						if l_ysize >= 0 then
							l_tmp := l_ysize
						else
							l_tmp := -l_ysize
						end
						if l_xsize >= 0 then
							l_tmp___0 := l_xsize
						else
							l_tmp___0 := -l_xsize
						end
						if l_tmp > l_tmp___0 then
							from
							until
								js.loop_left
							loop
								js.reset
								l_mpz_srcptr_swap__tmp.ce_gets (l_x___2)
								l_x___2.ce_gets (l_y)
								l_y.ce_gets (l_mpz_srcptr_swap__tmp)
								js.break
							end
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								l_mp_size_t_swap__tmp := l_xsize
								l_xsize := l_ysize
								l_ysize := l_mp_size_t_swap__tmp
								js.break
							end
							js.reset
						end
						l_sub := (l_sub).bit_xor (l_ysize)
						if l_ysize >= 0 then
							l_ysize := l_ysize
						else
							l_ysize := -l_ysize
						end
						if l_ysize = 1 then
							aorsmul_i_inst.gmpz_aorsmul_1 (l_sub, a_w, l_x___2, l_y.item.mp_d[0])
							js.return
						end
					end
					if not js.return_called then
						l_sub := (l_sub).bit_xor (l_xsize)
						if l_xsize >= 0 then
							l_xsize := l_xsize
						else
							l_xsize := -l_xsize
						end
						l_wsize_signed := (a_w.item.mp_size).to_integer_32
						l_sub := (l_sub).bit_xor (l_wsize_signed)
						if l_wsize_signed >= 0 then
							l_wsize := l_wsize_signed
						else
							l_wsize := -l_wsize_signed
						end
						l_tsize := l_xsize + l_ysize
						if l_wsize > l_tsize then
							l_tmp___2 := l_wsize
						else
							l_tmp___2 := l_tsize
						end
						if (builtin_expect ((l_tmp___2 + 1 > (a_w.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
							if l_wsize > l_tsize then
								l_tmp___1 := l_wsize
							else
								l_tmp___1 := l_tsize
							end
							realloc_inst.gmpz_realloc (a_w, l_tmp___1 + 1).do_nothing
						end
						l_wp.ce_gets (a_w.item.mp_d)
						if l_wsize_signed = 0 then
							l_high := mul_inst.gmpn_mul (l_wp, l_x___2.item.mp_d, l_xsize, l_y.item.mp_d, l_ysize)
							l_tsize := l_tsize - (l_high = {NATURAL_32} 0).to_integer
							if l_sub >= 0 then
								a_w.item.mp_size := l_tsize.to_integer_32
							else
								a_w.item.mp_size := (-l_tsize).to_integer_32
							end
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
						if (builtin_expect ((l_tsize.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___7.ce_gets ((l_aaf.new ((l_tsize.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___7.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_tsize.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___7))
						l_high := mul_inst.gmpn_mul (l_tp, l_x___2.item.mp_d, l_xsize, l_y.item.mp_d, l_ysize)
						l_tsize := l_tsize - (l_high = {NATURAL_32} 0).to_integer
						if not (l_sub >= 0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_up.ce_gets (l_wp)
						l_usize := l_wsize
						if l_usize < l_tsize then
							l_up.ce_gets (l_tp)
							l_usize := l_tsize
							l_tp.ce_gets (l_wp)
							l_tsize := l_wsize
							l_wsize := l_usize
						end
						l_c := gmp_inst.gmpn_add (l_wp, l_up, l_usize, l_tp, l_tsize)
						l_wp[l_wsize] := l_c
						l_wsize := l_wsize + (l_c /= {NATURAL_32} 0).to_integer
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else:
						l_up___0.ce_gets (l_wp)
						l_usize___0 := l_wsize
						if not (l_usize___0 < l_tsize) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 7 then -- else:
						if l_usize___0 /= l_tsize then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if not ((gmp_inst.gmpn_cmp (l_up___0, l_tp, l_usize___0)) < 0) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						l_up___0.ce_gets (l_tp)
						l_usize___0 := l_tsize
						l_tp.ce_gets (l_wp)
						l_tsize := l_wsize
						l_wsize := l_usize___0
						l_wsize_signed := -l_wsize_signed
				when 10 then -- if done | if done
						gmp_inst.gmpn_sub (l_wp, l_up___0, l_usize___0, l_tp, l_tsize).do_nothing
						l_wsize := l_usize___0
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								not (not js.loop_left and then (l_wsize > 0))
							loop
								js.reset
								if l_wp[(l_wsize - 1)] /= {NATURAL_32} 0 then
									js.break
								end
								if not js.loop_jumped then
									l_wsize := l_wsize - 1
								end
							end
							js.reset
							js.break
						end
						js.reset
				when 11 then -- if done
						if l_wsize_signed >= 0 then
							a_w.item.mp_size := l_wsize.to_integer_32
						else
							a_w.item.mp_size := (-l_wsize).to_integer_32
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
							end
							js.break
						end
						js.reset
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpz_addmul (a_w: CE_POINTER [PD_MPZ_STRUCT]; a_u: CE_POINTER [PD_MPZ_STRUCT]; a_v: CE_POINTER [PD_MPZ_STRUCT])
		do
			gmpz_aorsmul ((0).to_integer_32, a_w, a_u, a_v)
		end

	gmpz_submul (a_w: CE_POINTER [PD_MPZ_STRUCT]; a_u: CE_POINTER [PD_MPZ_STRUCT]; a_v: CE_POINTER [PD_MPZ_STRUCT])
		do
			gmpz_aorsmul ((-1).to_integer_32, a_w, a_u, a_v)
		end

end
