class
	P_ASSERT

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmp_assert_header (a_filename: CE_POINTER [INTEGER_8]; a_linenum: INTEGER_32)
		do
			if (a_filename.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (a_filename[0]).to_integer_32 /= 0 then
					Io.error.put_string (eif_string (a_filename) + ":")
					if a_linenum /= -1 then
						Io.error.put_string (a_linenum.out + ": ")
					end
				end
			end
		end

	gmp_assert_fail (a_filename: CE_POINTER [INTEGER_8]; a_linenum: INTEGER_32; a_expr: CE_POINTER [INTEGER_8])
		do
			gmp_assert_header (a_filename, a_linenum)
			Io.error.put_string ("GNU MP assertion failed: " + eif_string (a_expr) + "%N")
			abort
		end

end
