class
	P_CANONICALIZE

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpq_canonicalize (a_op: CE_POINTER [PD_MPQ_STRUCT])
		local
			l_gcd: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_tmp___19: INTEGER_32
			l_tmp___20: INTEGER_32
			l_tmp___24: INTEGER_32
			l_tmp___25: INTEGER_32
			l_tmp___26: INTEGER_32
			l_tmp___27: INTEGER_32
			l_tmp___28: INTEGER_32
			l_tmp___30: CE_POINTER [ANY]
			l_tmp___33: INTEGER_32
			l_tmp___34: INTEGER_32
			l_tmp___35: INTEGER_32
			l_tmp___36: INTEGER_32
			l_tmp___37: INTEGER_32
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_gcd.make (<<1>>)
			create l_tmp_marker.make
			create l_x.make
			create l_tmp___30.make

			if a_op.item.mp_den.mp_size = 0 then
				errno_inst.gmp_divide_by_zero
			end
			l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
			from
			until
				js.loop_left
			loop
				js.reset
				l_x.ce_gets (l_gcd)
				if a_op.item.mp_num.mp_size >= 0 then
					l_tmp___4 := a_op.item.mp_num.mp_size
				else
					l_tmp___4 := -a_op.item.mp_num.mp_size
				end
				if a_op.item.mp_den.mp_size >= 0 then
					l_tmp___5 := a_op.item.mp_den.mp_size
				else
					l_tmp___5 := -a_op.item.mp_den.mp_size
				end
				if l_tmp___4 > l_tmp___5 then
					if a_op.item.mp_num.mp_size >= 0 then
						l_tmp___1 := a_op.item.mp_num.mp_size
					else
						l_tmp___1 := -a_op.item.mp_num.mp_size
					end
					l_tmp___3 := l_tmp___1
				else
					if a_op.item.mp_den.mp_size >= 0 then
						l_tmp___2 := a_op.item.mp_den.mp_size
					else
						l_tmp___2 := -a_op.item.mp_den.mp_size
					end
					l_tmp___3 := l_tmp___2
				end
				l_x.item.mp_alloc := 1 + l_tmp___3
				if a_op.item.mp_num.mp_size >= 0 then
					l_tmp___36 := a_op.item.mp_num.mp_size
				else
					l_tmp___36 := -a_op.item.mp_num.mp_size
				end
				if a_op.item.mp_den.mp_size >= 0 then
					l_tmp___37 := a_op.item.mp_den.mp_size
				else
					l_tmp___37 := -a_op.item.mp_den.mp_size
				end
				if l_tmp___36 > l_tmp___37 then
					if a_op.item.mp_num.mp_size >= 0 then
						l_tmp___33 := a_op.item.mp_num.mp_size
					else
						l_tmp___33 := -a_op.item.mp_num.mp_size
					end
					l_tmp___35 := l_tmp___33
				else
					if a_op.item.mp_den.mp_size >= 0 then
						l_tmp___34 := a_op.item.mp_den.mp_size
					else
						l_tmp___34 := -a_op.item.mp_den.mp_size
					end
					l_tmp___35 := l_tmp___34
				end
				if (builtin_expect (((1 + l_tmp___35).to_natural_32 * Natural_32_bytes.to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
					if a_op.item.mp_num.mp_size >= 0 then
						l_tmp___19 := a_op.item.mp_num.mp_size
					else
						l_tmp___19 := -a_op.item.mp_num.mp_size
					end
					if a_op.item.mp_den.mp_size >= 0 then
						l_tmp___20 := a_op.item.mp_den.mp_size
					else
						l_tmp___20 := -a_op.item.mp_den.mp_size
					end
					if l_tmp___19 > l_tmp___20 then
						if a_op.item.mp_num.mp_size >= 0 then
							l_tmp___16 := a_op.item.mp_num.mp_size
						else
							l_tmp___16 := -a_op.item.mp_num.mp_size
						end
						l_tmp___18 := l_tmp___16
					else
						if a_op.item.mp_den.mp_size >= 0 then
							l_tmp___17 := a_op.item.mp_den.mp_size
						else
							l_tmp___17 := -a_op.item.mp_den.mp_size
						end
						l_tmp___18 := l_tmp___17
					end
					l_tmp___30.ce_gets ((l_aaf.new ((1 + l_tmp___18).to_natural_32 * Natural_32_bytes.to_natural_32)))
				else
					if a_op.item.mp_num.mp_size >= 0 then
						l_tmp___27 := a_op.item.mp_num.mp_size
					else
						l_tmp___27 := -a_op.item.mp_num.mp_size
					end
					if a_op.item.mp_den.mp_size >= 0 then
						l_tmp___28 := a_op.item.mp_den.mp_size
					else
						l_tmp___28 := -a_op.item.mp_den.mp_size
					end
					if l_tmp___27 > l_tmp___28 then
						if a_op.item.mp_num.mp_size >= 0 then
							l_tmp___24 := a_op.item.mp_num.mp_size
						else
							l_tmp___24 := -a_op.item.mp_num.mp_size
						end
						l_tmp___26 := l_tmp___24
					else
						if a_op.item.mp_den.mp_size >= 0 then
							l_tmp___25 := a_op.item.mp_den.mp_size
						else
							l_tmp___25 := -a_op.item.mp_den.mp_size
						end
						l_tmp___26 := l_tmp___25
					end
					l_tmp___30.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (1 + l_tmp___26).to_natural_32 * Natural_32_bytes.to_natural_32)))
				end
				l_x.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___30)
				js.break
			end
			js.reset
			gcd_inst.gmpz_gcd (l_gcd, (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op.c_pointer + {PD_MPQ_STRUCT}.mp_num_offset)), (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op.c_pointer + {PD_MPQ_STRUCT}.mp_den_offset)))
			if l_gcd[0].mp_size = 1 then
				if l_gcd[0].mp_d[0] /= {NATURAL_32} 1 then
					divegcd_inst.gmpz_divexact_gcd (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op.c_pointer + {PD_MPQ_STRUCT}.mp_num_offset), (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op.c_pointer + {PD_MPQ_STRUCT}.mp_num_offset)), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd))
					divegcd_inst.gmpz_divexact_gcd (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op.c_pointer + {PD_MPQ_STRUCT}.mp_den_offset), (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op.c_pointer + {PD_MPQ_STRUCT}.mp_den_offset)), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd))
				end
			else
				divegcd_inst.gmpz_divexact_gcd (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op.c_pointer + {PD_MPQ_STRUCT}.mp_num_offset), (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op.c_pointer + {PD_MPQ_STRUCT}.mp_num_offset)), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd))
				divegcd_inst.gmpz_divexact_gcd (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op.c_pointer + {PD_MPQ_STRUCT}.mp_den_offset), (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op.c_pointer + {PD_MPQ_STRUCT}.mp_den_offset)), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd))
			end
			if a_op.item.mp_den.mp_size < 0 then
				a_op.item.mp_num.mp_size := -a_op.item.mp_num.mp_size
				a_op.item.mp_den.mp_size := -a_op.item.mp_den.mp_size
			end
			from
			until
				js.loop_left
			loop
				js.reset
				if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
					tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
				end
				js.break
			end
			js.reset
		end

end
