class
	P_CDIV_R_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_cdiv_r_ui (a_rem: CE_POINTER [PD_MPZ_STRUCT]; a_dividend: CE_POINTER [PD_MPZ_STRUCT]; a_divisor: NATURAL_32): NATURAL_32
		local
			l_ns: INTEGER_32
			l_nn: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_rl: NATURAL_32
			js: JUMP_STATE
		do
			create l_np.make

			if a_divisor = {NATURAL_32} 0 then
				errno_inst.gmp_divide_by_zero
			end
			l_ns := (a_dividend.item.mp_size).to_integer_32
			if l_ns = 0 then
				a_rem.item.mp_size := 0
				Result := {NATURAL_32} 0
				js.return
			end
			if not js.return_called then
				if l_ns >= 0 then
					l_nn := l_ns
				else
					l_nn := -l_ns
				end
				l_np.ce_gets (a_dividend.item.mp_d)
				l_rl := mod_1_inst.gmpn_mod_1 (l_np, l_nn, a_divisor)
				if l_rl = {NATURAL_32} 0 then
					a_rem.item.mp_size := 0
				else
					if l_ns >= 0 then
						l_rl := a_divisor - l_rl
					end
					a_rem.item.mp_d[0] := l_rl
					a_rem.item.mp_size := -1
				end
				Result := l_rl
			end
		end

end
