class
	P_CEILFLOOR

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_ceil_or_floor (a_dir: INTEGER_32; a_r: CE_POINTER [PD_MPF_STRUCT]; a_u: CE_POINTER [PD_MPF_STRUCT])
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_p: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_asize: INTEGER_32
			l_prec: INTEGER_32
			l_exp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_rp.make
			create l_up.make
			create l_p.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_size := (a_u.item.mp_size).to_integer_32
					if l_size /= 0 then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | zero:
						a_r.item.mp_size := 0
						a_r.item.mp_exp := (0).to_integer_32
						js.return
				when 2 then -- if done
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 3 then -- if:
						l_rp.ce_gets (a_r.item.mp_d)
						l_exp := a_u.item.mp_exp
						if not (l_exp <= 0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if ((l_size).bit_xor (a_dir.to_integer_32)) < 0 then
							l_pos := -1 + 1 -- goto zero
						end
				when 5 then
						l_rp[0] := (1).to_natural_32
						a_r.item.mp_exp := (1).to_integer_32
						a_r.item.mp_size := a_dir
						js.return
				when 6 then -- if done | if done
						if not js.return_called then
							a_r.item.mp_exp := l_exp
							l_up.ce_gets (a_u.item.mp_d)
							if l_size >= 0 then
								l_asize := l_size
							else
								l_asize := -l_size
							end
							l_up.ce_gets (l_up + l_asize)
							if l_asize < l_exp then
								l_asize := l_asize
							else
								l_asize := l_exp
							end
							l_prec := (a_r.item.mp_prec + 1).to_integer_32
							if l_asize < l_prec then
								l_asize := l_asize
							else
								l_asize := l_prec
							end
							l_up.ce_gets (l_up - l_asize)
							if ((l_size).bit_xor (a_dir.to_integer_32)) >= 0 then
								l_p.ce_gets (a_u.item.mp_d)
								from
								until
									not (not js.loop_left and then ((l_p.c_pointer.to_integer_32).to_natural_32 /= (l_up.c_pointer.to_integer_32).to_natural_32))
								loop
									if l_p.item /= {NATURAL_32} 0 then
										if (gmp_inst.gmpn_add_1 (l_rp, l_up, l_asize, (1).to_natural_32)).to_boolean then
											l_rp[0] := (1).to_natural_32
											l_asize := (1).to_integer_32
											a_r.item.mp_exp := (a_r.item.mp_exp) + 1
										end
										if l_size >= 0 then
											a_r.item.mp_size := l_asize.to_integer_32
										else
											a_r.item.mp_size := (-l_asize).to_integer_32
										end
										js.return
									end
									if not js.return_called then
										l_p.ce_gets (l_p + 1)
									end
								end
							end
						end
						if not js.return_called then
							if l_size >= 0 then
								a_r.item.mp_size := l_asize.to_integer_32
							else
								a_r.item.mp_size := (-l_asize).to_integer_32
							end
							if (l_rp.c_pointer.to_integer_32).to_natural_32 /= (l_up.c_pointer.to_integer_32).to_natural_32 then
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_rp, l_up, l_asize)
									js.break
								end
								js.reset
							end
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gmpf_ceil (a_r: CE_POINTER [PD_MPF_STRUCT]; a_u: CE_POINTER [PD_MPF_STRUCT])
		do
			gmpf_ceil_or_floor (1, a_r, a_u)
		end

	gmpf_floor (a_r: CE_POINTER [PD_MPF_STRUCT]; a_u: CE_POINTER [PD_MPF_STRUCT])
		do
			gmpf_ceil_or_floor (-1, a_r, a_u)
		end

end
