class
	P_CFDIV_Q_2EXP

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_cfdiv_q_2exp (a_dir: INTEGER_32; a_w: CE_POINTER [PD_MPZ_STRUCT]; a_u: CE_POINTER [PD_MPZ_STRUCT]; a_cnt: NATURAL_32)
		local
			l_cnt: NATURAL_32
			l_wsize: INTEGER_32
			l_usize: INTEGER_32
			l_abs_usize: INTEGER_32
			l_limb_cnt: INTEGER_32
			l_i: INTEGER_32
			l_up: CE_POINTER [NATURAL_32]
			l_wp: CE_POINTER [NATURAL_32]
			l_round: NATURAL_32
			l_rmask: NATURAL_32
			l_cy: NATURAL_32
			js: JUMP_STATE
		do
			create l_up.make
			create l_wp.make

			l_cnt := a_cnt
			l_usize := (a_u.item.mp_size).to_integer_32
			if l_usize >= 0 then
				l_abs_usize := l_usize
			else
				l_abs_usize := -l_usize
			end
			l_limb_cnt := (l_cnt // {NATURAL_32} 32).to_integer_32
			l_wsize := l_abs_usize - l_limb_cnt
			if l_wsize <= 0 then
				a_w.item.mp_d[0] := (1).to_natural_32
				if l_usize = 0 then
					a_w.item.mp_size := 0
				elseif ((l_usize).bit_xor (a_dir.to_integer_32)) < 0 then
					a_w.item.mp_size := 0
				else
					a_w.item.mp_size := a_dir
				end
				js.return
			end
			if not js.return_called then
				if (builtin_expect ((l_wsize + 1 > (a_w.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					realloc_inst.gmpz_realloc (a_w, l_wsize + 1).do_nothing
				end
				l_up.ce_gets (a_u.item.mp_d)
				l_round := (0).to_natural_32
				if ((l_usize).bit_xor (a_dir.to_integer_32)) >= 0 then
					l_rmask := ((0).to_natural_32).bit_not
				else
					l_rmask := (0).to_natural_32
				end
				if l_rmask /= {NATURAL_32} 0 then
					l_i := (0).to_integer_32
					from
					until
						js.loop_left
					loop
						js.reset
						if l_i < l_limb_cnt then
							if l_round /= {NATURAL_32} 0 then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_round := l_up[l_i]
							l_i := l_i + 1
						end
					end
					js.reset
				end
				l_wp.ce_gets (a_w.item.mp_d)
				l_cnt := l_cnt \\ ({NATURAL_32} 32)
				if l_cnt /= {NATURAL_32} 0 then
					l_round := (l_round).bit_or (((l_rmask).bit_and ((gmp_inst.gmpn_rshift (l_wp, l_up + l_limb_cnt, l_wsize, l_cnt.to_natural_32)))))
					l_wsize := l_wsize - (l_wp[(l_wsize - 1)] = {NATURAL_32} 0).to_integer
				else
					from
					until
						js.loop_left
					loop
						js.reset
						gmp_inst.gmpn_copyi (l_wp, l_up + l_limb_cnt, l_wsize)
						js.break
					end
					js.reset
				end
				if l_round /= {NATURAL_32} 0 then
					if l_wsize /= 0 then
						l_cy := gmp_inst.gmpn_add_1 (l_wp, l_wp, l_wsize, (1).to_natural_32)
						l_wp[l_wsize] := l_cy
						l_wsize := (l_wsize.to_natural_32 + l_cy).to_integer_32
					else
						l_wp[0] := (1).to_natural_32
						l_wsize := (1).to_integer_32
					end
				end
				if l_usize >= 0 then
					a_w.item.mp_size := l_wsize.to_integer_32
				else
					a_w.item.mp_size := (-l_wsize).to_integer_32
				end
			end
		end

	gmpz_cdiv_q_2exp (a_w: CE_POINTER [PD_MPZ_STRUCT]; a_u: CE_POINTER [PD_MPZ_STRUCT]; a_cnt: NATURAL_32)
		do
			gmpz_cfdiv_q_2exp (1, a_w, a_u, a_cnt)
		end

	gmpz_fdiv_q_2exp (a_w: CE_POINTER [PD_MPZ_STRUCT]; a_u: CE_POINTER [PD_MPZ_STRUCT]; a_cnt: NATURAL_32)
		do
			gmpz_cfdiv_q_2exp (-1, a_w, a_u, a_cnt)
		end

end
