class
	P_CLRBIT

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_clrbit (a_d: CE_POINTER [PD_MPZ_STRUCT]; a_bit_index: NATURAL_32)
		local
			l_dsize: INTEGER_32
			l_dp: CE_POINTER [NATURAL_32]
			l_limb_index: INTEGER_32
			l_dlimb: NATURAL_32
			l_tmp: INTEGER_32
			l_zero_bound: INTEGER_32
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_dp.make
			create l_dst.make
			create l_tmp___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dsize := (a_d.item.mp_size).to_integer_32
					l_dp.ce_gets (a_d.item.mp_d)
					l_limb_index := (a_bit_index // {NATURAL_32} 32).to_integer_32
					if not (l_dsize >= 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_limb_index < l_dsize then
							l_dlimb := l_dp[l_limb_index]
							l_dlimb := (l_dlimb).bit_and ((((({NATURAL_32} 1).bit_shift_left ((a_bit_index \\ {NATURAL_32} 32).to_integer_32))).bit_not))
							l_dp[l_limb_index] := l_dlimb
							if l_dlimb = {NATURAL_32} 0 then
								if l_limb_index = l_dsize - 1 then
									l_tmp := 1
								else
									l_tmp := 0
								end
							else
								l_tmp := 0
							end
							if (builtin_expect ((l_tmp /= 0).to_integer, 0)).to_boolean then
								from
								until
									js.loop_left
								loop
									js.reset
									l_dsize := l_dsize - 1
									if l_dsize > 0 then
										if l_dp[(l_dsize - 1)] /= {NATURAL_32} 0 then
											js.break
										end
									else
										js.break
									end
								end
								js.reset
								a_d.item.mp_size := l_dsize.to_integer_32
							end
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 3 then -- else:
						l_dsize := -l_dsize
						l_zero_bound := (0).to_integer_32
						from
						until
							(l_dp[l_zero_bound] /= {NATURAL_32} 0)
						loop
							l_zero_bound := l_zero_bound + 1
						end
						if not (l_limb_index > l_zero_bound) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_limb_index < l_dsize then
							l_dp[l_limb_index] := (l_dp[l_limb_index]).bit_or ((({NATURAL_32} 1).bit_shift_left ((a_bit_index \\ {NATURAL_32} 32).to_integer_32)))
						else
							if (builtin_expect (((a_d.item.mp_alloc).to_integer_32 < l_limb_index + 1).to_integer, 0)).to_boolean then
								l_dp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((realloc_inst.gmpz_realloc (a_d, l_limb_index + 1))))
							end
							from
							until
								js.loop_left
							loop
								js.reset
								if l_limb_index - l_dsize /= 0 then
									l_dst.ce_gets (l_dp + l_dsize)
									l_n := l_limb_index - l_dsize
									from
									until
										js.loop_left
									loop
										js.reset
										l_tmp___3.ce_gets (l_dst)
										l_dst.ce_gets (l_dst + 1)
										l_tmp___3.item := (0).to_natural_32
										l_n := l_n - 1
										if not l_n.to_boolean then
											js.break
										end
									end
									js.reset
								end
								js.break
							end
							js.reset
							l_dp[l_limb_index] := ({NATURAL_32} 1).bit_shift_left ((a_bit_index \\ {NATURAL_32} 32).to_integer_32)
							a_d.item.mp_size := (-(l_limb_index + 1)).to_integer_32
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 6 then -- else:
						if l_limb_index /= l_zero_bound then
							l_pos := -1 + 14 -- skip if block
						end
				when 7 then -- if:
						l_dp[l_limb_index] := (((((l_dp[l_limb_index] - {NATURAL_32} 1)).bit_or ((({NATURAL_32} 1).bit_shift_left ((a_bit_index \\ {NATURAL_32} 32).to_integer_32)))) + {NATURAL_32} 1)).bit_and ({NATURAL_32} 4294967295)
						if l_dp[l_limb_index] /= {NATURAL_32} 0 then
							l_pos := -1 + 14 -- skip if block
						end
				when 8 then -- if:
						l_i := l_limb_index + 1
				when 9 then -- loop condition:
						if not (l_i < l_dsize) then
							l_pos := -1 + 12 -- skip loop
						end
				when 10 then -- loop body:
						l_dp[l_i] := ((l_dp[l_i] + {NATURAL_32} 1)).bit_and ({NATURAL_32} 4294967295)
						if l_dp[l_i] /= {NATURAL_32} 0 then
							l_pos := -1 + 13 -- goto fin
						end
				when 11 then
						l_i := l_i + 1
						l_pos := -1 + 9 -- back to loop condition
				when 12 then -- loop done
						l_dsize := l_dsize + 1
						if (builtin_expect (((a_d.item.mp_alloc).to_integer_32 < l_dsize).to_integer, 0)).to_boolean then
							l_dp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((realloc_inst.gmpz_realloc (a_d, l_dsize))))
						end
						l_dp[l_i] := (1).to_natural_32
						a_d.item.mp_size := (-l_dsize).to_integer_32
				when 13 then -- fin:
						
				when 14 then -- if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
