class
	P_CMP

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_cmp (a_u: CE_POINTER [PD_MPF_STRUCT]; a_v: CE_POINTER [PD_MPF_STRUCT]): INTEGER_32
		local
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_uexp: INTEGER_32
			l_vexp: INTEGER_32
			l_cmp: INTEGER_32
			l_usign: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_up.make
			create l_vp.make

			l_uexp := a_u.item.mp_exp
			l_vexp := a_v.item.mp_exp
			l_usize := (a_u.item.mp_size).to_integer_32
			l_vsize := (a_v.item.mp_size).to_integer_32
			if ((l_usize).bit_xor (l_vsize)) >= 0 then
				if l_usize = 0 then
					Result := (-(l_vsize /= 0).to_integer).to_integer
					js.return
				end
				if not js.return_called and then (l_vsize = 0) then
					Result := (l_usize /= 0).to_integer
					js.return
				end
			else
				if l_usize >= 0 then
					l_tmp := 1
				else
					l_tmp := -1
				end
				Result := l_tmp
				js.return
			end
			if not js.return_called then
				if l_usize >= 0 then
					l_usign := 1
				else
					l_usign := -1
				end
				if l_uexp > l_vexp then
					Result := l_usign
					js.return
				end
			end
			if not js.return_called and then (l_uexp < l_vexp) then
				Result := (-l_usign)
				js.return
			end
			if not js.return_called then
				if l_usize >= 0 then
					l_usize := l_usize
				else
					l_usize := -l_usize
				end
				if l_vsize >= 0 then
					l_vsize := l_vsize
				else
					l_vsize := -l_vsize
				end
				l_up.ce_gets (a_u.item.mp_d)
				l_vp.ce_gets (a_v.item.mp_d)
				from
				until
					l_up[0] /= {NATURAL_32} 0
				loop
					l_up.ce_gets (l_up + 1)
					l_usize := l_usize - 1
				end
				from
				until
					l_vp[0] /= {NATURAL_32} 0
				loop
					l_vp.ce_gets (l_vp + 1)
					l_vsize := l_vsize - 1
				end
				if l_usize > l_vsize then
					l_cmp := gmp_inst.gmpn_cmp ((l_up + l_usize) - l_vsize, l_vp, l_vsize)
					if l_cmp = 0 then
						Result := l_usign
						js.return
					end
				elseif l_vsize > l_usize then
					l_cmp := gmp_inst.gmpn_cmp (l_up, (l_vp + l_vsize) - l_usize, l_usize)
					if l_cmp = 0 then
						Result := (-l_usign)
						js.return
					end
				else
					l_cmp := gmp_inst.gmpn_cmp (l_up, l_vp, l_usize)
					if l_cmp = 0 then
						Result := 0
						js.return
					end
				end
			end
			if not js.return_called then
				if l_cmp > 0 then
					l_tmp___0 := l_usign
				else
					l_tmp___0 := -l_usign
				end
				Result := l_tmp___0
			end
		end

	gmpz_cmp (a_u: CE_POINTER [PD_MPZ_STRUCT]; a_v: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_dsize: INTEGER_32
			l_asize: INTEGER_32
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_cmp: INTEGER_32
			l_gmp_i: INTEGER_32
			l_gmp_x: NATURAL_32
			l_gmp_y: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_up.make
			create l_vp.make

			l_usize := (a_u.item.mp_size).to_integer_32
			l_vsize := (a_v.item.mp_size).to_integer_32
			l_dsize := l_usize - l_vsize
			if l_dsize /= 0 then
				Result := l_dsize.to_integer_32
				js.return
			end
			if not js.return_called then
				if l_usize >= 0 then
					l_asize := l_usize
				else
					l_asize := -l_usize
				end
				l_up.ce_gets (a_u.item.mp_d)
				l_vp.ce_gets (a_v.item.mp_d)
				from
				until
					js.loop_left
				loop
					js.reset
					l_cmp := 0
					l_gmp_i := l_asize
					from
					until
						js.loop_left
					loop
						js.reset
						l_gmp_i := l_gmp_i - 1
						if not (l_gmp_i >= 0) then
							js.break
						end
						if not js.loop_jumped then
							l_gmp_x := l_up[l_gmp_i]
							l_gmp_y := l_vp[l_gmp_i]
							if l_gmp_x /= l_gmp_y then
								if l_gmp_x > l_gmp_y then
									l_cmp := 1
								else
									l_cmp := -1
								end
								js.break
							end
						end
					end
					js.reset
					js.break
				end
				js.reset
				if l_usize >= 0 then
					l_tmp := l_cmp
				else
					l_tmp := -l_cmp
				end
				Result := l_tmp
			end
		end

	gmpq_cmp (a_op1: CE_POINTER [PD_MPQ_STRUCT]; a_op2: CE_POINTER [PD_MPQ_STRUCT]): INTEGER_32
		local
			l_num1_size: INTEGER_32
			l_den1_size: INTEGER_32
			l_num2_size: INTEGER_32
			l_den2_size: INTEGER_32
			l_tmp1_size: INTEGER_32
			l_tmp2_size: INTEGER_32
			l_tmp1_ptr: CE_POINTER [NATURAL_32]
			l_tmp2_ptr: CE_POINTER [NATURAL_32]
			l_num1_sign: INTEGER_32
			l_cc: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_cnt1: INTEGER_32
			l_cnt2: INTEGER_32
			l_bits1: NATURAL_32
			l_bits2: NATURAL_32
			l_tmp___12: CE_POINTER [ANY]
			l_tmp___20: INTEGER_32
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_tmp1_ptr.make
			create l_tmp2_ptr.make
			create l_tmp_marker.make
			create l_tmp___12.make

			l_num1_size := (a_op1.item.mp_num.mp_size).to_integer_32
			l_den1_size := (a_op1.item.mp_den.mp_size).to_integer_32
			l_num2_size := (a_op2.item.mp_num.mp_size).to_integer_32
			l_den2_size := (a_op2.item.mp_den.mp_size).to_integer_32
			if l_num1_size = 0 then
				Result := (-l_num2_size).to_integer_32
				js.return
			end
			if not js.return_called and then (l_num2_size = 0) then
				Result := l_num1_size.to_integer_32
				js.return
			end
			if not js.return_called and then (((l_num1_size).bit_xor (l_num2_size)) < 0) then
				Result := l_num1_size.to_integer_32
				js.return
			end
			if not js.return_called then
				l_num1_sign := l_num1_size
				if l_num1_size >= 0 then
					l_num1_size := l_num1_size
				else
					l_num1_size := -l_num1_size
				end
				if l_num2_size >= 0 then
					l_num2_size := l_num2_size
				else
					l_num2_size := -l_num2_size
				end
				l_tmp1_size := l_num1_size + l_den2_size
				l_tmp2_size := l_num2_size + l_den1_size
				if l_tmp1_size > l_tmp2_size + 1 then
					Result := l_num1_sign.to_integer_32
					js.return
				end
			end
			if not js.return_called and then (l_tmp2_size > l_tmp1_size + 1) then
				Result := (-l_num1_sign).to_integer_32
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_cnt1 := builtin_clzl (a_op1.item.mp_num.mp_d[(l_num1_size - 1)])
					js.break
				end
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					l_cnt2 := builtin_clzl (a_op2.item.mp_den.mp_d[(l_den2_size - 1)])
					js.break
				end
				js.reset
				l_bits1 := ((l_tmp1_size * 32 - l_cnt1.to_integer_32) - l_cnt2.to_integer_32).to_natural_32
				from
				until
					js.loop_left
				loop
					js.reset
					l_cnt1 := builtin_clzl (a_op2.item.mp_num.mp_d[(l_num2_size - 1)])
					js.break
				end
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					l_cnt2 := builtin_clzl (a_op1.item.mp_den.mp_d[(l_den1_size - 1)])
					js.break
				end
				js.reset
				l_bits2 := ((l_tmp2_size * 32 - l_cnt1.to_integer_32) - l_cnt2.to_integer_32).to_natural_32
				if l_bits1 > l_bits2 + {NATURAL_32} 1 then
					Result := l_num1_sign.to_integer_32
					js.return
				end
			end
			if not js.return_called and then (l_bits2 > l_bits1 + {NATURAL_32} 1) then
				Result := (-l_num1_sign).to_integer_32
				js.return
			end
			if not js.return_called then
				l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect (((l_tmp1_size + l_tmp2_size).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___12.ce_gets ((l_aaf.new (((l_tmp1_size + l_tmp2_size).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___12.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_tmp1_size + l_tmp2_size).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_tmp1_ptr.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___12))
					l_tmp2_ptr.ce_gets (l_tmp1_ptr + l_tmp1_size)
					js.break
				end
				js.reset
				if l_num1_size >= l_den2_size then
					l_tmp1_size := l_tmp1_size - ({NATURAL_32} 0 = (mul_inst.gmpn_mul (l_tmp1_ptr, a_op1.item.mp_num.mp_d, l_num1_size, a_op2.item.mp_den.mp_d, l_den2_size))).to_integer
				else
					l_tmp1_size := l_tmp1_size - ({NATURAL_32} 0 = (mul_inst.gmpn_mul (l_tmp1_ptr, a_op2.item.mp_den.mp_d, l_den2_size, a_op1.item.mp_num.mp_d, l_num1_size))).to_integer
				end
				if l_num2_size >= l_den1_size then
					l_tmp2_size := l_tmp2_size - ({NATURAL_32} 0 = (mul_inst.gmpn_mul (l_tmp2_ptr, a_op2.item.mp_num.mp_d, l_num2_size, a_op1.item.mp_den.mp_d, l_den1_size))).to_integer
				else
					l_tmp2_size := l_tmp2_size - ({NATURAL_32} 0 = (mul_inst.gmpn_mul (l_tmp2_ptr, a_op1.item.mp_den.mp_d, l_den1_size, a_op2.item.mp_num.mp_d, l_num2_size))).to_integer
				end
				if l_tmp1_size - l_tmp2_size /= 0 then
					l_cc := (l_tmp1_size - l_tmp2_size).to_integer_32
				else
					l_cc := (gmp_inst.gmpn_cmp (l_tmp1_ptr, l_tmp2_ptr, l_tmp1_size))
				end
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
					end
					js.break
				end
				js.reset
				if l_num1_sign < 0 then
					l_tmp___20 := -l_cc
				else
					l_tmp___20 := l_cc
				end
				Result := l_tmp___20
			end
		end

end
