class
	P_CMP_D

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_cmp_d (a_f: CE_POINTER [PD_MPF_STRUCT]; a_d: REAL_64): INTEGER_32
		local
			l_darray: CE_ARRAY [NATURAL_32]
			l_df: CE_ARRAY [PD_MPF_STRUCT]
			l_u: PD_IEEE_DOUBLE_EXTRACT
			l_tmp: INTEGER_32
			l_tmp___1: REAL_64
			js: JUMP_STATE
		do
			create l_darray.make (<<3>>)
			create l_df.make (<<1>>)
			create l_u.make

			from
			until
				js.loop_left
			loop
				js.reset
				l_u.d := a_d
				if (builtin_expect ((l_u.s.exp = {NATURAL_32} 2047).to_integer, 0)).to_boolean then
					if l_u.s.manl = {NATURAL_32} 0 then
						if l_u.s.manh = {NATURAL_32} 0 then
							if a_d < 0.0 then
								l_tmp := 1
							else
								l_tmp := -1
							end
							Result := l_tmp
							js.return
						else
							invalid_inst.gmp_invalid_operation
						end
					else
						invalid_inst.gmp_invalid_operation
					end
				end
				if not js.return_called then
					js.break
				end
			end
			js.reset
			if not js.return_called and then (a_d = 0.0) then
				Result := (a_f.item.mp_size)
				js.return
			end
			if not js.return_called then
				l_df[0].mp_d := l_darray
				if a_d >= 0.0 then
					l_df[0].mp_size := 3
				else
					l_df[0].mp_size := -3
				end
				if a_d >= (0).to_double then
					l_tmp___1 := a_d
				else
					l_tmp___1 := -a_d
				end
				l_df[0].mp_exp := (extract_dbl_inst.gmp_extract_double (l_darray, l_tmp___1)).to_integer_32
				Result := (cmp_inst.gmpf_cmp (a_f, create {CE_POINTER [PD_MPF_STRUCT]}.make_cast (l_df)))
			end
		end

	gmpz_cmp_d (a_z: CE_POINTER [PD_MPZ_STRUCT]; a_d: REAL_64): INTEGER_32
		local
			l_d: REAL_64
			l_darray: CE_ARRAY [NATURAL_32]
			l_zlimb: NATURAL_32
			l_dlimb: NATURAL_32
			l_zp: CE_POINTER [NATURAL_32]
			l_zsize: INTEGER_32
			l_dexp: INTEGER_32
			l_ret: INTEGER_32
			l_u: PD_IEEE_DOUBLE_EXTRACT
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_i: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_darray.make (<<3>>)
			create l_zp.make
			create l_u.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d := a_d
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_u.d := l_d
						if (builtin_expect ((l_u.s.exp = {NATURAL_32} 2047).to_integer, 0)).to_boolean then
							if l_u.s.manl = {NATURAL_32} 0 then
								if l_u.s.manh = {NATURAL_32} 0 then
									l_pos := -1 + 5 -- goto z_zero
								else
									invalid_inst.gmp_invalid_operation
								end
							else
								invalid_inst.gmp_invalid_operation
							end
						end
				when 3 then
						js.break
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					js.reset
					l_zsize := (a_z.item.mp_size).to_integer_32
					if l_d = 0.0 then
						Result := l_zsize.to_integer_32
						js.return
					end
					if not (not js.return_called and then (l_zsize = 0)) then
						l_pos := -1 + 6 -- skip if block
					end
				when 5 then -- if: | z_zero:
						if l_d < 0.0 then
							l_tmp___0 := 1
						else
							l_tmp___0 := -1
						end
						Result := l_tmp___0
						js.return
				when 6 then -- if done
					if not js.return_called then
						if l_zsize >= 0 then
							if l_d < 0.0 then
								Result := 1
								js.return
							end
							if not js.return_called then
								l_ret := 1
							end
						else
							if l_d >= 0.0 then
								Result := (-1)
								js.return
							end
							if not js.return_called then
								l_ret := -1
								l_d := -l_d
								l_zsize := -l_zsize
							end
						end
					end
					if not js.return_called and then (l_d < 1.0) then
						Result := l_ret
						js.return
					end
					if not js.return_called then
						l_dexp := extract_dbl_inst.gmp_extract_double (l_darray, l_d)
						if l_zsize /= l_dexp.to_integer_32 then
							if l_zsize >= l_dexp.to_integer_32 then
								l_tmp___1 := l_ret
							else
								l_tmp___1 := -l_ret
							end
							Result := l_tmp___1
							js.return
						end
					end
					if not js.return_called then
						l_zp.ce_gets (a_z.item.mp_d)
						from
						until
							js.loop_left
						loop
							js.reset
							l_zlimb := l_zp[(l_zsize - 1)]
							l_dlimb := l_darray[2]
							if l_zlimb /= l_dlimb then
								if l_zlimb >= l_dlimb then
									l_tmp___2 := l_ret
								else
									l_tmp___2 := -l_ret
								end
								Result := l_tmp___2
								js.return
							end
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called and then (l_zsize = 1) then
						if ((l_darray[0]).bit_or (l_darray[1])) /= {NATURAL_32} 0 then
							l_tmp___3 := -l_ret
						else
							l_tmp___3 := 0
						end
						Result := l_tmp___3
						js.return
					end
					if not js.return_called then
						from
						until
							js.loop_left
						loop
							js.reset
							l_zlimb := l_zp[(l_zsize - 2)]
							l_dlimb := l_darray[1]
							if l_zlimb /= l_dlimb then
								if l_zlimb >= l_dlimb then
									l_tmp___4 := l_ret
								else
									l_tmp___4 := -l_ret
								end
								Result := l_tmp___4
								js.return
							end
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called and then (l_zsize = 2) then
						if l_darray[0] /= {NATURAL_32} 0 then
							l_tmp___5 := -l_ret
						else
							l_tmp___5 := 0
						end
						Result := l_tmp___5
						js.return
					end
					if not js.return_called then
						from
						until
							js.loop_left
						loop
							js.reset
							l_zlimb := l_zp[(l_zsize - 3)]
							l_dlimb := l_darray[0]
							if l_zlimb /= l_dlimb then
								if l_zlimb >= l_dlimb then
									l_tmp___6 := l_ret
								else
									l_tmp___6 := -l_ret
								end
								Result := l_tmp___6
								js.return
							end
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						from
						until
							js.loop_left
						loop
							js.reset
							l_i := (l_zsize - 3) - 1
							from
							until
								not (not js.loop_left and then (l_i >= 0))
							loop
								if l_zp[l_i] /= {NATURAL_32} 0 then
									Result := l_ret
									js.return
								end
								if not js.return_called then
									l_i := l_i - 1
								end
							end
							if not js.return_called then
								Result := 0
								js.return
							end
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						Result := 0
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
