class
	P_CMPABS_D

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_cmpabs_d (a_z: CE_POINTER [PD_MPZ_STRUCT]; a_d: REAL_64): INTEGER_32
		local
			l_d: REAL_64
			l_darray: CE_ARRAY [NATURAL_32]
			l_zlimb: NATURAL_32
			l_dlimb: NATURAL_32
			l_zp: CE_POINTER [NATURAL_32]
			l_zsize: INTEGER_32
			l_dexp: INTEGER_32
			l_u: PD_IEEE_DOUBLE_EXTRACT
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			create l_darray.make (<<3>>)
			create l_zp.make
			create l_u.make

			l_d := a_d
			from
			until
				js.loop_left
			loop
				js.reset
				l_u.d := l_d
				if (builtin_expect ((l_u.s.exp = {NATURAL_32} 2047).to_integer, 0)).to_boolean then
					if l_u.s.manl = {NATURAL_32} 0 then
						if l_u.s.manh = {NATURAL_32} 0 then
							Result := (-1)
							js.return
						else
							invalid_inst.gmp_invalid_operation
						end
					else
						invalid_inst.gmp_invalid_operation
					end
				end
				if not js.return_called then
					js.break
				end
			end
			js.reset
			if not js.return_called then
				l_zsize := (a_z.item.mp_size).to_integer_32
				if l_d = 0.0 then
					Result := (l_zsize /= 0).to_integer
					js.return
				end
			end
			if not js.return_called and then (l_zsize = 0) then
				if l_d /= (0).to_double then
					l_tmp___0 := -1
				else
					l_tmp___0 := 0
				end
				Result := l_tmp___0
				js.return
			end
			if not js.return_called then
				if l_zsize >= 0 then
					l_zsize := l_zsize
				else
					l_zsize := -l_zsize
				end
				if l_d >= (0).to_double then
					l_d := l_d
				else
					l_d := -l_d
				end
				if l_d < 1.0 then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				l_dexp := extract_dbl_inst.gmp_extract_double (l_darray, l_d)
				if l_zsize /= l_dexp.to_integer_32 then
					if l_zsize >= l_dexp.to_integer_32 then
						l_tmp___1 := 1
					else
						l_tmp___1 := -1
					end
					Result := l_tmp___1
					js.return
				end
			end
			if not js.return_called then
				l_zp.ce_gets (a_z.item.mp_d)
				from
				until
					js.loop_left
				loop
					js.reset
					l_zlimb := l_zp[(l_zsize - 1)]
					l_dlimb := l_darray[2]
					if l_zlimb /= l_dlimb then
						if l_zlimb >= l_dlimb then
							l_tmp___2 := 1
						else
							l_tmp___2 := -1
						end
						Result := l_tmp___2
						js.return
					end
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (l_zsize = 1) then
				if ((l_darray[0]).bit_or (l_darray[1])) /= {NATURAL_32} 0 then
					l_tmp___3 := -1
				else
					l_tmp___3 := 0
				end
				Result := l_tmp___3
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_zlimb := l_zp[(l_zsize - 2)]
					l_dlimb := l_darray[1]
					if l_zlimb /= l_dlimb then
						if l_zlimb >= l_dlimb then
							l_tmp___4 := 1
						else
							l_tmp___4 := -1
						end
						Result := l_tmp___4
						js.return
					end
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (l_zsize = 2) then
				if l_darray[0] /= {NATURAL_32} 0 then
					l_tmp___5 := -1
				else
					l_tmp___5 := 0
				end
				Result := l_tmp___5
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_zlimb := l_zp[(l_zsize - 3)]
					l_dlimb := l_darray[0]
					if l_zlimb /= l_dlimb then
						if l_zlimb >= l_dlimb then
							l_tmp___6 := 1
						else
							l_tmp___6 := -1
						end
						Result := l_tmp___6
						js.return
					end
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_i := (l_zsize - 3) - 1
					from
					until
						not (not js.loop_left and then (l_i >= 0))
					loop
						if l_zp[l_i] /= {NATURAL_32} 0 then
							Result := 1
							js.return
						end
						if not js.return_called then
							l_i := l_i - 1
						end
					end
					if not js.return_called then
						Result := 0
						js.return
					end
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

end
