class
	P_COM

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_com (a_dst: CE_POINTER [PD_MPZ_STRUCT]; a_src: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_size: INTEGER_32
			l_src_ptr: CE_POINTER [NATURAL_32]
			l_dst_ptr: CE_POINTER [NATURAL_32]
			l_cy: NATURAL_32
			js: JUMP_STATE
		do
			create l_src_ptr.make
			create l_dst_ptr.make

			l_size := (a_src.item.mp_size).to_integer_32
			if l_size >= 0 then
				if (a_dst.item.mp_alloc).to_integer_32 < l_size + 1 then
					realloc_inst.gmpz_realloc (a_dst, l_size + 1).do_nothing
				end
				l_src_ptr.ce_gets (a_src.item.mp_d)
				l_dst_ptr.ce_gets (a_dst.item.mp_d)
				if (builtin_expect ((l_size = 0).to_integer, 0)).to_boolean then
					l_dst_ptr[0] := (1).to_natural_32
					a_dst.item.mp_size := -1
					js.return
				end
				if not js.return_called then
					l_cy := gmp_inst.gmpn_add_1 (l_dst_ptr, l_src_ptr, l_size, (1).to_natural_32)
					if l_cy.to_boolean then
						l_dst_ptr[l_size] := l_cy
						l_size := l_size + 1
					end
					a_dst.item.mp_size := (-l_size).to_integer_32
				end
			else
				l_size := -l_size
				if (a_dst.item.mp_alloc).to_integer_32 < l_size then
					realloc_inst.gmpz_realloc (a_dst, l_size).do_nothing
				end
				l_src_ptr.ce_gets (a_src.item.mp_d)
				l_dst_ptr.ce_gets (a_dst.item.mp_d)
				gmp_inst.gmpn_sub_1 (l_dst_ptr, l_src_ptr, l_size, (1).to_natural_32).do_nothing
				l_size := l_size - (l_dst_ptr[(l_size - 1)] = {NATURAL_32} 0).to_integer
				a_dst.item.mp_size := l_size.to_integer_32
			end
			if not js.return_called then
			end
		end

	gmpn_com (a_rp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_n: INTEGER_32)
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_ul: NATURAL_32
			l_tmp: CE_POINTER [NATURAL_32]
			l_tmp___0: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_rp.make
			create l_up.make
			create l_tmp.make
			create l_tmp___0.make

			l_rp.ce_gets (a_rp)
			l_up.ce_gets (a_up)
			l_n := a_n
			from
			until
				js.loop_left
			loop
				js.reset
				l_tmp.ce_gets (l_up)
				l_up.ce_gets (l_up + 1)
				l_ul := l_tmp.item
				l_tmp___0.ce_gets (l_rp)
				l_rp.ce_gets (l_rp + 1)
				l_tmp___0.item := ((l_ul).bit_not).bit_and ({NATURAL_32} 4294967295)
				l_n := l_n - 1
				if l_n = 0 then
					js.break
				end
			end
			js.reset
		end

end
