class
	P_COMBIT

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_combit (a_d: CE_POINTER [PD_MPZ_STRUCT]; a_bit_index: NATURAL_32)
		local
			l_dsize: INTEGER_32
			l_tmp: INTEGER_32
			l_dp: CE_POINTER [NATURAL_32]
			l_limb_index: INTEGER_32
			l_bit: NATURAL_32
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_32]
			l_x___2: NATURAL_32
			l_i: INTEGER_32
			l_c: NATURAL_32
			l_gmp_i: INTEGER_32
			l_gmp_x: NATURAL_32
			l_gmp_r: NATURAL_32
			l_gmp_j: INTEGER_32
			l_gmp_j___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_dp.make
			create l_dst.make
			create l_tmp___1.make

			if a_d.item.mp_size >= 0 then
				l_tmp := a_d.item.mp_size
			else
				l_tmp := -a_d.item.mp_size
			end
			l_dsize := l_tmp.to_integer_32
			l_dp.ce_gets (a_d.item.mp_d)
			l_limb_index := (a_bit_index // {NATURAL_32} 32).to_integer_32
			l_bit := ({NATURAL_32} 1).bit_shift_left ((a_bit_index \\ {NATURAL_32} 32).to_integer_32)
			if l_limb_index >= l_dsize then
				if (builtin_expect ((l_limb_index + 1 > (a_d.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					realloc_inst.gmpz_realloc (a_d, l_limb_index + 1).do_nothing
				end
				l_dp.ce_gets (a_d.item.mp_d)
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_limb_index + 1) - l_dsize /= 0 then
						l_dst.ce_gets (l_dp + l_dsize)
						l_n := (l_limb_index + 1) - l_dsize
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp___1.ce_gets (l_dst)
							l_dst.ce_gets (l_dst + 1)
							l_tmp___1.item := (0).to_natural_32
							l_n := l_n - 1
							if not l_n.to_boolean then
								js.break
							end
						end
						js.reset
					end
					js.break
				end
				js.reset
				l_dsize := l_limb_index + 1
			end
			if a_d.item.mp_size >= 0 then
				l_dp[l_limb_index] := (l_dp[l_limb_index]).bit_xor (l_bit)
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						not (not js.loop_left and then (l_dsize > 0))
					loop
						js.reset
						if l_dp[(l_dsize - 1)] /= {NATURAL_32} 0 then
							js.break
						end
						if not js.loop_jumped then
							l_dsize := l_dsize - 1
						end
					end
					js.reset
					js.break
				end
				js.reset
				a_d.item.mp_size := l_dsize.to_integer_32
			else
				l_x___2 := (-(l_dp[l_limb_index]).to_integer_32).to_natural_32
				l_i := l_limb_index - 1
				from
				until
					not (not js.loop_left and then (l_i >= 0))
				loop
					js.reset
					if l_dp[l_i] /= {NATURAL_32} 0 then
						l_x___2 := l_x___2 - 1
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i - 1
					end
				end
				js.reset
				if ((l_x___2).bit_and (l_bit)).to_boolean then
					if (builtin_expect ((l_dsize + 1 > (a_d.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
						realloc_inst.gmpz_realloc (a_d, l_dsize + 1).do_nothing
					end
					l_dp.ce_gets (a_d.item.mp_d)
					from
					until
						js.loop_left
					loop
						js.reset
						l_gmp_x := (l_dp + l_limb_index)[0]
						l_gmp_r := l_gmp_x + l_bit;
						(l_dp + l_limb_index)[0] := l_gmp_r
						if l_gmp_r < l_bit then
							l_c := (1).to_natural_32
							l_gmp_i := (1).to_integer_32
							from
							until
								not (not js.loop_left and then (l_gmp_i < l_dsize - l_limb_index))
							loop
								js.reset
								l_gmp_x := (l_dp + l_limb_index)[l_gmp_i]
								l_gmp_r := l_gmp_x + {NATURAL_32} 1;
								(l_dp + l_limb_index)[l_gmp_i] := l_gmp_r
								l_gmp_i := l_gmp_i + 1
								if not (l_gmp_r < {NATURAL_32} 1) then
									if ((l_dp + l_limb_index).c_pointer.to_integer_32).to_natural_32 /= ((l_dp + l_limb_index).c_pointer.to_integer_32).to_natural_32 then
										from
										until
											js.loop_left
										loop
											js.reset
											l_gmp_j := l_gmp_i
											from
											until
												not (l_gmp_j < l_dsize - l_limb_index)
											loop
												(l_dp + l_limb_index)[l_gmp_j] := (l_dp + l_limb_index)[l_gmp_j]
												l_gmp_j := l_gmp_j + 1
											end
											js.break
										end
										js.reset
									end
									l_c := (0).to_natural_32
									js.break
								end
							end
							js.reset
						else
							if ((l_dp + l_limb_index).c_pointer.to_integer_32).to_natural_32 /= ((l_dp + l_limb_index).c_pointer.to_integer_32).to_natural_32 then
								from
								until
									js.loop_left
								loop
									js.reset
									l_gmp_j___0 := (1).to_integer_32
									from
									until
										not (l_gmp_j___0 < l_dsize - l_limb_index)
									loop
										(l_dp + l_limb_index)[l_gmp_j___0] := (l_dp + l_limb_index)[l_gmp_j___0]
										l_gmp_j___0 := l_gmp_j___0 + 1
									end
									js.break
								end
								js.reset
							end
							l_c := (0).to_natural_32
						end
						js.break
					end
					js.reset
					l_dp[l_dsize] := l_c
					l_dsize := (l_dsize.to_natural_32 + l_c).to_integer_32
				else
					gmp_inst.gmpn_sub_1 (l_dp + l_limb_index, (l_dp + l_limb_index), l_dsize + l_limb_index, l_bit).do_nothing
				end
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						not (not js.loop_left and then (l_dsize > 0))
					loop
						js.reset
						if l_dp[(l_dsize - 1)] /= {NATURAL_32} 0 then
							js.break
						end
						if not js.loop_jumped then
							l_dsize := l_dsize - 1
						end
					end
					js.reset
					js.break
				end
				js.reset
				a_d.item.mp_size := (-l_dsize).to_integer_32
			end
		end

end
