class
	P_CONG_2EXP

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_congruent_2exp_p (a_a: CE_POINTER [PD_MPZ_STRUCT]; a_c: CE_POINTER [PD_MPZ_STRUCT]; a_d: NATURAL_32): INTEGER_32
		local
			l_a: CE_POINTER [PD_MPZ_STRUCT]
			l_c: CE_POINTER [PD_MPZ_STRUCT]
			l_i: INTEGER_32
			l_dlimbs: INTEGER_32
			l_dbits: NATURAL_32
			l_ap: CE_POINTER [NATURAL_32]
			l_cp: CE_POINTER [NATURAL_32]
			l_dmask: NATURAL_32
			l_alimb: NATURAL_32
			l_climb: NATURAL_32
			l_sum: NATURAL_32
			l_asize_signed: INTEGER_32
			l_csize_signed: INTEGER_32
			l_asize: INTEGER_32
			l_csize: INTEGER_32
			l_mpz_srcptr_swap__tmp: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_a.make
			create l_c.make
			create l_ap.make
			create l_cp.make
			create l_mpz_srcptr_swap__tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_a.ce_gets (a_a)
					l_c.ce_gets (a_c)
					if l_a.item.mp_size >= 0 then
						l_tmp := l_a.item.mp_size
					else
						l_tmp := -l_a.item.mp_size
					end
					if l_c.item.mp_size >= 0 then
						l_tmp___0 := l_c.item.mp_size
					else
						l_tmp___0 := -l_c.item.mp_size
					end
					if l_tmp < l_tmp___0 then
						from
						until
							js.loop_left
						loop
							js.reset
							l_mpz_srcptr_swap__tmp.ce_gets (l_a)
							l_a.ce_gets (l_c)
							l_c.ce_gets (l_mpz_srcptr_swap__tmp)
							js.break
						end
						js.reset
					end
					l_dlimbs := (a_d // {NATURAL_32} 32).to_integer_32
					l_dbits := (a_d \\ {NATURAL_32} 32).to_natural_32
					l_dmask := (({NATURAL_32} 1).bit_shift_left (l_dbits.to_integer_32)) - {NATURAL_32} 1
					l_ap.ce_gets (l_a.item.mp_d)
					l_cp.ce_gets (l_c.item.mp_d)
					l_asize_signed := (l_a.item.mp_size).to_integer_32
					if l_asize_signed >= 0 then
						l_asize := l_asize_signed
					else
						l_asize := -l_asize_signed
					end
					l_csize_signed := (l_c.item.mp_size).to_integer_32
					if l_csize_signed >= 0 then
						l_csize := l_csize_signed
					else
						l_csize := -l_csize_signed
					end
					if l_csize_signed = 0 then
						l_pos := -1 + 3 -- goto a_zeros
					end
				when 1 then
					if not (((l_asize_signed).bit_xor (l_csize_signed)) >= 0) then
						l_pos := -1 + 6 -- skip if block
					end
				when 2 then -- if:
						if l_csize < l_dlimbs then
							l_tmp___1 := l_csize
						else
							l_tmp___1 := l_dlimbs
						end
						if (gmp_inst.gmpn_cmp (l_ap, l_cp, l_tmp___1)) /= 0 then
							Result := 0
							js.return
						end
						if not js.return_called and then (l_csize > l_dlimbs) then
							Result := ((((l_ap[l_dlimbs] - l_cp[l_dlimbs])).bit_and (l_dmask)) = {NATURAL_32} 0).to_integer
							js.return
						end
						if js.return_called then
							l_pos := -1 + 4 -- skip if block
						end
				when 3 then -- if: | a_zeros:
						if l_asize <= l_dlimbs then
							Result := (l_asize = l_csize).to_integer
							js.return
						end
				when 4 then -- if done
						if not js.return_called then
							l_i := l_csize
							from
							until
								not (not js.loop_left and then (l_i < l_dlimbs))
							loop
								if l_ap[l_i] /= {NATURAL_32} 0 then
									Result := 0
									js.return
								end
								if not js.return_called then
									l_i := l_i + 1
								end
							end
						end
						if not js.return_called then
							Result := (((l_ap[l_dlimbs]).bit_and (l_dmask)) = {NATURAL_32} 0).to_integer
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_i := (0).to_integer_32
						from
						until
							js.loop_left
						loop
							js.reset
							l_alimb := l_ap[l_i]
							l_climb := l_cp[l_i]
							l_sum := ((l_alimb + l_climb)).bit_and ({NATURAL_32} 4294967295)
							if l_i >= l_dlimbs then
								Result := (((l_sum).bit_and (l_dmask)) = {NATURAL_32} 0).to_integer
								js.return
							end
							if not js.return_called then
								l_i := l_i + 1
								if l_sum /= {NATURAL_32} 0 then
									Result := 0
									js.return
								end
							end
							if not js.return_called and then (l_alimb /= {NATURAL_32} 0) then
								js.break
							end
						end
						js.reset
						if not js.return_called then
							from
							until
								not (not js.loop_left and then (not (l_i >= l_csize)))
							loop
								l_alimb := l_ap[l_i]
								l_climb := l_cp[l_i]
								l_sum := (((l_alimb + l_climb) + {NATURAL_32} 1)).bit_and ({NATURAL_32} 4294967295)
								if l_i >= l_dlimbs then
									Result := (((l_sum).bit_and (l_dmask)) = {NATURAL_32} 0).to_integer
									js.return
								end
								if not js.return_called and then (l_sum /= {NATURAL_32} 0) then
									Result := 0
									js.return
								end
								if not js.return_called then
									l_i := l_i + 1
								end
							end
						end
						if not js.return_called and then (l_asize < l_dlimbs) then
							Result := 0
							js.return
						end
						if not js.return_called then
							from
							until
								not (not js.loop_left and then (l_i < l_dlimbs))
							loop
								if l_ap[l_i] /= {NATURAL_32} 4294967295 then
									Result := 0
									js.return
								end
								if not js.return_called then
									l_i := l_i + 1
								end
							end
						end
						if not js.return_called and then (l_dbits = {NATURAL_32} 0) then
							Result := 1
							js.return
						end
						if not js.return_called and then (l_asize = l_dlimbs) then
							Result := 0
							js.return
						end
						if not js.return_called then
							Result := ((((l_ap[l_dlimbs] + {NATURAL_32} 1)).bit_and (l_dmask)) = {NATURAL_32} 0).to_integer
						end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
