class
	P_DCPI1_DIVAPPR_Q

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_dcpi1_divappr_q_n (a_qp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_dp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_dinv: CE_POINTER [PD_GMP_PI1_T]; a_tp: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_lo: INTEGER_32
			l_hi: INTEGER_32
			l_cy: NATURAL_32
			l_qh: NATURAL_32
			l_ql: NATURAL_32
			l_i: INTEGER_32
		do
			l_lo := (a_n).bit_shift_right (1)
			l_hi := a_n - l_lo
			if 19 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
				if l_hi >= 19 then
					l_qh := dcpi1_div_qr_inst.gmpn_dcpi1_div_qr_n (a_qp + l_lo, a_np + 2 * l_lo, a_dp + l_lo, l_hi, a_dinv, a_tp)
				else
					l_qh := sbpi1_div_qr_inst.gmpn_sbpi1_div_qr (a_qp + l_lo, a_np + 2 * l_lo, 2 * l_hi, a_dp + l_lo, l_hi, a_dinv.item.inv32)
				end
			else
				l_qh := sbpi1_div_qr_inst.gmpn_sbpi1_div_qr (a_qp + l_lo, a_np + 2 * l_lo, 2 * l_hi, a_dp + l_lo, l_hi, a_dinv.item.inv32)
			end
			mul_inst.gmpn_mul (a_tp, (a_qp + l_lo), l_hi, a_dp, l_lo).do_nothing
			l_cy := gmp_inst.gmpn_sub_n (a_np + l_lo, (a_np + l_lo), a_tp, a_n)
			if l_qh /= {NATURAL_32} 0 then
				l_cy := l_cy + (gmp_inst.gmpn_sub_n (a_np + a_n, (a_np + a_n), a_dp, l_lo))
			end
			from
			until
				l_cy = {NATURAL_32} 0
			loop
				l_qh := l_qh - (gmp_inst.gmpn_sub_1 (a_qp + l_lo, (a_qp + l_lo), l_hi, (1).to_natural_32))
				l_cy := l_cy - (gmp_inst.gmpn_add_n (a_np + l_lo, (a_np + l_lo), a_dp, a_n))
			end
			if 56 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
				if l_lo >= 56 then
					l_ql := gmpn_dcpi1_divappr_q_n (a_qp, a_np + l_hi, a_dp + l_hi, l_lo, a_dinv, a_tp)
				else
					l_ql := sbpi1_divappr_q_inst.gmpn_sbpi1_divappr_q (a_qp, a_np + l_hi, 2 * l_lo, a_dp + l_hi, l_lo, a_dinv.item.inv32)
				end
			else
				l_ql := sbpi1_divappr_q_inst.gmpn_sbpi1_divappr_q (a_qp, a_np + l_hi, 2 * l_lo, a_dp + l_hi, l_lo, a_dinv.item.inv32)
			end
			if (builtin_expect ((l_ql /= {NATURAL_32} 0).to_integer, 0)).to_boolean then
				l_i := (0).to_integer_32
				from
				until
					not (l_i < l_lo)
				loop
					a_qp[l_i] := {NATURAL_32} 4294967295
					l_i := l_i + 1
				end
			end
			Result := l_qh
		end

	gmpn_dcpi1_divappr_q (a_qp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_dinv: CE_POINTER [PD_GMP_PI1_T]): NATURAL_32
		local
			l_qp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_qn: INTEGER_32
			l_qh: NATURAL_32
			l_cy: NATURAL_32
			l_qsave: NATURAL_32
			l_tp: CE_POINTER [NATURAL_32]
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_q: NATURAL_32
			l_n2: NATURAL_32
			l_n1: NATURAL_32
			l_n0: NATURAL_32
			l_d1: NATURAL_32
			l_d0: NATURAL_32
			l_q0: NATURAL_32
			l_t1: NATURAL_32
			l_t0: NATURAL_32
			l_mask: NATURAL_32
			l_cy___0: NATURAL_32
			l_cy1: NATURAL_32
			l_q2p: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_qp.make
			create l_np.make
			create l_dp.make
			create l_tp.make
			create l_tmp_marker.make
			create l_q2p.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_qp.ce_gets (a_qp)
					l_np.ce_gets (a_np)
					l_dp.ce_gets (a_dp)
					l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
					l_qn := a_nn - a_dn
					l_qp.ce_gets (l_qp + l_qn)
					l_np.ce_gets (l_np + a_nn)
					l_dp.ce_gets (l_dp + a_dn)
					if not (l_qn >= a_dn) then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						l_qn := l_qn + 1
						from
						until
							js.loop_left
						loop
							js.reset
							l_qn := l_qn - a_dn
							if not (l_qn > a_dn) then
								js.break
							end
						end
						js.reset
						l_qp.ce_gets (l_qp - l_qn)
						l_np.ce_gets (l_np - l_qn)
						l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new ((a_dn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
						if l_qn /= 1 then
							l_pos := -1 + 8 -- skip if block
						end
				when 2 then -- if:
						l_qh := ((gmp_inst.gmpn_cmp (((l_np - a_dn) + 1), l_dp - a_dn, a_dn)) >= 0).to_integer.to_natural_32
						if l_qh.to_boolean then
							gmp_inst.gmpn_sub_n ((l_np - a_dn) + 1, ((l_np - a_dn) + 1), l_dp - a_dn, a_dn).do_nothing
						end
						l_n2 := l_np[0]
						l_n1 := l_np[-1]
						l_n0 := l_np[-2]
						l_d1 := l_dp[-1]
						l_d0 := l_dp[-2]
						if not ((builtin_expect ((l_n2 = l_d1).to_integer, 0)).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_n1 = l_d0 then
							l_q := {NATURAL_32} 4294967295
							l_cy := gmp_inst.gmpn_submul_1 (l_np - a_dn, l_dp - a_dn, a_dn, l_q)
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							asm306 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_q0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_q), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n2), a_dinv.address)
							asm307 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_q), create {CE_POINTER [NATURAL_32]}.make_shared ($l_q0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n2), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1))
							l_n1 := l_n1 - (l_d1 * l_q)
							l_n0 := l_n0
							asm308 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0))
							asm309 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_t0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_q))
							asm310 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t0))
							l_q := l_q + 1
							l_mask := (-(l_n1 >= l_q0).to_integer).to_natural_32
							l_q := l_q + l_mask
							asm311 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_mask), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0))
							if (builtin_expect ((l_n1 >= l_d1).to_integer, 0)).to_boolean then
								if l_n1 > l_d1 then
									l_q := l_q + 1
									asm312 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0))
								elseif l_n0 >= l_d0 then
									l_q := l_q + 1
									asm313 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0))
								end
							end
							js.break
						end
						js.reset
						if a_dn > 2 then
							l_cy___0 := gmp_inst.gmpn_submul_1 (l_np - a_dn, l_dp - a_dn, a_dn - 2, l_q)
							l_cy1 := (l_n0 < l_cy___0).to_integer.to_natural_32
							l_n0 := ((l_n0 - l_cy___0)).bit_and ({NATURAL_32} 4294967295)
							l_cy___0 := (l_n1 < l_cy1).to_integer.to_natural_32
							l_n1 := ((l_n1 - l_cy1)).bit_and ({NATURAL_32} 4294967295)
							l_np[-2] := l_n0
							if (builtin_expect ((l_cy___0 /= {NATURAL_32} 0).to_integer, 0)).to_boolean then
								l_n1 := l_n1 + (l_d1 + (gmp_inst.gmpn_add_n (l_np - a_dn, (l_np - a_dn), l_dp - a_dn, a_dn - 1)))
								l_qh := l_qh - (l_q = {NATURAL_32} 0).to_integer.to_natural_32
								l_q := ((l_q - {NATURAL_32} 1)).bit_and ({NATURAL_32} 4294967295)
							end
						else
							l_np[-2] := l_n0
						end
						l_np[-1] := l_n1
				when 6 then
						l_qp[0] := l_q
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						if l_qn = 2 then
							l_qh := gmp_inst.gmpn_divrem_2 (l_qp, 0, l_np - 2, (4).to_integer_32, l_dp - 2)
						elseif 19 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_qn >= 19 then
								l_qh := dcpi1_div_qr_inst.gmpn_dcpi1_div_qr_n (l_qp, l_np - l_qn, l_dp - l_qn, l_qn, a_dinv, l_tp)
							else
								l_qh := sbpi1_div_qr_inst.gmpn_sbpi1_div_qr (l_qp, l_np - l_qn, 2 * l_qn, l_dp - l_qn, l_qn, a_dinv.item.inv32)
							end
						else
							l_qh := sbpi1_div_qr_inst.gmpn_sbpi1_div_qr (l_qp, l_np - l_qn, 2 * l_qn, l_dp - l_qn, l_qn, a_dinv.item.inv32)
						end
						if l_qn /= a_dn then
							if l_qn > a_dn - l_qn then
								mul_inst.gmpn_mul (l_tp, l_qp, l_qn, l_dp - a_dn, a_dn - l_qn).do_nothing
							else
								mul_inst.gmpn_mul (l_tp, l_dp - a_dn, a_dn - l_qn, l_qp, l_qn).do_nothing
							end
							l_cy := gmp_inst.gmpn_sub_n (l_np - a_dn, (l_np - a_dn), l_tp, a_dn)
							if l_qh /= {NATURAL_32} 0 then
								l_cy := l_cy + (gmp_inst.gmpn_sub_n ((l_np - a_dn) + l_qn, ((l_np - a_dn) + l_qn), l_dp - a_dn, a_dn - l_qn))
							end
							from
							until
								l_cy = {NATURAL_32} 0
							loop
								l_qh := l_qh - (gmp_inst.gmpn_sub_1 (l_qp, l_qp, l_qn, (1).to_natural_32))
								l_cy := l_cy - (gmp_inst.gmpn_add_n (l_np - a_dn, (l_np - a_dn), l_dp - a_dn, a_dn))
							end
						end
				when 9 then -- if done
						l_qn := ((a_nn - a_dn) - l_qn) + 1
						from
						until
							not (l_qn > a_dn)
						loop
							l_qp.ce_gets (l_qp - a_dn)
							l_np.ce_gets (l_np - a_dn)
							dcpi1_div_qr_inst.gmpn_dcpi1_div_qr_n (l_qp, l_np - a_dn, l_dp - a_dn, a_dn, a_dinv, l_tp).do_nothing
							l_qn := l_qn - a_dn
						end
						l_qn := l_qn - 1
						l_qp.ce_gets (l_qp - l_qn)
						l_np.ce_gets (l_np - a_dn)
						l_qsave := l_qp[l_qn]
						gmpn_dcpi1_divappr_q_n (l_qp, l_np - a_dn, l_dp - a_dn, a_dn, a_dinv, l_tp).do_nothing
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (l_qp, (l_qp + 1), l_qn)
							js.break
						end
						js.reset
						l_qp[l_qn] := l_qsave
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_qp.ce_gets (l_qp - l_qn)
						l_np.ce_gets (l_np - l_qn)
						l_q2p.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new (((l_qn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
						if 56 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_qn >= 56 then
								l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new (((l_qn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
								l_qh := gmpn_dcpi1_divappr_q_n (l_q2p, (l_np - l_qn) - 2, l_dp - (l_qn + 1), l_qn + 1, a_dinv, l_tp)
							else
								l_qh := sbpi1_divappr_q_inst.gmpn_sbpi1_divappr_q (l_q2p, (l_np - l_qn) - 2, 2 * (l_qn + 1), l_dp - (l_qn + 1), l_qn + 1, a_dinv.item.inv32)
							end
						else
							l_qh := sbpi1_divappr_q_inst.gmpn_sbpi1_divappr_q (l_q2p, (l_np - l_qn) - 2, 2 * (l_qn + 1), l_dp - (l_qn + 1), l_qn + 1, a_dinv.item.inv32)
						end
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (l_qp, (l_q2p + 1), l_qn)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
				when 12 then -- if done
					from
					until
						js.loop_left
					loop
						js.reset
						if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
							tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
						end
						js.break
					end
					js.reset
					Result := l_qh
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
