class
	P_DIV

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_div (a_r: CE_POINTER [PD_MPF_STRUCT]; a_u: CE_POINTER [PD_MPF_STRUCT]; a_v: CE_POINTER [PD_MPF_STRUCT])
		local
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_new_vp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_rsize: INTEGER_32
			l_prospective_rsize: INTEGER_32
			l_tsize: INTEGER_32
			l_zeros: INTEGER_32
			l_sign_quotient: INTEGER_32
			l_prec: INTEGER_32
			l_high_zero: INTEGER_32
			l_chop: INTEGER_32
			l_rexp: INTEGER_32
			l_copy_u: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp: INTEGER_32
			l_tmp___3: CE_POINTER [ANY]
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_32]
			l_tmp___9: CE_POINTER [ANY]
			l_tmp___14: CE_POINTER [ANY]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_up.make
			create l_vp.make
			create l_rp.make
			create l_tp.make
			create l_new_vp.make
			create l_tmp_marker.make
			create l_tmp___3.make
			create l_dst.make
			create l_tmp___5.make
			create l_tmp___9.make
			create l_tmp___14.make

			l_usize := (a_u.item.mp_size).to_integer_32
			l_vsize := (a_v.item.mp_size).to_integer_32
			l_sign_quotient := (l_usize).bit_xor (l_vsize)
			if l_usize >= 0 then
				l_usize := l_usize
			else
				l_usize := -l_usize
			end
			if l_vsize >= 0 then
				l_vsize := l_vsize
			else
				l_vsize := -l_vsize
			end
			l_prec := (a_r.item.mp_prec).to_integer_32
			if l_vsize = 0 then
				errno_inst.gmp_divide_by_zero
			end
			if l_usize = 0 then
				a_r.item.mp_size := 0
				a_r.item.mp_exp := (0).to_integer_32
				js.return
			end
			if not js.return_called then
				l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
				l_rexp := ((a_u.item.mp_exp - a_v.item.mp_exp) + 1)
				l_rp.ce_gets (a_r.item.mp_d)
				l_up.ce_gets (a_u.item.mp_d)
				l_vp.ce_gets (a_v.item.mp_d)
				l_prospective_rsize := (l_usize - l_vsize) + 1
				l_rsize := l_prec + 1
				l_zeros := l_rsize - l_prospective_rsize
				if l_zeros > 0 then
					l_tmp := 1
				elseif (l_rp.c_pointer.to_integer_32).to_natural_32 = (l_up.c_pointer.to_integer_32).to_natural_32 then
					l_tmp := 1
				else
					l_tmp := 0
				end
				l_copy_u := l_tmp
				if -l_zeros > 0 then
					l_chop := -l_zeros
				else
					l_chop := (0).to_integer_32
				end
				l_up.ce_gets (l_up + l_chop)
				l_usize := l_usize - l_chop
				l_zeros := l_zeros + l_chop
				l_tsize := l_usize + l_zeros
				if l_copy_u.to_boolean then
					if (builtin_expect (((l_tsize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___3.ce_gets ((l_aaf.new (((l_tsize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___3.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_tsize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___3))
					from
					until
						js.loop_left
					loop
						js.reset
						if l_zeros /= 0 then
							l_dst.ce_gets (l_tp)
							l_n := l_zeros
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___5.ce_gets (l_dst)
								l_dst.ce_gets (l_dst + 1)
								l_tmp___5.item := (0).to_natural_32
								l_n := l_n - 1
								if not l_n.to_boolean then
									js.break
								end
							end
							js.reset
						end
						js.break
					end
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (l_tp + l_zeros, l_up, l_usize)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
					l_up.ce_gets (l_tp)
					l_usize := l_tsize
				else
					if (builtin_expect (((l_usize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___9.ce_gets ((l_aaf.new (((l_usize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___9.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_usize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___9))
				end
				if (l_rp.c_pointer.to_integer_32).to_natural_32 = (l_vp.c_pointer.to_integer_32).to_natural_32 then
					if (builtin_expect ((l_vsize.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___14.ce_gets ((l_aaf.new ((l_vsize.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___14.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_vsize.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_new_vp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___14))
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (l_new_vp, l_vp, l_vsize)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
					l_vp.ce_gets (l_new_vp)
				end
				div_q_inst.gmpn_div_q (l_rp, l_up, l_usize, l_vp, l_vsize, l_tp)
				l_high_zero := (l_rp[(l_rsize - 1)] = {NATURAL_32} 0).to_integer
				l_rsize := l_rsize - l_high_zero
				l_rexp := l_rexp - l_high_zero
				if l_sign_quotient >= 0 then
					a_r.item.mp_size := l_rsize.to_integer_32
				else
					a_r.item.mp_size := (-l_rsize).to_integer_32
				end
				a_r.item.mp_exp := l_rexp
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
					end
					js.break
				end
				js.reset
			end
		end

	gmpq_div (a_quot: CE_POINTER [PD_MPQ_STRUCT]; a_op1: CE_POINTER [PD_MPQ_STRUCT]; a_op2: CE_POINTER [PD_MPQ_STRUCT])
		local
			l_gcd1: CE_ARRAY [PD_MPZ_STRUCT]
			l_gcd2: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp1: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp2: CE_ARRAY [PD_MPZ_STRUCT]
			l_numtmp: CE_ARRAY [PD_MPZ_STRUCT]
			l_op1_num_size: INTEGER_32
			l_op1_den_size: INTEGER_32
			l_op2_num_size: INTEGER_32
			l_op2_den_size: INTEGER_32
			l_alloc: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___2: CE_POINTER [ANY]
			l_x___0: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___7: CE_POINTER [ANY]
			l_x___1: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___12: CE_POINTER [ANY]
			l_x___2: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___17: CE_POINTER [ANY]
			l_x___3: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___22: CE_POINTER [ANY]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_gcd1.make (<<1>>)
			create l_gcd2.make (<<1>>)
			create l_tmp1.make (<<1>>)
			create l_tmp2.make (<<1>>)
			create l_numtmp.make (<<1>>)
			create l_tmp_marker.make
			create l_x.make
			create l_tmp___2.make
			create l_x___0.make
			create l_tmp___7.make
			create l_x___1.make
			create l_tmp___12.make
			create l_x___2.make
			create l_tmp___17.make
			create l_x___3.make
			create l_tmp___22.make

			if a_op1.item.mp_num.mp_size >= 0 then
				l_op1_num_size := (a_op1.item.mp_num.mp_size).to_integer_32
			else
				l_op1_num_size := (-a_op1.item.mp_num.mp_size).to_integer_32
			end
			l_op1_den_size := (a_op1.item.mp_den.mp_size).to_integer_32
			if a_op2.item.mp_num.mp_size >= 0 then
				l_op2_num_size := (a_op2.item.mp_num.mp_size).to_integer_32
			else
				l_op2_num_size := (-a_op2.item.mp_num.mp_size).to_integer_32
			end
			l_op2_den_size := (a_op2.item.mp_den.mp_size).to_integer_32
			if l_op2_num_size = 0 then
				errno_inst.gmp_divide_by_zero
			end
			if l_op1_num_size = 0 then
				a_quot.item.mp_num.mp_size := 0
				a_quot.item.mp_den.mp_d[0] := (1).to_natural_32
				a_quot.item.mp_den.mp_size := 1
				js.return
			end
			if not js.return_called then
				l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
				if l_op1_num_size < l_op2_num_size then
					l_alloc := l_op1_num_size
				else
					l_alloc := l_op2_num_size
				end
				from
				until
					js.loop_left
				loop
					js.reset
					l_x.ce_gets (l_gcd1)
					l_x.item.mp_alloc := l_alloc.to_integer_32
					if (builtin_expect ((l_alloc.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___2.ce_gets ((l_aaf.new ((l_alloc.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___2.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_alloc.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_x.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2)
					js.break
				end
				js.reset
				if l_op1_den_size < l_op2_den_size then
					l_alloc := l_op1_den_size
				else
					l_alloc := l_op2_den_size
				end
				from
				until
					js.loop_left
				loop
					js.reset
					l_x___0.ce_gets (l_gcd2)
					l_x___0.item.mp_alloc := l_alloc.to_integer_32
					if (builtin_expect ((l_alloc.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___7.ce_gets ((l_aaf.new ((l_alloc.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___7.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_alloc.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_x___0.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___7)
					js.break
				end
				js.reset
				if l_op1_num_size > l_op2_num_size then
					l_alloc := l_op1_num_size
				else
					l_alloc := l_op2_num_size
				end
				from
				until
					js.loop_left
				loop
					js.reset
					l_x___1.ce_gets (l_tmp1)
					l_x___1.item.mp_alloc := l_alloc.to_integer_32
					if (builtin_expect ((l_alloc.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___12.ce_gets ((l_aaf.new ((l_alloc.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___12.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_alloc.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_x___1.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___12)
					js.break
				end
				js.reset
				if l_op1_den_size > l_op2_den_size then
					l_alloc := l_op1_den_size
				else
					l_alloc := l_op2_den_size
				end
				from
				until
					js.loop_left
				loop
					js.reset
					l_x___2.ce_gets (l_tmp2)
					l_x___2.item.mp_alloc := l_alloc.to_integer_32
					if (builtin_expect ((l_alloc.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___17.ce_gets ((l_aaf.new ((l_alloc.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___17.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_alloc.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_x___2.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___17)
					js.break
				end
				js.reset
				l_alloc := l_op1_num_size + l_op2_den_size
				from
				until
					js.loop_left
				loop
					js.reset
					l_x___3.ce_gets (l_numtmp)
					l_x___3.item.mp_alloc := l_alloc.to_integer_32
					if (builtin_expect ((l_alloc.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___22.ce_gets ((l_aaf.new ((l_alloc.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___22.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_alloc.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_x___3.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___22)
					js.break
				end
				js.reset
				gcd_inst.gmpz_gcd (l_gcd1, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + {PD_MPQ_STRUCT}.mp_num_offset), create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + {PD_MPQ_STRUCT}.mp_num_offset))
				gcd_inst.gmpz_gcd (l_gcd2, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + {PD_MPQ_STRUCT}.mp_den_offset), create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + {PD_MPQ_STRUCT}.mp_den_offset))
				divegcd_inst.gmpz_divexact_gcd (l_tmp1, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + {PD_MPQ_STRUCT}.mp_num_offset), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd1))
				divegcd_inst.gmpz_divexact_gcd (l_tmp2, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + {PD_MPQ_STRUCT}.mp_den_offset), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd2))
				mul_inst.gmpz_mul (l_numtmp, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp1), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp2))
				divegcd_inst.gmpz_divexact_gcd (l_tmp1, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + {PD_MPQ_STRUCT}.mp_num_offset), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd1))
				divegcd_inst.gmpz_divexact_gcd (l_tmp2, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + {PD_MPQ_STRUCT}.mp_den_offset), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd2))
				mul_inst.gmpz_mul (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_quot.c_pointer + {PD_MPQ_STRUCT}.mp_den_offset), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp1), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp2))
				set_inst.gmpz_set (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_quot.c_pointer + {PD_MPQ_STRUCT}.mp_num_offset), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_numtmp))
				if a_quot.item.mp_den.mp_size < 0 then
					a_quot.item.mp_den.mp_size := -a_quot.item.mp_den.mp_size
					a_quot.item.mp_num.mp_size := -a_quot.item.mp_num.mp_size
				end
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
					end
					js.break
				end
				js.reset
			end
		end

end
