class
	P_DIV_2EXP

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_div_2exp (a_r: CE_POINTER [PD_MPF_STRUCT]; a_u: CE_POINTER [PD_MPF_STRUCT]; a_exp: NATURAL_32)
		local
			l_up: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_abs_usize: INTEGER_32
			l_prec: INTEGER_32
			l_uexp: INTEGER_32
			l_cy_limb: NATURAL_32
			l_adj: INTEGER_32
			js: JUMP_STATE
		do
			create l_up.make
			create l_rp.make

			l_rp.ce_gets (a_r.item.mp_d)
			l_prec := (a_r.item.mp_prec).to_integer_32
			l_uexp := a_u.item.mp_exp
			l_usize := (a_u.item.mp_size).to_integer_32
			if (builtin_expect ((l_usize = 0).to_integer, 0)).to_boolean then
				a_r.item.mp_size := 0
				a_r.item.mp_exp := (0).to_integer_32
				js.return
			end
			if not js.return_called then
				if l_usize >= 0 then
					l_abs_usize := l_usize
				else
					l_abs_usize := -l_usize
				end
				l_up.ce_gets (a_u.item.mp_d)
				if a_exp \\ {NATURAL_32} 32 = {NATURAL_32} 0 then
					l_prec := l_prec + 1
					if l_abs_usize > l_prec then
						l_up.ce_gets (l_up + (l_abs_usize - l_prec))
						l_abs_usize := l_prec
					end
					if (l_rp.c_pointer.to_integer_32).to_natural_32 /= (l_up.c_pointer.to_integer_32).to_natural_32 then
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (l_rp, l_up, l_abs_usize)
							js.break
						end
						js.reset
					end
					a_r.item.mp_exp := (l_uexp.to_natural_32 - a_exp // {NATURAL_32} 32).to_integer_32
				else
					if l_abs_usize > l_prec then
						l_up.ce_gets (l_up + (l_abs_usize - l_prec))
						l_abs_usize := l_prec
						l_cy_limb := gmp_inst.gmpn_rshift (l_rp + 1, l_up, l_abs_usize, (a_exp \\ {NATURAL_32} 32).to_natural_32)
						l_rp[0] := l_cy_limb
						l_adj := (l_rp[l_abs_usize] /= {NATURAL_32} 0).to_integer
					else
						l_cy_limb := gmp_inst.gmpn_lshift (l_rp, l_up, l_abs_usize, ({NATURAL_32} 32 - a_exp \\ {NATURAL_32} 32).to_natural_32)
						l_rp[l_abs_usize] := l_cy_limb
						l_adj := (l_cy_limb /= {NATURAL_32} 0).to_integer
					end
					l_abs_usize := l_abs_usize + l_adj
					a_r.item.mp_exp := (((l_uexp.to_natural_32 - a_exp // {NATURAL_32} 32) - {NATURAL_32} 1) + l_adj.to_natural_32).to_integer_32
				end
				if l_usize >= 0 then
					a_r.item.mp_size := l_abs_usize.to_integer_32
				else
					a_r.item.mp_size := (-l_abs_usize).to_integer_32
				end
			end
		end

end
