class
	P_DIVEXACT

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_divexact (a_quot: CE_POINTER [PD_MPZ_STRUCT]; a_num: CE_POINTER [PD_MPZ_STRUCT]; a_den: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_qp: CE_POINTER [NATURAL_32]
			l_qn: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_nn: INTEGER_32
			l_dn: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___3: CE_POINTER [ANY]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_qp.make
			create l_np.make
			create l_dp.make
			create l_tmp_marker.make
			create l_tmp___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_num.item.mp_size >= 0 then
						l_nn := (a_num.item.mp_size).to_integer_32
					else
						l_nn := (-a_num.item.mp_size).to_integer_32
					end
					if a_den.item.mp_size >= 0 then
						l_dn := (a_den.item.mp_size).to_integer_32
					else
						l_dn := (-a_den.item.mp_size).to_integer_32
					end
					l_qn := (l_nn - l_dn) + 1
					if (builtin_expect ((l_qn > (a_quot.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
						realloc_inst.gmpz_realloc (a_quot, l_qn).do_nothing
					end
					if l_nn < l_dn then
						a_quot.item.mp_size := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
						l_qp.ce_gets (a_quot.item.mp_d)
						if (a_quot.c_pointer.to_integer_32).to_natural_32 /= (a_num.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (a_quot.c_pointer.to_integer_32).to_natural_32 /= (a_den.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if (builtin_expect ((l_qn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___3.ce_gets ((l_aaf.new ((l_qn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___3.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_qn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_qp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___3))
				when 6 then -- if done
						l_np.ce_gets (a_num.item.mp_d)
						l_dp.ce_gets (a_den.item.mp_d)
						gmpn_divexact (l_qp, l_np, l_nn, l_dp, l_dn)
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								not (not js.loop_left and then (l_qn > 0))
							loop
								js.reset
								if l_qp[(l_qn - 1)] /= {NATURAL_32} 0 then
									js.break
								end
								if not js.loop_jumped then
									l_qn := l_qn - 1
								end
							end
							js.reset
							js.break
						end
						js.reset
						if ((a_num.item.mp_size).bit_xor (a_den.item.mp_size)) >= 0 then
							a_quot.item.mp_size := l_qn.to_integer_32
						else
							a_quot.item.mp_size := (-l_qn).to_integer_32
						end
						if (l_qp.c_pointer.to_integer_32).to_natural_32 /= ((a_quot.item.mp_d).c_pointer.to_integer_32).to_natural_32 then
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (a_quot.item.mp_d, l_qp, l_qn)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
							end
							js.break
						end
						js.reset
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_divexact (a_qp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32)
		local
			l_np: CE_POINTER [NATURAL_32]
			l_nn: INTEGER_32
			l_dp: CE_POINTER [NATURAL_32]
			l_dn: INTEGER_32
			l_shift: NATURAL_32
			l_qn: INTEGER_32
			l_tp: CE_POINTER [NATURAL_32]
			l_wp: CE_POINTER [NATURAL_32]
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_ss: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___4: CE_POINTER [ANY]
			l_tmp___9: CE_POINTER [ANY]
			l_tmp___14: CE_POINTER [ANY]
			l_tmp___22: CE_POINTER [ANY]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_np.make
			create l_dp.make
			create l_tp.make
			create l_wp.make
			create l_tmp_marker.make
			create l_tmp___4.make
			create l_tmp___9.make
			create l_tmp___14.make
			create l_tmp___22.make

			l_np.ce_gets (a_np)
			l_nn := a_nn
			l_dp.ce_gets (a_dp)
			l_dn := a_dn
			from
			until
				not (not js.loop_left and then (l_dp[0] = {NATURAL_32} 0))
			loop
				l_dp.ce_gets (l_dp + 1)
				l_np.ce_gets (l_np + 1)
				l_dn := l_dn - 1
				l_nn := l_nn - 1
			end
			if l_dn = 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					gmp_impl_inst.gmpn_divexact_1 (a_qp, l_np, l_nn, l_dp[0])
					js.break
				end
				js.reset
				js.return
			end
			if not js.return_called then
				l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
				l_qn := (l_nn + 1) - l_dn
				from
				until
					js.loop_left
				loop
					js.reset
					l_shift := (builtin_ctzl (l_dp[0])).to_natural_32
					js.break
				end
				js.reset
				if l_shift > {NATURAL_32} 0 then
					if l_dn > l_qn then
						l_tmp___0 := l_qn + 1
					else
						l_tmp___0 := l_dn
					end
					l_ss := l_tmp___0
					if (builtin_expect ((l_ss.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___4.ce_gets ((l_aaf.new ((l_ss.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___4.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_ss.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___4))
					gmp_inst.gmpn_rshift (l_tp, l_dp, l_ss, l_shift).do_nothing
					l_dp.ce_gets (l_tp)
					if (builtin_expect (((l_qn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___9.ce_gets ((l_aaf.new (((l_qn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___9.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_qn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_wp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___9))
					gmp_inst.gmpn_rshift (l_wp, l_np, l_qn + 1, l_shift).do_nothing
				else
					if (builtin_expect ((l_qn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___14.ce_gets ((l_aaf.new ((l_qn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___14.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_qn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_wp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___14))
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (l_wp, l_np, l_qn)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
				end
				if l_dn > l_qn then
					l_dn := l_qn
				end
				if (builtin_expect (((bdiv_q_inst.gmpn_bdiv_q_itch (l_qn, l_dn)).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
					l_tmp___22.ce_gets ((l_aaf.new (((bdiv_q_inst.gmpn_bdiv_q_itch (l_qn, l_dn)).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				else
					l_tmp___22.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((bdiv_q_inst.gmpn_bdiv_q_itch (l_qn, l_dn)).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				end
				l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___22))
				bdiv_q_inst.gmpn_bdiv_q (a_qp, l_wp, l_qn, l_dp, l_dn, l_tp)
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
					end
					js.break
				end
				js.reset
			end
		end

end
