class
	P_DIVIS_2EXP

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_divisible_2exp_p (a_a: CE_POINTER [PD_MPZ_STRUCT]; a_d: NATURAL_32): INTEGER_32
		local
			l_i: INTEGER_32
			l_dlimbs: INTEGER_32
			l_dbits: NATURAL_32
			l_ap: CE_POINTER [NATURAL_32]
			l_dmask: NATURAL_32
			l_asize: INTEGER_32
			js: JUMP_STATE
		do
			create l_ap.make

			if a_a.item.mp_size >= 0 then
				l_asize := (a_a.item.mp_size).to_integer_32
			else
				l_asize := (-a_a.item.mp_size).to_integer_32
			end
			l_dlimbs := (a_d // {NATURAL_32} 32).to_integer_32
			if l_asize <= l_dlimbs then
				Result := (l_asize = 0).to_integer
				js.return
			end
			if not js.return_called then
				l_ap.ce_gets (a_a.item.mp_d)
				l_i := (0).to_integer_32
				from
				until
					not (not js.loop_left and then (l_i < l_dlimbs))
				loop
					if l_ap[l_i] /= {NATURAL_32} 0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				l_dbits := (a_d \\ {NATURAL_32} 32).to_natural_32
				l_dmask := (({NATURAL_32} 1).bit_shift_left (l_dbits.to_integer_32)) - {NATURAL_32} 1
				Result := (((l_ap[l_dlimbs]).bit_and (l_dmask)) = {NATURAL_32} 0).to_integer
			end
		end

end
