class
	P_DUMP

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_dump (a_u: CE_POINTER [PD_MPF_STRUCT])
		local
			l_exp: INTEGER_32
			l_str: CE_POINTER [INTEGER_8]
		do
			create l_str.make

			l_str.ce_gets (get_str_inst.gmpf_get_str (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_exp), 10, (0).to_natural_32, a_u))
			if (l_str[0]).to_integer_32 = 45 then
				printf ([ce_string ("-0.%%se%%ld%N"), l_str + 1, l_exp]).do_nothing
			else
				printf ([ce_string ("0.%%se%%ld%N"), l_str, l_exp]).do_nothing
			end
			memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (l_str), (strlen (l_str)) + {NATURAL_32} 1])
		end

	gmpz_dump (a_u: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_str: CE_POINTER [INTEGER_8]
		do
			create l_str.make

			l_str.ce_gets (get_str_inst.gmpz_get_str (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), 10, a_u))
			Io.put_string (eif_string (l_str) + "%N")
			memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (l_str), (strlen (l_str)) + {NATURAL_32} 1])
		end

	gmpn_dump (a_ptr: CE_POINTER [NATURAL_32]; a_n: INTEGER_32)
		local
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			l_n := a_n
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					not (not js.loop_left and then (l_n > 0))
				loop
					js.reset
					if a_ptr[(l_n - 1)] /= {NATURAL_32} 0 then
						js.break
					end
					if not js.loop_jumped then
						l_n := l_n - 1
					end
				end
				js.reset
				js.break
			end
			js.reset
			if l_n = 0 then
				Io.put_string ("0%N")
			else
				l_n := l_n - 1
				printf ([ce_string ("%%lX"), a_ptr[l_n]]).do_nothing
				from
				until
					not (l_n.to_boolean)
				loop
					l_n := l_n - 1
					printf ([ce_string ("%%0*lX"), 8, a_ptr[l_n]]).do_nothing
				end
				Io.put_string ("%N")
			end
		end

end
