class
	P_FIB2_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_fib2_ui (a_fn: CE_POINTER [PD_MPZ_STRUCT]; a_fnsub1: CE_POINTER [PD_MPZ_STRUCT]; a_n: NATURAL_32)
		local
			l_fp: CE_POINTER [NATURAL_32]
			l_f1p: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
		do
			create l_fp.make
			create l_f1p.make

			l_size := (((a_n // {NATURAL_32} 32) * {NATURAL_32} 23) // {NATURAL_32} 32).to_integer_32 + 4
			if (builtin_expect ((l_size > (a_fn.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
				realloc_inst.gmpz_realloc (a_fn, l_size).do_nothing
			end
			if (builtin_expect ((l_size > (a_fnsub1.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
				realloc_inst.gmpz_realloc (a_fnsub1, l_size).do_nothing
			end
			l_fp.ce_gets (a_fn.item.mp_d)
			l_f1p.ce_gets (a_fnsub1.item.mp_d)
			l_size := gmpn_fib2_ui (l_fp, l_f1p, a_n)
			a_fn.item.mp_size := (l_size - (a_n = {NATURAL_32} 0).to_integer).to_integer_32
			a_fnsub1.item.mp_size := (l_size - (l_f1p[(l_size - 1)] = {NATURAL_32} 0).to_integer).to_integer_32
		end

	gmpn_fib2_ui (a_fp: CE_POINTER [NATURAL_32]; a_f1p: CE_POINTER [NATURAL_32]; a_n: NATURAL_32): INTEGER_32
		local
			l_size: INTEGER_32
			l_nfirst: NATURAL_32
			l_mask: NATURAL_32
			l_alloc: INTEGER_32
			l_xp: CE_POINTER [NATURAL_32]
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___2: CE_POINTER [ANY]
			l_c: NATURAL_32
			l_tmp___4: INTEGER_32
			l_tmp___6: INTEGER_32
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_xp.make
			create l_tmp_marker.make
			create l_tmp___2.make

			l_mask := {NATURAL_32} 1
			l_nfirst := a_n
			from
			until
				not (l_nfirst > {NATURAL_32} 47)
			loop
				l_mask := (l_mask).bit_shift_left ((1))
				l_nfirst := l_nfirst // ({NATURAL_32} 2)
			end
			a_f1p[0] := fib_table_inst.gmp_fib_table[(l_nfirst.to_integer_32 - 1) + 1]
			a_fp[0] := fib_table_inst.gmp_fib_table[(l_nfirst + {NATURAL_32} 1).to_integer_32]
			l_size := (1).to_integer_32
			if l_mask /= {NATURAL_32} 1 then
				l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
				l_alloc := (((a_n // {NATURAL_32} 32) * {NATURAL_32} 23) // {NATURAL_32} 32).to_integer_32 + 4
				if (builtin_expect ((l_alloc.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
					l_tmp___2.ce_gets ((l_aaf.new ((l_alloc.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				else
					l_tmp___2.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_alloc.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				end
				l_xp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2))
				from
				until
					js.loop_left
				loop
					js.reset
					sqr_inst.gmpn_sqr (l_xp, a_fp, l_size)
					sqr_inst.gmpn_sqr (a_fp, a_f1p, l_size)
					l_size := l_size * (2)
					l_size := l_size - (l_xp[(l_size - 1)] = {NATURAL_32} 0).to_integer
					a_f1p[l_size] := gmp_inst.gmpn_add_n (a_f1p, l_xp, a_fp, l_size)
					l_c := gmp_inst.gmpn_lshift (l_xp, l_xp, l_size, {NATURAL_32} 2)
					if ((a_n).bit_and (l_mask)).to_boolean then
						l_tmp___4 := 0
					else
						l_tmp___4 := 2
					end
					l_xp[0] := (l_xp[0]).bit_or (l_tmp___4.to_natural_32)
					l_c := l_c - (gmp_inst.gmpn_sub_n (a_fp, l_xp, a_fp, l_size))
					if ((a_n).bit_and (l_mask)).to_boolean then
						l_tmp___6 := 2
					else
						l_tmp___6 := 0
					end
					a_fp[0] := a_fp[0] - l_tmp___6.to_natural_32
					a_fp[l_size] := l_c
					l_size := l_size + (a_fp[l_size] /= {NATURAL_32} 0).to_integer
					l_mask := (l_mask).bit_shift_right ((1))
					if ((a_n).bit_and (l_mask)).to_boolean then
						gmp_inst.gmpn_sub_n (a_f1p, a_fp, a_f1p, l_size).do_nothing
					else
						gmp_inst.gmpn_sub_n (a_fp, a_fp, a_f1p, l_size).do_nothing
						l_size := l_size - (a_fp[(l_size - 1)] = {NATURAL_32} 0).to_integer
					end
					if l_mask = {NATURAL_32} 1 then
						js.break
					end
				end
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
					end
					js.break
				end
				js.reset
			end
			Result := l_size
		end

end
