class
	P_GCDEXT

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_gcdext (a_g: CE_POINTER [PD_MPZ_STRUCT]; a_s: CE_POINTER [PD_MPZ_STRUCT]; a_t: CE_POINTER [PD_MPZ_STRUCT]; a_a: CE_POINTER [PD_MPZ_STRUCT]; a_b: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_asize: INTEGER_32
			l_bsize: INTEGER_32
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_ap: CE_POINTER [NATURAL_32]
			l_bp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_gsize: INTEGER_32
			l_ssize: INTEGER_32
			l_tmp_ssize: INTEGER_32
			l_gp: CE_POINTER [NATURAL_32]
			l_sp: CE_POINTER [NATURAL_32]
			l_tmp_gp: CE_POINTER [NATURAL_32]
			l_tmp_sp: CE_POINTER [NATURAL_32]
			l_u: CE_POINTER [PD_MPZ_STRUCT]
			l_v: CE_POINTER [PD_MPZ_STRUCT]
			l_ss: CE_POINTER [PD_MPZ_STRUCT]
			l_tt: CE_POINTER [PD_MPZ_STRUCT]
			l_stmp: PD_MPZ_STRUCT
			l_gtmp: PD_MPZ_STRUCT
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___7: CE_POINTER [ANY]
			l_tmp___12: CE_POINTER [ANY]
			l_tmp___17: CE_POINTER [ANY]
			l_tmp___23: CE_POINTER [ANY]
			l_tmp___28: CE_POINTER [ANY]
			l_x___2: CE_ARRAY [PD_MPZ_STRUCT]
			l_x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___33: CE_POINTER [ANY]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_ap.make
			create l_bp.make
			create l_up.make
			create l_vp.make
			create l_gp.make
			create l_sp.make
			create l_tmp_gp.make
			create l_tmp_sp.make
			create l_u.make
			create l_v.make
			create l_ss.make
			create l_tt.make
			create l_stmp.make
			create l_gtmp.make
			create l_tmp_marker.make
			create l_tmp___2.make
			create l_tmp___7.make
			create l_tmp___12.make
			create l_tmp___17.make
			create l_tmp___23.make
			create l_tmp___28.make
			create l_x___2.make (<<1>>)
			create l_x.make
			create l_tmp___33.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
					if a_a.item.mp_size >= 0 then
						l_asize := (a_a.item.mp_size).to_integer_32
					else
						l_asize := (-a_a.item.mp_size).to_integer_32
					end
					if a_b.item.mp_size >= 0 then
						l_bsize := (a_b.item.mp_size).to_integer_32
					else
						l_bsize := (-a_b.item.mp_size).to_integer_32
					end
					l_ap.ce_gets (a_a.item.mp_d)
					l_bp.ce_gets (a_b.item.mp_d)
					if not (l_asize > l_bsize) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if l_asize /= l_bsize then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if not ((gmp_inst.gmpn_cmp (l_ap, l_bp, l_asize)) > 0) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						l_usize := l_asize
						l_vsize := l_bsize
						if (builtin_expect (((l_usize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___2.ce_gets ((l_aaf.new (((l_usize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___2.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_usize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_up.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2))
						if (builtin_expect (((l_vsize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___7.ce_gets ((l_aaf.new (((l_vsize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___7.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_vsize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_vp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___7))
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (l_up, l_ap, l_usize)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (l_vp, l_bp, l_vsize)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						l_u.ce_gets (a_a)
						l_v.ce_gets (a_b)
						l_ss.ce_gets (a_s)
						l_tt.ce_gets (a_t)
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_pos := -1 + 9 -- goto _L___0
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L___0:
						l_usize := l_bsize
						l_vsize := l_asize
						if (builtin_expect (((l_usize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___12.ce_gets ((l_aaf.new (((l_usize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___12.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_usize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_up.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___12))
						if (builtin_expect (((l_vsize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___17.ce_gets ((l_aaf.new (((l_vsize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___17.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_vsize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_vp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___17))
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (l_up, l_bp, l_usize)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (l_vp, l_ap, l_vsize)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						l_u.ce_gets (a_b)
						l_v.ce_gets (a_a)
						l_ss.ce_gets (a_t)
						l_tt.ce_gets (a_s)
				when 10 then -- if done
						if (builtin_expect (((l_usize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___23.ce_gets ((l_aaf.new (((l_usize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___23.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_usize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_tmp_gp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___23))
						if (builtin_expect (((l_usize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___28.ce_gets ((l_aaf.new (((l_usize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___28.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_usize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_tmp_sp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___28))
						if l_vsize = 0 then
							l_tmp_sp[0] := (1).to_natural_32
							l_tmp_ssize := (1).to_integer_32
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_tmp_gp, l_up, l_usize)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
							l_gsize := l_usize
						else
							l_gsize := gmpn_gcdext (l_tmp_gp, l_tmp_sp, create {CE_POINTER [INTEGER_32]}.make_shared ($l_tmp_ssize), l_up, l_usize, l_vp, l_vsize)
						end
						if l_tmp_ssize >= 0 then
							l_ssize := l_tmp_ssize
						else
							l_ssize := -l_tmp_ssize
						end
						l_gtmp.mp_d := l_tmp_gp
						l_gtmp.mp_size := l_gsize.to_integer_32
						l_stmp.mp_d := l_tmp_sp
						if ((l_tmp_ssize).bit_xor ((l_u.item.mp_size).to_integer_32)) >= 0 then
							l_stmp.mp_size := l_ssize.to_integer_32
						else
							l_stmp.mp_size := (-l_ssize).to_integer_32
						end
						if (l_tt.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if l_v.item.mp_size = 0 then
								l_tt.item.mp_size := 0
							else
								from
								until
									js.loop_left
								loop
									js.reset
									l_x.ce_gets (l_x___2)
									l_x.item.mp_alloc := ((l_ssize + l_usize) + 1).to_integer_32
									if (builtin_expect ((((l_ssize + l_usize) + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
										l_tmp___33.ce_gets ((l_aaf.new ((((l_ssize + l_usize) + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
									else
										l_tmp___33.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (((l_ssize + l_usize) + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
									end
									l_x.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___33)
									js.break
								end
								js.reset
								mul_inst.gmpz_mul (l_x___2, (l_stmp.address), l_u)
								aors_inst.gmpz_sub (l_x___2, (l_gtmp.address), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_x___2))
								tdiv_q_inst.gmpz_tdiv_q (l_tt, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_x___2), l_v)
							end
						end
						if (l_ss.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (l_ss.item.mp_alloc).to_integer_32 < l_ssize then
								realloc_inst.gmpz_realloc (l_ss, l_ssize).do_nothing
							end
							l_sp.ce_gets (l_ss.item.mp_d)
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_sp, l_tmp_sp, l_ssize)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
							l_ss.item.mp_size := l_stmp.mp_size
						end
						if (a_g.item.mp_alloc).to_integer_32 < l_gsize then
							realloc_inst.gmpz_realloc (a_g, l_gsize).do_nothing
						end
						l_gp.ce_gets (a_g.item.mp_d)
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (l_gp, l_tmp_gp, l_gsize)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						a_g.item.mp_size := l_gsize.to_integer_32
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
							end
							js.break
						end
						js.reset
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	hgcd_mul_matrix_vector (a_M: CE_POINTER [PD_HGCD_MATRIX]; a_rp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_n: INTEGER_32
			l_ah: NATURAL_32
			l_bh: NATURAL_32
		do
			l_n := a_n
			if a_M.item.n >= l_n then
				mul_inst.gmpn_mul (a_tp, (a_M.item.p[0])[0], a_M.item.n, a_ap, l_n).do_nothing
				mul_inst.gmpn_mul (a_rp, (a_M.item.p[1])[0], a_M.item.n, a_bp, l_n).do_nothing
			else
				mul_inst.gmpn_mul (a_tp, a_ap, l_n, (a_M.item.p[0])[0], a_M.item.n).do_nothing
				mul_inst.gmpn_mul (a_rp, a_bp, l_n, (a_M.item.p[1])[0], a_M.item.n).do_nothing
			end
			l_ah := gmp_inst.gmpn_add_n (a_rp, a_rp, a_tp, l_n + a_M.item.n)
			if a_M.item.n >= l_n then
				mul_inst.gmpn_mul (a_tp, (a_M.item.p[1])[1], a_M.item.n, a_bp, l_n).do_nothing
				mul_inst.gmpn_mul (a_bp, (a_M.item.p[0])[1], a_M.item.n, a_ap, l_n).do_nothing
			else
				mul_inst.gmpn_mul (a_tp, a_bp, l_n, (a_M.item.p[1])[1], a_M.item.n).do_nothing
				mul_inst.gmpn_mul (a_bp, a_ap, l_n, (a_M.item.p[0])[1], a_M.item.n).do_nothing
			end
			l_bh := gmp_inst.gmpn_add_n (a_bp, a_bp, a_tp, l_n + a_M.item.n)
			l_n := l_n + (a_M.item.n)
			if ((l_ah).bit_or (l_bh)) > {NATURAL_32} 0 then
				a_rp[l_n] := l_ah
				a_bp[l_n] := l_bh
				l_n := l_n + 1
			else
				from
				until
					((a_rp[(l_n - 1)]).bit_or (a_bp[(l_n - 1)])) /= {NATURAL_32} 0
				loop
					l_n := l_n - 1
				end
			end
			Result := l_n.to_natural_32
		end

	compute_v (a_vp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_gp: CE_POINTER [NATURAL_32]; a_gn: INTEGER_32; a_up: CE_POINTER [NATURAL_32]; a_usize: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_size: INTEGER_32
			l_an: INTEGER_32
			l_bn: INTEGER_32
			l_vn: INTEGER_32
			l_cy: NATURAL_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			if a_usize >= 0 then
				l_size := a_usize
			else
				l_size := -a_usize
			end
			l_an := a_n
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					not (not js.loop_left and then (l_an > 0))
				loop
					js.reset
					if a_ap[(l_an - 1)] /= {NATURAL_32} 0 then
						js.break
					end
					if not js.loop_jumped then
						l_an := l_an - 1
					end
				end
				js.reset
				js.break
			end
			js.reset
			if l_an >= l_size then
				mul_inst.gmpn_mul (a_tp, a_ap, l_an, a_up, l_size).do_nothing
			else
				mul_inst.gmpn_mul (a_tp, a_up, l_size, a_ap, l_an).do_nothing
			end
			l_size := l_size + l_an
			l_size := l_size - (a_tp[(l_size - 1)] = {NATURAL_32} 0).to_integer
			if a_usize > 0 then
				gmp_inst.gmpn_sub (a_tp, a_tp, l_size, a_gp, a_gn).do_nothing
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						not (not js.loop_left and then (l_size > 0))
					loop
						js.reset
						if a_tp[(l_size - 1)] /= {NATURAL_32} 0 then
							js.break
						end
						if not js.loop_jumped then
							l_size := l_size - 1
						end
					end
					js.reset
					js.break
				end
				js.reset
				if l_size = 0 then
					Result := (0).to_integer_32
					js.return
				end
			else
				l_cy := (gmp_inst.gmpn_add (a_tp, a_tp, l_size, a_gp, a_gn))
				if l_cy.to_boolean then
					l_tmp___0 := l_size
					l_size := l_size + 1
					a_tp[l_tmp___0] := l_cy
				end
			end
			if not js.return_called then
				l_bn := a_n
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						not (not js.loop_left and then (l_bn > 0))
					loop
						js.reset
						if a_bp[(l_bn - 1)] /= {NATURAL_32} 0 then
							js.break
						end
						if not js.loop_jumped then
							l_bn := l_bn - 1
						end
					end
					js.reset
					js.break
				end
				js.reset
				l_vn := (l_size + 1) - l_bn
				divexact_inst.gmpn_divexact (a_vp, a_tp, l_size, a_bp, l_bn)
				l_vn := l_vn - (a_vp[(l_vn - 1)] = {NATURAL_32} 0).to_integer
				Result := l_vn
			end
		end

	gmpn_gcdext (a_gp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_usizep: CE_POINTER [INTEGER_32]; a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32): INTEGER_32
		local
			l_n: INTEGER_32
			l_talloc: INTEGER_32
			l_scratch: INTEGER_32
			l_matrix_scratch: INTEGER_32
			l_ualloc: INTEGER_32
			l_un: INTEGER_32
			l_u0: CE_POINTER [NATURAL_32]
			l_u1: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_hgcd_scratch: INTEGER_32
			l_update_scratch: INTEGER_32
			l_p1: INTEGER_32
			l_p2: INTEGER_32
			l_min_p: INTEGER_32
			l_tmp: INTEGER_32
			l_max_p: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___5: CE_POINTER [ANY]
			l_gn: INTEGER_32
			l_dst: CE_POINTER [NATURAL_32]
			l_n2: INTEGER_32
			l_tmp___11: CE_POINTER [NATURAL_32]
			l_M: PD_HGCD_MATRIX
			l_p: INTEGER_32
			l_nn: INTEGER_32
			l_gn___0: INTEGER_32
			l_updated_un: INTEGER_32
			l_M___0: PD_HGCD_MATRIX
			l_p___0: INTEGER_32
			l_nn___0: INTEGER_32
			l_t0: CE_POINTER [NATURAL_32]
			l_gn___1: INTEGER_32
			l_updated_un___0: INTEGER_32
			l_c: INTEGER_32
			l_gmp_i: INTEGER_32
			l_gmp_x: NATURAL_32
			l_gmp_y: NATURAL_32
			l_gn___2: INTEGER_32
			l_u0n: INTEGER_32
			l_u1n: INTEGER_32
			l_lehmer_un: INTEGER_32
			l_lehmer_vn: INTEGER_32
			l_gn___3: INTEGER_32
			l_lehmer_up: CE_POINTER [NATURAL_32]
			l_lehmer_vp: CE_POINTER [NATURAL_32]
			l_negate: INTEGER_32
			l_cy: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_u0.make
			create l_u1.make
			create l_tp.make
			create l_tmp_marker.make
			create l_tmp___5.make
			create l_dst.make
			create l_tmp___11.make
			create l_M.make
			create l_M___0.make
			create l_t0.make
			create l_lehmer_up.make
			create l_lehmer_vp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_n := a_n
					l_ualloc := l_n + 1
					l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
					l_talloc := 4 * l_n + 3
					l_scratch := (a_an - l_n) + 1
					if l_scratch > l_talloc then
						l_talloc := l_scratch
					end
					if 303 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
						if l_n >= 303 then
							l_p1 := l_n // 2
							l_p2 := l_n // 3
							if l_p1 < l_p2 then
								l_tmp := l_p1
							else
								l_tmp := l_p2
							end
							l_min_p := l_tmp
							if l_p1 > l_p2 then
								l_tmp___0 := l_p1
							else
								l_tmp___0 := l_p2
							end
							l_max_p := l_tmp___0
							l_matrix_scratch := 4 * (((l_n - l_min_p) + 1) // 2 + 1)
							l_hgcd_scratch := hgcd_inst.gmpn_hgcd_itch (l_n - l_min_p)
							l_update_scratch := (l_max_p + l_n) - 1
							if l_hgcd_scratch > l_update_scratch then
								l_tmp___1 := l_hgcd_scratch
							else
								l_tmp___1 := l_update_scratch
							end
							l_scratch := l_matrix_scratch + l_tmp___1
							if l_scratch > l_talloc then
								l_talloc := l_scratch
							end
							l_scratch := (2124).to_integer_32
							if l_scratch > l_talloc then
								l_talloc := l_scratch
							end
							l_talloc := l_talloc + (2 * (l_n + 1))
						end
					end
					if (builtin_expect ((l_talloc.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___5.ce_gets ((l_aaf.new ((l_talloc.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___5.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_talloc.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___5))
					if a_an > l_n then
						tdiv_qr_inst.gmpn_tdiv_qr (l_tp, a_ap, (0).to_integer_32, a_ap, a_an, a_bp, l_n)
						if (gmp_impl_inst.mpn_zero_p (a_ap, l_n)).to_boolean then
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (a_gp, a_bp, l_n)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
							a_usizep.item := (0).to_integer_32
							from
							until
								js.loop_left
							loop
								js.reset
								if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
									tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
								end
								js.break
							end
							js.reset
							Result := l_n
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if 303 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if not (l_n >= 303) then
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						l_gn := (gcdext_lehmer_inst.gmpn_gcdext_lehmer_n (a_gp, a_up, a_usizep, a_ap, a_bp, l_n, l_tp))
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
							end
							js.break
						end
						js.reset
						Result := l_gn
						js.return
				when 5 then -- if done
						if not js.return_called then
							from
							until
								js.loop_left
							loop
								js.reset
								if 2 * l_ualloc /= 0 then
									l_dst.ce_gets (l_tp)
									l_n2 := 2 * l_ualloc
									from
									until
										js.loop_left
									loop
										js.reset
										l_tmp___11.ce_gets (l_dst)
										l_dst.ce_gets (l_dst + 1)
										l_tmp___11.item := (0).to_natural_32
										l_n2 := l_n2 - 1
										if not l_n2.to_boolean then
											js.break
										end
									end
									js.reset
								end
								js.break
							end
							js.reset
							l_u0.ce_gets (l_tp)
							l_tp.ce_gets (l_tp + l_ualloc)
							l_u1.ce_gets (l_tp)
							l_tp.ce_gets (l_tp + l_ualloc)
							l_p := l_n // 2
							hgcd_inst.gmpn_hgcd_matrix_init (l_M.address, l_n - l_p, l_tp)
							l_nn := hgcd_inst.gmpn_hgcd (a_ap + l_p, a_bp + l_p, l_n - l_p, l_M.address, l_tp + l_matrix_scratch)
							if l_nn > 0 then
								l_n := hgcd_inst.gmpn_hgcd_matrix_adjust (l_M.address, l_p + l_nn, a_ap, a_bp, l_p, l_tp + l_matrix_scratch)
								from
								until
									js.loop_left
								loop
									js.reset
									from
									until
										js.loop_left
									loop
										js.reset
										gmp_inst.gmpn_copyi (l_u0, (l_M.p[1])[0], l_M.n)
										js.break
									end
									js.reset
									js.break
								end
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									from
									until
										js.loop_left
									loop
										js.reset
										gmp_inst.gmpn_copyi (l_u1, (l_M.p[1])[1], l_M.n)
										js.break
									end
									js.reset
									js.break
								end
								js.reset
								l_un := l_M.n
								from
								until
									((l_u0[(l_un - 1)]).bit_or (l_u1[(l_un - 1)])) /= {NATURAL_32} 0
								loop
									l_un := l_un - 1
								end
							else
								l_updated_un := (1).to_integer_32
								l_u1[0] := (1).to_natural_32
								l_n := gcdext_subdiv_step_inst.gmpn_gcdext_subdiv_step (a_gp, create {CE_POINTER [INTEGER_32]}.make_shared ($l_gn___0), a_up, a_usizep, a_ap, a_bp, l_n, l_u0, l_u1, create {CE_POINTER [INTEGER_32]}.make_shared ($l_updated_un), l_tp, l_tp + l_n)
								if l_n = 0 then
									from
									until
										js.loop_left
									loop
										js.reset
										if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
											tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
										end
										js.break
									end
									js.reset
									Result := l_gn___0
									js.return
								end
								if not js.return_called then
									l_un := l_updated_un
								end
							end
						end
						if not js.return_called then
							from
							until
								js.loop_left
							loop
								js.reset
								if 303 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
									if not (l_n >= 303) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_p___0 := l_n // 3
									hgcd_inst.gmpn_hgcd_matrix_init (l_M___0.address, l_n - l_p___0, l_tp)
									l_nn___0 := hgcd_inst.gmpn_hgcd (a_ap + l_p___0, a_bp + l_p___0, l_n - l_p___0, l_M___0.address, l_tp + l_matrix_scratch)
									if l_nn___0 > 0 then
										l_t0.ce_gets (l_tp + l_matrix_scratch)
										l_n := hgcd_inst.gmpn_hgcd_matrix_adjust (l_M___0.address, l_p___0 + l_nn___0, a_ap, a_bp, l_p___0, l_t0)
										from
										until
											js.loop_left
										loop
											js.reset
											from
											until
												js.loop_left
											loop
												js.reset
												gmp_inst.gmpn_copyi (l_t0, l_u0, l_un)
												js.break
											end
											js.reset
											js.break
										end
										js.reset
										l_un := (hgcd_mul_matrix_vector (l_M___0.address, l_u0, l_t0, l_u1, l_un, l_t0 + l_un)).to_integer_32
									else
										l_updated_un___0 := l_un
										l_n := gcdext_subdiv_step_inst.gmpn_gcdext_subdiv_step (a_gp, create {CE_POINTER [INTEGER_32]}.make_shared ($l_gn___1), a_up, a_usizep, a_ap, a_bp, l_n, l_u0, l_u1, create {CE_POINTER [INTEGER_32]}.make_shared ($l_updated_un___0), l_tp, l_tp + l_n)
										if l_n = 0 then
											from
											until
												js.loop_left
											loop
												js.reset
												if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
													tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
												end
												js.break
											end
											js.reset
											Result := l_gn___1
											js.return
										end
										if not js.return_called then
											l_un := l_updated_un___0
										end
									end
								end
							end
							js.reset
						end
						if not js.return_called then
							if (builtin_expect (((gmp_inst.gmpn_cmp (a_ap, a_bp, l_n)) = 0).to_integer, 0)).to_boolean then
								from
								until
									js.loop_left
								loop
									js.reset
									from
									until
										js.loop_left
									loop
										js.reset
										gmp_inst.gmpn_copyi (a_gp, a_ap, l_n)
										js.break
									end
									js.reset
									js.break
								end
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									l_c := 0
									l_gmp_i := l_un
									from
									until
										js.loop_left
									loop
										js.reset
										l_gmp_i := l_gmp_i - 1
										if not (l_gmp_i >= 0) then
											js.break
										end
										if not js.loop_jumped then
											l_gmp_x := l_u0[l_gmp_i]
											l_gmp_y := l_u1[l_gmp_i]
											if l_gmp_x /= l_gmp_y then
												if l_gmp_x > l_gmp_y then
													l_c := 1
												else
													l_c := -1
												end
												js.break
											end
										end
									end
									js.reset
									js.break
								end
								js.reset
								if l_c < 0 then
									from
									until
										js.loop_left
									loop
										js.reset
										from
										until
											not (not js.loop_left and then (l_un > 0))
										loop
											js.reset
											if l_u0[(l_un - 1)] /= {NATURAL_32} 0 then
												js.break
											end
											if not js.loop_jumped then
												l_un := l_un - 1
											end
										end
										js.reset
										js.break
									end
									js.reset
									from
									until
										js.loop_left
									loop
										js.reset
										from
										until
											js.loop_left
										loop
											js.reset
											gmp_inst.gmpn_copyi (a_up, l_u0, l_un)
											js.break
										end
										js.reset
										js.break
									end
									js.reset
									a_usizep.item := -l_un
								else
									from
									until
										js.loop_left
									loop
										js.reset
										from
										until
											(l_u1[(l_un - 1)] /= {NATURAL_32} 0)
										loop
											l_un := l_un - 1
										end
										js.break
									end
									js.reset
									from
									until
										js.loop_left
									loop
										js.reset
										from
										until
											js.loop_left
										loop
											js.reset
											gmp_inst.gmpn_copyi (a_up, l_u1, l_un)
											js.break
										end
										js.reset
										js.break
									end
									js.reset
									a_usizep.item := l_un
								end
								from
								until
									js.loop_left
								loop
									js.reset
									if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
										tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
									end
									js.break
								end
								js.reset
								Result := l_n
							elseif (gmp_impl_inst.mpn_zero_p (l_u0, l_un)).to_boolean then
								l_gn___2 := gcdext_lehmer_inst.gmpn_gcdext_lehmer_n (a_gp, a_up, a_usizep, a_ap, a_bp, l_n, l_tp)
								from
								until
									js.loop_left
								loop
									js.reset
									if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
										tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
									end
									js.break
								end
								js.reset
								Result := l_gn___2
							else
								l_lehmer_up.ce_gets (l_tp)
								l_tp.ce_gets (l_tp + l_n)
								from
								until
									js.loop_left
								loop
									js.reset
									from
									until
										js.loop_left
									loop
										js.reset
										gmp_inst.gmpn_copyi (l_tp, a_ap, l_n)
										js.break
									end
									js.reset
									js.break
								end
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									from
									until
										js.loop_left
									loop
										js.reset
										gmp_inst.gmpn_copyi (l_tp + l_n, a_bp, l_n)
										js.break
									end
									js.reset
									js.break
								end
								js.reset
								l_gn___3 := gcdext_lehmer_inst.gmpn_gcdext_lehmer_n (a_gp, l_lehmer_up, create {CE_POINTER [INTEGER_32]}.make_shared ($l_lehmer_un), l_tp, l_tp + l_n, l_n, l_tp + 2 * l_n)
								l_u0n := l_un
								from
								until
									js.loop_left
								loop
									js.reset
									from
									until
										not (not js.loop_left and then (l_u0n > 0))
									loop
										js.reset
										if l_u0[(l_u0n - 1)] /= {NATURAL_32} 0 then
											js.break
										end
										if not js.loop_jumped then
											l_u0n := l_u0n - 1
										end
									end
									js.reset
									js.break
								end
								js.reset
								if l_lehmer_un = 0 then
									from
									until
										js.loop_left
									loop
										js.reset
										from
										until
											js.loop_left
										loop
											js.reset
											gmp_inst.gmpn_copyi (a_up, l_u0, l_u0n)
											js.break
										end
										js.reset
										js.break
									end
									js.reset
									a_usizep.item := -l_u0n
									from
									until
										js.loop_left
									loop
										js.reset
										if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
											tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
										end
										js.break
									end
									js.reset
									Result := l_gn___3
									js.return
								end
								if not js.return_called then
									l_lehmer_vp.ce_gets (l_tp)
									l_lehmer_vn := compute_v (l_lehmer_vp, a_ap, a_bp, l_n, a_gp, l_gn___3, l_lehmer_up, l_lehmer_un, (l_tp + l_n) + 1)
									if l_lehmer_un > 0 then
										l_negate := 0
									else
										l_lehmer_un := -l_lehmer_un
										l_negate := 1
									end
									l_u1n := l_un
									from
									until
										js.loop_left
									loop
										js.reset
										from
										until
											not (not js.loop_left and then (l_u1n > 0))
										loop
											js.reset
											if l_u1[(l_u1n - 1)] /= {NATURAL_32} 0 then
												js.break
											end
											if not js.loop_jumped then
												l_u1n := l_u1n - 1
											end
										end
										js.reset
										js.break
									end
									js.reset
									if l_u1n = 0 then
										from
										until
											js.loop_left
										loop
											js.reset
											from
											until
												js.loop_left
											loop
												js.reset
												gmp_inst.gmpn_copyi (a_up, l_lehmer_vp, l_lehmer_vn)
												js.break
											end
											js.reset
											js.break
										end
										js.reset
										if l_negate.to_boolean then
											a_usizep.item := l_lehmer_vn
										else
											a_usizep.item := -l_lehmer_vn
										end
										from
										until
											js.loop_left
										loop
											js.reset
											if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
												tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
											end
											js.break
										end
										js.reset
										Result := l_gn___3
										js.return
									end
								end
								if not js.return_called then
									if l_lehmer_un <= l_u1n then
										mul_inst.gmpn_mul (a_up, l_u1, l_u1n, l_lehmer_up, l_lehmer_un).do_nothing
									else
										mul_inst.gmpn_mul (a_up, l_lehmer_up, l_lehmer_un, l_u1, l_u1n).do_nothing
									end
									l_un := l_u1n + l_lehmer_un
									l_un := l_un - (a_up[(l_un - 1)] = {NATURAL_32} 0).to_integer
									if l_lehmer_vn > 0 then
										if l_lehmer_vn <= l_u0n then
											mul_inst.gmpn_mul (l_u1, l_u0, l_u0n, l_lehmer_vp, l_lehmer_vn).do_nothing
										else
											mul_inst.gmpn_mul (l_u1, l_lehmer_vp, l_lehmer_vn, l_u0, l_u0n).do_nothing
										end
										l_u1n := l_u0n + l_lehmer_vn
										l_u1n := l_u1n - (l_u1[(l_u1n - 1)] = {NATURAL_32} 0).to_integer
										if l_u1n <= l_un then
											l_cy := gmp_inst.gmpn_add (a_up, a_up, l_un, l_u1, l_u1n)
										else
											l_cy := gmp_inst.gmpn_add (a_up, l_u1, l_u1n, a_up, l_un)
											l_un := l_u1n
										end
										a_up[l_un] := l_cy
										l_un := l_un + (l_cy /= {NATURAL_32} 0).to_integer
									end
									if l_negate.to_boolean then
										a_usizep.item := -l_un
									else
										a_usizep.item := l_un
									end
									from
									until
										js.loop_left
									loop
										js.reset
										if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
											tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
										end
										js.break
									end
									js.reset
									Result := l_gn___3
								end
							end
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
