class
	P_GCDEXT_LEHMER

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_gcdext_lehmer_n (a_gp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_usize: CE_POINTER [INTEGER_32]; a_ap: CE_POINTER [NATURAL_32]; a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_ap: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tp: CE_POINTER [NATURAL_32]
			l_ualloc: INTEGER_32
			l_un: INTEGER_32
			l_u0: CE_POINTER [NATURAL_32]
			l_u1: CE_POINTER [NATURAL_32]
			l_u2: CE_POINTER [NATURAL_32]
			l_dst: CE_POINTER [NATURAL_32]
			l_n2: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_32]
			l_M: PD_HGCD_MATRIX1
			l_ah: NATURAL_32
			l_al: NATURAL_32
			l_bh: NATURAL_32
			l_bl: NATURAL_32
			l_mask: NATURAL_32
			l_shift: INTEGER_32
			l_shift___0: INTEGER_32
			l_mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l_mp_ptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			l_gn: INTEGER_32
			l_updated_un: INTEGER_32
			l_c: INTEGER_32
			l_gmp_i: INTEGER_32
			l_gmp_x: NATURAL_32
			l_gmp_y: NATURAL_32
			l_uh: NATURAL_32
			l_vh: NATURAL_32
			l_u: INTEGER_32
			l_v: INTEGER_32
			l_negate: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_ap.make
			create l_tp.make
			create l_u0.make
			create l_u1.make
			create l_u2.make
			create l_dst.make
			create l_tmp.make
			create l_M.make
			create l_mp_ptr_swap__tmp.make
			create l_mp_ptr_swap__tmp___0.make

			l_ap.ce_gets (a_ap)
			l_n := a_n
			l_tp.ce_gets (a_tp)
			l_ualloc := l_n + 1
			from
			until
				js.loop_left
			loop
				js.reset
				if 3 * l_ualloc /= 0 then
					l_dst.ce_gets (l_tp)
					l_n2 := 3 * l_ualloc
					from
					until
						js.loop_left
					loop
						js.reset
						l_tmp.ce_gets (l_dst)
						l_dst.ce_gets (l_dst + 1)
						l_tmp.item := (0).to_natural_32
						l_n2 := l_n2 - 1
						if not l_n2.to_boolean then
							js.break
						end
					end
					js.reset
				end
				js.break
			end
			js.reset
			l_u0.ce_gets (l_tp)
			l_tp.ce_gets (l_tp + l_ualloc)
			l_u1.ce_gets (l_tp)
			l_tp.ce_gets (l_tp + l_ualloc)
			l_u2.ce_gets (l_tp)
			l_tp.ce_gets (l_tp + l_ualloc)
			l_u1[0] := (1).to_natural_32
			l_un := (1).to_integer_32
			from
			until
				not (not js.loop_left and then (l_n >= 2))
			loop
				l_mask := (l_ap[(l_n - 1)]).bit_or (a_bp[(l_n - 1)])
				if ((l_mask).bit_and ((({NATURAL_32} 1).bit_shift_left (31)))).to_boolean then
					l_ah := l_ap[(l_n - 1)]
					l_al := l_ap[(l_n - 2)]
					l_bh := a_bp[(l_n - 1)]
					l_bl := a_bp[(l_n - 2)]
				elseif l_n = 2 then
					from
					until
						js.loop_left
					loop
						js.reset
						l_shift := builtin_clzl (l_mask)
						js.break
					end
					js.reset
					l_ah := (((((l_ap[1]).bit_shift_left (l_shift))).bit_and ({NATURAL_32} 4294967295))).bit_or (((l_ap[0]).bit_shift_right ((32 - l_shift))))
					l_al := (l_ap[0]).bit_shift_left (l_shift)
					l_bh := (((((a_bp[1]).bit_shift_left (l_shift))).bit_and ({NATURAL_32} 4294967295))).bit_or (((a_bp[0]).bit_shift_right ((32 - l_shift))))
					l_bl := (a_bp[0]).bit_shift_left (l_shift)
				else
					from
					until
						js.loop_left
					loop
						js.reset
						l_shift___0 := builtin_clzl (l_mask)
						js.break
					end
					js.reset
					l_ah := (((((l_ap[(l_n - 1)]).bit_shift_left (l_shift___0))).bit_and ({NATURAL_32} 4294967295))).bit_or (((l_ap[(l_n - 2)]).bit_shift_right ((32 - l_shift___0))))
					l_al := (((((l_ap[(l_n - 2)]).bit_shift_left (l_shift___0))).bit_and ({NATURAL_32} 4294967295))).bit_or (((l_ap[(l_n - 3)]).bit_shift_right ((32 - l_shift___0))))
					l_bh := (((((a_bp[(l_n - 1)]).bit_shift_left (l_shift___0))).bit_and ({NATURAL_32} 4294967295))).bit_or (((a_bp[(l_n - 2)]).bit_shift_right ((32 - l_shift___0))))
					l_bl := (((((a_bp[(l_n - 2)]).bit_shift_left (l_shift___0))).bit_and ({NATURAL_32} 4294967295))).bit_or (((a_bp[(l_n - 3)]).bit_shift_right ((32 - l_shift___0))))
				end
				if (hgcd2_inst.gmpn_hgcd2 (l_ah, l_al, l_bh, l_bl, l_M.address)).to_boolean then
					l_n := hgcd2_inst.gmpn_hgcd_mul_matrix1_inverse_vector ((l_M.address), l_tp, l_ap, a_bp, l_n)
					from
					until
						js.loop_left
					loop
						js.reset
						l_mp_ptr_swap__tmp.ce_gets (l_ap)
						l_ap.ce_gets (l_tp)
						l_tp.ce_gets (l_mp_ptr_swap__tmp)
						js.break
					end
					js.reset
					l_un := hgcd2_inst.gmpn_hgcd_mul_matrix1_vector ((l_M.address), l_u2, l_u0, l_u1, l_un)
					from
					until
						js.loop_left
					loop
						js.reset
						l_mp_ptr_swap__tmp___0.ce_gets (l_u0)
						l_u0.ce_gets (l_u2)
						l_u2.ce_gets (l_mp_ptr_swap__tmp___0)
						js.break
					end
					js.reset
				else
					l_updated_un := l_un
					l_n := gcdext_subdiv_step_inst.gmpn_gcdext_subdiv_step (a_gp, create {CE_POINTER [INTEGER_32]}.make_shared ($l_gn), a_up, a_usize, l_ap, a_bp, l_n, l_u0, l_u1, create {CE_POINTER [INTEGER_32]}.make_shared ($l_updated_un), l_tp, l_u2)
					if l_n = 0 then
						Result := l_gn
						js.return
					end
					if not js.return_called then
						l_un := l_updated_un
					end
				end
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					if not (l_ap[0] > {NATURAL_32} 0) then
						assert_inst.gmp_assert_fail (ce_string ("gcdext_lehmer.c"), 122, ce_string ("ap[0] > 0"))
					end
					js.break
				end
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					if not (a_bp[0] > {NATURAL_32} 0) then
						assert_inst.gmp_assert_fail (ce_string ("gcdext_lehmer.c"), 123, ce_string ("bp[0] > 0"))
					end
					js.break
				end
				js.reset
				if l_ap[0] = a_bp[0] then
					a_gp[0] := l_ap[0]
					from
					until
						js.loop_left
					loop
						js.reset
						l_c := 0
						l_gmp_i := l_un
						from
						until
							js.loop_left
						loop
							js.reset
							l_gmp_i := l_gmp_i - 1
							if not (l_gmp_i >= 0) then
								js.break
							end
							if not js.loop_jumped then
								l_gmp_x := l_u0[l_gmp_i]
								l_gmp_y := l_u1[l_gmp_i]
								if l_gmp_x /= l_gmp_y then
									if l_gmp_x > l_gmp_y then
										l_c := 1
									else
										l_c := -1
									end
									js.break
								end
							end
						end
						js.reset
						js.break
					end
					js.reset
					if l_c < 0 then
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								not (not js.loop_left and then (l_un > 0))
							loop
								js.reset
								if l_u0[(l_un - 1)] /= {NATURAL_32} 0 then
									js.break
								end
								if not js.loop_jumped then
									l_un := l_un - 1
								end
							end
							js.reset
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (a_up, l_u0, l_un)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						a_usize.item := -l_un
					else
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								(l_u1[(l_un - 1)] /= {NATURAL_32} 0)
							loop
								l_un := l_un - 1
							end
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (a_up, l_u1, l_un)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						a_usize.item := l_un
					end
					Result := (1).to_integer_32
				else
					a_gp[0] := gcdext_1_inst.gmpn_gcdext_1 (create {CE_POINTER [INTEGER_32]}.make_shared ($l_u), create {CE_POINTER [INTEGER_32]}.make_shared ($l_v), l_ap[0], a_bp[0])
					if l_u = 0 then
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								not (not js.loop_left and then (l_un > 0))
							loop
								js.reset
								if l_u0[(l_un - 1)] /= {NATURAL_32} 0 then
									js.break
								end
								if not js.loop_jumped then
									l_un := l_un - 1
								end
							end
							js.reset
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (a_up, l_u0, l_un)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						a_usize.item := -l_un
						Result := (1).to_integer_32
						js.return
					elseif l_v = 0 then
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								not (not js.loop_left and then (l_un > 0))
							loop
								js.reset
								if l_u1[(l_un - 1)] /= {NATURAL_32} 0 then
									js.break
								end
								if not js.loop_jumped then
									l_un := l_un - 1
								end
							end
							js.reset
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (a_up, l_u1, l_un)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						a_usize.item := l_un
						Result := (1).to_integer_32
						js.return
					elseif l_u > 0 then
						l_negate := 0
						l_v := -l_v
					else
						l_negate := 1
						l_u := -l_u
					end
					if not js.return_called then
						l_uh := gmp_inst.gmpn_mul_1 (a_up, l_u1, l_un, l_u.to_natural_32)
						l_vh := gmp_inst.gmpn_addmul_1 (a_up, l_u0, l_un, l_v.to_natural_32)
						if ((l_uh).bit_or (l_vh)) > {NATURAL_32} 0 then
							l_uh := l_uh + l_vh
							l_tmp___1 := l_un
							l_un := l_un + 1
							a_up[l_tmp___1] := l_uh
							if l_uh < l_vh then
								l_tmp___2 := l_un
								l_un := l_un + 1
								a_up[l_tmp___2] := (1).to_natural_32
							end
						end
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								(a_up[(l_un - 1)] /= {NATURAL_32} 0)
							loop
								l_un := l_un - 1
							end
							js.break
						end
						js.reset
						if l_negate.to_boolean then
							a_usize.item := -l_un
						else
							a_usize.item := l_un
						end
						Result := (1).to_integer_32
					end
				end
			end
		end

end
