class
	P_GET_D_2EXP

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_get_d_2exp (a_exp2: CE_POINTER [INTEGER_32]; a_src: CE_POINTER [PD_MPF_STRUCT]): REAL_64
		local
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_32]
			l_cnt: INTEGER_32
			l_exp: INTEGER_32
			js: JUMP_STATE
		do
			create l_ptr.make

			l_size := (a_src.item.mp_size).to_integer_32
			if (builtin_expect ((l_size = 0).to_integer, 0)).to_boolean then
				a_exp2.item := 0
				Result := (0.0)
				js.return
			end
			if not js.return_called then
				l_ptr.ce_gets (a_src.item.mp_d)
				if l_size >= 0 then
					l_abs_size := l_size
				else
					l_abs_size := -l_size
				end
				from
				until
					js.loop_left
				loop
					js.reset
					l_cnt := builtin_clzl (l_ptr[(l_abs_size - 1)])
					js.break
				end
				js.reset
				l_cnt := l_cnt
				l_exp := (a_src.item.mp_exp * 32 - l_cnt.to_integer_32)
				a_exp2.item := l_exp
				Result := (get_d_inst.gmpn_get_d (l_ptr, l_abs_size, (0).to_integer_32, -(l_abs_size * 32 - l_cnt.to_integer_32)))
			end
		end

	gmpz_get_d_2exp (a_exp2: CE_POINTER [INTEGER_32]; a_src: CE_POINTER [PD_MPZ_STRUCT]): REAL_64
		local
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_32]
			l_cnt: INTEGER_32
			l_exp: INTEGER_32
			js: JUMP_STATE
		do
			create l_ptr.make

			l_size := (a_src.item.mp_size).to_integer_32
			if (builtin_expect ((l_size = 0).to_integer, 0)).to_boolean then
				a_exp2.item := 0
				Result := (0.0)
				js.return
			end
			if not js.return_called then
				l_ptr.ce_gets (a_src.item.mp_d)
				if l_size >= 0 then
					l_abs_size := l_size
				else
					l_abs_size := -l_size
				end
				from
				until
					js.loop_left
				loop
					js.reset
					l_cnt := builtin_clzl (l_ptr[(l_abs_size - 1)])
					js.break
				end
				js.reset
				l_exp := l_abs_size * 32 - l_cnt.to_integer_32
				a_exp2.item := l_exp
				Result := (get_d_inst.gmpn_get_d (l_ptr, l_abs_size, l_size, -l_exp))
			end
		end

end
