class
	P_GMP

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_add_n (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: CE_POINTER [NATURAL_32]; a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32): NATURAL_32
		do
			Result := c_gmpn_add_n (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3.c_pointer, a_arg4)
		end

	c_gmpn_add_n (a_arg1: POINTER; a_arg2: POINTER; a_arg3: POINTER; a_arg4: INTEGER_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_add_n($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_popcount (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32): NATURAL_32
		do
			Result := c_gmpn_popcount (a_arg1.c_pointer, a_arg2)
		end

	c_gmpn_popcount (a_arg1: POINTER; a_arg2: INTEGER_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_popcount($a_arg1, $a_arg2);"
		end

	gmpn_sub_n (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: CE_POINTER [NATURAL_32]; a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32): NATURAL_32
		do
			Result := c_gmpn_sub_n (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3.c_pointer, a_arg4)
		end

	c_gmpn_sub_n (a_arg1: POINTER; a_arg2: POINTER; a_arg3: POINTER; a_arg4: INTEGER_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_sub_n($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpz_fits_uint_p (a_gmp_z: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_gmp_n: INTEGER_32
			l_gmp_p: CE_POINTER [NATURAL_32]
			l_tmp: INTEGER_32
		do
			create l_gmp_p.make

			l_gmp_n := (a_gmp_z.item.mp_size).to_integer_32
			l_gmp_p.ce_gets (a_gmp_z.item.mp_d)
			if l_gmp_n = 0 then
				l_tmp := 1
			elseif l_gmp_n = 1 then
				if l_gmp_p[0] <= {NATURAL_32} 4294967295 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	gmpz_fits_ushort_p (a_gmp_z: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_gmp_n: INTEGER_32
			l_gmp_p: CE_POINTER [NATURAL_32]
			l_tmp: INTEGER_32
		do
			create l_gmp_p.make

			l_gmp_n := (a_gmp_z.item.mp_size).to_integer_32
			l_gmp_p.ce_gets (a_gmp_z.item.mp_d)
			if l_gmp_n = 0 then
				l_tmp := 1
			elseif l_gmp_n = 1 then
				if l_gmp_p[0] <= {NATURAL_32} 65535 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	gmpz_get_ui (a_gmp_z: CE_POINTER [PD_MPZ_STRUCT]): NATURAL_32
		local
			l_gmp_p: CE_POINTER [NATURAL_32]
			l_gmp_n: INTEGER_32
			l_gmp_l: NATURAL_32
			l_tmp: NATURAL_32
		do
			create l_gmp_p.make

			l_gmp_p.ce_gets (a_gmp_z.item.mp_d)
			l_gmp_n := (a_gmp_z.item.mp_size).to_integer_32
			l_gmp_l := l_gmp_p[0]
			if l_gmp_n /= 0 then
				l_tmp := l_gmp_l
			else
				l_tmp := (0).to_natural_32
			end
			Result := l_tmp
		end

	gmpz_getlimbn (a_gmp_z: CE_POINTER [PD_MPZ_STRUCT]; a_gmp_n: INTEGER_32): NATURAL_32
		local
			l_gmp_result: NATURAL_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			l_gmp_result := (0).to_natural_32
			if a_gmp_n >= 0 then
				if a_gmp_z.item.mp_size >= 0 then
					l_tmp := a_gmp_z.item.mp_size
				else
					l_tmp := -a_gmp_z.item.mp_size
				end
				if a_gmp_n < l_tmp.to_integer_32 then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			if (builtin_expect ((l_tmp___0 /= 0).to_integer, 1)).to_boolean then
				l_gmp_result := a_gmp_z.item.mp_d[a_gmp_n]
			end
			Result := l_gmp_result
		end

	gmpz_perfect_square_p (a_gmp_a: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_gmp_asize: INTEGER_32
			l_gmp_result: INTEGER_32
		do
			l_gmp_asize := (a_gmp_a.item.mp_size).to_integer_32
			l_gmp_result := (l_gmp_asize >= 0).to_integer
			if (builtin_expect ((l_gmp_asize > 0).to_integer, 1)).to_boolean then
				l_gmp_result := perfsqr_inst.gmpn_perfect_square_p (a_gmp_a.item.mp_d, l_gmp_asize)
			end
			Result := l_gmp_result
		end

	gmpz_popcount (a_gmp_u: CE_POINTER [PD_MPZ_STRUCT]): NATURAL_32
		local
			l_gmp_usize: INTEGER_32
			l_gmp_result: NATURAL_32
		do
			l_gmp_usize := (a_gmp_u.item.mp_size).to_integer_32
			if l_gmp_usize < 0 then
				l_gmp_result := ({NATURAL_32} 0).bit_not
			else
				l_gmp_result := (0).to_natural_32
			end
			if (builtin_expect ((l_gmp_usize > 0).to_integer, 1)).to_boolean then
				l_gmp_result := gmpn_popcount (a_gmp_u.item.mp_d, l_gmp_usize)
			end
			Result := l_gmp_result
		end

	gmpz_set_q (a_gmp_w: CE_POINTER [PD_MPZ_STRUCT]; a_gmp_u: CE_POINTER [PD_MPQ_STRUCT])
		do
			tdiv_q_inst.gmpz_tdiv_q (a_gmp_w, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_gmp_u.c_pointer + {PD_MPQ_STRUCT}.mp_num_offset), create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_gmp_u.c_pointer + {PD_MPQ_STRUCT}.mp_den_offset))
		end

	gmpz_size (a_gmp_z: CE_POINTER [PD_MPZ_STRUCT]): NATURAL_32
		local
			l_tmp: INTEGER_32
		do
			if a_gmp_z.item.mp_size >= 0 then
				l_tmp := a_gmp_z.item.mp_size
			else
				l_tmp := -a_gmp_z.item.mp_size
			end
			Result := l_tmp.to_natural_32
		end

	gmpn_add (a_gmp_wp: CE_POINTER [NATURAL_32]; a_gmp_xp: CE_POINTER [NATURAL_32]; a_gmp_xsize: INTEGER_32; a_gmp_yp: CE_POINTER [NATURAL_32]; a_gmp_ysize: INTEGER_32): NATURAL_32
		local
			l_gmp_c: NATURAL_32
			l_gmp_i: INTEGER_32
			l_gmp_x: NATURAL_32
			l_tmp: INTEGER_32
			l_tmp___0: NATURAL_32
			l_gmp_j: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if js.loop_left then
						l_pos := -1 + 9 -- skip loop
					end
				when 1 then -- loop body:
						js.reset
						l_gmp_i := a_gmp_ysize
						if l_gmp_i = 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if not ((gmpn_add_n (a_gmp_wp, a_gmp_xp, a_gmp_yp, l_gmp_i)).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 6 -- skip loop
						end
				when 4 then -- loop body:
						js.reset
						if l_gmp_i >= a_gmp_xsize then
							l_gmp_c := (1).to_natural_32
							l_pos := -1 + 8 -- goto __gmp_done
						end
				when 5 then
						l_gmp_x := a_gmp_xp[l_gmp_i]
						l_tmp := l_gmp_i
						l_gmp_i := l_gmp_i + 1
						l_tmp___0 := ((l_gmp_x + {NATURAL_32} 1)).bit_and ({NATURAL_32} 4294967295)
						a_gmp_wp[l_tmp] := l_tmp___0
						if l_tmp___0 /= {NATURAL_32} 0 then
							js.break
						end
						l_pos := -1 + 3 -- back to loop condition
				when 6 then -- loop done
						js.reset
				when 7 then -- if done | if done
						if (a_gmp_wp.c_pointer.to_integer_32).to_natural_32 /= (a_gmp_xp.c_pointer.to_integer_32).to_natural_32 then
							from
							until
								js.loop_left
							loop
								js.reset
								l_gmp_j := l_gmp_i
								from
								until
									not (l_gmp_j < a_gmp_xsize)
								loop
									a_gmp_wp[l_gmp_j] := a_gmp_xp[l_gmp_j]
									l_gmp_j := l_gmp_j + 1
								end
								js.break
							end
							js.reset
						end
						l_gmp_c := (0).to_natural_32
				when 8 then -- __gmp_done:
						
						js.break
						l_pos := -1 + 0 -- back to loop condition
				when 9 then -- loop done
					js.reset
					Result := l_gmp_c
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_add_1 (a_gmp_dst: CE_POINTER [NATURAL_32]; a_gmp_src: CE_POINTER [NATURAL_32]; a_gmp_size: INTEGER_32; a_gmp_n: NATURAL_32): NATURAL_32
		local
			l_gmp_c: NATURAL_32
			l_gmp_i: INTEGER_32
			l_gmp_x: NATURAL_32
			l_gmp_r: NATURAL_32
			l_gmp_j: INTEGER_32
			l_gmp_j___0: INTEGER_32
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				l_gmp_x := a_gmp_src[0]
				l_gmp_r := l_gmp_x + a_gmp_n
				a_gmp_dst[0] := l_gmp_r
				if l_gmp_r < a_gmp_n then
					l_gmp_c := (1).to_natural_32
					l_gmp_i := (1).to_integer_32
					from
					until
						not (not js.loop_left and then (l_gmp_i < a_gmp_size))
					loop
						js.reset
						l_gmp_x := a_gmp_src[l_gmp_i]
						l_gmp_r := l_gmp_x + {NATURAL_32} 1
						a_gmp_dst[l_gmp_i] := l_gmp_r
						l_gmp_i := l_gmp_i + 1
						if not (l_gmp_r < {NATURAL_32} 1) then
							if (a_gmp_src.c_pointer.to_integer_32).to_natural_32 /= (a_gmp_dst.c_pointer.to_integer_32).to_natural_32 then
								from
								until
									js.loop_left
								loop
									js.reset
									l_gmp_j := l_gmp_i
									from
									until
										not (l_gmp_j < a_gmp_size)
									loop
										a_gmp_dst[l_gmp_j] := a_gmp_src[l_gmp_j]
										l_gmp_j := l_gmp_j + 1
									end
									js.break
								end
								js.reset
							end
							l_gmp_c := (0).to_natural_32
							js.break
						end
					end
					js.reset
				else
					if (a_gmp_src.c_pointer.to_integer_32).to_natural_32 /= (a_gmp_dst.c_pointer.to_integer_32).to_natural_32 then
						from
						until
							js.loop_left
						loop
							js.reset
							l_gmp_j___0 := (1).to_integer_32
							from
							until
								not (l_gmp_j___0 < a_gmp_size)
							loop
								a_gmp_dst[l_gmp_j___0] := a_gmp_src[l_gmp_j___0]
								l_gmp_j___0 := l_gmp_j___0 + 1
							end
							js.break
						end
						js.reset
					end
					l_gmp_c := (0).to_natural_32
				end
				js.break
			end
			js.reset
			Result := l_gmp_c
		end

	gmpn_cmp (a_gmp_xp: CE_POINTER [NATURAL_32]; a_gmp_yp: CE_POINTER [NATURAL_32]; a_gmp_size: INTEGER_32): INTEGER_32
		local
			l_gmp_result: INTEGER_32
			l_gmp_i: INTEGER_32
			l_gmp_x: NATURAL_32
			l_gmp_y: NATURAL_32
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				l_gmp_result := 0
				l_gmp_i := a_gmp_size
				from
				until
					js.loop_left
				loop
					js.reset
					l_gmp_i := l_gmp_i - 1
					if not (l_gmp_i >= 0) then
						js.break
					end
					if not js.loop_jumped then
						l_gmp_x := a_gmp_xp[l_gmp_i]
						l_gmp_y := a_gmp_yp[l_gmp_i]
						if l_gmp_x /= l_gmp_y then
							if l_gmp_x > l_gmp_y then
								l_gmp_result := 1
							else
								l_gmp_result := -1
							end
							js.break
						end
					end
				end
				js.reset
				js.break
			end
			js.reset
			Result := l_gmp_result
		end

	gmpn_sub (a_gmp_wp: CE_POINTER [NATURAL_32]; a_gmp_xp: CE_POINTER [NATURAL_32]; a_gmp_xsize: INTEGER_32; a_gmp_yp: CE_POINTER [NATURAL_32]; a_gmp_ysize: INTEGER_32): NATURAL_32
		local
			l_gmp_c: NATURAL_32
			l_gmp_i: INTEGER_32
			l_gmp_x: NATURAL_32
			l_tmp: INTEGER_32
			l_gmp_j: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if js.loop_left then
						l_pos := -1 + 9 -- skip loop
					end
				when 1 then -- loop body:
						js.reset
						l_gmp_i := a_gmp_ysize
						if l_gmp_i = 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if not ((gmpn_sub_n (a_gmp_wp, a_gmp_xp, a_gmp_yp, l_gmp_i)).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 6 -- skip loop
						end
				when 4 then -- loop body:
						js.reset
						if l_gmp_i >= a_gmp_xsize then
							l_gmp_c := (1).to_natural_32
							l_pos := -1 + 8 -- goto __gmp_done
						end
				when 5 then
						l_gmp_x := a_gmp_xp[l_gmp_i]
						l_tmp := l_gmp_i
						l_gmp_i := l_gmp_i + 1
						a_gmp_wp[l_tmp] := ((l_gmp_x - {NATURAL_32} 1)).bit_and ({NATURAL_32} 4294967295)
						if l_gmp_x /= {NATURAL_32} 0 then
							js.break
						end
						l_pos := -1 + 3 -- back to loop condition
				when 6 then -- loop done
						js.reset
				when 7 then -- if done | if done
						if (a_gmp_wp.c_pointer.to_integer_32).to_natural_32 /= (a_gmp_xp.c_pointer.to_integer_32).to_natural_32 then
							from
							until
								js.loop_left
							loop
								js.reset
								l_gmp_j := l_gmp_i
								from
								until
									not (l_gmp_j < a_gmp_xsize)
								loop
									a_gmp_wp[l_gmp_j] := a_gmp_xp[l_gmp_j]
									l_gmp_j := l_gmp_j + 1
								end
								js.break
							end
							js.reset
						end
						l_gmp_c := (0).to_natural_32
				when 8 then -- __gmp_done:
						
						js.break
						l_pos := -1 + 0 -- back to loop condition
				when 9 then -- loop done
					js.reset
					Result := l_gmp_c
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_sub_1 (a_gmp_dst: CE_POINTER [NATURAL_32]; a_gmp_src: CE_POINTER [NATURAL_32]; a_gmp_size: INTEGER_32; a_gmp_n: NATURAL_32): NATURAL_32
		local
			l_gmp_c: NATURAL_32
			l_gmp_i: INTEGER_32
			l_gmp_x: NATURAL_32
			l_gmp_r: NATURAL_32
			l_gmp_j: INTEGER_32
			l_gmp_j___0: INTEGER_32
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				l_gmp_x := a_gmp_src[0]
				l_gmp_r := l_gmp_x - a_gmp_n
				a_gmp_dst[0] := l_gmp_r
				if l_gmp_x < a_gmp_n then
					l_gmp_c := (1).to_natural_32
					l_gmp_i := (1).to_integer_32
					from
					until
						not (not js.loop_left and then (l_gmp_i < a_gmp_size))
					loop
						js.reset
						l_gmp_x := a_gmp_src[l_gmp_i]
						l_gmp_r := l_gmp_x - {NATURAL_32} 1
						a_gmp_dst[l_gmp_i] := l_gmp_r
						l_gmp_i := l_gmp_i + 1
						if not (l_gmp_x < {NATURAL_32} 1) then
							if (a_gmp_src.c_pointer.to_integer_32).to_natural_32 /= (a_gmp_dst.c_pointer.to_integer_32).to_natural_32 then
								from
								until
									js.loop_left
								loop
									js.reset
									l_gmp_j := l_gmp_i
									from
									until
										not (l_gmp_j < a_gmp_size)
									loop
										a_gmp_dst[l_gmp_j] := a_gmp_src[l_gmp_j]
										l_gmp_j := l_gmp_j + 1
									end
									js.break
								end
								js.reset
							end
							l_gmp_c := (0).to_natural_32
							js.break
						end
					end
					js.reset
				else
					if (a_gmp_src.c_pointer.to_integer_32).to_natural_32 /= (a_gmp_dst.c_pointer.to_integer_32).to_natural_32 then
						from
						until
							js.loop_left
						loop
							js.reset
							l_gmp_j___0 := (1).to_integer_32
							from
							until
								not (l_gmp_j___0 < a_gmp_size)
							loop
								a_gmp_dst[l_gmp_j___0] := a_gmp_src[l_gmp_j___0]
								l_gmp_j___0 := l_gmp_j___0 + 1
							end
							js.break
						end
						js.reset
					end
					l_gmp_c := (0).to_natural_32
				end
				js.break
			end
			js.reset
			Result := l_gmp_c
		end

	gmpn_neg (a_gmp_rp: CE_POINTER [NATURAL_32]; a_gmp_up: CE_POINTER [NATURAL_32]; a_gmp_n: INTEGER_32): NATURAL_32
		local
			l_gmp_rp: CE_POINTER [NATURAL_32]
			l_gmp_up: CE_POINTER [NATURAL_32]
			l_gmp_n: INTEGER_32
			l_gmp_ul: NATURAL_32
			l_gmp_cy: NATURAL_32
			l_tmp: CE_POINTER [NATURAL_32]
			l_tmp___0: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_gmp_rp.make
			create l_gmp_up.make
			create l_tmp.make
			create l_tmp___0.make

			l_gmp_rp.ce_gets (a_gmp_rp)
			l_gmp_up.ce_gets (a_gmp_up)
			l_gmp_n := a_gmp_n
			l_gmp_cy := (0).to_natural_32
			from
			until
				js.loop_left
			loop
				js.reset
				l_tmp.ce_gets (l_gmp_up)
				l_gmp_up.ce_gets (l_gmp_up + 1)
				l_gmp_ul := l_tmp.item
				l_tmp___0.ce_gets (l_gmp_rp)
				l_gmp_rp.ce_gets (l_gmp_rp + 1)
				l_tmp___0.item := (-l_gmp_ul.to_integer_32).to_natural_32 - l_gmp_cy
				l_gmp_cy := (l_gmp_cy).bit_or ((l_gmp_ul /= {NATURAL_32} 0).to_integer.to_natural_32)
				l_gmp_n := l_gmp_n - 1
				if l_gmp_n = 0 then
					js.break
				end
			end
			js.reset
			Result := l_gmp_cy
		end

	gmpn_divrem_1 (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32; a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32; a_arg5: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_divrem_1 (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4, a_arg5)
		end

	c_gmpn_divrem_1 (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: POINTER; a_arg4: INTEGER_32; a_arg5: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_divrem_1($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5);"
		end

	gmpn_lshift (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_lshift (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_gmpn_lshift (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_lshift($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_rshift (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_rshift (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_gmpn_rshift (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_rshift($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_copyi (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32)
		do
			c_gmpn_copyi (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3)
		end

	c_gmpn_copyi (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32)
		external
			"C inline use <libgmp.h>"
		alias
			"__gmpn_copyi($a_arg1, $a_arg2, $a_arg3);"
		end

	gmpn_mul_1 (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_mul_1 (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_gmpn_mul_1 (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_mul_1($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_copyd (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32)
		do
			c_gmpn_copyd (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3)
		end

	c_gmpn_copyd (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32)
		external
			"C inline use <libgmp.h>"
		alias
			"__gmpn_copyd($a_arg1, $a_arg2, $a_arg3);"
		end

	gmpn_addmul_1 (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_addmul_1 (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_gmpn_addmul_1 (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_addmul_1($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_submul_1 (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_submul_1 (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_gmpn_submul_1 (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_submul_1($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_hamdist (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32): NATURAL_32
		do
			Result := c_gmpn_hamdist (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3)
		end

	c_gmpn_hamdist (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_hamdist($a_arg1, $a_arg2, $a_arg3);"
		end

	gmpn_divrem_2 (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32; a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32; a_arg5: CE_POINTER [NATURAL_32]): NATURAL_32
		do
			Result := c_gmpn_divrem_2 (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4, a_arg5.c_pointer)
		end

	c_gmpn_divrem_2 (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: POINTER; a_arg4: INTEGER_32; a_arg5: POINTER): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_divrem_2($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5);"
		end

end
