class
	P_HGCD

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_hgcd_matrix_init (a_M: CE_POINTER [PD_HGCD_MATRIX]; a_n: INTEGER_32; a_p: CE_POINTER [NATURAL_32])
		local
			l_s: INTEGER_32
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_32]
			l_tmp___0: NATURAL_32
			js: JUMP_STATE
		do
			create l_dst.make
			create l_tmp.make

			l_s := (a_n + 1) // 2 + 1
			a_M.item.alloc := l_s
			a_M.item.n := (1).to_integer_32
			from
			until
				js.loop_left
			loop
				js.reset
				if 4 * l_s /= 0 then
					l_dst.ce_gets (a_p)
					l_n := 4 * l_s
					from
					until
						js.loop_left
					loop
						js.reset
						l_tmp.ce_gets (l_dst)
						l_dst.ce_gets (l_dst + 1)
						l_tmp.item := (0).to_natural_32
						l_n := l_n - 1
						if not l_n.to_boolean then
							js.break
						end
					end
					js.reset
				end
				js.break
			end
			js.reset;
			(a_M.item.p[0])[0] := a_p;
			(a_M.item.p[0])[1] := a_p + l_s;
			(a_M.item.p[1])[0] := a_p + 2 * l_s;
			(a_M.item.p[1])[1] := a_p + 3 * l_s
			l_tmp___0 := (1).to_natural_32;
			((a_M.item.p[1])[1])[0] := l_tmp___0;
			((a_M.item.p[0])[0])[0] := l_tmp___0
		end

	hgcd_matrix_update_1 (a_M: CE_POINTER [PD_HGCD_MATRIX]; a_col: NATURAL_32)
		local
			l_c0: NATURAL_32
			l_c1: NATURAL_32
		do
			l_c0 := gmp_inst.gmpn_add_n ((a_M.item.p[0])[a_col.to_integer_32], (a_M.item.p[0])[0], (a_M.item.p[0])[1], a_M.item.n)
			l_c1 := gmp_inst.gmpn_add_n ((a_M.item.p[1])[a_col.to_integer_32], (a_M.item.p[1])[0], (a_M.item.p[1])[1], a_M.item.n);
			((a_M.item.p[0])[a_col.to_integer_32])[a_M.item.n] := l_c0;
			((a_M.item.p[1])[a_col.to_integer_32])[a_M.item.n] := l_c1
			a_M.item.n := a_M.item.n + (((l_c0).bit_or (l_c1)) /= {NATURAL_32} 0).to_integer
		end

	hgcd_matrix_update_q (a_M: CE_POINTER [PD_HGCD_MATRIX]; a_qp: CE_POINTER [NATURAL_32]; a_qn: INTEGER_32; a_col: NATURAL_32; a_tp: CE_POINTER [NATURAL_32])
		local
			l_q: NATURAL_32
			l_c0: NATURAL_32
			l_c1: NATURAL_32
			l_row: NATURAL_32
			l_c: CE_ARRAY [NATURAL_32]
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			create l_c.make (<<2>>)

			if a_qn = 1 then
				l_q := a_qp[0]
				l_c0 := gmp_inst.gmpn_addmul_1 ((a_M.item.p[0])[a_col.to_integer_32], (a_M.item.p[0])[({NATURAL_32} 1 - a_col).to_integer_32], a_M.item.n, l_q)
				l_c1 := gmp_inst.gmpn_addmul_1 ((a_M.item.p[1])[a_col.to_integer_32], (a_M.item.p[1])[({NATURAL_32} 1 - a_col).to_integer_32], a_M.item.n, l_q);
				((a_M.item.p[0])[a_col.to_integer_32])[a_M.item.n] := l_c0;
				((a_M.item.p[1])[a_col.to_integer_32])[a_M.item.n] := l_c1
				a_M.item.n := a_M.item.n + (((l_c0).bit_or (l_c1)) /= {NATURAL_32} 0).to_integer
			else
				l_n := a_M.item.n
				from
				until
					not (not js.loop_left and then (l_n + a_qn > a_M.item.n))
				loop
					js.reset
					if ((a_M.item.p[0])[({NATURAL_32} 1 - a_col).to_integer_32])[(l_n - 1)] > {NATURAL_32} 0 then
						js.break
					elseif ((a_M.item.p[1])[({NATURAL_32} 1 - a_col).to_integer_32])[(l_n - 1)] > {NATURAL_32} 0 then
						js.break
					end
					if not js.loop_jumped then
						l_n := l_n - 1
					end
				end
				js.reset
				l_row := {NATURAL_32} 0
				from
				until
					not (not js.loop_left and then (l_row < {NATURAL_32} 2))
				loop
					if a_qn <= l_n then
						mul_inst.gmpn_mul (a_tp, (a_M.item.p[l_row.to_integer_32])[({NATURAL_32} 1 - a_col).to_integer_32], l_n, a_qp, a_qn).do_nothing
					else
						mul_inst.gmpn_mul (a_tp, a_qp, a_qn, (a_M.item.p[l_row.to_integer_32])[({NATURAL_32} 1 - a_col).to_integer_32], l_n).do_nothing
					end
					l_c[l_row.to_integer_32] := gmp_inst.gmpn_add ((a_M.item.p[l_row.to_integer_32])[a_col.to_integer_32], a_tp, l_n + a_qn, (a_M.item.p[l_row.to_integer_32])[a_col.to_integer_32], a_M.item.n)
					l_row := l_row + 1
				end
				if ((l_c[0]).bit_or (l_c[1])).to_boolean then
					a_M.item.n := (l_n + a_qn) + 1;
					((a_M.item.p[0])[a_col.to_integer_32])[(l_n - 1)] := l_c[0];
					((a_M.item.p[1])[a_col.to_integer_32])[(l_n - 1)] := l_c[1]
				else
					l_n := l_n + a_qn
					l_n := l_n - (((((a_M.item.p[0])[a_col.to_integer_32])[(l_n - 1)]).bit_or (((a_M.item.p[1])[a_col.to_integer_32])[(l_n - 1)])) = {NATURAL_32} 0).to_integer
					if l_n > a_M.item.n then
						a_M.item.n := l_n
					end
				end
			end
		end

	hgcd_matrix_mul_1 (a_M: CE_POINTER [PD_HGCD_MATRIX]; a_M1: CE_POINTER [PD_HGCD_MATRIX1]; a_tp: CE_POINTER [NATURAL_32])
		local
			l_n0: INTEGER_32
			l_n1: INTEGER_32
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					gmp_inst.gmpn_copyi (a_tp, (a_M.item.p[0])[0], a_M.item.n)
					js.break
				end
				js.reset
				js.break
			end
			js.reset
			l_n0 := hgcd2_inst.gmpn_hgcd_mul_matrix1_vector (a_M1, (a_M.item.p[0])[0], a_tp, (a_M.item.p[0])[1], a_M.item.n)
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					gmp_inst.gmpn_copyi (a_tp, (a_M.item.p[1])[0], a_M.item.n)
					js.break
				end
				js.reset
				js.break
			end
			js.reset
			l_n1 := hgcd2_inst.gmpn_hgcd_mul_matrix1_vector (a_M1, (a_M.item.p[1])[0], a_tp, (a_M.item.p[1])[1], a_M.item.n)
			if l_n0 > l_n1 then
				a_M.item.n := l_n0
			else
				a_M.item.n := l_n1
			end
		end

	hgcd_step (a_n: INTEGER_32; a_ap: CE_POINTER [NATURAL_32]; a_bp: CE_POINTER [NATURAL_32]; a_s: INTEGER_32; a_M: CE_POINTER [PD_HGCD_MATRIX]; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_ap: CE_POINTER [NATURAL_32]
			l_bp: CE_POINTER [NATURAL_32]
			l_M1: PD_HGCD_MATRIX1
			l_mask: NATURAL_32
			l_ah: NATURAL_32
			l_al: NATURAL_32
			l_bh: NATURAL_32
			l_bl: NATURAL_32
			l_an: INTEGER_32
			l_bn: INTEGER_32
			l_qn: INTEGER_32
			l_col: INTEGER_32
			l_shift: INTEGER_32
			l_mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l_k: INTEGER_32
			l_c: INTEGER_32
			l_gmp_i: INTEGER_32
			l_gmp_x: NATURAL_32
			l_gmp_y: NATURAL_32
			l_cy: NATURAL_32
			l_mp_ptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			l_mp_size_t_swap__tmp: INTEGER_32
			l_c___0: INTEGER_32
			l_gmp_i___0: INTEGER_32
			l_gmp_x___0: NATURAL_32
			l_gmp_y___0: NATURAL_32
			l_mp_ptr_swap__tmp___1: CE_POINTER [NATURAL_32]
			l_cy___0: NATURAL_32
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ap.make
			create l_bp.make
			create l_M1.make
			create l_mp_ptr_swap__tmp.make
			create l_mp_ptr_swap__tmp___0.make
			create l_mp_ptr_swap__tmp___1.make
			create l_ptr_dummy.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ap.ce_gets (a_ap)
					l_bp.ce_gets (a_bp)
					l_mask := (l_ap[(a_n - 1)]).bit_or (l_bp[(a_n - 1)])
					if a_n /= a_s + 1 then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						if l_mask < {NATURAL_32} 4 then
							l_pos := -1 + 6 -- goto subtract
						end
				when 2 then
						l_ah := l_ap[(a_n - 1)]
						l_al := l_ap[(a_n - 2)]
						l_bh := l_bp[(a_n - 1)]
						l_bl := l_bp[(a_n - 2)]
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else:
						if ((l_mask).bit_and ((({NATURAL_32} 1).bit_shift_left (31)))).to_boolean then
							l_ah := l_ap[(a_n - 1)]
							l_al := l_ap[(a_n - 2)]
							l_bh := l_bp[(a_n - 1)]
							l_bl := l_bp[(a_n - 2)]
						else
							from
							until
								js.loop_left
							loop
								js.reset
								l_shift := builtin_clzl (l_mask)
								js.break
							end
							js.reset
							l_ah := (((((l_ap[(a_n - 1)]).bit_shift_left (l_shift))).bit_and ({NATURAL_32} 4294967295))).bit_or (((l_ap[(a_n - 2)]).bit_shift_right ((32 - l_shift))))
							l_al := (((((l_ap[(a_n - 2)]).bit_shift_left (l_shift))).bit_and ({NATURAL_32} 4294967295))).bit_or (((l_ap[(a_n - 3)]).bit_shift_right ((32 - l_shift))))
							l_bh := (((((l_bp[(a_n - 1)]).bit_shift_left (l_shift))).bit_and ({NATURAL_32} 4294967295))).bit_or (((l_bp[(a_n - 2)]).bit_shift_right ((32 - l_shift))))
							l_bl := (((((l_bp[(a_n - 2)]).bit_shift_left (l_shift))).bit_and ({NATURAL_32} 4294967295))).bit_or (((l_bp[(a_n - 3)]).bit_shift_right ((32 - l_shift))))
						end
				when 5 then -- if done
					if (hgcd2_inst.gmpn_hgcd2 (l_ah, l_al, l_bh, l_bl, l_M1.address)).to_boolean then
						hgcd_matrix_mul_1 (a_M, (l_M1.address), a_tp)
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (a_tp, l_ap, a_n)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						Result := (hgcd2_inst.gmpn_hgcd_mul_matrix1_inverse_vector ((l_M1.address), l_ap, a_tp, l_bp, a_n))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 6 then -- if: | subtract:
						l_an := a_n
						from
						until
							not (not js.loop_left and then (l_an > a_s))
						loop
							js.reset
							if l_ap[(l_an - 1)] /= l_bp[(l_an - 1)] then
								js.break
							end
							if not js.loop_jumped then
								l_an := l_an - 1
							end
						end
						js.reset
						if l_an = a_s then
							Result := (0).to_integer_32
							js.return
						end
				when 7 then -- if done
					if not js.return_called then
						if l_ap[(l_an - 1)] > l_bp[(l_an - 1)] then
							l_col := 1
						else
							from
							until
								js.loop_left
							loop
								js.reset
								l_mp_ptr_swap__tmp.ce_gets (l_ap)
								l_ap.ce_gets (l_bp)
								l_bp.ce_gets (l_mp_ptr_swap__tmp)
								js.break
							end
							js.reset
							l_col := 0
						end
						l_bn := a_n
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								not (not js.loop_left and then (l_bn > 0))
							loop
								js.reset
								if l_bp[(l_bn - 1)] /= {NATURAL_32} 0 then
									js.break
								end
								if not js.loop_jumped then
									l_bn := l_bn - 1
								end
							end
							js.reset
							js.break
						end
						js.reset
						if l_bn <= a_s then
							Result := (0).to_integer_32
							js.return
						end
					end
					if not js.return_called then
						if l_ap[(l_an - 1)] = l_bp[(l_an - 1)] + {NATURAL_32} 1 then
							l_k := l_an - 1
							from
							until
								not (not js.loop_left and then (l_k > a_s))
							loop
								js.reset
								if l_ap[(l_k - 1)] /= {NATURAL_32} 0 then
									js.break
								elseif l_bp[(l_k - 1)] /= {NATURAL_32} 4294967295 then
									js.break
								end
								if not js.loop_jumped then
									l_k := l_k - 1
								end
							end
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								l_c := 0
								l_gmp_i := l_k
								from
								until
									js.loop_left
								loop
									js.reset
									l_gmp_i := l_gmp_i - 1
									if not (l_gmp_i >= 0) then
										js.break
									end
									if not js.loop_jumped then
										l_gmp_x := l_ap[l_gmp_i]
										l_gmp_y := l_bp[l_gmp_i]
										if l_gmp_x /= l_gmp_y then
											if l_gmp_x > l_gmp_y then
												l_c := 1
											else
												l_c := -1
											end
											js.break
										end
									end
								end
								js.reset
								js.break
							end
							js.reset
							if l_c < 0 then
								if l_k = a_s then
									Result := (0).to_integer_32
									js.return
								end
								if not js.return_called then
									l_cy := gmp_inst.gmpn_sub_n (l_ap, l_ap, l_bp, l_k)
									l_an := l_k
								end
							else
								gmp_inst.gmpn_sub_n (l_ap, l_ap, l_bp, l_k).do_nothing
								l_ap[l_k] := (1).to_natural_32
								l_an := l_k + 1
							end
						else
							gmp_inst.gmpn_sub_n (l_ap, l_ap, l_bp, l_an).do_nothing
						end
					end
					if not js.return_called then
						hgcd_matrix_update_1 (a_M, l_col.to_natural_32)
						if l_an < l_bn then
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									l_mp_ptr_swap__tmp___0.ce_gets (l_ap)
									l_ap.ce_gets (l_bp)
									l_bp.ce_gets (l_mp_ptr_swap__tmp___0)
									js.break
								end
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									l_mp_size_t_swap__tmp := l_an
									l_an := l_bn
									l_bn := l_mp_size_t_swap__tmp
									js.break
								end
								js.reset
								js.break
							end
							js.reset
							l_col := (l_col).bit_xor ((1))
						elseif l_an = l_bn then
							from
							until
								js.loop_left
							loop
								js.reset
								l_c___0 := 0
								l_gmp_i___0 := l_an
								from
								until
									js.loop_left
								loop
									js.reset
									l_gmp_i___0 := l_gmp_i___0 - 1
									if not (l_gmp_i___0 >= 0) then
										js.break
									end
									if not js.loop_jumped then
										l_gmp_x___0 := l_ap[l_gmp_i___0]
										l_gmp_y___0 := l_bp[l_gmp_i___0]
										if l_gmp_x___0 /= l_gmp_y___0 then
											if l_gmp_x___0 > l_gmp_y___0 then
												l_c___0 := 1
											else
												l_c___0 := -1
											end
											js.break
										end
									end
								end
								js.reset
								js.break
							end
							js.reset
							if l_c___0 < 0 then
								from
								until
									js.loop_left
								loop
									js.reset
									l_mp_ptr_swap__tmp___1.ce_gets (l_ap)
									l_ap.ce_gets (l_bp)
									l_bp.ce_gets (l_mp_ptr_swap__tmp___1)
									js.break
								end
								js.reset
								l_col := (l_col).bit_xor ((1))
							end
						end
						l_qn := (l_an + 1) - l_bn
						tdiv_qr_inst.gmpn_tdiv_qr (a_tp, l_ap, (0).to_integer_32, l_ap, l_an, l_bp, l_bn)
						l_qn := l_qn - (a_tp[(l_qn - 1)] = {NATURAL_32} 0).to_integer
						l_an := l_bn
						from
						until
							not (not js.loop_left and then (l_an > a_s))
						loop
							js.reset
							if l_ap[(l_an - 1)] > {NATURAL_32} 0 then
								js.break
							end
							if not js.loop_jumped then
								l_an := l_an - 1
							end
						end
						js.reset
						if l_an <= a_s then
							l_cy___0 := gmp_inst.gmpn_add (l_ap, l_bp, l_bn, l_ap, l_an)
							if l_cy___0 > {NATURAL_32} 0 then
								l_ap[l_bn] := l_cy___0
								l_bp[l_bn] := (0).to_natural_32
								l_bn := l_bn + 1
							end
							from
							until
								js.loop_left
							loop
								js.reset
								asm130 (l_ptr_dummy.address, a_tp.address)
								js.break
							end
							js.reset
							l_qn := l_qn - (a_tp[(l_qn - 1)] = {NATURAL_32} 0).to_integer
						end
						if l_qn > 0 then
							hgcd_matrix_update_q (a_M, a_tp, l_qn, l_col.to_natural_32, a_tp + l_qn)
						end
						Result := l_bn
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_hgcd_lehmer (a_ap: CE_POINTER [NATURAL_32]; a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_M: CE_POINTER [PD_HGCD_MATRIX]; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			l_nn: INTEGER_32
			js: JUMP_STATE
		do
			l_n := a_n
			l_s := l_n // 2 + 1
			l_nn := hgcd_step (l_n, a_ap, a_bp, l_s, a_M, a_tp)
			if not l_nn.to_boolean then
				Result := (0).to_integer_32
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					l_n := l_nn
					l_nn := hgcd_step (l_n, a_ap, a_bp, l_s, a_M, a_tp)
					if not l_nn.to_boolean then
						Result := l_n
						js.return
					end
				end
			end
		end

	gmpn_hgcd_matrix_mul (a_M: CE_POINTER [PD_HGCD_MATRIX]; a_M1: CE_POINTER [PD_HGCD_MATRIX]; a_tp: CE_POINTER [NATURAL_32])
		local
			l_n: INTEGER_32
		do
			matrix22_mul_inst.gmpn_matrix22_mul ((a_M.item.p[0])[0], (a_M.item.p[0])[1], (a_M.item.p[1])[0], (a_M.item.p[1])[1], a_M.item.n, (a_M1.item.p[0])[0], (a_M1.item.p[0])[1], (a_M1.item.p[1])[0], (a_M1.item.p[1])[1], a_M1.item.n, a_tp)
			l_n := a_M.item.n + a_M1.item.n
			l_n := l_n - (((((((((a_M.item.p[0])[0])[l_n]).bit_or (((a_M.item.p[0])[1])[l_n]))).bit_or (((a_M.item.p[1])[0])[l_n]))).bit_or (((a_M.item.p[1])[1])[l_n])) = {NATURAL_32} 0).to_integer
			l_n := l_n - (((((((((a_M.item.p[0])[0])[l_n]).bit_or (((a_M.item.p[0])[1])[l_n]))).bit_or (((a_M.item.p[1])[0])[l_n]))).bit_or (((a_M.item.p[1])[1])[l_n])) = {NATURAL_32} 0).to_integer
			l_n := l_n - (((((((((a_M.item.p[0])[0])[l_n]).bit_or (((a_M.item.p[0])[1])[l_n]))).bit_or (((a_M.item.p[1])[0])[l_n]))).bit_or (((a_M.item.p[1])[1])[l_n])) = {NATURAL_32} 0).to_integer
			a_M.item.n := l_n + 1
		end

	gmpn_hgcd_matrix_adjust (a_M: CE_POINTER [PD_HGCD_MATRIX]; a_n: INTEGER_32; a_ap: CE_POINTER [NATURAL_32]; a_bp: CE_POINTER [NATURAL_32]; a_p: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_n: INTEGER_32
			l_t0: CE_POINTER [NATURAL_32]
			l_t1: CE_POINTER [NATURAL_32]
			l_ah: NATURAL_32
			l_bh: NATURAL_32
			l_cy: NATURAL_32
			js: JUMP_STATE
		do
			create l_t0.make
			create l_t1.make

			l_n := a_n
			l_t0.ce_gets (a_tp)
			l_t1.ce_gets ((a_tp + a_p) + a_M.item.n)
			if a_M.item.n >= a_p then
				mul_inst.gmpn_mul (l_t0, (a_M.item.p[1])[1], a_M.item.n, a_ap, a_p).do_nothing
				mul_inst.gmpn_mul (l_t1, (a_M.item.p[1])[0], a_M.item.n, a_ap, a_p).do_nothing
			else
				mul_inst.gmpn_mul (l_t0, a_ap, a_p, (a_M.item.p[1])[1], a_M.item.n).do_nothing
				mul_inst.gmpn_mul (l_t1, a_ap, a_p, (a_M.item.p[1])[0], a_M.item.n).do_nothing
			end
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					gmp_inst.gmpn_copyi (a_ap, l_t0, a_p)
					js.break
				end
				js.reset
				js.break
			end
			js.reset
			l_ah := gmp_inst.gmpn_add (a_ap + a_p, (a_ap + a_p), l_n - a_p, (l_t0 + a_p), a_M.item.n)
			if a_M.item.n >= a_p then
				mul_inst.gmpn_mul (l_t0, (a_M.item.p[0])[1], a_M.item.n, a_bp, a_p).do_nothing
			else
				mul_inst.gmpn_mul (l_t0, a_bp, a_p, (a_M.item.p[0])[1], a_M.item.n).do_nothing
			end
			l_cy := gmp_inst.gmpn_sub (a_ap, a_ap, l_n, l_t0, a_p + a_M.item.n)
			l_ah := l_ah - l_cy
			if a_M.item.n >= a_p then
				mul_inst.gmpn_mul (l_t0, (a_M.item.p[0])[0], a_M.item.n, a_bp, a_p).do_nothing
			else
				mul_inst.gmpn_mul (l_t0, a_bp, a_p, (a_M.item.p[0])[0], a_M.item.n).do_nothing
			end
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					gmp_inst.gmpn_copyi (a_bp, l_t0, a_p)
					js.break
				end
				js.reset
				js.break
			end
			js.reset
			l_bh := gmp_inst.gmpn_add (a_bp + a_p, (a_bp + a_p), l_n - a_p, (l_t0 + a_p), a_M.item.n)
			l_cy := gmp_inst.gmpn_sub (a_bp, a_bp, l_n, l_t1, a_p + a_M.item.n)
			l_bh := l_bh - l_cy
			if l_ah > {NATURAL_32} 0 then
				a_ap[l_n] := l_ah
				a_bp[l_n] := l_bh
				l_n := l_n + 1
			elseif l_bh > {NATURAL_32} 0 then
				a_ap[l_n] := l_ah
				a_bp[l_n] := l_bh
				l_n := l_n + 1
			elseif a_ap[(l_n - 1)] = {NATURAL_32} 0 then
				if a_bp[(l_n - 1)] = {NATURAL_32} 0 then
					l_n := l_n - 1
				end
			end
			Result := l_n
		end

	gmpn_hgcd_itch (a_n: INTEGER_32): INTEGER_32
		local
			l_k: NATURAL_32
			l_count: INTEGER_32
			l_nscaled: INTEGER_32
			js: JUMP_STATE
		do
			if 60 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
				if not (a_n >= 60) then
					Result := a_n
					js.return
				end
			else
				Result := a_n
				js.return
			end
			if not js.return_called then
				l_nscaled := (a_n - 1) // 59
				from
				until
					js.loop_left
				loop
					js.reset
					l_count := builtin_clzl (l_nscaled.to_natural_32)
					js.break
				end
				js.reset
				l_k := (32 - l_count).to_natural_32
				Result := (((20 * ((a_n + 3) // 4)).to_natural_32 + ({NATURAL_32} 22 * l_k).to_natural_32) + {NATURAL_32} 60).to_integer_32
			end
		end

	gmpn_hgcd (a_ap: CE_POINTER [NATURAL_32]; a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_M: CE_POINTER [PD_HGCD_MATRIX]; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			l_n2: INTEGER_32
			l_p: INTEGER_32
			l_nn: INTEGER_32
			l_success: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_M1: PD_HGCD_MATRIX
			l_scratch: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_M1.make

			l_n := a_n
			l_s := l_n // 2 + 1
			l_n2 := (3 * l_n) // 4 + 1
			l_success := 0
			if l_n <= l_s then
				Result := (0).to_integer_32
				js.return
			end
			if not js.return_called then
				if 60 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if not (l_n >= 60) then
						l_tmp := gmpn_hgcd_lehmer (a_ap, a_bp, l_n, a_M, a_tp)
						Result := l_tmp
						js.return
					end
				else
					l_tmp := gmpn_hgcd_lehmer (a_ap, a_bp, l_n, a_M, a_tp)
					Result := l_tmp
					js.return
				end
			end
			if not js.return_called then
				l_p := l_n // 2
				l_nn := gmpn_hgcd (a_ap + l_p, a_bp + l_p, l_n - l_p, a_M, a_tp)
				if l_nn > 0 then
					l_n := gmpn_hgcd_matrix_adjust (a_M, l_p + l_nn, a_ap, a_bp, l_p, a_tp)
					l_success := 1
				end
				from
				until
					not (not js.loop_left and then (l_n > l_n2))
				loop
					l_nn := hgcd_step (l_n, a_ap, a_bp, l_s, a_M, a_tp)
					if not l_nn.to_boolean then
						if l_success.to_boolean then
							l_tmp___0 := l_n
						else
							l_tmp___0 := (0).to_integer_32
						end
						Result := l_tmp___0
						js.return
					end
					if not js.return_called then
						l_n := l_nn
						l_success := 1
					end
				end
			end
			if not js.return_called then
				if l_n > l_s + 2 then
					l_p := (2 * l_s - l_n) + 1
					l_scratch := 4 * (((l_n - l_p) + 1) // 2 + 1)
					gmpn_hgcd_matrix_init (l_M1.address, l_n - l_p, a_tp)
					l_nn := gmpn_hgcd (a_ap + l_p, a_bp + l_p, l_n - l_p, l_M1.address, a_tp + l_scratch)
					if l_nn > 0 then
						l_n := gmpn_hgcd_matrix_adjust (l_M1.address, l_p + l_nn, a_ap, a_bp, l_p, a_tp + l_scratch)
						gmpn_hgcd_matrix_mul (a_M, (l_M1.address), a_tp + l_scratch)
						l_success := 1
					end
				end
				from
				until
					js.loop_left
				loop
					l_nn := hgcd_step (l_n, a_ap, a_bp, l_s, a_M, a_tp)
					if not l_nn.to_boolean then
						if l_success.to_boolean then
							l_tmp___1 := l_n
						else
							l_tmp___1 := (0).to_integer_32
						end
						Result := l_tmp___1
						js.return
					end
					if not js.return_called then
						l_n := l_nn
						l_success := 1
					end
				end
			end
		end

end
