class
	P_ISET

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_init_set (a_r: CE_POINTER [PD_MPF_STRUCT]; a_s: CE_POINTER [PD_MPF_STRUCT])
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_sp: CE_POINTER [NATURAL_32]
			l_ssize: INTEGER_32
			l_size: INTEGER_32
			l_prec: INTEGER_32
			js: JUMP_STATE
		do
			create l_rp.make
			create l_sp.make

			l_prec := set_dfl_prec_inst.gmp_default_fp_limb_precision
			a_r.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([((l_prec + 1) * 4).to_natural_32]))))
			a_r.item.mp_prec := l_prec.to_integer_32
			l_prec := l_prec + 1
			l_ssize := (a_s.item.mp_size).to_integer_32
			if l_ssize >= 0 then
				l_size := l_ssize
			else
				l_size := -l_ssize
			end
			l_rp.ce_gets (a_r.item.mp_d)
			l_sp.ce_gets (a_s.item.mp_d)
			if l_size > l_prec then
				l_sp.ce_gets (l_sp + (l_size - l_prec))
				l_size := l_prec
			end
			a_r.item.mp_exp := a_s.item.mp_exp
			if l_ssize >= 0 then
				a_r.item.mp_size := l_size.to_integer_32
			else
				a_r.item.mp_size := (-l_size).to_integer_32
			end
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					gmp_inst.gmpn_copyi (l_rp, l_sp, l_size)
					js.break
				end
				js.reset
				js.break
			end
			js.reset
		end

	gmpz_init_set (a_w: CE_POINTER [PD_MPZ_STRUCT]; a_u: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_wp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_size: INTEGER_32
			js: JUMP_STATE
		do
			create l_wp.make
			create l_up.make

			l_usize := (a_u.item.mp_size).to_integer_32
			if l_usize >= 0 then
				l_size := l_usize
			else
				l_size := -l_usize
			end
			if l_size > 1 then
				a_w.item.mp_alloc := l_size.to_integer_32
			else
				a_w.item.mp_alloc := 1
			end
			a_w.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([(a_w.item.mp_alloc * 4).to_natural_32]))))
			l_wp.ce_gets (a_w.item.mp_d)
			l_up.ce_gets (a_u.item.mp_d)
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					gmp_inst.gmpn_copyi (l_wp, l_up, l_size)
					js.break
				end
				js.reset
				js.break
			end
			js.reset
			a_w.item.mp_size := l_usize.to_integer_32
		end

end
