class
	P_LCM_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_lcm_ui (a_r: CE_POINTER [PD_MPZ_STRUCT]; a_u: CE_POINTER [PD_MPZ_STRUCT]; a_v: NATURAL_32)
		local
			l_v: NATURAL_32
			l_usize: INTEGER_32
			l_up: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_g: NATURAL_32
			l_c: NATURAL_32
			js: JUMP_STATE
		do
			create l_up.make
			create l_rp.make

			l_v := a_v
			l_usize := (a_u.item.mp_size).to_integer_32
			if l_usize = 0 then
				a_r.item.mp_size := 0
				js.return
			elseif l_v = {NATURAL_32} 0 then
				a_r.item.mp_size := 0
				js.return
			end
			if not js.return_called then
				if l_usize >= 0 then
					l_usize := l_usize
				else
					l_usize := -l_usize
				end
				if (builtin_expect ((l_usize + 1 > (a_r.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					realloc_inst.gmpz_realloc (a_r, l_usize + 1).do_nothing
				end
				l_up.ce_gets (a_u.item.mp_d)
				l_g := (gcd_1_inst.gmpn_gcd_1 (l_up, l_usize, l_v))
				l_v := l_v // l_g
				l_rp.ce_gets (a_r.item.mp_d)
				l_c := gmp_inst.gmpn_mul_1 (l_rp, l_up, l_usize, l_v)
				l_rp[l_usize] := l_c
				l_usize := l_usize + (l_c /= {NATURAL_32} 0).to_integer
				a_r.item.mp_size := l_usize.to_integer_32
			end
		end

end
