class
	P_MATRIX22_MUL

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	abs_sub_n (a_rp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32): INTEGER_32
		local
			l_c: INTEGER_32
			l_gmp_i: INTEGER_32
			l_gmp_x: NATURAL_32
			l_gmp_y: NATURAL_32
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				l_c := 0
				l_gmp_i := a_n
				from
				until
					js.loop_left
				loop
					js.reset
					l_gmp_i := l_gmp_i - 1
					if not (l_gmp_i >= 0) then
						js.break
					end
					if not js.loop_jumped then
						l_gmp_x := a_ap[l_gmp_i]
						l_gmp_y := a_bp[l_gmp_i]
						if l_gmp_x /= l_gmp_y then
							if l_gmp_x > l_gmp_y then
								l_c := 1
							else
								l_c := -1
							end
							js.break
						end
					end
				end
				js.reset
				js.break
			end
			js.reset
			if l_c >= 0 then
				gmp_inst.gmpn_sub_n (a_rp, a_ap, a_bp, a_n).do_nothing
				Result := 0
			else
				gmp_inst.gmpn_sub_n (a_rp, a_bp, a_ap, a_n).do_nothing
				Result := 1
			end
		end

	add_signed_n (a_rp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_as: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_bs: INTEGER_32; a_n: INTEGER_32): INTEGER_32
		do
			if a_as /= a_bs then
				Result := ((a_as).bit_xor ((abs_sub_n (a_rp, a_ap, a_bp, a_n))))
			else
				gmp_inst.gmpn_add_n (a_rp, a_ap, a_bp, a_n).do_nothing
				Result := a_as
			end
		end

	gmpn_matrix22_mul_itch (a_rn: INTEGER_32; a_mn: INTEGER_32): INTEGER_32
		do
			if 17 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
				if a_rn >= 17 then
					if 17 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
						if a_mn >= 17 then
							Result := (3 * (a_rn + a_mn) + 5)
						else
							Result := (3 * a_rn + 2 * a_mn)
						end
					else
						Result := (3 * a_rn + 2 * a_mn)
					end
				else
					Result := (3 * a_rn + 2 * a_mn)
				end
			else
				Result := (3 * a_rn + 2 * a_mn)
			end
		end

	gmpn_matrix22_mul_strassen (a_r0: CE_POINTER [NATURAL_32]; a_r1: CE_POINTER [NATURAL_32]; a_r2: CE_POINTER [NATURAL_32]; a_r3: CE_POINTER [NATURAL_32]; a_rn: INTEGER_32; a_m0: CE_POINTER [NATURAL_32]; a_m1: CE_POINTER [NATURAL_32]; a_m2: CE_POINTER [NATURAL_32]; a_m3: CE_POINTER [NATURAL_32]; a_mn: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		local
			l_rn: INTEGER_32
			l_mn: INTEGER_32
			l_tp: CE_POINTER [NATURAL_32]
			l_s0: CE_POINTER [NATURAL_32]
			l_t0: CE_POINTER [NATURAL_32]
			l_u0: CE_POINTER [NATURAL_32]
			l_u1: CE_POINTER [NATURAL_32]
			l_r1s: INTEGER_32
			l_r3s: INTEGER_32
			l_s0s: INTEGER_32
			l_t0s: INTEGER_32
			l_u1s: INTEGER_32
			js: JUMP_STATE
		do
			create l_tp.make
			create l_s0.make
			create l_t0.make
			create l_u0.make
			create l_u1.make

			l_rn := a_rn
			l_mn := a_mn
			l_tp.ce_gets (a_tp)
			l_s0.ce_gets (l_tp)
			l_tp.ce_gets (l_tp + (l_rn + 1))
			l_t0.ce_gets (l_tp)
			l_tp.ce_gets (l_tp + (l_mn + 1))
			l_u0.ce_gets (l_tp)
			l_tp.ce_gets (l_tp + ((l_rn + l_mn) + 1))
			l_u1.ce_gets (l_tp)
			from
			until
				js.loop_left
			loop
				js.reset
				if l_rn >= l_mn then
					mul_inst.gmpn_mul (l_u0, a_r1, l_rn, a_m2, l_mn).do_nothing
				else
					mul_inst.gmpn_mul (l_u0, a_m2, l_mn, a_r1, l_rn).do_nothing
				end
				js.break
			end
			js.reset
			l_r3s := abs_sub_n (a_r3, a_r3, a_r2, l_rn)
			if l_r3s.to_boolean then
				l_r1s := abs_sub_n (a_r1, a_r1, a_r3, l_rn)
				a_r1[l_rn] := (0).to_natural_32
			else
				a_r1[l_rn] := gmp_inst.gmpn_add_n (a_r1, a_r1, a_r3, l_rn)
				l_r1s := 0
			end
			if l_r1s.to_boolean then
				l_s0[l_rn] := gmp_inst.gmpn_add_n (l_s0, a_r1, a_r0, l_rn)
				l_s0s := 0
			elseif a_r1[l_rn] /= {NATURAL_32} 0 then
				l_s0[l_rn] := a_r1[l_rn] - (gmp_inst.gmpn_sub_n (l_s0, a_r1, a_r0, l_rn))
				l_s0s := 1
			else
				l_s0s := abs_sub_n (l_s0, a_r0, a_r1, l_rn)
				l_s0[l_rn] := (0).to_natural_32
			end
			from
			until
				js.loop_left
			loop
				js.reset
				if l_rn >= l_mn then
					mul_inst.gmpn_mul (l_u1, a_r0, l_rn, a_m0, l_mn).do_nothing
				else
					mul_inst.gmpn_mul (l_u1, a_m0, l_mn, a_r0, l_rn).do_nothing
				end
				js.break
			end
			js.reset
			a_r0[(l_rn + l_mn)] := gmp_inst.gmpn_add_n (a_r0, l_u0, l_u1, l_rn + l_mn)
			l_t0s := abs_sub_n (l_t0, a_m3, a_m2, l_mn)
			l_u1s := (((l_r3s).bit_xor (l_t0s))).bit_xor (1)
			from
			until
				js.loop_left
			loop
				js.reset
				if l_rn >= l_mn then
					mul_inst.gmpn_mul (l_u1, a_r3, l_rn, l_t0, l_mn).do_nothing
				else
					mul_inst.gmpn_mul (l_u1, l_t0, l_mn, a_r3, l_rn).do_nothing
				end
				js.break
			end
			js.reset
			l_u1[(l_rn + l_mn)] := (0).to_natural_32
			if l_t0s.to_boolean then
				l_t0s := abs_sub_n (l_t0, a_m1, l_t0, l_mn)
				l_t0[l_mn] := (0).to_natural_32
			else
				l_t0[l_mn] := gmp_inst.gmpn_add_n (l_t0, l_t0, a_m1, l_mn)
			end
			if l_t0[l_mn] /= {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					if l_rn >= l_mn + 1 then
						mul_inst.gmpn_mul (a_r3, a_r1, l_rn, l_t0, l_mn + 1).do_nothing
					else
						mul_inst.gmpn_mul (a_r3, l_t0, l_mn + 1, a_r1, l_rn).do_nothing
					end
					js.break
				end
				js.reset
				if a_r1[l_rn] /= {NATURAL_32} 0 then
					gmp_inst.gmpn_add_n (a_r3 + l_rn, (a_r3 + l_rn), l_t0, l_mn + 1).do_nothing
				end
			else
				from
				until
					js.loop_left
				loop
					js.reset
					if l_rn + 1 >= l_mn then
						mul_inst.gmpn_mul (a_r3, a_r1, l_rn + 1, l_t0, l_mn).do_nothing
					else
						mul_inst.gmpn_mul (a_r3, l_t0, l_mn, a_r1, l_rn + 1).do_nothing
					end
					js.break
				end
				js.reset
			end
			l_u0[(l_rn + l_mn)] := (0).to_natural_32
			if ((l_r1s).bit_xor (l_t0s)).to_boolean then
				l_r3s := abs_sub_n (a_r3, l_u0, a_r3, (l_rn + l_mn) + 1)
			else
				gmp_inst.gmpn_add_n (a_r3, a_r3, l_u0, (l_rn + l_mn) + 1).do_nothing
				l_r3s := 0
			end
			if l_t0s.to_boolean then
				l_t0[l_mn] := gmp_inst.gmpn_add_n (l_t0, l_t0, a_m0, l_mn)
			elseif l_t0[l_mn] /= {NATURAL_32} 0 then
				l_t0[l_mn] := l_t0[l_mn] - (gmp_inst.gmpn_sub_n (l_t0, l_t0, a_m0, l_mn))
			else
				l_t0s := abs_sub_n (l_t0, l_t0, a_m0, l_mn)
			end
			from
			until
				js.loop_left
			loop
				js.reset
				if l_rn >= l_mn + 1 then
					mul_inst.gmpn_mul (l_u0, a_r2, l_rn, l_t0, l_mn + 1).do_nothing
				else
					mul_inst.gmpn_mul (l_u0, l_t0, l_mn + 1, a_r2, l_rn).do_nothing
				end
				js.break
			end
			js.reset
			if l_r1s.to_boolean then
				gmp_inst.gmpn_sub_n (a_r1, a_r2, a_r1, l_rn).do_nothing
			else
				a_r1[l_rn] := a_r1[l_rn] + (gmp_inst.gmpn_add_n (a_r1, a_r1, a_r2, l_rn))
			end
			l_rn := l_rn + 1
			l_t0s := add_signed_n (a_r2, a_r3, l_r3s, l_u0, l_t0s, l_rn + l_mn)
			l_r3s := add_signed_n (a_r3, a_r3, l_r3s, l_u1, l_u1s, l_rn + l_mn)
			from
			until
				js.loop_left
			loop
				js.reset
				if l_rn >= l_mn then
					mul_inst.gmpn_mul (l_u0, l_s0, l_rn, a_m1, l_mn).do_nothing
				else
					mul_inst.gmpn_mul (l_u0, a_m1, l_mn, l_s0, l_rn).do_nothing
				end
				js.break
			end
			js.reset
			l_t0[l_mn] := gmp_inst.gmpn_add_n (l_t0, a_m3, a_m1, l_mn)
			from
			until
				js.loop_left
			loop
				js.reset
				if l_rn >= l_mn + 1 then
					mul_inst.gmpn_mul (l_u1, a_r1, l_rn, l_t0, l_mn + 1).do_nothing
				else
					mul_inst.gmpn_mul (l_u1, l_t0, l_mn + 1, a_r1, l_rn).do_nothing
				end
				js.break
			end
			js.reset
			l_mn := l_mn + l_rn
			add_signed_n (a_r1, a_r3, l_r3s, l_u0, l_s0s, l_mn).do_nothing
			if l_r3s.to_boolean then
				gmp_inst.gmpn_add_n (a_r3, l_u1, a_r3, l_mn).do_nothing
			else
				gmp_inst.gmpn_sub_n (a_r3, l_u1, a_r3, l_mn).do_nothing
			end
			if l_t0s.to_boolean then
				gmp_inst.gmpn_add_n (a_r2, l_u1, a_r2, l_mn).do_nothing
			else
				gmp_inst.gmpn_sub_n (a_r2, l_u1, a_r2, l_mn).do_nothing
			end
		end

	gmpn_matrix22_mul (a_r0: CE_POINTER [NATURAL_32]; a_r1: CE_POINTER [NATURAL_32]; a_r2: CE_POINTER [NATURAL_32]; a_r3: CE_POINTER [NATURAL_32]; a_rn: INTEGER_32; a_m0: CE_POINTER [NATURAL_32]; a_m1: CE_POINTER [NATURAL_32]; a_m2: CE_POINTER [NATURAL_32]; a_m3: CE_POINTER [NATURAL_32]; a_mn: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		local
			l_r0: CE_POINTER [NATURAL_32]
			l_r1: CE_POINTER [NATURAL_32]
			l_p0: CE_POINTER [NATURAL_32]
			l_p1: CE_POINTER [NATURAL_32]
			l_i: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_r0.make
			create l_r1.make
			create l_p0.make
			create l_p1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_r0.ce_gets (a_r0)
					l_r1.ce_gets (a_r1)
					if 17 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if not (a_rn >= 17) then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if 17 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if a_mn >= 17 then
							gmpn_matrix22_mul_strassen (l_r0, l_r1, a_r2, a_r3, a_rn, a_m0, a_m1, a_m2, a_m3, a_mn, a_tp)
						else
							l_pos := -1 + 5 -- goto _L___0
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L___0:
						l_p0.ce_gets (a_tp + a_rn)
						l_p1.ce_gets ((l_p0 + a_rn) + a_mn)
						l_i := {NATURAL_32} 0
						from
						until
							not (not js.loop_left and then (l_i < {NATURAL_32} 2))
						loop
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (a_tp, l_r0, a_rn)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
							if a_rn >= a_mn then
								mul_inst.gmpn_mul (l_p0, l_r0, a_rn, a_m0, a_mn).do_nothing
								mul_inst.gmpn_mul (l_p1, l_r1, a_rn, a_m3, a_mn).do_nothing
								mul_inst.gmpn_mul (l_r0, l_r1, a_rn, a_m2, a_mn).do_nothing
								mul_inst.gmpn_mul (l_r1, a_tp, a_rn, a_m1, a_mn).do_nothing
							else
								mul_inst.gmpn_mul (l_p0, a_m0, a_mn, l_r0, a_rn).do_nothing
								mul_inst.gmpn_mul (l_p1, a_m3, a_mn, l_r1, a_rn).do_nothing
								mul_inst.gmpn_mul (l_r0, a_m2, a_mn, l_r1, a_rn).do_nothing
								mul_inst.gmpn_mul (l_r1, a_m1, a_mn, a_tp, a_rn).do_nothing
							end
							l_r0[(a_rn + a_mn)] := gmp_inst.gmpn_add_n (l_r0, l_r0, l_p0, a_rn + a_mn)
							l_r1[(a_rn + a_mn)] := gmp_inst.gmpn_add_n (l_r1, l_r1, l_p1, a_rn + a_mn)
							l_r0.ce_gets (a_r2)
							l_r1.ce_gets (a_r3)
							l_i := l_i + 1
						end
				when 6 then -- if done | if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_pos := -1 + 5 -- goto _L___0
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_pos := -1 + 5 -- goto _L___0
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
