class
	P_MILLERRABIN

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_millerrabin (a_n: CE_POINTER [PD_MPZ_STRUCT]; a_reps: INTEGER_32): INTEGER_32
		local
			l_r: INTEGER_32
			l_nm1: CE_ARRAY [PD_MPZ_STRUCT]
			l_nm3: CE_ARRAY [PD_MPZ_STRUCT]
			l_x___2: CE_ARRAY [PD_MPZ_STRUCT]
			l_y: CE_ARRAY [PD_MPZ_STRUCT]
			l_q: CE_ARRAY [PD_MPZ_STRUCT]
			l_k: NATURAL_32
			l_rstate: CE_ARRAY [PD_GMP_RANDSTATE_STRUCT]
			l_is_prime: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___2: CE_POINTER [ANY]
			l_x___0: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___7: CE_POINTER [ANY]
			l_x___1: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___12: CE_POINTER [ANY]
			l_x___22: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___20: CE_POINTER [ANY]
			l_x___3: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___25: CE_POINTER [ANY]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_nm1.make (<<1>>)
			create l_nm3.make (<<1>>)
			create l_x___2.make (<<1>>)
			create l_y.make (<<1>>)
			create l_q.make (<<1>>)
			create l_rstate.make (<<1>>)
			create l_tmp_marker.make
			create l_x.make
			create l_tmp___2.make
			create l_x___0.make
			create l_tmp___7.make
			create l_x___1.make
			create l_tmp___12.make
			create l_x___22.make
			create l_tmp___20.make
			create l_x___3.make
			create l_tmp___25.make

			l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
			from
			until
				js.loop_left
			loop
				js.reset
				l_x.ce_gets (l_nm1)
				l_x.item.mp_alloc := (a_n.item.mp_size + 1)
				if (builtin_expect (((a_n.item.mp_size + 1).to_natural_32 * Natural_32_bytes.to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
					l_tmp___2.ce_gets ((l_aaf.new ((a_n.item.mp_size + 1).to_natural_32 * Natural_32_bytes.to_natural_32)))
				else
					l_tmp___2.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (a_n.item.mp_size + 1).to_natural_32 * Natural_32_bytes.to_natural_32)))
				end
				l_x.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2)
				js.break
			end
			js.reset
			aors_ui_inst.gmpz_sub_ui (l_nm1, a_n, {NATURAL_32} 1)
			from
			until
				js.loop_left
			loop
				js.reset
				l_x___0.ce_gets (l_x___2)
				l_x___0.item.mp_alloc := (a_n.item.mp_size + 1)
				if (builtin_expect (((a_n.item.mp_size + 1).to_natural_32 * Natural_32_bytes.to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
					l_tmp___7.ce_gets ((l_aaf.new ((a_n.item.mp_size + 1).to_natural_32 * Natural_32_bytes.to_natural_32)))
				else
					l_tmp___7.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (a_n.item.mp_size + 1).to_natural_32 * Natural_32_bytes.to_natural_32)))
				end
				l_x___0.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___7)
				js.break
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				l_x___1.ce_gets (l_y)
				l_x___1.item.mp_alloc := 2 * a_n.item.mp_size
				if (builtin_expect (((2 * a_n.item.mp_size).to_natural_32 * Natural_32_bytes.to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
					l_tmp___12.ce_gets ((l_aaf.new ((2 * a_n.item.mp_size).to_natural_32 * Natural_32_bytes.to_natural_32)))
				else
					l_tmp___12.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (2 * a_n.item.mp_size).to_natural_32 * Natural_32_bytes.to_natural_32)))
				end
				l_x___1.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___12)
				js.break
			end
			js.reset
			set_ui_inst.gmpz_set_ui (l_x___2, {NATURAL_32} 210)
			powm_inst.gmpz_powm (l_y, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_x___2), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nm1), a_n)
			if (cmp_ui_inst.gmpz_cmp_ui (create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_y), {NATURAL_32} 1)) /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
					end
					js.break
				end
				js.reset
				Result := 0
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_x___22.ce_gets (l_q)
					l_x___22.item.mp_alloc := a_n.item.mp_size
					if (builtin_expect (((a_n.item.mp_size).to_natural_32 * Natural_32_bytes.to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___20.ce_gets ((l_aaf.new ((a_n.item.mp_size).to_natural_32 * Natural_32_bytes.to_natural_32)))
					else
						l_tmp___20.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (a_n.item.mp_size).to_natural_32 * Natural_32_bytes.to_natural_32)))
					end
					l_x___22.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___20)
					js.break
				end
				js.reset
				l_k := scan1_inst.gmpz_scan1 (create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nm1), (0).to_natural_32)
				tdiv_q_2exp_inst.gmpz_tdiv_q_2exp (l_q, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nm1), l_k)
				from
				until
					js.loop_left
				loop
					js.reset
					l_x___3.ce_gets (l_nm3)
					l_x___3.item.mp_alloc := (a_n.item.mp_size + 1)
					if (builtin_expect (((a_n.item.mp_size + 1).to_natural_32 * Natural_32_bytes.to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___25.ce_gets ((l_aaf.new ((a_n.item.mp_size + 1).to_natural_32 * Natural_32_bytes.to_natural_32)))
					else
						l_tmp___25.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (a_n.item.mp_size + 1).to_natural_32 * Natural_32_bytes.to_natural_32)))
					end
					l_x___3.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___25)
					js.break
				end
				js.reset
				aors_ui_inst.gmpz_sub_ui (l_nm3, a_n, {NATURAL_32} 3)
				randdef_inst.gmp_randinit_default (create {CE_POINTER [PD_GMP_RANDSTATE_STRUCT]}.make_cast (l_rstate))
				l_is_prime := 1
				l_r := 0
				from
				until
					js.loop_left
				loop
					js.reset
					if l_r < a_reps then
						if not l_is_prime.to_boolean then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						urandomm_inst.gmpz_urandomm (l_x___2, create {CE_POINTER [PD_GMP_RANDSTATE_STRUCT]}.make_cast (l_rstate), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nm3))
						aors_ui_inst.gmpz_add_ui (l_x___2, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_x___2), {NATURAL_32} 2)
						l_is_prime := millerrabin (a_n, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nm1), l_x___2, l_y, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_q), l_k)
						l_r := l_r + 1
					end
				end
				js.reset
				randclr_inst.gmp_randclear (create {CE_POINTER [PD_GMP_RANDSTATE_STRUCT]}.make_cast (l_rstate))
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
					end
					js.break
				end
				js.reset
				Result := l_is_prime
			end
		end

	millerrabin (a_n: CE_POINTER [PD_MPZ_STRUCT]; a_nm1: CE_POINTER [PD_MPZ_STRUCT]; a_x___2: CE_POINTER [PD_MPZ_STRUCT]; a_y: CE_POINTER [PD_MPZ_STRUCT]; a_q: CE_POINTER [PD_MPZ_STRUCT]; a_k: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			powm_inst.gmpz_powm (a_y, a_x___2, a_q, a_n)
			if (cmp_ui_inst.gmpz_cmp_ui (a_y, {NATURAL_32} 1)) = 0 then
				Result := 1
				js.return
			elseif (cmp_inst.gmpz_cmp (a_y, a_nm1)) = 0 then
				Result := 1
				js.return
			end
			if not js.return_called then
				l_i := {NATURAL_32} 1
				from
				until
					not (not js.loop_left and then (l_i < a_k))
				loop
					powm_ui_inst.gmpz_powm_ui (a_y, a_y, {NATURAL_32} 2, a_n)
					if (cmp_inst.gmpz_cmp (a_y, a_nm1)) = 0 then
						Result := 1
						js.return
					end
					if not js.return_called then
						if (cmp_ui_inst.gmpz_cmp_ui (a_y, {NATURAL_32} 1)) = 0 then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

end
