class
	P_MP_SET_FNS

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmp_set_memory_functions (a_alloc_func: CE_ROUTINE; a_realloc_func: CE_ROUTINE; a_free_func: CE_ROUTINE)
		local
			l_alloc_func: CE_ROUTINE
			l_realloc_func: CE_ROUTINE
			l_free_func: CE_ROUTINE
		do
			create l_alloc_func.make
			create l_realloc_func.make
			create l_free_func.make

			l_alloc_func.ce_gets (a_alloc_func)
			l_realloc_func.ce_gets (a_realloc_func)
			l_free_func.ce_gets (a_free_func)
			if (l_alloc_func.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_alloc_func.ce_gets (memory_inst.gmp_default_allocate_address)
			end
			if (l_realloc_func.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_realloc_func.ce_gets (memory_inst.gmp_default_reallocate_address)
			end
			if (l_free_func.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_free_func.ce_gets (memory_inst.gmp_default_free_address)
			end
			memory_inst.gmp_allocate_func.ce_gets (l_alloc_func)
			memory_inst.gmp_reallocate_func.ce_gets (l_realloc_func)
			memory_inst.gmp_free_func.ce_gets (l_free_func)
		end

end
