class
	P_MU_DIVAPPR_Q

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_mu_divappr_q (a_qp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_np: CE_POINTER [NATURAL_32]
			l_nn: INTEGER_32
			l_dp: CE_POINTER [NATURAL_32]
			l_dn: INTEGER_32
			l_qn: INTEGER_32
			l_in: INTEGER_32
			l_cy: NATURAL_32
			l_qh: NATURAL_32
			l_ip: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_np.make
			create l_dp.make
			create l_ip.make
			create l_tp.make
			create l_dst.make
			create l_tmp.make

			l_np.ce_gets (a_np)
			l_nn := a_nn
			l_dp.ce_gets (a_dp)
			l_dn := a_dn
			l_qn := l_nn - l_dn
			if l_qn + 1 < l_dn then
				l_np.ce_gets (l_np + (l_dn - (l_qn + 1)))
				l_nn := l_nn - (l_dn - (l_qn + 1))
				l_dp.ce_gets (l_dp + (l_dn - (l_qn + 1)))
				l_dn := l_qn + 1
			end
			l_in := gmpn_mu_divappr_q_choose_in (l_qn, l_dn, 0)
			l_ip.ce_gets (a_scratch)
			l_tp.ce_gets ((a_scratch + l_in) + 1)
			if l_dn = l_in then
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						gmp_inst.gmpn_copyi (l_tp + 1, l_dp, l_in)
						js.break
					end
					js.reset
					js.break
				end
				js.reset
				l_tp[0] := (1).to_natural_32
				invertappr_inst.gmpn_invertappr (l_ip, l_tp, l_in + 1, create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)).do_nothing
				from
				until
					js.loop_left
				loop
					js.reset
					gmp_inst.gmpn_copyi (l_ip, (l_ip + 1), l_in)
					js.break
				end
				js.reset
			else
				l_cy := gmp_inst.gmpn_add_1 (l_tp, (l_dp + l_dn) - (l_in + 1), l_in + 1, (1).to_natural_32)
				if (builtin_expect ((l_cy /= {NATURAL_32} 0).to_integer, 0)).to_boolean then
					from
					until
						js.loop_left
					loop
						js.reset
						if l_in /= 0 then
							l_dst.ce_gets (l_ip)
							l_n := l_in
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp.ce_gets (l_dst)
								l_dst.ce_gets (l_dst + 1)
								l_tmp.item := (0).to_natural_32
								l_n := l_n - 1
								if not l_n.to_boolean then
									js.break
								end
							end
							js.reset
						end
						js.break
					end
					js.reset
				else
					invertappr_inst.gmpn_invertappr (l_ip, l_tp, l_in + 1, create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)).do_nothing
					from
					until
						js.loop_left
					loop
						js.reset
						gmp_inst.gmpn_copyi (l_ip, (l_ip + 1), l_in)
						js.break
					end
					js.reset
				end
			end
			l_qh := gmpn_preinv_mu_divappr_q (a_qp, l_np, l_nn, l_dp, l_dn, l_ip, l_in, a_scratch + l_in)
			Result := l_qh
		end

	gmpn_preinv_mu_divappr_q (a_qp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_ip: CE_POINTER [NATURAL_32]; a_in: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_qp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_ip: CE_POINTER [NATURAL_32]
			l_in: INTEGER_32
			l_qn: INTEGER_32
			l_cy: NATURAL_32
			l_cx: NATURAL_32
			l_qh: NATURAL_32
			l_r: NATURAL_32
			l_tn: INTEGER_32
			l_wn: INTEGER_32
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			l_ptr_dummy___0: CE_POINTER [NATURAL_32]
			l_ptr_dummy___1: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			create l_qp.make
			create l_np.make
			create l_ip.make
			create l_ptr_dummy.make
			create l_ptr_dummy___0.make
			create l_ptr_dummy___1.make

			l_qp.ce_gets (a_qp)
			l_np.ce_gets (a_np)
			l_ip.ce_gets (a_ip)
			l_in := a_in
			l_qn := a_nn - a_dn
			l_np.ce_gets (l_np + l_qn)
			l_qp.ce_gets (l_qp + l_qn)
			l_qh := ((gmp_inst.gmpn_cmp (l_np, a_dp, a_dn)) >= 0).to_integer.to_natural_32
			if l_qh /= {NATURAL_32} 0 then
				gmp_inst.gmpn_sub_n (a_scratch, l_np, a_dp, a_dn).do_nothing
			else
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						gmp_inst.gmpn_copyi (a_scratch, l_np, a_dn)
						js.break
					end
					js.reset
					js.break
				end
				js.reset
			end
			if l_qn = 0 then
				Result := l_qh
				js.return
			end
			if not js.return_called then
				from
				until
					not (not js.loop_left and then (l_qn > 0))
				loop
					js.reset
					if l_qn < l_in then
						l_ip.ce_gets (l_ip + (l_in - l_qn))
						l_in := l_qn
					end
					l_np.ce_gets (l_np - l_in)
					l_qp.ce_gets (l_qp - l_in)
					mul_n_inst.gmpn_mul_n (a_scratch + a_dn, ((a_scratch + a_dn) - l_in), l_ip, l_in)
					l_cy := gmp_inst.gmpn_add_n (l_qp, ((a_scratch + a_dn) + l_in), ((a_scratch + a_dn) - l_in), l_in)
					from
					until
						js.loop_left
					loop
						js.reset
						if l_cy /= {NATURAL_32} 0 then
							assert_inst.gmp_assert_fail (ce_string ("mu_divappr_q.c"), 195, ce_string ("cy == 0"))
						end
						js.break
					end
					js.reset
					l_qn := l_qn - l_in
					if l_qn = 0 then
						js.break
					end
					if not js.loop_jumped then
						if 58 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_in >= 58 then
								l_tn := mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (a_dn + 1)
								mulmod_bnm1_inst.gmpn_mulmod_bnm1 (a_scratch + a_dn, l_tn, a_dp, a_dn, l_qp, l_in, (a_scratch + a_dn) + l_tn)
								l_wn := (a_dn + l_in) - l_tn
								if l_wn > 0 then
									l_cy := gmp_inst.gmpn_sub_n (a_scratch + a_dn, (a_scratch + a_dn), ((a_scratch + a_dn) - l_wn), l_wn)
									l_cy := gmp_inst.gmpn_sub_1 ((a_scratch + a_dn) + l_wn, ((a_scratch + a_dn) + l_wn), l_tn - l_wn, l_cy)
									l_cx := ((gmp_inst.gmpn_cmp (((a_scratch + a_dn) - l_in), ((a_scratch + a_dn) + a_dn), l_tn - a_dn)) < 0).to_integer.to_natural_32
									from
									until
										js.loop_left
									loop
										js.reset
										if not (l_cx >= l_cy) then
											assert_inst.gmp_assert_fail (ce_string ("mu_divappr_q.c"), 217, ce_string ("cx >= cy"))
										end
										js.break
									end
									js.reset
									from
									until
										js.loop_left
									loop
										js.reset
										asm317 (l_ptr_dummy.address, a_scratch.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_dn), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cx), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
										js.break
									end
									js.reset
								end
							else
								mul_inst.gmpn_mul (a_scratch + a_dn, a_dp, a_dn, l_qp, l_in).do_nothing
							end
						else
							mul_inst.gmpn_mul (a_scratch + a_dn, a_dp, a_dn, l_qp, l_in).do_nothing
						end
						l_r := a_scratch[(a_dn - l_in)] - (a_scratch + a_dn)[a_dn]
						if a_dn /= l_in then
							l_cy := gmp_inst.gmpn_sub_n (a_scratch + a_dn, l_np, (a_scratch + a_dn), l_in)
							l_cy := gmp_impl_inst.gmpn_sub_nc ((a_scratch + a_dn) + l_in, a_scratch, ((a_scratch + a_dn) + l_in), a_dn - l_in, l_cy)
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (a_scratch, (a_scratch + a_dn), a_dn)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
						else
							l_cy := gmp_inst.gmpn_sub_n (a_scratch, l_np, (a_scratch + a_dn), l_in)
						end
						l_r := l_r - l_cy
						from
						until
							not (not js.loop_left and then (l_r /= {NATURAL_32} 0))
						loop
							from
							until
								js.loop_left
							loop
								js.reset
								asm318 (l_ptr_dummy___0.address, l_qp.address)
								js.break
							end
							js.reset
							l_cy := gmp_inst.gmpn_sub_n (a_scratch, a_scratch, a_dp, a_dn)
							l_r := l_r - l_cy
						end
						if (gmp_inst.gmpn_cmp (a_scratch, a_dp, a_dn)) >= 0 then
							from
							until
								js.loop_left
							loop
								js.reset
								asm319 (l_ptr_dummy___1.address, l_qp.address)
								js.break
							end
							js.reset
							l_cy := gmp_inst.gmpn_sub_n (a_scratch, a_scratch, a_dp, a_dn)
						end
					end
				end
				js.reset
				l_qn := a_nn - a_dn
				l_cy := l_cy + (gmp_inst.gmpn_add_1 (l_qp, l_qp, l_qn, (3).to_natural_32))
				if l_cy /= {NATURAL_32} 0 then
					if l_qh /= {NATURAL_32} 0 then
						l_i := (0).to_integer_32
						from
						until
							not (l_i < l_qn)
						loop
							l_qp[l_i] := {NATURAL_32} 4294967295
							l_i := l_i + 1
						end
					else
						l_qh := (1).to_natural_32
					end
				end
				Result := l_qh
			end
		end

	gmpn_mu_divappr_q_choose_in (a_qn: INTEGER_32; a_dn: INTEGER_32; a_k: INTEGER_32): INTEGER_32
		local
			l_in: INTEGER_32
			l_b: INTEGER_32
			l_xn: INTEGER_32
		do
			if a_k = 0 then
				if a_qn > a_dn then
					l_b := (a_qn - 1) // a_dn + 1
					l_in := (a_qn - 1) // l_b + 1
				elseif 3 * a_qn > a_dn then
					l_in := (a_qn - 1) // 2 + 1
				else
					l_in := (a_qn - 1) + 1
				end
			else
				if a_dn < a_qn then
					l_xn := a_dn
				else
					l_xn := a_qn
				end
				l_in := (l_xn - 1) // a_k.to_integer_32 + 1
			end
			Result := l_in
		end

	gmpn_mu_divappr_q_itch (a_nn: INTEGER_32; a_dn: INTEGER_32; a_mua_k: INTEGER_32): INTEGER_32
		local
			l_dn: INTEGER_32
			l_qn: INTEGER_32
			l_in: INTEGER_32
			l_itch_local: INTEGER_32
			l_itch_out: INTEGER_32
		do
			l_dn := a_dn
			l_qn := a_nn - l_dn
			if l_qn + 1 < l_dn then
				l_dn := l_qn + 1
			end
			l_in := gmpn_mu_divappr_q_choose_in (l_qn, l_dn, a_mua_k)
			l_itch_local := mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (l_dn + 1)
			l_itch_out := gmp_impl_inst.mpn_mulmod_bnm1_itch (l_itch_local, l_dn, l_in)
			Result := (((l_in + l_dn) + l_itch_local) + l_itch_out)
		end

end
