class
	P_MUL_2EXP

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_mul_2exp (a_r: CE_POINTER [PD_MPF_STRUCT]; a_u: CE_POINTER [PD_MPF_STRUCT]; a_exp: NATURAL_32)
		local
			l_up: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_abs_usize: INTEGER_32
			l_prec: INTEGER_32
			l_uexp: INTEGER_32
			l_cy_limb: NATURAL_32
			l_adj: INTEGER_32
			js: JUMP_STATE
		do
			create l_up.make
			create l_rp.make

			l_rp.ce_gets (a_r.item.mp_d)
			l_prec := (a_r.item.mp_prec).to_integer_32
			l_uexp := a_u.item.mp_exp
			l_usize := (a_u.item.mp_size).to_integer_32
			if (builtin_expect ((l_usize = 0).to_integer, 0)).to_boolean then
				a_r.item.mp_size := 0
				a_r.item.mp_exp := (0).to_integer_32
				js.return
			end
			if not js.return_called then
				if l_usize >= 0 then
					l_abs_usize := l_usize
				else
					l_abs_usize := -l_usize
				end
				l_up.ce_gets (a_u.item.mp_d)
				if a_exp \\ {NATURAL_32} 32 = {NATURAL_32} 0 then
					l_prec := l_prec + 1
					if l_abs_usize > l_prec then
						l_up.ce_gets (l_up + (l_abs_usize - l_prec))
						l_abs_usize := l_prec
					end
					if (l_rp.c_pointer.to_integer_32).to_natural_32 /= (l_up.c_pointer.to_integer_32).to_natural_32 then
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (l_rp, l_up, l_abs_usize)
							js.break
						end
						js.reset
					end
					a_r.item.mp_exp := (l_uexp.to_natural_32 + a_exp // {NATURAL_32} 32).to_integer_32
				else
					if l_abs_usize > l_prec then
						l_up.ce_gets (l_up + (l_abs_usize - l_prec))
						l_abs_usize := l_prec
						l_cy_limb := gmp_inst.gmpn_rshift (l_rp + 1, l_up, l_abs_usize, ({NATURAL_32} 32 - a_exp \\ {NATURAL_32} 32).to_natural_32)
						l_rp[0] := l_cy_limb
						l_adj := (l_rp[l_abs_usize] /= {NATURAL_32} 0).to_integer
					else
						l_cy_limb := gmp_inst.gmpn_lshift (l_rp, l_up, l_abs_usize, (a_exp \\ {NATURAL_32} 32).to_natural_32)
						l_rp[l_abs_usize] := l_cy_limb
						l_adj := (l_cy_limb /= {NATURAL_32} 0).to_integer
					end
					l_abs_usize := l_abs_usize + l_adj
					a_r.item.mp_exp := ((l_uexp.to_natural_32 + a_exp // {NATURAL_32} 32) + l_adj.to_natural_32).to_integer_32
				end
				if l_usize >= 0 then
					a_r.item.mp_size := l_abs_usize.to_integer_32
				else
					a_r.item.mp_size := (-l_abs_usize).to_integer_32
				end
			end
		end

	gmpz_mul_2exp (a_w: CE_POINTER [PD_MPZ_STRUCT]; a_u: CE_POINTER [PD_MPZ_STRUCT]; a_cnt: NATURAL_32)
		local
			l_cnt: NATURAL_32
			l_usize: INTEGER_32
			l_abs_usize: INTEGER_32
			l_tmp: INTEGER_32
			l_wsize: INTEGER_32
			l_limb_cnt: INTEGER_32
			l_wp: CE_POINTER [NATURAL_32]
			l_wlimb: NATURAL_32
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_wp.make
			create l_dst.make
			create l_tmp___0.make

			l_cnt := a_cnt
			l_usize := (a_u.item.mp_size).to_integer_32
			if l_usize >= 0 then
				l_tmp := l_usize
			else
				l_tmp := -l_usize
			end
			l_abs_usize := l_tmp
			if l_usize = 0 then
				a_w.item.mp_size := 0
				js.return
			end
			if not js.return_called then
				l_limb_cnt := (l_cnt // {NATURAL_32} 32).to_integer_32
				l_wsize := (l_abs_usize + l_limb_cnt) + 1
				if (a_w.item.mp_alloc).to_integer_32 < l_wsize then
					realloc_inst.gmpz_realloc (a_w, l_wsize).do_nothing
				end
				l_wp.ce_gets (a_w.item.mp_d)
				l_wsize := l_abs_usize + l_limb_cnt
				l_cnt := l_cnt \\ ({NATURAL_32} 32)
				if l_cnt /= {NATURAL_32} 0 then
					l_wlimb := gmp_inst.gmpn_lshift (l_wp + l_limb_cnt, a_u.item.mp_d, l_abs_usize, l_cnt.to_natural_32)
					if l_wlimb /= {NATURAL_32} 0 then
						l_wp[l_wsize] := l_wlimb
						l_wsize := l_wsize + 1
					end
				else
					from
					until
						js.loop_left
					loop
						js.reset
						gmp_inst.gmpn_copyd (l_wp + l_limb_cnt, a_u.item.mp_d, l_abs_usize)
						js.break
					end
					js.reset
				end
				from
				until
					js.loop_left
				loop
					js.reset
					if l_limb_cnt /= 0 then
						l_dst.ce_gets (l_wp)
						l_n := l_limb_cnt
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp___0.ce_gets (l_dst)
							l_dst.ce_gets (l_dst + 1)
							l_tmp___0.item := (0).to_natural_32
							l_n := l_n - 1
							if not l_n.to_boolean then
								js.break
							end
						end
						js.reset
					end
					js.break
				end
				js.reset
				if l_usize >= 0 then
					a_w.item.mp_size := l_wsize.to_integer_32
				else
					a_w.item.mp_size := (-l_wsize).to_integer_32
				end
			end
		end

end
