class
	P_MUL_I

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_mul_si (a_prod: CE_POINTER [PD_MPZ_STRUCT]; a_mult: CE_POINTER [PD_MPZ_STRUCT]; a_small_mult: INTEGER_32)
		local
			l_size: INTEGER_32
			l_sign_product: INTEGER_32
			l_sml: NATURAL_32
			l_cy: NATURAL_32
			l_pp: CE_POINTER [NATURAL_32]
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_pp.make

			l_size := (a_mult.item.mp_size).to_integer_32
			l_sign_product := l_size
			if l_size = 0 then
				a_prod.item.mp_size := 0
				js.return
			elseif a_small_mult = 0 then
				a_prod.item.mp_size := 0
				js.return
			end
			if not js.return_called then
				if l_size >= 0 then
					l_size := l_size
				else
					l_size := -l_size
				end
				if a_small_mult >= 0 then
					l_tmp := a_small_mult
				else
					l_tmp := -a_small_mult
				end
				l_sml := l_tmp.to_natural_32
				if l_sml <= {NATURAL_32} 4294967295 then
					if (builtin_expect ((l_size + 1 > (a_prod.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
						realloc_inst.gmpz_realloc (a_prod, l_size + 1).do_nothing
					end
					l_pp.ce_gets (a_prod.item.mp_d)
					l_cy := gmp_inst.gmpn_mul_1 (l_pp, a_mult.item.mp_d, l_size, (l_sml).bit_and ({NATURAL_32} 4294967295))
					l_pp[l_size] := l_cy
					l_size := l_size + (l_cy /= {NATURAL_32} 0).to_integer
				end
				if (((l_sign_product < 0).to_integer).bit_xor ((a_small_mult < 0).to_integer)).to_boolean then
					a_prod.item.mp_size := (-l_size).to_integer_32
				else
					a_prod.item.mp_size := l_size.to_integer_32
				end
			end
		end

	gmpz_mul_ui (a_prod: CE_POINTER [PD_MPZ_STRUCT]; a_mult: CE_POINTER [PD_MPZ_STRUCT]; a_small_mult: NATURAL_32)
		local
			l_size: INTEGER_32
			l_sign_product: INTEGER_32
			l_sml: NATURAL_32
			l_cy: NATURAL_32
			l_pp: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_pp.make

			l_size := (a_mult.item.mp_size).to_integer_32
			l_sign_product := l_size
			if l_size = 0 then
				a_prod.item.mp_size := 0
				js.return
			elseif a_small_mult = {NATURAL_32} 0 then
				a_prod.item.mp_size := 0
				js.return
			end
			if not js.return_called then
				if l_size >= 0 then
					l_size := l_size
				else
					l_size := -l_size
				end
				l_sml := a_small_mult
				if l_sml <= {NATURAL_32} 4294967295 then
					if (builtin_expect ((l_size + 1 > (a_prod.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
						realloc_inst.gmpz_realloc (a_prod, l_size + 1).do_nothing
					end
					l_pp.ce_gets (a_prod.item.mp_d)
					l_cy := gmp_inst.gmpn_mul_1 (l_pp, a_mult.item.mp_d, l_size, (l_sml).bit_and ({NATURAL_32} 4294967295))
					l_pp[l_size] := l_cy
					l_size := l_size + (l_cy /= {NATURAL_32} 0).to_integer
				end
				if (((l_sign_product < 0).to_integer).bit_xor ((a_small_mult < {NATURAL_32} 0).to_integer)).to_boolean then
					a_prod.item.mp_size := (-l_size).to_integer_32
				else
					a_prod.item.mp_size := l_size.to_integer_32
				end
			end
		end

end
