class
	P_MUL_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_mul_ui (a_r: CE_POINTER [PD_MPF_STRUCT]; a_u: CE_POINTER [PD_MPF_STRUCT]; a_v: NATURAL_32)
		local
			l_up: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_size: INTEGER_32
			l_prec: INTEGER_32
			l_excess: INTEGER_32
			l_cy_limb: NATURAL_32
			l_vl: NATURAL_32
			l_cbit: NATURAL_32
			l_cin: NATURAL_32
			l_rp: CE_POINTER [NATURAL_32]
			l_vl_shifted: NATURAL_32
			l_hi: NATURAL_32
			l_lo: NATURAL_32
			l_next_lo: NATURAL_32
			l_sum: NATURAL_32
			l_i: INTEGER_32
			l_x: NATURAL_32
			l_y: NATURAL_32
			l_w: NATURAL_32
			l_gmp_i: INTEGER_32
			l_gmp_x: NATURAL_32
			l_gmp_r: NATURAL_32
			l_gmp_j: INTEGER_32
			l_gmp_j___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_up.make
			create l_rp.make

			l_usize := (a_u.item.mp_size).to_integer_32
			if (builtin_expect ((a_v = {NATURAL_32} 0).to_integer, 0)).to_boolean then
				a_r.item.mp_size := 0
				a_r.item.mp_exp := (0).to_integer_32
				js.return
			elseif (builtin_expect ((l_usize = 0).to_integer, 0)).to_boolean then
				a_r.item.mp_size := 0
				a_r.item.mp_exp := (0).to_integer_32
				js.return
			end
			if not js.return_called then
				if l_usize >= 0 then
					l_size := l_usize
				else
					l_size := -l_usize
				end
				l_prec := (a_r.item.mp_prec).to_integer_32
				l_up.ce_gets (a_u.item.mp_d)
				l_vl := a_v
				l_excess := l_size - l_prec
				l_cin := (0).to_natural_32
				if l_excess > 0 then
					l_vl_shifted := l_vl
					l_i := l_excess - 1
					asm1 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_lo), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cin), l_up.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_i), create {CE_POINTER [NATURAL_32]}.make_shared ($l_vl_shifted))
					from
					until
						js.loop_left
					loop
						js.reset
						l_i := l_i - 1
						if l_i < 0 then
							js.break
						end
						if not js.loop_jumped then
							asm2 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_next_lo), create {CE_POINTER [NATURAL_32]}.make_shared ($l_hi), l_up.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_i), create {CE_POINTER [NATURAL_32]}.make_shared ($l_vl_shifted))
							l_lo := l_lo
							from
							until
								js.loop_left
							loop
								js.reset
								l_x := l_hi
								l_y := l_lo
								l_w := l_x + l_y
								l_sum := l_w
								l_cbit := (l_w < l_x).to_integer.to_natural_32
								js.break
							end
							js.reset
							l_cin := l_cin + l_cbit
							l_lo := l_next_lo
							if (builtin_expect ((l_sum /= {NATURAL_32} 4294967295).to_integer, 1)).to_boolean then
								js.break
							end
						end
					end
					js.reset
					l_up.ce_gets (l_up + l_excess)
					l_size := l_prec
				end
				l_rp.ce_gets (a_r.item.mp_d)
				l_cy_limb := gmp_inst.gmpn_mul_1 (l_rp, l_up, l_size, l_vl)
				from
				until
					js.loop_left
				loop
					js.reset
					l_gmp_x := l_rp[0]
					l_gmp_r := l_gmp_x + l_cin
					l_rp[0] := l_gmp_r
					if l_gmp_r < l_cin then
						l_cbit := (1).to_natural_32
						l_gmp_i := (1).to_integer_32
						from
						until
							not (not js.loop_left and then (l_gmp_i < l_size))
						loop
							js.reset
							l_gmp_x := l_rp[l_gmp_i]
							l_gmp_r := l_gmp_x + {NATURAL_32} 1
							l_rp[l_gmp_i] := l_gmp_r
							l_gmp_i := l_gmp_i + 1
							if not (l_gmp_r < {NATURAL_32} 1) then
								if (l_rp.c_pointer.to_integer_32).to_natural_32 /= (l_rp.c_pointer.to_integer_32).to_natural_32 then
									from
									until
										js.loop_left
									loop
										js.reset
										l_gmp_j := l_gmp_i
										from
										until
											not (l_gmp_j < l_size)
										loop
											l_rp[l_gmp_j] := l_rp[l_gmp_j]
											l_gmp_j := l_gmp_j + 1
										end
										js.break
									end
									js.reset
								end
								l_cbit := (0).to_natural_32
								js.break
							end
						end
						js.reset
					else
						if (l_rp.c_pointer.to_integer_32).to_natural_32 /= (l_rp.c_pointer.to_integer_32).to_natural_32 then
							from
							until
								js.loop_left
							loop
								js.reset
								l_gmp_j___0 := (1).to_integer_32
								from
								until
									not (l_gmp_j___0 < l_size)
								loop
									l_rp[l_gmp_j___0] := l_rp[l_gmp_j___0]
									l_gmp_j___0 := l_gmp_j___0 + 1
								end
								js.break
							end
							js.reset
						end
						l_cbit := (0).to_natural_32
					end
					js.break
				end
				js.reset
				l_cy_limb := l_cy_limb + l_cbit
				l_rp[l_size] := l_cy_limb
				l_cy_limb := (l_cy_limb /= {NATURAL_32} 0).to_integer.to_natural_32
				a_r.item.mp_exp := ((a_u.item.mp_exp).to_natural_32 + l_cy_limb).to_integer_32
				l_size := (l_size.to_natural_32 + l_cy_limb).to_integer_32
				if l_usize >= 0 then
					a_r.item.mp_size := l_size.to_integer_32
				else
					a_r.item.mp_size := (-l_size).to_integer_32
				end
			end
		end

end
