class
	P_MULMOD_BNM1

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_bc_mulmod_bnm1 (a_rp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_bp: CE_POINTER [NATURAL_32]; a_rn: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		local
			l_cy: NATURAL_32
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_ptr_dummy.make

			mul_n_inst.gmpn_mul_n (a_tp, a_ap, a_bp, a_rn)
			l_cy := gmp_inst.gmpn_add_n (a_rp, a_tp, (a_tp + a_rn), a_rn)
			from
			until
				js.loop_left
			loop
				js.reset
				asm222 (l_ptr_dummy.address, a_rp.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
		end

	mpn_bc_mulmod_bnp1 (a_rp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_bp: CE_POINTER [NATURAL_32]; a_rn: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		local
			l_cy: NATURAL_32
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_ptr_dummy.make

			mul_n_inst.gmpn_mul_n (a_tp, a_ap, a_bp, a_rn + 1)
			l_cy := a_tp[2 * a_rn] + (gmp_inst.gmpn_sub_n (a_rp, a_tp, (a_tp + a_rn), a_rn))
			a_rp[a_rn] := (0).to_natural_32
			from
			until
				js.loop_left
			loop
				js.reset
				asm223 (l_ptr_dummy.address, a_rp.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
		end

	gmpn_mulmod_bnm1 (a_rp: CE_POINTER [NATURAL_32]; a_rn: INTEGER_32; a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		local
			l_cy: NATURAL_32
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_cy___0: NATURAL_32
			l_hi: NATURAL_32
			l_am1: CE_POINTER [NATURAL_32]
			l_bm1: CE_POINTER [NATURAL_32]
			l_anm: INTEGER_32
			l_bnm: INTEGER_32
			l_so: CE_POINTER [NATURAL_32]
			l_ptr_dummy___0: CE_POINTER [NATURAL_32]
			l_ptr_dummy___1: CE_POINTER [NATURAL_32]
			l_k: INTEGER_32
			l_ap1: CE_POINTER [NATURAL_32]
			l_bp1: CE_POINTER [NATURAL_32]
			l_anp: INTEGER_32
			l_bnp: INTEGER_32
			l_ptr_dummy___2: CE_POINTER [NATURAL_32]
			l_ptr_dummy___3: CE_POINTER [NATURAL_32]
			l_mask: INTEGER_32
			l_ptr_dummy___4: CE_POINTER [NATURAL_32]
			l_ptr_dummy___5: CE_POINTER [NATURAL_32]
			l_ptr_dummy___6: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ptr_dummy.make
			create l_am1.make
			create l_bm1.make
			create l_so.make
			create l_ptr_dummy___0.make
			create l_ptr_dummy___1.make
			create l_ap1.make
			create l_bp1.make
			create l_ptr_dummy___2.make
			create l_ptr_dummy___3.make
			create l_ptr_dummy___4.make
			create l_ptr_dummy___5.make
			create l_ptr_dummy___6.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((a_rn).bit_and (1)) = 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 6 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if 13 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_rn >= 13 then
							l_n := (a_rn).bit_shift_right (1)
							if (builtin_expect ((a_an > l_n).to_integer, 1)).to_boolean then
								l_am1.ce_gets (a_tp)
								l_cy___0 := gmp_inst.gmpn_add (a_tp, a_ap, l_n, a_ap + l_n, a_an - l_n)
								from
								until
									js.loop_left
								loop
									js.reset
									asm224 (l_ptr_dummy___0.address, a_tp.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy___0))
									js.break
								end
								js.reset
								l_anm := l_n
								if (builtin_expect ((a_bn > l_n).to_integer, 1)).to_boolean then
									l_bm1.ce_gets ((a_tp + l_n))
									l_cy___0 := gmp_inst.gmpn_add (a_tp + l_n, a_bp, l_n, a_bp + l_n, a_bn - l_n)
									from
									until
										js.loop_left
									loop
										js.reset
										asm225 (l_ptr_dummy___1.address, a_tp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy___0))
										js.break
									end
									js.reset
									l_bnm := l_n
									l_so.ce_gets (a_tp + 2 * l_n)
								else
									l_so.ce_gets (a_tp + l_n)
									l_bm1.ce_gets (a_bp)
									l_bnm := a_bn
								end
							else
								l_so.ce_gets (a_tp)
								l_am1.ce_gets (a_ap)
								l_anm := a_an
								l_bm1.ce_gets (a_bp)
								l_bnm := a_bn
							end
							gmpn_mulmod_bnm1 (a_rp, l_n, l_am1, l_anm, l_bm1, l_bnm, l_so)
							if (builtin_expect ((a_an > l_n).to_integer, 1)).to_boolean then
								l_ap1.ce_gets (((a_tp + 2 * l_n) + 2))
								l_cy___0 := gmp_inst.gmpn_sub ((a_tp + 2 * l_n) + 2, a_ap, l_n, a_ap + l_n, a_an - l_n);
								((a_tp + 2 * l_n) + 2)[l_n] := (0).to_natural_32
								from
								until
									js.loop_left
								loop
									js.reset
									asm226 (l_ptr_dummy___2.address, a_tp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy___0))
									js.break
								end
								js.reset
								l_anp := (l_n.to_natural_32 + l_ap1[l_n]).to_integer_32
							else
								l_ap1.ce_gets (a_ap)
								l_anp := a_an
							end
							if (builtin_expect ((a_bn > l_n).to_integer, 1)).to_boolean then
								l_bp1.ce_gets (((((a_tp + 2 * l_n) + 2) + l_n) + 1))
								l_cy___0 := gmp_inst.gmpn_sub ((((a_tp + 2 * l_n) + 2) + l_n) + 1, a_bp, l_n, a_bp + l_n, a_bn - l_n);
								((a_tp + 2 * l_n) + 2)[(2 * l_n + 1)] := (0).to_natural_32
								from
								until
									js.loop_left
								loop
									js.reset
									asm227 (l_ptr_dummy___3.address, a_tp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy___0))
									js.break
								end
								js.reset
								l_bnp := (l_n.to_natural_32 + l_bp1[l_n]).to_integer_32
							else
								l_bp1.ce_gets (a_bp)
								l_bnp := a_bn
							end
							if 565 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
								if l_n >= 565 then
									l_k := mul_fft_inst.gmpn_fft_best_k (l_n, 0)
									l_mask := ((1).bit_shift_left (l_k)) - 1
									from
									until
										not (((l_n).bit_and (l_mask.to_integer_32)).to_boolean)
									loop
										l_k := l_k - 1
										l_mask := (l_mask).bit_shift_right ((1))
									end
								else
									l_k := 0
								end
							else
								l_k := 0
							end
							if l_k >= 4 then
								a_tp[l_n] := mul_fft_inst.gmpn_mul_fft (a_tp, l_n, l_ap1, l_anp, l_bp1, l_bnp, l_k)
							elseif (builtin_expect (((l_bp1.c_pointer.to_integer_32).to_natural_32 = (a_bp.c_pointer.to_integer_32).to_natural_32).to_integer, 0)).to_boolean then
								mul_inst.gmpn_mul (a_tp, l_ap1, l_anp, l_bp1, l_bnp).do_nothing
								l_anp := (l_anp + l_bnp) - l_n
								l_anp := l_anp - (l_anp > l_n).to_integer
								l_cy___0 := gmp_inst.gmpn_sub (a_tp, a_tp, l_n, (a_tp + l_n), l_anp)
								a_tp[l_n] := (0).to_natural_32
								from
								until
									js.loop_left
								loop
									js.reset
									asm228 (l_ptr_dummy___4.address, a_tp.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy___0))
									js.break
								end
								js.reset
							else
								mpn_bc_mulmod_bnp1 (a_tp, l_ap1, l_bp1, l_n, a_tp)
							end
							l_cy___0 := gmp_impl_inst.gmpn_add_nc (a_rp, a_rp, a_tp, l_n, a_tp[l_n])
							l_cy___0 := l_cy___0 + ((a_rp[0]).bit_and ({NATURAL_32} 1))
							gmp_inst.gmpn_rshift (a_rp, a_rp, l_n, {NATURAL_32} 1).do_nothing
							l_hi := (((l_cy___0).bit_shift_left (31))).bit_and ({NATURAL_32} 4294967295)
							l_cy___0 := (l_cy___0).bit_shift_right ((1))
							a_rp[(l_n - 1)] := (a_rp[(l_n - 1)]).bit_or (l_hi)
							from
							until
								js.loop_left
							loop
								js.reset
								asm229 (l_ptr_dummy___5.address, a_rp.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy___0))
								js.break
							end
							js.reset
							if (builtin_expect ((a_an + a_bn < a_rn).to_integer, 0)).to_boolean then
								l_cy___0 := gmp_inst.gmpn_sub_n (a_rp + l_n, a_rp, a_tp, (a_an + a_bn) - l_n)
								l_cy___0 := a_tp[l_n] + (gmp_impl_inst.gmpn_sub_nc (((a_tp + a_an) + a_bn) - l_n, (((a_rp + a_an) + a_bn) - l_n), (((a_tp + a_an) + a_bn) - l_n), a_rn - (a_an + a_bn), l_cy___0))
								l_cy___0 := gmp_inst.gmpn_sub_1 (a_rp, a_rp, a_an + a_bn, l_cy___0)
							else
								l_cy___0 := a_tp[l_n] + (gmp_inst.gmpn_sub_n (a_rp + l_n, a_rp, a_tp, l_n))
								from
								until
									js.loop_left
								loop
									js.reset
									asm230 (l_ptr_dummy___6.address, a_rp.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy___0))
									js.break
								end
								js.reset
							end
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L___0:
						if (builtin_expect ((a_bn < a_rn).to_integer, 0)).to_boolean then
							if (builtin_expect ((a_an + a_bn <= a_rn).to_integer, 0)).to_boolean then
								mul_inst.gmpn_mul (a_rp, a_ap, a_an, a_bp, a_bn).do_nothing
							else
								mul_inst.gmpn_mul (a_tp, a_ap, a_an, a_bp, a_bn).do_nothing
								l_cy := gmp_inst.gmpn_add (a_rp, a_tp, a_rn, (a_tp + a_rn), (a_an + a_bn) - a_rn)
								from
								until
									js.loop_left
								loop
									js.reset
									asm231 (l_ptr_dummy.address, a_rp.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
									js.break
								end
								js.reset
							end
						else
							gmpn_bc_mulmod_bnm1 (a_rp, a_ap, a_bp, a_rn, a_tp)
						end
				when 7 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gmpn_mulmod_bnm1_next_size (a_n: INTEGER_32): INTEGER_32
		local
			l_nh: INTEGER_32
			js: JUMP_STATE
		do
			if 13 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
				if not (a_n >= 13) then
					Result := a_n
					js.return
				end
			else
				Result := a_n
				js.return
			end
			if not js.return_called then
				if 49 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if not (a_n >= 49) then
						Result := (((a_n + 1)).bit_and (-2))
						js.return
					end
				else
					Result := (((a_n + 1)).bit_and (-2))
					js.return
				end
			end
			if not js.return_called then
				if 97 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if not (a_n >= 97) then
						Result := (((a_n + 3)).bit_and (-4))
						js.return
					end
				else
					Result := (((a_n + 3)).bit_and (-4))
					js.return
				end
			end
			if not js.return_called then
				l_nh := ((a_n + 1)).bit_shift_right (1)
				if 565 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if not (l_nh >= 565) then
						Result := (((a_n + 7)).bit_and (-8))
						js.return
					end
				else
					Result := (((a_n + 7)).bit_and (-8))
					js.return
				end
			end
			if not js.return_called then
				Result := (2 * (mul_fft_inst.gmpn_fft_next_size (l_nh, (mul_fft_inst.gmpn_fft_best_k (l_nh, 0)))))
			end
		end

end
