class
	P_NEG

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_neg (a_r: CE_POINTER [PD_MPF_STRUCT]; a_u: CE_POINTER [PD_MPF_STRUCT])
		local
			l_size: INTEGER_32
			l_prec: INTEGER_32
			l_asize: INTEGER_32
			l_rp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_rp.make
			create l_up.make

			l_size := (-a_u.item.mp_size).to_integer_32
			if (a_r.c_pointer.to_integer_32).to_natural_32 /= (a_u.c_pointer.to_integer_32).to_natural_32 then
				l_prec := (a_r.item.mp_prec + 1).to_integer_32
				if l_size >= 0 then
					l_asize := l_size
				else
					l_asize := -l_size
				end
				l_rp.ce_gets (a_r.item.mp_d)
				l_up.ce_gets (a_u.item.mp_d)
				if l_asize > l_prec then
					l_up.ce_gets (l_up + (l_asize - l_prec))
					l_asize := l_prec
				end
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						gmp_inst.gmpn_copyi (l_rp, l_up, l_asize)
						js.break
					end
					js.reset
					js.break
				end
				js.reset
				a_r.item.mp_exp := a_u.item.mp_exp
				if l_size >= 0 then
					l_size := l_asize
				else
					l_size := -l_asize
				end
			end
			a_r.item.mp_size := l_size.to_integer_32
		end

	gmpz_neg (a_w: CE_POINTER [PD_MPZ_STRUCT]; a_u: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_wp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_size: INTEGER_32
			js: JUMP_STATE
		do
			create l_wp.make
			create l_up.make

			l_usize := (a_u.item.mp_size).to_integer_32
			if (a_u.c_pointer.to_integer_32).to_natural_32 /= (a_w.c_pointer.to_integer_32).to_natural_32 then
				if l_usize >= 0 then
					l_size := l_usize
				else
					l_size := -l_usize
				end
				if (a_w.item.mp_alloc).to_integer_32 < l_size then
					realloc_inst.gmpz_realloc (a_w, l_size).do_nothing
				end
				l_wp.ce_gets (a_w.item.mp_d)
				l_up.ce_gets (a_u.item.mp_d)
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						gmp_inst.gmpn_copyi (l_wp, l_up, l_size)
						js.break
					end
					js.reset
					js.break
				end
				js.reset
			end
			a_w.item.mp_size := (-l_usize).to_integer_32
		end

	gmpq_neg (a_dst: CE_POINTER [PD_MPQ_STRUCT]; a_src: CE_POINTER [PD_MPQ_STRUCT])
		local
			l_num_size: INTEGER_32
			l_num_abs_size: INTEGER_32
			l_tmp: INTEGER_32
			l_den_size: INTEGER_32
			js: JUMP_STATE
		do
			l_num_size := (a_src.item.mp_num.mp_size).to_integer_32
			if (a_src.c_pointer.to_integer_32).to_natural_32 /= (a_dst.c_pointer.to_integer_32).to_natural_32 then
				if l_num_size >= 0 then
					l_tmp := l_num_size
				else
					l_tmp := -l_num_size
				end
				l_num_abs_size := l_tmp
				l_den_size := (a_src.item.mp_den.mp_size).to_integer_32
				if (builtin_expect ((l_num_abs_size > (a_dst.item.mp_num.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					realloc_inst.gmpz_realloc (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_dst.c_pointer + {PD_MPQ_STRUCT}.mp_num_offset), l_num_abs_size).do_nothing
				end
				if (builtin_expect ((l_den_size > (a_dst.item.mp_den.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					realloc_inst.gmpz_realloc (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_dst.c_pointer + {PD_MPQ_STRUCT}.mp_den_offset), l_den_size).do_nothing
				end
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						gmp_inst.gmpn_copyi (a_dst.item.mp_num.mp_d, a_src.item.mp_num.mp_d, l_num_abs_size)
						js.break
					end
					js.reset
					js.break
				end
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						gmp_inst.gmpn_copyi (a_dst.item.mp_den.mp_d, a_src.item.mp_den.mp_d, l_den_size)
						js.break
					end
					js.reset
					js.break
				end
				js.reset
				a_dst.item.mp_den.mp_size := l_den_size.to_integer_32
			end
			a_dst.item.mp_num.mp_size := (-l_num_size).to_integer_32
		end

end
