class
	P_PERFPOW

inherit
	LIBGMP_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {NONE} -- Initialization

	default_create
		do
			create nrtrial.make (<<3>>)
			create logs.make (<<3>>)
		end

feature {ANY} -- attributes

	nrtrial: CE_ARRAY [NATURAL_16]

	logs: CE_ARRAY [REAL_64]

feature {ANY} -- routines

	gmpz_perfect_power_p (a_u: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		do
			Result := (gmpn_perfect_power_p (a_u.item.mp_d, (a_u.item.mp_size).to_integer_32))
		end

	pow_equals (a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_xp: CE_POINTER [NATURAL_32]; a_xn: INTEGER_32; a_k: NATURAL_32; a_f: NATURAL_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_k: NATURAL_32
			l_tp2: CE_POINTER [NATURAL_32]
			l_y: NATURAL_32
			l_z: NATURAL_32
			l_count: NATURAL_32
			l_i: INTEGER_32
			l_bn: INTEGER_32
			l_ans: INTEGER_32
			l_h: NATURAL_32
			l_l: NATURAL_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_size: NATURAL_32
			l_tmp___4: CE_POINTER [ANY]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_tp2.make
			create l_tmp_marker.make
			create l_tmp___4.make

			l_k := a_k
			if a_xn = 1 then
				if a_xp[0] = {NATURAL_32} 1 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_z := (1 + ((a_nn).bit_shift_right (1))).to_natural_32
				l_bn := (1).to_integer_32
				from
				until
					not (not js.loop_left and then (l_bn.to_natural_32 < l_z))
				loop
					powlo_inst.gmpn_powlo (a_tp, a_xp, (create {CE_POINTER [NATURAL_32]}.make_shared ($l_k)), (1).to_integer_32, l_bn, a_tp + l_bn)
					if (gmp_inst.gmpn_cmp (a_tp, a_np, l_bn)) /= 0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_bn := (l_bn).bit_shift_left ((1))
					end
				end
			end
			if not js.return_called then
				l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
				from
				until
					js.loop_left
				loop
					js.reset
					l_count := (builtin_clzl (a_xp[(a_xn - 1)])).to_natural_32
					js.break
				end
				js.reset
				l_y := ((a_xn * 32).to_natural_32 - l_count) - {NATURAL_32} 1
				asm106 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_32]}.make_shared ($l_h), create {CE_POINTER [NATURAL_32]}.make_shared ($l_k), create {CE_POINTER [NATURAL_32]}.make_shared ($l_y))
				l_h := l_h - (l_l = {NATURAL_32} 0).to_integer.to_natural_32
				l_l := l_l - 1
				l_z := a_f - {NATURAL_32} 1
				if l_h = {NATURAL_32} 0 then
					if l_l <= l_z then
						l_size := l_l + l_k
						from
						until
							js.loop_left
						loop
							js.reset
							if not (l_size >= l_k) then
								assert_inst.gmp_assert_fail (ce_string ("perfpow.c"), 83, ce_string ("size >= k"))
							end
							js.break
						end
						js.reset
						l_y := {NATURAL_32} 2 + l_size // {NATURAL_32} 32
						if (builtin_expect ((l_y * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___4.ce_gets ((l_aaf.new ((l_y * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___4.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_y * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_tp2.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___4))
						l_i := pow_1_inst.gmpn_pow_1 (a_tp, a_xp, a_xn, l_k, l_tp2)
						if l_i = a_nn then
							if (gmp_inst.gmpn_cmp (a_tp, a_np, a_nn)) = 0 then
								l_ans := 1
							else
								l_ans := 0
							end
						else
							l_ans := 0
						end
					else
						l_ans := 0
					end
				else
					l_ans := 0
				end
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
					end
					js.break
				end
				js.reset
				Result := l_ans
			end
		end

	binv_root (a_rp: CE_POINTER [NATURAL_32]; a_yp: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_bn: INTEGER_32; a_b: NATURAL_32; a_tp: CE_POINTER [NATURAL_32])
		local
			l_bn: INTEGER_32
			l_b: NATURAL_32
			l_tp2: CE_POINTER [NATURAL_32]
			l_tp3: CE_POINTER [NATURAL_32]
			l_di: NATURAL_32
			l_k2: NATURAL_32
			l_order: CE_ARRAY [NATURAL_32]
			l_i: INTEGER_32
			l_d: INTEGER_32
			l_n: NATURAL_32
			l_inv: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_tp2.make
			create l_tp3.make
			create l_order.make (<<64>>)

			l_bn := a_bn
			l_b := a_b
			l_tp2.ce_gets (a_tp + l_bn)
			l_tp3.ce_gets (a_tp + 2 * l_bn)
			l_k2 := a_k + {NATURAL_32} 1
			l_d := 0
			from
			until
				js.loop_left
			loop
				js.reset
				l_n := a_k
				l_inv := (gmp_impl_inst.gmp_binvert_limb_table[((l_n // {NATURAL_32} 2).bit_and ({NATURAL_32} 127)).to_integer_32]).to_natural_32
				l_inv := {NATURAL_32} 2 * l_inv - (l_inv * l_inv) * l_n
				l_inv := {NATURAL_32} 2 * l_inv - (l_inv * l_inv) * l_n
				l_di := (l_inv).bit_and ({NATURAL_32} 4294967295)
				js.break
			end
			js.reset
			a_rp[0] := (1).to_natural_32
			from
			until
				l_b = {NATURAL_32} 1
			loop
				l_tmp := l_d
				l_d := l_d + 1
				l_order[l_tmp] := l_b
				l_b := ((l_b + {NATURAL_32} 1)).bit_shift_right (1)
			end
			l_i := l_d - 1
			from
			until
				not (l_i >= 0)
			loop
				l_b := l_order[l_i]
				l_bn := ({NATURAL_32} 1 + (l_b - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32
				gmp_inst.gmpn_mul_1 (a_tp, a_rp, l_bn, l_k2).do_nothing
				powlo_inst.gmpn_powlo (l_tp2, a_rp, (create {CE_POINTER [NATURAL_32]}.make_shared ($l_k2)), (1).to_integer_32, l_bn, l_tp3)
				mullo_n_inst.gmpn_mullo_n (a_rp, a_yp, l_tp2, l_bn)
				gmp_inst.gmpn_sub_n (l_tp2, a_tp, a_rp, l_bn).do_nothing
				bdiv_q_1_inst.gmpn_pi1_bdiv_q_1 (a_rp, l_tp2, l_bn, a_k, l_di, 0).do_nothing
				if l_b \\ {NATURAL_32} 32 /= {NATURAL_32} 0 then
					a_rp[((l_b - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32] := (a_rp[((l_b - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32]).bit_and (((({NATURAL_32} 1).bit_shift_left ((l_b \\ {NATURAL_32} 32).to_integer_32)) - {NATURAL_32} 1))
				end
				l_i := l_i - 1
			end
		end

	binv_sqroot (a_rp: CE_POINTER [NATURAL_32]; a_yp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_b: NATURAL_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_bn: INTEGER_32
			l_b: NATURAL_32
			l_k: NATURAL_32
			l_tp2: CE_POINTER [NATURAL_32]
			l_tp3: CE_POINTER [NATURAL_32]
			l_order: CE_ARRAY [NATURAL_32]
			l_i: INTEGER_32
			l_d: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_tp2.make
			create l_tp3.make
			create l_order.make (<<64>>)

			l_bn := a_bn
			l_b := a_b
			l_k := (3).to_natural_32
			l_tp2.ce_gets (a_tp + l_bn)
			l_tp3.ce_gets (a_tp + ((l_bn).bit_shift_left (1)))
			l_d := 0
			a_rp[0] := (1).to_natural_32
			if l_b = {NATURAL_32} 1 then
				if ((a_yp[0]).bit_and ({NATURAL_32} 3)) /= {NATURAL_32} 1 then
					Result := 0
					js.return
				end
			else
				if ((a_yp[0]).bit_and ({NATURAL_32} 7)) /= {NATURAL_32} 1 then
					Result := 0
					js.return
				end
				if not js.return_called then
					from
					until
						l_b = {NATURAL_32} 2
					loop
						l_tmp := l_d
						l_d := l_d + 1
						l_order[l_tmp] := l_b
						l_b := ((l_b + {NATURAL_32} 2)).bit_shift_right (1)
					end
					l_i := l_d - 1
					from
					until
						not (l_i >= 0)
					loop
						l_b := l_order[l_i]
						l_bn := ({NATURAL_32} 1 + l_b // {NATURAL_32} 32).to_integer_32
						gmp_inst.gmpn_mul_1 (a_tp, a_rp, l_bn, l_k).do_nothing
						powlo_inst.gmpn_powlo (l_tp2, a_rp, (create {CE_POINTER [NATURAL_32]}.make_shared ($l_k)), (1).to_integer_32, l_bn, l_tp3)
						mullo_n_inst.gmpn_mullo_n (a_rp, a_yp, l_tp2, l_bn)
						gmp_inst.gmpn_sub_n (l_tp2, a_tp, a_rp, l_bn).do_nothing
						gmp_inst.gmpn_rshift (a_rp, l_tp2, l_bn, {NATURAL_32} 1).do_nothing
						a_rp[(l_b // {NATURAL_32} 32).to_integer_32] := (a_rp[(l_b // {NATURAL_32} 32).to_integer_32]).bit_and (((({NATURAL_32} 1).bit_shift_left ((l_b \\ {NATURAL_32} 32).to_integer_32)) - {NATURAL_32} 1))
						l_i := l_i - 1
					end
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	is_kth_power (a_rp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_yp: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_f: NATURAL_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_x___2: NATURAL_32
			l_c: NATURAL_32
			l_b: NATURAL_32
			l_i: INTEGER_32
			l_rn: INTEGER_32
			l_xn: INTEGER_32
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_dst.make
			create l_tmp___3.make

			if a_k = {NATURAL_32} 2 then
				l_b := ((a_f + {NATURAL_32} 1)).bit_shift_right (1)
				l_rn := ({NATURAL_32} 1 + l_b // {NATURAL_32} 32).to_integer_32
				if (binv_sqroot (a_rp, a_yp, l_rn, l_b, a_tp)) /= 0 then
					l_xn := l_rn
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							not (not js.loop_left and then (l_xn > 0))
						loop
							js.reset
							if a_rp[(l_xn - 1)] /= {NATURAL_32} 0 then
								js.break
							end
							if not js.loop_jumped then
								l_xn := l_xn - 1
							end
						end
						js.reset
						js.break
					end
					js.reset
					if (pow_equals (a_np, a_nn, a_rp, l_xn, a_k, a_f, a_tp)) /= 0 then
						Result := 1
						js.return
					end
					if not js.return_called then
						l_c := (0).to_natural_32
						l_i := (0).to_integer_32
						from
						until
							not (l_i < l_rn)
						loop
							l_x___2 := a_rp[l_i]
							a_rp[l_i] := (-l_x___2.to_integer_32).to_natural_32 - l_c
							l_c := (l_c).bit_or ((l_x___2 /= {NATURAL_32} 0).to_integer.to_natural_32)
							l_i := l_i + 1
						end
						a_rp[(l_rn - 1)] := (a_rp[(l_rn - 1)]).bit_and (((({NATURAL_32} 1).bit_shift_left ((l_b \\ {NATURAL_32} 32).to_integer_32)) - {NATURAL_32} 1))
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								not (not js.loop_left and then (l_rn > 0))
							loop
								js.reset
								if a_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
									js.break
								end
								if not js.loop_jumped then
									l_rn := l_rn - 1
								end
							end
							js.reset
							js.break
						end
						js.reset
						if (pow_equals (a_np, a_nn, a_rp, l_rn, a_k, a_f, a_tp)) /= 0 then
							Result := 1
							js.return
						end
					end
				end
			else
				l_b := {NATURAL_32} 1 + (a_f - {NATURAL_32} 1) // a_k
				l_rn := ({NATURAL_32} 1 + (l_b - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32
				binv_root (a_rp, a_yp, a_k, l_rn, l_b, a_tp)
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						not (not js.loop_left and then (l_rn > 0))
					loop
						js.reset
						if a_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
							js.break
						end
						if not js.loop_jumped then
							l_rn := l_rn - 1
						end
					end
					js.reset
					js.break
				end
				js.reset
				if (pow_equals (a_np, a_nn, a_rp, l_rn, a_k, a_f, a_tp)) /= 0 then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					if l_rn /= 0 then
						l_dst.ce_gets (a_rp)
						l_n := l_rn
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp___3.ce_gets (l_dst)
							l_dst.ce_gets (l_dst + 1)
							l_tmp___3.item := (0).to_natural_32
							l_n := l_n - 1
							if not l_n.to_boolean then
								js.break
							end
						end
						js.reset
					end
					js.break
				end
				js.reset
				Result := 0
			end
		end

	perfpow (a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_ub: NATURAL_32; a_g: NATURAL_32; a_f: NATURAL_32; a_neg: INTEGER_32): INTEGER_32
		local
			l_ub: NATURAL_32
			l_yp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_k: NATURAL_32
			l_rp1: CE_POINTER [NATURAL_32]
			l_ans: INTEGER_32
			l_b: NATURAL_32
			l_ps: PD_GMP_PRIMESIEVE_T
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___7: CE_POINTER [ANY]
			l_tmp___12: CE_POINTER [ANY]
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___14: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_yp.make
			create l_tp.make
			create l_rp1.make
			create l_ps.make
			create l_tmp_marker.make
			create l_tmp___2.make
			create l_tmp___7.make
			create l_tmp___12.make
			create l_dst.make
			create l_tmp___14.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ub := a_ub
					l_k := (0).to_natural_32
					l_ans := 0
					l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
					nextprime_inst.gmp_init_primesieve (l_ps.address)
					l_b := ((a_f + {NATURAL_32} 3)).bit_shift_right (1)
					if (builtin_expect ((a_nn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___2.ce_gets ((l_aaf.new ((a_nn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___2.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (a_nn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_yp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2))
					if (builtin_expect ((a_nn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___7.ce_gets ((l_aaf.new ((a_nn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___7.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (a_nn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_rp1.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___7))
					if (builtin_expect (((5 * a_nn).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___12.ce_gets ((l_aaf.new (((5 * a_nn).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___12.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((5 * a_nn).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___12))
					from
					until
						js.loop_left
					loop
						js.reset
						if a_nn /= 0 then
							l_dst.ce_gets (l_rp1)
							l_n := a_nn
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___14.ce_gets (l_dst)
								l_dst.ce_gets (l_dst + 1)
								l_tmp___14.item := (0).to_natural_32
								l_n := l_n - 1
								if not l_n.to_boolean then
									js.break
								end
							end
							js.reset
						end
						js.break
					end
					js.reset
					binvert_inst.gmpn_binvert (l_yp, a_np, ({NATURAL_32} 1 + (l_b - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32, l_tp)
					if (l_b \\ {NATURAL_32} 32).to_boolean then
						l_yp[((l_b - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32] := (l_yp[((l_b - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32]).bit_and (((({NATURAL_32} 1).bit_shift_left ((l_b \\ {NATURAL_32} 32).to_integer_32)) - {NATURAL_32} 1))
					end
					if a_neg.to_boolean then
						nextprime_inst.gmp_nextprime (l_ps.address).do_nothing
					end
					if not (a_g > {NATURAL_32} 0) then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if l_ub < a_g + {NATURAL_32} 1 then
							l_ub := l_ub
						else
							l_ub := a_g + {NATURAL_32} 1
						end
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						l_k := nextprime_inst.gmp_nextprime (l_ps.address)
						if not (l_k < l_ub) then
							js.break
						end
						if not js.loop_jumped and then (a_g \\ l_k = {NATURAL_32} 0) then
							if (is_kth_power (l_rp1, a_np, l_k, l_yp, a_nn, a_f, l_tp)) /= 0 then
								l_ans := 1
								l_pos := -1 + 11 -- goto ret
							end
						end
				when 4 then
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
						js.reset
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else: | loop condition:
						if js.loop_left then
							l_pos := -1 + 10 -- skip loop
						end
				when 8 then -- loop body:
						js.reset
						l_k := nextprime_inst.gmp_nextprime (l_ps.address)
						if not (l_k < l_ub) then
							js.break
						end
						if not js.loop_jumped then
							if (is_kth_power (l_rp1, a_np, l_k, l_yp, a_nn, a_f, l_tp)) /= 0 then
								l_ans := 1
								l_pos := -1 + 11 -- goto ret
							end
						end
				when 9 then
						l_pos := -1 + 7 -- back to loop condition
				when 10 then -- loop done
						js.reset
				when 11 then -- ret:
					from
					until
						js.loop_left
					loop
						js.reset
						if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
							tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
						end
						js.break
					end
					js.reset
					Result := l_ans
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_perfect_power_p (a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32): INTEGER_32
		local
			l_nn: INTEGER_32
			l_ncn: INTEGER_32
			l_s: INTEGER_32
			l_pn: INTEGER_32
			l_xn: INTEGER_32
			l_nc: CE_POINTER [NATURAL_32]
			l_factor: NATURAL_32
			l_g: NATURAL_32
			l_exp: NATURAL_32
			l_prev: CE_POINTER [NATURAL_32]
			l_next: CE_POINTER [NATURAL_32]
			l_d: NATURAL_32
			l_l: NATURAL_32
			l_r: NATURAL_32
			l_c: NATURAL_32
			l_tp: CE_POINTER [NATURAL_32]
			l_cry: NATURAL_32
			l_twos: NATURAL_32
			l_count: NATURAL_32
			l_ans: INTEGER_32
			l_where: INTEGER_32
			l_neg: INTEGER_32
			l_trial: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp: INTEGER_32
			l_tmp___3: CE_POINTER [ANY]
			l_tmp___8: CE_POINTER [ANY]
			l_tmp___13: CE_POINTER [ANY]
			l_tmp___18: CE_POINTER [ANY]
			l_tmp___23: CE_POINTER [ANY]
			l_n: NATURAL_32
			l_inv: NATURAL_32
			l_mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l_mp_ptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			l_tmp___27: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_nc.make
			create l_prev.make
			create l_next.make
			create l_tp.make
			create l_tmp_marker.make
			create l_tmp___3.make
			create l_tmp___8.make
			create l_tmp___13.make
			create l_tmp___18.make
			create l_tmp___23.make
			create l_mp_ptr_swap__tmp.make
			create l_mp_ptr_swap__tmp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_nn := a_nn
					l_g := (0).to_natural_32
					l_twos := (0).to_natural_32
					l_where := 0
					l_neg := 0
					l_nc.ce_gets (a_np)
					if l_nn < 0 then
						l_neg := 1
						l_nn := -l_nn
					end
					if l_nn = 0 then
						Result := 1
						js.return
					elseif l_nn = 1 then
						if a_np[0] = {NATURAL_32} 1 then
							Result := 1
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
						l_ncn := l_nn
						l_twos := scan1_inst.gmpn_scan1 (a_np, (0).to_natural_32)
						if not (l_twos > {NATURAL_32} 0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 2 then -- if:
						if l_twos = {NATURAL_32} 1 then
							l_ans := 0
							l_pos := -1 + 13 -- goto ret
						end
				when 3 then
						l_s := (l_twos // {NATURAL_32} 32).to_integer_32
						if l_s + 1 = l_nn then
							if ((a_np[l_s]).bit_and ((a_np[l_s] - {NATURAL_32} 1))) = {NATURAL_32} 0 then
								if l_neg.to_boolean then
									if ((l_twos).bit_and ((l_twos - {NATURAL_32} 1))) = {NATURAL_32} 0 then
										l_tmp := 0
									else
										l_tmp := 1
									end
								else
									l_tmp := 1
								end
								l_ans := l_tmp
								l_pos := -1 + 13 -- goto ret
							end
						end
				when 4 then
						l_count := l_twos \\ {NATURAL_32} 32
						l_ncn := l_nn - l_s
						if (builtin_expect ((l_ncn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___3.ce_gets ((l_aaf.new ((l_ncn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___3.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_ncn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_nc.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___3))
						if l_count > {NATURAL_32} 0 then
							gmp_inst.gmpn_rshift (l_nc, a_np + l_s, l_ncn, l_count.to_natural_32).do_nothing
							l_ncn := l_ncn - (l_nc[(l_ncn - 1)] = {NATURAL_32} 0).to_integer
						else
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_nc, a_np + l_s, l_ncn)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
						end
						l_g := l_twos
				when 5 then -- if done
						if l_ncn <= 20 then
							l_trial := 0
						elseif l_ncn <= 100 then
							l_trial := 1
						else
							l_trial := 2
						end
						l_factor := trialdiv_inst.gmpn_trialdiv (l_nc, l_ncn, (nrtrial[l_trial]).to_integer_32, create {CE_POINTER [INTEGER_32]}.make_shared ($l_where))
						if l_factor = {NATURAL_32} 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 6 then -- if:
						if l_twos = {NATURAL_32} 0 then
							if (builtin_expect ((l_ncn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
								l_tmp___8.ce_gets ((l_aaf.new ((l_ncn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							else
								l_tmp___8.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_ncn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_nc.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___8))
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_nc, a_np, l_ncn)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
						end
						if (builtin_expect (((l_ncn + 2).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___13.ce_gets ((l_aaf.new (((l_ncn + 2).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___13.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_ncn + 2).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_prev.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___13))
						if (builtin_expect (((l_ncn + 2).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___18.ce_gets ((l_aaf.new (((l_ncn + 2).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___18.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_ncn + 2).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_next.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___18))
						if (builtin_expect (((4 * l_ncn).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___23.ce_gets ((l_aaf.new (((4 * l_ncn).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___23.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((4 * l_ncn).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___23))
				when 7 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 11 -- skip loop
						end
				when 8 then -- loop body:
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							l_n := l_factor
							l_inv := (gmp_impl_inst.gmp_binvert_limb_table[((l_n // {NATURAL_32} 2).bit_and ({NATURAL_32} 127)).to_integer_32]).to_natural_32
							l_inv := {NATURAL_32} 2 * l_inv - (l_inv * l_inv) * l_n
							l_inv := {NATURAL_32} 2 * l_inv - (l_inv * l_inv) * l_n
							l_d := (l_inv).bit_and ({NATURAL_32} 4294967295)
							js.break
						end
						js.reset
						l_prev[0] := l_d
						l_pn := (1).to_integer_32
						l_exp := (1).to_natural_32
						from
						until
							not (not js.loop_left and then (2 * l_pn - 1 <= l_ncn))
						loop
							js.reset
							sqr_inst.gmpn_sqr (l_next, l_prev, l_pn)
							l_xn := 2 * l_pn
							l_xn := l_xn - (l_next[(l_xn - 1)] = {NATURAL_32} 0).to_integer
							if (divis_inst.gmpn_divisible_p (l_nc, l_ncn, l_next, l_xn)) = 0 then
								js.break
							end
							if not js.loop_jumped then
								l_exp := (l_exp).bit_shift_left ((1))
								l_pn := l_xn
								from
								until
									js.loop_left
								loop
									js.reset
									l_mp_ptr_swap__tmp.ce_gets (l_next)
									l_next.ce_gets (l_prev)
									l_prev.ce_gets (l_mp_ptr_swap__tmp)
									js.break
								end
								js.reset
							end
						end
						js.reset
						l_l := l_exp + {NATURAL_32} 1
						l_r := {NATURAL_32} 2 * l_exp - {NATURAL_32} 1
						from
						until
							not (not js.loop_left and then (l_l <= l_r))
						loop
							js.reset
							l_c := ((l_l + l_r)).bit_shift_right (1)
							if l_c - l_exp > {NATURAL_32} 1 then
								l_xn := pow_1_inst.gmpn_pow_1 (l_tp, (create {CE_POINTER [NATURAL_32]}.make_shared ($l_d)), (1).to_integer_32, l_c - l_exp, l_next)
								if (l_pn + l_xn) - 1 > l_ncn then
									l_r := l_c - {NATURAL_32} 1
									js.continue
								end
								if not js.loop_jumped then
									mul_inst.gmpn_mul (l_next, l_prev, l_pn, l_tp, l_xn).do_nothing
									l_xn := l_xn + l_pn
									l_xn := l_xn - (l_next[(l_xn - 1)] = {NATURAL_32} 0).to_integer
								end
							else
								l_cry := gmp_inst.gmpn_mul_1 (l_next, l_prev, l_pn, l_d)
								l_next[l_pn] := l_cry
								l_xn := l_pn + (l_cry /= {NATURAL_32} 0).to_integer
							end
							if not js.loop_jumped then
								if (divis_inst.gmpn_divisible_p (l_nc, l_ncn, l_next, l_xn)) = 0 then
									l_r := l_c - {NATURAL_32} 1
								else
									l_exp := l_c
									l_l := l_c + {NATURAL_32} 1
									from
									until
										js.loop_left
									loop
										js.reset
										l_mp_ptr_swap__tmp___0.ce_gets (l_next)
										l_next.ce_gets (l_prev)
										l_prev.ce_gets (l_mp_ptr_swap__tmp___0)
										js.break
									end
									js.reset
									l_pn := l_xn
								end
							end
						end
						if l_g = {NATURAL_32} 0 then
							l_g := l_exp
						else
							l_g := gcd_1_inst.gmpn_gcd_1 ((create {CE_POINTER [NATURAL_32]}.make_shared ($l_g)), (1).to_integer_32, l_exp)
						end
						if l_g = {NATURAL_32} 1 then
							l_ans := 0
							l_pos := -1 + 13 -- goto ret
						end
				when 9 then
						divexact_inst.gmpn_divexact (l_next, l_nc, l_ncn, l_prev, l_pn)
						l_ncn := l_ncn - l_pn
						l_ncn := l_ncn + (l_next[l_ncn] /= {NATURAL_32} 0).to_integer
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (l_nc, l_next, l_ncn)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						if l_ncn = 1 then
							if l_nc[0] = {NATURAL_32} 1 then
								if l_neg.to_boolean then
									if ((l_g).bit_and ((l_g - {NATURAL_32} 1))) = {NATURAL_32} 0 then
										l_tmp___27 := 0
									else
										l_tmp___27 := 1
									end
								else
									l_tmp___27 := 1
								end
								l_ans := l_tmp___27
								l_pos := -1 + 13 -- goto ret
							end
						end
				when 10 then
						l_factor := trialdiv_inst.gmpn_trialdiv (l_nc, l_ncn, (nrtrial[l_trial]).to_integer_32, create {CE_POINTER [INTEGER_32]}.make_shared ($l_where))
						if l_factor = {NATURAL_32} 0 then
							js.break
						end
						l_pos := -1 + 7 -- back to loop condition
				when 11 then -- loop done
						js.reset
				when 12 then -- if done
						from
						until
							js.loop_left
						loop
							js.reset
							l_count := (builtin_clzl (l_nc[(l_ncn - 1)])).to_natural_32
							js.break
						end
						js.reset
						l_count := (32 * l_ncn).to_natural_32 - l_count
						l_d := (l_count.to_real_64 * logs[l_trial] + 1.e-9).truncated_to_integer_64.to_natural_32 + {NATURAL_32} 1
						l_ans := perfpow (l_nc, l_ncn, l_d, l_g, l_count, l_neg)
				when 13 then -- ret:
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
							end
							js.break
						end
						js.reset
						Result := l_ans
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
