class
	P_POW_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_pow_ui (a_r: CE_POINTER [PD_MPF_STRUCT]; a_b: CE_POINTER [PD_MPF_STRUCT]; a_e: NATURAL_32)
		local
			l_b2: CE_ARRAY [PD_MPF_STRUCT]
			l_e2: NATURAL_32
		do
			create l_b2.make (<<1>>)

			init2_inst.gmpf_init2 (l_b2, (get_prc_inst.gmpf_get_prec (a_r)))
			set_inst.gmpf_set (l_b2, a_b)
			set_ui_inst.gmpf_set_ui (a_r, {NATURAL_32} 1)
			if ((a_e).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
				set_inst.gmpf_set (a_r, create {CE_POINTER [PD_MPF_STRUCT]}.make_cast (l_b2))
			end
			l_e2 := (a_e).bit_shift_right (1)
			from
			until
				l_e2 = {NATURAL_32} 0
			loop
				mul_inst.gmpf_mul (l_b2, create {CE_POINTER [PD_MPF_STRUCT]}.make_cast (l_b2), create {CE_POINTER [PD_MPF_STRUCT]}.make_cast (l_b2))
				if ((l_e2).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
					mul_inst.gmpf_mul (a_r, a_r, create {CE_POINTER [PD_MPF_STRUCT]}.make_cast (l_b2))
				end
				l_e2 := (l_e2).bit_shift_right ((1))
			end
			clear_inst.gmpf_clear (l_b2)
		end

	gmpz_pow_ui (a_r: CE_POINTER [PD_MPZ_STRUCT]; a_b: CE_POINTER [PD_MPZ_STRUCT]; a_e: NATURAL_32)
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_e.to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 0
					set_ui_inst.gmpz_set_ui (a_r, {NATURAL_32} 1)
					l_pos := -1 + 5 -- switch 1; break
				when 2 then -- switch 1, case 1
					set_inst.gmpz_set (a_r, a_b)
					l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case 2
					mul_inst.gmpz_mul (a_r, a_b, a_b)
					l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, default:
					n_pow_ui_inst.gmpz_n_pow_ui (a_r, a_b.item.mp_d, (a_b.item.mp_size).to_integer_32, a_e)
				when 5 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
