class
	P_POWM

inherit
	LIBGMP_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {NONE} -- Initialization

	default_create
		do
			create x.make (<<11>>)
		end

feature {ANY} -- attributes

	x: CE_ARRAY [NATURAL_32]

feature {ANY} -- routines

	gmpz_powm (a_r: CE_POINTER [PD_MPZ_STRUCT]; a_b: CE_POINTER [PD_MPZ_STRUCT]; a_e: CE_POINTER [PD_MPZ_STRUCT]; a_m: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_b: CE_POINTER [PD_MPZ_STRUCT]
			l_n: INTEGER_32
			l_nodd: INTEGER_32
			l_ncnt: INTEGER_32
			l_cnt: INTEGER_32
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_bp: CE_POINTER [NATURAL_32]
			l_ep: CE_POINTER [NATURAL_32]
			l_mp: CE_POINTER [NATURAL_32]
			l_rn: INTEGER_32
			l_bn: INTEGER_32
			l_es: INTEGER_32
			l_en: INTEGER_32
			l_itch: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_new_b: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp: INTEGER_32
			l_x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___4: CE_POINTER [ANY]
			l_tmp___13: CE_POINTER [ANY]
			l_qp: CE_POINTER [NATURAL_32]
			l_tmp___18: CE_POINTER [ANY]
			l_tmp___20: INTEGER_32
			l_new: CE_POINTER [NATURAL_32]
			l_tmp___26: CE_POINTER [ANY]
			l_n_largest_binvert: INTEGER_32
			l_tmp___28: INTEGER_32
			l_itch_binvert: INTEGER_32
			l_tmp___30: INTEGER_32
			l_itch_binvert___0: INTEGER_32
			l_tmp___32: INTEGER_32
			l_tmp___36: CE_POINTER [ANY]
			l_r2: CE_POINTER [NATURAL_32]
			l_xp: CE_POINTER [NATURAL_32]
			l_yp: CE_POINTER [NATURAL_32]
			l_odd_inv_2exp: CE_POINTER [NATURAL_32]
			l_t: NATURAL_32
			l_bcnt: INTEGER_32
			l_new___0: CE_POINTER [NATURAL_32]
			l_tmp___41: CE_POINTER [ANY]
			l_dst: CE_POINTER [NATURAL_32]
			l_n2: INTEGER_32
			l_tmp___43: CE_POINTER [NATURAL_32]
			l_dst___0: CE_POINTER [NATURAL_32]
			l_n___0: INTEGER_32
			l_tmp___44: CE_POINTER [NATURAL_32]
			l_dst___1: CE_POINTER [NATURAL_32]
			l_n___1: INTEGER_32
			l_tmp___45: CE_POINTER [NATURAL_32]
			l_new___1: CE_POINTER [NATURAL_32]
			l_tmp___49: CE_POINTER [ANY]
			l_dst___2: CE_POINTER [NATURAL_32]
			l_n___2: INTEGER_32
			l_tmp___51: CE_POINTER [NATURAL_32]
			l_tmp___52: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_b.make
			create l_rp.make
			create l_tp.make
			create l_bp.make
			create l_ep.make
			create l_mp.make
			create l_tmp_marker.make
			create l_new_b.make (<<1>>)
			create l_x.make
			create l_tmp___4.make
			create l_tmp___13.make
			create l_qp.make
			create l_tmp___18.make
			create l_new.make
			create l_tmp___26.make
			create l_tmp___36.make
			create l_r2.make
			create l_xp.make
			create l_yp.make
			create l_odd_inv_2exp.make
			create l_new___0.make
			create l_tmp___41.make
			create l_dst.make
			create l_tmp___43.make
			create l_dst___0.make
			create l_tmp___44.make
			create l_dst___1.make
			create l_tmp___45.make
			create l_new___1.make
			create l_tmp___49.make
			create l_dst___2.make
			create l_tmp___51.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_b.ce_gets (a_b)
					if a_m.item.mp_size >= 0 then
						l_n := (a_m.item.mp_size).to_integer_32
					else
						l_n := (-a_m.item.mp_size).to_integer_32
					end
					if l_n = 0 then
						errno_inst.gmp_divide_by_zero
					end
					l_mp.ce_gets (a_m.item.mp_d)
					l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
					l_es := (a_e.item.mp_size).to_integer_32
					if (builtin_expect ((l_es <= 0).to_integer, 0)).to_boolean then
						if l_es = 0 then
							if l_n /= 1 then
								l_tmp := 1
							elseif l_mp[0] /= {NATURAL_32} 1 then
								l_tmp := 1
							else
								l_tmp := 0
							end
							a_r.item.mp_size := l_tmp
							a_r.item.mp_d[0] := (1).to_natural_32
							from
							until
								js.loop_left
							loop
								js.reset
								if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
									tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
								end
								js.break
							end
							js.reset
							js.return
						end
						if not js.return_called then
							from
							until
								js.loop_left
							loop
								js.reset
								l_x.ce_gets (l_new_b)
								l_x.item.mp_alloc := (l_n + 1).to_integer_32
								if (builtin_expect (((l_n + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
									l_tmp___4.ce_gets ((l_aaf.new (((l_n + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
								else
									l_tmp___4.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_n + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
								end
								l_x.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___4)
								js.break
							end
							js.reset
							if not (invert_inst.gmpz_invert (l_new_b, l_b, a_m)).to_boolean then
								errno_inst.gmp_divide_by_zero
							end
							l_b.ce_gets (create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_new_b))
							l_es := -l_es
						end
					end
					if not js.return_called then
						l_en := l_es
						if l_b.item.mp_size >= 0 then
							l_bn := (l_b.item.mp_size).to_integer_32
						else
							l_bn := (-l_b.item.mp_size).to_integer_32
						end
						if (builtin_expect ((l_bn = 0).to_integer, 0)).to_boolean then
							a_r.item.mp_size := 0
							from
							until
								js.loop_left
							loop
								js.reset
								if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
									tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
								end
								js.break
							end
							js.reset
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						l_ep.ce_gets (a_e.item.mp_d)
						if l_en = 1 then
							if l_ep[0] = {NATURAL_32} 1 then
								l_tmp___20 := 1
							else
								l_tmp___20 := 0
							end
						else
							l_tmp___20 := 0
						end
						if (builtin_expect ((l_tmp___20 /= 0).to_integer, 0)).to_boolean then
							if (builtin_expect ((l_n.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
								l_tmp___13.ce_gets ((l_aaf.new ((l_n.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							else
								l_tmp___13.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_n.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_rp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___13))
							l_bp.ce_gets (l_b.item.mp_d)
							if l_bn >= l_n then
								if (builtin_expect ((((l_bn - l_n) + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
									l_tmp___18.ce_gets ((l_aaf.new ((((l_bn - l_n) + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
								else
									l_tmp___18.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (((l_bn - l_n) + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
								end
								l_qp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___18))
								tdiv_qr_inst.gmpn_tdiv_qr (l_qp, l_rp, 0, l_bp, l_bn, l_mp, l_n)
								l_rn := l_n
								from
								until
									js.loop_left
								loop
									js.reset
									from
									until
										not (not js.loop_left and then (l_rn > 0))
									loop
										js.reset
										if l_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
											js.break
										end
										if not js.loop_jumped then
											l_rn := l_rn - 1
										end
									end
									js.reset
									js.break
								end
								js.reset
								if l_b.item.mp_size < 0 then
									if l_rn /= 0 then
										gmp_inst.gmpn_sub (l_rp, l_mp, l_n, l_rp, l_rn).do_nothing
										l_rn := l_n
										from
										until
											js.loop_left
										loop
											js.reset
											from
											until
												not (not js.loop_left and then (l_rn > 0))
											loop
												js.reset
												if l_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
													js.break
												end
												if not js.loop_jumped then
													l_rn := l_rn - 1
												end
											end
											js.reset
											js.break
										end
										js.reset
									end
								end
							elseif l_b.item.mp_size < 0 then
								gmp_inst.gmpn_sub (l_rp, l_mp, l_n, l_bp, l_bn).do_nothing
								l_rn := l_n
								l_rn := l_rn - (l_rp[(l_rn - 1)] = {NATURAL_32} 0).to_integer
							else
								from
								until
									js.loop_left
								loop
									js.reset
									from
									until
										js.loop_left
									loop
										js.reset
										gmp_inst.gmpn_copyi (l_rp, l_bp, l_bn)
										js.break
									end
									js.reset
									js.break
								end
								js.reset
								l_rn := l_bn
							end
							l_pos := -1 + 9 -- goto ret
						end
				when 2 then
						l_ncnt := (0).to_integer_32
						from
						until
							js.loop_left
						loop
							js.reset
							if not (builtin_expect ((l_mp[0] = {NATURAL_32} 0).to_integer, 0)).to_boolean then
								js.break
							end
							if not js.loop_jumped then
								l_mp.ce_gets (l_mp + 1)
								l_ncnt := l_ncnt + 1
							end
						end
						js.reset
						l_nodd := l_n - l_ncnt
						l_cnt := 0
						if l_mp[0] \\ {NATURAL_32} 2 = {NATURAL_32} 0 then
							if (builtin_expect ((l_nodd.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
								l_tmp___26.ce_gets ((l_aaf.new ((l_nodd.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							else
								l_tmp___26.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_nodd.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_new.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___26))
							from
							until
								js.loop_left
							loop
								js.reset
								l_cnt := builtin_ctzl (l_mp[0])
								js.break
							end
							js.reset
							gmp_inst.gmpn_rshift (l_new, l_mp, l_nodd, l_cnt.to_natural_32).do_nothing
							l_nodd := l_nodd - (l_new[(l_nodd - 1)] = {NATURAL_32} 0).to_integer
							l_mp.ce_gets (l_new)
							l_ncnt := l_ncnt + 1
						end
						if l_ncnt /= 0 then
							if l_ncnt > l_nodd then
								l_tmp___28 := l_ncnt
							else
								l_tmp___28 := l_nodd
							end
							l_n_largest_binvert := l_tmp___28
							l_itch_binvert := (binvert_inst.gmpn_binvert_itch (l_n_largest_binvert))
							if l_itch_binvert > 2 * l_n then
								l_tmp___30 := l_itch_binvert
							else
								l_tmp___30 := 2 * l_n
							end
							l_itch := 3 * l_n + l_tmp___30
						else
							l_itch_binvert___0 := (binvert_inst.gmpn_binvert_itch (l_nodd))
							if l_itch_binvert___0 > 2 * l_n then
								l_tmp___32 := l_itch_binvert___0
							else
								l_tmp___32 := 2 * l_n
							end
							l_itch := l_n + l_tmp___32
						end
						if (builtin_expect ((l_itch.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___36.ce_gets ((l_aaf.new ((l_itch.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___36.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_itch.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___36))
						l_rp.ce_gets (l_tp)
						l_tp.ce_gets (l_tp + l_n)
						l_bp.ce_gets (l_b.item.mp_d)
						gmpn_powm (l_rp, l_bp, l_bn, l_ep, l_en, l_mp, l_nodd, l_tp)
						l_rn := l_n
						if l_ncnt = 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if l_bn < l_ncnt then
							if (builtin_expect ((l_ncnt.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
								l_tmp___41.ce_gets ((l_aaf.new ((l_ncnt.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							else
								l_tmp___41.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_ncnt.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_new___0.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___41))
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_new___0, l_bp, l_bn)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								if l_ncnt - l_bn /= 0 then
									l_dst.ce_gets (l_new___0 + l_bn)
									l_n2 := l_ncnt - l_bn
									from
									until
										js.loop_left
									loop
										js.reset
										l_tmp___43.ce_gets (l_dst)
										l_dst.ce_gets (l_dst + 1)
										l_tmp___43.item := (0).to_natural_32
										l_n2 := l_n2 - 1
										if not l_n2.to_boolean then
											js.break
										end
									end
									js.reset
								end
								js.break
							end
							js.reset
							l_bp.ce_gets (l_new___0)
						end
						l_r2.ce_gets (l_tp)
						if l_bp[0] \\ {NATURAL_32} 2 /= {NATURAL_32} 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_en > 1 then
							from
							until
								js.loop_left
							loop
								js.reset
								if l_ncnt /= 0 then
									l_dst___0.ce_gets (l_r2)
									l_n___0 := l_ncnt
									from
									until
										js.loop_left
									loop
										js.reset
										l_tmp___44.ce_gets (l_dst___0)
										l_dst___0.ce_gets (l_dst___0 + 1)
										l_tmp___44.item := (0).to_natural_32
										l_n___0 := l_n___0 - 1
										if not l_n___0.to_boolean then
											js.break
										end
									end
									js.reset
								end
								js.break
							end
							js.reset
							l_pos := -1 + 7 -- goto zero
						end
				when 5 then
						l_t := ((l_ncnt - (l_cnt /= 0).to_integer) * 32 + l_cnt.to_integer_32).to_natural_32
						l_bcnt := (((4627).bit_shift_right (((((l_bp[0]).bit_and ({NATURAL_32} 7))).bit_shift_left (1)).to_integer_32))).bit_and (3)
						if l_ep[0] * l_bcnt.to_natural_32 >= l_t then
							from
							until
								js.loop_left
							loop
								js.reset
								if l_ncnt /= 0 then
									l_dst___1.ce_gets (l_r2)
									l_n___1 := l_ncnt
									from
									until
										js.loop_left
									loop
										js.reset
										l_tmp___45.ce_gets (l_dst___1)
										l_dst___1.ce_gets (l_dst___1 + 1)
										l_tmp___45.item := (0).to_natural_32
										l_n___1 := l_n___1 - 1
										if not l_n___1.to_boolean then
											js.break
										end
									end
									js.reset
								end
								js.break
							end
							js.reset
							l_pos := -1 + 7 -- goto zero
						end
				when 6 then
						powlo_inst.gmpn_powlo (l_r2, l_bp, l_ep, l_en, l_ncnt, l_tp + l_ncnt)
				when 7 then -- zero:
						if l_nodd < l_ncnt then
							if (builtin_expect ((l_ncnt.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
								l_tmp___49.ce_gets ((l_aaf.new ((l_ncnt.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							else
								l_tmp___49.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_ncnt.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_new___1.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___49))
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_new___1, l_mp, l_nodd)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								if l_ncnt - l_nodd /= 0 then
									l_dst___2.ce_gets (l_new___1 + l_nodd)
									l_n___2 := l_ncnt - l_nodd
									from
									until
										js.loop_left
									loop
										js.reset
										l_tmp___51.ce_gets (l_dst___2)
										l_dst___2.ce_gets (l_dst___2 + 1)
										l_tmp___51.item := (0).to_natural_32
										l_n___2 := l_n___2 - 1
										if not l_n___2.to_boolean then
											js.break
										end
									end
									js.reset
								end
								js.break
							end
							js.reset
							l_mp.ce_gets (l_new___1)
						end
						l_odd_inv_2exp.ce_gets (l_tp + l_n)
						binvert_inst.gmpn_binvert (l_odd_inv_2exp, l_mp, l_ncnt, l_tp + 2 * l_n)
						if l_nodd > l_ncnt then
							l_tmp___52 := l_ncnt
						else
							l_tmp___52 := l_nodd
						end
						gmp_inst.gmpn_sub (l_r2, l_r2, l_ncnt, l_rp, l_tmp___52).do_nothing
						l_xp.ce_gets (l_tp + 2 * l_n)
						mullo_n_inst.gmpn_mullo_n (l_xp, l_odd_inv_2exp, l_r2, l_ncnt)
						if l_cnt /= 0 then
							l_xp[(l_ncnt - 1)] := (l_xp[(l_ncnt - 1)]).bit_and (((({NATURAL_32} 1).bit_shift_left (l_cnt)) - {NATURAL_32} 1))
						end
						l_yp.ce_gets (l_tp)
						if l_ncnt > l_nodd then
							mul_inst.gmpn_mul (l_yp, l_xp, l_ncnt, l_mp, l_nodd).do_nothing
						else
							mul_inst.gmpn_mul (l_yp, l_mp, l_nodd, l_xp, l_ncnt).do_nothing
						end
						gmp_inst.gmpn_add (l_rp, l_yp, l_n, l_rp, l_nodd).do_nothing
				when 8 then -- if done
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								not (not js.loop_left and then (l_rn > 0))
							loop
								js.reset
								if l_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
									js.break
								end
								if not js.loop_jumped then
									l_rn := l_rn - 1
								end
							end
							js.reset
							js.break
						end
						js.reset
						if ((l_ep[0]).bit_and ({NATURAL_32} 1)).to_boolean then
							if l_b.item.mp_size < 0 then
								if l_rn /= 0 then
									gmp_inst.gmpn_sub (l_rp, a_m.item.mp_d, l_n, l_rp, l_rn).do_nothing
									l_rn := l_n
									from
									until
										js.loop_left
									loop
										js.reset
										from
										until
											not (not js.loop_left and then (l_rn > 0))
										loop
											js.reset
											if l_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
												js.break
											end
											if not js.loop_jumped then
												l_rn := l_rn - 1
											end
										end
										js.reset
										js.break
									end
									js.reset
								end
							end
						end
				when 9 then -- ret:
						if (builtin_expect ((l_rn > (a_r.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
							realloc_inst.gmpz_realloc (a_r, l_rn).do_nothing
						end
						a_r.item.mp_size := l_rn.to_integer_32
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (a_r.item.mp_d, l_rp, l_rn)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
							end
							js.break
						end
						js.reset
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	getbits (a_p: CE_POINTER [NATURAL_32]; a_bi: NATURAL_32; a_nbits: INTEGER_32): NATURAL_32
		local
			l_bi: NATURAL_32
			l_nbits_in_r: INTEGER_32
			l_r: NATURAL_32
			l_i: INTEGER_32
		do
			l_bi := a_bi
			if l_bi < a_nbits.to_natural_32 then
				Result := ((a_p[0]).bit_and (((({NATURAL_32} 1).bit_shift_left (l_bi.to_integer_32)) - {NATURAL_32} 1)))
			else
				l_bi := l_bi - a_nbits.to_natural_32
				l_i := (l_bi // {NATURAL_32} 32).to_integer_32
				l_bi := l_bi \\ ({NATURAL_32} 32)
				l_r := ((a_p[l_i]).bit_shift_right (l_bi.to_integer_32))
				l_nbits_in_r := ({NATURAL_32} 32 - l_bi).to_integer_32
				if l_nbits_in_r < a_nbits then
					l_r := l_r + ((a_p[(l_i + 1)]).bit_shift_left (l_nbits_in_r))
				end
				Result := ((l_r).bit_and (((({NATURAL_32} 1).bit_shift_left (a_nbits)) - {NATURAL_32} 1)))
			end
		end

	win_size (a_eb: NATURAL_32): INTEGER_32
		local
			l_k: INTEGER_32
		do
			l_k := 1
			from
			until
				not (a_eb > x[l_k])
			loop
				l_k := l_k + 1
			end
			Result := l_k
		end

	redcify (a_rp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_un: INTEGER_32; a_mp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32)
		local
			l_tp: CE_POINTER [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___7: CE_POINTER [ANY]
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___9: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_tp.make
			create l_qp.make
			create l_tmp_marker.make
			create l_tmp___2.make
			create l_tmp___7.make
			create l_dst.make
			create l_tmp___9.make

			l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
			if (builtin_expect (((a_un + a_n).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
				l_tmp___2.ce_gets ((l_aaf.new (((a_un + a_n).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			else
				l_tmp___2.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((a_un + a_n).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			end
			l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2))
			if (builtin_expect (((a_un + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
				l_tmp___7.ce_gets ((l_aaf.new (((a_un + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			else
				l_tmp___7.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((a_un + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			end
			l_qp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___7))
			from
			until
				js.loop_left
			loop
				js.reset
				if a_n /= 0 then
					l_dst.ce_gets (l_tp)
					l_n := a_n
					from
					until
						js.loop_left
					loop
						js.reset
						l_tmp___9.ce_gets (l_dst)
						l_dst.ce_gets (l_dst + 1)
						l_tmp___9.item := (0).to_natural_32
						l_n := l_n - 1
						if not l_n.to_boolean then
							js.break
						end
					end
					js.reset
				end
				js.break
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					gmp_inst.gmpn_copyi (l_tp + a_n, a_up, a_un)
					js.break
				end
				js.reset
				js.break
			end
			js.reset
			tdiv_qr_inst.gmpn_tdiv_qr (l_qp, a_rp, 0, l_tp, a_un + a_n, a_mp, a_n)
			from
			until
				js.loop_left
			loop
				js.reset
				if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
					tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
				end
				js.break
			end
			js.reset
		end

	gmpn_powm (a_rp: CE_POINTER [NATURAL_32]; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_ep: CE_POINTER [NATURAL_32]; a_en: INTEGER_32; a_mp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		local
			l_ip: CE_ARRAY [NATURAL_32]
			l_mip: CE_POINTER [NATURAL_32]
			l_cnt: INTEGER_32
			l_ebi: NATURAL_32
			l_windowsize: INTEGER_32
			l_this_windowsize: INTEGER_32
			l_expbits: NATURAL_32
			l_pp: CE_POINTER [NATURAL_32]
			l_this_pp: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_n: NATURAL_32
			l_inv: NATURAL_32
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___7: CE_POINTER [ANY]
			l_dst: CE_POINTER [NATURAL_32]
			l_n___0: INTEGER_32
			l_tmp___9: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_ip.make (<<2>>)
			create l_mip.make
			create l_pp.make
			create l_this_pp.make
			create l_tmp_marker.make
			create l_tmp___2.make
			create l_tmp___7.make
			create l_dst.make
			create l_tmp___9.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
					from
					until
						js.loop_left
					loop
						js.reset
						l_cnt := builtin_clzl (a_ep[(a_en - 1)])
						js.break
					end
					js.reset
					l_ebi := a_en.to_natural_32 * {NATURAL_32} 32 - l_cnt.to_natural_32
					l_windowsize := win_size (l_ebi)
					if 63 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_n >= 63 then
							if (builtin_expect ((a_n.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
								l_tmp___2.ce_gets ((l_aaf.new ((a_n.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							else
								l_tmp___2.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (a_n.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_mip.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2))
							binvert_inst.gmpn_binvert (l_mip, a_mp, a_n, a_tp)
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						l_mip.ce_gets (l_ip)
						from
						until
							js.loop_left
						loop
							js.reset
							l_n := a_mp[0]
							l_inv := (gmp_impl_inst.gmp_binvert_limb_table[((l_n // {NATURAL_32} 2).bit_and ({NATURAL_32} 127)).to_integer_32]).to_natural_32
							l_inv := {NATURAL_32} 2 * l_inv - (l_inv * l_inv) * l_n
							l_inv := {NATURAL_32} 2 * l_inv - (l_inv * l_inv) * l_n
							l_mip[0] := (l_inv).bit_and ({NATURAL_32} 4294967295)
							js.break
						end
						js.reset
						l_mip[0] := (-(l_mip[0]).to_integer_32).to_natural_32
				when 4 then
					if (builtin_expect ((((a_n).bit_shift_left ((l_windowsize - 1))).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___7.ce_gets ((l_aaf.new ((((a_n).bit_shift_left ((l_windowsize - 1))).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___7.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (((a_n).bit_shift_left ((l_windowsize - 1))).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_pp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___7))
					l_this_pp.ce_gets (l_pp)
					redcify (l_this_pp, a_bp, a_bn, a_mp, a_n)
					sqr_inst.gmpn_sqr (a_tp, l_this_pp, a_n)
					if 63 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
						if a_n >= 63 then
							redc_n_inst.gmpn_redc_n (a_rp, a_tp, a_mp, a_n, l_mip)
						else
							redc_1_inst.gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
						end
					else
						redc_1_inst.gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
					end
					l_i := (((1).bit_shift_left ((l_windowsize - 1))) - 1).to_integer_32
					from
					until
						not (l_i > 0)
					loop
						mul_n_inst.gmpn_mul_n (a_tp, l_this_pp, a_rp, a_n)
						l_this_pp.ce_gets (l_this_pp + a_n)
						if 63 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							if a_n >= 63 then
								redc_n_inst.gmpn_redc_n (l_this_pp, a_tp, a_mp, a_n, l_mip)
							else
								redc_1_inst.gmpn_redc_1 (l_this_pp, a_tp, a_mp, a_n, l_mip[0])
							end
						else
							redc_1_inst.gmpn_redc_1 (l_this_pp, a_tp, a_mp, a_n, l_mip[0])
						end
						l_i := l_i - 1
					end
					l_expbits := getbits (a_ep, l_ebi, l_windowsize)
					if l_ebi < l_windowsize.to_natural_32 then
						l_ebi := (0).to_natural_32
					else
						l_ebi := l_ebi - l_windowsize.to_natural_32
					end
					from
					until
						js.loop_left
					loop
						js.reset
						l_cnt := builtin_ctzl (l_expbits)
						js.break
					end
					js.reset
					l_ebi := l_ebi + l_cnt.to_natural_32
					l_expbits := (l_expbits).bit_shift_right (l_cnt)
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (a_rp, (l_pp + (a_n.to_natural_32 * ((l_expbits).bit_shift_right (1))).to_integer_32), a_n)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
					if True then
						l_pos := -1 + 31 -- skip if block
					end
				when 5 then -- if:
						if 63 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 25 -- skip if block
						end
				when 6 then -- if:
						if not (a_n >= 63) then
							l_pos := -1 + 23 -- skip if block
						end
				when 7 then -- if:
						if 20 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 17 -- skip if block
						end
				when 8 then -- if:
						if not (a_n >= 20) then
							l_pos := -1 + 15 -- skip if block
						end
				when 9 then -- if: | loop condition:
						if not (not js.loop_left and then (l_ebi /= {NATURAL_32} 0)) then
							l_pos := -1 + 14 -- skip loop
						end
				when 10 then -- loop body: | loop condition:
						if ((((a_ep[((l_ebi - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32]).bit_shift_right (((l_ebi - {NATURAL_32} 1) \\ {NATURAL_32} 32).to_integer_32))).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
							l_pos := -1 + 13 -- skip loop
						end
				when 11 then -- loop body:
						sqr_inst.gmpn_sqr (a_tp, a_rp, a_n)
						redc_n_inst.gmpn_redc_n (a_rp, a_tp, a_mp, a_n, l_mip)
						l_ebi := l_ebi - 1
						if l_ebi = {NATURAL_32} 0 then
							l_pos := -1 + 56 -- goto done
						end
				when 12 then
						l_pos := -1 + 10 -- back to loop condition
				when 13 then -- loop done
						l_expbits := getbits (a_ep, l_ebi, l_windowsize)
						l_this_windowsize := l_windowsize
						if l_ebi < l_windowsize.to_natural_32 then
							l_this_windowsize := (l_this_windowsize.to_natural_32 - (l_windowsize.to_natural_32 - l_ebi)).to_integer_32
							l_ebi := (0).to_natural_32
						else
							l_ebi := l_ebi - l_windowsize.to_natural_32
						end
						from
						until
							js.loop_left
						loop
							js.reset
							l_cnt := builtin_ctzl (l_expbits)
							js.break
						end
						js.reset
						l_this_windowsize := l_this_windowsize - l_cnt
						l_ebi := l_ebi + l_cnt.to_natural_32
						l_expbits := (l_expbits).bit_shift_right (l_cnt)
						from
						until
							js.loop_left
						loop
							js.reset
							sqr_inst.gmpn_sqr (a_tp, a_rp, a_n)
							redc_n_inst.gmpn_redc_n (a_rp, a_tp, a_mp, a_n, l_mip)
							l_this_windowsize := l_this_windowsize - 1
							if l_this_windowsize = 0 then
								js.break
							end
						end
						js.reset
						mul_n_inst.gmpn_mul_n (a_tp, a_rp, (l_pp + (a_n.to_natural_32 * ((l_expbits).bit_shift_right (1))).to_integer_32), a_n)
						redc_n_inst.gmpn_redc_n (a_rp, a_tp, a_mp, a_n, l_mip)
						l_pos := -1 + 9 -- back to loop condition
				when 14 then -- loop done | if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						l_pos := -1 + 17 -- goto _L___0
				when 16 then -- if done | if block done, skip else block:
						l_pos := -1 + 22
				when 17 then -- else: | _L___0:
						if not (not js.loop_left and then (l_ebi /= {NATURAL_32} 0)) then
							l_pos := -1 + 22 -- skip loop
						end
				when 18 then -- loop body: | loop condition:
						if ((((a_ep[((l_ebi - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32]).bit_shift_right (((l_ebi - {NATURAL_32} 1) \\ {NATURAL_32} 32).to_integer_32))).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
							l_pos := -1 + 21 -- skip loop
						end
				when 19 then -- loop body:
						gmp_impl_inst.gmpn_sqr_basecase (a_tp, a_rp, a_n)
						redc_n_inst.gmpn_redc_n (a_rp, a_tp, a_mp, a_n, l_mip)
						l_ebi := l_ebi - 1
						if l_ebi = {NATURAL_32} 0 then
							l_pos := -1 + 56 -- goto done
						end
				when 20 then
						l_pos := -1 + 18 -- back to loop condition
				when 21 then -- loop done
						l_expbits := getbits (a_ep, l_ebi, l_windowsize)
						l_this_windowsize := l_windowsize
						if l_ebi < l_windowsize.to_natural_32 then
							l_this_windowsize := (l_this_windowsize.to_natural_32 - (l_windowsize.to_natural_32 - l_ebi)).to_integer_32
							l_ebi := (0).to_natural_32
						else
							l_ebi := l_ebi - l_windowsize.to_natural_32
						end
						from
						until
							js.loop_left
						loop
							js.reset
							l_cnt := builtin_ctzl (l_expbits)
							js.break
						end
						js.reset
						l_this_windowsize := l_this_windowsize - l_cnt
						l_ebi := l_ebi + l_cnt.to_natural_32
						l_expbits := (l_expbits).bit_shift_right (l_cnt)
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_impl_inst.gmpn_sqr_basecase (a_tp, a_rp, a_n)
							redc_n_inst.gmpn_redc_n (a_rp, a_tp, a_mp, a_n, l_mip)
							l_this_windowsize := l_this_windowsize - 1
							if l_this_windowsize = 0 then
								js.break
							end
						end
						js.reset
						gmp_impl_inst.gmpn_mul_basecase (a_tp, a_rp, a_n, (l_pp + (a_n.to_natural_32 * ((l_expbits).bit_shift_right (1))).to_integer_32), a_n)
						redc_n_inst.gmpn_redc_n (a_rp, a_tp, a_mp, a_n, l_mip)
						l_pos := -1 + 17 -- back to loop condition
				when 22 then -- loop done | if done | if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else:
						l_pos := -1 + 25 -- goto _L___1
				when 24 then -- if done | if block done, skip else block:
						l_pos := -1 + 30
				when 25 then -- else: | _L___1:
						if not (not js.loop_left and then (l_ebi /= {NATURAL_32} 0)) then
							l_pos := -1 + 30 -- skip loop
						end
				when 26 then -- loop body: | loop condition:
						if ((((a_ep[((l_ebi - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32]).bit_shift_right (((l_ebi - {NATURAL_32} 1) \\ {NATURAL_32} 32).to_integer_32))).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
							l_pos := -1 + 29 -- skip loop
						end
				when 27 then -- loop body:
						gmp_impl_inst.gmpn_sqr_basecase (a_tp, a_rp, a_n)
						redc_1_inst.gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
						l_ebi := l_ebi - 1
						if l_ebi = {NATURAL_32} 0 then
							l_pos := -1 + 56 -- goto done
						end
				when 28 then
						l_pos := -1 + 26 -- back to loop condition
				when 29 then -- loop done
						l_expbits := getbits (a_ep, l_ebi, l_windowsize)
						l_this_windowsize := l_windowsize
						if l_ebi < l_windowsize.to_natural_32 then
							l_this_windowsize := (l_this_windowsize.to_natural_32 - (l_windowsize.to_natural_32 - l_ebi)).to_integer_32
							l_ebi := (0).to_natural_32
						else
							l_ebi := l_ebi - l_windowsize.to_natural_32
						end
						from
						until
							js.loop_left
						loop
							js.reset
							l_cnt := builtin_ctzl (l_expbits)
							js.break
						end
						js.reset
						l_this_windowsize := l_this_windowsize - l_cnt
						l_ebi := l_ebi + l_cnt.to_natural_32
						l_expbits := (l_expbits).bit_shift_right (l_cnt)
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_impl_inst.gmpn_sqr_basecase (a_tp, a_rp, a_n)
							redc_1_inst.gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
							l_this_windowsize := l_this_windowsize - 1
							if l_this_windowsize = 0 then
								js.break
							end
						end
						js.reset
						gmp_impl_inst.gmpn_mul_basecase (a_tp, a_rp, a_n, (l_pp + (a_n.to_natural_32 * ((l_expbits).bit_shift_right (1))).to_integer_32), a_n)
						redc_1_inst.gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
						l_pos := -1 + 25 -- back to loop condition
				when 30 then -- loop done | if done | if block done, skip else block:
						l_pos := -1 + 56
				when 31 then -- else:
						if 20 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 51 -- skip if block
						end
				when 32 then -- if:
						if not (a_n >= 20) then
							l_pos := -1 + 49 -- skip if block
						end
				when 33 then -- if:
						if 63 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 43 -- skip if block
						end
				when 34 then -- if:
						if not (a_n >= 63) then
							l_pos := -1 + 41 -- skip if block
						end
				when 35 then -- if: | loop condition:
						if not (not js.loop_left and then (l_ebi /= {NATURAL_32} 0)) then
							l_pos := -1 + 40 -- skip loop
						end
				when 36 then -- loop body: | loop condition:
						if ((((a_ep[((l_ebi - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32]).bit_shift_right (((l_ebi - {NATURAL_32} 1) \\ {NATURAL_32} 32).to_integer_32))).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
							l_pos := -1 + 39 -- skip loop
						end
				when 37 then -- loop body:
						sqr_inst.gmpn_sqr (a_tp, a_rp, a_n)
						redc_n_inst.gmpn_redc_n (a_rp, a_tp, a_mp, a_n, l_mip)
						l_ebi := l_ebi - 1
						if l_ebi = {NATURAL_32} 0 then
							l_pos := -1 + 56 -- goto done
						end
				when 38 then
						l_pos := -1 + 36 -- back to loop condition
				when 39 then -- loop done
						l_expbits := getbits (a_ep, l_ebi, l_windowsize)
						l_this_windowsize := l_windowsize
						if l_ebi < l_windowsize.to_natural_32 then
							l_this_windowsize := (l_this_windowsize.to_natural_32 - (l_windowsize.to_natural_32 - l_ebi)).to_integer_32
							l_ebi := (0).to_natural_32
						else
							l_ebi := l_ebi - l_windowsize.to_natural_32
						end
						from
						until
							js.loop_left
						loop
							js.reset
							l_cnt := builtin_ctzl (l_expbits)
							js.break
						end
						js.reset
						l_this_windowsize := l_this_windowsize - l_cnt
						l_ebi := l_ebi + l_cnt.to_natural_32
						l_expbits := (l_expbits).bit_shift_right (l_cnt)
						from
						until
							js.loop_left
						loop
							js.reset
							sqr_inst.gmpn_sqr (a_tp, a_rp, a_n)
							redc_n_inst.gmpn_redc_n (a_rp, a_tp, a_mp, a_n, l_mip)
							l_this_windowsize := l_this_windowsize - 1
							if l_this_windowsize = 0 then
								js.break
							end
						end
						js.reset
						mul_n_inst.gmpn_mul_n (a_tp, a_rp, (l_pp + (a_n.to_natural_32 * ((l_expbits).bit_shift_right (1))).to_integer_32), a_n)
						redc_n_inst.gmpn_redc_n (a_rp, a_tp, a_mp, a_n, l_mip)
						l_pos := -1 + 35 -- back to loop condition
				when 40 then -- loop done | if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else:
						l_pos := -1 + 43 -- goto _L___2
				when 42 then -- if done | if block done, skip else block:
						l_pos := -1 + 48
				when 43 then -- else: | _L___2:
						if not (not js.loop_left and then (l_ebi /= {NATURAL_32} 0)) then
							l_pos := -1 + 48 -- skip loop
						end
				when 44 then -- loop body: | loop condition:
						if ((((a_ep[((l_ebi - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32]).bit_shift_right (((l_ebi - {NATURAL_32} 1) \\ {NATURAL_32} 32).to_integer_32))).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
							l_pos := -1 + 47 -- skip loop
						end
				when 45 then -- loop body:
						sqr_inst.gmpn_sqr (a_tp, a_rp, a_n)
						redc_1_inst.gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
						l_ebi := l_ebi - 1
						if l_ebi = {NATURAL_32} 0 then
							l_pos := -1 + 56 -- goto done
						end
				when 46 then
						l_pos := -1 + 44 -- back to loop condition
				when 47 then -- loop done
						l_expbits := getbits (a_ep, l_ebi, l_windowsize)
						l_this_windowsize := l_windowsize
						if l_ebi < l_windowsize.to_natural_32 then
							l_this_windowsize := (l_this_windowsize.to_natural_32 - (l_windowsize.to_natural_32 - l_ebi)).to_integer_32
							l_ebi := (0).to_natural_32
						else
							l_ebi := l_ebi - l_windowsize.to_natural_32
						end
						from
						until
							js.loop_left
						loop
							js.reset
							l_cnt := builtin_ctzl (l_expbits)
							js.break
						end
						js.reset
						l_this_windowsize := l_this_windowsize - l_cnt
						l_ebi := l_ebi + l_cnt.to_natural_32
						l_expbits := (l_expbits).bit_shift_right (l_cnt)
						from
						until
							js.loop_left
						loop
							js.reset
							sqr_inst.gmpn_sqr (a_tp, a_rp, a_n)
							redc_1_inst.gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
							l_this_windowsize := l_this_windowsize - 1
							if l_this_windowsize = 0 then
								js.break
							end
						end
						js.reset
						mul_n_inst.gmpn_mul_n (a_tp, a_rp, (l_pp + (a_n.to_natural_32 * ((l_expbits).bit_shift_right (1))).to_integer_32), a_n)
						redc_1_inst.gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
						l_pos := -1 + 43 -- back to loop condition
				when 48 then -- loop done | if done | if block done, skip else block:
						l_pos := -1 + 50
				when 49 then -- else:
						l_pos := -1 + 51 -- goto _L___3
				when 50 then -- if done | if block done, skip else block:
						l_pos := -1 + 56
				when 51 then -- else: | _L___3:
						if not (not js.loop_left and then (l_ebi /= {NATURAL_32} 0)) then
							l_pos := -1 + 56 -- skip loop
						end
				when 52 then -- loop body: | loop condition:
						if ((((a_ep[((l_ebi - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32]).bit_shift_right (((l_ebi - {NATURAL_32} 1) \\ {NATURAL_32} 32).to_integer_32))).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
							l_pos := -1 + 55 -- skip loop
						end
				when 53 then -- loop body:
						gmp_impl_inst.gmpn_sqr_basecase (a_tp, a_rp, a_n)
						redc_1_inst.gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
						l_ebi := l_ebi - 1
						if l_ebi = {NATURAL_32} 0 then
							l_pos := -1 + 56 -- goto done
						end
				when 54 then
						l_pos := -1 + 52 -- back to loop condition
				when 55 then -- loop done
						l_expbits := getbits (a_ep, l_ebi, l_windowsize)
						l_this_windowsize := l_windowsize
						if l_ebi < l_windowsize.to_natural_32 then
							l_this_windowsize := (l_this_windowsize.to_natural_32 - (l_windowsize.to_natural_32 - l_ebi)).to_integer_32
							l_ebi := (0).to_natural_32
						else
							l_ebi := l_ebi - l_windowsize.to_natural_32
						end
						from
						until
							js.loop_left
						loop
							js.reset
							l_cnt := builtin_ctzl (l_expbits)
							js.break
						end
						js.reset
						l_this_windowsize := l_this_windowsize - l_cnt
						l_ebi := l_ebi + l_cnt.to_natural_32
						l_expbits := (l_expbits).bit_shift_right (l_cnt)
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_impl_inst.gmpn_sqr_basecase (a_tp, a_rp, a_n)
							redc_1_inst.gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
							l_this_windowsize := l_this_windowsize - 1
							if l_this_windowsize = 0 then
								js.break
							end
						end
						js.reset
						gmp_impl_inst.gmpn_mul_basecase (a_tp, a_rp, a_n, (l_pp + (a_n.to_natural_32 * ((l_expbits).bit_shift_right (1))).to_integer_32), a_n)
						redc_1_inst.gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
						l_pos := -1 + 51 -- back to loop condition
				when 56 then -- loop done | if done | done:
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (a_tp, a_rp, a_n)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							if a_n /= 0 then
								l_dst.ce_gets (a_tp + a_n)
								l_n___0 := a_n
								from
								until
									js.loop_left
								loop
									js.reset
									l_tmp___9.ce_gets (l_dst)
									l_dst.ce_gets (l_dst + 1)
									l_tmp___9.item := (0).to_natural_32
									l_n___0 := l_n___0 - 1
									if not l_n___0.to_boolean then
										js.break
									end
								end
								js.reset
							end
							js.break
						end
						js.reset
						if 63 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							if a_n >= 63 then
								redc_n_inst.gmpn_redc_n (a_rp, a_tp, a_mp, a_n, l_mip)
							else
								redc_1_inst.gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
							end
						else
							redc_1_inst.gmpn_redc_1 (a_rp, a_tp, a_mp, a_n, l_mip[0])
						end
						if (gmp_inst.gmpn_cmp (a_rp, a_mp, a_n)) >= 0 then
							gmp_inst.gmpn_sub_n (a_rp, a_rp, a_mp, a_n).do_nothing
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
							end
							js.break
						end
						js.reset
				when 57 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
