class
	P_POWM_SEC

inherit
	LIBGMP_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {NONE} -- Initialization

	default_create
		do
			create x___1.make (<<11>>)
		end

feature {ANY} -- attributes

	x___1: CE_ARRAY [NATURAL_32]

feature {ANY} -- routines

	gmpz_powm_sec (a_r: CE_POINTER [PD_MPZ_STRUCT]; a_b: CE_POINTER [PD_MPZ_STRUCT]; a_e: CE_POINTER [PD_MPZ_STRUCT]; a_m: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_n: INTEGER_32
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_bp: CE_POINTER [NATURAL_32]
			l_ep: CE_POINTER [NATURAL_32]
			l_mp: CE_POINTER [NATURAL_32]
			l_rn: INTEGER_32
			l_bn: INTEGER_32
			l_es: INTEGER_32
			l_en: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp: INTEGER_32
			l_tmp___7: CE_POINTER [ANY]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_rp.make
			create l_tp.make
			create l_bp.make
			create l_ep.make
			create l_mp.make
			create l_tmp_marker.make
			create l_tmp___7.make

			if a_m.item.mp_size >= 0 then
				l_n := (a_m.item.mp_size).to_integer_32
			else
				l_n := (-a_m.item.mp_size).to_integer_32
			end
			if l_n = 0 then
				errno_inst.gmp_divide_by_zero
			end
			l_mp.ce_gets (a_m.item.mp_d)
			if l_mp[0] \\ {NATURAL_32} 2 = {NATURAL_32} 0 then
				errno_inst.gmp_divide_by_zero
			end
			l_es := (a_e.item.mp_size).to_integer_32
			if (builtin_expect ((l_es <= 0).to_integer, 0)).to_boolean then
				if l_es = 0 then
					if l_n /= 1 then
						l_tmp := 1
					elseif l_mp[0] /= {NATURAL_32} 1 then
						l_tmp := 1
					else
						l_tmp := 0
					end
					a_r.item.mp_size := l_tmp
					a_r.item.mp_d[0] := (1).to_natural_32
					js.return
				end
				if not js.return_called then
					errno_inst.gmp_divide_by_zero
				end
			end
			if not js.return_called then
				l_en := l_es
				if a_b.item.mp_size >= 0 then
					l_bn := (a_b.item.mp_size).to_integer_32
				else
					l_bn := (-a_b.item.mp_size).to_integer_32
				end
				l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
				if (builtin_expect (((l_n + (gmpn_powm_sec_itch (l_bn, l_en, l_n))).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
					l_tmp___7.ce_gets ((l_aaf.new (((l_n + (gmpn_powm_sec_itch (l_bn, l_en, l_n))).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				else
					l_tmp___7.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_n + (gmpn_powm_sec_itch (l_bn, l_en, l_n))).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				end
				l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___7))
				l_rp.ce_gets (l_tp)
				l_tp.ce_gets (l_tp + l_n)
				l_bp.ce_gets (a_b.item.mp_d)
				l_ep.ce_gets (a_e.item.mp_d)
				gmpn_powm_sec (l_rp, l_bp, l_bn, l_ep, l_en, l_mp, l_n, l_tp)
				l_rn := l_n
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						not (not js.loop_left and then (l_rn > 0))
					loop
						js.reset
						if l_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
							js.break
						end
						if not js.loop_jumped then
							l_rn := l_rn - 1
						end
					end
					js.reset
					js.break
				end
				js.reset
				if ((l_ep[0]).bit_and ({NATURAL_32} 1)).to_boolean then
					if a_b.item.mp_size < 0 then
						if l_rn /= 0 then
							gmp_inst.gmpn_sub (l_rp, a_m.item.mp_d, l_n, l_rp, l_rn).do_nothing
							l_rn := l_n
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									not (not js.loop_left and then (l_rn > 0))
								loop
									js.reset
									if l_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
										js.break
									end
									if not js.loop_jumped then
										l_rn := l_rn - 1
									end
								end
								js.reset
								js.break
							end
							js.reset
						end
					end
				end
				if (builtin_expect ((l_rn > (a_r.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					realloc_inst.gmpz_realloc (a_r, l_rn).do_nothing
				end
				a_r.item.mp_size := l_rn.to_integer_32
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						gmp_inst.gmpn_copyi (a_r.item.mp_d, l_rp, l_rn)
						js.break
					end
					js.reset
					js.break
				end
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
					end
					js.break
				end
				js.reset
			end
		end

	win_size___1 (a_eb: NATURAL_32): INTEGER_32
		local
			l_k: INTEGER_32
		do
			l_k := 1
			from
			until
				not (a_eb > x___1[l_k])
			loop
				l_k := l_k + 1
			end
			Result := l_k
		end

	redcify___0 (a_rp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_un: INTEGER_32; a_mp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		local
			l_qp: CE_POINTER [NATURAL_32]
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_qp.make
			create l_tmp_marker.make
			create l_dst.make
			create l_tmp.make

			l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
			l_qp.ce_gets ((a_tp + a_un) + a_n)
			from
			until
				js.loop_left
			loop
				js.reset
				if a_n /= 0 then
					l_dst.ce_gets (a_tp)
					l_n := a_n
					from
					until
						js.loop_left
					loop
						js.reset
						l_tmp.ce_gets (l_dst)
						l_dst.ce_gets (l_dst + 1)
						l_tmp.item := (0).to_natural_32
						l_n := l_n - 1
						if not l_n.to_boolean then
							js.break
						end
					end
					js.reset
				end
				js.break
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					gmp_inst.gmpn_copyi (a_tp + a_n, a_up, a_un)
					js.break
				end
				js.reset
				js.break
			end
			js.reset
			tdiv_qr_inst.gmpn_tdiv_qr (l_qp, a_rp, 0, a_tp, a_un + a_n, a_mp, a_n)
			from
			until
				js.loop_left
			loop
				js.reset
				if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
					tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
				end
				js.break
			end
			js.reset
		end

	gmpn_powm_sec (a_rp: CE_POINTER [NATURAL_32]; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_ep: CE_POINTER [NATURAL_32]; a_en: INTEGER_32; a_mp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		local
			l_minv: NATURAL_32
			l_cnt: INTEGER_32
			l_ebi: NATURAL_32
			l_windowsize: INTEGER_32
			l_this_windowsize: INTEGER_32
			l_expbits: NATURAL_32
			l_pp: CE_POINTER [NATURAL_32]
			l_this_pp: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			l_cnd: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_n: NATURAL_32
			l_inv: NATURAL_32
			l_dst: CE_POINTER [NATURAL_32]
			l_n___0: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_pp.make
			create l_this_pp.make
			create l_tmp_marker.make
			create l_dst.make
			create l_tmp.make

			l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
			from
			until
				js.loop_left
			loop
				js.reset
				l_cnt := builtin_clzl (a_ep[(a_en - 1)])
				js.break
			end
			js.reset
			l_ebi := a_en.to_natural_32 * {NATURAL_32} 32 - l_cnt.to_natural_32
			l_windowsize := win_size___1 (l_ebi)
			from
			until
				js.loop_left
			loop
				js.reset
				l_n := a_mp[0]
				l_inv := (gmp_impl_inst.gmp_binvert_limb_table[((l_n // {NATURAL_32} 2).bit_and ({NATURAL_32} 127)).to_integer_32]).to_natural_32
				l_inv := {NATURAL_32} 2 * l_inv - (l_inv * l_inv) * l_n
				l_inv := {NATURAL_32} 2 * l_inv - (l_inv * l_inv) * l_n
				l_minv := (l_inv).bit_and ({NATURAL_32} 4294967295)
				js.break
			end
			js.reset
			l_minv := (-l_minv.to_integer_32).to_natural_32
			l_pp.ce_gets (a_tp + 4 * a_n)
			l_this_pp.ce_gets (l_pp)
			l_this_pp[a_n] := (1).to_natural_32
			redcify___0 (l_this_pp, (l_this_pp + a_n), (1).to_integer_32, a_mp, a_n, a_tp + 6 * a_n)
			l_this_pp.ce_gets (l_this_pp + a_n)
			redcify___0 (l_this_pp, a_bp, a_bn, a_mp, a_n, a_tp + 6 * a_n)
			l_i := (((1).bit_shift_left (l_windowsize)) - 2).to_integer_32
			from
			until
				not (l_i > 0)
			loop
				gmp_impl_inst.gmpn_mul_basecase (a_tp, l_this_pp, a_n, (l_pp + a_n), a_n)
				l_this_pp.ce_gets (l_this_pp + a_n)
				redc_1_sec_inst.gmpn_redc_1_sec (l_this_pp, a_tp, a_mp, a_n, l_minv)
				l_i := l_i - 1
			end
			l_expbits := powm_inst.getbits (a_ep, l_ebi, l_windowsize)
			if l_ebi < l_windowsize.to_natural_32 then
				l_ebi := (0).to_natural_32
			else
				l_ebi := l_ebi - l_windowsize.to_natural_32
			end
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					gmp_inst.gmpn_copyi (a_rp, (l_pp + (a_n.to_natural_32 * l_expbits).to_integer_32), a_n)
					js.break
				end
				js.reset
				js.break
			end
			js.reset
			from
			until
				not (not js.loop_left and then (l_ebi /= {NATURAL_32} 0))
			loop
				l_expbits := powm_inst.getbits (a_ep, l_ebi, l_windowsize)
				l_this_windowsize := l_windowsize
				if l_ebi < l_windowsize.to_natural_32 then
					l_this_windowsize := (l_this_windowsize.to_natural_32 - (l_windowsize.to_natural_32 - l_ebi)).to_integer_32
					l_ebi := (0).to_natural_32
				else
					l_ebi := l_ebi - l_windowsize.to_natural_32
				end
				from
				until
					js.loop_left
				loop
					js.reset
					gmp_impl_inst.gmpn_sqr_basecase (a_tp, a_rp, a_n)
					redc_1_sec_inst.gmpn_redc_1_sec (a_rp, a_tp, a_mp, a_n, l_minv)
					l_this_windowsize := l_this_windowsize - 1
					if l_this_windowsize = 0 then
						js.break
					end
				end
				js.reset
				gmpn_tabselect ((a_tp + 2 * a_n), l_pp, a_n, ((1).bit_shift_left (l_windowsize)).to_integer_32, l_expbits.to_integer_32)
				gmp_impl_inst.gmpn_mul_basecase (a_tp, a_rp, a_n, (a_tp + 2 * a_n), a_n)
				redc_1_sec_inst.gmpn_redc_1_sec (a_rp, a_tp, a_mp, a_n, l_minv)
			end
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					gmp_inst.gmpn_copyi (a_tp, a_rp, a_n)
					js.break
				end
				js.reset
				js.break
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				if a_n /= 0 then
					l_dst.ce_gets (a_tp + a_n)
					l_n___0 := a_n
					from
					until
						js.loop_left
					loop
						js.reset
						l_tmp.ce_gets (l_dst)
						l_dst.ce_gets (l_dst + 1)
						l_tmp.item := (0).to_natural_32
						l_n___0 := l_n___0 - 1
						if not l_n___0.to_boolean then
							js.break
						end
					end
					js.reset
				end
				js.break
			end
			js.reset
			redc_1_sec_inst.gmpn_redc_1_sec (a_rp, a_tp, a_mp, a_n, l_minv)
			l_cnd := (gmp_inst.gmpn_sub_n (a_tp, a_rp, a_mp, a_n)).to_integer_32
			subcnd_n_inst.gmpn_subcnd_n (a_rp, a_rp, a_mp, a_n, (not l_cnd.to_boolean).to_integer.to_natural_32).do_nothing
			from
			until
				js.loop_left
			loop
				js.reset
				if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
					tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
				end
				js.break
			end
			js.reset
		end

	gmpn_tabselect (a_rp: CE_POINTER [NATURAL_32]; a_tab___0: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_nents: INTEGER_32; a_which: INTEGER_32)
		local
			l_k: INTEGER_32
			l_i: INTEGER_32
			l_mask: NATURAL_32
			l_tp: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_tp.make

			l_k := (0).to_integer_32
			from
			until
				not (not js.loop_left and then (l_k < a_nents))
			loop
				l_mask := (-(a_which = l_k).to_integer).to_natural_32
				l_tp.ce_gets (a_tab___0 + a_n * l_k)
				l_i := (0).to_integer_32
				from
				until
					not (l_i < a_n)
				loop
					a_rp[l_i] := (((a_rp[l_i]).bit_and (((l_mask).bit_not)))).bit_or (((l_tp[l_i]).bit_and (l_mask)))
					l_i := l_i + 1
				end
				l_k := l_k + 1
			end
		end

	gmpn_powm_sec_itch (a_bn: INTEGER_32; a_en: INTEGER_32; a_n: INTEGER_32): INTEGER_32
		local
			l_windowsize: INTEGER_32
			l_redcify_itch: INTEGER_32
			l_itch: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_windowsize := win_size___1 ((a_en * 32).to_natural_32)
			l_itch := 4 * a_n + ((a_n).bit_shift_left (l_windowsize))
			l_redcify_itch := (2 * a_bn + a_n) + 1
			if l_itch > l_redcify_itch + 6 * a_n then
				l_tmp := l_itch
			else
				l_tmp := l_redcify_itch + 6 * a_n
			end
			Result := l_tmp
		end

end
