class
	P_PRINTFFUNS

inherit
	LIBGMP_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {NONE} -- Initialization

	default_create
		do
			create gmp_fprintf_funs.make
		end

feature {ANY} -- attributes

	gmp_fprintf_funs: PD_DOPRNT_FUNS_T

feature {ANY} -- routines

	gmp_fprintf_memory (a_fp: CE_POINTER [SD_IO_FILE]; a_str: CE_POINTER [INTEGER_8]; a_len: NATURAL_32): INTEGER_32
		do
			Result := (fwrite (create {CE_POINTER [ANY]}.make_cast (a_str), (1).to_natural_32, a_len, a_fp)).to_integer_32
		end

	gmp_fprintf_memory_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gmp_fprintf_memory)
		end

	gmp_fprintf_reps (a_fp: CE_POINTER [SD_IO_FILE]; a_c: INTEGER_32; a_reps: INTEGER_32): INTEGER_32
		local
			l_buf: CE_ARRAY [INTEGER_8]
			l_i: INTEGER_32
			l_piece: INTEGER_32
			l_ret: INTEGER_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_buf.make (<<256>>)

			if a_reps.to_natural_32 < (Integer_8_bytes.to_natural_32 * (256).to_natural_32) then
				l_tmp := a_reps.to_natural_32
			else
				l_tmp := (Integer_8_bytes.to_natural_32 * (256).to_natural_32)
			end
			memset (create {CE_POINTER [ANY]}.make_cast (l_buf), a_c, l_tmp).do_nothing
			l_i := a_reps
			from
			until
				not (not js.loop_left and then (l_i > 0))
			loop
				if l_i.to_natural_32 < (Integer_8_bytes.to_natural_32 * (256).to_natural_32) then
					l_piece := l_i
				else
					l_piece := (Integer_8_bytes.to_natural_32 * (256).to_natural_32).to_integer_32
				end
				l_ret := (fwrite (create {CE_POINTER [ANY]}.make_cast (l_buf), (1).to_natural_32, l_piece.to_natural_32, a_fp)).to_integer_32
				if l_ret = -1 then
					Result := l_ret
					js.return
				end
				if not js.return_called then
					l_i := (l_i.to_natural_32 - (Integer_8_bytes.to_natural_32 * (256).to_natural_32)).to_integer_32
				end
			end
			if not js.return_called then
				Result := a_reps
			end
		end

	gmp_fprintf_reps_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gmp_fprintf_reps)
		end

end
