class
	P_RANDLC2X

inherit
	LIBGMP_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {NONE} -- Initialization

	default_create
		do
			create Linear_Congruential_Generator.make
		end

feature {ANY} -- attributes

	Linear_Congruential_Generator: PD_GMP_RANDFNPTR_T_11__

feature {ANY} -- routines

	lc (a_rp: CE_POINTER [NATURAL_32]; a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]): NATURAL_32
		local
			l_tp: CE_POINTER [NATURAL_32]
			l_seedp: CE_POINTER [NATURAL_32]
			l_ap: CE_POINTER [NATURAL_32]
			l_ta: INTEGER_32
			l_tn: INTEGER_32
			l_seedn: INTEGER_32
			l_an: INTEGER_32
			l_m2exp: NATURAL_32
			l_bits: NATURAL_32
			l_cy: INTEGER_32
			l_xn: INTEGER_32
			l_p: CE_POINTER [PD_GMP_RAND_LC_STRUCT]
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp: INTEGER_32
			l_tmp___3: CE_POINTER [ANY]
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_32]
			l_tmp___9: CE_POINTER [ANY]
			l_gmp_i: INTEGER_32
			l_gmp_x: NATURAL_32
			l_tmp___11: INTEGER_32
			l_tmp___12: NATURAL_32
			l_gmp_j: INTEGER_32
			l_cnt: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_tp.make
			create l_seedp.make
			create l_ap.make
			create l_p.make
			create l_tmp_marker.make
			create l_tmp___3.make
			create l_dst.make
			create l_tmp___5.make
			create l_tmp___9.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p.ce_gets (create {CE_POINTER [PD_GMP_RAND_LC_STRUCT]}.make_cast (a_rstate.item.mp_seed[0].mp_d))
					l_m2exp := l_p.item.mp_m2exp
					l_seedp.ce_gets (l_p.item.mp_seed[0].mp_d)
					l_seedn := (l_p.item.mp_seed[0].mp_size).to_integer_32
					l_ap.ce_gets (l_p.item.mp_a[0].mp_d)
					l_an := (l_p.item.mp_a[0].mp_size).to_integer_32
					l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
					l_ta := (l_an + l_seedn) + 1
					l_tn := ((l_m2exp + {NATURAL_32} 31) // {NATURAL_32} 32).to_integer_32
					if l_ta <= l_tn then
						l_tmp := l_an + l_seedn
						l_ta := l_tn + 1
						if (builtin_expect ((l_ta.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___3.ce_gets ((l_aaf.new ((l_ta.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___3.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_ta.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___3))
						from
						until
							js.loop_left
						loop
							js.reset
							if l_ta - l_tmp /= 0 then
								l_dst.ce_gets (l_tp + l_tmp)
								l_n := l_ta - l_tmp
								from
								until
									js.loop_left
								loop
									js.reset
									l_tmp___5.ce_gets (l_dst)
									l_dst.ce_gets (l_dst + 1)
									l_tmp___5.item := (0).to_natural_32
									l_n := l_n - 1
									if not l_n.to_boolean then
										js.break
									end
								end
								js.reset
							end
							js.break
						end
						js.reset
					else
						if (builtin_expect ((l_ta.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___9.ce_gets ((l_aaf.new ((l_ta.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___9.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_ta.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___9))
					end
					mul_inst.gmpn_mul (l_tp, l_seedp, l_seedn, l_ap, l_an).do_nothing
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_gmp_i := l_p.item.cn
						if l_gmp_i = 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if not ((gmp_inst.gmpn_add_n (l_tp, l_tp, create {CE_POINTER [NATURAL_32]}.make_cast ((l_p.item.cp)), l_gmp_i)).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 4 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 7 -- skip loop
						end
				when 5 then -- loop body:
						js.reset
						if l_gmp_i >= l_tn then
							l_cy := 1
							l_pos := -1 + 9 -- goto __gmp_done
						end
				when 6 then
						l_gmp_x := l_tp[l_gmp_i]
						l_tmp___11 := l_gmp_i
						l_gmp_i := l_gmp_i + 1
						l_tmp___12 := ((l_gmp_x + {NATURAL_32} 1)).bit_and ({NATURAL_32} 4294967295)
						l_tp[l_tmp___11] := l_tmp___12
						if l_tmp___12 /= {NATURAL_32} 0 then
							js.break
						end
						l_pos := -1 + 4 -- back to loop condition
				when 7 then -- loop done
						js.reset
				when 8 then -- if done | if done
						if (l_tp.c_pointer.to_integer_32).to_natural_32 /= (l_tp.c_pointer.to_integer_32).to_natural_32 then
							from
							until
								js.loop_left
							loop
								js.reset
								l_gmp_j := l_gmp_i
								from
								until
									not (l_gmp_j < l_tn)
								loop
									l_tp[l_gmp_j] := l_tp[l_gmp_j]
									l_gmp_j := l_gmp_j + 1
								end
								js.break
							end
							js.reset
						end
						l_cy := 0
				when 9 then -- __gmp_done:
						
						js.break
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					js.reset
					l_tp[(l_m2exp // {NATURAL_32} 32).to_integer_32] := (l_tp[(l_m2exp // {NATURAL_32} 32).to_integer_32]).bit_and (((({NATURAL_32} 1).bit_shift_left ((l_m2exp \\ {NATURAL_32} 32).to_integer_32)) - {NATURAL_32} 1))
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (l_p.item.mp_seed[0].mp_d, l_tp, l_tn)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
					l_bits := l_m2exp // {NATURAL_32} 2
					l_xn := (l_bits // {NATURAL_32} 32).to_integer_32
					l_tn := l_tn - l_xn
					if l_tn > 0 then
						l_cnt := (l_bits \\ {NATURAL_32} 32).to_natural_32
						if l_cnt /= {NATURAL_32} 0 then
							gmp_inst.gmpn_rshift (l_tp, (l_tp + l_xn), l_tn, l_cnt).do_nothing
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (a_rp, l_tp, l_xn + 1)
								js.break
							end
							js.reset
						else
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (a_rp, (l_tp + l_xn), l_tn)
								js.break
							end
							js.reset
						end
					end
					from
					until
						js.loop_left
					loop
						js.reset
						if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
							tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
						end
						js.break
					end
					js.reset
					Result := ((l_m2exp + {NATURAL_32} 1) // {NATURAL_32} 2)
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	randget_lc (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_rp: CE_POINTER [NATURAL_32]; a_nbits: NATURAL_32)
		local
			l_rbitpos: NATURAL_32
			l_chunk_nbits: INTEGER_32
			l_tp: CE_POINTER [NATURAL_32]
			l_tn: INTEGER_32
			l_p: CE_POINTER [PD_GMP_RAND_LC_STRUCT]
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___2: CE_POINTER [ANY]
			l_r2p: CE_POINTER [NATURAL_32]
			l_savelimb: NATURAL_32
			l_rcy: NATURAL_32
			l_r2p___0: CE_POINTER [NATURAL_32]
			l_last_nbits: INTEGER_32
			l_savelimb___0: NATURAL_32
			l_rcy___0: NATURAL_32
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_tp.make
			create l_p.make
			create l_tmp_marker.make
			create l_tmp___2.make
			create l_r2p.make
			create l_r2p___0.make

			l_p.ce_gets (create {CE_POINTER [PD_GMP_RAND_LC_STRUCT]}.make_cast (a_rstate.item.mp_seed[0].mp_d))
			l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
			l_chunk_nbits := (l_p.item.mp_m2exp // {NATURAL_32} 2).to_integer_32
			l_tn := ((l_chunk_nbits + 31) // 32).to_integer_32
			if (builtin_expect ((l_tn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
				l_tmp___2.ce_gets ((l_aaf.new ((l_tn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			else
				l_tmp___2.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_tn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			end
			l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2))
			l_rbitpos := {NATURAL_32} 0
			from
			until
				not (l_rbitpos + l_chunk_nbits.to_natural_32 <= a_nbits)
			loop
				l_r2p.ce_gets (a_rp + (l_rbitpos // {NATURAL_32} 32).to_integer_32)
				if l_rbitpos \\ {NATURAL_32} 32 /= {NATURAL_32} 0 then
					lc (l_tp, a_rstate).do_nothing
					l_savelimb := l_r2p[0]
					l_rcy := gmp_inst.gmpn_lshift (l_r2p, l_tp, l_tn, (l_rbitpos \\ {NATURAL_32} 32).to_natural_32)
					l_r2p[0] := (l_r2p[0]).bit_or (l_savelimb)
					if (l_chunk_nbits \\ 32).to_natural_32 + l_rbitpos \\ {NATURAL_32} 32 > {NATURAL_32} 32 then
						l_r2p[l_tn] := l_rcy
					end
				else
					lc (l_r2p, a_rstate).do_nothing
				end
				l_rbitpos := l_rbitpos + l_chunk_nbits.to_natural_32
			end
			if l_rbitpos /= a_nbits then
				l_r2p___0.ce_gets (a_rp + (l_rbitpos // {NATURAL_32} 32).to_integer_32)
				l_last_nbits := (a_nbits - l_rbitpos).to_integer_32
				l_tn := ((l_last_nbits + 31) // 32).to_integer_32
				lc (l_tp, a_rstate).do_nothing
				if l_rbitpos \\ {NATURAL_32} 32 /= {NATURAL_32} 0 then
					l_savelimb___0 := l_r2p___0[0]
					l_rcy___0 := gmp_inst.gmpn_lshift (l_r2p___0, l_tp, l_tn, (l_rbitpos \\ {NATURAL_32} 32).to_natural_32)
					l_r2p___0[0] := (l_r2p___0[0]).bit_or (l_savelimb___0)
					if (l_rbitpos + (l_tn * 32).to_natural_32) - l_rbitpos \\ {NATURAL_32} 32 < a_nbits then
						l_r2p___0[l_tn] := l_rcy___0
					end
				else
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (l_r2p___0, l_tp, l_tn)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
				end
				if a_nbits \\ {NATURAL_32} 32 /= {NATURAL_32} 0 then
					a_rp[(a_nbits // {NATURAL_32} 32).to_integer_32] := (a_rp[(a_nbits // {NATURAL_32} 32).to_integer_32]).bit_and ((((({NATURAL_32} 4294967295).bit_shift_left ((a_nbits \\ {NATURAL_32} 32).to_integer_32))).bit_not))
				end
			end
			from
			until
				js.loop_left
			loop
				js.reset
				if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
					tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
				end
				js.break
			end
			js.reset
		end

	randget_lc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent randget_lc)
		end

	randseed_lc (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_seed: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_p: CE_POINTER [PD_GMP_RAND_LC_STRUCT]
			l_seedz: CE_POINTER [PD_MPZ_STRUCT]
			l_seedn: INTEGER_32
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_p.make
			create l_seedz.make
			create l_dst.make
			create l_tmp.make

			l_p.ce_gets (create {CE_POINTER [PD_GMP_RAND_LC_STRUCT]}.make_cast (a_rstate.item.mp_seed[0].mp_d))
			l_seedz.ce_gets (l_p.item.mp_seed)
			l_seedn := ((l_p.item.mp_m2exp + {NATURAL_32} 31) // {NATURAL_32} 32).to_integer_32
			cfdiv_r_2exp_inst.gmpz_fdiv_r_2exp (l_seedz, a_seed, l_p.item.mp_m2exp)
			from
			until
				js.loop_left
			loop
				js.reset
				if l_seedn - (l_seedz.item.mp_size).to_integer_32 /= 0 then
					l_dst.ce_gets (l_seedz.item.mp_d + l_seedz.item.mp_size)
					l_n := l_seedn - (l_seedz.item.mp_size).to_integer_32
					from
					until
						js.loop_left
					loop
						js.reset
						l_tmp.ce_gets (l_dst)
						l_dst.ce_gets (l_dst + 1)
						l_tmp.item := (0).to_natural_32
						l_n := l_n - 1
						if not l_n.to_boolean then
							js.break
						end
					end
					js.reset
				end
				js.break
			end
			js.reset
			l_seedz.item.mp_size := l_seedn.to_integer_32
		end

	randseed_lc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent randseed_lc)
		end

	randclear_lc (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT])
		local
			l_p: CE_POINTER [PD_GMP_RAND_LC_STRUCT]
		do
			create l_p.make

			l_p.ce_gets (create {CE_POINTER [PD_GMP_RAND_LC_STRUCT]}.make_cast (a_rstate.item.mp_seed[0].mp_d))
			clear_inst.gmpz_clear (l_p.item.mp_seed)
			clear_inst.gmpz_clear (l_p.item.mp_a)
			memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (l_p), {PD_GMP_RAND_LC_STRUCT}.sizeof.to_natural_32])
		end

	randclear_lc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent randclear_lc)
		end

	randiset_lc (a_dst: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_src: CE_POINTER [PD_GMP_RANDSTATE_STRUCT])
		local
			l_dstp: CE_POINTER [PD_GMP_RAND_LC_STRUCT]
			l_srcp: CE_POINTER [PD_GMP_RAND_LC_STRUCT]
		do
			create l_dstp.make
			create l_srcp.make

			l_srcp.ce_gets (create {CE_POINTER [PD_GMP_RAND_LC_STRUCT]}.make_cast (a_src.item.mp_seed[0].mp_d))
			l_dstp.ce_gets (create {CE_POINTER [PD_GMP_RAND_LC_STRUCT]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([{PD_GMP_RAND_LC_STRUCT}.sizeof.to_natural_32])))))
			a_dst.item.mp_seed[0].mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_dstp)
			a_dst.item.mp_algdata.mp_lc := create {CE_POINTER [ANY]}.make_cast ((Linear_Congruential_Generator.address))
			iset_inst.gmpz_init_set (l_dstp.item.mp_seed, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast ((l_srcp.item.mp_seed)))
			iset_inst.gmpz_init_set (l_dstp.item.mp_a, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast ((l_srcp.item.mp_a)))
			l_dstp.item.cn := l_srcp.item.cn
			l_dstp.item.cp[0] := l_srcp.item.cp[0]
			l_dstp.item.mp_m2exp := l_srcp.item.mp_m2exp
		end

	randiset_lc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent randiset_lc)
		end

	gmp_randinit_lc_2exp (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_a: CE_POINTER [PD_MPZ_STRUCT]; a_c: NATURAL_32; a_m2exp: NATURAL_32)
		local
			l_p: CE_POINTER [PD_GMP_RAND_LC_STRUCT]
			l_seedn: INTEGER_32
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_p.make
			create l_dst.make
			create l_tmp___0.make

			l_seedn := ((a_m2exp + {NATURAL_32} 31) // {NATURAL_32} 32).to_integer_32
			from
			until
				js.loop_left
			loop
				js.reset
				if a_m2exp = {NATURAL_32} 0 then
					assert_inst.gmp_assert_fail (ce_string ("randlc2x.c"), 291, ce_string ("m2exp != 0"))
				end
				js.break
			end
			js.reset
			l_p.ce_gets (create {CE_POINTER [PD_GMP_RAND_LC_STRUCT]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([{PD_GMP_RAND_LC_STRUCT}.sizeof.to_natural_32])))))
			a_rstate.item.mp_seed[0].mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_p)
			a_rstate.item.mp_algdata.mp_lc := create {CE_POINTER [ANY]}.make_cast ((Linear_Congruential_Generator.address))
			init2_inst.gmpz_init2 (l_p.item.mp_seed, a_m2exp)
			from
			until
				js.loop_left
			loop
				js.reset
				if l_seedn /= 0 then
					l_dst.ce_gets (l_p.item.mp_seed[0].mp_d)
					l_n := l_seedn
					from
					until
						js.loop_left
					loop
						js.reset
						l_tmp___0.ce_gets (l_dst)
						l_dst.ce_gets (l_dst + 1)
						l_tmp___0.item := (0).to_natural_32
						l_n := l_n - 1
						if not l_n.to_boolean then
							js.break
						end
					end
					js.reset
				end
				js.break
			end
			js.reset
			l_p.item.mp_seed[0].mp_size := l_seedn.to_integer_32
			l_p.item.mp_seed[0].mp_d[0] := (1).to_natural_32
			init_inst.gmpz_init (l_p.item.mp_a)
			cfdiv_r_2exp_inst.gmpz_fdiv_r_2exp (l_p.item.mp_a, a_a, a_m2exp)
			if l_p.item.mp_a[0].mp_size = 0 then
				l_p.item.mp_a[0].mp_size := 1
				l_p.item.mp_a[0].mp_d[0] := (0).to_natural_32
			end
			l_p.item.cp[0] := a_c
			l_p.item.cn := (l_p.item.cp[0] /= {NATURAL_32} 0).to_integer
			if l_seedn < l_p.item.cn then
				l_p.item.cn := (l_p.item.cp[0] /= {NATURAL_32} 0).to_integer
			end
			l_p.item.mp_m2exp := a_m2exp
		end

end
