class
	P_RANDMTS

inherit
	LIBGMP_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {NONE} -- Initialization

	default_create
		do
			create Mersenne_Twister_Generator.make
		end

feature {ANY} -- attributes

	Mersenne_Twister_Generator: PD_GMP_RANDFNPTR_T_11__2

feature {ANY} -- routines

	mangle_seed (a_r: CE_POINTER [PD_MPZ_STRUCT]; a_b_orig: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_t: CE_ARRAY [PD_MPZ_STRUCT]
			l_b: CE_ARRAY [PD_MPZ_STRUCT]
			l_e: NATURAL_32
			l_bit: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_t.make (<<1>>)
			create l_b.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_e := {NATURAL_32} 1074888996
					l_bit := {NATURAL_32} 536870912
					init_inst.gmpz_init (l_t)
					iset_inst.gmpz_init_set (l_b, a_b_orig)
					set_inst.gmpz_set (a_r, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_b))
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 5 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						mul_inst.gmpz_mul (a_r, a_r, a_r)
				when 3 then -- reduce:
						from
						until
							js.loop_left
						loop
							js.reset
							tdiv_q_2exp_inst.gmpz_tdiv_q_2exp (l_t, a_r, (19937).to_natural_32)
							if l_t[0].mp_size < 0 then
								l_tmp := -1
							else
								l_tmp := (l_t[0].mp_size > 0).to_integer
							end
							if l_tmp = 0 then
								js.break
							end
							if not js.loop_jumped then
								tdiv_r_2exp_inst.gmpz_tdiv_r_2exp (a_r, a_r, (19937).to_natural_32)
								aorsmul_i_inst.gmpz_addmul_ui (a_r, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t), {NATURAL_32} 20023)
							end
						end
						js.reset
						if ((l_e).bit_and (l_bit)) /= {NATURAL_32} 0 then
							l_e := (l_e).bit_and (((l_bit).bit_not))
							mul_inst.gmpz_mul (a_r, a_r, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_b))
							l_pos := -1 + 3 -- goto reduce
						end
				when 4 then
						l_bit := (l_bit).bit_shift_right ((1))
						if l_bit = {NATURAL_32} 0 then
							js.break
						end
						l_pos := -1 + 1 -- back to loop condition
				when 5 then -- loop done
					js.reset
					clear_inst.gmpz_clear (l_t)
					clear_inst.gmpz_clear (l_b)
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	randseed_mt (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_seed: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_i: INTEGER_32
			l_cnt: NATURAL_32
			l_p: CE_POINTER [PD_GMP_RAND_MT_STRUCT]
			l_mod: CE_ARRAY [PD_MPZ_STRUCT]
			l_seed1: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp___1: NATURAL_32
		do
			create l_p.make
			create l_mod.make (<<1>>)
			create l_seed1.make (<<1>>)

			l_p.ce_gets (create {CE_POINTER [PD_GMP_RAND_MT_STRUCT]}.make_cast (a_rstate.item.mp_seed[0].mp_d))
			init_inst.gmpz_init (l_mod)
			init_inst.gmpz_init (l_seed1)
			set_ui_inst.gmpz_set_ui (l_mod, {NATURAL_32} 0)
			setbit_inst.gmpz_setbit (l_mod, (19937).to_natural_32)
			aors_ui_inst.gmpz_sub_ui (l_mod, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_mod), {NATURAL_32} 20027)
			mod_inst.gmpz_mod (l_seed1, a_seed, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_mod))
			aors_ui_inst.gmpz_add_ui (l_seed1, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_seed1), {NATURAL_32} 2)
			mangle_seed (l_seed1, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_seed1))
			if (tstbit_inst.gmpz_tstbit (create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_seed1), (19936).to_natural_32)) /= 0 then
				l_p.item.mt[0] := {NATURAL_32} 2147483648
			else
				l_p.item.mt[0] := (0).to_natural_32
			end
			clrbit_inst.gmpz_clrbit (l_seed1, (19936).to_natural_32)
			export_inst.gmpz_export (create {CE_POINTER [ANY]}.make_cast ((l_p.item.mt + 1)), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cnt), -1, Natural_32_bytes.to_natural_32, 0, {NATURAL_32} 8 * Natural_32_bytes.to_natural_32 - {NATURAL_32} 32, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_seed1)).do_nothing
			l_cnt := l_cnt + 1
			from
			until
				not (l_cnt < {NATURAL_32} 624)
			loop
				l_tmp___1 := l_cnt
				l_cnt := l_cnt + 1
				l_p.item.mt[l_tmp___1.to_integer_32] := (0).to_natural_32
			end
			clear_inst.gmpz_clear (l_mod)
			clear_inst.gmpz_clear (l_seed1)
			l_i := 0
			from
			until
				not (l_i < 3)
			loop
				randmt_inst.gmp_mt_recalc_buffer (l_p.item.mt)
				l_i := l_i + 1
			end
			l_p.item.mti := 128
		end

	randseed_mt_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent randseed_mt)
		end

	gmp_randinit_mt (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT])
		do
			randmt_inst.gmp_randinit_mt_noseed (a_rstate)
			a_rstate.item.mp_algdata.mp_lc := create {CE_POINTER [ANY]}.make_cast ((Mersenne_Twister_Generator.address))
		end

end
