class
	P_RANDOM2

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_random2 (a_x___2: CE_POINTER [PD_MPF_STRUCT]; a_xs: INTEGER_32; a_exp: INTEGER_32)
		local
			l_exp: INTEGER_32
			l_xn: INTEGER_32
			l_prec: INTEGER_32
			l_elimb: NATURAL_32
			l_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			js: JUMP_STATE
		do
			create l_rstate.make

			l_exp := a_exp
			if a_xs >= 0 then
				l_xn := a_xs
			else
				l_xn := -a_xs
			end
			l_prec := (a_x___2.item.mp_prec).to_integer_32
			if l_xn = 0 then
				a_x___2.item.mp_exp := (0).to_integer_32
				a_x___2.item.mp_size := 0
				js.return
			end
			if not js.return_called then
				if l_xn > l_prec + 1 then
					l_xn := l_prec + 1
				end
				gmpn_random2 (a_x___2.item.mp_d, l_xn)
				from
				until
					js.loop_left
				loop
					js.reset
					if not rands_inst.gmp_rands_initialized.to_boolean then
						rands_inst.gmp_rands_initialized := (1).to_integer_8
						randmt_inst.gmp_randinit_mt_noseed (create {CE_POINTER [PD_GMP_RANDSTATE_STRUCT]}.make_cast (gmp_impl_inst.gmp_rands))
					end
					l_rstate.ce_gets (gmp_impl_inst.gmp_rands);
					((create {CE_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l_rstate.item.mp_algdata.mp_lc)).item.randget_fn).call ([l_rstate, create {CE_POINTER [NATURAL_32]}.make_shared ($l_elimb), {NATURAL_32} 32])
					js.break
				end
				js.reset
				if l_exp >= 0 then
					l_exp := l_exp
				else
					l_exp := -l_exp
				end
				l_exp := (l_elimb \\ (2 * l_exp + 1).to_natural_32 - l_exp.to_natural_32).to_integer_32
				a_x___2.item.mp_exp := l_exp
				if a_xs < 0 then
					a_x___2.item.mp_size := (-l_xn).to_integer_32
				else
					a_x___2.item.mp_size := l_xn.to_integer_32
				end
			end
		end

	gmpz_random2 (a_x___2: CE_POINTER [PD_MPZ_STRUCT]; a_size: INTEGER_32)
		local
			l_abs_size: INTEGER_32
		do
			if a_size >= 0 then
				l_abs_size := a_size
			else
				l_abs_size := -a_size
			end
			if l_abs_size /= 0 then
				if (a_x___2.item.mp_alloc).to_integer_32 < l_abs_size then
					realloc_inst.gmpz_realloc (a_x___2, l_abs_size).do_nothing
				end
				gmpn_random2 (a_x___2.item.mp_d, l_abs_size)
			end
			a_x___2.item.mp_size := a_size.to_integer_32
		end

	gmpn_random2 (a_rp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32)
		local
			l_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l_bit_pos: INTEGER_32
			l_ran: NATURAL_32
			l_ranm: NATURAL_32
			l_rstate2: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			js: JUMP_STATE
		do
			create l_rstate.make
			create l_rstate2.make

			if not rands_inst.gmp_rands_initialized.to_boolean then
				rands_inst.gmp_rands_initialized := (1).to_integer_8
				randmt_inst.gmp_randinit_mt_noseed (create {CE_POINTER [PD_GMP_RANDSTATE_STRUCT]}.make_cast (gmp_impl_inst.gmp_rands))
			end
			l_rstate.ce_gets (gmp_impl_inst.gmp_rands)
			from
			until
				js.loop_left
			loop
				js.reset
				l_rstate2.ce_gets (l_rstate);
				((create {CE_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l_rstate2.item.mp_algdata.mp_lc)).item.randget_fn).call ([l_rstate2, create {CE_POINTER [NATURAL_32]}.make_shared ($l_ranm), {NATURAL_32} 32])
				js.break
			end
			js.reset
			l_ran := l_ranm
			l_bit_pos := (l_ran \\ {NATURAL_32} 32).to_integer_32
			gmp_rrandomb___0 (a_rp, l_rstate, (a_n * 32 - l_bit_pos.to_integer_32).to_natural_32)
		end

	gmp_rrandomb___0 (a_rp: CE_POINTER [NATURAL_32]; a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_nbits: NATURAL_32)
		local
			l_bi: NATURAL_32
			l_ranm: NATURAL_32
			l_cap_chunksize: NATURAL_32
			l_chunksize: NATURAL_32
			l_i: INTEGER_32
			l_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l_rstate___0: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l_rstate___1: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_rstate.make
			create l_rstate___0.make
			create l_rstate___1.make
			create l_ptr_dummy.make

			l_i := (((a_nbits + {NATURAL_32} 32) - {NATURAL_32} 1) // {NATURAL_32} 32 - {NATURAL_32} 1).to_integer_32
			a_rp[l_i] := ({NATURAL_32} 4294967295).bit_shift_right ((({NATURAL_32} 32 - a_nbits \\ {NATURAL_32} 32) \\ {NATURAL_32} 32).to_integer_32)
			l_i := l_i - 1
			from
			until
				not (l_i >= 0)
			loop
				a_rp[l_i] := {NATURAL_32} 4294967295
				l_i := l_i - 1
			end
			from
			until
				js.loop_left
			loop
				js.reset
				l_rstate.ce_gets (a_rstate);
				((create {CE_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l_rstate.item.mp_algdata.mp_lc)).item.randget_fn).call ([l_rstate, create {CE_POINTER [NATURAL_32]}.make_shared ($l_ranm), {NATURAL_32} 32])
				js.break
			end
			js.reset
			l_cap_chunksize := (a_nbits // (l_ranm \\ {NATURAL_32} 4 + {NATURAL_32} 1)).to_natural_32
			l_cap_chunksize := l_cap_chunksize + (l_cap_chunksize = {NATURAL_32} 0).to_integer.to_natural_32
			l_bi := a_nbits
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					l_rstate___0.ce_gets (a_rstate);
					((create {CE_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l_rstate___0.item.mp_algdata.mp_lc)).item.randget_fn).call ([l_rstate___0, create {CE_POINTER [NATURAL_32]}.make_shared ($l_ranm), {NATURAL_32} 32])
					js.break
				end
				js.reset
				l_chunksize := ({NATURAL_32} 1 + l_ranm \\ l_cap_chunksize.to_natural_32).to_natural_32
				if l_bi < l_chunksize.to_natural_32 then
					l_bi := (0).to_natural_32
				else
					l_bi := l_bi - l_chunksize.to_natural_32
				end
				if l_bi = {NATURAL_32} 0 then
					js.break
				end
				if not js.loop_jumped then
					a_rp[(l_bi // {NATURAL_32} 32).to_integer_32] := (a_rp[(l_bi // {NATURAL_32} 32).to_integer_32]).bit_xor ((({NATURAL_32} 1).bit_shift_left ((l_bi \\ {NATURAL_32} 32).to_integer_32)))
					from
					until
						js.loop_left
					loop
						js.reset
						l_rstate___1.ce_gets (a_rstate);
						((create {CE_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l_rstate___1.item.mp_algdata.mp_lc)).item.randget_fn).call ([l_rstate___1, create {CE_POINTER [NATURAL_32]}.make_shared ($l_ranm), {NATURAL_32} 32])
						js.break
					end
					js.reset
					l_chunksize := ({NATURAL_32} 1 + l_ranm \\ l_cap_chunksize.to_natural_32).to_natural_32
					if l_bi < l_chunksize.to_natural_32 then
						l_bi := (0).to_natural_32
					else
						l_bi := l_bi - l_chunksize.to_natural_32
					end
					from
					until
						js.loop_left
					loop
						js.reset
						asm100 (l_ptr_dummy.address, a_rp.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_bi))
						js.break
					end
					js.reset
					if l_bi = {NATURAL_32} 0 then
						js.break
					end
				end
			end
			js.reset
		end

end
