class
	P_ROOT

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_root (a_root: CE_POINTER [PD_MPZ_STRUCT]; a_u: CE_POINTER [PD_MPZ_STRUCT]; a_nth: NATURAL_32): INTEGER_32
		local
			l_rootp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_us: INTEGER_32
			l_un: INTEGER_32
			l_rootn: INTEGER_32
			l_remn: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___5: CE_POINTER [ANY]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_rootp.make
			create l_up.make
			create l_tmp_marker.make
			create l_tmp___5.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_us := (a_u.item.mp_size).to_integer_32
					if l_us < 0 then
						if ((a_nth).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
							errno_inst.gmp_sqrt_of_negative
						end
					end
					if a_nth = {NATURAL_32} 0 then
						errno_inst.gmp_divide_by_zero
					end
					if l_us = 0 then
						if (a_root.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							a_root.item.mp_size := 0
						end
						Result := 1
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if l_us >= 0 then
							l_un := l_us
						else
							l_un := -l_us
						end
						l_rootn := ((l_un - 1).to_natural_32 // a_nth + {NATURAL_32} 1).to_integer_32
						l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
						if (a_root.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (a_u.c_pointer.to_integer_32).to_natural_32 /= (a_root.c_pointer.to_integer_32).to_natural_32 then
							if (builtin_expect ((l_rootn > (a_root.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
								l_rootp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((realloc_inst.gmpz_realloc (a_root, l_rootn))))
							else
								l_rootp.ce_gets (a_root.item.mp_d)
							end
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if (builtin_expect ((l_rootn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___5.ce_gets ((l_aaf.new ((l_rootn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___5.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_rootn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_rootp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___5))
				when 5 then
						l_up.ce_gets (a_u.item.mp_d)
						if a_nth = {NATURAL_32} 1 then
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_rootp, l_up, l_un)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
							l_remn := (0).to_integer_32
						else
							l_remn := rootrem_inst.gmpn_rootrem (l_rootp, create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer), l_up, l_un, a_nth)
						end
						if (a_root.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if l_us >= 0 then
								a_root.item.mp_size := l_rootn.to_integer_32
							else
								a_root.item.mp_size := (-l_rootn).to_integer_32
							end
							if (a_u.c_pointer.to_integer_32).to_natural_32 = (a_root.c_pointer.to_integer_32).to_natural_32 then
								from
								until
									js.loop_left
								loop
									js.reset
									from
									until
										js.loop_left
									loop
										js.reset
										gmp_inst.gmpn_copyi (l_up, l_rootp, l_rootn)
										js.break
									end
									js.reset
									js.break
								end
								js.reset
							end
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
							end
							js.break
						end
						js.reset
						Result := (l_remn = 0).to_integer
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
