class
	P_ROOTREM

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_rootrem (a_root: CE_POINTER [PD_MPZ_STRUCT]; a_rem: CE_POINTER [PD_MPZ_STRUCT]; a_u: CE_POINTER [PD_MPZ_STRUCT]; a_nth: NATURAL_32)
		local
			l_rootp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_remp: CE_POINTER [NATURAL_32]
			l_us: INTEGER_32
			l_un: INTEGER_32
			l_rootn: INTEGER_32
			l_remn: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___5: CE_POINTER [ANY]
			l_tmp___13: CE_POINTER [ANY]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_rootp.make
			create l_up.make
			create l_remp.make
			create l_tmp_marker.make
			create l_tmp___5.make
			create l_tmp___13.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_us := (a_u.item.mp_size).to_integer_32
					if l_us < 0 then
						if ((a_nth).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
							errno_inst.gmp_sqrt_of_negative
						end
					end
					if a_nth = {NATURAL_32} 0 then
						errno_inst.gmp_divide_by_zero
					end
					if l_us = 0 then
						if (a_root.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							a_root.item.mp_size := 0
						end
						a_rem.item.mp_size := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if l_us >= 0 then
							l_un := l_us
						else
							l_un := -l_us
						end
						l_rootn := ((l_un - 1).to_natural_32 // a_nth + {NATURAL_32} 1).to_integer_32
						l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
						if (a_root.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (a_u.c_pointer.to_integer_32).to_natural_32 /= (a_root.c_pointer.to_integer_32).to_natural_32 then
							if (builtin_expect ((l_rootn > (a_root.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
								l_rootp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((realloc_inst.gmpz_realloc (a_root, l_rootn))))
							else
								l_rootp.ce_gets (a_root.item.mp_d)
							end
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if (builtin_expect ((l_rootn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___5.ce_gets ((l_aaf.new ((l_rootn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___5.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_rootn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_rootp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___5))
				when 5 then
						if (a_u.c_pointer.to_integer_32).to_natural_32 /= (a_rem.c_pointer.to_integer_32).to_natural_32 then
							if (builtin_expect ((l_un > (a_rem.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
								l_remp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((realloc_inst.gmpz_realloc (a_rem, l_un))))
							else
								l_remp.ce_gets (a_rem.item.mp_d)
							end
						else
							if (builtin_expect ((l_un.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
								l_tmp___13.ce_gets ((l_aaf.new ((l_un.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							else
								l_tmp___13.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_un.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_remp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___13))
						end
						l_up.ce_gets (a_u.item.mp_d)
						if a_nth = {NATURAL_32} 1 then
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_rootp, l_up, l_un)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
							l_remn := (0).to_integer_32
						else
							l_remn := gmpn_rootrem (l_rootp, l_remp, l_up, l_un, a_nth)
						end
						if (a_root.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if l_us >= 0 then
								a_root.item.mp_size := l_rootn.to_integer_32
							else
								a_root.item.mp_size := (-l_rootn).to_integer_32
							end
							if (a_u.c_pointer.to_integer_32).to_natural_32 = (a_root.c_pointer.to_integer_32).to_natural_32 then
								from
								until
									js.loop_left
								loop
									js.reset
									from
									until
										js.loop_left
									loop
										js.reset
										gmp_inst.gmpn_copyi (l_up, l_rootp, l_rootn)
										js.break
									end
									js.reset
									js.break
								end
								js.reset
							elseif (a_u.c_pointer.to_integer_32).to_natural_32 = (a_rem.c_pointer.to_integer_32).to_natural_32 then
								from
								until
									js.loop_left
								loop
									js.reset
									from
									until
										js.loop_left
									loop
										js.reset
										gmp_inst.gmpn_copyi (l_up, l_remp, l_remn)
										js.break
									end
									js.reset
									js.break
								end
								js.reset
							end
						end
						a_rem.item.mp_size := l_remn.to_integer_32
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
							end
							js.break
						end
						js.reset
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_rootrem (a_rootp: CE_POINTER [NATURAL_32]; a_remp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_un: INTEGER_32; a_k: NATURAL_32): INTEGER_32
		local
			l_sp: CE_POINTER [NATURAL_32]
			l_wp: CE_POINTER [NATURAL_32]
			l_rn: INTEGER_32
			l_sn: INTEGER_32
			l_wn: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___7: CE_POINTER [ANY]
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___9: CE_POINTER [NATURAL_32]
			l_tmp___11: INTEGER_32
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_sp.make
			create l_wp.make
			create l_tmp_marker.make
			create l_tmp___2.make
			create l_tmp___7.make
			create l_dst.make
			create l_tmp___9.make

			if (a_remp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				if a_un.to_natural_32 // a_k > {NATURAL_32} 2 then
					l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
					l_wn := (a_un.to_natural_32 + a_k).to_integer_32
					if (builtin_expect ((l_wn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___2.ce_gets ((l_aaf.new ((l_wn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___2.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_wn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_wp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2))
					l_sn := ((a_un - 1).to_natural_32 // a_k + {NATURAL_32} 2).to_integer_32
					if (builtin_expect ((l_sn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___7.ce_gets ((l_aaf.new ((l_sn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___7.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_sn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_sp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___7))
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (l_wp + a_k.to_integer_32, a_up, a_un)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						if a_k /= {NATURAL_32} 0 then
							l_dst.ce_gets (l_wp)
							l_n := a_k.to_integer_32
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___9.ce_gets (l_dst)
								l_dst.ce_gets (l_dst + 1)
								l_tmp___9.item := (0).to_natural_32
								l_n := l_n - 1
								if not l_n.to_boolean then
									js.break
								end
							end
							js.reset
						end
						js.break
					end
					js.reset
					l_rn := mpn_rootrem_internal (l_sp, create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer), l_wp, l_wn, a_k, 1)
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (a_rootp, (l_sp + 1), l_sn - 1)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
							tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
						end
						js.break
					end
					js.reset
					Result := l_rn
				else
					l_tmp___11 := mpn_rootrem_internal (a_rootp, a_remp, a_up, a_un, a_k, 0)
					Result := l_tmp___11
				end
			else
				l_tmp___11 := mpn_rootrem_internal (a_rootp, a_remp, a_up, a_un, a_k, 0)
				Result := l_tmp___11
			end
		end

	mpn_rootrem_internal (a_rootp: CE_POINTER [NATURAL_32]; a_remp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_un: INTEGER_32; a_k: NATURAL_32; a_approx: INTEGER_32): INTEGER_32
		local
			l_remp: CE_POINTER [NATURAL_32]
			l_un: INTEGER_32
			l_approx: INTEGER_32
			l_qp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_sp: CE_POINTER [NATURAL_32]
			l_wp: CE_POINTER [NATURAL_32]
			l_scratch: CE_POINTER [NATURAL_32]
			l_qn: INTEGER_32
			l_rn: INTEGER_32
			l_sn: INTEGER_32
			l_wn: INTEGER_32
			l_nl: INTEGER_32
			l_bn: INTEGER_32
			l_save: NATURAL_32
			l_save2: NATURAL_32
			l_cy: NATURAL_32
			l_unb: NATURAL_32
			l_xnb: NATURAL_32
			l_cnt: NATURAL_32
			l_b: NATURAL_32
			l_kk: NATURAL_32
			l_sizes: CE_ARRAY [NATURAL_32]
			l_ni: INTEGER_32
			l_i: INTEGER_32
			l_c: INTEGER_32
			l_logk: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___7: CE_POINTER [ANY]
			l_tmp___12: CE_POINTER [ANY]
			l_tmp___17: CE_POINTER [ANY]
			l_tp: CE_POINTER [NATURAL_32]
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___21: CE_POINTER [NATURAL_32]
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			l_dst___0: CE_POINTER [NATURAL_32]
			l_n___0: INTEGER_32
			l_tmp___22: CE_POINTER [NATURAL_32]
			l_tmp___23: INTEGER_32
			l_ptr_dummy___0: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_remp.make
			create l_qp.make
			create l_rp.make
			create l_sp.make
			create l_wp.make
			create l_scratch.make
			create l_sizes.make (<<33>>)
			create l_tmp_marker.make
			create l_tmp___2.make
			create l_tmp___7.make
			create l_tmp___12.make
			create l_tmp___17.make
			create l_tp.make
			create l_dst.make
			create l_tmp___21.make
			create l_ptr_dummy.make
			create l_dst___0.make
			create l_tmp___22.make
			create l_ptr_dummy___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_remp.ce_gets (a_remp)
					l_un := a_un
					l_approx := a_approx
					l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
					if (builtin_expect ((((l_un + 2) + ((0.585 * a_k.to_real_64) / (32).to_double).truncated_to_integer).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___2.ce_gets ((l_aaf.new ((((l_un + 2) + ((0.585 * a_k.to_real_64) / (32).to_double).truncated_to_integer).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___2.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (((l_un + 2) + ((0.585 * a_k.to_real_64) / (32).to_double).truncated_to_integer).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_qp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2))
					if (l_remp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						if (builtin_expect (((l_un + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___7.ce_gets ((l_aaf.new (((l_un + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___7.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_un + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_rp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___7))
						l_scratch.ce_gets (l_rp)
					else
						if (builtin_expect (((l_un + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___12.ce_gets ((l_aaf.new (((l_un + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___12.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_un + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_scratch.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___12))
						l_rp.ce_gets (l_remp)
					end
					l_sp.ce_gets (a_rootp)
					if (builtin_expect ((((l_un + 2) + ((0.585 * a_k.to_real_64) / (32).to_double).truncated_to_integer).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___17.ce_gets ((l_aaf.new ((((l_un + 2) + ((0.585 * a_k.to_real_64) / (32).to_double).truncated_to_integer).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___17.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (((l_un + 2) + ((0.585 * a_k.to_real_64) / (32).to_double).truncated_to_integer).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_wp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___17))
					from
					until
						js.loop_left
					loop
						js.reset
						l_cnt := (builtin_clzl (a_up[(l_un - 1)])).to_natural_32
						js.break
					end
					js.reset
					l_unb := (l_un * 32).to_natural_32 - l_cnt.to_natural_32
					l_xnb := (l_unb - {NATURAL_32} 1) // a_k + {NATURAL_32} 1
					if l_xnb = {NATURAL_32} 1 then
						if (l_remp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_remp.ce_gets (l_rp)
						end
						gmp_inst.gmpn_sub_1 (l_remp, a_up, l_un, (1).to_natural_32).do_nothing
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								not (not js.loop_left and then (l_un > 0))
							loop
								js.reset
								if l_remp[(l_un - 1)] /= {NATURAL_32} 0 then
									js.break
								end
								if not js.loop_jumped then
									l_un := l_un - 1
								end
							end
							js.reset
							js.break
						end
						js.reset
						a_rootp[0] := (1).to_natural_32
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
							end
							js.break
						end
						js.reset
						Result := l_un
						js.return
					end
					if js.return_called then
						l_pos := -1 + 30 -- skip if block
					end
				when 1 then -- if:
						l_kk := a_k * (l_xnb - {NATURAL_32} 1)
						l_rn := (l_un.to_natural_32 - l_kk // {NATURAL_32} 32).to_integer_32
						from
						until
							js.loop_left
						loop
							js.reset
							if l_kk \\ {NATURAL_32} 32 /= {NATURAL_32} 0 then
								l_cy := gmp_inst.gmpn_rshift (l_rp, a_up + (l_kk // {NATURAL_32} 32).to_integer_32, l_rn, (l_kk \\ {NATURAL_32} 32).to_natural_32)
							else
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_rp, a_up + (l_kk // {NATURAL_32} 32).to_integer_32, l_rn)
									js.break
								end
								js.reset
								l_cy := (0).to_natural_32
							end
							js.break
						end
						js.reset
						gmp_inst.gmpn_sub_1 (l_rp, l_rp, l_rn, (1).to_natural_32).do_nothing
						l_sp[0] := (1).to_natural_32
						l_sn := (1).to_integer_32
						l_logk := 1
						from
						until
							((a_k - {NATURAL_32} 1)).bit_shift_right (l_logk) = {NATURAL_32} 0
						loop
							l_logk := l_logk + 1
						end
						l_b := l_xnb - {NATURAL_32} 1
						l_ni := 0
						from
						until
							l_b = {NATURAL_32} 0
						loop
							l_sizes[l_ni] := l_b
							l_b := ((l_b + l_logk.to_natural_32) + {NATURAL_32} 1) // {NATURAL_32} 2
							if l_b >= l_sizes[l_ni] then
								l_b := l_sizes[l_ni] - {NATURAL_32} 1
							end
							l_ni := l_ni + 1
						end
						l_sizes[l_ni] := {NATURAL_32} 0
						from
						until
							js.loop_left
						loop
							js.reset
							if not (l_ni < 33) then
								assert_inst.gmp_assert_fail (ce_string ("rootrem.c"), 214, ce_string ("ni < (32 - 0) + 1"))
							end
							js.break
						end
						js.reset
						l_wp[0] := (1).to_natural_32
						l_wn := (1).to_integer_32
						l_i := l_ni
				when 2 then -- loop condition:
						if not (not js.loop_left and then (l_i /= 0)) then
							l_pos := -1 + 29 -- skip loop
						end
				when 3 then -- loop body:
						l_b := l_sizes[l_i - 1] - l_sizes[l_i]
						if l_rn = 0 then
							l_rp[0] := (0).to_natural_32
							l_rn := (1).to_integer_32
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if l_b \\ {NATURAL_32} 32 /= {NATURAL_32} 0 then
								l_cy := gmp_inst.gmpn_lshift (l_rp + (l_b // {NATURAL_32} 32).to_integer_32, l_rp, l_rn, (l_b \\ {NATURAL_32} 32).to_natural_32)
							else
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyd (l_rp + (l_b // {NATURAL_32} 32).to_integer_32, l_rp, l_rn)
									js.break
								end
								js.reset
								l_cy := (0).to_natural_32
							end
							js.break
						end
						js.reset
						l_rn := (l_rn.to_natural_32 + l_b // {NATURAL_32} 32).to_integer_32
						if l_cy /= {NATURAL_32} 0 then
							l_rp[l_rn] := l_cy
							l_rn := l_rn + 1
						end
						l_kk := l_kk - l_b
						l_bn := (l_b // {NATURAL_32} 32).to_integer_32
						l_save := l_rp[l_bn]
						l_nl := (({NATURAL_32} 1 + ((l_kk + l_b) - {NATURAL_32} 1) // {NATURAL_32} 32) - l_kk // {NATURAL_32} 32).to_integer_32
						if l_nl - 1 > l_bn then
							l_save2 := l_rp[(l_bn + 1)]
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if l_kk \\ {NATURAL_32} 32 /= {NATURAL_32} 0 then
								l_cy := gmp_inst.gmpn_rshift (l_rp, a_up + (l_kk // {NATURAL_32} 32).to_integer_32, l_nl, (l_kk \\ {NATURAL_32} 32).to_natural_32)
							else
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_rp, a_up + (l_kk // {NATURAL_32} 32).to_integer_32, l_nl)
									js.break
								end
								js.reset
								l_cy := (0).to_natural_32
							end
							js.break
						end
						js.reset
						l_rp[l_bn] := (l_rp[l_bn]).bit_and (((({NATURAL_32} 1).bit_shift_left ((l_b \\ {NATURAL_32} 32).to_integer_32)) - {NATURAL_32} 1))
						l_rp[l_bn] := (l_rp[l_bn]).bit_or (l_save)
						if l_nl - 1 > l_bn then
							l_rp[(l_bn + 1)] := l_save2
						end
						l_cy := gmp_inst.gmpn_mul_1 (l_wp, l_wp, l_wn, a_k)
						l_wp[l_wn] := l_cy
						l_wn := l_wn + (l_cy /= {NATURAL_32} 0).to_integer
						if l_rn < l_wn then
							l_qn := (0).to_integer_32
						else
							l_qn := l_rn - l_wn
							l_tp.ce_gets ((l_qp + l_qn) + 1)
							div_q_inst.gmpn_div_q (l_qp, l_rp, l_rn, l_wp, l_wn, l_scratch)
							l_qn := l_qn + (l_qp[l_qn] /= {NATURAL_32} 0).to_integer
						end
						l_bn := ((l_b - {NATURAL_32} 1) // {NATURAL_32} 32 + {NATURAL_32} 1).to_integer_32
						if not (l_qn > l_bn) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if l_qn /= l_bn then
							l_pos := -1 + 10 -- skip if block
						end
				when 7 then -- if:
						if l_b \\ {NATURAL_32} 32 = {NATURAL_32} 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if not (l_qp[(l_qn - 1)] >= ({NATURAL_32} 1).bit_shift_left ((l_b \\ {NATURAL_32} 32).to_integer_32)) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						l_qn := (l_b // {NATURAL_32} 32 + {NATURAL_32} 1).to_integer_32
						from
						until
							js.loop_left
						loop
							js.reset
							if l_qn /= 0 then
								l_dst.ce_gets (l_qp)
								l_n := l_qn
								from
								until
									js.loop_left
								loop
									js.reset
									l_tmp___21.ce_gets (l_dst)
									l_dst.ce_gets (l_dst + 1)
									l_tmp___21.item := (0).to_natural_32
									l_n := l_n - 1
									if not l_n.to_boolean then
										js.break
									end
								end
								js.reset
							end
							js.break
						end
						js.reset
						l_qp[(l_qn - 1)] := ({NATURAL_32} 1).bit_shift_left ((l_b \\ {NATURAL_32} 32).to_integer_32)
						from
						until
							js.loop_left
						loop
							js.reset
							asm101 (l_ptr_dummy.address, l_qp.address)
							js.break
						end
						js.reset
						l_qn := l_qn - (l_qp[(l_qn - 1)] = {NATURAL_32} 0).to_integer
				when 10 then -- if done | if done | if done
						from
						until
							js.loop_left
						loop
							js.reset
							if l_b \\ {NATURAL_32} 32 /= {NATURAL_32} 0 then
								l_cy := gmp_inst.gmpn_lshift (l_sp + (l_b // {NATURAL_32} 32).to_integer_32, l_sp, l_sn, (l_b \\ {NATURAL_32} 32).to_natural_32)
							else
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyd (l_sp + (l_b // {NATURAL_32} 32).to_integer_32, l_sp, l_sn)
									js.break
								end
								js.reset
								l_cy := (0).to_natural_32
							end
							js.break
						end
						js.reset
						l_sn := (l_sn.to_natural_32 + l_b // {NATURAL_32} 32).to_integer_32
						if l_cy /= {NATURAL_32} 0 then
							l_sp[l_sn] := l_cy
							l_sn := l_sn + 1
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if not (l_bn >= l_qn) then
								assert_inst.gmp_assert_fail (ce_string ("rootrem.c"), 339, ce_string ("bn >= qn"))
							end
							js.break
						end
						js.reset
						l_save := l_sp[(l_b // {NATURAL_32} 32).to_integer_32]
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (l_sp, l_qp, l_qn)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							if l_bn - l_qn /= 0 then
								l_dst___0.ce_gets (l_sp + l_qn)
								l_n___0 := l_bn - l_qn
								from
								until
									js.loop_left
								loop
									js.reset
									l_tmp___22.ce_gets (l_dst___0)
									l_dst___0.ce_gets (l_dst___0 + 1)
									l_tmp___22.item := (0).to_natural_32
									l_n___0 := l_n___0 - 1
									if not l_n___0.to_boolean then
										js.break
									end
								end
								js.reset
							end
							js.break
						end
						js.reset
						l_sp[(l_b // {NATURAL_32} 32).to_integer_32] := (l_sp[(l_b // {NATURAL_32} 32).to_integer_32]).bit_or (l_save)
						l_kk := l_kk - ((a_k - {NATURAL_32} 1) * l_b)
						from
						until
							js.loop_left
						loop
							js.reset
							if l_kk \\ {NATURAL_32} 32 /= {NATURAL_32} 0 then
								l_cy := gmp_inst.gmpn_rshift (l_rp, a_up + (l_kk // {NATURAL_32} 32).to_integer_32, (l_un.to_natural_32 - l_kk // {NATURAL_32} 32).to_integer_32, (l_kk \\ {NATURAL_32} 32).to_natural_32)
							else
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_rp, a_up + (l_kk // {NATURAL_32} 32).to_integer_32, (l_un.to_natural_32 - l_kk // {NATURAL_32} 32).to_integer_32)
									js.break
								end
								js.reset
								l_cy := (0).to_natural_32
							end
							js.break
						end
						js.reset
						l_rn := (l_un.to_natural_32 - l_kk // {NATURAL_32} 32).to_integer_32
						l_rn := l_rn - (l_rp[(l_rn - 1)] = {NATURAL_32} 0).to_integer
						l_c := 0
				when 11 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 23 -- skip loop
						end
				when 12 then -- loop body:
						js.reset
						if l_i = 1 then
							if l_approx.to_boolean then
								if l_sp[0] > {NATURAL_32} 1 then
									l_tmp___23 := 1
								else
									l_tmp___23 := 0
								end
							else
								l_tmp___23 := 0
							end
							l_approx := l_tmp___23
							if l_approx = 0 then
								l_qn := (pow_1_inst.gmpn_pow_1 (l_qp, l_sp, l_sn, a_k, l_wp))
							else
								l_qn := (0).to_integer_32
							end
						else
							l_wn := pow_1_inst.gmpn_pow_1 (l_wp, l_sp, l_sn, a_k - {NATURAL_32} 1, l_qp)
							mul_inst.gmpn_mul (l_qp, l_wp, l_wn, l_sp, l_sn).do_nothing
							l_qn := l_wn + l_sn
							l_qn := l_qn - (l_qp[(l_qn - 1)] = {NATURAL_32} 0).to_integer
						end
						if not (l_qn > l_rn) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 17 -- goto _L___0
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 15 then -- else:
						if l_qn /= l_rn then
							l_pos := -1 + 21 -- skip if block
						end
				when 16 then -- if:
						if not ((gmp_inst.gmpn_cmp (l_qp, l_rp, l_rn)) > 0) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							asm102 (l_ptr_dummy___0.address, l_sp.address)
							js.break
						end
						js.reset
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:
						js.break
				when 20 then -- if done | if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						js.break
				when 22 then -- if done
						if not js.loop_jumped then
							l_c := l_c + 1
						end
						l_pos := -1 + 11 -- back to loop condition
				when 23 then -- loop done
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							if not (l_c <= 1) then
								assert_inst.gmp_assert_fail (ce_string ("rootrem.c"), 392, ce_string ("c <= 1"))
							end
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							if not (l_rn >= l_qn) then
								assert_inst.gmp_assert_fail (ce_string ("rootrem.c"), 393, ce_string ("rn >= qn"))
							end
							js.break
						end
						js.reset
						if not (l_i > 1) then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_pos := -1 + 27 -- goto _L___1
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 26 then -- else:
						if l_approx /= 0 then
							l_pos := -1 + 28 -- skip if block
						end
				when 27 then -- if: | _L___1:
						gmp_inst.gmpn_sub (l_rp, l_rp, l_rn, l_qp, l_qn).do_nothing
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								not (not js.loop_left and then (l_rn > 0))
							loop
								js.reset
								if l_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
									js.break
								end
								if not js.loop_jumped then
									l_rn := l_rn - 1
								end
							end
							js.reset
							js.break
						end
						js.reset
				when 28 then -- if done
						l_i := l_i - 1
						l_pos := -1 + 2 -- back to loop condition
				when 29 then -- loop done
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
							end
							js.break
						end
						js.reset
						Result := l_rn
				when 30 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
