class
	P_SET_D

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_set_d (a_r: CE_POINTER [PD_MPF_STRUCT]; a_d: REAL_64)
		local
			l_d: REAL_64
			l_negative: INTEGER_32
			l_u: PD_IEEE_DOUBLE_EXTRACT
			js: JUMP_STATE
		do
			create l_u.make

			l_d := a_d
			from
			until
				js.loop_left
			loop
				js.reset
				l_u.d := l_d
				if (builtin_expect ((l_u.s.exp = {NATURAL_32} 2047).to_integer, 0)).to_boolean then
					if l_u.s.manl = {NATURAL_32} 0 then
						if l_u.s.manh = {NATURAL_32} 0 then
							invalid_inst.gmp_invalid_operation
						else
							invalid_inst.gmp_invalid_operation
						end
					else
						invalid_inst.gmp_invalid_operation
					end
				end
				js.break
			end
			js.reset
			if (builtin_expect ((l_d = (0).to_double).to_integer, 0)).to_boolean then
				a_r.item.mp_size := 0
				a_r.item.mp_exp := (0).to_integer_32
				js.return
			end
			if not js.return_called then
				l_negative := (l_d < (0).to_double).to_integer
				if l_d >= (0).to_double then
					l_d := l_d
				else
					l_d := -l_d
				end
				if l_negative.to_boolean then
					a_r.item.mp_size := -3
				else
					a_r.item.mp_size := 3
				end
				a_r.item.mp_exp := (extract_dbl_inst.gmp_extract_double (a_r.item.mp_d, l_d)).to_integer_32
			end
		end

	gmpz_set_d (a_r: CE_POINTER [PD_MPZ_STRUCT]; a_d: REAL_64)
		local
			l_d: REAL_64
			l_negative: INTEGER_32
			l_tp: CE_ARRAY [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_rn: INTEGER_32
			l_u: PD_IEEE_DOUBLE_EXTRACT
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tp.make (<<3>>)
			create l_rp.make
			create l_u.make
			create l_dst.make
			create l_tmp___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d := a_d
					from
					until
						js.loop_left
					loop
						js.reset
						l_u.d := l_d
						if (builtin_expect ((l_u.s.exp = {NATURAL_32} 2047).to_integer, 0)).to_boolean then
							if l_u.s.manl = {NATURAL_32} 0 then
								if l_u.s.manh = {NATURAL_32} 0 then
									invalid_inst.gmp_invalid_operation
								else
									invalid_inst.gmp_invalid_operation
								end
							else
								invalid_inst.gmp_invalid_operation
							end
						end
						js.break
					end
					js.reset
					l_negative := (l_d < (0).to_double).to_integer
					if l_d >= (0).to_double then
						l_d := l_d
					else
						l_d := -l_d
					end
					l_rn := (extract_dbl_inst.gmp_extract_double (l_tp, l_d)).to_integer_32
					if (a_r.item.mp_alloc).to_integer_32 < l_rn then
						realloc_inst.gmpz_realloc (a_r, l_rn).do_nothing
					end
					if l_rn <= 0 then
						l_rn := (0).to_integer_32
					end
					l_rp.ce_gets (a_r.item.mp_d)
					inspect l_rn.to_integer_32 -- switch 1 head
					when 3 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					when 1 then l_pos := -1 + 4
					when 0 then l_pos := -1 + 5
					else l_pos := -1 + 1
					end
				when 1 then -- switch 1, default:
					from
					until
						js.loop_left
					loop
						js.reset
						if l_rn - 3 /= 0 then
							l_dst.ce_gets (l_rp)
							l_n := l_rn - 3
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___1.ce_gets (l_dst)
								l_dst.ce_gets (l_dst + 1)
								l_tmp___1.item := (0).to_natural_32
								l_n := l_n - 1
								if not l_n.to_boolean then
									js.break
								end
							end
							js.reset
						end
						js.break
					end
					js.reset
					l_rp.ce_gets (l_rp + (l_rn - 3))
				when 2 then -- switch 1, case 3
					l_rp[2] := l_tp[2]
					l_rp[1] := l_tp[1]
					l_rp[0] := l_tp[0]
					l_pos := -1 + 6 -- switch 1; break
				when 3 then -- switch 1, case 2
					l_rp[1] := l_tp[2]
					l_rp[0] := l_tp[1]
					l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 1
					l_rp[0] := l_tp[2]
					l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, case 0
					l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done:
					if l_negative.to_boolean then
						a_r.item.mp_size := (-l_rn).to_integer_32
					else
						a_r.item.mp_size := l_rn.to_integer_32
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpq_set_d (a_dest: CE_POINTER [PD_MPQ_STRUCT]; a_d: REAL_64)
		local
			l_d: REAL_64
			l_negative: INTEGER_32
			l_exp: INTEGER_32
			l_tp: CE_ARRAY [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_nn: INTEGER_32
			l_dn: INTEGER_32
			l_c: INTEGER_32
			l_u: PD_IEEE_DOUBLE_EXTRACT
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_32]
			l_dst___0: CE_POINTER [NATURAL_32]
			l_n___0: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tp.make (<<3>>)
			create l_np.make
			create l_dp.make
			create l_u.make
			create l_dst.make
			create l_tmp___3.make
			create l_dst___0.make
			create l_tmp___5.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d := a_d
					from
					until
						js.loop_left
					loop
						js.reset
						l_u.d := l_d
						if (builtin_expect ((l_u.s.exp = {NATURAL_32} 2047).to_integer, 0)).to_boolean then
							if l_u.s.manl = {NATURAL_32} 0 then
								if l_u.s.manh = {NATURAL_32} 0 then
									invalid_inst.gmp_invalid_operation
								else
									invalid_inst.gmp_invalid_operation
								end
							else
								invalid_inst.gmp_invalid_operation
							end
						end
						js.break
					end
					js.reset
					l_negative := (l_d < (0).to_double).to_integer
					if l_d >= (0).to_double then
						l_d := l_d
					else
						l_d := -l_d
					end
					l_exp := (extract_dbl_inst.gmp_extract_double (l_tp, l_d)).to_integer_32
					if not (l_exp <= 1) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 3 then -- else:
						if l_exp /= 2 then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if l_tp[0] = {NATURAL_32} 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						if l_d = 0.0 then
							a_dest.item.mp_num.mp_size := 0
							a_dest.item.mp_den.mp_size := 1
							a_dest.item.mp_den.mp_d[0] := (1).to_natural_32
							js.return
						end
						if not js.return_called then
							l_dn := -l_exp
							if (builtin_expect ((3 > a_dest.item.mp_num.mp_alloc).to_integer, 0)).to_boolean then
								realloc_inst.gmpz_realloc (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_dest.c_pointer + {PD_MPQ_STRUCT}.mp_num_offset), (3).to_integer_32).do_nothing
							end
							l_np.ce_gets (a_dest.item.mp_num.mp_d)
							if ((l_tp[0]).bit_or (l_tp[1])) = {NATURAL_32} 0 then
								l_np[0] := l_tp[2]
								l_nn := (1).to_integer_32
							elseif l_tp[0] = {NATURAL_32} 0 then
								l_np[1] := l_tp[2]
								l_np[0] := l_tp[1]
								l_nn := (2).to_integer_32
							else
								l_np[2] := l_tp[2]
								l_np[1] := l_tp[1]
								l_np[0] := l_tp[0]
								l_nn := (3).to_integer_32
							end
							l_dn := l_dn + (l_nn + 1)
							from
							until
								js.loop_left
							loop
								js.reset
								if not (l_dn > 0) then
									assert_inst.gmp_assert_fail (ce_string ("set_d.c"), 101, ce_string ("dn > 0"))
								end
								js.break
							end
							js.reset
							if (builtin_expect ((l_dn > (a_dest.item.mp_den.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
								realloc_inst.gmpz_realloc (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_dest.c_pointer + {PD_MPQ_STRUCT}.mp_den_offset), l_dn).do_nothing
							end
							l_dp.ce_gets (a_dest.item.mp_den.mp_d)
							from
							until
								js.loop_left
							loop
								js.reset
								if l_dn - 1 /= 0 then
									l_dst.ce_gets (l_dp)
									l_n := l_dn - 1
									from
									until
										js.loop_left
									loop
										js.reset
										l_tmp___3.ce_gets (l_dst)
										l_dst.ce_gets (l_dst + 1)
										l_tmp___3.item := (0).to_natural_32
										l_n := l_n - 1
										if not l_n.to_boolean then
											js.break
										end
									end
									js.reset
								end
								js.break
							end
							js.reset
							l_dp[(l_dn - 1)] := (1).to_natural_32
							from
							until
								js.loop_left
							loop
								js.reset
								l_c := builtin_ctzl ((l_np[0]).bit_or (l_dp[0]))
								js.break
							end
							js.reset
							if l_c /= 0 then
								gmp_inst.gmpn_rshift (l_np, l_np, l_nn, l_c.to_natural_32).do_nothing
								l_nn := l_nn - (l_np[(l_nn - 1)] = {NATURAL_32} 0).to_integer
								gmp_inst.gmpn_rshift (l_dp, l_dp, l_dn, l_c.to_natural_32).do_nothing
								l_dn := l_dn - (l_dp[(l_dn - 1)] = {NATURAL_32} 0).to_integer
							end
							a_dest.item.mp_den.mp_size := l_dn.to_integer_32
							if l_negative.to_boolean then
								a_dest.item.mp_num.mp_size := (-l_nn).to_integer_32
							else
								a_dest.item.mp_num.mp_size := l_nn.to_integer_32
							end
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_pos := -1 + 9 -- goto _L___0
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 14
				when 9 then -- else: | _L___0:
						l_nn := l_exp
						if (builtin_expect ((l_nn > (a_dest.item.mp_num.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
							realloc_inst.gmpz_realloc (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_dest.c_pointer + {PD_MPQ_STRUCT}.mp_num_offset), l_nn).do_nothing
						end
						l_np.ce_gets (a_dest.item.mp_num.mp_d)
						inspect l_nn.to_integer_32 -- switch 1 head
						when 3 then l_pos := -1 + 11
						when 2 then l_pos := -1 + 12
						else l_pos := -1 + 10
						end
				when 10 then -- switch 1, default:
						from
						until
							js.loop_left
						loop
							js.reset
							if l_nn - 3 /= 0 then
								l_dst___0.ce_gets (l_np)
								l_n___0 := l_nn - 3
								from
								until
									js.loop_left
								loop
									js.reset
									l_tmp___5.ce_gets (l_dst___0)
									l_dst___0.ce_gets (l_dst___0 + 1)
									l_tmp___5.item := (0).to_natural_32
									l_n___0 := l_n___0 - 1
									if not l_n___0.to_boolean then
										js.break
									end
								end
								js.reset
							end
							js.break
						end
						js.reset
						l_np.ce_gets (l_np + (l_nn - 3))
				when 11 then -- switch 1, case 3
						l_np[2] := l_tp[2]
						l_np[1] := l_tp[1]
						l_np[0] := l_tp[0]
						l_pos := -1 + 13 -- switch 1; break
				when 12 then -- switch 1, case 2
						l_np[1] := l_tp[2]
						l_np[0] := l_tp[1]
						l_pos := -1 + 13 -- switch 1; break
				when 13 then -- switch 1, done:
						l_dp.ce_gets (a_dest.item.mp_den.mp_d)
						l_dp[0] := (1).to_natural_32
						a_dest.item.mp_den.mp_size := 1
						if l_negative.to_boolean then
							a_dest.item.mp_num.mp_size := (-l_nn).to_integer_32
						else
							a_dest.item.mp_num.mp_size := l_nn.to_integer_32
						end
				when 14 then -- if done
						if not js.return_called then
						end
				when 15 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
