class
	P_SET_F

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_set_f (a_w: CE_POINTER [PD_MPZ_STRUCT]; a_u: CE_POINTER [PD_MPF_STRUCT])
		local
			l_wp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_exp: INTEGER_32
			l_zeros: INTEGER_32
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_wp.make
			create l_up.make
			create l_dst.make
			create l_tmp___0.make

			l_exp := a_u.item.mp_exp
			if l_exp <= 0 then
				a_w.item.mp_size := 0
				js.return
			end
			if not js.return_called then
				if (builtin_expect ((l_exp > (a_w.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					realloc_inst.gmpz_realloc (a_w, l_exp).do_nothing
				end
				l_wp.ce_gets (a_w.item.mp_d)
				l_up.ce_gets (a_u.item.mp_d)
				l_size := (a_u.item.mp_size).to_integer_32
				if l_size >= 0 then
					a_w.item.mp_size := l_exp.to_integer_32
				else
					a_w.item.mp_size := (-l_exp).to_integer_32
				end
				if l_size >= 0 then
					l_size := l_size
				else
					l_size := -l_size
				end
				if l_exp > l_size then
					l_zeros := l_exp - l_size
					from
					until
						js.loop_left
					loop
						js.reset
						if l_zeros /= 0 then
							l_dst.ce_gets (l_wp)
							l_n := l_zeros
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___0.ce_gets (l_dst)
								l_dst.ce_gets (l_dst + 1)
								l_tmp___0.item := (0).to_natural_32
								l_n := l_n - 1
								if not l_n.to_boolean then
									js.break
								end
							end
							js.reset
						end
						js.break
					end
					js.reset
					l_wp.ce_gets (l_wp + l_zeros)
				else
					l_up.ce_gets (l_up + (l_size - l_exp))
					l_size := l_exp
				end
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						gmp_inst.gmpn_copyi (l_wp, l_up, l_size)
						js.break
					end
					js.reset
					js.break
				end
				js.reset
			end
		end

	gmpq_set_f (a_q: CE_POINTER [PD_MPQ_STRUCT]; a_f: CE_POINTER [PD_MPF_STRUCT])
		local
			l_fexp: INTEGER_32
			l_fptr: CE_POINTER [NATURAL_32]
			l_fsize: INTEGER_32
			l_abs_fsize: INTEGER_32
			l_tmp: INTEGER_32
			l_flow: NATURAL_32
			l_num_ptr: CE_POINTER [NATURAL_32]
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_32]
			l_num_ptr___0: CE_POINTER [NATURAL_32]
			l_den_ptr: CE_POINTER [NATURAL_32]
			l_den_size: INTEGER_32
			l_dst___0: CE_POINTER [NATURAL_32]
			l_n___0: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_32]
			l_shift: INTEGER_32
			l_dst___1: CE_POINTER [NATURAL_32]
			l_n___1: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_fptr.make
			create l_num_ptr.make
			create l_dst.make
			create l_tmp___1.make
			create l_num_ptr___0.make
			create l_den_ptr.make
			create l_dst___0.make
			create l_tmp___4.make
			create l_dst___1.make
			create l_tmp___5.make

			l_fexp := a_f.item.mp_exp
			l_fptr.ce_gets (a_f.item.mp_d)
			l_fsize := (a_f.item.mp_size).to_integer_32
			if l_fsize >= 0 then
				l_tmp := l_fsize
			else
				l_tmp := -l_fsize
			end
			l_abs_fsize := l_tmp
			if l_fsize = 0 then
				a_q.item.mp_num.mp_size := 0
				a_q.item.mp_den.mp_size := 1
				a_q.item.mp_den.mp_d[0] := (1).to_natural_32
				js.return
			end
			if not js.return_called then
				l_flow := l_fptr.item
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						not (not js.loop_left and then (l_flow = {NATURAL_32} 0))
					loop
						l_abs_fsize := l_abs_fsize - 1
						l_fptr.ce_gets (l_fptr + 1)
						l_flow := l_fptr.item
					end
					js.break
				end
				js.reset
				if l_fexp >= l_abs_fsize then
					if (builtin_expect ((l_fexp > (a_q.item.mp_num.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
						realloc_inst.gmpz_realloc (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_q.c_pointer + {PD_MPQ_STRUCT}.mp_num_offset), l_fexp).do_nothing
					end
					l_num_ptr.ce_gets (a_q.item.mp_num.mp_d)
					from
					until
						js.loop_left
					loop
						js.reset
						if l_fexp - l_abs_fsize /= 0 then
							l_dst.ce_gets (l_num_ptr)
							l_n := l_fexp - l_abs_fsize
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___1.ce_gets (l_dst)
								l_dst.ce_gets (l_dst + 1)
								l_tmp___1.item := (0).to_natural_32
								l_n := l_n - 1
								if not l_n.to_boolean then
									js.break
								end
							end
							js.reset
						end
						js.break
					end
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi ((l_num_ptr + l_fexp) - l_abs_fsize, l_fptr, l_abs_fsize)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
					if l_fsize >= 0 then
						a_q.item.mp_num.mp_size := l_fexp.to_integer_32
					else
						a_q.item.mp_num.mp_size := (-l_fexp).to_integer_32
					end
					a_q.item.mp_den.mp_size := 1
					a_q.item.mp_den.mp_d[0] := (1).to_natural_32
				else
					l_den_size := l_abs_fsize - l_fexp
					if (builtin_expect ((l_abs_fsize > (a_q.item.mp_num.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
						realloc_inst.gmpz_realloc (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_q.c_pointer + {PD_MPQ_STRUCT}.mp_num_offset), l_abs_fsize).do_nothing
					end
					if (builtin_expect ((l_den_size + 1 > (a_q.item.mp_den.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
						realloc_inst.gmpz_realloc (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_q.c_pointer + {PD_MPQ_STRUCT}.mp_den_offset), l_den_size + 1).do_nothing
					end
					l_num_ptr___0.ce_gets (a_q.item.mp_num.mp_d)
					l_den_ptr.ce_gets (a_q.item.mp_den.mp_d)
					if ((l_flow).bit_and ({NATURAL_32} 1)).to_boolean then
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (l_num_ptr___0, l_fptr, l_abs_fsize)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							if l_den_size /= 0 then
								l_dst___0.ce_gets (l_den_ptr)
								l_n___0 := l_den_size
								from
								until
									js.loop_left
								loop
									js.reset
									l_tmp___4.ce_gets (l_dst___0)
									l_dst___0.ce_gets (l_dst___0 + 1)
									l_tmp___4.item := (0).to_natural_32
									l_n___0 := l_n___0 - 1
									if not l_n___0.to_boolean then
										js.break
									end
								end
								js.reset
							end
							js.break
						end
						js.reset
						l_den_ptr[l_den_size] := (1).to_natural_32
					else
						l_den_size := l_den_size - 1
						from
						until
							js.loop_left
						loop
							js.reset
							l_shift := builtin_ctzl (l_flow)
							js.break
						end
						js.reset
						gmp_inst.gmpn_rshift (l_num_ptr___0, l_fptr, l_abs_fsize, l_shift.to_natural_32).do_nothing
						l_abs_fsize := l_abs_fsize - (l_num_ptr___0[(l_abs_fsize - 1)] = {NATURAL_32} 0).to_integer
						from
						until
							js.loop_left
						loop
							js.reset
							if l_den_size /= 0 then
								l_dst___1.ce_gets (l_den_ptr)
								l_n___1 := l_den_size
								from
								until
									js.loop_left
								loop
									js.reset
									l_tmp___5.ce_gets (l_dst___1)
									l_dst___1.ce_gets (l_dst___1 + 1)
									l_tmp___5.item := (0).to_natural_32
									l_n___1 := l_n___1 - 1
									if not l_n___1.to_boolean then
										js.break
									end
								end
								js.reset
							end
							js.break
						end
						js.reset
						l_den_ptr[l_den_size] := ((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1))))).bit_shift_right ((l_shift - 1))
					end
					if l_fsize >= 0 then
						a_q.item.mp_num.mp_size := l_abs_fsize.to_integer_32
					else
						a_q.item.mp_num.mp_size := (-l_abs_fsize).to_integer_32
					end
					a_q.item.mp_den.mp_size := (l_den_size + 1).to_integer_32
				end
			end
		end

end
