class
	P_SET_NUM

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpq_set_num (a_dest: CE_POINTER [PD_MPQ_STRUCT]; a_num: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			l_size := (a_num.item.mp_size).to_integer_32
			if l_size >= 0 then
				l_tmp := l_size
			else
				l_tmp := -l_size
			end
			l_abs_size := l_tmp
			if (a_dest.item.mp_num.mp_alloc).to_integer_32 < l_abs_size then
				realloc_inst.gmpz_realloc (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_dest.c_pointer + {PD_MPQ_STRUCT}.mp_num_offset), l_abs_size).do_nothing
			end
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					gmp_inst.gmpn_copyi (a_dest.item.mp_num.mp_d, a_num.item.mp_d, l_abs_size)
					js.break
				end
				js.reset
				js.break
			end
			js.reset
			a_dest.item.mp_num.mp_size := l_size.to_integer_32
		end

end
