class
	P_SET_Q

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_set_q (a_r: CE_POINTER [PD_MPF_STRUCT]; a_q: CE_POINTER [PD_MPQ_STRUCT])
		local
			l_np: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_prec: INTEGER_32
			l_nsize: INTEGER_32
			l_dsize: INTEGER_32
			l_qsize: INTEGER_32
			l_prospective_qsize: INTEGER_32
			l_tsize: INTEGER_32
			l_zeros: INTEGER_32
			l_sign_quotient: INTEGER_32
			l_high_zero: INTEGER_32
			l_qp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_remp: CE_POINTER [NATURAL_32]
			l_exp: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_size: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___14: CE_POINTER [ANY]
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___16: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_np.make
			create l_dp.make
			create l_qp.make
			create l_tp.make
			create l_remp.make
			create l_tmp_marker.make
			create l_tmp___14.make
			create l_dst.make
			create l_tmp___16.make

			l_nsize := (a_q.item.mp_num.mp_size).to_integer_32
			l_dsize := (a_q.item.mp_den.mp_size).to_integer_32
			if (builtin_expect ((l_nsize = 0).to_integer, 0)).to_boolean then
				a_r.item.mp_size := 0
				a_r.item.mp_exp := (0).to_integer_32
				js.return
			end
			if not js.return_called then
				l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
				l_prec := (a_r.item.mp_prec).to_integer_32
				l_qp.ce_gets (a_r.item.mp_d)
				l_sign_quotient := l_nsize
				if l_nsize >= 0 then
					l_nsize := l_nsize
				else
					l_nsize := -l_nsize
				end
				l_np.ce_gets (a_q.item.mp_num.mp_d)
				l_dp.ce_gets (a_q.item.mp_den.mp_d)
				l_prospective_qsize := (l_nsize - l_dsize) + 1
				l_exp := l_prospective_qsize
				l_qsize := l_prec + 1
				l_zeros := l_qsize - l_prospective_qsize
				l_tsize := l_nsize + l_zeros
				if l_zeros > 0 then
					l_tmp___10 := l_tsize
				else
					l_tmp___10 := (0).to_integer_32
				end
				l_size := l_dsize + l_tmp___10
				if (builtin_expect ((l_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
					l_tmp___14.ce_gets ((l_aaf.new ((l_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				else
					l_tmp___14.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				end
				l_remp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___14))
				l_tp.ce_gets (l_remp + l_dsize)
				if l_zeros > 0 then
					from
					until
						js.loop_left
					loop
						js.reset
						if l_zeros /= 0 then
							l_dst.ce_gets (l_tp)
							l_n := l_zeros
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___16.ce_gets (l_dst)
								l_dst.ce_gets (l_dst + 1)
								l_tmp___16.item := (0).to_natural_32
								l_n := l_n - 1
								if not l_n.to_boolean then
									js.break
								end
							end
							js.reset
						end
						js.break
					end
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (l_tp + l_zeros, l_np, l_nsize)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
					l_np.ce_gets (l_tp)
					l_nsize := l_tsize
				else
					l_nsize := l_nsize + l_zeros
					l_np.ce_gets (l_np - l_zeros)
				end
				tdiv_qr_inst.gmpn_tdiv_qr (l_qp, l_remp, (0).to_integer_32, l_np, l_nsize, l_dp, l_dsize)
				l_high_zero := (l_qp[(l_qsize - 1)] = {NATURAL_32} 0).to_integer
				l_qsize := l_qsize - l_high_zero
				l_exp := l_exp - l_high_zero
				a_r.item.mp_exp := l_exp
				if l_sign_quotient >= 0 then
					a_r.item.mp_size := l_qsize.to_integer_32
				else
					a_r.item.mp_size := (-l_qsize).to_integer_32
				end
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
					end
					js.break
				end
				js.reset
			end
		end

end
