class
	P_SET_Z

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_set_z (a_r: CE_POINTER [PD_MPF_STRUCT]; a_u: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_asize: INTEGER_32
			l_prec: INTEGER_32
			js: JUMP_STATE
		do
			create l_rp.make
			create l_up.make

			l_prec := (a_r.item.mp_prec + 1).to_integer_32
			l_size := (a_u.item.mp_size).to_integer_32
			if l_size >= 0 then
				l_asize := l_size
			else
				l_asize := -l_size
			end
			l_rp.ce_gets (a_r.item.mp_d)
			l_up.ce_gets (a_u.item.mp_d)
			a_r.item.mp_exp := l_asize
			if l_asize > l_prec then
				l_up.ce_gets (l_up + (l_asize - l_prec))
				l_asize := l_prec
			end
			if l_size >= 0 then
				a_r.item.mp_size := l_asize.to_integer_32
			else
				a_r.item.mp_size := (-l_asize).to_integer_32
			end
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					gmp_inst.gmpn_copyi (l_rp, l_up, l_asize)
					js.break
				end
				js.reset
				js.break
			end
			js.reset
		end

	gmpq_set_z (a_dest: CE_POINTER [PD_MPQ_STRUCT]; a_src: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_num_size: INTEGER_32
			l_abs_num_size: INTEGER_32
			js: JUMP_STATE
		do
			l_num_size := (a_src.item.mp_size).to_integer_32
			if l_num_size >= 0 then
				l_abs_num_size := l_num_size
			else
				l_abs_num_size := -l_num_size
			end
			if (a_dest.item.mp_num.mp_alloc).to_integer_32 < l_abs_num_size then
				realloc_inst.gmpz_realloc (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_dest.c_pointer + {PD_MPQ_STRUCT}.mp_num_offset), l_abs_num_size).do_nothing
			end
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					gmp_inst.gmpn_copyi (a_dest.item.mp_num.mp_d, a_src.item.mp_d, l_abs_num_size)
					js.break
				end
				js.reset
				js.break
			end
			js.reset
			a_dest.item.mp_num.mp_size := l_num_size.to_integer_32
			a_dest.item.mp_den.mp_d[0] := (1).to_natural_32
			a_dest.item.mp_den.mp_size := 1
		end

end
