class
	P_SNPRNTFFUNS

inherit
	LIBGMP_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {NONE} -- Initialization

	default_create
		do
			create gmp_snprintf_funs.make
		end

feature {ANY} -- attributes

	gmp_snprintf_funs: PD_DOPRNT_FUNS_T

feature {ANY} -- routines

	gmp_snprintf_format (a_d: CE_POINTER [PD_GMP_SNPRINTF_T]; a_fmt: CE_POINTER [INTEGER_8]; a_orig_ap: CE_VA_LIST): INTEGER_32
		local
			l_orig_ap: CE_VA_LIST
			l_ret: INTEGER_32
			l_step___1: INTEGER_32
			l_alloc: INTEGER_32
			l_avail: INTEGER_32
			l_ap: CE_VA_LIST
			l_p: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_p.make

			create l_orig_ap.make_copy (a_orig_ap)
			l_avail := (a_d.item.size).to_integer_32
			if l_avail > 1 then
				create l_ap.make_copy (l_orig_ap)
				l_ret := vsnprintf (a_d.item.buf, l_avail.to_natural_32, a_fmt, l_ap)
				if l_ret = -1 then
					l_ret := l_avail - 1
				end
				if l_ret < l_avail - 1 then
					l_step___1 := l_ret
				else
					l_step___1 := l_avail - 1
				end
				a_d.item.size := a_d.item.size - l_step___1.to_natural_32
				a_d.item.buf := a_d.item.buf + l_step___1
				if l_ret /= l_avail - 1 then
					Result := l_ret
					js.return
				end
				if not js.return_called then
					if 128 > l_ret then
						l_alloc := 128
					else
						l_alloc := l_ret
					end
				end
			else
				l_alloc := 128
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_alloc := l_alloc * (2)
					l_p.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([l_alloc.to_natural_32 * Integer_8_bytes.to_natural_32])))))
					create l_ap.make_copy (l_orig_ap)
					l_ret := vsnprintf (l_p, l_alloc.to_natural_32, a_fmt, l_ap)
					memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (l_p), l_alloc.to_natural_32])
					if l_ret /= l_alloc - 1 then
						if l_ret /= -1 then
							js.break
						end
					end
				end
				js.reset
				Result := l_ret
			end
		end

	gmp_snprintf_format_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gmp_snprintf_format)
		end

	gmp_snprintf_memory (a_d: CE_POINTER [PD_GMP_SNPRINTF_T]; a_str: CE_POINTER [INTEGER_8]; a_len: NATURAL_32): INTEGER_32
		local
			l_n: NATURAL_32
		do
			if a_d.item.size > {NATURAL_32} 1 then
				if a_d.item.size - {NATURAL_32} 1 < a_len then
					l_n := a_d.item.size - {NATURAL_32} 1
				else
					l_n := a_len
				end
				memcpy (create {CE_POINTER [ANY]}.make_cast (a_d.item.buf), create {CE_POINTER [ANY]}.make_cast (a_str), l_n).do_nothing
				a_d.item.buf := a_d.item.buf + l_n.to_integer_32
				a_d.item.size := a_d.item.size - l_n
			end
			Result := a_len.to_integer_32
		end

	gmp_snprintf_memory_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gmp_snprintf_memory)
		end

	gmp_snprintf_reps (a_d: CE_POINTER [PD_GMP_SNPRINTF_T]; a_c: INTEGER_32; a_reps: INTEGER_32): INTEGER_32
		local
			l_n: NATURAL_32
		do
			if a_d.item.size > {NATURAL_32} 1 then
				if a_d.item.size - {NATURAL_32} 1 < a_reps.to_natural_32 then
					l_n := a_d.item.size - {NATURAL_32} 1
				else
					l_n := a_reps.to_natural_32
				end
				memset (create {CE_POINTER [ANY]}.make_cast (a_d.item.buf), a_c, l_n).do_nothing
				a_d.item.buf := a_d.item.buf + l_n.to_integer_32
				a_d.item.size := a_d.item.size - l_n
			end
			Result := a_reps
		end

	gmp_snprintf_reps_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gmp_snprintf_reps)
		end

	gmp_snprintf_final (a_d: CE_POINTER [PD_GMP_SNPRINTF_T]): INTEGER_32
		do
			if a_d.item.size >= {NATURAL_32} 1 then
				a_d.item.buf[0] := (('%/0/').code).to_integer_8
			end
			Result := 0
		end

	gmp_snprintf_final_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gmp_snprintf_final)
		end

end
