class
	P_SPRINTFFUNS

inherit
	LIBGMP_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {NONE} -- Initialization

	default_create
		do
			create gmp_sprintf_funs.make
		end

feature {ANY} -- attributes

	gmp_sprintf_funs: PD_DOPRNT_FUNS_T

feature {ANY} -- routines

	gmp_sprintf_format (a_bufp: CE_POINTER [CE_POINTER [INTEGER_8]]; a_fmt: CE_POINTER [INTEGER_8]; a_ap: CE_VA_LIST): INTEGER_32
		local
			l_ap: CE_VA_LIST
			l_buf: CE_POINTER [INTEGER_8]
			l_ret: INTEGER_32
		do
			create l_buf.make

			create l_ap.make_copy (a_ap)
			l_buf.ce_gets (a_bufp.item)
			vsprintf (l_buf, a_fmt, l_ap).do_nothing
			l_ret := (strlen (l_buf)).to_integer_32
			a_bufp.item := l_buf + l_ret
			Result := l_ret
		end

	gmp_sprintf_format_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gmp_sprintf_format)
		end

	gmp_sprintf_memory (a_bufp: CE_POINTER [CE_POINTER [INTEGER_8]]; a_str: CE_POINTER [INTEGER_8]; a_len: NATURAL_32): INTEGER_32
		local
			l_buf: CE_POINTER [INTEGER_8]
		do
			create l_buf.make

			l_buf.ce_gets (a_bufp.item)
			a_bufp.item := l_buf + a_len.to_integer_32
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_buf), create {CE_POINTER [ANY]}.make_cast (a_str), a_len).do_nothing
			Result := a_len.to_integer_32
		end

	gmp_sprintf_memory_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gmp_sprintf_memory)
		end

	gmp_sprintf_reps (a_bufp: CE_POINTER [CE_POINTER [INTEGER_8]]; a_c: INTEGER_32; a_reps: INTEGER_32): INTEGER_32
		local
			l_buf: CE_POINTER [INTEGER_8]
		do
			create l_buf.make

			l_buf.ce_gets (a_bufp.item)
			a_bufp.item := l_buf + a_reps
			memset (create {CE_POINTER [ANY]}.make_cast (l_buf), a_c, a_reps.to_natural_32).do_nothing
			Result := a_reps
		end

	gmp_sprintf_reps_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gmp_sprintf_reps)
		end

	gmp_sprintf_final (a_bufp: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_buf: CE_POINTER [INTEGER_8]
		do
			create l_buf.make

			l_buf.ce_gets (a_bufp.item)
			l_buf[0] := (('%/0/').code).to_integer_8
			Result := 0
		end

	gmp_sprintf_final_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gmp_sprintf_final)
		end

end
