class
	P_SQRT

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_sqrt (a_r: CE_POINTER [PD_MPF_STRUCT]; a_u: CE_POINTER [PD_MPF_STRUCT])
		local
			l_usize: INTEGER_32
			l_up: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_prec: INTEGER_32
			l_tsize: INTEGER_32
			l_uexp: INTEGER_32
			l_expodd: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___2: CE_POINTER [ANY]
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_up.make
			create l_tp.make
			create l_tmp_marker.make
			create l_tmp___2.make
			create l_dst.make
			create l_tmp___4.make

			l_usize := (a_u.item.mp_size).to_integer_32
			if l_usize <= 0 then
				if l_usize < 0 then
					errno_inst.gmp_sqrt_of_negative
				end
				a_r.item.mp_size := 0
				a_r.item.mp_exp := (0).to_integer_32
				js.return
			end
			if not js.return_called then
				l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
				l_uexp := a_u.item.mp_exp
				l_prec := (a_r.item.mp_prec).to_integer_32
				l_up.ce_gets (a_u.item.mp_d)
				l_expodd := (l_uexp).bit_and (1)
				l_tsize := 2 * l_prec - l_expodd
				a_r.item.mp_size := l_prec.to_integer_32
				a_r.item.mp_exp := (l_uexp + l_expodd) // 2
				if (builtin_expect ((l_tsize.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
					l_tmp___2.ce_gets ((l_aaf.new ((l_tsize.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				else
					l_tmp___2.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_tsize.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				end
				l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2))
				if l_usize > l_tsize then
					l_up.ce_gets (l_up + (l_usize - l_tsize))
					l_usize := l_tsize
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (l_tp, l_up, l_tsize)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
				else
					from
					until
						js.loop_left
					loop
						js.reset
						if l_tsize - l_usize /= 0 then
							l_dst.ce_gets (l_tp)
							l_n := l_tsize - l_usize
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___4.ce_gets (l_dst)
								l_dst.ce_gets (l_dst + 1)
								l_tmp___4.item := (0).to_natural_32
								l_n := l_n - 1
								if not l_n.to_boolean then
									js.break
								end
							end
							js.reset
						end
						js.break
					end
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (l_tp + (l_tsize - l_usize), l_up, l_usize)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
				end
				sqrtrem_inst.gmpn_sqrtrem (a_r.item.mp_d, create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer), l_tp, l_tsize).do_nothing
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
					end
					js.break
				end
				js.reset
			end
		end

	gmpz_sqrt (a_root: CE_POINTER [PD_MPZ_STRUCT]; a_op: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_op_size: INTEGER_32
			l_root_size: INTEGER_32
			l_root_ptr: CE_POINTER [NATURAL_32]
			l_op_ptr: CE_POINTER [NATURAL_32]
			l_free_me: CE_POINTER [NATURAL_32]
			l_free_me_size: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___3: CE_POINTER [ANY]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_root_ptr.make
			create l_op_ptr.make
			create l_free_me.make
			create l_tmp_marker.make
			create l_tmp___3.make

			l_free_me.ce_gets (create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer))
			l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
			l_op_size := (a_op.item.mp_size).to_integer_32
			if l_op_size <= 0 then
				if l_op_size < 0 then
					errno_inst.gmp_sqrt_of_negative
				end
				a_root.item.mp_size := 0
				js.return
			end
			if not js.return_called then
				l_root_size := (l_op_size + 1) // 2
				l_root_ptr.ce_gets (a_root.item.mp_d)
				l_op_ptr.ce_gets (a_op.item.mp_d)
				if (a_root.item.mp_alloc).to_integer_32 < l_root_size then
					if (l_root_ptr.c_pointer.to_integer_32).to_natural_32 = (l_op_ptr.c_pointer.to_integer_32).to_natural_32 then
						l_free_me.ce_gets (l_root_ptr)
						l_free_me_size := (a_root.item.mp_alloc).to_integer_32
					else
						memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (l_root_ptr), (a_root.item.mp_alloc * 4).to_natural_32])
					end
					a_root.item.mp_alloc := l_root_size.to_integer_32
					l_root_ptr.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([(l_root_size * 4).to_natural_32])))))
					a_root.item.mp_d := l_root_ptr
				elseif (l_root_ptr.c_pointer.to_integer_32).to_natural_32 = (l_op_ptr.c_pointer.to_integer_32).to_natural_32 then
					if (builtin_expect ((l_op_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___3.ce_gets ((l_aaf.new ((l_op_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___3.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_op_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_op_ptr.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___3))
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (l_op_ptr, l_root_ptr, l_op_size)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
				end
				sqrtrem_inst.gmpn_sqrtrem (l_root_ptr, create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer), l_op_ptr, l_op_size).do_nothing
				a_root.item.mp_size := l_root_size.to_integer_32
				if (l_free_me.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (l_free_me), (l_free_me_size * 4).to_natural_32])
				end
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
					end
					js.break
				end
				js.reset
			end
		end

end
