class
	P_TDIV_QR

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_tdiv_qr (a_quot: CE_POINTER [PD_MPZ_STRUCT]; a_rem: CE_POINTER [PD_MPZ_STRUCT]; a_num: CE_POINTER [PD_MPZ_STRUCT]; a_den: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_ql: INTEGER_32
			l_ns: INTEGER_32
			l_ds: INTEGER_32
			l_nl: INTEGER_32
			l_dl: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_np___0: CE_POINTER [NATURAL_32]
			l_rp___0: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_tmp___4: CE_POINTER [ANY]
			l_tp___0: CE_POINTER [NATURAL_32]
			l_tmp___9: CE_POINTER [ANY]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_np.make
			create l_dp.make
			create l_qp.make
			create l_rp.make
			create l_tmp_marker.make
			create l_np___0.make
			create l_rp___0.make
			create l_tp.make
			create l_tmp___4.make
			create l_tp___0.make
			create l_tmp___9.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ns := (a_num.item.mp_size).to_integer_32
					l_ds := (a_den.item.mp_size).to_integer_32
					if l_ns >= 0 then
						l_nl := l_ns
					else
						l_nl := -l_ns
					end
					if l_ds >= 0 then
						l_dl := l_ds
					else
						l_dl := -l_ds
					end
					l_ql := (l_nl - l_dl) + 1
					if l_dl = 0 then
						errno_inst.gmp_divide_by_zero
					end
					if (builtin_expect ((l_dl > (a_rem.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
						realloc_inst.gmpz_realloc (a_rem, l_dl).do_nothing
					end
					if l_ql <= 0 then
						if (a_num.c_pointer.to_integer_32).to_natural_32 /= (a_rem.c_pointer.to_integer_32).to_natural_32 then
							l_np___0.ce_gets (a_num.item.mp_d)
							l_rp___0.ce_gets (a_rem.item.mp_d)
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_rp___0, l_np___0, l_nl)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
							a_rem.item.mp_size := a_num.item.mp_size
						end
						a_quot.item.mp_size := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if (builtin_expect ((l_ql > (a_quot.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
							realloc_inst.gmpz_realloc (a_quot, l_ql).do_nothing
						end
						l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
						l_qp.ce_gets (a_quot.item.mp_d)
						l_rp.ce_gets (a_rem.item.mp_d)
						l_np.ce_gets (a_num.item.mp_d)
						l_dp.ce_gets (a_den.item.mp_d)
						if (l_dp.c_pointer.to_integer_32).to_natural_32 /= (l_rp.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (l_dp.c_pointer.to_integer_32).to_natural_32 /= (l_qp.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if (builtin_expect ((l_dl.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___4.ce_gets ((l_aaf.new ((l_dl.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___4.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_dl.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___4))
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (l_tp, l_dp, l_dl)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						l_dp.ce_gets (l_tp)
				when 6 then -- if done
						if (l_np.c_pointer.to_integer_32).to_natural_32 /= (l_rp.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if (l_np.c_pointer.to_integer_32).to_natural_32 /= (l_qp.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L___0:
						if (builtin_expect ((l_nl.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___9.ce_gets ((l_aaf.new ((l_nl.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___9.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_nl.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_tp___0.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___9))
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (l_tp___0, l_np, l_nl)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						l_np.ce_gets (l_tp___0)
				when 11 then -- if done
						gmpn_tdiv_qr (l_qp, l_rp, 0, l_np, l_nl, l_dp, l_dl)
						l_ql := l_ql - (l_qp[(l_ql - 1)] = {NATURAL_32} 0).to_integer
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								not (not js.loop_left and then (l_dl > 0))
							loop
								js.reset
								if l_rp[(l_dl - 1)] /= {NATURAL_32} 0 then
									js.break
								end
								if not js.loop_jumped then
									l_dl := l_dl - 1
								end
							end
							js.reset
							js.break
						end
						js.reset
						if ((l_ns).bit_xor (l_ds)) >= 0 then
							a_quot.item.mp_size := l_ql.to_integer_32
						else
							a_quot.item.mp_size := (-l_ql).to_integer_32
						end
						if l_ns >= 0 then
							a_rem.item.mp_size := l_dl.to_integer_32
						else
							a_rem.item.mp_size := (-l_dl).to_integer_32
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
							end
							js.break
						end
						js.reset
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_tdiv_qr (a_qp: CE_POINTER [NATURAL_32]; a_rp: CE_POINTER [NATURAL_32]; a_qxn: INTEGER_32; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32)
		local
			l_nn: INTEGER_32
			l_n2p: CE_POINTER [NATURAL_32]
			l_d2p: CE_POINTER [NATURAL_32]
			l_qhl: NATURAL_32
			l_cy: NATURAL_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_cnt: INTEGER_32
			l_dtmp: CE_ARRAY [NATURAL_32]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___7: CE_POINTER [ANY]
			l_adjust: INTEGER_32
			l_dinv: PD_GMP_PI1_T
			l_tmp_marker___0: CE_POINTER [PD_TMP_REENTRANT_T]
			l_n2p___0: CE_POINTER [NATURAL_32]
			l_d2p___0: CE_POINTER [NATURAL_32]
			l_cy___0: NATURAL_32
			l_cnt___0: INTEGER_32
			l_tmp___13: CE_POINTER [ANY]
			l_tmp___18: CE_POINTER [ANY]
			l_tmp___23: CE_POINTER [ANY]
			l_v: NATURAL_32
			l_p: NATURAL_32
			l_t1: NATURAL_32
			l_t0: NATURAL_32
			l_mask: NATURAL_32
			l_itch: INTEGER_32
			l_scratch: CE_POINTER [NATURAL_32]
			l_tmp___30: CE_POINTER [ANY]
			l_qn: INTEGER_32
			l_n2p___1: CE_POINTER [NATURAL_32]
			l_d2p___1: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_cy___1: NATURAL_32
			l_in: INTEGER_32
			l_rn: INTEGER_32
			l_quotient_too_large: NATURAL_32
			l_cnt___1: NATURAL_32
			l_tmp___38: CE_POINTER [ANY]
			l_tmp___43: CE_POINTER [ANY]
			l_tmp___48: CE_POINTER [ANY]
			l_q0: NATURAL_32
			l_r0: NATURAL_32
			l_v___0: NATURAL_32
			l_p___0: NATURAL_32
			l_t1___0: NATURAL_32
			l_t0___0: NATURAL_32
			l_mask___0: NATURAL_32
			l_itch___0: INTEGER_32
			l_scratch___0: CE_POINTER [NATURAL_32]
			l_tmp___55: CE_POINTER [ANY]
			l_r2p: CE_POINTER [NATURAL_32]
			l_dl: NATURAL_32
			l_x___2: NATURAL_32
			l_h: NATURAL_32
			l_dummy: NATURAL_32
			l_cy___2: NATURAL_32
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			l_cy1: NATURAL_32
			l_cy2: NATURAL_32
			l_tmp___60: CE_POINTER [ANY]
			l_ptr_dummy___0: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_n2p.make
			create l_d2p.make
			create l_tmp_marker.make
			create l_dtmp.make (<<2>>)
			create l_tmp___2.make
			create l_tmp___7.make
			create l_dinv.make
			create l_tmp_marker___0.make
			create l_n2p___0.make
			create l_d2p___0.make
			create l_tmp___13.make
			create l_tmp___18.make
			create l_tmp___23.make
			create l_scratch.make
			create l_tmp___30.make
			create l_n2p___1.make
			create l_d2p___1.make
			create l_tp.make
			create l_tmp___38.make
			create l_tmp___43.make
			create l_tmp___48.make
			create l_scratch___0.make
			create l_tmp___55.make
			create l_r2p.make
			create l_ptr_dummy.make
			create l_tmp___60.make
			create l_ptr_dummy___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_nn := a_nn
					from
					until
						js.loop_left
					loop
						js.reset
						if a_qxn /= 0 then
							assert_inst.gmp_assert_fail (ce_string ("tdiv_qr.c"), 40, ce_string ("qxn == 0"))
						end
						js.break
					end
					js.reset
					inspect a_dn.to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 0
					errno_inst.gmp_divide_by_zero
				when 2 then -- switch 1, case 1
					a_rp[0] := gmp_inst.gmpn_divrem_1 (a_qp, (0).to_integer_32, a_np, l_nn, a_dp[0])
					js.return
				when 3 then -- switch 1, case 2
					if not js.return_called then
						l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
						if ((a_dp[1]).bit_and ((({NATURAL_32} 1).bit_shift_left (31)))) = {NATURAL_32} 0 then
							from
							until
								js.loop_left
							loop
								js.reset
								l_cnt := builtin_clzl (a_dp[1])
								js.break
							end
							js.reset
							l_cnt := l_cnt
							l_d2p.ce_gets (l_dtmp)
							l_d2p[1] := ((((a_dp[1]).bit_shift_left (l_cnt))).bit_or (((a_dp[0]).bit_shift_right ((32 - l_cnt)))))
							l_d2p[0] := ((((a_dp[0]).bit_shift_left (l_cnt))).bit_and ({NATURAL_32} 4294967295))
							if (builtin_expect (((l_nn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
								l_tmp___2.ce_gets ((l_aaf.new (((l_nn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							else
								l_tmp___2.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_nn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_n2p.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2))
							l_cy := gmp_inst.gmpn_lshift (l_n2p, a_np, l_nn, l_cnt.to_natural_32)
							l_n2p[l_nn] := l_cy
							l_qhl := gmp_inst.gmpn_divrem_2 (a_qp, 0, l_n2p, l_nn + (l_cy /= {NATURAL_32} 0).to_integer, l_d2p)
							if l_cy = {NATURAL_32} 0 then
								a_qp[(l_nn - 2)] := l_qhl
							end
							a_rp[0] := (((l_n2p[0]).bit_shift_right (l_cnt))).bit_or (((((l_n2p[1]).bit_shift_left ((32 - l_cnt)))).bit_and ({NATURAL_32} 4294967295)))
							a_rp[1] := (l_n2p[1]).bit_shift_right (l_cnt)
						else
							l_d2p.ce_gets (a_dp)
							if (builtin_expect ((l_nn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
								l_tmp___7.ce_gets ((l_aaf.new ((l_nn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							else
								l_tmp___7.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_nn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_n2p.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___7))
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_n2p, a_np, l_nn)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
							l_qhl := gmp_inst.gmpn_divrem_2 (a_qp, 0, l_n2p, l_nn, l_d2p)
							a_qp[(l_nn - 2)] := l_qhl
							a_rp[0] := l_n2p[0]
							a_rp[1] := l_n2p[1]
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
							end
							js.break
						end
						js.reset
						js.return
					end
				when 4 then -- switch 1, default:
					if not js.return_called then
						l_tmp_marker___0.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
						l_adjust := (a_np[(l_nn - 1)] >= a_dp[(a_dn - 1)]).to_integer
						if l_nn + l_adjust.to_integer_32 >= 2 * a_dn then
							a_qp[(l_nn - a_dn)] := (0).to_natural_32
							if ((a_dp[(a_dn - 1)]).bit_and ((({NATURAL_32} 1).bit_shift_left (31)))) = {NATURAL_32} 0 then
								from
								until
									js.loop_left
								loop
									js.reset
									l_cnt___0 := builtin_clzl (a_dp[(a_dn - 1)])
									js.break
								end
								js.reset
								l_cnt___0 := l_cnt___0
								if (builtin_expect ((a_dn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
									l_tmp___13.ce_gets ((l_aaf.new ((a_dn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
								else
									l_tmp___13.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker___0.address, (a_dn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
								end
								l_d2p___0.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___13))
								gmp_inst.gmpn_lshift (l_d2p___0, a_dp, a_dn, l_cnt___0.to_natural_32).do_nothing
								if (builtin_expect (((l_nn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
									l_tmp___18.ce_gets ((l_aaf.new (((l_nn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
								else
									l_tmp___18.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker___0.address, ((l_nn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
								end
								l_n2p___0.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___18))
								l_cy___0 := gmp_inst.gmpn_lshift (l_n2p___0, a_np, l_nn, l_cnt___0.to_natural_32)
								l_n2p___0[l_nn] := l_cy___0
								l_nn := l_nn + l_adjust.to_integer_32
							else
								l_cnt___0 := 0
								l_d2p___0.ce_gets (a_dp)
								if (builtin_expect (((l_nn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
									l_tmp___23.ce_gets ((l_aaf.new (((l_nn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
								else
									l_tmp___23.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker___0.address, ((l_nn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
								end
								l_n2p___0.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___23))
								from
								until
									js.loop_left
								loop
									js.reset
									from
									until
										js.loop_left
									loop
										js.reset
										gmp_inst.gmpn_copyi (l_n2p___0, a_np, l_nn)
										js.break
									end
									js.reset
									js.break
								end
								js.reset
								l_n2p___0[l_nn] := (0).to_natural_32
								l_nn := l_nn + l_adjust.to_integer_32
							end
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									l_v := gmp_impl_inst.gmpn_invert_limb (l_d2p___0[(a_dn - 1)])
									js.break
								end
								js.reset
								l_p := l_d2p___0[(a_dn - 1)] * l_v
								l_p := l_p + (l_d2p___0[(a_dn - 2)])
								if l_p < l_d2p___0[(a_dn - 2)] then
									l_v := l_v - 1
									l_mask := (-(l_p >= l_d2p___0[(a_dn - 1)]).to_integer).to_integer.to_natural_32
									l_p := l_p - (l_d2p___0[(a_dn - 1)])
									l_v := l_v + l_mask
									l_p := l_p - ((l_mask).bit_and (l_d2p___0[(a_dn - 1)]))
								end
								asm116 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_t0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t1), l_d2p___0.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_dn), create {CE_POINTER [NATURAL_32]}.make_shared ($l_v))
								l_p := l_p + l_t1
								if l_p < l_t1 then
									l_v := l_v - 1
									if (builtin_expect ((l_p >= l_d2p___0[(a_dn - 1)]).to_integer, 0)).to_boolean then
										if l_p > l_d2p___0[(a_dn - 1)] then
											l_v := l_v - 1
										elseif l_t0 >= l_d2p___0[(a_dn - 2)] then
											l_v := l_v - 1
										end
									end
								end
								l_dinv.inv32 := l_v
								js.break
							end
							js.reset
							if 19 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
								if a_dn >= 19 then
									if 62 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
										if a_dn >= 62 then
											if 2616 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
												if l_nn >= 2616 then
													if (2492).to_double * a_dn.to_double + (62).to_double * l_nn.to_double > a_dn.to_double * l_nn.to_double then
														dcpi1_div_qr_inst.gmpn_dcpi1_div_qr (a_qp, l_n2p___0, l_nn, l_d2p___0, a_dn, l_dinv.address).do_nothing
													else
														l_itch := (mu_div_qr_inst.gmpn_mu_div_qr_itch (l_nn, a_dn, 0))
														if (builtin_expect ((l_itch.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
															l_tmp___30.ce_gets ((l_aaf.new ((l_itch.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
														else
															l_tmp___30.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker___0.address, (l_itch.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
														end
														l_scratch.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___30))
														mu_div_qr_inst.gmpn_mu_div_qr (a_qp, a_rp, l_n2p___0, l_nn, l_d2p___0, a_dn, l_scratch).do_nothing
														l_n2p___0.ce_gets (a_rp)
													end
												else
													dcpi1_div_qr_inst.gmpn_dcpi1_div_qr (a_qp, l_n2p___0, l_nn, l_d2p___0, a_dn, l_dinv.address).do_nothing
												end
											else
												dcpi1_div_qr_inst.gmpn_dcpi1_div_qr (a_qp, l_n2p___0, l_nn, l_d2p___0, a_dn, l_dinv.address).do_nothing
											end
										else
											dcpi1_div_qr_inst.gmpn_dcpi1_div_qr (a_qp, l_n2p___0, l_nn, l_d2p___0, a_dn, l_dinv.address).do_nothing
										end
									else
										dcpi1_div_qr_inst.gmpn_dcpi1_div_qr (a_qp, l_n2p___0, l_nn, l_d2p___0, a_dn, l_dinv.address).do_nothing
									end
								else
									sbpi1_div_qr_inst.gmpn_sbpi1_div_qr (a_qp, l_n2p___0, l_nn, l_d2p___0, a_dn, l_dinv.inv32).do_nothing
								end
							else
								sbpi1_div_qr_inst.gmpn_sbpi1_div_qr (a_qp, l_n2p___0, l_nn, l_d2p___0, a_dn, l_dinv.inv32).do_nothing
							end
							if l_cnt___0 /= 0 then
								gmp_inst.gmpn_rshift (a_rp, l_n2p___0, a_dn, l_cnt___0.to_natural_32).do_nothing
							else
								from
								until
									js.loop_left
								loop
									js.reset
									from
									until
										js.loop_left
									loop
										js.reset
										gmp_inst.gmpn_copyi (a_rp, l_n2p___0, a_dn)
										js.break
									end
									js.reset
									js.break
								end
								js.reset
							end
							from
							until
								js.loop_left
							loop
								js.reset
								if (builtin_expect (((l_tmp_marker___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
									tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker___0)
								end
								js.break
							end
							js.reset
							js.return
						end
					end
					if not js.return_called then
						l_qn := l_nn - a_dn
						a_qp[l_qn] := (0).to_natural_32
						l_qn := l_qn + l_adjust.to_integer_32
						if l_qn = 0 then
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (a_rp, a_np, a_dn)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								if (builtin_expect (((l_tmp_marker___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
									tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker___0)
								end
								js.break
							end
							js.reset
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 5 then -- if:
						l_in := a_dn - l_qn
						if ((a_dp[(a_dn - 1)]).bit_and ((({NATURAL_32} 1).bit_shift_left (31)))) = {NATURAL_32} 0 then
							from
							until
								js.loop_left
							loop
								js.reset
								l_cnt___1 := (builtin_clzl (a_dp[(a_dn - 1)])).to_natural_32
								js.break
							end
							js.reset
							l_cnt___1 := l_cnt___1
							if (builtin_expect ((l_qn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
								l_tmp___38.ce_gets ((l_aaf.new ((l_qn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							else
								l_tmp___38.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker___0.address, (l_qn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_d2p___1.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___38))
							gmp_inst.gmpn_lshift (l_d2p___1, a_dp + l_in, l_qn, l_cnt___1).do_nothing
							l_d2p___1[0] := (l_d2p___1[0]).bit_or (((a_dp[(l_in - 1)]).bit_shift_right (({NATURAL_32} 32 - l_cnt___1).to_integer_32)))
							if (builtin_expect (((2 * l_qn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
								l_tmp___43.ce_gets ((l_aaf.new (((2 * l_qn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							else
								l_tmp___43.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker___0.address, ((2 * l_qn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_n2p___1.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___43))
							l_cy___1 := gmp_inst.gmpn_lshift (l_n2p___1, (a_np + l_nn) - 2 * l_qn, 2 * l_qn, l_cnt___1)
							if l_adjust.to_boolean then
								l_n2p___1[2 * l_qn] := l_cy___1
								l_n2p___1.ce_gets (l_n2p___1 + 1)
							else
								l_n2p___1[0] := (l_n2p___1[0]).bit_or (((a_np[((l_nn - 2 * l_qn) - 1)]).bit_shift_right (({NATURAL_32} 32 - l_cnt___1).to_integer_32)))
							end
						else
							l_cnt___1 := {NATURAL_32} 0
							l_d2p___1.ce_gets (a_dp + l_in)
							if (builtin_expect (((2 * l_qn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
								l_tmp___48.ce_gets ((l_aaf.new (((2 * l_qn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							else
								l_tmp___48.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker___0.address, ((2 * l_qn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_n2p___1.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___48))
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_n2p___1, (a_np + l_nn) - 2 * l_qn, 2 * l_qn)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
							if l_adjust.to_boolean then
								l_n2p___1[2 * l_qn] := (0).to_natural_32
								l_n2p___1.ce_gets (l_n2p___1 + 1)
							end
						end
						if l_qn = 1 then
							asm117 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_q0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_r0), l_n2p___1.address, l_d2p___1.address)
							l_n2p___1[0] := l_r0
							a_qp[0] := l_q0
						elseif l_qn = 2 then
							gmp_inst.gmpn_divrem_2 (a_qp, 0, l_n2p___1, 4, l_d2p___1).do_nothing
						else
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									l_v___0 := gmp_impl_inst.gmpn_invert_limb (l_d2p___1[(l_qn - 1)])
									js.break
								end
								js.reset
								l_p___0 := l_d2p___1[(l_qn - 1)] * l_v___0
								l_p___0 := l_p___0 + (l_d2p___1[(l_qn - 2)])
								if l_p___0 < l_d2p___1[(l_qn - 2)] then
									l_v___0 := l_v___0 - 1
									l_mask___0 := (-(l_p___0 >= l_d2p___1[(l_qn - 1)]).to_integer).to_integer.to_natural_32
									l_p___0 := l_p___0 - (l_d2p___1[(l_qn - 1)])
									l_v___0 := l_v___0 + l_mask___0
									l_p___0 := l_p___0 - ((l_mask___0).bit_and (l_d2p___1[(l_qn - 1)]))
								end
								asm118 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_t0___0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t1___0), l_d2p___1.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_qn), create {CE_POINTER [NATURAL_32]}.make_shared ($l_v___0))
								l_p___0 := l_p___0 + l_t1___0
								if l_p___0 < l_t1___0 then
									l_v___0 := l_v___0 - 1
									if (builtin_expect ((l_p___0 >= l_d2p___1[(l_qn - 1)]).to_integer, 0)).to_boolean then
										if l_p___0 > l_d2p___1[(l_qn - 1)] then
											l_v___0 := l_v___0 - 1
										elseif l_t0___0 >= l_d2p___1[(l_qn - 2)] then
											l_v___0 := l_v___0 - 1
										end
									end
								end
								l_dinv.inv32 := l_v___0
								js.break
							end
							js.reset
							if 19 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
								if l_qn >= 19 then
									if 1308 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
										if l_qn >= 1308 then
											l_itch___0 := (mu_div_qr_inst.gmpn_mu_div_qr_itch (2 * l_qn, l_qn, 0))
											if (builtin_expect ((l_itch___0.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
												l_tmp___55.ce_gets ((l_aaf.new ((l_itch___0.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
											else
												l_tmp___55.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker___0.address, (l_itch___0.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
											end
											l_scratch___0.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___55))
											l_r2p.ce_gets (a_rp)
											if (a_np.c_pointer.to_integer_32).to_natural_32 = (l_r2p.c_pointer.to_integer_32).to_natural_32 then
												l_r2p.ce_gets (l_r2p + (l_nn - l_qn))
											end
											mu_div_qr_inst.gmpn_mu_div_qr (a_qp, l_r2p, l_n2p___1, 2 * l_qn, l_d2p___1, l_qn, l_scratch___0).do_nothing
											from
											until
												js.loop_left
											loop
												js.reset
												from
												until
													js.loop_left
												loop
													js.reset
													gmp_inst.gmpn_copyi (l_n2p___1, l_r2p, l_qn)
													js.break
												end
												js.reset
												js.break
											end
											js.reset
										else
											dcpi1_div_qr_inst.gmpn_dcpi1_div_qr (a_qp, l_n2p___1, 2 * l_qn, l_d2p___1, l_qn, l_dinv.address).do_nothing
										end
									else
										dcpi1_div_qr_inst.gmpn_dcpi1_div_qr (a_qp, l_n2p___1, 2 * l_qn, l_d2p___1, l_qn, l_dinv.address).do_nothing
									end
								else
									sbpi1_div_qr_inst.gmpn_sbpi1_div_qr (a_qp, l_n2p___1, 2 * l_qn, l_d2p___1, l_qn, l_dinv.inv32).do_nothing
								end
							else
								sbpi1_div_qr_inst.gmpn_sbpi1_div_qr (a_qp, l_n2p___1, 2 * l_qn, l_d2p___1, l_qn, l_dinv.inv32).do_nothing
							end
						end
						l_rn := l_qn
						if l_in - 2 < 0 then
							l_dl := (0).to_natural_32
						else
							l_dl := a_dp[(l_in - 2)]
						end
						l_x___2 := ((((a_dp[(l_in - 1)]).bit_shift_left (l_cnt___1.to_integer_32))).bit_or (((((l_dl).bit_shift_right (1))).bit_shift_right (((l_cnt___1).bit_not \\ {NATURAL_32} 32).to_integer_32))))
						asm119 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_dummy), create {CE_POINTER [NATURAL_32]}.make_shared ($l_h), create {CE_POINTER [NATURAL_32]}.make_shared ($l_x___2), a_qp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_qn))
						if l_n2p___1[(l_qn - 1)] < l_h then
							from
							until
								js.loop_left
							loop
								js.reset
								asm120 (l_ptr_dummy.address, a_qp.address)
								js.break
							end
							js.reset
							l_cy___2 := gmp_inst.gmpn_add_n (l_n2p___1, l_n2p___1, l_d2p___1, l_qn)
							if l_cy___2.to_boolean then
								l_n2p___1[l_qn] := l_cy___2
								l_rn := l_rn + 1
							end
						end
						l_quotient_too_large := (0).to_natural_32
						if l_cnt___1 /= {NATURAL_32} 0 then
							l_cy1 := gmp_inst.gmpn_lshift (l_n2p___1, l_n2p___1, l_rn, {NATURAL_32} 32 - l_cnt___1)
							l_n2p___1[0] := (l_n2p___1[0]).bit_or (((a_np[(l_in - 1)]).bit_and ((({NATURAL_32} 4294967295).bit_shift_right (l_cnt___1.to_integer_32)))))
							l_cy2 := gmp_inst.gmpn_submul_1 (l_n2p___1, a_qp, l_qn, ((a_dp[(l_in - 1)]).bit_and ((({NATURAL_32} 4294967295).bit_shift_right (l_cnt___1.to_integer_32)))))
							if l_qn /= l_rn then
								from
								until
									js.loop_left
								loop
									js.reset
									if not (l_n2p___1[l_qn] >= l_cy2) then
										assert_inst.gmp_assert_fail (ce_string ("tdiv_qr.c"), 332, ce_string ("n2p[qn] >= cy2"))
									end
									js.break
								end
								js.reset
								l_n2p___1[l_qn] := l_n2p___1[l_qn] - l_cy2
							else
								l_n2p___1[l_qn] := l_cy1 - l_cy2
								l_quotient_too_large := (l_cy1 < l_cy2).to_integer.to_natural_32
								l_rn := l_rn + 1
							end
							l_in := l_in - 1
						end
						if (builtin_expect ((a_dn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___60.ce_gets ((l_aaf.new ((a_dn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___60.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker___0.address, (a_dn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___60))
						if not (l_in < l_qn) then
							l_pos := -1 + 9 -- skip if block
						end
				when 6 then -- if:
						if l_in = 0 then
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (a_rp, l_n2p___1, l_rn)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								if l_rn /= a_dn then
									assert_inst.gmp_assert_fail (ce_string ("tdiv_qr.c"), 353, ce_string ("rn == dn"))
								end
								js.break
							end
							js.reset
							l_pos := -1 + 11 -- goto foo
						end
				when 7 then
						mul_inst.gmpn_mul (l_tp, a_qp, l_qn, a_dp, l_in).do_nothing
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						mul_inst.gmpn_mul (l_tp, a_dp, l_in, a_qp, l_qn).do_nothing
				when 10 then -- if done
						l_cy___1 := gmp_inst.gmpn_sub (l_n2p___1, l_n2p___1, l_rn, (l_tp + l_in), l_qn)
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (a_rp + l_in, l_n2p___1, a_dn - l_in)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						l_quotient_too_large := (l_quotient_too_large).bit_or (l_cy___1)
						l_cy___1 := gmp_inst.gmpn_sub_n (a_rp, a_np, l_tp, l_in)
						l_cy___1 := gmp_inst.gmpn_sub_1 (a_rp + l_in, (a_rp + l_in), l_rn, l_cy___1)
						l_quotient_too_large := (l_quotient_too_large).bit_or (l_cy___1)
				when 11 then -- foo:
						if l_quotient_too_large.to_boolean then
							from
							until
								js.loop_left
							loop
								js.reset
								asm121 (l_ptr_dummy___0.address, a_qp.address)
								js.break
							end
							js.reset
							gmp_inst.gmpn_add_n (a_rp, a_rp, a_dp, a_dn).do_nothing
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect (((l_tmp_marker___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker___0)
							end
							js.break
						end
						js.reset
				when 12 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
