class
	P_TDIV_R

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_tdiv_r (a_rem: CE_POINTER [PD_MPZ_STRUCT]; a_num: CE_POINTER [PD_MPZ_STRUCT]; a_den: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_ql: INTEGER_32
			l_ns: INTEGER_32
			l_ds: INTEGER_32
			l_nl: INTEGER_32
			l_dl: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_np___0: CE_POINTER [NATURAL_32]
			l_rp___0: CE_POINTER [NATURAL_32]
			l_tmp___3: CE_POINTER [ANY]
			l_tp: CE_POINTER [NATURAL_32]
			l_tmp___8: CE_POINTER [ANY]
			l_tp___0: CE_POINTER [NATURAL_32]
			l_tmp___13: CE_POINTER [ANY]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_np.make
			create l_dp.make
			create l_qp.make
			create l_rp.make
			create l_tmp_marker.make
			create l_np___0.make
			create l_rp___0.make
			create l_tmp___3.make
			create l_tp.make
			create l_tmp___8.make
			create l_tp___0.make
			create l_tmp___13.make

			l_ns := (a_num.item.mp_size).to_integer_32
			l_ds := (a_den.item.mp_size).to_integer_32
			if l_ns >= 0 then
				l_nl := l_ns
			else
				l_nl := -l_ns
			end
			if l_ds >= 0 then
				l_dl := l_ds
			else
				l_dl := -l_ds
			end
			l_ql := (l_nl - l_dl) + 1
			if l_dl = 0 then
				errno_inst.gmp_divide_by_zero
			end
			if (builtin_expect ((l_dl > (a_rem.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
				realloc_inst.gmpz_realloc (a_rem, l_dl).do_nothing
			end
			if l_ql <= 0 then
				if (a_num.c_pointer.to_integer_32).to_natural_32 /= (a_rem.c_pointer.to_integer_32).to_natural_32 then
					l_np___0.ce_gets (a_num.item.mp_d)
					l_rp___0.ce_gets (a_rem.item.mp_d)
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (l_rp___0, l_np___0, l_nl)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
					a_rem.item.mp_size := a_num.item.mp_size
				end
				js.return
			end
			if not js.return_called then
				l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
				if (builtin_expect ((l_ql.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
					l_tmp___3.ce_gets ((l_aaf.new ((l_ql.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				else
					l_tmp___3.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_ql.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				end
				l_qp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___3))
				l_rp.ce_gets (a_rem.item.mp_d)
				l_np.ce_gets (a_num.item.mp_d)
				l_dp.ce_gets (a_den.item.mp_d)
				if (l_dp.c_pointer.to_integer_32).to_natural_32 = (l_rp.c_pointer.to_integer_32).to_natural_32 then
					if (builtin_expect ((l_dl.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___8.ce_gets ((l_aaf.new ((l_dl.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___8.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_dl.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___8))
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (l_tp, l_dp, l_dl)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
					l_dp.ce_gets (l_tp)
				end
				if (l_np.c_pointer.to_integer_32).to_natural_32 = (l_rp.c_pointer.to_integer_32).to_natural_32 then
					if (builtin_expect ((l_nl.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___13.ce_gets ((l_aaf.new ((l_nl.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___13.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_nl.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_tp___0.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___13))
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (l_tp___0, l_np, l_nl)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
					l_np.ce_gets (l_tp___0)
				end
				tdiv_qr_inst.gmpn_tdiv_qr (l_qp, l_rp, 0, l_np, l_nl, l_dp, l_dl)
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						not (not js.loop_left and then (l_dl > 0))
					loop
						js.reset
						if l_rp[(l_dl - 1)] /= {NATURAL_32} 0 then
							js.break
						end
						if not js.loop_jumped then
							l_dl := l_dl - 1
						end
					end
					js.reset
					js.break
				end
				js.reset
				if l_ns >= 0 then
					a_rem.item.mp_size := l_dl.to_integer_32
				else
					a_rem.item.mp_size := (-l_dl).to_integer_32
				end
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
					end
					js.break
				end
				js.reset
			end
		end

end
