class
	P_TDIV_R_2EXP

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_tdiv_r_2exp (a_res: CE_POINTER [PD_MPZ_STRUCT]; a_in: CE_POINTER [PD_MPZ_STRUCT]; a_cnt: NATURAL_32)
		local
			l_in_size: INTEGER_32
			l_tmp: INTEGER_32
			l_res_size: INTEGER_32
			l_limb_cnt: INTEGER_32
			l_in_ptr: CE_POINTER [NATURAL_32]
			l_x___2: NATURAL_32
			js: JUMP_STATE
		do
			create l_in_ptr.make

			if a_in.item.mp_size >= 0 then
				l_tmp := a_in.item.mp_size
			else
				l_tmp := -a_in.item.mp_size
			end
			l_in_size := l_tmp.to_integer_32
			l_limb_cnt := (a_cnt // {NATURAL_32} 32).to_integer_32
			l_in_ptr.ce_gets (a_in.item.mp_d)
			if l_in_size > l_limb_cnt then
				l_x___2 := ((l_in_ptr[l_limb_cnt]).bit_and (((({NATURAL_32} 1).bit_shift_left ((a_cnt \\ {NATURAL_32} 32).to_integer_32)) - {NATURAL_32} 1)))
				if l_x___2 /= {NATURAL_32} 0 then
					l_res_size := l_limb_cnt + 1
					if (a_res.item.mp_alloc).to_integer_32 < l_res_size then
						realloc_inst.gmpz_realloc (a_res, l_res_size).do_nothing
					end
					a_res.item.mp_d[l_limb_cnt] := l_x___2
				else
					l_res_size := l_limb_cnt
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							not (not js.loop_left and then (l_res_size > 0))
						loop
							js.reset
							if l_in_ptr[(l_res_size - 1)] /= {NATURAL_32} 0 then
								js.break
							end
							if not js.loop_jumped then
								l_res_size := l_res_size - 1
							end
						end
						js.reset
						js.break
					end
					js.reset
					if (a_res.item.mp_alloc).to_integer_32 < l_res_size then
						realloc_inst.gmpz_realloc (a_res, l_res_size).do_nothing
					end
					l_limb_cnt := l_res_size
				end
			else
				l_res_size := l_in_size
				if (a_res.item.mp_alloc).to_integer_32 < l_res_size then
					realloc_inst.gmpz_realloc (a_res, l_res_size).do_nothing
				end
				l_limb_cnt := l_res_size
			end
			if (a_res.c_pointer.to_integer_32).to_natural_32 /= (a_in.c_pointer.to_integer_32).to_natural_32 then
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						gmp_inst.gmpn_copyi (a_res.item.mp_d, a_in.item.mp_d, l_limb_cnt)
						js.break
					end
					js.reset
					js.break
				end
				js.reset
			end
			if a_in.item.mp_size >= 0 then
				a_res.item.mp_size := l_res_size.to_integer_32
			else
				a_res.item.mp_size := (-l_res_size).to_integer_32
			end
		end

end
