class
	P_TOOM22_MUL

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_toom22_mul (a_pp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			l_t: INTEGER_32
			l_vm1_neg: INTEGER_32
			l_cy: NATURAL_32
			l_cy2: NATURAL_32
			l_asm1: CE_POINTER [NATURAL_32]
			l_bsm1: CE_POINTER [NATURAL_32]
			l_dst: CE_POINTER [NATURAL_32]
			l_n2: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_32]
			l_dst___0: CE_POINTER [NATURAL_32]
			l_n___0: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_32]
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			l_ptr_dummy___0: CE_POINTER [NATURAL_32]
			l_ptr_dummy___1: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_asm1.make
			create l_bsm1.make
			create l_dst.make
			create l_tmp___0.make
			create l_dst___0.make
			create l_tmp___4.make
			create l_ptr_dummy.make
			create l_ptr_dummy___0.make
			create l_ptr_dummy___1.make

			l_s := (a_an).bit_shift_right (1)
			l_n := a_an - l_s
			l_t := a_bn - l_n
			l_asm1.ce_gets (a_pp)
			l_bsm1.ce_gets (a_pp + l_n)
			l_vm1_neg := 0
			if l_s = l_n then
				if (gmp_inst.gmpn_cmp (a_ap, a_ap + l_n, l_n)) < 0 then
					gmp_inst.gmpn_sub_n (l_asm1, a_ap + l_n, a_ap, l_n).do_nothing
					l_vm1_neg := 1
				else
					gmp_inst.gmpn_sub_n (l_asm1, a_ap, a_ap + l_n, l_n).do_nothing
				end
			elseif (gmp_impl_inst.mpn_zero_p (a_ap + l_s, l_n - l_s)).to_boolean then
				if (gmp_inst.gmpn_cmp (a_ap, a_ap + l_n, l_s)) < 0 then
					gmp_inst.gmpn_sub_n (l_asm1, a_ap + l_n, a_ap, l_s).do_nothing
					from
					until
						js.loop_left
					loop
						js.reset
						if l_n - l_s /= 0 then
							l_dst.ce_gets (l_asm1 + l_s)
							l_n2 := l_n - l_s
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___0.ce_gets (l_dst)
								l_dst.ce_gets (l_dst + 1)
								l_tmp___0.item := (0).to_natural_32
								l_n2 := l_n2 - 1
								if not l_n2.to_boolean then
									js.break
								end
							end
							js.reset
						end
						js.break
					end
					js.reset
					l_vm1_neg := 1
				else
					gmp_inst.gmpn_sub (l_asm1, a_ap, l_n, a_ap + l_n, l_s).do_nothing
				end
			else
				gmp_inst.gmpn_sub (l_asm1, a_ap, l_n, a_ap + l_n, l_s).do_nothing
			end
			if l_t = l_n then
				if (gmp_inst.gmpn_cmp (a_bp, a_bp + l_n, l_n)) < 0 then
					gmp_inst.gmpn_sub_n (l_bsm1, a_bp + l_n, a_bp, l_n).do_nothing
					l_vm1_neg := (l_vm1_neg).bit_xor ((1))
				else
					gmp_inst.gmpn_sub_n (l_bsm1, a_bp, a_bp + l_n, l_n).do_nothing
				end
			elseif (gmp_impl_inst.mpn_zero_p (a_bp + l_t, l_n - l_t)).to_boolean then
				if (gmp_inst.gmpn_cmp (a_bp, a_bp + l_n, l_t)) < 0 then
					gmp_inst.gmpn_sub_n (l_bsm1, a_bp + l_n, a_bp, l_t).do_nothing
					from
					until
						js.loop_left
					loop
						js.reset
						if l_n - l_t /= 0 then
							l_dst___0.ce_gets (l_bsm1 + l_t)
							l_n___0 := l_n - l_t
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___4.ce_gets (l_dst___0)
								l_dst___0.ce_gets (l_dst___0 + 1)
								l_tmp___4.item := (0).to_natural_32
								l_n___0 := l_n___0 - 1
								if not l_n___0.to_boolean then
									js.break
								end
							end
							js.reset
						end
						js.break
					end
					js.reset
					l_vm1_neg := (l_vm1_neg).bit_xor ((1))
				else
					gmp_inst.gmpn_sub (l_bsm1, a_bp, l_n, a_bp + l_n, l_t).do_nothing
				end
			else
				gmp_inst.gmpn_sub (l_bsm1, a_bp, l_n, a_bp + l_n, l_t).do_nothing
			end
			from
			until
				js.loop_left
			loop
				js.reset
				if 20 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n >= 20 then
						gmpn_toom22_mul (a_scratch, l_asm1, l_n, l_bsm1, l_n, a_scratch + 2 * l_n)
					else
						gmp_impl_inst.gmpn_mul_basecase (a_scratch, l_asm1, l_n, l_bsm1, l_n)
					end
				else
					gmp_impl_inst.gmpn_mul_basecase (a_scratch, l_asm1, l_n, l_bsm1, l_n)
				end
				js.break
			end
			js.reset
			if l_s > l_t then
				from
				until
					js.loop_left
				loop
					js.reset
					if 20 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
						if l_t >= 20 then
							if 4 * l_s < 5 * l_t then
								gmpn_toom22_mul (a_pp + 2 * l_n, a_ap + l_n, l_s, a_bp + l_n, l_t, a_scratch + 2 * l_n)
							else
								toom32_mul_inst.gmpn_toom32_mul (a_pp + 2 * l_n, a_ap + l_n, l_s, a_bp + l_n, l_t, a_scratch + 2 * l_n)
							end
						else
							gmp_impl_inst.gmpn_mul_basecase (a_pp + 2 * l_n, a_ap + l_n, l_s, a_bp + l_n, l_t)
						end
					else
						gmp_impl_inst.gmpn_mul_basecase (a_pp + 2 * l_n, a_ap + l_n, l_s, a_bp + l_n, l_t)
					end
					js.break
				end
				js.reset
			else
				from
				until
					js.loop_left
				loop
					js.reset
					if 20 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
						if l_s >= 20 then
							gmpn_toom22_mul (a_pp + 2 * l_n, a_ap + l_n, l_s, a_bp + l_n, l_s, a_scratch + 2 * l_n)
						else
							gmp_impl_inst.gmpn_mul_basecase (a_pp + 2 * l_n, a_ap + l_n, l_s, a_bp + l_n, l_s)
						end
					else
						gmp_impl_inst.gmpn_mul_basecase (a_pp + 2 * l_n, a_ap + l_n, l_s, a_bp + l_n, l_s)
					end
					js.break
				end
				js.reset
			end
			from
			until
				js.loop_left
			loop
				js.reset
				if 20 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n >= 20 then
						gmpn_toom22_mul (a_pp, a_ap, l_n, a_bp, l_n, a_scratch + 2 * l_n)
					else
						gmp_impl_inst.gmpn_mul_basecase (a_pp, a_ap, l_n, a_bp, l_n)
					end
				else
					gmp_impl_inst.gmpn_mul_basecase (a_pp, a_ap, l_n, a_bp, l_n)
				end
				js.break
			end
			js.reset
			l_cy := gmp_inst.gmpn_add_n (a_pp + 2 * l_n, (a_pp + l_n), (a_pp + 2 * l_n), l_n)
			l_cy2 := l_cy + (gmp_inst.gmpn_add_n (a_pp + l_n, (a_pp + 2 * l_n), a_pp, l_n))
			l_cy := l_cy + (gmp_inst.gmpn_add (a_pp + 2 * l_n, (a_pp + 2 * l_n), l_n, ((a_pp + 2 * l_n) + l_n), (l_s + l_t) - l_n))
			if l_vm1_neg.to_boolean then
				l_cy := l_cy + (gmp_inst.gmpn_add_n (a_pp + l_n, (a_pp + l_n), a_scratch, 2 * l_n))
			else
				l_cy := l_cy - (gmp_inst.gmpn_sub_n (a_pp + l_n, (a_pp + l_n), a_scratch, 2 * l_n))
			end
			from
			until
				js.loop_left
			loop
				js.reset
				asm131 (l_ptr_dummy.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy2))
				js.break
			end
			js.reset
			if (builtin_expect ((l_cy <= {NATURAL_32} 2).to_integer, 1)).to_boolean then
				from
				until
					js.loop_left
				loop
					js.reset
					asm132 (l_ptr_dummy___0.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
					js.break
				end
				js.reset
			else
				from
				until
					js.loop_left
				loop
					js.reset
					asm133 (l_ptr_dummy___1.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n))
					js.break
				end
				js.reset
			end
		end

end
