class
	P_TOOM32_MUL

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_toom32_mul (a_pp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			l_t: INTEGER_32
			l_vm1_neg: INTEGER_32
			l_cy: NATURAL_32
			l_hi: INTEGER_32
			l_ap1_hi: NATURAL_32
			l_bp1_hi: NATURAL_32
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_dst: CE_POINTER [NATURAL_32]
			l_n2: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_32]
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			l_ptr_dummy___0: CE_POINTER [NATURAL_32]
			l_ptr_dummy___1: CE_POINTER [NATURAL_32]
			l_ptr_dummy___2: CE_POINTER [NATURAL_32]
			l_ptr_dummy___3: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_dst.make
			create l_tmp___4.make
			create l_ptr_dummy.make
			create l_ptr_dummy___0.make
			create l_ptr_dummy___1.make
			create l_ptr_dummy___2.make
			create l_ptr_dummy___3.make

			if 2 * a_an >= 3 * a_bn then
				l_tmp := (a_an - 1).to_natural_32 // {NATURAL_32} 3
			else
				l_tmp := (((a_bn - 1)).bit_shift_right (1)).to_natural_32
			end
			l_n := ({NATURAL_32} 1 + l_tmp).to_integer_32
			l_s := a_an - 2 * l_n
			l_t := a_bn - l_n
			l_ap1_hi := gmp_inst.gmpn_add (a_pp, a_ap, l_n, a_ap + 2 * l_n, l_s)
			if l_ap1_hi = {NATURAL_32} 0 then
				if (gmp_inst.gmpn_cmp (a_pp, a_ap + l_n, l_n)) < 0 then
					gmp_inst.gmpn_sub_n (a_pp + 2 * l_n, a_ap + l_n, a_pp, l_n).do_nothing
					l_hi := 0
					l_vm1_neg := 1
				else
					l_tmp___0 := gmp_inst.gmpn_sub_n (a_pp + 2 * l_n, a_pp, a_ap + l_n, l_n)
					l_hi := (l_ap1_hi - l_tmp___0).to_integer_32
					l_vm1_neg := 0
				end
			else
				l_tmp___0 := gmp_inst.gmpn_sub_n (a_pp + 2 * l_n, a_pp, a_ap + l_n, l_n)
				l_hi := (l_ap1_hi - l_tmp___0).to_integer_32
				l_vm1_neg := 0
			end
			l_ap1_hi := l_ap1_hi + (gmp_inst.gmpn_add_n (a_pp, a_pp, a_ap + l_n, l_n))
			if l_t = l_n then
				l_bp1_hi := gmp_inst.gmpn_add_n (a_pp + l_n, a_bp, a_bp + l_n, l_n)
				if (gmp_inst.gmpn_cmp (a_bp, a_bp + l_n, l_n)) < 0 then
					gmp_inst.gmpn_sub_n (a_pp + 3 * l_n, a_bp + l_n, a_bp, l_n).do_nothing
					l_vm1_neg := (l_vm1_neg).bit_xor ((1))
				else
					gmp_inst.gmpn_sub_n (a_pp + 3 * l_n, a_bp, a_bp + l_n, l_n).do_nothing
				end
			else
				l_bp1_hi := gmp_inst.gmpn_add (a_pp + l_n, a_bp, l_n, a_bp + l_n, l_t)
				if (gmp_impl_inst.mpn_zero_p (a_bp + l_t, l_n - l_t)).to_boolean then
					if (gmp_inst.gmpn_cmp (a_bp, a_bp + l_n, l_t)) < 0 then
						gmp_inst.gmpn_sub_n (a_pp + 3 * l_n, a_bp + l_n, a_bp, l_t).do_nothing
						from
						until
							js.loop_left
						loop
							js.reset
							if l_n - l_t /= 0 then
								l_dst.ce_gets ((a_pp + 3 * l_n) + l_t)
								l_n2 := l_n - l_t
								from
								until
									js.loop_left
								loop
									js.reset
									l_tmp___4.ce_gets (l_dst)
									l_dst.ce_gets (l_dst + 1)
									l_tmp___4.item := (0).to_natural_32
									l_n2 := l_n2 - 1
									if not l_n2.to_boolean then
										js.break
									end
								end
								js.reset
							end
							js.break
						end
						js.reset
						l_vm1_neg := (l_vm1_neg).bit_xor ((1))
					else
						gmp_inst.gmpn_sub (a_pp + 3 * l_n, a_bp, l_n, a_bp + l_n, l_t).do_nothing
					end
				else
					gmp_inst.gmpn_sub (a_pp + 3 * l_n, a_bp, l_n, a_bp + l_n, l_t).do_nothing
				end
			end
			from
			until
				js.loop_left
			loop
				js.reset
				mul_n_inst.gmpn_mul_n (a_scratch, a_pp, (a_pp + l_n), l_n)
				js.break
			end
			js.reset
			if l_ap1_hi = {NATURAL_32} 1 then
				l_cy := l_bp1_hi + (gmp_inst.gmpn_add_n (a_scratch + l_n, (a_scratch + l_n), (a_pp + l_n), l_n))
			elseif l_ap1_hi = {NATURAL_32} 2 then
				l_cy := {NATURAL_32} 2 * l_bp1_hi + (gmp_inst.gmpn_addmul_1 (a_scratch + l_n, (a_pp + l_n), l_n, (2).to_natural_32))
			else
				l_cy := (0).to_natural_32
			end
			if l_bp1_hi /= {NATURAL_32} 0 then
				l_cy := l_cy + (gmp_inst.gmpn_add_n (a_scratch + l_n, (a_scratch + l_n), a_pp, l_n))
			end
			a_scratch[2 * l_n] := l_cy
			from
			until
				js.loop_left
			loop
				js.reset
				mul_n_inst.gmpn_mul_n (a_pp, (a_pp + 2 * l_n), (a_pp + 3 * l_n), l_n)
				js.break
			end
			js.reset
			if l_hi.to_boolean then
				l_hi := (gmp_inst.gmpn_add_n (a_pp + l_n, (a_pp + l_n), (a_pp + 3 * l_n), l_n)).to_integer_32
			end
			a_pp[2 * l_n] := l_hi.to_natural_32
			if l_vm1_neg.to_boolean then
				gmp_inst.gmpn_sub_n (a_scratch, a_scratch, a_pp, 2 * l_n + 1).do_nothing
				gmp_inst.gmpn_rshift (a_scratch, a_scratch, 2 * l_n + 1, {NATURAL_32} 1).do_nothing
			else
				gmp_inst.gmpn_add_n (a_scratch, a_scratch, a_pp, 2 * l_n + 1).do_nothing
				gmp_inst.gmpn_rshift (a_scratch, a_scratch, 2 * l_n + 1, {NATURAL_32} 1).do_nothing
			end
			l_hi := (a_pp[2 * l_n]).to_integer_32
			l_cy := gmp_inst.gmpn_add_n (a_pp + 2 * l_n, a_scratch, (a_scratch + l_n), l_n)
			from
			until
				js.loop_left
			loop
				js.reset
				asm134 (l_ptr_dummy.address, a_scratch.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
			if l_vm1_neg.to_boolean then
				l_cy := gmp_inst.gmpn_add_n (a_scratch, a_scratch, a_pp, l_n)
				l_hi := (l_hi.to_natural_32 + (gmp_impl_inst.gmpn_add_nc (a_pp + 2 * l_n, (a_pp + 2 * l_n), (a_pp + l_n), l_n, l_cy))).to_integer_32
				from
				until
					js.loop_left
				loop
					js.reset
					asm135 (l_ptr_dummy___0.address, a_scratch.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n), create {CE_POINTER [INTEGER_32]}.make_shared ($l_hi))
					js.break
				end
				js.reset
			else
				l_cy := gmp_inst.gmpn_sub_n (a_scratch, a_scratch, a_pp, l_n)
				l_hi := (l_hi.to_natural_32 + (gmp_impl_inst.gmpn_sub_nc (a_pp + 2 * l_n, (a_pp + 2 * l_n), (a_pp + l_n), l_n, l_cy))).to_integer_32
				from
				until
					js.loop_left
				loop
					js.reset
					asm136 (l_ptr_dummy___1.address, a_scratch.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n), create {CE_POINTER [INTEGER_32]}.make_shared ($l_hi))
					js.break
				end
				js.reset
			end
			from
			until
				js.loop_left
			loop
				js.reset
				mul_n_inst.gmpn_mul_n (a_pp, a_ap, a_bp, l_n)
				js.break
			end
			js.reset
			if l_s > l_t then
				mul_inst.gmpn_mul (a_pp + 3 * l_n, a_ap + 2 * l_n, l_s, a_bp + l_n, l_t).do_nothing
			else
				mul_inst.gmpn_mul (a_pp + 3 * l_n, a_bp + l_n, l_t, a_ap + 2 * l_n, l_s).do_nothing
			end
			l_cy := gmp_inst.gmpn_sub_n (a_pp + l_n, (a_pp + l_n), (a_pp + 3 * l_n), l_n)
			l_hi := (a_scratch[2 * l_n] + l_cy).to_integer_32
			l_cy := gmp_impl_inst.gmpn_sub_nc (a_pp + 2 * l_n, (a_pp + 2 * l_n), a_pp, l_n, l_cy)
			l_hi := (l_hi.to_natural_32 - (gmp_impl_inst.gmpn_sub_nc (a_pp + 3 * l_n, (a_scratch + l_n), (a_pp + l_n), l_n, l_cy))).to_integer_32
			l_hi := (l_hi.to_natural_32 + (gmp_inst.gmpn_add (a_pp + l_n, (a_pp + l_n), 3 * l_n, a_scratch, l_n))).to_integer_32
			if (builtin_expect ((l_s + l_t > l_n).to_integer, 1)).to_boolean then
				l_hi := (l_hi.to_natural_32 - (gmp_inst.gmpn_sub (a_pp + 2 * l_n, (a_pp + 2 * l_n), 2 * l_n, (a_pp + 4 * l_n), (l_s + l_t) - l_n))).to_integer_32
				if l_hi < 0 then
					from
					until
						js.loop_left
					loop
						js.reset
						asm137 (l_ptr_dummy___2.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n), create {CE_POINTER [INTEGER_32]}.make_shared ($l_hi))
						js.break
					end
					js.reset
				else
					from
					until
						js.loop_left
					loop
						js.reset
						asm138 (l_ptr_dummy___3.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n), create {CE_POINTER [INTEGER_32]}.make_shared ($l_hi))
						js.break
					end
					js.reset
				end
			else
			end
		end

end
