class
	P_TOOM33_MUL

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_toom33_mul (a_pp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			l_t: INTEGER_32
			l_vm1_neg: INTEGER_32
			l_cy: NATURAL_32
			l_vinf0: NATURAL_32
			l_gp: CE_POINTER [NATURAL_32]
			l_as1: CE_POINTER [NATURAL_32]
			l_asm1: CE_POINTER [NATURAL_32]
			l_as2: CE_POINTER [NATURAL_32]
			l_bs1: CE_POINTER [NATURAL_32]
			l_bsm1: CE_POINTER [NATURAL_32]
			l_bs2: CE_POINTER [NATURAL_32]
			l_tmp___0: NATURAL_32
			l_tmp___5: NATURAL_32
			js: JUMP_STATE
		do
			create l_gp.make
			create l_as1.make
			create l_asm1.make
			create l_as2.make
			create l_bs1.make
			create l_bsm1.make
			create l_bs2.make

			l_n := ((a_an + 2).to_natural_32 // {NATURAL_32} 3).to_integer_32
			l_s := a_an - 2 * l_n
			l_t := a_bn - 2 * l_n
			l_as1.ce_gets ((a_scratch + 4 * l_n) + 4)
			l_asm1.ce_gets ((a_scratch + 2 * l_n) + 2)
			l_as2.ce_gets ((a_pp + l_n) + 1)
			l_bs1.ce_gets (a_pp)
			l_bsm1.ce_gets ((a_scratch + 3 * l_n) + 3)
			l_bs2.ce_gets ((a_pp + 2 * l_n) + 2)
			l_gp.ce_gets (a_scratch)
			l_vm1_neg := 0
			l_cy := gmp_inst.gmpn_add (l_gp, a_ap, l_n, a_ap + 2 * l_n, l_s)
			l_as1[l_n] := l_cy + (gmp_inst.gmpn_add_n (l_as1, l_gp, a_ap + l_n, l_n))
			if l_cy = {NATURAL_32} 0 then
				if (gmp_inst.gmpn_cmp (l_gp, a_ap + l_n, l_n)) < 0 then
					gmp_inst.gmpn_sub_n (l_asm1, a_ap + l_n, l_gp, l_n).do_nothing
					l_asm1[l_n] := (0).to_natural_32
					l_vm1_neg := 1
				else
					l_tmp___0 := gmp_inst.gmpn_sub_n (l_asm1, l_gp, a_ap + l_n, l_n)
					l_cy := l_cy - l_tmp___0
					l_asm1[l_n] := l_cy
				end
			else
				l_tmp___0 := gmp_inst.gmpn_sub_n (l_asm1, l_gp, a_ap + l_n, l_n)
				l_cy := l_cy - l_tmp___0
				l_asm1[l_n] := l_cy
			end
			l_cy := gmp_inst.gmpn_add_n (l_as2, a_ap + 2 * l_n, l_as1, l_s)
			if l_s /= l_n then
				l_cy := gmp_inst.gmpn_add_1 (l_as2 + l_s, (l_as1 + l_s), l_n - l_s, l_cy)
			end
			l_cy := l_cy + (l_as1[l_n])
			l_cy := {NATURAL_32} 2 * l_cy + (gmp_inst.gmpn_lshift (l_as2, l_as2, l_n, {NATURAL_32} 1))
			l_cy := l_cy - (gmp_inst.gmpn_sub_n (l_as2, l_as2, a_ap, l_n))
			l_as2[l_n] := l_cy
			l_cy := gmp_inst.gmpn_add (l_gp, a_bp, l_n, a_bp + 2 * l_n, l_t)
			l_bs1[l_n] := l_cy + (gmp_inst.gmpn_add_n (l_bs1, l_gp, a_bp + l_n, l_n))
			if l_cy = {NATURAL_32} 0 then
				if (gmp_inst.gmpn_cmp (l_gp, a_bp + l_n, l_n)) < 0 then
					gmp_inst.gmpn_sub_n (l_bsm1, a_bp + l_n, l_gp, l_n).do_nothing
					l_bsm1[l_n] := (0).to_natural_32
					l_vm1_neg := (l_vm1_neg).bit_xor ((1))
				else
					l_tmp___5 := gmp_inst.gmpn_sub_n (l_bsm1, l_gp, a_bp + l_n, l_n)
					l_cy := l_cy - l_tmp___5
					l_bsm1[l_n] := l_cy
				end
			else
				l_tmp___5 := gmp_inst.gmpn_sub_n (l_bsm1, l_gp, a_bp + l_n, l_n)
				l_cy := l_cy - l_tmp___5
				l_bsm1[l_n] := l_cy
			end
			l_cy := gmp_inst.gmpn_add_n (l_bs2, l_bs1, a_bp + 2 * l_n, l_t)
			if l_t /= l_n then
				l_cy := gmp_inst.gmpn_add_1 (l_bs2 + l_t, (l_bs1 + l_t), l_n - l_t, l_cy)
			end
			l_cy := l_cy + (l_bs1[l_n])
			l_cy := {NATURAL_32} 2 * l_cy + (gmp_inst.gmpn_lshift (l_bs2, l_bs2, l_n, {NATURAL_32} 1))
			l_cy := l_cy - (gmp_inst.gmpn_sub_n (l_bs2, l_bs2, a_bp, l_n))
			l_bs2[l_n] := l_cy
			from
			until
				js.loop_left
			loop
				js.reset
				toom22_mul_inst.gmpn_toom22_mul (a_scratch, l_asm1, l_n + 1, l_bsm1, l_n + 1, (a_scratch + 5 * l_n) + 5)
				js.break
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				toom22_mul_inst.gmpn_toom22_mul ((a_scratch + 2 * l_n) + 1, l_as2, l_n + 1, l_bs2, l_n + 1, (a_scratch + 5 * l_n) + 5)
				js.break
			end
			js.reset
			if l_s > l_t then
				mul_inst.gmpn_mul (a_pp + 4 * l_n, a_ap + 2 * l_n, l_s, a_bp + 2 * l_n, l_t).do_nothing
			else
				from
				until
					js.loop_left
				loop
					js.reset
					toom22_mul_inst.gmpn_toom22_mul (a_pp + 4 * l_n, a_ap + 2 * l_n, l_s, a_bp + 2 * l_n, l_s, (a_scratch + 5 * l_n) + 5)
					js.break
				end
				js.reset
			end
			l_vinf0 := (a_pp + 4 * l_n)[0]
			l_cy := (a_pp + 4 * l_n)[1]
			from
			until
				js.loop_left
			loop
				js.reset
				toom22_mul_inst.gmpn_toom22_mul (a_pp + 2 * l_n, l_as1, l_n + 1, l_bs1, l_n + 1, (a_scratch + 5 * l_n) + 5)
				js.break
			end
			js.reset;
			(a_pp + 4 * l_n)[1] := l_cy
			from
			until
				js.loop_left
			loop
				js.reset
				toom22_mul_inst.gmpn_toom22_mul (a_pp, a_ap, l_n, a_bp, l_n, (a_scratch + 5 * l_n) + 5)
				js.break
			end
			js.reset
			toom_interpolate_5pts_inst.gmpn_toom_interpolate_5pts (a_pp, (a_scratch + 2 * l_n) + 1, a_scratch, l_n, l_s + l_t, l_vm1_neg, l_vinf0)
		end

end
