class
	P_TOOM42_MUL

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_toom42_mul (a_pp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			l_t: INTEGER_32
			l_vm1_neg: INTEGER_32
			l_cy: NATURAL_32
			l_vinf0: NATURAL_32
			l_a0_a2: CE_POINTER [NATURAL_32]
			l_a1_a3: CE_POINTER [NATURAL_32]
			l_as1: CE_POINTER [NATURAL_32]
			l_asm1: CE_POINTER [NATURAL_32]
			l_as2: CE_POINTER [NATURAL_32]
			l_bs1: CE_POINTER [NATURAL_32]
			l_bsm1: CE_POINTER [NATURAL_32]
			l_bs2: CE_POINTER [NATURAL_32]
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_dst: CE_POINTER [NATURAL_32]
			l_n2: INTEGER_32
			l_tmp___12: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_a0_a2.make
			create l_a1_a3.make
			create l_as1.make
			create l_asm1.make
			create l_as2.make
			create l_bs1.make
			create l_bsm1.make
			create l_bs2.make
			create l_tmp_marker.make
			create l_dst.make
			create l_tmp___12.make

			if a_an >= 2 * a_bn then
				l_n := ((a_an + 3)).bit_shift_right (2)
			else
				l_n := ((a_bn + 1)).bit_shift_right (1)
			end
			l_s := a_an - 3 * l_n
			l_t := a_bn - l_n
			l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
			l_as1.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
			l_asm1.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
			l_as2.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
			l_bs1.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
			l_bsm1.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new ((l_n.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
			l_bs2.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
			l_a0_a2.ce_gets (a_pp)
			l_a1_a3.ce_gets ((a_pp + l_n) + 1)
			l_vm1_neg := ((toom_eval_dgr3_pm1_inst.gmpn_toom_eval_dgr3_pm1 (l_as1, l_asm1, a_ap, l_n, l_s, l_a0_a2))).bit_and (1)
			l_cy := gmp_inst.gmpn_lshift (l_as2, a_ap + 3 * l_n, l_s, {NATURAL_32} 1)
			l_cy := l_cy + (gmp_inst.gmpn_add_n (l_as2, a_ap + 2 * l_n, l_as2, l_s))
			if l_s /= l_n then
				l_cy := gmp_inst.gmpn_add_1 (l_as2 + l_s, (a_ap + 2 * l_n) + l_s, l_n - l_s, l_cy)
			end
			l_cy := {NATURAL_32} 2 * l_cy + (gmp_inst.gmpn_lshift (l_as2, l_as2, l_n, {NATURAL_32} 1))
			l_cy := l_cy + (gmp_inst.gmpn_add_n (l_as2, a_ap + l_n, l_as2, l_n))
			l_cy := {NATURAL_32} 2 * l_cy + (gmp_inst.gmpn_lshift (l_as2, l_as2, l_n, {NATURAL_32} 1))
			l_cy := l_cy + (gmp_inst.gmpn_add_n (l_as2, a_ap, l_as2, l_n))
			l_as2[l_n] := l_cy
			if l_t = l_n then
				l_bs1[l_n] := gmp_inst.gmpn_add_n (l_bs1, a_bp, a_bp + l_n, l_n)
				if (gmp_inst.gmpn_cmp (a_bp, a_bp + l_n, l_n)) < 0 then
					gmp_inst.gmpn_sub_n (l_bsm1, a_bp + l_n, a_bp, l_n).do_nothing
					l_vm1_neg := (l_vm1_neg).bit_xor ((1))
				else
					gmp_inst.gmpn_sub_n (l_bsm1, a_bp, a_bp + l_n, l_n).do_nothing
				end
			else
				l_bs1[l_n] := gmp_inst.gmpn_add (l_bs1, a_bp, l_n, a_bp + l_n, l_t)
				if (gmp_impl_inst.mpn_zero_p (a_bp + l_t, l_n - l_t)).to_boolean then
					if (gmp_inst.gmpn_cmp (a_bp, a_bp + l_n, l_t)) < 0 then
						gmp_inst.gmpn_sub_n (l_bsm1, a_bp + l_n, a_bp, l_t).do_nothing
						from
						until
							js.loop_left
						loop
							js.reset
							if l_n - l_t /= 0 then
								l_dst.ce_gets (l_bsm1 + l_t)
								l_n2 := l_n - l_t
								from
								until
									js.loop_left
								loop
									js.reset
									l_tmp___12.ce_gets (l_dst)
									l_dst.ce_gets (l_dst + 1)
									l_tmp___12.item := (0).to_natural_32
									l_n2 := l_n2 - 1
									if not l_n2.to_boolean then
										js.break
									end
								end
								js.reset
							end
							js.break
						end
						js.reset
						l_vm1_neg := (l_vm1_neg).bit_xor ((1))
					else
						gmp_inst.gmpn_sub (l_bsm1, a_bp, l_n, a_bp + l_n, l_t).do_nothing
					end
				else
					gmp_inst.gmpn_sub (l_bsm1, a_bp, l_n, a_bp + l_n, l_t).do_nothing
				end
			end
			gmp_inst.gmpn_add (l_bs2, l_bs1, l_n + 1, a_bp + l_n, l_t).do_nothing
			from
			until
				js.loop_left
			loop
				js.reset
				mul_n_inst.gmpn_mul_n (a_scratch, l_asm1, l_bsm1, l_n)
				js.break
			end
			js.reset
			l_cy := (0).to_natural_32
			if l_asm1[l_n] /= {NATURAL_32} 0 then
				l_cy := gmp_inst.gmpn_add_n (a_scratch + l_n, (a_scratch + l_n), l_bsm1, l_n)
			end
			a_scratch[2 * l_n] := l_cy
			from
			until
				js.loop_left
			loop
				js.reset
				mul_n_inst.gmpn_mul_n ((a_scratch + 2 * l_n) + 1, l_as2, l_bs2, l_n + 1)
				js.break
			end
			js.reset
			if l_s > l_t then
				mul_inst.gmpn_mul (a_pp + 4 * l_n, a_ap + 3 * l_n, l_s, a_bp + l_n, l_t).do_nothing
			else
				mul_inst.gmpn_mul (a_pp + 4 * l_n, a_bp + l_n, l_t, a_ap + 3 * l_n, l_s).do_nothing
			end
			l_vinf0 := (a_pp + 4 * l_n)[0]
			from
			until
				js.loop_left
			loop
				js.reset
				mul_n_inst.gmpn_mul_n (a_pp + 2 * l_n, l_as1, l_bs1, l_n)
				js.break
			end
			js.reset
			if l_as1[l_n] = {NATURAL_32} 1 then
				l_cy := l_bs1[l_n] + (gmp_inst.gmpn_add_n ((a_pp + 2 * l_n) + l_n, ((a_pp + 2 * l_n) + l_n), l_bs1, l_n))
			elseif l_as1[l_n] = {NATURAL_32} 2 then
				l_cy := {NATURAL_32} 2 * l_bs1[l_n] + (gmp_inst.gmpn_addmul_1 ((a_pp + 2 * l_n) + l_n, l_bs1, l_n, (2).to_natural_32))
			elseif l_as1[l_n] = {NATURAL_32} 3 then
				l_cy := {NATURAL_32} 3 * l_bs1[l_n] + (gmp_inst.gmpn_addmul_1 ((a_pp + 2 * l_n) + l_n, l_bs1, l_n, (3).to_natural_32))
			else
				l_cy := (0).to_natural_32
			end
			if l_bs1[l_n] /= {NATURAL_32} 0 then
				l_cy := l_cy + (gmp_inst.gmpn_add_n ((a_pp + 2 * l_n) + l_n, ((a_pp + 2 * l_n) + l_n), l_as1, l_n))
			end
			(a_pp + 2 * l_n)[2 * l_n] := l_cy
			from
			until
				js.loop_left
			loop
				js.reset
				mul_n_inst.gmpn_mul_n (a_pp, a_ap, a_bp, l_n)
				js.break
			end
			js.reset
			toom_interpolate_5pts_inst.gmpn_toom_interpolate_5pts (a_pp, (a_scratch + 2 * l_n) + 1, a_scratch, l_n, l_s + l_t, l_vm1_neg, l_vinf0)
			from
			until
				js.loop_left
			loop
				js.reset
				if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
					tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
				end
				js.break
			end
			js.reset
		end

end
