class
	P_TOOM52_MUL

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_toom52_mul (a_pp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			l_t: INTEGER_32
			l_flags: INTEGER_32
			l_tmp: NATURAL_32
			l_dst: CE_POINTER [NATURAL_32]
			l_n2: INTEGER_32
			l_tmp___2: CE_POINTER [NATURAL_32]
			l_dst___0: CE_POINTER [NATURAL_32]
			l_n___0: INTEGER_32
			l_tmp___6: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_dst.make
			create l_tmp___2.make
			create l_dst___0.make
			create l_tmp___6.make

			if 2 * a_an >= 5 * a_bn then
				l_tmp := (a_an - 1).to_natural_32 // {NATURAL_32} 5
			else
				l_tmp := (((a_bn - 1)).bit_shift_right (1)).to_natural_32
			end
			l_n := ({NATURAL_32} 1 + l_tmp).to_integer_32
			l_s := a_an - 4 * l_n
			l_t := a_bn - l_n
			l_flags := ((2).bit_and ((toom_eval_pm2_inst.gmpn_toom_eval_pm2 ((a_pp + 3 * l_n) + 3, (a_scratch + 4 * l_n) + 4, {NATURAL_32} 4, a_ap, l_n, l_s, (a_scratch + 3 * l_n) + 3))))
			if l_t = l_n then
				a_pp[l_n] := gmp_inst.gmpn_add_n (a_pp, a_bp, a_bp + l_n, l_n)
				if (gmp_inst.gmpn_cmp (a_bp, a_bp + l_n, l_n)) < 0 then
					gmp_inst.gmpn_sub_n ((a_scratch + 2 * l_n) + 2, a_bp + l_n, a_bp, l_n).do_nothing
					l_flags := ((l_flags.to_natural_32).bit_xor ({NATURAL_32} 1)).to_integer_32
				else
					gmp_inst.gmpn_sub_n ((a_scratch + 2 * l_n) + 2, a_bp, a_bp + l_n, l_n).do_nothing
				end
			else
				a_pp[l_n] := gmp_inst.gmpn_add (a_pp, a_bp, l_n, a_bp + l_n, l_t)
				if (gmp_impl_inst.mpn_zero_p (a_bp + l_t, l_n - l_t)).to_boolean then
					if (gmp_inst.gmpn_cmp (a_bp, a_bp + l_n, l_t)) < 0 then
						gmp_inst.gmpn_sub_n ((a_scratch + 2 * l_n) + 2, a_bp + l_n, a_bp, l_t).do_nothing
						from
						until
							js.loop_left
						loop
							js.reset
							if l_n - l_t /= 0 then
								l_dst.ce_gets (((a_scratch + 2 * l_n) + 2) + l_t)
								l_n2 := l_n - l_t
								from
								until
									js.loop_left
								loop
									js.reset
									l_tmp___2.ce_gets (l_dst)
									l_dst.ce_gets (l_dst + 1)
									l_tmp___2.item := (0).to_natural_32
									l_n2 := l_n2 - 1
									if not l_n2.to_boolean then
										js.break
									end
								end
								js.reset
							end
							js.break
						end
						js.reset
						l_flags := ((l_flags.to_natural_32).bit_xor ({NATURAL_32} 1)).to_integer_32
					else
						gmp_inst.gmpn_sub ((a_scratch + 2 * l_n) + 2, a_bp, l_n, a_bp + l_n, l_t).do_nothing
					end
				else
					gmp_inst.gmpn_sub ((a_scratch + 2 * l_n) + 2, a_bp, l_n, a_bp + l_n, l_t).do_nothing
				end
			end
			gmp_inst.gmpn_add ((a_pp + 2 * l_n) + 2, a_pp, l_n + 1, a_bp + l_n, l_t).do_nothing
			if ((l_flags.to_natural_32).bit_and ({NATURAL_32} 1)).to_boolean then
				((a_pp + l_n) + 1)[l_n] := gmp_inst.gmpn_add ((a_pp + l_n) + 1, ((a_scratch + 2 * l_n) + 2), l_n, a_bp + l_n, l_t)
				l_flags := ((l_flags.to_natural_32).bit_xor ({NATURAL_32} 2)).to_integer_32
			else
				((a_pp + l_n) + 1)[l_n] := (0).to_natural_32
				if l_t = l_n then
					if (gmp_inst.gmpn_cmp (((a_scratch + 2 * l_n) + 2), a_bp + l_n, l_n)) < 0 then
						gmp_inst.gmpn_sub_n ((a_pp + l_n) + 1, a_bp + l_n, ((a_scratch + 2 * l_n) + 2), l_n).do_nothing
						l_flags := ((l_flags.to_natural_32).bit_xor ({NATURAL_32} 2)).to_integer_32
					else
						gmp_inst.gmpn_sub_n ((a_pp + l_n) + 1, ((a_scratch + 2 * l_n) + 2), a_bp + l_n, l_n).do_nothing
					end
				elseif (gmp_impl_inst.mpn_zero_p ((((a_scratch + 2 * l_n) + 2) + l_t), l_n - l_t)).to_boolean then
					if (gmp_inst.gmpn_cmp (((a_scratch + 2 * l_n) + 2), a_bp + l_n, l_t)) < 0 then
						gmp_inst.gmpn_sub_n ((a_pp + l_n) + 1, a_bp + l_n, ((a_scratch + 2 * l_n) + 2), l_t).do_nothing
						from
						until
							js.loop_left
						loop
							js.reset
							if l_n - l_t /= 0 then
								l_dst___0.ce_gets (((a_pp + l_n) + 1) + l_t)
								l_n___0 := l_n - l_t
								from
								until
									js.loop_left
								loop
									js.reset
									l_tmp___6.ce_gets (l_dst___0)
									l_dst___0.ce_gets (l_dst___0 + 1)
									l_tmp___6.item := (0).to_natural_32
									l_n___0 := l_n___0 - 1
									if not l_n___0.to_boolean then
										js.break
									end
								end
								js.reset
							end
							js.break
						end
						js.reset
						l_flags := ((l_flags.to_natural_32).bit_xor ({NATURAL_32} 2)).to_integer_32
					else
						gmp_inst.gmpn_sub ((a_pp + l_n) + 1, ((a_scratch + 2 * l_n) + 2), l_n, a_bp + l_n, l_t).do_nothing
					end
				else
					gmp_inst.gmpn_sub ((a_pp + l_n) + 1, ((a_scratch + 2 * l_n) + 2), l_n, a_bp + l_n, l_t).do_nothing
				end
			end
			l_flags := ((l_flags.to_natural_32).bit_xor (((1).bit_and ((toom_eval_pm1_inst.gmpn_toom_eval_pm1 ((a_pp + 4 * l_n) + 4, (a_scratch + 3 * l_n) + 3, {NATURAL_32} 4, a_ap, l_n, l_s, a_scratch)))).to_natural_32)).to_integer_32
			mul_inst.gmpn_mul (a_scratch, ((a_scratch + 3 * l_n) + 3), l_n + 1, ((a_scratch + 2 * l_n) + 2), l_n).do_nothing
			mul_n_inst.gmpn_mul_n ((a_scratch + 2 * l_n) + 1, ((a_scratch + 4 * l_n) + 4), ((a_pp + l_n) + 1), l_n + 1)
			mul_n_inst.gmpn_mul_n ((a_scratch + 4 * l_n) + 2, ((a_pp + 3 * l_n) + 3), ((a_pp + 2 * l_n) + 2), l_n + 1)
			mul_n_inst.gmpn_mul_n (a_pp + 2 * l_n, ((a_pp + 4 * l_n) + 4), a_pp, l_n + 1)
			if l_s > l_t then
				mul_inst.gmpn_mul (a_pp + 5 * l_n, a_ap + 4 * l_n, l_s, a_bp + l_n, l_t).do_nothing
			else
				mul_inst.gmpn_mul (a_pp + 5 * l_n, a_bp + l_n, l_t, a_ap + 4 * l_n, l_s).do_nothing
			end
			mul_n_inst.gmpn_mul_n (a_pp, a_ap, a_bp, l_n)
			toom_interpolate_6pts_inst.gmpn_toom_interpolate_6pts (a_pp, l_n, l_flags, a_scratch, (a_scratch + 2 * l_n) + 1, (a_scratch + 4 * l_n) + 2, l_t + l_s)
		end

end
