class
	P_TOOM53_MUL

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_toom53_mul (a_pp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			l_t: INTEGER_32
			l_cy: NATURAL_32
			l_gp: CE_POINTER [NATURAL_32]
			l_as1: CE_POINTER [NATURAL_32]
			l_asm1: CE_POINTER [NATURAL_32]
			l_as2: CE_POINTER [NATURAL_32]
			l_asm2: CE_POINTER [NATURAL_32]
			l_ash: CE_POINTER [NATURAL_32]
			l_bs1: CE_POINTER [NATURAL_32]
			l_bsm1: CE_POINTER [NATURAL_32]
			l_bs2: CE_POINTER [NATURAL_32]
			l_bsm2: CE_POINTER [NATURAL_32]
			l_bsh: CE_POINTER [NATURAL_32]
			l_flags: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp: NATURAL_32
			l_tmp___19: NATURAL_32
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_gp.make
			create l_as1.make
			create l_asm1.make
			create l_as2.make
			create l_asm2.make
			create l_ash.make
			create l_bs1.make
			create l_bsm1.make
			create l_bs2.make
			create l_bsm2.make
			create l_bsh.make
			create l_tmp_marker.make
			create l_ptr_dummy.make

			if 3 * a_an >= 5 * a_bn then
				l_tmp := (a_an - 1).to_natural_32 // {NATURAL_32} 5
			else
				l_tmp := (a_bn - 1).to_natural_32 // {NATURAL_32} 3
			end
			l_n := ({NATURAL_32} 1 + l_tmp).to_integer_32
			l_s := a_an - 4 * l_n
			l_t := a_bn - 2 * l_n
			l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
			l_as1.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
			l_asm1.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
			l_as2.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
			l_asm2.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
			l_ash.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
			l_bs1.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
			l_bsm1.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
			l_bs2.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
			l_bsm2.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
			l_bsh.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new (((l_n + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
			l_gp.ce_gets (a_pp)
			l_flags := ((2).bit_and ((toom_eval_pm1_inst.gmpn_toom_eval_pm1 (l_as1, l_asm1, {NATURAL_32} 4, a_ap, l_n, l_s, l_gp))))
			l_flags := ((l_flags.to_natural_32).bit_or (((1).bit_and ((toom_eval_pm2_inst.gmpn_toom_eval_pm2 (l_as2, l_asm2, {NATURAL_32} 4, a_ap, l_n, l_s, l_gp)))).to_natural_32)).to_integer_32
			l_cy := gmp_inst.gmpn_lshift (l_ash, a_ap, l_n, {NATURAL_32} 1)
			l_cy := l_cy + (gmp_inst.gmpn_add_n (l_ash, l_ash, a_ap + l_n, l_n))
			l_cy := {NATURAL_32} 2 * l_cy + (gmp_inst.gmpn_lshift (l_ash, l_ash, l_n, {NATURAL_32} 1))
			l_cy := l_cy + (gmp_inst.gmpn_add_n (l_ash, l_ash, a_ap + 2 * l_n, l_n))
			l_cy := {NATURAL_32} 2 * l_cy + (gmp_inst.gmpn_lshift (l_ash, l_ash, l_n, {NATURAL_32} 1))
			l_cy := l_cy + (gmp_inst.gmpn_add_n (l_ash, l_ash, a_ap + 3 * l_n, l_n))
			l_cy := {NATURAL_32} 2 * l_cy + (gmp_inst.gmpn_lshift (l_ash, l_ash, l_n, {NATURAL_32} 1))
			l_ash[l_n] := l_cy + (gmp_inst.gmpn_add (l_ash, l_ash, l_n, a_ap + 4 * l_n, l_s))
			l_bs1[l_n] := gmp_inst.gmpn_add (l_bs1, a_bp, l_n, a_bp + 2 * l_n, l_t)
			if l_bs1[l_n] = {NATURAL_32} 0 then
				if (gmp_inst.gmpn_cmp (l_bs1, a_bp + l_n, l_n)) < 0 then
					gmp_inst.gmpn_sub_n (l_bsm1, a_bp + l_n, l_bs1, l_n).do_nothing
					l_bsm1[l_n] := (0).to_natural_32
					l_flags := ((l_flags.to_natural_32).bit_xor ({NATURAL_32} 2)).to_integer_32
				else
					l_tmp___19 := gmp_inst.gmpn_sub_n (l_bsm1, l_bs1, a_bp + l_n, l_n)
					l_bsm1[l_n] := l_bs1[l_n] - l_tmp___19
				end
			else
				l_tmp___19 := gmp_inst.gmpn_sub_n (l_bsm1, l_bs1, a_bp + l_n, l_n)
				l_bsm1[l_n] := l_bs1[l_n] - l_tmp___19
			end
			l_bs1[l_n] := l_bs1[l_n] + (gmp_inst.gmpn_add_n (l_bs1, l_bs1, a_bp + l_n, l_n))
			l_cy := gmp_inst.gmpn_lshift (l_gp, a_bp + 2 * l_n, l_t, {NATURAL_32} 2)
			l_bs2[l_n] := gmp_inst.gmpn_add (l_bs2, a_bp, l_n, l_gp, l_t)
			from
			until
				js.loop_left
			loop
				js.reset
				asm139 (l_ptr_dummy.address, l_bs2.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_t), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
			l_gp[l_n] := gmp_inst.gmpn_lshift (l_gp, a_bp + l_n, l_n, {NATURAL_32} 1)
			if (gmp_inst.gmpn_cmp (l_bs2, l_gp, l_n + 1)) < 0 then
				gmp_inst.gmpn_sub_n (l_bsm2, l_gp, l_bs2, l_n + 1).do_nothing
				l_flags := ((l_flags.to_natural_32).bit_xor ({NATURAL_32} 1)).to_integer_32
			else
				gmp_inst.gmpn_sub_n (l_bsm2, l_bs2, l_gp, l_n + 1).do_nothing
			end
			gmp_inst.gmpn_add_n (l_bs2, l_bs2, l_gp, l_n + 1).do_nothing
			l_cy := gmp_inst.gmpn_lshift (l_bsh, a_bp, l_n, {NATURAL_32} 1)
			l_cy := l_cy + (gmp_inst.gmpn_add_n (l_bsh, l_bsh, a_bp + l_n, l_n))
			l_cy := {NATURAL_32} 2 * l_cy + (gmp_inst.gmpn_lshift (l_bsh, l_bsh, l_n, {NATURAL_32} 1))
			l_bsh[l_n] := l_cy + (gmp_inst.gmpn_add (l_bsh, l_bsh, l_n, a_bp + 2 * l_n, l_t))
			mul_n_inst.gmpn_mul_n (a_scratch, l_as2, l_bs2, l_n + 1)
			mul_n_inst.gmpn_mul_n ((a_scratch + 2 * l_n) + 1, l_asm2, l_bsm2, l_n + 1)
			mul_n_inst.gmpn_mul_n ((a_scratch + 4 * l_n) + 2, l_ash, l_bsh, l_n + 1);
			((a_scratch + 6 * l_n) + 3)[2 * l_n] := (0).to_natural_32
			mul_n_inst.gmpn_mul_n ((a_scratch + 6 * l_n) + 3, l_asm1, l_bsm1, l_n + (((l_asm1[l_n]).bit_or (l_bsm1[l_n])) /= {NATURAL_32} 0).to_integer);
			(a_pp + 2 * l_n)[2 * l_n] := (0).to_natural_32
			mul_n_inst.gmpn_mul_n (a_pp + 2 * l_n, l_as1, l_bs1, l_n + (((l_as1[l_n]).bit_or (l_bs1[l_n])) /= {NATURAL_32} 0).to_integer)
			mul_n_inst.gmpn_mul_n (a_pp, a_ap, a_bp, l_n)
			if l_s > l_t then
				mul_inst.gmpn_mul (a_pp + 6 * l_n, a_ap + 4 * l_n, l_s, a_bp + 2 * l_n, l_t).do_nothing
			else
				mul_inst.gmpn_mul (a_pp + 6 * l_n, a_bp + 2 * l_n, l_t, a_ap + 4 * l_n, l_s).do_nothing
			end
			toom_interpolate_7pts_inst.gmpn_toom_interpolate_7pts (a_pp, l_n, l_flags, (a_scratch + 2 * l_n) + 1, (a_scratch + 6 * l_n) + 3, a_scratch, (a_scratch + 4 * l_n) + 2, l_s + l_t, (a_scratch + 8 * l_n) + 4)
			from
			until
				js.loop_left
			loop
				js.reset
				if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
					tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
				end
				js.break
			end
			js.reset
		end

end
