class
	P_URANDOMM

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_urandomm (a_rop: CE_POINTER [PD_MPZ_STRUCT]; a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_n: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_nlast: CE_POINTER [NATURAL_32]
			l_nbits: INTEGER_32
			l_size: INTEGER_32
			l_count: INTEGER_32
			l_pow2: INTEGER_32
			l_cmp: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tp: CE_POINTER [NATURAL_32]
			l_tmp___2: CE_POINTER [ANY]
			l_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l_gmp_i: INTEGER_32
			l_gmp_x: NATURAL_32
			l_gmp_y: NATURAL_32
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_rp.make
			create l_np.make
			create l_nlast.make
			create l_tmp_marker.make
			create l_tp.make
			create l_tmp___2.make
			create l_rstate.make

			if a_n.item.mp_size >= 0 then
				l_size := (a_n.item.mp_size).to_integer_32
			else
				l_size := (-a_n.item.mp_size).to_integer_32
			end
			if l_size = 0 then
				errno_inst.gmp_divide_by_zero
			end
			l_nlast.ce_gets (a_n.item.mp_d + (l_size - 1))
			l_pow2 := (((l_nlast.item).bit_and ((l_nlast.item - {NATURAL_32} 1))) = {NATURAL_32} 0).to_integer
			if l_pow2 /= 0 then
				l_np.ce_gets (a_n.item.mp_d)
				from
				until
					not (not js.loop_left and then ((l_np.c_pointer.to_integer_32).to_natural_32 < (l_nlast.c_pointer.to_integer_32).to_natural_32))
				loop
					js.reset
					if l_np.item /= {NATURAL_32} 0 then
						l_pow2 := 0
						js.break
					end
					if not js.loop_jumped then
						l_np.ce_gets (l_np + 1)
					end
				end
				js.reset
			end
			from
			until
				js.loop_left
			loop
				js.reset
				l_count := builtin_clzl (l_nlast.item)
				js.break
			end
			js.reset
			l_nbits := (l_size * 32 - l_count.to_integer_32) - l_pow2.to_integer_32
			if l_nbits = 0 then
				a_rop.item.mp_size := 0
				js.return
			end
			if not js.return_called then
				l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
				l_np.ce_gets (a_n.item.mp_d)
				if (a_rop.c_pointer.to_integer_32).to_natural_32 = (a_n.c_pointer.to_integer_32).to_natural_32 then
					if (builtin_expect ((l_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___2.ce_gets ((l_aaf.new ((l_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___2.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2))
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (l_tp, l_np, l_size)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
					l_np.ce_gets (l_tp)
				end
				if (builtin_expect ((l_size > (a_rop.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					l_rp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((realloc_inst.gmpz_realloc (a_rop, l_size))))
				else
					l_rp.ce_gets (a_rop.item.mp_d)
				end
				l_rp[(l_size - 1)] := (0).to_natural_32
				l_count := 80
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						l_rstate.ce_gets (a_rstate);
						((create {CE_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l_rstate.item.mp_algdata.mp_lc)).item.randget_fn).call ([l_rstate, l_rp, l_nbits.to_natural_32])
						js.break
					end
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						l_cmp := 0
						l_gmp_i := l_size
						from
						until
							js.loop_left
						loop
							js.reset
							l_gmp_i := l_gmp_i - 1
							if not (l_gmp_i >= 0) then
								js.break
							end
							if not js.loop_jumped then
								l_gmp_x := l_rp[l_gmp_i]
								l_gmp_y := l_np[l_gmp_i]
								if l_gmp_x /= l_gmp_y then
									if l_gmp_x > l_gmp_y then
										l_cmp := 1
									else
										l_cmp := -1
									end
									js.break
								end
							end
						end
						js.reset
						js.break
					end
					js.reset
					if l_cmp >= 0 then
						l_count := l_count - 1
						if l_count = 0 then
							js.break
						end
					else
						js.break
					end
				end
				js.reset
				if l_count = 0 then
					gmp_inst.gmpn_sub_n (l_rp, l_rp, l_np, l_size).do_nothing
				end
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						not (not js.loop_left and then (l_size > 0))
					loop
						js.reset
						if l_rp[(l_size - 1)] /= {NATURAL_32} 0 then
							js.break
						end
						if not js.loop_jumped then
							l_size := l_size - 1
						end
					end
					js.reset
					js.break
				end
				js.reset
				a_rop.item.mp_size := l_size.to_integer_32
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
					end
					js.break
				end
				js.reset
			end
		end

end
