class
	P_VASPRINTF

inherit
	LIBGMP_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {NONE} -- Initialization

	default_create
		do
			create gmp_asprintf_funs.make
		end

feature {ANY} -- attributes

	gmp_asprintf_funs: PD_DOPRNT_FUNS_T

feature {ANY} -- routines

	gmp_asprintf_format (a_d: CE_POINTER [PD_GMP_ASPRINTF_T]; a_fmt: CE_POINTER [INTEGER_8]; a_orig_ap: CE_VA_LIST): INTEGER_32
		local
			l_orig_ap: CE_VA_LIST
			l_ret: INTEGER_32
			l_ap: CE_VA_LIST
			l_space: NATURAL_32
			l_alloc: NATURAL_32
			l_newsize: NATURAL_32
			l_newalloc: NATURAL_32
			js: JUMP_STATE
		do
			create l_orig_ap.make_copy (a_orig_ap)
			l_space := (256).to_natural_32
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					l_alloc := a_d.item.alloc
					l_newsize := a_d.item.size + l_space
					if l_alloc <= l_newsize then
						l_newalloc := {NATURAL_32} 2 * l_newsize
						a_d.item.alloc := l_newalloc
						a_d.item.buf := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_reallocate_func.pointer_item ([create {CE_POINTER [ANY]}.make_cast (a_d.item.buf), l_alloc * Integer_8_bytes.to_natural_32, l_newalloc * Integer_8_bytes.to_natural_32]))))
					end
					js.break
				end
				js.reset
				l_space := a_d.item.alloc - a_d.item.size
				create l_ap.make_copy (l_orig_ap)
				l_ret := vsnprintf ((a_d.item.buf + (a_d.item.size).to_integer_32), l_space, a_fmt, l_ap)
				if l_ret = -1 then
					l_ret := (l_space - {NATURAL_32} 1).to_integer_32
				end
				if l_ret.to_natural_32 < l_space - {NATURAL_32} 1 then
					js.break
				end
				if not js.loop_jumped then
					if l_ret.to_natural_32 = l_space - {NATURAL_32} 1 then
						l_space := l_space * ({NATURAL_32} 2)
					else
						l_space := (l_ret + 2).to_natural_32
					end
				end
			end
			js.reset
			a_d.item.size := a_d.item.size + l_ret.to_natural_32
			Result := l_ret
		end

	gmp_asprintf_format_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gmp_asprintf_format)
		end

	gmp_vasprintf (a_result: CE_POINTER [CE_POINTER [INTEGER_8]]; a_fmt: CE_POINTER [INTEGER_8]; a_ap: CE_VA_LIST): INTEGER_32
		local
			l_ap: CE_VA_LIST
			l_d: PD_GMP_ASPRINTF_T
			js: JUMP_STATE
		do
			create l_d.make

			create l_ap.make_copy (a_ap)
			from
			until
				js.loop_left
			loop
				js.reset
				l_d.result2 := a_result
				l_d.alloc := (256).to_natural_32
				l_d.buf := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([l_d.alloc]))))
				l_d.size := (0).to_natural_32
				js.break
			end
			js.reset
			Result := (doprnt_inst.gmp_doprnt (gmp_asprintf_funs.address, create {CE_POINTER [ANY]}.make_cast ((l_d.address)), a_fmt, l_ap))
		end

end
