class
	SD_OBSTACK

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	chunk_size: INTEGER_32 assign set_chunk_size
		do
			Result := c_chunk_size (c_pointer)
		end

	chunk: CE_POINTER [SD_OBSTACK_CHUNK] assign set_chunk
		do
			create Result.make_shared (c_chunk (c_pointer))
		end

	object_base: CE_POINTER [INTEGER_8] assign set_object_base
		do
			create Result.make_shared (c_object_base (c_pointer))
		end

	next_free: CE_POINTER [INTEGER_8] assign set_next_free
		do
			create Result.make_shared (c_next_free (c_pointer))
		end

	chunk_limit: CE_POINTER [INTEGER_8] assign set_chunk_limit
		do
			create Result.make_shared (c_chunk_limit (c_pointer))
		end

	temp: SD_TEMP assign set_temp
		do
			create Result.make_shared (c_temp (c_pointer))
		end

	alignment_mask: INTEGER_32 assign set_alignment_mask
		do
			Result := c_alignment_mask (c_pointer)
		end

	chunkfun: CE_ROUTINE assign set_chunkfun
		do
			create Result.make_shared (c_chunkfun (c_pointer))
		end

	freefun: CE_ROUTINE assign set_freefun
		do
			create Result.make_shared (c_freefun (c_pointer))
		end

	extra_arg: CE_POINTER [ANY] assign set_extra_arg
		do
			create Result.make_shared (c_extra_arg (c_pointer))
		end

	use_extra_arg: NATURAL_32 assign set_use_extra_arg
		do
			Result := c_use_extra_arg (c_pointer)
		end

	maybe_empty_object: NATURAL_32 assign set_maybe_empty_object
		do
			Result := c_maybe_empty_object (c_pointer)
		end

	alloc_failed: NATURAL_32 assign set_alloc_failed
		do
			Result := c_alloc_failed (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_chunk_size (a_chunk_size: INTEGER_32)
		do
			c_set_chunk_size (c_pointer, a_chunk_size)
		end

	set_chunk (a_chunk: CE_POINTER [SD_OBSTACK_CHUNK])
		do
			c_set_chunk (c_pointer, a_chunk.c_pointer)
		end

	set_object_base (a_object_base: CE_POINTER [INTEGER_8])
		do
			c_set_object_base (c_pointer, a_object_base.c_pointer)
		end

	set_next_free (a_next_free: CE_POINTER [INTEGER_8])
		do
			c_set_next_free (c_pointer, a_next_free.c_pointer)
		end

	set_chunk_limit (a_chunk_limit: CE_POINTER [INTEGER_8])
		do
			c_set_chunk_limit (c_pointer, a_chunk_limit.c_pointer)
		end

	set_temp (a_temp: SD_TEMP)
		do
			temp.ce_gets (a_temp)
		end

	set_alignment_mask (a_alignment_mask: INTEGER_32)
		do
			c_set_alignment_mask (c_pointer, a_alignment_mask)
		end

	set_chunkfun (a_chunkfun: CE_ROUTINE)
		do
			c_set_chunkfun (c_pointer, a_chunkfun.c_pointer)
		end

	set_freefun (a_freefun: CE_ROUTINE)
		do
			c_set_freefun (c_pointer, a_freefun.c_pointer)
		end

	set_extra_arg (a_extra_arg: CE_POINTER [ANY])
		do
			c_set_extra_arg (c_pointer, a_extra_arg.c_pointer)
		end

	set_use_extra_arg (a_use_extra_arg: NATURAL_32)
		do
			c_set_use_extra_arg (c_pointer, a_use_extra_arg)
		end

	set_maybe_empty_object (a_maybe_empty_object: NATURAL_32)
		do
			c_set_maybe_empty_object (c_pointer, a_maybe_empty_object)
		end

	set_alloc_failed (a_alloc_failed: NATURAL_32)
		do
			c_set_alloc_failed (c_pointer, a_alloc_failed)
		end

feature {NONE} -- C getters

	c_chunk_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct obstack *)$tmp)->chunk_size;"
		end

	c_chunk (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _obstack_chunk *)((struct obstack *)$tmp)->chunk;"
		end

	c_object_base (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct obstack *)$tmp)->object_base;"
		end

	c_next_free (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct obstack *)$tmp)->next_free;"
		end

	c_chunk_limit (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct obstack *)$tmp)->chunk_limit;"
		end

	c_temp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_temp_1 *)&((struct obstack *)$tmp)->temp;"
		end

	c_alignment_mask (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct obstack *)$tmp)->alignment_mask;"
		end

	c_chunkfun (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _obstack_chunk *( *)(void *, long))((struct obstack *)$tmp)->chunkfun;"
		end

	c_freefun (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void *, struct _obstack_chunk *))((struct obstack *)$tmp)->freefun;"
		end

	c_extra_arg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct obstack *)$tmp)->extra_arg;"
		end

	c_use_extra_arg (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct obstack *)$tmp)->use_extra_arg;"
		end

	c_maybe_empty_object (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct obstack *)$tmp)->maybe_empty_object;"
		end

	c_alloc_failed (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct obstack *)$tmp)->alloc_failed;"
		end

feature {NONE} -- C setters

	c_set_chunk_size (tmp: POINTER; a_chunk_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct obstack *)$tmp)->chunk_size = $a_chunk_size;"
		end

	c_set_chunk (tmp: POINTER; a_chunk: POINTER)
		external
			"C inline"
		alias
			"((struct obstack *)$tmp)->chunk = (struct _obstack_chunk *)$a_chunk;"
		end

	c_set_object_base (tmp: POINTER; a_object_base: POINTER)
		external
			"C inline"
		alias
			"((struct obstack *)$tmp)->object_base = (char *)$a_object_base;"
		end

	c_set_next_free (tmp: POINTER; a_next_free: POINTER)
		external
			"C inline"
		alias
			"((struct obstack *)$tmp)->next_free = (char *)$a_next_free;"
		end

	c_set_chunk_limit (tmp: POINTER; a_chunk_limit: POINTER)
		external
			"C inline"
		alias
			"((struct obstack *)$tmp)->chunk_limit = (char *)$a_chunk_limit;"
		end

	c_set_alignment_mask (tmp: POINTER; a_alignment_mask: INTEGER_32)
		external
			"C inline"
		alias
			"((struct obstack *)$tmp)->alignment_mask = $a_alignment_mask;"
		end

	c_set_chunkfun (tmp: POINTER; a_chunkfun: POINTER)
		external
			"C inline"
		alias
			"((struct obstack *)$tmp)->chunkfun = (struct _obstack_chunk *( *)(void *, long))$a_chunkfun;"
		end

	c_set_freefun (tmp: POINTER; a_freefun: POINTER)
		external
			"C inline"
		alias
			"((struct obstack *)$tmp)->freefun = (void( *)(void *, struct _obstack_chunk *))$a_freefun;"
		end

	c_set_extra_arg (tmp: POINTER; a_extra_arg: POINTER)
		external
			"C inline"
		alias
			"((struct obstack *)$tmp)->extra_arg = (void *)$a_extra_arg;"
		end

	c_set_use_extra_arg (tmp: POINTER; a_use_extra_arg: NATURAL_32)
		external
			"C inline"
		alias
			"((struct obstack *)$tmp)->use_extra_arg = $a_use_extra_arg;"
		end

	c_set_maybe_empty_object (tmp: POINTER; a_maybe_empty_object: NATURAL_32)
		external
			"C inline"
		alias
			"((struct obstack *)$tmp)->maybe_empty_object = $a_maybe_empty_object;"
		end

	c_set_alloc_failed (tmp: POINTER; a_alloc_failed: NATURAL_32)
		external
			"C inline"
		alias
			"((struct obstack *)$tmp)->alloc_failed = $a_alloc_failed;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct obstack);"
		end

end
