class
	SD_OBSTACK_CHUNK

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	limit: CE_POINTER [INTEGER_8] assign set_limit
		do
			create Result.make_shared (c_limit (c_pointer))
		end

	prev: CE_POINTER [SD_OBSTACK_CHUNK] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	contents: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_contents (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_limit (a_limit: CE_POINTER [INTEGER_8])
		do
			c_set_limit (c_pointer, a_limit.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [SD_OBSTACK_CHUNK])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

feature {NONE} -- C getters

	c_limit (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _obstack_chunk *)$tmp)->limit;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _obstack_chunk *)((struct _obstack_chunk *)$tmp)->prev;"
		end

	c_contents (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _obstack_chunk *tmp = (struct _obstack_chunk *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->contents) / sizeof(tmp->contents[0]);
				return tmp->contents;
			]"
		end

feature {NONE} -- C setters

	c_set_limit (tmp: POINTER; a_limit: POINTER)
		external
			"C inline"
		alias
			"((struct _obstack_chunk *)$tmp)->limit = (char *)$a_limit;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct _obstack_chunk *)$tmp)->prev = (struct _obstack_chunk *)$a_prev;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct _obstack_chunk);"
		end

end
