deferred class
	S_STDIO

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	fprintf (a_args: TUPLE [a_stream: CE_POINTER [SD_IO_FILE]; a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_fprintf)).integer_32_item (a_args)
		end

	c_fprintf: POINTER
		external
			"C inline use <libgmp.h>"
		alias
			"return &fprintf;"
		end

	printf (a_args: TUPLE [a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_printf)).integer_32_item (a_args)
		end

	c_printf: POINTER
		external
			"C inline use <libgmp.h>"
		alias
			"return &printf;"
		end

	ungetc (a_c: INTEGER_32; a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_ungetc (a_c, a_stream.c_pointer)
		end

	c_ungetc (a_c: INTEGER_32; a_stream: POINTER): INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return ungetc($a_c, $a_stream);"
		end

	ungetc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ungetc)
		end

	fputc (a_c: INTEGER_32; a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fputc (a_c, a_stream.c_pointer)
		end

	c_fputc (a_c: INTEGER_32; a_stream: POINTER): INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return fputc($a_c, $a_stream);"
		end

	fwrite (a_ptr: CE_POINTER [ANY]; a_size: NATURAL_32; a_n: NATURAL_32; a_s: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fwrite (a_ptr.c_pointer, a_size, a_n, a_s.c_pointer)
		end

	c_fwrite (a_ptr: POINTER; a_size: NATURAL_32; a_n: NATURAL_32; a_s: POINTER): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return fwrite($a_ptr, $a_size, $a_n, $a_s);"
		end

	ferror (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_ferror (a_stream.c_pointer)
		end

	c_ferror (a_stream: POINTER): INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return ferror($a_stream);"
		end

	fread (a_ptr: CE_POINTER [ANY]; a_size: NATURAL_32; a_n: NATURAL_32; a_stream: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fread (a_ptr.c_pointer, a_size, a_n, a_stream.c_pointer)
		end

	c_fread (a_ptr: POINTER; a_size: NATURAL_32; a_n: NATURAL_32; a_stream: POINTER): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return fread($a_ptr, $a_size, $a_n, $a_stream);"
		end

	snprintf (a_args: TUPLE [a_s: CE_POINTER [INTEGER_8]; a_maxlen: NATURAL_32; a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_snprintf)).integer_32_item (a_args)
		end

	c_snprintf: POINTER
		external
			"C inline use <libgmp.h>"
		alias
			"return &snprintf;"
		end

	obstack_vprintf (a_obstack: CE_POINTER [SD_OBSTACK]; a_format: CE_POINTER [INTEGER_8]; a_args: CE_VA_LIST): INTEGER_32
		do
			Result := c_obstack_vprintf (a_obstack.c_pointer, a_format.c_pointer, a_args.c_pointer)
		end

	c_obstack_vprintf (a_obstack: POINTER; a_format: POINTER; a_args: POINTER): INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return obstack_vprintf($a_obstack, $a_format, $a_args);"
		end

	obstack_vprintf_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent obstack_vprintf)
		end

	vfprintf (a_s: CE_POINTER [SD_IO_FILE]; a_format: CE_POINTER [INTEGER_8]; a_arg: CE_VA_LIST): INTEGER_32
		do
			Result := c_vfprintf (a_s.c_pointer, a_format.c_pointer, a_arg.c_pointer)
		end

	c_vfprintf (a_s: POINTER; a_format: POINTER; a_arg: POINTER): INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return vfprintf($a_s, $a_format, $a_arg);"
		end

	vfprintf_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent vfprintf)
		end

	vsnprintf (a_s: CE_POINTER [INTEGER_8]; a_maxlen: NATURAL_32; a_format: CE_POINTER [INTEGER_8]; a_arg: CE_VA_LIST): INTEGER_32
		do
			Result := c_vsnprintf (a_s.c_pointer, a_maxlen, a_format.c_pointer, a_arg.c_pointer)
		end

	c_vsnprintf (a_s: POINTER; a_maxlen: NATURAL_32; a_format: POINTER; a_arg: POINTER): INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return vsnprintf($a_s, $a_maxlen, $a_format, $a_arg);"
		end

	vsprintf (a_s: CE_POINTER [INTEGER_8]; a_format: CE_POINTER [INTEGER_8]; a_arg: CE_VA_LIST): INTEGER_32
		do
			Result := c_vsprintf (a_s.c_pointer, a_format.c_pointer, a_arg.c_pointer)
		end

	c_vsprintf (a_s: POINTER; a_format: POINTER; a_arg: POINTER): INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return vsprintf($a_s, $a_format, $a_arg);"
		end

	fscanf (a_args: TUPLE [a_stream: CE_POINTER [SD_IO_FILE]; a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_fscanf)).integer_32_item (a_args)
		end

	c_fscanf: POINTER
		external
			"C inline use <libgmp.h>"
		alias
			"return &fscanf;"
		end

	fscanf_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_shared (c_fscanf)
		end

	fgetc (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fgetc (a_stream.c_pointer)
		end

	c_fgetc (a_stream: POINTER): INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return fgetc($a_stream);"
		end

	fgetc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent fgetc)
		end

	sscanf (a_args: TUPLE [a_s: CE_POINTER [INTEGER_8]; a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_sscanf)).integer_32_item (a_args)
		end

	c_sscanf: POINTER
		external
			"C inline use <libgmp.h>"
		alias
			"return &sscanf;"
		end

end
