deferred class
	S_STDLIB

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	abort
		external
			"C inline use <libgmp.h>"
		alias
			"abort();"
		end

	malloc (a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared_with_count (
					default_pointer.memory_alloc (a_size.to_integer_32),
					a_size.to_integer_32
				)
		end

	realloc (a_ptr: CE_POINTER [ANY]; a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared_with_count (
					a_ptr.c_pointer.memory_realloc (a_size.to_integer_32),
					a_size.to_integer_32
				)
		end

	free (a_ptr: CE_POINTER [ANY])
		do
			c_free (a_ptr.c_pointer)
		end

	c_free (a_ptr: POINTER)
		external
			"C inline use <libgmp.h>"
		alias
			"free($a_ptr);"
		end

	strtol (a_nptr: CE_POINTER [INTEGER_8]; a_endptr: CE_POINTER [CE_POINTER [INTEGER_8]]; a_base: INTEGER_32): INTEGER_32
		do
			Result := c_strtol (a_nptr.c_pointer, a_endptr.c_pointer, a_base)
		end

	c_strtol (a_nptr: POINTER; a_endptr: POINTER; a_base: INTEGER_32): INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return strtol($a_nptr, $a_endptr, $a_base);"
		end

end
