class
	PD_BROYDEN_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	H: CE_POINTER [PD_GSL_MATRIX] assign set_H
		do
			create Result.make_shared (c_H (c_pointer))
		end

	lu: CE_POINTER [PD_GSL_MATRIX] assign set_lu
		do
			create Result.make_shared (c_lu (c_pointer))
		end

	permutation: CE_POINTER [PD_GSL_PERMUTATION_STRUCT] assign set_permutation
		do
			create Result.make_shared (c_permutation (c_pointer))
		end

	v: CE_POINTER [PD_GSL_VECTOR] assign set_v
		do
			create Result.make_shared (c_v (c_pointer))
		end

	w: CE_POINTER [PD_GSL_VECTOR] assign set_w
		do
			create Result.make_shared (c_w (c_pointer))
		end

	y: CE_POINTER [PD_GSL_VECTOR] assign set_y
		do
			create Result.make_shared (c_y (c_pointer))
		end

	p: CE_POINTER [PD_GSL_VECTOR] assign set_p
		do
			create Result.make_shared (c_p (c_pointer))
		end

	fnew: CE_POINTER [PD_GSL_VECTOR] assign set_fnew
		do
			create Result.make_shared (c_fnew (c_pointer))
		end

	x_trial: CE_POINTER [PD_GSL_VECTOR] assign set_x_trial
		do
			create Result.make_shared (c_x_trial (c_pointer))
		end

	phi: REAL_64 assign set_phi
		do
			Result := c_phi (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_H (a_H: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_H (c_pointer, a_H.c_pointer)
		end

	set_lu (a_lu: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_lu (c_pointer, a_lu.c_pointer)
		end

	set_permutation (a_permutation: CE_POINTER [PD_GSL_PERMUTATION_STRUCT])
		do
			c_set_permutation (c_pointer, a_permutation.c_pointer)
		end

	set_v (a_v: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_v (c_pointer, a_v.c_pointer)
		end

	set_w (a_w: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_w (c_pointer, a_w.c_pointer)
		end

	set_y (a_y: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_y (c_pointer, a_y.c_pointer)
		end

	set_p (a_p: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_p (c_pointer, a_p.c_pointer)
		end

	set_fnew (a_fnew: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_fnew (c_pointer, a_fnew.c_pointer)
		end

	set_x_trial (a_x_trial: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_x_trial (c_pointer, a_x_trial.c_pointer)
		end

	set_phi (a_phi: REAL_64)
		do
			c_set_phi (c_pointer, a_phi)
		end

feature {NONE} -- C getters

	c_H (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_broyden_state_t_118 *)$tmp)->H;"
		end

	c_lu (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_broyden_state_t_118 *)$tmp)->lu;"
		end

	c_permutation (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct gsl_permutation_struct *)((struct __anonstruct_broyden_state_t_118 *)$tmp)->permutation;"
		end

	c_v (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_broyden_state_t_118 *)$tmp)->v;"
		end

	c_w (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_broyden_state_t_118 *)$tmp)->w;"
		end

	c_y (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_broyden_state_t_118 *)$tmp)->y;"
		end

	c_p (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_broyden_state_t_118 *)$tmp)->p;"
		end

	c_fnew (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_broyden_state_t_118 *)$tmp)->fnew;"
		end

	c_x_trial (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_broyden_state_t_118 *)$tmp)->x_trial;"
		end

	c_phi (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_broyden_state_t_118 *)$tmp)->phi;"
		end

feature {NONE} -- C setters

	c_set_H (tmp: POINTER; a_H: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_broyden_state_t_118 *)$tmp)->H = (gsl_matrix *)$a_h;"
		end

	c_set_lu (tmp: POINTER; a_lu: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_broyden_state_t_118 *)$tmp)->lu = (gsl_matrix *)$a_lu;"
		end

	c_set_permutation (tmp: POINTER; a_permutation: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_broyden_state_t_118 *)$tmp)->permutation = (struct gsl_permutation_struct *)$a_permutation;"
		end

	c_set_v (tmp: POINTER; a_v: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_broyden_state_t_118 *)$tmp)->v = (gsl_vector *)$a_v;"
		end

	c_set_w (tmp: POINTER; a_w: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_broyden_state_t_118 *)$tmp)->w = (gsl_vector *)$a_w;"
		end

	c_set_y (tmp: POINTER; a_y: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_broyden_state_t_118 *)$tmp)->y = (gsl_vector *)$a_y;"
		end

	c_set_p (tmp: POINTER; a_p: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_broyden_state_t_118 *)$tmp)->p = (gsl_vector *)$a_p;"
		end

	c_set_fnew (tmp: POINTER; a_fnew: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_broyden_state_t_118 *)$tmp)->fnew = (gsl_vector *)$a_fnew;"
		end

	c_set_x_trial (tmp: POINTER; a_x_trial: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_broyden_state_t_118 *)$tmp)->x_trial = (gsl_vector *)$a_x_trial;"
		end

	c_set_phi (tmp: POINTER; a_phi: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_broyden_state_t_118 *)$tmp)->phi = $a_phi;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_broyden_state_t_118);"
		end

end
