class
	PD_BSIMP_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	d: CE_POINTER [PD_GSL_MATRIX] assign set_d
		do
			create Result.make_shared (c_d (c_pointer))
		end

	a_mat: CE_POINTER [PD_GSL_MATRIX] assign set_a_mat
		do
			create Result.make_shared (c_a_mat (c_pointer))
		end

	p_vec: CE_POINTER [PD_GSL_PERMUTATION_STRUCT] assign set_p_vec
		do
			create Result.make_shared (c_p_vec (c_pointer))
		end

	x: CE_ARRAY [REAL_64]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_x (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	k_current: NATURAL_32 assign set_k_current
		do
			Result := c_k_current (c_pointer)
		end

	k_choice: NATURAL_32 assign set_k_choice
		do
			Result := c_k_choice (c_pointer)
		end

	h_next: REAL_64 assign set_h_next
		do
			Result := c_h_next (c_pointer)
		end

	eps: REAL_64 assign set_eps
		do
			Result := c_eps (c_pointer)
		end

	yp: CE_POINTER [REAL_64] assign set_yp
		do
			create Result.make_shared (c_yp (c_pointer))
		end

	y_save: CE_POINTER [REAL_64] assign set_y_save
		do
			create Result.make_shared (c_y_save (c_pointer))
		end

	yerr_save: CE_POINTER [REAL_64] assign set_yerr_save
		do
			create Result.make_shared (c_yerr_save (c_pointer))
		end

	y_extrap_save: CE_POINTER [REAL_64] assign set_y_extrap_save
		do
			create Result.make_shared (c_y_extrap_save (c_pointer))
		end

	y_extrap_sequence: CE_POINTER [REAL_64] assign set_y_extrap_sequence
		do
			create Result.make_shared (c_y_extrap_sequence (c_pointer))
		end

	extrap_work: CE_POINTER [REAL_64] assign set_extrap_work
		do
			create Result.make_shared (c_extrap_work (c_pointer))
		end

	dfdt: CE_POINTER [REAL_64] assign set_dfdt
		do
			create Result.make_shared (c_dfdt (c_pointer))
		end

	y_temp: CE_POINTER [REAL_64] assign set_y_temp
		do
			create Result.make_shared (c_y_temp (c_pointer))
		end

	delta_temp: CE_POINTER [REAL_64] assign set_delta_temp
		do
			create Result.make_shared (c_delta_temp (c_pointer))
		end

	weight: CE_POINTER [REAL_64] assign set_weight
		do
			create Result.make_shared (c_weight (c_pointer))
		end

	dfdy: CE_POINTER [PD_GSL_MATRIX] assign set_dfdy
		do
			create Result.make_shared (c_dfdy (c_pointer))
		end

	rhs_temp: CE_POINTER [REAL_64] assign set_rhs_temp
		do
			create Result.make_shared (c_rhs_temp (c_pointer))
		end

	delta: CE_POINTER [REAL_64] assign set_delta
		do
			create Result.make_shared (c_delta (c_pointer))
		end

	order: NATURAL_32 assign set_order
		do
			Result := c_order (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_d (a_d: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_d (c_pointer, a_d.c_pointer)
		end

	set_a_mat (a_a_mat: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_a_mat (c_pointer, a_a_mat.c_pointer)
		end

	set_p_vec (a_p_vec: CE_POINTER [PD_GSL_PERMUTATION_STRUCT])
		do
			c_set_p_vec (c_pointer, a_p_vec.c_pointer)
		end

	set_k_current (a_k_current: NATURAL_32)
		do
			c_set_k_current (c_pointer, a_k_current)
		end

	set_k_choice (a_k_choice: NATURAL_32)
		do
			c_set_k_choice (c_pointer, a_k_choice)
		end

	set_h_next (a_h_next: REAL_64)
		do
			c_set_h_next (c_pointer, a_h_next)
		end

	set_eps (a_eps: REAL_64)
		do
			c_set_eps (c_pointer, a_eps)
		end

	set_yp (a_yp: CE_POINTER [REAL_64])
		do
			c_set_yp (c_pointer, a_yp.c_pointer)
		end

	set_y_save (a_y_save: CE_POINTER [REAL_64])
		do
			c_set_y_save (c_pointer, a_y_save.c_pointer)
		end

	set_yerr_save (a_yerr_save: CE_POINTER [REAL_64])
		do
			c_set_yerr_save (c_pointer, a_yerr_save.c_pointer)
		end

	set_y_extrap_save (a_y_extrap_save: CE_POINTER [REAL_64])
		do
			c_set_y_extrap_save (c_pointer, a_y_extrap_save.c_pointer)
		end

	set_y_extrap_sequence (a_y_extrap_sequence: CE_POINTER [REAL_64])
		do
			c_set_y_extrap_sequence (c_pointer, a_y_extrap_sequence.c_pointer)
		end

	set_extrap_work (a_extrap_work: CE_POINTER [REAL_64])
		do
			c_set_extrap_work (c_pointer, a_extrap_work.c_pointer)
		end

	set_dfdt (a_dfdt: CE_POINTER [REAL_64])
		do
			c_set_dfdt (c_pointer, a_dfdt.c_pointer)
		end

	set_y_temp (a_y_temp: CE_POINTER [REAL_64])
		do
			c_set_y_temp (c_pointer, a_y_temp.c_pointer)
		end

	set_delta_temp (a_delta_temp: CE_POINTER [REAL_64])
		do
			c_set_delta_temp (c_pointer, a_delta_temp.c_pointer)
		end

	set_weight (a_weight: CE_POINTER [REAL_64])
		do
			c_set_weight (c_pointer, a_weight.c_pointer)
		end

	set_dfdy (a_dfdy: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_dfdy (c_pointer, a_dfdy.c_pointer)
		end

	set_rhs_temp (a_rhs_temp: CE_POINTER [REAL_64])
		do
			c_set_rhs_temp (c_pointer, a_rhs_temp.c_pointer)
		end

	set_delta (a_delta: CE_POINTER [REAL_64])
		do
			c_set_delta (c_pointer, a_delta.c_pointer)
		end

	set_order (a_order: NATURAL_32)
		do
			c_set_order (c_pointer, a_order)
		end

feature {NONE} -- C getters

	c_d (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_bsimp_state_t_120 *)$tmp)->d;"
		end

	c_a_mat (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_bsimp_state_t_120 *)$tmp)->a_mat;"
		end

	c_p_vec (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct gsl_permutation_struct *)((struct __anonstruct_bsimp_state_t_120 *)$tmp)->p_vec;"
		end

	c_x (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_bsimp_state_t_120 *tmp = (struct __anonstruct_bsimp_state_t_120 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->x) / sizeof(tmp->x[0]);
				return tmp->x;
			]"
		end

	c_k_current (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_bsimp_state_t_120 *)$tmp)->k_current;"
		end

	c_k_choice (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_bsimp_state_t_120 *)$tmp)->k_choice;"
		end

	c_h_next (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_bsimp_state_t_120 *)$tmp)->h_next;"
		end

	c_eps (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_bsimp_state_t_120 *)$tmp)->eps;"
		end

	c_yp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_bsimp_state_t_120 *)$tmp)->yp;"
		end

	c_y_save (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_bsimp_state_t_120 *)$tmp)->y_save;"
		end

	c_yerr_save (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_bsimp_state_t_120 *)$tmp)->yerr_save;"
		end

	c_y_extrap_save (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_bsimp_state_t_120 *)$tmp)->y_extrap_save;"
		end

	c_y_extrap_sequence (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_bsimp_state_t_120 *)$tmp)->y_extrap_sequence;"
		end

	c_extrap_work (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_bsimp_state_t_120 *)$tmp)->extrap_work;"
		end

	c_dfdt (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_bsimp_state_t_120 *)$tmp)->dfdt;"
		end

	c_y_temp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_bsimp_state_t_120 *)$tmp)->y_temp;"
		end

	c_delta_temp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_bsimp_state_t_120 *)$tmp)->delta_temp;"
		end

	c_weight (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_bsimp_state_t_120 *)$tmp)->weight;"
		end

	c_dfdy (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_bsimp_state_t_120 *)$tmp)->dfdy;"
		end

	c_rhs_temp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_bsimp_state_t_120 *)$tmp)->rhs_temp;"
		end

	c_delta (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_bsimp_state_t_120 *)$tmp)->delta;"
		end

	c_order (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_bsimp_state_t_120 *)$tmp)->order;"
		end

feature {NONE} -- C setters

	c_set_d (tmp: POINTER; a_d: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_bsimp_state_t_120 *)$tmp)->d = (gsl_matrix *)$a_d;"
		end

	c_set_a_mat (tmp: POINTER; a_a_mat: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_bsimp_state_t_120 *)$tmp)->a_mat = (gsl_matrix *)$a_a_mat;"
		end

	c_set_p_vec (tmp: POINTER; a_p_vec: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_bsimp_state_t_120 *)$tmp)->p_vec = (struct gsl_permutation_struct *)$a_p_vec;"
		end

	c_set_k_current (tmp: POINTER; a_k_current: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_bsimp_state_t_120 *)$tmp)->k_current = $a_k_current;"
		end

	c_set_k_choice (tmp: POINTER; a_k_choice: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_bsimp_state_t_120 *)$tmp)->k_choice = $a_k_choice;"
		end

	c_set_h_next (tmp: POINTER; a_h_next: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_bsimp_state_t_120 *)$tmp)->h_next = $a_h_next;"
		end

	c_set_eps (tmp: POINTER; a_eps: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_bsimp_state_t_120 *)$tmp)->eps = $a_eps;"
		end

	c_set_yp (tmp: POINTER; a_yp: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_bsimp_state_t_120 *)$tmp)->yp = (double *)$a_yp;"
		end

	c_set_y_save (tmp: POINTER; a_y_save: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_bsimp_state_t_120 *)$tmp)->y_save = (double *)$a_y_save;"
		end

	c_set_yerr_save (tmp: POINTER; a_yerr_save: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_bsimp_state_t_120 *)$tmp)->yerr_save = (double *)$a_yerr_save;"
		end

	c_set_y_extrap_save (tmp: POINTER; a_y_extrap_save: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_bsimp_state_t_120 *)$tmp)->y_extrap_save = (double *)$a_y_extrap_save;"
		end

	c_set_y_extrap_sequence (tmp: POINTER; a_y_extrap_sequence: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_bsimp_state_t_120 *)$tmp)->y_extrap_sequence = (double *)$a_y_extrap_sequence;"
		end

	c_set_extrap_work (tmp: POINTER; a_extrap_work: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_bsimp_state_t_120 *)$tmp)->extrap_work = (double *)$a_extrap_work;"
		end

	c_set_dfdt (tmp: POINTER; a_dfdt: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_bsimp_state_t_120 *)$tmp)->dfdt = (double *)$a_dfdt;"
		end

	c_set_y_temp (tmp: POINTER; a_y_temp: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_bsimp_state_t_120 *)$tmp)->y_temp = (double *)$a_y_temp;"
		end

	c_set_delta_temp (tmp: POINTER; a_delta_temp: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_bsimp_state_t_120 *)$tmp)->delta_temp = (double *)$a_delta_temp;"
		end

	c_set_weight (tmp: POINTER; a_weight: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_bsimp_state_t_120 *)$tmp)->weight = (double *)$a_weight;"
		end

	c_set_dfdy (tmp: POINTER; a_dfdy: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_bsimp_state_t_120 *)$tmp)->dfdy = (gsl_matrix *)$a_dfdy;"
		end

	c_set_rhs_temp (tmp: POINTER; a_rhs_temp: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_bsimp_state_t_120 *)$tmp)->rhs_temp = (double *)$a_rhs_temp;"
		end

	c_set_delta (tmp: POINTER; a_delta: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_bsimp_state_t_120 *)$tmp)->delta = (double *)$a_delta;"
		end

	c_set_order (tmp: POINTER; a_order: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_bsimp_state_t_120 *)$tmp)->order = $a_order;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_bsimp_state_t_120);"
		end

end
