class
	PD_CHEB_SERIES_STRUCT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	c: CE_POINTER [REAL_64] assign set_c
		do
			create Result.make_shared (c_c (c_pointer))
		end

	order: INTEGER_32 assign set_order
		do
			Result := c_order (c_pointer)
		end

	a: REAL_64 assign set_a
		do
			Result := c_a (c_pointer)
		end

	b: REAL_64 assign set_b
		do
			Result := c_b (c_pointer)
		end

	order_sp: INTEGER_32 assign set_order_sp
		do
			Result := c_order_sp (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_c (a_c: CE_POINTER [REAL_64])
		do
			c_set_c (c_pointer, a_c.c_pointer)
		end

	set_order (a_order: INTEGER_32)
		do
			c_set_order (c_pointer, a_order)
		end

	set_a (a_a: REAL_64)
		do
			c_set_a (c_pointer, a_a)
		end

	set_b (a_b: REAL_64)
		do
			c_set_b (c_pointer, a_b)
		end

	set_order_sp (a_order_sp: INTEGER_32)
		do
			c_set_order_sp (c_pointer, a_order_sp)
		end

feature {NONE} -- C getters

	c_c (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct cheb_series_struct *)$tmp)->c;"
		end

	c_order (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cheb_series_struct *)$tmp)->order;"
		end

	c_a (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct cheb_series_struct *)$tmp)->a;"
		end

	c_b (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct cheb_series_struct *)$tmp)->b;"
		end

	c_order_sp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cheb_series_struct *)$tmp)->order_sp;"
		end

feature {NONE} -- C setters

	c_set_c (tmp: POINTER; a_c: POINTER)
		external
			"C inline"
		alias
			"((struct cheb_series_struct *)$tmp)->c = (double *)$a_c;"
		end

	c_set_order (tmp: POINTER; a_order: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cheb_series_struct *)$tmp)->order = $a_order;"
		end

	c_set_a (tmp: POINTER; a_a: REAL_64)
		external
			"C inline"
		alias
			"((struct cheb_series_struct *)$tmp)->a = $a_a;"
		end

	c_set_b (tmp: POINTER; a_b: REAL_64)
		external
			"C inline"
		alias
			"((struct cheb_series_struct *)$tmp)->b = $a_b;"
		end

	c_set_order_sp (tmp: POINTER; a_order_sp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cheb_series_struct *)$tmp)->order_sp = $a_order_sp;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct cheb_series_struct);"
		end

end
