class
	PD_EXTRAPOLATION_TABLE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	n: NATURAL_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	rlist2: CE_ARRAY [REAL_64]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_rlist2 (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	nres: NATURAL_32 assign set_nres
		do
			Result := c_nres (c_pointer)
		end

	res3la: CE_ARRAY [REAL_64]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_res3la (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_n (a_n: NATURAL_32)
		do
			c_set_n (c_pointer, a_n)
		end

	set_nres (a_nres: NATURAL_32)
		do
			c_set_nres (c_pointer, a_nres)
		end

feature {NONE} -- C getters

	c_n (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct extrapolation_table *)$tmp)->n;"
		end

	c_rlist2 (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct extrapolation_table *tmp = (struct extrapolation_table *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->rlist2) / sizeof(tmp->rlist2[0]);
				return tmp->rlist2;
			]"
		end

	c_nres (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct extrapolation_table *)$tmp)->nres;"
		end

	c_res3la (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct extrapolation_table *tmp = (struct extrapolation_table *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->res3la) / sizeof(tmp->res3la[0]);
				return tmp->res3la;
			]"
		end

feature {NONE} -- C setters

	c_set_n (tmp: POINTER; a_n: NATURAL_32)
		external
			"C inline"
		alias
			"((struct extrapolation_table *)$tmp)->n = $a_n;"
		end

	c_set_nres (tmp: POINTER; a_nres: NATURAL_32)
		external
			"C inline"
		alias
			"((struct extrapolation_table *)$tmp)->nres = $a_nres;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct extrapolation_table);"
		end

end
