class
	PD_FN_CAUCHY_PARAMS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	function: CE_POINTER [PD_GSL_FUNCTION_STRUCT] assign set_function
		do
			create Result.make_shared (c_function (c_pointer))
		end

	singularity: REAL_64 assign set_singularity
		do
			Result := c_singularity (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_function (a_function: CE_POINTER [PD_GSL_FUNCTION_STRUCT])
		do
			c_set_function (c_pointer, a_function.c_pointer)
		end

	set_singularity (a_singularity: REAL_64)
		do
			c_set_singularity (c_pointer, a_singularity)
		end

feature {NONE} -- C getters

	c_function (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct gsl_function_struct *)((struct fn_cauchy_params *)$tmp)->function;"
		end

	c_singularity (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct fn_cauchy_params *)$tmp)->singularity;"
		end

feature {NONE} -- C setters

	c_set_function (tmp: POINTER; a_function: POINTER)
		external
			"C inline"
		alias
			"((struct fn_cauchy_params *)$tmp)->function = (struct gsl_function_struct *)$a_function;"
		end

	c_set_singularity (tmp: POINTER; a_singularity: REAL_64)
		external
			"C inline"
		alias
			"((struct fn_cauchy_params *)$tmp)->singularity = $a_singularity;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct fn_cauchy_params);"
		end

end
