class
	PD_GSL_BSPLINE_WORKSPACE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	k: NATURAL_32 assign set_k
		do
			Result := c_k (c_pointer)
		end

	km1: NATURAL_32 assign set_km1
		do
			Result := c_km1 (c_pointer)
		end

	l: NATURAL_32 assign set_l
		do
			Result := c_l (c_pointer)
		end

	nbreak: NATURAL_32 assign set_nbreak
		do
			Result := c_nbreak (c_pointer)
		end

	n: NATURAL_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	knots: CE_POINTER [PD_GSL_VECTOR] assign set_knots
		do
			create Result.make_shared (c_knots (c_pointer))
		end

	deltal: CE_POINTER [PD_GSL_VECTOR] assign set_deltal
		do
			create Result.make_shared (c_deltal (c_pointer))
		end

	deltar: CE_POINTER [PD_GSL_VECTOR] assign set_deltar
		do
			create Result.make_shared (c_deltar (c_pointer))
		end

	B: CE_POINTER [PD_GSL_VECTOR] assign set_B
		do
			create Result.make_shared (c_B (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_k (a_k: NATURAL_32)
		do
			c_set_k (c_pointer, a_k)
		end

	set_km1 (a_km1: NATURAL_32)
		do
			c_set_km1 (c_pointer, a_km1)
		end

	set_l (a_l: NATURAL_32)
		do
			c_set_l (c_pointer, a_l)
		end

	set_nbreak (a_nbreak: NATURAL_32)
		do
			c_set_nbreak (c_pointer, a_nbreak)
		end

	set_n (a_n: NATURAL_32)
		do
			c_set_n (c_pointer, a_n)
		end

	set_knots (a_knots: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_knots (c_pointer, a_knots.c_pointer)
		end

	set_deltal (a_deltal: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_deltal (c_pointer, a_deltal.c_pointer)
		end

	set_deltar (a_deltar: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_deltar (c_pointer, a_deltar.c_pointer)
		end

	set_B (a_B: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_B (c_pointer, a_B.c_pointer)
		end

feature {NONE} -- C getters

	c_k (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_bspline_workspace_113 *)$tmp)->k;"
		end

	c_km1 (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_bspline_workspace_113 *)$tmp)->km1;"
		end

	c_l (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_bspline_workspace_113 *)$tmp)->l;"
		end

	c_nbreak (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_bspline_workspace_113 *)$tmp)->nbreak;"
		end

	c_n (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_bspline_workspace_113 *)$tmp)->n;"
		end

	c_knots (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_bspline_workspace_113 *)$tmp)->knots;"
		end

	c_deltal (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_bspline_workspace_113 *)$tmp)->deltal;"
		end

	c_deltar (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_bspline_workspace_113 *)$tmp)->deltar;"
		end

	c_B (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_bspline_workspace_113 *)$tmp)->B;"
		end

feature {NONE} -- C setters

	c_set_k (tmp: POINTER; a_k: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_bspline_workspace_113 *)$tmp)->k = $a_k;"
		end

	c_set_km1 (tmp: POINTER; a_km1: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_bspline_workspace_113 *)$tmp)->km1 = $a_km1;"
		end

	c_set_l (tmp: POINTER; a_l: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_bspline_workspace_113 *)$tmp)->l = $a_l;"
		end

	c_set_nbreak (tmp: POINTER; a_nbreak: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_bspline_workspace_113 *)$tmp)->nbreak = $a_nbreak;"
		end

	c_set_n (tmp: POINTER; a_n: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_bspline_workspace_113 *)$tmp)->n = $a_n;"
		end

	c_set_knots (tmp: POINTER; a_knots: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_bspline_workspace_113 *)$tmp)->knots = (gsl_vector *)$a_knots;"
		end

	c_set_deltal (tmp: POINTER; a_deltal: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_bspline_workspace_113 *)$tmp)->deltal = (gsl_vector *)$a_deltal;"
		end

	c_set_deltar (tmp: POINTER; a_deltar: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_bspline_workspace_113 *)$tmp)->deltar = (gsl_vector *)$a_deltar;"
		end

	c_set_B (tmp: POINTER; a_B: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_bspline_workspace_113 *)$tmp)->B = (gsl_vector *)$a_b;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_bspline_workspace_113);"
		end

end
