class
	PD_GSL_DHT_STRUCT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	nu: REAL_64 assign set_nu
		do
			Result := c_nu (c_pointer)
		end

	xmax: REAL_64 assign set_xmax
		do
			Result := c_xmax (c_pointer)
		end

	kmax: REAL_64 assign set_kmax
		do
			Result := c_kmax (c_pointer)
		end

	j: CE_POINTER [REAL_64] assign set_j
		do
			create Result.make_shared (c_j (c_pointer))
		end

	Jjj: CE_POINTER [REAL_64] assign set_Jjj
		do
			create Result.make_shared (c_Jjj (c_pointer))
		end

	J2: CE_POINTER [REAL_64] assign set_J2
		do
			create Result.make_shared (c_J2 (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_nu (a_nu: REAL_64)
		do
			c_set_nu (c_pointer, a_nu)
		end

	set_xmax (a_xmax: REAL_64)
		do
			c_set_xmax (c_pointer, a_xmax)
		end

	set_kmax (a_kmax: REAL_64)
		do
			c_set_kmax (c_pointer, a_kmax)
		end

	set_j (a_j: CE_POINTER [REAL_64])
		do
			c_set_j (c_pointer, a_j.c_pointer)
		end

	set_Jjj (a_Jjj: CE_POINTER [REAL_64])
		do
			c_set_Jjj (c_pointer, a_Jjj.c_pointer)
		end

	set_J2 (a_J2: CE_POINTER [REAL_64])
		do
			c_set_J2 (c_pointer, a_J2.c_pointer)
		end

feature {NONE} -- C getters

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct gsl_dht_struct *)$tmp)->size;"
		end

	c_nu (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct gsl_dht_struct *)$tmp)->nu;"
		end

	c_xmax (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct gsl_dht_struct *)$tmp)->xmax;"
		end

	c_kmax (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct gsl_dht_struct *)$tmp)->kmax;"
		end

	c_j (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct gsl_dht_struct *)$tmp)->j;"
		end

	c_Jjj (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct gsl_dht_struct *)$tmp)->Jjj;"
		end

	c_J2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct gsl_dht_struct *)$tmp)->J2;"
		end

feature {NONE} -- C setters

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct gsl_dht_struct *)$tmp)->size = $a_size;"
		end

	c_set_nu (tmp: POINTER; a_nu: REAL_64)
		external
			"C inline"
		alias
			"((struct gsl_dht_struct *)$tmp)->nu = $a_nu;"
		end

	c_set_xmax (tmp: POINTER; a_xmax: REAL_64)
		external
			"C inline"
		alias
			"((struct gsl_dht_struct *)$tmp)->xmax = $a_xmax;"
		end

	c_set_kmax (tmp: POINTER; a_kmax: REAL_64)
		external
			"C inline"
		alias
			"((struct gsl_dht_struct *)$tmp)->kmax = $a_kmax;"
		end

	c_set_j (tmp: POINTER; a_j: POINTER)
		external
			"C inline"
		alias
			"((struct gsl_dht_struct *)$tmp)->j = (double *)$a_j;"
		end

	c_set_Jjj (tmp: POINTER; a_Jjj: POINTER)
		external
			"C inline"
		alias
			"((struct gsl_dht_struct *)$tmp)->Jjj = (double *)$a_jjj;"
		end

	c_set_J2 (tmp: POINTER; a_J2: POINTER)
		external
			"C inline"
		alias
			"((struct gsl_dht_struct *)$tmp)->J2 = (double *)$a_j2;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct gsl_dht_struct);"
		end

end
