class
	PD_GSL_EIGEN_FRANCIS_WORKSPACE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	max_iterations: NATURAL_32 assign set_max_iterations
		do
			Result := c_max_iterations (c_pointer)
		end

	n_iter: NATURAL_32 assign set_n_iter
		do
			Result := c_n_iter (c_pointer)
		end

	n_evals: NATURAL_32 assign set_n_evals
		do
			Result := c_n_evals (c_pointer)
		end

	compute_t: INTEGER_32 assign set_compute_t
		do
			Result := c_compute_t (c_pointer)
		end

	H: CE_POINTER [PD_GSL_MATRIX] assign set_H
		do
			create Result.make_shared (c_H (c_pointer))
		end

	Z: CE_POINTER [PD_GSL_MATRIX] assign set_Z
		do
			create Result.make_shared (c_Z (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_max_iterations (a_max_iterations: NATURAL_32)
		do
			c_set_max_iterations (c_pointer, a_max_iterations)
		end

	set_n_iter (a_n_iter: NATURAL_32)
		do
			c_set_n_iter (c_pointer, a_n_iter)
		end

	set_n_evals (a_n_evals: NATURAL_32)
		do
			c_set_n_evals (c_pointer, a_n_evals)
		end

	set_compute_t (a_compute_t: INTEGER_32)
		do
			c_set_compute_t (c_pointer, a_compute_t)
		end

	set_H (a_H: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_H (c_pointer, a_H.c_pointer)
		end

	set_Z (a_Z: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_Z (c_pointer, a_Z.c_pointer)
		end

feature {NONE} -- C getters

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_eigen_francis_workspace_117 *)$tmp)->size;"
		end

	c_max_iterations (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_eigen_francis_workspace_117 *)$tmp)->max_iterations;"
		end

	c_n_iter (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_eigen_francis_workspace_117 *)$tmp)->n_iter;"
		end

	c_n_evals (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_eigen_francis_workspace_117 *)$tmp)->n_evals;"
		end

	c_compute_t (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_eigen_francis_workspace_117 *)$tmp)->compute_t;"
		end

	c_H (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_gsl_eigen_francis_workspace_117 *)$tmp)->H;"
		end

	c_Z (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_gsl_eigen_francis_workspace_117 *)$tmp)->Z;"
		end

feature {NONE} -- C setters

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_francis_workspace_117 *)$tmp)->size = $a_size;"
		end

	c_set_max_iterations (tmp: POINTER; a_max_iterations: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_francis_workspace_117 *)$tmp)->max_iterations = $a_max_iterations;"
		end

	c_set_n_iter (tmp: POINTER; a_n_iter: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_francis_workspace_117 *)$tmp)->n_iter = $a_n_iter;"
		end

	c_set_n_evals (tmp: POINTER; a_n_evals: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_francis_workspace_117 *)$tmp)->n_evals = $a_n_evals;"
		end

	c_set_compute_t (tmp: POINTER; a_compute_t: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_francis_workspace_117 *)$tmp)->compute_t = $a_compute_t;"
		end

	c_set_H (tmp: POINTER; a_H: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_francis_workspace_117 *)$tmp)->H = (gsl_matrix *)$a_h;"
		end

	c_set_Z (tmp: POINTER; a_Z: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_francis_workspace_117 *)$tmp)->Z = (gsl_matrix *)$a_z;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_eigen_francis_workspace_117);"
		end

end
