class
	PD_GSL_EIGEN_GEN_WORKSPACE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	work: CE_POINTER [PD_GSL_VECTOR] assign set_work
		do
			create Result.make_shared (c_work (c_pointer))
		end

	n_evals: NATURAL_32 assign set_n_evals
		do
			Result := c_n_evals (c_pointer)
		end

	max_iterations: NATURAL_32 assign set_max_iterations
		do
			Result := c_max_iterations (c_pointer)
		end

	n_iter: NATURAL_32 assign set_n_iter
		do
			Result := c_n_iter (c_pointer)
		end

	eshift: REAL_64 assign set_eshift
		do
			Result := c_eshift (c_pointer)
		end

	needtop: INTEGER_32 assign set_needtop
		do
			Result := c_needtop (c_pointer)
		end

	atol: REAL_64 assign set_atol
		do
			Result := c_atol (c_pointer)
		end

	btol: REAL_64 assign set_btol
		do
			Result := c_btol (c_pointer)
		end

	ascale: REAL_64 assign set_ascale
		do
			Result := c_ascale (c_pointer)
		end

	bscale: REAL_64 assign set_bscale
		do
			Result := c_bscale (c_pointer)
		end

	H: CE_POINTER [PD_GSL_MATRIX] assign set_H
		do
			create Result.make_shared (c_H (c_pointer))
		end

	R: CE_POINTER [PD_GSL_MATRIX] assign set_R
		do
			create Result.make_shared (c_R (c_pointer))
		end

	compute_s: INTEGER_32 assign set_compute_s
		do
			Result := c_compute_s (c_pointer)
		end

	compute_t: INTEGER_32 assign set_compute_t
		do
			Result := c_compute_t (c_pointer)
		end

	Q: CE_POINTER [PD_GSL_MATRIX] assign set_Q
		do
			create Result.make_shared (c_Q (c_pointer))
		end

	Z: CE_POINTER [PD_GSL_MATRIX] assign set_Z
		do
			create Result.make_shared (c_Z (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_work (a_work: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_work (c_pointer, a_work.c_pointer)
		end

	set_n_evals (a_n_evals: NATURAL_32)
		do
			c_set_n_evals (c_pointer, a_n_evals)
		end

	set_max_iterations (a_max_iterations: NATURAL_32)
		do
			c_set_max_iterations (c_pointer, a_max_iterations)
		end

	set_n_iter (a_n_iter: NATURAL_32)
		do
			c_set_n_iter (c_pointer, a_n_iter)
		end

	set_eshift (a_eshift: REAL_64)
		do
			c_set_eshift (c_pointer, a_eshift)
		end

	set_needtop (a_needtop: INTEGER_32)
		do
			c_set_needtop (c_pointer, a_needtop)
		end

	set_atol (a_atol: REAL_64)
		do
			c_set_atol (c_pointer, a_atol)
		end

	set_btol (a_btol: REAL_64)
		do
			c_set_btol (c_pointer, a_btol)
		end

	set_ascale (a_ascale: REAL_64)
		do
			c_set_ascale (c_pointer, a_ascale)
		end

	set_bscale (a_bscale: REAL_64)
		do
			c_set_bscale (c_pointer, a_bscale)
		end

	set_H (a_H: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_H (c_pointer, a_H.c_pointer)
		end

	set_R (a_R: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_R (c_pointer, a_R.c_pointer)
		end

	set_compute_s (a_compute_s: INTEGER_32)
		do
			c_set_compute_s (c_pointer, a_compute_s)
		end

	set_compute_t (a_compute_t: INTEGER_32)
		do
			c_set_compute_t (c_pointer, a_compute_t)
		end

	set_Q (a_Q: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_Q (c_pointer, a_Q.c_pointer)
		end

	set_Z (a_Z: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_Z (c_pointer, a_Z.c_pointer)
		end

feature {NONE} -- C getters

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->size;"
		end

	c_work (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->work;"
		end

	c_n_evals (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->n_evals;"
		end

	c_max_iterations (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->max_iterations;"
		end

	c_n_iter (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->n_iter;"
		end

	c_eshift (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->eshift;"
		end

	c_needtop (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->needtop;"
		end

	c_atol (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->atol;"
		end

	c_btol (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->btol;"
		end

	c_ascale (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->ascale;"
		end

	c_bscale (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->bscale;"
		end

	c_H (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->H;"
		end

	c_R (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->R;"
		end

	c_compute_s (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->compute_s;"
		end

	c_compute_t (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->compute_t;"
		end

	c_Q (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->Q;"
		end

	c_Z (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->Z;"
		end

feature {NONE} -- C setters

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->size = $a_size;"
		end

	c_set_work (tmp: POINTER; a_work: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->work = (gsl_vector *)$a_work;"
		end

	c_set_n_evals (tmp: POINTER; a_n_evals: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->n_evals = $a_n_evals;"
		end

	c_set_max_iterations (tmp: POINTER; a_max_iterations: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->max_iterations = $a_max_iterations;"
		end

	c_set_n_iter (tmp: POINTER; a_n_iter: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->n_iter = $a_n_iter;"
		end

	c_set_eshift (tmp: POINTER; a_eshift: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->eshift = $a_eshift;"
		end

	c_set_needtop (tmp: POINTER; a_needtop: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->needtop = $a_needtop;"
		end

	c_set_atol (tmp: POINTER; a_atol: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->atol = $a_atol;"
		end

	c_set_btol (tmp: POINTER; a_btol: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->btol = $a_btol;"
		end

	c_set_ascale (tmp: POINTER; a_ascale: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->ascale = $a_ascale;"
		end

	c_set_bscale (tmp: POINTER; a_bscale: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->bscale = $a_bscale;"
		end

	c_set_H (tmp: POINTER; a_H: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->H = (gsl_matrix *)$a_h;"
		end

	c_set_R (tmp: POINTER; a_R: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->R = (gsl_matrix *)$a_r;"
		end

	c_set_compute_s (tmp: POINTER; a_compute_s: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->compute_s = $a_compute_s;"
		end

	c_set_compute_t (tmp: POINTER; a_compute_t: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->compute_t = $a_compute_t;"
		end

	c_set_Q (tmp: POINTER; a_Q: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->Q = (gsl_matrix *)$a_q;"
		end

	c_set_Z (tmp: POINTER; a_Z: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_gen_workspace_124 *)$tmp)->Z = (gsl_matrix *)$a_z;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_eigen_gen_workspace_124);"
		end

end
