class
	PD_GSL_EIGEN_GENV_WORKSPACE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	work1: CE_POINTER [PD_GSL_VECTOR] assign set_work1
		do
			create Result.make_shared (c_work1 (c_pointer))
		end

	work2: CE_POINTER [PD_GSL_VECTOR] assign set_work2
		do
			create Result.make_shared (c_work2 (c_pointer))
		end

	work3: CE_POINTER [PD_GSL_VECTOR] assign set_work3
		do
			create Result.make_shared (c_work3 (c_pointer))
		end

	work4: CE_POINTER [PD_GSL_VECTOR] assign set_work4
		do
			create Result.make_shared (c_work4 (c_pointer))
		end

	work5: CE_POINTER [PD_GSL_VECTOR] assign set_work5
		do
			create Result.make_shared (c_work5 (c_pointer))
		end

	work6: CE_POINTER [PD_GSL_VECTOR] assign set_work6
		do
			create Result.make_shared (c_work6 (c_pointer))
		end

	Q: CE_POINTER [PD_GSL_MATRIX] assign set_Q
		do
			create Result.make_shared (c_Q (c_pointer))
		end

	Z: CE_POINTER [PD_GSL_MATRIX] assign set_Z
		do
			create Result.make_shared (c_Z (c_pointer))
		end

	gen_workspace_p: CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE] assign set_gen_workspace_p
		do
			create Result.make_shared (c_gen_workspace_p (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_work1 (a_work1: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_work1 (c_pointer, a_work1.c_pointer)
		end

	set_work2 (a_work2: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_work2 (c_pointer, a_work2.c_pointer)
		end

	set_work3 (a_work3: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_work3 (c_pointer, a_work3.c_pointer)
		end

	set_work4 (a_work4: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_work4 (c_pointer, a_work4.c_pointer)
		end

	set_work5 (a_work5: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_work5 (c_pointer, a_work5.c_pointer)
		end

	set_work6 (a_work6: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_work6 (c_pointer, a_work6.c_pointer)
		end

	set_Q (a_Q: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_Q (c_pointer, a_Q.c_pointer)
		end

	set_Z (a_Z: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_Z (c_pointer, a_Z.c_pointer)
		end

	set_gen_workspace_p (a_gen_workspace_p: CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE])
		do
			c_set_gen_workspace_p (c_pointer, a_gen_workspace_p.c_pointer)
		end

feature {NONE} -- C getters

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_eigen_genv_workspace_125 *)$tmp)->size;"
		end

	c_work1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_eigen_genv_workspace_125 *)$tmp)->work1;"
		end

	c_work2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_eigen_genv_workspace_125 *)$tmp)->work2;"
		end

	c_work3 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_eigen_genv_workspace_125 *)$tmp)->work3;"
		end

	c_work4 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_eigen_genv_workspace_125 *)$tmp)->work4;"
		end

	c_work5 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_eigen_genv_workspace_125 *)$tmp)->work5;"
		end

	c_work6 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_eigen_genv_workspace_125 *)$tmp)->work6;"
		end

	c_Q (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_gsl_eigen_genv_workspace_125 *)$tmp)->Q;"
		end

	c_Z (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_gsl_eigen_genv_workspace_125 *)$tmp)->Z;"
		end

	c_gen_workspace_p (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_eigen_gen_workspace *)((struct __anonstruct_gsl_eigen_genv_workspace_125 *)$tmp)->gen_workspace_p;"
		end

feature {NONE} -- C setters

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_genv_workspace_125 *)$tmp)->size = $a_size;"
		end

	c_set_work1 (tmp: POINTER; a_work1: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_genv_workspace_125 *)$tmp)->work1 = (gsl_vector *)$a_work1;"
		end

	c_set_work2 (tmp: POINTER; a_work2: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_genv_workspace_125 *)$tmp)->work2 = (gsl_vector *)$a_work2;"
		end

	c_set_work3 (tmp: POINTER; a_work3: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_genv_workspace_125 *)$tmp)->work3 = (gsl_vector *)$a_work3;"
		end

	c_set_work4 (tmp: POINTER; a_work4: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_genv_workspace_125 *)$tmp)->work4 = (gsl_vector *)$a_work4;"
		end

	c_set_work5 (tmp: POINTER; a_work5: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_genv_workspace_125 *)$tmp)->work5 = (gsl_vector *)$a_work5;"
		end

	c_set_work6 (tmp: POINTER; a_work6: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_genv_workspace_125 *)$tmp)->work6 = (gsl_vector *)$a_work6;"
		end

	c_set_Q (tmp: POINTER; a_Q: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_genv_workspace_125 *)$tmp)->Q = (gsl_matrix *)$a_q;"
		end

	c_set_Z (tmp: POINTER; a_Z: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_genv_workspace_125 *)$tmp)->Z = (gsl_matrix *)$a_z;"
		end

	c_set_gen_workspace_p (tmp: POINTER; a_gen_workspace_p: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_genv_workspace_125 *)$tmp)->gen_workspace_p = (gsl_eigen_gen_workspace *)$a_gen_workspace_p;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_eigen_genv_workspace_125);"
		end

end
