class
	PD_GSL_EIGEN_HERMV_WORKSPACE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	d: CE_POINTER [REAL_64] assign set_d
		do
			create Result.make_shared (c_d (c_pointer))
		end

	sd: CE_POINTER [REAL_64] assign set_sd
		do
			create Result.make_shared (c_sd (c_pointer))
		end

	tau: CE_POINTER [REAL_64] assign set_tau
		do
			create Result.make_shared (c_tau (c_pointer))
		end

	gc: CE_POINTER [REAL_64] assign set_gc
		do
			create Result.make_shared (c_gc (c_pointer))
		end

	gs: CE_POINTER [REAL_64] assign set_gs
		do
			create Result.make_shared (c_gs (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_d (a_d: CE_POINTER [REAL_64])
		do
			c_set_d (c_pointer, a_d.c_pointer)
		end

	set_sd (a_sd: CE_POINTER [REAL_64])
		do
			c_set_sd (c_pointer, a_sd.c_pointer)
		end

	set_tau (a_tau: CE_POINTER [REAL_64])
		do
			c_set_tau (c_pointer, a_tau.c_pointer)
		end

	set_gc (a_gc: CE_POINTER [REAL_64])
		do
			c_set_gc (c_pointer, a_gc.c_pointer)
		end

	set_gs (a_gs: CE_POINTER [REAL_64])
		do
			c_set_gs (c_pointer, a_gs.c_pointer)
		end

feature {NONE} -- C getters

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_eigen_hermv_workspace_117 *)$tmp)->size;"
		end

	c_d (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_eigen_hermv_workspace_117 *)$tmp)->d;"
		end

	c_sd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_eigen_hermv_workspace_117 *)$tmp)->sd;"
		end

	c_tau (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_eigen_hermv_workspace_117 *)$tmp)->tau;"
		end

	c_gc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_eigen_hermv_workspace_117 *)$tmp)->gc;"
		end

	c_gs (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_eigen_hermv_workspace_117 *)$tmp)->gs;"
		end

feature {NONE} -- C setters

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_hermv_workspace_117 *)$tmp)->size = $a_size;"
		end

	c_set_d (tmp: POINTER; a_d: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_hermv_workspace_117 *)$tmp)->d = (double *)$a_d;"
		end

	c_set_sd (tmp: POINTER; a_sd: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_hermv_workspace_117 *)$tmp)->sd = (double *)$a_sd;"
		end

	c_set_tau (tmp: POINTER; a_tau: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_hermv_workspace_117 *)$tmp)->tau = (double *)$a_tau;"
		end

	c_set_gc (tmp: POINTER; a_gc: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_hermv_workspace_117 *)$tmp)->gc = (double *)$a_gc;"
		end

	c_set_gs (tmp: POINTER; a_gs: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_hermv_workspace_117 *)$tmp)->gs = (double *)$a_gs;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_eigen_hermv_workspace_117);"
		end

end
