class
	PD_GSL_EIGEN_NONSYMM_WORKSPACE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	diag: CE_POINTER [PD_GSL_VECTOR] assign set_diag
		do
			create Result.make_shared (c_diag (c_pointer))
		end

	tau: CE_POINTER [PD_GSL_VECTOR] assign set_tau
		do
			create Result.make_shared (c_tau (c_pointer))
		end

	Z: CE_POINTER [PD_GSL_MATRIX] assign set_Z
		do
			create Result.make_shared (c_Z (c_pointer))
		end

	do_balance: INTEGER_32 assign set_do_balance
		do
			Result := c_do_balance (c_pointer)
		end

	n_evals: NATURAL_32 assign set_n_evals
		do
			Result := c_n_evals (c_pointer)
		end

	francis_workspace_p: CE_POINTER [PD_GSL_EIGEN_FRANCIS_WORKSPACE] assign set_francis_workspace_p
		do
			create Result.make_shared (c_francis_workspace_p (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_diag (a_diag: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_diag (c_pointer, a_diag.c_pointer)
		end

	set_tau (a_tau: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_tau (c_pointer, a_tau.c_pointer)
		end

	set_Z (a_Z: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_Z (c_pointer, a_Z.c_pointer)
		end

	set_do_balance (a_do_balance: INTEGER_32)
		do
			c_set_do_balance (c_pointer, a_do_balance)
		end

	set_n_evals (a_n_evals: NATURAL_32)
		do
			c_set_n_evals (c_pointer, a_n_evals)
		end

	set_francis_workspace_p (a_francis_workspace_p: CE_POINTER [PD_GSL_EIGEN_FRANCIS_WORKSPACE])
		do
			c_set_francis_workspace_p (c_pointer, a_francis_workspace_p.c_pointer)
		end

feature {NONE} -- C getters

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_eigen_nonsymm_workspace_118 *)$tmp)->size;"
		end

	c_diag (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_eigen_nonsymm_workspace_118 *)$tmp)->diag;"
		end

	c_tau (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_eigen_nonsymm_workspace_118 *)$tmp)->tau;"
		end

	c_Z (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_gsl_eigen_nonsymm_workspace_118 *)$tmp)->Z;"
		end

	c_do_balance (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_eigen_nonsymm_workspace_118 *)$tmp)->do_balance;"
		end

	c_n_evals (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_eigen_nonsymm_workspace_118 *)$tmp)->n_evals;"
		end

	c_francis_workspace_p (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_eigen_francis_workspace *)((struct __anonstruct_gsl_eigen_nonsymm_workspace_118 *)$tmp)->francis_workspace_p;"
		end

feature {NONE} -- C setters

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_nonsymm_workspace_118 *)$tmp)->size = $a_size;"
		end

	c_set_diag (tmp: POINTER; a_diag: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_nonsymm_workspace_118 *)$tmp)->diag = (gsl_vector *)$a_diag;"
		end

	c_set_tau (tmp: POINTER; a_tau: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_nonsymm_workspace_118 *)$tmp)->tau = (gsl_vector *)$a_tau;"
		end

	c_set_Z (tmp: POINTER; a_Z: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_nonsymm_workspace_118 *)$tmp)->Z = (gsl_matrix *)$a_z;"
		end

	c_set_do_balance (tmp: POINTER; a_do_balance: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_nonsymm_workspace_118 *)$tmp)->do_balance = $a_do_balance;"
		end

	c_set_n_evals (tmp: POINTER; a_n_evals: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_nonsymm_workspace_118 *)$tmp)->n_evals = $a_n_evals;"
		end

	c_set_francis_workspace_p (tmp: POINTER; a_francis_workspace_p: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_nonsymm_workspace_118 *)$tmp)->francis_workspace_p = (gsl_eigen_francis_workspace *)$a_francis_workspace_p;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_eigen_nonsymm_workspace_118);"
		end

end
