class
	PD_GSL_EIGEN_NONSYMMV_WORKSPACE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	work: CE_POINTER [PD_GSL_VECTOR] assign set_work
		do
			create Result.make_shared (c_work (c_pointer))
		end

	work2: CE_POINTER [PD_GSL_VECTOR] assign set_work2
		do
			create Result.make_shared (c_work2 (c_pointer))
		end

	work3: CE_POINTER [PD_GSL_VECTOR] assign set_work3
		do
			create Result.make_shared (c_work3 (c_pointer))
		end

	Z: CE_POINTER [PD_GSL_MATRIX] assign set_Z
		do
			create Result.make_shared (c_Z (c_pointer))
		end

	nonsymm_workspace_p: CE_POINTER [PD_GSL_EIGEN_NONSYMM_WORKSPACE] assign set_nonsymm_workspace_p
		do
			create Result.make_shared (c_nonsymm_workspace_p (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_work (a_work: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_work (c_pointer, a_work.c_pointer)
		end

	set_work2 (a_work2: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_work2 (c_pointer, a_work2.c_pointer)
		end

	set_work3 (a_work3: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_work3 (c_pointer, a_work3.c_pointer)
		end

	set_Z (a_Z: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_Z (c_pointer, a_Z.c_pointer)
		end

	set_nonsymm_workspace_p (a_nonsymm_workspace_p: CE_POINTER [PD_GSL_EIGEN_NONSYMM_WORKSPACE])
		do
			c_set_nonsymm_workspace_p (c_pointer, a_nonsymm_workspace_p.c_pointer)
		end

feature {NONE} -- C getters

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_eigen_nonsymmv_workspace_119 *)$tmp)->size;"
		end

	c_work (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_eigen_nonsymmv_workspace_119 *)$tmp)->work;"
		end

	c_work2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_eigen_nonsymmv_workspace_119 *)$tmp)->work2;"
		end

	c_work3 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_eigen_nonsymmv_workspace_119 *)$tmp)->work3;"
		end

	c_Z (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_gsl_eigen_nonsymmv_workspace_119 *)$tmp)->Z;"
		end

	c_nonsymm_workspace_p (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_eigen_nonsymm_workspace *)((struct __anonstruct_gsl_eigen_nonsymmv_workspace_119 *)$tmp)->nonsymm_workspace_p;"
		end

feature {NONE} -- C setters

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_nonsymmv_workspace_119 *)$tmp)->size = $a_size;"
		end

	c_set_work (tmp: POINTER; a_work: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_nonsymmv_workspace_119 *)$tmp)->work = (gsl_vector *)$a_work;"
		end

	c_set_work2 (tmp: POINTER; a_work2: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_nonsymmv_workspace_119 *)$tmp)->work2 = (gsl_vector *)$a_work2;"
		end

	c_set_work3 (tmp: POINTER; a_work3: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_nonsymmv_workspace_119 *)$tmp)->work3 = (gsl_vector *)$a_work3;"
		end

	c_set_Z (tmp: POINTER; a_Z: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_nonsymmv_workspace_119 *)$tmp)->Z = (gsl_matrix *)$a_z;"
		end

	c_set_nonsymm_workspace_p (tmp: POINTER; a_nonsymm_workspace_p: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_nonsymmv_workspace_119 *)$tmp)->nonsymm_workspace_p = (gsl_eigen_nonsymm_workspace *)$a_nonsymm_workspace_p;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_eigen_nonsymmv_workspace_119);"
		end

end
