class
	PD_GSL_FFT_HALFCOMPLEX_WAVETABLE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	n: NATURAL_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	nf: NATURAL_32 assign set_nf
		do
			Result := c_nf (c_pointer)
		end

	factor: CE_ARRAY [NATURAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_factor (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	twiddle: CE_ARRAY [CE_POINTER [PD_GSL_COMPLEX]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_twiddle (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	trig: CE_POINTER [PD_GSL_COMPLEX] assign set_trig
		do
			create Result.make_shared (c_trig (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_n (a_n: NATURAL_32)
		do
			c_set_n (c_pointer, a_n)
		end

	set_nf (a_nf: NATURAL_32)
		do
			c_set_nf (c_pointer, a_nf)
		end

	set_trig (a_trig: CE_POINTER [PD_GSL_COMPLEX])
		do
			c_set_trig (c_pointer, a_trig.c_pointer)
		end

feature {NONE} -- C getters

	c_n (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_fft_halfcomplex_wavetable_36 *)$tmp)->n;"
		end

	c_nf (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_fft_halfcomplex_wavetable_36 *)$tmp)->nf;"
		end

	c_factor (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_gsl_fft_halfcomplex_wavetable_36 *tmp = (struct __anonstruct_gsl_fft_halfcomplex_wavetable_36 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->factor) / sizeof(tmp->factor[0]);
				return tmp->factor;
			]"
		end

	c_twiddle (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_gsl_fft_halfcomplex_wavetable_36 *tmp = (struct __anonstruct_gsl_fft_halfcomplex_wavetable_36 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->twiddle) / sizeof(tmp->twiddle[0]);
				return tmp->twiddle;
			]"
		end

	c_trig (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_complex *)((struct __anonstruct_gsl_fft_halfcomplex_wavetable_36 *)$tmp)->trig;"
		end

feature {NONE} -- C setters

	c_set_n (tmp: POINTER; a_n: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_fft_halfcomplex_wavetable_36 *)$tmp)->n = $a_n;"
		end

	c_set_nf (tmp: POINTER; a_nf: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_fft_halfcomplex_wavetable_36 *)$tmp)->nf = $a_nf;"
		end

	c_set_trig (tmp: POINTER; a_trig: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_fft_halfcomplex_wavetable_36 *)$tmp)->trig = (gsl_complex *)$a_trig;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_fft_halfcomplex_wavetable_36);"
		end

end
