class
	PD_GSL_FUNCTION_STRUCT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	function: CE_ROUTINE assign set_function
		do
			create Result.make_shared (c_function (c_pointer))
		end

	params: CE_POINTER [ANY] assign set_params
		do
			create Result.make_shared (c_params (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_function (a_function: CE_ROUTINE)
		do
			c_set_function (c_pointer, a_function.c_pointer)
		end

	set_params (a_params: CE_POINTER [ANY])
		do
			c_set_params (c_pointer, a_params.c_pointer)
		end

feature {NONE} -- C getters

	c_function (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double( *)(double x, void * params))((struct gsl_function_struct *)$tmp)->function;"
		end

	c_params (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct gsl_function_struct *)$tmp)->params;"
		end

feature {NONE} -- C setters

	c_set_function (tmp: POINTER; a_function: POINTER)
		external
			"C inline"
		alias
			"((struct gsl_function_struct *)$tmp)->function = (double( *)(double x, void * params))$a_function;"
		end

	c_set_params (tmp: POINTER; a_params: POINTER)
		external
			"C inline"
		alias
			"((struct gsl_function_struct *)$tmp)->params = (void *)$a_params;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct gsl_function_struct);"
		end

end
