class
	PD_GSL_HISTOGRAM2D

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	nx: NATURAL_32 assign set_nx
		do
			Result := c_nx (c_pointer)
		end

	ny: NATURAL_32 assign set_ny
		do
			Result := c_ny (c_pointer)
		end

	xrange: CE_POINTER [REAL_64] assign set_xrange
		do
			create Result.make_shared (c_xrange (c_pointer))
		end

	yrange: CE_POINTER [REAL_64] assign set_yrange
		do
			create Result.make_shared (c_yrange (c_pointer))
		end

	bin: CE_POINTER [REAL_64] assign set_bin
		do
			create Result.make_shared (c_bin (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_nx (a_nx: NATURAL_32)
		do
			c_set_nx (c_pointer, a_nx)
		end

	set_ny (a_ny: NATURAL_32)
		do
			c_set_ny (c_pointer, a_ny)
		end

	set_xrange (a_xrange: CE_POINTER [REAL_64])
		do
			c_set_xrange (c_pointer, a_xrange.c_pointer)
		end

	set_yrange (a_yrange: CE_POINTER [REAL_64])
		do
			c_set_yrange (c_pointer, a_yrange.c_pointer)
		end

	set_bin (a_bin: CE_POINTER [REAL_64])
		do
			c_set_bin (c_pointer, a_bin.c_pointer)
		end

feature {NONE} -- C getters

	c_nx (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_histogram2d_24 *)$tmp)->nx;"
		end

	c_ny (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_histogram2d_24 *)$tmp)->ny;"
		end

	c_xrange (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_histogram2d_24 *)$tmp)->xrange;"
		end

	c_yrange (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_histogram2d_24 *)$tmp)->yrange;"
		end

	c_bin (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_histogram2d_24 *)$tmp)->bin;"
		end

feature {NONE} -- C setters

	c_set_nx (tmp: POINTER; a_nx: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_histogram2d_24 *)$tmp)->nx = $a_nx;"
		end

	c_set_ny (tmp: POINTER; a_ny: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_histogram2d_24 *)$tmp)->ny = $a_ny;"
		end

	c_set_xrange (tmp: POINTER; a_xrange: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_histogram2d_24 *)$tmp)->xrange = (double *)$a_xrange;"
		end

	c_set_yrange (tmp: POINTER; a_yrange: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_histogram2d_24 *)$tmp)->yrange = (double *)$a_yrange;"
		end

	c_set_bin (tmp: POINTER; a_bin: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_histogram2d_24 *)$tmp)->bin = (double *)$a_bin;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_histogram2d_24);"
		end

end
