class
	PD_GSL_IEEE_DOUBLE_REP

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sign: INTEGER_32 assign set_sign
		do
			Result := c_sign (c_pointer)
		end

	mantissa: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_mantissa (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	exponent: INTEGER_32 assign set_exponent
		do
			Result := c_exponent (c_pointer)
		end

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_sign (a_sign: INTEGER_32)
		do
			c_set_sign (c_pointer, a_sign)
		end

	set_exponent (a_exponent: INTEGER_32)
		do
			c_set_exponent (c_pointer, a_exponent)
		end

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

feature {NONE} -- C getters

	c_sign (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_ieee_double_rep_8 *)$tmp)->sign;"
		end

	c_mantissa (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_gsl_ieee_double_rep_8 *tmp = (struct __anonstruct_gsl_ieee_double_rep_8 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->mantissa) / sizeof(tmp->mantissa[0]);
				return tmp->mantissa;
			]"
		end

	c_exponent (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_ieee_double_rep_8 *)$tmp)->exponent;"
		end

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_ieee_double_rep_8 *)$tmp)->type;"
		end

feature {NONE} -- C setters

	c_set_sign (tmp: POINTER; a_sign: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_ieee_double_rep_8 *)$tmp)->sign = $a_sign;"
		end

	c_set_exponent (tmp: POINTER; a_exponent: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_ieee_double_rep_8 *)$tmp)->exponent = $a_exponent;"
		end

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_ieee_double_rep_8 *)$tmp)->type = $a_type;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_ieee_double_rep_8);"
		end

end
