class
	PD_GSL_INTEGRATION_QAWS_TABLE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	alpha: REAL_64 assign set_alpha
		do
			Result := c_alpha (c_pointer)
		end

	beta: REAL_64 assign set_beta
		do
			Result := c_beta (c_pointer)
		end

	mu: INTEGER_32 assign set_mu
		do
			Result := c_mu (c_pointer)
		end

	nu: INTEGER_32 assign set_nu
		do
			Result := c_nu (c_pointer)
		end

	ri: CE_ARRAY [REAL_64]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_ri (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	rj: CE_ARRAY [REAL_64]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_rj (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	rg: CE_ARRAY [REAL_64]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_rg (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	rh: CE_ARRAY [REAL_64]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_rh (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_alpha (a_alpha: REAL_64)
		do
			c_set_alpha (c_pointer, a_alpha)
		end

	set_beta (a_beta: REAL_64)
		do
			c_set_beta (c_pointer, a_beta)
		end

	set_mu (a_mu: INTEGER_32)
		do
			c_set_mu (c_pointer, a_mu)
		end

	set_nu (a_nu: INTEGER_32)
		do
			c_set_nu (c_pointer, a_nu)
		end

feature {NONE} -- C getters

	c_alpha (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_integration_qaws_table_22 *)$tmp)->alpha;"
		end

	c_beta (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_integration_qaws_table_22 *)$tmp)->beta;"
		end

	c_mu (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_integration_qaws_table_22 *)$tmp)->mu;"
		end

	c_nu (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_integration_qaws_table_22 *)$tmp)->nu;"
		end

	c_ri (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_gsl_integration_qaws_table_22 *tmp = (struct __anonstruct_gsl_integration_qaws_table_22 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->ri) / sizeof(tmp->ri[0]);
				return tmp->ri;
			]"
		end

	c_rj (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_gsl_integration_qaws_table_22 *tmp = (struct __anonstruct_gsl_integration_qaws_table_22 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->rj) / sizeof(tmp->rj[0]);
				return tmp->rj;
			]"
		end

	c_rg (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_gsl_integration_qaws_table_22 *tmp = (struct __anonstruct_gsl_integration_qaws_table_22 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->rg) / sizeof(tmp->rg[0]);
				return tmp->rg;
			]"
		end

	c_rh (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_gsl_integration_qaws_table_22 *tmp = (struct __anonstruct_gsl_integration_qaws_table_22 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->rh) / sizeof(tmp->rh[0]);
				return tmp->rh;
			]"
		end

feature {NONE} -- C setters

	c_set_alpha (tmp: POINTER; a_alpha: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_qaws_table_22 *)$tmp)->alpha = $a_alpha;"
		end

	c_set_beta (tmp: POINTER; a_beta: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_qaws_table_22 *)$tmp)->beta = $a_beta;"
		end

	c_set_mu (tmp: POINTER; a_mu: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_qaws_table_22 *)$tmp)->mu = $a_mu;"
		end

	c_set_nu (tmp: POINTER; a_nu: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_qaws_table_22 *)$tmp)->nu = $a_nu;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_integration_qaws_table_22);"
		end

end
