class
	PD_GSL_INTERP_TYPE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	min_size: NATURAL_32 assign set_min_size
		do
			Result := c_min_size (c_pointer)
		end

	alloc: CE_ROUTINE assign set_alloc
		do
			create Result.make_shared (c_alloc (c_pointer))
		end

	init: CE_ROUTINE assign set_init
		do
			create Result.make_shared (c_init (c_pointer))
		end

	eval: CE_ROUTINE assign set_eval
		do
			create Result.make_shared (c_eval (c_pointer))
		end

	eval_deriv: CE_ROUTINE assign set_eval_deriv
		do
			create Result.make_shared (c_eval_deriv (c_pointer))
		end

	eval_deriv2: CE_ROUTINE assign set_eval_deriv2
		do
			create Result.make_shared (c_eval_deriv2 (c_pointer))
		end

	eval_integ: CE_ROUTINE assign set_eval_integ
		do
			create Result.make_shared (c_eval_integ (c_pointer))
		end

	free: CE_ROUTINE assign set_free
		do
			create Result.make_shared (c_free (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_min_size (a_min_size: NATURAL_32)
		do
			c_set_min_size (c_pointer, a_min_size)
		end

	set_alloc (a_alloc: CE_ROUTINE)
		do
			c_set_alloc (c_pointer, a_alloc.c_pointer)
		end

	set_init (a_init: CE_ROUTINE)
		do
			c_set_init (c_pointer, a_init.c_pointer)
		end

	set_eval (a_eval: CE_ROUTINE)
		do
			c_set_eval (c_pointer, a_eval.c_pointer)
		end

	set_eval_deriv (a_eval_deriv: CE_ROUTINE)
		do
			c_set_eval_deriv (c_pointer, a_eval_deriv.c_pointer)
		end

	set_eval_deriv2 (a_eval_deriv2: CE_ROUTINE)
		do
			c_set_eval_deriv2 (c_pointer, a_eval_deriv2.c_pointer)
		end

	set_eval_integ (a_eval_integ: CE_ROUTINE)
		do
			c_set_eval_integ (c_pointer, a_eval_integ.c_pointer)
		end

	set_free (a_free: CE_ROUTINE)
		do
			c_set_free (c_pointer, a_free.c_pointer)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_gsl_interp_type_113 *)$tmp)->name;"
		end

	c_min_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_interp_type_113 *)$tmp)->min_size;"
		end

	c_alloc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *( *)(unsigned int size))((struct __anonstruct_gsl_interp_type_113 *)$tmp)->alloc;"
		end

	c_init (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void *, double * xa, double * ya, unsigned int size))((struct __anonstruct_gsl_interp_type_113 *)$tmp)->init;"
		end

	c_eval (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void *, double * xa, double * ya, unsigned int size, double x, gsl_interp_accel *, double * y))((struct __anonstruct_gsl_interp_type_113 *)$tmp)->eval;"
		end

	c_eval_deriv (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void *, double * xa, double * ya, unsigned int size, double x, gsl_interp_accel *, double * y_p))((struct __anonstruct_gsl_interp_type_113 *)$tmp)->eval_deriv;"
		end

	c_eval_deriv2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void *, double * xa, double * ya, unsigned int size, double x, gsl_interp_accel *, double * y_pp))((struct __anonstruct_gsl_interp_type_113 *)$tmp)->eval_deriv2;"
		end

	c_eval_integ (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void *, double * xa, double * ya, unsigned int size, gsl_interp_accel *, double a, double b, double * result))((struct __anonstruct_gsl_interp_type_113 *)$tmp)->eval_integ;"
		end

	c_free (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void *))((struct __anonstruct_gsl_interp_type_113 *)$tmp)->free;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_interp_type_113 *)$tmp)->name = (char const *)$a_name;"
		end

	c_set_min_size (tmp: POINTER; a_min_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_interp_type_113 *)$tmp)->min_size = $a_min_size;"
		end

	c_set_alloc (tmp: POINTER; a_alloc: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_interp_type_113 *)$tmp)->alloc = (void *( *)(unsigned int size))$a_alloc;"
		end

	c_set_init (tmp: POINTER; a_init: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_interp_type_113 *)$tmp)->init = (int( *)(void *, double const * xa, double const * ya, unsigned int size))$a_init;"
		end

	c_set_eval (tmp: POINTER; a_eval: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_interp_type_113 *)$tmp)->eval = (int( *)(void const *, double const * xa, double const * ya, unsigned int size, double x, gsl_interp_accel *, double * y))$a_eval;"
		end

	c_set_eval_deriv (tmp: POINTER; a_eval_deriv: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_interp_type_113 *)$tmp)->eval_deriv = (int( *)(void const *, double const * xa, double const * ya, unsigned int size, double x, gsl_interp_accel *, double * y_p))$a_eval_deriv;"
		end

	c_set_eval_deriv2 (tmp: POINTER; a_eval_deriv2: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_interp_type_113 *)$tmp)->eval_deriv2 = (int( *)(void const *, double const * xa, double const * ya, unsigned int size, double x, gsl_interp_accel *, double * y_pp))$a_eval_deriv2;"
		end

	c_set_eval_integ (tmp: POINTER; a_eval_integ: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_interp_type_113 *)$tmp)->eval_integ = (int( *)(void const *, double const * xa, double const * ya, unsigned int size, gsl_interp_accel *, double a, double b, double * result))$a_eval_integ;"
		end

	c_set_free (tmp: POINTER; a_free: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_interp_type_113 *)$tmp)->free = (void( *)(void *))$a_free;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_interp_type_113);"
		end

end
