class
	PD_GSL_MONTE_MISER_PARAMS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	estimate_frac: REAL_64 assign set_estimate_frac
		do
			Result := c_estimate_frac (c_pointer)
		end

	min_calls: NATURAL_32 assign set_min_calls
		do
			Result := c_min_calls (c_pointer)
		end

	min_calls_per_bisection: NATURAL_32 assign set_min_calls_per_bisection
		do
			Result := c_min_calls_per_bisection (c_pointer)
		end

	alpha: REAL_64 assign set_alpha
		do
			Result := c_alpha (c_pointer)
		end

	dither: REAL_64 assign set_dither
		do
			Result := c_dither (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_estimate_frac (a_estimate_frac: REAL_64)
		do
			c_set_estimate_frac (c_pointer, a_estimate_frac)
		end

	set_min_calls (a_min_calls: NATURAL_32)
		do
			c_set_min_calls (c_pointer, a_min_calls)
		end

	set_min_calls_per_bisection (a_min_calls_per_bisection: NATURAL_32)
		do
			c_set_min_calls_per_bisection (c_pointer, a_min_calls_per_bisection)
		end

	set_alpha (a_alpha: REAL_64)
		do
			c_set_alpha (c_pointer, a_alpha)
		end

	set_dither (a_dither: REAL_64)
		do
			c_set_dither (c_pointer, a_dither)
		end

feature {NONE} -- C getters

	c_estimate_frac (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_monte_miser_params_30 *)$tmp)->estimate_frac;"
		end

	c_min_calls (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_monte_miser_params_30 *)$tmp)->min_calls;"
		end

	c_min_calls_per_bisection (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_monte_miser_params_30 *)$tmp)->min_calls_per_bisection;"
		end

	c_alpha (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_monte_miser_params_30 *)$tmp)->alpha;"
		end

	c_dither (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_monte_miser_params_30 *)$tmp)->dither;"
		end

feature {NONE} -- C setters

	c_set_estimate_frac (tmp: POINTER; a_estimate_frac: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_params_30 *)$tmp)->estimate_frac = $a_estimate_frac;"
		end

	c_set_min_calls (tmp: POINTER; a_min_calls: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_params_30 *)$tmp)->min_calls = $a_min_calls;"
		end

	c_set_min_calls_per_bisection (tmp: POINTER; a_min_calls_per_bisection: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_params_30 *)$tmp)->min_calls_per_bisection = $a_min_calls_per_bisection;"
		end

	c_set_alpha (tmp: POINTER; a_alpha: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_params_30 *)$tmp)->alpha = $a_alpha;"
		end

	c_set_dither (tmp: POINTER; a_dither: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_params_30 *)$tmp)->dither = $a_dither;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_monte_miser_params_30);"
		end

end
