class
	PD_GSL_MONTE_MISER_STATE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	min_calls: NATURAL_32 assign set_min_calls
		do
			Result := c_min_calls (c_pointer)
		end

	min_calls_per_bisection: NATURAL_32 assign set_min_calls_per_bisection
		do
			Result := c_min_calls_per_bisection (c_pointer)
		end

	dither: REAL_64 assign set_dither
		do
			Result := c_dither (c_pointer)
		end

	estimate_frac: REAL_64 assign set_estimate_frac
		do
			Result := c_estimate_frac (c_pointer)
		end

	alpha: REAL_64 assign set_alpha
		do
			Result := c_alpha (c_pointer)
		end

	dim: NATURAL_32 assign set_dim
		do
			Result := c_dim (c_pointer)
		end

	estimate_style: INTEGER_32 assign set_estimate_style
		do
			Result := c_estimate_style (c_pointer)
		end

	depth: INTEGER_32 assign set_depth
		do
			Result := c_depth (c_pointer)
		end

	verbose: INTEGER_32 assign set_verbose
		do
			Result := c_verbose (c_pointer)
		end

	x: CE_POINTER [REAL_64] assign set_x
		do
			create Result.make_shared (c_x (c_pointer))
		end

	xmid: CE_POINTER [REAL_64] assign set_xmid
		do
			create Result.make_shared (c_xmid (c_pointer))
		end

	sigma_l: CE_POINTER [REAL_64] assign set_sigma_l
		do
			create Result.make_shared (c_sigma_l (c_pointer))
		end

	sigma_r: CE_POINTER [REAL_64] assign set_sigma_r
		do
			create Result.make_shared (c_sigma_r (c_pointer))
		end

	fmax_l: CE_POINTER [REAL_64] assign set_fmax_l
		do
			create Result.make_shared (c_fmax_l (c_pointer))
		end

	fmax_r: CE_POINTER [REAL_64] assign set_fmax_r
		do
			create Result.make_shared (c_fmax_r (c_pointer))
		end

	fmin_l: CE_POINTER [REAL_64] assign set_fmin_l
		do
			create Result.make_shared (c_fmin_l (c_pointer))
		end

	fmin_r: CE_POINTER [REAL_64] assign set_fmin_r
		do
			create Result.make_shared (c_fmin_r (c_pointer))
		end

	fsum_l: CE_POINTER [REAL_64] assign set_fsum_l
		do
			create Result.make_shared (c_fsum_l (c_pointer))
		end

	fsum_r: CE_POINTER [REAL_64] assign set_fsum_r
		do
			create Result.make_shared (c_fsum_r (c_pointer))
		end

	fsum2_l: CE_POINTER [REAL_64] assign set_fsum2_l
		do
			create Result.make_shared (c_fsum2_l (c_pointer))
		end

	fsum2_r: CE_POINTER [REAL_64] assign set_fsum2_r
		do
			create Result.make_shared (c_fsum2_r (c_pointer))
		end

	hits_l: CE_POINTER [NATURAL_32] assign set_hits_l
		do
			create Result.make_shared (c_hits_l (c_pointer))
		end

	hits_r: CE_POINTER [NATURAL_32] assign set_hits_r
		do
			create Result.make_shared (c_hits_r (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_min_calls (a_min_calls: NATURAL_32)
		do
			c_set_min_calls (c_pointer, a_min_calls)
		end

	set_min_calls_per_bisection (a_min_calls_per_bisection: NATURAL_32)
		do
			c_set_min_calls_per_bisection (c_pointer, a_min_calls_per_bisection)
		end

	set_dither (a_dither: REAL_64)
		do
			c_set_dither (c_pointer, a_dither)
		end

	set_estimate_frac (a_estimate_frac: REAL_64)
		do
			c_set_estimate_frac (c_pointer, a_estimate_frac)
		end

	set_alpha (a_alpha: REAL_64)
		do
			c_set_alpha (c_pointer, a_alpha)
		end

	set_dim (a_dim: NATURAL_32)
		do
			c_set_dim (c_pointer, a_dim)
		end

	set_estimate_style (a_estimate_style: INTEGER_32)
		do
			c_set_estimate_style (c_pointer, a_estimate_style)
		end

	set_depth (a_depth: INTEGER_32)
		do
			c_set_depth (c_pointer, a_depth)
		end

	set_verbose (a_verbose: INTEGER_32)
		do
			c_set_verbose (c_pointer, a_verbose)
		end

	set_x (a_x: CE_POINTER [REAL_64])
		do
			c_set_x (c_pointer, a_x.c_pointer)
		end

	set_xmid (a_xmid: CE_POINTER [REAL_64])
		do
			c_set_xmid (c_pointer, a_xmid.c_pointer)
		end

	set_sigma_l (a_sigma_l: CE_POINTER [REAL_64])
		do
			c_set_sigma_l (c_pointer, a_sigma_l.c_pointer)
		end

	set_sigma_r (a_sigma_r: CE_POINTER [REAL_64])
		do
			c_set_sigma_r (c_pointer, a_sigma_r.c_pointer)
		end

	set_fmax_l (a_fmax_l: CE_POINTER [REAL_64])
		do
			c_set_fmax_l (c_pointer, a_fmax_l.c_pointer)
		end

	set_fmax_r (a_fmax_r: CE_POINTER [REAL_64])
		do
			c_set_fmax_r (c_pointer, a_fmax_r.c_pointer)
		end

	set_fmin_l (a_fmin_l: CE_POINTER [REAL_64])
		do
			c_set_fmin_l (c_pointer, a_fmin_l.c_pointer)
		end

	set_fmin_r (a_fmin_r: CE_POINTER [REAL_64])
		do
			c_set_fmin_r (c_pointer, a_fmin_r.c_pointer)
		end

	set_fsum_l (a_fsum_l: CE_POINTER [REAL_64])
		do
			c_set_fsum_l (c_pointer, a_fsum_l.c_pointer)
		end

	set_fsum_r (a_fsum_r: CE_POINTER [REAL_64])
		do
			c_set_fsum_r (c_pointer, a_fsum_r.c_pointer)
		end

	set_fsum2_l (a_fsum2_l: CE_POINTER [REAL_64])
		do
			c_set_fsum2_l (c_pointer, a_fsum2_l.c_pointer)
		end

	set_fsum2_r (a_fsum2_r: CE_POINTER [REAL_64])
		do
			c_set_fsum2_r (c_pointer, a_fsum2_r.c_pointer)
		end

	set_hits_l (a_hits_l: CE_POINTER [NATURAL_32])
		do
			c_set_hits_l (c_pointer, a_hits_l.c_pointer)
		end

	set_hits_r (a_hits_r: CE_POINTER [NATURAL_32])
		do
			c_set_hits_r (c_pointer, a_hits_r.c_pointer)
		end

feature {NONE} -- C getters

	c_min_calls (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->min_calls;"
		end

	c_min_calls_per_bisection (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->min_calls_per_bisection;"
		end

	c_dither (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->dither;"
		end

	c_estimate_frac (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->estimate_frac;"
		end

	c_alpha (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->alpha;"
		end

	c_dim (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->dim;"
		end

	c_estimate_style (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->estimate_style;"
		end

	c_depth (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->depth;"
		end

	c_verbose (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->verbose;"
		end

	c_x (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->x;"
		end

	c_xmid (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->xmid;"
		end

	c_sigma_l (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->sigma_l;"
		end

	c_sigma_r (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->sigma_r;"
		end

	c_fmax_l (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->fmax_l;"
		end

	c_fmax_r (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->fmax_r;"
		end

	c_fmin_l (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->fmin_l;"
		end

	c_fmin_r (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->fmin_r;"
		end

	c_fsum_l (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->fsum_l;"
		end

	c_fsum_r (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->fsum_r;"
		end

	c_fsum2_l (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->fsum2_l;"
		end

	c_fsum2_r (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->fsum2_r;"
		end

	c_hits_l (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned int *)((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->hits_l;"
		end

	c_hits_r (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned int *)((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->hits_r;"
		end

feature {NONE} -- C setters

	c_set_min_calls (tmp: POINTER; a_min_calls: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->min_calls = $a_min_calls;"
		end

	c_set_min_calls_per_bisection (tmp: POINTER; a_min_calls_per_bisection: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->min_calls_per_bisection = $a_min_calls_per_bisection;"
		end

	c_set_dither (tmp: POINTER; a_dither: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->dither = $a_dither;"
		end

	c_set_estimate_frac (tmp: POINTER; a_estimate_frac: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->estimate_frac = $a_estimate_frac;"
		end

	c_set_alpha (tmp: POINTER; a_alpha: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->alpha = $a_alpha;"
		end

	c_set_dim (tmp: POINTER; a_dim: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->dim = $a_dim;"
		end

	c_set_estimate_style (tmp: POINTER; a_estimate_style: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->estimate_style = $a_estimate_style;"
		end

	c_set_depth (tmp: POINTER; a_depth: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->depth = $a_depth;"
		end

	c_set_verbose (tmp: POINTER; a_verbose: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->verbose = $a_verbose;"
		end

	c_set_x (tmp: POINTER; a_x: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->x = (double *)$a_x;"
		end

	c_set_xmid (tmp: POINTER; a_xmid: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->xmid = (double *)$a_xmid;"
		end

	c_set_sigma_l (tmp: POINTER; a_sigma_l: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->sigma_l = (double *)$a_sigma_l;"
		end

	c_set_sigma_r (tmp: POINTER; a_sigma_r: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->sigma_r = (double *)$a_sigma_r;"
		end

	c_set_fmax_l (tmp: POINTER; a_fmax_l: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->fmax_l = (double *)$a_fmax_l;"
		end

	c_set_fmax_r (tmp: POINTER; a_fmax_r: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->fmax_r = (double *)$a_fmax_r;"
		end

	c_set_fmin_l (tmp: POINTER; a_fmin_l: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->fmin_l = (double *)$a_fmin_l;"
		end

	c_set_fmin_r (tmp: POINTER; a_fmin_r: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->fmin_r = (double *)$a_fmin_r;"
		end

	c_set_fsum_l (tmp: POINTER; a_fsum_l: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->fsum_l = (double *)$a_fsum_l;"
		end

	c_set_fsum_r (tmp: POINTER; a_fsum_r: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->fsum_r = (double *)$a_fsum_r;"
		end

	c_set_fsum2_l (tmp: POINTER; a_fsum2_l: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->fsum2_l = (double *)$a_fsum2_l;"
		end

	c_set_fsum2_r (tmp: POINTER; a_fsum2_r: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->fsum2_r = (double *)$a_fsum2_r;"
		end

	c_set_hits_l (tmp: POINTER; a_hits_l: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->hits_l = (unsigned int *)$a_hits_l;"
		end

	c_set_hits_r (tmp: POINTER; a_hits_r: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_miser_state_29 *)$tmp)->hits_r = (unsigned int *)$a_hits_r;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_monte_miser_state_29);"
		end

end
