class
	PD_GSL_MULTIFIT_FUNCTION_STRUCT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	f: CE_ROUTINE assign set_f
		do
			create Result.make_shared (c_f (c_pointer))
		end

	n: NATURAL_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	p: NATURAL_32 assign set_p
		do
			Result := c_p (c_pointer)
		end

	params: CE_POINTER [ANY] assign set_params
		do
			create Result.make_shared (c_params (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_f (a_f: CE_ROUTINE)
		do
			c_set_f (c_pointer, a_f.c_pointer)
		end

	set_n (a_n: NATURAL_32)
		do
			c_set_n (c_pointer, a_n)
		end

	set_p (a_p: NATURAL_32)
		do
			c_set_p (c_pointer, a_p)
		end

	set_params (a_params: CE_POINTER [ANY])
		do
			c_set_params (c_pointer, a_params.c_pointer)
		end

feature {NONE} -- C getters

	c_f (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(gsl_vector * x, void * params, gsl_vector * f))((struct gsl_multifit_function_struct *)$tmp)->f;"
		end

	c_n (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct gsl_multifit_function_struct *)$tmp)->n;"
		end

	c_p (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct gsl_multifit_function_struct *)$tmp)->p;"
		end

	c_params (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct gsl_multifit_function_struct *)$tmp)->params;"
		end

feature {NONE} -- C setters

	c_set_f (tmp: POINTER; a_f: POINTER)
		external
			"C inline"
		alias
			"((struct gsl_multifit_function_struct *)$tmp)->f = (int( *)(gsl_vector * x, void * params, gsl_vector * f))$a_f;"
		end

	c_set_n (tmp: POINTER; a_n: NATURAL_32)
		external
			"C inline"
		alias
			"((struct gsl_multifit_function_struct *)$tmp)->n = $a_n;"
		end

	c_set_p (tmp: POINTER; a_p: NATURAL_32)
		external
			"C inline"
		alias
			"((struct gsl_multifit_function_struct *)$tmp)->p = $a_p;"
		end

	c_set_params (tmp: POINTER; a_params: POINTER)
		external
			"C inline"
		alias
			"((struct gsl_multifit_function_struct *)$tmp)->params = (void *)$a_params;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct gsl_multifit_function_struct);"
		end

end
