class
	PD_GSL_MULTISET_STRUCT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	n: NATURAL_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	k: NATURAL_32 assign set_k
		do
			Result := c_k (c_pointer)
		end

	data: CE_POINTER [NATURAL_32] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_n (a_n: NATURAL_32)
		do
			c_set_n (c_pointer, a_n)
		end

	set_k (a_k: NATURAL_32)
		do
			c_set_k (c_pointer, a_k)
		end

	set_data (a_data: CE_POINTER [NATURAL_32])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

feature {NONE} -- C getters

	c_n (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct gsl_multiset_struct *)$tmp)->n;"
		end

	c_k (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct gsl_multiset_struct *)$tmp)->k;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned int *)((struct gsl_multiset_struct *)$tmp)->data;"
		end

feature {NONE} -- C setters

	c_set_n (tmp: POINTER; a_n: NATURAL_32)
		external
			"C inline"
		alias
			"((struct gsl_multiset_struct *)$tmp)->n = $a_n;"
		end

	c_set_k (tmp: POINTER; a_k: NATURAL_32)
		external
			"C inline"
		alias
			"((struct gsl_multiset_struct *)$tmp)->k = $a_k;"
		end

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct gsl_multiset_struct *)$tmp)->data = (unsigned int *)$a_data;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct gsl_multiset_struct);"
		end

end
