class
	PD_GSL_ODEIV_EVOLVE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	dimension: NATURAL_32 assign set_dimension
		do
			Result := c_dimension (c_pointer)
		end

	y0: CE_POINTER [REAL_64] assign set_y0
		do
			create Result.make_shared (c_y0 (c_pointer))
		end

	yerr: CE_POINTER [REAL_64] assign set_yerr
		do
			create Result.make_shared (c_yerr (c_pointer))
		end

	dydt_in: CE_POINTER [REAL_64] assign set_dydt_in
		do
			create Result.make_shared (c_dydt_in (c_pointer))
		end

	dydt_out: CE_POINTER [REAL_64] assign set_dydt_out
		do
			create Result.make_shared (c_dydt_out (c_pointer))
		end

	last_step: REAL_64 assign set_last_step
		do
			Result := c_last_step (c_pointer)
		end

	count: NATURAL_32 assign set_count
		do
			Result := c_count (c_pointer)
		end

	failed_steps: NATURAL_32 assign set_failed_steps
		do
			Result := c_failed_steps (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_dimension (a_dimension: NATURAL_32)
		do
			c_set_dimension (c_pointer, a_dimension)
		end

	set_y0 (a_y0: CE_POINTER [REAL_64])
		do
			c_set_y0 (c_pointer, a_y0.c_pointer)
		end

	set_yerr (a_yerr: CE_POINTER [REAL_64])
		do
			c_set_yerr (c_pointer, a_yerr.c_pointer)
		end

	set_dydt_in (a_dydt_in: CE_POINTER [REAL_64])
		do
			c_set_dydt_in (c_pointer, a_dydt_in.c_pointer)
		end

	set_dydt_out (a_dydt_out: CE_POINTER [REAL_64])
		do
			c_set_dydt_out (c_pointer, a_dydt_out.c_pointer)
		end

	set_last_step (a_last_step: REAL_64)
		do
			c_set_last_step (c_pointer, a_last_step)
		end

	set_count (a_count: NATURAL_32)
		do
			c_set_count (c_pointer, a_count)
		end

	set_failed_steps (a_failed_steps: NATURAL_32)
		do
			c_set_failed_steps (c_pointer, a_failed_steps)
		end

feature {NONE} -- C getters

	c_dimension (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_odeiv_evolve_31 *)$tmp)->dimension;"
		end

	c_y0 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_odeiv_evolve_31 *)$tmp)->y0;"
		end

	c_yerr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_odeiv_evolve_31 *)$tmp)->yerr;"
		end

	c_dydt_in (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_odeiv_evolve_31 *)$tmp)->dydt_in;"
		end

	c_dydt_out (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_odeiv_evolve_31 *)$tmp)->dydt_out;"
		end

	c_last_step (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_odeiv_evolve_31 *)$tmp)->last_step;"
		end

	c_count (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_gsl_odeiv_evolve_31 *)$tmp)->count;"
		end

	c_failed_steps (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_gsl_odeiv_evolve_31 *)$tmp)->failed_steps;"
		end

feature {NONE} -- C setters

	c_set_dimension (tmp: POINTER; a_dimension: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_evolve_31 *)$tmp)->dimension = $a_dimension;"
		end

	c_set_y0 (tmp: POINTER; a_y0: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_evolve_31 *)$tmp)->y0 = (double *)$a_y0;"
		end

	c_set_yerr (tmp: POINTER; a_yerr: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_evolve_31 *)$tmp)->yerr = (double *)$a_yerr;"
		end

	c_set_dydt_in (tmp: POINTER; a_dydt_in: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_evolve_31 *)$tmp)->dydt_in = (double *)$a_dydt_in;"
		end

	c_set_dydt_out (tmp: POINTER; a_dydt_out: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_evolve_31 *)$tmp)->dydt_out = (double *)$a_dydt_out;"
		end

	c_set_last_step (tmp: POINTER; a_last_step: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_evolve_31 *)$tmp)->last_step = $a_last_step;"
		end

	c_set_count (tmp: POINTER; a_count: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_evolve_31 *)$tmp)->count = $a_count;"
		end

	c_set_failed_steps (tmp: POINTER; a_failed_steps: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_evolve_31 *)$tmp)->failed_steps = $a_failed_steps;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_odeiv_evolve_31);"
		end

end
