class
	PD_GSL_ODEIV_SYSTEM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	function: CE_ROUTINE assign set_function
		do
			create Result.make_shared (c_function (c_pointer))
		end

	jacobian: CE_ROUTINE assign set_jacobian
		do
			create Result.make_shared (c_jacobian (c_pointer))
		end

	dimension: NATURAL_32 assign set_dimension
		do
			Result := c_dimension (c_pointer)
		end

	params: CE_POINTER [ANY] assign set_params
		do
			create Result.make_shared (c_params (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_function (a_function: CE_ROUTINE)
		do
			c_set_function (c_pointer, a_function.c_pointer)
		end

	set_jacobian (a_jacobian: CE_ROUTINE)
		do
			c_set_jacobian (c_pointer, a_jacobian.c_pointer)
		end

	set_dimension (a_dimension: NATURAL_32)
		do
			c_set_dimension (c_pointer, a_dimension)
		end

	set_params (a_params: CE_POINTER [ANY])
		do
			c_set_params (c_pointer, a_params.c_pointer)
		end

feature {NONE} -- C getters

	c_function (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(double t, double * y, double * dydt, void * params))((struct __anonstruct_gsl_odeiv_system_24 *)$tmp)->function;"
		end

	c_jacobian (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(double t, double * y, double * dfdy, double * dfdt, void * params))((struct __anonstruct_gsl_odeiv_system_24 *)$tmp)->jacobian;"
		end

	c_dimension (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_odeiv_system_24 *)$tmp)->dimension;"
		end

	c_params (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_gsl_odeiv_system_24 *)$tmp)->params;"
		end

feature {NONE} -- C setters

	c_set_function (tmp: POINTER; a_function: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_system_24 *)$tmp)->function = (int( *)(double t, double const * y, double * dydt, void * params))$a_function;"
		end

	c_set_jacobian (tmp: POINTER; a_jacobian: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_system_24 *)$tmp)->jacobian = (int( *)(double t, double const * y, double * dfdy, double * dfdt, void * params))$a_jacobian;"
		end

	c_set_dimension (tmp: POINTER; a_dimension: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_system_24 *)$tmp)->dimension = $a_dimension;"
		end

	c_set_params (tmp: POINTER; a_params: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_system_24 *)$tmp)->params = (void *)$a_params;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_odeiv_system_24);"
		end

end
