class
	PD_GSL_SF_MATHIEU_WORKSPACE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	even_order: NATURAL_32 assign set_even_order
		do
			Result := c_even_order (c_pointer)
		end

	odd_order: NATURAL_32 assign set_odd_order
		do
			Result := c_odd_order (c_pointer)
		end

	extra_values: INTEGER_32 assign set_extra_values
		do
			Result := c_extra_values (c_pointer)
		end

	qa: REAL_64 assign set_qa
		do
			Result := c_qa (c_pointer)
		end

	qb: REAL_64 assign set_qb
		do
			Result := c_qb (c_pointer)
		end

	aa: CE_POINTER [REAL_64] assign set_aa
		do
			create Result.make_shared (c_aa (c_pointer))
		end

	bb: CE_POINTER [REAL_64] assign set_bb
		do
			create Result.make_shared (c_bb (c_pointer))
		end

	dd: CE_POINTER [REAL_64] assign set_dd
		do
			create Result.make_shared (c_dd (c_pointer))
		end

	ee: CE_POINTER [REAL_64] assign set_ee
		do
			create Result.make_shared (c_ee (c_pointer))
		end

	tt: CE_POINTER [REAL_64] assign set_tt
		do
			create Result.make_shared (c_tt (c_pointer))
		end

	e2: CE_POINTER [REAL_64] assign set_e2
		do
			create Result.make_shared (c_e2 (c_pointer))
		end

	zz: CE_POINTER [REAL_64] assign set_zz
		do
			create Result.make_shared (c_zz (c_pointer))
		end

	eval: CE_POINTER [PD_GSL_VECTOR] assign set_eval
		do
			create Result.make_shared (c_eval (c_pointer))
		end

	evec: CE_POINTER [PD_GSL_MATRIX] assign set_evec
		do
			create Result.make_shared (c_evec (c_pointer))
		end

	wmat: CE_POINTER [PD_GSL_EIGEN_SYMMV_WORKSPACE] assign set_wmat
		do
			create Result.make_shared (c_wmat (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_even_order (a_even_order: NATURAL_32)
		do
			c_set_even_order (c_pointer, a_even_order)
		end

	set_odd_order (a_odd_order: NATURAL_32)
		do
			c_set_odd_order (c_pointer, a_odd_order)
		end

	set_extra_values (a_extra_values: INTEGER_32)
		do
			c_set_extra_values (c_pointer, a_extra_values)
		end

	set_qa (a_qa: REAL_64)
		do
			c_set_qa (c_pointer, a_qa)
		end

	set_qb (a_qb: REAL_64)
		do
			c_set_qb (c_pointer, a_qb)
		end

	set_aa (a_aa: CE_POINTER [REAL_64])
		do
			c_set_aa (c_pointer, a_aa.c_pointer)
		end

	set_bb (a_bb: CE_POINTER [REAL_64])
		do
			c_set_bb (c_pointer, a_bb.c_pointer)
		end

	set_dd (a_dd: CE_POINTER [REAL_64])
		do
			c_set_dd (c_pointer, a_dd.c_pointer)
		end

	set_ee (a_ee: CE_POINTER [REAL_64])
		do
			c_set_ee (c_pointer, a_ee.c_pointer)
		end

	set_tt (a_tt: CE_POINTER [REAL_64])
		do
			c_set_tt (c_pointer, a_tt.c_pointer)
		end

	set_e2 (a_e2: CE_POINTER [REAL_64])
		do
			c_set_e2 (c_pointer, a_e2.c_pointer)
		end

	set_zz (a_zz: CE_POINTER [REAL_64])
		do
			c_set_zz (c_pointer, a_zz.c_pointer)
		end

	set_eval (a_eval: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_eval (c_pointer, a_eval.c_pointer)
		end

	set_evec (a_evec: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_evec (c_pointer, a_evec.c_pointer)
		end

	set_wmat (a_wmat: CE_POINTER [PD_GSL_EIGEN_SYMMV_WORKSPACE])
		do
			c_set_wmat (c_pointer, a_wmat.c_pointer)
		end

feature {NONE} -- C getters

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->size;"
		end

	c_even_order (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->even_order;"
		end

	c_odd_order (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->odd_order;"
		end

	c_extra_values (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->extra_values;"
		end

	c_qa (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->qa;"
		end

	c_qb (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->qb;"
		end

	c_aa (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->aa;"
		end

	c_bb (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->bb;"
		end

	c_dd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->dd;"
		end

	c_ee (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->ee;"
		end

	c_tt (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->tt;"
		end

	c_e2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->e2;"
		end

	c_zz (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->zz;"
		end

	c_eval (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->eval;"
		end

	c_evec (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->evec;"
		end

	c_wmat (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_eigen_symmv_workspace *)((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->wmat;"
		end

feature {NONE} -- C setters

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->size = $a_size;"
		end

	c_set_even_order (tmp: POINTER; a_even_order: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->even_order = $a_even_order;"
		end

	c_set_odd_order (tmp: POINTER; a_odd_order: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->odd_order = $a_odd_order;"
		end

	c_set_extra_values (tmp: POINTER; a_extra_values: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->extra_values = $a_extra_values;"
		end

	c_set_qa (tmp: POINTER; a_qa: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->qa = $a_qa;"
		end

	c_set_qb (tmp: POINTER; a_qb: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->qb = $a_qb;"
		end

	c_set_aa (tmp: POINTER; a_aa: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->aa = (double *)$a_aa;"
		end

	c_set_bb (tmp: POINTER; a_bb: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->bb = (double *)$a_bb;"
		end

	c_set_dd (tmp: POINTER; a_dd: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->dd = (double *)$a_dd;"
		end

	c_set_ee (tmp: POINTER; a_ee: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->ee = (double *)$a_ee;"
		end

	c_set_tt (tmp: POINTER; a_tt: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->tt = (double *)$a_tt;"
		end

	c_set_e2 (tmp: POINTER; a_e2: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->e2 = (double *)$a_e2;"
		end

	c_set_zz (tmp: POINTER; a_zz: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->zz = (double *)$a_zz;"
		end

	c_set_eval (tmp: POINTER; a_eval: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->eval = (gsl_vector *)$a_eval;"
		end

	c_set_evec (tmp: POINTER; a_evec: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->evec = (gsl_matrix *)$a_evec;"
		end

	c_set_wmat (tmp: POINTER; a_wmat: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sf_mathieu_workspace_127 *)$tmp)->wmat = (gsl_eigen_symmv_workspace *)$a_wmat;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_sf_mathieu_workspace_127);"
		end

end
