class
	PD_GSL_SPLINE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	interp: CE_POINTER [PD_GSL_INTERP] assign set_interp
		do
			create Result.make_shared (c_interp (c_pointer))
		end

	x: CE_POINTER [REAL_64] assign set_x
		do
			create Result.make_shared (c_x (c_pointer))
		end

	y: CE_POINTER [REAL_64] assign set_y
		do
			create Result.make_shared (c_y (c_pointer))
		end

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_interp (a_interp: CE_POINTER [PD_GSL_INTERP])
		do
			c_set_interp (c_pointer, a_interp.c_pointer)
		end

	set_x (a_x: CE_POINTER [REAL_64])
		do
			c_set_x (c_pointer, a_x.c_pointer)
		end

	set_y (a_y: CE_POINTER [REAL_64])
		do
			c_set_y (c_pointer, a_y.c_pointer)
		end

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

feature {NONE} -- C getters

	c_interp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_interp *)((struct __anonstruct_gsl_spline_27 *)$tmp)->interp;"
		end

	c_x (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_spline_27 *)$tmp)->x;"
		end

	c_y (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_spline_27 *)$tmp)->y;"
		end

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_spline_27 *)$tmp)->size;"
		end

feature {NONE} -- C setters

	c_set_interp (tmp: POINTER; a_interp: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_spline_27 *)$tmp)->interp = (gsl_interp *)$a_interp;"
		end

	c_set_x (tmp: POINTER; a_x: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_spline_27 *)$tmp)->x = (double *)$a_x;"
		end

	c_set_y (tmp: POINTER; a_y: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_spline_27 *)$tmp)->y = (double *)$a_y;"
		end

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_spline_27 *)$tmp)->size = $a_size;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_spline_27);"
		end

end
