class
	PD_GSL_VECTOR

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	stride: NATURAL_32 assign set_stride
		do
			Result := c_stride (c_pointer)
		end

	data: CE_POINTER [REAL_64] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	block: CE_POINTER [PD_GSL_BLOCK_STRUCT] assign set_block
		do
			create Result.make_shared (c_block (c_pointer))
		end

	owner: INTEGER_32 assign set_owner
		do
			Result := c_owner (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_stride (a_stride: NATURAL_32)
		do
			c_set_stride (c_pointer, a_stride)
		end

	set_data (a_data: CE_POINTER [REAL_64])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_block (a_block: CE_POINTER [PD_GSL_BLOCK_STRUCT])
		do
			c_set_block (c_pointer, a_block.c_pointer)
		end

	set_owner (a_owner: INTEGER_32)
		do
			c_set_owner (c_pointer, a_owner)
		end

feature {NONE} -- C getters

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_vector_35 *)$tmp)->size;"
		end

	c_stride (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_vector_35 *)$tmp)->stride;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_vector_35 *)$tmp)->data;"
		end

	c_block (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct gsl_block_struct *)((struct __anonstruct_gsl_vector_35 *)$tmp)->block;"
		end

	c_owner (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_vector_35 *)$tmp)->owner;"
		end

feature {NONE} -- C setters

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_vector_35 *)$tmp)->size = $a_size;"
		end

	c_set_stride (tmp: POINTER; a_stride: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_vector_35 *)$tmp)->stride = $a_stride;"
		end

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_vector_35 *)$tmp)->data = (double *)$a_data;"
		end

	c_set_block (tmp: POINTER; a_block: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_vector_35 *)$tmp)->block = (struct gsl_block_struct *)$a_block;"
		end

	c_set_owner (tmp: POINTER; a_owner: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_vector_35 *)$tmp)->owner = $a_owner;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_vector_35);"
		end

end
