class
	PD_HYBRID_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	iter: NATURAL_32 assign set_iter
		do
			Result := c_iter (c_pointer)
		end

	ncfail: NATURAL_32 assign set_ncfail
		do
			Result := c_ncfail (c_pointer)
		end

	ncsuc: NATURAL_32 assign set_ncsuc
		do
			Result := c_ncsuc (c_pointer)
		end

	nslow1: NATURAL_32 assign set_nslow1
		do
			Result := c_nslow1 (c_pointer)
		end

	nslow2: NATURAL_32 assign set_nslow2
		do
			Result := c_nslow2 (c_pointer)
		end

	fnorm: REAL_64 assign set_fnorm
		do
			Result := c_fnorm (c_pointer)
		end

	delta: REAL_64 assign set_delta
		do
			Result := c_delta (c_pointer)
		end

	J: CE_POINTER [PD_GSL_MATRIX] assign set_J
		do
			create Result.make_shared (c_J (c_pointer))
		end

	q: CE_POINTER [PD_GSL_MATRIX] assign set_q
		do
			create Result.make_shared (c_q (c_pointer))
		end

	r: CE_POINTER [PD_GSL_MATRIX] assign set_r
		do
			create Result.make_shared (c_r (c_pointer))
		end

	tau: CE_POINTER [PD_GSL_VECTOR] assign set_tau
		do
			create Result.make_shared (c_tau (c_pointer))
		end

	diag: CE_POINTER [PD_GSL_VECTOR] assign set_diag
		do
			create Result.make_shared (c_diag (c_pointer))
		end

	qtf: CE_POINTER [PD_GSL_VECTOR] assign set_qtf
		do
			create Result.make_shared (c_qtf (c_pointer))
		end

	newton: CE_POINTER [PD_GSL_VECTOR] assign set_newton
		do
			create Result.make_shared (c_newton (c_pointer))
		end

	gradient: CE_POINTER [PD_GSL_VECTOR] assign set_gradient
		do
			create Result.make_shared (c_gradient (c_pointer))
		end

	x_trial: CE_POINTER [PD_GSL_VECTOR] assign set_x_trial
		do
			create Result.make_shared (c_x_trial (c_pointer))
		end

	f_trial: CE_POINTER [PD_GSL_VECTOR] assign set_f_trial
		do
			create Result.make_shared (c_f_trial (c_pointer))
		end

	df: CE_POINTER [PD_GSL_VECTOR] assign set_df
		do
			create Result.make_shared (c_df (c_pointer))
		end

	qtdf: CE_POINTER [PD_GSL_VECTOR] assign set_qtdf
		do
			create Result.make_shared (c_qtdf (c_pointer))
		end

	rdx: CE_POINTER [PD_GSL_VECTOR] assign set_rdx
		do
			create Result.make_shared (c_rdx (c_pointer))
		end

	w: CE_POINTER [PD_GSL_VECTOR] assign set_w
		do
			create Result.make_shared (c_w (c_pointer))
		end

	v: CE_POINTER [PD_GSL_VECTOR] assign set_v
		do
			create Result.make_shared (c_v (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_iter (a_iter: NATURAL_32)
		do
			c_set_iter (c_pointer, a_iter)
		end

	set_ncfail (a_ncfail: NATURAL_32)
		do
			c_set_ncfail (c_pointer, a_ncfail)
		end

	set_ncsuc (a_ncsuc: NATURAL_32)
		do
			c_set_ncsuc (c_pointer, a_ncsuc)
		end

	set_nslow1 (a_nslow1: NATURAL_32)
		do
			c_set_nslow1 (c_pointer, a_nslow1)
		end

	set_nslow2 (a_nslow2: NATURAL_32)
		do
			c_set_nslow2 (c_pointer, a_nslow2)
		end

	set_fnorm (a_fnorm: REAL_64)
		do
			c_set_fnorm (c_pointer, a_fnorm)
		end

	set_delta (a_delta: REAL_64)
		do
			c_set_delta (c_pointer, a_delta)
		end

	set_J (a_J: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_J (c_pointer, a_J.c_pointer)
		end

	set_q (a_q: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_q (c_pointer, a_q.c_pointer)
		end

	set_r (a_r: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_r (c_pointer, a_r.c_pointer)
		end

	set_tau (a_tau: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_tau (c_pointer, a_tau.c_pointer)
		end

	set_diag (a_diag: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_diag (c_pointer, a_diag.c_pointer)
		end

	set_qtf (a_qtf: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_qtf (c_pointer, a_qtf.c_pointer)
		end

	set_newton (a_newton: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_newton (c_pointer, a_newton.c_pointer)
		end

	set_gradient (a_gradient: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_gradient (c_pointer, a_gradient.c_pointer)
		end

	set_x_trial (a_x_trial: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_x_trial (c_pointer, a_x_trial.c_pointer)
		end

	set_f_trial (a_f_trial: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_f_trial (c_pointer, a_f_trial.c_pointer)
		end

	set_df (a_df: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_df (c_pointer, a_df.c_pointer)
		end

	set_qtdf (a_qtdf: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_qtdf (c_pointer, a_qtdf.c_pointer)
		end

	set_rdx (a_rdx: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_rdx (c_pointer, a_rdx.c_pointer)
		end

	set_w (a_w: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_w (c_pointer, a_w.c_pointer)
		end

	set_v (a_v: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_v (c_pointer, a_v.c_pointer)
		end

feature {NONE} -- C getters

	c_iter (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_hybrid_state_t_118 *)$tmp)->iter;"
		end

	c_ncfail (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_hybrid_state_t_118 *)$tmp)->ncfail;"
		end

	c_ncsuc (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_hybrid_state_t_118 *)$tmp)->ncsuc;"
		end

	c_nslow1 (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_hybrid_state_t_118 *)$tmp)->nslow1;"
		end

	c_nslow2 (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_hybrid_state_t_118 *)$tmp)->nslow2;"
		end

	c_fnorm (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_hybrid_state_t_118 *)$tmp)->fnorm;"
		end

	c_delta (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_hybrid_state_t_118 *)$tmp)->delta;"
		end

	c_J (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_hybrid_state_t_118 *)$tmp)->J;"
		end

	c_q (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_hybrid_state_t_118 *)$tmp)->q;"
		end

	c_r (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_hybrid_state_t_118 *)$tmp)->r;"
		end

	c_tau (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_hybrid_state_t_118 *)$tmp)->tau;"
		end

	c_diag (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_hybrid_state_t_118 *)$tmp)->diag;"
		end

	c_qtf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_hybrid_state_t_118 *)$tmp)->qtf;"
		end

	c_newton (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_hybrid_state_t_118 *)$tmp)->newton;"
		end

	c_gradient (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_hybrid_state_t_118 *)$tmp)->gradient;"
		end

	c_x_trial (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_hybrid_state_t_118 *)$tmp)->x_trial;"
		end

	c_f_trial (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_hybrid_state_t_118 *)$tmp)->f_trial;"
		end

	c_df (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_hybrid_state_t_118 *)$tmp)->df;"
		end

	c_qtdf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_hybrid_state_t_118 *)$tmp)->qtdf;"
		end

	c_rdx (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_hybrid_state_t_118 *)$tmp)->rdx;"
		end

	c_w (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_hybrid_state_t_118 *)$tmp)->w;"
		end

	c_v (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_hybrid_state_t_118 *)$tmp)->v;"
		end

feature {NONE} -- C setters

	c_set_iter (tmp: POINTER; a_iter: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_hybrid_state_t_118 *)$tmp)->iter = $a_iter;"
		end

	c_set_ncfail (tmp: POINTER; a_ncfail: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_hybrid_state_t_118 *)$tmp)->ncfail = $a_ncfail;"
		end

	c_set_ncsuc (tmp: POINTER; a_ncsuc: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_hybrid_state_t_118 *)$tmp)->ncsuc = $a_ncsuc;"
		end

	c_set_nslow1 (tmp: POINTER; a_nslow1: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_hybrid_state_t_118 *)$tmp)->nslow1 = $a_nslow1;"
		end

	c_set_nslow2 (tmp: POINTER; a_nslow2: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_hybrid_state_t_118 *)$tmp)->nslow2 = $a_nslow2;"
		end

	c_set_fnorm (tmp: POINTER; a_fnorm: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_hybrid_state_t_118 *)$tmp)->fnorm = $a_fnorm;"
		end

	c_set_delta (tmp: POINTER; a_delta: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_hybrid_state_t_118 *)$tmp)->delta = $a_delta;"
		end

	c_set_J (tmp: POINTER; a_J: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_hybrid_state_t_118 *)$tmp)->J = (gsl_matrix *)$a_j;"
		end

	c_set_q (tmp: POINTER; a_q: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_hybrid_state_t_118 *)$tmp)->q = (gsl_matrix *)$a_q;"
		end

	c_set_r (tmp: POINTER; a_r: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_hybrid_state_t_118 *)$tmp)->r = (gsl_matrix *)$a_r;"
		end

	c_set_tau (tmp: POINTER; a_tau: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_hybrid_state_t_118 *)$tmp)->tau = (gsl_vector *)$a_tau;"
		end

	c_set_diag (tmp: POINTER; a_diag: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_hybrid_state_t_118 *)$tmp)->diag = (gsl_vector *)$a_diag;"
		end

	c_set_qtf (tmp: POINTER; a_qtf: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_hybrid_state_t_118 *)$tmp)->qtf = (gsl_vector *)$a_qtf;"
		end

	c_set_newton (tmp: POINTER; a_newton: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_hybrid_state_t_118 *)$tmp)->newton = (gsl_vector *)$a_newton;"
		end

	c_set_gradient (tmp: POINTER; a_gradient: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_hybrid_state_t_118 *)$tmp)->gradient = (gsl_vector *)$a_gradient;"
		end

	c_set_x_trial (tmp: POINTER; a_x_trial: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_hybrid_state_t_118 *)$tmp)->x_trial = (gsl_vector *)$a_x_trial;"
		end

	c_set_f_trial (tmp: POINTER; a_f_trial: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_hybrid_state_t_118 *)$tmp)->f_trial = (gsl_vector *)$a_f_trial;"
		end

	c_set_df (tmp: POINTER; a_df: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_hybrid_state_t_118 *)$tmp)->df = (gsl_vector *)$a_df;"
		end

	c_set_qtdf (tmp: POINTER; a_qtdf: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_hybrid_state_t_118 *)$tmp)->qtdf = (gsl_vector *)$a_qtdf;"
		end

	c_set_rdx (tmp: POINTER; a_rdx: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_hybrid_state_t_118 *)$tmp)->rdx = (gsl_vector *)$a_rdx;"
		end

	c_set_w (tmp: POINTER; a_w: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_hybrid_state_t_118 *)$tmp)->w = (gsl_vector *)$a_w;"
		end

	c_set_v (tmp: POINTER; a_v: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_hybrid_state_t_118 *)$tmp)->v = (gsl_vector *)$a_v;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_hybrid_state_t_118);"
		end

end
