class
	PD_LMDER_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	iter: NATURAL_32 assign set_iter
		do
			Result := c_iter (c_pointer)
		end

	xnorm: REAL_64 assign set_xnorm
		do
			Result := c_xnorm (c_pointer)
		end

	fnorm: REAL_64 assign set_fnorm
		do
			Result := c_fnorm (c_pointer)
		end

	delta: REAL_64 assign set_delta
		do
			Result := c_delta (c_pointer)
		end

	par: REAL_64 assign set_par
		do
			Result := c_par (c_pointer)
		end

	par_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct_lmder_state_t_118, par);"
		end

	r: CE_POINTER [PD_GSL_MATRIX] assign set_r
		do
			create Result.make_shared (c_r (c_pointer))
		end

	tau: CE_POINTER [PD_GSL_VECTOR] assign set_tau
		do
			create Result.make_shared (c_tau (c_pointer))
		end

	diag: CE_POINTER [PD_GSL_VECTOR] assign set_diag
		do
			create Result.make_shared (c_diag (c_pointer))
		end

	qtf: CE_POINTER [PD_GSL_VECTOR] assign set_qtf
		do
			create Result.make_shared (c_qtf (c_pointer))
		end

	newton: CE_POINTER [PD_GSL_VECTOR] assign set_newton
		do
			create Result.make_shared (c_newton (c_pointer))
		end

	gradient: CE_POINTER [PD_GSL_VECTOR] assign set_gradient
		do
			create Result.make_shared (c_gradient (c_pointer))
		end

	x_trial: CE_POINTER [PD_GSL_VECTOR] assign set_x_trial
		do
			create Result.make_shared (c_x_trial (c_pointer))
		end

	f_trial: CE_POINTER [PD_GSL_VECTOR] assign set_f_trial
		do
			create Result.make_shared (c_f_trial (c_pointer))
		end

	df: CE_POINTER [PD_GSL_VECTOR] assign set_df
		do
			create Result.make_shared (c_df (c_pointer))
		end

	sdiag: CE_POINTER [PD_GSL_VECTOR] assign set_sdiag
		do
			create Result.make_shared (c_sdiag (c_pointer))
		end

	rptdx: CE_POINTER [PD_GSL_VECTOR] assign set_rptdx
		do
			create Result.make_shared (c_rptdx (c_pointer))
		end

	w: CE_POINTER [PD_GSL_VECTOR] assign set_w
		do
			create Result.make_shared (c_w (c_pointer))
		end

	work1: CE_POINTER [PD_GSL_VECTOR] assign set_work1
		do
			create Result.make_shared (c_work1 (c_pointer))
		end

	perm: CE_POINTER [PD_GSL_PERMUTATION_STRUCT] assign set_perm
		do
			create Result.make_shared (c_perm (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_iter (a_iter: NATURAL_32)
		do
			c_set_iter (c_pointer, a_iter)
		end

	set_xnorm (a_xnorm: REAL_64)
		do
			c_set_xnorm (c_pointer, a_xnorm)
		end

	set_fnorm (a_fnorm: REAL_64)
		do
			c_set_fnorm (c_pointer, a_fnorm)
		end

	set_delta (a_delta: REAL_64)
		do
			c_set_delta (c_pointer, a_delta)
		end

	set_par (a_par: REAL_64)
		do
			c_set_par (c_pointer, a_par)
		end

	set_r (a_r: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_r (c_pointer, a_r.c_pointer)
		end

	set_tau (a_tau: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_tau (c_pointer, a_tau.c_pointer)
		end

	set_diag (a_diag: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_diag (c_pointer, a_diag.c_pointer)
		end

	set_qtf (a_qtf: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_qtf (c_pointer, a_qtf.c_pointer)
		end

	set_newton (a_newton: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_newton (c_pointer, a_newton.c_pointer)
		end

	set_gradient (a_gradient: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_gradient (c_pointer, a_gradient.c_pointer)
		end

	set_x_trial (a_x_trial: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_x_trial (c_pointer, a_x_trial.c_pointer)
		end

	set_f_trial (a_f_trial: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_f_trial (c_pointer, a_f_trial.c_pointer)
		end

	set_df (a_df: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_df (c_pointer, a_df.c_pointer)
		end

	set_sdiag (a_sdiag: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_sdiag (c_pointer, a_sdiag.c_pointer)
		end

	set_rptdx (a_rptdx: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_rptdx (c_pointer, a_rptdx.c_pointer)
		end

	set_w (a_w: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_w (c_pointer, a_w.c_pointer)
		end

	set_work1 (a_work1: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_work1 (c_pointer, a_work1.c_pointer)
		end

	set_perm (a_perm: CE_POINTER [PD_GSL_PERMUTATION_STRUCT])
		do
			c_set_perm (c_pointer, a_perm.c_pointer)
		end

feature {NONE} -- C getters

	c_iter (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_lmder_state_t_118 *)$tmp)->iter;"
		end

	c_xnorm (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_lmder_state_t_118 *)$tmp)->xnorm;"
		end

	c_fnorm (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_lmder_state_t_118 *)$tmp)->fnorm;"
		end

	c_delta (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_lmder_state_t_118 *)$tmp)->delta;"
		end

	c_par (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_lmder_state_t_118 *)$tmp)->par;"
		end

	c_r (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_lmder_state_t_118 *)$tmp)->r;"
		end

	c_tau (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_lmder_state_t_118 *)$tmp)->tau;"
		end

	c_diag (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_lmder_state_t_118 *)$tmp)->diag;"
		end

	c_qtf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_lmder_state_t_118 *)$tmp)->qtf;"
		end

	c_newton (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_lmder_state_t_118 *)$tmp)->newton;"
		end

	c_gradient (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_lmder_state_t_118 *)$tmp)->gradient;"
		end

	c_x_trial (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_lmder_state_t_118 *)$tmp)->x_trial;"
		end

	c_f_trial (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_lmder_state_t_118 *)$tmp)->f_trial;"
		end

	c_df (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_lmder_state_t_118 *)$tmp)->df;"
		end

	c_sdiag (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_lmder_state_t_118 *)$tmp)->sdiag;"
		end

	c_rptdx (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_lmder_state_t_118 *)$tmp)->rptdx;"
		end

	c_w (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_lmder_state_t_118 *)$tmp)->w;"
		end

	c_work1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_lmder_state_t_118 *)$tmp)->work1;"
		end

	c_perm (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct gsl_permutation_struct *)((struct __anonstruct_lmder_state_t_118 *)$tmp)->perm;"
		end

feature {NONE} -- C setters

	c_set_iter (tmp: POINTER; a_iter: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_lmder_state_t_118 *)$tmp)->iter = $a_iter;"
		end

	c_set_xnorm (tmp: POINTER; a_xnorm: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_lmder_state_t_118 *)$tmp)->xnorm = $a_xnorm;"
		end

	c_set_fnorm (tmp: POINTER; a_fnorm: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_lmder_state_t_118 *)$tmp)->fnorm = $a_fnorm;"
		end

	c_set_delta (tmp: POINTER; a_delta: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_lmder_state_t_118 *)$tmp)->delta = $a_delta;"
		end

	c_set_par (tmp: POINTER; a_par: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_lmder_state_t_118 *)$tmp)->par = $a_par;"
		end

	c_set_r (tmp: POINTER; a_r: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_lmder_state_t_118 *)$tmp)->r = (gsl_matrix *)$a_r;"
		end

	c_set_tau (tmp: POINTER; a_tau: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_lmder_state_t_118 *)$tmp)->tau = (gsl_vector *)$a_tau;"
		end

	c_set_diag (tmp: POINTER; a_diag: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_lmder_state_t_118 *)$tmp)->diag = (gsl_vector *)$a_diag;"
		end

	c_set_qtf (tmp: POINTER; a_qtf: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_lmder_state_t_118 *)$tmp)->qtf = (gsl_vector *)$a_qtf;"
		end

	c_set_newton (tmp: POINTER; a_newton: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_lmder_state_t_118 *)$tmp)->newton = (gsl_vector *)$a_newton;"
		end

	c_set_gradient (tmp: POINTER; a_gradient: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_lmder_state_t_118 *)$tmp)->gradient = (gsl_vector *)$a_gradient;"
		end

	c_set_x_trial (tmp: POINTER; a_x_trial: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_lmder_state_t_118 *)$tmp)->x_trial = (gsl_vector *)$a_x_trial;"
		end

	c_set_f_trial (tmp: POINTER; a_f_trial: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_lmder_state_t_118 *)$tmp)->f_trial = (gsl_vector *)$a_f_trial;"
		end

	c_set_df (tmp: POINTER; a_df: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_lmder_state_t_118 *)$tmp)->df = (gsl_vector *)$a_df;"
		end

	c_set_sdiag (tmp: POINTER; a_sdiag: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_lmder_state_t_118 *)$tmp)->sdiag = (gsl_vector *)$a_sdiag;"
		end

	c_set_rptdx (tmp: POINTER; a_rptdx: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_lmder_state_t_118 *)$tmp)->rptdx = (gsl_vector *)$a_rptdx;"
		end

	c_set_w (tmp: POINTER; a_w: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_lmder_state_t_118 *)$tmp)->w = (gsl_vector *)$a_w;"
		end

	c_set_work1 (tmp: POINTER; a_work1: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_lmder_state_t_118 *)$tmp)->work1 = (gsl_vector *)$a_work1;"
		end

	c_set_perm (tmp: POINTER; a_perm: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_lmder_state_t_118 *)$tmp)->perm = (struct gsl_permutation_struct *)$a_perm;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_lmder_state_t_118);"
		end

end
