class
	PD_RAN1_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	x: NATURAL_32 assign set_x
		do
			Result := c_x (c_pointer)
		end

	n: NATURAL_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	shuffle: CE_ARRAY [NATURAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_shuffle (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_x (a_x: NATURAL_32)
		do
			c_set_x (c_pointer, a_x)
		end

	set_n (a_n: NATURAL_32)
		do
			c_set_n (c_pointer, a_n)
		end

feature {NONE} -- C getters

	c_x (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_ran1_state_t_26 *)$tmp)->x;"
		end

	c_n (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_ran1_state_t_26 *)$tmp)->n;"
		end

	c_shuffle (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_ran1_state_t_26 *tmp = (struct __anonstruct_ran1_state_t_26 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->shuffle) / sizeof(tmp->shuffle[0]);
				return tmp->shuffle;
			]"
		end

feature {NONE} -- C setters

	c_set_x (tmp: POINTER; a_x: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ran1_state_t_26 *)$tmp)->x = $a_x;"
		end

	c_set_n (tmp: POINTER; a_n: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ran1_state_t_26 *)$tmp)->n = $a_n;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_ran1_state_t_26);"
		end

end
