class
	PD_RANLUX_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	i: NATURAL_32 assign set_i
		do
			Result := c_i (c_pointer)
		end

	j: NATURAL_32 assign set_j
		do
			Result := c_j (c_pointer)
		end

	n: NATURAL_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	skip: NATURAL_32 assign set_skip
		do
			Result := c_skip (c_pointer)
		end

	carry: NATURAL_32 assign set_carry
		do
			Result := c_carry (c_pointer)
		end

	u: CE_ARRAY [NATURAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_u (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_i (a_i: NATURAL_32)
		do
			c_set_i (c_pointer, a_i)
		end

	set_j (a_j: NATURAL_32)
		do
			c_set_j (c_pointer, a_j)
		end

	set_n (a_n: NATURAL_32)
		do
			c_set_n (c_pointer, a_n)
		end

	set_skip (a_skip: NATURAL_32)
		do
			c_set_skip (c_pointer, a_skip)
		end

	set_carry (a_carry: NATURAL_32)
		do
			c_set_carry (c_pointer, a_carry)
		end

feature {NONE} -- C getters

	c_i (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_ranlux_state_t_26 *)$tmp)->i;"
		end

	c_j (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_ranlux_state_t_26 *)$tmp)->j;"
		end

	c_n (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_ranlux_state_t_26 *)$tmp)->n;"
		end

	c_skip (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_ranlux_state_t_26 *)$tmp)->skip;"
		end

	c_carry (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_ranlux_state_t_26 *)$tmp)->carry;"
		end

	c_u (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_ranlux_state_t_26 *tmp = (struct __anonstruct_ranlux_state_t_26 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->u) / sizeof(tmp->u[0]);
				return tmp->u;
			]"
		end

feature {NONE} -- C setters

	c_set_i (tmp: POINTER; a_i: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ranlux_state_t_26 *)$tmp)->i = $a_i;"
		end

	c_set_j (tmp: POINTER; a_j: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ranlux_state_t_26 *)$tmp)->j = $a_j;"
		end

	c_set_n (tmp: POINTER; a_n: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ranlux_state_t_26 *)$tmp)->n = $a_n;"
		end

	c_set_skip (tmp: POINTER; a_skip: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ranlux_state_t_26 *)$tmp)->skip = $a_skip;"
		end

	c_set_carry (tmp: POINTER; a_carry: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ranlux_state_t_26 *)$tmp)->carry = $a_carry;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_ranlux_state_t_26);"
		end

end
