class
	PD_RANLXS_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	xdbl: CE_ARRAY [REAL_64]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_xdbl (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	ydbl: CE_ARRAY [REAL_64]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_ydbl (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	carry: REAL_64 assign set_carry
		do
			Result := c_carry (c_pointer)
		end

	xflt: CE_ARRAY [REAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_xflt (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	ir: NATURAL_32 assign set_ir
		do
			Result := c_ir (c_pointer)
		end

	jr: NATURAL_32 assign set_jr
		do
			Result := c_jr (c_pointer)
		end

	is: NATURAL_32 assign set_is
		do
			Result := c_is (c_pointer)
		end

	is_old: NATURAL_32 assign set_is_old
		do
			Result := c_is_old (c_pointer)
		end

	pr: NATURAL_32 assign set_pr
		do
			Result := c_pr (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_carry (a_carry: REAL_64)
		do
			c_set_carry (c_pointer, a_carry)
		end

	set_ir (a_ir: NATURAL_32)
		do
			c_set_ir (c_pointer, a_ir)
		end

	set_jr (a_jr: NATURAL_32)
		do
			c_set_jr (c_pointer, a_jr)
		end

	set_is (a_is: NATURAL_32)
		do
			c_set_is (c_pointer, a_is)
		end

	set_is_old (a_is_old: NATURAL_32)
		do
			c_set_is_old (c_pointer, a_is_old)
		end

	set_pr (a_pr: NATURAL_32)
		do
			c_set_pr (c_pointer, a_pr)
		end

feature {NONE} -- C getters

	c_xdbl (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_ranlxs_state_t_26 *tmp = (struct __anonstruct_ranlxs_state_t_26 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->xdbl) / sizeof(tmp->xdbl[0]);
				return tmp->xdbl;
			]"
		end

	c_ydbl (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_ranlxs_state_t_26 *tmp = (struct __anonstruct_ranlxs_state_t_26 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->ydbl) / sizeof(tmp->ydbl[0]);
				return tmp->ydbl;
			]"
		end

	c_carry (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_ranlxs_state_t_26 *)$tmp)->carry;"
		end

	c_xflt (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_ranlxs_state_t_26 *tmp = (struct __anonstruct_ranlxs_state_t_26 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->xflt) / sizeof(tmp->xflt[0]);
				return tmp->xflt;
			]"
		end

	c_ir (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_ranlxs_state_t_26 *)$tmp)->ir;"
		end

	c_jr (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_ranlxs_state_t_26 *)$tmp)->jr;"
		end

	c_is (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_ranlxs_state_t_26 *)$tmp)->is;"
		end

	c_is_old (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_ranlxs_state_t_26 *)$tmp)->is_old;"
		end

	c_pr (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_ranlxs_state_t_26 *)$tmp)->pr;"
		end

feature {NONE} -- C setters

	c_set_carry (tmp: POINTER; a_carry: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_ranlxs_state_t_26 *)$tmp)->carry = $a_carry;"
		end

	c_set_ir (tmp: POINTER; a_ir: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ranlxs_state_t_26 *)$tmp)->ir = $a_ir;"
		end

	c_set_jr (tmp: POINTER; a_jr: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ranlxs_state_t_26 *)$tmp)->jr = $a_jr;"
		end

	c_set_is (tmp: POINTER; a_is: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ranlxs_state_t_26 *)$tmp)->is = $a_is;"
		end

	c_set_is_old (tmp: POINTER; a_is_old: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ranlxs_state_t_26 *)$tmp)->is_old = $a_is_old;"
		end

	c_set_pr (tmp: POINTER; a_pr: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ranlxs_state_t_26 *)$tmp)->pr = $a_pr;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_ranlxs_state_t_26);"
		end

end
