class
	PD_SOBOL_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sequence_count: NATURAL_32 assign set_sequence_count
		do
			Result := c_sequence_count (c_pointer)
		end

	last_denominator_inv: REAL_64 assign set_last_denominator_inv
		do
			Result := c_last_denominator_inv (c_pointer)
		end

	last_numerator_vec: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_last_numerator_vec (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	v_direction: CE_ARRAY [CE_ARRAY [INTEGER_32]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 2)
			create Result.make_shared (c_v_direction (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_sequence_count (a_sequence_count: NATURAL_32)
		do
			c_set_sequence_count (c_pointer, a_sequence_count)
		end

	set_last_denominator_inv (a_last_denominator_inv: REAL_64)
		do
			c_set_last_denominator_inv (c_pointer, a_last_denominator_inv)
		end

feature {NONE} -- C getters

	c_sequence_count (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_sobol_state_t_26 *)$tmp)->sequence_count;"
		end

	c_last_denominator_inv (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_sobol_state_t_26 *)$tmp)->last_denominator_inv;"
		end

	c_last_numerator_vec (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_sobol_state_t_26 *tmp = (struct __anonstruct_sobol_state_t_26 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->last_numerator_vec) / sizeof(tmp->last_numerator_vec[0]);
				return tmp->last_numerator_vec;
			]"
		end

	c_v_direction (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_sobol_state_t_26 *tmp = (struct __anonstruct_sobol_state_t_26 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->v_direction) / sizeof(tmp->v_direction[0]);
				((int *)$tmp_dimensions)[1] = sizeof(tmp->v_direction[0]) / sizeof(tmp->v_direction[0][0]);
				return tmp->v_direction;
			]"
		end

feature {NONE} -- C setters

	c_set_sequence_count (tmp: POINTER; a_sequence_count: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_sobol_state_t_26 *)$tmp)->sequence_count = $a_sequence_count;"
		end

	c_set_last_denominator_inv (tmp: POINTER; a_last_denominator_inv: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_sobol_state_t_26 *)$tmp)->last_denominator_inv = $a_last_denominator_inv;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_sobol_state_t_26);"
		end

end
