class
	PD_STEEPEST_DESCENT_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	step: REAL_64 assign set_step
		do
			Result := c_step (c_pointer)
		end

	max_step: REAL_64 assign set_max_step
		do
			Result := c_max_step (c_pointer)
		end

	tol: REAL_64 assign set_tol
		do
			Result := c_tol (c_pointer)
		end

	x1: CE_POINTER [PD_GSL_VECTOR] assign set_x1
		do
			create Result.make_shared (c_x1 (c_pointer))
		end

	g1: CE_POINTER [PD_GSL_VECTOR] assign set_g1
		do
			create Result.make_shared (c_g1 (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_step (a_step: REAL_64)
		do
			c_set_step (c_pointer, a_step)
		end

	set_max_step (a_max_step: REAL_64)
		do
			c_set_max_step (c_pointer, a_max_step)
		end

	set_tol (a_tol: REAL_64)
		do
			c_set_tol (c_pointer, a_tol)
		end

	set_x1 (a_x1: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_x1 (c_pointer, a_x1.c_pointer)
		end

	set_g1 (a_g1: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_g1 (c_pointer, a_g1.c_pointer)
		end

feature {NONE} -- C getters

	c_step (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_steepest_descent_state_t_119 *)$tmp)->step;"
		end

	c_max_step (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_steepest_descent_state_t_119 *)$tmp)->max_step;"
		end

	c_tol (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_steepest_descent_state_t_119 *)$tmp)->tol;"
		end

	c_x1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_steepest_descent_state_t_119 *)$tmp)->x1;"
		end

	c_g1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_steepest_descent_state_t_119 *)$tmp)->g1;"
		end

feature {NONE} -- C setters

	c_set_step (tmp: POINTER; a_step: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_steepest_descent_state_t_119 *)$tmp)->step = $a_step;"
		end

	c_set_max_step (tmp: POINTER; a_max_step: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_steepest_descent_state_t_119 *)$tmp)->max_step = $a_max_step;"
		end

	c_set_tol (tmp: POINTER; a_tol: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_steepest_descent_state_t_119 *)$tmp)->tol = $a_tol;"
		end

	c_set_x1 (tmp: POINTER; a_x1: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_steepest_descent_state_t_119 *)$tmp)->x1 = (gsl_vector *)$a_x1;"
		end

	c_set_g1 (tmp: POINTER; a_g1: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_steepest_descent_state_t_119 *)$tmp)->g1 = (gsl_vector *)$a_g1;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_steepest_descent_state_t_119);"
		end

end
