class
	PD_VECTOR_BFGS2_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	iter: INTEGER_32 assign set_iter
		do
			Result := c_iter (c_pointer)
		end

	step: REAL_64 assign set_step
		do
			Result := c_step (c_pointer)
		end

	g0norm: REAL_64 assign set_g0norm
		do
			Result := c_g0norm (c_pointer)
		end

	pnorm: REAL_64 assign set_pnorm
		do
			Result := c_pnorm (c_pointer)
		end

	delta_f: REAL_64 assign set_delta_f
		do
			Result := c_delta_f (c_pointer)
		end

	fp0: REAL_64 assign set_fp0
		do
			Result := c_fp0 (c_pointer)
		end

	fp0_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct_vector_bfgs2_state_t_121, fp0);"
		end

	x0: CE_POINTER [PD_GSL_VECTOR] assign set_x0
		do
			create Result.make_shared (c_x0 (c_pointer))
		end

	g0: CE_POINTER [PD_GSL_VECTOR] assign set_g0
		do
			create Result.make_shared (c_g0 (c_pointer))
		end

	p: CE_POINTER [PD_GSL_VECTOR] assign set_p
		do
			create Result.make_shared (c_p (c_pointer))
		end

	dx0: CE_POINTER [PD_GSL_VECTOR] assign set_dx0
		do
			create Result.make_shared (c_dx0 (c_pointer))
		end

	dg0: CE_POINTER [PD_GSL_VECTOR] assign set_dg0
		do
			create Result.make_shared (c_dg0 (c_pointer))
		end

	x_alpha: CE_POINTER [PD_GSL_VECTOR] assign set_x_alpha
		do
			create Result.make_shared (c_x_alpha (c_pointer))
		end

	g_alpha: CE_POINTER [PD_GSL_VECTOR] assign set_g_alpha
		do
			create Result.make_shared (c_g_alpha (c_pointer))
		end

	wrap: PD_WRAPPER_T assign set_wrap
		do
			create Result.make_shared (c_wrap (c_pointer))
		end

	wrap_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct_vector_bfgs2_state_t_121, wrap);"
		end

	rho: REAL_64 assign set_rho
		do
			Result := c_rho (c_pointer)
		end

	sigma: REAL_64 assign set_sigma
		do
			Result := c_sigma (c_pointer)
		end

	tau1: REAL_64 assign set_tau1
		do
			Result := c_tau1 (c_pointer)
		end

	tau2: REAL_64 assign set_tau2
		do
			Result := c_tau2 (c_pointer)
		end

	tau3: REAL_64 assign set_tau3
		do
			Result := c_tau3 (c_pointer)
		end

	order: INTEGER_32 assign set_order
		do
			Result := c_order (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_iter (a_iter: INTEGER_32)
		do
			c_set_iter (c_pointer, a_iter)
		end

	set_step (a_step: REAL_64)
		do
			c_set_step (c_pointer, a_step)
		end

	set_g0norm (a_g0norm: REAL_64)
		do
			c_set_g0norm (c_pointer, a_g0norm)
		end

	set_pnorm (a_pnorm: REAL_64)
		do
			c_set_pnorm (c_pointer, a_pnorm)
		end

	set_delta_f (a_delta_f: REAL_64)
		do
			c_set_delta_f (c_pointer, a_delta_f)
		end

	set_fp0 (a_fp0: REAL_64)
		do
			c_set_fp0 (c_pointer, a_fp0)
		end

	set_x0 (a_x0: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_x0 (c_pointer, a_x0.c_pointer)
		end

	set_g0 (a_g0: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_g0 (c_pointer, a_g0.c_pointer)
		end

	set_p (a_p: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_p (c_pointer, a_p.c_pointer)
		end

	set_dx0 (a_dx0: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_dx0 (c_pointer, a_dx0.c_pointer)
		end

	set_dg0 (a_dg0: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_dg0 (c_pointer, a_dg0.c_pointer)
		end

	set_x_alpha (a_x_alpha: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_x_alpha (c_pointer, a_x_alpha.c_pointer)
		end

	set_g_alpha (a_g_alpha: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_g_alpha (c_pointer, a_g_alpha.c_pointer)
		end

	set_wrap (a_wrap: PD_WRAPPER_T)
		do
			wrap.ce_gets (a_wrap)
		end

	set_rho (a_rho: REAL_64)
		do
			c_set_rho (c_pointer, a_rho)
		end

	set_sigma (a_sigma: REAL_64)
		do
			c_set_sigma (c_pointer, a_sigma)
		end

	set_tau1 (a_tau1: REAL_64)
		do
			c_set_tau1 (c_pointer, a_tau1)
		end

	set_tau2 (a_tau2: REAL_64)
		do
			c_set_tau2 (c_pointer, a_tau2)
		end

	set_tau3 (a_tau3: REAL_64)
		do
			c_set_tau3 (c_pointer, a_tau3)
		end

	set_order (a_order: INTEGER_32)
		do
			c_set_order (c_pointer, a_order)
		end

feature {NONE} -- C getters

	c_iter (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->iter;"
		end

	c_step (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->step;"
		end

	c_g0norm (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->g0norm;"
		end

	c_pnorm (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->pnorm;"
		end

	c_delta_f (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->delta_f;"
		end

	c_fp0 (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->fp0;"
		end

	c_x0 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->x0;"
		end

	c_g0 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->g0;"
		end

	c_p (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->p;"
		end

	c_dx0 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->dx0;"
		end

	c_dg0 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->dg0;"
		end

	c_x_alpha (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->x_alpha;"
		end

	c_g_alpha (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->g_alpha;"
		end

	c_wrap (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (wrapper_t *)&((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->wrap;"
		end

	c_rho (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->rho;"
		end

	c_sigma (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->sigma;"
		end

	c_tau1 (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->tau1;"
		end

	c_tau2 (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->tau2;"
		end

	c_tau3 (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->tau3;"
		end

	c_order (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->order;"
		end

feature {NONE} -- C setters

	c_set_iter (tmp: POINTER; a_iter: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->iter = $a_iter;"
		end

	c_set_step (tmp: POINTER; a_step: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->step = $a_step;"
		end

	c_set_g0norm (tmp: POINTER; a_g0norm: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->g0norm = $a_g0norm;"
		end

	c_set_pnorm (tmp: POINTER; a_pnorm: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->pnorm = $a_pnorm;"
		end

	c_set_delta_f (tmp: POINTER; a_delta_f: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->delta_f = $a_delta_f;"
		end

	c_set_fp0 (tmp: POINTER; a_fp0: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->fp0 = $a_fp0;"
		end

	c_set_x0 (tmp: POINTER; a_x0: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->x0 = (gsl_vector *)$a_x0;"
		end

	c_set_g0 (tmp: POINTER; a_g0: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->g0 = (gsl_vector *)$a_g0;"
		end

	c_set_p (tmp: POINTER; a_p: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->p = (gsl_vector *)$a_p;"
		end

	c_set_dx0 (tmp: POINTER; a_dx0: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->dx0 = (gsl_vector *)$a_dx0;"
		end

	c_set_dg0 (tmp: POINTER; a_dg0: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->dg0 = (gsl_vector *)$a_dg0;"
		end

	c_set_x_alpha (tmp: POINTER; a_x_alpha: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->x_alpha = (gsl_vector *)$a_x_alpha;"
		end

	c_set_g_alpha (tmp: POINTER; a_g_alpha: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->g_alpha = (gsl_vector *)$a_g_alpha;"
		end

	c_set_rho (tmp: POINTER; a_rho: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->rho = $a_rho;"
		end

	c_set_sigma (tmp: POINTER; a_sigma: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->sigma = $a_sigma;"
		end

	c_set_tau1 (tmp: POINTER; a_tau1: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->tau1 = $a_tau1;"
		end

	c_set_tau2 (tmp: POINTER; a_tau2: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->tau2 = $a_tau2;"
		end

	c_set_tau3 (tmp: POINTER; a_tau3: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->tau3 = $a_tau3;"
		end

	c_set_order (tmp: POINTER; a_order: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs2_state_t_121 *)$tmp)->order = $a_order;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_vector_bfgs2_state_t_121);"
		end

end
