#ifndef LIBGSL_H
#define LIBGSL_H

#include <ffi.h>
#include <libio.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <assert.h>

#undef size
#undef data
#undef next
#undef sbuf
#undef pos
#undef flags
#undef IO_read_ptr
#undef IO_read_end
#undef IO_read_base
#undef IO_write_base
#undef IO_write_ptr
#undef IO_write_end
#undef IO_buf_base
#undef IO_buf_end
#undef IO_save_base
#undef IO_backup_base
#undef IO_save_end
#undef markers
#undef chain
#undef fileno
#undef flags2
#undef old_offset
#undef cur_column
#undef vtable_offset
#undef shortbuf
#undef lock
#undef offset
#undef pad1
#undef pad2
#undef pad3
#undef pad4
#undef pad5
#undef mode
#undef unused2
#undef dat
#undef stride
#undef block
#undef owner
#undef size1
#undef size2
#undef tda
#undef vector
#undef k
#undef km1
#undef l
#undef nbreak
#undef n
#undef knots
#undef deltal
#undef deltar
#undef B
#undef A
#undef dB
#undef c
#undef order
#undef a
#undef b
#undef order_sp
#undef f
#undef function
#undef params
#undef val
#undef err
#undef nu
#undef xmax
#undef kmax
#undef j
#undef Jjj
#undef J2
#undef matrix
#undef max_iterations
#undef n_iter
#undef n_evals
#undef compute_t
#undef H
#undef Z
#undef diag
#undef tau
#undef do_balance
#undef francis_workspace_p
#undef work
#undef work2
#undef work3
#undef nonsymm_workspace_p
#undef d
#undef sd
#undef gc
#undef gs
#undef herm_workspace_p
#undef eshift
#undef needtop
#undef atol
#undef btol
#undef ascale
#undef bscale
#undef R
#undef compute_s
#undef Q
#undef work1
#undef work4
#undef work5
#undef work6
#undef gen_workspace_p
#undef symmv_workspace_p
#undef symm_workspace_p
#undef hermv_workspace_p
#undef nf
#undef factor
#undef twiddle
#undef trig
#undef scratch
#undef nx
#undef ny
#undef xrange
#undef yrange
#undef bin
#undef range
#undef sum
#undef sign
#undef mantissa
#undef exponent
#undef type
#undef byte
#undef ieee
#undef limit
#undef nrmax
#undef i
#undef maximum_level
#undef alist
#undef blist
#undef rlist
#undef elist
#undef level
#undef rlist2
#undef nres
#undef res3la
#undef omega
#undef L
#undef par
#undef sine
#undef chebmo
#undef alpha
#undef beta
#undef mu
#undef ri
#undef rj
#undef rg
#undef rh
#undef singularity
#undef x
#undef w
#undef precomputed
#undef table
#undef cache
#undef miss_count
#undef hit_count
#undef name
#undef min_size
#undef alloc
#undef init
#undef eval
#undef eval_deriv
#undef eval_deriv2
#undef eval_integ
#undef free
#undef g
#undef offdiag
#undef xmin
#undef state
#undef coeff
#undef interp
#undef y
#undef m
#undef set
#undef iterate
#undef step_size
#undef stored_step
#undef prev_stored_step
#undef x_prev_small
#undef f_prev_small
#undef x_small
#undef f_small
#undef num_iter
#undef x_minimum
#undef x_lower
#undef x_upper
#undef f_minimum
#undef f_lower
#undef f_upper
#undef dummy
#undef e
#undef v
#undef f_v
#undef f_w
#undef max
#undef min
#undef get
#undef get_double
#undef dim
#undef min_calls
#undef min_calls_per_bisection
#undef dither
#undef estimate_frac
#undef estimate_style
#undef depth
#undef verbose
#undef xmid
#undef sigma_l
#undef sigma_r
#undef fmax_l
#undef fmax_r
#undef fmin_l
#undef fmin_r
#undef fsum_l
#undef fsum_r
#undef fsum2_l
#undef fsum2_r
#undef hits_l
#undef hits_r
#undef bins_max
#undef bins
#undef boxes
#undef xi
#undef xin
#undef delx
#undef weight
#undef vol
#undef box
#undef iterations
#undef stage
#undef jac
#undef wtd_int_sum
#undef sum_wgts
#undef chi_sum
#undef chisq
#undef result2
#undef sigma
#undef it_start
#undef it_num
#undef samples
#undef calls_per_box
#undef ostream
#undef df
#undef fdf
#undef p
#undef iter
#undef xnorm
#undef fnorm
#undef delta
#undef r
#undef qtf
#undef newton
#undef gradient
#undef x_trial
#undef f_trial
#undef sdiag
#undef rptdx
#undef perm
#undef J
#undef dx
#undef QSI
#undef S
#undef t
#undef xt
#undef D
#undef restart
#undef x1
#undef y1
#undef ws1
#undef ws2
#undef step
#undef max_step
#undef tol
#undef dx1
#undef x2
#undef g0norm
#undef pnorm
#undef x0
#undef g0
#undef dx0
#undef dg0
#undef g1
#undef fdf_linear
#undef f_alpha
#undef df_alpha
#undef x_alpha
#undef g_alpha
#undef f_cache_key
#undef df_cache_key
#undef x_cache_key
#undef g_cache_key
#undef delta_f
#undef fp0
#undef wrap
#undef rho
#undef tau1
#undef tau2
#undef tau3
#undef center
#undef xmc
#undef S2
#undef count
#undef fval
#undef lu
#undef permutation
#undef phi
#undef ncfail
#undef ncsuc
#undef nslow1
#undef nslow2
#undef q
#undef qtdf
#undef rdx
#undef fnew
#undef file
#undef ntuple_data
#undef jacobian
#undef dimension
#undef can_use_dydt_in
#undef gives_exact_dydt_out
#undef apply
#undef reset
#undef ytmp
#undef y0
#undef k1
#undef k2
#undef k3
#undef k4
#undef k5
#undef k6
#undef hadjust
#undef yerr
#undef dydt_in
#undef dydt_out
#undef last_step
#undef failed_steps
#undef Y1
#undef y_onestep
#undef y0_orig
#undef eps_abs
#undef eps_rel
#undef a_y
#undef a_dydt
#undef dfdy
#undef dfdt
#undef scale_abs
#undef k1nu
#undef k2nu
#undef ytmp1
#undef ytmp2
#undef primed
#undef t_primed
#undef last_h
#undef primer
#undef yim1
#undef stutter
#undef a_mat
#undef p_vec
#undef k_current
#undef k_choice
#undef h_next
#undef eps
#undef yp
#undef y_save
#undef yerr_save
#undef y_extrap_save
#undef y_extrap_sequence
#undef extrap_work
#undef y_temp
#undef delta_temp
#undef rhs_temp
#undef nc
#undef max_dimension
#undef state_size
#undef init_state
#undef sequence_count
#undef last_denominator_inv
#undef last_numerator_vec
#undef v_direction
#undef cj
#undef nextq
#undef K
#undef F
#undef N
#undef u
#undef xdbl
#undef ydbl
#undef carry
#undef xflt
#undef ir
#undef jr
#undef is
#undef is_old
#undef pr
#undef shuffle
#undef z
#undef aa
#undef ran_x
#undef ir_old
#undef s1
#undef s2
#undef s3
#undef z1
#undef z2
#undef z3
#undef z4
#undef skip
#undef buffer
#undef nd
#undef ra
#undef x3
#undef x4
#undef x5
#undef y2
#undef y3
#undef mt
#undef mti
#undef root
#undef x_1
#undef x_2
#undef fa
#undef fb
#undef fc
#undef n_tries
#undef iters_fixed_T
#undef t_initial
#undef mu_t
#undef t_min
#undef e10
#undef even_order
#undef odd_order
#undef extra_values
#undef qa
#undef qb
#undef bb
#undef dd
#undef ee
#undef tt
#undef e2
#undef zz
#undef evec
#undef wmat
#undef terms_used
#undef sum_plain
#undef q_num
#undef q_den
#undef dsum
#undef dq_num
#undef dq_den
#undef h1
#undef h2
#undef g2
#undef builtin_inff
#undef builtin_nanf
#undef IO_putc
#undef __c
#undef __fp
#undef fprintf
#undef __stream
#undef __format
#undef fscanf
#undef fread
#undef __ptr
#undef __size
#undef __n
#undef fwrite
#undef __s
#undef malloc
#undef acos
#undef __x
#undef asin
#undef atan
#undef atan2
#undef __y
#undef cos
#undef sin
#undef cosh
#undef sinh
#undef tanh
#undef acosh
#undef atanh
#undef exp
#undef log
#undef log1p
#undef pow
#undef sqrt
#undef hypot
#undef fabs
#undef calloc
#undef __nmemb
#undef isnan
#undef __value
#undef isnanf
#undef isnanl
#undef floor
#undef abort
#undef fflush
#undef memcpy
#undef __dest
#undef __src
#undef strcpy
#undef strcmp
#undef __s1
#undef __s2
#undef strchr
#undef strlen
#undef getenv
#undef __name
#undef ceil
#undef frexp
#undef __exponent
#undef ldexp
#undef fclose
#undef fopen
#undef __filename
#undef __modes
#undef feof
#undef memset
#undef tan
#undef abs
#undef printf
#undef strtoul
#undef __nptr
#undef __endptr
#undef __base
#undef fputc
#undef assert_fail
#undef __assertion
#undef __file
#undef __line
#undef __function
#undef fmod
#undef finite
#undef isinf
#undef finite2
#undef isinff
#undef finitef
#undef isinfl
#undef finitel
#undef vprintf
#undef __arg
#undef expm1
#undef vfprintf

enum PC_CBLAS_ORDER {
	CblasRowMajor = 101,
	CblasColMajor = 102
};
enum PC_CBLAS_TRANSPOSE {
	CblasNoTrans = 111,
	CblasTrans = 112,
	CblasConjTrans = 113
};
enum PC_CBLAS_UPLO {
	CblasUpper = 121,
	CblasLower = 122
};
enum PC_CBLAS_DIAG {
	CblasNonUnit = 131,
	CblasUnit = 132
};
enum PC_CBLAS_SIDE {
	CblasLeft = 141,
	CblasRight = 142
};
enum PC_GSL_EIGEN_SORT_T {
	GSL_EIGEN_SORT_VAL_ASC = 0,
	GSL_EIGEN_SORT_VAL_DESC = 1,
	GSL_EIGEN_SORT_ABS_ASC = 2,
	GSL_EIGEN_SORT_ABS_DESC = 3
};
enum PC_GSL_FFT_DIRECTION {
	gsl_fft_forward = -1,
	gsl_fft_backward = 1
};
enum PC_GSL_INTEGRATION_QAWO_ENUM {
	GSL_INTEG_COSINE = 0,
	GSL_INTEG_SINE = 1
};
enum PC_GSL_LINALG_MATRIX_MOD_T {
	GSL_LINALG_MOD_NONE = 0,
	GSL_LINALG_MOD_TRANSPOSE = 1,
	GSL_LINALG_MOD_CONJUGATE = 2
};
enum PC_GSL_WAVELET_DIRECTION {
	gsl_wavelet_forward = 1,
	gsl_wavelet_backward = -1
};

struct gsl_block_complex_long_double_struct;
struct gsl_block_complex_struct;
struct gsl_block_complex_float_struct;
struct gsl_block_long_double_struct;
struct gsl_block_struct;
struct gsl_block_float_struct;
struct gsl_block_ulong_struct;
struct gsl_block_long_struct;
struct gsl_block_uint_struct;
struct gsl_block_int_struct;
struct gsl_block_ushort_struct;
struct gsl_block_short_struct;
struct gsl_block_uchar_struct;
struct gsl_block_char_struct;
struct __anonstruct_gsl_complex_long_double_26;
struct __anonstruct_gsl_complex_27;
struct __anonstruct_gsl_complex_float_28;
struct __anonstruct_gsl_vector_long_double_29;
struct __anonstruct_gsl_vector_complex_long_double_32;
struct __anonstruct_gsl_vector_35;
struct __anonstruct_gsl_vector_complex_38;
struct __anonstruct_gsl_vector_float_41;
struct __anonstruct_gsl_vector_complex_float_44;
struct __anonstruct_gsl_vector_ulong_47;
struct __anonstruct_gsl_vector_long_50;
struct __anonstruct_gsl_vector_uint_53;
struct __anonstruct_gsl_vector_int_56;
struct __anonstruct_gsl_vector_ushort_59;
struct __anonstruct_gsl_vector_short_62;
struct __anonstruct_gsl_vector_uchar_65;
struct __anonstruct_gsl_vector_char_68;
struct __anonstruct_gsl_matrix_complex_long_double_71;
struct __anonstruct_gsl_matrix_complex_74;
struct __anonstruct_gsl_matrix_complex_float_77;
struct __anonstruct_gsl_matrix_long_double_80;
struct __anonstruct_gsl_matrix_83;
struct __anonstruct_gsl_matrix_float_86;
struct __anonstruct_gsl_matrix_ulong_89;
struct __anonstruct_gsl_matrix_long_92;
struct __anonstruct_gsl_matrix_uint_95;
struct __anonstruct_gsl_matrix_int_98;
struct __anonstruct_gsl_matrix_ushort_101;
struct __anonstruct_gsl_matrix_short_104;
struct __anonstruct_gsl_matrix_uchar_107;
struct __anonstruct_gsl_matrix_char_110;
struct __anonstruct__gsl_vector_view_36;
struct __anonstruct_gsl_bspline_workspace_113;
struct __anonstruct_gsl_bspline_deriv_workspace_114;
struct gsl_cheb_series_struct;
struct gsl_function_struct;
struct gsl_sf_result_struct;
struct gsl_dht_struct;
struct __anonstruct__gsl_vector_complex_view_39;
struct __anonstruct__gsl_matrix_view_84;
struct __anonstruct_gsl_eigen_francis_workspace_117;
struct __anonstruct_gsl_eigen_nonsymm_workspace_118;
struct __anonstruct_gsl_eigen_nonsymmv_workspace_119;
struct gsl_permutation_struct;
struct __anonstruct_gsl_eigen_hermv_workspace_117;
struct __anonstruct_gsl_eigen_symmv_workspace_115;
struct __anonstruct_gsl_eigen_herm_workspace_116;
struct __anonstruct__gsl_vector_complex_const_view_38;
struct __anonstruct__gsl_matrix_complex_view_73;
struct __anonstruct__gsl_matrix_complex_const_view_74;
struct __anonstruct_gsl_eigen_genherm_workspace_120;
struct __anonstruct__gsl_matrix_const_view_85;
struct __anonstruct_gsl_eigen_gen_workspace_124;
struct __anonstruct_gsl_eigen_genv_workspace_125;
struct __anonstruct_gsl_eigen_symm_workspace_114;
struct __anonstruct_gsl_eigen_gensymmv_workspace_119;
struct __anonstruct__gsl_vector_const_view_35;
struct __anonstruct_gsl_eigen_gensymm_workspace_118;
struct __anonstruct_gsl_eigen_genhermv_workspace_121;
struct __anonstruct_gsl_fft_complex_wavetable_30;
struct __anonstruct_gsl_fft_complex_workspace_31;
struct __anonstruct_gsl_fft_complex_wavetable_float_32;
struct __anonstruct_gsl_fft_complex_workspace_float_33;
struct __anonstruct_gsl_fft_real_wavetable_34;
struct __anonstruct_gsl_fft_real_workspace_35;
struct __anonstruct_gsl_fft_halfcomplex_wavetable_36;
struct __anonstruct_gsl_fft_real_wavetable_float_37;
struct __anonstruct_gsl_fft_real_workspace_float_38;
struct __anonstruct_gsl_fft_halfcomplex_wavetable_float_39;
struct __anonstruct_gsl_histogram2d_24;
struct __anonstruct_gsl_histogram_24;
struct __anonstruct_gsl_histogram_pdf_25;
struct __anonstruct_gsl_histogram2d_pdf_27;
struct __anonstruct_gsl_ieee_float_rep_7;
struct __anonstruct_gsl_ieee_double_rep_8;
union __anonunion_u_29;
union __anonunion_u_30;
union __anonunion_u_31;
struct __anonstruct_ieee_33;
union __anonunion_u_32;
struct __anonstruct_ieee_35;
union __anonunion_u_34;
struct __anonstruct_gsl_integration_workspace_26;
struct extrapolation_table;
struct il_params;
struct iu_params;
struct __anonstruct_gsl_integration_qawo_table_23;
struct __anonstruct_gsl_integration_qaws_table_22;
struct fn_fourier_params;
struct fn_cauchy_params;
struct __anonstruct_gsl_integration_glfixed_table_30;
struct fn_qaws_params;
struct __anonstruct_gsl_interp_accel_112;
struct __anonstruct_gsl_interp_type_113;
struct __anonstruct_cspline_state_t_115;
struct __anonstruct_gsl_interp_28;
struct __anonstruct_polynomial_state_t_33;
struct __anonstruct_gsl_spline_27;
struct __anonstruct_akima_state_t_29;
struct moler_vanloan_optimal_suggestion;
struct __anonstruct__gsl_vector_long_double_view_30;
struct __anonstruct__gsl_vector_long_double_const_view_31;
struct __anonstruct__gsl_vector_complex_long_double_view_33;
struct __anonstruct__gsl_vector_complex_long_double_const_view_34;
struct __anonstruct__gsl_vector_float_view_48;
struct __anonstruct__gsl_vector_float_const_view_49;
struct __anonstruct__gsl_vector_complex_float_view_51;
struct __anonstruct__gsl_vector_complex_float_const_view_52;
struct __anonstruct__gsl_vector_ulong_view_66;
struct __anonstruct__gsl_vector_ulong_const_view_67;
struct __anonstruct__gsl_vector_long_view_72;
struct __anonstruct__gsl_vector_long_const_view_73;
struct __anonstruct__gsl_vector_uint_view_78;
struct __anonstruct__gsl_vector_uint_const_view_79;
struct __anonstruct__gsl_vector_int_view_84;
struct __anonstruct__gsl_vector_int_const_view_85;
struct __anonstruct__gsl_vector_ushort_view_90;
struct __anonstruct__gsl_vector_ushort_const_view_91;
struct __anonstruct__gsl_vector_short_view_96;
struct __anonstruct__gsl_vector_short_const_view_97;
struct __anonstruct__gsl_vector_uchar_view_102;
struct __anonstruct__gsl_vector_uchar_const_view_103;
struct __anonstruct__gsl_vector_char_view_108;
struct __anonstruct__gsl_vector_char_const_view_109;
struct __anonstruct__gsl_matrix_complex_long_double_view_34;
struct __anonstruct__gsl_matrix_complex_long_double_const_view_35;
struct __anonstruct__gsl_matrix_complex_float_view_52;
struct __anonstruct__gsl_matrix_complex_float_const_view_53;
struct __anonstruct__gsl_matrix_long_double_view_55;
struct __anonstruct__gsl_matrix_long_double_const_view_56;
struct __anonstruct__gsl_matrix_float_view_61;
struct __anonstruct__gsl_matrix_float_const_view_62;
struct __anonstruct__gsl_matrix_ulong_view_67;
struct __anonstruct__gsl_matrix_ulong_const_view_68;
struct __anonstruct__gsl_matrix_long_view_73;
struct __anonstruct__gsl_matrix_long_const_view_74;
struct __anonstruct__gsl_matrix_uint_view_79;
struct __anonstruct__gsl_matrix_uint_const_view_80;
struct __anonstruct__gsl_matrix_int_view_85;
struct __anonstruct__gsl_matrix_int_const_view_86;
struct __anonstruct__gsl_matrix_ushort_view_91;
struct __anonstruct__gsl_matrix_ushort_const_view_92;
struct __anonstruct__gsl_matrix_short_view_97;
struct __anonstruct__gsl_matrix_short_const_view_98;
struct __anonstruct__gsl_matrix_uchar_view_103;
struct __anonstruct__gsl_matrix_uchar_const_view_104;
struct __anonstruct__gsl_matrix_char_view_109;
struct __anonstruct__gsl_matrix_char_const_view_110;
struct __anonstruct_gsl_min_fminimizer_type_26;
struct __anonstruct_quad_golden_state_t_28;
struct __anonstruct_gsl_min_fminimizer_27;
struct __anonstruct_goldensection_state_t_28;
struct __anonstruct_brent_state_t_28;
struct __anonstruct_gsl_rng_type_26;
struct __anonstruct_gsl_rng_27;
struct gsl_monte_function_struct;
struct __anonstruct_gsl_monte_miser_state_29;
struct __anonstruct_gsl_monte_miser_params_30;
struct __anonstruct_gsl_monte_vegas_state_29;
struct __anonstruct_gsl_monte_vegas_params_30;
struct __anonstruct_gsl_monte_plain_state_28;
struct gsl_multifit_function_fdf_struct;
struct __anonstruct_gsl_multifit_fdfsolver_type_115;
struct __anonstruct_lmder_state_t_118;
struct __anonstruct_gsl_multifit_fdfsolver_116;
struct gsl_multifit_function_struct;
struct __anonstruct_gsl_multifit_fsolver_type_113;
struct __anonstruct_gsl_multifit_fsolver_114;
struct __anonstruct_gsl_multifit_linear_workspace_113;
struct gsl_multimin_function_fdf_struct;
struct __anonstruct_gsl_multimin_fdfminimizer_type_117;
struct __anonstruct_gsl_multimin_fdfminimizer_118;
struct gsl_multimin_function_struct;
struct __anonstruct_gsl_multimin_fminimizer_type_115;
struct __anonstruct_nmsimplex_state_t_119;
struct __anonstruct_vector_bfgs_state_t_119;
struct __anonstruct_conjugate_pr_state_t_119;
struct __anonstruct_steepest_descent_state_t_119;
struct __anonstruct_conjugate_fr_state_t_119;
struct gsl_function_fdf_struct;
struct __anonstruct_wrapper_t_120;
struct __anonstruct_vector_bfgs2_state_t_121;
struct __anonstruct_nmsimplex_state_t_119___0;
struct __anonstruct_gsl_multimin_fminimizer_116;
struct gsl_multiroot_function_fdf_struct;
struct __anonstruct_gsl_multiroot_fdfsolver_type_115;
struct __anonstruct_newton_state_t_118;
struct __anonstruct_gsl_multiroot_fdfsolver_116;
struct __anonstruct_gnewton_state_t_118;
struct __anonstruct_hybridj_state_t_118;
struct gsl_multiroot_function_struct;
struct __anonstruct_gsl_multiroot_fsolver_type_113;
struct __anonstruct_gsl_multiroot_fsolver_114;
struct __anonstruct_hybrid_state_t_118;
struct __anonstruct_dnewton_state_t_118;
struct __anonstruct_broyden_state_t_118;
struct __anonstruct_gsl_ntuple_26;
struct __anonstruct_gsl_ntuple_select_fn_27;
struct __anonstruct_gsl_ntuple_value_fn_28;
struct __anonstruct_gsl_odeiv_system_24;
struct __anonstruct_gsl_odeiv_step_type_25;
struct __anonstruct_rk8pd_state_t_30;
struct __anonstruct_rkck_state_t_30;
struct __anonstruct_gsl_odeiv_step_28;
struct __anonstruct_gsl_odeiv_control_type_29;
struct __anonstruct_gsl_odeiv_control_30;
struct __anonstruct_gsl_odeiv_evolve_31;
struct __anonstruct_rk2imp_state_t_32;
struct __anonstruct_std_control_state_t_32;
struct __anonstruct_rk2_state_t_30;
struct __anonstruct_gear1_state_t_32;
struct __anonstruct_rk2simp_state_t_120;
struct __anonstruct_sc_control_state_t_32;
struct __anonstruct_rk4imp_state_t_32;
struct __anonstruct_gear2_state_t_32;
struct __anonstruct_rkf45_state_t_30;
struct __anonstruct_rk4_state_t_30;
struct __anonstruct_bsimp_state_t_120;
struct gsl_combination_struct;
struct gsl_multiset_struct;
struct __anonstruct_gsl_poly_complex_workspace_24;
struct __anonstruct_gsl_qrng_type_24;
struct __anonstruct_gsl_qrng_25;
struct __anonstruct_reversehalton_state_t_26;
struct __anonstruct_sobol_state_t_26;
struct __anonstruct_nied2_state_t_26;
struct __anonstruct_halton_state_t_26;
struct __anonstruct_gsl_ran_discrete_t_28;
struct __anonstruct_gsl_stack_t_29;
struct __anonstruct_ran_state_t_26;
struct __anonstruct_zuf_state_t_26;
struct __anonstruct_ranlxs_state_t_26;
struct __anonstruct_randu_state_t_26;
struct __anonstruct_uni32_state_t_26;
struct __anonstruct_ran1_state_t_26;
struct __anonstruct_ran2_state_t_26;
struct __anonstruct_ran0_state_t_26;
struct __anonstruct_ran_state_t_26___0;
struct __anonstruct_tt_state_t_26;
struct __anonstruct_vax_state_t_26;
struct __anonstruct_ranmar_state_t_26;
struct __anonstruct_ran_state_t_26___1;
struct __anonstruct_ranf_state_t_28;
struct __anonstruct_ran_state_t_26___2;
struct __anonstruct_ranlxd_state_t_26;
struct __anonstruct_slatec_state_t_26;
struct __anonstruct_transputer_state_t_26;
struct __anonstruct_uni_state_t_26;
struct __anonstruct_taus_state_t_26;
struct __anonstruct_ran_state_t_26___3;
struct __anonstruct_taus113_state_t_26;
struct __anonstruct_rand_state_t_26;
struct __anonstruct_ranlux_state_t_26;
struct __anonstruct_rand48_state_t_28;
struct __anonstruct_r250_state_t_26;
struct __anonstruct_ran3_state_t_26;
struct __anonstruct_minstd_state_t_26;
struct __anonstruct_gfsr4_state_t_26;
struct __anonstruct_mrg_state_t_26;
struct __anonstruct_random8_state_t_26;
struct __anonstruct_random32_state_t_27;
struct __anonstruct_random64_state_t_28;
struct __anonstruct_random128_state_t_29;
struct __anonstruct_random256_state_t_30;
struct __anonstruct_cmrg_state_t_26;
struct __anonstruct_mt_state_t_26;
struct __anonstruct_gsl_root_fdfsolver_type_28;
struct __anonstruct_newton_state_t_30;
struct __anonstruct_gsl_root_fdfsolver_29;
struct __anonstruct_steffenson_state_t_30;
struct __anonstruct_gsl_root_fsolver_type_26;
struct __anonstruct_bisection_state_t_30;
struct __anonstruct_gsl_root_fsolver_27;
struct __anonstruct_brent_state_t_30;
struct __anonstruct_secant_state_t_30;
struct __anonstruct_falsepos_state_t_30;
struct __anonstruct_gsl_siman_params_t_28;
struct cheb_series_struct;
struct gsl_sf_result_e10_struct;
struct __anonstruct_gsl_sf_mathieu_workspace_127;
struct __anonstruct_fact_table_9;
struct __anonstruct_doub_fact_table_10;
struct __anonstruct_gsl_sum_levin_utrunc_workspace_27;
struct __anonstruct_gsl_sum_levin_u_workspace_26;
struct __anonstruct_gsl_wavelet_type_27;
struct __anonstruct_gsl_wavelet_26;
struct __anonstruct_gsl_wavelet_workspace_27;

typedef struct __anonstruct_gsl_complex_long_double_26 gsl_complex_long_double;
typedef struct __anonstruct_gsl_complex_27 gsl_complex;
typedef struct __anonstruct_gsl_complex_float_28 gsl_complex_float;
typedef struct __anonstruct_gsl_vector_long_double_29 gsl_vector_long_double;
typedef struct __anonstruct_gsl_vector_complex_long_double_32 gsl_vector_complex_long_double;
typedef struct __anonstruct_gsl_vector_35 gsl_vector;
typedef struct __anonstruct_gsl_vector_complex_38 gsl_vector_complex;
typedef struct __anonstruct_gsl_vector_float_41 gsl_vector_float;
typedef struct __anonstruct_gsl_vector_complex_float_44 gsl_vector_complex_float;
typedef struct __anonstruct_gsl_vector_ulong_47 gsl_vector_ulong;
typedef struct __anonstruct_gsl_vector_long_50 gsl_vector_long;
typedef struct __anonstruct_gsl_vector_uint_53 gsl_vector_uint;
typedef struct __anonstruct_gsl_vector_int_56 gsl_vector_int;
typedef struct __anonstruct_gsl_vector_ushort_59 gsl_vector_ushort;
typedef struct __anonstruct_gsl_vector_short_62 gsl_vector_short;
typedef struct __anonstruct_gsl_vector_uchar_65 gsl_vector_uchar;
typedef struct __anonstruct_gsl_vector_char_68 gsl_vector_char;
typedef struct __anonstruct_gsl_matrix_complex_long_double_71 gsl_matrix_complex_long_double;
typedef struct __anonstruct_gsl_matrix_complex_74 gsl_matrix_complex;
typedef struct __anonstruct_gsl_matrix_complex_float_77 gsl_matrix_complex_float;
typedef struct __anonstruct_gsl_matrix_long_double_80 gsl_matrix_long_double;
typedef struct __anonstruct_gsl_matrix_83 gsl_matrix;
typedef struct __anonstruct_gsl_matrix_float_86 gsl_matrix_float;
typedef struct __anonstruct_gsl_matrix_ulong_89 gsl_matrix_ulong;
typedef struct __anonstruct_gsl_matrix_long_92 gsl_matrix_long;
typedef struct __anonstruct_gsl_matrix_uint_95 gsl_matrix_uint;
typedef struct __anonstruct_gsl_matrix_int_98 gsl_matrix_int;
typedef struct __anonstruct_gsl_matrix_ushort_101 gsl_matrix_ushort;
typedef struct __anonstruct_gsl_matrix_short_104 gsl_matrix_short;
typedef struct __anonstruct_gsl_matrix_uchar_107 gsl_matrix_uchar;
typedef struct __anonstruct_gsl_matrix_char_110 gsl_matrix_char;
typedef struct __anonstruct__gsl_vector_view_36 gsl_vector_view;
typedef struct __anonstruct_gsl_bspline_workspace_113 gsl_bspline_workspace;
typedef struct __anonstruct_gsl_bspline_deriv_workspace_114 gsl_bspline_deriv_workspace;
typedef struct __anonstruct__gsl_vector_complex_view_39 gsl_vector_complex_view;
typedef struct __anonstruct__gsl_matrix_view_84 gsl_matrix_view;
typedef struct __anonstruct_gsl_eigen_francis_workspace_117 gsl_eigen_francis_workspace;
typedef struct __anonstruct_gsl_eigen_nonsymm_workspace_118 gsl_eigen_nonsymm_workspace;
typedef struct __anonstruct_gsl_eigen_nonsymmv_workspace_119 gsl_eigen_nonsymmv_workspace;
typedef struct __anonstruct_gsl_eigen_hermv_workspace_117 gsl_eigen_hermv_workspace;
typedef struct __anonstruct_gsl_eigen_symmv_workspace_115 gsl_eigen_symmv_workspace;
typedef struct __anonstruct_gsl_eigen_herm_workspace_116 gsl_eigen_herm_workspace;
typedef struct __anonstruct__gsl_vector_complex_const_view_38 gsl_vector_complex_const_view;
typedef struct __anonstruct__gsl_matrix_complex_view_73 gsl_matrix_complex_view;
typedef struct __anonstruct__gsl_matrix_complex_const_view_74 gsl_matrix_complex_const_view;
typedef struct __anonstruct_gsl_eigen_genherm_workspace_120 gsl_eigen_genherm_workspace;
typedef struct __anonstruct__gsl_matrix_const_view_85 gsl_matrix_const_view;
typedef struct __anonstruct_gsl_eigen_gen_workspace_124 gsl_eigen_gen_workspace;
typedef struct __anonstruct_gsl_eigen_genv_workspace_125 gsl_eigen_genv_workspace;
typedef struct __anonstruct_gsl_eigen_symm_workspace_114 gsl_eigen_symm_workspace;
typedef struct __anonstruct_gsl_eigen_gensymmv_workspace_119 gsl_eigen_gensymmv_workspace;
typedef struct __anonstruct__gsl_vector_const_view_35 gsl_vector_const_view;
typedef struct __anonstruct_gsl_eigen_gensymm_workspace_118 gsl_eigen_gensymm_workspace;
typedef struct __anonstruct_gsl_eigen_genhermv_workspace_121 gsl_eigen_genhermv_workspace;
typedef struct __anonstruct_gsl_fft_complex_wavetable_30 gsl_fft_complex_wavetable;
typedef struct __anonstruct_gsl_fft_complex_workspace_31 gsl_fft_complex_workspace;
typedef struct __anonstruct_gsl_fft_complex_wavetable_float_32 gsl_fft_complex_wavetable_float;
typedef struct __anonstruct_gsl_fft_complex_workspace_float_33 gsl_fft_complex_workspace_float;
typedef struct __anonstruct_gsl_fft_real_wavetable_34 gsl_fft_real_wavetable;
typedef struct __anonstruct_gsl_fft_real_workspace_35 gsl_fft_real_workspace;
typedef struct __anonstruct_gsl_fft_halfcomplex_wavetable_36 gsl_fft_halfcomplex_wavetable;
typedef struct __anonstruct_gsl_fft_real_wavetable_float_37 gsl_fft_real_wavetable_float;
typedef struct __anonstruct_gsl_fft_real_workspace_float_38 gsl_fft_real_workspace_float;
typedef struct __anonstruct_gsl_fft_halfcomplex_wavetable_float_39 gsl_fft_halfcomplex_wavetable_float;
typedef struct __anonstruct_gsl_histogram2d_24 gsl_histogram2d;
typedef struct __anonstruct_gsl_histogram_24 gsl_histogram;
typedef struct __anonstruct_gsl_histogram_pdf_25 gsl_histogram_pdf;
typedef struct __anonstruct_gsl_histogram2d_pdf_27 gsl_histogram2d_pdf;
typedef struct __anonstruct_gsl_ieee_float_rep_7 gsl_ieee_float_rep;
typedef struct __anonstruct_gsl_ieee_double_rep_8 gsl_ieee_double_rep;
typedef struct __anonstruct_gsl_integration_workspace_26 gsl_integration_workspace;
typedef struct __anonstruct_gsl_integration_qawo_table_23 gsl_integration_qawo_table;
typedef struct __anonstruct_gsl_integration_qaws_table_22 gsl_integration_qaws_table;
typedef struct __anonstruct_gsl_integration_glfixed_table_30 gsl_integration_glfixed_table;
typedef struct __anonstruct_gsl_interp_accel_112 gsl_interp_accel;
typedef struct __anonstruct_gsl_interp_type_113 gsl_interp_type;
typedef struct __anonstruct_cspline_state_t_115 cspline_state_t;
typedef struct __anonstruct_gsl_interp_28 gsl_interp;
typedef struct __anonstruct_polynomial_state_t_33 polynomial_state_t;
typedef struct __anonstruct_gsl_spline_27 gsl_spline;
typedef struct __anonstruct_akima_state_t_29 akima_state_t;
typedef struct __anonstruct__gsl_vector_long_double_view_30 _gsl_vector_long_double_view;
typedef struct __anonstruct__gsl_vector_long_double_const_view_31 _gsl_vector_long_double_const_view;
typedef struct __anonstruct__gsl_vector_complex_long_double_view_33 _gsl_vector_complex_long_double_view;
typedef struct __anonstruct__gsl_vector_complex_long_double_const_view_34 _gsl_vector_complex_long_double_const_view;
typedef struct __anonstruct__gsl_vector_float_view_48 _gsl_vector_float_view;
typedef struct __anonstruct__gsl_vector_float_const_view_49 _gsl_vector_float_const_view;
typedef struct __anonstruct__gsl_vector_complex_float_view_51 _gsl_vector_complex_float_view;
typedef struct __anonstruct__gsl_vector_complex_float_const_view_52 _gsl_vector_complex_float_const_view;
typedef struct __anonstruct__gsl_vector_ulong_view_66 _gsl_vector_ulong_view;
typedef struct __anonstruct__gsl_vector_ulong_const_view_67 _gsl_vector_ulong_const_view;
typedef struct __anonstruct__gsl_vector_long_view_72 _gsl_vector_long_view;
typedef struct __anonstruct__gsl_vector_long_const_view_73 _gsl_vector_long_const_view;
typedef struct __anonstruct__gsl_vector_uint_view_78 _gsl_vector_uint_view;
typedef struct __anonstruct__gsl_vector_uint_const_view_79 _gsl_vector_uint_const_view;
typedef struct __anonstruct__gsl_vector_int_view_84 _gsl_vector_int_view;
typedef struct __anonstruct__gsl_vector_int_const_view_85 _gsl_vector_int_const_view;
typedef struct __anonstruct__gsl_vector_ushort_view_90 _gsl_vector_ushort_view;
typedef struct __anonstruct__gsl_vector_ushort_const_view_91 _gsl_vector_ushort_const_view;
typedef struct __anonstruct__gsl_vector_short_view_96 _gsl_vector_short_view;
typedef struct __anonstruct__gsl_vector_short_const_view_97 _gsl_vector_short_const_view;
typedef struct __anonstruct__gsl_vector_uchar_view_102 _gsl_vector_uchar_view;
typedef struct __anonstruct__gsl_vector_uchar_const_view_103 _gsl_vector_uchar_const_view;
typedef struct __anonstruct__gsl_vector_char_view_108 _gsl_vector_char_view;
typedef struct __anonstruct__gsl_vector_char_const_view_109 _gsl_vector_char_const_view;
typedef struct __anonstruct__gsl_matrix_complex_long_double_view_34 _gsl_matrix_complex_long_double_view;
typedef struct __anonstruct__gsl_matrix_complex_long_double_const_view_35 _gsl_matrix_complex_long_double_const_view;
typedef struct __anonstruct__gsl_matrix_complex_float_view_52 _gsl_matrix_complex_float_view;
typedef struct __anonstruct__gsl_matrix_complex_float_const_view_53 _gsl_matrix_complex_float_const_view;
typedef struct __anonstruct__gsl_matrix_long_double_view_55 _gsl_matrix_long_double_view;
typedef struct __anonstruct__gsl_matrix_long_double_const_view_56 _gsl_matrix_long_double_const_view;
typedef struct __anonstruct__gsl_matrix_float_view_61 _gsl_matrix_float_view;
typedef struct __anonstruct__gsl_matrix_float_const_view_62 _gsl_matrix_float_const_view;
typedef struct __anonstruct__gsl_matrix_ulong_view_67 _gsl_matrix_ulong_view;
typedef struct __anonstruct__gsl_matrix_ulong_const_view_68 _gsl_matrix_ulong_const_view;
typedef struct __anonstruct__gsl_matrix_long_view_73 _gsl_matrix_long_view;
typedef struct __anonstruct__gsl_matrix_long_const_view_74 _gsl_matrix_long_const_view;
typedef struct __anonstruct__gsl_matrix_uint_view_79 _gsl_matrix_uint_view;
typedef struct __anonstruct__gsl_matrix_uint_const_view_80 _gsl_matrix_uint_const_view;
typedef struct __anonstruct__gsl_matrix_int_view_85 _gsl_matrix_int_view;
typedef struct __anonstruct__gsl_matrix_int_const_view_86 _gsl_matrix_int_const_view;
typedef struct __anonstruct__gsl_matrix_ushort_view_91 _gsl_matrix_ushort_view;
typedef struct __anonstruct__gsl_matrix_ushort_const_view_92 _gsl_matrix_ushort_const_view;
typedef struct __anonstruct__gsl_matrix_short_view_97 _gsl_matrix_short_view;
typedef struct __anonstruct__gsl_matrix_short_const_view_98 _gsl_matrix_short_const_view;
typedef struct __anonstruct__gsl_matrix_uchar_view_103 _gsl_matrix_uchar_view;
typedef struct __anonstruct__gsl_matrix_uchar_const_view_104 _gsl_matrix_uchar_const_view;
typedef struct __anonstruct__gsl_matrix_char_view_109 _gsl_matrix_char_view;
typedef struct __anonstruct__gsl_matrix_char_const_view_110 _gsl_matrix_char_const_view;
typedef struct __anonstruct_gsl_min_fminimizer_type_26 gsl_min_fminimizer_type;
typedef struct __anonstruct_quad_golden_state_t_28 quad_golden_state_t;
typedef struct __anonstruct_gsl_min_fminimizer_27 gsl_min_fminimizer;
typedef struct __anonstruct_goldensection_state_t_28 goldensection_state_t;
typedef struct __anonstruct_brent_state_t_28 brent_state_t;
typedef struct __anonstruct_gsl_rng_type_26 gsl_rng_type;
typedef struct __anonstruct_gsl_rng_27 gsl_rng;
typedef struct __anonstruct_gsl_monte_miser_state_29 gsl_monte_miser_state;
typedef struct __anonstruct_gsl_monte_miser_params_30 gsl_monte_miser_params;
typedef struct __anonstruct_gsl_monte_vegas_state_29 gsl_monte_vegas_state;
typedef struct __anonstruct_gsl_monte_vegas_params_30 gsl_monte_vegas_params;
typedef struct __anonstruct_gsl_monte_plain_state_28 gsl_monte_plain_state;
typedef struct __anonstruct_gsl_multifit_fdfsolver_type_115 gsl_multifit_fdfsolver_type;
typedef struct __anonstruct_lmder_state_t_118 lmder_state_t;
typedef struct __anonstruct_gsl_multifit_fdfsolver_116 gsl_multifit_fdfsolver;
typedef struct __anonstruct_gsl_multifit_fsolver_type_113 gsl_multifit_fsolver_type;
typedef struct __anonstruct_gsl_multifit_fsolver_114 gsl_multifit_fsolver;
typedef struct __anonstruct_gsl_multifit_linear_workspace_113 gsl_multifit_linear_workspace;
typedef struct __anonstruct_gsl_multimin_fdfminimizer_type_117 gsl_multimin_fdfminimizer_type;
typedef struct __anonstruct_gsl_multimin_fdfminimizer_118 gsl_multimin_fdfminimizer;
typedef struct __anonstruct_gsl_multimin_fminimizer_type_115 gsl_multimin_fminimizer_type;
typedef struct __anonstruct_nmsimplex_state_t_119 nmsimplex_state_t;
typedef struct __anonstruct_vector_bfgs_state_t_119 vector_bfgs_state_t;
typedef struct __anonstruct_conjugate_pr_state_t_119 conjugate_pr_state_t;
typedef struct __anonstruct_steepest_descent_state_t_119 steepest_descent_state_t;
typedef struct __anonstruct_conjugate_fr_state_t_119 conjugate_fr_state_t;
typedef struct __anonstruct_wrapper_t_120 wrapper_t;
typedef struct __anonstruct_vector_bfgs2_state_t_121 vector_bfgs2_state_t;
typedef struct __anonstruct_nmsimplex_state_t_119___0 nmsimplex_state_t___0;
typedef struct __anonstruct_gsl_multimin_fminimizer_116 gsl_multimin_fminimizer;
typedef struct __anonstruct_gsl_multiroot_fdfsolver_type_115 gsl_multiroot_fdfsolver_type;
typedef struct __anonstruct_newton_state_t_118 newton_state_t;
typedef struct __anonstruct_gsl_multiroot_fdfsolver_116 gsl_multiroot_fdfsolver;
typedef struct __anonstruct_gnewton_state_t_118 gnewton_state_t;
typedef struct __anonstruct_hybridj_state_t_118 hybridj_state_t;
typedef struct __anonstruct_gsl_multiroot_fsolver_type_113 gsl_multiroot_fsolver_type;
typedef struct __anonstruct_gsl_multiroot_fsolver_114 gsl_multiroot_fsolver;
typedef struct __anonstruct_hybrid_state_t_118 hybrid_state_t;
typedef struct __anonstruct_dnewton_state_t_118 dnewton_state_t;
typedef struct __anonstruct_broyden_state_t_118 broyden_state_t;
typedef struct __anonstruct_gsl_ntuple_26 gsl_ntuple;
typedef struct __anonstruct_gsl_ntuple_select_fn_27 gsl_ntuple_select_fn;
typedef struct __anonstruct_gsl_ntuple_value_fn_28 gsl_ntuple_value_fn;
typedef struct __anonstruct_gsl_odeiv_system_24 gsl_odeiv_system;
typedef struct __anonstruct_gsl_odeiv_step_type_25 gsl_odeiv_step_type;
typedef struct __anonstruct_rk8pd_state_t_30 rk8pd_state_t;
typedef struct __anonstruct_rkck_state_t_30 rkck_state_t;
typedef struct __anonstruct_gsl_odeiv_step_28 gsl_odeiv_step;
typedef struct __anonstruct_gsl_odeiv_control_type_29 gsl_odeiv_control_type;
typedef struct __anonstruct_gsl_odeiv_control_30 gsl_odeiv_control;
typedef struct __anonstruct_gsl_odeiv_evolve_31 gsl_odeiv_evolve;
typedef struct __anonstruct_rk2imp_state_t_32 rk2imp_state_t;
typedef struct __anonstruct_std_control_state_t_32 std_control_state_t;
typedef struct __anonstruct_rk2_state_t_30 rk2_state_t;
typedef struct __anonstruct_gear1_state_t_32 gear1_state_t;
typedef struct __anonstruct_rk2simp_state_t_120 rk2simp_state_t;
typedef struct __anonstruct_sc_control_state_t_32 sc_control_state_t;
typedef struct __anonstruct_rk4imp_state_t_32 rk4imp_state_t;
typedef struct __anonstruct_gear2_state_t_32 gear2_state_t;
typedef struct __anonstruct_rkf45_state_t_30 rkf45_state_t;
typedef struct __anonstruct_rk4_state_t_30 rk4_state_t;
typedef struct __anonstruct_bsimp_state_t_120 bsimp_state_t;
typedef struct __anonstruct_gsl_poly_complex_workspace_24 gsl_poly_complex_workspace;
typedef struct __anonstruct_gsl_qrng_type_24 gsl_qrng_type;
typedef struct __anonstruct_gsl_qrng_25 gsl_qrng;
typedef struct __anonstruct_reversehalton_state_t_26 reversehalton_state_t;
typedef struct __anonstruct_sobol_state_t_26 sobol_state_t;
typedef struct __anonstruct_nied2_state_t_26 nied2_state_t;
typedef struct __anonstruct_halton_state_t_26 halton_state_t;
typedef struct __anonstruct_gsl_ran_discrete_t_28 gsl_ran_discrete_t;
typedef struct __anonstruct_gsl_stack_t_29 gsl_stack_t;
typedef struct __anonstruct_ran_state_t_26 ran_state_t;
typedef struct __anonstruct_zuf_state_t_26 zuf_state_t;
typedef struct __anonstruct_ranlxs_state_t_26 ranlxs_state_t;
typedef struct __anonstruct_randu_state_t_26 randu_state_t;
typedef struct __anonstruct_uni32_state_t_26 uni32_state_t;
typedef struct __anonstruct_ran1_state_t_26 ran1_state_t;
typedef struct __anonstruct_ran2_state_t_26 ran2_state_t;
typedef struct __anonstruct_ran0_state_t_26 ran0_state_t;
typedef struct __anonstruct_ran_state_t_26___0 ran_state_t___0;
typedef struct __anonstruct_tt_state_t_26 tt_state_t;
typedef struct __anonstruct_vax_state_t_26 vax_state_t;
typedef struct __anonstruct_ranmar_state_t_26 ranmar_state_t;
typedef struct __anonstruct_ran_state_t_26___1 ran_state_t___1;
typedef struct __anonstruct_ranf_state_t_28 ranf_state_t;
typedef struct __anonstruct_ran_state_t_26___2 ran_state_t___2;
typedef struct __anonstruct_ranlxd_state_t_26 ranlxd_state_t;
typedef struct __anonstruct_slatec_state_t_26 slatec_state_t;
typedef struct __anonstruct_transputer_state_t_26 transputer_state_t;
typedef struct __anonstruct_uni_state_t_26 uni_state_t;
typedef struct __anonstruct_taus_state_t_26 taus_state_t;
typedef struct __anonstruct_ran_state_t_26___3 ran_state_t___3;
typedef struct __anonstruct_taus113_state_t_26 taus113_state_t;
typedef struct __anonstruct_rand_state_t_26 rand_state_t;
typedef struct __anonstruct_ranlux_state_t_26 ranlux_state_t;
typedef struct __anonstruct_rand48_state_t_28 rand48_state_t;
typedef struct __anonstruct_r250_state_t_26 r250_state_t;
typedef struct __anonstruct_ran3_state_t_26 ran3_state_t;
typedef struct __anonstruct_minstd_state_t_26 minstd_state_t;
typedef struct __anonstruct_gfsr4_state_t_26 gfsr4_state_t;
typedef struct __anonstruct_mrg_state_t_26 mrg_state_t;
typedef struct __anonstruct_random8_state_t_26 random8_state_t;
typedef struct __anonstruct_random32_state_t_27 random32_state_t;
typedef struct __anonstruct_random64_state_t_28 random64_state_t;
typedef struct __anonstruct_random128_state_t_29 random128_state_t;
typedef struct __anonstruct_random256_state_t_30 random256_state_t;
typedef struct __anonstruct_cmrg_state_t_26 cmrg_state_t;
typedef struct __anonstruct_mt_state_t_26 mt_state_t;
typedef struct __anonstruct_gsl_root_fdfsolver_type_28 gsl_root_fdfsolver_type;
typedef struct __anonstruct_newton_state_t_30 newton_state_t___0;
typedef struct __anonstruct_gsl_root_fdfsolver_29 gsl_root_fdfsolver;
typedef struct __anonstruct_steffenson_state_t_30 steffenson_state_t;
typedef struct __anonstruct_gsl_root_fsolver_type_26 gsl_root_fsolver_type;
typedef struct __anonstruct_bisection_state_t_30 bisection_state_t;
typedef struct __anonstruct_gsl_root_fsolver_27 gsl_root_fsolver;
typedef struct __anonstruct_brent_state_t_30 brent_state_t___0;
typedef struct __anonstruct_secant_state_t_30 secant_state_t;
typedef struct __anonstruct_falsepos_state_t_30 falsepos_state_t;
typedef struct __anonstruct_gsl_siman_params_t_28 gsl_siman_params_t;
typedef struct __anonstruct_gsl_sf_mathieu_workspace_127 gsl_sf_mathieu_workspace;
typedef struct __anonstruct_gsl_sum_levin_utrunc_workspace_27 gsl_sum_levin_utrunc_workspace;
typedef struct __anonstruct_gsl_sum_levin_u_workspace_26 gsl_sum_levin_u_workspace;
typedef struct __anonstruct_gsl_wavelet_type_27 gsl_wavelet_type;
typedef struct __anonstruct_gsl_wavelet_26 gsl_wavelet;
typedef struct __anonstruct_gsl_wavelet_workspace_27 gsl_wavelet_workspace;

struct gsl_block_complex_long_double_struct {
	unsigned int size;
	long double * data;
};
struct gsl_block_complex_struct {
	unsigned int size;
	double * data;
};
struct gsl_block_complex_float_struct {
	unsigned int size;
	float * data;
};
struct gsl_block_long_double_struct {
	unsigned int size;
	long double * data;
};
struct gsl_block_struct {
	unsigned int size;
	double * data;
};
struct gsl_block_float_struct {
	unsigned int size;
	float * data;
};
struct gsl_block_ulong_struct {
	unsigned int size;
	unsigned long * data;
};
struct gsl_block_long_struct {
	unsigned int size;
	long * data;
};
struct gsl_block_uint_struct {
	unsigned int size;
	unsigned int * data;
};
struct gsl_block_int_struct {
	unsigned int size;
	int * data;
};
struct gsl_block_ushort_struct {
	unsigned int size;
	unsigned short * data;
};
struct gsl_block_short_struct {
	unsigned int size;
	short * data;
};
struct gsl_block_uchar_struct {
	unsigned int size;
	unsigned char * data;
};
struct gsl_block_char_struct {
	unsigned int size;
	char * data;
};
struct __anonstruct_gsl_complex_long_double_26 {
	long double dat[2];
};
struct __anonstruct_gsl_complex_27 {
	double dat[2];
};
struct __anonstruct_gsl_complex_float_28 {
	float dat[2];
};
struct __anonstruct_gsl_vector_long_double_29 {
	unsigned int size;
	unsigned int stride;
	long double * data;
	struct gsl_block_long_double_struct * block;
	int owner;
};
struct __anonstruct_gsl_vector_complex_long_double_32 {
	unsigned int size;
	unsigned int stride;
	long double * data;
	struct gsl_block_complex_long_double_struct * block;
	int owner;
};
struct __anonstruct_gsl_vector_35 {
	unsigned int size;
	unsigned int stride;
	double * data;
	struct gsl_block_struct * block;
	int owner;
};
struct __anonstruct_gsl_vector_complex_38 {
	unsigned int size;
	unsigned int stride;
	double * data;
	struct gsl_block_complex_struct * block;
	int owner;
};
struct __anonstruct_gsl_vector_float_41 {
	unsigned int size;
	unsigned int stride;
	float * data;
	struct gsl_block_float_struct * block;
	int owner;
};
struct __anonstruct_gsl_vector_complex_float_44 {
	unsigned int size;
	unsigned int stride;
	float * data;
	struct gsl_block_complex_float_struct * block;
	int owner;
};
struct __anonstruct_gsl_vector_ulong_47 {
	unsigned int size;
	unsigned int stride;
	unsigned long * data;
	struct gsl_block_ulong_struct * block;
	int owner;
};
struct __anonstruct_gsl_vector_long_50 {
	unsigned int size;
	unsigned int stride;
	long * data;
	struct gsl_block_long_struct * block;
	int owner;
};
struct __anonstruct_gsl_vector_uint_53 {
	unsigned int size;
	unsigned int stride;
	unsigned int * data;
	struct gsl_block_uint_struct * block;
	int owner;
};
struct __anonstruct_gsl_vector_int_56 {
	unsigned int size;
	unsigned int stride;
	int * data;
	struct gsl_block_int_struct * block;
	int owner;
};
struct __anonstruct_gsl_vector_ushort_59 {
	unsigned int size;
	unsigned int stride;
	unsigned short * data;
	struct gsl_block_ushort_struct * block;
	int owner;
};
struct __anonstruct_gsl_vector_short_62 {
	unsigned int size;
	unsigned int stride;
	short * data;
	struct gsl_block_short_struct * block;
	int owner;
};
struct __anonstruct_gsl_vector_uchar_65 {
	unsigned int size;
	unsigned int stride;
	unsigned char * data;
	struct gsl_block_uchar_struct * block;
	int owner;
};
struct __anonstruct_gsl_vector_char_68 {
	unsigned int size;
	unsigned int stride;
	char * data;
	struct gsl_block_char_struct * block;
	int owner;
};
struct __anonstruct_gsl_matrix_complex_long_double_71 {
	unsigned int size1;
	unsigned int size2;
	unsigned int tda;
	long double * data;
	struct gsl_block_complex_long_double_struct * block;
	int owner;
};
struct __anonstruct_gsl_matrix_complex_74 {
	unsigned int size1;
	unsigned int size2;
	unsigned int tda;
	double * data;
	struct gsl_block_complex_struct * block;
	int owner;
};
struct __anonstruct_gsl_matrix_complex_float_77 {
	unsigned int size1;
	unsigned int size2;
	unsigned int tda;
	float * data;
	struct gsl_block_complex_float_struct * block;
	int owner;
};
struct __anonstruct_gsl_matrix_long_double_80 {
	unsigned int size1;
	unsigned int size2;
	unsigned int tda;
	long double * data;
	struct gsl_block_long_double_struct * block;
	int owner;
};
struct __anonstruct_gsl_matrix_83 {
	unsigned int size1;
	unsigned int size2;
	unsigned int tda;
	double * data;
	struct gsl_block_struct * block;
	int owner;
};
struct __anonstruct_gsl_matrix_float_86 {
	unsigned int size1;
	unsigned int size2;
	unsigned int tda;
	float * data;
	struct gsl_block_float_struct * block;
	int owner;
};
struct __anonstruct_gsl_matrix_ulong_89 {
	unsigned int size1;
	unsigned int size2;
	unsigned int tda;
	unsigned long * data;
	struct gsl_block_ulong_struct * block;
	int owner;
};
struct __anonstruct_gsl_matrix_long_92 {
	unsigned int size1;
	unsigned int size2;
	unsigned int tda;
	long * data;
	struct gsl_block_long_struct * block;
	int owner;
};
struct __anonstruct_gsl_matrix_uint_95 {
	unsigned int size1;
	unsigned int size2;
	unsigned int tda;
	unsigned int * data;
	struct gsl_block_uint_struct * block;
	int owner;
};
struct __anonstruct_gsl_matrix_int_98 {
	unsigned int size1;
	unsigned int size2;
	unsigned int tda;
	int * data;
	struct gsl_block_int_struct * block;
	int owner;
};
struct __anonstruct_gsl_matrix_ushort_101 {
	unsigned int size1;
	unsigned int size2;
	unsigned int tda;
	unsigned short * data;
	struct gsl_block_ushort_struct * block;
	int owner;
};
struct __anonstruct_gsl_matrix_short_104 {
	unsigned int size1;
	unsigned int size2;
	unsigned int tda;
	short * data;
	struct gsl_block_short_struct * block;
	int owner;
};
struct __anonstruct_gsl_matrix_uchar_107 {
	unsigned int size1;
	unsigned int size2;
	unsigned int tda;
	unsigned char * data;
	struct gsl_block_uchar_struct * block;
	int owner;
};
struct __anonstruct_gsl_matrix_char_110 {
	unsigned int size1;
	unsigned int size2;
	unsigned int tda;
	char * data;
	struct gsl_block_char_struct * block;
	int owner;
};
struct __anonstruct__gsl_vector_view_36 {
	gsl_vector vector;
};
struct __anonstruct_gsl_bspline_workspace_113 {
	unsigned int k;
	unsigned int km1;
	unsigned int l;
	unsigned int nbreak;
	unsigned int n;
	gsl_vector * knots;
	gsl_vector * deltal;
	gsl_vector * deltar;
	gsl_vector * B;
};
struct __anonstruct_gsl_bspline_deriv_workspace_114 {
	unsigned int k;
	gsl_matrix * A;
	gsl_matrix * dB;
};
struct gsl_cheb_series_struct {
	double * c;
	unsigned int order;
	double a;
	double b;
	unsigned int order_sp;
	double * f;
};
struct gsl_function_struct {
	double( * function)(double x, void * params);
	void * params;
};
struct gsl_sf_result_struct {
	double val;
	double err;
};
struct gsl_dht_struct {
	unsigned int size;
	double nu;
	double xmax;
	double kmax;
	double * j;
	double * Jjj;
	double * J2;
};
struct __anonstruct__gsl_vector_complex_view_39 {
	gsl_vector_complex vector;
};
struct __anonstruct__gsl_matrix_view_84 {
	gsl_matrix matrix;
};
struct __anonstruct_gsl_eigen_francis_workspace_117 {
	unsigned int size;
	unsigned int max_iterations;
	unsigned int n_iter;
	unsigned int n_evals;
	int compute_t;
	gsl_matrix * H;
	gsl_matrix * Z;
};
struct __anonstruct_gsl_eigen_nonsymm_workspace_118 {
	unsigned int size;
	gsl_vector * diag;
	gsl_vector * tau;
	gsl_matrix * Z;
	int do_balance;
	unsigned int n_evals;
	gsl_eigen_francis_workspace * francis_workspace_p;
};
struct __anonstruct_gsl_eigen_nonsymmv_workspace_119 {
	unsigned int size;
	gsl_vector * work;
	gsl_vector * work2;
	gsl_vector * work3;
	gsl_matrix * Z;
	gsl_eigen_nonsymm_workspace * nonsymm_workspace_p;
};
struct gsl_permutation_struct {
	unsigned int size;
	unsigned int * data;
};
struct __anonstruct_gsl_eigen_hermv_workspace_117 {
	unsigned int size;
	double * d;
	double * sd;
	double * tau;
	double * gc;
	double * gs;
};
struct __anonstruct_gsl_eigen_symmv_workspace_115 {
	unsigned int size;
	double * d;
	double * sd;
	double * gc;
	double * gs;
};
struct __anonstruct_gsl_eigen_herm_workspace_116 {
	unsigned int size;
	double * d;
	double * sd;
	double * tau;
};
struct __anonstruct__gsl_vector_complex_const_view_38 {
	gsl_vector_complex vector;
};
struct __anonstruct__gsl_matrix_complex_view_73 {
	gsl_matrix_complex matrix;
};
struct __anonstruct__gsl_matrix_complex_const_view_74 {
	gsl_matrix_complex matrix;
};
struct __anonstruct_gsl_eigen_genherm_workspace_120 {
	unsigned int size;
	gsl_eigen_herm_workspace * herm_workspace_p;
};
struct __anonstruct__gsl_matrix_const_view_85 {
	gsl_matrix matrix;
};
struct __anonstruct_gsl_eigen_gen_workspace_124 {
	unsigned int size;
	gsl_vector * work;
	unsigned int n_evals;
	unsigned int max_iterations;
	unsigned int n_iter;
	double eshift;
	int needtop;
	double atol;
	double btol;
	double ascale;
	double bscale;
	gsl_matrix * H;
	gsl_matrix * R;
	int compute_s;
	int compute_t;
	gsl_matrix * Q;
	gsl_matrix * Z;
};
struct __anonstruct_gsl_eigen_genv_workspace_125 {
	unsigned int size;
	gsl_vector * work1;
	gsl_vector * work2;
	gsl_vector * work3;
	gsl_vector * work4;
	gsl_vector * work5;
	gsl_vector * work6;
	gsl_matrix * Q;
	gsl_matrix * Z;
	gsl_eigen_gen_workspace * gen_workspace_p;
};
struct __anonstruct_gsl_eigen_symm_workspace_114 {
	unsigned int size;
	double * d;
	double * sd;
};
struct __anonstruct_gsl_eigen_gensymmv_workspace_119 {
	unsigned int size;
	gsl_eigen_symmv_workspace * symmv_workspace_p;
};
struct __anonstruct__gsl_vector_const_view_35 {
	gsl_vector vector;
};
struct __anonstruct_gsl_eigen_gensymm_workspace_118 {
	unsigned int size;
	gsl_eigen_symm_workspace * symm_workspace_p;
};
struct __anonstruct_gsl_eigen_genhermv_workspace_121 {
	unsigned int size;
	gsl_eigen_hermv_workspace * hermv_workspace_p;
};
struct __anonstruct_gsl_fft_complex_wavetable_30 {
	unsigned int n;
	unsigned int nf;
	unsigned int factor[64];
	gsl_complex * twiddle[64];
	gsl_complex * trig;
};
struct __anonstruct_gsl_fft_complex_workspace_31 {
	unsigned int n;
	double * scratch;
};
struct __anonstruct_gsl_fft_complex_wavetable_float_32 {
	unsigned int n;
	unsigned int nf;
	unsigned int factor[64];
	gsl_complex_float * twiddle[64];
	gsl_complex_float * trig;
};
struct __anonstruct_gsl_fft_complex_workspace_float_33 {
	unsigned int n;
	float * scratch;
};
struct __anonstruct_gsl_fft_real_wavetable_34 {
	unsigned int n;
	unsigned int nf;
	unsigned int factor[64];
	gsl_complex * twiddle[64];
	gsl_complex * trig;
};
struct __anonstruct_gsl_fft_real_workspace_35 {
	unsigned int n;
	double * scratch;
};
struct __anonstruct_gsl_fft_halfcomplex_wavetable_36 {
	unsigned int n;
	unsigned int nf;
	unsigned int factor[64];
	gsl_complex * twiddle[64];
	gsl_complex * trig;
};
struct __anonstruct_gsl_fft_real_wavetable_float_37 {
	unsigned int n;
	unsigned int nf;
	unsigned int factor[64];
	gsl_complex_float * twiddle[64];
	gsl_complex_float * trig;
};
struct __anonstruct_gsl_fft_real_workspace_float_38 {
	unsigned int n;
	float * scratch;
};
struct __anonstruct_gsl_fft_halfcomplex_wavetable_float_39 {
	unsigned int n;
	unsigned int nf;
	unsigned int factor[64];
	gsl_complex_float * twiddle[64];
	gsl_complex_float * trig;
};
struct __anonstruct_gsl_histogram2d_24 {
	unsigned int nx;
	unsigned int ny;
	double * xrange;
	double * yrange;
	double * bin;
};
struct __anonstruct_gsl_histogram_24 {
	unsigned int n;
	double * range;
	double * bin;
};
struct __anonstruct_gsl_histogram_pdf_25 {
	unsigned int n;
	double * range;
	double * sum;
};
struct __anonstruct_gsl_histogram2d_pdf_27 {
	unsigned int nx;
	unsigned int ny;
	double * xrange;
	double * yrange;
	double * sum;
};
struct __anonstruct_gsl_ieee_float_rep_7 {
	int sign;
	char mantissa[24];
	int exponent;
	int type;
};
struct __anonstruct_gsl_ieee_double_rep_8 {
	int sign;
	char mantissa[53];
	int exponent;
	int type;
};
union __anonunion_u_29 {
	long l;
	char c[sizeof(long)];
};
union __anonunion_u_30 {
	float f;
	unsigned char b[4];
};
union __anonunion_u_31 {
	double d;
	unsigned char b[8];
};
struct __anonstruct_ieee_33 {
	unsigned char byte[4];
};
union __anonunion_u_32 {
	float f;
	struct __anonstruct_ieee_33 ieee;
};
struct __anonstruct_ieee_35 {
	unsigned char byte[8];
};
union __anonunion_u_34 {
	double d;
	struct __anonstruct_ieee_35 ieee;
};
struct __anonstruct_gsl_integration_workspace_26 {
	unsigned int limit;
	unsigned int size;
	unsigned int nrmax;
	unsigned int i;
	unsigned int maximum_level;
	double * alist;
	double * blist;
	double * rlist;
	double * elist;
	unsigned int * order;
	unsigned int * level;
};
struct extrapolation_table {
	unsigned int n;
	double rlist2[52];
	unsigned int nres;
	double res3la[3];
};
struct il_params {
	double b;
	struct gsl_function_struct * f;
};
struct iu_params {
	double a;
	struct gsl_function_struct * f;
};
struct __anonstruct_gsl_integration_qawo_table_23 {
	unsigned int n;
	double omega;
	double L;
	double par;
	int sine;
	double * chebmo;
};
struct __anonstruct_gsl_integration_qaws_table_22 {
	double alpha;
	double beta;
	int mu;
	int nu;
	double ri[25];
	double rj[25];
	double rg[25];
	double rh[25];
};
struct fn_fourier_params {
	struct gsl_function_struct * function;
	double omega;
};
struct fn_cauchy_params {
	struct gsl_function_struct * function;
	double singularity;
};
struct __anonstruct_gsl_integration_glfixed_table_30 {
	unsigned int n;
	double * x;
	double * w;
	int precomputed;
};
struct fn_qaws_params {
	struct gsl_function_struct * function;
	double a;
	double b;
	gsl_integration_qaws_table * table;
};
struct __anonstruct_gsl_interp_accel_112 {
	unsigned int cache;
	unsigned int miss_count;
	unsigned int hit_count;
};
struct __anonstruct_gsl_interp_type_113 {
	char const * name;
	unsigned int min_size;
	void *( * alloc)(unsigned int size);
	int( * init)(void *, double const * xa, double const * ya, unsigned int size);
	int( * eval)(void const *, double const * xa, double const * ya, unsigned int size, double x, gsl_interp_accel *, double * y);
	int( * eval_deriv)(void const *, double const * xa, double const * ya, unsigned int size, double x, gsl_interp_accel *, double * y_p);
	int( * eval_deriv2)(void const *, double const * xa, double const * ya, unsigned int size, double x, gsl_interp_accel *, double * y_pp);
	int( * eval_integ)(void const *, double const * xa, double const * ya, unsigned int size, gsl_interp_accel *, double a, double b, double * result);
	void( * free)(void *);
};
struct __anonstruct_cspline_state_t_115 {
	double * c;
	double * g;
	double * diag;
	double * offdiag;
};
struct __anonstruct_gsl_interp_28 {
	gsl_interp_type * type;
	double xmin;
	double xmax;
	unsigned int size;
	void * state;
};
struct __anonstruct_polynomial_state_t_33 {
	double * d;
	double * coeff;
	double * work;
};
struct __anonstruct_gsl_spline_27 {
	gsl_interp * interp;
	double * x;
	double * y;
	unsigned int size;
};
struct __anonstruct_akima_state_t_29 {
	double * b;
	double * c;
	double * d;
	double * _m;
};
struct moler_vanloan_optimal_suggestion {
	int k;
	int j;
};
struct __anonstruct__gsl_vector_long_double_view_30 {
	gsl_vector_long_double vector;
};
struct __anonstruct__gsl_vector_long_double_const_view_31 {
	gsl_vector_long_double vector;
};
struct __anonstruct__gsl_vector_complex_long_double_view_33 {
	gsl_vector_complex_long_double vector;
};
struct __anonstruct__gsl_vector_complex_long_double_const_view_34 {
	gsl_vector_complex_long_double vector;
};
struct __anonstruct__gsl_vector_float_view_48 {
	gsl_vector_float vector;
};
struct __anonstruct__gsl_vector_float_const_view_49 {
	gsl_vector_float vector;
};
struct __anonstruct__gsl_vector_complex_float_view_51 {
	gsl_vector_complex_float vector;
};
struct __anonstruct__gsl_vector_complex_float_const_view_52 {
	gsl_vector_complex_float vector;
};
struct __anonstruct__gsl_vector_ulong_view_66 {
	gsl_vector_ulong vector;
};
struct __anonstruct__gsl_vector_ulong_const_view_67 {
	gsl_vector_ulong vector;
};
struct __anonstruct__gsl_vector_long_view_72 {
	gsl_vector_long vector;
};
struct __anonstruct__gsl_vector_long_const_view_73 {
	gsl_vector_long vector;
};
struct __anonstruct__gsl_vector_uint_view_78 {
	gsl_vector_uint vector;
};
struct __anonstruct__gsl_vector_uint_const_view_79 {
	gsl_vector_uint vector;
};
struct __anonstruct__gsl_vector_int_view_84 {
	gsl_vector_int vector;
};
struct __anonstruct__gsl_vector_int_const_view_85 {
	gsl_vector_int vector;
};
struct __anonstruct__gsl_vector_ushort_view_90 {
	gsl_vector_ushort vector;
};
struct __anonstruct__gsl_vector_ushort_const_view_91 {
	gsl_vector_ushort vector;
};
struct __anonstruct__gsl_vector_short_view_96 {
	gsl_vector_short vector;
};
struct __anonstruct__gsl_vector_short_const_view_97 {
	gsl_vector_short vector;
};
struct __anonstruct__gsl_vector_uchar_view_102 {
	gsl_vector_uchar vector;
};
struct __anonstruct__gsl_vector_uchar_const_view_103 {
	gsl_vector_uchar vector;
};
struct __anonstruct__gsl_vector_char_view_108 {
	gsl_vector_char vector;
};
struct __anonstruct__gsl_vector_char_const_view_109 {
	gsl_vector_char vector;
};
struct __anonstruct__gsl_matrix_complex_long_double_view_34 {
	gsl_matrix_complex_long_double matrix;
};
struct __anonstruct__gsl_matrix_complex_long_double_const_view_35 {
	gsl_matrix_complex_long_double matrix;
};
struct __anonstruct__gsl_matrix_complex_float_view_52 {
	gsl_matrix_complex_float matrix;
};
struct __anonstruct__gsl_matrix_complex_float_const_view_53 {
	gsl_matrix_complex_float matrix;
};
struct __anonstruct__gsl_matrix_long_double_view_55 {
	gsl_matrix_long_double matrix;
};
struct __anonstruct__gsl_matrix_long_double_const_view_56 {
	gsl_matrix_long_double matrix;
};
struct __anonstruct__gsl_matrix_float_view_61 {
	gsl_matrix_float matrix;
};
struct __anonstruct__gsl_matrix_float_const_view_62 {
	gsl_matrix_float matrix;
};
struct __anonstruct__gsl_matrix_ulong_view_67 {
	gsl_matrix_ulong matrix;
};
struct __anonstruct__gsl_matrix_ulong_const_view_68 {
	gsl_matrix_ulong matrix;
};
struct __anonstruct__gsl_matrix_long_view_73 {
	gsl_matrix_long matrix;
};
struct __anonstruct__gsl_matrix_long_const_view_74 {
	gsl_matrix_long matrix;
};
struct __anonstruct__gsl_matrix_uint_view_79 {
	gsl_matrix_uint matrix;
};
struct __anonstruct__gsl_matrix_uint_const_view_80 {
	gsl_matrix_uint matrix;
};
struct __anonstruct__gsl_matrix_int_view_85 {
	gsl_matrix_int matrix;
};
struct __anonstruct__gsl_matrix_int_const_view_86 {
	gsl_matrix_int matrix;
};
struct __anonstruct__gsl_matrix_ushort_view_91 {
	gsl_matrix_ushort matrix;
};
struct __anonstruct__gsl_matrix_ushort_const_view_92 {
	gsl_matrix_ushort matrix;
};
struct __anonstruct__gsl_matrix_short_view_97 {
	gsl_matrix_short matrix;
};
struct __anonstruct__gsl_matrix_short_const_view_98 {
	gsl_matrix_short matrix;
};
struct __anonstruct__gsl_matrix_uchar_view_103 {
	gsl_matrix_uchar matrix;
};
struct __anonstruct__gsl_matrix_uchar_const_view_104 {
	gsl_matrix_uchar matrix;
};
struct __anonstruct__gsl_matrix_char_view_109 {
	gsl_matrix_char matrix;
};
struct __anonstruct__gsl_matrix_char_const_view_110 {
	gsl_matrix_char matrix;
};
struct __anonstruct_gsl_min_fminimizer_type_26 {
	char const * name;
	unsigned int size;
	int( * set)(void * state, struct gsl_function_struct * f, double x_minimum, double f_minimum, double x_lower, double f_lower, double x_upper, double f_upper);
	int( * iterate)(void * state, struct gsl_function_struct * f, double * x_minimum, double * f_minimum, double * x_lower, double * f_lower, double * x_upper, double * f_upper);
};
struct __anonstruct_quad_golden_state_t_28 {
	double step_size;
	double stored_step;
	double prev_stored_step;
	double x_prev_small;
	double f_prev_small;
	double x_small;
	double f_small;
	unsigned int num_iter;
};
struct __anonstruct_gsl_min_fminimizer_27 {
	gsl_min_fminimizer_type * type;
	struct gsl_function_struct * function;
	double x_minimum;
	double x_lower;
	double x_upper;
	double f_minimum;
	double f_lower;
	double f_upper;
	void * state;
};
struct __anonstruct_goldensection_state_t_28 {
	double dummy;
};
struct __anonstruct_brent_state_t_28 {
	double d;
	double e;
	double v;
	double w;
	double f_v;
	double f_w;
};
struct __anonstruct_gsl_rng_type_26 {
	char const * name;
	unsigned long max;
	unsigned long min;
	unsigned int size;
	void( * set)(void * state, unsigned long seed);
	unsigned long( * get)(void * state);
	double( * get_double)(void * state);
};
struct __anonstruct_gsl_rng_27 {
	gsl_rng_type * type;
	void * state;
};
struct gsl_monte_function_struct {
	double( * f)(double * x_array, unsigned int dim, void * params);
	unsigned int dim;
	void * params;
};
struct __anonstruct_gsl_monte_miser_state_29 {
	unsigned int min_calls;
	unsigned int min_calls_per_bisection;
	double dither;
	double estimate_frac;
	double alpha;
	unsigned int dim;
	int estimate_style;
	int depth;
	int verbose;
	double * x;
	double * xmid;
	double * sigma_l;
	double * sigma_r;
	double * fmax_l;
	double * fmax_r;
	double * fmin_l;
	double * fmin_r;
	double * fsum_l;
	double * fsum_r;
	double * fsum2_l;
	double * fsum2_r;
	unsigned int * hits_l;
	unsigned int * hits_r;
};
struct __anonstruct_gsl_monte_miser_params_30 {
	double estimate_frac;
	unsigned int min_calls;
	unsigned int min_calls_per_bisection;
	double alpha;
	double dither;
};
struct __anonstruct_gsl_monte_vegas_state_29 {
	unsigned int dim;
	unsigned int bins_max;
	unsigned int bins;
	unsigned int boxes;
	double * xi;
	double * xin;
	double * delx;
	double * weight;
	double vol;
	double * x;
	int * bin;
	int * box;
	double * d;
	double alpha;
	int mode;
	int verbose;
	unsigned int iterations;
	int stage;
	double jac;
	double wtd_int_sum;
	double sum_wgts;
	double chi_sum;
	double chisq;
	double result;
	double sigma;
	unsigned int it_start;
	unsigned int it_num;
	unsigned int samples;
	unsigned int calls_per_box;
	struct _IO_FILE * ostream;
};
struct __anonstruct_gsl_monte_vegas_params_30 {
	double alpha;
	unsigned int iterations;
	int stage;
	int mode;
	int verbose;
	struct _IO_FILE * ostream;
};
struct __anonstruct_gsl_monte_plain_state_28 {
	unsigned int dim;
	double * x;
};
struct gsl_multifit_function_fdf_struct {
	int( * f)(gsl_vector * x, void * params, gsl_vector * f);
	int( * df)(gsl_vector * x, void * params, gsl_matrix * df);
	int( * fdf)(gsl_vector * x, void * params, gsl_vector * f, gsl_matrix * df);
	unsigned int n;
	unsigned int p;
	void * params;
};
struct __anonstruct_gsl_multifit_fdfsolver_type_115 {
	char const * name;
	unsigned int size;
	int( * alloc)(void * state, unsigned int n, unsigned int p);
	int( * set)(void * state, struct gsl_multifit_function_fdf_struct * fdf, gsl_vector * x, gsl_vector * f, gsl_matrix * J, gsl_vector * dx);
	int( * iterate)(void * state, struct gsl_multifit_function_fdf_struct * fdf, gsl_vector * x, gsl_vector * f, gsl_matrix * J, gsl_vector * dx);
	void( * free)(void * state);
};
struct __anonstruct_lmder_state_t_118 {
	unsigned int iter;
	double xnorm;
	double fnorm;
	double delta;
	double par;
	gsl_matrix * r;
	gsl_vector * tau;
	gsl_vector * diag;
	gsl_vector * qtf;
	gsl_vector * newton;
	gsl_vector * gradient;
	gsl_vector * x_trial;
	gsl_vector * f_trial;
	gsl_vector * df;
	gsl_vector * sdiag;
	gsl_vector * rptdx;
	gsl_vector * w;
	gsl_vector * work1;
	struct gsl_permutation_struct * perm;
};
struct __anonstruct_gsl_multifit_fdfsolver_116 {
	gsl_multifit_fdfsolver_type * type;
	struct gsl_multifit_function_fdf_struct * fdf;
	gsl_vector * x;
	gsl_vector * f;
	gsl_matrix * J;
	gsl_vector * dx;
	void * state;
};
struct gsl_multifit_function_struct {
	int( * f)(gsl_vector * x, void * params, gsl_vector * f);
	unsigned int n;
	unsigned int p;
	void * params;
};
struct __anonstruct_gsl_multifit_fsolver_type_113 {
	char const * name;
	unsigned int size;
	int( * alloc)(void * state, unsigned int n, unsigned int p);
	int( * set)(void * state, struct gsl_multifit_function_struct * function, gsl_vector * x, gsl_vector * f, gsl_vector * dx);
	int( * iterate)(void * state, struct gsl_multifit_function_struct * function, gsl_vector * x, gsl_vector * f, gsl_vector * dx);
	void( * free)(void * state);
};
struct __anonstruct_gsl_multifit_fsolver_114 {
	gsl_multifit_fsolver_type * type;
	struct gsl_multifit_function_struct * function;
	gsl_vector * x;
	gsl_vector * f;
	gsl_vector * dx;
	void * state;
};
struct __anonstruct_gsl_multifit_linear_workspace_113 {
	unsigned int n;
	unsigned int p;
	gsl_matrix * A;
	gsl_matrix * Q;
	gsl_matrix * QSI;
	gsl_vector * S;
	gsl_vector * t;
	gsl_vector * xt;
	gsl_vector * D;
};
struct gsl_multimin_function_fdf_struct {
	double( * f)(gsl_vector * x, void * params);
	void( * df)(gsl_vector * x, void * params, gsl_vector * df);
	void( * fdf)(gsl_vector * x, void * params, double * f, gsl_vector * df);
	unsigned int n;
	void * params;
};
struct __anonstruct_gsl_multimin_fdfminimizer_type_117 {
	char const * name;
	unsigned int size;
	int( * alloc)(void * state, unsigned int n);
	int( * set)(void * state, struct gsl_multimin_function_fdf_struct * fdf, gsl_vector * x, double * f, gsl_vector * gradient, double step_size, double tol);
	int( * iterate)(void * state, struct gsl_multimin_function_fdf_struct * fdf, gsl_vector * x, double * f, gsl_vector * gradient, gsl_vector * dx);
	int( * restart)(void * state);
	void( * free)(void * state);
};
struct __anonstruct_gsl_multimin_fdfminimizer_118 {
	gsl_multimin_fdfminimizer_type * type;
	struct gsl_multimin_function_fdf_struct * fdf;
	double f;
	gsl_vector * x;
	gsl_vector * gradient;
	gsl_vector * dx;
	void * state;
};
struct gsl_multimin_function_struct {
	double( * f)(gsl_vector * x, void * params);
	unsigned int n;
	void * params;
};
struct __anonstruct_gsl_multimin_fminimizer_type_115 {
	char const * name;
	unsigned int size;
	int( * alloc)(void * state, unsigned int n);
	int( * set)(void * state, struct gsl_multimin_function_struct * f, gsl_vector * x, double * size, gsl_vector * step_size);
	int( * iterate)(void * state, struct gsl_multimin_function_struct * f, gsl_vector * x, double * size, double * fval);
	void( * free)(void * state);
};
struct __anonstruct_nmsimplex_state_t_119 {
	gsl_matrix * x1;
	gsl_vector * y1;
	gsl_vector * ws1;
	gsl_vector * ws2;
};
struct __anonstruct_vector_bfgs_state_t_119 {
	int iter;
	double step;
	double max_step;
	double tol;
	gsl_vector * x1;
	gsl_vector * dx1;
	gsl_vector * x2;
	double g0norm;
	double pnorm;
	gsl_vector * p;
	gsl_vector * x0;
	gsl_vector * g0;
	gsl_vector * dx0;
	gsl_vector * dg0;
};
struct __anonstruct_conjugate_pr_state_t_119 {
	int iter;
	double step;
	double max_step;
	double tol;
	gsl_vector * x1;
	gsl_vector * dx1;
	gsl_vector * x2;
	double pnorm;
	gsl_vector * p;
	double g0norm;
	gsl_vector * g0;
};
struct __anonstruct_steepest_descent_state_t_119 {
	double step;
	double max_step;
	double tol;
	gsl_vector * x1;
	gsl_vector * g1;
};
struct __anonstruct_conjugate_fr_state_t_119 {
	int iter;
	double step;
	double max_step;
	double tol;
	gsl_vector * x1;
	gsl_vector * dx1;
	gsl_vector * x2;
	double pnorm;
	gsl_vector * p;
	double g0norm;
	gsl_vector * g0;
};
struct gsl_function_fdf_struct {
	double( * f)(double x, void * params);
	double( * df)(double x, void * params);
	void( * fdf)(double x, void * params, double * f, double * df);
	void * params;
};
struct __anonstruct_wrapper_t_120 {
	struct gsl_function_fdf_struct fdf_linear;
	struct gsl_multimin_function_fdf_struct * fdf;
	gsl_vector * x;
	gsl_vector * g;
	gsl_vector * p;
	double f_alpha;
	double df_alpha;
	gsl_vector * x_alpha;
	gsl_vector * g_alpha;
	double f_cache_key;
	double df_cache_key;
	double x_cache_key;
	double g_cache_key;
};
struct __anonstruct_vector_bfgs2_state_t_121 {
	int iter;
	double step;
	double g0norm;
	double pnorm;
	double delta_f;
	double fp0;
	gsl_vector * x0;
	gsl_vector * g0;
	gsl_vector * p;
	gsl_vector * dx0;
	gsl_vector * dg0;
	gsl_vector * x_alpha;
	gsl_vector * g_alpha;
	wrapper_t wrap;
	double rho;
	double sigma;
	double tau1;
	double tau2;
	double tau3;
	int order;
};
struct __anonstruct_nmsimplex_state_t_119___0 {
	gsl_matrix * x1;
	gsl_vector * y1;
	gsl_vector * ws1;
	gsl_vector * ws2;
	gsl_vector * center;
	gsl_vector * delta;
	gsl_vector * xmc;
	double S2;
	unsigned long count;
};
struct __anonstruct_gsl_multimin_fminimizer_116 {
	gsl_multimin_fminimizer_type * type;
	struct gsl_multimin_function_struct * f;
	double fval;
	gsl_vector * x;
	double size;
	void * state;
};
struct gsl_multiroot_function_fdf_struct {
	int( * f)(gsl_vector * x, void * params, gsl_vector * f);
	int( * df)(gsl_vector * x, void * params, gsl_matrix * df);
	int( * fdf)(gsl_vector * x, void * params, gsl_vector * f, gsl_matrix * df);
	unsigned int n;
	void * params;
};
struct __anonstruct_gsl_multiroot_fdfsolver_type_115 {
	char const * name;
	unsigned int size;
	int( * alloc)(void * state, unsigned int n);
	int( * set)(void * state, struct gsl_multiroot_function_fdf_struct * fdf, gsl_vector * x, gsl_vector * f, gsl_matrix * J, gsl_vector * dx);
	int( * iterate)(void * state, struct gsl_multiroot_function_fdf_struct * fdf, gsl_vector * x, gsl_vector * f, gsl_matrix * J, gsl_vector * dx);
	void( * free)(void * state);
};
struct __anonstruct_newton_state_t_118 {
	gsl_matrix * lu;
	struct gsl_permutation_struct * permutation;
};
struct __anonstruct_gsl_multiroot_fdfsolver_116 {
	gsl_multiroot_fdfsolver_type * type;
	struct gsl_multiroot_function_fdf_struct * fdf;
	gsl_vector * x;
	gsl_vector * f;
	gsl_matrix * J;
	gsl_vector * dx;
	void * state;
};
struct __anonstruct_gnewton_state_t_118 {
	double phi;
	gsl_vector * x_trial;
	gsl_vector * d;
	gsl_matrix * lu;
	struct gsl_permutation_struct * permutation;
};
struct __anonstruct_hybridj_state_t_118 {
	unsigned int iter;
	unsigned int ncfail;
	unsigned int ncsuc;
	unsigned int nslow1;
	unsigned int nslow2;
	double fnorm;
	double delta;
	gsl_matrix * q;
	gsl_matrix * r;
	gsl_vector * tau;
	gsl_vector * diag;
	gsl_vector * qtf;
	gsl_vector * newton;
	gsl_vector * gradient;
	gsl_vector * x_trial;
	gsl_vector * f_trial;
	gsl_vector * df;
	gsl_vector * qtdf;
	gsl_vector * rdx;
	gsl_vector * w;
	gsl_vector * v;
};
struct gsl_multiroot_function_struct {
	int( * f)(gsl_vector * x, void * params, gsl_vector * f);
	unsigned int n;
	void * params;
};
struct __anonstruct_gsl_multiroot_fsolver_type_113 {
	char const * name;
	unsigned int size;
	int( * alloc)(void * state, unsigned int n);
	int( * set)(void * state, struct gsl_multiroot_function_struct * function, gsl_vector * x, gsl_vector * f, gsl_vector * dx);
	int( * iterate)(void * state, struct gsl_multiroot_function_struct * function, gsl_vector * x, gsl_vector * f, gsl_vector * dx);
	void( * free)(void * state);
};
struct __anonstruct_gsl_multiroot_fsolver_114 {
	gsl_multiroot_fsolver_type * type;
	struct gsl_multiroot_function_struct * function;
	gsl_vector * x;
	gsl_vector * f;
	gsl_vector * dx;
	void * state;
};
struct __anonstruct_hybrid_state_t_118 {
	unsigned int iter;
	unsigned int ncfail;
	unsigned int ncsuc;
	unsigned int nslow1;
	unsigned int nslow2;
	double fnorm;
	double delta;
	gsl_matrix * J;
	gsl_matrix * q;
	gsl_matrix * r;
	gsl_vector * tau;
	gsl_vector * diag;
	gsl_vector * qtf;
	gsl_vector * newton;
	gsl_vector * gradient;
	gsl_vector * x_trial;
	gsl_vector * f_trial;
	gsl_vector * df;
	gsl_vector * qtdf;
	gsl_vector * rdx;
	gsl_vector * w;
	gsl_vector * v;
};
struct __anonstruct_dnewton_state_t_118 {
	gsl_matrix * J;
	gsl_matrix * lu;
	struct gsl_permutation_struct * permutation;
};
struct __anonstruct_broyden_state_t_118 {
	gsl_matrix * H;
	gsl_matrix * lu;
	struct gsl_permutation_struct * permutation;
	gsl_vector * v;
	gsl_vector * w;
	gsl_vector * y;
	gsl_vector * p;
	gsl_vector * fnew;
	gsl_vector * x_trial;
	double phi;
};
struct __anonstruct_gsl_ntuple_26 {
	struct _IO_FILE * file;
	void * ntuple_data;
	unsigned int size;
};
struct __anonstruct_gsl_ntuple_select_fn_27 {
	int( * function)(void * ntuple_data, void * params);
	void * params;
};
struct __anonstruct_gsl_ntuple_value_fn_28 {
	double( * function)(void * ntuple_data, void * params);
	void * params;
};
struct __anonstruct_gsl_odeiv_system_24 {
	int( * function)(double t, double const * y, double * dydt, void * params);
	int( * jacobian)(double t, double const * y, double * dfdy, double * dfdt, void * params);
	unsigned int dimension;
	void * params;
};
struct __anonstruct_gsl_odeiv_step_type_25 {
	char const * name;
	int can_use_dydt_in;
	int gives_exact_dydt_out;
	void *( * alloc)(unsigned int dim);
	int( * apply)(void * state, unsigned int dim, double t, double h, double * y, double * yerr, double const * dydt_in, double * dydt_out, gsl_odeiv_system * dydt);
	int( * reset)(void * state, unsigned int dim);
	unsigned int( * order)(void * state);
	void( * free)(void * state);
};
struct __anonstruct_rk8pd_state_t_30 {
	double * k[13];
	double * ytmp;
	double * y0;
};
struct __anonstruct_rkck_state_t_30 {
	double * k1;
	double * k2;
	double * k3;
	double * k4;
	double * k5;
	double * k6;
	double * y0;
	double * ytmp;
};
struct __anonstruct_gsl_odeiv_step_28 {
	gsl_odeiv_step_type * type;
	unsigned int dimension;
	void * state;
};
struct __anonstruct_gsl_odeiv_control_type_29 {
	char const * name;
	void *( * alloc)();
	int( * init)(void * state, double eps_abs, double eps_rel, double a_y, double a_dydt);
	int( * hadjust)(void * state, unsigned int dim, unsigned int ord, double const * y, double const * yerr, double const * yp, double * h);
	void( * free)(void * state);
};
struct __anonstruct_gsl_odeiv_control_30 {
	gsl_odeiv_control_type * type;
	void * state;
};
struct __anonstruct_gsl_odeiv_evolve_31 {
	unsigned int dimension;
	double * y0;
	double * yerr;
	double * dydt_in;
	double * dydt_out;
	double last_step;
	unsigned long count;
	unsigned long failed_steps;
};
struct __anonstruct_rk2imp_state_t_32 {
	double * Y1;
	double * y0;
	double * ytmp;
	double * y_onestep;
	double * y0_orig;
};
struct __anonstruct_std_control_state_t_32 {
	double eps_abs;
	double eps_rel;
	double a_y;
	double a_dydt;
};
struct __anonstruct_rk2_state_t_30 {
	double * k1;
	double * k2;
	double * k3;
	double * ytmp;
};
struct __anonstruct_gear1_state_t_32 {
	double * k;
	double * y0;
	double * y0_orig;
	double * y_onestep;
};
struct __anonstruct_rk2simp_state_t_120 {
	double * Y1;
	double * y0;
	double * y0_orig;
	double * ytmp;
	double * dfdy;
	double * dfdt;
	double * y_onestep;
	struct gsl_permutation_struct * p;
};
struct __anonstruct_sc_control_state_t_32 {
	double eps_abs;
	double eps_rel;
	double a_y;
	double a_dydt;
	double * scale_abs;
};
struct __anonstruct_rk4imp_state_t_32 {
	double * k1nu;
	double * k2nu;
	double * ytmp1;
	double * ytmp2;
	double * y0;
	double * y0_orig;
	double * y_onestep;
};
struct __anonstruct_gear2_state_t_32 {
	int primed;
	double t_primed;
	double last_h;
	gsl_odeiv_step * primer;
	double * yim1;
	double * k;
	double * y0;
	double * y0_orig;
	double * y_onestep;
	int stutter;
};
struct __anonstruct_rkf45_state_t_30 {
	double * k1;
	double * k2;
	double * k3;
	double * k4;
	double * k5;
	double * k6;
	double * y0;
	double * ytmp;
};
struct __anonstruct_rk4_state_t_30 {
	double * k;
	double * k1;
	double * y0;
	double * ytmp;
	double * y_onestep;
};
struct __anonstruct_bsimp_state_t_120 {
	gsl_matrix * d;
	gsl_matrix * a_mat;
	struct gsl_permutation_struct * p_vec;
	double x[7];
	unsigned int k_current;
	unsigned int k_choice;
	double h_next;
	double eps;
	double * yp;
	double * y_save;
	double * yerr_save;
	double * y_extrap_save;
	double * y_extrap_sequence;
	double * extrap_work;
	double * dfdt;
	double * y_temp;
	double * delta_temp;
	double * weight;
	gsl_matrix * dfdy;
	double * rhs_temp;
	double * delta;
	unsigned int order;
};
struct gsl_combination_struct {
	unsigned int n;
	unsigned int k;
	unsigned int * data;
};
struct gsl_multiset_struct {
	unsigned int n;
	unsigned int k;
	unsigned int * data;
};
struct __anonstruct_gsl_poly_complex_workspace_24 {
	unsigned int nc;
	double * matrix;
};
struct __anonstruct_gsl_qrng_type_24 {
	char const * name;
	unsigned int max_dimension;
	unsigned int( * state_size)(unsigned int dimension);
	int( * init_state)(void * state, unsigned int dimension);
	int( * get)(void * state, unsigned int dimension, double * x);
};
struct __anonstruct_gsl_qrng_25 {
	gsl_qrng_type * type;
	unsigned int dimension;
	unsigned int state_size;
	void * state;
};
struct __anonstruct_reversehalton_state_t_26 {
	unsigned int sequence_count;
};
struct __anonstruct_sobol_state_t_26 {
	unsigned int sequence_count;
	double last_denominator_inv;
	int last_numerator_vec[40];
	int v_direction[30][40];
};
struct __anonstruct_nied2_state_t_26 {
	unsigned int sequence_count;
	int cj[31][12];
	int nextq[12];
};
struct __anonstruct_halton_state_t_26 {
	unsigned int sequence_count;
};
struct __anonstruct_gsl_ran_discrete_t_28 {
	unsigned int K;
	unsigned int * A;
	double * F;
};
struct __anonstruct_gsl_stack_t_29 {
	unsigned int N;
	unsigned int * v;
	unsigned int i;
};
struct __anonstruct_ran_state_t_26 {
	unsigned long x;
};
struct __anonstruct_zuf_state_t_26 {
	int n;
	unsigned long u[607];
};
struct __anonstruct_ranlxs_state_t_26 {
	double xdbl[12];
	double ydbl[12];
	double carry;
	float xflt[24];
	unsigned int ir;
	unsigned int jr;
	unsigned int is;
	unsigned int is_old;
	unsigned int pr;
};
struct __anonstruct_randu_state_t_26 {
	unsigned long x;
};
struct __anonstruct_uni32_state_t_26 {
	int i;
	int j;
	unsigned long m[17];
};
struct __anonstruct_ran1_state_t_26 {
	unsigned long x;
	unsigned long n;
	unsigned long shuffle[32];
};
struct __anonstruct_ran2_state_t_26 {
	unsigned long x;
	unsigned long y;
	unsigned long n;
	unsigned long shuffle[32];
};
struct __anonstruct_ran0_state_t_26 {
	unsigned long x;
};
struct __anonstruct_ran_state_t_26___0 {
	unsigned long x0;
	unsigned long x1;
};
struct __anonstruct_tt_state_t_26 {
	int n;
	unsigned long x[25];
};
struct __anonstruct_vax_state_t_26 {
	unsigned long x;
};
struct __anonstruct_ranmar_state_t_26 {
	unsigned int i;
	unsigned int j;
	long carry;
	unsigned long u[97];
};
struct __anonstruct_ran_state_t_26___1 {
	unsigned long x;
	unsigned long y;
	unsigned long z;
};
struct __anonstruct_ranf_state_t_28 {
	unsigned short x0;
	unsigned short x1;
	unsigned short x2;
};
struct __anonstruct_ran_state_t_26___2 {
	unsigned int i;
	unsigned long aa[2009];
	unsigned long ran_x[100];
};
struct __anonstruct_ranlxd_state_t_26 {
	double xdbl[12];
	double carry;
	unsigned int ir;
	unsigned int jr;
	unsigned int ir_old;
	unsigned int pr;
};
struct __anonstruct_slatec_state_t_26 {
	long x0;
	long x1;
};
struct __anonstruct_transputer_state_t_26 {
	unsigned long x;
};
struct __anonstruct_uni_state_t_26 {
	int i;
	int j;
	unsigned long m[17];
};
struct __anonstruct_taus_state_t_26 {
	unsigned long s1;
	unsigned long s2;
	unsigned long s3;
};
struct __anonstruct_ran_state_t_26___3 {
	unsigned int i;
	long aa[1009];
	long ran_x[100];
};
struct __anonstruct_taus113_state_t_26 {
	unsigned long z1;
	unsigned long z2;
	unsigned long z3;
	unsigned long z4;
};
struct __anonstruct_rand_state_t_26 {
	unsigned long x;
};
struct __anonstruct_ranlux_state_t_26 {
	unsigned int i;
	unsigned int j;
	unsigned int n;
	unsigned int skip;
	unsigned int carry;
	unsigned long u[24];
};
struct __anonstruct_rand48_state_t_28 {
	unsigned short x0;
	unsigned short x1;
	unsigned short x2;
};
struct __anonstruct_r250_state_t_26 {
	int i;
	unsigned long x[250];
};
struct __anonstruct_ran3_state_t_26 {
	unsigned int x;
	unsigned int y;
	unsigned long buffer[56];
};
struct __anonstruct_minstd_state_t_26 {
	unsigned long x;
};
struct __anonstruct_gfsr4_state_t_26 {
	int nd;
	unsigned long ra[16384];
};
struct __anonstruct_mrg_state_t_26 {
	long x1;
	long x2;
	long x3;
	long x4;
	long x5;
};
struct __anonstruct_random8_state_t_26 {
	long x;
};
struct __anonstruct_random32_state_t_27 {
	int i;
	int j;
	long x[7];
};
struct __anonstruct_random64_state_t_28 {
	int i;
	int j;
	long x[15];
};
struct __anonstruct_random128_state_t_29 {
	int i;
	int j;
	long x[31];
};
struct __anonstruct_random256_state_t_30 {
	int i;
	int j;
	long x[63];
};
struct __anonstruct_cmrg_state_t_26 {
	long x1;
	long x2;
	long x3;
	long y1;
	long y2;
	long y3;
};
struct __anonstruct_mt_state_t_26 {
	unsigned long mt[624];
	int mti;
};
struct __anonstruct_gsl_root_fdfsolver_type_28 {
	char const * name;
	unsigned int size;
	int( * set)(void * state, struct gsl_function_fdf_struct * f, double * root);
	int( * iterate)(void * state, struct gsl_function_fdf_struct * f, double * root);
};
struct __anonstruct_newton_state_t_30 {
	double f;
	double df;
};
struct __anonstruct_gsl_root_fdfsolver_29 {
	gsl_root_fdfsolver_type * type;
	struct gsl_function_fdf_struct * fdf;
	double root;
	void * state;
};
struct __anonstruct_steffenson_state_t_30 {
	double f;
	double df;
	double x;
	double x_1;
	double x_2;
	int count;
};
struct __anonstruct_gsl_root_fsolver_type_26 {
	char const * name;
	unsigned int size;
	int( * set)(void * state, struct gsl_function_struct * f, double * root, double x_lower, double x_upper);
	int( * iterate)(void * state, struct gsl_function_struct * f, double * root, double * x_lower, double * x_upper);
};
struct __anonstruct_bisection_state_t_30 {
	double f_lower;
	double f_upper;
};
struct __anonstruct_gsl_root_fsolver_27 {
	gsl_root_fsolver_type * type;
	struct gsl_function_struct * function;
	double root;
	double x_lower;
	double x_upper;
	void * state;
};
struct __anonstruct_brent_state_t_30 {
	double a;
	double b;
	double c;
	double d;
	double e;
	double fa;
	double fb;
	double fc;
};
struct __anonstruct_secant_state_t_30 {
	double f;
	double df;
};
struct __anonstruct_falsepos_state_t_30 {
	double f_lower;
	double f_upper;
};
struct __anonstruct_gsl_siman_params_t_28 {
	int n_tries;
	int iters_fixed_T;
	double step_size;
	double k;
	double t_initial;
	double mu_t;
	double t_min;
};
struct cheb_series_struct {
	double * c;
	int order;
	double a;
	double b;
	int order_sp;
};
struct gsl_sf_result_e10_struct {
	double val;
	double err;
	int e10;
};
struct __anonstruct_gsl_sf_mathieu_workspace_127 {
	unsigned int size;
	unsigned int even_order;
	unsigned int odd_order;
	int extra_values;
	double qa;
	double qb;
	double * aa;
	double * bb;
	double * dd;
	double * ee;
	double * tt;
	double * e2;
	double * zz;
	gsl_vector * eval;
	gsl_matrix * evec;
	gsl_eigen_symmv_workspace * wmat;
};
struct __anonstruct_fact_table_9 {
	int n;
	double f;
	long i;
};
struct __anonstruct_doub_fact_table_10 {
	int n;
	double f;
	long i;
};
struct __anonstruct_gsl_sum_levin_utrunc_workspace_27 {
	unsigned int size;
	unsigned int i;
	unsigned int terms_used;
	double sum_plain;
	double * q_num;
	double * q_den;
	double * dsum;
};
struct __anonstruct_gsl_sum_levin_u_workspace_26 {
	unsigned int size;
	unsigned int i;
	unsigned int terms_used;
	double sum_plain;
	double * q_num;
	double * q_den;
	double * dq_num;
	double * dq_den;
	double * dsum;
};
struct __anonstruct_gsl_wavelet_type_27 {
	char const * name;
	int( * init)(double const * * h1, double const * * g1, double const * * h2, double const * * g2, unsigned int * nc, unsigned int * offset, unsigned int member);
};
struct __anonstruct_gsl_wavelet_26 {
	gsl_wavelet_type * type;
	double const * h1;
	double const * g1;
	double const * h2;
	double const * g2;
	unsigned int nc;
	unsigned int offset;
};
struct __anonstruct_gsl_wavelet_workspace_27 {
	double * scratch;
	unsigned int n;
};

#endif
