class
	P_ADD

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_histogram_increment (a_h: CE_POINTER [PD_GSL_HISTOGRAM]; a_x: REAL_64): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (gsl_histogram_accumulate (a_h, a_x, 1.0))
			Result := l_status
		end

	gsl_histogram_accumulate (a_h: CE_POINTER [PD_GSL_HISTOGRAM]; a_x: REAL_64; a_weight: REAL_64): INTEGER_32
		local
			l_n: NATURAL_32
			l_index: NATURAL_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_n := a_h.item.n
			l_index := (0).to_natural_32
			l_status := (find_inst.find___1 (a_h.item.n, a_h.item.range, a_x, create {CE_POINTER [NATURAL_32]}.make_shared ($l_index)))
			if l_status.to_boolean then
				Result := 1
				js.return
			end
			if not js.return_called and then (l_index >= l_n) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("index lies outside valid range of 0 .. n - 1"), ce_string ("add.c"), 49, 7)
					Result := 7
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				a_h.item.bin[l_index.to_integer_32] := a_h.item.bin[l_index.to_integer_32] + a_weight
				Result := 0
			end
		end

end
