class
	P_AIRY

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create am21_data.make (<<37>>)
			create am21_cs.make
			create ath1_data.make (<<36>>)
			create ath1_cs.make
			create am22_data.make (<<33>>)
			create am22_cs.make
			create ath2_data.make (<<32>>)
			create ath2_cs.make
			create ai_data_f.make (<<9>>)
			create aif_cs.make
			create ai_data_g.make (<<8>>)
			create aig_cs.make
			create data_bif.make (<<9>>)
			create bif_cs.make
			create data_big.make (<<8>>)
			create big_cs.make
			create data_bif2.make (<<10>>)
			create bif2_cs.make
			create data_big2.make (<<10>>)
			create big2_cs.make
			create data_aip.make (<<36>>)
			create aip_cs.make
			create data_bip.make (<<24>>)
			create bip_cs.make
			create data_bip2.make (<<29>>)
			create bip2_cs.make
		end

feature {ANY} -- attributes

	am21_data: CE_ARRAY [REAL_64]

	am21_cs: PD_CHEB_SERIES_STRUCT

	ath1_data: CE_ARRAY [REAL_64]

	ath1_cs: PD_CHEB_SERIES_STRUCT

	am22_data: CE_ARRAY [REAL_64]

	am22_cs: PD_CHEB_SERIES_STRUCT

	ath2_data: CE_ARRAY [REAL_64]

	ath2_cs: PD_CHEB_SERIES_STRUCT

	ai_data_f: CE_ARRAY [REAL_64]

	aif_cs: PD_CHEB_SERIES_STRUCT

	ai_data_g: CE_ARRAY [REAL_64]

	aig_cs: PD_CHEB_SERIES_STRUCT

	data_bif: CE_ARRAY [REAL_64]

	bif_cs: PD_CHEB_SERIES_STRUCT

	data_big: CE_ARRAY [REAL_64]

	big_cs: PD_CHEB_SERIES_STRUCT

	data_bif2: CE_ARRAY [REAL_64]

	bif2_cs: PD_CHEB_SERIES_STRUCT

	data_big2: CE_ARRAY [REAL_64]

	big2_cs: PD_CHEB_SERIES_STRUCT

	data_aip: CE_ARRAY [REAL_64]

	aip_cs: PD_CHEB_SERIES_STRUCT

	data_bip: CE_ARRAY [REAL_64]

	bip_cs: PD_CHEB_SERIES_STRUCT

	data_bip2: CE_ARRAY [REAL_64]

	bip2_cs: PD_CHEB_SERIES_STRUCT

feature {ANY} -- routines

	airy_mod_phase (a_x: REAL_64; a_mode: NATURAL_32; a_mod: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_phase: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_result_m: PD_GSL_SF_RESULT_STRUCT
			l_result_p: PD_GSL_SF_RESULT_STRUCT
			l_m___4: REAL_64
			l_p: REAL_64
			l_sqx: REAL_64
			l_z: REAL_64
			l_z___0: REAL_64
			l_tmp: REAL_64
			l_tmp___1: REAL_64
			js: JUMP_STATE
		do
			create l_result_m.make
			create l_result_p.make

			if a_x < -2.0 then
				l_z := 16.0 / ((a_x * a_x) * a_x) + 1.0
				cheb_eval_mode_inst.cheb_eval_mode_e ((am21_cs.address), l_z, a_mode, l_result_m.address).do_nothing
				cheb_eval_mode_inst.cheb_eval_mode_e ((ath1_cs.address), l_z, a_mode, l_result_p.address).do_nothing
			elseif a_x <= -1.0 then
				l_z___0 := (16.0 / ((a_x * a_x) * a_x) + 9.0) / 7.0
				cheb_eval_mode_inst.cheb_eval_mode_e ((am22_cs.address), l_z___0, a_mode, l_result_m.address).do_nothing
				cheb_eval_mode_inst.cheb_eval_mode_e ((ath2_cs.address), l_z___0, a_mode, l_result_p.address).do_nothing
			else
				a_mod.item.val := 0.0
				a_mod.item.err := 0.0
				a_phase.item.val := 0.0
				a_phase.item.err := 0.0
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("x is greater than 1.0"), ce_string ("airy.c"), 265, 1)
					Result := 1
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4 := 0.3125 + l_result_m.val
				l_p := -0.625 + l_result_p.val
				l_sqx := sqrt (-a_x)
				a_mod.item.val := sqrt (l_m___4 / l_sqx)
				l_tmp := fabs (a_mod.item.val)
				a_mod.item.err := l_tmp * (2.2204460492503131e-16 + (fabs (l_result_m.err / l_result_m.val)))
				a_phase.item.val := 0.78539816339744830962 - (a_x * l_sqx) * l_p
				l_tmp___1 := fabs (a_phase.item.val)
				a_phase.item.err := l_tmp___1 * (2.2204460492503131e-16 + (fabs (l_result_p.err / l_result_p.val)))
				Result := 0
			end
		end

	airy_aie (a_x: REAL_64; a_mode: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_sqx: REAL_64
			l_z: REAL_64
			l_y: REAL_64
			l_result_c: PD_GSL_SF_RESULT_STRUCT
		do
			create l_result_c.make

			l_sqx := (sqrt (a_x))
			l_z := 2.0 / (a_x * l_sqx) - 1.0
			l_y := (sqrt (l_sqx))
			cheb_eval_mode_inst.cheb_eval_mode_e ((aip_cs.address), l_z, a_mode, l_result_c.address).do_nothing
			a_result.item.val := (0.28125 + l_result_c.val) / l_y
			a_result.item.err := l_result_c.err / l_y + 2.2204460492503131e-16 * (fabs (a_result.item.val))
			Result := 0
		end

	airy_bie (a_x: REAL_64; a_mode: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ATR: REAL_64
			l_BTR: REAL_64
			l_sqx: REAL_64
			l_z: REAL_64
			l_y: REAL_64
			l_result_c: PD_GSL_SF_RESULT_STRUCT
			l_sqx___0: REAL_64
			l_z___0: REAL_64
			l_y___0: REAL_64
			l_result_c___0: PD_GSL_SF_RESULT_STRUCT
		do
			create l_result_c.make
			create l_result_c___0.make

			l_ATR := 8.7506905708484345
			l_BTR := -2.0938363213560543
			if a_x < 4.0 then
				l_sqx := (sqrt (a_x))
				l_z := l_ATR / (a_x * l_sqx) + l_BTR
				l_y := (sqrt (l_sqx))
				cheb_eval_mode_inst.cheb_eval_mode_e ((bip_cs.address), l_z, a_mode, l_result_c.address).do_nothing
				a_result.item.val := (0.625 + l_result_c.val) / l_y
				a_result.item.err := l_result_c.err / l_y + 2.2204460492503131e-16 * (fabs (a_result.item.val))
			else
				l_sqx___0 := (sqrt (a_x))
				l_z___0 := 16.0 / (a_x * l_sqx___0) - 1.0
				l_y___0 := (sqrt (l_sqx___0))
				cheb_eval_mode_inst.cheb_eval_mode_e ((bip2_cs.address), l_z___0, a_mode, l_result_c___0.address).do_nothing
				a_result.item.val := (0.625 + l_result_c___0.val) / l_y___0
				a_result.item.err := l_result_c___0.err / l_y___0 + 2.2204460492503131e-16 * (fabs (a_result.item.val))
			end
			Result := 0
		end

	gsl_sf_airy_Ai_e (a_x: REAL_64; a_mode: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_mod: PD_GSL_SF_RESULT_STRUCT
			l_theta: PD_GSL_SF_RESULT_STRUCT
			l_cos_result: PD_GSL_SF_RESULT_STRUCT
			l_stat_mp: INTEGER_32
			l_stat_cos: INTEGER_32
			l_tmp___1: REAL_64
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_z: REAL_64
			l_result_c0: PD_GSL_SF_RESULT_STRUCT
			l_result_c1: PD_GSL_SF_RESULT_STRUCT
			l_x32___0: REAL_64
			l_s: REAL_64
			l_result_aie: PD_GSL_SF_RESULT_STRUCT
			l_stat_aie: INTEGER_32
			js: JUMP_STATE
		do
			create l_mod.make
			create l_theta.make
			create l_cos_result.make
			create l_result_c0.make
			create l_result_c1.make
			create l_result_aie.make

			if a_x < -1.0 then
				l_stat_mp := (airy_mod_phase (a_x, a_mode, l_mod.address, l_theta.address))
				l_stat_cos := (trig_inst.gsl_sf_cos_err_e (l_theta.val, l_theta.err, l_cos_result.address))
				a_result.item.val := l_mod.val * l_cos_result.val
				l_tmp___1 := fabs (l_mod.val * l_cos_result.err)
				a_result.item.err := l_tmp___1 + (fabs (l_cos_result.val * l_mod.err))
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				if l_stat_mp /= 0 then
					l_tmp___5 := l_stat_mp
				else
					if l_stat_cos /= 0 then
						l_tmp___4 := l_stat_cos
					else
						l_tmp___4 := 0
					end
					l_tmp___5 := l_tmp___4
				end
				Result := l_tmp___5
			elseif a_x <= 1.0 then
				l_z := (a_x * a_x) * a_x
				cheb_eval_mode_inst.cheb_eval_mode_e ((aif_cs.address), l_z, a_mode, l_result_c0.address).do_nothing
				cheb_eval_mode_inst.cheb_eval_mode_e ((aig_cs.address), l_z, a_mode, l_result_c1.address).do_nothing
				a_result.item.val := 0.375 + (l_result_c0.val - a_x * (0.25 + l_result_c1.val))
				a_result.item.err := l_result_c0.err + (fabs (a_x * l_result_c1.err))
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				Result := 0
			else
				l_x32___0 := a_x * (sqrt (a_x))
				l_s := (exp ((-2.0 * l_x32___0) / 3.0))
				l_stat_aie := (airy_aie (a_x, a_mode, l_result_aie.address))
				a_result.item.val := l_result_aie.val * l_s
				a_result.item.err := l_result_aie.err * l_s + (a_result.item.val * l_x32___0) * 2.2204460492503131e-16
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				if (fabs (a_result.item.val)) < 2.2250738585072014e-308 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("airy.c"), 693, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
				if not js.return_called then
					Result := l_stat_aie
				end
			end
		end

	gsl_sf_airy_Ai_scaled_e (a_x: REAL_64; a_mode: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_mod: PD_GSL_SF_RESULT_STRUCT
			l_theta: PD_GSL_SF_RESULT_STRUCT
			l_cos_result: PD_GSL_SF_RESULT_STRUCT
			l_stat_mp: INTEGER_32
			l_stat_cos: INTEGER_32
			l_tmp___1: REAL_64
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_z: REAL_64
			l_result_c0: PD_GSL_SF_RESULT_STRUCT
			l_result_c1: PD_GSL_SF_RESULT_STRUCT
			l_scale: REAL_64
		do
			create l_mod.make
			create l_theta.make
			create l_cos_result.make
			create l_result_c0.make
			create l_result_c1.make

			if a_x < -1.0 then
				l_stat_mp := (airy_mod_phase (a_x, a_mode, l_mod.address, l_theta.address))
				l_stat_cos := (trig_inst.gsl_sf_cos_err_e (l_theta.val, l_theta.err, l_cos_result.address))
				a_result.item.val := l_mod.val * l_cos_result.val
				l_tmp___1 := fabs (l_mod.val * l_cos_result.err)
				a_result.item.err := l_tmp___1 + (fabs (l_cos_result.val * l_mod.err))
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				if l_stat_mp /= 0 then
					l_tmp___5 := l_stat_mp
				else
					if l_stat_cos /= 0 then
						l_tmp___4 := l_stat_cos
					else
						l_tmp___4 := 0
					end
					l_tmp___5 := l_tmp___4
				end
				Result := l_tmp___5
			elseif a_x <= 1.0 then
				l_z := (a_x * a_x) * a_x
				cheb_eval_mode_inst.cheb_eval_mode_e ((aif_cs.address), l_z, a_mode, l_result_c0.address).do_nothing
				cheb_eval_mode_inst.cheb_eval_mode_e ((aig_cs.address), l_z, a_mode, l_result_c1.address).do_nothing
				a_result.item.val := 0.375 + (l_result_c0.val - a_x * (0.25 + l_result_c1.val))
				a_result.item.err := l_result_c0.err + (fabs (a_x * l_result_c1.err))
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				if a_x > 0.0 then
					l_scale := (exp ((2.0 / 3.0) * (sqrt (l_z))))
					a_result.item.val := a_result.item.val * l_scale
					a_result.item.err := a_result.item.err * l_scale
				end
				Result := 0
			else
				Result := (airy_aie (a_x, a_mode, a_result))
			end
		end

	gsl_sf_airy_Bi_e (a_x: REAL_64; a_mode: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_mod: PD_GSL_SF_RESULT_STRUCT
			l_theta: PD_GSL_SF_RESULT_STRUCT
			l_sin_result: PD_GSL_SF_RESULT_STRUCT
			l_stat_mp: INTEGER_32
			l_stat_sin: INTEGER_32
			l_tmp___1: REAL_64
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_z: REAL_64
			l_result_c0: PD_GSL_SF_RESULT_STRUCT
			l_result_c1: PD_GSL_SF_RESULT_STRUCT
			l_z___0: REAL_64
			l_result_c0___0: PD_GSL_SF_RESULT_STRUCT
			l_result_c1___0: PD_GSL_SF_RESULT_STRUCT
			l_y: REAL_64
			l_s: REAL_64
			l_result_bie: PD_GSL_SF_RESULT_STRUCT
			l_stat_bie: INTEGER_32
			js: JUMP_STATE
		do
			create l_mod.make
			create l_theta.make
			create l_sin_result.make
			create l_result_c0.make
			create l_result_c1.make
			create l_result_c0___0.make
			create l_result_c1___0.make
			create l_result_bie.make

			if a_x < -1.0 then
				l_stat_mp := (airy_mod_phase (a_x, a_mode, l_mod.address, l_theta.address))
				l_stat_sin := (trig_inst.gsl_sf_sin_err_e (l_theta.val, l_theta.err, l_sin_result.address))
				a_result.item.val := l_mod.val * l_sin_result.val
				l_tmp___1 := fabs (l_mod.val * l_sin_result.err)
				a_result.item.err := l_tmp___1 + (fabs (l_sin_result.val * l_mod.err))
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				if l_stat_mp /= 0 then
					l_tmp___5 := l_stat_mp
				else
					if l_stat_sin /= 0 then
						l_tmp___4 := l_stat_sin
					else
						l_tmp___4 := 0
					end
					l_tmp___5 := l_tmp___4
				end
				Result := l_tmp___5
				js.return
			elseif a_x < 1.0 then
				l_z := (a_x * a_x) * a_x
				cheb_eval_mode_inst.cheb_eval_mode_e ((bif_cs.address), l_z, a_mode, l_result_c0.address).do_nothing
				cheb_eval_mode_inst.cheb_eval_mode_e ((big_cs.address), l_z, a_mode, l_result_c1.address).do_nothing
				a_result.item.val := (0.625 + l_result_c0.val) + a_x * (0.4375 + l_result_c1.val)
				a_result.item.err := l_result_c0.err + (fabs (a_x * l_result_c1.err))
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				Result := 0
				js.return
			elseif a_x <= 2.0 then
				l_z___0 := (((2.0 * a_x) * a_x) * a_x - 9.0) / 7.0
				cheb_eval_mode_inst.cheb_eval_mode_e ((bif2_cs.address), l_z___0, a_mode, l_result_c0___0.address).do_nothing
				cheb_eval_mode_inst.cheb_eval_mode_e ((big2_cs.address), l_z___0, a_mode, l_result_c1___0.address).do_nothing
				a_result.item.val := (1.125 + l_result_c0___0.val) + a_x * (0.625 + l_result_c1___0.val)
				a_result.item.err := l_result_c0___0.err + (fabs (a_x * l_result_c1___0.err))
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				Result := 0
				js.return
			else
				l_y := ((2.0 * a_x) * (sqrt (a_x))) / 3.0
				l_s := (exp (l_y))
				if l_y > 7.0978271289338397e+02 - 1.0 then
					from
					until
						js.loop_left
					loop
						js.reset
						a_result.item.val := (builtin_inff).to_double
						a_result.item.err := (builtin_inff).to_double
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("overflow"), ce_string ("airy.c"), 780, 16)
							Result := 16
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
						if not js.return_called then
							js.break
						end
					end
					js.reset
				else
					l_stat_bie := (airy_bie (a_x, a_mode, l_result_bie.address))
					a_result.item.val := l_result_bie.val * l_s
					a_result.item.err := l_result_bie.err * l_s + (fabs ((1.5 * l_y) * (2.2204460492503131e-16 * a_result.item.val)))
					a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
					Result := l_stat_bie
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_airy_Bi_scaled_e (a_x: REAL_64; a_mode: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_mod: PD_GSL_SF_RESULT_STRUCT
			l_theta: PD_GSL_SF_RESULT_STRUCT
			l_sin_result: PD_GSL_SF_RESULT_STRUCT
			l_stat_mp: INTEGER_32
			l_stat_sin: INTEGER_32
			l_tmp___1: REAL_64
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_z: REAL_64
			l_result_c0: PD_GSL_SF_RESULT_STRUCT
			l_result_c1: PD_GSL_SF_RESULT_STRUCT
			l_scale: REAL_64
			l_x3___1: REAL_64
			l_z___0: REAL_64
			l_s: REAL_64
			l_result_c0___0: PD_GSL_SF_RESULT_STRUCT
			l_result_c1___0: PD_GSL_SF_RESULT_STRUCT
		do
			create l_mod.make
			create l_theta.make
			create l_sin_result.make
			create l_result_c0.make
			create l_result_c1.make
			create l_result_c0___0.make
			create l_result_c1___0.make

			if a_x < -1.0 then
				l_stat_mp := (airy_mod_phase (a_x, a_mode, l_mod.address, l_theta.address))
				l_stat_sin := (trig_inst.gsl_sf_sin_err_e (l_theta.val, l_theta.err, l_sin_result.address))
				a_result.item.val := l_mod.val * l_sin_result.val
				l_tmp___1 := fabs (l_mod.val * l_sin_result.err)
				a_result.item.err := l_tmp___1 + (fabs (l_sin_result.val * l_mod.err))
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				if l_stat_mp /= 0 then
					l_tmp___5 := l_stat_mp
				else
					if l_stat_sin /= 0 then
						l_tmp___4 := l_stat_sin
					else
						l_tmp___4 := 0
					end
					l_tmp___5 := l_tmp___4
				end
				Result := l_tmp___5
			elseif a_x < 1.0 then
				l_z := (a_x * a_x) * a_x
				cheb_eval_mode_inst.cheb_eval_mode_e ((bif_cs.address), l_z, a_mode, l_result_c0.address).do_nothing
				cheb_eval_mode_inst.cheb_eval_mode_e ((big_cs.address), l_z, a_mode, l_result_c1.address).do_nothing
				a_result.item.val := (0.625 + l_result_c0.val) + a_x * (0.4375 + l_result_c1.val)
				a_result.item.err := l_result_c0.err + (fabs (a_x * l_result_c1.err))
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				if a_x > 0.0 then
					l_scale := (exp ((-2.0 / 3.0) * (sqrt (l_z))))
					a_result.item.val := a_result.item.val * l_scale
					a_result.item.err := a_result.item.err * l_scale
				end
				Result := 0
			elseif a_x <= 2.0 then
				l_x3___1 := (a_x * a_x) * a_x
				l_z___0 := (2.0 * l_x3___1 - 9.0) / 7.0
				l_s := (exp ((-2.0 / 3.0) * (sqrt (l_x3___1))))
				cheb_eval_mode_inst.cheb_eval_mode_e ((bif2_cs.address), l_z___0, a_mode, l_result_c0___0.address).do_nothing
				cheb_eval_mode_inst.cheb_eval_mode_e ((big2_cs.address), l_z___0, a_mode, l_result_c1___0.address).do_nothing
				a_result.item.val := l_s * ((1.125 + l_result_c0___0.val) + a_x * (0.625 + l_result_c1___0.val))
				a_result.item.err := l_s * (l_result_c0___0.err + (fabs (a_x * l_result_c1___0.err)))
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				Result := 0
			else
				Result := (airy_bie (a_x, a_mode, a_result))
			end
		end

	gsl_sf_airy_Ai (a_x: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_airy_Ai_e (a_x, a_mode, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_airy_Ai_e(x, mode, &result)"), ce_string ("airy.c"), 851, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_airy_Ai_scaled (a_x: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_airy_Ai_scaled_e (a_x, a_mode, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_airy_Ai_scaled_e(x, mode, &result)"), ce_string ("airy.c"), 856, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_airy_Bi (a_x: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_airy_Bi_e (a_x, a_mode, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_airy_Bi_e(x, mode, &result)"), ce_string ("airy.c"), 861, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_airy_Bi_scaled (a_x: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_airy_Bi_scaled_e (a_x, a_mode, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_airy_Bi_scaled_e(x, mode, &result)"), ce_string ("airy.c"), 866, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
