class
	P_AIRY_ZERO

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create zero_Ai.make (<<101>>)
			create zero_Bi.make (<<101>>)
			create zero_Aip.make (<<101>>)
			create zero_Bip.make (<<51>>)
		end

feature {ANY} -- attributes

	zero_Ai: CE_ARRAY [REAL_64]

	size_zero_Ai: NATURAL_32 assign set_size_zero_Ai

	set_size_zero_Ai (a_size_zero_Ai: NATURAL_32)
		do
			size_zero_Ai := a_size_zero_Ai
		end

	zero_Bi: CE_ARRAY [REAL_64]

	size_zero_Bi: NATURAL_32 assign set_size_zero_Bi

	set_size_zero_Bi (a_size_zero_Bi: NATURAL_32)
		do
			size_zero_Bi := a_size_zero_Bi
		end

	zero_Aip: CE_ARRAY [REAL_64]

	size_zero_Aip: NATURAL_32 assign set_size_zero_Aip

	set_size_zero_Aip (a_size_zero_Aip: NATURAL_32)
		do
			size_zero_Aip := a_size_zero_Aip
		end

	zero_Bip: CE_ARRAY [REAL_64]

	size_zero_Bip: NATURAL_32 assign set_size_zero_Bip

	set_size_zero_Bip (a_size_zero_Bip: NATURAL_32)
		do
			size_zero_Bip := a_size_zero_Bip
		end

feature {ANY} -- routines

	zero_f (a_z: REAL_64): REAL_64
		local
			l_pre: REAL_64
			l_zi2: REAL_64
			l_zi4: REAL_64
			l_t1: REAL_64
			l_t2: REAL_64
			l_t3: REAL_64
			l_t4: REAL_64
		do
			l_pre := (pow (a_z, 2.0 / 3.0))
			l_zi2 := 1.0 / (a_z * a_z)
			l_zi4 := l_zi2 * l_zi2
			l_t1 := (5.0 / 48.0) * l_zi2
			l_t2 := (-5.0 / 36.0) * l_zi4
			l_t3 := ((77125.0 / 82944.0) * l_zi4) * l_zi2
			l_t4 := ((-108056875.0 / 6967296.0) * l_zi4) * l_zi4
			Result := (l_pre * ((((1.0 + l_t1) + l_t2) + l_t3) + l_t4))
		end

	zero_g (a_z: REAL_64): REAL_64
		local
			l_pre: REAL_64
			l_zi2: REAL_64
			l_zi4: REAL_64
			l_t1: REAL_64
			l_t2: REAL_64
			l_t3: REAL_64
			l_t4: REAL_64
		do
			l_pre := (pow (a_z, 2.0 / 3.0))
			l_zi2 := 1.0 / (a_z * a_z)
			l_zi4 := l_zi2 * l_zi2
			l_t1 := (-7.0 / 48.0) * l_zi2
			l_t2 := (35.0 / 288.0) * l_zi4
			l_t3 := ((-181223.0 / 207360.0) * l_zi4) * l_zi2
			l_t4 := ((18683371.0 / 1244160.0) * l_zi4) * l_zi4
			Result := (l_pre * ((((1.0 + l_t1) + l_t2) + l_t3) + l_t4))
		end

	gsl_sf_airy_zero_Ai_e (a_s: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_z: REAL_64
			l_f: REAL_64
			js: JUMP_STATE
		do
			if a_s < {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("s is less than 1"), ce_string ("airy_zero.c"), 439, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_s < size_zero_Ai then
				a_result.item.val := zero_Ai[a_s.to_integer_32]
				a_result.item.err := 2.2204460492503131e-16 * (fabs (a_result.item.val))
				Result := 0
				js.return
			else
				l_z := ((3.0 * 3.14159265358979323846) / 8.0) * (4.0 * a_s.to_real_64 - 1.0)
				l_f := (zero_f (l_z))
				a_result.item.val := -l_f
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_airy_zero_Bi_e (a_s: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_z: REAL_64
			l_f: REAL_64
			js: JUMP_STATE
		do
			if a_s < {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("s is less than 1"), ce_string ("airy_zero.c"), 462, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_s < size_zero_Bi then
				a_result.item.val := zero_Bi[a_s.to_integer_32]
				a_result.item.err := 2.2204460492503131e-16 * (fabs (a_result.item.val))
				Result := 0
				js.return
			else
				l_z := ((3.0 * 3.14159265358979323846) / 8.0) * (4.0 * a_s.to_real_64 - 3.0)
				l_f := (zero_f (l_z))
				a_result.item.val := -l_f
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_airy_zero_Ai_deriv_e (a_s: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_z: REAL_64
			l_g: REAL_64
			js: JUMP_STATE
		do
			if a_s < {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("s is less than 1"), ce_string ("airy_zero.c"), 485, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_s < size_zero_Aip then
				a_result.item.val := zero_Aip[a_s.to_integer_32]
				a_result.item.err := 2.2204460492503131e-16 * (fabs (a_result.item.val))
				Result := 0
				js.return
			else
				l_z := ((3.0 * 3.14159265358979323846) / 8.0) * (4.0 * a_s.to_real_64 - 3.0)
				l_g := (zero_g (l_z))
				a_result.item.val := -l_g
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_airy_zero_Bi_deriv_e (a_s: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_z: REAL_64
			l_g: REAL_64
			js: JUMP_STATE
		do
			if a_s < {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("s is less than 1"), ce_string ("airy_zero.c"), 508, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_s < size_zero_Bip then
				a_result.item.val := zero_Bip[a_s.to_integer_32]
				a_result.item.err := 2.2204460492503131e-16 * (fabs (a_result.item.val))
				Result := 0
				js.return
			else
				l_z := ((3.0 * 3.14159265358979323846) / 8.0) * (4.0 * a_s.to_real_64 - 1.0)
				l_g := (zero_g (l_z))
				a_result.item.val := -l_g
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_airy_zero_Ai (a_s: NATURAL_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_airy_zero_Ai_e (a_s, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_airy_zero_Ai_e(s, &result)"), ce_string ("airy_zero.c"), 530, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_airy_zero_Bi (a_s: NATURAL_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_airy_zero_Bi_e (a_s, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_airy_zero_Bi_e(s, &result)"), ce_string ("airy_zero.c"), 535, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_airy_zero_Ai_deriv (a_s: NATURAL_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_airy_zero_Ai_deriv_e (a_s, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_airy_zero_Ai_deriv_e(s, &result)"), ce_string ("airy_zero.c"), 540, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_airy_zero_Bi_deriv (a_s: NATURAL_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_airy_zero_Bi_deriv_e (a_s, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_airy_zero_Bi_deriv_e(s, &result)"), ce_string ("airy_zero.c"), 545, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
