class
	P_APPLY_GIVENS

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	apply_givens_qr (a_M: NATURAL_32; a_N: NATURAL_32; a_Q___1: CE_POINTER [PD_GSL_MATRIX]; a_R: CE_POINTER [PD_GSL_MATRIX]; a_i: NATURAL_32; a_j: NATURAL_32; a_c___1: REAL_64; a_s: REAL_64)
		local
			l_k: NATURAL_32
			l_qki: REAL_64
			l_qkj: REAL_64
			l_rik: REAL_64
			l_rjk: REAL_64
		do
			l_k := (0).to_natural_32
			from
			until
				not (l_k < a_M)
			loop
				l_qki := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_Q___1, l_k, a_i))
				l_qkj := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_Q___1, l_k, a_j))
				gsl_gsl_matrix_double_inst.gsl_matrix_set (a_Q___1, l_k, a_i, l_qki * a_c___1 - l_qkj * a_s)
				gsl_gsl_matrix_double_inst.gsl_matrix_set (a_Q___1, l_k, a_j, l_qki * a_s + l_qkj * a_c___1)
				l_k := l_k + 1
			end
			if a_i < a_j then
				l_k := a_i
			else
				l_k := a_j
			end
			from
			until
				not (l_k < a_N)
			loop
				l_rik := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, a_i, l_k))
				l_rjk := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, a_j, l_k))
				gsl_gsl_matrix_double_inst.gsl_matrix_set (a_R, a_i, l_k, a_c___1 * l_rik - a_s * l_rjk)
				gsl_gsl_matrix_double_inst.gsl_matrix_set (a_R, a_j, l_k, a_s * l_rik + a_c___1 * l_rjk)
				l_k := l_k + 1
			end
		end

	apply_givens_vec (a_v: CE_POINTER [PD_GSL_VECTOR]; a_i: NATURAL_32; a_j: NATURAL_32; a_c___1: REAL_64; a_s: REAL_64)
		local
			l_vi: REAL_64
			l_vj: REAL_64
		do
			l_vi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_v, a_i))
			l_vj := (gsl_gsl_vector_double_inst.gsl_vector_get (a_v, a_j))
			gsl_gsl_vector_double_inst.gsl_vector_set (a_v, a_i, a_c___1 * l_vi - a_s * l_vj)
			gsl_gsl_vector_double_inst.gsl_vector_set (a_v, a_j, a_s * l_vi + a_c___1 * l_vj)
		end

	apply_givens_lq (a_M: NATURAL_32; a_N: NATURAL_32; a_Q___1: CE_POINTER [PD_GSL_MATRIX]; a_L: CE_POINTER [PD_GSL_MATRIX]; a_i: NATURAL_32; a_j: NATURAL_32; a_c___1: REAL_64; a_s: REAL_64)
		local
			l_k: NATURAL_32
			l_qik: REAL_64
			l_qjk: REAL_64
			l_lki: REAL_64
			l_lkj: REAL_64
		do
			l_k := (0).to_natural_32
			from
			until
				not (l_k < a_M)
			loop
				l_qik := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_Q___1, a_i, l_k))
				l_qjk := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_Q___1, a_j, l_k))
				gsl_gsl_matrix_double_inst.gsl_matrix_set (a_Q___1, a_i, l_k, l_qik * a_c___1 - l_qjk * a_s)
				gsl_gsl_matrix_double_inst.gsl_matrix_set (a_Q___1, a_j, l_k, l_qik * a_s + l_qjk * a_c___1)
				l_k := l_k + 1
			end
			if a_i < a_j then
				l_k := a_i
			else
				l_k := a_j
			end
			from
			until
				not (l_k < a_N)
			loop
				l_lki := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_L, l_k, a_i))
				l_lkj := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_L, l_k, a_j))
				gsl_gsl_matrix_double_inst.gsl_matrix_set (a_L, l_k, a_i, a_c___1 * l_lki - a_s * l_lkj)
				gsl_gsl_matrix_double_inst.gsl_matrix_set (a_L, l_k, a_j, a_s * l_lki + a_c___1 * l_lkj)
				l_k := l_k + 1
			end
		end

end
