class
	P_ATANINT

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create atanint_data.make (<<21>>)
			create atanint_cs.make
		end

feature {ANY} -- attributes

	atanint_data: CE_ARRAY [REAL_64]

	atanint_cs: PD_CHEB_SERIES_STRUCT

feature {ANY} -- routines

	gsl_sf_atanint_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ax: REAL_64
			l_sgn: REAL_64
			l_tmp___0: INTEGER_32
			l_t: REAL_64
			l_result_c: PD_GSL_SF_RESULT_STRUCT
			l_t___0: REAL_64
			l_result_c___0: PD_GSL_SF_RESULT_STRUCT
		do
			create l_result_c.make
			create l_result_c___0.make

			l_ax := (fabs (a_x))
			if a_x >= 0.0 then
				l_tmp___0 := 1
			else
				l_tmp___0 := -1
			end
			l_sgn := l_tmp___0.to_double
			if l_ax = 0.0 then
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				Result := 0
			elseif l_ax < 0.5 * 1.4901161193847656e-08 then
				a_result.item.val := a_x
				a_result.item.err := 0.0
				Result := 0
			elseif l_ax <= 1.0 then
				l_t := 2.0 * (a_x * a_x - 0.5)
				cheb_eval_inst.cheb_eval_e ((atanint_cs.address), l_t, l_result_c.address).do_nothing
				a_result.item.val := a_x * l_result_c.val
				a_result.item.err := a_x * l_result_c.err
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				Result := 0
			elseif l_ax < 1.0 / 1.4901161193847656e-08 then
				l_t___0 := 2.0 * (1.0 / (a_x * a_x) - 0.5)
				cheb_eval_inst.cheb_eval_e ((atanint_cs.address), l_t___0, l_result_c___0.address).do_nothing
				a_result.item.val := l_sgn * ((0.5 * 3.14159265358979323846) * (log (l_ax)) + l_result_c___0.val / l_ax)
				a_result.item.err := l_result_c___0.err / l_ax + (fabs (a_result.item.val * 2.2204460492503131e-16))
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				Result := 0
			else
				a_result.item.val := ((l_sgn * 0.5) * 3.14159265358979323846) * (log (l_ax))
				a_result.item.err := 2.0 * (fabs (a_result.item.val * 2.2204460492503131e-16))
				Result := 0
			end
		end

	gsl_sf_atanint (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_atanint_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_atanint_e(x, &result)"), ce_string ("atanint.c"), 114, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
