class
	P_BALANCEMAT

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_linalg_balance_matrix (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_D: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_N: NATURAL_32
			l_row_norm: REAL_64
			l_col_norm: REAL_64
			l_not_converged: INTEGER_32
			l_v: PD_GSL_VECTOR_VIEW
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_g: REAL_64
			l_f: REAL_64
			l_s: REAL_64
			js: JUMP_STATE
		do
			create l_v.make

			l_N := a_A___0.item.size1
			if l_N /= a_D.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must match matrix size"), ce_string ("balancemat.c"), 54, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				init_source_inst.gsl_vector_set_all (a_D, 1.0)
				l_not_converged := 1
				from
				until
					not (not js.loop_left and then (l_not_converged.to_boolean))
				loop
					l_not_converged := 0
					l_i := (0).to_natural_32
					from
					until
						not (not js.loop_left and then (l_i < l_N))
					loop
						js.reset
						l_row_norm := 0.0
						l_col_norm := 0.0
						l_j := (0).to_natural_32
						from
						until
							not (l_j < l_N)
						loop
							if l_j /= l_i then
								l_col_norm := l_col_norm + (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_j, l_i))))
								l_row_norm := l_row_norm + (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_j))))
							end
							l_j := l_j + 1
						end
						if l_col_norm = 0.0 then
							js.continue
						elseif l_row_norm = 0.0 then
							js.continue
						end
						if not js.loop_jumped then
							l_g := l_row_norm / 2.0
							l_f := 1.0
							l_s := l_col_norm + l_row_norm
							from
							until
								not (l_col_norm < l_g)
							loop
								l_f := l_f * (2.0)
								l_col_norm := l_col_norm * (2.0 * 2.0)
							end
							l_g := l_row_norm * 2.0
							from
							until
								not (l_col_norm > l_g)
							loop
								l_f := l_f / (2.0)
								l_col_norm := l_col_norm / (2.0 * 2.0)
							end
							if l_row_norm + l_col_norm < (0.95 * l_s) * l_f then
								l_not_converged := 1
								l_g := 1.0 / l_f
								l_v.ce_gets (rowcol_source_inst.gsl_matrix_row (a_A___0, l_i))
								blas_inst.gsl_blas_dscal (l_g, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))
								l_v.ce_gets (rowcol_source_inst.gsl_matrix_column (a_A___0, l_i))
								blas_inst.gsl_blas_dscal (l_f, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))
								gsl_gsl_vector_double_inst.gsl_vector_set (a_D, l_i, (gsl_gsl_vector_double_inst.gsl_vector_get (a_D, l_i)) * l_f)
							end
						end
						if not js.loop_left then
							l_i := l_i + 1
						end
					end
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_balance_accum (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_D: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_s: REAL_64
			l_r___3: PD_GSL_VECTOR_VIEW
			js: JUMP_STATE
		do
			create l_r___3.make

			l_N := a_A___0.item.size1
			if l_N /= a_D.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector must match matrix size"), ce_string ("balancemat.c"), 168, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					l_s := gsl_gsl_vector_double_inst.gsl_vector_get (a_D, l_i)
					l_r___3.ce_gets (rowcol_source_inst.gsl_matrix_row (a_A___0, l_i))
					blas_inst.gsl_blas_dscal (l_s, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_r___3.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))
					l_i := l_i + 1
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

end
