class
	P_BESSEL_I0

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create bi0_data.make (<<12>>)
			create bi0_cs.make
			create ai0_data.make (<<21>>)
			create ai0_cs.make
			create ai02_data.make (<<22>>)
			create ai02_cs.make
		end

feature {ANY} -- attributes

	bi0_data: CE_ARRAY [REAL_64]

	bi0_cs: PD_CHEB_SERIES_STRUCT

	ai0_data: CE_ARRAY [REAL_64]

	ai0_cs: PD_CHEB_SERIES_STRUCT

	ai02_data: CE_ARRAY [REAL_64]

	ai02_cs: PD_CHEB_SERIES_STRUCT

feature {ANY} -- routines

	gsl_sf_bessel_I0_scaled_e2 (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_y: REAL_64
			l_ey: REAL_64
			l_c___1: PD_GSL_SF_RESULT_STRUCT
			l_sy: REAL_64
			l_c___2: PD_GSL_SF_RESULT_STRUCT
			l_sy___0: REAL_64
			l_c___3: PD_GSL_SF_RESULT_STRUCT
		do
			create l_c___1.make
			create l_c___2.make
			create l_c___3.make

			l_y := (fabs (a_x))
			if l_y < 2.0 * 1.4901161193847656e-08 then
				a_result.item.val := 1.0 - l_y
				a_result.item.err := (0.5 * l_y) * l_y
				Result := 0
			elseif l_y <= 3.0 then
				l_ey := (exp (-l_y))
				cheb_eval_inst.cheb_eval_e ((bi0_cs.address), (l_y * l_y) / 4.5 - 1.0, l_c___1.address).do_nothing
				a_result.item.val := l_ey * (2.75 + l_c___1.val)
				a_result.item.err := 2.2204460492503131e-16 * (fabs (a_result.item.val)) + l_ey * l_c___1.err
				Result := 0
			elseif l_y <= 8.0 then
				l_sy := (sqrt (l_y))
				cheb_eval_inst.cheb_eval_e ((ai0_cs.address), (48.0 / l_y - 11.0) / 5.0, l_c___2.address).do_nothing
				a_result.item.val := (0.375 + l_c___2.val) / l_sy
				a_result.item.err := ((2.0 * 2.2204460492503131e-16) * (0.375 + (fabs (l_c___2.val)))) / l_sy
				a_result.item.err := a_result.item.err + (l_c___2.err / l_sy)
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
			else
				l_sy___0 := (sqrt (l_y))
				cheb_eval_inst.cheb_eval_e ((ai02_cs.address), 16.0 / l_y - 1.0, l_c___3.address).do_nothing
				a_result.item.val := (0.375 + l_c___3.val) / l_sy___0
				a_result.item.err := ((2.0 * 2.2204460492503131e-16) * (0.375 + (fabs (l_c___3.val)))) / l_sy___0
				a_result.item.err := a_result.item.err + (l_c___3.err / l_sy___0)
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
			end
		end

	gsl_sf_bessel_I0_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_y: REAL_64
			l_c___1: PD_GSL_SF_RESULT_STRUCT
			l_ey: REAL_64
			l_b_scaled: PD_GSL_SF_RESULT_STRUCT
			js: JUMP_STATE
		do
			create l_c___1.make
			create l_b_scaled.make

			l_y := (fabs (a_x))
			if l_y < 2.0 * 1.4901161193847656e-08 then
				a_result.item.val := 1.0
				a_result.item.err := (0.5 * l_y) * l_y
				Result := 0
				js.return
			elseif l_y <= 3.0 then
				cheb_eval_inst.cheb_eval_e ((bi0_cs.address), (l_y * l_y) / 4.5 - 1.0, l_c___1.address).do_nothing
				a_result.item.val := 2.75 + l_c___1.val
				a_result.item.err := 2.2204460492503131e-16 * (2.75 + (fabs (l_c___1.val)))
				a_result.item.err := a_result.item.err + (l_c___1.err)
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
				js.return
			elseif l_y < 7.0978271289338397e+02 - 1.0 then
				l_ey := (exp (l_y))
				gsl_sf_bessel_I0_scaled_e2 (a_x, l_b_scaled.address).do_nothing
				a_result.item.val := l_ey * l_b_scaled.val
				a_result.item.err := l_ey * l_b_scaled.err + (l_y * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_inff).to_double
					a_result.item.err := (builtin_inff).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("overflow"), ce_string ("bessel_I0.c"), 216, 16)
						Result := 16
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_bessel_I0_scaled2 (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_bessel_I0_scaled_e2 (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_bessel_I0_scaled_e(x, &result);"), ce_string ("bessel_I0.c"), 226, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_bessel_I0 (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_bessel_I0_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_bessel_I0_e(x, &result);"), ce_string ("bessel_I0.c"), 231, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
