class
	P_BESSEL_IN

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_sf_bessel_In_scaled_e (a_n: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_n: INTEGER_32
			l_ax: REAL_64
			l_t: PD_GSL_SF_RESULT_STRUCT
			l_ex: REAL_64
			l_stat_In: INTEGER_32
			l_I0_scaled: PD_GSL_SF_RESULT_STRUCT
			l_stat_I0: INTEGER_32
			l_rat: REAL_64
			l_stat_CF1: INTEGER_32
			l_Ikp1: REAL_64
			l_Ik: REAL_64
			l_Ikm1: REAL_64
			l_k: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_stat_as: INTEGER_32
			l_nhi: INTEGER_32
			l_r_Ikp1: PD_GSL_SF_RESULT_STRUCT
			l_r_Ik: PD_GSL_SF_RESULT_STRUCT
			l_stat_a1: INTEGER_32
			l_stat_a2: INTEGER_32
			l_Ikp1___0: REAL_64
			l_Ik___0: REAL_64
			l_Ikm1___0: REAL_64
			l_k___0: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___15: REAL_64
			l_pos: INTEGER_32
		do
			create l_t.make
			create l_I0_scaled.make
			create l_r_Ikp1.make
			create l_r_Ik.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_n := a_n
					l_ax := (fabs (a_x))
					l_n := abs (l_n)
					if l_n /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						Result := (bessel_i0_inst.gsl_sf_bessel_I0_scaled_e2 (a_x, a_result))
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 3 then -- else:
						if l_n /= 1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						Result := (bessel_i1_inst.gsl_sf_bessel_I1_scaled_e2 (a_x, a_result))
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 6 then -- else:
						if a_x /= 0.0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						a_result.item.val := 0.0
						a_result.item.err := 0.0
						Result := 0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 9 then -- else:
						if not (a_x * a_x < (10.0 * (l_n.to_double + 1.0)) / 2.7182818284590452354) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_ex := (exp (-l_ax))
						l_stat_In := (bessel_inst.gsl_sf_bessel_IJ_taylor_e (l_n.to_double, l_ax, 1, 50, 2.2204460492503131e-16, l_t.address))
						a_result.item.val := l_t.val * l_ex
						a_result.item.err := l_t.err * l_ex
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						if a_x < 0.0 then
							if ((l_n).bit_and (1)).to_boolean then
								a_result.item.val := -a_result.item.val
							end
						end
						Result := l_stat_In
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 12 then -- else:
						if not (l_n < 150) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if l_ax < 1.e7 then
							l_stat_I0 := (bessel_i0_inst.gsl_sf_bessel_I0_scaled_e2 (l_ax, l_I0_scaled.address))
							l_stat_CF1 := (bessel_inst.gsl_sf_bessel_I_CF1_ser (l_n.to_double, l_ax, create {CE_POINTER [REAL_64]}.make_shared ($l_rat)))
							l_Ikp1 := l_rat * 1.4916681462400413e-154
							l_Ik := 1.4916681462400413e-154
							l_k := l_n
							from
							until
								not (l_k >= 1)
							loop
								l_Ikm1 := l_Ikp1 + ((2.0 * l_k.to_double) / l_ax) * l_Ik
								l_Ikp1 := l_Ik
								l_Ik := l_Ikm1
								l_k := l_k - 1
							end
							a_result.item.val := l_I0_scaled.val * (1.4916681462400413e-154 / l_Ik)
							a_result.item.err := l_I0_scaled.err * (1.4916681462400413e-154 / l_Ik)
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							if a_x < 0.0 then
								if ((l_n).bit_and (1)).to_boolean then
									a_result.item.val := -a_result.item.val
								end
							end
							if l_stat_I0 /= 0 then
								l_tmp___9 := l_stat_I0
							else
								if l_stat_CF1 /= 0 then
									l_tmp___8 := l_stat_CF1
								else
									l_tmp___8 := 0
								end
								l_tmp___9 := l_tmp___8
							end
							Result := l_tmp___9
						else
							l_pos := -1 + 15 -- goto _L
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else: | _L:
						if 0.29 / (l_n * l_n).to_double < 0.5 / ((l_n * l_n).to_double + a_x * a_x) then
							l_tmp___15 := 0.29 / (l_n * l_n).to_double
						else
							l_tmp___15 := 0.5 / ((l_n * l_n).to_double + a_x * a_x)
						end
						if l_tmp___15 < 0.5 * 6.0554544523933429e-06 then
							l_stat_as := (bessel_inst.gsl_sf_bessel_Inu_scaled_asymp_unif_e (l_n.to_double, l_ax, a_result))
							if a_x < 0.0 then
								if ((l_n).bit_and (1)).to_boolean then
									a_result.item.val := -a_result.item.val
								end
							end
							Result := l_stat_as
						else
							l_nhi := 2 + (1.2 / 2.4607833005759251e-03).truncated_to_integer
							l_stat_a1 := (bessel_inst.gsl_sf_bessel_Inu_scaled_asymp_unif_e (l_nhi.to_double + 1.0, l_ax, l_r_Ikp1.address))
							l_stat_a2 := (bessel_inst.gsl_sf_bessel_Inu_scaled_asymp_unif_e (l_nhi.to_double, l_ax, l_r_Ik.address))
							l_Ikp1___0 := l_r_Ikp1.val
							l_Ik___0 := l_r_Ik.val
							l_k___0 := l_nhi
							from
							until
								not (l_k___0 > l_n)
							loop
								l_Ikm1___0 := l_Ikp1___0 + ((2.0 * l_k___0.to_double) / l_ax) * l_Ik___0
								l_Ikp1___0 := l_Ik___0
								l_Ik___0 := l_Ikm1___0
								l_k___0 := l_k___0 - 1
							end
							a_result.item.val := l_Ik___0
							a_result.item.err := l_Ik___0 * (l_r_Ikp1.err / l_r_Ikp1.val + l_r_Ik.err / l_r_Ik.val)
							if a_x < 0.0 then
								if ((l_n).bit_and (1)).to_boolean then
									a_result.item.val := -a_result.item.val
								end
							end
							if l_stat_a1 /= 0 then
								l_tmp___14 := l_stat_a1
							else
								if l_stat_a2 /= 0 then
									l_tmp___13 := l_stat_a2
								else
									l_tmp___13 := 0
								end
								l_tmp___14 := l_tmp___13
							end
							Result := l_tmp___14
						end
				when 16 then -- if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_bessel_In_scaled_array (a_nmin: INTEGER_32; a_nmax: INTEGER_32; a_x: REAL_64; a_result_array: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_j: INTEGER_32
			l_j___0: INTEGER_32
			l_I0_scaled: PD_GSL_SF_RESULT_STRUCT
			l_stat: INTEGER_32
			l_ax: REAL_64
			l_two_over_x: REAL_64
			l_r_Inp1: PD_GSL_SF_RESULT_STRUCT
			l_r_In: PD_GSL_SF_RESULT_STRUCT
			l_stat_0: INTEGER_32
			l_stat_1: INTEGER_32
			l_Inp1: REAL_64
			l_In: REAL_64
			l_Inm1: REAL_64
			l_n: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_I0_scaled.make
			create l_r_Inp1.make
			create l_r_In.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_nmax < a_nmin) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_nmin < 0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_j := 0
						from
						until
							not (l_j <= a_nmax - a_nmin)
						loop
							a_result_array[l_j] := 0.0
							l_j := l_j + 1
						end
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("domain error"), ce_string ("bessel_In.c"), 120, 1)
							Result := 1
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if a_x = 0.0 then
							l_j___0 := 0
							from
							until
								not (l_j___0 <= a_nmax - a_nmin)
							loop
								a_result_array[l_j___0] := 0.0
								l_j___0 := l_j___0 + 1
							end
							if a_nmin = 0 then
								a_result_array[0] := 1.0
							end
							Result := 0
							js.return
						elseif a_nmax = 0 then
							l_stat := (bessel_i0_inst.gsl_sf_bessel_I0_scaled_e2 (a_x, l_I0_scaled.address))
							a_result_array[0] := l_I0_scaled.val
							Result := l_stat
							js.return
						else
							l_ax := (fabs (a_x))
							l_two_over_x := 2.0 / l_ax
							l_stat_0 := (gsl_sf_bessel_In_scaled_e (a_nmax + 1, l_ax, l_r_Inp1.address))
							l_stat_1 := (gsl_sf_bessel_In_scaled_e (a_nmax, l_ax, l_r_In.address))
							l_Inp1 := l_r_Inp1.val
							l_In := l_r_In.val
							l_n := a_nmax
							from
							until
								not (l_n >= a_nmin)
							loop
								a_result_array[(l_n - a_nmin)] := l_In
								l_Inm1 := l_Inp1 + (l_n.to_double * l_two_over_x) * l_In
								l_Inp1 := l_In
								l_In := l_Inm1
								l_n := l_n - 1
							end
							if a_x < 0.0 then
								l_n := a_nmin
								from
								until
									not (l_n <= a_nmax)
								loop
									if ((l_n).bit_and (1)).to_boolean then
										a_result_array[(l_n - a_nmin)] := -a_result_array[(l_n - a_nmin)]
									end
									l_n := l_n + 1
								end
							end
							if l_stat_0 /= 0 then
								l_tmp___4 := l_stat_0
							else
								if l_stat_1 /= 0 then
									l_tmp___3 := l_stat_1
								else
									l_tmp___3 := 0
								end
								l_tmp___4 := l_tmp___3
							end
							Result := l_tmp___4
							js.return
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_bessel_In_e (a_n_in: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ax: REAL_64
			l_n: INTEGER_32
			l_In_scaled: PD_GSL_SF_RESULT_STRUCT
			l_stat_In_scaled: INTEGER_32
			l_ex: REAL_64
			js: JUMP_STATE
		do
			create l_In_scaled.make

			l_ax := (fabs (a_x))
			l_n := (abs (a_n_in))
			l_stat_In_scaled := (gsl_sf_bessel_In_scaled_e (l_n, l_ax, l_In_scaled.address))
			if l_ax > 7.0978271289338397e+02 - 1.0 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_inff).to_double
					a_result.item.err := (builtin_inff).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("overflow"), ce_string ("bessel_In.c"), 179, 16)
						Result := 16
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_ex := (exp (l_ax))
				a_result.item.val := l_ex * l_In_scaled.val
				a_result.item.err := l_ex * l_In_scaled.err
				a_result.item.err := a_result.item.err + ((l_ax * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				if a_x < 0.0 then
					if ((l_n).bit_and (1)).to_boolean then
						a_result.item.val := -a_result.item.val
					end
				end
				Result := l_stat_In_scaled
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_bessel_In_array (a_nmin: INTEGER_32; a_nmax: INTEGER_32; a_x: REAL_64; a_result_array: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_ax: REAL_64
			l_j: INTEGER_32
			l_j___0: INTEGER_32
			l_eax: REAL_64
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_ax := (fabs (a_x))
			if l_ax > 7.0978271289338397e+02 - 1.0 then
				l_j := 0
				from
				until
					not (l_j <= a_nmax - a_nmin)
				loop
					a_result_array[l_j] := 0.0
					l_j := l_j + 1
				end
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("overflow"), ce_string ("bessel_In.c"), 202, 16)
					Result := 16
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_eax := (exp (l_ax))
				l_status := (gsl_sf_bessel_In_scaled_array (a_nmin, a_nmax, a_x, a_result_array))
				l_j___0 := 0
				from
				until
					not (l_j___0 <= a_nmax - a_nmin)
				loop
					a_result_array[l_j___0] := a_result_array[l_j___0] * l_eax
					l_j___0 := l_j___0 + 1
				end
				Result := l_status
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_bessel_In_scaled (a_n: INTEGER_32; a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_bessel_In_scaled_e (a_n, a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_bessel_In_scaled_e(n, x, &result)"), ce_string ("bessel_In.c"), 219, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_bessel_In (a_n: INTEGER_32; a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_bessel_In_e (a_n, a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_bessel_In_e(n, x, &result)"), ce_string ("bessel_In.c"), 224, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
