class
	P_BESSEL_INU

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_sf_bessel_Inu_scaled_e (a_nu: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_b___0: PD_GSL_SF_RESULT_STRUCT
			l_ex: REAL_64
			l_stat: INTEGER_32
			l_N: INTEGER_32
			l_mu: REAL_64
			l_K_mu: REAL_64
			l_K_mup1: REAL_64
			l_Kp_mu: REAL_64
			l_K_nu: REAL_64
			l_K_nup1: REAL_64
			l_K_num1: REAL_64
			l_I_nu_ratio: REAL_64
			l_stat_Irat: INTEGER_32
			l_stat_Kmu: INTEGER_32
			l_n2: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_b___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_x < 0.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_nu < 0.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("bessel_Inu.c"), 43, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if a_x * a_x < 10.0 * (a_nu + 1.0) then
							l_ex := (exp (-a_x))
							l_stat := (bessel_inst.gsl_sf_bessel_IJ_taylor_e (a_nu, a_x, 1, 100, 2.2204460492503131e-16, l_b___0.address))
							a_result.item.val := l_b___0.val * l_ex
							a_result.item.err := l_b___0.err * l_ex
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							Result := l_stat
							js.return
						elseif 0.5 / (a_nu * a_nu + a_x * a_x) < 6.0554544523933429e-06 then
							Result := (bessel_inst.gsl_sf_bessel_Inu_scaled_asymp_unif_e (a_nu, a_x, a_result))
							js.return
						else
							l_N := (a_nu + 0.5).truncated_to_integer
							l_mu := a_nu - l_N.to_double
							if a_x < 2.0 then
								l_stat_Kmu := bessel_temme_inst.gsl_sf_bessel_K_scaled_temme (l_mu, a_x, create {CE_POINTER [REAL_64]}.make_shared ($l_K_mu), create {CE_POINTER [REAL_64]}.make_shared ($l_K_mup1), create {CE_POINTER [REAL_64]}.make_shared ($l_Kp_mu))
							else
								l_stat_Kmu := bessel_inst.gsl_sf_bessel_K_scaled_steed_temme_CF2 (l_mu, a_x, create {CE_POINTER [REAL_64]}.make_shared ($l_K_mu), create {CE_POINTER [REAL_64]}.make_shared ($l_K_mup1), create {CE_POINTER [REAL_64]}.make_shared ($l_Kp_mu))
							end
							l_K_nu := l_K_mu
							l_K_nup1 := l_K_mup1
							l_n2 := 0
							from
							until
								not (l_n2 < l_N)
							loop
								l_K_num1 := l_K_nu
								l_K_nu := l_K_nup1
								l_K_nup1 := ((2.0 * ((l_mu + l_n2.to_double) + (1).to_double)) / a_x) * l_K_nu + l_K_num1
								l_n2 := l_n2 + 1
							end
							l_stat_Irat := bessel_inst.gsl_sf_bessel_I_CF1_ser (a_nu, a_x, create {CE_POINTER [REAL_64]}.make_shared ($l_I_nu_ratio))
							a_result.item.val := 1.0 / (a_x * (l_K_nup1 + l_I_nu_ratio * l_K_nu))
							a_result.item.err := (2.2204460492503131e-16 * (0.5 * l_N.to_double + 2.0)) * (fabs (a_result.item.val))
							if l_stat_Kmu /= 0 then
								l_tmp___7 := l_stat_Kmu
							else
								if l_stat_Irat /= 0 then
									l_tmp___6 := l_stat_Irat
								else
									l_tmp___6 := 0
								end
								l_tmp___7 := l_tmp___6
							end
							Result := l_tmp___7
							js.return
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_bessel_Inu_e (a_nu: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_b___0: PD_GSL_SF_RESULT_STRUCT
			l_stat_I: INTEGER_32
			l_stat_e: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
		do
			create l_b___0.make

			l_stat_I := (gsl_sf_bessel_Inu_scaled_e (a_nu, a_x, l_b___0.address))
			l_stat_e := (exp_inst.gsl_sf_exp_mult_err_e (a_x, (fabs (a_x * 2.2204460492503131e-16)), l_b___0.val, l_b___0.err, a_result))
			if l_stat_e /= 0 then
				l_tmp___3 := l_stat_e
			else
				if l_stat_I /= 0 then
					l_tmp___2 := l_stat_I
				else
					l_tmp___2 := 0
				end
				l_tmp___3 := l_tmp___2
			end
			Result := l_tmp___3
		end

	gsl_sf_bessel_Inu_scaled (a_nu: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_bessel_Inu_scaled_e (a_nu, a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_bessel_Inu_scaled_e(nu, x, &result)"), ce_string ("bessel_Inu.c"), 115, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_bessel_Inu (a_nu: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_bessel_Inu_e (a_nu, a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_bessel_Inu_e(nu, x, &result)"), ce_string ("bessel_Inu.c"), 121, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
