class
	P_BESSEL_K

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	bessel_kl_scaled_small_x (a_l: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_num_fact: PD_GSL_SF_RESULT_STRUCT
			l_den: REAL_64
			l_stat_df: INTEGER_32
			l_lmax: INTEGER_32
			l_ipos_term: PD_GSL_SF_RESULT_STRUCT
			l_ineg_term: REAL_64
			l_sgn: REAL_64
			l_tmp___3: REAL_64
			l_ex: REAL_64
			l_t: REAL_64
			l_sum: REAL_64
			l_t_coeff: REAL_64
			l_t_power: REAL_64
			l_delta___0: REAL_64
			l_stat_il: INTEGER_32
			l_i: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_num_fact.make
			create l_ipos_term.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_den := (pow_int_inst.gsl_sf_pow_int (a_x, a_l + 1))
					l_stat_df := (gamma_inst.gsl_sf_doublefact_e ((2 * a_l - 1).to_natural_32, l_num_fact.address))
					if l_stat_df = 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if l_den /= 0.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_inff).to_double
							a_result.item.err := (builtin_inff).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("overflow"), ce_string ("bessel_k.c"), 48, 16)
								Result := 16
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_lmax := 50
						if ((a_l).bit_and (1)).to_boolean then
							l_tmp___3 := -1.0
						else
							l_tmp___3 := 1.0
						end
						l_sgn := l_tmp___3
						l_ex := (exp (a_x))
						l_t := (0.5 * a_x) * a_x
						l_sum := 1.0
						l_t_coeff := 1.0
						l_t_power := 1.0
						l_i := 1
						from
						until
							not (not js.loop_left and then (l_i < l_lmax))
						loop
							js.reset
							l_t_coeff := l_t_coeff / (l_i * (2 * (l_i - a_l) - 1)).to_double
							l_t_power := l_t_power * l_t
							l_delta___0 := l_t_power * l_t_coeff
							l_sum := l_sum + l_delta___0
							if (fabs (l_delta___0 / l_sum)) < 2.2204460492503131e-16 then
								js.break
							end
							if not js.loop_jumped then
								l_i := l_i + 1
							end
						end
						js.reset
						l_stat_il := bessel_i_inst.gsl_sf_bessel_il_scaled_e (a_l, a_x, l_ipos_term.address)
						l_ineg_term := ((l_sgn * l_num_fact.val) / l_den) * l_sum
						a_result.item.val := ((-l_sgn * 0.5) * 3.14159265358979323846) * (l_ex * l_ipos_term.val - l_ineg_term)
						a_result.item.val := a_result.item.val * l_ex
						a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
						Result := l_stat_il
						js.return
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_bessel_k0_scaled_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_x <= 0.0 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("bessel_k.c"), 89, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				a_result.item.val := 3.14159265358979323846 / (2.0 * a_x)
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				if (fabs (a_result.item.val)) < 2.2250738585072014e-308 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("bessel_k.c"), 94, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
				if not js.return_called then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_bessel_k1_scaled_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_x <= 0.0 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("bessel_k.c"), 105, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_x < (1.77245385090551602729816748334 + 1.0) / (1.41421356237309504880 * 1.3407807929942596e+154) then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_inff).to_double
					a_result.item.err := (builtin_inff).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("overflow"), ce_string ("bessel_k.c"), 108, 16)
						Result := 16
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				a_result.item.val := (3.14159265358979323846 / (2.0 * a_x)) * (1.0 + 1.0 / a_x)
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				if (fabs (a_result.item.val)) < 2.2250738585072014e-308 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("bessel_k.c"), 113, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
				if not js.return_called then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_bessel_k2_scaled_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_x <= 0.0 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("bessel_k.c"), 124, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_x < 2.0 / 5.6438030941222897e+102 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_inff).to_double
					a_result.item.err := (builtin_inff).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("overflow"), ce_string ("bessel_k.c"), 127, 16)
						Result := 16
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				a_result.item.val := (3.14159265358979323846 / (2.0 * a_x)) * (1.0 + (3.0 / a_x) * (1.0 + 1.0 / a_x))
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				if (fabs (a_result.item.val)) < 2.2250738585072014e-308 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("bessel_k.c"), 132, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
				if not js.return_called then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_bessel_kl_scaled_e (a_l: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_status: INTEGER_32
			l_pre: REAL_64
			l_status___0: INTEGER_32
			l_pre___0: REAL_64
			l_r_bk: PD_GSL_SF_RESULT_STRUCT
			l_r_bkm: PD_GSL_SF_RESULT_STRUCT
			l_stat_1: INTEGER_32
			l_stat_0: INTEGER_32
			l_bkp: REAL_64
			l_bk: REAL_64
			l_bkm: REAL_64
			l_j: INTEGER_32
			l_tmp___11: REAL_64
			l_tmp___12: REAL_64
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_r_bk.make
			create l_r_bkm.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_l < 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_x <= 0.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("bessel_k.c"), 141, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if a_l = 0 then
							Result := (gsl_sf_bessel_k0_scaled_e (a_x, a_result))
							js.return
						elseif a_l = 1 then
							Result := (gsl_sf_bessel_k1_scaled_e (a_x, a_result))
							js.return
						elseif a_l = 2 then
							Result := (gsl_sf_bessel_k2_scaled_e (a_x, a_result))
							js.return
						elseif a_x < 3.0 then
							Result := (bessel_kl_scaled_small_x (a_l, a_x, a_result))
							js.return
						elseif 6.0554544523933429e-06 * a_x > ((a_l * a_l + a_l) + 1).to_double then
							l_status := (bessel_inst.gsl_sf_bessel_Knu_scaled_asympx_e (a_l.to_double + 0.5, a_x, a_result))
							l_pre := (sqrt ((0.5 * 3.14159265358979323846) / a_x))
							a_result.item.val := a_result.item.val * l_pre
							a_result.item.err := a_result.item.err * l_pre
							Result := l_status
							js.return
						else
							if 0.29 / ((a_l * a_l).to_double + 1.0) < 0.5 / (((a_l * a_l).to_double + 1.0) + a_x * a_x) then
								l_tmp___17 := 0.29 / ((a_l * a_l).to_double + 1.0)
							else
								l_tmp___17 := 0.5 / (((a_l * a_l).to_double + 1.0) + a_x * a_x)
							end
							if l_tmp___17 < 6.0554544523933429e-06 then
								l_status___0 := (bessel_inst.gsl_sf_bessel_Knu_scaled_asymp_unif_e (a_l.to_double + 0.5, a_x, a_result))
								l_pre___0 := (sqrt ((0.5 * 3.14159265358979323846) / a_x))
								a_result.item.val := a_result.item.val * l_pre___0
								a_result.item.err := a_result.item.err * l_pre___0
								Result := l_status___0
								js.return
							else
								l_stat_1 := (gsl_sf_bessel_k1_scaled_e (a_x, l_r_bk.address))
								l_stat_0 := (gsl_sf_bessel_k0_scaled_e (a_x, l_r_bkm.address))
								l_bk := l_r_bk.val
								l_bkm := l_r_bkm.val
								l_j := 1
								from
								until
									not (l_j < a_l)
								loop
									l_bkp := ((2 * l_j + 1).to_double / a_x) * l_bk + l_bkm
									l_bkm := l_bk
									l_bk := l_bkp
									l_j := l_j + 1
								end
								a_result.item.val := l_bk
								l_tmp___11 := fabs (l_bk)
								l_tmp___12 := fabs (l_r_bk.err / l_r_bk.val)
								a_result.item.err := l_tmp___11 * (l_tmp___12 + (fabs (l_r_bkm.err / l_r_bkm.val)))
								a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
								if l_stat_1 /= 0 then
									l_tmp___16 := l_stat_1
								else
									if l_stat_0 /= 0 then
										l_tmp___15 := l_stat_0
									else
										l_tmp___15 := 0
									end
									l_tmp___16 := l_tmp___15
								end
								Result := l_tmp___16
								js.return
							end
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_bessel_kl_scaled_array (a_lmax: INTEGER_32; a_x: REAL_64; a_result_array: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_stat: INTEGER_32
			l_ell: INTEGER_32
			l_kellp1: REAL_64
			l_kell: REAL_64
			l_kellm1: REAL_64
			l_r_kell: PD_GSL_SF_RESULT_STRUCT
			l_r_kellm1: PD_GSL_SF_RESULT_STRUCT
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_result.make
			create l_r_kell.make
			create l_r_kellm1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_lmax < 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_x <= 0.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("domain error"), ce_string ("bessel_k.c"), 196, 1)
							Result := 1
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if a_lmax = 0 then
							l_stat := (gsl_sf_bessel_k0_scaled_e (a_x, l_result.address))
							a_result_array[0] := l_result.val
							Result := l_stat
							js.return
						else
							gsl_sf_bessel_k1_scaled_e (a_x, l_r_kell.address).do_nothing
							gsl_sf_bessel_k0_scaled_e (a_x, l_r_kellm1.address).do_nothing
							l_kell := l_r_kell.val
							l_kellm1 := l_r_kellm1.val
							a_result_array[0] := l_kellm1
							a_result_array[1] := l_kell
							l_ell := 1
							from
							until
								not (l_ell < a_lmax)
							loop
								l_kellp1 := ((2 * l_ell + 1).to_double / a_x) * l_kell + l_kellm1
								a_result_array[(l_ell + 1)] := l_kellp1
								l_kellm1 := l_kell
								l_kell := l_kellp1
								l_ell := l_ell + 1
							end
							Result := 0
							js.return
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_bessel_k0_scaled (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_bessel_k0_scaled_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_bessel_k0_scaled_e(x, &result)"), ce_string ("bessel_k.c"), 230, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_bessel_k1_scaled (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_bessel_k1_scaled_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_bessel_k1_scaled_e(x, &result)"), ce_string ("bessel_k.c"), 235, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_bessel_k2_scaled (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_bessel_k2_scaled_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_bessel_k2_scaled_e(x, &result)"), ce_string ("bessel_k.c"), 240, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_bessel_kl_scaled (a_l: INTEGER_32; a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_bessel_kl_scaled_e (a_l, a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_bessel_kl_scaled_e(l, x, &result)"), ce_string ("bessel_k.c"), 245, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
