class
	P_BETA_INC

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	isnegint (a_x: REAL_64): REAL_64
		local
			l_tmp___0: INTEGER_32
		do
			if a_x < (0).to_double then
				if a_x = (floor (a_x)) then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0.to_double
		end

	beta_cont_frac (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_max_iter: NATURAL_32
			l_cutoff: REAL_64
			l_iter_count: NATURAL_32
			l_cf: REAL_64
			l_num_term: REAL_64
			l_den_term: REAL_64
			l_k: INTEGER_32
			l_coeff: REAL_64
			l_delta_frac: REAL_64
			js: JUMP_STATE
		do
			l_max_iter := {NATURAL_32} 512
			l_cutoff := 2.0 * 2.2250738585072014e-308
			l_iter_count := {NATURAL_32} 0
			l_num_term := 1.0
			l_den_term := 1.0 - ((a_a___5 + a_b___0) * a_x) / (a_a___5 + 1.0)
			if (fabs (l_den_term)) < l_cutoff then
				l_den_term := l_cutoff
			end
			l_den_term := 1.0 / l_den_term
			l_cf := l_den_term
			from
			until
				not (not js.loop_left and then (l_iter_count < l_max_iter))
			loop
				js.reset
				l_k := (l_iter_count + {NATURAL_32} 1).to_integer_32
				l_coeff := ((l_k.to_double * (a_b___0 - l_k.to_double)) * a_x) / (((a_a___5 - 1.0) + (2 * l_k).to_double) * (a_a___5 + (2 * l_k).to_double))
				l_den_term := 1.0 + l_coeff * l_den_term
				l_num_term := 1.0 + l_coeff / l_num_term
				if (fabs (l_den_term)) < l_cutoff then
					l_den_term := l_cutoff
				end
				if (fabs (l_num_term)) < l_cutoff then
					l_num_term := l_cutoff
				end
				l_den_term := 1.0 / l_den_term
				l_delta_frac := l_den_term * l_num_term
				l_cf := l_cf * l_delta_frac
				l_coeff := ((-(a_a___5 + l_k.to_double) * ((a_a___5 + a_b___0) + l_k.to_double)) * a_x) / ((a_a___5 + (2 * l_k).to_double) * ((a_a___5 + (2 * l_k).to_double) + 1.0))
				l_den_term := 1.0 + l_coeff * l_den_term
				l_num_term := 1.0 + l_coeff / l_num_term
				if (fabs (l_den_term)) < l_cutoff then
					l_den_term := l_cutoff
				end
				if (fabs (l_num_term)) < l_cutoff then
					l_num_term := l_cutoff
				end
				l_den_term := 1.0 / l_den_term
				l_delta_frac := l_den_term * l_num_term
				l_cf := l_cf * l_delta_frac
				if (fabs (l_delta_frac - 1.0)) < 2.0 * 2.2204460492503131e-16 then
					js.break
				end
				if not js.loop_jumped then
					l_iter_count := l_iter_count + 1
				end
			end
			js.reset
			a_result.item.val := l_cf
			a_result.item.err := ((l_iter_count.to_real_64 * 4.0) * 2.2204460492503131e-16) * (fabs (l_cf))
			if l_iter_count >= l_max_iter then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("error"), ce_string ("beta_inc.c"), 97, 11)
					Result := 11
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_beta_inc_e (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_f: PD_GSL_SF_RESULT_STRUCT
			l_beta: PD_GSL_SF_RESULT_STRUCT
			l_stat: INTEGER_32
			l_stat_f: INTEGER_32
			l_stat_beta: INTEGER_32
			l_prefactor: REAL_64
			l_tmp___8: REAL_64
			l_tmp___9: REAL_64
			l_tmp___11: INTEGER_32
			l_ln_beta: PD_GSL_SF_RESULT_STRUCT
			l_ln_x: PD_GSL_SF_RESULT_STRUCT
			l_ln_1mx: PD_GSL_SF_RESULT_STRUCT
			l_prefactor___0: PD_GSL_SF_RESULT_STRUCT
			l_stat_ln_beta: INTEGER_32
			l_stat_ln_1mx: INTEGER_32
			l_stat_ln_x: INTEGER_32
			l_stat_ln: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_ln_pre_val: REAL_64
			l_ln_pre_err: REAL_64
			l_tmp___19: REAL_64
			l_stat_exp: INTEGER_32
			l_cf: PD_GSL_SF_RESULT_STRUCT
			l_stat_cf: INTEGER_32
			l_stat___0: INTEGER_32
			l_tmp___23: REAL_64
			l_tmp___25: INTEGER_32
			l_cf___0: PD_GSL_SF_RESULT_STRUCT
			l_stat_cf___0: INTEGER_32
			l_stat___1: INTEGER_32
			l_term: REAL_64
			l_tmp___31: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_f.make
			create l_beta.make
			create l_ln_beta.make
			create l_ln_x.make
			create l_ln_1mx.make
			create l_prefactor___0.make
			create l_cf.make
			create l_cf___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_x < 0.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 3 then -- else:
						if not (a_x > 1.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L___1:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("beta_inc.c"), 115, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 6 then -- else:
						if not ((isnegint (a_a___5)).truncated_to_integer.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 9 then -- else:
						if not ((isnegint (a_b___0)).truncated_to_integer.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("beta_inc.c"), 117, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 12 then -- else:
						if not ((isnegint (a_a___5 + a_b___0)).truncated_to_integer.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("beta_inc.c"), 119, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 15 then -- else:
						if a_x /= 0.0 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						a_result.item.val := 0.0
						a_result.item.err := 0.0
						Result := 0
						js.return
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 18 then -- else:
						if a_x /= 1.0 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						a_result.item.val := 1.0
						a_result.item.err := 0.0
						Result := 0
						js.return
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 21 then -- else:
						if not (a_a___5 <= (0).to_double) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_pos := -1 + 25 -- goto _L
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 24 then -- else:
						if not (a_b___0 <= (0).to_double) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if: | _L:
						l_stat_f := (hyperg_2f1_inst.gsl_sf_hyperg_2F1_e (a_a___5, (1).to_double - a_b___0, a_a___5 + (1).to_double, a_x, l_f.address))
						l_stat_beta := (beta_inst.gsl_sf_beta_e (a_a___5, a_b___0, l_beta.address))
						l_prefactor := (pow (a_x, a_a___5)) / a_a___5
						a_result.item.val := (l_prefactor * l_f.val) / l_beta.val
						l_tmp___8 := fabs (l_prefactor)
						l_tmp___9 := fabs (l_beta.val)
						a_result.item.err := (l_tmp___8 * l_f.err) / l_tmp___9 + (fabs (a_result.item.val / l_beta.val)) * l_beta.err
						if l_stat_f /= 0 then
							l_stat := l_stat_f
						else
							if l_stat_beta /= 0 then
								l_tmp___11 := l_stat_beta
							else
								l_tmp___11 := 0
							end
							l_stat := l_tmp___11
						end
						if l_stat = 0 then
							if (fabs (a_result.item.val)) < 2.2250738585072014e-308 then
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("underflow"), ce_string ("beta_inc.c"), 140, 15)
									Result := 15
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
							end
						end
						if not js.return_called then
							Result := l_stat
							js.return
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else:
						l_stat_ln_beta := (beta_inst.gsl_sf_lnbeta_e (a_a___5, a_b___0, l_ln_beta.address))
						l_stat_ln_1mx := (log_inst.gsl_sf_log_1plusx_e (-a_x, l_ln_1mx.address))
						l_stat_ln_x := (log_inst.gsl_sf_log_e (a_x, l_ln_x.address))
						if l_stat_ln_beta /= 0 then
							l_tmp___18 := l_stat_ln_beta
						else
							if l_stat_ln_1mx /= 0 then
								l_tmp___17 := l_stat_ln_1mx
							else
								if l_stat_ln_x /= 0 then
									l_tmp___16 := l_stat_ln_x
								else
									l_tmp___16 := 0
								end
								l_tmp___17 := l_tmp___16
							end
							l_tmp___18 := l_tmp___17
						end
						l_stat_ln := l_tmp___18
						l_ln_pre_val := (-l_ln_beta.val + a_a___5 * l_ln_x.val) + a_b___0 * l_ln_1mx.val
						l_tmp___19 := fabs (a_a___5 * l_ln_x.err)
						l_ln_pre_err := (l_ln_beta.err + l_tmp___19) + (fabs (a_b___0 * l_ln_1mx.err))
						l_stat_exp := (exp_inst.gsl_sf_exp_err_e (l_ln_pre_val, l_ln_pre_err, l_prefactor___0.address))
						if l_stat_ln /= 0 then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("error"), ce_string ("beta_inc.c"), 160, 7)
								Result := 7
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
						if not js.return_called then
							if a_x < (a_a___5 + 1.0) / ((a_a___5 + a_b___0) + 2.0) then
								l_stat_cf := (beta_cont_frac (a_a___5, a_b___0, a_x, l_cf.address))
								a_result.item.val := (l_prefactor___0.val * l_cf.val) / a_a___5
								l_tmp___23 := fabs (l_prefactor___0.err * l_cf.val)
								a_result.item.err := (l_tmp___23 + (fabs (l_prefactor___0.val * l_cf.err))) / a_a___5
								if l_stat_exp /= 0 then
									l_stat___0 := l_stat_exp
								else
									if l_stat_cf /= 0 then
										l_tmp___25 := l_stat_cf
									else
										l_tmp___25 := 0
									end
									l_stat___0 := l_tmp___25
								end
								if l_stat___0 = 0 then
									if (fabs (a_result.item.val)) < 2.2250738585072014e-308 then
										from
										until
											js.loop_left
										loop
											js.reset
											error_inst.gsl_error (ce_string ("underflow"), ce_string ("beta_inc.c"), 173, 15)
											Result := 15
											js.return
											if not js.return_called then
												js.break
											end
										end
										js.reset
									end
								end
								if not js.return_called then
									Result := l_stat___0
									js.return
								end
							else
								l_stat_cf___0 := (beta_cont_frac (a_b___0, a_a___5, 1.0 - a_x, l_cf___0.address))
								l_term := (l_prefactor___0.val * l_cf___0.val) / a_b___0
								a_result.item.val := 1.0 - l_term
								a_result.item.err := (fabs (l_prefactor___0.err * l_cf___0.val)) / a_b___0
								a_result.item.err := a_result.item.err + ((fabs (l_prefactor___0.val * l_cf___0.err)) / a_b___0)
								a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (1.0 + (fabs (l_term))))
								if l_stat_exp /= 0 then
									l_stat___1 := l_stat_exp
								else
									if l_stat_cf___0 /= 0 then
										l_tmp___31 := l_stat_cf___0
									else
										l_tmp___31 := 0
									end
									l_stat___1 := l_tmp___31
								end
								if l_stat___1 = 0 then
									if (fabs (a_result.item.val)) < 2.2250738585072014e-308 then
										from
										until
											js.loop_left
										loop
											js.reset
											error_inst.gsl_error (ce_string ("underflow"), ce_string ("beta_inc.c"), 189, 15)
											Result := 15
											js.return
											if not js.return_called then
												js.break
											end
										end
										js.reset
									end
								end
								if not js.return_called then
									Result := l_stat___1
									js.return
								end
							end
						end
				when 28 then -- if done | if done | if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 29 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_beta_inc (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_beta_inc_e (a_a___5, a_b___0, a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_beta_inc_e(a, b, x, &result)"), ce_string ("beta_inc.c"), 203, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	beta_cont_frac___0 (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_epsabs: REAL_64): REAL_64
		local
			l_max_iter: NATURAL_32
			l_cutoff: REAL_64
			l_iter_count: NATURAL_32
			l_cf: REAL_64
			l_num_term: REAL_64
			l_den_term: REAL_64
			l_k: INTEGER_32
			l_coeff: REAL_64
			l_delta_frac: REAL_64
			js: JUMP_STATE
		do
			l_max_iter := {NATURAL_32} 512
			l_cutoff := 2.0 * 2.2250738585072014e-308
			l_iter_count := {NATURAL_32} 0
			l_num_term := 1.0
			l_den_term := 1.0 - ((a_a___5 + a_b___0) * a_x) / (a_a___5 + 1.0)
			if (fabs (l_den_term)) < l_cutoff then
				l_den_term := (builtin_nanf (ce_string (""))).to_double
			end
			l_den_term := 1.0 / l_den_term
			l_cf := l_den_term
			from
			until
				not (not js.loop_left and then (l_iter_count < l_max_iter))
			loop
				js.reset
				l_k := (l_iter_count + {NATURAL_32} 1).to_integer_32
				l_coeff := ((l_k.to_double * (a_b___0 - l_k.to_double)) * a_x) / (((a_a___5 - 1.0) + (2 * l_k).to_double) * (a_a___5 + (2 * l_k).to_double))
				l_den_term := 1.0 + l_coeff * l_den_term
				l_num_term := 1.0 + l_coeff / l_num_term
				if (fabs (l_den_term)) < l_cutoff then
					l_den_term := (builtin_nanf (ce_string (""))).to_double
				end
				if (fabs (l_num_term)) < l_cutoff then
					l_num_term := (builtin_nanf (ce_string (""))).to_double
				end
				l_den_term := 1.0 / l_den_term
				l_delta_frac := l_den_term * l_num_term
				l_cf := l_cf * l_delta_frac
				l_coeff := ((-(a_a___5 + l_k.to_double) * ((a_a___5 + a_b___0) + l_k.to_double)) * a_x) / ((a_a___5 + (2 * l_k).to_double) * ((a_a___5 + (2 * l_k).to_double) + 1.0))
				l_den_term := 1.0 + l_coeff * l_den_term
				l_num_term := 1.0 + l_coeff / l_num_term
				if (fabs (l_den_term)) < l_cutoff then
					l_den_term := (builtin_nanf (ce_string (""))).to_double
				end
				if (fabs (l_num_term)) < l_cutoff then
					l_num_term := (builtin_nanf (ce_string (""))).to_double
				end
				l_den_term := 1.0 / l_den_term
				l_delta_frac := l_den_term * l_num_term
				l_cf := l_cf * l_delta_frac
				if (fabs (l_delta_frac - 1.0)) < 2.0 * 2.2204460492503131e-16 then
					js.break
				end
				if not js.loop_jumped then
					if l_cf * (fabs (l_delta_frac - 1.0)) < a_epsabs then
						js.break
					end
				end
				if not js.loop_jumped then
					l_iter_count := l_iter_count + 1
				end
			end
			js.reset
			if l_iter_count >= l_max_iter then
				Result := (builtin_nanf (ce_string (""))).to_double
				js.return
			end
			if not js.return_called then
				Result := l_cf
			end
		end

	beta_inc_AXPY (a_A___0: REAL_64; a_Y: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64): REAL_64
		local
			l_N: REAL_64
			l_N___0: REAL_64
			l_ln_beta: REAL_64
			l_ln_pre: REAL_64
			l_tmp___4: REAL_64
			l_prefactor: REAL_64
			l_epsabs: REAL_64
			l_cf: REAL_64
			l_epsabs___0: REAL_64
			l_cf___0: REAL_64
			l_term: REAL_64
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_x /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						Result := (a_A___0 * (0).to_double + a_Y)
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if a_x /= 1.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						Result := (a_A___0 * (1).to_double + a_Y)
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if not (a_a___5 > 1.e5) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if a_b___0 < (10).to_double then
							if a_x > a_a___5 / (a_a___5 + a_b___0) then
								l_N := a_a___5 + (a_b___0 - 1.0) / 2.0
								Result := (a_A___0 * (gamma_inc_inst.gsl_sf_gamma_inc_Q (a_b___0, -l_N * (log (a_x)))) + a_Y)
							else
								l_pos := -1 + 9 -- goto _L___2
							end
						else
							l_pos := -1 + 9 -- goto _L___2
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else: | _L___2:
						if not (a_b___0 > 1.e5) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if a_a___5 < (10).to_double then
							if a_x < a_b___0 / (a_a___5 + a_b___0) then
								l_N___0 := a_b___0 + (a_a___5 - 1.0) / 2.0
								Result := (a_A___0 * (gamma_inc_inst.gsl_sf_gamma_inc_P (a_a___5, -l_N___0 * (log1p (-a_x)))) + a_Y)
							else
								l_pos := -1 + 12 -- goto _L___0
							end
						else
							l_pos := -1 + 12 -- goto _L___0
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___0:
						l_ln_beta := (beta_inst.gsl_sf_lnbeta (a_a___5, a_b___0))
						l_tmp___4 := log (a_x)
						l_ln_pre := (-l_ln_beta + a_a___5 * l_tmp___4) + a_b___0 * (log1p (-a_x))
						l_prefactor := (exp (l_ln_pre))
						if a_x < (a_a___5 + 1.0) / ((a_a___5 + a_b___0) + 2.0) then
							l_epsabs := (fabs (a_Y / ((a_A___0 * l_prefactor) / a_a___5))) * 2.2204460492503131e-16
							l_cf := (beta_cont_frac___0 (a_a___5, a_b___0, a_x, l_epsabs))
							Result := (a_A___0 * ((l_prefactor * l_cf) / a_a___5) + a_Y)
						else
							l_epsabs___0 := (fabs ((a_A___0 + a_Y) / ((a_A___0 * l_prefactor) / a_b___0))) * 2.2204460492503131e-16
							l_cf___0 := (beta_cont_frac___0 (a_b___0, a_a___5, 1.0 - a_x, l_epsabs___0))
							l_term := (l_prefactor * l_cf___0) / a_b___0
							if a_A___0 = -a_Y then
								Result := (-a_A___0 * l_term)
							else
								Result := (a_A___0 * ((1).to_double - l_term) + a_Y)
							end
						end
				when 13 then -- if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	beta_cont_frac___1 (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_epsabs: REAL_64): REAL_64
		local
			l_max_iter: NATURAL_32
			l_cutoff: REAL_64
			l_iter_count: NATURAL_32
			l_cf: REAL_64
			l_num_term: REAL_64
			l_den_term: REAL_64
			l_k: INTEGER_32
			l_coeff: REAL_64
			l_delta_frac: REAL_64
			js: JUMP_STATE
		do
			l_max_iter := {NATURAL_32} 512
			l_cutoff := 2.0 * 2.2250738585072014e-308
			l_iter_count := {NATURAL_32} 0
			l_num_term := 1.0
			l_den_term := 1.0 - ((a_a___5 + a_b___0) * a_x) / (a_a___5 + 1.0)
			if (fabs (l_den_term)) < l_cutoff then
				l_den_term := (builtin_nanf (ce_string (""))).to_double
			end
			l_den_term := 1.0 / l_den_term
			l_cf := l_den_term
			from
			until
				not (not js.loop_left and then (l_iter_count < l_max_iter))
			loop
				js.reset
				l_k := (l_iter_count + {NATURAL_32} 1).to_integer_32
				l_coeff := ((l_k.to_double * (a_b___0 - l_k.to_double)) * a_x) / (((a_a___5 - 1.0) + (2 * l_k).to_double) * (a_a___5 + (2 * l_k).to_double))
				l_den_term := 1.0 + l_coeff * l_den_term
				l_num_term := 1.0 + l_coeff / l_num_term
				if (fabs (l_den_term)) < l_cutoff then
					l_den_term := (builtin_nanf (ce_string (""))).to_double
				end
				if (fabs (l_num_term)) < l_cutoff then
					l_num_term := (builtin_nanf (ce_string (""))).to_double
				end
				l_den_term := 1.0 / l_den_term
				l_delta_frac := l_den_term * l_num_term
				l_cf := l_cf * l_delta_frac
				l_coeff := ((-(a_a___5 + l_k.to_double) * ((a_a___5 + a_b___0) + l_k.to_double)) * a_x) / ((a_a___5 + (2 * l_k).to_double) * ((a_a___5 + (2 * l_k).to_double) + 1.0))
				l_den_term := 1.0 + l_coeff * l_den_term
				l_num_term := 1.0 + l_coeff / l_num_term
				if (fabs (l_den_term)) < l_cutoff then
					l_den_term := (builtin_nanf (ce_string (""))).to_double
				end
				if (fabs (l_num_term)) < l_cutoff then
					l_num_term := (builtin_nanf (ce_string (""))).to_double
				end
				l_den_term := 1.0 / l_den_term
				l_delta_frac := l_den_term * l_num_term
				l_cf := l_cf * l_delta_frac
				if (fabs (l_delta_frac - 1.0)) < 2.0 * 2.2204460492503131e-16 then
					js.break
				end
				if not js.loop_jumped then
					if l_cf * (fabs (l_delta_frac - 1.0)) < a_epsabs then
						js.break
					end
				end
				if not js.loop_jumped then
					l_iter_count := l_iter_count + 1
				end
			end
			js.reset
			if l_iter_count >= l_max_iter then
				Result := (builtin_nanf (ce_string (""))).to_double
				js.return
			end
			if not js.return_called then
				Result := l_cf
			end
		end

	beta_inc_AXPY___0 (a_A___0: REAL_64; a_Y: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64): REAL_64
		local
			l_N: REAL_64
			l_N___0: REAL_64
			l_ln_beta: REAL_64
			l_ln_pre: REAL_64
			l_tmp___4: REAL_64
			l_prefactor: REAL_64
			l_epsabs: REAL_64
			l_cf: REAL_64
			l_epsabs___0: REAL_64
			l_cf___0: REAL_64
			l_term: REAL_64
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_x /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						Result := (a_A___0 * (0).to_double + a_Y)
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if a_x /= 1.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						Result := (a_A___0 * (1).to_double + a_Y)
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if not (a_a___5 > 1.e5) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if a_b___0 < (10).to_double then
							if a_x > a_a___5 / (a_a___5 + a_b___0) then
								l_N := a_a___5 + (a_b___0 - 1.0) / 2.0
								Result := (a_A___0 * (gamma_inc_inst.gsl_sf_gamma_inc_Q (a_b___0, -l_N * (log (a_x)))) + a_Y)
							else
								l_pos := -1 + 9 -- goto _L___2
							end
						else
							l_pos := -1 + 9 -- goto _L___2
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else: | _L___2:
						if not (a_b___0 > 1.e5) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if a_a___5 < (10).to_double then
							if a_x < a_b___0 / (a_a___5 + a_b___0) then
								l_N___0 := a_b___0 + (a_a___5 - 1.0) / 2.0
								Result := (a_A___0 * (gamma_inc_inst.gsl_sf_gamma_inc_P (a_a___5, -l_N___0 * (log1p (-a_x)))) + a_Y)
							else
								l_pos := -1 + 12 -- goto _L___0
							end
						else
							l_pos := -1 + 12 -- goto _L___0
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___0:
						l_ln_beta := (beta_inst.gsl_sf_lnbeta (a_a___5, a_b___0))
						l_tmp___4 := log (a_x)
						l_ln_pre := (-l_ln_beta + a_a___5 * l_tmp___4) + a_b___0 * (log1p (-a_x))
						l_prefactor := (exp (l_ln_pre))
						if a_x < (a_a___5 + 1.0) / ((a_a___5 + a_b___0) + 2.0) then
							l_epsabs := (fabs (a_Y / ((a_A___0 * l_prefactor) / a_a___5))) * 2.2204460492503131e-16
							l_cf := (beta_cont_frac___1 (a_a___5, a_b___0, a_x, l_epsabs))
							Result := (a_A___0 * ((l_prefactor * l_cf) / a_a___5) + a_Y)
						else
							l_epsabs___0 := (fabs ((a_A___0 + a_Y) / ((a_A___0 * l_prefactor) / a_b___0))) * 2.2204460492503131e-16
							l_cf___0 := (beta_cont_frac___1 (a_b___0, a_a___5, 1.0 - a_x, l_epsabs___0))
							l_term := (l_prefactor * l_cf___0) / a_b___0
							if a_A___0 = -a_Y then
								Result := (-a_A___0 * l_term)
							else
								Result := (a_A___0 * ((1).to_double - l_term) + a_Y)
							end
						end
				when 13 then -- if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	beta_cont_frac___2 (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_epsabs: REAL_64): REAL_64
		local
			l_max_iter: NATURAL_32
			l_cutoff: REAL_64
			l_iter_count: NATURAL_32
			l_cf: REAL_64
			l_num_term: REAL_64
			l_den_term: REAL_64
			l_k: INTEGER_32
			l_coeff: REAL_64
			l_delta_frac: REAL_64
			js: JUMP_STATE
		do
			l_max_iter := {NATURAL_32} 512
			l_cutoff := 2.0 * 2.2250738585072014e-308
			l_iter_count := {NATURAL_32} 0
			l_num_term := 1.0
			l_den_term := 1.0 - ((a_a___5 + a_b___0) * a_x) / (a_a___5 + 1.0)
			if (fabs (l_den_term)) < l_cutoff then
				l_den_term := (builtin_nanf (ce_string (""))).to_double
			end
			l_den_term := 1.0 / l_den_term
			l_cf := l_den_term
			from
			until
				not (not js.loop_left and then (l_iter_count < l_max_iter))
			loop
				js.reset
				l_k := (l_iter_count + {NATURAL_32} 1).to_integer_32
				l_coeff := ((l_k.to_double * (a_b___0 - l_k.to_double)) * a_x) / (((a_a___5 - 1.0) + (2 * l_k).to_double) * (a_a___5 + (2 * l_k).to_double))
				l_den_term := 1.0 + l_coeff * l_den_term
				l_num_term := 1.0 + l_coeff / l_num_term
				if (fabs (l_den_term)) < l_cutoff then
					l_den_term := (builtin_nanf (ce_string (""))).to_double
				end
				if (fabs (l_num_term)) < l_cutoff then
					l_num_term := (builtin_nanf (ce_string (""))).to_double
				end
				l_den_term := 1.0 / l_den_term
				l_delta_frac := l_den_term * l_num_term
				l_cf := l_cf * l_delta_frac
				l_coeff := ((-(a_a___5 + l_k.to_double) * ((a_a___5 + a_b___0) + l_k.to_double)) * a_x) / ((a_a___5 + (2 * l_k).to_double) * ((a_a___5 + (2 * l_k).to_double) + 1.0))
				l_den_term := 1.0 + l_coeff * l_den_term
				l_num_term := 1.0 + l_coeff / l_num_term
				if (fabs (l_den_term)) < l_cutoff then
					l_den_term := (builtin_nanf (ce_string (""))).to_double
				end
				if (fabs (l_num_term)) < l_cutoff then
					l_num_term := (builtin_nanf (ce_string (""))).to_double
				end
				l_den_term := 1.0 / l_den_term
				l_delta_frac := l_den_term * l_num_term
				l_cf := l_cf * l_delta_frac
				if (fabs (l_delta_frac - 1.0)) < 2.0 * 2.2204460492503131e-16 then
					js.break
				end
				if not js.loop_jumped then
					if l_cf * (fabs (l_delta_frac - 1.0)) < a_epsabs then
						js.break
					end
				end
				if not js.loop_jumped then
					l_iter_count := l_iter_count + 1
				end
			end
			js.reset
			if l_iter_count >= l_max_iter then
				Result := (builtin_nanf (ce_string (""))).to_double
				js.return
			end
			if not js.return_called then
				Result := l_cf
			end
		end

	beta_inc_AXPY___1 (a_A___0: REAL_64; a_Y: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64): REAL_64
		local
			l_N: REAL_64
			l_N___0: REAL_64
			l_ln_beta: REAL_64
			l_ln_pre: REAL_64
			l_tmp___4: REAL_64
			l_prefactor: REAL_64
			l_epsabs: REAL_64
			l_cf: REAL_64
			l_epsabs___0: REAL_64
			l_cf___0: REAL_64
			l_term: REAL_64
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_x /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						Result := (a_A___0 * (0).to_double + a_Y)
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if a_x /= 1.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						Result := (a_A___0 * (1).to_double + a_Y)
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if not (a_a___5 > 1.e5) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if a_b___0 < (10).to_double then
							if a_x > a_a___5 / (a_a___5 + a_b___0) then
								l_N := a_a___5 + (a_b___0 - 1.0) / 2.0
								Result := (a_A___0 * (gamma_inc_inst.gsl_sf_gamma_inc_Q (a_b___0, -l_N * (log (a_x)))) + a_Y)
							else
								l_pos := -1 + 9 -- goto _L___2
							end
						else
							l_pos := -1 + 9 -- goto _L___2
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else: | _L___2:
						if not (a_b___0 > 1.e5) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if a_a___5 < (10).to_double then
							if a_x < a_b___0 / (a_a___5 + a_b___0) then
								l_N___0 := a_b___0 + (a_a___5 - 1.0) / 2.0
								Result := (a_A___0 * (gamma_inc_inst.gsl_sf_gamma_inc_P (a_a___5, -l_N___0 * (log1p (-a_x)))) + a_Y)
							else
								l_pos := -1 + 12 -- goto _L___0
							end
						else
							l_pos := -1 + 12 -- goto _L___0
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___0:
						l_ln_beta := (beta_inst.gsl_sf_lnbeta (a_a___5, a_b___0))
						l_tmp___4 := log (a_x)
						l_ln_pre := (-l_ln_beta + a_a___5 * l_tmp___4) + a_b___0 * (log1p (-a_x))
						l_prefactor := (exp (l_ln_pre))
						if a_x < (a_a___5 + 1.0) / ((a_a___5 + a_b___0) + 2.0) then
							l_epsabs := (fabs (a_Y / ((a_A___0 * l_prefactor) / a_a___5))) * 2.2204460492503131e-16
							l_cf := (beta_cont_frac___2 (a_a___5, a_b___0, a_x, l_epsabs))
							Result := (a_A___0 * ((l_prefactor * l_cf) / a_a___5) + a_Y)
						else
							l_epsabs___0 := (fabs ((a_A___0 + a_Y) / ((a_A___0 * l_prefactor) / a_b___0))) * 2.2204460492503131e-16
							l_cf___0 := (beta_cont_frac___2 (a_b___0, a_a___5, 1.0 - a_x, l_epsabs___0))
							l_term := (l_prefactor * l_cf___0) / a_b___0
							if a_A___0 = -a_Y then
								Result := (-a_A___0 * l_term)
							else
								Result := (a_A___0 * ((1).to_double - l_term) + a_Y)
							end
						end
				when 13 then -- if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
