class
	P_BIDIAG

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_linalg_bidiag_decomp (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_tau_U: CE_POINTER [PD_GSL_VECTOR]; a_tau_V: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_c___1: PD_GSL_VECTOR_VIEW
			l_v: PD_GSL_VECTOR_VIEW
			l_tau_i: REAL_64
			l_m___4: PD_GSL_MATRIX_VIEW
			l_r___3: PD_GSL_VECTOR_VIEW
			l_v___0: PD_GSL_VECTOR_VIEW
			l_tau_i___0: REAL_64
			l_m___5: PD_GSL_MATRIX_VIEW
			js: JUMP_STATE
		do
			create l_c___1.make
			create l_v.make
			create l_m___4.make
			create l_r___3.make
			create l_v___0.make
			create l_m___5.make

			if a_A___0.item.size1 < a_A___0.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("bidiagonal decomposition requires M>=N"), ce_string ("bidiag.c"), 79, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_tau_U.item.size /= a_A___0.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("size of tau_U must be N"), ce_string ("bidiag.c"), 83, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_tau_V.item.size + {NATURAL_32} 1 /= a_A___0.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("size of tau_V must be (N - 1)"), ce_string ("bidiag.c"), 87, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_M := a_A___0.item.size1
				l_N := a_A___0.item.size2
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					l_c___1.ce_gets ((rowcol_source_inst.gsl_matrix_column (a_A___0, l_i)))
					l_v.ce_gets ((subvector_source_inst.gsl_vector_subvector (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___1.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_i, l_M - l_i)))
					l_tau_i := (householder_inst.gsl_linalg_householder_transform (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)))
					if l_i + {NATURAL_32} 1 < l_N then
						l_m___4.ce_gets ((submatrix_source_inst.gsl_matrix_submatrix (a_A___0, l_i, l_i + {NATURAL_32} 1, l_M - l_i, l_N - (l_i + {NATURAL_32} 1))))
						householder_inst.gsl_linalg_householder_hm (l_tau_i, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
					end
					gsl_gsl_vector_double_inst.gsl_vector_set (a_tau_U, l_i, l_tau_i)
					if l_i + {NATURAL_32} 1 < l_N then
						l_r___3.ce_gets ((rowcol_source_inst.gsl_matrix_row (a_A___0, l_i)))
						l_v___0.ce_gets ((subvector_source_inst.gsl_vector_subvector (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_r___3.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_i + {NATURAL_32} 1, l_N - (l_i + {NATURAL_32} 1))))
						l_tau_i___0 := (householder_inst.gsl_linalg_householder_transform (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v___0.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)))
						if l_i + {NATURAL_32} 1 < l_M then
							l_m___5.ce_gets ((submatrix_source_inst.gsl_matrix_submatrix (a_A___0, l_i + {NATURAL_32} 1, l_i + {NATURAL_32} 1, l_M - (l_i + {NATURAL_32} 1), l_N - (l_i + {NATURAL_32} 1))))
							householder_inst.gsl_linalg_householder_mh (l_tau_i___0, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v___0.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___5.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
						end
						gsl_gsl_vector_double_inst.gsl_vector_set (a_tau_V, l_i, l_tau_i___0)
					end
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_bidiag_unpack (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_tau_U: CE_POINTER [PD_GSL_VECTOR]; a_U: CE_POINTER [PD_GSL_MATRIX]; a_tau_V: CE_POINTER [PD_GSL_VECTOR]; a_V: CE_POINTER [PD_GSL_MATRIX]; a_diag: CE_POINTER [PD_GSL_VECTOR]; a_superdiag: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_K: NATURAL_32
			l_tmp: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_Aii: REAL_64
			l_Aij: REAL_64
			l_r___3: PD_GSL_VECTOR_CONST_VIEW
			l_h: PD_GSL_VECTOR_CONST_VIEW
			l_ti: REAL_64
			l_m___4: PD_GSL_MATRIX_VIEW
			l_tmp___6: NATURAL_32
			l_c___1: PD_GSL_VECTOR_CONST_VIEW
			l_h___0: PD_GSL_VECTOR_CONST_VIEW
			l_tj: REAL_64
			l_m___5: PD_GSL_MATRIX_VIEW
			l_tmp___11: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_r___3.make
			create l_h.make
			create l_m___4.make
			create l_c___1.make
			create l_h___0.make
			create l_m___5.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if l_M < l_N then
						l_tmp := l_M
					else
						l_tmp := l_N
					end
					l_K := l_tmp
					if not (l_M < l_N) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix A must have M >= N"), ce_string ("bidiag.c"), 161, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 3 then -- else:
						if a_tau_U.item.size = l_K then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("size of tau must be MIN(M,N)"), ce_string ("bidiag.c"), 165, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 6 then -- else:
						if a_tau_V.item.size + {NATURAL_32} 1 = l_K then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("size of tau must be MIN(M,N) - 1"), ce_string ("bidiag.c"), 169, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 9 then -- else:
						if a_U.item.size1 = l_M then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L___0
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 12 then -- else:
						if a_U.item.size2 = l_N then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("size of U must be M x N"), ce_string ("bidiag.c"), 173, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 15 then -- else:
						if a_V.item.size1 = l_N then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 19 -- goto _L
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 18 then -- else:
						if a_V.item.size2 = l_N then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("size of V must be N x N"), ce_string ("bidiag.c"), 177, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						if a_diag.item.size /= l_K then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("size of diagonal must match size of A"), ce_string ("bidiag.c"), 181, 19)
								Result := 19
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						elseif a_superdiag.item.size + {NATURAL_32} 1 /= l_K then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("size of subdiagonal must be (diagonal size - 1)"), ce_string ("bidiag.c"), 185, 19)
								Result := 19
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						else
							l_i := (0).to_natural_32
							from
							until
								not (l_i < l_N)
							loop
								l_Aii := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_i))
								gsl_gsl_vector_double_inst.gsl_vector_set (a_diag, l_i, l_Aii)
								l_i := l_i + 1
							end
							l_i := (0).to_natural_32
							from
							until
								not (l_i < l_N - {NATURAL_32} 1)
							loop
								l_Aij := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_i + {NATURAL_32} 1))
								gsl_gsl_vector_double_inst.gsl_vector_set (a_superdiag, l_i, l_Aij)
								l_i := l_i + 1
							end
							init_source_inst.gsl_matrix_set_identity (a_V)
							l_i := l_N - {NATURAL_32} 1
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___6 := l_i
								l_i := l_i - 1
								if not (l_tmp___6 > {NATURAL_32} 0) then
									js.break
								end
								if not js.loop_jumped then
									l_r___3.ce_gets ((rowcol_source_inst.gsl_matrix_const_row (a_A___0, l_i)))
									l_h.ce_gets ((subvector_source_inst.gsl_vector_const_subvector ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_r___3.c_pointer + {PD_GSL_VECTOR_CONST_VIEW}.vector_offset)), l_i + {NATURAL_32} 1, l_N - (l_i + {NATURAL_32} 1))))
									l_ti := (gsl_gsl_vector_double_inst.gsl_vector_get (a_tau_V, l_i))
									l_m___4.ce_gets ((submatrix_source_inst.gsl_matrix_submatrix (a_V, l_i + {NATURAL_32} 1, l_i + {NATURAL_32} 1, l_N - (l_i + {NATURAL_32} 1), l_N - (l_i + {NATURAL_32} 1))))
									householder_inst.gsl_linalg_householder_hm (l_ti, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_h.c_pointer + {PD_GSL_VECTOR_CONST_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
								end
							end
							js.reset
							init_source_inst.gsl_matrix_set_identity (a_U)
							l_j := l_N
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___11 := l_j
								l_j := l_j - 1
								if not (l_tmp___11 > {NATURAL_32} 0) then
									js.break
								end
								if not js.loop_jumped then
									l_c___1.ce_gets ((rowcol_source_inst.gsl_matrix_const_column (a_A___0, l_j)))
									l_h___0.ce_gets ((subvector_source_inst.gsl_vector_const_subvector ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___1.c_pointer + {PD_GSL_VECTOR_CONST_VIEW}.vector_offset)), l_j, l_M - l_j)))
									l_tj := (gsl_gsl_vector_double_inst.gsl_vector_get (a_tau_U, l_j))
									l_m___5.ce_gets ((submatrix_source_inst.gsl_matrix_submatrix (a_U, l_j, l_j, l_M - l_j, l_N - l_j)))
									householder_inst.gsl_linalg_householder_hm (l_tj, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_h___0.c_pointer + {PD_GSL_VECTOR_CONST_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___5.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
								end
							end
							js.reset
							Result := 0
							js.return
						end
				when 22 then -- if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 23 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_linalg_bidiag_unpack2 (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_tau_U: CE_POINTER [PD_GSL_VECTOR]; a_tau_V: CE_POINTER [PD_GSL_VECTOR]; a_V: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_K: NATURAL_32
			l_tmp: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_r___3: PD_GSL_VECTOR_CONST_VIEW
			l_h: PD_GSL_VECTOR_CONST_VIEW
			l_ti: REAL_64
			l_m___4: PD_GSL_MATRIX_VIEW
			l_tmp___4: NATURAL_32
			l_Aij: REAL_64
			l_tj: REAL_64
			l_Ajj: REAL_64
			l_m___5: PD_GSL_MATRIX_VIEW
			l_tmp___9: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_r___3.make
			create l_h.make
			create l_m___4.make
			create l_m___5.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if l_M < l_N then
						l_tmp := l_M
					else
						l_tmp := l_N
					end
					l_K := l_tmp
					if not (l_M < l_N) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix A must have M >= N"), ce_string ("bidiag.c"), 260, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 3 then -- else:
						if a_tau_U.item.size = l_K then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("size of tau must be MIN(M,N)"), ce_string ("bidiag.c"), 264, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 6 then -- else:
						if a_tau_V.item.size + {NATURAL_32} 1 = l_K then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("size of tau must be MIN(M,N) - 1"), ce_string ("bidiag.c"), 268, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 9 then -- else:
						if a_V.item.size1 = l_N then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 12 then -- else:
						if a_V.item.size2 = l_N then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("size of V must be N x N"), ce_string ("bidiag.c"), 272, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						init_source_inst.gsl_matrix_set_identity (a_V)
						l_i := l_N - {NATURAL_32} 1
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp___4 := l_i
							l_i := l_i - 1
							if not (l_tmp___4 > {NATURAL_32} 0) then
								js.break
							end
							if not js.loop_jumped then
								l_r___3.ce_gets ((rowcol_source_inst.gsl_matrix_const_row (a_A___0, l_i)))
								l_h.ce_gets ((subvector_source_inst.gsl_vector_const_subvector ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_r___3.c_pointer + {PD_GSL_VECTOR_CONST_VIEW}.vector_offset)), l_i + {NATURAL_32} 1, l_N - (l_i + {NATURAL_32} 1))))
								l_ti := (gsl_gsl_vector_double_inst.gsl_vector_get (a_tau_V, l_i))
								l_m___4.ce_gets ((submatrix_source_inst.gsl_matrix_submatrix (a_V, l_i + {NATURAL_32} 1, l_i + {NATURAL_32} 1, l_N - (l_i + {NATURAL_32} 1), l_N - (l_i + {NATURAL_32} 1))))
								householder_inst.gsl_linalg_householder_hm (l_ti, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_h.c_pointer + {PD_GSL_VECTOR_CONST_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
							end
						end
						js.reset
						l_i := (0).to_natural_32
						from
						until
							not (l_i < l_N - {NATURAL_32} 1)
						loop
							l_Aij := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_i + {NATURAL_32} 1))
							gsl_gsl_vector_double_inst.gsl_vector_set (a_tau_V, l_i, l_Aij)
							l_i := l_i + 1
						end
						l_j := l_N
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp___9 := l_j
							l_j := l_j - 1
							if not (l_tmp___9 > {NATURAL_32} 0) then
								js.break
							end
							if not js.loop_jumped then
								l_tj := (gsl_gsl_vector_double_inst.gsl_vector_get (a_tau_U, l_j))
								l_Ajj := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_j, l_j))
								l_m___5.ce_gets ((submatrix_source_inst.gsl_matrix_submatrix (a_A___0, l_j, l_j, l_M - l_j, l_N - l_j)))
								gsl_gsl_vector_double_inst.gsl_vector_set (a_tau_U, l_j, l_Ajj)
								householder_inst.gsl_linalg_householder_hm1 (l_tj, create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___5.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
							end
						end
						js.reset
						Result := 0
						js.return
				when 16 then -- if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 17 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_linalg_bidiag_unpack_B (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_diag: CE_POINTER [PD_GSL_VECTOR]; a_superdiag: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_K: NATURAL_32
			l_tmp: NATURAL_32
			l_i: NATURAL_32
			l_Aii: REAL_64
			l_Aij: REAL_64
			js: JUMP_STATE
		do
			l_M := a_A___0.item.size1
			l_N := a_A___0.item.size2
			if l_M < l_N then
				l_tmp := l_M
			else
				l_tmp := l_N
			end
			l_K := l_tmp
			if a_diag.item.size /= l_K then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("size of diagonal must match size of A"), ce_string ("bidiag.c"), 336, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_superdiag.item.size + {NATURAL_32} 1 /= l_K then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("size of subdiagonal must be (matrix size - 1)"), ce_string ("bidiag.c"), 340, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_K)
				loop
					l_Aii := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_i))
					gsl_gsl_vector_double_inst.gsl_vector_set (a_diag, l_i, l_Aii)
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_K - {NATURAL_32} 1)
				loop
					l_Aij := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_i + {NATURAL_32} 1))
					gsl_gsl_vector_double_inst.gsl_vector_set (a_superdiag, l_i, l_Aij)
					l_i := l_i + 1
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

end
