class
	P_BISECTION

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create bisection_type.make
			create gsl_root_fsolver_bisection.make
		end

feature {ANY} -- attributes

	bisection_type: PD_GSL_ROOT_FSOLVER_TYPE

	gsl_root_fsolver_bisection: CE_POINTER [PD_GSL_ROOT_FSOLVER_TYPE]

feature {ANY} -- routines

	bisection_init (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_root: CE_POINTER [REAL_64]; a_x_lower: REAL_64; a_x_upper: REAL_64): INTEGER_32
		local
			l_state: CE_POINTER [PD_BISECTION_STATE_T]
			l_f_lower: REAL_64
			l_f_upper: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_state.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state.ce_gets (create {CE_POINTER [PD_BISECTION_STATE_T]}.make_cast (a_vstate))
					a_root.item := 0.5 * (a_x_lower + a_x_upper)
					from
					until
						js.loop_left
					loop
						js.reset
						l_f_lower := (a_f.item.function).real_64_item ([a_x_lower, a_f.item.params])
						if not (infnan_inst.gsl_finite (l_f_lower)).to_boolean then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("function value is not finite"), ce_string ("bisection.c"), 55, 9)
								Result := 9
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						from
						until
							js.loop_left
						loop
							js.reset
							l_f_upper := (a_f.item.function).real_64_item ([a_x_upper, a_f.item.params])
							if not (infnan_inst.gsl_finite (l_f_upper)).to_boolean then
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("function value is not finite"), ce_string ("bisection.c"), 56, 9)
									Result := 9
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
							end
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						l_state.item.f_lower := l_f_lower
						l_state.item.f_upper := l_f_upper
						if not (l_f_lower < 0.0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_f_upper < 0.0 then
							l_pos := -1 + 6 -- goto _L
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 4 then -- else: | _L___0:
						if not (l_f_lower > 0.0) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if not (l_f_upper > 0.0) then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("endpoints do not straddle y=0"), ce_string ("bisection.c"), 63, 4)
							Result := 4
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 7 then -- if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	bisection_init_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent bisection_init)
		end

	bisection_iterate (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_root: CE_POINTER [REAL_64]; a_x_lower: CE_POINTER [REAL_64]; a_x_upper: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_state: CE_POINTER [PD_BISECTION_STATE_T]
			l_x_bisect: REAL_64
			l_f_bisect: REAL_64
			l_x_left: REAL_64
			l_x_right: REAL_64
			l_f_lower: REAL_64
			l_f_upper: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_state.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state.ce_gets (create {CE_POINTER [PD_BISECTION_STATE_T]}.make_cast (a_vstate))
					l_x_left := a_x_lower.item
					l_x_right := a_x_upper.item
					l_f_lower := l_state.item.f_lower
					l_f_upper := l_state.item.f_upper
					if l_f_lower = 0.0 then
						a_root.item := l_x_left
						a_x_upper.item := l_x_left
						Result := 0
						js.return
					end
					if not js.return_called and then (l_f_upper = 0.0) then
						a_root.item := l_x_right
						a_x_lower.item := l_x_right
						Result := 0
						js.return
					end
					if not js.return_called then
						l_x_bisect := (l_x_left + l_x_right) / 2.0
						from
						until
							js.loop_left
						loop
							js.reset
							l_f_bisect := (a_f.item.function).real_64_item ([l_x_bisect, a_f.item.params])
							if not (infnan_inst.gsl_finite (l_f_bisect)).to_boolean then
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("function value is not finite"), ce_string ("bisection.c"), 99, 9)
									Result := 9
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
							end
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called and then (l_f_bisect = 0.0) then
						a_root.item := l_x_bisect
						a_x_lower.item := l_x_bisect
						a_x_upper.item := l_x_bisect
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (l_f_lower > 0.0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_f_bisect < 0.0 then
							a_root.item := 0.5 * (l_x_left + l_x_bisect)
							a_x_upper.item := l_x_bisect
							l_state.item.f_upper := l_f_bisect
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_f_lower < 0.0 then
							if l_f_bisect > 0.0 then
								a_root.item := 0.5 * (l_x_left + l_x_bisect)
								a_x_upper.item := l_x_bisect
								l_state.item.f_upper := l_f_bisect
							else
								a_root.item := 0.5 * (l_x_bisect + l_x_right)
								a_x_lower.item := l_x_bisect
								l_state.item.f_lower := l_f_bisect
							end
						else
							a_root.item := 0.5 * (l_x_bisect + l_x_right)
							a_x_lower.item := l_x_bisect
							l_state.item.f_lower := l_f_bisect
						end
				when 5 then
						Result := 0
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	bisection_iterate_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent bisection_iterate)
		end

end
