class
	P_BROYDEN

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create broyden_type.make
			create gsl_multiroot_fsolver_broyden.make
		end

feature {ANY} -- attributes

	broyden_type: PD_GSL_MULTIROOT_FSOLVER_TYPE

	gsl_multiroot_fsolver_broyden: CE_POINTER [PD_GSL_MULTIROOT_FSOLVER_TYPE]

feature {ANY} -- routines

	broyden_alloc (a_vstate: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_BROYDEN_STATE_T]
			l_v: CE_POINTER [PD_GSL_VECTOR]
			l_w: CE_POINTER [PD_GSL_VECTOR]
			l_y: CE_POINTER [PD_GSL_VECTOR]
			l_fnew: CE_POINTER [PD_GSL_VECTOR]
			l_x_trial: CE_POINTER [PD_GSL_VECTOR]
			l_p: CE_POINTER [PD_GSL_VECTOR]
			l_perm: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
			l_m___4: CE_POINTER [PD_GSL_MATRIX]
			l_H: CE_POINTER [PD_GSL_MATRIX]
			js: JUMP_STATE
		do
			create l_state.make
			create l_v.make
			create l_w.make
			create l_y.make
			create l_fnew.make
			create l_x_trial.make
			create l_p.make
			create l_perm.make
			create l_m___4.make
			create l_H.make

			l_state.ce_gets (create {CE_POINTER [PD_BROYDEN_STATE_T]}.make_cast (a_vstate))
			l_m___4.ce_gets (init_source_inst.gsl_matrix_calloc (a_n, a_n))
			if (l_m___4.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("failed to allocate space for lu"), ce_string ("broyden.c"), 77, 8)
					Result := 8
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_state.item.lu := l_m___4
				l_perm.ce_gets (init_inst.gsl_permutation_calloc (a_n))
				if (l_perm.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_m___4)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for permutation"), ce_string ("broyden.c"), 88, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.permutation := l_perm
				l_H.ce_gets (init_source_inst.gsl_matrix_calloc (a_n, a_n))
				if (l_H.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_inst.gsl_permutation_free (l_perm)
					init_source_inst.gsl_matrix_free (l_m___4)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for d"), ce_string ("broyden.c"), 100, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.H := l_H
				l_v.ce_gets (init_source_inst.gsl_vector_calloc (a_n))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_H)
					init_inst.gsl_permutation_free (l_perm)
					init_source_inst.gsl_matrix_free (l_m___4)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for v"), ce_string ("broyden.c"), 113, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.v := l_v
				l_w.ce_gets (init_source_inst.gsl_vector_calloc (a_n))
				if (l_w.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_v)
					init_source_inst.gsl_matrix_free (l_H)
					init_inst.gsl_permutation_free (l_perm)
					init_source_inst.gsl_matrix_free (l_m___4)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for w"), ce_string ("broyden.c"), 127, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.w := l_w
				l_y.ce_gets (init_source_inst.gsl_vector_calloc (a_n))
				if (l_y.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_w)
					init_source_inst.gsl_vector_free (l_v)
					init_source_inst.gsl_matrix_free (l_H)
					init_inst.gsl_permutation_free (l_perm)
					init_source_inst.gsl_matrix_free (l_m___4)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for y"), ce_string ("broyden.c"), 142, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.y := l_y
				l_fnew.ce_gets (init_source_inst.gsl_vector_calloc (a_n))
				if (l_fnew.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_y)
					init_source_inst.gsl_vector_free (l_w)
					init_source_inst.gsl_vector_free (l_v)
					init_source_inst.gsl_matrix_free (l_H)
					init_inst.gsl_permutation_free (l_perm)
					init_source_inst.gsl_matrix_free (l_m___4)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for fnew"), ce_string ("broyden.c"), 158, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.fnew := l_fnew
				l_x_trial.ce_gets (init_source_inst.gsl_vector_calloc (a_n))
				if (l_x_trial.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_fnew)
					init_source_inst.gsl_vector_free (l_y)
					init_source_inst.gsl_vector_free (l_w)
					init_source_inst.gsl_vector_free (l_v)
					init_source_inst.gsl_matrix_free (l_H)
					init_inst.gsl_permutation_free (l_perm)
					init_source_inst.gsl_matrix_free (l_m___4)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for x_trial"), ce_string ("broyden.c"), 175, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.x_trial := l_x_trial
				l_p.ce_gets (init_source_inst.gsl_vector_calloc (a_n))
				if (l_p.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_x_trial)
					init_source_inst.gsl_vector_free (l_fnew)
					init_source_inst.gsl_vector_free (l_y)
					init_source_inst.gsl_vector_free (l_w)
					init_source_inst.gsl_vector_free (l_v)
					init_source_inst.gsl_matrix_free (l_H)
					init_inst.gsl_permutation_free (l_perm)
					init_source_inst.gsl_matrix_free (l_m___4)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for p"), ce_string ("broyden.c"), 193, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.p := l_p
				Result := 0
			end
		end

	broyden_alloc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent broyden_alloc)
		end

	broyden_set (a_vstate: CE_POINTER [ANY]; a_function: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_state: CE_POINTER [PD_BROYDEN_STATE_T]
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_n: NATURAL_32
			l_signum: INTEGER_32
			js: JUMP_STATE
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_BROYDEN_STATE_T]}.make_cast (a_vstate))
			l_n := a_function.item.n
			l_signum := 0;
			(a_function.item.f).call ([a_x, a_function.item.params, a_f])
			fdjac_inst.gsl_multiroot_fdjacobian (a_function, a_x, a_f, 1.4901161193847656e-08, l_state.item.lu).do_nothing
			lu_inst.gsl_linalg_LU_decomp (l_state.item.lu, l_state.item.permutation, create {CE_POINTER [INTEGER_32]}.make_shared ($l_signum)).do_nothing
			lu_inst.gsl_linalg_LU_invert (l_state.item.lu, l_state.item.permutation, l_state.item.H).do_nothing
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_left and then (l_i < l_n))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_n)
				loop
					gsl_gsl_matrix_double_inst.gsl_matrix_set (l_state.item.H, l_i, l_j, -(gsl_gsl_matrix_double_inst.gsl_matrix_get (l_state.item.H, l_i, l_j)))
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				gsl_gsl_vector_double_inst.gsl_vector_set (a_dx, l_i, 0.0)
				l_i := l_i + 1
			end
			l_state.item.phi := enorm_inst.enorm___3 (a_f)
			Result := 0
		end

	broyden_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent broyden_set)
		end

	broyden_iterate (a_vstate: CE_POINTER [ANY]; a_function: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_state: CE_POINTER [PD_BROYDEN_STATE_T]
			l_phi0: REAL_64
			l_phi1: REAL_64
			l_t: REAL_64
			l_lambda: REAL_64
			l_H: CE_POINTER [PD_GSL_MATRIX]
			l_p: CE_POINTER [PD_GSL_VECTOR]
			l_y: CE_POINTER [PD_GSL_VECTOR]
			l_v: CE_POINTER [PD_GSL_VECTOR]
			l_w: CE_POINTER [PD_GSL_VECTOR]
			l_fnew: CE_POINTER [PD_GSL_VECTOR]
			l_x_trial: CE_POINTER [PD_GSL_VECTOR]
			l_lu: CE_POINTER [PD_GSL_MATRIX]
			l_perm: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_iter: NATURAL_32
			l_n: NATURAL_32
			l_sum: REAL_64
			l_tmp: REAL_64
			l_pi: REAL_64
			l_xi: REAL_64
			l_status: INTEGER_32
			l_theta: REAL_64
			l_signum: INTEGER_32
			l_pi___0: REAL_64
			l_xi___0: REAL_64
			l_status___0: INTEGER_32
			l_yi: REAL_64
			l_tmp___9: REAL_64
			l_sum___0: REAL_64
			l_tmp___11: REAL_64
			l_tmp___13: REAL_64
			l_vi: REAL_64
			l_tmp___15: REAL_64
			l_sum___1: REAL_64
			l_tmp___17: REAL_64
			l_vi___0: REAL_64
			l_wj: REAL_64
			l_Hij: REAL_64
			l_pi___1: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_state.make
			create l_H.make
			create l_p.make
			create l_y.make
			create l_v.make
			create l_w.make
			create l_fnew.make
			create l_x_trial.make
			create l_lu.make
			create l_perm.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state.ce_gets (create {CE_POINTER [PD_BROYDEN_STATE_T]}.make_cast (a_vstate))
					l_H.ce_gets (l_state.item.H)
					l_p.ce_gets (l_state.item.p)
					l_y.ce_gets (l_state.item.y)
					l_v.ce_gets (l_state.item.v)
					l_w.ce_gets (l_state.item.w)
					l_fnew.ce_gets (l_state.item.fnew)
					l_x_trial.ce_gets (l_state.item.x_trial)
					l_lu.ce_gets (l_state.item.lu)
					l_perm.ce_gets (l_state.item.permutation)
					l_n := a_function.item.n
					l_i := (0).to_natural_32
					from
					until
						not (not js.loop_left and then (l_i < l_n))
					loop
						l_sum := (0).to_double
						l_j := (0).to_natural_32
						from
						until
							not (l_j < l_n)
						loop
							l_tmp := gsl_gsl_matrix_double_inst.gsl_matrix_get (l_H, l_i, l_j)
							l_sum := l_sum + (l_tmp * (gsl_gsl_vector_double_inst.gsl_vector_get (a_f, l_j)))
							l_j := l_j + 1
						end
						gsl_gsl_vector_double_inst.gsl_vector_set (l_p, l_i, l_sum)
						l_i := l_i + 1
					end
					l_t := (1).to_double
					l_iter := (0).to_natural_32
					l_phi0 := l_state.item.phi
				when 1 then -- new_step:
					l_i := (0).to_natural_32
					from
					until
						not (l_i < l_n)
					loop
						l_pi := (gsl_gsl_vector_double_inst.gsl_vector_get (l_p, l_i))
						l_xi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_x, l_i))
						gsl_gsl_vector_double_inst.gsl_vector_set (l_x_trial, l_i, l_xi + l_t * l_pi)
						l_i := l_i + 1
					end
					l_status := ((a_function.item.f).integer_32_item ([l_x_trial, a_function.item.params, l_fnew]))
					if l_status /= 0 then
						Result := 9
						js.return
					end
					if js.return_called then
						l_pos := -1 + 4 -- skip if block
					end
				when 2 then -- if:
						l_phi1 := enorm_inst.enorm___3 (l_fnew)
						l_iter := l_iter + 1
						if l_phi1 > l_phi0 then
							if l_iter < {NATURAL_32} 10 then
								if l_t > 0.1 then
									l_theta := l_phi1 / l_phi0
									l_t := l_t * (((sqrt (1.0 + 6.0 * l_theta)) - 1.0) / (3.0 * l_theta))
									l_pos := -1 + 1 -- goto new_step
								end
							end
						end
				when 3 then
						if l_phi1 > l_phi0 then
							l_signum := 0
							fdjac_inst.gsl_multiroot_fdjacobian (a_function, a_x, a_f, 1.4901161193847656e-08, l_lu).do_nothing
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_n))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_n)
								loop
									gsl_gsl_matrix_double_inst.gsl_matrix_set (l_lu, l_i, l_j, -(gsl_gsl_matrix_double_inst.gsl_matrix_get (l_lu, l_i, l_j)))
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							lu_inst.gsl_linalg_LU_decomp (l_lu, l_perm, create {CE_POINTER [INTEGER_32]}.make_shared ($l_signum)).do_nothing
							lu_inst.gsl_linalg_LU_invert (l_lu, l_perm, l_H).do_nothing
							lu_inst.gsl_linalg_LU_solve (l_lu, l_perm, a_f, l_p).do_nothing
							l_t := (1).to_double
							l_i := (0).to_natural_32
							from
							until
								not (l_i < l_n)
							loop
								l_pi___0 := (gsl_gsl_vector_double_inst.gsl_vector_get (l_p, l_i))
								l_xi___0 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_x, l_i))
								gsl_gsl_vector_double_inst.gsl_vector_set (l_x_trial, l_i, l_xi___0 + l_t * l_pi___0)
								l_i := l_i + 1
							end
							l_status___0 := ((a_function.item.f).integer_32_item ([l_x_trial, a_function.item.params, l_fnew]))
							if l_status___0 /= 0 then
								Result := 9
								js.return
							end
							if not js.return_called then
								l_phi1 := enorm_inst.enorm___3 (l_fnew)
							end
						end
				when 4 then -- if done
					if not js.return_called then
						l_i := (0).to_natural_32
						from
						until
							not (l_i < l_n)
						loop
							l_tmp___9 := gsl_gsl_vector_double_inst.gsl_vector_get (l_fnew, l_i)
							l_yi := l_tmp___9 - (gsl_gsl_vector_double_inst.gsl_vector_get (a_f, l_i))
							gsl_gsl_vector_double_inst.gsl_vector_set (l_y, l_i, l_yi)
							l_i := l_i + 1
						end
						l_i := (0).to_natural_32
						from
						until
							not (not js.loop_left and then (l_i < l_n))
						loop
							l_sum___0 := (0).to_double
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_n)
							loop
								l_tmp___11 := gsl_gsl_matrix_double_inst.gsl_matrix_get (l_H, l_i, l_j)
								l_sum___0 := l_sum___0 + (l_tmp___11 * (gsl_gsl_vector_double_inst.gsl_vector_get (l_y, l_j)))
								l_j := l_j + 1
							end
							gsl_gsl_vector_double_inst.gsl_vector_set (l_v, l_i, l_sum___0)
							l_i := l_i + 1
						end
						l_lambda := (0).to_double
						l_i := (0).to_natural_32
						from
						until
							not (l_i < l_n)
						loop
							l_tmp___13 := gsl_gsl_vector_double_inst.gsl_vector_get (l_p, l_i)
							l_lambda := l_lambda + (l_tmp___13 * (gsl_gsl_vector_double_inst.gsl_vector_get (l_v, l_i)))
							l_i := l_i + 1
						end
						if l_lambda = (0).to_double then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("approximation to Jacobian has collapsed"), ce_string ("broyden.c"), 368, 12)
								Result := 12
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
					end
					if not js.return_called then
						l_i := (0).to_natural_32
						from
						until
							not (l_i < l_n)
						loop
							l_tmp___15 := gsl_gsl_vector_double_inst.gsl_vector_get (l_v, l_i)
							l_vi := l_tmp___15 + l_t * (gsl_gsl_vector_double_inst.gsl_vector_get (l_p, l_i))
							gsl_gsl_vector_double_inst.gsl_vector_set (l_v, l_i, l_vi)
							l_i := l_i + 1
						end
						l_i := (0).to_natural_32
						from
						until
							not (not js.loop_left and then (l_i < l_n))
						loop
							l_sum___1 := (0).to_double
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_n)
							loop
								l_tmp___17 := gsl_gsl_matrix_double_inst.gsl_matrix_get (l_H, l_j, l_i)
								l_sum___1 := l_sum___1 + (l_tmp___17 * (gsl_gsl_vector_double_inst.gsl_vector_get (l_p, l_j)))
								l_j := l_j + 1
							end
							gsl_gsl_vector_double_inst.gsl_vector_set (l_w, l_i, l_sum___1)
							l_i := l_i + 1
						end
						l_i := (0).to_natural_32
						from
						until
							not (not js.loop_left and then (l_i < l_n))
						loop
							l_vi___0 := (gsl_gsl_vector_double_inst.gsl_vector_get (l_v, l_i))
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_n)
							loop
								l_wj := (gsl_gsl_vector_double_inst.gsl_vector_get (l_w, l_j))
								l_Hij := (gsl_gsl_matrix_double_inst.gsl_matrix_get (l_H, l_i, l_j)) - (l_vi___0 * l_wj) / l_lambda
								gsl_gsl_matrix_double_inst.gsl_matrix_set (l_H, l_i, l_j, l_Hij)
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						copy_source_inst.gsl_vector_memcpy (a_f, l_fnew).do_nothing
						copy_source_inst.gsl_vector_memcpy (a_x, l_x_trial).do_nothing
						l_i := (0).to_natural_32
						from
						until
							not (l_i < l_n)
						loop
							l_pi___1 := (gsl_gsl_vector_double_inst.gsl_vector_get (l_p, l_i))
							gsl_gsl_vector_double_inst.gsl_vector_set (a_dx, l_i, l_t * l_pi___1)
							l_i := l_i + 1
						end
						l_state.item.phi := l_phi1
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	broyden_iterate_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent broyden_iterate)
		end

	broyden_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_BROYDEN_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_BROYDEN_STATE_T]}.make_cast (a_vstate))
			init_source_inst.gsl_matrix_free (l_state.item.H)
			init_source_inst.gsl_matrix_free (l_state.item.lu)
			init_inst.gsl_permutation_free (l_state.item.permutation)
			init_source_inst.gsl_vector_free (l_state.item.v)
			init_source_inst.gsl_vector_free (l_state.item.w)
			init_source_inst.gsl_vector_free (l_state.item.y)
			init_source_inst.gsl_vector_free (l_state.item.p)
			init_source_inst.gsl_vector_free (l_state.item.fnew)
			init_source_inst.gsl_vector_free (l_state.item.x_trial)
		end

	broyden_free_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent broyden_free)
		end

end
