class
	P_BSPLINE

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create h1_103.make (<<6>>)
			create g2_103.make (<<6>>)
			create h1_105.make (<<10>>)
			create g2_105.make (<<10>>)
			create g1_1.make (<<10>>)
			create h2_1.make (<<10>>)
			create h1_202.make (<<6>>)
			create g2_202.make (<<6>>)
			create h1_204.make (<<10>>)
			create g2_204.make (<<10>>)
			create h1_206.make (<<14>>)
			create g2_206.make (<<14>>)
			create h1_208.make (<<18>>)
			create g2_208.make (<<18>>)
			create h2_2.make (<<18>>)
			create g1_2.make (<<18>>)
			create h1_301.make (<<4>>)
			create g2_301.make (<<4>>)
			create h1_303.make (<<8>>)
			create g2_303.make (<<8>>)
			create h1_305.make (<<12>>)
			create g2_305.make (<<12>>)
			create h1_307.make (<<16>>)
			create g2_307.make (<<16>>)
			create h1_309.make (<<20>>)
			create g2_309.make (<<20>>)
			create h2_3.make (<<20>>)
			create g1_3.make (<<20>>)
			create bspline_type.make
			create bspline_centered_type.make
			create gsl_wavelet_bspline.make
			create gsl_wavelet_bspline_centered.make
		end

feature {ANY} -- attributes

	h1_103: CE_ARRAY [REAL_64]

	g2_103: CE_ARRAY [REAL_64]

	h1_105: CE_ARRAY [REAL_64]

	g2_105: CE_ARRAY [REAL_64]

	g1_1: CE_ARRAY [REAL_64]

	h2_1: CE_ARRAY [REAL_64]

	h1_202: CE_ARRAY [REAL_64]

	g2_202: CE_ARRAY [REAL_64]

	h1_204: CE_ARRAY [REAL_64]

	g2_204: CE_ARRAY [REAL_64]

	h1_206: CE_ARRAY [REAL_64]

	g2_206: CE_ARRAY [REAL_64]

	h1_208: CE_ARRAY [REAL_64]

	g2_208: CE_ARRAY [REAL_64]

	h2_2: CE_ARRAY [REAL_64]

	g1_2: CE_ARRAY [REAL_64]

	h1_301: CE_ARRAY [REAL_64]

	g2_301: CE_ARRAY [REAL_64]

	h1_303: CE_ARRAY [REAL_64]

	g2_303: CE_ARRAY [REAL_64]

	h1_305: CE_ARRAY [REAL_64]

	g2_305: CE_ARRAY [REAL_64]

	h1_307: CE_ARRAY [REAL_64]

	g2_307: CE_ARRAY [REAL_64]

	h1_309: CE_ARRAY [REAL_64]

	g2_309: CE_ARRAY [REAL_64]

	h2_3: CE_ARRAY [REAL_64]

	g1_3: CE_ARRAY [REAL_64]

	bspline_type: PD_GSL_WAVELET_TYPE

	bspline_centered_type: PD_GSL_WAVELET_TYPE

	gsl_wavelet_bspline: CE_POINTER [PD_GSL_WAVELET_TYPE]

	gsl_wavelet_bspline_centered: CE_POINTER [PD_GSL_WAVELET_TYPE]

feature {ANY} -- routines

	gsl_bspline_alloc (a_k: NATURAL_32; a_nbreak: NATURAL_32): CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]
		local
			l_w: CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]
			js: JUMP_STATE
		do
			create l_w.make

			if a_k = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("k must be at least 1"), ce_string ("bspline.c"), 58, 4)
					Result := (create {CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_nbreak < {NATURAL_32} 2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("nbreak must be at least 2"), ce_string ("bspline.c"), 62, 4)
					Result := (create {CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_w.ce_gets (create {CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]}.make_cast ((malloc ({PD_GSL_BSPLINE_WORKSPACE}.sizeof.to_natural_32))))
				if (l_w.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for workspace"), ce_string ("bspline.c"), 73, 8)
						Result := (create {CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
				if not js.return_called then
					l_w.item.k := a_k
					l_w.item.km1 := a_k - {NATURAL_32} 1
					l_w.item.nbreak := a_nbreak
					l_w.item.l := a_nbreak - {NATURAL_32} 1
					l_w.item.n := (l_w.item.l + a_k) - {NATURAL_32} 1
					l_w.item.knots := init_source_inst.gsl_vector_alloc (l_w.item.n + a_k)
					if ((l_w.item.knots).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						free (create {CE_POINTER [ANY]}.make_cast (l_w))
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("failed to allocate space for knots vector"), ce_string ("bspline.c"), 87, 8)
							Result := (create {CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]}.make_shared (default_pointer))
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
				end
				if not js.return_called then
					l_w.item.deltal := init_source_inst.gsl_vector_alloc (a_k)
					if ((l_w.item.deltal).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						init_source_inst.gsl_vector_free (l_w.item.knots)
						free (create {CE_POINTER [ANY]}.make_cast (l_w))
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("failed to allocate space for deltal vector"), ce_string ("bspline.c"), 96, 8)
							Result := (create {CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]}.make_shared (default_pointer))
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
				end
				if not js.return_called then
					l_w.item.deltar := init_source_inst.gsl_vector_alloc (a_k)
					if ((l_w.item.deltar).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						init_source_inst.gsl_vector_free (l_w.item.deltal)
						init_source_inst.gsl_vector_free (l_w.item.knots)
						free (create {CE_POINTER [ANY]}.make_cast (l_w))
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("failed to allocate space for deltar vector"), ce_string ("bspline.c"), 106, 8)
							Result := (create {CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]}.make_shared (default_pointer))
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
				end
				if not js.return_called then
					l_w.item.B := init_source_inst.gsl_vector_alloc (a_k)
					if ((l_w.item.B).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						init_source_inst.gsl_vector_free (l_w.item.deltar)
						init_source_inst.gsl_vector_free (l_w.item.deltal)
						init_source_inst.gsl_vector_free (l_w.item.knots)
						free (create {CE_POINTER [ANY]}.make_cast (l_w))
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("failed to allocate space for temporary spline vector"), ce_string ("bspline.c"), 119, 8)
							Result := (create {CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]}.make_shared (default_pointer))
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
				end
				if not js.return_called then
					Result := l_w
					js.return
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]}.make_shared (default_pointer))
			end
		end

	gsl_bspline_deriv_alloc (a_k: NATURAL_32): CE_POINTER [PD_GSL_BSPLINE_DERIV_WORKSPACE]
		local
			l_dw: CE_POINTER [PD_GSL_BSPLINE_DERIV_WORKSPACE]
			js: JUMP_STATE
		do
			create l_dw.make

			if a_k = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("k must be at least 1"), ce_string ("bspline.c"), 141, 4)
					Result := (create {CE_POINTER [PD_GSL_BSPLINE_DERIV_WORKSPACE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_dw.ce_gets (create {CE_POINTER [PD_GSL_BSPLINE_DERIV_WORKSPACE]}.make_cast ((malloc ({PD_GSL_BSPLINE_DERIV_WORKSPACE}.sizeof.to_natural_32))))
				if (l_dw.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for workspace"), ce_string ("bspline.c"), 154, 8)
						Result := (create {CE_POINTER [PD_GSL_BSPLINE_DERIV_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
				if not js.return_called then
					l_dw.item.A := init_source_inst.gsl_matrix_alloc (a_k, a_k)
					if ((l_dw.item.A).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						free (create {CE_POINTER [ANY]}.make_cast (l_dw))
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("failed to allocate space for derivative work matrix"), ce_string ("bspline.c"), 163, 8)
							Result := (create {CE_POINTER [PD_GSL_BSPLINE_DERIV_WORKSPACE]}.make_shared (default_pointer))
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
				end
				if not js.return_called then
					l_dw.item.dB := init_source_inst.gsl_matrix_alloc (a_k, a_k + {NATURAL_32} 1)
					if ((l_dw.item.dB).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						init_source_inst.gsl_matrix_free (l_dw.item.A)
						free (create {CE_POINTER [ANY]}.make_cast (l_dw))
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("failed to allocate space for temporary derivative matrix"), ce_string ("bspline.c"), 173, 8)
							Result := (create {CE_POINTER [PD_GSL_BSPLINE_DERIV_WORKSPACE]}.make_shared (default_pointer))
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
				end
				if not js.return_called then
					l_dw.item.k := a_k
					Result := l_dw
					js.return
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [PD_GSL_BSPLINE_DERIV_WORKSPACE]}.make_shared (default_pointer))
			end
		end

	gsl_bspline_ncoeffs (a_w: CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]): NATURAL_32
		do
			Result := (a_w.item.n)
		end

	gsl_bspline_order (a_w: CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]): NATURAL_32
		do
			Result := (a_w.item.k)
		end

	gsl_bspline_nbreak (a_w: CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]): NATURAL_32
		do
			Result := (a_w.item.nbreak)
		end

	gsl_bspline_breakpoint (a_i: NATURAL_32; a_w: CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]): REAL_64
		local
			l_j: NATURAL_32
		do
			l_j := (a_i + a_w.item.k) - {NATURAL_32} 1
			Result := (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.knots, l_j))
		end

	gsl_bspline_greville_abscissa (a_i: NATURAL_32; a_w: CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]): REAL_64
		local
			l_stride: NATURAL_32
			l_km1: NATURAL_32
			l_data: CE_POINTER [REAL_64]
		do
			create l_data.make

			l_stride := (a_w.item.knots).item.stride
			l_km1 := a_w.item.km1
			l_data.ce_gets ((a_w.item.knots).item.data + ((a_i + {NATURAL_32} 1) * l_stride).to_integer_32)
			if l_km1 = {NATURAL_32} 0 then
				l_km1 := (2).to_natural_32
				l_data.ce_gets (l_data - l_stride.to_integer_32)
			end
			Result := (mean_source_inst.gsl_stats_mean (l_data, l_stride, l_km1))
		end

	gsl_bspline_free (a_w: CE_POINTER [PD_GSL_BSPLINE_WORKSPACE])
		local
			js: JUMP_STATE
		do
			if (a_w).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				init_source_inst.gsl_vector_free (a_w.item.knots)
				init_source_inst.gsl_vector_free (a_w.item.deltal)
				init_source_inst.gsl_vector_free (a_w.item.deltar)
				init_source_inst.gsl_vector_free (a_w.item.B)
				free (create {CE_POINTER [ANY]}.make_cast (a_w))
			end
		end

	gsl_bspline_deriv_free (a_dw: CE_POINTER [PD_GSL_BSPLINE_DERIV_WORKSPACE])
		local
			js: JUMP_STATE
		do
			if (a_dw).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				init_source_inst.gsl_matrix_free (a_dw.item.A)
				init_source_inst.gsl_matrix_free (a_dw.item.dB)
				free (create {CE_POINTER [ANY]}.make_cast (a_dw))
			end
		end

	gsl_bspline_knots (a_breakpts: CE_POINTER [PD_GSL_VECTOR]; a_w: CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]): INTEGER_32
		local
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			if a_breakpts.item.size /= a_w.item.nbreak then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("breakpts vector has wrong size"), ce_string ("bspline.c"), 300, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_w.item.k)
				loop
					gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.knots, l_i, (gsl_gsl_vector_double_inst.gsl_vector_get (a_breakpts, (0).to_natural_32)))
					l_i := l_i + 1
				end
				l_i := (1).to_natural_32
				from
				until
					not (l_i < a_w.item.l)
				loop
					gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.knots, (a_w.item.k - {NATURAL_32} 1) + l_i, (gsl_gsl_vector_double_inst.gsl_vector_get (a_breakpts, l_i)))
					l_i := l_i + 1
				end
				l_i := a_w.item.n
				from
				until
					not (l_i < a_w.item.n + a_w.item.k)
				loop
					gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.knots, l_i, (gsl_gsl_vector_double_inst.gsl_vector_get (a_breakpts, a_w.item.l)))
					l_i := l_i + 1
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_bspline_knots_uniform (a_a___5: REAL_64; a_b___0: REAL_64; a_w: CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]): INTEGER_32
		local
			l_i: NATURAL_32
			l_delta___0: REAL_64
			l_x: REAL_64
		do
			l_delta___0 := (a_b___0 - a_a___5) / (a_w.item.l).to_real_64
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_w.item.k)
			loop
				gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.knots, l_i, a_a___5)
				l_i := l_i + 1
			end
			l_x := a_a___5 + l_delta___0
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_w.item.l - {NATURAL_32} 1)
			loop
				gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.knots, a_w.item.k + l_i, l_x)
				l_x := l_x + l_delta___0
				l_i := l_i + 1
			end
			l_i := a_w.item.n
			from
			until
				not (l_i < a_w.item.n + a_w.item.k)
			loop
				gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.knots, l_i, a_b___0)
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_bspline_eval (a_x: REAL_64; a_B: CE_POINTER [PD_GSL_VECTOR]; a_w: CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]): INTEGER_32
		local
			l_i: NATURAL_32
			l_istart: NATURAL_32
			l_iend: NATURAL_32
			l_error: INTEGER_32
			js: JUMP_STATE
		do
			if a_B.item.size /= a_w.item.n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector B not of length n"), ce_string ("bspline.c"), 394, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_error := gsl_bspline_eval_nonzero (a_x, a_w.item.B, create {CE_POINTER [NATURAL_32]}.make_shared ($l_istart), create {CE_POINTER [NATURAL_32]}.make_shared ($l_iend), a_w)
				if l_error.to_boolean then
					Result := l_error
					js.return
				end
				if not js.return_called then
					l_i := (0).to_natural_32
					from
					until
						not (l_i < l_istart)
					loop
						gsl_gsl_vector_double_inst.gsl_vector_set (a_B, l_i, 0.0)
						l_i := l_i + 1
					end
					l_i := l_istart
					from
					until
						not (l_i <= l_iend)
					loop
						gsl_gsl_vector_double_inst.gsl_vector_set (a_B, l_i, (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.B, l_i - l_istart)))
						l_i := l_i + 1
					end
					l_i := l_iend + {NATURAL_32} 1
					from
					until
						not (l_i < a_w.item.n)
					loop
						gsl_gsl_vector_double_inst.gsl_vector_set (a_B, l_i, 0.0)
						l_i := l_i + 1
					end
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_bspline_eval_nonzero (a_x: REAL_64; a_Bk: CE_POINTER [PD_GSL_VECTOR]; a_istart: CE_POINTER [NATURAL_32]; a_iend: CE_POINTER [NATURAL_32]; a_w: CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_flag: INTEGER_32
			l_error: INTEGER_32
			js: JUMP_STATE
		do
			if a_Bk.item.size /= a_w.item.k then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("Bk vector length does not match order k"), ce_string ("bspline.c"), 458, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_flag := 0
				l_error := 0
				l_i := bspline_find_interval (a_x, create {CE_POINTER [INTEGER_32]}.make_shared ($l_flag), a_w)
				l_error := bspline_process_interval_for_eval (a_x, create {CE_POINTER [NATURAL_32]}.make_shared ($l_i), l_flag, a_w)
				if l_error.to_boolean then
					Result := l_error
					js.return
				end
				if not js.return_called then
					a_istart.item := (l_i - a_w.item.k) + {NATURAL_32} 1
					a_iend.item := l_i
					bspline_pppack_bsplvb (a_w.item.knots, a_w.item.k, (1).to_natural_32, a_x, a_iend.item, create {CE_POINTER [NATURAL_32]}.make_shared ($l_j), a_w.item.deltal, a_w.item.deltar, a_Bk)
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_bspline_deriv_eval (a_x: REAL_64; a_nderiv: NATURAL_32; a_dB: CE_POINTER [PD_GSL_MATRIX]; a_w: CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]; a_dw: CE_POINTER [PD_GSL_BSPLINE_DERIV_WORKSPACE]): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_istart: NATURAL_32
			l_iend: NATURAL_32
			l_error: INTEGER_32
			js: JUMP_STATE
		do
			if a_dB.item.size1 /= a_w.item.n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("dB matrix first dimension not of length n"), ce_string ("bspline.c"), 513, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_dB.item.size2 < a_nderiv + {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("dB matrix second dimension must be at least length nderiv+1"), ce_string ("bspline.c"), 519, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_dw.item.k < a_w.item.k then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("derivative workspace is too small"), ce_string ("bspline.c"), 523, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_error := gsl_bspline_deriv_eval_nonzero (a_x, a_nderiv, a_dw.item.dB, create {CE_POINTER [NATURAL_32]}.make_shared ($l_istart), create {CE_POINTER [NATURAL_32]}.make_shared ($l_iend), a_w, a_dw)
				if l_error.to_boolean then
					Result := l_error
					js.return
				end
				if not js.return_called then
					l_j := (0).to_natural_32
					from
					until
						not (not js.loop_left and then (l_j <= a_nderiv))
					loop
						l_i := (0).to_natural_32
						from
						until
							not (l_i < l_istart)
						loop
							gsl_gsl_matrix_double_inst.gsl_matrix_set (a_dB, l_i, l_j, 0.0)
							l_i := l_i + 1
						end
						l_i := l_istart
						from
						until
							not (l_i <= l_iend)
						loop
							gsl_gsl_matrix_double_inst.gsl_matrix_set (a_dB, l_i, l_j, (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_dw.item.dB, l_i - l_istart, l_j)))
							l_i := l_i + 1
						end
						l_i := l_iend + {NATURAL_32} 1
						from
						until
							not (l_i < a_w.item.n)
						loop
							gsl_gsl_matrix_double_inst.gsl_matrix_set (a_dB, l_i, l_j, 0.0)
							l_i := l_i + 1
						end
						l_j := l_j + 1
					end
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_bspline_deriv_eval_nonzero (a_x: REAL_64; a_nderiv: NATURAL_32; a_dB: CE_POINTER [PD_GSL_MATRIX]; a_istart: CE_POINTER [NATURAL_32]; a_iend: CE_POINTER [NATURAL_32]; a_w: CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]; a_dw: CE_POINTER [PD_GSL_BSPLINE_DERIV_WORKSPACE]): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_flag: INTEGER_32
			l_error: INTEGER_32
			l_min_nderivk: NATURAL_32
			js: JUMP_STATE
		do
			if a_dB.item.size1 /= a_w.item.k then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("dB matrix first dimension not of length k"), ce_string ("bspline.c"), 607, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_dB.item.size2 < a_nderiv + {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("dB matrix second dimension must be at least length nderiv+1"), ce_string ("bspline.c"), 613, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_dw.item.k < a_w.item.k then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("derivative workspace is too small"), ce_string ("bspline.c"), 617, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_flag := 0
				l_error := 0
				l_i := bspline_find_interval (a_x, create {CE_POINTER [INTEGER_32]}.make_shared ($l_flag), a_w)
				l_error := bspline_process_interval_for_eval (a_x, create {CE_POINTER [NATURAL_32]}.make_shared ($l_i), l_flag, a_w)
				if l_error.to_boolean then
					Result := l_error
					js.return
				end
				if not js.return_called then
					a_istart.item := (l_i - a_w.item.k) + {NATURAL_32} 1
					a_iend.item := l_i
					bspline_pppack_bsplvd (a_w.item.knots, a_w.item.k, a_x, a_iend.item, a_w.item.deltal, a_w.item.deltar, a_dw.item.A, a_dB, a_nderiv)
					l_min_nderivk := (gsl_gsl_minmax_inst.GSL_MIN_INT (a_nderiv.to_integer_32, (a_w.item.k - {NATURAL_32} 1).to_integer_32)).to_natural_32
					l_j := l_min_nderivk + {NATURAL_32} 1
					from
					until
						not (not js.loop_left and then (l_j <= a_nderiv))
					loop
						l_i := (0).to_natural_32
						from
						until
							not (l_i < a_w.item.k)
						loop
							gsl_gsl_matrix_double_inst.gsl_matrix_set (a_dB, l_i, l_j, 0.0)
							l_i := l_i + 1
						end
						l_j := l_j + 1
					end
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	bspline_find_interval (a_x: REAL_64; a_flag: CE_POINTER [INTEGER_32]; a_w: CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]): NATURAL_32
		local
			l_i: NATURAL_32
			l_ti: REAL_64
			l_tip1: REAL_64
			js: JUMP_STATE
		do
			if a_x < (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.knots, (0).to_natural_32)) then
				a_flag.item := -1
				Result := (0).to_natural_32
				js.return
			end
			if not js.return_called then
				l_i := a_w.item.k - {NATURAL_32} 1
				from
				until
					not (not js.loop_left and then (l_i < (a_w.item.k + a_w.item.l) - {NATURAL_32} 1))
				loop
					js.reset
					l_ti := (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.knots, l_i))
					l_tip1 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.knots, l_i + {NATURAL_32} 1))
					if l_tip1 < l_ti then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("knots vector is not increasing"), ce_string ("bspline.c"), 699, 4)
							Result := (4).to_natural_32
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						if l_ti <= a_x then
							if a_x < l_tip1 then
								js.break
							end
						end
						if not js.loop_jumped and then (l_ti < a_x) then
							if a_x = l_tip1 then
								if l_tip1 = (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.knots, (a_w.item.k + a_w.item.l) - {NATURAL_32} 1)) then
									js.break
								end
							end
						end
						if not js.loop_jumped then
							l_i := l_i + 1
						end
					end
				end
				js.reset
			end
			if not js.return_called then
				if l_i = (a_w.item.k + a_w.item.l) - {NATURAL_32} 1 then
					a_flag.item := 1
				else
					a_flag.item := 0
				end
				Result := l_i
			end
		end

	bspline_process_interval_for_eval (a_x: REAL_64; a_i: CE_POINTER [NATURAL_32]; a_flag: INTEGER_32; a_w: CE_POINTER [PD_GSL_BSPLINE_WORKSPACE]): INTEGER_32
		local
			l_tmp___0: REAL_64
			js: JUMP_STATE
		do
			if a_flag = -1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("x outside of knot interval"), ce_string ("bspline.c"), 731, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_flag = 1 then
				if a_x <= (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.knots, a_i.item)) + 2.2204460492503131e-16 then
					a_i.item := (a_i.item) - 1
				else
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("x outside of knot interval"), ce_string ("bspline.c"), 741, 4)
						Result := 4
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_tmp___0 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.knots, a_i.item)
				if l_tmp___0 = (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.knots, a_i.item + {NATURAL_32} 1)) then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("knot(i) = knot(i+1) will result in division by zero"), ce_string ("bspline.c"), 748, 4)
						Result := 4
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	bspline_pppack_bsplvb (a_t: CE_POINTER [PD_GSL_VECTOR]; a_jhigh: NATURAL_32; a_index: NATURAL_32; a_x: REAL_64; a_left: NATURAL_32; a_j: CE_POINTER [NATURAL_32]; a_deltal: CE_POINTER [PD_GSL_VECTOR]; a_deltar: CE_POINTER [PD_GSL_VECTOR]; a_biatx: CE_POINTER [PD_GSL_VECTOR])
		local
			l_i: NATURAL_32
			l_saved: REAL_64
			l_term: REAL_64
			l_tmp___1: REAL_64
			l_tmp___2: REAL_64
			js: JUMP_STATE
		do
			if a_index = {NATURAL_32} 1 then
				a_j.item := (0).to_natural_32
				gsl_gsl_vector_double_inst.gsl_vector_set (a_biatx, (0).to_natural_32, 1.0)
			end
			from
			until
				not (not js.loop_left and then (a_j.item < a_jhigh - {NATURAL_32} 1))
			loop
				gsl_gsl_vector_double_inst.gsl_vector_set (a_deltar, a_j.item, (gsl_gsl_vector_double_inst.gsl_vector_get (a_t, (a_left + a_j.item) + {NATURAL_32} 1)) - a_x)
				gsl_gsl_vector_double_inst.gsl_vector_set (a_deltal, a_j.item, a_x - (gsl_gsl_vector_double_inst.gsl_vector_get (a_t, a_left - a_j.item)))
				l_saved := 0.0
				l_i := (0).to_natural_32
				from
				until
					not (l_i <= a_j.item)
				loop
					l_tmp___1 := gsl_gsl_vector_double_inst.gsl_vector_get (a_biatx, l_i)
					l_tmp___2 := gsl_gsl_vector_double_inst.gsl_vector_get (a_deltar, l_i)
					l_term := l_tmp___1 / (l_tmp___2 + (gsl_gsl_vector_double_inst.gsl_vector_get (a_deltal, a_j.item - l_i)))
					gsl_gsl_vector_double_inst.gsl_vector_set (a_biatx, l_i, l_saved + (gsl_gsl_vector_double_inst.gsl_vector_get (a_deltar, l_i)) * l_term)
					l_saved := (gsl_gsl_vector_double_inst.gsl_vector_get (a_deltal, a_j.item - l_i)) * l_term
					l_i := l_i + 1
				end
				gsl_gsl_vector_double_inst.gsl_vector_set (a_biatx, a_j.item + {NATURAL_32} 1, l_saved)
				a_j.item := (a_j.item) + 1
			end
		end

	bspline_pppack_bsplvd (a_t: CE_POINTER [PD_GSL_VECTOR]; a_k: NATURAL_32; a_x: REAL_64; a_left: NATURAL_32; a_deltal: CE_POINTER [PD_GSL_VECTOR]; a_deltar: CE_POINTER [PD_GSL_VECTOR]; a_a___5: CE_POINTER [PD_GSL_MATRIX]; a_dbiatx: CE_POINTER [PD_GSL_MATRIX]; a_nderiv: NATURAL_32)
		local
			l_i: INTEGER_32
			l_ideriv: INTEGER_32
			l_il: INTEGER_32
			l_j: INTEGER_32
			l_jlow: INTEGER_32
			l_jp1mid: INTEGER_32
			l_kmm: INTEGER_32
			l_ldummy: INTEGER_32
			l_m___4: INTEGER_32
			l_mhigh: INTEGER_32
			l_factor: REAL_64
			l_fkmm: REAL_64
			l_sum: REAL_64
			l_bsplvb_j: NATURAL_32
			l_dbcol: PD_GSL_VECTOR_VIEW
			l_tmp___1: REAL_64
			l_tmp___3: REAL_64
			l_tmp___5: REAL_64
			js: JUMP_STATE
		do
			create l_dbcol.make

			l_dbcol.ce_gets ((rowcol_source_inst.gsl_matrix_column (a_dbiatx, (0).to_natural_32)))
			l_mhigh := gsl_gsl_minmax_inst.GSL_MIN_INT (a_nderiv.to_integer_32, (a_k - {NATURAL_32} 1).to_integer_32)
			bspline_pppack_bsplvb (a_t, a_k - l_mhigh.to_natural_32, (1).to_natural_32, a_x, a_left, create {CE_POINTER [NATURAL_32]}.make_shared ($l_bsplvb_j), a_deltal, a_deltar, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_dbcol.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))
			if l_mhigh > 0 then
				l_ideriv := l_mhigh
				l_m___4 := 1
				from
				until
					not (not js.loop_left and then (l_m___4 <= l_mhigh))
				loop
					l_j := l_ideriv
					l_jp1mid := 0
					from
					until
						not (l_j < a_k.to_integer_32)
					loop
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_dbiatx, l_j.to_natural_32, l_ideriv.to_natural_32, (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_dbiatx, l_jp1mid.to_natural_32, (0).to_natural_32)))
						l_j := l_j + 1
						l_jp1mid := l_jp1mid + 1
					end
					l_ideriv := l_ideriv - 1
					bspline_pppack_bsplvb (a_t, a_k - l_ideriv.to_natural_32, (2).to_natural_32, a_x, a_left, create {CE_POINTER [NATURAL_32]}.make_shared ($l_bsplvb_j), a_deltal, a_deltar, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_dbcol.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))
					l_m___4 := l_m___4 + 1
				end
				l_jlow := 0
				l_i := 0
				from
				until
					not (not js.loop_left and then (l_i < a_k.to_integer_32))
				loop
					l_j := l_jlow
					from
					until
						not (l_j < a_k.to_integer_32)
					loop
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_a___5, l_j.to_natural_32, l_i.to_natural_32, 0.0)
						l_j := l_j + 1
					end
					l_jlow := l_i
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_a___5, l_i.to_natural_32, l_i.to_natural_32, 1.0)
					l_i := l_i + 1
				end
				l_m___4 := 1
				from
				until
					not (not js.loop_left and then (l_m___4 <= l_mhigh))
				loop
					l_kmm := (a_k - l_m___4.to_natural_32).to_integer_32
					l_fkmm := (l_kmm.to_real).to_double
					l_il := a_left.to_integer_32
					l_i := (a_k - {NATURAL_32} 1).to_integer_32
					l_ldummy := 0
					from
					until
						not (not js.loop_left and then (l_ldummy < l_kmm))
					loop
						l_tmp___1 := gsl_gsl_vector_double_inst.gsl_vector_get (a_t, (l_il + l_kmm).to_natural_32)
						l_factor := l_fkmm / (l_tmp___1 - (gsl_gsl_vector_double_inst.gsl_vector_get (a_t, l_il.to_natural_32)))
						l_j := 0
						from
						until
							not (l_j <= l_i)
						loop
							l_tmp___3 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_a___5, l_i.to_natural_32, l_j.to_natural_32)
							gsl_gsl_matrix_double_inst.gsl_matrix_set (a_a___5, l_i.to_natural_32, l_j.to_natural_32, l_factor * (l_tmp___3 - (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_a___5, (l_i - 1).to_natural_32, l_j.to_natural_32))))
							l_j := l_j + 1
						end
						l_il := l_il - 1
						l_i := l_i - 1
						l_ldummy := l_ldummy + 1
					end
					l_i := 0
					from
					until
						not (not js.loop_left and then (l_i < a_k.to_integer_32))
					loop
						l_sum := (0).to_double
						l_jlow := gsl_gsl_minmax_inst.GSL_MAX_INT (l_i, l_m___4)
						l_j := l_jlow
						from
						until
							not (l_j < a_k.to_integer_32)
						loop
							l_tmp___5 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_a___5, l_j.to_natural_32, l_i.to_natural_32)
							l_sum := l_sum + (l_tmp___5 * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_dbiatx, l_j.to_natural_32, l_m___4.to_natural_32)))
							l_j := l_j + 1
						end
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_dbiatx, l_i.to_natural_32, l_m___4.to_natural_32, l_sum)
						l_i := l_i + 1
					end
					l_m___4 := l_m___4 + 1
				end
			end
		end

	bspline_init (a_h1: CE_POINTER [CE_POINTER [REAL_64]]; a_g1: CE_POINTER [CE_POINTER [REAL_64]]; a_h2: CE_POINTER [CE_POINTER [REAL_64]]; a_g2: CE_POINTER [CE_POINTER [REAL_64]]; a_nc: CE_POINTER [NATURAL_32]; a_offset: CE_POINTER [NATURAL_32]; a_member: NATURAL_32): INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_member.to_integer_32 -- switch 1 head
					when 103 then l_pos := -1 + 1
					when 105 then l_pos := -1 + 2
					when 202 then l_pos := -1 + 3
					when 204 then l_pos := -1 + 4
					when 206 then l_pos := -1 + 5
					when 208 then l_pos := -1 + 6
					when 301 then l_pos := -1 + 7
					when 303 then l_pos := -1 + 8
					when 305 then l_pos := -1 + 9
					when 307 then l_pos := -1 + 10
					when 309 then l_pos := -1 + 11
					else l_pos := -1 + 12
					end
				when 1 then -- switch 1, case 103
					a_nc.item := (6).to_natural_32
					a_h1.item := h1_103
					a_g1.item := g1_1 + 2
					a_h2.item := h2_1 + 2
					a_g2.item := g2_103
					l_pos := -1 + 13 -- switch 1; break
				when 2 then -- switch 1, case 105
					a_nc.item := (10).to_natural_32
					a_h1.item := h1_105
					a_g1.item := g1_1
					a_h2.item := h2_1
					a_g2.item := g2_105
					l_pos := -1 + 13 -- switch 1; break
				when 3 then -- switch 1, case 202
					a_nc.item := (6).to_natural_32
					a_h1.item := h1_202
					a_g1.item := g1_2 + 6
					a_h2.item := h2_2 + 6
					a_g2.item := g2_202
					l_pos := -1 + 13 -- switch 1; break
				when 4 then -- switch 1, case 204
					a_nc.item := (10).to_natural_32
					a_h1.item := h1_204
					a_g1.item := g1_2 + 4
					a_h2.item := h2_2 + 4
					a_g2.item := g2_204
					l_pos := -1 + 13 -- switch 1; break
				when 5 then -- switch 1, case 206
					a_nc.item := (14).to_natural_32
					a_h1.item := h1_206
					a_g1.item := g1_2 + 2
					a_h2.item := h2_2 + 2
					a_g2.item := g2_206
					l_pos := -1 + 13 -- switch 1; break
				when 6 then -- switch 1, case 208
					a_nc.item := (18).to_natural_32
					a_h1.item := h1_208
					a_g1.item := g1_2
					a_h2.item := h2_2
					a_g2.item := g2_208
					l_pos := -1 + 13 -- switch 1; break
				when 7 then -- switch 1, case 301
					a_nc.item := (4).to_natural_32
					a_h1.item := h1_301
					a_g1.item := g1_3 + 8
					a_h2.item := h2_3 + 8
					a_g2.item := g2_301
					l_pos := -1 + 13 -- switch 1; break
				when 8 then -- switch 1, case 303
					a_nc.item := (8).to_natural_32
					a_h1.item := h1_303
					a_g1.item := g1_3 + 6
					a_h2.item := h2_3 + 6
					a_g2.item := g2_303
					l_pos := -1 + 13 -- switch 1; break
				when 9 then -- switch 1, case 305
					a_nc.item := (12).to_natural_32
					a_h1.item := h1_305
					a_g1.item := g1_3 + 4
					a_h2.item := h2_3 + 4
					a_g2.item := g2_305
					l_pos := -1 + 13 -- switch 1; break
				when 10 then -- switch 1, case 307
					a_nc.item := (16).to_natural_32
					a_h1.item := h1_307
					a_g1.item := g1_3 + 2
					a_h2.item := h2_3 + 2
					a_g2.item := g2_307
					l_pos := -1 + 13 -- switch 1; break
				when 11 then -- switch 1, case 309
					a_nc.item := (20).to_natural_32
					a_h1.item := h1_309
					a_g1.item := g1_3
					a_h2.item := h2_3
					a_g2.item := g2_309
					l_pos := -1 + 13 -- switch 1; break
				when 12 then -- switch 1, default:
					Result := (-1)
					js.return
				when 13 then -- switch 1, done:
					if not js.return_called then
						a_offset.item := (0).to_natural_32
						Result := 0
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	bspline_init_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent bspline_init)
		end

	bspline_centered_init (a_h1: CE_POINTER [CE_POINTER [REAL_64]]; a_g1: CE_POINTER [CE_POINTER [REAL_64]]; a_h2: CE_POINTER [CE_POINTER [REAL_64]]; a_g2: CE_POINTER [CE_POINTER [REAL_64]]; a_nc: CE_POINTER [NATURAL_32]; a_offset: CE_POINTER [NATURAL_32]; a_member: NATURAL_32): INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_member.to_integer_32 -- switch 1 head
					when 103 then l_pos := -1 + 1
					when 105 then l_pos := -1 + 2
					when 202 then l_pos := -1 + 3
					when 204 then l_pos := -1 + 4
					when 206 then l_pos := -1 + 5
					when 208 then l_pos := -1 + 6
					when 301 then l_pos := -1 + 7
					when 303 then l_pos := -1 + 8
					when 305 then l_pos := -1 + 9
					when 307 then l_pos := -1 + 10
					when 309 then l_pos := -1 + 11
					else l_pos := -1 + 12
					end
				when 1 then -- switch 1, case 103
					a_nc.item := (6).to_natural_32
					a_h1.item := h1_103
					a_g1.item := g1_1 + 2
					a_h2.item := h2_1 + 2
					a_g2.item := g2_103
					l_pos := -1 + 13 -- switch 1; break
				when 2 then -- switch 1, case 105
					a_nc.item := (10).to_natural_32
					a_h1.item := h1_105
					a_g1.item := g1_1
					a_h2.item := h2_1
					a_g2.item := g2_105
					l_pos := -1 + 13 -- switch 1; break
				when 3 then -- switch 1, case 202
					a_nc.item := (6).to_natural_32
					a_h1.item := h1_202
					a_g1.item := g1_2 + 6
					a_h2.item := h2_2 + 6
					a_g2.item := g2_202
					l_pos := -1 + 13 -- switch 1; break
				when 4 then -- switch 1, case 204
					a_nc.item := (10).to_natural_32
					a_h1.item := h1_204
					a_g1.item := g1_2 + 4
					a_h2.item := h2_2 + 4
					a_g2.item := g2_204
					l_pos := -1 + 13 -- switch 1; break
				when 5 then -- switch 1, case 206
					a_nc.item := (14).to_natural_32
					a_h1.item := h1_206
					a_g1.item := g1_2 + 2
					a_h2.item := h2_2 + 2
					a_g2.item := g2_206
					l_pos := -1 + 13 -- switch 1; break
				when 6 then -- switch 1, case 208
					a_nc.item := (18).to_natural_32
					a_h1.item := h1_208
					a_g1.item := g1_2
					a_h2.item := h2_2
					a_g2.item := g2_208
					l_pos := -1 + 13 -- switch 1; break
				when 7 then -- switch 1, case 301
					a_nc.item := (4).to_natural_32
					a_h1.item := h1_301
					a_g1.item := g1_3 + 8
					a_h2.item := h2_3 + 8
					a_g2.item := g2_301
					l_pos := -1 + 13 -- switch 1; break
				when 8 then -- switch 1, case 303
					a_nc.item := (8).to_natural_32
					a_h1.item := h1_303
					a_g1.item := g1_3 + 6
					a_h2.item := h2_3 + 6
					a_g2.item := g2_303
					l_pos := -1 + 13 -- switch 1; break
				when 9 then -- switch 1, case 305
					a_nc.item := (12).to_natural_32
					a_h1.item := h1_305
					a_g1.item := g1_3 + 4
					a_h2.item := h2_3 + 4
					a_g2.item := g2_305
					l_pos := -1 + 13 -- switch 1; break
				when 10 then -- switch 1, case 307
					a_nc.item := (16).to_natural_32
					a_h1.item := h1_307
					a_g1.item := g1_3 + 2
					a_h2.item := h2_3 + 2
					a_g2.item := g2_307
					l_pos := -1 + 13 -- switch 1; break
				when 11 then -- switch 1, case 309
					a_nc.item := (20).to_natural_32
					a_h1.item := h1_309
					a_g1.item := g1_3
					a_h2.item := h2_3
					a_g2.item := g2_309
					l_pos := -1 + 13 -- switch 1; break
				when 12 then -- switch 1, default:
					Result := (-1)
					js.return
				when 13 then -- switch 1, done:
					if not js.return_called then
						a_offset.item := (a_nc.item).bit_shift_right (1)
						Result := 0
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	bspline_centered_init_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent bspline_centered_init)
		end

end
