class
	P_C_MAIN

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_fft_complex_forward (a_data: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32; a_wavetable: CE_POINTER [PD_GSL_FFT_COMPLEX_WAVETABLE]; a_work: CE_POINTER [PD_GSL_FFT_COMPLEX_WORKSPACE]): INTEGER_32
		local
			l_sign: INTEGER_32
			l_status: INTEGER_32
		do
			l_sign := -1
			l_status := (gsl_fft_complex_transform (a_data, a_stride, a_n, a_wavetable, a_work, l_sign))
			Result := l_status
		end

	gsl_fft_complex_backward (a_data: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32; a_wavetable: CE_POINTER [PD_GSL_FFT_COMPLEX_WAVETABLE]; a_work: CE_POINTER [PD_GSL_FFT_COMPLEX_WORKSPACE]): INTEGER_32
		local
			l_sign: INTEGER_32
			l_status: INTEGER_32
		do
			l_sign := {PC_GSL_FFT_DIRECTION}.gsl_fft_backward
			l_status := (gsl_fft_complex_transform (a_data, a_stride, a_n, a_wavetable, a_work, l_sign))
			Result := l_status
		end

	gsl_fft_complex_inverse (a_data: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32; a_wavetable: CE_POINTER [PD_GSL_FFT_COMPLEX_WAVETABLE]; a_work: CE_POINTER [PD_GSL_FFT_COMPLEX_WORKSPACE]): INTEGER_32
		local
			l_sign: INTEGER_32
			l_status: INTEGER_32
			l_norm___0: REAL_64
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_sign := {PC_GSL_FFT_DIRECTION}.gsl_fft_backward
			l_status := (gsl_fft_complex_transform (a_data, a_stride, a_n, a_wavetable, a_work, l_sign))
			if l_status.to_boolean then
				Result := l_status
				js.return
			end
			if not js.return_called then
				l_norm___0 := 1.0 / a_n.to_real_64
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					a_data[(({NATURAL_32} 2 * a_stride) * l_i).to_integer_32] := a_data[(({NATURAL_32} 2 * a_stride) * l_i).to_integer_32] * l_norm___0
					a_data[(({NATURAL_32} 2 * a_stride) * l_i + {NATURAL_32} 1).to_integer_32] := a_data[(({NATURAL_32} 2 * a_stride) * l_i + {NATURAL_32} 1).to_integer_32] * l_norm___0
					l_i := l_i + 1
				end
				Result := l_status
			end
		end

	gsl_fft_complex_transform (a_data: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32; a_wavetable: CE_POINTER [PD_GSL_FFT_COMPLEX_WAVETABLE]; a_work: CE_POINTER [PD_GSL_FFT_COMPLEX_WORKSPACE]; a_sign: INTEGER_32): INTEGER_32
		local
			l_nf: NATURAL_32
			l_i: NATURAL_32
			l_q___3: NATURAL_32
			l_product: NATURAL_32
			l_twiddle1: CE_POINTER [PD_GSL_COMPLEX]
			l_twiddle2: CE_POINTER [PD_GSL_COMPLEX]
			l_twiddle3: CE_POINTER [PD_GSL_COMPLEX]
			l_twiddle4: CE_POINTER [PD_GSL_COMPLEX]
			l_twiddle5: CE_POINTER [PD_GSL_COMPLEX]
			l_twiddle6: CE_POINTER [PD_GSL_COMPLEX]
			l_state: NATURAL_32
			l_scratch: CE_POINTER [REAL_64]
			l_in: CE_POINTER [REAL_64]
			l_istride: NATURAL_32
			l_out: CE_POINTER [REAL_64]
			l_ostride: NATURAL_32
			l_factor: NATURAL_32
			js: JUMP_STATE
		do
			create l_twiddle1.make
			create l_twiddle2.make
			create l_twiddle3.make
			create l_twiddle4.make
			create l_twiddle5.make
			create l_twiddle6.make
			create l_scratch.make
			create l_in.make
			create l_out.make

			l_nf := a_wavetable.item.nf
			l_product := (1).to_natural_32
			l_state := (0).to_natural_32
			l_scratch.ce_gets (a_work.item.scratch)
			l_in.ce_gets (a_data)
			l_istride := a_stride
			l_out.ce_gets (l_scratch)
			l_ostride := (1).to_natural_32
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("length n must be positive integer"), ce_string ("c_main.c"), 107, 1)
					Result := 1
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_n = {NATURAL_32} 1) then
				Result := 0
				js.return
			end
			if not js.return_called and then (a_n /= a_wavetable.item.n) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("wavetable does not match length of data"), ce_string ("c_main.c"), 117, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_n /= a_work.item.n) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("workspace does not match length of data"), ce_string ("c_main.c"), 122, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_nf)
				loop
					l_factor := a_wavetable.item.factor[l_i.to_integer_32]
					l_product := l_product * l_factor
					l_q___3 := a_n // l_product
					if l_state = {NATURAL_32} 0 then
						l_in.ce_gets (a_data)
						l_istride := a_stride
						l_out.ce_gets (l_scratch)
						l_ostride := (1).to_natural_32
						l_state := (1).to_natural_32
					else
						l_in.ce_gets (l_scratch)
						l_istride := (1).to_natural_32
						l_out.ce_gets (a_data)
						l_ostride := a_stride
						l_state := (0).to_natural_32
					end
					if l_factor = {NATURAL_32} 2 then
						l_twiddle1.ce_gets (a_wavetable.item.twiddle[l_i.to_integer_32])
						c_pass_2_inst.fft_complex_pass_2 (l_in, l_istride, l_out, l_ostride, a_sign, l_product, a_n, l_twiddle1).do_nothing
					elseif l_factor = {NATURAL_32} 3 then
						l_twiddle1.ce_gets (a_wavetable.item.twiddle[l_i.to_integer_32])
						l_twiddle2.ce_gets (l_twiddle1 + l_q___3.to_integer_32)
						c_pass_3_inst.fft_complex_pass_3 (l_in, l_istride, l_out, l_ostride, a_sign, l_product, a_n, l_twiddle1, l_twiddle2).do_nothing
					elseif l_factor = {NATURAL_32} 4 then
						l_twiddle1.ce_gets (a_wavetable.item.twiddle[l_i.to_integer_32])
						l_twiddle2.ce_gets (l_twiddle1 + l_q___3.to_integer_32)
						l_twiddle3.ce_gets (l_twiddle2 + l_q___3.to_integer_32)
						c_pass_4_inst.fft_complex_pass_4 (l_in, l_istride, l_out, l_ostride, a_sign, l_product, a_n, l_twiddle1, l_twiddle2, l_twiddle3).do_nothing
					elseif l_factor = {NATURAL_32} 5 then
						l_twiddle1.ce_gets (a_wavetable.item.twiddle[l_i.to_integer_32])
						l_twiddle2.ce_gets (l_twiddle1 + l_q___3.to_integer_32)
						l_twiddle3.ce_gets (l_twiddle2 + l_q___3.to_integer_32)
						l_twiddle4.ce_gets (l_twiddle3 + l_q___3.to_integer_32)
						c_pass_5_inst.fft_complex_pass_5 (l_in, l_istride, l_out, l_ostride, a_sign, l_product, a_n, l_twiddle1, l_twiddle2, l_twiddle3, l_twiddle4).do_nothing
					elseif l_factor = {NATURAL_32} 6 then
						l_twiddle1.ce_gets (a_wavetable.item.twiddle[l_i.to_integer_32])
						l_twiddle2.ce_gets (l_twiddle1 + l_q___3.to_integer_32)
						l_twiddle3.ce_gets (l_twiddle2 + l_q___3.to_integer_32)
						l_twiddle4.ce_gets (l_twiddle3 + l_q___3.to_integer_32)
						l_twiddle5.ce_gets (l_twiddle4 + l_q___3.to_integer_32)
						c_pass_6_inst.fft_complex_pass_6 (l_in, l_istride, l_out, l_ostride, a_sign, l_product, a_n, l_twiddle1, l_twiddle2, l_twiddle3, l_twiddle4, l_twiddle5).do_nothing
					elseif l_factor = {NATURAL_32} 7 then
						l_twiddle1.ce_gets (a_wavetable.item.twiddle[l_i.to_integer_32])
						l_twiddle2.ce_gets (l_twiddle1 + l_q___3.to_integer_32)
						l_twiddle3.ce_gets (l_twiddle2 + l_q___3.to_integer_32)
						l_twiddle4.ce_gets (l_twiddle3 + l_q___3.to_integer_32)
						l_twiddle5.ce_gets (l_twiddle4 + l_q___3.to_integer_32)
						l_twiddle6.ce_gets (l_twiddle5 + l_q___3.to_integer_32)
						c_pass_7_inst.fft_complex_pass_7 (l_in, l_istride, l_out, l_ostride, a_sign, l_product, a_n, l_twiddle1, l_twiddle2, l_twiddle3, l_twiddle4, l_twiddle5, l_twiddle6).do_nothing
					else
						l_twiddle1.ce_gets (a_wavetable.item.twiddle[l_i.to_integer_32])
						c_pass_n_inst.fft_complex_pass_n (l_in, l_istride, l_out, l_ostride, a_sign, l_factor, l_product, a_n, l_twiddle1).do_nothing
					end
					l_i := l_i + 1
				end
				if l_state = {NATURAL_32} 1 then
					l_i := (0).to_natural_32
					from
					until
						not (l_i < a_n)
					loop
						a_data[(({NATURAL_32} 2 * a_stride) * l_i).to_integer_32] := l_scratch[({NATURAL_32} 2 * l_i).to_integer_32]
						a_data[(({NATURAL_32} 2 * a_stride) * l_i + {NATURAL_32} 1).to_integer_32] := l_scratch[({NATURAL_32} 2 * l_i + {NATURAL_32} 1).to_integer_32]
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

	gsl_fft_complex_float_forward (a_data: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32; a_wavetable: CE_POINTER [PD_GSL_FFT_COMPLEX_WAVETABLE_FLOAT]; a_work: CE_POINTER [PD_GSL_FFT_COMPLEX_WORKSPACE_FLOAT]): INTEGER_32
		local
			l_sign: INTEGER_32
			l_status: INTEGER_32
		do
			l_sign := -1
			l_status := (gsl_fft_complex_float_transform (a_data, a_stride, a_n, a_wavetable, a_work, l_sign))
			Result := l_status
		end

	gsl_fft_complex_float_backward (a_data: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32; a_wavetable: CE_POINTER [PD_GSL_FFT_COMPLEX_WAVETABLE_FLOAT]; a_work: CE_POINTER [PD_GSL_FFT_COMPLEX_WORKSPACE_FLOAT]): INTEGER_32
		local
			l_sign: INTEGER_32
			l_status: INTEGER_32
		do
			l_sign := {PC_GSL_FFT_DIRECTION}.gsl_fft_backward
			l_status := (gsl_fft_complex_float_transform (a_data, a_stride, a_n, a_wavetable, a_work, l_sign))
			Result := l_status
		end

	gsl_fft_complex_float_inverse (a_data: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32; a_wavetable: CE_POINTER [PD_GSL_FFT_COMPLEX_WAVETABLE_FLOAT]; a_work: CE_POINTER [PD_GSL_FFT_COMPLEX_WORKSPACE_FLOAT]): INTEGER_32
		local
			l_sign: INTEGER_32
			l_status: INTEGER_32
			l_norm___0: REAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_sign := {PC_GSL_FFT_DIRECTION}.gsl_fft_backward
			l_status := (gsl_fft_complex_float_transform (a_data, a_stride, a_n, a_wavetable, a_work, l_sign))
			if l_status.to_boolean then
				Result := l_status
				js.return
			end
			if not js.return_called then
				l_norm___0 := {REAL_32} 1.0 / a_n.to_real_32
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					a_data[(({NATURAL_32} 2 * a_stride) * l_i).to_integer_32] := a_data[(({NATURAL_32} 2 * a_stride) * l_i).to_integer_32] * l_norm___0
					a_data[(({NATURAL_32} 2 * a_stride) * l_i + {NATURAL_32} 1).to_integer_32] := a_data[(({NATURAL_32} 2 * a_stride) * l_i + {NATURAL_32} 1).to_integer_32] * l_norm___0
					l_i := l_i + 1
				end
				Result := l_status
			end
		end

	gsl_fft_complex_float_transform (a_data: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32; a_wavetable: CE_POINTER [PD_GSL_FFT_COMPLEX_WAVETABLE_FLOAT]; a_work: CE_POINTER [PD_GSL_FFT_COMPLEX_WORKSPACE_FLOAT]; a_sign: INTEGER_32): INTEGER_32
		local
			l_nf: NATURAL_32
			l_i: NATURAL_32
			l_q___3: NATURAL_32
			l_product: NATURAL_32
			l_twiddle1: CE_POINTER [PD_GSL_COMPLEX_FLOAT]
			l_twiddle2: CE_POINTER [PD_GSL_COMPLEX_FLOAT]
			l_twiddle3: CE_POINTER [PD_GSL_COMPLEX_FLOAT]
			l_twiddle4: CE_POINTER [PD_GSL_COMPLEX_FLOAT]
			l_twiddle5: CE_POINTER [PD_GSL_COMPLEX_FLOAT]
			l_twiddle6: CE_POINTER [PD_GSL_COMPLEX_FLOAT]
			l_state: NATURAL_32
			l_scratch: CE_POINTER [REAL_32]
			l_in: CE_POINTER [REAL_32]
			l_istride: NATURAL_32
			l_out: CE_POINTER [REAL_32]
			l_ostride: NATURAL_32
			l_factor: NATURAL_32
			js: JUMP_STATE
		do
			create l_twiddle1.make
			create l_twiddle2.make
			create l_twiddle3.make
			create l_twiddle4.make
			create l_twiddle5.make
			create l_twiddle6.make
			create l_scratch.make
			create l_in.make
			create l_out.make

			l_nf := a_wavetable.item.nf
			l_product := (1).to_natural_32
			l_state := (0).to_natural_32
			l_scratch.ce_gets (a_work.item.scratch)
			l_in.ce_gets (a_data)
			l_istride := a_stride
			l_out.ce_gets (l_scratch)
			l_ostride := (1).to_natural_32
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("length n must be positive integer"), ce_string ("c_main.c"), 107, 1)
					Result := 1
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_n = {NATURAL_32} 1) then
				Result := 0
				js.return
			end
			if not js.return_called and then (a_n /= a_wavetable.item.n) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("wavetable does not match length of data"), ce_string ("c_main.c"), 117, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_n /= a_work.item.n) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("workspace does not match length of data"), ce_string ("c_main.c"), 122, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_nf)
				loop
					l_factor := a_wavetable.item.factor[l_i.to_integer_32]
					l_product := l_product * l_factor
					l_q___3 := a_n // l_product
					if l_state = {NATURAL_32} 0 then
						l_in.ce_gets (a_data)
						l_istride := a_stride
						l_out.ce_gets (l_scratch)
						l_ostride := (1).to_natural_32
						l_state := (1).to_natural_32
					else
						l_in.ce_gets (l_scratch)
						l_istride := (1).to_natural_32
						l_out.ce_gets (a_data)
						l_ostride := a_stride
						l_state := (0).to_natural_32
					end
					if l_factor = {NATURAL_32} 2 then
						l_twiddle1.ce_gets (a_wavetable.item.twiddle[l_i.to_integer_32])
						c_pass_2_inst.fft_complex_float_pass_2 (l_in, l_istride, l_out, l_ostride, a_sign, l_product, a_n, l_twiddle1).do_nothing
					elseif l_factor = {NATURAL_32} 3 then
						l_twiddle1.ce_gets (a_wavetable.item.twiddle[l_i.to_integer_32])
						l_twiddle2.ce_gets (l_twiddle1 + l_q___3.to_integer_32)
						c_pass_3_inst.fft_complex_float_pass_3 (l_in, l_istride, l_out, l_ostride, a_sign, l_product, a_n, l_twiddle1, l_twiddle2).do_nothing
					elseif l_factor = {NATURAL_32} 4 then
						l_twiddle1.ce_gets (a_wavetable.item.twiddle[l_i.to_integer_32])
						l_twiddle2.ce_gets (l_twiddle1 + l_q___3.to_integer_32)
						l_twiddle3.ce_gets (l_twiddle2 + l_q___3.to_integer_32)
						c_pass_4_inst.fft_complex_float_pass_4 (l_in, l_istride, l_out, l_ostride, a_sign, l_product, a_n, l_twiddle1, l_twiddle2, l_twiddle3).do_nothing
					elseif l_factor = {NATURAL_32} 5 then
						l_twiddle1.ce_gets (a_wavetable.item.twiddle[l_i.to_integer_32])
						l_twiddle2.ce_gets (l_twiddle1 + l_q___3.to_integer_32)
						l_twiddle3.ce_gets (l_twiddle2 + l_q___3.to_integer_32)
						l_twiddle4.ce_gets (l_twiddle3 + l_q___3.to_integer_32)
						c_pass_5_inst.fft_complex_float_pass_5 (l_in, l_istride, l_out, l_ostride, a_sign, l_product, a_n, l_twiddle1, l_twiddle2, l_twiddle3, l_twiddle4).do_nothing
					elseif l_factor = {NATURAL_32} 6 then
						l_twiddle1.ce_gets (a_wavetable.item.twiddle[l_i.to_integer_32])
						l_twiddle2.ce_gets (l_twiddle1 + l_q___3.to_integer_32)
						l_twiddle3.ce_gets (l_twiddle2 + l_q___3.to_integer_32)
						l_twiddle4.ce_gets (l_twiddle3 + l_q___3.to_integer_32)
						l_twiddle5.ce_gets (l_twiddle4 + l_q___3.to_integer_32)
						c_pass_6_inst.fft_complex_float_pass_6 (l_in, l_istride, l_out, l_ostride, a_sign, l_product, a_n, l_twiddle1, l_twiddle2, l_twiddle3, l_twiddle4, l_twiddle5).do_nothing
					elseif l_factor = {NATURAL_32} 7 then
						l_twiddle1.ce_gets (a_wavetable.item.twiddle[l_i.to_integer_32])
						l_twiddle2.ce_gets (l_twiddle1 + l_q___3.to_integer_32)
						l_twiddle3.ce_gets (l_twiddle2 + l_q___3.to_integer_32)
						l_twiddle4.ce_gets (l_twiddle3 + l_q___3.to_integer_32)
						l_twiddle5.ce_gets (l_twiddle4 + l_q___3.to_integer_32)
						l_twiddle6.ce_gets (l_twiddle5 + l_q___3.to_integer_32)
						c_pass_7_inst.fft_complex_float_pass_7 (l_in, l_istride, l_out, l_ostride, a_sign, l_product, a_n, l_twiddle1, l_twiddle2, l_twiddle3, l_twiddle4, l_twiddle5, l_twiddle6).do_nothing
					else
						l_twiddle1.ce_gets (a_wavetable.item.twiddle[l_i.to_integer_32])
						c_pass_n_inst.fft_complex_float_pass_n (l_in, l_istride, l_out, l_ostride, a_sign, l_factor, l_product, a_n, l_twiddle1).do_nothing
					end
					l_i := l_i + 1
				end
				if l_state = {NATURAL_32} 1 then
					l_i := (0).to_natural_32
					from
					until
						not (l_i < a_n)
					loop
						a_data[(({NATURAL_32} 2 * a_stride) * l_i).to_integer_32] := l_scratch[({NATURAL_32} 2 * l_i).to_integer_32]
						a_data[(({NATURAL_32} 2 * a_stride) * l_i + {NATURAL_32} 1).to_integer_32] := l_scratch[({NATURAL_32} 2 * l_i + {NATURAL_32} 1).to_integer_32]
						l_i := l_i + 1
					end
				end
				Result := 0
			end
		end

end
