class
	P_CALLOC_RANGE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_histogram_calloc_range (a_n: NATURAL_32; a_range: CE_POINTER [REAL_64]): CE_POINTER [PD_GSL_HISTOGRAM]
		local
			l_i: NATURAL_32
			l_h: CE_POINTER [PD_GSL_HISTOGRAM]
			js: JUMP_STATE
		do
			create l_h.make

			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("histogram length n must be positive integer"), ce_string ("calloc_range.c"), 46, 1)
					Result := (create {CE_POINTER [PD_GSL_HISTOGRAM]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					if a_range[l_i.to_integer_32] >= a_range[(l_i + {NATURAL_32} 1).to_integer_32] then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("histogram bin extremes  must be in increasing order"), ce_string ("calloc_range.c"), 56, 1)
							Result := (create {CE_POINTER [PD_GSL_HISTOGRAM]}.make_shared (default_pointer))
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				l_h.ce_gets (create {CE_POINTER [PD_GSL_HISTOGRAM]}.make_cast ((malloc ({PD_GSL_HISTOGRAM}.sizeof.to_natural_32))))
				if (l_h.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram struct"), ce_string ("calloc_range.c"), 67, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_h.item.range := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((a_n + {NATURAL_32} 1) * Real_64_bytes.to_natural_32)))
				if ((l_h.item.range).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_h))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram ranges"), ce_string ("calloc_range.c"), 77, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_h.item.bin := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_n * Real_64_bytes.to_natural_32)))
				if ((l_h.item.bin).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_h.item.range))
					free (create {CE_POINTER [ANY]}.make_cast (l_h))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram bins"), ce_string ("calloc_range.c"), 88, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i <= a_n)
				loop
					l_h.item.range[l_i.to_integer_32] := a_range[l_i.to_integer_32]
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_h.item.bin[l_i.to_integer_32] := (0).to_double
					l_i := l_i + 1
				end
				l_h.item.n := a_n
				Result := l_h
			end
		end

end
