class
	P_CALLOC_RANGE2D

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_histogram2d_calloc_range (a_nx: NATURAL_32; a_ny: NATURAL_32; a_xrange: CE_POINTER [REAL_64]; a_yrange: CE_POINTER [REAL_64]): CE_POINTER [PD_GSL_HISTOGRAM2D]
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_h: CE_POINTER [PD_GSL_HISTOGRAM2D]
			js: JUMP_STATE
		do
			create l_h.make

			if a_nx = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("histogram length nx must be positive integer"), ce_string ("calloc_range2d.c"), 51, 1)
					Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_ny = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("histogram length ny must be positive integer"), ce_string ("calloc_range2d.c"), 57, 1)
					Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_nx))
				loop
					if a_xrange[l_i.to_integer_32] >= a_xrange[(l_i + {NATURAL_32} 1).to_integer_32] then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("histogram xrange not in increasing order"), ce_string ("calloc_range2d.c"), 67, 1)
							Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < a_ny))
				loop
					if a_yrange[l_j.to_integer_32] >= a_yrange[(l_j + {NATURAL_32} 1).to_integer_32] then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("histogram yrange not in increasing order"), ce_string ("calloc_range2d.c"), 76, 1)
							Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
			end
			if not js.return_called then
				l_h.ce_gets (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_cast ((malloc ({PD_GSL_HISTOGRAM2D}.sizeof.to_natural_32))))
				if (l_h.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram struct"), ce_string ("calloc_range2d.c"), 87, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_h.item.xrange := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((a_nx + {NATURAL_32} 1) * Real_64_bytes.to_natural_32)))
				if ((l_h.item.xrange).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_h))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram xrange"), ce_string ("calloc_range2d.c"), 98, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_h.item.yrange := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((a_ny + {NATURAL_32} 1) * Real_64_bytes.to_natural_32)))
				if ((l_h.item.yrange).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_h))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram yrange"), ce_string ("calloc_range2d.c"), 109, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_h.item.bin := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((a_nx * a_ny) * Real_64_bytes.to_natural_32)))
				if ((l_h.item.bin).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_h.item.xrange))
					free (create {CE_POINTER [ANY]}.make_cast (l_h.item.yrange))
					free (create {CE_POINTER [ANY]}.make_cast (l_h))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram bins"), ce_string ("calloc_range2d.c"), 122, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i <= a_nx)
				loop
					l_h.item.xrange[l_i.to_integer_32] := a_xrange[l_i.to_integer_32]
					l_i := l_i + 1
				end
				l_j := (0).to_natural_32
				from
				until
					not (l_j <= a_ny)
				loop
					l_h.item.yrange[l_j.to_integer_32] := a_yrange[l_j.to_integer_32]
					l_j := l_j + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_nx))
				loop
					l_j := (0).to_natural_32
					from
					until
						not (l_j < a_ny)
					loop
						l_h.item.bin[(l_i * a_ny + l_j).to_integer_32] := (0).to_double
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				l_h.item.nx := a_nx
				l_h.item.ny := a_ny
				Result := l_h
			end
		end

end
