class
	P_CAXPY

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_caxpy (a_N: INTEGER_32; a_alpha: CE_POINTER [ANY]; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32; a_Y: CE_POINTER [ANY]; a_incY: INTEGER_32)
		local
			l_i: INTEGER_32
			l_ix: INTEGER_32
			l_tmp: INTEGER_32
			l_iy: INTEGER_32
			l_tmp___0: INTEGER_32
			l_alpha_real: REAL_32
			l_alpha_imag: REAL_32
			l_x_real: REAL_32
			l_x_imag: REAL_32
			js: JUMP_STATE
		do
			if a_incX > 0 then
				l_tmp := 0
			else
				l_tmp := (a_N - 1) * -a_incX
			end
			l_ix := l_tmp
			if a_incY > 0 then
				l_tmp___0 := 0
			else
				l_tmp___0 := (a_N - 1) * -a_incY
			end
			l_iy := l_tmp___0
			l_alpha_real := create {CE_POINTER [REAL_32]}.make_cast (a_alpha)[0]
			l_alpha_imag := create {CE_POINTER [REAL_32]}.make_cast (a_alpha)[1]
			if (fabs (l_alpha_real.to_double)) = (0).to_double then
				if (fabs (l_alpha_imag.to_double)) = (0).to_double then
					js.return
				end
			end
			if not js.return_called then
				l_i := 0
				from
				until
					not (l_i < a_N)
				loop
					l_x_real := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix]
					l_x_imag := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix + 1)]
					create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy] + (l_alpha_real * l_x_real - l_alpha_imag * l_x_imag)
					create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy + 1)] + (l_alpha_real * l_x_imag + l_alpha_imag * l_x_real)
					l_ix := l_ix + a_incX
					l_iy := l_iy + a_incY
					l_i := l_i + 1
				end
			end
		end

end
