class
	P_CGBMV

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_cgbmv (a_order: INTEGER_32; a_TransA: INTEGER_32; a_M: INTEGER_32; a_N: INTEGER_32; a_KL: INTEGER_32; a_KU: INTEGER_32; a_alpha: CE_POINTER [ANY]; a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32; a_beta: CE_POINTER [ANY]; a_Y: CE_POINTER [ANY]; a_incY: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_lenX: INTEGER_32
			l_lenY: INTEGER_32
			l_L: INTEGER_32
			l_U: INTEGER_32
			l_alpha_real: REAL_32
			l_alpha_imag: REAL_32
			l_beta_real: REAL_32
			l_beta_imag: REAL_32
			l_iy: INTEGER_32
			l_tmp: INTEGER_32
			l_iy___0: INTEGER_32
			l_tmp___0: INTEGER_32
			l_y_real: REAL_32
			l_y_imag: REAL_32
			l_tmpR: REAL_32
			l_tmpI: REAL_32
			l_iy___1: INTEGER_32
			l_tmp___1: INTEGER_32
			l_dotR: REAL_32
			l_dotI: REAL_32
			l_j_min: INTEGER_32
			l_tmp___2: INTEGER_32
			l_j_max: INTEGER_32
			l_tmp___3: INTEGER_32
			l_ix: INTEGER_32
			l_tmp___4: INTEGER_32
			l_x_real: REAL_32
			l_x_imag: REAL_32
			l_A_real: REAL_32
			l_A_imag: REAL_32
			l_ix___0: INTEGER_32
			l_tmp___5: INTEGER_32
			l_x_real___0: REAL_32
			l_x_imag___0: REAL_32
			l_tmpR___0: REAL_32
			l_tmpI___0: REAL_32
			l_i_min: INTEGER_32
			l_tmp___6: INTEGER_32
			l_i_max: INTEGER_32
			l_tmp___7: INTEGER_32
			l_iy___2: INTEGER_32
			l_tmp___8: INTEGER_32
			l_A_real___0: REAL_32
			l_A_imag___0: REAL_32
			l_ix___1: INTEGER_32
			l_tmp___9: INTEGER_32
			l_x_real___1: REAL_32
			l_x_imag___1: REAL_32
			l_tmpR___1: REAL_32
			l_tmpI___1: REAL_32
			l_i_min___0: INTEGER_32
			l_tmp___10: INTEGER_32
			l_i_max___0: INTEGER_32
			l_tmp___11: INTEGER_32
			l_iy___3: INTEGER_32
			l_tmp___12: INTEGER_32
			l_A_real___1: REAL_32
			l_A_imag___1: REAL_32
			l_iy___4: INTEGER_32
			l_tmp___13: INTEGER_32
			l_dotR___0: REAL_32
			l_dotI___0: REAL_32
			l_j_min___0: INTEGER_32
			l_tmp___14: INTEGER_32
			l_j_max___0: INTEGER_32
			l_tmp___15: INTEGER_32
			l_ix___2: INTEGER_32
			l_tmp___16: INTEGER_32
			l_x_real___2: REAL_32
			l_x_imag___2: REAL_32
			l_A_real___2: REAL_32
			l_A_imag___2: REAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_alpha_real := create {CE_POINTER [REAL_32]}.make_cast (a_alpha)[0]
					l_alpha_imag := create {CE_POINTER [REAL_32]}.make_cast (a_alpha)[1]
					l_beta_real := create {CE_POINTER [REAL_32]}.make_cast (a_beta)[0]
					l_beta_imag := create {CE_POINTER [REAL_32]}.make_cast (a_beta)[1]
					if a_M = 0 then
						js.return
					elseif a_N = 0 then
						js.return
					end
					if not js.return_called and then (l_alpha_real.to_double = 0.0) then
						if l_alpha_imag.to_double = 0.0 then
							if l_beta_real.to_double = 1.0 then
								if l_beta_imag.to_double = 0.0 then
									js.return
								end
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if a_TransA.to_natural_32 = {NATURAL_32} 111 then
							l_lenX := a_N
							l_lenY := a_M
							l_L := a_KL
							l_U := a_KU
						else
							l_lenX := a_M
							l_lenY := a_N
							l_L := a_KU
							l_U := a_KL
						end
						if l_beta_real.to_double /= 0.0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_beta_imag.to_double = 0.0 then
							if a_incY > 0 then
								l_tmp := 0
							else
								l_tmp := (l_lenY - 1) * -a_incY
							end
							l_iy := l_tmp
							l_i := 0
							from
							until
								not (l_i < l_lenY)
							loop
								create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy] := (0.0).truncated_to_real
								create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy + 1)] := (0.0).truncated_to_real
								l_iy := l_iy + a_incY
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if l_beta_real.to_double /= 1.0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_beta_imag.to_double /= 0.0 then
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if a_incY > 0 then
							l_tmp___0 := 0
						else
							l_tmp___0 := (l_lenY - 1) * -a_incY
						end
						l_iy___0 := l_tmp___0
						l_i := 0
						from
						until
							not (l_i < l_lenY)
						loop
							l_y_real := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___0]
							l_y_imag := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___0 + 1)]
							l_tmpR := l_y_real * l_beta_real - l_y_imag * l_beta_imag
							l_tmpI := l_y_real * l_beta_imag + l_y_imag * l_beta_real
							create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___0] := l_tmpR
							create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___0 + 1)] := l_tmpI
							l_iy___0 := l_iy___0 + a_incY
							l_i := l_i + 1
						end
				when 8 then -- if done
						if l_alpha_real.to_double = 0.0 then
							if l_alpha_imag.to_double = 0.0 then
								js.return
							end
						end
				when 9 then -- if done
					if js.return_called then
						l_pos := -1 + 47 -- skip if block
					end
				when 10 then -- if:
						if a_order.to_natural_32 /= {NATURAL_32} 101 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if a_TransA.to_natural_32 = {NATURAL_32} 111 then
							l_pos := -1 + 15 -- goto _L___7
						else
							l_pos := -1 + 13 -- goto _L___9
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 13 then -- else: | _L___9:
						if a_order.to_natural_32 /= {NATURAL_32} 102 then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						if a_TransA.to_natural_32 /= {NATURAL_32} 112 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if: | _L___7:
						if a_incY > 0 then
							l_tmp___1 := 0
						else
							l_tmp___1 := (l_lenY - 1) * -a_incY
						end
						l_iy___1 := l_tmp___1
						l_i := 0
						from
						until
							not (not js.loop_left and then (l_i < l_lenY))
						loop
							l_dotR := (0.0).truncated_to_real
							l_dotI := (0.0).truncated_to_real
							if l_i > l_L then
								l_tmp___2 := l_i - l_L
							else
								l_tmp___2 := 0
							end
							l_j_min := l_tmp___2
							if l_lenX < (l_i + l_U) + 1 then
								l_tmp___3 := l_lenX
							else
								l_tmp___3 := (l_i + l_U) + 1
							end
							l_j_max := l_tmp___3
							if a_incX > 0 then
								l_tmp___4 := 0
							else
								l_tmp___4 := (l_lenX - 1) * -a_incX
							end
							l_ix := l_tmp___4 + l_j_min * a_incX
							l_j := l_j_min
							from
							until
								not (l_j < l_j_max)
							loop
								l_x_real := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix]
								l_x_imag := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix + 1)]
								l_A_real := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (a_lda * l_i + ((l_L + l_j) - l_i))]
								l_A_imag := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (a_lda * l_i + ((l_L + l_j) - l_i)) + 1)]
								l_dotR := l_dotR + (l_A_real * l_x_real - l_A_imag * l_x_imag)
								l_dotI := l_dotI + (l_A_real * l_x_imag + l_A_imag * l_x_real)
								l_ix := l_ix + a_incX
								l_j := l_j + 1
							end
							create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___1] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___1] + (l_alpha_real * l_dotR - l_alpha_imag * l_dotI)
							create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___1 + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___1 + 1)] + (l_alpha_real * l_dotI + l_alpha_imag * l_dotR)
							l_iy___1 := l_iy___1 + a_incY
							l_i := l_i + 1
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						l_pos := -1 + 19 -- goto _L___8
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 47
				when 19 then -- else: | _L___8:
						if a_order.to_natural_32 /= {NATURAL_32} 101 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if a_TransA.to_natural_32 = {NATURAL_32} 112 then
							l_pos := -1 + 24 -- goto _L___4
						else
							l_pos := -1 + 22 -- goto _L___6
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 22 then -- else: | _L___6:
						if a_order.to_natural_32 /= {NATURAL_32} 102 then
							l_pos := -1 + 34 -- skip if block
						end
				when 23 then -- if:
						if a_TransA.to_natural_32 /= {NATURAL_32} 111 then
							l_pos := -1 + 32 -- skip if block
						end
				when 24 then -- if: | _L___4:
						if a_incX > 0 then
							l_tmp___5 := 0
						else
							l_tmp___5 := (l_lenX - 1) * -a_incX
						end
						l_ix___0 := l_tmp___5
						l_j := 0
				when 25 then -- loop condition:
						if not (not js.loop_left and then (l_j < l_lenX)) then
							l_pos := -1 + 31 -- skip loop
						end
				when 26 then -- loop body:
						l_x_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix___0]
						l_x_imag___0 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix___0 + 1)]
						l_tmpR___0 := l_alpha_real * l_x_real___0 - l_alpha_imag * l_x_imag___0
						l_tmpI___0 := l_alpha_real * l_x_imag___0 + l_alpha_imag * l_x_real___0
						if l_tmpR___0.to_double /= 0.0 then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						if l_tmpI___0.to_double /= 0.0 then
							l_pos := -1 + 29 -- goto _L___1
						end
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else: | _L___1:
						if l_j > l_U then
							l_tmp___6 := l_j - l_U
						else
							l_tmp___6 := 0
						end
						l_i_min := l_tmp___6
						if l_lenY < (l_j + l_L) + 1 then
							l_tmp___7 := l_lenY
						else
							l_tmp___7 := (l_j + l_L) + 1
						end
						l_i_max := l_tmp___7
						if a_incY > 0 then
							l_tmp___8 := 0
						else
							l_tmp___8 := (l_lenY - 1) * -a_incY
						end
						l_iy___2 := l_tmp___8 + l_i_min * a_incY
						l_i := l_i_min
						from
						until
							not (l_i < l_i_max)
						loop
							l_A_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (a_lda * l_j + ((l_U + l_i) - l_j))]
							l_A_imag___0 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (a_lda * l_j + ((l_U + l_i) - l_j)) + 1)]
							create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___2] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___2] + (l_A_real___0 * l_tmpR___0 - l_A_imag___0 * l_tmpI___0)
							create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___2 + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___2 + 1)] + (l_A_real___0 * l_tmpI___0 + l_A_imag___0 * l_tmpR___0)
							l_iy___2 := l_iy___2 + a_incY
							l_i := l_i + 1
						end
				when 30 then
						l_ix___0 := l_ix___0 + a_incX
						l_j := l_j + 1
						l_pos := -1 + 25 -- back to loop condition
				when 31 then -- loop done | if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else:
						l_pos := -1 + 34 -- goto _L___5
				when 33 then -- if done | if block done, skip else block:
						l_pos := -1 + 47
				when 34 then -- else: | _L___5:
						if a_order.to_natural_32 /= {NATURAL_32} 101 then
							l_pos := -1 + 46 -- skip if block
						end
				when 35 then -- if:
						if a_TransA.to_natural_32 /= {NATURAL_32} 113 then
							l_pos := -1 + 44 -- skip if block
						end
				when 36 then -- if:
						if a_incX > 0 then
							l_tmp___9 := 0
						else
							l_tmp___9 := (l_lenX - 1) * -a_incX
						end
						l_ix___1 := l_tmp___9
						l_j := 0
				when 37 then -- loop condition:
						if not (not js.loop_left and then (l_j < l_lenX)) then
							l_pos := -1 + 43 -- skip loop
						end
				when 38 then -- loop body:
						l_x_real___1 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix___1]
						l_x_imag___1 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix___1 + 1)]
						l_tmpR___1 := l_alpha_real * l_x_real___1 - l_alpha_imag * l_x_imag___1
						l_tmpI___1 := l_alpha_real * l_x_imag___1 + l_alpha_imag * l_x_real___1
						if l_tmpR___1.to_double /= 0.0 then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						if l_tmpI___1.to_double /= 0.0 then
							l_pos := -1 + 41 -- goto _L___2
						end
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else: | _L___2:
						if l_j > l_U then
							l_tmp___10 := l_j - l_U
						else
							l_tmp___10 := 0
						end
						l_i_min___0 := l_tmp___10
						if l_lenY < (l_j + l_L) + 1 then
							l_tmp___11 := l_lenY
						else
							l_tmp___11 := (l_j + l_L) + 1
						end
						l_i_max___0 := l_tmp___11
						if a_incY > 0 then
							l_tmp___12 := 0
						else
							l_tmp___12 := (l_lenY - 1) * -a_incY
						end
						l_iy___3 := l_tmp___12 + l_i_min___0 * a_incY
						l_i := l_i_min___0
						from
						until
							not (l_i < l_i_max___0)
						loop
							l_A_real___1 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (a_lda * l_j + ((l_U + l_i) - l_j))]
							l_A_imag___1 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (a_lda * l_j + ((l_U + l_i) - l_j)) + 1)]
							create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___3] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___3] + (l_A_real___1 * l_tmpR___1 - -l_A_imag___1 * l_tmpI___1)
							create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___3 + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___3 + 1)] + (l_A_real___1 * l_tmpI___1 + -l_A_imag___1 * l_tmpR___1)
							l_iy___3 := l_iy___3 + a_incY
							l_i := l_i + 1
						end
				when 42 then
						l_ix___1 := l_ix___1 + a_incX
						l_j := l_j + 1
						l_pos := -1 + 37 -- back to loop condition
				when 43 then -- loop done | if block done, skip else block:
						l_pos := -1 + 45
				when 44 then -- else:
						l_pos := -1 + 46 -- goto _L___3
				when 45 then -- if done | if block done, skip else block:
						l_pos := -1 + 47
				when 46 then -- else: | _L___3:
						if a_order.to_natural_32 = {NATURAL_32} 102 then
							if a_TransA.to_natural_32 = {NATURAL_32} 113 then
								if a_incY > 0 then
									l_tmp___13 := 0
								else
									l_tmp___13 := (l_lenY - 1) * -a_incY
								end
								l_iy___4 := l_tmp___13
								l_i := 0
								from
								until
									not (not js.loop_left and then (l_i < l_lenY))
								loop
									l_dotR___0 := (0.0).truncated_to_real
									l_dotI___0 := (0.0).truncated_to_real
									if l_i > l_L then
										l_tmp___14 := l_i - l_L
									else
										l_tmp___14 := 0
									end
									l_j_min___0 := l_tmp___14
									if l_lenX < (l_i + l_U) + 1 then
										l_tmp___15 := l_lenX
									else
										l_tmp___15 := (l_i + l_U) + 1
									end
									l_j_max___0 := l_tmp___15
									if a_incX > 0 then
										l_tmp___16 := 0
									else
										l_tmp___16 := (l_lenX - 1) * -a_incX
									end
									l_ix___2 := l_tmp___16 + l_j_min___0 * a_incX
									l_j := l_j_min___0
									from
									until
										not (l_j < l_j_max___0)
									loop
										l_x_real___2 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix___2]
										l_x_imag___2 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix___2 + 1)]
										l_A_real___2 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (a_lda * l_i + ((l_L + l_j) - l_i))]
										l_A_imag___2 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (a_lda * l_i + ((l_L + l_j) - l_i)) + 1)]
										l_dotR___0 := l_dotR___0 + (l_A_real___2 * l_x_real___2 - -l_A_imag___2 * l_x_imag___2)
										l_dotI___0 := l_dotI___0 + (l_A_real___2 * l_x_imag___2 + -l_A_imag___2 * l_x_real___2)
										l_ix___2 := l_ix___2 + a_incX
										l_j := l_j + 1
									end
									create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___4] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___4] + (l_alpha_real * l_dotR___0 - l_alpha_imag * l_dotI___0)
									create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___4 + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___4 + 1)] + (l_alpha_real * l_dotI___0 + l_alpha_imag * l_dotR___0)
									l_iy___4 := l_iy___4 + a_incY
									l_i := l_i + 1
								end
							else
								xerbla_inst.cblas_xerbla ([0, ce_string ("source_gbmv_c.h"), ce_string ("unrecognized operation")])
							end
						else
							xerbla_inst.cblas_xerbla ([0, ce_string ("source_gbmv_c.h"), ce_string ("unrecognized operation")])
						end
				when 47 then -- if done | if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
