class
	P_CGEMV

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_cgemv (a_order: INTEGER_32; a_TransA: INTEGER_32; a_M: INTEGER_32; a_N: INTEGER_32; a_alpha: CE_POINTER [ANY]; a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32; a_beta: CE_POINTER [ANY]; a_Y: CE_POINTER [ANY]; a_incY: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_lenX: INTEGER_32
			l_lenY: INTEGER_32
			l_alpha_real: REAL_32
			l_alpha_imag: REAL_32
			l_beta_real: REAL_32
			l_beta_imag: REAL_32
			l_iy: INTEGER_32
			l_tmp: INTEGER_32
			l_iy___0: INTEGER_32
			l_tmp___0: INTEGER_32
			l_y_real: REAL_32
			l_y_imag: REAL_32
			l_tmpR: REAL_32
			l_tmpI: REAL_32
			l_iy___1: INTEGER_32
			l_tmp___1: INTEGER_32
			l_dotR: REAL_32
			l_dotI: REAL_32
			l_ix: INTEGER_32
			l_tmp___2: INTEGER_32
			l_x_real: REAL_32
			l_x_imag: REAL_32
			l_A_real: REAL_32
			l_A_imag: REAL_32
			l_ix___0: INTEGER_32
			l_tmp___3: INTEGER_32
			l_x_real___0: REAL_32
			l_x_imag___0: REAL_32
			l_tmpR___0: REAL_32
			l_tmpI___0: REAL_32
			l_iy___2: INTEGER_32
			l_tmp___4: INTEGER_32
			l_A_real___0: REAL_32
			l_A_imag___0: REAL_32
			l_ix___1: INTEGER_32
			l_tmp___5: INTEGER_32
			l_x_real___1: REAL_32
			l_x_imag___1: REAL_32
			l_tmpR___1: REAL_32
			l_tmpI___1: REAL_32
			l_iy___3: INTEGER_32
			l_tmp___6: INTEGER_32
			l_A_real___1: REAL_32
			l_A_imag___1: REAL_32
			l_iy___4: INTEGER_32
			l_tmp___7: INTEGER_32
			l_dotR___0: REAL_32
			l_dotI___0: REAL_32
			l_ix___2: INTEGER_32
			l_tmp___8: INTEGER_32
			l_x_real___2: REAL_32
			l_x_imag___2: REAL_32
			l_A_real___2: REAL_32
			l_A_imag___2: REAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_alpha_real := create {CE_POINTER [REAL_32]}.make_cast (a_alpha)[0]
					l_alpha_imag := create {CE_POINTER [REAL_32]}.make_cast (a_alpha)[1]
					l_beta_real := create {CE_POINTER [REAL_32]}.make_cast (a_beta)[0]
					l_beta_imag := create {CE_POINTER [REAL_32]}.make_cast (a_beta)[1]
					if a_M = 0 then
						js.return
					elseif a_N = 0 then
						js.return
					end
					if not js.return_called and then (l_alpha_real.to_double = 0.0) then
						if l_alpha_imag.to_double = 0.0 then
							if l_beta_real.to_double = 1.0 then
								if l_beta_imag.to_double = 0.0 then
									js.return
								end
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if a_TransA.to_natural_32 = {NATURAL_32} 111 then
							l_lenX := a_N
							l_lenY := a_M
						else
							l_lenX := a_M
							l_lenY := a_N
						end
						if l_beta_real.to_double /= 0.0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_beta_imag.to_double = 0.0 then
							if a_incY > 0 then
								l_tmp := 0
							else
								l_tmp := (l_lenY - 1) * -a_incY
							end
							l_iy := l_tmp
							l_i := 0
							from
							until
								not (l_i < l_lenY)
							loop
								create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy] := (0.0).truncated_to_real
								create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy + 1)] := (0.0).truncated_to_real
								l_iy := l_iy + a_incY
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if l_beta_real.to_double /= 1.0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_beta_imag.to_double /= 0.0 then
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if a_incY > 0 then
							l_tmp___0 := 0
						else
							l_tmp___0 := (l_lenY - 1) * -a_incY
						end
						l_iy___0 := l_tmp___0
						l_i := 0
						from
						until
							not (l_i < l_lenY)
						loop
							l_y_real := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___0]
							l_y_imag := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___0 + 1)]
							l_tmpR := l_y_real * l_beta_real - l_y_imag * l_beta_imag
							l_tmpI := l_y_real * l_beta_imag + l_y_imag * l_beta_real
							create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___0] := l_tmpR
							create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___0 + 1)] := l_tmpI
							l_iy___0 := l_iy___0 + a_incY
							l_i := l_i + 1
						end
				when 8 then -- if done
						if l_alpha_real.to_double = 0.0 then
							if l_alpha_imag.to_double = 0.0 then
								js.return
							end
						end
				when 9 then -- if done
					if js.return_called then
						l_pos := -1 + 32 -- skip if block
					end
				when 10 then -- if:
						if a_order.to_natural_32 /= {NATURAL_32} 101 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if a_TransA.to_natural_32 = {NATURAL_32} 111 then
							l_pos := -1 + 15 -- goto _L___5
						else
							l_pos := -1 + 13 -- goto _L___7
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 13 then -- else: | _L___7:
						if a_order.to_natural_32 /= {NATURAL_32} 102 then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						if a_TransA.to_natural_32 /= {NATURAL_32} 112 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if: | _L___5:
						if a_incY > 0 then
							l_tmp___1 := 0
						else
							l_tmp___1 := (l_lenY - 1) * -a_incY
						end
						l_iy___1 := l_tmp___1
						l_i := 0
						from
						until
							not (not js.loop_left and then (l_i < l_lenY))
						loop
							l_dotR := (0.0).truncated_to_real
							l_dotI := (0.0).truncated_to_real
							if a_incX > 0 then
								l_tmp___2 := 0
							else
								l_tmp___2 := (l_lenX - 1) * -a_incX
							end
							l_ix := l_tmp___2
							l_j := 0
							from
							until
								not (l_j < l_lenX)
							loop
								l_x_real := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix]
								l_x_imag := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix + 1)]
								l_A_real := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (a_lda * l_i + l_j)]
								l_A_imag := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_j) + 1)]
								l_dotR := l_dotR + (l_A_real * l_x_real - l_A_imag * l_x_imag)
								l_dotI := l_dotI + (l_A_real * l_x_imag + l_A_imag * l_x_real)
								l_ix := l_ix + a_incX
								l_j := l_j + 1
							end
							create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___1] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___1] + (l_alpha_real * l_dotR - l_alpha_imag * l_dotI)
							create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___1 + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___1 + 1)] + (l_alpha_real * l_dotI + l_alpha_imag * l_dotR)
							l_iy___1 := l_iy___1 + a_incY
							l_i := l_i + 1
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						l_pos := -1 + 19 -- goto _L___6
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 32
				when 19 then -- else: | _L___6:
						if a_order.to_natural_32 /= {NATURAL_32} 101 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if a_TransA.to_natural_32 = {NATURAL_32} 112 then
							l_pos := -1 + 24 -- goto _L___2
						else
							l_pos := -1 + 22 -- goto _L___4
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 22 then -- else: | _L___4:
						if a_order.to_natural_32 /= {NATURAL_32} 102 then
							l_pos := -1 + 28 -- skip if block
						end
				when 23 then -- if:
						if a_TransA.to_natural_32 /= {NATURAL_32} 111 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if: | _L___2:
						if a_incX > 0 then
							l_tmp___3 := 0
						else
							l_tmp___3 := (l_lenX - 1) * -a_incX
						end
						l_ix___0 := l_tmp___3
						l_j := 0
						from
						until
							not (not js.loop_left and then (l_j < l_lenX))
						loop
							l_x_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix___0]
							l_x_imag___0 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix___0 + 1)]
							l_tmpR___0 := l_alpha_real * l_x_real___0 - l_alpha_imag * l_x_imag___0
							l_tmpI___0 := l_alpha_real * l_x_imag___0 + l_alpha_imag * l_x_real___0
							if a_incY > 0 then
								l_tmp___4 := 0
							else
								l_tmp___4 := (l_lenY - 1) * -a_incY
							end
							l_iy___2 := l_tmp___4
							l_i := 0
							from
							until
								not (l_i < l_lenY)
							loop
								l_A_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (a_lda * l_j + l_i)]
								l_A_imag___0 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (a_lda * l_j + l_i) + 1)]
								create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___2] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___2] + (l_A_real___0 * l_tmpR___0 - l_A_imag___0 * l_tmpI___0)
								create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___2 + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___2 + 1)] + (l_A_real___0 * l_tmpI___0 + l_A_imag___0 * l_tmpR___0)
								l_iy___2 := l_iy___2 + a_incY
								l_i := l_i + 1
							end
							l_ix___0 := l_ix___0 + a_incX
							l_j := l_j + 1
						end
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						l_pos := -1 + 28 -- goto _L___3
				when 27 then -- if done | if block done, skip else block:
						l_pos := -1 + 32
				when 28 then -- else: | _L___3:
						if a_order.to_natural_32 /= {NATURAL_32} 101 then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						if a_TransA.to_natural_32 = {NATURAL_32} 113 then
							if a_incX > 0 then
								l_tmp___5 := 0
							else
								l_tmp___5 := (l_lenX - 1) * -a_incX
							end
							l_ix___1 := l_tmp___5
							l_j := 0
							from
							until
								not (not js.loop_left and then (l_j < l_lenX))
							loop
								l_x_real___1 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix___1]
								l_x_imag___1 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix___1 + 1)]
								l_tmpR___1 := l_alpha_real * l_x_real___1 - l_alpha_imag * l_x_imag___1
								l_tmpI___1 := l_alpha_real * l_x_imag___1 + l_alpha_imag * l_x_real___1
								if a_incY > 0 then
									l_tmp___6 := 0
								else
									l_tmp___6 := (l_lenY - 1) * -a_incY
								end
								l_iy___3 := l_tmp___6
								l_i := 0
								from
								until
									not (l_i < l_lenY)
								loop
									l_A_real___1 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (a_lda * l_j + l_i)]
									l_A_imag___1 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (a_lda * l_j + l_i) + 1)]
									create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___3] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___3] + (l_A_real___1 * l_tmpR___1 - -l_A_imag___1 * l_tmpI___1)
									create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___3 + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___3 + 1)] + (l_A_real___1 * l_tmpI___1 + -l_A_imag___1 * l_tmpR___1)
									l_iy___3 := l_iy___3 + a_incY
									l_i := l_i + 1
								end
								l_ix___1 := l_ix___1 + a_incX
								l_j := l_j + 1
							end
						else
							l_pos := -1 + 31 -- goto _L___1
						end
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 31 then -- else: | _L___1:
						if a_order.to_natural_32 = {NATURAL_32} 102 then
							if a_TransA.to_natural_32 = {NATURAL_32} 113 then
								if a_incY > 0 then
									l_tmp___7 := 0
								else
									l_tmp___7 := (l_lenY - 1) * -a_incY
								end
								l_iy___4 := l_tmp___7
								l_i := 0
								from
								until
									not (not js.loop_left and then (l_i < l_lenY))
								loop
									l_dotR___0 := (0.0).truncated_to_real
									l_dotI___0 := (0.0).truncated_to_real
									if a_incX > 0 then
										l_tmp___8 := 0
									else
										l_tmp___8 := (l_lenX - 1) * -a_incX
									end
									l_ix___2 := l_tmp___8
									l_j := 0
									from
									until
										not (l_j < l_lenX)
									loop
										l_x_real___2 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix___2]
										l_x_imag___2 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix___2 + 1)]
										l_A_real___2 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (a_lda * l_i + l_j)]
										l_A_imag___2 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_j) + 1)]
										l_dotR___0 := l_dotR___0 + (l_A_real___2 * l_x_real___2 - -l_A_imag___2 * l_x_imag___2)
										l_dotI___0 := l_dotI___0 + (l_A_real___2 * l_x_imag___2 + -l_A_imag___2 * l_x_real___2)
										l_ix___2 := l_ix___2 + a_incX
										l_j := l_j + 1
									end
									create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___4] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___4] + (l_alpha_real * l_dotR___0 - l_alpha_imag * l_dotI___0)
									create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___4 + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___4 + 1)] + (l_alpha_real * l_dotI___0 + l_alpha_imag * l_dotR___0)
									l_iy___4 := l_iy___4 + a_incY
									l_i := l_i + 1
								end
							else
								xerbla_inst.cblas_xerbla ([0, ce_string ("source_gemv_c.h"), ce_string ("unrecognized operation")])
							end
						else
							xerbla_inst.cblas_xerbla ([0, ce_string ("source_gemv_c.h"), ce_string ("unrecognized operation")])
						end
				when 32 then -- if done | if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
