class
	P_CHEB_EVAL

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cheb_eval_e (a_cs: CE_POINTER [PD_CHEB_SERIES_STRUCT]; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_j: INTEGER_32
			l_d: REAL_64
			l_dd: REAL_64
			l_y: REAL_64
			l_y2: REAL_64
			l_e: REAL_64
			l_temp: REAL_64
			l_tmp: REAL_64
			l_tmp___0: REAL_64
			l_temp___0: REAL_64
			l_tmp___2: REAL_64
			l_tmp___3: REAL_64
		do
			l_d := 0.0
			l_dd := 0.0
			l_y := ((2.0 * a_x - a_cs.item.a) - a_cs.item.b) / (a_cs.item.b - a_cs.item.a)
			l_y2 := 2.0 * l_y
			l_e := 0.0
			l_j := a_cs.item.order
			from
			until
				not (l_j >= 1)
			loop
				l_temp := l_d
				l_d := (l_y2 * l_d - l_dd) + a_cs.item.c[l_j]
				l_tmp := fabs (l_y2 * l_temp)
				l_tmp___0 := fabs (l_dd)
				l_e := l_e + ((l_tmp + l_tmp___0) + (fabs (a_cs.item.c[l_j])))
				l_dd := l_temp
				l_j := l_j - 1
			end
			l_temp___0 := l_d
			l_d := (l_y * l_d - l_dd) + 0.5 * a_cs.item.c[0]
			l_tmp___2 := fabs (l_y * l_temp___0)
			l_tmp___3 := fabs (l_dd)
			l_e := l_e + ((l_tmp___2 + l_tmp___3) + 0.5 * (fabs (a_cs.item.c[0])))
			a_result.item.val := l_d
			a_result.item.err := 2.2204460492503131e-16 * l_e + (fabs (a_cs.item.c[a_cs.item.order]))
			Result := 0
		end

end
