class
	P_CHOLESKY

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	quiet_sqrt (a_x: REAL_64): REAL_64
		local
			l_tmp___1: REAL_64
		do
			if a_x >= (0).to_double then
				l_tmp___1 := (sqrt (a_x))
			else
				l_tmp___1 := (builtin_nanf (ce_string (""))).to_double
			end
			Result := l_tmp___1
		end

	gsl_linalg_cholesky_decomp (a_A___0: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_status: INTEGER_32
			l_A_00: REAL_64
			l_L_00: REAL_64
			l_A_10: REAL_64
			l_A_11: REAL_64
			l_L_10: REAL_64
			l_diag: REAL_64
			l_L_11: REAL_64
			l_A_kk: REAL_64
			l_sum: REAL_64
			l_A_ki: REAL_64
			l_A_ii: REAL_64
			l_ci: PD_GSL_VECTOR_VIEW
			l_ck: PD_GSL_VECTOR_VIEW
			l_di: PD_GSL_VECTOR_VIEW
			l_dk: PD_GSL_VECTOR_VIEW
			l_ck___0: PD_GSL_VECTOR_VIEW
			l_dk___0: PD_GSL_VECTOR_VIEW
			l_sum___0: REAL_64
			l_diag___0: REAL_64
			l_L_kk: REAL_64
			l_A_ij: REAL_64
			js: JUMP_STATE
		do
			create l_ci.make
			create l_ck.make
			create l_di.make
			create l_dk.make
			create l_ck___0.make
			create l_dk___0.make

			l_M := a_A___0.item.size1
			l_N := a_A___0.item.size2
			if l_M /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("cholesky decomposition requires square matrix"), ce_string ("cholesky.c"), 59, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_status := 0
				l_A_00 := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (0).to_natural_32))
				l_L_00 := (quiet_sqrt (l_A_00))
				if l_A_00 <= (0).to_double then
					l_status := 1
				end
				gsl_gsl_matrix_double_inst.gsl_matrix_set (a_A___0, (0).to_natural_32, (0).to_natural_32, l_L_00)
				if l_M > {NATURAL_32} 1 then
					l_A_10 := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (0).to_natural_32))
					l_A_11 := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (1).to_natural_32))
					l_L_10 := l_A_10 / l_L_00
					l_diag := l_A_11 - l_L_10 * l_L_10
					l_L_11 := (quiet_sqrt (l_diag))
					if l_diag <= (0).to_double then
						l_status := 1
					end
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_A___0, (1).to_natural_32, (0).to_natural_32, l_L_10)
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_A___0, (1).to_natural_32, (1).to_natural_32, l_L_11)
				end
				l_k := (2).to_natural_32
				from
				until
					not (not js.loop_left and then (l_k < l_M))
				loop
					l_A_kk := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_k, l_k))
					l_i := (0).to_natural_32
					from
					until
						not (l_i < l_k)
					loop
						l_sum := (0).to_double
						l_A_ki := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_k, l_i))
						l_A_ii := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_i))
						l_ci.ce_gets ((rowcol_source_inst.gsl_matrix_row (a_A___0, l_i)))
						l_ck.ce_gets ((rowcol_source_inst.gsl_matrix_row (a_A___0, l_k)))
						if l_i > {NATURAL_32} 0 then
							l_di.ce_gets ((subvector_source_inst.gsl_vector_subvector (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_ci.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), (0).to_natural_32, l_i)))
							l_dk.ce_gets ((subvector_source_inst.gsl_vector_subvector (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_ck.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), (0).to_natural_32, l_i)))
							blas_inst.gsl_blas_ddot ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_di.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_dk.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [REAL_64]}.make_shared ($l_sum)).do_nothing
						end
						l_A_ki := (l_A_ki - l_sum) / l_A_ii
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_A___0, l_k, l_i, l_A_ki)
						l_i := l_i + 1
					end
					l_ck___0.ce_gets ((rowcol_source_inst.gsl_matrix_row (a_A___0, l_k)))
					l_dk___0.ce_gets ((subvector_source_inst.gsl_vector_subvector (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_ck___0.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), (0).to_natural_32, l_k)))
					l_sum___0 := (blas_inst.gsl_blas_dnrm2 ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_dk___0.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))))
					l_diag___0 := l_A_kk - l_sum___0 * l_sum___0
					l_L_kk := (quiet_sqrt (l_diag___0))
					if l_diag___0 <= (0).to_double then
						l_status := 1
					end
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_A___0, l_k, l_k, l_L_kk)
					l_k := l_k + 1
				end
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_j := (0).to_natural_32
					from
					until
						not (l_j < l_i)
					loop
						l_A_ij := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_j))
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_A___0, l_j, l_i, l_A_ij)
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				if l_status = 1 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("matrix must be positive definite"), ce_string ("cholesky.c"), 157, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
				if not js.return_called then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_cholesky_solve (a_LLT: CE_POINTER [PD_GSL_MATRIX]; a_b___0: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_LLT.item.size1 /= a_LLT.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("cholesky matrix must be square"), ce_string ("cholesky.c"), 172, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LLT.item.size1 /= a_b___0.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match b size"), ce_string ("cholesky.c"), 176, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LLT.item.size2 /= a_x.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match solution size"), ce_string ("cholesky.c"), 180, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				copy_source_inst.gsl_vector_memcpy (a_x, a_b___0).do_nothing
				blas_inst.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasLower, {PC_CBLAS_TRANSPOSE}.CblasNoTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_LLT, a_x).do_nothing
				blas_inst.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasUpper, {PC_CBLAS_TRANSPOSE}.CblasNoTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_LLT, a_x).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_cholesky_svx (a_LLT: CE_POINTER [PD_GSL_MATRIX]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_LLT.item.size1 /= a_LLT.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("cholesky matrix must be square"), ce_string ("cholesky.c"), 207, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LLT.item.size2 /= a_x.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match solution size"), ce_string ("cholesky.c"), 211, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				blas_inst.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasLower, {PC_CBLAS_TRANSPOSE}.CblasNoTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_LLT, a_x).do_nothing
				blas_inst.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasUpper, {PC_CBLAS_TRANSPOSE}.CblasNoTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_LLT, a_x).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_cholesky_invert (a_LLT: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_sum: REAL_64
			l_v1: PD_GSL_VECTOR_VIEW
			l_v2: PD_GSL_VECTOR_VIEW
			l_ajj: REAL_64
			l_m___4: PD_GSL_MATRIX_VIEW
			l_A_ij: REAL_64
			js: JUMP_STATE
		do
			create l_v1.make
			create l_v2.make
			create l_m___4.make

			if a_LLT.item.size1 /= a_LLT.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("cholesky matrix must be square"), ce_string ("cholesky.c"), 243, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_N := a_LLT.item.size1
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					l_j := (l_N - l_i) - {NATURAL_32} 1
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_LLT, l_j, l_j, 1.0 / (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_LLT, l_j, l_j)))
					l_ajj := -(gsl_gsl_matrix_double_inst.gsl_matrix_get (a_LLT, l_j, l_j))
					if l_j < l_N - {NATURAL_32} 1 then
						l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_LLT, l_j + {NATURAL_32} 1, l_j + {NATURAL_32} 1, (l_N - l_j) - {NATURAL_32} 1, (l_N - l_j) - {NATURAL_32} 1))
						l_v1.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_LLT, l_j, l_j + {NATURAL_32} 1, (l_N - l_j) - {NATURAL_32} 1))
						blas_inst.gsl_blas_dtrmv ({PC_CBLAS_UPLO}.CblasLower, {PC_CBLAS_TRANSPOSE}.CblasNoTrans, {PC_CBLAS_DIAG}.CblasNonUnit, (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v1.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)).do_nothing
						blas_inst.gsl_blas_dscal (l_ajj, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v1.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))
					end
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_N))
				loop
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (l_j < l_N)
					loop
						l_v1.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_LLT, l_i, l_j, l_N - l_j))
						l_v2.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_LLT, l_j, l_j, l_N - l_j))
						blas_inst.gsl_blas_ddot ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v1.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [REAL_64]}.make_shared ($l_sum)).do_nothing
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_LLT, l_i, l_j, l_sum)
						l_j := l_j + 1
					end
					l_v1.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_LLT, l_i, l_i, l_N - l_i))
					blas_inst.gsl_blas_ddot ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v1.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v1.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [REAL_64]}.make_shared ($l_sum)).do_nothing
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_LLT, l_i, l_i, l_sum)
					l_i := l_i + 1
				end
				l_j := (1).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_i := (0).to_natural_32
					from
					until
						not (l_i < l_j)
					loop
						l_A_ij := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_LLT, l_i, l_j))
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_LLT, l_j, l_i, l_A_ij)
						l_i := l_i + 1
					end
					l_j := l_j + 1
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_cholesky_decomp_unit (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_D: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_stat_chol: INTEGER_32
			l_C_ii: REAL_64
			l_tmp___1: REAL_64
			js: JUMP_STATE
		do
			l_N := a_A___0.item.size1
			l_stat_chol := (gsl_linalg_cholesky_decomp (a_A___0))
			if l_stat_chol = 0 then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					l_C_ii := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_i))
					gsl_gsl_vector_double_inst.gsl_vector_set (a_D, l_i, l_C_ii * l_C_ii)
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_N))
				loop
					l_j := (0).to_natural_32
					from
					until
						not (l_j < l_N)
					loop
						l_tmp___1 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_j)
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_A___0, l_i, l_j, l_tmp___1 / (sqrt ((gsl_gsl_vector_double_inst.gsl_vector_get (a_D, l_j)))))
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_N))
				loop
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (l_j < l_N)
					loop
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_A___0, l_i, l_j, (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_j, l_i)))
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
			end
			Result := l_stat_chol
		end

end
