class
	P_CHPMV

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_chpmv (a_order: INTEGER_32; a_Uplo: INTEGER_32; a_N: INTEGER_32; a_alpha: CE_POINTER [ANY]; a_Ap: CE_POINTER [ANY]; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32; a_beta: CE_POINTER [ANY]; a_Y: CE_POINTER [ANY]; a_incY: INTEGER_32)
		local
			l_conj: INTEGER_32
			l_tmp: INTEGER_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_alpha_real: REAL_32
			l_alpha_imag: REAL_32
			l_beta_real: REAL_32
			l_beta_imag: REAL_32
			l_iy: INTEGER_32
			l_tmp___0: INTEGER_32
			l_iy___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_y_real: REAL_32
			l_y_imag: REAL_32
			l_tmpR: REAL_32
			l_tmpI: REAL_32
			l_ix: INTEGER_32
			l_tmp___2: INTEGER_32
			l_iy___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_x_real: REAL_32
			l_x_imag: REAL_32
			l_temp1_real: REAL_32
			l_temp1_imag: REAL_32
			l_temp2_real: REAL_32
			l_temp2_imag: REAL_32
			l_j_min: INTEGER_32
			l_j_max: INTEGER_32
			l_jx: INTEGER_32
			l_tmp___4: INTEGER_32
			l_jy: INTEGER_32
			l_tmp___5: INTEGER_32
			l_Aii_real: REAL_32
			l_Aij_real: REAL_32
			l_Aij_imag: REAL_32
			l_ix___0: INTEGER_32
			l_tmp___6: INTEGER_32
			l_iy___2: INTEGER_32
			l_tmp___7: INTEGER_32
			l_x_real___0: REAL_32
			l_x_imag___0: REAL_32
			l_temp1_real___0: REAL_32
			l_temp1_imag___0: REAL_32
			l_temp2_real___0: REAL_32
			l_temp2_imag___0: REAL_32
			l_j_min___0: INTEGER_32
			l_j_max___0: INTEGER_32
			l_jx___0: INTEGER_32
			l_tmp___8: INTEGER_32
			l_jy___0: INTEGER_32
			l_tmp___9: INTEGER_32
			l_Aii_real___0: REAL_32
			l_Aij_real___0: REAL_32
			l_Aij_imag___0: REAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_order.to_natural_32 = {NATURAL_32} 102 then
						l_tmp := -1
					else
						l_tmp := 1
					end
					l_conj := l_tmp
					l_alpha_real := create {CE_POINTER [REAL_32]}.make_cast (a_alpha)[0]
					l_alpha_imag := create {CE_POINTER [REAL_32]}.make_cast (a_alpha)[1]
					l_beta_real := create {CE_POINTER [REAL_32]}.make_cast (a_beta)[0]
					l_beta_imag := create {CE_POINTER [REAL_32]}.make_cast (a_beta)[1]
					if l_alpha_real.to_double = 0.0 then
						if l_alpha_imag.to_double = 0.0 then
							if l_beta_real.to_double = 1.0 then
								if l_beta_imag.to_double = 0.0 then
									js.return
								end
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if l_beta_real.to_double /= 0.0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_beta_imag.to_double = 0.0 then
							if a_incY > 0 then
								l_tmp___0 := 0
							else
								l_tmp___0 := (a_N - 1) * -a_incY
							end
							l_iy := l_tmp___0
							l_i := 0
							from
							until
								not (l_i < a_N)
							loop
								create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy] := (0.0).truncated_to_real
								create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy + 1)] := (0.0).truncated_to_real
								l_iy := l_iy + a_incY
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if l_beta_real.to_double /= 1.0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_beta_imag.to_double /= 0.0 then
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if a_incY > 0 then
							l_tmp___1 := 0
						else
							l_tmp___1 := (a_N - 1) * -a_incY
						end
						l_iy___0 := l_tmp___1
						l_i := 0
						from
						until
							not (l_i < a_N)
						loop
							l_y_real := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___0]
							l_y_imag := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___0 + 1)]
							l_tmpR := l_y_real * l_beta_real - l_y_imag * l_beta_imag
							l_tmpI := l_y_real * l_beta_imag + l_y_imag * l_beta_real
							create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___0] := l_tmpR
							create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___0 + 1)] := l_tmpI
							l_iy___0 := l_iy___0 + a_incY
							l_i := l_i + 1
						end
				when 8 then -- if done
						if l_alpha_real.to_double = 0.0 then
							if l_alpha_imag.to_double = 0.0 then
								js.return
							end
						end
				when 9 then -- if done
					if js.return_called then
						l_pos := -1 + 29 -- skip if block
					end
				when 10 then -- if:
						if a_order.to_natural_32 /= {NATURAL_32} 101 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if a_Uplo.to_natural_32 = {NATURAL_32} 121 then
							l_pos := -1 + 15 -- goto _L___3
						else
							l_pos := -1 + 13 -- goto _L___5
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 13 then -- else: | _L___5:
						if a_order.to_natural_32 /= {NATURAL_32} 102 then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						if a_Uplo.to_natural_32 /= {NATURAL_32} 122 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if: | _L___3:
						if a_incX > 0 then
							l_tmp___2 := 0
						else
							l_tmp___2 := (a_N - 1) * -a_incX
						end
						l_ix := l_tmp___2
						if a_incY > 0 then
							l_tmp___3 := 0
						else
							l_tmp___3 := (a_N - 1) * -a_incY
						end
						l_iy___1 := l_tmp___3
						l_i := 0
						from
						until
							not (not js.loop_left and then (l_i < a_N))
						loop
							l_x_real := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix]
							l_x_imag := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix + 1)]
							l_temp1_real := l_alpha_real * l_x_real - l_alpha_imag * l_x_imag
							l_temp1_imag := l_alpha_real * l_x_imag + l_alpha_imag * l_x_real
							l_temp2_real := (0.0).truncated_to_real
							l_temp2_imag := (0.0).truncated_to_real
							l_j_min := l_i + 1
							l_j_max := a_N
							if a_incX > 0 then
								l_tmp___4 := 0
							else
								l_tmp___4 := (a_N - 1) * -a_incX
							end
							l_jx := l_tmp___4 + l_j_min * a_incX
							if a_incY > 0 then
								l_tmp___5 := 0
							else
								l_tmp___5 := (a_N - 1) * -a_incY
							end
							l_jy := l_tmp___5 + l_j_min * a_incY
							l_Aii_real := create {CE_POINTER [REAL_32]}.make_cast (a_Ap)[2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_i) - l_i)]
							create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___1] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___1] + (l_temp1_real * l_Aii_real)
							create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___1 + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___1 + 1)] + (l_temp1_imag * l_Aii_real)
							l_j := l_j_min
							from
							until
								not (l_j < l_j_max)
							loop
								l_Aij_real := create {CE_POINTER [REAL_32]}.make_cast (a_Ap)[2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_j) - l_i)]
								l_Aij_imag := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_Ap)[(2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_j) - l_i) + 1)])
								create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_jy] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_jy] + (l_temp1_real * l_Aij_real - l_temp1_imag * -l_Aij_imag)
								create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_jy + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_jy + 1)] + (l_temp1_real * -l_Aij_imag + l_temp1_imag * l_Aij_real)
								l_x_real := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_jx]
								l_x_imag := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_jx + 1)]
								l_temp2_real := l_temp2_real + (l_x_real * l_Aij_real - l_x_imag * l_Aij_imag)
								l_temp2_imag := l_temp2_imag + (l_x_real * l_Aij_imag + l_x_imag * l_Aij_real)
								l_jx := l_jx + a_incX
								l_jy := l_jy + a_incY
								l_j := l_j + 1
							end
							create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___1] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___1] + (l_alpha_real * l_temp2_real - l_alpha_imag * l_temp2_imag)
							create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___1 + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___1 + 1)] + (l_alpha_real * l_temp2_imag + l_alpha_imag * l_temp2_real)
							l_ix := l_ix + a_incX
							l_iy___1 := l_iy___1 + a_incY
							l_i := l_i + 1
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						l_pos := -1 + 19 -- goto _L___4
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 29
				when 19 then -- else: | _L___4:
						if a_order.to_natural_32 /= {NATURAL_32} 101 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if a_Uplo.to_natural_32 = {NATURAL_32} 122 then
							l_pos := -1 + 24 -- goto _L___1
						else
							l_pos := -1 + 22 -- goto _L___2
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 22 then -- else: | _L___2:
						if a_order.to_natural_32 /= {NATURAL_32} 102 then
							l_pos := -1 + 28 -- skip if block
						end
				when 23 then -- if:
						if a_Uplo.to_natural_32 /= {NATURAL_32} 121 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if: | _L___1:
						if a_incX > 0 then
							l_tmp___6 := 0
						else
							l_tmp___6 := (a_N - 1) * -a_incX
						end
						l_ix___0 := l_tmp___6
						if a_incY > 0 then
							l_tmp___7 := 0
						else
							l_tmp___7 := (a_N - 1) * -a_incY
						end
						l_iy___2 := l_tmp___7
						l_i := 0
						from
						until
							not (not js.loop_left and then (l_i < a_N))
						loop
							l_x_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix___0]
							l_x_imag___0 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix___0 + 1)]
							l_temp1_real___0 := l_alpha_real * l_x_real___0 - l_alpha_imag * l_x_imag___0
							l_temp1_imag___0 := l_alpha_real * l_x_imag___0 + l_alpha_imag * l_x_real___0
							l_temp2_real___0 := (0.0).truncated_to_real
							l_temp2_imag___0 := (0.0).truncated_to_real
							l_j_min___0 := 0
							l_j_max___0 := l_i
							if a_incX > 0 then
								l_tmp___8 := 0
							else
								l_tmp___8 := (a_N - 1) * -a_incX
							end
							l_jx___0 := l_tmp___8 + l_j_min___0 * a_incX
							if a_incY > 0 then
								l_tmp___9 := 0
							else
								l_tmp___9 := (a_N - 1) * -a_incY
							end
							l_jy___0 := l_tmp___9 + l_j_min___0 * a_incY
							l_Aii_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_Ap)[2 * ((l_i * (l_i + 1)) // 2 + l_i)]
							create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___2] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___2] + (l_temp1_real___0 * l_Aii_real___0)
							create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___2 + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___2 + 1)] + (l_temp1_imag___0 * l_Aii_real___0)
							l_j := l_j_min___0
							from
							until
								not (l_j < l_j_max___0)
							loop
								l_Aij_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_Ap)[2 * ((l_i * (l_i + 1)) // 2 + l_j)]
								l_Aij_imag___0 := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_Ap)[(2 * ((l_i * (l_i + 1)) // 2 + l_j) + 1)])
								create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_jy___0] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_jy___0] + (l_temp1_real___0 * l_Aij_real___0 - l_temp1_imag___0 * -l_Aij_imag___0)
								create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_jy___0 + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_jy___0 + 1)] + (l_temp1_real___0 * -l_Aij_imag___0 + l_temp1_imag___0 * l_Aij_real___0)
								l_x_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_jx___0]
								l_x_imag___0 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_jx___0 + 1)]
								l_temp2_real___0 := l_temp2_real___0 + (l_x_real___0 * l_Aij_real___0 - l_x_imag___0 * l_Aij_imag___0)
								l_temp2_imag___0 := l_temp2_imag___0 + (l_x_real___0 * l_Aij_imag___0 + l_x_imag___0 * l_Aij_real___0)
								l_jx___0 := l_jx___0 + a_incX
								l_jy___0 := l_jy___0 + a_incY
								l_j := l_j + 1
							end
							create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___2] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[2 * l_iy___2] + (l_alpha_real * l_temp2_real___0 - l_alpha_imag * l_temp2_imag___0)
							create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___2 + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_Y)[(2 * l_iy___2 + 1)] + (l_alpha_real * l_temp2_imag___0 + l_alpha_imag * l_temp2_real___0)
							l_ix___0 := l_ix___0 + a_incX
							l_iy___2 := l_iy___2 + a_incY
							l_i := l_i + 1
						end
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						xerbla_inst.cblas_xerbla ([0, ce_string ("source_hpmv.h"), ce_string ("unrecognized operation")])
				when 27 then -- if done | if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:
						xerbla_inst.cblas_xerbla ([0, ce_string ("source_hpmv.h"), ce_string ("unrecognized operation")])
				when 29 then -- if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
