class
	P_COPY2D

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_histogram2d_memcpy (a_dest: CE_POINTER [PD_GSL_HISTOGRAM2D]; a_src: CE_POINTER [PD_GSL_HISTOGRAM2D]): INTEGER_32
		local
			l_nx: NATURAL_32
			l_ny: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_nx := a_src.item.nx
					l_ny := a_src.item.ny
					if a_dest.item.nx = a_src.item.nx then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if a_dest.item.ny = a_src.item.ny then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("histograms have different sizes, cannot copy"), ce_string ("copy2d.c"), 47, 4)
							Result := 4
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_i := (0).to_natural_32
							from
							until
								not (l_i <= l_nx)
							loop
								a_dest.item.xrange[l_i.to_integer_32] := a_src.item.xrange[l_i.to_integer_32]
								l_i := l_i + 1
							end
							l_i := (0).to_natural_32
							from
							until
								not (l_i <= l_ny)
							loop
								a_dest.item.yrange[l_i.to_integer_32] := a_src.item.yrange[l_i.to_integer_32]
								l_i := l_i + 1
							end
							l_i := (0).to_natural_32
							from
							until
								not (l_i < l_nx * l_ny)
							loop
								a_dest.item.bin[l_i.to_integer_32] := a_src.item.bin[l_i.to_integer_32]
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_histogram2d_clone (a_src: CE_POINTER [PD_GSL_HISTOGRAM2D]): CE_POINTER [PD_GSL_HISTOGRAM2D]
		local
			l_nx: NATURAL_32
			l_ny: NATURAL_32
			l_i: NATURAL_32
			l_h: CE_POINTER [PD_GSL_HISTOGRAM2D]
			js: JUMP_STATE
		do
			create l_h.make

			l_nx := a_src.item.nx
			l_ny := a_src.item.ny
			l_h.ce_gets (calloc_range2d_inst.gsl_histogram2d_calloc_range (l_nx, l_ny, a_src.item.xrange, a_src.item.yrange))
			if (l_h.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("failed to allocate space for histogram struct"), ce_string ("copy2d.c"), 87, 8)
					Result := (create {CE_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_nx * l_ny)
				loop
					l_h.item.bin[l_i.to_integer_32] := a_src.item.bin[l_i.to_integer_32]
					l_i := l_i + 1
				end
				Result := l_h
			end
		end

end
