class
	P_COPY_SOURCE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_matrix_complex_long_double_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_src: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 31, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < {NATURAL_32} 2 * l_src_size2)
								loop
									a_dest.item.data[(({NATURAL_32} 2 * l_dest_tda) * l_i + l_j).to_integer_32] := a_src.item.data[(({NATURAL_32} 2 * l_src_tda) * l_i + l_j).to_integer_32]
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_complex_long_double_swap (a_dest: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_src: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_tmp: REAL_96
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 63, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < {NATURAL_32} 2 * l_src_size2)
								loop
									l_tmp := a_src.item.data[(({NATURAL_32} 2 * l_src_tda) * l_i + l_j).to_integer_32]
									a_src.item.data[(({NATURAL_32} 2 * l_src_tda) * l_i + l_j).to_integer_32] := a_dest.item.data[(({NATURAL_32} 2 * l_dest_tda) * l_i + l_j).to_integer_32]
									a_dest.item.data[(({NATURAL_32} 2 * l_dest_tda) * l_i + l_j).to_integer_32] := l_tmp
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_complex_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_src: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 31, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < {NATURAL_32} 2 * l_src_size2)
								loop
									a_dest.item.data[(({NATURAL_32} 2 * l_dest_tda) * l_i + l_j).to_integer_32] := a_src.item.data[(({NATURAL_32} 2 * l_src_tda) * l_i + l_j).to_integer_32]
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_complex_swap (a_dest: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_src: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_tmp: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 63, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < {NATURAL_32} 2 * l_src_size2)
								loop
									l_tmp := a_src.item.data[(({NATURAL_32} 2 * l_src_tda) * l_i + l_j).to_integer_32]
									a_src.item.data[(({NATURAL_32} 2 * l_src_tda) * l_i + l_j).to_integer_32] := a_dest.item.data[(({NATURAL_32} 2 * l_dest_tda) * l_i + l_j).to_integer_32]
									a_dest.item.data[(({NATURAL_32} 2 * l_dest_tda) * l_i + l_j).to_integer_32] := l_tmp
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_complex_float_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_src: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 31, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < {NATURAL_32} 2 * l_src_size2)
								loop
									a_dest.item.data[(({NATURAL_32} 2 * l_dest_tda) * l_i + l_j).to_integer_32] := a_src.item.data[(({NATURAL_32} 2 * l_src_tda) * l_i + l_j).to_integer_32]
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_complex_float_swap (a_dest: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_src: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_tmp: REAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 63, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < {NATURAL_32} 2 * l_src_size2)
								loop
									l_tmp := a_src.item.data[(({NATURAL_32} 2 * l_src_tda) * l_i + l_j).to_integer_32]
									a_src.item.data[(({NATURAL_32} 2 * l_src_tda) * l_i + l_j).to_integer_32] := a_dest.item.data[(({NATURAL_32} 2 * l_dest_tda) * l_i + l_j).to_integer_32]
									a_dest.item.data[(({NATURAL_32} 2 * l_dest_tda) * l_i + l_j).to_integer_32] := l_tmp
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_long_double_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]; a_src: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 31, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_src_size2)
								loop
									a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32] := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_long_double_swap (a_dest: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]; a_src: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_tmp: REAL_96
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 63, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_src_size2)
								loop
									l_tmp := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
									a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32] := a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32]
									a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32] := l_tmp
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX]; a_src: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 31, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_src_size2)
								loop
									a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32] := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_swap (a_dest: CE_POINTER [PD_GSL_MATRIX]; a_src: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_tmp: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 63, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_src_size2)
								loop
									l_tmp := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
									a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32] := a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32]
									a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32] := l_tmp
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_float_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_src: CE_POINTER [PD_GSL_MATRIX_FLOAT]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 31, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_src_size2)
								loop
									a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32] := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_float_swap (a_dest: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_src: CE_POINTER [PD_GSL_MATRIX_FLOAT]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_tmp: REAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 63, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_src_size2)
								loop
									l_tmp := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
									a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32] := a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32]
									a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32] := l_tmp
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_ulong_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_ULONG]; a_src: CE_POINTER [PD_GSL_MATRIX_ULONG]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 31, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_src_size2)
								loop
									a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32] := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_ulong_swap (a_dest: CE_POINTER [PD_GSL_MATRIX_ULONG]; a_src: CE_POINTER [PD_GSL_MATRIX_ULONG]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 63, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_src_size2)
								loop
									l_tmp := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
									a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32] := a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32]
									a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32] := l_tmp
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_long_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_LONG]; a_src: CE_POINTER [PD_GSL_MATRIX_LONG]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 31, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_src_size2)
								loop
									a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32] := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_long_swap (a_dest: CE_POINTER [PD_GSL_MATRIX_LONG]; a_src: CE_POINTER [PD_GSL_MATRIX_LONG]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 63, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_src_size2)
								loop
									l_tmp := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
									a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32] := a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32]
									a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32] := l_tmp
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_uint_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_UINT]; a_src: CE_POINTER [PD_GSL_MATRIX_UINT]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 31, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_src_size2)
								loop
									a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32] := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_uint_swap (a_dest: CE_POINTER [PD_GSL_MATRIX_UINT]; a_src: CE_POINTER [PD_GSL_MATRIX_UINT]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 63, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_src_size2)
								loop
									l_tmp := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
									a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32] := a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32]
									a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32] := l_tmp
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_int_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_INT]; a_src: CE_POINTER [PD_GSL_MATRIX_INT]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 31, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_src_size2)
								loop
									a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32] := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_int_swap (a_dest: CE_POINTER [PD_GSL_MATRIX_INT]; a_src: CE_POINTER [PD_GSL_MATRIX_INT]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 63, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_src_size2)
								loop
									l_tmp := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
									a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32] := a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32]
									a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32] := l_tmp
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_ushort_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_USHORT]; a_src: CE_POINTER [PD_GSL_MATRIX_USHORT]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 31, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_src_size2)
								loop
									a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32] := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_ushort_swap (a_dest: CE_POINTER [PD_GSL_MATRIX_USHORT]; a_src: CE_POINTER [PD_GSL_MATRIX_USHORT]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_tmp: NATURAL_16
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 63, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_src_size2)
								loop
									l_tmp := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
									a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32] := a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32]
									a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32] := l_tmp
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_short_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_SHORT]; a_src: CE_POINTER [PD_GSL_MATRIX_SHORT]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 31, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_src_size2)
								loop
									a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32] := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_short_swap (a_dest: CE_POINTER [PD_GSL_MATRIX_SHORT]; a_src: CE_POINTER [PD_GSL_MATRIX_SHORT]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_tmp: INTEGER_16
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 63, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_src_size2)
								loop
									l_tmp := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
									a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32] := a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32]
									a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32] := l_tmp
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_uchar_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_UCHAR]; a_src: CE_POINTER [PD_GSL_MATRIX_UCHAR]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 31, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_src_size2)
								loop
									a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32] := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_uchar_swap (a_dest: CE_POINTER [PD_GSL_MATRIX_UCHAR]; a_src: CE_POINTER [PD_GSL_MATRIX_UCHAR]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_tmp: NATURAL_8
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 63, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_src_size2)
								loop
									l_tmp := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
									a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32] := a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32]
									a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32] := l_tmp
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_char_memcpy (a_dest: CE_POINTER [PD_GSL_MATRIX_CHAR]; a_src: CE_POINTER [PD_GSL_MATRIX_CHAR]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 31, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_src_size2)
								loop
									a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32] := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_matrix_char_swap (a_dest: CE_POINTER [PD_GSL_MATRIX_CHAR]; a_src: CE_POINTER [PD_GSL_MATRIX_CHAR]): INTEGER_32
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_tmp: INTEGER_8
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := a_dest.item.size1
					l_dest_size2 := a_dest.item.size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 63, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_src_tda := a_src.item.tda
							l_dest_tda := a_dest.item.tda
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_src_size1))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_src_size2)
								loop
									l_tmp := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
									a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32] := a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32]
									a_dest.item.data[(l_dest_tda * l_i + l_j).to_integer_32] := l_tmp
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_vector_complex_long_double_memcpy (a_dest: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]; a_src: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_src_size: NATURAL_32
			l_dest_size: NATURAL_32
			l_src_stride: NATURAL_32
			l_dest_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_src_size := a_src.item.size
			l_dest_size := a_dest.item.size
			if l_src_size /= l_dest_size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector lengths are not equal"), ce_string ("copy_source.c"), 29, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_src_stride := a_src.item.stride
				l_dest_stride := a_dest.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_src_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						a_dest.item.data[(({NATURAL_32} 2 * l_dest_stride) * l_j + l_k).to_integer_32] := a_src.item.data[(({NATURAL_32} 2 * l_src_stride) * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_vector_complex_memcpy (a_dest: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_src: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_src_size: NATURAL_32
			l_dest_size: NATURAL_32
			l_src_stride: NATURAL_32
			l_dest_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_src_size := a_src.item.size
			l_dest_size := a_dest.item.size
			if l_src_size /= l_dest_size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector lengths are not equal"), ce_string ("copy_source.c"), 29, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_src_stride := a_src.item.stride
				l_dest_stride := a_dest.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_src_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						a_dest.item.data[(({NATURAL_32} 2 * l_dest_stride) * l_j + l_k).to_integer_32] := a_src.item.data[(({NATURAL_32} 2 * l_src_stride) * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_vector_complex_float_memcpy (a_dest: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_src: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_src_size: NATURAL_32
			l_dest_size: NATURAL_32
			l_src_stride: NATURAL_32
			l_dest_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_src_size := a_src.item.size
			l_dest_size := a_dest.item.size
			if l_src_size /= l_dest_size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector lengths are not equal"), ce_string ("copy_source.c"), 29, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_src_stride := a_src.item.stride
				l_dest_stride := a_dest.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_src_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						a_dest.item.data[(({NATURAL_32} 2 * l_dest_stride) * l_j + l_k).to_integer_32] := a_src.item.data[(({NATURAL_32} 2 * l_src_stride) * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_vector_long_double_memcpy (a_dest: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]; a_src: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]): INTEGER_32
		local
			l_src_size: NATURAL_32
			l_dest_size: NATURAL_32
			l_src_stride: NATURAL_32
			l_dest_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_src_size := a_src.item.size
			l_dest_size := a_dest.item.size
			if l_src_size /= l_dest_size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector lengths are not equal"), ce_string ("copy_source.c"), 29, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_src_stride := a_src.item.stride
				l_dest_stride := a_dest.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_src_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						a_dest.item.data[(l_dest_stride * l_j + l_k).to_integer_32] := a_src.item.data[(l_src_stride * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_vector_memcpy (a_dest: CE_POINTER [PD_GSL_VECTOR]; a_src: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_src_size: NATURAL_32
			l_dest_size: NATURAL_32
			l_src_stride: NATURAL_32
			l_dest_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_src_size := a_src.item.size
			l_dest_size := a_dest.item.size
			if l_src_size /= l_dest_size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector lengths are not equal"), ce_string ("copy_source.c"), 29, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_src_stride := a_src.item.stride
				l_dest_stride := a_dest.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_src_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						a_dest.item.data[(l_dest_stride * l_j + l_k).to_integer_32] := a_src.item.data[(l_src_stride * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_vector_float_memcpy (a_dest: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_src: CE_POINTER [PD_GSL_VECTOR_FLOAT]): INTEGER_32
		local
			l_src_size: NATURAL_32
			l_dest_size: NATURAL_32
			l_src_stride: NATURAL_32
			l_dest_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_src_size := a_src.item.size
			l_dest_size := a_dest.item.size
			if l_src_size /= l_dest_size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector lengths are not equal"), ce_string ("copy_source.c"), 29, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_src_stride := a_src.item.stride
				l_dest_stride := a_dest.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_src_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						a_dest.item.data[(l_dest_stride * l_j + l_k).to_integer_32] := a_src.item.data[(l_src_stride * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_vector_ulong_memcpy (a_dest: CE_POINTER [PD_GSL_VECTOR_ULONG]; a_src: CE_POINTER [PD_GSL_VECTOR_ULONG]): INTEGER_32
		local
			l_src_size: NATURAL_32
			l_dest_size: NATURAL_32
			l_src_stride: NATURAL_32
			l_dest_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_src_size := a_src.item.size
			l_dest_size := a_dest.item.size
			if l_src_size /= l_dest_size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector lengths are not equal"), ce_string ("copy_source.c"), 29, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_src_stride := a_src.item.stride
				l_dest_stride := a_dest.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_src_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						a_dest.item.data[(l_dest_stride * l_j + l_k).to_integer_32] := a_src.item.data[(l_src_stride * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_vector_long_memcpy (a_dest: CE_POINTER [PD_GSL_VECTOR_LONG]; a_src: CE_POINTER [PD_GSL_VECTOR_LONG]): INTEGER_32
		local
			l_src_size: NATURAL_32
			l_dest_size: NATURAL_32
			l_src_stride: NATURAL_32
			l_dest_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_src_size := a_src.item.size
			l_dest_size := a_dest.item.size
			if l_src_size /= l_dest_size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector lengths are not equal"), ce_string ("copy_source.c"), 29, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_src_stride := a_src.item.stride
				l_dest_stride := a_dest.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_src_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						a_dest.item.data[(l_dest_stride * l_j + l_k).to_integer_32] := a_src.item.data[(l_src_stride * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_vector_uint_memcpy (a_dest: CE_POINTER [PD_GSL_VECTOR_UINT]; a_src: CE_POINTER [PD_GSL_VECTOR_UINT]): INTEGER_32
		local
			l_src_size: NATURAL_32
			l_dest_size: NATURAL_32
			l_src_stride: NATURAL_32
			l_dest_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_src_size := a_src.item.size
			l_dest_size := a_dest.item.size
			if l_src_size /= l_dest_size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector lengths are not equal"), ce_string ("copy_source.c"), 29, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_src_stride := a_src.item.stride
				l_dest_stride := a_dest.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_src_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						a_dest.item.data[(l_dest_stride * l_j + l_k).to_integer_32] := a_src.item.data[(l_src_stride * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_vector_int_memcpy (a_dest: CE_POINTER [PD_GSL_VECTOR_INT]; a_src: CE_POINTER [PD_GSL_VECTOR_INT]): INTEGER_32
		local
			l_src_size: NATURAL_32
			l_dest_size: NATURAL_32
			l_src_stride: NATURAL_32
			l_dest_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_src_size := a_src.item.size
			l_dest_size := a_dest.item.size
			if l_src_size /= l_dest_size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector lengths are not equal"), ce_string ("copy_source.c"), 29, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_src_stride := a_src.item.stride
				l_dest_stride := a_dest.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_src_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						a_dest.item.data[(l_dest_stride * l_j + l_k).to_integer_32] := a_src.item.data[(l_src_stride * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_vector_ushort_memcpy (a_dest: CE_POINTER [PD_GSL_VECTOR_USHORT]; a_src: CE_POINTER [PD_GSL_VECTOR_USHORT]): INTEGER_32
		local
			l_src_size: NATURAL_32
			l_dest_size: NATURAL_32
			l_src_stride: NATURAL_32
			l_dest_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_src_size := a_src.item.size
			l_dest_size := a_dest.item.size
			if l_src_size /= l_dest_size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector lengths are not equal"), ce_string ("copy_source.c"), 29, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_src_stride := a_src.item.stride
				l_dest_stride := a_dest.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_src_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						a_dest.item.data[(l_dest_stride * l_j + l_k).to_integer_32] := a_src.item.data[(l_src_stride * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_vector_short_memcpy (a_dest: CE_POINTER [PD_GSL_VECTOR_SHORT]; a_src: CE_POINTER [PD_GSL_VECTOR_SHORT]): INTEGER_32
		local
			l_src_size: NATURAL_32
			l_dest_size: NATURAL_32
			l_src_stride: NATURAL_32
			l_dest_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_src_size := a_src.item.size
			l_dest_size := a_dest.item.size
			if l_src_size /= l_dest_size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector lengths are not equal"), ce_string ("copy_source.c"), 29, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_src_stride := a_src.item.stride
				l_dest_stride := a_dest.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_src_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						a_dest.item.data[(l_dest_stride * l_j + l_k).to_integer_32] := a_src.item.data[(l_src_stride * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_vector_uchar_memcpy (a_dest: CE_POINTER [PD_GSL_VECTOR_UCHAR]; a_src: CE_POINTER [PD_GSL_VECTOR_UCHAR]): INTEGER_32
		local
			l_src_size: NATURAL_32
			l_dest_size: NATURAL_32
			l_src_stride: NATURAL_32
			l_dest_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_src_size := a_src.item.size
			l_dest_size := a_dest.item.size
			if l_src_size /= l_dest_size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector lengths are not equal"), ce_string ("copy_source.c"), 29, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_src_stride := a_src.item.stride
				l_dest_stride := a_dest.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_src_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						a_dest.item.data[(l_dest_stride * l_j + l_k).to_integer_32] := a_src.item.data[(l_src_stride * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_vector_char_memcpy (a_dest: CE_POINTER [PD_GSL_VECTOR_CHAR]; a_src: CE_POINTER [PD_GSL_VECTOR_CHAR]): INTEGER_32
		local
			l_src_size: NATURAL_32
			l_dest_size: NATURAL_32
			l_src_stride: NATURAL_32
			l_dest_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_src_size := a_src.item.size
			l_dest_size := a_dest.item.size
			if l_src_size /= l_dest_size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector lengths are not equal"), ce_string ("copy_source.c"), 29, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_src_stride := a_src.item.stride
				l_dest_stride := a_dest.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_src_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						a_dest.item.data[(l_dest_stride * l_j + l_k).to_integer_32] := a_src.item.data[(l_src_stride * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

end
