class
	P_COULOMB_BOUND

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	R_norm (a_n: INTEGER_32; a_l: INTEGER_32; a_Z: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_A___0: REAL_64
			l_pre: REAL_64
			l_ln_a: PD_GSL_SF_RESULT_STRUCT
			l_ln_b: PD_GSL_SF_RESULT_STRUCT
			l_ex: PD_GSL_SF_RESULT_STRUCT
			l_stat_a: INTEGER_32
			l_stat_b: INTEGER_32
			l_diff_val: REAL_64
			l_diff_err: REAL_64
			l_stat_e: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
		do
			create l_ln_a.make
			create l_ln_b.make
			create l_ex.make

			l_A___0 := (2.0 * a_Z) / a_n.to_double
			l_pre := (sqrt (((l_A___0 * l_A___0) * l_A___0) / (2.0 * a_n.to_double)))
			l_stat_a := (gamma_inst.gsl_sf_lnfact_e ((a_n + a_l).to_natural_32, l_ln_a.address))
			l_stat_b := (gamma_inst.gsl_sf_lnfact_e (((a_n - a_l) - 1).to_natural_32, l_ln_b.address))
			l_diff_val := 0.5 * (l_ln_b.val - l_ln_a.val)
			l_diff_err := 0.5 * (l_ln_b.err + l_ln_a.err) + 2.2204460492503131e-16 * (fabs (l_diff_val))
			l_stat_e := (exp_inst.gsl_sf_exp_err_e (l_diff_val, l_diff_err, l_ex.address))
			a_result.item.val := l_pre * l_ex.val
			a_result.item.err := l_pre * l_ex.err
			a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
			if l_stat_e /= 0 then
				l_tmp___7 := l_stat_e
			else
				if l_stat_a /= 0 then
					l_tmp___6 := l_stat_a
				else
					if l_stat_b /= 0 then
						l_tmp___5 := l_stat_b
					else
						l_tmp___5 := 0
					end
					l_tmp___6 := l_tmp___5
				end
				l_tmp___7 := l_tmp___6
			end
			Result := l_tmp___7
		end

	gsl_sf_hydrogenicR_1_e (a_Z: REAL_64; a_r___3: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_A___0: REAL_64
			l_norm___0: REAL_64
			l_ea: REAL_64
			l_tmp___1: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_Z > 0.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_r___3 >= 0.0 then
							l_A___0 := 2.0 * a_Z
							l_norm___0 := l_A___0 * (sqrt (a_Z))
							l_ea := (exp (-a_Z * a_r___3))
							a_result.item.val := l_norm___0 * l_ea
							l_tmp___1 := fabs (a_result.item.val)
							a_result.item.err := ((2.0 * 2.2204460492503131e-16) * l_tmp___1) * (fabs (a_Z * a_r___3))
							if (fabs (a_result.item.val)) < 2.2250738585072014e-308 then
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("underflow"), ce_string ("coulomb_bound.c"), 66, 15)
									Result := 15
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
							end
							if not js.return_called then
								Result := 0
								js.return
							end
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("coulomb_bound.c"), 70, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 4 then
					if not js.return_called then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_sf_hydrogenicR_e (a_n: INTEGER_32; a_l: INTEGER_32; a_Z: REAL_64; a_r___3: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_A___0: REAL_64
			l_norm___0: PD_GSL_SF_RESULT_STRUCT
			l_stat_norm: INTEGER_32
			l_rho: REAL_64
			l_ea: REAL_64
			l_pp: REAL_64
			l_lag: PD_GSL_SF_RESULT_STRUCT
			l_stat_lag: INTEGER_32
			l_W_val: REAL_64
			l_W_err: REAL_64
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_norm___0.make
			create l_lag.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_n < 1) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 3 then -- else:
						if not (a_l > a_n - 1) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 6 then -- else:
						if not (a_Z <= 0.0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 9 then -- else:
						if not (a_r___3 < 0.0) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("coulomb_bound.c"), 81, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 12 then -- else:
						l_A___0 := (2.0 * a_Z) / a_n.to_double
						l_stat_norm := (R_norm (a_n, a_l, a_Z, l_norm___0.address))
						l_rho := l_A___0 * a_r___3
						l_ea := (exp (-0.5 * l_rho))
						l_pp := (pow_int_inst.gsl_sf_pow_int (l_rho, a_l))
						l_stat_lag := (laguerre_inst.gsl_sf_laguerre_n_e ((a_n - a_l) - 1, (2 * a_l + 1).to_double, l_rho, l_lag.address))
						l_W_val := (l_norm___0.val * l_ea) * l_pp
						l_W_err := (l_norm___0.err * l_ea) * l_pp
						l_W_err := l_W_err + (((l_norm___0.val * ((0.5 * l_rho + 1.0) * 2.2204460492503131e-16)) * l_ea) * l_pp)
						l_W_err := l_W_err + (((l_norm___0.val * l_ea) * ((a_l.to_double + 1.0) * 2.2204460492503131e-16)) * l_pp)
						a_result.item.val := l_W_val * l_lag.val
						a_result.item.err := l_W_val * l_lag.err + l_W_err * (fabs (l_lag.val))
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						if a_l /= 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 15 then -- else:
						if not (a_r___3 > (0).to_double) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if not (a_l > 0) then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L:
						if l_lag.val /= 0.0 then
							if l_stat_lag = 0 then
								if l_stat_norm = 0 then
									if (fabs (a_result.item.val)) < 2.2250738585072014e-308 then
										from
										until
											js.loop_left
										loop
											js.reset
											error_inst.gsl_error (ce_string ("underflow"), ce_string ("coulomb_bound.c"), 101, 15)
											Result := 15
											js.return
											if not js.return_called then
												js.break
											end
										end
										js.reset
									end
								end
							end
						end
				when 18 then -- if done | if done
						if not js.return_called then
							if l_stat_lag /= 0 then
								l_tmp___9 := l_stat_lag
							else
								if l_stat_norm /= 0 then
									l_tmp___8 := l_stat_norm
								else
									l_tmp___8 := 0
								end
								l_tmp___9 := l_tmp___8
							end
							Result := l_tmp___9
							js.return
						end
				when 19 then -- if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 20 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_hydrogenicR_1 (a_Z: REAL_64; a_r___3: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_hydrogenicR_1_e (a_Z, a_r___3, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_hydrogenicR_1_e(Z, r, &result)"), ce_string ("coulomb_bound.c"), 113, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_hydrogenicR (a_n: INTEGER_32; a_l: INTEGER_32; a_Z: REAL_64; a_r___3: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_hydrogenicR_e (a_n, a_l, a_Z, a_r___3, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_hydrogenicR_e(n, l, Z, r, &result)"), ce_string ("coulomb_bound.c"), 119, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
