class
	P_COUPLING

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	locMax32 (a_a___5: INTEGER_32; a_b___0: INTEGER_32; a_c___1: INTEGER_32): INTEGER_32
		local
			l_d: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			if a_a___5 > a_b___0 then
				l_tmp := a_a___5
			else
				l_tmp := a_b___0
			end
			l_d := l_tmp
			if l_d > a_c___1 then
				l_tmp___0 := l_d
			else
				l_tmp___0 := a_c___1
			end
			Result := l_tmp___0
		end

	locMin3 (a_a___5: INTEGER_32; a_b___0: INTEGER_32; a_c___1: INTEGER_32): INTEGER_32
		local
			l_d: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			if a_a___5 < a_b___0 then
				l_tmp := a_a___5
			else
				l_tmp := a_b___0
			end
			l_d := l_tmp
			if l_d < a_c___1 then
				l_tmp___0 := l_d
			else
				l_tmp___0 := a_c___1
			end
			Result := l_tmp___0
		end

	locMin5 (a_a___5: INTEGER_32; a_b___0: INTEGER_32; a_c___1: INTEGER_32; a_d: INTEGER_32; a_e: INTEGER_32): INTEGER_32
		local
			l_f: INTEGER_32
			l_tmp: INTEGER_32
			l_g: INTEGER_32
			l_tmp___0: INTEGER_32
			l_h: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
		do
			if a_a___5 < a_b___0 then
				l_tmp := a_a___5
			else
				l_tmp := a_b___0
			end
			l_f := l_tmp
			if a_c___1 < a_d then
				l_tmp___0 := a_c___1
			else
				l_tmp___0 := a_d
			end
			l_g := l_tmp___0
			if l_f < l_g then
				l_tmp___1 := l_f
			else
				l_tmp___1 := l_g
			end
			l_h := l_tmp___1
			if a_e < l_h then
				l_tmp___2 := a_e
			else
				l_tmp___2 := l_h
			end
			Result := l_tmp___2
		end

	delta (a_ta: INTEGER_32; a_tb: INTEGER_32; a_tc: INTEGER_32; a_d: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_f1: PD_GSL_SF_RESULT_STRUCT
			l_f2: PD_GSL_SF_RESULT_STRUCT
			l_f3: PD_GSL_SF_RESULT_STRUCT
			l_f4: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_f1.make
			create l_f2.make
			create l_f3.make
			create l_f4.make

			l_status := 0
			l_status := l_status + (gamma_inst.gsl_sf_fact_e ((((a_ta + a_tb) - a_tc) // 2).to_natural_32, l_f1.address))
			l_status := l_status + (gamma_inst.gsl_sf_fact_e ((((a_ta + a_tc) - a_tb) // 2).to_natural_32, l_f2.address))
			l_status := l_status + (gamma_inst.gsl_sf_fact_e ((((a_tb + a_tc) - a_ta) // 2).to_natural_32, l_f3.address))
			l_status := l_status + (gamma_inst.gsl_sf_fact_e ((((a_ta + a_tb) + a_tc) // 2 + 1).to_natural_32, l_f4.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_d.item.val := (builtin_inff).to_double
					a_d.item.err := (builtin_inff).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("overflow"), ce_string ("coupling.c"), 71, 16)
						Result := 16
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				a_d.item.val := ((l_f1.val * l_f2.val) * l_f3.val) / l_f4.val
				a_d.item.err := (4.0 * 2.2204460492503131e-16) * (fabs (a_d.item.val))
				Result := 0
			end
		end

	triangle_selection_fails (a_two_ja: INTEGER_32; a_two_jb: INTEGER_32; a_two_jc: INTEGER_32): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if a_two_jb < (abs (a_two_ja - a_two_jc)) then
				l_tmp___0 := 1
			elseif a_two_jb > a_two_ja + a_two_jc then
				l_tmp___0 := 1
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	m_selection_fails (a_two_ja: INTEGER_32; a_two_jb: INTEGER_32; a_two_jc: INTEGER_32; a_two_ma: INTEGER_32; a_two_mb: INTEGER_32; a_two_mc: INTEGER_32): INTEGER_32
		local
			l_tmp___2: INTEGER_32
		do
			if (abs (a_two_ma)) > a_two_ja then
				l_tmp___2 := 1
			elseif (abs (a_two_mb)) > a_two_jb then
				l_tmp___2 := 1
			elseif (abs (a_two_mc)) > a_two_jc then
				l_tmp___2 := 1
			elseif (((a_two_ja + a_two_ma)).bit_and (1)).to_boolean then
				l_tmp___2 := 1
			elseif (((a_two_jb + a_two_mb)).bit_and (1)).to_boolean then
				l_tmp___2 := 1
			elseif (((a_two_jc + a_two_mc)).bit_and (1)).to_boolean then
				l_tmp___2 := 1
			elseif (a_two_ma + a_two_mb) + a_two_mc /= 0 then
				l_tmp___2 := 1
			else
				l_tmp___2 := 0
			end
			Result := l_tmp___2
		end

	gsl_sf_coupling_3j_e (a_two_ja: INTEGER_32; a_two_jb: INTEGER_32; a_two_jc: INTEGER_32; a_two_ma: INTEGER_32; a_two_mb: INTEGER_32; a_two_mc: INTEGER_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_jca: INTEGER_32
			l_jcb: INTEGER_32
			l_jcc: INTEGER_32
			l_jmma: INTEGER_32
			l_jmmb: INTEGER_32
			l_jmmc: INTEGER_32
			l_jpma: INTEGER_32
			l_jpmb: INTEGER_32
			l_jpmc: INTEGER_32
			l_jsum: INTEGER_32
			l_kmin: INTEGER_32
			l_kmax___0: INTEGER_32
			l_k: INTEGER_32
			l_sign: INTEGER_32
			l_tmp___3: INTEGER_32
			l_status: INTEGER_32
			l_sum_pos: REAL_64
			l_sum_neg: REAL_64
			l_norm___0: REAL_64
			l_term: REAL_64
			l_bc1: PD_GSL_SF_RESULT_STRUCT
			l_bc2: PD_GSL_SF_RESULT_STRUCT
			l_bc3: PD_GSL_SF_RESULT_STRUCT
			l_bcn1: PD_GSL_SF_RESULT_STRUCT
			l_bcn2: PD_GSL_SF_RESULT_STRUCT
			l_bcd1: PD_GSL_SF_RESULT_STRUCT
			l_bcd2: PD_GSL_SF_RESULT_STRUCT
			l_bcd3: PD_GSL_SF_RESULT_STRUCT
			l_bcd4: PD_GSL_SF_RESULT_STRUCT
			l_tmp___12: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_bc1.make
			create l_bc2.make
			create l_bc3.make
			create l_bcn1.make
			create l_bcn2.make
			create l_bcd1.make
			create l_bcd2.make
			create l_bcd3.make
			create l_bcd4.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_two_ja < 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if not (a_two_jb < 0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not (a_two_jc < 0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("coupling.c"), 115, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						if (triangle_selection_fails (a_two_ja, a_two_jb, a_two_jc)).to_boolean then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							Result := 0
							js.return
						elseif (m_selection_fails (a_two_ja, a_two_jb, a_two_jc, a_two_ma, a_two_mb, a_two_mc)).to_boolean then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							Result := 0
							js.return
						else
							l_jca := ((-a_two_ja + a_two_jb) + a_two_jc) // 2
							l_jcb := ((a_two_ja - a_two_jb) + a_two_jc) // 2
							l_jcc := ((a_two_ja + a_two_jb) - a_two_jc) // 2
							l_jmma := (a_two_ja - a_two_ma) // 2
							l_jmmb := (a_two_jb - a_two_mb) // 2
							l_jmmc := (a_two_jc - a_two_mc) // 2
							l_jpma := (a_two_ja + a_two_ma) // 2
							l_jpmb := (a_two_jb + a_two_mb) // 2
							l_jpmc := (a_two_jc + a_two_mc) // 2
							l_jsum := ((a_two_ja + a_two_jb) + a_two_jc) // 2
							l_kmin := (locMax32 (0, l_jpmb - l_jmmc, l_jmma - l_jpmc))
							l_kmax___0 := (locMin3 (l_jcc, l_jmma, l_jpmb))
							if ((((l_kmin - l_jpma) + l_jmmb)).bit_and (1)).to_boolean then
								l_tmp___3 := -1
							else
								l_tmp___3 := 1
							end
							l_sign := l_tmp___3
							l_status := 0
							l_sum_pos := 0.0
							l_sum_neg := 0.0
							l_status := l_status + (gamma_inst.gsl_sf_choose_e (a_two_ja.to_natural_32, l_jcc.to_natural_32, l_bcn1.address))
							l_status := l_status + (gamma_inst.gsl_sf_choose_e (a_two_jb.to_natural_32, l_jcc.to_natural_32, l_bcn2.address))
							l_status := l_status + (gamma_inst.gsl_sf_choose_e ((l_jsum + 1).to_natural_32, l_jcc.to_natural_32, l_bcd1.address))
							l_status := l_status + (gamma_inst.gsl_sf_choose_e (a_two_ja.to_natural_32, l_jmma.to_natural_32, l_bcd2.address))
							l_status := l_status + (gamma_inst.gsl_sf_choose_e (a_two_jb.to_natural_32, l_jmmb.to_natural_32, l_bcd3.address))
							l_status := l_status + (gamma_inst.gsl_sf_choose_e (a_two_jc.to_natural_32, l_jpmc.to_natural_32, l_bcd4.address))
							if l_status /= 0 then
								from
								until
									js.loop_left
								loop
									js.reset
									a_result.item.val := (builtin_inff).to_double
									a_result.item.err := (builtin_inff).to_double
									from
									until
										js.loop_left
									loop
										js.reset
										error_inst.gsl_error (ce_string ("overflow"), ce_string ("coupling.c"), 150, 16)
										Result := 16
										js.return
										if not js.return_called then
											js.break
										end
									end
									js.reset
									if not js.return_called then
										js.break
									end
								end
								js.reset
							end
							if not js.return_called then
								l_tmp___12 := sqrt (l_bcn1.val * l_bcn2.val)
								l_norm___0 := l_tmp___12 / (sqrt ((((l_bcd1.val * l_bcd2.val) * l_bcd3.val) * l_bcd4.val) * (a_two_jc.to_double + 1.0)))
								l_k := l_kmin
								from
								until
									not (not js.loop_left and then (l_k <= l_kmax___0))
								loop
									l_status := l_status + (gamma_inst.gsl_sf_choose_e (l_jcc.to_natural_32, l_k.to_natural_32, l_bc1.address))
									l_status := l_status + (gamma_inst.gsl_sf_choose_e (l_jcb.to_natural_32, (l_jmma - l_k).to_natural_32, l_bc2.address))
									l_status := l_status + (gamma_inst.gsl_sf_choose_e (l_jca.to_natural_32, (l_jpmb - l_k).to_natural_32, l_bc3.address))
									if l_status /= 0 then
										from
										until
											js.loop_left
										loop
											js.reset
											a_result.item.val := (builtin_inff).to_double
											a_result.item.err := (builtin_inff).to_double
											from
											until
												js.loop_left
											loop
												js.reset
												error_inst.gsl_error (ce_string ("overflow"), ce_string ("coupling.c"), 162, 16)
												Result := 16
												js.return
												if not js.return_called then
													js.break
												end
											end
											js.reset
											if not js.return_called then
												js.break
											end
										end
										js.reset
									end
									if not js.return_called then
										l_term := (l_bc1.val * l_bc2.val) * l_bc3.val
										if l_sign < 0 then
											l_sum_neg := l_sum_neg + (l_norm___0 * l_term)
										else
											l_sum_pos := l_sum_pos + (l_norm___0 * l_term)
										end
										l_sign := -l_sign
										l_k := l_k + 1
									end
								end
							end
							if not js.return_called then
								a_result.item.val := l_sum_pos - l_sum_neg
								a_result.item.err := (2.0 * 2.2204460492503131e-16) * (l_sum_pos + l_sum_neg)
								a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * (l_kmax___0 - l_kmin).to_double) * (fabs (a_result.item.val)))
								Result := 0
								js.return
							end
						end
				when 10 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_coupling_6j_INCORRECT_e (a_two_ja: INTEGER_32; a_two_jb: INTEGER_32; a_two_jc: INTEGER_32; a_two_jd: INTEGER_32; a_two_je: INTEGER_32; a_two_jf: INTEGER_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		do
			Result := (gsl_sf_coupling_6j_e (a_two_ja, a_two_jb, a_two_je, a_two_jd, a_two_jc, a_two_jf, a_result))
		end

	gsl_sf_coupling_6j_e (a_two_ja: INTEGER_32; a_two_jb: INTEGER_32; a_two_jc: INTEGER_32; a_two_jd: INTEGER_32; a_two_je: INTEGER_32; a_two_jf: INTEGER_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_n1: PD_GSL_SF_RESULT_STRUCT
			l_d1: PD_GSL_SF_RESULT_STRUCT
			l_d2: PD_GSL_SF_RESULT_STRUCT
			l_d3: PD_GSL_SF_RESULT_STRUCT
			l_d4: PD_GSL_SF_RESULT_STRUCT
			l_d5: PD_GSL_SF_RESULT_STRUCT
			l_d6: PD_GSL_SF_RESULT_STRUCT
			l_norm___0: REAL_64
			l_tk: INTEGER_32
			l_tkmin: INTEGER_32
			l_tkmax: INTEGER_32
			l_phase: REAL_64
			l_sum_pos: REAL_64
			l_sum_neg: REAL_64
			l_sumsq_err: REAL_64
			l_status: INTEGER_32
			l_tmp___7: REAL_64
			l_tmp___8: REAL_64
			l_tmp___9: REAL_64
			l_term: REAL_64
			l_term_err: REAL_64
			l_den_1: PD_GSL_SF_RESULT_STRUCT
			l_den_2: PD_GSL_SF_RESULT_STRUCT
			l_d1_a: PD_GSL_SF_RESULT_STRUCT
			l_d1_b: PD_GSL_SF_RESULT_STRUCT
			l_tmp___21: REAL_64
			l_tmp___29: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_n1.make
			create l_d1.make
			create l_d2.make
			create l_d3.make
			create l_d4.make
			create l_d5.make
			create l_d6.make
			create l_den_1.make
			create l_den_2.make
			create l_d1_a.make
			create l_d1_b.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_two_ja < 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 3 then -- else:
						if not (a_two_jb < 0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 6 then -- else:
						if not (a_two_jc < 0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 9 then -- else:
						if not (a_two_jd < 0) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 12 then -- else:
						if not (a_two_je < 0) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 15 then -- else:
						if not (a_two_jf < 0) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("coupling.c"), 203, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						if (triangle_selection_fails (a_two_ja, a_two_jb, a_two_jc)).to_boolean then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							Result := 0
							js.return
						elseif (triangle_selection_fails (a_two_ja, a_two_je, a_two_jf)).to_boolean then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							Result := 0
							js.return
						elseif (triangle_selection_fails (a_two_jb, a_two_jd, a_two_jf)).to_boolean then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							Result := 0
							js.return
						elseif (triangle_selection_fails (a_two_je, a_two_jd, a_two_jc)).to_boolean then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							Result := 0
							js.return
						else
							l_sum_pos := 0.0
							l_sum_neg := 0.0
							l_sumsq_err := 0.0
							l_status := 0
							l_status := l_status + (delta (a_two_ja, a_two_jb, a_two_jc, l_d1.address))
							l_status := l_status + (delta (a_two_ja, a_two_je, a_two_jf, l_d2.address))
							l_status := l_status + (delta (a_two_jb, a_two_jd, a_two_jf, l_d3.address))
							l_status := l_status + (delta (a_two_je, a_two_jd, a_two_jc, l_d4.address))
							if l_status /= 0 then
								from
								until
									js.loop_left
								loop
									js.reset
									a_result.item.val := (builtin_inff).to_double
									a_result.item.err := (builtin_inff).to_double
									from
									until
										js.loop_left
									loop
										js.reset
										error_inst.gsl_error (ce_string ("overflow"), ce_string ("coupling.c"), 229, 16)
										Result := 16
										js.return
										if not js.return_called then
											js.break
										end
									end
									js.reset
									if not js.return_called then
										js.break
									end
								end
								js.reset
							end
							if not js.return_called then
								l_tmp___7 := sqrt (l_d1.val)
								l_tmp___8 := sqrt (l_d2.val)
								l_tmp___9 := sqrt (l_d3.val)
								l_norm___0 := ((l_tmp___7 * l_tmp___8) * l_tmp___9) * (sqrt (l_d4.val))
								l_tkmin := locMax32 (0, ((a_two_ja + a_two_jd) - a_two_jc) - a_two_jf, ((a_two_jb + a_two_je) - a_two_jc) - a_two_jf)
								l_tkmax := locMin5 ((((a_two_ja + a_two_jb) + a_two_je) + a_two_jd) + 2, (a_two_ja + a_two_jb) - a_two_jc, (a_two_je + a_two_jd) - a_two_jc, (a_two_ja + a_two_je) - a_two_jf, (a_two_jb + a_two_jd) - a_two_jf)
								if ((((((a_two_ja + a_two_jb) + a_two_je) + a_two_jd) + l_tkmin) // 2).bit_and (1)).to_boolean then
									l_phase := -1.0
								else
									l_phase := 1.0
								end
								l_tk := l_tkmin
								from
								until
									not (not js.loop_left and then (l_tk <= l_tkmax))
								loop
									l_status := 0
									l_status := l_status + (gamma_inst.gsl_sf_fact_e ((((((a_two_ja + a_two_jb) + a_two_je) + a_two_jd) - l_tk) // 2 + 1).to_natural_32, l_n1.address))
									l_status := l_status + (gamma_inst.gsl_sf_fact_e ((l_tk // 2).to_natural_32, l_d1_a.address))
									l_status := l_status + (gamma_inst.gsl_sf_fact_e ((((((a_two_jc + a_two_jf) - a_two_ja) - a_two_jd) + l_tk) // 2).to_natural_32, l_d1_b.address))
									l_status := l_status + (gamma_inst.gsl_sf_fact_e ((((((a_two_jc + a_two_jf) - a_two_jb) - a_two_je) + l_tk) // 2).to_natural_32, l_d2.address))
									l_status := l_status + (gamma_inst.gsl_sf_fact_e (((((a_two_ja + a_two_jb) - a_two_jc) - l_tk) // 2).to_natural_32, l_d3.address))
									l_status := l_status + (gamma_inst.gsl_sf_fact_e (((((a_two_je + a_two_jd) - a_two_jc) - l_tk) // 2).to_natural_32, l_d4.address))
									l_status := l_status + (gamma_inst.gsl_sf_fact_e (((((a_two_ja + a_two_je) - a_two_jf) - l_tk) // 2).to_natural_32, l_d5.address))
									l_status := l_status + (gamma_inst.gsl_sf_fact_e (((((a_two_jb + a_two_jd) - a_two_jf) - l_tk) // 2).to_natural_32, l_d6.address))
									if l_status /= 0 then
										from
										until
											js.loop_left
										loop
											js.reset
											a_result.item.val := (builtin_inff).to_double
											a_result.item.err := (builtin_inff).to_double
											from
											until
												js.loop_left
											loop
												js.reset
												error_inst.gsl_error (ce_string ("overflow"), ce_string ("coupling.c"), 264, 16)
												Result := 16
												js.return
												if not js.return_called then
													js.break
												end
											end
											js.reset
											if not js.return_called then
												js.break
											end
										end
										js.reset
									end
									if not js.return_called then
										l_d1.val := l_d1_a.val * l_d1_b.val
										l_tmp___21 := fabs (l_d1_b.val)
										l_d1.err := l_d1_a.err * l_tmp___21 + (fabs (l_d1_a.val)) * l_d1_b.err
										l_den_1.val := (l_d1.val * l_d2.val) * l_d3.val
										l_den_1.err := l_d1.err * (fabs (l_d2.val * l_d3.val))
										l_den_1.err := l_den_1.err + (l_d2.err * (fabs (l_d1.val * l_d3.val)))
										l_den_1.err := l_den_1.err + (l_d3.err * (fabs (l_d1.val * l_d2.val)))
										l_den_2.val := (l_d4.val * l_d5.val) * l_d6.val
										l_den_2.err := l_d4.err * (fabs (l_d5.val * l_d6.val))
										l_den_2.err := l_den_2.err + (l_d5.err * (fabs (l_d4.val * l_d6.val)))
										l_den_2.err := l_den_2.err + (l_d6.err * (fabs (l_d4.val * l_d5.val)))
										l_term := ((l_phase * l_n1.val) / l_den_1.val) / l_den_2.val
										l_phase := -l_phase
										l_tmp___29 := fabs (l_den_1.val)
										l_term_err := (l_n1.err / l_tmp___29) / (fabs (l_den_2.val))
										l_term_err := l_term_err + ((fabs (l_term / l_den_1.val)) * l_den_1.err)
										l_term_err := l_term_err + ((fabs (l_term / l_den_2.val)) * l_den_2.err)
										if l_term >= 0.0 then
											l_sum_pos := l_sum_pos + (l_norm___0 * l_term)
										else
											l_sum_neg := l_sum_neg - (l_norm___0 * l_term)
										end
										l_sumsq_err := l_sumsq_err + (((l_norm___0 * l_norm___0) * l_term_err) * l_term_err)
										l_tk := l_tk + (2)
									end
								end
							end
							if not js.return_called then
								a_result.item.val := l_sum_pos - l_sum_neg
								a_result.item.err := (2.0 * 2.2204460492503131e-16) * (l_sum_pos + l_sum_neg)
								a_result.item.err := a_result.item.err + (sqrt (l_sumsq_err / (0.5 * (l_tkmax - l_tkmin).to_double + 1.0)))
								a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * ((l_tkmax - l_tkmin).to_double + 2.0)) * (fabs (a_result.item.val)))
								Result := 0
								js.return
							end
						end
				when 19 then -- if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 20 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_coupling_RacahW_e (a_two_ja: INTEGER_32; a_two_jb: INTEGER_32; a_two_jc: INTEGER_32; a_two_jd: INTEGER_32; a_two_je: INTEGER_32; a_two_jf: INTEGER_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_status: INTEGER_32
			l_phase_sum: INTEGER_32
			l_tmp___0: REAL_64
		do
			l_status := (gsl_sf_coupling_6j_e (a_two_ja, a_two_jb, a_two_je, a_two_jd, a_two_jc, a_two_jf, a_result))
			l_phase_sum := (((a_two_ja + a_two_jb) + a_two_jc) + a_two_jd) // 2
			if ((l_phase_sum).bit_and (1)).to_boolean then
				l_tmp___0 := -1.0
			else
				l_tmp___0 := 1.0
			end
			a_result.item.val := a_result.item.val * l_tmp___0
			Result := l_status
		end

	gsl_sf_coupling_9j_e (a_two_ja: INTEGER_32; a_two_jb: INTEGER_32; a_two_jc: INTEGER_32; a_two_jd: INTEGER_32; a_two_je: INTEGER_32; a_two_jf: INTEGER_32; a_two_jg: INTEGER_32; a_two_jh: INTEGER_32; a_two_ji: INTEGER_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_tk: INTEGER_32
			l_tkmin: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tkmax: INTEGER_32
			l_sum_pos: REAL_64
			l_sum_neg: REAL_64
			l_sumsq_err: REAL_64
			l_phase: REAL_64
			l_s1: PD_GSL_SF_RESULT_STRUCT
			l_s2: PD_GSL_SF_RESULT_STRUCT
			l_s3: PD_GSL_SF_RESULT_STRUCT
			l_term: REAL_64
			l_term_err: REAL_64
			l_status: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s1.make
			create l_s2.make
			create l_s3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_two_ja < 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 25 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 3 then -- else:
						if not (a_two_jb < 0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 25 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 6 then -- else:
						if not (a_two_jc < 0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 25 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 9 then -- else:
						if not (a_two_jd < 0) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 25 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 12 then -- else:
						if not (a_two_je < 0) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 25 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 15 then -- else:
						if not (a_two_jf < 0) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 25 -- goto _L
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 18 then -- else:
						if not (a_two_jg < 0) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 25 -- goto _L
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 21 then -- else:
						if not (a_two_jh < 0) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_pos := -1 + 25 -- goto _L
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 24 then -- else:
						if not (a_two_ji < 0) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("coupling.c"), 330, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else:
						if (triangle_selection_fails (a_two_ja, a_two_jb, a_two_jc)).to_boolean then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							Result := 0
							js.return
						elseif (triangle_selection_fails (a_two_jd, a_two_je, a_two_jf)).to_boolean then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							Result := 0
							js.return
						elseif (triangle_selection_fails (a_two_jg, a_two_jh, a_two_ji)).to_boolean then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							Result := 0
							js.return
						elseif (triangle_selection_fails (a_two_ja, a_two_jd, a_two_jg)).to_boolean then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							Result := 0
							js.return
						elseif (triangle_selection_fails (a_two_jb, a_two_je, a_two_jh)).to_boolean then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							Result := 0
							js.return
						elseif (triangle_selection_fails (a_two_jc, a_two_jf, a_two_ji)).to_boolean then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							Result := 0
							js.return
						else
							l_tmp___1 := abs (a_two_jb - a_two_jf)
							l_tmp___2 := abs (a_two_jh - a_two_jd)
							l_tkmin := (locMax32 ((abs (a_two_ja - a_two_ji)), l_tmp___2, l_tmp___1))
							l_tkmax := (locMin3 (a_two_ja + a_two_ji, a_two_jh + a_two_jd, a_two_jb + a_two_jf))
							l_sum_pos := 0.0
							l_sum_neg := 0.0
							l_sumsq_err := 0.0
							l_tk := l_tkmin
							from
							until
								not (not js.loop_left and then (l_tk <= l_tkmax))
							loop
								l_status := 0
								l_status := l_status + (gsl_sf_coupling_6j_e (a_two_ja, a_two_ji, l_tk, a_two_jh, a_two_jd, a_two_jg, l_s1.address))
								l_status := l_status + (gsl_sf_coupling_6j_e (a_two_jb, a_two_jf, l_tk, a_two_jd, a_two_jh, a_two_je, l_s2.address))
								l_status := l_status + (gsl_sf_coupling_6j_e (a_two_ja, a_two_ji, l_tk, a_two_jf, a_two_jb, a_two_jc, l_s3.address))
								if l_status /= 0 then
									from
									until
										js.loop_left
									loop
										js.reset
										a_result.item.val := (builtin_inff).to_double
										a_result.item.err := (builtin_inff).to_double
										from
										until
											js.loop_left
										loop
											js.reset
											error_inst.gsl_error (ce_string ("overflow"), ce_string ("coupling.c"), 362, 16)
											Result := 16
											js.return
											if not js.return_called then
												js.break
											end
										end
										js.reset
										if not js.return_called then
											js.break
										end
									end
									js.reset
								end
								if not js.return_called then
									l_term := (l_s1.val * l_s2.val) * l_s3.val
									l_term_err := l_s1.err * (fabs (l_s2.val * l_s3.val))
									l_term_err := l_term_err + (l_s2.err * (fabs (l_s1.val * l_s3.val)))
									l_term_err := l_term_err + (l_s3.err * (fabs (l_s1.val * l_s2.val)))
									if l_term >= 0.0 then
										l_sum_pos := l_sum_pos + ((l_tk + 1).to_double * l_term)
									else
										l_sum_neg := l_sum_neg - ((l_tk + 1).to_double * l_term)
									end
									l_sumsq_err := l_sumsq_err + (((l_tk + 1).to_double * l_term_err) * ((l_tk + 1).to_double * l_term_err))
									l_tk := l_tk + (2)
								end
							end
							if not js.return_called then
								if ((l_tkmin).bit_and (1)).to_boolean then
									l_phase := -1.0
								else
									l_phase := 1.0
								end
								a_result.item.val := l_phase * (l_sum_pos - l_sum_neg)
								a_result.item.err := (2.0 * 2.2204460492503131e-16) * (l_sum_pos + l_sum_neg)
								a_result.item.err := a_result.item.err + (sqrt (l_sumsq_err / (0.5 * (l_tkmax - l_tkmin).to_double + 1.0)))
								a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * ((l_tkmax - l_tkmin).to_double + 2.0)) * (fabs (a_result.item.val)))
								Result := 0
								js.return
							end
						end
				when 28 then -- if done | if done | if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 29 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_coupling_3j (a_two_ja: INTEGER_32; a_two_jb: INTEGER_32; a_two_jc: INTEGER_32; a_two_ma: INTEGER_32; a_two_mb: INTEGER_32; a_two_mc: INTEGER_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_coupling_3j_e (a_two_ja, a_two_jb, a_two_jc, a_two_ma, a_two_mb, a_two_mc, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_coupling_3j_e(two_ja, two_jb, two_jc, two_ma, two_mb, two_mc, &result)"), ce_string ("coupling.c"), 400, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_coupling_6j_INCORRECT (a_two_ja: INTEGER_32; a_two_jb: INTEGER_32; a_two_jc: INTEGER_32; a_two_jd: INTEGER_32; a_two_je: INTEGER_32; a_two_jf: INTEGER_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_coupling_6j_INCORRECT_e (a_two_ja, a_two_jb, a_two_jc, a_two_jd, a_two_je, a_two_jf, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_coupling_6j_INCORRECT_e(two_ja, two_jb, two_jc, two_jd, two_je, two_jf, &result)"), ce_string ("coupling.c"), 409, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_coupling_6j (a_two_ja: INTEGER_32; a_two_jb: INTEGER_32; a_two_jc: INTEGER_32; a_two_jd: INTEGER_32; a_two_je: INTEGER_32; a_two_jf: INTEGER_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_coupling_6j_e (a_two_ja, a_two_jb, a_two_jc, a_two_jd, a_two_je, a_two_jf, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_coupling_6j_e(two_ja, two_jb, two_jc, two_jd, two_je, two_jf, &result)"), ce_string ("coupling.c"), 418, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_coupling_RacahW (a_two_ja: INTEGER_32; a_two_jb: INTEGER_32; a_two_jc: INTEGER_32; a_two_jd: INTEGER_32; a_two_je: INTEGER_32; a_two_jf: INTEGER_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_coupling_RacahW_e (a_two_ja, a_two_jb, a_two_jc, a_two_jd, a_two_je, a_two_jf, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_coupling_RacahW_e(two_ja, two_jb, two_jc, two_jd, two_je, two_jf, &result)"), ce_string ("coupling.c"), 427, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_coupling_9j (a_two_ja: INTEGER_32; a_two_jb: INTEGER_32; a_two_jc: INTEGER_32; a_two_jd: INTEGER_32; a_two_je: INTEGER_32; a_two_jf: INTEGER_32; a_two_jg: INTEGER_32; a_two_jh: INTEGER_32; a_two_ji: INTEGER_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_coupling_9j_e (a_two_ja, a_two_jb, a_two_jc, a_two_jd, a_two_je, a_two_jf, a_two_jg, a_two_jh, a_two_ji, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_coupling_9j_e(two_ja, two_jb, two_jc, two_jd, two_je, two_jf, two_jg, two_jh, two_ji, &result)"), ce_string ("coupling.c"), 438, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
