class
	P_COVAR

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_multifit_covar (a_J: CE_POINTER [PD_GSL_MATRIX]; a_epsrel: REAL_64; a_covar: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_tolr: REAL_64
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_kmax___0: NATURAL_32
			l_r___3: CE_POINTER [PD_GSL_MATRIX]
			l_tau: CE_POINTER [PD_GSL_VECTOR]
			l_norm___0: CE_POINTER [PD_GSL_VECTOR]
			l_perm: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
			l_m___4: NATURAL_32
			l_n: NATURAL_32
			l_signum: INTEGER_32
			l_rkk: REAL_64
			l_t: REAL_64
			l_rik: REAL_64
			l_rij: REAL_64
			l_rjk: REAL_64
			l_rij___0: REAL_64
			l_rik___0: REAL_64
			l_t___0: REAL_64
			l_rik___1: REAL_64
			l_pj: NATURAL_32
			l_pi: NATURAL_32
			l_rij___1: REAL_64
			l_rjj: REAL_64
			l_rji: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_r___3.make
			create l_tau.make
			create l_norm___0.make
			create l_perm.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_kmax___0 := (0).to_natural_32
					l_m___4 := a_J.item.size1
					l_n := a_J.item.size2
					if l_m___4 < l_n then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("Jacobian be rectangular M x N with M >= N"), ce_string ("covar.c"), 51, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if a_covar.item.size1 = a_covar.item.size2 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if a_covar.item.size1 = l_n then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("covariance matrix must be square and match second dimension of jacobian"), ce_string ("covar.c"), 56, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 6 then -- if done | if done
						if not js.return_called then
							l_r___3.ce_gets (init_source_inst.gsl_matrix_alloc (l_m___4, l_n))
							l_tau.ce_gets (init_source_inst.gsl_vector_alloc (l_n))
							l_perm.ce_gets (init_inst.gsl_permutation_alloc (l_n))
							l_norm___0.ce_gets (init_source_inst.gsl_vector_alloc (l_n))
							l_signum := 0
							copy_source_inst.gsl_matrix_memcpy (l_r___3, a_J).do_nothing
							qrpt_inst.gsl_linalg_QRPT_decomp (l_r___3, l_tau, l_perm, create {CE_POINTER [INTEGER_32]}.make_shared ($l_signum), l_norm___0).do_nothing
							l_tolr := a_epsrel * (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (l_r___3, (0).to_natural_32, (0).to_natural_32))))
							l_k := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_k < l_n))
							loop
								js.reset
								l_rkk := (gsl_gsl_matrix_double_inst.gsl_matrix_get (l_r___3, l_k, l_k))
								if (fabs (l_rkk)) <= l_tolr then
									js.break
								end
								if not js.loop_jumped then
									gsl_gsl_matrix_double_inst.gsl_matrix_set (l_r___3, l_k, l_k, 1.0 / l_rkk)
									l_j := (0).to_natural_32
									from
									until
										not (not js.loop_left and then (l_j < l_k))
									loop
										l_t := (gsl_gsl_matrix_double_inst.gsl_matrix_get (l_r___3, l_j, l_k)) / l_rkk
										gsl_gsl_matrix_double_inst.gsl_matrix_set (l_r___3, l_j, l_k, 0.0)
										l_i := (0).to_natural_32
										from
										until
											not (l_i <= l_j)
										loop
											l_rik := (gsl_gsl_matrix_double_inst.gsl_matrix_get (l_r___3, l_i, l_k))
											l_rij := (gsl_gsl_matrix_double_inst.gsl_matrix_get (l_r___3, l_i, l_j))
											gsl_gsl_matrix_double_inst.gsl_matrix_set (l_r___3, l_i, l_k, l_rik - l_t * l_rij)
											l_i := l_i + 1
										end
										l_j := l_j + 1
									end
									l_kmax___0 := l_k
									l_k := l_k + 1
								end
							end
							js.reset
							l_k := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_k <= l_kmax___0))
							loop
								l_j := (0).to_natural_32
								from
								until
									not (not js.loop_left and then (l_j < l_k))
								loop
									l_rjk := (gsl_gsl_matrix_double_inst.gsl_matrix_get (l_r___3, l_j, l_k))
									l_i := (0).to_natural_32
									from
									until
										not (l_i <= l_j)
									loop
										l_rij___0 := (gsl_gsl_matrix_double_inst.gsl_matrix_get (l_r___3, l_i, l_j))
										l_rik___0 := (gsl_gsl_matrix_double_inst.gsl_matrix_get (l_r___3, l_i, l_k))
										gsl_gsl_matrix_double_inst.gsl_matrix_set (l_r___3, l_i, l_j, l_rij___0 + l_rjk * l_rik___0)
										l_i := l_i + 1
									end
									l_j := l_j + 1
								end
								l_t___0 := (gsl_gsl_matrix_double_inst.gsl_matrix_get (l_r___3, l_k, l_k))
								l_i := (0).to_natural_32
								from
								until
									not (l_i <= l_k)
								loop
									l_rik___1 := (gsl_gsl_matrix_double_inst.gsl_matrix_get (l_r___3, l_i, l_k))
									gsl_gsl_matrix_double_inst.gsl_matrix_set (l_r___3, l_i, l_k, l_t___0 * l_rik___1)
									l_i := l_i + 1
								end
								l_k := l_k + 1
							end
							l_j := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_j < l_n))
							loop
								l_pj := (gsl_gsl_permutation_inst.gsl_permutation_get (l_perm, l_j))
								l_i := (0).to_natural_32
								from
								until
									not (l_i <= l_j)
								loop
									l_pi := (gsl_gsl_permutation_inst.gsl_permutation_get (l_perm, l_i))
									if l_j > l_kmax___0 then
										gsl_gsl_matrix_double_inst.gsl_matrix_set (l_r___3, l_i, l_j, 0.0)
										l_rij___1 := 0.0
									else
										l_rij___1 := gsl_gsl_matrix_double_inst.gsl_matrix_get (l_r___3, l_i, l_j)
									end
									if l_pi > l_pj then
										gsl_gsl_matrix_double_inst.gsl_matrix_set (l_r___3, l_pi, l_pj, l_rij___1)
									elseif l_pi < l_pj then
										gsl_gsl_matrix_double_inst.gsl_matrix_set (l_r___3, l_pj, l_pi, l_rij___1)
									end
									l_i := l_i + 1
								end
								l_rjj := (gsl_gsl_matrix_double_inst.gsl_matrix_get (l_r___3, l_j, l_j))
								gsl_gsl_matrix_double_inst.gsl_matrix_set (a_covar, l_pj, l_pj, l_rjj)
								l_j := l_j + 1
							end
							l_j := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_j < l_n))
							loop
								l_i := (0).to_natural_32
								from
								until
									not (l_i < l_j)
								loop
									l_rji := (gsl_gsl_matrix_double_inst.gsl_matrix_get (l_r___3, l_j, l_i))
									gsl_gsl_matrix_double_inst.gsl_matrix_set (a_covar, l_j, l_i, l_rji)
									gsl_gsl_matrix_double_inst.gsl_matrix_set (a_covar, l_i, l_j, l_rji)
									l_i := l_i + 1
								end
								l_j := l_j + 1
							end
							init_source_inst.gsl_matrix_free (l_r___3)
							init_inst.gsl_permutation_free (l_perm)
							init_source_inst.gsl_vector_free (l_tau)
							init_source_inst.gsl_vector_free (l_norm___0)
							Result := 0
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
