class
	P_CSCAL

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create sc_control_type.make
			create gsl_odeiv_control_scaled.make
		end

feature {ANY} -- attributes

	sc_control_type: PD_GSL_ODEIV_CONTROL_TYPE

	gsl_odeiv_control_scaled: CE_POINTER [PD_GSL_ODEIV_CONTROL_TYPE]

feature {ANY} -- routines

	sc_control_alloc: CE_POINTER [ANY]
		local
			l_s: CE_POINTER [PD_SC_CONTROL_STATE_T]
			js: JUMP_STATE
		do
			create l_s.make

			l_s.ce_gets (create {CE_POINTER [PD_SC_CONTROL_STATE_T]}.make_cast ((malloc ({PD_SC_CONTROL_STATE_T}.sizeof.to_natural_32))))
			if (l_s.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("failed to allocate space for sc_control_state"), ce_string ("cscal.c"), 47, 8)
					Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (create {CE_POINTER [ANY]}.make_cast (l_s))
			end
		end

	sc_control_alloc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent sc_control_alloc)
		end

	sc_control_init (a_vstate: CE_POINTER [ANY]; a_eps_abs: REAL_64; a_eps_rel: REAL_64; a_a_y: REAL_64; a_a_dydt: REAL_64): INTEGER_32
		local
			l_s: CE_POINTER [PD_SC_CONTROL_STATE_T]
			js: JUMP_STATE
		do
			create l_s.make

			l_s.ce_gets (create {CE_POINTER [PD_SC_CONTROL_STATE_T]}.make_cast (a_vstate))
			if a_eps_abs < (0).to_double then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("eps_abs is negative"), ce_string ("cscal.c"), 61, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_eps_rel < (0).to_double then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("eps_rel is negative"), ce_string ("cscal.c"), 65, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_a_y < (0).to_double then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("a_y is negative"), ce_string ("cscal.c"), 69, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_a_dydt < (0).to_double then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("a_dydt is negative"), ce_string ("cscal.c"), 73, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.item.eps_rel := a_eps_rel
				l_s.item.eps_abs := a_eps_abs
				l_s.item.a_y := a_a_y
				l_s.item.a_dydt := a_a_dydt
				Result := 0
			end
		end

	sc_control_init_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent sc_control_init)
		end

	sc_control_hadjust (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32; a_ord: NATURAL_32; a_y: CE_POINTER [REAL_64]; a_yerr: CE_POINTER [REAL_64]; a_yp: CE_POINTER [REAL_64]; a_h: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_state: CE_POINTER [PD_SC_CONTROL_STATE_T]
			l_eps_abs: REAL_64
			l_eps_rel: REAL_64
			l_a_y: REAL_64
			l_a_dydt: REAL_64
			l_scale_abs: CE_POINTER [REAL_64]
			l_S: REAL_64
			l_h_old: REAL_64
			l_rmax: REAL_64
			l_i: NATURAL_32
			l_D0: REAL_64
			l_tmp: REAL_64
			l_r___3: REAL_64
			l_tmp___1: REAL_64
			l_r___4: REAL_64
			l_r___5: REAL_64
		do
			create l_state.make
			create l_scale_abs.make

			l_state.ce_gets (create {CE_POINTER [PD_SC_CONTROL_STATE_T]}.make_cast (a_vstate))
			l_eps_abs := l_state.item.eps_abs
			l_eps_rel := l_state.item.eps_rel
			l_a_y := l_state.item.a_y
			l_a_dydt := l_state.item.a_dydt
			l_scale_abs.ce_gets (l_state.item.scale_abs)
			l_S := 0.9
			l_h_old := a_h.item
			l_rmax := (real_96_from_real_64 (2.22507385850720138309e-308)).truncated_to_real_64
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_dim)
			loop
				l_tmp := fabs (a_y[l_i.to_integer_32])
				l_D0 := l_eps_rel * (l_a_y * l_tmp + l_a_dydt * (fabs (l_h_old * a_yp[l_i.to_integer_32]))) + l_eps_abs * l_scale_abs[l_i.to_integer_32]
				l_tmp___1 := fabs (a_yerr[l_i.to_integer_32])
				l_r___3 := l_tmp___1 / (fabs (l_D0))
				l_rmax := gsl_gsl_minmax_inst.GSL_MAX_DBL (l_r___3, l_rmax)
				l_i := l_i + 1
			end
			if l_rmax > 1.1 then
				l_r___4 := l_S / (pow (l_rmax, 1.0 / a_ord.to_real_64))
				if l_r___4 < 0.2 then
					l_r___4 := 0.2
				end
				a_h.item := l_r___4 * l_h_old
				Result := (-1)
			elseif l_rmax < 0.5 then
				l_r___5 := l_S / (pow (l_rmax, 1.0 / (a_ord.to_real_64 + 1.0)))
				if l_r___5 > 5.0 then
					l_r___5 := 5.0
				end
				if l_r___5 < 1.0 then
					l_r___5 := 1.0
				end
				a_h.item := l_r___5 * l_h_old
				Result := 1
			else
				Result := 0
			end
		end

	sc_control_hadjust_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent sc_control_hadjust)
		end

	sc_control_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_SC_CONTROL_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_SC_CONTROL_STATE_T]}.make_cast (a_vstate))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.scale_abs))
			free (create {CE_POINTER [ANY]}.make_cast (l_state))
		end

	sc_control_free_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent sc_control_free)
		end

	gsl_odeiv_control_scaled_new (a_eps_abs: REAL_64; a_eps_rel: REAL_64; a_a_y: REAL_64; a_a_dydt: REAL_64; a_scale_abs: CE_POINTER [REAL_64]; a_dim: NATURAL_32): CE_POINTER [PD_GSL_ODEIV_CONTROL]
		local
			l_c___1: CE_POINTER [PD_GSL_ODEIV_CONTROL]
			l_status: INTEGER_32
			l_s: CE_POINTER [PD_SC_CONTROL_STATE_T]
			js: JUMP_STATE
		do
			create l_c___1.make
			create l_s.make

			l_c___1.ce_gets ((control_inst.gsl_odeiv_control_alloc (gsl_odeiv_control_scaled)))
			l_status := (control_inst.gsl_odeiv_control_init (l_c___1, a_eps_abs, a_eps_rel, a_a_y, a_a_dydt))
			if l_status /= 0 then
				control_inst.gsl_odeiv_control_free (l_c___1)
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("error trying to initialize control"), ce_string ("cscal.c"), 174, l_status)
					Result := (create {CE_POINTER [PD_GSL_ODEIV_CONTROL]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.ce_gets (create {CE_POINTER [PD_SC_CONTROL_STATE_T]}.make_cast (l_c___1.item.state))
				l_s.item.scale_abs := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * Real_64_bytes.to_natural_32)))
				if ((l_s.item.scale_abs).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for scale_abs"), ce_string ("cscal.c"), 186, 8)
						Result := (create {CE_POINTER [PD_GSL_ODEIV_CONTROL]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_s.item.scale_abs), create {CE_POINTER [ANY]}.make_cast (a_scale_abs), a_dim * Real_64_bytes.to_natural_32).do_nothing
				Result := l_c___1
			end
		end

	cblas_cscal (a_N: INTEGER_32; a_alpha: CE_POINTER [ANY]; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32)
		local
			l_i: INTEGER_32
			l_ix: INTEGER_32
			l_alpha_real: REAL_32
			l_alpha_imag: REAL_32
			l_x_real: REAL_32
			l_x_imag: REAL_32
			js: JUMP_STATE
		do
			l_ix := 0
			l_alpha_real := create {CE_POINTER [REAL_32]}.make_cast (a_alpha)[0]
			l_alpha_imag := create {CE_POINTER [REAL_32]}.make_cast (a_alpha)[1]
			if a_incX <= 0 then
				js.return
			end
			if not js.return_called then
				l_i := 0
				from
				until
					not (l_i < a_N)
				loop
					l_x_real := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix]
					l_x_imag := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix + 1)]
					create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix] := l_x_real * l_alpha_real - l_x_imag * l_alpha_imag
					create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix + 1)] := l_x_real * l_alpha_imag + l_x_imag * l_alpha_real
					l_ix := l_ix + a_incX
					l_i := l_i + 1
				end
			end
		end

end
