class
	P_CSYRK

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_csyrk (a_Order: INTEGER_32; a_Uplo: INTEGER_32; a_Trans: INTEGER_32; a_N: INTEGER_32; a_K: INTEGER_32; a_alpha: CE_POINTER [ANY]; a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32; a_beta: CE_POINTER [ANY]; a_C: CE_POINTER [ANY]; a_ldc: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_uplo: INTEGER_32
			l_trans: INTEGER_32
			l_alpha_real: REAL_32
			l_alpha_imag: REAL_32
			l_beta_real: REAL_32
			l_beta_imag: REAL_32
			l_Cij_real: REAL_32
			l_Cij_imag: REAL_32
			l_Cij_real___0: REAL_32
			l_Cij_imag___0: REAL_32
			l_temp_real: REAL_32
			l_temp_imag: REAL_32
			l_Aik_real: REAL_32
			l_Aik_imag: REAL_32
			l_Ajk_real: REAL_32
			l_Ajk_imag: REAL_32
			l_temp_real___0: REAL_32
			l_temp_imag___0: REAL_32
			l_Aki_real: REAL_32
			l_Aki_imag: REAL_32
			l_Akj_real: REAL_32
			l_Akj_imag: REAL_32
			l_temp_real___1: REAL_32
			l_temp_imag___1: REAL_32
			l_Aik_real___0: REAL_32
			l_Aik_imag___0: REAL_32
			l_Ajk_real___0: REAL_32
			l_Ajk_imag___0: REAL_32
			l_temp_real___2: REAL_32
			l_temp_imag___2: REAL_32
			l_Aki_real___0: REAL_32
			l_Aki_imag___0: REAL_32
			l_Akj_real___0: REAL_32
			l_Akj_imag___0: REAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_alpha_real := create {CE_POINTER [REAL_32]}.make_cast (a_alpha)[0]
					l_alpha_imag := create {CE_POINTER [REAL_32]}.make_cast (a_alpha)[1]
					l_beta_real := create {CE_POINTER [REAL_32]}.make_cast (a_beta)[0]
					l_beta_imag := create {CE_POINTER [REAL_32]}.make_cast (a_beta)[1]
					if l_alpha_real.to_double = 0.0 then
						if l_alpha_imag.to_double = 0.0 then
							if l_beta_real.to_double = 1.0 then
								if l_beta_imag.to_double = 0.0 then
									js.return
								end
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if a_Order.to_natural_32 = {NATURAL_32} 101 then
							l_uplo := a_Uplo
							if a_Trans.to_natural_32 = {NATURAL_32} 111 then
								l_trans := 111
							else
								l_trans := 112
							end
						else
							if a_Uplo.to_natural_32 = {NATURAL_32} 121 then
								l_uplo := 122
							else
								l_uplo := 121
							end
							if a_Trans.to_natural_32 = {NATURAL_32} 111 then
								l_trans := 112
							else
								l_trans := 111
							end
						end
						if l_beta_real.to_double /= 0.0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_beta_imag.to_double = 0.0 then
							if l_uplo = 121 then
								l_i := 0
								from
								until
									not (not js.loop_left and then (l_i < a_N))
								loop
									l_j := l_i
									from
									until
										not (l_j < a_N)
									loop
										create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := (0.0).truncated_to_real
										create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := (0.0).truncated_to_real
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								l_i := 0
								from
								until
									not (not js.loop_left and then (l_i < a_N))
								loop
									l_j := 0
									from
									until
										not (l_j <= l_i)
									loop
										create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := (0.0).truncated_to_real
										create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := (0.0).truncated_to_real
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if l_beta_real.to_double /= 1.0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_beta_imag.to_double /= 0.0 then
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if l_uplo = 121 then
							l_i := 0
							from
							until
								not (not js.loop_left and then (l_i < a_N))
							loop
								l_j := l_i
								from
								until
									not (l_j < a_N)
								loop
									l_Cij_real := create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)]
									l_Cij_imag := create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)]
									create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := l_beta_real * l_Cij_real - l_beta_imag * l_Cij_imag
									create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := l_beta_real * l_Cij_imag + l_beta_imag * l_Cij_real
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_i := 0
							from
							until
								not (not js.loop_left and then (l_i < a_N))
							loop
								l_j := 0
								from
								until
									not (l_j <= l_i)
								loop
									l_Cij_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)]
									l_Cij_imag___0 := create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)]
									create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := l_beta_real * l_Cij_real___0 - l_beta_imag * l_Cij_imag___0
									create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := l_beta_real * l_Cij_imag___0 + l_beta_imag * l_Cij_real___0
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						end
				when 8 then -- if done
						if l_alpha_real.to_double = 0.0 then
							if l_alpha_imag.to_double = 0.0 then
								js.return
							end
						end
				when 9 then -- if done
					if js.return_called then
						l_pos := -1 + 20 -- skip if block
					end
				when 10 then -- if:
						if l_uplo /= 121 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if l_trans = 111 then
							l_i := 0
							from
							until
								not (not js.loop_left and then (l_i < a_N))
							loop
								l_j := l_i
								from
								until
									not (not js.loop_left and then (l_j < a_N))
								loop
									l_temp_real := (0.0).truncated_to_real
									l_temp_imag := (0.0).truncated_to_real
									l_k := 0
									from
									until
										not (l_k < a_K)
									loop
										l_Aik_real := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
										l_Aik_imag := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)]
										l_Ajk_real := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
										l_Ajk_imag := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)]
										l_temp_real := l_temp_real + (l_Aik_real * l_Ajk_real - l_Aik_imag * l_Ajk_imag)
										l_temp_imag := l_temp_imag + (l_Aik_real * l_Ajk_imag + l_Aik_imag * l_Ajk_real)
										l_k := l_k + 1
									end
									create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_alpha_real * l_temp_real - l_alpha_imag * l_temp_imag)
									create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_alpha_real * l_temp_imag + l_alpha_imag * l_temp_real)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 13 -- goto _L___3
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else: | _L___3:
						if l_uplo /= 121 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if l_trans = 112 then
							l_i := 0
							from
							until
								not (not js.loop_left and then (l_i < a_N))
							loop
								l_j := l_i
								from
								until
									not (not js.loop_left and then (l_j < a_N))
								loop
									l_temp_real___0 := (0.0).truncated_to_real
									l_temp_imag___0 := (0.0).truncated_to_real
									l_k := 0
									from
									until
										not (l_k < a_K)
									loop
										l_Aki_real := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (l_k * a_lda + l_i)]
										l_Aki_imag := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_i) + 1)]
										l_Akj_real := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (l_k * a_lda + l_j)]
										l_Akj_imag := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_j) + 1)]
										l_temp_real___0 := l_temp_real___0 + (l_Aki_real * l_Akj_real - l_Aki_imag * l_Akj_imag)
										l_temp_imag___0 := l_temp_imag___0 + (l_Aki_real * l_Akj_imag + l_Aki_imag * l_Akj_real)
										l_k := l_k + 1
									end
									create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_alpha_real * l_temp_real___0 - l_alpha_imag * l_temp_imag___0)
									create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_alpha_real * l_temp_imag___0 + l_alpha_imag * l_temp_real___0)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 16 -- goto _L___2
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 16 then -- else: | _L___2:
						if l_uplo /= 122 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if l_trans = 111 then
							l_i := 0
							from
							until
								not (not js.loop_left and then (l_i < a_N))
							loop
								l_j := 0
								from
								until
									not (not js.loop_left and then (l_j <= l_i))
								loop
									l_temp_real___1 := (0.0).truncated_to_real
									l_temp_imag___1 := (0.0).truncated_to_real
									l_k := 0
									from
									until
										not (l_k < a_K)
									loop
										l_Aik_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
										l_Aik_imag___0 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)]
										l_Ajk_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
										l_Ajk_imag___0 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)]
										l_temp_real___1 := l_temp_real___1 + (l_Aik_real___0 * l_Ajk_real___0 - l_Aik_imag___0 * l_Ajk_imag___0)
										l_temp_imag___1 := l_temp_imag___1 + (l_Aik_real___0 * l_Ajk_imag___0 + l_Aik_imag___0 * l_Ajk_real___0)
										l_k := l_k + 1
									end
									create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_alpha_real * l_temp_real___1 - l_alpha_imag * l_temp_imag___1)
									create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_alpha_real * l_temp_imag___1 + l_alpha_imag * l_temp_real___1)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 19 -- goto _L___1
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L___1:
						if l_uplo = 122 then
							if l_trans = 112 then
								l_i := 0
								from
								until
									not (not js.loop_left and then (l_i < a_N))
								loop
									l_j := 0
									from
									until
										not (not js.loop_left and then (l_j <= l_i))
									loop
										l_temp_real___2 := (0.0).truncated_to_real
										l_temp_imag___2 := (0.0).truncated_to_real
										l_k := 0
										from
										until
											not (l_k < a_K)
										loop
											l_Aki_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (l_k * a_lda + l_i)]
											l_Aki_imag___0 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_i) + 1)]
											l_Akj_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (l_k * a_lda + l_j)]
											l_Akj_imag___0 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_j) + 1)]
											l_temp_real___2 := l_temp_real___2 + (l_Aki_real___0 * l_Akj_real___0 - l_Aki_imag___0 * l_Akj_imag___0)
											l_temp_imag___2 := l_temp_imag___2 + (l_Aki_real___0 * l_Akj_imag___0 + l_Aki_imag___0 * l_Akj_real___0)
											l_k := l_k + 1
										end
										create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_POINTER [REAL_32]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_alpha_real * l_temp_real___2 - l_alpha_imag * l_temp_imag___2)
										create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_POINTER [REAL_32]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_alpha_real * l_temp_imag___2 + l_alpha_imag * l_temp_real___2)
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								xerbla_inst.cblas_xerbla ([0, ce_string ("source_syrk_c.h"), ce_string ("unrecognized operation")])
							end
						else
							xerbla_inst.cblas_xerbla ([0, ce_string ("source_syrk_c.h"), ce_string ("unrecognized operation")])
						end
				when 20 then -- if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
