class
	P_DILOG

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
		end

feature {ANY} -- attributes

	kmax: INTEGER_32 assign set_kmax

	set_kmax (a_kmax: INTEGER_32)
		do
			kmax := a_kmax
		end

	c3___1: REAL_64 assign set_c3___1

	set_c3___1 (a_c3___1: REAL_64)
		do
			c3___1 := a_c3___1
		end

	c4___1: REAL_64 assign set_c4___1

	set_c4___1 (a_c4___1: REAL_64)
		do
			c4___1 := a_c4___1
		end

	c5___0: REAL_64 assign set_c5___0

	set_c5___0 (a_c5___0: REAL_64)
		do
			c5___0 := a_c5___0
		end

	c6___1: REAL_64 assign set_c6___1

	set_c6___1 (a_c6___1: REAL_64)
		do
			c6___1 := a_c6___1
		end

	c7: REAL_64 assign set_c7

	set_c7 (a_c7: REAL_64)
		do
			c7 := a_c7
		end

	c8: REAL_64 assign set_c8

	set_c8 (a_c8: REAL_64)
		do
			c8 := a_c8
		end

	MAGIC_SPLIT_VALUE: REAL_64 assign set_MAGIC_SPLIT_VALUE

	set_MAGIC_SPLIT_VALUE (a_MAGIC_SPLIT_VALUE: REAL_64)
		do
			MAGIC_SPLIT_VALUE := a_MAGIC_SPLIT_VALUE
		end

	zeta2: REAL_64 assign set_zeta2

	set_zeta2 (a_zeta2: REAL_64)
		do
			zeta2 := a_zeta2
		end

feature {ANY} -- routines

	dilog_series_1 (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_kmax___0: INTEGER_32
			l_sum: REAL_64
			l_term: REAL_64
			l_k: INTEGER_32
			l_rk: REAL_64
			js: JUMP_STATE
		do
			l_kmax___0 := 1000
			l_sum := a_x
			l_term := a_x
			l_k := 2
			from
			until
				not (not js.loop_left and then (l_k < l_kmax___0))
			loop
				js.reset
				l_rk := (l_k.to_double - 1.0) / l_k.to_double
				l_term := l_term * a_x
				l_term := l_term * (l_rk * l_rk)
				l_sum := l_sum + l_term
				if (fabs (l_term / l_sum)) < 2.2204460492503131e-16 then
					js.break
				end
				if not js.loop_jumped then
					l_k := l_k + 1
				end
			end
			js.reset
			a_result.item.val := l_sum
			a_result.item.err := 2.0 * (fabs (l_term))
			a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
			if l_k = l_kmax___0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("error"), ce_string ("dilog.c"), 57, 11)
					Result := 11
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	series_2 (a_r___3: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_rk: REAL_64
			l_sum: REAL_64
			l_k: INTEGER_32
			l_ds: REAL_64
			l_ds___0: REAL_64
			js: JUMP_STATE
		do
			l_rk := a_r___3
			l_sum := 0.5 * a_r___3
			l_k := 2
			from
			until
				not (l_k < 10)
			loop
				l_rk := l_rk * a_r___3
				l_ds := l_rk / ((l_k * l_k).to_double * (l_k.to_double + 1.0))
				l_sum := l_sum + l_ds
				l_k := l_k + 1
			end
			from
			until
				not (not js.loop_left and then (l_k < kmax))
			loop
				js.reset
				l_rk := l_rk * a_r___3
				l_ds___0 := l_rk / ((l_k * l_k).to_double * (l_k.to_double + 1.0))
				l_sum := l_sum + l_ds___0
				if (fabs (l_ds___0 / l_sum)) < 0.5 * 2.2204460492503131e-16 then
					js.break
				end
				if not js.loop_jumped then
					l_k := l_k + 1
				end
			end
			js.reset
			a_result.item.val := l_sum
			a_result.item.err := ((2.0 * kmax.to_double) * 2.2204460492503131e-16) * (fabs (l_sum))
			Result := 0
		end

	dilog_series_2 (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_stat_s3: INTEGER_32
			l_t: REAL_64
			l_t68: REAL_64
			l_t38: REAL_64
		do
			l_stat_s3 := (series_2 (a_x, a_result))
			if a_x > 0.01 then
				l_t := ((1.0 - a_x) * (log (1.0 - a_x))) / a_x
			else
				l_t68 := (c6___1 + (a_x * (c7 + (a_x * c8))))
				l_t38 := (c3___1 + (a_x * (c4___1 + (a_x * (c5___0 + (a_x * l_t68))))))
				l_t := (a_x - 1.0) * (1.0 + a_x * (0.5 + a_x * l_t38))
			end
			a_result.item.val := a_result.item.val + (1.0 + l_t)
			a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (l_t)))
			Result := l_stat_s3
		end

	dilog_xge0 (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ser: PD_GSL_SF_RESULT_STRUCT
			l_stat_ser: INTEGER_32
			l_log_x: REAL_64
			l_t1: REAL_64
			l_t2: REAL_64
			l_t3: REAL_64
			l_tmp___2: REAL_64
			l_tmp___3: REAL_64
			l_ser___0: PD_GSL_SF_RESULT_STRUCT
			l_stat_ser___0: INTEGER_32
			l_log_x___0: REAL_64
			l_log_term: REAL_64
			l_t1___0: REAL_64
			l_t2___0: REAL_64
			l_t3___0: REAL_64
			l_tmp___10: REAL_64
			l_tmp___11: REAL_64
			l_eps: REAL_64
			l_lne: REAL_64
			l_c0___0: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_c4___2: REAL_64
			l_c5___1: REAL_64
			l_c6___2: REAL_64
			l_c7___0: REAL_64
			l_c8___0: REAL_64
			l_ser___1: PD_GSL_SF_RESULT_STRUCT
			l_stat_ser___1: INTEGER_32
			l_log_x___1: REAL_64
			l_t1___1: REAL_64
			l_t2___1: REAL_64
			l_t3___1: REAL_64
			l_tmp___20: REAL_64
			l_tmp___21: REAL_64
		do
			create l_ser.make
			create l_ser___0.make
			create l_ser___1.make

			if a_x > 2.0 then
				l_stat_ser := (dilog_series_2 (1.0 / a_x, l_ser.address))
				l_log_x := (log (a_x))
				l_t1 := (3.14159265358979323846 * 3.14159265358979323846) / 3.0
				l_t2 := l_ser.val
				l_t3 := (0.5 * l_log_x) * l_log_x
				a_result.item.val := (l_t1 - l_t2) - l_t3
				a_result.item.err := 2.2204460492503131e-16 * (fabs (l_log_x)) + l_ser.err
				l_tmp___2 := fabs (l_t1)
				l_tmp___3 := fabs (l_t2)
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * ((l_tmp___2 + l_tmp___3) + (fabs (l_t3))))
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := l_stat_ser
			elseif a_x > 1.01 then
				l_stat_ser___0 := (dilog_series_2 (1.0 - 1.0 / a_x, l_ser___0.address))
				l_log_x___0 := (log (a_x))
				l_log_term := l_log_x___0 * ((log (1.0 - 1.0 / a_x)) + 0.5 * l_log_x___0)
				l_t1___0 := (3.14159265358979323846 * 3.14159265358979323846) / 6.0
				l_t2___0 := l_ser___0.val
				l_t3___0 := l_log_term
				a_result.item.val := (l_t1___0 + l_t2___0) - l_t3___0
				a_result.item.err := 2.2204460492503131e-16 * (fabs (l_log_x___0)) + l_ser___0.err
				l_tmp___10 := fabs (l_t1___0)
				l_tmp___11 := fabs (l_t2___0)
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * ((l_tmp___10 + l_tmp___11) + (fabs (l_t3___0))))
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := l_stat_ser___0
			elseif a_x > 1.0 then
				l_eps := a_x - 1.0
				l_lne := (log (l_eps))
				l_c0___0 := (3.14159265358979323846 * 3.14159265358979323846) / 6.0
				l_c1___2 := 1.0 - l_lne
				l_c2___0 := -(1.0 - 2.0 * l_lne) / 4.0
				l_c3___3 := (1.0 - 3.0 * l_lne) / 9.0
				l_c4___2 := -(1.0 - 4.0 * l_lne) / 16.0
				l_c5___1 := (1.0 - 5.0 * l_lne) / 25.0
				l_c6___2 := -(1.0 - 6.0 * l_lne) / 36.0
				l_c7___0 := (1.0 - 7.0 * l_lne) / 49.0
				l_c8___0 := -(1.0 - 8.0 * l_lne) / 64.0
				a_result.item.val := l_c0___0 + l_eps * (l_c1___2 + l_eps * (l_c2___0 + l_eps * (l_c3___3 + l_eps * (l_c4___2 + l_eps * (l_c5___1 + l_eps * (l_c6___2 + l_eps * (l_c7___0 + l_eps * l_c8___0)))))))
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
			elseif a_x = 1.0 then
				a_result.item.val := (3.14159265358979323846 * 3.14159265358979323846) / 6.0
				a_result.item.err := (((2.0 * 2.2204460492503131e-16) * 3.14159265358979323846) * 3.14159265358979323846) / 6.0
				Result := 0
			elseif a_x > 0.5 then
				l_stat_ser___1 := (dilog_series_2 (1.0 - a_x, l_ser___1.address))
				l_log_x___1 := (log (a_x))
				l_t1___1 := (3.14159265358979323846 * 3.14159265358979323846) / 6.0
				l_t2___1 := l_ser___1.val
				l_t3___1 := l_log_x___1 * (log (1.0 - a_x))
				a_result.item.val := (l_t1___1 - l_t2___1) - l_t3___1
				a_result.item.err := 2.2204460492503131e-16 * (fabs (l_log_x___1)) + l_ser___1.err
				l_tmp___20 := fabs (l_t1___1)
				l_tmp___21 := fabs (l_t2___1)
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * ((l_tmp___20 + l_tmp___21) + (fabs (l_t3___1))))
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := l_stat_ser___1
			elseif a_x > 0.25 then
				Result := (dilog_series_2 (a_x, a_result))
			elseif a_x > 0.0 then
				Result := (dilog_series_1 (a_x, a_result))
			else
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				Result := 0
			end
		end

	dilogc_series_1 (a_r___3: REAL_64; a_x: REAL_64; a_y: REAL_64; a_real_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_imag_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_cos_theta: REAL_64
			l_sin_theta: REAL_64
			l_alpha: REAL_64
			l_beta: REAL_64
			l_ck: REAL_64
			l_sk: REAL_64
			l_rk: REAL_64
			l_real_sum: REAL_64
			l_imag_sum: REAL_64
			l_kmax___0: INTEGER_32
			l_k: INTEGER_32
			l_dr: REAL_64
			l_di: REAL_64
			l_ck_tmp: REAL_64
			js: JUMP_STATE
		do
			l_cos_theta := a_x / a_r___3
			l_sin_theta := a_y / a_r___3
			l_alpha := 1.0 - l_cos_theta
			l_beta := l_sin_theta
			l_ck := l_cos_theta
			l_sk := l_sin_theta
			l_rk := a_r___3
			l_real_sum := a_r___3 * l_ck
			l_imag_sum := a_r___3 * l_sk
			l_kmax___0 := 50 + (22.0 / -(log (a_r___3))).truncated_to_integer
			l_k := 2
			from
			until
				not (not js.loop_left and then (l_k < l_kmax___0))
			loop
				js.reset
				l_ck_tmp := l_ck
				l_ck := l_ck - (l_alpha * l_ck + l_beta * l_sk)
				l_sk := l_sk - (l_alpha * l_sk - l_beta * l_ck_tmp)
				l_rk := l_rk * a_r___3
				l_dr := (l_rk / (l_k.to_double * l_k.to_double)) * l_ck
				l_di := (l_rk / (l_k.to_double * l_k.to_double)) * l_sk
				l_real_sum := l_real_sum + l_dr
				l_imag_sum := l_imag_sum + l_di
				if (fabs ((l_dr * l_dr + l_di * l_di) / (l_real_sum * l_real_sum + l_imag_sum * l_imag_sum))) < 2.2204460492503131e-16 * 2.2204460492503131e-16 then
					js.break
				end
				if not js.loop_jumped then
					l_k := l_k + 1
				end
			end
			js.reset
			a_real_result.item.val := l_real_sum
			a_real_result.item.err := ((2.0 * l_kmax___0.to_double) * 2.2204460492503131e-16) * (fabs (l_real_sum))
			a_imag_result.item.val := l_imag_sum
			a_imag_result.item.err := ((2.0 * l_kmax___0.to_double) * 2.2204460492503131e-16) * (fabs (l_imag_sum))
			Result := 0
		end

	series_2_c (a_r___3: REAL_64; a_x: REAL_64; a_y: REAL_64; a_sum_re: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_sum_im: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_cos_theta: REAL_64
			l_sin_theta: REAL_64
			l_alpha: REAL_64
			l_beta: REAL_64
			l_ck: REAL_64
			l_sk: REAL_64
			l_rk: REAL_64
			l_real_sum: REAL_64
			l_imag_sum: REAL_64
			l_kmax___0: INTEGER_32
			l_k: INTEGER_32
			l_dr: REAL_64
			l_di: REAL_64
			l_ck_tmp: REAL_64
			js: JUMP_STATE
		do
			l_cos_theta := a_x / a_r___3
			l_sin_theta := a_y / a_r___3
			l_alpha := 1.0 - l_cos_theta
			l_beta := l_sin_theta
			l_ck := l_cos_theta
			l_sk := l_sin_theta
			l_rk := a_r___3
			l_real_sum := (0.5 * a_r___3) * l_ck
			l_imag_sum := (0.5 * a_r___3) * l_sk
			l_kmax___0 := 30 + (18.0 / -(log (a_r___3))).truncated_to_integer
			l_k := 2
			from
			until
				not (not js.loop_left and then (l_k < l_kmax___0))
			loop
				js.reset
				l_ck_tmp := l_ck
				l_ck := l_ck - (l_alpha * l_ck + l_beta * l_sk)
				l_sk := l_sk - (l_alpha * l_sk - l_beta * l_ck_tmp)
				l_rk := l_rk * a_r___3
				l_dr := (l_rk / ((l_k.to_double * l_k.to_double) * (l_k.to_double + 1.0))) * l_ck
				l_di := (l_rk / ((l_k.to_double * l_k.to_double) * (l_k.to_double + 1.0))) * l_sk
				l_real_sum := l_real_sum + l_dr
				l_imag_sum := l_imag_sum + l_di
				if (fabs ((l_dr * l_dr + l_di * l_di) / (l_real_sum * l_real_sum + l_imag_sum * l_imag_sum))) < 2.2204460492503131e-16 * 2.2204460492503131e-16 then
					js.break
				end
				if not js.loop_jumped then
					l_k := l_k + 1
				end
			end
			js.reset
			a_sum_re.item.val := l_real_sum
			a_sum_re.item.err := ((2.0 * l_kmax___0.to_double) * 2.2204460492503131e-16) * (fabs (l_real_sum))
			a_sum_im.item.val := l_imag_sum
			a_sum_im.item.err := ((2.0 * l_kmax___0.to_double) * 2.2204460492503131e-16) * (fabs (l_imag_sum))
			Result := 0
		end

	dilogc_series_2 (a_r___3: REAL_64; a_x: REAL_64; a_y: REAL_64; a_real_dl: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_imag_dl: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_sum_re: PD_GSL_SF_RESULT_STRUCT
			l_sum_im: PD_GSL_SF_RESULT_STRUCT
			l_stat_s3: INTEGER_32
			l_ln_omz_r: PD_GSL_SF_RESULT_STRUCT
			l_ln_omz_theta: PD_GSL_SF_RESULT_STRUCT
			l_stat_log: INTEGER_32
			l_t_x: REAL_64
			l_t_y: REAL_64
			l_r_x: REAL_64
			l_r_y: REAL_64
			l_tmp___1: REAL_64
			l_tmp___3: REAL_64
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
		do
			create l_sum_re.make
			create l_sum_im.make
			create l_ln_omz_r.make
			create l_ln_omz_theta.make

			if a_r___3 = 0.0 then
				a_real_dl.item.val := 0.0
				a_imag_dl.item.val := 0.0
				a_real_dl.item.err := 0.0
				a_imag_dl.item.err := 0.0
				Result := 0
			else
				l_stat_s3 := (series_2_c (a_r___3, a_x, a_y, l_sum_re.address, l_sum_im.address))
				l_stat_log := (log_inst.gsl_sf_complex_log_e (1.0 - a_x, -a_y, l_ln_omz_r.address, l_ln_omz_theta.address))
				l_t_x := (l_ln_omz_r.val * a_x + l_ln_omz_theta.val * a_y) / (a_r___3 * a_r___3)
				l_t_y := (-l_ln_omz_r.val * a_y + l_ln_omz_theta.val * a_x) / (a_r___3 * a_r___3)
				l_r_x := (1.0 - a_x) * l_t_x + a_y * l_t_y
				l_r_y := (1.0 - a_x) * l_t_y - a_y * l_t_x
				a_real_dl.item.val := (l_sum_re.val + l_r_x) + 1.0
				a_imag_dl.item.val := l_sum_im.val + l_r_y
				l_tmp___1 := fabs (a_real_dl.item.val)
				a_real_dl.item.err := l_sum_re.err + (2.0 * 2.2204460492503131e-16) * (l_tmp___1 + (fabs (l_r_x)))
				l_tmp___3 := fabs (a_imag_dl.item.val)
				a_imag_dl.item.err := l_sum_im.err + (2.0 * 2.2204460492503131e-16) * (l_tmp___3 + (fabs (l_r_y)))
				if l_stat_s3 /= 0 then
					l_tmp___6 := l_stat_s3
				else
					if l_stat_log /= 0 then
						l_tmp___5 := l_stat_log
					else
						l_tmp___5 := 0
					end
					l_tmp___6 := l_tmp___5
				end
				Result := l_tmp___6
			end
		end

	dilogc_series_3 (a_r___3: REAL_64; a_x: REAL_64; a_y: REAL_64; a_real_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_imag_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_theta: REAL_64
			l_cos_theta: REAL_64
			l_sin_theta: REAL_64
			l_a___5: REAL_64
			l_omc: REAL_64
			l_omc2: REAL_64
			l_H_re: CE_ARRAY [REAL_64]
			l_H_im: CE_ARRAY [REAL_64]
			l_an: REAL_64
			l_nfact: REAL_64
			l_sum_re: REAL_64
			l_sum_im: REAL_64
			l_Him0: PD_GSL_SF_RESULT_STRUCT
			l_n: INTEGER_32
			l_t: REAL_64
			l_tmp___4: REAL_64
			l_tmp___6: REAL_64
		do
			create l_H_re.make (<<7>>)
			create l_H_im.make (<<7>>)
			create l_Him0.make

			l_theta := (atan2 (a_y, a_x))
			l_cos_theta := a_x / a_r___3
			l_sin_theta := a_y / a_r___3
			l_a___5 := (log (a_r___3))
			l_omc := 1.0 - l_cos_theta
			l_omc2 := l_omc * l_omc
			l_H_re[0] := (3.14159265358979323846 * 3.14159265358979323846) / 6.0 + 0.25 * (l_theta * l_theta - (2.0 * 3.14159265358979323846) * (fabs (l_theta)))
			clausen_inst.gsl_sf_clausen_e (l_theta, l_Him0.address).do_nothing
			l_H_im[0] := l_Him0.val
			l_H_re[1] := -0.5 * (log (2.0 * l_omc))
			l_H_im[1] := -(atan2 (-l_sin_theta, l_omc))
			l_H_re[2] := -0.5
			l_H_im[2] := (0.5 * l_sin_theta) / l_omc
			l_H_re[3] := -0.5 / l_omc
			l_H_im[3] := 0.0
			l_H_re[4] := 0.0
			l_H_im[4] := (-0.5 * l_sin_theta) / l_omc2
			l_H_re[5] := (0.5 * (2.0 + l_cos_theta)) / l_omc2
			l_H_im[5] := 0.0
			l_H_re[6] := 0.0
			l_H_im[6] := ((0.5 * l_sin_theta) / ((l_omc2 * l_omc2) * l_omc)) * (8.0 * l_omc - (l_sin_theta * l_sin_theta) * (3.0 + l_cos_theta))
			l_sum_re := l_H_re[0]
			l_sum_im := l_H_im[0]
			l_an := 1.0
			l_nfact := 1.0
			l_n := 1
			from
			until
				not (l_n <= 6)
			loop
				l_an := l_an * l_a___5
				l_nfact := l_nfact * l_n.to_double
				l_t := l_an / l_nfact
				l_sum_re := l_sum_re + (l_t * l_H_re[l_n])
				l_sum_im := l_sum_im + (l_t * l_H_im[l_n])
				l_n := l_n + 1
			end
			a_real_result.item.val := l_sum_re
			l_tmp___4 := fabs (l_sum_re)
			a_real_result.item.err := ((2.0 * 6.0) * 2.2204460492503131e-16) * l_tmp___4 + (fabs (l_an / l_nfact))
			a_imag_result.item.val := l_sum_im
			l_tmp___6 := fabs (l_sum_im)
			a_imag_result.item.err := (((2.0 * 6.0) * 2.2204460492503131e-16) * l_tmp___6 + l_Him0.err) + (fabs (l_an / l_nfact))
			Result := 0
		end

	dilogc_fundamental (a_r___3: REAL_64; a_x: REAL_64; a_y: REAL_64; a_real_dl: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_imag_dl: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		do
			if a_r___3 > 0.98 then
				Result := (dilogc_series_3 (a_r___3, a_x, a_y, a_real_dl, a_imag_dl))
			elseif a_r___3 > 0.25 then
				Result := (dilogc_series_2 (a_r___3, a_x, a_y, a_real_dl, a_imag_dl))
			else
				Result := (dilogc_series_1 (a_r___3, a_x, a_y, a_real_dl, a_imag_dl))
			end
		end

	dilogc_unitdisk (a_x: REAL_64; a_y: REAL_64; a_real_dl: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_imag_dl: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_r___3: REAL_64
			l_x_tmp: REAL_64
			l_y_tmp: REAL_64
			l_r_tmp: REAL_64
			l_result_re_tmp: PD_GSL_SF_RESULT_STRUCT
			l_result_im_tmp: PD_GSL_SF_RESULT_STRUCT
			l_stat_dilog: INTEGER_32
			l_lnz: REAL_64
			l_lnomz: REAL_64
			l_argz: REAL_64
			l_argomz: REAL_64
			l_tmp___6: REAL_64
			l_tmp___8: REAL_64
		do
			create l_result_re_tmp.make
			create l_result_im_tmp.make

			l_r___3 := (hypot (a_x, a_y))
			if a_x > MAGIC_SPLIT_VALUE then
				l_x_tmp := 1.0 - a_x
				l_y_tmp := -a_y
				l_r_tmp := (hypot (l_x_tmp, l_y_tmp))
				l_stat_dilog := (dilogc_fundamental (l_r_tmp, l_x_tmp, l_y_tmp, l_result_re_tmp.address, l_result_im_tmp.address))
				l_lnz := (log (l_r___3))
				l_lnomz := (log (l_r_tmp))
				l_argz := (atan2 (a_y, a_x))
				l_argomz := (atan2 (l_y_tmp, l_x_tmp))
				a_real_dl.item.val := ((-l_result_re_tmp.val + zeta2) - l_lnz * l_lnomz) + l_argz * l_argomz
				a_real_dl.item.err := l_result_re_tmp.err
				l_tmp___6 := fabs (l_lnz * l_lnomz)
				a_real_dl.item.err := a_real_dl.item.err + ((2.0 * 2.2204460492503131e-16) * ((zeta2 + l_tmp___6) + (fabs (l_argz * l_argomz))))
				a_imag_dl.item.val := (-l_result_im_tmp.val - l_argz * l_lnomz) - l_argomz * l_lnz
				a_imag_dl.item.err := l_result_im_tmp.err
				l_tmp___8 := fabs (l_argz * l_lnomz)
				a_imag_dl.item.err := a_imag_dl.item.err + ((2.0 * 2.2204460492503131e-16) * (l_tmp___8 + (fabs (l_argomz * l_lnz))))
				Result := l_stat_dilog
			else
				Result := (dilogc_fundamental (l_r___3, a_x, a_y, a_real_dl, a_imag_dl))
			end
		end

	gsl_sf_dilog_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_d1: PD_GSL_SF_RESULT_STRUCT
			l_d2: PD_GSL_SF_RESULT_STRUCT
			l_stat_d1: INTEGER_32
			l_stat_d2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
		do
			create l_d1.make
			create l_d2.make

			if a_x >= 0.0 then
				Result := (dilog_xge0 (a_x, a_result))
			else
				l_stat_d1 := (dilog_xge0 (-a_x, l_d1.address))
				l_stat_d2 := (dilog_xge0 (a_x * a_x, l_d2.address))
				a_result.item.val := -l_d1.val + 0.5 * l_d2.val
				a_result.item.err := l_d1.err + 0.5 * l_d2.err
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				if l_stat_d1 /= 0 then
					l_tmp___4 := l_stat_d1
				else
					if l_stat_d2 /= 0 then
						l_tmp___3 := l_stat_d2
					else
						l_tmp___3 := 0
					end
					l_tmp___4 := l_tmp___3
				end
				Result := l_tmp___4
			end
		end

	gsl_sf_complex_dilog_xy_e (a_x: REAL_64; a_y: REAL_64; a_real_dl: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_imag_dl: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_zeta2___0: REAL_64
			l_r2___0: REAL_64
			l_theta: REAL_64
			l_term1: REAL_64
			l_term2: REAL_64
			l_r___3: REAL_64
			l_x_tmp: REAL_64
			l_y_tmp: REAL_64
			l_result_re_tmp: PD_GSL_SF_RESULT_STRUCT
			l_result_im_tmp: PD_GSL_SF_RESULT_STRUCT
			l_stat_dilog: INTEGER_32
			l_theta___0: REAL_64
			l_theta_abs: REAL_64
			l_theta_sgn: REAL_64
			l_tmp___10: REAL_64
			l_ln_minusz_re: REAL_64
			l_ln_minusz_im: REAL_64
			l_lmz2_re: REAL_64
			l_lmz2_im: REAL_64
		do
			create l_result_re_tmp.make
			create l_result_im_tmp.make

			l_zeta2___0 := (3.14159265358979323846 * 3.14159265358979323846) / 6.0
			l_r2___0 := a_x * a_x + a_y * a_y
			if a_y = 0.0 then
				if a_x >= 1.0 then
					a_imag_dl.item.val := -3.14159265358979323846 * (log (a_x))
					a_imag_dl.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_imag_dl.item.val))
				else
					a_imag_dl.item.val := 0.0
					a_imag_dl.item.err := 0.0
				end
				Result := (gsl_sf_dilog_e (a_x, a_real_dl))
			elseif (fabs (l_r2___0 - 1.0)) < 2.2204460492503131e-16 then
				l_theta := (atan2 (a_y, a_x))
				l_term1 := (l_theta * l_theta) / 4.0
				l_term2 := (3.14159265358979323846 * (fabs (l_theta))) / 2.0
				a_real_dl.item.val := (l_zeta2___0 + l_term1) - l_term2
				a_real_dl.item.err := (2.0 * 2.2204460492503131e-16) * ((l_zeta2___0 + l_term1) + l_term2)
				Result := (clausen_inst.gsl_sf_clausen_e (l_theta, a_imag_dl))
			elseif l_r2___0 < 1.0 then
				Result := (dilogc_unitdisk (a_x, a_y, a_real_dl, a_imag_dl))
			else
				l_r___3 := (sqrt (l_r2___0))
				l_x_tmp := a_x / l_r2___0
				l_y_tmp := -a_y / l_r2___0
				l_stat_dilog := (dilogc_unitdisk (l_x_tmp, l_y_tmp, l_result_re_tmp.address, l_result_im_tmp.address))
				l_theta___0 := (atan2 (a_y, a_x))
				l_theta_abs := (fabs (l_theta___0))
				if l_theta___0 < 0.0 then
					l_tmp___10 := -1.0
				else
					l_tmp___10 := 1.0
				end
				l_theta_sgn := l_tmp___10
				l_ln_minusz_re := (log (l_r___3))
				l_ln_minusz_im := l_theta_sgn * (l_theta_abs - 3.14159265358979323846)
				l_lmz2_re := l_ln_minusz_re * l_ln_minusz_re - l_ln_minusz_im * l_ln_minusz_im
				l_lmz2_im := (2.0 * l_ln_minusz_re) * l_ln_minusz_im
				a_real_dl.item.val := (-l_result_re_tmp.val - 0.5 * l_lmz2_re) - l_zeta2___0
				a_real_dl.item.err := l_result_re_tmp.err + (2.0 * 2.2204460492503131e-16) * (0.5 * (fabs (l_lmz2_re)) + l_zeta2___0)
				a_imag_dl.item.val := -l_result_im_tmp.val - 0.5 * l_lmz2_im
				a_imag_dl.item.err := l_result_im_tmp.err + (2.0 * 2.2204460492503131e-16) * (fabs (l_lmz2_im))
				Result := l_stat_dilog
			end
		end

	gsl_sf_complex_dilog_e (a_r___3: REAL_64; a_theta: REAL_64; a_real_dl: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_imag_dl: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_cos_theta: REAL_64
			l_sin_theta: REAL_64
			l_x: REAL_64
			l_y: REAL_64
		do
			l_cos_theta := (cos (a_theta))
			l_sin_theta := (sin (a_theta))
			l_x := a_r___3 * l_cos_theta
			l_y := a_r___3 * l_sin_theta
			Result := (gsl_sf_complex_dilog_xy_e (l_x, l_y, a_real_dl, a_imag_dl))
		end

	gsl_sf_complex_spence_xy_e (a_x: REAL_64; a_y: REAL_64; a_real_sp: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_imag_sp: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_oms_x: REAL_64
			l_oms_y: REAL_64
		do
			l_oms_x := 1.0 - a_x
			l_oms_y := -a_y
			Result := (gsl_sf_complex_dilog_xy_e (l_oms_x, l_oms_y, a_real_sp, a_imag_sp))
		end

	gsl_sf_dilog (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_dilog_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_dilog_e(x, &result)"), ce_string ("dilog.c"), 661, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
