class
	P_DIRECTIONAL_MINIMIZE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	take_step (a_x: CE_POINTER [PD_GSL_VECTOR]; a_p: CE_POINTER [PD_GSL_VECTOR]; a_step: REAL_64; a_lambda: REAL_64; a_x1___0: CE_POINTER [PD_GSL_VECTOR]; a_dx: CE_POINTER [PD_GSL_VECTOR])
		do
			init_source_inst.gsl_vector_set_zero (a_dx)
			blas_inst.gsl_blas_daxpy (-a_step * a_lambda, a_p, a_dx).do_nothing
			copy_source_inst.gsl_vector_memcpy (a_x1___0, a_x).do_nothing
			blas_inst.gsl_blas_daxpy (1.0, a_dx, a_x1___0).do_nothing
		end

	intermediate_point (a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_p: CE_POINTER [PD_GSL_VECTOR]; a_lambda: REAL_64; a_pg: REAL_64; a_stepa: REAL_64; a_stepc: REAL_64; a_fa: REAL_64; a_fc: REAL_64; a_x1___0: CE_POINTER [PD_GSL_VECTOR]; a_dx: CE_POINTER [PD_GSL_VECTOR]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_step: CE_POINTER [REAL_64]; a_f: CE_POINTER [REAL_64])
		local
			l_stepc: REAL_64
			l_fc: REAL_64
			l_stepb: REAL_64
			l_fb: REAL_64
			l_u: REAL_64
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_stepc := a_stepc
					l_fc := a_fc
				when 1 then -- trial:
					l_u := (fabs ((a_pg * a_lambda) * l_stepc))
					l_stepb := ((0.5 * l_stepc) * l_u) / ((l_fc - a_fa) + l_u)
					take_step (a_x, a_p, l_stepb, a_lambda, a_x1___0, a_dx)
					l_fb := (a_fdf.item.f).real_64_item ([a_x1___0, a_fdf.item.params])
					if l_fb >= a_fa then
						if l_stepb > 0.0 then
							l_fc := l_fb
							l_stepc := l_stepb
							l_pos := -1 + 1 -- goto trial
						end
					end
				when 2 then
					a_step.item := l_stepb
					a_f.item := l_fb;
					(a_fdf.item.df).call ([a_x1___0, a_fdf.item.params, a_gradient])
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	minimize (a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_p: CE_POINTER [PD_GSL_VECTOR]; a_lambda: REAL_64; a_stepa: REAL_64; a_stepb: REAL_64; a_stepc: REAL_64; a_fa: REAL_64; a_fb: REAL_64; a_fc: REAL_64; a_tol: REAL_64; a_x1___0: CE_POINTER [PD_GSL_VECTOR]; a_dx1: CE_POINTER [PD_GSL_VECTOR]; a_x2___1: CE_POINTER [PD_GSL_VECTOR]; a_dx2: CE_POINTER [PD_GSL_VECTOR]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_step: CE_POINTER [REAL_64]; a_f: CE_POINTER [REAL_64]; a_gnorm: CE_POINTER [REAL_64])
		local
			l_stepa: REAL_64
			l_stepb: REAL_64
			l_stepc: REAL_64
			l_fa: REAL_64
			l_fb: REAL_64
			l_fc: REAL_64
			l_u: REAL_64
			l_v: REAL_64
			l_w: REAL_64
			l_fu: REAL_64
			l_fv: REAL_64
			l_fw: REAL_64
			l_old2: REAL_64
			l_old1: REAL_64
			l_stepm: REAL_64
			l_fm: REAL_64
			l_pg: REAL_64
			l_gnorm1: REAL_64
			l_iter: INTEGER_32
			l_dw: REAL_64
			l_dv: REAL_64
			l_du: REAL_64
			l_e1: REAL_64
			l_e2: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_stepa := a_stepa
					l_stepb := a_stepb
					l_stepc := a_stepc
					l_fa := a_fa
					l_fb := a_fb
					l_fc := a_fc
					l_u := l_stepb
					l_v := l_stepa
					l_w := l_stepc
					l_fu := l_fb
					l_fv := l_fa
					l_fw := l_fc
					l_old2 := (fabs (l_w - l_v))
					l_old1 := (fabs (l_v - l_u))
					l_iter := 0
					copy_source_inst.gsl_vector_memcpy (a_x2___1, a_x1___0).do_nothing
					copy_source_inst.gsl_vector_memcpy (a_dx2, a_dx1).do_nothing
					a_f.item := l_fb
					a_step.item := l_stepb
					a_gnorm.item := blas_inst.gsl_blas_dnrm2 (a_gradient)
				when 1 then -- mid_trial:
					l_iter := l_iter + 1
					if l_iter > 10 then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 10 -- skip if block
					end
				when 2 then -- if:
						l_dw := l_w - l_u
						l_dv := l_v - l_u
						l_du := 0.0
						l_e1 := ((l_fv - l_fu) * l_dw) * l_dw + ((l_fu - l_fw) * l_dv) * l_dv
						l_e2 := 2.0 * ((l_fv - l_fu) * l_dw + (l_fu - l_fw) * l_dv)
						if l_e2 /= 0.0 then
							l_du := l_e1 / l_e2
						end
						if not (l_du > 0.0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_du < l_stepc - l_stepb then
							if (fabs (l_du)) < 0.5 * l_old2 then
								l_stepm := l_u + l_du
							else
								l_pos := -1 + 5 -- goto _L___2
							end
						else
							l_pos := -1 + 5 -- goto _L___2
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else: | _L___2:
						if not (l_du < 0.0) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if l_du > l_stepa - l_stepb then
							if (fabs (l_du)) < 0.5 * l_old2 then
								l_stepm := l_u + l_du
							else
								l_pos := -1 + 8 -- goto _L___0
							end
						else
							l_pos := -1 + 8 -- goto _L___0
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L___0:
						if l_stepc - l_stepb > l_stepb - l_stepa then
							l_stepm := 0.38 * (l_stepc - l_stepb) + l_stepb
						else
							l_stepm := l_stepb - 0.38 * (l_stepb - l_stepa)
						end
				when 9 then -- if done
						take_step (a_x, a_p, l_stepm, a_lambda, a_x1___0, a_dx1)
						l_fm := (a_fdf.item.f).real_64_item ([a_x1___0, a_fdf.item.params])
						if l_fm > l_fb then
							if l_fm < l_fv then
								l_w := l_v
								l_v := l_stepm
								l_fw := l_fv
								l_fv := l_fm
							elseif l_fm < l_fw then
								l_w := l_stepm
								l_fw := l_fm
							end
							if l_stepm < l_stepb then
								l_stepa := l_stepm
								l_fa := l_fm
							else
								l_stepc := l_stepm
								l_fc := l_fm
							end
							l_pos := -1 + 1 -- goto mid_trial
						elseif l_fm <= l_fb then
							l_old2 := l_old1
							l_old1 := fabs (l_u - l_stepm)
							l_w := l_v
							l_v := l_u
							l_u := l_stepm
							l_fw := l_fv
							l_fv := l_fu
							l_fu := l_fm
							copy_source_inst.gsl_vector_memcpy (a_x2___1, a_x1___0).do_nothing
							copy_source_inst.gsl_vector_memcpy (a_dx2, a_dx1).do_nothing;
							(a_fdf.item.df).call ([a_x1___0, a_fdf.item.params, a_gradient])
							blas_inst.gsl_blas_ddot (a_p, a_gradient, create {CE_POINTER [REAL_64]}.make_shared ($l_pg)).do_nothing
							l_gnorm1 := blas_inst.gsl_blas_dnrm2 (a_gradient)
							a_f.item := l_fm
							a_step.item := l_stepm
							a_gnorm.item := l_gnorm1
							if (fabs ((l_pg * a_lambda) / l_gnorm1)) < a_tol then
								js.return
							end
							if not js.return_called then
								if l_stepm < l_stepb then
									l_stepc := l_stepb
									l_fc := l_fb
									l_stepb := l_stepm
									l_fb := l_fm
								else
									l_stepa := l_stepb
									l_fa := l_fb
									l_stepb := l_stepm
									l_fb := l_fm
								end
								l_pos := -1 + 1 -- goto mid_trial
							end
						end
				when 10 then
					if not js.return_called then
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	take_step___0 (a_x: CE_POINTER [PD_GSL_VECTOR]; a_p: CE_POINTER [PD_GSL_VECTOR]; a_step: REAL_64; a_lambda: REAL_64; a_x1___0: CE_POINTER [PD_GSL_VECTOR]; a_dx: CE_POINTER [PD_GSL_VECTOR])
		do
			init_source_inst.gsl_vector_set_zero (a_dx)
			blas_inst.gsl_blas_daxpy (-a_step * a_lambda, a_p, a_dx).do_nothing
			copy_source_inst.gsl_vector_memcpy (a_x1___0, a_x).do_nothing
			blas_inst.gsl_blas_daxpy (1.0, a_dx, a_x1___0).do_nothing
		end

	intermediate_point___0 (a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_p: CE_POINTER [PD_GSL_VECTOR]; a_lambda: REAL_64; a_pg: REAL_64; a_stepa: REAL_64; a_stepc: REAL_64; a_fa: REAL_64; a_fc: REAL_64; a_x1___0: CE_POINTER [PD_GSL_VECTOR]; a_dx: CE_POINTER [PD_GSL_VECTOR]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_step: CE_POINTER [REAL_64]; a_f: CE_POINTER [REAL_64])
		local
			l_stepc: REAL_64
			l_fc: REAL_64
			l_stepb: REAL_64
			l_fb: REAL_64
			l_u: REAL_64
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_stepc := a_stepc
					l_fc := a_fc
				when 1 then -- trial:
					l_u := (fabs ((a_pg * a_lambda) * l_stepc))
					l_stepb := ((0.5 * l_stepc) * l_u) / ((l_fc - a_fa) + l_u)
					take_step___0 (a_x, a_p, l_stepb, a_lambda, a_x1___0, a_dx)
					l_fb := (a_fdf.item.f).real_64_item ([a_x1___0, a_fdf.item.params])
					if l_fb >= a_fa then
						if l_stepb > 0.0 then
							l_fc := l_fb
							l_stepc := l_stepb
							l_pos := -1 + 1 -- goto trial
						end
					end
				when 2 then
					a_step.item := l_stepb
					a_f.item := l_fb;
					(a_fdf.item.df).call ([a_x1___0, a_fdf.item.params, a_gradient])
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	minimize___0 (a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_p: CE_POINTER [PD_GSL_VECTOR]; a_lambda: REAL_64; a_stepa: REAL_64; a_stepb: REAL_64; a_stepc: REAL_64; a_fa: REAL_64; a_fb: REAL_64; a_fc: REAL_64; a_tol: REAL_64; a_x1___0: CE_POINTER [PD_GSL_VECTOR]; a_dx1: CE_POINTER [PD_GSL_VECTOR]; a_x2___1: CE_POINTER [PD_GSL_VECTOR]; a_dx2: CE_POINTER [PD_GSL_VECTOR]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_step: CE_POINTER [REAL_64]; a_f: CE_POINTER [REAL_64]; a_gnorm: CE_POINTER [REAL_64])
		local
			l_stepa: REAL_64
			l_stepb: REAL_64
			l_stepc: REAL_64
			l_fa: REAL_64
			l_fb: REAL_64
			l_fc: REAL_64
			l_u: REAL_64
			l_v: REAL_64
			l_w: REAL_64
			l_fu: REAL_64
			l_fv: REAL_64
			l_fw: REAL_64
			l_old2: REAL_64
			l_old1: REAL_64
			l_stepm: REAL_64
			l_fm: REAL_64
			l_pg: REAL_64
			l_gnorm1: REAL_64
			l_iter: INTEGER_32
			l_dw: REAL_64
			l_dv: REAL_64
			l_du: REAL_64
			l_e1: REAL_64
			l_e2: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_stepa := a_stepa
					l_stepb := a_stepb
					l_stepc := a_stepc
					l_fa := a_fa
					l_fb := a_fb
					l_fc := a_fc
					l_u := l_stepb
					l_v := l_stepa
					l_w := l_stepc
					l_fu := l_fb
					l_fv := l_fa
					l_fw := l_fc
					l_old2 := (fabs (l_w - l_v))
					l_old1 := (fabs (l_v - l_u))
					l_iter := 0
					copy_source_inst.gsl_vector_memcpy (a_x2___1, a_x1___0).do_nothing
					copy_source_inst.gsl_vector_memcpy (a_dx2, a_dx1).do_nothing
					a_f.item := l_fb
					a_step.item := l_stepb
					a_gnorm.item := blas_inst.gsl_blas_dnrm2 (a_gradient)
				when 1 then -- mid_trial:
					l_iter := l_iter + 1
					if l_iter > 10 then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 10 -- skip if block
					end
				when 2 then -- if:
						l_dw := l_w - l_u
						l_dv := l_v - l_u
						l_du := 0.0
						l_e1 := ((l_fv - l_fu) * l_dw) * l_dw + ((l_fu - l_fw) * l_dv) * l_dv
						l_e2 := 2.0 * ((l_fv - l_fu) * l_dw + (l_fu - l_fw) * l_dv)
						if l_e2 /= 0.0 then
							l_du := l_e1 / l_e2
						end
						if not (l_du > 0.0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_du < l_stepc - l_stepb then
							if (fabs (l_du)) < 0.5 * l_old2 then
								l_stepm := l_u + l_du
							else
								l_pos := -1 + 5 -- goto _L___2
							end
						else
							l_pos := -1 + 5 -- goto _L___2
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else: | _L___2:
						if not (l_du < 0.0) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if l_du > l_stepa - l_stepb then
							if (fabs (l_du)) < 0.5 * l_old2 then
								l_stepm := l_u + l_du
							else
								l_pos := -1 + 8 -- goto _L___0
							end
						else
							l_pos := -1 + 8 -- goto _L___0
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L___0:
						if l_stepc - l_stepb > l_stepb - l_stepa then
							l_stepm := 0.38 * (l_stepc - l_stepb) + l_stepb
						else
							l_stepm := l_stepb - 0.38 * (l_stepb - l_stepa)
						end
				when 9 then -- if done
						take_step___0 (a_x, a_p, l_stepm, a_lambda, a_x1___0, a_dx1)
						l_fm := (a_fdf.item.f).real_64_item ([a_x1___0, a_fdf.item.params])
						if l_fm > l_fb then
							if l_fm < l_fv then
								l_w := l_v
								l_v := l_stepm
								l_fw := l_fv
								l_fv := l_fm
							elseif l_fm < l_fw then
								l_w := l_stepm
								l_fw := l_fm
							end
							if l_stepm < l_stepb then
								l_stepa := l_stepm
								l_fa := l_fm
							else
								l_stepc := l_stepm
								l_fc := l_fm
							end
							l_pos := -1 + 1 -- goto mid_trial
						elseif l_fm <= l_fb then
							l_old2 := l_old1
							l_old1 := fabs (l_u - l_stepm)
							l_w := l_v
							l_v := l_u
							l_u := l_stepm
							l_fw := l_fv
							l_fv := l_fu
							l_fu := l_fm
							copy_source_inst.gsl_vector_memcpy (a_x2___1, a_x1___0).do_nothing
							copy_source_inst.gsl_vector_memcpy (a_dx2, a_dx1).do_nothing;
							(a_fdf.item.df).call ([a_x1___0, a_fdf.item.params, a_gradient])
							blas_inst.gsl_blas_ddot (a_p, a_gradient, create {CE_POINTER [REAL_64]}.make_shared ($l_pg)).do_nothing
							l_gnorm1 := blas_inst.gsl_blas_dnrm2 (a_gradient)
							a_f.item := l_fm
							a_step.item := l_stepm
							a_gnorm.item := l_gnorm1
							if (fabs ((l_pg * a_lambda) / l_gnorm1)) < a_tol then
								js.return
							end
							if not js.return_called then
								if l_stepm < l_stepb then
									l_stepc := l_stepb
									l_fc := l_fb
									l_stepb := l_stepm
									l_fb := l_fm
								else
									l_stepa := l_stepb
									l_fa := l_fb
									l_stepb := l_stepm
									l_fb := l_fm
								end
								l_pos := -1 + 1 -- goto mid_trial
							end
						end
				when 10 then
					if not js.return_called then
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	take_step___1 (a_x: CE_POINTER [PD_GSL_VECTOR]; a_p: CE_POINTER [PD_GSL_VECTOR]; a_step: REAL_64; a_lambda: REAL_64; a_x1___0: CE_POINTER [PD_GSL_VECTOR]; a_dx: CE_POINTER [PD_GSL_VECTOR])
		do
			init_source_inst.gsl_vector_set_zero (a_dx)
			blas_inst.gsl_blas_daxpy (-a_step * a_lambda, a_p, a_dx).do_nothing
			copy_source_inst.gsl_vector_memcpy (a_x1___0, a_x).do_nothing
			blas_inst.gsl_blas_daxpy (1.0, a_dx, a_x1___0).do_nothing
		end

	intermediate_point___1 (a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_p: CE_POINTER [PD_GSL_VECTOR]; a_lambda: REAL_64; a_pg: REAL_64; a_stepa: REAL_64; a_stepc: REAL_64; a_fa: REAL_64; a_fc: REAL_64; a_x1___0: CE_POINTER [PD_GSL_VECTOR]; a_dx: CE_POINTER [PD_GSL_VECTOR]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_step: CE_POINTER [REAL_64]; a_f: CE_POINTER [REAL_64])
		local
			l_stepc: REAL_64
			l_fc: REAL_64
			l_stepb: REAL_64
			l_fb: REAL_64
			l_u: REAL_64
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_stepc := a_stepc
					l_fc := a_fc
				when 1 then -- trial:
					l_u := (fabs ((a_pg * a_lambda) * l_stepc))
					l_stepb := ((0.5 * l_stepc) * l_u) / ((l_fc - a_fa) + l_u)
					take_step___1 (a_x, a_p, l_stepb, a_lambda, a_x1___0, a_dx)
					l_fb := (a_fdf.item.f).real_64_item ([a_x1___0, a_fdf.item.params])
					if l_fb >= a_fa then
						if l_stepb > 0.0 then
							l_fc := l_fb
							l_stepc := l_stepb
							l_pos := -1 + 1 -- goto trial
						end
					end
				when 2 then
					a_step.item := l_stepb
					a_f.item := l_fb;
					(a_fdf.item.df).call ([a_x1___0, a_fdf.item.params, a_gradient])
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	minimize___1 (a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_p: CE_POINTER [PD_GSL_VECTOR]; a_lambda: REAL_64; a_stepa: REAL_64; a_stepb: REAL_64; a_stepc: REAL_64; a_fa: REAL_64; a_fb: REAL_64; a_fc: REAL_64; a_tol: REAL_64; a_x1___0: CE_POINTER [PD_GSL_VECTOR]; a_dx1: CE_POINTER [PD_GSL_VECTOR]; a_x2___1: CE_POINTER [PD_GSL_VECTOR]; a_dx2: CE_POINTER [PD_GSL_VECTOR]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_step: CE_POINTER [REAL_64]; a_f: CE_POINTER [REAL_64]; a_gnorm: CE_POINTER [REAL_64])
		local
			l_stepa: REAL_64
			l_stepb: REAL_64
			l_stepc: REAL_64
			l_fa: REAL_64
			l_fb: REAL_64
			l_fc: REAL_64
			l_u: REAL_64
			l_v: REAL_64
			l_w: REAL_64
			l_fu: REAL_64
			l_fv: REAL_64
			l_fw: REAL_64
			l_old2: REAL_64
			l_old1: REAL_64
			l_stepm: REAL_64
			l_fm: REAL_64
			l_pg: REAL_64
			l_gnorm1: REAL_64
			l_iter: INTEGER_32
			l_dw: REAL_64
			l_dv: REAL_64
			l_du: REAL_64
			l_e1: REAL_64
			l_e2: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_stepa := a_stepa
					l_stepb := a_stepb
					l_stepc := a_stepc
					l_fa := a_fa
					l_fb := a_fb
					l_fc := a_fc
					l_u := l_stepb
					l_v := l_stepa
					l_w := l_stepc
					l_fu := l_fb
					l_fv := l_fa
					l_fw := l_fc
					l_old2 := (fabs (l_w - l_v))
					l_old1 := (fabs (l_v - l_u))
					l_iter := 0
					copy_source_inst.gsl_vector_memcpy (a_x2___1, a_x1___0).do_nothing
					copy_source_inst.gsl_vector_memcpy (a_dx2, a_dx1).do_nothing
					a_f.item := l_fb
					a_step.item := l_stepb
					a_gnorm.item := blas_inst.gsl_blas_dnrm2 (a_gradient)
				when 1 then -- mid_trial:
					l_iter := l_iter + 1
					if l_iter > 10 then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 10 -- skip if block
					end
				when 2 then -- if:
						l_dw := l_w - l_u
						l_dv := l_v - l_u
						l_du := 0.0
						l_e1 := ((l_fv - l_fu) * l_dw) * l_dw + ((l_fu - l_fw) * l_dv) * l_dv
						l_e2 := 2.0 * ((l_fv - l_fu) * l_dw + (l_fu - l_fw) * l_dv)
						if l_e2 /= 0.0 then
							l_du := l_e1 / l_e2
						end
						if not (l_du > 0.0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_du < l_stepc - l_stepb then
							if (fabs (l_du)) < 0.5 * l_old2 then
								l_stepm := l_u + l_du
							else
								l_pos := -1 + 5 -- goto _L___2
							end
						else
							l_pos := -1 + 5 -- goto _L___2
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else: | _L___2:
						if not (l_du < 0.0) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if l_du > l_stepa - l_stepb then
							if (fabs (l_du)) < 0.5 * l_old2 then
								l_stepm := l_u + l_du
							else
								l_pos := -1 + 8 -- goto _L___0
							end
						else
							l_pos := -1 + 8 -- goto _L___0
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L___0:
						if l_stepc - l_stepb > l_stepb - l_stepa then
							l_stepm := 0.38 * (l_stepc - l_stepb) + l_stepb
						else
							l_stepm := l_stepb - 0.38 * (l_stepb - l_stepa)
						end
				when 9 then -- if done
						take_step___1 (a_x, a_p, l_stepm, a_lambda, a_x1___0, a_dx1)
						l_fm := (a_fdf.item.f).real_64_item ([a_x1___0, a_fdf.item.params])
						if l_fm > l_fb then
							if l_fm < l_fv then
								l_w := l_v
								l_v := l_stepm
								l_fw := l_fv
								l_fv := l_fm
							elseif l_fm < l_fw then
								l_w := l_stepm
								l_fw := l_fm
							end
							if l_stepm < l_stepb then
								l_stepa := l_stepm
								l_fa := l_fm
							else
								l_stepc := l_stepm
								l_fc := l_fm
							end
							l_pos := -1 + 1 -- goto mid_trial
						elseif l_fm <= l_fb then
							l_old2 := l_old1
							l_old1 := fabs (l_u - l_stepm)
							l_w := l_v
							l_v := l_u
							l_u := l_stepm
							l_fw := l_fv
							l_fv := l_fu
							l_fu := l_fm
							copy_source_inst.gsl_vector_memcpy (a_x2___1, a_x1___0).do_nothing
							copy_source_inst.gsl_vector_memcpy (a_dx2, a_dx1).do_nothing;
							(a_fdf.item.df).call ([a_x1___0, a_fdf.item.params, a_gradient])
							blas_inst.gsl_blas_ddot (a_p, a_gradient, create {CE_POINTER [REAL_64]}.make_shared ($l_pg)).do_nothing
							l_gnorm1 := blas_inst.gsl_blas_dnrm2 (a_gradient)
							a_f.item := l_fm
							a_step.item := l_stepm
							a_gnorm.item := l_gnorm1
							if (fabs ((l_pg * a_lambda) / l_gnorm1)) < a_tol then
								js.return
							end
							if not js.return_called then
								if l_stepm < l_stepb then
									l_stepc := l_stepb
									l_fc := l_fb
									l_stepb := l_stepm
									l_fb := l_fm
								else
									l_stepa := l_stepb
									l_fa := l_fb
									l_stepb := l_stepm
									l_fb := l_fm
								end
								l_pos := -1 + 1 -- goto mid_trial
							end
						end
				when 10 then
					if not js.return_called then
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
