class
	P_DROTM

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_drotm (a_N: INTEGER_32; a_X: CE_POINTER [REAL_64]; a_incX: INTEGER_32; a_Y: CE_POINTER [REAL_64]; a_incY: INTEGER_32; a_P___2: CE_POINTER [REAL_64])
		local
			l_n: INTEGER_32
			l_i: INTEGER_32
			l_tmp: INTEGER_32
			l_j: INTEGER_32
			l_tmp___0: INTEGER_32
			l_h11: REAL_64
			l_h21: REAL_64
			l_h12: REAL_64
			l_h22: REAL_64
			l_w: REAL_64
			l_z: REAL_64
			js: JUMP_STATE
		do
			if a_incX > 0 then
				l_tmp := 0
			else
				l_tmp := (a_N - 1) * -a_incX
			end
			l_i := l_tmp
			if a_incY > 0 then
				l_tmp___0 := 0
			else
				l_tmp___0 := (a_N - 1) * -a_incY
			end
			l_j := l_tmp___0
			if a_P___2[0] = (-1.0) then
				l_h11 := a_P___2[1]
				l_h21 := a_P___2[2]
				l_h12 := a_P___2[3]
				l_h22 := a_P___2[4]
			elseif a_P___2[0] = 0.0 then
				l_h11 := 1.0
				l_h21 := a_P___2[2]
				l_h12 := a_P___2[3]
				l_h22 := 1.0
			elseif a_P___2[0] = 1.0 then
				l_h11 := a_P___2[1]
				l_h21 := -1.0
				l_h12 := 1.0
				l_h22 := a_P___2[4]
			elseif a_P___2[0] = (-2.0) then
				js.return
			else
				xerbla_inst.cblas_xerbla ([0, ce_string ("source_rotm.h"), ce_string ("unrecognized value of P[0]")])
				js.return
			end
			if not js.return_called then
				l_n := 0
				from
				until
					not (l_n < a_N)
				loop
					l_w := a_X[l_i]
					l_z := a_Y[l_j]
					a_X[l_i] := l_h11 * l_w + l_h12 * l_z
					a_Y[l_j] := l_h21 * l_w + l_h22 * l_z
					l_i := l_i + a_incX
					l_j := l_j + a_incY
					l_n := l_n + 1
				end
			end
		end

end
