class
	P_DSYMM

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_dsymm (a_Order: INTEGER_32; a_Side: INTEGER_32; a_Uplo: INTEGER_32; a_M: INTEGER_32; a_N: INTEGER_32; a_alpha: REAL_64; a_A___0: CE_POINTER [REAL_64]; a_lda: INTEGER_32; a_B: CE_POINTER [REAL_64]; a_ldb: INTEGER_32; a_beta: REAL_64; a_C: CE_POINTER [REAL_64]; a_ldc: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_n1: INTEGER_32
			l_n2: INTEGER_32
			l_uplo: INTEGER_32
			l_side: INTEGER_32
			l_temp1: REAL_64
			l_temp2: REAL_64
			l_Aik: REAL_64
			l_temp1___0: REAL_64
			l_temp2___0: REAL_64
			l_Aik___0: REAL_64
			l_temp1___1: REAL_64
			l_temp2___1: REAL_64
			l_Ajk: REAL_64
			l_temp1___2: REAL_64
			l_temp2___2: REAL_64
			l_Ajk___0: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_alpha = 0.0 then
						if a_beta = 1.0 then
							js.return
						end
					end
					if not js.return_called then
						if a_Order.to_natural_32 = {NATURAL_32} 101 then
							l_n1 := a_M
							l_n2 := a_N
							l_uplo := a_Uplo
							l_side := a_Side
						else
							l_n1 := a_N
							l_n2 := a_M
							if a_Uplo.to_natural_32 = {NATURAL_32} 121 then
								l_uplo := 122
							else
								l_uplo := 121
							end
							if a_Side.to_natural_32 = {NATURAL_32} 141 then
								l_side := 142
							else
								l_side := 141
							end
						end
						if a_beta = 0.0 then
							l_i := 0
							from
							until
								not (not js.loop_left and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (l_j < l_n2)
								loop
									a_C[(a_ldc * l_i + l_j)] := 0.0
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						elseif a_beta /= 1.0 then
							l_i := 0
							from
							until
								not (not js.loop_left and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (l_j < l_n2)
								loop
									a_C[(a_ldc * l_i + l_j)] := a_C[(a_ldc * l_i + l_j)] * a_beta
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						end
						if a_alpha = 0.0 then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						if l_side /= 141 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_uplo = 121 then
							l_i := 0
							from
							until
								not (not js.loop_left and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (not js.loop_left and then (l_j < l_n2))
								loop
									l_temp1 := a_alpha * a_B[(a_ldb * l_i + l_j)]
									l_temp2 := 0.0
									a_C[(l_i * a_ldc + l_j)] := a_C[(l_i * a_ldc + l_j)] + (l_temp1 * a_A___0[(l_i * a_lda + l_i)])
									l_k := l_i + 1
									from
									until
										not (l_k < l_n1)
									loop
										l_Aik := a_A___0[(l_i * a_lda + l_k)]
										a_C[(l_k * a_ldc + l_j)] := a_C[(l_k * a_ldc + l_j)] + (l_Aik * l_temp1)
										l_temp2 := l_temp2 + (l_Aik * a_B[(a_ldb * l_k + l_j)])
										l_k := l_k + 1
									end
									a_C[(l_i * a_ldc + l_j)] := a_C[(l_i * a_ldc + l_j)] + (a_alpha * l_temp2)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 4 -- goto _L___1
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else: | _L___1:
						if l_side /= 141 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_uplo = 122 then
							l_i := 0
							from
							until
								not (not js.loop_left and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (not js.loop_left and then (l_j < l_n2))
								loop
									l_temp1___0 := a_alpha * a_B[(a_ldb * l_i + l_j)]
									l_temp2___0 := 0.0
									l_k := 0
									from
									until
										not (l_k < l_i)
									loop
										l_Aik___0 := a_A___0[(l_i * a_lda + l_k)]
										a_C[(l_k * a_ldc + l_j)] := a_C[(l_k * a_ldc + l_j)] + (l_Aik___0 * l_temp1___0)
										l_temp2___0 := l_temp2___0 + (l_Aik___0 * a_B[(a_ldb * l_k + l_j)])
										l_k := l_k + 1
									end
									a_C[(l_i * a_ldc + l_j)] := a_C[(l_i * a_ldc + l_j)] + (l_temp1___0 * a_A___0[(l_i * a_lda + l_i)] + a_alpha * l_temp2___0)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 7 -- goto _L___0
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else: | _L___0:
						if l_side /= 142 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_uplo = 121 then
							l_i := 0
							from
							until
								not (not js.loop_left and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (not js.loop_left and then (l_j < l_n2))
								loop
									l_temp1___1 := a_alpha * a_B[(a_ldb * l_i + l_j)]
									l_temp2___1 := 0.0
									a_C[(l_i * a_ldc + l_j)] := a_C[(l_i * a_ldc + l_j)] + (l_temp1___1 * a_A___0[(l_j * a_lda + l_j)])
									l_k := l_j + 1
									from
									until
										not (l_k < l_n2)
									loop
										l_Ajk := a_A___0[(l_j * a_lda + l_k)]
										a_C[(l_i * a_ldc + l_k)] := a_C[(l_i * a_ldc + l_k)] + (l_temp1___1 * l_Ajk)
										l_temp2___1 := l_temp2___1 + (a_B[(a_ldb * l_i + l_k)] * l_Ajk)
										l_k := l_k + 1
									end
									a_C[(l_i * a_ldc + l_j)] := a_C[(l_i * a_ldc + l_j)] + (a_alpha * l_temp2___1)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						if l_side = 142 then
							if l_uplo = 122 then
								l_i := 0
								from
								until
									not (not js.loop_left and then (l_i < l_n1))
								loop
									l_j := 0
									from
									until
										not (not js.loop_left and then (l_j < l_n2))
									loop
										l_temp1___2 := a_alpha * a_B[(a_ldb * l_i + l_j)]
										l_temp2___2 := 0.0
										l_k := 0
										from
										until
											not (l_k < l_j)
										loop
											l_Ajk___0 := a_A___0[(l_j * a_lda + l_k)]
											a_C[(l_i * a_ldc + l_k)] := a_C[(l_i * a_ldc + l_k)] + (l_temp1___2 * l_Ajk___0)
											l_temp2___2 := l_temp2___2 + (a_B[(a_ldb * l_i + l_k)] * l_Ajk___0)
											l_k := l_k + 1
										end
										a_C[(l_i * a_ldc + l_j)] := a_C[(l_i * a_ldc + l_j)] + (l_temp1___2 * a_A___0[(l_j * a_lda + l_j)] + a_alpha * l_temp2___2)
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								xerbla_inst.cblas_xerbla ([0, ce_string ("source_symm_r.h"), ce_string ("unrecognized operation")])
							end
						else
							xerbla_inst.cblas_xerbla ([0, ce_string ("source_symm_r.h"), ce_string ("unrecognized operation")])
						end
				when 11 then -- if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
