class
	P_DSYR2K

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_dsyr2k (a_Order: INTEGER_32; a_Uplo: INTEGER_32; a_Trans: INTEGER_32; a_N: INTEGER_32; a_K: INTEGER_32; a_alpha: REAL_64; a_A___0: CE_POINTER [REAL_64]; a_lda: INTEGER_32; a_B: CE_POINTER [REAL_64]; a_ldb: INTEGER_32; a_beta: REAL_64; a_C: CE_POINTER [REAL_64]; a_ldc: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_uplo: INTEGER_32
			l_trans: INTEGER_32
			l_temp: REAL_64
			l_temp1: REAL_64
			l_temp2: REAL_64
			l_temp___0: REAL_64
			l_temp1___0: REAL_64
			l_temp2___0: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_alpha = 0.0 then
						if a_beta = 1.0 then
							js.return
						end
					end
					if not js.return_called then
						if a_Order.to_natural_32 = {NATURAL_32} 101 then
							l_uplo := a_Uplo
							if a_Trans.to_natural_32 = {NATURAL_32} 113 then
								l_trans := 112
							else
								l_trans := a_Trans
							end
						else
							if a_Uplo.to_natural_32 = {NATURAL_32} 121 then
								l_uplo := 122
							else
								l_uplo := 121
							end
							if a_Trans.to_natural_32 = {NATURAL_32} 112 then
								l_trans := 111
							elseif a_Trans.to_natural_32 = {NATURAL_32} 113 then
								l_trans := 111
							else
								l_trans := 112
							end
						end
						if a_beta = 0.0 then
							if l_uplo = 121 then
								l_i := 0
								from
								until
									not (not js.loop_left and then (l_i < a_N))
								loop
									l_j := l_i
									from
									until
										not (l_j < a_N)
									loop
										a_C[(a_ldc * l_i + l_j)] := 0.0
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								l_i := 0
								from
								until
									not (not js.loop_left and then (l_i < a_N))
								loop
									l_j := 0
									from
									until
										not (l_j <= l_i)
									loop
										a_C[(a_ldc * l_i + l_j)] := 0.0
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							end
						elseif a_beta /= 1.0 then
							if l_uplo = 121 then
								l_i := 0
								from
								until
									not (not js.loop_left and then (l_i < a_N))
								loop
									l_j := l_i
									from
									until
										not (l_j < a_N)
									loop
										a_C[(a_ldc * l_i + l_j)] := a_C[(a_ldc * l_i + l_j)] * a_beta
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								l_i := 0
								from
								until
									not (not js.loop_left and then (l_i < a_N))
								loop
									l_j := 0
									from
									until
										not (l_j <= l_i)
									loop
										a_C[(a_ldc * l_i + l_j)] := a_C[(a_ldc * l_i + l_j)] * a_beta
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							end
						end
						if a_alpha = 0.0 then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						if l_uplo /= 121 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_trans = 111 then
							l_i := 0
							from
							until
								not (not js.loop_left and then (l_i < a_N))
							loop
								l_j := l_i
								from
								until
									not (not js.loop_left and then (l_j < a_N))
								loop
									l_temp := 0.0
									l_k := 0
									from
									until
										not (l_k < a_K)
									loop
										l_temp := l_temp + (a_A___0[(l_i * a_lda + l_k)] * a_B[(l_j * a_ldb + l_k)] + a_B[(l_i * a_ldb + l_k)] * a_A___0[(l_j * a_lda + l_k)])
										l_k := l_k + 1
									end
									a_C[(l_i * a_ldc + l_j)] := a_C[(l_i * a_ldc + l_j)] + (a_alpha * l_temp)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 4 -- goto _L___1
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else: | _L___1:
						if l_uplo /= 121 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_trans = 112 then
							l_k := 0
							from
							until
								not (not js.loop_left and then (l_k < a_K))
							loop
								l_i := 0
								from
								until
									not (not js.loop_left and then (l_i < a_N))
								loop
									l_temp1 := a_alpha * a_A___0[(l_k * a_lda + l_i)]
									l_temp2 := a_alpha * a_B[(l_k * a_ldb + l_i)]
									l_j := l_i
									from
									until
										not (l_j < a_N)
									loop
										a_C[(l_i * a_lda + l_j)] := a_C[(l_i * a_lda + l_j)] + (l_temp1 * a_B[(l_k * a_ldb + l_j)] + l_temp2 * a_A___0[(l_k * a_lda + l_j)])
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
								l_k := l_k + 1
							end
						else
							l_pos := -1 + 7 -- goto _L___0
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else: | _L___0:
						if l_uplo /= 122 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_trans = 111 then
							l_i := 0
							from
							until
								not (not js.loop_left and then (l_i < a_N))
							loop
								l_j := 0
								from
								until
									not (not js.loop_left and then (l_j <= l_i))
								loop
									l_temp___0 := 0.0
									l_k := 0
									from
									until
										not (l_k < a_K)
									loop
										l_temp___0 := l_temp___0 + (a_A___0[(l_i * a_lda + l_k)] * a_B[(l_j * a_ldb + l_k)] + a_B[(l_i * a_ldb + l_k)] * a_A___0[(l_j * a_lda + l_k)])
										l_k := l_k + 1
									end
									a_C[(l_i * a_ldc + l_j)] := a_C[(l_i * a_ldc + l_j)] + (a_alpha * l_temp___0)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						if l_uplo = 122 then
							if l_trans = 112 then
								l_k := 0
								from
								until
									not (not js.loop_left and then (l_k < a_K))
								loop
									l_i := 0
									from
									until
										not (not js.loop_left and then (l_i < a_N))
									loop
										l_temp1___0 := a_alpha * a_A___0[(l_k * a_lda + l_i)]
										l_temp2___0 := a_alpha * a_B[(l_k * a_ldb + l_i)]
										l_j := 0
										from
										until
											not (l_j <= l_i)
										loop
											a_C[(l_i * a_lda + l_j)] := a_C[(l_i * a_lda + l_j)] + (l_temp1___0 * a_B[(l_k * a_ldb + l_j)] + l_temp2___0 * a_A___0[(l_k * a_lda + l_j)])
											l_j := l_j + 1
										end
										l_i := l_i + 1
									end
									l_k := l_k + 1
								end
							else
								xerbla_inst.cblas_xerbla ([0, ce_string ("source_syr2k_r.h"), ce_string ("unrecognized operation")])
							end
						else
							xerbla_inst.cblas_xerbla ([0, ce_string ("source_syr2k_r.h"), ce_string ("unrecognized operation")])
						end
				when 11 then -- if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
