class
	P_ELEMENTARY

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_sf_multiply_e (a_x: REAL_64; a_y: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ax: REAL_64
			l_ay: REAL_64
			l_tmp___1: REAL_64
			l_f: REAL_64
			l_min: REAL_64
			l_tmp___2: REAL_64
			l_max: REAL_64
			l_tmp___5: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ax := (fabs (a_x))
					l_ay := (fabs (a_y))
					if a_x /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_result.item.val := 0.0
						a_result.item.err := 0.0
						Result := 0
						js.return
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 3 then -- else:
						if a_y /= 0.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						a_result.item.val := 0.0
						a_result.item.err := 0.0
						Result := 0
						js.return
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 6 then -- else:
						if not (l_ax <= 1.0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_ay >= 1.0 then
							a_result.item.val := a_x * a_y
							l_tmp___1 := fabs (a_result.item.val)
							a_result.item.err := (2.0 * 2.2204460492503131e-16) * l_tmp___1
							Result := 0
							js.return
						else
							l_pos := -1 + 9 -- goto _L___1
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 9 then -- else: | _L___1:
						if not (l_ay <= 1.0) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if l_ax >= 1.0 then
							a_result.item.val := a_x * a_y
							l_tmp___1 := fabs (a_result.item.val)
							a_result.item.err := (2.0 * 2.2204460492503131e-16) * l_tmp___1
							Result := 0
							js.return
						else
							l_pos := -1 + 12 -- goto _L___0
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 12 then -- else: | _L___0:
						l_f := 1.0 - 2.0 * 2.2204460492503131e-16
						l_tmp___2 := fabs (a_y)
						l_min := (gsl_gsl_minmax_inst.GSL_MIN_DBL ((fabs (a_x)), l_tmp___2))
						l_tmp___5 := fabs (a_y)
						l_max := (gsl_gsl_minmax_inst.GSL_MAX_DBL ((fabs (a_x)), l_tmp___5))
						if not (l_max < 0.9 * 1.3407807929942596e+154) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 15 then -- else:
						if not (l_min < (l_f * (real_96_from_real_64 (1.79769313486231570815e+308)).truncated_to_real_64) / l_max) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if: | _L:
						a_result.item.val := coerce_inst.gsl_coerce_double (a_x * a_y)
						a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
						if (fabs (a_result.item.val)) < 2.2250738585072014e-308 then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("underflow"), ce_string ("elementary.c"), 57, 15)
								Result := 15
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
						if not js.return_called then
							Result := 0
							js.return
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_inff).to_double
							a_result.item.err := (builtin_inff).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("overflow"), ce_string ("elementary.c"), 61, 16)
								Result := 16
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 19 then -- if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 20 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_multiply_err_e (a_x: REAL_64; a_dx: REAL_64; a_y: REAL_64; a_dy: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_status: INTEGER_32
			l_tmp___0: REAL_64
		do
			l_status := (gsl_sf_multiply_e (a_x, a_y, a_result))
			l_tmp___0 := fabs (a_dx * a_y)
			a_result.item.err := a_result.item.err + (l_tmp___0 + (fabs (a_dy * a_x)))
			Result := l_status
		end

	gsl_sf_multiply (a_x: REAL_64; a_y: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_multiply_e (a_x, a_y, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_multiply_e(x, y, &result)"), ce_string ("elementary.c"), 84, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
