class
	P_ELLINT

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	locMAX3 (a_x: REAL_64; a_y: REAL_64; a_z: REAL_64): REAL_64
		local
			l_xy: REAL_64
			l_tmp: REAL_64
			l_tmp___0: REAL_64
		do
			if a_x > a_y then
				l_tmp := a_x
			else
				l_tmp := a_y
			end
			l_xy := l_tmp
			if l_xy > a_z then
				l_tmp___0 := l_xy
			else
				l_tmp___0 := a_z
			end
			Result := l_tmp___0
		end

	locMAX4 (a_x: REAL_64; a_y: REAL_64; a_z: REAL_64; a_w: REAL_64): REAL_64
		local
			l_xy: REAL_64
			l_tmp: REAL_64
			l_xyz: REAL_64
			l_tmp___0: REAL_64
			l_tmp___1: REAL_64
		do
			if a_x > a_y then
				l_tmp := a_x
			else
				l_tmp := a_y
			end
			l_xy := l_tmp
			if l_xy > a_z then
				l_tmp___0 := l_xy
			else
				l_tmp___0 := a_z
			end
			l_xyz := l_tmp___0
			if l_xyz > a_w then
				l_tmp___1 := l_xyz
			else
				l_tmp___1 := a_w
			end
			Result := l_tmp___1
		end

	gsl_sf_ellint_RC_e (a_x: REAL_64; a_y: REAL_64; a_mode: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_lolim: REAL_64
			l_uplim: REAL_64
			l_goal: NATURAL_32
			l_errtol: REAL_64
			l_tmp___0: REAL_64
			l_prec: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_xn: REAL_64
			l_yn___0: REAL_64
			l_mu: REAL_64
			l_sn: REAL_64
			l_lamda: REAL_64
			l_s: REAL_64
			l_tmp___4: REAL_64
			l_tmp___10: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lolim := 5.0 * 2.2250738585072014e-308
					l_uplim := 0.2 * 1.7976931348623157e+308
					l_goal := (gsl_gsl_mode_inst.GSL_MODE_PREC (a_mode))
					if l_goal = {NATURAL_32} 0 then
						l_tmp___0 := 0.001
					else
						l_tmp___0 := 0.03
					end
					l_errtol := l_tmp___0
					l_prec := prec_inst.gsl_prec_eps[l_goal.to_integer_32]
					if not (a_x < 0.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if not (a_y < 0.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not (a_x + a_y < l_lolim) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("ellint.c"), 83, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						if a_x > a_y then
							l_tmp___10 := a_x
						else
							l_tmp___10 := a_y
						end
						if l_tmp___10 < l_uplim then
							l_c1___2 := 1.0 / 7.0
							l_c2___0 := 9.0 / 22.0
							l_xn := a_x
							l_yn___0 := a_y
							from
							until
								js.loop_left
							loop
								js.reset
								l_mu := ((l_xn + l_yn___0) + l_yn___0) / 3.0
								l_sn := (l_yn___0 + l_mu) / l_mu - 2.0
								if (fabs (l_sn)) < l_errtol then
									js.break
								end
								if not js.loop_jumped then
									l_tmp___4 := sqrt (l_xn)
									l_lamda := (2.0 * l_tmp___4) * (sqrt (l_yn___0)) + l_yn___0
									l_xn := (l_xn + l_lamda) * 0.25
									l_yn___0 := (l_yn___0 + l_lamda) * 0.25
								end
							end
							js.reset
							l_s := (l_sn * l_sn) * (0.3 + l_sn * (l_c1___2 + l_sn * (0.375 + l_sn * l_c2___0)))
							a_result.item.val := (1.0 + l_s) / (sqrt (l_mu))
							a_result.item.err := l_prec * (fabs (a_result.item.val))
							Result := 0
							js.return
						else
							from
							until
								js.loop_left
							loop
								js.reset
								a_result.item.val := (builtin_nanf (ce_string (""))).to_double
								a_result.item.err := (builtin_nanf (ce_string (""))).to_double
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("domain error"), ce_string ("ellint.c"), 105, 1)
									Result := 1
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
				when 10 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_ellint_RD_e (a_x: REAL_64; a_y: REAL_64; a_z: REAL_64; a_mode: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_goal: NATURAL_32
			l_errtol: REAL_64
			l_tmp___0: REAL_64
			l_prec: REAL_64
			l_lolim: REAL_64
			l_uplim: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_c4___2: REAL_64
			l_xn: REAL_64
			l_yn___0: REAL_64
			l_zn: REAL_64
			l_sigma: REAL_64
			l_power4: REAL_64
			l_ea: REAL_64
			l_eb: REAL_64
			l_ec___1: REAL_64
			l_ed: REAL_64
			l_ef: REAL_64
			l_s1: REAL_64
			l_s2: REAL_64
			l_mu: REAL_64
			l_xndev: REAL_64
			l_yndev: REAL_64
			l_zndev: REAL_64
			l_xnroot: REAL_64
			l_ynroot: REAL_64
			l_znroot: REAL_64
			l_lamda: REAL_64
			l_epslon: REAL_64
			l_tmp___5: REAL_64
			l_tmp___6: REAL_64
			l_tmp___13: REAL_64
			l_tmp___14: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_goal := (gsl_gsl_mode_inst.GSL_MODE_PREC (a_mode))
					if l_goal = {NATURAL_32} 0 then
						l_tmp___0 := 0.001
					else
						l_tmp___0 := 0.03
					end
					l_errtol := l_tmp___0
					l_prec := prec_inst.gsl_prec_eps[l_goal.to_integer_32]
					l_lolim := 2.0 / (pow (1.7976931348623157e+308, 2.0 / 3.0))
					l_uplim := (pow ((0.1 * l_errtol) / 2.2250738585072014e-308, 2.0 / 3.0))
					if a_x < a_y then
						l_tmp___13 := a_x
					else
						l_tmp___13 := a_y
					end
					if not (l_tmp___13 < 0.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_x + a_y < a_z then
							l_tmp___14 := a_x + a_y
						else
							l_tmp___14 := a_z
						end
						if not (l_tmp___14 < l_lolim) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("ellint.c"), 120, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if (locMAX3 (a_x, a_y, a_z)) < l_uplim then
							l_c1___2 := 3.0 / 14.0
							l_c2___0 := 1.0 / 6.0
							l_c3___3 := 9.0 / 22.0
							l_c4___2 := 3.0 / 26.0
							l_xn := a_x
							l_yn___0 := a_y
							l_zn := a_z
							l_sigma := 0.0
							l_power4 := 1.0
							from
							until
								js.loop_left
							loop
								js.reset
								l_mu := ((l_xn + l_yn___0) + 3.0 * l_zn) * 0.2
								l_xndev := (l_mu - l_xn) / l_mu
								l_yndev := (l_mu - l_yn___0) / l_mu
								l_zndev := (l_mu - l_zn) / l_mu
								l_tmp___5 := fabs (l_zndev)
								l_tmp___6 := fabs (l_yndev)
								l_epslon := locMAX3 ((fabs (l_xndev)), l_tmp___6, l_tmp___5)
								if l_epslon < l_errtol then
									js.break
								end
								if not js.loop_jumped then
									l_xnroot := sqrt (l_xn)
									l_ynroot := sqrt (l_yn___0)
									l_znroot := sqrt (l_zn)
									l_lamda := l_xnroot * (l_ynroot + l_znroot) + l_ynroot * l_znroot
									l_sigma := l_sigma + (l_power4 / (l_znroot * (l_zn + l_lamda)))
									l_power4 := l_power4 * (0.25)
									l_xn := (l_xn + l_lamda) * 0.25
									l_yn___0 := (l_yn___0 + l_lamda) * 0.25
									l_zn := (l_zn + l_lamda) * 0.25
								end
							end
							js.reset
							l_ea := l_xndev * l_yndev
							l_eb := l_zndev * l_zndev
							l_ec___1 := l_ea - l_eb
							l_ed := l_ea - 6.0 * l_eb
							l_ef := (l_ed + l_ec___1) + l_ec___1
							l_s1 := l_ed * ((-l_c1___2 + (0.25 * l_c3___3) * l_ed) - ((1.5 * l_c4___2) * l_zndev) * l_ef)
							l_s2 := l_zndev * (l_c2___0 * l_ef + l_zndev * (-l_c3___3 * l_ec___1 + (l_zndev * l_c4___2) * l_ea))
							a_result.item.val := 3.0 * l_sigma + (l_power4 * ((1.0 + l_s1) + l_s2)) / (l_mu * (sqrt (l_mu)))
							a_result.item.err := l_prec * (fabs (a_result.item.val))
							Result := 0
							js.return
						else
							from
							until
								js.loop_left
							loop
								js.reset
								a_result.item.val := (builtin_nanf (ce_string (""))).to_double
								a_result.item.err := (builtin_nanf (ce_string (""))).to_double
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("domain error"), ce_string ("ellint.c"), 165, 1)
									Result := 1
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_ellint_RF_e (a_x: REAL_64; a_y: REAL_64; a_z: REAL_64; a_mode: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_lolim: REAL_64
			l_uplim: REAL_64
			l_goal: NATURAL_32
			l_errtol: REAL_64
			l_tmp___0: REAL_64
			l_prec: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_xn: REAL_64
			l_yn___0: REAL_64
			l_zn: REAL_64
			l_mu: REAL_64
			l_xndev: REAL_64
			l_yndev: REAL_64
			l_zndev: REAL_64
			l_e2: REAL_64
			l_e3: REAL_64
			l_s: REAL_64
			l_epslon: REAL_64
			l_lamda: REAL_64
			l_xnroot: REAL_64
			l_ynroot: REAL_64
			l_znroot: REAL_64
			l_tmp___5: REAL_64
			l_tmp___6: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lolim := 5.0 * 2.2250738585072014e-308
					l_uplim := 0.2 * 1.7976931348623157e+308
					l_goal := (gsl_gsl_mode_inst.GSL_MODE_PREC (a_mode))
					if l_goal = {NATURAL_32} 0 then
						l_tmp___0 := 0.001
					else
						l_tmp___0 := 0.03
					end
					l_errtol := l_tmp___0
					l_prec := prec_inst.gsl_prec_eps[l_goal.to_integer_32]
					if not (a_x < 0.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 3 then -- else:
						if not (a_y < 0.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 6 then -- else:
						if not (a_z < 0.0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("ellint.c"), 180, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 9 then -- else:
						if not (a_x + a_y < l_lolim) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 12 then -- else:
						if not (a_x + a_z < l_lolim) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 15 then -- else:
						if not (a_y + a_z < l_lolim) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("ellint.c"), 183, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						if (locMAX3 (a_x, a_y, a_z)) < l_uplim then
							l_c1___2 := 1.0 / 24.0
							l_c2___0 := 3.0 / 44.0
							l_c3___3 := 1.0 / 14.0
							l_xn := a_x
							l_yn___0 := a_y
							l_zn := a_z
							from
							until
								js.loop_left
							loop
								js.reset
								l_mu := ((l_xn + l_yn___0) + l_zn) / 3.0
								l_xndev := 2.0 - (l_mu + l_xn) / l_mu
								l_yndev := 2.0 - (l_mu + l_yn___0) / l_mu
								l_zndev := 2.0 - (l_mu + l_zn) / l_mu
								l_tmp___5 := fabs (l_zndev)
								l_tmp___6 := fabs (l_yndev)
								l_epslon := locMAX3 ((fabs (l_xndev)), l_tmp___6, l_tmp___5)
								if l_epslon < l_errtol then
									js.break
								end
								if not js.loop_jumped then
									l_xnroot := sqrt (l_xn)
									l_ynroot := sqrt (l_yn___0)
									l_znroot := sqrt (l_zn)
									l_lamda := l_xnroot * (l_ynroot + l_znroot) + l_ynroot * l_znroot
									l_xn := (l_xn + l_lamda) * 0.25
									l_yn___0 := (l_yn___0 + l_lamda) * 0.25
									l_zn := (l_zn + l_lamda) * 0.25
								end
							end
							js.reset
							l_e2 := l_xndev * l_yndev - l_zndev * l_zndev
							l_e3 := (l_xndev * l_yndev) * l_zndev
							l_s := (1.0 + ((l_c1___2 * l_e2 - 0.1) - l_c2___0 * l_e3) * l_e2) + l_c3___3 * l_e3
							a_result.item.val := l_s / (sqrt (l_mu))
							a_result.item.err := l_prec * (fabs (a_result.item.val))
							Result := 0
							js.return
						else
							from
							until
								js.loop_left
							loop
								js.reset
								a_result.item.val := (builtin_nanf (ce_string (""))).to_double
								a_result.item.err := (builtin_nanf (ce_string (""))).to_double
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("domain error"), ce_string ("ellint.c"), 218, 1)
									Result := 1
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
				when 19 then -- if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 20 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_ellint_RJ_e (a_x: REAL_64; a_y: REAL_64; a_z: REAL_64; a_p: REAL_64; a_mode: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_goal: NATURAL_32
			l_errtol: REAL_64
			l_tmp___0: REAL_64
			l_prec: REAL_64
			l_lolim: REAL_64
			l_uplim: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_c4___2: REAL_64
			l_xn: REAL_64
			l_yn___0: REAL_64
			l_zn: REAL_64
			l_pn: REAL_64
			l_sigma: REAL_64
			l_power4: REAL_64
			l_mu: REAL_64
			l_xndev: REAL_64
			l_yndev: REAL_64
			l_zndev: REAL_64
			l_pndev: REAL_64
			l_ea: REAL_64
			l_eb: REAL_64
			l_ec___1: REAL_64
			l_e2: REAL_64
			l_e3: REAL_64
			l_s1: REAL_64
			l_s2: REAL_64
			l_s3: REAL_64
			l_xnroot: REAL_64
			l_ynroot: REAL_64
			l_znroot: REAL_64
			l_lamda: REAL_64
			l_alfa: REAL_64
			l_beta: REAL_64
			l_epslon: REAL_64
			l_rcresult: PD_GSL_SF_RESULT_STRUCT
			l_rcstatus: INTEGER_32
			l_tmp___7: REAL_64
			l_tmp___8: REAL_64
			l_tmp___9: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_rcresult.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_goal := (gsl_gsl_mode_inst.GSL_MODE_PREC (a_mode))
					if l_goal = {NATURAL_32} 0 then
						l_tmp___0 := 0.001
					else
						l_tmp___0 := 0.03
					end
					l_errtol := l_tmp___0
					l_prec := prec_inst.gsl_prec_eps[l_goal.to_integer_32]
					l_lolim := (pow (5.0 * 2.2250738585072014e-308, 1.0 / 3.0))
					l_uplim := 0.3 * (pow (0.2 * 1.7976931348623157e+308, 1.0 / 3.0))
					if not (a_x < 0.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 3 then -- else:
						if not (a_y < 0.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 6 then -- else:
						if not (a_z < 0.0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("ellint.c"), 233, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 9 then -- else:
						if not (a_x + a_y < l_lolim) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 19 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 12 then -- else:
						if not (a_x + a_z < l_lolim) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 19 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 15 then -- else:
						if not (a_y + a_z < l_lolim) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 19 -- goto _L
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 18 then -- else:
						if not (a_p < l_lolim) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("ellint.c"), 236, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						if (locMAX4 (a_x, a_y, a_z, a_p)) < l_uplim then
							l_c1___2 := 3.0 / 14.0
							l_c2___0 := 1.0 / 3.0
							l_c3___3 := 3.0 / 22.0
							l_c4___2 := 3.0 / 26.0
							l_xn := a_x
							l_yn___0 := a_y
							l_zn := a_z
							l_pn := a_p
							l_sigma := 0.0
							l_power4 := 1.0
							from
							until
								js.loop_left
							loop
								js.reset
								l_mu := ((((l_xn + l_yn___0) + l_zn) + l_pn) + l_pn) * 0.2
								l_xndev := (l_mu - l_xn) / l_mu
								l_yndev := (l_mu - l_yn___0) / l_mu
								l_zndev := (l_mu - l_zn) / l_mu
								l_pndev := (l_mu - l_pn) / l_mu
								l_tmp___7 := fabs (l_pndev)
								l_tmp___8 := fabs (l_zndev)
								l_tmp___9 := fabs (l_yndev)
								l_epslon := locMAX4 ((fabs (l_xndev)), l_tmp___9, l_tmp___8, l_tmp___7)
								if l_epslon < l_errtol then
									js.break
								end
								if not js.loop_jumped then
									l_xnroot := sqrt (l_xn)
									l_ynroot := sqrt (l_yn___0)
									l_znroot := sqrt (l_zn)
									l_lamda := l_xnroot * (l_ynroot + l_znroot) + l_ynroot * l_znroot
									l_alfa := l_pn * ((l_xnroot + l_ynroot) + l_znroot) + (l_xnroot * l_ynroot) * l_znroot
									l_alfa := l_alfa * l_alfa
									l_beta := (l_pn * (l_pn + l_lamda)) * (l_pn + l_lamda)
									l_rcstatus := gsl_sf_ellint_RC_e (l_alfa, l_beta, a_mode, l_rcresult.address)
									if l_rcstatus /= 0 then
										a_result.item.val := 0.0
										a_result.item.err := 0.0
										Result := l_rcstatus
										js.return
									end
									if not js.return_called then
										l_sigma := l_sigma + (l_power4 * l_rcresult.val)
										l_power4 := l_power4 * (0.25)
										l_xn := (l_xn + l_lamda) * 0.25
										l_yn___0 := (l_yn___0 + l_lamda) * 0.25
										l_zn := (l_zn + l_lamda) * 0.25
										l_pn := (l_pn + l_lamda) * 0.25
									end
								end
							end
							js.reset
							if not js.return_called then
								l_ea := l_xndev * (l_yndev + l_zndev) + l_yndev * l_zndev
								l_eb := (l_xndev * l_yndev) * l_zndev
								l_ec___1 := l_pndev * l_pndev
								l_e2 := l_ea - 3.0 * l_ec___1
								l_e3 := l_eb + (2.0 * l_pndev) * (l_ea - l_ec___1)
								l_s1 := 1.0 + l_e2 * ((-l_c1___2 + (0.75 * l_c3___3) * l_e2) - (1.5 * l_c4___2) * l_e3)
								l_s2 := l_eb * (0.5 * l_c2___0 + l_pndev * ((-l_c3___3 - l_c3___3) + l_pndev * l_c4___2))
								l_s3 := (l_pndev * l_ea) * (l_c2___0 - l_pndev * l_c3___3) - (l_c2___0 * l_pndev) * l_ec___1
								a_result.item.val := 3.0 * l_sigma + (l_power4 * ((l_s1 + l_s2) + l_s3)) / (l_mu * (sqrt (l_mu)))
								a_result.item.err := l_prec * (fabs (a_result.item.val))
								Result := 0
								js.return
							end
						else
							from
							until
								js.loop_left
							loop
								js.reset
								a_result.item.val := (builtin_nanf (ce_string (""))).to_double
								a_result.item.err := (builtin_nanf (ce_string (""))).to_double
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("domain error"), ce_string ("ellint.c"), 298, 1)
									Result := 1
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
				when 22 then -- if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 23 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_ellint_F_e (a_phi: REAL_64; a_k: REAL_64; a_mode: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_phi: REAL_64
			l_nc: REAL_64
			l_phi_red: REAL_64
			l_sin_phi: REAL_64
			l_sin2_phi: REAL_64
			l_x: REAL_64
			l_y: REAL_64
			l_rf: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			l_tmp___2: REAL_64
			l_rk: PD_GSL_SF_RESULT_STRUCT
			l_rkstatus: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
		do
			create l_rf.make
			create l_rk.make

			l_phi := a_phi
			l_nc := (floor (l_phi / 3.14159265358979323846 + 0.5))
			l_phi_red := l_phi - l_nc * 3.14159265358979323846
			l_phi := l_phi_red
			l_sin_phi := (sin (l_phi))
			l_sin2_phi := l_sin_phi * l_sin_phi
			l_x := 1.0 - l_sin2_phi
			l_y := 1.0 - (a_k * a_k) * l_sin2_phi
			l_status := (gsl_sf_ellint_RF_e (l_x, l_y, 1.0, a_mode, l_rf.address))
			a_result.item.val := l_sin_phi * l_rf.val
			l_tmp___2 := fabs (a_result.item.val)
			a_result.item.err := 2.2204460492503131e-16 * l_tmp___2 + (fabs (l_sin_phi * l_rf.err))
			if l_nc = (0).to_double then
				Result := l_status
			else
				l_rkstatus := (gsl_sf_ellint_Kcomp_e (a_k, a_mode, l_rk.address))
				a_result.item.val := a_result.item.val + (((2).to_double * l_nc) * l_rk.val)
				a_result.item.err := a_result.item.err + (((2).to_double * (fabs (l_nc))) * l_rk.err)
				if l_status /= 0 then
					l_tmp___7 := l_status
				else
					if l_rkstatus /= 0 then
						l_tmp___6 := l_rkstatus
					else
						l_tmp___6 := 0
					end
					l_tmp___7 := l_tmp___6
				end
				Result := l_tmp___7
			end
		end

	gsl_sf_ellint_E_e (a_phi: REAL_64; a_k: REAL_64; a_mode: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_phi: REAL_64
			l_nc: REAL_64
			l_phi_red: REAL_64
			l_sin_phi: REAL_64
			l_sin2_phi: REAL_64
			l_x: REAL_64
			l_y: REAL_64
			l_re: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			l_tmp___2: INTEGER_32
			l_rf: PD_GSL_SF_RESULT_STRUCT
			l_rd: PD_GSL_SF_RESULT_STRUCT
			l_sin3_phi: REAL_64
			l_rfstatus: INTEGER_32
			l_rdstatus: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_re___0: PD_GSL_SF_RESULT_STRUCT
			l_restatus: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
		do
			create l_re.make
			create l_rf.make
			create l_rd.make
			create l_re___0.make

			l_phi := a_phi
			l_nc := (floor (l_phi / 3.14159265358979323846 + 0.5))
			l_phi_red := l_phi - l_nc * 3.14159265358979323846
			l_phi := l_phi_red
			l_sin_phi := (sin (l_phi))
			l_sin2_phi := l_sin_phi * l_sin_phi
			l_x := 1.0 - l_sin2_phi
			l_y := 1.0 - (a_k * a_k) * l_sin2_phi
			if l_x < 2.2204460492503131e-16 then
				l_status := (gsl_sf_ellint_Ecomp_e (a_k, a_mode, l_re.address))
				if l_sin_phi >= 0.0 then
					l_tmp___2 := 1
				else
					l_tmp___2 := -1
				end
				a_result.item.val := ((2).to_double * l_nc) * l_re.val + l_tmp___2.to_double * l_re.val
				a_result.item.err := ((2).to_double * (fabs (l_nc))) * l_re.err + l_re.err
				Result := l_status
			else
				l_sin3_phi := l_sin2_phi * l_sin_phi
				l_rfstatus := (gsl_sf_ellint_RF_e (l_x, l_y, 1.0, a_mode, l_rf.address))
				l_rdstatus := (gsl_sf_ellint_RD_e (l_x, l_y, 1.0, a_mode, l_rd.address))
				a_result.item.val := l_sin_phi * l_rf.val - (((a_k * a_k) / 3.0) * l_sin3_phi) * l_rd.val
				a_result.item.err := 2.2204460492503131e-16 * (fabs (l_sin_phi * l_rf.val))
				a_result.item.err := a_result.item.err + (fabs (l_sin_phi * l_rf.err))
				a_result.item.err := a_result.item.err + ((((a_k * a_k) / 3.0) * 2.2204460492503131e-16) * (fabs (l_sin3_phi * l_rd.val)))
				a_result.item.err := a_result.item.err + (((a_k * a_k) / 3.0) * (fabs (l_sin3_phi * l_rd.err)))
				if l_nc = (0).to_double then
					if l_rfstatus /= 0 then
						l_tmp___11 := l_rfstatus
					else
						if l_rdstatus /= 0 then
							l_tmp___10 := l_rdstatus
						else
							l_tmp___10 := 0
						end
						l_tmp___11 := l_tmp___10
					end
					Result := l_tmp___11
				else
					l_restatus := (gsl_sf_ellint_Ecomp_e (a_k, a_mode, l_re___0.address))
					a_result.item.val := a_result.item.val + (((2).to_double * l_nc) * l_re___0.val)
					a_result.item.err := a_result.item.err + (((2).to_double * (fabs (l_nc))) * l_re___0.err)
					if l_rfstatus /= 0 then
						l_tmp___16 := l_rfstatus
					else
						if l_rdstatus /= 0 then
							l_tmp___15 := l_rdstatus
						else
							if l_restatus /= 0 then
								l_tmp___14 := l_restatus
							else
								l_tmp___14 := 0
							end
							l_tmp___15 := l_tmp___14
						end
						l_tmp___16 := l_tmp___15
					end
					Result := l_tmp___16
				end
			end
		end

	gsl_sf_ellint_P_e (a_phi: REAL_64; a_k: REAL_64; a_n: REAL_64; a_mode: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_phi: REAL_64
			l_nc: REAL_64
			l_phi_red: REAL_64
			l_sin_phi: REAL_64
			l_sin2_phi: REAL_64
			l_sin3_phi: REAL_64
			l_x: REAL_64
			l_y: REAL_64
			l_rf: PD_GSL_SF_RESULT_STRUCT
			l_rj: PD_GSL_SF_RESULT_STRUCT
			l_rfstatus: INTEGER_32
			l_rjstatus: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_rp: PD_GSL_SF_RESULT_STRUCT
			l_rpstatus: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
		do
			create l_rf.make
			create l_rj.make
			create l_rp.make

			l_phi := a_phi
			l_nc := (floor (l_phi / 3.14159265358979323846 + 0.5))
			l_phi_red := l_phi - l_nc * 3.14159265358979323846
			l_phi := l_phi_red
			l_sin_phi := (sin (l_phi))
			l_sin2_phi := l_sin_phi * l_sin_phi
			l_sin3_phi := l_sin2_phi * l_sin_phi
			l_x := 1.0 - l_sin2_phi
			l_y := 1.0 - (a_k * a_k) * l_sin2_phi
			l_rfstatus := (gsl_sf_ellint_RF_e (l_x, l_y, 1.0, a_mode, l_rf.address))
			l_rjstatus := (gsl_sf_ellint_RJ_e (l_x, l_y, 1.0, 1.0 + a_n * l_sin2_phi, a_mode, l_rj.address))
			a_result.item.val := l_sin_phi * l_rf.val - ((a_n / 3.0) * l_sin3_phi) * l_rj.val
			a_result.item.err := 2.2204460492503131e-16 * (fabs (l_sin_phi * l_rf.val))
			a_result.item.err := a_result.item.err + (fabs (l_sin_phi * l_rf.err))
			a_result.item.err := a_result.item.err + (((a_n / 3.0) * 2.2204460492503131e-16) * (fabs (l_sin3_phi * l_rj.val)))
			a_result.item.err := a_result.item.err + ((a_n / 3.0) * (fabs (l_sin3_phi * l_rj.err)))
			if l_nc = (0).to_double then
				if l_rfstatus /= 0 then
					l_tmp___8 := l_rfstatus
				else
					if l_rjstatus /= 0 then
						l_tmp___7 := l_rjstatus
					else
						l_tmp___7 := 0
					end
					l_tmp___8 := l_tmp___7
				end
				Result := l_tmp___8
			else
				l_rpstatus := (gsl_sf_ellint_Pcomp_e (a_k, a_n, a_mode, l_rp.address))
				a_result.item.val := a_result.item.val + (((2).to_double * l_nc) * l_rp.val)
				a_result.item.err := a_result.item.err + (((2).to_double * (fabs (l_nc))) * l_rp.err)
				if l_rfstatus /= 0 then
					l_tmp___13 := l_rfstatus
				else
					if l_rjstatus /= 0 then
						l_tmp___12 := l_rjstatus
					else
						if l_rpstatus /= 0 then
							l_tmp___11 := l_rpstatus
						else
							l_tmp___11 := 0
						end
						l_tmp___12 := l_tmp___11
					end
					l_tmp___13 := l_tmp___12
				end
				Result := l_tmp___13
			end
		end

	gsl_sf_ellint_D_e (a_phi: REAL_64; a_k: REAL_64; a_n: REAL_64; a_mode: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_phi: REAL_64
			l_nc: REAL_64
			l_phi_red: REAL_64
			l_sin_phi: REAL_64
			l_sin2_phi: REAL_64
			l_sin3_phi: REAL_64
			l_x: REAL_64
			l_y: REAL_64
			l_rd: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			l_tmp___2: REAL_64
			l_rd___0: PD_GSL_SF_RESULT_STRUCT
			l_rdstatus: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
		do
			create l_rd.make
			create l_rd___0.make

			l_phi := a_phi
			l_nc := (floor (l_phi / 3.14159265358979323846 + 0.5))
			l_phi_red := l_phi - l_nc * 3.14159265358979323846
			l_phi := l_phi_red
			l_sin_phi := (sin (l_phi))
			l_sin2_phi := l_sin_phi * l_sin_phi
			l_sin3_phi := l_sin2_phi * l_sin_phi
			l_x := 1.0 - l_sin2_phi
			l_y := 1.0 - (a_k * a_k) * l_sin2_phi
			l_status := (gsl_sf_ellint_RD_e (l_x, l_y, 1.0, a_mode, l_rd.address))
			a_result.item.val := (l_sin3_phi / 3.0) * l_rd.val
			l_tmp___2 := fabs (a_result.item.val)
			a_result.item.err := 2.2204460492503131e-16 * l_tmp___2 + (fabs ((l_sin3_phi / 3.0) * l_rd.err))
			if l_nc = (0).to_double then
				Result := l_status
			else
				l_rdstatus := (gsl_sf_ellint_Dcomp_e (a_k, a_mode, l_rd___0.address))
				a_result.item.val := a_result.item.val + (((2).to_double * l_nc) * l_rd___0.val)
				a_result.item.err := a_result.item.err + (((2).to_double * (fabs (l_nc))) * l_rd___0.err)
				if l_status /= 0 then
					l_tmp___7 := l_status
				else
					if l_rdstatus /= 0 then
						l_tmp___6 := l_rdstatus
					else
						l_tmp___6 := 0
					end
					l_tmp___7 := l_tmp___6
				end
				Result := l_tmp___7
			end
		end

	gsl_sf_ellint_Dcomp_e (a_k: REAL_64; a_mode: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_y: REAL_64
			l_rd: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			l_tmp___2: REAL_64
			js: JUMP_STATE
		do
			create l_rd.make

			if a_k * a_k >= 1.0 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("ellint.c"), 464, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_y := 1.0 - a_k * a_k
				l_status := (gsl_sf_ellint_RD_e (0.0, l_y, 1.0, a_mode, l_rd.address))
				a_result.item.val := (1.0 / 3.0) * l_rd.val
				l_tmp___2 := fabs (a_result.item.val)
				a_result.item.err := 2.2204460492503131e-16 * l_tmp___2 + (fabs ((1.0 / 3.0) * l_rd.err))
				Result := l_status
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_ellint_Kcomp_e (a_k: REAL_64; a_mode: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_y: REAL_64
			l_a___5: CE_ARRAY [REAL_64]
			l_b___0: CE_ARRAY [REAL_64]
			l_ta: REAL_64
			l_tb: REAL_64
			l_tmp___2: REAL_64
			l_y___0: REAL_64
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_a___5.make (<<3>>)
			create l_b___0.make (<<3>>)

			if a_k * a_k >= 1.0 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("ellint.c"), 481, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_k * a_k >= 1.0 - 1.4901161193847656e-08 then
				l_y := 1.0 - a_k * a_k
				l_a___5[0] := 1.38629436112
				l_a___5[1] := 0.09666344259
				l_a___5[2] := 0.03590092383
				l_b___0[0] := 0.5
				l_b___0[1] := 0.12498593597
				l_b___0[2] := 0.06880248576
				l_ta := l_a___5[0] + l_y * (l_a___5[1] + l_y * l_a___5[2])
				l_tb := -(log (l_y)) * (l_b___0[0] + l_y * (l_b___0[1] + l_y * l_b___0[2]))
				a_result.item.val := l_ta + l_tb
				l_tmp___2 := fabs (a_result.item.val)
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (l_tmp___2 + (fabs (a_k / l_y)))
				Result := 0
				js.return
			else
				l_y___0 := 1.0 - a_k * a_k
				l_status := (gsl_sf_ellint_RF_e (0.0, l_y___0, 1.0, a_mode, a_result))
				a_result.item.err := a_result.item.err + ((0.5 * 2.2204460492503131e-16) / l_y___0)
				Result := l_status
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_ellint_Ecomp_e (a_k: REAL_64; a_mode: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_y: REAL_64
			l_a___5: CE_ARRAY [REAL_64]
			l_b___0: CE_ARRAY [REAL_64]
			l_ta: REAL_64
			l_tb: REAL_64
			l_rf: PD_GSL_SF_RESULT_STRUCT
			l_rd: PD_GSL_SF_RESULT_STRUCT
			l_y___0: REAL_64
			l_rfstatus: INTEGER_32
			l_rdstatus: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
		do
			create l_a___5.make (<<3>>)
			create l_b___0.make (<<3>>)
			create l_rf.make
			create l_rd.make

			if a_k * a_k >= 1.0 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("ellint.c"), 518, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_k * a_k >= 1.0 - 1.4901161193847656e-08 then
				l_y := 1.0 - a_k * a_k
				l_a___5[0] := 0.44325141463
				l_a___5[1] := 0.06260601220
				l_a___5[2] := 0.04757383546
				l_b___0[0] := 0.24998368310
				l_b___0[1] := 0.09200180037
				l_b___0[2] := 0.04069697526
				l_ta := 1.0 + l_y * (l_a___5[0] + l_y * (l_a___5[1] + l_a___5[2] * l_y))
				l_tb := (-l_y * (log (l_y))) * (l_b___0[0] + l_y * (l_b___0[1] + l_b___0[2] * l_y))
				a_result.item.val := l_ta + l_tb
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * a_result.item.val
				Result := 0
				js.return
			else
				l_y___0 := 1.0 - a_k * a_k
				l_rfstatus := (gsl_sf_ellint_RF_e (0.0, l_y___0, 1.0, a_mode, l_rf.address))
				l_rdstatus := (gsl_sf_ellint_RD_e (0.0, l_y___0, 1.0, a_mode, l_rd.address))
				a_result.item.val := l_rf.val - ((a_k * a_k) / 3.0) * l_rd.val
				a_result.item.err := l_rf.err + ((a_k * a_k) / 3.0) * l_rd.err
				if l_rfstatus /= 0 then
					l_tmp___5 := l_rfstatus
				else
					if l_rdstatus /= 0 then
						l_tmp___4 := l_rdstatus
					else
						l_tmp___4 := 0
					end
					l_tmp___5 := l_tmp___4
				end
				Result := l_tmp___5
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_ellint_Pcomp_e (a_k: REAL_64; a_n: REAL_64; a_mode: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_rf: PD_GSL_SF_RESULT_STRUCT
			l_rj: PD_GSL_SF_RESULT_STRUCT
			l_y: REAL_64
			l_rfstatus: INTEGER_32
			l_rjstatus: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
		do
			create l_rf.make
			create l_rj.make

			if a_k * a_k >= 1.0 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("ellint.c"), 548, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_y := 1.0 - a_k * a_k
				l_rfstatus := (gsl_sf_ellint_RF_e (0.0, l_y, 1.0, a_mode, l_rf.address))
				l_rjstatus := (gsl_sf_ellint_RJ_e (0.0, l_y, 1.0, 1.0 + a_n, a_mode, l_rj.address))
				a_result.item.val := l_rf.val - (a_n / 3.0) * l_rj.val
				a_result.item.err := l_rf.err + (fabs (a_n / 3.0)) * l_rj.err
				if l_rfstatus /= 0 then
					l_tmp___5 := l_rfstatus
				else
					if l_rjstatus /= 0 then
						l_tmp___4 := l_rjstatus
					else
						l_tmp___4 := 0
					end
					l_tmp___5 := l_tmp___4
				end
				Result := l_tmp___5
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_ellint_Kcomp (a_k: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_ellint_Kcomp_e (a_k, a_mode, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_ellint_Kcomp_e(k, mode, &result)"), ce_string ("ellint.c"), 571, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_ellint_Ecomp (a_k: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_ellint_Ecomp_e (a_k, a_mode, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_ellint_Ecomp_e(k, mode, &result)"), ce_string ("ellint.c"), 576, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_ellint_Pcomp (a_k: REAL_64; a_n: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_ellint_Pcomp_e (a_k, a_n, a_mode, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_ellint_Pcomp_e(k, n, mode, &result)"), ce_string ("ellint.c"), 581, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_ellint_Dcomp (a_k: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_ellint_Dcomp_e (a_k, a_mode, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_ellint_Dcomp_e(k, mode, &result)"), ce_string ("ellint.c"), 586, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_ellint_F (a_phi: REAL_64; a_k: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_ellint_F_e (a_phi, a_k, a_mode, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_ellint_F_e(phi, k, mode, &result)"), ce_string ("ellint.c"), 591, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_ellint_E (a_phi: REAL_64; a_k: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_ellint_E_e (a_phi, a_k, a_mode, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_ellint_E_e(phi, k, mode, &result)"), ce_string ("ellint.c"), 596, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_ellint_P (a_phi: REAL_64; a_k: REAL_64; a_n: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_ellint_P_e (a_phi, a_k, a_n, a_mode, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_ellint_P_e(phi, k, n, mode, &result)"), ce_string ("ellint.c"), 601, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_ellint_D (a_phi: REAL_64; a_k: REAL_64; a_n: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_ellint_D_e (a_phi, a_k, a_n, a_mode, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_ellint_D_e(phi, k, n, mode, &result)"), ce_string ("ellint.c"), 606, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_ellint_RC (a_x: REAL_64; a_y: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_ellint_RC_e (a_x, a_y, a_mode, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_ellint_RC_e(x, y, mode, &result)"), ce_string ("ellint.c"), 611, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_ellint_RD (a_x: REAL_64; a_y: REAL_64; a_z: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_ellint_RD_e (a_x, a_y, a_z, a_mode, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_ellint_RD_e(x, y, z, mode, &result)"), ce_string ("ellint.c"), 616, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_ellint_RF (a_x: REAL_64; a_y: REAL_64; a_z: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_ellint_RF_e (a_x, a_y, a_z, a_mode, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_ellint_RF_e(x, y, z, mode, &result)"), ce_string ("ellint.c"), 621, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_ellint_RJ (a_x: REAL_64; a_y: REAL_64; a_z: REAL_64; a_p: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_ellint_RJ_e (a_x, a_y, a_z, a_p, a_mode, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_ellint_RJ_e(x, y, z, p, mode, &result)"), ce_string ("ellint.c"), 626, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
