class
	P_EVOLVE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_odeiv_evolve_alloc (a_dim: NATURAL_32): CE_POINTER [PD_GSL_ODEIV_EVOLVE]
		local
			l_e: CE_POINTER [PD_GSL_ODEIV_EVOLVE]
			js: JUMP_STATE
		do
			create l_e.make

			l_e.ce_gets (create {CE_POINTER [PD_GSL_ODEIV_EVOLVE]}.make_cast ((malloc ({PD_GSL_ODEIV_EVOLVE}.sizeof.to_natural_32))))
			if (l_e.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("failed to allocate space for evolve struct"), ce_string ("evolve.c"), 40, 8)
					Result := (create {CE_POINTER [PD_GSL_ODEIV_EVOLVE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_e.item.y0 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * Real_64_bytes.to_natural_32)))
				if ((l_e.item.y0).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_e))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for y0"), ce_string ("evolve.c"), 48, 8)
						Result := (create {CE_POINTER [PD_GSL_ODEIV_EVOLVE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_e.item.yerr := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * Real_64_bytes.to_natural_32)))
				if ((l_e.item.yerr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_e.item.y0))
					free (create {CE_POINTER [ANY]}.make_cast (l_e))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for yerr"), ce_string ("evolve.c"), 57, 8)
						Result := (create {CE_POINTER [PD_GSL_ODEIV_EVOLVE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_e.item.dydt_in := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * Real_64_bytes.to_natural_32)))
				if ((l_e.item.dydt_in).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_e.item.yerr))
					free (create {CE_POINTER [ANY]}.make_cast (l_e.item.y0))
					free (create {CE_POINTER [ANY]}.make_cast (l_e))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for dydt_in"), ce_string ("evolve.c"), 67, 8)
						Result := (create {CE_POINTER [PD_GSL_ODEIV_EVOLVE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_e.item.dydt_out := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * Real_64_bytes.to_natural_32)))
				if ((l_e.item.dydt_out).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_e.item.dydt_in))
					free (create {CE_POINTER [ANY]}.make_cast (l_e.item.yerr))
					free (create {CE_POINTER [ANY]}.make_cast (l_e.item.y0))
					free (create {CE_POINTER [ANY]}.make_cast (l_e))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for dydt_out"), ce_string ("evolve.c"), 78, 8)
						Result := (create {CE_POINTER [PD_GSL_ODEIV_EVOLVE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_e.item.dimension := a_dim
				l_e.item.count := {NATURAL_32} 0
				l_e.item.failed_steps := {NATURAL_32} 0
				l_e.item.last_step := 0.0
				Result := l_e
			end
		end

	gsl_odeiv_evolve_reset (a_e: CE_POINTER [PD_GSL_ODEIV_EVOLVE]): INTEGER_32
		do
			a_e.item.count := {NATURAL_32} 0
			a_e.item.failed_steps := {NATURAL_32} 0
			a_e.item.last_step := 0.0
			Result := 0
		end

	gsl_odeiv_evolve_free (a_e: CE_POINTER [PD_GSL_ODEIV_EVOLVE])
		local
			js: JUMP_STATE
		do
			if (a_e).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (a_e.item.dydt_out))
				free (create {CE_POINTER [ANY]}.make_cast (a_e.item.dydt_in))
				free (create {CE_POINTER [ANY]}.make_cast (a_e.item.yerr))
				free (create {CE_POINTER [ANY]}.make_cast (a_e.item.y0))
				free (create {CE_POINTER [ANY]}.make_cast (a_e))
			end
		end

	gsl_odeiv_evolve_apply (a_e: CE_POINTER [PD_GSL_ODEIV_EVOLVE]; a_con: CE_POINTER [PD_GSL_ODEIV_CONTROL]; a_step: CE_POINTER [PD_GSL_ODEIV_STEP]; a_dydt: CE_POINTER [PD_GSL_ODEIV_SYSTEM]; a_t: CE_POINTER [REAL_64]; a_t1: REAL_64; a_h: CE_POINTER [REAL_64]; a_y: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_t0: REAL_64
			l_h0: REAL_64
			l_step_status: INTEGER_32
			l_final_step: INTEGER_32
			l_dt: REAL_64
			l_status: INTEGER_32
			l_h_old: REAL_64
			l_hadjust_status: INTEGER_32
			l_t_curr: REAL_64
			l_t_next: REAL_64
			l_tmp___3: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_t0 := a_t.item
					l_h0 := a_h.item
					l_final_step := 0
					l_dt := a_t1 - l_t0
					if a_e.item.dimension /= a_step.item.dimension then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("step dimension must match evolution size"), ce_string ("evolve.c"), 128, 4)
							Result := 4
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if not (l_dt < 0.0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_h0 > 0.0 then
							l_pos := -1 + 6 -- goto _L
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 4 then -- else: | _L___0:
						if not (l_dt > 0.0) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if not (l_h0 < 0.0) then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("step direction must match interval direction"), ce_string ("evolve.c"), 133, 4)
							Result := 4
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 7 then -- if done | if done | if done
						if not js.return_called then
							if (a_con.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								memcpy (create {CE_POINTER [ANY]}.make_cast (a_e.item.y0), create {CE_POINTER [ANY]}.make_cast (a_y), a_e.item.dimension * Real_64_bytes.to_natural_32).do_nothing
							end
							if ((a_step.item.type).item.can_use_dydt_in).to_boolean then
								l_status := ((a_dydt.item.function).integer_32_item ([l_t0, a_y, a_e.item.dydt_in, a_dydt.item.params]))
								if l_status.to_boolean then
									Result := l_status
									js.return
								end
							end
						end
						if js.return_called then
							l_pos := -1 + 13 -- skip if block
						end
				when 8 then -- if: | try_step:
							if not (l_dt >= 0.0) then
								l_pos := -1 + 11 -- skip if block
							end
				when 9 then -- if:
							if l_h0 > l_dt then
								l_h0 := l_dt
								l_final_step := 1
							else
								l_pos := -1 + 11 -- goto _L___1
							end
				when 10 then -- if block done, skip else block:
							l_pos := -1 + 12
				when 11 then -- else: | _L___1:
							if l_dt < 0.0 then
								if l_h0 < l_dt then
									l_h0 := l_dt
									l_final_step := 1
								else
									l_final_step := 0
								end
							else
								l_final_step := 0
							end
				when 12 then
							if ((a_step.item.type).item.can_use_dydt_in).to_boolean then
								l_step_status := step_inst.gsl_odeiv_step_apply (a_step, l_t0, l_h0, a_y, a_e.item.yerr, a_e.item.dydt_in, a_e.item.dydt_out, a_dydt)
							else
								l_step_status := step_inst.gsl_odeiv_step_apply (a_step, l_t0, l_h0, a_y, a_e.item.yerr, create {CE_POINTER [REAL_64]}.make_shared (default_pointer), a_e.item.dydt_out, a_dydt)
							end
							if l_step_status /= 0 then
								a_h.item := l_h0
								a_t.item := l_t0
								Result := l_step_status
								js.return
							end
				when 13 then -- if done
						if js.return_called then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
							a_e.item.count := (a_e.item.count) + 1
							a_e.item.last_step := l_h0
							if l_final_step.to_boolean then
								a_t.item := a_t1
							else
								a_t.item := l_t0 + l_h0
							end
							if (a_con.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_h_old := l_h0
								l_hadjust_status := (control_inst.gsl_odeiv_control_hadjust (a_con, a_step, a_y, a_e.item.yerr, a_e.item.dydt_out, create {CE_POINTER [REAL_64]}.make_shared ($l_h0)))
								if l_hadjust_status = -1 then
									l_t_curr := (coerce_inst.gsl_coerce_double (a_t.item))
									l_t_next := (coerce_inst.gsl_coerce_double (a_t.item + l_h0))
									l_tmp___3 := fabs (l_h0)
									if l_tmp___3 < (fabs (l_h_old)) then
										if l_t_next /= l_t_curr then
											memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (a_e.item.y0), (a_dydt.item.dimension * Real_64_bytes.to_natural_32)).do_nothing
											a_e.item.failed_steps := (a_e.item.failed_steps) + 1
											l_pos := -1 + 8 -- goto try_step
										else
											l_h0 := l_h_old
										end
									else
										l_h0 := l_h_old
									end
								end
							end
				when 15 then
							a_h.item := l_h0
							Result := l_step_status
				when 16 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
