class
	P_EXP

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	exprel_n_CF (a_N: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_RECUR_BIG: REAL_64
			l_maxiter: INTEGER_32
			l_n: INTEGER_32
			l_Anm2: REAL_64
			l_Bnm2: REAL_64
			l_Anm1: REAL_64
			l_Bnm1: REAL_64
			l_a1___4: REAL_64
			l_b1___0: REAL_64
			l_a2___3: REAL_64
			l_b2: REAL_64
			l_an: REAL_64
			l_bn: REAL_64
			l_fn: REAL_64
			l_An2: REAL_64
			l_Bn2: REAL_64
			l_old_fn: REAL_64
			l_del: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_RECUR_BIG := 1.3407807929942596e+154
					l_maxiter := 5000
					l_n := 1
					l_Anm2 := 1.0
					l_Bnm2 := 0.0
					l_Anm1 := 0.0
					l_Bnm1 := 1.0
					l_a1___4 := 1.0
					l_b1___0 := 1.0
					l_a2___3 := -a_x
					l_b2 := a_N + (1).to_double
					l_An2 := l_b1___0 * l_Anm1 + l_a1___4 * l_Anm2
					l_Bn2 := l_b1___0 * l_Bnm1 + l_a1___4 * l_Bnm2
					l_n := l_n + 1
					l_Anm2 := l_Anm1
					l_Bnm2 := l_Bnm1
					l_Anm1 := l_An2
					l_Bnm1 := l_Bn2
					l_An2 := l_b2 * l_Anm1 + l_a2___3 * l_Anm2
					l_Bn2 := l_b2 * l_Bnm1 + l_a2___3 * l_Bnm2
					l_fn := l_An2 / l_Bn2
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_n < l_maxiter)) then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_n := l_n + 1
						l_Anm2 := l_Anm1
						l_Bnm2 := l_Bnm1
						l_Anm1 := l_An2
						l_Bnm1 := l_Bn2
						if ((l_n).bit_and (1)).to_boolean then
							l_an := ((l_n - 1) // 2).to_double * a_x
						else
							l_an := -((a_N + (l_n // 2).to_double) - (1).to_double) * a_x
						end
						l_bn := (a_N + l_n.to_double) - (1).to_double
						l_An2 := l_bn * l_Anm1 + l_an * l_Anm2
						l_Bn2 := l_bn * l_Bnm1 + l_an * l_Bnm2
						if not ((fabs (l_An2)) > l_RECUR_BIG) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if not ((fabs (l_Bn2)) > l_RECUR_BIG) then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						l_An2 := l_An2 / l_RECUR_BIG
						l_Bn2 := l_Bn2 / l_RECUR_BIG
						l_Anm1 := l_Anm1 / l_RECUR_BIG
						l_Bnm1 := l_Bnm1 / l_RECUR_BIG
						l_Anm2 := l_Anm2 / l_RECUR_BIG
						l_Bnm2 := l_Bnm2 / l_RECUR_BIG
				when 7 then -- if done
						l_old_fn := l_fn
						l_fn := l_An2 / l_Bn2
						l_del := l_old_fn / l_fn
						if (fabs (l_del - 1.0)) < 2.0 * 2.2204460492503131e-16 then
							js.break
						end
						l_pos := -1 + 1 -- back to loop condition
				when 8 then -- loop done
					js.reset
					a_result.item.val := l_fn
					a_result.item.err := ((4.0 * (l_n.to_double + 1.0)) * 2.2204460492503131e-16) * (fabs (l_fn))
					if l_n = l_maxiter then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("error"), ce_string ("exp.c"), 99, 11)
							Result := 11
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					else
						Result := 0
						js.return
					end
					if not js.return_called then
						Result := 0
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_sf_exp_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_x > 7.0978271289338397e+02 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_inff).to_double
					a_result.item.err := (builtin_inff).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("overflow"), ce_string ("exp.c"), 110, 16)
						Result := 16
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_x < -7.0839641853226408e+02 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := 0.0
					a_result.item.err := 2.2250738585072014e-308
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("exp.c"), 113, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				a_result.item.val := exp (a_x)
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_exp_e10_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_E10_STRUCT]): INTEGER_32
		local
			l_N: INTEGER_32
			l_tmp___1: REAL_64
			l_tmp___2: INTEGER_32
			l_tmp___3: REAL_64
			js: JUMP_STATE
		do
			if a_x > (2147483646).to_double then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_inff).to_double
					a_result.item.err := (builtin_inff).to_double
					a_result.item.e10 := 0
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("overflow"), ce_string ("exp.c"), 125, 16)
						Result := 16
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_x < (-2147483647).to_double then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := 0.0
					a_result.item.err := 2.2250738585072014e-308
					a_result.item.e10 := 0
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("exp.c"), 128, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				if a_x > 7.0978271289338397e+02 then
					l_tmp___1 := floor (a_x / 2.30258509299404568402)
					l_tmp___2 := l_tmp___1.truncated_to_integer
				elseif a_x < -7.0839641853226408e+02 then
					l_tmp___1 := floor (a_x / 2.30258509299404568402)
					l_tmp___2 := l_tmp___1.truncated_to_integer
				else
					l_tmp___2 := 0
				end
				l_N := l_tmp___2
				a_result.item.val := exp (a_x - l_N.to_double * 2.30258509299404568402)
				l_tmp___3 := fabs (a_x)
				a_result.item.err := ((2.0 * (l_tmp___3 + 1.0)) * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				a_result.item.e10 := l_N
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_exp_mult_e (a_x: REAL_64; a_y: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ay: REAL_64
			l_ex: REAL_64
			l_tmp___1: REAL_64
			l_ly: REAL_64
			l_lnr: REAL_64
			l_sy: REAL_64
			l_tmp___6: INTEGER_32
			l_M: REAL_64
			l_N: REAL_64
			l_a___5: REAL_64
			l_b___0: REAL_64
			l_berr: REAL_64
			l_tmp___9: REAL_64
			l_tmp___11: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ay := (fabs (a_y))
					if a_y /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_result.item.val := 0.0
						a_result.item.err := 0.0
						Result := 0
						js.return
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_x < 0.5 * 7.0978271289338397e+02) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_x > 0.5 * -7.0839641853226408e+02 then
							if l_ay < 0.8 * 1.3407807929942596e+154 then
								if l_ay > 1.2 * 1.4916681462400413e-154 then
									l_ex := (exp (a_x))
									a_result.item.val := a_y * l_ex
									l_tmp___1 := fabs (a_x)
									a_result.item.err := ((2.0 + l_tmp___1) * 2.2204460492503131e-16) * (fabs (a_result.item.val))
									Result := 0
									js.return
								else
									l_pos := -1 + 6 -- goto _L___0
								end
							else
								l_pos := -1 + 6 -- goto _L___0
							end
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L___0:
						l_ly := (log (l_ay))
						l_lnr := a_x + l_ly
						if l_lnr > 7.0978271289338397e+02 - 0.01 then
							from
							until
								js.loop_left
							loop
								js.reset
								a_result.item.val := (builtin_inff).to_double
								a_result.item.err := (builtin_inff).to_double
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("overflow"), ce_string ("exp.c"), 162, 16)
									Result := 16
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
								if not js.return_called then
									js.break
								end
							end
							js.reset
						elseif l_lnr < -7.0839641853226408e+02 + 0.01 then
							from
							until
								js.loop_left
							loop
								js.reset
								a_result.item.val := 0.0
								a_result.item.err := 2.2250738585072014e-308
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("underflow"), ce_string ("exp.c"), 165, 15)
									Result := 15
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
								if not js.return_called then
									js.break
								end
							end
							js.reset
						else
							if a_y >= 0.0 then
								l_tmp___6 := 1
							else
								l_tmp___6 := -1
							end
							l_sy := l_tmp___6.to_double
							l_M := (floor (a_x))
							l_N := (floor (l_ly))
							l_a___5 := a_x - l_M
							l_b___0 := l_ly - l_N
							l_tmp___9 := fabs (l_ly)
							l_berr := (2.0 * 2.2204460492503131e-16) * (l_tmp___9 + (fabs (l_N)))
							l_tmp___11 := exp (l_M + l_N)
							a_result.item.val := (l_sy * l_tmp___11) * (exp (l_a___5 + l_b___0))
							a_result.item.err := l_berr * (fabs (a_result.item.val))
							a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * ((l_M + l_N) + 1.0)) * (fabs (a_result.item.val)))
							Result := 0
							js.return
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_exp_mult_e10_e (a_x: REAL_64; a_y: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_E10_STRUCT]): INTEGER_32
		local
			l_ay: REAL_64
			l_ex: REAL_64
			l_tmp___1: REAL_64
			l_ly: REAL_64
			l_l10_val: REAL_64
			l_sy: REAL_64
			l_tmp___6: INTEGER_32
			l_N: INTEGER_32
			l_arg_val: REAL_64
			l_arg_err: REAL_64
			l_tmp___8: REAL_64
			l_tmp___9: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ay := (fabs (a_y))
					if a_y /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_result.item.val := 0.0
						a_result.item.err := 0.0
						a_result.item.e10 := 0
						Result := 0
						js.return
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_x < 0.5 * 7.0978271289338397e+02) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_x > 0.5 * -7.0839641853226408e+02 then
							if l_ay < 0.8 * 1.3407807929942596e+154 then
								if l_ay > 1.2 * 1.4916681462400413e-154 then
									l_ex := (exp (a_x))
									a_result.item.val := a_y * l_ex
									l_tmp___1 := fabs (a_x)
									a_result.item.err := ((2.0 + l_tmp___1) * 2.2204460492503131e-16) * (fabs (a_result.item.val))
									a_result.item.e10 := 0
									Result := 0
									js.return
								else
									l_pos := -1 + 6 -- goto _L___0
								end
							else
								l_pos := -1 + 6 -- goto _L___0
							end
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L___0:
						l_ly := (log (l_ay))
						l_l10_val := (a_x + l_ly) / 2.30258509299404568402
						if l_l10_val > (2147483646).to_double then
							from
							until
								js.loop_left
							loop
								js.reset
								a_result.item.val := (builtin_inff).to_double
								a_result.item.err := (builtin_inff).to_double
								a_result.item.e10 := 0
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("overflow"), ce_string ("exp.c"), 207, 16)
									Result := 16
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
								if not js.return_called then
									js.break
								end
							end
							js.reset
						elseif l_l10_val < (-2147483647).to_double then
							from
							until
								js.loop_left
							loop
								js.reset
								a_result.item.val := 0.0
								a_result.item.err := 2.2250738585072014e-308
								a_result.item.e10 := 0
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("underflow"), ce_string ("exp.c"), 210, 15)
									Result := 15
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
								if not js.return_called then
									js.break
								end
							end
							js.reset
						else
							if a_y >= 0.0 then
								l_tmp___6 := 1
							else
								l_tmp___6 := -1
							end
							l_sy := l_tmp___6.to_double
							l_N := (floor (l_l10_val)).truncated_to_integer
							l_arg_val := (l_l10_val - l_N.to_double) * 2.30258509299404568402
							l_tmp___8 := fabs (a_x)
							l_tmp___9 := fabs (l_ly)
							l_arg_err := (2.0 * 2.2204460492503131e-16) * ((l_tmp___8 + l_tmp___9) + 2.30258509299404568402 * (fabs (l_N.to_double)))
							a_result.item.val := l_sy * (exp (l_arg_val))
							a_result.item.err := l_arg_err * (fabs (a_result.item.val))
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							a_result.item.e10 := l_N
							Result := 0
							js.return
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_exp_mult_err_e (a_x: REAL_64; a_dx: REAL_64; a_y: REAL_64; a_dy: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ay: REAL_64
			l_ex: REAL_64
			l_tmp___2: REAL_64
			l_ly: REAL_64
			l_lnr: REAL_64
			l_sy: REAL_64
			l_tmp___8: INTEGER_32
			l_M: REAL_64
			l_N: REAL_64
			l_a___5: REAL_64
			l_b___0: REAL_64
			l_eMN: REAL_64
			l_eab: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ay := (fabs (a_y))
					if a_y /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_result.item.val := 0.0
						a_result.item.err := fabs (a_dy * (exp (a_x)))
						Result := 0
						js.return
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_x < 0.5 * 7.0978271289338397e+02) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_x > 0.5 * -7.0839641853226408e+02 then
							if l_ay < 0.8 * 1.3407807929942596e+154 then
								if l_ay > 1.2 * 1.4916681462400413e-154 then
									l_ex := (exp (a_x))
									a_result.item.val := a_y * l_ex
									l_tmp___2 := fabs (a_dy)
									a_result.item.err := l_ex * (l_tmp___2 + (fabs (a_y * a_dx)))
									a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
									Result := 0
									js.return
								else
									l_pos := -1 + 6 -- goto _L___0
								end
							else
								l_pos := -1 + 6 -- goto _L___0
							end
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L___0:
						l_ly := (log (l_ay))
						l_lnr := a_x + l_ly
						if l_lnr > 7.0978271289338397e+02 - 0.01 then
							from
							until
								js.loop_left
							loop
								js.reset
								a_result.item.val := (builtin_inff).to_double
								a_result.item.err := (builtin_inff).to_double
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("overflow"), ce_string ("exp.c"), 254, 16)
									Result := 16
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
								if not js.return_called then
									js.break
								end
							end
							js.reset
						elseif l_lnr < -7.0839641853226408e+02 + 0.01 then
							from
							until
								js.loop_left
							loop
								js.reset
								a_result.item.val := 0.0
								a_result.item.err := 2.2250738585072014e-308
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("underflow"), ce_string ("exp.c"), 257, 15)
									Result := 15
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
								if not js.return_called then
									js.break
								end
							end
							js.reset
						else
							if a_y >= 0.0 then
								l_tmp___8 := 1
							else
								l_tmp___8 := -1
							end
							l_sy := l_tmp___8.to_double
							l_M := (floor (a_x))
							l_N := (floor (l_ly))
							l_a___5 := a_x - l_M
							l_b___0 := l_ly - l_N
							l_eMN := (exp (l_M + l_N))
							l_eab := (exp (l_a___5 + l_b___0))
							a_result.item.val := (l_sy * l_eMN) * l_eab
							a_result.item.err := ((l_eMN * l_eab) * 2.0) * 2.2204460492503131e-16
							a_result.item.err := a_result.item.err + ((l_eMN * l_eab) * (fabs (a_dy / a_y)))
							a_result.item.err := a_result.item.err + ((l_eMN * l_eab) * (fabs (a_dx)))
							Result := 0
							js.return
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_exp_mult_err_e10_e (a_x: REAL_64; a_dx: REAL_64; a_y: REAL_64; a_dy: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_E10_STRUCT]): INTEGER_32
		local
			l_ay: REAL_64
			l_ex: REAL_64
			l_tmp___2: REAL_64
			l_ly: REAL_64
			l_l10_val: REAL_64
			l_sy: REAL_64
			l_tmp___8: INTEGER_32
			l_N: INTEGER_32
			l_arg_val: REAL_64
			l_arg_err: REAL_64
			l_tmp___10: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ay := (fabs (a_y))
					if a_y /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_result.item.val := 0.0
						a_result.item.err := fabs (a_dy * (exp (a_x)))
						a_result.item.e10 := 0
						Result := 0
						js.return
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_x < 0.5 * 7.0978271289338397e+02) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_x > 0.5 * -7.0839641853226408e+02 then
							if l_ay < 0.8 * 1.3407807929942596e+154 then
								if l_ay > 1.2 * 1.4916681462400413e-154 then
									l_ex := (exp (a_x))
									a_result.item.val := a_y * l_ex
									l_tmp___2 := fabs (a_dy)
									a_result.item.err := l_ex * (l_tmp___2 + (fabs (a_y * a_dx)))
									a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
									a_result.item.e10 := 0
									Result := 0
									js.return
								else
									l_pos := -1 + 6 -- goto _L___0
								end
							else
								l_pos := -1 + 6 -- goto _L___0
							end
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L___0:
						l_ly := (log (l_ay))
						l_l10_val := (a_x + l_ly) / 2.30258509299404568402
						if l_l10_val > (2147483646).to_double then
							from
							until
								js.loop_left
							loop
								js.reset
								a_result.item.val := (builtin_inff).to_double
								a_result.item.err := (builtin_inff).to_double
								a_result.item.e10 := 0
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("overflow"), ce_string ("exp.c"), 304, 16)
									Result := 16
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
								if not js.return_called then
									js.break
								end
							end
							js.reset
						elseif l_l10_val < (-2147483647).to_double then
							from
							until
								js.loop_left
							loop
								js.reset
								a_result.item.val := 0.0
								a_result.item.err := 2.2250738585072014e-308
								a_result.item.e10 := 0
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("underflow"), ce_string ("exp.c"), 307, 15)
									Result := 15
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
								if not js.return_called then
									js.break
								end
							end
							js.reset
						else
							if a_y >= 0.0 then
								l_tmp___8 := 1
							else
								l_tmp___8 := -1
							end
							l_sy := l_tmp___8.to_double
							l_N := (floor (l_l10_val)).truncated_to_integer
							l_arg_val := (l_l10_val - l_N.to_double) * 2.30258509299404568402
							l_tmp___10 := fabs (a_y)
							l_arg_err := (a_dy / l_tmp___10 + a_dx) + (2.0 * 2.2204460492503131e-16) * (fabs (l_arg_val))
							a_result.item.val := l_sy * (exp (l_arg_val))
							a_result.item.err := l_arg_err * (fabs (a_result.item.val))
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							a_result.item.e10 := l_N
							Result := 0
							js.return
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_expm1_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_cut: REAL_64
			js: JUMP_STATE
		do
			l_cut := 0.002
			if a_x < -7.0839641853226408e+02 then
				a_result.item.val := -1.0
				a_result.item.err := 2.2204460492503131e-16
				Result := 0
				js.return
			elseif a_x < -l_cut then
				a_result.item.val := (exp (a_x)) - 1.0
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			elseif a_x < l_cut then
				a_result.item.val := a_x * (1.0 + (0.5 * a_x) * (1.0 + (a_x / 3.0) * (1.0 + (0.25 * a_x) * (1.0 + 0.2 * a_x))))
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			elseif a_x < 7.0978271289338397e+02 then
				a_result.item.val := (exp (a_x)) - 1.0
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_inff).to_double
					a_result.item.err := (builtin_inff).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("overflow"), ce_string ("exp.c"), 351, 16)
						Result := 16
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_exprel_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_cut: REAL_64
			js: JUMP_STATE
		do
			l_cut := 0.002
			if a_x < -7.0839641853226408e+02 then
				a_result.item.val := -1.0 / a_x
				a_result.item.err := 2.2204460492503131e-16 * (fabs (a_result.item.val))
				Result := 0
				js.return
			elseif a_x < -l_cut then
				a_result.item.val := ((exp (a_x)) - 1.0) / a_x
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			elseif a_x < l_cut then
				a_result.item.val := 1.0 + (0.5 * a_x) * (1.0 + (a_x / 3.0) * (1.0 + (0.25 * a_x) * (1.0 + 0.2 * a_x)))
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			elseif a_x < 7.0978271289338397e+02 then
				a_result.item.val := ((exp (a_x)) - 1.0) / a_x
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_inff).to_double
					a_result.item.err := (builtin_inff).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("overflow"), ce_string ("exp.c"), 381, 16)
						Result := 16
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_exprel_2_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_cut: REAL_64
			js: JUMP_STATE
		do
			l_cut := 0.002
			if a_x < -7.0839641853226408e+02 then
				a_result.item.val := (-2.0 / a_x) * (1.0 + 1.0 / a_x)
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			elseif a_x < -l_cut then
				a_result.item.val := (2.0 * (((exp (a_x)) - 1.0) - a_x)) / (a_x * a_x)
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			elseif a_x < l_cut then
				a_result.item.val := 1.0 + ((1.0 / 3.0) * a_x) * (1.0 + (0.25 * a_x) * (1.0 + (0.2 * a_x) * (1.0 + (1.0 / 6.0) * a_x)))
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			elseif a_x < 7.0978271289338397e+02 then
				a_result.item.val := (2.0 * (((exp (a_x)) - 1.0) - a_x)) / (a_x * a_x)
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_inff).to_double
					a_result.item.err := (builtin_inff).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("overflow"), ce_string ("exp.c"), 411, 16)
						Result := 16
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_exprel_n_CF_e (a_N: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		do
			Result := (exprel_n_CF (a_N, a_x, a_result))
		end

	gsl_sf_exprel_n_e (a_N: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_lnf_N: PD_GSL_SF_RESULT_STRUCT
			l_lnr_val: REAL_64
			l_lnr_err: REAL_64
			l_lnterm: REAL_64
			l_tmp___5: REAL_64
			l_tmp___6: REAL_64
			l_ln_x: REAL_64
			l_lnf_N___0: PD_GSL_SF_RESULT_STRUCT
			l_lg_N: REAL_64
			l_lnpre_val: REAL_64
			l_lnpre_err: REAL_64
			l_tmp___11: REAL_64
			l_tmp___12: REAL_64
			l_stat_eG: INTEGER_32
			l_bigG_ratio: PD_GSL_SF_RESULT_STRUCT
			l_pre: PD_GSL_SF_RESULT_STRUCT
			l_stat_ex: INTEGER_32
			l_ln_bigG_ratio_pre: REAL_64
			l_bigGsum: REAL_64
			l_term: REAL_64
			l_k: INTEGER_32
			l_sum: REAL_64
			l_term___0: REAL_64
			l_k___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_lnf_N.make
			create l_lnf_N___0.make
			create l_bigG_ratio.make
			create l_pre.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_N < 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("exp.c"), 426, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 3 then -- else:
						if a_x /= 0.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						a_result.item.val := 1.0
						a_result.item.err := 0.0
						Result := 0
						js.return
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 6 then -- else:
						if not ((fabs (a_x)) < 6.0554544523933429e-06 * a_N.to_double) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						a_result.item.val := 1.0 + (a_x / (a_N + 1).to_double) * (1.0 + a_x / (a_N + 2).to_double)
						a_result.item.err := 2.0 * 2.2204460492503131e-16
						Result := 0
						js.return
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 9 then -- else:
						if a_N /= 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						Result := (gsl_sf_exp_e (a_x, a_result))
						js.return
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 12 then -- else:
						if a_N /= 1 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						Result := (gsl_sf_exprel_e (a_x, a_result))
						js.return
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 15 then -- else:
						if a_N /= 2 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						Result := (gsl_sf_exprel_2_e (a_x, a_result))
						js.return
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 18 then -- else:
						if not (a_x > a_N.to_double) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if -a_x + a_N.to_double * (1.0 + (log (a_x / a_N.to_double))) < -3.6043653389117154e+01 then
							gamma_inst.gsl_sf_lnfact_e (a_N.to_natural_32, l_lnf_N.address).do_nothing
							l_lnterm := a_N.to_double * (log (a_x))
							l_lnr_val := (a_x + l_lnf_N.val) - l_lnterm
							l_tmp___5 := fabs (a_x)
							l_tmp___6 := fabs (l_lnf_N.val)
							l_lnr_err := 2.2204460492503131e-16 * ((l_tmp___5 + l_tmp___6) + (fabs (l_lnterm)))
							l_lnr_err := l_lnr_err + (l_lnf_N.err)
							Result := (gsl_sf_exp_err_e (l_lnr_val, l_lnr_err, a_result))
							js.return
						else
							l_pos := -1 + 21 -- goto _L
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else: | _L:
						if a_x > a_N.to_double then
							l_ln_x := (log (a_x))
							gamma_inst.gsl_sf_lnfact_e (a_N.to_natural_32, l_lnf_N___0.address).do_nothing
							l_lg_N := l_lnf_N___0.val - (log (a_N.to_double))
							l_lnpre_val := (a_x + l_lnf_N___0.val) - a_N.to_double * l_ln_x
							l_tmp___11 := fabs (a_x)
							l_tmp___12 := fabs (l_lnf_N___0.val)
							l_lnpre_err := 2.2204460492503131e-16 * ((l_tmp___11 + l_tmp___12) + (fabs (a_N.to_double * l_ln_x)))
							l_lnpre_err := l_lnpre_err + (l_lnf_N___0.err)
							if l_lnpre_val < 7.0978271289338397e+02 - 5.0 then
								l_stat_ex := (gsl_sf_exp_err_e (l_lnpre_val, l_lnpre_err, l_pre.address))
								l_ln_bigG_ratio_pre := (-a_x + (a_N - 1).to_double * l_ln_x) - l_lg_N
								l_bigGsum := 1.0
								l_term := 1.0
								l_k := 1
								from
								until
									not (l_k < a_N)
								loop
									l_term := l_term * ((a_N - l_k).to_double / a_x)
									l_bigGsum := l_bigGsum + l_term
									l_k := l_k + 1
								end
								l_stat_eG := gsl_sf_exp_mult_e (l_ln_bigG_ratio_pre, l_bigGsum, l_bigG_ratio.address)
								if l_stat_eG = 0 then
									a_result.item.val := l_pre.val * (1.0 - l_bigG_ratio.val)
									a_result.item.err := l_pre.val * (2.0 * 2.2204460492503131e-16 + l_bigG_ratio.err)
									a_result.item.err := a_result.item.err + (l_pre.err * (fabs (1.0 - l_bigG_ratio.val)))
									a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
									Result := l_stat_ex
									js.return
								else
									a_result.item.val := 0.0
									a_result.item.err := 0.0
									Result := l_stat_eG
									js.return
								end
							else
								from
								until
									js.loop_left
								loop
									js.reset
									a_result.item.val := (builtin_inff).to_double
									a_result.item.err := (builtin_inff).to_double
									from
									until
										js.loop_left
									loop
										js.reset
										error_inst.gsl_error (ce_string ("overflow"), ce_string ("exp.c"), 508, 16)
										Result := 16
										js.return
										if not js.return_called then
											js.break
										end
									end
									js.reset
									if not js.return_called then
										js.break
									end
								end
								js.reset
							end
						elseif a_x > -10.0 * a_N.to_double then
							Result := (exprel_n_CF (a_N.to_double, a_x, a_result))
							js.return
						else
							l_sum := 1.0
							l_term___0 := 1.0
							l_k___0 := 1
							from
							until
								not (l_k___0 < a_N)
							loop
								l_term___0 := l_term___0 * ((a_N - l_k___0).to_double / a_x)
								l_sum := l_sum + l_term___0
								l_k___0 := l_k___0 + 1
							end
							a_result.item.val := ((-a_N).to_double / a_x) * l_sum
							a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
							Result := 0
							js.return
						end
				when 22 then -- if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 23 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_exp_err_e (a_x: REAL_64; a_dx: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_adx: REAL_64
			l_ex: REAL_64
			l_edx: REAL_64
			js: JUMP_STATE
		do
			l_adx := (fabs (a_dx))
			if a_x + l_adx > 7.0978271289338397e+02 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_inff).to_double
					a_result.item.err := (builtin_inff).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("overflow"), ce_string ("exp.c"), 542, 16)
						Result := 16
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_x - l_adx < -7.0839641853226408e+02 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := 0.0
					a_result.item.err := 2.2250738585072014e-308
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("exp.c"), 545, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_ex := (exp (a_x))
				l_edx := (exp (l_adx))
				a_result.item.val := l_ex
				a_result.item.err := l_ex * (gsl_gsl_minmax_inst.GSL_MAX_DBL (2.2204460492503131e-16, l_edx - 1.0 / l_edx))
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_exp_err_e10_e (a_x: REAL_64; a_dx: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_E10_STRUCT]): INTEGER_32
		local
			l_adx: REAL_64
			l_N: INTEGER_32
			l_ex: REAL_64
			js: JUMP_STATE
		do
			l_adx := (fabs (a_dx))
			if a_x + l_adx > (2147483646).to_double then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_inff).to_double
					a_result.item.err := (builtin_inff).to_double
					a_result.item.e10 := 0
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("overflow"), ce_string ("exp.c"), 566, 16)
						Result := 16
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_x - l_adx < (-2147483647).to_double then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := 0.0
					a_result.item.err := 2.2250738585072014e-308
					a_result.item.e10 := 0
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("exp.c"), 569, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_N := (floor (a_x / 2.30258509299404568402)).truncated_to_integer
				l_ex := (exp (a_x - l_N.to_double * 2.30258509299404568402))
				a_result.item.val := l_ex
				a_result.item.err := l_ex * ((2.0 * 2.2204460492503131e-16) * ((fabs (a_x)) + 1.0) + l_adx)
				a_result.item.e10 := l_N
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_exp (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_exp_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_exp_e(x, &result)"), ce_string ("exp.c"), 588, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_exp_mult (a_x: REAL_64; a_y: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_exp_mult_e (a_x, a_y, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_exp_mult_e(x, y, &result)"), ce_string ("exp.c"), 593, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_expm1 (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_expm1_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_expm1_e(x, &result)"), ce_string ("exp.c"), 598, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_exprel (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_exprel_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_exprel_e(x, &result)"), ce_string ("exp.c"), 603, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_exprel_2 (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_exprel_2_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_exprel_2_e(x, &result)"), ce_string ("exp.c"), 608, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_exprel_n (a_n: INTEGER_32; a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_exprel_n_e (a_n, a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_exprel_n_e(n, x, &result)"), ce_string ("exp.c"), 613, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
