class
	P_EXPINT3

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create expint3_data.make (<<24>>)
			create expint3_cs.make
			create expint3a_data.make (<<23>>)
			create expint3a_cs.make
		end

feature {ANY} -- attributes

	expint3_data: CE_ARRAY [REAL_64]

	expint3_cs: PD_CHEB_SERIES_STRUCT

	expint3a_data: CE_ARRAY [REAL_64]

	expint3a_cs: PD_CHEB_SERIES_STRUCT

feature {ANY} -- routines

	gsl_sf_expint_3_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_val_infinity: REAL_64
			l_t: REAL_64
			l_result_c: PD_GSL_SF_RESULT_STRUCT
			l_t___0: REAL_64
			l_s: REAL_64
			l_result_c___0: PD_GSL_SF_RESULT_STRUCT
			js: JUMP_STATE
		do
			create l_result_c.make
			create l_result_c___0.make

			l_val_infinity := 0.892979511569249211
			if a_x < 0.0 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("expint3.c"), 107, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_x < 1.6 * 6.0554544523933429e-06 then
				a_result.item.val := a_x
				a_result.item.err := 0.0
				Result := 0
				js.return
			elseif a_x <= 2.0 then
				l_t := ((a_x * a_x) * a_x) / 4.0 - 1.0
				cheb_eval_inst.cheb_eval_e ((expint3_cs.address), l_t, l_result_c.address).do_nothing
				a_result.item.val := a_x * l_result_c.val
				a_result.item.err := a_x * l_result_c.err
				Result := 0
				js.return
			elseif a_x < (pow (-(-3.6043653389117154e+01), 1.0 / 3.0)) then
				l_t___0 := 16.0 / ((a_x * a_x) * a_x) - 1.0
				l_s := (exp ((-a_x * a_x) * a_x)) / ((3.0 * a_x) * a_x)
				cheb_eval_inst.cheb_eval_e ((expint3a_cs.address), l_t___0, l_result_c___0.address).do_nothing
				a_result.item.val := l_val_infinity - l_result_c___0.val * l_s
				a_result.item.err := l_val_infinity * 2.2204460492503131e-16 + l_s * l_result_c___0.err
				Result := 0
				js.return
			else
				a_result.item.val := l_val_infinity
				a_result.item.err := l_val_infinity * 2.2204460492503131e-16
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_expint_3 (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_expint_3_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_expint_3_e(x, &result)"), ce_string ("expint3.c"), 145, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
