class
	P_EXPM1

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_expm1 (a_x: REAL_64): REAL_64
		local
			l_i: REAL_64
			l_sum: REAL_64
			l_term: REAL_64
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			if (fabs (a_x)) < 0.69314718055994530942 then
				l_i := 1.0
				l_sum := a_x
				l_term := a_x / 1.0
				from
				until
					js.loop_left
				loop
					js.reset
					l_i := l_i + (1).to_double
					l_term := l_term * (a_x / l_i)
					l_sum := l_sum + l_term
					l_tmp := fabs (l_term)
					if not (l_tmp > (fabs (l_sum)) * 2.2204460492503131e-16) then
						js.break
					end
				end
				js.reset
				Result := l_sum
			else
				Result := ((exp (a_x)) - (1).to_double)
			end
		end

end
