class
	P_EXPPOW

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_ran_exppow (a_r___3: CE_POINTER [PD_GSL_RNG]; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_v: REAL_64
			l_z: REAL_64
			l_x: REAL_64
			l_h: REAL_64
			l_u___0: REAL_64
			l_B: REAL_64
			l_tmp___5: REAL_64
			l_x___0: REAL_64
			l_h___0: REAL_64
			l_u___1: REAL_64
			l_B___0: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_b___0 < (1).to_double) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_b___0 > (4).to_double) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_u := (gsl_gsl_rng_inst.gsl_rng_uniform (a_r___3))
						l_v := (gamma_inst.gsl_ran_gamma (a_r___3, (1).to_double / a_b___0, 1.0))
						l_z := a_a___5 * (pow (l_v, (1).to_double / a_b___0))
						if l_u > 0.5 then
							Result := l_z
						else
							Result := (-l_z)
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if a_b___0 = (1).to_double then
							Result := (laplace_inst.gsl_ran_laplace (a_r___3, a_a___5))
						elseif a_b___0 < (2).to_double then
							l_B := (pow ((1).to_double / a_b___0, (1).to_double / a_b___0))
							from
							until
								js.loop_left
							loop
								js.reset
								l_x := laplace_inst.gsl_ran_laplace (a_r___3, l_B)
								l_u___0 := gsl_gsl_rng_inst.gsl_rng_uniform_pos (a_r___3)
								l_tmp___5 := pow ((fabs (l_x)), a_b___0)
								l_h := ((-l_tmp___5 + (fabs (l_x)) / l_B) - (1).to_double) + (1).to_double / a_b___0
								if not ((log (l_u___0)) > l_h) then
									js.break
								end
							end
							js.reset
							Result := (a_a___5 * l_x)
						elseif a_b___0 = (2).to_double then
							Result := (gauss_inst.gsl_ran_gaussian (a_r___3, a_a___5 / (sqrt (2.0))))
						else
							l_B___0 := (pow ((1).to_double / a_b___0, (1).to_double / a_b___0))
							from
							until
								js.loop_left
							loop
								js.reset
								l_x___0 := gauss_inst.gsl_ran_gaussian (a_r___3, l_B___0)
								l_u___1 := gsl_gsl_rng_inst.gsl_rng_uniform_pos (a_r___3)
								l_h___0 := ((-(pow ((fabs (l_x___0)), a_b___0)) + (l_x___0 * l_x___0) / (((2).to_double * l_B___0) * l_B___0)) + (1).to_double / a_b___0) - 0.5
								if not ((log (l_u___1)) > l_h___0) then
									js.break
								end
							end
							js.reset
							Result := (a_a___5 * l_x___0)
						end
				when 7 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_ran_exppow_pdf (a_x: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_p: REAL_64
			l_lngamma: REAL_64
		do
			l_lngamma := (gamma_inst.gsl_sf_lngamma ((1).to_double + (1).to_double / a_b___0))
			l_p := ((1).to_double / ((2).to_double * a_a___5)) * (exp (-(pow ((fabs (a_x / a_a___5)), a_b___0)) - l_lngamma))
			Result := l_p
		end

	gsl_cdf_exppow_P (a_x: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_P___2: REAL_64
			l_P___3: REAL_64
		do
			l_u := a_x / a_a___5
			if l_u < (0).to_double then
				l_P___2 := 0.5 * (gamma_inc_inst.gsl_sf_gamma_inc_Q (1.0 / a_b___0, (pow (-l_u, a_b___0))))
				Result := l_P___2
			else
				l_P___3 := 0.5 * (1.0 + (gamma_inc_inst.gsl_sf_gamma_inc_P (1.0 / a_b___0, (pow (l_u, a_b___0)))))
				Result := l_P___3
			end
		end

	gsl_cdf_exppow_Q (a_x: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_Q___1: REAL_64
			l_Q___2: REAL_64
		do
			l_u := a_x / a_a___5
			if l_u < (0).to_double then
				l_Q___1 := 0.5 * (1.0 + (gamma_inc_inst.gsl_sf_gamma_inc_P (1.0 / a_b___0, (pow (-l_u, a_b___0)))))
				Result := l_Q___1
			else
				l_Q___2 := 0.5 * (gamma_inc_inst.gsl_sf_gamma_inc_Q (1.0 / a_b___0, (pow (l_u, a_b___0))))
				Result := l_Q___2
			end
		end

end
