class
	P_FALSEPOS

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create falsepos_type.make
			create gsl_root_fsolver_falsepos.make
		end

feature {ANY} -- attributes

	falsepos_type: PD_GSL_ROOT_FSOLVER_TYPE

	gsl_root_fsolver_falsepos: CE_POINTER [PD_GSL_ROOT_FSOLVER_TYPE]

feature {ANY} -- routines

	falsepos_init (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_root: CE_POINTER [REAL_64]; a_x_lower: REAL_64; a_x_upper: REAL_64): INTEGER_32
		local
			l_state: CE_POINTER [PD_FALSEPOS_STATE_T]
			l_f_lower: REAL_64
			l_f_upper: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_state.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state.ce_gets (create {CE_POINTER [PD_FALSEPOS_STATE_T]}.make_cast (a_vstate))
					a_root.item := 0.5 * (a_x_lower + a_x_upper)
					from
					until
						js.loop_left
					loop
						js.reset
						l_f_lower := (a_f.item.function).real_64_item ([a_x_lower, a_f.item.params])
						if not (infnan_inst.gsl_finite (l_f_lower)).to_boolean then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("function value is not finite"), ce_string ("falsepos.c"), 66, 9)
								Result := 9
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						from
						until
							js.loop_left
						loop
							js.reset
							l_f_upper := (a_f.item.function).real_64_item ([a_x_upper, a_f.item.params])
							if not (infnan_inst.gsl_finite (l_f_upper)).to_boolean then
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("function value is not finite"), ce_string ("falsepos.c"), 67, 9)
									Result := 9
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
							end
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						l_state.item.f_lower := l_f_lower
						l_state.item.f_upper := l_f_upper
						if not (l_f_lower < 0.0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_f_upper < 0.0 then
							l_pos := -1 + 6 -- goto _L
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 4 then -- else: | _L___0:
						if not (l_f_lower > 0.0) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if not (l_f_upper > 0.0) then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("endpoints do not straddle y=0"), ce_string ("falsepos.c"), 74, 4)
							Result := 4
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 7 then -- if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	falsepos_init_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent falsepos_init)
		end

	falsepos_iterate (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_root: CE_POINTER [REAL_64]; a_x_lower: CE_POINTER [REAL_64]; a_x_upper: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_state: CE_POINTER [PD_FALSEPOS_STATE_T]
			l_x_linear: REAL_64
			l_f_linear: REAL_64
			l_x_bisect: REAL_64
			l_f_bisect: REAL_64
			l_x_left: REAL_64
			l_x_right: REAL_64
			l_f_lower: REAL_64
			l_f_upper: REAL_64
			l_w: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_state.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state.ce_gets (create {CE_POINTER [PD_FALSEPOS_STATE_T]}.make_cast (a_vstate))
					l_x_left := a_x_lower.item
					l_x_right := a_x_upper.item
					l_f_lower := l_state.item.f_lower
					l_f_upper := l_state.item.f_upper
					if l_f_lower = 0.0 then
						a_root.item := l_x_left
						a_x_upper.item := l_x_left
						Result := 0
						js.return
					end
					if not js.return_called and then (l_f_upper = 0.0) then
						a_root.item := l_x_right
						a_x_lower.item := l_x_right
						Result := 0
						js.return
					end
					if not js.return_called then
						l_x_linear := l_x_right - (l_f_upper * (l_x_left - l_x_right)) / (l_f_lower - l_f_upper)
						from
						until
							js.loop_left
						loop
							js.reset
							l_f_linear := (a_f.item.function).real_64_item ([l_x_linear, a_f.item.params])
							if not (infnan_inst.gsl_finite (l_f_linear)).to_boolean then
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("function value is not finite"), ce_string ("falsepos.c"), 117, 9)
									Result := 9
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
							end
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called and then (l_f_linear = 0.0) then
						a_root.item := l_x_linear
						a_x_lower.item := l_x_linear
						a_x_upper.item := l_x_linear
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (l_f_lower > 0.0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_f_linear < 0.0 then
							a_root.item := l_x_linear
							a_x_upper.item := l_x_linear
							l_state.item.f_upper := l_f_linear
							l_w := l_x_linear - l_x_left
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_f_lower < 0.0 then
							if l_f_linear > 0.0 then
								a_root.item := l_x_linear
								a_x_upper.item := l_x_linear
								l_state.item.f_upper := l_f_linear
								l_w := l_x_linear - l_x_left
							else
								a_root.item := l_x_linear
								a_x_lower.item := l_x_linear
								l_state.item.f_lower := l_f_linear
								l_w := l_x_right - l_x_linear
							end
						else
							a_root.item := l_x_linear
							a_x_lower.item := l_x_linear
							l_state.item.f_lower := l_f_linear
							l_w := l_x_right - l_x_linear
						end
				when 5 then
						if l_w < 0.5 * (l_x_right - l_x_left) then
							Result := 0
							js.return
						end
				when 6 then -- if done
					if not js.return_called then
						l_x_bisect := 0.5 * (l_x_left + l_x_right)
						from
						until
							js.loop_left
						loop
							js.reset
							l_f_bisect := (a_f.item.function).real_64_item ([l_x_bisect, a_f.item.params])
							if not (infnan_inst.gsl_finite (l_f_bisect)).to_boolean then
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("function value is not finite"), ce_string ("falsepos.c"), 151, 9)
									Result := 9
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
							end
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 18 -- skip if block
					end
				when 7 then -- if:
						if not (l_f_lower > 0.0) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_f_bisect < 0.0 then
							l_pos := -1 + 12 -- goto _L___0
						else
							l_pos := -1 + 10 -- goto _L___2
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 10 then -- else: | _L___2:
						if not (l_f_lower < 0.0) then
							l_pos := -1 + 16 -- skip if block
						end
				when 11 then -- if:
						if not (l_f_bisect > 0.0) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if: | _L___0:
						a_x_upper.item := l_x_bisect
						l_state.item.f_upper := l_f_bisect
						if a_root.item > l_x_bisect then
							a_root.item := 0.5 * (l_x_left + l_x_bisect)
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						l_pos := -1 + 16 -- goto _L___1
				when 15 then -- if done | if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else: | _L___1:
						a_x_lower.item := l_x_bisect
						l_state.item.f_lower := l_f_bisect
						if a_root.item < l_x_bisect then
							a_root.item := 0.5 * (l_x_bisect + l_x_right)
						end
				when 17 then -- if done
						Result := 0
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	falsepos_iterate_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent falsepos_iterate)
		end

end
