class
	P_FERMI_DIRAC

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create fd_1_a_data.make (<<22>>)
			create fd_1_a_cs.make
			create fd_1_b_data.make (<<22>>)
			create fd_1_b_cs.make
			create fd_1_c_data.make (<<23>>)
			create fd_1_c_cs.make
			create fd_1_d_data.make (<<30>>)
			create fd_1_d_cs.make
			create fd_1_e_data.make (<<10>>)
			create fd_1_e_cs.make
			create fd_2_a_data.make (<<21>>)
			create fd_2_a_cs.make
			create fd_2_b_data.make (<<22>>)
			create fd_2_b_cs.make
			create fd_2_c_data.make (<<20>>)
			create fd_2_c_cs.make
			create fd_2_d_data.make (<<30>>)
			create fd_2_d_cs.make
			create fd_2_e_data.make (<<4>>)
			create fd_2_e_cs.make
			create fd_mhalf_a_data.make (<<20>>)
			create fd_mhalf_a_cs.make
			create fd_mhalf_b_data.make (<<20>>)
			create fd_mhalf_b_cs.make
			create fd_mhalf_c_data.make (<<25>>)
			create fd_mhalf_c_cs.make
			create fd_mhalf_d_data.make (<<30>>)
			create fd_mhalf_d_cs.make
			create fd_half_a_data.make (<<23>>)
			create fd_half_a_cs.make
			create fd_half_b_data.make (<<20>>)
			create fd_half_b_cs.make
			create fd_half_c_data.make (<<23>>)
			create fd_half_c_cs.make
			create fd_half_d_data.make (<<30>>)
			create fd_half_d_cs.make
			create fd_3half_a_data.make (<<20>>)
			create fd_3half_a_cs.make
			create fd_3half_b_data.make (<<22>>)
			create fd_3half_b_cs.make
			create fd_3half_c_data.make (<<21>>)
			create fd_3half_c_cs.make
			create fd_3half_d_data.make (<<25>>)
			create fd_3half_d_cs.make
		end

feature {ANY} -- attributes

	fd_1_a_data: CE_ARRAY [REAL_64]

	fd_1_a_cs: PD_CHEB_SERIES_STRUCT

	fd_1_b_data: CE_ARRAY [REAL_64]

	fd_1_b_cs: PD_CHEB_SERIES_STRUCT

	fd_1_c_data: CE_ARRAY [REAL_64]

	fd_1_c_cs: PD_CHEB_SERIES_STRUCT

	fd_1_d_data: CE_ARRAY [REAL_64]

	fd_1_d_cs: PD_CHEB_SERIES_STRUCT

	fd_1_e_data: CE_ARRAY [REAL_64]

	fd_1_e_cs: PD_CHEB_SERIES_STRUCT

	fd_2_a_data: CE_ARRAY [REAL_64]

	fd_2_a_cs: PD_CHEB_SERIES_STRUCT

	fd_2_b_data: CE_ARRAY [REAL_64]

	fd_2_b_cs: PD_CHEB_SERIES_STRUCT

	fd_2_c_data: CE_ARRAY [REAL_64]

	fd_2_c_cs: PD_CHEB_SERIES_STRUCT

	fd_2_d_data: CE_ARRAY [REAL_64]

	fd_2_d_cs: PD_CHEB_SERIES_STRUCT

	fd_2_e_data: CE_ARRAY [REAL_64]

	fd_2_e_cs: PD_CHEB_SERIES_STRUCT

	fd_mhalf_a_data: CE_ARRAY [REAL_64]

	fd_mhalf_a_cs: PD_CHEB_SERIES_STRUCT

	fd_mhalf_b_data: CE_ARRAY [REAL_64]

	fd_mhalf_b_cs: PD_CHEB_SERIES_STRUCT

	fd_mhalf_c_data: CE_ARRAY [REAL_64]

	fd_mhalf_c_cs: PD_CHEB_SERIES_STRUCT

	fd_mhalf_d_data: CE_ARRAY [REAL_64]

	fd_mhalf_d_cs: PD_CHEB_SERIES_STRUCT

	fd_half_a_data: CE_ARRAY [REAL_64]

	fd_half_a_cs: PD_CHEB_SERIES_STRUCT

	fd_half_b_data: CE_ARRAY [REAL_64]

	fd_half_b_cs: PD_CHEB_SERIES_STRUCT

	fd_half_c_data: CE_ARRAY [REAL_64]

	fd_half_c_cs: PD_CHEB_SERIES_STRUCT

	fd_half_d_data: CE_ARRAY [REAL_64]

	fd_half_d_cs: PD_CHEB_SERIES_STRUCT

	fd_3half_a_data: CE_ARRAY [REAL_64]

	fd_3half_a_cs: PD_CHEB_SERIES_STRUCT

	fd_3half_b_data: CE_ARRAY [REAL_64]

	fd_3half_b_cs: PD_CHEB_SERIES_STRUCT

	fd_3half_c_data: CE_ARRAY [REAL_64]

	fd_3half_c_cs: PD_CHEB_SERIES_STRUCT

	fd_3half_d_data: CE_ARRAY [REAL_64]

	fd_3half_d_cs: PD_CHEB_SERIES_STRUCT

feature {ANY} -- routines

	fd_whiz (a_term: REAL_64; a_iterm: INTEGER_32; a_qnum: CE_POINTER [REAL_64]; a_qden: CE_POINTER [REAL_64]; a_result: CE_POINTER [REAL_64]; a_s: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_factor: REAL_64
			l_ratio: REAL_64
			l_j: INTEGER_32
			l_c___1: REAL_64
		do
			if a_iterm = 0 then
				a_s.item := 0.0
			end
			a_s.item := a_s.item + a_term
			a_qden[a_iterm] := 1.0 / ((a_term * (a_iterm.to_double + 1.0)) * (a_iterm.to_double + 1.0))
			a_qnum[a_iterm] := a_s.item * a_qden[a_iterm]
			if a_iterm > 0 then
				l_factor := 1.0
				l_ratio := a_iterm.to_double / (a_iterm.to_double + 1.0)
				l_j := a_iterm - 1
				from
				until
					not (l_j >= 0)
				loop
					l_c___1 := (l_factor * (l_j.to_double + 1.0)) / (a_iterm.to_double + 1.0)
					l_factor := l_factor * l_ratio
					a_qden[l_j] := a_qden[(l_j + 1)] - l_c___1 * a_qden[l_j]
					a_qnum[l_j] := a_qnum[(l_j + 1)] - l_c___1 * a_qnum[l_j]
					l_j := l_j - 1
				end
			end
			a_result.item := a_qnum[0] / a_qden[0]
			Result := 0
		end

	fd_nint (a_j: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_qcoeff: CE_ARRAY [REAL_64]
			l_a___5: REAL_64
			l_p: REAL_64
			l_f: REAL_64
			l_i: INTEGER_32
			l_k: INTEGER_32
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			create l_qcoeff.make (<<101>>)

			if a_j >= -1 then
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("error"), ce_string ("fermi_dirac.c"), 862, 7)
					Result := 7
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j < -101 then
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("error"), ce_string ("fermi_dirac.c"), 867, 24)
					Result := 24
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_n := -(a_j + 1)
				l_qcoeff[1] := 1.0
				l_k := 2
				from
				until
					not (not js.loop_left and then (l_k <= l_n))
				loop
					l_qcoeff[l_k] := -l_qcoeff[l_k - 1]
					l_i := l_k - 1
					from
					until
						not (l_i >= 2)
					loop
						l_qcoeff[l_i] := l_i.to_double * l_qcoeff[l_i] - (l_k - (l_i - 1)).to_double * l_qcoeff[l_i - 1]
						l_i := l_i - 1
					end
					l_k := l_k + 1
				end
				if a_x >= 0.0 then
					l_a___5 := exp (-a_x)
					l_f := l_qcoeff[1]
					l_i := 2
					from
					until
						not (l_i <= l_n)
					loop
						l_f := l_f * l_a___5 + l_qcoeff[l_i]
						l_i := l_i + 1
					end
				else
					l_a___5 := exp (a_x)
					l_f := l_qcoeff[l_n]
					l_i := l_n - 1
					from
					until
						not (l_i >= 1)
					loop
						l_f := l_f * l_a___5 + l_qcoeff[l_i]
						l_i := l_i - 1
					end
				end
				l_p := pow_int_inst.gsl_sf_pow_int (1.0 + l_a___5, a_j)
				a_result.item.val := (l_f * l_a___5) * l_p
				a_result.item.err := (3.0 * 2.2204460492503131e-16) * (fabs ((l_f * l_a___5) * l_p))
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	fd_neg (a_j: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_qnum: CE_ARRAY [REAL_64]
			l_qden: CE_ARRAY [REAL_64]
			l_ex: REAL_64
			l_term: REAL_64
			l_sum: REAL_64
			l_n: INTEGER_32
			l_rat: REAL_64
			l_p: REAL_64
			l_s: REAL_64
			l_xn: REAL_64
			l_ex___0: REAL_64
			l_enx: REAL_64
			l_f: REAL_64
			l_f_previous: REAL_64
			l_jterm: INTEGER_32
			l_p___0: REAL_64
			l_term___0: REAL_64
			l_tmp___5: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_qnum.make (<<101>>)
			create l_qden.make (<<101>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_x < -7.0839641853226408e+02) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_result.item.val := 0.0
						a_result.item.err := 0.0
						Result := 0
						js.return
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_x < -1.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_x < -(fabs (a_j + 1.0)) then
							l_ex := (exp (a_x))
							l_term := l_ex
							l_sum := l_term
							l_n := 2
							from
							until
								not (not js.loop_left and then (l_n < 100))
							loop
								js.reset
								l_rat := (l_n.to_double - 1.0) / l_n.to_double
								l_p := (pow (l_rat, a_j + 1.0))
								l_term := l_term * (-l_ex * l_p)
								l_sum := l_sum + l_term
								if (fabs (l_term / l_sum)) < 2.2204460492503131e-16 then
									js.break
								end
								if not js.loop_jumped then
									l_n := l_n + 1
								end
							end
							js.reset
							a_result.item.val := l_sum
							a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (l_sum))
							Result := 0
							js.return
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						l_s := 0.0
						l_xn := a_x
						l_ex___0 := -(exp (a_x))
						l_enx := -l_ex___0
						l_f := 0.0
						l_jterm := 0
						from
						until
							not (not js.loop_left and then (l_jterm <= 100))
						loop
							js.reset
							l_p___0 := (pow (l_jterm.to_double + 1.0, a_j + 1.0))
							l_term___0 := l_enx / l_p___0
							l_f_previous := l_f
							fd_whiz (l_term___0, l_jterm, l_qnum, l_qden, create {CE_POINTER [REAL_64]}.make_shared ($l_f), create {CE_POINTER [REAL_64]}.make_shared ($l_s)).do_nothing
							l_xn := l_xn + a_x
							l_tmp___5 := fabs (l_f - l_f_previous)
							if l_tmp___5 < ((fabs (l_f)) * 2.0) * 2.2204460492503131e-16 then
								js.break
							elseif l_xn < -7.0839641853226408e+02 then
								js.break
							end
							if not js.loop_jumped then
								l_enx := l_enx * l_ex___0
								l_jterm := l_jterm + 1
							end
						end
						js.reset
						a_result.item.val := l_f
						a_result.item.err := fabs (l_f - l_f_previous)
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (l_f)))
						if l_jterm = 100 then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("error"), ce_string ("fermi_dirac.c"), 968, 11)
								Result := 11
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						else
							Result := 0
							js.return
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	fd_asymp (a_j: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_j_integer: INTEGER_32
			l_itmax___0: INTEGER_32
			l_lg: PD_GSL_SF_RESULT_STRUCT
			l_stat_lg: INTEGER_32
			l_seqn_val: REAL_64
			l_seqn_err: REAL_64
			l_xm2: REAL_64
			l_xgam: REAL_64
			l_add: REAL_64
			l_cos_term: REAL_64
			l_ln_x: REAL_64
			l_ex_term_1: REAL_64
			l_ex_term_2: REAL_64
			l_fneg: PD_GSL_SF_RESULT_STRUCT
			l_ex_arg: PD_GSL_SF_RESULT_STRUCT
			l_ex: PD_GSL_SF_RESULT_STRUCT
			l_stat_fneg: INTEGER_32
			l_stat_e: INTEGER_32
			l_n: INTEGER_32
			l_add_previous: REAL_64
			l_eta: PD_GSL_SF_RESULT_STRUCT
			l_tmp___2: REAL_64
			l_tmp___7: REAL_64
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			js: JUMP_STATE
		do
			create l_lg.make
			create l_fneg.make
			create l_ex_arg.make
			create l_ex.make
			create l_eta.make

			l_j_integer := ((fabs (a_j - (floor (a_j + 0.5)))) < 100.0 * 2.2204460492503131e-16).to_integer
			l_itmax___0 := 200
			l_stat_lg := (gamma_inst.gsl_sf_lngamma_e (a_j + 2.0, l_lg.address))
			l_seqn_val := 0.5
			l_seqn_err := 0.0
			l_xm2 := (1.0 / a_x) / a_x
			l_xgam := 1.0
			l_add := 1.7976931348623157e+308
			l_n := 1
			from
			until
				not (not js.loop_left and then (l_n <= l_itmax___0))
			loop
				js.reset
				l_add_previous := l_add
				zeta_inst.gsl_sf_eta_int_e (2 * l_n, l_eta.address).do_nothing
				l_xgam := ((l_xgam * l_xm2) * ((a_j + 1.0) - (2 * l_n - 2).to_double)) * ((a_j + 1.0) - (2 * l_n - 1).to_double)
				l_add := l_eta.val * l_xgam
				if not l_j_integer.to_boolean then
					l_tmp___2 := fabs (l_add)
					if l_tmp___2 > (fabs (l_add_previous)) then
						js.break
					end
				end
				if not js.loop_jumped then
					if (fabs (l_add / l_seqn_val)) < 2.2204460492503131e-16 then
						js.break
					end
				end
				if not js.loop_jumped then
					l_seqn_val := l_seqn_val + l_add
					l_seqn_err := l_seqn_err + ((2.0 * 2.2204460492503131e-16) * (fabs (l_add)))
					l_n := l_n + 1
				end
			end
			js.reset
			l_seqn_err := l_seqn_err + (fabs (l_add))
			l_stat_fneg := fd_neg (a_j, -a_x, l_fneg.address)
			l_ln_x := log (a_x)
			l_ex_term_1 := (a_j + 1.0) * l_ln_x
			l_ex_term_2 := l_lg.val
			l_ex_arg.val := l_ex_term_1 - l_ex_term_2
			l_tmp___7 := fabs (l_ex_term_1)
			l_ex_arg.err := 2.2204460492503131e-16 * (l_tmp___7 + (fabs (l_ex_term_2))) + l_lg.err
			l_stat_e := exp_inst.gsl_sf_exp_err_e (l_ex_arg.val, l_ex_arg.err, l_ex.address)
			l_cos_term := cos (a_j * 3.14159265358979323846)
			a_result.item.val := l_cos_term * l_fneg.val + (2.0 * l_seqn_val) * l_ex.val
			a_result.item.err := fabs ((2.0 * l_ex.err) * l_seqn_val)
			a_result.item.err := a_result.item.err + (fabs ((2.0 * l_ex.val) * l_seqn_err))
			a_result.item.err := a_result.item.err + ((fabs (l_cos_term)) * l_fneg.err)
			a_result.item.err := a_result.item.err + ((4.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
			if l_stat_e /= 0 then
				l_tmp___14 := l_stat_e
			else
				if l_stat_fneg /= 0 then
					l_tmp___13 := l_stat_fneg
				else
					if l_stat_lg /= 0 then
						l_tmp___12 := l_stat_lg
					else
						l_tmp___12 := 0
					end
					l_tmp___13 := l_tmp___12
				end
				l_tmp___14 := l_tmp___13
			end
			Result := l_tmp___14
		end

	fd_series_int (a_j: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_n: INTEGER_32
			l_sum: REAL_64
			l_del: REAL_64
			l_pow_factor: REAL_64
			l_eta_factor: PD_GSL_SF_RESULT_STRUCT
			l_m___4: INTEGER_32
			l_jfact: PD_GSL_SF_RESULT_STRUCT
			l_sum2: REAL_64
			l_pre2: REAL_64
			js: JUMP_STATE
		do
			create l_eta_factor.make
			create l_jfact.make

			l_sum := 0.0
			l_pow_factor := 1.0
			zeta_inst.gsl_sf_eta_int_e (a_j + 1, l_eta_factor.address).do_nothing
			l_del := l_pow_factor * l_eta_factor.val
			l_sum := l_sum + l_del
			l_n := 1
			from
			until
				not (not js.loop_left and then (l_n <= a_j + 2))
			loop
				js.reset
				zeta_inst.gsl_sf_eta_int_e ((a_j + 1) - l_n, l_eta_factor.address).do_nothing
				l_pow_factor := l_pow_factor * (a_x / l_n.to_double)
				l_del := l_pow_factor * l_eta_factor.val
				l_sum := l_sum + l_del
				if (fabs (l_del / l_sum)) < 2.2204460492503131e-16 then
					js.break
				end
				if not js.loop_jumped then
					l_n := l_n + 1
				end
			end
			js.reset
			if a_j < 32 then
				gamma_inst.gsl_sf_fact_e (a_j.to_natural_32, l_jfact.address).do_nothing
				l_pre2 := (pow_int_inst.gsl_sf_pow_int (a_x, a_j)) / l_jfact.val
				zeta_inst.gsl_sf_eta_int_e (-3, l_eta_factor.address).do_nothing
				l_pow_factor := (((a_x * a_x) * a_x) * a_x) / ((((a_j + 4) * (a_j + 3)) * (a_j + 2)) * (a_j + 1)).to_double
				l_sum2 := l_eta_factor.val * l_pow_factor
				l_m___4 := 3
				from
				until
					not (l_m___4 < 24)
				loop
					zeta_inst.gsl_sf_eta_int_e (1 - 2 * l_m___4, l_eta_factor.address).do_nothing
					l_pow_factor := l_pow_factor * ((a_x * a_x) / ((a_j + 2 * l_m___4) * ((a_j + 2 * l_m___4) - 1)).to_double)
					l_sum2 := l_sum2 + (l_eta_factor.val * l_pow_factor)
					l_m___4 := l_m___4 + 1
				end
				l_sum := l_sum + (l_pre2 * l_sum2)
			end
			a_result.item.val := l_sum
			a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (l_sum))
			Result := 0
		end

	fd_UMseries_int (a_j: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_nmax: INTEGER_32
			l_pre: REAL_64
			l_lnpre_val: REAL_64
			l_lnpre_err: REAL_64
			l_sum_even_val: REAL_64
			l_sum_even_err: REAL_64
			l_sum_odd_val: REAL_64
			l_sum_odd_err: REAL_64
			l_stat_sum: INTEGER_32
			l_stat_e: INTEGER_32
			l_stat_h: INTEGER_32
			l_n: INTEGER_32
			l_p: REAL_64
			l_g: PD_GSL_SF_RESULT_STRUCT
			l_lnx: REAL_64
			l_lg: PD_GSL_SF_RESULT_STRUCT
			l_del_val: REAL_64
			l_del_err: REAL_64
			l_U: PD_GSL_SF_RESULT_STRUCT
			l_M: PD_GSL_SF_RESULT_STRUCT
			l_stat_h_U: INTEGER_32
			l_stat_h_F: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_del_val___0: REAL_64
			l_del_err___0: REAL_64
			l_U___0: PD_GSL_SF_RESULT_STRUCT
			l_M___0: PD_GSL_SF_RESULT_STRUCT
			l_stat_h_U___0: INTEGER_32
			l_stat_h_F___0: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_g.make
			create l_lg.make
			create l_U.make
			create l_M.make
			create l_U___0.make
			create l_M___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_nmax := 2000
					l_sum_even_val := 1.0
					l_sum_even_err := 0.0
					l_sum_odd_val := 0.0
					l_sum_odd_err := 0.0
					l_stat_h := 0
					if not (a_x < 500.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_j < 80 then
							l_p := (pow_int_inst.gsl_sf_pow_int (a_x, a_j + 1))
							gamma_inst.gsl_sf_fact_e ((a_j + 1).to_natural_32, l_g.address).do_nothing
							l_lnpre_val := 0.0
							l_lnpre_err := 0.0
							l_pre := l_p / l_g.val
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						l_lnx := (log (a_x))
						gamma_inst.gsl_sf_lngamma_e (a_j.to_double + 2.0, l_lg.address).do_nothing
						l_lnpre_val := (a_j.to_double + 1.0) * l_lnx - l_lg.val
						l_lnpre_err := (2.0 * 2.2204460492503131e-16) * (fabs ((a_j.to_double + 1.0) * l_lnx)) + l_lg.err
						l_pre := 1.0
				when 4 then
					l_n := 1
					from
					until
						not (not js.loop_left and then (l_n < l_nmax))
					loop
						js.reset
						l_stat_h_U := (hyperg_u_inst.gsl_sf_hyperg_U_int_e (1, a_j + 2, l_n.to_double * a_x, l_U.address))
						l_stat_h_F := (hyperg_1f1_inst.gsl_sf_hyperg_1F1_int_e (1, a_j + 2, (-l_n).to_double * a_x, l_M.address))
						if l_stat_h /= 0 then
							l_stat_h := l_stat_h
						else
							if l_stat_h_U /= 0 then
								l_tmp___5 := l_stat_h_U
							else
								if l_stat_h_F /= 0 then
									l_tmp___4 := l_stat_h_F
								else
									l_tmp___4 := 0
								end
								l_tmp___5 := l_tmp___4
							end
							l_stat_h := l_tmp___5
						end
						l_del_val := (a_j.to_double + 1.0) * l_U.val - l_M.val
						l_del_err := (fabs (a_j.to_double + 1.0)) * l_U.err + l_M.err
						l_sum_odd_val := l_sum_odd_val + l_del_val
						l_sum_odd_err := l_sum_odd_err + l_del_err
						if (fabs (l_del_val / l_sum_odd_val)) < 2.2204460492503131e-16 then
							js.break
						end
						if not js.loop_jumped then
							l_n := l_n + (2)
						end
					end
					js.reset
					l_n := 2
					from
					until
						not (not js.loop_left and then (l_n < l_nmax))
					loop
						js.reset
						l_stat_h_U___0 := (hyperg_u_inst.gsl_sf_hyperg_U_int_e (1, a_j + 2, l_n.to_double * a_x, l_U___0.address))
						l_stat_h_F___0 := (hyperg_1f1_inst.gsl_sf_hyperg_1F1_int_e (1, a_j + 2, (-l_n).to_double * a_x, l_M___0.address))
						if l_stat_h /= 0 then
							l_stat_h := l_stat_h
						else
							if l_stat_h_U___0 /= 0 then
								l_tmp___11 := l_stat_h_U___0
							else
								if l_stat_h_F___0 /= 0 then
									l_tmp___10 := l_stat_h_F___0
								else
									l_tmp___10 := 0
								end
								l_tmp___11 := l_tmp___10
							end
							l_stat_h := l_tmp___11
						end
						l_del_val___0 := (a_j.to_double + 1.0) * l_U___0.val - l_M___0.val
						l_del_err___0 := (fabs (a_j.to_double + 1.0)) * l_U___0.err + l_M___0.err
						l_sum_even_val := l_sum_even_val - l_del_val___0
						l_sum_even_err := l_sum_even_err + l_del_err___0
						if (fabs (l_del_val___0 / l_sum_even_val)) < 2.2204460492503131e-16 then
							js.break
						end
						if not js.loop_jumped then
							l_n := l_n + (2)
						end
					end
					js.reset
					if l_n >= l_nmax then
						l_stat_sum := 11
					else
						l_stat_sum := 0
					end
					l_stat_e := exp_inst.gsl_sf_exp_mult_err_e (l_lnpre_val, l_lnpre_err, l_pre * (l_sum_even_val + l_sum_odd_val), l_pre * (l_sum_even_err + l_sum_odd_err), a_result)
					a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
					if l_stat_e /= 0 then
						l_tmp___17 := l_stat_e
					else
						if l_stat_h /= 0 then
							l_tmp___16 := l_stat_h
						else
							if l_stat_sum /= 0 then
								l_tmp___15 := l_stat_sum
							else
								l_tmp___15 := 0
							end
							l_tmp___16 := l_tmp___15
						end
						l_tmp___17 := l_tmp___16
					end
					Result := l_tmp___17
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_sf_fermi_dirac_m1_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ex: REAL_64
			l_tmp___0: REAL_64
			l_ex___0: REAL_64
			js: JUMP_STATE
		do
			if a_x < -7.0839641853226408e+02 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := 0.0
					a_result.item.err := 2.2250738585072014e-308
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("fermi_dirac.c"), 1218, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_x < 0.0 then
				l_ex := (exp (a_x))
				a_result.item.val := l_ex / (1.0 + l_ex)
				l_tmp___0 := fabs (a_x)
				a_result.item.err := ((2.0 * (l_tmp___0 + 1.0)) * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			else
				l_ex___0 := (exp (-a_x))
				a_result.item.val := 1.0 / (1.0 + l_ex___0)
				a_result.item.err := ((2.0 * 2.2204460492503131e-16) * (a_x + 1.0)) * l_ex___0
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_fermi_dirac_0_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ex: REAL_64
			l_ser: REAL_64
			l_ex___0: REAL_64
			js: JUMP_STATE
		do
			if a_x < -7.0839641853226408e+02 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := 0.0
					a_result.item.err := 2.2250738585072014e-308
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("fermi_dirac.c"), 1239, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_x < -5.0 then
				l_ex := (exp (a_x))
				l_ser := 1.0 - l_ex * (0.5 - l_ex * (1.0 / 3.0 - l_ex * (1.0 / 4.0 - l_ex * (1.0 / 5.0 - l_ex / 6.0))))
				a_result.item.val := l_ex * l_ser
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			elseif a_x < 10.0 then
				a_result.item.val := log (1.0 + (exp (a_x)))
				a_result.item.err := fabs (a_x * 2.2204460492503131e-16)
				Result := 0
				js.return
			else
				l_ex___0 := (exp (-a_x))
				a_result.item.val := a_x + l_ex___0 * (((1.0 - 0.5 * l_ex___0) + (l_ex___0 * l_ex___0) / 3.0) - ((l_ex___0 * l_ex___0) * l_ex___0) / 4.0)
				a_result.item.err := (a_x + l_ex___0) * 2.2204460492503131e-16
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_fermi_dirac_1_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ex: REAL_64
			l_term: REAL_64
			l_sum: REAL_64
			l_n: INTEGER_32
			l_rat: REAL_64
			l_t: REAL_64
			l_t___0: REAL_64
			l_t___1: REAL_64
			l_c___1: PD_GSL_SF_RESULT_STRUCT
			l_t___2: REAL_64
			l_c___2: PD_GSL_SF_RESULT_STRUCT
			js: JUMP_STATE
		do
			create l_c___1.make
			create l_c___2.make

			if a_x < -7.0839641853226408e+02 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := 0.0
					a_result.item.err := 2.2250738585072014e-308
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("fermi_dirac.c"), 1265, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_x < -1.0 then
				l_ex := (exp (a_x))
				l_term := l_ex
				l_sum := l_term
				l_n := 2
				from
				until
					not (not js.loop_left and then (l_n < 100))
				loop
					js.reset
					l_rat := (l_n.to_double - 1.0) / l_n.to_double
					l_term := l_term * ((-l_ex * l_rat) * l_rat)
					l_sum := l_sum + l_term
					if (fabs (l_term / l_sum)) < 2.2204460492503131e-16 then
						js.break
					end
					if not js.loop_jumped then
						l_n := l_n + 1
					end
				end
				js.reset
				a_result.item.val := l_sum
				a_result.item.err := (2.0 * (fabs (l_sum))) * 2.2204460492503131e-16
				Result := 0
				js.return
			elseif a_x < 1.0 then
				Result := (cheb_eval_inst.cheb_eval_e ((fd_1_a_cs.address), a_x, a_result))
				js.return
			elseif a_x < 4.0 then
				l_t := (2.0 / 3.0) * (a_x - 1.0) - 1.0
				Result := (cheb_eval_inst.cheb_eval_e ((fd_1_b_cs.address), l_t, a_result))
				js.return
			elseif a_x < 10.0 then
				l_t___0 := (1.0 / 3.0) * (a_x - 4.0) - 1.0
				Result := (cheb_eval_inst.cheb_eval_e ((fd_1_c_cs.address), l_t___0, a_result))
				js.return
			elseif a_x < 30.0 then
				l_t___1 := 0.1 * a_x - 2.0
				cheb_eval_inst.cheb_eval_e ((fd_1_d_cs.address), l_t___1, l_c___1.address).do_nothing
				a_result.item.val := (l_c___1.val * a_x) * a_x
				a_result.item.err := (l_c___1.err * a_x) * a_x + 2.2204460492503131e-16 * (fabs (a_result.item.val))
				Result := 0
				js.return
			elseif a_x < 1.0 / 1.4901161193847656e-08 then
				l_t___2 := 60.0 / a_x - 1.0
				cheb_eval_inst.cheb_eval_e ((fd_1_e_cs.address), l_t___2, l_c___2.address).do_nothing
				a_result.item.val := (l_c___2.val * a_x) * a_x
				a_result.item.err := (l_c___2.err * a_x) * a_x + 2.2204460492503131e-16 * (fabs (a_result.item.val))
				Result := 0
				js.return
			elseif a_x < 1.3407807929942596e+154 then
				a_result.item.val := (0.5 * a_x) * a_x
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_inff).to_double
					a_result.item.err := (builtin_inff).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("overflow"), ce_string ("fermi_dirac.c"), 1317, 16)
						Result := 16
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_fermi_dirac_2_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ex: REAL_64
			l_term: REAL_64
			l_sum: REAL_64
			l_n: INTEGER_32
			l_rat: REAL_64
			l_t: REAL_64
			l_t___0: REAL_64
			l_t___1: REAL_64
			l_c___1: PD_GSL_SF_RESULT_STRUCT
			l_t___2: REAL_64
			l_c___2: PD_GSL_SF_RESULT_STRUCT
			js: JUMP_STATE
		do
			create l_c___1.make
			create l_c___2.make

			if a_x < -7.0839641853226408e+02 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := 0.0
					a_result.item.err := 2.2250738585072014e-308
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("fermi_dirac.c"), 1325, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_x < -1.0 then
				l_ex := (exp (a_x))
				l_term := l_ex
				l_sum := l_term
				l_n := 2
				from
				until
					not (not js.loop_left and then (l_n < 100))
				loop
					js.reset
					l_rat := (l_n.to_double - 1.0) / l_n.to_double
					l_term := l_term * (((-l_ex * l_rat) * l_rat) * l_rat)
					l_sum := l_sum + l_term
					if (fabs (l_term / l_sum)) < 2.2204460492503131e-16 then
						js.break
					end
					if not js.loop_jumped then
						l_n := l_n + 1
					end
				end
				js.reset
				a_result.item.val := l_sum
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (l_sum))
				Result := 0
				js.return
			elseif a_x < 1.0 then
				Result := (cheb_eval_inst.cheb_eval_e ((fd_2_a_cs.address), a_x, a_result))
				js.return
			elseif a_x < 4.0 then
				l_t := (2.0 / 3.0) * (a_x - 1.0) - 1.0
				Result := (cheb_eval_inst.cheb_eval_e ((fd_2_b_cs.address), l_t, a_result))
				js.return
			elseif a_x < 10.0 then
				l_t___0 := (1.0 / 3.0) * (a_x - 4.0) - 1.0
				Result := (cheb_eval_inst.cheb_eval_e ((fd_2_c_cs.address), l_t___0, a_result))
				js.return
			elseif a_x < 30.0 then
				l_t___1 := 0.1 * a_x - 2.0
				cheb_eval_inst.cheb_eval_e ((fd_2_d_cs.address), l_t___1, l_c___1.address).do_nothing
				a_result.item.val := ((l_c___1.val * a_x) * a_x) * a_x
				a_result.item.err := ((l_c___1.err * a_x) * a_x) * a_x + (3.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			elseif a_x < 1.0 / 6.0554544523933429e-06 then
				l_t___2 := 60.0 / a_x - 1.0
				cheb_eval_inst.cheb_eval_e ((fd_2_e_cs.address), l_t___2, l_c___2.address).do_nothing
				a_result.item.val := ((l_c___2.val * a_x) * a_x) * a_x
				a_result.item.err := ((l_c___2.err * a_x) * a_x) * a_x + (3.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			elseif a_x < 5.6438030941222897e+102 then
				a_result.item.val := (((1.0 / 6.0) * a_x) * a_x) * a_x
				a_result.item.err := (3.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_inff).to_double
					a_result.item.err := (builtin_inff).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("overflow"), ce_string ("fermi_dirac.c"), 1377, 16)
						Result := 16
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_fermi_dirac_int_e (a_j: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_fasymp: PD_GSL_SF_RESULT_STRUCT
			l_stat_asymp: INTEGER_32
		do
			create l_fasymp.make

			if a_j < -1 then
				Result := (fd_nint (a_j, a_x, a_result))
			elseif a_j = -1 then
				Result := (gsl_sf_fermi_dirac_m1_e (a_x, a_result))
			elseif a_j = 0 then
				Result := (gsl_sf_fermi_dirac_0_e (a_x, a_result))
			elseif a_j = 1 then
				Result := (gsl_sf_fermi_dirac_1_e (a_x, a_result))
			elseif a_j = 2 then
				Result := (gsl_sf_fermi_dirac_2_e (a_x, a_result))
			elseif a_x < 0.0 then
				Result := (fd_neg (a_j.to_double, a_x, a_result))
			elseif a_x = 0.0 then
				Result := (zeta_inst.gsl_sf_eta_int_e (a_j + 1, a_result))
			elseif a_x < 1.5 then
				Result := (fd_series_int (a_j, a_x, a_result))
			else
				l_stat_asymp := (fd_asymp (a_j.to_double, a_x, l_fasymp.address))
				if l_stat_asymp = 0 then
					a_result.item.val := l_fasymp.val
					a_result.item.err := l_fasymp.err
					a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
					Result := l_stat_asymp
				else
					Result := (fd_UMseries_int (a_j, a_x, a_result))
				end
			end
		end

	gsl_sf_fermi_dirac_mhalf_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ex: REAL_64
			l_term: REAL_64
			l_sum: REAL_64
			l_n: INTEGER_32
			l_rat: REAL_64
			l_t: REAL_64
			l_t___0: REAL_64
			l_rtx: REAL_64
			l_t___1: REAL_64
			l_c___1: PD_GSL_SF_RESULT_STRUCT
			js: JUMP_STATE
		do
			create l_c___1.make

			if a_x < -7.0839641853226408e+02 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := 0.0
					a_result.item.err := 2.2250738585072014e-308
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("fermi_dirac.c"), 1428, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_x < -1.0 then
				l_ex := (exp (a_x))
				l_term := l_ex
				l_sum := l_term
				l_n := 2
				from
				until
					not (not js.loop_left and then (l_n < 200))
				loop
					js.reset
					l_rat := (l_n.to_double - 1.0) / l_n.to_double
					l_term := l_term * (-l_ex * (sqrt (l_rat)))
					l_sum := l_sum + l_term
					if (fabs (l_term / l_sum)) < 2.2204460492503131e-16 then
						js.break
					end
					if not js.loop_jumped then
						l_n := l_n + 1
					end
				end
				js.reset
				a_result.item.val := l_sum
				a_result.item.err := (2.0 * (fabs (l_sum))) * 2.2204460492503131e-16
				Result := 0
				js.return
			elseif a_x < 1.0 then
				Result := (cheb_eval_inst.cheb_eval_e ((fd_mhalf_a_cs.address), a_x, a_result))
				js.return
			elseif a_x < 4.0 then
				l_t := (2.0 / 3.0) * (a_x - 1.0) - 1.0
				Result := (cheb_eval_inst.cheb_eval_e ((fd_mhalf_b_cs.address), l_t, a_result))
				js.return
			elseif a_x < 10.0 then
				l_t___0 := (1.0 / 3.0) * (a_x - 4.0) - 1.0
				Result := (cheb_eval_inst.cheb_eval_e ((fd_mhalf_c_cs.address), l_t___0, a_result))
				js.return
			elseif a_x < 30.0 then
				l_rtx := (sqrt (a_x))
				l_t___1 := 0.1 * a_x - 2.0
				cheb_eval_inst.cheb_eval_e ((fd_mhalf_d_cs.address), l_t___1, l_c___1.address).do_nothing
				a_result.item.val := l_c___1.val * l_rtx
				a_result.item.err := l_c___1.err * l_rtx + (0.5 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			else
				Result := (fd_asymp (-0.5, a_x, a_result))
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_fermi_dirac_half_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ex: REAL_64
			l_term: REAL_64
			l_sum: REAL_64
			l_n: INTEGER_32
			l_rat: REAL_64
			l_t: REAL_64
			l_t___0: REAL_64
			l_x32___0: REAL_64
			l_t___1: REAL_64
			l_c___1: PD_GSL_SF_RESULT_STRUCT
			js: JUMP_STATE
		do
			create l_c___1.make

			if a_x < -7.0839641853226408e+02 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := 0.0
					a_result.item.err := 2.2250738585072014e-308
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("fermi_dirac.c"), 1476, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_x < -1.0 then
				l_ex := (exp (a_x))
				l_term := l_ex
				l_sum := l_term
				l_n := 2
				from
				until
					not (not js.loop_left and then (l_n < 100))
				loop
					js.reset
					l_rat := (l_n.to_double - 1.0) / l_n.to_double
					l_term := l_term * ((-l_ex * l_rat) * (sqrt (l_rat)))
					l_sum := l_sum + l_term
					if (fabs (l_term / l_sum)) < 2.2204460492503131e-16 then
						js.break
					end
					if not js.loop_jumped then
						l_n := l_n + 1
					end
				end
				js.reset
				a_result.item.val := l_sum
				a_result.item.err := (2.0 * (fabs (l_sum))) * 2.2204460492503131e-16
				Result := 0
				js.return
			elseif a_x < 1.0 then
				Result := (cheb_eval_inst.cheb_eval_e ((fd_half_a_cs.address), a_x, a_result))
				js.return
			elseif a_x < 4.0 then
				l_t := (2.0 / 3.0) * (a_x - 1.0) - 1.0
				Result := (cheb_eval_inst.cheb_eval_e ((fd_half_b_cs.address), l_t, a_result))
				js.return
			elseif a_x < 10.0 then
				l_t___0 := (1.0 / 3.0) * (a_x - 4.0) - 1.0
				Result := (cheb_eval_inst.cheb_eval_e ((fd_half_c_cs.address), l_t___0, a_result))
				js.return
			elseif a_x < 30.0 then
				l_x32___0 := a_x * (sqrt (a_x))
				l_t___1 := 0.1 * a_x - 2.0
				cheb_eval_inst.cheb_eval_e ((fd_half_d_cs.address), l_t___1, l_c___1.address).do_nothing
				a_result.item.val := l_c___1.val * l_x32___0
				a_result.item.err := l_c___1.err * l_x32___0 + (1.5 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			else
				Result := (fd_asymp (0.5, a_x, a_result))
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_fermi_dirac_3half_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ex: REAL_64
			l_term: REAL_64
			l_sum: REAL_64
			l_n: INTEGER_32
			l_rat: REAL_64
			l_t: REAL_64
			l_t___0: REAL_64
			l_x52: REAL_64
			l_t___1: REAL_64
			l_c___1: PD_GSL_SF_RESULT_STRUCT
			js: JUMP_STATE
		do
			create l_c___1.make

			if a_x < -7.0839641853226408e+02 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := 0.0
					a_result.item.err := 2.2250738585072014e-308
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("fermi_dirac.c"), 1524, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_x < -1.0 then
				l_ex := (exp (a_x))
				l_term := l_ex
				l_sum := l_term
				l_n := 2
				from
				until
					not (not js.loop_left and then (l_n < 100))
				loop
					js.reset
					l_rat := (l_n.to_double - 1.0) / l_n.to_double
					l_term := l_term * (((-l_ex * l_rat) * l_rat) * (sqrt (l_rat)))
					l_sum := l_sum + l_term
					if (fabs (l_term / l_sum)) < 2.2204460492503131e-16 then
						js.break
					end
					if not js.loop_jumped then
						l_n := l_n + 1
					end
				end
				js.reset
				a_result.item.val := l_sum
				a_result.item.err := (2.0 * (fabs (l_sum))) * 2.2204460492503131e-16
				Result := 0
				js.return
			elseif a_x < 1.0 then
				Result := (cheb_eval_inst.cheb_eval_e ((fd_3half_a_cs.address), a_x, a_result))
				js.return
			elseif a_x < 4.0 then
				l_t := (2.0 / 3.0) * (a_x - 1.0) - 1.0
				Result := (cheb_eval_inst.cheb_eval_e ((fd_3half_b_cs.address), l_t, a_result))
				js.return
			elseif a_x < 10.0 then
				l_t___0 := (1.0 / 3.0) * (a_x - 4.0) - 1.0
				Result := (cheb_eval_inst.cheb_eval_e ((fd_3half_c_cs.address), l_t___0, a_result))
				js.return
			elseif a_x < 30.0 then
				l_x52 := (a_x * a_x) * (sqrt (a_x))
				l_t___1 := 0.1 * a_x - 2.0
				cheb_eval_inst.cheb_eval_e ((fd_3half_d_cs.address), l_t___1, l_c___1.address).do_nothing
				a_result.item.val := l_c___1.val * l_x52
				a_result.item.err := l_c___1.err * l_x52 + (2.5 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
				js.return
			else
				Result := (fd_asymp (1.5, a_x, a_result))
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_fermi_dirac_inc_0_e (a_x: REAL_64; a_b___0: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_arg: REAL_64
			l_f0: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			l_tmp___2: REAL_64
			js: JUMP_STATE
		do
			create l_f0.make

			if a_b___0 < 0.0 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("fermi_dirac.c"), 1572, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_arg := a_b___0 - a_x
				l_status := (gsl_sf_fermi_dirac_0_e (l_arg, l_f0.address))
				a_result.item.val := l_f0.val - l_arg
				l_tmp___2 := fabs (a_x)
				a_result.item.err := l_f0.err + 2.2204460492503131e-16 * (l_tmp___2 + (fabs (a_b___0)))
				Result := l_status
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_fermi_dirac_m1 (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_fermi_dirac_m1_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_fermi_dirac_m1_e(x, &result)"), ce_string ("fermi_dirac.c"), 1592, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_fermi_dirac_0 (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_fermi_dirac_0_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_fermi_dirac_0_e(x, &result)"), ce_string ("fermi_dirac.c"), 1597, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_fermi_dirac_1 (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_fermi_dirac_1_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_fermi_dirac_1_e(x, &result)"), ce_string ("fermi_dirac.c"), 1602, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_fermi_dirac_2 (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_fermi_dirac_2_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_fermi_dirac_2_e(x, &result)"), ce_string ("fermi_dirac.c"), 1607, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_fermi_dirac_int (a_j: INTEGER_32; a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_fermi_dirac_int_e (a_j, a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_fermi_dirac_int_e(j, x, &result)"), ce_string ("fermi_dirac.c"), 1612, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_fermi_dirac_mhalf (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_fermi_dirac_mhalf_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_fermi_dirac_mhalf_e(x, &result)"), ce_string ("fermi_dirac.c"), 1617, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_fermi_dirac_half (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_fermi_dirac_half_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_fermi_dirac_half_e(x, &result)"), ce_string ("fermi_dirac.c"), 1622, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_fermi_dirac_3half (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_fermi_dirac_3half_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_fermi_dirac_3half_e(x, &result)"), ce_string ("fermi_dirac.c"), 1627, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_fermi_dirac_inc_0 (a_x: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_fermi_dirac_inc_0_e (a_x, a_b___0, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_fermi_dirac_inc_0_e(x, b, &result)"), ce_string ("fermi_dirac.c"), 1632, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
