class
	P_FILE2D

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_histogram2d_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_h: CE_POINTER [PD_GSL_HISTOGRAM2D]): INTEGER_32
		local
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_status := (fwrite_source_inst.gsl_block_raw_fread (a_stream, a_h.item.xrange, a_h.item.nx + {NATURAL_32} 1, (1).to_natural_32))
			if l_status.to_boolean then
				Result := l_status
				js.return
			end
			if not js.return_called then
				l_status := fwrite_source_inst.gsl_block_raw_fread (a_stream, a_h.item.yrange, a_h.item.ny + {NATURAL_32} 1, (1).to_natural_32)
				if l_status.to_boolean then
					Result := l_status
					js.return
				end
			end
			if not js.return_called then
				l_status := fwrite_source_inst.gsl_block_raw_fread (a_stream, a_h.item.bin, a_h.item.nx * a_h.item.ny, (1).to_natural_32)
				Result := l_status
			end
		end

	gsl_histogram2d_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_h: CE_POINTER [PD_GSL_HISTOGRAM2D]): INTEGER_32
		local
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_status := (fwrite_source_inst.gsl_block_raw_fwrite (a_stream, a_h.item.xrange, (a_h.item.nx + {NATURAL_32} 1), (1).to_natural_32))
			if l_status.to_boolean then
				Result := l_status
				js.return
			end
			if not js.return_called then
				l_status := fwrite_source_inst.gsl_block_raw_fwrite (a_stream, a_h.item.yrange, (a_h.item.ny + {NATURAL_32} 1), (1).to_natural_32)
				if l_status.to_boolean then
					Result := l_status
					js.return
				end
			end
			if not js.return_called then
				l_status := fwrite_source_inst.gsl_block_raw_fwrite (a_stream, a_h.item.bin, (a_h.item.nx * a_h.item.ny), (1).to_natural_32)
				Result := l_status
			end
		end

	gsl_histogram2d_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_h: CE_POINTER [PD_GSL_HISTOGRAM2D]; a_range_format: CE_POINTER [INTEGER_8]; a_bin_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_nx: NATURAL_32
			l_ny: NATURAL_32
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_nx := a_h.item.nx
			l_ny := a_h.item.ny
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_left and then (l_i < l_nx))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_ny))
				loop
					l_status := fprintf ([a_stream, a_range_format, a_h.item.xrange[l_i.to_integer_32]])
					if l_status < 0 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("file2d.c"), 78, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("file2d.c"), 85, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_range_format, a_h.item.xrange[(l_i + {NATURAL_32} 1).to_integer_32]])
						if l_status < 0 then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("file2d.c"), 92, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
					end
					if not js.return_called then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("file2d.c"), 99, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_range_format, a_h.item.yrange[l_j.to_integer_32]])
						if l_status < 0 then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("file2d.c"), 106, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
					end
					if not js.return_called then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("file2d.c"), 113, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_range_format, a_h.item.yrange[(l_j + {NATURAL_32} 1).to_integer_32]])
						if l_status < 0 then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("file2d.c"), 120, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
					end
					if not js.return_called then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("file2d.c"), 127, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
					end
					if not js.return_called then
						l_status := fprintf ([a_stream, a_bin_format, a_h.item.bin[(l_i * l_ny + l_j).to_integer_32]])
						if l_status < 0 then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("fprintf failed"), ce_string ("file2d.c"), 134, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
					end
					if not js.return_called then
						l_status := IO_putc (('%N').code, a_stream)
						if l_status = -1 then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("putc failed"), ce_string ("file2d.c"), 141, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("putc failed"), ce_string ("file2d.c"), 148, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_histogram2d_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_h: CE_POINTER [PD_GSL_HISTOGRAM2D]): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_nx: NATURAL_32
			l_ny: NATURAL_32
			l_xupper: REAL_64
			l_yupper: REAL_64
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_nx := a_h.item.nx
			l_ny := a_h.item.ny
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_left and then (l_i < l_nx))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_ny))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%lg %%lg %%lg %%lg %%lg"), a_h.item.xrange + l_i.to_integer_32, create {CE_POINTER [REAL_64]}.make_shared ($l_xupper), a_h.item.yrange + l_j.to_integer_32, create {CE_POINTER [REAL_64]}.make_shared ($l_yupper), (a_h.item.bin + (l_i * l_ny).to_integer_32) + l_j.to_integer_32]))
					if l_status /= 5 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fscanf failed"), ce_string ("file2d.c"), 175, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					a_h.item.yrange[l_ny.to_integer_32] := l_yupper
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				a_h.item.xrange[l_nx.to_integer_32] := l_xupper
				Result := 0
			end
		end

end
