class
	P_FIND

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	find (a_n: NATURAL_32; a_range: CE_POINTER [REAL_64]; a_x: REAL_64; a_i: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_i_linear: NATURAL_32
			l_lower: NATURAL_32
			l_upper: NATURAL_32
			l_mid: NATURAL_32
			l_u: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_x < a_range[0] then
						Result := (-1)
						js.return
					end
					if not js.return_called and then (a_x >= a_range[a_n.to_integer_32]) then
						Result := 1
						js.return
					end
					if not js.return_called then
						l_u := (a_x - a_range[0]) / (a_range[a_n.to_integer_32] - a_range[0])
						l_i_linear := (l_u * a_n.to_real_64).truncated_to_integer_64.to_natural_32
						if a_x >= a_range[l_i_linear.to_integer_32] then
							if a_x < a_range[(l_i_linear + {NATURAL_32} 1).to_integer_32] then
								a_i.item := l_i_linear
								Result := 0
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_upper := a_n
						l_lower := (0).to_natural_32
						from
						until
							not (l_upper - l_lower > {NATURAL_32} 1)
						loop
							l_mid := (l_upper + l_lower) // {NATURAL_32} 2
							if a_x >= a_range[l_mid.to_integer_32] then
								l_lower := l_mid
							else
								l_upper := l_mid
							end
						end
						a_i.item := l_lower
						if not (a_x < a_range[l_lower.to_integer_32]) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_x >= a_range[(l_lower + {NATURAL_32} 1).to_integer_32]) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("x not found in range"), ce_string ("find.c"), 81, 7)
							Result := 7
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 6 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	find___0 (a_n: NATURAL_32; a_range: CE_POINTER [REAL_64]; a_x: REAL_64; a_i: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_i_linear: NATURAL_32
			l_lower: NATURAL_32
			l_upper: NATURAL_32
			l_mid: NATURAL_32
			l_u: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_x < a_range[0] then
						Result := (-1)
						js.return
					end
					if not js.return_called and then (a_x >= a_range[a_n.to_integer_32]) then
						Result := 1
						js.return
					end
					if not js.return_called then
						l_u := (a_x - a_range[0]) / (a_range[a_n.to_integer_32] - a_range[0])
						l_i_linear := (l_u * a_n.to_real_64).truncated_to_integer_64.to_natural_32
						if a_x >= a_range[l_i_linear.to_integer_32] then
							if a_x < a_range[(l_i_linear + {NATURAL_32} 1).to_integer_32] then
								a_i.item := l_i_linear
								Result := 0
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_upper := a_n
						l_lower := (0).to_natural_32
						from
						until
							not (l_upper - l_lower > {NATURAL_32} 1)
						loop
							l_mid := (l_upper + l_lower) // {NATURAL_32} 2
							if a_x >= a_range[l_mid.to_integer_32] then
								l_lower := l_mid
							else
								l_upper := l_mid
							end
						end
						a_i.item := l_lower
						if not (a_x < a_range[l_lower.to_integer_32]) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_x >= a_range[(l_lower + {NATURAL_32} 1).to_integer_32]) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("x not found in range"), ce_string ("find.c"), 81, 7)
							Result := 7
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 6 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	find___1 (a_n: NATURAL_32; a_range: CE_POINTER [REAL_64]; a_x: REAL_64; a_i: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_i_linear: NATURAL_32
			l_lower: NATURAL_32
			l_upper: NATURAL_32
			l_mid: NATURAL_32
			l_u: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_x < a_range[0] then
						Result := (-1)
						js.return
					end
					if not js.return_called and then (a_x >= a_range[a_n.to_integer_32]) then
						Result := 1
						js.return
					end
					if not js.return_called then
						l_u := (a_x - a_range[0]) / (a_range[a_n.to_integer_32] - a_range[0])
						l_i_linear := (l_u * a_n.to_real_64).truncated_to_integer_64.to_natural_32
						if a_x >= a_range[l_i_linear.to_integer_32] then
							if a_x < a_range[(l_i_linear + {NATURAL_32} 1).to_integer_32] then
								a_i.item := l_i_linear
								Result := 0
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_upper := a_n
						l_lower := (0).to_natural_32
						from
						until
							not (l_upper - l_lower > {NATURAL_32} 1)
						loop
							l_mid := (l_upper + l_lower) // {NATURAL_32} 2
							if a_x >= a_range[l_mid.to_integer_32] then
								l_lower := l_mid
							else
								l_upper := l_mid
							end
						end
						a_i.item := l_lower
						if not (a_x < a_range[l_lower.to_integer_32]) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_x >= a_range[(l_lower + {NATURAL_32} 1).to_integer_32]) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("x not found in range"), ce_string ("find.c"), 81, 7)
							Result := 7
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 6 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	find___2 (a_n: NATURAL_32; a_range: CE_POINTER [REAL_64]; a_x: REAL_64; a_i: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_i_linear: NATURAL_32
			l_lower: NATURAL_32
			l_upper: NATURAL_32
			l_mid: NATURAL_32
			l_u: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_x < a_range[0] then
						Result := (-1)
						js.return
					end
					if not js.return_called and then (a_x >= a_range[a_n.to_integer_32]) then
						Result := 1
						js.return
					end
					if not js.return_called then
						l_u := (a_x - a_range[0]) / (a_range[a_n.to_integer_32] - a_range[0])
						l_i_linear := (l_u * a_n.to_real_64).truncated_to_integer_64.to_natural_32
						if a_x >= a_range[l_i_linear.to_integer_32] then
							if a_x < a_range[(l_i_linear + {NATURAL_32} 1).to_integer_32] then
								a_i.item := l_i_linear
								Result := 0
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_upper := a_n
						l_lower := (0).to_natural_32
						from
						until
							not (l_upper - l_lower > {NATURAL_32} 1)
						loop
							l_mid := (l_upper + l_lower) // {NATURAL_32} 2
							if a_x >= a_range[l_mid.to_integer_32] then
								l_lower := l_mid
							else
								l_upper := l_mid
							end
						end
						a_i.item := l_lower
						if not (a_x < a_range[l_lower.to_integer_32]) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_x >= a_range[(l_lower + {NATURAL_32} 1).to_integer_32]) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("x not found in range"), ce_string ("find.c"), 81, 7)
							Result := 7
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 6 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	find___3 (a_n: NATURAL_32; a_range: CE_POINTER [REAL_64]; a_x: REAL_64; a_i: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_i_linear: NATURAL_32
			l_lower: NATURAL_32
			l_upper: NATURAL_32
			l_mid: NATURAL_32
			l_u: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_x < a_range[0] then
						Result := (-1)
						js.return
					end
					if not js.return_called and then (a_x >= a_range[a_n.to_integer_32]) then
						Result := 1
						js.return
					end
					if not js.return_called then
						l_u := (a_x - a_range[0]) / (a_range[a_n.to_integer_32] - a_range[0])
						l_i_linear := (l_u * a_n.to_real_64).truncated_to_integer_64.to_natural_32
						if a_x >= a_range[l_i_linear.to_integer_32] then
							if a_x < a_range[(l_i_linear + {NATURAL_32} 1).to_integer_32] then
								a_i.item := l_i_linear
								Result := 0
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_upper := a_n
						l_lower := (0).to_natural_32
						from
						until
							not (l_upper - l_lower > {NATURAL_32} 1)
						loop
							l_mid := (l_upper + l_lower) // {NATURAL_32} 2
							if a_x >= a_range[l_mid.to_integer_32] then
								l_lower := l_mid
							else
								l_upper := l_mid
							end
						end
						a_i.item := l_lower
						if not (a_x < a_range[l_lower.to_integer_32]) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_x >= a_range[(l_lower + {NATURAL_32} 1).to_integer_32]) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("x not found in range"), ce_string ("find.c"), 81, 7)
							Result := 7
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 6 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	find___4 (a_n: NATURAL_32; a_range: CE_POINTER [REAL_64]; a_x: REAL_64; a_i: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_i_linear: NATURAL_32
			l_lower: NATURAL_32
			l_upper: NATURAL_32
			l_mid: NATURAL_32
			l_u: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_x < a_range[0] then
						Result := (-1)
						js.return
					end
					if not js.return_called and then (a_x >= a_range[a_n.to_integer_32]) then
						Result := 1
						js.return
					end
					if not js.return_called then
						l_u := (a_x - a_range[0]) / (a_range[a_n.to_integer_32] - a_range[0])
						l_i_linear := (l_u * a_n.to_real_64).truncated_to_integer_64.to_natural_32
						if a_x >= a_range[l_i_linear.to_integer_32] then
							if a_x < a_range[(l_i_linear + {NATURAL_32} 1).to_integer_32] then
								a_i.item := l_i_linear
								Result := 0
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_upper := a_n
						l_lower := (0).to_natural_32
						from
						until
							not (l_upper - l_lower > {NATURAL_32} 1)
						loop
							l_mid := (l_upper + l_lower) // {NATURAL_32} 2
							if a_x >= a_range[l_mid.to_integer_32] then
								l_lower := l_mid
							else
								l_upper := l_mid
							end
						end
						a_i.item := l_lower
						if not (a_x < a_range[l_lower.to_integer_32]) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_x >= a_range[(l_lower + {NATURAL_32} 1).to_integer_32]) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("x not found in range"), ce_string ("find.c"), 81, 7)
							Result := 7
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 6 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
