class
	P_FISHMAN18

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create ran_type.make
			create gsl_rng_fishman18.make
		end

feature {ANY} -- attributes

	ran_type: PD_GSL_RNG_TYPE

	gsl_rng_fishman18: CE_POINTER [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	ran_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate))
			l_state.item.x := schrage_inst.schrage_mult ({NATURAL_32} 62089911, l_state.item.x, {NATURAL_32} 2147483647, {NATURAL_32} 46341)
			Result := (l_state.item.x)
		end

	ran_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran_get)
		end

	ran_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate))
			Result := ((ran_get (create {CE_POINTER [ANY]}.make_cast (l_state))).to_real_64 / 2147483647.0)
		end

	ran_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran_get_double)
		end

	ran_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			create l_state.make

			l_s := a_s
			l_state.ce_gets (create {CE_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate))
			if l_s \\ {NATURAL_32} 2147483647 = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.x := l_s \\ {NATURAL_32} 2147483647
		end

	ran_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran_set)
		end

end
