class
	P_FISHMAN20

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create ran_type___7.make
			create gsl_rng_fishman20.make
		end

feature {ANY} -- attributes

	m___1: INTEGER_32 assign set_m___1

	set_m___1 (a_m___1: INTEGER_32)
		do
			m___1 := a_m___1
		end

	a___2: INTEGER_32 assign set_a___2

	set_a___2 (a_a___2: INTEGER_32)
		do
			a___2 := a_a___2
		end

	q___1: INTEGER_32 assign set_q___1

	set_q___1 (a_q___1: INTEGER_32)
		do
			q___1 := a_q___1
		end

	r___1: INTEGER_32 assign set_r___1

	set_r___1 (a_r___1: INTEGER_32)
		do
			r___1 := a_r___1
		end

	ran_type___7: PD_GSL_RNG_TYPE

	gsl_rng_fishman20: CE_POINTER [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	ran_get___7 (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAN_STATE_T]
			l_x: NATURAL_32
			l_h: INTEGER_32
			l_t: INTEGER_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate))
			l_x := l_state.item.x
			l_h := (l_x // q___1.to_natural_32).to_integer_32
			l_t := (a___2.to_natural_32 * (l_x - (l_h * q___1).to_natural_32) - (l_h * r___1).to_natural_32).to_integer_32
			if l_t < 0 then
				l_state.item.x := (l_t + m___1).to_natural_32
			else
				l_state.item.x := l_t.to_natural_32
			end
			Result := (l_state.item.x)
		end

	ran_get___7_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran_get___7)
		end

	ran_get_double___7 (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate))
			Result := ((ran_get___7 (create {CE_POINTER [ANY]}.make_cast (l_state))).to_real_64 / 2147483647.0)
		end

	ran_get_double___7_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran_get_double___7)
		end

	ran_set___7 (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			create l_state.make

			l_s := a_s
			l_state.ce_gets (create {CE_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate))
			if l_s \\ m___1.to_natural_32 = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.x := (l_s).bit_and (m___1.to_natural_32)
		end

	ran_set___7_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran_set___7)
		end

end
