class
	P_FMINIMIZER

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_multimin_fminimizer_alloc (a_T: CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER_TYPE]; a_n: NATURAL_32): CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER]
		local
			l_status: INTEGER_32
			l_s: CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER]
			js: JUMP_STATE
		do
			create l_s.make

			l_s.ce_gets (create {CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER]}.make_cast ((malloc ({PD_GSL_MULTIMIN_FMINIMIZER}.sizeof.to_natural_32))))
			if (l_s.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("failed to allocate space for minimizer struct"), ce_string ("fminimizer.c"), 36, 8)
					Result := (create {CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.item.type := a_T
				l_s.item.x := init_source_inst.gsl_vector_calloc (a_n)
				if ((l_s.item.x).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for x"), ce_string ("fminimizer.c"), 46, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_s.item.state := malloc (a_T.item.size)
				if ((l_s.item.state).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_s.item.x)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for minimizer state"), ce_string ("fminimizer.c"), 56, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_status := (a_T.item.alloc).integer_32_item ([l_s.item.state, a_n])
				if l_status /= 0 then
					free (l_s.item.state)
					init_source_inst.gsl_vector_free (l_s.item.x)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to initialize minimizer state"), ce_string ("fminimizer.c"), 67, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				Result := l_s
			end
		end

	gsl_multimin_fminimizer_set (a_s: CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER]; a_f: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_step_size: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_s.item.x).item.size /= a_f.item.n then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("function incompatible with solver size"), ce_string ("fminimizer.c"), 81, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if a_x.item.size = a_f.item.n then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if a_step_size.item.size = a_f.item.n then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("vector length not compatible with function"), ce_string ("fminimizer.c"), 86, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 6 then -- if done | if done
						if not js.return_called then
							a_s.item.f := a_f
							copy_source_inst.gsl_vector_memcpy (a_s.item.x, a_x).do_nothing
							Result := (((a_s.item.type).item.set).integer_32_item ([a_s.item.state, a_s.item.f, a_s.item.x, create {CE_POINTER [REAL_64]}.make_shared (a_s.c_pointer + {PD_GSL_MULTIMIN_FMINIMIZER}.size_offset), a_step_size]))
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_multimin_fminimizer_free (a_s: CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER])
		local
			js: JUMP_STATE
		do
			if (a_s).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				((a_s.item.type).item.free).call ([a_s.item.state])
				free (a_s.item.state)
				init_source_inst.gsl_vector_free (a_s.item.x)
				free (create {CE_POINTER [ANY]}.make_cast (a_s))
			end
		end

	gsl_multimin_fminimizer_iterate (a_s: CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER]): INTEGER_32
		do
			Result := (((a_s.item.type).item.iterate).integer_32_item ([a_s.item.state, a_s.item.f, a_s.item.x, create {CE_POINTER [REAL_64]}.make_shared (a_s.c_pointer + {PD_GSL_MULTIMIN_FMINIMIZER}.size_offset), create {CE_POINTER [REAL_64]}.make_shared (a_s.c_pointer + {PD_GSL_MULTIMIN_FMINIMIZER}.fval_offset)]))
		end

	gsl_multimin_fminimizer_name (a_s: CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER]): CE_POINTER [INTEGER_8]
		do
			Result := ((a_s.item.type).item.name)
		end

	gsl_multimin_fminimizer_x (a_s: CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER]): CE_POINTER [PD_GSL_VECTOR]
		do
			Result := (a_s.item.x)
		end

	gsl_multimin_fminimizer_minimum (a_s: CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER]): REAL_64
		do
			Result := (a_s.item.fval)
		end

	gsl_multimin_fminimizer_size (a_s: CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER]): REAL_64
		do
			Result := (a_s.item.size)
		end

end
