class
	P_GAMMA_INC

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gamma_inc_D (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_lnr: REAL_64
			l_lg: PD_GSL_SF_RESULT_STRUCT
			l_tmp___0: REAL_64
			l_gstar: PD_GSL_SF_RESULT_STRUCT
			l_ln_term: PD_GSL_SF_RESULT_STRUCT
			l_term1: REAL_64
			l_u: REAL_64
			l_ln_u: REAL_64
			l_tmp___3: REAL_64
			l_mu: REAL_64
			l_tmp___6: REAL_64
			l_tmp___8: REAL_64
			l_tmp___10: REAL_64
			l_tmp___12: REAL_64
		do
			create l_lg.make
			create l_gstar.make
			create l_ln_term.make

			if a_a___5 < 10.0 then
				gamma_inst.gsl_sf_lngamma_e (a_a___5 + 1.0, l_lg.address).do_nothing
				l_lnr := (a_a___5 * (log (a_x)) - a_x) - l_lg.val
				a_result.item.val := exp (l_lnr)
				l_tmp___0 := fabs (l_lnr)
				a_result.item.err := ((2.0 * 2.2204460492503131e-16) * (l_tmp___0 + 1.0)) * (fabs (a_result.item.val))
				Result := 0
			else
				if a_x < 0.5 * a_a___5 then
					l_u := a_x / a_a___5
					l_ln_u := (log (l_u))
					l_ln_term.val := (l_ln_u - l_u) + 1.0
					l_tmp___3 := fabs (l_ln_u)
					l_ln_term.err := ((l_tmp___3 + (fabs (l_u))) + 1.0) * 2.2204460492503131e-16
				else
					l_mu := (a_x - a_a___5) / a_a___5
					log_inst.gsl_sf_log_1plusx_mx_e (l_mu, l_ln_term.address).do_nothing
					l_ln_term.err := l_ln_term.err + (2.2204460492503131e-16 * (fabs (l_mu)))
				end
				gamma_inst.gsl_sf_gammastar_e (a_a___5, l_gstar.address).do_nothing
				l_tmp___6 := exp (a_a___5 * l_ln_term.val)
				l_term1 := l_tmp___6 / (sqrt ((2.0 * 3.14159265358979323846) * a_a___5))
				a_result.item.val := l_term1 / l_gstar.val
				l_tmp___8 := fabs (a_a___5 * l_ln_term.val)
				a_result.item.err := ((2.0 * 2.2204460492503131e-16) * (l_tmp___8 + 1.0)) * (fabs (a_result.item.val))
				l_tmp___10 := fabs (a_a___5)
				a_result.item.err := a_result.item.err + ((l_tmp___10 * l_ln_term.err) * (fabs (a_result.item.val)))
				l_tmp___12 := fabs (l_gstar.val)
				a_result.item.err := a_result.item.err + ((l_gstar.err / l_tmp___12) * (fabs (a_result.item.val)))
				Result := 0
			end
		end

	gamma_inc_P_series (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_nmax: INTEGER_32
			l_D: PD_GSL_SF_RESULT_STRUCT
			l_stat_D: INTEGER_32
			l_cf_res: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			l_tmp___1: REAL_64
			l_sum: REAL_64
			l_term: REAL_64
			l_remainder___0: REAL_64
			l_n: INTEGER_32
			l_nlow: INTEGER_32
			l_tmp___3: REAL_64
			l_tnp1: REAL_64
			l_tmp___5: REAL_64
			js: JUMP_STATE
		do
			create l_D.make
			create l_cf_res.make

			l_nmax := 10000
			l_stat_D := (gamma_inc_D (a_a___5, a_x, l_D.address))
			if a_x > 0.995 * a_a___5 then
				if a_a___5 > 1.e5 then
					l_status := (exp_inst.gsl_sf_exprel_n_CF_e (a_a___5, a_x, l_cf_res.address))
					a_result.item.val := l_D.val * l_cf_res.val
					l_tmp___1 := fabs (l_D.val * l_cf_res.err)
					a_result.item.err := l_tmp___1 + (fabs (l_D.err * l_cf_res.val))
					Result := l_status
					js.return
				end
			end
			if not js.return_called and then (a_x > a_a___5 + l_nmax.to_double) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gamma_inc_P_series x>>a exceeds range"), ce_string ("gamma_inc.c"), 107, 11)
					Result := 11
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_sum := 1.0
				l_term := 1.0
				if a_x > a_a___5 then
					l_tmp___3 := a_x - a_a___5
				else
					l_tmp___3 := (0).to_double
				end
				l_nlow := l_tmp___3.truncated_to_integer
				l_n := 1
				from
				until
					not (l_n < l_nlow)
				loop
					l_term := l_term * (a_x / (a_a___5 + l_n.to_double))
					l_sum := l_sum + l_term
					l_n := l_n + 1
				end
				from
				until
					not (not js.loop_left and then (l_n < l_nmax))
				loop
					js.reset
					l_term := l_term * (a_x / (a_a___5 + l_n.to_double))
					l_sum := l_sum + l_term
					if (fabs (l_term / l_sum)) < 2.2204460492503131e-16 then
						js.break
					end
					if not js.loop_jumped then
						l_n := l_n + 1
					end
				end
				js.reset
				l_tnp1 := (a_x / (a_a___5 + l_n.to_double)) * l_term
				l_remainder___0 := l_tnp1 / (1.0 - a_x / ((a_a___5 + l_n.to_double) + 1.0))
				a_result.item.val := l_D.val * l_sum
				l_tmp___5 := fabs (l_sum)
				a_result.item.err := l_D.err * l_tmp___5 + (fabs (l_D.val * l_remainder___0))
				a_result.item.err := a_result.item.err + (((1.0 + l_n.to_double) * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				if l_n = l_nmax then
					if (fabs (l_remainder___0 / l_sum)) > 1.4901161193847656e-08 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("gamma_inc_P_series failed to converge"), ce_string ("gamma_inc.c"), 146, 11)
							Result := 11
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					else
						Result := l_stat_D
						js.return
					end
				else
					Result := l_stat_D
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gamma_inc_Q_large_x (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_nmax: INTEGER_32
			l_D: PD_GSL_SF_RESULT_STRUCT
			l_stat_D: INTEGER_32
			l_sum: REAL_64
			l_term: REAL_64
			l_last: REAL_64
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			create l_D.make

			l_nmax := 5000
			l_stat_D := (gamma_inc_D (a_a___5, a_x, l_D.address))
			l_sum := 1.0
			l_term := 1.0
			l_last := 1.0
			l_n := 1
			from
			until
				not (not js.loop_left and then (l_n < l_nmax))
			loop
				js.reset
				l_term := l_term * ((a_a___5 - l_n.to_double) / a_x)
				if (fabs (l_term / l_last)) > 1.0 then
					js.break
				end
				if not js.loop_jumped then
					if (fabs (l_term / l_sum)) < 2.2204460492503131e-16 then
						js.break
					end
				end
				if not js.loop_jumped then
					l_sum := l_sum + l_term
					l_last := l_term
					l_n := l_n + 1
				end
			end
			js.reset
			a_result.item.val := (l_D.val * (a_a___5 / a_x)) * l_sum
			a_result.item.err := l_D.err * (fabs ((a_a___5 / a_x) * l_sum))
			a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
			if l_n = l_nmax then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("error in large x asymptotic"), ce_string ("gamma_inc.c"), 181, 11)
					Result := 11
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				Result := l_stat_D
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gamma_inc_Q_asymp_unif (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_rta: REAL_64
			l_eps: REAL_64
			l_ln_term: PD_GSL_SF_RESULT_STRUCT
			l_stat_ln: INTEGER_32
			l_eta: REAL_64
			l_tmp___1: INTEGER_32
			l_erfc___0: PD_GSL_SF_RESULT_STRUCT
			l_R: REAL_64
			l_c0___0: REAL_64
			l_c1___2: REAL_64
			l_rt_term: REAL_64
			l_lam: REAL_64
		do
			create l_ln_term.make
			create l_erfc___0.make

			l_rta := (sqrt (a_a___5))
			l_eps := (a_x - a_a___5) / a_a___5
			l_stat_ln := (log_inst.gsl_sf_log_1plusx_mx_e (l_eps, l_ln_term.address))
			if l_eps >= 0.0 then
				l_tmp___1 := 1
			else
				l_tmp___1 := -1
			end
			l_eta := l_tmp___1.to_double * (sqrt (-2.0 * l_ln_term.val))
			erfc_inst.gsl_sf_erfc_e ((l_eta * l_rta) / 1.41421356237309504880, l_erfc___0.address).do_nothing
			if (fabs (l_eps)) < 7.4009597974140505e-04 then
				l_c0___0 := -1.0 / 3.0 + l_eps * (1.0 / 12.0 - l_eps * (23.0 / 540.0 - l_eps * (353.0 / 12960.0 - (l_eps * 589.0) / 30240.0)))
				l_c1___2 := -1.0 / 540.0 - l_eps / 288.0
			else
				l_rt_term := (sqrt ((-2.0 * l_ln_term.val) / (l_eps * l_eps)))
				l_lam := a_x / a_a___5
				l_c0___0 := (1.0 - 1.0 / l_rt_term) / l_eps
				l_c1___2 := -(((l_eta * l_eta) * l_eta) * ((l_lam * l_lam + 10.0 * l_lam) + 1.0) - ((12.0 * l_eps) * l_eps) * l_eps) / ((((((12.0 * l_eta) * l_eta) * l_eta) * l_eps) * l_eps) * l_eps)
			end
			l_R := ((exp (((-0.5 * a_a___5) * l_eta) * l_eta)) / ((1.41421356237309504880 * 1.77245385090551602729816748334) * l_rta)) * (l_c0___0 + l_c1___2 / a_a___5)
			a_result.item.val := 0.5 * l_erfc___0.val + l_R
			a_result.item.err := 2.2204460492503131e-16 * (fabs ((((l_R * 0.5) * a_a___5) * l_eta) * l_eta)) + 0.5 * l_erfc___0.err
			a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
			Result := l_stat_ln
		end

	gamma_inc_F_CF (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_nmax: INTEGER_32
			l_small___0: REAL_64
			l_hn: REAL_64
			l_Cn: REAL_64
			l_Dn: REAL_64
			l_n: INTEGER_32
			l_an: REAL_64
			l_delta___0: REAL_64
			js: JUMP_STATE
		do
			l_nmax := 5000
			l_small___0 := (gsl_gsl_pow_int_inst.gsl_pow_3 (2.2204460492503131e-16))
			l_hn := 1.0
			l_Cn := 1.0 / l_small___0
			l_Dn := 1.0
			l_n := 2
			from
			until
				not (not js.loop_left and then (l_n < l_nmax))
			loop
				js.reset
				if ((l_n).bit_and (1)).to_boolean then
					l_an := (0.5 * (l_n - 1).to_double) / a_x
				else
					l_an := (0.5 * l_n.to_double - a_a___5) / a_x
				end
				l_Dn := 1.0 + l_an * l_Dn
				if (fabs (l_Dn)) < l_small___0 then
					l_Dn := l_small___0
				end
				l_Cn := 1.0 + l_an / l_Cn
				if (fabs (l_Cn)) < l_small___0 then
					l_Cn := l_small___0
				end
				l_Dn := 1.0 / l_Dn
				l_delta___0 := l_Cn * l_Dn
				l_hn := l_hn * l_delta___0
				if (fabs (l_delta___0 - 1.0)) < 2.2204460492503131e-16 then
					js.break
				end
				if not js.loop_jumped then
					l_n := l_n + 1
				end
			end
			js.reset
			a_result.item.val := l_hn
			a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (l_hn))
			a_result.item.err := a_result.item.err + ((2.2204460492503131e-16 * (2.0 + 0.5 * l_n.to_double)) * (fabs (a_result.item.val)))
			if l_n = l_nmax then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("error in CF for F(a,x)"), ce_string ("gamma_inc.c"), 286, 11)
					Result := 11
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gamma_inc_Q_CF (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_D: PD_GSL_SF_RESULT_STRUCT
			l_F___0: PD_GSL_SF_RESULT_STRUCT
			l_stat_D: INTEGER_32
			l_stat_F: INTEGER_32
			l_tmp___1: REAL_64
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
		do
			create l_D.make
			create l_F___0.make

			l_stat_D := (gamma_inc_D (a_a___5, a_x, l_D.address))
			l_stat_F := (gamma_inc_F_CF (a_a___5, a_x, l_F___0.address))
			a_result.item.val := (l_D.val * (a_a___5 / a_x)) * l_F___0.val
			l_tmp___1 := fabs ((a_a___5 / a_x) * l_F___0.val)
			a_result.item.err := l_D.err * l_tmp___1 + (fabs (((l_D.val * a_a___5) / a_x) * l_F___0.err))
			if l_stat_F /= 0 then
				l_tmp___4 := l_stat_F
			else
				if l_stat_D /= 0 then
					l_tmp___3 := l_stat_D
				else
					l_tmp___3 := 0
				end
				l_tmp___4 := l_tmp___3
			end
			Result := l_tmp___4
		end

	gamma_inc_Q_series (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_term1: REAL_64
			l_sum: REAL_64
			l_stat_sum: INTEGER_32
			l_term2: REAL_64
			l_pg21: REAL_64
			l_lnx: REAL_64
			l_el: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_c4___2: REAL_64
			l_c5___1: REAL_64
			l_c6___2: REAL_64
			l_c7___0: REAL_64
			l_c8___0: REAL_64
			l_c9: REAL_64
			l_c10: REAL_64
			l_nmax: INTEGER_32
			l_t: REAL_64
			l_n: INTEGER_32
			l_tmp___1: REAL_64
			js: JUMP_STATE
		do
			l_pg21 := -2.404113806319188570799476
			l_lnx := (log (a_x))
			l_el := 0.57721566490153286060651209008 + l_lnx
			l_c1___2 := -l_el
			l_c2___0 := (3.14159265358979323846 * 3.14159265358979323846) / 12.0 - (0.5 * l_el) * l_el
			l_c3___3 := l_el * ((3.14159265358979323846 * 3.14159265358979323846) / 12.0 - (l_el * l_el) / 6.0) + l_pg21 / 6.0
			l_c4___2 := (((-0.04166666666666666667 * (-1.758243446661483480 + l_lnx)) * (-0.764428657272716373 + l_lnx)) * (0.723980571623507657 + l_lnx)) * (4.107554191916823640 + l_lnx)
			l_c5___1 := ((((-0.0083333333333333333 * (-2.06563396085715900 + l_lnx)) * (-1.28459889470864700 + l_lnx)) * (-0.27583535756454143 + l_lnx)) * (1.33677371336239618 + l_lnx)) * (5.17537282427561550 + l_lnx)
			l_c6___2 := (((((-0.0013888888888888889 * (-2.30814336454783200 + l_lnx)) * (-1.65846557706987300 + l_lnx)) * (-0.88768082560020400 + l_lnx)) * (0.17043847751371778 + l_lnx)) * (1.92135970115863890 + l_lnx)) * (6.22578557795474900 + l_lnx)
			l_c7___0 := ((((((-0.00019841269841269841 * (-2.5078657901291800 + l_lnx)) * (-1.9478900888958200 + l_lnx)) * (-1.3194837322612730 + l_lnx)) * (-0.5281322700249279 + l_lnx)) * (0.5913834939078759 + l_lnx)) * (2.4876819633378140 + l_lnx)) * (7.2648160783762400 + l_lnx)
			l_c8___0 := (((((((-0.00002480158730158730 * (-2.677341544966400 + l_lnx)) * (-2.182810448271700 + l_lnx)) * (-1.649350342277400 + l_lnx)) * (-1.014099048290790 + l_lnx)) * (-0.191366955370652 + l_lnx)) * (0.995403817918724 + l_lnx)) * (3.041323283529310 + l_lnx)) * (8.295966556941250 + l_lnx)
			l_c9 := ((((((((-2.75573192239859e-6 * (-2.8243487670469080 + l_lnx)) * (-2.3798494322701120 + l_lnx)) * (-1.9143674728689960 + l_lnx)) * (-1.3814529102920370 + l_lnx)) * (-0.7294312810261694 + l_lnx)) * (0.1299079285269565 + l_lnx)) * (1.3873333251885240 + l_lnx)) * (3.5857258865210760 + l_lnx)) * (9.3214237073814600 + l_lnx)
			l_c10 := (((((((((-2.75573192239859e-7 * (-2.9540329644556910 + l_lnx)) * (-2.5491366926991850 + l_lnx)) * (-2.1348279229279880 + l_lnx)) * (-1.6741881076349450 + l_lnx)) * (-1.1325949616098420 + l_lnx)) * (-0.4590034650618494 + l_lnx)) * (0.4399352987435699 + l_lnx)) * (1.7702236517651670 + l_lnx)) * (4.1231539047474080 + l_lnx)) * (10.342627908148680 + l_lnx)
			l_term1 := a_a___5 * (l_c1___2 + a_a___5 * (l_c2___0 + a_a___5 * (l_c3___3 + a_a___5 * (l_c4___2 + a_a___5 * (l_c5___1 + a_a___5 * (l_c6___2 + a_a___5 * (l_c7___0 + a_a___5 * (l_c8___0 + a_a___5 * (l_c9 + a_a___5 * l_c10)))))))))
			l_nmax := 5000
			l_t := 1.0
			l_sum := 1.0
			l_n := 1
			from
			until
				not (not js.loop_left and then (l_n < l_nmax))
			loop
				js.reset
				l_t := l_t * (-a_x / (l_n.to_double + 1.0))
				l_sum := l_sum + (((a_a___5 + 1.0) / ((a_a___5 + l_n.to_double) + 1.0)) * l_t)
				if (fabs (l_t / l_sum)) < 2.2204460492503131e-16 then
					js.break
				end
				if not js.loop_jumped then
					l_n := l_n + 1
				end
			end
			js.reset
			if l_n = l_nmax then
				l_stat_sum := 11
			else
				l_stat_sum := 0
			end
			l_term2 := ((((1.0 - l_term1) * a_a___5) / (a_a___5 + 1.0)) * a_x) * l_sum
			a_result.item.val := l_term1 + l_term2
			l_tmp___1 := fabs (l_term1)
			a_result.item.err := 2.2204460492503131e-16 * (l_tmp___1 + 2.0 * (fabs (l_term2)))
			a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
			Result := l_stat_sum
		end

	gamma_inc_series (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_Q___1: PD_GSL_SF_RESULT_STRUCT
			l_G: PD_GSL_SF_RESULT_STRUCT
			l_stat_Q: INTEGER_32
			l_stat_G: INTEGER_32
			l_tmp___1: REAL_64
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
		do
			create l_Q___1.make
			create l_G.make

			l_stat_Q := (gamma_inc_Q_series (a_a___5, a_x, l_Q___1.address))
			l_stat_G := (gamma_inst.gsl_sf_gamma_e (a_a___5, l_G.address))
			a_result.item.val := l_Q___1.val * l_G.val
			l_tmp___1 := fabs (l_Q___1.val * l_G.err)
			a_result.item.err := l_tmp___1 + (fabs (l_Q___1.err * l_G.val))
			a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
			if l_stat_Q /= 0 then
				l_tmp___5 := l_stat_Q
			else
				if l_stat_G /= 0 then
					l_tmp___4 := l_stat_G
				else
					l_tmp___4 := 0
				end
				l_tmp___5 := l_tmp___4
			end
			Result := l_tmp___5
		end

	gamma_inc_a_gt_0 (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_Q___1: PD_GSL_SF_RESULT_STRUCT
			l_G: PD_GSL_SF_RESULT_STRUCT
			l_stat_Q: INTEGER_32
			l_stat_G: INTEGER_32
			l_tmp___1: REAL_64
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
		do
			create l_Q___1.make
			create l_G.make

			l_stat_Q := (gsl_sf_gamma_inc_Q_e (a_a___5, a_x, l_Q___1.address))
			l_stat_G := (gamma_inst.gsl_sf_gamma_e (a_a___5, l_G.address))
			a_result.item.val := l_G.val * l_Q___1.val
			l_tmp___1 := fabs (l_G.val * l_Q___1.err)
			a_result.item.err := l_tmp___1 + (fabs (l_G.err * l_Q___1.val))
			a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
			if l_stat_G /= 0 then
				l_tmp___5 := l_stat_G
			else
				if l_stat_Q /= 0 then
					l_tmp___4 := l_stat_Q
				else
					l_tmp___4 := 0
				end
				l_tmp___5 := l_tmp___4
			end
			Result := l_tmp___5
		end

	gamma_inc_CF (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_F___0: PD_GSL_SF_RESULT_STRUCT
			l_pre: PD_GSL_SF_RESULT_STRUCT
			l_am1lgx: REAL_64
			l_stat_F: INTEGER_32
			l_stat_E: INTEGER_32
			l_tmp___3: REAL_64
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
		do
			create l_F___0.make
			create l_pre.make

			l_am1lgx := (a_a___5 - 1.0) * (log (a_x))
			l_stat_F := (gamma_inc_F_CF (a_a___5, a_x, l_F___0.address))
			l_stat_E := (exp_inst.gsl_sf_exp_err_e (l_am1lgx - a_x, 2.2204460492503131e-16 * (fabs (l_am1lgx)), l_pre.address))
			a_result.item.val := l_F___0.val * l_pre.val
			l_tmp___3 := fabs (l_F___0.err * l_pre.val)
			a_result.item.err := l_tmp___3 + (fabs (l_F___0.val * l_pre.err))
			a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
			if l_stat_F /= 0 then
				l_tmp___7 := l_stat_F
			else
				if l_stat_E /= 0 then
					l_tmp___6 := l_stat_E
				else
					l_tmp___6 := 0
				end
				l_tmp___7 := l_tmp___6
			end
			Result := l_tmp___7
		end

	gsl_sf_gamma_inc_Q_e (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_P___2: PD_GSL_SF_RESULT_STRUCT
			l_stat_P: INTEGER_32
			l_P___3: PD_GSL_SF_RESULT_STRUCT
			l_stat_P___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_P___2.make
			create l_P___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_a___5 < 0.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 3 then -- else:
						if not (a_x < 0.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L___1:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("gamma_inc.c"), 503, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 6 then -- else:
						if a_x /= 0.0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						a_result.item.val := 1.0
						a_result.item.err := 0.0
						Result := 0
						js.return
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 9 then -- else:
						if a_a___5 /= 0.0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						a_result.item.val := 0.0
						a_result.item.err := 0.0
						Result := 0
						js.return
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 12 then -- else:
						if not (a_x <= 0.5 * a_a___5) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_stat_P := (gamma_inc_P_series (a_a___5, a_x, l_P___2.address))
						a_result.item.val := 1.0 - l_P___2.val
						a_result.item.err := l_P___2.err
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						Result := l_stat_P
						js.return
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 15 then -- else:
						if not (a_a___5 >= 1.0e+06) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if (a_x - a_a___5) * (a_x - a_a___5) < a_a___5 then
							Result := (gamma_inc_Q_asymp_unif (a_a___5, a_x, a_result))
							js.return
						else
							l_pos := -1 + 18 -- goto _L___0
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 18 then -- else: | _L___0:
						if not (a_a___5 < 0.2) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if a_x < 5.0 then
							Result := (gamma_inc_Q_series (a_a___5, a_x, a_result))
							js.return
						else
							l_pos := -1 + 21 -- goto _L
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else: | _L:
						if a_a___5 <= a_x then
							if a_x <= 1.0e+06 then
								Result := (gamma_inc_Q_CF (a_a___5, a_x, a_result))
								js.return
							else
								Result := (gamma_inc_Q_large_x (a_a___5, a_x, a_result))
								js.return
							end
						elseif a_x > a_a___5 - (sqrt (a_a___5)) then
							Result := (gamma_inc_Q_CF (a_a___5, a_x, a_result))
							js.return
						else
							l_stat_P___0 := (gamma_inc_P_series (a_a___5, a_x, l_P___3.address))
							a_result.item.val := 1.0 - l_P___3.val
							a_result.item.err := l_P___3.err
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							Result := l_stat_P___0
							js.return
						end
				when 22 then -- if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 23 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_gamma_inc_P_e (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_tmp___1: INTEGER_32
			l_Q___1: PD_GSL_SF_RESULT_STRUCT
			l_stat_Q: INTEGER_32
			l_Q___2: PD_GSL_SF_RESULT_STRUCT
			l_stat_Q___0: INTEGER_32
			l_Q___3: PD_GSL_SF_RESULT_STRUCT
			l_stat_Q___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_Q___1.make
			create l_Q___2.make
			create l_Q___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_a___5 <= 0.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 3 then -- else:
						if not (a_x < 0.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("gamma_inc.c"), 584, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 6 then -- else:
						if a_x /= 0.0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						a_result.item.val := 0.0
						a_result.item.err := 0.0
						Result := 0
						js.return
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 9 then -- else:
						if not (a_x < 20.0) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_tmp___1 := gamma_inc_P_series (a_a___5, a_x, a_result)
						Result := l_tmp___1
						js.return
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 12 then -- else:
						if not (a_x < 0.5 * a_a___5) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_tmp___1 := gamma_inc_P_series (a_a___5, a_x, a_result)
						Result := l_tmp___1
						js.return
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 15 then -- else:
						if not (a_a___5 > 1.0e+06) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if (a_x - a_a___5) * (a_x - a_a___5) < a_a___5 then
							l_stat_Q := (gamma_inc_Q_asymp_unif (a_a___5, a_x, l_Q___1.address))
							a_result.item.val := 1.0 - l_Q___1.val
							a_result.item.err := l_Q___1.err
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							Result := l_stat_Q
							js.return
						else
							l_pos := -1 + 18 -- goto _L
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L:
						if a_a___5 <= a_x then
							if a_a___5 > 0.2 * a_x then
								l_stat_Q___0 := gamma_inc_Q_CF (a_a___5, a_x, l_Q___2.address)
							else
								l_stat_Q___0 := gamma_inc_Q_large_x (a_a___5, a_x, l_Q___2.address)
							end
							a_result.item.val := 1.0 - l_Q___2.val
							a_result.item.err := l_Q___2.err
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							Result := l_stat_Q___0
							js.return
						elseif (a_x - a_a___5) * (a_x - a_a___5) < a_a___5 then
							l_stat_Q___1 := (gamma_inc_Q_CF (a_a___5, a_x, l_Q___3.address))
							a_result.item.val := 1.0 - l_Q___3.val
							a_result.item.err := l_Q___3.err
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							Result := l_stat_Q___1
							js.return
						else
							Result := (gamma_inc_P_series (a_a___5, a_x, a_result))
							js.return
						end
				when 19 then -- if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 20 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_gamma_inc_e (a_a___5: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_fa: REAL_64
			l_da: REAL_64
			l_g_da: PD_GSL_SF_RESULT_STRUCT
			l_stat_g_da: INTEGER_32
			l_tmp___9: INTEGER_32
			l_alpha: REAL_64
			l_gax: REAL_64
			l_shift___0: REAL_64
			l_tmp___12: REAL_64
			js: JUMP_STATE
		do
			create l_g_da.make

			if a_x < 0.0 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("gamma_inc.c"), 649, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_x = 0.0 then
				Result := (gamma_inst.gsl_sf_gamma_e (a_a___5, a_result))
				js.return
			elseif a_a___5 = 0.0 then
				Result := (expint_inst.gsl_sf_expint_E1_e (a_x, a_result))
				js.return
			elseif a_a___5 > 0.0 then
				Result := (gamma_inc_a_gt_0 (a_a___5, a_x, a_result))
				js.return
			elseif a_x > 0.25 then
				Result := (gamma_inc_CF (a_a___5, a_x, a_result))
				js.return
			elseif (fabs (a_a___5)) < 0.5 then
				Result := (gamma_inc_series (a_a___5, a_x, a_result))
				js.return
			else
				l_fa := (floor (a_a___5))
				l_da := a_a___5 - l_fa
				if l_da > 0.0 then
					l_tmp___9 := (gamma_inc_a_gt_0 (l_da, a_x, l_g_da.address))
				else
					l_tmp___9 := (expint_inst.gsl_sf_expint_E1_e (a_x, l_g_da.address))
				end
				l_stat_g_da := l_tmp___9
				l_alpha := l_da
				l_gax := l_g_da.val
				from
				until
					js.loop_left
				loop
					js.reset
					l_shift___0 := (exp (-a_x + (l_alpha - 1.0) * (log (a_x))))
					l_gax := (l_gax - l_shift___0) / (l_alpha - 1.0)
					l_alpha := l_alpha - (1.0)
					if not (l_alpha > a_a___5) then
						js.break
					end
				end
				js.reset
				a_result.item.val := l_gax
				l_tmp___12 := fabs (a_a___5)
				a_result.item.err := ((2.0 * (1.0 + l_tmp___12)) * 2.2204460492503131e-16) * (fabs (l_gax))
				Result := l_stat_g_da
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_gamma_inc_P (a_a___5: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_gamma_inc_P_e (a_a___5, a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_gamma_inc_P_e(a, x, &result)"), ce_string ("gamma_inc.c"), 710, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_gamma_inc_Q (a_a___5: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_gamma_inc_Q_e (a_a___5, a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_gamma_inc_Q_e(a, x, &result)"), ce_string ("gamma_inc.c"), 715, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_gamma_inc (a_a___5: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_gamma_inc_e (a_a___5, a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_gamma_inc_e(a, x, &result)"), ce_string ("gamma_inc.c"), 720, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
