class
	P_GAUSSTAIL

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_ran_gaussian_tail (a_r___3: CE_POINTER [PD_GSL_RNG]; a_a___5: REAL_64; a_sigma: REAL_64): REAL_64
		local
			l_s: REAL_64
			l_x: REAL_64
			l_u: REAL_64
			l_v: REAL_64
			l_x___0: REAL_64
			js: JUMP_STATE
		do
			l_s := a_a___5 / a_sigma
			if l_s < (1).to_double then
				from
				until
					js.loop_left
				loop
					js.reset
					l_x := gauss_inst.gsl_ran_gaussian (a_r___3, 1.0)
					if not (l_x < l_s) then
						js.break
					end
				end
				js.reset
				Result := (l_x * a_sigma)
			else
				from
				until
					js.loop_left
				loop
					js.reset
					l_u := gsl_gsl_rng_inst.gsl_rng_uniform (a_r___3)
					from
					until
						js.loop_left
					loop
						js.reset
						l_v := gsl_gsl_rng_inst.gsl_rng_uniform (a_r___3)
						if l_v /= 0.0 then
							js.break
						end
					end
					js.reset
					l_x___0 := sqrt (l_s * l_s - (2).to_double * (log (l_v)))
					if not (l_x___0 * l_u > l_s) then
						js.break
					end
				end
				js.reset
				Result := (l_x___0 * a_sigma)
			end
		end

	gsl_ran_gaussian_tail_pdf (a_x: REAL_64; a_a___5: REAL_64; a_sigma: REAL_64): REAL_64
		local
			l_N: REAL_64
			l_p: REAL_64
			l_u: REAL_64
			l_f: REAL_64
			l_tmp___1: REAL_64
		do
			if a_x < a_a___5 then
				Result := (0).to_double
			else
				l_u := a_x / a_sigma
				l_f := (erfc_inst.gsl_sf_erfc (a_a___5 / ((sqrt (2.0)) * a_sigma)))
				l_N := 0.5 * l_f
				l_tmp___1 := sqrt ((2).to_double * 3.14159265358979323846)
				l_p := ((1).to_double / ((l_N * l_tmp___1) * a_sigma)) * (exp ((-l_u * l_u) / (2).to_double))
				Result := l_p
			end
		end

	gsl_ran_ugaussian_tail (a_r___3: CE_POINTER [PD_GSL_RNG]; a_a___5: REAL_64): REAL_64
		do
			Result := (gsl_ran_gaussian_tail (a_r___3, a_a___5, 1.0))
		end

	gsl_ran_ugaussian_tail_pdf (a_x: REAL_64; a_a___5: REAL_64): REAL_64
		do
			Result := (gsl_ran_gaussian_tail_pdf (a_x, a_a___5, 1.0))
		end

end
