class
	P_GEGENBAUER

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_sf_gegenpoly_1_e (a_lambda: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		do
			if a_lambda = 0.0 then
				a_result.item.val := 2.0 * a_x
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
			else
				a_result.item.val := (2.0 * a_lambda) * a_x
				a_result.item.err := (4.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
			end
		end

	gsl_sf_gegenpoly_2_e (a_lambda: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_txx: REAL_64
			l_tmp___1: REAL_64
		do
			if a_lambda = 0.0 then
				l_txx := (2.0 * a_x) * a_x
				a_result.item.val := -1.0 + l_txx
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (l_txx))
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
			else
				a_result.item.val := a_lambda * (-1.0 + ((2.0 * (1.0 + a_lambda)) * a_x) * a_x)
				l_tmp___1 := fabs (a_result.item.val)
				a_result.item.err := 2.2204460492503131e-16 * (2.0 * l_tmp___1 + (fabs (a_lambda)))
				Result := 0
			end
		end

	gsl_sf_gegenpoly_3_e (a_lambda: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_tmp: REAL_64
			l_c___1: REAL_64
			l_tmp___1: REAL_64
		do
			if a_lambda = 0.0 then
				a_result.item.val := a_x * (-2.0 + ((4.0 / 3.0) * a_x) * a_x)
				l_tmp := fabs (a_result.item.val)
				a_result.item.err := 2.2204460492503131e-16 * (2.0 * l_tmp + (fabs (a_x)))
				Result := 0
			else
				l_c___1 := 4.0 + a_lambda * (6.0 + 2.0 * a_lambda)
				a_result.item.val := ((2.0 * a_lambda) * a_x) * ((-1.0 - a_lambda) + ((l_c___1 * a_x) * a_x) / 3.0)
				l_tmp___1 := fabs (a_result.item.val)
				a_result.item.err := 2.2204460492503131e-16 * (2.0 * l_tmp___1 + (fabs (a_lambda * a_x)))
				Result := 0
			end
		end

	gsl_sf_gegenpoly_n_e (a_n: INTEGER_32; a_lambda: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_z: REAL_64
			l_k: INTEGER_32
			l_g2: PD_GSL_SF_RESULT_STRUCT
			l_g3: PD_GSL_SF_RESULT_STRUCT
			l_stat_g2: INTEGER_32
			l_stat_g3: INTEGER_32
			l_stat_g: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_gkm2: REAL_64
			l_gkm1: REAL_64
			l_gk: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_g2.make
			create l_g3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_lambda <= -0.5) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 3 then -- else:
						if not (a_n < 0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L___1:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("gegenbauer.c"), 93, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 6 then -- else:
						if a_n /= 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						a_result.item.val := 1.0
						a_result.item.err := 0.0
						Result := 0
						js.return
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 9 then -- else:
						if a_n /= 1 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						Result := (gsl_sf_gegenpoly_1_e (a_lambda, a_x, a_result))
						js.return
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 12 then -- else:
						if a_n /= 2 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						Result := (gsl_sf_gegenpoly_2_e (a_lambda, a_x, a_result))
						js.return
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 15 then -- else:
						if a_n /= 3 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						Result := (gsl_sf_gegenpoly_3_e (a_lambda, a_x, a_result))
						js.return
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 18 then -- else:
						if a_lambda /= 0.0 then
							l_pos := -1 + 27 -- skip if block
						end
				when 19 then -- if:
						if not (a_x >= -1.0) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 23 -- goto _L___0
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 22 then -- else:
						if not (a_x <= 1.0) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if: | _L___0:
						l_z := a_n.to_double * (acos (a_x))
						a_result.item.val := (2.0 * (cos (l_z))) / a_n.to_double
						a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (l_z * a_result.item.val))
						Result := 0
						js.return
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else:
						l_pos := -1 + 27 -- goto _L
				when 26 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else: | _L:
						l_stat_g2 := (gsl_sf_gegenpoly_2_e (a_lambda, a_x, l_g2.address))
						l_stat_g3 := (gsl_sf_gegenpoly_3_e (a_lambda, a_x, l_g3.address))
						if l_stat_g2 /= 0 then
							l_tmp___10 := l_stat_g2
						else
							if l_stat_g3 /= 0 then
								l_tmp___9 := l_stat_g3
							else
								l_tmp___9 := 0
							end
							l_tmp___10 := l_tmp___9
						end
						l_stat_g := l_tmp___10
						l_gkm2 := l_g2.val
						l_gkm1 := l_g3.val
						l_gk := 0.0
						l_k := 4
						from
						until
							not (l_k <= a_n)
						loop
							l_gk := (((2.0 * ((l_k.to_double + a_lambda) - 1.0)) * a_x) * l_gkm1 - ((l_k.to_double + 2.0 * a_lambda) - 2.0) * l_gkm2) / l_k.to_double
							l_gkm2 := l_gkm1
							l_gkm1 := l_gk
							l_k := l_k + 1
						end
						a_result.item.val := l_gk
						a_result.item.err := (((2.0 * 2.2204460492503131e-16) * 0.5) * a_n.to_double) * (fabs (l_gk))
						Result := l_stat_g
						js.return
				when 28 then -- if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 29 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_gegenpoly_array (a_nmax: INTEGER_32; a_lambda: REAL_64; a_x: REAL_64; a_result_array: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_k: INTEGER_32
			l_term1: REAL_64
			l_term2: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_lambda <= -0.5) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (a_nmax < 0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("domain error"), ce_string ("gegenbauer.c"), 148, 1)
							Result := 1
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							a_result_array[0] := 1.0
							if a_nmax = 0 then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							if a_lambda = 0.0 then
								a_result_array[1] := 2.0 * a_x
							else
								a_result_array[1] := (2.0 * a_lambda) * a_x
							end
							l_k := 2
							from
							until
								not (l_k <= a_nmax)
							loop
								l_term1 := ((2.0 * ((l_k.to_double + a_lambda) - 1.0)) * a_x) * a_result_array[(l_k - 1)]
								l_term2 := ((l_k.to_double + 2.0 * a_lambda) - 2.0) * a_result_array[(l_k - 2)]
								a_result_array[l_k] := (l_term1 - l_term2) / l_k.to_double
								l_k := l_k + 1
							end
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_gegenpoly_1 (a_lambda: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_gegenpoly_1_e (a_lambda, a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_gegenpoly_1_e(lambda, x, &result)"), ce_string ("gegenbauer.c"), 178, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_gegenpoly_2 (a_lambda: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_gegenpoly_2_e (a_lambda, a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_gegenpoly_2_e(lambda, x, &result)"), ce_string ("gegenbauer.c"), 183, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_gegenpoly_3 (a_lambda: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_gegenpoly_3_e (a_lambda, a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_gegenpoly_3_e(lambda, x, &result)"), ce_string ("gegenbauer.c"), 188, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_gegenpoly_n (a_n: INTEGER_32; a_lambda: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_gegenpoly_n_e (a_n, a_lambda, a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_gegenpoly_n_e(n, lambda, x, &result)"), ce_string ("gegenbauer.c"), 193, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
