class
	P_GEN

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_eigen_gen_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE]
		local
			l_w: CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE]
			js: JUMP_STATE
		do
			create l_w.make

			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension must be positive integer"), ce_string ("gen.c"), 118, 4)
					Result := (create {CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_w.ce_gets (create {CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE]}.make_cast ((calloc ((1).to_natural_32, {PD_GSL_EIGEN_GEN_WORKSPACE}.sizeof.to_natural_32))))
				if (l_w.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for workspace"), ce_string ("gen.c"), 125, 8)
						Result := (create {CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_w.item.size := a_n
				l_w.item.max_iterations := {NATURAL_32} 30 * a_n
				l_w.item.n_evals := (0).to_natural_32
				l_w.item.n_iter := (0).to_natural_32
				l_w.item.needtop := 0
				l_w.item.atol := 0.0
				l_w.item.btol := 0.0
				l_w.item.ascale := 0.0
				l_w.item.bscale := 0.0
				l_w.item.eshift := 0.0
				l_w.item.H := create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
				l_w.item.R := create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
				l_w.item.compute_s := 0
				l_w.item.compute_t := 0
				l_w.item.Q := create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
				l_w.item.Z := create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
				l_w.item.work := init_source_inst.gsl_vector_alloc (a_n)
				if ((l_w.item.work).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					gsl_eigen_gen_free (l_w)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for additional workspace"), ce_string ("gen.c"), 150, 8)
						Result := (create {CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				Result := l_w
			end
		end

	gsl_eigen_gen_free (a_w: CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE])
		local
			js: JUMP_STATE
		do
			if (a_w).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				if ((a_w.item.work).c_pointer /= default_pointer) then
					init_source_inst.gsl_vector_free (a_w.item.work)
				end
				free (create {CE_POINTER [ANY]}.make_cast (a_w))
			end
		end

	gsl_eigen_gen_params (a_compute_s: INTEGER_32; a_compute_t: INTEGER_32; a_balance: INTEGER_32; a_w: CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE])
		do
			a_w.item.compute_s := a_compute_s
			a_w.item.compute_t := a_compute_t
		end

	gsl_eigen_gen (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_B: CE_POINTER [PD_GSL_MATRIX]; a_alpha: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_beta: CE_POINTER [PD_GSL_VECTOR]; a_w: CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE]): INTEGER_32
		local
			l_N: NATURAL_32
			l_anorm: REAL_64
			l_bnorm: REAL_64
			l_tmp: INTEGER_32
			l_tmp___0: REAL_64
			l_tmp___1: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_N := a_A___0.item.size1
					if l_N = a_A___0.item.size2 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix must be square to compute eigenvalues"), ce_string ("gen.c"), 220, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 3 then -- else:
						if l_N = a_B.item.size1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 6 then -- else:
						if l_N = a_B.item.size2 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("B matrix dimensions must match A"), ce_string ("gen.c"), 224, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 9 then -- else:
						if a_alpha.item.size = l_N then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 12 then -- else:
						if a_beta.item.size = l_N then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("eigenvalue vector must match matrix size"), ce_string ("gen.c"), 228, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						if a_w.item.size /= l_N then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("matrix size does not match workspace"), ce_string ("gen.c"), 232, 19)
								Result := 19
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						else
							hesstri_inst.gsl_linalg_hesstri_decomp (a_A___0, a_B, a_w.item.Q, a_w.item.Z, a_w.item.work).do_nothing
							a_w.item.H := a_A___0
							a_w.item.R := a_B
							a_w.item.n_evals := (0).to_natural_32
							a_w.item.n_iter := (0).to_natural_32
							a_w.item.eshift := 0.0
							if ((a_w.item.Q).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_tmp := 1
							elseif ((a_w.item.Z).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_tmp := 1
							elseif (a_w.item.compute_t).to_boolean then
								l_tmp := 1
							elseif (a_w.item.compute_s).to_boolean then
								l_tmp := 1
							else
								l_tmp := 0
							end
							a_w.item.needtop := l_tmp
							l_anorm := jacobi_inst.norm (a_A___0)
							l_bnorm := jacobi_inst.norm (a_B)
							if 2.2250738585072014e-308 > 2.2204460492503131e-16 * l_anorm then
								a_w.item.atol := 2.2250738585072014e-308
							else
								a_w.item.atol := 2.2204460492503131e-16 * l_anorm
							end
							if 2.2250738585072014e-308 > 2.2204460492503131e-16 * l_bnorm then
								a_w.item.btol := 2.2250738585072014e-308
							else
								a_w.item.btol := 2.2204460492503131e-16 * l_bnorm
							end
							if 2.2250738585072014e-308 > l_anorm then
								l_tmp___0 := 2.2250738585072014e-308
							else
								l_tmp___0 := l_anorm
							end
							a_w.item.ascale := 1.0 / l_tmp___0
							if 2.2250738585072014e-308 > l_bnorm then
								l_tmp___1 := 2.2250738585072014e-308
							else
								l_tmp___1 := l_bnorm
							end
							a_w.item.bscale := 1.0 / l_tmp___1
							gen_schur_decomp (a_A___0, a_B, a_alpha, a_beta, a_w)
							if a_w.item.n_evals /= l_N then
								Result := 11
								js.return
							end
							if not js.return_called then
								Result := 0
								js.return
							end
						end
				when 16 then -- if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 17 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_eigen_gen_QZ (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_B: CE_POINTER [PD_GSL_MATRIX]; a_alpha: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_beta: CE_POINTER [PD_GSL_VECTOR]; a_Q___1: CE_POINTER [PD_GSL_MATRIX]; a_Z: CE_POINTER [PD_GSL_MATRIX]; a_w: CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE]): INTEGER_32
		local
			l_s: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_Q___1).c_pointer = default_pointer then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if a_A___0.item.size1 = a_Q___1.item.size1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L___2
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if a_A___0.item.size1 = a_Q___1.item.size2 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L___2:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("Q matrix has wrong dimensions"), ce_string ("gen.c"), 306, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_pos := -1 + 9 -- goto _L___1
				when 8 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 19
				when 9 then -- else: | _L___1:
						if (a_Z).c_pointer = default_pointer then
							l_pos := -1 + 18 -- skip if block
						end
				when 10 then -- if:
						if a_A___0.item.size1 = a_Z.item.size1 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L___0
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 13 then -- else:
						if a_A___0.item.size1 = a_Z.item.size2 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("Z matrix has wrong dimensions"), ce_string ("gen.c"), 310, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						l_pos := -1 + 18 -- goto _L
				when 17 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L:
						a_w.item.Q := a_Q___1
						a_w.item.Z := a_Z
						l_s := gsl_eigen_gen (a_A___0, a_B, a_alpha, a_beta, a_w)
						a_w.item.Q := create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
						a_w.item.Z := create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
						Result := l_s
						js.return
				when 19 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 20 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gen_schur_decomp (a_H: CE_POINTER [PD_GSL_MATRIX]; a_R: CE_POINTER [PD_GSL_MATRIX]; a_alpha: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_beta: CE_POINTER [PD_GSL_VECTOR]; a_w: CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE])
		local
			l_N: NATURAL_32
			l_h: PD_GSL_MATRIX_VIEW
			l_r___3: PD_GSL_MATRIX_VIEW
			l_vh: PD_GSL_MATRIX_VIEW
			l_vr: PD_GSL_MATRIX_VIEW
			l_q___3: NATURAL_32
			l_z1: PD_GSL_COMPLEX
			l_z2: PD_GSL_COMPLEX
			l_a___5: REAL_64
			l_b___0: REAL_64
			l_s: INTEGER_32
			l_flag: INTEGER_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_h.make
			create l_r___3.make
			create l_vh.make
			create l_vr.make
			create l_z1.make
			create l_z2.make

			l_N := a_H.item.size1
			l_h.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_H, (0).to_natural_32, (0).to_natural_32, l_N, l_N))
			l_r___3.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_R, (0).to_natural_32, (0).to_natural_32, l_N, l_N))
			from
			until
				js.loop_left
			loop
				js.reset
				if l_N > {NATURAL_32} 1 then
					l_tmp := a_w.item.n_iter
					a_w.item.n_iter := (a_w.item.n_iter) + 1
					if not (l_tmp < a_w.item.max_iterations) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_q___3 := gen_search_small_elements (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_h.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_r___3.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), create {CE_POINTER [INTEGER_32]}.make_shared ($l_flag), a_w)
					if l_flag = 0 then
						l_s := gen_qzstep (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_h.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_r___3.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), a_w)
						if l_s = -2 then
							l_s := gen_schur_standardize2 (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_h.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_r___3.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), l_z1.address, l_z2.address, create {CE_POINTER [REAL_64]}.make_shared ($l_a___5), create {CE_POINTER [REAL_64]}.make_shared ($l_b___0), a_w)
							if l_s /= 0 then
								js.continue
							end
							if not js.loop_jumped then
								gen_store_eigval2 ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_h.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), (l_z1.address), l_a___5, (l_z2.address), l_b___0, a_alpha, a_beta, a_w)
								l_N := (0).to_natural_32
							end
						end
						if not js.loop_jumped then
							js.continue
						end
					elseif l_flag = 2 then
						if l_q___3 = {NATURAL_32} 0 then
							gen_tri_split_top (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_h.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_r___3.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), a_w)
						else
							if l_q___3 /= l_N - {NATURAL_32} 1 then
								gen_tri_chase_zero (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_h.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_r___3.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), l_q___3, a_w)
							end
							gen_tri_zero_H (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_h.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_r___3.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), a_w)
						end
						js.continue
					end
				end
				if not js.loop_jumped then
					if l_q___3 = l_N - {NATURAL_32} 1 then
						l_vh.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_h.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), l_q___3, l_q___3, (1).to_natural_32, (1).to_natural_32))
						l_vr.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_r___3.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), l_q___3, l_q___3, (1).to_natural_32, (1).to_natural_32))
						gen_schur_standardize1 (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vh.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vr.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), create {CE_POINTER [REAL_64]}.make_shared ($l_a___5), create {CE_POINTER [REAL_64]}.make_shared ($l_b___0), a_w).do_nothing
						gen_store_eigval1 ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vh.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), l_a___5, l_b___0, a_alpha, a_beta, a_w)
						l_N := l_N - 1
						l_h.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_h.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), (0).to_natural_32, (0).to_natural_32, l_N, l_N))
						l_r___3.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_r___3.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), (0).to_natural_32, (0).to_natural_32, l_N, l_N))
					elseif l_q___3 = l_N - {NATURAL_32} 2 then
						l_vh.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_h.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), l_q___3, l_q___3, (2).to_natural_32, (2).to_natural_32))
						l_vr.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_r___3.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), l_q___3, l_q___3, (2).to_natural_32, (2).to_natural_32))
						l_s := gen_schur_standardize2 (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vh.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vr.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), l_z1.address, l_z2.address, create {CE_POINTER [REAL_64]}.make_shared ($l_a___5), create {CE_POINTER [REAL_64]}.make_shared ($l_b___0), a_w)
						if l_s /= 0 then
							gen_schur_decomp (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vh.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vr.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), a_alpha, a_beta, a_w)
						else
							gen_store_eigval2 ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vh.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), (l_z1.address), l_a___5, (l_z2.address), l_b___0, a_alpha, a_beta, a_w)
						end
						l_N := l_N - ({NATURAL_32} 2)
						l_h.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_h.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), (0).to_natural_32, (0).to_natural_32, l_N, l_N))
						l_r___3.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_r___3.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), (0).to_natural_32, (0).to_natural_32, l_N, l_N))
					elseif l_q___3 = {NATURAL_32} 1 then
						l_vh.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_h.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), (0).to_natural_32, (0).to_natural_32, (1).to_natural_32, (1).to_natural_32))
						l_vr.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_r___3.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), (0).to_natural_32, (0).to_natural_32, (1).to_natural_32, (1).to_natural_32))
						gen_schur_standardize1 (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vh.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vr.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), create {CE_POINTER [REAL_64]}.make_shared ($l_a___5), create {CE_POINTER [REAL_64]}.make_shared ($l_b___0), a_w).do_nothing
						gen_store_eigval1 ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vh.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), l_a___5, l_b___0, a_alpha, a_beta, a_w)
						l_N := l_N - 1
						l_h.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_h.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), (1).to_natural_32, (1).to_natural_32, l_N, l_N))
						l_r___3.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_r___3.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), (1).to_natural_32, (1).to_natural_32, l_N, l_N))
					elseif l_q___3 = {NATURAL_32} 2 then
						l_vh.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_h.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), (0).to_natural_32, (0).to_natural_32, (2).to_natural_32, (2).to_natural_32))
						l_vr.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_r___3.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), (0).to_natural_32, (0).to_natural_32, (2).to_natural_32, (2).to_natural_32))
						l_s := gen_schur_standardize2 (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vh.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vr.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), l_z1.address, l_z2.address, create {CE_POINTER [REAL_64]}.make_shared ($l_a___5), create {CE_POINTER [REAL_64]}.make_shared ($l_b___0), a_w)
						if l_s /= 0 then
							gen_schur_decomp (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vh.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vr.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), a_alpha, a_beta, a_w)
						else
							gen_store_eigval2 ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vh.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), (l_z1.address), l_a___5, (l_z2.address), l_b___0, a_alpha, a_beta, a_w)
						end
						l_N := l_N - ({NATURAL_32} 2)
						l_h.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_h.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), (2).to_natural_32, (2).to_natural_32, l_N, l_N))
						l_r___3.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_r___3.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), (2).to_natural_32, (2).to_natural_32, l_N, l_N))
					else
						l_vh.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_h.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), l_q___3, l_q___3, l_N - l_q___3, l_N - l_q___3))
						l_vr.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_r___3.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), l_q___3, l_q___3, l_N - l_q___3, l_N - l_q___3))
						gen_schur_decomp (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vh.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vr.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), a_alpha, a_beta, a_w)
						l_vh.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_h.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), (0).to_natural_32, (0).to_natural_32, l_q___3, l_q___3))
						l_vr.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_r___3.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), (0).to_natural_32, (0).to_natural_32, l_q___3, l_q___3))
						gen_schur_decomp (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vh.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vr.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), a_alpha, a_beta, a_w)
						l_N := (0).to_natural_32
					end
				end
			end
			js.reset
			if l_N = {NATURAL_32} 1 then
				gen_schur_standardize1 (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_h.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_r___3.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), create {CE_POINTER [REAL_64]}.make_shared ($l_a___5), create {CE_POINTER [REAL_64]}.make_shared ($l_b___0), a_w).do_nothing
				gen_store_eigval1 ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_h.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), l_a___5, l_b___0, a_alpha, a_beta, a_w)
			end
		end

	gen_qzstep (a_H: CE_POINTER [PD_GSL_MATRIX]; a_R: CE_POINTER [PD_GSL_MATRIX]; a_w: CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE]): INTEGER_32
		local
			l_N: NATURAL_32
			l_vh: PD_GSL_MATRIX_VIEW
			l_vr: PD_GSL_MATRIX_VIEW
			l_wr1: REAL_64
			l_wr2: REAL_64
			l_wi: REAL_64
			l_scale1: REAL_64
			l_scale2: REAL_64
			l_scale: REAL_64
			l_cs: REAL_64
			l_sn: REAL_64
			l_temp: REAL_64
			l_temp2: REAL_64
			l_j: NATURAL_32
			l_xv: PD_GSL_VECTOR_VIEW
			l_yv: PD_GSL_VECTOR_VIEW
			l_top: NATURAL_32
			l_rows: NATURAL_32
			l_tmp: REAL_64
			l_tmp___2: REAL_64
			l_tmp___5: REAL_64
			l_tmp___8: REAL_64
			l_tmp___11: REAL_64
			l_tmp___12: REAL_64
			l_tmp___17: REAL_64
			l_tmp___20: REAL_64
			js: JUMP_STATE
		do
			create l_vh.make
			create l_vr.make
			create l_xv.make
			create l_yv.make

			l_N := a_H.item.size1
			if a_w.item.n_iter \\ {NATURAL_32} 10 = {NATURAL_32} 0 then
				l_tmp___2 := fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_N - {NATURAL_32} 2, l_N - {NATURAL_32} 1)))
				if (2.2250738585072014e-308 * (a_w.item.max_iterations).to_real_64) * l_tmp___2 < (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_N - {NATURAL_32} 2, l_N - {NATURAL_32} 2)))) then
					l_tmp := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_N - {NATURAL_32} 2, l_N - {NATURAL_32} 1)
					a_w.item.eshift := a_w.item.eshift + (l_tmp / (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_N - {NATURAL_32} 2, l_N - {NATURAL_32} 2)))
				else
					a_w.item.eshift := a_w.item.eshift + (1.0 / (2.2250738585072014e-308 * (a_w.item.max_iterations).to_real_64))
				end
				if a_w.item.eshift < 2.2204460492503131e-16 then
					l_tmp___8 := fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_N - {NATURAL_32} 1, l_N - {NATURAL_32} 2)))
					if (2.2250738585072014e-308 * (a_w.item.max_iterations).to_real_64) * l_tmp___8 < (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_N - {NATURAL_32} 2, l_N - {NATURAL_32} 2)))) then
						l_tmp___5 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_N - {NATURAL_32} 1, l_N - {NATURAL_32} 2)
						a_w.item.eshift := (1.736 * (a_w.item.ascale * l_tmp___5)) / (a_w.item.bscale * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_N - {NATURAL_32} 2, l_N - {NATURAL_32} 2)))
					end
				end
				l_scale1 := 1.0
				l_wr1 := a_w.item.eshift
			else
				l_vh.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_H, l_N - {NATURAL_32} 2, l_N - {NATURAL_32} 2, (2).to_natural_32, (2).to_natural_32))
				l_vr.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_R, l_N - {NATURAL_32} 2, l_N - {NATURAL_32} 2, (2).to_natural_32, (2).to_natural_32))
				schur_inst.gsl_schur_gen_eigvals ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vh.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vr.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), create {CE_POINTER [REAL_64]}.make_shared ($l_wr1), create {CE_POINTER [REAL_64]}.make_shared ($l_wr2), create {CE_POINTER [REAL_64]}.make_shared ($l_wi), create {CE_POINTER [REAL_64]}.make_shared ($l_scale1), create {CE_POINTER [REAL_64]}.make_shared ($l_scale2)).do_nothing
				if l_wi /= 0.0 then
					if l_N = {NATURAL_32} 2 then
						Result := (-2)
						js.return
					else
						gen_qzstep_d (a_H, a_R, a_w)
					end
					if not js.return_called then
						Result := 0
						js.return
					end
				end
			end
			if not js.return_called then
				if a_w.item.ascale < 1.0 then
					l_tmp___11 := a_w.item.ascale
				else
					l_tmp___11 := 1.0
				end
				l_temp := l_tmp___11 * (0.5 / 2.2250738585072014e-308)
				if l_scale1 > l_temp then
					l_scale := l_temp / l_scale1
				else
					l_scale := 1.0
				end
				if a_w.item.bscale < 1.0 then
					l_tmp___12 := a_w.item.bscale
				else
					l_tmp___12 := 1.0
				end
				l_temp := l_tmp___12 * (0.5 / 2.2250738585072014e-308)
				if (fabs (l_wr1)) > l_temp then
					if l_scale < l_temp / (fabs (l_wr1)) then
						l_scale := l_scale
					else
						l_scale := l_temp / (fabs (l_wr1))
					end
				end
				l_scale1 := l_scale1 * l_scale
				l_wr1 := l_wr1 * l_scale
				if (a_w.item.needtop).to_boolean then
					l_top := gen_get_submatrix (a_w.item.H, a_H)
				end
				l_tmp___17 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, (0).to_natural_32, (0).to_natural_32)
				l_temp := l_scale1 * l_tmp___17 - l_wr1 * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, (0).to_natural_32, (0).to_natural_32))
				l_temp2 := l_scale1 * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, (1).to_natural_32, (0).to_natural_32))
				qrstep_inst.create_givens (l_temp, l_temp2, create {CE_POINTER [REAL_64]}.make_shared ($l_cs), create {CE_POINTER [REAL_64]}.make_shared ($l_sn))
				l_sn := -l_sn
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_N - {NATURAL_32} 1)
				loop
					if l_j > {NATURAL_32} 0 then
						l_temp := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_j, l_j - {NATURAL_32} 1)
						l_temp2 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_j + {NATURAL_32} 1, l_j - {NATURAL_32} 1)
						qrstep_inst.create_givens (l_temp, l_temp2, create {CE_POINTER [REAL_64]}.make_shared ($l_cs), create {CE_POINTER [REAL_64]}.make_shared ($l_sn))
						l_sn := -l_sn
						l_tmp___20 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_j, l_j - {NATURAL_32} 1)
						l_temp := l_cs * l_tmp___20 + l_sn * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_j + {NATURAL_32} 1, l_j - {NATURAL_32} 1))
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_H, l_j, l_j - {NATURAL_32} 1, l_temp)
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_H, l_j + {NATURAL_32} 1, l_j - {NATURAL_32} 1, 0.0)
					end
					if (a_w.item.compute_s).to_boolean then
						l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_w.item.H, l_top + l_j, l_top + l_j, (a_w.item.size - l_top) - l_j))
						l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_w.item.H, (l_top + l_j) + {NATURAL_32} 1, l_top + l_j, (a_w.item.size - l_top) - l_j))
					else
						l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_H, l_j, l_j, l_N - l_j))
						l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_H, l_j + {NATURAL_32} 1, l_j, l_N - l_j))
					end
					blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
					if (a_w.item.compute_t).to_boolean then
						l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_w.item.R, l_top + l_j, l_top + l_j, (a_w.item.size - l_top) - l_j))
						l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_w.item.R, (l_top + l_j) + {NATURAL_32} 1, l_top + l_j, (a_w.item.size - l_top) - l_j))
					else
						l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_R, l_j, l_j, l_N - l_j))
						l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_R, l_j + {NATURAL_32} 1, l_j, l_N - l_j))
					end
					blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
					if ((a_w.item.Q).c_pointer /= default_pointer) then
						l_xv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_w.item.Q, l_top + l_j))
						l_yv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_w.item.Q, (l_top + l_j) + {NATURAL_32} 1))
						blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
					end
					l_temp := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_j + {NATURAL_32} 1, l_j + {NATURAL_32} 1)
					l_temp2 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_j + {NATURAL_32} 1, l_j)
					qrstep_inst.create_givens (l_temp, l_temp2, create {CE_POINTER [REAL_64]}.make_shared ($l_cs), create {CE_POINTER [REAL_64]}.make_shared ($l_sn))
					if l_j + {NATURAL_32} 3 < l_N then
						l_rows := l_j + {NATURAL_32} 3
					else
						l_rows := l_N
					end
					if (a_w.item.compute_s).to_boolean then
						l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_w.item.H, l_top + l_j, (0).to_natural_32, l_top + l_rows))
						l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_w.item.H, (l_top + l_j) + {NATURAL_32} 1, (0).to_natural_32, l_top + l_rows))
					else
						l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_H, l_j, (0).to_natural_32, l_rows))
						l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_H, l_j + {NATURAL_32} 1, (0).to_natural_32, l_rows))
					end
					blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
					if l_j + {NATURAL_32} 2 < l_N then
						l_rows := l_j + {NATURAL_32} 2
					else
						l_rows := l_N
					end
					if (a_w.item.compute_t).to_boolean then
						l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_w.item.R, l_top + l_j, (0).to_natural_32, l_top + l_rows))
						l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_w.item.R, (l_top + l_j) + {NATURAL_32} 1, (0).to_natural_32, l_top + l_rows))
					else
						l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_R, l_j, (0).to_natural_32, l_rows))
						l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_R, l_j + {NATURAL_32} 1, (0).to_natural_32, l_rows))
					end
					blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
					if ((a_w.item.Z).c_pointer /= default_pointer) then
						l_xv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_w.item.Z, l_top + l_j))
						l_yv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_w.item.Z, (l_top + l_j) + {NATURAL_32} 1))
						blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gen_qzstep_d (a_H: CE_POINTER [PD_GSL_MATRIX]; a_R: CE_POINTER [PD_GSL_MATRIX]; a_w: CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE])
		local
			l_N: NATURAL_32
			l_j: NATURAL_32
			l_dat: CE_ARRAY [REAL_64]
			l_tau: REAL_64
			l_v2: PD_GSL_VECTOR_VIEW
			l_v3: PD_GSL_VECTOR_VIEW
			l_m___4: PD_GSL_MATRIX_VIEW
			l_tmp: REAL_64
			l_q___3: NATURAL_32
			l_r___3: NATURAL_32
			l_top: NATURAL_32
			l_scale: REAL_64
			l_AB11: REAL_64
			l_AB22: REAL_64
			l_ABNN: REAL_64
			l_ABMM: REAL_64
			l_AMNBNN: REAL_64
			l_ANMBMM: REAL_64
			l_A21B11: REAL_64
			l_A12B22: REAL_64
			l_A32B22: REAL_64
			l_B12B22: REAL_64
			l_BMNBNN: REAL_64
			l_tmp___0: REAL_64
			l_tmp___2: REAL_64
			l_tmp___4: REAL_64
			l_tmp___6: REAL_64
			l_tmp___8: REAL_64
			l_tmp___10: REAL_64
			l_tmp___12: REAL_64
			l_tmp___14: REAL_64
			l_tmp___16: REAL_64
			l_tmp___18: REAL_64
			l_tmp___20: REAL_64
			l_tmp___22: REAL_64
			l_tmp___23: REAL_64
			l_tmp___25: INTEGER_32
			l_tmp___26: REAL_64
			l_tmp___27: REAL_64
			l_tmp___30: REAL_64
			l_tmp___32: REAL_64
			l_tmp___33: REAL_64
			l_tmp___35: REAL_64
			l_tmp___37: REAL_64
		do
			create l_dat.make (<<3>>)
			create l_v2.make
			create l_v3.make
			create l_m___4.make

			l_N := a_H.item.size1
			l_v2.ce_gets (view_source_inst.gsl_vector_view_array (l_dat, (2).to_natural_32))
			l_v3.ce_gets (view_source_inst.gsl_vector_view_array (l_dat, (3).to_natural_32))
			if (a_w.item.needtop).to_boolean then
				l_top := gen_get_submatrix (a_w.item.H, a_H)
			end
			l_tmp___0 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_N - {NATURAL_32} 2, l_N - {NATURAL_32} 2)
			l_ABMM := (a_w.item.ascale * l_tmp___0) / (a_w.item.bscale * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_N - {NATURAL_32} 2, l_N - {NATURAL_32} 2)))
			l_tmp___2 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_N - {NATURAL_32} 1, l_N - {NATURAL_32} 1)
			l_ABNN := (a_w.item.ascale * l_tmp___2) / (a_w.item.bscale * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_N - {NATURAL_32} 1, l_N - {NATURAL_32} 1)))
			l_tmp___4 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, (0).to_natural_32, (0).to_natural_32)
			l_AB11 := (a_w.item.ascale * l_tmp___4) / (a_w.item.bscale * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, (0).to_natural_32, (0).to_natural_32)))
			l_tmp___6 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, (1).to_natural_32, (1).to_natural_32)
			l_AB22 := (a_w.item.ascale * l_tmp___6) / (a_w.item.bscale * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, (1).to_natural_32, (1).to_natural_32)))
			l_tmp___8 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_N - {NATURAL_32} 2, l_N - {NATURAL_32} 1)
			l_AMNBNN := (a_w.item.ascale * l_tmp___8) / (a_w.item.bscale * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_N - {NATURAL_32} 1, l_N - {NATURAL_32} 1)))
			l_tmp___10 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_N - {NATURAL_32} 1, l_N - {NATURAL_32} 2)
			l_ANMBMM := (a_w.item.ascale * l_tmp___10) / (a_w.item.bscale * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_N - {NATURAL_32} 2, l_N - {NATURAL_32} 2)))
			l_tmp___12 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_N - {NATURAL_32} 2, l_N - {NATURAL_32} 1)
			l_BMNBNN := l_tmp___12 / (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_N - {NATURAL_32} 1, l_N - {NATURAL_32} 1))
			l_tmp___14 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, (1).to_natural_32, (0).to_natural_32)
			l_A21B11 := (a_w.item.ascale * l_tmp___14) / (a_w.item.bscale * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, (0).to_natural_32, (0).to_natural_32)))
			l_tmp___16 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, (0).to_natural_32, (1).to_natural_32)
			l_A12B22 := (a_w.item.ascale * l_tmp___16) / (a_w.item.bscale * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, (1).to_natural_32, (1).to_natural_32)))
			l_tmp___18 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, (2).to_natural_32, (1).to_natural_32)
			l_A32B22 := (a_w.item.ascale * l_tmp___18) / (a_w.item.bscale * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, (1).to_natural_32, (1).to_natural_32)))
			l_tmp___20 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, (0).to_natural_32, (1).to_natural_32)
			l_B12B22 := l_tmp___20 / (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, (1).to_natural_32, (1).to_natural_32))
			l_dat[0] := (((l_ABMM - l_AB11) * (l_ABNN - l_AB11) - l_AMNBNN * l_ANMBMM) + (l_ANMBMM * l_BMNBNN) * l_AB11) + (l_A12B22 - l_AB11 * l_B12B22) * l_A21B11
			l_dat[1] := (((((l_AB22 - l_AB11) - l_A21B11 * l_B12B22) - (l_ABMM - l_AB11)) - (l_ABNN - l_AB11)) + l_ANMBMM * l_BMNBNN) * l_A21B11
			l_dat[2] := l_A32B22 * l_A21B11
			l_tmp___22 := fabs (l_dat[0])
			l_tmp___23 := fabs (l_dat[1])
			l_scale := (l_tmp___22 + l_tmp___23) + (fabs (l_dat[2]))
			if l_scale /= 0.0 then
				l_dat[0] := l_dat[0] / l_scale
				l_dat[1] := l_dat[1] / l_scale
				l_dat[2] := l_dat[2] / l_scale
			end
			l_j := (0).to_natural_32
			from
			until
				not (l_j < l_N - {NATURAL_32} 2)
			loop
				if l_j + {NATURAL_32} 4 < l_N then
					l_r___3 := l_j + {NATURAL_32} 4
				else
					l_r___3 := l_N
				end
				l_tau := householder_inst.gsl_linalg_householder_transform (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))
				if l_tau /= 0.0 then
					if 0 > l_j.to_integer_32 - 1 then
						l_tmp___25 := 0
					else
						l_tmp___25 := l_j.to_integer_32 - 1
					end
					l_q___3 := l_tmp___25.to_natural_32
					if (a_w.item.compute_s).to_boolean then
						l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_w.item.H, l_top + l_j, l_top + l_q___3, (3).to_natural_32, (a_w.item.size - l_top) - l_q___3))
						householder_inst.gsl_linalg_householder_hm (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
					else
						l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_H, l_j, l_q___3, (3).to_natural_32, l_N - l_q___3))
						householder_inst.gsl_linalg_householder_hm (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
					end
					if (a_w.item.compute_t).to_boolean then
						l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_w.item.R, l_top + l_j, l_top + l_j, (3).to_natural_32, (a_w.item.size - l_top) - l_j))
						householder_inst.gsl_linalg_householder_hm (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
					else
						l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_R, l_j, l_j, (3).to_natural_32, l_N - l_j))
						householder_inst.gsl_linalg_householder_hm (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
					end
					if ((a_w.item.Q).c_pointer /= default_pointer) then
						l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_w.item.Q, (0).to_natural_32, l_top + l_j, a_w.item.size, (3).to_natural_32))
						householder_inst.gsl_linalg_householder_mh (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
					end
				end
				l_dat[0] := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_j + {NATURAL_32} 2, l_j + {NATURAL_32} 2)
				l_dat[1] := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_j + {NATURAL_32} 2, l_j)
				l_dat[2] := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_j + {NATURAL_32} 2, l_j + {NATURAL_32} 1)
				l_tmp___26 := fabs (l_dat[0])
				l_tmp___27 := fabs (l_dat[1])
				l_scale := (l_tmp___26 + l_tmp___27) + (fabs (l_dat[2]))
				if l_scale /= 0.0 then
					l_dat[0] := l_dat[0] / l_scale
					l_dat[1] := l_dat[1] / l_scale
					l_dat[2] := l_dat[2] / l_scale
				end
				l_tau := householder_inst.gsl_linalg_householder_transform (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))
				if l_tau /= 0.0 then
					l_tmp := gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), (1).to_natural_32)
					gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), (1).to_natural_32, (gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), (2).to_natural_32)) / l_tmp)
					gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), (2).to_natural_32, 1.0 / l_tmp)
					l_tau := l_tau * (l_tmp * l_tmp)
					if (a_w.item.compute_s).to_boolean then
						l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_w.item.H, (0).to_natural_32, l_top + l_j, l_top + l_r___3, (3).to_natural_32))
						householder_inst.gsl_linalg_householder_mh (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
					else
						l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_H, (0).to_natural_32, l_j, l_r___3, (3).to_natural_32))
						householder_inst.gsl_linalg_householder_mh (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
					end
					if (a_w.item.compute_t).to_boolean then
						l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_w.item.R, (0).to_natural_32, l_top + l_j, (l_top + l_j) + {NATURAL_32} 3, (3).to_natural_32))
						householder_inst.gsl_linalg_householder_mh (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
					else
						l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_R, (0).to_natural_32, l_j, l_j + {NATURAL_32} 3, (3).to_natural_32))
						householder_inst.gsl_linalg_householder_mh (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
					end
					if ((a_w.item.Z).c_pointer /= default_pointer) then
						l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_w.item.Z, (0).to_natural_32, l_top + l_j, a_w.item.size, (3).to_natural_32))
						householder_inst.gsl_linalg_householder_mh (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
					end
				end
				l_dat[0] := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_j + {NATURAL_32} 1, l_j + {NATURAL_32} 1)
				l_dat[1] := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_j + {NATURAL_32} 1, l_j)
				l_tmp___30 := fabs (l_dat[0])
				l_scale := l_tmp___30 + (fabs (l_dat[1]))
				if l_scale /= 0.0 then
					l_dat[0] := l_dat[0] / l_scale
					l_dat[1] := l_dat[1] / l_scale
				end
				l_tau := householder_inst.gsl_linalg_householder_transform (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))
				if l_tau /= 0.0 then
					l_tmp := gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), (1).to_natural_32)
					gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), (1).to_natural_32, 1.0 / l_tmp)
					l_tau := l_tau * (l_tmp * l_tmp)
					if (a_w.item.compute_s).to_boolean then
						l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_w.item.H, (0).to_natural_32, l_top + l_j, l_top + l_r___3, (2).to_natural_32))
						householder_inst.gsl_linalg_householder_mh (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
					else
						l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_H, (0).to_natural_32, l_j, l_r___3, (2).to_natural_32))
						householder_inst.gsl_linalg_householder_mh (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
					end
					if (a_w.item.compute_t).to_boolean then
						l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_w.item.R, (0).to_natural_32, l_top + l_j, (l_top + l_j) + {NATURAL_32} 3, (2).to_natural_32))
						householder_inst.gsl_linalg_householder_mh (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
					else
						l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_R, (0).to_natural_32, l_j, l_j + {NATURAL_32} 3, (2).to_natural_32))
						householder_inst.gsl_linalg_householder_mh (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
					end
					if ((a_w.item.Z).c_pointer /= default_pointer) then
						l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_w.item.Z, (0).to_natural_32, l_top + l_j, a_w.item.size, (2).to_natural_32))
						householder_inst.gsl_linalg_householder_mh (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
					end
				end
				l_dat[0] := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_j + {NATURAL_32} 1, l_j)
				l_dat[1] := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_j + {NATURAL_32} 2, l_j)
				if l_j < l_N - {NATURAL_32} 3 then
					l_dat[2] := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_j + {NATURAL_32} 3, l_j)
				end
				l_tmp___32 := fabs (l_dat[0])
				l_tmp___33 := fabs (l_dat[1])
				l_scale := (l_tmp___32 + l_tmp___33) + (fabs (l_dat[2]))
				if l_scale /= 0.0 then
					l_dat[0] := l_dat[0] / l_scale
					l_dat[1] := l_dat[1] / l_scale
					l_dat[2] := l_dat[2] / l_scale
				end
				l_j := l_j + 1
			end
			l_tmp___35 := fabs (l_dat[0])
			l_scale := l_tmp___35 + (fabs (l_dat[1]))
			if l_scale /= 0.0 then
				l_dat[0] := l_dat[0] / l_scale
				l_dat[1] := l_dat[1] / l_scale
			end
			l_tau := householder_inst.gsl_linalg_householder_transform (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))
			if (a_w.item.compute_s).to_boolean then
				l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_w.item.H, (l_top + l_N) - {NATURAL_32} 2, (l_top + l_N) - {NATURAL_32} 3, (2).to_natural_32, ((a_w.item.size - l_top) - l_N) + {NATURAL_32} 3))
				householder_inst.gsl_linalg_householder_hm (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
			else
				l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_H, l_N - {NATURAL_32} 2, l_N - {NATURAL_32} 3, (2).to_natural_32, (3).to_natural_32))
				householder_inst.gsl_linalg_householder_hm (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
			end
			if (a_w.item.compute_t).to_boolean then
				l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_w.item.R, (l_top + l_N) - {NATURAL_32} 2, (l_top + l_N) - {NATURAL_32} 2, (2).to_natural_32, ((a_w.item.size - l_top) - l_N) + {NATURAL_32} 2))
				householder_inst.gsl_linalg_householder_hm (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
			else
				l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_R, l_N - {NATURAL_32} 2, l_N - {NATURAL_32} 2, (2).to_natural_32, (2).to_natural_32))
				householder_inst.gsl_linalg_householder_hm (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
			end
			if ((a_w.item.Q).c_pointer /= default_pointer) then
				l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_w.item.Q, (0).to_natural_32, (l_top + l_N) - {NATURAL_32} 2, a_w.item.size, (2).to_natural_32))
				householder_inst.gsl_linalg_householder_mh (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
			end
			l_dat[0] := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_N - {NATURAL_32} 1, l_N - {NATURAL_32} 1)
			l_dat[1] := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_N - {NATURAL_32} 1, l_N - {NATURAL_32} 2)
			l_tmp___37 := fabs (l_dat[0])
			l_scale := l_tmp___37 + (fabs (l_dat[1]))
			if l_scale /= 0.0 then
				l_dat[0] := l_dat[0] / l_scale
				l_dat[1] := l_dat[1] / l_scale
			end
			l_tau := householder_inst.gsl_linalg_householder_transform (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))
			l_tmp := gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), (1).to_natural_32)
			gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), (1).to_natural_32, 1.0 / l_tmp)
			l_tau := l_tau * (l_tmp * l_tmp)
			if (a_w.item.compute_s).to_boolean then
				l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_w.item.H, (0).to_natural_32, (l_top + l_N) - {NATURAL_32} 2, l_top + l_N, (2).to_natural_32))
				householder_inst.gsl_linalg_householder_mh (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
			else
				l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_H, (0).to_natural_32, l_N - {NATURAL_32} 2, l_N, (2).to_natural_32))
				householder_inst.gsl_linalg_householder_mh (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
			end
			if (a_w.item.compute_t).to_boolean then
				l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_w.item.R, (0).to_natural_32, (l_top + l_N) - {NATURAL_32} 2, l_top + l_N, (2).to_natural_32))
				householder_inst.gsl_linalg_householder_mh (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
			else
				l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_R, (0).to_natural_32, l_N - {NATURAL_32} 2, l_N, (2).to_natural_32))
				householder_inst.gsl_linalg_householder_mh (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
			end
			if ((a_w.item.Z).c_pointer /= default_pointer) then
				l_m___4.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_w.item.Z, (0).to_natural_32, (l_top + l_N) - {NATURAL_32} 2, a_w.item.size, (2).to_natural_32))
				householder_inst.gsl_linalg_householder_mh (l_tau, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
			end
		end

	gen_tri_split_top (a_H: CE_POINTER [PD_GSL_MATRIX]; a_R: CE_POINTER [PD_GSL_MATRIX]; a_w: CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE])
		local
			l_N: NATURAL_32
			l_j: NATURAL_32
			l_top: NATURAL_32
			l_cs: REAL_64
			l_sn: REAL_64
			l_xv: PD_GSL_VECTOR_VIEW
			l_yv: PD_GSL_VECTOR_VIEW
			l_tmp: REAL_64
		do
			create l_xv.make
			create l_yv.make

			l_N := a_H.item.size1
			if (a_w.item.needtop).to_boolean then
				l_top := gen_get_submatrix (a_w.item.H, a_H)
			end
			l_j := (0).to_natural_32
			l_tmp := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_j + {NATURAL_32} 1, l_j)
			qrstep_inst.create_givens ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_j, l_j)), l_tmp, create {CE_POINTER [REAL_64]}.make_shared ($l_cs), create {CE_POINTER [REAL_64]}.make_shared ($l_sn))
			l_sn := -l_sn
			if (a_w.item.compute_s).to_boolean then
				l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_w.item.H, l_top + l_j, l_top, a_w.item.size - l_top))
				l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_w.item.H, (l_top + l_j) + {NATURAL_32} 1, l_top, a_w.item.size - l_top))
			else
				l_xv.ce_gets (rowcol_source_inst.gsl_matrix_row (a_H, l_j))
				l_yv.ce_gets (rowcol_source_inst.gsl_matrix_row (a_H, l_j + {NATURAL_32} 1))
			end
			blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
			gsl_gsl_matrix_double_inst.gsl_matrix_set (a_H, l_j + {NATURAL_32} 1, l_j, 0.0)
			if (a_w.item.compute_t).to_boolean then
				l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_w.item.R, l_top + l_j, l_top + {NATURAL_32} 1, (a_w.item.size - l_top) - {NATURAL_32} 1))
				l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_w.item.R, (l_top + l_j) + {NATURAL_32} 1, l_top + {NATURAL_32} 1, (a_w.item.size - l_top) - {NATURAL_32} 1))
			else
				l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_R, l_j, (1).to_natural_32, l_N - {NATURAL_32} 1))
				l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_R, l_j + {NATURAL_32} 1, (1).to_natural_32, l_N - {NATURAL_32} 1))
			end
			blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
			if ((a_w.item.Q).c_pointer /= default_pointer) then
				l_xv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_w.item.Q, l_top + l_j))
				l_yv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_w.item.Q, (l_top + l_j) + {NATURAL_32} 1))
				blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
			end
		end

	gen_tri_chase_zero (a_H: CE_POINTER [PD_GSL_MATRIX]; a_R: CE_POINTER [PD_GSL_MATRIX]; a_q___3: NATURAL_32; a_w: CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE])
		local
			l_N: NATURAL_32
			l_j: NATURAL_32
			l_top: NATURAL_32
			l_cs: REAL_64
			l_sn: REAL_64
			l_xv: PD_GSL_VECTOR_VIEW
			l_yv: PD_GSL_VECTOR_VIEW
			l_tmp: REAL_64
			l_tmp___1: REAL_64
		do
			create l_xv.make
			create l_yv.make

			l_N := a_H.item.size1
			if (a_w.item.needtop).to_boolean then
				l_top := gen_get_submatrix (a_w.item.H, a_H)
			end
			l_j := a_q___3
			from
			until
				not (l_j < l_N - {NATURAL_32} 1)
			loop
				l_tmp := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_j + {NATURAL_32} 1, l_j + {NATURAL_32} 1)
				qrstep_inst.create_givens ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_j, l_j + {NATURAL_32} 1)), l_tmp, create {CE_POINTER [REAL_64]}.make_shared ($l_cs), create {CE_POINTER [REAL_64]}.make_shared ($l_sn))
				l_sn := -l_sn
				if (a_w.item.compute_t).to_boolean then
					l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_w.item.R, l_top + l_j, (l_top + l_j) + {NATURAL_32} 1, ((a_w.item.size - l_top) - l_j) - {NATURAL_32} 1))
					l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_w.item.R, (l_top + l_j) + {NATURAL_32} 1, (l_top + l_j) + {NATURAL_32} 1, ((a_w.item.size - l_top) - l_j) - {NATURAL_32} 1))
				else
					l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_R, l_j, l_j + {NATURAL_32} 1, (l_N - l_j) - {NATURAL_32} 1))
					l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_R, l_j + {NATURAL_32} 1, l_j + {NATURAL_32} 1, (l_N - l_j) - {NATURAL_32} 1))
				end
				blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
				gsl_gsl_matrix_double_inst.gsl_matrix_set (a_R, l_j + {NATURAL_32} 1, l_j + {NATURAL_32} 1, 0.0)
				if (a_w.item.compute_s).to_boolean then
					l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_w.item.H, l_top + l_j, (l_top + l_j) - {NATURAL_32} 1, ((a_w.item.size - l_top) - l_j) + {NATURAL_32} 1))
					l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_w.item.H, (l_top + l_j) + {NATURAL_32} 1, (l_top + l_j) - {NATURAL_32} 1, ((a_w.item.size - l_top) - l_j) + {NATURAL_32} 1))
				else
					l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_H, l_j, l_j - {NATURAL_32} 1, (l_N - l_j) + {NATURAL_32} 1))
					l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_H, l_j + {NATURAL_32} 1, l_j - {NATURAL_32} 1, (l_N - l_j) + {NATURAL_32} 1))
				end
				blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
				if ((a_w.item.Q).c_pointer /= default_pointer) then
					l_xv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_w.item.Q, l_top + l_j))
					l_yv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_w.item.Q, (l_top + l_j) + {NATURAL_32} 1))
					blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
				end
				l_tmp___1 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_j + {NATURAL_32} 1, l_j - {NATURAL_32} 1)
				qrstep_inst.create_givens ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_j + {NATURAL_32} 1, l_j)), l_tmp___1, create {CE_POINTER [REAL_64]}.make_shared ($l_cs), create {CE_POINTER [REAL_64]}.make_shared ($l_sn))
				l_sn := -l_sn
				if (a_w.item.compute_s).to_boolean then
					l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_w.item.H, l_top + l_j, (0).to_natural_32, (l_top + l_j) + {NATURAL_32} 2))
					l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_w.item.H, (l_top + l_j) - {NATURAL_32} 1, (0).to_natural_32, (l_top + l_j) + {NATURAL_32} 2))
				else
					l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_H, l_j, (0).to_natural_32, l_j + {NATURAL_32} 2))
					l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_H, l_j - {NATURAL_32} 1, (0).to_natural_32, l_j + {NATURAL_32} 2))
				end
				blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
				gsl_gsl_matrix_double_inst.gsl_matrix_set (a_H, l_j + {NATURAL_32} 1, l_j - {NATURAL_32} 1, 0.0)
				if (a_w.item.compute_t).to_boolean then
					l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_w.item.R, l_top + l_j, (0).to_natural_32, (l_top + l_j) + {NATURAL_32} 1))
					l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_w.item.R, (l_top + l_j) - {NATURAL_32} 1, (0).to_natural_32, (l_top + l_j) + {NATURAL_32} 1))
				else
					l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_R, l_j, (0).to_natural_32, l_j + {NATURAL_32} 1))
					l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_R, l_j - {NATURAL_32} 1, (0).to_natural_32, l_j + {NATURAL_32} 1))
				end
				blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
				if ((a_w.item.Z).c_pointer /= default_pointer) then
					l_xv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_w.item.Z, l_top + l_j))
					l_yv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_w.item.Z, (l_top + l_j) - {NATURAL_32} 1))
					blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
				end
				l_j := l_j + 1
			end
		end

	gen_tri_zero_H (a_H: CE_POINTER [PD_GSL_MATRIX]; a_R: CE_POINTER [PD_GSL_MATRIX]; a_w: CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE])
		local
			l_N: NATURAL_32
			l_top: NATURAL_32
			l_cs: REAL_64
			l_sn: REAL_64
			l_xv: PD_GSL_VECTOR_VIEW
			l_yv: PD_GSL_VECTOR_VIEW
			l_tmp: REAL_64
		do
			create l_xv.make
			create l_yv.make

			l_N := a_H.item.size1
			if (a_w.item.needtop).to_boolean then
				l_top := gen_get_submatrix (a_w.item.H, a_H)
			end
			l_tmp := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_N - {NATURAL_32} 1, l_N - {NATURAL_32} 2)
			qrstep_inst.create_givens ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_N - {NATURAL_32} 1, l_N - {NATURAL_32} 1)), l_tmp, create {CE_POINTER [REAL_64]}.make_shared ($l_cs), create {CE_POINTER [REAL_64]}.make_shared ($l_sn))
			l_sn := -l_sn
			if (a_w.item.compute_s).to_boolean then
				l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_w.item.H, (l_top + l_N) - {NATURAL_32} 1, (0).to_natural_32, l_top + l_N))
				l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_w.item.H, (l_top + l_N) - {NATURAL_32} 2, (0).to_natural_32, l_top + l_N))
			else
				l_xv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_H, l_N - {NATURAL_32} 1))
				l_yv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_H, l_N - {NATURAL_32} 2))
			end
			blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
			gsl_gsl_matrix_double_inst.gsl_matrix_set (a_H, l_N - {NATURAL_32} 1, l_N - {NATURAL_32} 2, 0.0)
			if (a_w.item.compute_t).to_boolean then
				l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_w.item.R, (l_top + l_N) - {NATURAL_32} 1, (0).to_natural_32, (l_top + l_N) - {NATURAL_32} 1))
				l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_w.item.R, (l_top + l_N) - {NATURAL_32} 2, (0).to_natural_32, (l_top + l_N) - {NATURAL_32} 1))
			else
				l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_R, l_N - {NATURAL_32} 1, (0).to_natural_32, l_N - {NATURAL_32} 1))
				l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_R, l_N - {NATURAL_32} 2, (0).to_natural_32, l_N - {NATURAL_32} 1))
			end
			blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
			if ((a_w.item.Z).c_pointer /= default_pointer) then
				l_xv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_w.item.Z, (l_top + l_N) - {NATURAL_32} 1))
				l_yv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_w.item.Z, (l_top + l_N) - {NATURAL_32} 2))
				blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
			end
		end

	gen_search_small_elements (a_H: CE_POINTER [PD_GSL_MATRIX]; a_R: CE_POINTER [PD_GSL_MATRIX]; a_flag: CE_POINTER [INTEGER_32]; a_w: CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE]): NATURAL_32
		local
			l_N: NATURAL_32
			l_k: INTEGER_32
			l_i: NATURAL_32
			l_pass1: INTEGER_32
			l_pass2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_N := a_H.item.size1
					l_pass1 := 0
					l_pass2 := 0
					l_k := l_N.to_integer_32 - 1
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_k >= 0)) then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						l_i := l_k.to_natural_32
						if l_i /= {NATURAL_32} 0 then
							if (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_H, l_i, l_i - {NATURAL_32} 1)))) <= a_w.item.atol then
								gsl_gsl_matrix_double_inst.gsl_matrix_set (a_H, l_i, l_i - {NATURAL_32} 1, 0.0)
								l_pass1 := 1
							end
						end
						if (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_R, l_i, l_i)))) < a_w.item.btol then
							gsl_gsl_matrix_double_inst.gsl_matrix_set (a_R, l_i, l_i, 0.0)
							l_pass2 := 1
						end
						if not (l_pass1.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if not l_pass2.to_boolean then
							a_flag.item := 1
							Result := l_i
							js.return
						else
							l_pos := -1 + 5 -- goto _L___0
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else: | _L___0:
						if l_pass1.to_boolean then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if l_pass2.to_boolean then
							a_flag.item := 2
							Result := l_i
							js.return
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if l_pass1.to_boolean then
							if l_pass2.to_boolean then
								a_flag.item := 3
								Result := l_i
								js.return
							end
						end
				when 9 then -- if done
						if not js.return_called then
							l_k := l_k - 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					if not js.return_called then
						a_flag.item := 0
						Result := (0).to_natural_32
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gen_schur_standardize1 (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_B: CE_POINTER [PD_GSL_MATRIX]; a_alphar: CE_POINTER [REAL_64]; a_beta: CE_POINTER [REAL_64]; a_w: CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE]): INTEGER_32
		local
			l_i: NATURAL_32
			l_top: NATURAL_32
		do
			if (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_B, (0).to_natural_32, (0).to_natural_32)) < 0.0 then
				if (a_w.item.needtop).to_boolean then
					l_top := gen_get_submatrix (a_w.item.H, a_A___0)
				end
				if (a_w.item.compute_t).to_boolean then
					l_i := (0).to_natural_32
					from
					until
						not (l_i <= l_top)
					loop
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_w.item.R, l_i, l_top, -(gsl_gsl_matrix_double_inst.gsl_matrix_get (a_w.item.R, l_i, l_top)))
						l_i := l_i + 1
					end
				else
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_B, (0).to_natural_32, (0).to_natural_32, -(gsl_gsl_matrix_double_inst.gsl_matrix_get (a_B, (0).to_natural_32, (0).to_natural_32)))
				end
				if (a_w.item.compute_s).to_boolean then
					l_i := (0).to_natural_32
					from
					until
						not (l_i <= l_top)
					loop
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_w.item.H, l_i, l_top, -(gsl_gsl_matrix_double_inst.gsl_matrix_get (a_w.item.H, l_i, l_top)))
						l_i := l_i + 1
					end
				else
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_A___0, (0).to_natural_32, (0).to_natural_32, -(gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (0).to_natural_32)))
				end
				if ((a_w.item.Z).c_pointer /= default_pointer) then
					l_i := (0).to_natural_32
					from
					until
						not (l_i < a_w.item.size)
					loop
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_w.item.Z, l_i, l_top, -(gsl_gsl_matrix_double_inst.gsl_matrix_get (a_w.item.Z, l_i, l_top)))
						l_i := l_i + 1
					end
				end
			end
			a_alphar.item := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (0).to_natural_32)
			a_beta.item := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_B, (0).to_natural_32, (0).to_natural_32)
			Result := 0
		end

	gen_schur_standardize2 (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_B: CE_POINTER [PD_GSL_MATRIX]; a_alpha1: CE_POINTER [PD_GSL_COMPLEX]; a_alpha2: CE_POINTER [PD_GSL_COMPLEX]; a_beta1: CE_POINTER [REAL_64]; a_beta2: CE_POINTER [REAL_64]; a_w: CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE]): INTEGER_32
		local
			l_datB: CE_ARRAY [REAL_64]
			l_datV: CE_ARRAY [REAL_64]
			l_datS: CE_ARRAY [REAL_64]
			l_work: CE_ARRAY [REAL_64]
			l_uv: PD_GSL_MATRIX_VIEW
			l_vv: PD_GSL_MATRIX_VIEW
			l_sv: PD_GSL_VECTOR_VIEW
			l_wv: PD_GSL_VECTOR_VIEW
			l_B11: REAL_64
			l_B22: REAL_64
			l_top: NATURAL_32
			l_det: REAL_64
			l_cr: REAL_64
			l_sr: REAL_64
			l_cl: REAL_64
			l_sl: REAL_64
			l_xv: PD_GSL_VECTOR_VIEW
			l_yv: PD_GSL_VECTOR_VIEW
			l_s: INTEGER_32
			l_tmp___3: REAL_64
			l_tmp___4: REAL_64
			l_tmp___5: REAL_64
			l_tmp___7: REAL_64
			l_tmp___8: REAL_64
			l_tmp___9: REAL_64
			l_i: NATURAL_32
		do
			create l_datB.make (<<4>>)
			create l_datV.make (<<4>>)
			create l_datS.make (<<2>>)
			create l_work.make (<<2>>)
			create l_uv.make
			create l_vv.make
			create l_sv.make
			create l_wv.make
			create l_xv.make
			create l_yv.make

			l_uv.ce_gets ((view_source_inst.gsl_matrix_view_array (l_datB, (2).to_natural_32, (2).to_natural_32)))
			l_vv.ce_gets ((view_source_inst.gsl_matrix_view_array (l_datV, (2).to_natural_32, (2).to_natural_32)))
			l_sv.ce_gets ((view_source_inst.gsl_vector_view_array (l_datS, (2).to_natural_32)))
			l_wv.ce_gets ((view_source_inst.gsl_vector_view_array (l_work, (2).to_natural_32)))
			if (a_w.item.needtop).to_boolean then
				l_top := gen_get_submatrix (a_w.item.H, a_A___0)
			end
			copy_source_inst.gsl_matrix_memcpy (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_uv.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), a_B).do_nothing
			svd_inst.gsl_linalg_SV_decomp (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_uv.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vv.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_sv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_wv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)).do_nothing
			l_tmp___3 := gsl_gsl_matrix_double_inst.gsl_matrix_get ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vv.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), (0).to_natural_32, (0).to_natural_32)
			l_tmp___4 := gsl_gsl_matrix_double_inst.gsl_matrix_get ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vv.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), (1).to_natural_32, (1).to_natural_32)
			l_tmp___5 := gsl_gsl_matrix_double_inst.gsl_matrix_get ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vv.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), (0).to_natural_32, (1).to_natural_32)
			l_det := l_tmp___3 * l_tmp___4 - l_tmp___5 * (gsl_gsl_matrix_double_inst.gsl_matrix_get ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vv.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), (1).to_natural_32, (0).to_natural_32))
			if l_det < 0.0 then
				l_datS[1] := -l_datS[1]
			end
			l_cr := gsl_gsl_matrix_double_inst.gsl_matrix_get ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vv.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), (0).to_natural_32, (0).to_natural_32)
			l_sr := gsl_gsl_matrix_double_inst.gsl_matrix_get ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vv.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), (1).to_natural_32, (0).to_natural_32)
			l_tmp___7 := gsl_gsl_matrix_double_inst.gsl_matrix_get ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_uv.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), (0).to_natural_32, (0).to_natural_32)
			l_tmp___8 := gsl_gsl_matrix_double_inst.gsl_matrix_get ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_uv.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), (1).to_natural_32, (1).to_natural_32)
			l_tmp___9 := gsl_gsl_matrix_double_inst.gsl_matrix_get ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_uv.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), (0).to_natural_32, (1).to_natural_32)
			l_det := l_tmp___7 * l_tmp___8 - l_tmp___9 * (gsl_gsl_matrix_double_inst.gsl_matrix_get ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_uv.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), (1).to_natural_32, (0).to_natural_32))
			if l_det < 0.0 then
				l_datS[1] := -l_datS[1]
			end
			l_cl := gsl_gsl_matrix_double_inst.gsl_matrix_get ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_uv.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), (0).to_natural_32, (0).to_natural_32)
			l_sl := gsl_gsl_matrix_double_inst.gsl_matrix_get ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_uv.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), (1).to_natural_32, (0).to_natural_32)
			l_B11 := gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_sv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), (0).to_natural_32)
			l_B22 := gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_sv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), (1).to_natural_32)
			if l_B11 < 0.0 then
				l_B11 := -l_B11
				l_B22 := -l_B22
				l_cr := -l_cr
				l_sr := -l_sr
			end
			if (a_w.item.compute_s).to_boolean then
				l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_w.item.H, l_top, l_top, a_w.item.size - l_top))
				l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_w.item.H, l_top + {NATURAL_32} 1, l_top, a_w.item.size - l_top))
				blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cl, l_sl).do_nothing
				l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_w.item.H, l_top, (0).to_natural_32, l_top + {NATURAL_32} 2))
				l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_w.item.H, l_top + {NATURAL_32} 1, (0).to_natural_32, l_top + {NATURAL_32} 2))
				blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cr, l_sr).do_nothing
			else
				l_xv.ce_gets (rowcol_source_inst.gsl_matrix_row (a_A___0, (0).to_natural_32))
				l_yv.ce_gets (rowcol_source_inst.gsl_matrix_row (a_A___0, (1).to_natural_32))
				blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cl, l_sl).do_nothing
				l_xv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_A___0, (0).to_natural_32))
				l_yv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_A___0, (1).to_natural_32))
				blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cr, l_sr).do_nothing
			end
			if (a_w.item.compute_t).to_boolean then
				if l_top /= a_w.item.size - {NATURAL_32} 2 then
					l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_w.item.R, l_top, l_top + {NATURAL_32} 2, (a_w.item.size - l_top) - {NATURAL_32} 2))
					l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_w.item.R, l_top + {NATURAL_32} 1, l_top + {NATURAL_32} 2, (a_w.item.size - l_top) - {NATURAL_32} 2))
					blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cl, l_sl).do_nothing
				end
				if l_top /= {NATURAL_32} 0 then
					l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_w.item.R, l_top, (0).to_natural_32, l_top))
					l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_w.item.R, l_top + {NATURAL_32} 1, (0).to_natural_32, l_top))
					blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cr, l_sr).do_nothing
				end
			end
			if ((a_w.item.Q).c_pointer /= default_pointer) then
				l_xv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_w.item.Q, l_top))
				l_yv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_w.item.Q, l_top + {NATURAL_32} 1))
				blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cl, l_sl).do_nothing
			end
			if ((a_w.item.Z).c_pointer /= default_pointer) then
				l_xv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_w.item.Z, l_top))
				l_yv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_w.item.Z, l_top + {NATURAL_32} 1))
				blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cr, l_sr).do_nothing
			end
			gsl_gsl_matrix_double_inst.gsl_matrix_set (a_B, (0).to_natural_32, (0).to_natural_32, l_B11)
			gsl_gsl_matrix_double_inst.gsl_matrix_set (a_B, (0).to_natural_32, (1).to_natural_32, 0.0)
			gsl_gsl_matrix_double_inst.gsl_matrix_set (a_B, (1).to_natural_32, (0).to_natural_32, 0.0)
			gsl_gsl_matrix_double_inst.gsl_matrix_set (a_B, (1).to_natural_32, (1).to_natural_32, l_B22)
			if l_B22 < 0.0 then
				if (a_w.item.compute_s).to_boolean then
					l_i := (0).to_natural_32
					from
					until
						not (l_i < l_top + {NATURAL_32} 2)
					loop
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_w.item.H, l_i, l_top + {NATURAL_32} 1, -(gsl_gsl_matrix_double_inst.gsl_matrix_get (a_w.item.H, l_i, l_top + {NATURAL_32} 1)))
						l_i := l_i + 1
					end
				else
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_A___0, (0).to_natural_32, (1).to_natural_32, -(gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (1).to_natural_32)))
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_A___0, (1).to_natural_32, (1).to_natural_32, -(gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (1).to_natural_32)))
				end
				if (a_w.item.compute_t).to_boolean then
					l_i := (0).to_natural_32
					from
					until
						not (l_i < l_top + {NATURAL_32} 2)
					loop
						gsl_gsl_matrix_double_inst.gsl_matrix_set (a_w.item.R, l_i, l_top + {NATURAL_32} 1, -(gsl_gsl_matrix_double_inst.gsl_matrix_get (a_w.item.R, l_i, l_top + {NATURAL_32} 1)))
						l_i := l_i + 1
					end
				else
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_B, (0).to_natural_32, (1).to_natural_32, -(gsl_gsl_matrix_double_inst.gsl_matrix_get (a_B, (0).to_natural_32, (1).to_natural_32)))
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_B, (1).to_natural_32, (1).to_natural_32, -(gsl_gsl_matrix_double_inst.gsl_matrix_get (a_B, (1).to_natural_32, (1).to_natural_32)))
				end
				if ((a_w.item.Z).c_pointer /= default_pointer) then
					l_xv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_w.item.Z, l_top + {NATURAL_32} 1))
					oper_source_inst.gsl_vector_scale (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), -1.0).do_nothing
				end
			end
			l_s := gen_compute_eigenvals (a_A___0, a_B, a_alpha1, a_alpha2, a_beta1, a_beta2)
			Result := l_s
		end

	gen_compute_eigenvals (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_B: CE_POINTER [PD_GSL_MATRIX]; a_alpha1: CE_POINTER [PD_GSL_COMPLEX]; a_alpha2: CE_POINTER [PD_GSL_COMPLEX]; a_beta1: CE_POINTER [REAL_64]; a_beta2: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_wr1: REAL_64
			l_wr2: REAL_64
			l_wi: REAL_64
			l_scale1: REAL_64
			l_scale2: REAL_64
			l_s1inv: REAL_64
			l_A11: REAL_64
			l_A12: REAL_64
			l_A21: REAL_64
			l_A22: REAL_64
			l_B11: REAL_64
			l_B22: REAL_64
			l_c11r: REAL_64
			l_c11i: REAL_64
			l_c12: REAL_64
			l_c21: REAL_64
			l_c22r: REAL_64
			l_c22i: REAL_64
			l_cz: REAL_64
			l_cq: REAL_64
			l_szr: REAL_64
			l_szi: REAL_64
			l_sqr: REAL_64
			l_sqi: REAL_64
			l_a1r: REAL_64
			l_a1i: REAL_64
			l_a2r: REAL_64
			l_a2i: REAL_64
			l_b1r: REAL_64
			l_b1i: REAL_64
			l_b1a: REAL_64
			l_b2r: REAL_64
			l_b2i: REAL_64
			l_b2a: REAL_64
			l_alphar: REAL_64
			l_alphai: REAL_64
			l_t1: REAL_64
			l_an: REAL_64
			l_bn: REAL_64
			l_tempr: REAL_64
			l_tempi: REAL_64
			l_wabs: REAL_64
			l_tmp: REAL_64
			l_tmp___0: REAL_64
			l_tmp___1: REAL_64
			l_tmp___2: REAL_64
			l_tmp___3: REAL_64
			l_tmp___5: REAL_64
			l_tmp___6: REAL_64
			l_tmp___7: REAL_64
			l_tmp___9: REAL_64
			l_tmp___11: REAL_64
			js: JUMP_STATE
		do
			schur_inst.gsl_schur_gen_eigvals (a_A___0, a_B, create {CE_POINTER [REAL_64]}.make_shared ($l_wr1), create {CE_POINTER [REAL_64]}.make_shared ($l_wr2), create {CE_POINTER [REAL_64]}.make_shared ($l_wi), create {CE_POINTER [REAL_64]}.make_shared ($l_scale1), create {CE_POINTER [REAL_64]}.make_shared ($l_scale2)).do_nothing
			if l_wi = 0.0 then
				Result := (-2)
				js.return
			end
			if not js.return_called then
				l_s1inv := 1.0 / l_scale1
				l_A11 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (0).to_natural_32)
				l_A12 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (1).to_natural_32)
				l_A21 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (0).to_natural_32)
				l_A22 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (1).to_natural_32)
				l_B11 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_B, (0).to_natural_32, (0).to_natural_32)
				l_B22 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_B, (1).to_natural_32, (1).to_natural_32)
				l_c11r := l_scale1 * l_A11 - l_wr1 * l_B11
				l_c11i := -l_wi * l_B11
				l_c12 := l_scale1 * l_A12
				l_c21 := l_scale1 * l_A21
				l_c22r := l_scale1 * l_A22 - l_wr1 * l_B22
				l_c22i := -l_wi * l_B22
				l_tmp := fabs (l_c11r)
				l_tmp___0 := fabs (l_c11i)
				l_tmp___1 := fabs (l_c12)
				l_tmp___2 := fabs (l_c21)
				l_tmp___3 := fabs (l_c22r)
				if (l_tmp + l_tmp___0) + l_tmp___1 > (l_tmp___2 + l_tmp___3) + (fabs (l_c22i)) then
					l_t1 := hypot_inst.gsl_hypot3 (l_c12, l_c11r, l_c11i)
					if l_t1 /= 0.0 then
						l_cz := l_c12 / l_t1
						l_szr := -l_c11r / l_t1
						l_szi := -l_c11i / l_t1
					else
						l_cz := 0.0
						l_szr := 1.0
						l_szi := 0.0
					end
				else
					l_cz := hypot (l_c22r, l_c22i)
					if l_cz <= 2.2250738585072014e-308 then
						l_cz := 0.0
						l_szr := 1.0
						l_szi := 0.0
					else
						l_tempr := l_c22r / l_cz
						l_tempi := l_c22i / l_cz
						l_t1 := hypot (l_cz, l_c21)
						l_cz := l_cz / l_t1
						l_szr := (-l_c21 * l_tempr) / l_t1
						l_szi := (l_c21 * l_tempi) / l_t1
					end
				end
				l_tmp___5 := fabs (l_A11)
				l_tmp___6 := fabs (l_A12)
				l_tmp___7 := fabs (l_A21)
				l_an := ((l_tmp___5 + l_tmp___6) + l_tmp___7) + (fabs (l_A22))
				l_tmp___9 := fabs (l_B11)
				l_bn := l_tmp___9 + (fabs (l_B22))
				l_tmp___11 := fabs (l_wr1)
				l_wabs := l_tmp___11 + (fabs (l_wi))
				if l_scale1 * l_an > l_wabs * l_bn then
					l_cq := l_cz * l_B11
					if l_cq <= 2.2250738585072014e-308 then
						l_cq := 0.0
						l_sqr := 1.0
						l_sqi := 0.0
					else
						l_sqr := l_szr * l_B22
						l_sqi := -l_szi * l_B22
					end
				else
					l_a1r := l_cz * l_A11 + l_szr * l_A12
					l_a1i := l_szi * l_A12
					l_a2r := l_cz * l_A21 + l_szr * l_A22
					l_a2i := l_szi * l_A22
					l_cq := hypot (l_a1r, l_a1i)
					if l_cq <= 2.2250738585072014e-308 then
						l_cq := 0.0
						l_sqr := 1.0
						l_sqi := 0.0
					else
						l_tempr := l_a1r / l_cq
						l_tempi := l_a1i / l_cq
						l_sqr := l_tempr * l_a2r + l_tempi * l_a2i
						l_sqi := l_tempi * l_a2r - l_tempr * l_a2i
					end
				end
				l_t1 := hypot_inst.gsl_hypot3 (l_cq, l_sqr, l_sqi)
				l_cq := l_cq / l_t1
				l_sqr := l_sqr / l_t1
				l_sqi := l_sqi / l_t1
				l_tempr := l_sqr * l_szr - l_sqi * l_szi
				l_tempi := l_sqr * l_szi + l_sqi * l_szr
				l_b1r := (l_cq * l_cz) * l_B11 + l_tempr * l_B22
				l_b1i := l_tempi * l_B22
				l_b1a := hypot (l_b1r, l_b1i)
				l_b2r := (l_cq * l_cz) * l_B22 + l_tempr * l_B11
				l_b2i := -l_tempi * l_B11
				l_b2a := hypot (l_b2r, l_b2i)
				a_beta1.item := l_b1a
				a_beta2.item := l_b2a
				l_alphar := (l_wr1 * l_b1a) * l_s1inv
				l_alphai := (l_wi * l_b1a) * l_s1inv
				from
				until
					js.loop_left
				loop
					js.reset
					a_alpha1.item.dat[0] := l_alphar
					a_alpha1.item.dat[1] := l_alphai
					js.break
				end
				js.reset
				l_alphar := (l_wr1 * l_b2a) * l_s1inv
				l_alphai := -(l_wi * l_b2a) * l_s1inv
				from
				until
					js.loop_left
				loop
					js.reset
					a_alpha2.item.dat[0] := l_alphar
					a_alpha2.item.dat[1] := l_alphai
					js.break
				end
				js.reset
				Result := 0
			end
		end

	gen_store_eigval1 (a_H: CE_POINTER [PD_GSL_MATRIX]; a_a___5: REAL_64; a_b___0: REAL_64; a_alpha: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_beta: CE_POINTER [PD_GSL_VECTOR]; a_w: CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE])
		local
			l_top: NATURAL_32
			l_z: PD_GSL_COMPLEX
			js: JUMP_STATE
		do
			create l_z.make

			l_top := (gen_get_submatrix (a_w.item.H, a_H))
			from
			until
				js.loop_left
			loop
				js.reset
				l_z.dat[0] := a_a___5
				l_z.dat[1] := 0.0
				js.break
			end
			js.reset
			gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_alpha, l_top, l_z)
			gsl_gsl_vector_double_inst.gsl_vector_set (a_beta, l_top, a_b___0)
			a_w.item.n_evals := (a_w.item.n_evals) + 1
			a_w.item.n_iter := (0).to_natural_32
			a_w.item.eshift := 0.0
		end

	gen_store_eigval2 (a_H: CE_POINTER [PD_GSL_MATRIX]; a_alpha1: CE_POINTER [PD_GSL_COMPLEX]; a_beta1: REAL_64; a_alpha2: CE_POINTER [PD_GSL_COMPLEX]; a_beta2: REAL_64; a_alpha: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_beta: CE_POINTER [PD_GSL_VECTOR]; a_w: CE_POINTER [PD_GSL_EIGEN_GEN_WORKSPACE])
		local
			l_top: NATURAL_32
		do
			l_top := (gen_get_submatrix (a_w.item.H, a_H))
			gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_alpha, l_top, a_alpha1.item)
			gsl_gsl_vector_double_inst.gsl_vector_set (a_beta, l_top, a_beta1)
			gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_alpha, l_top + {NATURAL_32} 1, a_alpha2.item)
			gsl_gsl_vector_double_inst.gsl_vector_set (a_beta, l_top + {NATURAL_32} 1, a_beta2)
			a_w.item.n_evals := a_w.item.n_evals + ({NATURAL_32} 2)
			a_w.item.n_iter := (0).to_natural_32
			a_w.item.eshift := 0.0
		end

	gen_get_submatrix (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_B: CE_POINTER [PD_GSL_MATRIX]): NATURAL_32
		local
			l_diff: NATURAL_32
			l_ratio: REAL_64
			l_top: NATURAL_32
		do
			l_diff := ((a_B.item.data).distance ((a_A___0.item.data))).to_natural_32
			l_ratio := l_diff.to_real_64 / (a_A___0.item.tda + {NATURAL_32} 1).to_real_64
			l_top := (floor (l_ratio)).truncated_to_integer_64.to_natural_32
			Result := l_top
		end

end
