class
	P_GENV

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_eigen_genv_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_EIGEN_GENV_WORKSPACE]
		local
			l_w: CE_POINTER [PD_GSL_EIGEN_GENV_WORKSPACE]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_w.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_n = {NATURAL_32} 0 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix dimension must be positive integer"), ce_string ("genv.c"), 68, 4)
							Result := (create {CE_POINTER [PD_GSL_EIGEN_GENV_WORKSPACE]}.make_shared (default_pointer))
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_w.ce_gets (create {CE_POINTER [PD_GSL_EIGEN_GENV_WORKSPACE]}.make_cast ((calloc ((1).to_natural_32, {PD_GSL_EIGEN_GENV_WORKSPACE}.sizeof.to_natural_32))))
						if (l_w.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("failed to allocate space for workspace"), ce_string ("genv.c"), 75, 8)
								Result := (create {CE_POINTER [PD_GSL_EIGEN_GENV_WORKSPACE]}.make_shared (default_pointer))
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
					end
					if not js.return_called then
						l_w.item.size := a_n
						l_w.item.Q := create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
						l_w.item.Z := create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
						l_w.item.gen_workspace_p := gen_inst.gsl_eigen_gen_alloc (a_n)
						if ((l_w.item.gen_workspace_p).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							gsl_eigen_genv_free (l_w)
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("failed to allocate space for gen workspace"), ce_string ("genv.c"), 87, 8)
								Result := (create {CE_POINTER [PD_GSL_EIGEN_GENV_WORKSPACE]}.make_shared (default_pointer))
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
					end
					if js.return_called then
						l_pos := -1 + 18 -- skip if block
					end
				when 1 then -- if:
						gen_inst.gsl_eigen_gen_params (1, 1, 1, l_w.item.gen_workspace_p)
						l_w.item.work1 := init_source_inst.gsl_vector_alloc (a_n)
						l_w.item.work2 := init_source_inst.gsl_vector_alloc (a_n)
						l_w.item.work3 := init_source_inst.gsl_vector_alloc (a_n)
						l_w.item.work4 := init_source_inst.gsl_vector_alloc (a_n)
						l_w.item.work5 := init_source_inst.gsl_vector_alloc (a_n)
						l_w.item.work6 := init_source_inst.gsl_vector_alloc (a_n)
						if ((l_w.item.work1).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 4 then -- else:
						if ((l_w.item.work2).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 7 then -- else:
						if ((l_w.item.work3).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 10 then -- else:
						if ((l_w.item.work4).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 13 then -- else:
						if ((l_w.item.work5).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if ((l_w.item.work6).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L:
						gsl_eigen_genv_free (l_w)
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("failed to allocate space for additional workspace"), ce_string ("genv.c"), 104, 8)
							Result := (create {CE_POINTER [PD_GSL_EIGEN_GENV_WORKSPACE]}.make_shared (default_pointer))
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 18 then -- if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := l_w
						end
				when 19 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_eigen_genv_free (a_w: CE_POINTER [PD_GSL_EIGEN_GENV_WORKSPACE])
		local
			js: JUMP_STATE
		do
			if (a_w).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				if ((a_w.item.gen_workspace_p).c_pointer /= default_pointer) then
					gen_inst.gsl_eigen_gen_free (a_w.item.gen_workspace_p)
				end
				if ((a_w.item.work1).c_pointer /= default_pointer) then
					init_source_inst.gsl_vector_free (a_w.item.work1)
				end
				if ((a_w.item.work2).c_pointer /= default_pointer) then
					init_source_inst.gsl_vector_free (a_w.item.work2)
				end
				if ((a_w.item.work3).c_pointer /= default_pointer) then
					init_source_inst.gsl_vector_free (a_w.item.work3)
				end
				if ((a_w.item.work4).c_pointer /= default_pointer) then
					init_source_inst.gsl_vector_free (a_w.item.work4)
				end
				if ((a_w.item.work5).c_pointer /= default_pointer) then
					init_source_inst.gsl_vector_free (a_w.item.work5)
				end
				if ((a_w.item.work6).c_pointer /= default_pointer) then
					init_source_inst.gsl_vector_free (a_w.item.work6)
				end
				free (create {CE_POINTER [ANY]}.make_cast (a_w))
			end
		end

	gsl_eigen_genv (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_B: CE_POINTER [PD_GSL_MATRIX]; a_alpha: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_beta: CE_POINTER [PD_GSL_VECTOR]; a_evec: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_w: CE_POINTER [PD_GSL_EIGEN_GENV_WORKSPACE]): INTEGER_32
		local
			l_N: NATURAL_32
			l_s: INTEGER_32
			l_Z: PD_GSL_MATRIX
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_Z.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_N := a_A___0.item.size1
					if l_N = a_A___0.item.size2 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix must be square to compute eigenvalues"), ce_string ("genv.c"), 174, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 3 then -- else:
						if l_N = a_B.item.size1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 6 then -- else:
						if l_N = a_B.item.size2 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("B matrix dimensions must match A"), ce_string ("genv.c"), 178, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 9 then -- else:
						if a_alpha.item.size = l_N then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 12 then -- else:
						if a_beta.item.size = l_N then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("eigenvalue vector must match matrix size"), ce_string ("genv.c"), 182, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						if a_w.item.size /= l_N then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("matrix size does not match workspace"), ce_string ("genv.c"), 186, 19)
								Result := 19
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						elseif a_evec.item.size1 /= l_N then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("eigenvector matrix has wrong size"), ce_string ("genv.c"), 190, 19)
								Result := 19
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						else
							l_Z.size1 := l_N
							l_Z.size2 := l_N
							l_Z.tda := {NATURAL_32} 2 * l_N
							l_Z.data := a_evec.item.data
							l_Z.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
							l_Z.owner := 0
							l_s := gen_inst.gsl_eigen_gen_QZ (a_A___0, a_B, a_alpha, a_beta, a_w.item.Q, l_Z.address, a_w.item.gen_workspace_p)
							if ((a_w.item.Z).c_pointer /= default_pointer) then
								copy_source_inst.gsl_matrix_memcpy (a_w.item.Z, (l_Z.address)).do_nothing
							end
							if l_s = 0 then
								l_s := genv_get_right_eigenvectors (a_A___0, a_B, l_Z.address, a_evec, a_w)
								if l_s = 0 then
									genv_normalize_eigenvectors (a_alpha, a_evec)
								end
							end
							Result := l_s
							js.return
						end
				when 16 then -- if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 17 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_eigen_genv_QZ (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_B: CE_POINTER [PD_GSL_MATRIX]; a_alpha: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_beta: CE_POINTER [PD_GSL_VECTOR]; a_evec: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_Q___1: CE_POINTER [PD_GSL_MATRIX]; a_Z: CE_POINTER [PD_GSL_MATRIX]; a_w: CE_POINTER [PD_GSL_EIGEN_GENV_WORKSPACE]): INTEGER_32
		local
			l_s: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_Q___1).c_pointer = default_pointer then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if a_A___0.item.size1 = a_Q___1.item.size1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L___2
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if a_A___0.item.size1 = a_Q___1.item.size2 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L___2:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("Q matrix has wrong dimensions"), ce_string ("genv.c"), 268, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_pos := -1 + 9 -- goto _L___1
				when 8 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 19
				when 9 then -- else: | _L___1:
						if (a_Z).c_pointer = default_pointer then
							l_pos := -1 + 18 -- skip if block
						end
				when 10 then -- if:
						if a_A___0.item.size1 = a_Z.item.size1 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L___0
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 13 then -- else:
						if a_A___0.item.size1 = a_Z.item.size2 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("Z matrix has wrong dimensions"), ce_string ("genv.c"), 272, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						l_pos := -1 + 18 -- goto _L
				when 17 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L:
						a_w.item.Q := a_Q___1
						a_w.item.Z := a_Z
						l_s := gsl_eigen_genv (a_A___0, a_B, a_alpha, a_beta, a_evec, a_w)
						a_w.item.Q := create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
						a_w.item.Z := create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
						Result := l_s
						js.return
				when 19 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 20 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	genv_get_right_eigenvectors (a_S: CE_POINTER [PD_GSL_MATRIX]; a_T: CE_POINTER [PD_GSL_MATRIX]; a_Z: CE_POINTER [PD_GSL_MATRIX]; a_evec: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_w: CE_POINTER [PD_GSL_EIGEN_GENV_WORKSPACE]): INTEGER_32
		local
			l_N: NATURAL_32
			l_small___0: REAL_64
			l_big: REAL_64
			l_bignum: REAL_64
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_end: NATURAL_32
			l_is: INTEGER_32
			l_anorm: REAL_64
			l_bnorm: REAL_64
			l_temp: REAL_64
			l_temp2: REAL_64
			l_temp2r: REAL_64
			l_temp2i: REAL_64
			l_ascale: REAL_64
			l_bscale: REAL_64
			l_salfar: REAL_64
			l_sbeta: REAL_64
			l_acoef: REAL_64
			l_bcoefr: REAL_64
			l_bcoefi: REAL_64
			l_acoefa: REAL_64
			l_bcoefa: REAL_64
			l_creala: REAL_64
			l_cimaga: REAL_64
			l_crealb: REAL_64
			l_cimagb: REAL_64
			l_cre2a: REAL_64
			l_cim2a: REAL_64
			l_cre2b: REAL_64
			l_cim2b: REAL_64
			l_dmin: REAL_64
			l_xmax: REAL_64
			l_scale: REAL_64
			l_nw: NATURAL_32
			l_na: NATURAL_32
			l_lsa: INTEGER_32
			l_lsb: INTEGER_32
			l_complex_pair: INTEGER_32
			l_z_zero: PD_GSL_COMPLEX
			l_z_one: PD_GSL_COMPLEX
			l_bdiag: CE_ARRAY [REAL_64]
			l_sum: CE_ARRAY [REAL_64]
			l_il2by2: INTEGER_32
			l_jr: NATURAL_32
			l_jc: NATURAL_32
			l_ja: NATURAL_32
			l_xscale: REAL_64
			l_ecol: PD_GSL_VECTOR_COMPLEX_VIEW
			l_re: PD_GSL_VECTOR_VIEW
			l_im: PD_GSL_VECTOR_VIEW
			l_re2: PD_GSL_VECTOR_VIEW
			l_im2: PD_GSL_VECTOR_VIEW
			l_tmp___12: NATURAL_32
			l_tmp___13: REAL_64
			l_tmp___14: REAL_64
			l_je: NATURAL_32
			l_tmp___41: REAL_64
			l_tmp___43: REAL_64
			l_tmp___46: REAL_64
			l_tmp___55: REAL_64
			l_tmp___57: REAL_64
			l_tmp___64: INTEGER_32
			l_tmp___67: INTEGER_32
			l_tmp___68: REAL_64
			l_tmp___69: REAL_64
			l_tmp___72: REAL_64
			l_tmp___73: REAL_64
			l_tmp___74: REAL_64
			l_tmp___75: REAL_64
			l_tmp___109: REAL_64
			l_tmp___110: REAL_64
			l_tmp___112: REAL_64
			l_tmp___117: REAL_64
			l_tmp___118: REAL_64
			l_tmp___131: REAL_64
			l_tmp___132: REAL_64
			l_tmp___134: REAL_64
			l_tmp___139: REAL_64
			l_tmp___140: REAL_64
			l_tmp___142: REAL_64
			l_vs: PD_GSL_MATRIX_CONST_VIEW
			l_vt: PD_GSL_MATRIX_CONST_VIEW
			l_tmp___146: REAL_64
			l_tmp___148: REAL_64
			l_tmp___151: REAL_64
			l_tmp___155: REAL_64
			l_tmp___158: REAL_64
			l_tmp___159: REAL_64
			l_tmp___170: REAL_64
			l_tmp___174: REAL_64
			l_tmp___178: REAL_64
			l_tmp___180: REAL_64
			l_tmp___182: REAL_64
			l_tmp___187: REAL_64
			l_tmp___189: REAL_64
			l_tmp___193: REAL_64
			l_tmp___195: REAL_64
			l_tmp___197: REAL_64
			l_tmp___198: REAL_64
			l_tmp___199: REAL_64
			l_tmp___201: REAL_64
			l_tmp___202: REAL_64
			l_tmp___203: REAL_64
			l_tmp___206: REAL_64
			l_tmp___207: REAL_64
			l_sv: PD_GSL_MATRIX_CONST_VIEW
			l_xv: PD_GSL_VECTOR_VIEW
			l_bv: PD_GSL_VECTOR_VIEW
			l_bdat: CE_ARRAY [REAL_64]
			l_sv___0: PD_GSL_MATRIX_CONST_VIEW
			l_xv___0: PD_GSL_VECTOR_COMPLEX_VIEW
			l_bv___0: PD_GSL_VECTOR_COMPLEX_VIEW
			l_z: PD_GSL_COMPLEX
			l_tmp___215: REAL_64
			l_tmp___216: REAL_64
			l_tmp___220: REAL_64
			l_tmp___222: REAL_64
			l_tmp___225: REAL_64
			l_tmp___226: REAL_64
			l_tmp___231: REAL_64
			l_tmp___233: REAL_64
			l_tmp___235: REAL_64
			l_tmp___236: REAL_64
			l_tmp___238: REAL_64
			l_tmp___239: REAL_64
			l_tmp___243: REAL_64
			l_tmp___244: REAL_64
			l_tmp___246: REAL_64
			l_tmp___248: REAL_64
			l_tmp___250: REAL_64
			l_tmp___251: REAL_64
			l_tmp___253: REAL_64
			l_tmp___254: REAL_64
			l_tmp___265: REAL_64
			l_tmp___269: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_z_zero.make
			create l_z_one.make
			create l_bdiag.make (<<2>>)
			create l_sum.make (<<4>>)
			create l_ecol.make
			create l_re.make
			create l_im.make
			create l_re2.make
			create l_im2.make
			create l_vs.make
			create l_vt.make
			create l_sv.make
			create l_xv.make
			create l_bv.make
			create l_bdat.make (<<4>>)
			create l_sv___0.make
			create l_xv___0.make
			create l_bv___0.make
			create l_z.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_N := a_w.item.size
					l_small___0 := (2.2250738585072014e-308 * l_N.to_real_64) / 2.2204460492503131e-16
					l_big := 1.0 / l_small___0
					l_bignum := 1.0 / (2.2250738585072014e-308 * l_N.to_real_64)
					l_bdiag[0] := 0.0
					l_bdiag[1] := 0.0
					from
					until
						js.loop_left
					loop
						js.reset
						l_z_zero.dat[0] := 0.0
						l_z_zero.dat[1] := 0.0
						js.break
					end
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						l_z_one.dat[0] := 1.0
						l_z_one.dat[1] := 0.0
						js.break
					end
					js.reset
					l_anorm := fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, (0).to_natural_32, (0).to_natural_32)))
					if l_N > {NATURAL_32} 1 then
						l_anorm := l_anorm + (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, (1).to_natural_32, (0).to_natural_32))))
					end
					l_bnorm := fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, (0).to_natural_32, (0).to_natural_32)))
					gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work1, (0).to_natural_32, 0.0)
					gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work2, (0).to_natural_32, 0.0)
					l_j := (1).to_natural_32
					from
					until
						not (not js.loop_left and then (l_j < l_N))
					loop
						l_temp2 := 0.0
						l_temp := l_temp2
						if (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, l_j, l_j - {NATURAL_32} 1)) = 0.0 then
							l_end := l_j
						else
							l_end := l_j - {NATURAL_32} 1
						end
						l_i := (0).to_natural_32
						from
						until
							not (l_i < l_end)
						loop
							l_temp := l_temp + (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, l_i, l_j))))
							l_temp2 := l_temp2 + (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_i, l_j))))
							l_i := l_i + 1
						end
						gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work1, l_j, l_temp)
						gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work2, l_j, l_temp2)
						l_i := l_end
						from
						until
							js.loop_left
						loop
							js.reset
							if l_j + {NATURAL_32} 2 < l_N then
								l_tmp___12 := l_j + {NATURAL_32} 2
							else
								l_tmp___12 := l_N
							end
							if not (l_i < l_tmp___12) then
								js.break
							end
							if not js.loop_jumped then
								l_temp := l_temp + (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, l_i, l_j))))
								l_temp2 := l_temp2 + (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_i, l_j))))
								l_i := l_i + 1
							end
						end
						js.reset
						if l_anorm > l_temp then
							l_anorm := l_anorm
						else
							l_anorm := l_temp
						end
						if l_bnorm > l_temp2 then
							l_bnorm := l_bnorm
						else
							l_bnorm := l_temp2
						end
						l_j := l_j + 1
					end
					if l_anorm > 2.2250738585072014e-308 then
						l_tmp___13 := l_anorm
					else
						l_tmp___13 := 2.2250738585072014e-308
					end
					l_ascale := 1.0 / l_tmp___13
					if l_bnorm > 2.2250738585072014e-308 then
						l_tmp___14 := l_bnorm
					else
						l_tmp___14 := 2.2250738585072014e-308
					end
					l_bscale := 1.0 / l_tmp___14
					l_complex_pair := 0
					l_k := (0).to_natural_32
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_k < l_N)) then
						l_pos := -1 + 14 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_je := (l_N - {NATURAL_32} 1) - l_k
						if l_complex_pair.to_boolean then
							l_complex_pair := 0
							js.continue
						end
						if not js.loop_jumped then
							l_nw := (1).to_natural_32
							if l_je > {NATURAL_32} 0 then
								if (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, l_je, l_je - {NATURAL_32} 1)) /= 0.0 then
									l_complex_pair := 1
									l_nw := (2).to_natural_32
								end
							end
							if not l_complex_pair.to_boolean then
								if (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, l_je, l_je)))) <= 2.2250738585072014e-308 then
									if (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_je, l_je)))) <= 2.2250738585072014e-308 then
										l_i := (0).to_natural_32
										from
										until
											not (l_i < l_N)
										loop
											gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_set (a_evec, l_i, l_je, l_z_zero)
											l_i := l_i + 1
										end
										gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_set (a_evec, l_je, l_je, l_z_one)
										js.continue
									end
								end
								if not js.loop_jumped then
									l_i := (0).to_natural_32
									from
									until
										not (l_i < l_N)
									loop
										gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work3, l_i, 0.0)
										l_i := l_i + 1
									end
								end
							else
								l_i := (0).to_natural_32
								from
								until
									not (l_i < l_N)
								loop
									gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work3, l_i, 0.0)
									gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work4, l_i, 0.0)
									l_i := l_i + 1
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 13 -- skip if block
						end
				when 3 then -- if:
						if l_complex_pair.to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 4 then -- if:
						l_tmp___57 := fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, l_je, l_je)))
						if l_tmp___57 * l_ascale > (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_je, l_je)))) * l_bscale then
							l_tmp___55 := (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, l_je, l_je)))) * l_ascale
						else
							l_tmp___55 := (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_je, l_je)))) * l_bscale
						end
						if 2.2250738585072014e-308 > l_tmp___55 then
							l_tmp___46 := 2.2250738585072014e-308
						else
							l_tmp___43 := fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, l_je, l_je)))
							if l_tmp___43 * l_ascale > (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_je, l_je)))) * l_bscale then
								l_tmp___41 := (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, l_je, l_je)))) * l_ascale
							else
								l_tmp___41 := (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_je, l_je)))) * l_bscale
							end
							l_tmp___46 := l_tmp___41
						end
						l_temp := 1.0 / l_tmp___46
						l_salfar := (l_temp * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, l_je, l_je))) * l_ascale
						l_sbeta := (l_temp * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_je, l_je))) * l_bscale
						l_acoef := l_sbeta * l_ascale
						l_bcoefr := l_salfar * l_bscale
						l_bcoefi := 0.0
						l_scale := 1.0
						if (fabs (l_sbeta)) >= 2.2250738585072014e-308 then
							if (fabs (l_acoef)) < l_small___0 then
								l_tmp___64 := 1
							else
								l_tmp___64 := 0
							end
						else
							l_tmp___64 := 0
						end
						l_lsa := l_tmp___64
						if (fabs (l_salfar)) >= 2.2250738585072014e-308 then
							if (fabs (l_bcoefr)) < l_small___0 then
								l_tmp___67 := 1
							else
								l_tmp___67 := 0
							end
						else
							l_tmp___67 := 0
						end
						l_lsb := l_tmp___67
						if l_lsa.to_boolean then
							l_tmp___68 := fabs (l_sbeta)
							if l_anorm < l_big then
								l_tmp___69 := l_anorm
							else
								l_tmp___69 := l_big
							end
							l_scale := (l_small___0 / l_tmp___68) * l_tmp___69
						end
						if l_lsb.to_boolean then
							l_tmp___74 := fabs (l_salfar)
							if l_bnorm < l_big then
								l_tmp___75 := l_bnorm
							else
								l_tmp___75 := l_big
							end
							if l_scale > (l_small___0 / l_tmp___74) * l_tmp___75 then
								l_scale := l_scale
							else
								l_tmp___72 := fabs (l_salfar)
								if l_bnorm < l_big then
									l_tmp___73 := l_bnorm
								else
									l_tmp___73 := l_big
								end
								l_scale := (l_small___0 / l_tmp___72) * l_tmp___73
							end
						end
						if not (l_lsa.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if not (l_lsb.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						l_tmp___140 := fabs (l_acoef)
						if l_tmp___140 > (fabs (l_bcoefr)) then
							l_tmp___139 := (fabs (l_acoef))
						else
							l_tmp___139 := (fabs (l_bcoefr))
						end
						if 1.0 > l_tmp___139 then
							l_tmp___134 := 1.0
						else
							l_tmp___132 := fabs (l_acoef)
							if l_tmp___132 > (fabs (l_bcoefr)) then
								l_tmp___131 := (fabs (l_acoef))
							else
								l_tmp___131 := (fabs (l_bcoefr))
							end
							l_tmp___134 := l_tmp___131
						end
						if l_scale < 1.0 / (2.2250738585072014e-308 * l_tmp___134) then
							l_scale := l_scale
						else
							l_tmp___118 := fabs (l_acoef)
							if l_tmp___118 > (fabs (l_bcoefr)) then
								l_tmp___117 := (fabs (l_acoef))
							else
								l_tmp___117 := (fabs (l_bcoefr))
							end
							if 1.0 > l_tmp___117 then
								l_tmp___112 := 1.0
							else
								l_tmp___110 := fabs (l_acoef)
								if l_tmp___110 > (fabs (l_bcoefr)) then
									l_tmp___109 := (fabs (l_acoef))
								else
									l_tmp___109 := (fabs (l_bcoefr))
								end
								l_tmp___112 := l_tmp___109
							end
							l_scale := 1.0 / (2.2250738585072014e-308 * l_tmp___112)
						end
						if l_lsa.to_boolean then
							l_acoef := l_ascale * (l_scale * l_sbeta)
						else
							l_acoef := l_acoef * l_scale
						end
						if l_lsb.to_boolean then
							l_bcoefr := l_bscale * (l_scale * l_salfar)
						else
							l_bcoefr := l_bcoefr * l_scale
						end
				when 9 then -- if done
						l_acoefa := fabs (l_acoef)
						l_bcoefa := fabs (l_bcoefr)
						gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work3, l_je, 1.0)
						l_xmax := 1.0
						l_i := (0).to_natural_32
						from
						until
							not (l_i < l_je)
						loop
							l_tmp___142 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_i, l_je)
							gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work3, l_i, l_bcoefr * l_tmp___142 - l_acoef * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, l_i, l_je)))
							l_i := l_i + 1
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_vs.ce_gets ((submatrix_source_inst.gsl_matrix_const_submatrix (a_S, l_je - {NATURAL_32} 1, l_je - {NATURAL_32} 1, (2).to_natural_32, (2).to_natural_32)))
						l_vt.ce_gets ((submatrix_source_inst.gsl_matrix_const_submatrix (a_T, l_je - {NATURAL_32} 1, l_je - {NATURAL_32} 1, (2).to_natural_32, (2).to_natural_32)))
						schur_inst.gsl_schur_gen_eigvals ((create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vs.c_pointer + {PD_GSL_MATRIX_CONST_VIEW}.matrix_offset)), (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_vt.c_pointer + {PD_GSL_MATRIX_CONST_VIEW}.matrix_offset)), create {CE_POINTER [REAL_64]}.make_shared ($l_bcoefr), create {CE_POINTER [REAL_64]}.make_shared ($l_temp2), create {CE_POINTER [REAL_64]}.make_shared ($l_bcoefi), create {CE_POINTER [REAL_64]}.make_shared ($l_acoef), create {CE_POINTER [REAL_64]}.make_shared ($l_temp)).do_nothing
						if l_bcoefi = 0.0 then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("gsl_schur_gen_eigvals failed on complex block"), ce_string ("genv.c"), 514, -1)
								Result := (-1)
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
						if not js.return_called then
							l_acoefa := fabs (l_acoef)
							l_tmp___146 := fabs (l_bcoefr)
							l_bcoefa := l_tmp___146 + (fabs (l_bcoefi))
							l_scale := 1.0
							if l_acoefa * 2.2204460492503131e-16 < 2.2250738585072014e-308 then
								if l_acoefa >= 2.2250738585072014e-308 then
									l_scale := (2.2250738585072014e-308 / 2.2204460492503131e-16) / l_acoefa
								end
							end
							if l_bcoefa * 2.2204460492503131e-16 < 2.2250738585072014e-308 then
								if l_bcoefa >= 2.2250738585072014e-308 then
									if l_scale > (2.2250738585072014e-308 / 2.2204460492503131e-16) / l_bcoefa then
										l_scale := l_scale
									else
										l_scale := (2.2250738585072014e-308 / 2.2204460492503131e-16) / l_bcoefa
									end
								end
							end
							if 2.2250738585072014e-308 * l_acoefa > l_ascale then
								l_scale := l_ascale / (2.2250738585072014e-308 * l_acoefa)
							end
							if 2.2250738585072014e-308 * l_bcoefa > l_bscale then
								if l_scale < l_bscale / (2.2250738585072014e-308 * l_bcoefa) then
									l_scale := l_scale
								else
									l_scale := l_bscale / (2.2250738585072014e-308 * l_bcoefa)
								end
							end
							if l_scale /= 1.0 then
								l_acoef := l_acoef * l_scale
								l_acoefa := fabs (l_acoef)
								l_bcoefr := l_bcoefr * l_scale
								l_bcoefi := l_bcoefi * l_scale
								l_tmp___148 := fabs (l_bcoefr)
								l_bcoefa := l_tmp___148 + (fabs (l_bcoefi))
							end
							l_temp := l_acoef * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, l_je, l_je - {NATURAL_32} 1))
							l_tmp___151 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, l_je, l_je)
							l_temp2r := l_acoef * l_tmp___151 - l_bcoefr * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_je, l_je))
							l_temp2i := -l_bcoefi * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_je, l_je))
							l_tmp___158 := fabs (l_temp)
							l_tmp___159 := fabs (l_temp2r)
							if l_tmp___158 >= l_tmp___159 + (fabs (l_temp2i)) then
								gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work3, l_je, 1.0)
								gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work4, l_je, 0.0)
								gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work3, l_je - {NATURAL_32} 1, -l_temp2r / l_temp)
								gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work4, l_je - {NATURAL_32} 1, -l_temp2i / l_temp)
							else
								gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work3, l_je - {NATURAL_32} 1, 1.0)
								gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work4, l_je - {NATURAL_32} 1, 0.0)
								l_temp := l_acoef * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, l_je - {NATURAL_32} 1, l_je))
								l_tmp___155 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_je - {NATURAL_32} 1, l_je - {NATURAL_32} 1)
								gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work3, l_je, (l_bcoefr * l_tmp___155 - l_acoef * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, l_je - {NATURAL_32} 1, l_je - {NATURAL_32} 1))) / l_temp)
								gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work4, l_je, (l_bcoefi * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_je - {NATURAL_32} 1, l_je - {NATURAL_32} 1))) / l_temp)
							end
							l_tmp___178 := fabs ((gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_je)))
							l_tmp___180 := fabs ((gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work4, l_je)))
							l_tmp___182 := fabs ((gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_je - {NATURAL_32} 1)))
							if l_tmp___178 + l_tmp___180 > l_tmp___182 + (fabs ((gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work4, l_je - {NATURAL_32} 1)))) then
								l_tmp___170 := fabs ((gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_je)))
								l_xmax := l_tmp___170 + (fabs ((gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work4, l_je))))
							else
								l_tmp___174 := fabs ((gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_je - {NATURAL_32} 1)))
								l_xmax := l_tmp___174 + (fabs ((gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work4, l_je - {NATURAL_32} 1))))
							end
							l_creala := l_acoef * (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_je - {NATURAL_32} 1))
							l_cimaga := l_acoef * (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work4, l_je - {NATURAL_32} 1))
							l_tmp___187 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_je - {NATURAL_32} 1)
							l_crealb := l_bcoefr * l_tmp___187 - l_bcoefi * (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work4, l_je - {NATURAL_32} 1))
							l_tmp___189 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_je - {NATURAL_32} 1)
							l_cimagb := l_bcoefi * l_tmp___189 + l_bcoefr * (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work4, l_je - {NATURAL_32} 1))
							l_cre2a := l_acoef * (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_je))
							l_cim2a := l_acoef * (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work4, l_je))
							l_tmp___193 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_je)
							l_cre2b := l_bcoefr * l_tmp___193 - l_bcoefi * (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work4, l_je))
							l_tmp___195 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_je)
							l_cim2b := l_bcoefi * l_tmp___195 + l_bcoefr * (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work4, l_je))
							l_i := (0).to_natural_32
							from
							until
								not (l_i < l_je - {NATURAL_32} 1)
							loop
								l_tmp___197 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, l_i, l_je - {NATURAL_32} 1)
								l_tmp___198 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_i, l_je - {NATURAL_32} 1)
								l_tmp___199 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, l_i, l_je)
								gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work3, l_i, ((-l_creala * l_tmp___197 + l_crealb * l_tmp___198) - l_cre2a * l_tmp___199) + l_cre2b * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_i, l_je)))
								l_tmp___201 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, l_i, l_je - {NATURAL_32} 1)
								l_tmp___202 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_i, l_je - {NATURAL_32} 1)
								l_tmp___203 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, l_i, l_je)
								gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work4, l_i, ((-l_cimaga * l_tmp___201 + l_cimagb * l_tmp___202) - l_cim2a * l_tmp___203) + l_cim2b * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_i, l_je)))
								l_i := l_i + 1
							end
						end
				when 12 then -- if done
						if not js.return_called then
							if (2.2204460492503131e-16 * l_acoefa) * l_anorm > (2.2204460492503131e-16 * l_bcoefa) * l_bnorm then
								l_tmp___207 := (2.2204460492503131e-16 * l_acoefa) * l_anorm
							else
								l_tmp___207 := (2.2204460492503131e-16 * l_bcoefa) * l_bnorm
							end
							if 2.2250738585072014e-308 > l_tmp___207 then
								l_dmin := 2.2250738585072014e-308
							else
								if (2.2204460492503131e-16 * l_acoefa) * l_anorm > (2.2204460492503131e-16 * l_bcoefa) * l_bnorm then
									l_tmp___206 := (2.2204460492503131e-16 * l_acoefa) * l_anorm
								else
									l_tmp___206 := (2.2204460492503131e-16 * l_bcoefa) * l_bnorm
								end
								l_dmin := l_tmp___206
							end
							l_il2by2 := 0
							l_is := l_je.to_integer_32 - l_nw.to_integer_32
							from
							until
								not (not js.loop_left and then (l_is >= 0))
							loop
								js.reset
								l_j := l_is.to_natural_32
								if not l_il2by2.to_boolean then
									if l_j > {NATURAL_32} 0 then
										if (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, l_j, l_j - {NATURAL_32} 1)) /= 0.0 then
											l_il2by2 := 1
											js.continue
										end
									end
								end
								if not js.loop_jumped then
									l_bdiag[0] := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_j, l_j)
									if l_il2by2.to_boolean then
										l_na := (2).to_natural_32
										l_bdiag[1] := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_j + {NATURAL_32} 1, l_j + {NATURAL_32} 1)
									else
										l_na := (1).to_natural_32
									end
									if l_nw = {NATURAL_32} 1 then
										l_sv.ce_gets ((submatrix_source_inst.gsl_matrix_const_submatrix (a_S, l_j, l_j, l_na, l_na)))
										l_bv.ce_gets (subvector_source_inst.gsl_vector_subvector (a_w.item.work3, l_j, l_na))
										l_xv.ce_gets (view_source_inst.gsl_vector_view_array_with_stride (l_sum, (2).to_natural_32, l_na))
										schur_inst.gsl_schur_solve_equation (l_acoef, (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_sv.c_pointer + {PD_GSL_MATRIX_CONST_VIEW}.matrix_offset)), l_bcoefr, l_bdiag[0], l_bdiag[1], (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_bv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [REAL_64]}.make_shared ($l_scale), create {CE_POINTER [REAL_64]}.make_shared ($l_temp), l_dmin).do_nothing
									else
										l_sv___0.ce_gets ((submatrix_source_inst.gsl_matrix_const_submatrix (a_S, l_j, l_j, l_na, l_na)))
										l_xv___0.ce_gets ((view_source_inst.gsl_vector_complex_view_array (l_sum, l_na)))
										l_bv___0.ce_gets ((view_source_inst.gsl_vector_complex_view_array (l_bdat, l_na)))
										l_bdat[0] := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_j)
										l_bdat[1] := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work4, l_j)
										if l_na = {NATURAL_32} 2 then
											l_bdat[2] := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_j + {NATURAL_32} 1)
											l_bdat[3] := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work4, l_j + {NATURAL_32} 1)
										end
										from
										until
											js.loop_left
										loop
											js.reset
											l_z.dat[0] := l_bcoefr
											l_z.dat[1] := l_bcoefi
											js.break
										end
										js.reset
										schur_inst.gsl_schur_solve_equation_z (l_acoef, (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_sv___0.c_pointer + {PD_GSL_MATRIX_CONST_VIEW}.matrix_offset)), l_z.address, l_bdiag[0], l_bdiag[1], (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_bv___0.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_xv___0.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset), create {CE_POINTER [REAL_64]}.make_shared ($l_scale), create {CE_POINTER [REAL_64]}.make_shared ($l_temp), l_dmin).do_nothing
									end
									if l_scale < 1.0 then
										l_jr := (0).to_natural_32
										from
										until
											not (l_jr <= l_je)
										loop
											gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work3, l_jr, l_scale * (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_jr)))
											if l_nw = {NATURAL_32} 2 then
												gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work4, l_jr, l_scale * (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work4, l_jr)))
											end
											l_jr := l_jr + 1
										end
									end
									if l_scale * l_xmax > l_temp then
										l_xmax := l_scale * l_xmax
									else
										l_xmax := l_temp
									end
									l_jr := (0).to_natural_32
									from
									until
										not (l_jr < l_na)
									loop
										gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work3, l_j + l_jr, l_sum[(l_jr * l_na).to_integer_32])
										if l_nw = {NATURAL_32} 2 then
											gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work4, l_j + l_jr, l_sum[(l_jr * l_na + {NATURAL_32} 1).to_integer_32])
										end
										l_jr := l_jr + 1
									end
									if l_j > {NATURAL_32} 0 then
										if 1.0 > l_xmax then
											l_tmp___215 := 1.0
										else
											l_tmp___215 := l_xmax
										end
										l_xscale := 1.0 / l_tmp___215
										l_tmp___216 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work1, l_j)
										l_temp := l_acoefa * l_tmp___216 + l_bcoefa * (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work2, l_j))
										if l_il2by2.to_boolean then
											l_tmp___222 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work1, l_j + {NATURAL_32} 1)
											if l_temp > l_acoefa * l_tmp___222 + l_bcoefa * (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work2, l_j + {NATURAL_32} 1)) then
												l_temp := l_temp
											else
												l_tmp___220 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work1, l_j + {NATURAL_32} 1)
												l_temp := l_acoefa * l_tmp___220 + l_bcoefa * (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work2, l_j + {NATURAL_32} 1))
											end
										end
										if l_acoefa > l_bcoefa then
											l_tmp___226 := l_acoefa
										else
											l_tmp___226 := l_bcoefa
										end
										if l_temp > l_tmp___226 then
											l_temp := l_temp
										else
											if l_acoefa > l_bcoefa then
												l_tmp___225 := l_acoefa
											else
												l_tmp___225 := l_bcoefa
											end
											l_temp := l_tmp___225
										end
										if l_temp > l_bignum * l_xscale then
											l_jr := (0).to_natural_32
											from
											until
												not (l_jr <= l_je)
											loop
												gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work3, l_jr, l_xscale * (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_jr)))
												if l_nw = {NATURAL_32} 2 then
													gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work4, l_jr, l_xscale * (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work4, l_jr)))
												end
												l_jr := l_jr + 1
											end
											l_xmax := l_xmax * l_xscale
										end
										l_ja := (0).to_natural_32
										from
										until
											not (not js.loop_left and then (l_ja < l_na))
										loop
											if l_complex_pair.to_boolean then
												l_creala := l_acoef * (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_j + l_ja))
												l_cimaga := l_acoef * (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work4, l_j + l_ja))
												l_tmp___231 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_j + l_ja)
												l_crealb := l_bcoefr * l_tmp___231 - l_bcoefi * (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work4, l_j + l_ja))
												l_tmp___233 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_j + l_ja)
												l_cimagb := l_bcoefi * l_tmp___233 + l_bcoefr * (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work4, l_j + l_ja))
												l_jr := (0).to_natural_32
												from
												until
													not (l_jr <= l_j - {NATURAL_32} 1)
												loop
													l_tmp___235 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_jr)
													l_tmp___236 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, l_jr, l_j + l_ja)
													gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work3, l_jr, (l_tmp___235 - l_creala * l_tmp___236) + l_crealb * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_jr, l_j + l_ja)))
													l_tmp___238 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work4, l_jr)
													l_tmp___239 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, l_jr, l_j + l_ja)
													gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work4, l_jr, (l_tmp___238 - l_cimaga * l_tmp___239) + l_cimagb * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_jr, l_j + l_ja)))
													l_jr := l_jr + 1
												end
											else
												l_creala := l_acoef * (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_j + l_ja))
												l_crealb := l_bcoefr * (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_j + l_ja))
												l_jr := (0).to_natural_32
												from
												until
													not (l_jr <= l_j - {NATURAL_32} 1)
												loop
													l_tmp___243 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_jr)
													l_tmp___244 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_S, l_jr, l_j + l_ja)
													gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work3, l_jr, (l_tmp___243 - l_creala * l_tmp___244) + l_crealb * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_jr, l_j + l_ja)))
													l_jr := l_jr + 1
												end
											end
											l_ja := l_ja + 1
										end
									end
									l_il2by2 := 0
								end
								if not js.loop_left then
									l_is := l_is - 1
								end
							end
							l_jr := (0).to_natural_32
							from
							until
								not (l_jr < l_N)
							loop
								l_tmp___246 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, (0).to_natural_32)
								gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work5, l_jr, l_tmp___246 * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_Z, l_jr, (0).to_natural_32)))
								if l_nw = {NATURAL_32} 2 then
									l_tmp___248 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work4, (0).to_natural_32)
									gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work6, l_jr, l_tmp___248 * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_Z, l_jr, (0).to_natural_32)))
								end
								l_jr := l_jr + 1
							end
							l_jc := (1).to_natural_32
							from
							until
								not (not js.loop_left and then (l_jc <= l_je))
							loop
								l_jr := (0).to_natural_32
								from
								until
									not (l_jr < l_N)
								loop
									l_tmp___250 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work5, l_jr)
									l_tmp___251 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_jc)
									gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work5, l_jr, l_tmp___250 + l_tmp___251 * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_Z, l_jr, l_jc)))
									if l_nw = {NATURAL_32} 2 then
										l_tmp___253 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work6, l_jr)
										l_tmp___254 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work4, l_jc)
										gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work6, l_jr, l_tmp___253 + l_tmp___254 * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_Z, l_jr, l_jc)))
									end
									l_jr := l_jr + 1
								end
								l_jc := l_jc + 1
							end
							if l_complex_pair.to_boolean then
								l_ecol.ce_gets (rowcol_source_inst.gsl_matrix_complex_column (a_evec, l_je - {NATURAL_32} 1))
								l_re.ce_gets (reim_source_inst.gsl_vector_complex_real (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_ecol.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)))
								l_im.ce_gets (reim_source_inst.gsl_vector_complex_imag (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_ecol.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)))
								l_ecol.ce_gets (rowcol_source_inst.gsl_matrix_complex_column (a_evec, l_je))
								l_re2.ce_gets (reim_source_inst.gsl_vector_complex_real (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_ecol.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)))
								l_im2.ce_gets (reim_source_inst.gsl_vector_complex_imag (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_ecol.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)))
							else
								l_ecol.ce_gets (rowcol_source_inst.gsl_matrix_complex_column (a_evec, l_je))
								l_re.ce_gets (reim_source_inst.gsl_vector_complex_real (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_ecol.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)))
								l_im.ce_gets (reim_source_inst.gsl_vector_complex_imag (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_ecol.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)))
							end
							l_jr := (0).to_natural_32
							from
							until
								not (l_jr < l_N)
							loop
								gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_re.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_jr, (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work5, l_jr)))
								if l_complex_pair.to_boolean then
									gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_im.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_jr, (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work6, l_jr)))
									gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_re2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_jr, (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work5, l_jr)))
									gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_im2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_jr, -(gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work6, l_jr)))
								else
									gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_im.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_jr, 0.0)
								end
								l_jr := l_jr + 1
							end
							l_xmax := 0.0
							if l_complex_pair.to_boolean then
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_N)
								loop
									l_tmp___269 := fabs ((gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_re.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), l_j)))
									if l_xmax > l_tmp___269 + (fabs ((gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_im.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), l_j)))) then
										l_xmax := l_xmax
									else
										l_tmp___265 := fabs ((gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_re.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), l_j)))
										l_xmax := l_tmp___265 + (fabs ((gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_im.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), l_j))))
									end
									l_j := l_j + 1
								end
							else
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_N)
								loop
									if l_xmax > (fabs ((gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_re.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), l_j)))) then
										l_xmax := l_xmax
									else
										l_xmax := (fabs ((gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_re.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), l_j))))
									end
									l_j := l_j + 1
								end
							end
							if l_xmax > 2.2250738585072014e-308 then
								l_xscale := 1.0 / l_xmax
								l_j := (0).to_natural_32
								from
								until
									not (l_j < l_N)
								loop
									gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_re.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_j, (gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_re.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), l_j)) * l_xscale)
									if l_complex_pair.to_boolean then
										gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_im.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_j, (gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_im.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), l_j)) * l_xscale)
										gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_re2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_j, (gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_re2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), l_j)) * l_xscale)
										gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_im2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_j, (gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_im2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), l_j)) * l_xscale)
									end
									l_j := l_j + 1
								end
							end
						end
				when 13 then -- if done
						if not js.loop_left then
							l_k := l_k + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 14 then -- loop done
					if not js.return_called then
						Result := 0
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	genv_normalize_eigenvectors (a_alpha: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_evec: CE_POINTER [PD_GSL_MATRIX_COMPLEX])
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_ai: PD_GSL_COMPLEX
			l_vi: PD_GSL_VECTOR_COMPLEX_VIEW
			l_re: PD_GSL_VECTOR_VIEW
			l_im: PD_GSL_VECTOR_VIEW
			l_scale: REAL_64
			l_tmp___0: REAL_64
		do
			create l_ai.make
			create l_vi.make
			create l_re.make
			create l_im.make

			l_N := a_evec.item.size1
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_N)
			loop
				l_ai.ce_gets (gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_alpha, l_i))
				l_vi.ce_gets (rowcol_source_inst.gsl_matrix_complex_column (a_evec, l_i))
				l_re.ce_gets (reim_source_inst.gsl_vector_complex_real (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_vi.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)))
				if l_ai.dat[1] = 0.0 then
					l_scale := 1.0 / (blas_inst.gsl_blas_dnrm2 ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_re.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))))
					blas_inst.gsl_blas_dscal (l_scale, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_re.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))
				elseif l_ai.dat[1] > 0.0 then
					l_im.ce_gets (reim_source_inst.gsl_vector_complex_imag (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_vi.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)))
					l_tmp___0 := blas_inst.gsl_blas_dnrm2 ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_im.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)))
					l_scale := 1.0 / (hypot_inst.gsl_hypot ((blas_inst.gsl_blas_dnrm2 ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_re.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)))), l_tmp___0))
					blas_inst.gsl_blas_zdscal (l_scale, create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_vi.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset))
					l_vi.ce_gets (rowcol_source_inst.gsl_matrix_complex_column (a_evec, l_i + {NATURAL_32} 1))
					blas_inst.gsl_blas_zdscal (l_scale, create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_vi.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset))
				end
				l_i := l_i + 1
			end
		end

end
