class
	P_GET2D

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_histogram2d_get (a_h: CE_POINTER [PD_GSL_HISTOGRAM2D]; a_i: NATURAL_32; a_j: NATURAL_32): REAL_64
		local
			l_nx: NATURAL_32
			l_ny: NATURAL_32
			js: JUMP_STATE
		do
			l_nx := a_h.item.nx
			l_ny := a_h.item.ny
			if a_i >= l_nx then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("index i lies outside valid range of 0 .. nx - 1"), ce_string ("get2d.c"), 35, 1)
					Result := (0).to_double
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_j >= l_ny) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("index j lies outside valid range of 0 .. ny - 1"), ce_string ("get2d.c"), 41, 1)
					Result := (0).to_double
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (a_h.item.bin[(a_i * l_ny + a_j).to_integer_32])
			end
		end

	gsl_histogram2d_get_xrange (a_h: CE_POINTER [PD_GSL_HISTOGRAM2D]; a_i: NATURAL_32; a_xlower: CE_POINTER [REAL_64]; a_xupper: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_nx: NATURAL_32
			js: JUMP_STATE
		do
			l_nx := a_h.item.nx
			if a_i >= l_nx then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("index i lies outside valid range of 0 .. nx - 1"), ce_string ("get2d.c"), 55, 1)
					Result := 1
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				a_xlower.item := a_h.item.xrange[a_i.to_integer_32]
				a_xupper.item := a_h.item.xrange[(a_i + {NATURAL_32} 1).to_integer_32]
				Result := 0
			end
		end

	gsl_histogram2d_get_yrange (a_h: CE_POINTER [PD_GSL_HISTOGRAM2D]; a_j: NATURAL_32; a_ylower: CE_POINTER [REAL_64]; a_yupper: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_ny: NATURAL_32
			js: JUMP_STATE
		do
			l_ny := a_h.item.ny
			if a_j >= l_ny then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("index j lies outside valid range of 0 .. ny - 1"), ce_string ("get2d.c"), 72, 1)
					Result := 1
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				a_ylower.item := a_h.item.yrange[a_j.to_integer_32]
				a_yupper.item := a_h.item.yrange[(a_j + {NATURAL_32} 1).to_integer_32]
				Result := 0
			end
		end

	gsl_histogram2d_find (a_h: CE_POINTER [PD_GSL_HISTOGRAM2D]; a_x: REAL_64; a_y: REAL_64; a_i: CE_POINTER [NATURAL_32]; a_j: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_status := (find_inst.find___0 (a_h.item.nx, a_h.item.xrange, a_x, a_i))
			if l_status.to_boolean then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("x not found in range of h"), ce_string ("get2d.c"), 90, 1)
					Result := 1
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_status := find_inst.find___0 (a_h.item.ny, a_h.item.yrange, a_y, a_j)
				if l_status.to_boolean then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("y not found in range of h"), ce_string ("get2d.c"), 97, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

end
