class
	P_GETSET_SOURCE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_matrix_complex_long_double_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_i: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_96]
			l_row_data: CE_POINTER [REAL_96]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets ((a_m___4.item.data + (({NATURAL_32} 2 * a_i) * l_tda).to_integer_32))
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_v_data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32] := l_row_data[({NATURAL_32} 2 * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_complex_long_double_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_j: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_96]
			l_column_data: CE_POINTER [REAL_96]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets ((a_m___4.item.data + ({NATURAL_32} 2 * a_j).to_integer_32))
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_v_data[((l_stride * {NATURAL_32} 2) * l_i + l_k).to_integer_32] := l_column_data[(({NATURAL_32} 2 * l_i) * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_complex_long_double_set_row (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_i: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_96]
			l_row_data: CE_POINTER [REAL_96]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 99, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 105, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets (a_m___4.item.data + (({NATURAL_32} 2 * a_i) * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_row_data[({NATURAL_32} 2 * l_j + l_k).to_integer_32] := l_v_data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_complex_long_double_set_col (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_j: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_96]
			l_column_data: CE_POINTER [REAL_96]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 140, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 146, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets (a_m___4.item.data + ({NATURAL_32} 2 * a_j).to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_column_data[(({NATURAL_32} 2 * l_i) * l_tda + l_k).to_integer_32] := l_v_data[(({NATURAL_32} 2 * l_stride) * l_i + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_complex_long_double_alloc_row_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_i: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]
			l_M: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_M := a_m___4.item.size1
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 181, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]}.make_cast ((malloc ({PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 189, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + (({NATURAL_32} 2 * a_i) * a_m___4.item.tda).to_integer_32
				l_v.item.size := a_m___4.item.size2
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_vector_complex_long_double_alloc_col_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_j: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_N := a_m___4.item.size2
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 210, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]}.make_cast ((malloc ({PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 218, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + ({NATURAL_32} 2 * a_j).to_integer_32
				l_v.item.size := a_m___4.item.size1
				l_v.item.stride := a_m___4.item.tda
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_matrix_complex_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_i: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_64]
			l_row_data: CE_POINTER [REAL_64]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets ((a_m___4.item.data + (({NATURAL_32} 2 * a_i) * l_tda).to_integer_32))
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_v_data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32] := l_row_data[({NATURAL_32} 2 * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_complex_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_j: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_64]
			l_column_data: CE_POINTER [REAL_64]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets ((a_m___4.item.data + ({NATURAL_32} 2 * a_j).to_integer_32))
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_v_data[((l_stride * {NATURAL_32} 2) * l_i + l_k).to_integer_32] := l_column_data[(({NATURAL_32} 2 * l_i) * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_complex_set_row (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_i: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_64]
			l_row_data: CE_POINTER [REAL_64]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 99, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 105, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets (a_m___4.item.data + (({NATURAL_32} 2 * a_i) * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_row_data[({NATURAL_32} 2 * l_j + l_k).to_integer_32] := l_v_data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_complex_set_col (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_j: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_64]
			l_column_data: CE_POINTER [REAL_64]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 140, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 146, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets (a_m___4.item.data + ({NATURAL_32} 2 * a_j).to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_column_data[(({NATURAL_32} 2 * l_i) * l_tda + l_k).to_integer_32] := l_v_data[(({NATURAL_32} 2 * l_stride) * l_i + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_complex_alloc_row_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_i: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_COMPLEX]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]
			l_M: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_M := a_m___4.item.size1
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 181, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_cast ((malloc ({PD_GSL_VECTOR_COMPLEX}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 189, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + (({NATURAL_32} 2 * a_i) * a_m___4.item.tda).to_integer_32
				l_v.item.size := a_m___4.item.size2
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_vector_complex_alloc_col_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_j: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_COMPLEX]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_N := a_m___4.item.size2
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 210, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_cast ((malloc ({PD_GSL_VECTOR_COMPLEX}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 218, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + ({NATURAL_32} 2 * a_j).to_integer_32
				l_v.item.size := a_m___4.item.size1
				l_v.item.stride := a_m___4.item.tda
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_matrix_complex_float_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_i: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_32]
			l_row_data: CE_POINTER [REAL_32]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets ((a_m___4.item.data + (({NATURAL_32} 2 * a_i) * l_tda).to_integer_32))
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_v_data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32] := l_row_data[({NATURAL_32} 2 * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_complex_float_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_j: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_32]
			l_column_data: CE_POINTER [REAL_32]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets ((a_m___4.item.data + ({NATURAL_32} 2 * a_j).to_integer_32))
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_v_data[((l_stride * {NATURAL_32} 2) * l_i + l_k).to_integer_32] := l_column_data[(({NATURAL_32} 2 * l_i) * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_complex_float_set_row (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_i: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_32]
			l_row_data: CE_POINTER [REAL_32]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 99, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 105, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets (a_m___4.item.data + (({NATURAL_32} 2 * a_i) * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_row_data[({NATURAL_32} 2 * l_j + l_k).to_integer_32] := l_v_data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_complex_float_set_col (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_j: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_32]
			l_column_data: CE_POINTER [REAL_32]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 140, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 146, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets (a_m___4.item.data + ({NATURAL_32} 2 * a_j).to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_column_data[(({NATURAL_32} 2 * l_i) * l_tda + l_k).to_integer_32] := l_v_data[(({NATURAL_32} 2 * l_stride) * l_i + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_complex_float_alloc_row_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_i: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]
			l_M: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_M := a_m___4.item.size1
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 181, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]}.make_cast ((malloc ({PD_GSL_VECTOR_COMPLEX_FLOAT}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 189, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + (({NATURAL_32} 2 * a_i) * a_m___4.item.tda).to_integer_32
				l_v.item.size := a_m___4.item.size2
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_vector_complex_float_alloc_col_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_j: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_N := a_m___4.item.size2
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 210, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]}.make_cast ((malloc ({PD_GSL_VECTOR_COMPLEX_FLOAT}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 218, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + ({NATURAL_32} 2 * a_j).to_integer_32
				l_v.item.size := a_m___4.item.size1
				l_v.item.stride := a_m___4.item.tda
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_matrix_long_double_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]; a_i: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_96]
			l_row_data: CE_POINTER [REAL_96]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets ((a_m___4.item.data + (a_i * l_tda).to_integer_32))
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_j + l_k).to_integer_32] := l_row_data[(l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_long_double_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]; a_j: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_96]
			l_column_data: CE_POINTER [REAL_96]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets ((a_m___4.item.data + a_j.to_integer_32))
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_i + l_k).to_integer_32] := l_column_data[(l_i * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_long_double_set_row (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]; a_i: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_96]
			l_row_data: CE_POINTER [REAL_96]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 99, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 105, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets (a_m___4.item.data + (a_i * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_row_data[(l_j + l_k).to_integer_32] := l_v_data[(l_stride * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_long_double_set_col (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]; a_j: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_96]
			l_column_data: CE_POINTER [REAL_96]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 140, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 146, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets (a_m___4.item.data + a_j.to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_column_data[(l_i * l_tda + l_k).to_integer_32] := l_v_data[(l_stride * l_i + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_long_double_alloc_row_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]; a_i: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]
			l_M: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_M := a_m___4.item.size1
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 181, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]}.make_cast ((malloc ({PD_GSL_VECTOR_LONG_DOUBLE}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 189, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
				l_v.item.size := a_m___4.item.size2
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_vector_long_double_alloc_col_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]; a_j: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_N := a_m___4.item.size2
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 210, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]}.make_cast ((malloc ({PD_GSL_VECTOR_LONG_DOUBLE}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 218, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + a_j.to_integer_32
				l_v.item.size := a_m___4.item.size1
				l_v.item.stride := a_m___4.item.tda
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_matrix_get_row (a_v: CE_POINTER [PD_GSL_VECTOR]; a_m___4: CE_POINTER [PD_GSL_MATRIX]; a_i: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_64]
			l_row_data: CE_POINTER [REAL_64]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets ((a_m___4.item.data + (a_i * l_tda).to_integer_32))
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_j + l_k).to_integer_32] := l_row_data[(l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_get_col (a_v: CE_POINTER [PD_GSL_VECTOR]; a_m___4: CE_POINTER [PD_GSL_MATRIX]; a_j: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_64]
			l_column_data: CE_POINTER [REAL_64]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets ((a_m___4.item.data + a_j.to_integer_32))
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_i + l_k).to_integer_32] := l_column_data[(l_i * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_set_row (a_m___4: CE_POINTER [PD_GSL_MATRIX]; a_i: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_64]
			l_row_data: CE_POINTER [REAL_64]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 99, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 105, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets (a_m___4.item.data + (a_i * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_row_data[(l_j + l_k).to_integer_32] := l_v_data[(l_stride * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_set_col (a_m___4: CE_POINTER [PD_GSL_MATRIX]; a_j: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_64]
			l_column_data: CE_POINTER [REAL_64]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 140, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 146, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets (a_m___4.item.data + a_j.to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_column_data[(l_i * l_tda + l_k).to_integer_32] := l_v_data[(l_stride * l_i + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_alloc_row_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX]; a_i: NATURAL_32): CE_POINTER [PD_GSL_VECTOR]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR]
			l_M: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_M := a_m___4.item.size1
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 181, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR]}.make_cast ((malloc ({PD_GSL_VECTOR}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 189, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
				l_v.item.size := a_m___4.item.size2
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_vector_alloc_col_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX]; a_j: NATURAL_32): CE_POINTER [PD_GSL_VECTOR]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR]
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_N := a_m___4.item.size2
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 210, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR]}.make_cast ((malloc ({PD_GSL_VECTOR}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 218, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + a_j.to_integer_32
				l_v.item.size := a_m___4.item.size1
				l_v.item.stride := a_m___4.item.tda
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_matrix_float_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_i: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_32]
			l_row_data: CE_POINTER [REAL_32]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets ((a_m___4.item.data + (a_i * l_tda).to_integer_32))
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_j + l_k).to_integer_32] := l_row_data[(l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_float_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_j: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_32]
			l_column_data: CE_POINTER [REAL_32]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets ((a_m___4.item.data + a_j.to_integer_32))
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_i + l_k).to_integer_32] := l_column_data[(l_i * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_float_set_row (a_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_i: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_32]
			l_row_data: CE_POINTER [REAL_32]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 99, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 105, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets (a_m___4.item.data + (a_i * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_row_data[(l_j + l_k).to_integer_32] := l_v_data[(l_stride * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_float_set_col (a_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_j: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_32]
			l_column_data: CE_POINTER [REAL_32]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 140, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 146, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets (a_m___4.item.data + a_j.to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_column_data[(l_i * l_tda + l_k).to_integer_32] := l_v_data[(l_stride * l_i + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_float_alloc_row_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_i: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_FLOAT]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]
			l_M: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_M := a_m___4.item.size1
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 181, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_FLOAT]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_FLOAT]}.make_cast ((malloc ({PD_GSL_VECTOR_FLOAT}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 189, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_FLOAT]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
				l_v.item.size := a_m___4.item.size2
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_vector_float_alloc_col_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_j: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_FLOAT]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_N := a_m___4.item.size2
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 210, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_FLOAT]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_FLOAT]}.make_cast ((malloc ({PD_GSL_VECTOR_FLOAT}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 218, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_FLOAT]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + a_j.to_integer_32
				l_v.item.size := a_m___4.item.size1
				l_v.item.stride := a_m___4.item.tda
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_matrix_ulong_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]; a_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]; a_i: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_32]
			l_row_data: CE_POINTER [NATURAL_32]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets ((a_m___4.item.data + (a_i * l_tda).to_integer_32))
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_j + l_k).to_integer_32] := l_row_data[(l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_ulong_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]; a_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]; a_j: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_32]
			l_column_data: CE_POINTER [NATURAL_32]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets ((a_m___4.item.data + a_j.to_integer_32))
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_i + l_k).to_integer_32] := l_column_data[(l_i * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_ulong_set_row (a_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]; a_i: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_32]
			l_row_data: CE_POINTER [NATURAL_32]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 99, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 105, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets (a_m___4.item.data + (a_i * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_row_data[(l_j + l_k).to_integer_32] := l_v_data[(l_stride * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_ulong_set_col (a_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]; a_j: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_32]
			l_column_data: CE_POINTER [NATURAL_32]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 140, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 146, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets (a_m___4.item.data + a_j.to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_column_data[(l_i * l_tda + l_k).to_integer_32] := l_v_data[(l_stride * l_i + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_ulong_alloc_row_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]; a_i: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_ULONG]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_ULONG]
			l_M: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_M := a_m___4.item.size1
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 181, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_ULONG]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_ULONG]}.make_cast ((malloc ({PD_GSL_VECTOR_ULONG}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 189, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_ULONG]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
				l_v.item.size := a_m___4.item.size2
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_vector_ulong_alloc_col_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]; a_j: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_ULONG]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_ULONG]
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_N := a_m___4.item.size2
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 210, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_ULONG]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_ULONG]}.make_cast ((malloc ({PD_GSL_VECTOR_ULONG}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 218, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_ULONG]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + a_j.to_integer_32
				l_v.item.size := a_m___4.item.size1
				l_v.item.stride := a_m___4.item.tda
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_matrix_long_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_LONG]; a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]; a_i: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_32]
			l_row_data: CE_POINTER [INTEGER_32]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets ((a_m___4.item.data + (a_i * l_tda).to_integer_32))
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_j + l_k).to_integer_32] := l_row_data[(l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_long_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_LONG]; a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]; a_j: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_32]
			l_column_data: CE_POINTER [INTEGER_32]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets ((a_m___4.item.data + a_j.to_integer_32))
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_i + l_k).to_integer_32] := l_column_data[(l_i * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_long_set_row (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]; a_i: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_LONG]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_32]
			l_row_data: CE_POINTER [INTEGER_32]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 99, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 105, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets (a_m___4.item.data + (a_i * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_row_data[(l_j + l_k).to_integer_32] := l_v_data[(l_stride * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_long_set_col (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]; a_j: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_LONG]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_32]
			l_column_data: CE_POINTER [INTEGER_32]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 140, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 146, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets (a_m___4.item.data + a_j.to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_column_data[(l_i * l_tda + l_k).to_integer_32] := l_v_data[(l_stride * l_i + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_long_alloc_row_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]; a_i: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_LONG]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_LONG]
			l_M: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_M := a_m___4.item.size1
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 181, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_LONG]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_LONG]}.make_cast ((malloc ({PD_GSL_VECTOR_LONG}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 189, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_LONG]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
				l_v.item.size := a_m___4.item.size2
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_vector_long_alloc_col_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]; a_j: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_LONG]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_LONG]
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_N := a_m___4.item.size2
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 210, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_LONG]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_LONG]}.make_cast ((malloc ({PD_GSL_VECTOR_LONG}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 218, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_LONG]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + a_j.to_integer_32
				l_v.item.size := a_m___4.item.size1
				l_v.item.stride := a_m___4.item.tda
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_matrix_uint_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_UINT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]; a_i: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_32]
			l_row_data: CE_POINTER [NATURAL_32]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets ((a_m___4.item.data + (a_i * l_tda).to_integer_32))
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_j + l_k).to_integer_32] := l_row_data[(l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_uint_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_UINT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]; a_j: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_32]
			l_column_data: CE_POINTER [NATURAL_32]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets ((a_m___4.item.data + a_j.to_integer_32))
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_i + l_k).to_integer_32] := l_column_data[(l_i * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_uint_set_row (a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]; a_i: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_UINT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_32]
			l_row_data: CE_POINTER [NATURAL_32]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 99, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 105, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets (a_m___4.item.data + (a_i * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_row_data[(l_j + l_k).to_integer_32] := l_v_data[(l_stride * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_uint_set_col (a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]; a_j: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_UINT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_32]
			l_column_data: CE_POINTER [NATURAL_32]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 140, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 146, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets (a_m___4.item.data + a_j.to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_column_data[(l_i * l_tda + l_k).to_integer_32] := l_v_data[(l_stride * l_i + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_uint_alloc_row_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]; a_i: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_UINT]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_UINT]
			l_M: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_M := a_m___4.item.size1
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 181, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_UINT]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_UINT]}.make_cast ((malloc ({PD_GSL_VECTOR_UINT}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 189, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_UINT]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
				l_v.item.size := a_m___4.item.size2
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_vector_uint_alloc_col_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]; a_j: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_UINT]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_UINT]
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_N := a_m___4.item.size2
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 210, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_UINT]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_UINT]}.make_cast ((malloc ({PD_GSL_VECTOR_UINT}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 218, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_UINT]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + a_j.to_integer_32
				l_v.item.size := a_m___4.item.size1
				l_v.item.stride := a_m___4.item.tda
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_matrix_int_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_INT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_INT]; a_i: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_32]
			l_row_data: CE_POINTER [INTEGER_32]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets ((a_m___4.item.data + (a_i * l_tda).to_integer_32))
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_j + l_k).to_integer_32] := l_row_data[(l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_int_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_INT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_INT]; a_j: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_32]
			l_column_data: CE_POINTER [INTEGER_32]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets ((a_m___4.item.data + a_j.to_integer_32))
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_i + l_k).to_integer_32] := l_column_data[(l_i * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_int_set_row (a_m___4: CE_POINTER [PD_GSL_MATRIX_INT]; a_i: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_INT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_32]
			l_row_data: CE_POINTER [INTEGER_32]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 99, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 105, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets (a_m___4.item.data + (a_i * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_row_data[(l_j + l_k).to_integer_32] := l_v_data[(l_stride * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_int_set_col (a_m___4: CE_POINTER [PD_GSL_MATRIX_INT]; a_j: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_INT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_32]
			l_column_data: CE_POINTER [INTEGER_32]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 140, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 146, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets (a_m___4.item.data + a_j.to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_column_data[(l_i * l_tda + l_k).to_integer_32] := l_v_data[(l_stride * l_i + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_int_alloc_row_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_INT]; a_i: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_INT]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_INT]
			l_M: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_M := a_m___4.item.size1
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 181, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_INT]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_INT]}.make_cast ((malloc ({PD_GSL_VECTOR_INT}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 189, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_INT]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
				l_v.item.size := a_m___4.item.size2
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_vector_int_alloc_col_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_INT]; a_j: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_INT]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_INT]
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_N := a_m___4.item.size2
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 210, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_INT]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_INT]}.make_cast ((malloc ({PD_GSL_VECTOR_INT}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 218, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_INT]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + a_j.to_integer_32
				l_v.item.size := a_m___4.item.size1
				l_v.item.stride := a_m___4.item.tda
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_matrix_ushort_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]; a_i: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_16]
			l_row_data: CE_POINTER [NATURAL_16]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets ((a_m___4.item.data + (a_i * l_tda).to_integer_32))
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_j + l_k).to_integer_32] := l_row_data[(l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_ushort_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]; a_j: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_16]
			l_column_data: CE_POINTER [NATURAL_16]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets ((a_m___4.item.data + a_j.to_integer_32))
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_i + l_k).to_integer_32] := l_column_data[(l_i * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_ushort_set_row (a_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]; a_i: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_16]
			l_row_data: CE_POINTER [NATURAL_16]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 99, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 105, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets (a_m___4.item.data + (a_i * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_row_data[(l_j + l_k).to_integer_32] := l_v_data[(l_stride * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_ushort_set_col (a_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]; a_j: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_16]
			l_column_data: CE_POINTER [NATURAL_16]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 140, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 146, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets (a_m___4.item.data + a_j.to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_column_data[(l_i * l_tda + l_k).to_integer_32] := l_v_data[(l_stride * l_i + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_ushort_alloc_row_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]; a_i: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_USHORT]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_USHORT]
			l_M: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_M := a_m___4.item.size1
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 181, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_USHORT]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_USHORT]}.make_cast ((malloc ({PD_GSL_VECTOR_USHORT}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 189, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_USHORT]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
				l_v.item.size := a_m___4.item.size2
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_vector_ushort_alloc_col_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]; a_j: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_USHORT]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_USHORT]
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_N := a_m___4.item.size2
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 210, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_USHORT]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_USHORT]}.make_cast ((malloc ({PD_GSL_VECTOR_USHORT}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 218, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_USHORT]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + a_j.to_integer_32
				l_v.item.size := a_m___4.item.size1
				l_v.item.stride := a_m___4.item.tda
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_matrix_short_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]; a_i: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_16]
			l_row_data: CE_POINTER [INTEGER_16]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets ((a_m___4.item.data + (a_i * l_tda).to_integer_32))
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_j + l_k).to_integer_32] := l_row_data[(l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_short_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]; a_j: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_16]
			l_column_data: CE_POINTER [INTEGER_16]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets ((a_m___4.item.data + a_j.to_integer_32))
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_i + l_k).to_integer_32] := l_column_data[(l_i * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_short_set_row (a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]; a_i: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_16]
			l_row_data: CE_POINTER [INTEGER_16]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 99, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 105, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets (a_m___4.item.data + (a_i * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_row_data[(l_j + l_k).to_integer_32] := l_v_data[(l_stride * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_short_set_col (a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]; a_j: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_16]
			l_column_data: CE_POINTER [INTEGER_16]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 140, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 146, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets (a_m___4.item.data + a_j.to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_column_data[(l_i * l_tda + l_k).to_integer_32] := l_v_data[(l_stride * l_i + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_short_alloc_row_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]; a_i: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_SHORT]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_SHORT]
			l_M: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_M := a_m___4.item.size1
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 181, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_SHORT]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_SHORT]}.make_cast ((malloc ({PD_GSL_VECTOR_SHORT}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 189, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_SHORT]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
				l_v.item.size := a_m___4.item.size2
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_vector_short_alloc_col_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]; a_j: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_SHORT]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_SHORT]
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_N := a_m___4.item.size2
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 210, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_SHORT]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_SHORT]}.make_cast ((malloc ({PD_GSL_VECTOR_SHORT}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 218, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_SHORT]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + a_j.to_integer_32
				l_v.item.size := a_m___4.item.size1
				l_v.item.stride := a_m___4.item.tda
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_matrix_uchar_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]; a_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]; a_i: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_8]
			l_row_data: CE_POINTER [NATURAL_8]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets ((a_m___4.item.data + (a_i * l_tda).to_integer_32))
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_j + l_k).to_integer_32] := l_row_data[(l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_uchar_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]; a_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]; a_j: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_8]
			l_column_data: CE_POINTER [NATURAL_8]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets ((a_m___4.item.data + a_j.to_integer_32))
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_i + l_k).to_integer_32] := l_column_data[(l_i * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_uchar_set_row (a_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]; a_i: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_8]
			l_row_data: CE_POINTER [NATURAL_8]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 99, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 105, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets (a_m___4.item.data + (a_i * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_row_data[(l_j + l_k).to_integer_32] := l_v_data[(l_stride * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_uchar_set_col (a_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]; a_j: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_8]
			l_column_data: CE_POINTER [NATURAL_8]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 140, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 146, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets (a_m___4.item.data + a_j.to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_column_data[(l_i * l_tda + l_k).to_integer_32] := l_v_data[(l_stride * l_i + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_uchar_alloc_row_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]; a_i: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_UCHAR]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]
			l_M: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_M := a_m___4.item.size1
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 181, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_UCHAR]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_UCHAR]}.make_cast ((malloc ({PD_GSL_VECTOR_UCHAR}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 189, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_UCHAR]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
				l_v.item.size := a_m___4.item.size2
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_vector_uchar_alloc_col_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]; a_j: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_UCHAR]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_N := a_m___4.item.size2
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 210, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_UCHAR]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_UCHAR]}.make_cast ((malloc ({PD_GSL_VECTOR_UCHAR}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 218, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_UCHAR]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + a_j.to_integer_32
				l_v.item.size := a_m___4.item.size1
				l_v.item.stride := a_m___4.item.tda
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_matrix_char_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]; a_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]; a_i: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_8]
			l_row_data: CE_POINTER [INTEGER_8]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets ((a_m___4.item.data + (a_i * l_tda).to_integer_32))
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_j + l_k).to_integer_32] := l_row_data[(l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_char_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]; a_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]; a_j: NATURAL_32): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_8]
			l_column_data: CE_POINTER [INTEGER_8]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets ((a_m___4.item.data + a_j.to_integer_32))
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_i + l_k).to_integer_32] := l_column_data[(l_i * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_char_set_row (a_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]; a_i: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_8]
			l_row_data: CE_POINTER [INTEGER_8]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_row_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 99, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_N) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 105, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_row_data.ce_gets (a_m___4.item.data + (a_i * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_row_data[(l_j + l_k).to_integer_32] := l_v_data[(l_stride * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_char_set_col (a_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]; a_j: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_8]
			l_column_data: CE_POINTER [INTEGER_8]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			create l_v_data.make
			create l_column_data.make

			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 140, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_v.item.size /= l_M) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 146, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v_data.ce_gets (a_v.item.data)
				l_column_data.ce_gets (a_m___4.item.data + a_j.to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_column_data[(l_i * l_tda + l_k).to_integer_32] := l_v_data[(l_stride * l_i + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_char_alloc_row_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]; a_i: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_CHAR]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_CHAR]
			l_M: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_M := a_m___4.item.size1
			if a_i >= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 181, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_CHAR]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_CHAR]}.make_cast ((malloc ({PD_GSL_VECTOR_CHAR}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 189, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_CHAR]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + (a_i * a_m___4.item.tda).to_integer_32
				l_v.item.size := a_m___4.item.size2
				l_v.item.stride := (1).to_natural_32
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

	gsl_vector_char_alloc_col_from_matrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]; a_j: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_CHAR]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_CHAR]
			l_N: NATURAL_32
			js: JUMP_STATE
		do
			create l_v.make

			l_N := a_m___4.item.size2
			if a_j >= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 210, 4)
					Result := (create {CE_POINTER [PD_GSL_VECTOR_CHAR]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_v.ce_gets (create {CE_POINTER [PD_GSL_VECTOR_CHAR]}.make_cast ((malloc ({PD_GSL_VECTOR_CHAR}.sizeof.to_natural_32))))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 218, 8)
						Result := (create {CE_POINTER [PD_GSL_VECTOR_CHAR]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_v.item.data := a_m___4.item.data + a_j.to_integer_32
				l_v.item.size := a_m___4.item.size1
				l_v.item.stride := a_m___4.item.tda
				l_v.item.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				Result := l_v
			end
		end

end
