class
	P_GFSR4

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gfsr4_type.make
			create gsl_rng_gfsr4.make
		end

feature {ANY} -- attributes

	gfsr4_type: PD_GSL_RNG_TYPE

	gsl_rng_gfsr4: CE_POINTER [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	gfsr4_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_GFSR4_STATE_T]
			l_tmp: NATURAL_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_GFSR4_STATE_T]}.make_cast (a_vstate))
			l_state.item.nd := ((l_state.item.nd + 1)).bit_and (16383)
			l_tmp := (((((l_state.item.ra[((l_state.item.nd + 15913)).bit_and (16383)]).bit_xor (l_state.item.ra[((l_state.item.nd + 14798)).bit_and (16383)]))).bit_xor (l_state.item.ra[((l_state.item.nd + 9396)).bit_and (16383)]))).bit_xor (l_state.item.ra[((l_state.item.nd + 6695)).bit_and (16383)])
			l_state.item.ra[l_state.item.nd] := l_tmp
			Result := l_tmp
		end

	gfsr4_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gfsr4_get)
		end

	gfsr4_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((gfsr4_get (a_vstate)).to_real_64 / 4294967296.0)
		end

	gfsr4_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gfsr4_get_double)
		end

	gfsr4_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_GFSR4_STATE_T]
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_msb: NATURAL_32
			l_mask___0: NATURAL_32
			l_t: NATURAL_32
			l_bit: NATURAL_32
			l_k: INTEGER_32
			js: JUMP_STATE
		do
			create l_state.make

			l_s := a_s
			l_state.ce_gets (create {CE_POINTER [PD_GFSR4_STATE_T]}.make_cast (a_vstate))
			l_msb := {NATURAL_32} 2147483648
			l_mask___0 := {NATURAL_32} 4294967295
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 4357
			end
			l_i := 0
			from
			until
				not (not js.loop_left and then (l_i <= 16383))
			loop
				l_t := {NATURAL_32} 0
				l_bit := l_msb
				l_j := 0
				from
				until
					not (l_j < 32)
				loop
					l_s := ({NATURAL_32} 69069 * l_s).bit_and ({NATURAL_32} 4294967295)
					if ((l_s).bit_and (l_msb)).to_boolean then
						l_t := (l_t).bit_or (l_bit)
					end
					l_bit := (l_bit).bit_shift_right ((1))
					l_j := l_j + 1
				end
				l_state.item.ra[l_i] := l_t
				l_i := l_i + 1
			end
			l_i := 0
			from
			until
				not (l_i < 32)
			loop
				l_k := 7 + l_i * 3
				l_state.item.ra[l_k] := (l_state.item.ra[l_k]).bit_and (l_mask___0)
				l_state.item.ra[l_k] := (l_state.item.ra[l_k]).bit_or (l_msb)
				l_mask___0 := (l_mask___0).bit_shift_right ((1))
				l_msb := (l_msb).bit_shift_right ((1))
				l_i := l_i + 1
			end
			l_state.item.nd := l_i
		end

	gfsr4_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gfsr4_set)
		end

end
