class
	P_GNEWTON

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gnewton_type.make
			create gsl_multiroot_fdfsolver_gnewton.make
		end

feature {ANY} -- attributes

	gnewton_type: PD_GSL_MULTIROOT_FDFSOLVER_TYPE

	gsl_multiroot_fdfsolver_gnewton: CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER_TYPE]

feature {ANY} -- routines

	gnewton_alloc (a_vstate: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_GNEWTON_STATE_T]
			l_d: CE_POINTER [PD_GSL_VECTOR]
			l_x_trial: CE_POINTER [PD_GSL_VECTOR]
			l_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
			l_m___4: CE_POINTER [PD_GSL_MATRIX]
			js: JUMP_STATE
		do
			create l_state.make
			create l_d.make
			create l_x_trial.make
			create l_p.make
			create l_m___4.make

			l_state.ce_gets (create {CE_POINTER [PD_GNEWTON_STATE_T]}.make_cast (a_vstate))
			l_m___4.ce_gets (init_source_inst.gsl_matrix_calloc (a_n, a_n))
			if (l_m___4.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("failed to allocate space for lu"), ce_string ("gnewton.c"), 64, 8)
					Result := 8
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_state.item.lu := l_m___4
				l_p.ce_gets (init_inst.gsl_permutation_calloc (a_n))
				if (l_p.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_m___4)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for permutation"), ce_string ("gnewton.c"), 75, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.permutation := l_p
				l_d.ce_gets (init_source_inst.gsl_vector_calloc (a_n))
				if (l_d.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_inst.gsl_permutation_free (l_p)
					init_source_inst.gsl_matrix_free (l_m___4)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for d"), ce_string ("gnewton.c"), 87, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.d := l_d
				l_x_trial.ce_gets (init_source_inst.gsl_vector_calloc (a_n))
				if (l_x_trial.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_d)
					init_inst.gsl_permutation_free (l_p)
					init_source_inst.gsl_matrix_free (l_m___4)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for x_trial"), ce_string ("gnewton.c"), 100, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.x_trial := l_x_trial
				Result := 0
			end
		end

	gnewton_alloc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gnewton_alloc)
		end

	gnewton_set (a_vstate: CE_POINTER [ANY]; a_FDF: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_state: CE_POINTER [PD_GNEWTON_STATE_T]
			l_i: NATURAL_32
			l_n: NATURAL_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_GNEWTON_STATE_T]}.make_cast (a_vstate))
			l_n := a_FDF.item.n;
			(a_FDF.item.fdf).call ([a_x, a_FDF.item.params, a_f, a_J])
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				gsl_gsl_vector_double_inst.gsl_vector_set (a_dx, l_i, 0.0)
				l_i := l_i + 1
			end
			l_state.item.phi := enorm_inst.enorm___0 (a_f)
			Result := 0
		end

	gnewton_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gnewton_set)
		end

	gnewton_iterate (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_state: CE_POINTER [PD_GNEWTON_STATE_T]
			l_signum: INTEGER_32
			l_t: REAL_64
			l_phi0: REAL_64
			l_phi1: REAL_64
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_di: REAL_64
			l_xi: REAL_64
			l_status: INTEGER_32
			l_theta: REAL_64
			l_u: REAL_64
			l_di___0: REAL_64
			l_status___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_state.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state.ce_gets (create {CE_POINTER [PD_GNEWTON_STATE_T]}.make_cast (a_vstate))
					l_n := a_fdf.item.n
					copy_source_inst.gsl_matrix_memcpy (l_state.item.lu, a_J).do_nothing
					lu_inst.gsl_linalg_LU_decomp (l_state.item.lu, l_state.item.permutation, create {CE_POINTER [INTEGER_32]}.make_shared ($l_signum)).do_nothing
					lu_inst.gsl_linalg_LU_solve (l_state.item.lu, l_state.item.permutation, a_f, l_state.item.d).do_nothing
					l_t := (1).to_double
					l_phi0 := l_state.item.phi
				when 1 then -- new_step:
					l_i := (0).to_natural_32
					from
					until
						not (l_i < l_n)
					loop
						l_di := (gsl_gsl_vector_double_inst.gsl_vector_get (l_state.item.d, l_i))
						l_xi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_x, l_i))
						gsl_gsl_vector_double_inst.gsl_vector_set (l_state.item.x_trial, l_i, l_xi - l_t * l_di)
						l_i := l_i + 1
					end
					l_status := ((a_fdf.item.f).integer_32_item ([l_state.item.x_trial, a_fdf.item.params, a_f]))
					if l_status /= 0 then
						Result := 9
						js.return
					end
					if js.return_called then
						l_pos := -1 + 4 -- skip if block
					end
				when 2 then -- if:
						l_phi1 := enorm_inst.enorm___0 (a_f)
						if l_phi1 > l_phi0 then
							if l_t > 2.2204460492503131e-16 then
								l_theta := l_phi1 / l_phi0
								l_u := ((sqrt (1.0 + 6.0 * l_theta)) - 1.0) / (3.0 * l_theta)
								l_t := l_t * l_u
								l_pos := -1 + 1 -- goto new_step
							end
						end
				when 3 then
						copy_source_inst.gsl_vector_memcpy (a_x, l_state.item.x_trial).do_nothing
						l_i := (0).to_natural_32
						from
						until
							not (l_i < l_n)
						loop
							l_di___0 := (gsl_gsl_vector_double_inst.gsl_vector_get (l_state.item.d, l_i))
							gsl_gsl_vector_double_inst.gsl_vector_set (a_dx, l_i, -l_t * l_di___0)
							l_i := l_i + 1
						end
						l_status___0 := ((a_fdf.item.df).integer_32_item ([a_x, a_fdf.item.params, a_J]))
						if l_status___0 /= 0 then
							Result := 9
							js.return
						end
				when 4 then -- if done
					if not js.return_called then
						l_state.item.phi := l_phi1
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gnewton_iterate_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gnewton_iterate)
		end

	gnewton_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_GNEWTON_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_GNEWTON_STATE_T]}.make_cast (a_vstate))
			init_source_inst.gsl_vector_free (l_state.item.d)
			init_source_inst.gsl_vector_free (l_state.item.x_trial)
			init_source_inst.gsl_matrix_free (l_state.item.lu)
			init_inst.gsl_permutation_free (l_state.item.permutation)
		end

	gnewton_free_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gnewton_free)
		end

end
