class
	P_GSL_GSL_INTERP

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_interp_bsearch (a_x_array: CE_POINTER [REAL_64]; a_x: REAL_64; a_index_lo: NATURAL_32; a_index_hi: NATURAL_32): NATURAL_32
		local
			l_ilo: NATURAL_32
			l_ihi: NATURAL_32
			l_i: NATURAL_32
		do
			l_ilo := a_index_lo
			l_ihi := a_index_hi
			from
			until
				not (l_ihi > l_ilo + {NATURAL_32} 1)
			loop
				l_i := (l_ihi + l_ilo) // {NATURAL_32} 2
				if a_x_array[l_i.to_integer_32] > a_x then
					l_ihi := l_i
				else
					l_ilo := l_i
				end
			end
			Result := l_ilo
		end

	gsl_interp_accel_find (a_a___5: CE_POINTER [PD_GSL_INTERP_ACCEL]; a_xa: CE_POINTER [REAL_64]; a_len: NATURAL_32; a_x: REAL_64): NATURAL_32
		local
			l_x_index: NATURAL_32
		do
			l_x_index := a_a___5.item.cache
			if a_x < a_xa[l_x_index.to_integer_32] then
				a_a___5.item.miss_count := (a_a___5.item.miss_count) + 1
				a_a___5.item.cache := gsl_interp_bsearch (a_xa, a_x, (0).to_natural_32, l_x_index)
			elseif a_x >= a_xa[(l_x_index + {NATURAL_32} 1).to_integer_32] then
				a_a___5.item.miss_count := (a_a___5.item.miss_count) + 1
				a_a___5.item.cache := gsl_interp_bsearch (a_xa, a_x, l_x_index, a_len - {NATURAL_32} 1)
			else
				a_a___5.item.hit_count := (a_a___5.item.hit_count) + 1
			end
			Result := (a_a___5.item.cache)
		end

end
