class
	P_GSL_GSL_RNG

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_rng_get (a_r___3: CE_POINTER [PD_GSL_RNG]): NATURAL_32
		do
			Result := (((a_r___3.item.type).item.get).natural_32_item ([a_r___3.item.state]))
		end

	gsl_rng_uniform (a_r___3: CE_POINTER [PD_GSL_RNG]): REAL_64
		do
			Result := (((a_r___3.item.type).item.get_double).real_64_item ([a_r___3.item.state]))
		end

	gsl_rng_uniform_pos (a_r___3: CE_POINTER [PD_GSL_RNG]): REAL_64
		local
			l_x: REAL_64
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				l_x := ((a_r___3.item.type).item.get_double).real_64_item ([a_r___3.item.state])
				if l_x /= (0).to_double then
					js.break
				end
			end
			js.reset
			Result := l_x
		end

	gsl_rng_uniform_int (a_r___3: CE_POINTER [PD_GSL_RNG]; a_n: NATURAL_32): NATURAL_32
		local
			l_offset: NATURAL_32
			l_range: NATURAL_32
			l_scale: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_offset := (a_r___3.item.type).item.min
					l_range := ((a_r___3.item.type).item.max - l_offset)
					if not (a_n > l_range) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if a_n /= {NATURAL_32} 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("invalid n, either 0 or exceeds maximum value of generator"), ce_string ("../gsl/gsl_rng.h"), 200, 4)
							Result := {NATURAL_32} 0
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if done
						if not js.return_called then
							l_scale := l_range // a_n
							from
							until
								js.loop_left
							loop
								js.reset
								l_k := ((((a_r___3.item.type).item.get).natural_32_item ([a_r___3.item.state])) - l_offset) // l_scale
								if not (l_k >= a_n) then
									js.break
								end
							end
							js.reset
							Result := l_k
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
