class
	P_GUMBEL

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_ran_gumbel1 (a_r___3: CE_POINTER [PD_GSL_RNG]; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_z: REAL_64
			l_tmp___0: REAL_64
		do
			l_x := (gsl_gsl_rng_inst.gsl_rng_uniform_pos (a_r___3))
			l_tmp___0 := log (a_b___0)
			l_z := (l_tmp___0 - (log (-(log (l_x))))) / a_a___5
			Result := l_z
		end

	gsl_ran_gumbel1_pdf (a_x: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_p: REAL_64
		do
			l_p := (a_a___5 * a_b___0) * (exp (-(a_b___0 * (exp (-a_a___5 * a_x)) + a_a___5 * a_x)))
			Result := l_p
		end

	gsl_ran_gumbel2 (a_r___3: CE_POINTER [PD_GSL_RNG]; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_z: REAL_64
		do
			l_x := (gsl_gsl_rng_inst.gsl_rng_uniform_pos (a_r___3))
			l_z := (pow (-a_b___0 / (log (l_x)), (1).to_double / a_a___5))
			Result := l_z
		end

	gsl_ran_gumbel2_pdf (a_x: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_p: REAL_64
			l_tmp: REAL_64
		do
			if a_x <= (0).to_double then
				Result := (0).to_double
			else
				l_tmp := pow (a_x, -(a_a___5 + (1).to_double))
				l_p := ((a_b___0 * a_a___5) * l_tmp) * (exp (-a_b___0 * (pow (a_x, -a_a___5))))
				Result := l_p
			end
		end

end
