class
	P_GUMBEL1

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_cdf_gumbel1_P (a_x: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_P___2: REAL_64
		do
			l_u := a_a___5 * a_x - (log (a_b___0))
			l_P___2 := (exp (-(exp (-l_u))))
			Result := l_P___2
		end

	gsl_cdf_gumbel1_Q (a_x: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_Q___1: REAL_64
			l_P___2: REAL_64
		do
			l_u := a_a___5 * a_x - (log (a_b___0))
			l_P___2 := (exp (-(exp (-l_u))))
			if l_P___2 < 0.5 then
				l_Q___1 := (1).to_double - l_P___2
			else
				l_Q___1 := -(expm1 (-(exp (-l_u))))
			end
			Result := l_Q___1
		end

end
