class
	P_HALTON

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create halton_type.make
			create gsl_qrng_halton.make
			create prime_numbers___0.make (<<1229>>)
		end

feature {ANY} -- attributes

	halton_type: PD_GSL_QRNG_TYPE

	gsl_qrng_halton: CE_POINTER [PD_GSL_QRNG_TYPE]

	prime_numbers___0: CE_ARRAY [INTEGER_32]

feature {ANY} -- routines

	halton_state_size (a_dimension: NATURAL_32): NATURAL_32
		do
			Result := ({PD_HALTON_STATE_T}.sizeof.to_natural_32)
		end

	halton_state_size_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent halton_state_size)
		end

	halton_init (a_state: CE_POINTER [ANY]; a_dimension: NATURAL_32): INTEGER_32
		local
			l_h_state: CE_POINTER [PD_HALTON_STATE_T]
			js: JUMP_STATE
		do
			create l_h_state.make

			l_h_state.ce_gets (create {CE_POINTER [PD_HALTON_STATE_T]}.make_cast (a_state))
			l_h_state.item.sequence_count := {NATURAL_32} 0
			if a_dimension < {NATURAL_32} 1 then
				Result := 4
				js.return
			elseif a_dimension > {NATURAL_32} 1229 then
				Result := 4
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	halton_init_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent halton_init)
		end

	vdcorput___0 (a_x: INTEGER_32; a_b___0: INTEGER_32): REAL_64
		local
			l_x: INTEGER_32
			l_r___3: REAL_64
			l_v: REAL_64
			l_binv: REAL_64
		do
			l_x := a_x
			l_r___3 := 0.
			l_v := 1.
			l_binv := 1. / a_b___0.to_double
			from
			until
				not (l_x > 0)
			loop
				l_v := l_v * l_binv
				l_r___3 := l_r___3 + (l_v * (l_x \\ a_b___0).to_double)
				l_x := l_x // a_b___0
			end
			Result := l_r___3
		end

	halton_get (a_state: CE_POINTER [ANY]; a_dimension: NATURAL_32; a_v: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_h_state: CE_POINTER [PD_HALTON_STATE_T]
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			create l_h_state.make

			l_h_state.ce_gets (create {CE_POINTER [PD_HALTON_STATE_T]}.make_cast (a_state))
			if a_dimension < {NATURAL_32} 1 then
				Result := 4
				js.return
			elseif a_dimension > {NATURAL_32} 1229 then
				Result := 4
				js.return
			end
			if not js.return_called then
				l_h_state.item.sequence_count := (l_h_state.item.sequence_count) + 1
				l_i := {NATURAL_32} 0
				from
				until
					not (l_i < a_dimension)
				loop
					a_v[l_i.to_integer_32] := vdcorput___0 ((l_h_state.item.sequence_count).to_integer_32, prime_numbers___0[l_i.to_integer_32])
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	halton_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent halton_get)
		end

end
