class
	P_HC_PASS_N

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	fft_halfcomplex_pass_n (a_in: CE_POINTER [REAL_64]; a_istride: NATURAL_32; a_out: CE_POINTER [REAL_64]; a_ostride: NATURAL_32; a_factor: NATURAL_32; a_product: NATURAL_32; a_n: NATURAL_32; a_twiddle: CE_POINTER [PD_GSL_COMPLEX])
		local
			l_k: NATURAL_32
			l_k1: NATURAL_32
			l_m___4: NATURAL_32
			l_q___3: NATURAL_32
			l_product_1: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			l_d_theta: REAL_64
			l_cos_d_theta: REAL_64
			l_sin_d_theta: REAL_64
			l_dw_real: REAL_64
			l_dw_imag: REAL_64
			l_sum_real: REAL_64
			l_w_real: REAL_64
			l_w_imag: REAL_64
			l_tmp_real: REAL_64
			l_tmp_imag: REAL_64
			l_z_real: REAL_64
			l_z_imag: REAL_64
			l_tmp_real___0: REAL_64
			l_tmp_imag___0: REAL_64
			l_from_idx: NATURAL_32
			l_from_idx___0: NATURAL_32
			l_from_idx___1: NATURAL_32
			l_to_idx: NATURAL_32
			l_dw_real___0: REAL_64
			l_dw_imag___0: REAL_64
			l_z_real___0: REAL_64
			l_z_imag___0: REAL_64
			l_sum_real___0: REAL_64
			l_sum_imag: REAL_64
			l_w_real___0: REAL_64
			l_w_imag___0: REAL_64
			l_t_real: REAL_64
			l_t_imag: REAL_64
			l_tmp_real___1: REAL_64
			l_tmp_imag___1: REAL_64
			l_from0: NATURAL_32
			l_from0___0: NATURAL_32
			l_tskip: NATURAL_32
			l_to0: NATURAL_32
			l_tw_arg: REAL_64
			l_cos_tw_arg: REAL_64
			l_sin_tw_arg: REAL_64
			l_dw_real___1: REAL_64
			l_dw_imag___1: REAL_64
			l_tw_real: REAL_64
			l_tw_imag: REAL_64
			l_w_real___1: REAL_64
			l_w_imag___1: REAL_64
			l_z_real___1: REAL_64
			l_z_imag___1: REAL_64
			l_sum_real___1: REAL_64
			l_tmp_real___2: REAL_64
			l_tmp_imag___2: REAL_64
			l_t_real___0: REAL_64
			l_t_imag___0: REAL_64
			l_tmp_real___3: REAL_64
			l_tmp_imag___3: REAL_64
			l_from0___1: NATURAL_32
			l_from0___2: NATURAL_32
			l_to0___0: NATURAL_32
			js: JUMP_STATE
		do
			l_m___4 := a_n // a_factor
			l_q___3 := a_n // a_product
			l_product_1 := a_product // a_factor
			l_d_theta := (2.0 * 3.14159265358979323846) / a_factor.to_real_64
			l_cos_d_theta := (cos (l_d_theta))
			l_sin_d_theta := (sin (l_d_theta))
			l_k1 := (0).to_natural_32
			from
			until
				not (not js.loop_left and then (l_k1 < l_product_1))
			loop
				l_dw_real := 1.0
				l_dw_imag := 0.0
				l_e1 := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_e1 < a_factor))
				loop
					l_sum_real := 0.0
					l_w_real := 1.0
					l_w_imag := 0.0
					if l_e1 > {NATURAL_32} 0 then
						l_tmp_real := l_dw_real * l_cos_d_theta - l_dw_imag * l_sin_d_theta
						l_tmp_imag := l_dw_real * l_sin_d_theta + l_dw_imag * l_cos_d_theta
						l_dw_real := l_tmp_real
						l_dw_imag := l_tmp_imag
					end
					l_e2 := (0).to_natural_32
					from
					until
						not (l_e2 <= a_factor - l_e2)
					loop
						if l_e2 > {NATURAL_32} 0 then
							l_tmp_real___0 := l_dw_real * l_w_real - l_dw_imag * l_w_imag
							l_tmp_imag___0 := l_dw_real * l_w_imag + l_dw_imag * l_w_real
							l_w_real := l_tmp_real___0
							l_w_imag := l_tmp_imag___0
						end
						if l_e2 = {NATURAL_32} 0 then
							l_from_idx := (a_factor * l_k1) * l_q___3
							l_z_real := a_in[(a_istride * l_from_idx).to_integer_32]
							l_z_imag := 0.0
							l_sum_real := l_sum_real + (l_w_real * l_z_real - l_w_imag * l_z_imag)
						elseif l_e2 = a_factor - l_e2 then
							l_from_idx___0 := ((a_factor * l_q___3) * l_k1 + ({NATURAL_32} 2 * l_e2) * l_q___3) - {NATURAL_32} 1
							l_z_real := a_in[(a_istride * l_from_idx___0).to_integer_32]
							l_z_imag := 0.0
							l_sum_real := l_sum_real + (l_w_real * l_z_real)
						else
							l_from_idx___1 := ((a_factor * l_q___3) * l_k1 + ({NATURAL_32} 2 * l_e2) * l_q___3) - {NATURAL_32} 1
							l_z_real := a_in[(a_istride * l_from_idx___1).to_integer_32]
							l_z_imag := a_in[(a_istride * (l_from_idx___1 + {NATURAL_32} 1)).to_integer_32]
							l_sum_real := l_sum_real + ((2).to_double * (l_w_real * l_z_real - l_w_imag * l_z_imag))
						end
						l_e2 := l_e2 + 1
					end
					l_to_idx := l_q___3 * l_k1 + l_e1 * l_m___4
					a_out[(a_ostride * l_to_idx).to_integer_32] := l_sum_real
					l_e1 := l_e1 + 1
				end
				l_k1 := l_k1 + 1
			end
			if l_q___3 = {NATURAL_32} 1 then
				js.return
			end
			if not js.return_called then
				l_k := (1).to_natural_32
				from
				until
					not (not js.loop_left and then (l_k < (l_q___3 + {NATURAL_32} 1) // {NATURAL_32} 2))
				loop
					l_k1 := (0).to_natural_32
					from
					until
						not (not js.loop_left and then (l_k1 < l_product_1))
					loop
						l_dw_real___0 := 1.0
						l_dw_imag___0 := 0.0
						l_e1 := (0).to_natural_32
						from
						until
							not (not js.loop_left and then (l_e1 < a_factor))
						loop
							l_sum_real___0 := 0.0
							l_sum_imag := 0.0
							l_w_real___0 := 1.0
							l_w_imag___0 := 0.0
							if l_e1 > {NATURAL_32} 0 then
								l_t_real := l_dw_real___0 * l_cos_d_theta - l_dw_imag___0 * l_sin_d_theta
								l_t_imag := l_dw_real___0 * l_sin_d_theta + l_dw_imag___0 * l_cos_d_theta
								l_dw_real___0 := l_t_real
								l_dw_imag___0 := l_t_imag
							end
							l_e2 := (0).to_natural_32
							from
							until
								not (l_e2 < a_factor)
							loop
								if l_e2 > {NATURAL_32} 0 then
									l_tmp_real___1 := l_dw_real___0 * l_w_real___0 - l_dw_imag___0 * l_w_imag___0
									l_tmp_imag___1 := l_dw_real___0 * l_w_imag___0 + l_dw_imag___0 * l_w_real___0
									l_w_real___0 := l_tmp_real___1
									l_w_imag___0 := l_tmp_imag___1
								end
								if l_e2 < a_factor - l_e2 then
									l_from0 := (((a_factor * l_k1) * l_q___3 + {NATURAL_32} 2 * l_k) + ({NATURAL_32} 2 * l_e2) * l_q___3) - {NATURAL_32} 1
									l_z_real___0 := a_in[(a_istride * l_from0).to_integer_32]
									l_z_imag___0 := a_in[(a_istride * (l_from0 + {NATURAL_32} 1)).to_integer_32]
								else
									l_from0___0 := (((a_factor * l_k1) * l_q___3 - {NATURAL_32} 2 * l_k) + ({NATURAL_32} 2 * (a_factor - l_e2)) * l_q___3) - {NATURAL_32} 1
									l_z_real___0 := a_in[(a_istride * l_from0___0).to_integer_32]
									l_z_imag___0 := (-a_in[(a_istride * (l_from0___0 + {NATURAL_32} 1)).to_integer_32])
								end
								l_sum_real___0 := l_sum_real___0 + (l_w_real___0 * l_z_real___0 - l_w_imag___0 * l_z_imag___0)
								l_sum_imag := l_sum_imag + (l_w_real___0 * l_z_imag___0 + l_w_imag___0 * l_z_real___0)
								l_e2 := l_e2 + 1
							end
							if l_k = {NATURAL_32} 0 then
								l_w_real___0 := 1.0
								l_w_imag___0 := 0.0
							elseif l_e1 = {NATURAL_32} 0 then
								l_w_real___0 := 1.0
								l_w_imag___0 := 0.0
							else
								l_tskip := (l_q___3 + {NATURAL_32} 1) // {NATURAL_32} 2 - {NATURAL_32} 1
								l_w_real___0 := (a_twiddle + ((l_k - {NATURAL_32} 1) + l_tskip * (l_e1 - {NATURAL_32} 1)).to_integer_32).item.dat[0]
								l_w_imag___0 := (a_twiddle + ((l_k - {NATURAL_32} 1) + l_tskip * (l_e1 - {NATURAL_32} 1)).to_integer_32).item.dat[1]
							end
							l_to0 := ((l_k1 * l_q___3 + {NATURAL_32} 2 * l_k) + l_e1 * l_m___4) - {NATURAL_32} 1
							a_out[(a_ostride * l_to0).to_integer_32] := l_w_real___0 * l_sum_real___0 - l_w_imag___0 * l_sum_imag
							a_out[(a_ostride * (l_to0 + {NATURAL_32} 1)).to_integer_32] := l_w_real___0 * l_sum_imag + l_w_imag___0 * l_sum_real___0
							l_e1 := l_e1 + 1
						end
						l_k1 := l_k1 + 1
					end
					l_k := l_k + 1
				end
				if l_q___3 \\ {NATURAL_32} 2 = {NATURAL_32} 1 then
					js.return
				end
			end
			if not js.return_called then
				l_tw_arg := 3.14159265358979323846 / a_factor.to_real_64
				l_cos_tw_arg := (cos (l_tw_arg))
				l_sin_tw_arg := (sin (l_tw_arg))
				l_k1 := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_k1 < l_product_1))
				loop
					l_dw_real___1 := 1.0
					l_dw_imag___1 := 0.0
					l_tw_real := 1.0
					l_tw_imag := 0.0
					l_e1 := (0).to_natural_32
					from
					until
						not (not js.loop_left and then (l_e1 < a_factor))
					loop
						l_sum_real___1 := 0.0
						if l_e1 > {NATURAL_32} 0 then
							l_tmp_real___2 := l_tw_real * l_cos_tw_arg - l_tw_imag * l_sin_tw_arg
							l_tmp_imag___2 := l_tw_real * l_sin_tw_arg + l_tw_imag * l_cos_tw_arg
							l_tw_real := l_tmp_real___2
							l_tw_imag := l_tmp_imag___2
						end
						l_w_real___1 := l_tw_real
						l_w_imag___1 := l_tw_imag
						if l_e1 > {NATURAL_32} 0 then
							l_t_real___0 := l_dw_real___1 * l_cos_d_theta - l_dw_imag___1 * l_sin_d_theta
							l_t_imag___0 := l_dw_real___1 * l_sin_d_theta + l_dw_imag___1 * l_cos_d_theta
							l_dw_real___1 := l_t_real___0
							l_dw_imag___1 := l_t_imag___0
						end
						l_e2 := (0).to_natural_32
						from
						until
							not (l_e2 <= (a_factor - l_e2) - {NATURAL_32} 1)
						loop
							if l_e2 > {NATURAL_32} 0 then
								l_tmp_real___3 := l_dw_real___1 * l_w_real___1 - l_dw_imag___1 * l_w_imag___1
								l_tmp_imag___3 := l_dw_real___1 * l_w_imag___1 + l_dw_imag___1 * l_w_real___1
								l_w_real___1 := l_tmp_real___3
								l_w_imag___1 := l_tmp_imag___3
							end
							if l_e2 = (a_factor - l_e2) - {NATURAL_32} 1 then
								l_from0___1 := (((a_factor * l_k1) * l_q___3 + l_q___3) + ({NATURAL_32} 2 * l_e2) * l_q___3) - {NATURAL_32} 1
								l_z_real___1 := a_in[(a_istride * l_from0___1).to_integer_32]
								l_z_imag___1 := 0.0
								l_sum_real___1 := l_sum_real___1 + (l_w_real___1 * l_z_real___1 - l_w_imag___1 * l_z_imag___1)
							else
								l_from0___2 := (((a_factor * l_k1) * l_q___3 + l_q___3) + ({NATURAL_32} 2 * l_e2) * l_q___3) - {NATURAL_32} 1
								l_z_real___1 := a_in[(a_istride * l_from0___2).to_integer_32]
								l_z_imag___1 := a_in[(a_istride * (l_from0___2 + {NATURAL_32} 1)).to_integer_32]
								l_sum_real___1 := l_sum_real___1 + ((2).to_double * (l_w_real___1 * l_z_real___1 - l_w_imag___1 * l_z_imag___1))
							end
							l_e2 := l_e2 + 1
						end
						l_to0___0 := ((l_k1 * l_q___3 + l_q___3) + l_e1 * l_m___4) - {NATURAL_32} 1
						a_out[(a_ostride * l_to0___0).to_integer_32] := l_sum_real___1
						l_e1 := l_e1 + 1
					end
					l_k1 := l_k1 + 1
				end
			end
		end

	fft_halfcomplex_float_pass_n (a_in: CE_POINTER [REAL_32]; a_istride: NATURAL_32; a_out: CE_POINTER [REAL_32]; a_ostride: NATURAL_32; a_factor: NATURAL_32; a_product: NATURAL_32; a_n: NATURAL_32; a_twiddle: CE_POINTER [PD_GSL_COMPLEX_FLOAT])
		local
			l_k: NATURAL_32
			l_k1: NATURAL_32
			l_m___4: NATURAL_32
			l_q___3: NATURAL_32
			l_product_1: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			l_d_theta: REAL_64
			l_cos_d_theta: REAL_32
			l_sin_d_theta: REAL_32
			l_dw_real: REAL_32
			l_dw_imag: REAL_32
			l_sum_real: REAL_32
			l_w_real: REAL_32
			l_w_imag: REAL_32
			l_tmp_real: REAL_32
			l_tmp_imag: REAL_32
			l_z_real: REAL_32
			l_z_imag: REAL_32
			l_tmp_real___0: REAL_32
			l_tmp_imag___0: REAL_32
			l_from_idx: NATURAL_32
			l_from_idx___0: NATURAL_32
			l_from_idx___1: NATURAL_32
			l_to_idx: NATURAL_32
			l_dw_real___0: REAL_32
			l_dw_imag___0: REAL_32
			l_z_real___0: REAL_32
			l_z_imag___0: REAL_32
			l_sum_real___0: REAL_32
			l_sum_imag: REAL_32
			l_w_real___0: REAL_32
			l_w_imag___0: REAL_32
			l_t_real: REAL_32
			l_t_imag: REAL_32
			l_tmp_real___1: REAL_32
			l_tmp_imag___1: REAL_32
			l_from0: NATURAL_32
			l_from0___0: NATURAL_32
			l_tskip: NATURAL_32
			l_to0: NATURAL_32
			l_tw_arg: REAL_64
			l_cos_tw_arg: REAL_32
			l_sin_tw_arg: REAL_32
			l_dw_real___1: REAL_32
			l_dw_imag___1: REAL_32
			l_tw_real: REAL_32
			l_tw_imag: REAL_32
			l_w_real___1: REAL_32
			l_w_imag___1: REAL_32
			l_z_real___1: REAL_32
			l_z_imag___1: REAL_32
			l_sum_real___1: REAL_32
			l_tmp_real___2: REAL_32
			l_tmp_imag___2: REAL_32
			l_t_real___0: REAL_32
			l_t_imag___0: REAL_32
			l_tmp_real___3: REAL_32
			l_tmp_imag___3: REAL_32
			l_from0___1: NATURAL_32
			l_from0___2: NATURAL_32
			l_to0___0: NATURAL_32
			js: JUMP_STATE
		do
			l_m___4 := a_n // a_factor
			l_q___3 := a_n // a_product
			l_product_1 := a_product // a_factor
			l_d_theta := (2.0 * 3.14159265358979323846) / a_factor.to_real_64
			l_cos_d_theta := (cos (l_d_theta)).truncated_to_real
			l_sin_d_theta := (sin (l_d_theta)).truncated_to_real
			l_k1 := (0).to_natural_32
			from
			until
				not (not js.loop_left and then (l_k1 < l_product_1))
			loop
				l_dw_real := (1.0).truncated_to_real
				l_dw_imag := (0.0).truncated_to_real
				l_e1 := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_e1 < a_factor))
				loop
					l_sum_real := (0.0).truncated_to_real
					l_w_real := (1.0).truncated_to_real
					l_w_imag := (0.0).truncated_to_real
					if l_e1 > {NATURAL_32} 0 then
						l_tmp_real := l_dw_real * l_cos_d_theta - l_dw_imag * l_sin_d_theta
						l_tmp_imag := l_dw_real * l_sin_d_theta + l_dw_imag * l_cos_d_theta
						l_dw_real := l_tmp_real
						l_dw_imag := l_tmp_imag
					end
					l_e2 := (0).to_natural_32
					from
					until
						not (l_e2 <= a_factor - l_e2)
					loop
						if l_e2 > {NATURAL_32} 0 then
							l_tmp_real___0 := l_dw_real * l_w_real - l_dw_imag * l_w_imag
							l_tmp_imag___0 := l_dw_real * l_w_imag + l_dw_imag * l_w_real
							l_w_real := l_tmp_real___0
							l_w_imag := l_tmp_imag___0
						end
						if l_e2 = {NATURAL_32} 0 then
							l_from_idx := (a_factor * l_k1) * l_q___3
							l_z_real := a_in[(a_istride * l_from_idx).to_integer_32]
							l_z_imag := (0.0).truncated_to_real
							l_sum_real := l_sum_real + (l_w_real * l_z_real - l_w_imag * l_z_imag)
						elseif l_e2 = a_factor - l_e2 then
							l_from_idx___0 := ((a_factor * l_q___3) * l_k1 + ({NATURAL_32} 2 * l_e2) * l_q___3) - {NATURAL_32} 1
							l_z_real := a_in[(a_istride * l_from_idx___0).to_integer_32]
							l_z_imag := (0.0).truncated_to_real
							l_sum_real := l_sum_real + (l_w_real * l_z_real)
						else
							l_from_idx___1 := ((a_factor * l_q___3) * l_k1 + ({NATURAL_32} 2 * l_e2) * l_q___3) - {NATURAL_32} 1
							l_z_real := a_in[(a_istride * l_from_idx___1).to_integer_32]
							l_z_imag := a_in[(a_istride * (l_from_idx___1 + {NATURAL_32} 1)).to_integer_32]
							l_sum_real := l_sum_real + ((2).to_real * (l_w_real * l_z_real - l_w_imag * l_z_imag))
						end
						l_e2 := l_e2 + 1
					end
					l_to_idx := l_q___3 * l_k1 + l_e1 * l_m___4
					a_out[(a_ostride * l_to_idx).to_integer_32] := l_sum_real
					l_e1 := l_e1 + 1
				end
				l_k1 := l_k1 + 1
			end
			if l_q___3 = {NATURAL_32} 1 then
				js.return
			end
			if not js.return_called then
				l_k := (1).to_natural_32
				from
				until
					not (not js.loop_left and then (l_k < (l_q___3 + {NATURAL_32} 1) // {NATURAL_32} 2))
				loop
					l_k1 := (0).to_natural_32
					from
					until
						not (not js.loop_left and then (l_k1 < l_product_1))
					loop
						l_dw_real___0 := (1.0).truncated_to_real
						l_dw_imag___0 := (0.0).truncated_to_real
						l_e1 := (0).to_natural_32
						from
						until
							not (not js.loop_left and then (l_e1 < a_factor))
						loop
							l_sum_real___0 := (0.0).truncated_to_real
							l_sum_imag := (0.0).truncated_to_real
							l_w_real___0 := (1.0).truncated_to_real
							l_w_imag___0 := (0.0).truncated_to_real
							if l_e1 > {NATURAL_32} 0 then
								l_t_real := l_dw_real___0 * l_cos_d_theta - l_dw_imag___0 * l_sin_d_theta
								l_t_imag := l_dw_real___0 * l_sin_d_theta + l_dw_imag___0 * l_cos_d_theta
								l_dw_real___0 := l_t_real
								l_dw_imag___0 := l_t_imag
							end
							l_e2 := (0).to_natural_32
							from
							until
								not (l_e2 < a_factor)
							loop
								if l_e2 > {NATURAL_32} 0 then
									l_tmp_real___1 := l_dw_real___0 * l_w_real___0 - l_dw_imag___0 * l_w_imag___0
									l_tmp_imag___1 := l_dw_real___0 * l_w_imag___0 + l_dw_imag___0 * l_w_real___0
									l_w_real___0 := l_tmp_real___1
									l_w_imag___0 := l_tmp_imag___1
								end
								if l_e2 < a_factor - l_e2 then
									l_from0 := (((a_factor * l_k1) * l_q___3 + {NATURAL_32} 2 * l_k) + ({NATURAL_32} 2 * l_e2) * l_q___3) - {NATURAL_32} 1
									l_z_real___0 := a_in[(a_istride * l_from0).to_integer_32]
									l_z_imag___0 := a_in[(a_istride * (l_from0 + {NATURAL_32} 1)).to_integer_32]
								else
									l_from0___0 := (((a_factor * l_k1) * l_q___3 - {NATURAL_32} 2 * l_k) + ({NATURAL_32} 2 * (a_factor - l_e2)) * l_q___3) - {NATURAL_32} 1
									l_z_real___0 := a_in[(a_istride * l_from0___0).to_integer_32]
									l_z_imag___0 := (-a_in[(a_istride * (l_from0___0 + {NATURAL_32} 1)).to_integer_32])
								end
								l_sum_real___0 := l_sum_real___0 + (l_w_real___0 * l_z_real___0 - l_w_imag___0 * l_z_imag___0)
								l_sum_imag := l_sum_imag + (l_w_real___0 * l_z_imag___0 + l_w_imag___0 * l_z_real___0)
								l_e2 := l_e2 + 1
							end
							if l_k = {NATURAL_32} 0 then
								l_w_real___0 := (1.0).truncated_to_real
								l_w_imag___0 := (0.0).truncated_to_real
							elseif l_e1 = {NATURAL_32} 0 then
								l_w_real___0 := (1.0).truncated_to_real
								l_w_imag___0 := (0.0).truncated_to_real
							else
								l_tskip := (l_q___3 + {NATURAL_32} 1) // {NATURAL_32} 2 - {NATURAL_32} 1
								l_w_real___0 := (a_twiddle + ((l_k - {NATURAL_32} 1) + l_tskip * (l_e1 - {NATURAL_32} 1)).to_integer_32).item.dat[0]
								l_w_imag___0 := (a_twiddle + ((l_k - {NATURAL_32} 1) + l_tskip * (l_e1 - {NATURAL_32} 1)).to_integer_32).item.dat[1]
							end
							l_to0 := ((l_k1 * l_q___3 + {NATURAL_32} 2 * l_k) + l_e1 * l_m___4) - {NATURAL_32} 1
							a_out[(a_ostride * l_to0).to_integer_32] := l_w_real___0 * l_sum_real___0 - l_w_imag___0 * l_sum_imag
							a_out[(a_ostride * (l_to0 + {NATURAL_32} 1)).to_integer_32] := l_w_real___0 * l_sum_imag + l_w_imag___0 * l_sum_real___0
							l_e1 := l_e1 + 1
						end
						l_k1 := l_k1 + 1
					end
					l_k := l_k + 1
				end
				if l_q___3 \\ {NATURAL_32} 2 = {NATURAL_32} 1 then
					js.return
				end
			end
			if not js.return_called then
				l_tw_arg := 3.14159265358979323846 / a_factor.to_real_64
				l_cos_tw_arg := (cos (l_tw_arg)).truncated_to_real
				l_sin_tw_arg := (sin (l_tw_arg)).truncated_to_real
				l_k1 := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_k1 < l_product_1))
				loop
					l_dw_real___1 := (1.0).truncated_to_real
					l_dw_imag___1 := (0.0).truncated_to_real
					l_tw_real := (1.0).truncated_to_real
					l_tw_imag := (0.0).truncated_to_real
					l_e1 := (0).to_natural_32
					from
					until
						not (not js.loop_left and then (l_e1 < a_factor))
					loop
						l_sum_real___1 := (0.0).truncated_to_real
						if l_e1 > {NATURAL_32} 0 then
							l_tmp_real___2 := l_tw_real * l_cos_tw_arg - l_tw_imag * l_sin_tw_arg
							l_tmp_imag___2 := l_tw_real * l_sin_tw_arg + l_tw_imag * l_cos_tw_arg
							l_tw_real := l_tmp_real___2
							l_tw_imag := l_tmp_imag___2
						end
						l_w_real___1 := l_tw_real
						l_w_imag___1 := l_tw_imag
						if l_e1 > {NATURAL_32} 0 then
							l_t_real___0 := l_dw_real___1 * l_cos_d_theta - l_dw_imag___1 * l_sin_d_theta
							l_t_imag___0 := l_dw_real___1 * l_sin_d_theta + l_dw_imag___1 * l_cos_d_theta
							l_dw_real___1 := l_t_real___0
							l_dw_imag___1 := l_t_imag___0
						end
						l_e2 := (0).to_natural_32
						from
						until
							not (l_e2 <= (a_factor - l_e2) - {NATURAL_32} 1)
						loop
							if l_e2 > {NATURAL_32} 0 then
								l_tmp_real___3 := l_dw_real___1 * l_w_real___1 - l_dw_imag___1 * l_w_imag___1
								l_tmp_imag___3 := l_dw_real___1 * l_w_imag___1 + l_dw_imag___1 * l_w_real___1
								l_w_real___1 := l_tmp_real___3
								l_w_imag___1 := l_tmp_imag___3
							end
							if l_e2 = (a_factor - l_e2) - {NATURAL_32} 1 then
								l_from0___1 := (((a_factor * l_k1) * l_q___3 + l_q___3) + ({NATURAL_32} 2 * l_e2) * l_q___3) - {NATURAL_32} 1
								l_z_real___1 := a_in[(a_istride * l_from0___1).to_integer_32]
								l_z_imag___1 := (0.0).truncated_to_real
								l_sum_real___1 := l_sum_real___1 + (l_w_real___1 * l_z_real___1 - l_w_imag___1 * l_z_imag___1)
							else
								l_from0___2 := (((a_factor * l_k1) * l_q___3 + l_q___3) + ({NATURAL_32} 2 * l_e2) * l_q___3) - {NATURAL_32} 1
								l_z_real___1 := a_in[(a_istride * l_from0___2).to_integer_32]
								l_z_imag___1 := a_in[(a_istride * (l_from0___2 + {NATURAL_32} 1)).to_integer_32]
								l_sum_real___1 := l_sum_real___1 + ((2).to_real * (l_w_real___1 * l_z_real___1 - l_w_imag___1 * l_z_imag___1))
							end
							l_e2 := l_e2 + 1
						end
						l_to0___0 := ((l_k1 * l_q___3 + l_q___3) + l_e1 * l_m___4) - {NATURAL_32} 1
						a_out[(a_ostride * l_to0___0).to_integer_32] := l_sum_real___1
						l_e1 := l_e1 + 1
					end
					l_k1 := l_k1 + 1
				end
			end
		end

end
