class
	P_HERMV

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_eigen_hermv_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE]
		local
			l_w: CE_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE]
			js: JUMP_STATE
		do
			create l_w.make

			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension must be positive integer"), ce_string ("hermv.c"), 44, 4)
					Result := (create {CE_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_w.ce_gets (create {CE_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE]}.make_cast ((malloc ({PD_GSL_EIGEN_HERMV_WORKSPACE}.sizeof.to_natural_32))))
				if (l_w.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for workspace"), ce_string ("hermv.c"), 51, 8)
						Result := (create {CE_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_w.item.d := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_n * Real_64_bytes.to_natural_32)))
				if ((l_w.item.d).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for diagonal"), ce_string ("hermv.c"), 59, 8)
						Result := (create {CE_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_w.item.sd := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_n * Real_64_bytes.to_natural_32)))
				if ((l_w.item.sd).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.d))
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for subdiagonal"), ce_string ("hermv.c"), 68, 8)
						Result := (create {CE_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_w.item.tau := create {CE_POINTER [REAL_64]}.make_cast ((malloc (({NATURAL_32} 2 * a_n) * Real_64_bytes.to_natural_32)))
				if ((l_w.item.tau).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.sd))
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.d))
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for tau"), ce_string ("hermv.c"), 78, 8)
						Result := (create {CE_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_w.item.gc := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_n * Real_64_bytes.to_natural_32)))
				if ((l_w.item.gc).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.tau))
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.sd))
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.d))
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for cosines"), ce_string ("hermv.c"), 89, 8)
						Result := (create {CE_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_w.item.gs := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_n * Real_64_bytes.to_natural_32)))
				if ((l_w.item.gs).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.gc))
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.tau))
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.sd))
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.d))
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for sines"), ce_string ("hermv.c"), 101, 8)
						Result := (create {CE_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_w.item.size := a_n
				Result := l_w
			end
		end

	gsl_eigen_hermv_free (a_w: CE_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE])
		local
			js: JUMP_STATE
		do
			if (a_w).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (a_w.item.gs))
				free (create {CE_POINTER [ANY]}.make_cast (a_w.item.gc))
				free (create {CE_POINTER [ANY]}.make_cast (a_w.item.tau))
				free (create {CE_POINTER [ANY]}.make_cast (a_w.item.sd))
				free (create {CE_POINTER [ANY]}.make_cast (a_w.item.d))
				free (create {CE_POINTER [ANY]}.make_cast (a_w))
			end
		end

	gsl_eigen_hermv (a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_eval: CE_POINTER [PD_GSL_VECTOR]; a_evec: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_w: CE_POINTER [PD_GSL_EIGEN_HERMV_WORKSPACE]): INTEGER_32
		local
			l_N: NATURAL_32
			l_d: CE_POINTER [REAL_64]
			l_sd: CE_POINTER [REAL_64]
			l_a___5: NATURAL_32
			l_b___0: NATURAL_32
			l_A00: PD_GSL_COMPLEX
			l_d_vec: PD_GSL_VECTOR_VIEW
			l_sd_vec: PD_GSL_VECTOR_VIEW
			l_tau_vec: PD_GSL_VECTOR_COMPLEX_VIEW
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_i: NATURAL_32
			l_n_block: NATURAL_32
			l_d_block: CE_POINTER [REAL_64]
			l_sd_block: CE_POINTER [REAL_64]
			l_gc: CE_POINTER [REAL_64]
			l_gs: CE_POINTER [REAL_64]
			l_c___1: REAL_64
			l_s: REAL_64
			l_k: NATURAL_32
			l_qki: PD_GSL_COMPLEX
			l_qkj: PD_GSL_COMPLEX
			l_x1___0: PD_GSL_COMPLEX
			l_y1___0: PD_GSL_COMPLEX
			l_x2___1: PD_GSL_COMPLEX
			l_y2: PD_GSL_COMPLEX
			l_qqki: PD_GSL_COMPLEX
			l_qqkj: PD_GSL_COMPLEX
			l_d_vec___0: PD_GSL_VECTOR_VIEW
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_d.make
			create l_sd.make
			create l_A00.make
			create l_d_vec.make
			create l_sd_vec.make
			create l_tau_vec.make
			create l_d_block.make
			create l_sd_block.make
			create l_gc.make
			create l_gs.make
			create l_qki.make
			create l_qkj.make
			create l_x1___0.make
			create l_y1___0.make
			create l_x2___1.make
			create l_y2.make
			create l_qqki.make
			create l_qqkj.make
			create l_d_vec___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_A___0.item.size1 = a_A___0.item.size2 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix must be square to compute eigenvalues"), ce_string ("hermv.c"), 128, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if a_eval.item.size = a_A___0.item.size1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("eigenvalue vector must match matrix size"), ce_string ("hermv.c"), 132, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if a_evec.item.size1 = a_A___0.item.size1 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if a_evec.item.size2 = a_A___0.item.size1 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("eigenvector matrix must match matrix size"), ce_string ("hermv.c"), 136, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						l_N := a_A___0.item.size1
						l_d.ce_gets (a_w.item.d)
						l_sd.ce_gets (a_w.item.sd)
						if l_N = {NATURAL_32} 1 then
							l_A00.ce_gets ((gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, (0).to_natural_32, (0).to_natural_32)))
							gsl_gsl_vector_double_inst.gsl_vector_set (a_eval, (0).to_natural_32, l_A00.dat[0])
							gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_set (a_evec, (0).to_natural_32, (0).to_natural_32, (gsl_gsl_complex_math_inst.gsl_complex_rect (1.0, 0.0)))
							Result := 0
							js.return
						end
						if not js.return_called then
							l_d_vec.ce_gets ((view_source_inst.gsl_vector_view_array (l_d, l_N)))
							l_sd_vec.ce_gets ((view_source_inst.gsl_vector_view_array (l_sd, l_N - {NATURAL_32} 1)))
							l_tau_vec.ce_gets ((view_source_inst.gsl_vector_complex_view_array (a_w.item.tau, l_N - {NATURAL_32} 1)))
							hermtd_inst.gsl_linalg_hermtd_decomp (a_A___0, create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_tau_vec.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)).do_nothing
							hermtd_inst.gsl_linalg_hermtd_unpack (a_A___0, (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_tau_vec.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)), a_evec, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_d_vec.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_sd_vec.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)).do_nothing
							qrstep_inst.chop_small_elements (l_N, l_d, l_sd)
							l_b___0 := l_N - {NATURAL_32} 1
							from
							until
								not (not js.loop_left and then (l_b___0 > {NATURAL_32} 0))
							loop
								js.reset
								if l_sd[(l_b___0 - {NATURAL_32} 1).to_integer_32] = 0.0 then
									l_b___0 := l_b___0 - 1
									js.continue
								else
									if Real_64_bytes.to_natural_32 = Real_32_bytes.to_natural_32 then
										l_tmp___8 := (isnanf ((l_sd[(l_b___0 - {NATURAL_32} 1).to_integer_32]).truncated_to_real))
									else
										if Real_64_bytes.to_natural_32 = Real_64_bytes.to_natural_32 then
											l_tmp___7 := (isnan (l_sd[(l_b___0 - {NATURAL_32} 1).to_integer_32]))
										else
											l_tmp___7 := (isnanl (real_96_from_real_64 (l_sd[(l_b___0 - {NATURAL_32} 1).to_integer_32])))
										end
										l_tmp___8 := l_tmp___7
									end
									if l_tmp___8.to_boolean then
										l_b___0 := l_b___0 - 1
										js.continue
									end
								end
								if not js.loop_jumped then
									l_a___5 := l_b___0 - {NATURAL_32} 1
									from
									until
										not (not js.loop_left and then (l_a___5 > {NATURAL_32} 0))
									loop
										js.reset
										if l_sd[(l_a___5 - {NATURAL_32} 1).to_integer_32] = 0.0 then
											js.break
										end
										if not js.loop_jumped then
											l_a___5 := l_a___5 - 1
										end
									end
									js.reset
									l_n_block := (l_b___0 - l_a___5) + {NATURAL_32} 1
									l_d_block.ce_gets (l_d + l_a___5.to_integer_32)
									l_sd_block.ce_gets (l_sd + l_a___5.to_integer_32)
									l_gc.ce_gets (a_w.item.gc)
									l_gs.ce_gets (a_w.item.gs)
									qrstep_inst.qrstep (l_n_block, l_d_block, l_sd_block, l_gc, l_gs)
									l_i := (0).to_natural_32
									from
									until
										not (not js.loop_left and then (l_i < l_n_block - {NATURAL_32} 1))
									loop
										l_c___1 := l_gc[l_i.to_integer_32]
										l_s := l_gs[l_i.to_integer_32]
										l_k := (0).to_natural_32
										from
										until
											not (l_k < l_N)
										loop
											l_qki.ce_gets ((gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_evec, l_k, l_a___5 + l_i)))
											l_qkj.ce_gets ((gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_evec, l_k, (l_a___5 + l_i) + {NATURAL_32} 1)))
											l_x1___0.ce_gets ((math_inst.gsl_complex_mul_real (l_qki, l_c___1)))
											l_y1___0.ce_gets ((math_inst.gsl_complex_mul_real (l_qkj, -l_s)))
											l_x2___1.ce_gets ((math_inst.gsl_complex_mul_real (l_qki, l_s)))
											l_y2.ce_gets ((math_inst.gsl_complex_mul_real (l_qkj, l_c___1)))
											l_qqki.ce_gets ((math_inst.gsl_complex_add (l_x1___0, l_y1___0)))
											l_qqkj.ce_gets ((math_inst.gsl_complex_add (l_x2___1, l_y2)))
											gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_set (a_evec, l_k, l_a___5 + l_i, l_qqki)
											gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_set (a_evec, l_k, (l_a___5 + l_i) + {NATURAL_32} 1, l_qqkj)
											l_k := l_k + 1
										end
										l_i := l_i + 1
									end
									qrstep_inst.chop_small_elements (l_n_block, l_d_block, l_sd_block)
								end
							end
							l_d_vec___0.ce_gets ((view_source_inst.gsl_vector_view_array (l_d, l_N)))
							copy_source_inst.gsl_vector_memcpy (a_eval, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_d_vec___0.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))).do_nothing
							Result := 0
							js.return
						end
				when 13 then -- if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
