class
	P_HESSTRI

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_linalg_hesstri_decomp (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_B: CE_POINTER [PD_GSL_MATRIX]; a_U: CE_POINTER [PD_GSL_MATRIX]; a_V: CE_POINTER [PD_GSL_MATRIX]; a_work: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_N: NATURAL_32
			l_cs: REAL_64
			l_sn: REAL_64
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xv: PD_GSL_VECTOR_VIEW
			l_yv: PD_GSL_VECTOR_VIEW
			l_tmp: REAL_64
			l_tmp___1: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_xv.make
			create l_yv.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_N := a_A___0.item.size1
					if l_N = a_A___0.item.size2 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if l_N = a_B.item.size1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if l_N = a_B.item.size2 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("Hessenberg-triangular reduction requires square matrices"), ce_string ("hesstri.c"), 65, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						if l_N /= a_work.item.size then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("length of workspace must match matrix dimension"), ce_string ("hesstri.c"), 70, 19)
								Result := 19
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						else
							qr_inst.gsl_linalg_QR_decomp (a_B, a_work).do_nothing
							qr_inst.gsl_linalg_QR_QTmat (a_B, a_work, a_A___0).do_nothing
							if ((a_U).c_pointer /= default_pointer) then
								qr_inst.gsl_linalg_QR_unpack (a_B, a_work, a_U, a_B).do_nothing
							else
								l_j := (0).to_natural_32
								from
								until
									not (not js.loop_left and then (l_j < l_N - {NATURAL_32} 1))
								loop
									l_i := l_j + {NATURAL_32} 1
									from
									until
										not (l_i < l_N)
									loop
										gsl_gsl_matrix_double_inst.gsl_matrix_set (a_B, l_i, l_j, 0.0)
										l_i := l_i + 1
									end
									l_j := l_j + 1
								end
							end
							if ((a_V).c_pointer /= default_pointer) then
								init_source_inst.gsl_matrix_set_identity (a_V)
							end
							if l_N < {NATURAL_32} 3 then
								Result := 0
								js.return
							end
							if not js.return_called then
								l_j := (0).to_natural_32
								from
								until
									not (not js.loop_left and then (l_j < l_N - {NATURAL_32} 2))
								loop
									l_i := l_N - {NATURAL_32} 1
									from
									until
										not (l_i >= l_j + {NATURAL_32} 2)
									loop
										l_tmp := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_j)
										qrstep_inst.create_givens ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i - {NATURAL_32} 1, l_j)), l_tmp, create {CE_POINTER [REAL_64]}.make_shared ($l_cs), create {CE_POINTER [REAL_64]}.make_shared ($l_sn))
										l_sn := -l_sn
										l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_A___0, l_i - {NATURAL_32} 1, l_j, l_N - l_j))
										l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_A___0, l_i, l_j, l_N - l_j))
										blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
										l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_B, l_i - {NATURAL_32} 1, l_i - {NATURAL_32} 1, (l_N - l_i) + {NATURAL_32} 1))
										l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subrow (a_B, l_i, l_i - {NATURAL_32} 1, (l_N - l_i) + {NATURAL_32} 1))
										blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
										if ((a_U).c_pointer /= default_pointer) then
											l_xv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_U, l_i - {NATURAL_32} 1))
											l_yv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_U, l_i))
											blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
										end
										l_tmp___1 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_B, l_i, l_i - {NATURAL_32} 1)
										qrstep_inst.create_givens (-(gsl_gsl_matrix_double_inst.gsl_matrix_get (a_B, l_i, l_i)), l_tmp___1, create {CE_POINTER [REAL_64]}.make_shared ($l_cs), create {CE_POINTER [REAL_64]}.make_shared ($l_sn))
										l_sn := -l_sn
										l_xv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_B, l_i - {NATURAL_32} 1, (0).to_natural_32, l_i + {NATURAL_32} 1))
										l_yv.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_B, l_i, (0).to_natural_32, l_i + {NATURAL_32} 1))
										blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
										l_xv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_A___0, l_i - {NATURAL_32} 1))
										l_yv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_A___0, l_i))
										blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
										if ((a_V).c_pointer /= default_pointer) then
											l_xv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_V, l_i - {NATURAL_32} 1))
											l_yv.ce_gets (rowcol_source_inst.gsl_matrix_column (a_V, l_i))
											blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_yv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_cs, l_sn).do_nothing
										end
										l_i := l_i - 1
									end
									l_j := l_j + 1
								end
								Result := 0
								js.return
							end
						end
				when 10 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
