class
	P_HH

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_linalg_HH_solve (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_b___0: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			if a_A___0.item.size1 > a_A___0.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("System is underdetermined"), ce_string ("hh.c"), 41, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_A___0.item.size2 /= a_x.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix and vector sizes must be equal"), ce_string ("hh.c"), 45, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				copy_source_inst.gsl_vector_memcpy (a_x, a_b___0).do_nothing
				l_status := gsl_linalg_HH_svx (a_A___0, a_x)
				Result := l_status
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_HH_svx (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_N: NATURAL_32
			l_M: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_d: CE_POINTER [REAL_64]
			l_aii: REAL_64
			l_alpha: REAL_64
			l_f: REAL_64
			l_ak: REAL_64
			l_max_norm: REAL_64
			l_r___3: REAL_64
			l_aki: REAL_64
			l_tmp___2: REAL_64
			l_tmp___3: INTEGER_32
			l_norm___0: REAL_64
			l_ajk: REAL_64
			l_aji: REAL_64
			l_ajk___0: REAL_64
			l_aji___0: REAL_64
			l_tmp___8: REAL_64
			l_tmp___10: REAL_64
			l_xj: REAL_64
			l_aji___1: REAL_64
			l_xi: REAL_64
			l_sum: REAL_64
			l_tmp___15: REAL_64
			l_tmp___17: NATURAL_32
			js: JUMP_STATE
		do
			create l_d.make

			if a_A___0.item.size1 > a_A___0.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("System is underdetermined"), ce_string ("hh.c"), 66, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_A___0.item.size2 /= a_x.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix and vector sizes must be equal"), ce_string ("hh.c"), 70, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_N := a_A___0.item.size1
				l_M := a_A___0.item.size2
				l_d.ce_gets (create {CE_POINTER [REAL_64]}.make_cast ((malloc (l_N * Real_64_bytes.to_natural_32))))
				if (l_d.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("could not allocate memory for workspace"), ce_string ("hh.c"), 81, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
				if not js.return_called then
					l_i := (0).to_natural_32
					from
					until
						not (not js.loop_left and then (l_i < l_N))
					loop
						l_aii := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_i))
						l_max_norm := 0.0
						l_r___3 := 0.0
						l_k := l_i
						from
						until
							not (l_k < l_M)
						loop
							l_aki := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_k, l_i))
							l_r___3 := l_r___3 + (l_aki * l_aki)
							l_k := l_k + 1
						end
						if l_r___3 = 0.0 then
							free (create {CE_POINTER [ANY]}.make_cast (l_d))
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("matrix is rank deficient"), ce_string ("hh.c"), 105, 21)
								Result := 21
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
						if not js.return_called then
							l_tmp___2 := sqrt (l_r___3)
							if l_aii >= 0.0 then
								l_tmp___3 := 1
							else
								l_tmp___3 := -1
							end
							l_alpha := l_tmp___2 * l_tmp___3.to_double
							l_ak := 1.0 / (l_r___3 + l_alpha * l_aii)
							gsl_gsl_matrix_double_inst.gsl_matrix_set (a_A___0, l_i, l_i, l_aii + l_alpha)
							l_d[l_i.to_integer_32] := -l_alpha
							l_k := l_i + {NATURAL_32} 1
							from
							until
								not (not js.loop_left and then (l_k < l_N))
							loop
								l_norm___0 := 0.0
								l_f := 0.0
								l_j := l_i
								from
								until
									not (l_j < l_M)
								loop
									l_ajk := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_j, l_k))
									l_aji := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_j, l_i))
									l_norm___0 := l_norm___0 + (l_ajk * l_ajk)
									l_f := l_f + (l_ajk * l_aji)
									l_j := l_j + 1
								end
								if l_max_norm > l_norm___0 then
									l_max_norm := l_max_norm
								else
									l_max_norm := l_norm___0
								end
								l_f := l_f * l_ak
								l_j := l_i
								from
								until
									not (l_j < l_M)
								loop
									l_ajk___0 := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_j, l_k))
									l_aji___0 := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_j, l_i))
									gsl_gsl_matrix_double_inst.gsl_matrix_set (a_A___0, l_j, l_k, l_ajk___0 - l_f * l_aji___0)
									l_j := l_j + 1
								end
								l_k := l_k + 1
							end
							l_tmp___8 := fabs (l_alpha)
							if l_tmp___8 < (2.0 * 2.2204460492503131e-16) * (sqrt (l_max_norm)) then
								free (create {CE_POINTER [ANY]}.make_cast (l_d))
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("apparent singularity detected"), ce_string ("hh.c"), 142, 21)
									Result := 21
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
							end
						end
						if not js.return_called then
							l_f := 0.0
							l_j := l_i
							from
							until
								not (l_j < l_M)
							loop
								l_tmp___10 := gsl_gsl_vector_double_inst.gsl_vector_get (a_x, l_j)
								l_f := l_f + (l_tmp___10 * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_j, l_i)))
								l_j := l_j + 1
							end
							l_f := l_f * l_ak
							l_j := l_i
							from
							until
								not (l_j < l_M)
							loop
								l_xj := (gsl_gsl_vector_double_inst.gsl_vector_get (a_x, l_j))
								l_aji___1 := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_j, l_i))
								gsl_gsl_vector_double_inst.gsl_vector_set (a_x, l_j, l_xj - l_f * l_aji___1)
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
					end
				end
				if not js.return_called then
					l_i := l_N
					from
					until
						js.loop_left
					loop
						js.reset
						l_tmp___17 := l_i
						l_i := l_i - 1
						if not (l_tmp___17 > {NATURAL_32} 0) then
							js.break
						end
						if not js.loop_jumped then
							l_xi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_x, l_i))
							l_sum := 0.0
							l_k := l_i + {NATURAL_32} 1
							from
							until
								not (l_k < l_N)
							loop
								l_tmp___15 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_k)
								l_sum := l_sum + (l_tmp___15 * (gsl_gsl_vector_double_inst.gsl_vector_get (a_x, l_k)))
								l_k := l_k + 1
							end
							gsl_gsl_vector_double_inst.gsl_vector_set (a_x, l_i, (l_xi - l_sum) / l_d[l_i.to_integer_32])
						end
					end
					js.reset
					free (create {CE_POINTER [ANY]}.make_cast (l_d))
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

end
