class
	P_HOUSEHOLDERCOMPLEX

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_linalg_complex_householder_transform (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): PD_GSL_COMPLEX
		local
			l_n: NATURAL_32
			l_alpha: PD_GSL_COMPLEX
			l_absa: REAL_64
			l_beta_r: REAL_64
			l_tmp___1: INTEGER_32
			l_tau: PD_GSL_COMPLEX
			l_beta: PD_GSL_COMPLEX
			l_tau___0: PD_GSL_COMPLEX
			l_beta_r___0: REAL_64
			l_x: PD_GSL_VECTOR_COMPLEX_VIEW
			l_alpha___0: PD_GSL_COMPLEX
			l_absa___0: REAL_64
			l_xnorm: REAL_64
			l_zero: PD_GSL_COMPLEX
			l_tmp___8: INTEGER_32
			l_amb: PD_GSL_COMPLEX
			l_s: PD_GSL_COMPLEX
			l_beta___0: PD_GSL_COMPLEX
			js: JUMP_STATE
		do
			create l_alpha.make
			create l_tau.make
			create l_beta.make
			create l_tau___0.make
			create l_x.make
			create l_alpha___0.make
			create l_zero.make
			create l_amb.make
			create l_s.make
			create l_beta___0.make

			l_n := a_v.item.size
			if l_n = {NATURAL_32} 1 then
				l_alpha.ce_gets ((gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_v, (0).to_natural_32)))
				l_absa := (math_inst.gsl_complex_abs (l_alpha))
				if l_alpha.dat[0] >= (0).to_double then
					l_tmp___1 := 1
				else
					l_tmp___1 := -1
				end
				l_beta_r := (-l_tmp___1).to_double * l_absa
				if l_beta_r = 0.0 then
					l_tau.dat[0] := 0.0
					l_tau.dat[1] := 0.0
				else
					l_tau.dat[0] := (l_beta_r - l_alpha.dat[0]) / l_beta_r
					l_tau.dat[1] := -l_alpha.dat[1] / l_beta_r
					l_beta.ce_gets ((gsl_gsl_complex_math_inst.gsl_complex_rect (l_beta_r, 0.0)))
					gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_v, (0).to_natural_32, l_beta)
				end
				Result := l_tau
			else
				l_x.ce_gets ((subvector_source_inst.gsl_vector_complex_subvector (a_v, (1).to_natural_32, l_n - {NATURAL_32} 1)))
				l_alpha___0.ce_gets ((gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_v, (0).to_natural_32)))
				l_absa___0 := (math_inst.gsl_complex_abs (l_alpha___0))
				l_xnorm := (blas_inst.gsl_blas_dznrm2 ((create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_x.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset))))
				if l_xnorm = (0).to_double then
					if l_alpha___0.dat[1] = (0).to_double then
						l_zero.ce_gets ((gsl_gsl_complex_math_inst.gsl_complex_rect (0.0, 0.0)))
						Result := l_zero
						js.return
					end
				end
				if not js.return_called then
					if l_alpha___0.dat[0] >= (0).to_double then
						l_tmp___8 := 1
					else
						l_tmp___8 := -1
					end
					l_beta_r___0 := (-l_tmp___8).to_double * (hypot (l_absa___0, l_xnorm))
					l_tau___0.dat[0] := (l_beta_r___0 - l_alpha___0.dat[0]) / l_beta_r___0
					l_tau___0.dat[1] := -l_alpha___0.dat[1] / l_beta_r___0
					l_amb.ce_gets ((math_inst.gsl_complex_sub_real (l_alpha___0, l_beta_r___0)))
					l_s.ce_gets ((math_inst.gsl_complex_inverse (l_amb)))
					blas_inst.gsl_blas_zscal (l_s, create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_x.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset))
					l_beta___0.ce_gets ((gsl_gsl_complex_math_inst.gsl_complex_rect (l_beta_r___0, 0.0)))
					gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_v, (0).to_natural_32, l_beta___0)
					Result := l_tau___0
				end
			end
		end

	gsl_linalg_complex_householder_hm (a_tau: PD_GSL_COMPLEX; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_tauwj: PD_GSL_COMPLEX
			l_wj: PD_GSL_COMPLEX
			l_Aij: PD_GSL_COMPLEX
			l_vi: PD_GSL_COMPLEX
			l_Av: PD_GSL_COMPLEX
			l_A0j: PD_GSL_COMPLEX
			l_Atw: PD_GSL_COMPLEX
			l_vi___0: PD_GSL_COMPLEX
			l_tauvw: PD_GSL_COMPLEX
			l_Aij___0: PD_GSL_COMPLEX
			l_Atwv: PD_GSL_COMPLEX
			js: JUMP_STATE
		do
			create l_tauwj.make
			create l_wj.make
			create l_Aij.make
			create l_vi.make
			create l_Av.make
			create l_A0j.make
			create l_Atw.make
			create l_vi___0.make
			create l_tauvw.make
			create l_Aij___0.make
			create l_Atwv.make

			if a_tau.dat[0] = 0.0 then
				if a_tau.dat[1] = 0.0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < a_A___0.item.size2))
				loop
					l_wj.ce_gets ((gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, (0).to_natural_32, l_j)))
					l_i := (1).to_natural_32
					from
					until
						not (l_i < a_A___0.item.size1)
					loop
						l_Aij.ce_gets ((gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, l_i, l_j)))
						l_vi.ce_gets ((gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_v, l_i)))
						l_Av.ce_gets ((math_inst.gsl_complex_mul (l_Aij, (math_inst.gsl_complex_conjugate (l_vi)))))
						l_wj.ce_gets (math_inst.gsl_complex_add (l_wj, l_Av))
						l_i := l_i + 1
					end
					l_tauwj.ce_gets (math_inst.gsl_complex_mul (a_tau, l_wj))
					l_A0j.ce_gets ((gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, (0).to_natural_32, l_j)))
					l_Atw.ce_gets ((math_inst.gsl_complex_sub (l_A0j, l_tauwj)))
					gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_set (a_A___0, (0).to_natural_32, l_j, l_Atw)
					l_i := (1).to_natural_32
					from
					until
						not (l_i < a_A___0.item.size1)
					loop
						l_vi___0.ce_gets ((gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_v, l_i)))
						l_tauvw.ce_gets ((math_inst.gsl_complex_mul (l_vi___0, l_tauwj)))
						l_Aij___0.ce_gets ((gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, l_i, l_j)))
						l_Atwv.ce_gets ((math_inst.gsl_complex_sub (l_Aij___0, l_tauvw)))
						gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_set (a_A___0, l_i, l_j, l_Atwv)
						l_i := l_i + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_linalg_complex_householder_mh (a_tau: PD_GSL_COMPLEX; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_tauwi: PD_GSL_COMPLEX
			l_Ai0: PD_GSL_COMPLEX
			l_wi: PD_GSL_COMPLEX
			l_Aij: PD_GSL_COMPLEX
			l_vj: PD_GSL_COMPLEX
			l_Av: PD_GSL_COMPLEX
			l_Atw: PD_GSL_COMPLEX
			l_vj___0: PD_GSL_COMPLEX
			l_tauwv: PD_GSL_COMPLEX
			l_Aij___0: PD_GSL_COMPLEX
			l_Atwv: PD_GSL_COMPLEX
			js: JUMP_STATE
		do
			create l_tauwi.make
			create l_Ai0.make
			create l_wi.make
			create l_Aij.make
			create l_vj.make
			create l_Av.make
			create l_Atw.make
			create l_vj___0.make
			create l_tauwv.make
			create l_Aij___0.make
			create l_Atwv.make

			if a_tau.dat[0] = 0.0 then
				if a_tau.dat[1] = 0.0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_A___0.item.size1))
				loop
					l_Ai0.ce_gets ((gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, l_i, (0).to_natural_32)))
					l_wi.ce_gets (l_Ai0)
					l_j := (1).to_natural_32
					from
					until
						not (l_j < a_A___0.item.size2)
					loop
						l_Aij.ce_gets ((gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, l_i, l_j)))
						l_vj.ce_gets ((gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_v, l_j)))
						l_Av.ce_gets ((math_inst.gsl_complex_mul (l_Aij, l_vj)))
						l_wi.ce_gets (math_inst.gsl_complex_add (l_wi, l_Av))
						l_j := l_j + 1
					end
					l_tauwi.ce_gets (math_inst.gsl_complex_mul (a_tau, l_wi))
					l_Atw.ce_gets ((math_inst.gsl_complex_sub (l_Ai0, l_tauwi)))
					gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_set (a_A___0, l_i, (0).to_natural_32, l_Atw)
					l_j := (1).to_natural_32
					from
					until
						not (l_j < a_A___0.item.size2)
					loop
						l_vj___0.ce_gets ((gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_v, l_j)))
						l_tauwv.ce_gets ((math_inst.gsl_complex_mul ((math_inst.gsl_complex_conjugate (l_vj___0)), l_tauwi)))
						l_Aij___0.ce_gets ((gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, l_i, l_j)))
						l_Atwv.ce_gets ((math_inst.gsl_complex_sub (l_Aij___0, l_tauwv)))
						gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_set (a_A___0, l_i, l_j, l_Atwv)
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_linalg_complex_householder_hv (a_tau: PD_GSL_COMPLEX; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_w: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_N: NATURAL_32
			l_z0: PD_GSL_COMPLEX
			l_z1: PD_GSL_COMPLEX
			l_z: PD_GSL_COMPLEX
			l_tz: PD_GSL_COMPLEX
			l_ntz: PD_GSL_COMPLEX
			l_v1: PD_GSL_VECTOR_COMPLEX_CONST_VIEW
			l_w1: PD_GSL_VECTOR_COMPLEX_VIEW
			l_w0: PD_GSL_COMPLEX
			l_w0ntz: PD_GSL_COMPLEX
			js: JUMP_STATE
		do
			create l_z0.make
			create l_z1.make
			create l_z.make
			create l_tz.make
			create l_ntz.make
			create l_v1.make
			create l_w1.make
			create l_w0.make
			create l_w0ntz.make

			l_N := a_v.item.size
			if a_tau.dat[0] = 0.0 then
				if a_tau.dat[1] = 0.0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_z0.ce_gets ((gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_w, (0).to_natural_32)))
				l_v1.ce_gets ((subvector_source_inst.gsl_vector_complex_const_subvector (a_v, (1).to_natural_32, l_N - {NATURAL_32} 1)))
				l_w1.ce_gets ((subvector_source_inst.gsl_vector_complex_subvector (a_w, (1).to_natural_32, l_N - {NATURAL_32} 1)))
				blas_inst.gsl_blas_zdotc ((create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_v1.c_pointer + {PD_GSL_VECTOR_COMPLEX_CONST_VIEW}.vector_offset)), (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_w1.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)), l_z1.address).do_nothing
				l_z.ce_gets (math_inst.gsl_complex_add (l_z0, l_z1))
				l_tz.ce_gets (math_inst.gsl_complex_mul (a_tau, l_z))
				l_ntz.ce_gets (math_inst.gsl_complex_negative (l_tz))
				l_w0.ce_gets ((gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_w, (0).to_natural_32)))
				l_w0ntz.ce_gets ((math_inst.gsl_complex_add (l_w0, l_ntz)))
				gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_w, (0).to_natural_32, l_w0ntz)
				blas_inst.gsl_blas_zaxpy (l_ntz, (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_v1.c_pointer + {PD_GSL_VECTOR_COMPLEX_CONST_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_w1.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)).do_nothing
				Result := 0
			end
		end

end
