class
	P_HYBRID

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create hybrid_type.make
			create hybrids_type.make
			create gsl_multiroot_fsolver_hybrid.make
			create gsl_multiroot_fsolver_hybrids.make
		end

feature {ANY} -- attributes

	hybrid_type: PD_GSL_MULTIROOT_FSOLVER_TYPE

	hybrids_type: PD_GSL_MULTIROOT_FSOLVER_TYPE

	gsl_multiroot_fsolver_hybrid: CE_POINTER [PD_GSL_MULTIROOT_FSOLVER_TYPE]

	gsl_multiroot_fsolver_hybrids: CE_POINTER [PD_GSL_MULTIROOT_FSOLVER_TYPE]

feature {ANY} -- routines

	hybrid_alloc (a_vstate: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_HYBRID_STATE_T]
			l_J: CE_POINTER [PD_GSL_MATRIX]
			l_q___3: CE_POINTER [PD_GSL_MATRIX]
			l_r___3: CE_POINTER [PD_GSL_MATRIX]
			l_tau: CE_POINTER [PD_GSL_VECTOR]
			l_diag: CE_POINTER [PD_GSL_VECTOR]
			l_qtf: CE_POINTER [PD_GSL_VECTOR]
			l_newton: CE_POINTER [PD_GSL_VECTOR]
			l_gradient: CE_POINTER [PD_GSL_VECTOR]
			l_x_trial: CE_POINTER [PD_GSL_VECTOR]
			l_f_trial: CE_POINTER [PD_GSL_VECTOR]
			l_df: CE_POINTER [PD_GSL_VECTOR]
			l_qtdf: CE_POINTER [PD_GSL_VECTOR]
			l_rdx: CE_POINTER [PD_GSL_VECTOR]
			l_w: CE_POINTER [PD_GSL_VECTOR]
			l_v: CE_POINTER [PD_GSL_VECTOR]
			js: JUMP_STATE
		do
			create l_state.make
			create l_J.make
			create l_q___3.make
			create l_r___3.make
			create l_tau.make
			create l_diag.make
			create l_qtf.make
			create l_newton.make
			create l_gradient.make
			create l_x_trial.make
			create l_f_trial.make
			create l_df.make
			create l_qtdf.make
			create l_rdx.make
			create l_w.make
			create l_v.make

			l_state.ce_gets (create {CE_POINTER [PD_HYBRID_STATE_T]}.make_cast (a_vstate))
			l_J.ce_gets (init_source_inst.gsl_matrix_calloc (a_n, a_n))
			if (l_J.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("failed to allocate space for J"), ce_string ("hybrid.c"), 88, 8)
					Result := 8
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_state.item.J := l_J
				l_q___3.ce_gets (init_source_inst.gsl_matrix_calloc (a_n, a_n))
				if (l_q___3.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_J)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for q"), ce_string ("hybrid.c"), 99, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.q := l_q___3
				l_r___3.ce_gets (init_source_inst.gsl_matrix_calloc (a_n, a_n))
				if (l_r___3.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_J)
					init_source_inst.gsl_matrix_free (l_q___3)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for r"), ce_string ("hybrid.c"), 111, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.r := l_r___3
				l_tau.ce_gets (init_source_inst.gsl_vector_calloc (a_n))
				if (l_tau.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_J)
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for tau"), ce_string ("hybrid.c"), 124, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.tau := l_tau
				l_diag.ce_gets (init_source_inst.gsl_vector_calloc (a_n))
				if (l_diag.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_J)
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for diag"), ce_string ("hybrid.c"), 138, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.diag := l_diag
				l_qtf.ce_gets (init_source_inst.gsl_vector_calloc (a_n))
				if (l_qtf.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_J)
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for qtf"), ce_string ("hybrid.c"), 153, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.qtf := l_qtf
				l_newton.ce_gets (init_source_inst.gsl_vector_calloc (a_n))
				if (l_newton.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_J)
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for newton"), ce_string ("hybrid.c"), 169, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.newton := l_newton
				l_gradient.ce_gets (init_source_inst.gsl_vector_calloc (a_n))
				if (l_gradient.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_J)
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for gradient"), ce_string ("hybrid.c"), 186, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.gradient := l_gradient
				l_x_trial.ce_gets (init_source_inst.gsl_vector_calloc (a_n))
				if (l_x_trial.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_J)
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					init_source_inst.gsl_vector_free (l_gradient)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for x_trial"), ce_string ("hybrid.c"), 204, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.x_trial := l_x_trial
				l_f_trial.ce_gets (init_source_inst.gsl_vector_calloc (a_n))
				if (l_f_trial.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_J)
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					init_source_inst.gsl_vector_free (l_gradient)
					init_source_inst.gsl_vector_free (l_x_trial)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for f_trial"), ce_string ("hybrid.c"), 223, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.f_trial := l_f_trial
				l_df.ce_gets (init_source_inst.gsl_vector_calloc (a_n))
				if (l_df.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_J)
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					init_source_inst.gsl_vector_free (l_gradient)
					init_source_inst.gsl_vector_free (l_x_trial)
					init_source_inst.gsl_vector_free (l_f_trial)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for df"), ce_string ("hybrid.c"), 243, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.df := l_df
				l_qtdf.ce_gets (init_source_inst.gsl_vector_calloc (a_n))
				if (l_qtdf.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_J)
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					init_source_inst.gsl_vector_free (l_gradient)
					init_source_inst.gsl_vector_free (l_x_trial)
					init_source_inst.gsl_vector_free (l_f_trial)
					init_source_inst.gsl_vector_free (l_df)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for qtdf"), ce_string ("hybrid.c"), 264, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.qtdf := l_qtdf
				l_rdx.ce_gets (init_source_inst.gsl_vector_calloc (a_n))
				if (l_rdx.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_J)
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					init_source_inst.gsl_vector_free (l_gradient)
					init_source_inst.gsl_vector_free (l_x_trial)
					init_source_inst.gsl_vector_free (l_f_trial)
					init_source_inst.gsl_vector_free (l_df)
					init_source_inst.gsl_vector_free (l_qtdf)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for rdx"), ce_string ("hybrid.c"), 287, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.rdx := l_rdx
				l_w.ce_gets (init_source_inst.gsl_vector_calloc (a_n))
				if (l_w.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_J)
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					init_source_inst.gsl_vector_free (l_gradient)
					init_source_inst.gsl_vector_free (l_x_trial)
					init_source_inst.gsl_vector_free (l_f_trial)
					init_source_inst.gsl_vector_free (l_df)
					init_source_inst.gsl_vector_free (l_qtdf)
					init_source_inst.gsl_vector_free (l_rdx)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for w"), ce_string ("hybrid.c"), 310, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.w := l_w
				l_v.ce_gets (init_source_inst.gsl_vector_calloc (a_n))
				if (l_v.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_J)
					init_source_inst.gsl_matrix_free (l_q___3)
					init_source_inst.gsl_matrix_free (l_r___3)
					init_source_inst.gsl_vector_free (l_tau)
					init_source_inst.gsl_vector_free (l_diag)
					init_source_inst.gsl_vector_free (l_qtf)
					init_source_inst.gsl_vector_free (l_newton)
					init_source_inst.gsl_vector_free (l_gradient)
					init_source_inst.gsl_vector_free (l_x_trial)
					init_source_inst.gsl_vector_free (l_f_trial)
					init_source_inst.gsl_vector_free (l_df)
					init_source_inst.gsl_vector_free (l_qtdf)
					init_source_inst.gsl_vector_free (l_rdx)
					init_source_inst.gsl_vector_free (l_w)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for v"), ce_string ("hybrid.c"), 334, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.v := l_v
				Result := 0
			end
		end

	hybrid_alloc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent hybrid_alloc)
		end

	hybrid_set (a_vstate: CE_POINTER [ANY]; a_func: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (hybrid_set_impl (a_vstate, a_func, a_x, a_f, a_dx, 0))
			Result := l_status
		end

	hybrid_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent hybrid_set)
		end

	hybrids_set (a_vstate: CE_POINTER [ANY]; a_func: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (hybrid_set_impl (a_vstate, a_func, a_x, a_f, a_dx, 1))
			Result := l_status
		end

	hybrids_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent hybrids_set)
		end

	hybrid_set_impl (a_vstate: CE_POINTER [ANY]; a_func: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_dx: CE_POINTER [PD_GSL_VECTOR]; a_scale: INTEGER_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_HYBRID_STATE_T]
			l_J: CE_POINTER [PD_GSL_MATRIX]
			l_q___3: CE_POINTER [PD_GSL_MATRIX]
			l_r___3: CE_POINTER [PD_GSL_MATRIX]
			l_tau: CE_POINTER [PD_GSL_VECTOR]
			l_diag: CE_POINTER [PD_GSL_VECTOR]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_state.make
			create l_J.make
			create l_q___3.make
			create l_r___3.make
			create l_tau.make
			create l_diag.make

			l_state.ce_gets (create {CE_POINTER [PD_HYBRID_STATE_T]}.make_cast (a_vstate))
			l_J.ce_gets (l_state.item.J)
			l_q___3.ce_gets (l_state.item.q)
			l_r___3.ce_gets (l_state.item.r)
			l_tau.ce_gets (l_state.item.tau)
			l_diag.ce_gets (l_state.item.diag)
			l_status := (a_func.item.f).integer_32_item ([a_x, a_func.item.params, a_f])
			if l_status.to_boolean then
				Result := l_status
				js.return
			end
			if not js.return_called then
				l_status := fdjac_inst.gsl_multiroot_fdjacobian (a_func, a_x, a_f, 1.4901161193847656e-08, l_J)
				if l_status.to_boolean then
					Result := l_status
					js.return
				end
			end
			if not js.return_called then
				l_state.item.iter := (1).to_natural_32
				l_state.item.fnorm := enorm_inst.enorm___2 (a_f)
				l_state.item.ncfail := (0).to_natural_32
				l_state.item.ncsuc := (0).to_natural_32
				l_state.item.nslow1 := (0).to_natural_32
				l_state.item.nslow2 := (0).to_natural_32
				init_source_inst.gsl_vector_set_all (a_dx, 0.0)
				if a_scale.to_boolean then
					dogleg_inst.compute_diag___1 (l_J, l_diag)
				else
					init_source_inst.gsl_vector_set_all (l_diag, 1.0)
				end
				l_state.item.delta := dogleg_inst.compute_delta___1 (l_diag, a_x)
				l_status := qr_inst.gsl_linalg_QR_decomp (l_J, l_tau)
				if l_status.to_boolean then
					Result := l_status
					js.return
				end
			end
			if not js.return_called then
				l_status := qr_inst.gsl_linalg_QR_unpack (l_J, l_tau, l_q___3, l_r___3)
				Result := l_status
			end
		end

	hybrid_iterate (a_vstate: CE_POINTER [ANY]; a_func: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (hybrid_iterate_impl (a_vstate, a_func, a_x, a_f, a_dx, 0))
			Result := l_status
		end

	hybrid_iterate_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent hybrid_iterate)
		end

	hybrids_iterate (a_vstate: CE_POINTER [ANY]; a_func: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (hybrid_iterate_impl (a_vstate, a_func, a_x, a_f, a_dx, 1))
			Result := l_status
		end

	hybrids_iterate_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent hybrids_iterate)
		end

	hybrid_iterate_impl (a_vstate: CE_POINTER [ANY]; a_func: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_dx: CE_POINTER [PD_GSL_VECTOR]; a_scale: INTEGER_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_HYBRID_STATE_T]
			l_fnorm: REAL_64
			l_J: CE_POINTER [PD_GSL_MATRIX]
			l_q___3: CE_POINTER [PD_GSL_MATRIX]
			l_r___3: CE_POINTER [PD_GSL_MATRIX]
			l_tau: CE_POINTER [PD_GSL_VECTOR]
			l_diag: CE_POINTER [PD_GSL_VECTOR]
			l_qtf: CE_POINTER [PD_GSL_VECTOR]
			l_x_trial: CE_POINTER [PD_GSL_VECTOR]
			l_f_trial: CE_POINTER [PD_GSL_VECTOR]
			l_df: CE_POINTER [PD_GSL_VECTOR]
			l_qtdf: CE_POINTER [PD_GSL_VECTOR]
			l_rdx: CE_POINTER [PD_GSL_VECTOR]
			l_w: CE_POINTER [PD_GSL_VECTOR]
			l_v: CE_POINTER [PD_GSL_VECTOR]
			l_prered: REAL_64
			l_actred: REAL_64
			l_pnorm: REAL_64
			l_fnorm1: REAL_64
			l_fnorm1p: REAL_64
			l_ratio: REAL_64
			l_p1: REAL_64
			l_p5: REAL_64
			l_p001: REAL_64
			l_p0001: REAL_64
			l_status: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_state.make
			create l_J.make
			create l_q___3.make
			create l_r___3.make
			create l_tau.make
			create l_diag.make
			create l_qtf.make
			create l_x_trial.make
			create l_f_trial.make
			create l_df.make
			create l_qtdf.make
			create l_rdx.make
			create l_w.make
			create l_v.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state.ce_gets (create {CE_POINTER [PD_HYBRID_STATE_T]}.make_cast (a_vstate))
					l_fnorm := l_state.item.fnorm
					l_J.ce_gets (l_state.item.J)
					l_q___3.ce_gets (l_state.item.q)
					l_r___3.ce_gets (l_state.item.r)
					l_tau.ce_gets (l_state.item.tau)
					l_diag.ce_gets (l_state.item.diag)
					l_qtf.ce_gets (l_state.item.qtf)
					l_x_trial.ce_gets (l_state.item.x_trial)
					l_f_trial.ce_gets (l_state.item.f_trial)
					l_df.ce_gets (l_state.item.df)
					l_qtdf.ce_gets (l_state.item.qtdf)
					l_rdx.ce_gets (l_state.item.rdx)
					l_w.ce_gets (l_state.item.w)
					l_v.ce_gets (l_state.item.v)
					l_p1 := 0.1
					l_p5 := 0.5
					l_p001 := 0.001
					l_p0001 := 0.0001
					dogleg_inst.compute_qtf___0 (l_q___3, a_f, l_qtf)
					dogleg_inst.dogleg___0 (l_r___3, l_qtf, l_diag, l_state.item.delta, l_state.item.newton, l_state.item.gradient, a_dx).do_nothing
					dogleg_inst.compute_trial_step___1 (a_x, a_dx, l_state.item.x_trial)
					l_pnorm := dogleg_inst.scaled_enorm___1 (l_diag, a_dx)
					if l_state.item.iter = {NATURAL_32} 1 then
						if l_pnorm < l_state.item.delta then
							l_state.item.delta := l_pnorm
						end
					end
					l_status := ((a_func.item.f).integer_32_item ([l_x_trial, a_func.item.params, l_f_trial]))
					if l_status /= 0 then
						Result := 9
						js.return
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						dogleg_inst.compute_df___0 (l_f_trial, a_f, l_df)
						l_fnorm1 := enorm_inst.enorm___2 (l_f_trial)
						l_actred := dogleg_inst.compute_actual_reduction___1 (l_fnorm, l_fnorm1)
						dogleg_inst.compute_rdx___0 (l_r___3, a_dx, l_rdx)
						l_fnorm1p := dogleg_inst.enorm_sum___0 (l_qtf, l_rdx)
						l_prered := dogleg_inst.compute_predicted_reduction___0 (l_fnorm, l_fnorm1p)
						if l_prered > (0).to_double then
							l_ratio := l_actred / l_prered
						else
							l_ratio := (0).to_double
						end
						if not (l_ratio < l_p1) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_state.item.ncsuc := (0).to_natural_32
						l_state.item.ncfail := (l_state.item.ncfail) + 1
						l_state.item.delta := l_state.item.delta * l_p5
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 4 then -- else:
						l_state.item.ncfail := (0).to_natural_32
						l_state.item.ncsuc := (l_state.item.ncsuc) + 1
						if not (l_ratio >= l_p5) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if not (l_state.item.ncsuc > {NATURAL_32} 1) then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if l_state.item.delta > l_pnorm / l_p5 then
							l_state.item.delta := l_state.item.delta
						else
							l_state.item.delta := l_pnorm / l_p5
						end
				when 9 then -- if done
						if (fabs (l_ratio - (1).to_double)) <= l_p1 then
							l_state.item.delta := l_pnorm / l_p5
						end
				when 10 then -- if done
						if l_ratio >= l_p0001 then
							copy_source_inst.gsl_vector_memcpy (a_x, l_x_trial).do_nothing
							copy_source_inst.gsl_vector_memcpy (a_f, l_f_trial).do_nothing
							l_state.item.fnorm := l_fnorm1
							l_state.item.iter := (l_state.item.iter) + 1
						end
						l_state.item.nslow1 := (l_state.item.nslow1) + 1
						if l_actred >= l_p001 then
							l_state.item.nslow1 := (0).to_natural_32
						end
						if l_actred >= l_p1 then
							l_state.item.nslow2 := (0).to_natural_32
						end
						if l_state.item.ncfail = {NATURAL_32} 2 then
							fdjac_inst.gsl_multiroot_fdjacobian (a_func, a_x, a_f, 1.4901161193847656e-08, l_J).do_nothing
							l_state.item.nslow2 := (l_state.item.nslow2) + 1
							if l_state.item.iter = {NATURAL_32} 1 then
								if a_scale.to_boolean then
									dogleg_inst.compute_diag___1 (l_J, l_diag)
								end
								l_state.item.delta := dogleg_inst.compute_delta___1 (l_diag, a_x)
							elseif a_scale.to_boolean then
								dogleg_inst.update_diag___1 (l_J, l_diag)
							end
							qr_inst.gsl_linalg_QR_decomp (l_J, l_tau).do_nothing
							qr_inst.gsl_linalg_QR_unpack (l_J, l_tau, l_q___3, l_r___3).do_nothing
							Result := 0
							js.return
						end
				when 11 then -- if done
					if not js.return_called then
						dogleg_inst.compute_qtf___0 (l_q___3, l_df, l_qtdf)
						dogleg_inst.compute_wv___0 (l_qtdf, l_rdx, a_dx, l_diag, l_pnorm, l_w, l_v)
						qr_inst.gsl_linalg_QR_update (l_q___3, l_r___3, l_w, l_v).do_nothing
						if l_state.item.nslow2 = {NATURAL_32} 5 then
							Result := 28
							js.return
						end
					end
					if not js.return_called and then (l_state.item.nslow1 = {NATURAL_32} 10) then
						Result := 27
						js.return
					end
					if not js.return_called then
						Result := 0
					end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	hybrid_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_HYBRID_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_HYBRID_STATE_T]}.make_cast (a_vstate))
			init_source_inst.gsl_vector_free (l_state.item.v)
			init_source_inst.gsl_vector_free (l_state.item.w)
			init_source_inst.gsl_vector_free (l_state.item.rdx)
			init_source_inst.gsl_vector_free (l_state.item.qtdf)
			init_source_inst.gsl_vector_free (l_state.item.df)
			init_source_inst.gsl_vector_free (l_state.item.f_trial)
			init_source_inst.gsl_vector_free (l_state.item.x_trial)
			init_source_inst.gsl_vector_free (l_state.item.gradient)
			init_source_inst.gsl_vector_free (l_state.item.newton)
			init_source_inst.gsl_vector_free (l_state.item.qtf)
			init_source_inst.gsl_vector_free (l_state.item.diag)
			init_source_inst.gsl_vector_free (l_state.item.tau)
			init_source_inst.gsl_matrix_free (l_state.item.r)
			init_source_inst.gsl_matrix_free (l_state.item.q)
			init_source_inst.gsl_matrix_free (l_state.item.J)
		end

	hybrid_free_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent hybrid_free)
		end

end
