class
	P_HYPERG_0F1

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	hyperg_0F1_bessel_I (a_nu: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_anu: REAL_64
			l_s: REAL_64
			l_ex: REAL_64
			l_I: PD_GSL_SF_RESULT_STRUCT
			l_K: PD_GSL_SF_RESULT_STRUCT
			l_stat_I: INTEGER_32
			l_stat_K: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_ex___0: REAL_64
			l_I___0: PD_GSL_SF_RESULT_STRUCT
			l_stat_I___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_I.make
			create l_K.make
			create l_I___0.make

			if a_x > 7.0978271289338397e+02 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_inff).to_double
					a_result.item.err := (builtin_inff).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("overflow"), ce_string ("hyperg_0F1.c"), 45, 16)
						Result := 16
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				if a_nu < 0.0 then
					l_anu := -a_nu
					l_s := (2.0 / 3.14159265358979323846) * (sin (l_anu * 3.14159265358979323846))
					l_ex := (exp (a_x))
					l_stat_I := (bessel_inu_inst.gsl_sf_bessel_Inu_scaled_e (l_anu, a_x, l_I.address))
					l_stat_K := (bessel_knu_inst.gsl_sf_bessel_Knu_scaled_e (l_anu, a_x, l_K.address))
					a_result.item.val := l_ex * l_I.val + l_s * (l_K.val / l_ex)
					a_result.item.err := l_ex * l_I.err + (fabs ((l_s * l_K.err) / l_ex))
					a_result.item.err := a_result.item.err + ((((fabs (l_s * (l_K.val / l_ex))) * 2.2204460492503131e-16) * l_anu) * 3.14159265358979323846)
					if l_stat_K /= 0 then
						l_tmp___8 := l_stat_K
					else
						if l_stat_I /= 0 then
							l_tmp___7 := l_stat_I
						else
							l_tmp___7 := 0
						end
						l_tmp___8 := l_tmp___7
					end
					Result := l_tmp___8
				else
					l_ex___0 := (exp (a_x))
					l_stat_I___0 := (bessel_inu_inst.gsl_sf_bessel_Inu_scaled_e (a_nu, a_x, l_I___0.address))
					a_result.item.val := l_ex___0 * l_I___0.val
					a_result.item.err := l_ex___0 * l_I___0.err + 2.2204460492503131e-16 * (fabs (a_result.item.val))
					Result := l_stat_I___0
				end
			end
		end

	hyperg_0F1_bessel_J (a_nu: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_anu: REAL_64
			l_s: REAL_64
			l_c___1: REAL_64
			l_J: PD_GSL_SF_RESULT_STRUCT
			l_Y: PD_GSL_SF_RESULT_STRUCT
			l_stat_J: INTEGER_32
			l_stat_Y: INTEGER_32
			l_tmp___3: REAL_64
			l_tmp___5: REAL_64
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
		do
			create l_J.make
			create l_Y.make

			if a_nu < 0.0 then
				l_anu := -a_nu
				l_s := (sin (l_anu * 3.14159265358979323846))
				l_c___1 := (cos (l_anu * 3.14159265358979323846))
				l_stat_J := (bessel_jnu_inst.gsl_sf_bessel_Jnu_e (l_anu, a_x, l_J.address))
				l_stat_Y := (bessel_ynu_inst.gsl_sf_bessel_Ynu_e (l_anu, a_x, l_Y.address))
				a_result.item.val := l_c___1 * l_J.val - l_s * l_Y.val
				l_tmp___3 := fabs (l_c___1 * l_J.err)
				a_result.item.err := l_tmp___3 + (fabs (l_s * l_Y.err))
				l_tmp___5 := fabs (l_anu * 3.14159265358979323846)
				a_result.item.err := a_result.item.err + ((l_tmp___5 * 2.2204460492503131e-16) * (fabs (l_J.val + l_Y.val)))
				if l_stat_Y /= 0 then
					l_tmp___8 := l_stat_Y
				else
					if l_stat_J /= 0 then
						l_tmp___7 := l_stat_J
					else
						l_tmp___7 := 0
					end
					l_tmp___8 := l_tmp___7
				end
				Result := l_tmp___8
			else
				Result := (bessel_jnu_inst.gsl_sf_bessel_Jnu_e (a_nu, a_x, a_result))
			end
		end

	gsl_sf_hyperg_0F1_e (a_c___1: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_rintc: REAL_64
			l_c_neg_integer: INTEGER_32
			l_tmp___1: INTEGER_32
			l_Jcm1: PD_GSL_SF_RESULT_STRUCT
			l_lg_c: PD_GSL_SF_RESULT_STRUCT
			l_sgn: REAL_64
			l_stat_g: INTEGER_32
			l_stat_J: INTEGER_32
			l_tl: REAL_64
			l_ln_pre_val: REAL_64
			l_ln_pre_err: REAL_64
			l_Icm1: PD_GSL_SF_RESULT_STRUCT
			l_lg_c___0: PD_GSL_SF_RESULT_STRUCT
			l_sgn___0: REAL_64
			l_stat_g___0: INTEGER_32
			l_stat_I: INTEGER_32
			l_tl___0: REAL_64
			l_ln_pre_val___0: REAL_64
			l_ln_pre_err___0: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_Jcm1.make
			create l_lg_c.make
			create l_Icm1.make
			create l_lg_c___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_rintc := (floor (a_c___1 + 0.5))
					if a_c___1 < 0.0 then
						if (fabs (a_c___1 - l_rintc)) < 1000.0 * 2.2204460492503131e-16 then
							l_tmp___1 := 1
						else
							l_tmp___1 := 0
						end
					else
						l_tmp___1 := 0
					end
					l_c_neg_integer := l_tmp___1
					if a_c___1 /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (l_c_neg_integer.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("hyperg_0F1.c"), 111, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if a_x < 0.0 then
							l_stat_g := (gamma_inst.gsl_sf_lngamma_sgn_e (a_c___1, l_lg_c.address, create {CE_POINTER [REAL_64]}.make_shared ($l_sgn)))
							l_stat_J := (hyperg_0F1_bessel_J (a_c___1 - 1.0, 2.0 * (sqrt (-a_x)), l_Jcm1.address))
							if l_stat_g /= 0 then
								a_result.item.val := 0.0
								a_result.item.err := 0.0
								Result := l_stat_g
								js.return
							elseif l_Jcm1.val = 0.0 then
								a_result.item.val := 0.0
								a_result.item.err := 0.0
								Result := l_stat_J
								js.return
							else
								l_tl := ((log (-a_x)) * 0.5) * (1.0 - a_c___1)
								l_ln_pre_val := l_lg_c.val + l_tl
								l_ln_pre_err := l_lg_c.err + (2.0 * 2.2204460492503131e-16) * (fabs (l_tl))
								Result := (exp_inst.gsl_sf_exp_mult_err_e (l_ln_pre_val, l_ln_pre_err, l_sgn * l_Jcm1.val, l_Jcm1.err, a_result))
								js.return
							end
						elseif a_x = 0.0 then
							a_result.item.val := 1.0
							a_result.item.err := 1.0
							Result := 0
							js.return
						else
							l_stat_g___0 := (gamma_inst.gsl_sf_lngamma_sgn_e (a_c___1, l_lg_c___0.address, create {CE_POINTER [REAL_64]}.make_shared ($l_sgn___0)))
							l_stat_I := (hyperg_0F1_bessel_I (a_c___1 - 1.0, 2.0 * (sqrt (a_x)), l_Icm1.address))
							if l_stat_g___0 /= 0 then
								a_result.item.val := 0.0
								a_result.item.err := 0.0
								Result := l_stat_g___0
								js.return
							elseif l_Icm1.val = 0.0 then
								a_result.item.val := 0.0
								a_result.item.err := 0.0
								Result := l_stat_I
								js.return
							else
								l_tl___0 := ((log (a_x)) * 0.5) * (1.0 - a_c___1)
								l_ln_pre_val___0 := l_lg_c___0.val + l_tl___0
								l_ln_pre_err___0 := l_lg_c___0.err + (2.0 * 2.2204460492503131e-16) * (fabs (l_tl___0))
								Result := (exp_inst.gsl_sf_exp_mult_err_e (l_ln_pre_val___0, l_ln_pre_err___0, l_sgn___0 * l_Icm1.val, l_Icm1.err, a_result))
								js.return
							end
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_hyperg_0F1 (a_c___1: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_hyperg_0F1_e (a_c___1, a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_hyperg_0F1_e(c, x, &result)"), ce_string ("hyperg_0F1.c"), 177, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
