class
	P_HYPERG_2F0

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_sf_hyperg_2F0_e (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_U: PD_GSL_SF_RESULT_STRUCT
			l_pre: REAL_64
			l_stat_U: INTEGER_32
			js: JUMP_STATE
		do
			create l_U.make

			if a_x < 0.0 then
				l_pre := (pow (-1.0 / a_x, a_a___5))
				l_stat_U := (hyperg_u_inst.gsl_sf_hyperg_U_e (a_a___5, (1.0 + a_a___5) - a_b___0, -1.0 / a_x, l_U.address))
				a_result.item.val := l_pre * l_U.val
				a_result.item.err := 2.2204460492503131e-16 * (fabs (a_result.item.val)) + l_pre * l_U.err
				Result := l_stat_U
				js.return
			elseif a_x = 0.0 then
				a_result.item.val := 1.0
				a_result.item.err := 0.0
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("hyperg_2F0.c"), 52, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_hyperg_2F0 (a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_hyperg_2F0_e (a_a___5, a_b___0, a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_hyperg_2F0_e(a, b, x, &result)"), ce_string ("hyperg_2F0.c"), 62, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
