class
	P_HYPERG_2F1

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	hyperg_2F1_series (a_a___5: REAL_64; a_b___0: REAL_64; a_c___1: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_sum_pos: REAL_64
			l_sum_neg: REAL_64
			l_del_pos: REAL_64
			l_del_neg: REAL_64
			l_del: REAL_64
			l_k: REAL_64
			l_i: INTEGER_32
			l_tmp___0: REAL_64
			l_tmp___3: REAL_64
			js: JUMP_STATE
		do
			l_sum_pos := 1.0
			l_sum_neg := 0.0
			l_del_pos := 1.0
			l_del_neg := 0.0
			l_del := 1.0
			l_k := 0.0
			l_i := 0
			if (fabs (a_c___1)) < 2.2204460492503131e-16 then
				a_result.item.val := 0.0
				a_result.item.err := 1.0
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("error"), ce_string ("hyperg_2F1.c"), 56, 1)
					Result := 1
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_i := l_i + 1
					if l_i > 30000 then
						a_result.item.val := l_sum_pos - l_sum_neg
						a_result.item.err := l_del_pos + l_del_neg
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (l_sum_pos + l_sum_neg))
						l_tmp___0 := sqrt (l_k)
						a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * (2.0 * l_tmp___0 + 1.0)) * (fabs (a_result.item.val)))
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("error"), ce_string ("hyperg_2F1.c"), 65, 11)
							Result := 11
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_del := l_del * ((((a_a___5 + l_k) * (a_b___0 + l_k)) * a_x) / ((a_c___1 + l_k) * (l_k + 1.0)))
						if l_del > 0.0 then
							l_del_pos := l_del
							l_sum_pos := l_sum_pos + l_del
						elseif l_del = 0.0 then
							l_del_pos := 0.0
							l_del_neg := 0.0
							js.break
						else
							l_del_neg := -l_del
							l_sum_neg := l_sum_neg - l_del
						end
						if not js.loop_jumped then
							l_k := l_k + (1.0)
							if not ((fabs ((l_del_pos + l_del_neg) / (l_sum_pos - l_sum_neg))) > 2.2204460492503131e-16) then
								js.break
							end
						end
					end
				end
				js.reset
			end
			if not js.return_called then
				a_result.item.val := l_sum_pos - l_sum_neg
				a_result.item.err := l_del_pos + l_del_neg
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (l_sum_pos + l_sum_neg))
				l_tmp___3 := sqrt (l_k)
				a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * (2.0 * l_tmp___3 + 1.0)) * (fabs (a_result.item.val)))
				Result := 0
			end
		end

	hyperg_2F1_conj_series (a_aR: REAL_64; a_aI: REAL_64; a_c___1: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_sum_pos: REAL_64
			l_sum_neg: REAL_64
			l_del_pos: REAL_64
			l_del_neg: REAL_64
			l_del: REAL_64
			l_k: REAL_64
			l_tmp: REAL_64
			l_tmp___2: REAL_64
			js: JUMP_STATE
		do
			if a_c___1 = 0.0 then
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("error"), ce_string ("hyperg_2F1.c"), 107, 1)
					Result := 1
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_sum_pos := 1.0
				l_sum_neg := 0.0
				l_del_pos := 1.0
				l_del_neg := 0.0
				l_del := 1.0
				l_k := 0.0
				from
				until
					js.loop_left
				loop
					js.reset
					l_del := l_del * ((((a_aR + l_k) * (a_aR + l_k) + a_aI * a_aI) / ((l_k + 1.0) * (a_c___1 + l_k))) * a_x)
					if l_del >= 0.0 then
						l_del_pos := l_del
						l_sum_pos := l_sum_pos + l_del
					else
						l_del_neg := -l_del
						l_sum_neg := l_sum_neg - l_del
					end
					if l_k > (30000).to_double then
						a_result.item.val := l_sum_pos - l_sum_neg
						a_result.item.err := l_del_pos + l_del_neg
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (l_sum_pos + l_sum_neg))
						l_tmp := sqrt (l_k)
						a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * (2.0 * l_tmp + 1.0)) * (fabs (a_result.item.val)))
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("error"), ce_string ("hyperg_2F1.c"), 133, 11)
							Result := 11
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_k := l_k + (1.0)
						if not ((fabs ((l_del_pos + l_del_neg) / (l_sum_pos - l_sum_neg))) > 2.2204460492503131e-16) then
							js.break
						end
					end
				end
				js.reset
				if not js.return_called then
					a_result.item.val := l_sum_pos - l_sum_neg
					a_result.item.err := l_del_pos + l_del_neg
					a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (l_sum_pos + l_sum_neg))
					l_tmp___2 := sqrt (l_k)
					a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * (2.0 * l_tmp___2 + 1.0)) * (fabs (a_result.item.val)))
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	hyperg_2F1_luke (a_a___5: REAL_64; a_b___0: REAL_64; a_c___1: REAL_64; a_xin: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_stat_iter: INTEGER_32
			l_RECUR_BIG: REAL_64
			l_nmax: INTEGER_32
			l_n: INTEGER_32
			l_x: REAL_64
			l_x3___1: REAL_64
			l_t0: REAL_64
			l_t1: REAL_64
			l_t2: REAL_64
			l_F___0: REAL_64
			l_prec: REAL_64
			l_Bnm3: REAL_64
			l_Bnm2: REAL_64
			l_Bnm1: REAL_64
			l_Anm3: REAL_64
			l_Anm2: REAL_64
			l_Anm1: REAL_64
			l_npam1: REAL_64
			l_npbm1: REAL_64
			l_npcm1: REAL_64
			l_npam2: REAL_64
			l_npbm2: REAL_64
			l_npcm2: REAL_64
			l_tnm1: REAL_64
			l_tnm3: REAL_64
			l_tnm5: REAL_64
			l_n2: REAL_64
			l_F1: REAL_64
			l_F2: REAL_64
			l_F3: REAL_64
			l_E: REAL_64
			l_An: REAL_64
			l_Bn: REAL_64
			l_r___3: REAL_64
			l_tmp___5: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_RECUR_BIG := 1.0e+50
					l_nmax := 20000
					l_n := 3
					l_x := -a_xin
					l_x3___1 := (l_x * l_x) * l_x
					l_t0 := (a_a___5 * a_b___0) / a_c___1
					l_t1 := ((a_a___5 + 1.0) * (a_b___0 + 1.0)) / (2.0 * a_c___1)
					l_t2 := ((a_a___5 + 2.0) * (a_b___0 + 2.0)) / (2.0 * (a_c___1 + 1.0))
					l_F___0 := 1.0
					l_Bnm3 := 1.0
					l_Bnm2 := 1.0 + l_t1 * l_x
					l_Bnm1 := 1.0 + (l_t2 * l_x) * (1.0 + (l_t1 / 3.0) * l_x)
					l_Anm3 := 1.0
					l_Anm2 := l_Bnm2 - l_t0 * l_x
					l_Anm1 := (l_Bnm1 - (l_t0 * (1.0 + l_t2 * l_x)) * l_x) + (((l_t0 * l_t1) * (a_c___1 / (a_c___1 + 1.0))) * l_x) * l_x
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 16 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_npam1 := (l_n.to_double + a_a___5) - (1).to_double
						l_npbm1 := (l_n.to_double + a_b___0) - (1).to_double
						l_npcm1 := (l_n.to_double + a_c___1) - (1).to_double
						l_npam2 := (l_n.to_double + a_a___5) - (2).to_double
						l_npbm2 := (l_n.to_double + a_b___0) - (2).to_double
						l_npcm2 := (l_n.to_double + a_c___1) - (2).to_double
						l_tnm1 := (2 * l_n - 1).to_double
						l_tnm3 := (2 * l_n - 3).to_double
						l_tnm5 := (2 * l_n - 5).to_double
						l_n2 := (l_n * l_n).to_double
						l_F1 := ((((3.0 * l_n2 + ((a_a___5 + a_b___0) - (6).to_double) * l_n.to_double) + (2).to_double) - a_a___5 * a_b___0) - (2).to_double * (a_a___5 + a_b___0)) / (((2).to_double * l_tnm3) * l_npcm1)
						l_F2 := ((-(((3.0 * l_n2 - ((a_a___5 + a_b___0) + (6).to_double) * l_n.to_double) + (2).to_double) - a_a___5 * a_b___0) * l_npam1) * l_npbm1) / (((((4).to_double * l_tnm1) * l_tnm3) * l_npcm2) * l_npcm1)
						l_F3 := (((((l_npam2 * l_npam1) * l_npbm2) * l_npbm1) * ((l_n.to_double - a_a___5) - (2).to_double)) * ((l_n.to_double - a_b___0) - (2).to_double)) / (((((((8).to_double * l_tnm3) * l_tnm3) * l_tnm5) * ((l_n.to_double + a_c___1) - (3).to_double)) * l_npcm2) * l_npcm1)
						l_E := ((-l_npam1 * l_npbm1) * ((l_n.to_double - a_c___1) - (1).to_double)) / ((((2).to_double * l_tnm3) * l_npcm2) * l_npcm1)
						l_An := ((1.0 + l_F1 * l_x) * l_Anm1 + ((l_E + l_F2 * l_x) * l_x) * l_Anm2) + (l_F3 * l_x3___1) * l_Anm3
						l_Bn := ((1.0 + l_F1 * l_x) * l_Bnm1 + ((l_E + l_F2 * l_x) * l_x) * l_Bnm2) + (l_F3 * l_x3___1) * l_Bnm3
						l_r___3 := l_An / l_Bn
						l_prec := fabs ((l_F___0 - l_r___3) / l_F___0)
						l_F___0 := l_r___3
						if l_prec < 2.2204460492503131e-16 then
							js.break
						elseif l_n > l_nmax then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 15 -- skip if block
						end
				when 3 then -- if:
						if not ((fabs (l_An)) > l_RECUR_BIG) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 6 then -- else:
						if not ((fabs (l_Bn)) > l_RECUR_BIG) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___0:
						l_An := l_An / l_RECUR_BIG
						l_Bn := l_Bn / l_RECUR_BIG
						l_Anm1 := l_Anm1 / l_RECUR_BIG
						l_Bnm1 := l_Bnm1 / l_RECUR_BIG
						l_Anm2 := l_Anm2 / l_RECUR_BIG
						l_Bnm2 := l_Bnm2 / l_RECUR_BIG
						l_Anm3 := l_Anm3 / l_RECUR_BIG
						l_Bnm3 := l_Bnm3 / l_RECUR_BIG
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 9 then -- else:
						if not ((fabs (l_An)) < 1.0 / l_RECUR_BIG) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 12 then -- else:
						if not ((fabs (l_Bn)) < 1.0 / l_RECUR_BIG) then
							l_pos := -1 + 14 -- skip if block
						end
				when 13 then -- if: | _L:
						l_An := l_An * l_RECUR_BIG
						l_Bn := l_Bn * l_RECUR_BIG
						l_Anm1 := l_Anm1 * l_RECUR_BIG
						l_Bnm1 := l_Bnm1 * l_RECUR_BIG
						l_Anm2 := l_Anm2 * l_RECUR_BIG
						l_Bnm2 := l_Bnm2 * l_RECUR_BIG
						l_Anm3 := l_Anm3 * l_RECUR_BIG
						l_Bnm3 := l_Bnm3 * l_RECUR_BIG
				when 14 then -- if done | if done | if done
						l_n := l_n + 1
						l_Bnm3 := l_Bnm2
						l_Bnm2 := l_Bnm1
						l_Bnm1 := l_Bn
						l_Anm3 := l_Anm2
						l_Anm2 := l_Anm1
						l_Anm1 := l_An
				when 15 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 16 then -- loop done
					js.reset
					a_result.item.val := l_F___0
					a_result.item.err := 2.0 * (fabs (l_prec * l_F___0))
					a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * (l_n.to_double + 1.0)) * (fabs (l_F___0)))
					l_tmp___5 := fabs (a_a___5)
					a_result.item.err := a_result.item.err * (8.0 * ((l_tmp___5 + (fabs (a_b___0))) + 1.0))
					if l_n >= l_nmax then
						l_stat_iter := 11
					else
						l_stat_iter := 0
					end
					Result := l_stat_iter
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	hyperg_2F1_conj_luke (a_aR: REAL_64; a_aI: REAL_64; a_c___1: REAL_64; a_xin: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_stat_iter: INTEGER_32
			l_RECUR_BIG: REAL_64
			l_nmax: INTEGER_32
			l_n: INTEGER_32
			l_x: REAL_64
			l_x3___1: REAL_64
			l_atimesb: REAL_64
			l_apb: REAL_64
			l_t0: REAL_64
			l_t1: REAL_64
			l_t2: REAL_64
			l_F___0: REAL_64
			l_prec: REAL_64
			l_Bnm3: REAL_64
			l_Bnm2: REAL_64
			l_Bnm1: REAL_64
			l_Anm3: REAL_64
			l_Anm2: REAL_64
			l_Anm1: REAL_64
			l_nm1: REAL_64
			l_nm2: REAL_64
			l_npam1_npbm1: REAL_64
			l_npam2_npbm2: REAL_64
			l_npcm1: REAL_64
			l_npcm2: REAL_64
			l_tnm1: REAL_64
			l_tnm3: REAL_64
			l_tnm5: REAL_64
			l_n2: REAL_64
			l_F1: REAL_64
			l_F2: REAL_64
			l_F3: REAL_64
			l_E: REAL_64
			l_An: REAL_64
			l_Bn: REAL_64
			l_r___3: REAL_64
			l_tmp: REAL_64
			l_tmp___7: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_RECUR_BIG := 1.0e+50
					l_nmax := 10000
					l_n := 3
					l_x := -a_xin
					l_x3___1 := (l_x * l_x) * l_x
					l_atimesb := a_aR * a_aR + a_aI * a_aI
					l_apb := 2.0 * a_aR
					l_t0 := l_atimesb / a_c___1
					l_t1 := ((l_atimesb + l_apb) + 1.0) / (2.0 * a_c___1)
					l_t2 := ((l_atimesb + 2.0 * l_apb) + 4.0) / (2.0 * (a_c___1 + 1.0))
					l_F___0 := 1.0
					l_Bnm3 := 1.0
					l_Bnm2 := 1.0 + l_t1 * l_x
					l_Bnm1 := 1.0 + (l_t2 * l_x) * (1.0 + (l_t1 / 3.0) * l_x)
					l_Anm3 := 1.0
					l_Anm2 := l_Bnm2 - l_t0 * l_x
					l_Anm1 := (l_Bnm1 - (l_t0 * (1.0 + l_t2 * l_x)) * l_x) + (((l_t0 * l_t1) * (a_c___1 / (a_c___1 + 1.0))) * l_x) * l_x
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 16 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_nm1 := (l_n - 1).to_double
						l_nm2 := (l_n - 2).to_double
						l_npam1_npbm1 := (l_atimesb + l_nm1 * l_apb) + l_nm1 * l_nm1
						l_npam2_npbm2 := (l_atimesb + l_nm2 * l_apb) + l_nm2 * l_nm2
						l_npcm1 := l_nm1 + a_c___1
						l_npcm2 := l_nm2 + a_c___1
						l_tnm1 := (2 * l_n - 1).to_double
						l_tnm3 := (2 * l_n - 3).to_double
						l_tnm5 := (2 * l_n - 5).to_double
						l_n2 := (l_n * l_n).to_double
						l_F1 := ((((3.0 * l_n2 + (l_apb - (6).to_double) * l_n.to_double) + (2).to_double) - l_atimesb) - (2).to_double * l_apb) / (((2).to_double * l_tnm3) * l_npcm1)
						l_F2 := (-(((3.0 * l_n2 - (l_apb + (6).to_double) * l_n.to_double) + (2).to_double) - l_atimesb) * l_npam1_npbm1) / (((((4).to_double * l_tnm1) * l_tnm3) * l_npcm2) * l_npcm1)
						l_F3 := ((l_npam2_npbm2 * l_npam1_npbm1) * ((l_nm2 * l_nm2 - l_nm2 * l_apb) + l_atimesb)) / (((((((8).to_double * l_tnm3) * l_tnm3) * l_tnm5) * ((l_n.to_double + a_c___1) - (3).to_double)) * l_npcm2) * l_npcm1)
						l_E := (-l_npam1_npbm1 * ((l_n.to_double - a_c___1) - (1).to_double)) / ((((2).to_double * l_tnm3) * l_npcm2) * l_npcm1)
						l_An := ((1.0 + l_F1 * l_x) * l_Anm1 + ((l_E + l_F2 * l_x) * l_x) * l_Anm2) + (l_F3 * l_x3___1) * l_Anm3
						l_Bn := ((1.0 + l_F1 * l_x) * l_Bnm1 + ((l_E + l_F2 * l_x) * l_x) * l_Bnm2) + (l_F3 * l_x3___1) * l_Bnm3
						l_r___3 := l_An / l_Bn
						l_tmp := fabs (l_F___0 - l_r___3)
						l_prec := l_tmp / (fabs (l_F___0))
						l_F___0 := l_r___3
						if l_prec < 2.2204460492503131e-16 then
							js.break
						elseif l_n > l_nmax then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 15 -- skip if block
						end
				when 3 then -- if:
						if not ((fabs (l_An)) > l_RECUR_BIG) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 6 then -- else:
						if not ((fabs (l_Bn)) > l_RECUR_BIG) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___0:
						l_An := l_An / l_RECUR_BIG
						l_Bn := l_Bn / l_RECUR_BIG
						l_Anm1 := l_Anm1 / l_RECUR_BIG
						l_Bnm1 := l_Bnm1 / l_RECUR_BIG
						l_Anm2 := l_Anm2 / l_RECUR_BIG
						l_Bnm2 := l_Bnm2 / l_RECUR_BIG
						l_Anm3 := l_Anm3 / l_RECUR_BIG
						l_Bnm3 := l_Bnm3 / l_RECUR_BIG
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 9 then -- else:
						if not ((fabs (l_An)) < 1.0 / l_RECUR_BIG) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 12 then -- else:
						if not ((fabs (l_Bn)) < 1.0 / l_RECUR_BIG) then
							l_pos := -1 + 14 -- skip if block
						end
				when 13 then -- if: | _L:
						l_An := l_An * l_RECUR_BIG
						l_Bn := l_Bn * l_RECUR_BIG
						l_Anm1 := l_Anm1 * l_RECUR_BIG
						l_Bnm1 := l_Bnm1 * l_RECUR_BIG
						l_Anm2 := l_Anm2 * l_RECUR_BIG
						l_Bnm2 := l_Bnm2 * l_RECUR_BIG
						l_Anm3 := l_Anm3 * l_RECUR_BIG
						l_Bnm3 := l_Bnm3 * l_RECUR_BIG
				when 14 then -- if done | if done | if done
						l_n := l_n + 1
						l_Bnm3 := l_Bnm2
						l_Bnm2 := l_Bnm1
						l_Bnm1 := l_Bn
						l_Anm3 := l_Anm2
						l_Anm2 := l_Anm1
						l_Anm1 := l_An
				when 15 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 16 then -- loop done
					js.reset
					a_result.item.val := l_F___0
					a_result.item.err := 2.0 * (fabs (l_prec * l_F___0))
					a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * (l_n.to_double + 1.0)) * (fabs (l_F___0)))
					l_tmp___7 := fabs (a_aR)
					a_result.item.err := a_result.item.err * (8.0 * ((l_tmp___7 + (fabs (a_aI))) + 1.0))
					if l_n >= l_nmax then
						l_stat_iter := 11
					else
						l_stat_iter := 0
					end
					Result := l_stat_iter
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	hyperg_2F1_reflect (a_a___5: REAL_64; a_b___0: REAL_64; a_c___1: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_d: REAL_64
			l_intd: INTEGER_32
			l_d_integer: INTEGER_32
			l_ln_omx: REAL_64
			l_ad: REAL_64
			l_stat_F2: INTEGER_32
			l_sgn_2: REAL_64
			l_F1: PD_GSL_SF_RESULT_STRUCT
			l_F2: PD_GSL_SF_RESULT_STRUCT
			l_d1: REAL_64
			l_d2: REAL_64
			l_lng_c: PD_GSL_SF_RESULT_STRUCT
			l_lng_ad2: PD_GSL_SF_RESULT_STRUCT
			l_lng_bd2: PD_GSL_SF_RESULT_STRUCT
			l_stat_c: INTEGER_32
			l_stat_ad2: INTEGER_32
			l_stat_bd2: INTEGER_32
			l_lng_ad: PD_GSL_SF_RESULT_STRUCT
			l_lng_ad1: PD_GSL_SF_RESULT_STRUCT
			l_lng_bd1: PD_GSL_SF_RESULT_STRUCT
			l_stat_ad: INTEGER_32
			l_stat_ad1: INTEGER_32
			l_stat_bd1: INTEGER_32
			l_i: INTEGER_32
			l_sum1: REAL_64
			l_term: REAL_64
			l_ln_pre1_val: REAL_64
			l_ln_pre1_err: REAL_64
			l_stat_e: INTEGER_32
			l_j: INTEGER_32
			l_maxiter: INTEGER_32
			l_psi_1: REAL_64
			l_psi_1pd: PD_GSL_SF_RESULT_STRUCT
			l_psi_apd1: PD_GSL_SF_RESULT_STRUCT
			l_psi_bpd1: PD_GSL_SF_RESULT_STRUCT
			l_stat_1pd: INTEGER_32
			l_stat_apd1: INTEGER_32
			l_stat_bpd1: INTEGER_32
			l_stat_dall: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_psi_val: REAL_64
			l_psi_err: REAL_64
			l_fact: REAL_64
			l_sum2_val: REAL_64
			l_sum2_err: REAL_64
			l_ln_pre2_val: REAL_64
			l_ln_pre2_err: REAL_64
			l_stat_e___0: INTEGER_32
			l_j___0: INTEGER_32
			l_term1: REAL_64
			l_term2: REAL_64
			l_delta___0: REAL_64
			l_tmp___18: REAL_64
			l_tmp___20: REAL_64
			l_tmp___22: REAL_64
			l_tmp___24: INTEGER_32
			l_tmp___25: REAL_64
			l_pre1: PD_GSL_SF_RESULT_STRUCT
			l_pre2: PD_GSL_SF_RESULT_STRUCT
			l_sgn1: REAL_64
			l_sgn2: REAL_64
			l_F1___0: PD_GSL_SF_RESULT_STRUCT
			l_F2___0: PD_GSL_SF_RESULT_STRUCT
			l_status_F1: INTEGER_32
			l_status_F2: INTEGER_32
			l_ln_g1ca: PD_GSL_SF_RESULT_STRUCT
			l_ln_g1cb: PD_GSL_SF_RESULT_STRUCT
			l_ln_g2a: PD_GSL_SF_RESULT_STRUCT
			l_ln_g2b: PD_GSL_SF_RESULT_STRUCT
			l_sgn_g1ca: REAL_64
			l_sgn_g1cb: REAL_64
			l_sgn_g2a: REAL_64
			l_sgn_g2b: REAL_64
			l_stat_1ca: INTEGER_32
			l_stat_1cb: INTEGER_32
			l_stat_2a: INTEGER_32
			l_stat_2b: INTEGER_32
			l_ok1: INTEGER_32
			l_tmp___32: INTEGER_32
			l_ok2: INTEGER_32
			l_tmp___33: INTEGER_32
			l_ln_gc: PD_GSL_SF_RESULT_STRUCT
			l_ln_gd: PD_GSL_SF_RESULT_STRUCT
			l_ln_gmd: PD_GSL_SF_RESULT_STRUCT
			l_sgn_gc: REAL_64
			l_sgn_gd: REAL_64
			l_sgn_gmd: REAL_64
			l_ln_pre1_val___0: REAL_64
			l_ln_pre2_val___0: REAL_64
			l_ln_pre1_err___0: REAL_64
			l_ln_pre2_err___0: REAL_64
			l_ln_pre1_val___1: REAL_64
			l_ln_pre1_err___1: REAL_64
			l_ln_pre2_val___1: REAL_64
			l_ln_pre2_err___1: REAL_64
			l_tmp___42: REAL_64
			l_tmp___44: REAL_64
			l_tmp___46: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_F1.make
			create l_F2.make
			create l_lng_c.make
			create l_lng_ad2.make
			create l_lng_bd2.make
			create l_lng_ad.make
			create l_lng_ad1.make
			create l_lng_bd1.make
			create l_psi_1pd.make
			create l_psi_apd1.make
			create l_psi_bpd1.make
			create l_pre1.make
			create l_pre2.make
			create l_F1___0.make
			create l_F2___0.make
			create l_ln_g1ca.make
			create l_ln_g1cb.make
			create l_ln_g2a.make
			create l_ln_g2b.make
			create l_ln_gc.make
			create l_ln_gd.make
			create l_ln_gmd.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d := (a_c___1 - a_a___5) - a_b___0
					l_intd := (floor (l_d + 0.5)).truncated_to_integer
					l_d_integer := ((fabs (l_d - l_intd.to_double)) < 1000.0 * 2.2204460492503131e-16).to_integer
					if not (l_d_integer.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_ln_omx := (log (1.0 - a_x))
						l_ad := (fabs (l_d))
						l_stat_F2 := 0
						if l_d >= 0.0 then
							l_d1 := l_d
							l_d2 := 0.0
						else
							l_d1 := 0.0
							l_d2 := l_d
						end
						l_stat_ad2 := gamma_inst.gsl_sf_lngamma_e (a_a___5 + l_d2, l_lng_ad2.address)
						l_stat_bd2 := gamma_inst.gsl_sf_lngamma_e (a_b___0 + l_d2, l_lng_bd2.address)
						l_stat_c := gamma_inst.gsl_sf_lngamma_e (a_c___1, l_lng_c.address)
						if l_ad < 2.2204460492503131e-16 then
							l_F1.val := 0.0
							l_F1.err := 0.0
						else
							l_stat_ad := (gamma_inst.gsl_sf_lngamma_e (l_ad, l_lng_ad.address))
							l_stat_ad1 := (gamma_inst.gsl_sf_lngamma_e (a_a___5 + l_d1, l_lng_ad1.address))
							l_stat_bd1 := (gamma_inst.gsl_sf_lngamma_e (a_b___0 + l_d1, l_lng_bd1.address))
							if l_stat_ad1 = 0 then
								if l_stat_bd1 = 0 then
									if l_stat_ad = 0 then
										l_sum1 := 1.0
										l_term := 1.0
										l_ln_pre1_val := (((l_lng_ad.val + l_lng_c.val) + l_d2 * l_ln_omx) - l_lng_ad1.val) - l_lng_bd1.val
										l_ln_pre1_err := (((l_lng_ad.err + l_lng_c.err) + l_lng_ad1.err) + l_lng_bd1.err) + 2.2204460492503131e-16 * (fabs (l_ln_pre1_val))
										l_i := 1
										from
										until
											not (l_i.to_double < l_ad)
										loop
											l_j := l_i - 1
											l_term := l_term * ((((((a_a___5 + l_d2) + l_j.to_double) * ((a_b___0 + l_d2) + l_j.to_double)) / ((1.0 + l_d2) + l_j.to_double)) / l_i.to_double) * (1.0 - a_x))
											l_sum1 := l_sum1 + l_term
											l_i := l_i + 1
										end
										l_stat_e := exp_inst.gsl_sf_exp_mult_err_e (l_ln_pre1_val, l_ln_pre1_err, l_sum1, 2.2204460492503131e-16 * (fabs (l_sum1)), l_F1.address)
										if l_stat_e = 16 then
											from
											until
												js.loop_left
											loop
												js.reset
												a_result.item.val := (builtin_inff).to_double
												a_result.item.err := (builtin_inff).to_double
												from
												until
													js.loop_left
												loop
													js.reset
													error_inst.gsl_error (ce_string ("overflow"), ce_string ("hyperg_2F1.c"), 428, 16)
													Result := 16
													js.return
													if not js.return_called then
														js.break
													end
												end
												js.reset
												if not js.return_called then
													js.break
												end
											end
											js.reset
										end
									else
										l_F1.val := 0.0
										l_F1.err := 0.0
									end
								else
									l_F1.val := 0.0
									l_F1.err := 0.0
								end
							else
								l_F1.val := 0.0
								l_F1.err := 0.0
							end
						end
						if not js.return_called then
							if l_stat_ad2 = 0 then
								if l_stat_bd2 = 0 then
									l_maxiter := 2000
									l_psi_1 := -0.57721566490153286060651209008
									l_stat_1pd := (psi_inst.gsl_sf_psi_e (1.0 + l_ad, l_psi_1pd.address))
									l_stat_apd1 := (psi_inst.gsl_sf_psi_e (a_a___5 + l_d1, l_psi_apd1.address))
									l_stat_bpd1 := (psi_inst.gsl_sf_psi_e (a_b___0 + l_d1, l_psi_bpd1.address))
									if l_stat_1pd /= 0 then
										l_tmp___15 := l_stat_1pd
									else
										if l_stat_apd1 /= 0 then
											l_tmp___14 := l_stat_apd1
										else
											if l_stat_bpd1 /= 0 then
												l_tmp___13 := l_stat_bpd1
											else
												l_tmp___13 := 0
											end
											l_tmp___14 := l_tmp___13
										end
										l_tmp___15 := l_tmp___14
									end
									l_stat_dall := l_tmp___15
									l_psi_val := (((l_psi_1 + l_psi_1pd.val) - l_psi_apd1.val) - l_psi_bpd1.val) - l_ln_omx
									l_psi_err := ((l_psi_1pd.err + l_psi_apd1.err) + l_psi_bpd1.err) + 2.2204460492503131e-16 * (fabs (l_psi_val))
									l_fact := 1.0
									l_sum2_val := l_psi_val
									l_sum2_err := l_psi_err
									l_ln_pre2_val := ((l_lng_c.val + l_d1 * l_ln_omx) - l_lng_ad2.val) - l_lng_bd2.val
									l_ln_pre2_err := ((l_lng_c.err + l_lng_ad2.err) + l_lng_bd2.err) + 2.2204460492503131e-16 * (fabs (l_ln_pre2_val))
									l_j___0 := 1
									from
									until
										not (not js.loop_left and then (l_j___0 < l_maxiter))
									loop
										js.reset
										l_term1 := 1.0 / l_j___0.to_double + 1.0 / (l_ad + l_j___0.to_double)
										l_term2 := 1.0 / (((a_a___5 + l_d1) + l_j___0.to_double) - 1.0) + 1.0 / (((a_b___0 + l_d1) + l_j___0.to_double) - 1.0)
										l_delta___0 := 0.0
										l_psi_val := l_psi_val + (l_term1 - l_term2)
										l_tmp___18 := fabs (l_term1)
										l_psi_err := l_psi_err + (2.2204460492503131e-16 * (l_tmp___18 + (fabs (l_term2))))
										l_fact := l_fact * ((((((a_a___5 + l_d1) + l_j___0.to_double) - 1.0) * (((a_b___0 + l_d1) + l_j___0.to_double) - 1.0)) / ((l_ad + l_j___0.to_double) * l_j___0.to_double)) * (1.0 - a_x))
										l_delta___0 := l_fact * l_psi_val
										l_sum2_val := l_sum2_val + l_delta___0
										l_tmp___20 := fabs (l_fact * l_psi_err)
										l_sum2_err := l_sum2_err + (l_tmp___20 + 2.2204460492503131e-16 * (fabs (l_delta___0)))
										l_tmp___22 := fabs (l_delta___0)
										if l_tmp___22 < 2.2204460492503131e-16 * (fabs (l_sum2_val)) then
											js.break
										end
										if not js.loop_jumped then
											l_j___0 := l_j___0 + 1
										end
									end
									js.reset
									if l_j___0 = l_maxiter then
										l_stat_F2 := 11
									end
									if l_sum2_val = 0.0 then
										l_F2.val := 0.0
										l_F2.err := 0.0
									else
										l_stat_e___0 := exp_inst.gsl_sf_exp_mult_err_e (l_ln_pre2_val, l_ln_pre2_err, l_sum2_val, l_sum2_err, l_F2.address)
										if l_stat_e___0 = 16 then
											a_result.item.val := 0.0
											a_result.item.err := 0.0
											from
											until
												js.loop_left
											loop
												js.reset
												error_inst.gsl_error (ce_string ("error"), ce_string ("hyperg_2F1.c"), 497, 16)
												Result := 16
												js.return
												if not js.return_called then
													js.break
												end
											end
											js.reset
										end
									end
									if not js.return_called then
										if l_stat_F2 /= 0 then
											l_stat_F2 := l_stat_F2
										else
											if l_stat_dall /= 0 then
												l_tmp___24 := l_stat_dall
											else
												l_tmp___24 := 0
											end
											l_stat_F2 := l_tmp___24
										end
									end
								else
									l_F2.val := 0.0
									l_F2.err := 0.0
								end
							else
								l_F2.val := 0.0
								l_F2.err := 0.0
							end
						end
						if not js.return_called then
							if ((l_intd).bit_and (1)).to_boolean then
								l_sgn_2 := -1.0
							else
								l_sgn_2 := 1.0
							end
							a_result.item.val := l_F1.val + l_sgn_2 * l_F2.val
							a_result.item.err := l_F1.err + l_F2.err
							l_tmp___25 := fabs (l_F1.val)
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (l_tmp___25 + (fabs (l_F2.val))))
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							Result := l_stat_F2
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 3 then -- else:
						l_stat_1ca := (gamma_inst.gsl_sf_lngamma_sgn_e (a_c___1 - a_a___5, l_ln_g1ca.address, create {CE_POINTER [REAL_64]}.make_shared ($l_sgn_g1ca)))
						l_stat_1cb := (gamma_inst.gsl_sf_lngamma_sgn_e (a_c___1 - a_b___0, l_ln_g1cb.address, create {CE_POINTER [REAL_64]}.make_shared ($l_sgn_g1cb)))
						l_stat_2a := (gamma_inst.gsl_sf_lngamma_sgn_e (a_a___5, l_ln_g2a.address, create {CE_POINTER [REAL_64]}.make_shared ($l_sgn_g2a)))
						l_stat_2b := (gamma_inst.gsl_sf_lngamma_sgn_e (a_b___0, l_ln_g2b.address, create {CE_POINTER [REAL_64]}.make_shared ($l_sgn_g2b)))
						if l_stat_1ca = 0 then
							if l_stat_1cb = 0 then
								l_tmp___32 := 1
							else
								l_tmp___32 := 0
							end
						else
							l_tmp___32 := 0
						end
						l_ok1 := l_tmp___32
						if l_stat_2a = 0 then
							if l_stat_2b = 0 then
								l_tmp___33 := 1
							else
								l_tmp___33 := 0
							end
						else
							l_tmp___33 := 0
						end
						l_ok2 := l_tmp___33
						gamma_inst.gsl_sf_lngamma_sgn_e (a_c___1, l_ln_gc.address, create {CE_POINTER [REAL_64]}.make_shared ($l_sgn_gc)).do_nothing
						gamma_inst.gsl_sf_lngamma_sgn_e (l_d, l_ln_gd.address, create {CE_POINTER [REAL_64]}.make_shared ($l_sgn_gd)).do_nothing
						gamma_inst.gsl_sf_lngamma_sgn_e (-l_d, l_ln_gmd.address, create {CE_POINTER [REAL_64]}.make_shared ($l_sgn_gmd)).do_nothing
						l_sgn1 := ((l_sgn_gc * l_sgn_gd) * l_sgn_g1ca) * l_sgn_g1cb
						l_sgn2 := ((l_sgn_gc * l_sgn_gmd) * l_sgn_g2a) * l_sgn_g2b
						if not (l_ok1.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if not (l_ok2.to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						l_ln_pre1_val___0 := ((l_ln_gc.val + l_ln_gd.val) - l_ln_g1ca.val) - l_ln_g1cb.val
						l_ln_pre2_val___0 := (((l_ln_gc.val + l_ln_gmd.val) - l_ln_g2a.val) - l_ln_g2b.val) + l_d * (log (1.0 - a_x))
						l_ln_pre1_err___0 := ((l_ln_gc.err + l_ln_gd.err) + l_ln_g1ca.err) + l_ln_g1cb.err
						l_ln_pre2_err___0 := ((l_ln_gc.err + l_ln_gmd.err) + l_ln_g2a.err) + l_ln_g2b.err
						if not (l_ln_pre1_val___0 < 7.0978271289338397e+02) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if l_ln_pre2_val___0 < 7.0978271289338397e+02 then
							exp_inst.gsl_sf_exp_err_e (l_ln_pre1_val___0, l_ln_pre1_err___0, l_pre1.address).do_nothing
							exp_inst.gsl_sf_exp_err_e (l_ln_pre2_val___0, l_ln_pre2_err___0, l_pre2.address).do_nothing
							l_pre1.val := l_pre1.val * l_sgn1
							l_pre2.val := l_pre2.val * l_sgn2
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_inff).to_double
							a_result.item.err := (builtin_inff).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("overflow"), ce_string ("hyperg_2F1.c"), 558, 16)
								Result := 16
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_pos := -1 + 12 -- goto _L___2
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 19
				when 12 then -- else: | _L___2:
						if not (l_ok1.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if not l_ok2.to_boolean then
							l_ln_pre1_val___1 := ((l_ln_gc.val + l_ln_gd.val) - l_ln_g1ca.val) - l_ln_g1cb.val
							l_ln_pre1_err___1 := ((l_ln_gc.err + l_ln_gd.err) + l_ln_g1ca.err) + l_ln_g1cb.err
							if l_ln_pre1_val___1 < 7.0978271289338397e+02 then
								exp_inst.gsl_sf_exp_err_e (l_ln_pre1_val___1, l_ln_pre1_err___1, l_pre1.address).do_nothing
								l_pre1.val := l_pre1.val * l_sgn1
								l_pre2.val := 0.0
								l_pre2.err := 0.0
							else
								from
								until
									js.loop_left
								loop
									js.reset
									a_result.item.val := (builtin_inff).to_double
									a_result.item.err := (builtin_inff).to_double
									from
									until
										js.loop_left
									loop
										js.reset
										error_inst.gsl_error (ce_string ("overflow"), ce_string ("hyperg_2F1.c"), 571, 16)
										Result := 16
										js.return
										if not js.return_called then
											js.break
										end
									end
									js.reset
									if not js.return_called then
										js.break
									end
								end
								js.reset
							end
						else
							l_pos := -1 + 15 -- goto _L___1
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 15 then -- else: | _L___1:
						if l_ok1.to_boolean then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if l_ok2.to_boolean then
							l_ln_pre2_val___1 := (((l_ln_gc.val + l_ln_gmd.val) - l_ln_g2a.val) - l_ln_g2b.val) + l_d * (log (1.0 - a_x))
							l_ln_pre2_err___1 := ((l_ln_gc.err + l_ln_gmd.err) + l_ln_g2a.err) + l_ln_g2b.err
							if l_ln_pre2_val___1 < 7.0978271289338397e+02 then
								l_pre1.val := 0.0
								l_pre1.err := 0.0
								exp_inst.gsl_sf_exp_err_e (l_ln_pre2_val___1, l_ln_pre2_err___1, l_pre2.address).do_nothing
								l_pre2.val := l_pre2.val * l_sgn2
							else
								from
								until
									js.loop_left
								loop
									js.reset
									a_result.item.val := (builtin_inff).to_double
									a_result.item.err := (builtin_inff).to_double
									from
									until
										js.loop_left
									loop
										js.reset
										error_inst.gsl_error (ce_string ("overflow"), ce_string ("hyperg_2F1.c"), 584, 16)
										Result := 16
										js.return
										if not js.return_called then
											js.break
										end
									end
									js.reset
									if not js.return_called then
										js.break
									end
								end
								js.reset
							end
						else
							l_pos := -1 + 18 -- goto _L___0
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L___0:
						l_pre1.val := 0.0
						l_pre2.val := 0.0
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := 0.0
							a_result.item.err := 2.2250738585072014e-308
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("underflow"), ce_string ("hyperg_2F1.c"), 590, 15)
								Result := 15
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 19 then -- if done | if done
						if not js.return_called then
							l_status_F1 := hyperg_2F1_series (a_a___5, a_b___0, 1.0 - l_d, 1.0 - a_x, l_F1___0.address)
							l_status_F2 := hyperg_2F1_series (a_c___1 - a_a___5, a_c___1 - a_b___0, 1.0 + l_d, 1.0 - a_x, l_F2___0.address)
							a_result.item.val := l_pre1.val * l_F1___0.val + l_pre2.val * l_F2___0.val
							l_tmp___42 := fabs (l_pre1.val * l_F1___0.err)
							a_result.item.err := l_tmp___42 + (fabs (l_pre2.val * l_F2___0.err))
							l_tmp___44 := fabs (l_pre1.err * l_F1___0.val)
							a_result.item.err := a_result.item.err + (l_tmp___44 + (fabs (l_pre2.err * l_F2___0.val)))
							l_tmp___46 := fabs (l_pre1.val * l_F1___0.val)
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (l_tmp___46 + (fabs (l_pre2.val * l_F2___0.val))))
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							Result := 0
						end
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	pow_omx (a_x: REAL_64; a_p: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ln_omx: REAL_64
			l_ln_result: REAL_64
		do
			if (fabs (a_x)) < 7.4009597974140505e-04 then
				l_ln_omx := -a_x * (1.0 + a_x * (1.0 / 2.0 + a_x * ((1.0 / 3.0 + a_x / 4.0) + (a_x * a_x) / 5.0)))
			else
				l_ln_omx := log (1.0 - a_x)
			end
			l_ln_result := a_p * l_ln_omx
			Result := (exp_inst.gsl_sf_exp_err_e (l_ln_result, 2.2204460492503131e-16 * (fabs (l_ln_result)), a_result))
		end

	gsl_sf_hyperg_2F1_e (a_a___5: REAL_64; a_b___0: REAL_64; a_c___1: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_d: REAL_64
			l_rinta: REAL_64
			l_rintb: REAL_64
			l_rintc: REAL_64
			l_a_neg_integer: INTEGER_32
			l_tmp___3: INTEGER_32
			l_b_neg_integer: INTEGER_32
			l_tmp___5: INTEGER_32
			l_c_neg_integer: INTEGER_32
			l_tmp___7: INTEGER_32
			l_lngamc: PD_GSL_SF_RESULT_STRUCT
			l_lngamcab: PD_GSL_SF_RESULT_STRUCT
			l_lngamca: PD_GSL_SF_RESULT_STRUCT
			l_lngamcb: PD_GSL_SF_RESULT_STRUCT
			l_lngamc_sgn: REAL_64
			l_lngamca_sgn: REAL_64
			l_lngamcb_sgn: REAL_64
			l_status: INTEGER_32
			l_stat1: INTEGER_32
			l_stat2: INTEGER_32
			l_stat3: INTEGER_32
			l_stat4: INTEGER_32
			l_tmp___19: INTEGER_32
			l_ap: REAL_64
			l_bp: REAL_64
			l_tmp___30: REAL_64
			l_tmp___35: REAL_64
			l_tmp___36: REAL_64
			l_tmp___37: REAL_64
			l_stat: INTEGER_32
			l_tmp___41: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_lngamc.make
			create l_lngamcab.make
			create l_lngamca.make
			create l_lngamcb.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d := (a_c___1 - a_a___5) - a_b___0
					l_rinta := (floor (a_a___5 + 0.5))
					l_rintb := (floor (a_b___0 + 0.5))
					l_rintc := (floor (a_c___1 + 0.5))
					if a_a___5 < 0.0 then
						if (fabs (a_a___5 - l_rinta)) < 1000.0 * 2.2204460492503131e-16 then
							l_tmp___3 := 1
						else
							l_tmp___3 := 0
						end
					else
						l_tmp___3 := 0
					end
					l_a_neg_integer := l_tmp___3
					if a_b___0 < 0.0 then
						if (fabs (a_b___0 - l_rintb)) < 1000.0 * 2.2204460492503131e-16 then
							l_tmp___5 := 1
						else
							l_tmp___5 := 0
						end
					else
						l_tmp___5 := 0
					end
					l_b_neg_integer := l_tmp___5
					if a_c___1 < 0.0 then
						if (fabs (a_c___1 - l_rintc)) < 1000.0 * 2.2204460492503131e-16 then
							l_tmp___7 := 1
						else
							l_tmp___7 := 0
						end
					else
						l_tmp___7 := 0
					end
					l_c_neg_integer := l_tmp___7
					a_result.item.val := 0.0
					a_result.item.err := 0.0
					if not ((fabs (a_x - 1.0)) < 1000.0 * 2.2204460492503131e-16) then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						if not ((a_c___1 - a_a___5) - a_b___0 > (0).to_double) then
							l_pos := -1 + 16 -- skip if block
						end
				when 2 then -- if:
						if a_c___1 = (0).to_double then
							l_pos := -1 + 16 -- skip if block
						end
				when 3 then -- if:
						if l_c_neg_integer.to_boolean then
							l_pos := -1 + 16 -- skip if block
						end
				when 4 then -- if:
						l_stat1 := (gamma_inst.gsl_sf_lngamma_sgn_e (a_c___1, l_lngamc.address, create {CE_POINTER [REAL_64]}.make_shared ($l_lngamc_sgn)))
						l_stat2 := (gamma_inst.gsl_sf_lngamma_e ((a_c___1 - a_a___5) - a_b___0, l_lngamcab.address))
						l_stat3 := (gamma_inst.gsl_sf_lngamma_sgn_e (a_c___1 - a_a___5, l_lngamca.address, create {CE_POINTER [REAL_64]}.make_shared ($l_lngamca_sgn)))
						l_stat4 := (gamma_inst.gsl_sf_lngamma_sgn_e (a_c___1 - a_b___0, l_lngamcb.address, create {CE_POINTER [REAL_64]}.make_shared ($l_lngamcb_sgn)))
						if l_stat1 = 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 7 then -- else:
						if l_stat2 = 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 10 then -- else:
						if l_stat3 = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 13 then -- else:
						if l_stat4 = 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("hyperg_2F1.c"), 654, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 15 then -- if done | if done | if done
						if not js.return_called then
							l_status := exp_inst.gsl_sf_exp_err_e (((l_lngamc.val + l_lngamcab.val) - l_lngamca.val) - l_lngamcb.val, ((l_lngamc.err + l_lngamcab.err) + l_lngamca.err) + l_lngamcb.err, a_result)
							a_result.item.val := a_result.item.val * (l_lngamc_sgn / (l_lngamca_sgn * l_lngamcb_sgn))
							Result := l_status
							js.return
						end
				when 16 then -- if done | if done | if done | if done
						if js.return_called then
							l_pos := -1 + 22 -- skip if block
						end
				when 17 then -- if:
							if not (a_x < -1.0) then
								l_pos := -1 + 20 -- skip if block
							end
				when 18 then -- if:
							l_pos := -1 + 21 -- goto _L___0
				when 19 then -- if block done, skip else block:
							l_pos := -1 + 22
				when 20 then -- else:
							if not (1.0 <= a_x) then
								l_pos := -1 + 22 -- skip if block
							end
				when 21 then -- if: | _L___0:
							from
							until
								js.loop_left
							loop
								js.reset
								a_result.item.val := (builtin_nanf (ce_string (""))).to_double
								a_result.item.err := (builtin_nanf (ce_string (""))).to_double
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("domain error"), ce_string ("hyperg_2F1.c"), 667, 1)
									Result := 1
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
								if not js.return_called then
									js.break
								end
							end
							js.reset
				when 22 then -- if done | if done
							if not (not js.return_called and then (l_c_neg_integer.to_boolean)) then
								l_pos := -1 + 30 -- skip if block
							end
				when 23 then -- if:
								if not (l_a_neg_integer.to_boolean) then
									l_pos := -1 + 26 -- skip if block
								end
				when 24 then -- if:
								if not (a_a___5 > a_c___1 + 0.1) then
									l_pos := -1 + 26 -- goto _L___2
								end
				when 25 then -- if block done, skip else block:
								l_pos := -1 + 30
				when 26 then -- else: | _L___2:
								if not (l_b_neg_integer.to_boolean) then
									l_pos := -1 + 29 -- skip if block
								end
				when 27 then -- if:
								if not (a_b___0 > a_c___1 + 0.1) then
									l_pos := -1 + 29 -- goto _L___1
								end
				when 28 then -- if block done, skip else block:
								l_pos := -1 + 30
				when 29 then -- else: | _L___1:
								from
								until
									js.loop_left
								loop
									js.reset
									a_result.item.val := (builtin_nanf (ce_string (""))).to_double
									a_result.item.err := (builtin_nanf (ce_string (""))).to_double
									from
									until
										js.loop_left
									loop
										js.reset
										error_inst.gsl_error (ce_string ("domain error"), ce_string ("hyperg_2F1.c"), 675, 1)
										Result := 1
										js.return
										if not js.return_called then
											js.break
										end
									end
									js.reset
									if not js.return_called then
										js.break
									end
								end
								js.reset
				when 30 then -- if done | if done
								if not js.return_called then
									if (fabs (a_c___1 - a_b___0)) < 1000.0 * 2.2204460492503131e-16 then
										l_tmp___19 := pow_omx (a_x, l_d, a_result)
										Result := l_tmp___19
										js.return
									elseif (fabs (a_c___1 - a_a___5)) < 1000.0 * 2.2204460492503131e-16 then
										l_tmp___19 := pow_omx (a_x, l_d, a_result)
										Result := l_tmp___19
										js.return
									end
								end
								if not js.return_called and then (a_a___5 >= 0.0) then
									if a_b___0 >= 0.0 then
										if a_c___1 >= 0.0 then
											if a_x >= 0.0 then
												if a_x < 0.995 then
													Result := (hyperg_2F1_series (a_a___5, a_b___0, a_c___1, a_x, a_result))
													js.return
												end
											end
										end
									end
								end
								if js.return_called then
									l_pos := -1 + 35 -- skip if block
								end
				when 31 then -- if:
									if not ((fabs (a_a___5)) < 10.0) then
										l_pos := -1 + 34 -- skip if block
									end
				when 32 then -- if:
									if (fabs (a_b___0)) < 10.0 then
										if l_a_neg_integer.to_boolean then
											Result := (hyperg_2F1_series (l_rinta, a_b___0, a_c___1, a_x, a_result))
											js.return
										end
										if not js.return_called and then (l_b_neg_integer.to_boolean) then
											Result := (hyperg_2F1_series (a_a___5, l_rintb, a_c___1, a_x, a_result))
											js.return
										end
										if not js.return_called then
											if a_x < -0.25 then
												Result := (hyperg_2F1_luke (a_a___5, a_b___0, a_c___1, a_x, a_result))
												js.return
											elseif a_x < 0.5 then
												Result := (hyperg_2F1_series (a_a___5, a_b___0, a_c___1, a_x, a_result))
												js.return
											elseif (fabs (a_c___1)) > 10.0 then
												Result := (hyperg_2F1_series (a_a___5, a_b___0, a_c___1, a_x, a_result))
												js.return
											else
												Result := (hyperg_2F1_reflect (a_a___5, a_b___0, a_c___1, a_x, a_result))
												js.return
											end
										end
									else
										l_pos := -1 + 34 -- goto _L___3
									end
				when 33 then -- if block done, skip else block:
									l_pos := -1 + 35
				when 34 then -- else: | _L___3:
									l_tmp___30 := fabs (a_a___5)
									if l_tmp___30 > (fabs (a_b___0)) then
										l_bp := a_a___5
										l_ap := a_b___0
									else
										l_bp := a_b___0
										l_ap := a_a___5
									end
									if a_x < 0.0 then
										Result := (hyperg_2F1_luke (a_a___5, a_b___0, a_c___1, a_x, a_result))
										js.return
									end
									if not js.return_called then
										l_tmp___35 := gsl_gsl_minmax_inst.GSL_MAX_DBL ((fabs (a_a___5)), 1.0)
										l_tmp___36 := fabs (l_bp)
										l_tmp___37 := fabs (a_x)
										if (l_tmp___35 * l_tmp___36) * l_tmp___37 < 2.0 * (fabs (a_c___1)) then
											Result := (hyperg_2F1_series (a_a___5, a_b___0, a_c___1, a_x, a_result))
											js.return
										end
									end
									if not js.return_called then
										l_tmp___41 := fabs (((l_bp * l_bp) * a_x) * a_x)
										if l_tmp___41 < 0.001 * (fabs (l_bp)) then
											if (fabs (a_a___5)) < 10.0 then
												l_stat := (hyperg_1f1_inst.gsl_sf_hyperg_1F1_e (a_a___5, a_c___1, l_bp * a_x, a_result))
												a_result.item.err := 0.001 * (fabs (a_result.item.val))
												Result := l_stat
												js.return
											end
										end
									end
									if not js.return_called then
										a_result.item.val := 0.0
										a_result.item.err := 0.0
										from
										until
											js.loop_left
										loop
											js.reset
											error_inst.gsl_error (ce_string ("error"), ce_string ("hyperg_2F1.c"), 755, 24)
											Result := 24
											js.return
											if not js.return_called then
												js.break
											end
										end
										js.reset
									end
				when 35 then -- if done
									if not js.return_called then
										Result := 0
									end
				when 36 then
									l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
						end

	gsl_sf_hyperg_2F1_conj_e (a_aR: REAL_64; a_aI: REAL_64; a_c___1: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ax: REAL_64
			l_rintc: REAL_64
			l_c_neg_integer: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ax := (fabs (a_x))
					l_rintc := (floor (a_c___1 + 0.5))
					if a_c___1 < 0.0 then
						if (fabs (a_c___1 - l_rintc)) < 1000.0 * 2.2204460492503131e-16 then
							l_tmp___2 := 1
						else
							l_tmp___2 := 0
						end
					else
						l_tmp___2 := 0
					end
					l_c_neg_integer := l_tmp___2
					a_result.item.val := 0.0
					a_result.item.err := 0.0
					if not (l_ax >= 1.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if not (l_c_neg_integer.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if a_c___1 /= 0.0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("hyperg_2F1.c"), 773, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 19 -- skip if block
						end
				when 9 then -- if:
							if not (l_ax < 0.25) then
								l_pos := -1 + 12 -- skip if block
							end
				when 10 then -- if:
							if (fabs (a_aR)) < 20.0 then
								if (fabs (a_aI)) < 20.0 then
									l_tmp___5 := hyperg_2F1_conj_series (a_aR, a_aI, a_c___1, a_x, a_result)
									Result := l_tmp___5
									js.return
								else
									l_pos := -1 + 12 -- goto _L___3
								end
							else
								l_pos := -1 + 12 -- goto _L___3
							end
				when 11 then -- if block done, skip else block:
							l_pos := -1 + 19
				when 12 then -- else: | _L___3:
							if not (a_c___1 > 0.0) then
								l_pos := -1 + 15 -- skip if block
							end
				when 13 then -- if:
							if a_x > 0.0 then
								l_tmp___5 := hyperg_2F1_conj_series (a_aR, a_aI, a_c___1, a_x, a_result)
								Result := l_tmp___5
								js.return
							else
								l_pos := -1 + 15 -- goto _L___1
							end
				when 14 then -- if block done, skip else block:
							l_pos := -1 + 19
				when 15 then -- else: | _L___1:
							if not ((fabs (a_aR)) < 10.0) then
								l_pos := -1 + 18 -- skip if block
							end
				when 16 then -- if:
							if (fabs (a_aI)) < 10.0 then
								if a_x < -0.25 then
									Result := (hyperg_2F1_conj_luke (a_aR, a_aI, a_c___1, a_x, a_result))
									js.return
								else
									Result := (hyperg_2F1_conj_series (a_aR, a_aI, a_c___1, a_x, a_result))
									js.return
								end
							else
								l_pos := -1 + 18 -- goto _L___0
							end
				when 17 then -- if block done, skip else block:
							l_pos := -1 + 19
				when 18 then -- else: | _L___0:
							if a_x < 0.0 then
								Result := (hyperg_2F1_conj_luke (a_aR, a_aI, a_c___1, a_x, a_result))
								js.return
							end
							if not js.return_called then
								a_result.item.val := 0.0
								a_result.item.err := 0.0
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("error"), ce_string ("hyperg_2F1.c"), 799, 24)
									Result := 24
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
							end
				when 19 then -- if done | if done | if done
							if not js.return_called then
								Result := 0
							end
				when 20 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	gsl_sf_hyperg_2F1_renorm_e (a_a___5: REAL_64; a_b___0: REAL_64; a_c___1: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_rinta: REAL_64
			l_rintb: REAL_64
			l_rintc: REAL_64
			l_a_neg_integer: INTEGER_32
			l_tmp___3: INTEGER_32
			l_b_neg_integer: INTEGER_32
			l_tmp___5: INTEGER_32
			l_c_neg_integer: INTEGER_32
			l_tmp___7: INTEGER_32
			l_g1: PD_GSL_SF_RESULT_STRUCT
			l_g2: PD_GSL_SF_RESULT_STRUCT
			l_g3: PD_GSL_SF_RESULT_STRUCT
			l_g4: PD_GSL_SF_RESULT_STRUCT
			l_g5: PD_GSL_SF_RESULT_STRUCT
			l_s1: REAL_64
			l_s2: REAL_64
			l_s3: REAL_64
			l_s4: REAL_64
			l_s5: REAL_64
			l_stat: INTEGER_32
			l_F___0: PD_GSL_SF_RESULT_STRUCT
			l_stat_F: INTEGER_32
			l_ln_pre_val: REAL_64
			l_ln_pre_err: REAL_64
			l_sg: REAL_64
			l_stat_e: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_F___1: PD_GSL_SF_RESULT_STRUCT
			l_lng: PD_GSL_SF_RESULT_STRUCT
			l_sgn: REAL_64
			l_stat_g: INTEGER_32
			l_stat_F___0: INTEGER_32
			l_stat_e___0: INTEGER_32
			l_tmp___22: INTEGER_32
			l_tmp___23: INTEGER_32
			l_tmp___24: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_g1.make
			create l_g2.make
			create l_g3.make
			create l_g4.make
			create l_g5.make
			create l_F___0.make
			create l_F___1.make
			create l_lng.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_rinta := (floor (a_a___5 + 0.5))
					l_rintb := (floor (a_b___0 + 0.5))
					l_rintc := (floor (a_c___1 + 0.5))
					if a_a___5 < 0.0 then
						if (fabs (a_a___5 - l_rinta)) < 1000.0 * 2.2204460492503131e-16 then
							l_tmp___3 := 1
						else
							l_tmp___3 := 0
						end
					else
						l_tmp___3 := 0
					end
					l_a_neg_integer := l_tmp___3
					if a_b___0 < 0.0 then
						if (fabs (a_b___0 - l_rintb)) < 1000.0 * 2.2204460492503131e-16 then
							l_tmp___5 := 1
						else
							l_tmp___5 := 0
						end
					else
						l_tmp___5 := 0
					end
					l_b_neg_integer := l_tmp___5
					if a_c___1 < 0.0 then
						if (fabs (a_c___1 - l_rintc)) < 1000.0 * 2.2204460492503131e-16 then
							l_tmp___7 := 1
						else
							l_tmp___7 := 0
						end
					else
						l_tmp___7 := 0
					end
					l_c_neg_integer := l_tmp___7
					if not (l_c_neg_integer.to_boolean) then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if not (l_a_neg_integer.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if a_a___5 > a_c___1 + 0.1 then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							Result := 0
							js.return
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if not (l_b_neg_integer.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if a_b___0 > a_c___1 + 0.1 then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							Result := 0
							js.return
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						l_stat := 0
						l_stat := l_stat + (gamma_inst.gsl_sf_lngamma_sgn_e ((a_a___5 - a_c___1) + (1).to_double, l_g1.address, create {CE_POINTER [REAL_64]}.make_shared ($l_s1)))
						l_stat := l_stat + (gamma_inst.gsl_sf_lngamma_sgn_e ((a_b___0 - a_c___1) + (1).to_double, l_g2.address, create {CE_POINTER [REAL_64]}.make_shared ($l_s2)))
						l_stat := l_stat + (gamma_inst.gsl_sf_lngamma_sgn_e (a_a___5, l_g3.address, create {CE_POINTER [REAL_64]}.make_shared ($l_s3)))
						l_stat := l_stat + (gamma_inst.gsl_sf_lngamma_sgn_e (a_b___0, l_g4.address, create {CE_POINTER [REAL_64]}.make_shared ($l_s4)))
						l_stat := l_stat + (gamma_inst.gsl_sf_lngamma_sgn_e (-a_c___1 + (2).to_double, l_g5.address, create {CE_POINTER [REAL_64]}.make_shared ($l_s5)))
						if l_stat /= 0 then
							from
							until
								js.loop_left
							loop
								js.reset
								a_result.item.val := (builtin_nanf (ce_string (""))).to_double
								a_result.item.err := (builtin_nanf (ce_string (""))).to_double
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("domain error"), ce_string ("hyperg_2F1.c"), 836, 1)
									Result := 1
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
								if not js.return_called then
									js.break
								end
							end
							js.reset
						else
							l_stat_F := (gsl_sf_hyperg_2F1_e ((a_a___5 - a_c___1) + (1).to_double, (a_b___0 - a_c___1) + (1).to_double, -a_c___1 + (2).to_double, a_x, l_F___0.address))
							l_ln_pre_val := (((l_g1.val + l_g2.val) - l_g3.val) - l_g4.val) - l_g5.val
							l_ln_pre_err := (((l_g1.err + l_g2.err) + l_g3.err) + l_g4.err) + l_g5.err
							l_sg := (((l_s1 * l_s2) * l_s3) * l_s4) * l_s5
							l_stat_e := (exp_inst.gsl_sf_exp_mult_err_e (l_ln_pre_val, l_ln_pre_err, l_sg * l_F___0.val, l_F___0.err, a_result))
							if l_stat_e /= 0 then
								l_tmp___18 := l_stat_e
							else
								if l_stat_F /= 0 then
									l_tmp___17 := l_stat_F
								else
									l_tmp___17 := 0
								end
								l_tmp___18 := l_tmp___17
							end
							Result := l_tmp___18
							js.return
						end
				when 8 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_stat_g := (gamma_inst.gsl_sf_lngamma_sgn_e (a_c___1, l_lng.address, create {CE_POINTER [REAL_64]}.make_shared ($l_sgn)))
						l_stat_F___0 := (gsl_sf_hyperg_2F1_e (a_a___5, a_b___0, a_c___1, a_x, l_F___1.address))
						l_stat_e___0 := (exp_inst.gsl_sf_exp_mult_err_e (-l_lng.val, l_lng.err, l_sgn * l_F___1.val, l_F___1.err, a_result))
						if l_stat_e___0 /= 0 then
							l_tmp___24 := l_stat_e___0
						else
							if l_stat_F___0 /= 0 then
								l_tmp___23 := l_stat_F___0
							else
								if l_stat_g /= 0 then
									l_tmp___22 := l_stat_g
								else
									l_tmp___22 := 0
								end
								l_tmp___23 := l_tmp___22
							end
							l_tmp___24 := l_tmp___23
						end
						Result := l_tmp___24
						js.return
				when 10 then
					if not js.return_called then
						Result := 0
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_sf_hyperg_2F1_conj_renorm_e (a_aR: REAL_64; a_aI: REAL_64; a_c___1: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_rintc: REAL_64
			l_rinta: REAL_64
			l_a_neg_integer: INTEGER_32
			l_tmp___2: INTEGER_32
			l_c_neg_integer: INTEGER_32
			l_tmp___4: INTEGER_32
			l_g1: PD_GSL_SF_RESULT_STRUCT
			l_g2: PD_GSL_SF_RESULT_STRUCT
			l_g3: PD_GSL_SF_RESULT_STRUCT
			l_a1___4: PD_GSL_SF_RESULT_STRUCT
			l_a2___3: PD_GSL_SF_RESULT_STRUCT
			l_stat: INTEGER_32
			l_F___0: PD_GSL_SF_RESULT_STRUCT
			l_stat_F: INTEGER_32
			l_ln_pre_val: REAL_64
			l_ln_pre_err: REAL_64
			l_stat_e: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_F___1: PD_GSL_SF_RESULT_STRUCT
			l_lng: PD_GSL_SF_RESULT_STRUCT
			l_sgn: REAL_64
			l_stat_g: INTEGER_32
			l_stat_F___0: INTEGER_32
			l_stat_e___0: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_tmp___19: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_g1.make
			create l_g2.make
			create l_g3.make
			create l_a1___4.make
			create l_a2___3.make
			create l_F___0.make
			create l_F___1.make
			create l_lng.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_rintc := (floor (a_c___1 + 0.5))
					l_rinta := (floor (a_aR + 0.5))
					if a_aR < 0.0 then
						if (fabs (a_aR - l_rinta)) < 1000.0 * 2.2204460492503131e-16 then
							if a_aI = 0.0 then
								l_tmp___2 := 1
							else
								l_tmp___2 := 0
							end
						else
							l_tmp___2 := 0
						end
					else
						l_tmp___2 := 0
					end
					l_a_neg_integer := l_tmp___2
					if a_c___1 < 0.0 then
						if (fabs (a_c___1 - l_rintc)) < 1000.0 * 2.2204460492503131e-16 then
							l_tmp___4 := 1
						else
							l_tmp___4 := 0
						end
					else
						l_tmp___4 := 0
					end
					l_c_neg_integer := l_tmp___4
					if not (l_c_neg_integer.to_boolean) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (l_a_neg_integer.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if a_aR > a_c___1 + 0.1 then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							Result := 0
							js.return
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						l_stat := 0
						l_stat := l_stat + (gamma_inst.gsl_sf_lngamma_complex_e ((a_aR - a_c___1) + (1).to_double, a_aI, l_g1.address, l_a1___4.address))
						l_stat := l_stat + (gamma_inst.gsl_sf_lngamma_complex_e (a_aR, a_aI, l_g2.address, l_a2___3.address))
						l_stat := l_stat + (gamma_inst.gsl_sf_lngamma_e (-a_c___1 + 2.0, l_g3.address))
						if l_stat /= 0 then
							from
							until
								js.loop_left
							loop
								js.reset
								a_result.item.val := (builtin_nanf (ce_string (""))).to_double
								a_result.item.err := (builtin_nanf (ce_string (""))).to_double
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("domain error"), ce_string ("hyperg_2F1.c"), 895, 1)
									Result := 1
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
								if not js.return_called then
									js.break
								end
							end
							js.reset
						else
							l_stat_F := (gsl_sf_hyperg_2F1_conj_e ((a_aR - a_c___1) + (1).to_double, a_aI, -a_c___1 + (2).to_double, a_x, l_F___0.address))
							l_ln_pre_val := 2.0 * (l_g1.val - l_g2.val) - l_g3.val
							l_ln_pre_err := 2.0 * (l_g1.err + l_g2.err) + l_g3.err
							l_stat_e := (exp_inst.gsl_sf_exp_mult_err_e (l_ln_pre_val, l_ln_pre_err, l_F___0.val, l_F___0.err, a_result))
							if l_stat_e /= 0 then
								l_tmp___13 := l_stat_e
							else
								if l_stat_F /= 0 then
									l_tmp___12 := l_stat_F
								else
									l_tmp___12 := 0
								end
								l_tmp___13 := l_tmp___12
							end
							Result := l_tmp___13
							js.return
						end
				when 5 then -- if done | if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_stat_g := (gamma_inst.gsl_sf_lngamma_sgn_e (a_c___1, l_lng.address, create {CE_POINTER [REAL_64]}.make_shared ($l_sgn)))
						l_stat_F___0 := (gsl_sf_hyperg_2F1_conj_e (a_aR, a_aI, a_c___1, a_x, l_F___1.address))
						l_stat_e___0 := (exp_inst.gsl_sf_exp_mult_err_e (-l_lng.val, l_lng.err, l_sgn * l_F___1.val, l_F___1.err, a_result))
						if l_stat_e___0 /= 0 then
							l_tmp___19 := l_stat_e___0
						else
							if l_stat_F___0 /= 0 then
								l_tmp___18 := l_stat_F___0
							else
								if l_stat_g /= 0 then
									l_tmp___17 := l_stat_g
								else
									l_tmp___17 := 0
								end
								l_tmp___18 := l_tmp___17
							end
							l_tmp___19 := l_tmp___18
						end
						Result := l_tmp___19
						js.return
				when 7 then
					if not js.return_called then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_sf_hyperg_2F1 (a_a___5: REAL_64; a_b___0: REAL_64; a_c___1: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_hyperg_2F1_e (a_a___5, a_b___0, a_c___1, a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_hyperg_2F1_e(a, b, c, x, &result)"), ce_string ("hyperg_2F1.c"), 930, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_hyperg_2F1_conj (a_aR: REAL_64; a_aI: REAL_64; a_c___1: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_hyperg_2F1_conj_e (a_aR, a_aI, a_c___1, a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_hyperg_2F1_conj_e(aR, aI, c, x, &result)"), ce_string ("hyperg_2F1.c"), 935, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_hyperg_2F1_renorm (a_a___5: REAL_64; a_b___0: REAL_64; a_c___1: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_hyperg_2F1_renorm_e (a_a___5, a_b___0, a_c___1, a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_hyperg_2F1_renorm_e(a, b, c, x, &result)"), ce_string ("hyperg_2F1.c"), 940, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_hyperg_2F1_conj_renorm (a_aR: REAL_64; a_aI: REAL_64; a_c___1: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_hyperg_2F1_conj_renorm_e (a_aR, a_aI, a_c___1, a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_hyperg_2F1_conj_renorm_e(aR, aI, c, x, &result)"), ce_string ("hyperg_2F1.c"), 945, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
