class
	P_INIT

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_cheb_alloc (a_order: NATURAL_32): CE_POINTER [PD_GSL_CHEB_SERIES_STRUCT]
		local
			l_cs: CE_POINTER [PD_GSL_CHEB_SERIES_STRUCT]
			js: JUMP_STATE
		do
			create l_cs.make

			l_cs.ce_gets (create {CE_POINTER [PD_GSL_CHEB_SERIES_STRUCT]}.make_cast ((malloc ({PD_GSL_CHEB_SERIES_STRUCT}.sizeof.to_natural_32))))
			if (l_cs.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("failed to allocate gsl_cheb_series struct"), ce_string ("init.c"), 35, 8)
					Result := (create {CE_POINTER [PD_GSL_CHEB_SERIES_STRUCT]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_cs.item.order := a_order
				l_cs.item.order_sp := a_order
				l_cs.item.c := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((a_order + {NATURAL_32} 1) * Real_64_bytes.to_natural_32)))
				if ((l_cs.item.c).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate cheb coefficients"), ce_string ("init.c"), 44, 8)
						Result := (create {CE_POINTER [PD_GSL_CHEB_SERIES_STRUCT]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_cs.item.f := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((a_order + {NATURAL_32} 1) * Real_64_bytes.to_natural_32)))
				if ((l_cs.item.f).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate cheb function space"), ce_string ("init.c"), 50, 8)
						Result := (create {CE_POINTER [PD_GSL_CHEB_SERIES_STRUCT]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				Result := l_cs
			end
		end

	gsl_cheb_free (a_cs: CE_POINTER [PD_GSL_CHEB_SERIES_STRUCT])
		local
			js: JUMP_STATE
		do
			if (a_cs).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (a_cs.item.f))
				free (create {CE_POINTER [ANY]}.make_cast (a_cs.item.c))
				free (create {CE_POINTER [ANY]}.make_cast (a_cs))
			end
		end

	gsl_cheb_init (a_cs: CE_POINTER [PD_GSL_CHEB_SERIES_STRUCT]; a_func: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_a___5: REAL_64; a_b___0: REAL_64): INTEGER_32
		local
			l_k: NATURAL_32
			l_j: NATURAL_32
			l_bma: REAL_64
			l_bpa: REAL_64
			l_fac: REAL_64
			l_y: REAL_64
			l_sum: REAL_64
			js: JUMP_STATE
		do
			if a_a___5 >= a_b___0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("null function interval [a,b]"), ce_string ("init.c"), 73, 1)
					Result := 0
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				a_cs.item.a := a_a___5
				a_cs.item.b := a_b___0
				l_bma := 0.5 * (a_cs.item.b - a_cs.item.a)
				l_bpa := 0.5 * (a_cs.item.b + a_cs.item.a)
				l_fac := 2.0 / ((a_cs.item.order).to_real_64 + 1.0)
				l_k := (0).to_natural_32
				from
				until
					not (l_k <= a_cs.item.order)
				loop
					l_y := (cos ((3.14159265358979323846 * (l_k.to_real_64 + 0.5)) / (a_cs.item.order + {NATURAL_32} 1).to_real_64))
					a_cs.item.f[l_k.to_integer_32] := (a_func.item.function).real_64_item ([l_y * l_bma + l_bpa, a_func.item.params])
					l_k := l_k + 1
				end
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j <= a_cs.item.order))
				loop
					l_sum := 0.0
					l_k := (0).to_natural_32
					from
					until
						not (l_k <= a_cs.item.order)
					loop
						l_sum := l_sum + (a_cs.item.f[l_k.to_integer_32] * (cos (((3.14159265358979323846 * l_j.to_real_64) * (l_k.to_real_64 + 0.5)) / (a_cs.item.order + {NATURAL_32} 1).to_real_64)))
						l_k := l_k + 1
					end
					a_cs.item.c[l_j.to_integer_32] := l_fac * l_sum
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_cheb_order (a_cs: CE_POINTER [PD_GSL_CHEB_SERIES_STRUCT]): NATURAL_32
		do
			Result := (a_cs.item.order)
		end

	gsl_cheb_size (a_cs: CE_POINTER [PD_GSL_CHEB_SERIES_STRUCT]): NATURAL_32
		do
			Result := (a_cs.item.order + {NATURAL_32} 1)
		end

	gsl_cheb_coeffs (a_cs: CE_POINTER [PD_GSL_CHEB_SERIES_STRUCT]): CE_POINTER [REAL_64]
		do
			Result := (a_cs.item.c)
		end

	gsl_histogram_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_HISTOGRAM]
		local
			l_h: CE_POINTER [PD_GSL_HISTOGRAM]
			js: JUMP_STATE
		do
			create l_h.make

			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("histogram length n must be positive integer"), ce_string ("init.c"), 33, 1)
					Result := (create {CE_POINTER [PD_GSL_HISTOGRAM]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_h.ce_gets (create {CE_POINTER [PD_GSL_HISTOGRAM]}.make_cast ((malloc ({PD_GSL_HISTOGRAM}.sizeof.to_natural_32))))
				if (l_h.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram struct"), ce_string ("init.c"), 41, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_h.item.range := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((a_n + {NATURAL_32} 1) * Real_64_bytes.to_natural_32)))
				if ((l_h.item.range).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_h))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram ranges"), ce_string ("init.c"), 51, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_h.item.bin := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_n * Real_64_bytes.to_natural_32)))
				if ((l_h.item.bin).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_h.item.range))
					free (create {CE_POINTER [ANY]}.make_cast (l_h))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram bins"), ce_string ("init.c"), 62, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_h.item.n := a_n
				Result := l_h
			end
		end

	make_uniform___0 (a_range: CE_POINTER [REAL_64]; a_n: NATURAL_32; a_xmin: REAL_64; a_xmax: REAL_64)
		local
			l_i: NATURAL_32
			l_f1: REAL_64
			l_f2: REAL_64
		do
			l_i := (0).to_natural_32
			from
			until
				not (l_i <= a_n)
			loop
				l_f1 := (a_n - l_i).to_real_64 / a_n.to_real_64
				l_f2 := l_i.to_real_64 / a_n.to_real_64
				a_range[l_i.to_integer_32] := l_f1 * a_xmin + l_f2 * a_xmax
				l_i := l_i + 1
			end
		end

	gsl_histogram_calloc_uniform (a_n: NATURAL_32; a_xmin: REAL_64; a_xmax: REAL_64): CE_POINTER [PD_GSL_HISTOGRAM]
		local
			l_h: CE_POINTER [PD_GSL_HISTOGRAM]
			js: JUMP_STATE
		do
			create l_h.make

			if a_xmin >= a_xmax then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("xmin must be less than xmax"), ce_string ("init.c"), 91, 4)
					Result := (create {CE_POINTER [PD_GSL_HISTOGRAM]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_h.ce_gets (gsl_histogram_calloc (a_n))
				if (l_h.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := l_h
					js.return
				end
			end
			if not js.return_called then
				make_uniform___0 (l_h.item.range, a_n, a_xmin, a_xmax)
				Result := l_h
			end
		end

	gsl_histogram_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_HISTOGRAM]
		local
			l_h: CE_POINTER [PD_GSL_HISTOGRAM]
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			create l_h.make

			l_h.ce_gets ((gsl_histogram_alloc (a_n)))
			if (l_h.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := l_h
				js.return
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n + {NATURAL_32} 1)
				loop
					l_h.item.range[l_i.to_integer_32] := l_i.to_real_64
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_h.item.bin[l_i.to_integer_32] := (0).to_double
					l_i := l_i + 1
				end
				l_h.item.n := a_n
				Result := l_h
			end
		end

	gsl_histogram_free (a_h: CE_POINTER [PD_GSL_HISTOGRAM])
		local
			js: JUMP_STATE
		do
			if (a_h).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (a_h.item.range))
				free (create {CE_POINTER [ANY]}.make_cast (a_h.item.bin))
				free (create {CE_POINTER [ANY]}.make_cast (a_h))
			end
		end

	gsl_histogram_set_ranges_uniform (a_h: CE_POINTER [PD_GSL_HISTOGRAM]; a_xmin: REAL_64; a_xmax: REAL_64): INTEGER_32
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_h.item.n
			if a_xmin >= a_xmax then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("xmin must be less than xmax"), ce_string ("init.c"), 155, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				make_uniform___0 (a_h.item.range, l_n, a_xmin, a_xmax)
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_n)
				loop
					a_h.item.bin[l_i.to_integer_32] := (0).to_double
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_histogram_set_ranges (a_h: CE_POINTER [PD_GSL_HISTOGRAM]; a_range: CE_POINTER [REAL_64]; a_size: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_h.item.n
			if a_size /= l_n + {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("size of range must match size of histogram"), ce_string ("init.c"), 180, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i <= l_n)
				loop
					a_h.item.range[l_i.to_integer_32] := a_range[l_i.to_integer_32]
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_n)
				loop
					a_h.item.bin[l_i.to_integer_32] := (0).to_double
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_permutation_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
		local
			l_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
			js: JUMP_STATE
		do
			create l_p.make

			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("permutation length n must be positive integer"), ce_string ("init.c"), 33, 1)
					Result := (create {CE_POINTER [PD_GSL_PERMUTATION_STRUCT]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_p.ce_gets (create {CE_POINTER [PD_GSL_PERMUTATION_STRUCT]}.make_cast ((malloc ({PD_GSL_PERMUTATION_STRUCT}.sizeof.to_natural_32))))
				if (l_p.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for permutation struct"), ce_string ("init.c"), 41, 8)
						Result := (create {CE_POINTER [PD_GSL_PERMUTATION_STRUCT]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_p.item.data := create {CE_POINTER [NATURAL_32]}.make_cast ((malloc (a_n * Natural_32_bytes.to_natural_32)))
				if ((l_p.item.data).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_p))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for permutation data"), ce_string ("init.c"), 51, 8)
						Result := (create {CE_POINTER [PD_GSL_PERMUTATION_STRUCT]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_p.item.size := a_n
				Result := l_p
			end
		end

	gsl_permutation_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
		local
			l_i: NATURAL_32
			l_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
			js: JUMP_STATE
		do
			create l_p.make

			l_p.ce_gets ((gsl_permutation_alloc (a_n)))
			if (l_p.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (create {CE_POINTER [PD_GSL_PERMUTATION_STRUCT]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_p.item.data[l_i.to_integer_32] := l_i
					l_i := l_i + 1
				end
				Result := l_p
			end
		end

	gsl_permutation_init (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT])
		local
			l_n: NATURAL_32
			l_i: NATURAL_32
		do
			l_n := a_p.item.size
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				a_p.item.data[l_i.to_integer_32] := l_i
				l_i := l_i + 1
			end
		end

	gsl_permutation_free (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT])
		local
			js: JUMP_STATE
		do
			if (a_p).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (a_p.item.data))
				free (create {CE_POINTER [ANY]}.make_cast (a_p))
			end
		end

	gsl_combination_alloc (a_n: NATURAL_32; a_k: NATURAL_32): CE_POINTER [PD_GSL_COMBINATION_STRUCT]
		local
			l_c___1: CE_POINTER [PD_GSL_COMBINATION_STRUCT]
			js: JUMP_STATE
		do
			create l_c___1.make

			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("combination parameter n must be positive integer"), ce_string ("init.c"), 35, 1)
					Result := (create {CE_POINTER [PD_GSL_COMBINATION_STRUCT]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_k > a_n) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("combination length k must be an integer less than or equal to n"), ce_string ("init.c"), 40, 1)
					Result := (create {CE_POINTER [PD_GSL_COMBINATION_STRUCT]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_c___1.ce_gets (create {CE_POINTER [PD_GSL_COMBINATION_STRUCT]}.make_cast ((malloc ({PD_GSL_COMBINATION_STRUCT}.sizeof.to_natural_32))))
				if (l_c___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for combination struct"), ce_string ("init.c"), 47, 8)
						Result := (create {CE_POINTER [PD_GSL_COMBINATION_STRUCT]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				if a_k > {NATURAL_32} 0 then
					l_c___1.item.data := create {CE_POINTER [NATURAL_32]}.make_cast ((malloc (a_k * Natural_32_bytes.to_natural_32)))
					if ((l_c___1.item.data).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						free (create {CE_POINTER [ANY]}.make_cast (l_c___1))
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("failed to allocate space for combination data"), ce_string ("init.c"), 59, 8)
							Result := (create {CE_POINTER [PD_GSL_COMBINATION_STRUCT]}.make_shared (default_pointer))
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
				else
					l_c___1.item.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				end
			end
			if not js.return_called then
				l_c___1.item.n := a_n
				l_c___1.item.k := a_k
				Result := l_c___1
			end
		end

	gsl_combination_calloc (a_n: NATURAL_32; a_k: NATURAL_32): CE_POINTER [PD_GSL_COMBINATION_STRUCT]
		local
			l_i: NATURAL_32
			l_c___1: CE_POINTER [PD_GSL_COMBINATION_STRUCT]
			js: JUMP_STATE
		do
			create l_c___1.make

			l_c___1.ce_gets ((gsl_combination_alloc (a_n, a_k)))
			if (l_c___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (create {CE_POINTER [PD_GSL_COMBINATION_STRUCT]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_k)
				loop
					l_c___1.item.data[l_i.to_integer_32] := l_i
					l_i := l_i + 1
				end
				Result := l_c___1
			end
		end

	gsl_combination_init_first (a_c___1: CE_POINTER [PD_GSL_COMBINATION_STRUCT])
		local
			l_k: NATURAL_32
			l_i: NATURAL_32
		do
			l_k := a_c___1.item.k
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_k)
			loop
				a_c___1.item.data[l_i.to_integer_32] := l_i
				l_i := l_i + 1
			end
		end

	gsl_combination_init_last (a_c___1: CE_POINTER [PD_GSL_COMBINATION_STRUCT])
		local
			l_k: NATURAL_32
			l_i: NATURAL_32
			l_n: NATURAL_32
		do
			l_k := a_c___1.item.k
			l_n := a_c___1.item.n
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_k)
			loop
				a_c___1.item.data[l_i.to_integer_32] := (l_n - l_k) + l_i
				l_i := l_i + 1
			end
		end

	gsl_combination_free (a_c___1: CE_POINTER [PD_GSL_COMBINATION_STRUCT])
		local
			js: JUMP_STATE
		do
			if (a_c___1).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				if a_c___1.item.k > {NATURAL_32} 0 then
					free (create {CE_POINTER [ANY]}.make_cast (a_c___1.item.data))
				end
				free (create {CE_POINTER [ANY]}.make_cast (a_c___1))
			end
		end

	gsl_multiset_alloc (a_n: NATURAL_32; a_k: NATURAL_32): CE_POINTER [PD_GSL_MULTISET_STRUCT]
		local
			l_c___1: CE_POINTER [PD_GSL_MULTISET_STRUCT]
			js: JUMP_STATE
		do
			create l_c___1.make

			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("multiset parameter n must be positive integer"), ce_string ("init.c"), 37, 1)
					Result := (create {CE_POINTER [PD_GSL_MULTISET_STRUCT]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_k > a_n) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("multiset length k must be an integer less than or equal to n"), ce_string ("init.c"), 42, 1)
					Result := (create {CE_POINTER [PD_GSL_MULTISET_STRUCT]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_c___1.ce_gets (create {CE_POINTER [PD_GSL_MULTISET_STRUCT]}.make_cast ((malloc ({PD_GSL_MULTISET_STRUCT}.sizeof.to_natural_32))))
				if (l_c___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for multiset struct"), ce_string ("init.c"), 49, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTISET_STRUCT]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				if a_k > {NATURAL_32} 0 then
					l_c___1.item.data := create {CE_POINTER [NATURAL_32]}.make_cast ((malloc (a_k * Natural_32_bytes.to_natural_32)))
					if ((l_c___1.item.data).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						free (create {CE_POINTER [ANY]}.make_cast (l_c___1))
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("failed to allocate space for multiset data"), ce_string ("init.c"), 61, 8)
							Result := (create {CE_POINTER [PD_GSL_MULTISET_STRUCT]}.make_shared (default_pointer))
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
				else
					l_c___1.item.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				end
			end
			if not js.return_called then
				l_c___1.item.n := a_n
				l_c___1.item.k := a_k
				Result := l_c___1
			end
		end

	gsl_multiset_calloc (a_n: NATURAL_32; a_k: NATURAL_32): CE_POINTER [PD_GSL_MULTISET_STRUCT]
		local
			l_i: NATURAL_32
			l_c___1: CE_POINTER [PD_GSL_MULTISET_STRUCT]
			js: JUMP_STATE
		do
			create l_c___1.make

			l_c___1.ce_gets ((gsl_multiset_alloc (a_n, a_k)))
			if (l_c___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (create {CE_POINTER [PD_GSL_MULTISET_STRUCT]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_k)
				loop
					l_c___1.item.data[l_i.to_integer_32] := (0).to_natural_32
					l_i := l_i + 1
				end
				Result := l_c___1
			end
		end

	gsl_multiset_init_first (a_c___1: CE_POINTER [PD_GSL_MULTISET_STRUCT])
		local
			l_k: NATURAL_32
			l_i: NATURAL_32
		do
			l_k := a_c___1.item.k
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_k)
			loop
				a_c___1.item.data[l_i.to_integer_32] := (0).to_natural_32
				l_i := l_i + 1
			end
		end

	gsl_multiset_init_last (a_c___1: CE_POINTER [PD_GSL_MULTISET_STRUCT])
		local
			l_k: NATURAL_32
			l_i: NATURAL_32
			l_n: NATURAL_32
		do
			l_k := a_c___1.item.k
			l_n := a_c___1.item.n
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_k)
			loop
				a_c___1.item.data[l_i.to_integer_32] := l_n - {NATURAL_32} 1
				l_i := l_i + 1
			end
		end

	gsl_multiset_free (a_c___1: CE_POINTER [PD_GSL_MULTISET_STRUCT])
		local
			js: JUMP_STATE
		do
			if (a_c___1).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				if a_c___1.item.k > {NATURAL_32} 0 then
					free (create {CE_POINTER [ANY]}.make_cast (a_c___1.item.data))
				end
				free (create {CE_POINTER [ANY]}.make_cast (a_c___1))
			end
		end

end
