class
	P_ISAMAX

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_isamax (a_N: INTEGER_32; a_X: CE_POINTER [REAL_32]; a_incX: INTEGER_32): NATURAL_32
		local
			l_max: REAL_32
			l_ix: INTEGER_32
			l_i: INTEGER_32
			l_result: NATURAL_32
			js: JUMP_STATE
		do
			l_max := (0.0).truncated_to_real
			l_ix := 0
			l_result := (0).to_natural_32
			if a_incX <= 0 then
				Result := (0).to_natural_32
				js.return
			end
			if not js.return_called then
				l_i := 0
				from
				until
					not (l_i < a_N)
				loop
					if (fabs ((a_X[l_ix]).to_double)) > l_max.to_double then
						l_max := (fabs ((a_X[l_ix]).to_double)).truncated_to_real
						l_result := l_i.to_natural_32
					end
					l_ix := l_ix + a_incX
					l_i := l_i + 1
				end
				Result := l_result
			end
		end

end
