class
	P_LAPLACE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_ran_laplace (a_r___3: CE_POINTER [PD_GSL_RNG]; a_a___5: REAL_64): REAL_64
		local
			l_u: REAL_64
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				l_u := (2).to_double * (gsl_gsl_rng_inst.gsl_rng_uniform (a_r___3)) - 1.0
				if l_u /= 0.0 then
					js.break
				end
			end
			js.reset
			if l_u < (0).to_double then
				Result := (a_a___5 * (log (-l_u)))
			else
				Result := (-a_a___5 * (log (l_u)))
			end
		end

	gsl_ran_laplace_pdf (a_x: REAL_64; a_a___5: REAL_64): REAL_64
		local
			l_p: REAL_64
		do
			l_p := ((1).to_double / ((2).to_double * a_a___5)) * (exp (-(fabs (a_x)) / a_a___5))
			Result := l_p
		end

	gsl_cdf_laplace_P (a_x: REAL_64; a_a___5: REAL_64): REAL_64
		local
			l_P___2: REAL_64
			l_u: REAL_64
		do
			l_u := a_x / a_a___5
			if l_u > (0).to_double then
				l_P___2 := 0.5 + 0.5 * ((1).to_double - (exp (-l_u)))
			else
				l_P___2 := 0.5 * (exp (l_u))
			end
			Result := l_P___2
		end

	gsl_cdf_laplace_Q (a_x: REAL_64; a_a___5: REAL_64): REAL_64
		local
			l_Q___1: REAL_64
			l_u: REAL_64
		do
			l_u := a_x / a_a___5
			if l_u > (0).to_double then
				l_Q___1 := 0.5 * (exp (-l_u))
			else
				l_Q___1 := (1).to_double - 0.5 * (exp (l_u))
			end
			Result := l_Q___1
		end

end
