class
	P_LDFREXP

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_ldexp (a_x: REAL_64; a_e: INTEGER_32): REAL_64
		local
			l_ex: INTEGER_32
			l_y: REAL_64
			l_e2: REAL_64
			l_p2: REAL_64
			js: JUMP_STATE
		do
			if a_x = 0.0 then
				Result := a_x
				js.return
			end
			if not js.return_called then
				l_y := (gsl_frexp (a_x, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ex)))
				l_e2 := (a_e + l_ex).to_double
				if l_e2 >= (1024).to_double then
					l_y := l_y * (pow (2.0, (l_e2 - (1024).to_double) + (1).to_double))
					l_e2 := (1023).to_double
				elseif l_e2 <= (-1021).to_double then
					l_y := l_y * (pow (2.0, (l_e2 - (-1021).to_double) - (1).to_double))
					l_e2 := (-1020).to_double
				end
				l_p2 := pow (2.0, l_e2)
				Result := (l_y * l_p2)
			end
		end

	gsl_frexp (a_x: REAL_64; a_e: CE_POINTER [INTEGER_32]): REAL_64
		local
			l_ex: REAL_64
			l_ei: INTEGER_32
			l_f: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_x /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_e.item := 0
						Result := (0.0)
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if not ((finite (a_x)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if not ((fabs (a_x)) >= 0.5) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (fabs (a_x)) < (1).to_double then
							a_e.item := 0
							Result := a_x
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						l_ex := (ceil ((log ((fabs (a_x)))) / 0.69314718055994530942))
						l_ei := l_ex.truncated_to_integer
						if l_ei < -1021 then
							l_ei := -1021
						end
						if l_ei > 1021 then
							l_ei := 1021
						end
						l_f := a_x * (pow (2.0, (-l_ei).to_double))
						if not (finite (l_f)).to_boolean then
							a_e.item := 0
							Result := l_f
							js.return
						end
						if not js.return_called then
							from
							until
								js.loop_left
							loop
								js.reset
								if not ((fabs (l_f)) >= 1.0) then
									js.break
								end
								if not js.loop_jumped then
									l_ei := l_ei + 1
									l_f := l_f / (2.0)
								end
							end
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								if (fabs (l_f)) > (0).to_double then
									if not ((fabs (l_f)) < 0.5) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_ei := l_ei - 1
									l_f := l_f * (2.0)
								end
							end
							js.reset
							a_e.item := l_ei
							Result := l_f
						end
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						a_e.item := 0
						Result := a_x
				when 10 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
