class
	P_LECUYER21

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create ran_type___4.make
			create gsl_rng_lecuyer21.make
		end

feature {ANY} -- attributes

	ran_type___4: PD_GSL_RNG_TYPE

	gsl_rng_lecuyer21: CE_POINTER [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	ran_get___4 (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAN_STATE_T]
			l_y: INTEGER_32
			l_r___3: INTEGER_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate))
			l_y := (l_state.item.x).to_integer_32
			l_r___3 := 3791 * (l_y // 52774)
			l_y := 40692 * (l_y \\ 52774) - l_r___3
			if l_y < 0 then
				l_y := (l_y.to_natural_32 + {NATURAL_32} 2147483399).to_integer_32
			end
			l_state.item.x := l_y.to_natural_32
			Result := (l_state.item.x)
		end

	ran_get___4_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran_get___4)
		end

	ran_get_double___4 (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate))
			Result := ((ran_get___4 (create {CE_POINTER [ANY]}.make_cast (l_state))).to_real_64 / 2147483399.0)
		end

	ran_get_double___4_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran_get_double___4)
		end

	ran_set___4 (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			create l_state.make

			l_s := a_s
			l_state.ce_gets (create {CE_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate))
			if l_s \\ {NATURAL_32} 2147483399 = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.x := l_s \\ {NATURAL_32} 2147483399
		end

	ran_set___4_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran_set___4)
		end

end
