class
	P_LEGENDRE_QN

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	legendreQ_CF1_xgt1 (a_ell: INTEGER_32; a_a___5: REAL_64; a_b___0: REAL_64; a_x: REAL_64; a_result: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_RECUR_BIG: REAL_64
			l_maxiter: INTEGER_32
			l_n: INTEGER_32
			l_Anm2: REAL_64
			l_Bnm2: REAL_64
			l_Anm1: REAL_64
			l_Bnm1: REAL_64
			l_a1___4: REAL_64
			l_b1___0: REAL_64
			l_An: REAL_64
			l_Bn: REAL_64
			l_an2: REAL_64
			l_bn2: REAL_64
			l_fn: REAL_64
			l_old_fn: REAL_64
			l_del: REAL_64
			l_lna: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_RECUR_BIG := 1.3407807929942596e+154
					l_maxiter := 5000
					l_n := 1
					l_Anm2 := 1.0
					l_Bnm2 := 0.0
					l_Anm1 := 0.0
					l_Bnm1 := 1.0
					l_a1___4 := ((a_ell.to_double + 1.0) + a_a___5) + a_b___0
					l_b1___0 := (2.0 * ((a_ell.to_double + 1.0) + a_a___5) + 1.0) * a_x
					l_An := l_b1___0 * l_Anm1 + l_a1___4 * l_Anm2
					l_Bn := l_b1___0 * l_Bnm1 + l_a1___4 * l_Bnm2
					l_fn := l_An / l_Bn
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_n < l_maxiter)) then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_n := l_n + 1
						l_Anm2 := l_Anm1
						l_Bnm2 := l_Bnm1
						l_Anm1 := l_An
						l_Bnm1 := l_Bn
						l_lna := (a_ell + l_n).to_double + a_a___5
						l_an2 := a_b___0 * a_b___0 - l_lna * l_lna
						l_bn2 := (2.0 * l_lna + 1.0) * a_x
						l_An := l_bn2 * l_Anm1 + l_an2 * l_Anm2
						l_Bn := l_bn2 * l_Bnm1 + l_an2 * l_Bnm2
						if not ((fabs (l_An)) > l_RECUR_BIG) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if not ((fabs (l_Bn)) > l_RECUR_BIG) then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						l_An := l_An / l_RECUR_BIG
						l_Bn := l_Bn / l_RECUR_BIG
						l_Anm1 := l_Anm1 / l_RECUR_BIG
						l_Bnm1 := l_Bnm1 / l_RECUR_BIG
						l_Anm2 := l_Anm2 / l_RECUR_BIG
						l_Bnm2 := l_Bnm2 / l_RECUR_BIG
				when 7 then -- if done
						l_old_fn := l_fn
						l_fn := l_An / l_Bn
						l_del := l_old_fn / l_fn
						if (fabs (l_del - 1.0)) < 4.0 * 2.2204460492503131e-16 then
							js.break
						end
						l_pos := -1 + 1 -- back to loop condition
				when 8 then -- loop done
					js.reset
					a_result.item := l_fn
					if l_n = l_maxiter then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("error"), ce_string ("legendre_Qn.c"), 89, 11)
							Result := 11
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					else
						Result := 0
						js.return
					end
					if not js.return_called then
						Result := 0
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	legendre_Ql_asymp_unif (a_ell: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_u: REAL_64
			l_th: REAL_64
			l_Y0: PD_GSL_SF_RESULT_STRUCT
			l_Y1: PD_GSL_SF_RESULT_STRUCT
			l_stat_Y0: INTEGER_32
			l_stat_Y1: INTEGER_32
			l_stat_m: INTEGER_32
			l_pre: REAL_64
			l_B00: REAL_64
			l_sum: REAL_64
			l_sin_th: REAL_64
			l_cot_th: REAL_64
			l_tmp___1: REAL_64
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_u___0: REAL_64
			l_xi: REAL_64
			l_K0_scaled: PD_GSL_SF_RESULT_STRUCT
			l_K1_scaled: PD_GSL_SF_RESULT_STRUCT
			l_stat_K0: INTEGER_32
			l_stat_K1: INTEGER_32
			l_stat_e: INTEGER_32
			l_pre___0: REAL_64
			l_B00___0: REAL_64
			l_sum___0: REAL_64
			l_sinh_xi: REAL_64
			l_coth_xi: REAL_64
			l_tmp___9: REAL_64
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
		do
			create l_Y0.make
			create l_Y1.make
			create l_K0_scaled.make
			create l_K1_scaled.make

			if a_x < 1.0 then
				l_u := a_ell + 0.5
				l_th := (acos (a_x))
				if l_th < 1.2207031250000000e-04 then
					l_B00 := (1.0 + (l_th * l_th) / 15.0) / 24.0
					l_pre := 1.0 + (l_th * l_th) / 12.0
				else
					l_sin_th := (sqrt (1.0 - a_x * a_x))
					l_cot_th := a_x / l_sin_th
					l_B00 := ((1.0 / 8.0) * (1.0 - l_th * l_cot_th)) / (l_th * l_th)
					l_pre := sqrt (l_th / l_sin_th)
				end
				l_stat_Y0 := bessel_y0_inst.gsl_sf_bessel_Y0_e (l_u * l_th, l_Y0.address)
				l_stat_Y1 := bessel_y1_inst.gsl_sf_bessel_Y1_e (l_u * l_th, l_Y1.address)
				l_sum := (-0.5 * 3.14159265358979323846) * (l_Y0.val + ((l_th / l_u) * l_Y1.val) * l_B00)
				l_stat_m := elementary_inst.gsl_sf_multiply_e (l_pre, l_sum, a_result)
				l_tmp___1 := fabs (l_pre)
				a_result.item.err := a_result.item.err + (((0.5 * 3.14159265358979323846) * l_tmp___1) * (l_Y0.err + (fabs ((l_th / l_u) * l_B00)) * l_Y1.err))
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				if l_stat_m /= 0 then
					l_tmp___6 := l_stat_m
				else
					if l_stat_Y0 /= 0 then
						l_tmp___5 := l_stat_Y0
					else
						if l_stat_Y1 /= 0 then
							l_tmp___4 := l_stat_Y1
						else
							l_tmp___4 := 0
						end
						l_tmp___5 := l_tmp___4
					end
					l_tmp___6 := l_tmp___5
				end
				Result := l_tmp___6
			else
				l_u___0 := a_ell + 0.5
				l_xi := (acosh (a_x))
				if l_xi < 1.2207031250000000e-04 then
					l_B00___0 := (1.0 - (l_xi * l_xi) / 15.0) / 24.0
					l_pre___0 := 1.0 - (l_xi * l_xi) / 12.0
				else
					l_sinh_xi := (sqrt (a_x * a_x - 1.0))
					l_coth_xi := a_x / l_sinh_xi
					l_B00___0 := ((-1.0 / 8.0) * (1.0 - l_xi * l_coth_xi)) / (l_xi * l_xi)
					l_pre___0 := sqrt (l_xi / l_sinh_xi)
				end
				l_stat_K0 := bessel_k0_inst.gsl_sf_bessel_K0_scaled_e2 (l_u___0 * l_xi, l_K0_scaled.address)
				l_stat_K1 := bessel_k1_inst.gsl_sf_bessel_K1_scaled_e2 (l_u___0 * l_xi, l_K1_scaled.address)
				l_sum___0 := l_K0_scaled.val - ((l_xi / l_u___0) * l_K1_scaled.val) * l_B00___0
				l_stat_e := exp_inst.gsl_sf_exp_mult_e (-l_u___0 * l_xi, l_pre___0 * l_sum___0, a_result)
				l_tmp___9 := fabs (a_result.item.val)
				a_result.item.err := (2.2204460492503131e-16 * l_tmp___9) * (fabs (l_u___0 * l_xi))
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				if l_stat_e /= 0 then
					l_tmp___14 := l_stat_e
				else
					if l_stat_K0 /= 0 then
						l_tmp___13 := l_stat_K0
					else
						if l_stat_K1 /= 0 then
							l_tmp___12 := l_stat_K1
						else
							l_tmp___12 := 0
						end
						l_tmp___13 := l_tmp___12
					end
					l_tmp___14 := l_tmp___13
				end
				Result := l_tmp___14
			end
		end

	gsl_sf_legendre_Q0_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_c3___3: REAL_64
			l_c5___1: REAL_64
			l_c7___0: REAL_64
			l_c9: REAL_64
			l_c11: REAL_64
			l_y: REAL_64
			l_series: REAL_64
			l_y___0: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___4: REAL_64
			l_c4___2: REAL_64
			l_c5___2: REAL_64
			l_c6___2: REAL_64
			l_c7___1: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_x <= -1.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_x /= 1.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("legendre_Qn.c"), 185, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if a_x * a_x < 2.4607833005759251e-03 then
							l_c3___3 := 1.0 / 3.0
							l_c5___1 := 1.0 / 5.0
							l_c7___0 := 1.0 / 7.0
							l_c9 := 1.0 / 9.0
							l_c11 := 1.0 / 11.0
							l_y := a_x * a_x
							l_series := 1.0 + l_y * (l_c3___3 + l_y * (l_c5___1 + l_y * (l_c7___0 + l_y * (l_c9 + l_y * l_c11))))
							a_result.item.val := a_x * l_series
							a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_x))
							Result := 0
							js.return
						elseif a_x < 1.0 then
							a_result.item.val := 0.5 * (log ((1.0 + a_x) / (1.0 - a_x)))
							a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
							Result := 0
							js.return
						elseif a_x < 10.0 then
							a_result.item.val := 0.5 * (log ((a_x + 1.0) / (a_x - 1.0)))
							a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
							Result := 0
							js.return
						elseif a_x * 2.2250738585072014e-308 < 2.0 then
							l_y___0 := 1.0 / (a_x * a_x)
							l_c1___2 := 1.0 / 3.0
							l_c2___0 := 1.0 / 5.0
							l_c3___4 := 1.0 / 7.0
							l_c4___2 := 1.0 / 9.0
							l_c5___2 := 1.0 / 11.0
							l_c6___2 := 1.0 / 13.0
							l_c7___1 := 1.0 / 15.0
							a_result.item.val := (1.0 / a_x) * (1.0 + l_y___0 * (l_c1___2 + l_y___0 * (l_c2___0 + l_y___0 * (l_c3___4 + l_y___0 * (l_c4___2 + l_y___0 * (l_c5___2 + l_y___0 * (l_c6___2 + l_y___0 * l_c7___1)))))))
							a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
							Result := 0
							js.return
						else
							from
							until
								js.loop_left
							loop
								js.reset
								a_result.item.val := 0.0
								a_result.item.err := 2.2250738585072014e-308
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("underflow"), ce_string ("legendre_Qn.c"), 223, 15)
									Result := 15
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_legendre_Q1_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_c3___3: REAL_64
			l_c5___1: REAL_64
			l_c7___0: REAL_64
			l_c9: REAL_64
			l_c11: REAL_64
			l_y: REAL_64
			l_series: REAL_64
			l_y___0: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___4: REAL_64
			l_c4___2: REAL_64
			l_c5___2: REAL_64
			l_c6___2: REAL_64
			l_c7___1: REAL_64
			l_c8___0: REAL_64
			l_sum: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_x <= -1.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_x /= 1.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("legendre_Qn.c"), 234, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if a_x * a_x < 2.4607833005759251e-03 then
							l_c3___3 := 1.0 / 3.0
							l_c5___1 := 1.0 / 5.0
							l_c7___0 := 1.0 / 7.0
							l_c9 := 1.0 / 9.0
							l_c11 := 1.0 / 11.0
							l_y := a_x * a_x
							l_series := 1.0 + l_y * (l_c3___3 + l_y * (l_c5___1 + l_y * (l_c7___0 + l_y * (l_c9 + l_y * l_c11))))
							a_result.item.val := (a_x * a_x) * l_series - 1.0
							a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
							Result := 0
							js.return
						elseif a_x < 1.0 then
							a_result.item.val := (0.5 * a_x) * (log ((1.0 + a_x) / (1.0 - a_x))) - 1.0
							a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
							Result := 0
							js.return
						elseif a_x < 6.0 then
							a_result.item.val := (0.5 * a_x) * (log ((a_x + 1.0) / (a_x - 1.0))) - 1.0
							a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
							Result := 0
							js.return
						elseif a_x * 1.4916681462400413e-154 < 0.99 / 1.73205080756887729352744634151 then
							l_y___0 := (1).to_double / (a_x * a_x)
							l_c1___2 := 3.0 / 5.0
							l_c2___0 := 3.0 / 7.0
							l_c3___4 := 3.0 / 9.0
							l_c4___2 := 3.0 / 11.0
							l_c5___2 := 3.0 / 13.0
							l_c6___2 := 3.0 / 15.0
							l_c7___1 := 3.0 / 17.0
							l_c8___0 := 3.0 / 19.0
							l_sum := 1.0 + l_y___0 * (l_c1___2 + l_y___0 * (l_c2___0 + l_y___0 * (l_c3___4 + l_y___0 * (l_c4___2 + l_y___0 * (l_c5___2 + l_y___0 * (l_c6___2 + l_y___0 * (l_c7___1 + l_y___0 * l_c8___0)))))))
							a_result.item.val := l_sum / ((3.0 * a_x) * a_x)
							a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
							Result := 0
							js.return
						else
							from
							until
								js.loop_left
							loop
								js.reset
								a_result.item.val := 0.0
								a_result.item.err := 2.2250738585072014e-308
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("underflow"), ce_string ("legendre_Qn.c"), 274, 15)
									Result := 15
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_legendre_Ql_e (a_l: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_Q0: PD_GSL_SF_RESULT_STRUCT
			l_Q1___0: PD_GSL_SF_RESULT_STRUCT
			l_stat_Q0: INTEGER_32
			l_stat_Q1: INTEGER_32
			l_Qellm1: REAL_64
			l_Qell: REAL_64
			l_Qellp1: REAL_64
			l_ell: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_rat: REAL_64
			l_stat_CF1: INTEGER_32
			l_stat_Q: INTEGER_32
			l_Qellp1___0: REAL_64
			l_Qell___0: REAL_64
			l_Qellm1___0: REAL_64
			l_ell___0: INTEGER_32
			l_Q0___0: PD_GSL_SF_RESULT_STRUCT
			l_Q1___1: PD_GSL_SF_RESULT_STRUCT
			l_tmp___12: REAL_64
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_Q0.make
			create l_Q1___0.make
			create l_Q0___0.make
			create l_Q1___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_x <= -1.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if a_x /= 1.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not (a_l < 0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("legendre_Qn.c"), 285, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						if a_l = 0 then
							Result := (gsl_sf_legendre_Q0_e (a_x, a_result))
							js.return
						elseif a_l = 1 then
							Result := (gsl_sf_legendre_Q1_e (a_x, a_result))
							js.return
						elseif a_l > 100000 then
							Result := (legendre_Ql_asymp_unif (a_l.to_double, a_x, a_result))
							js.return
						elseif a_x < 1.0 then
							l_stat_Q0 := (gsl_sf_legendre_Q0_e (a_x, l_Q0.address))
							l_stat_Q1 := (gsl_sf_legendre_Q1_e (a_x, l_Q1___0.address))
							l_Qellm1 := l_Q0.val
							l_Qell := l_Q1___0.val
							l_ell := 1
							from
							until
								not (l_ell < a_l)
							loop
								l_Qellp1 := ((a_x * (2.0 * l_ell.to_double + 1.0)) * l_Qell - l_ell.to_double * l_Qellm1) / (l_ell.to_double + 1.0)
								l_Qellm1 := l_Qell
								l_Qell := l_Qellp1
								l_ell := l_ell + 1
							end
							a_result.item.val := l_Qell
							a_result.item.err := (2.2204460492503131e-16 * a_l.to_double) * (fabs (a_result.item.val))
							if l_stat_Q0 /= 0 then
								l_tmp___8 := l_stat_Q0
							else
								if l_stat_Q1 /= 0 then
									l_tmp___7 := l_stat_Q1
								else
									l_tmp___7 := 0
								end
								l_tmp___8 := l_tmp___7
							end
							Result := l_tmp___8
							js.return
						else
							l_stat_CF1 := (legendreQ_CF1_xgt1 (a_l, 0.0, 0.0, a_x, create {CE_POINTER [REAL_64]}.make_shared ($l_rat)))
							l_Qellp1___0 := l_rat * 1.4916681462400413e-154
							l_Qell___0 := 1.4916681462400413e-154
							l_ell___0 := a_l
							from
							until
								not (l_ell___0 > 0)
							loop
								l_Qellm1___0 := ((a_x * (2.0 * l_ell___0.to_double + 1.0)) * l_Qell___0 - (l_ell___0.to_double + 1.0) * l_Qellp1___0) / l_ell___0.to_double
								l_Qellp1___0 := l_Qell___0
								l_Qell___0 := l_Qellm1___0
								l_ell___0 := l_ell___0 - 1
							end
							l_tmp___12 := fabs (l_Qell___0)
							if l_tmp___12 > (fabs (l_Qellp1___0)) then
								l_stat_Q := gsl_sf_legendre_Q0_e (a_x, l_Q0___0.address)
								a_result.item.val := (1.4916681462400413e-154 * l_Q0___0.val) / l_Qell___0
								a_result.item.err := (a_l.to_double * 2.2204460492503131e-16) * (fabs (a_result.item.val))
							else
								l_stat_Q := gsl_sf_legendre_Q1_e (a_x, l_Q1___1.address)
								a_result.item.val := (1.4916681462400413e-154 * l_Q1___1.val) / l_Qellp1___0
								a_result.item.err := (a_l.to_double * 2.2204460492503131e-16) * (fabs (a_result.item.val))
							end
							if l_stat_Q /= 0 then
								l_tmp___15 := l_stat_Q
							else
								if l_stat_CF1 /= 0 then
									l_tmp___14 := l_stat_CF1
								else
									l_tmp___14 := 0
								end
								l_tmp___15 := l_tmp___14
							end
							Result := l_tmp___15
							js.return
						end
				when 10 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_legendre_Q0 (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_legendre_Q0_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_legendre_Q0_e(x, &result)"), ce_string ("legendre_Qn.c"), 355, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_legendre_Q1 (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_legendre_Q1_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_legendre_Q1_e(x, &result)"), ce_string ("legendre_Qn.c"), 360, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_legendre_Ql (a_l: INTEGER_32; a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_legendre_Ql_e (a_l, a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_legendre_Ql_e(l, x, &result)"), ce_string ("legendre_Qn.c"), 365, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
