class
	P_LINEAR_WRAPPER

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	moveto (a_alpha: REAL_64; a_w: CE_POINTER [PD_WRAPPER_T])
		local
			js: JUMP_STATE
		do
			if a_alpha = a_w.item.x_cache_key then
				js.return
			end
			if not js.return_called then
				copy_source_inst.gsl_vector_memcpy (a_w.item.x_alpha, a_w.item.x).do_nothing
				blas_inst.gsl_blas_daxpy (a_alpha, a_w.item.p, a_w.item.x_alpha).do_nothing
				a_w.item.x_cache_key := a_alpha
			end
		end

	slope (a_w: CE_POINTER [PD_WRAPPER_T]): REAL_64
		local
			l_df: REAL_64
		do
			blas_inst.gsl_blas_ddot (a_w.item.g_alpha, a_w.item.p, create {CE_POINTER [REAL_64]}.make_shared ($l_df)).do_nothing
			Result := l_df
		end

	wrap_f (a_alpha: REAL_64; a_params: CE_POINTER [ANY]): REAL_64
		local
			l_w: CE_POINTER [PD_WRAPPER_T]
			js: JUMP_STATE
		do
			create l_w.make

			l_w.ce_gets (create {CE_POINTER [PD_WRAPPER_T]}.make_cast (a_params))
			if a_alpha = l_w.item.f_cache_key then
				Result := (l_w.item.f_alpha)
				js.return
			end
			if not js.return_called then
				moveto (a_alpha, l_w)
				l_w.item.f_alpha := ((l_w.item.fdf).item.f).real_64_item ([l_w.item.x_alpha, (l_w.item.fdf).item.params])
				l_w.item.f_cache_key := a_alpha
				Result := (l_w.item.f_alpha)
			end
		end

	wrap_f_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent wrap_f)
		end

	wrap_df (a_alpha: REAL_64; a_params: CE_POINTER [ANY]): REAL_64
		local
			l_w: CE_POINTER [PD_WRAPPER_T]
			js: JUMP_STATE
		do
			create l_w.make

			l_w.ce_gets (create {CE_POINTER [PD_WRAPPER_T]}.make_cast (a_params))
			if a_alpha = l_w.item.df_cache_key then
				Result := (l_w.item.df_alpha)
				js.return
			end
			if not js.return_called then
				moveto (a_alpha, l_w)
				if a_alpha /= l_w.item.g_cache_key then
					((l_w.item.fdf).item.df).call ([l_w.item.x_alpha, (l_w.item.fdf).item.params, l_w.item.g_alpha])
					l_w.item.g_cache_key := a_alpha
				end
				l_w.item.df_alpha := slope (l_w)
				l_w.item.df_cache_key := a_alpha
				Result := (l_w.item.df_alpha)
			end
		end

	wrap_df_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent wrap_df)
		end

	wrap_fdf (a_alpha: REAL_64; a_params: CE_POINTER [ANY]; a_f: CE_POINTER [REAL_64]; a_df: CE_POINTER [REAL_64])
		local
			l_w: CE_POINTER [PD_WRAPPER_T]
			js: JUMP_STATE
		do
			create l_w.make

			l_w.ce_gets (create {CE_POINTER [PD_WRAPPER_T]}.make_cast (a_params))
			if a_alpha = l_w.item.f_cache_key then
				if a_alpha = l_w.item.df_cache_key then
					a_f.item := l_w.item.f_alpha
					a_df.item := l_w.item.df_alpha
					js.return
				end
			end
			if not js.return_called then
				if a_alpha = l_w.item.f_cache_key then
					a_f.item := wrap_f (a_alpha, a_params)
					a_df.item := wrap_df (a_alpha, a_params)
					js.return
				elseif a_alpha = l_w.item.df_cache_key then
					a_f.item := wrap_f (a_alpha, a_params)
					a_df.item := wrap_df (a_alpha, a_params)
					js.return
				end
			end
			if not js.return_called then
				moveto (a_alpha, l_w);
				((l_w.item.fdf).item.fdf).call ([l_w.item.x_alpha, (l_w.item.fdf).item.params, create {CE_POINTER [REAL_64]}.make_shared (l_w.c_pointer + {PD_WRAPPER_T}.f_alpha_offset), l_w.item.g_alpha])
				l_w.item.f_cache_key := a_alpha
				l_w.item.g_cache_key := a_alpha
				l_w.item.df_alpha := slope (l_w)
				l_w.item.df_cache_key := a_alpha
				a_f.item := l_w.item.f_alpha
				a_df.item := l_w.item.df_alpha
			end
		end

	wrap_fdf_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent wrap_fdf)
		end

	prepare_wrapper (a_w: CE_POINTER [PD_WRAPPER_T]; a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: REAL_64; a_g: CE_POINTER [PD_GSL_VECTOR]; a_p: CE_POINTER [PD_GSL_VECTOR]; a_x_alpha: CE_POINTER [PD_GSL_VECTOR]; a_g_alpha: CE_POINTER [PD_GSL_VECTOR])
		do
			a_w.item.fdf_linear.f := wrap_f_address
			a_w.item.fdf_linear.df := wrap_df_address
			a_w.item.fdf_linear.fdf := wrap_fdf_address
			a_w.item.fdf_linear.params := create {CE_POINTER [ANY]}.make_cast (a_w)
			a_w.item.fdf := a_fdf
			a_w.item.x := a_x
			a_w.item.g := a_g
			a_w.item.p := a_p
			a_w.item.x_alpha := a_x_alpha
			a_w.item.g_alpha := a_g_alpha
			copy_source_inst.gsl_vector_memcpy (a_w.item.x_alpha, a_w.item.x).do_nothing
			a_w.item.x_cache_key := 0.0
			a_w.item.f_alpha := a_f
			a_w.item.f_cache_key := 0.0
			copy_source_inst.gsl_vector_memcpy (a_w.item.g_alpha, a_w.item.g).do_nothing
			a_w.item.g_cache_key := 0.0
			a_w.item.df_alpha := slope (a_w)
			a_w.item.df_cache_key := 0.0
		end

	update_position (a_w: CE_POINTER [PD_WRAPPER_T]; a_alpha: REAL_64; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [REAL_64]; a_g: CE_POINTER [PD_GSL_VECTOR])
		local
			l_f_alpha: REAL_64
			l_df_alpha: REAL_64
		do
			wrap_fdf (a_alpha, create {CE_POINTER [ANY]}.make_cast (a_w), create {CE_POINTER [REAL_64]}.make_shared ($l_f_alpha), create {CE_POINTER [REAL_64]}.make_shared ($l_df_alpha))
			a_f.item := a_w.item.f_alpha
			copy_source_inst.gsl_vector_memcpy (a_x, a_w.item.x_alpha).do_nothing
			copy_source_inst.gsl_vector_memcpy (a_g, a_w.item.g_alpha).do_nothing
		end

	change_direction (a_w: CE_POINTER [PD_WRAPPER_T])
		do
			copy_source_inst.gsl_vector_memcpy (a_w.item.x_alpha, a_w.item.x).do_nothing
			a_w.item.x_cache_key := 0.0
			a_w.item.f_cache_key := 0.0
			copy_source_inst.gsl_vector_memcpy (a_w.item.g_alpha, a_w.item.g).do_nothing
			a_w.item.g_cache_key := 0.0
			a_w.item.df_alpha := slope (a_w)
			a_w.item.df_cache_key := 0.0
		end

end
