class
	P_LOGARITHMIC

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_ran_logarithmic (a_r___3: CE_POINTER [PD_GSL_RNG]; a_p: REAL_64): NATURAL_32
		local
			l_c___1: REAL_64
			l_v: REAL_64
			l_u: REAL_64
			l_q___3: REAL_64
			l_x: REAL_64
			l_tmp___3: REAL_64
		do
			l_c___1 := (log ((1).to_double - a_p))
			l_v := (gsl_gsl_rng_inst.gsl_rng_uniform_pos (a_r___3))
			if l_v >= a_p then
				Result := {NATURAL_32} 1
			else
				l_u := (gsl_gsl_rng_inst.gsl_rng_uniform_pos (a_r___3))
				l_q___3 := (1).to_double - (exp (l_c___1 * l_u))
				if l_v <= l_q___3 * l_q___3 then
					l_tmp___3 := log (l_v)
					l_x := (1).to_double + l_tmp___3 / (log (l_q___3))
					Result := l_x.truncated_to_integer_64.to_natural_32
				elseif l_v <= l_q___3 then
					Result := {NATURAL_32} 2
				else
					Result := {NATURAL_32} 1
				end
			end
		end

	gsl_ran_logarithmic_pdf (a_k: NATURAL_32; a_p: REAL_64): REAL_64
		local
			l_P___2: REAL_64
			l_tmp: REAL_64
		do
			if a_k = {NATURAL_32} 0 then
				Result := (0).to_double
			else
				l_tmp := pow (a_p, a_k.to_real_64)
				l_P___2 := (l_tmp / a_k.to_real_64) / (log ((1).to_double / ((1).to_double - a_p)))
				Result := l_P___2
			end
		end

end
