class
	P_LOGISTIC

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_ran_logistic (a_r___3: CE_POINTER [PD_GSL_RNG]; a_a___5: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_z: REAL_64
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				l_x := gsl_gsl_rng_inst.gsl_rng_uniform_pos (a_r___3)
				if l_x /= (1).to_double then
					js.break
				end
			end
			js.reset
			l_z := log (l_x / ((1).to_double - l_x))
			Result := (a_a___5 * l_z)
		end

	gsl_ran_logistic_pdf (a_x: REAL_64; a_a___5: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_p: REAL_64
		do
			l_u := (exp (-(fabs (a_x)) / a_a___5))
			l_p := l_u / (((fabs (a_a___5)) * ((1).to_double + l_u)) * ((1).to_double + l_u))
			Result := l_p
		end

	gsl_cdf_logistic_P (a_x: REAL_64; a_a___5: REAL_64): REAL_64
		local
			l_P___2: REAL_64
			l_u: REAL_64
			l_tmp___0: REAL_64
		do
			l_u := a_x / a_a___5
			if l_u >= (0).to_double then
				l_P___2 := (1).to_double / ((1).to_double + (exp (-l_u)))
			else
				l_tmp___0 := exp (l_u)
				l_P___2 := l_tmp___0 / ((1).to_double + (exp (l_u)))
			end
			Result := l_P___2
		end

	gsl_cdf_logistic_Q (a_x: REAL_64; a_a___5: REAL_64): REAL_64
		local
			l_Q___1: REAL_64
			l_u: REAL_64
			l_tmp: REAL_64
		do
			l_u := a_x / a_a___5
			if l_u >= (0).to_double then
				l_tmp := exp (-l_u)
				l_Q___1 := l_tmp / ((1).to_double + (exp (-l_u)))
			else
				l_Q___1 := (1).to_double / ((1).to_double + (exp (l_u)))
			end
			Result := l_Q___1
		end

end
