class
	P_LQ

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_linalg_LQ_decomp (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_tau: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_N: NATURAL_32
			l_M: NATURAL_32
			l_i: NATURAL_32
			l_c_full: PD_GSL_VECTOR_VIEW
			l_c___1: PD_GSL_VECTOR_VIEW
			l_tau_i: REAL_64
			l_m___4: PD_GSL_MATRIX_VIEW
			l_tmp___3: NATURAL_32
			l_tmp___4: NATURAL_32
			js: JUMP_STATE
		do
			create l_c_full.make
			create l_c___1.make
			create l_m___4.make

			l_N := a_A___0.item.size1
			l_M := a_A___0.item.size2
			if l_M < l_N then
				l_tmp___4 := l_M
			else
				l_tmp___4 := l_N
			end
			if a_tau.item.size /= l_tmp___4 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("size of tau must be MIN(M,N)"), ce_string ("lq.c"), 90, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_i := (0).to_natural_32
				from
				until
					js.loop_left
				loop
					js.reset
					if l_M < l_N then
						l_tmp___3 := l_M
					else
						l_tmp___3 := l_N
					end
					if not (l_i < l_tmp___3) then
						js.break
					end
					if not js.loop_jumped then
						l_c_full.ce_gets ((rowcol_source_inst.gsl_matrix_row (a_A___0, l_i)))
						l_c___1.ce_gets ((subvector_source_inst.gsl_vector_subvector (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c_full.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_i, l_M - l_i)))
						l_tau_i := (householder_inst.gsl_linalg_householder_transform (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___1.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)))
						gsl_gsl_vector_double_inst.gsl_vector_set (a_tau, l_i, l_tau_i)
						if l_i + {NATURAL_32} 1 < l_N then
							l_m___4.ce_gets ((submatrix_source_inst.gsl_matrix_submatrix (a_A___0, l_i + {NATURAL_32} 1, l_i, l_N - (l_i + {NATURAL_32} 1), l_M - l_i)))
							householder_inst.gsl_linalg_householder_mh (l_tau_i, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___1.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
						end
						l_i := l_i + 1
					end
				end
				js.reset
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_LQ_solve_T (a_LQ: CE_POINTER [PD_GSL_MATRIX]; a_tau: CE_POINTER [PD_GSL_VECTOR]; a_b___0: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_LQ.item.size1 /= a_LQ.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("LQ matrix must be square"), ce_string ("lq.c"), 135, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LQ.item.size2 /= a_b___0.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match b size"), ce_string ("lq.c"), 139, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LQ.item.size1 /= a_x.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match solution size"), ce_string ("lq.c"), 143, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				copy_source_inst.gsl_vector_memcpy (a_x, a_b___0).do_nothing
				gsl_linalg_LQ_svx_T (a_LQ, a_tau, a_x).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_LQ_svx_T (a_LQ: CE_POINTER [PD_GSL_MATRIX]; a_tau: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_LQ.item.size1 /= a_LQ.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("LQ matrix must be square"), ce_string ("lq.c"), 172, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LQ.item.size1 /= a_x.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match x/rhs size"), ce_string ("lq.c"), 176, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				gsl_linalg_LQ_vecQT (a_LQ, a_tau, a_x).do_nothing
				blas_inst.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasLower, {PC_CBLAS_TRANSPOSE}.CblasTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_LQ, a_x).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_LQ_lssolve_T (a_LQ: CE_POINTER [PD_GSL_MATRIX]; a_tau: CE_POINTER [PD_GSL_VECTOR]; a_b___0: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_residual: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_N: NATURAL_32
			l_M: NATURAL_32
			l_L: PD_GSL_MATRIX_CONST_VIEW
			l_c___1: PD_GSL_VECTOR_VIEW
			js: JUMP_STATE
		do
			create l_L.make
			create l_c___1.make

			l_N := a_LQ.item.size1
			l_M := a_LQ.item.size2
			if l_M < l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("LQ matrix must have M>=N"), ce_string ("lq.c"), 208, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif l_M /= a_b___0.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match b size"), ce_string ("lq.c"), 212, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif l_N /= a_x.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match solution size"), ce_string ("lq.c"), 216, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif l_M /= a_residual.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match residual size"), ce_string ("lq.c"), 220, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_L.ce_gets ((submatrix_source_inst.gsl_matrix_const_submatrix (a_LQ, (0).to_natural_32, (0).to_natural_32, l_N, l_N)))
				l_c___1.ce_gets ((subvector_source_inst.gsl_vector_subvector (a_residual, (0).to_natural_32, l_N)))
				copy_source_inst.gsl_vector_memcpy (a_residual, a_b___0).do_nothing
				gsl_linalg_LQ_vecQT (a_LQ, a_tau, a_residual).do_nothing
				copy_source_inst.gsl_vector_memcpy (a_x, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___1.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))).do_nothing
				blas_inst.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasLower, {PC_CBLAS_TRANSPOSE}.CblasTrans, {PC_CBLAS_DIAG}.CblasNonUnit, (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_L.c_pointer + {PD_GSL_MATRIX_CONST_VIEW}.matrix_offset)), a_x).do_nothing
				init_source_inst.gsl_vector_set_zero (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___1.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))
				gsl_linalg_LQ_vecQ (a_LQ, a_tau, a_residual).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_LQ_Lsolve_T (a_LQ: CE_POINTER [PD_GSL_MATRIX]; a_b___0: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_LQ.item.size1 /= a_LQ.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("LQ matrix must be square"), ce_string ("lq.c"), 255, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LQ.item.size1 /= a_b___0.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match b size"), ce_string ("lq.c"), 259, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LQ.item.size1 /= a_x.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match x size"), ce_string ("lq.c"), 263, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				copy_source_inst.gsl_vector_memcpy (a_x, a_b___0).do_nothing
				blas_inst.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasLower, {PC_CBLAS_TRANSPOSE}.CblasTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_LQ, a_x).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_LQ_Lsvx_T (a_LQ: CE_POINTER [PD_GSL_MATRIX]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_LQ.item.size1 /= a_LQ.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("LQ matrix must be square"), ce_string ("lq.c"), 285, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LQ.item.size2 /= a_x.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match rhs size"), ce_string ("lq.c"), 289, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				blas_inst.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasLower, {PC_CBLAS_TRANSPOSE}.CblasTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_LQ, a_x).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_L_solve_T (a_L: CE_POINTER [PD_GSL_MATRIX]; a_b___0: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_L.item.size1 /= a_L.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("R matrix must be square"), ce_string ("lq.c"), 306, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_L.item.size2 /= a_b___0.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match b size"), ce_string ("lq.c"), 310, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_L.item.size1 /= a_x.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match solution size"), ce_string ("lq.c"), 314, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				copy_source_inst.gsl_vector_memcpy (a_x, a_b___0).do_nothing
				blas_inst.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasLower, {PC_CBLAS_TRANSPOSE}.CblasTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_L, a_x).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_LQ_vecQT (a_LQ: CE_POINTER [PD_GSL_MATRIX]; a_tau: CE_POINTER [PD_GSL_VECTOR]; a_v: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_N: NATURAL_32
			l_M: NATURAL_32
			l_i: NATURAL_32
			l_c___1: PD_GSL_VECTOR_CONST_VIEW
			l_h: PD_GSL_VECTOR_CONST_VIEW
			l_w: PD_GSL_VECTOR_VIEW
			l_ti: REAL_64
			l_tmp___3: NATURAL_32
			l_tmp___4: NATURAL_32
			js: JUMP_STATE
		do
			create l_c___1.make
			create l_h.make
			create l_w.make

			l_N := a_LQ.item.size1
			l_M := a_LQ.item.size2
			if l_M < l_N then
				l_tmp___4 := l_M
			else
				l_tmp___4 := l_N
			end
			if a_tau.item.size /= l_tmp___4 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("size of tau must be MIN(M,N)"), ce_string ("lq.c"), 341, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.size /= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector size must be M"), ce_string ("lq.c"), 345, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_i := (0).to_natural_32
				from
				until
					js.loop_left
				loop
					js.reset
					if l_M < l_N then
						l_tmp___3 := l_M
					else
						l_tmp___3 := l_N
					end
					if not (l_i < l_tmp___3) then
						js.break
					end
					if not js.loop_jumped then
						l_c___1.ce_gets ((rowcol_source_inst.gsl_matrix_const_row (a_LQ, l_i)))
						l_h.ce_gets ((subvector_source_inst.gsl_vector_const_subvector ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___1.c_pointer + {PD_GSL_VECTOR_CONST_VIEW}.vector_offset)), l_i, l_M - l_i)))
						l_w.ce_gets ((subvector_source_inst.gsl_vector_subvector (a_v, l_i, l_M - l_i)))
						l_ti := (gsl_gsl_vector_double_inst.gsl_vector_get (a_tau, l_i))
						householder_inst.gsl_linalg_householder_hv (l_ti, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_h.c_pointer + {PD_GSL_VECTOR_CONST_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_w.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)).do_nothing
						l_i := l_i + 1
					end
				end
				js.reset
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_LQ_vecQ (a_LQ: CE_POINTER [PD_GSL_MATRIX]; a_tau: CE_POINTER [PD_GSL_VECTOR]; a_v: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_N: NATURAL_32
			l_M: NATURAL_32
			l_i: NATURAL_32
			l_c___1: PD_GSL_VECTOR_CONST_VIEW
			l_h: PD_GSL_VECTOR_CONST_VIEW
			l_w: PD_GSL_VECTOR_VIEW
			l_ti: REAL_64
			l_tmp___3: NATURAL_32
			l_tmp___4: NATURAL_32
			js: JUMP_STATE
		do
			create l_c___1.make
			create l_h.make
			create l_w.make

			l_N := a_LQ.item.size1
			l_M := a_LQ.item.size2
			if l_M < l_N then
				l_tmp___4 := l_M
			else
				l_tmp___4 := l_N
			end
			if a_tau.item.size /= l_tmp___4 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("size of tau must be MIN(M,N)"), ce_string ("lq.c"), 374, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_v.item.size /= l_M then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector size must be M"), ce_string ("lq.c"), 378, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				if l_M < l_N then
					l_i := l_M
				else
					l_i := l_N
				end
				from
				until
					js.loop_left
				loop
					js.reset
					l_tmp___3 := l_i
					l_i := l_i - 1
					if not (l_tmp___3 > {NATURAL_32} 0) then
						js.break
					end
					if not js.loop_jumped then
						l_c___1.ce_gets ((rowcol_source_inst.gsl_matrix_const_row (a_LQ, l_i)))
						l_h.ce_gets ((subvector_source_inst.gsl_vector_const_subvector ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___1.c_pointer + {PD_GSL_VECTOR_CONST_VIEW}.vector_offset)), l_i, l_M - l_i)))
						l_w.ce_gets ((subvector_source_inst.gsl_vector_subvector (a_v, l_i, l_M - l_i)))
						l_ti := (gsl_gsl_vector_double_inst.gsl_vector_get (a_tau, l_i))
						householder_inst.gsl_linalg_householder_hv (l_ti, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_h.c_pointer + {PD_GSL_VECTOR_CONST_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_w.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)).do_nothing
					end
				end
				js.reset
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_LQ_unpack (a_LQ: CE_POINTER [PD_GSL_MATRIX]; a_tau: CE_POINTER [PD_GSL_VECTOR]; a_Q___1: CE_POINTER [PD_GSL_MATRIX]; a_L: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_N: NATURAL_32
			l_M: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_l_border: NATURAL_32
			l_c___1: PD_GSL_VECTOR_CONST_VIEW
			l_h: PD_GSL_VECTOR_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_VIEW
			l_ti: REAL_64
			l_tmp___3: NATURAL_32
			l_tmp___5: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_c___1.make
			create l_h.make
			create l_m___4.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_N := a_LQ.item.size1
					l_M := a_LQ.item.size2
					if a_Q___1.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if a_Q___1.item.size2 = l_M then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("Q matrix must be M x M"), ce_string ("lq.c"), 410, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if a_L.item.size1 = l_N then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if a_L.item.size2 = l_M then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("R matrix must be N x M"), ce_string ("lq.c"), 414, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						if l_M < l_N then
							l_tmp___5 := l_M
						else
							l_tmp___5 := l_N
						end
						if a_tau.item.size /= l_tmp___5 then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("size of tau must be MIN(M,N)"), ce_string ("lq.c"), 418, 19)
								Result := 19
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						else
							init_source_inst.gsl_matrix_set_identity (a_Q___1)
							if l_M < l_N then
								l_i := l_M
							else
								l_i := l_N
							end
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___3 := l_i
								l_i := l_i - 1
								if not (l_tmp___3 > {NATURAL_32} 0) then
									js.break
								end
								if not js.loop_jumped then
									l_c___1.ce_gets ((rowcol_source_inst.gsl_matrix_const_row (a_LQ, l_i)))
									l_h.ce_gets ((subvector_source_inst.gsl_vector_const_subvector ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___1.c_pointer + {PD_GSL_VECTOR_CONST_VIEW}.vector_offset)), l_i, l_M - l_i)))
									l_m___4.ce_gets ((submatrix_source_inst.gsl_matrix_submatrix (a_Q___1, l_i, l_i, l_M - l_i, l_M - l_i)))
									l_ti := (gsl_gsl_vector_double_inst.gsl_vector_get (a_tau, l_i))
									householder_inst.gsl_linalg_householder_mh (l_ti, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_h.c_pointer + {PD_GSL_VECTOR_CONST_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
								end
							end
							js.reset
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_N))
							loop
								if l_i < l_M - {NATURAL_32} 1 then
									l_l_border := l_i
								else
									l_l_border := l_M - {NATURAL_32} 1
								end
								l_j := (0).to_natural_32
								from
								until
									not (l_j <= l_l_border)
								loop
									gsl_gsl_matrix_double_inst.gsl_matrix_set (a_L, l_i, l_j, (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_LQ, l_i, l_j)))
									l_j := l_j + 1
								end
								l_j := l_l_border + {NATURAL_32} 1
								from
								until
									not (l_j < l_M)
								loop
									gsl_gsl_matrix_double_inst.gsl_matrix_set (a_L, l_i, l_j, 0.0)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
							js.return
						end
				when 13 then -- if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_linalg_LQ_update (a_Q___1: CE_POINTER [PD_GSL_MATRIX]; a_L: CE_POINTER [PD_GSL_MATRIX]; a_v: CE_POINTER [PD_GSL_VECTOR]; a_w: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_N: NATURAL_32
			l_M: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_w0: REAL_64
			l_c___1: REAL_64
			l_s: REAL_64
			l_wk: REAL_64
			l_wkm1: REAL_64
			l_lj0: REAL_64
			l_vj: REAL_64
			l_c___2: REAL_64
			l_s___0: REAL_64
			l_diag: REAL_64
			l_offdiag: REAL_64
			l_tmp___5: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_N := a_L.item.size1
					l_M := a_L.item.size2
					if a_Q___1.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_Q___1.item.size2 = l_M then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("Q matrix must be N x N if L is M x N"), ce_string ("lq.c"), 476, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if a_w.item.size /= l_M then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("w must be length N if L is M x N"), ce_string ("lq.c"), 480, 19)
								Result := 19
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						elseif a_v.item.size /= l_N then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("v must be length M if L is M x N"), ce_string ("lq.c"), 484, 19)
								Result := 19
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						else
							l_k := l_M - {NATURAL_32} 1
							from
							until
								not (l_k > {NATURAL_32} 0)
							loop
								l_wk := (gsl_gsl_vector_double_inst.gsl_vector_get (a_w, l_k))
								l_wkm1 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_w, l_k - {NATURAL_32} 1))
								qrstep_inst.create_givens (l_wkm1, l_wk, create {CE_POINTER [REAL_64]}.make_shared ($l_c___1), create {CE_POINTER [REAL_64]}.make_shared ($l_s))
								apply_givens_inst.apply_givens_vec (a_w, l_k - {NATURAL_32} 1, l_k, l_c___1, l_s)
								apply_givens_inst.apply_givens_lq (l_M, l_N, a_Q___1, a_L, l_k - {NATURAL_32} 1, l_k, l_c___1, l_s)
								l_k := l_k - 1
							end
							l_w0 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w, (0).to_natural_32)
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_N)
							loop
								l_lj0 := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_L, l_j, (0).to_natural_32))
								l_vj := (gsl_gsl_vector_double_inst.gsl_vector_get (a_v, l_j))
								gsl_gsl_matrix_double_inst.gsl_matrix_set (a_L, l_j, (0).to_natural_32, l_lj0 + l_w0 * l_vj)
								l_j := l_j + 1
							end
							l_k := (1).to_natural_32
							from
							until
								js.loop_left
							loop
								js.reset
								if l_M < l_N + {NATURAL_32} 1 then
									l_tmp___5 := l_M
								else
									l_tmp___5 := l_N + {NATURAL_32} 1
								end
								if not (l_k < l_tmp___5) then
									js.break
								end
								if not js.loop_jumped then
									l_diag := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_L, l_k - {NATURAL_32} 1, l_k - {NATURAL_32} 1))
									l_offdiag := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_L, l_k - {NATURAL_32} 1, l_k))
									qrstep_inst.create_givens (l_diag, l_offdiag, create {CE_POINTER [REAL_64]}.make_shared ($l_c___2), create {CE_POINTER [REAL_64]}.make_shared ($l_s___0))
									apply_givens_inst.apply_givens_lq (l_M, l_N, a_Q___1, a_L, l_k - {NATURAL_32} 1, l_k, l_c___2, l_s___0)
									gsl_gsl_matrix_double_inst.gsl_matrix_set (a_L, l_k - {NATURAL_32} 1, l_k, 0.0)
									l_k := l_k + 1
								end
							end
							js.reset
							Result := 0
							js.return
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_linalg_LQ_LQsolve (a_Q___1: CE_POINTER [PD_GSL_MATRIX]; a_L: CE_POINTER [PD_GSL_MATRIX]; a_b___0: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_N: NATURAL_32
			l_M: NATURAL_32
		do
			l_N := a_L.item.size1
			l_M := a_L.item.size2
			if l_M /= l_N then
				Result := 20
			elseif a_Q___1.item.size1 /= l_M then
				Result := 19
			elseif a_b___0.item.size /= l_M then
				Result := 19
			elseif a_x.item.size /= l_M then
				Result := 19
			else
				blas_inst.gsl_blas_dgemv ({PC_CBLAS_TRANSPOSE}.CblasNoTrans, 1.0, a_Q___1, a_b___0, 0.0, a_x).do_nothing
				blas_inst.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasLower, {PC_CBLAS_TRANSPOSE}.CblasTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_L, a_x).do_nothing
				Result := 0
			end
		end

end
