class
	P_LU

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_linalg_LU_decomp (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_signum: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_ajj: REAL_64
			l_max: REAL_64
			l_i_pivot: NATURAL_32
			l_aij: REAL_64
			l_aij___0: REAL_64
			l_aik: REAL_64
			l_ajk: REAL_64
			js: JUMP_STATE
		do
			if a_A___0.item.size1 /= a_A___0.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("LU decomposition requires square matrix"), ce_string ("lu.c"), 64, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_p.item.size /= a_A___0.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("permutation length must match matrix size"), ce_string ("lu.c"), 68, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_N := a_A___0.item.size1
				a_signum.item := 1
				init_inst.gsl_permutation_init (a_p)
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_j < l_N - {NATURAL_32} 1))
				loop
					l_max := (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_j, l_j))))
					l_i_pivot := l_j
					l_i := l_j + {NATURAL_32} 1
					from
					until
						not (l_i < l_N)
					loop
						l_aij := (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_j))))
						if l_aij > l_max then
							l_max := l_aij
							l_i_pivot := l_i
						end
						l_i := l_i + 1
					end
					if l_i_pivot /= l_j then
						swap_source_inst.gsl_matrix_swap_rows (a_A___0, l_j, l_i_pivot).do_nothing
						permutation_inst.gsl_permutation_swap (a_p, l_j, l_i_pivot).do_nothing
						a_signum.item := -a_signum.item
					end
					l_ajj := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_j, l_j)
					if l_ajj /= 0.0 then
						l_i := l_j + {NATURAL_32} 1
						from
						until
							not (not js.loop_left and then (l_i < l_N))
						loop
							l_aij___0 := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_j)) / l_ajj
							gsl_gsl_matrix_double_inst.gsl_matrix_set (a_A___0, l_i, l_j, l_aij___0)
							l_k := l_j + {NATURAL_32} 1
							from
							until
								not (l_k < l_N)
							loop
								l_aik := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_i, l_k))
								l_ajk := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_j, l_k))
								gsl_gsl_matrix_double_inst.gsl_matrix_set (a_A___0, l_i, l_k, l_aik - l_aij___0 * l_ajk)
								l_k := l_k + 1
							end
							l_i := l_i + 1
						end
					end
					l_j := l_j + 1
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_LU_solve (a_LU: CE_POINTER [PD_GSL_MATRIX]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_b___0: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			if a_LU.item.size1 /= a_LU.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("LU matrix must be square"), ce_string ("lu.c"), 131, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LU.item.size1 /= a_p.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("permutation length must match matrix size"), ce_string ("lu.c"), 135, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LU.item.size1 /= a_b___0.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match b size"), ce_string ("lu.c"), 139, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LU.item.size2 /= a_x.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match solution size"), ce_string ("lu.c"), 143, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif (singular (a_LU)).to_boolean then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix is singular"), ce_string ("lu.c"), 147, 1)
					Result := 1
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				copy_source_inst.gsl_vector_memcpy (a_x, a_b___0).do_nothing
				l_status := gsl_linalg_LU_svx (a_LU, a_p, a_x)
				Result := l_status
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_LU_svx (a_LU: CE_POINTER [PD_GSL_MATRIX]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_LU.item.size1 /= a_LU.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("LU matrix must be square"), ce_string ("lu.c"), 171, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LU.item.size1 /= a_p.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("permutation length must match matrix size"), ce_string ("lu.c"), 175, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LU.item.size1 /= a_x.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match solution/rhs size"), ce_string ("lu.c"), 179, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif (singular (a_LU)).to_boolean then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix is singular"), ce_string ("lu.c"), 183, 1)
					Result := 1
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				permute_source_inst.gsl_permute_vector (a_p, a_x).do_nothing
				blas_inst.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasLower, {PC_CBLAS_TRANSPOSE}.CblasNoTrans, {PC_CBLAS_DIAG}.CblasUnit, a_LU, a_x).do_nothing
				blas_inst.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasUpper, {PC_CBLAS_TRANSPOSE}.CblasNoTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_LU, a_x).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_LU_refine (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_LU: CE_POINTER [PD_GSL_MATRIX]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_b___0: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_residual: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			if a_A___0.item.size1 /= a_A___0.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix a must be square"), ce_string ("lu.c"), 209, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				if a_LU.item.size1 /= a_LU.item.size2 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("LU matrix must be square"), ce_string ("lu.c"), 213, 20)
						Result := 20
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				elseif a_A___0.item.size1 /= a_LU.item.size2 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("LU matrix must be decomposition of a"), ce_string ("lu.c"), 217, 20)
						Result := 20
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				elseif a_LU.item.size1 /= a_p.item.size then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("permutation length must match matrix size"), ce_string ("lu.c"), 221, 19)
						Result := 19
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				elseif a_LU.item.size1 /= a_b___0.item.size then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("matrix size must match b size"), ce_string ("lu.c"), 225, 19)
						Result := 19
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				elseif a_LU.item.size1 /= a_x.item.size then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("matrix size must match solution size"), ce_string ("lu.c"), 229, 19)
						Result := 19
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				elseif (singular (a_LU)).to_boolean then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("matrix is singular"), ce_string ("lu.c"), 233, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				else
					copy_source_inst.gsl_vector_memcpy (a_residual, a_b___0).do_nothing
					blas_inst.gsl_blas_dgemv ({PC_CBLAS_TRANSPOSE}.CblasNoTrans, 1.0, a_A___0, a_x, -1.0, a_residual).do_nothing
					l_status := gsl_linalg_LU_svx (a_LU, a_p, a_residual)
					blas_inst.gsl_blas_daxpy (-1.0, a_residual, a_x).do_nothing
					Result := l_status
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_LU_invert (a_LU: CE_POINTER [PD_GSL_MATRIX]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_inverse: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_status: INTEGER_32
			l_c___1: PD_GSL_VECTOR_VIEW
			l_status_i: INTEGER_32
			js: JUMP_STATE
		do
			create l_c___1.make

			l_n := a_LU.item.size1
			l_status := 0
			if (singular (a_LU)).to_boolean then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix is singular"), ce_string ("lu.c"), 262, 1)
					Result := 1
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				init_source_inst.gsl_matrix_set_identity (a_inverse)
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_n)
				loop
					l_c___1.ce_gets ((rowcol_source_inst.gsl_matrix_column (a_inverse, l_i)))
					l_status_i := (gsl_linalg_LU_svx (a_LU, a_p, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___1.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)))
					if l_status_i.to_boolean then
						l_status := l_status_i
					end
					l_i := l_i + 1
				end
				Result := l_status
			end
		end

	gsl_linalg_LU_det (a_LU: CE_POINTER [PD_GSL_MATRIX]; a_signum: INTEGER_32): REAL_64
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_det: REAL_64
		do
			l_n := a_LU.item.size1
			l_det := a_signum.to_double
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_det := l_det * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_LU, l_i, l_i))
				l_i := l_i + 1
			end
			Result := l_det
		end

	gsl_linalg_LU_lndet (a_LU: CE_POINTER [PD_GSL_MATRIX]): REAL_64
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_lndet: REAL_64
		do
			l_n := a_LU.item.size1
			l_lndet := 0.0
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_lndet := l_lndet + (log ((fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_LU, l_i, l_i))))))
				l_i := l_i + 1
			end
			Result := l_lndet
		end

	gsl_linalg_LU_sgndet (a_LU: CE_POINTER [PD_GSL_MATRIX]; a_signum: INTEGER_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_s: INTEGER_32
			l_u: REAL_64
			js: JUMP_STATE
		do
			l_n := a_LU.item.size1
			l_s := a_signum
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_left and then (l_i < l_n))
			loop
				js.reset
				l_u := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_LU, l_i, l_i))
				if l_u < (0).to_double then
					l_s := l_s * (-1)
				elseif l_u = (0).to_double then
					l_s := 0
					js.break
				end
				if not js.loop_jumped then
					l_i := l_i + 1
				end
			end
			js.reset
			Result := l_s
		end

	singular (a_LU: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_u: REAL_64
			js: JUMP_STATE
		do
			l_n := a_LU.item.size1
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_left and then (l_i < l_n))
			loop
				l_u := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_LU, l_i, l_i))
				if l_u = (0).to_double then
					Result := 1
					js.return
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

end
