class
	P_LUC

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_linalg_complex_LU_decomp (a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_signum: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_ajj: PD_GSL_COMPLEX
			l_max: REAL_64
			l_i_pivot: NATURAL_32
			l_aij: PD_GSL_COMPLEX
			l_ai: REAL_64
			l_aij_orig: PD_GSL_COMPLEX
			l_aij___0: PD_GSL_COMPLEX
			l_aik: PD_GSL_COMPLEX
			l_ajk: PD_GSL_COMPLEX
			l_aijajk: PD_GSL_COMPLEX
			l_aik_new: PD_GSL_COMPLEX
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ajj.make
			create l_aij.make
			create l_aij_orig.make
			create l_aij___0.make
			create l_aik.make
			create l_ajk.make
			create l_aijajk.make
			create l_aik_new.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_A___0.item.size1 = a_A___0.item.size2 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("LU decomposition requires square matrix"), ce_string ("luc.c"), 64, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 3 then -- else:
						if a_p.item.size = a_A___0.item.size1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("permutation length must match matrix size"), ce_string ("luc.c"), 68, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 6 then -- else:
						l_N := a_A___0.item.size1
						a_signum.item := 1
						init_inst.gsl_permutation_init (a_p)
						l_j := (0).to_natural_32
				when 7 then -- loop condition:
						if not (not js.loop_left and then (l_j < l_N - {NATURAL_32} 1)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 8 then -- loop body:
						l_ajj.ce_gets ((gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, l_j, l_j)))
						l_max := (math_inst.gsl_complex_abs (l_ajj))
						l_i_pivot := l_j
						l_i := l_j + {NATURAL_32} 1
						from
						until
							not (l_i < l_N)
						loop
							l_aij.ce_gets ((gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, l_i, l_j)))
							l_ai := (math_inst.gsl_complex_abs (l_aij))
							if l_ai > l_max then
								l_max := l_ai
								l_i_pivot := l_i
							end
							l_i := l_i + 1
						end
						if l_i_pivot /= l_j then
							swap_source_inst.gsl_matrix_complex_swap_rows (a_A___0, l_j, l_i_pivot).do_nothing
							permutation_inst.gsl_permutation_swap (a_p, l_j, l_i_pivot).do_nothing
							a_signum.item := -a_signum.item
						end
						l_ajj.ce_gets (gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, l_j, l_j))
						if l_ajj.dat[0] /= 0.0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if l_ajj.dat[1] /= 0.0 then
							l_pos := -1 + 11 -- goto _L
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L:
						l_i := l_j + {NATURAL_32} 1
						from
						until
							not (not js.loop_left and then (l_i < l_N))
						loop
							l_aij_orig.ce_gets ((gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, l_i, l_j)))
							l_aij___0.ce_gets ((math_inst.gsl_complex_div (l_aij_orig, l_ajj)))
							gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_set (a_A___0, l_i, l_j, l_aij___0)
							l_k := l_j + {NATURAL_32} 1
							from
							until
								not (l_k < l_N)
							loop
								l_aik.ce_gets ((gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, l_i, l_k)))
								l_ajk.ce_gets ((gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_A___0, l_j, l_k)))
								l_aijajk.ce_gets ((math_inst.gsl_complex_mul (l_aij___0, l_ajk)))
								l_aik_new.ce_gets ((math_inst.gsl_complex_sub (l_aik, l_aijajk)))
								gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_set (a_A___0, l_i, l_k, l_aik_new)
								l_k := l_k + 1
							end
							l_i := l_i + 1
						end
				when 12 then
						l_j := l_j + 1
						l_pos := -1 + 7 -- back to loop condition
				when 13 then -- loop done
						Result := 0
						js.return
				when 14 then -- if done | if done
						if not js.return_called then
							Result := 0
						end
				when 15 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_linalg_complex_LU_solve (a_LU: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_b___0: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_x: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			if a_LU.item.size1 /= a_LU.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("LU matrix must be square"), ce_string ("luc.c"), 140, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LU.item.size1 /= a_p.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("permutation length must match matrix size"), ce_string ("luc.c"), 144, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LU.item.size1 /= a_b___0.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match b size"), ce_string ("luc.c"), 148, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LU.item.size2 /= a_x.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match solution size"), ce_string ("luc.c"), 152, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif (singular___0 (a_LU)).to_boolean then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix is singular"), ce_string ("luc.c"), 156, 1)
					Result := 1
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				copy_source_inst.gsl_vector_complex_memcpy (a_x, a_b___0).do_nothing
				l_status := gsl_linalg_complex_LU_svx (a_LU, a_p, a_x)
				Result := l_status
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_complex_LU_svx (a_LU: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_LU.item.size1 /= a_LU.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("LU matrix must be square"), ce_string ("luc.c"), 180, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LU.item.size1 /= a_p.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("permutation length must match matrix size"), ce_string ("luc.c"), 184, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LU.item.size1 /= a_x.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match solution/rhs size"), ce_string ("luc.c"), 188, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif (singular___0 (a_LU)).to_boolean then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix is singular"), ce_string ("luc.c"), 192, 1)
					Result := 1
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				permute_source_inst.gsl_permute_vector_complex (a_p, a_x).do_nothing
				blas_inst.gsl_blas_ztrsv ({PC_CBLAS_UPLO}.CblasLower, {PC_CBLAS_TRANSPOSE}.CblasNoTrans, {PC_CBLAS_DIAG}.CblasUnit, a_LU, a_x).do_nothing
				blas_inst.gsl_blas_ztrsv ({PC_CBLAS_UPLO}.CblasUpper, {PC_CBLAS_TRANSPOSE}.CblasNoTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_LU, a_x).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_complex_LU_refine (a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_LU: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_b___0: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_x: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_residual: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_status: INTEGER_32
			l_one: PD_GSL_COMPLEX
			l_negone: PD_GSL_COMPLEX
			l_negone___0: PD_GSL_COMPLEX
			js: JUMP_STATE
		do
			create l_one.make
			create l_negone.make
			create l_negone___0.make

			if a_A___0.item.size1 /= a_A___0.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix a must be square"), ce_string ("luc.c"), 218, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				if a_LU.item.size1 /= a_LU.item.size2 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("LU matrix must be square"), ce_string ("luc.c"), 222, 20)
						Result := 20
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				elseif a_A___0.item.size1 /= a_LU.item.size2 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("LU matrix must be decomposition of a"), ce_string ("luc.c"), 226, 20)
						Result := 20
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				elseif a_LU.item.size1 /= a_p.item.size then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("permutation length must match matrix size"), ce_string ("luc.c"), 230, 19)
						Result := 19
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				elseif a_LU.item.size1 /= a_b___0.item.size then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("matrix size must match b size"), ce_string ("luc.c"), 234, 19)
						Result := 19
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				elseif a_LU.item.size1 /= a_x.item.size then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("matrix size must match solution size"), ce_string ("luc.c"), 238, 19)
						Result := 19
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				elseif (singular___0 (a_LU)).to_boolean then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("matrix is singular"), ce_string ("luc.c"), 242, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				else
					copy_source_inst.gsl_vector_complex_memcpy (a_residual, a_b___0).do_nothing
					l_one.ce_gets ((gsl_gsl_complex_math_inst.gsl_complex_rect (1.0, 0.0)))
					l_negone.ce_gets ((gsl_gsl_complex_math_inst.gsl_complex_rect (-1.0, 0.0)))
					blas_inst.gsl_blas_zgemv ({PC_CBLAS_TRANSPOSE}.CblasNoTrans, l_one, a_A___0, a_x, l_negone, a_residual).do_nothing
					l_status := gsl_linalg_complex_LU_svx (a_LU, a_p, a_residual)
					l_negone___0.ce_gets ((gsl_gsl_complex_math_inst.gsl_complex_rect (-1.0, 0.0)))
					blas_inst.gsl_blas_zaxpy (l_negone___0, a_residual, a_x).do_nothing
					Result := l_status
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_complex_LU_invert (a_LU: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_inverse: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_status: INTEGER_32
			l_c___1: PD_GSL_VECTOR_COMPLEX_VIEW
			l_status_i: INTEGER_32
		do
			create l_c___1.make

			l_n := a_LU.item.size1
			l_status := 0
			init_source_inst.gsl_matrix_complex_set_identity (a_inverse)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_c___1.ce_gets ((rowcol_source_inst.gsl_matrix_complex_column (a_inverse, l_i)))
				l_status_i := (gsl_linalg_complex_LU_svx (a_LU, a_p, create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_c___1.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)))
				if l_status_i.to_boolean then
					l_status := l_status_i
				end
				l_i := l_i + 1
			end
			Result := l_status
		end

	gsl_linalg_complex_LU_det (a_LU: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_signum: INTEGER_32): PD_GSL_COMPLEX
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_det: PD_GSL_COMPLEX
			l_zi: PD_GSL_COMPLEX
		do
			create l_det.make
			create l_zi.make

			l_n := a_LU.item.size1
			l_det.ce_gets ((gsl_gsl_complex_math_inst.gsl_complex_rect (a_signum.to_double, 0.0)))
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_zi.ce_gets ((gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_LU, l_i, l_i)))
				l_det.ce_gets (math_inst.gsl_complex_mul (l_det, l_zi))
				l_i := l_i + 1
			end
			Result := l_det
		end

	gsl_linalg_complex_LU_lndet (a_LU: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): REAL_64
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_lndet: REAL_64
			l_z: PD_GSL_COMPLEX
		do
			create l_z.make

			l_n := a_LU.item.size1
			l_lndet := 0.0
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_z.ce_gets ((gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_LU, l_i, l_i)))
				l_lndet := l_lndet + (log ((math_inst.gsl_complex_abs (l_z))))
				l_i := l_i + 1
			end
			Result := l_lndet
		end

	gsl_linalg_complex_LU_sgndet (a_LU: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_signum: INTEGER_32): PD_GSL_COMPLEX
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_phase: PD_GSL_COMPLEX
			l_z: PD_GSL_COMPLEX
			l_r___3: REAL_64
			js: JUMP_STATE
		do
			create l_phase.make
			create l_z.make

			l_n := a_LU.item.size1
			l_phase.ce_gets ((gsl_gsl_complex_math_inst.gsl_complex_rect (a_signum.to_double, 0.0)))
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_left and then (l_i < l_n))
			loop
				js.reset
				l_z.ce_gets ((gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_LU, l_i, l_i)))
				l_r___3 := (math_inst.gsl_complex_abs (l_z))
				if l_r___3 = (0).to_double then
					l_phase.ce_gets (gsl_gsl_complex_math_inst.gsl_complex_rect (0.0, 0.0))
					js.break
				else
					l_z.ce_gets (math_inst.gsl_complex_div_real (l_z, l_r___3))
					l_phase.ce_gets (math_inst.gsl_complex_mul (l_phase, l_z))
				end
				if not js.loop_jumped then
					l_i := l_i + 1
				end
			end
			js.reset
			Result := l_phase
		end

	singular___0 (a_LU: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_u: PD_GSL_COMPLEX
			js: JUMP_STATE
		do
			create l_u.make

			l_n := a_LU.item.size1
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_left and then (l_i < l_n))
			loop
				l_u.ce_gets ((gsl_gsl_matrix_complex_double_inst.gsl_matrix_complex_get (a_LU, l_i, l_i)))
				if l_u.dat[0] = (0).to_double then
					if l_u.dat[1] = (0).to_double then
						Result := 1
						js.return
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

end
