class
	P_MATHIEU_ANGFUNC

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_sf_mathieu_ce (a_order: INTEGER_32; a_qq: REAL_64; a_zz: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_order: INTEGER_32
			l_even_odd: INTEGER_32
			l_ii: INTEGER_32
			l_status: INTEGER_32
			l_coeff: CE_ARRAY [REAL_64]
			l_norm___0: REAL_64
			l_fn: REAL_64
			l_factor: REAL_64
			l_aa: PD_GSL_SF_RESULT_STRUCT
			js: JUMP_STATE
		do
			create l_coeff.make (<<100>>)
			create l_aa.make

			l_order := a_order
			l_norm___0 := 0.0
			l_even_odd := 0
			if l_order \\ 2 /= 0 then
				l_even_odd := 1
			end
			if a_qq = 0.0 then
				l_norm___0 := 1.0
				if l_order = 0 then
					l_norm___0 := sqrt (2.0)
				end
				l_fn := (cos (l_order.to_double * a_zz)) / l_norm___0
				a_result.item.val := l_fn
				a_result.item.err := 2.0 * 2.2204460492503131e-16
				l_factor := fabs (l_fn)
				if l_factor > 1.0 then
					a_result.item.err := a_result.item.err * l_factor
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				if l_order < 0 then
					l_order := l_order * (-1)
				end
				l_status := mathieu_charv_inst.gsl_sf_mathieu_a (l_order, a_qq, l_aa.address)
				if l_status /= 0 then
					Result := l_status
					js.return
				end
			end
			if not js.return_called then
				l_status := mathieu_coeff_inst.gsl_sf_mathieu_a_coeff (l_order, a_qq, l_aa.val, l_coeff)
				if l_status /= 0 then
					Result := l_status
					js.return
				end
			end
			if not js.return_called then
				if l_even_odd = 0 then
					l_fn := 0.0
					l_norm___0 := l_coeff[0] * l_coeff[0]
					l_ii := 0
					from
					until
						not (l_ii < 100)
					loop
						l_fn := l_fn + (l_coeff[l_ii] * (cos ((2.0 * l_ii.to_double) * a_zz)))
						l_norm___0 := l_norm___0 + (l_coeff[l_ii] * l_coeff[l_ii])
						l_ii := l_ii + 1
					end
				else
					l_fn := 0.0
					l_ii := 0
					from
					until
						not (l_ii < 100)
					loop
						l_fn := l_fn + (l_coeff[l_ii] * (cos ((2.0 * l_ii.to_double + 1.0) * a_zz)))
						l_norm___0 := l_norm___0 + (l_coeff[l_ii] * l_coeff[l_ii])
						l_ii := l_ii + 1
					end
				end
				l_norm___0 := sqrt (l_norm___0)
				l_fn := l_fn / l_norm___0
				a_result.item.val := l_fn
				a_result.item.err := 2.0 * 2.2204460492503131e-16
				l_factor := fabs (l_fn)
				if l_factor > 1.0 then
					a_result.item.err := a_result.item.err * l_factor
				end
				Result := 0
			end
		end

	gsl_sf_mathieu_se (a_order: INTEGER_32; a_qq: REAL_64; a_zz: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_order: INTEGER_32
			l_even_odd: INTEGER_32
			l_ii: INTEGER_32
			l_status: INTEGER_32
			l_coeff: CE_ARRAY [REAL_64]
			l_norm___0: REAL_64
			l_fn: REAL_64
			l_factor: REAL_64
			l_aa: PD_GSL_SF_RESULT_STRUCT
			js: JUMP_STATE
		do
			create l_coeff.make (<<100>>)
			create l_aa.make

			l_order := a_order
			l_norm___0 := 0.0
			l_even_odd := 0
			if l_order \\ 2 /= 0 then
				l_even_odd := 1
			end
			if l_order = 0 then
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				Result := 0
				js.return
			end
			if not js.return_called and then (a_qq = 0.0) then
				l_norm___0 := 1.0
				l_fn := sin (l_order.to_double * a_zz)
				a_result.item.val := l_fn
				a_result.item.err := 2.0 * 2.2204460492503131e-16
				l_factor := fabs (l_fn)
				if l_factor > 1.0 then
					a_result.item.err := a_result.item.err * l_factor
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				if l_order < 0 then
					l_order := l_order * (-1)
				end
				l_status := mathieu_charv_inst.gsl_sf_mathieu_b (l_order, a_qq, l_aa.address)
				if l_status /= 0 then
					Result := l_status
					js.return
				end
			end
			if not js.return_called then
				l_status := mathieu_coeff_inst.gsl_sf_mathieu_b_coeff (l_order, a_qq, l_aa.val, l_coeff)
				if l_status /= 0 then
					Result := l_status
					js.return
				end
			end
			if not js.return_called then
				if l_even_odd = 0 then
					l_fn := 0.0
					l_ii := 0
					from
					until
						not (l_ii < 100)
					loop
						l_norm___0 := l_norm___0 + (l_coeff[l_ii] * l_coeff[l_ii])
						l_fn := l_fn + (l_coeff[l_ii] * (sin ((2.0 * (l_ii + 1).to_double) * a_zz)))
						l_ii := l_ii + 1
					end
				else
					l_fn := 0.0
					l_ii := 0
					from
					until
						not (l_ii < 100)
					loop
						l_norm___0 := l_norm___0 + (l_coeff[l_ii] * l_coeff[l_ii])
						l_fn := l_fn + (l_coeff[l_ii] * (sin ((2.0 * l_ii.to_double + (1).to_double) * a_zz)))
						l_ii := l_ii + 1
					end
				end
				l_norm___0 := sqrt (l_norm___0)
				l_fn := l_fn / l_norm___0
				a_result.item.val := l_fn
				a_result.item.err := 2.0 * 2.2204460492503131e-16
				l_factor := fabs (l_fn)
				if l_factor > 1.0 then
					a_result.item.err := a_result.item.err * l_factor
				end
				Result := 0
			end
		end

	gsl_sf_mathieu_ce_array (a_nmin: INTEGER_32; a_nmax: INTEGER_32; a_qq: REAL_64; a_zz: REAL_64; a_work: CE_POINTER [PD_GSL_SF_MATHIEU_WORKSPACE]; a_result_array: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_even_odd: INTEGER_32
			l_order: INTEGER_32
			l_ii: INTEGER_32
			l_jj: INTEGER_32
			l_status: INTEGER_32
			l_coeff: CE_ARRAY [REAL_64]
			l_aa: CE_POINTER [REAL_64]
			l_norm___0: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_coeff.make (<<100>>)
			create l_aa.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_aa.ce_gets (a_work.item.aa)
					l_ii := 0
					from
					until
						not (l_ii < (a_nmax - a_nmin) + 1)
					loop
						a_result_array[l_ii] := 0.0
						l_ii := l_ii + 1
					end
					if a_work.item.size < a_nmax.to_natural_32 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("Work space not large enough"), ce_string ("mathieu_angfunc.c"), 211, 4)
							Result := 4
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (a_nmin < 0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_nmax < a_nmin) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("domain error"), ce_string ("mathieu_angfunc.c"), 216, 1)
							Result := 1
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 6 then -- if done | if done
						if not js.return_called then
							mathieu_charv_inst.gsl_sf_mathieu_a_array (0, a_nmax, a_qq, a_work, l_aa).do_nothing
							l_ii := 0
							l_order := a_nmin
							from
							until
								not (not js.loop_left and then (l_order <= a_nmax))
							loop
								js.reset
								l_norm___0 := 0.0
								l_even_odd := 0
								if l_order \\ 2 /= 0 then
									l_even_odd := 1
								end
								if a_qq = 0.0 then
									l_norm___0 := 1.0
									if l_order = 0 then
										l_norm___0 := sqrt (2.0)
									end
									a_result_array[l_ii] := (cos (l_order.to_double * a_zz)) / l_norm___0
									js.continue
								end
								if not js.loop_jumped then
									l_status := mathieu_coeff_inst.gsl_sf_mathieu_a_coeff (l_order, a_qq, l_aa[l_order], l_coeff)
									if l_status /= 0 then
										Result := l_status
										js.return
									end
									if not js.return_called then
										if l_even_odd = 0 then
											l_norm___0 := l_coeff[0] * l_coeff[0]
											l_jj := 0
											from
											until
												not (l_jj < 100)
											loop
												a_result_array[l_ii] := a_result_array[l_ii] + (l_coeff[l_jj] * (cos ((2.0 * l_jj.to_double) * a_zz)))
												l_norm___0 := l_norm___0 + (l_coeff[l_jj] * l_coeff[l_jj])
												l_jj := l_jj + 1
											end
										else
											l_jj := 0
											from
											until
												not (l_jj < 100)
											loop
												a_result_array[l_ii] := a_result_array[l_ii] + (l_coeff[l_jj] * (cos ((2.0 * l_jj.to_double + 1.0) * a_zz)))
												l_norm___0 := l_norm___0 + (l_coeff[l_jj] * l_coeff[l_jj])
												l_jj := l_jj + 1
											end
										end
										l_norm___0 := sqrt (l_norm___0)
										a_result_array[l_ii] := a_result_array[l_ii] / l_norm___0
									end
								end
								if not js.loop_left then
									l_ii := l_ii + 1
									l_order := l_order + 1
								end
							end
						end
						if not js.return_called then
							Result := 0
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_mathieu_se_array (a_nmin: INTEGER_32; a_nmax: INTEGER_32; a_qq: REAL_64; a_zz: REAL_64; a_work: CE_POINTER [PD_GSL_SF_MATHIEU_WORKSPACE]; a_result_array: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_even_odd: INTEGER_32
			l_order: INTEGER_32
			l_ii: INTEGER_32
			l_jj: INTEGER_32
			l_status: INTEGER_32
			l_coeff: CE_ARRAY [REAL_64]
			l_bb: CE_POINTER [REAL_64]
			l_norm___0: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_coeff.make (<<100>>)
			create l_bb.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_bb.ce_gets (a_work.item.bb)
					l_ii := 0
					from
					until
						not (l_ii < (a_nmax - a_nmin) + 1)
					loop
						a_result_array[l_ii] := 0.0
						l_ii := l_ii + 1
					end
					if a_work.item.size < a_nmax.to_natural_32 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("Work space not large enough"), ce_string ("mathieu_angfunc.c"), 287, 4)
							Result := 4
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (a_nmin < 0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_nmax < a_nmin) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("domain error"), ce_string ("mathieu_angfunc.c"), 292, 1)
							Result := 1
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 6 then -- if done | if done
						if not js.return_called then
							mathieu_charv_inst.gsl_sf_mathieu_b_array (0, a_nmax, a_qq, a_work, l_bb).do_nothing
							l_ii := 0
							l_order := a_nmin
							from
							until
								not (not js.loop_left and then (l_order <= a_nmax))
							loop
								js.reset
								l_norm___0 := 0.0
								l_even_odd := 0
								if l_order \\ 2 /= 0 then
									l_even_odd := 1
								end
								if a_qq = 0.0 then
									l_norm___0 := 1.0
									a_result_array[l_ii] := sin (l_order.to_double * a_zz)
									js.continue
								end
								if not js.loop_jumped then
									l_status := mathieu_coeff_inst.gsl_sf_mathieu_b_coeff (l_order, a_qq, l_bb[l_order], l_coeff)
									if l_status /= 0 then
										Result := l_status
										js.return
									end
									if not js.return_called then
										if l_even_odd = 0 then
											l_jj := 0
											from
											until
												not (l_jj < 100)
											loop
												a_result_array[l_ii] := a_result_array[l_ii] + (l_coeff[l_jj] * (sin ((2.0 * (l_jj + 1).to_double) * a_zz)))
												l_norm___0 := l_norm___0 + (l_coeff[l_jj] * l_coeff[l_jj])
												l_jj := l_jj + 1
											end
										else
											l_jj := 0
											from
											until
												not (l_jj < 100)
											loop
												a_result_array[l_ii] := a_result_array[l_ii] + (l_coeff[l_jj] * (sin ((2.0 * l_jj.to_double + 1.0) * a_zz)))
												l_norm___0 := l_norm___0 + (l_coeff[l_jj] * l_coeff[l_jj])
												l_jj := l_jj + 1
											end
										end
										l_norm___0 := sqrt (l_norm___0)
										a_result_array[l_ii] := a_result_array[l_ii] / l_norm___0
									end
								end
								if not js.loop_left then
									l_ii := l_ii + 1
									l_order := l_order + 1
								end
							end
						end
						if not js.return_called then
							Result := 0
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
