class
	P_MATHIEU_COEFF

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	backward_recurse_c (a_aa: REAL_64; a_qq: REAL_64; a_xx: REAL_64; a_ff: CE_POINTER [REAL_64]; a_gx: CE_POINTER [REAL_64]; a_even_odd: INTEGER_32; a_ni: INTEGER_32)
		local
			l_ii: INTEGER_32
			l_nn: INTEGER_32
			l_g1: REAL_64
		do
			l_g1 := a_gx.item
			a_ff[a_ni] := a_xx
			if a_even_odd = 0 then
				l_ii := 0
				from
				until
					not (l_ii < a_ni)
				loop
					l_nn := (100 - l_ii) - 1
					a_ff[((a_ni - l_ii) - 1)] := -1.0 / ((((4 * l_nn) * l_nn).to_double - a_aa) / a_qq + a_ff[(a_ni - l_ii)])
					l_ii := l_ii + 1
				end
				if a_ni = 99 then
					a_ff[0] := a_ff[0] * (2.0)
				end
			else
				l_ii := 0
				from
				until
					not (l_ii < a_ni)
				loop
					l_nn := (100 - l_ii) - 1
					a_ff[((a_ni - l_ii) - 1)] := -1.0 / ((((2 * l_nn + 1) * (2 * l_nn + 1)).to_double - a_aa) / a_qq + a_ff[(a_ni - l_ii)])
					l_ii := l_ii + 1
				end
			end
			a_gx.item := a_ff[0] - l_g1
		end

	backward_recurse_s (a_aa: REAL_64; a_qq: REAL_64; a_xx: REAL_64; a_ff: CE_POINTER [REAL_64]; a_gx: CE_POINTER [REAL_64]; a_even_odd: INTEGER_32; a_ni: INTEGER_32)
		local
			l_ii: INTEGER_32
			l_nn: INTEGER_32
			l_g1: REAL_64
		do
			l_g1 := a_gx.item
			a_ff[a_ni] := a_xx
			if a_even_odd = 0 then
				l_ii := 0
				from
				until
					not (l_ii < a_ni)
				loop
					l_nn := (100 - l_ii) - 1
					a_ff[((a_ni - l_ii) - 1)] := -1.0 / ((((4 * (l_nn + 1)) * (l_nn + 1)).to_double - a_aa) / a_qq + a_ff[(a_ni - l_ii)])
					l_ii := l_ii + 1
				end
			else
				l_ii := 0
				from
				until
					not (l_ii < a_ni)
				loop
					l_nn := (100 - l_ii) - 1
					a_ff[((a_ni - l_ii) - 1)] := -1.0 / ((((2 * l_nn + 1) * (2 * l_nn + 1)).to_double - a_aa) / a_qq + a_ff[(a_ni - l_ii)])
					l_ii := l_ii + 1
				end
			end
			a_gx.item := a_ff[0] - l_g1
		end

	gsl_sf_mathieu_a_coeff (a_order: INTEGER_32; a_qq: REAL_64; a_aa: REAL_64; a_coeff: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_ni: INTEGER_32
			l_nn: INTEGER_32
			l_ii: INTEGER_32
			l_even_odd: INTEGER_32
			l_eps: REAL_64
			l_g1: REAL_64
			l_g2: REAL_64
			l_x1___0: REAL_64
			l_x2___1: REAL_64
			l_e1: REAL_64
			l_e2: REAL_64
			l_de: REAL_64
			l_xh: REAL_64
			l_sum: REAL_64
			l_ratio: REAL_64
			l_ff: CE_ARRAY [REAL_64]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_ff.make (<<100>>)

			l_eps := 1.e-14
			a_coeff[0] := 1.0
			l_even_odd := 0
			if a_order \\ 2 /= 0 then
				l_even_odd := 1
			end
			if a_order > 100 then
				Result := (-1)
				js.return
			end
			if not js.return_called and then (a_qq = 0.0) then
				l_ii := 0
				from
				until
					not (l_ii < 100)
				loop
					a_coeff[l_ii] := 0.0
					l_ii := l_ii + 1
				end
				a_coeff[a_order // 2] := 1.0
				Result := 0
				js.return
			end
			if not js.return_called then
				if a_order < 5 then
					l_nn := 0
					l_sum := 0.0
					if l_even_odd = 0 then
						l_ratio := a_aa / a_qq
					else
						l_ratio := ((a_aa - (1).to_double) - a_qq) / a_qq
					end
				else
					if l_even_odd = 0 then
						a_coeff[1] := a_aa / a_qq
						a_coeff[2] := ((a_aa - (4).to_double) / a_qq) * a_coeff[1] - (2).to_double
						l_sum := (a_coeff[0] + a_coeff[1]) + a_coeff[2]
						l_ii := 3
						from
						until
							not (l_ii < a_order // 2 + 1)
						loop
							a_coeff[l_ii] := ((a_aa - ((4 * (l_ii - 1)) * (l_ii - 1)).to_double) / a_qq) * a_coeff[(l_ii - 1)] - a_coeff[(l_ii - 2)]
							l_sum := l_sum + (a_coeff[l_ii])
							l_ii := l_ii + 1
						end
					else
						a_coeff[1] := (a_aa - (1).to_double) / a_qq - (1).to_double
						l_sum := a_coeff[0] + a_coeff[1]
						l_ii := 2
						from
						until
							not (l_ii < a_order // 2 + 1)
						loop
							a_coeff[l_ii] := ((a_aa - ((2 * l_ii - 1) * (2 * l_ii - 1)).to_double) / a_qq) * a_coeff[(l_ii - 1)] - a_coeff[(l_ii - 2)]
							l_sum := l_sum + (a_coeff[l_ii])
							l_ii := l_ii + 1
						end
					end
					l_nn := l_ii - 1
					l_ratio := a_coeff[l_nn] / a_coeff[(l_nn - 1)]
				end
				l_ni := (100 - l_nn) - 1
				if l_even_odd = 0 then
					l_x1___0 := -a_qq / ((4.0 * (100).to_double) * (100).to_double)
				else
					l_x1___0 := -a_qq / ((2.0 * (100).to_double + 1.0) * (2.0 * (100).to_double + 1.0))
				end
				l_g1 := l_ratio
				backward_recurse_c (a_aa, a_qq, l_x1___0, l_ff, create {CE_POINTER [REAL_64]}.make_shared ($l_g1), l_even_odd, l_ni)
				l_x2___1 := l_g1
				l_g2 := l_ratio
				backward_recurse_c (a_aa, a_qq, l_x2___1, l_ff, create {CE_POINTER [REAL_64]}.make_shared ($l_g2), l_even_odd, l_ni)
				from
				until
					js.loop_left
				loop
					js.reset
					l_e1 := l_g1 - l_x1___0
					l_e2 := l_g2 - l_x2___1
					l_de := l_e1 - l_e2
					if (fabs (l_de)) < l_eps then
						js.break
					end
					if not js.loop_jumped then
						l_xh := (l_e1 * l_x2___1 - l_e2 * l_x1___0) / l_de
						l_x1___0 := l_x2___1
						l_g1 := l_g2
						l_x2___1 := l_xh
						l_g2 := l_ratio
						backward_recurse_c (a_aa, a_qq, l_x2___1, l_ff, create {CE_POINTER [REAL_64]}.make_shared ($l_g2), l_even_odd, l_ni)
					end
				end
				js.reset
				l_sum := l_sum + (a_coeff[l_nn])
				l_ii := l_nn + 1
				from
				until
					not (not js.loop_left and then (l_ii < 100))
				loop
					a_coeff[l_ii] := l_ff[(l_ii - l_nn) - 1] * a_coeff[(l_ii - 1)]
					l_sum := l_sum + (a_coeff[l_ii])
					if (fabs (a_coeff[l_ii])) < 1.e-20 then
						from
						until
							not (l_ii < 100)
						loop
							l_tmp___0 := l_ii
							l_ii := l_ii + 1
							a_coeff[l_tmp___0] := 0.0
						end
					end
					l_ii := l_ii + 1
				end
				l_ii := 0
				from
				until
					not (l_ii < 100)
				loop
					a_coeff[l_ii] := a_coeff[l_ii] / l_sum
					l_ii := l_ii + 1
				end
				Result := 0
			end
		end

	gsl_sf_mathieu_b_coeff (a_order: INTEGER_32; a_qq: REAL_64; a_aa: REAL_64; a_coeff: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_ni: INTEGER_32
			l_nn: INTEGER_32
			l_ii: INTEGER_32
			l_even_odd: INTEGER_32
			l_eps: REAL_64
			l_g1: REAL_64
			l_g2: REAL_64
			l_x1___0: REAL_64
			l_x2___1: REAL_64
			l_e1: REAL_64
			l_e2: REAL_64
			l_de: REAL_64
			l_xh: REAL_64
			l_sum: REAL_64
			l_ratio: REAL_64
			l_ff: CE_ARRAY [REAL_64]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_ff.make (<<100>>)

			l_eps := 1.e-10
			a_coeff[0] := 1.0
			l_even_odd := 0
			if a_order \\ 2 /= 0 then
				l_even_odd := 1
			end
			if a_order > 100 then
				Result := (-1)
				js.return
			end
			if not js.return_called and then (a_qq = 0.0) then
				l_ii := 0
				from
				until
					not (l_ii < 100)
				loop
					a_coeff[l_ii] := 0.0
					l_ii := l_ii + 1
				end
				a_coeff[(a_order - 1) // 2] := 1.0
				Result := 0
				js.return
			end
			if not js.return_called then
				if a_order < 5 then
					l_nn := 0
					l_sum := 0.0
					if l_even_odd = 0 then
						l_ratio := (a_aa - (4).to_double) / a_qq
					else
						l_ratio := ((a_aa - (1).to_double) - a_qq) / a_qq
					end
				else
					if l_even_odd = 0 then
						a_coeff[1] := (a_aa - (4).to_double) / a_qq
						l_sum := (2).to_double * a_coeff[0] + (4).to_double * a_coeff[1]
						l_ii := 2
						from
						until
							not (l_ii < a_order // 2)
						loop
							a_coeff[l_ii] := ((a_aa - ((4 * l_ii) * l_ii).to_double) / a_qq) * a_coeff[(l_ii - 1)] - a_coeff[(l_ii - 2)]
							l_sum := l_sum + ((2 * (l_ii + 1)).to_double * a_coeff[l_ii])
							l_ii := l_ii + 1
						end
					else
						a_coeff[1] := (a_aa - (1).to_double) / a_qq + (1).to_double
						l_sum := a_coeff[0] + (3).to_double * a_coeff[1]
						l_ii := 2
						from
						until
							not (l_ii < a_order // 2 + 1)
						loop
							a_coeff[l_ii] := ((a_aa - ((2 * l_ii - 1) * (2 * l_ii - 1)).to_double) / a_qq) * a_coeff[(l_ii - 1)] - a_coeff[(l_ii - 2)]
							l_sum := l_sum + ((2 * (l_ii + 1) - 1).to_double * a_coeff[l_ii])
							l_ii := l_ii + 1
						end
					end
					l_nn := l_ii - 1
					l_ratio := a_coeff[l_nn] / a_coeff[(l_nn - 1)]
				end
				l_ni := (100 - l_nn) - 1
				if l_even_odd = 0 then
					l_x1___0 := -a_qq / ((4.0 * ((100).to_double + 1.0)) * ((100).to_double + 1.0))
				else
					l_x1___0 := -a_qq / ((2.0 * (100).to_double + 1.0) * (2.0 * (100).to_double + 1.0))
				end
				l_g1 := l_ratio
				backward_recurse_s (a_aa, a_qq, l_x1___0, l_ff, create {CE_POINTER [REAL_64]}.make_shared ($l_g1), l_even_odd, l_ni)
				l_x2___1 := l_g1
				l_g2 := l_ratio
				backward_recurse_s (a_aa, a_qq, l_x2___1, l_ff, create {CE_POINTER [REAL_64]}.make_shared ($l_g2), l_even_odd, l_ni)
				from
				until
					js.loop_left
				loop
					js.reset
					l_e1 := l_g1 - l_x1___0
					l_e2 := l_g2 - l_x2___1
					l_de := l_e1 - l_e2
					if (fabs (l_de)) < l_eps then
						js.break
					end
					if not js.loop_jumped then
						l_xh := (l_e1 * l_x2___1 - l_e2 * l_x1___0) / l_de
						l_x1___0 := l_x2___1
						l_g1 := l_g2
						l_x2___1 := l_xh
						l_g2 := l_ratio
						backward_recurse_s (a_aa, a_qq, l_x2___1, l_ff, create {CE_POINTER [REAL_64]}.make_shared ($l_g2), l_even_odd, l_ni)
					end
				end
				js.reset
				l_sum := l_sum + ((2 * (l_nn + 1)).to_double * a_coeff[l_nn])
				l_ii := l_nn + 1
				from
				until
					not (not js.loop_left and then (l_ii < 100))
				loop
					a_coeff[l_ii] := l_ff[(l_ii - l_nn) - 1] * a_coeff[(l_ii - 1)]
					l_sum := l_sum + ((2 * (l_ii + 1)).to_double * a_coeff[l_ii])
					if (fabs (a_coeff[l_ii])) < 1.e-20 then
						from
						until
							not (l_ii < 100)
						loop
							l_tmp___0 := l_ii
							l_ii := l_ii + 1
							a_coeff[l_tmp___0] := 0.0
						end
					end
					l_ii := l_ii + 1
				end
				l_ii := 0
				from
				until
					not (l_ii < 100)
				loop
					a_coeff[l_ii] := a_coeff[l_ii] / l_sum
					l_ii := l_ii + 1
				end
				Result := 0
			end
		end

end
