class
	P_MAXVAL

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_histogram_max_val (a_h: CE_POINTER [PD_GSL_HISTOGRAM]): REAL_64
		local
			l_n: NATURAL_32
			l_i: NATURAL_32
			l_max: REAL_64
		do
			l_n := a_h.item.n
			l_max := a_h.item.bin[0]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				if a_h.item.bin[l_i.to_integer_32] > l_max then
					l_max := a_h.item.bin[l_i.to_integer_32]
				end
				l_i := l_i + 1
			end
			Result := l_max
		end

	gsl_histogram_max_bin (a_h: CE_POINTER [PD_GSL_HISTOGRAM]): NATURAL_32
		local
			l_i: NATURAL_32
			l_imax: NATURAL_32
			l_max: REAL_64
		do
			l_imax := (0).to_natural_32
			l_max := a_h.item.bin[0]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_h.item.n)
			loop
				if a_h.item.bin[l_i.to_integer_32] > l_max then
					l_max := a_h.item.bin[l_i.to_integer_32]
					l_imax := l_i
				end
				l_i := l_i + 1
			end
			Result := l_imax
		end

	gsl_histogram_min_val (a_h: CE_POINTER [PD_GSL_HISTOGRAM]): REAL_64
		local
			l_i: NATURAL_32
			l_min: REAL_64
		do
			l_min := a_h.item.bin[0]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_h.item.n)
			loop
				if a_h.item.bin[l_i.to_integer_32] < l_min then
					l_min := a_h.item.bin[l_i.to_integer_32]
				end
				l_i := l_i + 1
			end
			Result := l_min
		end

	gsl_histogram_min_bin (a_h: CE_POINTER [PD_GSL_HISTOGRAM]): NATURAL_32
		local
			l_i: NATURAL_32
			l_imin: NATURAL_32
			l_min: REAL_64
		do
			l_imin := (0).to_natural_32
			l_min := a_h.item.bin[0]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_h.item.n)
			loop
				if a_h.item.bin[l_i.to_integer_32] < l_min then
					l_min := a_h.item.bin[l_i.to_integer_32]
					l_imin := l_i
				end
				l_i := l_i + 1
			end
			Result := l_imin
		end

end
