class
	P_MAXVAL2D

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_histogram2d_max_val (a_h: CE_POINTER [PD_GSL_HISTOGRAM2D]): REAL_64
		local
			l_nx: NATURAL_32
			l_ny: NATURAL_32
			l_i: NATURAL_32
			l_max: REAL_64
		do
			l_nx := a_h.item.nx
			l_ny := a_h.item.ny
			l_max := a_h.item.bin[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_nx * l_ny)
			loop
				if a_h.item.bin[l_i.to_integer_32] > l_max then
					l_max := a_h.item.bin[l_i.to_integer_32]
				end
				l_i := l_i + 1
			end
			Result := l_max
		end

	gsl_histogram2d_max_bin (a_h: CE_POINTER [PD_GSL_HISTOGRAM2D]; a_imax_out: CE_POINTER [NATURAL_32]; a_jmax_out: CE_POINTER [NATURAL_32])
		local
			l_nx: NATURAL_32
			l_ny: NATURAL_32
			l_imax: NATURAL_32
			l_jmax: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_max: REAL_64
			l_x: REAL_64
			js: JUMP_STATE
		do
			l_nx := a_h.item.nx
			l_ny := a_h.item.ny
			l_imax := (0).to_natural_32
			l_jmax := (0).to_natural_32
			l_max := a_h.item.bin[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_left and then (l_i < l_nx))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_ny)
				loop
					l_x := a_h.item.bin[(l_i * l_ny + l_j).to_integer_32]
					if l_x > l_max then
						l_max := l_x
						l_imax := l_i
						l_jmax := l_j
					end
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
			a_imax_out.item := l_imax
			a_jmax_out.item := l_jmax
		end

	gsl_histogram2d_min_val (a_h: CE_POINTER [PD_GSL_HISTOGRAM2D]): REAL_64
		local
			l_nx: NATURAL_32
			l_ny: NATURAL_32
			l_i: NATURAL_32
			l_min: REAL_64
		do
			l_nx := a_h.item.nx
			l_ny := a_h.item.ny
			l_min := a_h.item.bin[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_nx * l_ny)
			loop
				if a_h.item.bin[l_i.to_integer_32] < l_min then
					l_min := a_h.item.bin[l_i.to_integer_32]
				end
				l_i := l_i + 1
			end
			Result := l_min
		end

	gsl_histogram2d_min_bin (a_h: CE_POINTER [PD_GSL_HISTOGRAM2D]; a_imin_out: CE_POINTER [NATURAL_32]; a_jmin_out: CE_POINTER [NATURAL_32])
		local
			l_nx: NATURAL_32
			l_ny: NATURAL_32
			l_imin: NATURAL_32
			l_jmin: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_min: REAL_64
			l_x: REAL_64
			js: JUMP_STATE
		do
			l_nx := a_h.item.nx
			l_ny := a_h.item.ny
			l_imin := (0).to_natural_32
			l_jmin := (0).to_natural_32
			l_min := a_h.item.bin[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_left and then (l_i < l_nx))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_ny)
				loop
					l_x := a_h.item.bin[(l_i * l_ny + l_j).to_integer_32]
					if l_x < l_min then
						l_min := l_x
						l_imin := l_i
						l_jmin := l_j
					end
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
			a_imin_out.item := l_imin
			a_jmin_out.item := l_jmin
		end

end
