class
	P_MEAN_SOURCE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_stats_long_double_mean (a_data: CE_POINTER [REAL_96]; a_stride: NATURAL_32; a_size: NATURAL_32): REAL_64
		local
			l_mean: REAL_96
			l_i: NATURAL_32
		do
			l_mean := real_96_from_integer_32 (0)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_mean := l_mean + ((a_data[(l_i * a_stride).to_integer_32] - l_mean) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_i := l_i + 1
			end
			Result := l_mean.truncated_to_real_64
		end

	gsl_stats_mean (a_data: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_size: NATURAL_32): REAL_64
		local
			l_mean: REAL_96
			l_i: NATURAL_32
		do
			l_mean := real_96_from_integer_32 (0)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_mean := l_mean + ((real_96_from_real_64 (a_data[(l_i * a_stride).to_integer_32]) - l_mean) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_i := l_i + 1
			end
			Result := l_mean.truncated_to_real_64
		end

	gsl_stats_float_mean (a_data: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_size: NATURAL_32): REAL_64
		local
			l_mean: REAL_96
			l_i: NATURAL_32
		do
			l_mean := real_96_from_integer_32 (0)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_mean := l_mean + ((real_96_from_real_32 (a_data[(l_i * a_stride).to_integer_32]) - l_mean) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_i := l_i + 1
			end
			Result := l_mean.truncated_to_real_64
		end

	gsl_stats_ulong_mean (a_data: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_size: NATURAL_32): REAL_64
		local
			l_mean: REAL_96
			l_i: NATURAL_32
		do
			l_mean := real_96_from_integer_32 (0)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_mean := l_mean + ((real_96_from_natural_32 (a_data[(l_i * a_stride).to_integer_32]) - l_mean) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_i := l_i + 1
			end
			Result := l_mean.truncated_to_real_64
		end

	gsl_stats_long_mean (a_data: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_size: NATURAL_32): REAL_64
		local
			l_mean: REAL_96
			l_i: NATURAL_32
		do
			l_mean := real_96_from_integer_32 (0)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_mean := l_mean + ((real_96_from_integer_32 (a_data[(l_i * a_stride).to_integer_32]) - l_mean) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_i := l_i + 1
			end
			Result := l_mean.truncated_to_real_64
		end

	gsl_stats_uint_mean (a_data: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_size: NATURAL_32): REAL_64
		local
			l_mean: REAL_96
			l_i: NATURAL_32
		do
			l_mean := real_96_from_integer_32 (0)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_mean := l_mean + ((real_96_from_natural_32 (a_data[(l_i * a_stride).to_integer_32]) - l_mean) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_i := l_i + 1
			end
			Result := l_mean.truncated_to_real_64
		end

	gsl_stats_int_mean (a_data: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_size: NATURAL_32): REAL_64
		local
			l_mean: REAL_96
			l_i: NATURAL_32
		do
			l_mean := real_96_from_integer_32 (0)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_mean := l_mean + ((real_96_from_integer_32 (a_data[(l_i * a_stride).to_integer_32]) - l_mean) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_i := l_i + 1
			end
			Result := l_mean.truncated_to_real_64
		end

	gsl_stats_ushort_mean (a_data: CE_POINTER [NATURAL_16]; a_stride: NATURAL_32; a_size: NATURAL_32): REAL_64
		local
			l_mean: REAL_96
			l_i: NATURAL_32
		do
			l_mean := real_96_from_integer_32 (0)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_mean := l_mean + ((real_96_from_natural_16 (a_data[(l_i * a_stride).to_integer_32]) - l_mean) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_i := l_i + 1
			end
			Result := l_mean.truncated_to_real_64
		end

	gsl_stats_short_mean (a_data: CE_POINTER [INTEGER_16]; a_stride: NATURAL_32; a_size: NATURAL_32): REAL_64
		local
			l_mean: REAL_96
			l_i: NATURAL_32
		do
			l_mean := real_96_from_integer_32 (0)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_mean := l_mean + ((real_96_from_integer_16 (a_data[(l_i * a_stride).to_integer_32]) - l_mean) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_i := l_i + 1
			end
			Result := l_mean.truncated_to_real_64
		end

	gsl_stats_uchar_mean (a_data: CE_POINTER [NATURAL_8]; a_stride: NATURAL_32; a_size: NATURAL_32): REAL_64
		local
			l_mean: REAL_96
			l_i: NATURAL_32
		do
			l_mean := real_96_from_integer_32 (0)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_mean := l_mean + ((real_96_from_natural_8 (a_data[(l_i * a_stride).to_integer_32]) - l_mean) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_i := l_i + 1
			end
			Result := l_mean.truncated_to_real_64
		end

	gsl_stats_char_mean (a_data: CE_POINTER [INTEGER_8]; a_stride: NATURAL_32; a_size: NATURAL_32): REAL_64
		local
			l_mean: REAL_96
			l_i: NATURAL_32
		do
			l_mean := real_96_from_integer_32 (0)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_size)
			loop
				l_mean := l_mean + ((real_96_from_integer_8 (a_data[(l_i * a_stride).to_integer_32]) - l_mean) / real_96_from_natural_32 ((l_i + {NATURAL_32} 1)))
				l_i := l_i + 1
			end
			Result := l_mean.truncated_to_real_64
		end

end
