class
	P_MRG

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create mrg_type.make
			create gsl_rng_mrg.make
		end

feature {ANY} -- attributes

	m___3: INTEGER_32 assign set_m___3

	set_m___3 (a_m___3: INTEGER_32)
		do
			m___3 := a_m___3
		end

	a1___3: INTEGER_32 assign set_a1___3

	set_a1___3 (a_a1___3: INTEGER_32)
		do
			a1___3 := a_a1___3
		end

	q1___0: INTEGER_32 assign set_q1___0

	set_q1___0 (a_q1___0: INTEGER_32)
		do
			q1___0 := a_q1___0
		end

	r1___0: INTEGER_32 assign set_r1___0

	set_r1___0 (a_r1___0: INTEGER_32)
		do
			r1___0 := a_r1___0
		end

	a5: INTEGER_32 assign set_a5

	set_a5 (a_a5: INTEGER_32)
		do
			a5 := a_a5
		end

	q52: INTEGER_32 assign set_q52

	set_q52 (a_q52: INTEGER_32)
		do
			q52 := a_q52
		end

	r5: INTEGER_32 assign set_r5

	set_r5 (a_r5: INTEGER_32)
		do
			r5 := a_r5
		end

	mrg_type: PD_GSL_RNG_TYPE

	gsl_rng_mrg: CE_POINTER [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	mrg_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_MRG_STATE_T]
			l_p1: INTEGER_32
			l_h1: INTEGER_32
			l_p5: INTEGER_32
			l_h5: INTEGER_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_MRG_STATE_T]}.make_cast (a_vstate))
			l_h5 := l_state.item.x5 // q52
			l_p5 := (a5 * (l_state.item.x5 - l_h5 * q52) - (l_h5 * r5))
			if l_p5 > 0 then
				l_p5 := l_p5 - m___3
			end
			l_h1 := l_state.item.x1 // q1___0
			l_p1 := (a1___3 * (l_state.item.x1 - l_h1 * q1___0) - (l_h1 * r1___0))
			if l_p1 < 0 then
				l_p1 := l_p1 + m___3
			end
			l_state.item.x5 := l_state.item.x4
			l_state.item.x4 := l_state.item.x3
			l_state.item.x3 := l_state.item.x2
			l_state.item.x2 := l_state.item.x1
			l_state.item.x1 := l_p1 + l_p5
			if l_state.item.x1 < 0 then
				l_state.item.x1 := l_state.item.x1 + m___3
			end
			Result := (l_state.item.x1).to_natural_32
		end

	mrg_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent mrg_get)
		end

	mrg_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((mrg_get (a_vstate)).to_real_64 / 2147483647.0)
		end

	mrg_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent mrg_get_double)
		end

	mrg_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_MRG_STATE_T]
		do
			create l_state.make

			l_s := a_s
			l_state.ce_gets (create {CE_POINTER [PD_MRG_STATE_T]}.make_cast (a_vstate))
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_s := ({NATURAL_32} 69069 * l_s).bit_and ({NATURAL_32} 4294967295)
			l_state.item.x1 := (l_s \\ m___3.to_natural_32).to_integer_32
			l_s := ({NATURAL_32} 69069 * l_s).bit_and ({NATURAL_32} 4294967295)
			l_state.item.x2 := (l_s \\ m___3.to_natural_32).to_integer_32
			l_s := ({NATURAL_32} 69069 * l_s).bit_and ({NATURAL_32} 4294967295)
			l_state.item.x3 := (l_s \\ m___3.to_natural_32).to_integer_32
			l_s := ({NATURAL_32} 69069 * l_s).bit_and ({NATURAL_32} 4294967295)
			l_state.item.x4 := (l_s \\ m___3.to_natural_32).to_integer_32
			l_s := ({NATURAL_32} 69069 * l_s).bit_and ({NATURAL_32} 4294967295)
			l_state.item.x5 := (l_s \\ m___3.to_natural_32).to_integer_32
			mrg_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			mrg_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			mrg_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			mrg_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			mrg_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			mrg_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
		end

	mrg_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent mrg_set)
		end

end
