class
	P_MULTILINEAR

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	multifit_linear_svd (a_X: CE_POINTER [PD_GSL_MATRIX]; a_y: CE_POINTER [PD_GSL_VECTOR]; a_tol: REAL_64; a_balance: INTEGER_32; a_rank: CE_POINTER [NATURAL_32]; a_c___1: CE_POINTER [PD_GSL_VECTOR]; a_cov: CE_POINTER [PD_GSL_MATRIX]; a_chisq: CE_POINTER [REAL_64]; a_work: CE_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]): INTEGER_32
		local
			l_n: NATURAL_32
			l_p: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_p_eff: NATURAL_32
			l_A___0: CE_POINTER [PD_GSL_MATRIX]
			l_Q___1: CE_POINTER [PD_GSL_MATRIX]
			l_QSI: CE_POINTER [PD_GSL_MATRIX]
			l_S: CE_POINTER [PD_GSL_VECTOR]
			l_xt: CE_POINTER [PD_GSL_VECTOR]
			l_D: CE_POINTER [PD_GSL_VECTOR]
			l_alpha0: REAL_64
			l_column: PD_GSL_VECTOR_VIEW
			l_alpha: REAL_64
			l_s2: REAL_64
			l_r2___0: REAL_64
			l_yi: REAL_64
			l_row: PD_GSL_VECTOR_CONST_VIEW
			l_y_est: REAL_64
			l_ri: REAL_64
			l_row_i: PD_GSL_VECTOR_VIEW
			l_d_i: REAL_64
			l_row_j: PD_GSL_VECTOR_VIEW
			l_d_j: REAL_64
			l_s3: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_A___0.make
			create l_Q___1.make
			create l_QSI.make
			create l_S.make
			create l_xt.make
			create l_D.make
			create l_column.make
			create l_row.make
			create l_row_i.make
			create l_row_j.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_X.item.size1 = a_y.item.size then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("number of observations in y does not match rows of matrix X"), ce_string ("multilinear.c"), 49, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 3 then -- else:
						if a_X.item.size2 = a_c___1.item.size then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("number of parameters c does not match columns of matrix X"), ce_string ("multilinear.c"), 54, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 6 then -- else:
						if a_cov.item.size1 = a_cov.item.size2 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("covariance matrix is not square"), ce_string ("multilinear.c"), 58, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 9 then -- else:
						if a_c___1.item.size = a_cov.item.size1 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("number of parameters does not match size of covariance matrix"), ce_string ("multilinear.c"), 64, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 12 then -- else:
						if a_X.item.size1 = a_work.item.n then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 15 then -- else:
						if a_X.item.size2 = a_work.item.p then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("size of workspace does not match size of observation matrix"), ce_string ("multilinear.c"), 70, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						if a_tol <= (0).to_double then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("tolerance must be positive"), ce_string ("multilinear.c"), 74, 4)
								Result := 4
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						else
							l_n := a_X.item.size1
							l_p := a_X.item.size2
							l_A___0.ce_gets (a_work.item.A)
							l_Q___1.ce_gets (a_work.item.Q)
							l_QSI.ce_gets (a_work.item.QSI)
							l_S.ce_gets (a_work.item.S)
							l_xt.ce_gets (a_work.item.xt)
							l_D.ce_gets (a_work.item.D)
							copy_source_inst.gsl_matrix_memcpy (l_A___0, a_X).do_nothing
							if a_balance.to_boolean then
								balance_inst.gsl_linalg_balance_columns (l_A___0, l_D).do_nothing
							else
								init_source_inst.gsl_vector_set_all (l_D, 1.0)
							end
							svd_inst.gsl_linalg_SV_decomp_mod (l_A___0, l_QSI, l_Q___1, l_S, l_xt).do_nothing
							blas_inst.gsl_blas_dgemv ({PC_CBLAS_TRANSPOSE}.CblasTrans, 1.0, l_A___0, a_y, 0.0, l_xt).do_nothing
							copy_source_inst.gsl_matrix_memcpy (l_QSI, l_Q___1).do_nothing
							l_alpha0 := (gsl_gsl_vector_double_inst.gsl_vector_get (l_S, (0).to_natural_32))
							l_p_eff := (0).to_natural_32
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_p)
							loop
								l_column.ce_gets ((rowcol_source_inst.gsl_matrix_column (l_QSI, l_j)))
								l_alpha := (gsl_gsl_vector_double_inst.gsl_vector_get (l_S, l_j))
								if l_alpha <= a_tol * l_alpha0 then
									l_alpha := 0.0
								else
									l_alpha := 1.0 / l_alpha
									l_p_eff := l_p_eff + 1
								end
								oper_source_inst.gsl_vector_scale (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_column.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_alpha).do_nothing
								l_j := l_j + 1
							end
							a_rank.item := l_p_eff
							init_source_inst.gsl_vector_set_zero (a_c___1)
							blas_inst.gsl_blas_dgemv ({PC_CBLAS_TRANSPOSE}.CblasNoTrans, 1.0, l_QSI, l_xt, 0.0, a_c___1).do_nothing
							oper_source_inst.gsl_vector_div (a_c___1, l_D).do_nothing
							l_s2 := (0).to_double
							l_r2___0 := (0).to_double
							l_i := (0).to_natural_32
							from
							until
								not (l_i < l_n)
							loop
								l_yi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_y, l_i))
								l_row.ce_gets ((rowcol_source_inst.gsl_matrix_const_row (a_X, l_i)))
								blas_inst.gsl_blas_ddot ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_row.c_pointer + {PD_GSL_VECTOR_CONST_VIEW}.vector_offset)), a_c___1, create {CE_POINTER [REAL_64]}.make_shared ($l_y_est)).do_nothing
								l_ri := l_yi - l_y_est
								l_r2___0 := l_r2___0 + (l_ri * l_ri)
								l_i := l_i + 1
							end
							l_s2 := l_r2___0 / (l_n - l_p_eff).to_real_64
							a_chisq.item := l_r2___0
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_p))
							loop
								l_row_i.ce_gets ((rowcol_source_inst.gsl_matrix_row (l_QSI, l_i)))
								l_d_i := (gsl_gsl_vector_double_inst.gsl_vector_get (l_D, l_i))
								l_j := l_i
								from
								until
									not (l_j < l_p)
								loop
									l_row_j.ce_gets ((rowcol_source_inst.gsl_matrix_row (l_QSI, l_j)))
									l_d_j := (gsl_gsl_vector_double_inst.gsl_vector_get (l_D, l_j))
									blas_inst.gsl_blas_ddot ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_row_i.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_row_j.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [REAL_64]}.make_shared ($l_s3)).do_nothing
									gsl_gsl_matrix_double_inst.gsl_matrix_set (a_cov, l_i, l_j, (l_s3 * l_s2) / (l_d_i * l_d_j))
									gsl_gsl_matrix_double_inst.gsl_matrix_set (a_cov, l_j, l_i, (l_s3 * l_s2) / (l_d_i * l_d_j))
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
							Result := 0
							js.return
						end
				when 19 then -- if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 20 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_multifit_linear (a_X: CE_POINTER [PD_GSL_MATRIX]; a_y: CE_POINTER [PD_GSL_VECTOR]; a_c___1: CE_POINTER [PD_GSL_VECTOR]; a_cov: CE_POINTER [PD_GSL_MATRIX]; a_chisq: CE_POINTER [REAL_64]; a_work: CE_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]): INTEGER_32
		local
			l_rank: NATURAL_32
			l_status: INTEGER_32
		do
			l_status := (multifit_linear_svd (a_X, a_y, 2.2204460492503131e-16, 1, create {CE_POINTER [NATURAL_32]}.make_shared ($l_rank), a_c___1, a_cov, a_chisq, a_work))
			Result := l_status
		end

	gsl_multifit_linear_svd (a_X: CE_POINTER [PD_GSL_MATRIX]; a_y: CE_POINTER [PD_GSL_VECTOR]; a_tol: REAL_64; a_rank: CE_POINTER [NATURAL_32]; a_c___1: CE_POINTER [PD_GSL_VECTOR]; a_cov: CE_POINTER [PD_GSL_MATRIX]; a_chisq: CE_POINTER [REAL_64]; a_work: CE_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (multifit_linear_svd (a_X, a_y, a_tol, 1, a_rank, a_c___1, a_cov, a_chisq, a_work))
			Result := l_status
		end

	gsl_multifit_linear_usvd (a_X: CE_POINTER [PD_GSL_MATRIX]; a_y: CE_POINTER [PD_GSL_VECTOR]; a_tol: REAL_64; a_rank: CE_POINTER [NATURAL_32]; a_c___1: CE_POINTER [PD_GSL_VECTOR]; a_cov: CE_POINTER [PD_GSL_MATRIX]; a_chisq: CE_POINTER [REAL_64]; a_work: CE_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (multifit_linear_svd (a_X, a_y, a_tol, 0, a_rank, a_c___1, a_cov, a_chisq, a_work))
			Result := l_status
		end

	multifit_wlinear_svd (a_X: CE_POINTER [PD_GSL_MATRIX]; a_w: CE_POINTER [PD_GSL_VECTOR]; a_y: CE_POINTER [PD_GSL_VECTOR]; a_tol: REAL_64; a_balance: INTEGER_32; a_rank: CE_POINTER [NATURAL_32]; a_c___1: CE_POINTER [PD_GSL_VECTOR]; a_cov: CE_POINTER [PD_GSL_MATRIX]; a_chisq: CE_POINTER [REAL_64]; a_work: CE_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]): INTEGER_32
		local
			l_n: NATURAL_32
			l_p: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_p_eff: NATURAL_32
			l_A___0: CE_POINTER [PD_GSL_MATRIX]
			l_Q___1: CE_POINTER [PD_GSL_MATRIX]
			l_QSI: CE_POINTER [PD_GSL_MATRIX]
			l_S: CE_POINTER [PD_GSL_VECTOR]
			l_t: CE_POINTER [PD_GSL_VECTOR]
			l_xt: CE_POINTER [PD_GSL_VECTOR]
			l_D: CE_POINTER [PD_GSL_VECTOR]
			l_wi: REAL_64
			l_row: PD_GSL_VECTOR_VIEW
			l_wi___0: REAL_64
			l_yi: REAL_64
			l_alpha0: REAL_64
			l_column: PD_GSL_VECTOR_VIEW
			l_alpha: REAL_64
			l_row_i: PD_GSL_VECTOR_VIEW
			l_d_i: REAL_64
			l_row_j: PD_GSL_VECTOR_VIEW
			l_d_j: REAL_64
			l_s2: REAL_64
			l_r2___0: REAL_64
			l_yi___0: REAL_64
			l_wi___1: REAL_64
			l_row___0: PD_GSL_VECTOR_CONST_VIEW
			l_y_est: REAL_64
			l_ri: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_A___0.make
			create l_Q___1.make
			create l_QSI.make
			create l_S.make
			create l_t.make
			create l_xt.make
			create l_D.make
			create l_row.make
			create l_column.make
			create l_row_i.make
			create l_row_j.make
			create l_row___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_X.item.size1 = a_y.item.size then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("number of observations in y does not match rows of matrix X"), ce_string ("multilinear.c"), 249, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 3 then -- else:
						if a_X.item.size2 = a_c___1.item.size then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("number of parameters c does not match columns of matrix X"), ce_string ("multilinear.c"), 254, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 6 then -- else:
						if a_w.item.size = a_y.item.size then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("number of weights does not match number of observations"), ce_string ("multilinear.c"), 259, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 9 then -- else:
						if a_cov.item.size1 = a_cov.item.size2 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("covariance matrix is not square"), ce_string ("multilinear.c"), 263, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 12 then -- else:
						if a_c___1.item.size = a_cov.item.size1 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("number of parameters does not match size of covariance matrix"), ce_string ("multilinear.c"), 269, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 15 then -- else:
						if a_X.item.size1 = a_work.item.n then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 19 -- goto _L
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 18 then -- else:
						if a_X.item.size2 = a_work.item.p then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("size of workspace does not match size of observation matrix"), ce_string ("multilinear.c"), 275, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						l_n := a_X.item.size1
						l_p := a_X.item.size2
						l_A___0.ce_gets (a_work.item.A)
						l_Q___1.ce_gets (a_work.item.Q)
						l_QSI.ce_gets (a_work.item.QSI)
						l_S.ce_gets (a_work.item.S)
						l_t.ce_gets (a_work.item.t)
						l_xt.ce_gets (a_work.item.xt)
						l_D.ce_gets (a_work.item.D)
						copy_source_inst.gsl_matrix_memcpy (l_A___0, a_X).do_nothing
						l_i := (0).to_natural_32
						from
						until
							not (l_i < l_n)
						loop
							l_wi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_w, l_i))
							if l_wi < (0).to_double then
								l_wi := (0).to_double
							end
							l_row.ce_gets ((rowcol_source_inst.gsl_matrix_row (l_A___0, l_i)))
							oper_source_inst.gsl_vector_scale (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_row.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), (sqrt (l_wi))).do_nothing
							l_i := l_i + 1
						end
						if a_balance.to_boolean then
							balance_inst.gsl_linalg_balance_columns (l_A___0, l_D).do_nothing
						else
							init_source_inst.gsl_vector_set_all (l_D, 1.0)
						end
						svd_inst.gsl_linalg_SV_decomp_mod (l_A___0, l_QSI, l_Q___1, l_S, l_xt).do_nothing
						l_i := (0).to_natural_32
						from
						until
							not (l_i < l_n)
						loop
							l_wi___0 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_w, l_i))
							l_yi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_y, l_i))
							if l_wi___0 < (0).to_double then
								l_wi___0 := (0).to_double
							end
							gsl_gsl_vector_double_inst.gsl_vector_set (l_t, l_i, (sqrt (l_wi___0)) * l_yi)
							l_i := l_i + 1
						end
						blas_inst.gsl_blas_dgemv ({PC_CBLAS_TRANSPOSE}.CblasTrans, 1.0, l_A___0, l_t, 0.0, l_xt).do_nothing
						copy_source_inst.gsl_matrix_memcpy (l_QSI, l_Q___1).do_nothing
						l_alpha0 := (gsl_gsl_vector_double_inst.gsl_vector_get (l_S, (0).to_natural_32))
						l_p_eff := (0).to_natural_32
						l_j := (0).to_natural_32
						from
						until
							not (l_j < l_p)
						loop
							l_column.ce_gets ((rowcol_source_inst.gsl_matrix_column (l_QSI, l_j)))
							l_alpha := (gsl_gsl_vector_double_inst.gsl_vector_get (l_S, l_j))
							if l_alpha <= a_tol * l_alpha0 then
								l_alpha := 0.0
							else
								l_alpha := 1.0 / l_alpha
								l_p_eff := l_p_eff + 1
							end
							oper_source_inst.gsl_vector_scale (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_column.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_alpha).do_nothing
							l_j := l_j + 1
						end
						a_rank.item := l_p_eff
						init_source_inst.gsl_vector_set_zero (a_c___1)
						blas_inst.gsl_blas_dgemv ({PC_CBLAS_TRANSPOSE}.CblasNoTrans, 1.0, l_QSI, l_xt, 0.0, a_c___1).do_nothing
						oper_source_inst.gsl_vector_div (a_c___1, l_D).do_nothing
						l_i := (0).to_natural_32
						from
						until
							not (not js.loop_left and then (l_i < l_p))
						loop
							l_row_i.ce_gets ((rowcol_source_inst.gsl_matrix_row (l_QSI, l_i)))
							l_d_i := (gsl_gsl_vector_double_inst.gsl_vector_get (l_D, l_i))
							l_j := l_i
							from
							until
								not (l_j < l_p)
							loop
								l_row_j.ce_gets ((rowcol_source_inst.gsl_matrix_row (l_QSI, l_j)))
								l_d_j := (gsl_gsl_vector_double_inst.gsl_vector_get (l_D, l_j))
								blas_inst.gsl_blas_ddot ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_row_i.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_row_j.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [REAL_64]}.make_shared ($l_s2)).do_nothing
								gsl_gsl_matrix_double_inst.gsl_matrix_set (a_cov, l_i, l_j, l_s2 / (l_d_i * l_d_j))
								gsl_gsl_matrix_double_inst.gsl_matrix_set (a_cov, l_j, l_i, l_s2 / (l_d_i * l_d_j))
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						l_r2___0 := (0).to_double
						l_i := (0).to_natural_32
						from
						until
							not (l_i < l_n)
						loop
							l_yi___0 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_y, l_i))
							l_wi___1 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_w, l_i))
							l_row___0.ce_gets ((rowcol_source_inst.gsl_matrix_const_row (a_X, l_i)))
							blas_inst.gsl_blas_ddot ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_row___0.c_pointer + {PD_GSL_VECTOR_CONST_VIEW}.vector_offset)), a_c___1, create {CE_POINTER [REAL_64]}.make_shared ($l_y_est)).do_nothing
							l_ri := l_yi___0 - l_y_est
							l_r2___0 := l_r2___0 + ((l_wi___1 * l_ri) * l_ri)
							l_i := l_i + 1
						end
						a_chisq.item := l_r2___0
						Result := 0
						js.return
				when 22 then -- if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 23 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_multifit_wlinear (a_X: CE_POINTER [PD_GSL_MATRIX]; a_w: CE_POINTER [PD_GSL_VECTOR]; a_y: CE_POINTER [PD_GSL_VECTOR]; a_c___1: CE_POINTER [PD_GSL_VECTOR]; a_cov: CE_POINTER [PD_GSL_MATRIX]; a_chisq: CE_POINTER [REAL_64]; a_work: CE_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]): INTEGER_32
		local
			l_rank: NATURAL_32
			l_status: INTEGER_32
		do
			l_status := (multifit_wlinear_svd (a_X, a_w, a_y, 2.2204460492503131e-16, 1, create {CE_POINTER [NATURAL_32]}.make_shared ($l_rank), a_c___1, a_cov, a_chisq, a_work))
			Result := l_status
		end

	gsl_multifit_wlinear_svd (a_X: CE_POINTER [PD_GSL_MATRIX]; a_w: CE_POINTER [PD_GSL_VECTOR]; a_y: CE_POINTER [PD_GSL_VECTOR]; a_tol: REAL_64; a_rank: CE_POINTER [NATURAL_32]; a_c___1: CE_POINTER [PD_GSL_VECTOR]; a_cov: CE_POINTER [PD_GSL_MATRIX]; a_chisq: CE_POINTER [REAL_64]; a_work: CE_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (multifit_wlinear_svd (a_X, a_w, a_y, a_tol, 1, a_rank, a_c___1, a_cov, a_chisq, a_work))
			Result := l_status
		end

	gsl_multifit_wlinear_usvd (a_X: CE_POINTER [PD_GSL_MATRIX]; a_w: CE_POINTER [PD_GSL_VECTOR]; a_y: CE_POINTER [PD_GSL_VECTOR]; a_tol: REAL_64; a_rank: CE_POINTER [NATURAL_32]; a_c___1: CE_POINTER [PD_GSL_VECTOR]; a_cov: CE_POINTER [PD_GSL_MATRIX]; a_chisq: CE_POINTER [REAL_64]; a_work: CE_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (multifit_wlinear_svd (a_X, a_w, a_y, a_tol, 0, a_rank, a_c___1, a_cov, a_chisq, a_work))
			Result := l_status
		end

	gsl_multifit_linear_est (a_x: CE_POINTER [PD_GSL_VECTOR]; a_c___1: CE_POINTER [PD_GSL_VECTOR]; a_cov: CE_POINTER [PD_GSL_MATRIX]; a_y: CE_POINTER [REAL_64]; a_y_err: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_var: REAL_64
			l_xi: REAL_64
			l_xj: REAL_64
			js: JUMP_STATE
		do
			if a_x.item.size /= a_c___1.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("number of parameters c does not match number of observations x"), ce_string ("multilinear.c"), 474, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_cov.item.size1 /= a_cov.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("covariance matrix is not square"), ce_string ("multilinear.c"), 478, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_c___1.item.size /= a_cov.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("number of parameters c does not match size of covariance matrix cov"), ce_string ("multilinear.c"), 483, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_var := (0).to_double
				blas_inst.gsl_blas_ddot (a_x, a_c___1, a_y).do_nothing
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_x.item.size))
				loop
					l_xi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_x, l_i))
					l_var := l_var + ((l_xi * l_xi) * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_cov, l_i, l_i)))
					l_j := (0).to_natural_32
					from
					until
						not (l_j < l_i)
					loop
						l_xj := (gsl_gsl_vector_double_inst.gsl_vector_get (a_x, l_j))
						l_var := l_var + ((((2).to_double * l_xi) * l_xj) * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_cov, l_i, l_j)))
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				a_y_err.item := sqrt (l_var)
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_multifit_linear_residuals (a_X: CE_POINTER [PD_GSL_MATRIX]; a_y: CE_POINTER [PD_GSL_VECTOR]; a_c___1: CE_POINTER [PD_GSL_VECTOR]; a_r___3: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_i: NATURAL_32
			l_yi: REAL_64
			l_row: PD_GSL_VECTOR_CONST_VIEW
			l_y_est: REAL_64
			l_ri: REAL_64
			js: JUMP_STATE
		do
			create l_row.make

			if a_X.item.size1 /= a_y.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("number of observations in y does not match rows of matrix X"), ce_string ("multilinear.c"), 530, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_X.item.size2 /= a_c___1.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("number of parameters c does not match columns of matrix X"), ce_string ("multilinear.c"), 535, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_y.item.size /= a_r___3.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("number of observations in y does not match number of residuals"), ce_string ("multilinear.c"), 540, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_y.item.size)
				loop
					l_yi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_y, l_i))
					l_row.ce_gets ((rowcol_source_inst.gsl_matrix_const_row (a_X, l_i)))
					blas_inst.gsl_blas_ddot ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_row.c_pointer + {PD_GSL_VECTOR_CONST_VIEW}.vector_offset)), a_c___1, create {CE_POINTER [REAL_64]}.make_shared ($l_y_est)).do_nothing
					l_ri := l_yi - l_y_est
					gsl_gsl_vector_double_inst.gsl_vector_set (a_r___3, l_i, l_ri)
					l_i := l_i + 1
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

end
