class
	P_NONSYMM

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_eigen_nonsymm_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_EIGEN_NONSYMM_WORKSPACE]
		local
			l_w: CE_POINTER [PD_GSL_EIGEN_NONSYMM_WORKSPACE]
			js: JUMP_STATE
		do
			create l_w.make

			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix dimension must be positive integer"), ce_string ("nonsymm.c"), 61, 4)
					Result := (create {CE_POINTER [PD_GSL_EIGEN_NONSYMM_WORKSPACE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_w.ce_gets (create {CE_POINTER [PD_GSL_EIGEN_NONSYMM_WORKSPACE]}.make_cast ((calloc ((1).to_natural_32, {PD_GSL_EIGEN_NONSYMM_WORKSPACE}.sizeof.to_natural_32))))
				if (l_w.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for workspace"), ce_string ("nonsymm.c"), 69, 8)
						Result := (create {CE_POINTER [PD_GSL_EIGEN_NONSYMM_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_w.item.size := a_n
				l_w.item.Z := create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
				l_w.item.do_balance := 0
				l_w.item.diag := init_source_inst.gsl_vector_alloc (a_n)
				if ((l_w.item.diag).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					gsl_eigen_nonsymm_free (l_w)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for balancing vector"), ce_string ("nonsymm.c"), 81, 8)
						Result := (create {CE_POINTER [PD_GSL_EIGEN_NONSYMM_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_w.item.tau := init_source_inst.gsl_vector_alloc (a_n)
				if ((l_w.item.tau).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					gsl_eigen_nonsymm_free (l_w)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for hessenberg coefficients"), ce_string ("nonsymm.c"), 89, 8)
						Result := (create {CE_POINTER [PD_GSL_EIGEN_NONSYMM_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_w.item.francis_workspace_p := francis_inst.gsl_eigen_francis_alloc
				if ((l_w.item.francis_workspace_p).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					gsl_eigen_nonsymm_free (l_w)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for francis workspace"), ce_string ("nonsymm.c"), 97, 8)
						Result := (create {CE_POINTER [PD_GSL_EIGEN_NONSYMM_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				Result := l_w
			end
		end

	gsl_eigen_nonsymm_free (a_w: CE_POINTER [PD_GSL_EIGEN_NONSYMM_WORKSPACE])
		local
			js: JUMP_STATE
		do
			if (a_w).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				if ((a_w.item.tau).c_pointer /= default_pointer) then
					init_source_inst.gsl_vector_free (a_w.item.tau)
				end
				if ((a_w.item.diag).c_pointer /= default_pointer) then
					init_source_inst.gsl_vector_free (a_w.item.diag)
				end
				if ((a_w.item.francis_workspace_p).c_pointer /= default_pointer) then
					francis_inst.gsl_eigen_francis_free (a_w.item.francis_workspace_p)
				end
				free (create {CE_POINTER [ANY]}.make_cast (a_w))
			end
		end

	gsl_eigen_nonsymm_params (a_compute_t: INTEGER_32; a_balance: INTEGER_32; a_w: CE_POINTER [PD_GSL_EIGEN_NONSYMM_WORKSPACE])
		do
			francis_inst.gsl_eigen_francis_T (a_compute_t, a_w.item.francis_workspace_p)
			a_w.item.do_balance := a_balance
		end

	gsl_eigen_nonsymm (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_eval: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_w: CE_POINTER [PD_GSL_EIGEN_NONSYMM_WORKSPACE]): INTEGER_32
		local
			l_N: NATURAL_32
			l_s: INTEGER_32
			js: JUMP_STATE
		do
			l_N := a_A___0.item.size1
			if l_N /= a_A___0.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix must be square to compute eigenvalues"), ce_string ("nonsymm.c"), 181, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_eval.item.size /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("eigenvalue vector must match matrix size"), ce_string ("nonsymm.c"), 185, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				if (a_w.item.do_balance).to_boolean then
					balancemat_inst.gsl_linalg_balance_matrix (a_A___0, a_w.item.diag).do_nothing
				end
				hessenberg_inst.gsl_linalg_hessenberg_decomp (a_A___0, a_w.item.tau).do_nothing
				if ((a_w.item.Z).c_pointer /= default_pointer) then
					hessenberg_inst.gsl_linalg_hessenberg_unpack (a_A___0, a_w.item.tau, a_w.item.Z).do_nothing
					l_s := francis_inst.gsl_eigen_francis_Z (a_A___0, a_eval, a_w.item.Z, a_w.item.francis_workspace_p)
					if (a_w.item.do_balance).to_boolean then
						balancemat_inst.gsl_linalg_balance_accum (a_w.item.Z, a_w.item.diag).do_nothing
					end
				else
					l_s := francis_inst.gsl_eigen_francis (a_A___0, a_eval, a_w.item.francis_workspace_p)
				end
				a_w.item.n_evals := (a_w.item.francis_workspace_p).item.n_evals
				Result := l_s
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_eigen_nonsymm_Z (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_eval: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_Z: CE_POINTER [PD_GSL_MATRIX]; a_w: CE_POINTER [PD_GSL_EIGEN_NONSYMM_WORKSPACE]): INTEGER_32
		local
			l_s: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_A___0.item.size1 = a_A___0.item.size2 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix must be square to compute eigenvalues"), ce_string ("nonsymm.c"), 271, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if a_eval.item.size = a_A___0.item.size1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("eigenvalue vector must match matrix size"), ce_string ("nonsymm.c"), 275, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if a_Z.item.size1 = a_Z.item.size2 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if a_Z.item.size1 = a_A___0.item.size1 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("Z matrix has wrong dimensions"), ce_string ("nonsymm.c"), 279, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						a_w.item.Z := a_Z
						l_s := gsl_eigen_nonsymm (a_A___0, a_eval, a_w)
						a_w.item.Z := create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
						Result := l_s
						js.return
				when 13 then -- if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
