class
	P_NONSYMMV

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_eigen_nonsymmv_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_EIGEN_NONSYMMV_WORKSPACE]
		local
			l_w: CE_POINTER [PD_GSL_EIGEN_NONSYMMV_WORKSPACE]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_w.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_n = {NATURAL_32} 0 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix dimension must be positive integer"), ce_string ("nonsymmv.c"), 73, 4)
							Result := (create {CE_POINTER [PD_GSL_EIGEN_NONSYMMV_WORKSPACE]}.make_shared (default_pointer))
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_w.ce_gets (create {CE_POINTER [PD_GSL_EIGEN_NONSYMMV_WORKSPACE]}.make_cast ((calloc ((1).to_natural_32, {PD_GSL_EIGEN_NONSYMMV_WORKSPACE}.sizeof.to_natural_32))))
						if (l_w.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("failed to allocate space for workspace"), ce_string ("nonsymmv.c"), 81, 8)
								Result := (create {CE_POINTER [PD_GSL_EIGEN_NONSYMMV_WORKSPACE]}.make_shared (default_pointer))
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
					end
					if not js.return_called then
						l_w.item.size := a_n
						l_w.item.Z := create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
						l_w.item.nonsymm_workspace_p := nonsymm_inst.gsl_eigen_nonsymm_alloc (a_n)
						if ((l_w.item.nonsymm_workspace_p).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							gsl_eigen_nonsymmv_free (l_w)
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("failed to allocate space for nonsymm workspace"), ce_string ("nonsymmv.c"), 91, 8)
								Result := (create {CE_POINTER [PD_GSL_EIGEN_NONSYMMV_WORKSPACE]}.make_shared (default_pointer))
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						nonsymm_inst.gsl_eigen_nonsymm_params (1, 1, l_w.item.nonsymm_workspace_p)
						l_w.item.work := init_source_inst.gsl_vector_alloc (a_n)
						l_w.item.work2 := init_source_inst.gsl_vector_alloc (a_n)
						l_w.item.work3 := init_source_inst.gsl_vector_alloc (a_n)
						if ((l_w.item.work).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 4 then -- else:
						if ((l_w.item.work2).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if ((l_w.item.work3).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						gsl_eigen_nonsymmv_free (l_w)
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("failed to allocate space for nonsymmv additional workspace"), ce_string ("nonsymmv.c"), 106, 8)
							Result := (create {CE_POINTER [PD_GSL_EIGEN_NONSYMMV_WORKSPACE]}.make_shared (default_pointer))
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 9 then -- if done | if done | if done
						if not js.return_called then
							Result := l_w
						end
				when 10 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_eigen_nonsymmv_free (a_w: CE_POINTER [PD_GSL_EIGEN_NONSYMMV_WORKSPACE])
		local
			js: JUMP_STATE
		do
			if (a_w).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				if ((a_w.item.nonsymm_workspace_p).c_pointer /= default_pointer) then
					nonsymm_inst.gsl_eigen_nonsymm_free (a_w.item.nonsymm_workspace_p)
				end
				if ((a_w.item.work).c_pointer /= default_pointer) then
					init_source_inst.gsl_vector_free (a_w.item.work)
				end
				if ((a_w.item.work2).c_pointer /= default_pointer) then
					init_source_inst.gsl_vector_free (a_w.item.work2)
				end
				if ((a_w.item.work3).c_pointer /= default_pointer) then
					init_source_inst.gsl_vector_free (a_w.item.work3)
				end
				free (create {CE_POINTER [ANY]}.make_cast (a_w))
			end
		end

	gsl_eigen_nonsymmv (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_eval: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_evec: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_w: CE_POINTER [PD_GSL_EIGEN_NONSYMMV_WORKSPACE]): INTEGER_32
		local
			l_N: NATURAL_32
			l_s: INTEGER_32
			l_Z: PD_GSL_MATRIX
			js: JUMP_STATE
		do
			create l_Z.make

			l_N := a_A___0.item.size1
			if l_N /= a_A___0.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix must be square to compute eigenvalues"), ce_string ("nonsymmv.c"), 165, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_eval.item.size /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("eigenvalue vector must match matrix size"), ce_string ("nonsymmv.c"), 169, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_evec.item.size1 /= a_evec.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("eigenvector matrix must be square"), ce_string ("nonsymmv.c"), 173, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_evec.item.size1 /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("eigenvector matrix has wrong size"), ce_string ("nonsymmv.c"), 177, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_Z.size1 := l_N
				l_Z.size2 := l_N
				l_Z.tda := {NATURAL_32} 2 * l_N
				l_Z.data := a_evec.item.data
				l_Z.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_Z.owner := 0
				l_s := nonsymm_inst.gsl_eigen_nonsymm_Z (a_A___0, a_eval, l_Z.address, a_w.item.nonsymm_workspace_p)
				if ((a_w.item.Z).c_pointer /= default_pointer) then
					copy_source_inst.gsl_matrix_memcpy (a_w.item.Z, (l_Z.address)).do_nothing
				end
				if l_s = 0 then
					nonsymmv_get_right_eigenvectors (a_A___0, l_Z.address, a_eval, a_evec, a_w)
					nonsymmv_normalize_eigenvectors (a_eval, a_evec)
				end
				Result := l_s
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_eigen_nonsymmv_Z (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_eval: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_evec: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_Z: CE_POINTER [PD_GSL_MATRIX]; a_w: CE_POINTER [PD_GSL_EIGEN_NONSYMMV_WORKSPACE]): INTEGER_32
		local
			l_s: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_A___0.item.size1 = a_A___0.item.size2 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("matrix must be square to compute eigenvalues/eigenvectors"), ce_string ("nonsymmv.c"), 247, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 3 then -- else:
						if a_eval.item.size = a_A___0.item.size1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("eigenvalue vector must match matrix size"), ce_string ("nonsymmv.c"), 251, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 6 then -- else:
						if a_evec.item.size1 = a_evec.item.size2 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("eigenvector matrix must be square"), ce_string ("nonsymmv.c"), 255, 20)
							Result := 20
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 9 then -- else:
						if a_evec.item.size1 = a_A___0.item.size1 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("eigenvector matrix has wrong size"), ce_string ("nonsymmv.c"), 259, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 12 then -- else:
						if a_Z.item.size1 = a_Z.item.size2 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 15 then -- else:
						if a_Z.item.size1 = a_A___0.item.size1 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("Z matrix has wrong dimensions"), ce_string ("nonsymmv.c"), 263, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						a_w.item.Z := a_Z
						l_s := gsl_eigen_nonsymmv (a_A___0, a_eval, a_evec, a_w)
						a_w.item.Z := create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
						Result := l_s
						js.return
				when 19 then -- if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 20 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	nonsymmv_get_right_eigenvectors (a_T: CE_POINTER [PD_GSL_MATRIX]; a_Z: CE_POINTER [PD_GSL_MATRIX]; a_eval: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_evec: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_w: CE_POINTER [PD_GSL_EIGEN_NONSYMMV_WORKSPACE])
		local
			l_N: NATURAL_32
			l_smlnum: REAL_64
			l_bignum: REAL_64
			l_i: INTEGER_32
			l_iu: NATURAL_32
			l_ju: NATURAL_32
			l_ii: NATURAL_32
			l_lambda: PD_GSL_COMPLEX
			l_lambda_re: REAL_64
			l_lambda_im: REAL_64
			l_Tv: PD_GSL_MATRIX_VIEW
			l_Zv: PD_GSL_MATRIX_VIEW
			l_y: PD_GSL_VECTOR_VIEW
			l_y2: PD_GSL_VECTOR_VIEW
			l_ev: PD_GSL_VECTOR_VIEW
			l_ev2: PD_GSL_VECTOR_VIEW
			l_dat: CE_ARRAY [REAL_64]
			l_dat_X: CE_ARRAY [REAL_64]
			l_scale: REAL_64
			l_xnorm: REAL_64
			l_ecol: PD_GSL_VECTOR_COMPLEX_VIEW
			l_ecol2: PD_GSL_VECTOR_COMPLEX_VIEW
			l_complex_pair: INTEGER_32
			l_smin: REAL_64
			l_tmp: REAL_64
			l_tmp___4: REAL_64
			l_tmp___11: REAL_64
			l_tmp___13: REAL_64
			l_k: INTEGER_32
			l_l: INTEGER_32
			l_bv: PD_GSL_VECTOR_VIEW
			l_xv: PD_GSL_VECTOR_VIEW
			l_lu: NATURAL_32
			l_x: REAL_64
			l_wv: PD_GSL_VECTOR_VIEW
			l_v1: PD_GSL_VECTOR_VIEW
			l_v2: PD_GSL_VECTOR_VIEW
			l_x11___0: REAL_64
			l_x21: REAL_64
			l_beta: REAL_64
			l_tmp___25: REAL_64
			l_wv___0: PD_GSL_VECTOR_VIEW
			l_v1___0: PD_GSL_VECTOR_VIEW
			l_v2___0: PD_GSL_VECTOR_VIEW
			l_x___0: PD_GSL_VECTOR_VIEW
			l_a___5: REAL_64
			l_bv___0: PD_GSL_VECTOR_COMPLEX_VIEW
			l_xv___0: PD_GSL_VECTOR_COMPLEX_VIEW
			l_k___0: NATURAL_32
			l_l___0: INTEGER_32
			l_lambda2: PD_GSL_COMPLEX
			l_tmp___33: REAL_64
			l_tmp___36: REAL_64
			l_tmp___38: REAL_64
			l_lu___0: NATURAL_32
			l_bval: PD_GSL_COMPLEX
			l_x___1: PD_GSL_COMPLEX
			l_wv___1: PD_GSL_VECTOR_VIEW
			l_v1___1: PD_GSL_VECTOR_VIEW
			l_v2___1: PD_GSL_VECTOR_VIEW
			l_b1___0: PD_GSL_COMPLEX
			l_b2: PD_GSL_COMPLEX
			l_x1___0: PD_GSL_COMPLEX
			l_x2___1: PD_GSL_COMPLEX
			l_beta___0: REAL_64
			l_tmp___46: REAL_64
			l_wv___2: PD_GSL_VECTOR_VIEW
			l_v1___2: PD_GSL_VECTOR_VIEW
			l_v2___2: PD_GSL_VECTOR_VIEW
			l_v3: PD_GSL_VECTOR_VIEW
			l_v4: PD_GSL_VECTOR_VIEW
			l_x___2: PD_GSL_VECTOR_VIEW
			l_a___6: REAL_64
			l_tmp___56: REAL_64
			l_tmp___59: REAL_64
			l_a___7: REAL_64
			js: JUMP_STATE
		do
			create l_lambda.make
			create l_Tv.make
			create l_Zv.make
			create l_y.make
			create l_y2.make
			create l_ev.make
			create l_ev2.make
			create l_dat.make (<<4>>)
			create l_dat_X.make (<<4>>)
			create l_ecol.make
			create l_ecol2.make
			create l_bv.make
			create l_xv.make
			create l_wv.make
			create l_v1.make
			create l_v2.make
			create l_wv___0.make
			create l_v1___0.make
			create l_v2___0.make
			create l_x___0.make
			create l_bv___0.make
			create l_xv___0.make
			create l_lambda2.make
			create l_bval.make
			create l_x___1.make
			create l_wv___1.make
			create l_v1___1.make
			create l_v2___1.make
			create l_b1___0.make
			create l_b2.make
			create l_x1___0.make
			create l_x2___1.make
			create l_wv___2.make
			create l_v1___2.make
			create l_v2___2.make
			create l_v3.make
			create l_v4.make
			create l_x___2.make

			l_N := a_T.item.size1
			l_smlnum := (2.2250738585072014e-308 * l_N.to_real_64) / 2.2204460492503131e-16
			l_bignum := (1.0 - 2.2204460492503131e-16) / l_smlnum
			gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work3, (0).to_natural_32, 0.0)
			l_ju := (1).to_natural_32
			from
			until
				not (not js.loop_left and then (l_ju < l_N))
			loop
				gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work3, l_ju, 0.0)
				l_iu := (0).to_natural_32
				from
				until
					not (l_iu < l_ju)
				loop
					l_tmp := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_ju)
					gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work3, l_ju, l_tmp + (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_iu, l_ju)))))
					l_iu := l_iu + 1
				end
				l_ju := l_ju + 1
			end
			l_i := l_N.to_integer_32 - 1
			from
			until
				not (not js.loop_left and then (l_i >= 0))
			loop
				l_iu := l_i.to_natural_32
				l_lambda_re := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_iu, l_iu)
				if l_iu /= {NATURAL_32} 0 then
					if (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_iu, l_iu - {NATURAL_32} 1)) /= 0.0 then
						l_tmp___4 := sqrt ((fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_iu, l_iu - {NATURAL_32} 1)))))
						l_lambda_im := l_tmp___4 * (sqrt ((fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_iu - {NATURAL_32} 1, l_iu))))))
					else
						l_lambda_im := 0.0
					end
				else
					l_lambda_im := 0.0
				end
				from
				until
					js.loop_left
				loop
					js.reset
					l_lambda.dat[0] := l_lambda_re
					l_lambda.dat[1] := l_lambda_im
					js.break
				end
				js.reset
				l_tmp___13 := fabs (l_lambda_re)
				if 2.2204460492503131e-16 * (l_tmp___13 + (fabs (l_lambda_im))) > l_smlnum then
					l_tmp___11 := fabs (l_lambda_re)
					l_smin := 2.2204460492503131e-16 * (l_tmp___11 + (fabs (l_lambda_im)))
				else
					l_smin := l_smlnum
				end
				if l_smin > 2.0 * 2.2250738585072014e-308 then
					l_smin := l_smin
				else
					l_smin := 2.0 * 2.2250738585072014e-308
				end
				if l_lambda_im = 0.0 then
					gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_eval, l_iu, l_lambda)
					l_k := 0
					from
					until
						not (l_k < l_i)
					loop
						gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work, l_k.to_natural_32, -(gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_k.to_natural_32, l_iu)))
						l_k := l_k + 1
					end
					gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work, l_iu, 1.0)
					l_l := l_i - 1
					from
					until
						not (l_l >= 0)
					loop
						l_lu := l_l.to_natural_32
						if l_lu = {NATURAL_32} 0 then
							l_complex_pair := 0
						else
							l_complex_pair := ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_lu, l_lu - {NATURAL_32} 1)) /= 0.0).to_integer
						end
						if not l_complex_pair.to_boolean then
							l_Tv.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_T, l_lu, l_lu, (1).to_natural_32, (1).to_natural_32))
							l_bv.ce_gets (view_source_inst.gsl_vector_view_array (l_dat, (1).to_natural_32))
							gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_bv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), (0).to_natural_32, (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work, l_lu)))
							l_xv.ce_gets (view_source_inst.gsl_vector_view_array (l_dat_X, (1).to_natural_32))
							schur_inst.gsl_schur_solve_equation (1.0, (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_Tv.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), l_lambda_re, 1.0, 1.0, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_bv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [REAL_64]}.make_shared ($l_scale), create {CE_POINTER [REAL_64]}.make_shared ($l_xnorm), l_smin).do_nothing
							l_x := gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), (0).to_natural_32)
							if l_xnorm > 1.0 then
								if (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_lu)) > l_bignum / l_xnorm then
									l_x := l_x / l_xnorm
									l_scale := l_scale / l_xnorm
								end
							end
							if l_scale /= 1.0 then
								l_wv.ce_gets (subvector_source_inst.gsl_vector_subvector (a_w.item.work, (0).to_natural_32, l_iu + {NATURAL_32} 1))
								blas_inst.gsl_blas_dscal (l_scale, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_wv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))
							end
							gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work, l_lu, l_x)
							if l_lu > {NATURAL_32} 0 then
								l_v1.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_T, l_lu, (0).to_natural_32, l_lu))
								l_v2.ce_gets (subvector_source_inst.gsl_vector_subvector (a_w.item.work, (0).to_natural_32, l_lu))
								blas_inst.gsl_blas_daxpy (-l_x, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v1.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)).do_nothing
							end
						else
							l_Tv.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_T, l_lu - {NATURAL_32} 1, l_lu - {NATURAL_32} 1, (2).to_natural_32, (2).to_natural_32))
							l_bv.ce_gets (view_source_inst.gsl_vector_view_array (l_dat, (2).to_natural_32))
							gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_bv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), (0).to_natural_32, (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work, l_lu - {NATURAL_32} 1)))
							gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_bv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), (1).to_natural_32, (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work, l_lu)))
							l_xv.ce_gets (view_source_inst.gsl_vector_view_array (l_dat_X, (2).to_natural_32))
							schur_inst.gsl_schur_solve_equation (1.0, (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_Tv.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), l_lambda_re, 1.0, 1.0, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_bv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [REAL_64]}.make_shared ($l_scale), create {CE_POINTER [REAL_64]}.make_shared ($l_xnorm), l_smin).do_nothing
							l_x11___0 := gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), (0).to_natural_32)
							l_x21 := gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_xv.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), (1).to_natural_32)
							if l_xnorm > 1.0 then
								l_tmp___25 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_lu - {NATURAL_32} 1)
								if l_tmp___25 > (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_lu)) then
									l_beta := (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_lu - {NATURAL_32} 1))
								else
									l_beta := (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_lu))
								end
								if l_beta > l_bignum / l_xnorm then
									l_x11___0 := l_x11___0 / l_xnorm
									l_x21 := l_x21 / l_xnorm
									l_scale := l_scale / l_xnorm
								end
							end
							if l_scale /= 1.0 then
								l_wv___0.ce_gets (subvector_source_inst.gsl_vector_subvector (a_w.item.work, (0).to_natural_32, l_iu + {NATURAL_32} 1))
								blas_inst.gsl_blas_dscal (l_scale, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_wv___0.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))
							end
							gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work, l_lu - {NATURAL_32} 1, l_x11___0)
							gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work, l_lu, l_x21)
							if l_lu > {NATURAL_32} 1 then
								l_v1___0.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_T, l_lu - {NATURAL_32} 1, (0).to_natural_32, l_lu - {NATURAL_32} 1))
								l_v2___0.ce_gets (subvector_source_inst.gsl_vector_subvector (a_w.item.work, (0).to_natural_32, l_lu - {NATURAL_32} 1))
								blas_inst.gsl_blas_daxpy (-l_x11___0, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v1___0.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2___0.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)).do_nothing
								l_v1___0.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_T, l_lu, (0).to_natural_32, l_lu - {NATURAL_32} 1))
								blas_inst.gsl_blas_daxpy (-l_x21, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v1___0.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2___0.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)).do_nothing
							end
							l_l := l_l - 1
						end
						l_l := l_l - 1
					end
					l_ecol.ce_gets (rowcol_source_inst.gsl_matrix_complex_column (a_evec, l_iu))
					l_y.ce_gets (rowcol_source_inst.gsl_matrix_column (a_Z, l_iu))
					if l_iu > {NATURAL_32} 0 then
						l_Zv.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_Z, (0).to_natural_32, (0).to_natural_32, l_N, l_iu))
						l_x___0.ce_gets (subvector_source_inst.gsl_vector_subvector (a_w.item.work, (0).to_natural_32, l_iu))
						blas_inst.gsl_blas_dgemv ({PC_CBLAS_TRANSPOSE}.CblasNoTrans, 1.0, (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_Zv.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_x___0.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work, l_iu)), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_y.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)).do_nothing
					end
					l_ev.ce_gets (reim_source_inst.gsl_vector_complex_real (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_ecol.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)))
					l_ev2.ce_gets (reim_source_inst.gsl_vector_complex_imag (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_ecol.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)))
					l_scale := 0.0
					l_ii := (0).to_natural_32
					from
					until
						not (l_ii < l_N)
					loop
						l_a___5 := (gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_y.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), l_ii))
						gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_ev.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_ii, l_a___5)
						gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_ev2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_ii, 0.0)
						if (fabs (l_a___5)) > l_scale then
							l_scale := fabs (l_a___5)
						end
						l_ii := l_ii + 1
					end
					if l_scale /= 0.0 then
						l_scale := 1.0 / l_scale
					end
					blas_inst.gsl_blas_dscal (l_scale, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_ev.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))
				else
					from
					until
						js.loop_left
					loop
						js.reset
						l_lambda2.dat[0] := l_lambda.dat[0]
						js.break
					end
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						l_lambda2.dat[1] := -l_lambda.dat[1]
						js.break
					end
					js.reset
					gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_eval, l_iu - {NATURAL_32} 1, l_lambda)
					gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_eval, l_iu, l_lambda2)
					l_tmp___33 := fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_iu - {NATURAL_32} 1, l_iu)))
					if l_tmp___33 >= (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_iu, l_iu - {NATURAL_32} 1)))) then
						gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work, l_iu - {NATURAL_32} 1, 1.0)
						gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work2, l_iu, l_lambda_im / (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_iu - {NATURAL_32} 1, l_iu)))
					else
						gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work, l_iu - {NATURAL_32} 1, -l_lambda_im / (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_iu, l_iu - {NATURAL_32} 1)))
						gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work2, l_iu, 1.0)
					end
					gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work, l_iu, 0.0)
					gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work2, l_iu - {NATURAL_32} 1, 0.0)
					l_k___0 := (0).to_natural_32
					from
					until
						not (l_k___0 < l_iu - {NATURAL_32} 1)
					loop
						l_tmp___36 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work, l_iu - {NATURAL_32} 1)
						gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work, l_k___0, -l_tmp___36 * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_k___0, l_iu - {NATURAL_32} 1)))
						l_tmp___38 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work2, l_iu)
						gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work2, l_k___0, -l_tmp___38 * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_k___0, l_iu)))
						l_k___0 := l_k___0 + 1
					end
					l_l___0 := l_i - 2
					from
					until
						not (not js.loop_left and then (l_l___0 >= 0))
					loop
						l_lu___0 := l_l___0.to_natural_32
						if l_lu___0 = {NATURAL_32} 0 then
							l_complex_pair := 0
						else
							l_complex_pair := ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_T, l_lu___0, l_lu___0 - {NATURAL_32} 1)) /= 0.0).to_integer
						end
						if not l_complex_pair.to_boolean then
							l_Tv.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_T, l_lu___0, l_lu___0, (1).to_natural_32, (1).to_natural_32))
							l_bv___0.ce_gets (view_source_inst.gsl_vector_complex_view_array (l_dat, (1).to_natural_32))
							l_xv___0.ce_gets (view_source_inst.gsl_vector_complex_view_array (l_dat_X, (1).to_natural_32))
							from
							until
								js.loop_left
							loop
								js.reset
								l_bval.dat[0] := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work, l_lu___0)
								l_bval.dat[1] := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work2, l_lu___0)
								js.break
							end
							js.reset
							gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_bv___0.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset), (0).to_natural_32, l_bval)
							schur_inst.gsl_schur_solve_equation_z (1.0, (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_Tv.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), l_lambda.address, 1.0, 1.0, (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_bv___0.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_xv___0.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset), create {CE_POINTER [REAL_64]}.make_shared ($l_scale), create {CE_POINTER [REAL_64]}.make_shared ($l_xnorm), l_smin).do_nothing
							if l_xnorm > 1.0 then
								if (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_lu___0)) > l_bignum / l_xnorm then
									blas_inst.gsl_blas_zdscal (1.0 / l_xnorm, create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_xv___0.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset))
									l_scale := l_scale / l_xnorm
								end
							end
							if l_scale /= 1.0 then
								l_wv___1.ce_gets (subvector_source_inst.gsl_vector_subvector (a_w.item.work, (0).to_natural_32, l_iu + {NATURAL_32} 1))
								blas_inst.gsl_blas_dscal (l_scale, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_wv___1.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))
								l_wv___1.ce_gets (subvector_source_inst.gsl_vector_subvector (a_w.item.work2, (0).to_natural_32, l_iu + {NATURAL_32} 1))
								blas_inst.gsl_blas_dscal (l_scale, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_wv___1.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))
							end
							l_x___1.ce_gets (gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get ((create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_xv___0.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)), (0).to_natural_32))
							gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work, l_lu___0, l_x___1.dat[0])
							gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work2, l_lu___0, l_x___1.dat[1])
							if l_lu___0 > {NATURAL_32} 0 then
								l_v1___1.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_T, l_lu___0, (0).to_natural_32, l_lu___0))
								l_v2___1.ce_gets (subvector_source_inst.gsl_vector_subvector (a_w.item.work, (0).to_natural_32, l_lu___0))
								blas_inst.gsl_blas_daxpy (-l_x___1.dat[0], (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v1___1.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2___1.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)).do_nothing
								l_v2___1.ce_gets (subvector_source_inst.gsl_vector_subvector (a_w.item.work2, (0).to_natural_32, l_lu___0))
								blas_inst.gsl_blas_daxpy (-l_x___1.dat[1], (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v1___1.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2___1.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)).do_nothing
							end
						else
							l_Tv.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_T, l_lu___0 - {NATURAL_32} 1, l_lu___0 - {NATURAL_32} 1, (2).to_natural_32, (2).to_natural_32))
							l_bv___0.ce_gets (view_source_inst.gsl_vector_complex_view_array (l_dat, (2).to_natural_32))
							l_xv___0.ce_gets (view_source_inst.gsl_vector_complex_view_array (l_dat_X, (2).to_natural_32))
							from
							until
								js.loop_left
							loop
								js.reset
								l_b1___0.dat[0] := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work, l_lu___0 - {NATURAL_32} 1)
								l_b1___0.dat[1] := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work2, l_lu___0 - {NATURAL_32} 1)
								js.break
							end
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								l_b2.dat[0] := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work, l_lu___0)
								l_b2.dat[1] := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work2, l_lu___0)
								js.break
							end
							js.reset
							gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_bv___0.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset), (0).to_natural_32, l_b1___0)
							gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_bv___0.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset), (1).to_natural_32, l_b2)
							schur_inst.gsl_schur_solve_equation_z (1.0, (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_Tv.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), l_lambda.address, 1.0, 1.0, (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_bv___0.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_xv___0.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset), create {CE_POINTER [REAL_64]}.make_shared ($l_scale), create {CE_POINTER [REAL_64]}.make_shared ($l_xnorm), l_smin).do_nothing
							l_x1___0.ce_gets (gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get ((create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_xv___0.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)), (0).to_natural_32))
							l_x2___1.ce_gets (gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get ((create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_xv___0.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)), (1).to_natural_32))
							if l_xnorm > 1.0 then
								l_tmp___46 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_lu___0 - {NATURAL_32} 1)
								if l_tmp___46 > (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_lu___0)) then
									l_beta___0 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_lu___0 - {NATURAL_32} 1))
								else
									l_beta___0 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work3, l_lu___0))
								end
								if l_beta___0 > l_bignum / l_xnorm then
									blas_inst.gsl_blas_zdscal (1.0 / l_xnorm, create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_xv___0.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset))
									l_scale := l_scale / l_xnorm
								end
							end
							if l_scale /= 1.0 then
								l_wv___2.ce_gets (subvector_source_inst.gsl_vector_subvector (a_w.item.work, (0).to_natural_32, l_iu + {NATURAL_32} 1))
								blas_inst.gsl_blas_dscal (l_scale, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_wv___2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))
								l_wv___2.ce_gets (subvector_source_inst.gsl_vector_subvector (a_w.item.work2, (0).to_natural_32, l_iu + {NATURAL_32} 1))
								blas_inst.gsl_blas_dscal (l_scale, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_wv___2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))
							end
							gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work, l_lu___0 - {NATURAL_32} 1, l_x1___0.dat[0])
							gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work, l_lu___0, l_x2___1.dat[0])
							gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work2, l_lu___0 - {NATURAL_32} 1, l_x1___0.dat[1])
							gsl_gsl_vector_double_inst.gsl_vector_set (a_w.item.work2, l_lu___0, l_x2___1.dat[1])
							if l_lu___0 > {NATURAL_32} 1 then
								l_v1___2.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_T, l_lu___0 - {NATURAL_32} 1, (0).to_natural_32, l_lu___0 - {NATURAL_32} 1))
								l_v4.ce_gets (rowcol_source_inst.gsl_matrix_subcolumn (a_T, l_lu___0, (0).to_natural_32, l_lu___0 - {NATURAL_32} 1))
								l_v2___2.ce_gets (subvector_source_inst.gsl_vector_subvector (a_w.item.work, (0).to_natural_32, l_lu___0 - {NATURAL_32} 1))
								l_v3.ce_gets (subvector_source_inst.gsl_vector_subvector (a_w.item.work2, (0).to_natural_32, l_lu___0 - {NATURAL_32} 1))
								blas_inst.gsl_blas_daxpy (-l_x1___0.dat[0], (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v1___2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2___2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)).do_nothing
								blas_inst.gsl_blas_daxpy (-l_x2___1.dat[0], (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v4.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v2___2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)).do_nothing
								blas_inst.gsl_blas_daxpy (-l_x1___0.dat[1], (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v1___2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)).do_nothing
								blas_inst.gsl_blas_daxpy (-l_x2___1.dat[1], (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v4.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_v3.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)).do_nothing
							end
							l_l___0 := l_l___0 - 1
						end
						l_l___0 := l_l___0 - 1
					end
					l_y.ce_gets (rowcol_source_inst.gsl_matrix_column (a_Z, l_iu - {NATURAL_32} 1))
					l_y2.ce_gets (rowcol_source_inst.gsl_matrix_column (a_Z, l_iu))
					if l_iu > {NATURAL_32} 1 then
						l_Zv.ce_gets (submatrix_source_inst.gsl_matrix_submatrix (a_Z, (0).to_natural_32, (0).to_natural_32, l_N, l_iu - {NATURAL_32} 1))
						l_x___2.ce_gets (subvector_source_inst.gsl_vector_subvector (a_w.item.work, (0).to_natural_32, l_iu - {NATURAL_32} 1))
						blas_inst.gsl_blas_dgemv ({PC_CBLAS_TRANSPOSE}.CblasNoTrans, 1.0, (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_Zv.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_x___2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work, l_iu - {NATURAL_32} 1)), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_y.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)).do_nothing
						l_x___2.ce_gets (subvector_source_inst.gsl_vector_subvector (a_w.item.work2, (0).to_natural_32, l_iu - {NATURAL_32} 1))
						blas_inst.gsl_blas_dgemv ({PC_CBLAS_TRANSPOSE}.CblasNoTrans, 1.0, (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_Zv.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)), (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_x___2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), (gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work2, l_iu)), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_y2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)).do_nothing
					else
						blas_inst.gsl_blas_dscal ((gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work, l_iu - {NATURAL_32} 1)), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_y.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))
						blas_inst.gsl_blas_dscal ((gsl_gsl_vector_double_inst.gsl_vector_get (a_w.item.work2, l_iu)), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_y2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))
					end
					l_ecol.ce_gets (rowcol_source_inst.gsl_matrix_complex_column (a_evec, l_iu - {NATURAL_32} 1))
					l_ecol2.ce_gets (rowcol_source_inst.gsl_matrix_complex_column (a_evec, l_iu))
					l_ev.ce_gets (reim_source_inst.gsl_vector_complex_imag (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_ecol.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)))
					l_ev2.ce_gets (reim_source_inst.gsl_vector_complex_imag (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_ecol2.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)))
					l_scale := 0.0
					l_ii := (0).to_natural_32
					from
					until
						not (l_ii < l_N)
					loop
						l_a___6 := (gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_y2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), l_ii))
						l_tmp___59 := fabs (l_a___6)
						if l_scale > l_tmp___59 + (fabs ((gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_y.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), l_ii)))) then
							l_scale := l_scale
						else
							l_tmp___56 := fabs (l_a___6)
							l_scale := l_tmp___56 + (fabs ((gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_y.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), l_ii))))
						end
						gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_ev.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_ii, l_a___6)
						gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_ev2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_ii, -l_a___6)
						l_ii := l_ii + 1
					end
					l_ev.ce_gets (reim_source_inst.gsl_vector_complex_real (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_ecol.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)))
					l_ev2.ce_gets (reim_source_inst.gsl_vector_complex_real (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_ecol2.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)))
					l_ii := (0).to_natural_32
					from
					until
						not (l_ii < l_N)
					loop
						l_a___7 := (gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_y.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), l_ii))
						gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_ev.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_ii, l_a___7)
						gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_ev2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_ii, l_a___7)
						l_ii := l_ii + 1
					end
					if l_scale /= 0.0 then
						l_scale := 1.0 / l_scale
					end
					blas_inst.gsl_blas_zdscal (l_scale, create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_ecol.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset))
					blas_inst.gsl_blas_zdscal (l_scale, create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_ecol2.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset))
					l_i := l_i - 1
				end
				l_i := l_i - 1
			end
		end

	nonsymmv_normalize_eigenvectors (a_eval: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_evec: CE_POINTER [PD_GSL_MATRIX_COMPLEX])
		local
			l_N: NATURAL_32
			l_i: NATURAL_32
			l_ei: PD_GSL_COMPLEX
			l_vi: PD_GSL_VECTOR_COMPLEX_VIEW
			l_re: PD_GSL_VECTOR_VIEW
			l_im: PD_GSL_VECTOR_VIEW
			l_scale: REAL_64
			l_tmp___0: REAL_64
		do
			create l_ei.make
			create l_vi.make
			create l_re.make
			create l_im.make

			l_N := a_evec.item.size1
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_N)
			loop
				l_ei.ce_gets (gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_eval, l_i))
				l_vi.ce_gets (rowcol_source_inst.gsl_matrix_complex_column (a_evec, l_i))
				l_re.ce_gets (reim_source_inst.gsl_vector_complex_real (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_vi.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)))
				if l_ei.dat[1] = 0.0 then
					l_scale := 1.0 / (blas_inst.gsl_blas_dnrm2 ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_re.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))))
					blas_inst.gsl_blas_dscal (l_scale, create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_re.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))
				elseif l_ei.dat[1] > 0.0 then
					l_im.ce_gets (reim_source_inst.gsl_vector_complex_imag (create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_vi.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset)))
					l_tmp___0 := blas_inst.gsl_blas_dnrm2 ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_im.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)))
					l_scale := 1.0 / (hypot_inst.gsl_hypot ((blas_inst.gsl_blas_dnrm2 ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_re.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)))), l_tmp___0))
					blas_inst.gsl_blas_zdscal (l_scale, create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_vi.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset))
					l_vi.ce_gets (rowcol_source_inst.gsl_matrix_complex_column (a_evec, l_i + {NATURAL_32} 1))
					blas_inst.gsl_blas_zdscal (l_scale, create {CE_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_vi.c_pointer + {PD_GSL_VECTOR_COMPLEX_VIEW}.vector_offset))
				end
				l_i := l_i + 1
			end
		end

end
