class
	P_NTUPLE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_ntuple_create (a_filename: CE_POINTER [INTEGER_8]; a_ntuple_data: CE_POINTER [ANY]; a_size: NATURAL_32): CE_POINTER [PD_GSL_NTUPLE]
		local
			l_ntuple: CE_POINTER [PD_GSL_NTUPLE]
			js: JUMP_STATE
		do
			create l_ntuple.make

			l_ntuple.ce_gets (create {CE_POINTER [PD_GSL_NTUPLE]}.make_cast ((malloc ({PD_GSL_NTUPLE}.sizeof.to_natural_32))))
			if (l_ntuple.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("failed to allocate space for ntuple struct"), ce_string ("ntuple.c"), 40, 8)
					Result := (create {CE_POINTER [PD_GSL_NTUPLE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_ntuple.item.ntuple_data := a_ntuple_data
				l_ntuple.item.size := a_size
				l_ntuple.item.file := fopen (a_filename, ce_string ("wb"))
				if ((l_ntuple.item.file).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_ntuple))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("unable to create ntuple file"), ce_string ("ntuple.c"), 51, 5)
						Result := (create {CE_POINTER [PD_GSL_NTUPLE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				Result := l_ntuple
			end
		end

	gsl_ntuple_open (a_filename: CE_POINTER [INTEGER_8]; a_ntuple_data: CE_POINTER [ANY]; a_size: NATURAL_32): CE_POINTER [PD_GSL_NTUPLE]
		local
			l_ntuple: CE_POINTER [PD_GSL_NTUPLE]
			js: JUMP_STATE
		do
			create l_ntuple.make

			l_ntuple.ce_gets (create {CE_POINTER [PD_GSL_NTUPLE]}.make_cast ((malloc ({PD_GSL_NTUPLE}.sizeof.to_natural_32))))
			if (l_ntuple.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("failed to allocate space for ntuple struct"), ce_string ("ntuple.c"), 70, 8)
					Result := (create {CE_POINTER [PD_GSL_NTUPLE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_ntuple.item.ntuple_data := a_ntuple_data
				l_ntuple.item.size := a_size
				l_ntuple.item.file := fopen (a_filename, ce_string ("rb"))
				if ((l_ntuple.item.file).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_ntuple))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("unable to open ntuple file for reading"), ce_string ("ntuple.c"), 82, 5)
						Result := (create {CE_POINTER [PD_GSL_NTUPLE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				Result := l_ntuple
			end
		end

	gsl_ntuple_write (a_ntuple: CE_POINTER [PD_GSL_NTUPLE]): INTEGER_32
		local
			l_nwrite: NATURAL_32
			js: JUMP_STATE
		do
			l_nwrite := fwrite (a_ntuple.item.ntuple_data, a_ntuple.item.size, (1).to_natural_32, a_ntuple.item.file)
			if l_nwrite /= {NATURAL_32} 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("failed to write ntuple entry to file"), ce_string ("ntuple.c"), 103, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_ntuple_bookdata (a_ntuple: CE_POINTER [PD_GSL_NTUPLE]): INTEGER_32
		do
			Result := (gsl_ntuple_write (a_ntuple))
		end

	gsl_ntuple_read (a_ntuple: CE_POINTER [PD_GSL_NTUPLE]): INTEGER_32
		local
			l_nread: NATURAL_32
			js: JUMP_STATE
		do
			l_nread := fread (a_ntuple.item.ntuple_data, a_ntuple.item.size, (1).to_natural_32, a_ntuple.item.file)
			if l_nread = {NATURAL_32} 0 then
				if (feof (a_ntuple.item.file)).to_boolean then
					Result := 32
					js.return
				end
			end
			if not js.return_called and then (l_nread /= {NATURAL_32} 1) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("failed to read ntuple entry from file"), ce_string ("ntuple.c"), 136, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_ntuple_project (a_h: CE_POINTER [PD_GSL_HISTOGRAM]; a_ntuple: CE_POINTER [PD_GSL_NTUPLE]; a_value_func: CE_POINTER [PD_GSL_NTUPLE_VALUE_FN]; a_select_func: CE_POINTER [PD_GSL_NTUPLE_SELECT_FN]): INTEGER_32
		local
			l_nread: NATURAL_32
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				l_nread := fread (a_ntuple.item.ntuple_data, a_ntuple.item.size, (1).to_natural_32, a_ntuple.item.file)
				if l_nread = {NATURAL_32} 0 then
					if (feof (a_ntuple.item.file)).to_boolean then
						js.break
					end
				end
				if not js.loop_jumped then
					if l_nread /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("failed to read ntuple for projection"), ce_string ("ntuple.c"), 170, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						if ((a_select_func.item.function).integer_32_item ([a_ntuple.item.ntuple_data, a_select_func.item.params])).to_boolean then
							add_inst.gsl_histogram_increment (a_h, ((a_value_func.item.function).real_64_item ([a_ntuple.item.ntuple_data, a_value_func.item.params]))).do_nothing
						end
					end
				end
			end
			js.reset
			if not js.return_called then
				Result := 0
			end
		end

	gsl_ntuple_close (a_ntuple: CE_POINTER [PD_GSL_NTUPLE]): INTEGER_32
		local
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_status := (fclose (a_ntuple.item.file))
			if l_status.to_boolean then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("failed to close ntuple file"), ce_string ("ntuple.c"), 196, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (a_ntuple))
				Result := 0
			end
		end

end
