class
	P_OPER

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_histogram_equal_bins_p (a_h1: CE_POINTER [PD_GSL_HISTOGRAM]; a_h2: CE_POINTER [PD_GSL_HISTOGRAM]): INTEGER_32
		local
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			if a_h1.item.n /= a_h2.item.n then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i <= a_h1.item.n))
				loop
					if a_h1.item.range[l_i.to_integer_32] /= a_h2.item.range[l_i.to_integer_32] then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_histogram_add (a_h1: CE_POINTER [PD_GSL_HISTOGRAM]; a_h2: CE_POINTER [PD_GSL_HISTOGRAM]): INTEGER_32
		local
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			if not (gsl_histogram_equal_bins_p (a_h1, a_h2)).to_boolean then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("histograms have different binning"), ce_string ("oper.c"), 82, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_h1.item.n)
				loop
					a_h1.item.bin[l_i.to_integer_32] := a_h1.item.bin[l_i.to_integer_32] + (a_h2.item.bin[l_i.to_integer_32])
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_histogram_sub (a_h1: CE_POINTER [PD_GSL_HISTOGRAM]; a_h2: CE_POINTER [PD_GSL_HISTOGRAM]): INTEGER_32
		local
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			if not (gsl_histogram_equal_bins_p (a_h1, a_h2)).to_boolean then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("histograms have different binning"), ce_string ("oper.c"), 105, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_h1.item.n)
				loop
					a_h1.item.bin[l_i.to_integer_32] := a_h1.item.bin[l_i.to_integer_32] - (a_h2.item.bin[l_i.to_integer_32])
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_histogram_mul (a_h1: CE_POINTER [PD_GSL_HISTOGRAM]; a_h2: CE_POINTER [PD_GSL_HISTOGRAM]): INTEGER_32
		local
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			if not (gsl_histogram_equal_bins_p (a_h1, a_h2)).to_boolean then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("histograms have different binning"), ce_string ("oper.c"), 129, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_h1.item.n)
				loop
					a_h1.item.bin[l_i.to_integer_32] := a_h1.item.bin[l_i.to_integer_32] * (a_h2.item.bin[l_i.to_integer_32])
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_histogram_div (a_h1: CE_POINTER [PD_GSL_HISTOGRAM]; a_h2: CE_POINTER [PD_GSL_HISTOGRAM]): INTEGER_32
		local
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			if not (gsl_histogram_equal_bins_p (a_h1, a_h2)).to_boolean then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("histograms have different binning"), ce_string ("oper.c"), 150, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_h1.item.n)
				loop
					a_h1.item.bin[l_i.to_integer_32] := a_h1.item.bin[l_i.to_integer_32] / (a_h2.item.bin[l_i.to_integer_32])
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_histogram_scale (a_h: CE_POINTER [PD_GSL_HISTOGRAM]; a_scale: REAL_64): INTEGER_32
		local
			l_i: NATURAL_32
		do
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_h.item.n)
			loop
				a_h.item.bin[l_i.to_integer_32] := a_h.item.bin[l_i.to_integer_32] * a_scale
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_histogram_shift (a_h: CE_POINTER [PD_GSL_HISTOGRAM]; a_shift___0: REAL_64): INTEGER_32
		local
			l_i: NATURAL_32
		do
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_h.item.n)
			loop
				a_h.item.bin[l_i.to_integer_32] := a_h.item.bin[l_i.to_integer_32] + a_shift___0
				l_i := l_i + 1
			end
			Result := 0
		end

end
