class
	P_PARETO

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_ran_pareto (a_r___3: CE_POINTER [PD_GSL_RNG]; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_z: REAL_64
		do
			l_x := (gsl_gsl_rng_inst.gsl_rng_uniform_pos (a_r___3))
			l_z := (pow (l_x, (-1).to_double / a_a___5))
			Result := (a_b___0 * l_z)
		end

	gsl_ran_pareto_pdf (a_x: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_p: REAL_64
		do
			if a_x >= a_b___0 then
				l_p := (a_a___5 / a_b___0) / (pow (a_x / a_b___0, a_a___5 + (1).to_double))
				Result := l_p
			else
				Result := (0).to_double
			end
		end

	gsl_cdf_pareto_P (a_x: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_P___2: REAL_64
		do
			if a_x < a_b___0 then
				l_P___2 := (0).to_double
			else
				l_P___2 := (1).to_double - (pow (a_b___0 / a_x, a_a___5))
			end
			Result := l_P___2
		end

	gsl_cdf_pareto_Q (a_x: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_Q___1: REAL_64
		do
			if a_x < a_b___0 then
				l_Q___1 := (1).to_double
			else
				l_Q___1 := pow (a_b___0 / a_x, a_a___5)
			end
			Result := l_Q___1
		end

end
