class
	P_PDF

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_histogram_pdf_sample (a_p: CE_POINTER [PD_GSL_HISTOGRAM_PDF]; a_r___3: REAL_64): REAL_64
		local
			l_r___3: REAL_64
			l_i: NATURAL_32
			l_status: INTEGER_32
			l_delta___0: REAL_64
			l_x: REAL_64
			js: JUMP_STATE
		do
			l_r___3 := a_r___3
			if l_r___3 = 1.0 then
				l_r___3 := 0.0
			end
			l_status := find_inst.find___2 (a_p.item.n, a_p.item.sum, l_r___3, create {CE_POINTER [NATURAL_32]}.make_shared ($l_i))
			if l_status.to_boolean then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("cannot find r in cumulative pdf"), ce_string ("pdf.c"), 46, 1)
					Result := (0).to_double
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_delta___0 := (l_r___3 - a_p.item.sum[l_i.to_integer_32]) / (a_p.item.sum[(l_i + {NATURAL_32} 1).to_integer_32] - a_p.item.sum[l_i.to_integer_32])
				l_x := a_p.item.range[l_i.to_integer_32] + l_delta___0 * (a_p.item.range[(l_i + {NATURAL_32} 1).to_integer_32] - a_p.item.range[l_i.to_integer_32])
				Result := l_x
				js.return
			end
			if not js.return_called then
				Result := (0).to_double
			end
		end

	gsl_histogram_pdf_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_HISTOGRAM_PDF]
		local
			l_p: CE_POINTER [PD_GSL_HISTOGRAM_PDF]
			js: JUMP_STATE
		do
			create l_p.make

			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("histogram pdf length n must be positive integer"), ce_string ("pdf.c"), 64, 1)
					Result := (create {CE_POINTER [PD_GSL_HISTOGRAM_PDF]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_p.ce_gets (create {CE_POINTER [PD_GSL_HISTOGRAM_PDF]}.make_cast ((malloc ({PD_GSL_HISTOGRAM_PDF}.sizeof.to_natural_32))))
				if (l_p.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram pdf struct"), ce_string ("pdf.c"), 72, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM_PDF]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_p.item.range := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((a_n + {NATURAL_32} 1) * Real_64_bytes.to_natural_32)))
				if ((l_p.item.range).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_p))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram pdf ranges"), ce_string ("pdf.c"), 82, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM_PDF]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_p.item.sum := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((a_n + {NATURAL_32} 1) * Real_64_bytes.to_natural_32)))
				if ((l_p.item.sum).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_p.item.range))
					free (create {CE_POINTER [ANY]}.make_cast (l_p))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for histogram pdf sums"), ce_string ("pdf.c"), 93, 8)
						Result := (create {CE_POINTER [PD_GSL_HISTOGRAM_PDF]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_p.item.n := a_n
				Result := l_p
			end
		end

	gsl_histogram_pdf_init (a_p: CE_POINTER [PD_GSL_HISTOGRAM_PDF]; a_h: CE_POINTER [PD_GSL_HISTOGRAM]): INTEGER_32
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_mean: REAL_64
			l_sum: REAL_64
			js: JUMP_STATE
		do
			l_n := a_p.item.n
			if l_n /= a_h.item.n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("histogram length must match pdf length"), ce_string ("pdf.c"), 109, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_n))
				loop
					if a_h.item.bin[l_i.to_integer_32] < (0).to_double then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("histogram bins must be non-negative to computea probability distribution"), ce_string ("pdf.c"), 117, 1)
							Result := 1
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_n + {NATURAL_32} 1)
				loop
					a_p.item.range[l_i.to_integer_32] := a_h.item.range[l_i.to_integer_32]
					l_i := l_i + 1
				end
				l_mean := (0).to_double
				l_sum := (0).to_double
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_n)
				loop
					l_mean := l_mean + ((a_h.item.bin[l_i.to_integer_32] - l_mean) / (l_i + {NATURAL_32} 1).to_real_64)
					l_i := l_i + 1
				end
				a_p.item.sum[0] := (0).to_double
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_n)
				loop
					l_sum := l_sum + ((a_h.item.bin[l_i.to_integer_32] / l_mean) / l_n.to_real_64)
					a_p.item.sum[(l_i + {NATURAL_32} 1).to_integer_32] := l_sum
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_histogram_pdf_free (a_p: CE_POINTER [PD_GSL_HISTOGRAM_PDF])
		local
			js: JUMP_STATE
		do
			if (a_p).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (a_p.item.range))
				free (create {CE_POINTER [ANY]}.make_cast (a_p.item.sum))
				free (create {CE_POINTER [ANY]}.make_cast (a_p))
			end
		end

end
