class
	P_POW_INT

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_sf_pow_int_e (a_x: REAL_64; a_n: INTEGER_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_x: REAL_64
			l_n: INTEGER_32
			l_value: REAL_64
			l_count: INTEGER_32
			l_u: REAL_64
			js: JUMP_STATE
		do
			l_x := a_x
			l_n := a_n
			l_value := 1.0
			l_count := 0
			if l_n < 0 then
				l_n := -l_n
				if l_x = 0.0 then
					l_u := 1.0 / l_x
					if (l_n \\ 2).to_boolean then
						a_result.item.val := l_u
					else
						a_result.item.val := l_u * l_u
					end
					a_result.item.err := (builtin_inff).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("overflow"), ce_string ("pow_int.c"), 45, 16)
						Result := 16
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
				if not js.return_called then
					l_x := 1.0 / l_x
				end
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					if ((l_n).bit_and (1)).to_boolean then
						l_value := l_value * l_x
					end
					l_n := (l_n).bit_shift_right ((1))
					l_x := l_x * l_x
					l_count := l_count + 1
					if not l_n.to_boolean then
						js.break
					end
				end
				js.reset
				a_result.item.val := l_value
				a_result.item.err := ((2.0 * 2.2204460492503131e-16) * (l_count.to_double + 1.0)) * (fabs (l_value))
				Result := 0
			end
		end

	gsl_sf_pow_int (a_x: REAL_64; a_n: INTEGER_32): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_pow_int_e (a_x, a_n, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_pow_int_e(x, n, &result)"), ce_string ("pow_int.c"), 73, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_pow_int (a_x: REAL_64; a_n: INTEGER_32): REAL_64
		local
			l_x: REAL_64
			l_n: INTEGER_32
			l_value: REAL_64
			js: JUMP_STATE
		do
			l_x := a_x
			l_n := a_n
			l_value := 1.0
			if l_n < 0 then
				l_x := 1.0 / l_x
				l_n := -l_n
			end
			from
			until
				js.loop_left
			loop
				js.reset
				if ((l_n).bit_and (1)).to_boolean then
					l_value := l_value * l_x
				end
				l_n := (l_n).bit_shift_right ((1))
				l_x := l_x * l_x
				if not l_n.to_boolean then
					js.break
				end
			end
			js.reset
			Result := l_value
		end

end
