class
	P_PTLQ

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_linalg_PTLQ_decomp (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_tau: CE_POINTER [PD_GSL_VECTOR]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_signum: CE_POINTER [INTEGER_32]; a_norm___0: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_N: NATURAL_32
			l_M: NATURAL_32
			l_i: NATURAL_32
			l_c___1: PD_GSL_VECTOR_VIEW
			l_x: REAL_64
			l_max_norm: REAL_64
			l_j: NATURAL_32
			l_kmax___0: NATURAL_32
			l_x___0: REAL_64
			l_c_full: PD_GSL_VECTOR_VIEW
			l_c___2: PD_GSL_VECTOR_VIEW
			l_tau_i: REAL_64
			l_m___4: PD_GSL_MATRIX_VIEW
			l_x___1: REAL_64
			l_y: REAL_64
			l_temp: REAL_64
			l_c_full___0: PD_GSL_VECTOR_VIEW
			l_c___3: PD_GSL_VECTOR_VIEW
			l_tmp___13: REAL_64
			l_tmp___15: NATURAL_32
			l_tmp___16: NATURAL_32
			js: JUMP_STATE
		do
			create l_c___1.make
			create l_c_full.make
			create l_c___2.make
			create l_m___4.make
			create l_c_full___0.make
			create l_c___3.make

			l_N := a_A___0.item.size1
			l_M := a_A___0.item.size2
			if l_M < l_N then
				l_tmp___16 := l_M
			else
				l_tmp___16 := l_N
			end
			if a_tau.item.size /= l_tmp___16 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("size of tau must be MIN(M,N)"), ce_string ("ptlq.c"), 83, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_p.item.size /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("permutation size must be N"), ce_string ("ptlq.c"), 87, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_norm___0.item.size /= l_N then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("norm size must be N"), ce_string ("ptlq.c"), 91, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				a_signum.item := 1
				init_inst.gsl_permutation_init (a_p)
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					l_c___1.ce_gets ((rowcol_source_inst.gsl_matrix_row (a_A___0, l_i)))
					l_x := (blas_inst.gsl_blas_dnrm2 ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___1.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset))))
					gsl_gsl_vector_double_inst.gsl_vector_set (a_norm___0, l_i, l_x)
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					js.loop_left
				loop
					js.reset
					if l_M < l_N then
						l_tmp___15 := l_M
					else
						l_tmp___15 := l_N
					end
					if not (l_i < l_tmp___15) then
						js.break
					end
					if not js.loop_jumped then
						l_max_norm := (gsl_gsl_vector_double_inst.gsl_vector_get (a_norm___0, l_i))
						l_kmax___0 := l_i
						l_j := l_i + {NATURAL_32} 1
						from
						until
							not (l_j < l_N)
						loop
							l_x___0 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_norm___0, l_j))
							if l_x___0 > l_max_norm then
								l_max_norm := l_x___0
								l_kmax___0 := l_j
							end
							l_j := l_j + 1
						end
						if l_kmax___0 /= l_i then
							swap_source_inst.gsl_matrix_swap_rows (a_A___0, l_i, l_kmax___0).do_nothing
							permutation_inst.gsl_permutation_swap (a_p, l_i, l_kmax___0).do_nothing
							swap_source_inst.gsl_vector_swap_elements (a_norm___0, l_i, l_kmax___0).do_nothing
							a_signum.item := -a_signum.item
						end
						l_c_full.ce_gets ((rowcol_source_inst.gsl_matrix_row (a_A___0, l_i)))
						l_c___2.ce_gets ((subvector_source_inst.gsl_vector_subvector (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c_full.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_i, l_M - l_i)))
						l_tau_i := (householder_inst.gsl_linalg_householder_transform (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)))
						gsl_gsl_vector_double_inst.gsl_vector_set (a_tau, l_i, l_tau_i)
						if l_i + {NATURAL_32} 1 < l_N then
							l_m___4.ce_gets ((submatrix_source_inst.gsl_matrix_submatrix (a_A___0, l_i + {NATURAL_32} 1, l_i, l_N - (l_i + {NATURAL_32} 1), l_M - l_i)))
							householder_inst.gsl_linalg_householder_mh (l_tau_i, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___2.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset)).do_nothing
						end
						if l_i + {NATURAL_32} 1 < l_M then
							l_j := l_i + {NATURAL_32} 1
							from
							until
								not (l_j < l_N)
							loop
								l_x___1 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_norm___0, l_j))
								if l_x___1 > 0.0 then
									l_y := (0).to_double
									l_temp := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, l_j, l_i)) / l_x___1
									if (fabs (l_temp)) >= (1).to_double then
										l_y := 0.0
									else
										l_y := l_x___1 * (sqrt ((1).to_double - l_temp * l_temp))
									end
									l_tmp___13 := fabs (l_y / l_x___1)
									if l_tmp___13 < (sqrt (20.0)) * 1.4901161193847656e-08 then
										l_c_full___0.ce_gets ((rowcol_source_inst.gsl_matrix_row (a_A___0, l_j)))
										l_c___3.ce_gets ((subvector_source_inst.gsl_vector_subvector (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c_full___0.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_i + {NATURAL_32} 1, l_M - (l_i + {NATURAL_32} 1))))
										l_y := blas_inst.gsl_blas_dnrm2 ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c___3.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)))
									end
									gsl_gsl_vector_double_inst.gsl_vector_set (a_norm___0, l_j, l_y)
								end
								l_j := l_j + 1
							end
						end
						l_i := l_i + 1
					end
				end
				js.reset
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_PTLQ_decomp2 (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_q___3: CE_POINTER [PD_GSL_MATRIX]; a_r___3: CE_POINTER [PD_GSL_MATRIX]; a_tau: CE_POINTER [PD_GSL_VECTOR]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_signum: CE_POINTER [INTEGER_32]; a_norm___0: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_N: NATURAL_32
			l_M: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_N := a_A___0.item.size1
					l_M := a_A___0.item.size2
					if a_q___3.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if a_q___3.item.size2 = l_M then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("q must be M x M"), ce_string ("ptlq.c"), 205, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if a_r___3.item.size1 = l_N then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if a_r___3.item.size2 = l_M then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("r must be N x M"), ce_string ("ptlq.c"), 209, 19)
							Result := 19
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						if l_M < l_N then
							l_tmp := l_M
						else
							l_tmp := l_N
						end
						if a_tau.item.size /= l_tmp then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("size of tau must be MIN(M,N)"), ce_string ("ptlq.c"), 213, 19)
								Result := 19
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						elseif a_p.item.size /= l_N then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("permutation size must be N"), ce_string ("ptlq.c"), 217, 19)
								Result := 19
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						elseif a_norm___0.item.size /= l_N then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("norm size must be N"), ce_string ("ptlq.c"), 221, 19)
								Result := 19
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
				when 13 then -- if done | if done | if done
						if not js.return_called then
							copy_source_inst.gsl_matrix_memcpy (a_r___3, a_A___0).do_nothing
							gsl_linalg_PTLQ_decomp (a_r___3, a_tau, a_p, a_signum, a_norm___0).do_nothing
							lq_inst.gsl_linalg_LQ_unpack (a_r___3, a_tau, a_q___3, a_r___3).do_nothing
							Result := 0
						end
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_linalg_PTLQ_solve_T (a_QR: CE_POINTER [PD_GSL_MATRIX]; a_tau: CE_POINTER [PD_GSL_VECTOR]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_b___0: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_QR.item.size1 /= a_QR.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("QR matrix must be square"), ce_string ("ptlq.c"), 253, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_QR.item.size2 /= a_p.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match permutation size"), ce_string ("ptlq.c"), 257, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_QR.item.size2 /= a_b___0.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match b size"), ce_string ("ptlq.c"), 261, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_QR.item.size1 /= a_x.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match solution size"), ce_string ("ptlq.c"), 265, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				copy_source_inst.gsl_vector_memcpy (a_x, a_b___0).do_nothing
				gsl_linalg_PTLQ_svx_T (a_QR, a_tau, a_p, a_x).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_PTLQ_svx_T (a_LQ: CE_POINTER [PD_GSL_MATRIX]; a_tau: CE_POINTER [PD_GSL_VECTOR]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_LQ.item.size1 /= a_LQ.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("LQ matrix must be square"), ce_string ("ptlq.c"), 285, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LQ.item.size2 /= a_p.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match permutation size"), ce_string ("ptlq.c"), 289, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LQ.item.size1 /= a_x.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match solution size"), ce_string ("ptlq.c"), 293, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				lq_inst.gsl_linalg_LQ_vecQT (a_LQ, a_tau, a_x).do_nothing
				blas_inst.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasLower, {PC_CBLAS_TRANSPOSE}.CblasTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_LQ, a_x).do_nothing
				permute_source_inst.gsl_permute_vector_inverse (a_p, a_x).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_PTLQ_LQsolve_T (a_Q___1: CE_POINTER [PD_GSL_MATRIX]; a_L: CE_POINTER [PD_GSL_MATRIX]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_b___0: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		do
			if a_Q___1.item.size1 /= a_Q___1.item.size2 then
				Result := 20
			elseif a_L.item.size1 /= a_L.item.size2 then
				Result := 20
			elseif a_Q___1.item.size1 /= a_p.item.size then
				Result := 19
			elseif a_Q___1.item.size1 /= a_L.item.size1 then
				Result := 19
			elseif a_Q___1.item.size1 /= a_b___0.item.size then
				Result := 19
			else
				blas_inst.gsl_blas_dgemv ({PC_CBLAS_TRANSPOSE}.CblasNoTrans, 1.0, a_Q___1, a_b___0, 0.0, a_x).do_nothing
				blas_inst.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasLower, {PC_CBLAS_TRANSPOSE}.CblasTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_L, a_x).do_nothing
				permute_source_inst.gsl_permute_vector_inverse (a_p, a_x).do_nothing
				Result := 0
			end
		end

	gsl_linalg_PTLQ_Lsolve_T (a_LQ: CE_POINTER [PD_GSL_MATRIX]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_b___0: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_LQ.item.size1 /= a_LQ.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("LQ matrix must be square"), ce_string ("ptlq.c"), 353, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LQ.item.size1 /= a_b___0.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match b size"), ce_string ("ptlq.c"), 357, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LQ.item.size2 /= a_x.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match x size"), ce_string ("ptlq.c"), 361, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_p.item.size /= a_x.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("permutation size must match x size"), ce_string ("ptlq.c"), 365, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				copy_source_inst.gsl_vector_memcpy (a_x, a_b___0).do_nothing
				blas_inst.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasLower, {PC_CBLAS_TRANSPOSE}.CblasTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_LQ, a_x).do_nothing
				permute_source_inst.gsl_permute_vector_inverse (a_p, a_x).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_PTLQ_Lsvx_T (a_LQ: CE_POINTER [PD_GSL_MATRIX]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_LQ.item.size1 /= a_LQ.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("LQ matrix must be square"), ce_string ("ptlq.c"), 391, 20)
					Result := 20
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_LQ.item.size2 /= a_x.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size must match x size"), ce_string ("ptlq.c"), 395, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_p.item.size /= a_x.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("permutation size must match x size"), ce_string ("ptlq.c"), 399, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				blas_inst.gsl_blas_dtrsv ({PC_CBLAS_UPLO}.CblasLower, {PC_CBLAS_TRANSPOSE}.CblasTrans, {PC_CBLAS_DIAG}.CblasNonUnit, a_LQ, a_x).do_nothing
				permute_source_inst.gsl_permute_vector_inverse (a_p, a_x).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_linalg_PTLQ_update (a_Q___1: CE_POINTER [PD_GSL_MATRIX]; a_L: CE_POINTER [PD_GSL_MATRIX]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR]; a_w: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_N: NATURAL_32
			l_M: NATURAL_32
			l_w0: REAL_64
			l_c___1: REAL_64
			l_s: REAL_64
			l_wk: REAL_64
			l_wkm1: REAL_64
			l_lj0: REAL_64
			l_p_j: NATURAL_32
			l_vj: REAL_64
			l_c___2: REAL_64
			l_s___0: REAL_64
			l_diag: REAL_64
			l_offdiag: REAL_64
		do
			if a_Q___1.item.size1 /= a_Q___1.item.size2 then
				Result := 20
			elseif a_L.item.size1 /= a_L.item.size2 then
				Result := 20
			elseif a_L.item.size1 /= a_Q___1.item.size2 then
				Result := 19
			elseif a_v.item.size /= a_Q___1.item.size2 then
				Result := 19
			elseif a_w.item.size /= a_Q___1.item.size2 then
				Result := 19
			else
				l_N := a_Q___1.item.size1
				l_M := a_Q___1.item.size2
				l_k := l_M - {NATURAL_32} 1
				from
				until
					not (l_k > {NATURAL_32} 0)
				loop
					l_wk := (gsl_gsl_vector_double_inst.gsl_vector_get (a_w, l_k))
					l_wkm1 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_w, l_k - {NATURAL_32} 1))
					qrstep_inst.create_givens (l_wkm1, l_wk, create {CE_POINTER [REAL_64]}.make_shared ($l_c___1), create {CE_POINTER [REAL_64]}.make_shared ($l_s))
					apply_givens_inst.apply_givens_vec (a_w, l_k - {NATURAL_32} 1, l_k, l_c___1, l_s)
					apply_givens_inst.apply_givens_lq (l_M, l_N, a_Q___1, a_L, l_k - {NATURAL_32} 1, l_k, l_c___1, l_s)
					l_k := l_k - 1
				end
				l_w0 := gsl_gsl_vector_double_inst.gsl_vector_get (a_w, (0).to_natural_32)
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_N)
				loop
					l_lj0 := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_L, l_j, (0).to_natural_32))
					l_p_j := (gsl_gsl_permutation_inst.gsl_permutation_get (a_p, l_j))
					l_vj := (gsl_gsl_vector_double_inst.gsl_vector_get (a_v, l_p_j))
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_L, l_j, (0).to_natural_32, l_lj0 + l_w0 * l_vj)
					l_j := l_j + 1
				end
				l_k := (1).to_natural_32
				from
				until
					not (l_k < l_N)
				loop
					l_diag := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_L, l_k - {NATURAL_32} 1, l_k - {NATURAL_32} 1))
					l_offdiag := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_L, l_k - {NATURAL_32} 1, l_k))
					qrstep_inst.create_givens (l_diag, l_offdiag, create {CE_POINTER [REAL_64]}.make_shared ($l_c___2), create {CE_POINTER [REAL_64]}.make_shared ($l_s___0))
					apply_givens_inst.apply_givens_lq (l_M, l_N, a_Q___1, a_L, l_k - {NATURAL_32} 1, l_k, l_c___2, l_s___0)
					l_k := l_k + 1
				end
				Result := 0
			end
		end

end
