class
	P_QAWO

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_integration_qawo (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_a___5: REAL_64; a_epsabs: REAL_64; a_epsrel: REAL_64; a_limit: NATURAL_32; a_workspace: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]; a_wf: CE_POINTER [PD_GSL_INTEGRATION_QAWO_TABLE]; a_result: CE_POINTER [REAL_64]; a_abserr: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_area: REAL_64
			l_errsum: REAL_64
			l_res_ext: REAL_64
			l_err_ext: REAL_64
			l_result0: REAL_64
			l_abserr0: REAL_64
			l_resabs0: REAL_64
			l_resasc0: REAL_64
			l_tolerance: REAL_64
			l_ertest: REAL_64
			l_error_over_large_intervals: REAL_64
			l_reseps: REAL_64
			l_abseps: REAL_64
			l_correc: REAL_64
			l_ktmin: NATURAL_32
			l_roundoff_type1: INTEGER_32
			l_roundoff_type2: INTEGER_32
			l_roundoff_type3: INTEGER_32
			l_error_type: INTEGER_32
			l_error_type2: INTEGER_32
			l_iteration: NATURAL_32
			l_positive_integrand: INTEGER_32
			l_extrapolate: INTEGER_32
			l_extall: INTEGER_32
			l_disallow_extrapolation: INTEGER_32
			l_table: PD_EXTRAPOLATION_TABLE
			l_b___0: REAL_64
			l_abs_omega: REAL_64
			l_current_level: NATURAL_32
			l_a1___4: REAL_64
			l_b1___0: REAL_64
			l_a2___3: REAL_64
			l_b2: REAL_64
			l_a_i: REAL_64
			l_b_i: REAL_64
			l_r_i: REAL_64
			l_e_i: REAL_64
			l_area1: REAL_64
			l_area2: REAL_64
			l_area12: REAL_64
			l_error1: REAL_64
			l_error2: REAL_64
			l_error12: REAL_64
			l_resasc1: REAL_64
			l_resasc2: REAL_64
			l_resabs1: REAL_64
			l_resabs2: REAL_64
			l_last_e_i: REAL_64
			l_delta___0: REAL_64
			l_tmp___3: REAL_64
			l_i: NATURAL_32
			l_width: REAL_64
			l_tmp___10: REAL_64
			l_max_area: REAL_64
			l_tmp___12: REAL_64
			l_ratio: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_table.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ertest := (0).to_double
					l_error_over_large_intervals := (0).to_double
					l_reseps := (0).to_double
					l_abseps := (0).to_double
					l_correc := (0).to_double
					l_ktmin := (0).to_natural_32
					l_roundoff_type1 := 0
					l_roundoff_type2 := 0
					l_roundoff_type3 := 0
					l_error_type := 0
					l_error_type2 := 0
					l_iteration := (0).to_natural_32
					l_positive_integrand := 0
					l_extrapolate := 0
					l_extall := 0
					l_disallow_extrapolation := 0
					l_b___0 := a_a___5 + a_wf.item.L
					l_abs_omega := (fabs (a_wf.item.omega))
					initialise_inst.initialise (a_workspace, a_a___5, l_b___0)
					a_result.item := (0).to_double
					a_abserr.item := (0).to_double
					if a_limit > a_workspace.item.limit then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("iteration limit exceeds available workspace"), ce_string ("qawo.c"), 80, 4)
							Result := 4
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not (not js.return_called and then (a_epsabs <= (0).to_double)) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (a_epsrel < (50).to_double * 2.2204460492503131e-16) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_epsrel < 0.5e-28) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("tolerance cannot be acheived with given epsabs and epsrel"), ce_string ("qawo.c"), 88, 13)
							Result := 13
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 6 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 14 -- skip if block
						end
				when 7 then -- if:
							qc25f_inst.qc25f (a_f, a_a___5, l_b___0, a_wf, (0).to_natural_32, create {CE_POINTER [REAL_64]}.make_shared ($l_result0), create {CE_POINTER [REAL_64]}.make_shared ($l_abserr0), create {CE_POINTER [REAL_64]}.make_shared ($l_resabs0), create {CE_POINTER [REAL_64]}.make_shared ($l_resasc0))
							set_initial_inst.set_initial_result (a_workspace, l_result0, l_abserr0)
							l_tolerance := gsl_gsl_minmax_inst.GSL_MAX_DBL (a_epsabs, a_epsrel * (fabs (l_result0)))
							if not (l_abserr0 <= ((100).to_double * 2.2204460492503131e-16) * l_resabs0) then
								l_pos := -1 + 10 -- skip if block
							end
				when 8 then -- if:
							if l_abserr0 > l_tolerance then
								a_result.item := l_result0
								a_abserr.item := l_abserr0
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("cannot reach tolerance because of roundoff erroron first attempt"), ce_string ("qawo.c"), 105, 18)
									Result := 18
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
							else
								l_pos := -1 + 10 -- goto _L___1
							end
				when 9 then -- if block done, skip else block:
							l_pos := -1 + 14
				when 10 then -- else: | _L___1:
							if not (l_abserr0 <= l_tolerance) then
								l_pos := -1 + 13 -- skip if block
							end
				when 11 then -- if:
							if l_abserr0 /= l_resasc0 then
								a_result.item := l_result0
								a_abserr.item := l_abserr0
								Result := 0
								js.return
							else
								l_pos := -1 + 13 -- goto _L___0
							end
				when 12 then -- if block done, skip else block:
							l_pos := -1 + 14
				when 13 then -- else: | _L___0:
							if l_abserr0 = 0.0 then
								a_result.item := l_result0
								a_abserr.item := l_abserr0
								Result := 0
								js.return
							elseif a_limit = {NATURAL_32} 1 then
								a_result.item := l_result0
								a_abserr.item := l_abserr0
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("a maximum of one iteration was insufficient"), ce_string ("qawo.c"), 119, 11)
									Result := 11
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
							end
				when 14 then -- if done | if done
							if js.return_called then
								l_pos := -1 + 40 -- skip if block
							end
				when 15 then -- if:
								qelg_inst.initialise_table___1 (l_table.address)
								if (0.5 * l_abs_omega) * (fabs (l_b___0 - a_a___5)) <= (2).to_double then
									qelg_inst.append_table___1 (l_table.address, l_result0)
									l_extall := 1
								end
								l_area := l_result0
								l_errsum := l_abserr0
								l_res_ext := l_result0
								l_err_ext := 1.7976931348623157e+308
								l_positive_integrand := positivity_inst.test_positivity (l_result0, l_resabs0)
								l_iteration := (1).to_natural_32
				when 16 then -- loop condition:
								if js.loop_left then
									l_pos := -1 + 27 -- skip loop
								end
				when 17 then -- loop body:
								js.reset
								l_area1 := (0).to_double
								l_area2 := (0).to_double
								l_area12 := (0).to_double
								l_error1 := (0).to_double
								l_error2 := (0).to_double
								l_error12 := (0).to_double
								util_inst.retrieve (a_workspace, create {CE_POINTER [REAL_64]}.make_shared ($l_a_i), create {CE_POINTER [REAL_64]}.make_shared ($l_b_i), create {CE_POINTER [REAL_64]}.make_shared ($l_r_i), create {CE_POINTER [REAL_64]}.make_shared ($l_e_i))
								l_current_level := a_workspace.item.level[(a_workspace.item.i).to_integer_32] + {NATURAL_32} 1
								if l_current_level >= a_wf.item.n then
									l_error_type := -1
									js.break
								end
								if js.loop_jumped then
									l_pos := -1 + 20 -- skip if block
								end
				when 18 then -- if:
								l_a1___4 := l_a_i
								l_b1___0 := 0.5 * (l_a_i + l_b_i)
								l_a2___3 := l_b1___0
								l_b2 := l_b_i
								l_iteration := l_iteration + 1
								qc25f_inst.qc25f (a_f, l_a1___4, l_b1___0, a_wf, l_current_level, create {CE_POINTER [REAL_64]}.make_shared ($l_area1), create {CE_POINTER [REAL_64]}.make_shared ($l_error1), create {CE_POINTER [REAL_64]}.make_shared ($l_resabs1), create {CE_POINTER [REAL_64]}.make_shared ($l_resasc1))
								qc25f_inst.qc25f (a_f, l_a2___3, l_b2, a_wf, l_current_level, create {CE_POINTER [REAL_64]}.make_shared ($l_area2), create {CE_POINTER [REAL_64]}.make_shared ($l_error2), create {CE_POINTER [REAL_64]}.make_shared ($l_resabs2), create {CE_POINTER [REAL_64]}.make_shared ($l_resasc2))
								l_area12 := l_area1 + l_area2
								l_error12 := l_error1 + l_error2
								l_last_e_i := l_e_i
								l_errsum := (l_errsum + l_error12) - l_e_i
								l_area := (l_area + l_area12) - l_r_i
								l_tolerance := gsl_gsl_minmax_inst.GSL_MAX_DBL (a_epsabs, a_epsrel * (fabs (l_area)))
								if l_resasc1 /= l_error1 then
									if l_resasc2 /= l_error2 then
										l_delta___0 := l_r_i - l_area12
										l_tmp___3 := fabs (l_delta___0)
										if l_tmp___3 <= 1.0e-5 * (fabs (l_area12)) then
											if l_error12 >= 0.99 * l_e_i then
												if not l_extrapolate.to_boolean then
													l_roundoff_type1 := l_roundoff_type1 + 1
												else
													l_roundoff_type2 := l_roundoff_type2 + 1
												end
											end
										end
										if l_iteration > {NATURAL_32} 10 then
											if l_error12 > l_e_i then
												l_roundoff_type3 := l_roundoff_type3 + 1
											end
										end
									end
								end
								if l_roundoff_type1 + l_roundoff_type2 >= 10 then
									l_error_type := 2
								elseif l_roundoff_type3 >= 20 then
									l_error_type := 2
								end
								if l_roundoff_type2 >= 5 then
									l_error_type2 := 1
								end
								if (util_inst.subinterval_too_small (l_a1___4, l_a2___3, l_b2)).to_boolean then
									l_error_type := 4
								end
								util_inst.update (a_workspace, l_a1___4, l_b1___0, l_area1, l_error1, l_a2___3, l_b2, l_area2, l_error2)
								if l_errsum <= l_tolerance then
									l_pos := -1 + 38 -- goto compute_result
								end
				when 19 then
								if l_error_type.to_boolean then
									js.break
								end
				when 20 then -- if done
								if not js.loop_jumped and then (l_iteration >= a_limit - {NATURAL_32} 1) then
									l_error_type := 1
									js.break
								end
								if not js.loop_jumped and then (l_iteration = {NATURAL_32} 2) then
									if l_extall.to_boolean then
										l_error_over_large_intervals := l_errsum
										l_ertest := l_tolerance
										qelg_inst.append_table___1 (l_table.address, l_area)
										js.continue
									end
								end
								if not js.loop_jumped and then (l_disallow_extrapolation.to_boolean) then
									js.continue
								end
								if js.loop_jumped then
									l_pos := -1 + 23 -- skip if block
								end
				when 21 then -- if:
								if l_extall.to_boolean then
									l_error_over_large_intervals := l_error_over_large_intervals + (-l_last_e_i)
									if l_current_level < a_workspace.item.maximum_level then
										l_error_over_large_intervals := l_error_over_large_intervals + l_error12
									end
									if l_extrapolate.to_boolean then
										l_pos := -1 + 24 -- goto label70
									end
								end
				when 22 then
								if (qpsrt2_inst.large_interval___0 (a_workspace)).to_boolean then
									js.continue
								end
				when 23 then -- if done
								if not js.loop_jumped then
									if l_extall.to_boolean then
										l_extrapolate := 1
										a_workspace.item.nrmax := (1).to_natural_32
									else
										l_i := a_workspace.item.i
										l_width := a_workspace.item.blist[l_i.to_integer_32] - a_workspace.item.alist[l_i.to_integer_32]
										if (0.25 * (fabs (l_width))) * l_abs_omega > (2).to_double then
											js.continue
										end
										if not js.loop_jumped then
											l_extall := 1
											l_error_over_large_intervals := l_errsum
											l_ertest := l_tolerance
											js.continue
										end
									end
								end
								if js.loop_jumped then
									l_pos := -1 + 25 -- skip if block
								end
				when 24 then -- if: | label70:
								if not l_error_type2.to_boolean then
									if l_error_over_large_intervals > l_ertest then
										if (qpsrt2_inst.increase_nrmax___0 (a_workspace)).to_boolean then
											js.continue
										end
									end
								end
				when 25 then -- if done
								if not js.loop_jumped then
									qelg_inst.append_table___1 (l_table.address, l_area)
									if l_table.n < {NATURAL_32} 3 then
										reset_inst.reset_nrmax (a_workspace)
										l_extrapolate := 0
										l_error_over_large_intervals := l_errsum
										js.continue
									end
								end
								if not js.loop_jumped then
									qelg_inst.qelg (l_table.address, create {CE_POINTER [REAL_64]}.make_shared ($l_reseps), create {CE_POINTER [REAL_64]}.make_shared ($l_abseps))
									l_ktmin := l_ktmin + 1
									if l_ktmin > {NATURAL_32} 5 then
										if l_err_ext < 0.001 * l_errsum then
											l_error_type := 5
										end
									end
									if l_abseps < l_err_ext then
										l_ktmin := (0).to_natural_32
										l_err_ext := l_abseps
										l_res_ext := l_reseps
										l_correc := l_error_over_large_intervals
										l_ertest := gsl_gsl_minmax_inst.GSL_MAX_DBL (a_epsabs, a_epsrel * (fabs (l_reseps)))
										if l_err_ext <= l_ertest then
											js.break
										end
									end
								end
								if not js.loop_jumped then
									if l_table.n = {NATURAL_32} 1 then
										l_disallow_extrapolation := 1
									end
									if l_error_type = 5 then
										js.break
									end
								end
								if not js.loop_jumped then
									reset_inst.reset_nrmax (a_workspace)
									l_extrapolate := 0
									l_error_over_large_intervals := l_errsum
								end
								if not js.loop_left and then (not (l_iteration < a_limit)) then
									l_pos := -1 + 27 -- break
								end
				when 26 then
								l_pos := -1 + 16 -- back to loop condition
				when 27 then -- loop done
								js.reset
								a_result.item := l_res_ext
								a_abserr.item := l_err_ext
								if l_err_ext = 1.7976931348623157e+308 then
									l_pos := -1 + 38 -- goto compute_result
								end
				when 28 then
								if not (l_error_type.to_boolean) then
									l_pos := -1 + 31 -- skip if block
								end
				when 29 then -- if:
								l_pos := -1 + 32 -- goto _L___3
				when 30 then -- if block done, skip else block:
								l_pos := -1 + 36
				when 31 then -- else:
								if not (l_error_type2.to_boolean) then
									l_pos := -1 + 36 -- skip if block
								end
				when 32 then -- if: | _L___3:
								if l_error_type2.to_boolean then
									l_err_ext := l_err_ext + l_correc
								end
								if l_error_type = 0 then
									l_error_type := 3
								end
								if (a_result.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_pos := -1 + 35 -- skip if block
								end
				when 33 then -- if:
								if l_area /= (0).to_double then
									l_tmp___10 := fabs (l_res_ext)
									if l_err_ext / l_tmp___10 > l_errsum / (fabs (l_area)) then
										l_pos := -1 + 38 -- goto compute_result
									end
								else
									l_pos := -1 + 35 -- goto _L___2
								end
				when 34 then -- if block done, skip else block:
								l_pos := -1 + 36
				when 35 then -- else: | _L___2:
								if l_err_ext > l_errsum then
									l_pos := -1 + 38 -- goto compute_result
								elseif l_area = 0.0 then
									l_pos := -1 + 39 -- goto return_error
								end
				when 36 then -- if done | if done
								l_tmp___12 := fabs (l_area)
								l_max_area := (gsl_gsl_minmax_inst.GSL_MAX_DBL ((fabs (l_res_ext)), l_tmp___12))
								if not l_positive_integrand.to_boolean then
									if l_max_area < 0.01 * l_resabs0 then
										l_pos := -1 + 39 -- goto return_error
									end
								end
				when 37 then
								l_ratio := l_res_ext / l_area
								if l_ratio < 0.01 then
									l_error_type := 6
								elseif l_ratio > (100).to_double then
									l_error_type := 6
								elseif l_errsum > (fabs (l_area)) then
									l_error_type := 6
								end
								l_pos := -1 + 39 -- goto return_error
				when 38 then -- compute_result:
								a_result.item := util_inst.sum_results (a_workspace)
								a_abserr.item := l_errsum
				when 39 then -- return_error:
								if l_error_type > 2 then
									l_error_type := l_error_type - 1
								end
								if l_error_type = 0 then
									Result := 0
									js.return
								elseif l_error_type = 1 then
									from
									until
										js.loop_left
									loop
										js.reset
										error_inst.gsl_error (ce_string ("number of iterations was insufficient"), ce_string ("qawo.c"), 431, 11)
										Result := 11
										js.return
										if not js.return_called then
											js.break
										end
									end
									js.reset
								elseif l_error_type = 2 then
									from
									until
										js.loop_left
									loop
										js.reset
										error_inst.gsl_error (ce_string ("cannot reach tolerance because of roundoff error"), ce_string ("qawo.c"), 436, 18)
										Result := 18
										js.return
										if not js.return_called then
											js.break
										end
									end
									js.reset
								elseif l_error_type = 3 then
									from
									until
										js.loop_left
									loop
										js.reset
										error_inst.gsl_error (ce_string ("bad integrand behavior found in the integration interval"), ce_string ("qawo.c"), 441, 21)
										Result := 21
										js.return
										if not js.return_called then
											js.break
										end
									end
									js.reset
								elseif l_error_type = 4 then
									from
									until
										js.loop_left
									loop
										js.reset
										error_inst.gsl_error (ce_string ("roundoff error detected in extrapolation table"), ce_string ("qawo.c"), 445, 18)
										Result := 18
										js.return
										if not js.return_called then
											js.break
										end
									end
									js.reset
								elseif l_error_type = 5 then
									from
									until
										js.loop_left
									loop
										js.reset
										error_inst.gsl_error (ce_string ("integral is divergent, or slowly convergent"), ce_string ("qawo.c"), 449, 22)
										Result := 22
										js.return
										if not js.return_called then
											js.break
										end
									end
									js.reset
								elseif l_error_type = -1 then
									from
									until
										js.loop_left
									loop
										js.reset
										error_inst.gsl_error (ce_string ("exceeded limit of trigonometric table"), ce_string ("qawo.c"), 453, 26)
										Result := 26
										js.return
										if not js.return_called then
											js.break
										end
									end
									js.reset
								else
									from
									until
										js.loop_left
									loop
										js.reset
										error_inst.gsl_error (ce_string ("could not integrate function"), ce_string ("qawo.c"), 457, 5)
										Result := 5
										js.return
										if not js.return_called then
											js.break
										end
									end
									js.reset
								end
				when 40 then -- if done
							if not js.return_called then
								Result := 0
							end
				when 41 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

end
