class
	P_QAWS

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_integration_qaws (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_a___5: REAL_64; a_b___0: REAL_64; a_t: CE_POINTER [PD_GSL_INTEGRATION_QAWS_TABLE]; a_epsabs: REAL_64; a_epsrel: REAL_64; a_limit: NATURAL_32; a_workspace: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]; a_result: CE_POINTER [REAL_64]; a_abserr: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_area: REAL_64
			l_errsum: REAL_64
			l_result0: REAL_64
			l_abserr0: REAL_64
			l_tolerance: REAL_64
			l_iteration: NATURAL_32
			l_roundoff_type1: INTEGER_32
			l_roundoff_type2: INTEGER_32
			l_error_type: INTEGER_32
			l_area1: REAL_64
			l_area2: REAL_64
			l_error1: REAL_64
			l_error2: REAL_64
			l_err_reliable1: INTEGER_32
			l_err_reliable2: INTEGER_32
			l_a1___4: REAL_64
			l_b1___0: REAL_64
			l_a2___3: REAL_64
			l_b2: REAL_64
			l_a1___5: REAL_64
			l_b1___1: REAL_64
			l_a2___4: REAL_64
			l_b2___0: REAL_64
			l_a_i: REAL_64
			l_b_i: REAL_64
			l_r_i: REAL_64
			l_e_i: REAL_64
			l_area1___0: REAL_64
			l_area2___0: REAL_64
			l_area12: REAL_64
			l_error1___0: REAL_64
			l_error2___0: REAL_64
			l_error12: REAL_64
			l_err_reliable1___0: INTEGER_32
			l_err_reliable2___0: INTEGER_32
			l_delta___0: REAL_64
			l_tmp___1: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_iteration := (0).to_natural_32
					l_roundoff_type1 := 0
					l_roundoff_type2 := 0
					l_error_type := 0
					initialise_inst.initialise (a_workspace, a_a___5, a_b___0)
					a_result.item := (0).to_double
					a_abserr.item := (0).to_double
					if a_limit > a_workspace.item.limit then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("iteration limit exceeds available workspace"), ce_string ("qaws.c"), 57, 4)
							Result := 4
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called and then (a_b___0 <= a_a___5) then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("limits must form an ascending sequence, a < b"), ce_string ("qaws.c"), 62, 4)
							Result := 4
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not (not js.return_called and then (a_epsabs <= (0).to_double)) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (a_epsrel < (50).to_double * 2.2204460492503131e-16) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_epsrel < 0.5e-28) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("tolerance cannot be acheived with given epsabs and epsrel"), ce_string ("qaws.c"), 68, 13)
							Result := 13
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 6 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 11 -- skip if block
						end
				when 7 then -- if:
							l_a1___4 := a_a___5
							l_b1___0 := 0.5 * (a_a___5 + a_b___0)
							l_a2___3 := l_b1___0
							l_b2 := a_b___0
							qc25s_inst.qc25s (a_f, a_a___5, a_b___0, l_a1___4, l_b1___0, a_t, create {CE_POINTER [REAL_64]}.make_shared ($l_area1), create {CE_POINTER [REAL_64]}.make_shared ($l_error1), create {CE_POINTER [INTEGER_32]}.make_shared ($l_err_reliable1))
							qc25s_inst.qc25s (a_f, a_a___5, a_b___0, l_a2___3, l_b2, a_t, create {CE_POINTER [REAL_64]}.make_shared ($l_area2), create {CE_POINTER [REAL_64]}.make_shared ($l_error2), create {CE_POINTER [INTEGER_32]}.make_shared ($l_err_reliable2))
							if l_error1 > l_error2 then
								append_inst.append_interval (a_workspace, l_a1___4, l_b1___0, l_area1, l_error1)
								append_inst.append_interval (a_workspace, l_a2___3, l_b2, l_area2, l_error2)
							else
								append_inst.append_interval (a_workspace, l_a2___3, l_b2, l_area2, l_error2)
								append_inst.append_interval (a_workspace, l_a1___4, l_b1___0, l_area1, l_error1)
							end
							l_result0 := l_area1 + l_area2
							l_abserr0 := l_error1 + l_error2
							l_tolerance := gsl_gsl_minmax_inst.GSL_MAX_DBL (a_epsabs, a_epsrel * (fabs (l_result0)))
							if not (l_abserr0 < l_tolerance) then
								l_pos := -1 + 10 -- skip if block
							end
				when 8 then -- if:
							if l_abserr0 < 0.01 * (fabs (l_result0)) then
								a_result.item := l_result0
								a_abserr.item := l_abserr0
								Result := 0
								js.return
							else
								l_pos := -1 + 10 -- goto _L___0
							end
				when 9 then -- if block done, skip else block:
							l_pos := -1 + 11
				when 10 then -- else: | _L___0:
							if a_limit = {NATURAL_32} 1 then
								a_result.item := l_result0
								a_abserr.item := l_abserr0
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("a maximum of one iteration was insufficient"), ce_string ("qaws.c"), 119, 11)
									Result := 11
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
							end
				when 11 then -- if done
							if not js.return_called then
								l_area := l_result0
								l_errsum := l_abserr0
								l_iteration := (2).to_natural_32
								from
								until
									js.loop_left
								loop
									js.reset
									l_area1___0 := (0).to_double
									l_area2___0 := (0).to_double
									l_area12 := (0).to_double
									l_error1___0 := (0).to_double
									l_error2___0 := (0).to_double
									l_error12 := (0).to_double
									util_inst.retrieve (a_workspace, create {CE_POINTER [REAL_64]}.make_shared ($l_a_i), create {CE_POINTER [REAL_64]}.make_shared ($l_b_i), create {CE_POINTER [REAL_64]}.make_shared ($l_r_i), create {CE_POINTER [REAL_64]}.make_shared ($l_e_i))
									l_a1___5 := l_a_i
									l_b1___1 := 0.5 * (l_a_i + l_b_i)
									l_a2___4 := l_b1___1
									l_b2___0 := l_b_i
									qc25s_inst.qc25s (a_f, a_a___5, a_b___0, l_a1___5, l_b1___1, a_t, create {CE_POINTER [REAL_64]}.make_shared ($l_area1___0), create {CE_POINTER [REAL_64]}.make_shared ($l_error1___0), create {CE_POINTER [INTEGER_32]}.make_shared ($l_err_reliable1___0))
									qc25s_inst.qc25s (a_f, a_a___5, a_b___0, l_a2___4, l_b2___0, a_t, create {CE_POINTER [REAL_64]}.make_shared ($l_area2___0), create {CE_POINTER [REAL_64]}.make_shared ($l_error2___0), create {CE_POINTER [INTEGER_32]}.make_shared ($l_err_reliable2___0))
									l_area12 := l_area1___0 + l_area2___0
									l_error12 := l_error1___0 + l_error2___0
									l_errsum := l_errsum + (l_error12 - l_e_i)
									l_area := l_area + (l_area12 - l_r_i)
									if l_err_reliable1___0.to_boolean then
										if l_err_reliable2___0.to_boolean then
											l_delta___0 := l_r_i - l_area12
											l_tmp___1 := fabs (l_delta___0)
											if l_tmp___1 <= 1.0e-5 * (fabs (l_area12)) then
												if l_error12 >= 0.99 * l_e_i then
													l_roundoff_type1 := l_roundoff_type1 + 1
												end
											end
											if l_iteration >= {NATURAL_32} 10 then
												if l_error12 > l_e_i then
													l_roundoff_type2 := l_roundoff_type2 + 1
												end
											end
										end
									end
									l_tolerance := gsl_gsl_minmax_inst.GSL_MAX_DBL (a_epsabs, a_epsrel * (fabs (l_area)))
									if l_errsum > l_tolerance then
										if l_roundoff_type1 >= 6 then
											l_error_type := 2
										elseif l_roundoff_type2 >= 20 then
											l_error_type := 2
										end
										if (util_inst.subinterval_too_small (l_a1___5, l_a2___4, l_b2___0)).to_boolean then
											l_error_type := 3
										end
									end
									util_inst.update (a_workspace, l_a1___5, l_b1___1, l_area1___0, l_error1___0, l_a2___4, l_b2___0, l_area2___0, l_error2___0)
									util_inst.retrieve (a_workspace, create {CE_POINTER [REAL_64]}.make_shared ($l_a_i), create {CE_POINTER [REAL_64]}.make_shared ($l_b_i), create {CE_POINTER [REAL_64]}.make_shared ($l_r_i), create {CE_POINTER [REAL_64]}.make_shared ($l_e_i))
									l_iteration := l_iteration + 1
									if l_iteration < a_limit then
										if not l_error_type.to_boolean then
											if not (l_errsum > l_tolerance) then
												js.break
											end
										else
											js.break
										end
									else
										js.break
									end
								end
								js.reset
								a_result.item := util_inst.sum_results (a_workspace)
								a_abserr.item := l_errsum
								if l_errsum <= l_tolerance then
									Result := 0
									js.return
								elseif l_error_type = 2 then
									from
									until
										js.loop_left
									loop
										js.reset
										error_inst.gsl_error (ce_string ("roundoff error prevents tolerance from being achieved"), ce_string ("qaws.c"), 204, 18)
										Result := 18
										js.return
										if not js.return_called then
											js.break
										end
									end
									js.reset
								elseif l_error_type = 3 then
									from
									until
										js.loop_left
									loop
										js.reset
										error_inst.gsl_error (ce_string ("bad integrand behavior found in the integration interval"), ce_string ("qaws.c"), 209, 21)
										Result := 21
										js.return
										if not js.return_called then
											js.break
										end
									end
									js.reset
								elseif l_iteration = a_limit then
									from
									until
										js.loop_left
									loop
										js.reset
										error_inst.gsl_error (ce_string ("maximum number of subdivisions reached"), ce_string ("qaws.c"), 213, 11)
										Result := 11
										js.return
										if not js.return_called then
											js.break
										end
									end
									js.reset
								else
									from
									until
										js.loop_left
									loop
										js.reset
										error_inst.gsl_error (ce_string ("could not integrate function"), ce_string ("qaws.c"), 217, 5)
										Result := 5
										js.return
										if not js.return_called then
											js.break
										end
									end
									js.reset
								end
							end
							if not js.return_called then
								Result := 0
							end
				when 12 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

end
