class
	P_QC25C

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	qc25c (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_a___5: REAL_64; a_b___0: REAL_64; a_c___1: REAL_64; a_result: CE_POINTER [REAL_64]; a_abserr: CE_POINTER [REAL_64]; a_err_reliable: CE_POINTER [INTEGER_32])
		local
			l_cc: REAL_64
			l_resabs: REAL_64
			l_resasc: REAL_64
			l_weighted_function: PD_GSL_FUNCTION_STRUCT
			l_fn_params: PD_FN_CAUCHY_PARAMS
			l_cheb12: CE_ARRAY [REAL_64]
			l_cheb24: CE_ARRAY [REAL_64]
			l_moment: CE_ARRAY [REAL_64]
			l_res12: REAL_64
			l_res24: REAL_64
			l_i: NATURAL_32
		do
			create l_weighted_function.make
			create l_fn_params.make
			create l_cheb12.make (<<13>>)
			create l_cheb24.make (<<25>>)
			create l_moment.make (<<25>>)

			l_cc := (((2).to_double * a_c___1 - a_b___0) - a_a___5) / (a_b___0 - a_a___5)
			if (fabs (l_cc)) > 1.1 then
				l_fn_params.function := a_f
				l_fn_params.singularity := a_c___1
				l_weighted_function.function := fn_cauchy_address
				l_weighted_function.params := create {CE_POINTER [ANY]}.make_cast ((l_fn_params.address))
				qk15_inst.gsl_integration_qk15 ((l_weighted_function.address), a_a___5, a_b___0, a_result, a_abserr, create {CE_POINTER [REAL_64]}.make_shared ($l_resabs), create {CE_POINTER [REAL_64]}.make_shared ($l_resasc))
				if a_abserr.item = l_resasc then
					a_err_reliable.item := 0
				else
					a_err_reliable.item := 1
				end
			else
				l_res12 := (0).to_double
				l_res24 := (0).to_double
				qcheb_inst.gsl_integration_qcheb (a_f, a_a___5, a_b___0, l_cheb12, l_cheb24)
				compute_moments___0 (l_cc, l_moment)
				l_i := (0).to_natural_32
				from
				until
					not (l_i < {NATURAL_32} 13)
				loop
					l_res12 := l_res12 + (l_cheb12[l_i.to_integer_32] * l_moment[l_i.to_integer_32])
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (l_i < {NATURAL_32} 25)
				loop
					l_res24 := l_res24 + (l_cheb24[l_i.to_integer_32] * l_moment[l_i.to_integer_32])
					l_i := l_i + 1
				end
				a_result.item := l_res24
				a_abserr.item := fabs (l_res24 - l_res12)
				a_err_reliable.item := 0
			end
		end

	fn_cauchy (a_x: REAL_64; a_params: CE_POINTER [ANY]): REAL_64
		local
			l_p: CE_POINTER [PD_FN_CAUCHY_PARAMS]
			l_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]
			l_c___1: REAL_64
		do
			create l_p.make
			create l_f.make

			l_p.ce_gets (create {CE_POINTER [PD_FN_CAUCHY_PARAMS]}.make_cast (a_params))
			l_f.ce_gets (l_p.item.function)
			l_c___1 := l_p.item.singularity
			Result := (((l_f.item.function).real_64_item ([a_x, l_f.item.params])) / (a_x - l_c___1))
		end

	fn_cauchy_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent fn_cauchy)
		end

	compute_moments___0 (a_cc: REAL_64; a_moment: CE_POINTER [REAL_64])
		local
			l_k: NATURAL_32
			l_a0___2: REAL_64
			l_a1___4: REAL_64
			l_a2___3: REAL_64
			l_km1: REAL_64
		do
			l_a0___2 := (log ((fabs ((1.0 - a_cc) / (1.0 + a_cc)))))
			l_a1___4 := (2).to_double + l_a0___2 * a_cc
			a_moment[0] := l_a0___2
			a_moment[1] := l_a1___4
			l_k := (2).to_natural_32
			from
			until
				not (l_k < {NATURAL_32} 25)
			loop
				if l_k \\ {NATURAL_32} 2 = {NATURAL_32} 0 then
					l_a2___3 := (2.0 * a_cc) * l_a1___4 - l_a0___2
				else
					l_km1 := l_k.to_real_64 - 1.0
					l_a2___3 := ((2.0 * a_cc) * l_a1___4 - l_a0___2) - 4.0 / (l_km1 * l_km1 - 1.0)
				end
				a_moment[l_k.to_integer_32] := l_a2___3
				l_a0___2 := l_a1___4
				l_a1___4 := l_a2___3
				l_k := l_k + 1
			end
		end

end
