class
	P_QC25F

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	qc25f (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_a___5: REAL_64; a_b___0: REAL_64; a_wf: CE_POINTER [PD_GSL_INTEGRATION_QAWO_TABLE]; a_level: NATURAL_32; a_result: CE_POINTER [REAL_64]; a_abserr: CE_POINTER [REAL_64]; a_resabs: CE_POINTER [REAL_64]; a_resasc: CE_POINTER [REAL_64])
		local
			l_center: REAL_64
			l_half_length: REAL_64
			l_omega: REAL_64
			l_par: REAL_64
			l_weighted_function: PD_GSL_FUNCTION_STRUCT
			l_fn_params: PD_FN_FOURIER_PARAMS
			l_moment: CE_POINTER [REAL_64]
			l_cheb12: CE_ARRAY [REAL_64]
			l_cheb24: CE_ARRAY [REAL_64]
			l_result_abs: REAL_64
			l_res12_cos: REAL_64
			l_res12_sin: REAL_64
			l_res24_cos: REAL_64
			l_res24_sin: REAL_64
			l_est_cos: REAL_64
			l_est_sin: REAL_64
			l_c___1: REAL_64
			l_s: REAL_64
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_k___0: NATURAL_32
			l_tmp: REAL_64
			l_tmp___3: REAL_64
			l_tmp___5: REAL_64
			js: JUMP_STATE
		do
			create l_weighted_function.make
			create l_fn_params.make
			create l_moment.make
			create l_cheb12.make (<<13>>)
			create l_cheb24.make (<<25>>)

			l_center := 0.5 * (a_a___5 + a_b___0)
			l_half_length := 0.5 * (a_b___0 - a_a___5)
			l_omega := a_wf.item.omega
			l_par := l_omega * l_half_length
			if (fabs (l_par)) < (2).to_double then
				l_fn_params.function := a_f
				l_fn_params.omega := l_omega
				if (a_wf.item.sine).to_natural_32 = {NATURAL_32} 1 then
					l_weighted_function.function := fn_sin_address
				else
					l_weighted_function.function := fn_cos_address
				end
				l_weighted_function.params := create {CE_POINTER [ANY]}.make_cast ((l_fn_params.address))
				qk15_inst.gsl_integration_qk15 ((l_weighted_function.address), a_a___5, a_b___0, a_result, a_abserr, a_resabs, a_resasc)
			else
				qcheb_inst.gsl_integration_qcheb (a_f, a_a___5, a_b___0, l_cheb12, l_cheb24)
				if a_level >= a_wf.item.n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("table overflow in internal function"), ce_string ("qc25f.c"), 83, 7)
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
				if not js.return_called then
					l_moment.ce_gets (a_wf.item.chebmo + ({NATURAL_32} 25 * a_level).to_integer_32)
					l_res12_cos := l_cheb12[12] * l_moment[12]
					l_res12_sin := (0).to_double
					l_i := (0).to_natural_32
					from
					until
						not (l_i < {NATURAL_32} 6)
					loop
						l_k := {NATURAL_32} 10 - {NATURAL_32} 2 * l_i
						l_res12_cos := l_res12_cos + (l_cheb12[l_k.to_integer_32] * l_moment[l_k.to_integer_32])
						l_res12_sin := l_res12_sin + (l_cheb12[(l_k + {NATURAL_32} 1).to_integer_32] * l_moment[(l_k + {NATURAL_32} 1).to_integer_32])
						l_i := l_i + 1
					end
					l_res24_cos := l_cheb24[24] * l_moment[24]
					l_res24_sin := (0).to_double
					l_result_abs := fabs (l_cheb24[24])
					l_i := (0).to_natural_32
					from
					until
						not (l_i < {NATURAL_32} 12)
					loop
						l_k___0 := {NATURAL_32} 22 - {NATURAL_32} 2 * l_i
						l_res24_cos := l_res24_cos + (l_cheb24[l_k___0.to_integer_32] * l_moment[l_k___0.to_integer_32])
						l_res24_sin := l_res24_sin + (l_cheb24[(l_k___0 + {NATURAL_32} 1).to_integer_32] * l_moment[(l_k___0 + {NATURAL_32} 1).to_integer_32])
						l_tmp := fabs (l_cheb24[l_k___0.to_integer_32])
						l_result_abs := l_result_abs + (l_tmp + (fabs (l_cheb24[(l_k___0 + {NATURAL_32} 1).to_integer_32])))
						l_i := l_i + 1
					end
					l_est_cos := fabs (l_res24_cos - l_res12_cos)
					l_est_sin := fabs (l_res24_sin - l_res12_sin)
					l_c___1 := l_half_length * (cos (l_center * l_omega))
					l_s := l_half_length * (sin (l_center * l_omega))
					if (a_wf.item.sine).to_natural_32 = {NATURAL_32} 1 then
						a_result.item := l_c___1 * l_res24_sin + l_s * l_res24_cos
						l_tmp___3 := fabs (l_c___1 * l_est_sin)
						a_abserr.item := l_tmp___3 + (fabs (l_s * l_est_cos))
					else
						a_result.item := l_c___1 * l_res24_cos - l_s * l_res24_sin
						l_tmp___5 := fabs (l_c___1 * l_est_cos)
						a_abserr.item := l_tmp___5 + (fabs (l_s * l_est_sin))
					end
					a_resabs.item := l_result_abs * l_half_length
					a_resasc.item := 1.7976931348623157e+308
				end
			end
		end

	fn_sin (a_x: REAL_64; a_params: CE_POINTER [ANY]): REAL_64
		local
			l_p: CE_POINTER [PD_FN_FOURIER_PARAMS]
			l_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]
			l_w: REAL_64
			l_wx: REAL_64
			l_sinwx: REAL_64
		do
			create l_p.make
			create l_f.make

			l_p.ce_gets (create {CE_POINTER [PD_FN_FOURIER_PARAMS]}.make_cast (a_params))
			l_f.ce_gets (l_p.item.function)
			l_w := l_p.item.omega
			l_wx := l_w * a_x
			l_sinwx := (sin (l_wx))
			Result := (((l_f.item.function).real_64_item ([a_x, l_f.item.params])) * l_sinwx)
		end

	fn_sin_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent fn_sin)
		end

	fn_cos (a_x: REAL_64; a_params: CE_POINTER [ANY]): REAL_64
		local
			l_p: CE_POINTER [PD_FN_FOURIER_PARAMS]
			l_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]
			l_w: REAL_64
			l_wx: REAL_64
			l_coswx: REAL_64
		do
			create l_p.make
			create l_f.make

			l_p.ce_gets (create {CE_POINTER [PD_FN_FOURIER_PARAMS]}.make_cast (a_params))
			l_f.ce_gets (l_p.item.function)
			l_w := l_p.item.omega
			l_wx := l_w * a_x
			l_coswx := (cos (l_wx))
			Result := (((l_f.item.function).real_64_item ([a_x, l_f.item.params])) * l_coswx)
		end

	fn_cos_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent fn_cos)
		end

end
