class
	P_QCHEB

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_integration_qcheb (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_a___5: REAL_64; a_b___0: REAL_64; a_cheb12: CE_POINTER [REAL_64]; a_cheb24: CE_POINTER [REAL_64])
		local
			l_i: NATURAL_32
			l_fval: CE_ARRAY [REAL_64]
			l_v: CE_ARRAY [REAL_64]
			l_x: CE_ARRAY [REAL_64]
			l_center: REAL_64
			l_half_length: REAL_64
			l_j: NATURAL_32
			l_u: REAL_64
			l_j___0: NATURAL_32
			l_alam1: REAL_64
			l_alam2: REAL_64
			l_alam1___0: REAL_64
			l_alam2___0: REAL_64
			l_alam: REAL_64
			l_alam___0: REAL_64
			l_part1: REAL_64
			l_part2: REAL_64
			l_part3: REAL_64
			l_alam1___1: REAL_64
			l_alam2___1: REAL_64
			l_alam1___2: REAL_64
			l_alam2___2: REAL_64
			l_alam___1: REAL_64
			l_alam___2: REAL_64
			l_alam___3: REAL_64
			l_alam___4: REAL_64
			l_j___1: NATURAL_32
			l_alam1___3: REAL_64
			l_alam2___3: REAL_64
			l_alam___5: REAL_64
			l_alam___6: REAL_64
			l_alam___7: REAL_64
			l_j___2: NATURAL_32
			l_alam___8: REAL_64
			l_alam___9: REAL_64
			l_alam___10: REAL_64
		do
			create l_fval.make (<<25>>)
			create l_v.make (<<12>>)
			create l_x.make (<<11>>)

			l_x[0] := 0.9914448613738104
			l_x[1] := 0.9659258262890683
			l_x[2] := 0.9238795325112868
			l_x[3] := 0.8660254037844386
			l_x[4] := 0.7933533402912352
			l_x[5] := 0.7071067811865475
			l_x[6] := 0.6087614290087206
			l_x[7] := 0.5000000000000000
			l_x[8] := 0.3826834323650898
			l_x[9] := 0.2588190451025208
			l_x[10] := 0.1305261922200516
			l_center := 0.5 * (a_b___0 + a_a___5)
			l_half_length := 0.5 * (a_b___0 - a_a___5)
			l_fval[0] := 0.5 * ((a_f.item.function).real_64_item ([a_b___0, a_f.item.params]))
			l_fval[12] := (a_f.item.function).real_64_item ([l_center, a_f.item.params])
			l_fval[24] := 0.5 * ((a_f.item.function).real_64_item ([a_a___5, a_f.item.params]))
			l_i := (1).to_natural_32
			from
			until
				not (l_i < {NATURAL_32} 12)
			loop
				l_j := {NATURAL_32} 24 - l_i
				l_u := l_half_length * l_x[(l_i - {NATURAL_32} 1).to_integer_32]
				l_fval[l_i.to_integer_32] := (a_f.item.function).real_64_item ([l_center + l_u, a_f.item.params])
				l_fval[l_j.to_integer_32] := (a_f.item.function).real_64_item ([l_center - l_u, a_f.item.params])
				l_i := l_i + 1
			end
			l_i := (0).to_natural_32
			from
			until
				not (l_i < {NATURAL_32} 12)
			loop
				l_j___0 := {NATURAL_32} 24 - l_i
				l_v[l_i.to_integer_32] := l_fval[l_i.to_integer_32] - l_fval[l_j___0.to_integer_32]
				l_fval[l_i.to_integer_32] := l_fval[l_i.to_integer_32] + (l_fval[l_j___0.to_integer_32])
				l_i := l_i + 1
			end
			l_alam1 := l_v[0] - l_v[8]
			l_alam2 := l_x[5] * ((l_v[2] - l_v[6]) - l_v[10])
			a_cheb12[3] := l_alam1 + l_alam2
			a_cheb12[9] := l_alam1 - l_alam2
			l_alam1___0 := (l_v[1] - l_v[7]) - l_v[9]
			l_alam2___0 := (l_v[3] - l_v[5]) - l_v[11]
			l_alam := l_x[2] * l_alam1___0 + l_x[8] * l_alam2___0
			a_cheb24[3] := a_cheb12[3] + l_alam
			a_cheb24[21] := a_cheb12[3] - l_alam
			l_alam___0 := l_x[8] * l_alam1___0 - l_x[2] * l_alam2___0
			a_cheb24[9] := a_cheb12[9] + l_alam___0
			a_cheb24[15] := a_cheb12[9] - l_alam___0
			l_part1 := l_x[3] * l_v[4]
			l_part2 := l_x[7] * l_v[8]
			l_part3 := l_x[5] * l_v[6]
			l_alam1___1 := (l_v[0] + l_part1) + l_part2
			l_alam2___1 := (l_x[1] * l_v[2] + l_part3) + l_x[9] * l_v[10]
			a_cheb12[1] := l_alam1___1 + l_alam2___1
			a_cheb12[11] := l_alam1___1 - l_alam2___1
			l_alam1___2 := (l_v[0] - l_part1) + l_part2
			l_alam2___2 := (l_x[9] * l_v[2] - l_part3) + l_x[1] * l_v[10]
			a_cheb12[5] := l_alam1___2 + l_alam2___2
			a_cheb12[7] := l_alam1___2 - l_alam2___2
			l_alam___1 := ((((l_x[0] * l_v[1] + l_x[2] * l_v[3]) + l_x[4] * l_v[5]) + l_x[6] * l_v[7]) + l_x[8] * l_v[9]) + l_x[10] * l_v[11]
			a_cheb24[1] := a_cheb12[1] + l_alam___1
			a_cheb24[23] := a_cheb12[1] - l_alam___1
			l_alam___2 := ((((l_x[10] * l_v[1] - l_x[8] * l_v[3]) + l_x[6] * l_v[5]) - l_x[4] * l_v[7]) + l_x[2] * l_v[9]) - l_x[0] * l_v[11]
			a_cheb24[11] := a_cheb12[11] + l_alam___2
			a_cheb24[13] := a_cheb12[11] - l_alam___2
			l_alam___3 := ((((l_x[4] * l_v[1] - l_x[8] * l_v[3]) - l_x[0] * l_v[5]) - l_x[10] * l_v[7]) + l_x[2] * l_v[9]) + l_x[6] * l_v[11]
			a_cheb24[5] := a_cheb12[5] + l_alam___3
			a_cheb24[19] := a_cheb12[5] - l_alam___3
			l_alam___4 := ((((l_x[6] * l_v[1] - l_x[2] * l_v[3]) - l_x[10] * l_v[5]) + l_x[0] * l_v[7]) - l_x[8] * l_v[9]) - l_x[4] * l_v[11]
			a_cheb24[7] := a_cheb12[7] + l_alam___4
			a_cheb24[17] := a_cheb12[7] - l_alam___4
			l_i := (0).to_natural_32
			from
			until
				not (l_i < {NATURAL_32} 6)
			loop
				l_j___1 := {NATURAL_32} 12 - l_i
				l_v[l_i.to_integer_32] := l_fval[l_i.to_integer_32] - l_fval[l_j___1.to_integer_32]
				l_fval[l_i.to_integer_32] := l_fval[l_i.to_integer_32] + (l_fval[l_j___1.to_integer_32])
				l_i := l_i + 1
			end
			l_alam1___3 := l_v[0] + l_x[7] * l_v[4]
			l_alam2___3 := l_x[3] * l_v[2]
			a_cheb12[2] := l_alam1___3 + l_alam2___3
			a_cheb12[10] := l_alam1___3 - l_alam2___3
			a_cheb12[6] := l_v[0] - l_v[4]
			l_alam___5 := (l_x[1] * l_v[1] + l_x[5] * l_v[3]) + l_x[9] * l_v[5]
			a_cheb24[2] := a_cheb12[2] + l_alam___5
			a_cheb24[22] := a_cheb12[2] - l_alam___5
			l_alam___6 := l_x[5] * ((l_v[1] - l_v[3]) - l_v[5])
			a_cheb24[6] := a_cheb12[6] + l_alam___6
			a_cheb24[18] := a_cheb12[6] - l_alam___6
			l_alam___7 := (l_x[9] * l_v[1] - l_x[5] * l_v[3]) + l_x[1] * l_v[5]
			a_cheb24[10] := a_cheb12[10] + l_alam___7
			a_cheb24[14] := a_cheb12[10] - l_alam___7
			l_i := (0).to_natural_32
			from
			until
				not (l_i < {NATURAL_32} 3)
			loop
				l_j___2 := {NATURAL_32} 6 - l_i
				l_v[l_i.to_integer_32] := l_fval[l_i.to_integer_32] - l_fval[l_j___2.to_integer_32]
				l_fval[l_i.to_integer_32] := l_fval[l_i.to_integer_32] + (l_fval[l_j___2.to_integer_32])
				l_i := l_i + 1
			end
			a_cheb12[4] := l_v[0] + l_x[7] * l_v[2]
			a_cheb12[8] := l_fval[0] - l_x[7] * l_fval[2]
			l_alam___8 := l_x[3] * l_v[1]
			a_cheb24[4] := a_cheb12[4] + l_alam___8
			a_cheb24[20] := a_cheb12[4] - l_alam___8
			l_alam___9 := l_x[7] * l_fval[1] - l_fval[3]
			a_cheb24[8] := a_cheb12[8] + l_alam___9
			a_cheb24[16] := a_cheb12[8] - l_alam___9
			a_cheb12[0] := l_fval[0] + l_fval[2]
			l_alam___10 := l_fval[1] + l_fval[3]
			a_cheb24[0] := a_cheb12[0] + l_alam___10
			a_cheb24[24] := a_cheb12[0] - l_alam___10
			a_cheb12[12] := l_v[0] - l_v[2]
			a_cheb24[12] := a_cheb12[12]
			l_i := (1).to_natural_32
			from
			until
				not (l_i < {NATURAL_32} 12)
			loop
				a_cheb12[l_i.to_integer_32] := a_cheb12[l_i.to_integer_32] * (1.0 / 6.0)
				l_i := l_i + 1
			end
			a_cheb12[0] := a_cheb12[0] * (1.0 / 12.0)
			a_cheb12[12] := a_cheb12[12] * (1.0 / 12.0)
			l_i := (1).to_natural_32
			from
			until
				not (l_i < {NATURAL_32} 24)
			loop
				a_cheb24[l_i.to_integer_32] := a_cheb24[l_i.to_integer_32] * (1.0 / 12.0)
				l_i := l_i + 1
			end
			a_cheb24[0] := a_cheb24[0] * (1.0 / 24.0)
			a_cheb24[24] := a_cheb24[24] * (1.0 / 24.0)
		end

end
