class
	P_QELG

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	initialise_table (a_table: CE_POINTER [PD_EXTRAPOLATION_TABLE])
		do
			a_table.item.n := (0).to_natural_32
			a_table.item.nres := (0).to_natural_32
		end

	append_table (a_table: CE_POINTER [PD_EXTRAPOLATION_TABLE]; a_y: REAL_64)
		local
			l_n: NATURAL_32
		do
			l_n := a_table.item.n
			a_table.item.rlist2[l_n.to_integer_32] := a_y
			a_table.item.n := (a_table.item.n) + 1
		end

	qelg (a_table: CE_POINTER [PD_EXTRAPOLATION_TABLE]; a_result: CE_POINTER [REAL_64]; a_abserr: CE_POINTER [REAL_64])
		local
			l_epstab: CE_POINTER [REAL_64]
			l_res3la: CE_POINTER [REAL_64]
			l_n: NATURAL_32
			l_current: REAL_64
			l_absolute: REAL_64
			l_relative: REAL_64
			l_newelm: NATURAL_32
			l_n_orig: NATURAL_32
			l_n_final: NATURAL_32
			l_i: NATURAL_32
			l_nres_orig: NATURAL_32
			l_res: REAL_64
			l_e0: REAL_64
			l_e1: REAL_64
			l_e2: REAL_64
			l_e1abs: REAL_64
			l_delta2: REAL_64
			l_err2: REAL_64
			l_tol2: REAL_64
			l_delta3: REAL_64
			l_err3: REAL_64
			l_tol3: REAL_64
			l_e3: REAL_64
			l_delta1: REAL_64
			l_err1: REAL_64
			l_tol1: REAL_64
			l_ss: REAL_64
			l_error: REAL_64
			l_limexp: NATURAL_32
			l_tmp___12: REAL_64
			l_tmp___13: REAL_64
			js: JUMP_STATE
		do
			create l_epstab.make
			create l_res3la.make

			l_epstab.ce_gets (a_table.item.rlist2)
			l_res3la.ce_gets (a_table.item.res3la)
			l_n := a_table.item.n - {NATURAL_32} 1
			l_current := l_epstab[l_n.to_integer_32]
			l_absolute := 1.7976931348623157e+308
			l_relative := ((5).to_double * 2.2204460492503131e-16) * (fabs (l_current))
			l_newelm := l_n // {NATURAL_32} 2
			l_n_orig := l_n
			l_n_final := l_n
			l_nres_orig := a_table.item.nres
			a_result.item := l_current
			a_abserr.item := 1.7976931348623157e+308
			if l_n < {NATURAL_32} 2 then
				a_result.item := l_current
				a_abserr.item := gsl_gsl_minmax_inst.GSL_MAX_DBL (l_absolute, l_relative)
				js.return
			end
			if not js.return_called then
				l_epstab[(l_n + {NATURAL_32} 2).to_integer_32] := l_epstab[l_n.to_integer_32]
				l_epstab[l_n.to_integer_32] := 1.7976931348623157e+308
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_newelm))
				loop
					js.reset
					l_res := l_epstab[((l_n - {NATURAL_32} 2 * l_i) + {NATURAL_32} 2).to_integer_32]
					l_e0 := l_epstab[((l_n - {NATURAL_32} 2 * l_i) - {NATURAL_32} 2).to_integer_32]
					l_e1 := l_epstab[((l_n - {NATURAL_32} 2 * l_i) - {NATURAL_32} 1).to_integer_32]
					l_e2 := l_res
					l_e1abs := (fabs (l_e1))
					l_delta2 := l_e2 - l_e1
					l_err2 := (fabs (l_delta2))
					l_tol2 := (gsl_gsl_minmax_inst.GSL_MAX_DBL ((fabs (l_e2)), l_e1abs)) * 2.2204460492503131e-16
					l_delta3 := l_e1 - l_e0
					l_err3 := (fabs (l_delta3))
					l_tol3 := (gsl_gsl_minmax_inst.GSL_MAX_DBL (l_e1abs, (fabs (l_e0)))) * 2.2204460492503131e-16
					if l_err2 <= l_tol2 then
						if l_err3 <= l_tol3 then
							a_result.item := l_res
							l_absolute := l_err2 + l_err3
							l_relative := ((5).to_double * 2.2204460492503131e-16) * (fabs (l_res))
							a_abserr.item := gsl_gsl_minmax_inst.GSL_MAX_DBL (l_absolute, l_relative)
							js.return
						end
					end
					if not js.return_called then
						l_e3 := l_epstab[(l_n - {NATURAL_32} 2 * l_i).to_integer_32]
						l_epstab[(l_n - {NATURAL_32} 2 * l_i).to_integer_32] := l_e1
						l_delta1 := l_e1 - l_e3
						l_err1 := fabs (l_delta1)
						l_tol1 := (gsl_gsl_minmax_inst.GSL_MAX_DBL (l_e1abs, (fabs (l_e3)))) * 2.2204460492503131e-16
						if l_err1 <= l_tol1 then
							l_n_final := {NATURAL_32} 2 * l_i
							js.break
						elseif l_err2 <= l_tol2 then
							l_n_final := {NATURAL_32} 2 * l_i
							js.break
						elseif l_err3 <= l_tol3 then
							l_n_final := {NATURAL_32} 2 * l_i
							js.break
						end
						if not js.loop_jumped then
							l_ss := ((1).to_double / l_delta1 + (1).to_double / l_delta2) - (1).to_double / l_delta3
							if (fabs (l_ss * l_e1)) <= 0.0001 then
								l_n_final := {NATURAL_32} 2 * l_i
								js.break
							end
						end
						if not js.loop_jumped then
							l_res := l_e1 + (1).to_double / l_ss
							l_epstab[(l_n - {NATURAL_32} 2 * l_i).to_integer_32] := l_res
							l_error := (l_err2 + (fabs (l_res - l_e2))) + l_err3
							if l_error <= a_abserr.item then
								a_abserr.item := l_error
								a_result.item := l_res
							end
							l_i := l_i + 1
						end
					end
				end
				js.reset
			end
			if not js.return_called then
				l_limexp := (49).to_natural_32
				if l_n_final = l_limexp then
					l_n_final := {NATURAL_32} 2 * (l_limexp // {NATURAL_32} 2)
				end
				if l_n_orig \\ {NATURAL_32} 2 = {NATURAL_32} 1 then
					l_i := (0).to_natural_32
					from
					until
						not (l_i <= l_newelm)
					loop
						l_epstab[({NATURAL_32} 1 + l_i * {NATURAL_32} 2).to_integer_32] := l_epstab[(l_i * {NATURAL_32} 2 + {NATURAL_32} 3).to_integer_32]
						l_i := l_i + 1
					end
				else
					l_i := (0).to_natural_32
					from
					until
						not (l_i <= l_newelm)
					loop
						l_epstab[(l_i * {NATURAL_32} 2).to_integer_32] := l_epstab[(l_i * {NATURAL_32} 2 + {NATURAL_32} 2).to_integer_32]
						l_i := l_i + 1
					end
				end
				if l_n_orig /= l_n_final then
					l_i := (0).to_natural_32
					from
					until
						not (l_i <= l_n_final)
					loop
						l_epstab[l_i.to_integer_32] := l_epstab[((l_n_orig - l_n_final) + l_i).to_integer_32]
						l_i := l_i + 1
					end
				end
				a_table.item.n := l_n_final + {NATURAL_32} 1
				if l_nres_orig < {NATURAL_32} 3 then
					l_res3la[l_nres_orig.to_integer_32] := a_result.item
					a_abserr.item := 1.7976931348623157e+308
				else
					l_tmp___12 := fabs (a_result.item - l_res3la[2])
					l_tmp___13 := fabs (a_result.item - l_res3la[1])
					a_abserr.item := (l_tmp___12 + l_tmp___13) + (fabs (a_result.item - l_res3la[0]))
					l_res3la[0] := l_res3la[1]
					l_res3la[1] := l_res3la[2]
					l_res3la[2] := a_result.item
				end
				a_table.item.nres := l_nres_orig + {NATURAL_32} 1
				a_abserr.item := gsl_gsl_minmax_inst.GSL_MAX_DBL (a_abserr.item, ((5).to_double * 2.2204460492503131e-16) * (fabs (a_result.item)))
			end
		end

	initialise_table___0 (a_table: CE_POINTER [PD_EXTRAPOLATION_TABLE])
		do
			a_table.item.n := (0).to_natural_32
			a_table.item.nres := (0).to_natural_32
		end

	append_table___0 (a_table: CE_POINTER [PD_EXTRAPOLATION_TABLE]; a_y: REAL_64)
		local
			l_n: NATURAL_32
		do
			l_n := a_table.item.n
			a_table.item.rlist2[l_n.to_integer_32] := a_y
			a_table.item.n := (a_table.item.n) + 1
		end

	initialise_table___1 (a_table: CE_POINTER [PD_EXTRAPOLATION_TABLE])
		do
			a_table.item.n := (0).to_natural_32
			a_table.item.nres := (0).to_natural_32
		end

	append_table___1 (a_table: CE_POINTER [PD_EXTRAPOLATION_TABLE]; a_y: REAL_64)
		local
			l_n: NATURAL_32
		do
			l_n := a_table.item.n
			a_table.item.rlist2[l_n.to_integer_32] := a_y
			a_table.item.n := (a_table.item.n) + 1
		end

	initialise_table___2 (a_table: CE_POINTER [PD_EXTRAPOLATION_TABLE])
		do
			a_table.item.n := (0).to_natural_32
			a_table.item.nres := (0).to_natural_32
		end

	append_table___2 (a_table: CE_POINTER [PD_EXTRAPOLATION_TABLE]; a_y: REAL_64)
		local
			l_n: NATURAL_32
		do
			l_n := a_table.item.n
			a_table.item.rlist2[l_n.to_integer_32] := a_y
			a_table.item.n := (a_table.item.n) + 1
		end

end
