class
	P_QMOMO

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_integration_qaws_table_alloc (a_alpha: REAL_64; a_beta: REAL_64; a_mu: INTEGER_32; a_nu: INTEGER_32): CE_POINTER [PD_GSL_INTEGRATION_QAWS_TABLE]
		local
			l_t: CE_POINTER [PD_GSL_INTEGRATION_QAWS_TABLE]
			js: JUMP_STATE
		do
			create l_t.make

			if a_alpha < -1.0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("alpha must be greater than -1.0"), ce_string ("qmomo.c"), 36, 4)
					Result := (create {CE_POINTER [PD_GSL_INTEGRATION_QAWS_TABLE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_beta < -1.0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("beta must be greater than -1.0"), ce_string ("qmomo.c"), 41, 4)
					Result := (create {CE_POINTER [PD_GSL_INTEGRATION_QAWS_TABLE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_mu /= 0) then
				if a_mu /= 1 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("mu must be 0 or 1"), ce_string ("qmomo.c"), 46, 4)
						Result := (create {CE_POINTER [PD_GSL_INTEGRATION_QAWS_TABLE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called and then (a_nu /= 0) then
				if a_nu /= 1 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("nu must be 0 or 1"), ce_string ("qmomo.c"), 51, 4)
						Result := (create {CE_POINTER [PD_GSL_INTEGRATION_QAWS_TABLE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_t.ce_gets (create {CE_POINTER [PD_GSL_INTEGRATION_QAWS_TABLE]}.make_cast ((malloc ({PD_GSL_INTEGRATION_QAWS_TABLE}.sizeof.to_natural_32))))
				if (l_t.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for qaws_table struct"), ce_string ("qmomo.c"), 60, 8)
						Result := (create {CE_POINTER [PD_GSL_INTEGRATION_QAWS_TABLE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_t.item.alpha := a_alpha
				l_t.item.beta := a_beta
				l_t.item.mu := a_mu
				l_t.item.nu := a_nu
				initialise___1 (l_t.item.ri, l_t.item.rj, l_t.item.rg, l_t.item.rh, a_alpha, a_beta)
				Result := l_t
			end
		end

	gsl_integration_qaws_table_set (a_t: CE_POINTER [PD_GSL_INTEGRATION_QAWS_TABLE]; a_alpha: REAL_64; a_beta: REAL_64; a_mu: INTEGER_32; a_nu: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_alpha < -1.0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("alpha must be greater than -1.0"), ce_string ("qmomo.c"), 80, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_beta < -1.0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("beta must be greater than -1.0"), ce_string ("qmomo.c"), 85, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_mu /= 0) then
				if a_mu /= 1 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("mu must be 0 or 1"), ce_string ("qmomo.c"), 90, 4)
						Result := 4
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called and then (a_nu /= 0) then
				if a_nu /= 1 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("nu must be 0 or 1"), ce_string ("qmomo.c"), 95, 4)
						Result := 4
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				a_t.item.alpha := a_alpha
				a_t.item.beta := a_beta
				a_t.item.mu := a_mu
				a_t.item.nu := a_nu
				initialise___1 (a_t.item.ri, a_t.item.rj, a_t.item.rg, a_t.item.rh, a_alpha, a_beta)
				Result := 0
			end
		end

	gsl_integration_qaws_table_free (a_t: CE_POINTER [PD_GSL_INTEGRATION_QAWS_TABLE])
		local
			js: JUMP_STATE
		do
			if (a_t).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (a_t))
			end
		end

	initialise___1 (a_ri: CE_POINTER [REAL_64]; a_rj: CE_POINTER [REAL_64]; a_rg: CE_POINTER [REAL_64]; a_rh: CE_POINTER [REAL_64]; a_alpha: REAL_64; a_beta: REAL_64)
		local
			l_alpha_p1: REAL_64
			l_beta_p1: REAL_64
			l_alpha_p2: REAL_64
			l_beta_p2: REAL_64
			l_r_alpha: REAL_64
			l_r_beta: REAL_64
			l_i: NATURAL_32
			l_an: REAL_64
			l_anm1: REAL_64
		do
			l_alpha_p1 := a_alpha + 1.0
			l_beta_p1 := a_beta + 1.0
			l_alpha_p2 := a_alpha + 2.0
			l_beta_p2 := a_beta + 2.0
			l_r_alpha := (pow (2.0, l_alpha_p1))
			l_r_beta := (pow (2.0, l_beta_p1))
			a_ri[0] := l_r_alpha / l_alpha_p1
			a_ri[1] := (a_ri[0] * a_alpha) / l_alpha_p2
			l_an := 2.0
			l_anm1 := 1.0
			l_i := (2).to_natural_32
			from
			until
				not (l_i < {NATURAL_32} 25)
			loop
				a_ri[l_i.to_integer_32] := -(l_r_alpha + (l_an * (l_an - l_alpha_p2)) * a_ri[(l_i - {NATURAL_32} 1).to_integer_32]) / (l_anm1 * (l_an + l_alpha_p1))
				l_anm1 := l_an
				l_an := l_an + (1.0)
				l_i := l_i + 1
			end
			a_rj[0] := l_r_beta / l_beta_p1
			a_rj[1] := (a_rj[0] * a_beta) / l_beta_p2
			l_an := 2.0
			l_anm1 := 1.0
			l_i := (2).to_natural_32
			from
			until
				not (l_i < {NATURAL_32} 25)
			loop
				a_rj[l_i.to_integer_32] := -(l_r_beta + (l_an * (l_an - l_beta_p2)) * a_rj[(l_i - {NATURAL_32} 1).to_integer_32]) / (l_anm1 * (l_an + l_beta_p1))
				l_anm1 := l_an
				l_an := l_an + (1.0)
				l_i := l_i + 1
			end
			a_rg[0] := -a_ri[0] / l_alpha_p1
			a_rg[1] := -a_rg[0] - (2.0 * l_r_alpha) / (l_alpha_p2 * l_alpha_p2)
			l_an := 2.0
			l_anm1 := 1.0
			l_i := (2).to_natural_32
			from
			until
				not (l_i < {NATURAL_32} 25)
			loop
				a_rg[l_i.to_integer_32] := -(((l_an * (l_an - l_alpha_p2)) * a_rg[(l_i - {NATURAL_32} 1).to_integer_32] - l_an * a_ri[(l_i - {NATURAL_32} 1).to_integer_32]) + l_anm1 * a_ri[l_i.to_integer_32]) / (l_anm1 * (l_an + l_alpha_p1))
				l_anm1 := l_an
				l_an := l_an + (1.0)
				l_i := l_i + 1
			end
			a_rh[0] := -a_rj[0] / l_beta_p1
			a_rh[1] := -a_rh[0] - (2.0 * l_r_beta) / (l_beta_p2 * l_beta_p2)
			l_an := 2.0
			l_anm1 := 1.0
			l_i := (2).to_natural_32
			from
			until
				not (l_i < {NATURAL_32} 25)
			loop
				a_rh[l_i.to_integer_32] := -(((l_an * (l_an - l_beta_p2)) * a_rh[(l_i - {NATURAL_32} 1).to_integer_32] - l_an * a_rj[(l_i - {NATURAL_32} 1).to_integer_32]) + l_anm1 * a_rj[l_i.to_integer_32]) / (l_anm1 * (l_an + l_beta_p1))
				l_anm1 := l_an
				l_an := l_an + (1.0)
				l_i := l_i + 1
			end
			l_i := (1).to_natural_32
			from
			until
				not (l_i < {NATURAL_32} 25)
			loop
				a_rj[l_i.to_integer_32] := a_rj[l_i.to_integer_32] * (-1).to_double
				a_rh[l_i.to_integer_32] := a_rh[l_i.to_integer_32] * (-1).to_double
				l_i := l_i + ({NATURAL_32} 2)
			end
		end

end
