class
	P_QRSTEP

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	chop_small_elements (a_N: NATURAL_32; a_d: CE_POINTER [REAL_64]; a_sd: CE_POINTER [REAL_64])
		local
			l_d_i: REAL_64
			l_i: NATURAL_32
			l_sd_i: REAL_64
			l_d_ip1: REAL_64
			l_tmp: REAL_64
			l_tmp___0: REAL_64
		do
			l_d_i := a_d[0]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_N - {NATURAL_32} 1)
			loop
				l_sd_i := a_sd[l_i.to_integer_32]
				l_d_ip1 := a_d[(l_i + {NATURAL_32} 1).to_integer_32]
				l_tmp := fabs (l_sd_i)
				l_tmp___0 := fabs (l_d_i)
				if l_tmp < 2.2204460492503131e-16 * (l_tmp___0 + (fabs (l_d_ip1))) then
					a_sd[l_i.to_integer_32] := 0.0
				end
				l_d_i := l_d_ip1
				l_i := l_i + 1
			end
		end

	create_givens (a_a___5: REAL_64; a_b___0: REAL_64; a_c___1: CE_POINTER [REAL_64]; a_s: CE_POINTER [REAL_64])
		local
			l_t: REAL_64
			l_s1: REAL_64
			l_t___0: REAL_64
			l_c1___2: REAL_64
			l_tmp___1: REAL_64
		do
			if a_b___0 = (0).to_double then
				a_c___1.item := (1).to_double
				a_s.item := (0).to_double
			else
				l_tmp___1 := fabs (a_b___0)
				if l_tmp___1 > (fabs (a_a___5)) then
					l_t := -a_a___5 / a_b___0
					l_s1 := 1.0 / (sqrt ((1).to_double + l_t * l_t))
					a_s.item := l_s1
					a_c___1.item := l_s1 * l_t
				else
					l_t___0 := -a_b___0 / a_a___5
					l_c1___2 := 1.0 / (sqrt ((1).to_double + l_t___0 * l_t___0))
					a_c___1.item := l_c1___2
					a_s.item := l_c1___2 * l_t___0
				end
			end
		end

	trailing_eigenvalue (a_n: NATURAL_32; a_d: CE_POINTER [REAL_64]; a_sd: CE_POINTER [REAL_64]): REAL_64
		local
			l_ta: REAL_64
			l_tb: REAL_64
			l_tab: REAL_64
			l_dt: REAL_64
			l_mu: REAL_64
		do
			l_ta := a_d[(a_n - {NATURAL_32} 2).to_integer_32]
			l_tb := a_d[(a_n - {NATURAL_32} 1).to_integer_32]
			l_tab := a_sd[(a_n - {NATURAL_32} 2).to_integer_32]
			l_dt := (l_ta - l_tb) / 2.0
			if l_dt > (0).to_double then
				l_mu := l_tb - l_tab * (l_tab / (l_dt + (hypot (l_dt, l_tab))))
			elseif l_dt = (0).to_double then
				l_mu := l_tb - (fabs (l_tab))
			else
				l_mu := l_tb + l_tab * (l_tab / (-l_dt + (hypot (l_dt, l_tab))))
			end
			Result := l_mu
		end

	qrstep (a_n: NATURAL_32; a_d: CE_POINTER [REAL_64]; a_sd: CE_POINTER [REAL_64]; a_gc: CE_POINTER [REAL_64]; a_gs: CE_POINTER [REAL_64])
		local
			l_x: REAL_64
			l_z: REAL_64
			l_ak: REAL_64
			l_bk: REAL_64
			l_zk: REAL_64
			l_ap: REAL_64
			l_bp: REAL_64
			l_aq: REAL_64
			l_bq: REAL_64
			l_k: NATURAL_32
			l_mu: REAL_64
			l_tmp___0: REAL_64
			l_tmp___1: REAL_64
			l_c___1: REAL_64
			l_s: REAL_64
			l_ap1: REAL_64
			l_bp1: REAL_64
			l_aq1: REAL_64
			l_c___2: REAL_64
			l_s___0: REAL_64
			l_bk1: REAL_64
			l_ap1___0: REAL_64
			l_bp1___0: REAL_64
			l_zp1: REAL_64
			l_aq1___0: REAL_64
			l_bq1: REAL_64
			js: JUMP_STATE
		do
			l_mu := (trailing_eigenvalue (a_n, a_d, a_sd))
			l_tmp___0 := fabs (l_mu)
			l_tmp___1 := fabs (a_d[0])
			if 2.2204460492503131e-16 * l_tmp___0 > l_tmp___1 + (fabs (a_sd[0])) then
				l_mu := (0).to_double
			end
			l_x := a_d[0] - l_mu
			l_z := a_sd[0]
			l_ak := (0).to_double
			l_bk := (0).to_double
			l_zk := (0).to_double
			l_ap := a_d[0]
			l_bp := a_sd[0]
			l_aq := a_d[1]
			if a_n = {NATURAL_32} 2 then
				create_givens (l_x, l_z, create {CE_POINTER [REAL_64]}.make_shared ($l_c___1), create {CE_POINTER [REAL_64]}.make_shared ($l_s))
				if (a_gc.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					a_gc[0] := l_c___1
				end
				if (a_gs.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					a_gs[0] := l_s
				end
				l_ap1 := l_c___1 * (l_c___1 * l_ap - l_s * l_bp) + l_s * (l_s * l_aq - l_c___1 * l_bp)
				l_bp1 := l_c___1 * (l_s * l_ap + l_c___1 * l_bp) - l_s * (l_s * l_bp + l_c___1 * l_aq)
				l_aq1 := l_s * (l_s * l_ap + l_c___1 * l_bp) + l_c___1 * (l_s * l_bp + l_c___1 * l_aq)
				l_ak := l_ap1
				l_bk := l_bp1
				l_ap := l_aq1
				a_d[0] := l_ak
				a_sd[0] := l_bk
				a_d[1] := l_ap
				js.return
			end
			if not js.return_called then
				l_bq := a_sd[1]
				l_k := (0).to_natural_32
				from
				until
					not (l_k < a_n - {NATURAL_32} 1)
				loop
					create_givens (l_x, l_z, create {CE_POINTER [REAL_64]}.make_shared ($l_c___2), create {CE_POINTER [REAL_64]}.make_shared ($l_s___0))
					if (a_gc.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						a_gc[l_k.to_integer_32] := l_c___2
					end
					if (a_gs.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						a_gs[l_k.to_integer_32] := l_s___0
					end
					l_bk1 := l_c___2 * l_bk - l_s___0 * l_zk
					l_ap1___0 := l_c___2 * (l_c___2 * l_ap - l_s___0 * l_bp) + l_s___0 * (l_s___0 * l_aq - l_c___2 * l_bp)
					l_bp1___0 := l_c___2 * (l_s___0 * l_ap + l_c___2 * l_bp) - l_s___0 * (l_s___0 * l_bp + l_c___2 * l_aq)
					l_zp1 := -l_s___0 * l_bq
					l_aq1___0 := l_s___0 * (l_s___0 * l_ap + l_c___2 * l_bp) + l_c___2 * (l_s___0 * l_bp + l_c___2 * l_aq)
					l_bq1 := l_c___2 * l_bq
					l_ak := l_ap1___0
					l_bk := l_bp1___0
					l_zk := l_zp1
					l_ap := l_aq1___0
					l_bp := l_bq1
					if l_k < a_n - {NATURAL_32} 2 then
						l_aq := a_d[(l_k + {NATURAL_32} 2).to_integer_32]
					end
					if l_k < a_n - {NATURAL_32} 3 then
						l_bq := a_sd[(l_k + {NATURAL_32} 2).to_integer_32]
					end
					a_d[l_k.to_integer_32] := l_ak
					if l_k > {NATURAL_32} 0 then
						a_sd[(l_k - {NATURAL_32} 1).to_integer_32] := l_bk1
					end
					if l_k < a_n - {NATURAL_32} 2 then
						a_sd[(l_k + {NATURAL_32} 1).to_integer_32] := l_bp
					end
					l_x := l_bk
					l_z := l_zk
					l_k := l_k + 1
				end
				a_d[l_k.to_integer_32] := l_ap
				a_sd[(l_k - {NATURAL_32} 1).to_integer_32] := l_bk
			end
		end

	chop_small_elements___0 (a_N: NATURAL_32; a_d: CE_POINTER [REAL_64]; a_sd: CE_POINTER [REAL_64])
		local
			l_d_i: REAL_64
			l_i: NATURAL_32
			l_sd_i: REAL_64
			l_d_ip1: REAL_64
			l_tmp: REAL_64
			l_tmp___0: REAL_64
		do
			l_d_i := a_d[0]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_N - {NATURAL_32} 1)
			loop
				l_sd_i := a_sd[l_i.to_integer_32]
				l_d_ip1 := a_d[(l_i + {NATURAL_32} 1).to_integer_32]
				l_tmp := fabs (l_sd_i)
				l_tmp___0 := fabs (l_d_i)
				if l_tmp < 2.2204460492503131e-16 * (l_tmp___0 + (fabs (l_d_ip1))) then
					a_sd[l_i.to_integer_32] := 0.0
				end
				l_d_i := l_d_ip1
				l_i := l_i + 1
			end
		end

	qrstep___0 (a_n: NATURAL_32; a_d: CE_POINTER [REAL_64]; a_sd: CE_POINTER [REAL_64]; a_gc: CE_POINTER [REAL_64]; a_gs: CE_POINTER [REAL_64])
		local
			l_x: REAL_64
			l_z: REAL_64
			l_ak: REAL_64
			l_bk: REAL_64
			l_zk: REAL_64
			l_ap: REAL_64
			l_bp: REAL_64
			l_aq: REAL_64
			l_bq: REAL_64
			l_k: NATURAL_32
			l_mu: REAL_64
			l_tmp___0: REAL_64
			l_tmp___1: REAL_64
			l_c___1: REAL_64
			l_s: REAL_64
			l_ap1: REAL_64
			l_bp1: REAL_64
			l_aq1: REAL_64
			l_c___2: REAL_64
			l_s___0: REAL_64
			l_bk1: REAL_64
			l_ap1___0: REAL_64
			l_bp1___0: REAL_64
			l_zp1: REAL_64
			l_aq1___0: REAL_64
			l_bq1: REAL_64
			js: JUMP_STATE
		do
			l_mu := (trailing_eigenvalue (a_n, a_d, a_sd))
			l_tmp___0 := fabs (l_mu)
			l_tmp___1 := fabs (a_d[0])
			if 2.2204460492503131e-16 * l_tmp___0 > l_tmp___1 + (fabs (a_sd[0])) then
				l_mu := (0).to_double
			end
			l_x := a_d[0] - l_mu
			l_z := a_sd[0]
			l_ak := (0).to_double
			l_bk := (0).to_double
			l_zk := (0).to_double
			l_ap := a_d[0]
			l_bp := a_sd[0]
			l_aq := a_d[1]
			if a_n = {NATURAL_32} 2 then
				create_givens (l_x, l_z, create {CE_POINTER [REAL_64]}.make_shared ($l_c___1), create {CE_POINTER [REAL_64]}.make_shared ($l_s))
				if (a_gc.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					a_gc[0] := l_c___1
				end
				if (a_gs.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					a_gs[0] := l_s
				end
				l_ap1 := l_c___1 * (l_c___1 * l_ap - l_s * l_bp) + l_s * (l_s * l_aq - l_c___1 * l_bp)
				l_bp1 := l_c___1 * (l_s * l_ap + l_c___1 * l_bp) - l_s * (l_s * l_bp + l_c___1 * l_aq)
				l_aq1 := l_s * (l_s * l_ap + l_c___1 * l_bp) + l_c___1 * (l_s * l_bp + l_c___1 * l_aq)
				l_ak := l_ap1
				l_bk := l_bp1
				l_ap := l_aq1
				a_d[0] := l_ak
				a_sd[0] := l_bk
				a_d[1] := l_ap
				js.return
			end
			if not js.return_called then
				l_bq := a_sd[1]
				l_k := (0).to_natural_32
				from
				until
					not (l_k < a_n - {NATURAL_32} 1)
				loop
					create_givens (l_x, l_z, create {CE_POINTER [REAL_64]}.make_shared ($l_c___2), create {CE_POINTER [REAL_64]}.make_shared ($l_s___0))
					if (a_gc.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						a_gc[l_k.to_integer_32] := l_c___2
					end
					if (a_gs.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						a_gs[l_k.to_integer_32] := l_s___0
					end
					l_bk1 := l_c___2 * l_bk - l_s___0 * l_zk
					l_ap1___0 := l_c___2 * (l_c___2 * l_ap - l_s___0 * l_bp) + l_s___0 * (l_s___0 * l_aq - l_c___2 * l_bp)
					l_bp1___0 := l_c___2 * (l_s___0 * l_ap + l_c___2 * l_bp) - l_s___0 * (l_s___0 * l_bp + l_c___2 * l_aq)
					l_zp1 := -l_s___0 * l_bq
					l_aq1___0 := l_s___0 * (l_s___0 * l_ap + l_c___2 * l_bp) + l_c___2 * (l_s___0 * l_bp + l_c___2 * l_aq)
					l_bq1 := l_c___2 * l_bq
					l_ak := l_ap1___0
					l_bk := l_bp1___0
					l_zk := l_zp1
					l_ap := l_aq1___0
					l_bp := l_bq1
					if l_k < a_n - {NATURAL_32} 2 then
						l_aq := a_d[(l_k + {NATURAL_32} 2).to_integer_32]
					end
					if l_k < a_n - {NATURAL_32} 3 then
						l_bq := a_sd[(l_k + {NATURAL_32} 2).to_integer_32]
					end
					a_d[l_k.to_integer_32] := l_ak
					if l_k > {NATURAL_32} 0 then
						a_sd[(l_k - {NATURAL_32} 1).to_integer_32] := l_bk1
					end
					if l_k < a_n - {NATURAL_32} 2 then
						a_sd[(l_k + {NATURAL_32} 1).to_integer_32] := l_bp
					end
					l_x := l_bk
					l_z := l_zk
					l_k := l_k + 1
				end
				a_d[l_k.to_integer_32] := l_ap
				a_sd[(l_k - {NATURAL_32} 1).to_integer_32] := l_bk
			end
		end

	chop_small_elements___1 (a_N: NATURAL_32; a_d: CE_POINTER [REAL_64]; a_sd: CE_POINTER [REAL_64])
		local
			l_d_i: REAL_64
			l_i: NATURAL_32
			l_sd_i: REAL_64
			l_d_ip1: REAL_64
			l_tmp: REAL_64
			l_tmp___0: REAL_64
		do
			l_d_i := a_d[0]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_N - {NATURAL_32} 1)
			loop
				l_sd_i := a_sd[l_i.to_integer_32]
				l_d_ip1 := a_d[(l_i + {NATURAL_32} 1).to_integer_32]
				l_tmp := fabs (l_sd_i)
				l_tmp___0 := fabs (l_d_i)
				if l_tmp < 2.2204460492503131e-16 * (l_tmp___0 + (fabs (l_d_ip1))) then
					a_sd[l_i.to_integer_32] := 0.0
				end
				l_d_i := l_d_ip1
				l_i := l_i + 1
			end
		end

	qrstep___1 (a_n: NATURAL_32; a_d: CE_POINTER [REAL_64]; a_sd: CE_POINTER [REAL_64]; a_gc: CE_POINTER [REAL_64]; a_gs: CE_POINTER [REAL_64])
		local
			l_x: REAL_64
			l_z: REAL_64
			l_ak: REAL_64
			l_bk: REAL_64
			l_zk: REAL_64
			l_ap: REAL_64
			l_bp: REAL_64
			l_aq: REAL_64
			l_bq: REAL_64
			l_k: NATURAL_32
			l_mu: REAL_64
			l_tmp___0: REAL_64
			l_tmp___1: REAL_64
			l_c___1: REAL_64
			l_s: REAL_64
			l_ap1: REAL_64
			l_bp1: REAL_64
			l_aq1: REAL_64
			l_c___2: REAL_64
			l_s___0: REAL_64
			l_bk1: REAL_64
			l_ap1___0: REAL_64
			l_bp1___0: REAL_64
			l_zp1: REAL_64
			l_aq1___0: REAL_64
			l_bq1: REAL_64
			js: JUMP_STATE
		do
			l_mu := (trailing_eigenvalue (a_n, a_d, a_sd))
			l_tmp___0 := fabs (l_mu)
			l_tmp___1 := fabs (a_d[0])
			if 2.2204460492503131e-16 * l_tmp___0 > l_tmp___1 + (fabs (a_sd[0])) then
				l_mu := (0).to_double
			end
			l_x := a_d[0] - l_mu
			l_z := a_sd[0]
			l_ak := (0).to_double
			l_bk := (0).to_double
			l_zk := (0).to_double
			l_ap := a_d[0]
			l_bp := a_sd[0]
			l_aq := a_d[1]
			if a_n = {NATURAL_32} 2 then
				create_givens (l_x, l_z, create {CE_POINTER [REAL_64]}.make_shared ($l_c___1), create {CE_POINTER [REAL_64]}.make_shared ($l_s))
				if (a_gc.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					a_gc[0] := l_c___1
				end
				if (a_gs.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					a_gs[0] := l_s
				end
				l_ap1 := l_c___1 * (l_c___1 * l_ap - l_s * l_bp) + l_s * (l_s * l_aq - l_c___1 * l_bp)
				l_bp1 := l_c___1 * (l_s * l_ap + l_c___1 * l_bp) - l_s * (l_s * l_bp + l_c___1 * l_aq)
				l_aq1 := l_s * (l_s * l_ap + l_c___1 * l_bp) + l_c___1 * (l_s * l_bp + l_c___1 * l_aq)
				l_ak := l_ap1
				l_bk := l_bp1
				l_ap := l_aq1
				a_d[0] := l_ak
				a_sd[0] := l_bk
				a_d[1] := l_ap
				js.return
			end
			if not js.return_called then
				l_bq := a_sd[1]
				l_k := (0).to_natural_32
				from
				until
					not (l_k < a_n - {NATURAL_32} 1)
				loop
					create_givens (l_x, l_z, create {CE_POINTER [REAL_64]}.make_shared ($l_c___2), create {CE_POINTER [REAL_64]}.make_shared ($l_s___0))
					if (a_gc.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						a_gc[l_k.to_integer_32] := l_c___2
					end
					if (a_gs.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						a_gs[l_k.to_integer_32] := l_s___0
					end
					l_bk1 := l_c___2 * l_bk - l_s___0 * l_zk
					l_ap1___0 := l_c___2 * (l_c___2 * l_ap - l_s___0 * l_bp) + l_s___0 * (l_s___0 * l_aq - l_c___2 * l_bp)
					l_bp1___0 := l_c___2 * (l_s___0 * l_ap + l_c___2 * l_bp) - l_s___0 * (l_s___0 * l_bp + l_c___2 * l_aq)
					l_zp1 := -l_s___0 * l_bq
					l_aq1___0 := l_s___0 * (l_s___0 * l_ap + l_c___2 * l_bp) + l_c___2 * (l_s___0 * l_bp + l_c___2 * l_aq)
					l_bq1 := l_c___2 * l_bq
					l_ak := l_ap1___0
					l_bk := l_bp1___0
					l_zk := l_zp1
					l_ap := l_aq1___0
					l_bp := l_bq1
					if l_k < a_n - {NATURAL_32} 2 then
						l_aq := a_d[(l_k + {NATURAL_32} 2).to_integer_32]
					end
					if l_k < a_n - {NATURAL_32} 3 then
						l_bq := a_sd[(l_k + {NATURAL_32} 2).to_integer_32]
					end
					a_d[l_k.to_integer_32] := l_ak
					if l_k > {NATURAL_32} 0 then
						a_sd[(l_k - {NATURAL_32} 1).to_integer_32] := l_bk1
					end
					if l_k < a_n - {NATURAL_32} 2 then
						a_sd[(l_k + {NATURAL_32} 1).to_integer_32] := l_bp
					end
					l_x := l_bk
					l_z := l_zk
					l_k := l_k + 1
				end
				a_d[l_k.to_integer_32] := l_ap
				a_sd[(l_k - {NATURAL_32} 1).to_integer_32] := l_bk
			end
		end

	chop_small_elements___2 (a_N: NATURAL_32; a_d: CE_POINTER [REAL_64]; a_sd: CE_POINTER [REAL_64])
		local
			l_d_i: REAL_64
			l_i: NATURAL_32
			l_sd_i: REAL_64
			l_d_ip1: REAL_64
			l_tmp: REAL_64
			l_tmp___0: REAL_64
		do
			l_d_i := a_d[0]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_N - {NATURAL_32} 1)
			loop
				l_sd_i := a_sd[l_i.to_integer_32]
				l_d_ip1 := a_d[(l_i + {NATURAL_32} 1).to_integer_32]
				l_tmp := fabs (l_sd_i)
				l_tmp___0 := fabs (l_d_i)
				if l_tmp < 2.2204460492503131e-16 * (l_tmp___0 + (fabs (l_d_ip1))) then
					a_sd[l_i.to_integer_32] := 0.0
				end
				l_d_i := l_d_ip1
				l_i := l_i + 1
			end
		end

	qrstep___2 (a_n: NATURAL_32; a_d: CE_POINTER [REAL_64]; a_sd: CE_POINTER [REAL_64]; a_gc: CE_POINTER [REAL_64]; a_gs: CE_POINTER [REAL_64])
		local
			l_x: REAL_64
			l_z: REAL_64
			l_ak: REAL_64
			l_bk: REAL_64
			l_zk: REAL_64
			l_ap: REAL_64
			l_bp: REAL_64
			l_aq: REAL_64
			l_bq: REAL_64
			l_k: NATURAL_32
			l_mu: REAL_64
			l_tmp___0: REAL_64
			l_tmp___1: REAL_64
			l_c___1: REAL_64
			l_s: REAL_64
			l_ap1: REAL_64
			l_bp1: REAL_64
			l_aq1: REAL_64
			l_c___2: REAL_64
			l_s___0: REAL_64
			l_bk1: REAL_64
			l_ap1___0: REAL_64
			l_bp1___0: REAL_64
			l_zp1: REAL_64
			l_aq1___0: REAL_64
			l_bq1: REAL_64
			js: JUMP_STATE
		do
			l_mu := (trailing_eigenvalue (a_n, a_d, a_sd))
			l_tmp___0 := fabs (l_mu)
			l_tmp___1 := fabs (a_d[0])
			if 2.2204460492503131e-16 * l_tmp___0 > l_tmp___1 + (fabs (a_sd[0])) then
				l_mu := (0).to_double
			end
			l_x := a_d[0] - l_mu
			l_z := a_sd[0]
			l_ak := (0).to_double
			l_bk := (0).to_double
			l_zk := (0).to_double
			l_ap := a_d[0]
			l_bp := a_sd[0]
			l_aq := a_d[1]
			if a_n = {NATURAL_32} 2 then
				create_givens (l_x, l_z, create {CE_POINTER [REAL_64]}.make_shared ($l_c___1), create {CE_POINTER [REAL_64]}.make_shared ($l_s))
				if (a_gc.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					a_gc[0] := l_c___1
				end
				if (a_gs.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					a_gs[0] := l_s
				end
				l_ap1 := l_c___1 * (l_c___1 * l_ap - l_s * l_bp) + l_s * (l_s * l_aq - l_c___1 * l_bp)
				l_bp1 := l_c___1 * (l_s * l_ap + l_c___1 * l_bp) - l_s * (l_s * l_bp + l_c___1 * l_aq)
				l_aq1 := l_s * (l_s * l_ap + l_c___1 * l_bp) + l_c___1 * (l_s * l_bp + l_c___1 * l_aq)
				l_ak := l_ap1
				l_bk := l_bp1
				l_ap := l_aq1
				a_d[0] := l_ak
				a_sd[0] := l_bk
				a_d[1] := l_ap
				js.return
			end
			if not js.return_called then
				l_bq := a_sd[1]
				l_k := (0).to_natural_32
				from
				until
					not (l_k < a_n - {NATURAL_32} 1)
				loop
					create_givens (l_x, l_z, create {CE_POINTER [REAL_64]}.make_shared ($l_c___2), create {CE_POINTER [REAL_64]}.make_shared ($l_s___0))
					if (a_gc.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						a_gc[l_k.to_integer_32] := l_c___2
					end
					if (a_gs.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						a_gs[l_k.to_integer_32] := l_s___0
					end
					l_bk1 := l_c___2 * l_bk - l_s___0 * l_zk
					l_ap1___0 := l_c___2 * (l_c___2 * l_ap - l_s___0 * l_bp) + l_s___0 * (l_s___0 * l_aq - l_c___2 * l_bp)
					l_bp1___0 := l_c___2 * (l_s___0 * l_ap + l_c___2 * l_bp) - l_s___0 * (l_s___0 * l_bp + l_c___2 * l_aq)
					l_zp1 := -l_s___0 * l_bq
					l_aq1___0 := l_s___0 * (l_s___0 * l_ap + l_c___2 * l_bp) + l_c___2 * (l_s___0 * l_bp + l_c___2 * l_aq)
					l_bq1 := l_c___2 * l_bq
					l_ak := l_ap1___0
					l_bk := l_bp1___0
					l_zk := l_zp1
					l_ap := l_aq1___0
					l_bp := l_bq1
					if l_k < a_n - {NATURAL_32} 2 then
						l_aq := a_d[(l_k + {NATURAL_32} 2).to_integer_32]
					end
					if l_k < a_n - {NATURAL_32} 3 then
						l_bq := a_sd[(l_k + {NATURAL_32} 2).to_integer_32]
					end
					a_d[l_k.to_integer_32] := l_ak
					if l_k > {NATURAL_32} 0 then
						a_sd[(l_k - {NATURAL_32} 1).to_integer_32] := l_bk1
					end
					if l_k < a_n - {NATURAL_32} 2 then
						a_sd[(l_k + {NATURAL_32} 1).to_integer_32] := l_bp
					end
					l_x := l_bk
					l_z := l_zk
					l_k := l_k + 1
				end
				a_d[l_k.to_integer_32] := l_ap
				a_sd[(l_k - {NATURAL_32} 1).to_integer_32] := l_bk
			end
		end

end
