class
	P_RAN1

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create ran1_type.make
			create gsl_rng_ran1.make
		end

feature {ANY} -- attributes

	m: INTEGER_32 assign set_m

	set_m (a_m: INTEGER_32)
		do
			m := a_m
		end

	a___0: INTEGER_32 assign set_a___0

	set_a___0 (a_a___0: INTEGER_32)
		do
			a___0 := a_a___0
		end

	q: INTEGER_32 assign set_q

	set_q (a_q: INTEGER_32)
		do
			q := a_q
		end

	r: INTEGER_32 assign set_r

	set_r (a_r: INTEGER_32)
		do
			r := a_r
		end

	ran1_type: PD_GSL_RNG_TYPE

	gsl_rng_ran1: CE_POINTER [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	ran1_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAN1_STATE_T]
			l_x: NATURAL_32
			l_h: INTEGER_32
			l_t: INTEGER_32
			l_j: NATURAL_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RAN1_STATE_T]}.make_cast (a_vstate))
			l_x := l_state.item.x
			l_h := (l_x // q.to_natural_32).to_integer_32
			l_t := (a___0.to_natural_32 * (l_x - (l_h * q).to_natural_32) - (l_h * r).to_natural_32).to_integer_32
			if l_t < 0 then
				l_state.item.x := (l_t + m).to_natural_32
			else
				l_state.item.x := l_t.to_natural_32
			end
			l_j := l_state.item.n // {NATURAL_32} 67108864
			l_state.item.n := l_state.item.shuffle[l_j.to_integer_32]
			l_state.item.shuffle[l_j.to_integer_32] := l_state.item.x
			Result := (l_state.item.n)
		end

	ran1_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran1_get)
		end

	ran1_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_x_max: REAL_32
			l_x: REAL_32
			js: JUMP_STATE
		do
			l_x_max := (1).to_real - {REAL_32} 1.2e-7
			l_x := (ran1_get (a_vstate)).to_real_32 / {REAL_32} 2147483647.0
			if l_x > l_x_max then
				Result := l_x_max.to_double
				js.return
			end
			if not js.return_called then
				Result := l_x.to_double
			end
		end

	ran1_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran1_get_double)
		end

	ran1_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RAN1_STATE_T]
			l_i: INTEGER_32
			l_h: INTEGER_32
			l_t: INTEGER_32
			l_h___0: INTEGER_32
			l_t___0: INTEGER_32
		do
			create l_state.make

			l_s := a_s
			l_state.ce_gets (create {CE_POINTER [PD_RAN1_STATE_T]}.make_cast (a_vstate))
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_i := 0
			from
			until
				not (l_i < 8)
			loop
				l_h := (l_s // q.to_natural_32).to_integer_32
				l_t := (a___0.to_natural_32 * (l_s - (l_h * q).to_natural_32) - (l_h * r).to_natural_32).to_integer_32
				if l_t < 0 then
					l_t := l_t + m
				end
				l_s := l_t.to_natural_32
				l_i := l_i + 1
			end
			l_i := 31
			from
			until
				not (l_i >= 0)
			loop
				l_h___0 := (l_s // q.to_natural_32).to_integer_32
				l_t___0 := (a___0.to_natural_32 * (l_s - (l_h___0 * q).to_natural_32) - (l_h___0 * r).to_natural_32).to_integer_32
				if l_t___0 < 0 then
					l_t___0 := l_t___0 + m
				end
				l_s := l_t___0.to_natural_32
				l_state.item.shuffle[l_i] := l_s
				l_i := l_i - 1
			end
			l_state.item.x := l_s
			l_state.item.n := l_s
		end

	ran1_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran1_set)
		end

end
