class
	P_RAND

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create rand_type.make
			create gsl_rng_rand.make
		end

feature {ANY} -- attributes

	rand_type: PD_GSL_RNG_TYPE

	gsl_rng_rand: CE_POINTER [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	rand_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAND_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RAND_STATE_T]}.make_cast (a_vstate))
			l_state.item.x := (({NATURAL_32} 1103515245 * l_state.item.x + {NATURAL_32} 12345)).bit_and ({NATURAL_32} 2147483647)
			Result := (l_state.item.x)
		end

	rand_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rand_get)
		end

	rand_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((rand_get (a_vstate)).to_real_64 / 2147483648.0)
		end

	rand_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rand_get_double)
		end

	rand_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RAND_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RAND_STATE_T]}.make_cast (a_vstate))
			l_state.item.x := a_s
		end

	rand_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rand_set)
		end

end
