class
	P_RAND48

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create rand48_type.make
			create gsl_rng_rand48.make
		end

feature {ANY} -- attributes

	a0___1: NATURAL_16 assign set_a0___1

	set_a0___1 (a_a0___1: NATURAL_16)
		do
			a0___1 := a_a0___1
		end

	a1___2: NATURAL_16 assign set_a1___2

	set_a1___2 (a_a1___2: NATURAL_16)
		do
			a1___2 := a_a1___2
		end

	a2___1: NATURAL_16 assign set_a2___1

	set_a2___1 (a_a2___1: NATURAL_16)
		do
			a2___1 := a_a2___1
		end

	c0: NATURAL_16 assign set_c0

	set_c0 (a_c0: NATURAL_16)
		do
			c0 := a_c0
		end

	rand48_type: PD_GSL_RNG_TYPE

	gsl_rng_rand48: CE_POINTER [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	rand48_advance (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_RAND48_STATE_T]
			l_x0: NATURAL_32
			l_x1___0: NATURAL_32
			l_x2___1: NATURAL_32
			l_a___5: NATURAL_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RAND48_STATE_T]}.make_cast (a_vstate))
			l_x0 := (l_state.item.x0).to_natural_32
			l_x1___0 := (l_state.item.x1).to_natural_32
			l_x2___1 := (l_state.item.x2).to_natural_32
			l_a___5 := a0___1.to_natural_32 * l_x0 + c0.to_natural_32
			l_state.item.x0 := ((l_a___5).bit_and ({NATURAL_32} 65535)).to_natural_16
			l_a___5 := (l_a___5).bit_shift_right ((16))
			l_a___5 := l_a___5 + (a0___1.to_natural_32 * l_x1___0 + a1___2.to_natural_32 * l_x0)
			l_state.item.x1 := ((l_a___5).bit_and ({NATURAL_32} 65535)).to_natural_16
			l_a___5 := (l_a___5).bit_shift_right ((16))
			l_a___5 := l_a___5 + ((a0___1.to_natural_32 * l_x2___1 + a1___2.to_natural_32 * l_x1___0) + a2___1.to_natural_32 * l_x0)
			l_state.item.x2 := ((l_a___5).bit_and ({NATURAL_32} 65535)).to_natural_16
		end

	rand48_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_x1___0: NATURAL_32
			l_x2___1: NATURAL_32
			l_state: CE_POINTER [PD_RAND48_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RAND48_STATE_T]}.make_cast (a_vstate))
			rand48_advance (create {CE_POINTER [ANY]}.make_cast (l_state))
			l_x2___1 := (l_state.item.x2).to_natural_32
			l_x1___0 := (l_state.item.x1).to_natural_32
			Result := (((l_x2___1).bit_shift_left (16)) + l_x1___0)
		end

	rand48_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rand48_get)
		end

	rand48_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_state: CE_POINTER [PD_RAND48_STATE_T]
			l_tmp: REAL_64
			l_tmp___0: REAL_64
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RAND48_STATE_T]}.make_cast (a_vstate))
			rand48_advance (create {CE_POINTER [ANY]}.make_cast (l_state))
			l_tmp := ldexp ((l_state.item.x2).to_real_64, -16)
			l_tmp___0 := ldexp ((l_state.item.x1).to_real_64, -32)
			Result := ((l_tmp + l_tmp___0) + (ldexp ((l_state.item.x0).to_real_64, -48)))
		end

	rand48_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rand48_get_double)
		end

	rand48_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RAND48_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RAND48_STATE_T]}.make_cast (a_vstate))
			if a_s = {NATURAL_32} 0 then
				l_state.item.x0 := (13070).to_natural_16
				l_state.item.x1 := (43981).to_natural_16
				l_state.item.x2 := (4660).to_natural_16
			else
				l_state.item.x0 := (13070).to_natural_16
				l_state.item.x1 := ((a_s).bit_and ({NATURAL_32} 65535)).to_natural_16
				l_state.item.x2 := ((((a_s).bit_shift_right (16))).bit_and ({NATURAL_32} 65535)).to_natural_16
			end
		end

	rand48_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rand48_set)
		end

end
