class
	P_RANDOM

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create random_glibc2_type.make
			create random8_glibc2_type.make
			create random32_glibc2_type.make
			create random64_glibc2_type.make
			create random128_glibc2_type.make
			create random256_glibc2_type.make
			create random_libc5_type.make
			create random8_libc5_type.make
			create random32_libc5_type.make
			create random64_libc5_type.make
			create random128_libc5_type.make
			create random256_libc5_type.make
			create random_bsd_type.make
			create random8_bsd_type.make
			create random32_bsd_type.make
			create random64_bsd_type.make
			create random128_bsd_type.make
			create random256_bsd_type.make
			create gsl_rng_random_libc5.make
			create gsl_rng_random8_libc5.make
			create gsl_rng_random32_libc5.make
			create gsl_rng_random64_libc5.make
			create gsl_rng_random128_libc5.make
			create gsl_rng_random256_libc5.make
			create gsl_rng_random_glibc2.make
			create gsl_rng_random8_glibc2.make
			create gsl_rng_random32_glibc2.make
			create gsl_rng_random64_glibc2.make
			create gsl_rng_random128_glibc2.make
			create gsl_rng_random256_glibc2.make
			create gsl_rng_random_bsd.make
			create gsl_rng_random8_bsd.make
			create gsl_rng_random32_bsd.make
			create gsl_rng_random64_bsd.make
			create gsl_rng_random128_bsd.make
			create gsl_rng_random256_bsd.make
		end

feature {ANY} -- attributes

	random_glibc2_type: PD_GSL_RNG_TYPE

	random8_glibc2_type: PD_GSL_RNG_TYPE

	random32_glibc2_type: PD_GSL_RNG_TYPE

	random64_glibc2_type: PD_GSL_RNG_TYPE

	random128_glibc2_type: PD_GSL_RNG_TYPE

	random256_glibc2_type: PD_GSL_RNG_TYPE

	random_libc5_type: PD_GSL_RNG_TYPE

	random8_libc5_type: PD_GSL_RNG_TYPE

	random32_libc5_type: PD_GSL_RNG_TYPE

	random64_libc5_type: PD_GSL_RNG_TYPE

	random128_libc5_type: PD_GSL_RNG_TYPE

	random256_libc5_type: PD_GSL_RNG_TYPE

	random_bsd_type: PD_GSL_RNG_TYPE

	random8_bsd_type: PD_GSL_RNG_TYPE

	random32_bsd_type: PD_GSL_RNG_TYPE

	random64_bsd_type: PD_GSL_RNG_TYPE

	random128_bsd_type: PD_GSL_RNG_TYPE

	random256_bsd_type: PD_GSL_RNG_TYPE

	gsl_rng_random_libc5: CE_POINTER [PD_GSL_RNG_TYPE]

	gsl_rng_random8_libc5: CE_POINTER [PD_GSL_RNG_TYPE]

	gsl_rng_random32_libc5: CE_POINTER [PD_GSL_RNG_TYPE]

	gsl_rng_random64_libc5: CE_POINTER [PD_GSL_RNG_TYPE]

	gsl_rng_random128_libc5: CE_POINTER [PD_GSL_RNG_TYPE]

	gsl_rng_random256_libc5: CE_POINTER [PD_GSL_RNG_TYPE]

	gsl_rng_random_glibc2: CE_POINTER [PD_GSL_RNG_TYPE]

	gsl_rng_random8_glibc2: CE_POINTER [PD_GSL_RNG_TYPE]

	gsl_rng_random32_glibc2: CE_POINTER [PD_GSL_RNG_TYPE]

	gsl_rng_random64_glibc2: CE_POINTER [PD_GSL_RNG_TYPE]

	gsl_rng_random128_glibc2: CE_POINTER [PD_GSL_RNG_TYPE]

	gsl_rng_random256_glibc2: CE_POINTER [PD_GSL_RNG_TYPE]

	gsl_rng_random_bsd: CE_POINTER [PD_GSL_RNG_TYPE]

	gsl_rng_random8_bsd: CE_POINTER [PD_GSL_RNG_TYPE]

	gsl_rng_random32_bsd: CE_POINTER [PD_GSL_RNG_TYPE]

	gsl_rng_random64_bsd: CE_POINTER [PD_GSL_RNG_TYPE]

	gsl_rng_random128_bsd: CE_POINTER [PD_GSL_RNG_TYPE]

	gsl_rng_random256_bsd: CE_POINTER [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	random8_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RANDOM8_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RANDOM8_STATE_T]}.make_cast (a_vstate))
			l_state.item.x := (((1103515245 * l_state.item.x + 12345).to_natural_32).bit_and ({NATURAL_32} 2147483647)).to_integer_32
			Result := (l_state.item.x).to_natural_32
		end

	random8_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random8_get)
		end

	random_get (a_i: CE_POINTER [INTEGER_32]; a_j: CE_POINTER [INTEGER_32]; a_n: INTEGER_32; a_x: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_k: INTEGER_32
		do
			a_x[a_i.item] := a_x[a_i.item] + (a_x[a_j.item])
			l_k := (((a_x[a_i.item]).bit_shift_right (1))).bit_and (2147483647)
			a_i.item := (a_i.item) + 1
			if a_i.item = a_n then
				a_i.item := 0
			end
			a_j.item := (a_j.item) + 1
			if a_j.item = a_n then
				a_j.item := 0
			end
			Result := l_k
		end

	random32_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RANDOM32_STATE_T]
			l_k: NATURAL_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RANDOM32_STATE_T]}.make_cast (a_vstate))
			l_k := (random_get (create {CE_POINTER [INTEGER_32]}.make_shared (l_state.c_pointer + {PD_RANDOM32_STATE_T}.i_offset), create {CE_POINTER [INTEGER_32]}.make_shared (l_state.c_pointer + {PD_RANDOM32_STATE_T}.j_offset), 7, l_state.item.x)).to_natural_32
			Result := l_k
		end

	random32_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random32_get)
		end

	random64_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RANDOM64_STATE_T]
			l_k: INTEGER_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RANDOM64_STATE_T]}.make_cast (a_vstate))
			l_k := (random_get (create {CE_POINTER [INTEGER_32]}.make_shared (l_state.c_pointer + {PD_RANDOM64_STATE_T}.i_offset), create {CE_POINTER [INTEGER_32]}.make_shared (l_state.c_pointer + {PD_RANDOM64_STATE_T}.j_offset), 15, l_state.item.x))
			Result := l_k.to_natural_32
		end

	random64_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random64_get)
		end

	random128_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RANDOM128_STATE_T]
			l_k: NATURAL_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RANDOM128_STATE_T]}.make_cast (a_vstate))
			l_k := (random_get (create {CE_POINTER [INTEGER_32]}.make_shared (l_state.c_pointer + {PD_RANDOM128_STATE_T}.i_offset), create {CE_POINTER [INTEGER_32]}.make_shared (l_state.c_pointer + {PD_RANDOM128_STATE_T}.j_offset), 31, l_state.item.x)).to_natural_32
			Result := l_k
		end

	random128_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random128_get)
		end

	random256_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RANDOM256_STATE_T]
			l_k: INTEGER_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RANDOM256_STATE_T]}.make_cast (a_vstate))
			l_k := (random_get (create {CE_POINTER [INTEGER_32]}.make_shared (l_state.c_pointer + {PD_RANDOM256_STATE_T}.i_offset), create {CE_POINTER [INTEGER_32]}.make_shared (l_state.c_pointer + {PD_RANDOM256_STATE_T}.j_offset), 63, l_state.item.x))
			Result := l_k.to_natural_32
		end

	random256_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random256_get)
		end

	random8_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((random8_get (a_vstate)).to_real_64 / 2147483648.0)
		end

	random8_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random8_get_double)
		end

	random32_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((random32_get (a_vstate)).to_real_64 / 2147483648.0)
		end

	random32_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random32_get_double)
		end

	random64_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((random64_get (a_vstate)).to_real_64 / 2147483648.0)
		end

	random64_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random64_get_double)
		end

	random128_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((random128_get (a_vstate)).to_real_64 / 2147483648.0)
		end

	random128_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random128_get_double)
		end

	random256_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((random256_get (a_vstate)).to_real_64 / 2147483648.0)
		end

	random256_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random256_get_double)
		end

	random8_bsd_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RANDOM8_STATE_T]
		do
			create l_state.make

			l_s := a_s
			l_state.ce_gets (create {CE_POINTER [PD_RANDOM8_STATE_T]}.make_cast (a_vstate))
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.x := l_s.to_integer_32
		end

	random8_bsd_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random8_bsd_set)
		end

	random32_bsd_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RANDOM32_STATE_T]
			l_i: INTEGER_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RANDOM32_STATE_T]}.make_cast (a_vstate))
			bsd_initialize (l_state.item.x, 7, a_s)
			l_state.item.i := 3
			l_state.item.j := 0
			l_i := 0
			from
			until
				not (l_i < 70)
			loop
				random32_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
				l_i := l_i + 1
			end
		end

	random32_bsd_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random32_bsd_set)
		end

	random64_bsd_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RANDOM64_STATE_T]
			l_i: INTEGER_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RANDOM64_STATE_T]}.make_cast (a_vstate))
			bsd_initialize (l_state.item.x, 15, a_s)
			l_state.item.i := 1
			l_state.item.j := 0
			l_i := 0
			from
			until
				not (l_i < 150)
			loop
				random64_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
				l_i := l_i + 1
			end
		end

	random64_bsd_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random64_bsd_set)
		end

	random128_bsd_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RANDOM128_STATE_T]
			l_i: INTEGER_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RANDOM128_STATE_T]}.make_cast (a_vstate))
			bsd_initialize (l_state.item.x, 31, a_s)
			l_state.item.i := 3
			l_state.item.j := 0
			l_i := 0
			from
			until
				not (l_i < 310)
			loop
				random128_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
				l_i := l_i + 1
			end
		end

	random128_bsd_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random128_bsd_set)
		end

	random256_bsd_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RANDOM256_STATE_T]
			l_i: INTEGER_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RANDOM256_STATE_T]}.make_cast (a_vstate))
			bsd_initialize (l_state.item.x, 63, a_s)
			l_state.item.i := 1
			l_state.item.j := 0
			l_i := 0
			from
			until
				not (l_i < 630)
			loop
				random256_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
				l_i := l_i + 1
			end
		end

	random256_bsd_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random256_bsd_set)
		end

	bsd_initialize (a_x: CE_POINTER [INTEGER_32]; a_n: INTEGER_32; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_i: INTEGER_32
		do
			l_s := a_s
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			a_x[0] := l_s.to_integer_32
			l_i := 1
			from
			until
				not (l_i < a_n)
			loop
				a_x[l_i] := 1103515245 * a_x[(l_i - 1)] + 12345
				l_i := l_i + 1
			end
		end

	libc5_initialize (a_x: CE_POINTER [INTEGER_32]; a_n: INTEGER_32; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_i: INTEGER_32
		do
			l_s := a_s
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			a_x[0] := l_s.to_integer_32
			l_i := 1
			from
			until
				not (l_i < a_n)
			loop
				a_x[l_i] := 1103515145 * a_x[(l_i - 1)] + 12345
				l_i := l_i + 1
			end
		end

	glibc2_initialize (a_x: CE_POINTER [INTEGER_32]; a_n: INTEGER_32; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_i: INTEGER_32
			l_h: INTEGER_32
			l_t: INTEGER_32
		do
			l_s := a_s
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			a_x[0] := l_s.to_integer_32
			l_i := 1
			from
			until
				not (l_i < a_n)
			loop
				l_h := (l_s // {NATURAL_32} 127773).to_integer_32
				l_t := ({NATURAL_32} 16807 * (l_s - (l_h * 127773).to_natural_32) - (l_h * 2836).to_natural_32).to_integer_32
				if l_t < 0 then
					l_s := (l_t + 2147483647).to_natural_32
				else
					l_s := l_t.to_natural_32
				end
				a_x[l_i] := l_s.to_integer_32
				l_i := l_i + 1
			end
		end

	random8_glibc2_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RANDOM8_STATE_T]
		do
			create l_state.make

			l_s := a_s
			l_state.ce_gets (create {CE_POINTER [PD_RANDOM8_STATE_T]}.make_cast (a_vstate))
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.x := l_s.to_integer_32
		end

	random8_glibc2_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random8_glibc2_set)
		end

	random32_glibc2_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RANDOM32_STATE_T]
			l_i: INTEGER_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RANDOM32_STATE_T]}.make_cast (a_vstate))
			glibc2_initialize (l_state.item.x, 7, a_s)
			l_state.item.i := 3
			l_state.item.j := 0
			l_i := 0
			from
			until
				not (l_i < 70)
			loop
				random32_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
				l_i := l_i + 1
			end
		end

	random32_glibc2_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random32_glibc2_set)
		end

	random64_glibc2_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RANDOM64_STATE_T]
			l_i: INTEGER_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RANDOM64_STATE_T]}.make_cast (a_vstate))
			glibc2_initialize (l_state.item.x, 15, a_s)
			l_state.item.i := 1
			l_state.item.j := 0
			l_i := 0
			from
			until
				not (l_i < 150)
			loop
				random64_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
				l_i := l_i + 1
			end
		end

	random64_glibc2_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random64_glibc2_set)
		end

	random128_glibc2_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RANDOM128_STATE_T]
			l_i: INTEGER_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RANDOM128_STATE_T]}.make_cast (a_vstate))
			glibc2_initialize (l_state.item.x, 31, a_s)
			l_state.item.i := 3
			l_state.item.j := 0
			l_i := 0
			from
			until
				not (l_i < 310)
			loop
				random128_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
				l_i := l_i + 1
			end
		end

	random128_glibc2_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random128_glibc2_set)
		end

	random256_glibc2_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RANDOM256_STATE_T]
			l_i: INTEGER_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RANDOM256_STATE_T]}.make_cast (a_vstate))
			glibc2_initialize (l_state.item.x, 63, a_s)
			l_state.item.i := 1
			l_state.item.j := 0
			l_i := 0
			from
			until
				not (l_i < 630)
			loop
				random256_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
				l_i := l_i + 1
			end
		end

	random256_glibc2_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random256_glibc2_set)
		end

	random8_libc5_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RANDOM8_STATE_T]
		do
			create l_state.make

			l_s := a_s
			l_state.ce_gets (create {CE_POINTER [PD_RANDOM8_STATE_T]}.make_cast (a_vstate))
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.x := l_s.to_integer_32
		end

	random8_libc5_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random8_libc5_set)
		end

	random32_libc5_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RANDOM32_STATE_T]
			l_i: INTEGER_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RANDOM32_STATE_T]}.make_cast (a_vstate))
			libc5_initialize (l_state.item.x, 7, a_s)
			l_state.item.i := 3
			l_state.item.j := 0
			l_i := 0
			from
			until
				not (l_i < 70)
			loop
				random32_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
				l_i := l_i + 1
			end
		end

	random32_libc5_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random32_libc5_set)
		end

	random64_libc5_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RANDOM64_STATE_T]
			l_i: INTEGER_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RANDOM64_STATE_T]}.make_cast (a_vstate))
			libc5_initialize (l_state.item.x, 15, a_s)
			l_state.item.i := 1
			l_state.item.j := 0
			l_i := 0
			from
			until
				not (l_i < 150)
			loop
				random64_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
				l_i := l_i + 1
			end
		end

	random64_libc5_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random64_libc5_set)
		end

	random128_libc5_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RANDOM128_STATE_T]
			l_i: INTEGER_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RANDOM128_STATE_T]}.make_cast (a_vstate))
			libc5_initialize (l_state.item.x, 31, a_s)
			l_state.item.i := 3
			l_state.item.j := 0
			l_i := 0
			from
			until
				not (l_i < 310)
			loop
				random128_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
				l_i := l_i + 1
			end
		end

	random128_libc5_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random128_libc5_set)
		end

	random256_libc5_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RANDOM256_STATE_T]
			l_i: INTEGER_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RANDOM256_STATE_T]}.make_cast (a_vstate))
			libc5_initialize (l_state.item.x, 63, a_s)
			l_state.item.i := 1
			l_state.item.j := 0
			l_i := 0
			from
			until
				not (l_i < 630)
			loop
				random256_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
				l_i := l_i + 1
			end
		end

	random256_libc5_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent random256_libc5_set)
		end

end
