class
	P_RANDU

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create randu_type.make
			create gsl_rng_randu.make
		end

feature {ANY} -- attributes

	a3: INTEGER_32 assign set_a3

	set_a3 (a_a3: INTEGER_32)
		do
			a3 := a_a3
		end

	randu_type: PD_GSL_RNG_TYPE

	gsl_rng_randu: CE_POINTER [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	randu_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RANDU_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RANDU_STATE_T]}.make_cast (a_vstate))
			l_state.item.x := (a3.to_natural_32 * l_state.item.x).bit_and ({NATURAL_32} 2147483647)
			Result := (l_state.item.x)
		end

	randu_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent randu_get)
		end

	randu_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((randu_get (a_vstate)).to_real_64 / 2147483648.0)
		end

	randu_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent randu_get_double)
		end

	randu_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RANDU_STATE_T]
		do
			create l_state.make

			l_s := a_s
			l_state.ce_gets (create {CE_POINTER [PD_RANDU_STATE_T]}.make_cast (a_vstate))
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.x := l_s
		end

	randu_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent randu_set)
		end

end
