class
	P_RANLUX

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create ranlux_type.make
			create ranlux389_type.make
			create gsl_rng_ranlux.make
			create gsl_rng_ranlux389.make
		end

feature {ANY} -- attributes

	mask_lo: NATURAL_32 assign set_mask_lo

	set_mask_lo (a_mask_lo: NATURAL_32)
		do
			mask_lo := a_mask_lo
		end

	mask_hi: NATURAL_32 assign set_mask_hi

	set_mask_hi (a_mask_hi: NATURAL_32)
		do
			mask_hi := a_mask_hi
		end

	two24___0: NATURAL_32 assign set_two24___0

	set_two24___0 (a_two24___0: NATURAL_32)
		do
			two24___0 := a_two24___0
		end

	ranlux_type: PD_GSL_RNG_TYPE

	ranlux389_type: PD_GSL_RNG_TYPE

	gsl_rng_ranlux: CE_POINTER [PD_GSL_RNG_TYPE]

	gsl_rng_ranlux389: CE_POINTER [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	increment_state___1 (a_state: CE_POINTER [PD_RANLUX_STATE_T]): NATURAL_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_delta___0: INTEGER_32
		do
			l_i := a_state.item.i
			l_j := a_state.item.j
			l_delta___0 := ((a_state.item.u[l_j.to_integer_32] - a_state.item.u[l_i.to_integer_32]) - (a_state.item.carry).to_natural_32).to_integer_32
			if ((l_delta___0.to_natural_32).bit_and (mask_hi)).to_boolean then
				a_state.item.carry := {NATURAL_32} 1
				l_delta___0 := ((l_delta___0.to_natural_32).bit_and (mask_lo)).to_integer_32
			else
				a_state.item.carry := {NATURAL_32} 0
			end
			a_state.item.u[l_i.to_integer_32] := l_delta___0.to_natural_32
			if l_i = {NATURAL_32} 0 then
				l_i := {NATURAL_32} 23
			else
				l_i := l_i - 1
			end
			a_state.item.i := l_i
			if l_j = {NATURAL_32} 0 then
				l_j := {NATURAL_32} 23
			else
				l_j := l_j - 1
			end
			a_state.item.j := l_j
			Result := l_delta___0.to_natural_32
		end

	ranlux_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RANLUX_STATE_T]
			l_skip: NATURAL_32
			l_r___3: NATURAL_32
			l_i: NATURAL_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RANLUX_STATE_T]}.make_cast (a_vstate))
			l_skip := l_state.item.skip
			l_r___3 := (increment_state___1 (l_state))
			l_state.item.n := (l_state.item.n) + 1
			if l_state.item.n = {NATURAL_32} 24 then
				l_state.item.n := {NATURAL_32} 0
				l_i := {NATURAL_32} 0
				from
				until
					not (l_i < l_skip)
				loop
					increment_state___1 (l_state).do_nothing
					l_i := l_i + 1
				end
			end
			Result := l_r___3
		end

	ranlux_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ranlux_get)
		end

	ranlux_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((ranlux_get (a_vstate)).to_real_64 / 16777216.0)
		end

	ranlux_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ranlux_get_double)
		end

	ranlux_set_lux (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32; a_luxury: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RANLUX_STATE_T]
			l_i: INTEGER_32
			l_seed: INTEGER_32
			l_k: NATURAL_32
		do
			create l_state.make

			l_s := a_s
			l_state.ce_gets (create {CE_POINTER [PD_RANLUX_STATE_T]}.make_cast (a_vstate))
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 314159265
			end
			l_seed := l_s.to_integer_32
			l_i := 0
			from
			until
				not (l_i < 24)
			loop
				l_k := (l_seed // 53668).to_natural_32
				l_seed := ({NATURAL_32} 40014 * (l_seed.to_natural_32 - l_k * {NATURAL_32} 53668) - l_k * {NATURAL_32} 12211).to_integer_32
				if l_seed < 0 then
					l_seed := l_seed + (2147483563)
				end
				l_state.item.u[l_i] := (l_seed.to_natural_32 \\ two24___0)
				l_i := l_i + 1
			end
			l_state.item.i := {NATURAL_32} 23
			l_state.item.j := {NATURAL_32} 9
			l_state.item.n := {NATURAL_32} 0
			l_state.item.skip := a_luxury - {NATURAL_32} 24
			if ((l_state.item.u[23]).bit_and (mask_hi)).to_boolean then
				l_state.item.carry := {NATURAL_32} 1
			else
				l_state.item.carry := {NATURAL_32} 0
			end
		end

	ranlux_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		do
			ranlux_set_lux (a_vstate, a_s, {NATURAL_32} 223)
		end

	ranlux_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ranlux_set)
		end

	ranlux389_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		do
			ranlux_set_lux (a_vstate, a_s, {NATURAL_32} 389)
		end

	ranlux389_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ranlux389_set)
		end

end
