class
	P_REAL_INIT

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_fft_real_wavetable_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_FFT_REAL_WAVETABLE]
		local
			l_status: INTEGER_32
			l_i: NATURAL_32
			l_n_factors: NATURAL_32
			l_t: NATURAL_32
			l_product: NATURAL_32
			l_product_1: NATURAL_32
			l_q___3: NATURAL_32
			l_d_theta: REAL_64
			l_wavetable: CE_POINTER [PD_GSL_FFT_REAL_WAVETABLE]
			l_j: NATURAL_32
			l_factor: NATURAL_32
			l_k: NATURAL_32
			l_m___4: NATURAL_32
			l_theta: REAL_64
			js: JUMP_STATE
		do
			create l_wavetable.make

			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("length n must be positive integer"), ce_string ("real_init.c"), 33, 1)
					Result := (create {CE_POINTER [PD_GSL_FFT_REAL_WAVETABLE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_wavetable.ce_gets (create {CE_POINTER [PD_GSL_FFT_REAL_WAVETABLE]}.make_cast ((malloc ({PD_GSL_FFT_REAL_WAVETABLE}.sizeof.to_natural_32))))
				if (l_wavetable.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate struct"), ce_string ("real_init.c"), 41, 8)
						Result := (create {CE_POINTER [PD_GSL_FFT_REAL_WAVETABLE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				if a_n = {NATURAL_32} 1 then
					l_wavetable.item.trig := create {CE_POINTER [PD_GSL_COMPLEX]}.make_shared (default_pointer)
				else
					l_wavetable.item.trig := create {CE_POINTER [PD_GSL_COMPLEX]}.make_cast ((malloc ((a_n // {NATURAL_32} 2) * {PD_GSL_COMPLEX}.sizeof.to_natural_32)))
					if ((l_wavetable.item.trig).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						free (create {CE_POINTER [ANY]}.make_cast (l_wavetable))
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("failed to allocate trigonometric lookup table"), ce_string ("real_init.c"), 60, 8)
							Result := (create {CE_POINTER [PD_GSL_FFT_REAL_WAVETABLE]}.make_shared (default_pointer))
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
				end
			end
			if not js.return_called then
				l_wavetable.item.n := a_n
				l_status := factorize_inst.fft_real_factorize (a_n, create {CE_POINTER [NATURAL_32]}.make_shared ($l_n_factors), l_wavetable.item.factor)
				if l_status.to_boolean then
					free (create {CE_POINTER [ANY]}.make_cast (l_wavetable.item.trig))
					free (create {CE_POINTER [ANY]}.make_cast (l_wavetable))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("factorization failed"), ce_string ("real_init.c"), 75, 6)
						Result := (create {CE_POINTER [PD_GSL_FFT_REAL_WAVETABLE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_wavetable.item.nf := l_n_factors
				l_d_theta := (2.0 * 3.14159265358979323846) / a_n.to_real_64
				l_t := (0).to_natural_32
				l_product := (1).to_natural_32
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_wavetable.item.nf))
				loop
					l_factor := l_wavetable.item.factor[l_i.to_integer_32]
					l_wavetable.item.twiddle[l_i.to_integer_32] := l_wavetable.item.trig + l_t.to_integer_32
					l_product_1 := l_product
					l_product := l_product * l_factor
					l_q___3 := a_n // l_product
					l_j := (1).to_natural_32
					from
					until
						not (not js.loop_left and then (l_j < l_factor))
					loop
						l_m___4 := (0).to_natural_32
						l_k := (1).to_natural_32
						from
						until
							not (l_k < (l_product_1 + {NATURAL_32} 1) // {NATURAL_32} 2)
						loop
							l_m___4 := l_m___4 + (l_j * l_q___3)
							l_m___4 := l_m___4 \\ a_n
							l_theta := l_d_theta * l_m___4.to_real_64;
							(l_wavetable.item.trig + l_t.to_integer_32).item.dat[0] := cos (l_theta);
							(l_wavetable.item.trig + l_t.to_integer_32).item.dat[1] := sin (l_theta)
							l_t := l_t + 1
							l_k := l_k + 1
						end
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				if l_t > a_n // {NATURAL_32} 2 then
					free (create {CE_POINTER [ANY]}.make_cast (l_wavetable.item.trig))
					free (create {CE_POINTER [ANY]}.make_cast (l_wavetable))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("overflowed trigonometric lookup table"), ce_string ("real_init.c"), 119, 7)
						Result := (create {CE_POINTER [PD_GSL_FFT_REAL_WAVETABLE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				Result := l_wavetable
			end
		end

	gsl_fft_real_workspace_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_FFT_REAL_WORKSPACE]
		local
			l_workspace: CE_POINTER [PD_GSL_FFT_REAL_WORKSPACE]
			js: JUMP_STATE
		do
			create l_workspace.make

			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("length n must be positive integer"), ce_string ("real_init.c"), 132, 1)
					Result := (create {CE_POINTER [PD_GSL_FFT_REAL_WORKSPACE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_workspace.ce_gets (create {CE_POINTER [PD_GSL_FFT_REAL_WORKSPACE]}.make_cast ((malloc ({PD_GSL_FFT_REAL_WORKSPACE}.sizeof.to_natural_32))))
				if (l_workspace.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate struct"), ce_string ("real_init.c"), 140, 8)
						Result := (create {CE_POINTER [PD_GSL_FFT_REAL_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_workspace.item.n := a_n
				l_workspace.item.scratch := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_n * Real_64_bytes.to_natural_32)))
				if ((l_workspace.item.scratch).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate scratch space"), ce_string ("real_init.c"), 153, 8)
						Result := (create {CE_POINTER [PD_GSL_FFT_REAL_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				Result := l_workspace
			end
		end

	gsl_fft_real_wavetable_free (a_wavetable: CE_POINTER [PD_GSL_FFT_REAL_WAVETABLE])
		local
			js: JUMP_STATE
		do
			if (a_wavetable).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (a_wavetable.item.trig))
				a_wavetable.item.trig := create {CE_POINTER [PD_GSL_COMPLEX]}.make_shared (default_pointer)
				free (create {CE_POINTER [ANY]}.make_cast (a_wavetable))
			end
		end

	gsl_fft_real_workspace_free (a_workspace: CE_POINTER [PD_GSL_FFT_REAL_WORKSPACE])
		local
			js: JUMP_STATE
		do
			if (a_workspace).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (a_workspace.item.scratch))
				a_workspace.item.scratch := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				free (create {CE_POINTER [ANY]}.make_cast (a_workspace))
			end
		end

	gsl_fft_real_wavetable_float_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_FFT_REAL_WAVETABLE_FLOAT]
		local
			l_status: INTEGER_32
			l_i: NATURAL_32
			l_n_factors: NATURAL_32
			l_t: NATURAL_32
			l_product: NATURAL_32
			l_product_1: NATURAL_32
			l_q___3: NATURAL_32
			l_d_theta: REAL_64
			l_wavetable: CE_POINTER [PD_GSL_FFT_REAL_WAVETABLE_FLOAT]
			l_j: NATURAL_32
			l_factor: NATURAL_32
			l_k: NATURAL_32
			l_m___4: NATURAL_32
			l_theta: REAL_64
			js: JUMP_STATE
		do
			create l_wavetable.make

			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("length n must be positive integer"), ce_string ("real_init.c"), 33, 1)
					Result := (create {CE_POINTER [PD_GSL_FFT_REAL_WAVETABLE_FLOAT]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_wavetable.ce_gets (create {CE_POINTER [PD_GSL_FFT_REAL_WAVETABLE_FLOAT]}.make_cast ((malloc ({PD_GSL_FFT_REAL_WAVETABLE_FLOAT}.sizeof.to_natural_32))))
				if (l_wavetable.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate struct"), ce_string ("real_init.c"), 41, 8)
						Result := (create {CE_POINTER [PD_GSL_FFT_REAL_WAVETABLE_FLOAT]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				if a_n = {NATURAL_32} 1 then
					l_wavetable.item.trig := create {CE_POINTER [PD_GSL_COMPLEX_FLOAT]}.make_shared (default_pointer)
				else
					l_wavetable.item.trig := create {CE_POINTER [PD_GSL_COMPLEX_FLOAT]}.make_cast ((malloc ((a_n // {NATURAL_32} 2) * {PD_GSL_COMPLEX_FLOAT}.sizeof.to_natural_32)))
					if ((l_wavetable.item.trig).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						free (create {CE_POINTER [ANY]}.make_cast (l_wavetable))
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("failed to allocate trigonometric lookup table"), ce_string ("real_init.c"), 60, 8)
							Result := (create {CE_POINTER [PD_GSL_FFT_REAL_WAVETABLE_FLOAT]}.make_shared (default_pointer))
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
				end
			end
			if not js.return_called then
				l_wavetable.item.n := a_n
				l_status := factorize_inst.fft_real_factorize (a_n, create {CE_POINTER [NATURAL_32]}.make_shared ($l_n_factors), l_wavetable.item.factor)
				if l_status.to_boolean then
					free (create {CE_POINTER [ANY]}.make_cast (l_wavetable.item.trig))
					free (create {CE_POINTER [ANY]}.make_cast (l_wavetable))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("factorization failed"), ce_string ("real_init.c"), 75, 6)
						Result := (create {CE_POINTER [PD_GSL_FFT_REAL_WAVETABLE_FLOAT]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_wavetable.item.nf := l_n_factors
				l_d_theta := (2.0 * 3.14159265358979323846) / a_n.to_real_64
				l_t := (0).to_natural_32
				l_product := (1).to_natural_32
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_wavetable.item.nf))
				loop
					l_factor := l_wavetable.item.factor[l_i.to_integer_32]
					l_wavetable.item.twiddle[l_i.to_integer_32] := l_wavetable.item.trig + l_t.to_integer_32
					l_product_1 := l_product
					l_product := l_product * l_factor
					l_q___3 := a_n // l_product
					l_j := (1).to_natural_32
					from
					until
						not (not js.loop_left and then (l_j < l_factor))
					loop
						l_m___4 := (0).to_natural_32
						l_k := (1).to_natural_32
						from
						until
							not (l_k < (l_product_1 + {NATURAL_32} 1) // {NATURAL_32} 2)
						loop
							l_m___4 := l_m___4 + (l_j * l_q___3)
							l_m___4 := l_m___4 \\ a_n
							l_theta := l_d_theta * l_m___4.to_real_64;
							(l_wavetable.item.trig + l_t.to_integer_32).item.dat[0] := (cos (l_theta)).truncated_to_real;
							(l_wavetable.item.trig + l_t.to_integer_32).item.dat[1] := (sin (l_theta)).truncated_to_real
							l_t := l_t + 1
							l_k := l_k + 1
						end
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				if l_t > a_n // {NATURAL_32} 2 then
					free (create {CE_POINTER [ANY]}.make_cast (l_wavetable.item.trig))
					free (create {CE_POINTER [ANY]}.make_cast (l_wavetable))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("overflowed trigonometric lookup table"), ce_string ("real_init.c"), 119, 7)
						Result := (create {CE_POINTER [PD_GSL_FFT_REAL_WAVETABLE_FLOAT]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				Result := l_wavetable
			end
		end

	gsl_fft_real_workspace_float_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_FFT_REAL_WORKSPACE_FLOAT]
		local
			l_workspace: CE_POINTER [PD_GSL_FFT_REAL_WORKSPACE_FLOAT]
			js: JUMP_STATE
		do
			create l_workspace.make

			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("length n must be positive integer"), ce_string ("real_init.c"), 132, 1)
					Result := (create {CE_POINTER [PD_GSL_FFT_REAL_WORKSPACE_FLOAT]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_workspace.ce_gets (create {CE_POINTER [PD_GSL_FFT_REAL_WORKSPACE_FLOAT]}.make_cast ((malloc ({PD_GSL_FFT_REAL_WORKSPACE_FLOAT}.sizeof.to_natural_32))))
				if (l_workspace.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate struct"), ce_string ("real_init.c"), 140, 8)
						Result := (create {CE_POINTER [PD_GSL_FFT_REAL_WORKSPACE_FLOAT]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_workspace.item.n := a_n
				l_workspace.item.scratch := create {CE_POINTER [REAL_32]}.make_cast ((malloc (a_n * Real_32_bytes.to_natural_32)))
				if ((l_workspace.item.scratch).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_workspace))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate scratch space"), ce_string ("real_init.c"), 153, 8)
						Result := (create {CE_POINTER [PD_GSL_FFT_REAL_WORKSPACE_FLOAT]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				Result := l_workspace
			end
		end

	gsl_fft_real_wavetable_float_free (a_wavetable: CE_POINTER [PD_GSL_FFT_REAL_WAVETABLE_FLOAT])
		local
			js: JUMP_STATE
		do
			if (a_wavetable).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (a_wavetable.item.trig))
				a_wavetable.item.trig := create {CE_POINTER [PD_GSL_COMPLEX_FLOAT]}.make_shared (default_pointer)
				free (create {CE_POINTER [ANY]}.make_cast (a_wavetable))
			end
		end

	gsl_fft_real_workspace_float_free (a_workspace: CE_POINTER [PD_GSL_FFT_REAL_WORKSPACE_FLOAT])
		local
			js: JUMP_STATE
		do
			if (a_workspace).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (a_workspace.item.scratch))
				a_workspace.item.scratch := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				free (create {CE_POINTER [ANY]}.make_cast (a_workspace))
			end
		end

end
