class
	P_REAL_RADIX2

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_fft_real_radix2_transform (a_data: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_result: INTEGER_32
			l_p: NATURAL_32
			l_p_1: NATURAL_32
			l_q___3: NATURAL_32
			l_i: NATURAL_32
			l_logn: NATURAL_32
			l_status: INTEGER_32
			l_a___5: NATURAL_32
			l_b___0: NATURAL_32
			l_t0_real: REAL_64
			l_t1_real: REAL_64
			l_w_real: REAL_64
			l_w_imag: REAL_64
			l_theta: REAL_64
			l_s: REAL_64
			l_t: REAL_64
			l_s2: REAL_64
			l_tmp_real: REAL_64
			l_tmp_imag: REAL_64
			l_z0_real: REAL_64
			l_z0_imag: REAL_64
			l_z1_real: REAL_64
			l_z1_imag: REAL_64
			l_t0_real___0: REAL_64
			l_t0_imag: REAL_64
			l_t1_real___0: REAL_64
			l_t1_imag: REAL_64
			js: JUMP_STATE
		do
			l_logn := (0).to_natural_32
			if a_n = {NATURAL_32} 1 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_result := factorize_inst.fft_binary_logn (a_n)
				if l_result = -1 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("n is not a power of 2"), ce_string ("real_radix2.c"), 40, 4)
						Result := 4
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				else
					l_logn := l_result.to_natural_32
				end
			end
			if not js.return_called then
				l_status := bitreverse_inst.fft_real_bitreverse_order (a_data, a_stride, a_n, l_logn)
				l_p := (1).to_natural_32
				l_q___3 := a_n
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i <= l_logn))
				loop
					l_p_1 := l_p
					l_p := {NATURAL_32} 2 * l_p
					l_q___3 := l_q___3 // ({NATURAL_32} 2)
					l_b___0 := (0).to_natural_32
					from
					until
						not (l_b___0 < l_q___3)
					loop
						l_t0_real := a_data[(a_stride * (l_b___0 * l_p)).to_integer_32] + a_data[(a_stride * (l_b___0 * l_p + l_p_1)).to_integer_32]
						l_t1_real := a_data[(a_stride * (l_b___0 * l_p)).to_integer_32] - a_data[(a_stride * (l_b___0 * l_p + l_p_1)).to_integer_32]
						a_data[(a_stride * (l_b___0 * l_p)).to_integer_32] := l_t0_real
						a_data[(a_stride * (l_b___0 * l_p + l_p_1)).to_integer_32] := l_t1_real
						l_b___0 := l_b___0 + 1
					end
					l_w_real := 1.0
					l_w_imag := 0.0
					l_theta := (-2.0 * 3.14159265358979323846) / l_p.to_real_64
					l_s := (sin (l_theta))
					l_t := (sin (l_theta / 2.0))
					l_s2 := (2.0 * l_t) * l_t
					l_a___5 := (1).to_natural_32
					from
					until
						not (not js.loop_left and then (l_a___5 < l_p_1 // {NATURAL_32} 2))
					loop
						l_tmp_real := (l_w_real - l_s * l_w_imag) - l_s2 * l_w_real
						l_tmp_imag := (l_w_imag + l_s * l_w_real) - l_s2 * l_w_imag
						l_w_real := l_tmp_real
						l_w_imag := l_tmp_imag
						l_b___0 := (0).to_natural_32
						from
						until
							not (l_b___0 < l_q___3)
						loop
							l_z0_real := a_data[(a_stride * (l_b___0 * l_p + l_a___5)).to_integer_32]
							l_z0_imag := a_data[(a_stride * ((l_b___0 * l_p + l_p_1) - l_a___5)).to_integer_32]
							l_z1_real := a_data[(a_stride * ((l_b___0 * l_p + l_p_1) + l_a___5)).to_integer_32]
							l_z1_imag := a_data[(a_stride * ((l_b___0 * l_p + l_p) - l_a___5)).to_integer_32]
							l_t0_real___0 := (l_z0_real + l_w_real * l_z1_real) - l_w_imag * l_z1_imag
							l_t0_imag := (l_z0_imag + l_w_real * l_z1_imag) + l_w_imag * l_z1_real
							l_t1_real___0 := (l_z0_real - l_w_real * l_z1_real) + l_w_imag * l_z1_imag
							l_t1_imag := (l_z0_imag - l_w_real * l_z1_imag) - l_w_imag * l_z1_real
							a_data[(a_stride * (l_b___0 * l_p + l_a___5)).to_integer_32] := l_t0_real___0
							a_data[(a_stride * ((l_b___0 * l_p + l_p) - l_a___5)).to_integer_32] := l_t0_imag
							a_data[(a_stride * ((l_b___0 * l_p + l_p_1) - l_a___5)).to_integer_32] := l_t1_real___0
							a_data[(a_stride * ((l_b___0 * l_p + l_p_1) + l_a___5)).to_integer_32] := -l_t1_imag
							l_b___0 := l_b___0 + 1
						end
						l_a___5 := l_a___5 + 1
					end
					if l_p_1 > {NATURAL_32} 1 then
						l_b___0 := (0).to_natural_32
						from
						until
							not (l_b___0 < l_q___3)
						loop
							a_data[(a_stride * ((l_b___0 * l_p + l_p) - l_p_1 // {NATURAL_32} 2)).to_integer_32] := a_data[(a_stride * ((l_b___0 * l_p + l_p) - l_p_1 // {NATURAL_32} 2)).to_integer_32] * (-1).to_double
							l_b___0 := l_b___0 + 1
						end
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_fft_real_float_radix2_transform (a_data: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_result: INTEGER_32
			l_p: NATURAL_32
			l_p_1: NATURAL_32
			l_q___3: NATURAL_32
			l_i: NATURAL_32
			l_logn: NATURAL_32
			l_status: INTEGER_32
			l_a___5: NATURAL_32
			l_b___0: NATURAL_32
			l_t0_real: REAL_32
			l_t1_real: REAL_32
			l_w_real: REAL_32
			l_w_imag: REAL_32
			l_theta: REAL_64
			l_s: REAL_32
			l_t: REAL_32
			l_s2: REAL_32
			l_tmp_real: REAL_32
			l_tmp_imag: REAL_32
			l_z0_real: REAL_32
			l_z0_imag: REAL_32
			l_z1_real: REAL_32
			l_z1_imag: REAL_32
			l_t0_real___0: REAL_32
			l_t0_imag: REAL_32
			l_t1_real___0: REAL_32
			l_t1_imag: REAL_32
			js: JUMP_STATE
		do
			l_logn := (0).to_natural_32
			if a_n = {NATURAL_32} 1 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_result := factorize_inst.fft_binary_logn (a_n)
				if l_result = -1 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("n is not a power of 2"), ce_string ("real_radix2.c"), 40, 4)
						Result := 4
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				else
					l_logn := l_result.to_natural_32
				end
			end
			if not js.return_called then
				l_status := bitreverse_inst.fft_real_float_bitreverse_order (a_data, a_stride, a_n, l_logn)
				l_p := (1).to_natural_32
				l_q___3 := a_n
				l_i := (1).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i <= l_logn))
				loop
					l_p_1 := l_p
					l_p := {NATURAL_32} 2 * l_p
					l_q___3 := l_q___3 // ({NATURAL_32} 2)
					l_b___0 := (0).to_natural_32
					from
					until
						not (l_b___0 < l_q___3)
					loop
						l_t0_real := a_data[(a_stride * (l_b___0 * l_p)).to_integer_32] + a_data[(a_stride * (l_b___0 * l_p + l_p_1)).to_integer_32]
						l_t1_real := a_data[(a_stride * (l_b___0 * l_p)).to_integer_32] - a_data[(a_stride * (l_b___0 * l_p + l_p_1)).to_integer_32]
						a_data[(a_stride * (l_b___0 * l_p)).to_integer_32] := l_t0_real
						a_data[(a_stride * (l_b___0 * l_p + l_p_1)).to_integer_32] := l_t1_real
						l_b___0 := l_b___0 + 1
					end
					l_w_real := (1.0).truncated_to_real
					l_w_imag := (0.0).truncated_to_real
					l_theta := (-2.0 * 3.14159265358979323846) / l_p.to_real_64
					l_s := (sin (l_theta)).truncated_to_real
					l_t := (sin (l_theta / 2.0)).truncated_to_real
					l_s2 := ((2.0 * l_t.to_double) * l_t.to_double).truncated_to_real
					l_a___5 := (1).to_natural_32
					from
					until
						not (not js.loop_left and then (l_a___5 < l_p_1 // {NATURAL_32} 2))
					loop
						l_tmp_real := (l_w_real - l_s * l_w_imag) - l_s2 * l_w_real
						l_tmp_imag := (l_w_imag + l_s * l_w_real) - l_s2 * l_w_imag
						l_w_real := l_tmp_real
						l_w_imag := l_tmp_imag
						l_b___0 := (0).to_natural_32
						from
						until
							not (l_b___0 < l_q___3)
						loop
							l_z0_real := a_data[(a_stride * (l_b___0 * l_p + l_a___5)).to_integer_32]
							l_z0_imag := a_data[(a_stride * ((l_b___0 * l_p + l_p_1) - l_a___5)).to_integer_32]
							l_z1_real := a_data[(a_stride * ((l_b___0 * l_p + l_p_1) + l_a___5)).to_integer_32]
							l_z1_imag := a_data[(a_stride * ((l_b___0 * l_p + l_p) - l_a___5)).to_integer_32]
							l_t0_real___0 := (l_z0_real + l_w_real * l_z1_real) - l_w_imag * l_z1_imag
							l_t0_imag := (l_z0_imag + l_w_real * l_z1_imag) + l_w_imag * l_z1_real
							l_t1_real___0 := (l_z0_real - l_w_real * l_z1_real) + l_w_imag * l_z1_imag
							l_t1_imag := (l_z0_imag - l_w_real * l_z1_imag) - l_w_imag * l_z1_real
							a_data[(a_stride * (l_b___0 * l_p + l_a___5)).to_integer_32] := l_t0_real___0
							a_data[(a_stride * ((l_b___0 * l_p + l_p) - l_a___5)).to_integer_32] := l_t0_imag
							a_data[(a_stride * ((l_b___0 * l_p + l_p_1) - l_a___5)).to_integer_32] := l_t1_real___0
							a_data[(a_stride * ((l_b___0 * l_p + l_p_1) + l_a___5)).to_integer_32] := -l_t1_imag
							l_b___0 := l_b___0 + 1
						end
						l_a___5 := l_a___5 + 1
					end
					if l_p_1 > {NATURAL_32} 1 then
						l_b___0 := (0).to_natural_32
						from
						until
							not (l_b___0 < l_q___3)
						loop
							a_data[(a_stride * ((l_b___0 * l_p + l_p) - l_p_1 // {NATURAL_32} 2)).to_integer_32] := a_data[(a_stride * ((l_b___0 * l_p + l_p) - l_p_1 // {NATURAL_32} 2)).to_integer_32] * (-1).to_real
							l_b___0 := l_b___0 + 1
						end
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

end
