class
	P_REAL_UNPACK

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_fft_real_unpack (a_real_coefficient: CE_POINTER [REAL_64]; a_complex_coefficient: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("length n must be positive integer"), ce_string ("real_unpack.c"), 31, 1)
					Result := 1
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					a_complex_coefficient[(({NATURAL_32} 2 * a_stride) * l_i).to_integer_32] := a_real_coefficient[(l_i * a_stride).to_integer_32]
					a_complex_coefficient[(({NATURAL_32} 2 * a_stride) * l_i + {NATURAL_32} 1).to_integer_32] := 0.0
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_fft_real_float_unpack (a_real_coefficient: CE_POINTER [REAL_32]; a_complex_coefficient: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("length n must be positive integer"), ce_string ("real_unpack.c"), 31, 1)
					Result := 1
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					a_complex_coefficient[(({NATURAL_32} 2 * a_stride) * l_i).to_integer_32] := a_real_coefficient[(l_i * a_stride).to_integer_32]
					a_complex_coefficient[(({NATURAL_32} 2 * a_stride) * l_i + {NATURAL_32} 1).to_integer_32] := (0.0).truncated_to_real
					l_i := l_i + 1
				end
				Result := 0
			end
		end

end
