class
	P_REIM_SOURCE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_vector_complex_long_double_real (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]): PD_GSL_VECTOR_LONG_DOUBLE_VIEW
		local
			l_s: PD_GSL_VECTOR_LONG_DOUBLE
			l_view: PD_GSL_VECTOR_LONG_DOUBLE_VIEW
		do
			create l_s.make
			create l_view.make

			l_s.size := (0).to_natural_32
			l_s.stride := (0).to_natural_32
			l_s.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_s.data := a_v.item.data
			l_s.size := a_v.item.size
			l_s.stride := {NATURAL_32} 2 * a_v.item.stride
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			l_view.vector := l_s
			Result := l_view
		end

	gsl_vector_complex_long_double_imag (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]): PD_GSL_VECTOR_LONG_DOUBLE_VIEW
		local
			l_s: PD_GSL_VECTOR_LONG_DOUBLE
			l_view: PD_GSL_VECTOR_LONG_DOUBLE_VIEW
		do
			create l_s.make
			create l_view.make

			l_s.size := (0).to_natural_32
			l_s.stride := (0).to_natural_32
			l_s.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_s.data := a_v.item.data + 1
			l_s.size := a_v.item.size
			l_s.stride := {NATURAL_32} 2 * a_v.item.stride
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			l_view.vector := l_s
			Result := l_view
		end

	gsl_vector_complex_real (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): PD_GSL_VECTOR_VIEW
		local
			l_s: PD_GSL_VECTOR
			l_view: PD_GSL_VECTOR_VIEW
		do
			create l_s.make
			create l_view.make

			l_s.size := (0).to_natural_32
			l_s.stride := (0).to_natural_32
			l_s.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_s.data := a_v.item.data
			l_s.size := a_v.item.size
			l_s.stride := {NATURAL_32} 2 * a_v.item.stride
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			l_view.vector := l_s
			Result := l_view
		end

	gsl_vector_complex_imag (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): PD_GSL_VECTOR_VIEW
		local
			l_s: PD_GSL_VECTOR
			l_view: PD_GSL_VECTOR_VIEW
		do
			create l_s.make
			create l_view.make

			l_s.size := (0).to_natural_32
			l_s.stride := (0).to_natural_32
			l_s.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_s.data := a_v.item.data + 1
			l_s.size := a_v.item.size
			l_s.stride := {NATURAL_32} 2 * a_v.item.stride
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			l_view.vector := l_s
			Result := l_view
		end

	gsl_vector_complex_float_real (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): PD_GSL_VECTOR_FLOAT_VIEW
		local
			l_s: PD_GSL_VECTOR_FLOAT
			l_view: PD_GSL_VECTOR_FLOAT_VIEW
		do
			create l_s.make
			create l_view.make

			l_s.size := (0).to_natural_32
			l_s.stride := (0).to_natural_32
			l_s.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_s.data := a_v.item.data
			l_s.size := a_v.item.size
			l_s.stride := {NATURAL_32} 2 * a_v.item.stride
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			l_view.vector := l_s
			Result := l_view
		end

	gsl_vector_complex_float_imag (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): PD_GSL_VECTOR_FLOAT_VIEW
		local
			l_s: PD_GSL_VECTOR_FLOAT
			l_view: PD_GSL_VECTOR_FLOAT_VIEW
		do
			create l_s.make
			create l_view.make

			l_s.size := (0).to_natural_32
			l_s.stride := (0).to_natural_32
			l_s.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_s.data := a_v.item.data + 1
			l_s.size := a_v.item.size
			l_s.stride := {NATURAL_32} 2 * a_v.item.stride
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			l_view.vector := l_s
			Result := l_view
		end

	gsl_vector_complex_long_double_const_real (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]): PD_GSL_VECTOR_LONG_DOUBLE_CONST_VIEW
		local
			l_s: PD_GSL_VECTOR_LONG_DOUBLE
			l_view: PD_GSL_VECTOR_LONG_DOUBLE_CONST_VIEW
		do
			create l_s.make
			create l_view.make

			l_s.size := (0).to_natural_32
			l_s.stride := (0).to_natural_32
			l_s.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_s.data := a_v.item.data
			l_s.size := a_v.item.size
			l_s.stride := {NATURAL_32} 2 * a_v.item.stride
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			l_view.vector := l_s
			Result := l_view
		end

	gsl_vector_complex_long_double_const_imag (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]): PD_GSL_VECTOR_LONG_DOUBLE_CONST_VIEW
		local
			l_s: PD_GSL_VECTOR_LONG_DOUBLE
			l_view: PD_GSL_VECTOR_LONG_DOUBLE_CONST_VIEW
		do
			create l_s.make
			create l_view.make

			l_s.size := (0).to_natural_32
			l_s.stride := (0).to_natural_32
			l_s.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_s.data := (a_v.item.data + 1)
			l_s.size := a_v.item.size
			l_s.stride := {NATURAL_32} 2 * a_v.item.stride
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			l_view.vector := l_s
			Result := l_view
		end

	gsl_vector_complex_const_real (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): PD_GSL_VECTOR_CONST_VIEW
		local
			l_s: PD_GSL_VECTOR
			l_view: PD_GSL_VECTOR_CONST_VIEW
		do
			create l_s.make
			create l_view.make

			l_s.size := (0).to_natural_32
			l_s.stride := (0).to_natural_32
			l_s.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_s.data := a_v.item.data
			l_s.size := a_v.item.size
			l_s.stride := {NATURAL_32} 2 * a_v.item.stride
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			l_view.vector := l_s
			Result := l_view
		end

	gsl_vector_complex_const_imag (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): PD_GSL_VECTOR_CONST_VIEW
		local
			l_s: PD_GSL_VECTOR
			l_view: PD_GSL_VECTOR_CONST_VIEW
		do
			create l_s.make
			create l_view.make

			l_s.size := (0).to_natural_32
			l_s.stride := (0).to_natural_32
			l_s.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_s.data := (a_v.item.data + 1)
			l_s.size := a_v.item.size
			l_s.stride := {NATURAL_32} 2 * a_v.item.stride
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			l_view.vector := l_s
			Result := l_view
		end

	gsl_vector_complex_float_const_real (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): PD_GSL_VECTOR_FLOAT_CONST_VIEW
		local
			l_s: PD_GSL_VECTOR_FLOAT
			l_view: PD_GSL_VECTOR_FLOAT_CONST_VIEW
		do
			create l_s.make
			create l_view.make

			l_s.size := (0).to_natural_32
			l_s.stride := (0).to_natural_32
			l_s.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_s.data := a_v.item.data
			l_s.size := a_v.item.size
			l_s.stride := {NATURAL_32} 2 * a_v.item.stride
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			l_view.vector := l_s
			Result := l_view
		end

	gsl_vector_complex_float_const_imag (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): PD_GSL_VECTOR_FLOAT_CONST_VIEW
		local
			l_s: PD_GSL_VECTOR_FLOAT
			l_view: PD_GSL_VECTOR_FLOAT_CONST_VIEW
		do
			create l_s.make
			create l_view.make

			l_s.size := (0).to_natural_32
			l_s.stride := (0).to_natural_32
			l_s.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_s.data := (a_v.item.data + 1)
			l_s.size := a_v.item.size
			l_s.stride := {NATURAL_32} 2 * a_v.item.stride
			l_s.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_s.owner := 0
			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			l_view.vector := l_s
			Result := l_view
		end

end
