class
	P_RESULTS

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
		end

feature {ANY} -- attributes

	tests: NATURAL_32 assign set_tests

	set_tests (a_tests: NATURAL_32)
		do
			tests := a_tests
		end

	passed: NATURAL_32 assign set_passed

	set_passed (a_passed: NATURAL_32)
		do
			passed := a_passed
		end

	failed: NATURAL_32 assign set_failed

	set_failed (a_failed: NATURAL_32)
		do
			failed := a_failed
		end

	verbose: NATURAL_32 assign set_verbose

	set_verbose (a_verbose: NATURAL_32)
		do
			verbose := a_verbose
		end

feature {ANY} -- routines

	initialise___7
		local
			l_p: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_p.make

			l_p.ce_gets ((getenv (ce_string ("GSL_TEST_VERBOSE"))))
			if (l_p.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called and then ((l_p[0]).to_integer_32 = 0) then
				js.return
			end
			if not js.return_called then
				verbose := (strtoul (l_p, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), 0)).to_natural_32
			end
		end

	update___5 (a_s: INTEGER_32)
		do
			tests := tests + 1
			if a_s = 0 then
				passed := passed + 1
			else
				failed := failed + 1
			end
		end

	gsl_test (a_args: TUPLE [a_status: INTEGER_32; a_test_description: CE_POINTER [INTEGER_8]])
		local
			l_tmp: CE_POINTER [INTEGER_8]
			l_ap: CE_VA_LIST
			l_pos: INTEGER_32
		do
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not tests.to_boolean then
						initialise___7
					end
					update___5 (a_args.a_status)
					if not (a_args.a_status.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (verbose.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if a_args.a_status.to_boolean then
							l_tmp.ce_gets (ce_string ("FAIL: "))
						else
							l_tmp.ce_gets (ce_string ("PASS: "))
						end
						Io.put_string (eif_string (l_tmp))
						create l_ap.make (a_args, 3)
						vprintf (a_args.a_test_description, l_ap).do_nothing
						if a_args.a_status.to_boolean then
							if not verbose.to_boolean then
								Io.put_string (" [" + tests.out + "]")
							end
						end
						Io.put_string ("%N")
						Io.standard_default.flush
				when 5 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_test_rel (a_args: TUPLE [a_result: REAL_64; a_expected: REAL_64; a_relative_error: REAL_64; a_test_description: CE_POINTER [INTEGER_8]])
		local
			l_status: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: REAL_64
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_ap: CE_VA_LIST
			l_pos: INTEGER_32
		do
			create l_tmp___10.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not tests.to_boolean then
						initialise___7
					end
					if not ((infnan_inst.gsl_isnan (a_args.a_result)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_tmp := infnan_inst.gsl_isnan (a_args.a_result)
						l_tmp___0 := infnan_inst.gsl_isnan (a_args.a_expected)
						l_status := (l_tmp /= l_tmp___0).to_integer
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 3 then -- else:
						if not ((infnan_inst.gsl_isnan (a_args.a_expected)).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_tmp := infnan_inst.gsl_isnan (a_args.a_result)
						l_tmp___0 := infnan_inst.gsl_isnan (a_args.a_expected)
						l_status := (l_tmp /= l_tmp___0).to_integer
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 6 then -- else:
						if not ((infnan_inst.gsl_isinf (a_args.a_result)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_tmp___1 := infnan_inst.gsl_isinf (a_args.a_result)
						l_tmp___2 := infnan_inst.gsl_isinf (a_args.a_expected)
						l_status := (l_tmp___1 /= l_tmp___2).to_integer
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 9 then -- else:
						if not ((infnan_inst.gsl_isinf (a_args.a_expected)).to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_tmp___1 := infnan_inst.gsl_isinf (a_args.a_result)
						l_tmp___2 := infnan_inst.gsl_isinf (a_args.a_expected)
						l_status := (l_tmp___1 /= l_tmp___2).to_integer
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 12 then -- else:
						if not (a_args.a_expected > (0).to_double) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if a_args.a_expected < 2.2250738585072014e-308 then
							l_status := -1
						else
							l_pos := -1 + 15 -- goto _L___0
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 15 then -- else: | _L___0:
						if not (a_args.a_expected < (0).to_double) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if a_args.a_expected > -2.2250738585072014e-308 then
							l_status := -1
						else
							l_pos := -1 + 18 -- goto _L
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L:
						if a_args.a_expected /= (0).to_double then
							l_tmp___3 := fabs (a_args.a_result - a_args.a_expected)
							l_status := (l_tmp___3 / (fabs (a_args.a_expected)) > a_args.a_relative_error).to_integer
						else
							l_status := ((fabs (a_args.a_result)) > a_args.a_relative_error).to_integer
						end
				when 19 then -- if done | if done | if done | if done | if done
						update___5 (l_status)
						if not (l_status.to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
							l_pos := -1 + 23 -- goto _L___1
				when 21 then -- if block done, skip else block:
							l_pos := -1 + 24
				when 22 then -- else:
							if not (verbose.to_boolean) then
								l_pos := -1 + 24 -- skip if block
							end
				when 23 then -- if: | _L___1:
							if l_status.to_boolean then
								l_tmp___10.ce_gets (ce_string ("FAIL: "))
							else
								l_tmp___10.ce_gets (ce_string ("PASS: "))
							end
							Io.put_string (eif_string (l_tmp___10))
							create l_ap.make (a_args, 5)
							vprintf (a_args.a_test_description, l_ap).do_nothing
							if l_status = 0 then
								if (strlen (a_args.a_test_description)) < {NATURAL_32} 45 then
									printf ([ce_string (" (%%g observed vs %%g expected)"), a_args.a_result, a_args.a_expected]).do_nothing
								else
									printf ([ce_string (" (%%g obs vs %%g exp)"), a_args.a_result, a_args.a_expected]).do_nothing
								end
							else
								printf ([ce_string (" (%%.18g observed vs %%.18g expected)"), a_args.a_result, a_args.a_expected]).do_nothing
							end
							if l_status = -1 then
								Io.put_string (" [test uses subnormal value]")
							end
							if l_status.to_boolean then
								if not verbose.to_boolean then
									Io.put_string (" [" + tests.out + "]")
								end
							end
							Io.put_string ("%N")
							Io.standard_default.flush
				when 24 then -- if done
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	gsl_test_abs (a_args: TUPLE [a_result: REAL_64; a_expected: REAL_64; a_absolute_error: REAL_64; a_test_description: CE_POINTER [INTEGER_8]])
		local
			l_status: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: REAL_64
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_ap: CE_VA_LIST
			l_pos: INTEGER_32
		do
			create l_tmp___8.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not tests.to_boolean then
						initialise___7
					end
					if not ((infnan_inst.gsl_isnan (a_args.a_result)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_tmp := infnan_inst.gsl_isnan (a_args.a_result)
						l_tmp___0 := infnan_inst.gsl_isnan (a_args.a_expected)
						l_status := (l_tmp /= l_tmp___0).to_integer
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 3 then -- else:
						if not ((infnan_inst.gsl_isnan (a_args.a_expected)).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_tmp := infnan_inst.gsl_isnan (a_args.a_result)
						l_tmp___0 := infnan_inst.gsl_isnan (a_args.a_expected)
						l_status := (l_tmp /= l_tmp___0).to_integer
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 6 then -- else:
						if not ((infnan_inst.gsl_isinf (a_args.a_result)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_tmp___1 := infnan_inst.gsl_isinf (a_args.a_result)
						l_tmp___2 := infnan_inst.gsl_isinf (a_args.a_expected)
						l_status := (l_tmp___1 /= l_tmp___2).to_integer
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 9 then -- else:
						if not ((infnan_inst.gsl_isinf (a_args.a_expected)).to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_tmp___1 := infnan_inst.gsl_isinf (a_args.a_result)
						l_tmp___2 := infnan_inst.gsl_isinf (a_args.a_expected)
						l_status := (l_tmp___1 /= l_tmp___2).to_integer
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 12 then -- else:
						if not (a_args.a_expected > (0).to_double) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if a_args.a_expected < 2.2250738585072014e-308 then
							l_status := -1
						else
							l_pos := -1 + 15 -- goto _L
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else: | _L:
						if a_args.a_expected < (0).to_double then
							if a_args.a_expected > -2.2250738585072014e-308 then
								l_status := -1
							else
								l_tmp___3 := fabs (a_args.a_result - a_args.a_expected)
								l_status := (l_tmp___3 > a_args.a_absolute_error).to_integer
							end
						else
							l_tmp___3 := fabs (a_args.a_result - a_args.a_expected)
							l_status := (l_tmp___3 > a_args.a_absolute_error).to_integer
						end
				when 16 then -- if done | if done | if done | if done
						update___5 (l_status)
						if not (l_status.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
							l_pos := -1 + 20 -- goto _L___0
				when 18 then -- if block done, skip else block:
							l_pos := -1 + 21
				when 19 then -- else:
							if not (verbose.to_boolean) then
								l_pos := -1 + 21 -- skip if block
							end
				when 20 then -- if: | _L___0:
							if l_status.to_boolean then
								l_tmp___8.ce_gets (ce_string ("FAIL: "))
							else
								l_tmp___8.ce_gets (ce_string ("PASS: "))
							end
							Io.put_string (eif_string (l_tmp___8))
							create l_ap.make (a_args, 5)
							vprintf (a_args.a_test_description, l_ap).do_nothing
							if l_status = 0 then
								if (strlen (a_args.a_test_description)) < {NATURAL_32} 45 then
									printf ([ce_string (" (%%g observed vs %%g expected)"), a_args.a_result, a_args.a_expected]).do_nothing
								else
									printf ([ce_string (" (%%g obs vs %%g exp)"), a_args.a_result, a_args.a_expected]).do_nothing
								end
							else
								printf ([ce_string (" (%%.18g observed vs %%.18g expected)"), a_args.a_result, a_args.a_expected]).do_nothing
							end
							if l_status = -1 then
								Io.put_string (" [test uses subnormal value]")
							end
							if l_status.to_boolean then
								if not verbose.to_boolean then
									Io.put_string (" [" + tests.out + "]")
								end
							end
							Io.put_string ("%N")
							Io.standard_default.flush
				when 21 then -- if done
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	gsl_test_factor (a_args: TUPLE [a_result: REAL_64; a_expected: REAL_64; a_factor: REAL_64; a_test_description: CE_POINTER [INTEGER_8]])
		local
			l_status: INTEGER_32
			l_tmp: INTEGER_32
			l_u: REAL_64
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_ap: CE_VA_LIST
			l_pos: INTEGER_32
		do
			create l_tmp___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not tests.to_boolean then
						initialise___7
					end
					if not (a_args.a_expected > (0).to_double) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_args.a_expected < 2.2250738585072014e-308 then
							l_status := -1
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else: | _L___0:
						if not (a_args.a_expected < (0).to_double) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_args.a_expected > -2.2250738585072014e-308 then
							l_status := -1
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if a_args.a_result = a_args.a_expected then
							l_status := 0
						elseif a_args.a_expected = 0.0 then
							if a_args.a_result > a_args.a_expected then
								l_tmp := 1
							elseif a_args.a_result < a_args.a_expected then
								l_tmp := 1
							else
								l_tmp := 0
							end
							l_status := l_tmp
						else
							l_u := a_args.a_result / a_args.a_expected
							if l_u > a_args.a_factor then
								l_tmp___0 := 1
							elseif l_u < 1.0 / a_args.a_factor then
								l_tmp___0 := 1
							else
								l_tmp___0 := 0
							end
							l_status := l_tmp___0
						end
				when 7 then -- if done
						update___5 (l_status)
						if not (l_status.to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
							l_pos := -1 + 11 -- goto _L___1
				when 9 then -- if block done, skip else block:
							l_pos := -1 + 12
				when 10 then -- else:
							if not (verbose.to_boolean) then
								l_pos := -1 + 12 -- skip if block
							end
				when 11 then -- if: | _L___1:
							if l_status.to_boolean then
								l_tmp___1.ce_gets (ce_string ("FAIL: "))
							else
								l_tmp___1.ce_gets (ce_string ("PASS: "))
							end
							Io.put_string (eif_string (l_tmp___1))
							create l_ap.make (a_args, 5)
							vprintf (a_args.a_test_description, l_ap).do_nothing
							if l_status = 0 then
								if (strlen (a_args.a_test_description)) < {NATURAL_32} 45 then
									printf ([ce_string (" (%%g observed vs %%g expected)"), a_args.a_result, a_args.a_expected]).do_nothing
								else
									printf ([ce_string (" (%%g obs vs %%g exp)"), a_args.a_result, a_args.a_expected]).do_nothing
								end
							else
								printf ([ce_string (" (%%.18g observed vs %%.18g expected)"), a_args.a_result, a_args.a_expected]).do_nothing
							end
							if l_status = -1 then
								Io.put_string (" [test uses subnormal value]")
							end
							if l_status.to_boolean then
								if not verbose.to_boolean then
									Io.put_string (" [" + tests.out + "]")
								end
							end
							Io.put_string ("%N")
							Io.standard_default.flush
				when 12 then -- if done
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	gsl_test_int (a_args: TUPLE [a_result: INTEGER_32; a_expected: INTEGER_32; a_test_description: CE_POINTER [INTEGER_8]])
		local
			l_status: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_ap: CE_VA_LIST
			l_pos: INTEGER_32
		do
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_status := (a_args.a_result /= a_args.a_expected).to_integer
					if not tests.to_boolean then
						initialise___7
					end
					update___5 (l_status)
					if not (l_status.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (verbose.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if l_status.to_boolean then
							l_tmp.ce_gets (ce_string ("FAIL: "))
						else
							l_tmp.ce_gets (ce_string ("PASS: "))
						end
						Io.put_string (eif_string (l_tmp))
						create l_ap.make (a_args, 4)
						vprintf (a_args.a_test_description, l_ap).do_nothing
						if l_status = 0 then
							Io.put_string (" (" + a_args.a_result.out + " observed vs " + a_args.a_expected.out + " expected)")
						else
							Io.put_string (" (" + a_args.a_result.out + " observed vs " + a_args.a_expected.out + " expected)")
						end
						if l_status.to_boolean then
							if not verbose.to_boolean then
								Io.put_string (" [" + tests.out + "]")
							end
						end
						Io.put_string ("%N")
						Io.standard_default.flush
				when 5 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_test_str (a_args: TUPLE [a_result: CE_POINTER [INTEGER_8]; a_expected: CE_POINTER [INTEGER_8]; a_test_description: CE_POINTER [INTEGER_8]])
		local
			l_status: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_ap: CE_VA_LIST
			l_pos: INTEGER_32
		do
			create l_tmp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_status := (strcmp (a_args.a_result, a_args.a_expected))
					if not tests.to_boolean then
						initialise___7
					end
					update___5 (l_status)
					if not (l_status.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (verbose.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if l_status.to_boolean then
							l_tmp___0.ce_gets (ce_string ("FAIL: "))
						else
							l_tmp___0.ce_gets (ce_string ("PASS: "))
						end
						Io.put_string (eif_string (l_tmp___0))
						create l_ap.make (a_args, 4)
						vprintf (a_args.a_test_description, l_ap).do_nothing
						if l_status.to_boolean then
							Io.put_string (" (" + eif_string (a_args.a_result) + " observed vs " + eif_string (a_args.a_expected) + " expected)")
						end
						if l_status.to_boolean then
							if not verbose.to_boolean then
								Io.put_string (" [" + tests.out + "]")
							end
						end
						Io.put_string ("%N")
						Io.standard_default.flush
				when 5 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_test_verbose (a_v: INTEGER_32)
		do
			verbose := a_v.to_natural_32
		end

	gsl_test_summary: INTEGER_32
		local
			js: JUMP_STATE
		do
			if failed /= {NATURAL_32} 0 then
				Result := 1
				js.return
			end
			if not js.return_called and then (tests /= passed + failed) then
				if verbose.to_boolean then
					Io.put_string ("TEST RESULTS DO NOT ADD UP " + tests.to_integer_32.out + " != " + passed.to_integer_32.out + " + " + failed.to_integer_32.out + "%N")
				end
				Result := 1
				js.return
			end
			if not js.return_called and then (passed = tests) then
				if not verbose.to_boolean then
					Io.put_string ("Completed [" + passed.to_integer_32.out + "/" + tests.to_integer_32.out + "]%N")
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 1
			end
		end

end
