class
	P_RK8PD

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create Abar.make (<<13>>)
			create A.make (<<12>>)
			create ah.make (<<10>>)
			create b3.make (<<2>>)
			create b4.make (<<3>>)
			create b5.make (<<4>>)
			create b6.make (<<5>>)
			create b7.make (<<6>>)
			create b8.make (<<7>>)
			create b9.make (<<8>>)
			create b10.make (<<9>>)
			create b11.make (<<10>>)
			create b12.make (<<11>>)
			create b13.make (<<12>>)
			create rk8pd_type.make
			create gsl_odeiv_step_rk8pd.make
		end

feature {ANY} -- attributes

	Abar: CE_ARRAY [REAL_64]

	A: CE_ARRAY [REAL_64]

	ah: CE_ARRAY [REAL_64]

	b21: REAL_64 assign set_b21

	set_b21 (a_b21: REAL_64)
		do
			b21 := a_b21
		end

	b3: CE_ARRAY [REAL_64]

	b4: CE_ARRAY [REAL_64]

	b5: CE_ARRAY [REAL_64]

	b6: CE_ARRAY [REAL_64]

	b7: CE_ARRAY [REAL_64]

	b8: CE_ARRAY [REAL_64]

	b9: CE_ARRAY [REAL_64]

	b10: CE_ARRAY [REAL_64]

	b11: CE_ARRAY [REAL_64]

	b12: CE_ARRAY [REAL_64]

	b13: CE_ARRAY [REAL_64]

	rk8pd_type: PD_GSL_ODEIV_STEP_TYPE

	gsl_odeiv_step_rk8pd: CE_POINTER [PD_GSL_ODEIV_STEP_TYPE]

feature {ANY} -- routines

	rk8pd_alloc (a_dim: NATURAL_32): CE_POINTER [ANY]
		local
			l_state: CE_POINTER [PD_RK8PD_STATE_T]
			l_i: INTEGER_32
			l_j: INTEGER_32
			js: JUMP_STATE
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RK8PD_STATE_T]}.make_cast ((malloc ({PD_RK8PD_STATE_T}.sizeof.to_natural_32))))
			if (l_state.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("failed to allocate space for rk8pd_state"), ce_string ("rk8pd.c"), 182, 8)
					Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_state.item.ytmp := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * Real_64_bytes.to_natural_32)))
				if ((l_state.item.ytmp).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for ytmp"), ce_string ("rk8pd.c"), 190, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.y0 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * Real_64_bytes.to_natural_32)))
				if ((l_state.item.y0).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for y0"), ce_string ("rk8pd.c"), 199, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_i := 0
				from
				until
					not (not js.loop_left and then (l_i < 13))
				loop
					l_state.item.k[l_i] := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * Real_64_bytes.to_natural_32)))
					if ((l_state.item.k[l_i]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_j := 0
						from
						until
							not (l_j < l_i)
						loop
							free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k[l_j]))
							l_j := l_j + 1
						end
						free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
						free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp))
						free (create {CE_POINTER [ANY]}.make_cast (l_state))
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("failed to allocate space for k%'s"), ce_string ("rk8pd.c"), 215, 8)
							Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [ANY]}.make_cast (l_state))
			end
		end

	rk8pd_alloc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk8pd_alloc)
		end

	rk8pd_apply (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32; a_t: REAL_64; a_h: REAL_64; a_y: CE_POINTER [REAL_64]; a_yerr: CE_POINTER [REAL_64]; a_dydt_in: CE_POINTER [REAL_64]; a_dydt_out: CE_POINTER [REAL_64]; a_sys: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		local
			l_state: CE_POINTER [PD_RK8PD_STATE_T]
			l_i: NATURAL_32
			l_ytmp: CE_POINTER [REAL_64]
			l_y0: CE_POINTER [REAL_64]
			l_k1: CE_POINTER [REAL_64]
			l_k2: CE_POINTER [REAL_64]
			l_k3: CE_POINTER [REAL_64]
			l_k4: CE_POINTER [REAL_64]
			l_k5: CE_POINTER [REAL_64]
			l_k6: CE_POINTER [REAL_64]
			l_k7: CE_POINTER [REAL_64]
			l_k8: CE_POINTER [REAL_64]
			l_k9: CE_POINTER [REAL_64]
			l_k10: CE_POINTER [REAL_64]
			l_k11: CE_POINTER [REAL_64]
			l_k12: CE_POINTER [REAL_64]
			l_k13: CE_POINTER [REAL_64]
			l_s: INTEGER_32
			l_s___0: INTEGER_32
			l_s___1: INTEGER_32
			l_s___2: INTEGER_32
			l_s___3: INTEGER_32
			l_s___4: INTEGER_32
			l_s___5: INTEGER_32
			l_s___6: INTEGER_32
			l_s___7: INTEGER_32
			l_s___8: INTEGER_32
			l_s___9: INTEGER_32
			l_s___10: INTEGER_32
			l_s___11: INTEGER_32
			l_ksum8: REAL_64
			l_s___12: INTEGER_32
			l_ksum8___0: REAL_64
			l_ksum7: REAL_64
			js: JUMP_STATE
		do
			create l_state.make
			create l_ytmp.make
			create l_y0.make
			create l_k1.make
			create l_k2.make
			create l_k3.make
			create l_k4.make
			create l_k5.make
			create l_k6.make
			create l_k7.make
			create l_k8.make
			create l_k9.make
			create l_k10.make
			create l_k11.make
			create l_k12.make
			create l_k13.make

			l_state.ce_gets (create {CE_POINTER [PD_RK8PD_STATE_T]}.make_cast (a_vstate))
			l_ytmp.ce_gets (l_state.item.ytmp)
			l_y0.ce_gets (l_state.item.y0)
			l_k1.ce_gets (l_state.item.k[0])
			l_k2.ce_gets (l_state.item.k[1])
			l_k3.ce_gets (l_state.item.k[2])
			l_k4.ce_gets (l_state.item.k[3])
			l_k5.ce_gets (l_state.item.k[4])
			l_k6.ce_gets (l_state.item.k[5])
			l_k7.ce_gets (l_state.item.k[6])
			l_k8.ce_gets (l_state.item.k[7])
			l_k9.ce_gets (l_state.item.k[8])
			l_k10.ce_gets (l_state.item.k[9])
			l_k11.ce_gets (l_state.item.k[10])
			l_k12.ce_gets (l_state.item.k[11])
			l_k13.ce_gets (l_state.item.k[12])
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_y0), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * Real_64_bytes.to_natural_32).do_nothing
			if (a_dydt_in.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_k1), create {CE_POINTER [ANY]}.make_cast (a_dydt_in), a_dim * Real_64_bytes.to_natural_32).do_nothing
			else
				l_s := ((a_sys.item.function).integer_32_item ([a_t, a_y, l_k1, a_sys.item.params]))
				if l_s /= 0 then
					Result := l_s
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + ((b21 * a_h) * l_k1[l_i.to_integer_32])
					l_i := l_i + 1
				end
				l_s___0 := ((a_sys.item.function).integer_32_item ([a_t + (ah[0] * a_h), l_ytmp, l_k2, a_sys.item.params]))
				if l_s___0 /= 0 then
					Result := l_s___0
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * (b3[0] * l_k1[l_i.to_integer_32] + b3[1] * l_k2[l_i.to_integer_32])
					l_i := l_i + 1
				end
				l_s___1 := ((a_sys.item.function).integer_32_item ([a_t + (ah[1] * a_h), l_ytmp, l_k3, a_sys.item.params]))
				if l_s___1 /= 0 then
					Result := l_s___1
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * (b4[0] * l_k1[l_i.to_integer_32] + b4[2] * l_k3[l_i.to_integer_32])
					l_i := l_i + 1
				end
				l_s___2 := ((a_sys.item.function).integer_32_item ([a_t + (ah[2] * a_h), l_ytmp, l_k4, a_sys.item.params]))
				if l_s___2 /= 0 then
					Result := l_s___2
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * ((b5[0] * l_k1[l_i.to_integer_32] + b5[2] * l_k3[l_i.to_integer_32]) + b5[3] * l_k4[l_i.to_integer_32])
					l_i := l_i + 1
				end
				l_s___3 := ((a_sys.item.function).integer_32_item ([a_t + (ah[3] * a_h), l_ytmp, l_k5, a_sys.item.params]))
				if l_s___3 /= 0 then
					Result := l_s___3
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * ((b6[0] * l_k1[l_i.to_integer_32] + b6[3] * l_k4[l_i.to_integer_32]) + b6[4] * l_k5[l_i.to_integer_32])
					l_i := l_i + 1
				end
				l_s___4 := ((a_sys.item.function).integer_32_item ([a_t + (ah[4] * a_h), l_ytmp, l_k6, a_sys.item.params]))
				if l_s___4 /= 0 then
					Result := l_s___4
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * (((b7[0] * l_k1[l_i.to_integer_32] + b7[3] * l_k4[l_i.to_integer_32]) + b7[4] * l_k5[l_i.to_integer_32]) + b7[5] * l_k6[l_i.to_integer_32])
					l_i := l_i + 1
				end
				l_s___5 := ((a_sys.item.function).integer_32_item ([a_t + (ah[5] * a_h), l_ytmp, l_k7, a_sys.item.params]))
				if l_s___5 /= 0 then
					Result := l_s___5
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * ((((b8[0] * l_k1[l_i.to_integer_32] + b8[3] * l_k4[l_i.to_integer_32]) + b8[4] * l_k5[l_i.to_integer_32]) + b8[5] * l_k6[l_i.to_integer_32]) + b8[6] * l_k7[l_i.to_integer_32])
					l_i := l_i + 1
				end
				l_s___6 := ((a_sys.item.function).integer_32_item ([a_t + (ah[6] * a_h), l_ytmp, l_k8, a_sys.item.params]))
				if l_s___6 /= 0 then
					Result := l_s___6
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * (((((b9[0] * l_k1[l_i.to_integer_32] + b9[3] * l_k4[l_i.to_integer_32]) + b9[4] * l_k5[l_i.to_integer_32]) + b9[5] * l_k6[l_i.to_integer_32]) + b9[6] * l_k7[l_i.to_integer_32]) + b9[7] * l_k8[l_i.to_integer_32])
					l_i := l_i + 1
				end
				l_s___7 := ((a_sys.item.function).integer_32_item ([a_t + (ah[7] * a_h), l_ytmp, l_k9, a_sys.item.params]))
				if l_s___7 /= 0 then
					Result := l_s___7
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * ((((((b10[0] * l_k1[l_i.to_integer_32] + b10[3] * l_k4[l_i.to_integer_32]) + b10[4] * l_k5[l_i.to_integer_32]) + b10[5] * l_k6[l_i.to_integer_32]) + b10[6] * l_k7[l_i.to_integer_32]) + b10[7] * l_k8[l_i.to_integer_32]) + b10[8] * l_k9[l_i.to_integer_32])
					l_i := l_i + 1
				end
				l_s___8 := ((a_sys.item.function).integer_32_item ([a_t + (ah[8] * a_h), l_ytmp, l_k10, a_sys.item.params]))
				if l_s___8 /= 0 then
					Result := l_s___8
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * (((((((b11[0] * l_k1[l_i.to_integer_32] + b11[3] * l_k4[l_i.to_integer_32]) + b11[4] * l_k5[l_i.to_integer_32]) + b11[5] * l_k6[l_i.to_integer_32]) + b11[6] * l_k7[l_i.to_integer_32]) + b11[7] * l_k8[l_i.to_integer_32]) + b11[8] * l_k9[l_i.to_integer_32]) + b11[9] * l_k10[l_i.to_integer_32])
					l_i := l_i + 1
				end
				l_s___9 := ((a_sys.item.function).integer_32_item ([a_t + (ah[9] * a_h), l_ytmp, l_k11, a_sys.item.params]))
				if l_s___9 /= 0 then
					Result := l_s___9
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * ((((((((b12[0] * l_k1[l_i.to_integer_32] + b12[3] * l_k4[l_i.to_integer_32]) + b12[4] * l_k5[l_i.to_integer_32]) + b12[5] * l_k6[l_i.to_integer_32]) + b12[6] * l_k7[l_i.to_integer_32]) + b12[7] * l_k8[l_i.to_integer_32]) + b12[8] * l_k9[l_i.to_integer_32]) + b12[9] * l_k10[l_i.to_integer_32]) + b12[10] * l_k11[l_i.to_integer_32])
					l_i := l_i + 1
				end
				l_s___10 := ((a_sys.item.function).integer_32_item ([a_t + a_h, l_ytmp, l_k12, a_sys.item.params]))
				if l_s___10 /= 0 then
					Result := l_s___10
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * (((((((((b13[0] * l_k1[l_i.to_integer_32] + b13[3] * l_k4[l_i.to_integer_32]) + b13[4] * l_k5[l_i.to_integer_32]) + b13[5] * l_k6[l_i.to_integer_32]) + b13[6] * l_k7[l_i.to_integer_32]) + b13[7] * l_k8[l_i.to_integer_32]) + b13[8] * l_k9[l_i.to_integer_32]) + b13[9] * l_k10[l_i.to_integer_32]) + b13[10] * l_k11[l_i.to_integer_32]) + b13[11] * l_k12[l_i.to_integer_32])
					l_i := l_i + 1
				end
				l_s___11 := ((a_sys.item.function).integer_32_item ([a_t + a_h, l_ytmp, l_k13, a_sys.item.params]))
				if l_s___11 /= 0 then
					Result := l_s___11
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ksum8 := ((((((((Abar[0] * l_k1[l_i.to_integer_32] + Abar[5] * l_k6[l_i.to_integer_32]) + Abar[6] * l_k7[l_i.to_integer_32]) + Abar[7] * l_k8[l_i.to_integer_32]) + Abar[8] * l_k9[l_i.to_integer_32]) + Abar[9] * l_k10[l_i.to_integer_32]) + Abar[10] * l_k11[l_i.to_integer_32]) + Abar[11] * l_k12[l_i.to_integer_32]) + Abar[12] * l_k13[l_i.to_integer_32])
					a_y[l_i.to_integer_32] := a_y[l_i.to_integer_32] + (a_h * l_ksum8)
					l_i := l_i + 1
				end
				if (a_dydt_out.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					l_s___12 := ((a_sys.item.function).integer_32_item ([a_t + a_h, a_y, a_dydt_out, a_sys.item.params]))
					if l_s___12 /= 0 then
						memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_y0), a_dim * Real_64_bytes.to_natural_32).do_nothing
						Result := l_s___12
						js.return
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ksum8___0 := ((((((((Abar[0] * l_k1[l_i.to_integer_32] + Abar[5] * l_k6[l_i.to_integer_32]) + Abar[6] * l_k7[l_i.to_integer_32]) + Abar[7] * l_k8[l_i.to_integer_32]) + Abar[8] * l_k9[l_i.to_integer_32]) + Abar[9] * l_k10[l_i.to_integer_32]) + Abar[10] * l_k11[l_i.to_integer_32]) + Abar[11] * l_k12[l_i.to_integer_32]) + Abar[12] * l_k13[l_i.to_integer_32])
					l_ksum7 := (((((((A[0] * l_k1[l_i.to_integer_32] + A[5] * l_k6[l_i.to_integer_32]) + A[6] * l_k7[l_i.to_integer_32]) + A[7] * l_k8[l_i.to_integer_32]) + A[8] * l_k9[l_i.to_integer_32]) + A[9] * l_k10[l_i.to_integer_32]) + A[10] * l_k11[l_i.to_integer_32]) + A[11] * l_k12[l_i.to_integer_32])
					a_yerr[l_i.to_integer_32] := a_h * (l_ksum7 - l_ksum8___0)
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	rk8pd_apply_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk8pd_apply)
		end

	rk8pd_reset (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_RK8PD_STATE_T]
			l_i: INTEGER_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RK8PD_STATE_T]}.make_cast (a_vstate))
			l_i := 0
			from
			until
				not (l_i < 13)
			loop
				memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.k[l_i]), 0, a_dim * Real_64_bytes.to_natural_32).do_nothing
				l_i := l_i + 1
			end
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0), 0, a_dim * Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp), 0, a_dim * Real_64_bytes.to_natural_32).do_nothing
			Result := 0
		end

	rk8pd_reset_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk8pd_reset)
		end

	rk8pd_order (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RK8PD_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RK8PD_STATE_T]}.make_cast (a_vstate))
			l_state.ce_gets (create {CE_POINTER [PD_RK8PD_STATE_T]}.make_shared (default_pointer))
			Result := {NATURAL_32} 8
		end

	rk8pd_order_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk8pd_order)
		end

	rk8pd_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_RK8PD_STATE_T]
			l_i: INTEGER_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RK8PD_STATE_T]}.make_cast (a_vstate))
			l_i := 0
			from
			until
				not (l_i < 13)
			loop
				free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k[l_i]))
				l_i := l_i + 1
			end
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp))
			free (create {CE_POINTER [ANY]}.make_cast (l_state))
		end

	rk8pd_free_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rk8pd_free)
		end

end
