class
	P_RKF45

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create ah___1.make (<<5>>)
			create b3___1.make (<<2>>)
			create b4___1.make (<<3>>)
			create b5___1.make (<<4>>)
			create b6___1.make (<<5>>)
			create ec___0.make (<<7>>)
			create rkf45_type.make
			create gsl_odeiv_step_rkf45.make
		end

feature {ANY} -- attributes

	ah___1: CE_ARRAY [REAL_64]

	b3___1: CE_ARRAY [REAL_64]

	b4___1: CE_ARRAY [REAL_64]

	b5___1: CE_ARRAY [REAL_64]

	b6___1: CE_ARRAY [REAL_64]

	c1___0: REAL_64 assign set_c1___0

	set_c1___0 (a_c1___0: REAL_64)
		do
			c1___0 := a_c1___0
		end

	c3___0: REAL_64 assign set_c3___0

	set_c3___0 (a_c3___0: REAL_64)
		do
			c3___0 := a_c3___0
		end

	c4___0: REAL_64 assign set_c4___0

	set_c4___0 (a_c4___0: REAL_64)
		do
			c4___0 := a_c4___0
		end

	c5: REAL_64 assign set_c5

	set_c5 (a_c5: REAL_64)
		do
			c5 := a_c5
		end

	c6___0: REAL_64 assign set_c6___0

	set_c6___0 (a_c6___0: REAL_64)
		do
			c6___0 := a_c6___0
		end

	ec___0: CE_ARRAY [REAL_64]

	rkf45_type: PD_GSL_ODEIV_STEP_TYPE

	gsl_odeiv_step_rkf45: CE_POINTER [PD_GSL_ODEIV_STEP_TYPE]

feature {ANY} -- routines

	rkf45_alloc (a_dim: NATURAL_32): CE_POINTER [ANY]
		local
			l_state: CE_POINTER [PD_RKF45_STATE_T]
			js: JUMP_STATE
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RKF45_STATE_T]}.make_cast ((malloc ({PD_RKF45_STATE_T}.sizeof.to_natural_32))))
			if (l_state.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("failed to allocate space for rkf45_state"), ce_string ("rkf45.c"), 81, 8)
					Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_state.item.k1 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * Real_64_bytes.to_natural_32)))
				if ((l_state.item.k1).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for k1"), ce_string ("rkf45.c"), 89, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.k2 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * Real_64_bytes.to_natural_32)))
				if ((l_state.item.k2).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for k2"), ce_string ("rkf45.c"), 98, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.k3 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * Real_64_bytes.to_natural_32)))
				if ((l_state.item.k3).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k2))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for k3"), ce_string ("rkf45.c"), 108, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.k4 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * Real_64_bytes.to_natural_32)))
				if ((l_state.item.k4).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k3))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k2))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for k4"), ce_string ("rkf45.c"), 119, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.k5 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * Real_64_bytes.to_natural_32)))
				if ((l_state.item.k5).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k4))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k3))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k2))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for k5"), ce_string ("rkf45.c"), 131, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.k6 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * Real_64_bytes.to_natural_32)))
				if ((l_state.item.k6).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k5))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k4))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k3))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k2))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for k6"), ce_string ("rkf45.c"), 144, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.y0 := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * Real_64_bytes.to_natural_32)))
				if ((l_state.item.y0).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k6))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k5))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k4))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k3))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k2))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for y0"), ce_string ("rkf45.c"), 158, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.ytmp := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_dim * Real_64_bytes.to_natural_32)))
				if ((l_state.item.ytmp).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k6))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k5))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k4))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k3))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k2))
					free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1))
					free (create {CE_POINTER [ANY]}.make_cast (l_state))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for ytmp"), ce_string ("rkf45.c"), 173, 8)
						Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [ANY]}.make_cast (l_state))
			end
		end

	rkf45_alloc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rkf45_alloc)
		end

	rkf45_apply (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32; a_t: REAL_64; a_h: REAL_64; a_y: CE_POINTER [REAL_64]; a_yerr: CE_POINTER [REAL_64]; a_dydt_in: CE_POINTER [REAL_64]; a_dydt_out: CE_POINTER [REAL_64]; a_sys: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		local
			l_state: CE_POINTER [PD_RKF45_STATE_T]
			l_i: NATURAL_32
			l_k1: CE_POINTER [REAL_64]
			l_k2: CE_POINTER [REAL_64]
			l_k3: CE_POINTER [REAL_64]
			l_k4: CE_POINTER [REAL_64]
			l_k5: CE_POINTER [REAL_64]
			l_k6: CE_POINTER [REAL_64]
			l_ytmp: CE_POINTER [REAL_64]
			l_y0: CE_POINTER [REAL_64]
			l_s: INTEGER_32
			l_s___0: INTEGER_32
			l_s___1: INTEGER_32
			l_s___2: INTEGER_32
			l_s___3: INTEGER_32
			l_s___4: INTEGER_32
			l_d_i: REAL_64
			l_s___5: INTEGER_32
			js: JUMP_STATE
		do
			create l_state.make
			create l_k1.make
			create l_k2.make
			create l_k3.make
			create l_k4.make
			create l_k5.make
			create l_k6.make
			create l_ytmp.make
			create l_y0.make

			l_state.ce_gets (create {CE_POINTER [PD_RKF45_STATE_T]}.make_cast (a_vstate))
			l_k1.ce_gets (l_state.item.k1)
			l_k2.ce_gets (l_state.item.k2)
			l_k3.ce_gets (l_state.item.k3)
			l_k4.ce_gets (l_state.item.k4)
			l_k5.ce_gets (l_state.item.k5)
			l_k6.ce_gets (l_state.item.k6)
			l_ytmp.ce_gets (l_state.item.ytmp)
			l_y0.ce_gets (l_state.item.y0)
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_y0), create {CE_POINTER [ANY]}.make_cast (a_y), a_dim * Real_64_bytes.to_natural_32).do_nothing
			if (a_dydt_in.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_k1), create {CE_POINTER [ANY]}.make_cast (a_dydt_in), a_dim * Real_64_bytes.to_natural_32).do_nothing
			else
				l_s := ((a_sys.item.function).integer_32_item ([a_t, a_y, l_k1, a_sys.item.params]))
				if l_s /= 0 then
					Result := l_s
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + ((ah___1[0] * a_h) * l_k1[l_i.to_integer_32])
					l_i := l_i + 1
				end
				l_s___0 := ((a_sys.item.function).integer_32_item ([a_t + (ah___1[0] * a_h), l_ytmp, l_k2, a_sys.item.params]))
				if l_s___0 /= 0 then
					Result := l_s___0
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * (b3___1[0] * l_k1[l_i.to_integer_32] + b3___1[1] * l_k2[l_i.to_integer_32])
					l_i := l_i + 1
				end
				l_s___1 := ((a_sys.item.function).integer_32_item ([a_t + (ah___1[1] * a_h), l_ytmp, l_k3, a_sys.item.params]))
				if l_s___1 /= 0 then
					Result := l_s___1
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * ((b4___1[0] * l_k1[l_i.to_integer_32] + b4___1[1] * l_k2[l_i.to_integer_32]) + b4___1[2] * l_k3[l_i.to_integer_32])
					l_i := l_i + 1
				end
				l_s___2 := ((a_sys.item.function).integer_32_item ([a_t + (ah___1[2] * a_h), l_ytmp, l_k4, a_sys.item.params]))
				if l_s___2 /= 0 then
					Result := l_s___2
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * (((b5___1[0] * l_k1[l_i.to_integer_32] + b5___1[1] * l_k2[l_i.to_integer_32]) + b5___1[2] * l_k3[l_i.to_integer_32]) + b5___1[3] * l_k4[l_i.to_integer_32])
					l_i := l_i + 1
				end
				l_s___3 := ((a_sys.item.function).integer_32_item ([a_t + (ah___1[3] * a_h), l_ytmp, l_k5, a_sys.item.params]))
				if l_s___3 /= 0 then
					Result := l_s___3
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * ((((b6___1[0] * l_k1[l_i.to_integer_32] + b6___1[1] * l_k2[l_i.to_integer_32]) + b6___1[2] * l_k3[l_i.to_integer_32]) + b6___1[3] * l_k4[l_i.to_integer_32]) + b6___1[4] * l_k5[l_i.to_integer_32])
					l_i := l_i + 1
				end
				l_s___4 := ((a_sys.item.function).integer_32_item ([a_t + (ah___1[4] * a_h), l_ytmp, l_k6, a_sys.item.params]))
				if l_s___4 /= 0 then
					Result := l_s___4
					js.return
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_d_i := ((((c1___0 * l_k1[l_i.to_integer_32] + c3___0 * l_k3[l_i.to_integer_32]) + c4___0 * l_k4[l_i.to_integer_32]) + c5 * l_k5[l_i.to_integer_32]) + c6___0 * l_k6[l_i.to_integer_32])
					a_y[l_i.to_integer_32] := a_y[l_i.to_integer_32] + (a_h * l_d_i)
					l_i := l_i + 1
				end
				if (a_dydt_out.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					l_s___5 := ((a_sys.item.function).integer_32_item ([a_t + a_h, a_y, a_dydt_out, a_sys.item.params]))
					if l_s___5 /= 0 then
						memcpy (create {CE_POINTER [ANY]}.make_cast (a_y), create {CE_POINTER [ANY]}.make_cast (l_y0), a_dim * Real_64_bytes.to_natural_32).do_nothing
						Result := l_s___5
						js.return
					end
				end
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					a_yerr[l_i.to_integer_32] := a_h * ((((ec___0[1] * l_k1[l_i.to_integer_32] + ec___0[3] * l_k3[l_i.to_integer_32]) + ec___0[4] * l_k4[l_i.to_integer_32]) + ec___0[5] * l_k5[l_i.to_integer_32]) + ec___0[6] * l_k6[l_i.to_integer_32])
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	rkf45_apply_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rkf45_apply)
		end

	rkf45_reset (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_RKF45_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RKF45_STATE_T]}.make_cast (a_vstate))
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1), 0, a_dim * Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.k2), 0, a_dim * Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.k3), 0, a_dim * Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.k4), 0, a_dim * Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.k5), 0, a_dim * Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.k6), 0, a_dim * Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp), 0, a_dim * Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0), 0, a_dim * Real_64_bytes.to_natural_32).do_nothing
			Result := 0
		end

	rkf45_reset_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rkf45_reset)
		end

	rkf45_order (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RKF45_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RKF45_STATE_T]}.make_cast (a_vstate))
			l_state.ce_gets (create {CE_POINTER [PD_RKF45_STATE_T]}.make_shared (default_pointer))
			Result := {NATURAL_32} 5
		end

	rkf45_order_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rkf45_order)
		end

	rkf45_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_RKF45_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RKF45_STATE_T]}.make_cast (a_vstate))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.ytmp))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.y0))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k6))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k5))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k4))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k3))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k2))
			free (create {CE_POINTER [ANY]}.make_cast (l_state.item.k1))
			free (create {CE_POINTER [ANY]}.make_cast (l_state))
		end

	rkf45_free_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent rkf45_free)
		end

end
