class
	P_SCHUR

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_schur_gen_eigvals (a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_B: CE_POINTER [PD_GSL_MATRIX]; a_wr1: CE_POINTER [REAL_64]; a_wr2: CE_POINTER [REAL_64]; a_wi: CE_POINTER [REAL_64]; a_scale1: CE_POINTER [REAL_64]; a_scale2: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_safemin: REAL_64
			l_safemax: REAL_64
			l_rtmin: REAL_64
			l_rtmax: REAL_64
			l_anorm: REAL_64
			l_bnorm: REAL_64
			l_ascale: REAL_64
			l_bscale: REAL_64
			l_bsize: REAL_64
			l_s1: REAL_64
			l_s2: REAL_64
			l_A11: REAL_64
			l_A12: REAL_64
			l_A21: REAL_64
			l_A22: REAL_64
			l_B11: REAL_64
			l_B12: REAL_64
			l_B22: REAL_64
			l_binv11: REAL_64
			l_binv22: REAL_64
			l_bmin: REAL_64
			l_as11: REAL_64
			l_as12: REAL_64
			l_as22: REAL_64
			l_abi22: REAL_64
			l_pp: REAL_64
			l_qq: REAL_64
			l_shift___0: REAL_64
			l_ss: REAL_64
			l_discr: REAL_64
			l_r___3: REAL_64
			l_tmp___34: REAL_64
			l_tmp___38: REAL_64
			l_tmp___41: REAL_64
			l_tmp___43: REAL_64
			l_tmp___45: REAL_64
			l_tmp___47: REAL_64
			l_tmp___59: REAL_64
			l_tmp___63: REAL_64
			l_tmp___66: REAL_64
			l_tmp___68: REAL_64
			l_tmp___70: REAL_64
			l_tmp___72: REAL_64
			l_tmp___105: REAL_64
			l_tmp___107: REAL_64
			l_tmp___108: REAL_64
			l_tmp___111: REAL_64
			l_tmp___113: REAL_64
			l_tmp___114: REAL_64
			l_tmp___123: REAL_64
			l_tmp___125: REAL_64
			l_tmp___126: REAL_64
			l_tmp___129: REAL_64
			l_tmp___131: INTEGER_32
			l_tmp___133: INTEGER_32
			l_tmp___146: REAL_64
			l_tmp___148: REAL_64
			l_tmp___149: REAL_64
			l_tmp___151: REAL_64
			l_tmp___154: REAL_64
			l_tmp___156: REAL_64
			l_tmp___157: REAL_64
			l_tmp___163: REAL_64
			l_tmp___165: REAL_64
			l_sum: REAL_64
			l_tmp___174: INTEGER_32
			l_diff: REAL_64
			l_tmp___175: INTEGER_32
			l_wbig: REAL_64
			l_wsmall: REAL_64
			l_wdet: REAL_64
			l_tmp___176: REAL_64
			l_tmp___179: REAL_64
			l_fuzzy1: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_c4___2: REAL_64
			l_c5___1: REAL_64
			l_wabs: REAL_64
			l_wsize: REAL_64
			l_wscale: REAL_64
			l_tmp___181: REAL_64
			l_tmp___182: REAL_64
			l_tmp___183: REAL_64
			l_tmp___243: REAL_64
			l_tmp___244: REAL_64
			l_tmp___245: REAL_64
			l_tmp___246: REAL_64
			l_tmp___248: REAL_64
			l_tmp___249: REAL_64
			l_tmp___250: REAL_64
			l_tmp___251: REAL_64
			l_tmp___257: REAL_64
			l_tmp___258: REAL_64
			l_tmp___259: REAL_64
			l_tmp___260: REAL_64
			l_tmp___262: REAL_64
			l_tmp___263: REAL_64
			l_tmp___264: REAL_64
			l_tmp___283: REAL_64
			l_tmp___284: REAL_64
			l_tmp___285: REAL_64
			l_tmp___286: REAL_64
			l_tmp___288: REAL_64
			l_tmp___289: REAL_64
			l_tmp___290: REAL_64
			l_tmp___291: REAL_64
			l_tmp___297: REAL_64
			l_tmp___298: REAL_64
			l_tmp___299: REAL_64
			l_tmp___300: REAL_64
			l_tmp___302: REAL_64
			l_tmp___303: REAL_64
			l_tmp___304: REAL_64
			l_tmp___305: REAL_64
			l_tmp___306: REAL_64
			l_tmp___307: REAL_64
			l_tmp___308: REAL_64
			l_tmp___503: REAL_64
			l_tmp___505: REAL_64
			l_tmp___508: REAL_64
			l_tmp___510: REAL_64
			l_tmp___511: REAL_64
			l_tmp___518: REAL_64
			l_tmp___520: REAL_64
			l_tmp___523: REAL_64
			l_tmp___525: REAL_64
			l_tmp___547: REAL_64
			l_tmp___549: REAL_64
			l_tmp___552: REAL_64
			l_tmp___554: REAL_64
			l_tmp___555: REAL_64
			l_tmp___562: REAL_64
			l_tmp___564: REAL_64
			l_tmp___567: REAL_64
			l_tmp___633: REAL_64
			l_tmp___635: REAL_64
			l_tmp___638: REAL_64
			l_tmp___640: REAL_64
			l_tmp___641: REAL_64
			l_tmp___648: REAL_64
			l_tmp___650: REAL_64
			l_tmp___653: REAL_64
			l_tmp___655: REAL_64
			l_tmp___677: REAL_64
			l_tmp___679: REAL_64
			l_tmp___682: REAL_64
			l_tmp___684: REAL_64
			l_tmp___685: REAL_64
			l_tmp___692: REAL_64
			l_tmp___694: REAL_64
			l_tmp___697: REAL_64
			l_tmp___699: REAL_64
			l_tmp___700: REAL_64
			l_tmp___701: REAL_64
			l_tmp___702: REAL_64
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_safemin := 2.2250738585072014e-308 * 1.0e2
					l_safemax := 1.0 / l_safemin
					l_rtmin := (sqrt (l_safemin))
					l_rtmax := 1.0 / l_rtmin
					l_tmp___68 := fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (0).to_natural_32)))
					l_tmp___70 := fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (0).to_natural_32)))
					l_tmp___72 := fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (1).to_natural_32)))
					if l_tmp___68 + l_tmp___70 > l_tmp___72 + (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (1).to_natural_32)))) then
						l_tmp___59 := fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (0).to_natural_32)))
						l_tmp___66 := l_tmp___59 + (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (0).to_natural_32))))
					else
						l_tmp___63 := fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (1).to_natural_32)))
						l_tmp___66 := l_tmp___63 + (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (1).to_natural_32))))
					end
					if l_tmp___66 > l_safemin then
						l_tmp___43 := fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (0).to_natural_32)))
						l_tmp___45 := fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (0).to_natural_32)))
						l_tmp___47 := fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (1).to_natural_32)))
						if l_tmp___43 + l_tmp___45 > l_tmp___47 + (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (1).to_natural_32)))) then
							l_tmp___34 := fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (0).to_natural_32)))
							l_tmp___41 := l_tmp___34 + (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (0).to_natural_32))))
						else
							l_tmp___38 := fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (1).to_natural_32)))
							l_tmp___41 := l_tmp___38 + (fabs ((gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (1).to_natural_32))))
						end
						l_anorm := l_tmp___41
					else
						l_anorm := l_safemin
					end
					l_ascale := 1.0 / l_anorm
					l_A11 := l_ascale * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (0).to_natural_32))
					l_A12 := l_ascale * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (1).to_natural_32))
					l_A21 := l_ascale * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (0).to_natural_32))
					l_A22 := l_ascale * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (1).to_natural_32))
					l_B11 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_B, (0).to_natural_32, (0).to_natural_32)
					l_B12 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_B, (0).to_natural_32, (1).to_natural_32)
					l_B22 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_B, (1).to_natural_32, (1).to_natural_32)
					l_tmp___114 := fabs (l_B11)
					l_tmp___126 := fabs (l_B12)
					if (fabs (l_B22)) > l_rtmin then
						l_tmp___129 := (fabs (l_B22))
					else
						l_tmp___129 := l_rtmin
					end
					if l_tmp___126 > l_tmp___129 then
						l_tmp___125 := (fabs (l_B12))
					else
						if (fabs (l_B22)) > l_rtmin then
							l_tmp___123 := (fabs (l_B22))
						else
							l_tmp___123 := l_rtmin
						end
						l_tmp___125 := l_tmp___123
					end
					if l_tmp___114 > l_tmp___125 then
						l_tmp___113 := (fabs (l_B11))
					else
						l_tmp___108 := fabs (l_B12)
						if (fabs (l_B22)) > l_rtmin then
							l_tmp___111 := (fabs (l_B22))
						else
							l_tmp___111 := l_rtmin
						end
						if l_tmp___108 > l_tmp___111 then
							l_tmp___107 := (fabs (l_B12))
						else
							if (fabs (l_B22)) > l_rtmin then
								l_tmp___105 := (fabs (l_B22))
							else
								l_tmp___105 := l_rtmin
							end
							l_tmp___107 := l_tmp___105
						end
						l_tmp___113 := l_tmp___107
					end
					l_bmin := l_rtmin * l_tmp___113
					if (fabs (l_B11)) < l_bmin then
						if l_B11 >= 0.0 then
							l_tmp___131 := 1
						else
							l_tmp___131 := -1
						end
						l_B11 := l_tmp___131.to_double * l_bmin
					end
					if (fabs (l_B22)) < l_bmin then
						if l_B22 >= 0.0 then
							l_tmp___133 := 1
						else
							l_tmp___133 := -1
						end
						l_B22 := l_tmp___133.to_double * l_bmin
					end
					l_tmp___151 := fabs (l_B11)
					l_tmp___157 := fabs (l_B12)
					if l_tmp___157 + (fabs (l_B22)) > l_safemin then
						l_tmp___154 := fabs (l_B12)
						l_tmp___156 := l_tmp___154 + (fabs (l_B22))
					else
						l_tmp___156 := l_safemin
					end
					if l_tmp___151 > l_tmp___156 then
						l_bnorm := (fabs (l_B11))
					else
						l_tmp___149 := fabs (l_B12)
						if l_tmp___149 + (fabs (l_B22)) > l_safemin then
							l_tmp___146 := fabs (l_B12)
							l_tmp___148 := l_tmp___146 + (fabs (l_B22))
						else
							l_tmp___148 := l_safemin
						end
						l_bnorm := l_tmp___148
					end
					l_tmp___163 := fabs (l_B11)
					if l_tmp___163 > (fabs (l_B22)) then
						l_bsize := (fabs (l_B11))
					else
						l_bsize := (fabs (l_B22))
					end
					l_bscale := 1.0 / l_bsize
					l_B11 := l_B11 * l_bscale
					l_B12 := l_B12 * l_bscale
					l_B22 := l_B22 * l_bscale
					l_binv11 := 1.0 / l_B11
					l_binv22 := 1.0 / l_B22
					l_s1 := l_A11 * l_binv11
					l_s2 := l_A22 * l_binv22
					l_tmp___165 := fabs (l_s1)
					if l_tmp___165 <= (fabs (l_s2)) then
						l_as12 := l_A12 - l_s1 * l_B12
						l_as22 := l_A22 - l_s1 * l_B22
						l_ss := l_A21 * (l_binv11 * l_binv22)
						l_abi22 := l_as22 * l_binv22 - l_ss * l_B12
						l_pp := 0.5 * l_abi22
						l_shift___0 := l_s1
					else
						l_as12 := l_A12 - l_s2 * l_B12
						l_as11 := l_A11 - l_s2 * l_B11
						l_ss := l_A21 * (l_binv11 * l_binv22)
						l_abi22 := -l_ss * l_B12
						l_pp := 0.5 * (l_as11 * l_binv11 + l_abi22)
						l_shift___0 := l_s2
					end
					l_qq := l_ss * l_as12
					if (fabs (l_pp * l_rtmin)) >= 1.0 then
						l_discr := (l_rtmin * l_pp) * (l_rtmin * l_pp) + l_qq * l_safemin
						l_r___3 := (sqrt ((fabs (l_discr)))) * l_rtmax
					elseif l_pp * l_pp + (fabs (l_qq)) <= l_safemin then
						l_discr := (l_rtmax * l_pp) * (l_rtmax * l_pp) + l_qq * l_safemax
						l_r___3 := (sqrt ((fabs (l_discr)))) * l_rtmin
					else
						l_discr := l_pp * l_pp + l_qq
						l_r___3 := sqrt ((fabs (l_discr)))
					end
					if not (l_discr >= 0.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if l_r___3 /= 0.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						if l_pp >= 0.0 then
							l_tmp___174 := 1
						else
							l_tmp___174 := -1
						end
						l_sum := l_pp + l_tmp___174.to_double * l_r___3
						if l_pp >= 0.0 then
							l_tmp___175 := 1
						else
							l_tmp___175 := -1
						end
						l_diff := l_pp - l_tmp___175.to_double * l_r___3
						l_wbig := l_shift___0 + l_sum
						l_wsmall := l_shift___0 + l_diff
						l_tmp___176 := fabs (l_wbig)
						if (fabs (l_wsmall)) > l_safemin then
							l_tmp___179 := (fabs (l_wsmall))
						else
							l_tmp___179 := l_safemin
						end
						if 0.5 * l_tmp___176 > l_tmp___179 then
							l_wdet := (l_A11 * l_A22 - l_A12 * l_A21) * (l_binv11 * l_binv22)
							l_wsmall := l_wdet / l_wbig
						end
						if l_pp > l_abi22 then
							if l_wbig < l_wsmall then
								a_wr1.item := l_wbig
							else
								a_wr1.item := l_wsmall
							end
							if l_wbig > l_wsmall then
								a_wr2.item := l_wbig
							else
								a_wr2.item := l_wsmall
							end
						else
							if l_wbig > l_wsmall then
								a_wr1.item := l_wbig
							else
								a_wr1.item := l_wsmall
							end
							if l_wbig < l_wsmall then
								a_wr2.item := l_wbig
							else
								a_wr2.item := l_wsmall
							end
						end
						a_wi.item := 0.0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						a_wr1.item := l_shift___0 + l_pp
						a_wr2.item := a_wr1.item
						a_wi.item := l_r___3
				when 7 then -- if done
						l_fuzzy1 := 1.0 + 1.0e-5
						if 1.0 > l_ascale then
							l_tmp___181 := 1.0
						else
							l_tmp___181 := l_ascale
						end
						l_c1___2 := l_bsize * (l_safemin * l_tmp___181)
						if 1.0 > l_bnorm then
							l_tmp___182 := 1.0
						else
							l_tmp___182 := l_bnorm
						end
						l_c2___0 := l_safemin * l_tmp___182
						l_c3___3 := l_bsize * l_safemin
						if l_ascale <= 1.0 then
							if l_bsize <= 1.0 then
								if 1.0 < (l_ascale / l_safemin) * l_bsize then
									l_c4___2 := 1.0
								else
									l_c4___2 := (l_ascale / l_safemin) * l_bsize
								end
							else
								l_c4___2 := 1.0
							end
						else
							l_c4___2 := 1.0
						end
						if not (l_ascale <= 1.0) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
							l_pos := -1 + 11 -- goto _L___0
				when 9 then -- if block done, skip else block:
							l_pos := -1 + 14
				when 10 then -- else:
							if not (l_bsize <= 1.0) then
								l_pos := -1 + 13 -- skip if block
							end
				when 11 then -- if: | _L___0:
							if 1.0 < l_ascale * l_bsize then
								l_c5___1 := 1.0
							else
								l_c5___1 := l_ascale * l_bsize
							end
				when 12 then -- if block done, skip else block:
							l_pos := -1 + 14
				when 13 then -- else:
							l_c5___1 := 1.0
				when 14 then -- if done
							l_tmp___183 := fabs (a_wr1.item)
							l_wabs := l_tmp___183 + (fabs (a_wi.item))
							if l_wabs > l_c5___1 then
								l_tmp___304 := l_wabs
							else
								l_tmp___304 := l_c5___1
							end
							if l_c4___2 < 0.5 * l_tmp___304 then
								l_tmp___303 := l_c4___2
							else
								if l_wabs > l_c5___1 then
									l_tmp___302 := l_wabs
								else
									l_tmp___302 := l_c5___1
								end
								l_tmp___303 := 0.5 * l_tmp___302
							end
							if l_fuzzy1 * (l_wabs * l_c2___0 + l_c3___3) > l_tmp___303 then
								l_tmp___300 := l_fuzzy1 * (l_wabs * l_c2___0 + l_c3___3)
							else
								if l_wabs > l_c5___1 then
									l_tmp___299 := l_wabs
								else
									l_tmp___299 := l_c5___1
								end
								if l_c4___2 < 0.5 * l_tmp___299 then
									l_tmp___298 := l_c4___2
								else
									if l_wabs > l_c5___1 then
										l_tmp___297 := l_wabs
									else
										l_tmp___297 := l_c5___1
									end
									l_tmp___298 := 0.5 * l_tmp___297
								end
								l_tmp___300 := l_tmp___298
							end
							if l_c1___2 > l_tmp___300 then
								l_tmp___291 := l_c1___2
							else
								if l_wabs > l_c5___1 then
									l_tmp___290 := l_wabs
								else
									l_tmp___290 := l_c5___1
								end
								if l_c4___2 < 0.5 * l_tmp___290 then
									l_tmp___289 := l_c4___2
								else
									if l_wabs > l_c5___1 then
										l_tmp___288 := l_wabs
									else
										l_tmp___288 := l_c5___1
									end
									l_tmp___289 := 0.5 * l_tmp___288
								end
								if l_fuzzy1 * (l_wabs * l_c2___0 + l_c3___3) > l_tmp___289 then
									l_tmp___286 := l_fuzzy1 * (l_wabs * l_c2___0 + l_c3___3)
								else
									if l_wabs > l_c5___1 then
										l_tmp___285 := l_wabs
									else
										l_tmp___285 := l_c5___1
									end
									if l_c4___2 < 0.5 * l_tmp___285 then
										l_tmp___284 := l_c4___2
									else
										if l_wabs > l_c5___1 then
											l_tmp___283 := l_wabs
										else
											l_tmp___283 := l_c5___1
										end
										l_tmp___284 := 0.5 * l_tmp___283
									end
									l_tmp___286 := l_tmp___284
								end
								l_tmp___291 := l_tmp___286
							end
							if l_safemin > l_tmp___291 then
								l_wsize := l_safemin
							else
								if l_wabs > l_c5___1 then
									l_tmp___264 := l_wabs
								else
									l_tmp___264 := l_c5___1
								end
								if l_c4___2 < 0.5 * l_tmp___264 then
									l_tmp___263 := l_c4___2
								else
									if l_wabs > l_c5___1 then
										l_tmp___262 := l_wabs
									else
										l_tmp___262 := l_c5___1
									end
									l_tmp___263 := 0.5 * l_tmp___262
								end
								if l_fuzzy1 * (l_wabs * l_c2___0 + l_c3___3) > l_tmp___263 then
									l_tmp___260 := l_fuzzy1 * (l_wabs * l_c2___0 + l_c3___3)
								else
									if l_wabs > l_c5___1 then
										l_tmp___259 := l_wabs
									else
										l_tmp___259 := l_c5___1
									end
									if l_c4___2 < 0.5 * l_tmp___259 then
										l_tmp___258 := l_c4___2
									else
										if l_wabs > l_c5___1 then
											l_tmp___257 := l_wabs
										else
											l_tmp___257 := l_c5___1
										end
										l_tmp___258 := 0.5 * l_tmp___257
									end
									l_tmp___260 := l_tmp___258
								end
								if l_c1___2 > l_tmp___260 then
									l_tmp___251 := l_c1___2
								else
									if l_wabs > l_c5___1 then
										l_tmp___250 := l_wabs
									else
										l_tmp___250 := l_c5___1
									end
									if l_c4___2 < 0.5 * l_tmp___250 then
										l_tmp___249 := l_c4___2
									else
										if l_wabs > l_c5___1 then
											l_tmp___248 := l_wabs
										else
											l_tmp___248 := l_c5___1
										end
										l_tmp___249 := 0.5 * l_tmp___248
									end
									if l_fuzzy1 * (l_wabs * l_c2___0 + l_c3___3) > l_tmp___249 then
										l_tmp___246 := l_fuzzy1 * (l_wabs * l_c2___0 + l_c3___3)
									else
										if l_wabs > l_c5___1 then
											l_tmp___245 := l_wabs
										else
											l_tmp___245 := l_c5___1
										end
										if l_c4___2 < 0.5 * l_tmp___245 then
											l_tmp___244 := l_c4___2
										else
											if l_wabs > l_c5___1 then
												l_tmp___243 := l_wabs
											else
												l_tmp___243 := l_c5___1
											end
											l_tmp___244 := 0.5 * l_tmp___243
										end
										l_tmp___246 := l_tmp___244
									end
									l_tmp___251 := l_tmp___246
								end
								l_wsize := l_tmp___251
							end
							if l_wsize /= 1.0 then
								l_wscale := 1.0 / l_wsize
								if l_wsize > 1.0 then
									if l_ascale > l_bsize then
										l_tmp___305 := l_ascale
									else
										l_tmp___305 := l_bsize
									end
									if l_ascale < l_bsize then
										l_tmp___306 := l_ascale
									else
										l_tmp___306 := l_bsize
									end
									a_scale1.item := (l_tmp___305 * l_wscale) * l_tmp___306
								else
									if l_ascale < l_bsize then
										l_tmp___307 := l_ascale
									else
										l_tmp___307 := l_bsize
									end
									if l_ascale > l_bsize then
										l_tmp___308 := l_ascale
									else
										l_tmp___308 := l_bsize
									end
									a_scale1.item := (l_tmp___307 * l_wscale) * l_tmp___308
								end
								a_wr1.item := a_wr1.item * l_wscale
								if a_wi.item /= 0.0 then
									a_wi.item := a_wi.item * l_wscale
									a_wr2.item := a_wr1.item
									a_scale2.item := a_scale1.item
								end
							else
								a_scale1.item := l_ascale * l_bsize
								a_scale2.item := a_scale1.item
							end
							if a_wi.item = 0.0 then
								l_tmp___685 := fabs (a_wr2.item)
								if (fabs (a_wr2.item)) > l_c5___1 then
									l_tmp___697 := (fabs (a_wr2.item))
								else
									l_tmp___697 := l_c5___1
								end
								if l_c4___2 < 0.5 * l_tmp___697 then
									l_tmp___694 := l_c4___2
								else
									if (fabs (a_wr2.item)) > l_c5___1 then
										l_tmp___692 := (fabs (a_wr2.item))
									else
										l_tmp___692 := l_c5___1
									end
									l_tmp___694 := 0.5 * l_tmp___692
								end
								if l_fuzzy1 * (l_tmp___685 * l_c2___0 + l_c3___3) > l_tmp___694 then
									l_tmp___684 := l_fuzzy1 * ((fabs (a_wr2.item)) * l_c2___0 + l_c3___3)
								else
									if (fabs (a_wr2.item)) > l_c5___1 then
										l_tmp___682 := (fabs (a_wr2.item))
									else
										l_tmp___682 := l_c5___1
									end
									if l_c4___2 < 0.5 * l_tmp___682 then
										l_tmp___679 := l_c4___2
									else
										if (fabs (a_wr2.item)) > l_c5___1 then
											l_tmp___677 := (fabs (a_wr2.item))
										else
											l_tmp___677 := l_c5___1
										end
										l_tmp___679 := 0.5 * l_tmp___677
									end
									l_tmp___684 := l_tmp___679
								end
								if l_c1___2 > l_tmp___684 then
									l_tmp___655 := l_c1___2
								else
									l_tmp___641 := fabs (a_wr2.item)
									if (fabs (a_wr2.item)) > l_c5___1 then
										l_tmp___653 := (fabs (a_wr2.item))
									else
										l_tmp___653 := l_c5___1
									end
									if l_c4___2 < 0.5 * l_tmp___653 then
										l_tmp___650 := l_c4___2
									else
										if (fabs (a_wr2.item)) > l_c5___1 then
											l_tmp___648 := (fabs (a_wr2.item))
										else
											l_tmp___648 := l_c5___1
										end
										l_tmp___650 := 0.5 * l_tmp___648
									end
									if l_fuzzy1 * (l_tmp___641 * l_c2___0 + l_c3___3) > l_tmp___650 then
										l_tmp___640 := l_fuzzy1 * ((fabs (a_wr2.item)) * l_c2___0 + l_c3___3)
									else
										if (fabs (a_wr2.item)) > l_c5___1 then
											l_tmp___638 := (fabs (a_wr2.item))
										else
											l_tmp___638 := l_c5___1
										end
										if l_c4___2 < 0.5 * l_tmp___638 then
											l_tmp___635 := l_c4___2
										else
											if (fabs (a_wr2.item)) > l_c5___1 then
												l_tmp___633 := (fabs (a_wr2.item))
											else
												l_tmp___633 := l_c5___1
											end
											l_tmp___635 := 0.5 * l_tmp___633
										end
										l_tmp___640 := l_tmp___635
									end
									l_tmp___655 := l_tmp___640
								end
								if l_safemin > l_tmp___655 then
									l_wsize := l_safemin
								else
									l_tmp___555 := fabs (a_wr2.item)
									if (fabs (a_wr2.item)) > l_c5___1 then
										l_tmp___567 := (fabs (a_wr2.item))
									else
										l_tmp___567 := l_c5___1
									end
									if l_c4___2 < 0.5 * l_tmp___567 then
										l_tmp___564 := l_c4___2
									else
										if (fabs (a_wr2.item)) > l_c5___1 then
											l_tmp___562 := (fabs (a_wr2.item))
										else
											l_tmp___562 := l_c5___1
										end
										l_tmp___564 := 0.5 * l_tmp___562
									end
									if l_fuzzy1 * (l_tmp___555 * l_c2___0 + l_c3___3) > l_tmp___564 then
										l_tmp___554 := l_fuzzy1 * ((fabs (a_wr2.item)) * l_c2___0 + l_c3___3)
									else
										if (fabs (a_wr2.item)) > l_c5___1 then
											l_tmp___552 := (fabs (a_wr2.item))
										else
											l_tmp___552 := l_c5___1
										end
										if l_c4___2 < 0.5 * l_tmp___552 then
											l_tmp___549 := l_c4___2
										else
											if (fabs (a_wr2.item)) > l_c5___1 then
												l_tmp___547 := (fabs (a_wr2.item))
											else
												l_tmp___547 := l_c5___1
											end
											l_tmp___549 := 0.5 * l_tmp___547
										end
										l_tmp___554 := l_tmp___549
									end
									if l_c1___2 > l_tmp___554 then
										l_tmp___525 := l_c1___2
									else
										l_tmp___511 := fabs (a_wr2.item)
										if (fabs (a_wr2.item)) > l_c5___1 then
											l_tmp___523 := (fabs (a_wr2.item))
										else
											l_tmp___523 := l_c5___1
										end
										if l_c4___2 < 0.5 * l_tmp___523 then
											l_tmp___520 := l_c4___2
										else
											if (fabs (a_wr2.item)) > l_c5___1 then
												l_tmp___518 := (fabs (a_wr2.item))
											else
												l_tmp___518 := l_c5___1
											end
											l_tmp___520 := 0.5 * l_tmp___518
										end
										if l_fuzzy1 * (l_tmp___511 * l_c2___0 + l_c3___3) > l_tmp___520 then
											l_tmp___510 := l_fuzzy1 * ((fabs (a_wr2.item)) * l_c2___0 + l_c3___3)
										else
											if (fabs (a_wr2.item)) > l_c5___1 then
												l_tmp___508 := (fabs (a_wr2.item))
											else
												l_tmp___508 := l_c5___1
											end
											if l_c4___2 < 0.5 * l_tmp___508 then
												l_tmp___505 := l_c4___2
											else
												if (fabs (a_wr2.item)) > l_c5___1 then
													l_tmp___503 := (fabs (a_wr2.item))
												else
													l_tmp___503 := l_c5___1
												end
												l_tmp___505 := 0.5 * l_tmp___503
											end
											l_tmp___510 := l_tmp___505
										end
										l_tmp___525 := l_tmp___510
									end
									l_wsize := l_tmp___525
								end
								if l_wsize /= 1.0 then
									l_wscale := 1.0 / l_wsize
									if l_wsize > 1.0 then
										if l_ascale > l_bsize then
											l_tmp___699 := l_ascale
										else
											l_tmp___699 := l_bsize
										end
										if l_ascale < l_bsize then
											l_tmp___700 := l_ascale
										else
											l_tmp___700 := l_bsize
										end
										a_scale2.item := (l_tmp___699 * l_wscale) * l_tmp___700
									else
										if l_ascale < l_bsize then
											l_tmp___701 := l_ascale
										else
											l_tmp___701 := l_bsize
										end
										if l_ascale > l_bsize then
											l_tmp___702 := l_ascale
										else
											l_tmp___702 := l_bsize
										end
										a_scale2.item := (l_tmp___701 * l_wscale) * l_tmp___702
									end
									a_wr2.item := a_wr2.item * l_wscale
								else
									a_scale2.item := l_ascale * l_bsize
								end
							end
							Result := 0
				when 15 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	gsl_schur_solve_equation (a_ca: REAL_64; a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_z: REAL_64; a_d1: REAL_64; a_d2: REAL_64; a_b___0: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_s: CE_POINTER [REAL_64]; a_xnorm: CE_POINTER [REAL_64]; a_smin: REAL_64): INTEGER_32
		local
			l_N: NATURAL_32
			l_bnorm: REAL_64
			l_scale: REAL_64
			l_c___1: REAL_64
			l_cnorm: REAL_64
			l_cr: CE_ARRAY [CE_ARRAY [REAL_64]]
			l_crv: CE_POINTER [REAL_64]
			l_cmax: REAL_64
			l_icmax: NATURAL_32
			l_j: NATURAL_32
			l_bval1: REAL_64
			l_bval2: REAL_64
			l_ur11: REAL_64
			l_ur12: REAL_64
			l_ur22: REAL_64
			l_ur11r: REAL_64
			l_cr21: REAL_64
			l_cr22: REAL_64
			l_lr21: REAL_64
			l_b1___0: REAL_64
			l_b2: REAL_64
			l_bbnd: REAL_64
			l_x1___0: REAL_64
			l_x2___1: REAL_64
			l_temp: REAL_64
			l_ipivot: CE_ARRAY [CE_ARRAY [NATURAL_32]]
			l_rswap: CE_ARRAY [INTEGER_32]
			l_zswap: CE_ARRAY [INTEGER_32]
			l_tmp___12: REAL_64
			l_tmp___19: REAL_64
			l_tmp___27: REAL_64
			js: JUMP_STATE
		do
			create l_cr.make (<<2, 2>>)
			create l_crv.make
			create l_ipivot.make (<<4, 4>>)
			create l_rswap.make (<<4>>)
			create l_zswap.make (<<4>>)

			l_N := a_A___0.item.size1
			l_scale := 1.0
			if l_N = {NATURAL_32} 1 then
				l_c___1 := a_ca * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (0).to_natural_32)) - a_z * a_d1
				l_cnorm := fabs (l_c___1)
				if l_cnorm < a_smin then
					l_c___1 := a_smin
					l_cnorm := a_smin
				end
				l_bnorm := fabs ((gsl_gsl_vector_double_inst.gsl_vector_get (a_b___0, (0).to_natural_32)))
				if l_cnorm < 1.0 then
					if l_bnorm > 1.0 then
						if l_bnorm > ((1.0 - 2.2204460492503131e-16) / (2.0 * 2.2250738585072014e-308)) * l_cnorm then
							l_scale := 1.0 / l_bnorm
						end
					end
				end
				gsl_gsl_vector_double_inst.gsl_vector_set (a_x, (0).to_natural_32, ((gsl_gsl_vector_double_inst.gsl_vector_get (a_b___0, (0).to_natural_32)) * l_scale) / l_c___1)
				a_xnorm.item := fabs ((gsl_gsl_vector_double_inst.gsl_vector_get (a_x, (0).to_natural_32)))
			else
				(l_ipivot[0])[0] := (0).to_natural_32;
				(l_ipivot[0])[1] := (1).to_natural_32;
				(l_ipivot[0])[2] := (2).to_natural_32;
				(l_ipivot[0])[3] := (3).to_natural_32;
				(l_ipivot[1])[0] := (1).to_natural_32;
				(l_ipivot[1])[1] := (0).to_natural_32;
				(l_ipivot[1])[2] := (3).to_natural_32;
				(l_ipivot[1])[3] := (2).to_natural_32;
				(l_ipivot[2])[0] := (2).to_natural_32;
				(l_ipivot[2])[1] := (3).to_natural_32;
				(l_ipivot[2])[2] := (0).to_natural_32;
				(l_ipivot[2])[3] := (1).to_natural_32;
				(l_ipivot[3])[0] := (3).to_natural_32;
				(l_ipivot[3])[1] := (2).to_natural_32;
				(l_ipivot[3])[2] := (1).to_natural_32;
				(l_ipivot[3])[3] := (0).to_natural_32
				l_rswap[0] := 0
				l_rswap[1] := 1
				l_rswap[2] := 0
				l_rswap[3] := 1
				l_zswap[0] := 0
				l_zswap[1] := 0
				l_zswap[2] := 1
				l_zswap[3] := 1
				l_crv.ce_gets (create {CE_POINTER [REAL_64]}.make_cast (l_cr));
				(l_cr[0])[0] := a_ca * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (0).to_natural_32)) - a_z * a_d1;
				(l_cr[1])[1] := a_ca * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (1).to_natural_32)) - a_z * a_d2;
				(l_cr[0])[1] := a_ca * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (0).to_natural_32));
				(l_cr[1])[0] := a_ca * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (1).to_natural_32))
				l_cmax := 0.0
				l_icmax := (0).to_natural_32
				l_j := (0).to_natural_32
				from
				until
					not (l_j < {NATURAL_32} 4)
				loop
					if (fabs (l_crv[l_j.to_integer_32])) > l_cmax then
						l_cmax := fabs (l_crv[l_j.to_integer_32])
						l_icmax := l_j
					end
					l_j := l_j + 1
				end
				l_bval1 := gsl_gsl_vector_double_inst.gsl_vector_get (a_b___0, (0).to_natural_32)
				l_bval2 := gsl_gsl_vector_double_inst.gsl_vector_get (a_b___0, (1).to_natural_32)
				if l_cmax < a_smin then
					l_tmp___12 := fabs (l_bval1)
					if l_tmp___12 > (fabs (l_bval2)) then
						l_bnorm := (fabs (l_bval1))
					else
						l_bnorm := (fabs (l_bval2))
					end
					if a_smin < 1.0 then
						if l_bnorm > 1.0 then
							if l_bnorm > ((1.0 - 2.2204460492503131e-16) / (2.0 * 2.2250738585072014e-308)) * a_smin then
								l_scale := 1.0 / l_bnorm
							end
						end
					end
					l_temp := l_scale / a_smin
					gsl_gsl_vector_double_inst.gsl_vector_set (a_x, (0).to_natural_32, l_temp * l_bval1)
					gsl_gsl_vector_double_inst.gsl_vector_set (a_x, (1).to_natural_32, l_temp * l_bval2)
					a_xnorm.item := l_temp * l_bnorm
					a_s.item := l_scale
					Result := 0
					js.return
				end
				if not js.return_called then
					l_ur11 := l_crv[l_icmax.to_integer_32]
					l_cr21 := l_crv[((l_ipivot[1])[l_icmax.to_integer_32]).to_integer_32]
					l_ur12 := l_crv[((l_ipivot[2])[l_icmax.to_integer_32]).to_integer_32]
					l_cr22 := l_crv[((l_ipivot[3])[l_icmax.to_integer_32]).to_integer_32]
					l_ur11r := 1.0 / l_ur11
					l_lr21 := l_ur11r * l_cr21
					l_ur22 := l_cr22 - l_ur12 * l_lr21
					if (fabs (l_ur22)) < a_smin then
						l_ur22 := a_smin
					end
					if (l_rswap[l_icmax.to_integer_32]).to_boolean then
						l_b1___0 := l_bval2
						l_b2 := l_bval1
					else
						l_b1___0 := l_bval1
						l_b2 := l_bval2
					end
					l_b2 := l_b2 - (l_lr21 * l_b1___0)
					l_tmp___19 := fabs (l_b1___0 * (l_ur22 * l_ur11r))
					if l_tmp___19 > (fabs (l_b2)) then
						l_bbnd := (fabs (l_b1___0 * (l_ur22 * l_ur11r)))
					else
						l_bbnd := (fabs (l_b2))
					end
					if l_bbnd > 1.0 then
						if (fabs (l_ur22)) < 1.0 then
							if l_bbnd >= ((1.0 - 2.2204460492503131e-16) / (2.0 * 2.2250738585072014e-308)) * (fabs (l_ur22)) then
								l_scale := 1.0 / l_bbnd
							end
						end
					end
					l_x2___1 := (l_b2 * l_scale) / l_ur22
					l_x1___0 := (l_scale * l_b1___0) * l_ur11r - l_x2___1 * (l_ur11r * l_ur12)
					if (l_zswap[l_icmax.to_integer_32]).to_boolean then
						gsl_gsl_vector_double_inst.gsl_vector_set (a_x, (0).to_natural_32, l_x2___1)
						gsl_gsl_vector_double_inst.gsl_vector_set (a_x, (1).to_natural_32, l_x1___0)
					else
						gsl_gsl_vector_double_inst.gsl_vector_set (a_x, (0).to_natural_32, l_x1___0)
						gsl_gsl_vector_double_inst.gsl_vector_set (a_x, (1).to_natural_32, l_x2___1)
					end
					l_tmp___27 := fabs (l_x1___0)
					if l_tmp___27 > (fabs (l_x2___1)) then
						a_xnorm.item := (fabs (l_x1___0))
					else
						a_xnorm.item := (fabs (l_x2___1))
					end
					if a_xnorm.item > 1.0 then
						if l_cmax > 1.0 then
							if a_xnorm.item > ((1.0 - 2.2204460492503131e-16) / (2.0 * 2.2250738585072014e-308)) / l_cmax then
								l_temp := l_cmax / ((1.0 - 2.2204460492503131e-16) / (2.0 * 2.2250738585072014e-308))
								blas_inst.gsl_blas_dscal (l_temp, a_x)
								a_xnorm.item := a_xnorm.item * l_temp
								l_scale := l_scale * l_temp
							end
						end
					end
				end
			end
			if not js.return_called then
				a_s.item := l_scale
				Result := 0
			end
		end

	gsl_schur_solve_equation_z (a_ca: REAL_64; a_A___0: CE_POINTER [PD_GSL_MATRIX]; a_z: CE_POINTER [PD_GSL_COMPLEX]; a_d1: REAL_64; a_d2: REAL_64; a_b___0: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_x: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_s: CE_POINTER [REAL_64]; a_xnorm: CE_POINTER [REAL_64]; a_smin: REAL_64): INTEGER_32
		local
			l_N: NATURAL_32
			l_scale: REAL_64
			l_bnorm: REAL_64
			l_cr: REAL_64
			l_ci: REAL_64
			l_cnorm: REAL_64
			l_bval: PD_GSL_COMPLEX
			l_c___1: PD_GSL_COMPLEX
			l_xval: PD_GSL_COMPLEX
			l_tmp: PD_GSL_COMPLEX
			l_tmp___1: REAL_64
			l_tmp___3: REAL_64
			l_tmp___5: REAL_64
			l_cr___0: CE_ARRAY [CE_ARRAY [REAL_64]]
			l_ci___0: CE_ARRAY [CE_ARRAY [REAL_64]]
			l_civ: CE_POINTER [REAL_64]
			l_crv: CE_POINTER [REAL_64]
			l_cmax: REAL_64
			l_bval1: PD_GSL_COMPLEX
			l_bval2: PD_GSL_COMPLEX
			l_xval1: PD_GSL_COMPLEX
			l_xval2: PD_GSL_COMPLEX
			l_xr1: REAL_64
			l_xi1: REAL_64
			l_icmax: NATURAL_32
			l_j: NATURAL_32
			l_temp: REAL_64
			l_ur11: REAL_64
			l_ur12: REAL_64
			l_ur22: REAL_64
			l_ui11: REAL_64
			l_ui12: REAL_64
			l_ui22: REAL_64
			l_ur11r: REAL_64
			l_ui11r: REAL_64
			l_ur12s: REAL_64
			l_ui12s: REAL_64
			l_u22abs: REAL_64
			l_lr21: REAL_64
			l_li21: REAL_64
			l_cr21: REAL_64
			l_cr22: REAL_64
			l_ci21: REAL_64
			l_ci22: REAL_64
			l_br1: REAL_64
			l_bi1: REAL_64
			l_br2: REAL_64
			l_bi2: REAL_64
			l_bbnd: REAL_64
			l_b1___0: PD_GSL_COMPLEX
			l_b2: PD_GSL_COMPLEX
			l_ipivot: CE_ARRAY [CE_ARRAY [NATURAL_32]]
			l_rswap: CE_ARRAY [INTEGER_32]
			l_zswap: CE_ARRAY [INTEGER_32]
			l_tmp___11: REAL_64
			l_tmp___13: REAL_64
			l_tmp___19: REAL_64
			l_tmp___21: REAL_64
			l_tmp___23: REAL_64
			l_tmp___24: REAL_64
			l_tmp___25: REAL_64
			l_tmp___27: REAL_64
			l_tmp___29: REAL_64
			l_tmp___37: REAL_64
			l_tmp___38: REAL_64
			l_tmp___39: REAL_64
			l_tmp___41: REAL_64
			l_tmp___43: REAL_64
			l_tmp___44: REAL_64
			l_tmp___45: REAL_64
			l_tmp___46: REAL_64
			l_tmp___47: REAL_64
			l_tmp___53: REAL_64
			l_tmp___55: REAL_64
			l_tmp___57: REAL_64
			l_tmp___58: REAL_64
			l_tmp___59: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_bval.make
			create l_c___1.make
			create l_xval.make
			create l_tmp.make
			create l_cr___0.make (<<2, 2>>)
			create l_ci___0.make (<<2, 2>>)
			create l_civ.make
			create l_crv.make
			create l_bval1.make
			create l_bval2.make
			create l_xval1.make
			create l_xval2.make
			create l_b1___0.make
			create l_b2.make
			create l_ipivot.make (<<4, 4>>)
			create l_rswap.make (<<4>>)
			create l_zswap.make (<<4>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_N := a_A___0.item.size1
					l_scale := 1.0
					if l_N /= {NATURAL_32} 1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_cr := a_ca * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (0).to_natural_32)) - a_z.item.dat[0] * a_d1
						l_ci := -a_z.item.dat[1] * a_d1
						l_tmp___1 := fabs (l_cr)
						l_cnorm := l_tmp___1 + (fabs (l_ci))
						if l_cnorm < a_smin then
							l_cr := a_smin
							l_ci := 0.0
							l_cnorm := a_smin
						end
						l_bval.ce_gets (gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_b___0, (0).to_natural_32))
						l_tmp___3 := fabs (l_bval.dat[0])
						l_bnorm := l_tmp___3 + (fabs (l_bval.dat[1]))
						if l_cnorm < 1.0 then
							if l_bnorm > 1.0 then
								if l_bnorm > ((1.0 - 2.2204460492503131e-16) / (2.0 * 2.2250738585072014e-308)) * l_cnorm then
									l_scale := 1.0 / l_bnorm
								end
							end
						end
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp.dat[0] := l_scale * l_bval.dat[0]
							l_tmp.dat[1] := l_scale * l_bval.dat[1]
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							l_c___1.dat[0] := l_cr
							l_c___1.dat[1] := l_ci
							js.break
						end
						js.reset
						l_xval.ce_gets (math_inst.gsl_complex_div (l_tmp, l_c___1))
						gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_x, (0).to_natural_32, l_xval)
						l_tmp___5 := fabs (l_xval.dat[0])
						a_xnorm.item := l_tmp___5 + (fabs (l_xval.dat[1]))
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 3 then -- else:;
						(l_ipivot[0])[0] := (0).to_natural_32;
						(l_ipivot[0])[1] := (1).to_natural_32;
						(l_ipivot[0])[2] := (2).to_natural_32;
						(l_ipivot[0])[3] := (3).to_natural_32;
						(l_ipivot[1])[0] := (1).to_natural_32;
						(l_ipivot[1])[1] := (0).to_natural_32;
						(l_ipivot[1])[2] := (3).to_natural_32;
						(l_ipivot[1])[3] := (2).to_natural_32;
						(l_ipivot[2])[0] := (2).to_natural_32;
						(l_ipivot[2])[1] := (3).to_natural_32;
						(l_ipivot[2])[2] := (0).to_natural_32;
						(l_ipivot[2])[3] := (1).to_natural_32;
						(l_ipivot[3])[0] := (3).to_natural_32;
						(l_ipivot[3])[1] := (2).to_natural_32;
						(l_ipivot[3])[2] := (1).to_natural_32;
						(l_ipivot[3])[3] := (0).to_natural_32
						l_rswap[0] := 0
						l_rswap[1] := 1
						l_rswap[2] := 0
						l_rswap[3] := 1
						l_zswap[0] := 0
						l_zswap[1] := 0
						l_zswap[2] := 1
						l_zswap[3] := 1
						l_civ.ce_gets (create {CE_POINTER [REAL_64]}.make_cast (l_ci___0))
						l_crv.ce_gets (create {CE_POINTER [REAL_64]}.make_cast (l_cr___0));
						(l_cr___0[0])[0] := a_ca * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (0).to_natural_32)) - a_z.item.dat[0] * a_d1;
						(l_cr___0[1])[1] := a_ca * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (1).to_natural_32)) - a_z.item.dat[0] * a_d2;
						(l_cr___0[0])[1] := a_ca * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (1).to_natural_32, (0).to_natural_32));
						(l_cr___0[1])[0] := a_ca * (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_A___0, (0).to_natural_32, (1).to_natural_32));
						(l_ci___0[0])[0] := -a_z.item.dat[1] * a_d1;
						(l_ci___0[0])[1] := 0.0;
						(l_ci___0[1])[0] := 0.0;
						(l_ci___0[1])[1] := -a_z.item.dat[1] * a_d2
						l_cmax := 0.0
						l_icmax := (0).to_natural_32
						l_j := (0).to_natural_32
						from
						until
							not (l_j < {NATURAL_32} 4)
						loop
							l_tmp___13 := fabs (l_crv[l_j.to_integer_32])
							if l_tmp___13 + (fabs (l_civ[l_j.to_integer_32])) > l_cmax then
								l_tmp___11 := fabs (l_crv[l_j.to_integer_32])
								l_cmax := l_tmp___11 + (fabs (l_civ[l_j.to_integer_32]))
								l_icmax := l_j
							end
							l_j := l_j + 1
						end
						l_bval1.ce_gets (gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_b___0, (0).to_natural_32))
						l_bval2.ce_gets (gsl_gsl_vector_complex_double_inst.gsl_vector_complex_get (a_b___0, (1).to_natural_32))
						if l_cmax < a_smin then
							l_tmp___23 := fabs (l_bval1.dat[0])
							l_tmp___24 := fabs (l_bval1.dat[1])
							l_tmp___25 := fabs (l_bval2.dat[0])
							if l_tmp___23 + l_tmp___24 > l_tmp___25 + (fabs (l_bval2.dat[1])) then
								l_tmp___19 := fabs (l_bval1.dat[0])
								l_bnorm := l_tmp___19 + (fabs (l_bval1.dat[1]))
							else
								l_tmp___21 := fabs (l_bval2.dat[0])
								l_bnorm := l_tmp___21 + (fabs (l_bval2.dat[1]))
							end
							if a_smin < 1.0 then
								if l_bnorm > 1.0 then
									if l_bnorm > ((1.0 - 2.2204460492503131e-16) / (2.0 * 2.2250738585072014e-308)) * a_smin then
										l_scale := 1.0 / l_bnorm
									end
								end
							end
							l_temp := l_scale / a_smin
							l_xval1.ce_gets (math_inst.gsl_complex_mul_real (l_bval1, l_temp))
							l_xval2.ce_gets (math_inst.gsl_complex_mul_real (l_bval2, l_temp))
							gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_x, (0).to_natural_32, l_xval1)
							gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_x, (1).to_natural_32, l_xval2)
							a_xnorm.item := l_temp * l_bnorm
							a_s.item := l_scale
							Result := 0
							js.return
						end
						if js.return_called then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						l_ur11 := l_crv[l_icmax.to_integer_32]
						l_ui11 := l_civ[l_icmax.to_integer_32]
						l_cr21 := l_crv[((l_ipivot[1])[l_icmax.to_integer_32]).to_integer_32]
						l_ci21 := l_civ[((l_ipivot[1])[l_icmax.to_integer_32]).to_integer_32]
						l_ur12 := l_crv[((l_ipivot[2])[l_icmax.to_integer_32]).to_integer_32]
						l_ui12 := l_civ[((l_ipivot[2])[l_icmax.to_integer_32]).to_integer_32]
						l_cr22 := l_crv[((l_ipivot[3])[l_icmax.to_integer_32]).to_integer_32]
						l_ci22 := l_civ[((l_ipivot[3])[l_icmax.to_integer_32]).to_integer_32]
						if l_icmax /= {NATURAL_32} 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if l_icmax /= {NATURAL_32} 3 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L:
						l_tmp___27 := fabs (l_ur11)
						if l_tmp___27 > (fabs (l_ui11)) then
							l_temp := l_ui11 / l_ur11
							l_ur11r := 1.0 / (l_ur11 * (1.0 + l_temp * l_temp))
							l_ui11r := -l_temp * l_ur11r
						else
							l_temp := l_ur11 / l_ui11
							l_ui11r := -1.0 / (l_ui11 * (1.0 + l_temp * l_temp))
							l_ur11r := -l_temp * l_ui11r
						end
						l_lr21 := l_cr21 * l_ur11r
						l_li21 := l_cr21 * l_ui11r
						l_ur12s := l_ur12 * l_ur11r
						l_ui12s := l_ur12 * l_ui11r
						l_ur22 := l_cr22 - l_ur12 * l_lr21
						l_ui22 := l_ci22 - l_ur12 * l_li21
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_ur11r := 1.0 / l_ur11
						l_ui11r := 0.0
						l_lr21 := l_cr21 * l_ur11r
						l_li21 := l_ci21 * l_ur11r
						l_ur12s := l_ur12 * l_ur11r
						l_ui12s := l_ui12 * l_ur11r
						l_ur22 := (l_cr22 - l_ur12 * l_lr21) + l_ui12 * l_li21
						l_ui22 := -l_ur12 * l_li21 - l_ui12 * l_lr21
				when 11 then -- if done
						l_tmp___29 := fabs (l_ur22)
						l_u22abs := l_tmp___29 + (fabs (l_ui22))
						if l_u22abs < a_smin then
							l_ur22 := a_smin
							l_ui22 := 0.0
						end
						if (l_rswap[l_icmax.to_integer_32]).to_boolean then
							l_br2 := l_bval1.dat[0]
							l_bi2 := l_bval1.dat[1]
							l_br1 := l_bval2.dat[0]
							l_bi1 := l_bval2.dat[1]
						else
							l_br1 := l_bval1.dat[0]
							l_bi1 := l_bval1.dat[1]
							l_br2 := l_bval2.dat[0]
							l_bi2 := l_bval2.dat[1]
						end
						l_br2 := l_br2 + (l_li21 * l_bi1 - l_lr21 * l_br1)
						l_bi2 := l_bi2 - (l_li21 * l_br1 + l_lr21 * l_bi1)
						l_tmp___43 := fabs (l_br1)
						l_tmp___44 := fabs (l_bi1)
						l_tmp___45 := fabs (l_ur11r)
						l_tmp___46 := fabs (l_ui11r)
						l_tmp___47 := fabs (l_br2)
						if (l_tmp___43 + l_tmp___44) * (l_u22abs * (l_tmp___45 + l_tmp___46)) > l_tmp___47 + (fabs (l_bi2)) then
							l_tmp___37 := fabs (l_br1)
							l_tmp___38 := fabs (l_bi1)
							l_tmp___39 := fabs (l_ur11r)
							l_bbnd := (l_tmp___37 + l_tmp___38) * (l_u22abs * (l_tmp___39 + (fabs (l_ui11r))))
						else
							l_tmp___41 := fabs (l_br2)
							l_bbnd := l_tmp___41 + (fabs (l_bi2))
						end
						if l_bbnd > 1.0 then
							if l_u22abs < 1.0 then
								if l_bbnd >= ((1.0 - 2.2204460492503131e-16) / (2.0 * 2.2250738585072014e-308)) * l_u22abs then
									l_scale := 1.0 / l_bbnd
									l_br1 := l_br1 * l_scale
									l_bi1 := l_bi1 * l_scale
									l_br2 := l_br2 * l_scale
									l_bi2 := l_bi2 * l_scale
								end
							end
						end
						from
						until
							js.loop_left
						loop
							js.reset
							l_b1___0.dat[0] := l_br2
							l_b1___0.dat[1] := l_bi2
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							l_b2.dat[0] := l_ur22
							l_b2.dat[1] := l_ui22
							js.break
						end
						js.reset
						l_xval2.ce_gets (math_inst.gsl_complex_div (l_b1___0, l_b2))
						l_xr1 := ((l_ur11r * l_br1 - l_ui11r * l_bi1) - l_ur12s * l_xval2.dat[0]) + l_ui12s * l_xval2.dat[1]
						l_xi1 := ((l_ui11r * l_br1 + l_ur11r * l_bi1) - l_ui12s * l_xval2.dat[0]) - l_ur12s * l_xval2.dat[1]
						from
						until
							js.loop_left
						loop
							js.reset
							l_xval1.dat[0] := l_xr1
							l_xval1.dat[1] := l_xi1
							js.break
						end
						js.reset
						if (l_zswap[l_icmax.to_integer_32]).to_boolean then
							gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_x, (0).to_natural_32, l_xval2)
							gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_x, (1).to_natural_32, l_xval1)
						else
							gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_x, (0).to_natural_32, l_xval1)
							gsl_gsl_vector_complex_double_inst.gsl_vector_complex_set (a_x, (1).to_natural_32, l_xval2)
						end
						l_tmp___57 := fabs (l_xval1.dat[0])
						l_tmp___58 := fabs (l_xval1.dat[1])
						l_tmp___59 := fabs (l_xval2.dat[0])
						if l_tmp___57 + l_tmp___58 > l_tmp___59 + (fabs (l_xval2.dat[1])) then
							l_tmp___53 := fabs (l_xval1.dat[0])
							a_xnorm.item := l_tmp___53 + (fabs (l_xval1.dat[1]))
						else
							l_tmp___55 := fabs (l_xval2.dat[0])
							a_xnorm.item := l_tmp___55 + (fabs (l_xval2.dat[1]))
						end
						if a_xnorm.item > 1.0 then
							if l_cmax > 1.0 then
								if a_xnorm.item > ((1.0 - 2.2204460492503131e-16) / (2.0 * 2.2250738585072014e-308)) / l_cmax then
									l_temp := l_cmax / ((1.0 - 2.2204460492503131e-16) / (2.0 * 2.2250738585072014e-308))
									blas_inst.gsl_blas_zdscal (l_temp, a_x)
									a_xnorm.item := a_xnorm.item * l_temp
									l_scale := l_scale * l_temp
								end
							end
						end
				when 12 then -- if done | if done
						if not js.return_called then
							a_s.item := l_scale
							Result := 0
						end
				when 13 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
