class
	P_SECANT

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create secant_type.make
			create gsl_root_fdfsolver_secant.make
		end

feature {ANY} -- attributes

	secant_type: PD_GSL_ROOT_FDFSOLVER_TYPE

	gsl_root_fdfsolver_secant: CE_POINTER [PD_GSL_ROOT_FDFSOLVER_TYPE]

feature {ANY} -- routines

	secant_init (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_FUNCTION_FDF_STRUCT]; a_root: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_state: CE_POINTER [PD_SECANT_STATE_T]
			l_x: REAL_64
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_SECANT_STATE_T]}.make_cast (a_vstate))
			l_x := a_root.item;
			(a_fdf.item.fdf).call ([l_x, a_fdf.item.params, create {CE_POINTER [REAL_64]}.make_shared (l_state.c_pointer + {PD_SECANT_STATE_T}.f_offset), create {CE_POINTER [REAL_64]}.make_shared (l_state.c_pointer + {PD_SECANT_STATE_T}.df_offset)])
			Result := 0
		end

	secant_init_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent secant_init)
		end

	secant_iterate (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_FUNCTION_FDF_STRUCT]; a_root: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_state: CE_POINTER [PD_SECANT_STATE_T]
			l_x: REAL_64
			l_f: REAL_64
			l_df: REAL_64
			l_x_new: REAL_64
			l_f_new: REAL_64
			l_df_new: REAL_64
			js: JUMP_STATE
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_SECANT_STATE_T]}.make_cast (a_vstate))
			l_x := a_root.item
			l_f := l_state.item.f
			l_df := l_state.item.df
			if l_state.item.df = 0.0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("derivative is zero"), ce_string ("secant.c"), 84, 12)
					Result := 12
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_x_new := l_x - l_f / l_df
				l_f_new := (a_fdf.item.f).real_64_item ([l_x_new, a_fdf.item.params])
				l_df_new := (l_f_new - l_f) / (l_x_new - l_x)
				a_root.item := l_x_new
				l_state.item.f := l_f_new
				l_state.item.df := l_df_new
				if not (infnan_inst.gsl_finite (l_f_new)).to_boolean then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("function value is not finite"), ce_string ("secant.c"), 99, 9)
						Result := 9
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				if not (infnan_inst.gsl_finite (l_df_new)).to_boolean then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("derivative value is not finite"), ce_string ("secant.c"), 104, 9)
						Result := 9
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	secant_iterate_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent secant_iterate)
		end

end
