class
	P_SGBMV

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_sgbmv (a_order: INTEGER_32; a_TransA: INTEGER_32; a_M: INTEGER_32; a_N: INTEGER_32; a_KL: INTEGER_32; a_KU: INTEGER_32; a_alpha: REAL_32; a_A___0: CE_POINTER [REAL_32]; a_lda: INTEGER_32; a_X: CE_POINTER [REAL_32]; a_incX: INTEGER_32; a_beta: REAL_32; a_Y: CE_POINTER [REAL_32]; a_incY: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_lenX: INTEGER_32
			l_lenY: INTEGER_32
			l_L: INTEGER_32
			l_U: INTEGER_32
			l_Trans: INTEGER_32
			l_tmp: NATURAL_32
			l_iy: INTEGER_32
			l_tmp___0: INTEGER_32
			l_iy___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_iy___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_temp: REAL_32
			l_j_min: INTEGER_32
			l_tmp___3: INTEGER_32
			l_j_max: INTEGER_32
			l_tmp___4: INTEGER_32
			l_jx: INTEGER_32
			l_tmp___5: INTEGER_32
			l_jx___0: INTEGER_32
			l_tmp___6: INTEGER_32
			l_temp___0: REAL_32
			l_i_min: INTEGER_32
			l_tmp___7: INTEGER_32
			l_i_max: INTEGER_32
			l_tmp___8: INTEGER_32
			l_iy___2: INTEGER_32
			l_tmp___9: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_TransA.to_natural_32 /= {NATURAL_32} 113 then
						l_tmp := a_TransA.to_natural_32
					else
						l_tmp := {NATURAL_32} 112
					end
					l_Trans := l_tmp.to_integer_32
					if a_M = 0 then
						js.return
					elseif a_N = 0 then
						js.return
					end
					if not js.return_called and then (a_alpha.to_double = 0.0) then
						if a_beta.to_double = 1.0 then
							js.return
						end
					end
					if not js.return_called then
						if l_Trans = 111 then
							l_lenX := a_N
							l_lenY := a_M
							l_L := a_KL
							l_U := a_KU
						else
							l_lenX := a_M
							l_lenY := a_N
							l_L := a_KU
							l_U := a_KL
						end
						if a_beta.to_double = 0.0 then
							if a_incY > 0 then
								l_tmp___0 := 0
							else
								l_tmp___0 := (l_lenY - 1) * -a_incY
							end
							l_iy := l_tmp___0
							l_i := 0
							from
							until
								not (l_i < l_lenY)
							loop
								a_Y[l_iy] := (0).to_real
								l_iy := l_iy + a_incY
								l_i := l_i + 1
							end
						elseif a_beta.to_double /= 1.0 then
							if a_incY > 0 then
								l_tmp___1 := 0
							else
								l_tmp___1 := (l_lenY - 1) * -a_incY
							end
							l_iy___0 := l_tmp___1
							l_i := 0
							from
							until
								not (l_i < l_lenY)
							loop
								a_Y[l_iy___0] := a_Y[l_iy___0] * a_beta
								l_iy___0 := l_iy___0 + a_incY
								l_i := l_i + 1
							end
						end
						if a_alpha.to_double = 0.0 then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 20 -- skip if block
					end
				when 1 then -- if:
						if a_order.to_natural_32 /= {NATURAL_32} 101 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_Trans = 111 then
							l_pos := -1 + 6 -- goto _L___1
						else
							l_pos := -1 + 4 -- goto _L___3
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 4 then -- else: | _L___3:
						if a_order.to_natural_32 /= {NATURAL_32} 102 then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if l_Trans /= 112 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L___1:
						if a_incY > 0 then
							l_tmp___2 := 0
						else
							l_tmp___2 := (l_lenY - 1) * -a_incY
						end
						l_iy___1 := l_tmp___2
						l_i := 0
						from
						until
							not (not js.loop_left and then (l_i < l_lenY))
						loop
							l_temp := (0.0).truncated_to_real
							if l_i > l_L then
								l_tmp___3 := l_i - l_L
							else
								l_tmp___3 := 0
							end
							l_j_min := l_tmp___3
							if l_lenX < (l_i + l_U) + 1 then
								l_tmp___4 := l_lenX
							else
								l_tmp___4 := (l_i + l_U) + 1
							end
							l_j_max := l_tmp___4
							if a_incX > 0 then
								l_tmp___5 := 0
							else
								l_tmp___5 := (l_lenX - 1) * -a_incX
							end
							l_jx := l_tmp___5 + l_j_min * a_incX
							l_j := l_j_min
							from
							until
								not (l_j < l_j_max)
							loop
								l_temp := l_temp + (a_X[l_jx] * a_A___0[(((l_L - l_i) + l_j) + l_i * a_lda)])
								l_jx := l_jx + a_incX
								l_j := l_j + 1
							end
							a_Y[l_iy___1] := a_Y[l_iy___1] + (a_alpha * l_temp)
							l_iy___1 := l_iy___1 + a_incY
							l_i := l_i + 1
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_pos := -1 + 10 -- goto _L___2
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 10 then -- else: | _L___2:
						if a_order.to_natural_32 /= {NATURAL_32} 101 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if l_Trans = 112 then
							l_pos := -1 + 15 -- goto _L
						else
							l_pos := -1 + 13 -- goto _L___0
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else: | _L___0:
						if a_order.to_natural_32 /= {NATURAL_32} 102 then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						if l_Trans /= 111 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if: | _L:
						if a_incX > 0 then
							l_tmp___6 := 0
						else
							l_tmp___6 := (l_lenX - 1) * -a_incX
						end
						l_jx___0 := l_tmp___6
						l_j := 0
						from
						until
							not (not js.loop_left and then (l_j < l_lenX))
						loop
							l_temp___0 := a_alpha * a_X[l_jx___0]
							if l_temp___0.to_double /= 0.0 then
								if l_j > l_U then
									l_tmp___7 := l_j - l_U
								else
									l_tmp___7 := 0
								end
								l_i_min := l_tmp___7
								if l_lenY < (l_j + l_L) + 1 then
									l_tmp___8 := l_lenY
								else
									l_tmp___8 := (l_j + l_L) + 1
								end
								l_i_max := l_tmp___8
								if a_incY > 0 then
									l_tmp___9 := 0
								else
									l_tmp___9 := (l_lenY - 1) * -a_incY
								end
								l_iy___2 := l_tmp___9 + l_i_min * a_incY
								l_i := l_i_min
								from
								until
									not (l_i < l_i_max)
								loop
									a_Y[l_iy___2] := a_Y[l_iy___2] + (l_temp___0 * a_A___0[(a_lda * l_j + ((l_U + l_i) - l_j))])
									l_iy___2 := l_iy___2 + a_incY
									l_i := l_i + 1
								end
							end
							l_jx___0 := l_jx___0 + a_incX
							l_j := l_j + 1
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						xerbla_inst.cblas_xerbla ([0, ce_string ("source_gbmv_r.h"), ce_string ("unrecognized operation")])
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:
						xerbla_inst.cblas_xerbla ([0, ce_string ("source_gbmv_r.h"), ce_string ("unrecognized operation")])
				when 20 then -- if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
