class
	P_SGEMM

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_sgemm (a_Order: INTEGER_32; a_TransA: INTEGER_32; a_TransB: INTEGER_32; a_M: INTEGER_32; a_N: INTEGER_32; a_K: INTEGER_32; a_alpha: REAL_32; a_A___0: CE_POINTER [REAL_32]; a_lda: INTEGER_32; a_B: CE_POINTER [REAL_32]; a_ldb: INTEGER_32; a_beta: REAL_32; a_C: CE_POINTER [REAL_32]; a_ldc: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_n1: INTEGER_32
			l_n2: INTEGER_32
			l_ldf: INTEGER_32
			l_ldg: INTEGER_32
			l_TransF: INTEGER_32
			l_TransG: INTEGER_32
			l_F___0: CE_POINTER [REAL_32]
			l_G: CE_POINTER [REAL_32]
			l_temp: REAL_32
			l_temp___0: REAL_32
			l_temp___1: REAL_32
			l_temp___2: REAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_F___0.make
			create l_G.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_alpha.to_double = 0.0 then
						if a_beta.to_double = 1.0 then
							js.return
						end
					end
					if not js.return_called then
						if a_Order.to_natural_32 = {NATURAL_32} 101 then
							l_n1 := a_M
							l_n2 := a_N
							l_F___0.ce_gets (a_A___0)
							l_ldf := a_lda
							if a_TransA.to_natural_32 = {NATURAL_32} 113 then
								l_TransF := 112
							else
								l_TransF := a_TransA
							end
							l_G.ce_gets (a_B)
							l_ldg := a_ldb
							if a_TransB.to_natural_32 = {NATURAL_32} 113 then
								l_TransG := 112
							else
								l_TransG := a_TransB
							end
						else
							l_n1 := a_N
							l_n2 := a_M
							l_F___0.ce_gets (a_B)
							l_ldf := a_ldb
							if a_TransB.to_natural_32 = {NATURAL_32} 113 then
								l_TransF := 112
							else
								l_TransF := a_TransB
							end
							l_G.ce_gets (a_A___0)
							l_ldg := a_lda
							if a_TransA.to_natural_32 = {NATURAL_32} 113 then
								l_TransG := 112
							else
								l_TransG := a_TransA
							end
						end
						if a_beta.to_double = 0.0 then
							l_i := 0
							from
							until
								not (not js.loop_left and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (l_j < l_n2)
								loop
									a_C[(a_ldc * l_i + l_j)] := (0.0).truncated_to_real
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						elseif a_beta.to_double /= 1.0 then
							l_i := 0
							from
							until
								not (not js.loop_left and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (l_j < l_n2)
								loop
									a_C[(a_ldc * l_i + l_j)] := a_C[(a_ldc * l_i + l_j)] * a_beta
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						end
						if a_alpha.to_double = 0.0 then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						if l_TransF /= 111 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_TransG = 111 then
							l_k := 0
							from
							until
								not (not js.loop_left and then (l_k < a_K))
							loop
								l_i := 0
								from
								until
									not (not js.loop_left and then (l_i < l_n1))
								loop
									l_temp := a_alpha * l_F___0[(l_ldf * l_i + l_k)]
									if l_temp.to_double /= 0.0 then
										l_j := 0
										from
										until
											not (l_j < l_n2)
										loop
											a_C[(a_ldc * l_i + l_j)] := a_C[(a_ldc * l_i + l_j)] + (l_temp * l_G[(l_ldg * l_k + l_j)])
											l_j := l_j + 1
										end
									end
									l_i := l_i + 1
								end
								l_k := l_k + 1
							end
						else
							l_pos := -1 + 4 -- goto _L___1
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else: | _L___1:
						if l_TransF /= 111 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_TransG = 112 then
							l_i := 0
							from
							until
								not (not js.loop_left and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (not js.loop_left and then (l_j < l_n2))
								loop
									l_temp___0 := (0.0).truncated_to_real
									l_k := 0
									from
									until
										not (l_k < a_K)
									loop
										l_temp___0 := l_temp___0 + (l_F___0[(l_ldf * l_i + l_k)] * l_G[(l_ldg * l_j + l_k)])
										l_k := l_k + 1
									end
									a_C[(a_ldc * l_i + l_j)] := a_C[(a_ldc * l_i + l_j)] + (a_alpha * l_temp___0)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 7 -- goto _L___0
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else: | _L___0:
						if l_TransF /= 112 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_TransG = 111 then
							l_k := 0
							from
							until
								not (not js.loop_left and then (l_k < a_K))
							loop
								l_i := 0
								from
								until
									not (not js.loop_left and then (l_i < l_n1))
								loop
									l_temp___1 := a_alpha * l_F___0[(l_ldf * l_k + l_i)]
									if l_temp___1.to_double /= 0.0 then
										l_j := 0
										from
										until
											not (l_j < l_n2)
										loop
											a_C[(a_ldc * l_i + l_j)] := a_C[(a_ldc * l_i + l_j)] + (l_temp___1 * l_G[(l_ldg * l_k + l_j)])
											l_j := l_j + 1
										end
									end
									l_i := l_i + 1
								end
								l_k := l_k + 1
							end
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						if l_TransF = 112 then
							if l_TransG = 112 then
								l_i := 0
								from
								until
									not (not js.loop_left and then (l_i < l_n1))
								loop
									l_j := 0
									from
									until
										not (not js.loop_left and then (l_j < l_n2))
									loop
										l_temp___2 := (0.0).truncated_to_real
										l_k := 0
										from
										until
											not (l_k < a_K)
										loop
											l_temp___2 := l_temp___2 + (l_F___0[(l_ldf * l_k + l_i)] * l_G[(l_ldg * l_j + l_k)])
											l_k := l_k + 1
										end
										a_C[(a_ldc * l_i + l_j)] := a_C[(a_ldc * l_i + l_j)] + (a_alpha * l_temp___2)
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								xerbla_inst.cblas_xerbla ([0, ce_string ("source_gemm_r.h"), ce_string ("unrecognized operation")])
							end
						else
							xerbla_inst.cblas_xerbla ([0, ce_string ("source_gemm_r.h"), ce_string ("unrecognized operation")])
						end
				when 11 then -- if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
