class
	P_SHINT

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create shi_data.make (<<7>>)
			create shi_cs.make
		end

feature {ANY} -- attributes

	shi_data: CE_ARRAY [REAL_64]

	shi_cs: PD_CHEB_SERIES_STRUCT

feature {ANY} -- routines

	gsl_sf_Shi_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_xsml: REAL_64
			l_ax: REAL_64
			l_result_c: PD_GSL_SF_RESULT_STRUCT
			l_result_Ei: PD_GSL_SF_RESULT_STRUCT
			l_result_E1: PD_GSL_SF_RESULT_STRUCT
			l_status_Ei: INTEGER_32
			l_status_E1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_result_c.make
			create l_result_Ei.make
			create l_result_E1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_xsml := 1.4901161193847656e-08
					l_ax := (fabs (a_x))
					if not (l_ax < l_xsml) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_result.item.val := a_x
						a_result.item.err := 0.0
						Result := 0
						js.return
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 3 then -- else:
						if not (l_ax <= 0.375) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						cheb_eval_inst.cheb_eval_e ((shi_cs.address), ((128.0 * a_x) * a_x) / 9.0 - 1.0, l_result_c.address).do_nothing
						a_result.item.val := a_x * (1.0 + l_result_c.val)
						a_result.item.err := a_x * l_result_c.err
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						Result := 0
						js.return
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 6 then -- else:
						l_status_Ei := (expint_inst.gsl_sf_expint_Ei_e (a_x, l_result_Ei.address))
						l_status_E1 := (expint_inst.gsl_sf_expint_E1_e (a_x, l_result_E1.address))
						a_result.item.val := 0.5 * (l_result_Ei.val + l_result_E1.val)
						a_result.item.err := 0.5 * (l_result_Ei.err + l_result_E1.err)
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						if l_status_Ei /= 15 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_status_E1 = 15 then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("underflow"), ce_string ("shint.c"), 88, 15)
								Result := 15
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						else
							l_pos := -1 + 9 -- goto _L___0
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 9 then -- else: | _L___0:
						if l_status_Ei /= 16 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 12 then -- else:
						if l_status_E1 /= 16 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("overflow"), ce_string ("shint.c"), 91, 16)
							Result := 16
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						Result := 0
						js.return
				when 16 then -- if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 17 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_Chi_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_result_Ei: PD_GSL_SF_RESULT_STRUCT
			l_result_E1: PD_GSL_SF_RESULT_STRUCT
			l_status_Ei: INTEGER_32
			l_status_E1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_result_Ei.make
			create l_result_E1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_status_Ei := (expint_inst.gsl_sf_expint_Ei_e (a_x, l_result_Ei.address))
					l_status_E1 := (expint_inst.gsl_sf_expint_E1_e (a_x, l_result_E1.address))
					if l_status_Ei /= 1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 3 then -- else:
						if l_status_E1 /= 1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L___1:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("shint.c"), 107, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 6 then -- else:
						if l_status_Ei /= 15 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_status_E1 = 15 then
							from
							until
								js.loop_left
							loop
								js.reset
								a_result.item.val := 0.0
								a_result.item.err := 2.2250738585072014e-308
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.gsl_error (ce_string ("underflow"), ce_string ("shint.c"), 110, 15)
									Result := 15
									js.return
									if not js.return_called then
										js.break
									end
								end
								js.reset
								if not js.return_called then
									js.break
								end
							end
							js.reset
						else
							l_pos := -1 + 9 -- goto _L___0
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 9 then -- else: | _L___0:
						if l_status_Ei /= 16 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 12 then -- else:
						if l_status_E1 /= 16 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							a_result.item.val := (builtin_inff).to_double
							a_result.item.err := (builtin_inff).to_double
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("overflow"), ce_string ("shint.c"), 113, 16)
								Result := 16
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
							if not js.return_called then
								js.break
							end
						end
						js.reset
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						a_result.item.val := 0.5 * (l_result_Ei.val - l_result_E1.val)
						a_result.item.err := 0.5 * (l_result_Ei.err + l_result_E1.err)
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						Result := 0
						js.return
				when 16 then -- if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 17 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_Shi (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_Shi_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_Shi_e(x, &result)"), ce_string ("shint.c"), 129, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_Chi (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_Chi_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_Chi_e(x, &result)"), ce_string ("shint.c"), 134, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
