class
	P_SIMPLEX2

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create nmsimplex_type___0.make
			create gsl_multimin_fminimizer_nmsimplex2.make
			create nmsimplex2rand_type.make
			create gsl_multimin_fminimizer_nmsimplex2rand.make
		end

feature {ANY} -- attributes

	nmsimplex_type___0: PD_GSL_MULTIMIN_FMINIMIZER_TYPE

	gsl_multimin_fminimizer_nmsimplex2: CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER_TYPE]

	nmsimplex2rand_type: PD_GSL_MULTIMIN_FMINIMIZER_TYPE

	gsl_multimin_fminimizer_nmsimplex2rand: CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER_TYPE]

feature {ANY} -- routines

	try_corner_move (a_coeff: REAL_64; a_state: CE_POINTER [PD_NMSIMPLEX_STATE_T_119__]; a_corner: NATURAL_32; a_xc: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_STRUCT]): REAL_64
		local
			l_x1___0: CE_POINTER [PD_GSL_MATRIX]
			l_P___2: NATURAL_32
			l_newval: REAL_64
			l_alpha: REAL_64
			l_beta: REAL_64
			l_row: PD_GSL_VECTOR_CONST_VIEW
		do
			create l_x1___0.make
			create l_row.make

			l_x1___0.ce_gets (a_state.item.x1)
			l_P___2 := l_x1___0.item.size1
			l_alpha := (((1).to_double - a_coeff) * l_P___2.to_real_64) / (l_P___2.to_real_64 - 1.0)
			l_beta := (l_P___2.to_real_64 * a_coeff - 1.0) / (l_P___2.to_real_64 - 1.0)
			l_row.ce_gets ((rowcol_source_inst.gsl_matrix_const_row (l_x1___0, a_corner)))
			copy_source_inst.gsl_vector_memcpy (a_xc, a_state.item.center).do_nothing
			blas_inst.gsl_blas_dscal (l_alpha, a_xc)
			blas_inst.gsl_blas_daxpy (l_beta, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_row.c_pointer + {PD_GSL_VECTOR_CONST_VIEW}.vector_offset)), a_xc).do_nothing
			l_newval := (a_f.item.f).real_64_item ([a_xc, a_f.item.params])
			Result := l_newval
		end

	update_point (a_state: CE_POINTER [PD_NMSIMPLEX_STATE_T_119__]; a_i: NATURAL_32; a_x: CE_POINTER [PD_GSL_VECTOR]; a_val: REAL_64)
		local
			l_x_orig: PD_GSL_VECTOR_CONST_VIEW
			l_P___2: NATURAL_32
			l_d: REAL_64
			l_xmcd: REAL_64
			l_alpha: REAL_64
		do
			create l_x_orig.make

			l_x_orig.ce_gets ((rowcol_source_inst.gsl_matrix_const_row (a_state.item.x1, a_i)))
			l_P___2 := (a_state.item.x1).item.size1
			copy_source_inst.gsl_vector_memcpy (a_state.item.delta, a_x).do_nothing
			blas_inst.gsl_blas_daxpy (-1.0, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_x_orig.c_pointer + {PD_GSL_VECTOR_CONST_VIEW}.vector_offset)), a_state.item.delta).do_nothing
			copy_source_inst.gsl_vector_memcpy (a_state.item.xmc, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_x_orig.c_pointer + {PD_GSL_VECTOR_CONST_VIEW}.vector_offset))).do_nothing
			blas_inst.gsl_blas_daxpy (-1.0, a_state.item.center, a_state.item.xmc).do_nothing
			l_d := (blas_inst.gsl_blas_dnrm2 (a_state.item.delta))
			blas_inst.gsl_blas_ddot (a_state.item.xmc, a_state.item.delta, create {CE_POINTER [REAL_64]}.make_shared ($l_xmcd)).do_nothing
			a_state.item.S2 := a_state.item.S2 + ((2.0 / l_P___2.to_real_64) * l_xmcd + ((l_P___2.to_real_64 - 1.0) / l_P___2.to_real_64) * ((l_d * l_d) / l_P___2.to_real_64))
			l_alpha := 1.0 / l_P___2.to_real_64
			blas_inst.gsl_blas_daxpy (-l_alpha, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_x_orig.c_pointer + {PD_GSL_VECTOR_CONST_VIEW}.vector_offset)), a_state.item.center).do_nothing
			blas_inst.gsl_blas_daxpy (l_alpha, a_x, a_state.item.center).do_nothing
			getset_source_inst.gsl_matrix_set_row (a_state.item.x1, a_i, a_x).do_nothing
			gsl_gsl_vector_double_inst.gsl_vector_set (a_state.item.y1, a_i, a_val)
		end

	contract_by_best (a_state: CE_POINTER [PD_NMSIMPLEX_STATE_T_119__]; a_best: NATURAL_32; a_xc: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_STRUCT]): INTEGER_32
		local
			l_x1___0: CE_POINTER [PD_GSL_MATRIX]
			l_y1___0: CE_POINTER [PD_GSL_VECTOR]
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_newval: REAL_64
			l_status: INTEGER_32
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			create l_x1___0.make
			create l_y1___0.make

			l_x1___0.ce_gets (a_state.item.x1)
			l_y1___0.ce_gets (a_state.item.y1)
			l_status := 0
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_left and then (l_i < l_x1___0.item.size1))
			loop
				if l_i /= a_best then
					l_j := (0).to_natural_32
					from
					until
						not (l_j < l_x1___0.item.size2)
					loop
						l_tmp := gsl_gsl_matrix_double_inst.gsl_matrix_get (l_x1___0, l_i, l_j)
						l_newval := 0.5 * (l_tmp + (gsl_gsl_matrix_double_inst.gsl_matrix_get (l_x1___0, a_best, l_j)))
						gsl_gsl_matrix_double_inst.gsl_matrix_set (l_x1___0, l_i, l_j, l_newval)
						l_j := l_j + 1
					end
					getset_source_inst.gsl_matrix_get_row (a_xc, l_x1___0, l_i).do_nothing
					l_newval := (a_f.item.f).real_64_item ([a_xc, a_f.item.params])
					gsl_gsl_vector_double_inst.gsl_vector_set (l_y1___0, l_i, l_newval)
					if not (infnan_inst.gsl_finite (l_newval)).to_boolean then
						l_status := 9
					end
				end
				l_i := l_i + 1
			end
			compute_center (a_state, a_state.item.center).do_nothing
			compute_size (a_state, a_state.item.center).do_nothing
			Result := l_status
		end

	compute_center (a_state: CE_POINTER [PD_NMSIMPLEX_STATE_T_119__]; a_center: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_x1___0: CE_POINTER [PD_GSL_MATRIX]
			l_P___2: NATURAL_32
			l_i: NATURAL_32
			l_row: PD_GSL_VECTOR_CONST_VIEW
			l_alpha: REAL_64
		do
			create l_x1___0.make
			create l_row.make

			l_x1___0.ce_gets (a_state.item.x1)
			l_P___2 := l_x1___0.item.size1
			init_source_inst.gsl_vector_set_zero (a_center)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_P___2)
			loop
				l_row.ce_gets ((rowcol_source_inst.gsl_matrix_const_row (l_x1___0, l_i)))
				blas_inst.gsl_blas_daxpy (1.0, (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_row.c_pointer + {PD_GSL_VECTOR_CONST_VIEW}.vector_offset)), a_center).do_nothing
				l_i := l_i + 1
			end
			l_alpha := 1.0 / l_P___2.to_real_64
			blas_inst.gsl_blas_dscal (l_alpha, a_center)
			Result := 0
		end

	compute_size (a_state: CE_POINTER [PD_NMSIMPLEX_STATE_T_119__]; a_center: CE_POINTER [PD_GSL_VECTOR]): REAL_64
		local
			l_s: CE_POINTER [PD_GSL_VECTOR]
			l_x1___0: CE_POINTER [PD_GSL_MATRIX]
			l_P___2: NATURAL_32
			l_i: NATURAL_32
			l_ss: REAL_64
			l_t: REAL_64
		do
			create l_s.make
			create l_x1___0.make

			l_s.ce_gets (a_state.item.ws1)
			l_x1___0.ce_gets (a_state.item.x1)
			l_P___2 := l_x1___0.item.size1
			l_ss := 0.0
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_P___2)
			loop
				getset_source_inst.gsl_matrix_get_row (l_s, l_x1___0, l_i).do_nothing
				blas_inst.gsl_blas_daxpy (-1.0, a_center, l_s).do_nothing
				l_t := blas_inst.gsl_blas_dnrm2 (l_s)
				l_ss := l_ss + (l_t * l_t)
				l_i := l_i + 1
			end
			a_state.item.S2 := l_ss / l_P___2.to_real_64
			Result := (sqrt (l_ss / l_P___2.to_real_64))
		end

	nmsimplex_alloc___0 (a_vstate: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_NMSIMPLEX_STATE_T_119__]
			js: JUMP_STATE
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_NMSIMPLEX_STATE_T_119__]}.make_cast (a_vstate))
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("invalid number of parameters specified"), ce_string ("simplex2.c"), 251, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_state.item.x1 := init_source_inst.gsl_matrix_alloc (a_n + {NATURAL_32} 1, a_n)
				if ((l_state.item.x1).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for x1"), ce_string ("simplex2.c"), 258, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.y1 := init_source_inst.gsl_vector_alloc (a_n + {NATURAL_32} 1)
				if ((l_state.item.y1).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_state.item.x1)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for y"), ce_string ("simplex2.c"), 266, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.ws1 := init_source_inst.gsl_vector_alloc (a_n)
				if ((l_state.item.ws1).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_state.item.x1)
					init_source_inst.gsl_vector_free (l_state.item.y1)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for ws1"), ce_string ("simplex2.c"), 275, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.ws2 := init_source_inst.gsl_vector_alloc (a_n)
				if ((l_state.item.ws2).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_state.item.x1)
					init_source_inst.gsl_vector_free (l_state.item.y1)
					init_source_inst.gsl_vector_free (l_state.item.ws1)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for ws2"), ce_string ("simplex2.c"), 285, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.center := init_source_inst.gsl_vector_alloc (a_n)
				if ((l_state.item.center).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_state.item.x1)
					init_source_inst.gsl_vector_free (l_state.item.y1)
					init_source_inst.gsl_vector_free (l_state.item.ws1)
					init_source_inst.gsl_vector_free (l_state.item.ws2)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for center"), ce_string ("simplex2.c"), 296, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.delta := init_source_inst.gsl_vector_alloc (a_n)
				if ((l_state.item.delta).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_state.item.x1)
					init_source_inst.gsl_vector_free (l_state.item.y1)
					init_source_inst.gsl_vector_free (l_state.item.ws1)
					init_source_inst.gsl_vector_free (l_state.item.ws2)
					init_source_inst.gsl_vector_free (l_state.item.center)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for delta"), ce_string ("simplex2.c"), 308, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.xmc := init_source_inst.gsl_vector_alloc (a_n)
				if ((l_state.item.xmc).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_state.item.x1)
					init_source_inst.gsl_vector_free (l_state.item.y1)
					init_source_inst.gsl_vector_free (l_state.item.ws1)
					init_source_inst.gsl_vector_free (l_state.item.ws2)
					init_source_inst.gsl_vector_free (l_state.item.center)
					init_source_inst.gsl_vector_free (l_state.item.delta)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for xmc"), ce_string ("simplex2.c"), 321, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.count := {NATURAL_32} 0
				Result := 0
			end
		end

	nmsimplex_alloc___0_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent nmsimplex_alloc___0)
		end

	nmsimplex_free___0 (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_NMSIMPLEX_STATE_T_119__]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_NMSIMPLEX_STATE_T_119__]}.make_cast (a_vstate))
			init_source_inst.gsl_matrix_free (l_state.item.x1)
			init_source_inst.gsl_vector_free (l_state.item.y1)
			init_source_inst.gsl_vector_free (l_state.item.ws1)
			init_source_inst.gsl_vector_free (l_state.item.ws2)
			init_source_inst.gsl_vector_free (l_state.item.center)
			init_source_inst.gsl_vector_free (l_state.item.delta)
			init_source_inst.gsl_vector_free (l_state.item.xmc)
		end

	nmsimplex_free___0_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent nmsimplex_free___0)
		end

	nmsimplex_set___0 (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_size: CE_POINTER [REAL_64]; a_step_size: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
			l_i: NATURAL_32
			l_val: REAL_64
			l_state: CE_POINTER [PD_NMSIMPLEX_STATE_T_119__]
			l_xtemp: CE_POINTER [PD_GSL_VECTOR]
			l_xi: REAL_64
			l_si: REAL_64
			js: JUMP_STATE
		do
			create l_state.make
			create l_xtemp.make

			l_state.ce_gets (create {CE_POINTER [PD_NMSIMPLEX_STATE_T_119__]}.make_cast (a_vstate))
			l_xtemp.ce_gets (l_state.item.ws1)
			if l_xtemp.item.size /= a_x.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("incompatible size of x"), ce_string ("simplex2.c"), 358, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (l_xtemp.item.size /= a_step_size.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("incompatible size of step_size"), ce_string ("simplex2.c"), 363, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_val := (a_f.item.f).real_64_item ([a_x, a_f.item.params])
				if not (infnan_inst.gsl_finite (l_val)).to_boolean then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("non-finite function value encountered"), ce_string ("simplex2.c"), 372, 9)
						Result := 9
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				getset_source_inst.gsl_matrix_set_row (l_state.item.x1, (0).to_natural_32, a_x).do_nothing
				gsl_gsl_vector_double_inst.gsl_vector_set (l_state.item.y1, (0).to_natural_32, l_val)
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_x.item.size))
				loop
					l_status := copy_source_inst.gsl_vector_memcpy (l_xtemp, a_x)
					if l_status /= 0 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("vector memcopy failed"), ce_string ("simplex2.c"), 386, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_xi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_x, l_i))
						l_si := (gsl_gsl_vector_double_inst.gsl_vector_get (a_step_size, l_i))
						gsl_gsl_vector_double_inst.gsl_vector_set (l_xtemp, l_i, l_xi + l_si)
						l_val := (a_f.item.f).real_64_item ([l_xtemp, a_f.item.params])
						if not (infnan_inst.gsl_finite (l_val)).to_boolean then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("non-finite function value encountered"), ce_string ("simplex2.c"), 399, 9)
								Result := 9
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
					end
					if not js.return_called then
						getset_source_inst.gsl_matrix_set_row (l_state.item.x1, l_i + {NATURAL_32} 1, l_xtemp).do_nothing
						gsl_gsl_vector_double_inst.gsl_vector_set (l_state.item.y1, l_i + {NATURAL_32} 1, l_val)
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				compute_center (l_state, l_state.item.center).do_nothing
				a_size.item := compute_size (l_state, l_state.item.center)
				l_state.item.count := (l_state.item.count) + 1
				Result := 0
			end
		end

	nmsimplex_set___0_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent nmsimplex_set___0)
		end

	nmsimplex_iterate___0 (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_size: CE_POINTER [REAL_64]; a_fval: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_state: CE_POINTER [PD_NMSIMPLEX_STATE_T_119__]
			l_xc: CE_POINTER [PD_GSL_VECTOR]
			l_xc2: CE_POINTER [PD_GSL_VECTOR]
			l_y1___0: CE_POINTER [PD_GSL_VECTOR]
			l_x1___0: CE_POINTER [PD_GSL_MATRIX]
			l_n: NATURAL_32
			l_i: NATURAL_32
			l_hi: NATURAL_32
			l_s_hi: NATURAL_32
			l_lo: NATURAL_32
			l_dhi: REAL_64
			l_ds_hi: REAL_64
			l_dlo: REAL_64
			l_status: INTEGER_32
			l_val: REAL_64
			l_val2: REAL_64
			l_S2: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_state.make
			create l_xc.make
			create l_xc2.make
			create l_y1___0.make
			create l_x1___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state.ce_gets (create {CE_POINTER [PD_NMSIMPLEX_STATE_T_119__]}.make_cast (a_vstate))
					l_xc.ce_gets (l_state.item.ws1)
					l_xc2.ce_gets (l_state.item.ws2)
					l_y1___0.ce_gets (l_state.item.y1)
					l_x1___0.ce_gets (l_state.item.x1)
					l_n := l_y1___0.item.size
					if l_xc.item.size /= a_x.item.size then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("incompatible size of x"), ce_string ("simplex2.c"), 442, 4)
							Result := 4
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						l_dlo := gsl_gsl_vector_double_inst.gsl_vector_get (l_y1___0, (0).to_natural_32)
						l_dhi := l_dlo
						l_hi := (0).to_natural_32
						l_lo := (0).to_natural_32
						l_ds_hi := gsl_gsl_vector_double_inst.gsl_vector_get (l_y1___0, (1).to_natural_32)
						l_s_hi := (1).to_natural_32
						l_i := (1).to_natural_32
						from
						until
							not (l_i < l_n)
						loop
							l_val := gsl_gsl_vector_double_inst.gsl_vector_get (l_y1___0, l_i)
							if l_val < l_dlo then
								l_dlo := l_val
								l_lo := l_i
							elseif l_val > l_dhi then
								l_ds_hi := l_dhi
								l_s_hi := l_hi
								l_dhi := l_val
								l_hi := l_i
							elseif l_val > l_ds_hi then
								l_ds_hi := l_val
								l_s_hi := l_i
							end
							l_i := l_i + 1
						end
						l_val := try_corner_move (-1.0, l_state, l_hi, l_xc, a_f)
						if not ((infnan_inst.gsl_finite (l_val)).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_val < (gsl_gsl_vector_double_inst.gsl_vector_get (l_y1___0, l_lo)) then
							l_val2 := try_corner_move (-2.0, l_state, l_hi, l_xc2, a_f)
							if (infnan_inst.gsl_finite (l_val2)).to_boolean then
								if l_val2 < (gsl_gsl_vector_double_inst.gsl_vector_get (l_y1___0, l_lo)) then
									update_point (l_state, l_hi, l_xc2, l_val2)
								else
									update_point (l_state, l_hi, l_xc, l_val)
								end
							else
								update_point (l_state, l_hi, l_xc, l_val)
							end
						else
							l_pos := -1 + 4 -- goto _L___1
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 4 then -- else: | _L___1:
						if not ((infnan_inst.gsl_finite (l_val)).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 5 then -- if:
						if not (l_val > (gsl_gsl_vector_double_inst.gsl_vector_get (l_y1___0, l_s_hi))) then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if: | _L___0:
						if (infnan_inst.gsl_finite (l_val)).to_boolean then
							if l_val <= (gsl_gsl_vector_double_inst.gsl_vector_get (l_y1___0, l_hi)) then
								update_point (l_state, l_hi, l_xc, l_val)
							end
						end
						l_val2 := try_corner_move (0.5, l_state, l_hi, l_xc2, a_f)
						if not ((infnan_inst.gsl_finite (l_val2)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_val2 <= (gsl_gsl_vector_double_inst.gsl_vector_get (l_y1___0, l_hi)) then
							update_point (l_state, l_hi, l_xc2, l_val2)
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						l_status := contract_by_best (l_state, l_lo, l_xc, a_f)
						if l_status /= 0 then
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("contraction failed"), ce_string ("simplex2.c"), 524, 5)
								Result := 5
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
				when 10 then -- if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						update_point (l_state, l_hi, l_xc, l_val)
				when 12 then -- if done | if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						l_pos := -1 + 6 -- goto _L___0
				when 14 then -- if done | if done
						if not js.return_called then
							l_lo := minmax_source_inst.gsl_vector_min_index (l_y1___0)
							getset_source_inst.gsl_matrix_get_row (a_x, l_x1___0, l_lo).do_nothing
							a_fval.item := gsl_gsl_vector_double_inst.gsl_vector_get (l_y1___0, l_lo)
							l_S2 := l_state.item.S2
							if l_S2 > (0).to_double then
								a_size.item := sqrt (l_S2)
							else
								a_size.item := compute_size (l_state, l_state.item.center)
							end
							Result := 0
						end
				when 15 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	nmsimplex_iterate___0_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent nmsimplex_iterate___0)
		end

	ran_unif (a_seed: CE_POINTER [NATURAL_32]): REAL_64
		local
			l_s: NATURAL_32
		do
			l_s := a_seed.item
			a_seed.item := ((l_s * {NATURAL_32} 69069 + {NATURAL_32} 1)).bit_and ({NATURAL_32} 4294967295)
			Result := ((a_seed.item).to_real_64 / 4294967296.0)
		end

	nmsimplex_set_rand (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_size: CE_POINTER [REAL_64]; a_step_size: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_val: REAL_64
			l_state: CE_POINTER [PD_NMSIMPLEX_STATE_T_119__]
			l_xtemp: CE_POINTER [PD_GSL_VECTOR]
			l_m___4: PD_GSL_MATRIX_VIEW
			l_seed: NATURAL_32
			l_s: REAL_64
			l_angle: REAL_64
			l_c___1: REAL_64
			l_s___0: REAL_64
			l_c_i: PD_GSL_VECTOR_VIEW
			l_c_j: PD_GSL_VECTOR_VIEW
			l_x_i: REAL_64
			l_s_i: REAL_64
			l_c_i___0: PD_GSL_VECTOR_VIEW
			l_x_ij: REAL_64
			l_r_i: PD_GSL_VECTOR_VIEW
			js: JUMP_STATE
		do
			create l_state.make
			create l_xtemp.make
			create l_m___4.make
			create l_c_i.make
			create l_c_j.make
			create l_c_i___0.make
			create l_r_i.make

			l_state.ce_gets (create {CE_POINTER [PD_NMSIMPLEX_STATE_T_119__]}.make_cast (a_vstate))
			l_xtemp.ce_gets (l_state.item.ws1)
			if l_xtemp.item.size /= a_x.item.size then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("incompatible size of x"), ce_string ("simplex2.c"), 596, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (l_xtemp.item.size /= a_step_size.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("incompatible size of step_size"), ce_string ("simplex2.c"), 601, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_val := (a_f.item.f).real_64_item ([a_x, a_f.item.params])
				if not (infnan_inst.gsl_finite (l_val)).to_boolean then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("non-finite function value encountered"), ce_string ("simplex2.c"), 610, 9)
						Result := 9
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				getset_source_inst.gsl_matrix_set_row (l_state.item.x1, (0).to_natural_32, a_x).do_nothing
				gsl_gsl_vector_double_inst.gsl_vector_set (l_state.item.y1, (0).to_natural_32, l_val)
				l_m___4.ce_gets ((submatrix_source_inst.gsl_matrix_submatrix (l_state.item.x1, (1).to_natural_32, (0).to_natural_32, a_x.item.size, a_x.item.size)))
				l_seed := (l_state.item.count).bit_xor ({NATURAL_32} 305419896)
				ran_unif (create {CE_POINTER [NATURAL_32]}.make_shared ($l_seed)).do_nothing
				init_source_inst.gsl_matrix_set_identity (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset))
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_x.item.size)
				loop
					l_s := (ran_unif (create {CE_POINTER [NATURAL_32]}.make_shared ($l_seed)))
					if l_s > 0.5 then
						gsl_gsl_matrix_double_inst.gsl_matrix_set (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), l_i, l_i, -1.0)
					end
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_x.item.size))
				loop
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (l_j < a_x.item.size)
					loop
						l_angle := (2.0 * 3.14159265358979323846) * (ran_unif (create {CE_POINTER [NATURAL_32]}.make_shared ($l_seed)))
						l_c___1 := (cos (l_angle))
						l_s___0 := (sin (l_angle))
						l_c_i.ce_gets ((rowcol_source_inst.gsl_matrix_column (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), l_i)))
						l_c_j.ce_gets ((rowcol_source_inst.gsl_matrix_column (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), l_j)))
						blas_inst.gsl_blas_drot (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c_i.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c_j.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_c___1, l_s___0).do_nothing
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_x.item.size))
				loop
					l_x_i := (gsl_gsl_vector_double_inst.gsl_vector_get (a_x, l_i))
					l_s_i := (gsl_gsl_vector_double_inst.gsl_vector_get (a_step_size, l_i))
					l_c_i___0.ce_gets ((rowcol_source_inst.gsl_matrix_column (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), l_i)))
					l_j := (0).to_natural_32
					from
					until
						not (l_j < a_x.item.size)
					loop
						l_x_ij := (gsl_gsl_vector_double_inst.gsl_vector_get ((create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c_i___0.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), l_j))
						gsl_gsl_vector_double_inst.gsl_vector_set (create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_c_i___0.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset), l_j, l_x_i + l_s_i * l_x_ij)
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_x.item.size))
				loop
					l_r_i.ce_gets ((rowcol_source_inst.gsl_matrix_row (create {CE_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.c_pointer + {PD_GSL_MATRIX_VIEW}.matrix_offset), l_i)))
					l_val := (a_f.item.f).real_64_item ([(create {CE_POINTER [PD_GSL_VECTOR]}.make_shared (l_r_i.c_pointer + {PD_GSL_VECTOR_VIEW}.vector_offset)), a_f.item.params])
					if not (infnan_inst.gsl_finite (l_val)).to_boolean then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("non-finite function value encountered"), ce_string ("simplex2.c"), 674, 9)
							Result := 9
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						gsl_gsl_vector_double_inst.gsl_vector_set (l_state.item.y1, l_i + {NATURAL_32} 1, l_val)
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				compute_center (l_state, l_state.item.center).do_nothing
				a_size.item := compute_size (l_state, l_state.item.center)
				l_state.item.count := (l_state.item.count) + 1
				Result := 0
			end
		end

	nmsimplex_set_rand_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent nmsimplex_set_rand)
		end

end
