class
	P_SOLVE_CUBIC

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_poly_solve_cubic (a_a___5: REAL_64; a_b___0: REAL_64; a_c___1: REAL_64; a_x0: CE_POINTER [REAL_64]; a_x1___0: CE_POINTER [REAL_64]; a_x2___1: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_q___3: REAL_64
			l_r___3: REAL_64
			l_Q___1: REAL_64
			l_R: REAL_64
			l_Q3___0: REAL_64
			l_R2: REAL_64
			l_CR2: REAL_64
			l_CQ3: REAL_64
			l_sqrtQ: REAL_64
			l_sgnR: REAL_64
			l_tmp___0: INTEGER_32
			l_ratio: REAL_64
			l_theta: REAL_64
			l_norm___0: REAL_64
			l_tmp___7: REAL_64
			l_tmp___8: REAL_64
			l_tmp___9: REAL_64
			l_sgnR___0: REAL_64
			l_tmp___10: INTEGER_32
			l_A___0: REAL_64
			l_tmp___11: REAL_64
			l_B: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_q___3 := a_a___5 * a_a___5 - (3).to_double * a_b___0
					l_r___3 := ((((2).to_double * a_a___5) * a_a___5) * a_a___5 - ((9).to_double * a_a___5) * a_b___0) + (27).to_double * a_c___1
					l_Q___1 := l_q___3 / (9).to_double
					l_R := l_r___3 / (54).to_double
					l_Q3___0 := (l_Q___1 * l_Q___1) * l_Q___1
					l_R2 := l_R * l_R
					l_CR2 := ((729).to_double * l_r___3) * l_r___3
					l_CQ3 := (((2916).to_double * l_q___3) * l_q___3) * l_q___3
					if l_R /= (0).to_double then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_Q___1 = (0).to_double then
							a_x0.item := -a_a___5 / (3).to_double
							a_x1___0.item := -a_a___5 / (3).to_double
							a_x2___1.item := -a_a___5 / (3).to_double
							Result := 3
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if l_CR2 = l_CQ3 then
							l_sqrtQ := (sqrt (l_Q___1))
							if l_R > (0).to_double then
								a_x0.item := (-2).to_double * l_sqrtQ - a_a___5 / (3).to_double
								a_x1___0.item := l_sqrtQ - a_a___5 / (3).to_double
								a_x2___1.item := l_sqrtQ - a_a___5 / (3).to_double
							else
								a_x0.item := -l_sqrtQ - a_a___5 / (3).to_double
								a_x1___0.item := -l_sqrtQ - a_a___5 / (3).to_double
								a_x2___1.item := (2).to_double * l_sqrtQ - a_a___5 / (3).to_double
							end
							Result := 3
						elseif l_R2 < l_Q3___0 then
							if l_R >= (0).to_double then
								l_tmp___0 := 1
							else
								l_tmp___0 := -1
							end
							l_sgnR := l_tmp___0.to_double
							l_ratio := l_sgnR * (sqrt (l_R2 / l_Q3___0))
							l_theta := (acos (l_ratio))
							l_norm___0 := (-2).to_double * (sqrt (l_Q___1))
							a_x0.item := l_norm___0 * (cos (l_theta / (3).to_double)) - a_a___5 / (3).to_double
							a_x1___0.item := l_norm___0 * (cos ((l_theta + 2.0 * 3.14159265358979323846) / (3).to_double)) - a_a___5 / (3).to_double
							a_x2___1.item := l_norm___0 * (cos ((l_theta - 2.0 * 3.14159265358979323846) / (3).to_double)) - a_a___5 / (3).to_double
							if a_x0.item > a_x1___0.item then
								from
								until
									js.loop_left
								loop
									js.reset
									l_tmp___7 := a_x1___0.item
									a_x1___0.item := a_x0.item
									a_x0.item := l_tmp___7
									js.break
								end
								js.reset
							end
							if a_x1___0.item > a_x2___1.item then
								from
								until
									js.loop_left
								loop
									js.reset
									l_tmp___8 := a_x2___1.item
									a_x2___1.item := a_x1___0.item
									a_x1___0.item := l_tmp___8
									js.break
								end
								js.reset
								if a_x0.item > a_x1___0.item then
									from
									until
										js.loop_left
									loop
										js.reset
										l_tmp___9 := a_x1___0.item
										a_x1___0.item := a_x0.item
										a_x0.item := l_tmp___9
										js.break
									end
									js.reset
								end
							end
							Result := 3
						else
							if l_R >= (0).to_double then
								l_tmp___10 := 1
							else
								l_tmp___10 := -1
							end
							l_sgnR___0 := l_tmp___10.to_double
							l_tmp___11 := fabs (l_R)
							l_A___0 := -l_sgnR___0 * (pow (l_tmp___11 + (sqrt (l_R2 - l_Q3___0)), 1.0 / 3.0))
							l_B := l_Q___1 / l_A___0
							a_x0.item := (l_A___0 + l_B) - a_a___5 / (3).to_double
							Result := 1
						end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
