class
	P_SPHERE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_ran_dir_2d (a_r___3: CE_POINTER [PD_GSL_RNG]; a_x: CE_POINTER [REAL_64]; a_y: CE_POINTER [REAL_64])
		local
			l_u: REAL_64
			l_v: REAL_64
			l_s: REAL_64
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				l_u := (-1).to_double + (2).to_double * (gsl_gsl_rng_inst.gsl_rng_uniform (a_r___3))
				l_v := (-1).to_double + (2).to_double * (gsl_gsl_rng_inst.gsl_rng_uniform (a_r___3))
				l_s := l_u * l_u + l_v * l_v
				if not (l_s > 1.0) then
					if l_s /= 0.0 then
						js.break
					end
				end
			end
			js.reset
			a_x.item := (l_u * l_u - l_v * l_v) / l_s
			a_y.item := (((2).to_double * l_u) * l_v) / l_s
		end

	gsl_ran_dir_2d_trig_method (a_r___3: CE_POINTER [PD_GSL_RNG]; a_x: CE_POINTER [REAL_64]; a_y: CE_POINTER [REAL_64])
		local
			l_t: REAL_64
		do
			l_t := 6.2831853071795864 * (gsl_gsl_rng_inst.gsl_rng_uniform (a_r___3))
			a_x.item := cos (l_t)
			a_y.item := sin (l_t)
		end

	gsl_ran_dir_3d (a_r___3: CE_POINTER [PD_GSL_RNG]; a_x: CE_POINTER [REAL_64]; a_y: CE_POINTER [REAL_64]; a_z: CE_POINTER [REAL_64])
		local
			l_s: REAL_64
			l_a___5: REAL_64
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				a_x.item := (-1).to_double + (2).to_double * (gsl_gsl_rng_inst.gsl_rng_uniform (a_r___3))
				a_y.item := (-1).to_double + (2).to_double * (gsl_gsl_rng_inst.gsl_rng_uniform (a_r___3))
				l_s := a_x.item * a_x.item + a_y.item * a_y.item
				if not (l_s > 1.0) then
					js.break
				end
			end
			js.reset
			a_z.item := (-1).to_double + (2).to_double * l_s
			l_a___5 := (2).to_double * (sqrt ((1).to_double - l_s))
			a_x.item := a_x.item * l_a___5
			a_y.item := a_y.item * l_a___5
		end

	gsl_ran_dir_nd (a_r___3: CE_POINTER [PD_GSL_RNG]; a_n: NATURAL_32; a_x: CE_POINTER [REAL_64])
		local
			l_d: REAL_64
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_d := (0).to_double
			from
			until
				js.loop_left
			loop
				js.reset
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					a_x[l_i.to_integer_32] := gauss_inst.gsl_ran_gaussian (a_r___3, 1.0)
					l_d := l_d + (a_x[l_i.to_integer_32] * a_x[l_i.to_integer_32])
					l_i := l_i + 1
				end
				if l_d /= (0).to_double then
					js.break
				end
			end
			js.reset
			l_d := sqrt (l_d)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				a_x[l_i.to_integer_32] := a_x[l_i.to_integer_32] / l_d
				l_i := l_i + 1
			end
		end

end
