class
	P_SSPR2

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_sspr2 (a_order: INTEGER_32; a_Uplo: INTEGER_32; a_N: INTEGER_32; a_alpha: REAL_32; a_X: CE_POINTER [REAL_32]; a_incX: INTEGER_32; a_Y: CE_POINTER [REAL_32]; a_incY: INTEGER_32; a_Ap: CE_POINTER [REAL_32])
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_ix: INTEGER_32
			l_tmp: INTEGER_32
			l_iy: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp1: REAL_64
			l_tmp2: REAL_64
			l_jx: INTEGER_32
			l_jy: INTEGER_32
			l_ix___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_iy___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp1___0: REAL_64
			l_tmp2___0: REAL_64
			l_jx___0: INTEGER_32
			l_tmp___3: INTEGER_32
			l_jy___0: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_N = 0 then
						js.return
					end
					if not js.return_called and then (a_alpha.to_double = 0.0) then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 20 -- skip if block
					end
				when 1 then -- if:
						if a_order.to_natural_32 /= {NATURAL_32} 101 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if a_Uplo.to_natural_32 = {NATURAL_32} 121 then
							l_pos := -1 + 6 -- goto _L___1
						else
							l_pos := -1 + 4 -- goto _L___3
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 4 then -- else: | _L___3:
						if a_order.to_natural_32 /= {NATURAL_32} 102 then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if a_Uplo.to_natural_32 /= {NATURAL_32} 122 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L___1:
						if a_incX > 0 then
							l_tmp := 0
						else
							l_tmp := (a_N - 1) * -a_incX
						end
						l_ix := l_tmp
						if a_incY > 0 then
							l_tmp___0 := 0
						else
							l_tmp___0 := (a_N - 1) * -a_incY
						end
						l_iy := l_tmp___0
						l_i := 0
						from
						until
							not (not js.loop_left and then (l_i < a_N))
						loop
							l_tmp1 := (a_alpha * a_X[l_ix]).to_double
							l_tmp2 := (a_alpha * a_Y[l_iy]).to_double
							l_jx := l_ix
							l_jy := l_iy
							l_j := l_i
							from
							until
								not (l_j < a_N)
							loop
								a_Ap[(((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_j) - l_i)] := ((a_Ap[(((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_j) - l_i)]).to_double + (l_tmp1 * (a_Y[l_jy]).to_double + l_tmp2 * (a_X[l_jx]).to_double)).truncated_to_real
								l_jx := l_jx + a_incX
								l_jy := l_jy + a_incY
								l_j := l_j + 1
							end
							l_ix := l_ix + a_incX
							l_iy := l_iy + a_incY
							l_i := l_i + 1
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_pos := -1 + 10 -- goto _L___2
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 10 then -- else: | _L___2:
						if a_order.to_natural_32 /= {NATURAL_32} 101 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if a_Uplo.to_natural_32 = {NATURAL_32} 122 then
							l_pos := -1 + 15 -- goto _L
						else
							l_pos := -1 + 13 -- goto _L___0
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else: | _L___0:
						if a_order.to_natural_32 /= {NATURAL_32} 102 then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						if a_Uplo.to_natural_32 /= {NATURAL_32} 121 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if: | _L:
						if a_incX > 0 then
							l_tmp___1 := 0
						else
							l_tmp___1 := (a_N - 1) * -a_incX
						end
						l_ix___0 := l_tmp___1
						if a_incY > 0 then
							l_tmp___2 := 0
						else
							l_tmp___2 := (a_N - 1) * -a_incY
						end
						l_iy___0 := l_tmp___2
						l_i := 0
						from
						until
							not (not js.loop_left and then (l_i < a_N))
						loop
							l_tmp1___0 := (a_alpha * a_X[l_ix___0]).to_double
							l_tmp2___0 := (a_alpha * a_Y[l_iy___0]).to_double
							if a_incX > 0 then
								l_tmp___3 := 0
							else
								l_tmp___3 := (a_N - 1) * -a_incX
							end
							l_jx___0 := l_tmp___3
							if a_incY > 0 then
								l_tmp___4 := 0
							else
								l_tmp___4 := (a_N - 1) * -a_incY
							end
							l_jy___0 := l_tmp___4
							l_j := 0
							from
							until
								not (l_j <= l_i)
							loop
								a_Ap[((l_i * (l_i + 1)) // 2 + l_j)] := ((a_Ap[((l_i * (l_i + 1)) // 2 + l_j)]).to_double + (l_tmp1___0 * (a_Y[l_jy___0]).to_double + l_tmp2___0 * (a_X[l_jx___0]).to_double)).truncated_to_real
								l_jx___0 := l_jx___0 + a_incX
								l_jy___0 := l_jy___0 + a_incY
								l_j := l_j + 1
							end
							l_ix___0 := l_ix___0 + a_incX
							l_iy___0 := l_iy___0 + a_incY
							l_i := l_i + 1
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						xerbla_inst.cblas_xerbla ([0, ce_string ("source_spr2.h"), ce_string ("unrecognized operation")])
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:
						xerbla_inst.cblas_xerbla ([0, ce_string ("source_spr2.h"), ce_string ("unrecognized operation")])
				when 20 then -- if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
