class
	P_STAT

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_histogram_mean (a_h: CE_POINTER [PD_GSL_HISTOGRAM]): REAL_64
		local
			l_n: NATURAL_32
			l_i: NATURAL_32
			l_wmean: REAL_96
			l_W: REAL_96
			l_xi: REAL_64
			l_wi: REAL_64
		do
			l_n := a_h.item.n
			l_wmean := real_96_from_integer_32 (0)
			l_W := real_96_from_integer_32 (0)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_xi := (a_h.item.range[(l_i + {NATURAL_32} 1).to_integer_32] + a_h.item.range[l_i.to_integer_32]) / (2).to_double
				l_wi := a_h.item.bin[l_i.to_integer_32]
				if l_wi > (0).to_double then
					l_W := l_W + real_96_from_real_64 (l_wi)
					l_wmean := l_wmean + ((real_96_from_real_64 (l_xi) - l_wmean) * (real_96_from_real_64 (l_wi) / l_W))
				end
				l_i := l_i + 1
			end
			Result := l_wmean.truncated_to_real_64
		end

	gsl_histogram_sigma (a_h: CE_POINTER [PD_GSL_HISTOGRAM]): REAL_64
		local
			l_n: NATURAL_32
			l_i: NATURAL_32
			l_wvariance: REAL_96
			l_wmean: REAL_96
			l_W: REAL_96
			l_xi: REAL_64
			l_wi: REAL_64
			l_xi___0: REAL_64
			l_wi___0: REAL_64
			l_delta___0: REAL_96
			l_sigma: REAL_64
		do
			l_n := a_h.item.n
			l_wvariance := real_96_from_integer_32 (0)
			l_wmean := real_96_from_integer_32 (0)
			l_W := real_96_from_integer_32 (0)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_xi := (a_h.item.range[(l_i + {NATURAL_32} 1).to_integer_32] + a_h.item.range[l_i.to_integer_32]) / (2).to_double
				l_wi := a_h.item.bin[l_i.to_integer_32]
				if l_wi > (0).to_double then
					l_W := l_W + real_96_from_real_64 (l_wi)
					l_wmean := l_wmean + ((real_96_from_real_64 (l_xi) - l_wmean) * (real_96_from_real_64 (l_wi) / l_W))
				end
				l_i := l_i + 1
			end
			l_W := real_96_from_real_64 (0.0)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_xi___0 := (a_h.item.range[(l_i + {NATURAL_32} 1).to_integer_32] + a_h.item.range[l_i.to_integer_32]) / (2).to_double
				l_wi___0 := a_h.item.bin[l_i.to_integer_32]
				if l_wi___0 > (0).to_double then
					l_delta___0 := real_96_from_real_64 (l_xi___0) - l_wmean
					l_W := l_W + real_96_from_real_64 (l_wi___0)
					l_wvariance := l_wvariance + ((l_delta___0 * l_delta___0 - l_wvariance) * (real_96_from_real_64 (l_wi___0) / l_W))
				end
				l_i := l_i + 1
			end
			l_sigma := (sqrt (l_wvariance.truncated_to_real_64))
			Result := l_sigma
		end

	gsl_histogram_sum (a_h: CE_POINTER [PD_GSL_HISTOGRAM]): REAL_64
		local
			l_sum: REAL_64
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_tmp: NATURAL_32
		do
			l_sum := (0).to_double
			l_i := (0).to_natural_32
			l_n := a_h.item.n
			from
			until
				not (l_i < l_n)
			loop
				l_tmp := l_i
				l_i := l_i + 1
				l_sum := l_sum + (a_h.item.bin[l_tmp.to_integer_32])
			end
			Result := l_sum
		end

end
