class
	P_STEP

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_odeiv_step_alloc (a_T: CE_POINTER [PD_GSL_ODEIV_STEP_TYPE]; a_dim: NATURAL_32): CE_POINTER [PD_GSL_ODEIV_STEP]
		local
			l_s: CE_POINTER [PD_GSL_ODEIV_STEP]
			js: JUMP_STATE
		do
			create l_s.make

			l_s.ce_gets (create {CE_POINTER [PD_GSL_ODEIV_STEP]}.make_cast ((malloc ({PD_GSL_ODEIV_STEP}.sizeof.to_natural_32))))
			if (l_s.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("failed to allocate space for ode struct"), ce_string ("step.c"), 34, 8)
					Result := (create {CE_POINTER [PD_GSL_ODEIV_STEP]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.item.type := a_T
				l_s.item.dimension := a_dim
				l_s.item.state := create {CE_POINTER [ANY]}.make_cast (((l_s.item.type).item.alloc).pointer_item ([a_dim]))
				if ((l_s.item.state).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for ode state"), ce_string ("step.c"), 46, 8)
						Result := (create {CE_POINTER [PD_GSL_ODEIV_STEP]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				Result := l_s
			end
		end

	gsl_odeiv_step_name (a_s: CE_POINTER [PD_GSL_ODEIV_STEP]): CE_POINTER [INTEGER_8]
		do
			Result := ((a_s.item.type).item.name)
		end

	gsl_odeiv_step_order (a_s: CE_POINTER [PD_GSL_ODEIV_STEP]): NATURAL_32
		do
			Result := (((a_s.item.type).item.order).natural_32_item ([a_s.item.state]))
		end

	gsl_odeiv_step_apply (a_s: CE_POINTER [PD_GSL_ODEIV_STEP]; a_t: REAL_64; a_h: REAL_64; a_y: CE_POINTER [REAL_64]; a_yerr: CE_POINTER [REAL_64]; a_dydt_in: CE_POINTER [REAL_64]; a_dydt_out: CE_POINTER [REAL_64]; a_dydt: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		do
			Result := (((a_s.item.type).item.apply).integer_32_item ([a_s.item.state, a_s.item.dimension, a_t, a_h, a_y, a_yerr, a_dydt_in, a_dydt_out, a_dydt]))
		end

	gsl_odeiv_step_reset (a_s: CE_POINTER [PD_GSL_ODEIV_STEP]): INTEGER_32
		do
			Result := (((a_s.item.type).item.reset).integer_32_item ([a_s.item.state, a_s.item.dimension]))
		end

	gsl_odeiv_step_free (a_s: CE_POINTER [PD_GSL_ODEIV_STEP])
		local
			js: JUMP_STATE
		do
			if (a_s).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				((a_s.item.type).item.free).call ([a_s.item.state])
				free (create {CE_POINTER [ANY]}.make_cast (a_s))
			end
		end

end
