class
	P_SUBVECTOR_SOURCE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_vector_complex_long_double_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_VIEW
			l_s: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (({NATURAL_32} 2 * a_v.item.stride) * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_complex_long_double_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_VIEW
			l_s: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (({NATURAL_32} 2 * a_v.item.stride) * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride * a_stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_complex_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_VIEW
			l_s: PD_GSL_VECTOR_COMPLEX
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (({NATURAL_32} 2 * a_v.item.stride) * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_complex_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_VIEW
			l_s: PD_GSL_VECTOR_COMPLEX
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (({NATURAL_32} 2 * a_v.item.stride) * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride * a_stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_complex_float_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
			l_s: PD_GSL_VECTOR_COMPLEX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (({NATURAL_32} 2 * a_v.item.stride) * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_complex_float_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
			l_s: PD_GSL_VECTOR_COMPLEX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (({NATURAL_32} 2 * a_v.item.stride) * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride * a_stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_long_double_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_DOUBLE_VIEW
			l_s: PD_GSL_VECTOR_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (a_v.item.stride * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_long_double_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_DOUBLE_VIEW
			l_s: PD_GSL_VECTOR_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (a_v.item.stride * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride * a_stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_subvector (a_v: CE_POINTER [PD_GSL_VECTOR]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_VIEW
		local
			l_view: PD_GSL_VECTOR_VIEW
			l_s: PD_GSL_VECTOR
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (a_v.item.stride * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_VIEW
		local
			l_view: PD_GSL_VECTOR_VIEW
			l_s: PD_GSL_VECTOR
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (a_v.item.stride * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride * a_stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_float_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_FLOAT_VIEW
		local
			l_view: PD_GSL_VECTOR_FLOAT_VIEW
			l_s: PD_GSL_VECTOR_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (a_v.item.stride * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_float_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_FLOAT_VIEW
		local
			l_view: PD_GSL_VECTOR_FLOAT_VIEW
			l_s: PD_GSL_VECTOR_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (a_v.item.stride * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride * a_stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_ulong_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_ULONG_VIEW
		local
			l_view: PD_GSL_VECTOR_ULONG_VIEW
			l_s: PD_GSL_VECTOR_ULONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (a_v.item.stride * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_ulong_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_ULONG_VIEW
		local
			l_view: PD_GSL_VECTOR_ULONG_VIEW
			l_s: PD_GSL_VECTOR_ULONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (a_v.item.stride * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride * a_stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_long_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_LONG]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_LONG_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_VIEW
			l_s: PD_GSL_VECTOR_LONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (a_v.item.stride * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_long_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_LONG]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_LONG_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_VIEW
			l_s: PD_GSL_VECTOR_LONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (a_v.item.stride * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride * a_stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_uint_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_UINT]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_UINT_VIEW
		local
			l_view: PD_GSL_VECTOR_UINT_VIEW
			l_s: PD_GSL_VECTOR_UINT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (a_v.item.stride * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_uint_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_UINT]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_UINT_VIEW
		local
			l_view: PD_GSL_VECTOR_UINT_VIEW
			l_s: PD_GSL_VECTOR_UINT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (a_v.item.stride * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride * a_stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_int_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_INT]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_INT_VIEW
		local
			l_view: PD_GSL_VECTOR_INT_VIEW
			l_s: PD_GSL_VECTOR_INT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (a_v.item.stride * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_int_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_INT]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_INT_VIEW
		local
			l_view: PD_GSL_VECTOR_INT_VIEW
			l_s: PD_GSL_VECTOR_INT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (a_v.item.stride * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride * a_stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_ushort_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_USHORT_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_VIEW
			l_s: PD_GSL_VECTOR_USHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (a_v.item.stride * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_ushort_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_USHORT_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_VIEW
			l_s: PD_GSL_VECTOR_USHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (a_v.item.stride * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride * a_stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_short_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_SHORT_VIEW
		local
			l_view: PD_GSL_VECTOR_SHORT_VIEW
			l_s: PD_GSL_VECTOR_SHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (a_v.item.stride * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_short_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_SHORT_VIEW
		local
			l_view: PD_GSL_VECTOR_SHORT_VIEW
			l_s: PD_GSL_VECTOR_SHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (a_v.item.stride * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride * a_stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_uchar_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_UCHAR_VIEW
		local
			l_view: PD_GSL_VECTOR_UCHAR_VIEW
			l_s: PD_GSL_VECTOR_UCHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (a_v.item.stride * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_uchar_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_UCHAR_VIEW
		local
			l_view: PD_GSL_VECTOR_UCHAR_VIEW
			l_s: PD_GSL_VECTOR_UCHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (a_v.item.stride * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride * a_stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_char_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_CHAR_VIEW
		local
			l_view: PD_GSL_VECTOR_CHAR_VIEW
			l_s: PD_GSL_VECTOR_CHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (a_v.item.stride * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_char_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_CHAR_VIEW
		local
			l_view: PD_GSL_VECTOR_CHAR_VIEW
			l_s: PD_GSL_VECTOR_CHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_v.item.data + (a_v.item.stride * a_offset).to_integer_32
				l_s.size := a_n
				l_s.stride := a_v.item.stride * a_stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_complex_long_double_const_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_CONST_VIEW
			l_s: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (({NATURAL_32} 2 * a_v.item.stride) * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_complex_long_double_const_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_CONST_VIEW
			l_s: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (({NATURAL_32} 2 * a_v.item.stride) * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := (a_v.item.stride * a_stride)
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_complex_const_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_CONST_VIEW
			l_s: PD_GSL_VECTOR_COMPLEX
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (({NATURAL_32} 2 * a_v.item.stride) * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_complex_const_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_CONST_VIEW
			l_s: PD_GSL_VECTOR_COMPLEX
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (({NATURAL_32} 2 * a_v.item.stride) * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := (a_v.item.stride * a_stride)
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_complex_float_const_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
			l_s: PD_GSL_VECTOR_COMPLEX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (({NATURAL_32} 2 * a_v.item.stride) * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_complex_float_const_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
			l_s: PD_GSL_VECTOR_COMPLEX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (({NATURAL_32} 2 * a_v.item.stride) * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := (a_v.item.stride * a_stride)
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_long_double_const_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_DOUBLE_CONST_VIEW
			l_s: PD_GSL_VECTOR_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (a_v.item.stride * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_long_double_const_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_DOUBLE_CONST_VIEW
			l_s: PD_GSL_VECTOR_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (a_v.item.stride * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := (a_v.item.stride * a_stride)
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_const_subvector (a_v: CE_POINTER [PD_GSL_VECTOR]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_CONST_VIEW
			l_s: PD_GSL_VECTOR
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (a_v.item.stride * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_const_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_CONST_VIEW
			l_s: PD_GSL_VECTOR
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (a_v.item.stride * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := (a_v.item.stride * a_stride)
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_float_const_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_FLOAT_CONST_VIEW
			l_s: PD_GSL_VECTOR_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (a_v.item.stride * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_float_const_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_FLOAT_CONST_VIEW
			l_s: PD_GSL_VECTOR_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (a_v.item.stride * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := (a_v.item.stride * a_stride)
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_ulong_const_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_ULONG_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_ULONG_CONST_VIEW
			l_s: PD_GSL_VECTOR_ULONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (a_v.item.stride * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_ulong_const_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_ULONG_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_ULONG_CONST_VIEW
			l_s: PD_GSL_VECTOR_ULONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (a_v.item.stride * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := (a_v.item.stride * a_stride)
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_long_const_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_LONG]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_LONG_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_CONST_VIEW
			l_s: PD_GSL_VECTOR_LONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (a_v.item.stride * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_long_const_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_LONG]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_LONG_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_CONST_VIEW
			l_s: PD_GSL_VECTOR_LONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (a_v.item.stride * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := (a_v.item.stride * a_stride)
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_uint_const_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_UINT]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_UINT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_UINT_CONST_VIEW
			l_s: PD_GSL_VECTOR_UINT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (a_v.item.stride * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_uint_const_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_UINT]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_UINT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_UINT_CONST_VIEW
			l_s: PD_GSL_VECTOR_UINT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (a_v.item.stride * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := (a_v.item.stride * a_stride)
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_int_const_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_INT]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_INT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_INT_CONST_VIEW
			l_s: PD_GSL_VECTOR_INT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (a_v.item.stride * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_int_const_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_INT]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_INT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_INT_CONST_VIEW
			l_s: PD_GSL_VECTOR_INT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (a_v.item.stride * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := (a_v.item.stride * a_stride)
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_ushort_const_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_USHORT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_CONST_VIEW
			l_s: PD_GSL_VECTOR_USHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (a_v.item.stride * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_ushort_const_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_USHORT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_CONST_VIEW
			l_s: PD_GSL_VECTOR_USHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (a_v.item.stride * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := (a_v.item.stride * a_stride)
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_short_const_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_SHORT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_SHORT_CONST_VIEW
			l_s: PD_GSL_VECTOR_SHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (a_v.item.stride * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_short_const_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_SHORT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_SHORT_CONST_VIEW
			l_s: PD_GSL_VECTOR_SHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (a_v.item.stride * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := (a_v.item.stride * a_stride)
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_uchar_const_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_UCHAR_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_UCHAR_CONST_VIEW
			l_s: PD_GSL_VECTOR_UCHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (a_v.item.stride * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_uchar_const_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_UCHAR_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_UCHAR_CONST_VIEW
			l_s: PD_GSL_VECTOR_UCHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (a_v.item.stride * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := (a_v.item.stride * a_stride)
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_char_const_subvector (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]; a_offset: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_CHAR_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_CHAR_CONST_VIEW
			l_s: PD_GSL_VECTOR_CHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (a_v.item.stride * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := a_v.item.stride
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

	gsl_vector_char_const_subvector_with_stride (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]; a_offset: NATURAL_32; a_stride: NATURAL_32; a_n: NATURAL_32): PD_GSL_VECTOR_CHAR_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_CHAR_CONST_VIEW
			l_s: PD_GSL_VECTOR_CHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_view.vector.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_stride = {NATURAL_32} 0) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= a_v.item.size) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size := (0).to_natural_32
				l_s.stride := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_v.item.data + (a_v.item.stride * a_offset).to_integer_32)
				l_s.size := a_n
				l_s.stride := (a_v.item.stride * a_stride)
				l_s.block := a_v.item.block
				l_s.owner := 0
				l_view.vector := l_s
				Result := l_view
			end
		end

end
