class
	P_SYNCHROTRON

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create synchrotron1_data.make (<<13>>)
			create synchrotron1_cs.make
			create synchrotron2_data.make (<<12>>)
			create synchrotron2_cs.make
			create synchrotron1a_data.make (<<23>>)
			create synchrotron1a_cs.make
			create synchrotron21_data.make (<<13>>)
			create synchrotron21_cs.make
			create synchrotron22_data.make (<<13>>)
			create synchrotron22_cs.make
			create synchrotron2a_data.make (<<17>>)
			create synchrotron2a_cs.make
		end

feature {ANY} -- attributes

	synchrotron1_data: CE_ARRAY [REAL_64]

	synchrotron1_cs: PD_CHEB_SERIES_STRUCT

	synchrotron2_data: CE_ARRAY [REAL_64]

	synchrotron2_cs: PD_CHEB_SERIES_STRUCT

	synchrotron1a_data: CE_ARRAY [REAL_64]

	synchrotron1a_cs: PD_CHEB_SERIES_STRUCT

	synchrotron21_data: CE_ARRAY [REAL_64]

	synchrotron21_cs: PD_CHEB_SERIES_STRUCT

	synchrotron22_data: CE_ARRAY [REAL_64]

	synchrotron22_cs: PD_CHEB_SERIES_STRUCT

	synchrotron2a_data: CE_ARRAY [REAL_64]

	synchrotron2a_cs: PD_CHEB_SERIES_STRUCT

feature {ANY} -- routines

	gsl_sf_synchrotron_1_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_z: REAL_64
			l_cf: REAL_64
			l_c0___0: REAL_64
			l_px: REAL_64
			l_px11: REAL_64
			l_t: REAL_64
			l_result_c1: PD_GSL_SF_RESULT_STRUCT
			l_result_c2: PD_GSL_SF_RESULT_STRUCT
			l_c0___1: REAL_64
			l_t___0: REAL_64
			l_result_c1___0: PD_GSL_SF_RESULT_STRUCT
			l_tmp___5: REAL_64
			js: JUMP_STATE
		do
			create l_result_c1.make
			create l_result_c2.make
			create l_result_c1___0.make

			if a_x < 0.0 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("synchrotron.c"), 187, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_x < (2.0 * 1.41421356237309504880) * 1.4901161193847656e-08 then
				l_z := (pow (a_x, 1.0 / 3.0))
				l_cf := (1).to_double - (8.43812762813205e-01 * l_z) * l_z
				a_result.item.val := (2.14952824153447863671 * l_z) * l_cf
				a_result.item.err := 2.2204460492503131e-16 * a_result.item.val
				Result := 0
				js.return
			elseif a_x <= 4.0 then
				l_c0___0 := 3.14159265358979323846 / 1.73205080756887729352744634151
				l_px := (pow (a_x, 1.0 / 3.0))
				l_px11 := (pow_int_inst.gsl_sf_pow_int (l_px, 11))
				l_t := (a_x * a_x) / 8.0 - 1.0
				cheb_eval_inst.cheb_eval_e ((synchrotron1_cs.address), l_t, l_result_c1.address).do_nothing
				cheb_eval_inst.cheb_eval_e ((synchrotron2_cs.address), l_t, l_result_c2.address).do_nothing
				a_result.item.val := (l_px * l_result_c1.val - l_px11 * l_result_c2.val) - l_c0___0 * a_x
				a_result.item.err := (l_px * l_result_c1.err + l_px11 * l_result_c2.err) + (l_c0___0 * a_x) * 2.2204460492503131e-16
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
				js.return
			elseif a_x < (-8.0 * -7.0839641853226408e+02) / 7.0 then
				l_c0___1 := 0.2257913526447274323630976
				l_t___0 := (12.0 - a_x) / (a_x + 4.0)
				cheb_eval_inst.cheb_eval_e ((synchrotron1a_cs.address), l_t___0, l_result_c1___0.address).do_nothing
				l_tmp___5 := sqrt (a_x)
				a_result.item.val := (l_tmp___5 * l_result_c1___0.val) * (exp (l_c0___1 - a_x))
				a_result.item.err := ((2.0 * 2.2204460492503131e-16) * a_result.item.val) * ((fabs (l_c0___1 - a_x)) + 1.0)
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := 0.0
					a_result.item.err := 2.2250738585072014e-308
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("synchrotron.c"), 223, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_synchrotron_2_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_z: REAL_64
			l_cf: REAL_64
			l_px: REAL_64
			l_px5: REAL_64
			l_t: REAL_64
			l_cheb1: PD_GSL_SF_RESULT_STRUCT
			l_cheb2: PD_GSL_SF_RESULT_STRUCT
			l_c0___0: REAL_64
			l_t___0: REAL_64
			l_cheb1___0: PD_GSL_SF_RESULT_STRUCT
			l_tmp___5: REAL_64
			js: JUMP_STATE
		do
			create l_cheb1.make
			create l_cheb2.make
			create l_cheb1___0.make

			if a_x < 0.0 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("synchrotron.c"), 233, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_x < (2.0 * 1.41421356237309504880) * 1.4901161193847656e-08 then
				l_z := (pow (a_x, 1.0 / 3.0))
				l_cf := (1).to_double - (1.17767156510235e+00 * l_z) * a_x
				a_result.item.val := (1.07476412076723931836 * l_z) * l_cf
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * a_result.item.val
				Result := 0
				js.return
			elseif a_x <= 4.0 then
				l_px := (pow (a_x, 1.0 / 3.0))
				l_px5 := (pow_int_inst.gsl_sf_pow_int (l_px, 5))
				l_t := (a_x * a_x) / 8.0 - 1.0
				cheb_eval_inst.cheb_eval_e ((synchrotron21_cs.address), l_t, l_cheb1.address).do_nothing
				cheb_eval_inst.cheb_eval_e ((synchrotron22_cs.address), l_t, l_cheb2.address).do_nothing
				a_result.item.val := l_px * l_cheb1.val - l_px5 * l_cheb2.val
				a_result.item.err := l_px * l_cheb1.err + l_px5 * l_cheb2.err
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
				js.return
			elseif a_x < (-8.0 * -7.0839641853226408e+02) / 7.0 then
				l_c0___0 := 0.22579135264472743236
				l_t___0 := (10.0 - a_x) / (a_x + 2.0)
				cheb_eval_inst.cheb_eval_e ((synchrotron2a_cs.address), l_t___0, l_cheb1___0.address).do_nothing
				l_tmp___5 := sqrt (a_x)
				a_result.item.val := (l_tmp___5 * (exp (l_c0___0 - a_x))) * l_cheb1___0.val
				a_result.item.err := (2.2204460492503131e-16 * a_result.item.val) * ((fabs (l_c0___0 - a_x)) + 1.0)
				Result := 0
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := 0.0
					a_result.item.err := 2.2250738585072014e-308
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("synchrotron.c"), 269, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_synchrotron_1 (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_synchrotron_1_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_synchrotron_1_e(x, &result)"), ce_string ("synchrotron.c"), 279, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_synchrotron_2 (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_synchrotron_2_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_synchrotron_2_e(x, &result)"), ce_string ("synchrotron.c"), 284, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
