class
	P_TRANSPORT

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create transport2_data.make (<<18>>)
			create transport2_cs.make
			create transport3_data.make (<<18>>)
			create transport3_cs.make
			create transport4_data.make (<<18>>)
			create transport4_cs.make
			create transport5_data.make (<<18>>)
			create transport5_cs.make
		end

feature {ANY} -- attributes

	transport2_data: CE_ARRAY [REAL_64]

	transport2_cs: PD_CHEB_SERIES_STRUCT

	transport3_data: CE_ARRAY [REAL_64]

	transport3_cs: PD_CHEB_SERIES_STRUCT

	transport4_data: CE_ARRAY [REAL_64]

	transport4_cs: PD_CHEB_SERIES_STRUCT

	transport5_data: CE_ARRAY [REAL_64]

	transport5_cs: PD_CHEB_SERIES_STRUCT

feature {ANY} -- routines

	transport_sumexp (a_numexp: INTEGER_32; a_order: INTEGER_32; a_t: REAL_64; a_x: REAL_64): REAL_64
		local
			l_rk: REAL_64
			l_sumexp: REAL_64
			l_k: INTEGER_32
			l_sum2: REAL_64
			l_xk: REAL_64
			l_xk1: REAL_64
			l_j: INTEGER_32
			js: JUMP_STATE
		do
			l_rk := a_numexp.to_double
			l_sumexp := 0.0
			l_k := 1
			from
			until
				not (not js.loop_left and then (l_k <= a_numexp))
			loop
				l_sum2 := 1.0
				l_xk := 1.0 / (l_rk * a_x)
				l_xk1 := 1.0
				l_j := 1
				from
				until
					not (l_j <= a_order)
				loop
					l_sum2 := (l_sum2 * l_xk1) * l_xk + 1.0
					l_xk1 := l_xk1 + (1.0)
					l_j := l_j + 1
				end
				l_sumexp := l_sumexp * a_t
				l_sumexp := l_sumexp + l_sum2
				l_rk := l_rk - (1.0)
				l_k := l_k + 1
			end
			Result := l_sumexp
		end

	gsl_sf_transport_2_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_val_infinity: REAL_64
			l_t: REAL_64
			l_result_c: PD_GSL_SF_RESULT_STRUCT
			l_numexp: INTEGER_32
			l_sumexp: REAL_64
			l_t___0: REAL_64
			l_tmp___5: REAL_64
			l_et: REAL_64
			l_numexp___0: INTEGER_32
			l_sumexp___0: REAL_64
			l_t___1: REAL_64
			l_tmp___10: REAL_64
			l_et___0: REAL_64
			l_t___2: REAL_64
			l_et___1: REAL_64
			js: JUMP_STATE
		do
			create l_result_c.make

			l_val_infinity := 3.289868133696452873
			if a_x < 0.0 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("transport.c"), 178, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_x < 3.0 * 1.4901161193847656e-08 then
				a_result.item.val := a_x
				a_result.item.err := 2.2204460492503131e-16 * (fabs (a_x)) + (a_x * a_x) / 2.0
				Result := 0
				js.return
			elseif a_x <= 4.0 then
				l_t := ((a_x * a_x) / 8.0 - 0.5) - 0.5
				cheb_eval_inst.cheb_eval_e ((transport2_cs.address), l_t, l_result_c.address).do_nothing
				a_result.item.val := a_x * l_result_c.val
				a_result.item.err := a_x * l_result_c.err
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
				js.return
			elseif a_x < -(-3.6043653389117154e+01) then
				l_numexp := (-(-3.6043653389117154e+01) / a_x).truncated_to_integer + 1
				l_sumexp := (transport_sumexp (l_numexp, 2, (exp (-a_x)), a_x))
				l_tmp___5 := log (a_x)
				l_t___0 := (2.0 * l_tmp___5 - a_x) + (log (l_sumexp))
				if l_t___0 < -3.6043653389117154e+01 then
					a_result.item.val := l_val_infinity
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * l_val_infinity
				else
					l_et := (exp (l_t___0))
					a_result.item.val := l_val_infinity - l_et
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * (l_val_infinity + (fabs (l_t___0)) * l_et)
				end
				Result := 0
				js.return
			elseif a_x < 2.0 / 2.2204460492503131e-16 then
				l_numexp___0 := 1
				l_sumexp___0 := (transport_sumexp (l_numexp___0, 2, 1.0, a_x))
				l_tmp___10 := log (a_x)
				l_t___1 := (2.0 * l_tmp___10 - a_x) + (log (l_sumexp___0))
				if l_t___1 < -3.6043653389117154e+01 then
					a_result.item.val := l_val_infinity
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * l_val_infinity
				else
					l_et___0 := (exp (l_t___1))
					a_result.item.val := l_val_infinity - l_et___0
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * (l_val_infinity + ((fabs (l_t___1)) + 1.0) * l_et___0)
				end
				Result := 0
				js.return
			else
				l_t___2 := 2.0 * (log (a_x)) - a_x
				if l_t___2 < -3.6043653389117154e+01 then
					a_result.item.val := l_val_infinity
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * l_val_infinity
				else
					l_et___1 := (exp (l_t___2))
					a_result.item.val := l_val_infinity - l_et___1
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * (l_val_infinity + ((fabs (l_t___2)) + 1.0) * l_et___1)
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_transport_3_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_val_infinity: REAL_64
			l_x2___1: REAL_64
			l_t: REAL_64
			l_result_c: PD_GSL_SF_RESULT_STRUCT
			l_numexp: INTEGER_32
			l_sumexp: REAL_64
			l_t___0: REAL_64
			l_tmp___5: REAL_64
			l_et: REAL_64
			l_numexp___0: INTEGER_32
			l_sumexp___0: REAL_64
			l_t___1: REAL_64
			l_tmp___10: REAL_64
			l_et___0: REAL_64
			l_t___2: REAL_64
			l_et___1: REAL_64
			js: JUMP_STATE
		do
			create l_result_c.make

			l_val_infinity := 7.212341418957565712
			if a_x < 0.0 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("transport.c"), 248, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_x = 0.0 then
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				Result := 0
				js.return
			elseif a_x < 3.0 * 1.4901161193847656e-08 then
				a_result.item.val := (0.5 * a_x) * a_x
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * a_result.item.val
				if (fabs (a_result.item.val)) < 2.2250738585072014e-308 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("transport.c"), 258, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
				if not js.return_called then
					Result := 0
					js.return
				end
			elseif a_x <= 4.0 then
				l_x2___1 := a_x * a_x
				l_t := (l_x2___1 / 8.0 - 0.5) - 0.5
				cheb_eval_inst.cheb_eval_e ((transport3_cs.address), l_t, l_result_c.address).do_nothing
				a_result.item.val := l_x2___1 * l_result_c.val
				a_result.item.err := l_x2___1 * l_result_c.err
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				Result := 0
				js.return
			elseif a_x < -(-3.6043653389117154e+01) then
				l_numexp := (-(-3.6043653389117154e+01) / a_x).truncated_to_integer + 1
				l_sumexp := (transport_sumexp (l_numexp, 3, (exp (-a_x)), a_x))
				l_tmp___5 := log (a_x)
				l_t___0 := (3.0 * l_tmp___5 - a_x) + (log (l_sumexp))
				if l_t___0 < -3.6043653389117154e+01 then
					a_result.item.val := l_val_infinity
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * l_val_infinity
				else
					l_et := (exp (l_t___0))
					a_result.item.val := l_val_infinity - l_et
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * (l_val_infinity + (fabs (l_t___0)) * l_et)
				end
				Result := 0
				js.return
			elseif a_x < 3.0 / 2.2204460492503131e-16 then
				l_numexp___0 := 1
				l_sumexp___0 := (transport_sumexp (l_numexp___0, 3, 1.0, a_x))
				l_tmp___10 := log (a_x)
				l_t___1 := (3.0 * l_tmp___10 - a_x) + (log (l_sumexp___0))
				if l_t___1 < -3.6043653389117154e+01 then
					a_result.item.val := l_val_infinity
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * l_val_infinity
				else
					l_et___0 := (exp (l_t___1))
					a_result.item.val := l_val_infinity - l_et___0
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * (l_val_infinity + ((fabs (l_t___1)) + 1.0) * l_et___0)
				end
				Result := 0
				js.return
			else
				l_t___2 := 3.0 * (log (a_x)) - a_x
				if l_t___2 < -3.6043653389117154e+01 then
					a_result.item.val := l_val_infinity
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * l_val_infinity
				else
					l_et___1 := (exp (l_t___2))
					a_result.item.val := l_val_infinity - l_et___1
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * (l_val_infinity + ((fabs (l_t___2)) + 1.0) * l_et___1)
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_transport_4_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_val_infinity: REAL_64
			l_x2___1: REAL_64
			l_t: REAL_64
			l_result_c: PD_GSL_SF_RESULT_STRUCT
			l_numexp: INTEGER_32
			l_sumexp: REAL_64
			l_t___0: REAL_64
			l_tmp___5: REAL_64
			l_et: REAL_64
			l_numexp___0: INTEGER_32
			l_sumexp___0: REAL_64
			l_t___1: REAL_64
			l_tmp___10: REAL_64
			l_et___0: REAL_64
			l_t___2: REAL_64
			l_et___1: REAL_64
			js: JUMP_STATE
		do
			create l_result_c.make

			l_val_infinity := 25.97575760906731660
			if a_x < 0.0 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("transport.c"), 325, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_x = 0.0 then
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				Result := 0
				js.return
			elseif a_x < 3.0 * 1.4901161193847656e-08 then
				a_result.item.val := ((a_x * a_x) * a_x) / 3.0
				a_result.item.err := (3.0 * 2.2204460492503131e-16) * a_result.item.val
				if (fabs (a_result.item.val)) < 2.2250738585072014e-308 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("transport.c"), 335, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
				if not js.return_called then
					Result := 0
					js.return
				end
			elseif a_x <= 4.0 then
				l_x2___1 := a_x * a_x
				l_t := (l_x2___1 / 8.0 - 0.5) - 0.5
				cheb_eval_inst.cheb_eval_e ((transport4_cs.address), l_t, l_result_c.address).do_nothing
				a_result.item.val := (l_x2___1 * a_x) * l_result_c.val
				a_result.item.err := (l_x2___1 * a_x) * l_result_c.err
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
				js.return
			elseif a_x < -(-3.6043653389117154e+01) then
				l_numexp := (-(-3.6043653389117154e+01) / a_x).truncated_to_integer + 1
				l_sumexp := (transport_sumexp (l_numexp, 4, (exp (-a_x)), a_x))
				l_tmp___5 := log (a_x)
				l_t___0 := (4.0 * l_tmp___5 - a_x) + (log (l_sumexp))
				if l_t___0 < -3.6043653389117154e+01 then
					a_result.item.val := l_val_infinity
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * l_val_infinity
				else
					l_et := (exp (l_t___0))
					a_result.item.val := l_val_infinity - l_et
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * (l_val_infinity + ((fabs (l_t___0)) + 1.0) * l_et)
				end
				Result := 0
				js.return
			elseif a_x < 3.0 / 2.2204460492503131e-16 then
				l_numexp___0 := 1
				l_sumexp___0 := (transport_sumexp (l_numexp___0, 4, 1.0, a_x))
				l_tmp___10 := log (a_x)
				l_t___1 := (4.0 * l_tmp___10 - a_x) + (log (l_sumexp___0))
				if l_t___1 < -3.6043653389117154e+01 then
					a_result.item.val := l_val_infinity
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * l_val_infinity
				else
					l_et___0 := (exp (l_t___1))
					a_result.item.val := l_val_infinity - l_et___0
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * (l_val_infinity + ((fabs (l_t___1)) + 1.0) * l_et___0)
				end
				Result := 0
				js.return
			else
				l_t___2 := 4.0 * (log (a_x)) - a_x
				if l_t___2 < -3.6043653389117154e+01 then
					a_result.item.val := l_val_infinity
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * l_val_infinity
				else
					l_et___1 := (exp (l_t___2))
					a_result.item.val := l_val_infinity - l_et___1
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * (l_val_infinity + ((fabs (l_t___2)) + 1.0) * l_et___1)
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_transport_5_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_val_infinity: REAL_64
			l_x2___1: REAL_64
			l_t: REAL_64
			l_result_c: PD_GSL_SF_RESULT_STRUCT
			l_numexp: INTEGER_32
			l_sumexp: REAL_64
			l_t___0: REAL_64
			l_tmp___5: REAL_64
			l_et: REAL_64
			l_numexp___0: INTEGER_32
			l_sumexp___0: REAL_64
			l_t___1: REAL_64
			l_tmp___10: REAL_64
			l_et___0: REAL_64
			l_t___2: REAL_64
			l_et___1: REAL_64
			js: JUMP_STATE
		do
			create l_result_c.make

			l_val_infinity := 124.4313306172043912
			if a_x < 0.0 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("transport.c"), 402, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_x = 0.0 then
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				Result := 0
				js.return
			elseif a_x < 3.0 * 1.4901161193847656e-08 then
				a_result.item.val := (((a_x * a_x) * a_x) * a_x) / 4.0
				a_result.item.err := (4.0 * 2.2204460492503131e-16) * a_result.item.val
				if (fabs (a_result.item.val)) < 2.2250738585072014e-308 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("transport.c"), 412, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
				if not js.return_called then
					Result := 0
					js.return
				end
			elseif a_x <= 4.0 then
				l_x2___1 := a_x * a_x
				l_t := (l_x2___1 / 8.0 - 0.5) - 0.5
				cheb_eval_inst.cheb_eval_e ((transport5_cs.address), l_t, l_result_c.address).do_nothing
				a_result.item.val := (l_x2___1 * l_x2___1) * l_result_c.val
				a_result.item.err := (l_x2___1 * l_x2___1) * l_result_c.err
				a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := 0
				js.return
			elseif a_x < -(-3.6043653389117154e+01) then
				l_numexp := (-(-3.6043653389117154e+01) / a_x).truncated_to_integer + 1
				l_sumexp := (transport_sumexp (l_numexp, 5, (exp (-a_x)), a_x))
				l_tmp___5 := log (a_x)
				l_t___0 := (5.0 * l_tmp___5 - a_x) + (log (l_sumexp))
				if l_t___0 < -3.6043653389117154e+01 then
					a_result.item.val := l_val_infinity
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * l_val_infinity
				else
					l_et := (exp (l_t___0))
					a_result.item.val := l_val_infinity - l_et
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * (l_val_infinity + ((fabs (l_t___0)) + 1.0) * l_et)
				end
				Result := 0
				js.return
			elseif a_x < 3.0 / 2.2204460492503131e-16 then
				l_numexp___0 := 1
				l_sumexp___0 := (transport_sumexp (l_numexp___0, 5, 1.0, a_x))
				l_tmp___10 := log (a_x)
				l_t___1 := (5.0 * l_tmp___10 - a_x) + (log (l_sumexp___0))
				if l_t___1 < -3.6043653389117154e+01 then
					a_result.item.val := l_val_infinity
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * l_val_infinity
				else
					l_et___0 := (exp (l_t___1))
					a_result.item.val := l_val_infinity - l_et___0
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * (l_val_infinity + ((fabs (l_t___1)) + 1.0) * l_et___0)
				end
				Result := 0
				js.return
			else
				l_t___2 := 5.0 * (log (a_x)) - a_x
				if l_t___2 < -3.6043653389117154e+01 then
					a_result.item.val := l_val_infinity
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * l_val_infinity
				else
					l_et___1 := (exp (l_t___2))
					a_result.item.val := l_val_infinity - l_et___1
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * (l_val_infinity + ((fabs (l_t___2)) + 1.0) * l_et___1)
				end
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_transport_2 (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_transport_2_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_transport_2_e(x, &result)"), ce_string ("transport.c"), 476, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_transport_3 (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_transport_3_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_transport_3_e(x, &result)"), ce_string ("transport.c"), 481, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_transport_4 (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_transport_4_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_transport_4_e(x, &result)"), ce_string ("transport.c"), 486, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

	gsl_sf_transport_5 (a_x: REAL_64): REAL_64
		local
			l_result: PD_GSL_SF_RESULT_STRUCT
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make

			l_status := (gsl_sf_transport_5_e (a_x, l_result.address))
			if l_status /= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("gsl_sf_transport_5_e(x, &result)"), ce_string ("transport.c"), 491, l_status)
					Result := (l_result.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (l_result.val)
			end
		end

end
