class
	P_TRANSPUTER

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create transputer_type.make
			create gsl_rng_transputer.make
		end

feature {ANY} -- attributes

	transputer_type: PD_GSL_RNG_TYPE

	gsl_rng_transputer: CE_POINTER [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	transputer_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_TRANSPUTER_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_TRANSPUTER_STATE_T]}.make_cast (a_vstate))
			l_state.item.x := ({NATURAL_32} 1664525 * l_state.item.x).bit_and ({NATURAL_32} 4294967295)
			Result := (l_state.item.x)
		end

	transputer_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent transputer_get)
		end

	transputer_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((transputer_get (a_vstate)).to_real_64 / 4294967296.0)
		end

	transputer_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent transputer_get_double)
		end

	transputer_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_TRANSPUTER_STATE_T]
		do
			create l_state.make

			l_s := a_s
			l_state.ce_gets (create {CE_POINTER [PD_TRANSPUTER_STATE_T]}.make_cast (a_vstate))
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.x := l_s
		end

	transputer_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent transputer_set)
		end

end
