class
	P_TT

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create tt_type.make
			create gsl_rng_tt800.make
		end

feature {ANY} -- attributes

	tt_type: PD_GSL_RNG_TYPE

	gsl_rng_tt800: CE_POINTER [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	tt_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_TT_STATE_T]
			l_mag01: CE_ARRAY [NATURAL_32]
			l_y: NATURAL_32
			l_x: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_i: INTEGER_32
		do
			create l_state.make
			create l_mag01.make (<<2>>)
			create l_x.make

			l_state.ce_gets (create {CE_POINTER [PD_TT_STATE_T]}.make_cast (a_vstate))
			l_mag01[0] := {NATURAL_32} 0
			l_mag01[1] := {NATURAL_32} 2394935336
			l_x.ce_gets (l_state.item.x)
			l_n := l_state.item.n
			if l_n >= 25 then
				l_i := 0
				from
				until
					not (l_i < 18)
				loop
					l_x[l_i] := (((l_x[(l_i + 7)]).bit_xor (((l_x[l_i]).bit_shift_right (1))))).bit_xor (l_mag01[(l_x[l_i] \\ {NATURAL_32} 2).to_integer_32])
					l_i := l_i + 1
				end
				from
				until
					not (l_i < 25)
				loop
					l_x[l_i] := (((l_x[(l_i + -18)]).bit_xor (((l_x[l_i]).bit_shift_right (1))))).bit_xor (l_mag01[(l_x[l_i] \\ {NATURAL_32} 2).to_integer_32])
					l_i := l_i + 1
				end
				l_n := 0
			end
			l_y := l_x[l_n]
			l_y := (l_y).bit_xor (((((l_y).bit_shift_left (7))).bit_and ({NATURAL_32} 727393536)))
			l_y := (l_y).bit_xor (((((l_y).bit_shift_left (15))).bit_and ({NATURAL_32} 3683319808)))
			l_y := (l_y).bit_and (({NATURAL_32} 4294967295))
			l_y := (l_y).bit_xor (((l_y).bit_shift_right (16)))
			l_state.item.n := l_n + 1
			Result := l_y
		end

	tt_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent tt_get)
		end

	tt_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((tt_get (a_vstate)).to_real_64 / 4294967296.0)
		end

	tt_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent tt_get_double)
		end

	tt_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_TT_STATE_T]
			l_init_state: PD_TT_STATE_T
			l_i: INTEGER_32
		do
			create l_state.make
			create l_init_state.make

			l_state.ce_gets (create {CE_POINTER [PD_TT_STATE_T]}.make_cast (a_vstate))
			l_init_state.n := 0
			l_init_state.x[0] := {NATURAL_32} 2515684779
			l_init_state.x[1] := {NATURAL_32} 191386133
			l_init_state.x[2] := {NATURAL_32} 3882666727
			l_init_state.x[3] := {NATURAL_32} 2940125753
			l_init_state.x[4] := {NATURAL_32} 1902095651
			l_init_state.x[5] := {NATURAL_32} 614830253
			l_init_state.x[6] := {NATURAL_32} 1776596463
			l_init_state.x[7] := {NATURAL_32} 3208995137
			l_init_state.x[8] := {NATURAL_32} 2528910203
			l_init_state.x[9] := {NATURAL_32} 2814244901
			l_init_state.x[10] := {NATURAL_32} 3252581815
			l_init_state.x[11] := {NATURAL_32} 2287512009
			l_init_state.x[12] := {NATURAL_32} 766015123
			l_init_state.x[13] := {NATURAL_32} 3059218909
			l_init_state.x[14] := {NATURAL_32} 4292643487
			l_init_state.x[15] := {NATURAL_32} 2166479473
			l_init_state.x[16] := {NATURAL_32} 2340568779
			l_init_state.x[17] := {NATURAL_32} 2287797749
			l_init_state.x[18] := {NATURAL_32} 1310772551
			l_init_state.x[19] := {NATURAL_32} 1520096729
			l_init_state.x[20] := {NATURAL_32} 1361841155
			l_init_state.x[21] := {NATURAL_32} 3934616781
			l_init_state.x[22] := {NATURAL_32} 1287770895
			l_init_state.x[23] := {NATURAL_32} 2291247265
			l_init_state.x[24] := {NATURAL_32} 2797054683
			if a_s = {NATURAL_32} 0 then
				l_state.item := l_init_state
			else
				l_state.item.n := 0
				l_state.item.x[0] := (a_s).bit_and ({NATURAL_32} 4294967295)
				l_i := 1
				from
				until
					not (l_i < 25)
				loop
					l_state.item.x[l_i] := ({NATURAL_32} 69069 * l_state.item.x[l_i - 1]).bit_and ({NATURAL_32} 4294967295)
					l_i := l_i + 1
				end
			end
		end

	tt_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent tt_set)
		end

end
