class
	P_UNI

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create uni_type.make
			create gsl_rng_uni.make
		end

feature {ANY} -- attributes

	m1___1: NATURAL_32 assign set_m1___1

	set_m1___1 (a_m1___1: NATURAL_32)
		do
			m1___1 := a_m1___1
		end

	m2___1: NATURAL_32 assign set_m2___1

	set_m2___1 (a_m2___1: NATURAL_32)
		do
			m2___1 := a_m2___1
		end

	uni_type: PD_GSL_RNG_TYPE

	gsl_rng_uni: CE_POINTER [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	uni_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_UNI_STATE_T]
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_UNI_STATE_T]}.make_cast (a_vstate))
			l_i := l_state.item.i
			l_j := l_state.item.j
			l_k := (l_state.item.m[l_i] - l_state.item.m[l_j]).to_integer_32
			if l_k < 0 then
				l_k := (l_k.to_natural_32 + m1___1.to_natural_32).to_integer_32
			end
			l_state.item.m[l_j] := l_k.to_natural_32
			if l_i = 0 then
				l_state.item.i := 16
			else
				l_state.item.i := (l_state.item.i) - 1
			end
			if l_j = 0 then
				l_state.item.j := 16
			else
				l_state.item.j := (l_state.item.j) - 1
			end
			Result := l_k.to_natural_32
		end

	uni_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent uni_get)
		end

	uni_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((uni_get (a_vstate)).to_real_64 / 32767.0)
		end

	uni_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent uni_get_double)
		end

	uni_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_i: NATURAL_32
			l_seed: NATURAL_32
			l_k0: NATURAL_32
			l_k1: NATURAL_32
			l_j0: NATURAL_32
			l_j1: NATURAL_32
			l_state: CE_POINTER [PD_UNI_STATE_T]
		do
			create l_state.make

			l_s := a_s
			l_state.ce_gets (create {CE_POINTER [PD_UNI_STATE_T]}.make_cast (a_vstate))
			l_s := {NATURAL_32} 2 * l_s + {NATURAL_32} 1
			if l_s < m1___1.to_natural_32 then
				l_seed := l_s.to_natural_32
			else
				l_seed := m1___1
			end
			l_k0 := {NATURAL_32} 9069 \\ m2___1
			l_k1 := {NATURAL_32} 9069 // m2___1
			l_j0 := l_seed \\ m2___1
			l_j1 := l_seed // m2___1
			l_i := {NATURAL_32} 0
			from
			until
				not (l_i < {NATURAL_32} 17)
			loop
				l_seed := l_j0 * l_k0
				l_j1 := ((l_seed // m2___1 + l_j0 * l_k1) + l_j1 * l_k0) \\ (m2___1 // {NATURAL_32} 2)
				l_j0 := l_seed \\ m2___1
				l_state.item.m[l_i.to_integer_32] := (l_j0 + (m2___1 * l_j1)).to_natural_32
				l_i := l_i + 1
			end
			l_state.item.i := 4
			l_state.item.j := 16
		end

	uni_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent uni_set)
		end

end
