class
	P_UTIL

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	update (a_workspace: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]; a_a1___4: REAL_64; a_b1___0: REAL_64; a_area1: REAL_64; a_error1: REAL_64; a_a2___3: REAL_64; a_b2: REAL_64; a_area2: REAL_64; a_error2: REAL_64)
		local
			l_alist: CE_POINTER [REAL_64]
			l_blist: CE_POINTER [REAL_64]
			l_rlist: CE_POINTER [REAL_64]
			l_elist: CE_POINTER [REAL_64]
			l_level: CE_POINTER [NATURAL_32]
			l_i_max: NATURAL_32
			l_i_new: NATURAL_32
			l_new_level: NATURAL_32
		do
			create l_alist.make
			create l_blist.make
			create l_rlist.make
			create l_elist.make
			create l_level.make

			l_alist.ce_gets (a_workspace.item.alist)
			l_blist.ce_gets (a_workspace.item.blist)
			l_rlist.ce_gets (a_workspace.item.rlist)
			l_elist.ce_gets (a_workspace.item.elist)
			l_level.ce_gets (a_workspace.item.level)
			l_i_max := a_workspace.item.i
			l_i_new := a_workspace.item.size
			l_new_level := a_workspace.item.level[l_i_max.to_integer_32] + {NATURAL_32} 1
			if a_error2 > a_error1 then
				l_alist[l_i_max.to_integer_32] := a_a2___3
				l_rlist[l_i_max.to_integer_32] := a_area2
				l_elist[l_i_max.to_integer_32] := a_error2
				l_level[l_i_max.to_integer_32] := l_new_level
				l_alist[l_i_new.to_integer_32] := a_a1___4
				l_blist[l_i_new.to_integer_32] := a_b1___0
				l_rlist[l_i_new.to_integer_32] := a_area1
				l_elist[l_i_new.to_integer_32] := a_error1
				l_level[l_i_new.to_integer_32] := l_new_level
			else
				l_blist[l_i_max.to_integer_32] := a_b1___0
				l_rlist[l_i_max.to_integer_32] := a_area1
				l_elist[l_i_max.to_integer_32] := a_error1
				l_level[l_i_max.to_integer_32] := l_new_level
				l_alist[l_i_new.to_integer_32] := a_a2___3
				l_blist[l_i_new.to_integer_32] := a_b2
				l_rlist[l_i_new.to_integer_32] := a_area2
				l_elist[l_i_new.to_integer_32] := a_error2
				l_level[l_i_new.to_integer_32] := l_new_level
			end
			a_workspace.item.size := (a_workspace.item.size) + 1
			if l_new_level > a_workspace.item.maximum_level then
				a_workspace.item.maximum_level := l_new_level
			end
			qpsrt_inst.qpsrt (a_workspace)
		end

	retrieve (a_workspace: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]; a_a___5: CE_POINTER [REAL_64]; a_b___0: CE_POINTER [REAL_64]; a_r___3: CE_POINTER [REAL_64]; a_e: CE_POINTER [REAL_64])
		local
			l_i: NATURAL_32
			l_alist: CE_POINTER [REAL_64]
			l_blist: CE_POINTER [REAL_64]
			l_rlist: CE_POINTER [REAL_64]
			l_elist: CE_POINTER [REAL_64]
		do
			create l_alist.make
			create l_blist.make
			create l_rlist.make
			create l_elist.make

			l_i := a_workspace.item.i
			l_alist.ce_gets (a_workspace.item.alist)
			l_blist.ce_gets (a_workspace.item.blist)
			l_rlist.ce_gets (a_workspace.item.rlist)
			l_elist.ce_gets (a_workspace.item.elist)
			a_a___5.item := l_alist[l_i.to_integer_32]
			a_b___0.item := l_blist[l_i.to_integer_32]
			a_r___3.item := l_rlist[l_i.to_integer_32]
			a_e.item := l_elist[l_i.to_integer_32]
		end

	sum_results (a_workspace: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]): REAL_64
		local
			l_rlist: CE_POINTER [REAL_64]
			l_n: NATURAL_32
			l_k: NATURAL_32
			l_result_sum: REAL_64
		do
			create l_rlist.make

			l_rlist.ce_gets (a_workspace.item.rlist)
			l_n := a_workspace.item.size
			l_result_sum := (0).to_double
			l_k := (0).to_natural_32
			from
			until
				not (l_k < l_n)
			loop
				l_result_sum := l_result_sum + (l_rlist[l_k.to_integer_32])
				l_k := l_k + 1
			end
			Result := l_result_sum
		end

	subinterval_too_small (a_a1___4: REAL_64; a_a2___3: REAL_64; a_b2: REAL_64): INTEGER_32
		local
			l_e: REAL_64
			l_u: REAL_64
			l_tmp: REAL_64
			l_status: INTEGER_32
			l_tmp___3: INTEGER_32
		do
			l_e := 2.2204460492503131e-16
			l_u := 2.2250738585072014e-308
			l_tmp := ((1).to_double + (100).to_double * l_e) * ((fabs (a_a2___3)) + (1000).to_double * l_u)
			if (fabs (a_a1___4)) <= l_tmp then
				if (fabs (a_b2)) <= l_tmp then
					l_tmp___3 := 1
				else
					l_tmp___3 := 0
				end
			else
				l_tmp___3 := 0
			end
			l_status := l_tmp___3
			Result := l_status
		end

end
