class
	P_VECTOR_BFGS

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create vector_bfgs_type.make
			create gsl_multimin_fdfminimizer_vector_bfgs.make
		end

feature {ANY} -- attributes

	vector_bfgs_type: PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE

	gsl_multimin_fdfminimizer_vector_bfgs: CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE]

feature {ANY} -- routines

	vector_bfgs_alloc (a_vstate: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_VECTOR_BFGS_STATE_T]
			js: JUMP_STATE
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_VECTOR_BFGS_STATE_T]}.make_cast (a_vstate))
			l_state.item.x1 := init_source_inst.gsl_vector_calloc (a_n)
			if ((l_state.item.x1).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("failed to allocate space for x1"), ce_string ("vector_bfgs.c"), 58, 8)
					Result := 8
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_state.item.dx1 := init_source_inst.gsl_vector_calloc (a_n)
				if ((l_state.item.dx1).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_state.item.x1)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for dx1"), ce_string ("vector_bfgs.c"), 66, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.x2 := init_source_inst.gsl_vector_calloc (a_n)
				if ((l_state.item.x2).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_state.item.dx1)
					init_source_inst.gsl_vector_free (l_state.item.x1)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for x2"), ce_string ("vector_bfgs.c"), 75, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.p := init_source_inst.gsl_vector_calloc (a_n)
				if ((l_state.item.p).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_state.item.x2)
					init_source_inst.gsl_vector_free (l_state.item.dx1)
					init_source_inst.gsl_vector_free (l_state.item.x1)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for p"), ce_string ("vector_bfgs.c"), 85, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.x0 := init_source_inst.gsl_vector_calloc (a_n)
				if ((l_state.item.x0).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_state.item.p)
					init_source_inst.gsl_vector_free (l_state.item.x2)
					init_source_inst.gsl_vector_free (l_state.item.dx1)
					init_source_inst.gsl_vector_free (l_state.item.x1)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for g0"), ce_string ("vector_bfgs.c"), 96, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.g0 := init_source_inst.gsl_vector_calloc (a_n)
				if ((l_state.item.g0).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_state.item.x0)
					init_source_inst.gsl_vector_free (l_state.item.p)
					init_source_inst.gsl_vector_free (l_state.item.x2)
					init_source_inst.gsl_vector_free (l_state.item.dx1)
					init_source_inst.gsl_vector_free (l_state.item.x1)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for g0"), ce_string ("vector_bfgs.c"), 108, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.dx0 := init_source_inst.gsl_vector_calloc (a_n)
				if ((l_state.item.dx0).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_state.item.g0)
					init_source_inst.gsl_vector_free (l_state.item.x0)
					init_source_inst.gsl_vector_free (l_state.item.p)
					init_source_inst.gsl_vector_free (l_state.item.x2)
					init_source_inst.gsl_vector_free (l_state.item.dx1)
					init_source_inst.gsl_vector_free (l_state.item.x1)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for g0"), ce_string ("vector_bfgs.c"), 121, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.dg0 := init_source_inst.gsl_vector_calloc (a_n)
				if ((l_state.item.dg0).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_state.item.dx0)
					init_source_inst.gsl_vector_free (l_state.item.g0)
					init_source_inst.gsl_vector_free (l_state.item.x0)
					init_source_inst.gsl_vector_free (l_state.item.p)
					init_source_inst.gsl_vector_free (l_state.item.x2)
					init_source_inst.gsl_vector_free (l_state.item.dx1)
					init_source_inst.gsl_vector_free (l_state.item.x1)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for g0"), ce_string ("vector_bfgs.c"), 135, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	vector_bfgs_alloc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent vector_bfgs_alloc)
		end

	vector_bfgs_set (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [REAL_64]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_step_size: REAL_64; a_tol: REAL_64): INTEGER_32
		local
			l_state: CE_POINTER [PD_VECTOR_BFGS_STATE_T]
			l_gnorm: REAL_64
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_VECTOR_BFGS_STATE_T]}.make_cast (a_vstate))
			l_state.item.iter := 0
			l_state.item.step := a_step_size
			l_state.item.max_step := a_step_size
			l_state.item.tol := a_tol;
			(a_fdf.item.fdf).call ([a_x, a_fdf.item.params, a_f, a_gradient])
			copy_source_inst.gsl_vector_memcpy (l_state.item.x0, a_x).do_nothing
			copy_source_inst.gsl_vector_memcpy (l_state.item.p, a_gradient).do_nothing
			copy_source_inst.gsl_vector_memcpy (l_state.item.g0, a_gradient).do_nothing
			l_gnorm := (blas_inst.gsl_blas_dnrm2 (a_gradient))
			l_state.item.pnorm := l_gnorm
			l_state.item.g0norm := l_gnorm
			Result := 0
		end

	vector_bfgs_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent vector_bfgs_set)
		end

	vector_bfgs_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_VECTOR_BFGS_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_VECTOR_BFGS_STATE_T]}.make_cast (a_vstate))
			init_source_inst.gsl_vector_free (l_state.item.dg0)
			init_source_inst.gsl_vector_free (l_state.item.dx0)
			init_source_inst.gsl_vector_free (l_state.item.g0)
			init_source_inst.gsl_vector_free (l_state.item.x0)
			init_source_inst.gsl_vector_free (l_state.item.p)
			init_source_inst.gsl_vector_free (l_state.item.x2)
			init_source_inst.gsl_vector_free (l_state.item.dx1)
			init_source_inst.gsl_vector_free (l_state.item.x1)
		end

	vector_bfgs_free_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent vector_bfgs_free)
		end

	vector_bfgs_restart (a_vstate: CE_POINTER [ANY]): INTEGER_32
		local
			l_state: CE_POINTER [PD_VECTOR_BFGS_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_VECTOR_BFGS_STATE_T]}.make_cast (a_vstate))
			l_state.item.iter := 0
			Result := 0
		end

	vector_bfgs_restart_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent vector_bfgs_restart)
		end

	vector_bfgs_iterate (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [REAL_64]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_state: CE_POINTER [PD_VECTOR_BFGS_STATE_T]
			l_x1___0: CE_POINTER [PD_GSL_VECTOR]
			l_dx1: CE_POINTER [PD_GSL_VECTOR]
			l_x2___1: CE_POINTER [PD_GSL_VECTOR]
			l_p: CE_POINTER [PD_GSL_VECTOR]
			l_g0: CE_POINTER [PD_GSL_VECTOR]
			l_x0: CE_POINTER [PD_GSL_VECTOR]
			l_pnorm: REAL_64
			l_g0norm: REAL_64
			l_fa: REAL_64
			l_fb: REAL_64
			l_fc: REAL_64
			l_dir: REAL_64
			l_stepa: REAL_64
			l_stepb: REAL_64
			l_stepc: REAL_64
			l_tol: REAL_64
			l_g1norm: REAL_64
			l_pg: REAL_64
			l_dx0: CE_POINTER [PD_GSL_VECTOR]
			l_dg0: CE_POINTER [PD_GSL_VECTOR]
			l_dxg: REAL_64
			l_dgg: REAL_64
			l_dxdg: REAL_64
			l_dgnorm: REAL_64
			l_A___0: REAL_64
			l_B: REAL_64
			js: JUMP_STATE
		do
			create l_state.make
			create l_x1___0.make
			create l_dx1.make
			create l_x2___1.make
			create l_p.make
			create l_g0.make
			create l_x0.make
			create l_dx0.make
			create l_dg0.make

			l_state.ce_gets (create {CE_POINTER [PD_VECTOR_BFGS_STATE_T]}.make_cast (a_vstate))
			l_x1___0.ce_gets (l_state.item.x1)
			l_dx1.ce_gets (l_state.item.dx1)
			l_x2___1.ce_gets (l_state.item.x2)
			l_p.ce_gets (l_state.item.p)
			l_g0.ce_gets (l_state.item.g0)
			l_x0.ce_gets (l_state.item.x0)
			l_pnorm := l_state.item.pnorm
			l_g0norm := l_state.item.g0norm
			l_fa := a_f.item
			l_stepa := 0.0
			l_stepc := l_state.item.step
			l_tol := l_state.item.tol
			if l_pnorm = 0.0 then
				init_source_inst.gsl_vector_set_zero (a_dx)
				Result := 27
				js.return
			elseif l_g0norm = 0.0 then
				init_source_inst.gsl_vector_set_zero (a_dx)
				Result := 27
				js.return
			end
			if not js.return_called then
				blas_inst.gsl_blas_ddot (l_p, a_gradient, create {CE_POINTER [REAL_64]}.make_shared ($l_pg)).do_nothing
				if l_pg >= 0.0 then
					l_dir := 1.0
				else
					l_dir := -1.0
				end
				directional_minimize_inst.take_step (a_x, l_p, l_stepc, l_dir / l_pnorm, l_x1___0, a_dx)
				l_fc := (a_fdf.item.f).real_64_item ([l_x1___0, a_fdf.item.params])
				if l_fc < l_fa then
					l_state.item.step := l_stepc * 2.0
					a_f.item := l_fc
					copy_source_inst.gsl_vector_memcpy (a_x, l_x1___0).do_nothing;
					(a_fdf.item.df).call ([l_x1___0, a_fdf.item.params, a_gradient])
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				directional_minimize_inst.intermediate_point (a_fdf, a_x, l_p, l_dir / l_pnorm, l_pg, l_stepa, l_stepc, l_fa, l_fc, l_x1___0, l_dx1, a_gradient, create {CE_POINTER [REAL_64]}.make_shared ($l_stepb), create {CE_POINTER [REAL_64]}.make_shared ($l_fb))
				if l_stepb = 0.0 then
					Result := 27
					js.return
				end
			end
			if not js.return_called then
				directional_minimize_inst.minimize (a_fdf, a_x, l_p, l_dir / l_pnorm, l_stepa, l_stepb, l_stepc, l_fa, l_fb, l_fc, l_tol, l_x1___0, l_dx1, l_x2___1, a_dx, a_gradient, create {CE_POINTER [REAL_64]}.make_shared (l_state.c_pointer + {PD_VECTOR_BFGS_STATE_T}.step_offset), a_f, create {CE_POINTER [REAL_64]}.make_shared ($l_g1norm))
				copy_source_inst.gsl_vector_memcpy (a_x, l_x2___1).do_nothing
				l_state.item.iter := ((l_state.item.iter + 1).to_natural_32 \\ a_x.item.size).to_integer_32
				if l_state.item.iter = 0 then
					copy_source_inst.gsl_vector_memcpy (l_p, a_gradient).do_nothing
					l_state.item.pnorm := l_g1norm
				else
					l_dx0.ce_gets (l_state.item.dx0)
					l_dg0.ce_gets (l_state.item.dg0)
					copy_source_inst.gsl_vector_memcpy (l_dx0, a_x).do_nothing
					blas_inst.gsl_blas_daxpy (-1.0, l_x0, l_dx0).do_nothing
					copy_source_inst.gsl_vector_memcpy (l_dg0, a_gradient).do_nothing
					blas_inst.gsl_blas_daxpy (-1.0, l_g0, l_dg0).do_nothing
					blas_inst.gsl_blas_ddot (l_dx0, a_gradient, create {CE_POINTER [REAL_64]}.make_shared ($l_dxg)).do_nothing
					blas_inst.gsl_blas_ddot (l_dg0, a_gradient, create {CE_POINTER [REAL_64]}.make_shared ($l_dgg)).do_nothing
					blas_inst.gsl_blas_ddot (l_dx0, l_dg0, create {CE_POINTER [REAL_64]}.make_shared ($l_dxdg)).do_nothing
					l_dgnorm := blas_inst.gsl_blas_dnrm2 (l_dg0)
					if l_dxdg /= (0).to_double then
						l_B := l_dxg / l_dxdg
						l_A___0 := -(1.0 + (l_dgnorm * l_dgnorm) / l_dxdg) * l_B + l_dgg / l_dxdg
					else
						l_B := (0).to_double
						l_A___0 := (0).to_double
					end
					copy_source_inst.gsl_vector_memcpy (l_p, a_gradient).do_nothing
					blas_inst.gsl_blas_daxpy (-l_A___0, l_dx0, l_p).do_nothing
					blas_inst.gsl_blas_daxpy (-l_B, l_dg0, l_p).do_nothing
					l_state.item.pnorm := blas_inst.gsl_blas_dnrm2 (l_p)
				end
				copy_source_inst.gsl_vector_memcpy (l_g0, a_gradient).do_nothing
				copy_source_inst.gsl_vector_memcpy (l_x0, a_x).do_nothing
				l_state.item.g0norm := blas_inst.gsl_blas_dnrm2 (l_g0)
				Result := 0
			end
		end

	vector_bfgs_iterate_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent vector_bfgs_iterate)
		end

end
