class
	P_WEIBULL

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_ran_weibull (a_r___3: CE_POINTER [PD_GSL_RNG]; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_z: REAL_64
		do
			l_x := (gsl_gsl_rng_inst.gsl_rng_uniform_pos (a_r___3))
			l_z := (pow (-(log (l_x)), (1).to_double / a_b___0))
			Result := (a_a___5 * l_z)
		end

	gsl_ran_weibull_pdf (a_x: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_p: REAL_64
			l_tmp___0: REAL_64
		do
			if a_x < (0).to_double then
				Result := (0).to_double
			elseif a_x = (0).to_double then
				if a_b___0 = (1).to_double then
					Result := ((1).to_double / a_a___5)
				else
					Result := (0).to_double
				end
			elseif a_b___0 = (1).to_double then
				Result := ((exp (-a_x / a_a___5)) / a_a___5)
			else
				l_tmp___0 := pow (a_x / a_a___5, a_b___0)
				l_p := (a_b___0 / a_a___5) * (exp (-l_tmp___0 + (a_b___0 - (1).to_double) * (log (a_x / a_a___5))))
				Result := l_p
			end
		end

	gsl_cdf_weibull_P (a_x: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_P___2: REAL_64
		do
			l_P___2 := -(expm1 (-(pow (a_x / a_a___5, a_b___0))))
			Result := l_P___2
		end

	gsl_cdf_weibull_Q (a_x: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_Q___1: REAL_64
		do
			l_Q___1 := (exp (-(pow (a_x / a_a___5, a_b___0))))
			Result := l_Q___1
		end

end
