class
	P_WORKSPACE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_integration_workspace_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]
		local
			l_w: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]
			js: JUMP_STATE
		do
			create l_w.make

			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("workspace length n must be positive integer"), ce_string ("workspace.c"), 33, 1)
					Result := (create {CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_w.ce_gets (create {CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]}.make_cast ((malloc ({PD_GSL_INTEGRATION_WORKSPACE}.sizeof.to_natural_32))))
				if (l_w.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for workspace struct"), ce_string ("workspace.c"), 42, 8)
						Result := (create {CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_w.item.alist := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_n * Real_64_bytes.to_natural_32)))
				if ((l_w.item.alist).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for alist ranges"), ce_string ("workspace.c"), 52, 8)
						Result := (create {CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_w.item.blist := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_n * Real_64_bytes.to_natural_32)))
				if ((l_w.item.blist).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.alist))
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for blist ranges"), ce_string ("workspace.c"), 63, 8)
						Result := (create {CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_w.item.rlist := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_n * Real_64_bytes.to_natural_32)))
				if ((l_w.item.rlist).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.blist))
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.alist))
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for rlist ranges"), ce_string ("workspace.c"), 75, 8)
						Result := (create {CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_w.item.elist := create {CE_POINTER [REAL_64]}.make_cast ((malloc (a_n * Real_64_bytes.to_natural_32)))
				if ((l_w.item.elist).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.rlist))
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.blist))
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.alist))
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for elist ranges"), ce_string ("workspace.c"), 89, 8)
						Result := (create {CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_w.item.order := create {CE_POINTER [NATURAL_32]}.make_cast ((malloc (a_n * Natural_32_bytes.to_natural_32)))
				if ((l_w.item.order).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.elist))
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.rlist))
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.blist))
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.alist))
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for order ranges"), ce_string ("workspace.c"), 103, 8)
						Result := (create {CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_w.item.level := create {CE_POINTER [NATURAL_32]}.make_cast ((malloc (a_n * Natural_32_bytes.to_natural_32)))
				if ((l_w.item.level).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.order))
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.elist))
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.rlist))
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.blist))
					free (create {CE_POINTER [ANY]}.make_cast (l_w.item.alist))
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for order ranges"), ce_string ("workspace.c"), 118, 8)
						Result := (create {CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_w.item.size := (0).to_natural_32
				l_w.item.limit := a_n
				l_w.item.maximum_level := (0).to_natural_32
				Result := l_w
			end
		end

	gsl_integration_workspace_free (a_w: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE])
		local
			js: JUMP_STATE
		do
			if (a_w).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (a_w.item.level))
				free (create {CE_POINTER [ANY]}.make_cast (a_w.item.order))
				free (create {CE_POINTER [ANY]}.make_cast (a_w.item.elist))
				free (create {CE_POINTER [ANY]}.make_cast (a_w.item.rlist))
				free (create {CE_POINTER [ANY]}.make_cast (a_w.item.blist))
				free (create {CE_POINTER [ANY]}.make_cast (a_w.item.alist))
				free (create {CE_POINTER [ANY]}.make_cast (a_w))
			end
		end

end
