class
	P_ZHEMM

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_zhemm (a_Order: INTEGER_32; a_Side: INTEGER_32; a_Uplo: INTEGER_32; a_M: INTEGER_32; a_N: INTEGER_32; a_alpha: CE_POINTER [ANY]; a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32; a_B: CE_POINTER [ANY]; a_ldb: INTEGER_32; a_beta: CE_POINTER [ANY]; a_C: CE_POINTER [ANY]; a_ldc: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_n1: INTEGER_32
			l_n2: INTEGER_32
			l_uplo: INTEGER_32
			l_side: INTEGER_32
			l_alpha_real: REAL_64
			l_alpha_imag: REAL_64
			l_beta_real: REAL_64
			l_beta_imag: REAL_64
			l_Cij_real: REAL_64
			l_Cij_imag: REAL_64
			l_Bij_real: REAL_64
			l_Bij_imag: REAL_64
			l_temp1_real: REAL_64
			l_temp1_imag: REAL_64
			l_temp2_real: REAL_64
			l_temp2_imag: REAL_64
			l_Aii_real: REAL_64
			l_Aik_real: REAL_64
			l_Aik_imag: REAL_64
			l_Bkj_real: REAL_64
			l_Bkj_imag: REAL_64
			l_Bij_real___0: REAL_64
			l_Bij_imag___0: REAL_64
			l_temp1_real___0: REAL_64
			l_temp1_imag___0: REAL_64
			l_temp2_real___0: REAL_64
			l_temp2_imag___0: REAL_64
			l_Aik_real___0: REAL_64
			l_Aik_imag___0: REAL_64
			l_Bkj_real___0: REAL_64
			l_Bkj_imag___0: REAL_64
			l_Aii_real___0: REAL_64
			l_Bij_real___1: REAL_64
			l_Bij_imag___1: REAL_64
			l_temp1_real___1: REAL_64
			l_temp1_imag___1: REAL_64
			l_temp2_real___1: REAL_64
			l_temp2_imag___1: REAL_64
			l_Ajj_real: REAL_64
			l_Ajk_real: REAL_64
			l_Ajk_imag: REAL_64
			l_Bik_real: REAL_64
			l_Bik_imag: REAL_64
			l_Bij_real___2: REAL_64
			l_Bij_imag___2: REAL_64
			l_temp1_real___2: REAL_64
			l_temp1_imag___2: REAL_64
			l_temp2_real___2: REAL_64
			l_temp2_imag___2: REAL_64
			l_Ajk_real___0: REAL_64
			l_Ajk_imag___0: REAL_64
			l_Bik_real___0: REAL_64
			l_Bik_imag___0: REAL_64
			l_Ajj_real___0: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_alpha_real := create {CE_POINTER [REAL_64]}.make_cast (a_alpha)[0]
					l_alpha_imag := create {CE_POINTER [REAL_64]}.make_cast (a_alpha)[1]
					l_beta_real := create {CE_POINTER [REAL_64]}.make_cast (a_beta)[0]
					l_beta_imag := create {CE_POINTER [REAL_64]}.make_cast (a_beta)[1]
					if l_alpha_real = 0.0 then
						if l_alpha_imag = 0.0 then
							if l_beta_real = 1.0 then
								if l_beta_imag = 0.0 then
									js.return
								end
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if a_Order.to_natural_32 = {NATURAL_32} 101 then
							l_n1 := a_M
							l_n2 := a_N
							l_uplo := a_Uplo
							l_side := a_Side
						else
							l_n1 := a_N
							l_n2 := a_M
							if a_Uplo.to_natural_32 = {NATURAL_32} 121 then
								l_uplo := 122
							else
								l_uplo := 121
							end
							if a_Side.to_natural_32 = {NATURAL_32} 141 then
								l_side := 142
							else
								l_side := 141
							end
						end
						if l_beta_real /= 0.0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_beta_imag = 0.0 then
							l_i := 0
							from
							until
								not (not js.loop_left and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (l_j < l_n2)
								loop
									create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := 0.0
									create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := 0.0
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if l_beta_real /= 1.0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_beta_imag /= 0.0 then
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						l_i := 0
						from
						until
							not (not js.loop_left and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (l_j < l_n2)
							loop
								l_Cij_real := create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)]
								l_Cij_imag := create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)]
								create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := l_beta_real * l_Cij_real - l_beta_imag * l_Cij_imag
								create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := l_beta_real * l_Cij_imag + l_beta_imag * l_Cij_real
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 8 then -- if done
						if l_alpha_real = 0.0 then
							if l_alpha_imag = 0.0 then
								js.return
							end
						end
				when 9 then -- if done
					if js.return_called then
						l_pos := -1 + 20 -- skip if block
					end
				when 10 then -- if:
						if l_side /= 141 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if l_uplo = 121 then
							l_i := 0
							from
							until
								not (not js.loop_left and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (not js.loop_left and then (l_j < l_n2))
								loop
									l_Bij_real := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									l_temp1_real := l_alpha_real * l_Bij_real - l_alpha_imag * l_Bij_imag
									l_temp1_imag := l_alpha_real * l_Bij_imag + l_alpha_imag * l_Bij_real
									l_temp2_real := 0.0
									l_temp2_imag := 0.0
									l_Aii_real := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_i * a_lda + l_i)]
									create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_temp1_real * l_Aii_real)
									create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_temp1_imag * l_Aii_real)
									l_k := l_i + 1
									from
									until
										not (l_k < l_n1)
									loop
										l_Aik_real := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
										l_Aik_imag := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)]
										l_Bkj_real := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (a_ldb * l_k + l_j)]
										l_Bkj_imag := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (a_ldb * l_k + l_j) + 1)]
										create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_k * a_ldc + l_j)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_k * a_ldc + l_j)] + (l_Aik_real * l_temp1_real - -l_Aik_imag * l_temp1_imag)
										create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_k * a_ldc + l_j) + 1)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_k * a_ldc + l_j) + 1)] + (l_Aik_real * l_temp1_imag + -l_Aik_imag * l_temp1_real)
										l_temp2_real := l_temp2_real + (l_Aik_real * l_Bkj_real - l_Aik_imag * l_Bkj_imag)
										l_temp2_imag := l_temp2_imag + (l_Aik_real * l_Bkj_imag + l_Aik_imag * l_Bkj_real)
										l_k := l_k + 1
									end
									create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_alpha_real * l_temp2_real - l_alpha_imag * l_temp2_imag)
									create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_alpha_real * l_temp2_imag + l_alpha_imag * l_temp2_real)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 13 -- goto _L___3
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else: | _L___3:
						if l_side /= 141 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if l_uplo = 122 then
							l_i := 0
							from
							until
								not (not js.loop_left and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (not js.loop_left and then (l_j < l_n2))
								loop
									l_Bij_real___0 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag___0 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									l_temp1_real___0 := l_alpha_real * l_Bij_real___0 - l_alpha_imag * l_Bij_imag___0
									l_temp1_imag___0 := l_alpha_real * l_Bij_imag___0 + l_alpha_imag * l_Bij_real___0
									l_temp2_real___0 := 0.0
									l_temp2_imag___0 := 0.0
									l_k := 0
									from
									until
										not (l_k < l_i)
									loop
										l_Aik_real___0 := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
										l_Aik_imag___0 := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)]
										l_Bkj_real___0 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (a_ldb * l_k + l_j)]
										l_Bkj_imag___0 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (a_ldb * l_k + l_j) + 1)]
										create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_k * a_ldc + l_j)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_k * a_ldc + l_j)] + (l_Aik_real___0 * l_temp1_real___0 - -l_Aik_imag___0 * l_temp1_imag___0)
										create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_k * a_ldc + l_j) + 1)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_k * a_ldc + l_j) + 1)] + (l_Aik_real___0 * l_temp1_imag___0 + -l_Aik_imag___0 * l_temp1_real___0)
										l_temp2_real___0 := l_temp2_real___0 + (l_Aik_real___0 * l_Bkj_real___0 - l_Aik_imag___0 * l_Bkj_imag___0)
										l_temp2_imag___0 := l_temp2_imag___0 + (l_Aik_real___0 * l_Bkj_imag___0 + l_Aik_imag___0 * l_Bkj_real___0)
										l_k := l_k + 1
									end
									l_Aii_real___0 := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_i * a_lda + l_i)]
									create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_temp1_real___0 * l_Aii_real___0)
									create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_temp1_imag___0 * l_Aii_real___0)
									create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_alpha_real * l_temp2_real___0 - l_alpha_imag * l_temp2_imag___0)
									create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_alpha_real * l_temp2_imag___0 + l_alpha_imag * l_temp2_real___0)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 16 -- goto _L___2
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 16 then -- else: | _L___2:
						if l_side /= 142 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if l_uplo = 121 then
							l_i := 0
							from
							until
								not (not js.loop_left and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (not js.loop_left and then (l_j < l_n2))
								loop
									l_Bij_real___1 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag___1 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									l_temp1_real___1 := l_alpha_real * l_Bij_real___1 - l_alpha_imag * l_Bij_imag___1
									l_temp1_imag___1 := l_alpha_real * l_Bij_imag___1 + l_alpha_imag * l_Bij_real___1
									l_temp2_real___1 := 0.0
									l_temp2_imag___1 := 0.0
									l_Ajj_real := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_j * a_lda + l_j)]
									create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_temp1_real___1 * l_Ajj_real)
									create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_temp1_imag___1 * l_Ajj_real)
									l_k := l_j + 1
									from
									until
										not (l_k < l_n2)
									loop
										l_Ajk_real := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
										l_Ajk_imag := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)]
										l_Bik_real := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (a_ldb * l_i + l_k)]
										l_Bik_imag := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_k) + 1)]
										create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_i * a_ldc + l_k)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_i * a_ldc + l_k)] + (l_temp1_real___1 * l_Ajk_real - l_temp1_imag___1 * l_Ajk_imag)
										create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_k) + 1)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_k) + 1)] + (l_temp1_real___1 * l_Ajk_imag + l_temp1_imag___1 * l_Ajk_real)
										l_temp2_real___1 := l_temp2_real___1 + (l_Bik_real * l_Ajk_real - l_Bik_imag * -l_Ajk_imag)
										l_temp2_imag___1 := l_temp2_imag___1 + (l_Bik_real * -l_Ajk_imag + l_Bik_imag * l_Ajk_real)
										l_k := l_k + 1
									end
									create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_alpha_real * l_temp2_real___1 - l_alpha_imag * l_temp2_imag___1)
									create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_alpha_real * l_temp2_imag___1 + l_alpha_imag * l_temp2_real___1)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 19 -- goto _L___1
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L___1:
						if l_side = 142 then
							if l_uplo = 122 then
								l_i := 0
								from
								until
									not (not js.loop_left and then (l_i < l_n1))
								loop
									l_j := 0
									from
									until
										not (not js.loop_left and then (l_j < l_n2))
									loop
										l_Bij_real___2 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
										l_Bij_imag___2 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
										l_temp1_real___2 := l_alpha_real * l_Bij_real___2 - l_alpha_imag * l_Bij_imag___2
										l_temp1_imag___2 := l_alpha_real * l_Bij_imag___2 + l_alpha_imag * l_Bij_real___2
										l_temp2_real___2 := 0.0
										l_temp2_imag___2 := 0.0
										l_k := 0
										from
										until
											not (l_k < l_j)
										loop
											l_Ajk_real___0 := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
											l_Ajk_imag___0 := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)]
											l_Bik_real___0 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[2 * (a_ldb * l_i + l_k)]
											l_Bik_imag___0 := create {CE_POINTER [REAL_64]}.make_cast (a_B)[(2 * (a_ldb * l_i + l_k) + 1)]
											create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_i * a_ldc + l_k)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_i * a_ldc + l_k)] + (l_temp1_real___2 * l_Ajk_real___0 - l_temp1_imag___2 * l_Ajk_imag___0)
											create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_k) + 1)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_k) + 1)] + (l_temp1_real___2 * l_Ajk_imag___0 + l_temp1_imag___2 * l_Ajk_real___0)
											l_temp2_real___2 := l_temp2_real___2 + (l_Bik_real___0 * l_Ajk_real___0 - l_Bik_imag___0 * -l_Ajk_imag___0)
											l_temp2_imag___2 := l_temp2_imag___2 + (l_Bik_real___0 * -l_Ajk_imag___0 + l_Bik_imag___0 * l_Ajk_real___0)
											l_k := l_k + 1
										end
										l_Ajj_real___0 := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_j * a_lda + l_j)]
										create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_temp1_real___2 * l_Ajj_real___0)
										create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_temp1_imag___2 * l_Ajj_real___0)
										create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_alpha_real * l_temp2_real___2 - l_alpha_imag * l_temp2_imag___2)
										create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_POINTER [REAL_64]}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_alpha_real * l_temp2_imag___2 + l_alpha_imag * l_temp2_real___2)
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								xerbla_inst.cblas_xerbla ([0, ce_string ("source_hemm.h"), ce_string ("unrecognized operation")])
							end
						else
							xerbla_inst.cblas_xerbla ([0, ce_string ("source_hemm.h"), ce_string ("unrecognized operation")])
						end
				when 20 then -- if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
