class
	P_ZHPR

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_zhpr (a_order: INTEGER_32; a_Uplo: INTEGER_32; a_N: INTEGER_32; a_alpha: REAL_64; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32; a_Ap: CE_POINTER [ANY])
		local
			l_conj: INTEGER_32
			l_tmp: INTEGER_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_ix: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp_real: REAL_64
			l_tmp_imag: REAL_64
			l_jx: INTEGER_32
			l_X_real: REAL_64
			l_X_imag: REAL_64
			l_X_real___0: REAL_64
			l_X_imag___0: REAL_64
			l_ix___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp_real___0: REAL_64
			l_tmp_imag___0: REAL_64
			l_jx___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_X_real___1: REAL_64
			l_X_imag___1: REAL_64
			l_X_real___2: REAL_64
			l_X_imag___2: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_order.to_natural_32 = {NATURAL_32} 102 then
						l_tmp := -1
					else
						l_tmp := 1
					end
					l_conj := l_tmp
					if a_alpha = 0.0 then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 20 -- skip if block
					end
				when 1 then -- if:
						if a_order.to_natural_32 /= {NATURAL_32} 101 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if a_Uplo.to_natural_32 = {NATURAL_32} 121 then
							l_pos := -1 + 6 -- goto _L___1
						else
							l_pos := -1 + 4 -- goto _L___3
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 4 then -- else: | _L___3:
						if a_order.to_natural_32 /= {NATURAL_32} 102 then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if a_Uplo.to_natural_32 /= {NATURAL_32} 122 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L___1:
						if a_incX > 0 then
							l_tmp___0 := 0
						else
							l_tmp___0 := (a_N - 1) * -a_incX
						end
						l_ix := l_tmp___0
						l_i := 0
						from
						until
							not (not js.loop_left and then (l_i < a_N))
						loop
							l_tmp_real := a_alpha * create {CE_POINTER [REAL_64]}.make_cast (a_X)[2 * l_ix]
							l_tmp_imag := (a_alpha * l_conj.to_double) * create {CE_POINTER [REAL_64]}.make_cast (a_X)[(2 * l_ix + 1)]
							l_jx := l_ix
							l_X_real := create {CE_POINTER [REAL_64]}.make_cast (a_X)[2 * l_jx]
							l_X_imag := ((-l_conj).to_double * create {CE_POINTER [REAL_64]}.make_cast (a_X)[(2 * l_jx + 1)])
							create {CE_POINTER [REAL_64]}.make_cast (a_Ap)[2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_i) - l_i)] := create {CE_POINTER [REAL_64]}.make_cast (a_Ap)[2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_i) - l_i)] + (l_X_real * l_tmp_real - l_X_imag * l_tmp_imag)
							create {CE_POINTER [REAL_64]}.make_cast (a_Ap)[(2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_i) - l_i) + 1)] := (0).to_double
							l_jx := l_jx + a_incX
							l_j := l_i + 1
							from
							until
								not (l_j < a_N)
							loop
								l_X_real___0 := create {CE_POINTER [REAL_64]}.make_cast (a_X)[2 * l_jx]
								l_X_imag___0 := ((-l_conj).to_double * create {CE_POINTER [REAL_64]}.make_cast (a_X)[(2 * l_jx + 1)])
								create {CE_POINTER [REAL_64]}.make_cast (a_Ap)[2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_j) - l_i)] := create {CE_POINTER [REAL_64]}.make_cast (a_Ap)[2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_j) - l_i)] + (l_X_real___0 * l_tmp_real - l_X_imag___0 * l_tmp_imag)
								create {CE_POINTER [REAL_64]}.make_cast (a_Ap)[(2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_j) - l_i) + 1)] := create {CE_POINTER [REAL_64]}.make_cast (a_Ap)[(2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_j) - l_i) + 1)] + (l_X_imag___0 * l_tmp_real + l_X_real___0 * l_tmp_imag)
								l_jx := l_jx + a_incX
								l_j := l_j + 1
							end
							l_ix := l_ix + a_incX
							l_i := l_i + 1
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_pos := -1 + 10 -- goto _L___2
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 10 then -- else: | _L___2:
						if a_order.to_natural_32 /= {NATURAL_32} 101 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if a_Uplo.to_natural_32 = {NATURAL_32} 122 then
							l_pos := -1 + 15 -- goto _L
						else
							l_pos := -1 + 13 -- goto _L___0
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else: | _L___0:
						if a_order.to_natural_32 /= {NATURAL_32} 102 then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						if a_Uplo.to_natural_32 /= {NATURAL_32} 121 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if: | _L:
						if a_incX > 0 then
							l_tmp___1 := 0
						else
							l_tmp___1 := (a_N - 1) * -a_incX
						end
						l_ix___0 := l_tmp___1
						l_i := 0
						from
						until
							not (not js.loop_left and then (l_i < a_N))
						loop
							l_tmp_real___0 := a_alpha * create {CE_POINTER [REAL_64]}.make_cast (a_X)[2 * l_ix___0]
							l_tmp_imag___0 := (a_alpha * l_conj.to_double) * create {CE_POINTER [REAL_64]}.make_cast (a_X)[(2 * l_ix___0 + 1)]
							if a_incX > 0 then
								l_tmp___2 := 0
							else
								l_tmp___2 := (a_N - 1) * -a_incX
							end
							l_jx___0 := l_tmp___2
							l_j := 0
							from
							until
								not (l_j < l_i)
							loop
								l_X_real___1 := create {CE_POINTER [REAL_64]}.make_cast (a_X)[2 * l_jx___0]
								l_X_imag___1 := ((-l_conj).to_double * create {CE_POINTER [REAL_64]}.make_cast (a_X)[(2 * l_jx___0 + 1)])
								create {CE_POINTER [REAL_64]}.make_cast (a_Ap)[2 * ((l_i * (l_i + 1)) // 2 + l_j)] := create {CE_POINTER [REAL_64]}.make_cast (a_Ap)[2 * ((l_i * (l_i + 1)) // 2 + l_j)] + (l_X_real___1 * l_tmp_real___0 - l_X_imag___1 * l_tmp_imag___0)
								create {CE_POINTER [REAL_64]}.make_cast (a_Ap)[(2 * ((l_i * (l_i + 1)) // 2 + l_j) + 1)] := create {CE_POINTER [REAL_64]}.make_cast (a_Ap)[(2 * ((l_i * (l_i + 1)) // 2 + l_j) + 1)] + (l_X_imag___1 * l_tmp_real___0 + l_X_real___1 * l_tmp_imag___0)
								l_jx___0 := l_jx___0 + a_incX
								l_j := l_j + 1
							end
							l_X_real___2 := create {CE_POINTER [REAL_64]}.make_cast (a_X)[2 * l_jx___0]
							l_X_imag___2 := ((-l_conj).to_double * create {CE_POINTER [REAL_64]}.make_cast (a_X)[(2 * l_jx___0 + 1)])
							create {CE_POINTER [REAL_64]}.make_cast (a_Ap)[2 * ((l_i * (l_i + 1)) // 2 + l_i)] := create {CE_POINTER [REAL_64]}.make_cast (a_Ap)[2 * ((l_i * (l_i + 1)) // 2 + l_i)] + (l_X_real___2 * l_tmp_real___0 - l_X_imag___2 * l_tmp_imag___0)
							create {CE_POINTER [REAL_64]}.make_cast (a_Ap)[(2 * ((l_i * (l_i + 1)) // 2 + l_i) + 1)] := (0).to_double
							l_jx___0 := l_jx___0 + a_incX
							l_ix___0 := l_ix___0 + a_incX
							l_i := l_i + 1
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						xerbla_inst.cblas_xerbla ([0, ce_string ("source_hpr.h"), ce_string ("unrecognized operation")])
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:
						xerbla_inst.cblas_xerbla ([0, ce_string ("source_hpr.h"), ce_string ("unrecognized operation")])
				when 20 then -- if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
