class
	P_ZSOLVE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_poly_complex_solve (a_a___5: CE_POINTER [REAL_64]; a_n: NATURAL_32; a_w: CE_POINTER [PD_GSL_POLY_COMPLEX_WORKSPACE]; a_z: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_status: INTEGER_32
			l_m___4: CE_POINTER [REAL_64]
			js: JUMP_STATE
		do
			create l_m___4.make

			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("number of terms must be a positive integer"), ce_string ("zsolve.c"), 50, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_n = {NATURAL_32} 1) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("cannot solve for only one term"), ce_string ("zsolve.c"), 55, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_a___5[(a_n - {NATURAL_32} 1).to_integer_32] = (0).to_double) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("leading term of polynomial must be non-zero"), ce_string ("zsolve.c"), 60, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_w.item.nc /= a_n - {NATURAL_32} 1) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("size of workspace does not match polynomial"), ce_string ("zsolve.c"), 65, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_m___4.ce_gets (a_w.item.matrix)
				companion_inst.set_companion_matrix (a_a___5, a_n - {NATURAL_32} 1, l_m___4)
				balance_inst.balance_companion_matrix (l_m___4, a_n - {NATURAL_32} 1)
				l_status := qr_inst.qr_companion (l_m___4, a_n - {NATURAL_32} 1, a_z)
				if l_status.to_boolean then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("root solving qr method failed to converge"), ce_string ("zsolve.c"), 78, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

end
