class
	P_ZSOLVE_INIT

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_poly_complex_workspace_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_POLY_COMPLEX_WORKSPACE]
		local
			l_nc: NATURAL_32
			l_w: CE_POINTER [PD_GSL_POLY_COMPLEX_WORKSPACE]
			js: JUMP_STATE
		do
			create l_w.make

			if a_n = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("matrix size n must be positive integer"), ce_string ("zsolve_init.c"), 36, 1)
					Result := (create {CE_POINTER [PD_GSL_POLY_COMPLEX_WORKSPACE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_w.ce_gets (create {CE_POINTER [PD_GSL_POLY_COMPLEX_WORKSPACE]}.make_cast ((malloc ({PD_GSL_POLY_COMPLEX_WORKSPACE}.sizeof.to_natural_32))))
				if (l_w.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for struct"), ce_string ("zsolve_init.c"), 44, 8)
						Result := (create {CE_POINTER [PD_GSL_POLY_COMPLEX_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_nc := a_n - {NATURAL_32} 1
				l_w.item.nc := l_nc
				l_w.item.matrix := create {CE_POINTER [REAL_64]}.make_cast ((malloc ((l_nc * l_nc) * Real_64_bytes.to_natural_32)))
				if ((l_w.item.matrix).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for workspace matrix"), ce_string ("zsolve_init.c"), 58, 8)
						Result := (create {CE_POINTER [PD_GSL_POLY_COMPLEX_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				Result := l_w
			end
		end

	gsl_poly_complex_workspace_free (a_w: CE_POINTER [PD_GSL_POLY_COMPLEX_WORKSPACE])
		local
			js: JUMP_STATE
		do
			if (a_w).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (a_w.item.matrix))
				free (create {CE_POINTER [ANY]}.make_cast (a_w))
			end
		end

end
