deferred class
	S_MATH

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	acos (a_x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return acos($a_x);"
		end

	asin (a_x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return asin($a_x);"
		end

	atan (a_x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return atan($a_x);"
		end

	atan2 (a_y: REAL_64; a_x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return atan2($a_y, $a_x);"
		end

	cos (a_x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return cos($a_x);"
		end

	sin (a_x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return sin($a_x);"
		end

	cosh (a_x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return cosh($a_x);"
		end

	sinh (a_x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return sinh($a_x);"
		end

	tanh (a_x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return tanh($a_x);"
		end

	acosh (a_x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return acosh($a_x);"
		end

	atanh (a_x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return atanh($a_x);"
		end

	exp (a_x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return exp($a_x);"
		end

	log (a_x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return log($a_x);"
		end

	log1p (a_x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return log1p($a_x);"
		end

	pow (a_x: REAL_64; a_y: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return pow($a_x, $a_y);"
		end

	sqrt (a_x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return sqrt($a_x);"
		end

	hypot (a_x: REAL_64; a_y: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return hypot($a_x, $a_y);"
		end

	fabs (a_x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return fabs($a_x);"
		end

	isnan (a_value: REAL_64): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return __isnan($a_value);"
		end

	isnanf (a_value: REAL_32): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return __isnanf($a_value);"
		end

	isnanl (a_value: REAL_96): INTEGER_32
		do
			Result := c_isnanl (a_value.c_pointer)
		end

	c_isnanl (a_value: POINTER): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return __isnanl(*(long double *)$a_value);"
		end

	floor (a_x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return floor($a_x);"
		end

	ceil (a_x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return ceil($a_x);"
		end

	frexp (a_x: REAL_64; a_exponent: CE_POINTER [INTEGER_32]): REAL_64
		do
			Result := c_frexp (a_x, a_exponent.c_pointer)
		end

	c_frexp (a_x: REAL_64; a_exponent: POINTER): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return frexp($a_x, $a_exponent);"
		end

	ldexp (a_x: REAL_64; a_exponent: INTEGER_32): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return ldexp($a_x, $a_exponent);"
		end

	tan (a_x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return tan($a_x);"
		end

	fmod (a_x: REAL_64; a_y: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return fmod($a_x, $a_y);"
		end

	finite (a_value: REAL_64): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return finite($a_value);"
		end

	isinf (a_value: REAL_64): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return __isinf($a_value);"
		end

	finite2 (a_value: REAL_64): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return __finite($a_value);"
		end

	isinff (a_value: REAL_32): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return __isinff($a_value);"
		end

	finitef (a_value: REAL_32): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return __finitef($a_value);"
		end

	isinfl (a_value: REAL_96): INTEGER_32
		do
			Result := c_isinfl (a_value.c_pointer)
		end

	c_isinfl (a_value: POINTER): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return __isinfl(*(long double *)$a_value);"
		end

	finitel (a_value: REAL_96): INTEGER_32
		do
			Result := c_finitel (a_value.c_pointer)
		end

	c_finitel (a_value: POINTER): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return __finitel(*(long double *)$a_value);"
		end

	expm1 (a_x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return expm1($a_x);"
		end

end
