deferred class
	S_STDIO

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	fprintf (a_args: TUPLE [a_stream: CE_POINTER [SD_IO_FILE]; a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_fprintf)).integer_32_item (a_args)
		end

	c_fprintf: POINTER
		external
			"C inline use <libgsl.h>"
		alias
			"return &fprintf;"
		end

	fscanf (a_args: TUPLE [a_stream: CE_POINTER [SD_IO_FILE]; a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_fscanf)).integer_32_item (a_args)
		end

	c_fscanf: POINTER
		external
			"C inline use <libgsl.h>"
		alias
			"return &fscanf;"
		end

	fread (a_ptr: CE_POINTER [ANY]; a_size: NATURAL_32; a_n: NATURAL_32; a_stream: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fread (a_ptr.c_pointer, a_size, a_n, a_stream.c_pointer)
		end

	c_fread (a_ptr: POINTER; a_size: NATURAL_32; a_n: NATURAL_32; a_stream: POINTER): NATURAL_32
		external
			"C inline use <libgsl.h>"
		alias
			"return fread($a_ptr, $a_size, $a_n, $a_stream);"
		end

	fwrite (a_ptr: CE_POINTER [ANY]; a_size: NATURAL_32; a_n: NATURAL_32; a_s: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fwrite (a_ptr.c_pointer, a_size, a_n, a_s.c_pointer)
		end

	c_fwrite (a_ptr: POINTER; a_size: NATURAL_32; a_n: NATURAL_32; a_s: POINTER): NATURAL_32
		external
			"C inline use <libgsl.h>"
		alias
			"return fwrite($a_ptr, $a_size, $a_n, $a_s);"
		end

	fflush (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fflush (a_stream.c_pointer)
		end

	c_fflush (a_stream: POINTER): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return fflush($a_stream);"
		end

	fclose (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fclose (a_stream.c_pointer)
		end

	c_fclose (a_stream: POINTER): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return fclose($a_stream);"
		end

	fopen (a_filename: CE_POINTER [INTEGER_8]; a_modes: CE_POINTER [INTEGER_8]): CE_POINTER [SD_IO_FILE]
		do
			create Result.make_shared (c_fopen (a_filename.c_pointer, a_modes.c_pointer))
		end

	c_fopen (a_filename: POINTER; a_modes: POINTER): POINTER
		external
			"C inline use <libgsl.h>"
		alias
			"return fopen($a_filename, $a_modes);"
		end

	feof (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_feof (a_stream.c_pointer)
		end

	c_feof (a_stream: POINTER): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return feof($a_stream);"
		end

	printf (a_args: TUPLE [a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_printf)).integer_32_item (a_args)
		end

	c_printf: POINTER
		external
			"C inline use <libgsl.h>"
		alias
			"return &printf;"
		end

	fputc (a_c: INTEGER_32; a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fputc (a_c, a_stream.c_pointer)
		end

	c_fputc (a_c: INTEGER_32; a_stream: POINTER): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return fputc($a_c, $a_stream);"
		end

	vprintf (a_format: CE_POINTER [INTEGER_8]; a_arg: CE_VA_LIST): INTEGER_32
		do
			Result := c_vprintf (a_format.c_pointer, a_arg.c_pointer)
		end

	c_vprintf (a_format: POINTER; a_arg: POINTER): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return vprintf($a_format, $a_arg);"
		end

	vfprintf (a_s: CE_POINTER [SD_IO_FILE]; a_format: CE_POINTER [INTEGER_8]; a_arg: CE_VA_LIST): INTEGER_32
		do
			Result := c_vfprintf (a_s.c_pointer, a_format.c_pointer, a_arg.c_pointer)
		end

	c_vfprintf (a_s: POINTER; a_format: POINTER; a_arg: POINTER): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return vfprintf($a_s, $a_format, $a_arg);"
		end

end
