deferred class
	S_STDLIB

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	malloc (a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared_with_count (
					default_pointer.memory_alloc (a_size.to_integer_32),
					a_size.to_integer_32
				)
		end

	free (a_ptr: CE_POINTER [ANY])
		do
			c_free (a_ptr.c_pointer)
		end

	c_free (a_ptr: POINTER)
		external
			"C inline use <libgsl.h>"
		alias
			"free($a_ptr);"
		end

	calloc (a_nmemb: NATURAL_32; a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared_with_count (
					default_pointer.memory_calloc (a_nmemb.to_integer_32, a_size.to_integer_32),
					(a_nmemb * a_size).to_integer_32
				)
		end

	abort
		external
			"C inline use <libgsl.h>"
		alias
			"abort();"
		end

	getenv (a_name: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_getenv (a_name.c_pointer))
		end

	c_getenv (a_name: POINTER): POINTER
		external
			"C inline use <libgsl.h>"
		alias
			"return getenv($a_name);"
		end

	abs (a_x: INTEGER_32): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return abs($a_x);"
		end

	strtoul (a_nptr: CE_POINTER [INTEGER_8]; a_endptr: CE_POINTER [CE_POINTER [INTEGER_8]]; a_base: INTEGER_32): NATURAL_32
		do
			Result := c_strtoul (a_nptr.c_pointer, a_endptr.c_pointer, a_base)
		end

	c_strtoul (a_nptr: POINTER; a_endptr: POINTER; a_base: INTEGER_32): NATURAL_32
		external
			"C inline use <libgsl.h>"
		alias
			"return strtoul($a_nptr, $a_endptr, $a_base);"
		end

end
