class
	P_HTML

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create html_stack.make
			create roman_tbl.make (<<20>>)
			create color_specs.make (<<140>>)
			create eoff.make
			create form.make
			create menu_stack.make
			create elements.make (<<63>>)
		end

feature {ANY} -- attributes

	html_stack: PD_LIST_HEAD

	get_attr_val_nl: INTEGER_32 assign set_get_attr_val_nl

	set_get_attr_val_nl (a_get_attr_val_nl: INTEGER_32)
		do
			get_attr_val_nl := a_get_attr_val_nl
		end

	roman_tbl: CE_ARRAY [PD_ROMAN_TBL]

	color_specs: CE_ARRAY [PD_COLOR_SPEC]

	eoff: CE_POINTER [NATURAL_8]

	pos: INTEGER_32 assign set_pos

	set_pos (a_pos: INTEGER_32)
		do
			pos := a_pos
		end

	putsp: INTEGER_32 assign set_putsp

	set_putsp (a_putsp: INTEGER_32)
		do
			putsp := a_putsp
		end

	was_br: INTEGER_32 assign set_was_br

	set_was_br (a_was_br: INTEGER_32)
		do
			was_br := a_was_br
		end

	form: PD_FORM

	menu_stack_size: INTEGER_32 assign set_menu_stack_size

	set_menu_stack_size (a_menu_stack_size: INTEGER_32)
		do
			menu_stack_size := a_menu_stack_size
		end

	menu_stack: CE_POINTER [CE_POINTER [PD_MENU_ITEM]]

	elements: CE_ARRAY [PD_ELEMENT_INFO]

feature {ANY} -- routines

	atchr (a_c: NATURAL_8): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if a_c.to_integer_32 > 32 then
				if a_c.to_integer_32 /= 61 then
					if a_c.to_integer_32 /= 60 then
						if a_c.to_integer_32 /= 62 then
							l_tmp := 1
						else
							l_tmp := 0
						end
					else
						l_tmp := 0
					end
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	parse_element (a_e: CE_POINTER [NATURAL_8]; a_eof: CE_POINTER [NATURAL_8]; a_name: CE_POINTER [CE_POINTER [NATURAL_8]]; a_namelen: CE_POINTER [INTEGER_32]; a_attr: CE_POINTER [CE_POINTER [NATURAL_8]]; a_end: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_e: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_uu: NATURAL_8
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_e.make
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_e.ce_gets (a_e)
					if a_eof.distance (l_e) < 3 then
						Result := (-1)
						js.return
					else
						l_tmp.ce_gets (l_e)
						l_e.ce_gets (l_e + 1)
						if (l_tmp.item).to_integer_32 /= 60 then
							Result := (-1)
							js.return
						end
					end
					if not js.return_called then
						if ((a_name).c_pointer /= default_pointer) then
							a_name.item := l_e
						end
						if (l_e.item).to_integer_32 = 47 then
							l_e.ce_gets (l_e + 1)
						end
						if not (links_inst.isA (l_e.item)).to_boolean then
							Result := (-1)
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto x1
				when 2 then
						if js.loop_left then
							l_pos := -1 + 6 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if not (links_inst.isA (l_e.item)).to_boolean then
							if (l_e.item).to_integer_32 /= 61 then
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | x1:
						l_e.ce_gets (l_e + 1)
						if (l_e.c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
							Result := (-1)
							js.return
						end
				when 5 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 6 then -- loop done
						js.reset
				when 7 then -- if done
					if not js.return_called then
						if ((a_name).c_pointer /= default_pointer) then
							if ((a_namelen).c_pointer /= default_pointer) then
								a_namelen.item := l_e.distance ((a_name.item))
							end
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_e.item).to_integer_32 /= 9 then
								if (l_e.item).to_integer_32 /= 10 then
									if (l_e.item).to_integer_32 /= 12 then
										if (l_e.item).to_integer_32 /= 13 then
											if (l_e.item).to_integer_32 /= 32 then
												if (l_e.item).to_integer_32 /= 47 then
													if (l_e.item).to_integer_32 /= 58 then
														js.break
													end
												end
											end
										end
									end
								end
							end
							if not js.loop_jumped then
								l_e.ce_gets (l_e + 1)
								if (l_e.c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
									Result := (-1)
									js.return
								end
							end
						end
						js.reset
					end
					if not js.return_called then
						if not (atchr (l_e.item)).to_boolean then
							if (l_e.item).to_integer_32 /= 62 then
								if (l_e.item).to_integer_32 /= 60 then
									Result := (-1)
									js.return
								end
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 10 -- skip if block
					end
				when 8 then -- if:
						if ((a_attr).c_pointer /= default_pointer) then
							a_attr.item := l_e
						end
				when 9 then -- nextattr:
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_e.item).to_integer_32 /= 9 then
								if (l_e.item).to_integer_32 /= 10 then
									if (l_e.item).to_integer_32 /= 12 then
										if (l_e.item).to_integer_32 /= 13 then
											if (l_e.item).to_integer_32 /= 32 then
												js.break
											end
										end
									end
								end
							end
							if not js.loop_jumped then
								l_e.ce_gets (l_e + 1)
								if (l_e.c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
									Result := (-1)
									js.return
								end
							end
						end
						js.reset
				when 10 then -- if done
					if not js.return_called then
						if not (atchr (l_e.item)).to_boolean then
							if (l_e.item).to_integer_32 /= 62 then
								if (l_e.item).to_integer_32 /= 60 then
									Result := (-1)
									js.return
								end
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 13 -- skip if block
					end
				when 11 then -- if:
						if (l_e.item).to_integer_32 = 62 then
							l_pos := -1 + 36 -- goto en
						elseif (l_e.item).to_integer_32 = 60 then
							l_pos := -1 + 36 -- goto en
						end
				when 12 then
						from
						until
							js.loop_left
						loop
							js.reset
							if not (atchr (l_e.item)).to_boolean then
								js.break
							end
							if not js.loop_jumped then
								l_e.ce_gets (l_e + 1)
								if (l_e.c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
									Result := (-1)
									js.return
								end
							end
						end
						js.reset
				when 13 then -- if done
					if not js.return_called then
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_e.item).to_integer_32 /= 9 then
								if (l_e.item).to_integer_32 /= 10 then
									if (l_e.item).to_integer_32 /= 12 then
										if (l_e.item).to_integer_32 /= 13 then
											if (l_e.item).to_integer_32 /= 32 then
												js.break
											end
										end
									end
								end
							end
							if not js.loop_jumped then
								l_e.ce_gets (l_e + 1)
								if (l_e.c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
									Result := (-1)
									js.return
								end
							end
						end
						js.reset
					end
					if js.return_called then
						l_pos := -1 + 21 -- skip if block
					end
				when 14 then -- if:
						if (l_e.item).to_integer_32 /= 61 then
							l_pos := -1 + 35 -- goto endattr
						end
				when 15 then
						l_pos := -1 + 18 -- goto x2
				when 16 then
						if js.loop_left then
							l_pos := -1 + 20 -- skip loop
						end
				when 17 then -- loop body:
						js.reset
						if (l_e.item).to_integer_32 /= 9 then
							if (l_e.item).to_integer_32 /= 10 then
								if (l_e.item).to_integer_32 /= 12 then
									if (l_e.item).to_integer_32 /= 13 then
										if (l_e.item).to_integer_32 /= 32 then
											js.break
										end
									end
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 19 -- skip if block
						end
				when 18 then -- if: | x2:
						l_e.ce_gets (l_e + 1)
						if (l_e.c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
							Result := (-1)
							js.return
						end
				when 19 then -- if done
						l_pos := -1 + 16 -- back to loop condition
				when 20 then -- loop done
						js.reset
				when 21 then -- if done
					if js.return_called then
						l_pos := -1 + 34 -- skip if block
					end
				when 22 then -- if:
						if (l_e.item).to_integer_32 /= 34 then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 26 -- goto _L
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 25 then -- else:
						if (l_e.item).to_integer_32 /= 39 then
							l_pos := -1 + 33 -- skip if block
						end
				when 26 then -- if: | _L:
						l_uu := l_e.item
						l_pos := -1 + 29 -- goto x3
				when 27 then
						if js.loop_left then
							l_pos := -1 + 31 -- skip loop
						end
				when 28 then -- loop body:
						js.reset
						if (l_e.c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_e.item).to_integer_32 /= l_uu.to_integer_32 then
								if not (l_e.item).to_boolean then
									js.break
								end
							else
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 30 -- skip if block
						end
				when 29 then -- if: | x3:
						l_e.ce_gets (l_e + 1)
						if (l_e.c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
							Result := (-1)
							js.return
						end
				when 30 then -- if done
						l_pos := -1 + 27 -- back to loop condition
				when 31 then -- loop done
						js.reset
						if not js.return_called and then ((l_e.item).to_integer_32 < 32) then
							Result := (-1)
							js.return
						end
						if not js.return_called then
							l_e.ce_gets (l_e + 1)
							if (l_e.c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
								Result := (-1)
								js.return
							end
						end
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 33 then -- else:
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_e.item).to_integer_32 = 9 then
								js.break
							elseif (l_e.item).to_integer_32 = 10 then
								js.break
							elseif (l_e.item).to_integer_32 = 12 then
								js.break
							elseif (l_e.item).to_integer_32 = 13 then
								js.break
							elseif (l_e.item).to_integer_32 = 32 then
								js.break
							elseif (l_e.item).to_integer_32 /= 62 then
								if (l_e.item).to_integer_32 = 60 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_e.ce_gets (l_e + 1)
								if (l_e.c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
									Result := (-1)
									js.return
								end
							end
						end
						js.reset
				when 34 then -- if done | if done
						if not js.return_called then
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_e.item).to_integer_32 /= 9 then
									if (l_e.item).to_integer_32 /= 10 then
										if (l_e.item).to_integer_32 /= 12 then
											if (l_e.item).to_integer_32 /= 13 then
												if (l_e.item).to_integer_32 /= 32 then
													js.break
												end
											end
										end
									end
								end
								if not js.loop_jumped then
									l_e.ce_gets (l_e + 1)
									if (l_e.c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
										Result := (-1)
										js.return
									end
								end
							end
							js.reset
						end
						if js.return_called then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if: | endattr:
							if (l_e.item).to_integer_32 /= 62 then
								if (l_e.item).to_integer_32 /= 60 then
									l_pos := -1 + 9 -- goto nextattr
								end
							end
				when 36 then -- en:
							if ((a_end).c_pointer /= default_pointer) then
								a_end.item := l_e + ((l_e.item).to_integer_32 = 62).to_integer
							end
							Result := 0
				when 37 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	get_attr_val (a_e: CE_POINTER [NATURAL_8]; a_name: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_e: CE_POINTER [NATURAL_8]
			l_n: CE_POINTER [NATURAL_8]
			l_a: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_f: INTEGER_32
			l_tmp: NATURAL_8
			l_tmp___3: INTEGER_32
			l_uu: INTEGER_8
			l_tmp___5: INTEGER_32
			l_tmp___7: INTEGER_32
			l_b: CE_POINTER [NATURAL_8]
			l_tmp___9: INTEGER_32
			l_aa: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_e.make
			create l_n.make
			create l_a.make
			create l_b.make
			create l_aa.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_e.ce_gets (a_e)
					l_a.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + -1))
					l_l := 0
				when 1 then -- aa:
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_e.item).to_integer_32 /= 9 then
							if (l_e.item).to_integer_32 /= 10 then
								if (l_e.item).to_integer_32 /= 12 then
									if (l_e.item).to_integer_32 /= 13 then
										if (l_e.item).to_integer_32 /= 32 then
											js.break
										end
									end
								end
							end
						end
						if not js.loop_jumped then
							l_e.ce_gets (l_e + 1)
						end
					end
					js.reset
					if (l_e.item).to_integer_32 = 62 then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					elseif (l_e.item).to_integer_32 = 60 then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 25 -- skip if block
					end
				when 2 then -- if:
						l_n.ce_gets (a_name)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_n.item).to_boolean then
								l_tmp := links_inst.upcase (l_e.item)
								if l_tmp.to_integer_32 /= (links_inst.upcase (l_n.item)).to_integer_32 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_e.ce_gets (l_e + 1)
								l_n.ce_gets (l_n + 1)
							end
						end
						js.reset
						l_f := (l_n.item).to_integer_32
						from
						until
							js.loop_left
						loop
							js.reset
							if not (atchr (l_e.item)).to_boolean then
								js.break
							end
							if not js.loop_jumped then
								l_f := 1
								l_e.ce_gets (l_e + 1)
							end
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_e.item).to_integer_32 /= 9 then
								if (l_e.item).to_integer_32 /= 10 then
									if (l_e.item).to_integer_32 /= 12 then
										if (l_e.item).to_integer_32 /= 13 then
											if (l_e.item).to_integer_32 /= 32 then
												js.break
											end
										end
									end
								end
							end
							if not js.loop_jumped then
								l_e.ce_gets (l_e + 1)
							end
						end
						js.reset
						if (l_e.item).to_integer_32 /= 61 then
							l_pos := -1 + 26 -- goto ea
						end
				when 3 then
						l_e.ce_gets (l_e + 1)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_e.item).to_integer_32 /= 9 then
								if (l_e.item).to_integer_32 /= 10 then
									if (l_e.item).to_integer_32 /= 12 then
										if (l_e.item).to_integer_32 /= 13 then
											if (l_e.item).to_integer_32 /= 32 then
												js.break
											end
										end
									end
								end
							end
							if not js.loop_jumped then
								l_e.ce_gets (l_e + 1)
							end
						end
						js.reset
						if (l_e.item).to_integer_32 /= 34 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 6 then -- else:
						if (l_e.item).to_integer_32 /= 39 then
							l_pos := -1 + 24 -- skip if block
						end
				when 7 then -- if: | _L___0:
						l_uu := (l_e.item).to_integer_8
						l_e.ce_gets (l_e + 1)
				when 8 then -- loop condition:
						if not (not js.loop_left and then ((l_e.item).to_integer_32 /= l_uu.to_integer_32)) then
							l_pos := -1 + 22 -- skip loop
						end
				when 9 then -- loop body:
						if not (l_e.item).to_boolean then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 125, create {CE_POINTER [ANY]}.make_cast (l_a))
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
						if js.return_called then
							l_pos := -1 + 21 -- skip if block
						end
				when 10 then -- if:
						if l_f.to_boolean then
							l_pos := -1 + 20 -- skip if block
						end
				when 11 then -- if:
						if get_attr_val_nl = 2 then
							l_pos := -1 + 15 -- goto exact
						end
				when 12 then
						if (l_e.item).to_integer_32 = 13 then
							l_pos := -1 + 20 -- skip if block
						end
				when 13 then -- if:
						if (l_e.item).to_integer_32 = 9 then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						if (l_e.item).to_integer_32 = 10 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if: | exact:
						from
						until
							js.loop_left
						loop
							js.reset
							if not ((l_l).bit_and (31)).to_boolean then
								if l_l.to_natural_32 > {NATURAL_32} 2147483615 then
									from
									until
										False
									loop
										error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html.c"), 131])
										kbd_inst.fatal_tty_exit
										exit (4)
									end
								end
								l_a.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 131, create {CE_POINTER [ANY]}.make_cast (l_a), (l_l + 32).to_natural_32))))
							end
							l_tmp___5 := l_l
							l_l := l_l + 1
							l_a[l_tmp___5] := l_e.item
							js.break
						end
						js.reset
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						l_pos := -1 + 19 -- goto _L
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L:
						if not get_attr_val_nl.to_boolean then
							from
							until
								js.loop_left
							loop
								js.reset
								if not ((l_l).bit_and (31)).to_boolean then
									if l_l.to_natural_32 > {NATURAL_32} 2147483615 then
										from
										until
											False
										loop
											error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html.c"), 132])
											kbd_inst.fatal_tty_exit
											exit (4)
										end
									end
									l_a.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 132, create {CE_POINTER [ANY]}.make_cast (l_a), (l_l + 32).to_natural_32))))
								end
								l_tmp___7 := l_l
								l_l := l_l + 1
								l_a[l_tmp___7] := ((' ').code).to_natural_8
								js.break
							end
							js.reset
						end
				when 20 then -- if done | if done
						l_e.ce_gets (l_e + 1)
				when 21 then -- if done
						l_pos := -1 + 8 -- back to loop condition
				when 22 then -- loop done
						if not js.return_called then
							l_e.ce_gets (l_e + 1)
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_e.item).to_integer_32 = 9 then
								js.break
							elseif (l_e.item).to_integer_32 = 10 then
								js.break
							elseif (l_e.item).to_integer_32 = 12 then
								js.break
							elseif (l_e.item).to_integer_32 = 13 then
								js.break
							elseif (l_e.item).to_integer_32 = 32 then
								js.break
							elseif (l_e.item).to_integer_32 /= 62 then
								if (l_e.item).to_integer_32 = 60 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if not l_f.to_boolean then
									from
									until
										js.loop_left
									loop
										js.reset
										if not ((l_l).bit_and (31)).to_boolean then
											if l_l.to_natural_32 > {NATURAL_32} 2147483615 then
												from
												until
													False
												loop
													error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html.c"), 116])
													kbd_inst.fatal_tty_exit
													exit (4)
												end
											end
											l_a.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 116, create {CE_POINTER [ANY]}.make_cast (l_a), (l_l + 32).to_natural_32))))
										end
										l_tmp___3 := l_l
										l_l := l_l + 1
										l_a[l_tmp___3] := l_e.item
										js.break
									end
									js.reset
								end
								l_e.ce_gets (l_e + 1)
							end
						end
						js.reset
				when 25 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 27 -- skip if block
						end
				when 26 then -- if: | ea:
							if not l_f.to_boolean then
								from
								until
									js.loop_left
								loop
									js.reset
									if not ((l_l).bit_and (31)).to_boolean then
										if l_l.to_natural_32 > {NATURAL_32} 2147483615 then
											from
											until
												False
											loop
												error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html.c"), 146])
												kbd_inst.fatal_tty_exit
												exit (4)
											end
										end
										l_a.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 146, create {CE_POINTER [ANY]}.make_cast (l_a), (l_l + 32).to_natural_32))))
									end
									l_tmp___9 := l_l
									l_l := l_l + 1
									l_a[l_tmp___9] := (0).to_natural_8
									js.break
								end
								js.reset
								if (((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_a), ('&').code))).c_pointer /= default_pointer) then
									l_aa.ce_gets (l_a)
									l_c := links_inst.d_opt.item.cp
									links_inst.d_opt.item.cp := links_inst.d_opt.item.real_cp
									l_a.ce_gets (charsets_inst.convert_string (create {CE_POINTER [PD_CONV_TABLE]}.make_shared (default_pointer), l_aa, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_aa))).to_integer_32))
									links_inst.d_opt.item.cp := l_c
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 153, create {CE_POINTER [ANY]}.make_cast (l_aa))
								end
								from
								until
									js.loop_left
								loop
									js.reset
									l_b.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_a), 1))))
									if (l_b).c_pointer = default_pointer then
										js.break
									end
									if not js.loop_jumped then
										l_b.item := ((' ').code).to_natural_8
									end
								end
								js.reset
								if get_attr_val_nl /= 2 then
									l_b.ce_gets (l_a)
									from
									until
										(l_b.item).to_integer_32 /= 32
									loop
										l_b.ce_gets (l_b + 1)
									end
									if (l_b.c_pointer.to_integer_32).to_natural_32 /= (l_a.c_pointer.to_integer_32).to_natural_32 then
										memmove (create {CE_POINTER [ANY]}.make_cast (l_a), create {CE_POINTER [ANY]}.make_cast (l_b), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_b))) + {NATURAL_32} 1).do_nothing
									end
									l_b.ce_gets ((l_a + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_a))).to_integer_32) - 1)
									from
									until
										js.loop_left
									loop
										js.reset
										if (l_b.c_pointer.to_integer_32).to_natural_32 >= (l_a.c_pointer.to_integer_32).to_natural_32 then
											if (l_b.item).to_integer_32 /= 32 then
												js.break
											end
										else
											js.break
										end
										if not js.loop_jumped then
											l_b.item := (0).to_natural_8
											l_b.ce_gets (l_b - 1)
										end
									end
									js.reset
								end
								error_inst.set_mem_comment (create {CE_POINTER [ANY]}.make_cast (l_a), a_name, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_name))).to_integer_32)
								Result := l_a
								js.return
							end
				when 27 then -- if done
						if not js.return_called then
							l_pos := -1 + 1 -- goto aa
						end
				when 28 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	has_attr (a_e: CE_POINTER [NATURAL_8]; a_name: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_a: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_a.make

			l_a.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((get_attr_val (a_e, a_name))))
			if (l_a).c_pointer = default_pointer then
				Result := 0
				js.return
			end
			if not js.return_called then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 171, create {CE_POINTER [ANY]}.make_cast (l_a))
				Result := 1
			end
		end

	get_url_val (a_e: CE_POINTER [NATURAL_8]; a_name: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_a: CE_POINTER [NATURAL_8]
		do
			create l_a.make

			get_attr_val_nl := 1
			l_a.ce_gets (get_attr_val (a_e, a_name))
			get_attr_val_nl := 0
			Result := l_a
		end

	get_exact_attr_val (a_e: CE_POINTER [NATURAL_8]; a_name: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_a: CE_POINTER [NATURAL_8]
		do
			create l_a.make

			get_attr_val_nl := 2
			l_a.ce_gets (get_attr_val (a_e, a_name))
			get_attr_val_nl := 0
			Result := l_a
		end

	roman (a_p: CE_POINTER [INTEGER_8]; a_n: NATURAL_32)
		local
			l_n: NATURAL_32
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			l_n := a_n
			l_i := 0
			if l_n >= {NATURAL_32} 4000 then
				strcpy (a_p, ce_string ("---")).do_nothing
				js.return
			end
			if not js.return_called and then (not l_n.to_boolean) then
				strcpy (a_p, ce_string ("o")).do_nothing
				js.return
			end
			if not js.return_called then
				a_p[0] := (0).to_integer_8
				from
				until
					not (not js.loop_left and then (l_n.to_boolean))
				loop
					from
					until
						not ((roman_tbl[l_i].n).to_natural_32 <= l_n)
					loop
						l_n := l_n - (roman_tbl[l_i].n).to_natural_32
						strcat (a_p, roman_tbl[l_i].s).do_nothing
					end
					l_i := l_i + 1
					if l_n.to_boolean then
						if not (roman_tbl[l_i].n).to_boolean then
							from
							until
								False
							loop
								links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")))
								links_inst.errline := 262
								error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("BUG in roman number convertor"))])
							end
							js.return
						end
					end
				end
			end
			if not js.return_called then
			end
		end

	decode_color (a_str: CE_POINTER [NATURAL_8]; a_col: CE_POINTER [PD_RGB]): INTEGER_32
		local
			l_str: CE_POINTER [NATURAL_8]
			l_ch: NATURAL_32
			l_cs: CE_POINTER [PD_COLOR_SPEC]
			l_end: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_str.make
			create l_cs.make
			create l_end.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_str.ce_gets (a_str)
					if (l_str.item).to_integer_32 = 35 then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_cs.ce_gets (color_specs)
				when 2 then -- loop condition:
						if not ((l_cs.c_pointer.to_integer_32).to_natural_32 < ((color_specs + (({PD_COLOR_SPEC}.sizeof.to_natural_32 * (140).to_natural_32) // {PD_COLOR_SPEC}.sizeof.to_natural_32).to_integer_32).c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						if not (strcasecmp (l_cs.item.name, create {CE_POINTER [INTEGER_8]}.make_cast (l_str))).to_boolean then
							l_ch := (l_cs.item.rgb).to_natural_32
							l_pos := -1 + 9 -- goto found
						end
				when 4 then
						l_cs.ce_gets (l_cs + 1)
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
						l_str.ce_gets (l_str - 1)
				when 6 then -- if done
					l_str.ce_gets (l_str + 1)
					if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_str))) /= {NATURAL_32} 6 then
						l_pos := -1 + 10 -- skip if block
					end
				when 7 then -- if:
						l_ch := strtoul (create {CE_POINTER [INTEGER_8]}.make_cast (l_str), (l_end.address), 16)
						if (l_end[0]).to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if not (l_ch < {NATURAL_32} 16777216) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | found:
						a_col.item.r := (l_ch // {NATURAL_32} 65536).to_natural_8
						a_col.item.g := ((l_ch // {NATURAL_32} 256) \\ {NATURAL_32} 256).to_natural_8
						a_col.item.b := (l_ch \\ {NATURAL_32} 256).to_natural_8
						Result := 0
						js.return
				when 10 then -- if done | if done | if done
						if not js.return_called then
							Result := (-1)
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	get_color (a_a: CE_POINTER [NATURAL_8]; a_c: CE_POINTER [NATURAL_8]; a_rgb: CE_POINTER [PD_RGB]): INTEGER_32
		local
			l_at: CE_POINTER [INTEGER_8]
			l_r: INTEGER_32
		do
			create l_at.make

			l_r := -1
			if links_inst.d_opt.item.col >= 1 then
				l_at.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((get_attr_val (a_a, a_c))))
				if ((l_at).c_pointer /= default_pointer) then
					l_r := decode_color (create {CE_POINTER [NATURAL_8]}.make_cast (l_at), a_rgb)
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 451, create {CE_POINTER [ANY]}.make_cast (l_at))
				end
			end
			Result := l_r
		end

	get_bgcolor (a_a: CE_POINTER [NATURAL_8]; a_rgb: CE_POINTER [PD_RGB]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if links_inst.d_opt.item.col < 2 then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				Result := (get_color (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bgcolor")), a_rgb))
			end
		end

	get_target (a_a: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_v: CE_POINTER [NATURAL_8]
		do
			create l_v.make

			l_v.ce_gets ((get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("target")))))
			if ((l_v).c_pointer /= default_pointer) then
				if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_v), ce_string ("_self"))).to_boolean then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 467, create {CE_POINTER [ANY]}.make_cast (l_v))
					l_v.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 468, links_inst.d_opt.item.framename))
				end
			end
			Result := l_v
		end

	kill_html_stack_item (a_e: CE_POINTER [PD_HTML_ELEMENT])
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_e.item.dontkill = 2 then
						from
						until
							False
						loop
							links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")))
							links_inst.errline := 477
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("trying to kill unkillable element"))])
						end
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if ((a_e).c_pointer /= default_pointer) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (a_e.c_pointer.to_integer_32).to_natural_32 /= ((html_stack.address).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							False
						loop
							links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")))
							links_inst.errline := 481
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("trying to free bad html element"))])
						end
						js.return
				when 6 then -- if done | if done
						if not js.return_called then
							if ((a_e.item.attr.link).c_pointer /= default_pointer) then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 484, create {CE_POINTER [ANY]}.make_cast (a_e.item.attr.link))
							end
							if ((a_e.item.attr.target).c_pointer /= default_pointer) then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 485, create {CE_POINTER [ANY]}.make_cast (a_e.item.attr.target))
							end
							if ((a_e.item.attr.image).c_pointer /= default_pointer) then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 486, create {CE_POINTER [ANY]}.make_cast (a_e.item.attr.image))
							end
							if ((a_e.item.attr.href_base).c_pointer /= default_pointer) then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 487, create {CE_POINTER [ANY]}.make_cast (a_e.item.attr.href_base))
							end
							if ((a_e.item.attr.target_base).c_pointer /= default_pointer) then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 488, create {CE_POINTER [ANY]}.make_cast (a_e.item.attr.target_base))
							end
							if ((a_e.item.attr.select2).c_pointer /= default_pointer) then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 489, create {CE_POINTER [ANY]}.make_cast (a_e.item.attr.select2))
							end
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_e));
							(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_e.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (a_e.item.prev);
							(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_e.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (a_e.item.next)
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_e))
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 491, create {CE_POINTER [ANY]}.make_cast (a_e))
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	debug_stack
		local
			l_e: CE_POINTER [PD_HTML_ELEMENT]
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			create l_e.make

			Io.put_string ("HTML stack debug: %N")
			l_e.ce_gets (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.prev))
			from
			until
				not (not js.loop_left and then ((l_e.c_pointer.to_integer_32).to_natural_32 /= ((html_stack.address).c_pointer.to_integer_32).to_natural_32))
			loop
				Io.put_string ("%"")
				l_i := 0
				from
				until
					not (l_i < l_e.item.namelen)
				loop
					Io.put_string (((l_e.item.name[l_i]).to_integer_32).to_character_8.out)
					l_i := l_i + 1
				end
				Io.put_string ("%"%N")
				l_e.ce_gets (l_e.item.prev)
			end
			Io.put_string ("")
			Io.standard_default.flush
			sleep ({NATURAL_32} 1).do_nothing
		end

	html_stack_dup
		local
			l_e: CE_POINTER [PD_HTML_ELEMENT]
			l_ep: CE_POINTER [PD_HTML_ELEMENT]
			l_tmp___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_e.make
			create l_ep.make
			create l_tmp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ep.ce_gets (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next))
					if (l_ep.c_pointer.to_integer_32).to_natural_32 /= ((html_stack.address).c_pointer.to_integer_32).to_natural_32 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if ((html_stack.next).c_pointer /= default_pointer) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							False
						loop
							links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")))
							links_inst.errline := 525
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html stack empty"))])
						end
						js.return
				when 5 then -- if done
						if not js.return_called then
							l_e.ce_gets (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 528, {PD_HTML_ELEMENT}.sizeof.to_natural_32))))
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_e), create {CE_POINTER [ANY]}.make_cast (l_ep), {PD_HTML_ELEMENT}.sizeof.to_natural_32).do_nothing
							l_e.item.attr.link := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 530, l_ep.item.attr.link)
							l_e.item.attr.target := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 531, l_ep.item.attr.target)
							l_e.item.attr.image := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 532, l_ep.item.attr.image)
							l_e.item.attr.href_base := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 533, l_ep.item.attr.href_base)
							l_e.item.attr.target_base := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 534, l_ep.item.attr.target_base)
							l_e.item.attr.select2 := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 535, l_ep.item.attr.select2)
							l_tmp___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							l_e.item.options := l_tmp___0
							l_e.item.name := l_tmp___0
							l_e.item.namelen := 0
							l_e.item.dontkill := 0
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((html_stack.address)))
								l_e.item.next := (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast ((html_stack.address))).item.next
								l_e.item.prev := create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast ((html_stack.address));
								(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast ((html_stack.address))).item.next := l_e;
								(l_e.item.next).item.prev := l_e
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((html_stack.address)))
								js.break
							end
							js.reset
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ln_break (a_n: INTEGER_32; a_line_break___0: CE_ROUTINE; a_f: CE_POINTER [ANY])
		local
			js: JUMP_STATE
		do
			if not a_n.to_boolean then
				js.return
			elseif ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.invisible).to_boolean then
				js.return
			end
			if not js.return_called then
				from
				until
					not (a_n > links_inst.line_breax)
				loop
					links_inst.line_breax := links_inst.line_breax + 1
					a_line_break___0.call ([a_f])
				end
				pos := 0
				putsp := -1
			end
		end

	put_chrs (a_start: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_put_chars___0: CE_ROUTINE; a_f: CE_POINTER [ANY])
		local
			l_start: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			create l_start.make

			l_start.ce_gets (a_start)
			l_len := a_len
			if (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align = 4 then
				putsp := 0
			end
			if not l_len.to_boolean then
				js.return
			elseif ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.invisible).to_boolean then
				js.return
			end
			if not js.return_called then
				if putsp = 1 then
					pos := pos + (a_put_chars___0.integer_32_item ([a_f, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), 1]))
					putsp := -1
				end
				if putsp = -1 then
					if (l_start[0]).to_integer_32 = 32 then
						l_start.ce_gets (l_start + 1)
						l_len := l_len - 1
					end
					putsp := 0
				end
				if not l_len.to_boolean then
					putsp := -1
					if (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align = 4 then
						putsp := 0
					end
					js.return
				end
			end
			if not js.return_called then
				if (l_start[(l_len - 1)]).to_integer_32 = 32 then
					putsp := -1
				end
				if (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align = 4 then
					putsp := 0
				end
				was_br := 0
				pos := pos + (a_put_chars___0.integer_32_item ([a_f, l_start, l_len]))
				links_inst.line_breax := 0
			end
		end

	kill_until (a_args: TUPLE [a_ls: INTEGER_32])
		local
			l_l: INTEGER_32
			l_e: CE_POINTER [PD_HTML_ELEMENT]
			l_sk: INTEGER_32
			l_arg: CE_VA_LIST
			l_s: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_e.make
			create l_s.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_e.ce_gets (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next))
					if a_args.a_ls.to_boolean then
						l_e.ce_gets (l_e.item.next)
					end
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_e.c_pointer.to_integer_32).to_natural_32 /= ((html_stack.address).c_pointer.to_integer_32).to_natural_32)) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_sk := 0
						create l_arg.make (a_args, 2)
				when 3 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 6 -- skip loop
						end
				when 4 then -- loop body:
						js.reset
						l_s.ce_gets ((create {CE_POINTER [INTEGER_8]}.make_cast (l_arg.pointer_item)))
						if (l_s).c_pointer = default_pointer then
							js.break
						end
						if not js.loop_jumped then
							if not (l_s[0]).to_boolean then
								l_sk := l_sk + 1
							elseif (l_e.item.namelen).to_natural_32 = (strlen (l_s)) then
								if not (links_inst.casecmp (l_e.item.name, create {CE_POINTER [NATURAL_8]}.make_cast (l_s), (strlen (l_s)))).to_boolean then
									if not l_sk.to_boolean then
										if (l_e.item.dontkill).to_boolean then
											js.break
										end
										if not js.loop_jumped then
											l_pos := -1 + 9 -- goto killll
										end
									elseif l_sk = 1 then
										l_pos := -1 + 8 -- goto killl
									else
										js.break
									end
								end
							end
						end
				when 5 then
						l_pos := -1 + 3 -- back to loop condition
				when 6 then -- loop done
						js.reset
						if (l_e.item.dontkill).to_boolean then
							js.break
						elseif l_e.item.namelen = 5 then
							if not (links_inst.casecmp (l_e.item.name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("TABLE")), (5).to_natural_32)).to_boolean then
								js.break
							end
						end
						if not js.loop_jumped and then (l_e.item.namelen = 2) then
							if (links_inst.upcase (l_e.item.name[0])).to_integer_32 = 84 then
								if (links_inst.upcase (l_e.item.name[1])).to_integer_32 = 68 then
									js.break
								elseif (links_inst.upcase (l_e.item.name[1])).to_integer_32 = 72 then
									js.break
								elseif (links_inst.upcase (l_e.item.name[1])).to_integer_32 = 82 then
									js.break
								end
							end
						end
						if not js.loop_jumped then
							l_e.ce_gets (l_e.item.next)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					js.reset
					js.return
					if js.return_called then
						l_pos := -1 + 10 -- skip if block
					end
				when 8 then -- if: | killl:
						l_e.ce_gets (l_e.item.prev)
				when 9 then -- killll:
						l_l := 0
						from
						until
							not (not js.loop_left and then ((l_e.c_pointer.to_integer_32).to_natural_32 /= ((html_stack.address).c_pointer.to_integer_32).to_natural_32))
						loop
							js.reset
							if a_args.a_ls.to_boolean then
								if (l_e.c_pointer.to_integer_32).to_natural_32 = ((html_stack.next).c_pointer.to_integer_32).to_natural_32 then
									js.break
								end
							end
							if not js.loop_jumped then
								if l_e.item.linebreak > l_l then
									l_l := l_e.item.linebreak
								end
								l_e.ce_gets (l_e.item.prev)
								kill_html_stack_item (l_e.item.next)
							end
						end
						js.reset
						ln_break (l_l, links_inst.line_break_f, links_inst.ff)
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_num (a_a: CE_POINTER [NATURAL_8]; a_n: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_al: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			l_s: NATURAL_32
			js: JUMP_STATE
		do
			create l_al.make
			create l_end.make

			l_al.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((get_attr_val (a_a, a_n))))
			if ((l_al).c_pointer /= default_pointer) then
				l_s := (strtoul (l_al, (l_end.address), 10))
				if not (l_al[0]).to_boolean then
					l_s := {NATURAL_32} 4294967295
				elseif (l_end[0]).to_boolean then
					l_s := {NATURAL_32} 4294967295
				elseif l_s > {NATURAL_32} 10000 then
					l_s := {NATURAL_32} 4294967295
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 646, create {CE_POINTER [ANY]}.make_cast (l_al))
				Result := l_s.to_integer_32
				js.return
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	parse_width (a_w: CE_POINTER [NATURAL_8]; a_trunc: INTEGER_32): INTEGER_32
		local
			l_w: CE_POINTER [NATURAL_8]
			l_end: CE_POINTER [NATURAL_8]
			l_p: INTEGER_32
			l_s: INTEGER_32
			l_l: INTEGER_32
			js: JUMP_STATE
		do
			create l_w.make
			create l_end.make

			l_w.ce_gets (a_w)
			l_p := 0
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_w.item).to_integer_32 /= 9 then
					if (l_w.item).to_integer_32 /= 10 then
						if (l_w.item).to_integer_32 /= 12 then
							if (l_w.item).to_integer_32 /= 13 then
								if (l_w.item).to_integer_32 /= 32 then
									js.break
								end
							end
						end
					end
				end
				if not js.loop_jumped then
					l_w.ce_gets (l_w + 1)
				end
			end
			js.reset
			l_l := 0
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_w[l_l]).to_boolean then
					if (l_w[l_l]).to_integer_32 = 44 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_l := l_l + 1
				end
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				if l_l.to_boolean then
					if (l_w[(l_l - 1)]).to_integer_32 /= 9 then
						if (l_w[(l_l - 1)]).to_integer_32 /= 10 then
							if (l_w[(l_l - 1)]).to_integer_32 /= 12 then
								if (l_w[(l_l - 1)]).to_integer_32 /= 13 then
									if (l_w[(l_l - 1)]).to_integer_32 /= 32 then
										js.break
									end
								end
							end
						end
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_l := l_l - 1
				end
			end
			js.reset
			if not l_l.to_boolean then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				if (l_w[(l_l - 1)]).to_integer_32 = 37 then
					l_l := l_l - 1
					l_p := 1
				end
				from
				until
					js.loop_left
				loop
					js.reset
					if l_l.to_boolean then
						if (l_w[(l_l - 1)]).to_integer_32 /= 9 then
							if (l_w[(l_l - 1)]).to_integer_32 /= 10 then
								if (l_w[(l_l - 1)]).to_integer_32 /= 12 then
									if (l_w[(l_l - 1)]).to_integer_32 /= 13 then
										if (l_w[(l_l - 1)]).to_integer_32 /= 32 then
											js.break
										end
									end
								end
							end
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_l := l_l - 1
					end
				end
				js.reset
				if not l_l.to_boolean then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				l_s := (strtoul (create {CE_POINTER [INTEGER_8]}.make_cast (l_w), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast ((l_end.address)), 10)).to_integer_32
				if l_end.distance (l_w) < l_l then
					Result := (-1)
					js.return
				elseif l_s < 0 then
					Result := (-1)
					js.return
				elseif l_s > 10000 then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				if l_p.to_boolean then
					if a_trunc.to_boolean then
						l_s := (l_s * (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.width - (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin) - (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.rightmargin).to_integer_32) // 100
					else
						Result := (-1)
						js.return
					end
				else
					l_s := (l_s + 3) // 7
				end
			end
			if not js.return_called then
				if a_trunc.to_boolean then
					if l_s > (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.width - (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin) - (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.rightmargin).to_integer_32 then
						l_s := (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.width - (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin) - (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.rightmargin).to_integer_32
					end
				end
				if l_s < 0 then
					l_s := 0
				end
				Result := l_s.to_integer_32
			end
		end

	get_width (a_a: CE_POINTER [NATURAL_8]; a_n: CE_POINTER [NATURAL_8]; a_trunc: INTEGER_32): INTEGER_32
		local
			l_r: INTEGER_32
			l_w: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_w.make

			l_w.ce_gets (get_attr_val (a_a, a_n))
			if (l_w).c_pointer = default_pointer then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				l_r := parse_width (l_w, a_trunc)
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 682, create {CE_POINTER [ANY]}.make_cast (l_w))
				Result := l_r
			end
		end

	put_link_line (a_prefix: CE_POINTER [NATURAL_8]; a_linkname: CE_POINTER [NATURAL_8]; a_link___0: CE_POINTER [NATURAL_8]; a_target: CE_POINTER [NATURAL_8])
		do
			html_stack_dup
			ln_break (1, links_inst.line_break_f, links_inst.ff)
			if (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.link).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 700, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.link));
				(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.link := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
			if (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.target).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 701, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.target));
				(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.target := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.form := create {CE_POINTER [PD_FORM_CONTROL]}.make_shared (default_pointer)
			put_chrs (a_prefix, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_prefix))).to_integer_32, links_inst.put_chars_f, links_inst.ff);
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.link := url_inst.join_urls ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.href_base, a_link___0);
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.target := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 705, a_target)
			memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_RGB]}.make_shared ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).c_pointer + {PD_HTML_ELEMENT}.attr_offset + {PD_TEXT_ATTRIB}.fg_offset))), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_RGB]}.make_shared ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).c_pointer + {PD_HTML_ELEMENT}.attr_offset + {PD_TEXT_ATTRIB}.clink_offset))), {PD_RGB}.sizeof.to_natural_32).do_nothing
			put_chrs (a_linkname, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_linkname))).to_integer_32, links_inst.put_chars_f, links_inst.ff)
			ln_break (1, links_inst.line_break_f, links_inst.ff)
			kill_html_stack_item (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next))
		end

	html_span (a_a: CE_POINTER [NATURAL_8])
		do
		end

	html_span_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_span)
		end

	html_bold (a_a: CE_POINTER [NATURAL_8])
		do
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr).bit_or ((1))
		end

	html_bold_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_bold)
		end

	html_italic (a_a: CE_POINTER [NATURAL_8])
		do
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr).bit_or ((2))
		end

	html_italic_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_italic)
		end

	html_underline (a_a: CE_POINTER [NATURAL_8])
		do
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr).bit_or ((4))
		end

	html_underline_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_underline)
		end

	html_fixed (a_a: CE_POINTER [NATURAL_8])
		do
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr).bit_or ((8))
		end

	html_fixed_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_fixed)
		end

	html_a (a_a: CE_POINTER [NATURAL_8])
		local
			l_al: CE_POINTER [INTEGER_8]
			l_all: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_al.make
			create l_all.make

			l_al.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((get_url_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("href"))))))
			if ((l_al).c_pointer /= default_pointer) then
				l_all.ce_gets (l_al)
				from
				until
					(l_all[0]).to_integer_32 /= 32
				loop
					l_all.ce_gets (l_all + 1)
				end
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_all[0]).to_boolean then
						if (l_all[((strlen (l_all)) - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 32 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_all[((strlen (l_all)) - {NATURAL_32} 1).to_integer_32] := (0).to_integer_8
					end
				end
				js.reset
				if (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.link).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 725, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.link))
				end
				(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.link := url_inst.join_urls ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.href_base, create {CE_POINTER [NATURAL_8]}.make_cast (l_all))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 727, create {CE_POINTER [ANY]}.make_cast (l_al))
				l_al.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((get_target (a_a))))
				if ((l_al).c_pointer /= default_pointer) then
					if (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.target).c_pointer /= default_pointer) then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 729, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.target))
					end
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.target := create {CE_POINTER [NATURAL_8]}.make_cast (l_al)
				else
					if (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.target).c_pointer /= default_pointer) then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 732, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.target))
					end
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.target := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 733, (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.target_base)
				end
				memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_RGB]}.make_shared ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).c_pointer + {PD_HTML_ELEMENT}.attr_offset + {PD_TEXT_ATTRIB}.fg_offset))), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_RGB]}.make_shared ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).c_pointer + {PD_HTML_ELEMENT}.attr_offset + {PD_TEXT_ATTRIB}.clink_offset))), {PD_RGB}.sizeof.to_natural_32).do_nothing
			else
				kill_html_stack_item (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next))
			end
			l_al.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("name"))))))
			if ((l_al).c_pointer /= default_pointer) then
				links_inst.special_f.call ([links_inst.ff, 0, l_al])
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 740, create {CE_POINTER [ANY]}.make_cast (l_al))
			end
		end

	html_a_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_a)
		end

	html_font (a_a: CE_POINTER [NATURAL_8])
		local
			l_al: CE_POINTER [INTEGER_8]
			l_p: INTEGER_32
			l_s: NATURAL_32
			l_nn: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
		do
			create l_al.make
			create l_nn.make
			create l_end.make

			l_al.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("size"))))))
			if ((l_al).c_pointer /= default_pointer) then
				l_p := 0
				l_nn.ce_gets (l_al)
				if (l_al[0]).to_integer_32 = 43 then
					l_p := 1
					l_nn.ce_gets (l_nn + 1)
				end
				if (l_al[0]).to_integer_32 = 45 then
					l_p := -1
					l_nn.ce_gets (l_nn + 1)
				end
				l_s := strtoul (l_nn, (l_end.address), 10)
				if (l_nn[0]).to_boolean then
					if not (l_end[0]).to_boolean then
						if l_s > {NATURAL_32} 7 then
							l_s := {NATURAL_32} 7
						end
						if not l_p.to_boolean then
							(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.fontsize := l_s.to_integer_32
						else
							(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.fontsize := (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.fontsize).to_natural_32 + l_p.to_natural_32 * l_s).to_integer_32
						end
						if (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.fontsize < 1 then
							(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.fontsize := 1
						end
						if (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.fontsize > 7 then
							(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.fontsize := 7
						end
					end
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 762, create {CE_POINTER [ANY]}.make_cast (l_al))
			end
			get_color (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("color")), create {CE_POINTER [PD_RGB]}.make_shared ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).c_pointer + {PD_HTML_ELEMENT}.attr_offset + {PD_TEXT_ATTRIB}.fg_offset)).do_nothing
		end

	html_font_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_font)
		end

	html_img (a_a: CE_POINTER [NATURAL_8])
		local
			l_al: CE_POINTER [NATURAL_8]
			l_ismap: INTEGER_32
			l_usemap: INTEGER_32
			l_u: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_h: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_al.make
			create l_u.make
			create l_s.make
			create l_h.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_usemap := 0
					l_al.ce_gets (get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("usemap"))))
					if ((l_al).c_pointer /= default_pointer) then
						l_usemap := 1
						html_stack_dup
						if (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.link).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 776, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.link))
						end
						if (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.form).c_pointer /= default_pointer) then
							(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.form := create {CE_POINTER [PD_FORM_CONTROL]}.make_shared (default_pointer)
						end
						l_u.ce_gets (url_inst.join_urls ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.href_base, l_al));
						(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.link := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 779, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_u))) + {NATURAL_32} 5)))
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.link), ce_string ("MAP@")).do_nothing
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.link), create {CE_POINTER [INTEGER_8]}.make_cast (l_u)).do_nothing;
						(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr).bit_or ((1))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 783, create {CE_POINTER [ANY]}.make_cast (l_u))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 784, create {CE_POINTER [ANY]}.make_cast (l_al))
					end
					if (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.link).c_pointer /= default_pointer) then
						if (has_attr (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ismap")))).to_boolean then
							if not l_usemap.to_boolean then
								l_tmp___2 := 1
							else
								l_tmp___2 := 0
							end
						else
							l_tmp___2 := 0
						end
					else
						l_tmp___2 := 0
					end
					l_ismap := l_tmp___2
					l_al.ce_gets (get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("alt"))))
					if (l_al).c_pointer = default_pointer then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if: | _L___0:
						if (l_al.item).to_boolean then
							l_pos := -1 + 3 -- skip if block
						end
				when 2 then -- if: | _L:
						if ((l_al).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 788, create {CE_POINTER [ANY]}.make_cast (l_al))
						end
						if not (links_inst.d_opt.item.images).to_boolean then
							if ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.link).c_pointer = default_pointer then
								js.return
							end
						end
						if not js.return_called then
							if l_usemap.to_boolean then
								l_al.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 790, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("[USEMAP]"))))
							elseif l_ismap.to_boolean then
								l_al.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 791, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("[ISMAP]"))))
							else
								l_al.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 792, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("[IMG]"))))
							end
						end
				when 3 then -- if done | if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else:
						l_al.ce_gets (get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("title"))))
						if ((l_al).c_pointer /= default_pointer) then
							l_pos := -1 + 1 -- goto _L___0
						else
							l_pos := -1 + 2 -- goto _L
						end
				when 5 then
					if not js.return_called then
						if (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.image).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 794, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.image));
							(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.image := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						end
						if ((l_al).c_pointer /= default_pointer) then
							l_s.ce_gets (get_url_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("src"))))
							if ((l_s).c_pointer /= default_pointer) then
								(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.image := url_inst.join_urls ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.href_base, l_s)
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 799, create {CE_POINTER [ANY]}.make_cast (l_s))
							else
								l_s.ce_gets (get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("dynsrc"))))
								if ((l_s).c_pointer /= default_pointer) then
									(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.image := url_inst.join_urls ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.href_base, l_s)
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 799, create {CE_POINTER [ANY]}.make_cast (l_s))
								end
							end
							if l_ismap.to_boolean then
								html_stack_dup
								l_h.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 804, (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.link))
								links_inst.add_to_strn (l_h.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("?0,0")))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 806, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.link));
								(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.link := l_h
							end
							put_chrs (l_al, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_al))).to_integer_32, links_inst.put_chars_f, links_inst.ff)
							if l_ismap.to_boolean then
								kill_html_stack_item (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next))
							end
						end
						if (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.image).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 812, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.image));
							(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.image := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						end
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 813, create {CE_POINTER [ANY]}.make_cast (l_al))
						if l_usemap.to_boolean then
							kill_html_stack_item (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next))
						end
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	html_img_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_img)
		end

	html_body (a_a: CE_POINTER [NATURAL_8])
		do
			get_color (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("text")), create {CE_POINTER [PD_RGB]}.make_shared ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).c_pointer + {PD_HTML_ELEMENT}.attr_offset + {PD_TEXT_ATTRIB}.fg_offset)).do_nothing
			get_color (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("link")), create {CE_POINTER [PD_RGB]}.make_shared ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).c_pointer + {PD_HTML_ELEMENT}.attr_offset + {PD_TEXT_ATTRIB}.clink_offset)).do_nothing
			get_color (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("vlink")), create {CE_POINTER [PD_RGB]}.make_shared ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).c_pointer + {PD_HTML_ELEMENT}.attr_offset + {PD_TEXT_ATTRIB}.vlink_offset)).do_nothing
			get_bgcolor (a_a, create {CE_POINTER [PD_RGB]}.make_shared ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).c_pointer + {PD_HTML_ELEMENT}.attr_offset + {PD_TEXT_ATTRIB}.bg_offset)).do_nothing
			get_bgcolor (a_a, create {CE_POINTER [PD_RGB]}.make_shared ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).c_pointer + {PD_HTML_ELEMENT}.parattr_offset + {PD_PAR_ATTRIB}.bgcolor_offset)).do_nothing
		end

	html_body_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_body)
		end

	html_skip (a_a: CE_POINTER [NATURAL_8])
		local
			l_tmp: INTEGER_32
		do
			l_tmp := 1;
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.dontkill := l_tmp;
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.invisible := l_tmp
		end

	html_skip_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_skip)
		end

	html_title (a_a: CE_POINTER [NATURAL_8])
		local
			l_tmp: INTEGER_32
		do
			l_tmp := 1;
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.dontkill := l_tmp;
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.invisible := l_tmp
		end

	html_title_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_title)
		end

	html_center (a_a: CE_POINTER [NATURAL_8])
		local
			l_tmp: INTEGER_32
		do
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align := 1
			if not links_inst.table_level.to_boolean then
				l_tmp := 0;
				(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.rightmargin := l_tmp;
				(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin := l_tmp
			end
		end

	html_center_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_center)
		end

	html_linebrk (a_a: CE_POINTER [NATURAL_8])
		local
			l_al: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
		do
			create l_al.make

			l_al.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("align"))))))
			if ((l_al).c_pointer /= default_pointer) then
				if not (strcasecmp (l_al, ce_string ("left"))).to_boolean then
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align := 0
				end
				if not (strcasecmp (l_al, ce_string ("right"))).to_boolean then
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align := 2
				end
				if not (strcasecmp (l_al, ce_string ("center"))).to_boolean then
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align := 1
					if not links_inst.table_level.to_boolean then
						l_tmp___1 := 0;
						(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.rightmargin := l_tmp___1;
						(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin := l_tmp___1
					end
				end
				if not (strcasecmp (l_al, ce_string ("justify"))).to_boolean then
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align := 3
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 848, create {CE_POINTER [ANY]}.make_cast (l_al))
			end
		end

	html_linebrk_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_linebrk)
		end

	html_br (a_a: CE_POINTER [NATURAL_8])
		do
			html_linebrk (a_a)
			if was_br.to_boolean then
				ln_break (2, links_inst.line_break_f, links_inst.ff)
			end
			was_br := 1
		end

	html_br_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_br)
		end

	html_form (a_a: CE_POINTER [NATURAL_8])
		do
			was_br := 1
		end

	html_form_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_form)
		end

	html_p (a_a: CE_POINTER [NATURAL_8])
		do
			if (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin < links_inst.margin then
				(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin := links_inst.margin
			end
			if (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.rightmargin < links_inst.margin then
				(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.rightmargin := links_inst.margin
			end
			html_linebrk (a_a)
		end

	html_p_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_p)
		end

	html_address (a_a: CE_POINTER [NATURAL_8])
		do
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin) + 1;
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align := 0
		end

	html_address_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_address)
		end

	html_blockquote (a_a: CE_POINTER [NATURAL_8])
		do
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin := (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin + (2);
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align := 0
		end

	html_blockquote_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_blockquote)
		end

	html_h (a_h: INTEGER_32; a_a: CE_POINTER [INTEGER_8])
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:;
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align := 0
					html_linebrk (create {CE_POINTER [NATURAL_8]}.make_cast (a_a))
					inspect (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 1 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 0;
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin := (a_h - 2) * 2;
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.rightmargin := 0
					l_pos := -1 + 5 -- switch 1; break
				when 2 then -- switch 1, case 2;
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin := 0;
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.rightmargin := (a_h - 2) * 2
					l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case 1
					l_tmp := 0;
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.rightmargin := l_tmp;
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin := l_tmp
					l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, case 3
					l_tmp___0 := (a_h - 2) * 2;
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.rightmargin := l_tmp___0;
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin := l_tmp___0
					l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	html_h2 (a_a: CE_POINTER [NATURAL_8])
		do
			html_h (2, create {CE_POINTER [INTEGER_8]}.make_cast (a_a))
		end

	html_h2_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_h2)
		end

	html_h3 (a_a: CE_POINTER [NATURAL_8])
		do
			html_h (3, create {CE_POINTER [INTEGER_8]}.make_cast (a_a))
		end

	html_h3_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_h3)
		end

	html_h4 (a_a: CE_POINTER [NATURAL_8])
		do
			html_h (4, create {CE_POINTER [INTEGER_8]}.make_cast (a_a))
		end

	html_h4_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_h4)
		end

	html_h5 (a_a: CE_POINTER [NATURAL_8])
		do
			html_h (5, create {CE_POINTER [INTEGER_8]}.make_cast (a_a))
		end

	html_h5_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_h5)
		end

	html_h6 (a_a: CE_POINTER [NATURAL_8])
		do
			html_h (6, create {CE_POINTER [INTEGER_8]}.make_cast (a_a))
		end

	html_h6_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_h6)
		end

	html_pre (a_a: CE_POINTER [NATURAL_8])
		do
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align := 4;
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin > 1).to_integer;
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.rightmargin := 0
		end

	html_pre_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_pre)
		end

	html_hr (a_a: CE_POINTER [NATURAL_8])
		local
			l_i: INTEGER_32
			l_r: NATURAL_8
			l_q: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			l_r := (205).to_natural_8
			l_q := (get_num (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("size"))))
			if l_q >= 0 then
				if l_q < 2 then
					l_r := (196).to_natural_8
				end
			end
			html_stack_dup;
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align := 1
			if (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.link).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 927, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.link));
				(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.link := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.form := create {CE_POINTER [PD_FORM_CONTROL]}.make_shared (default_pointer)
			html_linebrk (a_a)
			if (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align = 3 then
				(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align := 1
			end
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin := links_inst.margin;
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.rightmargin := links_inst.margin
			l_i := get_width (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("width")), 1)
			if l_i = -1 then
				l_i := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.width - 2 * links_inst.margin) - 4
			end
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr := 16
			links_inst.special_f.call ([links_inst.ff, 6, 1])
			from
			until
				js.loop_left
			loop
				js.reset
				l_tmp___0 := l_i
				l_i := l_i - 1
				if not (l_tmp___0 > 0) then
					js.break
				end
				if not js.loop_jumped then
					put_chrs (create {CE_POINTER [NATURAL_8]}.make_shared ($l_r), 1, links_inst.put_chars_f, links_inst.ff)
				end
			end
			js.reset
			links_inst.special_f.call ([links_inst.ff, 6, 0])
			ln_break (2, links_inst.line_break_f, links_inst.ff)
			kill_html_stack_item (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next))
		end

	html_hr_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_hr)
		end

	html_table (a_a: CE_POINTER [NATURAL_8])
		do
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin := links_inst.margin;
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.rightmargin := links_inst.margin;
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align := 0
			html_linebrk (a_a);
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr := 0
		end

	html_table_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_table)
		end

	html_tr (a_a: CE_POINTER [NATURAL_8])
		do
			html_linebrk (a_a)
		end

	html_tr_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_tr)
		end

	html_th (a_a: CE_POINTER [NATURAL_8])
		do
			kill_until ([1, ce_string ("TD"), ce_string ("TH"), ce_string (""), ce_string ("TR"), ce_string ("TABLE"), create {CE_POINTER [ANY]}.make_shared (default_pointer)]);
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr).bit_or ((1))
			put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), 1, links_inst.put_chars_f, links_inst.ff)
		end

	html_th_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_th)
		end

	html_td (a_a: CE_POINTER [NATURAL_8])
		do
			kill_until ([1, ce_string ("TD"), ce_string ("TH"), ce_string (""), ce_string ("TR"), ce_string ("TABLE"), create {CE_POINTER [ANY]}.make_shared (default_pointer)]);
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr).bit_and ((-2))
			put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), 1, links_inst.put_chars_f, links_inst.ff)
		end

	html_td_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_td)
		end

	html_base (a_a: CE_POINTER [NATURAL_8])
		local
			l_al: CE_POINTER [INTEGER_8]
		do
			create l_al.make

			l_al.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((get_url_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("href"))))))
			if ((l_al).c_pointer /= default_pointer) then
				if (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.href_base).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 976, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.href_base))
				end
				(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.href_base := url_inst.join_urls ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.prev)).item.attr.href_base, create {CE_POINTER [NATURAL_8]}.make_cast (l_al))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 978, create {CE_POINTER [ANY]}.make_cast (l_al))
			end
			l_al.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((get_target (a_a))))
			if ((l_al).c_pointer /= default_pointer) then
				if (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.target_base).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 981, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.target_base))
				end
				(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.target_base := create {CE_POINTER [NATURAL_8]}.make_cast (l_al)
			end
		end

	html_base_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_base)
		end

	html_ul (a_a: CE_POINTER [NATURAL_8])
		local
			l_al: CE_POINTER [INTEGER_8]
			l_tmp___3: INTEGER_32
		do
			create l_al.make;

			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.list_level := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.list_level) + 1;
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.list_number := {NATURAL_32} 0;
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.flags := 1
			l_al.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("type"))))))
			if ((l_al).c_pointer /= default_pointer) then
				if (strcasecmp (l_al, ce_string ("disc"))).to_boolean then
					if not (strcasecmp (l_al, ce_string ("circle"))).to_boolean then
						(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.flags := 2
					end
				else
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.flags := 2
				end
				if not (strcasecmp (l_al, ce_string ("square"))).to_boolean then
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.flags := 3
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 996, create {CE_POINTER [ANY]}.make_cast (l_al))
			end
			l_tmp___3 := (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin + (2 + ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.list_level > 1).to_integer);
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin := l_tmp___3
			if l_tmp___3 > ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.width * 2) // 3 then
				if not links_inst.table_level.to_boolean then
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.width * 2) // 3
				end
			end
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align := 0;
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.dontkill := 1
		end

	html_ul_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_ul)
		end

	html_ol (a_a: CE_POINTER [NATURAL_8])
		local
			l_al: CE_POINTER [INTEGER_8]
			l_st: INTEGER_32
			l_tmp___7: INTEGER_32
		do
			create l_al.make;

			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.list_level := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.list_level) + 1
			l_st := get_num (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("start")))
			if l_st = -1 then
				l_st := 1
			end
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.list_number := l_st.to_natural_32;
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.flags := 1
			l_al.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("type"))))))
			if ((l_al).c_pointer /= default_pointer) then
				if not (strcmp (l_al, ce_string ("1"))).to_boolean then
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.flags := 1
				end
				if not (strcmp (l_al, ce_string ("a"))).to_boolean then
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.flags := 2
				end
				if not (strcmp (l_al, ce_string ("A"))).to_boolean then
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.flags := 3
				end
				if not (strcmp (l_al, ce_string ("r"))).to_boolean then
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.flags := 4
				end
				if not (strcmp (l_al, ce_string ("R"))).to_boolean then
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.flags := 5
				end
				if not (strcmp (l_al, ce_string ("i"))).to_boolean then
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.flags := 4
				end
				if not (strcmp (l_al, ce_string ("I"))).to_boolean then
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.flags := 5
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1021, create {CE_POINTER [ANY]}.make_cast (l_al))
			end
			l_tmp___7 := (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin + ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.list_level > 1).to_integer;
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin := l_tmp___7
			if l_tmp___7 > ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.width * 2) // 3 then
				if not links_inst.table_level.to_boolean then
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.width * 2) // 3
				end
			end
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align := 0;
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.dontkill := 1
		end

	html_ol_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_ol)
		end

	html_li (a_a: CE_POINTER [NATURAL_8])
		local
			l_x: CE_ARRAY [INTEGER_8]
			l_c: INTEGER_8
			l_n: CE_ARRAY [INTEGER_8]
			l_t: INTEGER_32
			l_s: INTEGER_32
			l_tmp___0: INTEGER_32
			l_x___0: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			create l_x.make (<<7>>)
			create l_n.make (<<32>>)
			create l_x___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.list_number).to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_x[0] := (('*').code).to_integer_8
						l_x[1] := (('&').code).to_integer_8
						l_x[2] := (('n').code).to_integer_8
						l_x[3] := (('b').code).to_integer_8
						l_x[4] := (('s').code).to_integer_8
						l_x[5] := (('p').code).to_integer_8
						l_x[6] := ((';').code).to_integer_8
						if (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.flags).bit_and (7)) = 2 then
							l_x[0] := (('o').code).to_integer_8
						end
						if (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.flags).bit_and (7)) = 3 then
							l_x[0] := (('+').code).to_integer_8
						end
						put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (l_x), 7, links_inst.put_chars_f, links_inst.ff);
						(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin := (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin + (2);
						(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align := 0
						putsp := -1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 3 then -- else:
						l_c := (0).to_integer_8
						l_t := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.flags).bit_and (7)
						l_s := (get_num (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("value"))))
						if l_s /= -1 then
							(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.list_number := l_s.to_natural_32
						end
						if l_t = 4 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_t /= 5 then
							if (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.list_number < {NATURAL_32} 10 then
								put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("&nbsp;")), 6, links_inst.put_chars_f, links_inst.ff)
								l_c := (1).to_integer_8
							else
								l_pos := -1 + 6 -- goto _L___0
							end
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L___0:
						if l_t = 2 then
							put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("&nbsp;")), 6, links_inst.put_chars_f, links_inst.ff)
							l_c := (1).to_integer_8
						elseif l_t = 3 then
							put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("&nbsp;")), 6, links_inst.put_chars_f, links_inst.ff)
							l_c := (1).to_integer_8
						end
				when 7 then
						if l_t /= 3 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L___2
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 10 then -- else:
						if l_t /= 2 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if: | _L___2:
						if ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.list_number).to_boolean then
							if l_t = 3 then
								l_tmp___0 := ('A').code
							else
								l_tmp___0 := ('a').code
							end
							l_n[0] := (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.list_number - {NATURAL_32} 1) \\ {NATURAL_32} 26 + l_tmp___0.to_natural_32).to_integer_8
						else
							l_n[0] := (0).to_integer_8
						end
						l_n[1] := (0).to_integer_8
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else:
						if l_t /= 5 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___1
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 16 then -- else:
						if l_t /= 4 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if: | _L___1:
						roman (l_n, (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.list_number)
						if l_t = 5 then
							l_x___0.ce_gets (l_n)
							from
							until
								not ((l_x___0[0]).to_boolean)
							loop
								l_x___0[0] := (links_inst.upcase ((l_x___0[0]).to_natural_8)).to_integer_8
								l_x___0.ce_gets (l_x___0 + 1)
							end
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:
						sprintf ([l_n, ce_string ("%%d"), (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.list_number]).do_nothing
				when 20 then -- if done | if done | if done
						put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (l_n), (strlen (l_n)).to_integer_32, links_inst.put_chars_f, links_inst.ff)
						put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".&nbsp;")), 7, links_inst.put_chars_f, links_inst.ff);
						(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin := (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin).to_natural_32 + (((strlen (l_n)) + l_c.to_natural_32) + {NATURAL_32} 2)).to_integer_32;
						(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align := 0;
						(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.list_number := {NATURAL_32} 0;
						((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.next).item.parattr.list_number := (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.next).item.parattr.list_number) + 1
						putsp := -1
				when 21 then -- if done
					links_inst.line_breax := 2
				when 22 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	html_li_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_li)
		end

	html_dl (a_a: CE_POINTER [NATURAL_8])
		do
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.flags := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.flags).bit_and ((-9))
			if (has_attr (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("compact")))).to_boolean then
				(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.flags := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.flags).bit_or ((8))
			end
			if ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.list_level).to_boolean then
				(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin := (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin + (5)
			end
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.list_level := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.list_level) + 1;
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.list_number := {NATURAL_32} 0;
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align := 0;
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.dd_margin := (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin;
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.dontkill := 1
			if not (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.flags).bit_and (8)).to_boolean then
				ln_break (2, links_inst.line_break_f, links_inst.ff);
				(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.linebreak := 2
			end
		end

	html_dl_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_dl)
		end

	html_dt (a_a: CE_POINTER [NATURAL_8])
		do
			kill_until ([0, ce_string (""), ce_string ("DL"), create {CE_POINTER [ANY]}.make_shared (default_pointer)]);
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align := 0;
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin := (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.dd_margin
			if not (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.flags).bit_and (8)).to_boolean then
				if not (has_attr (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("compact")))).to_boolean then
					ln_break (2, links_inst.line_break_f, links_inst.ff)
				end
			end
		end

	html_dt_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_dt)
		end

	html_dd (a_a: CE_POINTER [NATURAL_8])
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			kill_until ([0, ce_string (""), ce_string ("DL"), create {CE_POINTER [ANY]}.make_shared (default_pointer)])
			if links_inst.table_level.to_boolean then
				l_tmp___0 := 3
			else
				l_tmp___0 := 8
			end
			l_tmp := (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.dd_margin + l_tmp___0;
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin := l_tmp
			if l_tmp > ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.width * 2) // 3 then
				if not links_inst.table_level.to_boolean then
					(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.leftmargin := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.width * 2) // 3
				end
			end
			(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align := 0
		end

	html_dd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_dd)
		end

	get_html_form (a_a: CE_POINTER [NATURAL_8]; a_form___0: CE_POINTER [PD_FORM])
		local
			l_al: CE_POINTER [NATURAL_8]
			l_ch: CE_POINTER [NATURAL_8]
			l_ax: CE_POINTER [INTEGER_8]
			l_all: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_al.make
			create l_ch.make
			create l_ax.make
			create l_all.make
			create l_tmp___4.make

			a_form___0.item.method := 0
			l_al.ce_gets (get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("method"))))
			if ((l_al).c_pointer /= default_pointer) then
				if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_al), ce_string ("post"))).to_boolean then
					a_form___0.item.method := 1
					l_ax.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("enctype"))))))
					if ((l_ax).c_pointer /= default_pointer) then
						if not (strcasecmp (l_ax, ce_string ("multipart/form-data"))).to_boolean then
							a_form___0.item.method := 2
						end
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1113, create {CE_POINTER [ANY]}.make_cast (l_ax))
					end
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1116, create {CE_POINTER [ANY]}.make_cast (l_al))
			end
			l_al.ce_gets (get_url_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("action"))))
			if ((l_al).c_pointer /= default_pointer) then
				l_all.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (l_al))
				from
				until
					(l_all[0]).to_integer_32 /= 32
				loop
					l_all.ce_gets (l_all + 1)
				end
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_all[0]).to_boolean then
						if (l_all[((strlen (l_all)) - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 32 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_all[((strlen (l_all)) - {NATURAL_32} 1).to_integer_32] := (0).to_integer_8
					end
				end
				js.reset
				a_form___0.item.action := url_inst.join_urls ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.href_base, create {CE_POINTER [NATURAL_8]}.make_cast (l_all))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1123, create {CE_POINTER [ANY]}.make_cast (l_al))
			else
				l_tmp___4.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1125, (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.href_base))
				a_form___0.item.action := l_tmp___4
				l_ch.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___4), 1))))
				if ((l_ch).c_pointer /= default_pointer) then
					l_ch.item := (0).to_natural_8
				end
				if a_form___0.item.method = 0 then
					l_ch.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (a_form___0.item.action), ('?').code))))
					if ((l_ch).c_pointer /= default_pointer) then
						l_ch.item := (0).to_natural_8
					end
				end
			end
			l_al.ce_gets (get_target (a_a))
			if ((l_al).c_pointer /= default_pointer) then
				a_form___0.item.target := l_al
			else
				a_form___0.item.target := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1131, (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.target_base)
			end
			a_form___0.item.num := a_a.distance (links_inst.startf)
		end

	find_form_for_input (a_i: CE_POINTER [NATURAL_8])
		local
			l_s: CE_POINTER [NATURAL_8]
			l_ss: CE_POINTER [NATURAL_8]
			l_name: CE_POINTER [NATURAL_8]
			l_attr: CE_POINTER [NATURAL_8]
			l_lf: CE_POINTER [NATURAL_8]
			l_la: CE_POINTER [NATURAL_8]
			l_namelen: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_ss.make
			create l_name.make
			create l_attr.make
			create l_lf.make
			create l_la.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((form.action).c_pointer /= default_pointer) then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1140, create {CE_POINTER [ANY]}.make_cast (form.action))
					end
					if ((form.target).c_pointer /= default_pointer) then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1141, create {CE_POINTER [ANY]}.make_cast (form.target))
					end
					memset (create {CE_POINTER [ANY]}.make_cast ((form.address)), 0, {PD_FORM}.sizeof.to_natural_32).do_nothing
					if ((create {CE_POINTER [ANY]}.make_cast (links_inst.special_f.pointer_item ([links_inst.ff, 3, create {CE_POINTER [ANY]}.make_shared (default_pointer)])))).c_pointer = default_pointer then
						js.return
					end
					if not js.return_called and then ((links_inst.last_input_tag).c_pointer /= default_pointer) then
						if (a_i.c_pointer.to_integer_32).to_natural_32 <= (links_inst.last_input_tag.c_pointer.to_integer_32).to_natural_32 then
							if (a_i.c_pointer.to_integer_32).to_natural_32 > (links_inst.last_form_tag.c_pointer.to_integer_32).to_natural_32 then
								get_html_form (links_inst.last_form_attr, form.address)
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if ((links_inst.last_input_tag).c_pointer /= default_pointer) then
							if (a_i.c_pointer.to_integer_32).to_natural_32 > (links_inst.last_input_tag.c_pointer.to_integer_32).to_natural_32 then
								l_s.ce_gets (links_inst.last_form_tag)
							else
								l_s.ce_gets (links_inst.startf)
							end
						else
							l_s.ce_gets (links_inst.startf)
						end
						l_lf.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						l_la.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				when 2 then -- se:
						if js.loop_left then
							l_pos := -1 + 6 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if (l_s.c_pointer.to_integer_32).to_natural_32 < (a_i.c_pointer.to_integer_32).to_natural_32 then
							if (l_s.item).to_integer_32 = 60 then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | sp:
						l_s.ce_gets (l_s + 1)
				when 5 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 6 then -- loop done
						js.reset
						if (l_s.c_pointer.to_integer_32).to_natural_32 >= (a_i.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 11 -- goto end_parse
						end
				when 7 then
						if ((l_s + 2).c_pointer.to_integer_32).to_natural_32 <= (links_inst.eofff.c_pointer.to_integer_32).to_natural_32 then
							if (l_s[1]).to_integer_32 = 33 then
								l_s.ce_gets (skip_comment (l_s, a_i))
								l_pos := -1 + 2 -- goto se
							elseif (l_s[1]).to_integer_32 = 63 then
								l_s.ce_gets (skip_comment (l_s, a_i))
								l_pos := -1 + 2 -- goto se
							end
						end
				when 8 then
						l_ss.ce_gets (l_s)
						if (parse_element (l_s, a_i, l_name.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_namelen), l_attr.address, l_s.address)).to_boolean then
							l_pos := -1 + 4 -- goto sp
						end
				when 9 then
						if l_namelen /= 4 then
							l_pos := -1 + 2 -- goto se
						elseif (links_inst.casecmp (l_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("FORM")), (4).to_natural_32)).to_boolean then
							l_pos := -1 + 2 -- goto se
						end
				when 10 then
						l_lf.ce_gets (l_ss)
						l_la.ce_gets (l_attr)
						l_pos := -1 + 2 -- goto se
				when 11 then -- end_parse:
						if ((l_lf).c_pointer /= default_pointer) then
							links_inst.last_form_tag.ce_gets (l_lf)
							links_inst.last_form_attr.ce_gets (l_la)
							links_inst.last_input_tag.ce_gets (a_i)
							get_html_form (l_la, form.address)
						else
							memset (create {CE_POINTER [ANY]}.make_cast ((form.address)), 0, {PD_FORM}.sizeof.to_natural_32).do_nothing
						end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	html_button (a_a: CE_POINTER [NATURAL_8])
		local
			l_al: CE_POINTER [INTEGER_8]
			l_fc: CE_POINTER [PD_FORM_CONTROL]
			l_tmp___8: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_al.make
			create l_fc.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					find_form_for_input (a_a)
					l_fc.ce_gets (create {CE_POINTER [PD_FORM_CONTROL]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1181, {PD_FORM_CONTROL}.sizeof.to_natural_32))))
					memset (create {CE_POINTER [ANY]}.make_cast (l_fc), 0, {PD_FORM_CONTROL}.sizeof.to_natural_32).do_nothing
					l_al.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("type"))))))
					if (l_al).c_pointer = default_pointer then
						l_fc.item.type := 8
						l_pos := -1 + 3 -- goto xxx
					end
				when 1 then
					if (strcasecmp (l_al, ce_string ("submit"))).to_boolean then
						if (strcasecmp (l_al, ce_string ("reset"))).to_boolean then
							if (strcasecmp (l_al, ce_string ("button"))).to_boolean then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1200, create {CE_POINTER [ANY]}.make_cast (l_al))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1201, create {CE_POINTER [ANY]}.make_cast (l_fc))
								js.return
							else
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1190, create {CE_POINTER [ANY]}.make_cast (l_al))
								put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" [&nbsp;")), 8, links_inst.put_chars_f, links_inst.ff)
								l_al.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("value"))))))
								if ((l_al).c_pointer /= default_pointer) then
									put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (l_al), (strlen (l_al)).to_integer_32, links_inst.put_chars_f, links_inst.ff)
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1194, create {CE_POINTER [ANY]}.make_cast (l_al))
								else
									put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("BUTTON")), 6, links_inst.put_chars_f, links_inst.ff)
								end
								put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("&nbsp;] ")), 8, links_inst.put_chars_f, links_inst.ff)
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1197, create {CE_POINTER [ANY]}.make_cast (l_fc))
								js.return
							end
						else
							l_fc.item.type := 10
						end
					else
						l_fc.item.type := 8
					end
					if js.return_called then
						l_pos := -1 + 4 -- skip if block
					end
				when 2 then -- if:
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1204, create {CE_POINTER [ANY]}.make_cast (l_al))
				when 3 then -- xxx:
						l_fc.item.form_num := links_inst.last_form_tag.distance (links_inst.startf)
						l_fc.item.ctrl_num := a_a.distance (links_inst.last_form_tag)
						l_fc.item.position := a_a.distance (links_inst.startf)
						l_fc.item.method := form.method
						l_fc.item.action := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1210, form.action)
						l_fc.item.name := get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("name")))
						l_fc.item.default_value := get_exact_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("value")))
						if (has_attr (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("disabled")))).to_boolean then
							l_fc.item.ro := 2
						else
							if (has_attr (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("readonly")))).to_boolean then
								l_tmp___8 := 1
							else
								l_tmp___8 := 0
							end
							l_fc.item.ro := l_tmp___8
						end
						if l_fc.item.type = 9 then
							l_fc.item.alt := get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("alt")))
						end
						if l_fc.item.type = 8 then
							if (l_fc.item.default_value).c_pointer = default_pointer then
								l_fc.item.default_value := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1215, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Submit")))
							end
						end
						if l_fc.item.type = 10 then
							if (l_fc.item.default_value).c_pointer = default_pointer then
								l_fc.item.default_value := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1216, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Reset")))
							end
						end
						if (l_fc.item.default_value).c_pointer = default_pointer then
							l_fc.item.default_value := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1217, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
						end
						links_inst.special_f.call ([links_inst.ff, 1, l_fc]);
						(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.form := l_fc;
						(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr).bit_or ((1))
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	html_button_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_button)
		end

	html_input (a_a: CE_POINTER [NATURAL_8])
		local
			l_i: INTEGER_32
			l_al: CE_POINTER [NATURAL_8]
			l_fc: CE_POINTER [PD_FORM_CONTROL]
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___15: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_al.make
			create l_fc.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					find_form_for_input (a_a)
					l_fc.ce_gets (create {CE_POINTER [PD_FORM_CONTROL]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1233, {PD_FORM_CONTROL}.sizeof.to_natural_32))))
					memset (create {CE_POINTER [ANY]}.make_cast (l_fc), 0, {PD_FORM_CONTROL}.sizeof.to_natural_32).do_nothing
					l_al.ce_gets (get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("type"))))
					if (l_al).c_pointer = default_pointer then
						l_fc.item.type := 1
						l_pos := -1 + 3 -- goto xxx
					end
				when 1 then
					if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_al), ce_string ("text"))).to_boolean then
						if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_al), ce_string ("password"))).to_boolean then
							if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_al), ce_string ("checkbox"))).to_boolean then
								if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_al), ce_string ("radio"))).to_boolean then
									if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_al), ce_string ("submit"))).to_boolean then
										if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_al), ce_string ("reset"))).to_boolean then
											if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_al), ce_string ("file"))).to_boolean then
												if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_al), ce_string ("hidden"))).to_boolean then
													if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_al), ce_string ("image"))).to_boolean then
														if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_al), ce_string ("button"))).to_boolean then
															l_fc.item.type := 1
														else
															error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1249, create {CE_POINTER [ANY]}.make_cast (l_al))
															put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" [&nbsp;")), 8, links_inst.put_chars_f, links_inst.ff)
															l_al.ce_gets (get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("value"))))
															if ((l_al).c_pointer /= default_pointer) then
																put_chrs (l_al, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_al))).to_integer_32, links_inst.put_chars_f, links_inst.ff)
																error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1253, create {CE_POINTER [ANY]}.make_cast (l_al))
															else
																put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("BUTTON")), 6, links_inst.put_chars_f, links_inst.ff)
															end
															put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("&nbsp;] ")), 8, links_inst.put_chars_f, links_inst.ff)
															error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1256, create {CE_POINTER [ANY]}.make_cast (l_fc))
															js.return
														end
													else
														l_fc.item.type := 9
													end
												else
													l_fc.item.type := 11
												end
											else
												l_fc.item.type := 3
											end
										else
											l_fc.item.type := 10
										end
									else
										l_fc.item.type := 8
									end
								else
									l_fc.item.type := 6
								end
							else
								l_fc.item.type := 5
							end
						else
							l_fc.item.type := 2
						end
					else
						l_fc.item.type := 1
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 2 then -- if:
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1259, create {CE_POINTER [ANY]}.make_cast (l_al))
				when 3 then -- xxx:
						l_fc.item.form_num := links_inst.last_form_tag.distance (links_inst.startf)
						l_fc.item.ctrl_num := a_a.distance (links_inst.last_form_tag)
						l_fc.item.position := a_a.distance (links_inst.startf)
						l_fc.item.method := form.method
						l_fc.item.action := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1265, form.action)
						l_fc.item.target := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1266, form.target)
						l_fc.item.name := get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("name")))
						if l_fc.item.type = 1 then
							l_fc.item.default_value := get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("value")))
						elseif l_fc.item.type = 2 then
							l_fc.item.default_value := get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("value")))
						elseif l_fc.item.type /= 3 then
							l_fc.item.default_value := get_exact_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("value")))
						end
						if l_fc.item.type = 5 then
							if (l_fc.item.default_value).c_pointer = default_pointer then
								l_fc.item.default_value := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1270, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("on")))
							end
						end
						l_tmp___11 := get_num (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("size")))
						l_fc.item.size := l_tmp___11
						if l_tmp___11 = -1 then
							l_fc.item.size := 20
						end
						l_fc.item.size := (l_fc.item.size) + 1
						if l_fc.item.size > links_inst.d_opt.item.xw then
							l_fc.item.size := links_inst.d_opt.item.xw
						end
						l_tmp___12 := get_num (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("maxlength")))
						l_fc.item.maxlength := l_tmp___12
						if l_tmp___12 = -1 then
							l_fc.item.maxlength := 536870911
						end
						if l_fc.item.type = 5 then
							l_fc.item.default_state := has_attr (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("checked")))
						elseif l_fc.item.type = 6 then
							l_fc.item.default_state := has_attr (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("checked")))
						end
						if (has_attr (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("disabled")))).to_boolean then
							l_fc.item.ro := 2
						else
							if (has_attr (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("readonly")))).to_boolean then
								l_tmp___15 := 1
							else
								l_tmp___15 := 0
							end
							l_fc.item.ro := l_tmp___15
						end
						if l_fc.item.type = 9 then
							l_fc.item.alt := get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("alt")))
						end
						if l_fc.item.type = 8 then
							if (l_fc.item.default_value).c_pointer = default_pointer then
								l_fc.item.default_value := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1278, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Submit")))
							end
						end
						if l_fc.item.type = 10 then
							if (l_fc.item.default_value).c_pointer = default_pointer then
								l_fc.item.default_value := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1279, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Reset")))
							end
						end
						if (l_fc.item.default_value).c_pointer = default_pointer then
							l_fc.item.default_value := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1280, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
						end
						if l_fc.item.type = 11 then
							l_pos := -1 + 11 -- goto hid
						end
				when 4 then
						put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), 1, links_inst.put_chars_f, links_inst.ff)
						html_stack_dup;
						(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.form := l_fc
						inspect l_fc.item.type -- switch 1 head
						when 1 then l_pos := -1 + 5
						when 2 then l_pos := -1 + 5
						when 3 then l_pos := -1 + 5
						when 5 then l_pos := -1 + 6
						when 6 then l_pos := -1 + 6
						when 9 then l_pos := -1 + 7
						when 8 then l_pos := -1 + 8
						when 10 then l_pos := -1 + 8
						else l_pos := -1 + 9
						end
				when 5 then -- switch 1, case 1 | switch 1, case 2 | switch 1, case 3;
						(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr).bit_or ((1))
						l_i := 0
						from
						until
							not (l_i < l_fc.item.size)
						loop
							put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("_")), 1, links_inst.put_chars_f, links_inst.ff)
							l_i := l_i + 1
						end
						l_pos := -1 + 10 -- switch 1; break
				when 6 then -- switch 1, case 5 | switch 1, case 6;
						(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr).bit_or ((1))
						put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("[&nbsp;]")), 8, links_inst.put_chars_f, links_inst.ff)
						l_pos := -1 + 10 -- switch 1; break
				when 7 then -- switch 1, case 9
						if (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.image).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1298, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.image));
							(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.image := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						end
						l_al.ce_gets (get_url_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("src"))))
						if ((l_al).c_pointer /= default_pointer) then
							(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.image := url_inst.join_urls ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.href_base, l_al)
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1301, create {CE_POINTER [ANY]}.make_cast (l_al))
						else
							l_al.ce_gets (get_url_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("dynsrc"))))
							if ((l_al).c_pointer /= default_pointer) then
								(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.image := url_inst.join_urls ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.href_base, l_al)
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1301, create {CE_POINTER [ANY]}.make_cast (l_al))
							end
						end
						(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr).bit_or ((1))
						put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("[&nbsp;")), 7, links_inst.put_chars_f, links_inst.ff)
						if ((l_fc.item.alt).c_pointer /= default_pointer) then
							put_chrs (l_fc.item.alt, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fc.item.alt))).to_integer_32, links_inst.put_chars_f, links_inst.ff)
						else
							put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Submit")), 6, links_inst.put_chars_f, links_inst.ff)
						end
						put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("&nbsp;]")), 7, links_inst.put_chars_f, links_inst.ff)
						l_pos := -1 + 10 -- switch 1; break
				when 8 then -- switch 1, case 8 | switch 1, case 10;
						(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr).bit_or ((1))
						put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("[&nbsp;")), 7, links_inst.put_chars_f, links_inst.ff)
						if ((l_fc.item.default_value).c_pointer /= default_pointer) then
							put_chrs (l_fc.item.default_value, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fc.item.default_value))).to_integer_32, links_inst.put_chars_f, links_inst.ff)
						end
						put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("&nbsp;]")), 7, links_inst.put_chars_f, links_inst.ff)
						l_pos := -1 + 10 -- switch 1; break
				when 9 then -- switch 1, default:
						from
						until
							False
						loop
							links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")))
							links_inst.errline := 1317
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bad control type"))])
						end
				when 10 then -- switch 1, done:
						kill_html_stack_item (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next))
						put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), 1, links_inst.put_chars_f, links_inst.ff)
				when 11 then -- hid:
						links_inst.special_f.call ([links_inst.ff, 1, l_fc])
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	html_input_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_input)
		end

	html_select (a_a: CE_POINTER [NATURAL_8])
		local
			l_al: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_al.make

			l_al.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("name"))))))
			if (l_al).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.dontkill := 1
				if (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.select2).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1331, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.select2))
				end
				(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.select2 := create {CE_POINTER [NATURAL_8]}.make_cast (l_al);
				(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.select_disabled := 2 * (has_attr (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("disabled"))))
			end
		end

	html_select_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_select)
		end

	html_option (a_a: CE_POINTER [NATURAL_8])
		local
			l_fc: CE_POINTER [PD_FORM_CONTROL]
			l_val: CE_POINTER [NATURAL_8]
			l_p: CE_POINTER [NATURAL_8]
			l_r: CE_POINTER [NATURAL_8]
			l_name: CE_POINTER [NATURAL_8]
			l_namelen: INTEGER_32
			l_l: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fc.make
			create l_val.make
			create l_p.make
			create l_r.make
			create l_name.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					find_form_for_input (a_a)
					if ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.select2).c_pointer = default_pointer then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 28 -- skip if block
					end
				when 1 then -- if:
						l_fc.ce_gets (create {CE_POINTER [PD_FORM_CONTROL]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1342, {PD_FORM_CONTROL}.sizeof.to_natural_32))))
						memset (create {CE_POINTER [ANY]}.make_cast (l_fc), 0, {PD_FORM_CONTROL}.sizeof.to_natural_32).do_nothing
						l_val.ce_gets (get_exact_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("value"))))
						if ((l_val).c_pointer /= default_pointer) then
							l_pos := -1 + 27 -- skip if block
						end
				when 2 then -- if:
						l_l := 0
						l_p.ce_gets (a_a - 1)
						from
						until
							(l_p.item).to_integer_32 = 60
						loop
							l_p.ce_gets (l_p - 1)
						end
						l_val.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1350))
						if (parse_element (l_p, eoff, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), l_p.address)).to_boolean then
							from
							until
								False
							loop
								links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")))
								links_inst.errline := 1352
								error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("parse element failed"))])
							end
							l_pos := -1 + 27 -- goto x
						end
				when 3 then -- rrrr:
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_p.c_pointer.to_integer_32).to_natural_32 < (eoff.c_pointer.to_integer_32).to_natural_32 then
								if (l_p.item).to_integer_32 /= 9 then
									if (l_p.item).to_integer_32 /= 10 then
										if (l_p.item).to_integer_32 /= 12 then
											if (l_p.item).to_integer_32 /= 13 then
												if (l_p.item).to_integer_32 /= 32 then
													js.break
												end
											end
										end
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p.ce_gets (l_p + 1)
							end
						end
						js.reset
				when 4 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 8 -- skip loop
						end
				when 5 then -- loop body:
						js.reset
						if (l_p.c_pointer.to_integer_32).to_natural_32 < (eoff.c_pointer.to_integer_32).to_natural_32 then
							if (l_p.item).to_integer_32 = 9 then
								js.break
							elseif (l_p.item).to_integer_32 = 10 then
								js.break
							elseif (l_p.item).to_integer_32 = 12 then
								js.break
							elseif (l_p.item).to_integer_32 = 13 then
								js.break
							elseif (l_p.item).to_integer_32 = 32 then
								js.break
							elseif (l_p.item).to_integer_32 = 60 then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | pppp:
						links_inst.add_chr_to_str (l_val.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_p.item)
						l_p.ce_gets (l_p + 1)
				when 7 then -- if done
						l_pos := -1 + 4 -- back to loop condition
				when 8 then -- loop done
						js.reset
						l_r.ce_gets (l_p)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_r.c_pointer.to_integer_32).to_natural_32 < (eoff.c_pointer.to_integer_32).to_natural_32 then
								if (l_r.item).to_integer_32 /= 9 then
									if (l_r.item).to_integer_32 /= 10 then
										if (l_r.item).to_integer_32 /= 12 then
											if (l_r.item).to_integer_32 /= 13 then
												if (l_r.item).to_integer_32 /= 32 then
													js.break
												end
											end
										end
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_r.ce_gets (l_r + 1)
							end
						end
						js.reset
						if (l_r.c_pointer.to_integer_32).to_natural_32 >= (eoff.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 27 -- goto x
						end
				when 9 then
						if ((l_r - 2).c_pointer.to_integer_32).to_natural_32 <= (eoff.c_pointer.to_integer_32).to_natural_32 then
							if (l_r[1]).to_integer_32 = 33 then
								l_p.ce_gets (skip_comment (l_r, eoff))
								l_pos := -1 + 3 -- goto rrrr
							elseif (l_r[1]).to_integer_32 = 63 then
								l_p.ce_gets (skip_comment (l_r, eoff))
								l_pos := -1 + 3 -- goto rrrr
							end
						end
				when 10 then
						if (parse_element (l_r, eoff, l_name.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_namelen), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), l_p.address)).to_boolean then
							l_pos := -1 + 6 -- goto pppp
						end
				when 11 then
						if l_namelen /= 6 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if (links_inst.casecmp (l_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("OPTION")), (6).to_natural_32)).to_boolean then
							l_pos := -1 + 14 -- goto _L___3
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 14 then -- else: | _L___3:
						if l_namelen /= 7 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if (links_inst.casecmp (l_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/OPTION")), (7).to_natural_32)).to_boolean then
							l_pos := -1 + 17 -- goto _L___2
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 17 then -- else: | _L___2:
						if l_namelen /= 6 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						if (links_inst.casecmp (l_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("SELECT")), (6).to_natural_32)).to_boolean then
							l_pos := -1 + 20 -- goto _L___1
						end
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 20 then -- else: | _L___1:
						if l_namelen /= 7 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						if (links_inst.casecmp (l_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/SELECT")), (7).to_natural_32)).to_boolean then
							l_pos := -1 + 23 -- goto _L___0
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 23 then -- else: | _L___0:
						if l_namelen /= 8 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						if (links_inst.casecmp (l_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("OPTGROUP")), (8).to_natural_32)).to_boolean then
							l_pos := -1 + 26 -- goto _L
						end
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else: | _L:
						if l_namelen = 9 then
							if (links_inst.casecmp (l_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/OPTGROUP")), (9).to_natural_32)).to_boolean then
								l_pos := -1 + 3 -- goto rrrr
							end
						else
							l_pos := -1 + 3 -- goto rrrr
						end
				when 27 then -- if done | if done | if done | if done | if done | x:
						l_fc.item.form_num := links_inst.last_form_tag.distance (links_inst.startf)
						l_fc.item.ctrl_num := a_a.distance (links_inst.last_form_tag)
						l_fc.item.position := a_a.distance (links_inst.startf)
						l_fc.item.method := form.method
						l_fc.item.action := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1381, form.action)
						l_fc.item.type := 5
						l_fc.item.name := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1383, (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.select2)
						l_fc.item.default_value := l_val
						l_fc.item.default_state := has_attr (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("selected")))
						l_fc.item.ro := (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.select_disabled
						if (has_attr (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("disabled")))).to_boolean then
							l_fc.item.ro := 2
						end
						put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), 1, links_inst.put_chars_f, links_inst.ff)
						html_stack_dup;
						(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.form := l_fc;
						(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr).bit_or ((1))
						put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("[ ]")), 3, links_inst.put_chars_f, links_inst.ff)
						kill_html_stack_item (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next))
						put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), 1, links_inst.put_chars_f, links_inst.ff)
						links_inst.special_f.call ([links_inst.ff, 1, l_fc])
				when 28 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	html_option_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_option)
		end

	clr_spaces (a_name: CE_POINTER [NATURAL_8])
		local
			l_n1: CE_POINTER [NATURAL_8]
			l_n2: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_n1.make
			create l_n2.make
			create l_tmp___0.make

			l_n1.ce_gets (a_name)
			from
			until
				not ((l_n1.item).to_boolean)
			loop
				if (l_n1.item).to_integer_32 = 9 then
					l_n1.item := ((' ').code).to_natural_8
				elseif (l_n1.item).to_integer_32 = 10 then
					l_n1.item := ((' ').code).to_natural_8
				elseif (l_n1.item).to_integer_32 = 12 then
					l_n1.item := ((' ').code).to_natural_8
				elseif (l_n1.item).to_integer_32 = 13 then
					l_n1.item := ((' ').code).to_natural_8
				elseif (l_n1.item).to_integer_32 = 32 then
					l_n1.item := ((' ').code).to_natural_8
				elseif (l_n1.item).to_integer_32 = 1 then
					l_n1.item := ((' ').code).to_natural_8
				end
				l_n1.ce_gets (l_n1 + 1)
			end
			if ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (a_name), (' ').code))).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				l_n1.ce_gets (a_name)
				l_n2.ce_gets (a_name)
				from
				until
					not ((l_n1.item).to_boolean)
				loop
					if (l_n1[0]).to_integer_32 = 32 then
						if (l_n2.c_pointer.to_integer_32).to_natural_32 /= (a_name.c_pointer.to_integer_32).to_natural_32 then
							if (l_n1[1]).to_integer_32 /= 32 then
								if (l_n1[1]).to_boolean then
									l_tmp___0.ce_gets (l_n2)
									l_n2.ce_gets (l_n2 + 1)
									l_tmp___0.item := l_n1.item
								end
							end
						end
					else
						l_tmp___0.ce_gets (l_n2)
						l_n2.ce_gets (l_n2 + 1)
						l_tmp___0.item := l_n1.item
					end
					l_n1.ce_gets (l_n1 + 1)
				end
				l_n2.item := (0).to_natural_8
			end
		end

	new_menu_item (a_name: CE_POINTER [NATURAL_8]; a_data: INTEGER_32; a_fullname: INTEGER_32)
		local
			l_name: CE_POINTER [NATURAL_8]
			l_top: CE_POINTER [PD_MENU_ITEM]
			l_item: CE_POINTER [PD_MENU_ITEM]
			l_nmenu: CE_POINTER [PD_MENU_ITEM]
			l_below: CE_POINTER [PD_MENU_ITEM]
			l_tmp___2: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_name.make
			create l_top.make
			create l_item.make
			create l_nmenu.make
			create l_below.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_name.ce_gets (a_name)
					l_nmenu.ce_gets (create {CE_POINTER [PD_MENU_ITEM]}.make_shared (default_pointer))
					if ((l_name).c_pointer /= default_pointer) then
						clr_spaces (l_name)
						if not (l_name[0]).to_boolean then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1422, create {CE_POINTER [ANY]}.make_cast (l_name))
							l_name.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1422, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" "))))
						end
						if (l_name[0]).to_integer_32 = 1 then
							l_name[0] := ((' ').code).to_natural_8
						end
					end
					if ((l_name).c_pointer /= default_pointer) then
						if a_data = -1 then
							l_nmenu.ce_gets (create {CE_POINTER [PD_MENU_ITEM]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1426, {PD_MENU_ITEM}.sizeof.to_natural_32))))
							memset (create {CE_POINTER [ANY]}.make_cast (l_nmenu), 0, {PD_MENU_ITEM}.sizeof.to_natural_32).do_nothing
						end
					end
					if not (menu_stack_size.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if ((l_name).c_pointer /= default_pointer) then
							l_item.ce_gets (menu_stack[(menu_stack_size - 1)])
							l_top.ce_gets (l_item)
							from
							until
								(l_item.item.text).c_pointer = default_pointer
							loop
								l_item.ce_gets (l_item + 1)
							end
							if ((create {CE_POINTER [INTEGER_8]}.make_cast ((l_item + 2))).distance ((create {CE_POINTER [INTEGER_8]}.make_cast (l_top)))).to_natural_32 > {NATURAL_32} 2147483647 then
								from
								until
									False
								loop
									error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html.c"), 1433])
									kbd_inst.fatal_tty_exit
									exit (4)
								end
							end
							l_top.ce_gets (create {CE_POINTER [PD_MENU_ITEM]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1434, create {CE_POINTER [ANY]}.make_cast (l_top), ((create {CE_POINTER [INTEGER_8]}.make_cast ((l_item + 2))).distance ((create {CE_POINTER [INTEGER_8]}.make_cast (l_top)))).to_natural_32))))
							l_item.ce_gets (l_top + (l_item.distance ((menu_stack[(menu_stack_size - 1)]))))
							menu_stack[(menu_stack_size - 1)] := l_top
							if menu_stack_size >= 2 then
								l_below.ce_gets (menu_stack[(menu_stack_size - 2)])
								from
								until
									(l_below.item.text).c_pointer = default_pointer
								loop
									l_below.ce_gets (l_below + 1)
								end
								(l_below + -1).item.data := create {CE_POINTER [ANY]}.make_cast (l_top)
							end
							l_item.item.text := l_name
							if a_data = -1 then
								l_item.item.rtext := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (">"))
							else
								l_item.item.rtext := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
							end
							if a_fullname.to_boolean then
								l_item.item.hotkey := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/0/%/1/"))
							else
								l_item.item.hotkey := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/0/%/0/"))
							end
							if a_data = -1 then
								l_item.item.func := (do_select_submenu_address)
							else
								l_item.item.func := (view_inst.selected_item_address)
							end
							if a_data = -1 then
								l_item.item.data := create {CE_POINTER [ANY]}.make_cast (l_nmenu)
							else
								l_item.item.data := create {CE_POINTER [ANY]}.make_shared (default_pointer + a_data)
							end
							if a_data = -1 then
								l_item.item.in_m := 1
							else
								l_item.item.in_m := 0
							end
							l_item.item.free_i := 0
							l_item.ce_gets (l_item + 1)
							memset (create {CE_POINTER [ANY]}.make_cast (l_item), 0, {PD_MENU_ITEM}.sizeof.to_natural_32).do_nothing
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if ((l_name).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1452, create {CE_POINTER [ANY]}.make_cast (l_name))
						end
				when 4 then
					if ((l_name).c_pointer /= default_pointer) then
						if a_data = -1 then
							if menu_stack_size.to_natural_32 > {NATURAL_32} 2147483647 // Pointer_bytes.to_natural_32 - {NATURAL_32} 1 then
								from
								until
									False
								loop
									error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html.c"), 1454])
									kbd_inst.fatal_tty_exit
									exit (4)
								end
							end
							menu_stack.ce_gets (create {CE_POINTER [CE_POINTER [PD_MENU_ITEM]]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1455, create {CE_POINTER [ANY]}.make_cast (menu_stack), (menu_stack_size + 1).to_natural_32 * Pointer_bytes.to_natural_32))))
							l_tmp___2 := menu_stack_size
							menu_stack_size := menu_stack_size + 1
							menu_stack[l_tmp___2] := l_nmenu
						end
					end
					if (l_name).c_pointer = default_pointer then
						menu_stack_size := menu_stack_size - 1
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	init_menu
		do
			menu_stack_size := 0
			menu_stack.ce_gets (create {CE_POINTER [CE_POINTER [PD_MENU_ITEM]]}.make_shared (default_pointer + -1))
			new_menu_item ((links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1465, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))), -1, 0)
		end

	free_menu (a_m: CE_POINTER [PD_MENU_ITEM])
		local
			l_mm: CE_POINTER [PD_MENU_ITEM]
		do
			create l_mm.make

			l_mm.ce_gets (a_m)
			from
			until
				(l_mm.item.text).c_pointer = default_pointer
			loop
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1472, create {CE_POINTER [ANY]}.make_cast (l_mm.item.text))
				if ((l_mm.item.func).c_pointer.to_integer_32).to_natural_32 = ((do_select_submenu_address).c_pointer.to_integer_32).to_natural_32 then
					free_menu (create {CE_POINTER [PD_MENU_ITEM]}.make_cast (l_mm.item.data))
				end
				l_mm.ce_gets (l_mm + 1)
			end
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1475, create {CE_POINTER [ANY]}.make_cast (a_m))
		end

	detach_menu: CE_POINTER [PD_MENU_ITEM]
		local
			l_i: CE_POINTER [PD_MENU_ITEM]
		do
			create l_i.make

			l_i.ce_gets (create {CE_POINTER [PD_MENU_ITEM]}.make_shared (default_pointer))
			if menu_stack_size.to_boolean then
				l_i.ce_gets (menu_stack[0])
			end
			if ((menu_stack).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1482, create {CE_POINTER [ANY]}.make_cast (menu_stack))
			end
			Result := l_i
		end

	destroy_menu
		do
			if ((menu_stack).c_pointer /= default_pointer) then
				if (menu_stack.c_pointer.to_integer_32).to_natural_32 /= (-1).to_natural_32 then
					free_menu (menu_stack[0])
				end
			end
			detach_menu.do_nothing
		end

	menu_labels (a_m: CE_POINTER [PD_MENU_ITEM]; a_base: CE_POINTER [NATURAL_8]; a_lbls: CE_POINTER [CE_POINTER [NATURAL_8]])
		local
			l_m: CE_POINTER [PD_MENU_ITEM]
			l_bs: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
		do
			create l_m.make
			create l_bs.make
			create l_tmp.make

			l_m.ce_gets (a_m)
			from
			until
				(l_m.item.text).c_pointer = default_pointer
			loop
				if ((l_m.item.func).c_pointer.to_integer_32).to_natural_32 = ((do_select_submenu_address).c_pointer.to_integer_32).to_natural_32 then
					l_bs.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1497, a_base))
					if ((l_bs).c_pointer /= default_pointer) then
						links_inst.add_to_strn (l_bs.address, l_m.item.text)
						links_inst.add_to_strn (l_bs.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
						menu_labels (create {CE_POINTER [PD_MENU_ITEM]}.make_cast (l_m.item.data), l_bs, a_lbls)
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1501, create {CE_POINTER [ANY]}.make_cast (l_bs))
					end
				else
					if (l_m.item.hotkey[1]).to_boolean then
						l_tmp.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
					else
						l_tmp.ce_gets (a_base)
					end
					l_bs.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1504, l_tmp))
					if ((l_bs).c_pointer /= default_pointer) then
						links_inst.add_to_strn (l_bs.address, l_m.item.text)
					end
					a_lbls[((l_m.item.data).c_pointer.to_integer_32).to_integer_32] := l_bs
				end
				l_m.ce_gets (l_m + 1)
			end
		end

	menu_contains (a_m: CE_POINTER [PD_MENU_ITEM]; a_f: INTEGER_32): INTEGER_32
		local
			l_m: CE_POINTER [PD_MENU_ITEM]
			js: JUMP_STATE
		do
			create l_m.make

			l_m.ce_gets (a_m)
			if ((l_m.item.func).c_pointer.to_integer_32).to_natural_32 /= ((do_select_submenu_address).c_pointer.to_integer_32).to_natural_32 then
				Result := (((l_m.item.data).c_pointer.to_integer_32).to_integer_32 = a_f).to_integer
				js.return
			end
			if not js.return_called then
				l_m.ce_gets (create {CE_POINTER [PD_MENU_ITEM]}.make_cast (l_m.item.data))
				from
				until
					not (not js.loop_left and then ((l_m.item.text).c_pointer /= default_pointer))
				loop
					if (menu_contains (l_m, a_f)).to_boolean then
						Result := 1
						js.return
					end
					if not js.return_called then
						l_m.ce_gets (l_m + 1)
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	do_select_submenu (a_term: CE_POINTER [PD_TERMINAL]; a_menu: CE_POINTER [PD_MENU_ITEM]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_m: CE_POINTER [PD_MENU_ITEM]
			l_def: INTEGER_32
			l_sel: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_m.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_def := (view_inst.get_current_state (a_ses))
					l_sel := 0
					if l_def < 0 then
						l_def := 0
					end
					l_m.ce_gets (a_menu)
				when 1 then -- loop condition:
					if (l_m.item.text).c_pointer = default_pointer then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if (menu_contains (l_m, l_def)).to_boolean then
							l_pos := -1 + 5 -- goto f
						end
				when 3 then
						l_m.ce_gets (l_m + 1)
						l_sel := l_sel + 1
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					l_sel := 0
				when 5 then -- f:
					bfu_inst.do_menu_selected (a_term, a_menu, create {CE_POINTER [ANY]}.make_cast (a_ses), l_sel)
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_select_submenu_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent do_select_submenu)
		end

	do_html_select (a_attr: CE_POINTER [NATURAL_8]; a_html: CE_POINTER [NATURAL_8]; a_eof: CE_POINTER [NATURAL_8]; a_end: CE_POINTER [CE_POINTER [NATURAL_8]]; a_f: CE_POINTER [ANY]): INTEGER_32
		local
			l_html: CE_POINTER [NATURAL_8]
			l_fc: CE_POINTER [PD_FORM_CONTROL]
			l_t_name: CE_POINTER [NATURAL_8]
			l_t_attr: CE_POINTER [NATURAL_8]
			l_en: CE_POINTER [NATURAL_8]
			l_t_namelen: INTEGER_32
			l_lbl: CE_POINTER [NATURAL_8]
			l_lbl_l: INTEGER_32
			l_vlbl: CE_POINTER [NATURAL_8]
			l_vlbl_l: INTEGER_32
			l_nnmi: INTEGER_32
			l_ct: CE_POINTER [PD_CONV_TABLE]
			l_val: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_lbls: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_order: INTEGER_32
			l_preselect: INTEGER_32
			l_group: INTEGER_32
			l_i: INTEGER_32
			l_mw: INTEGER_32
			l_i___0: INTEGER_32
			l_q: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_v: CE_POINTER [NATURAL_8]
			l_vx: CE_POINTER [NATURAL_8]
			l_tmp___7: INTEGER_32
			l_la: CE_POINTER [INTEGER_8]
			l_tmp___24: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_html.make
			create l_fc.make
			create l_t_name.make
			create l_t_attr.make
			create l_en.make
			create l_lbl.make
			create l_vlbl.make
			create l_ct.make
			create l_val.make
			create l_lbls.make
			create l_q.make
			create l_s.make
			create l_v.make
			create l_vx.make
			create l_la.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_html.ce_gets (a_html)
					l_nnmi := 0
					l_ct.ce_gets (create {CE_POINTER [PD_CONV_TABLE]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (links_inst.special_f.pointer_item ([a_f, 2, create {CE_POINTER [ANY]}.make_shared (default_pointer)])))))
					if (has_attr (a_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("multiple")))).to_boolean then
						Result := 1
						js.return
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						find_form_for_input (a_attr)
						l_lbl.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						l_lbl_l := 0
						l_vlbl.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						l_vlbl_l := 0
						l_val.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer + -1))
						l_order := 0
						l_group := 0
						l_preselect := -1
						init_menu
				when 2 then -- se:
						l_en.ce_gets (l_html)
				when 3 then -- see:
						l_html.ce_gets (l_en)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_html.c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32 then
								if (l_html.item).to_integer_32 = 60 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_html.ce_gets (l_html + 1)
							end
						end
						js.reset
						if not ((l_html.c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | abort:
						a_end.item := l_html
						if ((l_lbl).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1561, create {CE_POINTER [ANY]}.make_cast (l_lbl))
						end
						if ((l_vlbl).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1562, create {CE_POINTER [ANY]}.make_cast (l_vlbl))
						end
						l_i___0 := 0
						from
						until
							not (l_i___0 < l_order)
						loop
							if ((l_val[l_i___0]).c_pointer /= default_pointer) then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1563, create {CE_POINTER [ANY]}.make_cast (l_val[l_i___0]))
							end
							l_i___0 := l_i___0 + 1
						end
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1564, create {CE_POINTER [ANY]}.make_cast (l_val))
						destroy_menu
						a_end.item := l_en
						Result := 0
						js.return
				when 5 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 23 -- skip if block
						end
				when 6 then -- if:
							if ((l_lbl).c_pointer /= default_pointer) then
								l_s.ce_gets (l_en)
								l_l := l_html.distance (l_en)
								from
								until
									js.loop_left
								loop
									js.reset
									if l_l.to_boolean then
										if (l_s[0]).to_integer_32 /= 9 then
											if (l_s[0]).to_integer_32 /= 10 then
												if (l_s[0]).to_integer_32 /= 12 then
													if (l_s[0]).to_integer_32 /= 13 then
														if (l_s[0]).to_integer_32 /= 32 then
															js.break
														end
													end
												end
											end
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_s.ce_gets (l_s + 1)
										l_l := l_l - 1
									end
								end
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									if l_l.to_boolean then
										if (l_s[(l_l - 1)]).to_integer_32 /= 9 then
											if (l_s[(l_l - 1)]).to_integer_32 /= 10 then
												if (l_s[(l_l - 1)]).to_integer_32 /= 12 then
													if (l_s[(l_l - 1)]).to_integer_32 /= 13 then
														if (l_s[(l_l - 1)]).to_integer_32 /= 32 then
															js.break
														end
													end
												end
											end
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_l := l_l - 1
									end
								end
								js.reset
								l_q.ce_gets (charsets_inst.convert_string (l_ct, l_s, l_l))
								if ((l_q).c_pointer /= default_pointer) then
									links_inst.add_to_str (l_lbl.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_lbl_l), l_q)
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1575, create {CE_POINTER [ANY]}.make_cast (l_q))
								end
								links_inst.add_bytes_to_str (l_vlbl.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_vlbl_l), l_s, l_l)
							end
							if ((l_html + 2).c_pointer.to_integer_32).to_natural_32 <= (a_eof.c_pointer.to_integer_32).to_natural_32 then
								if (l_html[1]).to_integer_32 = 33 then
									l_html.ce_gets (skip_comment (l_html, a_eof))
									l_pos := -1 + 2 -- goto se
								elseif (l_html[1]).to_integer_32 = 63 then
									l_html.ce_gets (skip_comment (l_html, a_eof))
									l_pos := -1 + 2 -- goto se
								end
							end
				when 7 then
							if (parse_element (l_html, a_eof, l_t_name.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_t_namelen), l_t_attr.address, l_en.address)).to_boolean then
								l_html.ce_gets (l_html + 1)
								l_pos := -1 + 2 -- goto se
							end
				when 8 then
							if l_t_namelen = 7 then
								if not (links_inst.casecmp (l_t_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/SELECT")), (7).to_natural_32)).to_boolean then
									if ((l_lbl).c_pointer /= default_pointer) then
										if (l_val[(l_order - 1)]).c_pointer = default_pointer then
											l_val[(l_order - 1)] := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1588, l_vlbl)
										end
										if not l_nnmi.to_boolean then
											new_menu_item (l_lbl, l_order - 1, 1)
											l_lbl.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
										else
											error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1590, create {CE_POINTER [ANY]}.make_cast (l_lbl))
											l_lbl.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
										end
										error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1591, create {CE_POINTER [ANY]}.make_cast (l_vlbl))
										l_vlbl.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
									end
									l_pos := -1 + 21 -- goto end_parse
								end
							end
				when 9 then
							if l_t_namelen = 7 then
								if not (links_inst.casecmp (l_t_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/OPTION")), (7).to_natural_32)).to_boolean then
									if ((l_lbl).c_pointer /= default_pointer) then
										if (l_val[(l_order - 1)]).c_pointer = default_pointer then
											l_val[(l_order - 1)] := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1597, l_vlbl)
										end
										if not l_nnmi.to_boolean then
											new_menu_item (l_lbl, l_order - 1, 1)
											l_lbl.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
										else
											error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1599, create {CE_POINTER [ANY]}.make_cast (l_lbl))
											l_lbl.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
										end
										error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1600, create {CE_POINTER [ANY]}.make_cast (l_vlbl))
										l_vlbl.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
									end
									l_pos := -1 + 3 -- goto see
								end
							end
				when 10 then
							if l_t_namelen /= 6 then
								l_pos := -1 + 14 -- skip if block
							end
				when 11 then -- if:
							if (links_inst.casecmp (l_t_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("OPTION")), (6).to_natural_32)).to_boolean then
								l_pos := -1 + 14 -- skip if block
							end
				when 12 then -- if:
							if ((l_lbl).c_pointer /= default_pointer) then
								if (l_val[(l_order - 1)]).c_pointer = default_pointer then
									l_val[(l_order - 1)] := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1607, l_vlbl)
								end
								if not l_nnmi.to_boolean then
									new_menu_item (l_lbl, l_order - 1, 1)
									l_lbl.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								else
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1609, create {CE_POINTER [ANY]}.make_cast (l_lbl))
									l_lbl.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								end
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1610, create {CE_POINTER [ANY]}.make_cast (l_vlbl))
								l_vlbl.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							end
							if (has_attr (l_t_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("disabled")))).to_boolean then
								l_pos := -1 + 3 -- goto see
							end
				when 13 then
							if l_preselect = -1 then
								if (has_attr (l_t_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("selected")))).to_boolean then
									l_preselect := l_order
								end
							end
							l_v.ce_gets (get_exact_attr_val (l_t_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("value"))))
							if not ((l_order).bit_and (63)).to_boolean then
								if l_order.to_natural_32 > {NATURAL_32} 2147483647 // Pointer_bytes.to_natural_32 - {NATURAL_32} 64 then
									from
									until
										False
									loop
										error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html.c"), 1616])
										kbd_inst.fatal_tty_exit
										exit (4)
									end
								end
								if l_order.to_natural_32 > {NATURAL_32} 2147483647 // Pointer_bytes.to_natural_32 - {NATURAL_32} 64 then
									from
									until
										False
									loop
										error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html.c"), 1617])
										kbd_inst.fatal_tty_exit
										exit (4)
									end
								end
								l_val.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1618, create {CE_POINTER [ANY]}.make_cast (l_val), (l_order + 64).to_natural_32 * Pointer_bytes.to_natural_32))))
							end
							l_tmp___7 := l_order
							l_order := l_order + 1
							l_val[l_tmp___7] := l_v
							l_vx.ce_gets (get_attr_val (l_t_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("label"))))
							if ((l_vx).c_pointer /= default_pointer) then
								new_menu_item ((charsets_inst.convert_string (l_ct, l_vx, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_vx))).to_integer_32)), l_order - 1, 0)
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1623, create {CE_POINTER [ANY]}.make_cast (l_vx))
							end
							if (l_v).c_pointer = default_pointer then
								l_lbl.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1626))
								l_lbl_l := 0
								l_vlbl.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1627))
								l_vlbl_l := 0
								l_nnmi := (((l_vx).c_pointer /= default_pointer)).to_integer
							elseif (l_vx).c_pointer = default_pointer then
								l_lbl.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1626))
								l_lbl_l := 0
								l_vlbl.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1627))
								l_vlbl_l := 0
								l_nnmi := (((l_vx).c_pointer /= default_pointer)).to_integer
							end
							l_pos := -1 + 3 -- goto see
				when 14 then -- if done
							if l_t_namelen /= 8 then
								l_pos := -1 + 17 -- skip if block
							end
				when 15 then -- if:
							if (links_inst.casecmp (l_t_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("OPTGROUP")), (8).to_natural_32)).to_boolean then
								l_pos := -1 + 17 -- goto _L___0
							else
								l_pos := -1 + 19 -- goto _L
							end
				when 16 then -- if block done, skip else block:
							l_pos := -1 + 20
				when 17 then -- else: | _L___0:
							if l_t_namelen /= 9 then
								l_pos := -1 + 20 -- skip if block
							end
				when 18 then -- if:
							if (links_inst.casecmp (l_t_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/OPTGROUP")), (9).to_natural_32)).to_boolean then
								l_pos := -1 + 20 -- skip if block
							end
				when 19 then -- if: | _L:
							if ((l_lbl).c_pointer /= default_pointer) then
								if (l_val[(l_order - 1)]).c_pointer = default_pointer then
									l_val[(l_order - 1)] := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1634, l_vlbl)
								end
								if not l_nnmi.to_boolean then
									new_menu_item (l_lbl, l_order - 1, 1)
									l_lbl.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								else
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1636, create {CE_POINTER [ANY]}.make_cast (l_lbl))
									l_lbl.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								end
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1637, create {CE_POINTER [ANY]}.make_cast (l_vlbl))
								l_vlbl.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							end
							if l_group.to_boolean then
								new_menu_item (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), -1, 0)
								l_group := 0
							end
				when 20 then -- if done | if done
							if l_t_namelen = 8 then
								if not (links_inst.casecmp (l_t_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("OPTGROUP")), (8).to_natural_32)).to_boolean then
									l_la.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((get_attr_val (l_t_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("label"))))))
									if (l_la).c_pointer = default_pointer then
										l_la.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1643, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))))))
									end
									new_menu_item ((charsets_inst.convert_string (l_ct, create {CE_POINTER [NATURAL_8]}.make_cast (l_la), (strlen (l_la)).to_integer_32)), -1, 0)
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1645, create {CE_POINTER [ANY]}.make_cast (l_la))
									l_group := 1
								end
							end
							l_pos := -1 + 3 -- goto see
				when 21 then -- end_parse:
							a_end.item := l_en
							if not l_order.to_boolean then
								l_pos := -1 + 4 -- goto abort
							end
				when 22 then
							l_fc.ce_gets (create {CE_POINTER [PD_FORM_CONTROL]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1653, {PD_FORM_CONTROL}.sizeof.to_natural_32))))
							memset (create {CE_POINTER [ANY]}.make_cast (l_fc), 0, {PD_FORM_CONTROL}.sizeof.to_natural_32).do_nothing
							l_lbls.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1655, l_order.to_natural_32 * Pointer_bytes.to_natural_32))))
							memset (create {CE_POINTER [ANY]}.make_cast (l_lbls), 0, l_order.to_natural_32 * Pointer_bytes.to_natural_32).do_nothing
							l_fc.item.form_num := links_inst.last_form_tag.distance (links_inst.startf)
							l_fc.item.ctrl_num := a_attr.distance (links_inst.last_form_tag)
							l_fc.item.position := a_attr.distance (links_inst.startf)
							l_fc.item.method := form.method
							l_fc.item.action := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1661, form.action)
							l_fc.item.name := get_attr_val (a_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("name")))
							l_fc.item.type := 7
							if l_preselect < 0 then
								l_fc.item.default_state := 0
							else
								l_fc.item.default_state := l_preselect
							end
							if l_order.to_boolean then
								l_fc.item.default_value := (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1665, l_val[l_fc.item.default_state]))
							else
								l_fc.item.default_value := (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1665, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))))
							end
							if (has_attr (a_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("disabled")))).to_boolean then
								l_fc.item.ro := 2
							else
								if (has_attr (a_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("readonly")))).to_boolean then
									l_tmp___24 := 1
								else
									l_tmp___24 := 0
								end
								l_fc.item.ro := l_tmp___24
							end
							l_fc.item.nvalues := l_order
							l_fc.item.values := l_val
							l_fc.item.menu := detach_menu
							l_fc.item.labels := l_lbls
							menu_labels (l_fc.item.menu, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), l_lbls)
							put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("[")), 1, links_inst.put_chars_f, a_f)
							html_stack_dup;
							(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.form := l_fc;
							(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr).bit_or ((1))
							l_mw := 0
							l_i := 0
							from
							until
								not (l_i < l_order)
							loop
								if ((l_lbls[l_i]).c_pointer /= default_pointer) then
									if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_lbls[l_i]))) > l_mw.to_natural_32 then
										l_mw := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_lbls[l_i]))).to_integer_32
									end
								end
								l_i := l_i + 1
							end
							l_i := 0
							from
							until
								not (l_i < l_mw)
							loop
								put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("_")), 1, links_inst.put_chars_f, a_f)
								l_i := l_i + 1
							end
							kill_html_stack_item (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next))
							put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("]")), 1, links_inst.put_chars_f, a_f)
							links_inst.special_f.call ([links_inst.ff, 1, l_fc])
							Result := 0
				when 23 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	html_textarea (a_a: CE_POINTER [NATURAL_8])
		do
			from
			until
				False
			loop
				links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")))
				links_inst.errline := 1687
				error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("This should be never called"))])
			end
		end

	html_textarea_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_textarea)
		end

	do_html_textarea (a_attr: CE_POINTER [NATURAL_8]; a_html: CE_POINTER [NATURAL_8]; a_eof: CE_POINTER [NATURAL_8]; a_end: CE_POINTER [CE_POINTER [NATURAL_8]]; a_f: CE_POINTER [ANY])
		local
			l_html: CE_POINTER [NATURAL_8]
			l_fc: CE_POINTER [PD_FORM_CONTROL]
			l_p: CE_POINTER [NATURAL_8]
			l_t_name: CE_POINTER [NATURAL_8]
			l_w: CE_POINTER [NATURAL_8]
			l_t_namelen: INTEGER_32
			l_cols: INTEGER_32
			l_rows: INTEGER_32
			l_i: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___10: INTEGER_32
			l_j: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_html.make
			create l_fc.make
			create l_p.make
			create l_t_name.make
			create l_w.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_html.ce_gets (a_html)
					find_form_for_input (a_attr)
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_html.c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_html.item).to_integer_32 /= 10 then
								if (l_html.item).to_integer_32 /= 13 then
									js.break
								end
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_html.ce_gets (l_html + 1)
						end
					end
					js.reset
					l_p.ce_gets (l_html)
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 5 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if (l_p.c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_p.item).to_integer_32 = 60 then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 4 -- skip if block
						end
				when 3 then -- if: | pp:
						l_p.ce_gets (l_p + 1)
				when 4 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 5 then -- loop done
					js.reset
					if (l_p.c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
						a_end.item := a_eof
						js.return
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 6 then -- if:
						if (parse_element (l_p, a_eof, l_t_name.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_t_namelen), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), a_end)).to_boolean then
							l_pos := -1 + 3 -- goto pp
						end
				when 7 then
						if l_t_namelen /= 9 then
							l_pos := -1 + 3 -- goto pp
						elseif (links_inst.casecmp (l_t_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/TEXTAREA")), (9).to_natural_32)).to_boolean then
							l_pos := -1 + 3 -- goto pp
						end
				when 8 then
						l_fc.ce_gets (create {CE_POINTER [PD_FORM_CONTROL]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1710, {PD_FORM_CONTROL}.sizeof.to_natural_32))))
						memset (create {CE_POINTER [ANY]}.make_cast (l_fc), 0, {PD_FORM_CONTROL}.sizeof.to_natural_32).do_nothing
						l_fc.item.form_num := links_inst.last_form_tag.distance (links_inst.startf)
						l_fc.item.ctrl_num := a_attr.distance (links_inst.last_form_tag)
						l_fc.item.position := a_attr.distance (links_inst.startf)
						l_fc.item.method := form.method
						l_fc.item.action := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1716, form.action)
						l_fc.item.name := get_attr_val (a_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("name")))
						l_fc.item.type := 4
						if (has_attr (a_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("disabled")))).to_boolean then
							l_fc.item.ro := 2
						else
							if (has_attr (a_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("readonly")))).to_boolean then
								l_tmp___4 := 1
							else
								l_tmp___4 := 0
							end
							l_fc.item.ro := l_tmp___4
						end
						l_fc.item.default_value := links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1720, l_html, l_p.distance (l_html))
						l_cols := get_num (a_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cols")))
						if l_cols <= 0 then
							l_cols := 40
						end
						l_cols := l_cols + 1
						l_rows := get_num (a_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("rows")))
						if l_rows <= 0 then
							l_rows := 7
						end
						if l_cols > links_inst.d_opt.item.xw then
							l_cols := links_inst.d_opt.item.xw
						end
						if l_rows > links_inst.d_opt.item.yw then
							l_rows := links_inst.d_opt.item.yw
						end
						l_fc.item.cols := l_cols
						l_fc.item.rows := l_rows
						l_fc.item.wrap := 1
						l_w.ce_gets (get_attr_val (a_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("wrap"))))
						if ((l_w).c_pointer /= default_pointer) then
							if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_w), ce_string ("hard"))).to_boolean then
								if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_w), ce_string ("physical"))).to_boolean then
									if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_w), ce_string ("off"))).to_boolean then
										l_fc.item.wrap := 0
									end
								else
									l_fc.item.wrap := 2
								end
							else
								l_fc.item.wrap := 2
							end
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1732, create {CE_POINTER [ANY]}.make_cast (l_w))
						end
						l_tmp___10 := get_num (a_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("maxlength")))
						l_fc.item.maxlength := l_tmp___10
						if l_tmp___10 = -1 then
							l_fc.item.maxlength := 536870911
						end
						if l_rows > 1 then
							ln_break (1, links_inst.line_break_f, a_f)
						else
							put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), 1, links_inst.put_chars_f, a_f)
						end
						html_stack_dup;
						(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.form := l_fc;
						(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.attr).bit_or ((1))
						l_i := 0
						from
						until
							not (not js.loop_left and then (l_i < l_rows))
						loop
							l_j := 0
							from
							until
								not (l_j < l_cols)
							loop
								put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("_")), 1, links_inst.put_chars_f, a_f)
								l_j := l_j + 1
							end
							if l_i < l_rows - 1 then
								ln_break (1, links_inst.line_break_f, a_f)
							end
							l_i := l_i + 1
						end
						kill_html_stack_item (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next))
						if l_rows > 1 then
							ln_break (1, links_inst.line_break_f, a_f)
						else
							put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), 1, links_inst.put_chars_f, a_f)
						end
						links_inst.special_f.call ([a_f, 1, l_fc])
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	html_iframe (a_a: CE_POINTER [NATURAL_8])
		local
			l_name: CE_POINTER [NATURAL_8]
			l_url: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_name.make
			create l_url.make

			l_url.ce_gets (get_url_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("src"))))
			if (l_url).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				l_name.ce_gets (get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("name"))))
				if (l_name).c_pointer = default_pointer then
					l_name.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1755, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))))
				end
				if (l_name.item).to_boolean then
					put_link_line (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("IFrame: ")), l_name, l_url, links_inst.d_opt.item.framename)
				else
					put_link_line (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("IFrame")), l_url, links_inst.d_opt.item.framename)
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1758, create {CE_POINTER [ANY]}.make_cast (l_name))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1759, create {CE_POINTER [ANY]}.make_cast (l_url))
			end
		end

	html_iframe_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_iframe)
		end

	html_noframes (a_a: CE_POINTER [NATURAL_8])
		do
			if (links_inst.d_opt.item.frames).to_boolean then
				html_skip (a_a)
			end
		end

	html_noframes_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_noframes)
		end

	html_frame (a_a: CE_POINTER [NATURAL_8])
		local
			l_name: CE_POINTER [NATURAL_8]
			l_u2: CE_POINTER [NATURAL_8]
			l_url: CE_POINTER [NATURAL_8]
			l_fp: PD_FRAME_PARAM
			js: JUMP_STATE
		do
			create l_name.make
			create l_u2.make
			create l_url.make
			create l_fp.make

			l_u2.ce_gets (get_url_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("src"))))
			if ((l_u2).c_pointer /= default_pointer) then
				l_url.ce_gets (url_inst.join_urls ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.href_base, l_u2))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1774, create {CE_POINTER [ANY]}.make_cast (l_u2))
			else
				l_url.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1771, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))))
			end
			if (l_url).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				l_name.ce_gets (get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("name"))))
				if (l_name).c_pointer = default_pointer then
					l_name.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1779, l_url))
				elseif not (l_name[0]).to_boolean then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1781, create {CE_POINTER [ANY]}.make_cast (l_name))
					l_name.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1782, l_url))
				end
				if not (links_inst.d_opt.item.frames).to_boolean then
					put_link_line (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Frame: ")), l_name, l_url, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
				elseif ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.frameset).c_pointer = default_pointer then
					put_link_line (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Frame: ")), l_name, l_url, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
				else
					l_fp.name := l_name
					l_fp.url := l_url
					l_fp.parent := (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.frameset
					if (((create {CE_POINTER [ANY]}.make_cast (links_inst.special_f.pointer_item ([links_inst.ff, 3, create {CE_POINTER [ANY]}.make_shared (default_pointer)])))).c_pointer /= default_pointer) then
						links_inst.special_f.call ([links_inst.ff, 5, l_fp.address])
					end
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1792, create {CE_POINTER [ANY]}.make_cast (l_name))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1793, create {CE_POINTER [ANY]}.make_cast (l_url))
			end
		end

	html_frame_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_frame)
		end

	parse_frame_widths (a_a: CE_POINTER [NATURAL_8]; a_ww: INTEGER_32; a_www: INTEGER_32; a_op: CE_POINTER [CE_POINTER [INTEGER_32]]; a_olp: CE_POINTER [INTEGER_32])
		local
			l_a: CE_POINTER [NATURAL_8]
			l_aa: CE_POINTER [NATURAL_8]
			l_q: INTEGER_32
			l_qq: INTEGER_32
			l_i: INTEGER_32
			l_d: INTEGER_32
			l_nn: INTEGER_32
			l_n: NATURAL_32
			l_oo: CE_POINTER [INTEGER_32]
			l_o: CE_POINTER [INTEGER_32]
			l_ol: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_nn___0: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_j: INTEGER_32
			l_m: INTEGER_32
			l_mj: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_a.make
			create l_aa.make
			create l_oo.make
			create l_o.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_a.ce_gets (a_a)
					l_ol := 0
					l_o.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer + -1))
				when 1 then -- new_ch:
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_a.item).to_integer_32 /= 9 then
							if (l_a.item).to_integer_32 /= 10 then
								if (l_a.item).to_integer_32 /= 12 then
									if (l_a.item).to_integer_32 /= 13 then
										if (l_a.item).to_integer_32 /= 32 then
											js.break
										end
									end
								end
							end
						end
						if not js.loop_jumped then
							l_a.ce_gets (l_a + 1)
						end
					end
					js.reset
					l_n := strtoul (create {CE_POINTER [INTEGER_8]}.make_cast (l_a), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast ((l_a.address)), 10)
					if l_n > {NATURAL_32} 10000 then
						l_n := {NATURAL_32} 10000
					end
					l_q := l_n.to_integer_32
					if (l_a.item).to_integer_32 = 37 then
						l_q := (l_q * a_ww) // 100
					elseif (l_a.item).to_integer_32 /= 42 then
						if a_www.to_boolean then
							l_tmp := a_www
						else
							l_tmp := 1
						end
						l_q := (l_q + (a_www - 1) // 2) // l_tmp
					else
						l_q := -l_q
						if not l_q.to_boolean then
							l_q := -1
						end
					end
					if l_ol.to_natural_32 > {NATURAL_32} 2147483647 // Integer_32_bytes.to_natural_32 - {NATURAL_32} 1 then
						from
						until
							False
						loop
							error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html.c"), 1813])
							kbd_inst.fatal_tty_exit
							exit (4)
						end
					end
					l_o.ce_gets (create {CE_POINTER [INTEGER_32]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1814, create {CE_POINTER [ANY]}.make_cast (l_o), (l_ol + 1).to_natural_32 * Integer_32_bytes.to_natural_32))))
					l_tmp___1 := l_ol
					l_ol := l_ol + 1
					l_o[l_tmp___1] := l_q
					l_aa.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_a), (',').code))))
					if ((l_aa).c_pointer /= default_pointer) then
						l_a.ce_gets (l_aa + 1)
						l_pos := -1 + 1 -- goto new_ch
					end
				when 2 then
					a_op.item := l_o
					a_olp.item := l_ol
					l_q := 2 * l_ol - 1
					l_i := 0
					from
					until
						not (l_i < l_ol)
					loop
						if l_o[l_i] > 0 then
							l_q := l_q + (l_o[l_i] - 1)
						end
						l_i := l_i + 1
					end
					if not (l_q >= a_ww) then
						l_pos := -1 + 5 -- skip if block
					end
				when 3 then -- if: | distribute:
						l_i := 0
						from
						until
							not (l_i < l_ol)
						loop
							if l_o[l_i] < 1 then
								l_o[l_i] := 1
							end
							l_i := l_i + 1
						end
						l_q := l_q - a_ww
						l_d := 0
						l_i := 0
						from
						until
							not (l_i < l_ol)
						loop
							l_d := l_d + (l_o[l_i])
							l_i := l_i + 1
						end
						l_qq := l_q
						l_i := 0
						from
						until
							not (l_i < l_ol)
						loop
							if l_d.to_boolean then
								l_tmp___3 := l_d
							else
								l_tmp___3 := 1
							end
							l_q := l_q - (l_o[l_i] - (l_o[l_i] * (l_d - l_qq)) // l_tmp___3)
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared ($l_d))))
							if l_d.to_boolean then
								l_tmp___4 := l_d
							else
								l_tmp___4 := 1
							end
							l_o[l_i] := (l_o[l_i] * (l_d - l_qq)) // l_tmp___4
							l_i := l_i + 1
						end
						from
						until
							not (not js.loop_left and then (l_q.to_boolean))
						loop
							js.reset
							l_nn := 0
							l_i := 0
							from
							until
								not (not js.loop_left and then (l_i < l_ol))
							loop
								js.reset
								if l_q < 0 then
									l_o[l_i] := (l_o[l_i]) + 1
									l_q := l_q + 1
									l_nn := 1
								end
								if l_q > 0 then
									if l_o[l_i] > 1 then
										l_o[l_i] := (l_o[l_i]) - 1
										l_q := l_q - 1
										l_nn := 1
									end
								end
								if not l_q.to_boolean then
									js.break
								end
								if not js.loop_jumped then
									l_i := l_i + 1
								end
							end
							js.reset
							if not l_nn.to_boolean then
								js.break
							end
						end
						js.reset
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						l_nn___0 := 0
						l_i := 0
						from
						until
							not (l_i < l_ol)
						loop
							if l_o[l_i] < 0 then
								l_nn___0 := 1
							end
							l_i := l_i + 1
						end
						if not l_nn___0.to_boolean then
							l_pos := -1 + 3 -- goto distribute
						end
				when 6 then
						if l_ol.to_natural_32 > {NATURAL_32} 2147483647 // Integer_32_bytes.to_natural_32 then
							from
							until
								False
							loop
								error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html.c"), 1850])
								kbd_inst.fatal_tty_exit
								exit (4)
							end
						end
						l_oo.ce_gets (create {CE_POINTER [INTEGER_32]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1851, l_ol.to_natural_32 * Integer_32_bytes.to_natural_32))))
						memcpy (create {CE_POINTER [ANY]}.make_cast (l_oo), create {CE_POINTER [ANY]}.make_cast (l_o), l_ol.to_natural_32 * Integer_32_bytes.to_natural_32).do_nothing
						l_i := 0
						from
						until
							not (l_i < l_ol)
						loop
							if l_o[l_i] < 1 then
								l_o[l_i] := 1
							end
							l_i := l_i + 1
						end
						l_q := a_ww - l_q
						l_d := 0
						l_i := 0
						from
						until
							not (l_i < l_ol)
						loop
							if l_oo[l_i] < 0 then
								l_d := l_d + (-l_oo[l_i])
							end
							l_i := l_i + 1
						end
						l_qq := l_q
						l_i := 0
						from
						until
							not (l_i < l_ol)
						loop
							if l_oo[l_i] < 0 then
								if l_d.to_boolean then
									l_tmp___6 := l_d
								else
									l_tmp___6 := 1
								end
								l_o[l_i] := l_o[l_i] + ((-l_oo[l_i] * l_qq) // l_tmp___6)
								if l_d.to_boolean then
									l_tmp___7 := l_d
								else
									l_tmp___7 := 1
								end
								l_q := l_q - ((-l_oo[l_i] * l_qq) // l_tmp___7)
							end
							l_i := l_i + 1
						end
						if l_q < 0 then
							l_q := 0
						end
						l_i := 0
						from
						until
							not (l_i < l_ol)
						loop
							if l_oo[l_i] < 0 then
								if l_q.to_boolean then
									l_o[l_i] := (l_o[l_i]) + 1
									l_q := l_q - 1
								end
							end
							l_i := l_i + 1
						end
						if l_q > 0 then
							l_q := 0
						end
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1873, create {CE_POINTER [ANY]}.make_cast (l_oo))
				when 7 then -- if done
					l_i := 0
					from
					until
						not (not js.loop_left and then (l_i < l_ol))
					loop
						if not (l_o[l_i]).to_boolean then
							l_m := 0
							l_mj := 0
							l_j := 0
							from
							until
								not (l_j < l_ol)
							loop
								if l_o[l_j] > l_m then
									l_m := l_o[l_j]
									l_mj := l_j
								end
								l_j := l_j + 1
							end
							if l_m.to_boolean then
								l_o[l_i] := 1
								l_o[l_mj] := (l_o[l_mj]) - 1
							end
						end
						l_i := l_i + 1
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	html_frameset (a_a: CE_POINTER [NATURAL_8])
		local
			l_x: INTEGER_32
			l_y: INTEGER_32
			l_fp: PD_FRAMESET_PARAM
			l_c: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [NATURAL_8]
			l_f: CE_POINTER [PD_FRAMESET_DESC]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fp.make
			create l_c.make
			create l_d.make
			create l_f.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (links_inst.d_opt.item.frames).to_boolean then
						js.return
					elseif ((create {CE_POINTER [ANY]}.make_cast (links_inst.special_f.pointer_item ([links_inst.ff, 3, create {CE_POINTER [ANY]}.make_shared (default_pointer)])))).c_pointer = default_pointer then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						l_c.ce_gets (get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cols"))))
						if (l_c).c_pointer = default_pointer then
							l_c.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1890, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("100%%"))))
						end
						l_d.ce_gets (get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("rows"))))
						if (l_d).c_pointer = default_pointer then
							l_d.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1891, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("100%%"))))
						end
						if (((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.frameset).c_pointer /= default_pointer) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_x := links_inst.d_opt.item.xw
						l_y := links_inst.d_opt.item.yw
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						l_f.ce_gets ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.frameset)
						if l_f.item.yp >= l_f.item.y then
							l_pos := -1 + 7 -- goto free_cd
						end
				when 5 then
						l_x := l_f.item.f[l_f.item.xp + l_f.item.yp * l_f.item.x].xw
						l_y := l_f.item.f[l_f.item.xp + l_f.item.yp * l_f.item.x].yw
				when 6 then -- if done
						parse_frame_widths (l_c, l_x, 10, create {CE_POINTER [CE_POINTER [INTEGER_32]]}.make_shared (l_fp.c_pointer + {PD_FRAMESET_PARAM}.xw_offset), create {CE_POINTER [INTEGER_32]}.make_shared (l_fp.c_pointer + {PD_FRAMESET_PARAM}.x_offset))
						parse_frame_widths (l_d, l_y, 16, create {CE_POINTER [CE_POINTER [INTEGER_32]]}.make_shared (l_fp.c_pointer + {PD_FRAMESET_PARAM}.yw_offset), create {CE_POINTER [INTEGER_32]}.make_shared (l_fp.c_pointer + {PD_FRAMESET_PARAM}.y_offset))
						l_fp.parent := (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.frameset
						if (l_fp.x).to_boolean then
							if (l_fp.y).to_boolean then
								(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.frameset := create {CE_POINTER [PD_FRAMESET_DESC]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (links_inst.special_f.pointer_item ([links_inst.ff, 4, l_fp.address]))))
							end
						end
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1905, create {CE_POINTER [ANY]}.make_cast (l_fp.xw))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1906, create {CE_POINTER [ANY]}.make_cast (l_fp.yw))
				when 7 then -- free_cd:
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1908, create {CE_POINTER [ANY]}.make_cast (l_c))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1909, create {CE_POINTER [ANY]}.make_cast (l_d))
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	html_frameset_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_frameset)
		end

	html_link (a_a: CE_POINTER [NATURAL_8])
		local
			l_name: CE_POINTER [NATURAL_8]
			l_url: CE_POINTER [NATURAL_8]
			l_title: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_name.make
			create l_url.make
			create l_title.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_name.ce_gets (get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("type"))))
					if ((l_name).c_pointer /= default_pointer) then
						if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_name), ce_string ("text/html"))).to_boolean then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1955, create {CE_POINTER [ANY]}.make_cast (l_name))
							js.return
						end
						if not js.return_called then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1958, create {CE_POINTER [ANY]}.make_cast (l_name))
						end
					end
					if not js.return_called then
						l_url.ce_gets (get_url_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("href"))))
						if (l_url).c_pointer = default_pointer then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						l_name.ce_gets (get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("rel"))))
						if (l_name).c_pointer = default_pointer then
							l_name.ce_gets (get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("rev"))))
							if (l_name).c_pointer = default_pointer then
								l_name.ce_gets (get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ref"))))
								if (l_name).c_pointer = default_pointer then
									l_name.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1964, l_url))
								end
							end
						end
						if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_name), ce_string ("stylesheet"))).to_boolean then
							if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_name), ce_string ("alternate stylesheet"))).to_boolean then
								if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_name), ce_string ("made"))).to_boolean then
									if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_name), ce_string ("icon"))).to_boolean then
										if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_name), ce_string ("shortcut icon"))).to_boolean then
											if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_name), ce_string ("apple-touch-icon"))).to_boolean then
												if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_name), ce_string ("meta"))).to_boolean then
													if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_name), ce_string ("pingback"))).to_boolean then
														if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_name), ce_string ("File-List"))).to_boolean then
															if not (links_inst.casecmp (l_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("schema")), (6).to_natural_32)).to_boolean then
																l_pos := -1 + 3 -- goto skip
															end
														else
															l_pos := -1 + 3 -- goto skip
														end
													else
														l_pos := -1 + 3 -- goto skip
													end
												else
													l_pos := -1 + 3 -- goto skip
												end
											else
												l_pos := -1 + 3 -- goto skip
											end
										else
											l_pos := -1 + 3 -- goto skip
										end
									else
										l_pos := -1 + 3 -- goto skip
									end
								else
									l_pos := -1 + 3 -- goto skip
								end
							else
								l_pos := -1 + 3 -- goto skip
							end
						else
							l_pos := -1 + 3 -- goto skip
						end
				when 2 then
						l_title.ce_gets (get_attr_val (a_a, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("title"))))
						if ((l_title).c_pointer /= default_pointer) then
							links_inst.add_to_strn (l_name.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (": ")))
							links_inst.add_to_strn (l_name.address, l_title)
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1978, create {CE_POINTER [ANY]}.make_cast (l_title))
						end
						put_link_line (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Link: ")), l_name, l_url, (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.attr.target_base)
				when 3 then -- skip:
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1982, create {CE_POINTER [ANY]}.make_cast (l_name))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 1983, create {CE_POINTER [ANY]}.make_cast (l_url))
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	html_link_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_link)
		end

	skip_comment (a_html: CE_POINTER [NATURAL_8]; a_eof: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_html: CE_POINTER [NATURAL_8]
			l_comm: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_html.make

			l_html.ce_gets (a_html)
			if ((l_html + 4).c_pointer.to_integer_32).to_natural_32 <= (a_eof.c_pointer.to_integer_32).to_natural_32 then
				if (l_html[2]).to_integer_32 = 45 then
					if (l_html[3]).to_integer_32 = 45 then
						l_tmp := 1
					else
						l_tmp := 0
					end
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			l_comm := l_tmp
			if l_comm.to_boolean then
				l_tmp___0 := 4
			else
				l_tmp___0 := 2
			end
			l_html.ce_gets (l_html + l_tmp___0)
			from
			until
				not (not js.loop_left and then ((l_html.c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32))
			loop
				js.reset
				if not l_comm.to_boolean then
					if (l_html[0]).to_integer_32 = 62 then
						Result := (l_html + 1)
						js.return
					end
				end
				if not js.return_called then
					if l_comm.to_boolean then
						if ((l_html + 2).c_pointer.to_integer_32).to_natural_32 <= (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_html[0]).to_integer_32 = 45 then
								if (l_html[1]).to_integer_32 = 45 then
									l_html.ce_gets (l_html + (2))
									from
									until
										js.loop_left
									loop
										js.reset
										if (l_html.c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32 then
											if (l_html.item).to_integer_32 /= 45 then
												js.break
											end
										else
											js.break
										end
										if not js.loop_jumped then
											l_html.ce_gets (l_html + 1)
										end
									end
									js.reset
									from
									until
										js.loop_left
									loop
										js.reset
										if (l_html.c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32 then
											if (l_html.item).to_integer_32 /= 9 then
												if (l_html.item).to_integer_32 /= 10 then
													if (l_html.item).to_integer_32 /= 12 then
														if (l_html.item).to_integer_32 /= 13 then
															if (l_html.item).to_integer_32 /= 32 then
																js.break
															end
														end
													end
												end
											end
										else
											js.break
										end
										if not js.loop_jumped then
											l_html.ce_gets (l_html + 1)
										end
									end
									js.reset
									if (l_html.c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
										Result := a_eof
										js.return
									end
									if not js.return_called and then ((l_html.item).to_integer_32 = 62) then
										Result := (l_html + 1)
										js.return
									end
									if not js.return_called then
										js.continue
									end
								end
							end
						end
					end
					if not js.loop_jumped then
						l_html.ce_gets (l_html + 1)
					end
				end
			end
			if not js.return_called then
				Result := a_eof
			end
		end

	process_head (a_head___0: CE_POINTER [NATURAL_8])
		local
			l_r: CE_POINTER [NATURAL_8]
			l_p: CE_POINTER [NATURAL_8]
		do
			create l_r.make
			create l_p.make

			l_r.ce_gets (http_inst.parse_http_header (a_head___0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Refresh")), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
			if ((l_r).c_pointer /= default_pointer) then
				l_p.ce_gets (http_inst.parse_header_param (l_r, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("URL"))))
				if ((l_p).c_pointer /= default_pointer) then
					put_link_line (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Refresh: ")), l_p, l_p, links_inst.d_opt.item.framename)
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2094, create {CE_POINTER [ANY]}.make_cast (l_p))
				else
					l_p.ce_gets (http_inst.parse_header_param (l_r, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))))
					if ((l_p).c_pointer /= default_pointer) then
						put_link_line (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Refresh: ")), l_p, l_p, links_inst.d_opt.item.framename)
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2094, create {CE_POINTER [ANY]}.make_cast (l_p))
					end
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2096, create {CE_POINTER [ANY]}.make_cast (l_r))
			end
		end

	qd (a_html: CE_POINTER [NATURAL_8]; a_eof: CE_POINTER [NATURAL_8]; a_len: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_l: INTEGER_32
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			a_len.item := 1
			if (a_html.c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
				from
				until
					False
				loop
					links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")))
					links_inst.errline := 2105
					error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("qd: out of data, html == %%p, eof == %%p")), a_html, a_eof])
				end
				Result := (-1)
				js.return
			end
			if not js.return_called and then ((a_html[0]).to_integer_32 /= 38) then
				Result := (a_html[0]).to_integer_32
				js.return
			end
			if not js.return_called and then (((a_html + 1).c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32) then
				Result := (-1)
				js.return
			end
			if not js.return_called and then ((a_html[1]).to_integer_32 /= 35) then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				l_l := 2
				from
				until
					js.loop_left
				loop
					js.reset
					if l_l < 10 then
						if not (((a_html + l_l).c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped and then ((a_html[l_l]).to_integer_32 = 59) then
						l_n := (charsets_inst.get_entity_number (a_html + 2, l_l - 2))
						if l_n >= 0 then
							a_len.item := l_l + 1
							Result := l_n
							js.return
						end
						if not js.return_called then
							js.break
						end
					end
					if not js.loop_jumped then
						l_l := l_l + 1
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	parse_html (a_html: CE_POINTER [NATURAL_8]; a_eof: CE_POINTER [NATURAL_8]; a_put_chars___0: CE_ROUTINE; a_line_break___0: CE_ROUTINE; a_special: CE_ROUTINE; a_f: CE_POINTER [ANY]; a_head___0: CE_POINTER [NATURAL_8])
		local
			l_html: CE_POINTER [NATURAL_8]
			l_lt: CE_POINTER [NATURAL_8]
			l_name: CE_POINTER [NATURAL_8]
			l_attr: CE_POINTER [NATURAL_8]
			l_end: CE_POINTER [NATURAL_8]
			l_namelen: INTEGER_32
			l_ei: CE_POINTER [PD_ELEMENT_INFO]
			l_inv: INTEGER_32
			l_h: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_q: INTEGER_32
			l_ee: CE_POINTER [NATURAL_8]
			l_nm: CE_POINTER [NATURAL_8]
			l_a: CE_POINTER [INTEGER_8]
			l_a___0: INTEGER_32
			l_pa: PD_PAR_ATTRIB
			l_e: CE_POINTER [PD_HTML_ELEMENT]
			l_e___0: CE_POINTER [PD_HTML_ELEMENT]
			l_ff___0: CE_POINTER [PD_HTML_ELEMENT]
			l_lnb: INTEGER_32
			l_xxx: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_html.make
			create l_lt.make
			create l_name.make
			create l_attr.make
			create l_end.make
			create l_ei.make
			create l_h.make
			create l_ee.make
			create l_nm.make
			create l_a.make
			create l_pa.make
			create l_e.make
			create l_e___0.make
			create l_ff___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_html.ce_gets (a_html)
					putsp := -1
					if links_inst.table_level.to_boolean then
						links_inst.line_breax := 2
					else
						links_inst.line_breax := 1
					end
					pos := 0
					was_br := 0
					links_inst.put_chars_f.ce_gets (a_put_chars___0)
					links_inst.line_break_f.ce_gets (a_line_break___0)
					links_inst.special_f.ce_gets (a_special)
					links_inst.ff.ce_gets (a_f)
					eoff.ce_gets (a_eof)
					if ((a_head___0).c_pointer /= default_pointer) then
						process_head (a_head___0)
					end
				when 1 then -- set_lt:
					links_inst.put_chars_f.ce_gets (a_put_chars___0)
					links_inst.line_break_f.ce_gets (a_line_break___0)
					links_inst.special_f.ce_gets (a_special)
					links_inst.ff.ce_gets (a_f)
					eoff.ce_gets (a_eof)
					l_lt.ce_gets (l_html)
				when 2 then -- loop condition:
					if not (not js.loop_left and then ((l_html.c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32)) then
						l_pos := -1 + 88 -- skip loop
					end
				when 3 then -- loop body:
						js.reset
						if (l_html.item).to_integer_32 /= 9 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 6 then -- else:
						if (l_html.item).to_integer_32 /= 10 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 9 then -- else:
						if (l_html.item).to_integer_32 /= 12 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 12 then -- else:
						if (l_html.item).to_integer_32 /= 13 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 15 then -- else:
						if (l_html.item).to_integer_32 /= 32 then
							l_pos := -1 + 22 -- skip if block
						end
				when 16 then -- if: | _L:
						if (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align = 4 then
							l_pos := -1 + 22 -- skip if block
						end
				when 17 then -- if:
						l_h.ce_gets (l_html)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_h.c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32 then
								if (l_h.item).to_integer_32 /= 9 then
									if (l_h.item).to_integer_32 /= 10 then
										if (l_h.item).to_integer_32 /= 12 then
											if (l_h.item).to_integer_32 /= 13 then
												if (l_h.item).to_integer_32 /= 32 then
													js.break
												end
											end
										end
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_h.ce_gets (l_h + 1)
							end
						end
						js.reset
						if ((l_h + 1).c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_h[0]).to_integer_32 = 60 then
								if (l_h[1]).to_integer_32 = 47 then
									if not (parse_element (l_h, a_eof, l_name.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_namelen), l_attr.address, l_end.address)).to_boolean then
										put_chrs (l_lt, l_html.distance (l_lt), a_put_chars___0, a_f)
										l_html.ce_gets (l_h)
										l_lt.ce_gets (l_html)
										if not ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.invisible).to_boolean then
											putsp := 1
										end
										l_pos := -1 + 49 -- goto element
									end
								end
							end
						end
				when 18 then
						l_html.ce_gets (l_html + 1)
						if not (pos + ((l_html.distance (l_lt)) - 1)).to_boolean then
							l_pos := -1 + 20 -- goto skip_w
						end
				when 19 then
						if (l_html[-1]).to_integer_32 = 32 then
							if (l_html.c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32 then
								if (l_html.item).to_integer_32 /= 9 then
									if (l_html.item).to_integer_32 /= 10 then
										if (l_html.item).to_integer_32 /= 12 then
											if (l_html.item).to_integer_32 /= 13 then
												if (l_html.item).to_integer_32 /= 32 then
													js.continue
												end
											end
										end
									end
								end
							end
							if not js.loop_jumped then
								put_chrs (l_lt, l_html.distance (l_lt), a_put_chars___0, a_f)
							end
						else
							put_chrs (l_lt, (l_html - 1).distance (l_lt), a_put_chars___0, a_f)
							put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), 1, a_put_chars___0, a_f)
						end
						if js.loop_jumped then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if: | skip_w:
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_html.c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32 then
								if (l_html.item).to_integer_32 /= 9 then
									if (l_html.item).to_integer_32 /= 10 then
										if (l_html.item).to_integer_32 /= 12 then
											if (l_html.item).to_integer_32 /= 13 then
												if (l_html.item).to_integer_32 /= 32 then
													js.break
												end
											end
										end
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_html.ce_gets (l_html + 1)
							end
						end
						js.reset
						l_pos := -1 + 1 -- goto set_lt
				when 21 then -- put_sp:
						put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), 1, a_put_chars___0, a_f)
				when 22 then -- if done | if done | if done | if done | if done | if done
						if js.loop_jumped then
							l_pos := -1 + 48 -- skip if block
						end
				when 23 then -- if:
						if (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align /= 4 then
							l_pos := -1 + 39 -- skip if block
						end
				when 24 then -- if:
						if not ((l_html.item).to_integer_32 < 32) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 28 -- goto _L___1
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 27 then -- else:
						if (l_html.item).to_integer_32 /= 38 then
							l_pos := -1 + 39 -- skip if block
						end
				when 28 then -- if: | _L___1:
						l_q := (qd (l_html, a_eof, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l)))
						putsp := 0
						if l_q /= 9 then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						put_chrs (l_lt, l_html.distance (l_lt), a_put_chars___0, a_f)
						put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("        ")), 8 - pos \\ 8, a_put_chars___0, a_f)
						l_html.ce_gets (l_html + l_l)
						l_pos := -1 + 1 -- goto set_lt
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 31 then -- else:
						if l_q /= 13 then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						l_pos := -1 + 35 -- goto _L___0
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 34 then -- else:
						if l_q /= 10 then
							l_pos := -1 + 39 -- skip if block
						end
				when 35 then -- if: | _L___0:
						put_chrs (l_lt, l_html.distance (l_lt), a_put_chars___0, a_f)
				when 36 then -- next_break:
						l_html.ce_gets (l_html + l_l)
						if l_q = 13 then
							if (l_html.c_pointer.to_integer_32).to_natural_32 < ((a_eof - 1).c_pointer.to_integer_32).to_natural_32 then
								if (qd (l_html, a_eof, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l))) = 10 then
									l_html.ce_gets (l_html + l_l)
								end
							end
						end
						ln_break (1, a_line_break___0, a_f)
						if (l_html.c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 1 -- goto set_lt
						end
				when 37 then
						l_q := qd (l_html, a_eof, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l))
						if l_q = 13 then
							links_inst.line_breax := 0
							l_pos := -1 + 36 -- goto next_break
						elseif l_q = 10 then
							links_inst.line_breax := 0
							l_pos := -1 + 36 -- goto next_break
						end
				when 38 then
						l_pos := -1 + 1 -- goto set_lt
				when 39 then -- if done | if done | if done | if done | if done
						if (l_html.item).to_integer_32 < 32 then
							put_chrs (l_lt, l_html.distance (l_lt), a_put_chars___0, a_f)
							put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".")), 1, a_put_chars___0, a_f)
							l_html.ce_gets (l_html + 1)
							l_pos := -1 + 1 -- goto set_lt
						end
				when 40 then
						if not (((l_html + 2).c_pointer.to_integer_32).to_natural_32 <= (a_eof.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 47 -- skip if block
						end
				when 41 then -- if:
						if (l_html[0]).to_integer_32 /= 60 then
							l_pos := -1 + 47 -- skip if block
						end
				when 42 then -- if:
						if (l_html[1]).to_integer_32 /= 33 then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if:
						l_pos := -1 + 46 -- goto _L___2
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 45 then -- else:
						if (l_html[1]).to_integer_32 /= 63 then
							l_pos := -1 + 47 -- skip if block
						end
				when 46 then -- if: | _L___2:
						if not (links_inst.d_opt.item.plain).to_boolean then
							put_chrs (l_lt, l_html.distance (l_lt), a_put_chars___0, a_f)
							l_html.ce_gets (skip_comment (l_html, a_eof))
							l_pos := -1 + 1 -- goto set_lt
						end
				when 47 then -- if done | if done | if done
						if (l_html.item).to_integer_32 /= 60 then
							l_html.ce_gets (l_html + 1)
							js.continue
						elseif (links_inst.d_opt.item.plain).to_boolean then
							l_html.ce_gets (l_html + 1)
							js.continue
						elseif (parse_element (l_html, a_eof, l_name.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_namelen), l_attr.address, l_end.address)).to_boolean then
							l_html.ce_gets (l_html + 1)
							js.continue
						end
				when 48 then -- if done
						if js.loop_jumped then
							l_pos := -1 + 87 -- skip if block
						end
				when 49 then -- if: | element:
						l_inv := ((l_name.item).to_integer_32 = 47).to_integer
						l_name.ce_gets (l_name + l_inv)
						l_namelen := l_namelen - l_inv
						if not l_inv.to_boolean then
							if putsp = 1 then
								if not ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.invisible).to_boolean then
									l_pos := -1 + 21 -- goto put_sp
								end
							end
						end
				when 50 then
						put_chrs (l_lt, l_html.distance (l_lt), a_put_chars___0, a_f)
						if (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align = 4 then
							l_pos := -1 + 59 -- skip if block
						end
				when 51 then -- if:
						if l_inv.to_boolean then
							l_pos := -1 + 59 -- skip if block
						end
				when 52 then -- if:
						if putsp.to_boolean then
							l_pos := -1 + 59 -- skip if block
						end
				when 53 then -- if:
						l_ee.ce_gets (l_end)
				when 54 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 57 -- skip loop
						end
				when 55 then -- loop body:
						js.reset
						if (parse_element (l_ee, a_eof, l_nm.address, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), l_ee.address)).to_boolean then
							js.break
						end
						if not js.loop_jumped and then ((l_nm.item).to_integer_32 = 47) then
							l_pos := -1 + 58 -- goto ng
						end
				when 56 then
						l_pos := -1 + 54 -- back to loop condition
				when 57 then -- loop done
						js.reset
						if (l_ee.c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_ee.item).to_integer_32 = 9 then
								put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), 1, a_put_chars___0, a_f)
							elseif (l_ee.item).to_integer_32 = 10 then
								put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), 1, a_put_chars___0, a_f)
							elseif (l_ee.item).to_integer_32 = 12 then
								put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), 1, a_put_chars___0, a_f)
							elseif (l_ee.item).to_integer_32 = 13 then
								put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), 1, a_put_chars___0, a_f)
							elseif (l_ee.item).to_integer_32 = 32 then
								put_chrs (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), 1, a_put_chars___0, a_f)
							end
						end
				when 58 then -- ng:
						
				when 59 then -- if done | if done | if done
						l_html.ce_gets (l_end)
						l_ei.ce_gets (elements)
				when 60 then -- loop condition:
						if not (not js.loop_left and then ((l_ei.item.name).c_pointer /= default_pointer)) then
							l_pos := -1 + 86 -- skip loop
						end
				when 61 then -- loop body:
						js.reset
						if ((l_ei.item.name).c_pointer /= default_pointer) then
							if (strlen (l_ei.item.name)) /= l_namelen.to_natural_32 then
								js.continue
							elseif (links_inst.casecmp (create {CE_POINTER [NATURAL_8]}.make_cast (l_ei.item.name), l_name, l_namelen.to_natural_32)).to_boolean then
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 84 -- skip if block
						end
				when 62 then -- if:
						if l_inv.to_boolean then
							l_pos := -1 + 74 -- skip if block
						end
				when 63 then -- if:
						ln_break (l_ei.item.linebreak, a_line_break___0, a_f)
						if ((l_ei.item.name).c_pointer /= default_pointer) then
							l_a.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((get_attr_val (l_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("id"))))))
							if ((l_a).c_pointer /= default_pointer) then
								a_special.call ([a_f, 0, l_a])
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2251, create {CE_POINTER [ANY]}.make_cast (l_a))
							end
						end
						if ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.invisible).to_boolean then
							l_pos := -1 + 73 -- skip if block
						end
				when 64 then -- if:
						l_a___0 := ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr.align = 4).to_integer
						l_pa.ce_gets ((create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr)
						if ((l_ei.item.func).c_pointer.to_integer_32).to_natural_32 = ((html_table_address).c_pointer.to_integer_32).to_natural_32 then
							if (links_inst.d_opt.item.tables).to_boolean then
								if links_inst.table_level < 10 then
									html_tbl_inst.format_table (l_attr, l_html, a_eof, l_html.address, a_f)
									ln_break (2, a_line_break___0, a_f)
									l_pos := -1 + 1 -- goto set_lt
								end
							end
						end
				when 65 then
						if ((l_ei.item.func).c_pointer.to_integer_32).to_natural_32 = ((html_select_address).c_pointer.to_integer_32).to_natural_32 then
							if not (do_html_select (l_attr, l_html, a_eof, l_html.address, a_f)).to_boolean then
								l_pos := -1 + 1 -- goto set_lt
							end
						end
				when 66 then
						if ((l_ei.item.func).c_pointer.to_integer_32).to_natural_32 = ((html_textarea_address).c_pointer.to_integer_32).to_natural_32 then
							do_html_textarea (l_attr, l_html, a_eof, l_html.address, a_f)
							l_pos := -1 + 1 -- goto set_lt
						end
				when 67 then
						if l_ei.item.nopair /= 2 then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if:
						l_pos := -1 + 71 -- goto _L___3
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 72
				when 70 then -- else:
						if l_ei.item.nopair /= 3 then
							l_pos := -1 + 72 -- skip if block
						end
				when 71 then -- if: | _L___3:
						if l_ei.item.nopair = 2 then
							l_e.ce_gets (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next))
							from
							until
								not (not js.loop_left and then ((l_e.c_pointer.to_integer_32).to_natural_32 /= ((html_stack.address).c_pointer.to_integer_32).to_natural_32))
							loop
								js.reset
								if (l_e.item.dontkill).to_boolean then
									js.break
								end
								if not js.loop_jumped then
									if (l_e.item.linebreak).to_boolean then
										js.break
									elseif not (l_ei.item.linebreak).to_boolean then
										js.break
									end
								end
								if not js.loop_jumped then
									l_e.ce_gets (l_e.item.next)
								end
							end
							js.reset
						else
							l_e.ce_gets (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next))
							from
							until
								not (not js.loop_left and then ((l_e.c_pointer.to_integer_32).to_natural_32 /= ((html_stack.address).c_pointer.to_integer_32).to_natural_32))
							loop
								js.reset
								if (l_e.item.linebreak).to_boolean then
									if not (l_ei.item.linebreak).to_boolean then
										js.break
									end
								end
								if not js.loop_jumped and then ((l_e.item.dontkill).to_boolean) then
									js.break
								end
								if not js.loop_jumped and then (l_e.item.namelen = l_namelen) then
									if not (links_inst.casecmp (l_e.item.name, l_name, (l_e.item.namelen).to_natural_32)).to_boolean then
										js.break
									end
								end
								if not js.loop_jumped then
									l_e.ce_gets (l_e.item.next)
								end
							end
							js.reset
						end
						if l_e.item.namelen = l_namelen then
							if not (links_inst.casecmp (l_e.item.name, l_name, (l_e.item.namelen).to_natural_32)).to_boolean then
								from
								until
									((l_e.item.prev).c_pointer.to_integer_32).to_natural_32 = ((html_stack.address).c_pointer.to_integer_32).to_natural_32
								loop
									kill_html_stack_item (l_e.item.prev)
								end
								if l_e.item.dontkill /= 2 then
									kill_html_stack_item (l_e)
								end
							end
						end
				when 72 then -- if done
						if l_ei.item.nopair /= 1 then
							html_stack_dup;
							(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.name := l_name;
							(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.namelen := l_namelen;
							(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.options := l_attr;
							(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.linebreak := l_ei.item.linebreak
						end
						if ((l_ei.item.func).c_pointer /= default_pointer) then
							(l_ei.item.func).call ([l_attr])
						end
						if ((l_ei.item.func).c_pointer.to_integer_32).to_natural_32 /= ((html_br_address).c_pointer.to_integer_32).to_natural_32 then
							was_br := 0
						end
						if l_a___0.to_boolean then
							(create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next)).item.parattr := l_pa
						end
				when 73 then -- if done | if block done, skip else block:
						l_pos := -1 + 84
				when 74 then -- else:
						l_lnb := 0
						l_xxx := 0
						was_br := 0
						if l_ei.item.nopair = 1 then
							js.break
						elseif l_ei.item.nopair = 3 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 84 -- skip if block
						end
				when 75 then -- if:
						l_e___0.ce_gets (create {CE_POINTER [PD_HTML_ELEMENT]}.make_cast (html_stack.next))
				when 76 then -- loop condition:
						if not (not js.loop_left and then ((l_e___0.c_pointer.to_integer_32).to_natural_32 /= ((html_stack.address).c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 83 -- skip loop
						end
				when 77 then -- loop body:
						js.reset
						if (l_e___0.item.linebreak).to_boolean then
							if not (l_ei.item.linebreak).to_boolean then
								if ((l_ei.item.name).c_pointer /= default_pointer) then
									l_xxx := 1
								end
							end
						end
						if l_e___0.item.namelen = l_namelen then
							l_pos := -1 + 80 -- skip if block
						end
				when 78 then -- if:
						l_pos := -1 + 81 -- goto _L___4
				when 79 then -- if block done, skip else block:
						l_pos := -1 + 82
				when 80 then -- else:
						if not ((links_inst.casecmp (l_e___0.item.name, l_name, (l_e___0.item.namelen).to_natural_32)).to_boolean) then
							l_pos := -1 + 82 -- skip if block
						end
				when 81 then -- if: | _L___4:
						if (l_e___0.item.dontkill).to_boolean then
							js.break
						else
							js.continue
						end
				when 82 then -- if done
						if not js.loop_jumped and then (l_xxx.to_boolean) then
							kill_html_stack_item (l_e___0)
							js.break
						end
						if not js.loop_jumped then
							l_ff___0.ce_gets (l_e___0)
							from
							until
								(l_ff___0.c_pointer.to_integer_32).to_natural_32 = ((html_stack.address).c_pointer.to_integer_32).to_natural_32
							loop
								if l_ff___0.item.linebreak > l_lnb then
									l_lnb := l_ff___0.item.linebreak
								end
								l_ff___0.ce_gets (l_ff___0.item.prev)
							end
							ln_break (l_lnb, a_line_break___0, a_f)
							from
							until
								((l_e___0.item.prev).c_pointer.to_integer_32).to_natural_32 = ((html_stack.address).c_pointer.to_integer_32).to_natural_32
							loop
								kill_html_stack_item (l_e___0.item.prev)
							end
							kill_html_stack_item (l_e___0)
							js.break
						end
						if not js.loop_left then
							l_e___0.ce_gets (l_e___0.item.next)
						end
						l_pos := -1 + 76 -- back to loop condition
				when 83 then -- loop done
						js.reset
				when 84 then -- if done | if done | if done
						if not js.loop_jumped then
							l_pos := -1 + 1 -- goto set_lt
						end
				when 85 then
						if not js.loop_left then
							l_ei.ce_gets (l_ei + 1)
						end
						l_pos := -1 + 60 -- back to loop condition
				when 86 then -- loop done
						js.reset
						l_pos := -1 + 1 -- goto set_lt
				when 87 then
						l_pos := -1 + 2 -- back to loop condition
				when 88 then -- loop done
					put_chrs (l_lt, l_html.distance (l_lt), a_put_chars___0, a_f)
					ln_break (1, a_line_break___0, a_f)
					putsp := -1
					pos := 0
					was_br := 0
				when 89 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_image_map (a_head___0: CE_POINTER [NATURAL_8]; a_s: CE_POINTER [NATURAL_8]; a_eof: CE_POINTER [NATURAL_8]; a_tag: CE_POINTER [NATURAL_8]; a_menu: CE_POINTER [CE_POINTER [PD_MENU_ITEM]]; a_ml: CE_POINTER [CE_POINTER [PD_MEMORY_LIST]]; a_href_base: CE_POINTER [NATURAL_8]; a_target_base: CE_POINTER [NATURAL_8]; a_to: INTEGER_32; a_def: INTEGER_32; a_hdef: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_name: CE_POINTER [NATURAL_8]
			l_attr: CE_POINTER [NATURAL_8]
			l_al: CE_POINTER [NATURAL_8]
			l_label: CE_POINTER [NATURAL_8]
			l_href: CE_POINTER [NATURAL_8]
			l_target: CE_POINTER [NATURAL_8]
			l_namelen: INTEGER_32
			l_lblen: INTEGER_32
			l_ld: CE_POINTER [PD_LINK_DEF]
			l_nm: CE_POINTER [PD_MENU_ITEM]
			l_nmenu: INTEGER_32
			l_i: INTEGER_32
			l_hd: CE_POINTER [NATURAL_8]
			l_hdl: INTEGER_32
			l_ct: CE_POINTER [PD_CONV_TABLE]
			l_ss: CE_POINTER [NATURAL_8]
			l_l: CE_POINTER [NATURAL_8]
			l_tmp___18: CE_POINTER [NATURAL_8]
			l_ll: CE_POINTER [PD_LINK_DEF]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_name.make
			create l_attr.make
			create l_al.make
			create l_label.make
			create l_href.make
			create l_target.make
			create l_ld.make
			create l_nm.make
			create l_hd.make
			create l_ct.make
			create l_ss.make
			create l_l.make
			create l_tmp___18.make
			create l_ll.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s.ce_gets (a_s)
					l_nmenu := 0
					l_hd.ce_gets ((links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2343)))
					l_hdl := 0
					if ((a_head___0).c_pointer /= default_pointer) then
						links_inst.add_to_str (l_hd.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_hdl), a_head___0)
					end
					scan_http_equiv (l_s, a_eof, l_hd.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_hdl), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))
					l_ct.ce_gets (html_r_inst.get_convert_table (l_hd, a_to, a_def, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), a_hdef))
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2349, create {CE_POINTER [ANY]}.make_cast (l_hd))
					a_menu.item := create {CE_POINTER [PD_MENU_ITEM]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2350, {PD_MENU_ITEM}.sizeof.to_natural_32)))
					memset (create {CE_POINTER [ANY]}.make_cast (a_menu.item), 0, {PD_MENU_ITEM}.sizeof.to_natural_32).do_nothing
				when 1 then -- se:
					if js.loop_left then
						l_pos := -1 + 5 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if (l_s.c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_s.item).to_integer_32 = 60 then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 4 -- skip if block
						end
				when 3 then -- if: | sp:
						l_s.ce_gets (l_s + 1)
				when 4 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 5 then -- loop done
					js.reset
					if (l_s.c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2359, create {CE_POINTER [ANY]}.make_cast (a_menu.item))
						Result := (-1)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 20 -- skip if block
					end
				when 6 then -- if:
						if ((l_s + 2).c_pointer.to_integer_32).to_natural_32 <= (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_s[1]).to_integer_32 = 33 then
								l_s.ce_gets (skip_comment (l_s, a_eof))
								l_pos := -1 + 1 -- goto se
							elseif (l_s[1]).to_integer_32 = 63 then
								l_s.ce_gets (skip_comment (l_s, a_eof))
								l_pos := -1 + 1 -- goto se
							end
						end
				when 7 then
						if (parse_element (l_s, a_eof, l_name.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_namelen), l_attr.address, l_s.address)).to_boolean then
							l_pos := -1 + 3 -- goto sp
						end
				when 8 then
						if l_namelen /= 3 then
							l_pos := -1 + 1 -- goto se
						elseif (links_inst.casecmp (l_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("MAP")), (3).to_natural_32)).to_boolean then
							l_pos := -1 + 1 -- goto se
						end
				when 9 then
						if (a_tag).c_pointer = default_pointer then
							l_pos := -1 + 14 -- skip if block
						end
				when 10 then -- if:
						if not ((a_tag.item).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 11 then -- if:
						l_al.ce_gets (get_attr_val (l_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("name"))))
						if (l_al).c_pointer = default_pointer then
							l_pos := -1 + 1 -- goto se
						end
				when 12 then
						if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_al), create {CE_POINTER [INTEGER_8]}.make_cast (a_tag))).to_boolean then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2371, create {CE_POINTER [ANY]}.make_cast (l_al))
							l_pos := -1 + 1 -- goto se
						end
				when 13 then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2374, create {CE_POINTER [ANY]}.make_cast (l_al))
				when 14 then -- if done | if done
						a_ml.item := bfu_inst.getml ([create {CE_POINTER [ANY]}.make_shared (default_pointer)])
				when 15 then -- se2:
						if js.loop_left then
							l_pos := -1 + 19 -- skip loop
						end
				when 16 then -- loop body:
						js.reset
						if (l_s.c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_s.item).to_integer_32 = 60 then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | sp2:
						l_s.ce_gets (l_s + 1)
				when 18 then -- if done
						l_pos := -1 + 15 -- back to loop condition
				when 19 then -- loop done
						js.reset
						if (l_s.c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
							bfu_inst.freeml (a_ml.item)
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2384, create {CE_POINTER [ANY]}.make_cast (a_menu.item))
							Result := (-1)
							js.return
						end
				when 20 then -- if done
					if js.return_called then
						l_pos := -1 + 52 -- skip if block
					end
				when 21 then -- if:
						if ((l_s + 2).c_pointer.to_integer_32).to_natural_32 <= (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_s[1]).to_integer_32 = 33 then
								l_s.ce_gets (skip_comment (l_s, a_eof))
								l_pos := -1 + 15 -- goto se2
							elseif (l_s[1]).to_integer_32 = 63 then
								l_s.ce_gets (skip_comment (l_s, a_eof))
								l_pos := -1 + 15 -- goto se2
							end
						end
				when 22 then
						if (parse_element (l_s, a_eof, l_name.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_namelen), l_attr.address, l_s.address)).to_boolean then
							l_pos := -1 + 17 -- goto sp2
						end
				when 23 then
						if l_namelen /= 1 then
							l_pos := -1 + 48 -- skip if block
						end
				when 24 then -- if:
						if not ((links_inst.casecmp (l_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("A")), (1).to_natural_32)).to_boolean) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 48 -- goto _L___5
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 27 then -- else:
						l_label.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2394))
						l_lblen := 0
				when 28 then -- se3:
						l_ss.ce_gets (l_s)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_ss.c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32 then
								if (l_ss.item).to_integer_32 = 60 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_ss.ce_gets (l_ss + 1)
							end
						end
						js.reset
						if (l_ss.c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2400, create {CE_POINTER [ANY]}.make_cast (l_label))
							bfu_inst.freeml (a_ml.item)
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2402, create {CE_POINTER [ANY]}.make_cast (a_menu.item))
							Result := (-1)
							js.return
						end
						if js.return_called then
							l_pos := -1 + 47 -- skip if block
						end
				when 29 then -- if:
						links_inst.add_bytes_to_str (l_label.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_lblen), l_s, l_ss.distance (l_s))
						l_s.ce_gets (l_ss)
						if ((l_s + 2).c_pointer.to_integer_32).to_natural_32 <= (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_s[1]).to_integer_32 = 33 then
								l_s.ce_gets (skip_comment (l_s, a_eof))
								l_pos := -1 + 28 -- goto se3
							elseif (l_s[1]).to_integer_32 = 63 then
								l_s.ce_gets (skip_comment (l_s, a_eof))
								l_pos := -1 + 28 -- goto se3
							end
						end
				when 30 then
						if (parse_element (l_s, a_eof, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), l_ss.address)).to_boolean then
							l_pos := -1 + 28 -- goto se3
						end
				when 31 then
						if l_namelen /= 1 then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						if (links_inst.casecmp (l_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("A")), (1).to_natural_32)).to_boolean then
							l_pos := -1 + 34 -- goto _L___3
						end
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 34 then -- else: | _L___3:
						if l_namelen /= 2 then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						if (links_inst.casecmp (l_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/A")), (2).to_natural_32)).to_boolean then
							l_pos := -1 + 37 -- goto _L___2
						end
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 37 then -- else: | _L___2:
						if l_namelen /= 3 then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						if (links_inst.casecmp (l_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("MAP")), (3).to_natural_32)).to_boolean then
							l_pos := -1 + 40 -- goto _L___1
						end
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 40 then -- else: | _L___1:
						if l_namelen /= 4 then
							l_pos := -1 + 43 -- skip if block
						end
				when 41 then -- if:
						if (links_inst.casecmp (l_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/MAP")), (4).to_natural_32)).to_boolean then
							l_pos := -1 + 43 -- goto _L___0
						end
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 43 then -- else: | _L___0:
						if l_namelen /= 4 then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						if (links_inst.casecmp (l_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("AREA")), (4).to_natural_32)).to_boolean then
							l_pos := -1 + 46 -- goto _L
						end
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 46 then -- else: | _L:
						if l_namelen = 5 then
							if (links_inst.casecmp (l_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/AREA")), (5).to_natural_32)).to_boolean then
								l_s.ce_gets (l_ss)
								l_pos := -1 + 28 -- goto se3
							end
						else
							l_s.ce_gets (l_ss)
							l_pos := -1 + 28 -- goto se3
						end
				when 47 then -- if done | if done | if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 52
				when 48 then -- else: | _L___5:
						if l_namelen /= 4 then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:
						if (links_inst.casecmp (l_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("AREA")), (4).to_natural_32)).to_boolean then
							l_pos := -1 + 51 -- goto _L___4
						else
							l_l.ce_gets ((get_attr_val (l_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("alt")))))
							if ((l_l).c_pointer /= default_pointer) then
								l_label.ce_gets (charsets_inst.convert_string (l_ct, l_l, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_l))).to_integer_32))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2423, create {CE_POINTER [ANY]}.make_cast (l_l))
							else
								l_label.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							end
						end
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 52
				when 51 then -- else: | _L___4:
						if l_namelen = 4 then
							if (links_inst.casecmp (l_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/MAP")), (4).to_natural_32)).to_boolean then
								l_pos := -1 + 15 -- goto se2
							else
								l_pos := -1 + 62 -- goto done
							end
						else
							l_pos := -1 + 15 -- goto se2
						end
				when 52 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 63 -- skip if block
						end
				when 53 then -- if:
							l_href.ce_gets (get_url_val (l_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("href"))))
							if (l_href).c_pointer = default_pointer then
								if ((l_label).c_pointer /= default_pointer) then
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2428, create {CE_POINTER [ANY]}.make_cast (l_label))
								end
								l_pos := -1 + 15 -- goto se2
							end
				when 54 then
							l_target.ce_gets (get_target (l_attr))
							if (l_target).c_pointer = default_pointer then
								l_target.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2431, a_target_base))
								if (l_target).c_pointer = default_pointer then
									l_target.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2432, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))))
								end
							end
							l_ld.ce_gets (create {CE_POINTER [PD_LINK_DEF]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2433, {PD_LINK_DEF}.sizeof.to_natural_32))))
							l_tmp___18.ce_gets (url_inst.join_urls (a_href_base, l_href))
							l_ld.item.link := l_tmp___18
							if ((l_tmp___18).c_pointer /= default_pointer) then
								l_pos := -1 + 57 -- skip if block
							end
				when 55 then -- if:
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2435, create {CE_POINTER [ANY]}.make_cast (l_href))
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2436, create {CE_POINTER [ANY]}.make_cast (l_target))
				when 56 then -- f:
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2438, create {CE_POINTER [ANY]}.make_cast (l_ld))
							if ((l_label).c_pointer /= default_pointer) then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2439, create {CE_POINTER [ANY]}.make_cast (l_label))
							end
							l_pos := -1 + 15 -- goto se2
				when 57 then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2442, create {CE_POINTER [ANY]}.make_cast (l_href))
							l_ld.item.target := l_target
							l_i := 0
				when 58 then -- loop condition:
							if not (l_i < l_nmenu) then
								l_pos := -1 + 61 -- skip loop
							end
				when 59 then -- loop body:
							l_ll.ce_gets (create {CE_POINTER [PD_LINK_DEF]}.make_cast ((a_menu.item + l_i).item.data))
							if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ll.item.link), create {CE_POINTER [INTEGER_8]}.make_cast (l_ld.item.link))).to_boolean then
								if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ll.item.target), create {CE_POINTER [INTEGER_8]}.make_cast (l_ld.item.target))).to_boolean then
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2447, create {CE_POINTER [ANY]}.make_cast (l_ld.item.link))
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2448, create {CE_POINTER [ANY]}.make_cast (l_ld.item.target))
									l_pos := -1 + 56 -- goto f
								end
							end
				when 60 then
							l_i := l_i + 1
							l_pos := -1 + 58 -- back to loop condition
				when 61 then -- loop done
							if ((l_label).c_pointer /= default_pointer) then
								clr_spaces (l_label)
							end
							if ((l_label).c_pointer /= default_pointer) then
								if not (l_label.item).to_boolean then
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2453, create {CE_POINTER [ANY]}.make_cast (l_label))
									l_label.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								end
							end
							if (l_label).c_pointer = default_pointer then
								l_label.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2454, l_ld.item.link))
							end
							if l_nmenu.to_natural_32 > {NATURAL_32} 2147483647 // {PD_MENU_ITEM}.sizeof.to_natural_32 - {NATURAL_32} 2 then
								from
								until
									False
								loop
									error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html.c"), 2455])
									kbd_inst.fatal_tty_exit
									exit (4)
								end
							end
							l_nm.ce_gets (create {CE_POINTER [PD_MENU_ITEM]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2456, create {CE_POINTER [ANY]}.make_cast (a_menu.item), (l_nmenu + 2).to_natural_32 * {PD_MENU_ITEM}.sizeof.to_natural_32))))
							a_menu.item := l_nm
							memset (create {CE_POINTER [ANY]}.make_cast ((l_nm + l_nmenu)), 0, {NATURAL_32} 2 * {PD_MENU_ITEM}.sizeof.to_natural_32).do_nothing;
							(l_nm + l_nmenu).item.text := l_label;
							(l_nm + l_nmenu).item.rtext := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""));
							(l_nm + l_nmenu).item.hotkey := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""));
							(l_nm + l_nmenu).item.func := (session_inst.map_selected_address);
							(l_nm + l_nmenu).item.data := create {CE_POINTER [ANY]}.make_cast (l_ld)
							l_nmenu := l_nmenu + 1;
							(l_nm + l_nmenu).item.text := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							bfu_inst.add_to_ml ([a_ml, l_ld, l_ld.item.link, l_ld.item.target, l_label, create {CE_POINTER [ANY]}.make_shared (default_pointer)])
							l_pos := -1 + 15 -- goto se2
				when 62 then -- done:
							bfu_inst.add_to_ml ([a_ml, a_menu.item, create {CE_POINTER [ANY]}.make_shared (default_pointer)])
							Result := 0
				when 63 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	scan_http_equiv (a_s: CE_POINTER [NATURAL_8]; a_eof: CE_POINTER [NATURAL_8]; a_head___0: CE_POINTER [CE_POINTER [NATURAL_8]]; a_hdl: CE_POINTER [INTEGER_32]; a_title: CE_POINTER [CE_POINTER [NATURAL_8]])
		local
			l_s: CE_POINTER [NATURAL_8]
			l_name: CE_POINTER [NATURAL_8]
			l_attr: CE_POINTER [NATURAL_8]
			l_he: CE_POINTER [NATURAL_8]
			l_c: CE_POINTER [NATURAL_8]
			l_namelen: INTEGER_32
			l_tlen: INTEGER_32
			l_s1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_name.make
			create l_attr.make
			create l_he.make
			create l_c.make
			create l_s1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s.ce_gets (a_s)
					l_tlen := 0
					if ((a_title).c_pointer /= default_pointer) then
						a_title.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2477)
					end
					links_inst.add_chr_to_str (a_head___0, a_hdl, (('%N').code).to_natural_8)
				when 1 then -- se:
					if js.loop_left then
						l_pos := -1 + 5 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if (l_s.c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_s.item).to_integer_32 = 60 then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 4 -- skip if block
						end
				when 3 then -- if: | sp:
						l_s.ce_gets (l_s + 1)
				when 4 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 5 then -- loop done
					js.reset
					if (l_s.c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 6 then -- if:
						if ((l_s + 2).c_pointer.to_integer_32).to_natural_32 <= (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_s[1]).to_integer_32 = 33 then
								l_s.ce_gets (skip_comment (l_s, a_eof))
								l_pos := -1 + 1 -- goto se
							elseif (l_s[1]).to_integer_32 = 63 then
								l_s.ce_gets (skip_comment (l_s, a_eof))
								l_pos := -1 + 1 -- goto se
							end
						end
				when 7 then
						if (parse_element (l_s, a_eof, l_name.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_namelen), l_attr.address, l_s.address)).to_boolean then
							l_pos := -1 + 3 -- goto sp
						end
				when 8 then -- ps:
						if l_namelen = 5 then
							if not (links_inst.casecmp (l_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/HEAD")), (5).to_natural_32)).to_boolean then
								js.return
							end
						end
				when 9 then -- if done
					if js.return_called then
						l_pos := -1 + 26 -- skip if block
					end
				when 10 then -- if:
						if (a_title).c_pointer = default_pointer then
							l_pos := -1 + 23 -- skip if block
						end
				when 11 then -- if:
						if l_tlen.to_boolean then
							l_pos := -1 + 23 -- skip if block
						end
				when 12 then -- if:
						if l_namelen /= 5 then
							l_pos := -1 + 23 -- skip if block
						end
				when 13 then -- if:
						if (links_inst.casecmp (l_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("TITLE")), (5).to_natural_32)).to_boolean then
							l_pos := -1 + 23 -- skip if block
						end
				when 14 then -- if: | xse:
						l_s1.ce_gets (l_s)
				when 15 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 19 -- skip loop
						end
				when 16 then -- loop body:
						js.reset
						if (l_s.c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_s.item).to_integer_32 = 60 then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | xsp:
						l_s.ce_gets (l_s + 1)
				when 18 then -- if done
						l_pos := -1 + 15 -- back to loop condition
				when 19 then -- loop done
						js.reset
						links_inst.add_bytes_to_str (a_title, create {CE_POINTER [INTEGER_32]}.make_shared ($l_tlen), l_s1, l_s.distance (l_s1))
						if (l_s.c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 1 -- goto se
						end
				when 20 then
						if ((l_s + 2).c_pointer.to_integer_32).to_natural_32 <= (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_s[1]).to_integer_32 = 33 then
								l_s.ce_gets (skip_comment (l_s, a_eof))
								l_pos := -1 + 14 -- goto xse
							elseif (l_s[1]).to_integer_32 = 63 then
								l_s.ce_gets (skip_comment (l_s, a_eof))
								l_pos := -1 + 14 -- goto xse
							end
						end
				when 21 then
						if (parse_element (l_s, a_eof, l_name.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_namelen), l_attr.address, l_s.address)).to_boolean then
							l_s1.ce_gets (l_s)
							l_pos := -1 + 17 -- goto xsp
						end
				when 22 then
						clr_spaces (a_title.item)
						l_pos := -1 + 8 -- goto ps
				when 23 then -- if done | if done | if done
						if l_namelen /= 4 then
							l_pos := -1 + 1 -- goto se
						elseif (links_inst.casecmp (l_name, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("META")), (4).to_natural_32)).to_boolean then
							l_pos := -1 + 1 -- goto se
						end
				when 24 then
						l_he.ce_gets (get_attr_val (l_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("charset"))))
						if ((l_he).c_pointer /= default_pointer) then
							links_inst.add_to_str (a_head___0, a_hdl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Charset: ")))
							links_inst.add_to_str (a_head___0, a_hdl, l_he)
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2511, create {CE_POINTER [ANY]}.make_cast (l_he))
						end
						l_he.ce_gets (get_attr_val (l_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http-equiv"))))
						if (l_he).c_pointer = default_pointer then
							l_pos := -1 + 1 -- goto se
						end
				when 25 then
						l_c.ce_gets (get_attr_val (l_attr, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("content"))))
						links_inst.add_to_str (a_head___0, a_hdl, l_he)
						if ((l_c).c_pointer /= default_pointer) then
							links_inst.add_to_str (a_head___0, a_hdl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (": ")))
							links_inst.add_to_str (a_head___0, a_hdl, l_c)
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2516, create {CE_POINTER [ANY]}.make_cast (l_c))
						end
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html.c")), 2517, create {CE_POINTER [ANY]}.make_cast (l_he))
						links_inst.add_to_str (a_head___0, a_hdl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%N")))
						l_pos := -1 + 1 -- goto se
				when 26 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
