class
	P_SESSION

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create downloads.make
			create sessions.make
			create strerror_buf.make
		end

feature {ANY} -- attributes

	downloads: PD_LIST_HEAD

	sessions: PD_LIST_HEAD

	session_id: INTEGER_32 assign set_session_id

	set_session_id (a_session_id: INTEGER_32)
		do
			session_id := a_session_id
		end

	strerror_buf: PD_LIST_HEAD

	depth: INTEGER_32 assign set_depth

	set_depth (a_depth: INTEGER_32)
		do
			depth := a_depth
		end

	stop_recursion: INTEGER_32 assign set_stop_recursion

	set_stop_recursion (a_stop_recursion: INTEGER_32)
		do
			stop_recursion := a_stop_recursion
		end

feature {ANY} -- routines

	are_there_downloads: INTEGER_32
		local
			l_d: INTEGER_32
			l_down___0: CE_POINTER [PD_DOWNLOAD]
		do
			create l_down___0.make

			l_d := 0
			l_down___0.ce_gets (create {CE_POINTER [PD_DOWNLOAD]}.make_cast (downloads.next))
			from
			until
				(l_down___0.c_pointer.to_integer_32).to_natural_32 = ((downloads.address).c_pointer.to_integer_32).to_natural_32
			loop
				if (l_down___0.item.prog).c_pointer = default_pointer then
					l_d := 1
				end
				l_down___0.ce_gets (l_down___0.item.next)
			end
			Result := l_d
		end

	free_strerror_buf
		local
			l_a__: CE_POINTER [PD_XLIST_HEAD]
		do
			create l_a__.make

			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((strerror_buf.address)))
			l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (strerror_buf.next))
			from
			until
				(l_a__.c_pointer.to_integer_32).to_natural_32 = ((strerror_buf.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__.ce_gets (l_a__.item.next)
			end
			l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (strerror_buf.prev))
			from
			until
				(l_a__.c_pointer.to_integer_32).to_natural_32 = ((strerror_buf.address).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__.ce_gets (l_a__.item.prev)
			end
			from
			until
				((strerror_buf.next).c_pointer.to_integer_32).to_natural_32 = ((strerror_buf.address).c_pointer.to_integer_32).to_natural_32
			loop
				l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (strerror_buf.next))
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a__.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a__.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 27, create {CE_POINTER [ANY]}.make_cast (l_a__))
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((strerror_buf.address)))
		end

	get_err_msg (a_state: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_e: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [PD_STRERROR_VAL]
			l_i: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_e.make
			create l_s.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_state <= -1000) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 3 then -- else:
						if not (a_state >= 0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_i := 0
						from
						until
							not (not js.loop_left and then ((sched_inst.msg_dsc[l_i].msg).c_pointer /= default_pointer))
						loop
							if sched_inst.msg_dsc[l_i].n = a_state then
								Result := (sched_inst.msg_dsc[l_i].msg)
								js.return
							end
							if not js.return_called then
								l_i := l_i + 1
							end
						end
						if js.return_called then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | unk:
						Result := (links_inst.dummyarray + 154)
						js.return
				when 6 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
							l_e.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strerror (-a_state))))
							if ((l_e).c_pointer /= default_pointer) then
								if not (l_e.item).to_boolean then
									l_pos := -1 + 5 -- goto unk
								end
							else
								l_pos := -1 + 5 -- goto unk
							end
				when 8 then
							l_s.ce_gets (create {CE_POINTER [PD_STRERROR_VAL]}.make_cast (strerror_buf.next))
							from
							until
								not (not js.loop_left and then ((l_s.c_pointer.to_integer_32).to_natural_32 /= ((strerror_buf.address).c_pointer.to_integer_32).to_natural_32))
							loop
								if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_s.item.msg)), create {CE_POINTER [INTEGER_8]}.make_cast (l_e))).to_boolean then
									Result := (l_s.item.msg)
									js.return
								end
								if not js.return_called then
									l_s.ce_gets (l_s.item.next)
								end
							end
				when 9 then -- if done
						if not js.return_called then
							l_s.ce_gets (create {CE_POINTER [PD_STRERROR_VAL]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 43, ({PD_STRERROR_VAL}.sizeof.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_e)))) + {NATURAL_32} 1))))
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_s.item.msg)), create {CE_POINTER [INTEGER_8]}.make_cast (l_e)).do_nothing
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((strerror_buf.address)))
								l_s.item.next := (create {CE_POINTER [PD_STRERROR_VAL]}.make_cast ((strerror_buf.address))).item.next
								l_s.item.prev := create {CE_POINTER [PD_STRERROR_VAL]}.make_cast ((strerror_buf.address));
								(create {CE_POINTER [PD_STRERROR_VAL]}.make_cast ((strerror_buf.address))).item.next := l_s;
								(l_s.item.next).item.prev := l_s
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((strerror_buf.address)))
								js.break
							end
							js.reset
							Result := (l_s.item.msg)
						end
				when 10 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	add_xnum_to_str (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_n: INTEGER_32)
		local
			l_n: INTEGER_32
			l_suff: NATURAL_8
			l_d: INTEGER_32
		do
			l_n := a_n
			l_suff := (0).to_natural_8
			l_d := -1
			if l_n >= 1000000000 then
				l_suff := (('G').code).to_natural_8
				l_d := ((l_n // 100000000) \\ 10).to_integer_32
				l_n := l_n // (1000000000)
			elseif l_n >= 1000000 then
				l_suff := (('M').code).to_natural_8
				l_d := ((l_n // 100000) \\ 10).to_integer_32
				l_n := l_n // (1000000)
			elseif l_n >= 1000 then
				l_suff := (('k').code).to_natural_8
				l_d := ((l_n // 100) \\ 10).to_integer_32
				l_n := l_n // (1000)
			end
			links_inst.add_num_to_str (a_s, a_l, l_n)
			if l_n < 10 then
				if l_d /= -1 then
					links_inst.add_chr_to_str (a_s, a_l, (('.').code).to_natural_8)
					links_inst.add_num_to_str (a_s, a_l, l_d.to_integer_32)
				end
			end
			links_inst.add_chr_to_str (a_s, a_l, ((' ').code).to_natural_8)
			if l_suff.to_boolean then
				links_inst.add_chr_to_str (a_s, a_l, l_suff)
			end
			links_inst.add_chr_to_str (a_s, a_l, (('B').code).to_natural_8)
		end

	add_time_to_str (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_t: INTEGER_32)
		local
			l_t: INTEGER_32
			l_q: CE_ARRAY [NATURAL_8]
		do
			create l_q.make (<<64>>)

			l_t := a_t
			if l_t < 0 then
				l_t := (0).to_integer_32
			end
			l_t := ((l_t.to_natural_32).bit_and ({NATURAL_32} 4294967295)).to_integer_32
			if l_t >= 86400 then
				sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_q), ce_string ("%%dd "), (l_t // 86400).to_integer_32]).do_nothing
				links_inst.add_to_str (a_s, a_l, l_q)
			end
			if l_t >= 3600 then
				l_t := l_t \\ (86400)
				sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_q), ce_string ("%%d:%%02d"), (l_t // 3600).to_integer_32, ((l_t // 60) \\ 60).to_integer_32]).do_nothing
				links_inst.add_to_str (a_s, a_l, l_q)
			else
				sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_q), ce_string ("%%d"), (l_t // 60).to_integer_32]).do_nothing
				links_inst.add_to_str (a_s, a_l, l_q)
			end
			sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_q), ce_string (":%%02d"), (l_t \\ 60).to_integer_32]).do_nothing
			links_inst.add_to_str (a_s, a_l, l_q)
		end

	get_stat_msg (a_stat___0: CE_POINTER [PD_STATUS]; a_term: CE_POINTER [PD_TERMINAL]): CE_POINTER [NATURAL_8]
		local
			l_m: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			js: JUMP_STATE
		do
			create l_m.make

			if a_stat___0.item.state = 8 then
				if ((a_stat___0.item.prg).item.elapsed // 100).to_boolean then
					l_m.ce_gets ((links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 77)))
					l_l := 0
					links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (language_inst.get_text_translation (links_inst.dummyarray + 155, a_term)))
					links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
					add_xnum_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (a_stat___0.item.prg).item.pos)
					if (a_stat___0.item.prg).item.size >= 0 then
						links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
						links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (language_inst.get_text_translation (links_inst.dummyarray + 156, a_term)))
						links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
						add_xnum_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (a_stat___0.item.prg).item.size)
					end
					links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (", ")))
					if (a_stat___0.item.prg).item.elapsed >= 10000 then
						links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (language_inst.get_text_translation (links_inst.dummyarray + 157, a_term)))
						links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
					end
					add_xnum_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), ((((a_stat___0.item.prg).item.loaded).to_integer_64 * {INTEGER_64} 10) // ((a_stat___0.item.prg).item.elapsed // 100).to_integer_64).to_integer_32)
					links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/s")))
					if (a_stat___0.item.prg).item.elapsed >= 10000 then
						links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (", ")))
						links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (language_inst.get_text_translation (links_inst.dummyarray + 158, a_term)))
						links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
						add_xnum_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (a_stat___0.item.prg).item.cur_loaded // 5)
						links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/s")))
					end
					Result := l_m
					js.return
				end
			end
			if not js.return_called then
				Result := (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 95, (language_inst.get_text_translation ((get_err_msg (a_stat___0.item.state)), a_term))))
			end
		end

	print_screen_status (a_ses: CE_POINTER [PD_SESSION])
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_stat___0: CE_POINTER [PD_STATUS]
			l_m: CE_POINTER [NATURAL_8]
			l_ftl: CE_POINTER [PD_FILE_TO_LOAD]
			l_p: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_term.make
			create l_stat___0.make
			create l_m.make
			create l_ftl.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_term.ce_gets (a_ses.item.term)
					l_stat___0.ce_gets (create {CE_POINTER [PD_STATUS]}.make_shared (default_pointer))
					terminal_inst.fill_area (l_term, 0, 0, l_term.item.x, 1, {NATURAL_32} 1792)
					terminal_inst.fill_area (l_term, 0, l_term.item.y - 1, l_term.item.x, 1, {NATURAL_32} 1792)
					if (a_ses.item.wtd).to_boolean then
						l_stat___0.ce_gets (create {CE_POINTER [PD_STATUS]}.make_shared (a_ses.c_pointer + {PD_SESSION}.loading_offset))
					elseif ((a_ses.item.history.next).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
						l_stat___0.ce_gets (create {CE_POINTER [PD_STATUS]}.make_shared ((create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)).c_pointer + {PD_LOCATION}.stat_offset))
					end
					if ((l_stat___0).c_pointer /= default_pointer) then
						if l_stat___0.item.state = -1000 then
							l_ftl.ce_gets (create {CE_POINTER [PD_FILE_TO_LOAD]}.make_cast (a_ses.item.more_files.next))
							from
							until
								not (not js.loop_left and then ((l_ftl.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.more_files_offset)).c_pointer.to_integer_32).to_natural_32))
							loop
								js.reset
								if (l_ftl.item.req_sent).to_boolean then
									if l_ftl.item.stat.state >= 0 then
										l_stat___0.ce_gets (create {CE_POINTER [PD_STATUS]}.make_shared (l_ftl.c_pointer + {PD_FILE_TO_LOAD}.stat_offset))
										js.break
									end
								end
								if not js.loop_jumped then
									l_ftl.ce_gets (l_ftl.item.next)
								end
							end
							js.reset
						end
					end
					if (l_stat___0).c_pointer = default_pointer then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if l_stat___0.item.state = -1000 then
							l_m.ce_gets (view_inst.print_current_link (a_ses))
							if ((l_m).c_pointer /= default_pointer) then
								l_pos := -1 + 3 -- goto p
							end
						end
				when 2 then
						l_m.ce_gets (get_stat_msg (l_stat___0, l_term))
						if (l_m).c_pointer = default_pointer then
							l_pos := -1 + 4 -- skip if block
						end
				when 3 then -- if: | p:
						terminal_inst.print_text (l_term, 0, l_term.item.y - 1, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_m))).to_integer_32, l_m, {NATURAL_32} 14336)
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 121, create {CE_POINTER [ANY]}.make_cast (l_m))
				when 4 then -- if done
						l_m.ce_gets (view_inst.print_current_title (a_ses))
						if ((l_m).c_pointer /= default_pointer) then
							l_p := ((l_term.item.x - 1).to_natural_32 - (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_m)))).to_integer_32
							if l_p < 0 then
								l_p := 0
							end
							terminal_inst.print_text (l_term, l_p, 0, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_m))).to_integer_32, l_m, {NATURAL_32} 1792)
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 129, create {CE_POINTER [ANY]}.make_cast (l_m))
						end
						l_m.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 131, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Links"))))
						if ((a_ses.item.screen).c_pointer /= default_pointer) then
							if (((a_ses.item.screen).item.f_data).c_pointer /= default_pointer) then
								if ((((a_ses.item.screen).item.f_data).item.title).c_pointer /= default_pointer) then
									if (((a_ses.item.screen).item.f_data).item.title[0]).to_boolean then
										links_inst.add_to_strn (l_m.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" - ")))
										links_inst.add_to_strn (l_m.address, ((a_ses.item.screen).item.f_data).item.title)
									end
								end
							end
						end
						terminal_inst.set_terminal_title (l_term, l_m)
				when 5 then -- if done
					terminal_inst.redraw_from_window (a_ses.item.win)
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	print_error_dialog (a_ses: CE_POINTER [PD_SESSION]; a_stat___0: CE_POINTER [PD_STATUS]; a_title: CE_POINTER [NATURAL_8])
		local
			l_t: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_t.make

			l_t.ce_gets ((get_err_msg (a_stat___0.item.state)))
			if (l_t).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				bfu_inst.msg_box ([a_ses.item.term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), a_title, 1, l_t, a_ses, 1, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
			end
		end

	free_wtd (a_ses: CE_POINTER [PD_SESSION])
		local
			js: JUMP_STATE
		do
			if not (a_ses.item.wtd).to_boolean then
				from
				until
					False
				loop
					links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")))
					links_inst.errline := 149
					error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("no WTD"))])
				end
				js.return
			end
			if not js.return_called then
				if ((a_ses.item.goto_position).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 152, create {CE_POINTER [ANY]}.make_cast (a_ses.item.goto_position))
					a_ses.item.goto_position := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 153, create {CE_POINTER [ANY]}.make_cast (a_ses.item.loading_url))
				a_ses.item.loading_url := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				a_ses.item.wtd := 0
			end
		end

	abort_files_load (a_ses: CE_POINTER [PD_SESSION])
		local
			l_ftl: CE_POINTER [PD_FILE_TO_LOAD]
			l_q: INTEGER_32
			js: JUMP_STATE
		do
			create l_ftl.make

			from
			until
				js.loop_left
			loop
				js.reset
				l_q := 0
				l_ftl.ce_gets (create {CE_POINTER [PD_FILE_TO_LOAD]}.make_cast (a_ses.item.more_files.next))
				from
				until
					(l_ftl.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.more_files_offset)).c_pointer.to_integer_32).to_natural_32
				loop
					if l_ftl.item.stat.state >= 0 then
						if (l_ftl.item.req_sent).to_boolean then
							l_q := 1
							sched_inst.change_connection (create {CE_POINTER [PD_STATUS]}.make_shared (l_ftl.c_pointer + {PD_FILE_TO_LOAD}.stat_offset), create {CE_POINTER [PD_STATUS]}.make_shared (default_pointer), 5)
						end
					end
					l_ftl.ce_gets (l_ftl.item.next)
				end
				if not l_q.to_boolean then
					js.break
				end
			end
			js.reset
		end

	free_files (a_ses: CE_POINTER [PD_SESSION])
		local
			l_ftl: CE_POINTER [PD_FILE_TO_LOAD]
			l_a__: CE_POINTER [PD_XLIST_HEAD]
		do
			create l_ftl.make
			create l_a__.make

			abort_files_load (a_ses)
			l_ftl.ce_gets (create {CE_POINTER [PD_FILE_TO_LOAD]}.make_cast (a_ses.item.more_files.next))
			from
			until
				(l_ftl.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.more_files_offset)).c_pointer.to_integer_32).to_natural_32
			loop
				if ((l_ftl.item.ce).c_pointer /= default_pointer) then
					(l_ftl.item.ce).item.refcount := ((l_ftl.item.ce).item.refcount) - 1
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 179, create {CE_POINTER [ANY]}.make_cast (l_ftl.item.url))
				l_ftl.ce_gets (l_ftl.item.next)
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.more_files_offset))))
			l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_ses.item.more_files.next))
			from
			until
				(l_a__.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.more_files_offset)).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__.ce_gets (l_a__.item.next)
			end
			l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_ses.item.more_files.prev))
			from
			until
				(l_a__.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.more_files_offset)).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__.ce_gets (l_a__.item.prev)
			end
			from
			until
				((a_ses.item.more_files.next).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.more_files_offset)).c_pointer.to_integer_32).to_natural_32
			loop
				l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_ses.item.more_files.next))
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a__.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a__.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 181, create {CE_POINTER [ANY]}.make_cast (l_a__))
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.more_files_offset))))
		end

	destroy_location (a_loc: CE_POINTER [PD_LOCATION])
		local
			l_frame: CE_POINTER [PD_FRAME]
			l_a__: CE_POINTER [PD_XLIST_HEAD]
		do
			create l_frame.make
			create l_a__.make

			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_loc));
			(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_loc.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (a_loc.item.prev);
			(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_loc.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (a_loc.item.next)
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_loc))
			l_frame.ce_gets (create {CE_POINTER [PD_FRAME]}.make_cast (a_loc.item.frames.next))
			from
			until
				(l_frame.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_loc.c_pointer + {PD_LOCATION}.frames_offset)).c_pointer.to_integer_32).to_natural_32
			loop
				view_inst.destroy_vs (create {CE_POINTER [PD_VIEW_STATE]}.make_shared (l_frame.c_pointer + {PD_FRAME}.vs_offset))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 190, create {CE_POINTER [ANY]}.make_cast (l_frame.item.name))
				l_frame.ce_gets (l_frame.item.next)
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_loc.c_pointer + {PD_LOCATION}.frames_offset))))
			l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_loc.item.frames.next))
			from
			until
				(l_a__.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_loc.c_pointer + {PD_LOCATION}.frames_offset)).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__.ce_gets (l_a__.item.next)
			end
			l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_loc.item.frames.prev))
			from
			until
				(l_a__.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_loc.c_pointer + {PD_LOCATION}.frames_offset)).c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__.ce_gets (l_a__.item.prev)
			end
			from
			until
				((a_loc.item.frames.next).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_loc.c_pointer + {PD_LOCATION}.frames_offset)).c_pointer.to_integer_32).to_natural_32
			loop
				l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_loc.item.frames.next))
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a__.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a__.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 192, create {CE_POINTER [ANY]}.make_cast (l_a__))
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_loc.c_pointer + {PD_LOCATION}.frames_offset))))
			view_inst.destroy_vs (create {CE_POINTER [PD_VIEW_STATE]}.make_shared (a_loc.c_pointer + {PD_LOCATION}.vs_offset))
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 194, create {CE_POINTER [ANY]}.make_cast (a_loc))
		end

	ses_forward (a_ses: CE_POINTER [PD_SESSION])
		local
			l_l: CE_POINTER [PD_LOCATION]
			l_len: NATURAL_32
			l_frm: CE_POINTER [PD_FRAME]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_l.make
			create l_frm.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					free_files (a_ses)
					if ((a_ses.item.history.next).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
						l_l.ce_gets (create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next))
					end
					if ((a_ses.item.search_word).c_pointer /= default_pointer) then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 205, create {CE_POINTER [ANY]}.make_cast (a_ses.item.search_word))
						a_ses.item.search_word := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
				when 1 then -- x:
					l_len := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_ses.item.loading_url))
					if ((a_ses.item.history.next).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
						if l_len < (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (((create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)).item.vs.url)))) then
							l_len := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (((create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)).item.vs.url)))
						end
					end
					l_l.ce_gets (create {CE_POINTER [PD_LOCATION]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 210, ({PD_LOCATION}.sizeof.to_natural_32 + l_len) + {NATURAL_32} 1))))
					memset (create {CE_POINTER [ANY]}.make_cast (l_l), 0, {PD_LOCATION}.sizeof.to_natural_32).do_nothing
					memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_STATUS]}.make_shared (l_l.c_pointer + {PD_LOCATION}.stat_offset))), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_STATUS]}.make_shared (a_ses.c_pointer + {PD_SESSION}.loading_offset))), {PD_STATUS}.sizeof.to_natural_32).do_nothing
					if (a_ses.item.wtd_target).c_pointer = default_pointer then
						l_pos := -1 + 9 -- skip if block
					end
				when 2 then -- if:
						if not (((a_ses.item.wtd_target).item).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if:
						if ((a_ses.item.history.next).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
							from
							until
								False
							loop
								links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")))
								links_inst.errline := 216
								error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("no history"))])
							end
							js.return
						end
						if js.return_called then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						view_inst.copy_location (l_l, create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next))
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset))))
							l_l.item.next := (create {CE_POINTER [PD_LOCATION]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)))).item.next
							l_l.item.prev := create {CE_POINTER [PD_LOCATION]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)));
							(create {CE_POINTER [PD_LOCATION]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)))).item.next := l_l;
							(l_l.item.next).item.prev := l_l
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset))))
							js.break
						end
						js.reset
						l_frm.ce_gets (ses_change_frame_url (a_ses, a_ses.item.wtd_target, a_ses.item.loading_url))
						if (l_frm).c_pointer = default_pointer then
							destroy_location (l_l)
							a_ses.item.wtd_target := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							l_pos := -1 + 1 -- goto x
						end
				when 5 then
						view_inst.destroy_vs (create {CE_POINTER [PD_VIEW_STATE]}.make_shared (l_frm.c_pointer + {PD_FRAME}.vs_offset))
						view_inst.init_vs (create {CE_POINTER [PD_VIEW_STATE]}.make_shared (l_frm.c_pointer + {PD_FRAME}.vs_offset), a_ses.item.loading_url)
						if ((a_ses.item.goto_position).c_pointer /= default_pointer) then
							if ((l_frm.item.vs.goto_position).c_pointer /= default_pointer) then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 230, create {CE_POINTER [ANY]}.make_cast (l_frm.item.vs.goto_position))
							end
							l_frm.item.vs.goto_position := a_ses.item.goto_position
							a_ses.item.goto_position := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						end
				when 6 then -- if done | if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_pos := -1 + 9 -- goto _L
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_l.c_pointer + {PD_LOCATION}.frames_offset))))
						l_l.item.frames.next := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_l.c_pointer + {PD_LOCATION}.frames_offset)))
						l_l.item.frames.prev := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_l.c_pointer + {PD_LOCATION}.frames_offset)))
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_l.c_pointer + {PD_LOCATION}.frames_offset))))
						view_inst.init_vs (create {CE_POINTER [PD_VIEW_STATE]}.make_shared (l_l.c_pointer + {PD_LOCATION}.vs_offset), a_ses.item.loading_url)
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset))))
							l_l.item.next := (create {CE_POINTER [PD_LOCATION]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)))).item.next
							l_l.item.prev := create {CE_POINTER [PD_LOCATION]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)));
							(create {CE_POINTER [PD_LOCATION]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)))).item.next := l_l;
							(l_l.item.next).item.prev := l_l
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset))))
							js.break
						end
						js.reset
						if ((a_ses.item.goto_position).c_pointer /= default_pointer) then
							l_l.item.vs.goto_position := a_ses.item.goto_position
							a_ses.item.goto_position := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						end
				when 10 then
					if not js.return_called then
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ses_imgmap (a_ses: CE_POINTER [PD_SESSION])
		local
			l_ce: CE_POINTER [PD_CACHE_ENTRY]
			l_fr: CE_POINTER [PD_FRAGMENT]
			l_ml: CE_POINTER [PD_MEMORY_LIST]
			l_menu: CE_POINTER [PD_MENU_ITEM]
			l_fd: CE_POINTER [PD_F_DATA_C]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ce.make
			create l_fr.make
			create l_ml.make
			create l_menu.make
			create l_fd.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((cache_inst.find_in_cache (a_ses.item.loading_url, l_ce.address)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if ((l_ce).c_pointer /= default_pointer) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							False
						loop
							links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")))
							links_inst.errline := 254
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("can%'t find cache entry"))])
						end
						js.return
				when 5 then -- if done
						if not js.return_called then
							cache_inst.defrag_entry (l_ce)
							l_fr.ce_gets (create {CE_POINTER [PD_FRAGMENT]}.make_cast (l_ce.item.frag.next))
							if (l_fr.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_ce.c_pointer + {PD_CACHE_ENTRY}.frag_offset)).c_pointer.to_integer_32).to_natural_32 then
								js.return
							end
						end
						if not js.return_called then
							l_fd.ce_gets (view_inst.current_frame (a_ses))
							if ((l_fd).c_pointer /= default_pointer) then
								if (l_fd.item.f_data).c_pointer = default_pointer then
									js.return
								end
							else
								js.return
							end
						end
						if not js.return_called then
							links_inst.d_opt.ce_gets (create {CE_POINTER [PD_DOCUMENT_OPTIONS]}.make_shared ((l_fd.item.f_data).c_pointer + {PD_F_DATA}.opt_offset))
							if (html_inst.get_image_map (l_ce.item.head, l_fr.item.data, l_fr.item.data + l_fr.item.length, a_ses.item.goto_position, l_menu.address, l_ml.address, a_ses.item.imgmap_href_base, a_ses.item.imgmap_target_base, ((a_ses.item.term).item.spec).item.charset, a_ses.item.ds.assume_cp, a_ses.item.ds.hard_assume)).to_boolean then
								js.return
							end
						end
						if not js.return_called then
							terminal_inst.add_empty_window (a_ses.item.term, (bfu_inst.freeml_address), create {CE_POINTER [ANY]}.make_cast (l_ml))
							bfu_inst.do_menu (a_ses.item.term, l_menu, create {CE_POINTER [ANY]}.make_cast (a_ses))
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	map_selected (a_term: CE_POINTER [PD_TERMINAL]; a_ld: CE_POINTER [PD_LINK_DEF]; a_ses: CE_POINTER [PD_SESSION])
		do
			goto_url_f (a_ses, a_ld.item.link, a_ld.item.target)
		end

	map_selected_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent map_selected)
		end

	ses_back (a_ses: CE_POINTER [PD_SESSION])
		local
			l_loc: CE_POINTER [PD_LOCATION]
			js: JUMP_STATE
		do
			create l_loc.make

			free_files (a_ses)
			l_loc.ce_gets (create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next))
			if ((a_ses.item.search_word).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 278, create {CE_POINTER [ANY]}.make_cast (a_ses.item.search_word))
				a_ses.item.search_word := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
			if (l_loc.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
				js.return
			end
			if not js.return_called then
				destroy_location (l_loc)
				l_loc.ce_gets (create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next))
				if (l_loc.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
					js.return
				end
			end
			if not js.return_called then
				if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_loc.item.vs.url)), create {CE_POINTER [INTEGER_8]}.make_cast (a_ses.item.loading_url))).to_boolean then
					js.return
				end
			end
			if not js.return_called then
				destroy_location (l_loc)
				ses_forward (a_ses)
			end
		end

	get_download_ses (a_down___0: CE_POINTER [PD_DOWNLOAD]): CE_POINTER [PD_SESSION]
		local
			l_ses: CE_POINTER [PD_SESSION]
			js: JUMP_STATE
		do
			create l_ses.make

			l_ses.ce_gets (create {CE_POINTER [PD_SESSION]}.make_cast (sessions.next))
			from
			until
				not (not js.loop_left and then ((l_ses.c_pointer.to_integer_32).to_natural_32 /= ((sessions.address).c_pointer.to_integer_32).to_natural_32))
			loop
				if (l_ses.c_pointer.to_integer_32).to_natural_32 = ((a_down___0.item.ses).c_pointer.to_integer_32).to_natural_32 then
					Result := l_ses
					js.return
				end
				if not js.return_called then
					l_ses.ce_gets (l_ses.item.next)
				end
			end
			if not js.return_called and then (((sessions.next).c_pointer.to_integer_32).to_natural_32 /= ((sessions.address).c_pointer.to_integer_32).to_natural_32) then
				Result := (create {CE_POINTER [PD_SESSION]}.make_cast (sessions.next))
				js.return
			end
			if not js.return_called then
				Result := (create {CE_POINTER [PD_SESSION]}.make_shared (default_pointer))
			end
		end

	abort_download (a_down___0: CE_POINTER [PD_DOWNLOAD])
		do
			if ((a_down___0.item.win).c_pointer /= default_pointer) then
				terminal_inst.delete_window (a_down___0.item.win)
			end
			if ((a_down___0.item.ask).c_pointer /= default_pointer) then
				terminal_inst.delete_window (a_down___0.item.ask)
			end
			if a_down___0.item.stat.state >= 0 then
				sched_inst.change_connection (create {CE_POINTER [PD_STATUS]}.make_shared (a_down___0.c_pointer + {PD_DOWNLOAD}.stat_offset), create {CE_POINTER [PD_STATUS]}.make_shared (default_pointer), 5)
			end
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 307, create {CE_POINTER [ANY]}.make_cast (a_down___0.item.url))
			if a_down___0.item.handle /= -1 then
				links_inst.prealloc_truncate (a_down___0.item.handle, a_down___0.item.last_pos)
				close (a_down___0.item.handle).do_nothing
			end
			if ((a_down___0.item.prog).c_pointer /= default_pointer) then
				unlink (create {CE_POINTER [INTEGER_8]}.make_cast (a_down___0.item.file)).do_nothing
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 311, create {CE_POINTER [ANY]}.make_cast (a_down___0.item.prog))
			end
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 313, create {CE_POINTER [ANY]}.make_cast (a_down___0.item.file))
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_down___0));
			(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_down___0.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (a_down___0.item.prev);
			(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_down___0.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (a_down___0.item.next)
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_down___0))
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 315, create {CE_POINTER [ANY]}.make_cast (a_down___0))
		end

	abort_download_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent abort_download)
		end

	kill_downloads_to_file (a_file: CE_POINTER [NATURAL_8])
		local
			l_down___0: CE_POINTER [PD_DOWNLOAD]
		do
			create l_down___0.make

			l_down___0.ce_gets (create {CE_POINTER [PD_DOWNLOAD]}.make_cast (downloads.next))
			from
			until
				(l_down___0.c_pointer.to_integer_32).to_natural_32 = ((downloads.address).c_pointer.to_integer_32).to_natural_32
			loop
				if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_down___0.item.file), create {CE_POINTER [INTEGER_8]}.make_cast (a_file))).to_boolean then
					l_down___0.ce_gets (l_down___0.item.prev)
					abort_download (l_down___0.item.next)
				end
				l_down___0.ce_gets (l_down___0.item.next)
			end
		end

	undisplay_download (a_down___0: CE_POINTER [PD_DOWNLOAD])
		do
			if ((a_down___0.item.win).c_pointer /= default_pointer) then
				terminal_inst.delete_window (a_down___0.item.win)
			end
		end

	undisplay_download_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent undisplay_download)
		end

	dlg_abort_download (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		do
			select_inst.register_bottom_half ((abort_download_address), (a_dlg.item.dlg).item.udata).do_nothing
			Result := 0
		end

	dlg_abort_download_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dlg_abort_download)
		end

	dlg_undisplay_download (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		do
			select_inst.register_bottom_half ((undisplay_download_address), (a_dlg.item.dlg).item.udata).do_nothing
			Result := 0
		end

	dlg_undisplay_download_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dlg_undisplay_download)
		end

	download_abort_function (a_dlg: CE_POINTER [PD_DIALOG_DATA])
		local
			l_down___0: CE_POINTER [PD_DOWNLOAD]
		do
			create l_down___0.make

			l_down___0.ce_gets (create {CE_POINTER [PD_DOWNLOAD]}.make_cast ((a_dlg.item.dlg).item.udata))
			l_down___0.item.win := create {CE_POINTER [PD_WINDOW]}.make_shared (default_pointer)
		end

	download_abort_function_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent download_abort_function)
		end

	download_window_function (a_dlg: CE_POINTER [PD_DIALOG_DATA])
		local
			l_down___0: CE_POINTER [PD_DOWNLOAD]
			l_term: CE_POINTER [PD_TERMINAL]
			l_max: INTEGER_32
			l_min: INTEGER_32
			l_w: INTEGER_32
			l_x: INTEGER_32
			l_y: INTEGER_32
			l_t: INTEGER_32
			l_m: CE_POINTER [NATURAL_8]
			l_u: CE_POINTER [NATURAL_8]
			l_stat___0: CE_POINTER [PD_STATUS]
			l_l: INTEGER_32
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_q: CE_ARRAY [NATURAL_8]
			l_p: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_down___0.make
			create l_term.make
			create l_m.make
			create l_u.make
			create l_stat___0.make
			create l_tmp___6.make
			create l_tmp___7.make
			create l_q.make (<<64>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_down___0.ce_gets (create {CE_POINTER [PD_DOWNLOAD]}.make_cast ((a_dlg.item.dlg).item.udata))
					l_term.ce_gets ((a_dlg.item.win).item.term)
					l_max := 0
					l_min := 0
					l_t := 0
					l_stat___0.ce_gets (create {CE_POINTER [PD_STATUS]}.make_shared (l_down___0.c_pointer + {PD_DOWNLOAD}.stat_offset))
					terminal_inst.redraw_below_window (a_dlg.item.win)
					l_down___0.item.win := a_dlg.item.win
					if l_stat___0.item.state = 8 then
						if ((l_stat___0.item.prg).item.elapsed // 100).to_boolean then
							l_l := 0
							l_m.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 360))
							l_t := 1
							links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (language_inst.get_text_translation (links_inst.dummyarray + 155, l_term)))
							links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
							add_xnum_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (l_stat___0.item.prg).item.pos)
							if (l_stat___0.item.prg).item.size >= 0 then
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (language_inst.get_text_translation (links_inst.dummyarray + 156, l_term)))
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
								add_xnum_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (l_stat___0.item.prg).item.size)
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
							end
							links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
							if (l_stat___0.item.prg).item.elapsed >= 10000 then
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (language_inst.get_text_translation (links_inst.dummyarray + 159, l_term)))
							else
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (language_inst.get_text_translation (links_inst.dummyarray + 160, l_term)))
							end
							links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
							add_xnum_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), ((((l_stat___0.item.prg).item.loaded).to_integer_64 * {INTEGER_64} 10) // ((l_stat___0.item.prg).item.elapsed // 100).to_integer_64).to_integer_32)
							links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/s")))
							if (l_stat___0.item.prg).item.elapsed >= 10000 then
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (", ")))
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (language_inst.get_text_translation (links_inst.dummyarray + 161, l_term)))
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
								add_xnum_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (l_stat___0.item.prg).item.cur_loaded // 5)
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/s")))
							end
							links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
							links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (language_inst.get_text_translation (links_inst.dummyarray + 162, l_term)))
							links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
							add_time_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (l_stat___0.item.prg).item.elapsed // 1000)
							if (l_stat___0.item.prg).item.size >= 0 then
								if (l_stat___0.item.prg).item.loaded > 0 then
									links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (", ")))
									links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (language_inst.get_text_translation (links_inst.dummyarray + 163, l_term)))
									links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
									add_time_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (((l_stat___0.item.prg).item.size - (l_stat___0.item.prg).item.pos).to_integer_64 // ((((l_stat___0.item.prg).item.loaded).to_integer_64 * {INTEGER_64} 10) // ((l_stat___0.item.prg).item.elapsed // 100).to_integer_64)).to_integer_32)
								end
							end
						else
							l_tmp___6.ce_gets (get_err_msg (l_stat___0.item.state))
							l_tmp___7.ce_gets (language_inst.get_text_translation (l_tmp___6, l_term))
							l_m.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 389, l_tmp___7))
						end
					else
						l_tmp___6.ce_gets (get_err_msg (l_stat___0.item.state))
						l_tmp___7.ce_gets (language_inst.get_text_translation (l_tmp___6, l_term))
						l_m.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 389, l_tmp___7))
					end
					l_u.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 390, l_down___0.item.url))
					if (((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_u), 1))).c_pointer /= default_pointer) then
						(strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_u), 1))[0] := (0).to_integer_8
					end
					bfu_inst.max_text_width (l_term, l_u, create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))
					bfu_inst.min_text_width (l_term, l_u, create {CE_POINTER [INTEGER_32]}.make_shared ($l_min))
					bfu_inst.max_text_width (l_term, l_m, create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))
					bfu_inst.min_text_width (l_term, l_m, create {CE_POINTER [INTEGER_32]}.make_shared ($l_min))
					bfu_inst.max_buttons_width (l_term, a_dlg.item.items, a_dlg.item.n, create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))
					bfu_inst.min_buttons_width (l_term, a_dlg.item.items, a_dlg.item.n, create {CE_POINTER [INTEGER_32]}.make_shared ($l_min))
					l_w := (((a_dlg.item.win).item.term).item.x * 9) // 10 - 12
					if l_w < l_min then
						l_w := l_min
					end
					if l_w > ((a_dlg.item.win).item.term).item.x - 12 then
						l_w := ((a_dlg.item.win).item.term).item.x - 12
					end
					if not (l_t.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (l_stat___0.item.prg).item.size >= 0 then
							if l_w < 20 then
								l_w := 20
							end
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if l_w > l_max then
							l_w := l_max
						end
				when 4 then
					if l_w < 1 then
						l_w := 1
					end
					l_y := 0
					bfu_inst.dlg_format_text (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, l_u, 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 14336, 0)
					l_y := l_y + 1
					if l_t.to_boolean then
						if (l_stat___0.item.prg).item.size >= 0 then
							l_y := l_y + (2)
						end
					end
					bfu_inst.dlg_format_text (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, l_m, 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 14336, 0)
					l_y := l_y + 1
					bfu_inst.dlg_format_buttons (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, a_dlg.item.items, a_dlg.item.n, 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 1)
					a_dlg.item.xw := l_w + 12
					a_dlg.item.yw := l_y + 4
					bfu_inst.center_dlg (a_dlg)
					bfu_inst.draw_dlg (a_dlg)
					l_y := (a_dlg.item.y + 2) + 1
					l_x := a_dlg.item.x + 6
					bfu_inst.dlg_format_text (l_term, l_term, l_u, l_x, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 14336, 0)
					if l_t.to_boolean then
						if (l_stat___0.item.prg).item.size >= 0 then
							l_p := l_w - 6
							l_y := l_y + 1
							terminal_inst.set_only_char (l_term, l_x, l_y, (('[').code).to_natural_32)
							terminal_inst.set_only_char (l_term, (l_x + l_w) - 5, l_y, ((']').code).to_natural_32)
							terminal_inst.fill_area (l_term, l_x + 1, l_y, ((l_p.to_integer_64 * ((l_stat___0.item.prg).item.pos).to_integer_64) // ((l_stat___0.item.prg).item.size).to_integer_64).to_integer_32, 1, {NATURAL_32} 1792)
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_q), ce_string ("%%3d%%%%"), (({INTEGER_64} 100 * ((l_stat___0.item.prg).item.pos).to_integer_64) // ((l_stat___0.item.prg).item.size).to_integer_64).to_integer_32]).do_nothing
							terminal_inst.print_text (l_term, (l_x + l_w) - 4, l_y, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_q))).to_integer_32, l_q, {NATURAL_32} 14336)
							l_y := l_y + 1
						end
					end
					l_y := l_y + 1
					bfu_inst.dlg_format_text (l_term, l_term, l_m, l_x, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 14336, 0)
					l_y := l_y + 1
					bfu_inst.dlg_format_buttons (l_term, l_term, a_dlg.item.items, a_dlg.item.n, l_x, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 1)
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 436, create {CE_POINTER [ANY]}.make_cast (l_u))
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 437, create {CE_POINTER [ANY]}.make_cast (l_m))
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	download_window_function_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent download_window_function)
		end

	display_download (a_term: CE_POINTER [PD_TERMINAL]; a_down___0: CE_POINTER [PD_DOWNLOAD]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_dlg: CE_POINTER [PD_DIALOG]
			l_dd: CE_POINTER [PD_DOWNLOAD]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_dlg.make
			create l_dd.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dd.ce_gets (create {CE_POINTER [PD_DOWNLOAD]}.make_cast (downloads.next))
				when 1 then -- loop condition:
					if (l_dd.c_pointer.to_integer_32).to_natural_32 = ((downloads.address).c_pointer.to_integer_32).to_natural_32 then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if (l_dd.c_pointer.to_integer_32).to_natural_32 = (a_down___0.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 5 -- goto found
						end
				when 3 then
						l_dd.ce_gets (l_dd.item.next)
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					js.return
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 5 then -- if: | found:
						l_dlg.ce_gets (create {CE_POINTER [PD_DIALOG]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 447, {PD_DIALOG}.sizeof.to_natural_32 + {NATURAL_32} 3 * {PD_DIALOG_ITEM}.sizeof.to_natural_32))))
						memset (create {CE_POINTER [ANY]}.make_cast (l_dlg), 0, {PD_DIALOG}.sizeof.to_natural_32 + {NATURAL_32} 3 * {PD_DIALOG_ITEM}.sizeof.to_natural_32).do_nothing
						undisplay_download (a_down___0)
						a_down___0.item.ses := a_ses
						l_dlg.item.title := links_inst.dummyarray + 117
						l_dlg.item.fn := download_window_function_address
						l_dlg.item.abort := download_abort_function_address
						l_dlg.item.udata := create {CE_POINTER [ANY]}.make_cast (a_down___0)
						l_dlg.item.align := 1
						l_dlg.item.items[0].type := 4
						l_dlg.item.items[0].gid := 3
						l_dlg.item.items[0].fn := dlg_undisplay_download_address
						l_dlg.item.items[0].text := links_inst.dummyarray + 164
						l_dlg.item.items[1].type := 4
						l_dlg.item.items[1].gid := 0
						l_dlg.item.items[1].fn := dlg_abort_download_address
						l_dlg.item.items[1].text := links_inst.dummyarray + 165
						l_dlg.item.items[2].type := 0
						bfu_inst.do_dialog (a_term, l_dlg, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_dlg), create {CE_POINTER [ANY]}.make_shared (default_pointer)])))
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	display_download_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent display_download)
		end

	parse_http_date (a_date: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_date: CE_POINTER [INTEGER_8]
			l_months: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_t: INTEGER_32
			l_tm: SD_TM
			js: JUMP_STATE
		do
			create l_date.make
			create l_months.make (<<12>>)
			create l_tm.make

			l_date.ce_gets (a_date)
			l_months[0] := ce_string ("Jan")
			l_months[1] := ce_string ("Feb")
			l_months[2] := ce_string ("Mar")
			l_months[3] := ce_string ("Apr")
			l_months[4] := ce_string ("May")
			l_months[5] := ce_string ("Jun")
			l_months[6] := ce_string ("Jul")
			l_months[7] := ce_string ("Aug")
			l_months[8] := ce_string ("Sep")
			l_months[9] := ce_string ("Oct")
			l_months[10] := ce_string ("Nov")
			l_months[11] := ce_string ("Dec")
			l_t := (0).to_integer_32
			if (l_date).c_pointer = default_pointer then
				Result := (0).to_integer_32
				js.return
			elseif (strlen (l_date)) < {NATURAL_32} 28 then
				Result := (0).to_integer_32
				js.return
			end
			if not js.return_called then
				l_date.ce_gets (l_date + (5))
				l_tm.tm_mday := ((((l_date[0]).to_integer_32 - 48) * 10 + (l_date[1]).to_integer_32) - 48)
				l_date.ce_gets (l_date + (3))
				l_tm.tm_mon := 0
				from
				until
					not (not js.loop_left and then (l_tm.tm_mon < 12))
				loop
					js.reset
					if not (strncmp (l_date, l_months[l_tm.tm_mon], (3).to_natural_32)).to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_tm.tm_mon := (l_tm.tm_mon) + 1
					end
				end
				js.reset
				l_date.ce_gets (l_date + (4))
				l_tm.tm_year := (((((((l_date[0]).to_integer_32 - 48) * 1000 + ((l_date[1]).to_integer_32 - 48) * 100) + ((l_date[2]).to_integer_32 - 48) * 10) + (l_date[3]).to_integer_32) - 48) - 1900)
				l_date.ce_gets (l_date + (5))
				l_tm.tm_hour := ((((l_date[0]).to_integer_32 - 48) * 10 + (l_date[1]).to_integer_32) - 48)
				l_date.ce_gets (l_date + (3))
				l_tm.tm_min := ((((l_date[0]).to_integer_32 - 48) * 10 + (l_date[1]).to_integer_32) - 48)
				l_date.ce_gets (l_date + (3))
				l_tm.tm_sec := ((((l_date[0]).to_integer_32 - 48) * 10 + (l_date[1]).to_integer_32) - 48)
				l_t := mktime (l_tm.address)
				if l_t = -1 then
					Result := (0).to_integer_32
				else
					Result := l_t
				end
			end
		end

	download_data (a_stat___0: CE_POINTER [PD_STATUS]; a_down___0: CE_POINTER [PD_DOWNLOAD])
		local
			l_ce: CE_POINTER [PD_CACHE_ENTRY]
			l_frag: CE_POINTER [PD_FRAGMENT]
			l_u: CE_POINTER [NATURAL_8]
			l_p: CE_POINTER [NATURAL_8]
			l_pos___0: CE_POINTER [NATURAL_8]
			l_ev: PD_EVENT
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_w: INTEGER_32
			l_emsg: CE_POINTER [NATURAL_8]
			l_msg: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [PD_MEMORY_LIST]
			l_t: CE_POINTER [NATURAL_8]
			l_tt: CE_POINTER [NATURAL_8]
			l_tmp___12: CE_POINTER [PD_SESSION]
			l_tmp___13: CE_POINTER [PD_MEMORY_LIST]
			l_foo: SD_UTIMBUF
			l_ev___0: PD_EVENT
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ce.make
			create l_frag.make
			create l_u.make
			create l_p.make
			create l_pos___0.make
			create l_ev.make
			create l_emsg.make
			create l_msg.make
			create l_tmp___6.make
			create l_t.make
			create l_tt.make
			create l_tmp___12.make
			create l_tmp___13.make
			create l_foo.make
			create l_ev___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_stat___0.item.state >= 0 then
						if a_stat___0.item.state < 8 then
							l_pos := -1 + 10 -- goto end_store
						end
					end
				when 1 then
					l_ce.ce_gets (a_stat___0.item.ce)
					if (l_ce).c_pointer = default_pointer then
						l_pos := -1 + 10 -- goto end_store
					end
				when 2 then
					if ((l_ce.item.last_modified).c_pointer /= default_pointer) then
						a_down___0.item.remotetime := parse_http_date (create {CE_POINTER [INTEGER_8]}.make_cast (l_ce.item.last_modified))
					end
					if (l_ce.item.redirect).c_pointer = default_pointer then
						l_pos := -1 + 6 -- skip if block
					end
				when 3 then -- if:
						l_tmp___1 := a_down___0.item.redirect_cnt
						a_down___0.item.redirect_cnt := (a_down___0.item.redirect_cnt) + 1
						if not (l_tmp___1 < 10) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_stat___0.item.state >= 0 then
							sched_inst.change_connection (create {CE_POINTER [PD_STATUS]}.make_shared (a_down___0.c_pointer + {PD_DOWNLOAD}.stat_offset), create {CE_POINTER [PD_STATUS]}.make_shared (default_pointer), 5)
						end
						l_u.ce_gets (url_inst.join_urls (a_down___0.item.url, l_ce.item.redirect))
						if (l_u).c_pointer = default_pointer then
							l_pos := -1 + 7 -- goto x
						end
				when 5 then
						l_pos___0.ce_gets (url_inst.extract_position (l_u))
						if ((l_pos___0).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 510, create {CE_POINTER [ANY]}.make_cast (l_pos___0))
						end
						if not (default_inst.http_bugs.bug_302_redirect).to_boolean then
							if not (l_ce.item.redirect_get).to_boolean then
								l_p.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (a_down___0.item.url), 1))))
								if ((l_p).c_pointer /= default_pointer) then
									links_inst.add_to_strn (l_u.address, l_p)
								end
							end
						end
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 512, create {CE_POINTER [ANY]}.make_cast (a_down___0.item.url))
						a_down___0.item.url := l_u
						a_down___0.item.stat.state := -999
						if ((a_down___0.item.win).c_pointer /= default_pointer) then
							l_ev.ev := 3
							l_ev.x := 0
							l_ev.y := 0
							l_ev.b := 0
							l_ev.x := (((a_down___0.item.win).item.term).item.x).to_integer_32
							l_ev.y := (((a_down___0.item.win).item.term).item.y).to_integer_32;
							((a_down___0.item.win).item.handler).call ([a_down___0.item.win, l_ev.address, 0])
						end
						if a_down___0.item.redirect_cnt < 5 then
							l_tmp___0 := 1
						else
							l_tmp___0 := 3
						end
						sched_inst.load_url (a_down___0.item.url, create {CE_POINTER [PD_STATUS]}.make_shared (a_down___0.c_pointer + {PD_DOWNLOAD}.stat_offset), 0, l_tmp___0).do_nothing
						js.return
				when 6 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | x:
							l_frag.ce_gets (create {CE_POINTER [PD_FRAGMENT]}.make_cast (l_ce.item.frag.next))
							from
							until
								not (not js.loop_left and then ((l_frag.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_ce.c_pointer + {PD_CACHE_ENTRY}.frag_offset)).c_pointer.to_integer_32).to_natural_32))
							loop
								from
								until
									js.loop_left
								loop
									js.reset
									if l_frag.item.offset <= a_down___0.item.last_pos then
										if not (l_frag.item.offset + l_frag.item.length > a_down___0.item.last_pos) then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_w := write (a_down___0.item.handle, create {CE_POINTER [ANY]}.make_cast ((l_frag.item.data + (a_down___0.item.last_pos - l_frag.item.offset))), (l_frag.item.length - (a_down___0.item.last_pos - l_frag.item.offset)).to_natural_32)
										if l_w = -1 then
											if ((sessions.next).c_pointer.to_integer_32).to_natural_32 /= ((sessions.address).c_pointer.to_integer_32).to_natural_32 then
												l_emsg.ce_gets ((links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 551, create {CE_POINTER [NATURAL_8]}.make_cast ((strerror ((errno_location).item))))))
												l_msg.ce_gets ((links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 552, a_down___0.item.file)))
												l_tmp___6.ce_gets (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_msg), l_emsg, create {CE_POINTER [ANY]}.make_shared (default_pointer)]))
												bfu_inst.msg_box ([(get_download_ses (a_down___0)).item.term, l_tmp___6, links_inst.dummyarray + 168, 129, links_inst.dummyarray + 169, ce_string (" "), l_msg, ce_string (": "), l_emsg, create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
											end
											sched_inst.detach_connection (a_stat___0, a_down___0.item.last_pos)
											abort_download (a_down___0)
											js.return
										end
										if not js.return_called then
											a_down___0.item.last_pos := a_down___0.item.last_pos + l_w.to_integer_32
										end
									end
								end
								js.reset
								if not js.return_called then
									l_frag.ce_gets (l_frag.item.next)
								end
							end
				when 8 then -- if done
						if js.return_called then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
							sched_inst.detach_connection (a_stat___0, a_down___0.item.last_pos)
				when 10 then -- end_store:
							
							if a_stat___0.item.state < 0 then
								if a_stat___0.item.state /= -1000 then
									l_t.ce_gets ((get_err_msg (a_stat___0.item.state)))
									if ((l_t).c_pointer /= default_pointer) then
										l_tt.ce_gets ((links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 567, a_down___0.item.url)))
										if (((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_tt), 1))).c_pointer /= default_pointer) then
											(strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_tt), 1))[0] := (0).to_integer_8
										end
										l_tmp___12.ce_gets (get_download_ses (a_down___0))
										l_tmp___13.ce_gets (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_tt), create {CE_POINTER [ANY]}.make_shared (default_pointer)]))
										bfu_inst.msg_box ([(get_download_ses (a_down___0)).item.term, l_tmp___13, links_inst.dummyarray + 168, 129, links_inst.dummyarray + 170, ce_string (" "), l_tt, ce_string (":%N%N"), l_t, create {CE_POINTER [ANY]}.make_shared (default_pointer), l_tmp___12, 1, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
									end
								elseif ((a_down___0.item.prog).c_pointer /= default_pointer) then
									links_inst.prealloc_truncate (a_down___0.item.handle, a_down___0.item.last_pos)
									close (a_down___0.item.handle).do_nothing
									a_down___0.item.handle := -1
									terminal_inst.exec_on_terminal ((get_download_ses (a_down___0)).item.term, a_down___0.item.prog, a_down___0.item.file, ((a_down___0.item.prog_flags).to_boolean).to_integer)
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 576, create {CE_POINTER [ANY]}.make_cast (a_down___0.item.prog))
									a_down___0.item.prog := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
								elseif (a_down___0.item.remotetime).to_boolean then
									if default_inst.download_utime.to_boolean then
										l_foo.modtime := a_down___0.item.remotetime
										l_foo.actime := l_foo.modtime
										utime (create {CE_POINTER [INTEGER_8]}.make_cast (a_down___0.item.file), (l_foo.address)).do_nothing
									end
								end
								abort_download (a_down___0)
								js.return
							end
				when 11 then -- if done
						if not js.return_called and then ((a_down___0.item.win).c_pointer /= default_pointer) then
							l_ev___0.ev := 3
							l_ev___0.x := 0
							l_ev___0.y := 0
							l_ev___0.b := 0
							l_ev___0.x := (((a_down___0.item.win).item.term).item.x).to_integer_32
							l_ev___0.y := (((a_down___0.item.win).item.term).item.y).to_integer_32;
							((a_down___0.item.win).item.handler).call ([a_down___0.item.win, l_ev___0.address, 0])
						end
				when 12 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	download_data_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent download_data)
		end

	create_download_file (a_term: CE_POINTER [PD_TERMINAL]; a_fi: CE_POINTER [NATURAL_8]; a_safe: INTEGER_32): INTEGER_32
		local
			l_file: CE_POINTER [NATURAL_8]
			l_wd: CE_POINTER [NATURAL_8]
			l_h: INTEGER_32
			l_i: INTEGER_32
			l_sf: INTEGER_32
			l_h___0: CE_POINTER [NATURAL_8]
			l_fl: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_msg: CE_POINTER [NATURAL_8]
			l_msge: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_file.make
			create l_wd.make
			create l_h___0.make
			create l_msg.make
			create l_msge.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_file.ce_gets (a_fi)
					l_wd.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_sf := a_safe
					if not a_safe.to_boolean then
						l_wd.ce_gets (terminal_inst.get_cwd)
						terminal_inst.set_cwd (a_term.item.cwd)
						if (l_file[0]).to_integer_32 = 126 then
							if (os_dep_inst.dir_sep ((l_file[1]).to_integer_8)).to_boolean then
								l_h___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((getenv (ce_string ("HOME")))))
								if ((l_h___0).c_pointer /= default_pointer) then
									l_fl := 0
									l_file.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 612))
									links_inst.add_to_str (l_file.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_fl), l_h___0)
									links_inst.add_to_str (l_file.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_fl), a_fi + 1)
								end
							end
						end
					end
					if l_sf.to_boolean then
						l_tmp___1 := 384
					else
						l_tmp___1 := 438
					end
					if a_safe.to_boolean then
						l_tmp___2 := 128
					else
						l_tmp___2 := 0
					end
					l_h := open ([create {CE_POINTER [INTEGER_8]}.make_cast (l_file), (577).bit_or (l_tmp___2), l_tmp___1])
					if l_h /= -1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (errno_location).item = 17 then
							if a_safe.to_boolean then
								l_h := -2
								l_pos := -1 + 9 -- goto x
							end
						end
				when 2 then
						l_msg.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 625, l_file))
						l_msge.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 626, create {CE_POINTER [NATURAL_8]}.make_cast ((strerror ((errno_location).item)))))
						bfu_inst.msg_box ([a_term, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_msg), l_msge, create {CE_POINTER [ANY]}.make_shared (default_pointer)])), links_inst.dummyarray + 168, 129, links_inst.dummyarray + 171, ce_string (" "), l_msg, ce_string (": "), l_msge, create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
						l_pos := -1 + 9 -- goto x
				when 3 then
					os_dep_inst.set_bin (l_h)
					if a_safe.to_boolean then
						l_pos := -1 + 9 -- goto x
					end
				when 4 then
					if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_file))) >= {NATURAL_32} 1024 then
						memcpy (create {CE_POINTER [ANY]}.make_cast (default_inst.download_dir), create {CE_POINTER [ANY]}.make_cast (l_file), (1023).to_natural_32).do_nothing
						default_inst.download_dir[1023] := (0).to_natural_8
					else
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (default_inst.download_dir), create {CE_POINTER [INTEGER_8]}.make_cast (l_file)).do_nothing
					end
					l_i := ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (default_inst.download_dir))) - {NATURAL_32} 1).to_integer_32
				when 5 then -- loop condition:
					if not (l_i >= 0) then
						l_pos := -1 + 8 -- skip loop
					end
				when 6 then -- loop body:
						if (os_dep_inst.dir_sep ((default_inst.download_dir[l_i]).to_integer_8)).to_boolean then
							default_inst.download_dir[l_i + 1] := (0).to_natural_8
							l_pos := -1 + 9 -- goto x
						end
				when 7 then
						l_i := l_i - 1
						l_pos := -1 + 5 -- back to loop condition
				when 8 then -- loop done
					default_inst.download_dir[0] := (0).to_natural_8
				when 9 then -- x:
					if (l_file.c_pointer.to_integer_32).to_natural_32 /= (a_fi.c_pointer.to_integer_32).to_natural_32 then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 640, create {CE_POINTER [ANY]}.make_cast (l_file))
					end
					if ((l_wd).c_pointer /= default_pointer) then
						terminal_inst.set_cwd (l_wd)
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 641, create {CE_POINTER [ANY]}.make_cast (l_wd))
					end
					Result := l_h
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_temp_name (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_l: INTEGER_32
			l_nl: INTEGER_32
			l_name: CE_POINTER [NATURAL_8]
			l_fn: CE_POINTER [NATURAL_8]
			l_fnn: CE_POINTER [NATURAL_8]
			l_fnnn: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_nm: CE_POINTER [NATURAL_8]
			l_directory: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_name.make
			create l_fn.make
			create l_fnn.make
			create l_fnnn.make
			create l_s.make
			create l_nm.make
			create l_directory.make

			l_directory.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			l_nm.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((tempnam (create {CE_POINTER [INTEGER_8]}.make_cast (l_directory), ce_string ("links")))))
			if (l_nm).c_pointer = default_pointer then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_name.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 660))
				l_nl := 0
				links_inst.add_to_str (l_name.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_nl), l_nm)
				free (create {CE_POINTER [ANY]}.make_cast (l_nm))
				url_inst.get_filename_from_url (a_url, l_fn.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l))
				l_fnnn.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				l_fnn.ce_gets (l_fn)
				from
				until
					not ((l_fnn.c_pointer.to_integer_32).to_natural_32 < ((l_fn + l_l).c_pointer.to_integer_32).to_natural_32)
				loop
					if (l_fnn.item).to_integer_32 = 46 then
						l_fnnn.ce_gets (l_fnn)
					end
					l_fnn.ce_gets (l_fnn + 1)
				end
				if ((l_fnnn).c_pointer /= default_pointer) then
					l_s.ce_gets (links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 668, l_fnnn, l_l - (l_fnnn.distance (l_fn))))
					os_dep_inst.check_shell_security (l_s.address)
					links_inst.add_to_str (l_name.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_nl), l_s)
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 671, create {CE_POINTER [ANY]}.make_cast (l_s))
				end
				Result := l_name
			end
		end

	subst_file (a_prog: CE_POINTER [NATURAL_8]; a_file: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_prog: CE_POINTER [NATURAL_8]
			l_n: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_p: INTEGER_32
			js: JUMP_STATE
		do
			create l_prog.make
			create l_n.make

			l_prog.ce_gets (a_prog)
			l_n.ce_gets ((links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 678)))
			l_l := 0
			from
			until
				not (not js.loop_left and then ((l_prog.item).to_boolean))
			loop
				l_p := 0
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_prog[l_p]).to_boolean then
						if (l_prog[l_p]).to_integer_32 = 37 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_p := l_p + 1
					end
				end
				js.reset
				links_inst.add_bytes_to_str (l_n.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_prog, l_p)
				l_prog.ce_gets (l_prog + l_p)
				if (l_prog.item).to_integer_32 = 37 then
					links_inst.add_to_str (l_n.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), a_file)
					l_prog.ce_gets (l_prog + 1)
				end
			end
			Result := l_n
		end

	start_download (a_ses: CE_POINTER [PD_SESSION]; a_file: CE_POINTER [NATURAL_8])
		local
			l_down___0: CE_POINTER [PD_DOWNLOAD]
			l_h: INTEGER_32
			l_url: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_down___0.make
			create l_url.make

			l_url.ce_gets (a_ses.item.dn_url)
			if (l_url).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				kill_downloads_to_file (a_file)
				l_h := create_download_file (a_ses.item.term, a_file, 0)
				if l_h < 0 then
					js.return
				end
			end
			if not js.return_called then
				l_down___0.ce_gets (create {CE_POINTER [PD_DOWNLOAD]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 711, {PD_DOWNLOAD}.sizeof.to_natural_32))))
				memset (create {CE_POINTER [ANY]}.make_cast (l_down___0), 0, {PD_DOWNLOAD}.sizeof.to_natural_32).do_nothing
				l_down___0.item.url := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 713, l_url)
				l_down___0.item.stat.end2 := (download_data_address)
				l_down___0.item.stat.data := create {CE_POINTER [ANY]}.make_cast (l_down___0)
				l_down___0.item.last_pos := (0).to_integer_32
				l_down___0.item.file := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 717, a_file)
				l_down___0.item.handle := l_h
				l_down___0.item.ses := a_ses
				l_down___0.item.remotetime := (0).to_integer_32
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((downloads.address)))
					l_down___0.item.next := (create {CE_POINTER [PD_DOWNLOAD]}.make_cast ((downloads.address))).item.next
					l_down___0.item.prev := create {CE_POINTER [PD_DOWNLOAD]}.make_cast ((downloads.address));
					(create {CE_POINTER [PD_DOWNLOAD]}.make_cast ((downloads.address))).item.next := l_down___0;
					(l_down___0.item.next).item.prev := l_down___0
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((downloads.address)))
					js.break
				end
				js.reset
				sched_inst.load_url (l_url, create {CE_POINTER [PD_STATUS]}.make_shared (l_down___0.c_pointer + {PD_DOWNLOAD}.stat_offset), 0, 1).do_nothing
				display_download (a_ses.item.term, l_down___0, a_ses)
			end
		end

	start_download_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent start_download)
		end

	continue_download (a_ses: CE_POINTER [PD_SESSION]; a_file: CE_POINTER [NATURAL_8])
		local
			l_file: CE_POINTER [NATURAL_8]
			l_down___0: CE_POINTER [PD_DOWNLOAD]
			l_h: INTEGER_32
			l_namecount: INTEGER_32
			l_url: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_file.make
			create l_down___0.make
			create l_url.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_file.ce_gets (a_file)
					l_namecount := 0
					l_url.ce_gets (a_ses.item.tq_url)
					if (l_url).c_pointer = default_pointer then
						js.return
					end
					if not (not js.return_called and then ((a_ses.item.tq_prog).c_pointer /= default_pointer)) then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | new_name:
						l_file.ce_gets (get_temp_name (l_url))
						if (l_file).c_pointer = default_pointer then
							tp_cancel (a_ses)
							js.return
						end
				when 2 then -- if done
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 3 then -- if:
						kill_downloads_to_file (l_file)
						if (a_ses.item.tq_prog).c_pointer = default_pointer then
							kill_downloads_to_file (l_file)
						end
						l_h := create_download_file (a_ses.item.term, l_file, (((a_ses.item.tq_prog).c_pointer /= default_pointer)).to_integer)
						if not (l_h < 0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if l_h /= -2 then
							l_pos := -1 + 8 -- skip if block
						end
				when 5 then -- if:
						if (a_ses.item.tq_prog).c_pointer = default_pointer then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_namecount := l_namecount + 1
						if l_namecount < 10000 then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 749, create {CE_POINTER [ANY]}.make_cast (l_file))
							l_pos := -1 + 1 -- goto new_name
						end
				when 7 then
						bfu_inst.msg_box ([a_ses.item.term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 168, 129, links_inst.dummyarray + 172, create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
				when 8 then -- if done | if done
						if ((a_ses.item.tq_prog).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 754, create {CE_POINTER [ANY]}.make_cast (l_file))
						end
						tp_cancel (a_ses)
						js.return
				when 9 then -- if done | if done
						if not js.return_called then
							l_down___0.ce_gets (create {CE_POINTER [PD_DOWNLOAD]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 758, {PD_DOWNLOAD}.sizeof.to_natural_32))))
							memset (create {CE_POINTER [ANY]}.make_cast (l_down___0), 0, {PD_DOWNLOAD}.sizeof.to_natural_32).do_nothing
							l_down___0.item.url := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 760, l_url)
							l_down___0.item.stat.end2 := (download_data_address)
							l_down___0.item.stat.data := create {CE_POINTER [ANY]}.make_cast (l_down___0)
							l_down___0.item.last_pos := (0).to_integer_32
							l_down___0.item.file := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 764, l_file)
							l_down___0.item.handle := l_h
							l_down___0.item.ses := a_ses
							if ((a_ses.item.tq_prog).c_pointer /= default_pointer) then
								l_down___0.item.prog := subst_file (a_ses.item.tq_prog, l_file)
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 769, create {CE_POINTER [ANY]}.make_cast (l_file))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 770, create {CE_POINTER [ANY]}.make_cast (a_ses.item.tq_prog))
								a_ses.item.tq_prog := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							end
							l_down___0.item.prog_flags := a_ses.item.tq_prog_flags
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((downloads.address)))
								l_down___0.item.next := (create {CE_POINTER [PD_DOWNLOAD]}.make_cast ((downloads.address))).item.next
								l_down___0.item.prev := create {CE_POINTER [PD_DOWNLOAD]}.make_cast ((downloads.address));
								(create {CE_POINTER [PD_DOWNLOAD]}.make_cast ((downloads.address))).item.next := l_down___0;
								(l_down___0.item.next).item.prev := l_down___0
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((downloads.address)))
								js.break
							end
							js.reset
							sched_inst.change_connection (create {CE_POINTER [PD_STATUS]}.make_shared (a_ses.c_pointer + {PD_SESSION}.tq_offset), create {CE_POINTER [PD_STATUS]}.make_shared (l_down___0.c_pointer + {PD_DOWNLOAD}.stat_offset), 0)
							tp_free (a_ses)
							display_download (a_ses.item.term, l_down___0, a_ses)
						end
				when 10 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	continue_download_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent continue_download)
		end

	tp_free (a_ses: CE_POINTER [PD_SESSION])
		do
			(a_ses.item.tq_ce).item.refcount := ((a_ses.item.tq_ce).item.refcount) - 1
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 783, create {CE_POINTER [ANY]}.make_cast (a_ses.item.tq_url))
			a_ses.item.tq_url := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			if ((a_ses.item.tq_goto_position).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 785, create {CE_POINTER [ANY]}.make_cast (a_ses.item.tq_goto_position))
				a_ses.item.tq_goto_position := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
			a_ses.item.tq_ce := create {CE_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer)
		end

	tp_cancel (a_ses: CE_POINTER [PD_SESSION])
		do
			sched_inst.change_connection (create {CE_POINTER [PD_STATUS]}.make_shared (a_ses.c_pointer + {PD_SESSION}.tq_offset), create {CE_POINTER [PD_STATUS]}.make_shared (default_pointer), 5)
			tp_free (a_ses)
		end

	tp_cancel_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent tp_cancel)
		end

	tp_save (a_ses: CE_POINTER [PD_SESSION])
		do
			if ((a_ses.item.tq_prog).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 797, create {CE_POINTER [ANY]}.make_cast (a_ses.item.tq_prog))
				a_ses.item.tq_prog := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
			menu_inst.query_file (a_ses, a_ses.item.tq_url, continue_download_address, tp_cancel_address)
		end

	tp_save_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent tp_save)
		end

	tp_open (a_ses: CE_POINTER [PD_SESSION])
		do
			continue_download (a_ses, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
		end

	tp_open_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent tp_open)
		end

	tp_display (a_ses: CE_POINTER [PD_SESSION])
		local
			l_l: CE_POINTER [PD_LOCATION]
			js: JUMP_STATE
		do
			create l_l.make

			l_l.ce_gets (create {CE_POINTER [PD_LOCATION]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 811, {PD_LOCATION}.sizeof.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_ses.item.tq_url)))))))
			memset (create {CE_POINTER [ANY]}.make_cast (l_l), 0, {PD_LOCATION}.sizeof.to_natural_32).do_nothing
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_l.c_pointer + {PD_LOCATION}.frames_offset))))
			l_l.item.frames.next := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_l.c_pointer + {PD_LOCATION}.frames_offset)))
			l_l.item.frames.prev := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_l.c_pointer + {PD_LOCATION}.frames_offset)))
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_l.c_pointer + {PD_LOCATION}.frames_offset))))
			memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_STATUS]}.make_shared (l_l.c_pointer + {PD_LOCATION}.stat_offset))), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_STATUS]}.make_shared (a_ses.c_pointer + {PD_SESSION}.tq_offset))), {PD_STATUS}.sizeof.to_natural_32).do_nothing
			view_inst.init_vs (create {CE_POINTER [PD_VIEW_STATE]}.make_shared (l_l.c_pointer + {PD_LOCATION}.vs_offset), a_ses.item.tq_url)
			if ((a_ses.item.tq_goto_position).c_pointer /= default_pointer) then
				l_l.item.vs.goto_position := a_ses.item.tq_goto_position
				a_ses.item.tq_goto_position := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
			from
			until
				js.loop_left
			loop
				js.reset
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset))))
				l_l.item.next := (create {CE_POINTER [PD_LOCATION]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)))).item.next
				l_l.item.prev := create {CE_POINTER [PD_LOCATION]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)));
				(create {CE_POINTER [PD_LOCATION]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)))).item.next := l_l;
				(l_l.item.next).item.prev := l_l
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset))))
				js.break
			end
			js.reset;
			(create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)).item.stat.end2 := (doc_end_load_address);
			(create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)).item.stat.data := create {CE_POINTER [ANY]}.make_cast (a_ses)
			if a_ses.item.tq.state >= 0 then
				sched_inst.change_connection (create {CE_POINTER [PD_STATUS]}.make_shared (a_ses.c_pointer + {PD_SESSION}.tq_offset), create {CE_POINTER [PD_STATUS]}.make_shared ((create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)).c_pointer + {PD_LOCATION}.stat_offset), 0)
			else
				(create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)).item.stat.state := a_ses.item.tq.state
			end
			(create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)).item.vs.plain := 1
			display_timer (a_ses)
			tp_free (a_ses)
		end

	tp_display_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent tp_display)
		end

	type_query (a_ses: CE_POINTER [PD_SESSION]; a_ce: CE_POINTER [PD_CACHE_ENTRY]; a_ct: CE_POINTER [NATURAL_8]; a_a: CE_POINTER [PD_ASSOC])
		local
			l_m1: CE_POINTER [NATURAL_8]
			l_m2: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_m1.make
			create l_m2.make
			create l_tmp___1.make

			if ((a_ses.item.tq_prog).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 834, create {CE_POINTER [ANY]}.make_cast (a_ses.item.tq_prog))
				a_ses.item.tq_prog := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
			if ((a_a).c_pointer /= default_pointer) then
				a_ses.item.tq_prog := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 835, a_a.item.prog)
				a_ses.item.tq_prog_flags := a_a.item.block
			end
			if ((a_a).c_pointer /= default_pointer) then
				if not (a_a.item.ask).to_boolean then
					tp_open (a_ses)
					js.return
				end
			end
			if not js.return_called then
				l_m1.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 840, a_ct))
				if (a_a).c_pointer = default_pointer then
					if not default_inst.anonymous.to_boolean then
						bfu_inst.msg_box ([a_ses.item.term, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_m1), create {CE_POINTER [ANY]}.make_shared (default_pointer)])), links_inst.dummyarray + 173, 129, links_inst.dummyarray + 174, ce_string (" "), l_m1, ce_string (".%N"), links_inst.dummyarray + 175, create {CE_POINTER [ANY]}.make_shared (default_pointer), a_ses, 3, links_inst.dummyarray + 176, tp_save_address, 1, links_inst.dummyarray + 177, tp_display_address, 0, links_inst.dummyarray + 6, tp_cancel_address, 2])
					else
						bfu_inst.msg_box ([a_ses.item.term, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_m1), create {CE_POINTER [ANY]}.make_shared (default_pointer)])), links_inst.dummyarray + 173, 129, links_inst.dummyarray + 174, ce_string (" "), l_m1, ce_string (".%N"), links_inst.dummyarray + 175, create {CE_POINTER [ANY]}.make_shared (default_pointer), a_ses, 2, links_inst.dummyarray + 177, tp_display_address, 1, links_inst.dummyarray + 6, tp_cancel_address, 2])
					end
				else
					if ((a_a.item.label).c_pointer /= default_pointer) then
						l_tmp___1.ce_gets (a_a.item.label)
					else
						l_tmp___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
					end
					l_m2.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 845, l_tmp___1))
					if not default_inst.anonymous.to_boolean then
						bfu_inst.msg_box ([a_ses.item.term, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_m1), l_m2, create {CE_POINTER [ANY]}.make_shared (default_pointer)])), links_inst.dummyarray + 178, 129, links_inst.dummyarray + 174, ce_string (" "), l_m1, ce_string (".%N"), links_inst.dummyarray + 179, ce_string (" "), l_m2, ce_string (", "), links_inst.dummyarray + 180, create {CE_POINTER [ANY]}.make_shared (default_pointer), a_ses, 4, links_inst.dummyarray + 181, tp_open_address, 1, links_inst.dummyarray + 176, tp_save_address, 0, links_inst.dummyarray + 177, tp_display_address, 0, links_inst.dummyarray + 6, tp_cancel_address, 2])
					else
						bfu_inst.msg_box ([a_ses.item.term, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_m1), l_m2, create {CE_POINTER [ANY]}.make_shared (default_pointer)])), links_inst.dummyarray + 178, 129, links_inst.dummyarray + 174, ce_string (" "), l_m1, ce_string (".%N"), links_inst.dummyarray + 179, ce_string (" "), l_m2, ce_string (", "), links_inst.dummyarray + 180, create {CE_POINTER [ANY]}.make_shared (default_pointer), a_ses, 3, links_inst.dummyarray + 181, tp_open_address, 1, links_inst.dummyarray + 177, tp_display_address, 0, links_inst.dummyarray + 6, tp_cancel_address, 2])
					end
				end
			end
		end

	ses_chktype (a_ses: CE_POINTER [PD_SESSION]; a_stat___0: CE_POINTER [CE_POINTER [PD_STATUS]]; a_ce: CE_POINTER [PD_CACHE_ENTRY]): INTEGER_32
		local
			l_a: CE_POINTER [PD_ASSOC]
			l_ct: CE_POINTER [NATURAL_8]
			l_r: INTEGER_32
			l_tmp___4: CE_POINTER [PD_STATUS]
			l_tmp___5: CE_POINTER [PD_CACHE_ENTRY]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_a.make
			create l_ct.make
			create l_tmp___4.make
			create l_tmp___5.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_r := 0
					l_ct.ce_gets (types_inst.get_content_type (a_ce.item.head, a_ce.item.url))
					if (l_ct).c_pointer = default_pointer then
						l_pos := -1 + 6 -- goto f
					end
				when 1 then
					if (types_inst.is_html_type (l_ct)).to_boolean then
						l_pos := -1 + 5 -- goto ff
					end
				when 2 then
					l_r := 1
					if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ct), ce_string ("text/plain"))).to_boolean then
						if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ct), ce_string ("file/txt"))).to_boolean then
							l_pos := -1 + 5 -- goto ff
						end
					else
						l_pos := -1 + 5 -- goto ff
					end
				when 3 then
					l_a.ce_gets (types_inst.get_type_assoc (a_ses.item.term, l_ct))
					if (l_a).c_pointer = default_pointer then
						if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ct))) >= {NATURAL_32} 4 then
							if not (links_inst.casecmp (l_ct, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("text")), (4).to_natural_32)).to_boolean then
								l_pos := -1 + 5 -- goto ff
							end
						end
					end
				when 4 then
					if ((a_ses.item.tq_url).c_pointer /= default_pointer) then
						from
						until
							False
						loop
							links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")))
							links_inst.errline := 861
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("type query to %%s already in prgress")), a_ses.item.tq_url])
						end
					end
					a_ses.item.tq_url := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 862, a_ses.item.loading_url)
					l_tmp___4.ce_gets (create {CE_POINTER [PD_STATUS]}.make_shared (a_ses.c_pointer + {PD_SESSION}.tq_offset))
					a_stat___0.item := l_tmp___4
					sched_inst.change_connection (create {CE_POINTER [PD_STATUS]}.make_shared (a_ses.c_pointer + {PD_SESSION}.loading_offset), l_tmp___4, 0)
					l_tmp___5.ce_gets (a_ce)
					a_ses.item.tq_ce := l_tmp___5
					l_tmp___5.item.refcount := (l_tmp___5.item.refcount) + 1
					if ((a_ses.item.tq_goto_position).c_pointer /= default_pointer) then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 865, create {CE_POINTER [ANY]}.make_cast (a_ses.item.tq_goto_position))
					end
					a_ses.item.tq_goto_position := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 866, a_ses.item.goto_position)
					type_query (a_ses, a_ce, l_ct, l_a)
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 868, create {CE_POINTER [ANY]}.make_cast (l_ct))
					Result := 1
					js.return
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 5 then -- if: | ff:
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 872, create {CE_POINTER [ANY]}.make_cast (l_ct))
				when 6 then -- f:
						if ((a_ses.item.wtd_target).c_pointer /= default_pointer) then
							if l_r.to_boolean then
								(a_ses.item.wtd_target).item := (0).to_natural_8
							end
						end
						ses_forward (a_ses);
						(create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)).item.vs.plain := l_r
						Result := 0
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	post_yes (a_w: CE_POINTER [PD_WTD_DATA])
		do
			abort_preloading (a_w.item.ses)
			if (((a_w.item.ses).item.goto_position).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 894, create {CE_POINTER [ANY]}.make_cast ((a_w.item.ses).item.goto_position))
			end
			(a_w.item.ses).item.goto_position := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 895, a_w.item.pos);
			(a_w.item.ses).item.loading.end2 := a_w.item.fn;
			(a_w.item.ses).item.loading.data := create {CE_POINTER [ANY]}.make_cast (a_w.item.ses);
			(a_w.item.ses).item.loading_url := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 898, a_w.item.url);
			(a_w.item.ses).item.wtd := a_w.item.wtd;
			(a_w.item.ses).item.wtd_target := a_w.item.target
			sched_inst.load_url ((a_w.item.ses).item.loading_url, create {CE_POINTER [PD_STATUS]}.make_shared ((a_w.item.ses).c_pointer + {PD_SESSION}.loading_offset), a_w.item.pri, a_w.item.cache).do_nothing
		end

	post_yes_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent post_yes)
		end

	post_no (a_w: CE_POINTER [PD_WTD_DATA])
		do
			(strchr (create {CE_POINTER [INTEGER_8]}.make_cast (a_w.item.url), 1))[0] := (0).to_integer_8
			post_yes (a_w)
		end

	post_no_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent post_no)
		end

	post_cancel (a_w: CE_POINTER [PD_WTD_DATA])
		do
			reload (a_w.item.ses, 1)
		end

	post_cancel_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent post_cancel)
		end

	ses_goto (a_ses: CE_POINTER [PD_SESSION]; a_url: CE_POINTER [NATURAL_8]; a_target: CE_POINTER [NATURAL_8]; a_pri: INTEGER_32; a_cache___0: INTEGER_32; a_wtd: INTEGER_32; a_pos___0: CE_POINTER [NATURAL_8]; a_fn: CE_ROUTINE; a_redir: INTEGER_32)
		local
			l_w: CE_POINTER [PD_WTD_DATA]
			l_m1: CE_POINTER [NATURAL_8]
			l_m2: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [PD_CACHE_ENTRY]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_w.make
			create l_m1.make
			create l_m2.make
			create l_e.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (a_url), 1))).c_pointer = default_pointer then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if a_cache___0 /= 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 2 then -- if:
						if (cache_inst.find_in_cache (a_url, l_e.address)).to_boolean then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (l_e.item.incomplete).to_boolean then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if ((a_ses.item.goto_position).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 921, create {CE_POINTER [ANY]}.make_cast (a_ses.item.goto_position))
						end
						a_ses.item.goto_position := a_pos___0
						a_ses.item.loading.end2 := a_fn
						a_ses.item.loading.data := create {CE_POINTER [ANY]}.make_cast (a_ses)
						a_ses.item.loading_url := a_url
						a_ses.item.wtd := a_wtd
						a_ses.item.wtd_target := a_target
						sched_inst.load_url (a_url, create {CE_POINTER [PD_STATUS]}.make_shared (a_ses.c_pointer + {PD_SESSION}.loading_offset), a_pri, a_cache___0).do_nothing
						js.return
				when 5 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_pos := -1 + 4 -- goto _L
				when 7 then
					if not js.return_called then
						l_w.ce_gets (create {CE_POINTER [PD_WTD_DATA]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 931, {PD_WTD_DATA}.sizeof.to_natural_32))))
						l_w.item.ses := a_ses
						l_w.item.url := a_url
						l_w.item.pri := a_pri
						l_w.item.cache := a_cache___0
						l_w.item.wtd := a_wtd
						l_w.item.target := a_target
						l_w.item.pos := a_pos___0
						l_w.item.fn := a_fn
						if a_redir.to_boolean then
							l_m1.ce_gets (links_inst.dummyarray + 182)
						elseif a_wtd = 1 then
							l_m1.ce_gets (links_inst.dummyarray + 183)
						else
							l_m1.ce_gets (links_inst.dummyarray + 184)
						end
						l_m2.ce_gets (links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 943, a_url, (create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (a_url), 1)))).distance (a_url)))
						bfu_inst.msg_box ([a_ses.item.term, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_m2), l_w, l_w.item.url, l_w.item.pos, create {CE_POINTER [ANY]}.make_shared (default_pointer)])), links_inst.dummyarray + 185, 129, l_m1, ce_string (" "), l_m2, ce_string ("?"), create {CE_POINTER [ANY]}.make_shared (default_pointer), l_w, 3, links_inst.dummyarray + 166, post_yes_address, 1, links_inst.dummyarray + 167, post_no_address, 0, links_inst.dummyarray + 6, post_cancel_address, 2])
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_move (a_ses: CE_POINTER [PD_SESSION]; a_stat___0: CE_POINTER [CE_POINTER [PD_STATUS]]): INTEGER_32
		local
			l_ce: CE_POINTER [PD_CACHE_ENTRY]
			l_u: CE_POINTER [NATURAL_8]
			l_p: CE_POINTER [NATURAL_8]
			l_gp: CE_POINTER [NATURAL_8]
			l_pos___0: CE_POINTER [NATURAL_8]
			l_w: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___5: CE_POINTER [PD_STATUS]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ce.make
			create l_u.make
			create l_p.make
			create l_gp.make
			create l_pos___0.make
			create l_tmp___5.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ce.ce_gets (create {CE_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer))
					if (a_ses.item.loading_url).c_pointer = default_pointer then
						from
						until
							False
						loop
							links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")))
							links_inst.errline := 951
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("no ses->loading_url"))])
						end
						Result := 0
						js.return
					end
					if not js.return_called then
						l_ce.ce_gets ((a_stat___0.item).item.ce)
						if ((l_ce).c_pointer /= default_pointer) then
							if a_ses.item.wtd = 2 then
								if (a_stat___0.item).item.state >= 0 then
									Result := 0
									js.return
								end
							end
						else
							Result := 0
							js.return
						end
					end
					if not (not js.return_called and then ((l_ce.item.redirect).c_pointer /= default_pointer)) then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						l_tmp___3 := a_ses.item.redirect_cnt
						a_ses.item.redirect_cnt := (a_ses.item.redirect_cnt) + 1
						if not (l_tmp___3 < 10) then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						l_w := a_ses.item.wtd
						if a_ses.item.wtd = 4 then
							if (((create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)).item.next).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
								l_pos := -1 + 11 -- goto b
							end
						end
				when 3 then
						l_u.ce_gets (url_inst.join_urls (a_ses.item.loading_url, l_ce.item.redirect))
						if (l_u).c_pointer = default_pointer then
							l_pos := -1 + 11 -- goto b
						end
				when 4 then
						if not (default_inst.http_bugs.bug_302_redirect).to_boolean then
							if not (l_ce.item.redirect_get).to_boolean then
								l_p.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (a_ses.item.loading_url), 1))))
								if ((l_p).c_pointer /= default_pointer) then
									links_inst.add_to_strn (l_u.address, l_p)
								end
							end
						end
						l_gp.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 966, a_ses.item.goto_position))
						l_pos___0.ce_gets (url_inst.extract_position (l_u))
						if ((l_pos___0).c_pointer /= default_pointer) then
							if (l_gp).c_pointer = default_pointer then
								l_gp.ce_gets (l_pos___0)
							else
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 969, create {CE_POINTER [ANY]}.make_cast (l_pos___0))
							end
						end
						abort_loading (a_ses)
						if ((a_ses.item.history.next).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
							a_stat___0.item := create {CE_POINTER [PD_STATUS]}.make_shared ((create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)).c_pointer + {PD_LOCATION}.stat_offset)
						else
							a_stat___0.item := create {CE_POINTER [PD_STATUS]}.make_shared (default_pointer)
						end
						if l_w /= 1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if l_w /= 2 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if a_ses.item.redirect_cnt < 5 then
							l_tmp___0 := 1
						else
							l_tmp___0 := 3
						end
						ses_goto (a_ses, l_u, a_ses.item.wtd_target, 0, l_tmp___0, l_w, l_gp, end_load_address, 1)
						Result := 2
						js.return
				when 9 then -- if done
						if not js.return_called then
							if ((l_gp).c_pointer /= default_pointer) then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 978, create {CE_POINTER [ANY]}.make_cast (l_gp))
							end
							if l_w = 4 then
								if a_ses.item.redirect_cnt < 5 then
									l_tmp___1 := 1
								else
									l_tmp___1 := 3
								end
								ses_goto (a_ses, l_u, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, l_tmp___1, 3, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), end_load_address, 1)
								Result := 2
								js.return
							end
						end
						if not js.return_called and then (l_w = 3) then
							if a_ses.item.redirect_cnt < 5 then
								if a_ses.item.reloadlevel < 3 then
									l_tmp___2 := a_ses.item.reloadlevel
								else
									l_tmp___2 := 3
								end
							else
								l_tmp___2 := 3
							end
							ses_goto (a_ses, l_u, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, l_tmp___2, 3, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), end_load_address, 1)
							Result := 2
							js.return
						end
				when 10 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | b:
							if a_ses.item.display_timer /= -1 then
								select_inst.kill_timer (a_ses.item.display_timer)
								a_ses.item.display_timer := -1
							end
							if a_ses.item.wtd = 1 then
								if (ses_chktype (a_ses, a_stat___0, l_ce)).to_boolean then
									free_wtd (a_ses)
									reload (a_ses, 1)
									Result := 2
									js.return
								end
							end
				when 12 then -- if done
						if not js.return_called then
							if a_ses.item.wtd = 2 then
								ses_imgmap (a_ses)
							end
							if a_ses.item.wtd = 4 then
								ses_back (a_ses)
							end
							if a_ses.item.wtd = 3 then
								ses_back (a_ses)
								ses_forward (a_ses)
							end
							if (a_stat___0.item).item.state >= 0 then
								l_tmp___5.ce_gets (create {CE_POINTER [PD_STATUS]}.make_shared ((create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)).c_pointer + {PD_LOCATION}.stat_offset))
								a_stat___0.item := l_tmp___5
								sched_inst.change_connection (create {CE_POINTER [PD_STATUS]}.make_shared (a_ses.c_pointer + {PD_SESSION}.loading_offset), l_tmp___5, 0)
							else
								(create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)).item.stat.state := a_ses.item.loading.state
							end
							free_wtd (a_ses)
							Result := 1
						end
				when 13 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	request_frame (a_ses: CE_POINTER [PD_SESSION]; a_name: CE_POINTER [NATURAL_8]; a_uurl: CE_POINTER [NATURAL_8])
		local
			l_loc: CE_POINTER [PD_LOCATION]
			l_frm: CE_POINTER [PD_FRAME]
			l_url: CE_POINTER [NATURAL_8]
			l_pos___0: CE_POINTER [NATURAL_8]
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_tmp___2: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_loc.make
			create l_frm.make
			create l_url.make
			create l_pos___0.make
			create l_fd.make
			create l_tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_loc.ce_gets (create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next))
					if ((a_ses.item.history.next).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
						from
						until
							False
						loop
							links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")))
							links_inst.errline := 1014
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("request_frame: no location"))])
						end
						js.return
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						l_frm.ce_gets (create {CE_POINTER [PD_FRAME]}.make_cast (l_loc.item.frames.next))
				when 2 then -- loop condition:
						if not (not js.loop_left and then ((l_frm.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_loc.c_pointer + {PD_LOCATION}.frames_offset)).c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_frm.item.name), create {CE_POINTER [INTEGER_8]}.make_cast (a_name))).to_boolean then
							l_fd.ce_gets (create {CE_POINTER [PD_F_DATA_C]}.make_cast (a_ses.item.scrn_frames.next))
							from
							until
								not (not js.loop_left and then ((l_fd.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.scrn_frames_offset)).c_pointer.to_integer_32).to_natural_32))
							loop
								if ((l_fd.item.vs).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_VIEW_STATE]}.make_shared (l_frm.c_pointer + {PD_FRAME}.vs_offset)).c_pointer.to_integer_32).to_natural_32 then
									if (((l_fd.item.f_data).item.frame_desc).c_pointer /= default_pointer) then
										request_frameset (a_ses, (l_fd.item.f_data).item.frame_desc)
										js.return
									end
								end
								if not js.return_called then
									l_fd.ce_gets (l_fd.item.next)
								end
							end
							if not js.return_called then
								l_url.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1023, l_frm.item.vs.url))
								l_pos := -1 + 7 -- goto found
							end
						end
				when 4 then
						if not js.return_called then
							l_frm.ce_gets (l_frm.item.next)
						end
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done | if done
						if not js.return_called then
							l_url.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1032, a_uurl))
							l_pos___0.ce_gets (url_inst.extract_position (l_url))
							l_frm.ce_gets (create {CE_POINTER [PD_FRAME]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1034, ({PD_FRAME}.sizeof.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_url)))) + {NATURAL_32} 1))))
							memset (create {CE_POINTER [ANY]}.make_cast (l_frm), 0, {PD_FRAME}.sizeof.to_natural_32).do_nothing
							l_tmp___2.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1036, a_name))
							l_frm.item.name := l_tmp___2
							if (l_tmp___2).c_pointer = default_pointer then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1037, create {CE_POINTER [ANY]}.make_cast (l_frm))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1038, create {CE_POINTER [ANY]}.make_cast (l_url))
								if ((l_pos___0).c_pointer /= default_pointer) then
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1039, create {CE_POINTER [ANY]}.make_cast (l_pos___0))
								end
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
							view_inst.init_vs (create {CE_POINTER [PD_VIEW_STATE]}.make_shared (l_frm.c_pointer + {PD_FRAME}.vs_offset), l_url)
							if ((l_pos___0).c_pointer /= default_pointer) then
								l_frm.item.vs.goto_position := l_pos___0
							end
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_loc.c_pointer + {PD_LOCATION}.frames_offset))))
								l_frm.item.next := (create {CE_POINTER [PD_FRAME]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_loc.c_pointer + {PD_LOCATION}.frames_offset)))).item.next
								l_frm.item.prev := create {CE_POINTER [PD_FRAME]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_loc.c_pointer + {PD_LOCATION}.frames_offset)));
								(create {CE_POINTER [PD_FRAME]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_loc.c_pointer + {PD_LOCATION}.frames_offset)))).item.next := l_frm;
								(l_frm.item.next).item.prev := l_frm
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_loc.c_pointer + {PD_LOCATION}.frames_offset))))
								js.break
							end
							js.reset
				when 7 then -- found:
							if (l_url.item).to_boolean then
								request_additional_file (a_ses, l_url, 1).do_nothing
							end
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1047, create {CE_POINTER [ANY]}.make_cast (l_url))
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	request_frameset (a_ses: CE_POINTER [PD_SESSION]; a_fd: CE_POINTER [PD_FRAMESET_DESC])
		local
			l_i: INTEGER_32
		do
			depth := depth + 1
			if depth <= 5 then
				l_i := 0
				from
				until
					not (l_i < a_fd.item.n)
				loop
					if ((a_fd.item.f[l_i].subframe).c_pointer /= default_pointer) then
						request_frameset (a_ses, a_fd.item.f[l_i].subframe)
					elseif ((a_fd.item.f[l_i].name).c_pointer /= default_pointer) then
						request_frame (a_ses, a_fd.item.f[l_i].name, a_fd.item.f[l_i].url)
					end
					l_i := l_i + 1
				end
			end
			depth := depth - 1
		end

	load_frames (a_ses: CE_POINTER [PD_SESSION]; a_fd: CE_POINTER [PD_F_DATA_C])
		local
			l_ff___0: CE_POINTER [PD_F_DATA]
			js: JUMP_STATE
		do
			create l_ff___0.make

			l_ff___0.ce_gets (a_fd.item.f_data)
			if (l_ff___0).c_pointer = default_pointer then
				js.return
			elseif not (l_ff___0.item.frame).to_boolean then
				js.return
			end
			if not js.return_called then
				request_frameset (a_ses, l_ff___0.item.frame_desc)
			end
		end

	display_timer (a_ses: CE_POINTER [PD_SESSION])
		local
			l_t: INTEGER_32
		do
			l_t := (select_inst.get_time)
			html_r_inst.html_interpret (a_ses)
			view_inst.draw_formatted (a_ses)
			l_t := ((select_inst.get_time) - l_t) * 20
			if l_t < 200 then
				l_t := (200).to_integer_32
			end
			a_ses.item.display_timer := select_inst.install_timer (l_t, (display_timer_address), create {CE_POINTER [ANY]}.make_cast (a_ses))
			load_frames (a_ses, a_ses.item.screen)
			process_file_requests (a_ses)
		end

	display_timer_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent display_timer)
		end

	end_load (a_stat___0: CE_POINTER [PD_STATUS]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_stat___0: CE_POINTER [PD_STATUS]
			l_d: INTEGER_32
			js: JUMP_STATE
		do
			create l_stat___0.make

			l_stat___0.ce_gets (a_stat___0)
			if not (a_ses.item.wtd).to_boolean then
				from
				until
					False
				loop
					links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")))
					links_inst.errline := 1086
					error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("end_load: !ses->wtd"))])
				end
				js.return
			end
			if not js.return_called then
				l_d := do_move (a_ses, l_stat___0.address)
				if (l_stat___0).c_pointer = default_pointer then
					js.return
				end
			end
			if not js.return_called then
				if l_d = 1 then
					l_stat___0.item.end2 := (doc_end_load_address)
					display_timer (a_ses)
				end
				if l_stat___0.item.state < 0 then
					if l_d /= 2 then
						if (a_ses.item.wtd).to_boolean then
							free_wtd (a_ses)
						end
					end
					if l_d = 1 then
						doc_end_load (l_stat___0, a_ses)
					end
				end
				if l_stat___0.item.state < 0 then
					if l_stat___0.item.state /= -1000 then
						if l_d /= 2 then
							if l_d /= 1 then
								print_error_dialog (a_ses, l_stat___0, links_inst.dummyarray + 186)
								if not l_d.to_boolean then
									reload (a_ses, 1)
								end
							end
						end
					end
				end
				print_screen_status (a_ses)
			end
		end

	end_load_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent end_load)
		end

	doc_end_load (a_stat___0: CE_POINTER [PD_STATUS]; a_ses: CE_POINTER [PD_SESSION])
		do
			if a_stat___0.item.state < 0 then
				if a_ses.item.display_timer /= -1 then
					select_inst.kill_timer (a_ses.item.display_timer)
					a_ses.item.display_timer := -1
				end
				html_r_inst.html_interpret (a_ses)
				view_inst.draw_formatted (a_ses)
				load_frames (a_ses, a_ses.item.screen)
				process_file_requests (a_ses)
				if a_stat___0.item.state /= -1000 then
					print_error_dialog (a_ses, a_stat___0, links_inst.dummyarray + 186)
				end
			elseif a_ses.item.display_timer = -1 then
				display_timer (a_ses)
			end
			print_screen_status (a_ses)
		end

	doc_end_load_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent doc_end_load)
		end

	file_end_load (a_stat___0: CE_POINTER [PD_STATUS]; a_ftl: CE_POINTER [PD_FILE_TO_LOAD])
		local
			l_tmp: CE_POINTER [PD_CACHE_ENTRY]
		do
			create l_tmp.make

			if ((a_ftl.item.stat.ce).c_pointer /= default_pointer) then
				if ((a_ftl.item.ce).c_pointer /= default_pointer) then
					(a_ftl.item.ce).item.refcount := ((a_ftl.item.ce).item.refcount) - 1
				end
				l_tmp.ce_gets (a_ftl.item.stat.ce)
				a_ftl.item.ce := l_tmp
				l_tmp.item.refcount := (l_tmp.item.refcount) + 1
			end
			doc_end_load (a_stat___0, a_ftl.item.ses)
		end

	file_end_load_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent file_end_load)
		end

	request_additional_file (a_ses: CE_POINTER [PD_SESSION]; a_url: CE_POINTER [NATURAL_8]; a_pri: INTEGER_32): CE_POINTER [PD_FILE_TO_LOAD]
		local
			l_ftl: CE_POINTER [PD_FILE_TO_LOAD]
			js: JUMP_STATE
		do
			create l_ftl.make

			l_ftl.ce_gets (create {CE_POINTER [PD_FILE_TO_LOAD]}.make_cast (a_ses.item.more_files.next))
			from
			until
				not (not js.loop_left and then ((l_ftl.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.more_files_offset)).c_pointer.to_integer_32).to_natural_32))
			loop
				if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ftl.item.url), create {CE_POINTER [INTEGER_8]}.make_cast (a_url))).to_boolean then
					if l_ftl.item.pri > a_pri then
						l_ftl.item.pri := a_pri
						sched_inst.change_connection (create {CE_POINTER [PD_STATUS]}.make_shared (l_ftl.c_pointer + {PD_FILE_TO_LOAD}.stat_offset), create {CE_POINTER [PD_STATUS]}.make_shared (l_ftl.c_pointer + {PD_FILE_TO_LOAD}.stat_offset), a_pri)
					end
					Result := (create {CE_POINTER [PD_FILE_TO_LOAD]}.make_shared (default_pointer))
					js.return
				end
				if not js.return_called then
					l_ftl.ce_gets (l_ftl.item.next)
				end
			end
			if not js.return_called then
				l_ftl.ce_gets (create {CE_POINTER [PD_FILE_TO_LOAD]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1142, {PD_FILE_TO_LOAD}.sizeof.to_natural_32))))
				l_ftl.item.url := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1143, a_url)
				l_ftl.item.stat.end2 := (file_end_load_address)
				l_ftl.item.stat.data := create {CE_POINTER [ANY]}.make_cast (l_ftl)
				l_ftl.item.req_sent := 0
				l_ftl.item.pri := a_pri
				l_ftl.item.ce := create {CE_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer)
				l_ftl.item.ses := a_ses
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.more_files_offset))))
					l_ftl.item.next := (create {CE_POINTER [PD_FILE_TO_LOAD]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.more_files_offset)))).item.next
					l_ftl.item.prev := create {CE_POINTER [PD_FILE_TO_LOAD]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.more_files_offset)));
					(create {CE_POINTER [PD_FILE_TO_LOAD]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.more_files_offset)))).item.next := l_ftl;
					(l_ftl.item.next).item.prev := l_ftl
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.more_files_offset))))
					js.break
				end
				js.reset
				Result := l_ftl
			end
		end

	request_additional_loading_file (a_ses: CE_POINTER [PD_SESSION]; a_url: CE_POINTER [NATURAL_8]; a_stat___0: CE_POINTER [PD_STATUS]; a_pri: INTEGER_32): CE_POINTER [PD_FILE_TO_LOAD]
		local
			l_ftl: CE_POINTER [PD_FILE_TO_LOAD]
			js: JUMP_STATE
		do
			create l_ftl.make

			l_ftl.ce_gets (request_additional_file (a_ses, a_url, a_pri))
			if (l_ftl).c_pointer = default_pointer then
				sched_inst.change_connection (a_stat___0, create {CE_POINTER [PD_STATUS]}.make_shared (default_pointer), 5)
				Result := (create {CE_POINTER [PD_FILE_TO_LOAD]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_ftl.item.req_sent := 1
				l_ftl.item.ce := a_stat___0.item.ce
				sched_inst.change_connection (a_stat___0, create {CE_POINTER [PD_STATUS]}.make_shared (l_ftl.c_pointer + {PD_FILE_TO_LOAD}.stat_offset), a_pri)
				Result := l_ftl
			end
		end

	process_file_requests (a_ses: CE_POINTER [PD_SESSION])
		local
			l_ftl: CE_POINTER [PD_FILE_TO_LOAD]
			l_more: INTEGER_32
			js: JUMP_STATE
		do
			create l_ftl.make

			if stop_recursion.to_boolean then
				js.return
			end
			if not js.return_called then
				stop_recursion := 1
				from
				until
					js.loop_left
				loop
					js.reset
					l_more := 0
					l_ftl.ce_gets (create {CE_POINTER [PD_FILE_TO_LOAD]}.make_cast (a_ses.item.more_files.next))
					from
					until
						(l_ftl.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.more_files_offset)).c_pointer.to_integer_32).to_natural_32
					loop
						if not (l_ftl.item.req_sent).to_boolean then
							l_ftl.item.req_sent := 1
							sched_inst.load_url (l_ftl.item.url, create {CE_POINTER [PD_STATUS]}.make_shared (l_ftl.c_pointer + {PD_FILE_TO_LOAD}.stat_offset), l_ftl.item.pri, 1).do_nothing
							l_more := 1
						end
						l_ftl.ce_gets (l_ftl.item.next)
					end
					if not l_more.to_boolean then
						js.break
					end
				end
				js.reset
				stop_recursion := 0
			end
		end

	create_session (a_win: CE_POINTER [PD_WINDOW]): CE_POINTER [PD_SESSION]
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_ses: CE_POINTER [PD_SESSION]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_term.make
			create l_ses.make

			l_term.ce_gets (a_win.item.term)
			l_ses.ce_gets (create {CE_POINTER [PD_SESSION]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1189, {PD_SESSION}.sizeof.to_natural_32))))
			memset (create {CE_POINTER [ANY]}.make_cast (l_ses), 0, {PD_SESSION}.sizeof.to_natural_32).do_nothing
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + {PD_SESSION}.history_offset))))
			l_ses.item.history.next := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + {PD_SESSION}.history_offset)))
			l_ses.item.history.prev := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + {PD_SESSION}.history_offset)))
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + {PD_SESSION}.history_offset))))
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + {PD_SESSION}.scrn_frames_offset))))
			l_ses.item.scrn_frames.next := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + {PD_SESSION}.scrn_frames_offset)))
			l_ses.item.scrn_frames.prev := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + {PD_SESSION}.scrn_frames_offset)))
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + {PD_SESSION}.scrn_frames_offset))))
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + {PD_SESSION}.more_files_offset))))
			l_ses.item.more_files.next := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + {PD_SESSION}.more_files_offset)))
			l_ses.item.more_files.prev := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + {PD_SESSION}.more_files_offset)))
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + {PD_SESSION}.more_files_offset))))
			l_ses.item.term := l_term
			l_ses.item.win := a_win
			l_tmp___0 := session_id
			session_id := session_id + 1
			l_ses.item.id := l_tmp___0
			l_ses.item.screen := create {CE_POINTER [PD_F_DATA_C]}.make_shared (default_pointer)
			l_ses.item.wtd := 0
			l_ses.item.display_timer := -1
			l_ses.item.loading_url := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_ses.item.goto_position := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_DOCUMENT_SETUP]}.make_shared (l_ses.c_pointer + {PD_SESSION}.ds_offset))), create {CE_POINTER [ANY]}.make_cast ((default_inst.dds.address)), {PD_DOCUMENT_SETUP}.sizeof.to_natural_32).do_nothing
			from
			until
				js.loop_left
			loop
				js.reset
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((sessions.address)))
				l_ses.item.next := (create {CE_POINTER [PD_SESSION]}.make_cast ((sessions.address))).item.next
				l_ses.item.prev := create {CE_POINTER [PD_SESSION]}.make_cast ((sessions.address));
				(create {CE_POINTER [PD_SESSION]}.make_cast ((sessions.address))).item.next := l_ses;
				(l_ses.item.next).item.prev := l_ses
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((sessions.address)))
				js.break
			end
			js.reset
			if default_inst.first_use.to_boolean then
				default_inst.first_use := 0
				bfu_inst.msg_box ([l_term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 187, 129, links_inst.dummyarray + 188, ce_string ("%N%N"), links_inst.dummyarray + 189, create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 14, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
			end
			Result := l_ses
		end

	copy_session (a_old: CE_POINTER [PD_SESSION]; a_new: CE_POINTER [PD_SESSION])
		do
			if ((a_old.item.history.next).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_old.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
				goto_url (a_new, (create {CE_POINTER [PD_LOCATION]}.make_cast (a_old.item.history.next)).item.vs.url)
			end
		end

	create_session_info (a_cp: INTEGER_32; a_url: CE_POINTER [NATURAL_8]; a_ll: CE_POINTER [INTEGER_32]): CE_POINTER [ANY]
		local
			l_l: INTEGER_32
			l_i: CE_POINTER [INTEGER_32]
		do
			create l_i.make

			l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_url))).to_integer_32
			a_ll.item := ({NATURAL_32} 2 * Integer_32_bytes.to_natural_32 + l_l.to_natural_32).to_integer_32
			l_i.ce_gets (create {CE_POINTER [INTEGER_32]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1238, {NATURAL_32} 2 * Integer_32_bytes.to_natural_32 + l_l.to_natural_32))))
			l_i[0] := a_cp
			l_i[1] := l_l
			memcpy (create {CE_POINTER [ANY]}.make_cast ((l_i + 2)), create {CE_POINTER [ANY]}.make_cast (a_url), l_l.to_natural_32).do_nothing
			Result := (create {CE_POINTER [ANY]}.make_cast (l_i))
		end

	hx (a_a: INTEGER_32): NATURAL_8
		local
			l_tmp: INTEGER_32
		do
			if a_a >= 10 then
				l_tmp := (a_a + 65) - 10
			else
				l_tmp := a_a + 48
			end
			Result := l_tmp.to_natural_8
		end

	unhx (a_a: NATURAL_8): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_a.to_integer_32 >= 48 then
				if a_a.to_integer_32 <= 57 then
					Result := (a_a.to_integer_32 - 48)
					js.return
				end
			end
			if not js.return_called and then (a_a.to_integer_32 >= 65) then
				if a_a.to_integer_32 <= 70 then
					Result := ((a_a.to_integer_32 - 65) + 10)
					js.return
				end
			end
			if not js.return_called and then (a_a.to_integer_32 >= 97) then
				if a_a.to_integer_32 <= 102 then
					Result := ((a_a.to_integer_32 - 97) + 10)
					js.return
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	encode_url (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_url: CE_POINTER [NATURAL_8]
			l_u: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_tmp___0: NATURAL_8
			l_tmp___1: NATURAL_8
		do
			create l_url.make
			create l_u.make

			l_url.ce_gets (a_url)
			l_u.ce_gets ((links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1260)))
			l_l := 0
			from
			until
				not ((l_url.item).to_boolean)
			loop
				if (os_dep_inst.is_safe_in_shell (l_url.item)).to_boolean then
					if (l_url.item).to_integer_32 /= 43 then
						links_inst.add_chr_to_str (l_u.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_url.item)
					else
						links_inst.add_chr_to_str (l_u.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (('+').code).to_natural_8)
						l_tmp___0 := hx (((l_url.item).to_integer_32).bit_shift_right (4))
						links_inst.add_chr_to_str (l_u.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_tmp___0)
						l_tmp___1 := hx (((l_url.item).to_integer_32).bit_and (15))
						links_inst.add_chr_to_str (l_u.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_tmp___1)
					end
				else
					links_inst.add_chr_to_str (l_u.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (('+').code).to_natural_8)
					l_tmp___0 := hx (((l_url.item).to_integer_32).bit_shift_right (4))
					links_inst.add_chr_to_str (l_u.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_tmp___0)
					l_tmp___1 := hx (((l_url.item).to_integer_32).bit_and (15))
					links_inst.add_chr_to_str (l_u.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_tmp___1)
				end
				l_url.ce_gets (l_url + 1)
			end
			Result := l_u
		end

	decode_url (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_url: CE_POINTER [NATURAL_8]
			l_u: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			create l_url.make
			create l_u.make

			l_url.ce_gets (a_url)
			l_u.ce_gets ((links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1271)))
			l_l := 0
			from
			until
				not ((l_url.item).to_boolean)
			loop
				if (l_url.item).to_integer_32 /= 43 then
					links_inst.add_chr_to_str (l_u.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_url.item)
				elseif (unhx (l_url[1])) = -1 then
					links_inst.add_chr_to_str (l_u.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_url.item)
				elseif (unhx (l_url[2])) = -1 then
					links_inst.add_chr_to_str (l_u.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_url.item)
				else
					l_tmp___0 := unhx (l_url[1])
					links_inst.add_chr_to_str (l_u.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (((l_tmp___0).bit_shift_left (4)) + (unhx (l_url[2]))).to_natural_8)
					l_url.ce_gets (l_url + (2))
				end
				l_url.ce_gets (l_url + 1)
			end
			Result := l_u
		end

	read_session_info (a_fd: INTEGER_32; a_ses: CE_POINTER [PD_SESSION]; a_data: CE_POINTER [ANY]; a_len: INTEGER_32): INTEGER_32
		local
			l_h: CE_POINTER [NATURAL_8]
			l_cpfrom: INTEGER_32
			l_sz: INTEGER_32
			l_s: CE_POINTER [PD_SESSION]
			l_u: CE_POINTER [INTEGER_8]
			l_uu: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_h.make
			create l_s.make
			create l_u.make
			create l_uu.make

			if a_len < 2 * (Integer_32_bytes.to_natural_32).to_integer_32 then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				l_cpfrom := (create {CE_POINTER [INTEGER_32]}.make_cast (a_data)).item
				l_sz := create {CE_POINTER [INTEGER_32]}.make_cast (a_data)[1]
				l_s.ce_gets (create {CE_POINTER [PD_SESSION]}.make_cast (sessions.next))
				from
				until
					not (not js.loop_left and then ((l_s.c_pointer.to_integer_32).to_natural_32 /= ((sessions.address).c_pointer.to_integer_32).to_natural_32))
				loop
					js.reset
					if l_s.item.id = l_cpfrom then
						copy_session (l_s, a_ses)
						js.break
					end
					if not js.loop_jumped then
						l_s.ce_gets (l_s.item.next)
					end
				end
				js.reset
				if l_sz.to_boolean then
					if a_len < 2 * (Integer_32_bytes.to_natural_32).to_integer_32 + l_sz then
						Result := 0
						js.return
					end
					if not js.return_called then
						if l_sz.to_natural_32 >= {NATURAL_32} 2147483647 then
							from
							until
								False
							loop
								error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("session.c"), 1295])
								kbd_inst.fatal_tty_exit
								exit (4)
							end
						end
						l_u.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1296, (l_sz + 1).to_natural_32))))
						memcpy (create {CE_POINTER [ANY]}.make_cast (l_u), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_cast (a_data) + 2)), l_sz.to_natural_32).do_nothing
						l_u[l_sz] := (0).to_integer_8
						l_uu.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((decode_url (create {CE_POINTER [NATURAL_8]}.make_cast (l_u)))))
						goto_url (a_ses, create {CE_POINTER [NATURAL_8]}.make_cast (l_uu))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1301, create {CE_POINTER [ANY]}.make_cast (l_u))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1302, create {CE_POINTER [ANY]}.make_cast (l_uu))
					end
				else
					l_h.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((getenv (ce_string ("WWW_HOME")))))
					if ((l_h).c_pointer /= default_pointer) then
						if (l_h.item).to_boolean then
							goto_url (a_ses, l_h)
						end
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	abort_preloading (a_ses: CE_POINTER [PD_SESSION])
		do
			if (a_ses.item.wtd).to_boolean then
				sched_inst.change_connection (create {CE_POINTER [PD_STATUS]}.make_shared (a_ses.c_pointer + {PD_SESSION}.loading_offset), create {CE_POINTER [PD_STATUS]}.make_shared (default_pointer), 5)
				free_wtd (a_ses)
			end
		end

	abort_loading (a_ses: CE_POINTER [PD_SESSION])
		local
			l_l: CE_POINTER [PD_LOCATION]
		do
			create l_l.make

			l_l.ce_gets (create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next))
			if (l_l.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
				if l_l.item.stat.state >= 0 then
					sched_inst.change_connection (create {CE_POINTER [PD_STATUS]}.make_shared (l_l.c_pointer + {PD_LOCATION}.stat_offset), create {CE_POINTER [PD_STATUS]}.make_shared (default_pointer), 5)
				end
				abort_files_load (a_ses)
			end
			abort_preloading (a_ses)
		end

	destroy_session (a_ses: CE_POINTER [PD_SESSION])
		local
			l_fdc: CE_POINTER [PD_F_DATA_C]
			l_d: CE_POINTER [PD_DOWNLOAD]
			l_l: CE_POINTER [PD_LOCATION]
			l_a__: CE_POINTER [PD_XLIST_HEAD]
			l_frm: CE_POINTER [PD_FRAME]
			js: JUMP_STATE
		do
			create l_fdc.make
			create l_d.make
			create l_l.make
			create l_a__.make
			create l_frm.make

			if (a_ses).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				l_d.ce_gets (create {CE_POINTER [PD_DOWNLOAD]}.make_cast (downloads.next))
				from
				until
					(l_d.c_pointer.to_integer_32).to_natural_32 = ((downloads.address).c_pointer.to_integer_32).to_natural_32
				loop
					if ((l_d.item.ses).c_pointer.to_integer_32).to_natural_32 = (a_ses.c_pointer.to_integer_32).to_natural_32 then
						if ((l_d.item.prog).c_pointer /= default_pointer) then
							l_d.ce_gets (l_d.item.prev)
							abort_download (l_d.item.next)
						end
					end
					l_d.ce_gets (l_d.item.next)
				end
				abort_loading (a_ses)
				free_files (a_ses)
				if ((a_ses.item.screen).c_pointer /= default_pointer) then
					view_inst.detach_formatted (a_ses.item.screen)
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1338, create {CE_POINTER [ANY]}.make_cast (a_ses.item.screen))
				end
				l_fdc.ce_gets (create {CE_POINTER [PD_F_DATA_C]}.make_cast (a_ses.item.scrn_frames.next))
				from
				until
					(l_fdc.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.scrn_frames_offset)).c_pointer.to_integer_32).to_natural_32
				loop
					view_inst.detach_formatted (l_fdc)
					l_fdc.ce_gets (l_fdc.item.next)
				end
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.scrn_frames_offset))))
				l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_ses.item.scrn_frames.next))
				from
				until
					(l_a__.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.scrn_frames_offset)).c_pointer.to_integer_32).to_natural_32
				loop
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
					l_a__.ce_gets (l_a__.item.next)
				end
				l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_ses.item.scrn_frames.prev))
				from
				until
					(l_a__.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.scrn_frames_offset)).c_pointer.to_integer_32).to_natural_32
				loop
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
					l_a__.ce_gets (l_a__.item.prev)
				end
				from
				until
					((a_ses.item.scrn_frames.next).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.scrn_frames_offset)).c_pointer.to_integer_32).to_natural_32
				loop
					l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_ses.item.scrn_frames.next))
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__));
					(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a__.item.prev);
					(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a__.item.next)
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1340, create {CE_POINTER [ANY]}.make_cast (l_a__))
				end
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.scrn_frames_offset))))
				from
				until
					js.loop_left
				loop
					js.reset
					l_l.ce_gets (create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next))
					if (l_l.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
						js.break
					end
					if not js.loop_jumped then
						from
						until
							js.loop_left
						loop
							js.reset
							l_frm.ce_gets (create {CE_POINTER [PD_FRAME]}.make_cast (l_l.item.frames.next))
							if (l_frm.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_l.c_pointer + {PD_LOCATION}.frames_offset)).c_pointer.to_integer_32).to_natural_32 then
								js.break
							end
							if not js.loop_jumped then
								view_inst.destroy_vs (create {CE_POINTER [PD_VIEW_STATE]}.make_shared (l_frm.c_pointer + {PD_FRAME}.vs_offset))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1345, create {CE_POINTER [ANY]}.make_cast (l_frm.item.name))
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_frm));
								(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_frm.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_frm.item.prev);
								(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_frm.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_frm.item.next)
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_frm))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1347, create {CE_POINTER [ANY]}.make_cast (l_frm))
							end
						end
						js.reset
						view_inst.destroy_vs (create {CE_POINTER [PD_VIEW_STATE]}.make_shared (l_l.c_pointer + {PD_LOCATION}.vs_offset))
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_l));
						(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_l.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_l.item.prev);
						(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_l.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_l.item.next)
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_l))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1351, create {CE_POINTER [ANY]}.make_cast (l_l))
					end
				end
				js.reset
				if ((a_ses.item.loading_url).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1353, create {CE_POINTER [ANY]}.make_cast (a_ses.item.loading_url))
				end
				if a_ses.item.display_timer /= -1 then
					select_inst.kill_timer (a_ses.item.display_timer)
				end
				if ((a_ses.item.goto_position).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1355, create {CE_POINTER [ANY]}.make_cast (a_ses.item.goto_position))
				end
				if ((a_ses.item.imgmap_href_base).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1356, create {CE_POINTER [ANY]}.make_cast (a_ses.item.imgmap_href_base))
				end
				if ((a_ses.item.imgmap_target_base).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1357, create {CE_POINTER [ANY]}.make_cast (a_ses.item.imgmap_target_base))
				end
				if ((a_ses.item.tq_ce).c_pointer /= default_pointer) then
					(a_ses.item.tq_ce).item.refcount := ((a_ses.item.tq_ce).item.refcount) - 1
				end
				if ((a_ses.item.tq_url).c_pointer /= default_pointer) then
					sched_inst.change_connection (create {CE_POINTER [PD_STATUS]}.make_shared (a_ses.c_pointer + {PD_SESSION}.tq_offset), create {CE_POINTER [PD_STATUS]}.make_shared (default_pointer), 5)
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1361, create {CE_POINTER [ANY]}.make_cast (a_ses.item.tq_url))
				end
				if ((a_ses.item.tq_goto_position).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1363, create {CE_POINTER [ANY]}.make_cast (a_ses.item.tq_goto_position))
				end
				if ((a_ses.item.tq_prog).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1364, create {CE_POINTER [ANY]}.make_cast (a_ses.item.tq_prog))
				end
				if ((a_ses.item.dn_url).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1365, create {CE_POINTER [ANY]}.make_cast (a_ses.item.dn_url))
				end
				if ((a_ses.item.search_word).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1366, create {CE_POINTER [ANY]}.make_cast (a_ses.item.search_word))
				end
				if ((a_ses.item.last_search_word).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1367, create {CE_POINTER [ANY]}.make_cast (a_ses.item.last_search_word))
				end
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_ses));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_ses.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (a_ses.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_ses.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (a_ses.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_ses))
			end
		end

	destroy_all_sessions
		do
		end

	abort_all_downloads
		do
			from
			until
				(((downloads.next).c_pointer.to_integer_32).to_natural_32 = ((downloads.address).c_pointer.to_integer_32).to_natural_32)
			loop
				abort_download (create {CE_POINTER [PD_DOWNLOAD]}.make_cast (downloads.next))
			end
		end

	reload (a_ses: CE_POINTER [PD_SESSION]; a_no_cache: INTEGER_32)
		local
			l_no_cache: INTEGER_32
			l_l: CE_POINTER [PD_LOCATION]
			l_ftl: CE_POINTER [PD_FILE_TO_LOAD]
			js: JUMP_STATE
		do
			create l_l.make
			create l_ftl.make

			l_no_cache := a_no_cache
			abort_loading (a_ses)
			if l_no_cache = -1 then
				a_ses.item.reloadlevel := (a_ses.item.reloadlevel) + 1
				l_no_cache := a_ses.item.reloadlevel
			else
				a_ses.item.reloadlevel := l_no_cache
			end
			l_l.ce_gets (create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next))
			if (l_l.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
				l_l.item.stat.data := create {CE_POINTER [ANY]}.make_cast (a_ses)
				l_l.item.stat.end2 := (doc_end_load_address)
				sched_inst.load_url (l_l.item.vs.url, create {CE_POINTER [PD_STATUS]}.make_shared (l_l.c_pointer + {PD_LOCATION}.stat_offset), 0, l_no_cache).do_nothing
				l_ftl.ce_gets (create {CE_POINTER [PD_FILE_TO_LOAD]}.make_cast (a_ses.item.more_files.next))
				from
				until
					(l_ftl.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.more_files_offset)).c_pointer.to_integer_32).to_natural_32
				loop
					js.reset
					if (l_ftl.item.req_sent).to_boolean then
						if l_ftl.item.stat.state >= 0 then
							js.continue
						end
					end
					if not js.loop_jumped then
						l_ftl.item.stat.data := create {CE_POINTER [ANY]}.make_cast (l_ftl)
						l_ftl.item.stat.end2 := (file_end_load_address)
						sched_inst.load_url (l_ftl.item.url, create {CE_POINTER [PD_STATUS]}.make_shared (l_ftl.c_pointer + {PD_FILE_TO_LOAD}.stat_offset), 1, l_no_cache).do_nothing
					end
					l_ftl.ce_gets (l_ftl.item.next)
				end
			end
		end

	go_back (a_ses: CE_POINTER [PD_SESSION])
		local
			l_url: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_url.make

			a_ses.item.reloadlevel := 1
			if (a_ses.item.wtd).to_boolean then
				abort_loading (a_ses)
				print_screen_status (a_ses)
				reload (a_ses, 1)
				js.return
			end
			if not js.return_called then
				if ((a_ses.item.history.next).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
					js.return
				elseif ((a_ses.item.history.next).c_pointer.to_integer_32).to_natural_32 = ((a_ses.item.history.prev).c_pointer.to_integer_32).to_natural_32 then
					js.return
				end
			end
			if not js.return_called then
				abort_loading (a_ses)
				l_url.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1417, ((create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)).item.next).item.vs.url))
				a_ses.item.redirect_cnt := 0
				ses_goto (a_ses, l_url, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, 0, 4, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), end_load_address, 0)
			end
		end

	goto_url_w (a_ses: CE_POINTER [PD_SESSION]; a_url: CE_POINTER [NATURAL_8]; a_target: CE_POINTER [NATURAL_8]; a_wtd: INTEGER_32)
		local
			l_u: CE_POINTER [NATURAL_8]
			l_pos___0: CE_POINTER [NATURAL_8]
			l_fn: CE_ROUTINE
			l_stat___0: PD_STATUS
			js: JUMP_STATE
		do
			create l_u.make
			create l_pos___0.make
			create l_fn.make
			create l_stat___0.make

			l_fn.ce_gets (url_inst.get_external_protocol_function (a_url))
			if ((l_fn).c_pointer /= default_pointer) then
				l_fn.call ([a_ses, a_url])
				js.return
			end
			if not js.return_called then
				a_ses.item.reloadlevel := 1
				l_u.ce_gets (url_inst.translate_url (a_url, (a_ses.item.term).item.cwd))
				if (l_u).c_pointer = default_pointer then
					l_stat___0.next := create {CE_POINTER [PD_STATUS]}.make_shared (default_pointer)
					l_stat___0.prev := create {CE_POINTER [PD_STATUS]}.make_shared (default_pointer)
					l_stat___0.c := create {CE_POINTER [PD_CONNECTION]}.make_shared (default_pointer)
					l_stat___0.ce := create {CE_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer)
					l_stat___0.state := -1009
					l_stat___0.prev_error := 5
					l_stat___0.pri := 0
					l_stat___0.end2 := create {CE_ROUTINE}.make_shared (default_pointer)
					l_stat___0.data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
					l_stat___0.prg := create {CE_POINTER [PD_REMAINING_INFO]}.make_shared (default_pointer)
					print_error_dialog (a_ses, l_stat___0.address, links_inst.dummyarray + 186)
					js.return
				end
			end
			if not js.return_called then
				l_pos___0.ce_gets (url_inst.extract_position (l_u))
				if a_ses.item.wtd = a_wtd then
					if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_ses.item.loading_url), create {CE_POINTER [INTEGER_8]}.make_cast (l_u))).to_boolean then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1441, create {CE_POINTER [ANY]}.make_cast (l_u))
						if ((a_ses.item.goto_position).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1442, create {CE_POINTER [ANY]}.make_cast (a_ses.item.goto_position))
						end
						a_ses.item.goto_position := l_pos___0
						js.return
					end
				end
			end
			if not js.return_called then
				abort_loading (a_ses)
				a_ses.item.redirect_cnt := 0
				ses_goto (a_ses, l_u, a_target, 0, 1, a_wtd, l_pos___0, end_load_address, 0)
			end
		end

	goto_url_f (a_ses: CE_POINTER [PD_SESSION]; a_url: CE_POINTER [NATURAL_8]; a_target: CE_POINTER [NATURAL_8])
		do
			goto_url_w (a_ses, a_url, a_target, 1)
		end

	goto_url (a_ses: CE_POINTER [PD_SESSION]; a_url: CE_POINTER [NATURAL_8])
		do
			goto_url_w (a_ses, a_url, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 1)
		end

	goto_url_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent goto_url)
		end

	goto_imgmap (a_ses: CE_POINTER [PD_SESSION]; a_url: CE_POINTER [NATURAL_8]; a_href: CE_POINTER [NATURAL_8]; a_target: CE_POINTER [NATURAL_8])
		do
			if ((a_ses.item.imgmap_href_base).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1465, create {CE_POINTER [ANY]}.make_cast (a_ses.item.imgmap_href_base))
			end
			a_ses.item.imgmap_href_base := a_href
			if ((a_ses.item.imgmap_target_base).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1467, create {CE_POINTER [ANY]}.make_cast (a_ses.item.imgmap_target_base))
			end
			a_ses.item.imgmap_target_base := a_target
			goto_url_w (a_ses, a_url, a_target, 2)
		end

	ses_find_frame (a_ses: CE_POINTER [PD_SESSION]; a_name: CE_POINTER [NATURAL_8]): CE_POINTER [PD_FRAME]
		local
			l_l: CE_POINTER [PD_LOCATION]
			l_frm: CE_POINTER [PD_FRAME]
			js: JUMP_STATE
		do
			create l_l.make
			create l_frm.make

			l_l.ce_gets (create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next))
			if ((a_ses.item.history.next).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
				from
				until
					False
				loop
					links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")))
					links_inst.errline := 1477
					error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ses_request_frame: history empty"))])
				end
				Result := (create {CE_POINTER [PD_FRAME]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_frm.ce_gets (create {CE_POINTER [PD_FRAME]}.make_cast (l_l.item.frames.prev))
				from
				until
					not (not js.loop_left and then ((l_frm.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_l.c_pointer + {PD_LOCATION}.frames_offset)).c_pointer.to_integer_32).to_natural_32))
				loop
					if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_frm.item.name), create {CE_POINTER [INTEGER_8]}.make_cast (a_name))).to_boolean then
						Result := l_frm
						js.return
					end
					if not js.return_called then
						l_frm.ce_gets (l_frm.item.prev)
					end
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [PD_FRAME]}.make_shared (default_pointer))
			end
		end

	ses_change_frame_url (a_ses: CE_POINTER [PD_SESSION]; a_name: CE_POINTER [NATURAL_8]; a_url: CE_POINTER [NATURAL_8]): CE_POINTER [PD_FRAME]
		local
			l_l: CE_POINTER [PD_LOCATION]
			l_frm: CE_POINTER [PD_FRAME]
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_nf: CE_POINTER [PD_FRAME]
			l_tmp___1: CE_POINTER [PD_FRAME]
			l_tmp___2: NATURAL_32
			js: JUMP_STATE
		do
			create l_l.make
			create l_frm.make
			create l_fd.make
			create l_nf.make
			create l_tmp___1.make

			l_l.ce_gets (create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next))
			if ((a_ses.item.history.next).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
				from
				until
					False
				loop
					links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")))
					links_inst.errline := 1490
					error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ses_change_frame_url: history empty"))])
				end
				Result := (create {CE_POINTER [PD_FRAME]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_frm.ce_gets (create {CE_POINTER [PD_FRAME]}.make_cast (l_l.item.frames.prev))
				from
				until
					not (not js.loop_left and then ((l_frm.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_l.c_pointer + {PD_LOCATION}.frames_offset)).c_pointer.to_integer_32).to_natural_32))
				loop
					if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_frm.item.name), create {CE_POINTER [INTEGER_8]}.make_cast (a_name))).to_boolean then
						l_tmp___2 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_url))
						if l_tmp___2 > (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_frm.item.vs.url)))) then
							l_nf.ce_gets (l_frm)
							l_nf.ce_gets (create {CE_POINTER [PD_FRAME]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("session.c")), 1497, create {CE_POINTER [ANY]}.make_cast (l_frm), ({PD_FRAME}.sizeof.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_url)))) + {NATURAL_32} 1))))
							l_tmp___1.ce_gets (l_nf);
							(l_nf.item.next).item.prev := l_tmp___1;
							(l_nf.item.prev).item.next := l_tmp___1
							l_fd.ce_gets (create {CE_POINTER [PD_F_DATA_C]}.make_cast (a_ses.item.scrn_frames.next))
							from
							until
								(l_fd.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.scrn_frames_offset)).c_pointer.to_integer_32).to_natural_32
							loop
								if ((l_fd.item.vs).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_VIEW_STATE]}.make_shared (l_frm.c_pointer + {PD_FRAME}.vs_offset)).c_pointer.to_integer_32).to_natural_32 then
									l_fd.item.vs := create {CE_POINTER [PD_VIEW_STATE]}.make_shared (l_nf.c_pointer + {PD_FRAME}.vs_offset)
								end
								l_fd.ce_gets (l_fd.item.next)
							end
							l_frm.ce_gets (l_nf)
						end
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_frm.item.vs.url)), create {CE_POINTER [INTEGER_8]}.make_cast (a_url)).do_nothing
						Result := l_frm
						js.return
					end
					if not js.return_called then
						l_frm.ce_gets (l_frm.item.prev)
					end
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [PD_FRAME]}.make_shared (default_pointer))
			end
		end

	win_func (a_win: CE_POINTER [PD_WINDOW]; a_ev: CE_POINTER [PD_EVENT]; a_fw: INTEGER_32)
		local
			l_ses: CE_POINTER [PD_SESSION]
			l_tmp: CE_POINTER [ANY]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ses.make
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ses.ce_gets (create {CE_POINTER [PD_SESSION]}.make_cast (a_win.item.data))
					inspect (a_ev.item.ev).to_integer_32 -- switch 1 head
					when 5 then l_pos := -1 + 1
					when 0 then l_pos := -1 + 2
					when 4 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 4
					when 1 then l_pos := -1 + 5
					when 2 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 1 then -- switch 1, case 5
					if ((l_ses).c_pointer /= default_pointer) then
						destroy_session (l_ses)
					end
					l_pos := -1 + 7 -- switch 1; break
				when 2 then -- switch 1, case 0
					l_tmp.ce_gets (create {CE_POINTER [ANY]}.make_cast ((create_session (a_win))))
					a_win.item.data := l_tmp
					l_ses.ce_gets (create {CE_POINTER [PD_SESSION]}.make_cast (l_tmp))
					if ((l_ses).c_pointer /= default_pointer) then
						if (read_session_info ((a_win.item.term).item.fdin, l_ses, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer + a_ev.item.b) + (Integer_32_bytes.to_natural_32).to_integer_32)), (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer + a_ev.item.b)).item)).to_boolean then
							select_inst.register_bottom_half ((terminal_inst.destroy_terminal_address), create {CE_POINTER [ANY]}.make_cast (a_win.item.term)).do_nothing
							js.return
						end
					else
						select_inst.register_bottom_half ((terminal_inst.destroy_terminal_address), create {CE_POINTER [ANY]}.make_cast (a_win.item.term)).do_nothing
						js.return
					end
				when 3 then -- switch 1, case 4
					if not js.return_called then
						html_r_inst.html_interpret (l_ses)
						view_inst.draw_formatted (l_ses)
						load_frames (l_ses, l_ses.item.screen)
						process_file_requests (l_ses)
						print_screen_status (l_ses)
					end
					l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 3
					view_inst.draw_formatted (l_ses)
					print_screen_status (l_ses)
					l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 1 | switch 1, case 2
					view_inst.send_event (l_ses, a_ev)
					l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, default:
					error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: unknown event"))])
				when 7 then -- switch 1, done:
					if not js.return_called then
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	win_func_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent win_func)
		end

	get_current_url (a_ses: CE_POINTER [PD_SESSION]; a_str: CE_POINTER [NATURAL_8]; a_str_size: NATURAL_32): CE_POINTER [NATURAL_8]
		local
			l_here: CE_POINTER [NATURAL_8]
			l_end_of_url: CE_POINTER [NATURAL_8]
			l_url_len: NATURAL_32
			js: JUMP_STATE
		do
			create l_here.make
			create l_end_of_url.make

			l_url_len := (0).to_natural_32
			if ((a_ses.item.history.next).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_here.ce_gets ((create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)).item.vs.url)
				l_end_of_url.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_here), 1))))
				if ((l_end_of_url).c_pointer /= default_pointer) then
					l_url_len := (l_end_of_url.distance (l_here)).to_natural_32
				else
					l_url_len := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_here))
				end
				if l_url_len >= a_str_size then
					l_url_len := a_str_size - {NATURAL_32} 1
				end
				strncpy (create {CE_POINTER [INTEGER_8]}.make_cast (a_str), create {CE_POINTER [INTEGER_8]}.make_cast (l_here), l_url_len).do_nothing
				a_str[l_url_len.to_integer_32] := (('%/0/').code).to_natural_8
				Result := a_str
			end
		end

	get_current_title (a_ses: CE_POINTER [PD_SESSION]; a_str: CE_POINTER [NATURAL_8]; a_str_size: NATURAL_32): CE_POINTER [NATURAL_8]
		local
			l_fd: CE_POINTER [PD_F_DATA_C]
			js: JUMP_STATE
		do
			create l_fd.make

			l_fd.ce_gets ((view_inst.current_frame (a_ses)))
			if (l_fd).c_pointer = default_pointer then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				Result := (links_inst.safe_strncpy (a_str, (l_fd.item.f_data).item.title, a_str_size))
			end
		end

	get_current_link_url (a_ses: CE_POINTER [PD_SESSION]; a_str: CE_POINTER [NATURAL_8]; a_str_size: NATURAL_32): CE_POINTER [NATURAL_8]
		local
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_l: CE_POINTER [PD_LINK]
			l_tmp___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_fd.make
			create l_l.make
			create l_tmp___0.make

			l_fd.ce_gets ((view_inst.current_frame (a_ses)))
			if (l_fd).c_pointer = default_pointer then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called and then ((l_fd.item.vs).item.current_link = -1) then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_l.ce_gets ((l_fd.item.f_data).item.links + (l_fd.item.vs).item.current_link)
				if l_l.item.type /= 0 then
					Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				if ((l_l.item.where).c_pointer /= default_pointer) then
					l_tmp___0.ce_gets (l_l.item.where)
				else
					l_tmp___0.ce_gets (l_l.item.where_img)
				end
				Result := (links_inst.safe_strncpy (a_str, l_tmp___0, a_str_size))
			end
		end

end
