class
	P_VIEW

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create fr_trans.make (<<2, 4>>)
			create head.make (<<9>>)
			create hash.make (<<4096>>)
		end

feature {ANY} -- attributes

	fr_trans: CE_ARRAY [CE_ARRAY [NATURAL_8]]

	head: CE_ARRAY [INTEGER_8]

	hash: CE_ARRAY [INTEGER_8]

	init___0: INTEGER_8 assign set_init___0

	set_init___0 (a_init___0: INTEGER_8)
		do
			init___0 := a_init___0
		end

feature {ANY} -- routines

	init_vs (a_vs: CE_POINTER [PD_VIEW_STATE]; a_url: CE_POINTER [NATURAL_8])
		do
			memset (create {CE_POINTER [ANY]}.make_cast (a_vs), 0, {PD_VIEW_STATE}.sizeof.to_natural_32).do_nothing
			a_vs.item.current_link := -1
			a_vs.item.orig_link := -1
			a_vs.item.plain := -1
			a_vs.item.form_info := create {CE_POINTER [PD_FORM_STATE]}.make_shared (default_pointer + -1)
			a_vs.item.form_info_len := 0
			strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((a_vs.item.url)), create {CE_POINTER [INTEGER_8]}.make_cast (a_url)).do_nothing
		end

	destroy_vs (a_vs: CE_POINTER [PD_VIEW_STATE])
		local
			l_i: INTEGER_32
		do
			if ((a_vs.item.goto_position).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 17, create {CE_POINTER [ANY]}.make_cast (a_vs.item.goto_position))
			end
			if ((a_vs.item.goto_position_end).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 18, create {CE_POINTER [ANY]}.make_cast (a_vs.item.goto_position_end))
			end
			l_i := 0
			from
			until
				not (l_i < a_vs.item.form_info_len)
			loop
				if (((a_vs.item.form_info + l_i).item.value).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 19, create {CE_POINTER [ANY]}.make_cast ((a_vs.item.form_info + l_i).item.value))
				end
				l_i := l_i + 1
			end
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 20, create {CE_POINTER [ANY]}.make_cast (a_vs.item.form_info))
		end

	init_formatted (a_scr: CE_POINTER [PD_F_DATA])
		do
			memset (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [CE_POINTER [PD_F_DATA]]}.make_cast (a_scr) + 2)), 0, {PD_F_DATA}.sizeof.to_natural_32 - {NATURAL_32} 2 * Pointer_bytes.to_natural_32).do_nothing
			a_scr.item.data := create {CE_POINTER [PD_LINE]}.make_shared (default_pointer + -1)
			a_scr.item.nlinks := 0
			a_scr.item.links := create {CE_POINTER [PD_LINK]}.make_shared (default_pointer + -1)
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.forms_offset))))
			a_scr.item.forms.next := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.forms_offset)))
			a_scr.item.forms.prev := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.forms_offset)))
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.forms_offset))))
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.tags_offset))))
			a_scr.item.tags.next := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.tags_offset)))
			a_scr.item.tags.prev := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.tags_offset)))
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.tags_offset))))
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.nodes_offset))))
			a_scr.item.nodes.next := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.nodes_offset)))
			a_scr.item.nodes.prev := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.nodes_offset)))
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.nodes_offset))))
		end

	destroy_fc (a_fc: CE_POINTER [PD_FORM_CONTROL])
		local
			l_i: INTEGER_32
		do
			if ((a_fc.item.action).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 37, create {CE_POINTER [ANY]}.make_cast (a_fc.item.action))
			end
			if ((a_fc.item.target).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 38, create {CE_POINTER [ANY]}.make_cast (a_fc.item.target))
			end
			if ((a_fc.item.name).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 39, create {CE_POINTER [ANY]}.make_cast (a_fc.item.name))
			end
			if ((a_fc.item.alt).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 40, create {CE_POINTER [ANY]}.make_cast (a_fc.item.alt))
			end
			if ((a_fc.item.default_value).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 41, create {CE_POINTER [ANY]}.make_cast (a_fc.item.default_value))
			end
			l_i := 0
			from
			until
				not (l_i < a_fc.item.nvalues)
			loop
				if ((a_fc.item.values[l_i]).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 43, create {CE_POINTER [ANY]}.make_cast (a_fc.item.values[l_i]))
				end
				if ((a_fc.item.labels[l_i]).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 44, create {CE_POINTER [ANY]}.make_cast (a_fc.item.labels[l_i]))
				end
				l_i := l_i + 1
			end
			if ((a_fc.item.values).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 46, create {CE_POINTER [ANY]}.make_cast (a_fc.item.values))
			end
			if ((a_fc.item.labels).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 47, create {CE_POINTER [ANY]}.make_cast (a_fc.item.labels))
			end
			if ((a_fc.item.menu).c_pointer /= default_pointer) then
				html_inst.free_menu (a_fc.item.menu)
			end
		end

	free_frameset_desc (a_fd: CE_POINTER [PD_FRAMESET_DESC])
		local
			l_i: INTEGER_32
		do
			l_i := 0
			from
			until
				not (l_i < a_fd.item.n)
			loop
				if ((a_fd.item.f[l_i].subframe).c_pointer /= default_pointer) then
					free_frameset_desc (a_fd.item.f[l_i].subframe)
				end
				if ((a_fd.item.f[l_i].name).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 56, create {CE_POINTER [ANY]}.make_cast (a_fd.item.f[l_i].name))
				end
				if ((a_fd.item.f[l_i].url).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 57, create {CE_POINTER [ANY]}.make_cast (a_fd.item.f[l_i].url))
				end
				l_i := l_i + 1
			end
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 59, create {CE_POINTER [ANY]}.make_cast (a_fd))
		end

	clear_formatted (a_scr: CE_POINTER [PD_F_DATA])
		local
			l_n: INTEGER_32
			l_y: INTEGER_32
			l_ce: CE_POINTER [PD_CACHE_ENTRY]
			l_fc: CE_POINTER [PD_FORM_CONTROL]
			l_l: CE_POINTER [PD_LINK]
			l_a__: CE_POINTER [PD_XLIST_HEAD]
			l_a_____0: CE_POINTER [PD_XLIST_HEAD]
			l_a_____1: CE_POINTER [PD_XLIST_HEAD]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ce.make
			create l_fc.make
			create l_l.make
			create l_a__.make
			create l_a_____0.make
			create l_a_____1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_scr).c_pointer = default_pointer then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if not ((cache_inst.find_in_cache (a_scr.item.url, l_ce.address)).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if ((l_ce).c_pointer /= default_pointer) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							False
						loop
							links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")))
							links_inst.errline := 69
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("no cache entry for document"))])
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_ce.item.refcount := (l_ce.item.refcount) - 1
				when 8 then -- if done
						if ((a_scr.item.url).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 71, create {CE_POINTER [ANY]}.make_cast (a_scr.item.url))
						end
						if ((a_scr.item.title).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 72, create {CE_POINTER [ANY]}.make_cast (a_scr.item.title))
						end
						if ((a_scr.item.frame_desc).c_pointer /= default_pointer) then
							free_frameset_desc (a_scr.item.frame_desc)
						end
						l_n := 0
						from
						until
							not (l_n < a_scr.item.nlinks)
						loop
							l_l.ce_gets (a_scr.item.links + l_n)
							if ((l_l.item.where).c_pointer /= default_pointer) then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 78, create {CE_POINTER [ANY]}.make_cast (l_l.item.where))
							end
							if ((l_l.item.target).c_pointer /= default_pointer) then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 79, create {CE_POINTER [ANY]}.make_cast (l_l.item.target))
							end
							if ((l_l.item.where_img).c_pointer /= default_pointer) then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 80, create {CE_POINTER [ANY]}.make_cast (l_l.item.where_img))
							end
							if ((l_l.item.pos).c_pointer /= default_pointer) then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 81, create {CE_POINTER [ANY]}.make_cast (l_l.item.pos))
							end
							l_n := l_n + 1
						end
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 83, create {CE_POINTER [ANY]}.make_cast (a_scr.item.links))
						l_y := 0
						from
						until
							not (l_y < a_scr.item.y)
						loop
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 84, create {CE_POINTER [ANY]}.make_cast ((a_scr.item.data + l_y).item.d))
							l_y := l_y + 1
						end
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 85, create {CE_POINTER [ANY]}.make_cast (a_scr.item.data))
						if ((a_scr.item.lines1).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 86, create {CE_POINTER [ANY]}.make_cast (a_scr.item.lines1))
						end
						if ((a_scr.item.lines2).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 87, create {CE_POINTER [ANY]}.make_cast (a_scr.item.lines2))
						end
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 88, create {CE_POINTER [ANY]}.make_cast (a_scr.item.opt.framename))
						l_fc.ce_gets (create {CE_POINTER [PD_FORM_CONTROL]}.make_cast (a_scr.item.forms.next))
						from
						until
							(l_fc.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.forms_offset)).c_pointer.to_integer_32).to_natural_32
						loop
							destroy_fc (l_fc)
							l_fc.ce_gets (l_fc.item.next)
						end
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.forms_offset))))
						l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_scr.item.forms.next))
						from
						until
							(l_a__.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.forms_offset)).c_pointer.to_integer_32).to_natural_32
						loop
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
							l_a__.ce_gets (l_a__.item.next)
						end
						l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_scr.item.forms.prev))
						from
						until
							(l_a__.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.forms_offset)).c_pointer.to_integer_32).to_natural_32
						loop
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
							l_a__.ce_gets (l_a__.item.prev)
						end
						from
						until
							((a_scr.item.forms.next).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.forms_offset)).c_pointer.to_integer_32).to_natural_32
						loop
							l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_scr.item.forms.next))
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__));
							(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a__.item.prev);
							(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a__.item.next)
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 92, create {CE_POINTER [ANY]}.make_cast (l_a__))
						end
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.forms_offset))))
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.tags_offset))))
						l_a_____0.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_scr.item.tags.next))
						from
						until
							(l_a_____0.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.tags_offset)).c_pointer.to_integer_32).to_natural_32
						loop
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____0))
							l_a_____0.ce_gets (l_a_____0.item.next)
						end
						l_a_____0.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_scr.item.tags.prev))
						from
						until
							(l_a_____0.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.tags_offset)).c_pointer.to_integer_32).to_natural_32
						loop
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____0))
							l_a_____0.ce_gets (l_a_____0.item.prev)
						end
						from
						until
							((a_scr.item.tags.next).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.tags_offset)).c_pointer.to_integer_32).to_natural_32
						loop
							l_a_____0.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_scr.item.tags.next))
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____0));
							(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____0.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a_____0.item.prev);
							(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____0.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a_____0.item.next)
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____0))
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 93, create {CE_POINTER [ANY]}.make_cast (l_a_____0))
						end
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.tags_offset))))
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.nodes_offset))))
						l_a_____1.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_scr.item.nodes.next))
						from
						until
							(l_a_____1.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.nodes_offset)).c_pointer.to_integer_32).to_natural_32
						loop
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____1))
							l_a_____1.ce_gets (l_a_____1.item.next)
						end
						l_a_____1.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_scr.item.nodes.prev))
						from
						until
							(l_a_____1.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.nodes_offset)).c_pointer.to_integer_32).to_natural_32
						loop
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____1))
							l_a_____1.ce_gets (l_a_____1.item.prev)
						end
						from
						until
							((a_scr.item.nodes.next).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.nodes_offset)).c_pointer.to_integer_32).to_natural_32
						loop
							l_a_____1.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_scr.item.nodes.next))
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____1));
							(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____1.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a_____1.item.prev);
							(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____1.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a_____1.item.next)
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____1))
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 94, create {CE_POINTER [ANY]}.make_cast (l_a_____1))
						end
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_scr.c_pointer + {PD_F_DATA}.nodes_offset))))
						if ((a_scr.item.search).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 95, create {CE_POINTER [ANY]}.make_cast (a_scr.item.search))
						end
						if ((a_scr.item.slines1).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 96, create {CE_POINTER [ANY]}.make_cast (a_scr.item.slines1))
						end
						if ((a_scr.item.slines2).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 97, create {CE_POINTER [ANY]}.make_cast (a_scr.item.slines2))
						end
						init_formatted (a_scr)
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	destroy_formatted (a_scr: CE_POINTER [PD_F_DATA])
		local
			js: JUMP_STATE
		do
			if (a_scr.item.refcount).to_boolean then
				from
				until
					False
				loop
					links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")))
					links_inst.errline := 104
					error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("trying to free locked formatted data"))])
				end
				js.return
			end
			if not js.return_called then
				clear_formatted (a_scr)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_scr));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_scr.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (a_scr.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (a_scr.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (a_scr.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_scr))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 109, create {CE_POINTER [ANY]}.make_cast (a_scr))
			end
		end

	detach_formatted (a_scr: CE_POINTER [PD_F_DATA_C])
		do
			if ((a_scr.item.f_data).c_pointer /= default_pointer) then
				html_r_inst.format_cache_reactivate (a_scr.item.f_data);
				(a_scr.item.f_data).item.refcount := ((a_scr.item.f_data).item.refcount) - 1
				if not ((a_scr.item.f_data).item.refcount).to_boolean then
					html_r_inst.format_cache_entries := html_r_inst.format_cache_entries + 1
				end
				if (a_scr.item.f_data).item.refcount < 0 then
					from
					until
						False
					loop
						links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")))
						links_inst.errline := 121
						error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("format_cache refcount underflow"))])
					end
					(a_scr.item.f_data).item.refcount := 0
				end
				a_scr.item.f_data := create {CE_POINTER [PD_F_DATA]}.make_shared (default_pointer)
			end
			a_scr.item.vs := create {CE_POINTER [PD_VIEW_STATE]}.make_shared (default_pointer)
			if ((a_scr.item.link_bg).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 127, create {CE_POINTER [ANY]}.make_cast (a_scr.item.link_bg))
				a_scr.item.link_bg := create {CE_POINTER [PD_LINK_BG]}.make_shared (default_pointer)
				a_scr.item.link_bg_n := 0
			end
			if ((a_scr.item.name).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 128, create {CE_POINTER [ANY]}.make_cast (a_scr.item.name))
				a_scr.item.name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
		end

	copy_vs (a_dst: CE_POINTER [PD_VIEW_STATE]; a_src: CE_POINTER [PD_VIEW_STATE])
		local
			l_i: INTEGER_32
		do
			memcpy (create {CE_POINTER [ANY]}.make_cast (a_dst), create {CE_POINTER [ANY]}.make_cast (a_src), {PD_VIEW_STATE}.sizeof.to_natural_32).do_nothing
			strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((a_dst.item.url)), create {CE_POINTER [INTEGER_8]}.make_cast ((a_src.item.url))).do_nothing
			a_dst.item.goto_position := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 136, a_src.item.goto_position)
			a_dst.item.goto_position_end := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 137, a_src.item.goto_position_end)
			if (a_src.item.form_info_len).to_natural_32 > {NATURAL_32} 2147483647 // {PD_FORM_STATE}.sizeof.to_natural_32 then
				from
				until
					False
				loop
					error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("view.c"), 138])
					kbd_inst.fatal_tty_exit
					exit (4)
				end
			end
			a_dst.item.form_info := create {CE_POINTER [PD_FORM_STATE]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 139, (a_src.item.form_info_len).to_natural_32 * {PD_FORM_STATE}.sizeof.to_natural_32)))
			memcpy (create {CE_POINTER [ANY]}.make_cast (a_dst.item.form_info), create {CE_POINTER [ANY]}.make_cast (a_src.item.form_info), (a_src.item.form_info_len).to_natural_32 * {PD_FORM_STATE}.sizeof.to_natural_32).do_nothing
			l_i := 0
			from
			until
				not (l_i < a_src.item.form_info_len)
			loop
				if (((a_src.item.form_info + l_i).item.value).c_pointer /= default_pointer) then
					(a_dst.item.form_info + l_i).item.value := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 141, (a_src.item.form_info + l_i).item.value)
				end
				l_i := l_i + 1
			end
		end

	copy_location (a_dst: CE_POINTER [PD_LOCATION]; a_src: CE_POINTER [PD_LOCATION])
		local
			l_f: CE_POINTER [PD_FRAME]
			l_nf: CE_POINTER [PD_FRAME]
			js: JUMP_STATE
		do
			create l_f.make
			create l_nf.make

			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_dst.c_pointer + {PD_LOCATION}.frames_offset))))
			a_dst.item.frames.next := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_dst.c_pointer + {PD_LOCATION}.frames_offset)))
			a_dst.item.frames.prev := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_dst.c_pointer + {PD_LOCATION}.frames_offset)))
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_dst.c_pointer + {PD_LOCATION}.frames_offset))))
			l_f.ce_gets (create {CE_POINTER [PD_FRAME]}.make_cast (a_src.item.frames.prev))
			from
			until
				not (not js.loop_left and then ((l_f.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_src.c_pointer + {PD_LOCATION}.frames_offset)).c_pointer.to_integer_32).to_natural_32))
			loop
				l_nf.ce_gets (create {CE_POINTER [PD_FRAME]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 149, ({PD_FRAME}.sizeof.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_f.item.vs.url))))) + {NATURAL_32} 1))))
				l_nf.item.name := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 150, l_f.item.name)
				l_nf.item.redirect_cnt := 0
				copy_vs (create {CE_POINTER [PD_VIEW_STATE]}.make_shared (l_nf.c_pointer + {PD_FRAME}.vs_offset), create {CE_POINTER [PD_VIEW_STATE]}.make_shared (l_f.c_pointer + {PD_FRAME}.vs_offset))
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_dst.c_pointer + {PD_LOCATION}.frames_offset))))
					l_nf.item.next := (create {CE_POINTER [PD_FRAME]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_dst.c_pointer + {PD_LOCATION}.frames_offset)))).item.next
					l_nf.item.prev := create {CE_POINTER [PD_FRAME]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_dst.c_pointer + {PD_LOCATION}.frames_offset)));
					(create {CE_POINTER [PD_FRAME]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_dst.c_pointer + {PD_LOCATION}.frames_offset)))).item.next := l_nf;
					(l_nf.item.next).item.prev := l_nf
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_dst.c_pointer + {PD_LOCATION}.frames_offset))))
					js.break
				end
				js.reset
				l_f.ce_gets (l_f.item.prev)
			end
			copy_vs (create {CE_POINTER [PD_VIEW_STATE]}.make_shared (a_dst.c_pointer + {PD_LOCATION}.vs_offset), create {CE_POINTER [PD_VIEW_STATE]}.make_shared (a_src.c_pointer + {PD_LOCATION}.vs_offset))
		end

	check_vs (a_f: CE_POINTER [PD_F_DATA_C])
		local
			l_vs: CE_POINTER [PD_VIEW_STATE]
			l_ovx: INTEGER_32
			l_ovy: INTEGER_32
			l_ol: INTEGER_32
		do
			create l_vs.make

			l_vs.ce_gets (a_f.item.vs)
			l_ovx := l_vs.item.orig_view_posx
			l_ovy := l_vs.item.orig_view_pos
			l_ol := l_vs.item.orig_link
			if l_vs.item.current_link >= (a_f.item.f_data).item.nlinks then
				l_vs.item.current_link := (a_f.item.f_data).item.nlinks - 1
			end
			if l_vs.item.current_link /= -1 then
				if not (c2_in_view (a_f)).to_boolean then
					set_pos_x (a_f, (a_f.item.f_data).item.links + (a_f.item.vs).item.current_link)
					set_pos_y (a_f, (a_f.item.f_data).item.links + (a_f.item.vs).item.current_link)
				end
			end
			if l_vs.item.current_link = -1 then
				find_link (a_f, 1, 0)
			end
			l_vs.item.orig_view_posx := l_ovx
			l_vs.item.orig_view_pos := l_ovy
			l_vs.item.orig_link := l_ol
		end

	set_link (a_f: CE_POINTER [PD_F_DATA_C])
		local
			js: JUMP_STATE
		do
			if (c2_in_view (a_f)).to_boolean then
				js.return
			end
			if not js.return_called then
				find_link (a_f, 1, 0)
			end
		end

	find_tag (a_f: CE_POINTER [PD_F_DATA]; a_name: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tag: CE_POINTER [PD_TAG]
			l_tt: CE_POINTER [NATURAL_8]
			l_ll: INTEGER_32
			js: JUMP_STATE
		do
			create l_tag.make
			create l_tt.make

			l_tt.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 188))
			l_ll := 0
			url_inst.add_conv_str (l_tt.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), a_name, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_name))).to_integer_32, -2)
			l_tag.ce_gets (create {CE_POINTER [PD_TAG]}.make_cast (a_f.item.tags.next))
			from
			until
				not (not js.loop_left and then ((l_tag.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_f.c_pointer + {PD_F_DATA}.tags_offset)).c_pointer.to_integer_32).to_natural_32))
			loop
				if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_tag.item.name)), create {CE_POINTER [INTEGER_8]}.make_cast (l_tt))).to_boolean then
					if (l_tag.item.name[0]).to_integer_32 = 35 then
						if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_tag.item.name + 1)), create {CE_POINTER [INTEGER_8]}.make_cast (l_tt))).to_boolean then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 192, create {CE_POINTER [ANY]}.make_cast (l_tt))
							Result := (l_tag.item.y)
							js.return
						end
					end
				else
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 192, create {CE_POINTER [ANY]}.make_cast (l_tt))
					Result := (l_tag.item.y)
					js.return
				end
				if not js.return_called then
					l_tag.ce_gets (l_tag.item.next)
				end
			end
			if not js.return_called then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 195, create {CE_POINTER [ANY]}.make_cast (l_tt))
				Result := (-1)
			end
		end

	comp_links (a_l1: CE_POINTER [PD_LINK]; a_l2: CE_POINTER [PD_LINK]): INTEGER_32
		do
			Result := (a_l1.item.num - a_l2.item.num)
		end

	comp_links_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent comp_links)
		end

	sort_links (a_f: CE_POINTER [PD_F_DATA])
		local
			l_i: INTEGER_32
			l_p: INTEGER_32
			l_q: INTEGER_32
			l_j: INTEGER_32
			l_link___0: CE_POINTER [PD_LINK]
			js: JUMP_STATE
		do
			create l_link___0.make

			if (a_f.item.nlinks).to_boolean then
				qsort (create {CE_POINTER [ANY]}.make_cast (a_f.item.links), (a_f.item.nlinks).to_natural_32, {PD_LINK}.sizeof.to_natural_32, (comp_links_address))
			end
			if (a_f.item.y).to_natural_32 > {NATURAL_32} 2147483647 // Pointer_bytes.to_natural_32 then
				from
				until
					False
				loop
					error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("view.c"), 208])
					kbd_inst.fatal_tty_exit
					exit (4)
				end
			end
			a_f.item.lines1 := create {CE_POINTER [CE_POINTER [PD_LINK]]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 209, (a_f.item.y).to_natural_32 * Pointer_bytes.to_natural_32)))
			a_f.item.lines2 := create {CE_POINTER [CE_POINTER [PD_LINK]]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 210, (a_f.item.y).to_natural_32 * Pointer_bytes.to_natural_32)))
			memset (create {CE_POINTER [ANY]}.make_cast (a_f.item.lines1), 0, (a_f.item.y).to_natural_32 * Pointer_bytes.to_natural_32).do_nothing
			memset (create {CE_POINTER [ANY]}.make_cast (a_f.item.lines2), 0, (a_f.item.y).to_natural_32 * Pointer_bytes.to_natural_32).do_nothing
			l_i := 0
			from
			until
				not (not js.loop_left and then (l_i < a_f.item.nlinks))
			loop
				js.reset
				l_link___0.ce_gets (a_f.item.links + l_i)
				if not (l_link___0.item.n).to_boolean then
					if (links_inst.d_opt.item.num_links).to_boolean then
						js.continue
					end
					if not js.loop_jumped then
						if ((l_link___0.item.where).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 218, create {CE_POINTER [ANY]}.make_cast (l_link___0.item.where))
						end
						if ((l_link___0.item.target).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 219, create {CE_POINTER [ANY]}.make_cast (l_link___0.item.target))
						end
						if ((l_link___0.item.where_img).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 220, create {CE_POINTER [ANY]}.make_cast (l_link___0.item.where_img))
						end
						if ((l_link___0.item.pos).c_pointer /= default_pointer) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 221, create {CE_POINTER [ANY]}.make_cast (l_link___0.item.pos))
						end
						memmove (create {CE_POINTER [ANY]}.make_cast (l_link___0), create {CE_POINTER [ANY]}.make_cast ((l_link___0 + 1)), ((a_f.item.nlinks - l_i) - 1).to_natural_32 * {PD_LINK}.sizeof.to_natural_32).do_nothing
						a_f.item.nlinks := (a_f.item.nlinks) - 1
						l_i := l_i - 1
						js.continue
					end
				end
				if not js.loop_jumped then
					l_p := a_f.item.y - 1
					l_q := 0
					l_j := 0
					from
					until
						not (l_j < l_link___0.item.n)
					loop
						if (l_link___0.item.pos + l_j).item.y < l_p then
							l_p := (l_link___0.item.pos + l_j).item.y
						end
						if (l_link___0.item.pos + l_j).item.y > l_q then
							l_q := (l_link___0.item.pos + l_j).item.y
						end
						l_j := l_j + 1
					end
					if l_p > l_q then
						l_j := l_p
						l_p := l_q
						l_q := l_j
					end
					l_j := l_p
					from
					until
						not (not js.loop_left and then (l_j <= l_q))
					loop
						js.reset
						if l_j >= a_f.item.y then
							from
							until
								False
							loop
								links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")))
								links_inst.errline := 240
								error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("link out of screen"))])
							end
							js.continue
						end
						if not js.loop_jumped then
							a_f.item.lines2[l_j] := a_f.item.links + l_i
							if (a_f.item.lines1[l_j]).c_pointer = default_pointer then
								a_f.item.lines1[l_j] := a_f.item.links + l_i
							end
						end
						if not js.loop_left then
							l_j := l_j + 1
						end
					end
				end
				if not js.loop_left then
					l_i := l_i + 1
				end
			end
		end

	format_text (a_text: CE_POINTER [NATURAL_8]; a_width: INTEGER_32; a_wrap: INTEGER_32): CE_POINTER [PD_LINE_INFO]
		local
			l_text: CE_POINTER [NATURAL_8]
			l_ln: CE_POINTER [PD_LINE_INFO]
			l_lnn: INTEGER_32
			l_b: CE_POINTER [NATURAL_8]
			l_sk: INTEGER_32
			l_ps: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_text.make
			create l_ln.make
			create l_b.make
			create l_s.make
			create l_tmp___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_text.ce_gets (a_text)
					l_ln.ce_gets (create {CE_POINTER [PD_LINE_INFO]}.make_shared (default_pointer + -1))
					l_lnn := 0
					l_b.ce_gets (l_text)
					l_ps := 0
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_text.item).to_boolean)) then
						l_pos := -1 + 12 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if (l_text.item).to_integer_32 /= 10 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_sk := 1
				when 4 then -- put:
						if not ((l_lnn).bit_and (63)).to_boolean then
							if l_lnn.to_natural_32 > {NATURAL_32} 2147483647 // {PD_LINE_INFO}.sizeof.to_natural_32 - {NATURAL_32} 64 then
								from
								until
									False
								loop
									error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("view.c"), 268])
									kbd_inst.fatal_tty_exit
									exit (4)
								end
							end
							l_ln.ce_gets (create {CE_POINTER [PD_LINE_INFO]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 269, create {CE_POINTER [ANY]}.make_cast (l_ln), (l_lnn + 64).to_natural_32 * {PD_LINE_INFO}.sizeof.to_natural_32))))
						end
						(l_ln + l_lnn).item.st := l_b
						l_tmp___0 := l_lnn
						l_lnn := l_lnn + 1;
						(l_ln + l_tmp___0).item.en := l_text
						l_text.ce_gets (l_text + l_sk)
						l_b.ce_gets (l_text)
						js.continue
				when 5 then -- if done
						if not js.loop_jumped then
							if not a_wrap.to_boolean then
								l_text.ce_gets (l_text + 1)
								js.continue
							elseif l_text.distance (l_b) < a_width then
								l_text.ce_gets (l_text + 1)
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if:
						l_s.ce_gets (l_text)
				when 7 then -- loop condition:
						if not (not js.loop_left and then ((l_s.c_pointer.to_integer_32).to_natural_32 >= (l_b.c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 10 -- skip loop
						end
				when 8 then -- loop body:
						if (l_s.item).to_integer_32 = 32 then
							l_text.ce_gets (l_s)
							if a_wrap = 2 then
								l_s.item := (('%N').code).to_natural_8
								l_s.ce_gets (l_s + 1)
								from
								until
									not (not js.loop_left and then ((l_s.item).to_boolean))
								loop
									js.reset
									if (l_s.item).to_integer_32 = 10 then
										if (l_s[1]).to_integer_32 /= 10 then
											l_s.item := ((' ').code).to_natural_8
										end
										js.break
									end
									if not js.loop_jumped then
										l_s.ce_gets (l_s + 1)
									end
								end
								js.reset
							end
							l_sk := 1
							l_pos := -1 + 4 -- goto put
						end
				when 9 then
						l_s.ce_gets (l_s - 1)
						l_pos := -1 + 7 -- back to loop condition
				when 10 then -- loop done
						l_sk := 0
						l_pos := -1 + 4 -- goto put
				when 11 then
						l_pos := -1 + 1 -- back to loop condition
				when 12 then -- loop done
					if l_ps < 2 then
						l_ps := l_ps + 1
						l_sk := 0
						l_pos := -1 + 4 -- goto put
					end
				when 13 then
					l_tmp___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer));
					(l_ln + (l_lnn - 1)).item.en := l_tmp___1;
					(l_ln + (l_lnn - 1)).item.st := l_tmp___1
					Result := l_ln
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	area_cursor (a_form___0: CE_POINTER [PD_FORM_CONTROL]; a_fs: CE_POINTER [PD_FORM_STATE]): INTEGER_32
		local
			l_ln: CE_POINTER [PD_LINE_INFO]
			l_q: INTEGER_32
			l_x: INTEGER_32
			l_y: INTEGER_32
			js: JUMP_STATE
		do
			create l_ln.make

			l_q := 0
			l_ln.ce_gets (format_text (a_fs.item.value, a_form___0.item.cols, a_form___0.item.wrap))
			if ((l_ln).c_pointer /= default_pointer) then
				l_y := 0
				from
				until
					not (not js.loop_left and then (((l_ln + l_y).item.st).c_pointer /= default_pointer))
				loop
					js.reset
					if ((a_fs.item.value + a_fs.item.state).c_pointer.to_integer_32).to_natural_32 >= (((l_ln + l_y).item.st).c_pointer.to_integer_32).to_natural_32 then
						if ((a_fs.item.value + a_fs.item.state).c_pointer.to_integer_32).to_natural_32 < (((l_ln + l_y).item.en + ((((l_ln + (l_y + 1)).item.st).c_pointer.to_integer_32).to_natural_32 /= (((l_ln + l_y).item.en).c_pointer.to_integer_32).to_natural_32).to_integer).c_pointer.to_integer_32).to_natural_32 then
							l_x := (a_fs.item.value + a_fs.item.state).distance (((l_ln + l_y).item.st))
							if (a_form___0.item.wrap).to_boolean then
								if l_x = a_form___0.item.cols then
									l_x := l_x - 1
								end
							end
							if l_x >= a_form___0.item.cols + a_fs.item.vpos then
								a_fs.item.vpos := (l_x - a_form___0.item.cols) + 1
							end
							if l_x < a_fs.item.vpos then
								a_fs.item.vpos := l_x
							end
							if l_y >= a_form___0.item.rows + a_fs.item.vypos then
								a_fs.item.vypos := (l_y - a_form___0.item.rows) + 1
							end
							if l_y < a_fs.item.vypos then
								a_fs.item.vypos := l_y
							end
							l_x := l_x - (a_fs.item.vpos)
							l_y := l_y - (a_fs.item.vypos)
							l_q := l_y * a_form___0.item.cols + l_x
							js.break
						end
					end
					if not js.loop_jumped then
						l_y := l_y + 1
					end
				end
				js.reset
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 322, create {CE_POINTER [ANY]}.make_cast (l_ln))
			end
			Result := l_q
		end

	draw_link (a_t: CE_POINTER [PD_TERMINAL]; a_scr: CE_POINTER [PD_F_DATA_C]; a_l: INTEGER_32)
		local
			l_link___0: CE_POINTER [PD_LINK]
			l_xp: INTEGER_32
			l_yp: INTEGER_32
			l_xw: INTEGER_32
			l_yw: INTEGER_32
			l_vx: INTEGER_32
			l_vy: INTEGER_32
			l_vs: CE_POINTER [PD_VIEW_STATE]
			l_f: INTEGER_32
			l_i: INTEGER_32
			l_q: INTEGER_32
			l_fs: CE_POINTER [PD_FORM_STATE]
			l_fs___0: CE_POINTER [PD_FORM_STATE]
			l_x: INTEGER_32
			l_y: INTEGER_32
			l_co: NATURAL_32
			l_xx: INTEGER_32
			l_yy: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_link___0.make
			create l_vs.make
			create l_fs.make
			create l_fs___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_link___0.ce_gets ((a_scr.item.f_data).item.links + a_l)
					l_xp := a_scr.item.xp
					l_yp := a_scr.item.yp
					l_xw := a_scr.item.xw
					l_yw := a_scr.item.yw
					l_vs.ce_gets (a_scr.item.vs)
					l_f := 0
					l_vx := l_vs.item.view_posx
					l_vy := l_vs.item.view_pos
					if ((a_scr.item.link_bg).c_pointer /= default_pointer) then
						from
						until
							False
						loop
							links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")))
							links_inst.errline := 340
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("link background not empty"))])
						end
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 341, create {CE_POINTER [ANY]}.make_cast (a_scr.item.link_bg))
					end
					if a_l = -1 then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 35 -- skip if block
					end
				when 1 then -- if:
						inspect l_link___0.item.type -- switch 1 head
						when 0 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 2
						when 1 then l_pos := -1 + 2
						when 3 then l_pos := -1 + 2
						when 4 then l_pos := -1 + 2
						when 5 then l_pos := -1 + 2
						else l_pos := -1 + 34
						end
				when 2 then -- switch 1, case 0 | switch 1, case 2 | switch 1, case 1 | switch 1, case 3 | switch 1, case 4 | switch 1, case 5
						l_q := 0
						if l_link___0.item.type = 4 then
							l_fs.ce_gets ((find_form_state (a_scr, l_link___0.item.form)))
							if ((l_fs).c_pointer /= default_pointer) then
								l_q := l_fs.item.state - l_fs.item.vpos
							end
						elseif l_link___0.item.type = 5 then
							l_fs___0.ce_gets ((find_form_state (a_scr, l_link___0.item.form)))
							if ((l_fs___0).c_pointer /= default_pointer) then
								l_q := area_cursor (l_link___0.item.form, l_fs___0)
							end
						end
						if (l_link___0.item.n).to_natural_32 > {NATURAL_32} 2147483647 // {PD_LINK_BG}.sizeof.to_natural_32 then
							from
							until
								False
							loop
								error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("view.c"), 363])
								kbd_inst.fatal_tty_exit
								exit (4)
							end
						end
						a_scr.item.link_bg := create {CE_POINTER [PD_LINK_BG]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 364, (l_link___0.item.n).to_natural_32 * {PD_LINK_BG}.sizeof.to_natural_32)))
						a_scr.item.link_bg_n := l_link___0.item.n
						l_i := 0
				when 3 then -- loop condition:
						if not (l_i < l_link___0.item.n) then
							l_pos := -1 + 33 -- skip loop
						end
				when 4 then -- loop body:
						l_x := ((l_link___0.item.pos + l_i).item.x + l_xp) - l_vx
						l_y := ((l_link___0.item.pos + l_i).item.y + l_yp) - l_vy
						if not (l_x >= l_xp) then
							l_pos := -1 + 31 -- skip if block
						end
				when 5 then -- if:
						if not (l_y >= l_yp) then
							l_pos := -1 + 29 -- skip if block
						end
				when 6 then -- if:
						if not (l_x < l_xp + l_xw) then
							l_pos := -1 + 27 -- skip if block
						end
				when 7 then -- if:
						if not (l_y < l_yp + l_yw) then
							l_pos := -1 + 25 -- skip if block
						end
				when 8 then -- if:
						l_co := terminal_inst.get_char (a_t, l_x, l_y)
						if ((a_scr.item.link_bg).c_pointer /= default_pointer) then
							(a_scr.item.link_bg + l_i).item.x := l_x;
							(a_scr.item.link_bg + l_i).item.y := l_y;
							(a_scr.item.link_bg + l_i).item.c := l_co
						end
						if l_f.to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 22 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 11 then -- else:
						if l_link___0.item.type /= 2 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if l_i = 1 then
							l_pos := -1 + 22 -- goto _L
						else
							l_pos := -1 + 14 -- goto _L___2
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 14 then -- else: | _L___2:
						if l_link___0.item.type /= 1 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if l_i = 2 then
							l_pos := -1 + 22 -- goto _L
						else
							l_pos := -1 + 17 -- goto _L___1
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 17 then -- else: | _L___1:
						if l_link___0.item.type /= 4 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 21 -- goto _L___0
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 20 then -- else:
						if l_link___0.item.type /= 5 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if: | _L___0:
						if l_i /= l_q then
							l_pos := -1 + 23 -- skip if block
						end
				when 22 then -- if: | _L:
						l_xx := l_x
						l_yy := l_y
						if l_link___0.item.type /= 4 then
							if l_link___0.item.type /= 5 then
								if ((((l_co).bit_shift_right (8))).bit_and ({NATURAL_32} 56)) /= ((l_link___0.item.sel_color).bit_and ({NATURAL_32} 56)) then
									l_xx := (l_xp + l_xw) - 1
									l_yy := (l_yp + l_yw) - 1
								end
							end
						end
						terminal_inst.set_cursor (a_t, l_x, l_y, l_xx, l_yy)
						terminal_inst.set_window_ptr ((terminal_inst.get_root_window (a_t)), l_x, l_y)
						l_f := 1
				when 23 then -- if done | if done | if done | if done | if done
						terminal_inst.set_color (a_t, l_x, l_y, (l_link___0.item.sel_color).bit_shift_left (8))
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else:
						l_tmp___4 := {NATURAL_32} 4294967295;
						(a_scr.item.link_bg + l_i).item.c := l_tmp___4
						l_tmp___3 := l_tmp___4.to_integer_32;
						(a_scr.item.link_bg + l_i).item.y := l_tmp___3;
						(a_scr.item.link_bg + l_i).item.x := l_tmp___3
				when 26 then -- if done | if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else:
						l_tmp___4 := {NATURAL_32} 4294967295;
						(a_scr.item.link_bg + l_i).item.c := l_tmp___4
						l_tmp___3 := l_tmp___4.to_integer_32;
						(a_scr.item.link_bg + l_i).item.y := l_tmp___3;
						(a_scr.item.link_bg + l_i).item.x := l_tmp___3
				when 28 then -- if done | if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else:
						l_tmp___4 := {NATURAL_32} 4294967295;
						(a_scr.item.link_bg + l_i).item.c := l_tmp___4
						l_tmp___3 := l_tmp___4.to_integer_32;
						(a_scr.item.link_bg + l_i).item.y := l_tmp___3;
						(a_scr.item.link_bg + l_i).item.x := l_tmp___3
				when 30 then -- if done | if block done, skip else block:
						l_pos := -1 + 32
				when 31 then -- else:
						l_tmp___4 := {NATURAL_32} 4294967295;
						(a_scr.item.link_bg + l_i).item.c := l_tmp___4
						l_tmp___3 := l_tmp___4.to_integer_32;
						(a_scr.item.link_bg + l_i).item.y := l_tmp___3;
						(a_scr.item.link_bg + l_i).item.x := l_tmp___3
				when 32 then -- if done
						l_i := l_i + 1
						l_pos := -1 + 3 -- back to loop condition
				when 33 then -- loop done
						l_pos := -1 + 35 -- switch 1; break
				when 34 then -- switch 1, default:
						from
						until
							False
						loop
							links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")))
							links_inst.errline := 388
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bad link type"))])
						end
				when 35 then -- switch 1, done:
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	free_link (a_scr: CE_POINTER [PD_F_DATA_C])
		do
			if ((a_scr.item.link_bg).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 395, create {CE_POINTER [ANY]}.make_cast (a_scr.item.link_bg))
				a_scr.item.link_bg := create {CE_POINTER [PD_LINK_BG]}.make_shared (default_pointer)
			end
			a_scr.item.link_bg_n := 0
		end

	clear_link (a_t: CE_POINTER [PD_TERMINAL]; a_scr: CE_POINTER [PD_F_DATA_C])
		local
			l_i: INTEGER_32
		do
			if ((a_scr.item.link_bg).c_pointer /= default_pointer) then
				l_i := a_scr.item.link_bg_n - 1
				from
				until
					not (l_i >= 0)
				loop
					terminal_inst.set_char (a_t, (a_scr.item.link_bg + l_i).item.x, (a_scr.item.link_bg + l_i).item.y, (a_scr.item.link_bg + l_i).item.c)
					l_i := l_i - 1
				end
				free_link (a_scr)
			end
		end

	get_range (a_f: CE_POINTER [PD_F_DATA]; a_y: INTEGER_32; a_yw: INTEGER_32; a_l: INTEGER_32; a_s1: CE_POINTER [CE_POINTER [PD_SEARCH]]; a_s2: CE_POINTER [CE_POINTER [PD_SEARCH]]): INTEGER_32
		local
			l_i: INTEGER_32
			l_tmp: CE_POINTER [PD_SEARCH]
			l_tmp___0: CE_POINTER [PD_SEARCH]
			js: JUMP_STATE
		do
			create l_tmp.make
			create l_tmp___0.make

			l_tmp.ce_gets (create {CE_POINTER [PD_SEARCH]}.make_shared (default_pointer))
			a_s2.item := l_tmp
			a_s1.item := l_tmp
			if a_y < 0 then
				l_i := 0
			else
				l_i := a_y
			end
			from
			until
				js.loop_left
			loop
				js.reset
				if l_i < a_y + a_yw then
					if not (l_i < a_f.item.y) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if ((a_f.item.slines1[l_i]).c_pointer /= default_pointer) then
						if (a_s1.item).c_pointer = default_pointer then
							a_s1.item := a_f.item.slines1[l_i]
						elseif ((a_f.item.slines1[l_i]).c_pointer.to_integer_32).to_natural_32 < ((a_s1.item).c_pointer.to_integer_32).to_natural_32 then
							a_s1.item := a_f.item.slines1[l_i]
						end
					end
					if ((a_f.item.slines2[l_i]).c_pointer /= default_pointer) then
						if (a_s2.item).c_pointer = default_pointer then
							a_s2.item := a_f.item.slines2[l_i]
						elseif ((a_f.item.slines2[l_i]).c_pointer.to_integer_32).to_natural_32 > ((a_s2.item).c_pointer.to_integer_32).to_natural_32 then
							a_s2.item := a_f.item.slines2[l_i]
						end
					end
					l_i := l_i + 1
				end
			end
			js.reset
			if (a_s1.item).c_pointer = default_pointer then
				Result := (-1)
				js.return
			elseif (a_s2.item).c_pointer = default_pointer then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				a_s1.item := a_s1.item - a_l
				if ((a_s1.item).c_pointer.to_integer_32).to_natural_32 < ((a_f.item.search).c_pointer.to_integer_32).to_natural_32 then
					a_s1.item := a_f.item.search
				end
				if ((a_s2.item + a_l).c_pointer.to_integer_32).to_natural_32 > ((a_f.item.search + a_f.item.nsearch).c_pointer.to_integer_32).to_natural_32 then
					a_s2.item := (a_f.item.search + a_f.item.nsearch) - a_l
				end
				if ((a_s1.item).c_pointer.to_integer_32).to_natural_32 > ((a_s2.item).c_pointer.to_integer_32).to_natural_32 then
					l_tmp___0.ce_gets (create {CE_POINTER [PD_SEARCH]}.make_shared (default_pointer))
					a_s2.item := l_tmp___0
					a_s1.item := l_tmp___0
				end
				if (a_s1.item).c_pointer = default_pointer then
					Result := (-1)
					js.return
				elseif (a_s2.item).c_pointer = default_pointer then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	is_in_range (a_f: CE_POINTER [PD_F_DATA]; a_y: INTEGER_32; a_yw: INTEGER_32; a_txt: CE_POINTER [NATURAL_8]; a_min: CE_POINTER [INTEGER_32]; a_max: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_found: INTEGER_32
			l_l: INTEGER_32
			l_s1: CE_POINTER [PD_SEARCH]
			l_s2: CE_POINTER [PD_SEARCH]
			l_i: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s1.make
			create l_s2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_found := 0
					l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_txt))).to_integer_32
					if ((a_min).c_pointer /= default_pointer) then
						a_min.item := 2147483647
						a_max.item := 0
					elseif ((a_max).c_pointer /= default_pointer) then
						a_min.item := 2147483647
						a_max.item := 0
					end
					if (get_range (a_f, a_y, a_yw, l_l, l_s1.address, l_s2.address)).to_boolean then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 17 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if not (not js.loop_left and then ((l_s1.c_pointer.to_integer_32).to_natural_32 <= (l_s2.c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 17 -- skip loop
						end
				when 2 then -- loop body:
						js.reset
						if (l_s1.item.c).to_integer_32 = (a_txt[0]).to_integer_32 then
							l_pos := -1 + 4 -- skip if block
						end
				when 3 then -- if: | unable_to_handle_kernel_paging_request___oops:
						js.continue
				when 4 then -- if done
						if js.loop_jumped then
							l_pos := -1 + 14 -- skip if block
						end
				when 5 then -- if:
						l_i := 1
				when 6 then -- loop condition:
						if not (l_i < l_l) then
							l_pos := -1 + 9 -- skip loop
						end
				when 7 then -- loop body:
						if ((l_s1 + l_i).item.c).to_integer_32 /= (a_txt[l_i]).to_integer_32 then
							l_pos := -1 + 3 -- goto unable_to_handle_kernel_paging_request___oops
						end
				when 8 then
						l_i := l_i + 1
						l_pos := -1 + 6 -- back to loop condition
				when 9 then -- loop done
						l_i := 0
				when 10 then -- loop condition:
						if not (l_i < l_l) then
							l_pos := -1 + 13 -- skip loop
						end
				when 11 then -- loop body:
						if (l_s1 + l_i).item.y >= a_y then
							if (l_s1 + l_i).item.y < a_y + a_yw then
								if ((l_s1 + l_i).item.n).to_boolean then
									l_pos := -1 + 15 -- goto in_view
								end
							end
						end
				when 12 then
						l_i := l_i + 1
						l_pos := -1 + 10 -- back to loop condition
				when 13 then -- loop done
						js.continue
				when 14 then -- if done
						if js.loop_jumped then
							l_pos := -1 + 16 -- skip if block
						end
				when 15 then -- if: | in_view:
						if (a_min).c_pointer = default_pointer then
							if (a_max).c_pointer = default_pointer then
								Result := 1
								js.return
							end
						end
						if not js.return_called then
							l_found := 1
							l_i := 0
							from
							until
								not (l_i < l_l)
							loop
								if ((l_s1 + l_i).item.n).to_boolean then
									if (l_s1 + l_i).item.x < a_min.item then
										a_min.item := (l_s1 + l_i).item.x
									end
									if (l_s1 + l_i).item.x + (l_s1 + l_i).item.n > a_max.item then
										a_max.item := (l_s1 + l_i).item.x + (l_s1 + l_i).item.n
									end
								end
								l_i := l_i + 1
							end
						end
				when 16 then -- if done
						if not js.loop_left then
							l_s1.ce_gets (l_s1 + 1)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 17 then -- loop done | if done
						if not js.return_called then
							Result := l_found
						end
				when 18 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	get_searched (a_scr: CE_POINTER [PD_F_DATA_C]; a_pt: CE_POINTER [CE_POINTER [PD_POINT]]; a_pl: CE_POINTER [INTEGER_32])
		local
			l_xp: INTEGER_32
			l_yp: INTEGER_32
			l_xw: INTEGER_32
			l_yw: INTEGER_32
			l_vx: INTEGER_32
			l_vy: INTEGER_32
			l_s1: CE_POINTER [PD_SEARCH]
			l_s2: CE_POINTER [PD_SEARCH]
			l_l: INTEGER_32
			l_c: NATURAL_8
			l_points: CE_POINTER [PD_POINT]
			l_len: INTEGER_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_x: INTEGER_32
			l_y: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s1.make
			create l_s2.make
			create l_points.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_xp := a_scr.item.xp
					l_yp := a_scr.item.yp
					l_xw := a_scr.item.xw
					l_yw := a_scr.item.yw
					l_vx := (a_scr.item.vs).item.view_posx
					l_vy := (a_scr.item.vs).item.view_pos
					l_points.ce_gets (create {CE_POINTER [PD_POINT]}.make_shared (default_pointer + -1))
					l_len := 0
					if (a_scr.item.search_word).c_pointer = default_pointer then
						js.return
					elseif ((a_scr.item.search_word).item).c_pointer = default_pointer then
						js.return
					elseif not ((a_scr.item.search_word).item[0]).to_boolean then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						html_r_inst.get_search_data (a_scr.item.f_data)
						l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((a_scr.item.search_word).item))).to_integer_32
						l_c := (a_scr.item.search_word).item[0]
						if (get_range (a_scr.item.f_data, (a_scr.item.vs).item.view_pos, a_scr.item.yw, l_l, l_s1.address, l_s2.address)).to_boolean then
							l_pos := -1 + 12 -- goto ret
						end
				when 2 then
						if not (not js.loop_left and then ((l_s1.c_pointer.to_integer_32).to_natural_32 <= (l_s2.c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 12 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if (l_s1.item.c).to_integer_32 = l_c.to_integer_32 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | c:
						js.continue
				when 5 then -- if done
						if js.loop_jumped then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if:
						l_i := 1
				when 7 then -- loop condition:
						if not (l_i < l_l) then
							l_pos := -1 + 10 -- skip loop
						end
				when 8 then -- loop body:
						if ((l_s1 + l_i).item.c).to_integer_32 /= ((a_scr.item.search_word).item[l_i]).to_integer_32 then
							l_pos := -1 + 4 -- goto c
						end
				when 9 then
						l_i := l_i + 1
						l_pos := -1 + 7 -- back to loop condition
				when 10 then -- loop done
						l_i := 0
						from
						until
							not (not js.loop_left and then (l_i < l_l))
						loop
							l_j := 0
							from
							until
								not (not js.loop_left and then (l_j < (l_s1 + l_i).item.n))
							loop
								l_x := (((l_s1 + l_i).item.x + l_j) + l_xp) - l_vx
								l_y := ((l_s1 + l_i).item.y + l_yp) - l_vy
								if l_x >= l_xp then
									if l_y >= l_yp then
										if l_x < l_xp + l_xw then
											if l_y < l_yp + l_yw then
												if not ((l_len).bit_and (63)).to_boolean then
													if l_len.to_natural_32 > {NATURAL_32} 2147483647 // {PD_POINT}.sizeof.to_natural_32 - {NATURAL_32} 64 then
														from
														until
															False
														loop
															error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("view.c"), 488])
															kbd_inst.fatal_tty_exit
															exit (4)
														end
													end
													l_points.ce_gets (create {CE_POINTER [PD_POINT]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 489, create {CE_POINTER [ANY]}.make_cast (l_points), {PD_POINT}.sizeof.to_natural_32 * (l_len + 64).to_natural_32))))
												end
												(l_points + l_len).item.x := (l_s1 + l_i).item.x + l_j
												l_tmp___2 := l_len
												l_len := l_len + 1;
												(l_points + l_tmp___2).item.y := (l_s1 + l_i).item.y
											end
										end
									end
								end
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 11 then -- if done
						if not js.loop_left then
							l_s1.ce_gets (l_s1 + 1)
						end
						l_pos := -1 + 2 -- back to loop condition
				when 12 then -- ret:
						a_pt.item := l_points
						a_pl.item := l_len
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	draw_searched (a_t: CE_POINTER [PD_TERMINAL]; a_scr: CE_POINTER [PD_F_DATA_C])
		local
			l_xp: INTEGER_32
			l_yp: INTEGER_32
			l_vx: INTEGER_32
			l_vy: INTEGER_32
			l_pt: CE_POINTER [PD_POINT]
			l_len: INTEGER_32
			l_i: INTEGER_32
			l_x: INTEGER_32
			l_y: INTEGER_32
			l_co: NATURAL_32
			js: JUMP_STATE
		do
			create l_pt.make

			l_xp := a_scr.item.xp
			l_yp := a_scr.item.yp
			l_vx := (a_scr.item.vs).item.view_posx
			l_vy := (a_scr.item.vs).item.view_pos
			if (a_scr.item.search_word).c_pointer = default_pointer then
				js.return
			elseif ((a_scr.item.search_word).item).c_pointer = default_pointer then
				js.return
			elseif not ((a_scr.item.search_word).item[0]).to_boolean then
				js.return
			end
			if not js.return_called then
				get_searched (a_scr, l_pt.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_len))
				l_i := 0
				from
				until
					not (l_i < l_len)
				loop
					l_x := ((l_pt + l_i).item.x + l_xp) - l_vx
					l_y := ((l_pt + l_i).item.y + l_yp) - l_vy
					l_co := terminal_inst.get_char (a_t, l_x, l_y)
					l_co := (((((l_co).bit_shift_right (3))).bit_and ({NATURAL_32} 1792))).bit_or (((((l_co).bit_shift_left (3))).bit_and ({NATURAL_32} 14336)))
					terminal_inst.set_color (a_t, l_x, l_y, l_co)
					l_i := l_i + 1
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 518, create {CE_POINTER [ANY]}.make_cast (l_pt))
			end
		end

	draw_current_link (a_t: CE_POINTER [PD_TERMINAL]; a_scr: CE_POINTER [PD_F_DATA_C])
		do
			draw_link (a_t, a_scr, (a_scr.item.vs).item.current_link)
			draw_searched (a_t, a_scr)
		end

	get_first_link (a_f: CE_POINTER [PD_F_DATA_C]): CE_POINTER [PD_LINK]
		local
			l_i: INTEGER_32
			l_l: CE_POINTER [PD_LINK]
		do
			create l_l.make

			l_l.ce_gets ((a_f.item.f_data).item.links + (a_f.item.f_data).item.nlinks)
			l_i := (a_f.item.vs).item.view_pos
			from
			until
				not (l_i < (a_f.item.vs).item.view_pos + a_f.item.yw)
			loop
				if l_i >= 0 then
					if l_i < (a_f.item.f_data).item.y then
						if (((a_f.item.f_data).item.lines1[l_i]).c_pointer /= default_pointer) then
							if (((a_f.item.f_data).item.lines1[l_i]).c_pointer.to_integer_32).to_natural_32 < (l_l.c_pointer.to_integer_32).to_natural_32 then
								l_l.ce_gets ((a_f.item.f_data).item.lines1[l_i])
							end
						end
					end
				end
				l_i := l_i + 1
			end
			if (l_l.c_pointer.to_integer_32).to_natural_32 = (((a_f.item.f_data).item.links + (a_f.item.f_data).item.nlinks).c_pointer.to_integer_32).to_natural_32 then
				l_l.ce_gets (create {CE_POINTER [PD_LINK]}.make_shared (default_pointer))
			end
			Result := l_l
		end

	get_last_link (a_f: CE_POINTER [PD_F_DATA_C]): CE_POINTER [PD_LINK]
		local
			l_i: INTEGER_32
			l_l: CE_POINTER [PD_LINK]
		do
			create l_l.make

			l_l.ce_gets (create {CE_POINTER [PD_LINK]}.make_shared (default_pointer))
			l_i := (a_f.item.vs).item.view_pos
			from
			until
				not (l_i < (a_f.item.vs).item.view_pos + a_f.item.yw)
			loop
				if l_i >= 0 then
					if l_i < (a_f.item.f_data).item.y then
						if (((a_f.item.f_data).item.lines2[l_i]).c_pointer.to_integer_32).to_natural_32 > (l_l.c_pointer.to_integer_32).to_natural_32 then
							l_l.ce_gets ((a_f.item.f_data).item.lines2[l_i])
						end
					end
				end
				l_i := l_i + 1
			end
			Result := l_l
		end

	fixup_select_state (a_fc: CE_POINTER [PD_FORM_CONTROL]; a_fs: CE_POINTER [PD_FORM_STATE])
		local
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			if a_fs.item.state >= 0 then
				if a_fs.item.state < a_fc.item.nvalues then
					if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_fc.item.values[a_fs.item.state]), create {CE_POINTER [INTEGER_8]}.make_cast (a_fs.item.value))).to_boolean then
						js.return
					end
				end
			end
			if not js.return_called then
				l_i := 0
				from
				until
					not (not js.loop_left and then (l_i < a_fc.item.nvalues))
				loop
					if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_fc.item.values[l_i]), create {CE_POINTER [INTEGER_8]}.make_cast (a_fs.item.value))).to_boolean then
						a_fs.item.state := l_i
						js.return
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				a_fs.item.state := 0
				if ((a_fs.item.value).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 559, create {CE_POINTER [ANY]}.make_cast (a_fs.item.value))
				end
				if (a_fc.item.nvalues).to_boolean then
					a_fs.item.value := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 560, a_fc.item.values[0])
				else
					a_fs.item.value := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 561, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
				end
			end
		end

	init_ctrl (a_form___0: CE_POINTER [PD_FORM_CONTROL]; a_fs: CE_POINTER [PD_FORM_STATE])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((a_fs.item.value).c_pointer /= default_pointer) then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 566, create {CE_POINTER [ANY]}.make_cast (a_fs.item.value))
						a_fs.item.value := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
					inspect a_form___0.item.type -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 1
					when 4 then l_pos := -1 + 1
					when 3 then l_pos := -1 + 2
					when 5 then l_pos := -1 + 3
					when 6 then l_pos := -1 + 3
					when 7 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 1 | switch 1, case 2 | switch 1, case 4
					a_fs.item.value := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 571, a_form___0.item.default_value)
					a_fs.item.state := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_form___0.item.default_value))).to_integer_32
					a_fs.item.vpos := 0
					l_pos := -1 + 5 -- switch 1; break
				when 2 then -- switch 1, case 3
					a_fs.item.value := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 576, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
					a_fs.item.state := 0
					a_fs.item.vpos := 0
					l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case 5 | switch 1, case 6
					a_fs.item.state := a_form___0.item.default_state
					l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, case 7
					a_fs.item.value := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 585, a_form___0.item.default_value)
					a_fs.item.state := a_form___0.item.default_state
					fixup_select_state (a_form___0, a_fs)
					l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	find_form_state (a_f: CE_POINTER [PD_F_DATA_C]; a_form___0: CE_POINTER [PD_FORM_CONTROL]): CE_POINTER [PD_FORM_STATE]
		local
			l_vs: CE_POINTER [PD_VIEW_STATE]
			l_fs: CE_POINTER [PD_FORM_STATE]
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			create l_vs.make
			create l_fs.make

			l_vs.ce_gets (a_f.item.vs)
			l_n := a_form___0.item.g_ctrl_num
			if l_n < l_vs.item.form_info_len then
				l_fs.ce_gets (l_vs.item.form_info + l_n)
			else
				if l_n.to_natural_32 > {NATURAL_32} 2147483647 // {PD_FORM_STATE}.sizeof.to_natural_32 - {NATURAL_32} 1 then
					from
					until
						False
					loop
						error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("view.c"), 599])
						kbd_inst.fatal_tty_exit
						exit (4)
					end
				end
				l_fs.ce_gets (create {CE_POINTER [PD_FORM_STATE]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 600, create {CE_POINTER [ANY]}.make_cast (l_vs.item.form_info), (l_n + 1).to_natural_32 * {PD_FORM_STATE}.sizeof.to_natural_32))))
				l_vs.item.form_info := l_fs
				memset (create {CE_POINTER [ANY]}.make_cast ((l_fs + l_vs.item.form_info_len)), 0, ((l_n + 1) - l_vs.item.form_info_len).to_natural_32 * {PD_FORM_STATE}.sizeof.to_natural_32).do_nothing
				l_vs.item.form_info_len := l_n + 1
				l_fs.ce_gets (l_vs.item.form_info + l_n)
			end
			if l_fs.item.form_num = a_form___0.item.form_num then
				if l_fs.item.ctrl_num = a_form___0.item.ctrl_num then
					if l_fs.item.g_ctrl_num = a_form___0.item.g_ctrl_num then
						if l_fs.item.position = a_form___0.item.position then
							if l_fs.item.type = a_form___0.item.type then
								Result := l_fs
								js.return
							end
						end
					end
				end
			end
			if not js.return_called then
				if ((l_fs.item.value).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 607, create {CE_POINTER [ANY]}.make_cast (l_fs.item.value))
				end
				memset (create {CE_POINTER [ANY]}.make_cast (l_fs), 0, {PD_FORM_STATE}.sizeof.to_natural_32).do_nothing
				l_fs.item.form_num := a_form___0.item.form_num
				l_fs.item.ctrl_num := a_form___0.item.ctrl_num
				l_fs.item.g_ctrl_num := a_form___0.item.g_ctrl_num
				l_fs.item.position := a_form___0.item.position
				l_fs.item.type := a_form___0.item.type
				init_ctrl (a_form___0, l_fs)
				Result := l_fs
			end
		end

	draw_form_entry (a_t: CE_POINTER [PD_TERMINAL]; a_f: CE_POINTER [PD_F_DATA_C]; a_l: CE_POINTER [PD_LINK])
		local
			l_xp: INTEGER_32
			l_yp: INTEGER_32
			l_xw: INTEGER_32
			l_yw: INTEGER_32
			l_vs: CE_POINTER [PD_VIEW_STATE]
			l_vx: INTEGER_32
			l_vy: INTEGER_32
			l_fs: CE_POINTER [PD_FORM_STATE]
			l_form___0: CE_POINTER [PD_FORM_CONTROL]
			l_i: INTEGER_32
			l_x: INTEGER_32
			l_y: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_ln: CE_POINTER [PD_LINE_INFO]
			l_lnx: CE_POINTER [PD_LINE_INFO]
			l_sl: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_vs.make
			create l_fs.make
			create l_form___0.make
			create l_s.make
			create l_ln.make
			create l_lnx.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_xp := a_f.item.xp
					l_yp := a_f.item.yp
					l_xw := a_f.item.xw
					l_yw := a_f.item.yw
					l_vs.ce_gets (a_f.item.vs)
					l_vx := l_vs.item.view_posx
					l_vy := l_vs.item.view_pos
					l_form___0.ce_gets (a_l.item.form)
					if (l_form___0).c_pointer = default_pointer then
						from
						until
							False
						loop
							links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")))
							links_inst.errline := 631
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("link %%d has no form")), a_l.distance (((a_f.item.f_data).item.links))])
						end
						js.return
					end
					if not js.return_called then
						l_fs.ce_gets (find_form_state (a_f, l_form___0))
						if (l_fs).c_pointer = default_pointer then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						inspect l_form___0.item.type -- switch 1 head
						when 1 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 2
						when 3 then l_pos := -1 + 2
						when 4 then l_pos := -1 + 4
						when 5 then l_pos := -1 + 7
						when 6 then l_pos := -1 + 7
						when 7 then l_pos := -1 + 9
						when 8 then l_pos := -1 + 10
						when 9 then l_pos := -1 + 10
						when 10 then l_pos := -1 + 10
						when 11 then l_pos := -1 + 10
						else l_pos := -1 + 11
						end
				when 2 then -- switch 1, case 1 | switch 1, case 2 | switch 1, case 3
						if l_fs.item.state >= l_fs.item.vpos + l_form___0.item.size then
							l_fs.item.vpos := (l_fs.item.state - l_form___0.item.size) + 1
						end
						if l_fs.item.state < l_fs.item.vpos then
							l_fs.item.vpos := l_fs.item.state
						end
						if not (a_l.item.n).to_boolean then
							l_pos := -1 + 11 -- switch 1; break
						end
				when 3 then
						l_x := ((a_l.item.pos + 0).item.x + l_xp) - l_vx
						l_y := ((a_l.item.pos + 0).item.y + l_yp) - l_vy
						l_i := 0
						from
						until
							not (l_i < l_form___0.item.size)
						loop
							if l_x >= l_xp then
								if l_y >= l_yp then
									if l_x < l_xp + l_xw then
										if l_y < l_yp + l_yw then
											if ((l_fs.item.value).c_pointer /= default_pointer) then
												if l_i >= -l_fs.item.vpos then
													if l_i < (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fs.item.value))).to_integer_32 - l_fs.item.vpos then
														if l_form___0.item.type /= 2 then
															l_tmp := (l_fs.item.value[(l_i + l_fs.item.vpos)]).to_integer_32
														else
															l_tmp := ('*').code
														end
														terminal_inst.set_only_char (a_t, l_x, l_y, l_tmp.to_natural_32)
													else
														terminal_inst.set_only_char (a_t, l_x, l_y, (('_').code).to_natural_32)
													end
												else
													terminal_inst.set_only_char (a_t, l_x, l_y, (('_').code).to_natural_32)
												end
											else
												terminal_inst.set_only_char (a_t, l_x, l_y, (('_').code).to_natural_32)
											end
										end
									end
								end
							end
							l_i := l_i + 1
							l_x := l_x + 1
						end
						l_pos := -1 + 11 -- switch 1; break
				when 4 then -- switch 1, case 4
						if not (a_l.item.n).to_boolean then
							l_pos := -1 + 11 -- switch 1; break
						end
				when 5 then
						l_x := ((a_l.item.pos + 0).item.x + l_xp) - l_vx
						l_y := ((a_l.item.pos + 0).item.y + l_yp) - l_vy
						area_cursor (l_form___0, l_fs).do_nothing
						l_lnx.ce_gets (format_text (l_fs.item.value, l_form___0.item.cols, l_form___0.item.wrap))
						if (l_lnx).c_pointer = default_pointer then
							l_pos := -1 + 11 -- switch 1; break
						end
				when 6 then
						l_ln.ce_gets (l_lnx)
						l_sl := l_fs.item.vypos
						from
						until
							js.loop_left
						loop
							js.reset
							if ((l_ln.item.st).c_pointer /= default_pointer) then
								if not l_sl.to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_sl := l_sl - 1
								l_ln.ce_gets (l_ln + 1)
							end
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							if ((l_ln.item.st).c_pointer /= default_pointer) then
								if not (l_y < (((a_l.item.pos + 0).item.y + l_yp) - l_vy) + l_form___0.item.rows) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_i := 0
								from
								until
									not (l_i < l_form___0.item.cols)
								loop
									if l_x + l_i >= l_xp then
										if l_y >= l_yp then
											if l_x + l_i < l_xp + l_xw then
												if l_y < l_yp + l_yw then
													if ((l_fs.item.value).c_pointer /= default_pointer) then
														if l_i >= -l_fs.item.vpos then
															if l_i + l_fs.item.vpos < (l_ln.item.en).distance ((l_ln.item.st)) then
																terminal_inst.set_only_char (a_t, l_x + l_i, l_y, (l_ln.item.st[(l_i + l_fs.item.vpos)]).to_natural_32)
															else
																terminal_inst.set_only_char (a_t, l_x + l_i, l_y, (('_').code).to_natural_32)
															end
														else
															terminal_inst.set_only_char (a_t, l_x + l_i, l_y, (('_').code).to_natural_32)
														end
													else
														terminal_inst.set_only_char (a_t, l_x + l_i, l_y, (('_').code).to_natural_32)
													end
												end
											end
										end
									end
									l_i := l_i + 1
								end
								l_ln.ce_gets (l_ln + 1)
								l_y := l_y + 1
							end
						end
						js.reset
						from
						until
							not (not js.loop_left and then (l_y < (((a_l.item.pos + 0).item.y + l_yp) - l_vy) + l_form___0.item.rows))
						loop
							l_i := 0
							from
							until
								not (l_i < l_form___0.item.cols)
							loop
								if l_x + l_i >= l_xp then
									if l_y >= l_yp then
										if l_x + l_i < l_xp + l_xw then
											if l_y < l_yp + l_yw then
												terminal_inst.set_only_char (a_t, l_x + l_i, l_y, (('_').code).to_natural_32)
											end
										end
									end
								end
								l_i := l_i + 1
							end
							l_y := l_y + 1
						end
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 675, create {CE_POINTER [ANY]}.make_cast (l_lnx))
						l_pos := -1 + 11 -- switch 1; break
				when 7 then -- switch 1, case 5 | switch 1, case 6
						if a_l.item.n < 2 then
							l_pos := -1 + 11 -- switch 1; break
						end
				when 8 then
						l_x := ((a_l.item.pos + 1).item.x + l_xp) - l_vx
						l_y := ((a_l.item.pos + 1).item.y + l_yp) - l_vy
						if l_x >= l_xp then
							if l_y >= l_yp then
								if l_x < l_xp + l_xw then
									if l_y < l_yp + l_yw then
										if (l_fs.item.state).to_boolean then
											l_tmp___1 := ('X').code
										else
											l_tmp___1 := (' ').code
										end
										terminal_inst.set_only_char (a_t, l_x, l_y, l_tmp___1.to_natural_32)
									end
								end
							end
						end
						l_pos := -1 + 11 -- switch 1; break
				when 9 then -- switch 1, case 7
						fixup_select_state (l_form___0, l_fs)
						if l_fs.item.state < l_form___0.item.nvalues then
							l_s.ce_gets (l_form___0.item.labels[l_fs.item.state])
						else
							l_s.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
						end
						if ((l_s).c_pointer /= default_pointer) then
							l_sl := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))).to_integer_32
						else
							l_sl := 0
						end
						l_i := 0
						from
						until
							not (l_i < a_l.item.n)
						loop
							l_x := ((a_l.item.pos + l_i).item.x + l_xp) - l_vx
							l_y := ((a_l.item.pos + l_i).item.y + l_yp) - l_vy
							if l_x >= l_xp then
								if l_y >= l_yp then
									if l_x < l_xp + l_xw then
										if l_y < l_yp + l_yw then
											if l_i < l_sl then
												l_tmp___3 := (l_s[l_i]).to_integer_32
											else
												l_tmp___3 := ('_').code
											end
											terminal_inst.set_only_char (a_t, l_x, l_y, l_tmp___3.to_natural_32)
										end
									end
								end
							end
							l_i := l_i + 1
						end
						l_pos := -1 + 11 -- switch 1; break
				when 10 then -- switch 1, case 8 | switch 1, case 9 | switch 1, case 10 | switch 1, case 11
						l_pos := -1 + 11 -- switch 1; break
				when 11 then -- switch 1, done:
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	draw_forms (a_t: CE_POINTER [PD_TERMINAL]; a_f: CE_POINTER [PD_F_DATA_C])
		local
			l_l1: CE_POINTER [PD_LINK]
			l_l2: CE_POINTER [PD_LINK]
			l_tmp___1: CE_POINTER [PD_LINK]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_l1.make
			create l_l2.make
			create l_tmp___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_l1.ce_gets ((get_first_link (a_f)))
					l_l2.ce_gets ((get_last_link (a_f)))
					if ((l_l1).c_pointer /= default_pointer) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if ((l_l2).c_pointer /= default_pointer) then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if: | _L___0:
						if (l_l1).c_pointer = default_pointer then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if (l_l2).c_pointer = default_pointer then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						from
						until
							False
						loop
							links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")))
							links_inst.errline := 709
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("get_first_link == %%p, get_last_link == %%p")), l_l1, l_l2])
						end
				when 9 then -- if done
						js.return
				when 10 then -- if done
						if not js.return_called then
							from
							until
								js.loop_left
							loop
								js.reset
								if l_l1.item.type /= 0 then
									draw_form_entry (a_t, a_f, l_l1)
								end
								l_tmp___1.ce_gets (l_l1)
								l_l1.ce_gets (l_l1 + 1)
								if not ((l_tmp___1.c_pointer.to_integer_32).to_natural_32 < (l_l2.c_pointer.to_integer_32).to_natural_32) then
									js.break
								end
							end
							js.reset
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	set_xchar (a_t: CE_POINTER [PD_TERMINAL]; a_x: INTEGER_32; a_y: INTEGER_32; a_dir: NATURAL_32)
		local
			l_c: NATURAL_32
			js: JUMP_STATE
		do
			if a_x < 0 then
				js.return
			elseif a_x >= a_t.item.x then
				js.return
			elseif a_y < 0 then
				js.return
			elseif a_y >= a_t.item.y then
				js.return
			end
			if not js.return_called then
				l_c := terminal_inst.get_char (a_t, a_x, a_y)
				if not ((l_c).bit_and ({NATURAL_32} 32768)).to_boolean then
					js.return
				end
			end
			if not js.return_called then
				l_c := (l_c).bit_and (({NATURAL_32} 255))
				if l_c = ((fr_trans[(a_dir // {NATURAL_32} 2).to_integer_32])[0]).to_natural_32 then
					terminal_inst.set_only_char (a_t, a_x, a_y, ((((fr_trans[(a_dir // {NATURAL_32} 2).to_integer_32])[({NATURAL_32} 1 + ((a_dir).bit_and ({NATURAL_32} 1))).to_integer_32]).to_integer_32).bit_or (32768)).to_natural_32)
				elseif l_c = ((fr_trans[(a_dir // {NATURAL_32} 2).to_integer_32])[({NATURAL_32} 2 - ((a_dir).bit_and ({NATURAL_32} 1))).to_integer_32]).to_natural_32 then
					terminal_inst.set_only_char (a_t, a_x, a_y, ((((fr_trans[(a_dir // {NATURAL_32} 2).to_integer_32])[3]).to_integer_32).bit_or (32768)).to_natural_32)
				end
			end
		end

	draw_frame_lines (a_t: CE_POINTER [PD_TERMINAL]; a_fsd: CE_POINTER [PD_FRAMESET_DESC]; a_xp: INTEGER_32; a_yp: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_x: INTEGER_32
			l_y: INTEGER_32
			l_wwy: INTEGER_32
			l_wwx: INTEGER_32
			l_wwy___0: INTEGER_32
			l_wwx___0: INTEGER_32
			js: JUMP_STATE
		do
			if (a_fsd).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				l_y := a_yp - 1
				l_j := 0
				from
				until
					not (not js.loop_left and then (l_j < a_fsd.item.y))
				loop
					l_wwy := a_fsd.item.f[l_j * a_fsd.item.x].yw
					l_x := a_xp - 1
					l_i := 0
					from
					until
						not (l_i < a_fsd.item.x)
					loop
						l_wwx := a_fsd.item.f[l_i].xw
						if l_i.to_boolean then
							terminal_inst.fill_area (a_t, l_x, l_y + 1, 1, l_wwy, {NATURAL_32} 32947)
							if l_j = a_fsd.item.y - 1 then
								set_xchar (a_t, l_x, (l_y + l_wwy) + 1, {NATURAL_32} 3)
							end
						elseif l_j.to_boolean then
							set_xchar (a_t, l_x, l_y, {NATURAL_32} 0)
						end
						if l_j.to_boolean then
							terminal_inst.fill_area (a_t, l_x + 1, l_y, l_wwx, 1, {NATURAL_32} 32964)
							if l_i = a_fsd.item.x - 1 then
								set_xchar (a_t, (l_x + l_wwx) + 1, l_y, {NATURAL_32} 1)
							end
						elseif l_i.to_boolean then
							set_xchar (a_t, l_x, l_y, {NATURAL_32} 2)
						end
						if l_i.to_boolean then
							if l_j.to_boolean then
								terminal_inst.set_char (a_t, l_x, l_y, {NATURAL_32} 32965)
							end
						end
						l_x := l_x + (l_wwx + 1)
						l_i := l_i + 1
					end
					l_y := l_y + (l_wwy + 1)
					l_j := l_j + 1
				end
				l_y := a_yp - 1
				l_j := 0
				from
				until
					not (not js.loop_left and then (l_j < a_fsd.item.y))
				loop
					l_wwy___0 := a_fsd.item.f[l_j * a_fsd.item.x].yw
					l_x := a_xp - 1
					l_i := 0
					from
					until
						not (l_i < a_fsd.item.x)
					loop
						l_wwx___0 := a_fsd.item.f[l_i].xw
						if ((a_fsd.item.f[l_j * a_fsd.item.x + l_i].subframe).c_pointer /= default_pointer) then
							draw_frame_lines (a_t, a_fsd.item.f[l_j * a_fsd.item.x + l_i].subframe, l_x + 1, l_y + 1)
						end
						l_x := l_x + (l_wwx___0 + 1)
						l_i := l_i + 1
					end
					l_y := l_y + (l_wwy___0 + 1)
					l_j := l_j + 1
				end
			end
		end

	draw_doc (a_t: CE_POINTER [PD_TERMINAL]; a_scr: CE_POINTER [PD_F_DATA_C]; a_active: INTEGER_32)
		local
			l_y: INTEGER_32
			l_xp: INTEGER_32
			l_yp: INTEGER_32
			l_xw: INTEGER_32
			l_yw: INTEGER_32
			l_vs: CE_POINTER [PD_VIEW_STATE]
			l_vx: INTEGER_32
			l_vy: INTEGER_32
			l_ce: CE_POINTER [PD_CACHE_ENTRY]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_ol: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_st: INTEGER_32
			l_tmp___6: INTEGER_32
			l_en: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_vs.make
			create l_ce.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_xp := a_scr.item.xp
					l_yp := a_scr.item.yp
					l_xw := a_scr.item.xw
					l_yw := a_scr.item.yw
					if a_active.to_boolean then
						terminal_inst.set_cursor (a_t, (l_xp + l_xw) - 1, (l_yp + l_yw) - 1, (l_xp + l_xw) - 1, (l_yp + l_yw) - 1)
						terminal_inst.set_window_ptr ((terminal_inst.get_root_window (a_t)), l_xp, l_yp)
					end
					if (a_scr.item.vs).c_pointer = default_pointer then
						if ((a_scr.item.f_data).item.y).to_boolean then
							l_tmp___0 := (a_scr.item.f_data).item.bg
						else
							l_tmp___0 := (' ').code
						end
						terminal_inst.fill_area (a_t, l_xp, l_yp, l_xw, l_yw, l_tmp___0.to_natural_32)
						js.return
					end
					if not js.return_called and then (((a_scr.item.f_data).item.frame).to_boolean) then
						if ((a_scr.item.f_data).item.y).to_boolean then
							l_tmp___1 := (a_scr.item.f_data).item.bg
						else
							l_tmp___1 := (' ').code
						end
						terminal_inst.fill_area (a_t, l_xp, l_yp, l_xw, l_yw, l_tmp___1.to_natural_32)
						draw_frame_lines (a_t, (a_scr.item.f_data).item.frame_desc, l_xp, l_yp)
						if ((a_scr.item.vs).c_pointer /= default_pointer) then
							if (a_scr.item.vs).item.current_link = -1 then
								(a_scr.item.vs).item.current_link := 0;
								(a_scr.item.vs).item.orig_link := (a_scr.item.vs).item.current_link
							end
						end
						js.return
					end
					if js.return_called then
						l_pos := -1 + 27 -- skip if block
					end
				when 1 then -- if:
						check_vs (a_scr)
						l_vs.ce_gets (a_scr.item.vs)
						if ((l_vs.item.goto_position).c_pointer /= default_pointer) then
							if not (cache_inst.get_cache_entry (l_vs.item.url, l_ce.address)).to_boolean then
								l_vy := find_tag (a_scr.item.f_data, l_vs.item.goto_position)
								if l_vy /= -1 then
									if ((l_vs.item.goto_position_end).c_pointer /= default_pointer) then
										error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 798, create {CE_POINTER [ANY]}.make_cast (l_vs.item.goto_position_end))
									end
									if (l_ce.item.incomplete).to_boolean then
										l_vs.item.goto_position_end := l_vs.item.goto_position
									else
										l_vs.item.goto_position_end := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
										error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 803, create {CE_POINTER [ANY]}.make_cast (l_vs.item.goto_position))
									end
									l_vs.item.goto_position := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
									l_pos := -1 + 7 -- goto goto_vy
								end
							end
						end
				when 2 then
						if (l_vs.item.goto_position_end).c_pointer = default_pointer then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if (cache_inst.get_cache_entry (l_vs.item.url, l_ce.address)).to_boolean then
							l_pos := -1 + 8 -- skip if block
						end
				when 4 then -- if:
						if (l_ce.item.incomplete).to_boolean then
							l_pos := -1 + 8 -- skip if block
						end
				when 5 then -- if:
						l_vy := find_tag (a_scr.item.f_data, l_vs.item.goto_position_end)
						if l_vy = -1 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 809, create {CE_POINTER [ANY]}.make_cast (l_vs.item.goto_position_end))
						l_vs.item.goto_position_end := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				when 7 then -- goto_vy:
						if l_vy > (a_scr.item.f_data).item.y then
							l_vy := (a_scr.item.f_data).item.y - 1
						end
						if l_vy < 0 then
							l_vy := 0
						end
						l_vs.item.view_pos := l_vy
						l_vs.item.view_posx := 0
						l_vs.item.orig_view_pos := l_vs.item.view_pos
						l_vs.item.orig_view_posx := l_vs.item.view_posx
						set_link (a_scr)
				when 8 then -- if done | if done | if done | if done
						if l_vs.item.view_pos = l_vs.item.orig_view_pos then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 15 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 11 then -- else:
						if l_vs.item.view_posx = l_vs.item.orig_view_posx then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 15 -- goto _L
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 14 then -- else:
						if l_vs.item.current_link = l_vs.item.orig_link then
							l_pos := -1 + 16 -- skip if block
						end
				when 15 then -- if: | _L:
						l_vs.item.view_pos := l_vs.item.orig_view_pos
						l_vs.item.view_posx := l_vs.item.orig_view_posx
						l_ol := l_vs.item.orig_link
						if l_ol < (a_scr.item.f_data).item.nlinks then
							l_vs.item.current_link := l_ol
						end
						set_link (a_scr)
						check_vs (a_scr)
						l_vs.item.orig_link := l_ol
				when 16 then -- if done | if done
						l_vx := l_vs.item.view_posx
						l_vy := l_vs.item.view_pos
						if a_scr.item.xl /= l_vx then
							l_pos := -1 + 27 -- skip if block
						end
				when 17 then -- if:
						if a_scr.item.yl /= l_vy then
							l_pos := -1 + 27 -- skip if block
						end
				when 18 then -- if:
						if a_scr.item.xl = -1 then
							l_pos := -1 + 27 -- skip if block
						end
				when 19 then -- if:
						if ((a_scr.item.search_word).c_pointer /= default_pointer) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 26 -- goto _L___0
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 22 then -- else:
						if (((a_scr.item.search_word).item).c_pointer /= default_pointer) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 26 -- goto _L___0
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 25 then -- else:
						if ((a_scr.item.search_word).item[0]).to_boolean then
							l_pos := -1 + 27 -- skip if block
						end
				when 26 then -- if: | _L___0:
						clear_link (a_t, a_scr)
						draw_forms (a_t, a_scr)
						if a_active.to_boolean then
							draw_current_link (a_t, a_scr)
						end
						js.return
				when 27 then -- if done | if done | if done | if done | if done | if done
						if not js.return_called then
							free_link (a_scr)
							a_scr.item.xl := l_vx
							a_scr.item.yl := l_vy
							if ((a_scr.item.f_data).item.y).to_boolean then
								l_tmp___4 := (a_scr.item.f_data).item.bg
							else
								l_tmp___4 := (' ').code
							end
							terminal_inst.fill_area (a_t, l_xp, l_yp, l_xw, l_yw, l_tmp___4.to_natural_32)
							if not ((a_scr.item.f_data).item.y).to_boolean then
								js.return
							end
						end
						if not js.return_called then
							from
							until
								not (l_vs.item.view_pos >= (a_scr.item.f_data).item.y)
							loop
								if l_yw.to_boolean then
									l_tmp___5 := l_yw
								else
									l_tmp___5 := 1
								end
								l_vs.item.view_pos := l_vs.item.view_pos - l_tmp___5
							end
							if l_vs.item.view_pos < 0 then
								l_vs.item.view_pos := 0
							end
							if l_vy /= l_vs.item.view_pos then
								l_vy := l_vs.item.view_pos
								check_vs (a_scr)
							end
							if l_vy <= 0 then
								l_y := 0
							else
								l_y := l_vy
							end
							from
							until
								js.loop_left
							loop
								js.reset
								if -l_vy + (a_scr.item.f_data).item.y <= l_yw then
									l_tmp___8 := (a_scr.item.f_data).item.y
								else
									l_tmp___8 := l_yw + l_vy
								end
								if not (l_y < l_tmp___8) then
									js.break
								end
								if not js.loop_jumped then
									if l_vx <= 0 then
										l_tmp___6 := 0
									else
										l_tmp___6 := l_vx
									end
									l_st := l_tmp___6
									if -l_vx + ((a_scr.item.f_data).item.data + l_y).item.l <= l_xw then
										l_tmp___7 := ((a_scr.item.f_data).item.data + l_y).item.l
									else
										l_tmp___7 := l_xw + l_vx
									end
									l_en := l_tmp___7
									terminal_inst.set_line (a_t, (l_xp + l_st) - l_vx, (l_yp + l_y) - l_vy, l_en - l_st, ((a_scr.item.f_data).item.data + l_y).item.d + l_st)
									l_y := l_y + 1
								end
							end
							js.reset
							draw_forms (a_t, a_scr)
							if a_active.to_boolean then
								draw_current_link (a_t, a_scr)
							end
							if ((a_scr.item.search_word).c_pointer /= default_pointer) then
								if (((a_scr.item.search_word).item).c_pointer /= default_pointer) then
									if ((a_scr.item.search_word).item[0]).to_boolean then
										l_tmp___9 := -1
										a_scr.item.yl := l_tmp___9
										a_scr.item.xl := l_tmp___9
									end
								end
							end
						end
				when 28 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	draw_frames (a_ses: CE_POINTER [PD_SESSION])
		local
			l_n: INTEGER_32
			l_i: INTEGER_32
			l_d: INTEGER_32
			l_more: INTEGER_32
			l_l: CE_POINTER [INTEGER_32]
			l_f: CE_POINTER [PD_F_DATA_C]
			l_cf: CE_POINTER [PD_F_DATA_C]
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_l.make
			create l_f.make
			create l_cf.make

			if not (((a_ses.item.screen).item.f_data).item.frame).to_boolean then
				js.return
			end
			if not js.return_called then
				l_n := 0
				l_f.ce_gets (create {CE_POINTER [PD_F_DATA_C]}.make_cast (a_ses.item.scrn_frames.next))
				from
				until
					(l_f.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.scrn_frames_offset)).c_pointer.to_integer_32).to_natural_32
				loop
					l_tmp := -1
					l_f.item.yl := l_tmp
					l_f.item.xl := l_tmp
					l_n := l_n + 1
					l_f.ce_gets (l_f.item.next)
				end
				l_l.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared ((create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)).c_pointer + {PD_LOCATION}.vs_offset + {PD_VIEW_STATE}.current_link_offset))
				if l_l.item < 0 then
					l_l.item := 0
				end
				if not l_n.to_boolean then
					l_n := 1
				end
				l_l.item := l_l.item \\ l_n
				l_i := l_l.item
				l_cf.ce_gets (current_frame (a_ses))
				l_d := 0
				from
				until
					js.loop_left
				loop
					js.reset
					l_more := 0
					l_f.ce_gets (create {CE_POINTER [PD_F_DATA_C]}.make_cast (a_ses.item.scrn_frames.next))
					from
					until
						(l_f.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.scrn_frames_offset)).c_pointer.to_integer_32).to_natural_32
					loop
						if l_f.item.depth = l_d then
							draw_doc (a_ses.item.term, l_f, ((l_f.c_pointer.to_integer_32).to_natural_32 = (l_cf.c_pointer.to_integer_32).to_natural_32).to_integer)
						elseif l_f.item.depth > l_d then
							l_more := 1
						end
						l_f.ce_gets (l_f.item.next)
					end
					l_d := l_d + 1
					if not l_more.to_boolean then
						js.break
					end
				end
				js.reset
			end
		end

	draw_formatted (a_ses: CE_POINTER [PD_SESSION])
		local
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			if (a_ses.item.screen).c_pointer = default_pointer then
				terminal_inst.fill_area (a_ses.item.term, 0, 1, (a_ses.item.term).item.x, (a_ses.item.term).item.y - 2, ((' ').code).to_natural_32)
				js.return
			elseif ((a_ses.item.screen).item.f_data).c_pointer = default_pointer then
				terminal_inst.fill_area (a_ses.item.term, 0, 1, (a_ses.item.term).item.x, (a_ses.item.term).item.y - 2, ((' ').code).to_natural_32)
				js.return
			end
			if not js.return_called then
				if ((a_ses.item.screen).item.vs).c_pointer = default_pointer then
					if ((a_ses.item.history.next).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
						(a_ses.item.screen).item.vs := create {CE_POINTER [PD_VIEW_STATE]}.make_shared ((create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)).c_pointer + {PD_LOCATION}.vs_offset)
					end
				end
				l_tmp := -1;
				(a_ses.item.screen).item.yl := l_tmp;
				(a_ses.item.screen).item.xl := l_tmp
				draw_doc (a_ses.item.term, a_ses.item.screen, 1)
				draw_frames (a_ses)
				session_inst.print_screen_status (a_ses)
				terminal_inst.redraw_from_window (a_ses.item.win)
			end
		end

	dump_to_file (a_fd: CE_POINTER [PD_F_DATA]; a_h: INTEGER_32): INTEGER_32
		local
			l_x: INTEGER_32
			l_y: INTEGER_32
			l_buf___0: CE_POINTER [NATURAL_8]
			l_bptr: INTEGER_32
			l_c: INTEGER_32
			l_tmp___0: INTEGER_32
			l_i: INTEGER_32
			l_tmp___4: INTEGER_32
			l_lnk: CE_POINTER [PD_LINK]
			l_s: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_fc: CE_POINTER [PD_FORM_CONTROL]
			l_fc___0: CE_POINTER [PD_FORM_CONTROL]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___0.make
			create l_lnk.make
			create l_s.make
			create l_fc.make
			create l_fc___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_bptr := 0
					l_buf___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 907, (65536).to_natural_32))))
					l_y := 0
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_y < a_fd.item.y)) then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						l_x := 0
				when 3 then -- loop condition:
						if not (l_x <= (a_fd.item.data + l_y).item.l) then
							l_pos := -1 + 8 -- skip loop
						end
				when 4 then -- loop body:
						if l_x = (a_fd.item.data + l_y).item.l then
							l_c := ('%N').code
						else
							l_c := ((a_fd.item.data + l_y).item.d[l_x]).to_integer_32
							if ((l_c).bit_and (255)) = 1 then
								l_c := l_c + (31)
							end
							if ((l_c).bit_shift_right (15)).to_boolean then
								if ((l_c).bit_and (255)) >= 176 then
									if ((l_c).bit_and (255)) < 224 then
										l_c := (terminal_inst.frame_dumb[((l_c).bit_and (255)) - 176]).to_integer_32
									end
								end
							end
						end
						l_tmp___0 := l_bptr
						l_bptr := l_bptr + 1
						l_buf___0[l_tmp___0] := l_c.to_natural_8
						if not (l_bptr >= 65536) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (terminal_inst.hard_write (a_h, l_buf___0, l_bptr)) /= l_bptr then
							l_pos := -1 + 10 -- goto fail
						end
				when 6 then
						l_bptr := 0
				when 7 then -- if done
						l_x := l_x + 1
						l_pos := -1 + 3 -- back to loop condition
				when 8 then -- loop done
						l_y := l_y + 1
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
					if (terminal_inst.hard_write (a_h, l_buf___0, l_bptr)) = l_bptr then
						l_pos := -1 + 11 -- skip if block
					end
				when 10 then -- if: | fail:
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 923, create {CE_POINTER [ANY]}.make_cast (l_buf___0))
						Result := (-1)
						js.return
				when 11 then -- if done
					if js.return_called then
						l_pos := -1 + 43 -- skip if block
					end
				when 12 then -- if:
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 926, create {CE_POINTER [ANY]}.make_cast (l_buf___0))
						if not ((a_fd.item.opt.num_links).to_boolean) then
							l_pos := -1 + 43 -- skip if block
						end
				when 13 then -- if:
						if not ((a_fd.item.nlinks).to_boolean) then
							l_pos := -1 + 43 -- skip if block
						end
				when 14 then -- if:
						l_tmp___4 := terminal_inst.hard_write (a_h, create {CE_POINTER [NATURAL_8]}.make_cast (head), (strlen (head)).to_integer_32)
						if l_tmp___4 /= (strlen (head)).to_integer_32 then
							Result := (-1)
							js.return
						end
						if js.return_called then
							l_pos := -1 + 43 -- skip if block
						end
				when 15 then -- if:
						l_i := 0
				when 16 then -- loop condition:
						if not (not js.loop_left and then (l_i < a_fd.item.nlinks)) then
							l_pos := -1 + 43 -- skip loop
						end
				when 17 then -- loop body:
						l_lnk.ce_gets (a_fd.item.links + l_i)
						l_s.ce_gets ((links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 933)))
						l_l := 0
						links_inst.add_num_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (l_i + 1).to_integer_32)
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (". ")))
						if (l_lnk.item.where).c_pointer = default_pointer then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_lnk.item.where)
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 20 then -- else:
						if (l_lnk.item.where_img).c_pointer = default_pointer then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Image: ")))
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_lnk.item.where_img)
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 23 then -- else:
						if l_lnk.item.type /= 1 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_fc.ce_gets (l_lnk.item.form)
						if l_fc.item.type = 10 then
							links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Reset form")))
						elseif (l_fc.item.action).c_pointer = default_pointer then
							links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Button")))
						else
							if (l_fc.item.method).to_boolean then
								links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Submit form: ")))
							else
								links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Post form: ")))
							end
							links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_fc.item.action)
						end
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 26 then -- else:
						if l_lnk.item.type /= 2 then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						l_pos := -1 + 36 -- goto _L___0
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 29 then -- else:
						if l_lnk.item.type /= 3 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						l_pos := -1 + 36 -- goto _L___0
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 32 then -- else:
						if l_lnk.item.type /= 4 then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 36 -- goto _L___0
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 35 then -- else:
						if l_lnk.item.type /= 5 then
							l_pos := -1 + 42 -- skip if block
						end
				when 36 then -- if: | _L___0:
						l_fc___0.ce_gets (l_lnk.item.form)
						if l_fc___0.item.type = 6 then
							links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Radio button")))
						elseif l_fc___0.item.type = 5 then
							links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Checkbox")))
						elseif l_fc___0.item.type = 7 then
							links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Select field")))
						elseif l_fc___0.item.type = 1 then
							links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Text field")))
						elseif l_fc___0.item.type = 4 then
							links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Text area")))
						elseif l_fc___0.item.type = 3 then
							links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("File upload")))
						elseif l_fc___0.item.type = 2 then
							links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Password field")))
						else
							l_pos := -1 + 42 -- goto unknown
						end
				when 37 then
						if ((l_fc___0.item.name).c_pointer /= default_pointer) then
							if (l_fc___0.item.name[0]).to_boolean then
								links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (", Name ")))
								links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_fc___0.item.name)
							end
						end
						if l_fc___0.item.type /= 5 then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						l_pos := -1 + 41 -- goto _L
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 40 then -- else:
						if l_fc___0.item.type /= 6 then
							l_pos := -1 + 42 -- skip if block
						end
				when 41 then -- if: | _L:
						if ((l_fc___0.item.default_value).c_pointer /= default_pointer) then
							if (l_fc___0.item.default_value[0]).to_boolean then
								links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (", Value ")))
								links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_fc___0.item.default_value)
							end
						end
				when 42 then -- if done | if done | if done | if done | if done | if done | if done | if done | unknown:
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
						if (terminal_inst.hard_write (a_h, l_s, l_l)) /= l_l then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 967, create {CE_POINTER [ANY]}.make_cast (l_s))
							Result := (-1)
							js.return
						end
						if not js.return_called then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 970, create {CE_POINTER [ANY]}.make_cast (l_s))
							l_i := l_i + 1
						end
						l_pos := -1 + 16 -- back to loop condition
				when 43 then -- loop done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 44 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	in_viewx (a_f: CE_POINTER [PD_F_DATA_C]; a_l: CE_POINTER [PD_LINK]): INTEGER_32
		local
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			l_i := 0
			from
			until
				not (not js.loop_left and then (l_i < a_l.item.n))
			loop
				if (a_l.item.pos + l_i).item.x >= (a_f.item.vs).item.view_posx then
					if (a_l.item.pos + l_i).item.x < (a_f.item.vs).item.view_posx + a_f.item.xw then
						Result := 1
						js.return
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	in_viewy (a_f: CE_POINTER [PD_F_DATA_C]; a_l: CE_POINTER [PD_LINK]): INTEGER_32
		local
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			l_i := 0
			from
			until
				not (not js.loop_left and then (l_i < a_l.item.n))
			loop
				if (a_l.item.pos + l_i).item.y >= (a_f.item.vs).item.view_pos then
					if (a_l.item.pos + l_i).item.y < (a_f.item.vs).item.view_pos + a_f.item.yw then
						Result := 1
						js.return
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	in_viewy_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent in_viewy)
		end

	in_view (a_f: CE_POINTER [PD_F_DATA_C]; a_l: CE_POINTER [PD_LINK]): INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if (in_viewy (a_f, a_l)).to_boolean then
				if (in_viewx (a_f, a_l)).to_boolean then
					l_tmp___1 := 1
				else
					l_tmp___1 := 0
				end
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	in_view_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent in_view)
		end

	c2_in_view (a_f: CE_POINTER [PD_F_DATA_C]): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (a_f.item.vs).item.current_link /= -1 then
				if (in_view (a_f, (a_f.item.f_data).item.links + (a_f.item.vs).item.current_link)).to_boolean then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	next_in_view (a_f: CE_POINTER [PD_F_DATA_C]; a_p: INTEGER_32; a_d: INTEGER_32; a_fn: CE_ROUTINE; a_cntr: CE_ROUTINE): INTEGER_32
		local
			l_p: INTEGER_32
			l_p1___0: INTEGER_32
			l_p2___0: INTEGER_32
			l_y: INTEGER_32
			l_yl: INTEGER_32
			js: JUMP_STATE
		do
			l_p := a_p
			l_p1___0 := (a_f.item.f_data).item.nlinks - 1
			l_p2___0 := 0
			l_yl := (a_f.item.vs).item.view_pos + a_f.item.yw
			if l_yl > (a_f.item.f_data).item.y then
				l_yl := (a_f.item.f_data).item.y
			end
			if (a_f.item.vs).item.view_pos < 0 then
				l_y := 0
			else
				l_y := (a_f.item.vs).item.view_pos
			end
			from
			until
				not (l_y < l_yl)
			loop
				if (((a_f.item.f_data).item.lines1[l_y]).c_pointer /= default_pointer) then
					if ((a_f.item.f_data).item.lines1[l_y]).distance (((a_f.item.f_data).item.links)) < l_p1___0 then
						l_p1___0 := ((a_f.item.f_data).item.lines1[l_y]).distance (((a_f.item.f_data).item.links))
					end
				end
				if (((a_f.item.f_data).item.lines2[l_y]).c_pointer /= default_pointer) then
					if ((a_f.item.f_data).item.lines2[l_y]).distance (((a_f.item.f_data).item.links)) > l_p2___0 then
						l_p2___0 := ((a_f.item.f_data).item.lines2[l_y]).distance (((a_f.item.f_data).item.links))
					end
				end
				l_y := l_y + 1
			end
			from
			until
				js.loop_left
			loop
				js.reset
				if l_p >= l_p1___0 then
					if not (l_p <= l_p2___0) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if (a_fn.integer_32_item ([a_f, (a_f.item.f_data).item.links + l_p])).to_boolean then
						(a_f.item.vs).item.current_link := l_p;
						(a_f.item.vs).item.orig_link := (a_f.item.vs).item.current_link
						if ((a_cntr).c_pointer /= default_pointer) then
							a_cntr.call ([a_f, (a_f.item.f_data).item.links + l_p])
						end
						Result := 1
						js.return
					end
					if not js.return_called then
						l_p := l_p + a_d
					end
				end
			end
			js.reset
			if not js.return_called then
				(a_f.item.vs).item.current_link := -1;
				(a_f.item.vs).item.orig_link := (a_f.item.vs).item.current_link
				Result := 0
			end
		end

	set_pos_x (a_f: CE_POINTER [PD_F_DATA_C]; a_l: CE_POINTER [PD_LINK])
		local
			l_i: INTEGER_32
			l_xm: INTEGER_32
			l_xl: INTEGER_32
			js: JUMP_STATE
		do
			l_xm := 0
			l_xl := 2147483647
			l_i := 0
			from
			until
				not (l_i < a_l.item.n)
			loop
				if (a_l.item.pos + l_i).item.y >= (a_f.item.vs).item.view_pos then
					if (a_l.item.pos + l_i).item.y < (a_f.item.vs).item.view_pos + a_f.item.yw then
						if (a_l.item.pos + l_i).item.x >= l_xm then
							l_xm := (a_l.item.pos + l_i).item.x + 1
						end
						if (a_l.item.pos + l_i).item.x < l_xl then
							l_xl := (a_l.item.pos + l_i).item.x
						end
					end
				end
				l_i := l_i + 1
			end
			if l_xl = 2147483647 then
				js.return
			end
			if not js.return_called then
				if (a_f.item.vs).item.view_posx + a_f.item.xw < l_xm then
					(a_f.item.vs).item.view_posx := l_xm - a_f.item.xw
				end
				if (a_f.item.vs).item.view_posx > l_xl then
					(a_f.item.vs).item.view_posx := l_xl
				end
				(a_f.item.vs).item.orig_view_posx := (a_f.item.vs).item.view_posx
			end
		end

	set_pos_x_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent set_pos_x)
		end

	set_pos_y (a_f: CE_POINTER [PD_F_DATA_C]; a_l: CE_POINTER [PD_LINK])
		local
			l_i: INTEGER_32
			l_ym: INTEGER_32
			l_yl: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_ym := 0
			l_yl := (a_f.item.f_data).item.y
			l_i := 0
			from
			until
				not (l_i < a_l.item.n)
			loop
				if (a_l.item.pos + l_i).item.y >= l_ym then
					l_ym := (a_l.item.pos + l_i).item.y + 1
				end
				if (a_l.item.pos + l_i).item.y < l_yl then
					l_yl := (a_l.item.pos + l_i).item.y
				end
				l_i := l_i + 1
			end
			l_tmp := (l_ym + l_yl) // 2 - (a_f.item.f_data).item.opt.yw // 2;
			(a_f.item.vs).item.view_pos := l_tmp
			if l_tmp > (a_f.item.f_data).item.y - (a_f.item.f_data).item.opt.yw then
				(a_f.item.vs).item.view_pos := (a_f.item.f_data).item.y - (a_f.item.f_data).item.opt.yw
			end
			if (a_f.item.vs).item.view_pos < 0 then
				(a_f.item.vs).item.view_pos := 0
			end
			(a_f.item.vs).item.orig_view_pos := (a_f.item.vs).item.view_pos
		end

	find_link (a_f: CE_POINTER [PD_F_DATA_C]; a_p: INTEGER_32; a_s: INTEGER_32)
		local
			l_y: INTEGER_32
			l_l: INTEGER_32
			l_link___0: CE_POINTER [PD_LINK]
			l_line: CE_POINTER [CE_POINTER [PD_LINK]]
			l_tmp: CE_POINTER [CE_POINTER [PD_LINK]]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_link___0.make
			create l_line.make
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_p = -1 then
						l_tmp.ce_gets ((a_f.item.f_data).item.lines2)
					else
						l_tmp.ce_gets ((a_f.item.f_data).item.lines1)
					end
					l_line.ce_gets (l_tmp)
					if a_p = -1 then
						l_y := ((a_f.item.vs).item.view_pos + a_f.item.yw) - 1
						if l_y >= (a_f.item.f_data).item.y then
							l_y := (a_f.item.f_data).item.y - 1
						end
					else
						l_y := (a_f.item.vs).item.view_pos
						if l_y < 0 then
							l_y := 0
						end
					end
					if l_y < 0 then
						l_pos := -1 + 3 -- goto nolink
					elseif l_y >= (a_f.item.f_data).item.y then
						l_pos := -1 + 3 -- goto nolink
					end
				when 1 then
					l_link___0.ce_gets (create {CE_POINTER [PD_LINK]}.make_shared (default_pointer))
					from
					until
						js.loop_left
					loop
						js.reset
						if ((l_line[l_y]).c_pointer /= default_pointer) then
							if (l_link___0).c_pointer = default_pointer then
								l_link___0.ce_gets (l_line[l_y])
							else
								if a_p > 0 then
									l_tmp___0 := (((l_line[l_y]).c_pointer.to_integer_32).to_natural_32 < (l_link___0.c_pointer.to_integer_32).to_natural_32).to_integer
								else
									l_tmp___0 := (((l_line[l_y]).c_pointer.to_integer_32).to_natural_32 > (l_link___0.c_pointer.to_integer_32).to_natural_32).to_integer
								end
								if l_tmp___0.to_boolean then
									l_link___0.ce_gets (l_line[l_y])
								end
							end
						end
						l_y := l_y + a_p
						if l_y < 0 then
							js.break
						elseif l_y < (a_f.item.vs).item.view_pos then
							js.break
						elseif l_y >= (a_f.item.vs).item.view_pos + (a_f.item.f_data).item.opt.yw then
							js.break
						elseif l_y >= (a_f.item.f_data).item.y then
							js.break
						end
					end
					js.reset
					if (l_link___0).c_pointer = default_pointer then
						l_pos := -1 + 3 -- goto nolink
					end
				when 2 then
					l_l := l_link___0.distance (((a_f.item.f_data).item.links))
					if a_s = 0 then
						next_in_view (a_f, l_l, a_p, in_view_address, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
						js.return
					end
					if not js.return_called then
						(a_f.item.vs).item.current_link := l_l;
						(a_f.item.vs).item.orig_link := (a_f.item.vs).item.current_link
						set_pos_x (a_f, l_link___0)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 4 -- skip if block
					end
				when 3 then -- if: | nolink:;
						(a_f.item.vs).item.current_link := -1;
						(a_f.item.vs).item.orig_link := (a_f.item.vs).item.current_link
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	page_down (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		do
			if (a_f.item.vs).item.view_pos + (a_f.item.f_data).item.opt.yw < (a_f.item.f_data).item.y then
				(a_f.item.vs).item.view_pos := (a_f.item.vs).item.view_pos + ((a_f.item.f_data).item.opt.yw);
				(a_f.item.vs).item.orig_view_pos := (a_f.item.vs).item.view_pos
				find_link (a_f, 1, a_a)
			else
				find_link (a_f, -1, a_a)
			end
		end

	page_down_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent page_down)
		end

	page_up (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		do
			(a_f.item.vs).item.view_pos := (a_f.item.vs).item.view_pos - (a_f.item.yw)
			find_link (a_f, -1, a_a)
			if (a_f.item.vs).item.view_pos < 0 then
				(a_f.item.vs).item.view_pos := 0
			end
			(a_f.item.vs).item.orig_view_pos := (a_f.item.vs).item.view_pos
		end

	page_up_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent page_up)
		end

	down (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		local
			l_l: INTEGER_32
		do
			l_l := (a_f.item.vs).item.current_link
			if (a_f.item.vs).item.current_link = -1 then
				page_down (a_ses, a_f, 1)
			elseif not (next_in_view (a_f, (a_f.item.vs).item.current_link + 1, 1, in_viewy_address, set_pos_x_address)).to_boolean then
				page_down (a_ses, a_f, 1)
			end
			if l_l /= (a_f.item.vs).item.current_link then
				set_textarea (a_ses, a_f, 262)
			end
		end

	down_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent down)
		end

	up (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		local
			l_l: INTEGER_32
		do
			l_l := (a_f.item.vs).item.current_link
			if (a_f.item.vs).item.current_link = -1 then
				page_up (a_ses, a_f, 1)
			elseif not (next_in_view (a_f, (a_f.item.vs).item.current_link - 1, -1, in_viewy_address, set_pos_x_address)).to_boolean then
				page_up (a_ses, a_f, 1)
			end
			if l_l /= (a_f.item.vs).item.current_link then
				set_textarea (a_ses, a_f, 263)
			end
		end

	up_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent up)
		end

	scroll_dirty_workaround_for_name_clash_with_libraries_on_macos (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		local
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			if (a_f.item.vs).item.view_pos + (a_f.item.f_data).item.opt.yw >= (a_f.item.f_data).item.y then
				if a_a > 0 then
					js.return
				end
			end
			if not js.return_called then
				(a_f.item.vs).item.view_pos := (a_f.item.vs).item.view_pos + a_a
				if (a_f.item.vs).item.view_pos > (a_f.item.f_data).item.y - (a_f.item.f_data).item.opt.yw then
					if a_a > 0 then
						(a_f.item.vs).item.view_pos := (a_f.item.f_data).item.y - (a_f.item.f_data).item.opt.yw
					end
				end
				if (a_f.item.vs).item.view_pos < 0 then
					(a_f.item.vs).item.view_pos := 0
				end
				(a_f.item.vs).item.orig_view_pos := (a_f.item.vs).item.view_pos
				if (c2_in_view (a_f)).to_boolean then
					js.return
				end
			end
			if not js.return_called then
				if a_a < 0 then
					l_tmp___0 := -1
				else
					l_tmp___0 := 1
				end
				find_link (a_f, l_tmp___0, 0)
			end
		end

	scroll_dirty_workaround_for_name_clash_with_libraries_on_macos_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent scroll_dirty_workaround_for_name_clash_with_libraries_on_macos)
		end

	hscroll (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		local
			js: JUMP_STATE
		do
			(a_f.item.vs).item.view_posx := (a_f.item.vs).item.view_posx + a_a
			if (a_f.item.vs).item.view_posx >= (a_f.item.f_data).item.x then
				(a_f.item.vs).item.view_posx := (a_f.item.f_data).item.x - 1
			end
			if (a_f.item.vs).item.view_posx < 0 then
				(a_f.item.vs).item.view_posx := 0
			end
			(a_f.item.vs).item.orig_view_posx := (a_f.item.vs).item.view_posx
			if (c2_in_view (a_f)).to_boolean then
				js.return
			end
			if not js.return_called then
				find_link (a_f, 1, 0)
			end
		end

	hscroll_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent hscroll)
		end

	home (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		local
			l_tmp: INTEGER_32
		do
			l_tmp := 0;
			(a_f.item.vs).item.view_posx := l_tmp;
			(a_f.item.vs).item.view_pos := l_tmp;
			(a_f.item.vs).item.orig_view_posx := (a_f.item.vs).item.view_posx;
			(a_f.item.vs).item.orig_view_pos := (a_f.item.vs).item.view_pos
			find_link (a_f, 1, 0)
		end

	home_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent home)
		end

	x_end (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		do
			(a_f.item.vs).item.view_posx := 0
			if (a_f.item.vs).item.view_pos < (a_f.item.f_data).item.y - (a_f.item.f_data).item.opt.yw then
				(a_f.item.vs).item.view_pos := (a_f.item.f_data).item.y - (a_f.item.f_data).item.opt.yw
			end
			if (a_f.item.vs).item.view_pos < 0 then
				(a_f.item.vs).item.view_pos := 0
			end
			(a_f.item.vs).item.orig_view_pos := (a_f.item.vs).item.view_pos;
			(a_f.item.vs).item.orig_view_posx := (a_f.item.vs).item.view_posx
			find_link (a_f, -1, 0)
		end

	x_end_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent x_end)
		end

	has_form_submit (a_f: CE_POINTER [PD_F_DATA]; a_form___0: CE_POINTER [PD_FORM_CONTROL]): INTEGER_32
		local
			l_i: CE_POINTER [PD_FORM_CONTROL]
			l_q: INTEGER_32
			js: JUMP_STATE
		do
			create l_i.make

			l_q := 0
			l_i.ce_gets (create {CE_POINTER [PD_FORM_CONTROL]}.make_cast (a_f.item.forms.next))
			from
			until
				not (not js.loop_left and then ((l_i.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_f.c_pointer + {PD_F_DATA}.forms_offset)).c_pointer.to_integer_32).to_natural_32))
			loop
				if l_i.item.form_num = a_form___0.item.form_num then
					if l_i.item.type = 8 then
						Result := 1
						js.return
					elseif l_i.item.type = 9 then
						Result := 1
						js.return
					end
					if not js.return_called then
						l_q := 1
					end
				end
				if not js.return_called then
					l_i.ce_gets (l_i.item.next)
				end
			end
			if not js.return_called then
				if not l_q.to_boolean then
					from
					until
						False
					loop
						links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")))
						links_inst.errline := 1178
						error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("form is not on list"))])
					end
				end
				Result := 0
			end
		end

	decrement_fc_refcount (a_f: CE_POINTER [PD_F_DATA])
		do
			a_f.item.refcount := (a_f.item.refcount) - 1
			if not (a_f.item.refcount).to_boolean then
				html_r_inst.format_cache_entries := html_r_inst.format_cache_entries + 1
			end
		end

	decrement_fc_refcount_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent decrement_fc_refcount)
		end

	free_succesful_controls (a_submit: CE_POINTER [PD_LIST_HEAD])
		local
			l_v: CE_POINTER [PD_SUBMITTED_VALUE]
			l_a__: CE_POINTER [PD_XLIST_HEAD]
		do
			create l_v.make
			create l_a__.make

			l_v.ce_gets (create {CE_POINTER [PD_SUBMITTED_VALUE]}.make_cast (a_submit.item.next))
			from
			until
				(l_v.c_pointer.to_integer_32).to_natural_32 = (a_submit.c_pointer.to_integer_32).to_natural_32
			loop
				if ((l_v.item.name).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1202, create {CE_POINTER [ANY]}.make_cast (l_v.item.name))
				end
				if ((l_v.item.value).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1203, create {CE_POINTER [ANY]}.make_cast (l_v.item.value))
				end
				if ((l_v.item.file_content).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1204, l_v.item.file_content)
				end
				l_v.ce_gets (l_v.item.next)
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_submit))
			l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_submit.item.next))
			from
			until
				(l_a__.c_pointer.to_integer_32).to_natural_32 = (a_submit.c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__.ce_gets (l_a__.item.next)
			end
			l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_submit.item.prev))
			from
			until
				(l_a__.c_pointer.to_integer_32).to_natural_32 = (a_submit.c_pointer.to_integer_32).to_natural_32
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__.ce_gets (l_a__.item.prev)
			end
			from
			until
				((a_submit.item.next).c_pointer.to_integer_32).to_natural_32 = (a_submit.c_pointer.to_integer_32).to_natural_32
			loop
				l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (a_submit.item.next))
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a__.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a__.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1206, create {CE_POINTER [ANY]}.make_cast (l_a__))
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_submit))
		end

	encode_textarea (a_t: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_t: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_o: CE_POINTER [NATURAL_8]
		do
			create l_t.make
			create l_o.make

			l_t.ce_gets (a_t)
			l_len := 0
			l_o.ce_gets ((links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1212)))
			from
			until
				not ((l_t.item).to_boolean)
			loop
				if (l_t.item).to_integer_32 /= 10 then
					links_inst.add_chr_to_str (l_o.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_len), l_t.item)
				else
					links_inst.add_to_str (l_o.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_len), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%N")))
				end
				l_t.ce_gets (l_t + 1)
			end
			Result := l_o
		end

	compare_submitted (a_sub1: CE_POINTER [PD_SUBMITTED_VALUE]; a_sub2: CE_POINTER [PD_SUBMITTED_VALUE]): INTEGER_32
		do
			Result := (a_sub1.item.position - a_sub2.item.position)
		end

	get_succesful_controls (a_f: CE_POINTER [PD_F_DATA_C]; a_fc: CE_POINTER [PD_FORM_CONTROL]; a_subm: CE_POINTER [PD_LIST_HEAD])
		local
			l_ch: INTEGER_32
			l_form___0: CE_POINTER [PD_FORM_CONTROL]
			l_sub: CE_POINTER [PD_SUBMITTED_VALUE]
			l_fs: CE_POINTER [PD_FORM_STATE]
			l_fi: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_sub___0: CE_POINTER [PD_SUBMITTED_VALUE]
			l_nx: CE_POINTER [PD_SUBMITTED_VALUE]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_form___0.make
			create l_sub.make
			create l_fs.make
			create l_tmp___1.make
			create l_sub___0.make
			create l_nx.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_subm))
					a_subm.item.next := create {CE_POINTER [ANY]}.make_cast (a_subm)
					a_subm.item.prev := create {CE_POINTER [ANY]}.make_cast (a_subm)
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_subm))
					l_form___0.ce_gets (create {CE_POINTER [PD_FORM_CONTROL]}.make_cast ((a_f.item.f_data).item.forms.next))
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_form___0.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((a_f.item.f_data).c_pointer + {PD_F_DATA}.forms_offset)).c_pointer.to_integer_32).to_natural_32)) then
						l_pos := -1 + 26 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if l_form___0.item.form_num /= a_fc.item.form_num then
							l_pos := -1 + 25 -- skip if block
						end
				when 3 then -- if:
						if l_form___0.item.type = 8 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_form___0.item.type /= 9 then
							if l_form___0.item.type /= 10 then
								l_pos := -1 + 7 -- goto _L___0
							else
								l_pos := -1 + 6 -- goto _L___2
							end
						else
							l_pos := -1 + 6 -- goto _L___2
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 6 then -- else: | _L___2:
						if (l_form___0.c_pointer.to_integer_32).to_natural_32 /= (a_fc.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 25 -- skip if block
						end
				when 7 then -- if: | _L___0:
						if (l_form___0.item.name).c_pointer = default_pointer then
							l_pos := -1 + 25 -- skip if block
						end
				when 8 then -- if:
						if not ((l_form___0.item.name[0]).to_boolean) then
							l_pos := -1 + 25 -- skip if block
						end
				when 9 then -- if:
						if l_form___0.item.type = 9 then
							if ((l_form___0.item.default_value).c_pointer /= default_pointer) then
								if ((l_form___0.item.default_value).item).to_boolean then
									l_tmp := -1
								else
									l_tmp := 0
								end
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
						l_fi := l_tmp
						l_fs.ce_gets (find_form_state (a_f, l_form___0))
						if (l_fs).c_pointer = default_pointer then
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if:
						if l_form___0.item.type /= 5 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 13 then -- else:
						if l_form___0.item.type /= 6 then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L:
						if not (l_fs.item.state).to_boolean then
							js.continue
						end
				when 15 then -- if done | if done
						if not js.loop_jumped and then (l_form___0.item.type = 7) then
							if not (l_form___0.item.nvalues).to_boolean then
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 24 -- skip if block
						end
				when 16 then -- if: | fi_rep:
						l_sub.ce_gets (create {CE_POINTER [PD_SUBMITTED_VALUE]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1242, {PD_SUBMITTED_VALUE}.sizeof.to_natural_32))))
						memset (create {CE_POINTER [ANY]}.make_cast (l_sub), 0, {PD_SUBMITTED_VALUE}.sizeof.to_natural_32).do_nothing
						l_sub.item.type := l_form___0.item.type
						l_sub.item.name := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1245, l_form___0.item.name)
						inspect l_form___0.item.type -- switch 1 head
						when 1 then l_pos := -1 + 17
						when 2 then l_pos := -1 + 17
						when 3 then l_pos := -1 + 17
						when 4 then l_pos := -1 + 18
						when 5 then l_pos := -1 + 19
						when 6 then l_pos := -1 + 19
						when 8 then l_pos := -1 + 19
						when 11 then l_pos := -1 + 19
						when 7 then l_pos := -1 + 20
						when 9 then l_pos := -1 + 21
						else l_pos := -1 + 23
						end
				when 17 then -- switch 1, case 1 | switch 1, case 2 | switch 1, case 3
						l_sub.item.value := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1250, l_fs.item.value)
						l_pos := -1 + 24 -- switch 1; break
				when 18 then -- switch 1, case 4
						l_sub.item.value := encode_textarea (l_fs.item.value)
						l_pos := -1 + 24 -- switch 1; break
				when 19 then -- switch 1, case 5 | switch 1, case 6 | switch 1, case 8 | switch 1, case 11
						l_sub.item.value := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1259, l_form___0.item.default_value)
						l_pos := -1 + 24 -- switch 1; break
				when 20 then -- switch 1, case 7
						fixup_select_state (l_form___0, l_fs)
						l_sub.item.value := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1263, l_fs.item.value)
						l_pos := -1 + 24 -- switch 1; break
				when 21 then -- switch 1, case 9
						if l_fi = -1 then
							l_sub.item.value := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1267, l_form___0.item.default_value)
							l_pos := -1 + 24 -- switch 1; break
						end
				when 22 then
						if l_fi.to_boolean then
							l_tmp___1.ce_gets (ce_string (".x"))
						else
							l_tmp___1.ce_gets (ce_string (".y"))
						end
						links_inst.add_to_strn (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_sub.c_pointer + {PD_SUBMITTED_VALUE}.name_offset), create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___1))
						l_sub.item.value := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1271, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("1")))
						l_pos := -1 + 24 -- switch 1; break
				when 23 then -- switch 1, default:
						from
						until
							False
						loop
							links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")))
							links_inst.errline := 1274
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bad form control type"))])
						end
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1275, create {CE_POINTER [ANY]}.make_cast (l_sub))
						js.continue
				when 24 then -- switch 1, done: | if done
						if not js.loop_jumped then
							l_sub.item.position := l_form___0.item.form_num + l_form___0.item.ctrl_num
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_subm))
								l_sub.item.next := (create {CE_POINTER [PD_SUBMITTED_VALUE]}.make_cast (a_subm)).item.next
								l_sub.item.prev := create {CE_POINTER [PD_SUBMITTED_VALUE]}.make_cast (a_subm);
								(create {CE_POINTER [PD_SUBMITTED_VALUE]}.make_cast (a_subm)).item.next := l_sub;
								(l_sub.item.next).item.prev := l_sub
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (a_subm))
								js.break
							end
							js.reset
							if l_form___0.item.type = 9 then
								if l_fi < 1 then
									l_fi := l_fi + 1
									l_pos := -1 + 16 -- goto fi_rep
								end
							end
						end
				when 25 then -- if done | if done | if done | if done
						if not js.loop_left then
							l_form___0.ce_gets (l_form___0.item.next)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 26 then -- loop done
					from
					until
						js.loop_left
					loop
						js.reset
						l_ch := 0
						l_sub___0.ce_gets (create {CE_POINTER [PD_SUBMITTED_VALUE]}.make_cast (a_subm.item.next))
						from
						until
							not (not js.loop_left and then ((l_sub___0.c_pointer.to_integer_32).to_natural_32 /= (a_subm.c_pointer.to_integer_32).to_natural_32))
						loop
							if ((l_sub___0.item.next).c_pointer.to_integer_32).to_natural_32 /= (a_subm.c_pointer.to_integer_32).to_natural_32 then
								if (l_sub___0.item.next).item.position < l_sub___0.item.position then
									l_nx.ce_gets (l_sub___0.item.next)
									error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_sub___0));
									(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_sub___0.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_sub___0.item.prev);
									(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_sub___0.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_sub___0.item.next)
									error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_sub___0))
									from
									until
										js.loop_left
									loop
										js.reset
										error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_nx))
										l_sub___0.item.next := l_nx.item.next
										l_sub___0.item.prev := l_nx
										l_nx.item.next := l_sub___0;
										(l_sub___0.item.next).item.prev := l_sub___0
										error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_nx))
										js.break
									end
									js.reset
									l_sub___0.ce_gets (l_nx)
									l_ch := 1
								end
							end
							l_sub___0.ce_gets (l_sub___0.item.next)
						end
						l_sub___0.ce_gets (create {CE_POINTER [PD_SUBMITTED_VALUE]}.make_cast (a_subm.item.prev))
						from
						until
							not (not js.loop_left and then ((l_sub___0.c_pointer.to_integer_32).to_natural_32 /= (a_subm.c_pointer.to_integer_32).to_natural_32))
						loop
							if ((l_sub___0.item.next).c_pointer.to_integer_32).to_natural_32 /= (a_subm.c_pointer.to_integer_32).to_natural_32 then
								if (l_sub___0.item.next).item.position < l_sub___0.item.position then
									l_nx.ce_gets (l_sub___0.item.next)
									error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_sub___0));
									(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_sub___0.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_sub___0.item.prev);
									(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_sub___0.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_sub___0.item.next)
									error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_sub___0))
									from
									until
										js.loop_left
									loop
										js.reset
										error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_nx))
										l_sub___0.item.next := l_nx.item.next
										l_sub___0.item.prev := l_nx
										l_nx.item.next := l_sub___0;
										(l_sub___0.item.next).item.prev := l_sub___0
										error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_nx))
										js.break
									end
									js.reset
									l_sub___0.ce_gets (l_nx)
									l_ch := 1
								end
							end
							l_sub___0.ce_gets (l_sub___0.item.prev)
						end
						if not l_ch.to_boolean then
							js.break
						end
					end
					js.reset
				when 27 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	strip_file_name (a_f: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_n: CE_POINTER [NATURAL_8]
			l_l: CE_POINTER [NATURAL_8]
		do
			create l_n.make
			create l_l.make

			l_l.ce_gets (a_f - 1)
			l_n.ce_gets (a_f)
			from
			until
				not ((l_n.item).to_boolean)
			loop
				if (os_dep_inst.dir_sep ((l_n.item).to_integer_8)).to_boolean then
					l_l.ce_gets (l_n)
				end
				l_n.ce_gets (l_n + 1)
			end
			Result := (l_l + 1)
		end

	safe_char (a_c: NATURAL_8): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_c.to_integer_32 >= 48) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_c.to_integer_32 <= 57 then
							l_tmp := 1
						else
							l_pos := -1 + 3 -- goto _L___1
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else: | _L___1:
						if not (a_c.to_integer_32 >= 65) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_c.to_integer_32 <= 90 then
							l_tmp := 1
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else: | _L___0:
						if not (a_c.to_integer_32 >= 97) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if a_c.to_integer_32 <= 122 then
							l_tmp := 1
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if a_c.to_integer_32 = 46 then
							l_tmp := 1
						elseif a_c.to_integer_32 = 45 then
							l_tmp := 1
						elseif a_c.to_integer_32 = 95 then
							l_tmp := 1
						else
							l_tmp := 0
						end
				when 10 then -- if done | if done
						Result := l_tmp
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	encode_string (a_name: CE_POINTER [NATURAL_8]; a_data: CE_POINTER [CE_POINTER [NATURAL_8]]; a_len: CE_POINTER [INTEGER_32])
		local
			l_name: CE_POINTER [NATURAL_8]
			l_n: CE_ARRAY [NATURAL_8]
		do
			create l_name.make
			create l_n.make (<<4>>)

			l_name.ce_gets (a_name)
			from
			until
				not ((l_name.item).to_boolean)
			loop
				if (l_name.item).to_integer_32 = 32 then
					links_inst.add_chr_to_str (a_data, a_len, (('+').code).to_natural_8)
				elseif (safe_char (l_name.item)).to_boolean then
					links_inst.add_chr_to_str (a_data, a_len, l_name.item)
				else
					sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_n), ce_string ("%%%%%%02X"), (l_name.item).to_integer_32]).do_nothing
					links_inst.add_to_str (a_data, a_len, l_n)
				end
				l_name.ce_gets (l_name + 1)
			end
		end

	encode_controls (a_l: CE_POINTER [PD_LIST_HEAD]; a_data: CE_POINTER [CE_POINTER [NATURAL_8]]; a_len: CE_POINTER [INTEGER_32]; a_cp_from: INTEGER_32; a_cp_to: INTEGER_32)
		local
			l_sv: CE_POINTER [PD_SUBMITTED_VALUE]
			l_lst: INTEGER_32
			l_p2___0: CE_POINTER [INTEGER_8]
			l_convert_table___0: CE_POINTER [PD_CONV_TABLE]
			l_p: CE_POINTER [NATURAL_8]
			l_o: PD_DOCUMENT_OPTIONS
			l_tmp___0: NATURAL_32
			l_tmp___1: CE_POINTER [NATURAL_8]
		do
			create l_sv.make
			create l_p2___0.make
			create l_convert_table___0.make
			create l_p.make
			create l_o.make
			create l_tmp___1.make

			l_lst := 0
			l_convert_table___0.ce_gets ((charsets_inst.get_translation_table (a_cp_from, a_cp_to)))
			a_len.item := 0
			a_data.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1343)
			l_sv.ce_gets (create {CE_POINTER [PD_SUBMITTED_VALUE]}.make_cast (a_l.item.next))
			from
			until
				(l_sv.c_pointer.to_integer_32).to_natural_32 = (a_l.c_pointer.to_integer_32).to_natural_32
			loop
				l_p.ce_gets (l_sv.item.value)
				memset (create {CE_POINTER [ANY]}.make_cast ((l_o.address)), 0, {PD_DOCUMENT_OPTIONS}.sizeof.to_natural_32).do_nothing
				l_o.plain := 1
				links_inst.d_opt.ce_gets (l_o.address)
				if l_lst.to_boolean then
					links_inst.add_to_str (a_data, a_len, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("&")))
				else
					l_lst := 1
				end
				encode_string (l_sv.item.name, a_data, a_len)
				links_inst.add_to_str (a_data, a_len, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("=")))
				if l_sv.item.type = 1 then
					l_tmp___0 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p))
					l_tmp___1.ce_gets (charsets_inst.convert_string (l_convert_table___0, l_p, l_tmp___0.to_integer_32))
					l_p2___0.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___1))
				elseif l_sv.item.type = 2 then
					l_tmp___0 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p))
					l_tmp___1.ce_gets (charsets_inst.convert_string (l_convert_table___0, l_p, l_tmp___0.to_integer_32))
					l_p2___0.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___1))
				elseif l_sv.item.type = 4 then
					l_tmp___0 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p))
					l_tmp___1.ce_gets (charsets_inst.convert_string (l_convert_table___0, l_p, l_tmp___0.to_integer_32))
					l_p2___0.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___1))
				else
					l_p2___0.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1356, l_p))))
				end
				encode_string (create {CE_POINTER [NATURAL_8]}.make_cast (l_p2___0), a_data, a_len)
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1358, create {CE_POINTER [ANY]}.make_cast (l_p2___0))
				l_sv.ce_gets (l_sv.item.next)
			end
		end

	encode_multipart (a_ses: CE_POINTER [PD_SESSION]; a_l: CE_POINTER [PD_LIST_HEAD]; a_data: CE_POINTER [CE_POINTER [NATURAL_8]]; a_len: CE_POINTER [INTEGER_32]; a_bound: CE_POINTER [NATURAL_8]; a_cp_from: INTEGER_32; a_cp_to: INTEGER_32)
		local
			l_bound_ptrs: CE_POINTER [INTEGER_32]
			l_nbound_ptrs: INTEGER_32
			l_m1: CE_POINTER [NATURAL_8]
			l_m2: CE_POINTER [NATURAL_8]
			l_sv: CE_POINTER [PD_SUBMITTED_VALUE]
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_flg: INTEGER_32
			l_p: CE_POINTER [INTEGER_8]
			l_convert_table___0: CE_POINTER [PD_CONV_TABLE]
			l_ct: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_o: PD_DOCUMENT_OPTIONS
			l_tmp___6: NATURAL_32
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_fh: INTEGER_32
			l_rd: INTEGER_32
			l_buffer___0: CE_ARRAY [NATURAL_8]
			l_tmp___10: NATURAL_8
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_bound_ptrs.make
			create l_m1.make
			create l_m2.make
			create l_sv.make
			create l_p.make
			create l_convert_table___0.make
			create l_ct.make
			create l_o.make
			create l_tmp___7.make
			create l_buffer___0.make (<<1024>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_bound_ptrs.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer + -1))
					l_nbound_ptrs := 0
					l_flg := 0
					l_convert_table___0.ce_gets ((charsets_inst.get_translation_table (a_cp_from, a_cp_to)))
					memset (create {CE_POINTER [ANY]}.make_cast (a_bound), ('x').code, (56).to_natural_32).do_nothing
					a_len.item := 0
					a_data.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1379)
					l_sv.ce_gets (create {CE_POINTER [PD_SUBMITTED_VALUE]}.make_cast (a_l.item.next))
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_sv.c_pointer.to_integer_32).to_natural_32 /= (a_l.c_pointer.to_integer_32).to_natural_32)) then
						l_pos := -1 + 17 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
				when 3 then -- bnd:
						links_inst.add_to_str (a_data, a_len, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("--")))
						if not ((l_nbound_ptrs).bit_and (63)).to_boolean then
							if l_nbound_ptrs.to_natural_32 > {NATURAL_32} 2147483647 // Integer_32_bytes.to_natural_32 - {NATURAL_32} 64 then
								from
								until
									False
								loop
									error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("view.c"), 1385])
									kbd_inst.fatal_tty_exit
									exit (4)
								end
							end
							l_bound_ptrs.ce_gets (create {CE_POINTER [INTEGER_32]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1386, create {CE_POINTER [ANY]}.make_cast (l_bound_ptrs), (l_nbound_ptrs + 64).to_natural_32 * Integer_32_bytes.to_natural_32))))
						end
						l_tmp___1 := l_nbound_ptrs
						l_nbound_ptrs := l_nbound_ptrs + 1
						l_bound_ptrs[l_tmp___1] := a_len.item
						links_inst.add_bytes_to_str (a_data, a_len, a_bound, 56)
						if l_flg.to_boolean then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 16 -- skip if block
						end
				when 4 then -- if:
						links_inst.add_to_str (a_data, a_len, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%NContent-Disposition: form-data; name=%"")))
						links_inst.add_to_str (a_data, a_len, l_sv.item.name)
						links_inst.add_to_str (a_data, a_len, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%"")))
						if l_sv.item.type = 3 then
							links_inst.add_to_str (a_data, a_len, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("; filename=%"")))
							links_inst.add_to_str (a_data, a_len, (strip_file_name (l_sv.item.value)))
							links_inst.add_to_str (a_data, a_len, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%"")))
							if ((l_sv.item.value).item).to_boolean then
								l_ct.ce_gets (types_inst.get_content_type (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_sv.item.value))
								if ((l_ct).c_pointer /= default_pointer) then
									links_inst.add_to_str (a_data, a_len, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%NContent-Type: ")))
									links_inst.add_to_str (a_data, a_len, l_ct)
									if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ct))) >= {NATURAL_32} 4 then
										if not (links_inst.casecmp (l_ct, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("text")), (4).to_natural_32)).to_boolean then
											links_inst.add_to_str (a_data, a_len, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("; charset=")))
											links_inst.add_to_str (a_data, a_len, (charsets_inst.get_cp_mime_name (((a_ses.item.term).item.spec).item.charset)))
										end
									end
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1407, create {CE_POINTER [ANY]}.make_cast (l_ct))
								end
							end
						end
						links_inst.add_to_str (a_data, a_len, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%N%R%N")))
						if l_sv.item.type = 3 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_o.plain := 1
						links_inst.d_opt.ce_gets (l_o.address)
						if l_sv.item.type = 1 then
							l_tmp___6 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_sv.item.value))
							l_tmp___7.ce_gets (charsets_inst.convert_string (l_convert_table___0, l_sv.item.value, l_tmp___6.to_integer_32))
							l_p.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___7))
						elseif l_sv.item.type = 2 then
							l_tmp___6 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_sv.item.value))
							l_tmp___7.ce_gets (charsets_inst.convert_string (l_convert_table___0, l_sv.item.value, l_tmp___6.to_integer_32))
							l_p.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___7))
						elseif l_sv.item.type = 4 then
							l_tmp___6 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_sv.item.value))
							l_tmp___7.ce_gets (charsets_inst.convert_string (l_convert_table___0, l_sv.item.value, l_tmp___6.to_integer_32))
							l_p.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___7))
						else
							l_p.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1417, l_sv.item.value))))
						end
						links_inst.add_to_str (a_data, a_len, create {CE_POINTER [NATURAL_8]}.make_cast (l_p))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1419, create {CE_POINTER [ANY]}.make_cast (l_p))
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 7 then -- else:
						if not (((l_sv.item.value).item).to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 8 then -- if:
						if default_inst.anonymous.to_boolean then
							(errno_location).item := 1
							l_pos := -1 + 29 -- goto error
						end
				when 9 then
						l_fh := open ([create {CE_POINTER [INTEGER_8]}.make_cast (l_sv.item.value), 0])
						if l_fh = -1 then
							l_pos := -1 + 29 -- goto error
						end
				when 10 then
						os_dep_inst.set_bin (l_fh)
				when 11 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 14 -- skip loop
						end
				when 12 then -- loop body:
						js.reset
						l_rd := read (l_fh, create {CE_POINTER [ANY]}.make_cast (l_buffer___0), (1024).to_natural_32)
						if l_rd = -1 then
							close (l_fh).do_nothing
							l_pos := -1 + 29 -- goto error
						end
				when 13 then
						if l_rd.to_boolean then
							links_inst.add_bytes_to_str (a_data, a_len, l_buffer___0, l_rd)
						end
						if not l_rd.to_boolean then
							js.break
						end
						l_pos := -1 + 11 -- back to loop condition
				when 14 then -- loop done
						js.reset
						close (l_fh).do_nothing
				when 15 then -- if done | if done
						links_inst.add_to_str (a_data, a_len, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%N")))
						l_sv.ce_gets (l_sv.item.next)
				when 16 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 17 then -- loop done
					js.reset
					if not l_flg.to_boolean then
						l_flg := 1
						l_pos := -1 + 3 -- goto bnd
					end
				when 18 then
					links_inst.add_to_str (a_data, a_len, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("--%R%N")))
					memset (create {CE_POINTER [ANY]}.make_cast (a_bound), ('-').code, (27).to_natural_32).do_nothing
					memset (create {CE_POINTER [ANY]}.make_cast ((a_bound + 27)), ('0').code, (29).to_natural_32).do_nothing
				when 19 then -- again:
					l_i := 0
				when 20 then -- loop condition:
					if not (not js.loop_left and then (l_i <= a_len.item - 56)) then
						l_pos := -1 + 28 -- skip loop
					end
				when 21 then -- loop body:
						l_j := 0
				when 22 then -- loop condition:
						if not (l_j < 56) then
							l_pos := -1 + 25 -- skip loop
						end
				when 23 then -- loop body:
						if (a_data.item[(l_i + l_j)]).to_integer_32 /= (a_bound[l_j]).to_integer_32 then
							l_pos := -1 + 27 -- goto nb
						end
				when 24 then
						l_j := l_j + 1
						l_pos := -1 + 22 -- back to loop condition
				when 25 then -- loop done
						l_j := 55
						from
						until
							not (l_j >= 0)
						loop
							if (a_bound[l_j]).to_integer_32 < 48 then
								a_bound[l_j] := (47).to_natural_8
							end
							l_j := l_j - 1
						end
						l_tmp___10 := a_bound[l_j]
						a_bound[l_j] := ((a_bound[l_j]).to_integer_32 + 1).to_natural_8
						if l_tmp___10 >= 57 then
							a_bound[l_j] := (('0').code).to_natural_8
						else
							l_pos := -1 + 19 -- goto again
						end
				when 26 then
						from
						until
							False
						loop
							links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")))
							links_inst.errline := 1461
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Counld not assing boundary"))])
						end
				when 27 then -- nb:
						l_i := l_i + 1
						l_pos := -1 + 20 -- back to loop condition
				when 28 then -- loop done
					l_i := 0
					from
					until
						not (l_i < l_nbound_ptrs)
					loop
						memcpy (create {CE_POINTER [ANY]}.make_cast ((a_data.item + l_bound_ptrs[l_i])), create {CE_POINTER [ANY]}.make_cast (a_bound), (56).to_natural_32).do_nothing
						l_i := l_i + 1
					end
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1465, create {CE_POINTER [ANY]}.make_cast (l_bound_ptrs))
					js.return
					if js.return_called then
						l_pos := -1 + 30 -- skip if block
					end
				when 29 then -- if: | error:
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1468, create {CE_POINTER [ANY]}.make_cast (l_bound_ptrs))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1469, create {CE_POINTER [ANY]}.make_cast (a_data.item))
						a_data.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						l_m1.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1471, l_sv.item.value))
						l_m2.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1472, create {CE_POINTER [NATURAL_8]}.make_cast ((strerror ((errno_location).item)))))
						bfu_inst.msg_box ([a_ses.item.term, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_m1), l_m2, create {CE_POINTER [ANY]}.make_shared (default_pointer)])), links_inst.dummyarray + 205, 129, links_inst.dummyarray + 206, ce_string (" "), l_m1, ce_string (": "), l_m2, create {CE_POINTER [ANY]}.make_shared (default_pointer), a_ses, 1, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
				when 30 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	reset_form (a_f: CE_POINTER [PD_F_DATA_C]; a_form_num: INTEGER_32)
		local
			l_form___0: CE_POINTER [PD_FORM_CONTROL]
			l_fs: CE_POINTER [PD_FORM_STATE]
		do
			create l_form___0.make
			create l_fs.make

			l_form___0.ce_gets (create {CE_POINTER [PD_FORM_CONTROL]}.make_cast ((a_f.item.f_data).item.forms.next))
			from
			until
				(l_form___0.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((a_f.item.f_data).c_pointer + {PD_F_DATA}.forms_offset)).c_pointer.to_integer_32).to_natural_32
			loop
				if l_form___0.item.form_num = a_form_num then
					l_fs.ce_gets (find_form_state (a_f, l_form___0))
					if ((l_fs).c_pointer /= default_pointer) then
						init_ctrl (l_form___0, l_fs)
					end
				end
				l_form___0.ce_gets (l_form___0.item.next)
			end
		end

	get_form_url (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_form___0: CE_POINTER [PD_FORM_CONTROL]): CE_POINTER [NATURAL_8]
		local
			l_submit: PD_LIST_HEAD
			l_data: CE_POINTER [NATURAL_8]
			l_bound: CE_ARRAY [NATURAL_8]
			l_len: INTEGER_32
			l_go: CE_POINTER [NATURAL_8]
			l_cp_from: INTEGER_32
			l_cp_to: INTEGER_32
			l_pos___0: CE_POINTER [NATURAL_8]
			l_poss: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_i: INTEGER_32
			l_p: CE_ARRAY [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_submit.make
			create l_data.make
			create l_bound.make (<<56>>)
			create l_go.make
			create l_pos___0.make
			create l_poss.make
			create l_p.make (<<3>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_go.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					if (a_form___0).c_pointer = default_pointer then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called and then (a_form___0.item.type = 10) then
						reset_form (a_f, a_form___0.item.form_num)
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called and then ((a_form___0.item.action).c_pointer = default_pointer) then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						get_succesful_controls (a_f, a_form___0, l_submit.address)
						l_cp_from := ((a_ses.item.term).item.spec).item.charset
						l_cp_to := (a_f.item.f_data).item.cp
						if a_form___0.item.method = 0 then
							encode_controls (l_submit.address, l_data.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_len), l_cp_from, l_cp_to)
						elseif a_form___0.item.method = 1 then
							encode_controls (l_submit.address, l_data.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_len), l_cp_from, l_cp_to)
						else
							encode_multipart (a_ses, l_submit.address, l_data.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_len), l_bound, l_cp_from, l_cp_to)
						end
						if (l_data).c_pointer = default_pointer then
							l_pos := -1 + 3 -- goto ff
						end
				when 2 then
						if a_form___0.item.method = 0 then
							if ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_form___0.item.action))) + {NATURAL_32} 2) + l_len.to_natural_32 < l_len.to_natural_32 then
								from
								until
									False
								loop
									error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("view.c"), 1509])
									kbd_inst.fatal_tty_exit
									exit (4)
								end
							end
							l_go.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1510, (((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_form___0.item.action))) + {NATURAL_32} 1) + l_len.to_natural_32) + {NATURAL_32} 1))))
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_go), create {CE_POINTER [INTEGER_8]}.make_cast (a_form___0.item.action)).do_nothing
							l_pos___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_go), ('#').code))))
							if ((l_pos___0).c_pointer /= default_pointer) then
								l_poss.ce_gets (l_pos___0)
								l_pos___0.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1514, l_pos___0))
								l_poss.item := (0).to_natural_8
							end
							if (((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_go), ('?').code))).c_pointer /= default_pointer) then
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_go), ce_string ("&")).do_nothing
							else
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_go), ce_string ("?")).do_nothing
							end
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_go), create {CE_POINTER [INTEGER_8]}.make_cast (l_data)).do_nothing
							if ((l_pos___0).c_pointer /= default_pointer) then
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_go), create {CE_POINTER [INTEGER_8]}.make_cast (l_pos___0)).do_nothing
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1520, create {CE_POINTER [ANY]}.make_cast (l_pos___0))
							end
						else
							l_l := 0
							l_go.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1524))
							links_inst.add_to_str (l_go.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), a_form___0.item.action)
							links_inst.add_chr_to_str (l_go.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (1).to_natural_8)
							if a_form___0.item.method = 1 then
								links_inst.add_to_str (l_go.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("application/x-www-form-urlencoded%N")))
							else
								links_inst.add_to_str (l_go.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("multipart/form-data; boundary=")))
								links_inst.add_bytes_to_str (l_go.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_bound, 56)
								links_inst.add_to_str (l_go.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
							end
							l_i := 0
							from
							until
								not (l_i < l_len)
							loop
								sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_p), ce_string ("%%02x"), (l_data[l_i]).to_integer_32]).do_nothing
								links_inst.add_to_str (l_go.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_p)
								l_i := l_i + 1
							end
						end
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1539, create {CE_POINTER [ANY]}.make_cast (l_data))
				when 3 then -- ff:
						free_succesful_controls (l_submit.address)
						Result := l_go
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_link_url (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_l: CE_POINTER [PD_LINK]): CE_POINTER [NATURAL_8]
		local
			js: JUMP_STATE
		do
			if a_l.item.type = 0 then
				if (a_l.item.where).c_pointer = default_pointer then
					Result := (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1548, a_l.item.where_img))
					js.return
				end
				if not js.return_called then
					Result := (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1549, a_l.item.where))
					js.return
				end
			end
			if not js.return_called and then (a_l.item.type /= 1) then
				if a_l.item.type /= 4 then
					Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				Result := (get_form_url (a_ses, a_f, a_l.item.form))
			end
		end

	set_frame (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		local
			js: JUMP_STATE
		do
			if (a_f.c_pointer.to_integer_32).to_natural_32 = ((a_ses.item.screen).c_pointer.to_integer_32).to_natural_32 then
				js.return
			end
			if not js.return_called then
				session_inst.goto_url (a_ses, (a_f.item.vs).item.url)
			end
		end

	set_frame_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent set_frame)
		end

	enter (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32): INTEGER_32
		local
			l_link___0: CE_POINTER [PD_LINK]
			l_u: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_fs: CE_POINTER [PD_FORM_STATE]
			l_fc: CE_POINTER [PD_FORM_CONTROL]
			l_ffs___0: CE_POINTER [PD_FORM_STATE]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_link___0.make
			create l_u.make
			create l_tmp.make
			create l_fs.make
			create l_fc.make
			create l_ffs___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_f.item.vs).item.current_link = -1 then
						Result := 1
						js.return
					end
					if js.return_called then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						l_link___0.ce_gets ((a_f.item.f_data).item.links + (a_f.item.vs).item.current_link)
						if l_link___0.item.type /= 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto submit
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 4 then -- else:
						if l_link___0.item.type /= 1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | submit:
						l_u.ce_gets (get_link_url (a_ses, a_f, l_link___0))
						if ((l_u).c_pointer /= default_pointer) then
							if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_u))) >= {NATURAL_32} 4 then
								if (links_inst.casecmp (l_u, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("MAP@")), (4).to_natural_32)).to_boolean then
									session_inst.goto_url_f (a_ses, l_u, l_link___0.item.target)
								else
									l_tmp.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1571, l_link___0.item.target))
									session_inst.goto_imgmap (a_ses, l_u + 4, (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1571, l_u + 4)), l_tmp)
								end
							else
								session_inst.goto_url_f (a_ses, l_u, l_link___0.item.target)
							end
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1573, create {CE_POINTER [ANY]}.make_cast (l_u))
							Result := 2
							js.return
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 7 then -- else:
						if l_link___0.item.type /= 4 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 10 then -- else:
						if l_link___0.item.type /= 5 then
							l_pos := -1 + 14 -- skip if block
						end
				when 11 then -- if: | _L:
						if not (has_form_submit (a_f.item.f_data, l_link___0.item.form)).to_boolean then
							l_pos := -1 + 5 -- goto submit
						end
				when 12 then
						down (a_ses, a_f, 0)
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						if l_link___0.item.type = 2 then
							l_fs.ce_gets ((find_form_state (a_f, l_link___0.item.form)))
							if ((l_link___0.item.form).item.ro).to_boolean then
								Result := 1
								js.return
							end
							if not js.return_called then
								if (l_link___0.item.form).item.type = 5 then
									l_fs.item.state := (not (l_fs.item.state).to_boolean).to_integer
								else
									l_fc.ce_gets (create {CE_POINTER [PD_FORM_CONTROL]}.make_cast ((a_f.item.f_data).item.forms.next))
									from
									until
										(l_fc.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((a_f.item.f_data).c_pointer + {PD_F_DATA}.forms_offset)).c_pointer.to_integer_32).to_natural_32
									loop
										if l_fc.item.form_num = (l_link___0.item.form).item.form_num then
											if l_fc.item.type = 6 then
												if not (links_inst.xstrcmp (l_fc.item.name, (l_link___0.item.form).item.name)).to_boolean then
													l_ffs___0.ce_gets ((find_form_state (a_f, l_fc)))
													if ((l_ffs___0).c_pointer /= default_pointer) then
														l_ffs___0.item.state := 0
													end
												end
											end
										end
										l_fc.ce_gets (l_fc.item.next)
									end
									l_fs.ce_gets (find_form_state (a_f, l_link___0.item.form))
									l_fs.item.state := 1
								end
							end
						elseif l_link___0.item.type = 3 then
							if ((l_link___0.item.form).item.ro).to_boolean then
								Result := 1
								js.return
							end
							if not js.return_called then
								(a_f.item.f_data).item.refcount := ((a_f.item.f_data).item.refcount) + 1
								terminal_inst.add_empty_window (a_ses.item.term, (decrement_fc_refcount_address), create {CE_POINTER [ANY]}.make_cast (a_f.item.f_data))
								html_inst.do_select_submenu (a_ses.item.term, (l_link___0.item.form).item.menu, a_ses)
							end
						else
							from
							until
								False
							loop
								links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")))
								links_inst.errline := 1598
								error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bad link type %%d")), l_link___0.item.type])
							end
						end
				when 15 then -- if done | if done | if done | if done
						if not js.return_called then
							Result := 1
						end
				when 16 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	toggle (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		local
			js: JUMP_STATE
		do
			if (a_f).c_pointer = default_pointer then
				js.return
			elseif (a_f.item.vs).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				(a_f.item.vs).item.plain := (not ((a_f.item.vs).item.plain).to_boolean).to_integer
				html_r_inst.html_interpret (a_ses)
				draw_formatted (a_ses)
			end
		end

	back (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		do
			session_inst.go_back (a_ses)
		end

	selected_item (a_term: CE_POINTER [PD_TERMINAL]; a_pitem: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_item: INTEGER_32
			l_f: CE_POINTER [PD_F_DATA_C]
			l_l: CE_POINTER [PD_LINK]
			l_fs: CE_POINTER [PD_FORM_STATE]
			l_form___0: CE_POINTER [PD_FORM_CONTROL]
			js: JUMP_STATE
		do
			create l_f.make
			create l_l.make
			create l_fs.make
			create l_form___0.make

			l_item := (a_pitem.c_pointer.to_integer_32).to_integer_32
			l_f.ce_gets ((current_frame (a_ses)))
			if (l_f).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called and then ((l_f.item.vs).item.current_link = -1) then
				js.return
			end
			if not js.return_called then
				l_l.ce_gets ((l_f.item.f_data).item.links + (l_f.item.vs).item.current_link)
				if l_l.item.type /= 3 then
					js.return
				end
			end
			if not js.return_called then
				l_fs.ce_gets (find_form_state (l_f, l_l.item.form))
				if ((l_fs).c_pointer /= default_pointer) then
					l_form___0.ce_gets (l_l.item.form)
					if l_item >= 0 then
						if l_item < l_form___0.item.nvalues then
							l_fs.item.state := l_item
							if ((l_fs.item.value).c_pointer /= default_pointer) then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1629, create {CE_POINTER [ANY]}.make_cast (l_fs.item.value))
							end
							l_fs.item.value := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1630, l_form___0.item.values[l_item])
						end
					end
					fixup_select_state (l_form___0, l_fs)
				end
				draw_doc (a_ses.item.term, l_f, 1)
				session_inst.print_screen_status (a_ses)
				terminal_inst.redraw_from_window (a_ses.item.win)
			end
		end

	selected_item_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent selected_item)
		end

	get_current_state (a_ses: CE_POINTER [PD_SESSION]): INTEGER_32
		local
			l_f: CE_POINTER [PD_F_DATA_C]
			l_l: CE_POINTER [PD_LINK]
			l_fs: CE_POINTER [PD_FORM_STATE]
			js: JUMP_STATE
		do
			create l_f.make
			create l_l.make
			create l_fs.make

			l_f.ce_gets ((current_frame (a_ses)))
			if (l_f).c_pointer = default_pointer then
				Result := (-1)
				js.return
			end
			if not js.return_called and then ((l_f.item.vs).item.current_link = -1) then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				l_l.ce_gets ((l_f.item.f_data).item.links + (l_f.item.vs).item.current_link)
				if l_l.item.type /= 3 then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				l_fs.ce_gets (find_form_state (l_f, l_l.item.form))
				if ((l_fs).c_pointer /= default_pointer) then
					Result := (l_fs.item.state)
					js.return
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	textarea_adjust_viewport (a_fd: CE_POINTER [PD_F_DATA_C]; a_l: CE_POINTER [PD_LINK]): INTEGER_32
		local
			l_fc: CE_POINTER [PD_FORM_CONTROL]
			l_vs: CE_POINTER [PD_VIEW_STATE]
			l_r: INTEGER_32
		do
			create l_fc.make
			create l_vs.make

			l_fc.ce_gets (a_l.item.form)
			l_vs.ce_gets (a_fd.item.vs)
			l_r := 0
			if (a_l.item.pos + 0).item.x + l_fc.item.cols > a_fd.item.xw + l_vs.item.view_posx then
				l_vs.item.view_posx := ((a_l.item.pos + 0).item.x + l_fc.item.cols) - a_fd.item.xw
				l_r := 1
			end
			if (a_l.item.pos + 0).item.x < l_vs.item.view_posx then
				l_vs.item.view_posx := (a_l.item.pos + 0).item.x
				l_r := 1
			end
			if (a_l.item.pos + 0).item.y + l_fc.item.rows > a_fd.item.yw + l_vs.item.view_pos then
				l_vs.item.view_pos := ((a_l.item.pos + 0).item.y + l_fc.item.rows) - a_fd.item.yw
				l_r := 1
			end
			if (a_l.item.pos + 0).item.y < l_vs.item.view_pos then
				l_vs.item.view_pos := (a_l.item.pos + 0).item.y
				l_r := 1
			end
			l_vs.item.orig_view_pos := l_vs.item.view_pos
			l_vs.item.orig_view_posx := l_vs.item.view_posx
			Result := l_r
		end

	field_op (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_l: CE_POINTER [PD_LINK]; a_ev: CE_POINTER [PD_EVENT]; a_rep: INTEGER_32): INTEGER_32
		local
			l_form___0: CE_POINTER [PD_FORM_CONTROL]
			l_fs: CE_POINTER [PD_FORM_STATE]
			l_x: INTEGER_32
			l_ln: CE_POINTER [PD_LINE_INFO]
			l_y: INTEGER_32
			l_ln___0: CE_POINTER [PD_LINE_INFO]
			l_y___0: INTEGER_32
			l_ln___1: CE_POINTER [PD_LINE_INFO]
			l_y___1: INTEGER_32
			l_ln___2: CE_POINTER [PD_LINE_INFO]
			l_y___2: INTEGER_32
			l_clipboard: CE_POINTER [INTEGER_8]
			l_v: CE_POINTER [NATURAL_8]
			l_v___0: CE_POINTER [NATURAL_8]
			l_tmp___15: INTEGER_32
			l_v___1: CE_POINTER [NATURAL_8]
			l_tmp___24: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_form___0.make
			create l_fs.make
			create l_ln.make
			create l_ln___0.make
			create l_ln___1.make
			create l_ln___2.make
			create l_clipboard.make
			create l_v.make
			create l_v___0.make
			create l_v___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_form___0.ce_gets (a_l.item.form)
					l_x := 1
					if (l_form___0).c_pointer = default_pointer then
						from
						until
							False
						loop
							links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")))
							links_inst.errline := 1679
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("link has no form control"))])
						end
						Result := 0
						js.return
					end
					if not js.return_called and then ((a_l.item.form).item.ro = 2) then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_fs.ce_gets (find_form_state (a_f, l_form___0))
						if (l_fs).c_pointer = default_pointer then
							Result := 0
							js.return
						end
					end
					if not js.return_called and then ((l_fs.item.value).c_pointer = default_pointer) then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 73 -- skip if block
					end
				when 1 then -- if:
						if a_ev.item.ev /= 1 then
							l_pos := -1 + 71 -- skip if block
						end
				when 2 then -- if:
						inspect (kbdbind_inst.kbd_action (1, a_ev)) -- switch 1 head
						when 23 then l_pos := -1 + 3
						when 35 then l_pos := -1 + 4
						when 20 then l_pos := -1 + 5
						when 45 then l_pos := -1 + 16
						when 9 then l_pos := -1 + 31
						when 11 then l_pos := -1 + 46
						when 5 then l_pos := -1 + 57
						when 6 then l_pos := -1 + 58
						when 30 then l_pos := -1 + 59
						when 12 then l_pos := -1 + 61
						when 3 then l_pos := -1 + 62
						when 7 then l_pos := -1 + 63
						when 21 then l_pos := -1 + 64
						when 22 then l_pos := -1 + 65
						else l_pos := -1 + 66
						end
				when 3 then -- switch 1, case 23
						if (l_fs.item.state).to_boolean then
							l_fs.item.state := (l_fs.item.state) - 1
						else
							l_fs.item.state := 0
						end
						l_pos := -1 + 70 -- switch 1; break
				when 4 then -- switch 1, case 35
						if (l_fs.item.state).to_natural_32 < (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fs.item.value))) then
							l_fs.item.state := (l_fs.item.state) + 1
						else
							l_fs.item.state := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fs.item.value))).to_integer_32
						end
						l_pos := -1 + 70 -- switch 1; break
				when 5 then -- switch 1, case 20
						if l_form___0.item.type /= 4 then
							l_pos := -1 + 14 -- skip if block
						end
				when 6 then -- if:
						l_ln.ce_gets (format_text (l_fs.item.value, l_form___0.item.cols, l_form___0.item.wrap))
						if (l_ln).c_pointer = default_pointer then
							l_pos := -1 + 13 -- skip if block
						end
				when 7 then -- if:
						l_y := 0
				when 8 then -- loop condition:
						if ((l_ln + l_y).item.st).c_pointer = default_pointer then
							l_pos := -1 + 11 -- skip loop
						end
				when 9 then -- loop body:
						if ((l_fs.item.value + l_fs.item.state).c_pointer.to_integer_32).to_natural_32 >= (((l_ln + l_y).item.st).c_pointer.to_integer_32).to_natural_32 then
							if ((l_fs.item.value + l_fs.item.state).c_pointer.to_integer_32).to_natural_32 < (((l_ln + l_y).item.en + ((((l_ln + (l_y + 1)).item.st).c_pointer.to_integer_32).to_natural_32 /= (((l_ln + l_y).item.en).c_pointer.to_integer_32).to_natural_32).to_integer).c_pointer.to_integer_32).to_natural_32 then
								l_fs.item.state := ((l_ln + l_y).item.st).distance ((l_fs.item.value))
								l_pos := -1 + 12 -- goto x
							end
						end
				when 10 then
						l_y := l_y + 1
						l_pos := -1 + 8 -- back to loop condition
				when 11 then -- loop done
						l_fs.item.state := 0
				when 12 then -- x:
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1700, create {CE_POINTER [ANY]}.make_cast (l_ln))
				when 13 then -- if done | if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						l_fs.item.state := 0
				when 15 then -- if done
						l_pos := -1 + 70 -- switch 1; break
				when 16 then -- switch 1, case 45
						if l_form___0.item.type /= 4 then
							l_pos := -1 + 29 -- skip if block
						end
				when 17 then -- if:
						l_ln___0.ce_gets (format_text (l_fs.item.value, l_form___0.item.cols, l_form___0.item.wrap))
						if (l_ln___0).c_pointer = default_pointer then
							l_pos := -1 + 28 -- skip if block
						end
				when 18 then -- if: | rep1:
						l_y___0 := 0
				when 19 then -- loop condition:
						if ((l_ln___0 + l_y___0).item.st).c_pointer = default_pointer then
							l_pos := -1 + 25 -- skip loop
						end
				when 20 then -- loop body:
						if not (((l_fs.item.value + l_fs.item.state).c_pointer.to_integer_32).to_natural_32 >= (((l_ln___0 + l_y___0).item.st).c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 24 -- skip if block
						end
				when 21 then -- if:
						if not (((l_fs.item.value + l_fs.item.state).c_pointer.to_integer_32).to_natural_32 < (((l_ln___0 + l_y___0).item.en + ((((l_ln___0 + (l_y___0 + 1)).item.st).c_pointer.to_integer_32).to_natural_32 /= (((l_ln___0 + l_y___0).item.en).c_pointer.to_integer_32).to_natural_32).to_integer).c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if not l_y___0.to_boolean then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1712, create {CE_POINTER [ANY]}.make_cast (l_ln___0))
							l_pos := -1 + 69 -- goto b
						end
				when 23 then
						l_fs.item.state := l_fs.item.state - (((l_ln___0 + l_y___0).item.st).distance (((l_ln___0 + (l_y___0 - 1)).item.st)))
						if ((l_fs.item.value + l_fs.item.state).c_pointer.to_integer_32).to_natural_32 > (((l_ln___0 + (l_y___0 - 1)).item.en).c_pointer.to_integer_32).to_natural_32 then
							l_fs.item.state := ((l_ln___0 + (l_y___0 - 1)).item.en).distance ((l_fs.item.value))
						end
						l_pos := -1 + 26 -- goto xx
				when 24 then -- if done
						l_y___0 := l_y___0 + 1
						l_pos := -1 + 19 -- back to loop condition
				when 25 then -- loop done
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1719, create {CE_POINTER [ANY]}.make_cast (l_ln___0))
						l_pos := -1 + 69 -- goto b
				when 26 then -- xx:
						if a_rep.to_boolean then
							l_pos := -1 + 18 -- goto rep1
						end
				when 27 then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1723, create {CE_POINTER [ANY]}.make_cast (l_ln___0))
				when 28 then -- if done | if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else:
						l_x := 0
				when 30 then -- if done
						l_pos := -1 + 70 -- switch 1; break
				when 31 then -- switch 1, case 9
						if l_form___0.item.type /= 4 then
							l_pos := -1 + 44 -- skip if block
						end
				when 32 then -- if:
						l_ln___1.ce_gets (format_text (l_fs.item.value, l_form___0.item.cols, l_form___0.item.wrap))
						if (l_ln___1).c_pointer = default_pointer then
							l_pos := -1 + 43 -- skip if block
						end
				when 33 then -- if: | rep2:
						l_y___1 := 0
				when 34 then -- loop condition:
						if ((l_ln___1 + l_y___1).item.st).c_pointer = default_pointer then
							l_pos := -1 + 40 -- skip loop
						end
				when 35 then -- loop body:
						if not (((l_fs.item.value + l_fs.item.state).c_pointer.to_integer_32).to_natural_32 >= (((l_ln___1 + l_y___1).item.st).c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 39 -- skip if block
						end
				when 36 then -- if:
						if not (((l_fs.item.value + l_fs.item.state).c_pointer.to_integer_32).to_natural_32 < (((l_ln___1 + l_y___1).item.en + ((((l_ln___1 + (l_y___1 + 1)).item.st).c_pointer.to_integer_32).to_natural_32 /= (((l_ln___1 + l_y___1).item.en).c_pointer.to_integer_32).to_natural_32).to_integer).c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						if ((l_ln___1 + (l_y___1 + 1)).item.st).c_pointer = default_pointer then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1735, create {CE_POINTER [ANY]}.make_cast (l_ln___1))
							l_pos := -1 + 69 -- goto b
						end
				when 38 then
						l_fs.item.state := l_fs.item.state + (((l_ln___1 + (l_y___1 + 1)).item.st).distance (((l_ln___1 + l_y___1).item.st)))
						if ((l_fs.item.value + l_fs.item.state).c_pointer.to_integer_32).to_natural_32 > (((l_ln___1 + (l_y___1 + 1)).item.en).c_pointer.to_integer_32).to_natural_32 then
							l_fs.item.state := ((l_ln___1 + (l_y___1 + 1)).item.en).distance ((l_fs.item.value))
						end
						l_pos := -1 + 41 -- goto yy
				when 39 then -- if done
						l_y___1 := l_y___1 + 1
						l_pos := -1 + 34 -- back to loop condition
				when 40 then -- loop done
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1742, create {CE_POINTER [ANY]}.make_cast (l_ln___1))
						l_pos := -1 + 69 -- goto b
				when 41 then -- yy:
						if a_rep.to_boolean then
							l_pos := -1 + 33 -- goto rep2
						end
				when 42 then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1746, create {CE_POINTER [ANY]}.make_cast (l_ln___1))
				when 43 then -- if done | if block done, skip else block:
						l_pos := -1 + 45
				when 44 then -- else:
						l_x := 0
				when 45 then -- if done
						l_pos := -1 + 70 -- switch 1; break
				when 46 then -- switch 1, case 11
						if l_form___0.item.type /= 4 then
							l_pos := -1 + 55 -- skip if block
						end
				when 47 then -- if:
						l_ln___2.ce_gets (format_text (l_fs.item.value, l_form___0.item.cols, l_form___0.item.wrap))
						if (l_ln___2).c_pointer = default_pointer then
							l_pos := -1 + 54 -- skip if block
						end
				when 48 then -- if:
						l_y___2 := 0
				when 49 then -- loop condition:
						if ((l_ln___2 + l_y___2).item.st).c_pointer = default_pointer then
							l_pos := -1 + 52 -- skip loop
						end
				when 50 then -- loop body:
						if ((l_fs.item.value + l_fs.item.state).c_pointer.to_integer_32).to_natural_32 >= (((l_ln___2 + l_y___2).item.st).c_pointer.to_integer_32).to_natural_32 then
							if ((l_fs.item.value + l_fs.item.state).c_pointer.to_integer_32).to_natural_32 < (((l_ln___2 + l_y___2).item.en + ((((l_ln___2 + (l_y___2 + 1)).item.st).c_pointer.to_integer_32).to_natural_32 /= (((l_ln___2 + l_y___2).item.en).c_pointer.to_integer_32).to_natural_32).to_integer).c_pointer.to_integer_32).to_natural_32 then
								l_fs.item.state := ((l_ln___2 + l_y___2).item.en).distance ((l_fs.item.value))
								if (l_fs.item.state).to_boolean then
									if (l_fs.item.state).to_natural_32 < (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fs.item.value))) then
										if (((l_ln___2 + (l_y___2 + 1)).item.st).c_pointer.to_integer_32).to_natural_32 = (((l_ln___2 + l_y___2).item.en).c_pointer.to_integer_32).to_natural_32 then
											l_fs.item.state := (l_fs.item.state) - 1
										end
									end
								end
								l_pos := -1 + 53 -- goto yyyy
							end
						end
				when 51 then
						l_y___2 := l_y___2 + 1
						l_pos := -1 + 49 -- back to loop condition
				when 52 then -- loop done
						l_fs.item.state := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fs.item.value))).to_integer_32
				when 53 then -- yyyy:
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1762, create {CE_POINTER [ANY]}.make_cast (l_ln___2))
				when 54 then -- if done | if block done, skip else block:
						l_pos := -1 + 56
				when 55 then -- else:
						l_fs.item.state := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fs.item.value))).to_integer_32
				when 56 then -- if done
						l_pos := -1 + 70 -- switch 1; break
				when 57 then -- switch 1, case 5
						os_dep_inst.set_clipboard_text (create {CE_POINTER [INTEGER_8]}.make_cast (l_fs.item.value))
						l_pos := -1 + 70 -- switch 1; break
				when 58 then -- switch 1, case 6
						os_dep_inst.set_clipboard_text (create {CE_POINTER [INTEGER_8]}.make_cast (l_fs.item.value))
						if not (l_form___0.item.ro).to_boolean then
							l_fs.item.value[0] := (0).to_natural_8
						end
						l_fs.item.state := 0
						l_pos := -1 + 70 -- switch 1; break
				when 59 then -- switch 1, case 30
						l_clipboard.ce_gets ((os_dep_inst.get_clipboard_text))
						if (l_clipboard).c_pointer = default_pointer then
							l_pos := -1 + 70 -- switch 1; break
						end
				when 60 then
						if not (l_form___0.item.ro).to_boolean then
							if (strlen (l_clipboard)) <= (l_form___0.item.maxlength).to_natural_32 then
								l_v.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1779, create {CE_POINTER [ANY]}.make_cast (l_fs.item.value), (strlen (l_clipboard)) + {NATURAL_32} 1))))
								l_fs.item.value := l_v
								memmove (create {CE_POINTER [ANY]}.make_cast (l_v), create {CE_POINTER [ANY]}.make_cast (l_clipboard), (strlen (l_clipboard)) + {NATURAL_32} 1).do_nothing
								l_fs.item.state := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fs.item.value))).to_integer_32
							end
						end
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1784, create {CE_POINTER [ANY]}.make_cast (l_clipboard))
						l_pos := -1 + 70 -- switch 1; break
				when 61 then -- switch 1, case 12
						if l_form___0.item.type = 4 then
							if not (l_form___0.item.ro).to_boolean then
								if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fs.item.value))) < (l_form___0.item.maxlength).to_natural_32 then
									l_v___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1791, create {CE_POINTER [ANY]}.make_cast (l_fs.item.value), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fs.item.value))) + {NATURAL_32} 2))))
									l_fs.item.value := l_v___0
									memmove (create {CE_POINTER [ANY]}.make_cast (((l_v___0 + l_fs.item.state) + 1)), create {CE_POINTER [ANY]}.make_cast ((l_v___0 + l_fs.item.state)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_v___0 + l_fs.item.state)))) + {NATURAL_32} 1).do_nothing
									l_tmp___15 := l_fs.item.state
									l_fs.item.state := (l_fs.item.state) + 1
									l_v___0[l_tmp___15] := (('%N').code).to_natural_8
								end
							end
						else
							l_x := 0
						end
						l_pos := -1 + 70 -- switch 1; break
				when 62 then -- switch 1, case 3
						if not (l_form___0.item.ro).to_boolean then
							if (l_fs.item.state).to_boolean then
								memmove (create {CE_POINTER [ANY]}.make_cast (((l_fs.item.value + l_fs.item.state) - 1)), create {CE_POINTER [ANY]}.make_cast ((l_fs.item.value + l_fs.item.state)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_fs.item.value + l_fs.item.state)))) + {NATURAL_32} 1).do_nothing
								l_fs.item.state := (l_fs.item.state) - 1
							end
						end
						l_pos := -1 + 70 -- switch 1; break
				when 63 then -- switch 1, case 7
						if not (l_form___0.item.ro).to_boolean then
							if (l_fs.item.state).to_natural_32 < (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fs.item.value))) then
								memmove (create {CE_POINTER [ANY]}.make_cast ((l_fs.item.value + l_fs.item.state)), create {CE_POINTER [ANY]}.make_cast (((l_fs.item.value + l_fs.item.state) + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_fs.item.value + l_fs.item.state))))).do_nothing
							end
						end
						l_pos := -1 + 70 -- switch 1; break
				when 64 then -- switch 1, case 21
						if not (l_form___0.item.ro).to_boolean then
							memmove (create {CE_POINTER [ANY]}.make_cast (l_fs.item.value), create {CE_POINTER [ANY]}.make_cast ((l_fs.item.value + l_fs.item.state)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_fs.item.value + l_fs.item.state)))) + {NATURAL_32} 1).do_nothing
						end
						l_fs.item.state := 0
						l_pos := -1 + 70 -- switch 1; break
				when 65 then -- switch 1, case 22
						l_fs.item.value[l_fs.item.state] := (0).to_natural_8
						l_pos := -1 + 70 -- switch 1; break
				when 66 then -- switch 1, default:
						if (a_ev.item.y).to_boolean then
							l_pos := -1 + 69 -- skip if block
						end
				when 67 then -- if:
						if a_ev.item.x >= 32 then
							if a_ev.item.x < 256 then
								if (charsets_inst.cp2u ((a_ev.item.x).to_natural_8, ((a_ses.item.term).item.spec).item.charset)) /= -1 then
									if not (l_form___0.item.ro).to_boolean then
										if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fs.item.value))) < (l_form___0.item.maxlength).to_natural_32 then
											l_v___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1816, create {CE_POINTER [ANY]}.make_cast (l_fs.item.value), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fs.item.value))) + {NATURAL_32} 2))))
											l_fs.item.value := l_v___1
											memmove (create {CE_POINTER [ANY]}.make_cast (((l_v___1 + l_fs.item.state) + 1)), create {CE_POINTER [ANY]}.make_cast ((l_v___1 + l_fs.item.state)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_v___1 + l_fs.item.state)))) + {NATURAL_32} 1).do_nothing
											l_tmp___24 := l_fs.item.state
											l_fs.item.state := (l_fs.item.state) + 1
											l_v___1[l_tmp___24] := (a_ev.item.x).to_natural_8
										end
									end
								else
									l_pos := -1 + 69 -- goto b
								end
							else
								l_pos := -1 + 69 -- goto b
							end
						else
							l_pos := -1 + 69 -- goto b
						end
				when 68 then -- if block done, skip else block:
						l_pos := -1 + 70
				when 69 then -- else: | b:
						l_x := 0
				when 70 then -- switch 1, done: | if block done, skip else block:
						l_pos := -1 + 72
				when 71 then -- else:
						l_x := 0
				when 72 then -- if done
						if l_x.to_boolean then
							if a_ev.item.x /= 262 then
								if a_ev.item.x /= 263 then
									if l_form___0.item.type = 4 then
										textarea_adjust_viewport (a_f, a_l).do_nothing
									end
								end
							end
							draw_form_entry (a_ses.item.term, a_f, a_l)
							terminal_inst.redraw_from_window (a_ses.item.win)
						end
						Result := l_x
				when 73 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_textarea (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_kbd: INTEGER_32)
		local
			l_ev: PD_EVENT
		do
			create l_ev.make

			if (a_f.item.vs).item.current_link /= -1 then
				if ((a_f.item.f_data).item.links + (a_f.item.vs).item.current_link).item.type = 5 then
					l_ev.ev := 1
					l_ev.x := 0
					l_ev.y := 0
					l_ev.b := 0
					l_ev.x := a_kbd.to_integer_32
					field_op (a_ses, a_f, (a_f.item.f_data).item.links + (a_f.item.vs).item.current_link, l_ev.address, 1).do_nothing
				end
			end
		end

	search_for_back (a_ses: CE_POINTER [PD_SESSION]; a_str: CE_POINTER [NATURAL_8])
		local
			l_f: CE_POINTER [PD_F_DATA_C]
			js: JUMP_STATE
		do
			create l_f.make

			l_f.ce_gets ((current_frame (a_ses)))
			if (l_f).c_pointer = default_pointer then
				js.return
			elseif (a_str).c_pointer = default_pointer then
				js.return
			elseif not (a_str[0]).to_boolean then
				js.return
			end
			if not js.return_called then
				if ((a_ses.item.search_word).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1848, create {CE_POINTER [ANY]}.make_cast (a_ses.item.search_word))
				end
				a_ses.item.search_word := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1849, a_str)
				charsets_inst.charset_upcase_string (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (a_ses.c_pointer + {PD_SESSION}.search_word_offset), ((a_ses.item.term).item.spec).item.charset)
				if ((a_ses.item.last_search_word).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1851, create {CE_POINTER [ANY]}.make_cast (a_ses.item.last_search_word))
				end
				a_ses.item.last_search_word := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1852, a_ses.item.search_word)
				a_ses.item.search_direction := -1
				find_next (a_ses, l_f, 1)
			end
		end

	search_for_back_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent search_for_back)
		end

	search_for (a_ses: CE_POINTER [PD_SESSION]; a_str: CE_POINTER [NATURAL_8])
		local
			l_f: CE_POINTER [PD_F_DATA_C]
			js: JUMP_STATE
		do
			create l_f.make

			l_f.ce_gets ((current_frame (a_ses)))
			if (l_f).c_pointer = default_pointer then
				js.return
			elseif (a_str).c_pointer = default_pointer then
				js.return
			elseif not (a_str[0]).to_boolean then
				js.return
			end
			if not js.return_called then
				if ((a_ses.item.search_word).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1861, create {CE_POINTER [ANY]}.make_cast (a_ses.item.search_word))
				end
				a_ses.item.search_word := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1862, a_str)
				charsets_inst.charset_upcase_string (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (a_ses.c_pointer + {PD_SESSION}.search_word_offset), ((a_ses.item.term).item.spec).item.charset)
				if ((a_ses.item.last_search_word).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1864, create {CE_POINTER [ANY]}.make_cast (a_ses.item.last_search_word))
				end
				a_ses.item.last_search_word := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1865, a_ses.item.search_word)
				a_ses.item.search_direction := 1
				find_next (a_ses, l_f, 1)
			end
		end

	search_for_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent search_for)
		end

	point_intersect (a_p1___0: CE_POINTER [PD_POINT]; a_l1: INTEGER_32; a_p2___0: CE_POINTER [PD_POINT]; a_l2: INTEGER_32): INTEGER_32
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			js: JUMP_STATE
		do
			if not init___0.to_boolean then
				memset (create {CE_POINTER [ANY]}.make_cast (hash), 0, (4096).to_natural_32).do_nothing
				init___0 := (1).to_integer_8
			end
			l_i := 0
			from
			until
				not (l_i < a_l1)
			loop
				hash[(((((a_p1___0 + l_i).item.y).bit_shift_left (6)) + (a_p1___0 + l_i).item.x)).bit_and (4095)] := (1).to_integer_8
				l_i := l_i + 1
			end
			l_j := 0
			from
			until
				not (not js.loop_left and then (l_j < a_l2))
			loop
				if (hash[(((((a_p2___0 + l_j).item.y).bit_shift_left (6)) + (a_p2___0 + l_j).item.x)).bit_and (4095)]).to_boolean then
					l_i := 0
					from
					until
						not (not js.loop_left and then (l_i < a_l1))
					loop
						if (a_p1___0 + l_i).item.x = (a_p2___0 + l_j).item.x then
							if (a_p1___0 + l_i).item.y = (a_p2___0 + l_j).item.y then
								l_i := 0
								from
								until
									not (l_i < a_l1)
								loop
									hash[(((((a_p1___0 + l_i).item.y).bit_shift_left (6)) + (a_p1___0 + l_i).item.x)).bit_and (4095)] := (0).to_integer_8
									l_i := l_i + 1
								end
								Result := 1
								js.return
							end
						end
						if not js.return_called then
							l_i := l_i + 1
						end
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				l_i := 0
				from
				until
					not (l_i < a_l1)
				loop
					hash[(((((a_p1___0 + l_i).item.y).bit_shift_left (6)) + (a_p1___0 + l_i).item.x)).bit_and (4095)] := (0).to_integer_8
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	find_next_link_in_search (a_f: CE_POINTER [PD_F_DATA_C]; a_d: INTEGER_32): INTEGER_32
		local
			l_d: INTEGER_32
			l_pt: CE_POINTER [PD_POINT]
			l_len: INTEGER_32
			l_link___0: CE_POINTER [PD_LINK]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_pt.make
			create l_link___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d := a_d
					if l_d /= -2 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if l_d /= 2 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_d := l_d // (2)
						find_link (a_f, l_d, 0)
						if (a_f.item.vs).item.current_link = -1 then
							Result := 1
							js.return
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | nx:
						if (a_f.item.vs).item.current_link = -1 then
							find_link (a_f, l_d, 0)
							Result := 1
							js.return
						elseif not (next_in_view (a_f, (a_f.item.vs).item.current_link + l_d, l_d, in_view_address, create {CE_ROUTINE}.make_shared (default_pointer))).to_boolean then
							find_link (a_f, l_d, 0)
							Result := 1
							js.return
						end
				when 7 then -- if done
						if not js.return_called then
							l_link___0.ce_gets ((a_f.item.f_data).item.links + (a_f.item.vs).item.current_link)
							get_searched (a_f, l_pt.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_len))
							if (point_intersect (l_pt, l_len, l_link___0.item.pos, l_link___0.item.n)).to_boolean then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1907, create {CE_POINTER [ANY]}.make_cast (l_pt))
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1910, create {CE_POINTER [ANY]}.make_cast (l_pt))
							l_pos := -1 + 6 -- goto nx
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	find_next (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		local
			l_min: INTEGER_32
			l_max: INTEGER_32
			l_c: INTEGER_32
			l_p: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			l_c := 0
			l_p := (a_f.item.vs).item.view_pos
			if not a_a.to_boolean then
				if ((a_ses.item.search_word).c_pointer /= default_pointer) then
					if not (find_next_link_in_search (a_f, a_ses.item.search_direction)).to_boolean then
						js.return
					end
					if not js.return_called then
						l_p := l_p + (a_ses.item.search_direction * a_f.item.yw)
					end
				end
			end
			if not js.return_called and then ((a_ses.item.search_word).c_pointer = default_pointer) then
				if (a_ses.item.last_search_word).c_pointer = default_pointer then
					bfu_inst.msg_box ([a_ses.item.term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 92, 1, links_inst.dummyarray + 207, create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
					js.return
				end
				if not js.return_called then
					a_ses.item.search_word := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 1928, a_ses.item.last_search_word)
				end
			end
			if not js.return_called then
				html_r_inst.get_search_data (a_f.item.f_data)
				from
				until
					js.loop_left
				loop
					js.reset
					if (is_in_range (a_f.item.f_data, l_p, a_f.item.yw, a_ses.item.search_word, create {CE_POINTER [INTEGER_32]}.make_shared ($l_min), create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))).to_boolean then
						(a_f.item.vs).item.view_pos := l_p
						if l_max >= l_min then
							if l_max > (a_f.item.vs).item.view_posx + a_f.item.xw then
								(a_f.item.vs).item.view_posx := l_max - a_f.item.xw
							end
							if l_min < (a_f.item.vs).item.view_posx then
								(a_f.item.vs).item.view_posx := l_min
							end
						end
						(a_f.item.vs).item.orig_view_pos := (a_f.item.vs).item.view_pos;
						(a_f.item.vs).item.orig_view_posx := (a_f.item.vs).item.view_posx
						set_link (a_f)
						find_next_link_in_search (a_f, a_ses.item.search_direction * 2).do_nothing
						js.return
					end
					if not js.return_called then
						l_p := l_p + (a_ses.item.search_direction * a_f.item.yw)
						if l_p > (a_f.item.f_data).item.y then
							l_p := 0
						end
						if l_p < 0 then
							l_p := 0
							from
							until
								not (l_p < (a_f.item.f_data).item.y)
							loop
								if (a_f.item.yw).to_boolean then
									l_tmp___1 := a_f.item.yw
								else
									l_tmp___1 := 1
								end
								l_p := l_p + l_tmp___1
							end
							l_p := l_p - (a_f.item.yw)
						end
						if (a_f.item.yw).to_boolean then
							l_tmp___2 := a_f.item.yw
						else
							l_tmp___2 := 1
						end
						l_c := l_c + l_tmp___2
						if not (l_c < (a_f.item.f_data).item.y + a_f.item.yw) then
							js.break
						end
					end
				end
				js.reset
			end
			if not js.return_called then
				bfu_inst.msg_box ([a_ses.item.term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 92, 1, links_inst.dummyarray + 208, create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
			end
		end

	find_next_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent find_next)
		end

	find_next_back (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		do
			a_ses.item.search_direction := -a_ses.item.search_direction
			find_next (a_ses, a_f, a_a)
			a_ses.item.search_direction := -a_ses.item.search_direction
		end

	find_next_back_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent find_next_back)
		end

	rep_ev (a_ses: CE_POINTER [PD_SESSION]; a_fd: CE_POINTER [PD_F_DATA_C]; a_f: CE_ROUTINE; a_a: INTEGER_32)
		local
			l_i: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			if (a_ses.item.kbdprefix.rep).to_boolean then
				l_tmp := a_ses.item.kbdprefix.rep_num
			else
				l_tmp := 1
			end
			l_i := l_tmp
			from
			until
				js.loop_left
			loop
				js.reset
				l_tmp___0 := l_i
				l_i := l_i - 1
				if not l_tmp___0.to_boolean then
					js.break
				end
				if not js.loop_jumped then
					a_f.call ([a_ses, a_fd, a_a])
				end
			end
			js.reset
		end

	choose_mouse_link (a_f: CE_POINTER [PD_F_DATA_C]; a_ev: CE_POINTER [PD_EVENT]): CE_POINTER [PD_LINK]
		local
			l_l1: CE_POINTER [PD_LINK]
			l_l2: CE_POINTER [PD_LINK]
			l_l: CE_POINTER [PD_LINK]
			l_i: INTEGER_32
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_l1.make
			create l_l2.make
			create l_l.make

			l_l1.ce_gets ((a_f.item.f_data).item.links + (a_f.item.f_data).item.nlinks)
			l_l2.ce_gets ((a_f.item.f_data).item.links)
			if not ((a_f.item.f_data).item.nlinks).to_boolean then
				Result := (create {CE_POINTER [PD_LINK]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				if a_ev.item.x < 0 then
					Result := (create {CE_POINTER [PD_LINK]}.make_shared (default_pointer))
					js.return
				elseif a_ev.item.y < 0 then
					Result := (create {CE_POINTER [PD_LINK]}.make_shared (default_pointer))
					js.return
				elseif a_ev.item.x >= (a_f.item.xw).to_integer_32 then
					Result := (create {CE_POINTER [PD_LINK]}.make_shared (default_pointer))
					js.return
				elseif a_ev.item.y >= (a_f.item.yw).to_integer_32 then
					Result := (create {CE_POINTER [PD_LINK]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				l_i := (a_f.item.vs).item.view_pos
				from
				until
					js.loop_left
				loop
					js.reset
					if l_i < (a_f.item.f_data).item.y then
						if not (l_i < (a_f.item.vs).item.view_pos + a_f.item.yw) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						if (((a_f.item.f_data).item.lines1[l_i]).c_pointer /= default_pointer) then
							if (((a_f.item.f_data).item.lines1[l_i]).c_pointer.to_integer_32).to_natural_32 < (l_l1.c_pointer.to_integer_32).to_natural_32 then
								l_l1.ce_gets ((a_f.item.f_data).item.lines1[l_i])
							end
						end
						if (((a_f.item.f_data).item.lines2[l_i]).c_pointer /= default_pointer) then
							if (((a_f.item.f_data).item.lines2[l_i]).c_pointer.to_integer_32).to_natural_32 > (l_l2.c_pointer.to_integer_32).to_natural_32 then
								l_l2.ce_gets ((a_f.item.f_data).item.lines2[l_i])
							end
						end
						l_i := l_i + 1
					end
				end
				js.reset
				l_l.ce_gets (l_l1)
				from
				until
					not (not js.loop_left and then ((l_l.c_pointer.to_integer_32).to_natural_32 <= (l_l2.c_pointer.to_integer_32).to_natural_32))
				loop
					l_i___0 := 0
					from
					until
						not (not js.loop_left and then (l_i___0 < l_l.item.n))
					loop
						if ((l_l.item.pos + l_i___0).item.x - (a_f.item.vs).item.view_posx).to_integer_32 = a_ev.item.x then
							if ((l_l.item.pos + l_i___0).item.y - (a_f.item.vs).item.view_pos).to_integer_32 = a_ev.item.y then
								Result := l_l
								js.return
							end
						end
						if not js.return_called then
							l_i___0 := l_i___0 + 1
						end
					end
					if not js.return_called then
						l_l.ce_gets (l_l + 1)
					end
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [PD_LINK]}.make_shared (default_pointer))
			end
		end

	goto_link_number (a_ses: CE_POINTER [PD_SESSION]; a_num: CE_POINTER [NATURAL_8])
		local
			l_n: INTEGER_32
			l_f: CE_POINTER [PD_F_DATA_C]
			l_link___0: CE_POINTER [PD_LINK]
			js: JUMP_STATE
		do
			create l_f.make
			create l_link___0.make

			l_n := (atoi (create {CE_POINTER [INTEGER_8]}.make_cast (a_num)))
			l_f.ce_gets ((current_frame (a_ses)))
			if (l_f).c_pointer = default_pointer then
				js.return
			elseif (l_f.item.vs).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				if l_n < 0 then
					js.return
				elseif l_n > (l_f.item.f_data).item.nlinks then
					js.return
				end
			end
			if not js.return_called then
				(l_f.item.vs).item.current_link := l_n - 1;
				(l_f.item.vs).item.orig_link := (l_f.item.vs).item.current_link
				l_link___0.ce_gets ((l_f.item.f_data).item.links + (l_f.item.vs).item.current_link)
				check_vs (l_f);
				(l_f.item.vs).item.orig_view_pos := (l_f.item.vs).item.view_pos;
				(l_f.item.vs).item.orig_view_posx := (l_f.item.vs).item.view_posx
				if l_link___0.item.type /= 5 then
					if l_link___0.item.type /= 4 then
						enter (a_ses, l_f, 0).do_nothing
					end
				end
			end
		end

	goto_link_number_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent goto_link_number)
		end

	frame_ev (a_ses: CE_POINTER [PD_SESSION]; a_fd: CE_POINTER [PD_F_DATA_C]; a_ev: CE_POINTER [PD_EVENT]): INTEGER_32
		local
			l_x: INTEGER_32
			l_tmp___0: INTEGER_32
			l_current_link: CE_POINTER [INTEGER_8]
			l_f_data: CE_POINTER [PD_F_DATA]
			l_nl: INTEGER_32
			l_lnl: INTEGER_32
			l_d: CE_ARRAY [NATURAL_8]
			l_l: CE_POINTER [PD_LINK]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_current_link.make
			create l_f_data.make
			create l_d.make (<<2>>)
			create l_l.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_x := 1
					if not ((a_fd.item.vs).item.current_link >= 0) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if ((a_fd.item.f_data).item.links + (a_fd.item.vs).item.current_link).item.type /= 4 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if ((a_fd.item.f_data).item.links + (a_fd.item.vs).item.current_link).item.type /= 5 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if (field_op (a_ses, a_fd, (a_fd.item.f_data).item.links + (a_fd.item.vs).item.current_link, a_ev, 0)).to_boolean then
							Result := 1
							js.return
						end
				when 6 then -- if done | if done
						if not (not js.return_called and then (a_ev.item.ev = 1)) then
							l_pos := -1 + 14 -- skip if block
						end
				when 7 then -- if:
							if not (a_ev.item.x >= (48 + (not (a_ses.item.kbdprefix.rep).to_boolean).to_integer).to_integer_32) then
								l_pos := -1 + 14 -- skip if block
							end
				when 8 then -- if:
							if not (a_ev.item.x <= 57) then
								l_pos := -1 + 14 -- skip if block
							end
				when 9 then -- if:
							if ((a_fd.item.f_data).item.opt.num_links).to_boolean then
								l_pos := -1 + 12 -- skip if block
							end
				when 10 then -- if:
							l_pos := -1 + 13 -- goto _L___0
				when 11 then -- if block done, skip else block:
							l_pos := -1 + 14
				when 12 then -- else:
							if not ((a_ev.item.y).to_boolean) then
								l_pos := -1 + 14 -- skip if block
							end
				when 13 then -- if: | _L___0:
							if not (a_ses.item.kbdprefix.rep).to_boolean then
								a_ses.item.kbdprefix.rep_num := 0
							end
							l_tmp___0 := (((a_ses.item.kbdprefix.rep_num * 10).to_integer_32 + a_ev.item.x) - 48).to_integer_32
							a_ses.item.kbdprefix.rep_num := l_tmp___0
							if l_tmp___0 > 65536 then
								a_ses.item.kbdprefix.rep_num := 65536
							end
							a_ses.item.kbdprefix.rep := 1
							Result := 1
							js.return
				when 14 then -- if done | if done | if done | if done
							if js.return_called then
								l_pos := -1 + 54 -- skip if block
							end
				when 15 then -- if:
								if a_ev.item.ev /= 1 then
									l_pos := -1 + 38 -- skip if block
								end
				when 16 then -- if:
								inspect (kbdbind_inst.kbd_action (0, a_ev)) -- switch 1 head
								when 28 then l_pos := -1 + 17
								when 29 then l_pos := -1 + 18
								when 9 then l_pos := -1 + 19
								when 45 then l_pos := -1 + 20
								when 5 then l_pos := -1 + 21
								when 39 then l_pos := -1 + 22
								when 36 then l_pos := -1 + 23
								when 37 then l_pos := -1 + 24
								when 38 then l_pos := -1 + 25
								when 20 then l_pos := -1 + 26
								when 11 then l_pos := -1 + 27
								when 12 then l_pos := -1 + 28
								when 10 then l_pos := -1 + 29
								when 40 then l_pos := -1 + 30
								when 41 then l_pos := -1 + 31
								when 14 then l_pos := -1 + 32
								when 15 then l_pos := -1 + 33
								when 47 then l_pos := -1 + 34
								when 46 then l_pos := -1 + 35
								else l_pos := -1 + 36
								end
				when 17 then -- switch 1, case 28
								rep_ev (a_ses, a_fd, page_down_address, 0)
								l_pos := -1 + 37 -- switch 1; break
				when 18 then -- switch 1, case 29
								rep_ev (a_ses, a_fd, page_up_address, 0)
								l_pos := -1 + 37 -- switch 1; break
				when 19 then -- switch 1, case 9
								rep_ev (a_ses, a_fd, down_address, 0)
								l_pos := -1 + 37 -- switch 1; break
				when 20 then -- switch 1, case 45
								rep_ev (a_ses, a_fd, up_address, 0)
								l_pos := -1 + 37 -- switch 1; break
				when 21 then -- switch 1, case 5
								l_current_link.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((print_current_link (a_ses))))
								if ((l_current_link).c_pointer /= default_pointer) then
									os_dep_inst.set_clipboard_text (l_current_link)
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2031, create {CE_POINTER [ANY]}.make_cast (l_current_link))
								end
								l_pos := -1 + 37 -- switch 1; break
				when 22 then -- switch 1, case 39
								rep_ev (a_ses, a_fd, scroll_dirty_workaround_for_name_clash_with_libraries_on_macos_address, -1 - (not (a_ses.item.kbdprefix.rep).to_boolean).to_integer)
								l_pos := -1 + 37 -- switch 1; break
				when 23 then -- switch 1, case 36
								rep_ev (a_ses, a_fd, scroll_dirty_workaround_for_name_clash_with_libraries_on_macos_address, 1 + (not (a_ses.item.kbdprefix.rep).to_boolean).to_integer)
								l_pos := -1 + 37 -- switch 1; break
				when 24 then -- switch 1, case 37
								rep_ev (a_ses, a_fd, hscroll_address, -1 - 7 * (not (a_ses.item.kbdprefix.rep).to_boolean).to_integer)
								l_pos := -1 + 37 -- switch 1; break
				when 25 then -- switch 1, case 38
								rep_ev (a_ses, a_fd, hscroll_address, 1 + 7 * (not (a_ses.item.kbdprefix.rep).to_boolean).to_integer)
								l_pos := -1 + 37 -- switch 1; break
				when 26 then -- switch 1, case 20
								rep_ev (a_ses, a_fd, home_address, 0)
								l_pos := -1 + 37 -- switch 1; break
				when 27 then -- switch 1, case 11
								rep_ev (a_ses, a_fd, x_end_address, 0)
								l_pos := -1 + 37 -- switch 1; break
				when 28 then -- switch 1, case 12
								l_x := enter (a_ses, a_fd, 0)
								l_pos := -1 + 37 -- switch 1; break
				when 29 then -- switch 1, case 10
								if not default_inst.anonymous.to_boolean then
									frm_download (a_ses, a_fd)
								end
								l_pos := -1 + 37 -- switch 1; break
				when 30 then -- switch 1, case 40
								menu_inst.search_dlg (a_ses, a_fd, 0)
								l_pos := -1 + 37 -- switch 1; break
				when 31 then -- switch 1, case 41
								menu_inst.search_back_dlg (a_ses, a_fd, 0)
								l_pos := -1 + 37 -- switch 1; break
				when 32 then -- switch 1, case 14
								find_next (a_ses, a_fd, 0)
								l_pos := -1 + 37 -- switch 1; break
				when 33 then -- switch 1, case 15
								find_next_back (a_ses, a_fd, 0)
								l_pos := -1 + 37 -- switch 1; break
				when 34 then -- switch 1, case 47
								set_frame (a_ses, a_fd, 0)
								l_x := 2
								l_pos := -1 + 37 -- switch 1; break
				when 35 then -- switch 1, case 46
								send_image (a_ses.item.term, create {CE_POINTER [ANY]}.make_shared (default_pointer), a_ses)
								l_pos := -1 + 37 -- switch 1; break
				when 36 then -- switch 1, default:
								if a_ev.item.x >= 49 then
									if a_ev.item.x <= 57 then
										if not (a_ev.item.y).to_boolean then
											l_f_data.ce_gets (a_fd.item.f_data)
											l_d[0] := (a_ev.item.x).to_natural_8
											l_d[1] := (0).to_natural_8
											l_nl := l_f_data.item.nlinks
											l_lnl := 1
											from
											until
												not (l_nl.to_boolean)
											loop
												l_nl := l_nl // (10)
												l_lnl := l_lnl + 1
											end
											if l_lnl > 1 then
												bfu_inst.input_field (a_ses.item.term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 258, links_inst.dummyarray + 259, links_inst.dummyarray + 14, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_cast (a_ses), create {CE_POINTER [PD_HISTORY]}.make_shared (default_pointer), l_lnl, l_d, 1, l_f_data.item.nlinks, bfu_inst.check_number_address, (goto_link_number_address), create {CE_ROUTINE}.make_shared (default_pointer))
											end
										else
											l_x := 0
										end
									else
										l_x := 0
									end
								else
									l_x := 0
								end
				when 37 then -- switch 1, done: | if block done, skip else block:
								l_pos := -1 + 53
				when 38 then -- else:
								if a_ev.item.ev /= 2 then
									l_pos := -1 + 52 -- skip if block
								end
				when 39 then -- if:
								l_l.ce_gets ((choose_mouse_link (a_fd, a_ev)))
								if (l_l).c_pointer = default_pointer then
									l_pos := -1 + 51 -- skip if block
								end
				when 40 then -- if:
								l_x := 1;
								(a_fd.item.vs).item.current_link := l_l.distance (((a_fd.item.f_data).item.links));
								(a_fd.item.vs).item.orig_link := (a_fd.item.vs).item.current_link
								if l_l.item.type /= 0 then
									l_pos := -1 + 43 -- skip if block
								end
				when 41 then -- if:
								l_pos := -1 + 50 -- goto _L___1
				when 42 then -- if block done, skip else block:
								l_pos := -1 + 51
				when 43 then -- else:
								if l_l.item.type /= 1 then
									l_pos := -1 + 46 -- skip if block
								end
				when 44 then -- if:
								l_pos := -1 + 50 -- goto _L___1
				when 45 then -- if block done, skip else block:
								l_pos := -1 + 51
				when 46 then -- else:
								if l_l.item.type /= 2 then
									l_pos := -1 + 49 -- skip if block
								end
				when 47 then -- if:
								l_pos := -1 + 50 -- goto _L___1
				when 48 then -- if block done, skip else block:
								l_pos := -1 + 51
				when 49 then -- else:
								if l_l.item.type /= 3 then
									l_pos := -1 + 51 -- skip if block
								end
				when 50 then -- if: | _L___1:
								if ((a_ev.item.b).bit_and (12)) = 4 then
									draw_doc (a_ses.item.term, a_fd, 1)
									session_inst.print_screen_status (a_ses)
									terminal_inst.redraw_from_window (a_ses.item.win)
									if ((a_ev.item.b).bit_and (3)) < 1 then
										l_x := enter (a_ses, a_fd, 0)
									else
										link_menu (a_ses.item.term, create {CE_POINTER [ANY]}.make_shared (default_pointer), a_ses)
									end
								end
				when 51 then -- if done | if done | if done | if done | if done | if block done, skip else block:
								l_pos := -1 + 53
				when 52 then -- else:
								l_x := 0
				when 53 then -- if done
								a_ses.item.kbdprefix.rep := 0
								Result := l_x
				when 54 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	current_frame (a_ses: CE_POINTER [PD_SESSION]): CE_POINTER [PD_F_DATA_C]
		local
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_i: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_fd.make

			l_fd.ce_gets (create {CE_POINTER [PD_F_DATA_C]}.make_shared (default_pointer))
			if ((a_ses.item.history.next).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
				Result := (create {CE_POINTER [PD_F_DATA_C]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_i := (create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)).item.vs.current_link
				l_fd.ce_gets (create {CE_POINTER [PD_F_DATA_C]}.make_cast (a_ses.item.scrn_frames.next))
				from
				until
					not (not js.loop_left and then ((l_fd.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.scrn_frames_offset)).c_pointer.to_integer_32).to_natural_32))
				loop
					js.reset
					if ((l_fd.item.f_data).c_pointer /= default_pointer) then
						if ((l_fd.item.f_data).item.frame).to_boolean then
							js.continue
						end
					end
					if not js.loop_jumped then
						l_tmp := l_i
						l_i := l_i - 1
						if not l_tmp.to_boolean then
							Result := l_fd
							js.return
						end
					end
					if not js.loop_left then
						l_fd.ce_gets (l_fd.item.next)
					end
				end
			end
			if not js.return_called then
				if (a_ses.item.screen).c_pointer = default_pointer then
					Result := (create {CE_POINTER [PD_F_DATA_C]}.make_shared (default_pointer))
					js.return
				elseif ((a_ses.item.screen).item.f_data).c_pointer = default_pointer then
					Result := (create {CE_POINTER [PD_F_DATA_C]}.make_shared (default_pointer))
					js.return
				elseif (((a_ses.item.screen).item.f_data).item.frame).to_boolean then
					Result := (create {CE_POINTER [PD_F_DATA_C]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				Result := (a_ses.item.screen)
			end
		end

	send_to_frame (a_ses: CE_POINTER [PD_SESSION]; a_ev: CE_POINTER [PD_EVENT]): INTEGER_32
		local
			l_r: INTEGER_32
			l_fd: CE_POINTER [PD_F_DATA_C]
			js: JUMP_STATE
		do
			create l_fd.make

			l_fd.ce_gets (current_frame (a_ses))
			if (l_fd).c_pointer = default_pointer then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_r := frame_ev (a_ses, l_fd, a_ev)
				if l_r = 1 then
					draw_doc (a_ses.item.term, l_fd, 1)
					session_inst.print_screen_status (a_ses)
					terminal_inst.redraw_from_window (a_ses.item.win)
				end
				Result := l_r
			end
		end

	next_frame (a_ses: CE_POINTER [PD_SESSION]; a_p: INTEGER_32)
		local
			l_n: INTEGER_32
			l_vs: CE_POINTER [PD_VIEW_STATE]
			l_fd: CE_POINTER [PD_F_DATA_C]
			js: JUMP_STATE
		do
			create l_vs.make
			create l_fd.make

			if ((a_ses.item.history.next).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
				js.return
			elseif ((a_ses.item.screen).c_pointer /= default_pointer) then
				if (((a_ses.item.screen).item.f_data).c_pointer /= default_pointer) then
					if not (((a_ses.item.screen).item.f_data).item.frame).to_boolean then
						js.return
					end
				end
			end
			if not js.return_called then
				l_vs.ce_gets (create {CE_POINTER [PD_VIEW_STATE]}.make_shared ((create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)).c_pointer + {PD_LOCATION}.vs_offset))
				l_n := 0
				l_fd.ce_gets (create {CE_POINTER [PD_F_DATA_C]}.make_cast (a_ses.item.scrn_frames.next))
				from
				until
					(l_fd.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.scrn_frames_offset)).c_pointer.to_integer_32).to_natural_32
				loop
					if ((l_fd.item.f_data).c_pointer /= default_pointer) then
						if not ((l_fd.item.f_data).item.frame).to_boolean then
							l_n := l_n + 1
						end
					else
						l_n := l_n + 1
					end
					l_fd.ce_gets (l_fd.item.next)
				end
				l_vs.item.current_link := l_vs.item.current_link + a_p
				if not l_n.to_boolean then
					l_n := 1
				end
				from
				until
					not (l_vs.item.current_link < 0)
				loop
					l_vs.item.current_link := l_vs.item.current_link + l_n
				end
				l_vs.item.current_link := l_vs.item.current_link \\ l_n
			end
		end

	do_for_frame (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_ROUTINE; a_a: INTEGER_32)
		local
			l_fd: CE_POINTER [PD_F_DATA_C]
			js: JUMP_STATE
		do
			create l_fd.make

			l_fd.ce_gets ((current_frame (a_ses)))
			if (l_fd).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				a_f.call ([a_ses, l_fd, a_a])
				draw_doc (a_ses.item.term, l_fd, 1)
				session_inst.print_screen_status (a_ses)
				terminal_inst.redraw_from_window (a_ses.item.win)
			end
		end

	do_mouse_event (a_ses: CE_POINTER [PD_SESSION]; a_ev: CE_POINTER [PD_EVENT])
		local
			l_evv: PD_EVENT
			l_fdd: CE_POINTER [PD_F_DATA_C]
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_o: CE_POINTER [PD_DOCUMENT_OPTIONS]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_evv.make
			create l_fdd.make
			create l_fd.make
			create l_o.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fd.ce_gets ((current_frame (a_ses)))
					if (l_fd).c_pointer = default_pointer then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						l_o.ce_gets (create {CE_POINTER [PD_DOCUMENT_OPTIONS]}.make_shared ((l_fd.item.f_data).c_pointer + {PD_F_DATA}.opt_offset))
						if a_ev.item.x >= (l_o.item.xp).to_integer_32 then
							if a_ev.item.x < (l_o.item.xp + l_o.item.xw).to_integer_32 then
								if a_ev.item.y >= (l_o.item.yp).to_integer_32 then
									if a_ev.item.y < (l_o.item.yp + l_o.item.yw).to_integer_32 then
										l_pos := -1 + 6 -- goto ok
									end
								end
							end
						end
				when 2 then -- r:
						next_frame (a_ses, 1)
						l_fdd.ce_gets (current_frame (a_ses))
						l_o.ce_gets (create {CE_POINTER [PD_DOCUMENT_OPTIONS]}.make_shared ((l_fdd.item.f_data).c_pointer + {PD_F_DATA}.opt_offset))
						if a_ev.item.x >= (l_o.item.xp).to_integer_32 then
							if a_ev.item.x < (l_o.item.xp + l_o.item.xw).to_integer_32 then
								if a_ev.item.y >= (l_o.item.yp).to_integer_32 then
									if a_ev.item.y < (l_o.item.yp + l_o.item.yw).to_integer_32 then
										draw_formatted (a_ses)
										l_fd.ce_gets (l_fdd)
										l_pos := -1 + 6 -- goto ok
									end
								end
							end
						end
				when 3 then
						if (l_fdd.c_pointer.to_integer_32).to_natural_32 /= (l_fd.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 2 -- goto r
						end
				when 4 then
						js.return
				when 5 then -- if done
					if js.return_called then
						l_pos := -1 + 7 -- skip if block
					end
				when 6 then -- if: | ok:
						memcpy (create {CE_POINTER [ANY]}.make_cast ((l_evv.address)), create {CE_POINTER [ANY]}.make_cast (a_ev), {PD_EVENT}.sizeof.to_natural_32).do_nothing
						l_evv.x := l_evv.x - (l_fd.item.xp).to_integer_32
						l_evv.y := l_evv.y - (l_fd.item.yp).to_integer_32
						send_to_frame (a_ses, l_evv.address).do_nothing
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	send_event (a_ses: CE_POINTER [PD_SESSION]; a_ev: CE_POINTER [PD_EVENT])
		local
			l_s: CE_POINTER [NATURAL_8]
			l_url: CE_ARRAY [NATURAL_8]
			l_m: CE_POINTER [PD_WINDOW]
			l_m___0: CE_POINTER [PD_WINDOW]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_url.make (<<1024>>)
			create l_m.make
			create l_m___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_ev.item.ev /= 1 then
						l_pos := -1 + 29 -- skip if block
					end
				when 1 then -- if:
						if (send_to_frame (a_ses, a_ev)).to_boolean then
							js.return
						end
						if js.return_called then
							l_pos := -1 + 29 -- skip if block
						end
				when 2 then -- if:
						inspect (kbdbind_inst.kbd_action (0, a_ev)) -- switch 1 head
						when 24 then l_pos := -1 + 3
						when 13 then l_pos := -1 + 4
						when 25 then l_pos := -1 + 5
						when 31 then l_pos := -1 + 6
						when 2 then l_pos := -1 + 7
						when 34 then l_pos := -1 + 8
						when 16 then l_pos := -1 + 9
						when 17 then l_pos := -1 + 10
						when 18 then l_pos := -1 + 12
						when 0 then l_pos := -1 + 14
						when 4 then l_pos := -1 + 15
						when 32 then l_pos := -1 + 16
						when 33 then l_pos := -1 + 17
						when 8 then l_pos := -1 + 18
						when 19 then l_pos := -1 + 19
						when 42 then l_pos := -1 + 20
						when 43 then l_pos := -1 + 21
						when 44 then l_pos := -1 + 22
						when 26 then l_pos := -1 + 23
						when 27 then l_pos := -1 + 24
						else l_pos := -1 + 25
						end
				when 3 then -- switch 1, case 24
						menu_inst.activate_bfu_technology (a_ses, -1)
						l_pos := -1 + 35 -- goto x
				when 4 then -- switch 1, case 13
						menu_inst.activate_bfu_technology (a_ses, 0)
						l_pos := -1 + 35 -- goto x
				when 5 then -- switch 1, case 25
						next_frame (a_ses, 1)
						draw_formatted (a_ses)
						l_pos := -1 + 35 -- goto x
				when 6 then -- switch 1, case 31
						next_frame (a_ses, -1)
						draw_formatted (a_ses)
						l_pos := -1 + 35 -- goto x
				when 7 then -- switch 1, case 2
						back (a_ses, create {CE_POINTER [PD_F_DATA_C]}.make_shared (default_pointer), 0)
						l_pos := -1 + 35 -- goto x
				when 8 then -- switch 1, case 34
						session_inst.reload (a_ses, -1)
						l_pos := -1 + 35 -- goto x
				when 9 then -- quak: | switch 1, case 16
						menu_inst.dialog_goto_url (a_ses, ce_string (""))
						l_pos := -1 + 35 -- goto x
				when 10 then -- switch 1, case 17
						if ((a_ses.item.history.next).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 9 -- goto quak
						end
				when 11 then
						l_s.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2229, (create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)).item.vs.url))
						if (((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), 1))).c_pointer /= default_pointer) then
							(strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), 1))[0] := (0).to_integer_8
						end
						menu_inst.dialog_goto_url (a_ses, create {CE_POINTER [INTEGER_8]}.make_cast (l_s))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2232, create {CE_POINTER [ANY]}.make_cast (l_s))
						l_pos := -1 + 35 -- goto x
				when 12 then -- switch 1, case 18
						if ((session_inst.get_current_link_url (a_ses, l_url, (Natural_8_bytes.to_natural_32 * (1024).to_natural_32)))).c_pointer = default_pointer then
							l_pos := -1 + 9 -- goto quak
						end
				when 13 then
						menu_inst.dialog_goto_url (a_ses, create {CE_POINTER [INTEGER_8]}.make_cast (l_url))
						l_pos := -1 + 35 -- goto x
				when 14 then -- switch 1, case 0
						if not default_inst.anonymous.to_boolean then
							bookmark_inst.launch_bm_add_doc_dialog (a_ses.item.term, create {CE_POINTER [PD_DIALOG_DATA]}.make_shared (default_pointer), a_ses)
						end
						l_pos := -1 + 35 -- goto x
				when 15 then -- switch 1, case 4
						if not default_inst.anonymous.to_boolean then
							bookmark_inst.menu_bookmark_manager (a_ses.item.term, create {CE_POINTER [ANY]}.make_shared (default_pointer), a_ses)
						end
						l_pos := -1 + 35 -- goto x
				when 16 then -- switch 1, case 32
						menu_inst.exit_prog (a_ses.item.term, create {CE_POINTER [ANY]}.make_shared (default_pointer + 1), a_ses)
						l_pos := -1 + 35 -- goto x
				when 17 then -- quit: | switch 1, case 33
						menu_inst.exit_prog (a_ses.item.term, create {CE_POINTER [ANY]}.make_shared (default_pointer + (a_ev.item.x = 512).to_integer), a_ses)
						l_pos := -1 + 35 -- goto x
				when 18 then -- switch 1, case 8
						state_msg (a_ses)
						l_pos := -1 + 35 -- goto x
				when 19 then -- switch 1, case 19
						head_msg (a_ses)
						l_pos := -1 + 35 -- goto x
				when 20 then -- switch 1, case 42
						a_ses.item.ds.images := (not (a_ses.item.ds.images).to_boolean).to_integer
						html_r_inst.html_interpret (a_ses)
						draw_formatted (a_ses)
						l_pos := -1 + 35 -- goto x
				when 21 then -- switch 1, case 43
						a_ses.item.ds.tables := (not (a_ses.item.ds.tables).to_boolean).to_integer
						html_r_inst.html_interpret (a_ses)
						draw_formatted (a_ses)
						l_pos := -1 + 35 -- goto x
				when 22 then -- switch 1, case 44
						toggle (a_ses, a_ses.item.screen, 0)
						l_pos := -1 + 35 -- goto x
				when 23 then -- switch 1, case 26
						open_in_new_window (a_ses.item.term, send_open_new_xterm_address, a_ses)
						l_pos := -1 + 35 -- goto x
				when 24 then -- switch 1, case 27
						open_in_new_window (a_ses.item.term, send_open_in_new_xterm_address, a_ses)
						l_pos := -1 + 35 -- goto x
				when 25 then -- switch 1, default:
						if a_ev.item.x = 512 then
							l_pos := -1 + 17 -- goto quit
						end
				when 26 then
						if not (((a_ev.item.y).bit_and (4)).to_boolean) then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						a_ev.item.y := (a_ev.item.y).bit_and ((-5))
						menu_inst.activate_bfu_technology (a_ses, -1)
						l_m.ce_gets (create {CE_POINTER [PD_WINDOW]}.make_cast ((a_ses.item.term).item.windows.next));
						(l_m.item.handler).call ([l_m, a_ev, 0])
						if (((a_ses.item.term).item.windows.next).c_pointer.to_integer_32).to_natural_32 = (l_m.c_pointer.to_integer_32).to_natural_32 then
							terminal_inst.delete_window (l_m)
						else
							l_pos := -1 + 35 -- goto x
						end
				when 28 then
						a_ev.item.y := (a_ev.item.y).bit_or ((4))
				when 29 then -- switch 1, done: | if done | if done
						if js.return_called then
							l_pos := -1 + 34 -- skip if block
						end
				when 30 then -- if:
							if a_ev.item.ev /= 2 then
								l_pos := -1 + 33 -- skip if block
							end
				when 31 then -- if:
							if a_ev.item.y = 0 then
								if ((a_ev.item.b).bit_and (12)) = 0 then
									menu_inst.activate_bfu_technology (a_ses, -1)
									l_m___0.ce_gets (create {CE_POINTER [PD_WINDOW]}.make_cast ((a_ses.item.term).item.windows.next));
									(l_m___0.item.handler).call ([l_m___0, a_ev, 0])
									l_pos := -1 + 35 -- goto x
								end
							end
				when 32 then
							do_mouse_event (a_ses, a_ev)
				when 33 then -- if done
							js.return
				when 34 then -- if done
						if js.return_called then
							l_pos := -1 + 36 -- skip if block
						end
				when 35 then -- if: | x:
							a_ses.item.kbdprefix.rep := 0
				when 36 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	send_enter (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_ev: PD_EVENT
		do
			create l_ev.make

			l_ev.ev := 1
			l_ev.x := 256
			l_ev.y := 0
			l_ev.b := 0
			send_event (a_ses, l_ev.address)
		end

	send_enter_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent send_enter)
		end

	frm_download (a_ses: CE_POINTER [PD_SESSION]; a_fd: CE_POINTER [PD_F_DATA_C])
		local
			l_link___0: CE_POINTER [PD_LINK]
			l_tmp___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_link___0.make
			create l_tmp___0.make

			if (a_fd.item.vs).item.current_link = -1 then
				js.return
			elseif (a_fd.item.vs).item.current_link >= (a_fd.item.f_data).item.nlinks then
				js.return
			end
			if not js.return_called then
				if ((a_ses.item.dn_url).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2319, create {CE_POINTER [ANY]}.make_cast (a_ses.item.dn_url))
					a_ses.item.dn_url := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				end
				l_link___0.ce_gets ((a_fd.item.f_data).item.links + (a_fd.item.vs).item.current_link)
				if l_link___0.item.type /= 0 then
					if l_link___0.item.type /= 1 then
						js.return
					end
				end
			end
			if not js.return_called then
				l_tmp___0.ce_gets (get_link_url (a_ses, a_fd, l_link___0))
				a_ses.item.dn_url := l_tmp___0
				if ((l_tmp___0).c_pointer /= default_pointer) then
					if not (links_inst.casecmp (a_ses.item.dn_url, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("MAP@")), (4).to_natural_32)).to_boolean then
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2324, create {CE_POINTER [ANY]}.make_cast (a_ses.item.dn_url))
						a_ses.item.dn_url := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						js.return
					end
					if not js.return_called then
						menu_inst.query_file (a_ses, a_ses.item.dn_url, session_inst.start_download_address, create {CE_ROUTINE}.make_shared (default_pointer))
					end
				end
			end
			if not js.return_called then
			end
		end

	send_download_image (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_tmp___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_fd.make
			create l_tmp___0.make

			l_fd.ce_gets ((current_frame (a_ses)))
			if (l_fd).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called and then ((l_fd.item.vs).item.current_link = -1) then
				js.return
			end
			if not js.return_called then
				if ((a_ses.item.dn_url).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2337, create {CE_POINTER [ANY]}.make_cast (a_ses.item.dn_url))
				end
				l_tmp___0.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2338, ((l_fd.item.f_data).item.links + (l_fd.item.vs).item.current_link).item.where_img))
				a_ses.item.dn_url := l_tmp___0
				if ((l_tmp___0).c_pointer /= default_pointer) then
					menu_inst.query_file (a_ses, a_ses.item.dn_url, session_inst.start_download_address, create {CE_ROUTINE}.make_shared (default_pointer))
				end
			end
		end

	send_download_image_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent send_download_image)
		end

	send_download (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_tmp___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_fd.make
			create l_tmp___0.make

			l_fd.ce_gets ((current_frame (a_ses)))
			if (l_fd).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called and then ((l_fd.item.vs).item.current_link = -1) then
				js.return
			end
			if not js.return_called then
				if ((a_ses.item.dn_url).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2347, create {CE_POINTER [ANY]}.make_cast (a_ses.item.dn_url))
				end
				l_tmp___0.ce_gets (get_link_url (a_ses, l_fd, (l_fd.item.f_data).item.links + (l_fd.item.vs).item.current_link))
				a_ses.item.dn_url := l_tmp___0
				if ((l_tmp___0).c_pointer /= default_pointer) then
					menu_inst.query_file (a_ses, a_ses.item.dn_url, session_inst.start_download_address, create {CE_ROUTINE}.make_shared (default_pointer))
				end
			end
		end

	send_download_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent send_download)
		end

	send_open_in_new_xterm (a_term: CE_POINTER [PD_TERMINAL]; a_open_window: CE_ROUTINE; a_ses: CE_POINTER [PD_SESSION])
		local
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_enc_url: CE_POINTER [NATURAL_8]
			l_path: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_fd.make
			create l_enc_url.make
			create l_path.make
			create l_tmp___2.make

			l_fd.ce_gets ((current_frame (a_ses)))
			if (l_fd).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called and then ((l_fd.item.vs).item.current_link = -1) then
				js.return
			end
			if not js.return_called then
				if ((a_ses.item.dn_url).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2358, create {CE_POINTER [ANY]}.make_cast (a_ses.item.dn_url))
				end
				l_tmp___2.ce_gets (get_link_url (a_ses, l_fd, (l_fd.item.f_data).item.links + (l_fd.item.vs).item.current_link))
				a_ses.item.dn_url := l_tmp___2
				if ((l_tmp___2).c_pointer /= default_pointer) then
					l_enc_url.ce_gets ((session_inst.encode_url (a_ses.item.dn_url)))
					l_path.ce_gets ((os_dep_inst.escape_path (links_inst.path_to_exe)))
					a_open_window.call ([a_term, l_path, l_enc_url])
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2363, create {CE_POINTER [ANY]}.make_cast (l_enc_url))
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2364, create {CE_POINTER [ANY]}.make_cast (l_path))
				end
			end
		end

	send_open_in_new_xterm_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent send_open_in_new_xterm)
		end

	send_open_new_xterm (a_term: CE_POINTER [PD_TERMINAL]; a_open_window: CE_ROUTINE; a_ses: CE_POINTER [PD_SESSION])
		local
			l_l: INTEGER_32
			l_path: CE_POINTER [NATURAL_8]
		do
			create l_path.make

			if ((a_ses.item.dn_url).c_pointer /= default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2372, create {CE_POINTER [ANY]}.make_cast (a_ses.item.dn_url))
			end
			a_ses.item.dn_url := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2373)
			l_l := 0
			links_inst.add_to_str (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (a_ses.c_pointer + {PD_SESSION}.dn_url_offset), create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("-base-session ")))
			links_inst.add_num_to_str (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (a_ses.c_pointer + {PD_SESSION}.dn_url_offset), create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (a_ses.item.id).to_integer_32)
			l_path.ce_gets (os_dep_inst.escape_path (links_inst.path_to_exe))
			a_open_window.call ([a_term, l_path, a_ses.item.dn_url])
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2379, create {CE_POINTER [ANY]}.make_cast (l_path))
		end

	send_open_new_xterm_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent send_open_new_xterm)
		end

	open_in_new_window (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_ROUTINE; a_ses: CE_POINTER [PD_SESSION])
		local
			l_mi: CE_POINTER [PD_MENU_ITEM]
			l_oin: CE_POINTER [PD_OPEN_IN_NEW]
			l_oi: CE_POINTER [PD_OPEN_IN_NEW]
			js: JUMP_STATE
		do
			create l_mi.make
			create l_oin.make
			create l_oi.make

			l_oin.ce_gets (os_dep_inst.get_open_in_new (a_term.item.environment))
			if (l_oin).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called and then (((l_oin + 1).item.text).c_pointer = default_pointer) then
				a_xxx.call ([a_term, (l_oin + 0).item.fn, a_ses])
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2389, create {CE_POINTER [ANY]}.make_cast (l_oin))
				js.return
			end
			if not js.return_called then
				l_mi.ce_gets (bfu_inst.new_menu (1))
				if (l_mi).c_pointer = default_pointer then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2393, create {CE_POINTER [ANY]}.make_cast (l_oin))
					js.return
				end
			end
			if not js.return_called then
				l_oi.ce_gets (l_oin)
				from
				until
					(l_oi.item.text).c_pointer = default_pointer
				loop
					bfu_inst.add_to_menu (l_mi.address, l_oi.item.text, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), l_oi.item.hk, a_xxx, create {CE_POINTER [ANY]}.make_cast (l_oi.item.fn), 0)
					l_oi.ce_gets (l_oi + 1)
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2397, create {CE_POINTER [ANY]}.make_cast (l_oin))
				bfu_inst.do_menu (a_term, l_mi, create {CE_POINTER [ANY]}.make_cast (a_ses))
			end
		end

	open_in_new_window_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent open_in_new_window)
		end

	can_open_in_new (a_term: CE_POINTER [PD_TERMINAL]): INTEGER_32
		local
			l_oin: CE_POINTER [PD_OPEN_IN_NEW]
			js: JUMP_STATE
		do
			create l_oin.make

			l_oin.ce_gets ((os_dep_inst.get_open_in_new (a_term.item.environment)))
			if (l_oin).c_pointer = default_pointer then
				Result := 0
				js.return
			end
			if not js.return_called and then (((l_oin + 1).item.text).c_pointer = default_pointer) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2406, create {CE_POINTER [ANY]}.make_cast (l_oin))
				Result := 1
				js.return
			end
			if not js.return_called then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2409, create {CE_POINTER [ANY]}.make_cast (l_oin))
				Result := 2
			end
		end

	save_url (a_ses: CE_POINTER [PD_SESSION]; a_url: CE_POINTER [NATURAL_8])
		local
			l_u: CE_POINTER [NATURAL_8]
			l_stat___0: PD_STATUS
			js: JUMP_STATE
		do
			create l_u.make
			create l_stat___0.make

			l_u.ce_gets (url_inst.translate_url (a_url, (a_ses.item.term).item.cwd))
			if (l_u).c_pointer = default_pointer then
				l_stat___0.next := create {CE_POINTER [PD_STATUS]}.make_shared (default_pointer)
				l_stat___0.prev := create {CE_POINTER [PD_STATUS]}.make_shared (default_pointer)
				l_stat___0.c := create {CE_POINTER [PD_CONNECTION]}.make_shared (default_pointer)
				l_stat___0.ce := create {CE_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer)
				l_stat___0.state := -1009
				l_stat___0.prev_error := 5
				l_stat___0.pri := 0
				l_stat___0.end2 := create {CE_ROUTINE}.make_shared (default_pointer)
				l_stat___0.data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
				l_stat___0.prg := create {CE_POINTER [PD_REMAINING_INFO]}.make_shared (default_pointer)
				session_inst.print_error_dialog (a_ses, l_stat___0.address, links_inst.dummyarray + 186)
				js.return
			end
			if not js.return_called then
				if ((a_ses.item.dn_url).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2421, create {CE_POINTER [ANY]}.make_cast (a_ses.item.dn_url))
				end
				a_ses.item.dn_url := l_u
				menu_inst.query_file (a_ses, a_ses.item.dn_url, session_inst.start_download_address, create {CE_ROUTINE}.make_shared (default_pointer))
			end
		end

	save_url_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent save_url)
		end

	send_image (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_u: CE_POINTER [NATURAL_8]
			l_fd: CE_POINTER [PD_F_DATA_C]
			js: JUMP_STATE
		do
			create l_u.make
			create l_fd.make

			l_fd.ce_gets ((current_frame (a_ses)))
			if (l_fd).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called and then ((l_fd.item.vs).item.current_link = -1) then
				js.return
			end
			if not js.return_called then
				l_u.ce_gets (((l_fd.item.f_data).item.links + (l_fd.item.vs).item.current_link).item.where_img)
				if (l_u).c_pointer = default_pointer then
					js.return
				end
			end
			if not js.return_called then
				session_inst.goto_url (a_ses, l_u)
			end
		end

	send_image_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent send_image)
		end

	save_as (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_l: CE_POINTER [PD_LOCATION]
			l_tmp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_l.make
			create l_tmp.make

			if ((a_ses.item.history.next).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
				js.return
			end
			if not js.return_called then
				l_l.ce_gets (create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next))
				if ((a_ses.item.dn_url).c_pointer /= default_pointer) then
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2441, create {CE_POINTER [ANY]}.make_cast (a_ses.item.dn_url))
				end
				l_tmp.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2442, l_l.item.vs.url))
				a_ses.item.dn_url := l_tmp
				if ((l_tmp).c_pointer /= default_pointer) then
					menu_inst.query_file (a_ses, a_ses.item.dn_url, session_inst.start_download_address, create {CE_ROUTINE}.make_shared (default_pointer))
				end
			end
		end

	save_as_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent save_as)
		end

	save_formatted (a_ses: CE_POINTER [PD_SESSION]; a_file: CE_POINTER [NATURAL_8])
		local
			l_h: INTEGER_32
			l_f: CE_POINTER [PD_F_DATA_C]
			js: JUMP_STATE
		do
			create l_f.make

			l_f.ce_gets (current_frame (a_ses))
			if ((l_f).c_pointer /= default_pointer) then
				if (l_f.item.f_data).c_pointer = default_pointer then
					js.return
				end
			else
				js.return
			end
			if not js.return_called then
				l_h := session_inst.create_download_file (a_ses.item.term, a_file, 0)
				if l_h < 0 then
					js.return
				end
			end
			if not js.return_called then
				if (dump_to_file (l_f.item.f_data, l_h)).to_boolean then
					bfu_inst.msg_box ([a_ses.item.term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 209, 1, links_inst.dummyarray + 210, create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
				end
				close (l_h).do_nothing
			end
		end

	save_formatted_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent save_formatted)
		end

	menu_save_formatted (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_f: CE_POINTER [PD_F_DATA_C]
			js: JUMP_STATE
		do
			create l_f.make

			l_f.ce_gets (current_frame (a_ses))
			if ((l_f).c_pointer /= default_pointer) then
				if (l_f.item.f_data).c_pointer = default_pointer then
					js.return
				end
			else
				js.return
			end
			if not js.return_called then
				menu_inst.query_file (a_ses, (l_f.item.vs).item.url, save_formatted_address, create {CE_ROUTINE}.make_shared (default_pointer))
			end
		end

	menu_save_formatted_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_save_formatted)
		end

	link_menu (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_f: CE_POINTER [PD_F_DATA_C]
			l_link___0: CE_POINTER [PD_LINK]
			l_mi: CE_POINTER [PD_MENU_ITEM]
			l_l: INTEGER_32
			l_c: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_c___0: INTEGER_32
			l_tmp___5: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_f.make
			create l_link___0.make
			create l_mi.make
			create l_tmp___1.make
			create l_tmp___5.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_f.ce_gets ((current_frame (a_ses)))
					l_l := 0
					l_mi.ce_gets (bfu_inst.new_menu (1))
					if (l_mi).c_pointer = default_pointer then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 23 -- skip if block
					end
				when 1 then -- if:
						if (l_f).c_pointer = default_pointer then
							l_pos := -1 + 20 -- goto x
						end
				when 2 then
						if (l_f.item.vs).item.current_link = -1 then
							l_pos := -1 + 21 -- goto no_l
						end
				when 3 then
						l_link___0.ce_gets ((l_f.item.f_data).item.links + (l_f.item.vs).item.current_link)
						if l_link___0.item.type /= 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if (l_link___0.item.where).c_pointer = default_pointer then
							l_pos := -1 + 9 -- skip if block
						end
				when 5 then -- if:
						l_l := 1
						if not ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_link___0.item.where))) >= {NATURAL_32} 4) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (links_inst.casecmp (l_link___0.item.where, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("MAP@")), (4).to_natural_32)).to_boolean then
							l_pos := -1 + 8 -- goto _L
						else
							bfu_inst.add_to_menu (l_mi.address, links_inst.dummyarray + 211, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (">")), links_inst.dummyarray + 361, (send_enter_address), create {CE_POINTER [ANY]}.make_shared (default_pointer), 1)
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						l_c := (can_open_in_new (a_term))
						bfu_inst.add_to_menu (l_mi.address, links_inst.dummyarray + 212, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), links_inst.dummyarray + 362, (send_enter_address), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
						if l_c.to_boolean then
							if (l_c - 1).to_boolean then
								l_tmp___1.ce_gets (ce_string (">"))
							else
								l_tmp___1.ce_gets (ce_string (""))
							end
							bfu_inst.add_to_menu (l_mi.address, links_inst.dummyarray + 213, create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___1), links_inst.dummyarray + 363, (open_in_new_window_address), create {CE_POINTER [ANY]}.make_cast ((send_open_in_new_xterm_address)), l_c - 1)
						end
						if not default_inst.anonymous.to_boolean then
							bfu_inst.add_to_menu (l_mi.address, links_inst.dummyarray + 214, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("d")), links_inst.dummyarray + 364, (send_download_address), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
						end
				when 9 then -- if done | if done
						if l_link___0.item.type /= 1 then
							l_pos := -1 + 19 -- skip if block
						end
				when 10 then -- if:
						if (l_link___0.item.form).c_pointer = default_pointer then
							l_pos := -1 + 19 -- skip if block
						end
				when 11 then -- if:
						l_l := 1
						if (l_link___0.item.form).item.type /= 10 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						bfu_inst.add_to_menu (l_mi.address, links_inst.dummyarray + 215, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), links_inst.dummyarray + 365, (send_enter_address), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 14 then -- else:
						if (l_link___0.item.form).item.type /= 8 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 18 -- goto _L___0
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 17 then -- else:
						if (l_link___0.item.form).item.type /= 9 then
							l_pos := -1 + 19 -- skip if block
						end
				when 18 then -- if: | _L___0:
						l_c___0 := (can_open_in_new (a_term))
						bfu_inst.add_to_menu (l_mi.address, links_inst.dummyarray + 216, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), links_inst.dummyarray + 366, (send_enter_address), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
						if l_c___0.to_boolean then
							if (l_link___0.item.form).item.method = 0 then
								if (l_c___0 - 1).to_boolean then
									l_tmp___5.ce_gets (ce_string (">"))
								else
									l_tmp___5.ce_gets (ce_string (""))
								end
								bfu_inst.add_to_menu (l_mi.address, links_inst.dummyarray + 217, create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___5), links_inst.dummyarray + 367, (open_in_new_window_address), create {CE_POINTER [ANY]}.make_cast ((send_open_in_new_xterm_address)), l_c___0 - 1)
							end
						end
						if not default_inst.anonymous.to_boolean then
							bfu_inst.add_to_menu (l_mi.address, links_inst.dummyarray + 218, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("d")), links_inst.dummyarray + 368, (send_download_address), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
						end
				when 19 then -- if done | if done | if done | if done
						if ((l_link___0.item.where_img).c_pointer /= default_pointer) then
							l_l := 1
							bfu_inst.add_to_menu (l_mi.address, links_inst.dummyarray + 219, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), links_inst.dummyarray + 369, (send_image_address), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
							if not default_inst.anonymous.to_boolean then
								bfu_inst.add_to_menu (l_mi.address, links_inst.dummyarray + 220, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), links_inst.dummyarray + 370, (send_download_image_address), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
							end
						end
				when 20 then -- x:
						if l_l.to_boolean then
							l_pos := -1 + 22 -- skip if block
						end
				when 21 then -- if: | no_l:
						bfu_inst.add_to_menu (l_mi.address, links_inst.dummyarray + 221, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), bfu_inst.m_bar_address, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 0)
				when 22 then -- if done
						bfu_inst.do_menu (a_term, l_mi, create {CE_POINTER [ANY]}.make_cast (a_ses))
				when 23 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	link_menu_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent link_menu)
		end

	print_current_titlex (a_fd: CE_POINTER [PD_F_DATA_C]; a_w: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_w: INTEGER_32
			l_ml: INTEGER_32
			l_pl: INTEGER_32
			l_m: CE_POINTER [NATURAL_8]
			l_p: CE_POINTER [NATURAL_8]
			l_pp: INTEGER_32
			l_pe: INTEGER_32
			js: JUMP_STATE
		do
			create l_m.make
			create l_p.make

			l_w := a_w
			l_ml := 0
			l_pl := 0
			if (a_fd).c_pointer = default_pointer then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_w := l_w - 1
				l_p.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2514))
				if a_fd.item.yw < (a_fd.item.f_data).item.y then
					if (a_fd.item.yw).to_boolean then
						l_pp := ((a_fd.item.vs).item.view_pos + a_fd.item.yw // 2) // a_fd.item.yw + 1
						l_pe := (((a_fd.item.f_data).item.y + a_fd.item.yw) - 1) // a_fd.item.yw
					else
						l_pe := 1
						l_pp := l_pe
					end
					if l_pp > l_pe then
						l_pp := l_pe
					end
					if (a_fd.item.vs).item.view_pos + a_fd.item.yw >= (a_fd.item.f_data).item.y then
						l_pp := l_pe
					end
					if (((a_fd.item.f_data).item.title).c_pointer /= default_pointer) then
						links_inst.add_chr_to_str (l_p.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_pl), ((' ').code).to_natural_8)
					end
					links_inst.add_to_str (l_p.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_pl), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("(p")))
					links_inst.add_num_to_str (l_p.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_pl), l_pp.to_integer_32)
					links_inst.add_to_str (l_p.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_pl), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" of ")))
					links_inst.add_num_to_str (l_p.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_pl), l_pe.to_integer_32)
					links_inst.add_chr_to_str (l_p.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_pl), ((')').code).to_natural_8)
				end
				if ((a_fd.item.f_data).item.title).c_pointer = default_pointer then
					Result := l_p
					js.return
				end
			end
			if not js.return_called then
				l_m.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2531))
				links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ml), (a_fd.item.f_data).item.title)
				if l_ml + l_pl > l_w then
					l_ml := l_w - l_pl
					if l_ml < 0 then
						l_ml := 0
					end
				end
				links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ml), l_p)
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2535, create {CE_POINTER [ANY]}.make_cast (l_p))
				Result := l_m
			end
		end

	print_current_linkx (a_fd: CE_POINTER [PD_F_DATA_C]; a_term: CE_POINTER [PD_TERMINAL]): CE_POINTER [NATURAL_8]
		local
			l_ll: INTEGER_32
			l_l: CE_POINTER [PD_LINK]
			l_m: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_l.make
			create l_m.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ll := 0
					if (a_fd).c_pointer = default_pointer then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						if (a_fd.item.vs).item.current_link = -1 then
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						elseif (a_fd.item.vs).item.current_link >= (a_fd.item.f_data).item.nlinks then
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						elseif ((a_fd.item.f_data).item.frame).to_boolean then
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_l.ce_gets ((a_fd.item.f_data).item.links + (a_fd.item.vs).item.current_link)
						if l_l.item.type /= 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 2 then -- if:
						if (l_l.item.where).c_pointer = default_pointer then
							if ((l_l.item.where_img).c_pointer /= default_pointer) then
								l_m.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2549))
								l_ll := 0
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), (language_inst.get_text_translation (links_inst.dummyarray + 222, a_term)))
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), l_l.item.where_img)
								l_pos := -1 + 28 -- goto p
							end
						end
				when 3 then
						if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_l.item.where))) >= {NATURAL_32} 4 then
							if not (links_inst.casecmp (l_l.item.where, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("MAP@")), (4).to_natural_32)).to_boolean then
								l_m.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2557))
								l_ll := 0
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), (language_inst.get_text_translation (links_inst.dummyarray + 223, a_term)))
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), l_l.item.where + 4)
								l_pos := -1 + 28 -- goto p
							end
						end
				when 4 then
						l_m.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2564, l_l.item.where))
						l_pos := -1 + 28 -- goto p
				when 5 then
						if (l_l.item.form).c_pointer = default_pointer then
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
				when 6 then -- if done
					if not (not js.return_called and then (l_l.item.type = 1)) then
						l_pos := -1 + 9 -- skip if block
					end
				when 7 then -- if:
						if (l_l.item.form).item.type = 10 then
							l_m.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2570, (language_inst.get_text_translation (links_inst.dummyarray + 215, a_term))))
							l_pos := -1 + 28 -- goto p
						end
				when 8 then
						if ((l_l.item.form).item.action).c_pointer = default_pointer then
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called then
							l_m.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2574))
							l_ll := 0
							if (l_l.item.form).item.method = 0 then
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), (language_inst.get_text_translation (links_inst.dummyarray + 224, a_term)))
							else
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), (language_inst.get_text_translation (links_inst.dummyarray + 225, a_term)))
							end
							links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
							links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), (l_l.item.form).item.action)
							l_pos := -1 + 28 -- goto p
						end
				when 9 then
					if js.return_called then
						l_pos := -1 + 27 -- skip if block
					end
				when 10 then -- if:
						if l_l.item.type /= 2 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 20 -- goto _L___0
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 13 then -- else:
						if l_l.item.type /= 3 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 20 -- goto _L___0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 16 then -- else:
						if l_l.item.type /= 4 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L___0
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 19 then -- else:
						if l_l.item.type /= 5 then
							l_pos := -1 + 27 -- skip if block
						end
				when 20 then -- if: | _L___0:
						l_m.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2583))
						l_ll := 0
						if (l_l.item.form).item.type = 6 then
							links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), (language_inst.get_text_translation (links_inst.dummyarray + 226, a_term)))
						elseif (l_l.item.form).item.type = 5 then
							links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), (language_inst.get_text_translation (links_inst.dummyarray + 227, a_term)))
						elseif (l_l.item.form).item.type = 7 then
							links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), (language_inst.get_text_translation (links_inst.dummyarray + 228, a_term)))
						elseif (l_l.item.form).item.type = 1 then
							links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), (language_inst.get_text_translation (links_inst.dummyarray + 229, a_term)))
						elseif (l_l.item.form).item.type = 4 then
							links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), (language_inst.get_text_translation (links_inst.dummyarray + 230, a_term)))
						elseif (l_l.item.form).item.type = 3 then
							links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), (language_inst.get_text_translation (links_inst.dummyarray + 231, a_term)))
						elseif (l_l.item.form).item.type = 2 then
							links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), (language_inst.get_text_translation (links_inst.dummyarray + 232, a_term)))
						else
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2593, create {CE_POINTER [ANY]}.make_cast (l_m))
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
						if js.return_called then
							l_pos := -1 + 27 -- skip if block
						end
				when 21 then -- if:
						if (((l_l.item.form).item.name).c_pointer /= default_pointer) then
							if ((l_l.item.form).item.name[0]).to_boolean then
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (", ")))
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), (language_inst.get_text_translation (links_inst.dummyarray + 233, a_term)))
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), (l_l.item.form).item.name)
							end
						end
						if (l_l.item.form).item.type /= 5 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_pos := -1 + 25 -- goto _L
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 24 then -- else:
						if (l_l.item.form).item.type /= 6 then
							l_pos := -1 + 26 -- skip if block
						end
				when 25 then -- if: | _L:
						if (((l_l.item.form).item.default_value).c_pointer /= default_pointer) then
							if ((l_l.item.form).item.default_value[0]).to_boolean then
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (", ")))
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), (language_inst.get_text_translation (links_inst.dummyarray + 234, a_term)))
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
								links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), (l_l.item.form).item.default_value)
							end
						end
				when 26 then -- if done
						if l_l.item.type = 4 then
							if not (has_form_submit (a_fd.item.f_data, l_l.item.form)).to_boolean then
								if (((l_l.item.form).item.action).c_pointer /= default_pointer) then
									links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (", ")))
									links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), (language_inst.get_text_translation (links_inst.dummyarray + 235, a_term)))
									links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
									if (l_l.item.form).item.method = 0 then
										links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), (language_inst.get_text_translation (links_inst.dummyarray + 236, a_term)))
									else
										links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), (language_inst.get_text_translation (links_inst.dummyarray + 237, a_term)))
									end
									links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
									links_inst.add_to_str (l_m.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ll), (l_l.item.form).item.action)
								end
							end
						end
						l_pos := -1 + 28 -- goto p
				when 27 then -- if done | if done | if done | if done | if done
						if js.return_called then
							l_pos := -1 + 29 -- skip if block
						end
				when 28 then -- if: | p:
							Result := l_m
				when 29 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	print_current_link (a_ses: CE_POINTER [PD_SESSION]): CE_POINTER [NATURAL_8]
		do
			Result := (print_current_linkx ((current_frame (a_ses)), a_ses.item.term))
		end

	print_current_title (a_ses: CE_POINTER [PD_SESSION]): CE_POINTER [NATURAL_8]
		do
			Result := (print_current_titlex ((current_frame (a_ses)), (a_ses.item.term).item.x))
		end

	loc_msg (a_term: CE_POINTER [PD_TERMINAL]; a_lo: CE_POINTER [PD_LOCATION]; a_frame: CE_POINTER [PD_F_DATA_C])
		local
			l_ce: CE_POINTER [PD_CACHE_ENTRY]
			l_s: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_a: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_ce.make
			create l_s.make
			create l_a.make

			l_l := 0
			if (a_lo).c_pointer = default_pointer then
				bfu_inst.msg_box ([a_term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 238, 0, links_inst.dummyarray + 240, create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 14, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
				js.return
			elseif (a_frame).c_pointer = default_pointer then
				bfu_inst.msg_box ([a_term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 238, 0, links_inst.dummyarray + 240, create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 14, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
				js.return
			elseif (a_frame.item.f_data).c_pointer = default_pointer then
				bfu_inst.msg_box ([a_term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 238, 0, links_inst.dummyarray + 240, create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 14, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
				js.return
			end
			if not js.return_called then
				l_s.ce_gets (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2633))
				links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (language_inst.get_text_translation (links_inst.dummyarray + 241, a_term)))
				links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (": ")))
				if (((strchr (create {CE_POINTER [INTEGER_8]}.make_cast ((a_lo.item.vs.url)), 1))).c_pointer /= default_pointer) then
					links_inst.add_bytes_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), a_lo.item.vs.url, (create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast ((a_lo.item.vs.url)), 1)))).distance ((a_lo.item.vs.url)))
				else
					links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), a_lo.item.vs.url)
				end
				if not (cache_inst.get_cache_entry (a_lo.item.vs.url, l_ce.address)).to_boolean then
					links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
					links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (language_inst.get_text_translation (links_inst.dummyarray + 242, a_term)))
					links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (": ")))
					links_inst.add_num_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_ce.item.length)
					if (l_ce.item.incomplete).to_boolean then
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" (")))
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (language_inst.get_text_translation (links_inst.dummyarray + 243, a_term)))
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (")")))
					end
					links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
					links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (language_inst.get_text_translation (links_inst.dummyarray + 244, a_term)))
					links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (": ")))
					links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (charsets_inst.get_cp_name ((a_frame.item.f_data).item.cp)))
					if (a_frame.item.f_data).item.ass = 1 then
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" (")))
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (language_inst.get_text_translation (links_inst.dummyarray + 245, a_term)))
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (")")))
					end
					if (a_frame.item.f_data).item.ass = 2 then
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" (")))
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (language_inst.get_text_translation (links_inst.dummyarray + 246, a_term)))
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (")")))
					end
					l_a.ce_gets (http_inst.parse_http_header (l_ce.item.head, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Server")), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
					if ((l_a).c_pointer /= default_pointer) then
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (language_inst.get_text_translation (links_inst.dummyarray + 247, a_term)))
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (": ")))
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_a)
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2659, create {CE_POINTER [ANY]}.make_cast (l_a))
					end
					l_a.ce_gets (http_inst.parse_http_header (l_ce.item.head, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Date")), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
					if ((l_a).c_pointer /= default_pointer) then
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (language_inst.get_text_translation (links_inst.dummyarray + 248, a_term)))
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (": ")))
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_a)
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2666, create {CE_POINTER [ANY]}.make_cast (l_a))
					end
					if ((l_ce.item.last_modified).c_pointer /= default_pointer) then
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (language_inst.get_text_translation (links_inst.dummyarray + 249, a_term)))
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (": ")))
						links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_ce.item.last_modified)
					end
				end
				l_a.ce_gets (print_current_linkx (a_frame, a_term))
				if ((l_a).c_pointer /= default_pointer) then
					links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N%N")))
					links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), (language_inst.get_text_translation (links_inst.dummyarray + 111, a_term)))
					links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (": ")))
					links_inst.add_to_str (l_s.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_l), l_a)
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2687, create {CE_POINTER [ANY]}.make_cast (l_a))
				end
				bfu_inst.msg_box ([a_term, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_s), create {CE_POINTER [ANY]}.make_shared (default_pointer)])), links_inst.dummyarray + 238, 0, l_s, create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 14, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
			end
		end

	state_msg (a_ses: CE_POINTER [PD_SESSION])
		do
			if ((a_ses.item.history.next).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
				loc_msg (a_ses.item.term, create {CE_POINTER [PD_LOCATION]}.make_shared (default_pointer), create {CE_POINTER [PD_F_DATA_C]}.make_shared (default_pointer))
			else
				loc_msg (a_ses.item.term, create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next), (current_frame (a_ses)))
			end
		end

	head_msg (a_ses: CE_POINTER [PD_SESSION])
		local
			l_ce: CE_POINTER [PD_CACHE_ENTRY]
			l_s: CE_POINTER [NATURAL_8]
			l_ss: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			create l_ce.make
			create l_s.make
			create l_ss.make

			if ((a_ses.item.history.next).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + {PD_SESSION}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
				bfu_inst.msg_box ([a_ses.item.term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 239, 0, links_inst.dummyarray + 240, create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 14, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
				js.return
			end
			if not js.return_called then
				if not (cache_inst.find_in_cache ((create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)).item.vs.url, l_ce.address)).to_boolean then
					if ((l_ce.item.head).c_pointer /= default_pointer) then
						l_s.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2708, l_ce.item.head))
						l_ss.ce_gets (l_s)
					else
						l_ss.ce_gets (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("view.c")), 2709, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))))
						l_s.ce_gets (l_ss)
					end
					l_len := ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))) - {NATURAL_32} 1).to_integer_32
					if l_len > 0 then
						from
						until
							js.loop_left
						loop
							js.reset
							l_ss.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("%R%N")))))
							if (l_ss).c_pointer = default_pointer then
								js.break
							end
							if not js.loop_jumped then
								memmove (create {CE_POINTER [ANY]}.make_cast (l_ss), create {CE_POINTER [ANY]}.make_cast ((l_ss + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ss)))).do_nothing
							end
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_s.item).to_boolean then
								if (l_s[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 10 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_s[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))) - {NATURAL_32} 1).to_integer_32] := (0).to_natural_8
							end
						end
						js.reset
					end
					bfu_inst.msg_box ([a_ses.item.term, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_s), create {CE_POINTER [ANY]}.make_shared (default_pointer)])), links_inst.dummyarray + 239, 0, l_s, create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 14, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
				end
			end
		end

end
