class
	P_EX_CMDS

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create sortbuf1.make
			create sortbuf2.make
			create prevcmd.make
			create old_sub.make
			create mtable.make (<<27>>)
			create rtable.make (<<27>>)
			create first_sign.make
			create cmds.make (<<7>>)
			create cmdnames.make (<<517>>)
		end

feature {ANY} -- attributes

	sortbuf1: CE_POINTER [NATURAL_8]

	sortbuf2: CE_POINTER [NATURAL_8]

	sort_ic: INTEGER_32 assign set_sort_ic

	set_sort_ic (a_sort_ic: INTEGER_32)
		do
			sort_ic := a_sort_ic
		end

	sort_nr: INTEGER_32 assign set_sort_nr

	set_sort_nr (a_sort_nr: INTEGER_32)
		do
			sort_nr := a_sort_nr
		end

	sort_rx: INTEGER_32 assign set_sort_rx

	set_sort_rx (a_sort_rx: INTEGER_32)
		do
			sort_rx := a_sort_rx
		end

	sort_abort: INTEGER_32 assign set_sort_abort

	set_sort_abort (a_sort_abort: INTEGER_32)
		do
			sort_abort := a_sort_abort
		end

	prevcmd: CE_POINTER [NATURAL_8]

	viminfo_errcnt: INTEGER_32 assign set_viminfo_errcnt

	set_viminfo_errcnt (a_viminfo_errcnt: INTEGER_32)
		do
			viminfo_errcnt := a_viminfo_errcnt
		end

	append_indent: INTEGER_32 assign set_append_indent

	set_append_indent (a_append_indent: INTEGER_32)
		do
			append_indent := a_append_indent
		end

	old_sub: CE_POINTER [NATURAL_8]

	global_need_beginline: INTEGER_32 assign set_global_need_beginline

	set_global_need_beginline (a_global_need_beginline: INTEGER_32)
		do
			global_need_beginline := a_global_need_beginline
		end

	do_all: INTEGER_32 assign set_do_all

	set_do_all (a_do_all: INTEGER_32)
		do
			do_all := a_do_all
		end

	do_ask: INTEGER_32 assign set_do_ask

	set_do_ask (a_do_ask: INTEGER_32)
		do
			do_ask := a_do_ask
		end

	do_count: INTEGER_32 assign set_do_count

	set_do_count (a_do_count: INTEGER_32)
		do
			do_count := a_do_count
		end

	do_error: INTEGER_32 assign set_do_error

	set_do_error (a_do_error: INTEGER_32)
		do
			do_error := a_do_error
		end

	do_print: INTEGER_32 assign set_do_print

	set_do_print (a_do_print: INTEGER_32)
		do
			do_print := a_do_print
		end

	do_list: INTEGER_32 assign set_do_list

	set_do_list (a_do_list: INTEGER_32)
		do
			do_list := a_do_list
		end

	do_number: INTEGER_32 assign set_do_number

	set_do_number (a_do_number: INTEGER_32)
		do
			do_number := a_do_number
		end

	do_ic: INTEGER_32 assign set_do_ic

	set_do_ic (a_do_ic: INTEGER_32)
		do
			do_ic := a_do_ic
		end

	mtable: CE_ARRAY [CE_POINTER [INTEGER_8]]

	rtable: CE_ARRAY [CE_POINTER [INTEGER_8]]

	first_sign: CE_POINTER [PD_SIGN]

	last_sign_typenr: INTEGER_32 assign set_last_sign_typenr

	set_last_sign_typenr (a_last_sign_typenr: INTEGER_32)
		do
			last_sign_typenr := a_last_sign_typenr
		end

	cmds: CE_ARRAY [CE_POINTER [INTEGER_8]]

	expand_what: INTEGER_32 assign set_expand_what

	set_expand_what (a_expand_what: INTEGER_32)
		do
			expand_what := a_expand_what
		end

	cmdnames: CE_ARRAY [PD_CMDNAME]

feature {ANY} -- routines

	do_ascii (a_eap: CE_POINTER [PD_EXARG])
		local
			l_c: INTEGER_32
			l_cval: INTEGER_32
			l_buf1: CE_ARRAY [INTEGER_8]
			l_buf2: CE_ARRAY [INTEGER_8]
			l_buf3: CE_ARRAY [NATURAL_8]
			l_cc___0: CE_ARRAY [INTEGER_32]
			l_ci: INTEGER_32
			l_len: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___5: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___15: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf1.make (<<20>>)
			create l_buf2.make (<<20>>)
			create l_buf3.make (<<7>>)
			create l_cc___0.make (<<6>>)
			create l_tmp___3.make
			create l_tmp___14.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ci := 0
					if globals_inst.enc_utf8.to_boolean then
						l_c := mbyte_inst.utfc_ptr2char ((memline_inst.ml_get_cursor), l_cc___0)
					else
						l_c := misc1_inst.gchar_cursor
					end
					if l_c = 0 then
						message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("NUL"))).do_nothing
						js.return
					end
					if js.return_called then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						globals_inst.IObuff[0] := (('%/0/').code).to_natural_8
						if globals_inst.has_mbyte.to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 4 then -- else:
						if globals_inst.enc_dbcs = 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_c < 256 then
							l_pos := -1 + 8 -- goto _L
						else
							l_pos := -1 + 7 -- goto _L___0
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else: | _L___0:
						if not (l_c < 128) then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if l_c = 10 then
							l_c := ('%/0/').code
						end
						if l_c = 13 then
							if (misc2_inst.get_fileformat (globals_inst.curbuf)) = 2 then
								l_cval := ('%N').code
							else
								l_cval := l_c
							end
						else
							l_cval := l_c
						end
						if (charset_inst.vim_isprintc_strict (l_c)).to_boolean then
							if l_c < 32 then
								charset_inst.transchar_nonprint (l_buf3, l_c)
								message_inst.vim_snprintf ([l_buf1, (Integer_8_bytes.to_natural_32 * (20).to_natural_32), ce_string ("  <%%s>"), create {CE_POINTER [INTEGER_8]}.make_cast (l_buf3)]).do_nothing
							elseif l_c > 126 then
								charset_inst.transchar_nonprint (l_buf3, l_c)
								message_inst.vim_snprintf ([l_buf1, (Integer_8_bytes.to_natural_32 * (20).to_natural_32), ce_string ("  <%%s>"), create {CE_POINTER [INTEGER_8]}.make_cast (l_buf3)]).do_nothing
							else
								l_buf1[0] := (('%/0/').code).to_integer_8
							end
						else
							l_buf1[0] := (('%/0/').code).to_integer_8
						end
						if l_c >= 128 then
							message_inst.vim_snprintf ([l_buf2, (Integer_8_bytes.to_natural_32 * (20).to_natural_32), ce_string ("  <M-%%s>"), create {CE_POINTER [INTEGER_8]}.make_cast ((charset_inst.transchar ((l_c).bit_and (127))))]).do_nothing
						else
							l_buf2[0] := (('%/0/').code).to_integer_8
						end
						l_tmp___3.ce_gets (charset_inst.transchar (l_c))
						message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1025).to_natural_32, (gettext (ce_string ("<%%s>%%s%%s  %%d,  Hex %%02x,  Octal %%03o"))), l_tmp___3, l_buf1, l_buf2, l_cval, l_cval, l_cval]).do_nothing
						if globals_inst.enc_utf8.to_boolean then
							l_tmp___5 := l_ci
							l_ci := l_ci + 1
							l_c := l_cc___0[l_tmp___5]
						else
							l_c := 0
						end
				when 9 then -- if done | if done
						from
						until
							js.loop_left
						loop
							js.reset
							if globals_inst.has_mbyte.to_boolean then
								if not (l_c >= 256) then
									if globals_inst.enc_utf8.to_boolean then
										if not (l_c >= 128) then
											js.break
										end
									else
										js.break
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff))).to_integer_32
								if l_len > 0 then
									l_tmp___7 := l_len
									l_len := l_len + 1
									globals_inst.IObuff[l_tmp___7] := ((' ').code).to_natural_8
								end
								l_tmp___8 := l_len
								l_len := l_len + 1
								globals_inst.IObuff[l_tmp___8] := (('<').code).to_natural_8
								if globals_inst.enc_utf8.to_boolean then
									if (mbyte_inst.utf_iscomposing (l_c)).to_boolean then
										l_tmp___9 := l_len
										l_len := l_len + 1
										globals_inst.IObuff[l_tmp___9] := ((' ').code).to_natural_8
									end
								end
								l_len := l_len + (globals_inst.mb_char2bytes.integer_32_item ([l_c, globals_inst.IObuff + l_len]))
								if l_c < 65536 then
									l_tmp___14.ce_gets ((gettext (ce_string ("> %%d, Hex %%04x, Octal %%o"))))
								else
									l_tmp___14.ce_gets ((gettext (ce_string ("> %%d, Hex %%08x, Octal %%o"))))
								end
								message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff) + l_len, (1025 - l_len).to_natural_32, l_tmp___14, l_c, l_c, l_c]).do_nothing
								if l_ci = 6 then
									js.break
								end
							end
							if not js.loop_jumped then
								if globals_inst.enc_utf8.to_boolean then
									l_tmp___15 := l_ci
									l_ci := l_ci + 1
									l_c := l_cc___0[l_tmp___15]
								else
									l_c := 0
								end
							end
						end
						js.reset
						message_inst.msg (globals_inst.IObuff).do_nothing
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_ascii_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent do_ascii)
		end

	ex_align (a_eap: CE_POINTER [PD_EXARG])
		local
			l_save_curpos: PD_POS_T
			l_len: INTEGER_32
			l_indent: INTEGER_32
			l_new_indent: INTEGER_32
			l_has_tab: INTEGER_32
			l_width: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_32]
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_save_curpos.make
			create l_tmp___0.make

			l_indent := 0
			l_width := atoi (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg))
			l_save_curpos.ce_gets (globals_inst.curwin.item.w_cursor)
			if a_eap.item.cmdidx = 207 then
				if l_width >= 0 then
					l_indent := l_width
				end
			else
				if l_width <= 0 then
					l_width := (globals_inst.curbuf.item.b_p_tw).to_integer_32
				end
				if l_width = 0 then
					if globals_inst.curbuf.item.b_p_wm > 0 then
						l_width := ((globals_inst.curwin.item.w_width).to_integer_32 - globals_inst.curbuf.item.b_p_wm).to_integer_32
					end
				end
				if l_width <= 0 then
					l_width := 80
				end
			end
			if (undo_inst.u_save (a_eap.item.line1 - 1, a_eap.item.line2 + 1)) = 0 then
				js.return
			end
			if not js.return_called then
				globals_inst.curwin.item.w_cursor.lnum := a_eap.item.line1
				from
				until
					not (not js.loop_left and then (globals_inst.curwin.item.w_cursor.lnum <= a_eap.item.line2))
				loop
					js.reset
					if a_eap.item.cmdidx = 207 then
						l_new_indent := l_indent
					else
						l_has_tab := 0
						if a_eap.item.cmdidx = 341 then
							l_tmp___0.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared ($l_has_tab))
						else
							l_tmp___0.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
						end
						l_tmp___1 := linelen (l_tmp___0)
						l_len := l_tmp___1 - (misc1_inst.get_indent)
						if l_len <= 0 then
							js.continue
						end
						if not js.loop_jumped then
							if a_eap.item.cmdidx = 56 then
								l_new_indent := (l_width - l_len) // 2
							else
								l_new_indent := l_width - l_len
								if l_has_tab.to_boolean then
									from
									until
										not (not js.loop_left and then (l_new_indent > 0))
									loop
										js.reset
										misc1_inst.set_indent (l_new_indent, 0).do_nothing
										if (linelen (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))) <= l_width then
											from
											until
												js.loop_left
											loop
												js.reset
												l_new_indent := l_new_indent + 1
												misc1_inst.set_indent (l_new_indent, 0).do_nothing
												if not ((linelen (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))) <= l_width) then
													js.break
												end
											end
											js.reset
											l_new_indent := l_new_indent - 1
											js.break
										end
										if not js.loop_jumped then
											l_new_indent := l_new_indent - 1
										end
									end
									js.reset
								end
							end
						end
					end
					if not js.loop_jumped then
						if l_new_indent < 0 then
							l_new_indent := 0
						end
						misc1_inst.set_indent (l_new_indent, 0).do_nothing
					end
					if not js.loop_left then
						globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
					end
				end
				misc1_inst.changed_lines (a_eap.item.line1, 0, a_eap.item.line2 + 1, 0)
				globals_inst.curwin.item.w_cursor := l_save_curpos
				edit_inst.beginline (5)
			end
		end

	ex_align_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_align)
		end

	linelen (a_has_tab: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_line: CE_POINTER [NATURAL_8]
			l_first___0: CE_POINTER [NATURAL_8]
			l_last: CE_POINTER [NATURAL_8]
			l_save___0: INTEGER_32
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			create l_line.make
			create l_first___0.make
			create l_last.make

			l_line.ce_gets (memline_inst.ml_get_curline)
			l_first___0.ce_gets (charset_inst.skipwhite (l_line))
			l_last.ce_gets (l_first___0 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_first___0))).to_integer_32)
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_last.c_pointer.to_integer_32).to_natural_32 > (l_first___0.c_pointer.to_integer_32).to_natural_32 then
					if (l_last[-1]).to_integer_32 /= 32 then
						if (l_last[-1]).to_integer_32 /= 9 then
							js.break
						end
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_last.ce_gets (l_last - 1)
				end
			end
			js.reset
			l_save___0 := (l_last.item).to_integer_32
			l_last.item := (('%/0/').code).to_natural_8
			l_len := charset_inst.linetabsize (l_line)
			if (a_has_tab.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				a_has_tab.item := (((misc2_inst.vim_strrchr (l_first___0, ('%T').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
			end
			l_last.item := l_save___0.to_natural_8
			Result := l_len
		end

	sort_compare (a_s1: CE_POINTER [ANY]; a_s2: CE_POINTER [ANY]): INTEGER_32
		local
			l_l1: PD_SORTI_T
			l_l2: PD_SORTI_T
			l_result___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_l1.make
			create l_l2.make

			l_l1.ce_gets ((create {CE_POINTER [PD_SORTI_T]}.make_cast (a_s1)).item)
			l_l2.ce_gets ((create {CE_POINTER [PD_SORTI_T]}.make_cast (a_s2)).item)
			l_result___2 := 0
			if sort_abort.to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				misc1_inst.fast_breakcheck
				if globals_inst.got_int.to_boolean then
					sort_abort := 1
				end
				if sort_nr.to_boolean then
					l_result___2 := (l_l1.start_col_nr - l_l2.start_col_nr).to_integer_32
				else
					strncpy (create {CE_POINTER [INTEGER_8]}.make_cast (sortbuf1), create {CE_POINTER [INTEGER_8]}.make_cast (((memline_inst.ml_get (l_l1.lnum)) + l_l1.start_col_nr)), ((l_l1.end_col_nr - l_l1.start_col_nr) + 1).to_natural_32).do_nothing
					sortbuf1[(l_l1.end_col_nr - l_l1.start_col_nr)] := (0).to_natural_8
					strncpy (create {CE_POINTER [INTEGER_8]}.make_cast (sortbuf2), create {CE_POINTER [INTEGER_8]}.make_cast (((memline_inst.ml_get (l_l2.lnum)) + l_l2.start_col_nr)), ((l_l2.end_col_nr - l_l2.start_col_nr) + 1).to_natural_32).do_nothing
					sortbuf2[(l_l2.end_col_nr - l_l2.start_col_nr)] := (0).to_natural_8
					if sort_ic.to_boolean then
						l_result___2 := (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (sortbuf1), create {CE_POINTER [INTEGER_8]}.make_cast (sortbuf2)))
					else
						l_result___2 := (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (sortbuf1), create {CE_POINTER [INTEGER_8]}.make_cast (sortbuf2)))
					end
				end
				if l_result___2 = 0 then
					Result := (l_l1.lnum - l_l2.lnum).to_integer_32
					js.return
				end
			end
			if not js.return_called then
				Result := l_result___2
			end
		end

	sort_compare_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent sort_compare)
		end

	ex_sort (a_eap: CE_POINTER [PD_EXARG])
		local
			l_regmatch___0: PD_REGMATCH_T
			l_len: INTEGER_32
			l_lnum: INTEGER_32
			l_maxlen: INTEGER_32
			l_nrs: CE_POINTER [PD_SORTI_T]
			l_count___2: NATURAL_32
			l_i___0: NATURAL_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_s2: CE_POINTER [NATURAL_8]
			l_c: NATURAL_8
			l_unique: INTEGER_32
			l_deleted: INTEGER_32
			l_start_col: INTEGER_32
			l_end_col: INTEGER_32
			l_sort_oct: INTEGER_32
			l_sort_hex: INTEGER_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___10: NATURAL_32
			l_tmp___11: INTEGER_32
			l_tmp___15: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_regmatch___0.make
			create l_nrs.make
			create l_p___0.make
			create l_s.make
			create l_s2.make
			create l_tmp___4.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_maxlen := 0
					l_count___2 := ((a_eap.item.line2 - a_eap.item.line1) + 1).to_natural_32
					l_unique := 0
					if l_count___2 <= {NATURAL_32} 1 then
						js.return
					end
					if not js.return_called then
						if (undo_inst.u_save (a_eap.item.line1 - 1, a_eap.item.line2 + 1)) = 0 then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 68 -- skip if block
					end
				when 1 then -- if:
						sortbuf1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						sortbuf2.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						l_regmatch___0.regprog := create {CE_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
						l_nrs.ce_gets (create {CE_POINTER [PD_SORTI_T]}.make_cast ((misc2_inst.lalloc ((l_count___2 * {PD_SORTI_T}.sizeof.to_natural_32).to_natural_32, 1))))
						if (l_nrs.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 67 -- goto sortend
						end
				when 2 then
						l_sort_hex := 0
						l_sort_oct := l_sort_hex
						sort_nr := l_sort_oct
						sort_rx := sort_nr
						sort_ic := sort_rx
						sort_abort := sort_ic
						l_p___0.ce_gets (a_eap.item.arg)
				when 3 then -- loop condition:
						if not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0)) then
							l_pos := -1 + 40 -- skip loop
						end
				when 4 then -- loop body:
						js.reset
						if ((l_p___0.item).to_integer_32 = 32) then
							l_pos := -1 + 39 -- skip if block
						end
				when 5 then -- if:
						if ((l_p___0.item).to_integer_32 = 9) then
							l_pos := -1 + 39 -- skip if block
						end
				when 6 then -- if:
						if (l_p___0.item).to_integer_32 /= 105 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						sort_ic := 1
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 9 then -- else:
						if (l_p___0.item).to_integer_32 /= 114 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						sort_rx := 1
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 12 then -- else:
						if (l_p___0.item).to_integer_32 /= 110 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						sort_nr := 2
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 15 then -- else:
						if (l_p___0.item).to_integer_32 /= 111 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_sort_oct := 2
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 18 then -- else:
						if (l_p___0.item).to_integer_32 /= 120 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_sort_hex := 2
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 21 then -- else:
						if (l_p___0.item).to_integer_32 /= 117 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_unique := 1
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 24 then -- else:
						if (l_p___0.item).to_integer_32 /= 34 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						js.break
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 27 then -- else:
						if ((ex_docmd_inst.check_nextcmd (l_p___0)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						a_eap.item.nextcmd := ex_docmd_inst.check_nextcmd (l_p___0)
						js.break
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 30 then -- else:
						if not ((l_p___0.item).to_integer_32 < 127) then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						if ((((ctype_b_loc).item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (1024)).to_boolean then
							l_tmp___4.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg2)))
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___4), l_p___0).do_nothing
							l_pos := -1 + 67 -- goto sortend
						else
							l_pos := -1 + 33 -- goto _L
						end
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 33 then -- else: | _L:
						if ((l_regmatch___0.regprog).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 38 -- skip if block
						end
				when 34 then -- if:
						l_s.ce_gets (regexp_inst.skip_regexp (l_p___0 + 1, (l_p___0.item).to_integer_32, 1, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
						if (l_s.item).to_integer_32 /= (l_p___0.item).to_integer_32 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invalpat))))).do_nothing
							l_pos := -1 + 67 -- goto sortend
						end
				when 35 then
						l_s.item := (('%/0/').code).to_natural_8
						if (l_s.c_pointer.to_integer_32).to_natural_32 = ((l_p___0 + 1).c_pointer.to_integer_32).to_natural_32 then
							if ((search_inst.last_search_pat).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_regmatch___0.regprog := regexp_inst.vim_regcomp ((search_inst.last_search_pat), 1)
							else
								l_regmatch___0.regprog := regexp_inst.vim_regcomp (l_p___0 + 1, 1)
							end
						else
							l_regmatch___0.regprog := regexp_inst.vim_regcomp (l_p___0 + 1, 1)
						end
						if ((l_regmatch___0.regprog).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 67 -- goto sortend
						end
				when 36 then
						l_p___0.ce_gets (l_s)
						l_regmatch___0.rm_ic := option_inst.p_ic
				when 37 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 38 then -- else:
						l_tmp___4.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg2)))
						message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___4), l_p___0).do_nothing
						l_pos := -1 + 67 -- goto sortend
				when 39 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
						if not js.loop_jumped then
							l_p___0.ce_gets (l_p___0 + 1)
						end
						l_pos := -1 + 3 -- back to loop condition
				when 40 then -- loop done
						js.reset
						if (sort_nr + l_sort_oct) + l_sort_hex > 2 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg))))).do_nothing
							l_pos := -1 + 67 -- goto sortend
						end
				when 41 then
						sort_nr := sort_nr + (l_sort_oct + l_sort_hex)
						l_lnum := a_eap.item.line1
				when 42 then -- loop condition:
						if not (l_lnum <= a_eap.item.line2) then
							l_pos := -1 + 49 -- skip loop
						end
				when 43 then -- loop body:
						l_s.ce_gets (memline_inst.ml_get (l_lnum))
						l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))).to_integer_32
						if l_maxlen < l_len.to_integer_32 then
							l_maxlen := l_len.to_integer_32
						end
						l_start_col := 0
						l_end_col := l_len
						if ((l_regmatch___0.regprog).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						if (regexp_inst.vim_regexec (l_regmatch___0.address, l_s, 0)).to_boolean then
							if sort_rx.to_boolean then
								l_start_col := (l_regmatch___0.startp[0]).distance (l_s)
								l_end_col := (l_regmatch___0.endp[0]).distance (l_s)
							else
								l_start_col := (l_regmatch___0.endp[0]).distance (l_s)
							end
						else
							l_pos := -1 + 46 -- goto _L___0
						end
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 46 then -- else: | _L___0:
						if ((l_regmatch___0.regprog).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_end_col := 0
						end
				when 47 then
						if sort_nr.to_boolean then
							l_s2.ce_gets (l_s + l_end_col)
							l_c := l_s2.item
							l_s2.item := (0).to_natural_8
							l_p___0.ce_gets (l_s + l_start_col)
							if l_sort_hex.to_boolean then
								l_s.ce_gets (charset_inst.skiptohex (l_p___0))
							else
								l_s.ce_gets (charset_inst.skiptodigit (l_p___0))
							end
							if (l_s.c_pointer.to_integer_32).to_natural_32 > (l_p___0.c_pointer.to_integer_32).to_natural_32 then
								if (l_s[-1]).to_integer_32 = 45 then
									l_s.ce_gets (l_s - 1)
								end
							end
							charset_inst.vim_str2nr (l_s, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_sort_oct, l_sort_hex, create {CE_POINTER [INTEGER_32]}.make_shared ((l_nrs + (l_lnum - a_eap.item.line1)).c_pointer + {PD_SORTI_T}.start_col_nr_offset), create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer))
							l_s2.item := l_c
						else
							(l_nrs + (l_lnum - a_eap.item.line1)).item.start_col_nr := l_start_col.to_integer_32;
							(l_nrs + (l_lnum - a_eap.item.line1)).item.end_col_nr := l_end_col.to_integer_32
						end
						(l_nrs + (l_lnum - a_eap.item.line1)).item.lnum := l_lnum
						if ((l_regmatch___0.regprog).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							misc1_inst.fast_breakcheck
						end
						if globals_inst.got_int.to_boolean then
							l_pos := -1 + 67 -- goto sortend
						end
				when 48 then
						l_lnum := l_lnum + 1
						l_pos := -1 + 42 -- back to loop condition
				when 49 then -- loop done
						sortbuf1.ce_gets (misc2_inst.alloc (l_maxlen.to_natural_32 + {NATURAL_32} 1))
						if (sortbuf1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 67 -- goto sortend
						end
				when 50 then
						sortbuf2.ce_gets (misc2_inst.alloc (l_maxlen.to_natural_32 + {NATURAL_32} 1))
						if (sortbuf2.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 67 -- goto sortend
						end
				when 51 then
						qsort (create {CE_POINTER [ANY]}.make_cast (l_nrs), l_count___2, {PD_SORTI_T}.sizeof.to_natural_32, sort_compare_address)
						if sort_abort.to_boolean then
							l_pos := -1 + 67 -- goto sortend
						end
				when 52 then
						l_lnum := a_eap.item.line2
						l_i___0 := (0).to_natural_32
				when 53 then -- loop condition:
						if not (not js.loop_left and then (l_i___0 < l_count___2)) then
							l_pos := -1 + 66 -- skip loop
						end
				when 54 then -- loop body:
						js.reset
						if (a_eap.item.forceit).to_boolean then
							l_tmp___10 := (l_count___2 - l_i___0) - {NATURAL_32} 1
						else
							l_tmp___10 := l_i___0
						end
						l_s.ce_gets (memline_inst.ml_get ((l_nrs + l_tmp___10.to_integer_32).item.lnum))
						if l_unique.to_boolean then
							l_pos := -1 + 57 -- skip if block
						end
				when 55 then -- if:
						l_pos := -1 + 61 -- goto _L___1
				when 56 then -- if block done, skip else block:
						l_pos := -1 + 62
				when 57 then -- else:
						if l_i___0 /= {NATURAL_32} 0 then
							l_pos := -1 + 60 -- skip if block
						end
				when 58 then -- if:
						l_pos := -1 + 61 -- goto _L___1
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 62
				when 60 then -- else:
						if sort_ic.to_boolean then
							l_tmp___15 := (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), create {CE_POINTER [INTEGER_8]}.make_cast (sortbuf1)))
						else
							l_tmp___15 := (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), create {CE_POINTER [INTEGER_8]}.make_cast (sortbuf1)))
						end
						if l_tmp___15 = 0 then
							l_pos := -1 + 62 -- skip if block
						end
				when 61 then -- if: | _L___1:
						l_tmp___11 := l_lnum
						l_lnum := l_lnum + 1
						if (memline_inst.ml_append (l_tmp___11, l_s, 0, 0)) = 0 then
							js.break
						end
						if not js.loop_jumped and then (l_unique.to_boolean) then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (sortbuf1), create {CE_POINTER [INTEGER_8]}.make_cast (l_s)).do_nothing
						end
				when 62 then -- if done | if done
						if js.loop_jumped then
							l_pos := -1 + 65 -- skip if block
						end
				when 63 then -- if:
						misc1_inst.fast_breakcheck
						if globals_inst.got_int.to_boolean then
							l_pos := -1 + 67 -- goto sortend
						end
				when 64 then
						l_i___0 := l_i___0 + 1
				when 65 then -- if done
						l_pos := -1 + 53 -- back to loop condition
				when 66 then -- loop done
						js.reset
						if l_i___0 = l_count___2 then
							l_i___0 := (0).to_natural_32
							from
							until
								not (l_i___0 < l_count___2)
							loop
								memline_inst.ml_delete (a_eap.item.line1, 0).do_nothing
								l_i___0 := l_i___0 + 1
							end
						else
							l_count___2 := (0).to_natural_32
						end
						l_deleted := (l_count___2.to_natural_32 - (l_lnum - a_eap.item.line2).to_natural_32).to_integer_32
						if l_deleted > 0 then
							mark_inst.mark_adjust (a_eap.item.line2 - l_deleted, a_eap.item.line2, 2147483647, -l_deleted)
						elseif l_deleted < 0 then
							mark_inst.mark_adjust (a_eap.item.line2, 2147483647, -l_deleted, 0)
						end
						misc1_inst.changed_lines (a_eap.item.line1, 0, a_eap.item.line2 + 1, -l_deleted)
						globals_inst.curwin.item.w_cursor.lnum := a_eap.item.line1
						edit_inst.beginline (5)
				when 67 then -- sortend:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_nrs))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (sortbuf1))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (sortbuf2))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_regmatch___0.regprog))
						if globals_inst.got_int.to_boolean then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_interr))))).do_nothing
						end
				when 68 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_sort_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_sort)
		end

	ex_retab (a_eap: CE_POINTER [PD_EXARG])
		local
			l_lnum: INTEGER_32
			l_got_tab: INTEGER_32
			l_num_spaces: INTEGER_32
			l_num_tabs: INTEGER_32
			l_len: INTEGER_32
			l_col: INTEGER_32
			l_vcol: INTEGER_32
			l_start_col: INTEGER_32
			l_start_vcol: INTEGER_32
			l_temp: INTEGER_32
			l_old_len: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_new_line: CE_POINTER [NATURAL_8]
			l_did_undo: INTEGER_32
			l_new_ts: INTEGER_32
			l_save_list: INTEGER_32
			l_first_line: INTEGER_32
			l_last_line: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ptr.make
			create l_new_line.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_got_tab := 0
					l_num_spaces := 0
					l_start_col := 0
					l_start_vcol := 0
					l_new_line.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1))
					l_first_line := (0).to_integer_32
					l_last_line := (0).to_integer_32
					l_save_list := globals_inst.curwin.item.w_onebuf_opt.wo_list
					globals_inst.curwin.item.w_onebuf_opt.wo_list := 0
					l_new_ts := (charset_inst.getdigits (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (a_eap.c_pointer + {PD_EXARG}.arg_offset))).to_integer_32
					if l_new_ts < 0 then
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_positive))))).do_nothing
						js.return
					end
					if js.return_called then
						l_pos := -1 + 30 -- skip if block
					end
				when 1 then -- if:
						if l_new_ts = 0 then
							l_new_ts := (globals_inst.curbuf.item.b_p_ts).to_integer_32
						end
						l_lnum := a_eap.item.line1
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 29 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if not globals_inst.got_int.to_boolean then
							if not (l_lnum <= a_eap.item.line2) then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 28 -- skip if block
						end
				when 4 then -- if:
						l_ptr.ce_gets (memline_inst.ml_get (l_lnum))
						l_col := 0
						l_vcol := 0
						l_did_undo := 0
				when 5 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 27 -- skip loop
						end
				when 6 then -- loop body:
						js.reset
						if (l_ptr[l_col]).to_integer_32 /= 32 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___1
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 9 then -- else:
						if (l_ptr[l_col]).to_integer_32 /= 9 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L___1:
						if not l_got_tab.to_boolean then
							if l_num_spaces = 0 then
								l_start_vcol := l_vcol
								l_start_col := l_col
							end
						end
						if (l_ptr[l_col]).to_integer_32 = 32 then
							l_num_spaces := l_num_spaces + 1
						else
							l_got_tab := 1
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 12 then -- else:
						if not (l_got_tab.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 17 -- goto _L___0
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 15 then -- else:
						if not ((a_eap.item.forceit).to_boolean) then
							l_pos := -1 + 25 -- skip if block
						end
				when 16 then -- if:
						if not (l_num_spaces > 1) then
							l_pos := -1 + 25 -- skip if block
						end
				when 17 then -- if: | _L___0:
						l_num_spaces := l_vcol - l_start_vcol
						l_len := l_num_spaces
						l_num_tabs := 0
						if not (globals_inst.curbuf.item.b_p_et).to_boolean then
							l_temp := (l_new_ts.to_integer_32 - l_start_vcol \\ l_new_ts.to_integer_32).to_integer_32
							if l_num_spaces >= l_temp.to_integer_32 then
								l_num_spaces := l_num_spaces - l_temp.to_integer_32
								l_num_tabs := l_num_tabs + 1
							end
							l_num_tabs := l_num_tabs + (l_num_spaces // l_new_ts.to_integer_32)
							l_num_spaces := l_num_spaces - ((l_num_spaces // l_new_ts.to_integer_32) * l_new_ts.to_integer_32)
						end
						if not ((globals_inst.curbuf.item.b_p_et).to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 24 -- goto _L
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 20 then -- else:
						if not (l_got_tab.to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 24 -- goto _L
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 23 then -- else:
						if not (l_num_spaces + l_num_tabs < l_len) then
							l_pos := -1 + 25 -- skip if block
						end
				when 24 then -- if: | _L:
						if l_did_undo = 0 then
							l_did_undo := 1
							if (undo_inst.u_save (l_lnum - 1, l_lnum + 1)) = 0 then
								l_new_line.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								js.break
							end
						end
						if not js.loop_jumped then
							l_len := l_num_spaces + l_num_tabs
							l_old_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr))).to_integer_32
							l_new_line.ce_gets (misc2_inst.lalloc (((((l_old_len - l_col) + l_start_col) + l_len) + 1).to_natural_32, 1))
							if (l_new_line.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.break
							end
						end
						if not js.loop_jumped then
							if l_start_col > 0 then
								memmove (create {CE_POINTER [ANY]}.make_cast (l_new_line), create {CE_POINTER [ANY]}.make_cast (l_ptr), l_start_col.to_natural_32).do_nothing
							end
							memmove (create {CE_POINTER [ANY]}.make_cast (((l_new_line + l_start_col) + l_len)), create {CE_POINTER [ANY]}.make_cast ((l_ptr + l_col)), ((l_old_len - l_col) + 1).to_natural_32).do_nothing
							l_ptr.ce_gets (l_new_line + l_start_col)
							l_col := 0
							from
							until
								not (l_col < l_len)
							loop
								if l_col < l_num_tabs then
									l_ptr[l_col] := (('%T').code).to_natural_8
								else
									l_ptr[l_col] := ((' ').code).to_natural_8
								end
								l_col := l_col + 1
							end
							memline_inst.ml_replace (l_lnum, l_new_line, 0).do_nothing
							if l_first_line = 0 then
								l_first_line := l_lnum
							end
							l_last_line := l_lnum
							l_ptr.ce_gets (l_new_line)
							l_col := l_start_col + l_len
						end
				when 25 then -- if done | if done | if done | if done | if done
						if not js.loop_jumped then
							l_got_tab := 0
							l_num_spaces := 0
						end
				when 26 then -- if done
						if not js.loop_jumped and then ((l_ptr[l_col]).to_integer_32 = 0) then
							js.break
						end
						if not js.loop_jumped then
							l_vcol := l_vcol + (charset_inst.chartabsize (l_ptr + l_col, l_vcol.to_integer_32)).to_integer_32
							if globals_inst.has_mbyte.to_boolean then
								l_col := l_col + (globals_inst.mb_ptr2len.integer_32_item ([l_ptr + l_col])).to_integer_32
							else
								l_col := l_col + 1
							end
						end
						l_pos := -1 + 5 -- back to loop condition
				when 27 then -- loop done
						js.reset
						if (l_new_line.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						end
				when 28 then -- if done
						if not js.loop_jumped then
							misc1_inst.line_breakcheck
							l_lnum := l_lnum + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 29 then -- loop done
						js.reset
						if globals_inst.got_int.to_boolean then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_interr))))).do_nothing
						end
						if globals_inst.curbuf.item.b_p_ts /= l_new_ts.to_integer_32 then
							screen_inst.redraw_curbuf_later (40)
						end
						if l_first_line /= 0 then
							misc1_inst.changed_lines (l_first_line, 0, l_last_line + 1, 0)
						end
						globals_inst.curwin.item.w_onebuf_opt.wo_list := l_save_list
						globals_inst.curbuf.item.b_p_ts := l_new_ts.to_integer_32
						misc2_inst.coladvance (globals_inst.curwin.item.w_curswant).do_nothing
						undo_inst.u_clearline
				when 30 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_retab_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_retab)
		end

	do_move (a_line1: INTEGER_32; a_line2: INTEGER_32; a_dest: INTEGER_32): INTEGER_32
		local
			l_str___1: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_extra: INTEGER_32
			l_num_lines: INTEGER_32
			l_last_line: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_str___1.make

			if a_dest >= a_line1 then
				if a_dest < a_line2 then
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E134: Move lines into themselves"))))).do_nothing
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_num_lines := (a_line2 - a_line1) + 1
				if (undo_inst.u_save (a_dest, a_dest + 1)) = 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_extra := (0).to_integer_32
				l_l := a_line1
				from
				until
					not (l_l <= a_line2)
				loop
					l_str___1.ce_gets (misc2_inst.vim_strsave ((memline_inst.ml_get (l_l + l_extra))))
					if (l_str___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						memline_inst.ml_append ((a_dest + l_l) - a_line1, l_str___1, 0, 0).do_nothing
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_str___1))
						if a_dest < a_line1 then
							l_extra := l_extra + 1
						end
					end
					l_l := l_l + 1
				end
				l_last_line := globals_inst.curbuf.item.b_ml.ml_line_count
				mark_inst.mark_adjust (a_line1, a_line2, l_last_line - a_line2, 0)
				if a_dest >= a_line2 then
					mark_inst.mark_adjust (a_line2 + 1, a_dest, -l_num_lines, 0)
					globals_inst.curbuf.item.b_op_start.lnum := (a_dest - l_num_lines) + 1
					globals_inst.curbuf.item.b_op_end.lnum := a_dest
				else
					mark_inst.mark_adjust (a_dest + 1, a_line1 - 1, l_num_lines, 0)
					globals_inst.curbuf.item.b_op_start.lnum := a_dest + 1
					globals_inst.curbuf.item.b_op_end.lnum := a_dest + l_num_lines
				end
				l_tmp___2 := 0
				globals_inst.curbuf.item.b_op_end.col := l_tmp___2
				globals_inst.curbuf.item.b_op_start.col := l_tmp___2
				mark_inst.mark_adjust ((l_last_line - l_num_lines) + 1, l_last_line, -((l_last_line - a_dest) - l_extra), 0)
				if (undo_inst.u_save ((a_line1 + l_extra) - 1, (a_line2 + l_extra) + 1)) = 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_l := a_line1
				from
				until
					not (l_l <= a_line2)
				loop
					memline_inst.ml_delete (a_line1 + l_extra, 1).do_nothing
					l_l := l_l + 1
				end
				if not globals_inst.global_busy.to_boolean then
					if l_num_lines > option_inst.p_report then
						if l_num_lines = 1 then
							message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("1 line moved"))))).do_nothing
						else
							message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%%ld lines moved")))), l_num_lines]).do_nothing
						end
					end
				end
				if a_dest >= a_line1 then
					globals_inst.curwin.item.w_cursor.lnum := a_dest
				else
					globals_inst.curwin.item.w_cursor.lnum := (a_dest + (a_line2 - a_line1)) + 1
				end
				if a_line1 < a_dest then
					misc1_inst.changed_lines (a_line1, 0, (a_dest + l_num_lines) + 1, 0)
				else
					misc1_inst.changed_lines (a_dest + 1, 0, a_line1 + l_num_lines, 0)
				end
				Result := 1
			end
		end

	ex_copy (a_line1: INTEGER_32; a_line2: INTEGER_32; a_n: INTEGER_32)
		local
			l_line1: INTEGER_32
			l_line2: INTEGER_32
			l_count___2: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			l_line1 := a_line1
			l_line2 := a_line2
			l_count___2 := (l_line2 - l_line1) + 1
			globals_inst.curbuf.item.b_op_start.lnum := a_n + 1
			globals_inst.curbuf.item.b_op_end.lnum := a_n + l_count___2
			l_tmp := 0
			globals_inst.curbuf.item.b_op_end.col := l_tmp
			globals_inst.curbuf.item.b_op_start.col := l_tmp
			if (undo_inst.u_save (a_n, a_n + 1)) = 0 then
				js.return
			end
			if not js.return_called then
				globals_inst.curwin.item.w_cursor.lnum := a_n
				from
				until
					not (l_line1 <= l_line2)
				loop
					l_p___0.ce_gets (misc2_inst.vim_strsave ((memline_inst.ml_get (l_line1))))
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						memline_inst.ml_append (globals_inst.curwin.item.w_cursor.lnum, l_p___0, 0, 0).do_nothing
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
					end
					if l_line1 = a_n then
						l_line1 := globals_inst.curwin.item.w_cursor.lnum
					end
					l_line1 := l_line1 + 1
					if globals_inst.curwin.item.w_cursor.lnum < l_line1 then
						l_line1 := l_line1 + 1
					end
					if globals_inst.curwin.item.w_cursor.lnum < l_line2 then
						l_line2 := l_line2 + 1
					end
					globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
				end
				misc1_inst.appended_lines_mark (a_n, l_count___2)
				misc1_inst.msgmore (l_count___2)
			end
		end

	do_bang (a_addr_count: INTEGER_32; a_eap: CE_POINTER [PD_EXARG]; a_forceit: INTEGER_32; a_do_in: INTEGER_32; a_do_out: INTEGER_32)
		local
			l_arg: CE_POINTER [NATURAL_8]
			l_line1: INTEGER_32
			l_line2: INTEGER_32
			l_newcmd: CE_POINTER [NATURAL_8]
			l_free_newcmd: INTEGER_32
			l_ins_prevcmd: INTEGER_32
			l_t: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_trailarg: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_scroll_save: INTEGER_32
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___8: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_arg.make
			create l_newcmd.make
			create l_t.make
			create l_p___0.make
			create l_trailarg.make
			create l_tmp___7.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_arg.ce_gets (a_eap.item.arg)
					l_line1 := a_eap.item.line1
					l_line2 := a_eap.item.line2
					l_newcmd.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_free_newcmd := 0
					l_scroll_save := globals_inst.msg_scroll
					if (check_restricted).to_boolean then
						js.return
					elseif (check_secure).to_boolean then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						if a_addr_count = 0 then
							globals_inst.msg_scroll := 0
							ex_cmds2_inst.autowrite_all
							globals_inst.msg_scroll := l_scroll_save
						end
						l_ins_prevcmd := a_forceit
						l_trailarg.ce_gets (l_arg)
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 14 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_trailarg))).to_integer_32 + 1
						if (l_newcmd.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_len := l_len + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_newcmd))).to_integer_32
						end
						if l_ins_prevcmd.to_boolean then
							if (prevcmd.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_noprev))))).do_nothing
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_newcmd))
								js.return
							end
							if not js.return_called then
								l_len := l_len + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (prevcmd))).to_integer_32
							end
						end
						if not js.return_called then
							l_t.ce_gets (misc2_inst.alloc (l_len.to_natural_32))
							if (l_t.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_newcmd))
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 13 -- skip if block
						end
				when 4 then -- if:
						l_t.item := (('%/0/').code).to_natural_8
						if (l_newcmd.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_t), create {CE_POINTER [INTEGER_8]}.make_cast (l_newcmd)).do_nothing
						end
						if l_ins_prevcmd.to_boolean then
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_t), create {CE_POINTER [INTEGER_8]}.make_cast (prevcmd)).do_nothing
						end
						l_p___0.ce_gets (l_t + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_t))).to_integer_32)
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_t), create {CE_POINTER [INTEGER_8]}.make_cast (l_trailarg)).do_nothing
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_newcmd))
						l_newcmd.ce_gets (l_t)
						l_trailarg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				when 5 then -- loop condition:
						if not (not js.loop_left and then ((l_p___0.item).to_boolean)) then
							l_pos := -1 + 12 -- skip loop
						end
				when 6 then -- loop body:
						js.reset
						if (l_p___0.item).to_integer_32 /= 33 then
							l_pos := -1 + 11 -- skip if block
						end
				when 7 then -- if:
						if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_newcmd.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if (l_p___0[-1]).to_integer_32 = 92 then
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_p___0 - 1)), create {CE_POINTER [ANY]}.make_cast (l_p___0), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))) + {NATURAL_32} 1).do_nothing
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						l_trailarg.ce_gets (l_p___0)
						l_tmp___7.ce_gets (l_trailarg)
						l_trailarg.ce_gets (l_trailarg + 1)
						l_tmp___7.item := (('%/0/').code).to_natural_8
						l_ins_prevcmd := 1
						js.break
				when 11 then -- if done
						if not js.loop_jumped then
							l_p___0.ce_gets (l_p___0 + 1)
						end
						l_pos := -1 + 5 -- back to loop condition
				when 12 then -- loop done
						js.reset
						if (l_trailarg.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						end
				when 13 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 14 then -- loop done
						js.reset
				when 15 then -- if done
					if not js.return_called then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (prevcmd))
						prevcmd.ce_gets (l_newcmd)
						if globals_inst.bangredo.to_boolean then
							getchar_inst.AppendToRedobuffLit (prevcmd, -1)
							getchar_inst.AppendToRedobuff (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
							globals_inst.bangredo := 0
						end
						if (option_inst.p_shq.item).to_integer_32 /= 0 then
							l_tmp___8 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (prevcmd))
							l_newcmd.ce_gets (misc2_inst.alloc ((l_tmp___8 + {NATURAL_32} 2 * (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_shq)))) + {NATURAL_32} 1))
							if (l_newcmd.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.return
							end
							if not js.return_called then
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_newcmd), create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_shq)).do_nothing
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_newcmd), create {CE_POINTER [INTEGER_8]}.make_cast (prevcmd)).do_nothing
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_newcmd), create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_shq)).do_nothing
								l_free_newcmd := 1
							end
						end
					end
					if not js.return_called then
						if a_addr_count = 0 then
							message_inst.msg_start
							message_inst.msg_putchar ((':').code)
							message_inst.msg_putchar (('!').code)
							message_inst.msg_outtrans (l_newcmd).do_nothing
							message_inst.msg_clr_eos
							screen_inst.windgoto (globals_inst.msg_row, globals_inst.msg_col)
							do_shell (l_newcmd, 0)
						else
							do_filter (l_line1, l_line2, a_eap, l_newcmd, a_do_in, a_do_out)
							fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_SHELLFILTERPOST, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
						end
						if l_free_newcmd.to_boolean then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_newcmd))
						end
					end
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_filter (a_line1: INTEGER_32; a_line2: INTEGER_32; a_eap: CE_POINTER [PD_EXARG]; a_cmd: CE_POINTER [NATURAL_8]; a_do_in: INTEGER_32; a_do_out: INTEGER_32)
		local
			l_itmp: CE_POINTER [NATURAL_8]
			l_otmp: CE_POINTER [NATURAL_8]
			l_linecount: INTEGER_32
			l_read_linecount: INTEGER_32
			l_cursor_save: PD_POS_T
			l_cmd_buf: CE_POINTER [NATURAL_8]
			l_old_curbuf: CE_POINTER [PD_FILE_BUFFER]
			l_shell_flags: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_itmp.make
			create l_otmp.make
			create l_cursor_save.make
			create l_cmd_buf.make
			create l_old_curbuf.make
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_itmp.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_otmp.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_old_curbuf.ce_gets (globals_inst.curbuf)
					l_shell_flags := 0
					if (a_cmd.item).to_integer_32 = 0 then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 37 -- skip if block
					end
				when 1 then -- if:
						l_cursor_save.ce_gets (globals_inst.curwin.item.w_cursor)
						l_linecount := (a_line2 - a_line1) + 1
						globals_inst.curwin.item.w_cursor.lnum := a_line1
						globals_inst.curwin.item.w_cursor.col := 0
						move_inst.changed_line_abv_curs
						move_inst.invalidate_botline
						if a_do_out.to_boolean then
							l_shell_flags := (l_shell_flags).bit_or ((8))
						end
						if a_do_in.to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if a_do_out.to_boolean then
							if not option_inst.p_stmp.to_boolean then
								l_shell_flags := (l_shell_flags).bit_or ((32))
								globals_inst.curwin.item.w_cursor.lnum := a_line2
							else
								l_pos := -1 + 4 -- goto _L___5
							end
						else
							l_pos := -1 + 4 -- goto _L___5
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 4 then -- else: | _L___5:
						if not (a_do_in.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if not a_do_out.to_boolean then
							if not option_inst.p_stmp.to_boolean then
								l_shell_flags := (l_shell_flags).bit_or ((64))
								globals_inst.curbuf.item.b_op_start.lnum := a_line1
								globals_inst.curbuf.item.b_op_end.lnum := a_line2
							else
								l_pos := -1 + 7 -- goto _L___3
							end
						else
							l_pos := -1 + 7 -- goto _L___3
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 7 then -- else: | _L___3:
						if not (a_do_in.to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if a_do_out.to_boolean then
							if not option_inst.p_stmp.to_boolean then
								l_shell_flags := (l_shell_flags).bit_or ((96))
								globals_inst.curbuf.item.b_op_start.lnum := a_line1
								globals_inst.curbuf.item.b_op_end.lnum := a_line2
								globals_inst.curwin.item.w_cursor.lnum := a_line2
							else
								l_pos := -1 + 10 -- goto _L___1
							end
						else
							l_pos := -1 + 10 -- goto _L___1
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else: | _L___1:
						if not (a_do_in.to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_itmp.ce_gets (fileio_inst.vim_tempname (('i').code))
						if (l_itmp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_tmp.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notmp)))
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
							l_pos := -1 + 36 -- goto filterend
						else
							l_pos := -1 + 13 -- goto _L
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L:
						if a_do_out.to_boolean then
							l_otmp.ce_gets (fileio_inst.vim_tempname (('o').code))
							if (l_otmp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_tmp.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notmp)))
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
								l_pos := -1 + 36 -- goto filterend
							end
						end
				when 14 then -- if done | if done | if done
						globals_inst.no_wait_return := globals_inst.no_wait_return + 1
						if (l_itmp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (fileio_inst.buf_write (globals_inst.curbuf, l_itmp, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), a_line1, a_line2, a_eap, 0, 0, 0, 1)) = 0 then
								message_inst.msg_putchar (('%N').code)
								globals_inst.no_wait_return := globals_inst.no_wait_return - 1
								if not (ex_eval_inst.aborting).to_boolean then
									message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notcreate)))), l_itmp).do_nothing
								end
								l_pos := -1 + 36 -- goto filterend
							end
						end
				when 15 then
						if (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 /= (l_old_curbuf.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 36 -- goto filterend
						end
				when 16 then
						if not a_do_out.to_boolean then
							message_inst.msg_putchar (('%N').code)
						end
						l_cmd_buf.ce_gets (make_filter_cmd (a_cmd, l_itmp, l_otmp))
						if (l_cmd_buf.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 36 -- goto filterend
						end
				when 17 then
						screen_inst.windgoto (globals_inst.Rows.to_integer_32 - 1, 0)
						term_inst.cursor_on
						if not a_do_out.to_boolean then
							screen_inst.redraw_later_clear
						elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_srr), ce_string (">"))) = 0 then
							screen_inst.redraw_later_clear
						elseif not a_do_in.to_boolean then
							screen_inst.redraw_later_clear
						end
						if not (a_do_out.to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						if (undo_inst.u_save (a_line2, a_line2 + 1)) = 0 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cmd_buf))
							l_pos := -1 + 35 -- goto error
						end
				when 19 then
						screen_inst.redraw_curbuf_later (10)
				when 20 then -- if done
						l_read_linecount := globals_inst.curbuf.item.b_ml.ml_line_count
						if (misc2_inst.call_shell (l_cmd_buf, (5).bit_or (l_shell_flags))).to_boolean then
							screen_inst.redraw_later_clear
							message_inst.wait_return (0)
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cmd_buf))
						globals_inst.did_check_timestamps := 0
						globals_inst.need_check_timestamps := 1
						ui_inst.ui_breakcheck
						globals_inst.got_int := 0
						if not (a_do_out.to_boolean) then
							l_pos := -1 + 35 -- skip if block
						end
				when 21 then -- if:
						if (l_otmp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if (fileio_inst.readfile (l_otmp, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), a_line2, (0).to_integer_32, 2147483647, a_eap, 2)) = 0 then
							if not (ex_eval_inst.aborting).to_boolean then
								message_inst.msg_putchar (('%N').code)
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notread)))), l_otmp).do_nothing
							end
							l_pos := -1 + 35 -- goto error
						end
				when 23 then
						if (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 /= (l_old_curbuf.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 36 -- goto filterend
						end
				when 24 then
						l_read_linecount := globals_inst.curbuf.item.b_ml.ml_line_count - l_read_linecount
						if ((l_shell_flags).bit_and (32)).to_boolean then
							globals_inst.curbuf.item.b_op_start.lnum := a_line2 + 1
							globals_inst.curbuf.item.b_op_end.lnum := globals_inst.curwin.item.w_cursor.lnum
							misc1_inst.appended_lines_mark (a_line2, l_read_linecount)
						end
						if not (a_do_in.to_boolean) then
							l_pos := -1 + 32 -- skip if block
						end
				when 25 then -- if:
						if not ((globals_inst.cmdmod.keepmarks).to_boolean) then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_pos := -1 + 29 -- goto _L___6
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 28 then -- else:
						if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('R').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 30 -- skip if block
						end
				when 29 then -- if: | _L___6:
						if l_read_linecount >= l_linecount then
							mark_inst.mark_adjust (a_line1, a_line2, l_linecount, 0)
						else
							mark_inst.mark_adjust (a_line1, (a_line1 + l_read_linecount) - 1, l_linecount, 0)
							mark_inst.mark_adjust (a_line1 + l_read_linecount, a_line2, 2147483647, 0)
						end
				when 30 then -- if done
						globals_inst.curwin.item.w_cursor.lnum := a_line1
						misc1_inst.del_lines (l_linecount, 1)
						globals_inst.curbuf.item.b_op_start.lnum := globals_inst.curbuf.item.b_op_start.lnum - l_linecount
						globals_inst.curbuf.item.b_op_end.lnum := globals_inst.curbuf.item.b_op_end.lnum - l_linecount
						fileio_inst.write_lnum_adjust (-l_linecount)
						fold_inst.foldUpdate (globals_inst.curwin, globals_inst.curbuf.item.b_op_start.lnum, globals_inst.curbuf.item.b_op_end.lnum)
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else:
						l_linecount := (globals_inst.curbuf.item.b_op_end.lnum - globals_inst.curbuf.item.b_op_start.lnum) + 1
						globals_inst.curwin.item.w_cursor.lnum := globals_inst.curbuf.item.b_op_end.lnum
				when 33 then -- if done
						edit_inst.beginline (5)
						globals_inst.no_wait_return := globals_inst.no_wait_return - 1
						if l_linecount > option_inst.p_report then
							if a_do_in.to_boolean then
								message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.msg_buf), (Natural_8_bytes.to_natural_32 * (480).to_natural_32), (gettext (ce_string ("%%ld lines filtered"))), l_linecount]).do_nothing
								if (message_inst.msg (globals_inst.msg_buf)).to_boolean then
									if not globals_inst.msg_scroll.to_boolean then
										message_inst.set_keep_msg (globals_inst.msg_buf, 0)
									end
								end
							else
								misc1_inst.msgmore (l_linecount)
							end
						end
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 35 then -- else: | error:
						globals_inst.curwin.item.w_cursor := l_cursor_save
						globals_inst.no_wait_return := globals_inst.no_wait_return - 1
						message_inst.wait_return (0)
				when 36 then -- filterend:
						if (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 /= (l_old_curbuf.c_pointer.to_integer_32).to_natural_32 then
							globals_inst.no_wait_return := globals_inst.no_wait_return - 1
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E135: *Filter* Autocommands must not change current buffer"))))).do_nothing
						end
						if (l_itmp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_itmp)).do_nothing
						end
						if (l_otmp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_otmp)).do_nothing
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_itmp))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_otmp))
				when 37 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_shell (a_cmd: CE_POINTER [NATURAL_8]; a_flags___0: INTEGER_32)
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_save_nwr: INTEGER_32
			js: JUMP_STATE
		do
			create l_buf___6.make

			if (check_restricted).to_boolean then
				message_inst.msg_end.do_nothing
				js.return
			elseif (check_secure).to_boolean then
				message_inst.msg_end.do_nothing
				js.return
			end
			if not js.return_called then
				message_inst.msg_putchar (('%R').code)
				if not globals_inst.autocmd_busy.to_boolean then
					term_inst.stoptermcap
				end
				message_inst.msg_putchar (('%N').code)
				if option_inst.p_warn.to_boolean then
					if not globals_inst.autocmd_busy.to_boolean then
						if globals_inst.msg_silent = 0 then
							l_buf___6.ce_gets (globals_inst.firstbuf)
							from
							until
								not (not js.loop_left and then ((l_buf___6).c_pointer /= default_pointer))
							loop
								js.reset
								if (undo_inst.bufIsChanged (l_buf___6)).to_boolean then
									message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("[No write since last change]%N")))))
									js.break
								end
								if not js.loop_jumped then
									l_buf___6.ce_gets (l_buf___6.item.b_next)
								end
							end
							js.reset
						end
					end
				end
				if not (term_inst.swapping_screen).to_boolean then
					screen_inst.windgoto (globals_inst.msg_row, globals_inst.msg_col)
				end
				term_inst.cursor_on
				misc2_inst.call_shell (a_cmd, (4).bit_or (a_flags___0)).do_nothing
				globals_inst.did_check_timestamps := 0
				globals_inst.need_check_timestamps := 1
				if not (term_inst.swapping_screen).to_boolean then
					globals_inst.msg_row := (globals_inst.Rows - 1).to_integer_32
					globals_inst.msg_col := 0
				end
				if globals_inst.autocmd_busy.to_boolean then
					if globals_inst.msg_silent = 0 then
						screen_inst.redraw_later_clear
					end
				else
					if (a_cmd.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						if globals_inst.msg_silent = 0 then
							screen_inst.redraw_later_clear
						end
						globals_inst.need_wait_return := 0
					else
						l_save_nwr := globals_inst.no_wait_return
						if (term_inst.swapping_screen).to_boolean then
							globals_inst.no_wait_return := 0
						end
						message_inst.wait_return ((globals_inst.msg_silent = 0).to_integer)
						globals_inst.no_wait_return := l_save_nwr
					end
					term_inst.starttermcap
				end
				gui_inst.display_errors
				fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_SHELLCMDPOST, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
			end
		end

	make_filter_cmd (a_cmd: CE_POINTER [NATURAL_8]; a_itmp: CE_POINTER [NATURAL_8]; a_otmp: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_buf___6: CE_POINTER [NATURAL_8]
			l_len: NATURAL_32
			l_tmp___1: NATURAL_32
			js: JUMP_STATE
		do
			create l_buf___6.make

			l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd))).to_natural_32 + {NATURAL_32} 3
			if (a_itmp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_len := l_len + ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_itmp))).to_natural_32 + {NATURAL_32} 9)
			end
			if (a_otmp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_tmp___1 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_otmp))
				l_len := l_len + ((l_tmp___1.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_srr))).to_natural_32) + {NATURAL_32} 2)
			end
			l_buf___6.ce_gets (misc2_inst.lalloc (l_len, 1))
			if (l_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				if (a_itmp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), l_len.to_natural_32, ce_string ("(%%s)"), create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd)]).do_nothing
				elseif (a_otmp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), l_len.to_natural_32, ce_string ("(%%s)"), create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd)]).do_nothing
				else
					strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd)).do_nothing
				end
				if (a_itmp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string (" < ")).do_nothing
					strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), create {CE_POINTER [INTEGER_8]}.make_cast (a_itmp)).do_nothing
				end
				if (a_otmp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					append_redir (l_buf___6, l_len.to_integer_32, option_inst.p_srr, a_otmp)
				end
				Result := l_buf___6
			end
		end

	append_redir (a_buf___6: CE_POINTER [NATURAL_8]; a_buflen: INTEGER_32; a_opt: CE_POINTER [NATURAL_8]; a_fname: CE_POINTER [NATURAL_8])
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_end: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_end.make
			create l_tmp___0.make

			l_end.ce_gets (a_buf___6 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6))).to_integer_32)
			l_p___0.ce_gets (a_opt)
			from
			until
				js.loop_left
			loop
				js.reset
				l_p___0.ce_gets (misc2_inst.vim_strchr (l_p___0, ('%%').code))
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					js.break
				end
				if not js.loop_jumped and then ((l_p___0[1]).to_integer_32 = 115) then
					js.break
				end
				if not js.loop_jumped then
					l_p___0.ce_gets (l_p___0 + 1)
				end
			end
			js.reset
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_end.item := ((' ').code).to_natural_8
				message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_end) + 1, (a_buflen - ((l_end + 1).distance (a_buf___6))).to_natural_32, create {CE_POINTER [INTEGER_8]}.make_cast (a_opt), create {CE_POINTER [INTEGER_8]}.make_cast (a_fname)]).do_nothing
			else
				if (a_opt.c_pointer.to_integer_32).to_natural_32 /= (option_inst.p_sp.c_pointer.to_integer_32).to_natural_32 then
					l_tmp___0.ce_gets (ce_string (" %%s%%s"))
				else
					l_tmp___0.ce_gets (ce_string (" %%s %%s"))
				end
				message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_end), (a_buflen - (l_end.distance (a_buf___6))).to_natural_32, l_tmp___0, create {CE_POINTER [INTEGER_8]}.make_cast (a_opt), create {CE_POINTER [INTEGER_8]}.make_cast (a_fname)]).do_nothing
			end
		end

	no_viminfo: INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (globals_inst.use_viminfo.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.use_viminfo), ce_string ("NONE"))) = 0 then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	viminfo_error (a_errnum: CE_POINTER [INTEGER_8]; a_message: CE_POINTER [INTEGER_8]; a_line: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			js: JUMP_STATE
		do
			message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1025).to_natural_32, (gettext (ce_string ("%%sviminfo: %%s in line: "))), a_errnum, a_message]).do_nothing
			strncat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), create {CE_POINTER [INTEGER_8]}.make_cast (a_line), ({NATURAL_32} 1025 - (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff)))) - {NATURAL_32} 1).do_nothing
			if (globals_inst.IObuff[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 10 then
				globals_inst.IObuff[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff))) - {NATURAL_32} 1).to_integer_32] := (('%/0/').code).to_natural_8
			end
			message_inst.emsg (globals_inst.IObuff).do_nothing
			viminfo_errcnt := viminfo_errcnt + 1
			if viminfo_errcnt >= 10 then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E136: viminfo: Too many errors, skipping rest of file"))))).do_nothing
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	read_viminfo (a_file: CE_POINTER [NATURAL_8]; a_flags___0: INTEGER_32): INTEGER_32
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_fname: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_fp.make
			create l_fname.make
			create l_tmp___1.make
			create l_tmp___3.make
			create l_tmp___5.make
			create l_tmp___7.make

			if (no_viminfo).to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_fname.ce_gets (viminfo_filename (a_file))
				if (l_fname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_fp.ce_gets (fopen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), ce_string ("r")))
				if option_inst.p_verbose > 0 then
					message_inst.verbose_enter
					if (l_fp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_tmp___1.ce_gets ((gettext (ce_string (" FAILED"))))
					else
						l_tmp___1.ce_gets (ce_string (""))
					end
					if ((a_flags___0).bit_and (8)).to_boolean then
						l_tmp___3.ce_gets ((gettext (ce_string (" oldfiles"))))
					else
						l_tmp___3.ce_gets (ce_string (""))
					end
					if ((a_flags___0).bit_and (2)).to_boolean then
						l_tmp___5.ce_gets ((gettext (ce_string (" marks"))))
					else
						l_tmp___5.ce_gets (ce_string (""))
					end
					if ((a_flags___0).bit_and (1)).to_boolean then
						l_tmp___7.ce_gets ((gettext (ce_string (" info"))))
					else
						l_tmp___7.ce_gets (ce_string (""))
					end
					message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Reading viminfo file %"%%s%"%%s%%s%%s")))), l_fname, l_tmp___7, l_tmp___5, l_tmp___3, l_tmp___1]).do_nothing
					message_inst.verbose_leave
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fname))
				if (l_fp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				viminfo_errcnt := 0
				do_viminfo (l_fp, create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer), a_flags___0)
				fclose (l_fp).do_nothing
				Result := 1
			end
		end

	write_viminfo (a_file: CE_POINTER [NATURAL_8]; a_forceit: INTEGER_32)
		local
			l_fname: CE_POINTER [NATURAL_8]
			l_fp_in: CE_POINTER [SD_IO_FILE]
			l_fp_out: CE_POINTER [SD_IO_FILE]
			l_tempname: CE_POINTER [NATURAL_8]
			l_st_new: SD_STAT
			l_wp___0: CE_POINTER [NATURAL_8]
			l_umask_save: NATURAL_32
			l_shortname: INTEGER_32
			l_st_old: SD_STAT
			l_tt: INTEGER_32
			l_tmp___6: NATURAL_32
			l_tmp___8: NATURAL_32
			l_fd: INTEGER_32
			l_tmp___15: CE_POINTER [NATURAL_8]
			l_tmp___18: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fname.make
			create l_fp_in.make
			create l_fp_out.make
			create l_tempname.make
			create l_st_new.make
			create l_wp___0.make
			create l_st_old.make
			create l_tmp___15.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fp_in.ce_gets (create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer))
					l_fp_out.ce_gets (create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer))
					l_tempname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_shortname := 0
					if (no_viminfo).to_boolean then
						js.return
					end
					if not js.return_called then
						l_fname.ce_gets (viminfo_filename (a_file))
						if (l_fname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						l_fp_in.ce_gets (fopen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), ce_string ("r")))
						if (l_fp_in.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 5 -- skip if block
						end
				when 2 then -- if:
						if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), (l_st_new.address))) = 0 then
							l_pos := -1 + 9 -- goto end
						end
				when 3 then
						l_umask_save := umask ((63).to_natural_32)
						l_fp_out.ce_gets (fopen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), ce_string ("w")))
						umask (l_umask_save).do_nothing
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						l_st_old.st_dev := (0).to_natural_64
						l_st_old.st_ino := (0).to_natural_32
						l_st_old.st_mode := (384).to_natural_32
						if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), (l_st_old.address))) = 0 then
							if (getuid) /= {NATURAL_32} 0 then
								if l_st_old.st_uid = (getuid) then
									l_tmp___8 := (l_st_old.st_mode).bit_and ({NATURAL_32} 128)
								else
									if l_st_old.st_gid = (getgid) then
										l_tmp___6 := (l_st_old.st_mode).bit_and ({NATURAL_32} 16)
									else
										l_tmp___6 := (l_st_old.st_mode).bit_and ({NATURAL_32} 2)
									end
									l_tmp___8 := l_tmp___6
								end
								if not l_tmp___8.to_boolean then
									l_tt := globals_inst.msg_didany
									message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E137: Viminfo file is not writable: %%s")))), l_fname).do_nothing
									globals_inst.msg_didany := l_tt
									fclose (l_fp_in).do_nothing
									l_pos := -1 + 9 -- goto end
								end
							end
						end
				when 6 then
						from
						until
							js.loop_left
						loop
							js.reset
							l_tempname.ce_gets (fileio_inst.buf_modname (l_shortname, l_fname, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".tmp")), 0))
							if (l_tempname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.break
							end
							if not js.loop_jumped then
								if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_tempname), (l_st_new.address))) = 0 then
									if not l_shortname.to_boolean then
										if l_st_new.st_dev = l_st_old.st_dev then
											if l_st_new.st_ino = l_st_old.st_ino then
												misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tempname))
												l_tempname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
												l_shortname := 1
												js.continue
											end
										end
									end
									if not js.loop_jumped then
										l_wp___0.ce_gets ((l_tempname + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tempname))).to_integer_32) - 5)
										if (l_wp___0.c_pointer.to_integer_32).to_natural_32 < ((misc1_inst.gettail (l_tempname)).c_pointer.to_integer_32).to_natural_32 then
											l_wp___0.ce_gets (misc1_inst.gettail (l_tempname))
										end
										l_wp___0.item := (('z').code).to_natural_8
										from
										until
											js.loop_left
										loop
											js.reset
											if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_tempname), (l_st_new.address))) /= 0 then
												js.break
											end
											if not js.loop_jumped and then ((l_wp___0.item).to_integer_32 = 97) then
												misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tempname))
												l_tempname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
												js.break
											end
											if not js.loop_jumped then
												l_wp___0.item := ((l_wp___0.item).to_integer_32 - 1).to_natural_8
											end
										end
										js.reset
									end
								end
							end
							if not js.loop_jumped then
								js.break
							end
							if not js.loop_left then
								
							end
						end
						js.reset
						if (l_tempname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_umask_save := umask ((0).to_natural_32)
							l_fd := open ([create {CE_POINTER [INTEGER_8]}.make_cast (l_tempname), 131265, ((((l_st_old.st_mode).bit_and ({NATURAL_32} 511))).bit_or ({NATURAL_32} 384)).to_integer_32])
							umask (l_umask_save).do_nothing
							if l_fd < 0 then
								l_fp_out.ce_gets (create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer))
							else
								l_fp_out.ce_gets (fdopen (l_fd, ce_string ("w")))
							end
							if (l_fp_out.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tempname))
								l_tempname.ce_gets (fileio_inst.vim_tempname (('o').code))
								if (l_tempname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_fp_out.ce_gets (fopen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tempname), ce_string ("w")))
								end
							end
							if (l_fp_out.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								globals_inst.ignored := fchown ((fileno (l_fp_out)), l_st_old.st_uid, l_st_old.st_gid)
							end
						end
				when 7 then -- if done
						if (l_fp_out.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if (l_fp_in.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_tmp___15.ce_gets (l_fname)
							elseif (l_tempname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_tmp___15.ce_gets (l_fname)
							else
								l_tmp___15.ce_gets (l_tempname)
							end
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E138: Can%'t write viminfo file %%s!")))), l_tmp___15).do_nothing
							if (l_fp_in.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								fclose (l_fp_in).do_nothing
							end
							l_pos := -1 + 9 -- goto end
						end
				when 8 then
						if option_inst.p_verbose > 0 then
							message_inst.verbose_enter
							message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Writing viminfo file %"%%s%"")))), l_fname]).do_nothing
							message_inst.verbose_leave
						end
						viminfo_errcnt := 0
						if a_forceit.to_boolean then
							l_tmp___18 := 0
						else
							l_tmp___18 := 3
						end
						do_viminfo (l_fp_in, l_fp_out, l_tmp___18)
						fclose (l_fp_out).do_nothing
						if (l_fp_in.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							fclose (l_fp_in).do_nothing
							if viminfo_errcnt.to_boolean then
								unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_tempname)).do_nothing
							elseif (fileio_inst.vim_rename (l_tempname, l_fname)) = -1 then
								unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_tempname)).do_nothing
							end
						end
				when 9 then -- end:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fname))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tempname))
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	viminfo_filename (a_file: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_file: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_file.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_file.ce_gets (a_file)
					if (l_file.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if (l_file.item).to_integer_32 /= 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if (globals_inst.use_viminfo.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_file.ce_gets (globals_inst.use_viminfo)
						else
							l_file.ce_gets (option_inst.find_viminfo_parameter (('n').code))
							if (l_file.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_file.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("$HOME/.viminfo")))
							elseif (l_file.item).to_integer_32 = 0 then
								l_file.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("$HOME/.viminfo")))
							end
						end
						misc1_inst.expand_env (l_file, globals_inst.NameBuff, 4096)
						l_file.ce_gets (globals_inst.NameBuff)
				when 5 then -- if done
						Result := (misc2_inst.vim_strsave (l_file))
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	do_viminfo (a_fp_in: CE_POINTER [SD_IO_FILE]; a_fp_out: CE_POINTER [SD_IO_FILE]; a_flags___0: INTEGER_32)
		local
			l_count___2: INTEGER_32
			l_eof: INTEGER_32
			l_vir: PD_VIR_T
			js: JUMP_STATE
		do
			create l_vir.make

			l_count___2 := 0
			l_eof := 0
			l_vir.vir_line := misc2_inst.alloc ({NATURAL_32} 512)
			if ((l_vir.vir_line).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				l_vir.vir_fd := a_fp_in
				l_vir.vir_conv.vc_type := 0
				if (a_fp_in.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if ((a_flags___0).bit_and (1)).to_boolean then
						l_eof := read_viminfo_up_to_marks (l_vir.address, (a_flags___0).bit_and (4), ((a_fp_out.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer)
					else
						from
						until
							js.loop_left
						loop
							js.reset
							l_eof := viminfo_readline (l_vir.address)
							if l_eof.to_boolean then
								js.break
							elseif (l_vir.vir_line[0]).to_integer_32 = 62 then
								js.break
							end
						end
						js.reset
					end
				end
				if (a_fp_out.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					fprintf ([a_fp_out, (gettext (ce_string ("# This viminfo file was generated by Vim %%s.%N"))), ce_string ("7.3")]).do_nothing
					fputs ((gettext (ce_string ("# You may edit it if you%'re careful!%N%N"))), a_fp_out).do_nothing
					fputs ((gettext (ce_string ("# Value of %'encoding%' when this file was written%N"))), a_fp_out).do_nothing
					fprintf ([a_fp_out, ce_string ("*encoding=%%s%N%N"), option_inst.p_enc]).do_nothing
					search_inst.write_viminfo_search_pattern (a_fp_out)
					write_viminfo_sub_string (a_fp_out)
					ex_getln_inst.write_viminfo_history (a_fp_out)
					ops_inst.write_viminfo_registers (a_fp_out)
					eval_inst.write_viminfo_varlist (a_fp_out)
					mark_inst.write_viminfo_filemarks (a_fp_out)
					buffer_inst.write_viminfo_bufferlist (a_fp_out)
					l_count___2 := mark_inst.write_viminfo_marks (a_fp_out)
				end
				if (a_fp_in.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if ((a_flags___0).bit_and (14)).to_boolean then
						mark_inst.copy_viminfo_marks (l_vir.address, a_fp_out, l_count___2, l_eof, a_flags___0)
					end
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_vir.vir_line))
				if l_vir.vir_conv.vc_type /= 0 then
					mbyte_inst.convert_setup (create {CE_POINTER [PD_VIMCONV_T]}.make_shared (l_vir.c_pointer + {PD_VIR_T}.vir_conv_offset), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
				end
			end
		end

	read_viminfo_up_to_marks (a_virp: CE_POINTER [PD_VIR_T]; a_forceit: INTEGER_32; a_writing: INTEGER_32): INTEGER_32
		local
			l_eof: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___6.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_forceit.to_boolean then
						l_tmp := 9999
					else
						l_tmp := 0
					end
					ex_getln_inst.prepare_viminfo_history (l_tmp)
					l_eof := viminfo_readline (a_virp)
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 15 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if not l_eof.to_boolean then
							if (a_virp.item.vir_line[0]).to_integer_32 = 62 then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 14 -- skip if block
						end
				when 3 then -- if:
						inspect (a_virp.item.vir_line[0]).to_integer_32 -- switch 1 head
						when 43 then l_pos := -1 + 4
						when 124 then l_pos := -1 + 4
						when 94 then l_pos := -1 + 4
						when 60 then l_pos := -1 + 4
						when 0 then l_pos := -1 + 4
						when 13 then l_pos := -1 + 4
						when 10 then l_pos := -1 + 4
						when 35 then l_pos := -1 + 4
						when 42 then l_pos := -1 + 5
						when 33 then l_pos := -1 + 6
						when 37 then l_pos := -1 + 7
						when 34 then l_pos := -1 + 8
						when 47 then l_pos := -1 + 9
						when 38 then l_pos := -1 + 9
						when 126 then l_pos := -1 + 9
						when 36 then l_pos := -1 + 10
						when 58 then l_pos := -1 + 11
						when 63 then l_pos := -1 + 11
						when 61 then l_pos := -1 + 11
						when 64 then l_pos := -1 + 11
						when 45 then l_pos := -1 + 12
						when 39 then l_pos := -1 + 12
						else l_pos := -1 + 13
						end
				when 4 then -- switch 1, case 43 | switch 1, case 124 | switch 1, case 94 | switch 1, case 60 | switch 1, case 0 | switch 1, case 13 | switch 1, case 10 | switch 1, case 35
						l_eof := viminfo_readline (a_virp)
						l_pos := -1 + 14 -- switch 1; break
				when 5 then -- switch 1, case 42
						l_eof := viminfo_encoding (a_virp)
						l_pos := -1 + 14 -- switch 1; break
				when 6 then -- switch 1, case 33
						l_eof := eval_inst.read_viminfo_varlist (a_virp, a_writing)
						l_pos := -1 + 14 -- switch 1; break
				when 7 then -- switch 1, case 37
						l_eof := buffer_inst.read_viminfo_bufferlist (a_virp, a_writing)
						l_pos := -1 + 14 -- switch 1; break
				when 8 then -- switch 1, case 34
						l_eof := ops_inst.read_viminfo_register (a_virp, a_forceit)
						l_pos := -1 + 14 -- switch 1; break
				when 9 then -- switch 1, case 47 | switch 1, case 38 | switch 1, case 126
						l_eof := search_inst.read_viminfo_search_pattern (a_virp, a_forceit)
						l_pos := -1 + 14 -- switch 1; break
				when 10 then -- switch 1, case 36
						l_eof := read_viminfo_sub_string (a_virp, a_forceit)
						l_pos := -1 + 14 -- switch 1; break
				when 11 then -- switch 1, case 58 | switch 1, case 63 | switch 1, case 61 | switch 1, case 64
						l_eof := ex_getln_inst.read_viminfo_history (a_virp)
						l_pos := -1 + 14 -- switch 1; break
				when 12 then -- switch 1, case 45 | switch 1, case 39
						l_eof := mark_inst.read_viminfo_filemark (a_virp, a_forceit)
						l_pos := -1 + 14 -- switch 1; break
				when 13 then -- switch 1, default:
						if (viminfo_error (ce_string ("E575: "), (gettext (ce_string ("Illegal starting char"))), a_virp.item.vir_line)).to_boolean then
							l_eof := 1
						else
							l_eof := viminfo_readline (a_virp)
						end
						l_pos := -1 + 14 -- switch 1; break
				when 14 then -- switch 1, done: | if done
						l_pos := -1 + 1 -- back to loop condition
				when 15 then -- loop done
					js.reset
					ex_getln_inst.finish_viminfo_history
					l_buf___6.ce_gets (globals_inst.firstbuf)
					from
					until
						(l_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
					loop
						mark_inst.fmarks_check_names (l_buf___6)
						l_buf___6.ce_gets (l_buf___6.item.b_next)
					end
					Result := l_eof
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	viminfo_encoding (a_virp: CE_POINTER [PD_VIR_T]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			if (option_inst.get_viminfo_parameter (('c').code)) /= 0 then
				l_p___0.ce_gets (misc2_inst.vim_strchr (a_virp.item.vir_line, ('=').code))
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					l_p___0.ce_gets (l_p___0 + 1)
					l_i___0 := 0
					from
					until
						js.loop_left
					loop
						js.reset
						if not (charset_inst.vim_isprintc ((l_p___0[l_i___0]).to_integer_32)).to_boolean then
							js.break
						end
						if not js.loop_jumped then
							l_i___0 := l_i___0 + 1
						end
					end
					js.reset
					l_p___0[l_i___0] := (('%/0/').code).to_natural_8
					mbyte_inst.convert_setup (create {CE_POINTER [PD_VIMCONV_T]}.make_shared (a_virp.c_pointer + {PD_VIR_T}.vir_conv_offset), l_p___0, option_inst.p_enc).do_nothing
				end
			end
			Result := (viminfo_readline (a_virp))
		end

	viminfo_readline (a_virp: CE_POINTER [PD_VIR_T]): INTEGER_32
		do
			Result := (fileio_inst.vim_fgets (a_virp.item.vir_line, 512, a_virp.item.vir_fd))
		end

	viminfo_readstring (a_virp: CE_POINTER [PD_VIR_T]; a_off___0: INTEGER_32; a_convert: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_retval: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_retval.make
			create l_s.make
			create l_d.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_virp.item.vir_line[a_off___0]).to_integer_32 /= 22 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (charset_inst.vim_isdigit ((a_virp.item.vir_line[(a_off___0 + 1)]).to_integer_32)).to_boolean then
							l_len := atol (((create {CE_POINTER [INTEGER_8]}.make_cast (a_virp.item.vir_line) + a_off___0) + 1))
							l_retval.ce_gets (misc2_inst.lalloc (l_len.to_natural_32, 1))
							if (l_retval.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								fileio_inst.vim_fgets (a_virp.item.vir_line, 10, a_virp.item.vir_fd).do_nothing
								Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								js.return
							end
							if not js.return_called then
								fileio_inst.vim_fgets (l_retval, l_len.to_integer_32, a_virp.item.vir_fd).do_nothing
								l_s.ce_gets (l_retval + 1)
							end
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						l_retval.ce_gets (misc2_inst.vim_strsave (a_virp.item.vir_line + a_off___0))
						if (l_retval.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called then
							l_s.ce_gets (l_retval)
						end
				when 4 then
					if not js.return_called then
						l_d.ce_gets (l_retval)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_s.item).to_integer_32 /= 0 then
								if (l_s.item).to_integer_32 = 10 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if (l_s[0]).to_integer_32 = 22 then
									if (l_s[1]).to_integer_32 /= 0 then
										if (l_s[1]).to_integer_32 = 110 then
											l_tmp___0.ce_gets (l_d)
											l_d.ce_gets (l_d + 1)
											l_tmp___0.item := (('%N').code).to_natural_8
										else
											l_tmp___1.ce_gets (l_d)
											l_d.ce_gets (l_d + 1)
											l_tmp___1.item := (22).to_natural_8
										end
										l_s.ce_gets (l_s + (2))
									else
										l_tmp___2.ce_gets (l_d)
										l_d.ce_gets (l_d + 1)
										l_tmp___3.ce_gets (l_s)
										l_s.ce_gets (l_s + 1)
										l_tmp___2.item := l_tmp___3.item
									end
								else
									l_tmp___2.ce_gets (l_d)
									l_d.ce_gets (l_d + 1)
									l_tmp___3.ce_gets (l_s)
									l_s.ce_gets (l_s + 1)
									l_tmp___2.item := l_tmp___3.item
								end
							end
						end
						js.reset
						l_d.item := (('%/0/').code).to_natural_8
						if a_convert.to_boolean then
							if a_virp.item.vir_conv.vc_type /= 0 then
								if (l_retval.item).to_integer_32 /= 0 then
									l_d.ce_gets (mbyte_inst.string_convert (create {CE_POINTER [PD_VIMCONV_T]}.make_shared (a_virp.c_pointer + {PD_VIR_T}.vir_conv_offset), l_retval, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
									if (l_d.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_retval))
										l_retval.ce_gets (l_d)
									end
								end
							end
						end
						Result := l_retval
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	viminfo_writestring (a_fd: CE_POINTER [SD_IO_FILE]; a_p___0: CE_POINTER [NATURAL_8])
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_s.make
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (a_p___0)
					l_len := 0
					l_s.ce_gets (l_p___0)
					from
					until
						(l_s.item).to_integer_32 = 0
					loop
						if (l_s.item).to_integer_32 = 22 then
							l_len := l_len + 1
						elseif (l_s.item).to_integer_32 = 10 then
							l_len := l_len + 1
						end
						l_len := l_len + 1
						l_s.ce_gets (l_s + 1)
					end
					if l_len > 256 then
						fprintf ([a_fd, ce_string ("%/22/%%d%N<"), l_len + 3]).do_nothing
					end
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_tmp.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_c := (l_tmp.item).to_integer_32
						if l_c = 0 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						if l_c /= 22 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if l_c /= 10 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						IO_putc (22, a_fd).do_nothing
						if l_c = 10 then
							l_c := ('n').code
						end
				when 8 then -- if done
						IO_putc (l_c, a_fd).do_nothing
				when 9 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					js.reset
					IO_putc (('%N').code, a_fd).do_nothing
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_fixdel (a_eap: CE_POINTER [PD_EXARG])
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make
			create l_tmp.make

			l_p___0.ce_gets (term_inst.find_termcode (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kb"))))
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (l_p___0.item).to_integer_32 = 127 then
					l_tmp.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%B")))
				else
					l_tmp.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/127/")))
				end
			else
				l_tmp.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/127/")))
			end
			term_inst.add_termcode (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kD")), l_tmp, 0)
		end

	do_fixdel_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent do_fixdel)
		end

	print_line_no_prefix (a_lnum: INTEGER_32; a_use_number: INTEGER_32; a_list: INTEGER_32)
		local
			l_numbuf: CE_ARRAY [NATURAL_8]
			l_tmp: INTEGER_32
		do
			create l_numbuf.make (<<30>>)

			if (globals_inst.curwin.item.w_onebuf_opt.wo_nu).to_boolean then
				l_tmp := screen_inst.number_width (globals_inst.curwin)
				message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_numbuf), (Natural_8_bytes.to_natural_32 * (30).to_natural_32), ce_string ("%%*ld "), l_tmp, a_lnum]).do_nothing
				message_inst.msg_puts_attr (l_numbuf, globals_inst.highlight_attr[9])
			elseif a_use_number.to_boolean then
				l_tmp := screen_inst.number_width (globals_inst.curwin)
				message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_numbuf), (Natural_8_bytes.to_natural_32 * (30).to_natural_32), ce_string ("%%*ld "), l_tmp, a_lnum]).do_nothing
				message_inst.msg_puts_attr (l_numbuf, globals_inst.highlight_attr[9])
			end
			message_inst.msg_prt_line ((memline_inst.ml_get (a_lnum)), a_list)
		end

	print_line (a_lnum: INTEGER_32; a_use_number: INTEGER_32; a_list: INTEGER_32)
		local
			l_save_silent: INTEGER_32
		do
			l_save_silent := globals_inst.silent_mode
			message_inst.msg_start
			globals_inst.silent_mode := 0
			globals_inst.info_message := 1
			print_line_no_prefix (a_lnum, a_use_number, a_list)
			if l_save_silent.to_boolean then
				message_inst.msg_putchar (('%N').code)
				term_inst.cursor_on
				term_inst.out_flush
				globals_inst.silent_mode := l_save_silent
			end
			globals_inst.info_message := 0
		end

	ex_file (a_eap: CE_POINTER [PD_EXARG])
		local
			l_fname: CE_POINTER [NATURAL_8]
			l_sfname: CE_POINTER [NATURAL_8]
			l_xfname: CE_POINTER [NATURAL_8]
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fname.make
			create l_sfname.make
			create l_xfname.make
			create l_buf___6.make
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_eap.item.addr_count > 0 then
						if ((a_eap.item.arg).item).to_integer_32 /= 0 then
							l_tmp.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg)))
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
							js.return
						elseif a_eap.item.line2 > 0 then
							l_tmp.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg)))
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
							js.return
						elseif a_eap.item.addr_count > 1 then
							l_tmp.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg)))
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if ((a_eap.item.arg).item).to_integer_32 = 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if a_eap.item.addr_count /= 1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						l_buf___6.ce_gets (globals_inst.curbuf)
						fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFFILEPRE, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
						if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 then
							js.return
						end
						if not js.return_called then
							if (ex_eval_inst.aborting).to_boolean then
								js.return
							end
						end
						if not js.return_called then
							l_fname.ce_gets (globals_inst.curbuf.item.b_ffname)
							l_sfname.ce_gets (globals_inst.curbuf.item.b_sfname)
							l_xfname.ce_gets (globals_inst.curbuf.item.b_fname)
							globals_inst.curbuf.item.b_ffname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							globals_inst.curbuf.item.b_sfname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							if (buffer_inst.setfname (globals_inst.curbuf, a_eap.item.arg, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 1)) = 0 then
								globals_inst.curbuf.item.b_ffname := l_fname
								globals_inst.curbuf.item.b_sfname := l_sfname
								js.return
							end
						end
						if not js.return_called then
							globals_inst.curbuf.item.b_flags := (globals_inst.curbuf.item.b_flags).bit_or ((8))
							if (l_xfname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if (l_xfname.item).to_integer_32 /= 0 then
									l_buf___6.ce_gets (buffer_inst.buflist_new (l_fname, l_xfname, globals_inst.curwin.item.w_cursor.lnum, 0))
									if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										if not (globals_inst.cmdmod.keepalt).to_boolean then
											globals_inst.curwin.item.w_alt_fnum := l_buf___6.item.b_fnum
										end
									end
								end
							end
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fname))
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_sfname))
							fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFFILEPOST, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
							if option_inst.p_acd.to_boolean then
								buffer_inst.do_autochdir
							end
						end
				when 6 then -- if done | if done
						if not js.return_called then
							buffer_inst.fileinfo (0, 0, a_eap.item.forceit)
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_file_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_file)
		end

	ex_update (a_eap: CE_POINTER [PD_EXARG])
		do
			if (undo_inst.curbufIsChanged).to_boolean then
				do_write (a_eap).do_nothing
			end
		end

	ex_update_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_update)
		end

	ex_write (a_eap: CE_POINTER [PD_EXARG])
		do
			if (a_eap.item.usefilter).to_boolean then
				do_bang (1, a_eap, 0, 1, 0)
			else
				do_write (a_eap).do_nothing
			end
		end

	ex_write_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_write)
		end

	do_write (a_eap: CE_POINTER [PD_EXARG]): INTEGER_32
		local
			l_other: INTEGER_32
			l_fname: CE_POINTER [NATURAL_8]
			l_ffname: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
			l_free_fname: CE_POINTER [NATURAL_8]
			l_browse_file: CE_POINTER [NATURAL_8]
			l_alt_buf: CE_POINTER [PD_FILE_BUFFER]
			l_was_curbuf: CE_POINTER [PD_FILE_BUFFER]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fname.make
			create l_ffname.make
			create l_free_fname.make
			create l_browse_file.make
			create l_alt_buf.make
			create l_was_curbuf.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_retval := 0
					l_free_fname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_browse_file.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_alt_buf.ce_gets (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
					if (not_writing).to_boolean then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 35 -- skip if block
					end
				when 1 then -- if:
						l_ffname.ce_gets (a_eap.item.arg)
						if not ((globals_inst.cmdmod.browse).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_browse_file.ce_gets (message_inst.do_browse (1, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Save As")))), l_ffname, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), globals_inst.curbuf))
						if (l_browse_file.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 34 -- goto theend
						end
				when 3 then
						l_ffname.ce_gets (l_browse_file)
				when 4 then -- if done
						if (l_ffname.item).to_integer_32 /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 5 then -- if:
						if a_eap.item.cmdidx = 354 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_argreq))))).do_nothing
							l_pos := -1 + 34 -- goto theend
						end
				when 6 then
						l_other := 0
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_fname.ce_gets (l_ffname)
						l_free_fname.ce_gets (buffer_inst.fix_fname (l_ffname))
						if (l_free_fname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_ffname.ce_gets (l_free_fname)
						end
						l_other := buffer_inst.otherfile (l_ffname)
				when 9 then -- if done
						if l_other.to_boolean then
							if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('A').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_alt_buf.ce_gets (buffer_inst.setaltfname (l_ffname, l_fname, (1).to_integer_32))
							elseif a_eap.item.cmdidx = 354 then
								l_alt_buf.ce_gets (buffer_inst.setaltfname (l_ffname, l_fname, (1).to_integer_32))
							else
								l_alt_buf.ce_gets (buffer_inst.buflist_findname (l_ffname))
							end
							if (l_alt_buf.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if ((l_alt_buf.item.b_ml.ml_mfp).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_bufloaded))))).do_nothing
									l_pos := -1 + 34 -- goto theend
								end
							end
						end
				when 10 then
						if not l_other.to_boolean then
							if (quickfix_inst.bt_dontwrite_msg (globals_inst.curbuf)).to_boolean then
								l_pos := -1 + 34 -- goto theend
							elseif (ex_cmds2_inst.check_fname) = 0 then
								l_pos := -1 + 34 -- goto theend
							elseif (check_readonly (create {CE_POINTER [INTEGER_32]}.make_shared (a_eap.c_pointer + {PD_EXARG}.forceit_offset), globals_inst.curbuf)).to_boolean then
								l_pos := -1 + 34 -- goto theend
							end
						end
				when 11 then
						if l_other.to_boolean then
							l_pos := -1 + 27 -- skip if block
						end
				when 12 then -- if:
						l_ffname.ce_gets (globals_inst.curbuf.item.b_ffname)
						l_fname.ce_gets (globals_inst.curbuf.item.b_fname)
						if a_eap.item.line1 = 1 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L___0
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 15 then -- else:
						if a_eap.item.line2 = globals_inst.curbuf.item.b_ml.ml_line_count then
							l_pos := -1 + 27 -- skip if block
						end
				when 16 then -- if: | _L___0:
						if (a_eap.item.forceit).to_boolean then
							l_pos := -1 + 27 -- skip if block
						end
				when 17 then -- if:
						if (a_eap.item.append).to_boolean then
							l_pos := -1 + 27 -- skip if block
						end
				when 18 then -- if:
						if option_inst.p_wa.to_boolean then
							l_pos := -1 + 27 -- skip if block
						end
				when 19 then -- if:
						if not (option_inst.p_confirm.to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 23 -- goto _L
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 22 then -- else:
						if not ((globals_inst.cmdmod.confirm).to_boolean) then
							l_pos := -1 + 26 -- skip if block
						end
				when 23 then -- if: | _L:
						if (message_inst.vim_dialog_yesno (4, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Write partial file?")))), 2)) /= 2 then
							l_pos := -1 + 34 -- goto theend
						end
				when 24 then
						a_eap.item.forceit := 1
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E140: Use ! to write partial buffer"))))).do_nothing
						l_pos := -1 + 34 -- goto theend
				when 27 then -- if done | if done | if done | if done | if done | if done | if done
						if (check_overwrite (a_eap, globals_inst.curbuf, l_fname, l_ffname, l_other)) /= 1 then
							l_pos := -1 + 34 -- skip if block
						end
				when 28 then -- if:
						if a_eap.item.cmdidx /= 354 then
							l_pos := -1 + 33 -- skip if block
						end
				when 29 then -- if:
						if (l_alt_buf.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 33 -- skip if block
						end
				when 30 then -- if:
						l_was_curbuf.ce_gets (globals_inst.curbuf)
						fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFFILEPRE, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
						fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFFILEPRE, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, l_alt_buf).do_nothing
						if (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 /= (l_was_curbuf.c_pointer.to_integer_32).to_natural_32 then
							l_retval := 0
							l_pos := -1 + 34 -- goto theend
						elseif (ex_eval_inst.aborting).to_boolean then
							l_retval := 0
							l_pos := -1 + 34 -- goto theend
						end
				when 31 then
						l_fname.ce_gets (l_alt_buf.item.b_fname)
						l_alt_buf.item.b_fname := globals_inst.curbuf.item.b_fname
						globals_inst.curbuf.item.b_fname := l_fname
						l_fname.ce_gets (l_alt_buf.item.b_ffname)
						l_alt_buf.item.b_ffname := globals_inst.curbuf.item.b_ffname
						globals_inst.curbuf.item.b_ffname := l_fname
						l_fname.ce_gets (l_alt_buf.item.b_sfname)
						l_alt_buf.item.b_sfname := globals_inst.curbuf.item.b_sfname
						globals_inst.curbuf.item.b_sfname := l_fname
						buffer_inst.buf_name_changed (globals_inst.curbuf)
						fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFFILEPOST, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
						fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFFILEPOST, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, l_alt_buf).do_nothing
						if not (l_alt_buf.item.b_p_bl).to_boolean then
							l_alt_buf.item.b_p_bl := 1
							fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFADD, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, l_alt_buf).do_nothing
						end
						if (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 /= (l_was_curbuf.c_pointer.to_integer_32).to_natural_32 then
							l_retval := 0
							l_pos := -1 + 34 -- goto theend
						elseif (ex_eval_inst.aborting).to_boolean then
							l_retval := 0
							l_pos := -1 + 34 -- goto theend
						end
				when 32 then
						if ((globals_inst.curbuf.item.b_p_ft).item).to_integer_32 = 0 then
							if (fileio_inst.au_has_group (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("filetypedetect")))).to_boolean then
								fileio_inst.do_doautocmd (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("filetypedetect BufRead")), 1).do_nothing
							end
							buffer_inst.do_modelines (0)
						end
				when 33 then -- if done | if done
						l_retval := fileio_inst.buf_write (globals_inst.curbuf, l_ffname, l_fname, a_eap.item.line1, a_eap.item.line2, a_eap, a_eap.item.append, a_eap.item.forceit, 1, 0)
						if a_eap.item.cmdidx = 354 then
							if l_retval = 1 then
								globals_inst.curbuf.item.b_p_ro := 0
								globals_inst.redraw_tabline := 1
							end
							if option_inst.p_acd.to_boolean then
								buffer_inst.do_autochdir
							end
						end
				when 34 then -- theend:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_browse_file))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_free_fname))
						Result := l_retval
				when 35 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_overwrite (a_eap: CE_POINTER [PD_EXARG]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_fname: CE_POINTER [NATURAL_8]; a_ffname: CE_POINTER [NATURAL_8]; a_other: INTEGER_32): INTEGER_32
		local
			l_buff: CE_ARRAY [NATURAL_8]
			l_dir___0: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_r: INTEGER_32
			l_swapname: CE_POINTER [NATURAL_8]
			l_buff___0: CE_ARRAY [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buff.make (<<1025>>)
			create l_dir___0.make (<<4096>>)
			create l_p___0.make
			create l_swapname.make
			create l_buff___0.make (<<1025>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_other.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 10 -- goto _L___1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 3 then -- else:
						if not (((a_buf___6.item.b_flags).bit_and (8)).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L___1
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 6 then -- else:
						if not (((a_buf___6.item.b_flags).bit_and (16)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('O').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 10 -- goto _L___1
						else
							l_pos := -1 + 9 -- goto _L___2
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 9 then -- else: | _L___2:
						if not (((a_buf___6.item.b_flags).bit_and (64)).to_boolean) then
							l_pos := -1 + 34 -- skip if block
						end
				when 10 then -- if: | _L___1:
						if option_inst.p_wa.to_boolean then
							l_pos := -1 + 34 -- skip if block
						end
				when 11 then -- if:
						if (quickfix_inst.bt_nofile (a_buf___6)).to_boolean then
							l_pos := -1 + 34 -- skip if block
						end
				when 12 then -- if:
						if not ((misc1_inst.vim_fexists (a_ffname)).to_boolean) then
							l_pos := -1 + 34 -- skip if block
						end
				when 13 then -- if:
						if (a_eap.item.forceit).to_boolean then
							l_pos := -1 + 23 -- skip if block
						end
				when 14 then -- if:
						if (a_eap.item.append).to_boolean then
							l_pos := -1 + 23 -- skip if block
						end
				when 15 then -- if:
						if (os_unix_inst.mch_isdir (a_ffname)).to_boolean then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_isadir2)))), a_ffname).do_nothing
							Result := 0
							js.return
						end
						if js.return_called then
							l_pos := -1 + 23 -- skip if block
						end
				when 16 then -- if:
						if not (option_inst.p_confirm.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 19 then -- else:
						if not ((globals_inst.cmdmod.confirm).to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if: | _L:
						ex_docmd_inst.dialog_msg (l_buff, (gettext (ce_string ("Overwrite existing file %"%%s%"?"))), a_fname)
						if (message_inst.vim_dialog_yesno (4, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_buff, 2)) /= 2 then
							Result := 0
							js.return
						end
						if not js.return_called then
							a_eap.item.forceit := 1
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_exists))))).do_nothing
						Result := 0
						js.return
				when 23 then -- if done | if done | if done | if done
						if not (not js.return_called and then (a_other.to_boolean)) then
							l_pos := -1 + 34 -- skip if block
						end
				when 24 then -- if:
						if globals_inst.emsg_silent.to_boolean then
							l_pos := -1 + 34 -- skip if block
						end
				when 25 then -- if:
						if (option_inst.p_dir.item).to_integer_32 = 0 then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_dir___0), ce_string (".")).do_nothing
						else
							l_p___0.ce_gets (option_inst.p_dir)
							misc2_inst.copy_option_part (l_p___0.address, l_dir___0, 4096, ce_string (",")).do_nothing
						end
						l_swapname.ce_gets (memline_inst.makeswapname (a_fname, a_ffname, globals_inst.curbuf, l_dir___0))
						l_r := misc1_inst.vim_fexists (l_swapname)
						if not (l_r.to_boolean) then
							l_pos := -1 + 33 -- skip if block
						end
				when 26 then -- if:
						if not (option_inst.p_confirm.to_boolean) then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						l_pos := -1 + 30 -- goto _L___0
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 29 then -- else:
						if not ((globals_inst.cmdmod.confirm).to_boolean) then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if: | _L___0:
						ex_docmd_inst.dialog_msg (l_buff___0, (gettext (ce_string ("Swap file %"%%s%" exists, overwrite anyway?"))), l_swapname)
						if (message_inst.vim_dialog_yesno (4, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_buff___0, 2)) /= 2 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_swapname))
							Result := 0
							js.return
						end
						if not js.return_called then
							a_eap.item.forceit := 1
						end
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else:
						message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E768: Swap file exists: %%s (:silent! overrides)")))), l_swapname).do_nothing
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_swapname))
						Result := 0
						js.return
				when 33 then -- if done | if done
						if not js.return_called then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_swapname))
						end
				when 34 then -- if done | if done | if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 1
						end
				when 35 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_wnext (a_eap: CE_POINTER [PD_EXARG])
		local
			l_i___0: INTEGER_32
		do
			if (a_eap.item.cmd[1]).to_integer_32 = 110 then
				l_i___0 := globals_inst.curwin.item.w_arg_idx + (a_eap.item.line2).to_integer_32
			else
				l_i___0 := globals_inst.curwin.item.w_arg_idx - (a_eap.item.line2).to_integer_32
			end
			a_eap.item.line1 := (1).to_integer_32
			a_eap.item.line2 := globals_inst.curbuf.item.b_ml.ml_line_count
			if (do_write (a_eap)) /= 0 then
				ex_cmds2_inst.do_argfile (a_eap, l_i___0)
			end
		end

	ex_wnext_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_wnext)
		end

	do_wqall (a_eap: CE_POINTER [PD_EXARG])
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_error: INTEGER_32
			l_save_forceit: INTEGER_32
			js: JUMP_STATE
		do
			create l_buf___6.make

			l_error := 0
			l_save_forceit := a_eap.item.forceit
			if a_eap.item.cmdidx = 495 then
				globals_inst.exiting := 1
			elseif a_eap.item.cmdidx = 490 then
				globals_inst.exiting := 1
			end
			l_buf___6.ce_gets (globals_inst.firstbuf)
			from
			until
				not (not js.loop_left and then ((l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				js.reset
				if (undo_inst.bufIsChanged (l_buf___6)).to_boolean then
					if (not_writing).to_boolean then
						l_error := l_error + 1
						js.break
					end
					if not js.loop_jumped then
						if ((l_buf___6.item.b_ffname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if (globals_inst.cmdmod.browse).to_boolean then
								ex_cmds2_inst.browse_save_fname (l_buf___6)
							end
						end
						if ((l_buf___6.item.b_ffname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							misc2_inst.emsgn (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E141: No file name for buffer %%ld")))), (l_buf___6.item.b_fnum).to_integer_32).do_nothing
							l_error := l_error + 1
						elseif (check_readonly (create {CE_POINTER [INTEGER_32]}.make_shared (a_eap.c_pointer + {PD_EXARG}.forceit_offset), l_buf___6)).to_boolean then
							l_error := l_error + 1
						elseif (check_overwrite (a_eap, l_buf___6, l_buf___6.item.b_fname, l_buf___6.item.b_ffname, 0)) = 0 then
							l_error := l_error + 1
						else
							if (ex_cmds2_inst.buf_write_all (l_buf___6, a_eap.item.forceit)) = 0 then
								l_error := l_error + 1
							end
							if not (buffer_inst.buf_valid (l_buf___6)).to_boolean then
								l_buf___6.ce_gets (globals_inst.firstbuf)
							end
						end
						a_eap.item.forceit := l_save_forceit
					end
				end
				if not js.loop_jumped then
					l_buf___6.ce_gets (l_buf___6.item.b_next)
				end
			end
			js.reset
			if globals_inst.exiting.to_boolean then
				if not l_error.to_boolean then
					main_inst.getout (0)
				end
				ex_docmd_inst.not_exiting
			end
		end

	do_wqall_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent do_wqall)
		end

	not_writing: INTEGER_32
		local
			js: JUMP_STATE
		do
			if option_inst.p_write.to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E142: File not written: Writing is disabled by %'write%' option"))))).do_nothing
				Result := 1
			end
		end

	check_readonly (a_forceit: CE_POINTER [INTEGER_32]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			l_st: SD_STAT
			l_buff: CE_ARRAY [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_st.make
			create l_buff.make (<<1025>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_forceit.item).to_boolean then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						if not ((a_buf___6.item.b_p_ro).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 6 -- goto _L___1
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 4 then -- else:
						if not ((stat (create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6.item.b_ffname), (l_st.address))) >= 0) then
							l_pos := -1 + 14 -- skip if block
						end
				when 5 then -- if:
						if not ((fileio_inst.check_file_readonly (a_buf___6.item.b_ffname, 511)).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 6 then -- if: | _L___1:
						if not (option_inst.p_confirm.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if not ((globals_inst.cmdmod.confirm).to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L___0:
						if ((a_buf___6.item.b_fname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (a_buf___6.item.b_p_ro).to_boolean then
								ex_docmd_inst.dialog_msg (l_buff, (gettext (ce_string ("%'readonly%' option is set for %"%%s%".%NDo you wish to write anyway?"))), a_buf___6.item.b_fname)
							else
								ex_docmd_inst.dialog_msg (l_buff, (gettext (ce_string ("File permissions of %"%%s%" are read-only.%NIt may still be possible to write it.%NDo you wish to try?"))), a_buf___6.item.b_fname)
							end
							if (message_inst.vim_dialog_yesno (4, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_buff, 2)) = 2 then
								a_forceit.item := 1
								Result := 0
								js.return
							else
								Result := 1
								js.return
							end
						else
							l_pos := -1 + 12 -- goto _L
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						if (a_buf___6.item.b_p_ro).to_boolean then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_readonly))))).do_nothing
						else
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E505: %"%%s%" is read-only (add ! to override)")))), a_buf___6.item.b_fname).do_nothing
						end
				when 13 then -- if done
						if not js.return_called then
							Result := 1
							js.return
						end
				when 14 then -- if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 15 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	getfile (a_fnum___0: INTEGER_32; a_ffname: CE_POINTER [NATURAL_8]; a_sfname: CE_POINTER [NATURAL_8]; a_setpm: INTEGER_32; a_lnum: INTEGER_32; a_forceit: INTEGER_32): INTEGER_32
		local
			l_ffname: CE_POINTER [NATURAL_8]
			l_sfname: CE_POINTER [NATURAL_8]
			l_other: INTEGER_32
			l_retval: INTEGER_32
			l_free_me: CE_POINTER [NATURAL_8]
			l_tmp___7: INTEGER_32
			l_tmp___9: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ffname.make
			create l_sfname.make
			create l_free_me.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ffname.ce_gets (a_ffname)
					l_sfname.ce_gets (a_sfname)
					l_free_me.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					if (ex_getln_inst.text_locked).to_boolean then
						Result := 1
						js.return
					end
					if not js.return_called then
						if (ex_getln_inst.curbuf_locked).to_boolean then
							Result := 1
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						if a_fnum___0 = 0 then
							buffer_inst.fname_expand (globals_inst.curbuf, l_ffname.address, l_sfname.address)
							l_other := buffer_inst.otherfile (l_ffname)
							l_free_me.ce_gets (l_ffname)
						else
							l_other := (a_fnum___0 /= globals_inst.curbuf.item.b_fnum).to_integer
						end
						if l_other.to_boolean then
							globals_inst.no_wait_return := globals_inst.no_wait_return + 1
						end
						if l_other.to_boolean then
							if not a_forceit.to_boolean then
								if globals_inst.curbuf.item.b_nwindows = 1 then
									if not (quickfix_inst.buf_hide (globals_inst.curbuf)).to_boolean then
										if (undo_inst.curbufIsChanged).to_boolean then
											if (ex_cmds2_inst.autowrite (globals_inst.curbuf, a_forceit)) = 0 then
												if option_inst.p_confirm.to_boolean then
													if option_inst.p_write.to_boolean then
														ex_cmds2_inst.dialog_changed (globals_inst.curbuf, 0)
													end
												end
												if (undo_inst.curbufIsChanged).to_boolean then
													if l_other.to_boolean then
														globals_inst.no_wait_return := globals_inst.no_wait_return - 1
													end
													message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_nowrtmsg))))).do_nothing
													l_retval := 2
													l_pos := -1 + 3 -- goto theend
												end
											end
										end
									end
								end
							end
						end
				when 2 then
						if l_other.to_boolean then
							globals_inst.no_wait_return := globals_inst.no_wait_return - 1
						end
						if a_setpm.to_boolean then
							mark_inst.setpcmark
						end
						if not l_other.to_boolean then
							if a_lnum /= 0 then
								globals_inst.curwin.item.w_cursor.lnum := a_lnum
							end
							misc2_inst.check_cursor_lnum
							edit_inst.beginline (6)
							l_retval := 0
						else
							if (quickfix_inst.buf_hide (globals_inst.curbuf)).to_boolean then
								l_tmp___7 := 1
							else
								l_tmp___7 := 0
							end
							if a_forceit.to_boolean then
								l_tmp___9 := 8
							else
								l_tmp___9 := 0
							end
							if (do_ecmd (a_fnum___0, l_ffname, l_sfname, create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer), a_lnum, l_tmp___7 + l_tmp___9, globals_inst.curwin)) = 1 then
								l_retval := -1
							else
								l_retval := 1
							end
						end
				when 3 then -- theend:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_free_me))
						Result := l_retval
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_ecmd (a_fnum___0: INTEGER_32; a_ffname: CE_POINTER [NATURAL_8]; a_sfname: CE_POINTER [NATURAL_8]; a_eap: CE_POINTER [PD_EXARG]; a_newlnum: INTEGER_32; a_flags___0: INTEGER_32; a_oldwin: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			l_ffname: CE_POINTER [NATURAL_8]
			l_sfname: CE_POINTER [NATURAL_8]
			l_newlnum: INTEGER_32
			l_other_file: INTEGER_32
			l_oldbuf: INTEGER_32
			l_auto_buf: INTEGER_32
			l_new_name: CE_POINTER [NATURAL_8]
			l_did_set_swapcommand: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_old_curbuf: CE_POINTER [PD_FILE_BUFFER]
			l_free_fname: CE_POINTER [NATURAL_8]
			l_browse_file: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
			l_n: INTEGER_32
			l_lnum: INTEGER_32
			l_topline: INTEGER_32
			l_newcol: INTEGER_32
			l_solcol: INTEGER_32
			l_pos___3: CE_POINTER [PD_POS_T]
			l_command: CE_POINTER [NATURAL_8]
			l_did_get_winopts: INTEGER_32
			l_readfile_flags: INTEGER_32
			l_tmp___2: INTEGER_32
			l_len: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tlnum: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___11: INTEGER_32
			l_p___1: CE_POINTER [NATURAL_8]
			l_win: CE_POINTER [PD_WINDOW_S]
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_msg_scroll_save: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ffname.make
			create l_sfname.make
			create l_new_name.make
			create l_buf___6.make
			create l_old_curbuf.make
			create l_free_fname.make
			create l_browse_file.make
			create l_pos___3.make
			create l_command.make
			create l_p___0.make
			create l_p___1.make
			create l_win.make
			create l_tp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ffname.ce_gets (a_ffname)
					l_sfname.ce_gets (a_sfname)
					l_newlnum := a_newlnum
					l_auto_buf := 0
					l_new_name.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_did_set_swapcommand := 0
					l_old_curbuf.ce_gets (globals_inst.curbuf)
					l_free_fname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_browse_file.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_retval := 0
					l_topline := (0).to_integer_32
					l_newcol := -1
					l_solcol := -1
					l_command.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_did_get_winopts := 0
					l_readfile_flags := 0
					if (a_eap.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_command.ce_gets (a_eap.item.do_ecmd_cmd)
					end
					if a_fnum___0 = 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_fnum___0 = globals_inst.curbuf.item.b_fnum then
							Result := 1
							js.return
						end
						if not js.return_called then
							l_other_file := 1
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 3 then -- else:
						if not ((globals_inst.cmdmod.browse).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if (gui_inst.gui.in_use).to_boolean then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (fileio_inst.au_has_group (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("FileExplorer")))).to_boolean then
							if (l_ffname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_ffname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".")))
							elseif not (os_unix_inst.mch_isdir (l_ffname)).to_boolean then
								l_ffname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".")))
							end
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else: | _L:
						l_browse_file.ce_gets (message_inst.do_browse (0, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Edit File")))), l_ffname, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), globals_inst.curbuf))
						if (l_browse_file.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 85 -- goto theend
						end
				when 8 then
						l_ffname.ce_gets (l_browse_file)
				when 9 then -- if done
						if (l_sfname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_sfname.ce_gets (l_ffname)
						end
						if ((a_flags___0).bit_and (16)).to_boolean then
							if (l_ffname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_pos := -1 + 85 -- goto theend
							elseif (l_ffname.item).to_integer_32 = 0 then
								l_pos := -1 + 85 -- goto theend
							end
						end
				when 10 then
						if (l_ffname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_other_file := 1
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 13 then -- else:
						if (l_ffname.item).to_integer_32 /= 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if ((globals_inst.curbuf.item.b_ffname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_other_file := 0
						else
							l_pos := -1 + 16 -- goto _L___0
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else: | _L___0:
						if (l_ffname.item).to_integer_32 = 0 then
							l_ffname.ce_gets (globals_inst.curbuf.item.b_ffname)
							l_sfname.ce_gets (globals_inst.curbuf.item.b_fname)
						end
						l_free_fname.ce_gets (buffer_inst.fix_fname (l_ffname))
						if (l_free_fname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_ffname.ce_gets (l_free_fname)
						end
						l_other_file := buffer_inst.otherfile (l_ffname)
				when 17 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 86 -- skip if block
						end
				when 18 then -- if:
							if l_other_file.to_boolean then
								l_pos := -1 + 21 -- skip if block
							end
				when 19 then -- if:
							if not ((a_flags___0).bit_and (4)).to_boolean then
								l_pos := -1 + 23 -- goto _L___1
							else
								l_pos := -1 + 21 -- goto _L___2
							end
				when 20 then -- if block done, skip else block:
							l_pos := -1 + 24
				when 21 then -- else: | _L___2:
							if globals_inst.curbuf.item.b_nwindows /= 1 then
								l_pos := -1 + 24 -- skip if block
							end
				when 22 then -- if:
							if ((a_flags___0).bit_and (17)).to_boolean then
								l_pos := -1 + 24 -- skip if block
							end
				when 23 then -- if: | _L___1:
							if (ex_cmds2_inst.check_changed (globals_inst.curbuf, option_inst.p_awa, (not l_other_file.to_boolean).to_integer, (a_flags___0).bit_and (8), 0)).to_boolean then
								if a_fnum___0 = 0 then
									if l_other_file.to_boolean then
										if (l_ffname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
											if l_newlnum < 0 then
												l_tmp___2 := (0).to_integer_32
											else
												l_tmp___2 := l_newlnum
											end
											buffer_inst.setaltfname (l_ffname, l_sfname, l_tmp___2).do_nothing
										end
									end
								end
								l_pos := -1 + 85 -- goto theend
							end
				when 24 then -- if done | if done
							normal_inst.reset_VIsual
							if (l_command.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_pos := -1 + 27 -- skip if block
							end
				when 25 then -- if:
							l_pos := -1 + 28 -- goto _L___3
				when 26 then -- if block done, skip else block:
							l_pos := -1 + 29
				when 27 then -- else:
							if not (l_newlnum > 0) then
								l_pos := -1 + 29 -- skip if block
							end
				when 28 then -- if: | _L___3:
							if ((eval_inst.get_vim_var_str (47)).item).to_integer_32 = 0 then
								if (l_command.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_command))).to_integer_32 + 3
								else
									l_len := 30
								end
								l_p___0.ce_gets (misc2_inst.alloc (l_len.to_natural_32))
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if (l_command.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), l_len.to_natural_32, ce_string (":%%s%R"), l_command]).do_nothing
									else
										message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), l_len.to_natural_32, ce_string ("%%ldG"), l_newlnum]).do_nothing
									end
									eval_inst.set_vim_var_string (47, l_p___0, -1)
									l_did_set_swapcommand := 1
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
								end
							end
				when 29 then -- if done
							if not (l_other_file.to_boolean) then
								l_pos := -1 + 59 -- skip if block
							end
				when 30 then -- if:
							if not ((a_flags___0).bit_and (16)).to_boolean then
								if not (globals_inst.cmdmod.keepalt).to_boolean then
									globals_inst.curwin.item.w_alt_fnum := globals_inst.curbuf.item.b_fnum
								end
								if (a_oldwin.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									buffer_inst.buflist_altfpos (a_oldwin)
								end
							end
							if not (a_fnum___0.to_boolean) then
								l_pos := -1 + 33 -- skip if block
							end
				when 31 then -- if:
							l_buf___6.ce_gets (buffer_inst.buflist_findnr (a_fnum___0))
				when 32 then -- if block done, skip else block:
							l_pos := -1 + 35
				when 33 then -- else:
							if ((a_flags___0).bit_and (16)).to_boolean then
								l_tlnum := 1
								if (l_command.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_tlnum := atol (create {CE_POINTER [INTEGER_8]}.make_cast (l_command))
									if l_tlnum <= 0 then
										l_tlnum := 1
									end
								end
								buffer_inst.buflist_new (l_ffname, l_sfname, l_tlnum, 2).do_nothing
								l_pos := -1 + 85 -- goto theend
							end
				when 34 then
							if ((a_flags___0).bit_and (2)).to_boolean then
								l_tmp___6 := 0
							else
								l_tmp___6 := 2
							end
							l_buf___6.ce_gets (buffer_inst.buflist_new (l_ffname, l_sfname, 0, (1).bit_or (l_tmp___6)))
				when 35 then -- if done
							if (l_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_pos := -1 + 85 -- goto theend
							end
				when 36 then
							if ((l_buf___6.item.b_ml.ml_mfp).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_pos := -1 + 39 -- skip if block
							end
				when 37 then -- if:
							l_oldbuf := 0
							l_buf___6.item.b_nwindows := 0
				when 38 then -- if block done, skip else block:
							l_pos := -1 + 41
				when 39 then -- else:
							l_oldbuf := 1
							fileio_inst.buf_check_timestamp (l_buf___6, 0).do_nothing
							if (buffer_inst.buf_valid (l_buf___6)).to_boolean then
								if (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 /= (l_old_curbuf.c_pointer.to_integer_32).to_natural_32 then
									l_pos := -1 + 85 -- goto theend
								end
							else
								l_pos := -1 + 85 -- goto theend
							end
				when 40 then
							if (ex_eval_inst.aborting).to_boolean then
								l_pos := -1 + 85 -- goto theend
							end
				when 41 then
							if not (l_oldbuf.to_boolean) then
								l_pos := -1 + 44 -- skip if block
							end
				when 42 then -- if:
							if l_newlnum = 0 then
								l_pos___3.ce_gets (buffer_inst.buflist_findfpos (l_buf___6))
								l_newlnum := l_pos___3.item.lnum
								l_solcol := l_pos___3.item.col
							else
								l_pos := -1 + 44 -- goto _L___4
							end
				when 43 then -- if block done, skip else block:
							l_pos := -1 + 45
				when 44 then -- else: | _L___4:
							if l_newlnum = -1 then
								l_pos___3.ce_gets (buffer_inst.buflist_findfpos (l_buf___6))
								l_newlnum := l_pos___3.item.lnum
								l_solcol := l_pos___3.item.col
							end
				when 45 then
							if (l_buf___6.c_pointer.to_integer_32).to_natural_32 = (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 then
								l_pos := -1 + 56 -- skip if block
							end
				when 46 then -- if:
							if ((l_buf___6.item.b_fname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_new_name.ce_gets (misc2_inst.vim_strsave (l_buf___6.item.b_fname))
							end
							globals_inst.au_new_curbuf.ce_gets (l_buf___6)
							fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFLEAVE, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
							if not (buffer_inst.buf_valid (l_buf___6)).to_boolean then
								delbuf_msg (l_new_name)
								l_pos := -1 + 85 -- goto theend
							end
				when 47 then
							if (ex_eval_inst.aborting).to_boolean then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_new_name))
								l_pos := -1 + 85 -- goto theend
							end
				when 48 then
							if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 then
								l_pos := -1 + 51 -- skip if block
							end
				when 49 then -- if:
							l_auto_buf := 1
				when 50 then -- if block done, skip else block:
							l_pos := -1 + 54
				when 51 then -- else:
							if (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 = (l_old_curbuf.c_pointer.to_integer_32).to_natural_32 then
								option_inst.buf_copy_options (l_buf___6, 1)
							end
							undo_inst.u_sync (0)
							if ((a_flags___0).bit_and (1)).to_boolean then
								l_tmp___11 := 0
							else
								l_tmp___11 := 2
							end
							buffer_inst.close_buffer (a_oldwin, globals_inst.curbuf, l_tmp___11)
							if (ex_eval_inst.aborting).to_boolean then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_new_name))
								l_pos := -1 + 85 -- goto theend
							end
				when 52 then
							if not (buffer_inst.buf_valid (l_buf___6)).to_boolean then
								delbuf_msg (l_new_name)
								l_pos := -1 + 85 -- goto theend
							end
				when 53 then
							if (l_buf___6.c_pointer.to_integer_32).to_natural_32 = (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 then
								l_auto_buf := 1
							else
								if ((globals_inst.curwin.item.w_s).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_SYNBLOCK_T]}.make_shared ((globals_inst.curwin.item.w_buffer).c_pointer + {PD_FILE_BUFFER}.b_s_offset)).c_pointer.to_integer_32).to_natural_32 then
									globals_inst.curwin.item.w_s := create {CE_POINTER [PD_SYNBLOCK_T]}.make_shared (l_buf___6.c_pointer + {PD_FILE_BUFFER}.b_s_offset)
								end
								globals_inst.curwin.item.w_buffer := l_buf___6
								globals_inst.curbuf.ce_gets (l_buf___6)
								globals_inst.curbuf.item.b_nwindows := (globals_inst.curbuf.item.b_nwindows) + 1
								if (option_inst.p_ffs.item).to_boolean then
									if not l_oldbuf.to_boolean then
										misc2_inst.set_fileformat ((misc2_inst.default_fileformat), 4)
									end
								end
							end
							buffer_inst.get_winopts (globals_inst.curbuf)
							l_did_get_winopts := 1
				when 54 then -- if done
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_new_name))
							globals_inst.au_new_curbuf.ce_gets (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
				when 55 then -- if block done, skip else block:
							l_pos := -1 + 57
				when 56 then -- else:
							globals_inst.curbuf.item.b_nwindows := (globals_inst.curbuf.item.b_nwindows) + 1
				when 57 then -- if done
							globals_inst.curwin.item.w_pcmark.lnum := (1).to_integer_32
							globals_inst.curwin.item.w_pcmark.col := 0
				when 58 then -- if block done, skip else block:
							l_pos := -1 + 61
				when 59 then -- else:
							if ((a_flags___0).bit_and (16)).to_boolean then
								l_pos := -1 + 85 -- goto theend
							elseif (ex_cmds2_inst.check_fname) = 0 then
								l_pos := -1 + 85 -- goto theend
							end
				when 60 then
							l_oldbuf := (a_flags___0).bit_and (4)
				when 61 then -- if done
							if not (((a_flags___0).bit_and (2)).to_boolean) then
								l_pos := -1 + 64 -- skip if block
							end
				when 62 then -- if:
							l_pos := -1 + 65 -- goto _L___5
				when 63 then -- if block done, skip else block:
							l_pos := -1 + 68
				when 64 then -- else:
							if not (globals_inst.keep_help_flag.to_boolean) then
								l_pos := -1 + 67 -- skip if block
							end
				when 65 then -- if: | _L___5:
							globals_inst.curbuf.item.b_help := 1
							option_inst.set_string_option_direct (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("buftype")), -1, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("help")), 5, 0)
							l_p___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("!-~,^*,^|,^%",192-255")))
							if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.curbuf.item.b_p_isk), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___1))) /= 0 then
								option_inst.set_string_option_direct (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("isk")), -1, l_p___1, 5, 0)
								option_inst.check_buf_options (globals_inst.curbuf)
								charset_inst.buf_init_chartab (globals_inst.curbuf, 0).do_nothing
							end
							globals_inst.curbuf.item.b_p_ts := 8
							globals_inst.curwin.item.w_onebuf_opt.wo_list := 0
							globals_inst.curbuf.item.b_p_ma := 0
							globals_inst.curbuf.item.b_p_bin := 0
							globals_inst.curwin.item.w_onebuf_opt.wo_nu := 0
							globals_inst.curwin.item.w_onebuf_opt.wo_rnu := 0
							globals_inst.curwin.item.w_onebuf_opt.wo_scb := 0
							globals_inst.curwin.item.w_onebuf_opt.wo_fen := 0
							globals_inst.curwin.item.w_onebuf_opt.wo_diff := 0
							globals_inst.curwin.item.w_onebuf_opt.wo_spell := 0
							l_buf___6.ce_gets (globals_inst.curbuf)
							buffer_inst.set_buflisted (0)
				when 66 then -- if block done, skip else block:
							l_pos := -1 + 68
				when 67 then -- else:
							l_buf___6.ce_gets (globals_inst.curbuf)
							if not (globals_inst.curbuf.item.b_help).to_boolean then
								buffer_inst.set_buflisted (1)
							end
				when 68 then -- if done
							if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 then
								l_pos := -1 + 85 -- goto theend
							end
				when 69 then
							if (ex_eval_inst.aborting).to_boolean then
								l_pos := -1 + 85 -- goto theend
							end
				when 70 then
							globals_inst.did_filetype := 0
							if l_other_file.to_boolean then
								l_pos := -1 + 84 -- skip if block
							end
				when 71 then -- if:
							if l_oldbuf.to_boolean then
								l_pos := -1 + 84 -- skip if block
							end
				when 72 then -- if:
							mark_inst.set_last_cursor (globals_inst.curwin)
							if l_newlnum = -1 then
								l_newlnum := globals_inst.curwin.item.w_cursor.lnum
								l_solcol := globals_inst.curwin.item.w_cursor.col
							elseif l_newlnum = 0 then
								l_newlnum := globals_inst.curwin.item.w_cursor.lnum
								l_solcol := globals_inst.curwin.item.w_cursor.col
							end
							l_buf___6.ce_gets (globals_inst.curbuf)
							if ((l_buf___6.item.b_fname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_new_name.ce_gets (misc2_inst.vim_strsave (l_buf___6.item.b_fname))
							else
								l_new_name.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							end
							if not (option_inst.p_ur < 0) then
								l_pos := -1 + 75 -- skip if block
							end
				when 73 then -- if:
							l_pos := -1 + 76 -- goto _L___6
				when 74 then -- if block done, skip else block:
							l_pos := -1 + 80
				when 75 then -- else:
							if not (globals_inst.curbuf.item.b_ml.ml_line_count <= option_inst.p_ur) then
								l_pos := -1 + 79 -- skip if block
							end
				when 76 then -- if: | _L___6:
							undo_inst.u_sync (0)
							if (undo_inst.u_savecommon ((0).to_integer_32, globals_inst.curbuf.item.b_ml.ml_line_count + 1, (0).to_integer_32, 1)) = 0 then
								l_pos := -1 + 85 -- goto theend
							end
				when 77 then
							undo_inst.u_unchanged (globals_inst.curbuf)
							buffer_inst.buf_freeall (globals_inst.curbuf, 4)
							l_readfile_flags := 32
				when 78 then -- if block done, skip else block:
							l_pos := -1 + 80
				when 79 then -- else:
							buffer_inst.buf_freeall (globals_inst.curbuf, 0)
				when 80 then -- if done
							if not (buffer_inst.buf_valid (l_buf___6)).to_boolean then
								delbuf_msg (l_new_name)
								l_pos := -1 + 85 -- goto theend
							end
				when 81 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_new_name))
							if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 then
								l_pos := -1 + 85 -- goto theend
							end
				when 82 then
							if (ex_eval_inst.aborting).to_boolean then
								l_pos := -1 + 85 -- goto theend
							end
				when 83 then
							buffer_inst.buf_clear_file (globals_inst.curbuf)
							globals_inst.curbuf.item.b_op_start.lnum := (0).to_integer_32
							globals_inst.curbuf.item.b_op_end.lnum := (0).to_integer_32
				when 84 then -- if done | if done
							globals_inst.RedrawingDisabled := globals_inst.RedrawingDisabled + 1
							l_retval := 1
							misc2_inst.check_cursor
							ex_cmds2_inst.check_arg_idx (globals_inst.curwin)
							syntax_inst.reset_synblock (globals_inst.curwin)
							if not l_auto_buf.to_boolean then
								window_inst.curwin_init
								l_tp.ce_gets (globals_inst.first_tabpage)
								from
								until
									not (not js.loop_left and then ((l_tp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
								loop
									if (l_tp.c_pointer.to_integer_32).to_natural_32 = (globals_inst.curtab.c_pointer.to_integer_32).to_natural_32 then
										l_win.ce_gets (globals_inst.firstwin)
									else
										l_win.ce_gets (l_tp.item.tp_firstwin)
									end
									from
									until
										(l_win).c_pointer = default_pointer
									loop
										if ((l_win.item.w_buffer).c_pointer.to_integer_32).to_natural_32 = (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 then
											fold_inst.foldUpdateAll (l_win)
										end
										l_win.ce_gets (l_win.item.w_next)
									end
									l_tp.ce_gets (l_tp.item.tp_next)
								end
								if option_inst.p_acd.to_boolean then
									buffer_inst.do_autochdir
								end
								l_lnum := globals_inst.curwin.item.w_cursor.lnum
								l_topline := globals_inst.curwin.item.w_topline
								if not l_oldbuf.to_boolean then
									globals_inst.swap_exists_action := 1
									globals_inst.curbuf.item.b_flags := (globals_inst.curbuf.item.b_flags).bit_or ((2))
									if (ex_eval_inst.should_abort ((buffer_inst.open_buffer (0, a_eap, l_readfile_flags)))).to_boolean then
										l_retval := 0
									end
									if globals_inst.swap_exists_action = 2 then
										l_retval := 0
									end
									buffer_inst.handle_swap_exists (l_old_curbuf)
								else
									buffer_inst.do_modelines (16)
									fileio_inst.apply_autocmds_retval ({PC_AUTO_EVENT}.EVENT_BUFENTER, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf, create {CE_POINTER [INTEGER_32]}.make_shared ($l_retval)).do_nothing
									fileio_inst.apply_autocmds_retval ({PC_AUTO_EVENT}.EVENT_BUFWINENTER, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf, create {CE_POINTER [INTEGER_32]}.make_shared ($l_retval)).do_nothing
								end
								ex_cmds2_inst.check_arg_idx (globals_inst.curwin)
								if globals_inst.curwin.item.w_cursor.lnum /= l_lnum then
									l_newlnum := globals_inst.curwin.item.w_cursor.lnum
									l_newcol := globals_inst.curwin.item.w_cursor.col
								end
								if globals_inst.curwin.item.w_topline = l_topline then
									l_topline := (0).to_integer_32
								end
								move_inst.changed_line_abv_curs
								buffer_inst.maketitle
							end
							if (globals_inst.curwin.item.w_onebuf_opt.wo_diff).to_boolean then
								diff_inst.diff_buf_add (globals_inst.curbuf)
								diff_inst.diff_invalidate (globals_inst.curbuf)
							end
							if l_did_get_winopts.to_boolean then
								if (globals_inst.curwin.item.w_onebuf_opt.wo_spell).to_boolean then
									if (((globals_inst.curwin.item.w_s).item.b_p_spl).item).to_integer_32 /= 0 then
										spell_inst.did_set_spelllang (globals_inst.curwin).do_nothing
									end
								end
							end
							if (l_command.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								if l_newcol >= 0 then
									globals_inst.curwin.item.w_cursor.lnum := l_newlnum
									globals_inst.curwin.item.w_cursor.col := l_newcol
									misc2_inst.check_cursor
								elseif l_newlnum > 0 then
									globals_inst.curwin.item.w_cursor.lnum := l_newlnum
									misc2_inst.check_cursor_lnum
									if l_solcol >= 0 then
										if not option_inst.p_sol.to_boolean then
											globals_inst.curwin.item.w_cursor.col := l_solcol
											misc2_inst.check_cursor_col
											globals_inst.curwin.item.w_cursor.coladd := 0
											globals_inst.curwin.item.w_set_curswant := 1
										else
											edit_inst.beginline (6)
										end
									else
										edit_inst.beginline (6)
									end
								else
									if globals_inst.exmode_active.to_boolean then
										globals_inst.curwin.item.w_cursor.lnum := globals_inst.curbuf.item.b_ml.ml_line_count
									end
									edit_inst.beginline (5)
								end
							end
							window_inst.check_lnums (0)
							if l_oldbuf.to_boolean then
								if not l_auto_buf.to_boolean then
									l_msg_scroll_save := globals_inst.msg_scroll
									if (option_inst.shortmess (('O').code)).to_boolean then
										if not globals_inst.exiting.to_boolean then
											if option_inst.p_verbose = 0 then
												globals_inst.msg_scroll := 0
											end
										end
									end
									if not globals_inst.msg_scroll.to_boolean then
										screen_inst.check_for_delay (0)
									end
									message_inst.msg_start
									globals_inst.msg_scroll := l_msg_scroll_save
									globals_inst.msg_scrolled_ign := 1
									buffer_inst.fileinfo (0, 1, 0)
									globals_inst.msg_scrolled_ign := 0
								end
							end
							if (l_command.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								ex_docmd_inst.do_cmdline (l_command, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 1).do_nothing
							end
							globals_inst.RedrawingDisabled := globals_inst.RedrawingDisabled - 1
							if not globals_inst.skip_redraw.to_boolean then
								l_n := option_inst.p_so
								if l_topline = 0 then
									if (l_command.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										option_inst.p_so := 999
									end
								end
								move_inst.update_topline
								globals_inst.curwin.item.w_scbind_pos := globals_inst.curwin.item.w_topline
								option_inst.p_so := l_n
								screen_inst.redraw_curbuf_later (40)
							end
							if option_inst.p_im.to_boolean then
								globals_inst.need_start_insertmode := 1
							end
							if option_inst.p_acd.to_boolean then
								buffer_inst.do_autochdir
							end
							if ((globals_inst.curbuf.item.b_ffname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if ((a_flags___0).bit_and (2)) /= 2 then
									netbeans_inst.netbeans_file_opened (globals_inst.curbuf)
								end
							end
				when 85 then -- theend:
							if l_did_set_swapcommand.to_boolean then
								eval_inst.set_vim_var_string (47, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), -1)
							end
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_browse_file))
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_free_fname))
							Result := l_retval
				when 86 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	delbuf_msg (a_name___1: CE_POINTER [NATURAL_8])
		local
			l_tmp: CE_POINTER [NATURAL_8]
		do
			create l_tmp.make

			if (a_name___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_tmp.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
			else
				l_tmp.ce_gets (a_name___1)
			end
			message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E143: Autocommands unexpectedly deleted new buffer %%s")))), l_tmp).do_nothing
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_name___1))
			globals_inst.au_new_curbuf.ce_gets (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
		end

	ex_append (a_eap: CE_POINTER [PD_EXARG])
		local
			l_theline: CE_POINTER [NATURAL_8]
			l_did_undo: INTEGER_32
			l_lnum: INTEGER_32
			l_indent: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_vcol: INTEGER_32
			l_empty: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_theline.make
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_did_undo := 0
					l_lnum := a_eap.item.line2
					l_indent := 0
					l_empty := (globals_inst.curbuf.item.b_ml.ml_flags).bit_and (1)
					if (a_eap.item.forceit).to_boolean then
						globals_inst.curbuf.item.b_p_ai := (not (globals_inst.curbuf.item.b_p_ai).to_boolean).to_integer
					end
					if a_eap.item.cmdidx /= 42 then
						if (globals_inst.curbuf.item.b_p_ai).to_boolean then
							if l_lnum > 0 then
								append_indent := misc1_inst.get_indent_lnum (l_lnum)
							end
						end
					end
					if a_eap.item.cmdidx /= 0 then
						l_lnum := l_lnum - 1
					end
					if l_empty.to_boolean then
						if l_lnum = 1 then
							l_lnum := (0).to_integer_32
						end
					end
					globals_inst.State := 16
					if globals_inst.curbuf.item.b_p_iminsert = 1 then
						globals_inst.State := (globals_inst.State).bit_or ((32))
					end
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						globals_inst.msg_scroll := 1
						globals_inst.need_wait_return := 0
						if (globals_inst.curbuf.item.b_p_ai).to_boolean then
							if append_indent >= 0 then
								l_indent := append_indent
								append_indent := -1
							elseif l_lnum > 0 then
								l_indent := misc1_inst.get_indent_lnum (l_lnum)
							end
						end
						globals_inst.ex_keep_indent := 0
						if ((a_eap.item.getline).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if ((a_eap.item.nextcmd).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.break
							elseif ((a_eap.item.nextcmd).item).to_integer_32 = 0 then
								js.break
							end
							if not js.loop_jumped then
								l_p___0.ce_gets (misc2_inst.vim_strchr (a_eap.item.nextcmd, ('%N').code))
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_p___0.ce_gets (a_eap.item.nextcmd + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.nextcmd))).to_integer_32)
								end
								l_theline.ce_gets (misc2_inst.vim_strnsave (a_eap.item.nextcmd, l_p___0.distance ((a_eap.item.nextcmd))))
								if (l_p___0.item).to_integer_32 /= 0 then
									l_p___0.ce_gets (l_p___0 + 1)
								end
								a_eap.item.nextcmd := l_p___0
							end
						else
							if (a_eap.item.cstack).item.cs_looplevel > 0 then
								l_tmp___0 := -1
							else
								l_tmp___0 := ('%/0/').code
							end
							l_theline.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((a_eap.item.getline).pointer_item ([l_tmp___0, a_eap.item.cookie, l_indent])))
						end
						if not js.loop_jumped then
							globals_inst.lines_left := (globals_inst.Rows - 1).to_integer_32
							if (l_theline.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if:
						if globals_inst.ex_keep_indent.to_boolean then
							append_indent := l_indent
						end
						l_vcol := 0
						l_p___0.ce_gets (l_theline)
						from
						until
							not (not js.loop_left and then (l_indent > l_vcol))
						loop
							js.reset
							if (l_p___0.item).to_integer_32 = 32 then
								l_vcol := l_vcol + 1
							elseif (l_p___0.item).to_integer_32 = 9 then
								l_vcol := l_vcol + (8 - l_vcol \\ 8)
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0.ce_gets (l_p___0 + 1)
							end
						end
						js.reset
						if (l_p___0[0]).to_integer_32 /= 46 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (l_p___0[1]).to_integer_32 = 0 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_theline))
							js.break
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if not l_did_undo.to_boolean then
							if l_empty.to_boolean then
								l_tmp___1 := 1
							else
								l_tmp___1 := 0
							end
							if (undo_inst.u_save (l_lnum, (l_lnum + 1) + l_tmp___1.to_integer_32)) = 0 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_theline))
								js.break
							end
						end
				when 7 then -- if done
						if not js.loop_jumped then
							if (l_p___0[0]).to_integer_32 = 0 then
								l_theline[0] := (('%/0/').code).to_natural_8
							end
							l_did_undo := 1
							memline_inst.ml_append (l_lnum, l_theline, 0, 0).do_nothing
							misc1_inst.appended_lines_mark (l_lnum, 1)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_theline))
							l_lnum := l_lnum + 1
							if l_empty.to_boolean then
								memline_inst.ml_delete (2, 0).do_nothing
								l_empty := 0
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 8 then -- loop done
					js.reset
					globals_inst.State := 1
					if (a_eap.item.forceit).to_boolean then
						globals_inst.curbuf.item.b_p_ai := (not (globals_inst.curbuf.item.b_p_ai).to_boolean).to_integer
					end
					if a_eap.item.line2 < globals_inst.curbuf.item.b_ml.ml_line_count then
						globals_inst.curbuf.item.b_op_start.lnum := a_eap.item.line2 + 1
					else
						globals_inst.curbuf.item.b_op_start.lnum := globals_inst.curbuf.item.b_ml.ml_line_count
					end
					if a_eap.item.cmdidx /= 0 then
						globals_inst.curbuf.item.b_op_start.lnum := (globals_inst.curbuf.item.b_op_start.lnum) - 1
					end
					if a_eap.item.line2 < l_lnum then
						globals_inst.curbuf.item.b_op_end.lnum := l_lnum
					else
						globals_inst.curbuf.item.b_op_end.lnum := globals_inst.curbuf.item.b_op_start.lnum
					end
					l_tmp___3 := 0
					globals_inst.curbuf.item.b_op_end.col := l_tmp___3
					globals_inst.curbuf.item.b_op_start.col := l_tmp___3
					globals_inst.curwin.item.w_cursor.lnum := l_lnum
					misc2_inst.check_cursor_lnum
					edit_inst.beginline (6)
					globals_inst.need_wait_return := 0
					globals_inst.ex_no_reprint := 1
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_append_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_append)
		end

	ex_change (a_eap: CE_POINTER [PD_EXARG])
		local
			l_lnum: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			if a_eap.item.line2 >= a_eap.item.line1 then
				if (undo_inst.u_save (a_eap.item.line1 - 1, a_eap.item.line2 + 1)) = 0 then
					js.return
				end
			end
			if not js.return_called then
				if (a_eap.item.forceit).to_boolean then
					l_tmp___0 := (not (globals_inst.curbuf.item.b_p_ai).to_boolean).to_integer
				else
					l_tmp___0 := globals_inst.curbuf.item.b_p_ai
				end
				if l_tmp___0.to_boolean then
					append_indent := misc1_inst.get_indent_lnum (a_eap.item.line1)
				end
				l_lnum := a_eap.item.line2
				from
				until
					not (not js.loop_left and then (l_lnum >= a_eap.item.line1))
				loop
					js.reset
					if ((globals_inst.curbuf.item.b_ml.ml_flags).bit_and (1)).to_boolean then
						js.break
					end
					if not js.loop_jumped then
						memline_inst.ml_delete (a_eap.item.line1, 0).do_nothing
						l_lnum := l_lnum - 1
					end
				end
				js.reset
				misc2_inst.check_cursor_lnum
				misc1_inst.deleted_lines_mark (a_eap.item.line1, a_eap.item.line2 - l_lnum)
				a_eap.item.line2 := a_eap.item.line1
				ex_append (a_eap)
			end
		end

	ex_change_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_change)
		end

	ex_z (a_eap: CE_POINTER [PD_EXARG])
		local
			l_x___0: CE_POINTER [NATURAL_8]
			l_bigness: INTEGER_32
			l_kind: CE_POINTER [NATURAL_8]
			l_minus: INTEGER_32
			l_start___1: INTEGER_32
			l_end: INTEGER_32
			l_curs: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_lnum: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_x___0.make
			create l_kind.make
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_minus := 0
					l_lnum := a_eap.item.line2
					if (a_eap.item.forceit).to_boolean then
						l_bigness := globals_inst.curwin.item.w_height
					elseif (globals_inst.firstwin.c_pointer.to_integer_32).to_natural_32 = (globals_inst.lastwin.c_pointer.to_integer_32).to_natural_32 then
						l_bigness := (globals_inst.curwin.item.w_onebuf_opt.wo_scr * 2).to_integer_32
					else
						l_bigness := globals_inst.curwin.item.w_height - 3
					end
					if l_bigness < 1 then
						l_bigness := 1
					end
					l_x___0.ce_gets (a_eap.item.arg)
					l_kind.ce_gets (l_x___0)
					if (l_kind.item).to_integer_32 = 45 then
						l_x___0.ce_gets (l_x___0 + 1)
					elseif (l_kind.item).to_integer_32 = 43 then
						l_x___0.ce_gets (l_x___0 + 1)
					elseif (l_kind.item).to_integer_32 = 61 then
						l_x___0.ce_gets (l_x___0 + 1)
					elseif (l_kind.item).to_integer_32 = 94 then
						l_x___0.ce_gets (l_x___0 + 1)
					elseif (l_kind.item).to_integer_32 = 46 then
						l_x___0.ce_gets (l_x___0 + 1)
					end
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_x___0.item).to_integer_32 /= 45 then
							if (l_x___0.item).to_integer_32 /= 43 then
								js.break
							end
						end
						if not js.loop_jumped then
							l_x___0.ce_gets (l_x___0 + 1)
						end
					end
					js.reset
					if (l_x___0.item).to_integer_32 /= 0 then
						if (l_x___0.item).to_integer_32 >= 48 then
							if (l_x___0.item).to_integer_32 <= 57 then
								l_bigness := atoi (create {CE_POINTER [INTEGER_8]}.make_cast (l_x___0))
								option_inst.p_window := l_bigness.to_integer_32
								if (l_kind.item).to_integer_32 = 61 then
									l_bigness := l_bigness + (2)
								end
							else
								l_tmp.ce_gets (gettext (ce_string ("E144: non-numeric argument to :z")))
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
								js.return
							end
						else
							l_tmp.ce_gets (gettext (ce_string ("E144: non-numeric argument to :z")))
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						if (l_kind.item).to_integer_32 /= 45 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (l_kind.item).to_integer_32 /= 43 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						l_x___0.ce_gets (l_kind + 1)
						from
						until
							(l_x___0.item).to_integer_32 /= (l_kind.item).to_integer_32
						loop
							l_x___0.ce_gets (l_x___0 + 1)
						end
				when 6 then -- if done
						inspect (l_kind.item).to_integer_32 -- switch 1 head
						when 45 then l_pos := -1 + 7
						when 61 then l_pos := -1 + 8
						when 94 then l_pos := -1 + 9
						when 46 then l_pos := -1 + 10
						else l_pos := -1 + 11
						end
				when 7 then -- switch 1, case 45
						l_start___1 := l_lnum - l_bigness.to_integer_32 * (l_x___0.distance (l_kind)).to_integer_32
						l_end := l_start___1 + l_bigness.to_integer_32
						l_curs := l_end
						l_pos := -1 + 12 -- switch 1; break
				when 8 then -- switch 1, case 61
						l_start___1 := (l_lnum - ((l_bigness + 1) // 2).to_integer_32) + 1
						l_end := (l_lnum + ((l_bigness + 1) // 2).to_integer_32) - 1
						l_curs := l_lnum
						l_minus := 1
						l_pos := -1 + 12 -- switch 1; break
				when 9 then -- switch 1, case 94
						l_start___1 := l_lnum - (l_bigness * 2).to_integer_32
						l_end := l_lnum - l_bigness.to_integer_32
						l_curs := l_lnum - l_bigness.to_integer_32
						l_pos := -1 + 12 -- switch 1; break
				when 10 then -- switch 1, case 46
						l_start___1 := (l_lnum - ((l_bigness + 1) // 2).to_integer_32) + 1
						l_end := (l_lnum + ((l_bigness + 1) // 2).to_integer_32) - 1
						l_curs := l_end
						l_pos := -1 + 12 -- switch 1; break
				when 11 then -- switch 1, default:
						l_start___1 := l_lnum
						if (l_kind.item).to_integer_32 = 43 then
							l_start___1 := l_start___1 + (l_bigness.to_integer_32 * ((l_x___0.distance (l_kind)) - 1).to_integer_32 + 1)
						elseif a_eap.item.addr_count = 0 then
							l_start___1 := l_start___1 + 1
						end
						l_end := (l_start___1 + l_bigness.to_integer_32) - 1
						l_curs := l_end
						l_pos := -1 + 12 -- switch 1; break
				when 12 then -- switch 1, done:
						if l_start___1 < 1 then
							l_start___1 := (1).to_integer_32
						end
						if l_end > globals_inst.curbuf.item.b_ml.ml_line_count then
							l_end := globals_inst.curbuf.item.b_ml.ml_line_count
						end
						if l_curs > globals_inst.curbuf.item.b_ml.ml_line_count then
							l_curs := globals_inst.curbuf.item.b_ml.ml_line_count
						end
						l_i___0 := l_start___1
						from
						until
							not (not js.loop_left and then (l_i___0 <= l_end))
						loop
							if l_minus.to_boolean then
								if l_i___0 = l_lnum then
									message_inst.msg_putchar (('%N').code)
									l_j := 1
									from
									until
										not (l_j.to_integer_32 < globals_inst.Columns)
									loop
										message_inst.msg_putchar (('-').code)
										l_j := l_j + 1
									end
								end
							end
							print_line (l_i___0, (a_eap.item.flags).bit_and (2), (a_eap.item.flags).bit_and (1))
							if l_minus.to_boolean then
								if l_i___0 = l_lnum then
									message_inst.msg_putchar (('%N').code)
									l_j := 1
									from
									until
										not (l_j.to_integer_32 < globals_inst.Columns)
									loop
										message_inst.msg_putchar (('-').code)
										l_j := l_j + 1
									end
								end
							end
							l_i___0 := l_i___0 + 1
						end
						globals_inst.curwin.item.w_cursor.lnum := l_curs
						globals_inst.ex_no_reprint := 1
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_z_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_z)
		end

	check_restricted: INTEGER_32
		local
			js: JUMP_STATE
		do
			if globals_inst.restricted.to_boolean then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E145: Shell commands not allowed in rvim"))))).do_nothing
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	check_secure: INTEGER_32
		local
			js: JUMP_STATE
		do
			if globals_inst.secure.to_boolean then
				globals_inst.secure := 2
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_curdir))))).do_nothing
				Result := 1
				js.return
			end
			if not js.return_called and then (globals_inst.sandbox /= 0) then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_sandbox))))).do_nothing
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	do_sub (a_eap: CE_POINTER [PD_EXARG])
		local
			l_lnum: INTEGER_32
			l_i___0: INTEGER_32
			l_regmatch___0: PD_REGMMATCH_T
			l_pat: CE_POINTER [NATURAL_8]
			l_sub: CE_POINTER [NATURAL_8]
			l_delimiter: INTEGER_32
			l_sublen: INTEGER_32
			l_got_quit: INTEGER_32
			l_got_match: INTEGER_32
			l_temp: INTEGER_32
			l_which_pat: INTEGER_32
			l_cmd: CE_POINTER [NATURAL_8]
			l_save_State: INTEGER_32
			l_first_line: INTEGER_32
			l_last_line: INTEGER_32
			l_old_line_count: INTEGER_32
			l_line2: INTEGER_32
			l_nmatch: INTEGER_32
			l_sub_firstline: CE_POINTER [NATURAL_8]
			l_endcolumn: INTEGER_32
			l_old_cursor: PD_POS_T
			l_start_nsubs: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___8: INTEGER_32
			l_copycol: INTEGER_32
			l_matchcol: INTEGER_32
			l_prev_matchcol: INTEGER_32
			l_new_end: CE_POINTER [NATURAL_8]
			l_new_start: CE_POINTER [NATURAL_8]
			l_new_start_len: NATURAL_32
			l_p1: CE_POINTER [NATURAL_8]
			l_did_sub: INTEGER_32
			l_lastone: INTEGER_32
			l_len: INTEGER_32
			l_copy_len: INTEGER_32
			l_needed_len: INTEGER_32
			l_nmatch_tl: INTEGER_32
			l_do_again: INTEGER_32
			l_skip_match: INTEGER_32
			l_sub_firstlnum: INTEGER_32
			l_typed: INTEGER_32
			l_resp: CE_POINTER [NATURAL_8]
			l_sc: INTEGER_32
			l_ec: INTEGER_32
			l_save_p_fen: INTEGER_32
			l_tmp___33: INTEGER_32
			l_tmp___42: INTEGER_32
			l_tmp___45: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_regmatch___0.make
			create l_pat.make
			create l_sub.make
			create l_cmd.make
			create l_sub_firstline.make
			create l_old_cursor.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_new_end.make
			create l_new_start.make
			create l_p1.make
			create l_resp.make
			create l_tmp___45.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_i___0 := 0
					l_pat.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_sub.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_got_quit := 0
					l_got_match := 0
					l_first_line := (0).to_integer_32
					l_last_line := (0).to_integer_32
					l_old_line_count := globals_inst.curbuf.item.b_ml.ml_line_count
					l_endcolumn := 0
					l_old_cursor.ce_gets (globals_inst.curwin.item.w_cursor)
					l_cmd.ce_gets (a_eap.item.arg)
					if not globals_inst.global_busy.to_boolean then
						globals_inst.sub_nsubs := 0
						globals_inst.sub_nlines := (0).to_integer_32
					end
					l_start_nsubs := globals_inst.sub_nsubs.to_integer_32
					if a_eap.item.cmdidx = 516 then
						l_which_pat := 2
					else
						l_which_pat := 1
					end
					if (a_eap.item.cmd[0]).to_integer_32 /= 115 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (l_cmd.item).to_integer_32 /= 0 then
							if (l_cmd.item).to_integer_32 = 32 then
								l_pos := -1 + 3 -- goto _L___1
							elseif (l_cmd.item).to_integer_32 = 9 then
								l_pos := -1 + 3 -- goto _L___1
							elseif ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("0123456789cegriIp|%"")), (l_cmd.item).to_integer_32)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								if ((((ctype_b_loc).item[(l_cmd.item).to_integer_32]).to_integer_32).bit_and (1024)).to_boolean then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E146: Regular expressions can%'t be delimited by letters"))))).do_nothing
									js.return
								end
								if not js.return_called then
									if (l_cmd.item).to_integer_32 = 92 then
										l_cmd.ce_gets (l_cmd + 1)
										if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/?&")), (l_cmd.item).to_integer_32)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
											message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_backslash))))).do_nothing
											js.return
										end
										if not js.return_called then
											if (l_cmd.item).to_integer_32 /= 38 then
												l_which_pat := 0
											end
											l_pat.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
											l_tmp___3.ce_gets (l_cmd)
											l_cmd.ce_gets (l_cmd + 1)
											l_delimiter := (l_tmp___3.item).to_integer_32
										end
									else
										l_which_pat := 2
										l_tmp___4.ce_gets (l_cmd)
										l_cmd.ce_gets (l_cmd + 1)
										l_delimiter := (l_tmp___4.item).to_integer_32
										l_pat.ce_gets (l_cmd)
										l_cmd.ce_gets (regexp_inst.skip_regexp (l_cmd, l_delimiter, option_inst.p_magic, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (a_eap.c_pointer + {PD_EXARG}.arg_offset)))
										if (l_cmd[0]).to_integer_32 = l_delimiter then
											l_tmp___5.ce_gets (l_cmd)
											l_cmd.ce_gets (l_cmd + 1)
											l_tmp___5.item := (('%/0/').code).to_natural_8
										end
									end
								end
								if not js.return_called then
									l_sub.ce_gets (l_cmd)
									from
									until
										not (not js.loop_left and then ((l_cmd[0]).to_boolean))
									loop
										js.reset
										if (l_cmd[0]).to_integer_32 = l_delimiter then
											l_tmp___6.ce_gets (l_cmd)
											l_cmd.ce_gets (l_cmd + 1)
											l_tmp___6.item := (('%/0/').code).to_natural_8
											js.break
										end
										if not js.loop_jumped then
											if (l_cmd[0]).to_integer_32 = 92 then
												if (l_cmd[1]).to_integer_32 /= 0 then
													l_cmd.ce_gets (l_cmd + 1)
												end
											end
											if globals_inst.has_mbyte.to_boolean then
												l_tmp___8 := (globals_inst.mb_ptr2len.integer_32_item ([l_cmd]))
											else
												l_tmp___8 := 1
											end
											l_cmd.ce_gets (l_cmd + l_tmp___8)
										end
									end
									js.reset
									if not (a_eap.item.skip).to_boolean then
										if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_sub), ce_string ("%%"))) = 0 then
											if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('/').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
												if (old_sub.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
													message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_nopresub))))).do_nothing
													js.return
												end
												if not js.return_called then
													l_sub.ce_gets (old_sub)
												end
											else
												misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (old_sub))
												old_sub.ce_gets (misc2_inst.vim_strsave (l_sub))
											end
										else
											misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (old_sub))
											old_sub.ce_gets (misc2_inst.vim_strsave (l_sub))
										end
									end
								end
							else
								l_pos := -1 + 3 -- goto _L___1
							end
						else
							l_pos := -1 + 3 -- goto _L___1
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___1:
						if not (a_eap.item.skip).to_boolean then
							if (old_sub.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_nopresub))))).do_nothing
								js.return
							end
							if not js.return_called then
								l_pat.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								l_sub.ce_gets (old_sub)
								l_endcolumn := ((globals_inst.curwin.item.w_curswant).to_integer_32 = 2147483647).to_integer
							end
						end
				when 4 then
					if not js.return_called then
						if (l_cmd.item).to_integer_32 = 38 then
							l_cmd.ce_gets (l_cmd + 1)
						else
							if not option_inst.p_ed.to_boolean then
								if option_inst.p_gd.to_boolean then
									do_all := 1
								else
									do_all := 0
								end
								do_ask := 0
							end
							do_error := 1
							do_print := 0
							do_count := 0
							do_number := 0
							do_ic := 0
						end
						from
						until
							not (not js.loop_left and then ((l_cmd.item).to_boolean))
						loop
							js.reset
							if (l_cmd.item).to_integer_32 = 103 then
								do_all := (not do_all.to_boolean).to_integer
							elseif (l_cmd.item).to_integer_32 = 99 then
								do_ask := (not do_ask.to_boolean).to_integer
							elseif (l_cmd.item).to_integer_32 = 110 then
								do_count := 1
							elseif (l_cmd.item).to_integer_32 = 101 then
								do_error := (not do_error.to_boolean).to_integer
							elseif (l_cmd.item).to_integer_32 = 114 then
								l_which_pat := 2
							elseif (l_cmd.item).to_integer_32 = 112 then
								do_print := 1
							elseif (l_cmd.item).to_integer_32 = 35 then
								do_print := 1
								do_number := 1
							elseif (l_cmd.item).to_integer_32 = 108 then
								do_print := 1
								do_list := 1
							elseif (l_cmd.item).to_integer_32 = 105 then
								do_ic := ('i').code
							elseif (l_cmd.item).to_integer_32 = 73 then
								do_ic := ('I').code
							else
								js.break
							end
							if not js.loop_jumped then
								l_cmd.ce_gets (l_cmd + 1)
							end
						end
						js.reset
						if do_count.to_boolean then
							do_ask := 0
						end
						l_cmd.ce_gets (charset_inst.skipwhite (l_cmd))
						if (l_cmd.item).to_integer_32 >= 48 then
							if (l_cmd.item).to_integer_32 <= 57 then
								l_i___0 := charset_inst.getdigits (l_cmd.address)
								if l_i___0 <= 0 then
									if not (a_eap.item.skip).to_boolean then
										if do_error.to_boolean then
											message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_zerocount))))).do_nothing
											js.return
										end
									end
								end
								if not js.return_called then
									a_eap.item.line1 := a_eap.item.line2
									a_eap.item.line2 := a_eap.item.line2 + (l_i___0 - 1)
									if a_eap.item.line2 > globals_inst.curbuf.item.b_ml.ml_line_count then
										a_eap.item.line2 := globals_inst.curbuf.item.b_ml.ml_line_count
									end
								end
							end
						end
					end
					if not js.return_called then
						l_cmd.ce_gets (charset_inst.skipwhite (l_cmd))
						if (l_cmd.item).to_boolean then
							if (l_cmd.item).to_integer_32 /= 34 then
								a_eap.item.nextcmd := ex_docmd_inst.check_nextcmd (l_cmd)
								if ((a_eap.item.nextcmd).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_trailing))))).do_nothing
									js.return
								end
							end
						end
					end
					if not js.return_called and then ((a_eap.item.skip).to_boolean) then
						js.return
					end
					if not js.return_called and then (not do_count.to_boolean) then
						if not (globals_inst.curbuf.item.b_p_ma).to_boolean then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_modifiable))))).do_nothing
							js.return
						end
					end
					if not js.return_called then
						if (search_inst.search_regcomp (l_pat, 1, l_which_pat, 32, l_regmatch___0.address)) = 0 then
							if do_error.to_boolean then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invcmd))))).do_nothing
							end
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 72 -- skip if block
					end
				when 5 then -- if:
						if do_ic = 105 then
							l_regmatch___0.rmm_ic := 1
						elseif do_ic = 73 then
							l_regmatch___0.rmm_ic := 0
						end
						l_sub_firstline.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						if (l_sub[0]).to_integer_32 = 92 then
							if (l_sub[1]).to_integer_32 /= 61 then
								l_sub.ce_gets (regexp_inst.regtilde (l_sub, option_inst.p_magic))
							end
						else
							l_sub.ce_gets (regexp_inst.regtilde (l_sub, option_inst.p_magic))
						end
						l_line2 := a_eap.item.line2
						l_lnum := a_eap.item.line1
				when 6 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 70 -- skip loop
						end
				when 7 then -- loop body:
						js.reset
						if l_lnum <= l_line2 then
							if l_got_quit.to_boolean then
								js.break
							elseif (ex_eval_inst.aborting).to_boolean then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 69 -- skip if block
						end
				when 8 then -- if:
						l_nmatch := regexp_inst.vim_regexec_multi (l_regmatch___0.address, globals_inst.curwin, globals_inst.curbuf, l_lnum, 0, create {CE_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))
						if not (l_nmatch.to_boolean) then
							l_pos := -1 + 68 -- skip if block
						end
				when 9 then -- if:
						l_prev_matchcol := (2147483647).to_integer_32
						l_new_start.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						l_new_start_len := {NATURAL_32} 0
						l_did_sub := 0
						l_nmatch_tl := 0
						l_skip_match := 0
						l_sub_firstlnum := l_lnum
						l_copycol := 0
						l_matchcol := 0
						if not l_got_match.to_boolean then
							mark_inst.setpcmark
							l_got_match := 1
						end
				when 10 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 67 -- skip loop
						end
				when 11 then -- loop body:
						js.reset
						if l_regmatch___0.startpos[0].lnum > 0 then
							l_lnum := l_lnum + (l_regmatch___0.startpos[0].lnum)
							l_sub_firstlnum := l_sub_firstlnum + (l_regmatch___0.startpos[0].lnum)
							l_nmatch := l_nmatch - (l_regmatch___0.startpos[0].lnum)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_sub_firstline))
							l_sub_firstline.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						end
						if (l_sub_firstline.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_sub_firstline.ce_gets (misc2_inst.vim_strsave ((memline_inst.ml_get (l_sub_firstlnum))))
							if (l_sub_firstline.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_new_start))
								l_pos := -1 + 71 -- goto outofmem
							end
						end
				when 12 then
						globals_inst.curwin.item.w_cursor.lnum := l_lnum
						l_do_again := 0
						if l_matchcol = l_prev_matchcol then
							if l_regmatch___0.endpos[0].lnum = 0 then
								if l_matchcol = l_regmatch___0.endpos[0].col then
									if (l_sub_firstline[l_matchcol]).to_integer_32 = 0 then
										l_skip_match := 1
									else
										l_matchcol := l_matchcol + 1
									end
									l_pos := -1 + 33 -- goto skip
								end
							end
						end
				when 13 then
						l_matchcol := l_regmatch___0.endpos[0].col
						l_prev_matchcol := l_matchcol
						if do_count.to_boolean then
							if l_nmatch > 1 then
								l_matchcol := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_sub_firstline))).to_integer_32
								l_nmatch := 1
								l_skip_match := 1
							end
							globals_inst.sub_nsubs := globals_inst.sub_nsubs + 1
							l_did_sub := 1
							l_pos := -1 + 33 -- goto skip
						end
				when 14 then
						if not (do_ask.to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_typed := 0
						l_save_State := globals_inst.State
						globals_inst.State := 2048
						term_inst.setmouse
						globals_inst.curwin.item.w_cursor.col := l_regmatch___0.startpos[0].col
						if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('u').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							globals_inst.no_u_sync := globals_inst.no_u_sync + 1
						end
						from
						until
							not (not js.loop_left and then (do_ask.to_boolean))
						loop
							js.reset
							if globals_inst.exmode_active.to_boolean then
								print_line_no_prefix (l_lnum, 0, 0)
								charset_inst.getvcol (globals_inst.curwin, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset), create {CE_POINTER [INTEGER_32]}.make_shared ($l_sc), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
								globals_inst.curwin.item.w_cursor.col := l_regmatch___0.endpos[0].col - 1
								charset_inst.getvcol (globals_inst.curwin, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_ec))
								message_inst.msg_start
								l_i___0 := 0
								from
								until
									not (l_i___0 < l_sc.to_integer_32)
								loop
									message_inst.msg_putchar ((' ').code)
									l_i___0 := l_i___0 + 1
								end
								from
								until
									not (l_i___0 <= l_ec.to_integer_32)
								loop
									message_inst.msg_putchar (('^').code)
									l_i___0 := l_i___0 + 1
								end
								l_resp.ce_gets (ex_getln_inst.getexmodeline (('?').code, create {CE_POINTER [ANY]}.make_shared (default_pointer), 0))
								if (l_resp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_typed := (l_resp.item).to_integer_32
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_resp))
								end
							else
								l_save_p_fen := globals_inst.curwin.item.w_onebuf_opt.wo_fen
								globals_inst.curwin.item.w_onebuf_opt.wo_fen := 0
								l_temp := globals_inst.RedrawingDisabled
								globals_inst.RedrawingDisabled := 0
								globals_inst.search_match_lines := l_regmatch___0.endpos[0].lnum - l_regmatch___0.startpos[0].lnum
								globals_inst.search_match_endcol := l_regmatch___0.endpos[0].col
								globals_inst.highlight_match := 1
								move_inst.update_topline
								move_inst.validate_cursor
								screen_inst.update_screen (35)
								globals_inst.highlight_match := 0
								screen_inst.redraw_later (35)
								globals_inst.curwin.item.w_onebuf_opt.wo_fen := l_save_p_fen
								if globals_inst.msg_row.to_integer_32 = globals_inst.Rows - 1 then
									globals_inst.msg_didout := 0
								end
								message_inst.msg_starthere
								l_i___0 := globals_inst.msg_scroll.to_integer_32
								globals_inst.msg_scroll := 0
								globals_inst.msg_no_more := 1
								message_inst.smsg_attr ([globals_inst.highlight_attr[10], create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("replace with %%s (y/n/a/q/l/^E/^Y)?")))), l_sub]).do_nothing
								globals_inst.msg_no_more := 0
								globals_inst.msg_scroll := l_i___0.to_integer_32
								screen_inst.showruler (1)
								screen_inst.windgoto (globals_inst.msg_row, globals_inst.msg_col)
								globals_inst.RedrawingDisabled := l_temp
								globals_inst.dont_scroll := 0
								globals_inst.no_mapping := globals_inst.no_mapping + 1
								globals_inst.allow_keys := globals_inst.allow_keys + 1
								l_typed := getchar_inst.plain_vgetc
								globals_inst.allow_keys := globals_inst.allow_keys - 1
								globals_inst.no_mapping := globals_inst.no_mapping - 1
								globals_inst.msg_didout := 0
								globals_inst.msg_col := 0
								ex_getln_inst.gotocmdline (1)
							end
							globals_inst.need_wait_return := 0
							if l_typed = 113 then
								l_got_quit := 1
								js.break
							elseif l_typed = 27 then
								l_got_quit := 1
								js.break
							elseif l_typed = 3 then
								l_got_quit := 1
								js.break
							elseif l_typed = globals_inst.intr_char then
								l_got_quit := 1
								js.break
							end
							if not js.loop_jumped and then (l_typed = 110) then
								js.break
							end
							if not js.loop_jumped and then (l_typed = 121) then
								js.break
							end
							if not js.loop_jumped and then (l_typed = 108) then
								do_all := 0
								l_line2 := l_lnum
								js.break
							end
							if not js.loop_jumped and then (l_typed = 97) then
								do_ask := 0
								js.break
							end
							if not js.loop_jumped then
								if l_typed = 5 then
									move_inst.scrollup_clamp
								elseif l_typed = 25 then
									move_inst.scrolldown_clamp
								end
							end
						end
						js.reset
						globals_inst.State := l_save_State
						term_inst.setmouse
						if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('u').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							globals_inst.no_u_sync := globals_inst.no_u_sync - 1
						end
						if l_typed = 110 then
							if l_nmatch > 1 then
								l_matchcol := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_sub_firstline))).to_integer_32
								l_skip_match := 1
							end
							l_pos := -1 + 33 -- goto skip
						end
				when 16 then
						if l_got_quit.to_boolean then
							js.break
						end
				when 17 then -- if done
						if js.loop_jumped then
							l_pos := -1 + 66 -- skip if block
						end
				when 18 then -- if:
						globals_inst.curwin.item.w_cursor.col := l_regmatch___0.startpos[0].col
						l_sublen := regexp_inst.vim_regsub_multi (l_regmatch___0.address, l_sub_firstlnum - l_regmatch___0.startpos[0].lnum, l_sub, l_sub_firstline, 0, option_inst.p_magic, 1)
						if l_nmatch > (globals_inst.curbuf.item.b_ml.ml_line_count - l_sub_firstlnum) + 1 then
							l_nmatch := (globals_inst.curbuf.item.b_ml.ml_line_count - l_sub_firstlnum) + 1
							l_skip_match := 1
						end
						if l_nmatch = 1 then
							l_p1.ce_gets (l_sub_firstline)
						else
							l_p1.ce_gets (memline_inst.ml_get ((l_sub_firstlnum + l_nmatch) - 1))
							l_nmatch_tl := l_nmatch_tl + (l_nmatch - 1)
						end
						l_copy_len := l_regmatch___0.startpos[0].col - l_copycol
						l_needed_len := (((l_copy_len.to_natural_32 + ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p1))) - (l_regmatch___0.endpos[0].col).to_natural_32)) + l_sublen.to_natural_32) + {NATURAL_32} 1).to_integer_32
						if (l_new_start.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 22 -- skip if block
						end
				when 19 then -- if:
						l_new_start_len := (l_needed_len + 50).to_natural_32
						l_new_start.ce_gets (misc2_inst.alloc_check (l_new_start_len))
						if (l_new_start.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 71 -- goto outofmem
						end
				when 20 then
						l_new_start.item := (('%/0/').code).to_natural_8
						l_new_end.ce_gets (l_new_start)
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 22 then -- else:
						l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_new_start))).to_integer_32
						l_needed_len := l_needed_len + l_len
						if not (l_needed_len > l_new_start_len.to_integer_32) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_new_start_len := (l_needed_len + 50).to_natural_32
						l_p1.ce_gets (misc2_inst.alloc_check (l_new_start_len))
						if (l_p1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_new_start))
							l_pos := -1 + 71 -- goto outofmem
						end
				when 24 then
						memmove (create {CE_POINTER [ANY]}.make_cast (l_p1), create {CE_POINTER [ANY]}.make_cast (l_new_start), (l_len + 1).to_natural_32).do_nothing
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_new_start))
						l_new_start.ce_gets (l_p1)
				when 25 then -- if done
						l_new_end.ce_gets (l_new_start + l_len)
				when 26 then -- if done
						memmove (create {CE_POINTER [ANY]}.make_cast (l_new_end), create {CE_POINTER [ANY]}.make_cast ((l_sub_firstline + l_copycol)), l_copy_len.to_natural_32).do_nothing
						l_new_end.ce_gets (l_new_end + l_copy_len)
						regexp_inst.vim_regsub_multi (l_regmatch___0.address, l_sub_firstlnum - l_regmatch___0.startpos[0].lnum, l_sub, l_new_end, 1, option_inst.p_magic, 1).do_nothing
						globals_inst.sub_nsubs := globals_inst.sub_nsubs + 1
						l_did_sub := 1
						globals_inst.curwin.item.w_cursor.col := 0
						if l_nmatch > 1 then
							l_sub_firstlnum := l_sub_firstlnum + (l_nmatch - 1)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_sub_firstline))
							l_sub_firstline.ce_gets (misc2_inst.vim_strsave ((memline_inst.ml_get (l_sub_firstlnum))))
							if l_sub_firstlnum <= l_line2 then
								l_do_again := 1
							else
								do_all := 0
							end
						end
						l_copycol := l_regmatch___0.endpos[0].col
						if l_skip_match.to_boolean then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_sub_firstline))
							l_sub_firstline.ce_gets (misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))))
							l_copycol := 0
						end
						l_p1.ce_gets (l_new_end)
				when 27 then -- loop condition:
						if not ((l_p1.item).to_boolean) then
							l_pos := -1 + 33 -- skip loop
						end
				when 28 then -- loop body:
						if (l_p1[0]).to_integer_32 /= 92 then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						if (l_p1[1]).to_integer_32 /= 0 then
							memmove (create {CE_POINTER [ANY]}.make_cast (l_p1), create {CE_POINTER [ANY]}.make_cast ((l_p1 + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p1 + 1)))) + {NATURAL_32} 1).do_nothing
						else
							l_pos := -1 + 31 -- goto _L___2
						end
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 31 then -- else: | _L___2:
						if (l_p1.item).to_integer_32 = 13 then
							if (undo_inst.u_inssub (l_lnum)) = 1 then
								l_p1.item := (('%/0/').code).to_natural_8
								memline_inst.ml_append (l_lnum - 1, l_new_start, (l_p1.distance (l_new_start)) + 1, 0).do_nothing
								mark_inst.mark_adjust (l_lnum + 1, 2147483647, 1, 0)
								if do_ask.to_boolean then
									misc1_inst.appended_lines (l_lnum - 1, 1)
								else
									if l_first_line = 0 then
										l_first_line := l_lnum
									end
									l_last_line := l_lnum + 1
								end
								l_sub_firstlnum := l_sub_firstlnum + 1
								l_lnum := l_lnum + 1
								l_line2 := l_line2 + 1
								globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
								memmove (create {CE_POINTER [ANY]}.make_cast (l_new_start), create {CE_POINTER [ANY]}.make_cast ((l_p1 + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p1 + 1)))) + {NATURAL_32} 1).do_nothing
								l_p1.ce_gets (l_new_start - 1)
							end
						elseif globals_inst.has_mbyte.to_boolean then
							l_p1.ce_gets (l_p1 + ((globals_inst.mb_ptr2len.integer_32_item ([l_p1])) - 1))
						end
				when 32 then
						l_p1.ce_gets (l_p1 + 1)
						l_pos := -1 + 27 -- back to loop condition
				when 33 then -- skip:
						if not (l_skip_match.to_boolean) then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						l_tmp___33 := 1
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 52
				when 36 then -- else:
						if not (globals_inst.got_int.to_boolean) then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						l_tmp___33 := 1
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 52
				when 39 then -- else:
						if not (l_got_quit.to_boolean) then
							l_pos := -1 + 42 -- skip if block
						end
				when 40 then -- if:
						l_tmp___33 := 1
				when 41 then -- if block done, skip else block:
						l_pos := -1 + 52
				when 42 then -- else:
						if not (l_lnum > l_line2) then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if:
						l_tmp___33 := 1
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 52
				when 45 then -- else:
						if not (do_all.to_boolean) then
							l_pos := -1 + 48 -- skip if block
						end
				when 46 then -- if:
						l_pos := -1 + 49 -- goto _L___3
				when 47 then -- if block done, skip else block:
						l_pos := -1 + 52
				when 48 then -- else:
						if not (l_do_again.to_boolean) then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if: | _L___3:
						if (l_sub_firstline[l_matchcol]).to_integer_32 = 0 then
							if l_nmatch <= 1 then
								if (regexp_inst.re_multiline (l_regmatch___0.regprog)).to_boolean then
									l_tmp___33 := 0
								else
									l_tmp___33 := 1
								end
							else
								l_tmp___33 := 0
							end
						else
							l_tmp___33 := 0
						end
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 52
				when 51 then -- else:
						l_tmp___33 := 1
				when 52 then -- if done | if done | if done | if done | if done
						l_lastone := l_tmp___33
						l_nmatch := -1
						if not (l_lastone.to_boolean) then
							l_pos := -1 + 55 -- skip if block
						end
				when 53 then -- if:
						l_pos := -1 + 65 -- goto _L___4
				when 54 then -- if block done, skip else block:
						l_pos := -1 + 66
				when 55 then -- else:
						if not (do_ask.to_boolean) then
							l_pos := -1 + 58 -- skip if block
						end
				when 56 then -- if:
						if (regexp_inst.re_lookbehind (l_regmatch___0.regprog)).to_boolean then
							l_pos := -1 + 58 -- goto _L___5
						else
							l_pos := -1 + 65 -- goto _L___4
						end
				when 57 then -- if block done, skip else block:
						l_pos := -1 + 66
				when 58 then -- else: | _L___5:
						if not (l_nmatch_tl > 0) then
							l_pos := -1 + 61 -- skip if block
						end
				when 59 then -- if:
						l_pos := -1 + 65 -- goto _L___4
				when 60 then -- if block done, skip else block:
						l_pos := -1 + 66
				when 61 then -- else:
						l_nmatch := regexp_inst.vim_regexec_multi (l_regmatch___0.address, globals_inst.curwin, globals_inst.curbuf, l_sub_firstlnum, l_matchcol, create {CE_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))
						if l_nmatch /= 0 then
							l_pos := -1 + 64 -- skip if block
						end
				when 62 then -- if:
						l_pos := -1 + 65 -- goto _L___4
				when 63 then -- if block done, skip else block:
						l_pos := -1 + 66
				when 64 then -- else:
						if not (l_regmatch___0.startpos[0].lnum > 0) then
							l_pos := -1 + 66 -- skip if block
						end
				when 65 then -- if: | _L___4:
						if (l_new_start.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_new_start), create {CE_POINTER [INTEGER_8]}.make_cast ((l_sub_firstline + l_copycol))).do_nothing
							l_matchcol := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_sub_firstline))).to_integer_32 - l_matchcol
							l_prev_matchcol := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_sub_firstline))).to_integer_32 - l_prev_matchcol
							if (undo_inst.u_savesub (l_lnum)) /= 1 then
								js.break
							end
							if not js.loop_jumped then
								memline_inst.ml_replace (l_lnum, l_new_start, 1).do_nothing
								if l_nmatch_tl > 0 then
									l_lnum := l_lnum + 1
									if (undo_inst.u_savedel (l_lnum, l_nmatch_tl)) /= 1 then
										js.break
									end
									if not js.loop_jumped then
										l_i___0 := 0
										from
										until
											not (l_i___0 < l_nmatch_tl)
										loop
											memline_inst.ml_delete (l_lnum, 0).do_nothing
											l_i___0 := l_i___0 + 1
										end
										mark_inst.mark_adjust (l_lnum, (l_lnum + l_nmatch_tl) - 1, 2147483647, -l_nmatch_tl)
										if do_ask.to_boolean then
											misc1_inst.deleted_lines (l_lnum, l_nmatch_tl)
										end
										l_lnum := l_lnum - 1
										l_line2 := l_line2 - l_nmatch_tl
										l_nmatch_tl := 0
									end
								end
							end
							if not js.loop_jumped then
								if do_ask.to_boolean then
									misc1_inst.changed_bytes (l_lnum, 0)
								else
									if l_first_line = 0 then
										l_first_line := l_lnum
									end
									l_last_line := l_lnum + 1
								end
								l_sub_firstlnum := l_lnum
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_sub_firstline))
								l_sub_firstline.ce_gets (l_new_start)
								l_new_start.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								l_matchcol := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_sub_firstline))).to_integer_32 - l_matchcol
								l_prev_matchcol := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_sub_firstline))).to_integer_32 - l_prev_matchcol
								l_copycol := 0
							end
						end
						if not js.loop_jumped then
							if l_nmatch = -1 then
								if not l_lastone.to_boolean then
									l_nmatch := regexp_inst.vim_regexec_multi (l_regmatch___0.address, globals_inst.curwin, globals_inst.curbuf, l_sub_firstlnum, l_matchcol, create {CE_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))
								end
							end
							if l_nmatch <= 0 then
								if l_nmatch = -1 then
									l_lnum := l_lnum - (l_regmatch___0.startpos[0].lnum)
								end
								js.break
							end
						end
				when 66 then -- if done | if done | if done | if done | if done
						if not js.loop_jumped then
							misc1_inst.line_breakcheck
						end
						l_pos := -1 + 10 -- back to loop condition
				when 67 then -- loop done
						js.reset
						if l_did_sub.to_boolean then
							globals_inst.sub_nlines := globals_inst.sub_nlines + 1
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_new_start))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_sub_firstline))
						l_sub_firstline.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				when 68 then -- if done
						misc1_inst.line_breakcheck
						l_lnum := l_lnum + 1
				when 69 then -- if done
						l_pos := -1 + 6 -- back to loop condition
				when 70 then -- loop done
						js.reset
						if l_first_line /= 0 then
							l_i___0 := globals_inst.curbuf.item.b_ml.ml_line_count - l_old_line_count
							misc1_inst.changed_lines (l_first_line, 0, l_last_line - l_i___0, l_i___0)
						end
				when 71 then -- outofmem:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_sub_firstline))
						if do_count.to_boolean then
							globals_inst.curwin.item.w_cursor := l_old_cursor
						end
						if globals_inst.sub_nsubs > l_start_nsubs.to_integer_32 then
							globals_inst.curbuf.item.b_op_start.lnum := a_eap.item.line1
							globals_inst.curbuf.item.b_op_end.lnum := l_line2
							l_tmp___42 := 0
							globals_inst.curbuf.item.b_op_end.col := l_tmp___42
							globals_inst.curbuf.item.b_op_start.col := l_tmp___42
							if not globals_inst.global_busy.to_boolean then
								if l_endcolumn.to_boolean then
									misc2_inst.coladvance ((2147483647).to_integer_32).do_nothing
								else
									edit_inst.beginline (5)
								end
								if not (do_sub_msg (do_count)).to_boolean then
									if do_ask.to_boolean then
										message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))).do_nothing
									end
								end
							else
								global_need_beginline := 1
							end
							if do_print.to_boolean then
								print_line (globals_inst.curwin.item.w_cursor.lnum, do_number, do_list)
							end
						elseif not globals_inst.global_busy.to_boolean then
							if globals_inst.got_int.to_boolean then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_interr))))).do_nothing
							elseif l_got_match.to_boolean then
								message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))).do_nothing
							elseif do_error.to_boolean then
								l_tmp___45.ce_gets (search_inst.get_search_pat)
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_patnotf2)))), l_tmp___45).do_nothing
							end
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_regmatch___0.regprog))
				when 72 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_sub_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent do_sub)
		end

	do_sub_msg (a_count_only: INTEGER_32): INTEGER_32
		local
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tmp___2.make
			create l_tmp___5.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (globals_inst.sub_nsubs > option_inst.p_report) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if globals_inst.KeyTyped.to_boolean then
							l_pos := -1 + 4 -- goto _L
						elseif globals_inst.sub_nlines > 1 then
							l_pos := -1 + 4 -- goto _L
						elseif option_inst.p_report < 1 then
							l_pos := -1 + 4 -- goto _L
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else: | _L___0:
						if not (a_count_only.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if (screen_inst.messaging).to_boolean then
							if globals_inst.got_int.to_boolean then
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.msg_buf), (gettext (ce_string ("(Interrupted) ")))).do_nothing
							else
								globals_inst.msg_buf[0] := (('%/0/').code).to_natural_8
							end
							if globals_inst.sub_nsubs = 1 then
								if a_count_only.to_boolean then
									l_tmp___2.ce_gets ((gettext (ce_string ("1 match"))))
								else
									l_tmp___2.ce_gets ((gettext (ce_string ("1 substitution"))))
								end
								message_inst.vim_snprintf_add ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.msg_buf), (Natural_8_bytes.to_natural_32 * (480).to_natural_32), ce_string ("%%s"), l_tmp___2]).do_nothing
							else
								if a_count_only.to_boolean then
									l_tmp___5.ce_gets ((gettext (ce_string ("%%ld matches"))))
								else
									l_tmp___5.ce_gets ((gettext (ce_string ("%%ld substitutions"))))
								end
								message_inst.vim_snprintf_add ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.msg_buf), (Natural_8_bytes.to_natural_32 * (480).to_natural_32), l_tmp___5, globals_inst.sub_nsubs]).do_nothing
							end
							if globals_inst.sub_nlines = 1 then
								message_inst.vim_snprintf_add ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.msg_buf), (Natural_8_bytes.to_natural_32 * (480).to_natural_32), ce_string ("%%s"), (gettext (ce_string (" on 1 line")))]).do_nothing
							else
								message_inst.vim_snprintf_add ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.msg_buf), (Natural_8_bytes.to_natural_32 * (480).to_natural_32), (gettext (ce_string (" on %%ld lines"))), globals_inst.sub_nlines]).do_nothing
							end
							if (message_inst.msg (globals_inst.msg_buf)).to_boolean then
								message_inst.set_keep_msg (globals_inst.msg_buf, 0)
							end
							Result := 1
							js.return
						end
				when 5 then -- if done
						if not js.return_called and then (globals_inst.got_int.to_boolean) then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_interr))))).do_nothing
							Result := 1
							js.return
						end
						if not js.return_called then
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_global (a_eap: CE_POINTER [PD_EXARG])
		local
			l_lnum: INTEGER_32
			l_ndone: INTEGER_32
			l_type: INTEGER_32
			l_cmd: CE_POINTER [NATURAL_8]
			l_delim: NATURAL_8
			l_pat: CE_POINTER [NATURAL_8]
			l_regmatch___0: PD_REGMMATCH_T
			l_match: INTEGER_32
			l_which_pat: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_cmd.make
			create l_pat.make
			create l_regmatch___0.make
			create l_tmp___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ndone := 0
					if globals_inst.global_busy.to_boolean then
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E147: Cannot do :global recursive"))))).do_nothing
						js.return
					end
					if not js.return_called then
						if (a_eap.item.forceit).to_boolean then
							l_type := ('v').code
						else
							l_type := ((a_eap.item.cmd).item).to_integer_32
						end
						l_cmd.ce_gets (a_eap.item.arg)
						l_which_pat := 2
						if (l_cmd.item).to_integer_32 = 92 then
							l_cmd.ce_gets (l_cmd + 1)
							if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/?&")), (l_cmd.item).to_integer_32)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_backslash))))).do_nothing
								js.return
							end
							if not js.return_called then
								if (l_cmd.item).to_integer_32 = 38 then
									l_which_pat := 1
								else
									l_which_pat := 0
								end
								l_cmd.ce_gets (l_cmd + 1)
								l_pat.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
							end
						elseif (l_cmd.item).to_integer_32 = 0 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E148: Regular expression missing from global"))))).do_nothing
							js.return
						else
							l_delim := l_cmd.item
							if l_delim.to_boolean then
								l_cmd.ce_gets (l_cmd + 1)
							end
							l_pat.ce_gets (l_cmd)
							l_cmd.ce_gets (regexp_inst.skip_regexp (l_cmd, l_delim.to_integer_32, option_inst.p_magic, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (a_eap.c_pointer + {PD_EXARG}.arg_offset)))
							if (l_cmd[0]).to_integer_32 = l_delim.to_integer_32 then
								l_tmp___3.ce_gets (l_cmd)
								l_cmd.ce_gets (l_cmd + 1)
								l_tmp___3.item := (('%/0/').code).to_natural_8
							end
						end
					end
					if not js.return_called then
						if (search_inst.search_regcomp (l_pat, 2, l_which_pat, 32, l_regmatch___0.address)) = 0 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invcmd))))).do_nothing
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						l_lnum := a_eap.item.line1
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if l_lnum <= a_eap.item.line2 then
							if globals_inst.got_int.to_boolean then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						l_match := (regexp_inst.vim_regexec_multi (l_regmatch___0.address, globals_inst.curwin, globals_inst.curbuf, l_lnum, 0, create {CE_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))).to_integer_32
						if l_type /= 103 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_match.to_boolean then
							memline_inst.ml_setmarked (l_lnum)
							l_ndone := l_ndone + 1
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if l_type = 118 then
							if not l_match.to_boolean then
								memline_inst.ml_setmarked (l_lnum)
								l_ndone := l_ndone + 1
							end
						end
				when 8 then
						misc1_inst.line_breakcheck
						l_lnum := l_lnum + 1
				when 9 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						js.reset
						if globals_inst.got_int.to_boolean then
							message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_interr))))).do_nothing
						elseif l_ndone = 0 then
							if l_type = 118 then
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Pattern found in every line: %%s")))), l_pat]).do_nothing
							else
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_patnotf2)))), l_pat]).do_nothing
							end
						else
							global_exe (l_cmd)
						end
						memline_inst.ml_clearmarked
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_regmatch___0.regprog))
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_global_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_global)
		end

	global_exe (a_cmd: CE_POINTER [NATURAL_8])
		local
			l_old_lcount: INTEGER_32
			l_lnum: INTEGER_32
			js: JUMP_STATE
		do
			mark_inst.setpcmark
			globals_inst.msg_didout := 1
			globals_inst.sub_nsubs := 0
			globals_inst.sub_nlines := (0).to_integer_32
			global_need_beginline := 0
			globals_inst.global_busy := 1
			l_old_lcount := globals_inst.curbuf.item.b_ml.ml_line_count
			from
			until
				js.loop_left
			loop
				js.reset
				if not globals_inst.got_int.to_boolean then
					l_lnum := memline_inst.ml_firstmarked
					if l_lnum /= 0 then
						if globals_inst.global_busy /= 1 then
							js.break
						end
					else
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					globals_inst.curwin.item.w_cursor.lnum := l_lnum
					globals_inst.curwin.item.w_cursor.col := 0
					if (a_cmd.item).to_integer_32 = 0 then
						ex_docmd_inst.do_cmdline (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("p")), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 2).do_nothing
					elseif (a_cmd.item).to_integer_32 = 10 then
						ex_docmd_inst.do_cmdline (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("p")), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 2).do_nothing
					else
						ex_docmd_inst.do_cmdline (a_cmd, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 2).do_nothing
					end
					ui_inst.ui_breakcheck
				end
			end
			js.reset
			globals_inst.global_busy := 0
			if global_need_beginline.to_boolean then
				edit_inst.beginline (5)
			else
				misc2_inst.check_cursor
			end
			move_inst.changed_line_abv_curs
			if globals_inst.msg_col = 0 then
				if globals_inst.msg_scrolled = 0 then
					globals_inst.msg_didout := 0
				end
			end
			if not (do_sub_msg (0)).to_boolean then
				misc1_inst.msgmore (globals_inst.curbuf.item.b_ml.ml_line_count - l_old_lcount)
			end
		end

	read_viminfo_sub_string (a_virp: CE_POINTER [PD_VIR_T]; a_force: INTEGER_32): INTEGER_32
		do
			if (old_sub.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if a_force.to_boolean then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (old_sub))
				end
			end
			if a_force.to_boolean then
				old_sub.ce_gets (viminfo_readstring (a_virp, 1, 1))
			elseif (old_sub.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				old_sub.ce_gets (viminfo_readstring (a_virp, 1, 1))
			end
			Result := (viminfo_readline (a_virp))
		end

	write_viminfo_sub_string (a_fp: CE_POINTER [SD_IO_FILE])
		do
			if (option_inst.get_viminfo_parameter (('/').code)) /= 0 then
				if (old_sub.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					fputs ((gettext (ce_string ("%N# Last Substitute String:%N$"))), a_fp).do_nothing
					viminfo_writestring (a_fp, old_sub)
				end
			end
		end

	prepare_tagpreview (a_undo_sync: INTEGER_32): INTEGER_32
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_wp___0.make

			globals_inst.need_mouse_correct := 1
			if not (globals_inst.curwin.item.w_onebuf_opt.wo_pvw).to_boolean then
				l_wp___0.ce_gets (globals_inst.firstwin)
				from
				until
					not (not js.loop_left and then ((l_wp___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
				loop
					js.reset
					if (l_wp___0.item.w_onebuf_opt.wo_pvw).to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_wp___0.ce_gets (l_wp___0.item.w_next)
					end
				end
				js.reset
				if (l_wp___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					window_inst.win_enter (l_wp___0, a_undo_sync)
				else
					if globals_inst.g_do_tagpreview > 0 then
						l_tmp := globals_inst.g_do_tagpreview
					else
						l_tmp := 0
					end
					if (window_inst.win_split (l_tmp, 0)) = 0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						globals_inst.curwin.item.w_onebuf_opt.wo_pvw := 1
						globals_inst.curwin.item.w_onebuf_opt.wo_wfh := 1
						globals_inst.curwin.item.w_onebuf_opt.wo_scb := 0
						globals_inst.curwin.item.w_onebuf_opt.wo_diff := 0
						globals_inst.curwin.item.w_onebuf_opt.wo_fdc := 0
						Result := 1
						js.return
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	ex_help (a_eap: CE_POINTER [PD_EXARG])
		local
			l_arg: CE_POINTER [NATURAL_8]
			l_tag: CE_POINTER [NATURAL_8]
			l_helpfd: CE_POINTER [SD_IO_FILE]
			l_n: INTEGER_32
			l_i___0: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_num_matches___0: INTEGER_32
			l_matches___0: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_p___0: CE_POINTER [NATURAL_8]
			l_empty_fnum: INTEGER_32
			l_alt_fnum: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_len: INTEGER_32
			l_lang: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_arg.make
			create l_tag.make
			create l_helpfd.make
			create l_wp___0.make
			create l_matches___0.make
			create l_p___0.make
			create l_buf___6.make
			create l_lang.make
			create l_tmp.make
			create l_tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_empty_fnum := 0
					l_alt_fnum := 0
					if (a_eap.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_arg.ce_gets (a_eap.item.arg)
						from
						until
							not (not js.loop_left and then ((l_arg.item).to_boolean))
						loop
							js.reset
							if (l_arg.item).to_integer_32 = 10 then
								l_tmp.ce_gets (l_arg)
								l_arg.ce_gets (l_arg + 1)
								l_tmp.item := (('%/0/').code).to_natural_8
								a_eap.item.nextcmd := l_arg
								js.break
							elseif (l_arg.item).to_integer_32 = 13 then
								l_tmp.ce_gets (l_arg)
								l_arg.ce_gets (l_arg + 1)
								l_tmp.item := (('%/0/').code).to_natural_8
								a_eap.item.nextcmd := l_arg
								js.break
							elseif (l_arg.item).to_integer_32 = 124 then
								if (l_arg[1]).to_integer_32 /= 0 then
									if (l_arg[1]).to_integer_32 /= 124 then
										l_tmp.ce_gets (l_arg)
										l_arg.ce_gets (l_arg + 1)
										l_tmp.item := (('%/0/').code).to_natural_8
										a_eap.item.nextcmd := l_arg
										js.break
									end
								end
							end
							if not js.loop_jumped then
								l_arg.ce_gets (l_arg + 1)
							end
						end
						js.reset
						l_arg.ce_gets (a_eap.item.arg)
						if (a_eap.item.forceit).to_boolean then
							if (l_arg.item).to_integer_32 = 0 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E478: Don%'t panic!"))))).do_nothing
								js.return
							end
						end
						if not js.return_called and then ((a_eap.item.skip).to_boolean) then
							js.return
						end
					else
						l_arg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
					end
					if js.return_called then
						l_pos := -1 + 19 -- skip if block
					end
				when 1 then -- if:
						l_p___0.ce_gets ((l_arg + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg))).to_integer_32) - 1)
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 14 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_arg.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if (l_p___0.item).to_integer_32 /= 32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if (l_p___0.item).to_integer_32 /= 9 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L:
						if (l_p___0[-1]).to_integer_32 = 92 then
							js.break
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						js.break
				when 11 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						js.break
				when 13 then
						if not js.loop_jumped then
							l_tmp___2.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 - 1)
							l_tmp___2.item := (('%/0/').code).to_natural_8
						end
						l_pos := -1 + 2 -- back to loop condition
				when 14 then -- loop done
						js.reset
						l_lang.ce_gets (check_help_lang (l_arg))
						if (l_arg.item).to_integer_32 = 0 then
							l_arg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("help.txt")))
						end
						if (a_eap.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (a_eap.item.forceit).to_boolean then
								l_tmp___3 := 1
							else
								l_tmp___3 := 0
							end
						else
							l_tmp___3 := 0
						end
						l_n := find_help_tags (l_arg, create {CE_POINTER [INTEGER_32]}.make_shared ($l_num_matches___0), l_matches___0.address, l_tmp___3)
						l_i___0 := 0
						if l_n /= 0 then
							if (l_lang.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_i___0 := 0
								from
								until
									not (not js.loop_left and then (l_i___0 < l_num_matches___0))
								loop
									js.reset
									l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_matches___0[l_i___0]))).to_integer_32
									if l_len > 3 then
										if ((l_matches___0[l_i___0])[(l_len - 3)]).to_integer_32 = 64 then
											if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (((l_matches___0[l_i___0] + l_len) - 2)), create {CE_POINTER [INTEGER_8]}.make_cast (l_lang))) = 0 then
												js.break
											end
										end
									end
									if not js.loop_jumped then
										l_i___0 := l_i___0 + 1
									end
								end
								js.reset
							end
						end
						if not (l_i___0 >= l_num_matches___0) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 18 -- goto _L___0
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 17 then -- else:
						if l_n /= 0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 18 then -- if: | _L___0:
						if (l_lang.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							misc2_inst.emsg3 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E661: Sorry, no %'%%s%' help for %%s")))), l_lang, l_arg).do_nothing
						else
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E149: Sorry, no help for %%s")))), l_arg).do_nothing
						end
						if l_n /= 0 then
							misc1_inst.FreeWild (l_num_matches___0, l_matches___0)
						end
						js.return
				when 19 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 32 -- skip if block
						end
				when 20 then -- if:
							l_tag.ce_gets (misc2_inst.vim_strsave (l_matches___0[l_i___0]))
							misc1_inst.FreeWild (l_num_matches___0, l_matches___0)
							globals_inst.need_mouse_correct := 1
							if ((globals_inst.curwin.item.w_buffer).item.b_help).to_boolean then
								l_pos := -1 + 23 -- skip if block
							end
				when 21 then -- if:
							l_pos := -1 + 24 -- goto _L___2
				when 22 then -- if block done, skip else block:
							l_pos := -1 + 30
				when 23 then -- else:
							if globals_inst.cmdmod.tab = 0 then
								l_pos := -1 + 30 -- skip if block
							end
				when 24 then -- if: | _L___2:
							if globals_inst.cmdmod.tab /= 0 then
								l_wp___0.ce_gets (create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
							else
								l_wp___0.ce_gets (globals_inst.firstwin)
								from
								until
									not (not js.loop_left and then ((l_wp___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
								loop
									js.reset
									if ((l_wp___0.item.w_buffer).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										if ((l_wp___0.item.w_buffer).item.b_help).to_boolean then
											js.break
										end
									end
									if not js.loop_jumped then
										l_wp___0.ce_gets (l_wp___0.item.w_next)
									end
								end
								js.reset
							end
							if (l_wp___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_pos := -1 + 27 -- skip if block
							end
				when 25 then -- if:
							if (l_wp___0.item.w_buffer).item.b_nwindows > 0 then
								window_inst.win_enter (l_wp___0, 1)
							else
								l_pos := -1 + 27 -- goto _L___1
							end
				when 26 then -- if block done, skip else block:
							l_pos := -1 + 30
				when 27 then -- else: | _L___1:
							l_helpfd.ce_gets (fopen (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_hf), ce_string ("r")))
							if (l_helpfd.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Sorry, help file %"%%s%" not found")))), option_inst.p_hf]).do_nothing
								l_pos := -1 + 31 -- goto erret
							end
				when 28 then
							fclose (l_helpfd).do_nothing
							l_n := 16
							if globals_inst.cmdmod.split = 0 then
								if (globals_inst.curwin.item.w_width).to_integer_32 /= globals_inst.Columns then
									if globals_inst.curwin.item.w_width < 80 then
										l_n := (l_n).bit_or ((4))
									end
								end
							end
							if (window_inst.win_split (0, l_n)) = 0 then
								l_pos := -1 + 31 -- goto erret
							end
				when 29 then
							if (globals_inst.curwin.item.w_height).to_integer_32 < option_inst.p_hh then
								window_inst.win_setheight (option_inst.p_hh.to_integer_32)
							end
							l_alt_fnum := globals_inst.curbuf.item.b_fnum
							do_ecmd (0, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer), (0).to_integer_32, 3, create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)).do_nothing
							if not (globals_inst.cmdmod.keepalt).to_boolean then
								globals_inst.curwin.item.w_alt_fnum := l_alt_fnum
							end
							l_empty_fnum := globals_inst.curbuf.item.b_fnum
				when 30 then -- if done | if done
							if not option_inst.p_im.to_boolean then
								globals_inst.restart_edit := 0
							end
							if (l_tag.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								tag_inst.do_tag (l_tag, 8, 1, 0, 1).do_nothing
							end
							if l_empty_fnum /= 0 then
								if globals_inst.curbuf.item.b_fnum /= l_empty_fnum then
									l_buf___6.ce_gets (buffer_inst.buflist_findnr (l_empty_fnum))
									if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										if l_buf___6.item.b_nwindows = 0 then
											buffer_inst.wipe_buffer (l_buf___6, 1)
										end
									end
								end
							end
							if l_alt_fnum /= 0 then
								if globals_inst.curwin.item.w_alt_fnum = l_empty_fnum then
									if not (globals_inst.cmdmod.keepalt).to_boolean then
										globals_inst.curwin.item.w_alt_fnum := l_alt_fnum
									end
								end
							end
				when 31 then -- erret:
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tag))
				when 32 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_help_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_help)
		end

	check_help_lang (a_arg: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_arg))).to_integer_32
			if l_len >= 3 then
				if (a_arg[(l_len - 3)]).to_integer_32 = 64 then
					if (a_arg[(l_len - 2)]).to_integer_32 < 127 then
						if ((((ctype_b_loc).item[(a_arg[(l_len - 2)]).to_integer_32]).to_integer_32).bit_and (1024)).to_boolean then
							if (a_arg[(l_len - 1)]).to_integer_32 < 127 then
								if ((((ctype_b_loc).item[(a_arg[(l_len - 1)]).to_integer_32]).to_integer_32).bit_and (1024)).to_boolean then
									a_arg[(l_len - 3)] := (('%/0/').code).to_natural_8
									Result := ((a_arg + l_len) - 2)
									js.return
								end
							end
						end
					end
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	help_heuristic (a_matched_string: CE_POINTER [NATURAL_8]; a_offset: INTEGER_32; a_wrong_case: INTEGER_32): INTEGER_32
		local
			l_offset: INTEGER_32
			l_num_letters: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_offset := a_offset
					l_num_letters := 0
					l_p___0.ce_gets (a_matched_string)
					from
					until
						not ((l_p___0.item).to_boolean)
					loop
						if (l_p___0.item).to_integer_32 < 127 then
							if ((((ctype_b_loc).item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
								l_num_letters := l_num_letters + 1
							end
						end
						l_p___0.ce_gets (l_p___0 + 1)
					end
					if not ((a_matched_string[l_offset]).to_integer_32 < 127) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if ((((ctype_b_loc).item[(a_matched_string[l_offset]).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
							if l_offset > 0 then
								if (a_matched_string[(l_offset - 1)]).to_integer_32 < 127 then
									if ((((ctype_b_loc).item[(a_matched_string[(l_offset - 1)]).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
										l_offset := l_offset + (10000)
									else
										l_pos := -1 + 3 -- goto _L___1
									end
								else
									l_pos := -1 + 3 -- goto _L___1
								end
							else
								l_pos := -1 + 3 -- goto _L___1
							end
						else
							l_pos := -1 + 3 -- goto _L___1
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___1:
						if l_offset > 2 then
							l_offset := l_offset * (200)
						end
				when 4 then
					if a_wrong_case.to_boolean then
						l_offset := l_offset + (5000)
					end
					if (a_matched_string[0]).to_integer_32 = 43 then
						if (a_matched_string[1]).to_integer_32 /= 0 then
							l_offset := l_offset + (100)
						end
					end
					Result := (((100 * l_num_letters).to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_matched_string)))) + l_offset.to_natural_32).to_integer_32
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	help_compare (a_s1: CE_POINTER [ANY]; a_s2: CE_POINTER [ANY]): INTEGER_32
		local
			l_p1: CE_POINTER [INTEGER_8]
			l_p2: CE_POINTER [INTEGER_8]
		do
			create l_p1.make
			create l_p2.make

			l_p1.ce_gets (((create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast (a_s1)).item + (strlen ((create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast (a_s1)).item)).to_integer_32) + 1)
			l_p2.ce_gets (((create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast (a_s2)).item + (strlen ((create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast (a_s2)).item)).to_integer_32) + 1)
			Result := (strcmp (l_p1, l_p2))
		end

	help_compare_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent help_compare)
		end

	find_help_tags (a_arg: CE_POINTER [NATURAL_8]; a_num_matches___0: CE_POINTER [INTEGER_32]; a_matches___0: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_keep_lang: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_flags___0: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___14: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_d.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___7.make
			create l_tmp___8.make
			create l_tmp___9.make
			create l_tmp___10.make
			create l_tmp___14.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d.ce_gets (globals_inst.IObuff)
					l_i___0 := ((Pointer_bytes.to_natural_32 * (27).to_natural_32) // Pointer_bytes.to_natural_32).to_integer_32
					from
					until
						js.loop_left
					loop
						js.reset
						l_i___0 := l_i___0 - 1
						if not (l_i___0 >= 0) then
							js.break
						end
						if not js.loop_jumped then
							if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_arg), mtable[l_i___0])) = 0 then
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_d), rtable[l_i___0]).do_nothing
								js.break
							end
						end
					end
					js.reset
					if not (l_i___0 < 0) then
						l_pos := -1 + 41 -- skip if block
					end
				when 1 then -- if:
						if (a_arg[0]).to_integer_32 /= 92 then
							l_pos := -1 + 13 -- skip if block
						end
				when 2 then -- if:
						if (a_arg[1]).to_integer_32 = 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (a_arg[2]).to_integer_32 = 0 then
							l_pos := -1 + 7 -- goto _L___5
						else
							l_pos := -1 + 5 -- goto _L___6
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 5 then -- else: | _L___6:
						if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%%_z@")), (a_arg[1]).to_integer_32)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if:
						if (a_arg[2]).to_integer_32 = 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___5:
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_d), ce_string ("/\\")).do_nothing
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_d + 3)), create {CE_POINTER [INTEGER_8]}.make_cast ((a_arg + 1))).do_nothing
						if (l_d[3]).to_integer_32 = 95 then
							if (l_d[4]).to_integer_32 = 36 then
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_d + 4)), ce_string ("\$")).do_nothing
							end
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_pos := -1 + 13 -- goto _L___4
				when 10 then -- if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_pos := -1 + 13 -- goto _L___4
				when 12 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 41
				when 13 then -- else: | _L___4:
						if (a_arg[0]).to_integer_32 = 91 then
							if (a_arg[1]).to_integer_32 = 58 then
								l_tmp___0.ce_gets (l_d)
								l_d.ce_gets (l_d + 1)
								l_tmp___0.item := (('\').code).to_natural_8
							elseif (a_arg[1]).to_integer_32 = 43 then
								if (a_arg[2]).to_integer_32 = 43 then
									l_tmp___0.ce_gets (l_d)
									l_d.ce_gets (l_d + 1)
									l_tmp___0.item := (('\').code).to_natural_8
								end
							end
						end
						l_s.ce_gets (a_arg)
				when 14 then -- loop condition:
						if not (not js.loop_left and then ((l_s.item).to_boolean)) then
							l_pos := -1 + 40 -- skip loop
						end
				when 15 then -- loop body:
						js.reset
						if l_d.distance (globals_inst.IObuff) > 1015 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 22 -- skip if block
						end
				when 16 then -- if:
						inspect (l_s.item).to_integer_32 -- switch 1 head
						when 124 then l_pos := -1 + 17
						when 34 then l_pos := -1 + 18
						when 42 then l_pos := -1 + 19
						when 63 then l_pos := -1 + 20
						when 36 then l_pos := -1 + 21
						when 46 then l_pos := -1 + 21
						when 126 then l_pos := -1 + 21
						else l_pos := -1 + 22
						end
				when 17 then -- switch 1, case 124
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_d), ce_string ("bar")).do_nothing
						l_d.ce_gets (l_d + (3))
						js.continue
				when 18 then -- switch 1, case 34
						if not js.loop_jumped then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_d), ce_string ("quote")).do_nothing
							l_d.ce_gets (l_d + (5))
							js.continue
						end
				when 19 then -- switch 1, case 42
						if not js.loop_jumped then
							l_tmp___1.ce_gets (l_d)
							l_d.ce_gets (l_d + 1)
							l_tmp___1.item := (('.').code).to_natural_8
						end
						l_pos := -1 + 22 -- switch 1; break
				when 20 then -- switch 1, case 63
						l_tmp___2.ce_gets (l_d)
						l_d.ce_gets (l_d + 1)
						l_tmp___2.item := (('.').code).to_natural_8
						js.continue
				when 21 then -- switch 1, case 36 | switch 1, case 46 | switch 1, case 126
						if not js.loop_jumped then
							l_tmp___3.ce_gets (l_d)
							l_d.ce_gets (l_d + 1)
							l_tmp___3.item := (('\').code).to_natural_8
						end
						l_pos := -1 + 22 -- switch 1; break
				when 22 then -- switch 1, done: | if done
						if js.loop_jumped then
							l_pos := -1 + 39 -- skip if block
						end
				when 23 then -- if:
						if not ((l_s.item).to_integer_32 < 32) then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_pos := -1 + 32 -- goto _L___1
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 26 then -- else:
						if (l_s.item).to_integer_32 /= 94 then
							l_pos := -1 + 38 -- skip if block
						end
				when 27 then -- if:
						if not ((l_s[1]).to_boolean) then
							l_pos := -1 + 36 -- skip if block
						end
				when 28 then -- if:
						if not ((l_s[1]).to_integer_32 < 127) then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						if ((((ctype_b_loc).item[(l_s[1]).to_integer_32]).to_integer_32).bit_and (1024)).to_boolean then
							l_pos := -1 + 32 -- goto _L___1
						else
							l_pos := -1 + 31 -- goto _L___2
						end
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 35
				when 31 then -- else: | _L___2:
						if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("?@[\]^")), (l_s[1]).to_integer_32)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if: | _L___1:
						if (l_d.c_pointer.to_integer_32).to_natural_32 > (globals_inst.IObuff.c_pointer.to_integer_32).to_natural_32 then
							if (l_d[-1]).to_integer_32 /= 95 then
								l_tmp___4.ce_gets (l_d)
								l_d.ce_gets (l_d + 1)
								l_tmp___4.item := (('_').code).to_natural_8
							end
						end
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_d), ce_string ("CTRL-")).do_nothing
						l_d.ce_gets (l_d + (5))
						if (l_s.item).to_integer_32 < 32 then
							l_tmp___5.ce_gets (l_d)
							l_d.ce_gets (l_d + 1)
							l_tmp___5.item := ((l_s.item).to_integer_32 + 64).to_natural_8
							if (l_d[-1]).to_integer_32 = 92 then
								l_tmp___6.ce_gets (l_d)
								l_d.ce_gets (l_d + 1)
								l_tmp___6.item := (('\').code).to_natural_8
							end
						else
							l_tmp___7.ce_gets (l_d)
							l_d.ce_gets (l_d + 1)
							l_s.ce_gets (l_s + 1)
							l_tmp___7.item := l_s.item
						end
						if (l_s[1]).to_integer_32 /= 0 then
							if (l_s[1]).to_integer_32 /= 95 then
								l_tmp___8.ce_gets (l_d)
								l_d.ce_gets (l_d + 1)
								l_tmp___8.item := (('_').code).to_natural_8
							end
						end
						js.continue
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 35
				when 34 then -- else:
						l_pos := -1 + 38 -- goto _L___3
				when 35 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 37
				when 36 then -- else:
						l_pos := -1 + 38 -- goto _L___3
				when 37 then -- if done | if block done, skip else block:
						l_pos := -1 + 39
				when 38 then -- else: | _L___3:
						if (l_s.item).to_integer_32 = 94 then
							l_tmp___9.ce_gets (l_d)
							l_d.ce_gets (l_d + 1)
							l_tmp___9.item := (('\').code).to_natural_8
						elseif (l_s[0]).to_integer_32 = 92 then
							if (l_s[1]).to_integer_32 /= 92 then
								if (a_arg.item).to_integer_32 = 47 then
									if (l_s.c_pointer.to_integer_32).to_natural_32 = ((a_arg + 1).c_pointer.to_integer_32).to_natural_32 then
										l_tmp___10.ce_gets (l_d)
										l_d.ce_gets (l_d + 1)
										l_tmp___10.item := (('\').code).to_natural_8
									end
								end
							end
						end
				when 39 then -- if done | if done
						if not js.loop_jumped then
							if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("CTRL-\_"), (7).to_natural_32)) = 0 then
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_d), ce_string ("CTRL-\\")).do_nothing
								l_d.ce_gets (l_d + (7))
								l_s.ce_gets (l_s + (6))
							end
							l_tmp___14.ce_gets (l_d)
							l_d.ce_gets (l_d + 1)
							l_tmp___14.item := l_s.item
							if (l_s.item).to_integer_32 = 39 then
								if (l_s.c_pointer.to_integer_32).to_natural_32 > (a_arg.c_pointer.to_integer_32).to_natural_32 then
									if (a_arg.item).to_integer_32 = 39 then
										js.break
									end
								end
							end
						end
						if not js.loop_left then
							l_s.ce_gets (l_s + 1)
						end
						l_pos := -1 + 14 -- back to loop condition
				when 40 then -- loop done
						js.reset
						l_d.item := (('%/0/').code).to_natural_8
				when 41 then -- if done
						a_matches___0.item := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (ce_string (""))
						a_num_matches___0.item := 0
						l_flags___0 := 39
						if a_keep_lang.to_boolean then
							l_flags___0 := (l_flags___0).bit_or ((128))
						end
						if (tag_inst.find_tags (globals_inst.IObuff, a_num_matches___0, a_matches___0, l_flags___0, 2147483647, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))) = 1 then
							if a_num_matches___0.item > 0 then
								qsort (create {CE_POINTER [ANY]}.make_cast (a_matches___0.item), (a_num_matches___0.item).to_natural_32, Pointer_bytes.to_natural_32, help_compare_address)
								from
								until
									not (a_num_matches___0.item > 300)
								loop
									a_num_matches___0.item := (a_num_matches___0.item) - 1
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_matches___0.item[a_num_matches___0.item]))
								end
							end
						end
						Result := 1
				when 42 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	fix_help_buffer
		local
			l_lnum: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_in_example: INTEGER_32
			l_len: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_rt: CE_POINTER [NATURAL_8]
			l_mustfree: INTEGER_32
			l_fcount: INTEGER_32
			l_fnames: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_fd: CE_POINTER [SD_IO_FILE]
			l_s: CE_POINTER [NATURAL_8]
			l_fi: INTEGER_32
			l_vc: PD_VIMCONV_T
			l_cp: CE_POINTER [NATURAL_8]
			l_this_utf: INTEGER_32
			l_l: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_line.make
			create l_p___0.make
			create l_rt.make
			create l_fnames.make
			create l_fd.make
			create l_s.make
			create l_vc.make
			create l_cp.make
			create l_tmp___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_in_example := 0
					option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ft")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("help")), 4)
					if (syntax_inst.syntax_present (globals_inst.curwin)).to_boolean then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						l_lnum := (1).to_integer_32
				when 2 then -- loop condition:
						if not (l_lnum <= globals_inst.curbuf.item.b_ml.ml_line_count) then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						l_line.ce_gets (memline_inst.ml_get_buf (globals_inst.curbuf, l_lnum, 0))
						l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_line))).to_integer_32
						if l_in_example.to_boolean then
							if l_len > 0 then
								if (l_line[0]).to_integer_32 /= 32 then
									if (l_line[0]).to_integer_32 /= 9 then
										if (l_line[0]).to_integer_32 = 60 then
											l_line.ce_gets (memline_inst.ml_get_buf (globals_inst.curbuf, l_lnum, 1))
											l_line[0] := ((' ').code).to_natural_8
										end
										l_in_example := 0
									end
								end
							end
						end
						if l_in_example.to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if not (l_len > 0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 5 then -- if:
						if (l_line[(l_len - 1)]).to_integer_32 /= 62 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if l_len = 1 then
							l_line.ce_gets (memline_inst.ml_get_buf (globals_inst.curbuf, l_lnum, 1))
							l_line[(l_len - 1)] := ((' ').code).to_natural_8
							l_in_example := 1
						elseif (l_line[(l_len - 2)]).to_integer_32 = 32 then
							l_line.ce_gets (memline_inst.ml_get_buf (globals_inst.curbuf, l_lnum, 1))
							l_line[(l_len - 1)] := ((' ').code).to_natural_8
							l_in_example := 1
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if (l_line[(l_len - 1)]).to_integer_32 = 126 then
							l_line.ce_gets (memline_inst.ml_get_buf (globals_inst.curbuf, l_lnum, 1))
							l_line[(l_len - 1)] := ((' ').code).to_natural_8
						end
				when 9 then -- if done | if done
						l_lnum := l_lnum + 1
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done | if done
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast ((misc1_inst.gettail (globals_inst.curbuf.item.b_fname))), ce_string ("help.txt"))) = 0 then
							l_lnum := (1).to_integer_32
							from
							until
								not (not js.loop_left and then (l_lnum < globals_inst.curbuf.item.b_ml.ml_line_count))
							loop
								js.reset
								l_line.ce_gets (memline_inst.ml_get_buf (globals_inst.curbuf, l_lnum, 0))
								if ((strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_line), ce_string ("*local-additions*"))).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_p___0.ce_gets (option_inst.p_rtp)
									from
									until
										not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0))
									loop
										misc2_inst.copy_option_part (l_p___0.address, globals_inst.NameBuff, 4096, ce_string (",")).do_nothing
										l_mustfree := 0
										l_rt.ce_gets (misc1_inst.vim_getenv (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("VIMRUNTIME")), create {CE_POINTER [INTEGER_32]}.make_shared ($l_mustfree)))
										if (misc1_inst.fullpathcmp (l_rt, globals_inst.NameBuff, 0)) /= 1 then
											misc1_inst.add_pathsep (globals_inst.NameBuff)
											strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff), ce_string ("doc/*.txt")).do_nothing
											if (misc1_inst.gen_expand_wildcards (1, globals_inst.NameBuff.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_fcount), l_fnames.address, 34)) = 1 then
												if l_fcount > 0 then
													l_fi := 0
													from
													until
														not (not js.loop_left and then (l_fi < l_fcount))
													loop
														l_fd.ce_gets (fopen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fnames[l_fi]), ce_string ("r")))
														if (l_fd.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
															fileio_inst.vim_fgets (globals_inst.IObuff, 1025, l_fd).do_nothing
															if (globals_inst.IObuff[0]).to_integer_32 = 42 then
																l_s.ce_gets (misc2_inst.vim_strchr (globals_inst.IObuff + 1, ('*').code))
																if (l_s.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
																	l_this_utf := 2
																	globals_inst.IObuff[0] := (('|').code).to_natural_8
																	l_s.item := (('|').code).to_natural_8
																	from
																	until
																		(l_s.item).to_integer_32 = 0
																	loop
																		if (l_s.item).to_integer_32 = 13 then
																			l_s.item := (('%/0/').code).to_natural_8
																		elseif (l_s.item).to_integer_32 = 10 then
																			l_s.item := (('%/0/').code).to_natural_8
																		end
																		if (l_s.item).to_integer_32 >= 128 then
																			if l_this_utf /= 0 then
																				l_this_utf := 1
																				l_l := mbyte_inst.utf_ptr2len (l_s)
																				if l_l = 1 then
																					l_this_utf := 0
																				end
																				l_s.ce_gets (l_s + (l_l - 1))
																			end
																		end
																		l_s.ce_gets (l_s + 1)
																	end
																	l_vc.vc_type := 0
																	if l_this_utf = 1 then
																		l_tmp___1.ce_gets (ce_string ("utf-8"))
																	else
																		l_tmp___1.ce_gets (ce_string ("latin1"))
																	end
																	mbyte_inst.convert_setup (l_vc.address, create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___1), option_inst.p_enc).do_nothing
																	if l_vc.vc_type = 0 then
																		l_cp.ce_gets (globals_inst.IObuff)
																	else
																		l_cp.ce_gets (mbyte_inst.string_convert (l_vc.address, globals_inst.IObuff, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
																		if (l_cp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
																			l_cp.ce_gets (globals_inst.IObuff)
																		end
																	end
																	mbyte_inst.convert_setup (l_vc.address, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
																	memline_inst.ml_append (l_lnum, l_cp, 0, 0).do_nothing
																	if (l_cp.c_pointer.to_integer_32).to_natural_32 /= (globals_inst.IObuff.c_pointer.to_integer_32).to_natural_32 then
																		misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cp))
																	end
																	l_lnum := l_lnum + 1
																end
															end
															fclose (l_fd).do_nothing
														end
														l_fi := l_fi + 1
													end
													misc1_inst.FreeWild (l_fcount, l_fnames)
												end
											end
										end
										if l_mustfree.to_boolean then
											misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_rt))
										end
									end
									js.break
								end
								if not js.loop_jumped then
									l_lnum := l_lnum + 1
								end
							end
							js.reset
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_exusage (a_eap: CE_POINTER [PD_EXARG])
		do
			ex_docmd_inst.do_cmdline_cmd (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("help ex-cmd-index"))).do_nothing
		end

	ex_exusage_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_exusage)
		end

	ex_viusage (a_eap: CE_POINTER [PD_EXARG])
		do
			ex_docmd_inst.do_cmdline_cmd (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("help normal-index"))).do_nothing
		end

	ex_viusage_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_viusage)
		end

	ex_helptags (a_eap: CE_POINTER [PD_EXARG])
		local
			l_ga: PD_GROWARRAY
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_len: INTEGER_32
			l_lang: CE_ARRAY [NATURAL_8]
			l_xpc: PD_EXPAND
			l_dirname: CE_POINTER [NATURAL_8]
			l_ext: CE_ARRAY [NATURAL_8]
			l_fname: CE_ARRAY [NATURAL_8]
			l_filecount: INTEGER_32
			l_files: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_add_help_tags: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___6: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			js: JUMP_STATE
		do
			create l_ga.make
			create l_lang.make (<<2>>)
			create l_xpc.make
			create l_dirname.make
			create l_ext.make (<<5>>)
			create l_fname.make (<<8>>)
			create l_files.make
			create l_tmp___0.make

			l_add_help_tags := 0
			if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg), ce_string ("++t"), (3).to_natural_32)) = 0 then
				if (a_eap.item.arg[3]).to_integer_32 = 32 then
					l_add_help_tags := 1
					a_eap.item.arg := charset_inst.skipwhite (a_eap.item.arg + 3)
				elseif (a_eap.item.arg[3]).to_integer_32 = 9 then
					l_add_help_tags := 1
					a_eap.item.arg := charset_inst.skipwhite (a_eap.item.arg + 3)
				end
			end
			ex_getln_inst.ExpandInit (l_xpc.address)
			l_xpc.xp_context := 3
			l_dirname.ce_gets (ex_getln_inst.ExpandOne (l_xpc.address, a_eap.item.arg, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 65, 2))
			if (l_dirname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_tmp___0.ce_gets (gettext (ce_string ("E150: Not a directory: %%s")))
				message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___0), a_eap.item.arg).do_nothing
				js.return
			elseif not (os_unix_inst.mch_isdir (l_dirname)).to_boolean then
				l_tmp___0.ce_gets (gettext (ce_string ("E150: Not a directory: %%s")))
				message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___0), a_eap.item.arg).do_nothing
				js.return
			end
			if not js.return_called then
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff), create {CE_POINTER [INTEGER_8]}.make_cast (l_dirname)).do_nothing
				misc1_inst.add_pathsep (globals_inst.NameBuff)
				strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff), ce_string ("*")).do_nothing
				if (misc1_inst.gen_expand_wildcards (1, globals_inst.NameBuff.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_filecount), l_files.address, 34)) = 0 then
					message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E151: No match: %%s")), globals_inst.NameBuff).do_nothing
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_dirname))
					js.return
				elseif l_filecount = 0 then
					message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E151: No match: %%s")), globals_inst.NameBuff).do_nothing
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_dirname))
					js.return
				end
			end
			if not js.return_called then
				misc2_inst.ga_init2 (l_ga.address, 1, 10)
				l_i___0 := 0
				from
				until
					not (not js.loop_left and then (l_i___0 < l_filecount))
				loop
					js.reset
					l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_files[l_i___0]))).to_integer_32
					if l_len > 4 then
						if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (((l_files[l_i___0] + l_len) - 4)), ce_string (".txt"))) = 0 then
							l_lang[0] := (('e').code).to_natural_8
							l_lang[1] := (('n').code).to_natural_8
						elseif ((l_files[l_i___0])[(l_len - 4)]).to_integer_32 = 46 then
							if ((l_files[l_i___0])[(l_len - 3)]).to_integer_32 < 127 then
								if ((((ctype_b_loc).item[((l_files[l_i___0])[(l_len - 3)]).to_integer_32]).to_integer_32).bit_and (1024)).to_boolean then
									if ((l_files[l_i___0])[(l_len - 2)]).to_integer_32 < 127 then
										if ((((ctype_b_loc).item[((l_files[l_i___0])[(l_len - 2)]).to_integer_32]).to_integer_32).bit_and (1024)).to_boolean then
											if ((l_files[l_i___0])[(l_len - 1)]).to_integer_32 < 65 then
												l_tmp___6 := ((l_files[l_i___0])[(l_len - 1)]).to_integer_32
											elseif ((l_files[l_i___0])[(l_len - 1)]).to_integer_32 > 90 then
												l_tmp___6 := ((l_files[l_i___0])[(l_len - 1)]).to_integer_32
											else
												l_tmp___6 := ((l_files[l_i___0])[(l_len - 1)]).to_integer_32 + 32
											end
											if l_tmp___6 = 120 then
												if ((l_files[l_i___0])[(l_len - 3)]).to_integer_32 < 65 then
													l_lang[0] := (l_files[l_i___0])[(l_len - 3)]
												elseif ((l_files[l_i___0])[(l_len - 3)]).to_integer_32 > 90 then
													l_lang[0] := (l_files[l_i___0])[(l_len - 3)]
												else
													l_lang[0] := (((l_files[l_i___0])[(l_len - 3)]).to_integer_32 + 32).to_natural_8
												end
												if ((l_files[l_i___0])[(l_len - 2)]).to_integer_32 < 65 then
													l_lang[1] := (l_files[l_i___0])[(l_len - 2)]
												elseif ((l_files[l_i___0])[(l_len - 2)]).to_integer_32 > 90 then
													l_lang[1] := (l_files[l_i___0])[(l_len - 2)]
												else
													l_lang[1] := (((l_files[l_i___0])[(l_len - 2)]).to_integer_32 + 32).to_natural_8
												end
											else
												js.continue
											end
										else
											js.continue
										end
									else
										js.continue
									end
								else
									js.continue
								end
							else
								js.continue
							end
						else
							js.continue
						end
						if not js.loop_jumped then
							l_j := 0
							from
							until
								not (not js.loop_left and then (l_j < l_ga.ga_len))
							loop
								js.reset
								if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_lang), create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.ga_data) + l_j)), (2).to_natural_32)) = 0 then
									js.break
								end
								if not js.loop_jumped then
									l_j := l_j + (2)
								end
							end
							js.reset
							if l_j = l_ga.ga_len then
								if (misc2_inst.ga_grow (l_ga.address, 2)) = 0 then
									js.break
								end
								if not js.loop_jumped then
									l_tmp___10 := l_ga.ga_len
									l_ga.ga_len := (l_ga.ga_len) + 1
									create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.ga_data)[l_tmp___10] := l_lang[0]
									l_tmp___11 := l_ga.ga_len
									l_ga.ga_len := (l_ga.ga_len) + 1
									create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.ga_data)[l_tmp___11] := l_lang[1]
								end
							end
						end
					end
					if not js.loop_left then
						l_i___0 := l_i___0 + 1
					end
				end
				js.reset
				l_j := 0
				from
				until
					not (l_j < l_ga.ga_len)
				loop
					strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), ce_string ("tags-xx")).do_nothing
					l_fname[5] := create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.ga_data)[l_j]
					l_fname[6] := create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.ga_data)[(l_j + 1)]
					if (l_fname[5]).to_integer_32 = 101 then
						if (l_fname[6]).to_integer_32 = 110 then
							l_fname[4] := (('%/0/').code).to_natural_8
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_ext), ce_string (".txt")).do_nothing
						else
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_ext), ce_string (".xxx")).do_nothing
							l_ext[1] := l_fname[5]
							l_ext[2] := l_fname[6]
						end
					else
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_ext), ce_string (".xxx")).do_nothing
						l_ext[1] := l_fname[5]
						l_ext[2] := l_fname[6]
					end
					helptags_one (l_dirname, l_ext, l_fname, l_add_help_tags)
					l_j := l_j + (2)
				end
				misc2_inst.ga_clear (l_ga.address)
				misc1_inst.FreeWild (l_filecount, l_files)
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_dirname))
			end
		end

	ex_helptags_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_helptags)
		end

	helptags_one (a_dir___0: CE_POINTER [NATURAL_8]; a_ext: CE_POINTER [NATURAL_8]; a_tagfname: CE_POINTER [NATURAL_8]; a_add_help_tags: INTEGER_32)
		local
			l_fd_tags: CE_POINTER [SD_IO_FILE]
			l_fd: CE_POINTER [SD_IO_FILE]
			l_ga: PD_GROWARRAY
			l_filecount: INTEGER_32
			l_files: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_p1: CE_POINTER [NATURAL_8]
			l_p2: CE_POINTER [NATURAL_8]
			l_fi: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_fname: CE_POINTER [NATURAL_8]
			l_utf8: INTEGER_32
			l_this_utf8: INTEGER_32
			l_firstline: INTEGER_32
			l_mix: INTEGER_32
			l_l: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fd_tags.make
			create l_fd.make
			create l_ga.make
			create l_files.make
			create l_p1.make
			create l_p2.make
			create l_s.make
			create l_fname.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_utf8 := 2
					l_mix := 0
					strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff), create {CE_POINTER [INTEGER_8]}.make_cast (a_dir___0)).do_nothing
					misc1_inst.add_pathsep (globals_inst.NameBuff)
					strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff), ce_string ("*")).do_nothing
					strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff), create {CE_POINTER [INTEGER_8]}.make_cast (a_ext)).do_nothing
					if (misc1_inst.gen_expand_wildcards (1, globals_inst.NameBuff.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_filecount), l_files.address, 34)) /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_filecount /= 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if not globals_inst.got_int.to_boolean then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E151: No match: %%s")), globals_inst.NameBuff).do_nothing
						end
						js.return
				when 5 then -- if done
						if not js.return_called then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff), create {CE_POINTER [INTEGER_8]}.make_cast (a_dir___0)).do_nothing
							misc1_inst.add_pathsep (globals_inst.NameBuff)
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff), create {CE_POINTER [INTEGER_8]}.make_cast (a_tagfname)).do_nothing
							l_fd_tags.ce_gets (fopen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff), ce_string ("w")))
							if (l_fd_tags.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E152: Cannot open %%s for writing")))), globals_inst.NameBuff).do_nothing
								misc1_inst.FreeWild (l_filecount, l_files)
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 40 -- skip if block
						end
				when 6 then -- if:
							misc2_inst.ga_init2 (l_ga.address, (Pointer_bytes.to_natural_32).to_integer_32, 100)
							if not (a_add_help_tags.to_boolean) then
								l_pos := -1 + 9 -- skip if block
							end
				when 7 then -- if:
							l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
							l_pos := -1 + 11
				when 9 then -- else:
							if (misc1_inst.fullpathcmp (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("$VIMRUNTIME/doc")), a_dir___0, 0)) /= 1 then
								l_pos := -1 + 11 -- skip if block
							end
				when 10 then -- if: | _L___0:
							if (misc2_inst.ga_grow (l_ga.address, 1)) = 0 then
								globals_inst.got_int := 1
							else
								l_s.ce_gets (misc2_inst.alloc ({NATURAL_32} 18 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_tagfname)))))
								if (l_s.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									globals_inst.got_int := 1
								else
									sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("help-tags%T%%s%T1%N"), a_tagfname]).do_nothing
									create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_ga.ga_data)[l_ga.ga_len] := l_s
									l_ga.ga_len := (l_ga.ga_len) + 1
								end
							end
				when 11 then -- if done
							l_fi := 0
				when 12 then -- loop condition:
							if js.loop_left then
								l_pos := -1 + 39 -- skip loop
							end
				when 13 then -- loop body:
							js.reset
							if l_fi < l_filecount then
								if globals_inst.got_int.to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_fd.ce_gets (fopen (create {CE_POINTER [INTEGER_8]}.make_cast (l_files[l_fi]), ce_string ("r")))
								if (l_fd.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E153: Unable to open %%s for reading")))), l_files[l_fi]).do_nothing
									js.continue
								end
							end
							if js.loop_jumped then
								l_pos := -1 + 38 -- skip if block
							end
				when 14 then -- if:
							l_fname.ce_gets (misc1_inst.gettail (l_files[l_fi]))
							l_firstline := 1
				when 15 then -- loop condition:
							if js.loop_left then
								l_pos := -1 + 37 -- skip loop
							end
				when 16 then -- loop body:
							js.reset
							if (fileio_inst.vim_fgets (globals_inst.IObuff, 1025, l_fd)).to_boolean then
								js.break
							elseif globals_inst.got_int.to_boolean then
								js.break
							end
							if js.loop_jumped then
								l_pos := -1 + 36 -- skip if block
							end
				when 17 then -- if:
							if l_firstline.to_boolean then
								l_this_utf8 := 2
								l_s.ce_gets (globals_inst.IObuff)
								from
								until
									not (not js.loop_left and then ((l_s.item).to_integer_32 /= 0))
								loop
									js.reset
									if (l_s.item).to_integer_32 >= 128 then
										l_this_utf8 := 1
										l_l := mbyte_inst.utf_ptr2len (l_s)
										if l_l = 1 then
											l_this_utf8 := 0
											js.break
										end
										if not js.loop_jumped then
											l_s.ce_gets (l_s + (l_l - 1))
										end
									end
									if not js.loop_jumped then
										l_s.ce_gets (l_s + 1)
									end
								end
								js.reset
								if l_this_utf8 = 2 then
									l_this_utf8 := 0
								end
								if l_utf8 = 2 then
									l_utf8 := l_this_utf8
								elseif l_utf8 /= l_this_utf8 then
									message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E670: Mix of help file encodings within a language: %%s")))), l_files[l_fi]).do_nothing
									l_mix := (not globals_inst.got_int.to_boolean).to_integer
									globals_inst.got_int := 1
								end
								l_firstline := 0
							end
							l_p1.ce_gets (misc2_inst.vim_strchr (globals_inst.IObuff, ('*').code))
				when 18 then -- loop condition:
							if not (not js.loop_left and then ((l_p1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32)) then
								l_pos := -1 + 35 -- skip loop
							end
				when 19 then -- loop body:
							js.reset
							l_p2.ce_gets (misc2_inst.vim_strchr (l_p1 + 1, ('*').code))
							if (l_p2.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_pos := -1 + 34 -- skip if block
							end
				when 20 then -- if:
							if not ((l_p2.c_pointer.to_integer_32).to_natural_32 > ((l_p1 + 1).c_pointer.to_integer_32).to_natural_32) then
								l_pos := -1 + 34 -- skip if block
							end
				when 21 then -- if:
							l_s.ce_gets (l_p1 + 1)
							from
							until
								not (not js.loop_left and then ((l_s.c_pointer.to_integer_32).to_natural_32 < (l_p2.c_pointer.to_integer_32).to_natural_32))
							loop
								js.reset
								if (l_s.item).to_integer_32 = 32 then
									js.break
								elseif (l_s.item).to_integer_32 = 9 then
									js.break
								elseif (l_s.item).to_integer_32 = 124 then
									js.break
								end
								if not js.loop_jumped then
									l_s.ce_gets (l_s + 1)
								end
							end
							js.reset
							if (l_s.c_pointer.to_integer_32).to_natural_32 /= (l_p2.c_pointer.to_integer_32).to_natural_32 then
								l_pos := -1 + 34 -- skip if block
							end
				when 22 then -- if:
							if (l_p1.c_pointer.to_integer_32).to_natural_32 /= (globals_inst.IObuff.c_pointer.to_integer_32).to_natural_32 then
								l_pos := -1 + 25 -- skip if block
							end
				when 23 then -- if:
							l_pos := -1 + 29 -- goto _L___2
				when 24 then -- if block done, skip else block:
							l_pos := -1 + 34
				when 25 then -- else:
							if (l_p1[-1]).to_integer_32 /= 32 then
								l_pos := -1 + 28 -- skip if block
							end
				when 26 then -- if:
							l_pos := -1 + 29 -- goto _L___2
				when 27 then -- if block done, skip else block:
							l_pos := -1 + 34
				when 28 then -- else:
							if (l_p1[-1]).to_integer_32 /= 9 then
								l_pos := -1 + 34 -- skip if block
							end
				when 29 then -- if: | _L___2:
							if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" %T%N%R")), (l_s[1]).to_integer_32)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_pos := -1 + 32 -- skip if block
							end
				when 30 then -- if:
							l_pos := -1 + 33 -- goto _L___1
				when 31 then -- if block done, skip else block:
							l_pos := -1 + 34
				when 32 then -- else:
							if (l_s[1]).to_integer_32 /= 0 then
								l_pos := -1 + 34 -- skip if block
							end
				when 33 then -- if: | _L___1:
							l_p2.item := (('%/0/').code).to_natural_8
							l_p1.ce_gets (l_p1 + 1)
							if (misc2_inst.ga_grow (l_ga.address, 1)) = 0 then
								globals_inst.got_int := 1
								js.break
							end
							if not js.loop_jumped then
								l_s.ce_gets (misc2_inst.alloc (((l_p2.distance (l_p1)).to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname)))) + {NATURAL_32} 2))
								if (l_s.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									globals_inst.got_int := 1
									js.break
								end
							end
							if not js.loop_jumped then
								create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_ga.ga_data)[l_ga.ga_len] := l_s
								l_ga.ga_len := (l_ga.ga_len) + 1
								sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("%%s%T%%s"), l_p1, l_fname]).do_nothing
								l_p2.ce_gets (misc2_inst.vim_strchr (l_p2 + 1, ('*').code))
							end
				when 34 then -- if done | if done | if done | if done | if done | if done | if done
							if not js.loop_jumped then
								l_p1.ce_gets (l_p2)
							end
							l_pos := -1 + 18 -- back to loop condition
				when 35 then -- loop done
							js.reset
							misc1_inst.line_breakcheck
				when 36 then -- if done
							l_pos := -1 + 15 -- back to loop condition
				when 37 then -- loop done
							js.reset
							fclose (l_fd).do_nothing
				when 38 then -- if done
							if not js.loop_left then
								l_fi := l_fi + 1
							end
							l_pos := -1 + 12 -- back to loop condition
				when 39 then -- loop done
							js.reset
							misc1_inst.FreeWild (l_filecount, l_files)
							if not globals_inst.got_int.to_boolean then
								misc2_inst.sort_strings (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_ga.ga_data), l_ga.ga_len)
								l_i___0 := 1
								from
								until
									not (not js.loop_left and then (l_i___0 < l_ga.ga_len))
								loop
									l_p1.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_ga.ga_data)[(l_i___0 - 1)])
									l_p2.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_ga.ga_data)[l_i___0])
									from
									until
										not (not js.loop_left and then ((l_p1.item).to_integer_32 = (l_p2.item).to_integer_32))
									loop
										js.reset
										if (l_p2.item).to_integer_32 = 9 then
											l_p2.item := (('%/0/').code).to_natural_8
											message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff), (4096).to_natural_32, (gettext (ce_string ("E154: Duplicate tag %"%%s%" in file %%s/%%s"))), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_ga.ga_data)[l_i___0], a_dir___0, l_p2 + 1]).do_nothing
											message_inst.emsg (globals_inst.NameBuff).do_nothing
											l_p2.item := (('%T').code).to_natural_8
											js.break
										end
										if not js.loop_jumped then
											l_p1.ce_gets (l_p1 + 1)
											l_p2.ce_gets (l_p2 + 1)
										end
									end
									js.reset
									l_i___0 := l_i___0 + 1
								end
								if l_utf8 = 1 then
									fprintf ([l_fd_tags, ce_string ("!_TAG_FILE_ENCODING%Tutf-8%T//%N")]).do_nothing
								end
								l_i___0 := 0
								from
								until
									not (not js.loop_left and then (l_i___0 < l_ga.ga_len))
								loop
									l_s.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_ga.ga_data)[l_i___0])
									if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("help-tags%T"), (10).to_natural_32)) = 0 then
										fputs (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), l_fd_tags).do_nothing
									else
										fprintf ([l_fd_tags, ce_string ("%%s%T/*"), l_s]).do_nothing
										l_p1.ce_gets (l_s)
										from
										until
											(l_p1.item).to_integer_32 = 9
										loop
											if (l_p1.item).to_integer_32 = 92 then
												IO_putc (('\').code, l_fd_tags).do_nothing
											elseif (l_p1.item).to_integer_32 = 47 then
												IO_putc (('\').code, l_fd_tags).do_nothing
											end
											IO_putc ((l_p1.item).to_integer_32, l_fd_tags).do_nothing
											l_p1.ce_gets (l_p1 + 1)
										end
										fprintf ([l_fd_tags, ce_string ("*%N")]).do_nothing
									end
									l_i___0 := l_i___0 + 1
								end
							end
							if l_mix.to_boolean then
								globals_inst.got_int := 0
							end
							l_i___0 := 0
							from
							until
								not (l_i___0 < l_ga.ga_len)
							loop
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (l_ga.ga_data)[l_i___0]))
								l_i___0 := l_i___0 + 1
							end
							misc2_inst.ga_clear (l_ga.address)
							fclose (l_fd_tags).do_nothing
				when 40 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	sign_cmd_idx (a_begin_cmd: CE_POINTER [NATURAL_8]; a_end_cmd: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_idx: INTEGER_32
			l_save___0: INTEGER_8
			js: JUMP_STATE
		do
			l_save___0 := (a_end_cmd.item).to_integer_8
			a_end_cmd.item := (('%/0/').code).to_natural_8
			l_idx := 0
			from
			until
				js.loop_left
			loop
				js.reset
				if ((cmds[l_idx]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					js.break
				elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_begin_cmd), cmds[l_idx])) = 0 then
					js.break
				end
				if not js.loop_jumped then
					l_idx := l_idx + 1
				end
			end
			js.reset
			a_end_cmd.item := l_save___0.to_natural_8
			Result := l_idx
		end

	ex_sign (a_eap: CE_POINTER [PD_EXARG])
		local
			l_arg: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_idx: INTEGER_32
			l_sp: CE_POINTER [PD_SIGN]
			l_sp_prev: CE_POINTER [PD_SIGN]
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_lp: CE_POINTER [PD_SIGN]
			l_start___1: INTEGER_32
			l_tmp___5: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_cells: INTEGER_32
			l_len: INTEGER_32
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: INTEGER_32
			l_id: INTEGER_32
			l_lnum: INTEGER_32
			l_sign_name: CE_POINTER [NATURAL_8]
			l_arg1: CE_POINTER [NATURAL_8]
			l_tmp___23: CE_POINTER [NATURAL_8]
			l_tmp___33: CE_POINTER [INTEGER_8]
			l_tmp___34: CE_POINTER [INTEGER_8]
			l_cmd: CE_POINTER [NATURAL_8]
			l_tmp___39: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_arg.make
			create l_p___0.make
			create l_sp.make
			create l_sp_prev.make
			create l_buf___6.make
			create l_tmp___1.make
			create l_lp.make
			create l_s.make
			create l_tmp___11.make
			create l_sign_name.make
			create l_arg1.make
			create l_tmp___23.make
			create l_tmp___33.make
			create l_tmp___34.make
			create l_cmd.make
			create l_tmp___39.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_arg.ce_gets (a_eap.item.arg)
					l_p___0.ce_gets (charset_inst.skiptowhite (l_arg))
					l_idx := sign_cmd_idx (l_arg, l_p___0)
					if l_idx = 6 then
						message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E160: Unknown sign command: %%s")))), l_arg).do_nothing
						js.return
					end
					if js.return_called then
						l_pos := -1 + 30 -- skip if block
					end
				when 1 then -- if:
						l_arg.ce_gets (charset_inst.skipwhite (l_p___0))
						if not (l_idx <= 2) then
							l_pos := -1 + 19 -- skip if block
						end
				when 2 then -- if:
						if l_idx /= 2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (l_arg.item).to_integer_32 = 0 then
							l_sp.ce_gets (first_sign)
							from
							until
								(l_sp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
							loop
								sign_list_defined (l_sp)
								l_sp.ce_gets (l_sp.item.sn_next)
							end
						else
							l_pos := -1 + 5 -- goto _L___0
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 5 then -- else: | _L___0:
						if (l_arg.item).to_integer_32 /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E156: Missing sign name"))))).do_nothing
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 8 then -- else:
						l_p___0.ce_gets (charset_inst.skiptowhite (l_arg))
						if (l_p___0.item).to_integer_32 /= 0 then
							l_tmp___1.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___1.item := (('%/0/').code).to_natural_8
						end
						l_sp_prev.ce_gets (create {CE_POINTER [PD_SIGN]}.make_shared (default_pointer))
						l_sp.ce_gets (first_sign)
						from
						until
							not (not js.loop_left and then ((l_sp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
						loop
							js.reset
							if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_sp.item.sn_name), create {CE_POINTER [INTEGER_8]}.make_cast (l_arg))) = 0 then
								js.break
							end
							if not js.loop_jumped then
								l_sp_prev.ce_gets (l_sp)
								l_sp.ce_gets (l_sp.item.sn_next)
							end
						end
						js.reset
						if l_idx /= 0 then
							l_pos := -1 + 17 -- skip if block
						end
				when 9 then -- if:
						if (l_sp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if:
						l_sp.ce_gets (create {CE_POINTER [PD_SIGN]}.make_cast ((misc2_inst.alloc_clear ({PD_SIGN}.sizeof.to_natural_32))))
						if (l_sp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.return
						end
						if js.return_called then
							l_pos := -1 + 15 -- skip if block
						end
				when 11 then -- if:
						if (l_sp_prev.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							first_sign.ce_gets (l_sp)
						else
							l_sp_prev.item.sn_next := l_sp
						end
						l_sp.item.sn_name := misc2_inst.vim_strnsave (l_arg, l_p___0.distance (l_arg))
						if not ((l_arg.item).to_integer_32 >= 48) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if (l_arg.item).to_integer_32 <= 57 then
							l_sp.item.sn_typenr := atoi (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg))
						else
							l_pos := -1 + 14 -- goto _L
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else: | _L:
						l_start___1 := last_sign_typenr
						l_lp.ce_gets (first_sign)
						from
						until
							not (not js.loop_left and then ((l_lp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
						loop
							js.reset
							if l_lp.item.sn_typenr = last_sign_typenr then
								last_sign_typenr := last_sign_typenr - 1
								if last_sign_typenr = 0 then
									last_sign_typenr := 65535
								end
								if last_sign_typenr = l_start___1 then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E612: Too many signs defined"))))).do_nothing
									js.return
								end
								if not js.return_called then
									l_lp.ce_gets (first_sign)
									js.continue
								end
							end
							if not js.loop_left then
								l_lp.ce_gets (l_lp.item.sn_next)
							end
						end
						if not js.return_called then
							l_tmp___5 := last_sign_typenr
							last_sign_typenr := last_sign_typenr - 1
							l_sp.item.sn_typenr := l_tmp___5
							if last_sign_typenr = 0 then
								last_sign_typenr := 65535
							end
						end
				when 15 then -- if done | if done
						if not js.return_called then
							from
							until
								js.loop_left
							loop
								js.reset
								l_arg.ce_gets (charset_inst.skipwhite (l_p___0))
								if (l_arg.item).to_integer_32 = 0 then
									js.break
								end
								if not js.loop_jumped then
									l_p___0.ce_gets (charset_inst.skiptowhite_esc (l_arg))
									if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("icon="), (5).to_natural_32)) = 0 then
										l_arg.ce_gets (l_arg + (5))
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_sp.item.sn_icon))
										l_sp.item.sn_icon := misc2_inst.vim_strnsave (l_arg, l_p___0.distance (l_arg))
										charset_inst.backslash_halve (l_sp.item.sn_icon)
										if (gui_inst.gui.in_use).to_boolean then
											term_inst.out_flush
											if ((l_sp.item.sn_image).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
												gui_gtk_x11_inst.gui_mch_destroy_sign (l_sp.item.sn_image)
											end
											l_sp.item.sn_image := gui_gtk_x11_inst.gui_mch_register_sign (l_sp.item.sn_icon)
										end
									elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("text="), (5).to_natural_32)) = 0 then
										l_arg.ce_gets (l_arg + (5))
										if globals_inst.has_mbyte.to_boolean then
											l_cells := 0
											l_s.ce_gets (l_arg)
											from
											until
												not (not js.loop_left and then ((l_s.c_pointer.to_integer_32).to_natural_32 < (l_p___0.c_pointer.to_integer_32).to_natural_32))
											loop
												js.reset
												if not (charset_inst.vim_isprintc ((globals_inst.mb_ptr2char.integer_32_item ([l_s])))).to_boolean then
													js.break
												end
												if not js.loop_jumped then
													l_cells := l_cells + (globals_inst.mb_ptr2cells.integer_32_item ([l_s]))
													l_s.ce_gets (l_s + (globals_inst.mb_ptr2len.integer_32_item ([l_s])))
												end
											end
											js.reset
										else
											l_s.ce_gets (l_arg)
											from
											until
												not (not js.loop_left and then ((l_s.c_pointer.to_integer_32).to_natural_32 < (l_p___0.c_pointer.to_integer_32).to_natural_32))
											loop
												js.reset
												if not (charset_inst.vim_isprintc ((l_s.item).to_integer_32)).to_boolean then
													js.break
												end
												if not js.loop_jumped then
													l_s.ce_gets (l_s + 1)
												end
											end
											js.reset
											l_cells := l_s.distance (l_arg)
										end
										if (l_s.c_pointer.to_integer_32).to_natural_32 /= (l_p___0.c_pointer.to_integer_32).to_natural_32 then
											l_p___0.item := (('%/0/').code).to_natural_8
											l_tmp___11.ce_gets (gettext (ce_string ("E239: Invalid sign text: %%s")))
											message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___11), l_arg).do_nothing
											js.return
										elseif l_cells < 1 then
											l_p___0.item := (('%/0/').code).to_natural_8
											l_tmp___11.ce_gets (gettext (ce_string ("E239: Invalid sign text: %%s")))
											message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___11), l_arg).do_nothing
											js.return
										elseif l_cells > 2 then
											l_p___0.item := (('%/0/').code).to_natural_8
											l_tmp___11.ce_gets (gettext (ce_string ("E239: Invalid sign text: %%s")))
											message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___11), l_arg).do_nothing
											js.return
										end
										if not js.return_called then
											misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_sp.item.sn_text))
											if l_cells = 1 then
												l_tmp___12 := 1
											else
												l_tmp___12 := 0
											end
											l_len := (l_p___0.distance (l_arg)) + l_tmp___12
											l_sp.item.sn_text := misc2_inst.vim_strnsave (l_arg, l_len)
											if ((l_sp.item.sn_text).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
												if l_cells = 1 then
													strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (((l_sp.item.sn_text + l_len) - 1)), ce_string (" ")).do_nothing
												end
											end
										end
									elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("linehl="), (7).to_natural_32)) = 0 then
										l_arg.ce_gets (l_arg + (7))
										l_sp.item.sn_line_hl := syntax_inst.syn_check_group (l_arg, l_p___0.distance (l_arg))
									elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("texthl="), (7).to_natural_32)) = 0 then
										l_arg.ce_gets (l_arg + (7))
										l_sp.item.sn_text_hl := syntax_inst.syn_check_group (l_arg, l_p___0.distance (l_arg))
									else
										message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg2)))), l_arg).do_nothing
										js.return
									end
								end
							end
							js.reset
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						if (l_sp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E155: Unknown sign: %%s")))), l_arg).do_nothing
						elseif l_idx = 2 then
							sign_list_defined (l_sp)
						else
							sign_undefine (l_sp, l_sp_prev)
						end
				when 18 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 30
				when 19 then -- else:
						l_id := -1
						l_lnum := (-1).to_integer_32
						l_sign_name.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						if (l_arg.item).to_integer_32 = 0 then
							if l_idx = 3 then
								buffer_inst.sign_list_placed (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
							elseif l_idx = 4 then
								l_id := buffer_inst.buf_findsign_id (globals_inst.curwin.item.w_buffer, globals_inst.curwin.item.w_cursor.lnum)
								if l_id > 0 then
									buffer_inst.buf_delsign (globals_inst.curwin.item.w_buffer, l_id).do_nothing
									screen_inst.update_debug_sign (globals_inst.curwin.item.w_buffer, globals_inst.curwin.item.w_cursor.lnum)
								else
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E159: Missing sign number"))))).do_nothing
								end
							else
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_argreq))))).do_nothing
							end
							js.return
						end
						if not js.return_called and then (l_idx = 4) then
							if (l_arg[0]).to_integer_32 = 42 then
								if (l_arg[1]).to_integer_32 = 0 then
									buffer_inst.buf_delete_all_signs
									js.return
								end
							end
						end
						if js.return_called then
							l_pos := -1 + 29 -- skip if block
						end
				when 20 then -- if:
						l_arg1.ce_gets (l_arg)
						if not ((l_arg.item).to_integer_32 >= 48) then
							l_pos := -1 + 29 -- skip if block
						end
				when 21 then -- if:
						if not ((l_arg.item).to_integer_32 <= 57) then
							l_pos := -1 + 29 -- skip if block
						end
				when 22 then -- if:
						l_id := (charset_inst.getdigits (l_arg.address)).to_integer_32
						if (l_arg.item).to_integer_32 /= 32 then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 26 -- goto _L___2
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 25 then -- else:
						if (l_arg.item).to_integer_32 /= 9 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if: | _L___2:
						l_arg.ce_gets (charset_inst.skipwhite (l_arg))
						if l_idx = 4 then
							if (l_arg.item).to_integer_32 = 0 then
								l_buf___6.ce_gets (globals_inst.firstbuf)
								from
								until
									(l_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
								loop
									l_lnum := buffer_inst.buf_delsign (l_buf___6, l_id)
									if l_lnum /= 0 then
										screen_inst.update_debug_sign (l_buf___6, l_lnum)
									end
									l_buf___6.ce_gets (l_buf___6.item.b_next)
								end
								js.return
							end
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:
						if (l_arg.item).to_integer_32 /= 0 then
							l_id := -1
							l_arg.ce_gets (l_arg1)
						else
							l_pos := -1 + 26 -- goto _L___2
						end
				when 29 then -- if done | if done | if done | if done
						if not js.return_called then
							from
							until
								js.loop_left
							loop
								js.reset
								if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("line="), (5).to_natural_32)) = 0 then
									l_arg.ce_gets (l_arg + (5))
									l_lnum := (atoi (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg))).to_integer_32
									l_arg.ce_gets (charset_inst.skiptowhite (l_arg))
								elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("name="), (5).to_natural_32)) = 0 then
									l_arg.ce_gets (l_arg + (5))
									l_sign_name.ce_gets (l_arg)
									l_arg.ce_gets (charset_inst.skiptowhite (l_arg))
									if (l_arg.item).to_integer_32 /= 0 then
										l_tmp___23.ce_gets (l_arg)
										l_arg.ce_gets (l_arg + 1)
										l_tmp___23.item := (('%/0/').code).to_natural_8
									end
								elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("file="), (5).to_natural_32)) = 0 then
									l_arg.ce_gets (l_arg + (5))
									l_buf___6.ce_gets (buffer_inst.buflist_findname (l_arg))
									js.break
								elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("buffer="), (7).to_natural_32)) = 0 then
									l_arg.ce_gets (l_arg + (7))
									l_buf___6.ce_gets (buffer_inst.buflist_findnr ((charset_inst.getdigits (l_arg.address)).to_integer_32))
									if ((charset_inst.skipwhite (l_arg)).item).to_integer_32 /= 0 then
										message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_trailing))))).do_nothing
									end
									js.break
								else
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg))))).do_nothing
									js.return
								end
								if not js.loop_jumped then
									l_arg.ce_gets (charset_inst.skipwhite (l_arg))
								end
							end
							js.reset
						end
						if not js.return_called then
							if (l_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E158: Invalid buffer name: %%s")))), l_arg).do_nothing
							elseif l_id <= 0 then
								if l_lnum >= 0 then
									l_tmp___33.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg)))
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___33)).do_nothing
								elseif (l_sign_name.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_tmp___33.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg)))
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___33)).do_nothing
								else
									buffer_inst.sign_list_placed (l_buf___6)
								end
							elseif l_idx = 5 then
								if l_lnum >= 0 then
									l_tmp___34.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg)))
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___34)).do_nothing
								elseif (l_sign_name.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_tmp___34.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg)))
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___34)).do_nothing
								else
									l_lnum := (buffer_inst.buf_findsign (l_buf___6, l_id)).to_integer_32
									if l_lnum > 0 then
										if ((window_inst.buf_jump_open_win (l_buf___6)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
											globals_inst.curwin.item.w_cursor.lnum := l_lnum
											misc2_inst.check_cursor_lnum
											edit_inst.beginline (1)
										else
											l_cmd.ce_gets (misc2_inst.alloc ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6.item.b_fname))) + {NATURAL_32} 25))
											if (l_cmd.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
												js.return
											end
											if not js.return_called then
												sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_cmd), ce_string ("e +%%ld %%s"), l_lnum, l_buf___6.item.b_fname]).do_nothing
												ex_docmd_inst.do_cmdline_cmd (l_cmd).do_nothing
												misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cmd))
											end
										end
										if not js.return_called then
											fold_inst.foldOpenCursor
										end
									else
										misc2_inst.emsgn (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E157: Invalid sign ID: %%ld")))), l_id.to_integer_32).do_nothing
									end
								end
							elseif l_idx = 4 then
								if l_lnum >= 0 then
									l_tmp___39.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg)))
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___39)).do_nothing
								elseif (l_sign_name.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_tmp___39.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg)))
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___39)).do_nothing
								else
									l_lnum := buffer_inst.buf_delsign (l_buf___6, l_id)
									screen_inst.update_debug_sign (l_buf___6, l_lnum)
								end
							elseif (l_sign_name.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_sp.ce_gets (first_sign)
								from
								until
									not (not js.loop_left and then ((l_sp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
								loop
									js.reset
									if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_sp.item.sn_name), create {CE_POINTER [INTEGER_8]}.make_cast (l_sign_name))) = 0 then
										js.break
									end
									if not js.loop_jumped then
										l_sp.ce_gets (l_sp.item.sn_next)
									end
								end
								js.reset
								if (l_sp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E155: Unknown sign: %%s")))), l_sign_name).do_nothing
									js.return
								end
								if not js.return_called then
									if l_lnum > 0 then
										buffer_inst.buf_addsign (l_buf___6, l_id, l_lnum, l_sp.item.sn_typenr)
									else
										l_lnum := buffer_inst.buf_change_sign_type (l_buf___6, l_id, l_sp.item.sn_typenr)
									end
									screen_inst.update_debug_sign (l_buf___6, l_lnum)
								end
							else
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg))))).do_nothing
							end
						end
				when 30 then -- if done
						if not js.return_called then
						end
				when 31 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_sign_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_sign)
		end

	sign_gui_started
		local
			l_sp: CE_POINTER [PD_SIGN]
		do
			create l_sp.make

			l_sp.ce_gets (first_sign)
			from
			until
				(l_sp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
			loop
				if ((l_sp.item.sn_icon).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					l_sp.item.sn_image := gui_gtk_x11_inst.gui_mch_register_sign (l_sp.item.sn_icon)
				end
				l_sp.ce_gets (l_sp.item.sn_next)
			end
		end

	sign_list_defined (a_sp: CE_POINTER [PD_SIGN])
		local
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make

			message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("sign %%s")), a_sp.item.sn_name]).do_nothing
			if ((a_sp.item.sn_icon).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" icon=")))
				message_inst.msg_outtrans (a_sp.item.sn_icon).do_nothing
				if ((a_sp.item.sn_image).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string (" (NOT FOUND)")))))
				end
			end
			if ((a_sp.item.sn_text).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" text=")))
				message_inst.msg_outtrans (a_sp.item.sn_text).do_nothing
			end
			if a_sp.item.sn_line_hl > 0 then
				message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" linehl=")))
				l_p___0.ce_gets (syntax_inst.get_highlight_name (create {CE_POINTER [PD_EXPAND]}.make_shared (default_pointer), a_sp.item.sn_line_hl - 1))
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("NONE")))
				else
					message_inst.msg_puts (l_p___0)
				end
			end
			if a_sp.item.sn_text_hl > 0 then
				message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" texthl=")))
				l_p___0.ce_gets (syntax_inst.get_highlight_name (create {CE_POINTER [PD_EXPAND]}.make_shared (default_pointer), a_sp.item.sn_text_hl - 1))
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("NONE")))
				else
					message_inst.msg_puts (l_p___0)
				end
			end
		end

	sign_undefine (a_sp: CE_POINTER [PD_SIGN]; a_sp_prev: CE_POINTER [PD_SIGN])
		do
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_sp.item.sn_name))
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_sp.item.sn_icon))
			if ((a_sp.item.sn_image).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				term_inst.out_flush
				gui_gtk_x11_inst.gui_mch_destroy_sign (a_sp.item.sn_image)
			end
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_sp.item.sn_text))
			if (a_sp_prev.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				first_sign.ce_gets (a_sp.item.sn_next)
			else
				a_sp_prev.item.sn_next := a_sp.item.sn_next
			end
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_sp))
		end

	sign_get_attr (a_typenr: INTEGER_32; a_line: INTEGER_32): INTEGER_32
		local
			l_sp: CE_POINTER [PD_SIGN]
			js: JUMP_STATE
		do
			create l_sp.make

			l_sp.ce_gets (first_sign)
			from
			until
				not (not js.loop_left and then ((l_sp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				js.reset
				if l_sp.item.sn_typenr = a_typenr then
					if a_line.to_boolean then
						if l_sp.item.sn_line_hl > 0 then
							Result := (syntax_inst.syn_id2attr (l_sp.item.sn_line_hl))
							js.return
						end
					elseif l_sp.item.sn_text_hl > 0 then
						Result := (syntax_inst.syn_id2attr (l_sp.item.sn_text_hl))
						js.return
					end
					if not js.return_called then
						js.break
					end
				end
				if not js.loop_jumped then
					l_sp.ce_gets (l_sp.item.sn_next)
				end
			end
			js.reset
			if not js.return_called then
				Result := 0
			end
		end

	sign_get_text (a_typenr: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_sp: CE_POINTER [PD_SIGN]
			js: JUMP_STATE
		do
			create l_sp.make

			l_sp.ce_gets (first_sign)
			from
			until
				not (not js.loop_left and then ((l_sp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				if l_sp.item.sn_typenr = a_typenr then
					Result := (l_sp.item.sn_text)
					js.return
				end
				if not js.return_called then
					l_sp.ce_gets (l_sp.item.sn_next)
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	sign_get_image (a_typenr: INTEGER_32): CE_POINTER [ANY]
		local
			l_sp: CE_POINTER [PD_SIGN]
			js: JUMP_STATE
		do
			create l_sp.make

			l_sp.ce_gets (first_sign)
			from
			until
				not (not js.loop_left and then ((l_sp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				if l_sp.item.sn_typenr = a_typenr then
					Result := (l_sp.item.sn_image)
					js.return
				end
				if not js.return_called then
					l_sp.ce_gets (l_sp.item.sn_next)
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
			end
		end

	sign_typenr2name (a_typenr: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_sp: CE_POINTER [PD_SIGN]
			js: JUMP_STATE
		do
			create l_sp.make

			l_sp.ce_gets (first_sign)
			from
			until
				not (not js.loop_left and then ((l_sp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				if l_sp.item.sn_typenr = a_typenr then
					Result := (l_sp.item.sn_name)
					js.return
				end
				if not js.return_called then
					l_sp.ce_gets (l_sp.item.sn_next)
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("[Deleted]")))))
			end
		end

	get_sign_name (a_xp: CE_POINTER [PD_EXPAND]; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_sp: CE_POINTER [PD_SIGN]
			l_current_idx: INTEGER_32
			l_define_arg: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_place_arg: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_unplace_arg: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_sp.make
			create l_define_arg.make (<<5>>)
			create l_place_arg.make (<<5>>)
			create l_unplace_arg.make (<<3>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect expand_what -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 4
					when 4 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 1 then -- switch 1, case 0
					Result := (create {CE_POINTER [NATURAL_8]}.make_cast (cmds[a_idx]))
					js.return
				when 2 then -- switch 1, case 1
					if not js.return_called then
						l_define_arg[0] := ce_string ("icon=")
						l_define_arg[1] := ce_string ("linehl=")
						l_define_arg[2] := ce_string ("text=")
						l_define_arg[3] := ce_string ("texthl=")
						l_define_arg[4] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						Result := (create {CE_POINTER [NATURAL_8]}.make_cast (l_define_arg[a_idx]))
						js.return
					end
				when 3 then -- switch 1, case 2
					if not js.return_called then
						l_place_arg[0] := ce_string ("line=")
						l_place_arg[1] := ce_string ("name=")
						l_place_arg[2] := ce_string ("file=")
						l_place_arg[3] := ce_string ("buffer=")
						l_place_arg[4] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						Result := (create {CE_POINTER [NATURAL_8]}.make_cast (l_place_arg[a_idx]))
						js.return
					end
				when 4 then -- switch 1, case 3
					if not js.return_called then
						l_unplace_arg[0] := ce_string ("file=")
						l_unplace_arg[1] := ce_string ("buffer=")
						l_unplace_arg[2] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						Result := (create {CE_POINTER [NATURAL_8]}.make_cast (l_unplace_arg[a_idx]))
						js.return
					end
				when 5 then -- switch 1, case 4
					if not js.return_called then
						l_current_idx := 0
						l_sp.ce_gets (first_sign)
						from
						until
							not (not js.loop_left and then ((l_sp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
						loop
							l_tmp := l_current_idx
							l_current_idx := l_current_idx + 1
							if l_tmp = a_idx then
								Result := (l_sp.item.sn_name)
								js.return
							end
							if not js.return_called then
								l_sp.ce_gets (l_sp.item.sn_next)
							end
						end
					end
					if not js.return_called then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
				when 6 then -- switch 1, default:
					if not js.return_called then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					end
				when 7 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_sign_name_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent get_sign_name)
		end

	set_context_in_sign_cmd (a_xp: CE_POINTER [PD_EXPAND]; a_arg: CE_POINTER [NATURAL_8])
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_end_subcmd: CE_POINTER [NATURAL_8]
			l_last: CE_POINTER [NATURAL_8]
			l_cmd_idx: INTEGER_32
			l_begin_subcmd_args: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_end_subcmd.make
			create l_last.make
			create l_begin_subcmd_args.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					a_xp.item.xp_context := 34
					expand_what := {PC_EXPAND_WHAT}.EXP_SUBCMD
					a_xp.item.xp_pattern := a_arg
					l_end_subcmd.ce_gets (charset_inst.skiptowhite (a_arg))
					if (l_end_subcmd.item).to_integer_32 = 0 then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_cmd_idx := sign_cmd_idx (a_arg, l_end_subcmd)
						l_begin_subcmd_args.ce_gets (charset_inst.skipwhite (l_end_subcmd))
						l_p___0.ce_gets (charset_inst.skiptowhite (l_begin_subcmd_args))
						if (l_p___0.item).to_integer_32 /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 2 then -- if:
						a_xp.item.xp_pattern := l_begin_subcmd_args
						inspect l_cmd_idx -- switch 1 head
						when 2 then l_pos := -1 + 3
						when 1 then l_pos := -1 + 3
						else l_pos := -1 + 4
						end
				when 3 then -- switch 1, case 2 | switch 1, case 1
						expand_what := {PC_EXPAND_WHAT}.EXP_SIGN_NAMES
						l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, default:
						a_xp.item.xp_context := 0
				when 5 then -- switch 1, done:
						js.return
				when 6 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 18 -- skip if block
						end
				when 7 then -- if:
							from
							until
								js.loop_left
							loop
								js.reset
								l_p___0.ce_gets (charset_inst.skipwhite (l_p___0))
								l_last.ce_gets (l_p___0)
								l_p___0.ce_gets (charset_inst.skiptowhite (l_p___0))
								if (l_p___0.item).to_integer_32 = 0 then
									js.break
								end
							end
							js.reset
							l_p___0.ce_gets (misc2_inst.vim_strchr (l_last, ('=').code))
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_pos := -1 + 14 -- skip if block
							end
				when 8 then -- if:
							a_xp.item.xp_pattern := l_last
							inspect l_cmd_idx -- switch 2 head
							when 0 then l_pos := -1 + 9
							when 3 then l_pos := -1 + 10
							when 5 then l_pos := -1 + 11
							when 4 then l_pos := -1 + 11
							else l_pos := -1 + 12
							end
				when 9 then -- switch 2, case 0
							expand_what := {PC_EXPAND_WHAT}.EXP_DEFINE
							l_pos := -1 + 13 -- switch 2; break
				when 10 then -- switch 2, case 3
							expand_what := {PC_EXPAND_WHAT}.EXP_PLACE
							l_pos := -1 + 13 -- switch 2; break
				when 11 then -- switch 2, case 5 | switch 2, case 4
							expand_what := {PC_EXPAND_WHAT}.EXP_UNPLACE
							l_pos := -1 + 13 -- switch 2; break
				when 12 then -- switch 2, default:
							a_xp.item.xp_context := 0
				when 13 then -- switch 2, done: | if block done, skip else block:
							l_pos := -1 + 18
				when 14 then -- else:
							a_xp.item.xp_pattern := l_p___0 + 1
							inspect l_cmd_idx -- switch 3 head
							when 0 then l_pos := -1 + 15
							when 3 then l_pos := -1 + 16
							else l_pos := -1 + 17
							end
				when 15 then -- switch 3, case 0
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_last), ce_string ("texthl"), (l_p___0.distance (l_last)).to_natural_32)) = 0 then
								a_xp.item.xp_context := 13
							elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_last), ce_string ("linehl"), (l_p___0.distance (l_last)).to_natural_32)) = 0 then
								a_xp.item.xp_context := 13
							elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_last), ce_string ("icon"), (l_p___0.distance (l_last)).to_natural_32)) = 0 then
								a_xp.item.xp_context := 2
							else
								a_xp.item.xp_context := 0
							end
							l_pos := -1 + 18 -- switch 3; break
				when 16 then -- switch 3, case 3
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_last), ce_string ("name"), (l_p___0.distance (l_last)).to_natural_32)) = 0 then
								expand_what := {PC_EXPAND_WHAT}.EXP_SIGN_NAMES
							else
								a_xp.item.xp_context := 0
							end
							l_pos := -1 + 18 -- switch 3; break
				when 17 then -- switch 3, default:
							a_xp.item.xp_context := 0
				when 18 then -- switch 3, done: | if done
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	ex_drop (a_eap: CE_POINTER [PD_EXARG])
		local
			l_split: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_tp: CE_POINTER [PD_TABPAGE_S]
			js: JUMP_STATE
		do
			create l_wp___0.make
			create l_buf___6.make
			create l_tp.make

			l_split := 0
			ex_cmds2_inst.set_arglist (a_eap.item.arg)
			if (globals_inst.curwin.item.w_alist).item.al_ga.ga_len = 0 then
				js.return
			end
			if not js.return_called then
				if (globals_inst.cmdmod.tab).to_boolean then
					ex_docmd_inst.ex_all (a_eap)
				else
					l_buf___6.ce_gets (buffer_inst.buflist_findnr ((create {CE_POINTER [PD_ARGENTRY]}.make_cast ((globals_inst.curwin.item.w_alist).item.al_ga.ga_data) + 0).item.ae_fnum))
					l_tp.ce_gets (globals_inst.first_tabpage)
					from
					until
						not (not js.loop_left and then ((l_tp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
					loop
						if (l_tp.c_pointer.to_integer_32).to_natural_32 = (globals_inst.curtab.c_pointer.to_integer_32).to_natural_32 then
							l_wp___0.ce_gets (globals_inst.firstwin)
						else
							l_wp___0.ce_gets (l_tp.item.tp_firstwin)
						end
						from
						until
							not (not js.loop_left and then ((l_wp___0).c_pointer /= default_pointer))
						loop
							if ((l_wp___0.item.w_buffer).c_pointer.to_integer_32).to_natural_32 = (l_buf___6.c_pointer.to_integer_32).to_natural_32 then
								window_inst.goto_tabpage_win (l_tp, l_wp___0)
								globals_inst.curwin.item.w_arg_idx := 0
								js.return
							end
							if not js.return_called then
								l_wp___0.ce_gets (l_wp___0.item.w_next)
							end
						end
						if not js.return_called then
							l_tp.ce_gets (l_tp.item.tp_next)
						end
					end
					if not js.return_called then
						if not (quickfix_inst.buf_hide (globals_inst.curbuf)).to_boolean then
							globals_inst.emsg_off := globals_inst.emsg_off + 1
							l_split := ex_cmds2_inst.check_changed (globals_inst.curbuf, 1, 0, 0, 0)
							globals_inst.emsg_off := globals_inst.emsg_off - 1
						end
						if l_split.to_boolean then
							a_eap.item.cmdidx := {PC_CMD_INDEX}.CMD_sfirst
							a_eap.item.cmd[0] := (('s').code).to_natural_8
						else
							a_eap.item.cmdidx := {PC_CMD_INDEX}.CMD_first
						end
						ex_cmds2_inst.ex_rewind (a_eap)
					end
				end
			end
			if not js.return_called then
			end
		end

	ex_drop_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_drop)
		end

end
