class
	P_EX_DOCMD

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create ucmds.make
			create cmdidxs.make (<<27>>)
			create dollar_command.make (<<2>>)
			create cmdmods.make (<<20>>)
			create command_complete.make (<<24>>)
			create fcmd.make (<<27>>)
			create user_cmd_flags.make (<<8>>)
			create user_cmd_nargs.make (<<5>>)
			create prev_dir.make
			create spec_str.make (<<10>>)
		end

feature {ANY} -- attributes

	quitmore: INTEGER_32 assign set_quitmore

	set_quitmore (a_quitmore: INTEGER_32)
		do
			quitmore := a_quitmore
		end

	ex_pressedreturn: INTEGER_32 assign set_ex_pressedreturn

	set_ex_pressedreturn (a_ex_pressedreturn: INTEGER_32)
		do
			ex_pressedreturn := a_ex_pressedreturn
		end

	ucmds: PD_GROWARRAY

	did_lcd: INTEGER_32 assign set_did_lcd

	set_did_lcd (a_did_lcd: INTEGER_32)
		do
			did_lcd := a_did_lcd
		end

	cmdidxs: CE_ARRAY [INTEGER_32]

	dollar_command: CE_ARRAY [NATURAL_8]

	recursive___0: INTEGER_32 assign set_recursive___0

	set_recursive___0 (a_recursive___0: INTEGER_32)
		do
			recursive___0 := a_recursive___0
		end

	call_depth: INTEGER_32 assign set_call_depth

	set_call_depth (a_call_depth: INTEGER_32)
		do
			call_depth := a_call_depth
		end

	cmdmods: CE_ARRAY [PD_CMDMOD]

	command_complete: CE_ARRAY [PD_COMMAND_COMPLETE]

	fcmd: CE_ARRAY [NATURAL_8]

	user_cmd_flags: CE_ARRAY [CE_POINTER [INTEGER_8]]

	user_cmd_nargs: CE_ARRAY [CE_POINTER [INTEGER_8]]

	prev_dir: CE_POINTER [NATURAL_8]

	spec_str: CE_ARRAY [CE_POINTER [INTEGER_8]]

	filetype_detect: INTEGER_32 assign set_filetype_detect

	set_filetype_detect (a_filetype_detect: INTEGER_32)
		do
			filetype_detect := a_filetype_detect
		end

	filetype_plugin: INTEGER_32 assign set_filetype_plugin

	set_filetype_plugin (a_filetype_plugin: INTEGER_32)
		do
			filetype_plugin := a_filetype_plugin
		end

	filetype_indent: INTEGER_32 assign set_filetype_indent

	set_filetype_indent (a_filetype_indent: INTEGER_32)
		do
			filetype_indent := a_filetype_indent
		end

feature {ANY} -- routines

	save_dbg_stuff (a_dsp: CE_POINTER [PD_DBG_STUFF])
		do
			a_dsp.item.trylevel := globals_inst.trylevel
			globals_inst.trylevel := 0
			a_dsp.item.force_abort := globals_inst.force_abort
			globals_inst.force_abort := 0
			a_dsp.item.caught_stack := globals_inst.caught_stack
			globals_inst.caught_stack.ce_gets (create {CE_POINTER [PD_VIM_EXCEPTION]}.make_shared (default_pointer))
			a_dsp.item.vv_exception := eval_inst.v_exception (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			a_dsp.item.vv_throwpoint := eval_inst.v_throwpoint (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			a_dsp.item.did_emsg := globals_inst.did_emsg
			globals_inst.did_emsg := 0
			a_dsp.item.got_int := globals_inst.got_int
			globals_inst.got_int := 0
			a_dsp.item.did_throw := globals_inst.did_throw
			globals_inst.did_throw := 0
			a_dsp.item.need_rethrow := globals_inst.need_rethrow
			globals_inst.need_rethrow := 0
			a_dsp.item.check_cstack := globals_inst.check_cstack
			globals_inst.check_cstack := 0
			a_dsp.item.current_exception := globals_inst.current_exception
			globals_inst.current_exception.ce_gets (create {CE_POINTER [PD_VIM_EXCEPTION]}.make_shared (default_pointer))
		end

	restore_dbg_stuff (a_dsp: CE_POINTER [PD_DBG_STUFF])
		do
			globals_inst.suppress_errthrow := 0
			globals_inst.trylevel := a_dsp.item.trylevel
			globals_inst.force_abort := a_dsp.item.force_abort
			globals_inst.caught_stack.ce_gets (a_dsp.item.caught_stack)
			eval_inst.v_exception (a_dsp.item.vv_exception).do_nothing
			eval_inst.v_throwpoint (a_dsp.item.vv_throwpoint).do_nothing
			globals_inst.did_emsg := a_dsp.item.did_emsg
			globals_inst.got_int := a_dsp.item.got_int
			globals_inst.did_throw := a_dsp.item.did_throw
			globals_inst.need_rethrow := a_dsp.item.need_rethrow
			globals_inst.check_cstack := a_dsp.item.check_cstack
			globals_inst.current_exception.ce_gets (a_dsp.item.current_exception)
		end

	do_exmode (a_improved: INTEGER_32)
		local
			l_save_msg_scroll: INTEGER_32
			l_prev_msg_row: INTEGER_32
			l_prev_line: INTEGER_32
			l_changedtick___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_improved.to_boolean then
						globals_inst.exmode_active := 2
					else
						globals_inst.exmode_active := 1
					end
					globals_inst.State := 1
					if globals_inst.global_busy.to_boolean then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						l_save_msg_scroll := globals_inst.msg_scroll
						globals_inst.RedrawingDisabled := globals_inst.RedrawingDisabled + 1
						globals_inst.no_wait_return := globals_inst.no_wait_return + 1
						globals_inst.hold_gui_events := globals_inst.hold_gui_events + (1)
						message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Entering Ex mode.  Type %"visual%" to go to Normal mode."))))).do_nothing
				when 2 then -- loop condition:
						if not (not js.loop_left and then (globals_inst.exmode_active.to_boolean)) then
							l_pos := -1 + 12 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if globals_inst.ex_normal_busy > 0 then
							if globals_inst.typebuf.tb_len = 0 then
								globals_inst.exmode_active := 0
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 11 -- skip if block
						end
				when 4 then -- if:
						globals_inst.msg_scroll := 1
						globals_inst.need_wait_return := 0
						ex_pressedreturn := 0
						globals_inst.ex_no_reprint := 0
						l_changedtick___1 := globals_inst.curbuf.item.b_changedtick
						l_prev_msg_row := globals_inst.msg_row
						l_prev_line := globals_inst.curwin.item.w_cursor.lnum
						if a_improved.to_boolean then
							globals_inst.cmdline_row := globals_inst.msg_row
							do_cmdline (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), ex_getln_inst.getexline_address, create {CE_POINTER [ANY]}.make_shared (default_pointer), 0).do_nothing
						else
							do_cmdline (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), ex_getln_inst.getexmodeline_address, create {CE_POINTER [ANY]}.make_shared (default_pointer), 2).do_nothing
						end
						globals_inst.lines_left := (globals_inst.Rows - 1).to_integer_32
						if l_prev_line = globals_inst.curwin.item.w_cursor.lnum then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L___0
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if l_changedtick___1 = globals_inst.curbuf.item.b_changedtick then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L___0:
						if not globals_inst.ex_no_reprint.to_boolean then
							if ((globals_inst.curbuf.item.b_ml.ml_flags).bit_and (1)).to_boolean then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_emptybuf))))).do_nothing
							else
								if ex_pressedreturn.to_boolean then
									globals_inst.msg_row := l_prev_msg_row
									if l_prev_msg_row.to_integer_32 = globals_inst.Rows - 1 then
										globals_inst.msg_row := globals_inst.msg_row - 1
									end
								end
								globals_inst.msg_col := 0
								ex_cmds_inst.print_line_no_prefix (globals_inst.curwin.item.w_cursor.lnum, 0, 0)
								message_inst.msg_clr_eos
							end
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						if ex_pressedreturn.to_boolean then
							if not globals_inst.ex_no_reprint.to_boolean then
								if ((globals_inst.curbuf.item.b_ml.ml_flags).bit_and (1)).to_boolean then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_emptybuf))))).do_nothing
								else
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E501: At end-of-file"))))).do_nothing
								end
							end
						end
				when 11 then -- if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 12 then -- loop done
						js.reset
						globals_inst.hold_gui_events := globals_inst.hold_gui_events - (1)
						globals_inst.RedrawingDisabled := globals_inst.RedrawingDisabled - 1
						globals_inst.no_wait_return := globals_inst.no_wait_return - 1
						screen_inst.update_screen (50)
						globals_inst.need_wait_return := 0
						globals_inst.msg_scroll := l_save_msg_scroll
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_cmdline_cmd (a_cmd: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := (do_cmdline (a_cmd, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 11))
		end

	do_cmdline (a_cmdline: CE_POINTER [NATURAL_8]; a_getline___0: CE_ROUTINE; a_cookie: CE_POINTER [ANY]; a_flags___0: INTEGER_32): INTEGER_32
		local
			l_next_cmdline: CE_POINTER [NATURAL_8]
			l_cmdline_copy: CE_POINTER [NATURAL_8]
			l_used_getline: INTEGER_32
			l_msg_didout_before_start: INTEGER_32
			l_count___2: INTEGER_32
			l_did_inc: INTEGER_32
			l_retval: INTEGER_32
			l_cstack: PD_CONDSTACK
			l_lines_ga: PD_GROWARRAY
			l_current_line: INTEGER_32
			l_fname: CE_POINTER [NATURAL_8]
			l_breakpoint: CE_POINTER [INTEGER_32]
			l_dbg_tick: CE_POINTER [INTEGER_32]
			l_debug_saved: PD_DBG_STUFF
			l_initial_trylevel: INTEGER_32
			l_saved_msg_list: CE_POINTER [CE_POINTER [PD_MSGLIST]]
			l_private_msg_list: CE_POINTER [PD_MSGLIST]
			l_cmd_getline: CE_ROUTINE
			l_cmd_cookie: CE_POINTER [ANY]
			l_cmd_loop_cookie: PD_LOOP_COOKIE
			l_real_cookie: CE_POINTER [ANY]
			l_getline_is_func: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___20: CE_POINTER [ANY]
			l_idx: INTEGER_32
			l_tmp___33: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [ANY]
			l_saved_sourcing_name: CE_POINTER [NATURAL_8]
			l_saved_sourcing_lnum: INTEGER_32
			l_messages: CE_POINTER [PD_MSGLIST]
			l_next: CE_POINTER [PD_MSGLIST]
			l_tmp___43: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_next_cmdline.make
			create l_cmdline_copy.make
			create l_cstack.make
			create l_lines_ga.make
			create l_fname.make
			create l_breakpoint.make
			create l_dbg_tick.make
			create l_debug_saved.make
			create l_saved_msg_list.make
			create l_private_msg_list.make
			create l_cmd_getline.make
			create l_cmd_cookie.make
			create l_cmd_loop_cookie.make
			create l_real_cookie.make
			create l_tmp___20.make
			create l_tmp___33.make
			create l_p___0.make
			create l_saved_sourcing_name.make
			create l_messages.make
			create l_next.make
			create l_tmp___43.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_cmdline_copy.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_used_getline := 0
					l_msg_didout_before_start := 0
					l_count___2 := 0
					l_did_inc := 0
					l_retval := 1
					l_current_line := 0
					l_fname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_breakpoint.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
					l_dbg_tick.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
					l_saved_msg_list.ce_gets (create {CE_POINTER [CE_POINTER [PD_MSGLIST]]}.make_shared (default_pointer))
					l_saved_msg_list.ce_gets (globals_inst.msg_list)
					globals_inst.msg_list.ce_gets (l_private_msg_list.address)
					l_private_msg_list.ce_gets (create {CE_POINTER [PD_MSGLIST]}.make_shared (default_pointer))
					if call_depth = 200 then
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E169: Command too recursive"))))).do_nothing
						ex_eval_inst.do_errthrow (create {CE_POINTER [PD_CONDSTACK]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						globals_inst.msg_list.ce_gets (l_saved_msg_list)
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 86 -- skip if block
					end
				when 1 then -- if:
						call_depth := call_depth + 1
						l_cstack.cs_idx := -1
						l_cstack.cs_looplevel := 0
						l_cstack.cs_trylevel := 0
						l_cstack.cs_emsg_silent_list := create {CE_POINTER [PD_ESLIST_ELEM]}.make_shared (default_pointer)
						l_cstack.cs_lflags := (0).to_integer_8
						misc2_inst.ga_init2 (l_lines_ga.address, ({PD_WCMD_T}.sizeof.to_natural_32).to_integer_32, 10)
						l_real_cookie.ce_gets (getline_cookie (a_getline___0, a_cookie))
						l_getline_is_func := getline_equal (a_getline___0, a_cookie, eval_inst.get_func_line_address)
						if l_getline_is_func.to_boolean then
							if globals_inst.ex_nesting_level = (eval_inst.func_level (l_real_cookie)) then
								globals_inst.ex_nesting_level := globals_inst.ex_nesting_level + 1
							end
						end
						if l_getline_is_func.to_boolean then
							l_fname.ce_gets (eval_inst.func_name (l_real_cookie))
							l_breakpoint.ce_gets (eval_inst.func_breakpoint (l_real_cookie))
							l_dbg_tick.ce_gets (eval_inst.func_dbg_tick (l_real_cookie))
						elseif (getline_equal (a_getline___0, a_cookie, ex_cmds2_inst.getsourceline_address)).to_boolean then
							l_fname.ce_gets (globals_inst.sourcing_name)
							l_breakpoint.ce_gets (ex_cmds2_inst.source_breakpoint (l_real_cookie))
							l_dbg_tick.ce_gets (ex_cmds2_inst.source_dbg_tick (l_real_cookie))
						end
						if not recursive___0.to_boolean then
							globals_inst.force_abort := 0
							globals_inst.suppress_errthrow := 0
						end
						if ((a_flags___0).bit_and (16)).to_boolean then
							save_dbg_stuff (l_debug_saved.address)
						else
							memset (create {CE_POINTER [ANY]}.make_cast ((l_debug_saved.address)), 0, (1).to_natural_32).do_nothing
						end
						l_initial_trylevel := globals_inst.trylevel
						globals_inst.did_throw := 0
						globals_inst.did_emsg := 0
						if not ((a_flags___0).bit_and (8)).to_boolean then
							if not (getline_equal (a_getline___0, a_cookie, ex_getln_inst.getexline_address)).to_boolean then
								globals_inst.KeyTyped := 0
							end
						end
						l_next_cmdline.ce_gets (a_cmdline)
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 43 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						l_getline_is_func := getline_equal (a_getline___0, a_cookie, eval_inst.get_func_line_address)
						if (l_next_cmdline.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if not globals_inst.force_abort.to_boolean then
								if l_cstack.cs_idx < 0 then
									if l_getline_is_func.to_boolean then
										if not (eval_inst.func_has_abort (l_real_cookie)).to_boolean then
											globals_inst.did_emsg := 0
										end
									else
										globals_inst.did_emsg := 0
									end
								end
							end
						end
						if l_cstack.cs_looplevel > 0 then
							if l_current_line < l_lines_ga.ga_len then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cmdline_copy))
								l_cmdline_copy.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								if l_getline_is_func.to_boolean then
									if (eval_inst.func_has_ended (l_real_cookie)).to_boolean then
										l_retval := 0
										js.break
									end
								end
								if not js.loop_jumped then
									if (ex_cmds2_inst.source_finished (a_getline___0, a_cookie)).to_boolean then
										l_retval := 0
										js.break
									end
								end
								if not js.loop_jumped then
									if (l_breakpoint.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										if (l_dbg_tick.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
											if l_dbg_tick.item /= globals_inst.debug_tick then
												l_breakpoint.item := ex_cmds2_inst.dbg_find_breakpoint ((getline_equal (a_getline___0, a_cookie, ex_cmds2_inst.getsourceline_address)), l_fname, globals_inst.sourcing_lnum)
												l_dbg_tick.item := globals_inst.debug_tick
											end
										end
									end
									l_next_cmdline.ce_gets ((create {CE_POINTER [PD_WCMD_T]}.make_cast (l_lines_ga.ga_data) + l_current_line).item.line)
									globals_inst.sourcing_lnum := (create {CE_POINTER [PD_WCMD_T]}.make_cast (l_lines_ga.ga_data) + l_current_line).item.lnum
									if (l_breakpoint.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										if l_breakpoint.item /= 0 then
											if l_breakpoint.item <= globals_inst.sourcing_lnum then
												ex_cmds2_inst.dbg_breakpoint (l_fname, globals_inst.sourcing_lnum)
												l_breakpoint.item := ex_cmds2_inst.dbg_find_breakpoint ((getline_equal (a_getline___0, a_cookie, ex_cmds2_inst.getsourceline_address)), l_fname, globals_inst.sourcing_lnum)
												l_dbg_tick.item := globals_inst.debug_tick
											end
										end
									end
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 13 -- skip if block
						end
				when 4 then -- if:
						if l_cstack.cs_looplevel > 0 then
							l_cmd_getline.ce_gets (get_loop_line_address)
							l_cmd_cookie.ce_gets (create {CE_POINTER [ANY]}.make_cast ((l_cmd_loop_cookie.address)))
							l_cmd_loop_cookie.lines_gap := l_lines_ga.address
							l_cmd_loop_cookie.current_line := l_current_line
							l_cmd_loop_cookie.getline := a_getline___0
							l_cmd_loop_cookie.cookie := a_cookie
							l_cmd_loop_cookie.repeating := (l_current_line < l_lines_ga.ga_len).to_integer
						else
							l_cmd_getline.ce_gets (a_getline___0)
							l_cmd_cookie.ce_gets (a_cookie)
						end
						if (l_next_cmdline.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 12 -- skip if block
						end
				when 5 then -- if:
						if l_count___2 = 1 then
							if (getline_equal (a_getline___0, a_cookie, ex_getln_inst.getexline_address)).to_boolean then
								globals_inst.msg_didout := 1
							end
						end
						if (a_getline___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if l_cstack.cs_idx < 0 then
							l_tmp___9 := 0
						else
							l_tmp___9 := (l_cstack.cs_idx + 1) * 2
						end
						l_next_cmdline.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (a_getline___0.pointer_item ([(':').code, a_cookie, l_tmp___9])))
						if (l_next_cmdline.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if globals_inst.KeyTyped.to_boolean then
							if not ((a_flags___0).bit_and (4)).to_boolean then
								globals_inst.need_wait_return := 0
							end
						end
						l_retval := 0
						js.break
				when 10 then -- if done
						if not js.loop_jumped then
							l_used_getline := 1
							if ((a_flags___0).bit_and (32)).to_boolean then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.repeat_cmdline))
								if l_count___2 = 0 then
									globals_inst.repeat_cmdline.ce_gets (misc2_inst.vim_strsave (l_next_cmdline))
								else
									globals_inst.repeat_cmdline.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								end
							end
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						if (l_cmdline_copy.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_next_cmdline.ce_gets (misc2_inst.vim_strsave (l_next_cmdline))
							if (l_next_cmdline.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_outofmem))))).do_nothing
								l_retval := 0
								js.break
							end
						end
				when 13 then -- if done | if done
						if js.loop_jumped then
							l_pos := -1 + 20 -- skip if block
						end
				when 14 then -- if:
						l_cmdline_copy.ce_gets (l_next_cmdline)
						if l_current_line /= l_lines_ga.ga_len then
							l_pos := -1 + 20 -- skip if block
						end
				when 15 then -- if:
						if not ((l_cstack.cs_looplevel).to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 19 -- goto _L___0
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 18 then -- else:
						if not ((ex_eval_inst.has_loop_cmd (l_next_cmdline)).to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 19 then -- if: | _L___0:
						if (store_loop_line (l_lines_ga.address, l_next_cmdline)) = 0 then
							l_retval := 0
							js.break
						end
				when 20 then -- if done | if done | if done
						if js.loop_jumped then
							l_pos := -1 + 42 -- skip if block
						end
				when 21 then -- if:
						globals_inst.did_endif := 0
						l_tmp___13 := l_count___2
						l_count___2 := l_count___2 + 1
						if l_tmp___13 = 0 then
							if not ((a_flags___0).bit_and (2)).to_boolean then
								if not recursive___0.to_boolean then
									l_msg_didout_before_start := globals_inst.msg_didout
									globals_inst.msg_didany := 0
									message_inst.msg_start
									globals_inst.msg_scroll := 1
									globals_inst.no_wait_return := globals_inst.no_wait_return + 1
									globals_inst.RedrawingDisabled := globals_inst.RedrawingDisabled + 1
									l_did_inc := 1
								end
							end
						end
						if option_inst.p_verbose >= 15 then
							if (globals_inst.sourcing_name.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								globals_inst.no_wait_return := globals_inst.no_wait_return + 1
								message_inst.verbose_enter_scroll
								message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("line %%ld: %%s")))), globals_inst.sourcing_lnum, l_cmdline_copy]).do_nothing
								if globals_inst.msg_silent = 0 then
									message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
								end
								message_inst.verbose_leave_scroll
								globals_inst.no_wait_return := globals_inst.no_wait_return - 1
							end
						end
						recursive___0 := recursive___0 + 1
						l_next_cmdline.ce_gets (do_one_cmd (l_cmdline_copy.address, (a_flags___0).bit_and (1), l_cstack.address, l_cmd_getline, l_cmd_cookie))
						recursive___0 := recursive___0 - 1
						if (l_cmd_cookie.c_pointer.to_integer_32).to_natural_32 = ((l_cmd_loop_cookie.address).c_pointer.to_integer_32).to_natural_32 then
							l_current_line := l_cmd_loop_cookie.current_line
						end
						if (l_next_cmdline.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cmdline_copy))
							l_cmdline_copy.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							if (getline_equal (a_getline___0, a_cookie, ex_getln_inst.getexline_address)).to_boolean then
								if (globals_inst.new_last_cmdline.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.last_cmdline))
									globals_inst.last_cmdline.ce_gets (globals_inst.new_last_cmdline)
									globals_inst.new_last_cmdline.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								end
							end
						else
							memmove (create {CE_POINTER [ANY]}.make_cast (l_cmdline_copy), create {CE_POINTER [ANY]}.make_cast (l_next_cmdline), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_next_cmdline))) + {NATURAL_32} 1).do_nothing
							l_next_cmdline.ce_gets (l_cmdline_copy)
						end
						if globals_inst.did_emsg.to_boolean then
							if not globals_inst.force_abort.to_boolean then
								if (getline_equal (a_getline___0, a_cookie, eval_inst.get_func_line_address)).to_boolean then
									if not (eval_inst.func_has_abort (l_real_cookie)).to_boolean then
										globals_inst.did_emsg := 0
									end
								end
							end
						end
						if not (l_cstack.cs_looplevel > 0) then
							l_pos := -1 + 29 -- skip if block
						end
				when 22 then -- if:
						l_current_line := l_current_line + 1
						if not ((((l_cstack.cs_lflags).to_integer_32).bit_and (6)).to_boolean) then
							l_pos := -1 + 28 -- skip if block
						end
				when 23 then -- if:
						l_cstack.cs_lflags := (((l_cstack.cs_lflags).to_integer_32).bit_and (-7)).to_integer_8
						if globals_inst.did_emsg.to_boolean then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						if not globals_inst.got_int.to_boolean then
							if not globals_inst.did_throw.to_boolean then
								if l_cstack.cs_idx >= 0 then
									if (((l_cstack.cs_flags[l_cstack.cs_idx]).to_integer_32).bit_and (24)).to_boolean then
										if l_cstack.cs_line[l_cstack.cs_idx] >= 0 then
											if (((l_cstack.cs_flags[l_cstack.cs_idx]).to_integer_32).bit_and (2)).to_boolean then
												l_current_line := l_cstack.cs_line[l_cstack.cs_idx]
												l_cstack.cs_lflags := (((l_cstack.cs_lflags).to_integer_32).bit_or (1)).to_integer_8
												misc1_inst.line_breakcheck
												if (l_breakpoint.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
													l_breakpoint.item := ex_cmds2_inst.dbg_find_breakpoint ((getline_equal (a_getline___0, a_cookie, ex_cmds2_inst.getsourceline_address)), l_fname, (create {CE_POINTER [PD_WCMD_T]}.make_cast (l_lines_ga.ga_data) + l_current_line).item.lnum - 1)
													l_dbg_tick.item := globals_inst.debug_tick
												end
											else
												l_pos := -1 + 26 -- goto _L___6
											end
										else
											l_pos := -1 + 26 -- goto _L___6
										end
									else
										l_pos := -1 + 26 -- goto _L___6
									end
								else
									l_pos := -1 + 26 -- goto _L___6
								end
							else
								l_pos := -1 + 26 -- goto _L___6
							end
						else
							l_pos := -1 + 26 -- goto _L___6
						end
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else: | _L___6:
						if l_cstack.cs_idx >= 0 then
							ex_eval_inst.rewind_conditionals (l_cstack.address, l_cstack.cs_idx - 1, 24, create {CE_POINTER [INTEGER_32]}.make_shared (l_cstack.c_pointer + {PD_CONDSTACK}.cs_looplevel_offset))
						end
				when 27 then -- if done | if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:
						if (((l_cstack.cs_lflags).to_integer_32).bit_and (1)).to_boolean then
							l_cstack.cs_lflags := (((l_cstack.cs_lflags).to_integer_32).bit_and (-2)).to_integer_8
							l_cstack.cs_line[l_cstack.cs_idx] := l_current_line - 1
						end
				when 29 then -- if done
						if l_cstack.cs_looplevel = 0 then
							if l_lines_ga.ga_len > 0 then
								globals_inst.sourcing_lnum := (create {CE_POINTER [PD_WCMD_T]}.make_cast (l_lines_ga.ga_data) + (l_lines_ga.ga_len - 1)).item.lnum
								free_cmdlines (l_lines_ga.address)
							end
							l_current_line := 0
						end
						if (((l_cstack.cs_lflags).to_integer_32).bit_and (8)).to_boolean then
							l_cstack.cs_lflags := (((l_cstack.cs_lflags).to_integer_32).bit_and (-9)).to_integer_8
							if globals_inst.did_throw.to_boolean then
								l_tmp___20.ce_gets (create {CE_POINTER [ANY]}.make_cast (globals_inst.current_exception))
							else
								l_tmp___20.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer))
							end
							ex_eval_inst.report_make_pending (((l_cstack.cs_pending[l_cstack.cs_idx]).to_integer_32).bit_and (7), l_tmp___20)
							globals_inst.did_throw := 0
							globals_inst.got_int := globals_inst.did_throw
							globals_inst.did_emsg := globals_inst.got_int
							l_cstack.cs_flags[l_cstack.cs_idx] := (((l_cstack.cs_flags[l_cstack.cs_idx]).to_integer_32).bit_or (514)).to_integer_16
						end
						globals_inst.trylevel := l_initial_trylevel + l_cstack.cs_trylevel
						if globals_inst.trylevel = 0 then
							if not globals_inst.did_emsg.to_boolean then
								if not globals_inst.got_int.to_boolean then
									if not globals_inst.did_throw.to_boolean then
										globals_inst.force_abort := 0
									end
								end
							end
						end
						ex_eval_inst.do_intthrow (l_cstack.address).do_nothing
						if not (globals_inst.got_int.to_boolean) then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						l_pos := -1 + 36 -- goto _L___10
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 32 then -- else:
						if not (globals_inst.did_emsg.to_boolean) then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						if globals_inst.force_abort.to_boolean then
							l_pos := -1 + 36 -- goto _L___10
						else
							l_pos := -1 + 35 -- goto _L___11
						end
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 35 then -- else: | _L___11:
						if not (globals_inst.did_throw.to_boolean) then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if: | _L___10:
						if l_cstack.cs_trylevel = 0 then
							js.break
						else
							l_pos := -1 + 38 -- goto _L___9
						end
				when 37 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 38 then -- else: | _L___9:
						if not (globals_inst.did_emsg.to_boolean) then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						if l_used_getline.to_boolean then
							if (getline_equal (a_getline___0, a_cookie, ex_getln_inst.getexmodeline_address)).to_boolean then
								js.break
							elseif (getline_equal (a_getline___0, a_cookie, ex_getln_inst.getexline_address)).to_boolean then
								js.break
							else
								l_pos := -1 + 41 -- goto _L___8
							end
						else
							l_pos := -1 + 41 -- goto _L___8
						end
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else: | _L___8:
						if (l_next_cmdline.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if not (l_cstack.cs_idx >= 0) then
								if not ((a_flags___0).bit_and (4)).to_boolean then
									js.break
								end
							end
						end
				when 42 then -- if done | if done | if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 43 then -- loop done
						js.reset
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cmdline_copy))
						free_cmdlines (l_lines_ga.address)
						misc2_inst.ga_clear (l_lines_ga.address)
						if not (l_cstack.cs_idx >= 0) then
							l_pos := -1 + 53 -- skip if block
						end
				when 44 then -- if:
						if globals_inst.got_int.to_boolean then
							l_pos := -1 + 52 -- skip if block
						end
				when 45 then -- if:
						if globals_inst.did_throw.to_boolean then
							l_pos := -1 + 52 -- skip if block
						end
				when 46 then -- if:
						if not ((getline_equal (a_getline___0, a_cookie, ex_cmds2_inst.getsourceline_address)).to_boolean) then
							l_pos := -1 + 49 -- skip if block
						end
				when 47 then -- if:
						if (ex_cmds2_inst.source_finished (a_getline___0, a_cookie)).to_boolean then
							l_pos := -1 + 49 -- goto _L___13
						else
							l_pos := -1 + 51 -- goto _L___12
						end
				when 48 then -- if block done, skip else block:
						l_pos := -1 + 52
				when 49 then -- else: | _L___13:
						if not ((getline_equal (a_getline___0, a_cookie, eval_inst.get_func_line_address)).to_boolean) then
							l_pos := -1 + 52 -- skip if block
						end
				when 50 then -- if:
						if (eval_inst.func_has_ended (l_real_cookie)).to_boolean then
							l_pos := -1 + 52 -- skip if block
						end
				when 51 then -- if: | _L___12:
						if (((l_cstack.cs_flags[l_cstack.cs_idx]).to_integer_32).bit_and (256)).to_boolean then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_endtry))))).do_nothing
						elseif (((l_cstack.cs_flags[l_cstack.cs_idx]).to_integer_32).bit_and (8)).to_boolean then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_endwhile))))).do_nothing
						elseif (((l_cstack.cs_flags[l_cstack.cs_idx]).to_integer_32).bit_and (16)).to_boolean then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_endfor))))).do_nothing
						else
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_endif))))).do_nothing
						end
				when 52 then -- if done | if done | if done | if done
						from
						until
							js.loop_left
						loop
							js.reset
							l_idx := (ex_eval_inst.cleanup_conditionals (l_cstack.address, 0, 1))
							if l_idx >= 0 then
								l_idx := l_idx - 1
							end
							ex_eval_inst.rewind_conditionals (l_cstack.address, l_idx, 24, create {CE_POINTER [INTEGER_32]}.make_shared (l_cstack.c_pointer + {PD_CONDSTACK}.cs_looplevel_offset))
							if not (l_cstack.cs_idx >= 0) then
								js.break
							end
						end
						js.reset
						globals_inst.trylevel := l_initial_trylevel
				when 53 then -- if done
						if (getline_equal (a_getline___0, a_cookie, eval_inst.get_func_line_address)).to_boolean then
							l_tmp___33.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("endfunction")))
						else
							l_tmp___33.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						end
						ex_eval_inst.do_errthrow (l_cstack.address, l_tmp___33)
						if globals_inst.trylevel /= 0 then
							l_pos := -1 + 63 -- skip if block
						end
				when 54 then -- if:
						if not (globals_inst.did_throw.to_boolean) then
							l_pos := -1 + 62 -- skip if block
						end
				when 55 then -- if:
						l_p___0.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer))
						l_messages.ce_gets (create {CE_POINTER [PD_MSGLIST]}.make_shared (default_pointer))
						inspect globals_inst.current_exception.item.type -- switch 1 head
						when 0 then l_pos := -1 + 56
						when 1 then l_pos := -1 + 57
						when 2 then l_pos := -1 + 58
						else l_pos := -1 + 59
						end
				when 56 then -- switch 1, case 0
						message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1025).to_natural_32, (gettext (ce_string ("E605: Exception not caught: %%s"))), globals_inst.current_exception.item.value]).do_nothing
						l_p___0.ce_gets (create {CE_POINTER [ANY]}.make_cast ((misc2_inst.vim_strsave (globals_inst.IObuff))))
						l_pos := -1 + 60 -- switch 1; break
				when 57 then -- switch 1, case 1
						l_messages.ce_gets (globals_inst.current_exception.item.messages)
						globals_inst.current_exception.item.messages := create {CE_POINTER [PD_MSGLIST]}.make_shared (default_pointer)
						l_pos := -1 + 60 -- switch 1; break
				when 58 then -- switch 1, case 2
						l_pos := -1 + 60 -- switch 1; break
				when 59 then -- switch 1, default:
						l_p___0.ce_gets (create {CE_POINTER [ANY]}.make_cast ((misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_internal))))))))
				when 60 then -- switch 1, done:
						l_saved_sourcing_name.ce_gets (globals_inst.sourcing_name)
						l_saved_sourcing_lnum := globals_inst.sourcing_lnum.to_integer_32
						globals_inst.sourcing_name.ce_gets (globals_inst.current_exception.item.throw_name)
						globals_inst.sourcing_lnum := globals_inst.current_exception.item.throw_lnum
						globals_inst.current_exception.item.throw_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						ex_eval_inst.discard_current_exception
						globals_inst.suppress_errthrow := 1
						globals_inst.force_abort := 1
						if (l_messages.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							from
							until
								js.loop_left
							loop
								js.reset
								l_next.ce_gets (l_messages.item.next)
								message_inst.emsg (l_messages.item.msg).do_nothing
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_messages.item.msg))
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_messages))
								l_messages.ce_gets (l_next)
								if (l_messages.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									js.break
								end
							end
							js.reset
						elseif (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_p___0)).do_nothing
							misc2_inst.vim_free (l_p___0)
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.sourcing_name))
						globals_inst.sourcing_name.ce_gets (l_saved_sourcing_name)
						globals_inst.sourcing_lnum := l_saved_sourcing_lnum.to_integer_32
				when 61 then -- if block done, skip else block:
						l_pos := -1 + 63
				when 62 then -- else:
						if globals_inst.got_int.to_boolean then
							globals_inst.suppress_errthrow := 1
						elseif globals_inst.did_emsg.to_boolean then
							if globals_inst.force_abort.to_boolean then
								globals_inst.suppress_errthrow := 1
							end
						end
				when 63 then -- if done | if done
						if globals_inst.did_throw.to_boolean then
							globals_inst.need_rethrow := 1
						end
						if not ((getline_equal (a_getline___0, a_cookie, ex_cmds2_inst.getsourceline_address)).to_boolean) then
							l_pos := -1 + 66 -- skip if block
						end
				when 64 then -- if:
						if globals_inst.ex_nesting_level > (ex_cmds2_inst.source_level (l_real_cookie)) then
							l_pos := -1 + 68 -- goto _L___15
						else
							l_pos := -1 + 66 -- goto _L___17
						end
				when 65 then -- if block done, skip else block:
						l_pos := -1 + 77
				when 66 then -- else: | _L___17:
						if not ((getline_equal (a_getline___0, a_cookie, eval_inst.get_func_line_address)).to_boolean) then
							l_pos := -1 + 72 -- skip if block
						end
				when 67 then -- if:
						if not (globals_inst.ex_nesting_level > (eval_inst.func_level (l_real_cookie)) + 1) then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if: | _L___15:
						if not globals_inst.did_throw.to_boolean then
							globals_inst.check_cstack := 1
						end
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 71
				when 70 then -- else:
						l_pos := -1 + 72 -- goto _L___16
				when 71 then -- if done | if block done, skip else block:
						l_pos := -1 + 77
				when 72 then -- else: | _L___16:
						if (getline_equal (a_getline___0, a_cookie, eval_inst.get_func_line_address)).to_boolean then
							globals_inst.ex_nesting_level := globals_inst.ex_nesting_level - 1
						end
						if not ((getline_equal (a_getline___0, a_cookie, ex_cmds2_inst.getsourceline_address)).to_boolean) then
							l_pos := -1 + 75 -- skip if block
						end
				when 73 then -- if:
						l_pos := -1 + 76 -- goto _L___14
				when 74 then -- if block done, skip else block:
						l_pos := -1 + 77
				when 75 then -- else:
						if not ((getline_equal (a_getline___0, a_cookie, eval_inst.get_func_line_address)).to_boolean) then
							l_pos := -1 + 77 -- skip if block
						end
				when 76 then -- if: | _L___14:
						if globals_inst.ex_nesting_level + 1 <= globals_inst.debug_break_level then
							if (getline_equal (a_getline___0, a_cookie, ex_cmds2_inst.getsourceline_address)).to_boolean then
								l_tmp___43.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("End of sourced file")))))
							else
								l_tmp___43.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("End of function")))))
							end
							ex_cmds2_inst.do_debug (l_tmp___43)
						end
				when 77 then -- if done | if done | if done
						if ((a_flags___0).bit_and (16)).to_boolean then
							restore_dbg_stuff (l_debug_saved.address)
						end
						globals_inst.msg_list.ce_gets (l_saved_msg_list)
						if not (l_did_inc.to_boolean) then
							l_pos := -1 + 85 -- skip if block
						end
				when 78 then -- if:
						globals_inst.RedrawingDisabled := globals_inst.RedrawingDisabled - 1
						globals_inst.no_wait_return := globals_inst.no_wait_return - 1
						globals_inst.msg_scroll := 0
						if l_retval /= 0 then
							l_pos := -1 + 81 -- skip if block
						end
				when 79 then -- if:
						globals_inst.need_wait_return := 0
						globals_inst.msg_didany := 0
				when 80 then -- if block done, skip else block:
						l_pos := -1 + 85
				when 81 then -- else:
						if not (globals_inst.did_endif.to_boolean) then
							l_pos := -1 + 84 -- skip if block
						end
				when 82 then -- if:
						if globals_inst.KeyTyped.to_boolean then
							if not globals_inst.did_emsg.to_boolean then
								globals_inst.need_wait_return := 0
								globals_inst.msg_didany := 0
							else
								l_pos := -1 + 84 -- goto _L___19
							end
						else
							l_pos := -1 + 84 -- goto _L___19
						end
				when 83 then -- if block done, skip else block:
						l_pos := -1 + 85
				when 84 then -- else: | _L___19:
						if globals_inst.need_wait_return.to_boolean then
							globals_inst.msg_didout := (globals_inst.msg_didout).bit_or (l_msg_didout_before_start)
							message_inst.wait_return (0)
						end
				when 85 then -- if done | if done
						call_depth := call_depth - 1
						Result := l_retval
				when 86 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_loop_line (a_c: INTEGER_32; a_cookie: CE_POINTER [ANY]; a_indent: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_cp: CE_POINTER [PD_LOOP_COOKIE]
			l_wp___0: CE_POINTER [PD_WCMD_T]
			l_line: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_cp.make
			create l_wp___0.make
			create l_line.make

			l_cp.ce_gets (create {CE_POINTER [PD_LOOP_COOKIE]}.make_cast (a_cookie))
			if l_cp.item.current_line + 1 >= (l_cp.item.lines_gap).item.ga_len then
				if (l_cp.item.repeating).to_boolean then
					Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					js.return
				end
				if not js.return_called then
					if ((l_cp.item.getline).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_line.ce_gets (ex_getln_inst.getcmdline (a_c, 0, a_indent))
					else
						l_line.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((l_cp.item.getline).pointer_item ([a_c, l_cp.item.cookie, a_indent])))
					end
					if (l_line.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						if (store_loop_line (l_cp.item.lines_gap, l_line)) = 1 then
							l_cp.item.current_line := (l_cp.item.current_line) + 1
						end
					end
					Result := l_line
					js.return
				end
			end
			if not js.return_called then
				globals_inst.KeyTyped := 0
				l_cp.item.current_line := (l_cp.item.current_line) + 1
				l_wp___0.ce_gets (create {CE_POINTER [PD_WCMD_T]}.make_cast ((l_cp.item.lines_gap).item.ga_data) + l_cp.item.current_line)
				globals_inst.sourcing_lnum := l_wp___0.item.lnum
				Result := (misc2_inst.vim_strsave (l_wp___0.item.line))
			end
		end

	get_loop_line_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent get_loop_line)
		end

	store_loop_line (a_gap: CE_POINTER [PD_GROWARRAY]; a_line: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (misc2_inst.ga_grow (a_gap, 1)) = 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				(create {CE_POINTER [PD_WCMD_T]}.make_cast (a_gap.item.ga_data) + a_gap.item.ga_len).item.line := misc2_inst.vim_strsave (a_line);
				(create {CE_POINTER [PD_WCMD_T]}.make_cast (a_gap.item.ga_data) + a_gap.item.ga_len).item.lnum := globals_inst.sourcing_lnum
				a_gap.item.ga_len := (a_gap.item.ga_len) + 1
				Result := 1
			end
		end

	free_cmdlines (a_gap: CE_POINTER [PD_GROWARRAY])
		do
			from
			until
				not (a_gap.item.ga_len > 0)
			loop
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_WCMD_T]}.make_cast (a_gap.item.ga_data) + (a_gap.item.ga_len - 1)).item.line))
				a_gap.item.ga_len := (a_gap.item.ga_len) - 1
			end
		end

	getline_equal (a_fgetline: CE_ROUTINE; a_cookie: CE_POINTER [ANY]; a_func: CE_ROUTINE): INTEGER_32
		local
			l_gp: CE_ROUTINE
			l_cp: CE_POINTER [PD_LOOP_COOKIE]
		do
			create l_gp.make
			create l_cp.make

			l_gp.ce_gets (a_fgetline)
			l_cp.ce_gets (create {CE_POINTER [PD_LOOP_COOKIE]}.make_cast (a_cookie))
			from
			until
				(l_gp.c_pointer.to_integer_32).to_natural_32 /= ((get_loop_line_address).c_pointer.to_integer_32).to_natural_32
			loop
				l_gp.ce_gets (l_cp.item.getline)
				l_cp.ce_gets (create {CE_POINTER [PD_LOOP_COOKIE]}.make_cast (l_cp.item.cookie))
			end
			Result := ((l_gp.c_pointer.to_integer_32).to_natural_32 = (a_func.c_pointer.to_integer_32).to_natural_32).to_integer
		end

	getline_cookie (a_fgetline: CE_ROUTINE; a_cookie: CE_POINTER [ANY]): CE_POINTER [ANY]
		local
			l_gp: CE_ROUTINE
			l_cp: CE_POINTER [PD_LOOP_COOKIE]
		do
			create l_gp.make
			create l_cp.make

			l_gp.ce_gets (a_fgetline)
			l_cp.ce_gets (create {CE_POINTER [PD_LOOP_COOKIE]}.make_cast (a_cookie))
			from
			until
				(l_gp.c_pointer.to_integer_32).to_natural_32 /= ((get_loop_line_address).c_pointer.to_integer_32).to_natural_32
			loop
				l_gp.ce_gets (l_cp.item.getline)
				l_cp.ce_gets (create {CE_POINTER [PD_LOOP_COOKIE]}.make_cast (l_cp.item.cookie))
			end
			Result := (create {CE_POINTER [ANY]}.make_cast (l_cp))
		end

	do_one_cmd (a_cmdlinep: CE_POINTER [CE_POINTER [NATURAL_8]]; a_sourcing: INTEGER_32; a_cstack: CE_POINTER [PD_CONDSTACK]; a_fgetline: CE_ROUTINE; a_cookie: CE_POINTER [ANY]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_lnum: INTEGER_32
			l_n: INTEGER_32
			l_errormsg: CE_POINTER [NATURAL_8]
			l_ea: PD_EXARG
			l_verbose_save: INTEGER_32
			l_save_msg_scroll: INTEGER_32
			l_save_msg_silent: INTEGER_32
			l_did_esilent: INTEGER_32
			l_did_sandbox: INTEGER_32
			l_save_cmdmod: PD_CMDMOD_T
			l_ni: INTEGER_32
			l_tmp___29: INTEGER_32
			l_fp: CE_POINTER [PD_POS_T]
			l_tmp___37: INTEGER_32
			l_tmp___46: CE_POINTER [INTEGER_8]
			l_tmp___53: CE_POINTER [NATURAL_8]
			l_tmp___56: INTEGER_32
			l_tmp___59: CE_POINTER [INTEGER_8]
			l_tmp___69: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_errormsg.make
			create l_ea.make
			create l_save_cmdmod.make
			create l_fp.make
			create l_tmp___46.make
			create l_tmp___53.make
			create l_tmp___59.make
			create l_tmp___69.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_errormsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_verbose_save := -1
					l_save_msg_scroll := globals_inst.msg_scroll
					l_save_msg_silent := -1
					l_did_esilent := 0
					l_did_sandbox := 0
					memset (create {CE_POINTER [ANY]}.make_cast ((l_ea.address)), 0, {PD_EXARG}.sizeof.to_natural_32).do_nothing
					l_ea.line1 := (1).to_integer_32
					l_ea.line2 := (1).to_integer_32
					globals_inst.ex_nesting_level := globals_inst.ex_nesting_level + 1
					if quitmore.to_boolean then
						if not (getline_equal (a_fgetline, a_cookie, eval_inst.get_func_line_address)).to_boolean then
							quitmore := quitmore - 1
						end
					end
					l_save_cmdmod.ce_gets (globals_inst.cmdmod)
					memset (create {CE_POINTER [ANY]}.make_cast ((globals_inst.cmdmod.address)), 0, {PD_CMDMOD_T}.sizeof.to_natural_32).do_nothing
					if (a_cmdlinep.item[0]).to_integer_32 = 35 then
						if (a_cmdlinep.item[1]).to_integer_32 = 33 then
							l_pos := -1 + 190 -- goto doend
						end
					end
				when 1 then
					l_ea.cmd := a_cmdlinep.item
				when 2 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 49 -- skip loop
					end
				when 3 then -- loop body:
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							if ((l_ea.cmd).item).to_integer_32 /= 32 then
								if ((l_ea.cmd).item).to_integer_32 /= 9 then
									if ((l_ea.cmd).item).to_integer_32 /= 58 then
										js.break
									end
								end
							end
							if not js.loop_jumped then
								l_ea.cmd := (l_ea.cmd) + 1
							end
						end
						js.reset
						if ((l_ea.cmd).item).to_integer_32 /= 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						if not (globals_inst.exmode_active.to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if not ((getline_equal (a_fgetline, a_cookie, ex_getln_inst.getexmodeline_address)).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if not ((getline_equal (a_fgetline, a_cookie, ex_getln_inst.getexline_address)).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if globals_inst.curwin.item.w_cursor.lnum < globals_inst.curbuf.item.b_ml.ml_line_count then
							l_ea.cmd := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("+"))
							ex_pressedreturn := 1
						end
				when 10 then -- if done | if done | if done
						if ((l_ea.cmd).item).to_integer_32 = 34 then
							l_pos := -1 + 190 -- goto doend
						end
				when 11 then
						if ((l_ea.cmd).item).to_integer_32 = 0 then
							ex_pressedreturn := 1
							l_pos := -1 + 190 -- goto doend
						end
				when 12 then
						l_p___0.ce_gets (l_ea.cmd)
						if ((l_ea.cmd).item).to_integer_32 >= 48 then
							if ((l_ea.cmd).item).to_integer_32 <= 57 then
								l_p___0.ce_gets (charset_inst.skipwhite ((charset_inst.skipdigits (l_ea.cmd))))
							end
						end
						inspect (l_p___0.item).to_integer_32 -- switch 1 head
						when 97 then l_pos := -1 + 13
						when 98 then l_pos := -1 + 15
						when 99 then l_pos := -1 + 18
						when 107 then l_pos := -1 + 21
						when 104 then l_pos := -1 + 24
						when 108 then l_pos := -1 + 27
						when 110 then l_pos := -1 + 30
						when 114 then l_pos := -1 + 33
						when 115 then l_pos := -1 + 36
						when 116 then l_pos := -1 + 39
						when 117 then l_pos := -1 + 42
						when 118 then l_pos := -1 + 45
						else l_pos := -1 + 48
						end
				when 13 then -- switch 1, case 97
						if not (checkforcmd (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_ea.c_pointer + {PD_EXARG}.cmd_offset), ce_string ("aboveleft"), 3)).to_boolean then
							l_pos := -1 + 48 -- switch 1; break
						end
				when 14 then
						globals_inst.cmdmod.split := (globals_inst.cmdmod.split).bit_or ((64))
						js.continue
				when 15 then -- switch 1, case 98
						if not js.loop_jumped then
							if (checkforcmd (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_ea.c_pointer + {PD_EXARG}.cmd_offset), ce_string ("belowright"), 3)).to_boolean then
								globals_inst.cmdmod.split := (globals_inst.cmdmod.split).bit_or ((32))
								js.continue
							end
						end
						if not js.loop_jumped then
							if (checkforcmd (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_ea.c_pointer + {PD_EXARG}.cmd_offset), ce_string ("browse"), 3)).to_boolean then
								globals_inst.cmdmod.browse := 1
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if not (checkforcmd (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_ea.c_pointer + {PD_EXARG}.cmd_offset), ce_string ("botright"), 2)).to_boolean then
							l_pos := -1 + 48 -- switch 1; break
						end
				when 17 then
						globals_inst.cmdmod.split := (globals_inst.cmdmod.split).bit_or ((8))
						js.continue
				when 18 then -- switch 1, case 99
						if js.loop_jumped then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if not (checkforcmd (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_ea.c_pointer + {PD_EXARG}.cmd_offset), ce_string ("confirm"), 4)).to_boolean then
							l_pos := -1 + 48 -- switch 1; break
						end
				when 20 then
						globals_inst.cmdmod.confirm := 1
						js.continue
				when 21 then -- switch 1, case 107
						if not js.loop_jumped then
							if (checkforcmd (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_ea.c_pointer + {PD_EXARG}.cmd_offset), ce_string ("keepmarks"), 3)).to_boolean then
								globals_inst.cmdmod.keepmarks := 1
								js.continue
							end
						end
						if not js.loop_jumped then
							if (checkforcmd (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_ea.c_pointer + {PD_EXARG}.cmd_offset), ce_string ("keepalt"), 5)).to_boolean then
								globals_inst.cmdmod.keepalt := 1
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if not (checkforcmd (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_ea.c_pointer + {PD_EXARG}.cmd_offset), ce_string ("keepjumps"), 5)).to_boolean then
							l_pos := -1 + 48 -- switch 1; break
						end
				when 23 then
						globals_inst.cmdmod.keepjumps := 1
						js.continue
				when 24 then -- switch 1, case 104
						if js.loop_jumped then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= ((l_ea.cmd).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 48 -- switch 1; break
						elseif (checkforcmd (l_p___0.address, ce_string ("hide"), 3)).to_boolean then
							if (l_p___0.item).to_integer_32 = 0 then
								l_pos := -1 + 48 -- switch 1; break
							elseif (ends_excmd ((l_p___0.item).to_integer_32)).to_boolean then
								l_pos := -1 + 48 -- switch 1; break
							end
						else
							l_pos := -1 + 48 -- switch 1; break
						end
				when 26 then
						l_ea.cmd := l_p___0
						globals_inst.cmdmod.hide := 1
						js.continue
				when 27 then -- switch 1, case 108
						if not js.loop_jumped then
							if (checkforcmd (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_ea.c_pointer + {PD_EXARG}.cmd_offset), ce_string ("lockmarks"), 3)).to_boolean then
								globals_inst.cmdmod.lockmarks := 1
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						if not (checkforcmd (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_ea.c_pointer + {PD_EXARG}.cmd_offset), ce_string ("leftabove"), 5)).to_boolean then
							l_pos := -1 + 48 -- switch 1; break
						end
				when 29 then
						globals_inst.cmdmod.split := (globals_inst.cmdmod.split).bit_or ((64))
						js.continue
				when 30 then -- switch 1, case 110
						if js.loop_jumped then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						if not (checkforcmd (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_ea.c_pointer + {PD_EXARG}.cmd_offset), ce_string ("noautocmd"), 3)).to_boolean then
							l_pos := -1 + 48 -- switch 1; break
						end
				when 32 then
						if ((globals_inst.cmdmod.save_ei).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							globals_inst.cmdmod.save_ei := misc2_inst.vim_strsave (option_inst.p_ei)
							option_inst.set_string_option_direct (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ei")), -1, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("all")), 1, -6)
						end
						js.continue
				when 33 then -- switch 1, case 114
						if js.loop_jumped then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						if not (checkforcmd (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_ea.c_pointer + {PD_EXARG}.cmd_offset), ce_string ("rightbelow"), 6)).to_boolean then
							l_pos := -1 + 48 -- switch 1; break
						end
				when 35 then
						globals_inst.cmdmod.split := (globals_inst.cmdmod.split).bit_or ((32))
						js.continue
				when 36 then -- switch 1, case 115
						if not js.loop_jumped then
							if (checkforcmd (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_ea.c_pointer + {PD_EXARG}.cmd_offset), ce_string ("sandbox"), 3)).to_boolean then
								if not l_did_sandbox.to_boolean then
									globals_inst.sandbox := globals_inst.sandbox + 1
								end
								l_did_sandbox := 1
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						if not (checkforcmd (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_ea.c_pointer + {PD_EXARG}.cmd_offset), ce_string ("silent"), 3)).to_boolean then
							l_pos := -1 + 48 -- switch 1; break
						end
				when 38 then
						if l_save_msg_silent = -1 then
							l_save_msg_silent := globals_inst.msg_silent
						end
						globals_inst.msg_silent := globals_inst.msg_silent + 1
						if ((l_ea.cmd).item).to_integer_32 = 33 then
							if (l_ea.cmd[-1]).to_integer_32 /= 32 then
								if (l_ea.cmd[-1]).to_integer_32 /= 9 then
									l_ea.cmd := charset_inst.skipwhite (l_ea.cmd + 1)
									globals_inst.emsg_silent := globals_inst.emsg_silent + 1
									l_did_esilent := l_did_esilent + 1
								end
							end
						end
						js.continue
				when 39 then -- switch 1, case 116
						if not js.loop_jumped then
							if (checkforcmd (l_p___0.address, ce_string ("tab"), 3)).to_boolean then
								if (charset_inst.vim_isdigit (((l_ea.cmd).item).to_integer_32)).to_boolean then
									globals_inst.cmdmod.tab := (atoi (create {CE_POINTER [INTEGER_8]}.make_cast (l_ea.cmd))) + 1
								else
									globals_inst.cmdmod.tab := (window_inst.tabpage_index (globals_inst.curtab)) + 1
								end
								l_ea.cmd := l_p___0
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 42 -- skip if block
						end
				when 40 then -- if:
						if not (checkforcmd (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_ea.c_pointer + {PD_EXARG}.cmd_offset), ce_string ("topleft"), 2)).to_boolean then
							l_pos := -1 + 48 -- switch 1; break
						end
				when 41 then
						globals_inst.cmdmod.split := (globals_inst.cmdmod.split).bit_or ((4))
						js.continue
				when 42 then -- switch 1, case 117
						if js.loop_jumped then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if:
						if not (checkforcmd (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_ea.c_pointer + {PD_EXARG}.cmd_offset), ce_string ("unsilent"), 3)).to_boolean then
							l_pos := -1 + 48 -- switch 1; break
						end
				when 44 then
						if l_save_msg_silent = -1 then
							l_save_msg_silent := globals_inst.msg_silent
						end
						globals_inst.msg_silent := 0
						js.continue
				when 45 then -- switch 1, case 118
						if not js.loop_jumped then
							if (checkforcmd (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_ea.c_pointer + {PD_EXARG}.cmd_offset), ce_string ("vertical"), 4)).to_boolean then
								globals_inst.cmdmod.split := (globals_inst.cmdmod.split).bit_or ((2))
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 48 -- skip if block
						end
				when 46 then -- if:
						if not (checkforcmd (l_p___0.address, ce_string ("verbose"), 4)).to_boolean then
							l_pos := -1 + 48 -- switch 1; break
						end
				when 47 then
						if l_verbose_save < 0 then
							l_verbose_save := option_inst.p_verbose
						end
						if (charset_inst.vim_isdigit (((l_ea.cmd).item).to_integer_32)).to_boolean then
							option_inst.p_verbose := (atoi (create {CE_POINTER [INTEGER_8]}.make_cast (l_ea.cmd))).to_integer_32
						else
							option_inst.p_verbose := 1
						end
						l_ea.cmd := l_p___0
						js.continue
				when 48 then -- switch 1, done:
						if not js.loop_jumped then
							js.break
						end
						if not js.loop_left then
							
						end
						l_pos := -1 + 2 -- back to loop condition
				when 49 then -- loop done
					js.reset
					if globals_inst.did_emsg.to_boolean then
						l_tmp___29 := 1
					elseif globals_inst.got_int.to_boolean then
						l_tmp___29 := 1
					elseif globals_inst.did_throw.to_boolean then
						l_tmp___29 := 1
					elseif a_cstack.item.cs_idx >= 0 then
						if not (((a_cstack.item.cs_flags[a_cstack.item.cs_idx]).to_integer_32).bit_and (2)).to_boolean then
							l_tmp___29 := 1
						else
							l_tmp___29 := 0
						end
					else
						l_tmp___29 := 0
					end
					l_ea.skip := l_tmp___29
					ex_cmds2_inst.dbg_check_breakpoint (l_ea.address)
					if not (l_ea.skip).to_boolean then
						if globals_inst.got_int.to_boolean then
							l_ea.skip := 1
							ex_eval_inst.do_intthrow (a_cstack).do_nothing
						end
					end
				when 50 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 65 -- skip loop
					end
				when 51 then -- loop body:
						js.reset
						l_ea.line1 := l_ea.line2
						l_ea.line2 := globals_inst.curwin.item.w_cursor.lnum
						l_ea.cmd := charset_inst.skipwhite (l_ea.cmd)
						l_lnum := get_address (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_ea.c_pointer + {PD_EXARG}.cmd_offset), l_ea.skip, (l_ea.addr_count = 0).to_integer)
						if ((l_ea.cmd).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 190 -- goto doend
						end
				when 52 then
						if l_lnum /= 2147483647 then
							l_pos := -1 + 63 -- skip if block
						end
				when 53 then -- if:
						if ((l_ea.cmd).item).to_integer_32 /= 37 then
							l_pos := -1 + 56 -- skip if block
						end
				when 54 then -- if:
						l_ea.cmd := (l_ea.cmd) + 1
						l_ea.line1 := (1).to_integer_32
						l_ea.line2 := globals_inst.curbuf.item.b_ml.ml_line_count
						l_ea.addr_count := (l_ea.addr_count) + 1
				when 55 then -- if block done, skip else block:
						l_pos := -1 + 62
				when 56 then -- else:
						if ((l_ea.cmd).item).to_integer_32 /= 42 then
							l_pos := -1 + 62 -- skip if block
						end
				when 57 then -- if:
						if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('*').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 62 -- skip if block
						end
				when 58 then -- if:
						l_ea.cmd := (l_ea.cmd) + 1
						if (l_ea.skip).to_boolean then
							l_pos := -1 + 62 -- skip if block
						end
				when 59 then -- if:
						l_fp.ce_gets (mark_inst.getmark (('<').code, 0))
						if (mark_inst.check_mark (l_fp)) = 0 then
							l_pos := -1 + 190 -- goto doend
						end
				when 60 then
						l_ea.line1 := l_fp.item.lnum
						l_fp.ce_gets (mark_inst.getmark (('>').code, 0))
						if (mark_inst.check_mark (l_fp)) = 0 then
							l_pos := -1 + 190 -- goto doend
						end
				when 61 then
						l_ea.line2 := l_fp.item.lnum
						l_ea.addr_count := (l_ea.addr_count) + 1
				when 62 then -- if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 64
				when 63 then -- else:
						l_ea.line2 := l_lnum
				when 64 then -- if done
						l_ea.addr_count := (l_ea.addr_count) + 1
						if ((l_ea.cmd).item).to_integer_32 = 59 then
							if not (l_ea.skip).to_boolean then
								globals_inst.curwin.item.w_cursor.lnum := l_ea.line2
							end
						elseif ((l_ea.cmd).item).to_integer_32 /= 44 then
							js.break
						end
						if not js.loop_jumped then
							l_ea.cmd := (l_ea.cmd) + 1
						end
						l_pos := -1 + 50 -- back to loop condition
				when 65 then -- loop done
					js.reset
					if l_ea.addr_count = 1 then
						l_ea.line1 := l_ea.line2
						if l_lnum = 2147483647 then
							l_ea.addr_count := 0
						end
					end
					misc2_inst.check_cursor_lnum
					l_ea.cmd := charset_inst.skipwhite (l_ea.cmd)
					from
					until
						((l_ea.cmd).item).to_integer_32 /= 58
					loop
						l_ea.cmd := charset_inst.skipwhite (l_ea.cmd + 1)
					end
					if ((l_ea.cmd).item).to_integer_32 /= 0 then
						l_pos := -1 + 68 -- skip if block
					end
				when 66 then -- if:
						l_pos := -1 + 72 -- goto _L___2
				when 67 then -- if block done, skip else block:
						l_pos := -1 + 84
				when 68 then -- else:
						if ((l_ea.cmd).item).to_integer_32 /= 34 then
							l_pos := -1 + 71 -- skip if block
						end
				when 69 then -- if:
						l_pos := -1 + 72 -- goto _L___2
				when 70 then -- if block done, skip else block:
						l_pos := -1 + 84
				when 71 then -- else:
						l_ea.nextcmd := check_nextcmd (l_ea.cmd)
						if ((l_ea.nextcmd).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 84 -- skip if block
						end
				when 72 then -- if: | _L___2:
						if (l_ea.skip).to_boolean then
							l_pos := -1 + 190 -- goto doend
						end
				when 73 then
						if ((l_ea.cmd).item).to_integer_32 /= 124 then
							l_pos := -1 + 76 -- skip if block
						end
				when 74 then -- if:
						l_pos := -1 + 78 -- goto _L___0
				when 75 then -- if block done, skip else block:
						l_pos := -1 + 83
				when 76 then -- else:
						if not (globals_inst.exmode_active.to_boolean) then
							l_pos := -1 + 82 -- skip if block
						end
				when 77 then -- if:
						if l_ea.line1 = l_ea.line2 then
							l_pos := -1 + 80 -- skip if block
						end
				when 78 then -- if: | _L___0:
						l_ea.cmdidx := {PC_CMD_INDEX}.CMD_print
						l_ea.argt := 1281
						l_errormsg.ce_gets (invalid_range (l_ea.address))
						if (l_errormsg.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							correct_range (l_ea.address)
							ex_print (l_ea.address)
						end
				when 79 then -- if block done, skip else block:
						l_pos := -1 + 81
				when 80 then -- else:
						l_pos := -1 + 82 -- goto _L___1
				when 81 then -- if done | if block done, skip else block:
						l_pos := -1 + 83
				when 82 then -- else: | _L___1:
						if l_ea.addr_count /= 0 then
							if l_ea.line2 > globals_inst.curbuf.item.b_ml.ml_line_count then
								if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('-').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_ea.line2 := (-1).to_integer_32
								else
									l_ea.line2 := globals_inst.curbuf.item.b_ml.ml_line_count
								end
							end
							if l_ea.line2 < 0 then
								l_errormsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invrange)))))
							else
								if l_ea.line2 = 0 then
									globals_inst.curwin.item.w_cursor.lnum := (1).to_integer_32
								else
									globals_inst.curwin.item.w_cursor.lnum := l_ea.line2
								end
								edit_inst.beginline (6)
							end
						end
				when 83 then -- if done
						l_pos := -1 + 190 -- goto doend
				when 84 then -- if done | if done
						l_p___0.ce_gets (find_command (l_ea.address, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if not (l_ea.skip).to_boolean then
								l_errormsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E464: Ambiguous use of user-defined command")))))
							end
							l_pos := -1 + 190 -- goto doend
						end
				when 85 then
						if (l_p___0.item).to_integer_32 = 33 then
							if (l_ea.cmd[1]).to_integer_32 = 105 then
								if (l_ea.cmd[0]).to_integer_32 = 78 then
									l_errormsg.ce_gets (uc_fun_cmd)
									l_pos := -1 + 190 -- goto doend
								end
							end
						end
				when 86 then
						if l_ea.cmdidx = 517 then
							if not (l_ea.skip).to_boolean then
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("E492: Not an editor command")))).do_nothing
								if not a_sourcing.to_boolean then
									strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), ce_string (": ")).do_nothing
									strncat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), create {CE_POINTER [INTEGER_8]}.make_cast (a_cmdlinep.item), (40).to_natural_32).do_nothing
								end
								l_errormsg.ce_gets (globals_inst.IObuff)
							end
							l_pos := -1 + 190 -- goto doend
						end
				when 87 then
						if not (l_ea.cmdidx < 0) then
							if ((ex_cmds_inst.cmdnames[l_ea.cmdidx].cmd_func).c_pointer.to_integer_32).to_natural_32 = ((ex_ni_address).c_pointer.to_integer_32).to_natural_32 then
								l_tmp___37 := 1
							elseif ((ex_cmds_inst.cmdnames[l_ea.cmdidx].cmd_func).c_pointer.to_integer_32).to_natural_32 = ((ex_script_ni_address).c_pointer.to_integer_32).to_natural_32 then
								l_tmp___37 := 1
							else
								l_tmp___37 := 0
							end
						else
							l_tmp___37 := 0
						end
						l_ni := l_tmp___37
						if (l_p___0.item).to_integer_32 = 33 then
							if l_ea.cmdidx /= 349 then
								if l_ea.cmdidx /= 379 then
									if l_ea.cmdidx /= 385 then
										l_p___0.ce_gets (l_p___0 + 1)
										l_ea.forceit := 1
									else
										l_ea.forceit := 0
									end
								else
									l_ea.forceit := 0
								end
							else
								l_ea.forceit := 0
							end
						else
							l_ea.forceit := 0
						end
						if not (l_ea.cmdidx < 0) then
							l_ea.argt := (ex_cmds_inst.cmdnames[l_ea.cmdidx].cmd_argt).to_integer_32
						end
						if (l_ea.skip).to_boolean then
							l_pos := -1 + 93 -- skip if block
						end
				when 88 then -- if:
							if globals_inst.sandbox /= 0 then
								if not ((l_ea.argt).bit_and (524288)).to_boolean then
									l_errormsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_sandbox)))))
									l_pos := -1 + 190 -- goto doend
								end
							end
				when 89 then
							if not (globals_inst.curbuf.item.b_p_ma).to_boolean then
								if ((l_ea.argt).bit_and (2097152)).to_boolean then
									l_errormsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_modifiable)))))
									l_pos := -1 + 190 -- goto doend
								end
							end
				when 90 then
							if (ex_getln_inst.text_locked).to_boolean then
								if not ((l_ea.argt).bit_and (1048576)).to_boolean then
									if not (l_ea.cmdidx < 0) then
										if globals_inst.cmdwin_type /= 0 then
											l_errormsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_cmdwin)))))
										else
											l_errormsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_secure)))))
										end
										l_pos := -1 + 190 -- goto doend
									end
								end
							end
				when 91 then
							if not ((l_ea.argt).bit_and (1048576)).to_boolean then
								if l_ea.cmdidx /= 120 then
									if l_ea.cmdidx /= 66 then
										if not (l_ea.cmdidx < 0) then
											if (ex_getln_inst.curbuf_locked).to_boolean then
												l_pos := -1 + 190 -- goto doend
											end
										end
									end
								end
							end
				when 92 then
							if not l_ni.to_boolean then
								if not ((l_ea.argt).bit_and (1)).to_boolean then
									if l_ea.addr_count > 0 then
										l_errormsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_norange)))))
										l_pos := -1 + 190 -- goto doend
									end
								end
							end
				when 93 then
						if not l_ni.to_boolean then
							if not ((l_ea.argt).bit_and (2)).to_boolean then
								if (l_ea.forceit).to_boolean then
									l_errormsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_nobang)))))
									l_pos := -1 + 190 -- goto doend
								end
							end
						end
				when 94 then
						if (l_ea.skip).to_boolean then
							l_pos := -1 + 103 -- skip if block
						end
				when 95 then -- if:
							if l_ni.to_boolean then
								l_pos := -1 + 103 -- skip if block
							end
				when 96 then -- if:
							if globals_inst.global_busy.to_boolean then
								l_pos := -1 + 102 -- skip if block
							end
				when 97 then -- if:
							if not (l_ea.line1 > l_ea.line2) then
								l_pos := -1 + 102 -- skip if block
							end
				when 98 then -- if:
							if globals_inst.msg_silent /= 0 then
								l_pos := -1 + 101 -- skip if block
							end
				when 99 then -- if:
							if a_sourcing.to_boolean then
								l_tmp___46.ce_gets (gettext (ce_string ("E493: Backwards range given")))
								l_errormsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___46))
								l_pos := -1 + 190 -- goto doend
							elseif globals_inst.exmode_active.to_boolean then
								l_tmp___46.ce_gets (gettext (ce_string ("E493: Backwards range given")))
								l_errormsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___46))
								l_pos := -1 + 190 -- goto doend
							end
				when 100 then
							if (misc1_inst.ask_yesno (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Backwards range given, OK to swap")))), 0)) /= 121 then
								l_pos := -1 + 190 -- goto doend
							end
				when 101 then
							l_lnum := l_ea.line1
							l_ea.line1 := l_ea.line2
							l_ea.line2 := l_lnum
				when 102 then -- if done | if done
							l_errormsg.ce_gets (invalid_range (l_ea.address))
							if (l_errormsg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_pos := -1 + 190 -- goto doend
							end
				when 103 then -- if done
							if ((l_ea.argt).bit_and (16384)).to_boolean then
								if l_ea.addr_count = 0 then
									l_ea.line2 := (1).to_integer_32
								end
							end
							correct_range (l_ea.address)
							if not (((l_ea.argt).bit_and (64)).to_boolean) then
								l_pos := -1 + 106 -- skip if block
							end
				when 104 then -- if:
								l_pos := -1 + 107 -- goto _L___3
				when 105 then -- if block done, skip else block:
								l_pos := -1 + 108
				when 106 then -- else:
								if not (l_ea.addr_count >= 2) then
									l_pos := -1 + 108 -- skip if block
								end
				when 107 then -- if: | _L___3:
								if not globals_inst.global_busy.to_boolean then
									fold_inst.hasFolding (l_ea.line1, create {CE_POINTER [INTEGER_32]}.make_shared (l_ea.c_pointer + {PD_EXARG}.line1_offset), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)).do_nothing
									fold_inst.hasFolding (l_ea.line2, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (l_ea.c_pointer + {PD_EXARG}.line2_offset)).do_nothing
								end
				when 108 then -- if done
								l_p___0.ce_gets (replace_makeprg (l_ea.address, l_p___0, a_cmdlinep))
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_pos := -1 + 190 -- goto doend
								end
				when 109 then
								if l_ea.cmdidx = 505 then
									l_ea.arg := l_p___0
								else
									l_ea.arg := charset_inst.skipwhite (l_p___0)
								end
								if not (((l_ea.argt).bit_and (262144)).to_boolean) then
									l_pos := -1 + 114 -- skip if block
								end
				when 110 then -- if: | loop condition:
									if js.loop_left then
										l_pos := -1 + 113 -- skip loop
									end
				when 111 then -- loop body:
									js.reset
									if (l_ea.arg[0]).to_integer_32 = 43 then
										if (l_ea.arg[1]).to_integer_32 /= 43 then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										if (getargopt (l_ea.address)) = 0 then
											if not l_ni.to_boolean then
												l_errormsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg)))))
												l_pos := -1 + 190 -- goto doend
											end
										end
									end
				when 112 then
									l_pos := -1 + 110 -- back to loop condition
				when 113 then -- loop done
									js.reset
				when 114 then -- if done
								if l_ea.cmdidx /= 479 then
									l_pos := -1 + 117 -- skip if block
								end
				when 115 then -- if:
									l_pos := -1 + 118 -- goto _L___4
				when 116 then -- if block done, skip else block:
									l_pos := -1 + 123
				when 117 then -- else:
									if l_ea.cmdidx /= 460 then
										l_pos := -1 + 123 -- skip if block
									end
				when 118 then -- if: | _L___4:
									if ((l_ea.arg).item).to_integer_32 /= 62 then
										l_pos := -1 + 122 -- skip if block
									end
				when 119 then -- if:
									l_ea.arg := (l_ea.arg) + 1
									if ((l_ea.arg).item).to_integer_32 /= 62 then
										l_errormsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E494: Use w or w>>")))))
										l_pos := -1 + 190 -- goto doend
									end
				when 120 then
									l_ea.arg := charset_inst.skipwhite (l_ea.arg + 1)
									l_ea.append := 1
				when 121 then -- if block done, skip else block:
									l_pos := -1 + 123
				when 122 then -- else:
									if ((l_ea.arg).item).to_integer_32 = 33 then
										if l_ea.cmdidx = 479 then
											l_ea.arg := (l_ea.arg) + 1
											l_ea.usefilter := 1
										end
									end
				when 123 then -- if done | if done
									if l_ea.cmdidx = 330 then
										if (l_ea.forceit).to_boolean then
											l_ea.usefilter := 1
											l_ea.forceit := 0
										elseif ((l_ea.arg).item).to_integer_32 = 33 then
											l_ea.arg := (l_ea.arg) + 1
											l_ea.usefilter := 1
										end
									end
									if l_ea.cmdidx /= 509 then
										l_pos := -1 + 126 -- skip if block
									end
				when 124 then -- if:
										l_pos := -1 + 127 -- goto _L___5
				when 125 then -- if block done, skip else block:
										l_pos := -1 + 128
				when 126 then -- else:
										if l_ea.cmdidx /= 511 then
											l_pos := -1 + 128 -- skip if block
										end
				when 127 then -- if: | _L___5:
										l_ea.amount := 1
										from
										until
											((l_ea.arg).item).to_integer_32 /= ((l_ea.cmd).item).to_integer_32
										loop
											l_ea.arg := (l_ea.arg) + 1
											l_ea.amount := (l_ea.amount) + 1
										end
										l_ea.arg := charset_inst.skipwhite (l_ea.arg)
				when 128 then -- if done
										if ((l_ea.argt).bit_and (32768)).to_boolean then
											if not (l_ea.usefilter).to_boolean then
												l_ea.do_ecmd_cmd := getargcmd (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_ea.c_pointer + {PD_EXARG}.arg_offset))
											end
										end
										if not (((l_ea.argt).bit_and (256)).to_boolean) then
											l_pos := -1 + 131 -- skip if block
										end
				when 129 then -- if:
											if not (l_ea.usefilter).to_boolean then
												separate_nextcmd (l_ea.address)
											else
												l_pos := -1 + 131 -- goto _L___8
											end
				when 130 then -- if block done, skip else block:
											l_pos := -1 + 149
				when 131 then -- else: | _L___8:
											if l_ea.cmdidx /= 505 then
												l_pos := -1 + 134 -- skip if block
											end
				when 132 then -- if:
											l_pos := -1 + 141 -- goto _L___7
				when 133 then -- if block done, skip else block:
											l_pos := -1 + 149
				when 134 then -- else:
											if l_ea.cmdidx /= 155 then
												l_pos := -1 + 137 -- skip if block
											end
				when 135 then -- if:
											l_pos := -1 + 141 -- goto _L___7
				when 136 then -- if block done, skip else block:
											l_pos := -1 + 149
				when 137 then -- else:
											if l_ea.cmdidx /= 461 then
												l_pos := -1 + 140 -- skip if block
											end
				when 138 then -- if:
											l_pos := -1 + 141 -- goto _L___7
				when 139 then -- if block done, skip else block:
											l_pos := -1 + 149
				when 140 then -- else:
											if not ((l_ea.usefilter).to_boolean) then
												l_pos := -1 + 149 -- skip if block
											end
				when 141 then -- if: | _L___7:
											l_p___0.ce_gets (l_ea.arg)
				when 142 then -- loop condition:
											if not (not js.loop_left and then ((l_p___0.item).to_boolean)) then
												l_pos := -1 + 148 -- skip loop
											end
				when 143 then -- loop body:
											js.reset
											if (l_p___0.item).to_integer_32 /= 92 then
												l_pos := -1 + 146 -- skip if block
											end
				when 144 then -- if:
											if (l_p___0[1]).to_integer_32 = 10 then
												memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 1)))) + {NATURAL_32} 1).do_nothing
											else
												l_pos := -1 + 146 -- goto _L___6
											end
				when 145 then -- if block done, skip else block:
											l_pos := -1 + 147
				when 146 then -- else: | _L___6:
											if (l_p___0.item).to_integer_32 = 10 then
												l_ea.nextcmd := l_p___0 + 1
												l_p___0.item := (('%/0/').code).to_natural_8
												js.break
											end
				when 147 then
											if not js.loop_jumped then
												l_p___0.ce_gets (l_p___0 + 1)
											end
											l_pos := -1 + 142 -- back to loop condition
				when 148 then -- loop done
											js.reset
				when 149 then -- if done | if done | if done | if done
											if ((l_ea.argt).bit_and (32)).to_boolean then
												if l_ea.addr_count = 0 then
													l_ea.line1 := (1).to_integer_32
													l_ea.line2 := globals_inst.curbuf.item.b_ml.ml_line_count
												end
											end
											if not (((l_ea.argt).bit_and (512)).to_boolean) then
												l_pos := -1 + 160 -- skip if block
											end
				when 150 then -- if:
												if ((l_ea.arg).item).to_integer_32 = 0 then
													l_pos := -1 + 160 -- skip if block
												end
				when 151 then -- if:
												if l_ea.cmdidx /= 320 then
													if l_ea.cmdidx < 0 then
														l_tmp___56 := 1
													else
														l_tmp___56 := 0
													end
												else
													l_tmp___56 := 0
												end
												if not ((ops_inst.valid_yank_reg (((l_ea.arg).item).to_integer_32, l_tmp___56)).to_boolean) then
													l_pos := -1 + 160 -- skip if block
												end
				when 152 then -- if:
												if (l_ea.cmdidx < 0) then
													l_pos := -1 + 155 -- skip if block
												end
				when 153 then -- if:
												l_pos := -1 + 156 -- goto _L___10
				when 154 then -- if block done, skip else block:
												l_pos := -1 + 160
				when 155 then -- else:
												if ((l_ea.arg).item).to_integer_32 = 61 then
													l_pos := -1 + 160 -- skip if block
												end
				when 156 then -- if: | _L___10:
												if not (((l_ea.argt).bit_and (1024)).to_boolean) then
													l_pos := -1 + 159 -- skip if block
												end
				when 157 then -- if:
												if ((l_ea.arg).item).to_integer_32 >= 48 then
													if not (((l_ea.arg).item).to_integer_32 <= 57) then
														l_pos := -1 + 159 -- goto _L___9
													end
												else
													l_pos := -1 + 159 -- goto _L___9
												end
				when 158 then -- if block done, skip else block:
												l_pos := -1 + 160
				when 159 then -- else: | _L___9:
												l_tmp___53.ce_gets (l_ea.arg)
												l_ea.arg := (l_ea.arg) + 1
												l_ea.regname := (l_tmp___53.item).to_integer_32
												if (l_ea.arg[-1]).to_integer_32 = 61 then
													if (l_ea.arg[0]).to_integer_32 /= 0 then
														ops_inst.set_expr_line ((misc2_inst.vim_strsave (l_ea.arg)))
														l_ea.arg := l_ea.arg + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ea.arg))).to_integer_32
													end
												end
												l_ea.arg := charset_inst.skipwhite (l_ea.arg)
				when 160 then -- if done | if done | if done | if done | if done
												if not (((l_ea.argt).bit_and (1024)).to_boolean) then
													l_pos := -1 + 175 -- skip if block
												end
				when 161 then -- if:
													if not (((l_ea.arg).item).to_integer_32 >= 48) then
														l_pos := -1 + 175 -- skip if block
													end
				when 162 then -- if:
													if not (((l_ea.arg).item).to_integer_32 <= 57) then
														l_pos := -1 + 175 -- skip if block
													end
				when 163 then -- if:
													if ((l_ea.argt).bit_and (65536)).to_boolean then
														l_pos := -1 + 166 -- skip if block
													end
				when 164 then -- if:
													l_pos := -1 + 173 -- goto _L___12
				when 165 then -- if block done, skip else block:
													l_pos := -1 + 175
				when 166 then -- else:
													l_p___0.ce_gets (charset_inst.skipdigits (l_ea.arg))
													if (l_p___0.item).to_integer_32 /= 0 then
														l_pos := -1 + 169 -- skip if block
													end
				when 167 then -- if:
													l_pos := -1 + 173 -- goto _L___12
				when 168 then -- if block done, skip else block:
													l_pos := -1 + 175
				when 169 then -- else:
													if (l_p___0.item).to_integer_32 /= 32 then
														l_pos := -1 + 172 -- skip if block
													end
				when 170 then -- if:
													l_pos := -1 + 173 -- goto _L___12
				when 171 then -- if block done, skip else block:
													l_pos := -1 + 175
				when 172 then -- else:
													if (l_p___0.item).to_integer_32 /= 9 then
														l_pos := -1 + 175 -- skip if block
													end
				when 173 then -- if: | _L___12:
													l_n := charset_inst.getdigits (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (l_ea.c_pointer + {PD_EXARG}.arg_offset))
													l_ea.arg := charset_inst.skipwhite (l_ea.arg)
													if l_n <= 0 then
														if not l_ni.to_boolean then
															if ((l_ea.argt).bit_and (4096)) = 0 then
																l_errormsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_zerocount)))))
																l_pos := -1 + 190 -- goto doend
															end
														end
													end
				when 174 then
													if ((l_ea.argt).bit_and (16384)).to_boolean then
														l_ea.line2 := l_n
														if l_ea.addr_count = 0 then
															l_ea.addr_count := 1
														end
													else
														l_ea.line1 := l_ea.line2
														l_ea.line2 := l_ea.line2 + (l_n - 1)
														l_ea.addr_count := (l_ea.addr_count) + 1
														if l_ea.line2 > globals_inst.curbuf.item.b_ml.ml_line_count then
															l_ea.line2 := globals_inst.curbuf.item.b_ml.ml_line_count
														end
													end
				when 175 then -- if done | if done | if done | if done | if done | if done
													if ((l_ea.argt).bit_and (4194304)).to_boolean then
														get_flags (l_ea.address)
													end
													if not l_ni.to_boolean then
														if not ((l_ea.argt).bit_and (4)).to_boolean then
															if ((l_ea.arg).item).to_integer_32 /= 0 then
																if ((l_ea.arg).item).to_integer_32 /= 34 then
																	if ((l_ea.arg).item).to_integer_32 /= 124 then
																		l_tmp___59.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_trailing)))
																		l_errormsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___59))
																		l_pos := -1 + 190 -- goto doend
																	elseif ((l_ea.argt).bit_and (256)) = 0 then
																		l_tmp___59.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_trailing)))
																		l_errormsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___59))
																		l_pos := -1 + 190 -- goto doend
																	end
																end
															end
														end
													end
				when 176 then
													if not l_ni.to_boolean then
														if ((l_ea.argt).bit_and (128)).to_boolean then
															if ((l_ea.arg).item).to_integer_32 = 0 then
																l_errormsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_argreq)))))
																l_pos := -1 + 190 -- goto doend
															end
														end
													end
				when 177 then
													if not ((l_ea.skip).to_boolean) then
														l_pos := -1 + 182 -- skip if block
													end
				when 178 then -- if:
														inspect l_ea.cmdidx -- switch 2 head
														when 482 then l_pos := -1 + 179
														when 134 then l_pos := -1 + 179
														when 153 then l_pos := -1 + 179
														when 132 then l_pos := -1 + 179
														when 172 then l_pos := -1 + 179
														when 128 then l_pos := -1 + 179
														when 127 then l_pos := -1 + 179
														when 130 then l_pos := -1 + 179
														when 447 then l_pos := -1 + 179
														when 51 then l_pos := -1 + 179
														when 144 then l_pos := -1 + 179
														when 133 then l_pos := -1 + 179
														when 154 then l_pos := -1 + 179
														when 3 then l_pos := -1 + 180
														when 507 then l_pos := -1 + 180
														when 25 then l_pos := -1 + 180
														when 30 then l_pos := -1 + 180
														when 37 then l_pos := -1 + 180
														when 50 then l_pos := -1 + 180
														when 86 then l_pos := -1 + 180
														when 103 then l_pos := -1 + 180
														when 113 then l_pos := -1 + 180
														when 114 then l_pos := -1 + 180
														when 118 then l_pos := -1 + 180
														when 119 then l_pos := -1 + 180
														when 122 then l_pos := -1 + 180
														when 123 then l_pos := -1 + 180
														when 125 then l_pos := -1 + 180
														when 126 then l_pos := -1 + 180
														when 137 then l_pos := -1 + 180
														when 161 then l_pos := -1 + 180
														when 167 then l_pos := -1 + 180
														when 173 then l_pos := -1 + 180
														when 174 then l_pos := -1 + 180
														when 182 then l_pos := -1 + 180
														when 183 then l_pos := -1 + 180
														when 192 then l_pos := -1 + 180
														when 191 then l_pos := -1 + 180
														when 190 then l_pos := -1 + 180
														when 208 then l_pos := -1 + 180
														when 209 then l_pos := -1 + 180
														when 231 then l_pos := -1 + 180
														when 239 then l_pos := -1 + 180
														when 253 then l_pos := -1 + 180
														when 263 then l_pos := -1 + 180
														when 298 then l_pos := -1 + 180
														when 310 then l_pos := -1 + 180
														when 322 then l_pos := -1 + 180
														when 324 then l_pos := -1 + 180
														when 325 then l_pos := -1 + 180
														when 339 then l_pos := -1 + 180
														when 342 then l_pos := -1 + 180
														when 344 then l_pos := -1 + 180
														when 376 then l_pos := -1 + 180
														when 379 then l_pos := -1 + 180
														when 385 then l_pos := -1 + 180
														when 349 then l_pos := -1 + 180
														when 413 then l_pos := -1 + 180
														when 419 then l_pos := -1 + 180
														when 434 then l_pos := -1 + 180
														when 439 then l_pos := -1 + 180
														when 516 then l_pos := -1 + 180
														when 444 then l_pos := -1 + 180
														when 455 then l_pos := -1 + 180
														when 463 then l_pos := -1 + 180
														when 464 then l_pos := -1 + 180
														else l_pos := -1 + 181
														end
				when 179 then -- switch 2, case 482 | switch 2, case 134 | switch 2, case 153 | switch 2, case 132 | switch 2, case 172 | switch 2, case 128 | switch 2, case 127 | switch 2, case 130 | switch 2, case 447 | switch 2, case 51 | switch 2, case 144 | switch 2, case 133 | switch 2, case 154
														l_pos := -1 + 182 -- switch 2; break
				when 180 then -- switch 2, case 3 | switch 2, case 507 | switch 2, case 25 | switch 2, case 30 | switch 2, case 37 | switch 2, case 50 | switch 2, case 86 | switch 2, case 103 | switch 2, case 113 | switch 2, case 114 | switch 2, case 118 | switch 2, case 119 | switch 2, case 122 | switch 2, case 123 | switch 2, case 125 | switch 2, case 126 | switch 2, case 137 | switch 2, case 161 | switch 2, case 167 | switch 2, case 173 | switch 2, case 174 | switch 2, case 182 | switch 2, case 183 | switch 2, case 192 | switch 2, case 191 | switch 2, case 190 | switch 2, case 208 | switch 2, case 209 | switch 2, case 231 | switch 2, case 239 | switch 2, case 253 | switch 2, case 263 | switch 2, case 298 | switch 2, case 310 | switch 2, case 322 | switch 2, case 324 | switch 2, case 325 | switch 2, case 339 | switch 2, case 342 | switch 2, case 344 | switch 2, case 376 | switch 2, case 379 | switch 2, case 385 | switch 2, case 349 | switch 2, case 413 | switch 2, case 419 | switch 2, case 434 | switch 2, case 439 | switch 2, case 516 | switch 2, case 444 | switch 2, case 455 | switch 2, case 463 | switch 2, case 464
														l_pos := -1 + 182 -- switch 2; break
				when 181 then -- switch 2, default:
														l_pos := -1 + 190 -- goto doend
				when 182 then -- switch 2, done: | if done
														if ((l_ea.argt).bit_and (8)).to_boolean then
															if (expand_filename (l_ea.address, a_cmdlinep, l_errormsg.address)) = 0 then
																l_pos := -1 + 190 -- goto doend
															end
														end
				when 183 then
														if not (((l_ea.argt).bit_and (65536)).to_boolean) then
															l_pos := -1 + 189 -- skip if block
														end
				when 184 then -- if:
															if ((l_ea.arg).item).to_integer_32 = 0 then
																l_pos := -1 + 189 -- skip if block
															end
				when 185 then -- if:
															if l_ea.addr_count /= 0 then
																l_pos := -1 + 189 -- skip if block
															end
				when 186 then -- if:
															if (l_ea.cmdidx < 0) then
																l_pos := -1 + 189 -- skip if block
															end
				when 187 then -- if:
															if l_ea.cmdidx = 23 then
																l_p___0.ce_gets (charset_inst.skiptowhite_esc (l_ea.arg))
															elseif l_ea.cmdidx = 41 then
																l_p___0.ce_gets (charset_inst.skiptowhite_esc (l_ea.arg))
															elseif l_ea.cmdidx = 40 then
																l_p___0.ce_gets (charset_inst.skiptowhite_esc (l_ea.arg))
															else
																l_p___0.ce_gets (l_ea.arg + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ea.arg))).to_integer_32)
																from
																until
																	js.loop_left
																loop
																	js.reset
																	if (l_p___0.c_pointer.to_integer_32).to_natural_32 > ((l_ea.arg).c_pointer.to_integer_32).to_natural_32 then
																		if (l_p___0[-1]).to_integer_32 /= 32 then
																			if (l_p___0[-1]).to_integer_32 /= 9 then
																				js.break
																			end
																		end
																	else
																		js.break
																	end
																	if not js.loop_jumped then
																		l_p___0.ce_gets (l_p___0 - 1)
																	end
																end
																js.reset
															end
															l_ea.line2 := (buffer_inst.buflist_findpat (l_ea.arg, l_p___0, (((l_ea.argt).bit_and (131072)) /= 0).to_integer, 0)).to_integer_32
															if l_ea.line2 < 0 then
																l_pos := -1 + 190 -- goto doend
															end
				when 188 then
															l_ea.addr_count := 1
															l_ea.arg := charset_inst.skipwhite (l_p___0)
				when 189 then -- if done | if done | if done | if done
															l_ea.cmdlinep := a_cmdlinep
															l_ea.getline := a_fgetline
															l_ea.cookie := a_cookie
															l_ea.cstack := a_cstack
															if l_ea.cmdidx < 0 then
																do_ucmd (l_ea.address)
															else
																l_ea.errmsg := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer);
																(ex_cmds_inst.cmdnames[l_ea.cmdidx].cmd_func).call ([l_ea.address])
																if ((l_ea.errmsg).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
																	l_errormsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (l_ea.errmsg)))))
																end
															end
															if globals_inst.need_rethrow.to_boolean then
																ex_eval_inst.do_throw (a_cstack)
															elseif globals_inst.check_cstack.to_boolean then
																if (ex_cmds2_inst.source_finished (a_fgetline, a_cookie)).to_boolean then
																	ex_cmds2_inst.do_finish (l_ea.address, 1)
																elseif (getline_equal (a_fgetline, a_cookie, eval_inst.get_func_line_address)).to_boolean then
																	if (eval_inst.current_func_returned).to_boolean then
																		eval_inst.do_return (l_ea.address, 1, 0, create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
																	end
																end
															end
															globals_inst.check_cstack := 0
															globals_inst.need_rethrow := globals_inst.check_cstack
				when 190 then -- doend:
															if globals_inst.curwin.item.w_cursor.lnum = 0 then
																globals_inst.curwin.item.w_cursor.lnum := (1).to_integer_32
															end
															if (l_errormsg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
																if (l_errormsg.item).to_integer_32 /= 0 then
																	if not globals_inst.did_emsg.to_boolean then
																		if a_sourcing.to_boolean then
																			if (l_errormsg.c_pointer.to_integer_32).to_natural_32 /= (globals_inst.IObuff.c_pointer.to_integer_32).to_natural_32 then
																				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), create {CE_POINTER [INTEGER_8]}.make_cast (l_errormsg)).do_nothing
																				l_errormsg.ce_gets (globals_inst.IObuff)
																			end
																			strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_errormsg), ce_string (": ")).do_nothing
																			strncat (create {CE_POINTER [INTEGER_8]}.make_cast (l_errormsg), create {CE_POINTER [INTEGER_8]}.make_cast (a_cmdlinep.item), ({NATURAL_32} 1025 - (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff)))) - {NATURAL_32} 1).do_nothing
																		end
																		message_inst.emsg (l_errormsg).do_nothing
																	end
																end
															end
															if l_ea.cmdidx /= 517 then
																if not (l_ea.cmdidx < 0) then
																	l_tmp___69.ce_gets (ex_cmds_inst.cmdnames[l_ea.cmdidx].cmd_name)
																else
																	l_tmp___69.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
																end
															else
																l_tmp___69.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
															end
															ex_eval_inst.do_errthrow (a_cstack, l_tmp___69)
															if l_verbose_save >= 0 then
																option_inst.p_verbose := l_verbose_save
															end
															if ((globals_inst.cmdmod.save_ei).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
																option_inst.set_string_option_direct (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ei")), -1, globals_inst.cmdmod.save_ei, 1, -6)
																option_inst.free_string_option (globals_inst.cmdmod.save_ei)
															end
															globals_inst.cmdmod.ce_gets (l_save_cmdmod)
															if l_save_msg_silent /= -1 then
																if not globals_inst.did_emsg.to_boolean then
																	globals_inst.msg_silent := l_save_msg_silent
																elseif globals_inst.msg_silent > l_save_msg_silent then
																	globals_inst.msg_silent := l_save_msg_silent
																end
																globals_inst.emsg_silent := globals_inst.emsg_silent - l_did_esilent
																if globals_inst.emsg_silent < 0 then
																	globals_inst.emsg_silent := 0
																end
																globals_inst.msg_scroll := l_save_msg_scroll
																if (message_inst.redirecting).to_boolean then
																	globals_inst.msg_col := 0
																end
															end
															if l_did_sandbox.to_boolean then
																globals_inst.sandbox := globals_inst.sandbox - 1
															end
															if ((l_ea.nextcmd).c_pointer /= default_pointer) then
																if ((l_ea.nextcmd).item).to_integer_32 = 0 then
																	l_ea.nextcmd := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
																end
															end
															globals_inst.ex_nesting_level := globals_inst.ex_nesting_level - 1
															Result := (l_ea.nextcmd)
				when 191 then
															l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
												end

	checkforcmd (a_pp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_cmd: CE_POINTER [INTEGER_8]; a_len: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then ((a_cmd[l_i___0]).to_integer_32 /= 0))
			loop
				js.reset
				if (create {CE_POINTER [NATURAL_8]}.make_cast (a_cmd)[l_i___0]).to_integer_32 /= (a_pp.item[l_i___0]).to_integer_32 then
					js.break
				end
				if not js.loop_jumped then
					l_i___0 := l_i___0 + 1
				end
			end
			js.reset
			if l_i___0 >= a_len then
				if not ((((ctype_b_loc).item[(a_pp.item[l_i___0]).to_integer_32]).to_integer_32).bit_and (1024)).to_boolean then
					a_pp.item := charset_inst.skipwhite (a_pp.item + l_i___0)
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	find_command (a_eap: CE_POINTER [PD_EXARG]; a_full: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		local
			l_len: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (a_eap.item.cmd)
					if (l_p___0.item).to_integer_32 /= 107 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_eap.item.cmdidx := {PC_CMD_INDEX}.CMD_k
						l_p___0.ce_gets (l_p___0 + 1)
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 3 then -- else:
						if (l_p___0[0]).to_integer_32 /= 115 then
							l_pos := -1 + 15 -- skip if block
						end
				when 4 then -- if:
						if (l_p___0[1]).to_integer_32 /= 99 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (l_p___0[2]).to_integer_32 /= 115 then
							if (l_p___0[2]).to_integer_32 /= 114 then
								if (l_p___0[3]).to_integer_32 /= 105 then
									if (l_p___0[4]).to_integer_32 /= 112 then
										a_eap.item.cmdidx := {PC_CMD_INDEX}.CMD_substitute
										l_p___0.ce_gets (l_p___0 + 1)
									else
										l_pos := -1 + 7 -- goto _L___7
									end
								else
									l_pos := -1 + 7 -- goto _L___7
								end
							else
								l_pos := -1 + 7 -- goto _L___7
							end
						else
							l_pos := -1 + 7 -- goto _L___7
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 7 then -- else: | _L___7:
						if (l_p___0[1]).to_integer_32 /= 103 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						a_eap.item.cmdidx := {PC_CMD_INDEX}.CMD_substitute
						l_p___0.ce_gets (l_p___0 + 1)
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if (l_p___0[1]).to_integer_32 /= 105 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if (l_p___0[2]).to_integer_32 /= 109 then
							if (l_p___0[2]).to_integer_32 /= 108 then
								if (l_p___0[2]).to_integer_32 /= 103 then
									a_eap.item.cmdidx := {PC_CMD_INDEX}.CMD_substitute
									l_p___0.ce_gets (l_p___0 + 1)
								else
									l_pos := -1 + 13 -- goto _L___3
								end
							else
								l_pos := -1 + 13 -- goto _L___3
							end
						else
							l_pos := -1 + 13 -- goto _L___3
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L___3:
						if (l_p___0[1]).to_integer_32 = 73 then
							a_eap.item.cmdidx := {PC_CMD_INDEX}.CMD_substitute
							l_p___0.ce_gets (l_p___0 + 1)
						elseif (l_p___0[1]).to_integer_32 = 114 then
							if (l_p___0[2]).to_integer_32 /= 101 then
								a_eap.item.cmdidx := {PC_CMD_INDEX}.CMD_substitute
								l_p___0.ce_gets (l_p___0 + 1)
							else
								l_pos := -1 + 15 -- goto _L___0
							end
						else
							l_pos := -1 + 15 -- goto _L___0
						end
				when 14 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 22
				when 15 then -- else: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_p___0.item).to_integer_32 < 127 then
								if not ((((ctype_b_loc).item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (1024)).to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p___0.ce_gets (l_p___0 + 1)
							end
						end
						js.reset
						if (a_eap.item.cmd[0]).to_integer_32 = 112 then
							if (a_eap.item.cmd[1]).to_integer_32 = 121 then
								from
								until
									js.loop_left
								loop
									js.reset
									if (l_p___0.item).to_integer_32 < 127 then
										if not ((((ctype_b_loc).item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_p___0.ce_gets (l_p___0 + 1)
									end
								end
								js.reset
							end
						end
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = ((a_eap.item.cmd).c_pointer.to_integer_32).to_natural_32 then
							if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("@*!=><&~#")), (l_p___0.item).to_integer_32)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_p___0.ce_gets (l_p___0 + 1)
							end
						end
						l_len := l_p___0.distance ((a_eap.item.cmd))
						if ((a_eap.item.cmd).item).to_integer_32 /= 100 then
							l_pos := -1 + 21 -- skip if block
						end
				when 16 then -- if:
						if (l_p___0[-1]).to_integer_32 /= 108 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 19 then -- else:
						if (l_p___0[-1]).to_integer_32 /= 112 then
							l_pos := -1 + 21 -- skip if block
						end
				when 20 then -- if: | _L:
						l_i___0 := 0
						from
						until
							not (not js.loop_left and then (l_i___0 < l_len))
						loop
							js.reset
							if (a_eap.item.cmd[l_i___0]).to_integer_32 /= (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("delete"))[l_i___0]).to_integer_32 then
								js.break
							end
							if not js.loop_jumped then
								l_i___0 := l_i___0 + 1
							end
						end
						js.reset
						if l_i___0 = l_len - 1 then
							l_len := l_len - 1
							if (l_p___0[-1]).to_integer_32 = 108 then
								a_eap.item.flags := (a_eap.item.flags).bit_or ((1))
							else
								a_eap.item.flags := (a_eap.item.flags).bit_or ((4))
							end
						end
				when 21 then -- if done | if done
						if ((a_eap.item.cmd).item).to_integer_32 < 127 then
							if ((((ctype_b_loc).item[((a_eap.item.cmd).item).to_integer_32]).to_integer_32).bit_and (512)).to_boolean then
								a_eap.item.cmdidx := cmdidxs[((a_eap.item.cmd).item).to_integer_32 - 97]
							else
								a_eap.item.cmdidx := cmdidxs[26]
							end
						else
							a_eap.item.cmdidx := cmdidxs[26]
						end
						from
						until
							not (not js.loop_left and then (a_eap.item.cmdidx < 517))
						loop
							js.reset
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (ex_cmds_inst.cmdnames[a_eap.item.cmdidx].cmd_name), create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.cmd), l_len.to_natural_32)) = 0 then
								if (a_full.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if (ex_cmds_inst.cmdnames[a_eap.item.cmdidx].cmd_name[l_len]).to_integer_32 = 0 then
										a_full.item := 1
									end
								end
								js.break
							end
							if not js.loop_jumped then
								a_eap.item.cmdidx := (a_eap.item.cmdidx + 1)
							end
						end
						js.reset
						if a_eap.item.cmdidx = 517 then
							if ((a_eap.item.cmd).item).to_integer_32 >= 65 then
								if ((a_eap.item.cmd).item).to_integer_32 <= 90 then
									from
									until
										js.loop_left
									loop
										js.reset
										if (l_p___0.item).to_integer_32 < 127 then
											if not ((((ctype_b_loc).item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
												js.break
											end
										else
											js.break
										end
										if not js.loop_jumped then
											l_p___0.ce_gets (l_p___0 + 1)
										end
									end
									js.reset
									l_p___0.ce_gets (find_ucmd (a_eap, l_p___0, a_full, create {CE_POINTER [PD_EXPAND]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
								end
							end
						end
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = ((a_eap.item.cmd).c_pointer.to_integer_32).to_natural_32 then
							a_eap.item.cmdidx := {PC_CMD_INDEX}.CMD_SIZE
						end
				when 22 then -- if done
						Result := l_p___0
				when 23 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	find_ucmd (a_eap: CE_POINTER [PD_EXARG]; a_p___0: CE_POINTER [NATURAL_8]; a_full: CE_POINTER [INTEGER_32]; a_xp: CE_POINTER [PD_EXPAND]; a_compl: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		local
			l_len: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_matchlen: INTEGER_32
			l_uc: CE_POINTER [PD_UCMD]
			l_found: INTEGER_32
			l_possible: INTEGER_32
			l_cp: CE_POINTER [NATURAL_8]
			l_np: CE_POINTER [NATURAL_8]
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_amb_local: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_uc.make
			create l_cp.make
			create l_np.make
			create l_gap.make
			create l_tmp.make
			create l_tmp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := a_p___0.distance ((a_eap.item.cmd))
					l_matchlen := 0
					l_found := 0
					l_possible := 0
					l_amb_local := 0
					l_gap.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared (globals_inst.curbuf.c_pointer + {PD_FILE_BUFFER}.b_ucmds_offset))
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 18 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_j := 0
				when 3 then -- loop condition:
						if not (not js.loop_left and then (l_j < l_gap.item.ga_len)) then
							l_pos := -1 + 17 -- skip loop
						end
				when 4 then -- loop body:
						js.reset
						l_uc.ce_gets (create {CE_POINTER [PD_UCMD]}.make_cast (l_gap.item.ga_data) + l_j)
						l_cp.ce_gets (a_eap.item.cmd)
						l_np.ce_gets (l_uc.item.uc_name)
						l_k := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if l_k < l_len then
								if (l_np.item).to_integer_32 /= 0 then
									l_tmp.ce_gets (l_cp)
									l_cp.ce_gets (l_cp + 1)
									l_tmp___0.ce_gets (l_np)
									l_np.ce_gets (l_np + 1)
									if (l_tmp.item).to_integer_32 /= (l_tmp___0.item).to_integer_32 then
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_k := l_k + 1
							end
						end
						js.reset
						if l_k /= l_len then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 9 -- goto _L___0
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 7 then -- else:
						if (l_np.item).to_integer_32 /= 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 8 then -- if:
						if not ((charset_inst.vim_isdigit ((a_eap.item.cmd[l_k]).to_integer_32)).to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 9 then -- if: | _L___0:
						if l_k = l_len then
							if l_found.to_boolean then
								if (l_np.item).to_integer_32 /= 0 then
									if (l_gap.c_pointer.to_integer_32).to_natural_32 = ((ucmds.address).c_pointer.to_integer_32).to_natural_32 then
										Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
										js.return
									end
									if not js.return_called then
										l_amb_local := 1
									end
								end
							end
						end
						if js.return_called then
							l_pos := -1 + 16 -- skip if block
						end
				when 10 then -- if:
						if l_found.to_boolean then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 15 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 13 then -- else:
						if l_k /= l_len then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if (l_np.item).to_integer_32 /= 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 15 then -- if: | _L:
						if l_k = l_len then
							l_found := 1
						else
							l_possible := 1
						end
						if (l_gap.c_pointer.to_integer_32).to_natural_32 = ((ucmds.address).c_pointer.to_integer_32).to_natural_32 then
							a_eap.item.cmdidx := -1
						else
							a_eap.item.cmdidx := -2
						end
						a_eap.item.argt := (l_uc.item.uc_argt).to_integer_32
						a_eap.item.useridx := l_j
						if (a_compl.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							a_compl.item := l_uc.item.uc_compl
						end
						if (a_xp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							a_xp.item.xp_arg := l_uc.item.uc_compl_arg
							a_xp.item.xp_scriptID := l_uc.item.uc_scriptID
						end
						l_matchlen := l_k
						if l_k = l_len then
							if (l_np.item).to_integer_32 = 0 then
								if (a_full.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									a_full.item := 1
								end
								l_amb_local := 0
								js.break
							end
						end
				when 16 then -- if done | if done | if done | if done | if done | if done
						if not js.loop_jumped then
							l_j := l_j + 1
						end
						l_pos := -1 + 3 -- back to loop condition
				when 17 then -- loop done
						js.reset
						if not js.return_called then
							if l_j < l_gap.item.ga_len then
								js.break
							elseif (l_gap.c_pointer.to_integer_32).to_natural_32 = ((ucmds.address).c_pointer.to_integer_32).to_natural_32 then
								js.break
							end
							if not js.loop_jumped then
								l_gap.ce_gets (ucmds.address)
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 18 then -- loop done
					js.reset
					if not js.return_called and then (l_amb_local.to_boolean) then
						if (a_xp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							a_xp.item.xp_context := -2
						end
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						if l_found.to_boolean then
							Result := (a_p___0 + (l_matchlen - l_len))
							js.return
						elseif l_possible.to_boolean then
							Result := (a_p___0 + (l_matchlen - l_len))
							js.return
						end
					end
					if not js.return_called then
						Result := a_p___0
					end
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	modifier_len (a_cmd: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0.ce_gets (a_cmd)
			if (a_cmd.item).to_integer_32 >= 48 then
				if (a_cmd.item).to_integer_32 <= 57 then
					l_p___0.ce_gets (charset_inst.skipwhite ((charset_inst.skipdigits (a_cmd))))
				end
			end
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (l_i___0 < (({PD_CMDMOD}.sizeof.to_natural_32 * (20).to_natural_32) // {PD_CMDMOD}.sizeof.to_natural_32).to_integer_32))
			loop
				l_j := 0
				from
				until
					not (not js.loop_left and then ((l_p___0[l_j]).to_integer_32 /= 0))
				loop
					js.reset
					if (l_p___0[l_j]).to_integer_32 /= (cmdmods[l_i___0].name[l_j]).to_integer_32 then
						js.break
					end
					if not js.loop_jumped then
						l_j := l_j + 1
					end
				end
				js.reset
				if not ((((ctype_b_loc).item[(l_p___0[l_j]).to_integer_32]).to_integer_32).bit_and (1024)).to_boolean then
					if l_j >= cmdmods[l_i___0].minlen then
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (a_cmd.c_pointer.to_integer_32).to_natural_32 then
							Result := (l_j + (l_p___0.distance (a_cmd)))
							js.return
						elseif (cmdmods[l_i___0].has_count).to_boolean then
							Result := (l_j + (l_p___0.distance (a_cmd)))
							js.return
						end
					end
				end
				if not js.return_called then
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	cmd_exists (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_ea: PD_EXARG
			l_full: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
		do
			create l_ea.make
			create l_p___0.make

			l_full := 0
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (l_i___0 < (({PD_CMDMOD}.sizeof.to_natural_32 * (20).to_natural_32) // {PD_CMDMOD}.sizeof.to_natural_32).to_integer_32))
			loop
				l_j := 0
				from
				until
					not (not js.loop_left and then ((a_name___1[l_j]).to_integer_32 /= 0))
				loop
					js.reset
					if (a_name___1[l_j]).to_integer_32 /= (cmdmods[l_i___0].name[l_j]).to_integer_32 then
						js.break
					end
					if not js.loop_jumped then
						l_j := l_j + 1
					end
				end
				js.reset
				if (a_name___1[l_j]).to_integer_32 = 0 then
					if l_j >= cmdmods[l_i___0].minlen then
						if (cmdmods[l_i___0].name[l_j]).to_integer_32 = 0 then
							l_tmp := 2
						else
							l_tmp := 1
						end
						Result := l_tmp
						js.return
					end
				end
				if not js.return_called then
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				if (a_name___1.item).to_integer_32 = 50 then
					l_ea.cmd := a_name___1 + 1
				elseif (a_name___1.item).to_integer_32 = 51 then
					l_ea.cmd := a_name___1 + 1
				else
					l_ea.cmd := a_name___1
				end
				l_ea.cmdidx := {PC_CMD_INDEX}.CMD_append
				l_p___0.ce_gets (find_command (l_ea.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_full)))
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := 3
					js.return
				end
			end
			if not js.return_called then
				if (charset_inst.vim_isdigit ((a_name___1.item).to_integer_32)).to_boolean then
					if l_ea.cmdidx /= 253 then
						Result := 0
						js.return
					end
				end
			end
			if not js.return_called then
				if ((charset_inst.skipwhite (l_p___0)).item).to_integer_32 /= 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if l_ea.cmdidx = 517 then
					l_tmp___3 := 0
				else
					if l_full.to_boolean then
						l_tmp___2 := 2
					else
						l_tmp___2 := 1
					end
					l_tmp___3 := l_tmp___2
				end
				Result := l_tmp___3
			end
		end

	set_one_cmd_context (a_xp: CE_POINTER [PD_EXPAND]; a_buff: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_cmd: CE_POINTER [NATURAL_8]
			l_arg: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_ea: PD_EXARG
			l_compl: INTEGER_32
			l_delim: INTEGER_32
			l_forceit: INTEGER_32
			l_usefilter: INTEGER_32
			l_tmp___7: INTEGER_32
			l_c: INTEGER_32
			l_in_quote: INTEGER_32
			l_bow: CE_POINTER [NATURAL_8]
			l_tmp___12: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___28: CE_POINTER [NATURAL_8]
			l_tmp___29: CE_POINTER [NATURAL_8]
			l_tmp___32: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_cmd.make
			create l_arg.make
			create l_ea.make
			create l_bow.make
			create l_tmp___28.make
			create l_tmp___29.make
			create l_tmp___32.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := 0
					l_compl := 0
					l_forceit := 0
					l_usefilter := 0
					ex_getln_inst.ExpandInit (a_xp)
					a_xp.item.xp_pattern := a_buff
					a_xp.item.xp_context := 1
					l_ea.argt := 0
					l_cmd.ce_gets (a_buff)
					from
					until
						js.loop_left
					loop
						js.reset
						if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" %T:|")), (l_cmd.item).to_integer_32)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						end
						if not js.loop_jumped then
							l_cmd.ce_gets (l_cmd + 1)
						end
					end
					js.reset
					a_xp.item.xp_pattern := l_cmd
					if (l_cmd.item).to_integer_32 = 0 then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called and then ((l_cmd.item).to_integer_32 = 34) then
						a_xp.item.xp_context := 0
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						l_cmd.ce_gets (skip_range (l_cmd, create {CE_POINTER [INTEGER_32]}.make_shared (a_xp.c_pointer + {PD_EXPAND}.xp_context_offset)))
						a_xp.item.xp_pattern := l_cmd
						if (l_cmd.item).to_integer_32 = 0 then
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
					end
					if not js.return_called and then ((l_cmd.item).to_integer_32 = 34) then
						a_xp.item.xp_context := 0
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						if (l_cmd.item).to_integer_32 = 124 then
							Result := (l_cmd + 1)
							js.return
						elseif (l_cmd.item).to_integer_32 = 10 then
							Result := (l_cmd + 1)
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 21 -- skip if block
					end
				when 1 then -- if:
						if (l_cmd.item).to_integer_32 /= 107 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (l_cmd[1]).to_integer_32 /= 101 then
							l_ea.cmdidx := {PC_CMD_INDEX}.CMD_k
							l_p___0.ce_gets (l_cmd + 1)
						else
							l_pos := -1 + 4 -- goto _L___1
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 4 then -- else: | _L___1:
						l_p___0.ce_gets (l_cmd)
				when 5 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 11 -- skip loop
						end
				when 6 then -- loop body:
						js.reset
						if not ((l_p___0.item).to_integer_32 < 127) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if not ((((ctype_b_loc).item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (1024)).to_boolean then
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if (l_p___0.item).to_integer_32 /= 42 then
							js.break
						end
				when 10 then
						if not js.loop_jumped then
							l_p___0.ce_gets (l_p___0 + 1)
						end
						l_pos := -1 + 5 -- back to loop condition
				when 11 then -- loop done
						js.reset
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (l_cmd.c_pointer.to_integer_32).to_natural_32 then
							if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("@*!=><&~#")), (l_p___0.item).to_integer_32)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_p___0.ce_gets (l_p___0 + 1)
							end
						end
						l_len := l_p___0.distance (l_cmd)
						if l_len = 0 then
							a_xp.item.xp_context := -2
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
						if js.return_called then
							l_pos := -1 + 21 -- skip if block
						end
				when 12 then -- if:
						l_ea.cmdidx := {PC_CMD_INDEX}.CMD_append
						from
						until
							not (not js.loop_left and then (l_ea.cmdidx < 517))
						loop
							js.reset
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (ex_cmds_inst.cmdnames[l_ea.cmdidx].cmd_name), create {CE_POINTER [INTEGER_8]}.make_cast (l_cmd), l_len.to_natural_32)) = 0 then
								js.break
							end
							if not js.loop_jumped then
								l_ea.cmdidx := (l_ea.cmdidx + 1)
							end
						end
						js.reset
						if not ((l_cmd[0]).to_integer_32 >= 65) then
							l_pos := -1 + 21 -- skip if block
						end
				when 13 then -- if:
						if not ((l_cmd[0]).to_integer_32 <= 90) then
							l_pos := -1 + 21 -- skip if block
						end
				when 14 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 20 -- skip loop
						end
				when 15 then -- loop body:
						js.reset
						if not ((l_p___0.item).to_integer_32 < 127) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if not ((((ctype_b_loc).item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
							l_pos := -1 + 18 -- goto _L___0
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L___0:
						if (l_p___0.item).to_integer_32 /= 42 then
							js.break
						end
				when 19 then
						if not js.loop_jumped then
							l_p___0.ce_gets (l_p___0 + 1)
						end
						l_pos := -1 + 14 -- back to loop condition
				when 20 then -- loop done
						js.reset
				when 21 then -- if done | if done | if done | if done
						if not js.return_called and then ((l_p___0.item).to_integer_32 = 0) then
							if (l_p___0[-1]).to_integer_32 < 127 then
								if ((((ctype_b_loc).item[(l_p___0[-1]).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
									Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
									js.return
								end
							end
						end
						if js.return_called then
							l_pos := -1 + 28 -- skip if block
						end
				when 22 then -- if:
							if l_ea.cmdidx /= 517 then
								l_pos := -1 + 27 -- skip if block
							end
				when 23 then -- if:
							if (l_cmd.item).to_integer_32 /= 115 then
								l_pos := -1 + 26 -- skip if block
							end
				when 24 then -- if:
							if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cgriI")), (l_cmd[1]).to_integer_32)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_ea.cmdidx := {PC_CMD_INDEX}.CMD_substitute
								l_p___0.ce_gets (l_cmd + 1)
							else
								l_pos := -1 + 26 -- goto _L___2
							end
				when 25 then -- if block done, skip else block:
							l_pos := -1 + 27
				when 26 then -- else: | _L___2:
							if (l_cmd[0]).to_integer_32 >= 65 then
								if (l_cmd[0]).to_integer_32 <= 90 then
									l_ea.cmd := l_cmd
									l_p___0.ce_gets (find_ucmd (l_ea.address, l_p___0, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), a_xp, create {CE_POINTER [INTEGER_32]}.make_shared ($l_compl)))
									if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										l_ea.cmdidx := {PC_CMD_INDEX}.CMD_SIZE
									end
								end
							end
				when 27 then -- if done
							if l_ea.cmdidx = 517 then
								a_xp.item.xp_context := -2
								Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								js.return
							end
				when 28 then -- if done
						if js.return_called then
							l_pos := -1 + 40 -- skip if block
						end
				when 29 then -- if:
							a_xp.item.xp_context := 0
							if (l_p___0.item).to_integer_32 = 33 then
								l_forceit := 1
								l_p___0.ce_gets (l_p___0 + 1)
							end
							if not (l_ea.cmdidx < 0) then
								l_ea.argt := (ex_cmds_inst.cmdnames[l_ea.cmdidx].cmd_argt).to_integer_32
							end
							l_arg.ce_gets (charset_inst.skipwhite (l_p___0))
							if l_ea.cmdidx /= 479 then
								l_pos := -1 + 32 -- skip if block
							end
				when 30 then -- if:
							l_pos := -1 + 33 -- goto _L___3
				when 31 then -- if block done, skip else block:
							l_pos := -1 + 34
				when 32 then -- else:
							if l_ea.cmdidx /= 460 then
								l_pos := -1 + 34 -- skip if block
							end
				when 33 then -- if: | _L___3:
							if (l_arg.item).to_integer_32 = 62 then
								l_arg.ce_gets (l_arg + 1)
								if (l_arg.item).to_integer_32 = 62 then
									l_arg.ce_gets (l_arg + 1)
								end
								l_arg.ce_gets (charset_inst.skipwhite (l_arg))
							elseif (l_arg.item).to_integer_32 = 33 then
								if l_ea.cmdidx = 479 then
									l_arg.ce_gets (l_arg + 1)
									l_usefilter := 1
								end
							end
				when 34 then -- if done
							if l_ea.cmdidx = 330 then
								l_usefilter := l_forceit
								if (l_arg.item).to_integer_32 = 33 then
									l_arg.ce_gets (l_arg + 1)
									l_usefilter := 1
								end
							end
							if l_ea.cmdidx /= 509 then
								l_pos := -1 + 37 -- skip if block
							end
				when 35 then -- if:
							l_pos := -1 + 38 -- goto _L___4
				when 36 then -- if block done, skip else block:
							l_pos := -1 + 39
				when 37 then -- else:
							if l_ea.cmdidx /= 511 then
								l_pos := -1 + 39 -- skip if block
							end
				when 38 then -- if: | _L___4:
							from
							until
								(l_arg.item).to_integer_32 /= (l_cmd.item).to_integer_32
							loop
								l_arg.ce_gets (l_arg + 1)
							end
							l_arg.ce_gets (charset_inst.skipwhite (l_arg))
				when 39 then -- if done
							if ((l_ea.argt).bit_and (32768)).to_boolean then
								if not l_usefilter.to_boolean then
									if (l_arg.item).to_integer_32 = 43 then
										l_p___0.ce_gets (l_arg + 1)
										l_arg.ce_gets (skip_cmd_arg (l_arg, 0))
										if (l_arg.item).to_integer_32 = 0 then
											Result := l_p___0
											js.return
										end
										if not js.return_called then
											l_arg.ce_gets (charset_inst.skipwhite (l_arg))
										end
									end
								end
							end
				when 40 then -- if done
						if not (not js.return_called and then (((l_ea.argt).bit_and (256)).to_boolean)) then
							l_pos := -1 + 56 -- skip if block
						end
				when 41 then -- if:
							if l_usefilter.to_boolean then
								l_pos := -1 + 56 -- skip if block
							end
				when 42 then -- if:
							l_p___0.ce_gets (l_arg)
							if l_ea.cmdidx = 333 then
								if (l_p___0[0]).to_integer_32 = 64 then
									if (l_p___0[1]).to_integer_32 = 34 then
										l_p___0.ce_gets (l_p___0 + (2))
									end
								end
							end
				when 43 then -- loop condition:
							if not (not js.loop_left and then ((l_p___0.item).to_boolean)) then
								l_pos := -1 + 56 -- skip loop
							end
				when 44 then -- loop body:
							if (l_p___0.item).to_integer_32 /= 22 then
								l_pos := -1 + 47 -- skip if block
							end
				when 45 then -- if:
							if (l_p___0[1]).to_integer_32 /= 0 then
								l_p___0.ce_gets (l_p___0 + 1)
							end
				when 46 then -- if block done, skip else block:
							l_pos := -1 + 55
				when 47 then -- else:
							if (l_p___0.item).to_integer_32 /= 34 then
								l_pos := -1 + 50 -- skip if block
							end
				when 48 then -- if:
							if not ((l_ea.argt).bit_and (2048)).to_boolean then
								l_pos := -1 + 54 -- goto _L___5
							else
								l_pos := -1 + 50 -- goto _L___6
							end
				when 49 then -- if block done, skip else block:
							l_pos := -1 + 55
				when 50 then -- else: | _L___6:
							if (l_p___0.item).to_integer_32 /= 124 then
								l_pos := -1 + 53 -- skip if block
							end
				when 51 then -- if:
							l_pos := -1 + 54 -- goto _L___5
				when 52 then -- if block done, skip else block:
							l_pos := -1 + 55
				when 53 then -- else:
							if (l_p___0.item).to_integer_32 /= 10 then
								l_pos := -1 + 55 -- skip if block
							end
				when 54 then -- if: | _L___5:
							if (l_p___0[-1]).to_integer_32 /= 92 then
								if (l_p___0.item).to_integer_32 = 124 then
									Result := (l_p___0 + 1)
									js.return
								elseif (l_p___0.item).to_integer_32 = 10 then
									Result := (l_p___0 + 1)
									js.return
								end
								if not js.return_called then
									Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
									js.return
								end
							end
				when 55 then -- if done | if done | if done
							if not js.return_called then
								if globals_inst.has_mbyte.to_boolean then
									l_tmp___7 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
								else
									l_tmp___7 := 1
								end
								l_p___0.ce_gets (l_p___0 + l_tmp___7)
							end
							l_pos := -1 + 43 -- back to loop condition
				when 56 then -- loop done | if done | if done
							if not js.return_called and then (not ((l_ea.argt).bit_and (4)).to_boolean) then
								if (l_arg.item).to_integer_32 /= 0 then
									if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("|%"")), (l_arg.item).to_integer_32)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
										js.return
									end
								end
							end
							if js.return_called then
								l_pos := -1 + 135 -- skip if block
							end
				when 57 then -- if:
								l_p___0.ce_gets (a_buff + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_buff))).to_integer_32)
								from
								until
									js.loop_left
								loop
									js.reset
									if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (l_arg.c_pointer.to_integer_32).to_natural_32 then
										if (l_p___0.item).to_integer_32 /= 32 then
											if (l_p___0.item).to_integer_32 = 9 then
												js.break
											end
										else
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_p___0.ce_gets (l_p___0 - 1)
									end
								end
								js.reset
								if (l_p___0.item).to_integer_32 = 32 then
									l_p___0.ce_gets (l_p___0 + 1)
								elseif (l_p___0.item).to_integer_32 = 9 then
									l_p___0.ce_gets (l_p___0 + 1)
								end
								a_xp.item.xp_pattern := l_p___0
								if not (((l_ea.argt).bit_and (8)).to_boolean) then
									l_pos := -1 + 87 -- skip if block
								end
				when 58 then -- if:
								l_in_quote := 0
								l_bow.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								a_xp.item.xp_pattern := charset_inst.skipwhite (l_arg)
								l_p___0.ce_gets (a_xp.item.xp_pattern)
				when 59 then -- loop condition:
								if not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0)) then
									l_pos := -1 + 81 -- skip loop
								end
				when 60 then -- loop body:
								if globals_inst.has_mbyte.to_boolean then
									l_c := globals_inst.mb_ptr2char.integer_32_item ([l_p___0])
								else
									l_c := (l_p___0.item).to_integer_32
								end
								if l_c /= 92 then
									l_pos := -1 + 63 -- skip if block
								end
				when 61 then -- if:
								if (l_p___0[1]).to_integer_32 /= 0 then
									l_p___0.ce_gets (l_p___0 + 1)
								else
									l_pos := -1 + 63 -- goto _L___9
								end
				when 62 then -- if block done, skip else block:
								l_pos := -1 + 80
				when 63 then -- else: | _L___9:
								if l_c /= 96 then
									l_pos := -1 + 66 -- skip if block
								end
				when 64 then -- if:
								if not l_in_quote.to_boolean then
									a_xp.item.xp_pattern := l_p___0
									l_bow.ce_gets (l_p___0 + 1)
								end
								l_in_quote := (not l_in_quote.to_boolean).to_integer
				when 65 then -- if block done, skip else block:
								l_pos := -1 + 80
				when 66 then -- else:
								if l_c /= 124 then
									l_pos := -1 + 69 -- skip if block
								end
				when 67 then -- if:
								l_pos := -1 + 79 -- goto _L___8
				when 68 then -- if block done, skip else block:
								l_pos := -1 + 80
				when 69 then -- else:
								if l_c /= 10 then
									l_pos := -1 + 72 -- skip if block
								end
				when 70 then -- if:
								l_pos := -1 + 79 -- goto _L___8
				when 71 then -- if block done, skip else block:
								l_pos := -1 + 80
				when 72 then -- else:
								if l_c /= 34 then
									l_pos := -1 + 75 -- skip if block
								end
				when 73 then -- if:
								l_pos := -1 + 79 -- goto _L___8
				when 74 then -- if block done, skip else block:
								l_pos := -1 + 80
				when 75 then -- else:
								if l_c /= 32 then
									l_pos := -1 + 78 -- skip if block
								end
				when 76 then -- if:
								l_pos := -1 + 79 -- goto _L___8
				when 77 then -- if block done, skip else block:
								l_pos := -1 + 80
				when 78 then -- else:
								if l_c /= 9 then
									l_pos := -1 + 80 -- skip if block
								end
				when 79 then -- if: | _L___8:
								l_len := 0
								from
								until
									not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0))
								loop
									js.reset
									if globals_inst.has_mbyte.to_boolean then
										l_c := globals_inst.mb_ptr2char.integer_32_item ([l_p___0])
									else
										l_c := (l_p___0.item).to_integer_32
									end
									if l_c = 96 then
										js.break
									elseif (charset_inst.vim_isfilec_or_wc (l_c)).to_boolean then
										js.break
									end
									if not js.loop_jumped then
										if globals_inst.has_mbyte.to_boolean then
											l_len := globals_inst.mb_ptr2len.integer_32_item ([l_p___0])
										else
											l_len := 1
										end
										if globals_inst.has_mbyte.to_boolean then
											l_tmp___12 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
										else
											l_tmp___12 := 1
										end
										l_p___0.ce_gets (l_p___0 + l_tmp___12)
									end
								end
								js.reset
								if l_in_quote.to_boolean then
									l_bow.ce_gets (l_p___0)
								else
									a_xp.item.xp_pattern := l_p___0
								end
								l_p___0.ce_gets (l_p___0 - l_len)
				when 80 then -- if done | if done | if done | if done | if done | if done
								if globals_inst.has_mbyte.to_boolean then
									l_tmp___14 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
								else
									l_tmp___14 := 1
								end
								l_p___0.ce_gets (l_p___0 + l_tmp___14)
								l_pos := -1 + 59 -- back to loop condition
				when 81 then -- loop done
								if (l_bow.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if l_in_quote.to_boolean then
										a_xp.item.xp_pattern := l_bow
									end
								end
								a_xp.item.xp_context := 2
								if not (l_usefilter.to_boolean) then
									l_pos := -1 + 84 -- skip if block
								end
				when 82 then -- if:
								l_pos := -1 + 85 -- goto _L___10
				when 83 then -- if block done, skip else block:
								l_pos := -1 + 86
				when 84 then -- else:
								if l_ea.cmdidx /= 505 then
									l_pos := -1 + 86 -- skip if block
								end
				when 85 then -- if: | _L___10:
								a_xp.item.xp_shell := 1
								if ((a_xp.item.xp_pattern).c_pointer.to_integer_32).to_natural_32 = ((charset_inst.skipwhite (l_arg)).c_pointer.to_integer_32).to_natural_32 then
									a_xp.item.xp_context := 32
								end
				when 86 then -- if done
								if ((a_xp.item.xp_pattern).item).to_integer_32 = 36 then
									l_p___0.ce_gets (a_xp.item.xp_pattern + 1)
									from
									until
										not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0))
									loop
										js.reset
										if not (charset_inst.vim_isIDc ((l_p___0.item).to_integer_32)).to_boolean then
											js.break
										end
										if not js.loop_jumped then
											l_p___0.ce_gets (l_p___0 + 1)
										end
									end
									js.reset
									if (l_p___0.item).to_integer_32 = 0 then
										a_xp.item.xp_context := 26
										a_xp.item.xp_pattern := (a_xp.item.xp_pattern) + 1
										if l_compl /= 30 then
											if l_compl /= 31 then
												l_compl := 26
											end
										end
									end
								end
				when 87 then -- if done
								inspect l_ea.cmdidx -- switch 1 head
								when 143 then l_pos := -1 + 88
								when 371 then l_pos := -1 + 88
								when 423 then l_pos := -1 + 88
								when 55 then l_pos := -1 + 89
								when 63 then l_pos := -1 + 89
								when 203 then l_pos := -1 + 89
								when 204 then l_pos := -1 + 89
								when 161 then l_pos := -1 + 90
								when 3 then l_pos := -1 + 91
								when 10 then l_pos := -1 + 91
								when 25 then l_pos := -1 + 91
								when 30 then l_pos := -1 + 91
								when 37 then l_pos := -1 + 91
								when 39 then l_pos := -1 + 91
								when 86 then l_pos := -1 + 91
								when 100 then l_pos := -1 + 91
								when 151 then l_pos := -1 + 91
								when 150 then l_pos := -1 + 91
								when 167 then l_pos := -1 + 91
								when 192 then l_pos := -1 + 91
								when 191 then l_pos := -1 + 91
								when 190 then l_pos := -1 + 91
								when 208 then l_pos := -1 + 91
								when 231 then l_pos := -1 + 91
								when 342 then l_pos := -1 + 91
								when 353 then l_pos := -1 + 91
								when 376 then l_pos := -1 + 91
								when 419 then l_pos := -1 + 91
								when 444 then l_pos := -1 + 91
								when 463 then l_pos := -1 + 91
								when 464 then l_pos := -1 + 91
								when 485 then l_pos := -1 + 91
								when 253 then l_pos := -1 + 92
								when 82 then l_pos := -1 + 99
								when 102 then l_pos := -1 + 102
								when 155 then l_pos := -1 + 103
								when 461 then l_pos := -1 + 103
								when 507 then l_pos := -1 + 104
								when 349 then l_pos := -1 + 104
								when 182 then l_pos := -1 + 105
								when 118 then l_pos := -1 + 105
								when 174 then l_pos := -1 + 105
								when 114 then l_pos := -1 + 105
								when 173 then l_pos := -1 + 105
								when 310 then l_pos := -1 + 105
								when 113 then l_pos := -1 + 105
								when 183 then l_pos := -1 + 105
								when 119 then l_pos := -1 + 105
								when 16 then l_pos := -1 + 106
								when 115 then l_pos := -1 + 107
								when 116 then l_pos := -1 + 107
								when 367 then l_pos := -1 + 108
								when 369 then l_pos := -1 + 109
								when 370 then l_pos := -1 + 110
								when 417 then l_pos := -1 + 111
								when 400 then l_pos := -1 + 111
								when 311 then l_pos := -1 + 111
								when 238 then l_pos := -1 + 111
								when 448 then l_pos := -1 + 111
								when 406 then l_pos := -1 + 111
								when 319 then l_pos := -1 + 111
								when 440 then l_pos := -1 + 111
								when 405 then l_pos := -1 + 111
								when 314 then l_pos := -1 + 111
								when 17 then l_pos := -1 + 112
								when 413 then l_pos := -1 + 113
								when 209 then l_pos := -1 + 114
								when 172 then l_pos := -1 + 114
								when 128 then l_pos := -1 + 114
								when 482 then l_pos := -1 + 114
								when 153 then l_pos := -1 + 114
								when 122 then l_pos := -1 + 114
								when 126 then l_pos := -1 + 114
								when 137 then l_pos := -1 + 114
								when 125 then l_pos := -1 + 114
								when 123 then l_pos := -1 + 114
								when 50 then l_pos := -1 + 114
								when 339 then l_pos := -1 + 114
								when 455 then l_pos := -1 + 115
								when 154 then l_pos := -1 + 116
								when 103 then l_pos := -1 + 116
								when 124 then l_pos := -1 + 117
								when 166 then l_pos := -1 + 118
								when 375 then l_pos := -1 + 119
								when 23 then l_pos := -1 + 120
								when 41 then l_pos := -1 + 120
								when 40 then l_pos := -1 + 120
								when 19 then l_pos := -1 + 121
								when 355 then l_pos := -1 + 121
								when 66 then l_pos := -1 + 121
								when -1 then l_pos := -1 + 122
								when -2 then l_pos := -1 + 122
								when 250 then l_pos := -1 + 123
								when 275 then l_pos := -1 + 123
								when 270 then l_pos := -1 + 123
								when 273 then l_pos := -1 + 123
								when 470 then l_pos := -1 + 123
								when 473 then l_pos := -1 + 123
								when 286 then l_pos := -1 + 123
								when 290 then l_pos := -1 + 123
								when 175 then l_pos := -1 + 123
								when 178 then l_pos := -1 + 123
								when 70 then l_pos := -1 + 123
								when 76 then l_pos := -1 + 123
								when 222 then l_pos := -1 + 123
								when 225 then l_pos := -1 + 123
								when 457 then l_pos := -1 + 124
								when 282 then l_pos := -1 + 124
								when 477 then l_pos := -1 + 124
								when 293 then l_pos := -1 + 124
								when 184 then l_pos := -1 + 124
								when 94 then l_pos := -1 + 124
								when 242 then l_pos := -1 + 124
								when 1 then l_pos := -1 + 125
								when 278 then l_pos := -1 + 125
								when 45 then l_pos := -1 + 125
								when 77 then l_pos := -1 + 125
								when 170 then l_pos := -1 + 125
								when 179 then l_pos := -1 + 125
								when 453 then l_pos := -1 + 126
								when 95 then l_pos := -1 + 126
								when 185 then l_pos := -1 + 126
								when 254 then l_pos := -1 + 127
								when 279 then l_pos := -1 + 127
								when 458 then l_pos := -1 + 127
								when 5 then l_pos := -1 + 127
								when 6 then l_pos := -1 + 127
								when 18 then l_pos := -1 + 127
								when 272 then l_pos := -1 + 127
								when 274 then l_pos := -1 + 127
								when 283 then l_pos := -1 + 127
								when 472 then l_pos := -1 + 127
								when 475 then l_pos := -1 + 127
								when 478 then l_pos := -1 + 127
								when 288 then l_pos := -1 + 127
								when 291 then l_pos := -1 + 127
								when 294 then l_pos := -1 + 127
								when 177 then l_pos := -1 + 127
								when 180 then l_pos := -1 + 127
								when 186 then l_pos := -1 + 127
								when 72 then l_pos := -1 + 127
								when 78 then l_pos := -1 + 127
								when 96 then l_pos := -1 + 127
								when 442 then l_pos := -1 + 127
								when 449 then l_pos := -1 + 127
								when 302 then l_pos := -1 + 127
								when 437 then l_pos := -1 + 127
								when 129 then l_pos := -1 + 127
								when 81 then l_pos := -1 + 128
								when 84 then l_pos := -1 + 129
								when 295 then l_pos := -1 + 130
								when 368 then l_pos := -1 + 131
								when 197 then l_pos := -1 + 132
								when 24 then l_pos := -1 + 133
								else l_pos := -1 + 134
								end
				when 88 then -- switch 1, case 143 | switch 1, case 371 | switch 1, case 423
								a_xp.item.xp_context := 38
								l_pos := -1 + 135 -- switch 1; break
				when 89 then -- switch 1, case 55 | switch 1, case 63 | switch 1, case 203 | switch 1, case 204
								if a_xp.item.xp_context = 2 then
									a_xp.item.xp_context := 3
								end
								l_pos := -1 + 135 -- switch 1; break
				when 90 then -- switch 1, case 161
								a_xp.item.xp_context := 8
								a_xp.item.xp_pattern := l_arg
								l_pos := -1 + 135 -- switch 1; break
				when 91 then -- switch 1, case 3 | switch 1, case 10 | switch 1, case 25 | switch 1, case 30 | switch 1, case 37 | switch 1, case 39 | switch 1, case 86 | switch 1, case 100 | switch 1, case 151 | switch 1, case 150 | switch 1, case 167 | switch 1, case 192 | switch 1, case 191 | switch 1, case 190 | switch 1, case 208 | switch 1, case 231 | switch 1, case 342 | switch 1, case 353 | switch 1, case 376 | switch 1, case 419 | switch 1, case 444 | switch 1, case 463 | switch 1, case 464 | switch 1, case 485
								Result := l_arg
								js.return
				when 92 then -- switch 1, case 253
								if js.return_called then
									l_pos := -1 + 99 -- skip if block
								end
				when 93 then -- if:
								if (l_arg.item).to_integer_32 /= 0 then
									l_pos := -1 + 96 -- skip if block
								end
				when 94 then -- if:
								l_pos := -1 + 97 -- goto _L___11
				when 95 then -- if block done, skip else block:
								l_pos := -1 + 98
				when 96 then -- else:
								if (ends_excmd ((l_arg.item).to_integer_32)).to_boolean then
									l_pos := -1 + 98 -- skip if block
								end
				when 97 then -- if: | _L___11:
								syntax_inst.set_context_in_echohl_cmd (a_xp, l_arg)
								l_arg.ce_gets (charset_inst.skipwhite ((charset_inst.skiptowhite (l_arg))))
								if (l_arg.item).to_integer_32 /= 0 then
									a_xp.item.xp_context := 0
									l_arg.ce_gets (regexp_inst.skip_regexp (l_arg + 1, (l_arg.item).to_integer_32, option_inst.p_magic, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
								end
				when 98 then -- if done
								Result := (find_nextcmd (l_arg))
								js.return
				when 99 then -- switch 1, case 82
								if not js.return_called then
									from
									until
										not (not js.loop_left and then ((l_arg.item).to_integer_32 = 45))
									loop
										l_arg.ce_gets (l_arg + 1)
										l_p___0.ce_gets (charset_inst.skiptowhite (l_arg))
										if (l_p___0.item).to_integer_32 = 0 then
											l_p___0.ce_gets (misc2_inst.vim_strchr (l_arg, ('=').code))
											if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
												a_xp.item.xp_context := 23
												a_xp.item.xp_pattern := l_arg
												Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
												js.return
											end
											if not js.return_called then
												if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("complete"), (l_p___0.distance (l_arg)).to_natural_32)) = 0 then
													a_xp.item.xp_context := 25
													a_xp.item.xp_pattern := l_p___0 + 1
													Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
													js.return
												elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("nargs"), (l_p___0.distance (l_arg)).to_natural_32)) = 0 then
													a_xp.item.xp_context := 24
													a_xp.item.xp_pattern := l_p___0 + 1
													Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
													js.return
												end
											end
											if not js.return_called then
												Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
												js.return
											end
										end
										if not js.return_called then
											l_arg.ce_gets (charset_inst.skipwhite (l_p___0))
										end
									end
								end
								if js.return_called then
									l_pos := -1 + 102 -- skip if block
								end
				when 100 then -- if:
								l_p___0.ce_gets (charset_inst.skiptowhite (l_arg))
								if (l_p___0.item).to_integer_32 = 0 then
									a_xp.item.xp_context := 22
									a_xp.item.xp_pattern := l_arg
									l_pos := -1 + 135 -- switch 1; break
								end
				when 101 then
								Result := (charset_inst.skipwhite (l_p___0))
								js.return
				when 102 then -- switch 1, case 102
								if not js.return_called then
									a_xp.item.xp_context := 22
									a_xp.item.xp_pattern := l_arg
								end
								l_pos := -1 + 135 -- switch 1; break
				when 103 then -- switch 1, case 155 | switch 1, case 461
								l_delim := (l_arg.item).to_integer_32
								if l_delim.to_boolean then
									l_arg.ce_gets (l_arg + 1)
								end
								from
								until
									js.loop_left
								loop
									js.reset
									if (l_arg[0]).to_integer_32 /= 0 then
										if (l_arg[0]).to_integer_32 = l_delim then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										if (l_arg[0]).to_integer_32 = 92 then
											if (l_arg[1]).to_integer_32 /= 0 then
												l_arg.ce_gets (l_arg + 1)
											end
										end
										l_arg.ce_gets (l_arg + 1)
									end
								end
								js.reset
								if (l_arg[0]).to_integer_32 /= 0 then
									Result := (l_arg + 1)
									js.return
								end
								l_pos := -1 + 135 -- switch 1; break
				when 104 then -- switch 1, case 507 | switch 1, case 349
								l_delim := (l_arg.item).to_integer_32
								if l_delim.to_boolean then
									l_arg.ce_gets (l_arg + 1)
									l_arg.ce_gets (regexp_inst.skip_regexp (l_arg, l_delim, option_inst.p_magic, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
								end
								from
								until
									js.loop_left
								loop
									js.reset
									if (l_arg[0]).to_integer_32 /= 0 then
										if (l_arg[0]).to_integer_32 = l_delim then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										if (l_arg[0]).to_integer_32 = 92 then
											if (l_arg[1]).to_integer_32 /= 0 then
												l_arg.ce_gets (l_arg + 1)
											end
										end
										l_arg.ce_gets (l_arg + 1)
									end
								end
								js.reset
								if (l_arg[0]).to_integer_32 /= 0 then
									l_arg.ce_gets (l_arg + 1)
								end
								from
								until
									js.loop_left
								loop
									js.reset
									if (l_arg[0]).to_boolean then
										if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("|%"#")), (l_arg[0]).to_integer_32)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_arg.ce_gets (l_arg + 1)
									end
								end
								js.reset
								if (l_arg[0]).to_integer_32 /= 0 then
									Result := l_arg
									js.return
								end
								l_pos := -1 + 135 -- switch 1; break
				when 105 then -- switch 1, case 182 | switch 1, case 118 | switch 1, case 174 | switch 1, case 114 | switch 1, case 173 | switch 1, case 310 | switch 1, case 113 | switch 1, case 183 | switch 1, case 119
								l_arg.ce_gets (charset_inst.skipwhite ((charset_inst.skipdigits (l_arg))))
								if (l_arg.item).to_integer_32 = 47 then
									l_arg.ce_gets (l_arg + 1)
									from
									until
										js.loop_left
									loop
										js.reset
										if (l_arg.item).to_boolean then
											if (l_arg.item).to_integer_32 = 47 then
												js.break
											end
										else
											js.break
										end
										if not js.loop_jumped then
											if (l_arg.item).to_integer_32 = 92 then
												if (l_arg[1]).to_integer_32 /= 0 then
													l_arg.ce_gets (l_arg + 1)
												end
											end
											l_arg.ce_gets (l_arg + 1)
										end
									end
									js.reset
									if (l_arg.item).to_boolean then
										l_arg.ce_gets (charset_inst.skipwhite (l_arg + 1))
										if (l_arg.item).to_boolean then
											if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("|%"%N")), (l_arg.item).to_integer_32)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
												a_xp.item.xp_context := 0
											else
												Result := l_arg
												js.return
											end
										else
											Result := l_arg
											js.return
										end
									end
								end
								l_pos := -1 + 135 -- switch 1; break
				when 106 then -- switch 1, case 16
								Result := (fileio_inst.set_context_in_autocmd (a_xp, l_arg, 0))
								js.return
				when 107 then -- switch 1, case 115 | switch 1, case 116
								if not js.return_called then
									Result := (fileio_inst.set_context_in_autocmd (a_xp, l_arg, 1))
									js.return
								end
				when 108 then -- switch 1, case 367
								if not js.return_called then
									option_inst.set_context_in_set_cmd (a_xp, l_arg, 0)
								end
								l_pos := -1 + 135 -- switch 1; break
				when 109 then -- switch 1, case 369
								option_inst.set_context_in_set_cmd (a_xp, l_arg, 2)
								l_pos := -1 + 135 -- switch 1; break
				when 110 then -- switch 1, case 370
								option_inst.set_context_in_set_cmd (a_xp, l_arg, 4)
								l_pos := -1 + 135 -- switch 1; break
				when 111 then -- switch 1, case 417 | switch 1, case 400 | switch 1, case 311 | switch 1, case 238 | switch 1, case 448 | switch 1, case 406 | switch 1, case 319 | switch 1, case 440 | switch 1, case 405 | switch 1, case 314
								if (option_inst.p_wop.item).to_integer_32 /= 0 then
									a_xp.item.xp_context := 17
								else
									a_xp.item.xp_context := 6
								end
								a_xp.item.xp_pattern := l_arg
								l_pos := -1 + 135 -- switch 1; break
				when 112 then -- switch 1, case 17
								a_xp.item.xp_context := 14
								a_xp.item.xp_pattern := l_arg
								l_pos := -1 + 135 -- switch 1; break
				when 113 then -- switch 1, case 413
								syntax_inst.set_context_in_syntax_cmd (a_xp, l_arg)
								l_pos := -1 + 135 -- switch 1; break
				when 114 then -- switch 1, case 209 | switch 1, case 172 | switch 1, case 128 | switch 1, case 482 | switch 1, case 153 | switch 1, case 122 | switch 1, case 126 | switch 1, case 137 | switch 1, case 125 | switch 1, case 123 | switch 1, case 50 | switch 1, case 339
								eval_inst.set_context_for_expression (a_xp, l_arg, l_ea.cmdidx)
								l_pos := -1 + 135 -- switch 1; break
				when 115 then -- switch 1, case 455
								from
								until
									js.loop_left
								loop
									js.reset
									l_tmp___28.ce_gets (misc2_inst.vim_strchr (l_arg, (' ').code))
									a_xp.item.xp_pattern := l_tmp___28
									if (l_tmp___28.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										js.break
									end
									if not js.loop_jumped then
										l_arg.ce_gets (a_xp.item.xp_pattern + 1)
									end
								end
								js.reset
								a_xp.item.xp_context := 15
								a_xp.item.xp_pattern := l_arg
								l_pos := -1 + 135 -- switch 1; break
				when 116 then -- switch 1, case 154 | switch 1, case 103
								a_xp.item.xp_context := 19
								a_xp.item.xp_pattern := l_arg
								l_pos := -1 + 135 -- switch 1; break
				when 117 then -- switch 1, case 124
								syntax_inst.set_context_in_echohl_cmd (a_xp, l_arg)
								l_pos := -1 + 135 -- switch 1; break
				when 118 then -- switch 1, case 166
								syntax_inst.set_context_in_highlight_cmd (a_xp, l_arg)
								l_pos := -1 + 135 -- switch 1; break
				when 119 then -- switch 1, case 375
								ex_cmds_inst.set_context_in_sign_cmd (a_xp, l_arg)
								l_pos := -1 + 135 -- switch 1; break
				when 120 then -- switch 1, case 23 | switch 1, case 41 | switch 1, case 40
								from
								until
									js.loop_left
								loop
									js.reset
									l_tmp___29.ce_gets (misc2_inst.vim_strchr (l_arg, (' ').code))
									a_xp.item.xp_pattern := l_tmp___29
									if (l_tmp___29.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										js.break
									end
									if not js.loop_jumped then
										l_arg.ce_gets (a_xp.item.xp_pattern + 1)
									end
								end
								js.reset
				when 121 then -- switch 1, case 19 | switch 1, case 355 | switch 1, case 66
								a_xp.item.xp_context := 9
								a_xp.item.xp_pattern := l_arg
								l_pos := -1 + 135 -- switch 1; break
				when 122 then -- switch 1, case -1 | switch 1, case -2
								if l_compl /= 0 then
									if not ((l_ea.argt).bit_and (8)).to_boolean then
										if l_compl = 11 then
											Result := (menu_inst.set_context_in_menu_cmd (a_xp, l_cmd, l_arg, l_forceit))
											js.return
										end
										if not js.return_called and then (l_compl = 1) then
											Result := l_arg
											js.return
										end
										if not js.return_called and then (l_compl = 16) then
											Result := (getchar_inst.set_context_in_map_cmd (a_xp, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("map")), l_arg, l_forceit, 0, 0, {PC_CMD_INDEX}.CMD_map))
											js.return
										end
										if not js.return_called then
											from
											until
												js.loop_left
											loop
												js.reset
												l_tmp___32.ce_gets (misc2_inst.vim_strchr (l_arg, (' ').code))
												a_xp.item.xp_pattern := l_tmp___32
												if (l_tmp___32.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
													js.break
												end
												if not js.loop_jumped then
													l_arg.ce_gets (a_xp.item.xp_pattern + 1)
												end
											end
											js.reset
											a_xp.item.xp_pattern := l_arg
										end
									end
									if not js.return_called then
										a_xp.item.xp_context := l_compl
									end
								end
								l_pos := -1 + 135 -- switch 1; break
				when 123 then -- switch 1, case 250 | switch 1, case 275 | switch 1, case 270 | switch 1, case 273 | switch 1, case 470 | switch 1, case 473 | switch 1, case 286 | switch 1, case 290 | switch 1, case 175 | switch 1, case 178 | switch 1, case 70 | switch 1, case 76 | switch 1, case 222 | switch 1, case 225
								Result := (getchar_inst.set_context_in_map_cmd (a_xp, l_cmd, l_arg, l_forceit, 0, 0, l_ea.cmdidx))
								js.return
				when 124 then -- switch 1, case 457 | switch 1, case 282 | switch 1, case 477 | switch 1, case 293 | switch 1, case 184 | switch 1, case 94 | switch 1, case 242
								if not js.return_called then
									Result := (getchar_inst.set_context_in_map_cmd (a_xp, l_cmd, l_arg, l_forceit, 0, 1, l_ea.cmdidx))
									js.return
								end
				when 125 then -- switch 1, case 1 | switch 1, case 278 | switch 1, case 45 | switch 1, case 77 | switch 1, case 170 | switch 1, case 179
								if not js.return_called then
									Result := (getchar_inst.set_context_in_map_cmd (a_xp, l_cmd, l_arg, l_forceit, 1, 0, l_ea.cmdidx))
									js.return
								end
				when 126 then -- switch 1, case 453 | switch 1, case 95 | switch 1, case 185
								if not js.return_called then
									Result := (getchar_inst.set_context_in_map_cmd (a_xp, l_cmd, l_arg, l_forceit, 1, 1, l_ea.cmdidx))
									js.return
								end
				when 127 then -- switch 1, case 254 | switch 1, case 279 | switch 1, case 458 | switch 1, case 5 | switch 1, case 6 | switch 1, case 18 | switch 1, case 272 | switch 1, case 274 | switch 1, case 283 | switch 1, case 472 | switch 1, case 475 | switch 1, case 478 | switch 1, case 288 | switch 1, case 291 | switch 1, case 294 | switch 1, case 177 | switch 1, case 180 | switch 1, case 186 | switch 1, case 72 | switch 1, case 78 | switch 1, case 96 | switch 1, case 442 | switch 1, case 449 | switch 1, case 302 | switch 1, case 437 | switch 1, case 129
								if not js.return_called then
									Result := (menu_inst.set_context_in_menu_cmd (a_xp, l_cmd, l_arg, l_forceit))
									js.return
								end
				when 128 then -- switch 1, case 81
								if not js.return_called then
									a_xp.item.xp_context := 28
									a_xp.item.xp_pattern := l_arg
								end
								l_pos := -1 + 135 -- switch 1; break
				when 129 then -- switch 1, case 84
								a_xp.item.xp_context := 29
								a_xp.item.xp_pattern := l_arg
								l_pos := -1 + 135 -- switch 1; break
				when 130 then -- switch 1, case 295
								a_xp.item.xp_context := 39
								a_xp.item.xp_pattern := l_arg
								l_pos := -1 + 135 -- switch 1; break
				when 131 then -- switch 1, case 368
								a_xp.item.xp_context := 37
								a_xp.item.xp_pattern := l_arg
								l_pos := -1 + 135 -- switch 1; break
				when 132 then -- switch 1, case 197
								if ((charset_inst.skiptowhite (l_arg)).item).to_integer_32 = 0 then
									a_xp.item.xp_context := 27
									a_xp.item.xp_pattern := l_arg
								else
									a_xp.item.xp_context := 0
								end
								l_pos := -1 + 135 -- switch 1; break
				when 133 then -- switch 1, case 24
								a_xp.item.xp_context := 36
								l_pos := -1 + 135 -- switch 1; break
				when 134 then -- switch 1, default:
								l_pos := -1 + 135 -- switch 1; break
				when 135 then -- switch 1, done: | if done
								if not js.return_called then
									Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								end
				when 136 then
								l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
					end

	skip_range (a_cmd: CE_POINTER [NATURAL_8]; a_ctx: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		local
			l_cmd: CE_POINTER [NATURAL_8]
			l_delim: NATURAL_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_cmd.make
			create l_tmp.make
			create l_tmp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_cmd.ce_gets (a_cmd)
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 13 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" %T0123456789.$%%%'/?-+,;")), (l_cmd.item).to_integer_32)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 12 -- skip if block
						end
				when 3 then -- if:
						if (l_cmd.item).to_integer_32 /= 39 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_cmd.ce_gets (l_cmd + 1)
						if (l_cmd.item).to_integer_32 = 0 then
							if (a_ctx.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								a_ctx.item := 0
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 6 then -- else:
						if (l_cmd.item).to_integer_32 /= 47 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if (l_cmd.item).to_integer_32 /= 63 then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						l_tmp.ce_gets (l_cmd)
						l_cmd.ce_gets (l_cmd + 1)
						l_delim := (l_tmp.item).to_natural_32
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_cmd.item).to_integer_32 /= 0 then
								if (l_cmd.item).to_natural_32 = l_delim then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_tmp___0.ce_gets (l_cmd)
								l_cmd.ce_gets (l_cmd + 1)
								if (l_tmp___0.item).to_integer_32 = 92 then
									if (l_cmd.item).to_integer_32 /= 0 then
										l_cmd.ce_gets (l_cmd + 1)
									end
								end
							end
						end
						js.reset
						if (l_cmd.item).to_integer_32 = 0 then
							if (a_ctx.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								a_ctx.item := 0
							end
						end
				when 11 then -- if done | if done
						if (l_cmd.item).to_integer_32 /= 0 then
							l_cmd.ce_gets (l_cmd + 1)
						end
				when 12 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 13 then -- loop done
					js.reset
					from
					until
						(l_cmd.item).to_integer_32 /= 58
					loop
						l_cmd.ce_gets (charset_inst.skipwhite (l_cmd + 1))
					end
					Result := l_cmd
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_address (a_ptr: CE_POINTER [CE_POINTER [NATURAL_8]]; a_skip___0: INTEGER_32; a_to_other_file: INTEGER_32): INTEGER_32
		local
			l_c: INTEGER_32
			l_i___0: INTEGER_32
			l_n: INTEGER_32
			l_cmd: CE_POINTER [NATURAL_8]
			l_pos___3: PD_POS_T
			l_fp: CE_POINTER [PD_POS_T]
			l_lnum: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___4: INTEGER_32
			l_tmp___6: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_cmd.make
			create l_pos___3.make
			create l_fp.make
			create l_tmp___1.make
			create l_tmp___6.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_cmd.ce_gets (charset_inst.skipwhite (a_ptr.item))
					l_lnum := 2147483647
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 26 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						inspect (l_cmd.item).to_integer_32 -- switch 1 head
						when 46 then l_pos := -1 + 3
						when 36 then l_pos := -1 + 4
						when 39 then l_pos := -1 + 5
						when 47 then l_pos := -1 + 15
						when 63 then l_pos := -1 + 15
						when 92 then l_pos := -1 + 21
						else l_pos := -1 + 24
						end
				when 3 then -- switch 1, case 46
						l_cmd.ce_gets (l_cmd + 1)
						l_lnum := globals_inst.curwin.item.w_cursor.lnum
						l_pos := -1 + 25 -- switch 1; break
				when 4 then -- switch 1, case 36
						l_cmd.ce_gets (l_cmd + 1)
						l_lnum := globals_inst.curbuf.item.b_ml.ml_line_count
						l_pos := -1 + 25 -- switch 1; break
				when 5 then -- switch 1, case 39
						l_cmd.ce_gets (l_cmd + 1)
						if (l_cmd.item).to_integer_32 = 0 then
							l_cmd.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							l_pos := -1 + 27 -- goto error
						end
				when 6 then
						if not (a_skip___0.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_cmd.ce_gets (l_cmd + 1)
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 9 then -- else:
						if a_to_other_file.to_boolean then
							if (l_cmd[1]).to_integer_32 = 0 then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
						l_fp.ce_gets (mark_inst.getmark ((l_cmd.item).to_integer_32, l_tmp))
						l_cmd.ce_gets (l_cmd + 1)
						if (l_fp.c_pointer.to_integer_32).to_natural_32 /= (-1).to_natural_32 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_lnum := globals_inst.curwin.item.w_cursor.lnum
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 12 then -- else:
						if (mark_inst.check_mark (l_fp)) = 0 then
							l_cmd.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							l_pos := -1 + 27 -- goto error
						end
				when 13 then
						l_lnum := l_fp.item.lnum
				when 14 then -- if done | if done
						l_pos := -1 + 25 -- switch 1; break
				when 15 then -- switch 1, case 47 | switch 1, case 63
						l_tmp___1.ce_gets (l_cmd)
						l_cmd.ce_gets (l_cmd + 1)
						l_c := (l_tmp___1.item).to_integer_32
						if not (a_skip___0.to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_cmd.ce_gets (regexp_inst.skip_regexp (l_cmd, l_c, option_inst.p_magic, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
						if (l_cmd.item).to_integer_32 = l_c then
							l_cmd.ce_gets (l_cmd + 1)
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 18 then -- else:
						l_pos___3.ce_gets (globals_inst.curwin.item.w_cursor)
						if l_lnum /= 2147483647 then
							globals_inst.curwin.item.w_cursor.lnum := l_lnum
						end
						if l_c = 47 then
							globals_inst.curwin.item.w_cursor.col := (2147483647).to_integer_32
						else
							globals_inst.curwin.item.w_cursor.col := 0
						end
						globals_inst.searchcmdlen := 0
						if not (search_inst.do_search (create {CE_POINTER [PD_OPARG_S]}.make_shared (default_pointer), l_c, l_cmd, 1, 44, create {CE_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))).to_boolean then
							globals_inst.curwin.item.w_cursor := l_pos___3
							l_cmd.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							l_pos := -1 + 27 -- goto error
						end
				when 19 then
						l_lnum := globals_inst.curwin.item.w_cursor.lnum
						globals_inst.curwin.item.w_cursor := l_pos___3
						l_cmd.ce_gets (l_cmd + globals_inst.searchcmdlen)
				when 20 then -- if done
						l_pos := -1 + 25 -- switch 1; break
				when 21 then -- switch 1, case 92
						l_cmd.ce_gets (l_cmd + 1)
						if (l_cmd.item).to_integer_32 = 38 then
							l_i___0 := 1
						elseif (l_cmd.item).to_integer_32 = 63 then
							l_i___0 := 0
						elseif (l_cmd.item).to_integer_32 = 47 then
							l_i___0 := 0
						else
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_backslash))))).do_nothing
							l_cmd.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							l_pos := -1 + 27 -- goto error
						end
				when 22 then
						if not a_skip___0.to_boolean then
							if l_lnum /= 2147483647 then
								l_pos___3.lnum := l_lnum
							else
								l_pos___3.lnum := globals_inst.curwin.item.w_cursor.lnum
							end
							if (l_cmd.item).to_integer_32 /= 63 then
								l_pos___3.col := (2147483647).to_integer_32
							else
								l_pos___3.col := 0
							end
							if (l_cmd.item).to_integer_32 = 63 then
								l_tmp___4 := -1
							else
								l_tmp___4 := 1
							end
							if (search_inst.searchit (globals_inst.curwin, globals_inst.curbuf, l_pos___3.address, l_tmp___4, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 1, 12, l_i___0, (0).to_integer_32, create {CE_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))) /= 0 then
								l_lnum := l_pos___3.lnum
							else
								l_cmd.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								l_pos := -1 + 27 -- goto error
							end
						end
				when 23 then
						l_cmd.ce_gets (l_cmd + 1)
						l_pos := -1 + 25 -- switch 1; break
				when 24 then -- switch 1, default:
						if (l_cmd.item).to_integer_32 >= 48 then
							if (l_cmd.item).to_integer_32 <= 57 then
								l_lnum := charset_inst.getdigits (l_cmd.address)
							end
						end
				when 25 then -- switch 1, done:
						from
						until
							js.loop_left
						loop
							js.reset
							l_cmd.ce_gets (charset_inst.skipwhite (l_cmd))
							if (l_cmd.item).to_integer_32 /= 45 then
								if (l_cmd.item).to_integer_32 /= 43 then
									if (l_cmd.item).to_integer_32 >= 48 then
										if not ((l_cmd.item).to_integer_32 <= 57) then
											js.break
										end
									else
										js.break
									end
								end
							end
							if not js.loop_jumped then
								if l_lnum = 2147483647 then
									l_lnum := globals_inst.curwin.item.w_cursor.lnum
								end
								if (l_cmd.item).to_integer_32 >= 48 then
									if (l_cmd.item).to_integer_32 <= 57 then
										l_i___0 := ('+').code
									else
										l_tmp___6.ce_gets (l_cmd)
										l_cmd.ce_gets (l_cmd + 1)
										l_i___0 := (l_tmp___6.item).to_integer_32
									end
								else
									l_tmp___6.ce_gets (l_cmd)
									l_cmd.ce_gets (l_cmd + 1)
									l_i___0 := (l_tmp___6.item).to_integer_32
								end
								if (l_cmd.item).to_integer_32 >= 48 then
									if (l_cmd.item).to_integer_32 <= 57 then
										l_n := charset_inst.getdigits (l_cmd.address)
									else
										l_n := 1
									end
								else
									l_n := 1
								end
								if l_i___0 = 45 then
									l_lnum := l_lnum - l_n
								else
									l_lnum := l_lnum + l_n
								end
							end
						end
						js.reset
						if (l_cmd.item).to_integer_32 /= 47 then
							if (l_cmd.item).to_integer_32 /= 63 then
								js.break
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 26 then -- loop done
					js.reset
				when 27 then -- error:
					a_ptr.item := l_cmd
					Result := l_lnum
				when 28 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_flags (a_eap: CE_POINTER [PD_EXARG])
		local
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lp#")), ((a_eap.item.arg).item).to_integer_32)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					js.break
				end
				if not js.loop_jumped then
					if ((a_eap.item.arg).item).to_integer_32 = 108 then
						a_eap.item.flags := (a_eap.item.flags).bit_or ((1))
					elseif ((a_eap.item.arg).item).to_integer_32 = 112 then
						a_eap.item.flags := (a_eap.item.flags).bit_or ((4))
					else
						a_eap.item.flags := (a_eap.item.flags).bit_or ((2))
					end
					a_eap.item.arg := charset_inst.skipwhite (a_eap.item.arg + 1)
				end
			end
			js.reset
		end

	ex_ni (a_eap: CE_POINTER [PD_EXARG])
		do
			if not (a_eap.item.skip).to_boolean then
				a_eap.item.errmsg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E319: Sorry, the command is not available in this version"))
			end
		end

	ex_ni_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_ni)
		end

	ex_script_ni (a_eap: CE_POINTER [PD_EXARG])
		do
			if not (a_eap.item.skip).to_boolean then
				ex_ni (a_eap)
			else
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((ex_getln_inst.script_get (a_eap, a_eap.item.arg))))
			end
		end

	ex_script_ni_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_script_ni)
		end

	invalid_range (a_eap: CE_POINTER [PD_EXARG]): CE_POINTER [NATURAL_8]
		local
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_tmp.make

			if a_eap.item.line1 < 0 then
				l_tmp.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invrange)))
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp))
				js.return
			elseif a_eap.item.line2 < 0 then
				l_tmp.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invrange)))
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp))
				js.return
			elseif a_eap.item.line1 > a_eap.item.line2 then
				l_tmp.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invrange)))
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp))
				js.return
			elseif ((a_eap.item.argt).bit_and (1)).to_boolean then
				if not ((a_eap.item.argt).bit_and (16384)).to_boolean then
					if a_eap.item.line2 > globals_inst.curbuf.item.b_ml.ml_line_count + (a_eap.item.cmdidx = 106).to_integer then
						l_tmp.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invrange)))
						Result := (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp))
						js.return
					end
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	correct_range (a_eap: CE_POINTER [PD_EXARG])
		do
			if not ((a_eap.item.argt).bit_and (4096)).to_boolean then
				if a_eap.item.line1 = 0 then
					a_eap.item.line1 := (1).to_integer_32
				end
				if a_eap.item.line2 = 0 then
					a_eap.item.line2 := (1).to_integer_32
				end
			end
		end

	skip_grep_pat (a_eap: CE_POINTER [PD_EXARG]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (a_eap.item.arg)
					if (l_p___0.item).to_integer_32 = 0 then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						if a_eap.item.cmdidx /= 467 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 4 then -- else:
						if a_eap.item.cmdidx /= 243 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 7 then -- else:
						if a_eap.item.cmdidx /= 468 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 10 then -- else:
						if a_eap.item.cmdidx /= 244 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 13 then -- else:
						if not ((quickfix_inst.grep_internal (a_eap.item.cmdidx)).to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L:
						l_p___0.ce_gets (quickfix_inst.skip_vimgrep_pat (l_p___0, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_p___0.ce_gets (a_eap.item.arg)
						end
				when 15 then -- if done | if done | if done | if done | if done
						Result := l_p___0
				when 16 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	replace_makeprg (a_eap: CE_POINTER [PD_EXARG]; a_p___0: CE_POINTER [NATURAL_8]; a_cmdlinep: CE_POINTER [CE_POINTER [NATURAL_8]]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_new_cmdline: CE_POINTER [NATURAL_8]
			l_program: CE_POINTER [NATURAL_8]
			l_pos___3: CE_POINTER [NATURAL_8]
			l_ptr: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp___3: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_new_cmdline.make
			create l_program.make
			create l_pos___3.make
			create l_ptr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (a_p___0)
					if a_eap.item.cmdidx /= 249 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 16 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 3 then -- else:
						if a_eap.item.cmdidx /= 224 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 16 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 6 then -- else:
						if a_eap.item.cmdidx /= 157 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 16 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 9 then -- else:
						if a_eap.item.cmdidx /= 216 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 16 -- goto _L___0
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 12 then -- else:
						if a_eap.item.cmdidx /= 158 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L___0
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 15 then -- else:
						if a_eap.item.cmdidx /= 217 then
							l_pos := -1 + 31 -- skip if block
						end
				when 16 then -- if: | _L___0:
						if (quickfix_inst.grep_internal (a_eap.item.cmdidx)).to_boolean then
							l_pos := -1 + 31 -- skip if block
						end
				when 17 then -- if:
						if a_eap.item.cmdidx /= 157 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 27 -- goto _L
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 20 then -- else:
						if a_eap.item.cmdidx /= 216 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 27 -- goto _L
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 23 then -- else:
						if a_eap.item.cmdidx /= 158 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_pos := -1 + 27 -- goto _L
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 26 then -- else:
						if a_eap.item.cmdidx /= 217 then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if: | _L:
						if ((globals_inst.curbuf.item.b_p_gp).item).to_integer_32 = 0 then
							l_program.ce_gets (option_inst.p_gp)
						else
							l_program.ce_gets (globals_inst.curbuf.item.b_p_gp)
						end
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else:
						if ((globals_inst.curbuf.item.b_p_mp).item).to_integer_32 = 0 then
							l_program.ce_gets (option_inst.p_mp)
						else
							l_program.ce_gets (globals_inst.curbuf.item.b_p_mp)
						end
				when 30 then -- if done | if done | if done
						l_p___0.ce_gets (charset_inst.skipwhite (l_p___0))
						l_pos___3.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_program), ce_string ("$*")))))
						if (l_pos___3.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_i___0 := 1
							from
							until
								js.loop_left
							loop
								js.reset
								l_pos___3.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strstr ((create {CE_POINTER [INTEGER_8]}.make_cast (l_pos___3) + 2), ce_string ("$*")))))
								if (l_pos___3.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									js.break
								end
								if not js.loop_jumped then
									l_i___0 := l_i___0 + 1
								end
							end
							js.reset
							l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32
							l_new_cmdline.ce_gets (misc2_inst.alloc ((((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_program))) + (l_i___0 * (l_len - 2)).to_natural_32) + {NATURAL_32} 1)))
							if (l_new_cmdline.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								js.return
							end
							if not js.return_called then
								l_ptr.ce_gets (l_new_cmdline)
								from
								until
									js.loop_left
								loop
									js.reset
									l_pos___3.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_program), ce_string ("$*")))))
									if (l_pos___3.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										js.break
									end
									if not js.loop_jumped then
										l_i___0 := l_pos___3.distance (l_program)
										strncpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), create {CE_POINTER [INTEGER_8]}.make_cast (l_program), l_i___0.to_natural_32).do_nothing
										l_ptr.ce_gets (l_ptr + l_i___0)
										strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0)).do_nothing
										l_ptr.ce_gets (l_ptr + l_len)
										l_program.ce_gets (l_pos___3 + 2)
									end
								end
								js.reset
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), create {CE_POINTER [INTEGER_8]}.make_cast (l_program)).do_nothing
							end
						else
							l_tmp___3 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_program))
							l_new_cmdline.ce_gets (misc2_inst.alloc (((l_tmp___3 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0)))) + {NATURAL_32} 2)))
							if (l_new_cmdline.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								js.return
							end
							if not js.return_called then
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_new_cmdline), create {CE_POINTER [INTEGER_8]}.make_cast (l_program)).do_nothing
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_new_cmdline), ce_string (" ")).do_nothing
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_new_cmdline), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0)).do_nothing
							end
						end
						if not js.return_called then
							message_inst.msg_make (l_p___0)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_cmdlinep.item))
							a_cmdlinep.item := l_new_cmdline
							l_p___0.ce_gets (l_new_cmdline)
						end
				when 31 then -- if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := l_p___0
						end
				when 32 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	expand_filename (a_eap: CE_POINTER [PD_EXARG]; a_cmdlinep: CE_POINTER [CE_POINTER [NATURAL_8]]; a_errormsgp: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_has_wildcards: INTEGER_32
			l_repl: CE_POINTER [NATURAL_8]
			l_srclen: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			l_escaped: INTEGER_32
			l_l: CE_POINTER [NATURAL_8]
			l_l___0: CE_POINTER [NATURAL_8]
			l_l___1: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_xpc: PD_EXPAND
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_repl.make
			create l_p___0.make
			create l_l.make
			create l_l___0.make
			create l_l___1.make
			create l_tmp___5.make
			create l_xpc.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (skip_grep_pat (a_eap))
					l_has_wildcards := os_unix_inst.mch_has_wildcard (l_p___0)
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0)) then
						l_pos := -1 + 12 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if (l_p___0[0]).to_integer_32 = 96 then
							if (l_p___0[1]).to_integer_32 = 61 then
								l_p___0.ce_gets (l_p___0 + (2))
								eval_inst.skip_expr (l_p___0.address).do_nothing
								if (l_p___0.item).to_integer_32 = 96 then
									l_p___0.ce_gets (l_p___0 + 1)
								end
								js.continue
							end
						end
						if not js.loop_jumped then
							if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%%#<")), (l_p___0.item).to_integer_32)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_p___0.ce_gets (l_p___0 + 1)
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						l_repl.ce_gets (eval_vars (l_p___0, a_eap.item.arg, create {CE_POINTER [INTEGER_32]}.make_shared ($l_srclen), create {CE_POINTER [INTEGER_32]}.make_shared (a_eap.c_pointer + {PD_EXARG}.do_ecmd_lnum_offset), a_errormsgp, create {CE_POINTER [INTEGER_32]}.make_shared ($l_escaped)))
						if ((a_errormsgp.item).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							Result := 0
							js.return
						end
						if js.return_called then
							l_pos := -1 + 11 -- skip if block
						end
				when 4 then -- if:
						if (l_repl.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_p___0.ce_gets (l_p___0 + l_srclen)
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 11 -- skip if block
						end
				when 5 then -- if:
						if ((misc2_inst.vim_strchr (l_repl, ('$').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_l.ce_gets (l_repl)
							l_repl.ce_gets (misc1_inst.expand_env_save (l_repl))
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_l))
						elseif ((misc2_inst.vim_strchr (l_repl, ('~').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_l.ce_gets (l_repl)
							l_repl.ce_gets (misc1_inst.expand_env_save (l_repl))
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_l))
						end
						if not (a_eap.item.usefilter).to_boolean then
							if not l_escaped.to_boolean then
								if a_eap.item.cmdidx /= 505 then
									if a_eap.item.cmdidx /= 249 then
										if a_eap.item.cmdidx /= 224 then
											if a_eap.item.cmdidx /= 157 then
												if a_eap.item.cmdidx /= 216 then
													if a_eap.item.cmdidx /= 158 then
														if a_eap.item.cmdidx /= 217 then
															l_l___0.ce_gets (l_repl)
															from
															until
																not (not js.loop_left and then ((l_l___0.item).to_boolean))
															loop
																js.reset
																if ((misc2_inst.vim_strchr (globals_inst.escape_chars, (l_l___0.item).to_integer_32)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
																	l_l___0.ce_gets (misc2_inst.vim_strsave_escaped (l_repl, globals_inst.escape_chars))
																	if (l_l___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
																		misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_repl))
																		l_repl.ce_gets (l_l___0)
																	end
																	js.break
																end
																if not js.loop_jumped then
																	l_l___0.ce_gets (l_l___0 + 1)
																end
															end
															js.reset
														end
													end
												end
											end
										end
									end
								end
							end
						end
						if not ((a_eap.item.usefilter).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if a_eap.item.cmdidx /= 505 then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if ((strpbrk (create {CE_POINTER [INTEGER_8]}.make_cast (l_repl), ce_string ("!&;()<>"))).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_l___1.ce_gets (misc2_inst.vim_strsave_escaped (l_repl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("!&;()<>"))))
							if (l_l___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_repl))
								l_repl.ce_gets (l_l___1)
								if ((strstr (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_sh), ce_string ("sh"))).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_l___1.ce_gets (misc2_inst.vim_strsave_escaped (l_repl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("!"))))
									if (l_l___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_repl))
										l_repl.ce_gets (l_l___1)
									end
								end
							end
						end
				when 10 then -- if done
						l_p___0.ce_gets (repl_cmdline (a_eap, l_p___0, l_srclen, l_repl, a_cmdlinep))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_repl))
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							Result := 0
							js.return
						end
				when 11 then -- if done | if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 12 then -- loop done
					if not (not js.return_called and then (((a_eap.item.argt).bit_and (16)).to_boolean)) then
						l_pos := -1 + 27 -- skip if block
					end
				when 13 then -- if:
						if (a_eap.item.usefilter).to_boolean then
							l_pos := -1 + 27 -- skip if block
						end
				when 14 then -- if:
						l_n := 1
				when 15 then -- loop condition:
						if not (not js.loop_left and then (l_n <= 2)) then
							l_pos := -1 + 27 -- skip loop
						end
				when 16 then -- loop body:
						if l_n /= 2 then
							l_pos := -1 + 26 -- skip if block
						end
				when 17 then -- if:
						if l_has_wildcards.to_boolean then
							l_pos := -1 + 25 -- skip if block
						end
				when 18 then -- if:
						l_p___0.ce_gets (a_eap.item.arg)
				when 19 then -- loop condition:
						if not (not js.loop_left and then ((l_p___0.item).to_boolean)) then
							l_pos := -1 + 25 -- skip loop
						end
				when 20 then -- loop body:
						if not ((l_p___0[1]).to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						if (l_p___0.item).to_integer_32 = 92 then
							l_p___0.ce_gets (l_p___0 + 1)
						elseif (l_p___0.item).to_integer_32 = 22 then
							l_p___0.ce_gets (l_p___0 + 1)
						else
							l_pos := -1 + 23 -- goto _L___0
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else: | _L___0:
						if (l_p___0.item).to_integer_32 = 32 then
							l_tmp___5.ce_gets (gettext (ce_string ("E172: Only one file name allowed")))
							a_errormsgp.item := create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___5)
							Result := 0
							js.return
						elseif (l_p___0.item).to_integer_32 = 9 then
							l_tmp___5.ce_gets (gettext (ce_string ("E172: Only one file name allowed")))
							a_errormsgp.item := create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___5)
							Result := 0
							js.return
						end
				when 24 then
						if not js.return_called then
							l_p___0.ce_gets (l_p___0 + 1)
						end
						l_pos := -1 + 19 -- back to loop condition
				when 25 then -- loop done | if done
						if not js.return_called and then (not l_has_wildcards.to_boolean) then
							charset_inst.backslash_halve (a_eap.item.arg)
						end
				when 26 then -- if done
						if not js.return_called and then (l_has_wildcards.to_boolean) then
							if l_n = 1 then
								if ((misc2_inst.vim_strchr (a_eap.item.arg, ('$').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									misc1_inst.expand_env_esc (a_eap.item.arg, globals_inst.NameBuff, 4096, 1, 1, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
									l_has_wildcards := os_unix_inst.mch_has_wildcard (globals_inst.NameBuff)
									l_p___0.ce_gets (globals_inst.NameBuff)
								elseif ((misc2_inst.vim_strchr (a_eap.item.arg, ('~').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									misc1_inst.expand_env_esc (a_eap.item.arg, globals_inst.NameBuff, 4096, 1, 1, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
									l_has_wildcards := os_unix_inst.mch_has_wildcard (globals_inst.NameBuff)
									l_p___0.ce_gets (globals_inst.NameBuff)
								else
									l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								end
							else
								ex_getln_inst.ExpandInit (l_xpc.address)
								l_xpc.xp_context := 2
								l_p___0.ce_gets (ex_getln_inst.ExpandOne (l_xpc.address, a_eap.item.arg, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 17, 2))
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									Result := 0
									js.return
								end
							end
							if not js.return_called and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32) then
								repl_cmdline (a_eap, a_eap.item.arg, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg))).to_integer_32, l_p___0, a_cmdlinep).do_nothing
								if l_n = 2 then
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
								end
							end
						end
						if not js.return_called then
							l_n := l_n + 1
						end
						l_pos := -1 + 15 -- back to loop condition
				when 27 then -- loop done | if done | if done
						if not js.return_called then
							Result := 1
						end
				when 28 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	repl_cmdline (a_eap: CE_POINTER [PD_EXARG]; a_src: CE_POINTER [NATURAL_8]; a_srclen: INTEGER_32; a_repl: CE_POINTER [NATURAL_8]; a_cmdlinep: CE_POINTER [CE_POINTER [NATURAL_8]]): CE_POINTER [NATURAL_8]
		local
			l_src: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			l_new_cmdline: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_src.make
			create l_new_cmdline.make

			l_src.ce_gets (a_src)
			l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_repl))).to_integer_32
			l_i___0 := (((l_src.distance ((a_cmdlinep.item))) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_src + a_srclen)))).to_integer_32) + l_len) + 3
			if ((a_eap.item.nextcmd).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_i___0 := l_i___0 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.nextcmd))).to_integer_32
			end
			l_new_cmdline.ce_gets (misc2_inst.alloc (l_i___0.to_natural_32))
			if (l_new_cmdline.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_i___0 := l_src.distance ((a_cmdlinep.item))
				memmove (create {CE_POINTER [ANY]}.make_cast (l_new_cmdline), create {CE_POINTER [ANY]}.make_cast (a_cmdlinep.item), l_i___0.to_natural_32).do_nothing
				memmove (create {CE_POINTER [ANY]}.make_cast ((l_new_cmdline + l_i___0)), create {CE_POINTER [ANY]}.make_cast (a_repl), l_len.to_natural_32).do_nothing
				l_i___0 := l_i___0 + l_len
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_new_cmdline + l_i___0)), create {CE_POINTER [INTEGER_8]}.make_cast ((l_src + a_srclen))).do_nothing
				l_src.ce_gets (l_new_cmdline + l_i___0)
				if ((a_eap.item.nextcmd).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					l_i___0 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_new_cmdline))).to_integer_32 + 1
					strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_new_cmdline + l_i___0)), create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.nextcmd)).do_nothing
					a_eap.item.nextcmd := l_new_cmdline + l_i___0
				end
				a_eap.item.cmd := l_new_cmdline + ((a_eap.item.cmd).distance ((a_cmdlinep.item)))
				a_eap.item.arg := l_new_cmdline + ((a_eap.item.arg).distance ((a_cmdlinep.item)))
				if ((a_eap.item.do_ecmd_cmd).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if ((a_eap.item.do_ecmd_cmd).c_pointer.to_integer_32).to_natural_32 /= (dollar_command.c_pointer.to_integer_32).to_natural_32 then
						a_eap.item.do_ecmd_cmd := l_new_cmdline + ((a_eap.item.do_ecmd_cmd).distance ((a_cmdlinep.item)))
					end
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_cmdlinep.item))
				a_cmdlinep.item := l_new_cmdline
				Result := l_src
			end
		end

	separate_nextcmd (a_eap: CE_POINTER [PD_EXARG])
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (skip_grep_pat (a_eap))
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_p___0.item).to_boolean)) then
						l_pos := -1 + 32 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if (l_p___0.item).to_integer_32 /= 22 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if ((a_eap.item.argt).bit_and (8200)).to_boolean then
							l_p___0.ce_gets (l_p___0 + 1)
						else
							memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 1)))) + {NATURAL_32} 1).do_nothing
						end
						if (l_p___0.item).to_integer_32 = 0 then
							js.break
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 5 then -- else:
						if (l_p___0[0]).to_integer_32 /= 96 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (l_p___0[1]).to_integer_32 = 61 then
							if ((a_eap.item.argt).bit_and (8)).to_boolean then
								l_p___0.ce_gets (l_p___0 + (2))
								eval_inst.skip_expr (l_p___0.address).do_nothing
							else
								l_pos := -1 + 8 -- goto _L___7
							end
						else
							l_pos := -1 + 8 -- goto _L___7
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 8 then -- else: | _L___7:
						if (l_p___0.item).to_integer_32 /= 34 then
							l_pos := -1 + 20 -- skip if block
						end
				when 9 then -- if:
						if ((a_eap.item.argt).bit_and (2048)).to_boolean then
							l_pos := -1 + 18 -- skip if block
						end
				when 10 then -- if:
						if a_eap.item.cmdidx = 512 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if a_eap.item.cmdidx /= 508 then
							l_pos := -1 + 14 -- goto _L___3
						else
							l_pos := -1 + 13 -- goto _L___4
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 13 then -- else: | _L___4:
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = ((a_eap.item.arg).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if: | _L___3:
						if a_eap.item.cmdidx /= 333 then
							l_pos := -1 + 24 -- goto _L___0
						elseif (l_p___0.c_pointer.to_integer_32).to_natural_32 /= ((a_eap.item.arg + 1).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 24 -- goto _L___0
						elseif (l_p___0[-1]).to_integer_32 /= 64 then
							l_pos := -1 + 24 -- goto _L___0
						else
							l_pos := -1 + 20 -- goto _L___5
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						l_pos := -1 + 20 -- goto _L___5
				when 17 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						l_pos := -1 + 20 -- goto _L___5
				when 19 then -- if done | if block done, skip else block:
						l_pos := -1 + 31
				when 20 then -- else: | _L___5:
						if (l_p___0.item).to_integer_32 /= 124 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 24 -- goto _L___0
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 23 then -- else:
						if (l_p___0.item).to_integer_32 /= 10 then
							l_pos := -1 + 31 -- skip if block
						end
				when 24 then -- if: | _L___0:
						if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('b').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 28 -- goto _L
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 27 then -- else:
						if ((a_eap.item.argt).bit_and (8192)).to_boolean then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if: | _L:
						if (l_p___0[-1]).to_integer_32 = 92 then
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_p___0 - 1)), create {CE_POINTER [ANY]}.make_cast (l_p___0), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))) + {NATURAL_32} 1).do_nothing
							l_p___0.ce_gets (l_p___0 - 1)
						else
							a_eap.item.nextcmd := check_nextcmd (l_p___0)
							l_p___0.item := (('%/0/').code).to_natural_8
							js.break
						end
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else:
						a_eap.item.nextcmd := check_nextcmd (l_p___0)
						l_p___0.item := (('%/0/').code).to_natural_8
						js.break
				when 31 then -- if done | if done | if done | if done | if done | if done
						if not js.loop_jumped then
							if globals_inst.has_mbyte.to_boolean then
								l_tmp___0 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
							else
								l_tmp___0 := 1
							end
							l_p___0.ce_gets (l_p___0 + l_tmp___0)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 32 then -- loop done
					js.reset
					if not ((a_eap.item.argt).bit_and (2048)).to_boolean then
						misc2_inst.del_trailing_spaces (a_eap.item.arg)
					end
				when 33 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	getargcmd (a_argp: CE_POINTER [CE_POINTER [NATURAL_8]]): CE_POINTER [NATURAL_8]
		local
			l_arg: CE_POINTER [NATURAL_8]
			l_command: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
		do
			create l_arg.make
			create l_command.make
			create l_tmp.make

			l_arg.ce_gets (a_argp.item)
			l_command.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			if (l_arg.item).to_integer_32 = 43 then
				l_arg.ce_gets (l_arg + 1)
				if (misc2_inst.vim_isspace ((l_arg.item).to_integer_32)).to_boolean then
					l_command.ce_gets (dollar_command)
				else
					l_command.ce_gets (l_arg)
					l_arg.ce_gets (skip_cmd_arg (l_command, 1))
					if (l_arg.item).to_integer_32 /= 0 then
						l_tmp.ce_gets (l_arg)
						l_arg.ce_gets (l_arg + 1)
						l_tmp.item := (('%/0/').code).to_natural_8
					end
				end
				l_arg.ce_gets (charset_inst.skipwhite (l_arg))
				a_argp.item := l_arg
			end
			Result := l_command
		end

	skip_cmd_arg (a_p___0: CE_POINTER [NATURAL_8]; a_rembs: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0.ce_gets (a_p___0)
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_p___0.item).to_boolean then
					if (misc2_inst.vim_isspace ((l_p___0.item).to_integer_32)).to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if (l_p___0.item).to_integer_32 = 92 then
						if (l_p___0[1]).to_integer_32 /= 0 then
							if a_rembs.to_boolean then
								memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 1)))) + {NATURAL_32} 1).do_nothing
							else
								l_p___0.ce_gets (l_p___0 + 1)
							end
						end
					end
					if globals_inst.has_mbyte.to_boolean then
						l_tmp___1 := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0]))
					else
						l_tmp___1 := 1
					end
					l_p___0.ce_gets (l_p___0 + l_tmp___1)
				end
			end
			js.reset
			Result := l_p___0
		end

	getargopt (a_eap: CE_POINTER [PD_EXARG]): INTEGER_32
		local
			l_arg: CE_POINTER [NATURAL_8]
			l_pp: CE_POINTER [INTEGER_32]
			l_bad_char_idx: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_arg.make
			create l_pp.make
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_arg.ce_gets (a_eap.item.arg + 2)
					l_pp.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
					if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("bin"), (3).to_natural_32)) /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("nobin"), (5).to_natural_32)) /= 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if (l_arg.item).to_integer_32 = 110 then
							l_arg.ce_gets (l_arg + (2))
							a_eap.item.force_bin := 2
						else
							a_eap.item.force_bin := 1
						end
						if not (checkforcmd (l_arg.address, ce_string ("binary"), 3)).to_boolean then
							Result := 0
							js.return
						end
						if not js.return_called then
							a_eap.item.arg := charset_inst.skipwhite (l_arg)
							Result := 1
							js.return
						end
				when 5 then -- if done
						if not js.return_called then
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("edit"), (4).to_natural_32)) = 0 then
								a_eap.item.read_edit := 1
								a_eap.item.arg := charset_inst.skipwhite (l_arg + 4)
								Result := 1
								js.return
							end
						end
						if not js.return_called then
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("ff"), (2).to_natural_32)) = 0 then
								l_arg.ce_gets (l_arg + (2))
								l_pp.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared (a_eap.c_pointer + {PD_EXARG}.force_ff_offset))
							elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("fileformat"), (10).to_natural_32)) = 0 then
								l_arg.ce_gets (l_arg + (10))
								l_pp.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared (a_eap.c_pointer + {PD_EXARG}.force_ff_offset))
							elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("enc"), (3).to_natural_32)) = 0 then
								l_arg.ce_gets (l_arg + (3))
								l_pp.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared (a_eap.c_pointer + {PD_EXARG}.force_enc_offset))
							elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("encoding"), (8).to_natural_32)) = 0 then
								l_arg.ce_gets (l_arg + (8))
								l_pp.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared (a_eap.c_pointer + {PD_EXARG}.force_enc_offset))
							elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("bad"), (3).to_natural_32)) = 0 then
								l_arg.ce_gets (l_arg + (3))
								l_pp.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared ($l_bad_char_idx))
							end
							if (l_pp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								Result := 0
								js.return
							elseif (l_arg.item).to_integer_32 /= 61 then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							l_arg.ce_gets (l_arg + 1)
							l_pp.item := l_arg.distance ((a_eap.item.cmd))
							l_arg.ce_gets (skip_cmd_arg (l_arg, 0))
							a_eap.item.arg := charset_inst.skipwhite (l_arg)
							l_arg.item := (('%/0/').code).to_natural_8
							if (l_pp.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [INTEGER_32]}.make_shared (a_eap.c_pointer + {PD_EXARG}.force_ff_offset)).c_pointer.to_integer_32).to_natural_32 then
								if (option_inst.check_ff_value (a_eap.item.cmd + a_eap.item.force_ff)) = 0 then
									Result := 0
									js.return
								end
							elseif (l_pp.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [INTEGER_32]}.make_shared (a_eap.c_pointer + {PD_EXARG}.force_enc_offset)).c_pointer.to_integer_32).to_natural_32 then
								l_p___0.ce_gets (a_eap.item.cmd + a_eap.item.force_enc)
								from
								until
									(l_p___0.item).to_integer_32 = 0
								loop
									if (l_p___0.item).to_integer_32 < 65 then
										l_p___0.item := l_p___0.item
									elseif (l_p___0.item).to_integer_32 > 90 then
										l_p___0.item := l_p___0.item
									else
										l_p___0.item := ((l_p___0.item).to_integer_32 + 32).to_natural_8
									end
									l_p___0.ce_gets (l_p___0 + 1)
								end
							else
								l_p___0.ce_gets (a_eap.item.cmd + l_bad_char_idx)
								if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("keep"))) = 0 then
									a_eap.item.bad_char := -1
								elseif (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("drop"))) = 0 then
									a_eap.item.bad_char := -2
								elseif (globals_inst.mb_bytelen_tab[(l_p___0.item).to_integer_32]).to_integer_32 = 1 then
									if (l_p___0[1]).to_integer_32 = 0 then
										a_eap.item.bad_char := (l_p___0.item).to_integer_32
									else
										Result := 0
										js.return
									end
								else
									Result := 0
									js.return
								end
							end
						end
						if not js.return_called then
							Result := 1
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_abbreviate (a_eap: CE_POINTER [PD_EXARG])
		do
			do_exmap (a_eap, 1)
		end

	ex_abbreviate_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_abbreviate)
		end

	ex_map (a_eap: CE_POINTER [PD_EXARG])
		do
			if globals_inst.secure.to_boolean then
				globals_inst.secure := 2
				message_inst.msg_outtrans (a_eap.item.cmd).do_nothing
				message_inst.msg_putchar (('%N').code)
			end
			do_exmap (a_eap, 0)
		end

	ex_map_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_map)
		end

	ex_unmap (a_eap: CE_POINTER [PD_EXARG])
		do
			do_exmap (a_eap, 0)
		end

	ex_unmap_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_unmap)
		end

	ex_mapclear (a_eap: CE_POINTER [PD_EXARG])
		do
			getchar_inst.map_clear (a_eap.item.cmd, a_eap.item.arg, a_eap.item.forceit, 0)
		end

	ex_mapclear_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_mapclear)
		end

	ex_abclear (a_eap: CE_POINTER [PD_EXARG])
		do
			getchar_inst.map_clear (a_eap.item.cmd, a_eap.item.arg, 1, 1)
		end

	ex_abclear_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_abclear)
		end

	ex_autocmd (a_eap: CE_POINTER [PD_EXARG])
		do
			if globals_inst.secure.to_boolean then
				globals_inst.secure := 2
				a_eap.item.errmsg := globals_inst.e_curdir
			elseif a_eap.item.cmdidx = 16 then
				fileio_inst.do_autocmd (a_eap.item.arg, a_eap.item.forceit)
			else
				fileio_inst.do_augroup (a_eap.item.arg, a_eap.item.forceit)
			end
		end

	ex_autocmd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_autocmd)
		end

	ex_doautocmd (a_eap: CE_POINTER [PD_EXARG])
		do
			fileio_inst.do_doautocmd (a_eap.item.arg, 1).do_nothing
			buffer_inst.do_modelines (0)
		end

	ex_doautocmd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_doautocmd)
		end

	ex_bunload (a_eap: CE_POINTER [PD_EXARG])
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			if a_eap.item.cmdidx = 23 then
				l_tmp___0 := 3
			else
				if a_eap.item.cmdidx = 41 then
					l_tmp := 4
				else
					l_tmp := 2
				end
				l_tmp___0 := l_tmp
			end
			a_eap.item.errmsg := buffer_inst.do_bufdel (l_tmp___0, a_eap.item.arg, a_eap.item.addr_count, (a_eap.item.line1).to_integer_32, (a_eap.item.line2).to_integer_32, a_eap.item.forceit)
		end

	ex_bunload_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_bunload)
		end

	ex_buffer (a_eap: CE_POINTER [PD_EXARG])
		do
			if ((a_eap.item.arg).item).to_boolean then
				a_eap.item.errmsg := globals_inst.e_trailing
			elseif a_eap.item.addr_count = 0 then
				buffer_inst.goto_buffer (a_eap, 0, 1, 0)
			else
				buffer_inst.goto_buffer (a_eap, 1, 1, (a_eap.item.line2).to_integer_32)
			end
		end

	ex_buffer_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_buffer)
		end

	ex_bmodified (a_eap: CE_POINTER [PD_EXARG])
		do
			buffer_inst.goto_buffer (a_eap, 3, 1, (a_eap.item.line2).to_integer_32)
		end

	ex_bmodified_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_bmodified)
		end

	ex_bnext (a_eap: CE_POINTER [PD_EXARG])
		do
			buffer_inst.goto_buffer (a_eap, 0, 1, (a_eap.item.line2).to_integer_32)
		end

	ex_bnext_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_bnext)
		end

	ex_bprevious (a_eap: CE_POINTER [PD_EXARG])
		do
			buffer_inst.goto_buffer (a_eap, 0, -1, (a_eap.item.line2).to_integer_32)
		end

	ex_bprevious_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_bprevious)
		end

	ex_brewind (a_eap: CE_POINTER [PD_EXARG])
		do
			buffer_inst.goto_buffer (a_eap, 1, 1, 0)
		end

	ex_brewind_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_brewind)
		end

	ex_blast (a_eap: CE_POINTER [PD_EXARG])
		do
			buffer_inst.goto_buffer (a_eap, 2, -1, 0)
		end

	ex_blast_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_blast)
		end

	ends_excmd (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if a_c = 0 then
				l_tmp := 1
			elseif a_c = 124 then
				l_tmp := 1
			elseif a_c = 34 then
				l_tmp := 1
			elseif a_c = 10 then
				l_tmp := 1
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	find_nextcmd (a_p___0: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0.ce_gets (a_p___0)
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_p___0.item).to_integer_32 /= 124 then
					if (l_p___0.item).to_integer_32 = 10 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if (l_p___0.item).to_integer_32 = 0 then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						l_p___0.ce_gets (l_p___0 + 1)
					end
				end
			end
			js.reset
			if not js.return_called then
				Result := (l_p___0 + 1)
			end
		end

	check_nextcmd (a_p___0: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make

			l_p___0.ce_gets (a_p___0)
			l_p___0.ce_gets (charset_inst.skipwhite (l_p___0))
			if (l_p___0.item).to_integer_32 = 124 then
				Result := (l_p___0 + 1)
			elseif (l_p___0.item).to_integer_32 = 10 then
				Result := (l_p___0 + 1)
			else
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	check_more (a_message: INTEGER_32; a_forceit: INTEGER_32): INTEGER_32
		local
			l_n: INTEGER_32
			l_buff: CE_ARRAY [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buff.make (<<1025>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_n := ((globals_inst.curwin.item.w_alist).item.al_ga.ga_len - globals_inst.curwin.item.w_arg_idx) - 1
					if a_forceit.to_boolean then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						if not ((window_inst.only_one_window).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 2 then -- if:
						if not ((globals_inst.curwin.item.w_alist).item.al_ga.ga_len > 1) then
							l_pos := -1 + 14 -- skip if block
						end
				when 3 then -- if:
						if globals_inst.arg_had_last.to_boolean then
							l_pos := -1 + 14 -- skip if block
						end
				when 4 then -- if:
						if not (l_n >= 0) then
							l_pos := -1 + 14 -- skip if block
						end
				when 5 then -- if:
						if quitmore /= 0 then
							l_pos := -1 + 14 -- skip if block
						end
				when 6 then -- if:
						if not (a_message.to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 7 then -- if:
						if not (option_inst.p_confirm.to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else:
						if not ((globals_inst.cmdmod.confirm).to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L:
						if ((globals_inst.curbuf.item.b_fname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if l_n = 1 then
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_buff), (gettext (ce_string ("1 more file to edit.  Quit anyway?")))).do_nothing
							else
								message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buff), (1025).to_natural_32, (gettext (ce_string ("%%d more files to edit.  Quit anyway?"))), l_n]).do_nothing
							end
							if (message_inst.vim_dialog_yesno (4, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_buff, 1)) = 2 then
								Result := 1
								js.return
							end
							if not js.return_called then
								Result := 0
								js.return
							end
						end
				when 12 then -- if done
						if not js.return_called then
							if l_n = 1 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E173: 1 more file to edit"))))).do_nothing
							else
								misc2_inst.emsgn (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E173: %%ld more files to edit")))), l_n.to_integer_32).do_nothing
							end
							quitmore := 2
						end
				when 13 then -- if done
						if not js.return_called then
							Result := 0
							js.return
						end
				when 14 then -- if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 1
						end
				when 15 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	get_command_name (a_xp: CE_POINTER [PD_EXPAND]; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			js: JUMP_STATE
		do
			if a_idx >= 517 then
				Result := (get_user_command_name (a_idx))
				js.return
			end
			if not js.return_called then
				Result := (ex_cmds_inst.cmdnames[a_idx].cmd_name)
			end
		end

	get_command_name_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent get_command_name)
		end

	uc_add_command (a_name___1: CE_POINTER [NATURAL_8]; a_name_len: NATURAL_32; a_rep: CE_POINTER [NATURAL_8]; a_argt: INTEGER_32; a_def: INTEGER_32; a_flags___0: INTEGER_32; a_compl: INTEGER_32; a_compl_arg: CE_POINTER [NATURAL_8]; a_force: INTEGER_32): INTEGER_32
		local
			l_cmd: CE_POINTER [PD_UCMD]
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_cmp: INTEGER_32
			l_rep_buf: CE_POINTER [NATURAL_8]
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_len: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_cmd.make
			create l_p___0.make
			create l_rep_buf.make
			create l_gap.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_cmd.ce_gets (create {CE_POINTER [PD_UCMD]}.make_shared (default_pointer))
					l_cmp := 1
					l_rep_buf.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					term_inst.replace_termcodes (a_rep, l_rep_buf.address, 0, 0, 0).do_nothing
					if (l_rep_buf.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_rep_buf.ce_gets (misc2_inst.vim_strsave (a_rep))
						if (l_rep_buf.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							Result := 0
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if ((a_flags___0).bit_and (1)).to_boolean then
							l_gap.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared (globals_inst.curbuf.c_pointer + {PD_FILE_BUFFER}.b_ucmds_offset))
							if l_gap.item.ga_itemsize = 0 then
								misc2_inst.ga_init2 (l_gap, ({PD_UCMD}.sizeof.to_natural_32).to_integer_32, 4)
							end
						else
							l_gap.ce_gets (ucmds.address)
						end
						l_i___0 := 0
				when 2 then -- loop condition:
						if not (not js.loop_left and then (l_i___0 < l_gap.item.ga_len)) then
							l_pos := -1 + 7 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						l_cmd.ce_gets (create {CE_POINTER [PD_UCMD]}.make_cast (l_gap.item.ga_data) + l_i___0)
						l_len := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_cmd.item.uc_name))
						l_cmp := strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), create {CE_POINTER [INTEGER_8]}.make_cast (l_cmd.item.uc_name), a_name_len)
						if l_cmp = 0 then
							if a_name_len < l_len then
								l_cmp := -1
							elseif a_name_len > l_len then
								l_cmp := 1
							end
						end
						if l_cmp /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if not a_force.to_boolean then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E174: Command already exists: add ! to replace it"))))).do_nothing
							l_pos := -1 + 13 -- goto fail
						end
				when 5 then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cmd.item.uc_rep))
						l_cmd.item.uc_rep := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cmd.item.uc_compl_arg))
						l_cmd.item.uc_compl_arg := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						js.break
				when 6 then -- if done
						if not js.loop_jumped and then (l_cmp < 0) then
							js.break
						end
						if not js.loop_jumped then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 7 then -- loop done
						js.reset
						if l_cmp = 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 8 then -- if:
						if (misc2_inst.ga_grow (l_gap, 1)) /= 1 then
							l_pos := -1 + 13 -- goto fail
						end
				when 9 then
						l_p___0.ce_gets (misc2_inst.vim_strnsave (a_name___1, a_name_len.to_integer_32))
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 13 -- goto fail
						end
				when 10 then
						l_cmd.ce_gets (create {CE_POINTER [PD_UCMD]}.make_cast (l_gap.item.ga_data) + l_i___0)
						memmove (create {CE_POINTER [ANY]}.make_cast ((l_cmd + 1)), create {CE_POINTER [ANY]}.make_cast (l_cmd), (l_gap.item.ga_len - l_i___0).to_natural_32 * {PD_UCMD}.sizeof.to_natural_32).do_nothing
						l_gap.item.ga_len := (l_gap.item.ga_len) + 1
						l_cmd.item.uc_name := l_p___0
				when 11 then -- if done
						l_cmd.item.uc_rep := l_rep_buf
						l_cmd.item.uc_argt := a_argt.to_natural_32
						l_cmd.item.uc_def := a_def
						l_cmd.item.uc_compl := a_compl
						l_cmd.item.uc_scriptID := globals_inst.current_SID
						l_cmd.item.uc_compl_arg := a_compl_arg
						Result := 1
						js.return
				when 12 then -- if done
					if js.return_called then
						l_pos := -1 + 14 -- skip if block
					end
				when 13 then -- if: | fail:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_rep_buf))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_compl_arg))
						Result := 0
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	uc_list (a_name___1: CE_POINTER [NATURAL_8]; a_name_len: NATURAL_32)
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_found: INTEGER_32
			l_cmd: CE_POINTER [PD_UCMD]
			l_len: INTEGER_32
			l_a: INTEGER_32
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___17: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_cmd.make
			create l_gap.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_found := 0
					l_gap.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared (globals_inst.curbuf.c_pointer + {PD_FILE_BUFFER}.b_ucmds_offset))
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 14 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_i___0 := 0
				when 3 then -- loop condition:
						if not (not js.loop_left and then (l_i___0 < l_gap.item.ga_len)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 4 then -- loop body:
						js.reset
						l_cmd.ce_gets (create {CE_POINTER [PD_UCMD]}.make_cast (l_gap.item.ga_data) + l_i___0)
						l_a := (l_cmd.item.uc_argt).to_integer_32
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), create {CE_POINTER [INTEGER_8]}.make_cast (l_cmd.item.uc_name), a_name_len)) /= 0 then
							js.continue
						end
						if not js.loop_jumped then
							if not l_found.to_boolean then
								message_inst.msg_puts_title (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%N    Name        Args Range Complete  Definition")))))
							end
							l_found := 1
							message_inst.msg_putchar (('%N').code)
							if globals_inst.got_int.to_boolean then
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 12 -- skip if block
						end
				when 5 then -- if:
						if ((l_a).bit_and (2)).to_boolean then
							l_tmp___1 := ('!').code
						else
							l_tmp___1 := (' ').code
						end
						message_inst.msg_putchar (l_tmp___1)
						if ((l_a).bit_and (512)).to_boolean then
							l_tmp___2 := ('%"').code
						else
							l_tmp___2 := (' ').code
						end
						message_inst.msg_putchar (l_tmp___2)
						if (l_gap.c_pointer.to_integer_32).to_natural_32 /= ((ucmds.address).c_pointer.to_integer_32).to_natural_32 then
							l_tmp___3 := ('b').code
						else
							l_tmp___3 := (' ').code
						end
						message_inst.msg_putchar (l_tmp___3)
						message_inst.msg_putchar ((' ').code)
						message_inst.msg_outtrans_attr (l_cmd.item.uc_name, globals_inst.highlight_attr[2]).do_nothing
						l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_cmd.item.uc_name))).to_integer_32 + 4
						from
						until
							js.loop_left
						loop
							js.reset
							message_inst.msg_putchar ((' ').code)
							l_len := l_len + 1
							if not (l_len < 16) then
								js.break
							end
						end
						js.reset
						l_len := 0
						inspect ((l_a).bit_and (148)).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 6
						when 4 then l_pos := -1 + 7
						when 20 then l_pos := -1 + 8
						when 132 then l_pos := -1 + 9
						when 148 then l_pos := -1 + 10
						else l_pos := -1 + 11
						end
				when 6 then -- switch 1, case 0
						l_tmp___5 := l_len
						l_len := l_len + 1
						globals_inst.IObuff[l_tmp___5] := (('0').code).to_natural_8
						l_pos := -1 + 11 -- switch 1; break
				when 7 then -- switch 1, case 4
						l_tmp___6 := l_len
						l_len := l_len + 1
						globals_inst.IObuff[l_tmp___6] := (('*').code).to_natural_8
						l_pos := -1 + 11 -- switch 1; break
				when 8 then -- switch 1, case 20
						l_tmp___7 := l_len
						l_len := l_len + 1
						globals_inst.IObuff[l_tmp___7] := (('?').code).to_natural_8
						l_pos := -1 + 11 -- switch 1; break
				when 9 then -- switch 1, case 132
						l_tmp___8 := l_len
						l_len := l_len + 1
						globals_inst.IObuff[l_tmp___8] := (('+').code).to_natural_8
						l_pos := -1 + 11 -- switch 1; break
				when 10 then -- switch 1, case 148
						l_tmp___9 := l_len
						l_len := l_len + 1
						globals_inst.IObuff[l_tmp___9] := (('1').code).to_natural_8
						l_pos := -1 + 11 -- switch 1; break
				when 11 then -- switch 1, done:
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp___10 := l_len
							l_len := l_len + 1
							globals_inst.IObuff[l_tmp___10] := ((' ').code).to_natural_8
							if not (l_len < 5) then
								js.break
							end
						end
						js.reset
						if ((l_a).bit_and (1025)).to_boolean then
							if ((l_a).bit_and (1024)).to_boolean then
								sprintf ([(create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff) + l_len), ce_string ("%%ldc"), l_cmd.item.uc_def]).do_nothing
								l_len := l_len + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((globals_inst.IObuff + l_len)))).to_integer_32
							elseif ((l_a).bit_and (32)).to_boolean then
								l_tmp___12 := l_len
								l_len := l_len + 1
								globals_inst.IObuff[l_tmp___12] := (('%%').code).to_natural_8
							elseif l_cmd.item.uc_def >= 0 then
								sprintf ([(create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff) + l_len), ce_string ("%%ld"), l_cmd.item.uc_def]).do_nothing
								l_len := l_len + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((globals_inst.IObuff + l_len)))).to_integer_32
							else
								l_tmp___14 := l_len
								l_len := l_len + 1
								globals_inst.IObuff[l_tmp___14] := (('.').code).to_natural_8
							end
						end
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp___15 := l_len
							l_len := l_len + 1
							globals_inst.IObuff[l_tmp___15] := ((' ').code).to_natural_8
							if not (l_len < 11) then
								js.break
							end
						end
						js.reset
						l_j := 0
						from
						until
							not (not js.loop_left and then (command_complete[l_j].expand /= 0))
						loop
							js.reset
							if command_complete[l_j].expand = l_cmd.item.uc_compl then
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((globals_inst.IObuff + l_len)), command_complete[l_j].name).do_nothing
								l_len := l_len + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((globals_inst.IObuff + l_len)))).to_integer_32
								js.break
							end
							if not js.loop_jumped then
								l_j := l_j + 1
							end
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp___17 := l_len
							l_len := l_len + 1
							globals_inst.IObuff[l_tmp___17] := ((' ').code).to_natural_8
							if not (l_len < 21) then
								js.break
							end
						end
						js.reset
						globals_inst.IObuff[l_len] := (('%/0/').code).to_natural_8
						message_inst.msg_outtrans (globals_inst.IObuff).do_nothing
						message_inst.msg_outtrans_special (l_cmd.item.uc_rep, 0).do_nothing
						if option_inst.p_verbose > 0 then
							eval_inst.last_set_msg (l_cmd.item.uc_scriptID)
						end
						term_inst.out_flush
						ui_inst.ui_breakcheck
						if globals_inst.got_int.to_boolean then
							js.break
						end
				when 12 then -- if done
						if not js.loop_left then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 3 -- back to loop condition
				when 13 then -- loop done
						js.reset
						if (l_gap.c_pointer.to_integer_32).to_natural_32 = ((ucmds.address).c_pointer.to_integer_32).to_natural_32 then
							js.break
						elseif l_i___0 < l_gap.item.ga_len then
							js.break
						end
						if not js.loop_jumped then
							l_gap.ce_gets (ucmds.address)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 14 then -- loop done
					js.reset
					if not l_found.to_boolean then
						message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("No user-defined commands found"))))).do_nothing
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	uc_fun_cmd: CE_POINTER [NATURAL_8]
		local
			l_i___0: INTEGER_32
		do
			l_i___0 := 0
			from
			until
				not ((fcmd[l_i___0]).to_boolean)
			loop
				globals_inst.IObuff[l_i___0] := ((fcmd[l_i___0]).to_integer_32 - 64).to_natural_8
				l_i___0 := l_i___0 + 1
			end
			globals_inst.IObuff[l_i___0] := (0).to_natural_8
			Result := globals_inst.IObuff
		end

	uc_scan_attr (a_attr: CE_POINTER [NATURAL_8]; a_len: NATURAL_32; a_argt: CE_POINTER [INTEGER_32]; a_def: CE_POINTER [INTEGER_32]; a_flags___0: CE_POINTER [INTEGER_32]; a_compl: CE_POINTER [INTEGER_32]; a_compl_arg: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_val___0: CE_POINTER [NATURAL_8]
			l_vallen: NATURAL_32
			l_attrlen: NATURAL_32
			l_ch: NATURAL_8
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_val___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_len = {NATURAL_32} 0 then
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E175: No attribute specified"))))).do_nothing
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 40 -- skip if block
					end
				when 1 then -- if:
						if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_attr), ce_string ("bang"), a_len)) /= 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						a_argt.item := (a_argt.item).bit_or ((2))
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 4 then -- else:
						if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_attr), ce_string ("buffer"), a_len)) /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						a_flags___0.item := (a_flags___0.item).bit_or ((1))
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 7 then -- else:
						if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_attr), ce_string ("register"), a_len)) /= 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						a_argt.item := (a_argt.item).bit_or ((512))
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 10 then -- else:
						if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_attr), ce_string ("bar"), a_len)) /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						a_argt.item := (a_argt.item).bit_or ((256))
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 13 then -- else:
						l_val___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						l_vallen := (0).to_natural_32
						l_attrlen := a_len
						l_i___0 := 0
						from
						until
							not (not js.loop_left and then (l_i___0 < a_len.to_integer_32))
						loop
							js.reset
							if (a_attr[l_i___0]).to_integer_32 = 61 then
								l_val___0.ce_gets (a_attr + (l_i___0 + 1))
								l_vallen := (a_len - l_i___0.to_natural_32) - {NATURAL_32} 1
								l_attrlen := l_i___0.to_natural_32
								js.break
							end
							if not js.loop_jumped then
								l_i___0 := l_i___0 + 1
							end
						end
						js.reset
						if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_attr), ce_string ("nargs"), l_attrlen)) /= 0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						if l_vallen /= {NATURAL_32} 1 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if (l_val___0.item).to_integer_32 /= 48 then
							if (l_val___0.item).to_integer_32 = 49 then
								a_argt.item := (a_argt.item).bit_or ((148))
							elseif (l_val___0.item).to_integer_32 = 42 then
								a_argt.item := (a_argt.item).bit_or ((4))
							elseif (l_val___0.item).to_integer_32 = 63 then
								a_argt.item := (a_argt.item).bit_or ((20))
							elseif (l_val___0.item).to_integer_32 = 43 then
								a_argt.item := (a_argt.item).bit_or ((132))
							else
								l_pos := -1 + 17 -- goto wrong_nargs
							end
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else: | wrong_nargs:
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E176: Invalid number of arguments"))))).do_nothing
						Result := 0
						js.return
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 40
				when 19 then -- else:
						if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_attr), ce_string ("range"), l_attrlen)) /= 0 then
							l_pos := -1 + 33 -- skip if block
						end
				when 20 then -- if:
						a_argt.item := (a_argt.item).bit_or ((1))
						if l_vallen /= {NATURAL_32} 1 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						if (l_val___0.item).to_integer_32 = 37 then
							a_argt.item := (a_argt.item).bit_or ((32))
						else
							l_pos := -1 + 23 -- goto _L___0
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 23 then -- else: | _L___0:
						if (l_val___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 32 -- skip if block
						end
				when 24 then -- if:
						l_p___0.ce_gets (l_val___0)
						if not (a_def.item >= 0) then
							l_pos := -1 + 26 -- skip if block
						end
				when 25 then -- if: | two_count:
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E177: Count cannot be specified twice"))))).do_nothing
						Result := 0
						js.return
				when 26 then -- if done
						if js.return_called then
							l_pos := -1 + 32 -- skip if block
						end
				when 27 then -- if:
						a_def.item := charset_inst.getdigits (l_p___0.address)
						a_argt.item := (a_argt.item).bit_or ((20480))
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = ((l_val___0 + l_vallen.to_integer_32).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						l_pos := -1 + 31 -- goto invalid_count
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 30 then -- else:
						if l_vallen /= {NATURAL_32} 0 then
							l_pos := -1 + 32 -- skip if block
						end
				when 31 then -- if: | invalid_count:
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E178: Invalid default value for count"))))).do_nothing
						Result := 0
						js.return
				when 32 then -- if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 40
				when 33 then -- else:
						if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_attr), ce_string ("count"), l_attrlen)) /= 0 then
							l_pos := -1 + 39 -- skip if block
						end
				when 34 then -- if:
						a_argt.item := (a_argt.item).bit_or ((21505))
						if (l_val___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						l_p___0.ce_gets (l_val___0)
						if a_def.item >= 0 then
							l_pos := -1 + 25 -- goto two_count
						end
				when 36 then
						a_def.item := charset_inst.getdigits (l_p___0.address)
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= ((l_val___0 + l_vallen.to_integer_32).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 31 -- goto invalid_count
						end
				when 37 then
						if a_def.item < 0 then
							a_def.item := 0
						end
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 39 then -- else:
						if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_attr), ce_string ("complete"), l_attrlen)) = 0 then
							if (l_val___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E179: argument required for -complete"))))).do_nothing
								Result := 0
								js.return
							end
							if not js.return_called then
								if (parse_compl_arg (l_val___0, l_vallen.to_integer_32, a_compl, a_argt, a_compl_arg)) = 0 then
									Result := 0
									js.return
								end
							end
						else
							l_ch := a_attr[a_len.to_integer_32]
							a_attr[a_len.to_integer_32] := (('%/0/').code).to_natural_8
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E181: Invalid attribute: %%s")))), a_attr).do_nothing
							a_attr[a_len.to_integer_32] := l_ch
							Result := 0
							js.return
						end
				when 40 then -- if done | if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 1
						end
				when 41 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_command (a_eap: CE_POINTER [PD_EXARG])
		local
			l_name___1: CE_POINTER [NATURAL_8]
			l_end: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_argt: INTEGER_32
			l_def: INTEGER_32
			l_flags___0: INTEGER_32
			l_compl: INTEGER_32
			l_compl_arg: CE_POINTER [NATURAL_8]
			l_has_attr: INTEGER_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_name___1.make
			create l_end.make
			create l_p___0.make
			create l_compl_arg.make
			create l_tmp___4.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_argt := 0
					l_def := -1
					l_flags___0 := 0
					l_compl := 0
					l_compl_arg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_has_attr := ((a_eap.item.arg[0]).to_integer_32 = 45).to_integer
					l_p___0.ce_gets (a_eap.item.arg)
					from
					until
						not (not js.loop_left and then ((l_p___0.item).to_integer_32 = 45))
					loop
						l_p___0.ce_gets (l_p___0 + 1)
						l_end.ce_gets (charset_inst.skiptowhite (l_p___0))
						if (uc_scan_attr (l_p___0, (l_end.distance (l_p___0)).to_natural_32, create {CE_POINTER [INTEGER_32]}.make_shared ($l_argt), create {CE_POINTER [INTEGER_32]}.make_shared ($l_def), create {CE_POINTER [INTEGER_32]}.make_shared ($l_flags___0), create {CE_POINTER [INTEGER_32]}.make_shared ($l_compl), l_compl_arg.address)) = 0 then
							js.return
						end
						if not js.return_called then
							l_p___0.ce_gets (charset_inst.skipwhite (l_end))
						end
					end
					if not js.return_called then
						l_name___1.ce_gets (l_p___0)
						if (l_p___0.item).to_integer_32 < 127 then
							if ((((ctype_b_loc).item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (1024)).to_boolean then
								from
								until
									js.loop_left
								loop
									js.reset
									if (l_p___0.item).to_integer_32 < 127 then
										if not ((((ctype_b_loc).item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_p___0.ce_gets (l_p___0 + 1)
									end
								end
								js.reset
							end
						end
						if not (ends_excmd ((l_p___0.item).to_integer_32)).to_boolean then
							if (l_p___0.item).to_integer_32 /= 32 then
								if (l_p___0.item).to_integer_32 /= 9 then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E182: Invalid command name"))))).do_nothing
									js.return
								end
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						l_end.ce_gets (l_p___0)
						l_p___0.ce_gets (charset_inst.skipwhite (l_end))
						if l_has_attr.to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (ends_excmd ((l_p___0.item).to_integer_32)).to_boolean then
							uc_list (l_name___1, (l_end.distance (l_name___1)).to_natural_32)
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if (l_name___1.item).to_integer_32 < 127 then
							if ((((ctype_b_loc).item[(l_name___1.item).to_integer_32]).to_integer_32).bit_and (256)).to_boolean then
								uc_add_command (l_name___1, (l_end.distance (l_name___1)).to_natural_32, l_p___0, l_argt, l_def, l_flags___0, l_compl, l_compl_arg, a_eap.item.forceit).do_nothing
							else
								l_tmp___4.ce_gets (gettext (ce_string ("E183: User defined commands must start with an uppercase letter")))
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___4)).do_nothing
								js.return
							end
						else
							l_tmp___4.ce_gets (gettext (ce_string ("E183: User defined commands must start with an uppercase letter")))
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___4)).do_nothing
							js.return
						end
				when 5 then -- if done
						if not js.return_called then
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_command_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_command)
		end

	ex_comclear (a_eap: CE_POINTER [PD_EXARG])
		do
			uc_clear (ucmds.address)
			uc_clear (create {CE_POINTER [PD_GROWARRAY]}.make_shared (globals_inst.curbuf.c_pointer + {PD_FILE_BUFFER}.b_ucmds_offset))
		end

	ex_comclear_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_comclear)
		end

	uc_clear (a_gap: CE_POINTER [PD_GROWARRAY])
		local
			l_i___0: INTEGER_32
			l_cmd: CE_POINTER [PD_UCMD]
		do
			create l_cmd.make

			l_i___0 := 0
			from
			until
				not (l_i___0 < a_gap.item.ga_len)
			loop
				l_cmd.ce_gets (create {CE_POINTER [PD_UCMD]}.make_cast (a_gap.item.ga_data) + l_i___0)
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cmd.item.uc_name))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cmd.item.uc_rep))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cmd.item.uc_compl_arg))
				l_i___0 := l_i___0 + 1
			end
			misc2_inst.ga_clear (a_gap)
		end

	ex_delcommand (a_eap: CE_POINTER [PD_EXARG])
		local
			l_i___0: INTEGER_32
			l_cmd: CE_POINTER [PD_UCMD]
			l_cmp: INTEGER_32
			l_gap: CE_POINTER [PD_GROWARRAY]
			js: JUMP_STATE
		do
			create l_cmd.make
			create l_gap.make

			l_i___0 := 0
			l_cmd.ce_gets (create {CE_POINTER [PD_UCMD]}.make_shared (default_pointer))
			l_cmp := -1
			l_gap.ce_gets (create {CE_POINTER [PD_GROWARRAY]}.make_shared (globals_inst.curbuf.c_pointer + {PD_FILE_BUFFER}.b_ucmds_offset))
			from
			until
				js.loop_left
			loop
				js.reset
				l_i___0 := 0
				from
				until
					not (not js.loop_left and then (l_i___0 < l_gap.item.ga_len))
				loop
					js.reset
					l_cmd.ce_gets (create {CE_POINTER [PD_UCMD]}.make_cast (l_gap.item.ga_data) + l_i___0)
					l_cmp := strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg), create {CE_POINTER [INTEGER_8]}.make_cast (l_cmd.item.uc_name))
					if l_cmp <= 0 then
						js.break
					end
					if not js.loop_jumped then
						l_i___0 := l_i___0 + 1
					end
				end
				js.reset
				if (l_gap.c_pointer.to_integer_32).to_natural_32 = ((ucmds.address).c_pointer.to_integer_32).to_natural_32 then
					js.break
				elseif l_cmp = 0 then
					js.break
				end
				if not js.loop_jumped then
					l_gap.ce_gets (ucmds.address)
				end
			end
			js.reset
			if l_cmp /= 0 then
				message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E184: No such user-defined command: %%s")))), a_eap.item.arg).do_nothing
				js.return
			end
			if not js.return_called then
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cmd.item.uc_name))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cmd.item.uc_rep))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cmd.item.uc_compl_arg))
				l_gap.item.ga_len := (l_gap.item.ga_len) - 1
				if l_i___0 < l_gap.item.ga_len then
					memmove (create {CE_POINTER [ANY]}.make_cast (l_cmd), create {CE_POINTER [ANY]}.make_cast ((l_cmd + 1)), (l_gap.item.ga_len - l_i___0).to_natural_32 * {PD_UCMD}.sizeof.to_natural_32).do_nothing
				end
			end
		end

	ex_delcommand_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_delcommand)
		end

	uc_split_args (a_arg: CE_POINTER [NATURAL_8]; a_lenp: CE_POINTER [NATURAL_32]): CE_POINTER [NATURAL_8]
		local
			l_buf___6: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_q: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___11: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___6.make
			create l_p___0.make
			create l_q.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___7.make
			create l_tmp___8.make
			create l_tmp___9.make
			create l_tmp___10.make
			create l_tmp___11.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (a_arg)
					l_len := 2
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_p___0.item).to_boolean)) then
						l_pos := -1 + 22 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if (l_p___0[0]).to_integer_32 /= 92 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (l_p___0[1]).to_integer_32 = 92 then
							l_len := l_len + (2)
							l_p___0.ce_gets (l_p___0 + (2))
						else
							l_pos := -1 + 5 -- goto _L___1
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 5 then -- else: | _L___1:
						if (l_p___0[0]).to_integer_32 /= 92 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (l_p___0[1]).to_integer_32 = 32 then
							l_len := l_len + 1
							l_p___0.ce_gets (l_p___0 + (2))
						elseif (l_p___0[1]).to_integer_32 = 9 then
							l_len := l_len + 1
							l_p___0.ce_gets (l_p___0 + (2))
						else
							l_pos := -1 + 8 -- goto _L___0
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 8 then -- else: | _L___0:
						if (l_p___0.item).to_integer_32 /= 92 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_len := l_len + (2)
						l_p___0.ce_gets (l_p___0 + 1)
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 11 then -- else:
						if (l_p___0.item).to_integer_32 /= 34 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_len := l_len + (2)
						l_p___0.ce_gets (l_p___0 + 1)
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 14 then -- else:
						if (l_p___0.item).to_integer_32 /= 32 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 18 -- goto _L
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 17 then -- else:
						if (l_p___0.item).to_integer_32 /= 9 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if: | _L:
						l_p___0.ce_gets (charset_inst.skipwhite (l_p___0))
						if (l_p___0.item).to_integer_32 = 0 then
							js.break
						end
						if not js.loop_jumped then
							l_len := l_len + (3)
						end
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						l_len := l_len + 1
						l_p___0.ce_gets (l_p___0 + 1)
				when 21 then -- if done | if done | if done | if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 22 then -- loop done
					js.reset
					l_buf___6.ce_gets (misc2_inst.alloc ((l_len + 1).to_natural_32))
					if (l_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						a_lenp.item := (0).to_natural_32
						Result := l_buf___6
						js.return
					end
					if js.return_called then
						l_pos := -1 + 46 -- skip if block
					end
				when 23 then -- if:
						l_p___0.ce_gets (a_arg)
						l_q.ce_gets (l_buf___6)
						l_tmp.ce_gets (l_q)
						l_q.ce_gets (l_q + 1)
						l_tmp.item := (('%"').code).to_natural_8
				when 24 then -- loop condition:
						if not (not js.loop_left and then ((l_p___0.item).to_boolean)) then
							l_pos := -1 + 45 -- skip loop
						end
				when 25 then -- loop body:
						js.reset
						if (l_p___0[0]).to_integer_32 /= 92 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						if (l_p___0[1]).to_integer_32 = 92 then
							l_tmp___0.ce_gets (l_q)
							l_q.ce_gets (l_q + 1)
							l_tmp___0.item := (('\').code).to_natural_8
							l_tmp___1.ce_gets (l_q)
							l_q.ce_gets (l_q + 1)
							l_tmp___1.item := (('\').code).to_natural_8
							l_p___0.ce_gets (l_p___0 + (2))
						else
							l_pos := -1 + 28 -- goto _L___5
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 28 then -- else: | _L___5:
						if (l_p___0[0]).to_integer_32 /= 92 then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						if (l_p___0[1]).to_integer_32 = 32 then
							l_tmp___2.ce_gets (l_q)
							l_q.ce_gets (l_q + 1)
							l_tmp___2.item := l_p___0[1]
							l_p___0.ce_gets (l_p___0 + (2))
						elseif (l_p___0[1]).to_integer_32 = 9 then
							l_tmp___2.ce_gets (l_q)
							l_q.ce_gets (l_q + 1)
							l_tmp___2.item := l_p___0[1]
							l_p___0.ce_gets (l_p___0 + (2))
						else
							l_pos := -1 + 31 -- goto _L___4
						end
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 31 then -- else: | _L___4:
						if (l_p___0.item).to_integer_32 /= 92 then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						l_pos := -1 + 35 -- goto _L___3
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 34 then -- else:
						if (l_p___0.item).to_integer_32 /= 34 then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if: | _L___3:
						l_tmp___3.ce_gets (l_q)
						l_q.ce_gets (l_q + 1)
						l_tmp___3.item := (('\').code).to_natural_8
						l_tmp___4.ce_gets (l_q)
						l_q.ce_gets (l_q + 1)
						l_tmp___5.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___4.item := l_tmp___5.item
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 37 then -- else:
						if (l_p___0.item).to_integer_32 /= 32 then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						l_pos := -1 + 41 -- goto _L___2
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 40 then -- else:
						if (l_p___0.item).to_integer_32 /= 9 then
							l_pos := -1 + 43 -- skip if block
						end
				when 41 then -- if: | _L___2:
						l_p___0.ce_gets (charset_inst.skipwhite (l_p___0))
						if (l_p___0.item).to_integer_32 = 0 then
							js.break
						end
						if not js.loop_jumped then
							l_tmp___6.ce_gets (l_q)
							l_q.ce_gets (l_q + 1)
							l_tmp___6.item := (('%"').code).to_natural_8
							l_tmp___7.ce_gets (l_q)
							l_q.ce_gets (l_q + 1)
							l_tmp___7.item := ((',').code).to_natural_8
							l_tmp___8.ce_gets (l_q)
							l_q.ce_gets (l_q + 1)
							l_tmp___8.item := (('%"').code).to_natural_8
						end
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 43 then -- else:
						l_tmp___9.ce_gets (l_q)
						l_q.ce_gets (l_q + 1)
						l_tmp___10.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___9.item := l_tmp___10.item
				when 44 then -- if done | if done | if done | if done | if done
						l_pos := -1 + 24 -- back to loop condition
				when 45 then -- loop done
						js.reset
						l_tmp___11.ce_gets (l_q)
						l_q.ce_gets (l_q + 1)
						l_tmp___11.item := (('%"').code).to_natural_8
						l_q.item := (0).to_natural_8
						a_lenp.item := l_len.to_natural_32
						Result := l_buf___6
				when 46 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	uc_check_code (a_code: CE_POINTER [NATURAL_8]; a_len: NATURAL_32; a_buf___6: CE_POINTER [NATURAL_8]; a_cmd: CE_POINTER [PD_UCMD]; a_eap: CE_POINTER [PD_EXARG]; a_split_buf: CE_POINTER [CE_POINTER [NATURAL_8]]; a_split_len: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_buf___6: CE_POINTER [NATURAL_8]
			l_result___2: NATURAL_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_l: NATURAL_32
			l_quote: INTEGER_32
			l_type: INTEGER_32
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___11: CE_POINTER [NATURAL_8]
			l_tmp___12: CE_POINTER [NATURAL_8]
			l_tmp___13: CE_POINTER [NATURAL_8]
			l_num_buf: CE_ARRAY [INTEGER_8]
			l_num: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_num_len: NATURAL_32
			l_tmp___17: CE_POINTER [NATURAL_8]
			l_tmp___18: CE_POINTER [NATURAL_8]
			l_tmp___19: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_buf___6.make
			create l_p___0.make
			create l_tmp___9.make
			create l_tmp___10.make
			create l_tmp___11.make
			create l_tmp___12.make
			create l_tmp___13.make
			create l_num_buf.make (<<20>>)
			create l_tmp___17.make
			create l_tmp___18.make
			create l_tmp___19.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buf___6.ce_gets (a_buf___6)
					l_result___2 := (0).to_natural_32
					l_p___0.ce_gets (a_code + 1)
					l_l := a_len - {NATURAL_32} 2
					l_quote := 0
					l_type := {PC_TYPE2}.ct_NONE
					if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("qQfF")), (l_p___0.item).to_integer_32)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						if (l_p___0[1]).to_integer_32 = 45 then
							if (l_p___0.item).to_integer_32 = 113 then
								l_quote := 1
							elseif (l_p___0.item).to_integer_32 = 81 then
								l_quote := 1
							else
								l_quote := 2
							end
							l_p___0.ce_gets (l_p___0 + (2))
							l_l := l_l - ({NATURAL_32} 2)
						end
					end
					l_l := l_l + 1
					if l_l <= {NATURAL_32} 1 then
						l_type := {PC_TYPE2}.ct_NONE
					elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("args>"), l_l)) = 0 then
						l_type := {PC_TYPE2}.ct_ARGS
					elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("bang>"), l_l)) = 0 then
						l_type := {PC_TYPE2}.ct_BANG
					elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("count>"), l_l)) = 0 then
						l_type := {PC_TYPE2}.ct_COUNT
					elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("line1>"), l_l)) = 0 then
						l_type := {PC_TYPE2}.ct_LINE1
					elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("line2>"), l_l)) = 0 then
						l_type := {PC_TYPE2}.ct_LINE2
					elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("lt>"), l_l)) = 0 then
						l_type := {PC_TYPE2}.ct_LT
					elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("reg>"), l_l)) = 0 then
						l_type := {PC_TYPE2}.ct_REGISTER
					elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("register>"), l_l)) = 0 then
						l_type := {PC_TYPE2}.ct_REGISTER
					end
					inspect l_type -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 7
					when 3 then l_pos := -1 + 8
					when 4 then l_pos := -1 + 8
					when 2 then l_pos := -1 + 8
					when 5 then l_pos := -1 + 9
					when 6 then l_pos := -1 + 10
					else l_pos := -1 + 11
					end
				when 1 then -- switch 1, case 0
					if ((a_eap.item.arg).item).to_integer_32 = 0 then
						if l_quote = 1 then
							l_result___2 := (2).to_natural_32
							if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("%'%'")).do_nothing
							end
						else
							l_result___2 := (0).to_natural_32
						end
						l_pos := -1 + 12 -- switch 1; break
					end
				when 2 then
					if ((a_eap.item.argt).bit_and (16)).to_boolean then
						if l_quote = 2 then
							l_quote := 1
						end
					end
					inspect l_quote -- switch 2 head
					when 0 then l_pos := -1 + 3
					when 1 then l_pos := -1 + 4
					when 2 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 3 then -- switch 2, case 0
					l_result___2 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg))
					if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg)).do_nothing
					end
					l_pos := -1 + 6 -- switch 2; break
				when 4 then -- switch 2, case 1
					l_result___2 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg))) + {NATURAL_32} 2
					l_p___0.ce_gets (a_eap.item.arg)
					from
					until
						not ((l_p___0.item).to_boolean)
					loop
						if (l_p___0.item).to_integer_32 = 92 then
							l_result___2 := l_result___2 + 1
						elseif (l_p___0.item).to_integer_32 = 34 then
							l_result___2 := l_result___2 + 1
						end
						l_p___0.ce_gets (l_p___0 + 1)
					end
					if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_tmp___9.ce_gets (l_buf___6)
						l_buf___6.ce_gets (l_buf___6 + 1)
						l_tmp___9.item := (('%"').code).to_natural_8
						l_p___0.ce_gets (a_eap.item.arg)
						from
						until
							not ((l_p___0.item).to_boolean)
						loop
							if (l_p___0.item).to_integer_32 = 92 then
								l_tmp___10.ce_gets (l_buf___6)
								l_buf___6.ce_gets (l_buf___6 + 1)
								l_tmp___10.item := (('\').code).to_natural_8
							elseif (l_p___0.item).to_integer_32 = 34 then
								l_tmp___10.ce_gets (l_buf___6)
								l_buf___6.ce_gets (l_buf___6 + 1)
								l_tmp___10.item := (('\').code).to_natural_8
							end
							l_tmp___11.ce_gets (l_buf___6)
							l_buf___6.ce_gets (l_buf___6 + 1)
							l_tmp___11.item := l_p___0.item
							l_p___0.ce_gets (l_p___0 + 1)
						end
						l_buf___6.item := (('%"').code).to_natural_8
					end
					l_pos := -1 + 6 -- switch 2; break
				when 5 then -- switch 2, case 2
					if ((a_split_buf.item).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						a_split_buf.item := uc_split_args (a_eap.item.arg, a_split_len)
					end
					l_result___2 := a_split_len.item
					if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						if l_result___2 /= {NATURAL_32} 0 then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), create {CE_POINTER [INTEGER_8]}.make_cast (a_split_buf.item)).do_nothing
						end
					end
					l_pos := -1 + 6 -- switch 2; break
				when 6 then -- switch 2, done:
					l_pos := -1 + 12 -- switch 1; break
				when 7 then -- switch 1, case 1
					if (a_eap.item.forceit).to_boolean then
						l_result___2 := (1).to_natural_32
					else
						l_result___2 := (0).to_natural_32
					end
					if l_quote.to_boolean then
						l_result___2 := l_result___2 + ({NATURAL_32} 2)
					end
					if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						if l_quote.to_boolean then
							l_tmp___12.ce_gets (l_buf___6)
							l_buf___6.ce_gets (l_buf___6 + 1)
							l_tmp___12.item := (('%"').code).to_natural_8
						end
						if (a_eap.item.forceit).to_boolean then
							l_tmp___13.ce_gets (l_buf___6)
							l_buf___6.ce_gets (l_buf___6 + 1)
							l_tmp___13.item := (('!').code).to_natural_8
						end
						if l_quote.to_boolean then
							l_buf___6.item := (('%"').code).to_natural_8
						end
					end
					l_pos := -1 + 12 -- switch 1; break
				when 8 then -- switch 1, case 3 | switch 1, case 4 | switch 1, case 2
					if l_type.to_natural_32 = {NATURAL_32} 3 then
						l_tmp___16 := a_eap.item.line1
					else
						if l_type.to_natural_32 = {NATURAL_32} 4 then
							l_tmp___15 := a_eap.item.line2
						else
							if a_eap.item.addr_count > 0 then
								l_tmp___14 := a_eap.item.line2
							else
								l_tmp___14 := a_cmd.item.uc_def
							end
							l_tmp___15 := l_tmp___14
						end
						l_tmp___16 := l_tmp___15
					end
					l_num := l_tmp___16
					sprintf ([l_num_buf, ce_string ("%%ld"), l_num]).do_nothing
					l_num_len := strlen (l_num_buf)
					l_result___2 := l_num_len
					if l_quote.to_boolean then
						l_result___2 := l_result___2 + ({NATURAL_32} 2)
					end
					if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						if l_quote.to_boolean then
							l_tmp___17.ce_gets (l_buf___6)
							l_buf___6.ce_gets (l_buf___6 + 1)
							l_tmp___17.item := (('%"').code).to_natural_8
						end
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), l_num_buf).do_nothing
						l_buf___6.ce_gets (l_buf___6 + l_num_len.to_integer_32)
						if l_quote.to_boolean then
							l_buf___6.item := (('%"').code).to_natural_8
						end
					end
					l_pos := -1 + 12 -- switch 1; break
				when 9 then -- switch 1, case 5
					if (a_eap.item.regname).to_boolean then
						l_result___2 := (1).to_natural_32
					else
						l_result___2 := (0).to_natural_32
					end
					if l_quote.to_boolean then
						l_result___2 := l_result___2 + ({NATURAL_32} 2)
					end
					if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						if l_quote.to_boolean then
							l_tmp___18.ce_gets (l_buf___6)
							l_buf___6.ce_gets (l_buf___6 + 1)
							l_tmp___18.item := (('%'').code).to_natural_8
						end
						if (a_eap.item.regname).to_boolean then
							l_tmp___19.ce_gets (l_buf___6)
							l_buf___6.ce_gets (l_buf___6 + 1)
							l_tmp___19.item := (a_eap.item.regname).to_natural_8
						end
						if l_quote.to_boolean then
							l_buf___6.item := (('%'').code).to_natural_8
						end
					end
					l_pos := -1 + 12 -- switch 1; break
				when 10 then -- switch 1, case 6
					l_result___2 := (1).to_natural_32
					if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_buf___6.item := (('<').code).to_natural_8
					end
					l_pos := -1 + 12 -- switch 1; break
				when 11 then -- switch 1, default:
					l_result___2 := (-1).to_natural_32
					if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_buf___6.item := (('<').code).to_natural_8
					end
					l_pos := -1 + 12 -- switch 1; break
				when 12 then -- switch 1, done:
					Result := l_result___2
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_ucmd (a_eap: CE_POINTER [PD_EXARG])
		local
			l_buf___6: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_q: CE_POINTER [NATURAL_8]
			l_start___1: CE_POINTER [NATURAL_8]
			l_end: CE_POINTER [NATURAL_8]
			l_ksp: CE_POINTER [NATURAL_8]
			l_len: NATURAL_32
			l_totlen: NATURAL_32
			l_split_len: NATURAL_32
			l_split_buf: CE_POINTER [NATURAL_8]
			l_cmd: CE_POINTER [PD_UCMD]
			l_save_current_SID: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___6.make
			create l_p___0.make
			create l_q.make
			create l_start___1.make
			create l_end.make
			create l_ksp.make
			create l_split_buf.make
			create l_cmd.make
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_end.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_split_len := (0).to_natural_32
					l_split_buf.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_save_current_SID := globals_inst.current_SID
					if a_eap.item.cmdidx = -1 then
						l_cmd.ce_gets (create {CE_POINTER [PD_UCMD]}.make_cast (ucmds.ga_data) + a_eap.item.useridx)
					else
						l_cmd.ce_gets (create {CE_POINTER [PD_UCMD]}.make_cast (globals_inst.curbuf.item.b_ucmds.ga_data) + a_eap.item.useridx)
					end
					l_buf___6.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 21 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_p___0.ce_gets (l_cmd.item.uc_rep)
						l_q.ce_gets (l_buf___6)
						l_totlen := (0).to_natural_32
				when 3 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 20 -- skip loop
						end
				when 4 then -- loop body:
						js.reset
						l_start___1.ce_gets (misc2_inst.vim_strchr (l_p___0, ('<').code))
						if (l_start___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_end.ce_gets (misc2_inst.vim_strchr (l_start___1 + 1, ('>').code))
						end
						if (l_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 19 -- skip if block
						end
				when 5 then -- if:
						l_ksp.ce_gets (misc2_inst.vim_strchr (l_p___0, 128))
						if (l_ksp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 19 -- skip if block
						end
				when 6 then -- if:
						if (l_start___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 13 -- goto _L___1
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 9 then -- else:
						if not ((l_ksp.c_pointer.to_integer_32).to_natural_32 < (l_start___1.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L___1
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 12 then -- else:
						if (l_end.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 19 -- skip if block
						end
				when 13 then -- if: | _L___1:
						if (l_ksp[1]).to_integer_32 /= 254 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if (l_ksp[2]).to_integer_32 = 88 then
							l_pos := -1 + 18 -- goto _L
						else
							l_pos := -1 + 16 -- goto _L___0
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 16 then -- else: | _L___0:
						if (l_ksp[1]).to_integer_32 /= 253 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if (l_ksp[2]).to_integer_32 /= 81 then
							l_pos := -1 + 19 -- skip if block
						end
				when 18 then -- if: | _L:
						l_len := (l_ksp.distance (l_p___0)).to_natural_32
						if l_len > {NATURAL_32} 0 then
							memmove (create {CE_POINTER [ANY]}.make_cast (l_q), create {CE_POINTER [ANY]}.make_cast (l_p___0), l_len).do_nothing
							l_q.ce_gets (l_q + l_len.to_integer_32)
						end
						l_tmp.ce_gets (l_q)
						l_q.ce_gets (l_q + 1)
						if (l_ksp[1]).to_integer_32 = 254 then
							l_tmp.item := (128).to_natural_8
						else
							l_tmp.item := (155).to_natural_8
						end
						l_p___0.ce_gets (l_ksp + 3)
						js.continue
				when 19 then -- if done | if done | if done | if done | if done | if done | if done
						if not js.loop_jumped then
							if (l_start___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.break
							elseif (l_end.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.break
							end
						end
						if not js.loop_jumped then
							l_end.ce_gets (l_end + 1)
							l_len := (l_start___1.distance (l_p___0)).to_natural_32
							if (l_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_totlen := l_totlen + l_len
							else
								memmove (create {CE_POINTER [ANY]}.make_cast (l_q), create {CE_POINTER [ANY]}.make_cast (l_p___0), l_len).do_nothing
								l_q.ce_gets (l_q + l_len.to_integer_32)
							end
							l_len := uc_check_code (l_start___1, (l_end.distance (l_start___1)).to_natural_32, l_q, l_cmd, a_eap, l_split_buf.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_split_len))
							if l_len = {NATURAL_32} 4294967295 then
								l_p___0.ce_gets (l_start___1 + 1)
								l_len := (1).to_natural_32
							else
								l_p___0.ce_gets (l_end)
							end
							if (l_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_totlen := l_totlen + l_len
							else
								l_q.ce_gets (l_q + l_len.to_integer_32)
							end
						end
						if not js.loop_left then
							
						end
						l_pos := -1 + 3 -- back to loop condition
				when 20 then -- loop done
						js.reset
						if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_q), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0)).do_nothing
							js.break
						end
						if not js.loop_jumped then
							l_totlen := l_totlen + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0)))
							l_buf___6.ce_gets (misc2_inst.alloc (l_totlen + {NATURAL_32} 1))
							if (l_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_split_buf))
								js.return
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 21 then -- loop done
					js.reset
					if not js.return_called then
						globals_inst.current_SID := l_cmd.item.uc_scriptID
						do_cmdline (l_buf___6, a_eap.item.getline, a_eap.item.cookie, 11).do_nothing
						globals_inst.current_SID := l_save_current_SID
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_split_buf))
					end
				when 22 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_user_command_name (a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		do
			Result := (get_user_commands (create {CE_POINTER [PD_EXPAND]}.make_shared (default_pointer), a_idx - 517))
		end

	get_user_commands (a_xp: CE_POINTER [PD_EXPAND]; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_idx: INTEGER_32
			js: JUMP_STATE
		do
			l_idx := a_idx
			if l_idx < globals_inst.curbuf.item.b_ucmds.ga_len then
				Result := ((create {CE_POINTER [PD_UCMD]}.make_cast (globals_inst.curbuf.item.b_ucmds.ga_data) + l_idx).item.uc_name)
				js.return
			end
			if not js.return_called then
				l_idx := l_idx - (globals_inst.curbuf.item.b_ucmds.ga_len)
				if l_idx < ucmds.ga_len then
					Result := ((create {CE_POINTER [PD_UCMD]}.make_cast (ucmds.ga_data) + l_idx).item.uc_name)
					js.return
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	get_user_commands_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent get_user_commands)
		end

	get_user_cmd_flags (a_xp: CE_POINTER [PD_EXPAND]; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			js: JUMP_STATE
		do
			if a_idx >= ((Pointer_bytes.to_natural_32 * (8).to_natural_32) // Pointer_bytes.to_natural_32).to_integer_32 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (user_cmd_flags[a_idx]))
			end
		end

	get_user_cmd_flags_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent get_user_cmd_flags)
		end

	get_user_cmd_nargs (a_xp: CE_POINTER [PD_EXPAND]; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			js: JUMP_STATE
		do
			if a_idx >= ((Pointer_bytes.to_natural_32 * (5).to_natural_32) // Pointer_bytes.to_natural_32).to_integer_32 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (user_cmd_nargs[a_idx]))
			end
		end

	get_user_cmd_nargs_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent get_user_cmd_nargs)
		end

	get_user_cmd_complete (a_xp: CE_POINTER [PD_EXPAND]; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		do
			Result := (create {CE_POINTER [NATURAL_8]}.make_cast (command_complete[a_idx].name))
		end

	get_user_cmd_complete_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent get_user_cmd_complete)
		end

	parse_compl_arg (a_value: CE_POINTER [NATURAL_8]; a_vallen: INTEGER_32; a_complp: CE_POINTER [INTEGER_32]; a_argt: CE_POINTER [INTEGER_32]; a_compl_arg: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_arg: CE_POINTER [NATURAL_8]
			l_arglen: NATURAL_32
			l_i___0: INTEGER_32
			l_valend: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_arg.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_arg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_arglen := (0).to_natural_32
					l_valend := a_vallen
					l_i___0 := 0
					from
					until
						not (not js.loop_left and then (l_i___0 < a_vallen))
					loop
						js.reset
						if (a_value[l_i___0]).to_integer_32 = 44 then
							l_arg.ce_gets (a_value + (l_i___0 + 1))
							l_arglen := ((a_vallen - l_i___0) - 1).to_natural_32
							l_valend := l_i___0
							js.break
						end
						if not js.loop_jumped then
							l_i___0 := l_i___0 + 1
						end
					end
					js.reset
					l_i___0 := 0
					from
					until
						not (not js.loop_left and then (command_complete[l_i___0].expand /= 0))
					loop
						js.reset
						if (strlen (command_complete[l_i___0].name)).to_integer_32 = l_valend then
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_value), command_complete[l_i___0].name, l_valend.to_natural_32)) = 0 then
								a_complp.item := command_complete[l_i___0].expand
								if command_complete[l_i___0].expand = 9 then
									a_argt.item := (a_argt.item).bit_or ((65536))
								elseif command_complete[l_i___0].expand = 3 then
									a_argt.item := (a_argt.item).bit_or ((8))
								elseif command_complete[l_i___0].expand = 2 then
									a_argt.item := (a_argt.item).bit_or ((8))
								end
								js.break
							end
						end
						if not js.loop_jumped then
							l_i___0 := l_i___0 + 1
						end
					end
					js.reset
					if command_complete[l_i___0].expand = 0 then
						message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E180: Invalid complete value: %%s")))), a_value).do_nothing
						Result := 0
						js.return
					end
					if not js.return_called and then (a_complp.item /= 30) then
						if a_complp.item /= 31 then
							if (l_arg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E468: Completion argument only allowed for custom completion"))))).do_nothing
								Result := 0
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if a_complp.item /= 30 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if a_complp.item /= 31 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if (l_arg.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E467: Custom completion requires a function argument"))))).do_nothing
							Result := 0
							js.return
						end
				when 6 then -- if done | if done
						if not js.return_called then
							if (l_arg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								a_compl_arg.item := misc2_inst.vim_strnsave (l_arg, l_arglen.to_integer_32)
							end
							Result := 1
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_colorscheme (a_eap: CE_POINTER [PD_EXARG])
		local
			l_expr: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_expr.make
			create l_p___0.make

			if ((a_eap.item.arg).item).to_integer_32 = 0 then
				l_expr.ce_gets ((misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("g:colors_name")))))
				l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				if (l_expr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					globals_inst.emsg_off := globals_inst.emsg_off + 1
					l_p___0.ce_gets (eval_inst.eval_to_string (l_expr, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), 0))
					globals_inst.emsg_off := globals_inst.emsg_off - 1
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_expr))
				end
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					message_inst.msg (l_p___0).do_nothing
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
				else
					message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("default"))).do_nothing
				end
			elseif (syntax_inst.load_colors (a_eap.item.arg)) = 0 then
				message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E185: Cannot find color scheme %%s")))), a_eap.item.arg).do_nothing
			end
		end

	ex_colorscheme_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_colorscheme)
		end

	ex_highlight (a_eap: CE_POINTER [PD_EXARG])
		do
			if ((a_eap.item.arg).item).to_integer_32 = 0 then
				if (a_eap.item.cmd[2]).to_integer_32 = 33 then
					message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Greetings, Vim user!"))))).do_nothing
				end
			end
			syntax_inst.do_highlight (a_eap.item.arg, a_eap.item.forceit, 0)
		end

	ex_highlight_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_highlight)
		end

	not_exiting
		do
			globals_inst.exiting := 0
			term_inst.settmode (2)
		end

	ex_quit (a_eap: CE_POINTER [PD_EXARG])
		local
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if globals_inst.cmdwin_type /= 0 then
						globals_inst.cmdwin_result := 3
						js.return
					end
					if not js.return_called then
						if (ex_getln_inst.text_locked).to_boolean then
							ex_getln_inst.text_locked_msg
							js.return
						end
					end
					if not js.return_called then
						if (ex_getln_inst.curbuf_locked).to_boolean then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						globals_inst.netbeansForcedQuit := a_eap.item.forceit
						if (check_more (0, a_eap.item.forceit)) = 1 then
							if (window_inst.only_one_window).to_boolean then
								globals_inst.exiting := 1
							end
						end
						if not ((quickfix_inst.buf_hide (globals_inst.curbuf)).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if: | _L___0:
						if (check_more (1, a_eap.item.forceit)) /= 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						not_exiting
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else:
						if not ((window_inst.only_one_window).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (ex_cmds2_inst.check_changed_any (a_eap.item.forceit)).to_boolean then
							not_exiting
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if (window_inst.only_one_window).to_boolean then
							main_inst.getout (0)
						end
						globals_inst.need_mouse_correct := 1
						if (quickfix_inst.buf_hide (globals_inst.curwin.item.w_buffer)).to_boolean then
							if (a_eap.item.forceit).to_boolean then
								l_tmp___5 := 1
							else
								l_tmp___5 := 0
							end
						else
							l_tmp___5 := 1
						end
						window_inst.win_close (globals_inst.curwin, l_tmp___5)
				when 9 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						if (ex_cmds2_inst.check_changed (globals_inst.curbuf, option_inst.p_awa, 0, a_eap.item.forceit, 0)).to_boolean then
							not_exiting
						else
							l_pos := -1 + 2 -- goto _L___0
						end
				when 11 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_quit_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_quit)
		end

	ex_cquit (a_eap: CE_POINTER [PD_EXARG])
		do
			main_inst.getout (1)
		end

	ex_cquit_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_cquit)
		end

	ex_quit_all (a_eap: CE_POINTER [PD_EXARG])
		local
			js: JUMP_STATE
		do
			if globals_inst.cmdwin_type /= 0 then
				if (a_eap.item.forceit).to_boolean then
					globals_inst.cmdwin_result := -(253 + ((57).bit_shift_left (8)))
				else
					globals_inst.cmdwin_result := -(253 + ((58).bit_shift_left (8)))
				end
				js.return
			end
			if not js.return_called then
				if (ex_getln_inst.text_locked).to_boolean then
					ex_getln_inst.text_locked_msg
					js.return
				end
			end
			if not js.return_called then
				if (ex_getln_inst.curbuf_locked).to_boolean then
					js.return
				end
			end
			if not js.return_called then
				globals_inst.exiting := 1
				if (a_eap.item.forceit).to_boolean then
					main_inst.getout (0)
				elseif not (ex_cmds2_inst.check_changed_any (0)).to_boolean then
					main_inst.getout (0)
				end
				not_exiting
			end
		end

	ex_quit_all_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_quit_all)
		end

	ex_close (a_eap: CE_POINTER [PD_EXARG])
		do
			if globals_inst.cmdwin_type /= 0 then
				globals_inst.cmdwin_result := -(253 + ((53).bit_shift_left (8)))
			elseif not (ex_getln_inst.text_locked).to_boolean then
				if not (ex_getln_inst.curbuf_locked).to_boolean then
					ex_win_close (a_eap.item.forceit, globals_inst.curwin, create {CE_POINTER [PD_TABPAGE_S]}.make_shared (default_pointer))
				end
			end
		end

	ex_close_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_close)
		end

	ex_pclose (a_eap: CE_POINTER [PD_EXARG])
		local
			l_win: CE_POINTER [PD_WINDOW_S]
			js: JUMP_STATE
		do
			create l_win.make

			l_win.ce_gets (globals_inst.firstwin)
			from
			until
				not (not js.loop_left and then ((l_win.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				js.reset
				if (l_win.item.w_onebuf_opt.wo_pvw).to_boolean then
					ex_win_close (a_eap.item.forceit, l_win, create {CE_POINTER [PD_TABPAGE_S]}.make_shared (default_pointer))
					js.break
				end
				if not js.loop_jumped then
					l_win.ce_gets (l_win.item.w_next)
				end
			end
			js.reset
		end

	ex_pclose_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_pclose)
		end

	ex_win_close (a_forceit: INTEGER_32; a_win: CE_POINTER [PD_WINDOW_S]; a_tp: CE_POINTER [PD_TABPAGE_S])
		local
			l_need_hide: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_tmp___0: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___6: INTEGER_32
			l_tmp___8: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___6.make
			create l_tmp___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buf___6.ce_gets (a_win.item.w_buffer)
					if (undo_inst.bufIsChanged (l_buf___6)).to_boolean then
						if l_buf___6.item.b_nwindows <= 1 then
							l_tmp___0 := 1
						else
							l_tmp___0 := 0
						end
					else
						l_tmp___0 := 0
					end
					l_need_hide := l_tmp___0
					if not (l_need_hide.to_boolean) then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						if (quickfix_inst.buf_hide (l_buf___6)).to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						if a_forceit.to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if:
						if not (option_inst.p_confirm.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not ((globals_inst.cmdmod.confirm).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						if option_inst.p_write.to_boolean then
							ex_cmds2_inst.dialog_changed (l_buf___6, 0)
							if (buffer_inst.buf_valid (l_buf___6)).to_boolean then
								if (undo_inst.bufIsChanged (l_buf___6)).to_boolean then
									js.return
								end
							end
							if not js.return_called then
								l_need_hide := 0
							end
						else
							l_tmp___3.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_nowrtmsg)))
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___3)).do_nothing
							js.return
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_tmp___3.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_nowrtmsg)))
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___3)).do_nothing
						js.return
				when 10 then -- if done | if done | if done | if done
						if not js.return_called then
							globals_inst.need_mouse_correct := 1
							if (a_tp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								if not l_need_hide.to_boolean then
									if (quickfix_inst.buf_hide (l_buf___6)).to_boolean then
										l_tmp___6 := 0
									else
										l_tmp___6 := 1
									end
								else
									l_tmp___6 := 0
								end
								window_inst.win_close (a_win, l_tmp___6)
							else
								if not l_need_hide.to_boolean then
									if (quickfix_inst.buf_hide (l_buf___6)).to_boolean then
										l_tmp___8 := 0
									else
										l_tmp___8 := 1
									end
								else
									l_tmp___8 := 0
								end
								window_inst.win_close_othertab (a_win, l_tmp___8, a_tp)
							end
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_tabclose (a_eap: CE_POINTER [PD_EXARG])
		local
			l_tp: CE_POINTER [PD_TABPAGE_S]
			js: JUMP_STATE
		do
			create l_tp.make

			if globals_inst.cmdwin_type /= 0 then
				globals_inst.cmdwin_result := -(253 + ((53).bit_shift_left (8)))
			elseif ((globals_inst.first_tabpage.item.tp_next).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E784: Cannot close last tab page"))))).do_nothing
			else
				if a_eap.item.addr_count > 0 then
					l_tp.ce_gets (window_inst.find_tabpage ((a_eap.item.line2).to_integer_32))
					if (l_tp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						misc1_inst.beep_flush
						js.return
					end
					if not js.return_called and then ((l_tp.c_pointer.to_integer_32).to_natural_32 /= (globals_inst.curtab.c_pointer.to_integer_32).to_natural_32) then
						tabpage_close_other (l_tp, a_eap.item.forceit)
						js.return
					end
				end
				if not js.return_called then
					if not (ex_getln_inst.text_locked).to_boolean then
						if not (ex_getln_inst.curbuf_locked).to_boolean then
							tabpage_close (a_eap.item.forceit)
						end
					end
				end
			end
			if not js.return_called then
			end
		end

	ex_tabclose_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_tabclose)
		end

	ex_tabonly (a_eap: CE_POINTER [PD_EXARG])
		local
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_done___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_tp.make

			if globals_inst.cmdwin_type /= 0 then
				globals_inst.cmdwin_result := -(253 + ((53).bit_shift_left (8)))
			elseif ((globals_inst.first_tabpage.item.tp_next).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Already only one tab page"))))).do_nothing
			else
				l_done___2 := 0
				from
				until
					not (not js.loop_left and then (l_done___2 < 1000))
				loop
					js.reset
					l_tp.ce_gets (globals_inst.first_tabpage)
					from
					until
						not (not js.loop_left and then ((l_tp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
					loop
						js.reset
						if ((l_tp.item.tp_topframe).c_pointer.to_integer_32).to_natural_32 /= (globals_inst.topframe.c_pointer.to_integer_32).to_natural_32 then
							tabpage_close_other (l_tp, a_eap.item.forceit)
							if (window_inst.valid_tabpage (l_tp)).to_boolean then
								l_done___2 := 1000
							end
							js.break
						end
						if not js.loop_jumped then
							l_tp.ce_gets (l_tp.item.tp_next)
						end
					end
					js.reset
					if ((globals_inst.first_tabpage.item.tp_next).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.break
					end
					if not js.loop_jumped then
						l_done___2 := l_done___2 + 1
					end
				end
				js.reset
			end
		end

	ex_tabonly_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_tabonly)
		end

	tabpage_close (a_forceit: INTEGER_32)
		do
			if (globals_inst.lastwin.c_pointer.to_integer_32).to_natural_32 /= (globals_inst.firstwin.c_pointer.to_integer_32).to_natural_32 then
				window_inst.close_others (1, a_forceit)
			end
			if (globals_inst.lastwin.c_pointer.to_integer_32).to_natural_32 = (globals_inst.firstwin.c_pointer.to_integer_32).to_natural_32 then
				ex_win_close (a_forceit, globals_inst.curwin, create {CE_POINTER [PD_TABPAGE_S]}.make_shared (default_pointer))
			end
			globals_inst.need_mouse_correct := 1
		end

	tabpage_close_other (a_tp: CE_POINTER [PD_TABPAGE_S]; a_forceit: INTEGER_32)
		local
			l_done___2: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_h: INTEGER_32
			js: JUMP_STATE
		do
			create l_wp___0.make

			l_done___2 := 0
			l_h := (window_inst.tabline_height)
			from
			until
				js.loop_left
			loop
				js.reset
				l_done___2 := l_done___2 + 1
				if not (l_done___2 < 1000) then
					js.break
				end
				if not js.loop_jumped then
					l_wp___0.ce_gets (a_tp.item.tp_firstwin)
					ex_win_close (a_forceit, l_wp___0, a_tp)
					if (window_inst.valid_tabpage (a_tp)).to_boolean then
						if ((a_tp.item.tp_firstwin).c_pointer.to_integer_32).to_natural_32 = (l_wp___0.c_pointer.to_integer_32).to_natural_32 then
							js.break
						end
					else
						js.break
					end
				end
			end
			js.reset
			globals_inst.redraw_tabline := 1
			if l_h /= (window_inst.tabline_height) then
				window_inst.shell_new_rows
			end
		end

	ex_only (a_eap: CE_POINTER [PD_EXARG])
		do
			globals_inst.need_mouse_correct := 1
			window_inst.close_others (1, a_eap.item.forceit)
		end

	ex_only_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_only)
		end

	ex_all (a_eap: CE_POINTER [PD_EXARG])
		do
			if a_eap.item.addr_count = 0 then
				a_eap.item.line2 := (9999).to_integer_32
			end
			buffer_inst.do_arg_all ((a_eap.item.line2).to_integer_32, a_eap.item.forceit, (a_eap.item.cmdidx = 117).to_integer)
		end

	ex_all_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_all)
		end

	ex_hide (a_eap: CE_POINTER [PD_EXARG])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((a_eap.item.arg).item).to_integer_32 = 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if ((check_nextcmd (a_eap.item.arg)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							a_eap.item.errmsg := globals_inst.e_invarg
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						a_eap.item.nextcmd := check_nextcmd (a_eap.item.arg)
						if not (a_eap.item.skip).to_boolean then
							globals_inst.need_mouse_correct := 1
							window_inst.win_close (globals_inst.curwin, 0)
						end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_hide_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_hide)
		end

	ex_stop (a_eap: CE_POINTER [PD_EXARG])
		do
			if not (ex_cmds_inst.check_restricted).to_boolean then
				if not (a_eap.item.forceit).to_boolean then
					ex_cmds2_inst.autowrite_all
				end
				screen_inst.windgoto (globals_inst.Rows.to_integer_32 - 1, 0)
				term_inst.out_char ((('%N').code).to_natural_32)
				term_inst.out_flush
				term_inst.stoptermcap
				term_inst.out_flush
				os_unix_inst.mch_restore_title (3)
				ui_inst.ui_suspend
				buffer_inst.maketitle
				buffer_inst.resettitle
				term_inst.starttermcap
				term_inst.scroll_start
				screen_inst.redraw_later_clear
				term_inst.shell_resized
			end
		end

	ex_stop_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_stop)
		end

	ex_exit (a_eap: CE_POINTER [PD_EXARG])
		local
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if globals_inst.cmdwin_type /= 0 then
						globals_inst.cmdwin_result := 3
						js.return
					end
					if not js.return_called then
						if (ex_getln_inst.text_locked).to_boolean then
							ex_getln_inst.text_locked_msg
							js.return
						end
					end
					if not js.return_called then
						if (ex_getln_inst.curbuf_locked).to_boolean then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						if (check_more (0, a_eap.item.forceit)) = 1 then
							if (window_inst.only_one_window).to_boolean then
								globals_inst.exiting := 1
							end
						end
						if a_eap.item.cmdidx /= 489 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L___1
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 4 then -- else:
						if not ((undo_inst.curbufIsChanged).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L___1:
						if (ex_cmds_inst.do_write (a_eap)) = 0 then
							not_exiting
						else
							l_pos := -1 + 7 -- goto _L___0
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 7 then -- else: | _L___0:
						if (check_more (1, a_eap.item.forceit)) /= 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						not_exiting
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if not ((window_inst.only_one_window).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if (ex_cmds2_inst.check_changed_any (a_eap.item.forceit)).to_boolean then
							not_exiting
						else
							l_pos := -1 + 13 -- goto _L
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L:
						if (window_inst.only_one_window).to_boolean then
							main_inst.getout (0)
						end
						globals_inst.need_mouse_correct := 1
						if (quickfix_inst.buf_hide (globals_inst.curwin.item.w_buffer)).to_boolean then
							l_tmp___5 := 0
						else
							l_tmp___5 := 1
						end
						window_inst.win_close (globals_inst.curwin, l_tmp___5)
				when 14 then -- if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_exit_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_exit)
		end

	ex_print (a_eap: CE_POINTER [PD_EXARG])
		local
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			if ((globals_inst.curbuf.item.b_ml.ml_flags).bit_and (1)).to_boolean then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_emptybuf))))).do_nothing
			else
				from
				until
					not (not js.loop_left and then (not globals_inst.got_int.to_boolean))
				loop
					js.reset
					if a_eap.item.cmdidx = 193 then
						l_tmp___0 := 1
					elseif ((a_eap.item.flags).bit_and (1)).to_boolean then
						l_tmp___0 := 1
					else
						l_tmp___0 := 0
					end
					if a_eap.item.cmdidx = 281 then
						l_tmp___1 := 1
					elseif a_eap.item.cmdidx = 506 then
						l_tmp___1 := 1
					elseif ((a_eap.item.flags).bit_and (2)).to_boolean then
						l_tmp___1 := 1
					else
						l_tmp___1 := 0
					end
					ex_cmds_inst.print_line (a_eap.item.line1, l_tmp___1, l_tmp___0)
					a_eap.item.line1 := (a_eap.item.line1) + 1
					if a_eap.item.line1 > a_eap.item.line2 then
						js.break
					end
					if not js.loop_jumped then
						term_inst.out_flush
						ui_inst.ui_breakcheck
					end
				end
				js.reset
				mark_inst.setpcmark
				globals_inst.curwin.item.w_cursor.lnum := a_eap.item.line2
				edit_inst.beginline (6)
			end
			globals_inst.ex_no_reprint := 1
		end

	ex_print_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_print)
		end

	ex_goto (a_eap: CE_POINTER [PD_EXARG])
		do
			memline_inst.goto_byte (a_eap.item.line2)
		end

	ex_goto_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_goto)
		end

	ex_shell (a_eap: CE_POINTER [PD_EXARG])
		do
			ex_cmds_inst.do_shell (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0)
		end

	ex_shell_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_shell)
		end

	handle_drop (a_filec: INTEGER_32; a_filev: CE_POINTER [CE_POINTER [NATURAL_8]]; a_split: INTEGER_32)
		local
			l_split: INTEGER_32
			l_ea: PD_EXARG
			l_save_msg_scroll: INTEGER_32
			js: JUMP_STATE
		do
			create l_ea.make

			l_split := a_split
			l_save_msg_scroll := globals_inst.msg_scroll
			if (ex_getln_inst.text_locked).to_boolean then
				js.return
			end
			if not js.return_called then
				if (ex_getln_inst.curbuf_locked).to_boolean then
					js.return
				end
			end
			if not js.return_called and then (globals_inst.updating_screen.to_boolean) then
				js.return
			end
			if not js.return_called then
				if not (quickfix_inst.buf_hide (globals_inst.curbuf)).to_boolean then
					if not l_split.to_boolean then
						globals_inst.emsg_off := globals_inst.emsg_off + 1
						l_split := ex_cmds2_inst.check_changed (globals_inst.curbuf, 1, 0, 0, 0)
						globals_inst.emsg_off := globals_inst.emsg_off - 1
					end
				end
				if l_split.to_boolean then
					if (window_inst.win_split (0, 0)) = 0 then
						js.return
					end
					if not js.return_called then
						globals_inst.curwin.item.w_onebuf_opt.wo_scb := 0
						alist_unlink (globals_inst.curwin.item.w_alist)
						alist_new
					end
				end
			end
			if not js.return_called then
				alist_set (globals_inst.curwin.item.w_alist, a_filec, a_filev, 0, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0)
				memset (create {CE_POINTER [ANY]}.make_cast ((l_ea.address)), 0, {PD_EXARG}.sizeof.to_natural_32).do_nothing
				l_ea.cmd := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("next"))
				ex_cmds2_inst.do_argfile (l_ea.address, 0)
				globals_inst.need_start_insertmode := 0
				globals_inst.msg_scroll := l_save_msg_scroll
			end
		end

	alist_clear (a_al: CE_POINTER [PD_ARGLIST])
		local
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				a_al.item.al_ga.ga_len := (a_al.item.al_ga.ga_len) - 1
				if not (a_al.item.al_ga.ga_len >= 0) then
					js.break
				end
				if not js.loop_jumped then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_ARGENTRY]}.make_cast (a_al.item.al_ga.ga_data) + a_al.item.al_ga.ga_len).item.ae_fname))
				end
			end
			js.reset
			misc2_inst.ga_clear (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_al.c_pointer + {PD_ARGLIST}.al_ga_offset))
		end

	alist_init (a_al: CE_POINTER [PD_ARGLIST])
		do
			misc2_inst.ga_init2 (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_al.c_pointer + {PD_ARGLIST}.al_ga_offset), ({PD_ARGENTRY}.sizeof.to_natural_32).to_integer_32, 5)
		end

	alist_unlink (a_al: CE_POINTER [PD_ARGLIST])
		do
			if (a_al.c_pointer.to_integer_32).to_natural_32 /= ((globals_inst.global_alist.address).c_pointer.to_integer_32).to_natural_32 then
				a_al.item.al_refcount := (a_al.item.al_refcount) - 1
				if a_al.item.al_refcount <= 0 then
					alist_clear (a_al)
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_al))
				end
			end
		end

	alist_new
		do
			globals_inst.curwin.item.w_alist := create {CE_POINTER [PD_ARGLIST]}.make_cast ((misc2_inst.alloc ({PD_ARGLIST}.sizeof.to_natural_32)))
			if ((globals_inst.curwin.item.w_alist).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				globals_inst.curwin.item.w_alist := globals_inst.global_alist.address
				globals_inst.global_alist.al_refcount := (globals_inst.global_alist.al_refcount) + 1
			else
				(globals_inst.curwin.item.w_alist).item.al_refcount := 1
				alist_init (globals_inst.curwin.item.w_alist)
			end
		end

	alist_set (a_al: CE_POINTER [PD_ARGLIST]; a_count___2: INTEGER_32; a_files: CE_POINTER [CE_POINTER [NATURAL_8]]; a_use_curbuf: INTEGER_32; a_fnum_list: CE_POINTER [INTEGER_32]; a_fnum_len: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			alist_clear (a_al)
			if (misc2_inst.ga_grow (create {CE_POINTER [PD_GROWARRAY]}.make_shared (a_al.c_pointer + {PD_ARGLIST}.al_ga_offset), a_count___2)) = 1 then
				l_i___0 := 0
				from
				until
					not (not js.loop_left and then (l_i___0 < a_count___2))
				loop
					js.reset
					if globals_inst.got_int.to_boolean then
						from
						until
							not (l_i___0 < a_count___2)
						loop
							l_tmp := l_i___0
							l_i___0 := l_i___0 + 1
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_files[l_tmp]))
						end
						js.break
					end
					if not js.loop_jumped then
						if (a_fnum_list.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if l_i___0 < a_fnum_len then
								buffer_inst.buf_set_name (a_fnum_list[l_i___0], a_files[l_i___0])
							end
						end
						if a_use_curbuf.to_boolean then
							l_tmp___0 := 2
						else
							l_tmp___0 := 1
						end
						alist_add (a_al, a_files[l_i___0], l_tmp___0)
						ui_inst.ui_breakcheck
						l_i___0 := l_i___0 + 1
					end
				end
				js.reset
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_files))
			else
				misc1_inst.FreeWild (a_count___2, a_files)
			end
			if (a_al.c_pointer.to_integer_32).to_natural_32 = ((globals_inst.global_alist.address).c_pointer.to_integer_32).to_natural_32 then
				globals_inst.arg_had_last := 0
			end
		end

	alist_add (a_al: CE_POINTER [PD_ARGLIST]; a_fname: CE_POINTER [NATURAL_8]; a_set_fnum: INTEGER_32)
		local
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			if (a_fname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				(create {CE_POINTER [PD_ARGENTRY]}.make_cast (a_al.item.al_ga.ga_data) + a_al.item.al_ga.ga_len).item.ae_fname := a_fname
				if a_set_fnum > 0 then
					if a_set_fnum = 2 then
						l_tmp := 1
					else
						l_tmp := 0
					end
					(create {CE_POINTER [PD_ARGENTRY]}.make_cast (a_al.item.al_ga.ga_data) + a_al.item.al_ga.ga_len).item.ae_fnum := buffer_inst.buflist_add (a_fname, (2).bit_or (l_tmp))
				end
				a_al.item.al_ga.ga_len := (a_al.item.al_ga.ga_len) + 1
			end
		end

	ex_preserve (a_eap: CE_POINTER [PD_EXARG])
		do
			globals_inst.curbuf.item.b_flags := (globals_inst.curbuf.item.b_flags).bit_or ((256))
			memline_inst.ml_preserve (globals_inst.curbuf, 1)
		end

	ex_preserve_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_preserve)
		end

	ex_recover (a_eap: CE_POINTER [PD_EXARG])
		do
			globals_inst.recoverymode := 1
			if not (ex_cmds2_inst.check_changed (globals_inst.curbuf, option_inst.p_awa, 1, a_eap.item.forceit, 0)).to_boolean then
				if ((a_eap.item.arg).item).to_integer_32 = 0 then
					memline_inst.ml_recover
				elseif (buffer_inst.setfname (globals_inst.curbuf, a_eap.item.arg, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 1)) = 1 then
					memline_inst.ml_recover
				end
			end
			globals_inst.recoverymode := 0
		end

	ex_recover_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_recover)
		end

	ex_wrongmodifier (a_eap: CE_POINTER [PD_EXARG])
		do
			a_eap.item.errmsg := globals_inst.e_invcmd
		end

	ex_wrongmodifier_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_wrongmodifier)
		end

	ex_splitview (a_eap: CE_POINTER [PD_EXARG])
		local
			l_old_curwin___1: CE_POINTER [PD_WINDOW_S]
			l_fname: CE_POINTER [NATURAL_8]
			l_browse_flag: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_old_curwin___1.make
			create l_fname.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_old_curwin___1.ce_gets (globals_inst.curwin)
					l_fname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_browse_flag := globals_inst.cmdmod.browse
					globals_inst.need_mouse_correct := 1
					if (quickfix_inst.bt_quickfix (globals_inst.curbuf)).to_boolean then
						if globals_inst.cmdmod.tab = 0 then
							if a_eap.item.cmdidx = 390 then
								a_eap.item.cmdidx := {PC_CMD_INDEX}.CMD_new
							end
							if a_eap.item.cmdidx = 476 then
								a_eap.item.cmdidx := {PC_CMD_INDEX}.CMD_vnew
							end
						end
					end
					if a_eap.item.cmdidx /= 371 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 3 then -- else:
						if a_eap.item.cmdidx /= 423 then
							l_pos := -1 + 7 -- skip if block
						end
				when 4 then -- if: | _L___0:
						l_fname.ce_gets (misc2_inst.find_file_in_path (a_eap.item.arg, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg))).to_integer_32, 1, 1, globals_inst.curbuf.item.b_ffname))
						if (l_fname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 26 -- goto theend
						end
				when 5 then
						a_eap.item.arg := l_fname
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 7 then -- else:
						if not ((globals_inst.cmdmod.browse).to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 8 then -- if:
						if a_eap.item.cmdidx = 474 then
							l_pos := -1 + 15 -- skip if block
						end
				when 9 then -- if:
						if a_eap.item.cmdidx = 269 then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if:
						if (gui_inst.gui.in_use).to_boolean then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if (fileio_inst.au_has_group (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("FileExplorer")))).to_boolean then
							if ((a_eap.item.arg).item).to_integer_32 = 0 then
								a_eap.item.arg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("."))
							elseif not (os_unix_inst.mch_isdir (a_eap.item.arg)).to_boolean then
								a_eap.item.arg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("."))
							end
						else
							l_pos := -1 + 13 -- goto _L
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 13 then -- else: | _L:
						l_fname.ce_gets (message_inst.do_browse (0, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Edit File in new window")))), a_eap.item.arg, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), globals_inst.curbuf))
						if (l_fname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 26 -- goto theend
						end
				when 14 then
						a_eap.item.arg := l_fname
				when 15 then -- if done | if done | if done | if done | if done
						globals_inst.cmdmod.browse := 0
						if a_eap.item.cmdidx /= 422 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
							l_pos := -1 + 22 -- goto _L___1
				when 17 then -- if block done, skip else block:
							l_pos := -1 + 25
				when 18 then -- else:
							if a_eap.item.cmdidx /= 423 then
								l_pos := -1 + 21 -- skip if block
							end
				when 19 then -- if:
							l_pos := -1 + 22 -- goto _L___1
				when 20 then -- if block done, skip else block:
							l_pos := -1 + 25
				when 21 then -- else:
							if a_eap.item.cmdidx /= 428 then
								l_pos := -1 + 24 -- skip if block
							end
				when 22 then -- if: | _L___1:
							if globals_inst.cmdmod.tab /= 0 then
								l_tmp___6 := globals_inst.cmdmod.tab
							else
								if a_eap.item.addr_count = 0 then
									l_tmp___5 := 0
								else
									l_tmp___5 := (a_eap.item.line2).to_integer_32 + 1
								end
								l_tmp___6 := l_tmp___5
							end
							if (window_inst.win_new_tabpage (l_tmp___6)) /= 0 then
								do_exedit (a_eap, l_old_curwin___1)
								if (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 /= (l_old_curwin___1.c_pointer.to_integer_32).to_natural_32 then
									if (window_inst.win_valid (l_old_curwin___1)).to_boolean then
										if ((l_old_curwin___1.item.w_buffer).c_pointer.to_integer_32).to_natural_32 /= (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 then
											if not (globals_inst.cmdmod.keepalt).to_boolean then
												l_old_curwin___1.item.w_alt_fnum := globals_inst.curbuf.item.b_fnum
											end
										end
									end
								end
							end
				when 23 then -- if block done, skip else block:
							l_pos := -1 + 25
				when 24 then -- else:
							if ((a_eap.item.cmd).item).to_integer_32 = 118 then
								l_tmp___8 := 2
							else
								l_tmp___8 := 0
							end
							if a_eap.item.addr_count > 0 then
								l_tmp___9 := (a_eap.item.line2).to_integer_32
							else
								l_tmp___9 := 0
							end
							if (window_inst.win_split (l_tmp___9, l_tmp___8)) /= 0 then
								if ((a_eap.item.arg).item).to_integer_32 /= 0 then
									globals_inst.curwin.item.w_onebuf_opt.wo_scb := 0
								elseif (globals_inst.cmdmod.browse).to_boolean then
									globals_inst.curwin.item.w_onebuf_opt.wo_scb := 0
								else
									normal_inst.do_check_scrollbind (0)
								end
								do_exedit (a_eap, l_old_curwin___1)
							end
				when 25 then -- if done | if done
							globals_inst.cmdmod.browse := l_browse_flag
				when 26 then -- theend:
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fname))
				when 27 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	ex_splitview_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_splitview)
		end

	tabpage_new
		local
			l_ea: PD_EXARG
		do
			create l_ea.make

			memset (create {CE_POINTER [ANY]}.make_cast ((l_ea.address)), 0, {PD_EXARG}.sizeof.to_natural_32).do_nothing
			l_ea.cmdidx := {PC_CMD_INDEX}.CMD_tabnew
			l_ea.cmd := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("tabn"))
			l_ea.arg := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			ex_splitview (l_ea.address)
		end

	ex_tabnext (a_eap: CE_POINTER [PD_EXARG])
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_eap.item.cmdidx -- switch 1 head
					when 424 then l_pos := -1 + 1
					when 432 then l_pos := -1 + 1
					when 426 then l_pos := -1 + 2
					when 430 then l_pos := -1 + 3
					when 431 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 424 | switch 1, case 432
					window_inst.goto_tabpage (1)
					l_pos := -1 + 5 -- switch 1; break
				when 2 then -- switch 1, case 426
					window_inst.goto_tabpage (9999)
					l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case 430 | switch 1, case 431
					if a_eap.item.addr_count = 0 then
						l_tmp := -1
					else
						l_tmp := -(a_eap.item.line2).to_integer_32
					end
					window_inst.goto_tabpage (l_tmp)
					l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, default:
					if a_eap.item.addr_count = 0 then
						l_tmp___0 := 0
					else
						l_tmp___0 := (a_eap.item.line2).to_integer_32
					end
					window_inst.goto_tabpage (l_tmp___0)
					l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_tabnext_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_tabnext)
		end

	ex_tabmove (a_eap: CE_POINTER [PD_EXARG])
		local
			l_tmp: INTEGER_32
		do
			if a_eap.item.addr_count = 0 then
				l_tmp := 9999
			else
				l_tmp := (a_eap.item.line2).to_integer_32
			end
			window_inst.tabpage_move (l_tmp)
		end

	ex_tabmove_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_tabmove)
		end

	ex_tabs (a_eap: CE_POINTER [PD_EXARG])
		local
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_tabcount: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
		do
			create l_tp.make
			create l_wp___0.make

			l_tabcount := 1
			message_inst.msg_start
			globals_inst.msg_scroll := 1
			l_tp.ce_gets (globals_inst.first_tabpage)
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_tp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if globals_inst.got_int.to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					message_inst.msg_putchar (('%N').code)
					l_tmp := l_tabcount
					l_tabcount := l_tabcount + 1
					message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1025).to_natural_32, (gettext (ce_string ("Tab page %%d"))), l_tmp]).do_nothing
					message_inst.msg_outtrans_attr (globals_inst.IObuff, globals_inst.highlight_attr[14]).do_nothing
					term_inst.out_flush
					ui_inst.ui_breakcheck
					if (l_tp.c_pointer.to_integer_32).to_natural_32 = (globals_inst.curtab.c_pointer.to_integer_32).to_natural_32 then
						l_wp___0.ce_gets (globals_inst.firstwin)
					else
						l_wp___0.ce_gets (l_tp.item.tp_firstwin)
					end
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_wp___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if globals_inst.got_int.to_boolean then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							message_inst.msg_putchar (('%N').code)
							if (l_wp___0.c_pointer.to_integer_32).to_natural_32 = (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 then
								l_tmp___1 := ('>').code
							else
								l_tmp___1 := (' ').code
							end
							message_inst.msg_putchar (l_tmp___1)
							message_inst.msg_putchar ((' ').code)
							if (undo_inst.bufIsChanged (l_wp___0.item.w_buffer)).to_boolean then
								l_tmp___3 := ('+').code
							else
								l_tmp___3 := (' ').code
							end
							message_inst.msg_putchar (l_tmp___3)
							message_inst.msg_putchar ((' ').code)
							if ((buffer_inst.buf_spname (l_wp___0.item.w_buffer)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (buffer_inst.buf_spname (l_wp___0.item.w_buffer))).do_nothing
							else
								misc1_inst.home_replace (l_wp___0.item.w_buffer, (l_wp___0.item.w_buffer).item.b_fname, globals_inst.IObuff, 1025, 1)
							end
							message_inst.msg_outtrans (globals_inst.IObuff).do_nothing
							term_inst.out_flush
							ui_inst.ui_breakcheck
							l_wp___0.ce_gets (l_wp___0.item.w_next)
						end
					end
					js.reset
					l_tp.ce_gets (l_tp.item.tp_next)
				end
			end
			js.reset
		end

	ex_tabs_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_tabs)
		end

	ex_mode (a_eap: CE_POINTER [PD_EXARG])
		do
			if ((a_eap.item.arg).item).to_integer_32 = 0 then
				term_inst.shell_resized
			else
				os_unix_inst.mch_screenmode (a_eap.item.arg).do_nothing
			end
		end

	ex_mode_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_mode)
		end

	ex_resize (a_eap: CE_POINTER [PD_EXARG])
		local
			l_n: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			js: JUMP_STATE
		do
			create l_wp___0.make

			l_wp___0.ce_gets (globals_inst.curwin)
			if a_eap.item.addr_count > 0 then
				l_n := (a_eap.item.line2).to_integer_32
				l_wp___0.ce_gets (globals_inst.firstwin)
				from
				until
					js.loop_left
				loop
					js.reset
					if ((l_wp___0.item.w_next).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_n := l_n - 1
						if not (l_n > 0) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_wp___0.ce_gets (l_wp___0.item.w_next)
					end
				end
				js.reset
			end
			globals_inst.need_mouse_correct := 1
			l_n := (atol (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg))).to_integer_32
			if ((globals_inst.cmdmod.split).bit_and (2)).to_boolean then
				if ((a_eap.item.arg).item).to_integer_32 = 45 then
					l_n := l_n + (globals_inst.curwin.item.w_width)
				elseif ((a_eap.item.arg).item).to_integer_32 = 43 then
					l_n := l_n + (globals_inst.curwin.item.w_width)
				elseif l_n = 0 then
					if (a_eap.item.arg[0]).to_integer_32 = 0 then
						l_n := 9999
					end
				end
				window_inst.win_setwidth_win (l_n, l_wp___0)
			else
				if ((a_eap.item.arg).item).to_integer_32 = 45 then
					l_n := l_n + (globals_inst.curwin.item.w_height)
				elseif ((a_eap.item.arg).item).to_integer_32 = 43 then
					l_n := l_n + (globals_inst.curwin.item.w_height)
				elseif l_n = 0 then
					if (a_eap.item.arg[0]).to_integer_32 = 0 then
						l_n := 9999
					end
				end
				window_inst.win_setheight_win (l_n, l_wp___0)
			end
		end

	ex_resize_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_resize)
		end

	ex_find (a_eap: CE_POINTER [PD_EXARG])
		local
			l_fname: CE_POINTER [NATURAL_8]
			l_count___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_fname.make

			l_fname.ce_gets (misc2_inst.find_file_in_path (a_eap.item.arg, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg))).to_integer_32, 1, 1, globals_inst.curbuf.item.b_ffname))
			if a_eap.item.addr_count > 0 then
				l_count___2 := (a_eap.item.line2).to_integer_32
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_fname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_count___2 := l_count___2 - 1
						if not (l_count___2 > 0) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fname))
						l_fname.ce_gets (misc2_inst.find_file_in_path (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, 1, 0, globals_inst.curbuf.item.b_ffname))
					end
				end
				js.reset
			end
			if (l_fname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				a_eap.item.arg := l_fname
				do_exedit (a_eap, create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fname))
			end
		end

	ex_find_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_find)
		end

	ex_open (a_eap: CE_POINTER [PD_EXARG])
		local
			l_regmatch___0: PD_REGMATCH_T
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
		do
			create l_regmatch___0.make
			create l_p___0.make

			globals_inst.curwin.item.w_cursor.lnum := a_eap.item.line2
			edit_inst.beginline (6)
			if ((a_eap.item.arg).item).to_integer_32 = 47 then
				a_eap.item.arg := (a_eap.item.arg) + 1
				l_p___0.ce_gets (regexp_inst.skip_regexp (a_eap.item.arg, ('/').code, option_inst.p_magic, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
				l_p___0.item := (('%/0/').code).to_natural_8
				if option_inst.p_magic.to_boolean then
					l_tmp := 1
				else
					l_tmp := 0
				end
				l_regmatch___0.regprog := regexp_inst.vim_regcomp (a_eap.item.arg, l_tmp)
				if ((l_regmatch___0.regprog).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					l_regmatch___0.rm_ic := option_inst.p_ic
					l_p___0.ce_gets (memline_inst.ml_get_curline)
					if (regexp_inst.vim_regexec (l_regmatch___0.address, l_p___0, 0)).to_boolean then
						globals_inst.curwin.item.w_cursor.col := (l_regmatch___0.startp[0]).distance (l_p___0)
					else
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_nomatch))))).do_nothing
					end
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_regmatch___0.regprog))
				end
				a_eap.item.arg := a_eap.item.arg + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg))).to_integer_32
			end
			misc2_inst.check_cursor
			a_eap.item.cmdidx := {PC_CMD_INDEX}.CMD_visual
			do_exedit (a_eap, create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
		end

	ex_open_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_open)
		end

	ex_edit (a_eap: CE_POINTER [PD_EXARG])
		do
			do_exedit (a_eap, create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
		end

	ex_edit_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_edit)
		end

	do_exedit (a_eap: CE_POINTER [PD_EXARG]; a_old_curwin___1: CE_POINTER [PD_WINDOW_S])
		local
			l_n: INTEGER_32
			l_need_hide: INTEGER_32
			l_exmode_was: INTEGER_32
			l_rd: INTEGER_32
			l_nwr: INTEGER_32
			l_ms: INTEGER_32
			l_he: INTEGER_32
			l_tmp: CE_POINTER [PD_WINDOW_S]
			l_tmp___0: INTEGER_32
			l_tmp___3: INTEGER_32
			l_cs: PD_CLEANUP_STUFF
			l_tmp___5: INTEGER_32
			l_tmp___7: CE_POINTER [PD_WINDOW_S]
			l_tmp___9: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___16: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tmp.make
			create l_cs.make
			create l_tmp___7.make
			create l_tmp___16.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_exmode_was := globals_inst.exmode_active
					if not (globals_inst.exmode_active.to_boolean) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if a_eap.item.cmdidx /= 465 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if a_eap.item.cmdidx /= 466 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						globals_inst.exmode_active := 0
						if ((a_eap.item.arg).item).to_integer_32 = 0 then
							if globals_inst.global_busy.to_boolean then
								l_rd := globals_inst.RedrawingDisabled
								l_nwr := globals_inst.no_wait_return
								l_ms := globals_inst.msg_scroll
								l_he := globals_inst.hold_gui_events
								if ((a_eap.item.nextcmd).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									getchar_inst.stuffReadbuff (a_eap.item.nextcmd)
									a_eap.item.nextcmd := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
								end
								if l_exmode_was /= 2 then
									term_inst.settmode (2)
								end
								globals_inst.RedrawingDisabled := 0
								globals_inst.no_wait_return := 0
								globals_inst.need_wait_return := 0
								globals_inst.msg_scroll := 0
								globals_inst.hold_gui_events := 0
								globals_inst.must_redraw := 50
								main_inst.main_loop (0, 1)
								globals_inst.RedrawingDisabled := l_rd
								globals_inst.no_wait_return := l_nwr
								globals_inst.msg_scroll := l_ms
								globals_inst.hold_gui_events := l_he
							end
							js.return
						end
				when 6 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 39 -- skip if block
						end
				when 7 then -- if:
							if a_eap.item.cmdidx /= 269 then
								l_pos := -1 + 10 -- skip if block
							end
				when 8 then -- if:
							l_pos := -1 + 17 -- goto _L___4
				when 9 then -- if block done, skip else block:
							l_pos := -1 + 39
				when 10 then -- else:
							if a_eap.item.cmdidx /= 428 then
								l_pos := -1 + 13 -- skip if block
							end
				when 11 then -- if:
							l_pos := -1 + 17 -- goto _L___4
				when 12 then -- if block done, skip else block:
							l_pos := -1 + 39
				when 13 then -- else:
							if a_eap.item.cmdidx /= 422 then
								l_pos := -1 + 16 -- skip if block
							end
				when 14 then -- if:
							l_pos := -1 + 17 -- goto _L___4
				when 15 then -- if block done, skip else block:
							l_pos := -1 + 39
				when 16 then -- else:
							if a_eap.item.cmdidx /= 474 then
								l_pos := -1 + 19 -- skip if block
							end
				when 17 then -- if: | _L___4:
							if ((a_eap.item.arg).item).to_integer_32 = 0 then
								mark_inst.setpcmark
								if (a_old_curwin___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_tmp.ce_gets (globals_inst.curwin)
								else
									l_tmp.ce_gets (create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
								end
								if (a_eap.item.forceit).to_boolean then
									l_tmp___0 := 8
								else
									l_tmp___0 := 0
								end
								ex_cmds_inst.do_ecmd (0, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), a_eap, (1).to_integer_32, 1 + l_tmp___0, l_tmp).do_nothing
							else
								l_pos := -1 + 19 -- goto _L___3
							end
				when 18 then -- if block done, skip else block:
							l_pos := -1 + 39
				when 19 then -- else: | _L___3:
							if a_eap.item.cmdidx = 390 then
								l_pos := -1 + 22 -- skip if block
							end
				when 20 then -- if:
							if a_eap.item.cmdidx /= 476 then
								l_pos := -1 + 26 -- goto _L___1
							else
								l_pos := -1 + 22 -- goto _L___2
							end
				when 21 then -- if block done, skip else block:
							l_pos := -1 + 39
				when 22 then -- else: | _L___2:
							if ((a_eap.item.arg).item).to_integer_32 = 0 then
								l_pos := -1 + 25 -- skip if block
							end
				when 23 then -- if:
							l_pos := -1 + 26 -- goto _L___1
				when 24 then -- if block done, skip else block:
							l_pos := -1 + 39
				when 25 then -- else:
							if not ((globals_inst.cmdmod.browse).to_boolean) then
								l_pos := -1 + 38 -- skip if block
							end
				when 26 then -- if: | _L___1:
							if ((a_eap.item.arg).item).to_integer_32 /= 0 then
								if (ex_getln_inst.curbuf_locked).to_boolean then
									js.return
								end
							end
							if js.return_called then
								l_pos := -1 + 37 -- skip if block
							end
				when 27 then -- if:
							l_n := globals_inst.readonlymode
							if a_eap.item.cmdidx = 466 then
								globals_inst.readonlymode := 1
							elseif a_eap.item.cmdidx = 411 then
								globals_inst.readonlymode := 1
							elseif a_eap.item.cmdidx = 135 then
								globals_inst.readonlymode := 0
							end
							mark_inst.setpcmark
							if (a_old_curwin___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_tmp___7.ce_gets (globals_inst.curwin)
							else
								l_tmp___7.ce_gets (create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
							end
							if (quickfix_inst.buf_hide (globals_inst.curbuf)).to_boolean then
								l_tmp___9 := 1
							else
								l_tmp___9 := 0
							end
							if (a_eap.item.forceit).to_boolean then
								l_tmp___11 := 8
							else
								l_tmp___11 := 0
							end
							if a_eap.item.cmdidx = 22 then
								l_tmp___12 := 16
							else
								l_tmp___12 := 0
							end
							if ((a_eap.item.arg).item).to_integer_32 = 0 then
								if a_eap.item.do_ecmd_lnum = 0 then
									if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('g').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										l_tmp___14 := (1).to_integer_32
									else
										l_tmp___14 := a_eap.item.do_ecmd_lnum
									end
								else
									l_tmp___14 := a_eap.item.do_ecmd_lnum
								end
							else
								l_tmp___14 := a_eap.item.do_ecmd_lnum
							end
							if a_eap.item.cmdidx = 135 then
								l_tmp___16.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							else
								l_tmp___16.ce_gets (a_eap.item.arg)
							end
							if (ex_cmds_inst.do_ecmd (0, l_tmp___16, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), a_eap, l_tmp___14, (l_tmp___9 + l_tmp___11) + l_tmp___12, l_tmp___7)) /= 0 then
								l_pos := -1 + 35 -- skip if block
							end
				when 28 then -- if:
							if (a_old_curwin___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_pos := -1 + 34 -- skip if block
							end
				when 29 then -- if:
							if (undo_inst.curbufIsChanged).to_boolean then
								if globals_inst.curbuf.item.b_nwindows <= 1 then
									l_tmp___3 := 1
								else
									l_tmp___3 := 0
								end
							else
								l_tmp___3 := 0
							end
							l_need_hide := l_tmp___3
							if l_need_hide.to_boolean then
								l_pos := -1 + 32 -- skip if block
							end
				when 30 then -- if:
							l_pos := -1 + 33 -- goto _L___0
				when 31 then -- if block done, skip else block:
							l_pos := -1 + 34
				when 32 then -- else:
							if not ((quickfix_inst.buf_hide (globals_inst.curbuf)).to_boolean) then
								l_pos := -1 + 34 -- skip if block
							end
				when 33 then -- if: | _L___0:
							ex_eval_inst.enter_cleanup (l_cs.address)
							globals_inst.need_mouse_correct := 1
							if not l_need_hide.to_boolean then
								if (quickfix_inst.buf_hide (globals_inst.curbuf)).to_boolean then
									l_tmp___5 := 0
								else
									l_tmp___5 := 1
								end
							else
								l_tmp___5 := 0
							end
							window_inst.win_close (globals_inst.curwin, l_tmp___5)
							ex_eval_inst.leave_cleanup (l_cs.address)
				when 34 then -- if done | if done | if done | if block done, skip else block:
							l_pos := -1 + 36
				when 35 then -- else:
							if globals_inst.readonlymode.to_boolean then
								if globals_inst.curbuf.item.b_nwindows = 1 then
									globals_inst.curbuf.item.b_p_ro := 1
								end
							end
				when 36 then
							globals_inst.readonlymode := l_n
				when 37 then -- if done | if block done, skip else block:
							l_pos := -1 + 39
				when 38 then -- else:
							if ((a_eap.item.do_ecmd_cmd).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								do_cmdline_cmd (a_eap.item.do_ecmd_cmd).do_nothing
							end
							l_n := globals_inst.curwin.item.w_arg_idx_invalid
							ex_cmds2_inst.check_arg_idx (globals_inst.curwin)
							if l_n /= globals_inst.curwin.item.w_arg_idx_invalid then
								buffer_inst.maketitle
							end
				when 39 then -- if done | if done | if done | if done | if done | if done | if done
							if not js.return_called then
								if (a_old_curwin___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if ((a_eap.item.arg).item).to_integer_32 /= 0 then
										if (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 /= (a_old_curwin___1.c_pointer.to_integer_32).to_natural_32 then
											if (window_inst.win_valid (a_old_curwin___1)).to_boolean then
												if ((a_old_curwin___1.item.w_buffer).c_pointer.to_integer_32).to_natural_32 /= (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 then
													if not (globals_inst.cmdmod.keepalt).to_boolean then
														a_old_curwin___1.item.w_alt_fnum := globals_inst.curbuf.item.b_fnum
													end
												end
											end
										end
									end
								end
								globals_inst.ex_no_reprint := 1
							end
				when 40 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	ex_popup (a_eap: CE_POINTER [PD_EXARG])
		do
			gui_gtk_inst.gui_make_popup (a_eap.item.arg, a_eap.item.forceit)
		end

	ex_popup_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_popup)
		end

	ex_swapname (a_eap: CE_POINTER [PD_EXARG])
		local
			l_tmp: CE_POINTER [INTEGER_8]
		do
			create l_tmp.make

			if ((globals_inst.curbuf.item.b_ml.ml_mfp).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_tmp.ce_gets (gettext (ce_string ("No swap file")))
				message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
			elseif (((globals_inst.curbuf.item.b_ml.ml_mfp).item.mf_fname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_tmp.ce_gets (gettext (ce_string ("No swap file")))
				message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
			else
				message_inst.msg ((globals_inst.curbuf.item.b_ml.ml_mfp).item.mf_fname).do_nothing
			end
		end

	ex_swapname_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_swapname)
		end

	ex_syncbind (a_eap: CE_POINTER [PD_EXARG])
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_topline: INTEGER_32
			l_y: INTEGER_32
			l_old_linenr: INTEGER_32
			l_ctrl_o: CE_ARRAY [NATURAL_8]
		do
			create l_wp___0.make
			create l_ctrl_o.make (<<2>>)

			l_old_linenr := globals_inst.curwin.item.w_cursor.lnum
			mark_inst.setpcmark
			if (globals_inst.curwin.item.w_onebuf_opt.wo_scb).to_boolean then
				l_topline := globals_inst.curwin.item.w_topline
				l_wp___0.ce_gets (globals_inst.firstwin)
				from
				until
					(l_wp___0).c_pointer = default_pointer
				loop
					if (l_wp___0.item.w_onebuf_opt.wo_scb).to_boolean then
						if ((l_wp___0.item.w_buffer).c_pointer /= default_pointer) then
							l_y := (l_wp___0.item.w_buffer).item.b_ml.ml_line_count - option_inst.p_so
							if l_topline > l_y then
								l_topline := l_y
							end
						end
					end
					l_wp___0.ce_gets (l_wp___0.item.w_next)
				end
				if l_topline < 1 then
					l_topline := 1
				end
			else
				l_topline := 1
			end
			l_wp___0.ce_gets (globals_inst.curwin)
			globals_inst.curwin.ce_gets (globals_inst.firstwin)
			from
			until
				(globals_inst.curwin).c_pointer = default_pointer
			loop
				if (globals_inst.curwin.item.w_onebuf_opt.wo_scb).to_boolean then
					l_y := l_topline - globals_inst.curwin.item.w_topline
					if l_y > 0 then
						move_inst.scrollup (l_y, 1)
					else
						move_inst.scrolldown (-l_y, 1)
					end
					globals_inst.curwin.item.w_scbind_pos := l_topline
					screen_inst.redraw_later (10)
					move_inst.cursor_correct
					globals_inst.curwin.item.w_redr_status := 1
				end
				globals_inst.curwin.ce_gets (globals_inst.curwin.item.w_next)
			end
			globals_inst.curwin.ce_gets (l_wp___0)
			if (globals_inst.curwin.item.w_onebuf_opt.wo_scb).to_boolean then
				globals_inst.did_syncbind := 1
				mark_inst.checkpcmark
				if l_old_linenr /= globals_inst.curwin.item.w_cursor.lnum then
					l_ctrl_o[0] := (15).to_natural_8
					l_ctrl_o[1] := (0).to_natural_8
					getchar_inst.ins_typebuf (l_ctrl_o, -1, 0, 1, 0).do_nothing
				end
			end
		end

	ex_syncbind_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_syncbind)
		end

	ex_read (a_eap: CE_POINTER [PD_EXARG])
		local
			l_i___0: INTEGER_32
			l_empty: INTEGER_32
			l_lnum: INTEGER_32
			l_browseFile: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_browseFile.make

			l_empty := (globals_inst.curbuf.item.b_ml.ml_flags).bit_and (1)
			if (a_eap.item.usefilter).to_boolean then
				ex_cmds_inst.do_bang (1, a_eap, 0, 0, 1)
			else
				if (undo_inst.u_save (a_eap.item.line2, a_eap.item.line2 + 1)) = 0 then
					js.return
				end
				if not js.return_called then
					if (globals_inst.cmdmod.browse).to_boolean then
						l_browseFile.ce_gets (message_inst.do_browse (0, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Append File")))), a_eap.item.arg, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), globals_inst.curbuf))
						if (l_browseFile.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_i___0 := fileio_inst.readfile (l_browseFile, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), a_eap.item.line2, (0).to_integer_32, 2147483647, a_eap, 0)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_browseFile))
						else
							l_i___0 := 1
						end
					elseif ((a_eap.item.arg).item).to_integer_32 = 0 then
						if (ex_cmds2_inst.check_fname) = 0 then
							js.return
						end
						if not js.return_called then
							l_i___0 := fileio_inst.readfile (globals_inst.curbuf.item.b_ffname, globals_inst.curbuf.item.b_fname, a_eap.item.line2, (0).to_integer_32, 2147483647, a_eap, 0)
						end
					else
						if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('a').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							buffer_inst.setaltfname (a_eap.item.arg, a_eap.item.arg, (1).to_integer_32).do_nothing
						end
						l_i___0 := fileio_inst.readfile (a_eap.item.arg, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), a_eap.item.line2, (0).to_integer_32, 2147483647, a_eap, 0)
					end
				end
				if not js.return_called then
					if l_i___0 = 0 then
						if not (ex_eval_inst.aborting).to_boolean then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notopen)))), a_eap.item.arg).do_nothing
						end
					else
						if l_empty.to_boolean then
							if globals_inst.exmode_active.to_boolean then
								if a_eap.item.line2 = 0 then
									l_lnum := globals_inst.curbuf.item.b_ml.ml_line_count
								else
									l_lnum := (1).to_integer_32
								end
								if ((memline_inst.ml_get (l_lnum)).item).to_integer_32 = 0 then
									if (undo_inst.u_savedel (l_lnum, 1)) = 1 then
										memline_inst.ml_delete (l_lnum, 0).do_nothing
										if globals_inst.curwin.item.w_cursor.lnum > 1 then
											if globals_inst.curwin.item.w_cursor.lnum >= l_lnum then
												globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) - 1
											end
										end
										misc1_inst.deleted_lines_mark (l_lnum, 1)
									end
								end
							end
						end
						screen_inst.redraw_curbuf_later (10)
					end
				end
			end
			if not js.return_called then
			end
		end

	ex_read_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_read)
		end

	ex_cd (a_eap: CE_POINTER [PD_EXARG])
		local
			l_new_dir: CE_POINTER [NATURAL_8]
			l_tofree: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_new_dir.make
			create l_tofree.make
			create l_tmp___6.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_new_dir.ce_gets (a_eap.item.arg)
					if (ex_getln_inst.allbuf_locked).to_boolean then
						js.return
					end
					if not js.return_called then
						if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('.').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (undo_inst.curbufIsChanged).to_boolean then
								if not (a_eap.item.forceit).to_boolean then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E747: Cannot change directory, buffer is modified (add ! to override)"))))).do_nothing
									js.return
								end
							end
						end
					end
					if not js.return_called then
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_new_dir), ce_string ("-"))) = 0 then
							if (prev_dir.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E186: No previous directory"))))).do_nothing
								js.return
							end
							if not js.return_called then
								l_new_dir.ce_gets (prev_dir)
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						l_tofree.ce_gets (prev_dir)
						if (os_unix_inst.mch_dirname (globals_inst.NameBuff, 4096)) = 1 then
							prev_dir.ce_gets (misc2_inst.vim_strsave (globals_inst.NameBuff))
						else
							prev_dir.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						end
						if (l_new_dir.item).to_integer_32 = 0 then
							misc1_inst.expand_env (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("$HOME")), globals_inst.NameBuff, 4096)
							l_new_dir.ce_gets (globals_inst.NameBuff)
						end
						if (l_new_dir.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_tmp___6.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_failed)))
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___6)).do_nothing
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 4 then -- else:
						if not ((misc2_inst.vim_chdir (l_new_dir)).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_tmp___6.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_failed)))
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___6)).do_nothing
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 7 then -- else:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.curwin.item.w_localdir))
						if a_eap.item.cmdidx /= 203 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if a_eap.item.cmdidx /= 204 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if: | _L:
						if (globals_inst.globaldir.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if (prev_dir.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								globals_inst.globaldir.ce_gets (misc2_inst.vim_strsave (prev_dir))
							end
						end
						if (os_unix_inst.mch_dirname (globals_inst.NameBuff, 4096)) = 1 then
							globals_inst.curwin.item.w_localdir := misc2_inst.vim_strsave (globals_inst.NameBuff)
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.globaldir))
						globals_inst.globaldir.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						globals_inst.curwin.item.w_localdir := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				when 14 then -- if done
						fileio_inst.shorten_fnames (1)
						if globals_inst.KeyTyped.to_boolean then
							ex_pwd (a_eap)
						elseif option_inst.p_verbose >= 5 then
							ex_pwd (a_eap)
						end
				when 15 then -- if done | if done
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tofree))
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_cd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_cd)
		end

	ex_pwd (a_eap: CE_POINTER [PD_EXARG])
		do
			if (os_unix_inst.mch_dirname (globals_inst.NameBuff, 4096)) = 1 then
				message_inst.msg (globals_inst.NameBuff).do_nothing
			else
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E187: Unknown"))))).do_nothing
			end
		end

	ex_pwd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_pwd)
		end

	ex_equal (a_eap: CE_POINTER [PD_EXARG])
		do
			message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%%ld")), a_eap.item.line2]).do_nothing
			ex_may_print (a_eap)
		end

	ex_equal_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_equal)
		end

	ex_sleep (a_eap: CE_POINTER [PD_EXARG])
		local
			l_n: INTEGER_32
			l_len: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (move_inst.cursor_valid).to_boolean then
						l_n := (globals_inst.curwin.item.w_winrow + globals_inst.curwin.item.w_wrow) - globals_inst.msg_scrolled
						if l_n >= 0 then
							screen_inst.windgoto (l_n, globals_inst.curwin.item.w_wcol)
						end
					end
					l_len := a_eap.item.line2
					inspect ((a_eap.item.arg).item).to_integer_32 -- switch 1 head
					when 109 then l_pos := -1 + 1
					when 0 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 109
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 0
					l_len := l_len * (1000)
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg2)))), a_eap.item.arg).do_nothing
					js.return
				when 4 then -- switch 1, done:
					if not js.return_called then
						do_sleep (l_len)
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_sleep_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_sleep)
		end

	do_sleep (a_msec: INTEGER_32)
		local
			l_done___2: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			term_inst.cursor_on
			term_inst.out_flush
			l_done___2 := 0
			from
			until
				js.loop_left
			loop
				js.reset
				if not globals_inst.got_int.to_boolean then
					if not (l_done___2 < a_msec) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if a_msec - l_done___2 > 1000 then
						l_tmp := 1000
					else
						l_tmp := a_msec - l_done___2
					end
					ui_inst.ui_delay (l_tmp, 1)
					ui_inst.ui_breakcheck
					l_done___2 := l_done___2 + (1000)
				end
			end
			js.reset
		end

	do_exmap (a_eap: CE_POINTER [PD_EXARG]; a_isabbrev: INTEGER_32)
		local
			l_mode: INTEGER_32
			l_cmdp: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			create l_cmdp.make
			create l_tmp___5.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_cmdp.ce_gets (a_eap.item.cmd)
					if (a_eap.item.forceit).to_boolean then
						l_tmp := 1
					elseif a_isabbrev.to_boolean then
						l_tmp := 1
					else
						l_tmp := 0
					end
					l_mode := getchar_inst.get_map_mode (l_cmdp.address, l_tmp)
					if (l_cmdp.item).to_integer_32 = 110 then
						l_tmp___0 := 2
					else
						l_tmp___0 := ((l_cmdp.item).to_integer_32 = 117).to_integer
					end
					inspect (getchar_inst.do_map (l_tmp___0, a_eap.item.arg, l_mode, a_isabbrev)) -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 1
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg))))).do_nothing
					l_pos := -1 + 3 -- switch 1; break
				when 2 then -- switch 1, case 2
					if a_isabbrev.to_boolean then
						l_tmp___5.ce_gets ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_noabbr))))
					else
						l_tmp___5.ce_gets ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_nomap))))
					end
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___5)).do_nothing
					l_pos := -1 + 3 -- switch 1; break
				when 3 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_winsize (a_eap: CE_POINTER [PD_EXARG])
		local
			l_w: INTEGER_32
			l_h: INTEGER_32
			l_arg: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
		do
			create l_arg.make
			create l_p___0.make
			create l_tmp___1.make

			l_arg.ce_gets (a_eap.item.arg)
			l_w := (charset_inst.getdigits (l_arg.address)).to_integer_32
			l_arg.ce_gets (charset_inst.skipwhite (l_arg))
			l_p___0.ce_gets (l_arg)
			l_h := (charset_inst.getdigits (l_arg.address)).to_integer_32
			if (l_p___0.item).to_integer_32 /= 0 then
				if (l_arg.item).to_integer_32 = 0 then
					term_inst.set_shellsize (l_w, l_h, 1)
				else
					l_tmp___1.ce_gets (gettext (ce_string ("E465: :winsize requires two number arguments")))
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___1)).do_nothing
				end
			else
				l_tmp___1.ce_gets (gettext (ce_string ("E465: :winsize requires two number arguments")))
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___1)).do_nothing
			end
		end

	ex_winsize_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_winsize)
		end

	ex_wincmd (a_eap: CE_POINTER [PD_EXARG])
		local
			l_xchar: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_xchar := ('%/0/').code
					if ((a_eap.item.arg).item).to_integer_32 /= 103 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if ((a_eap.item.arg).item).to_integer_32 /= 7 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						if (a_eap.item.arg[1]).to_integer_32 = 0 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg))))).do_nothing
							js.return
						end
						if not js.return_called then
							l_xchar := (a_eap.item.arg[1]).to_integer_32
							l_p___0.ce_gets (a_eap.item.arg + 2)
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_p___0.ce_gets (a_eap.item.arg + 1)
				when 7 then -- if done
						if js.return_called then
							l_pos := -1 + 12 -- skip if block
						end
				when 8 then -- if:
							a_eap.item.nextcmd := check_nextcmd (l_p___0)
							l_p___0.ce_gets (charset_inst.skipwhite (l_p___0))
							if (l_p___0.item).to_integer_32 = 0 then
								l_pos := -1 + 11 -- skip if block
							end
				when 9 then -- if:
							if (l_p___0.item).to_integer_32 /= 34 then
								if ((a_eap.item.nextcmd).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg))))).do_nothing
								else
									l_pos := -1 + 11 -- goto _L___1
								end
							else
								l_pos := -1 + 11 -- goto _L___1
							end
				when 10 then -- if block done, skip else block:
							l_pos := -1 + 12
				when 11 then -- else: | _L___1:
							globals_inst.postponed_split_flags := globals_inst.cmdmod.split
							globals_inst.postponed_split_tab := globals_inst.cmdmod.tab
							if a_eap.item.addr_count > 0 then
								l_tmp___1 := a_eap.item.line2
							else
								l_tmp___1 := 0
							end
							window_inst.do_window (((a_eap.item.arg).item).to_integer_32, l_tmp___1, l_xchar)
							globals_inst.postponed_split_flags := 0
							globals_inst.postponed_split_tab := 0
				when 12 then -- if done
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	ex_wincmd_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_wincmd)
		end

	ex_winpos (a_eap: CE_POINTER [PD_EXARG])
		local
			l_x___0: INTEGER_32
			l_y: INTEGER_32
			l_arg: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_arg.make
			create l_p___0.make
			create l_tmp___0.make
			create l_tmp___4.make

			l_arg.ce_gets (a_eap.item.arg)
			if (l_arg.item).to_integer_32 = 0 then
				if (gui_inst.gui.in_use).to_boolean then
					if (gui_gtk_x11_inst.gui_mch_get_winpos (create {CE_POINTER [INTEGER_32]}.make_shared ($l_x___0), create {CE_POINTER [INTEGER_32]}.make_shared ($l_y))) /= 0 then
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("Window position: X %%d, Y %%d"))), l_x___0, l_y]).do_nothing
						message_inst.msg (globals_inst.IObuff).do_nothing
					else
						l_tmp___0.ce_gets (gettext (ce_string ("E188: Obtaining window position not implemented for this platform")))
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___0)).do_nothing
					end
				else
					l_tmp___0.ce_gets (gettext (ce_string ("E188: Obtaining window position not implemented for this platform")))
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___0)).do_nothing
				end
			else
				l_x___0 := (charset_inst.getdigits (l_arg.address)).to_integer_32
				l_arg.ce_gets (charset_inst.skipwhite (l_arg))
				l_p___0.ce_gets (l_arg)
				l_y := (charset_inst.getdigits (l_arg.address)).to_integer_32
				if (l_p___0.item).to_integer_32 = 0 then
					l_tmp___4.ce_gets (gettext (ce_string ("E466: :winpos requires two number arguments")))
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___4)).do_nothing
					js.return
				elseif (l_arg.item).to_integer_32 /= 0 then
					l_tmp___4.ce_gets (gettext (ce_string ("E466: :winpos requires two number arguments")))
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___4)).do_nothing
					js.return
				end
				if not js.return_called then
					if (gui_inst.gui.in_use).to_boolean then
						gui_gtk_x11_inst.gui_mch_set_winpos (l_x___0, l_y)
					elseif (gui_inst.gui.starting).to_boolean then
						globals_inst.gui_win_x := l_x___0
						globals_inst.gui_win_y := l_y
					elseif ((term_inst.term_strings[50]).item).to_boolean then
						term_inst.term_set_winpos (l_x___0, l_y)
					end
				end
			end
			if not js.return_called then
			end
		end

	ex_winpos_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_winpos)
		end

	ex_operators (a_eap: CE_POINTER [PD_EXARG])
		local
			l_oa: PD_OPARG_S
			l_pos: INTEGER_32
		do
			create l_oa.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					ops_inst.clear_oparg (l_oa.address)
					l_oa.regname := a_eap.item.regname
					l_oa.start.lnum := a_eap.item.line1
					l_oa.end2.lnum := a_eap.item.line2
					l_oa.line_count := (a_eap.item.line2 - a_eap.item.line1) + 1
					l_oa.motion_type := 1
					globals_inst.virtual_op := 0
					if a_eap.item.cmdidx /= 503 then
						mark_inst.setpcmark
						globals_inst.curwin.item.w_cursor.lnum := a_eap.item.line1
						edit_inst.beginline (6)
					end
					inspect a_eap.item.cmdidx -- switch 1 head
					when 98 then l_pos := -1 + 1
					when 503 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 98
					l_oa.op_type := 1
					ops_inst.op_delete (l_oa.address).do_nothing
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 503
					l_oa.op_type := 2
					ops_inst.op_yank (l_oa.address, 0, 1).do_nothing
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					if a_eap.item.cmdidx = 511 then
						l_oa.op_type := 5
					else
						l_oa.op_type := 4
					end
					ops_inst.op_shift (l_oa.address, 0, a_eap.item.amount)
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					globals_inst.virtual_op := 2
					ex_may_print (a_eap)
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_operators_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_operators)
		end

	ex_put (a_eap: CE_POINTER [PD_EXARG])
		local
			l_tmp: INTEGER_32
		do
			if a_eap.item.line2 = 0 then
				a_eap.item.line2 := (1).to_integer_32
				a_eap.item.forceit := 1
			end
			globals_inst.curwin.item.w_cursor.lnum := a_eap.item.line2
			if (a_eap.item.forceit).to_boolean then
				l_tmp := -1
			else
				l_tmp := 1
			end
			ops_inst.do_put (a_eap.item.regname, l_tmp, 1, 12)
		end

	ex_put_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_put)
		end

	ex_copymove (a_eap: CE_POINTER [PD_EXARG])
		local
			l_n: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_tmp.make

			l_n := get_address (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (a_eap.c_pointer + {PD_EXARG}.arg_offset), 0, 0)
			if ((a_eap.item.arg).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				a_eap.item.nextcmd := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				js.return
			end
			if not js.return_called then
				get_flags (a_eap)
				if l_n = 2147483647 then
					l_tmp.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invaddr)))
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
					js.return
				elseif l_n < 0 then
					l_tmp.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invaddr)))
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
					js.return
				elseif l_n > globals_inst.curbuf.item.b_ml.ml_line_count then
					l_tmp.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invaddr)))
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp)).do_nothing
					js.return
				end
			end
			if not js.return_called then
				if a_eap.item.cmdidx = 247 then
					if (ex_cmds_inst.do_move (a_eap.item.line1, a_eap.item.line2, l_n)) = 0 then
						js.return
					end
				else
					ex_cmds_inst.ex_copy (a_eap.item.line1, a_eap.item.line2, l_n)
				end
			end
			if not js.return_called then
				undo_inst.u_clearline
				edit_inst.beginline (6)
				ex_may_print (a_eap)
			end
		end

	ex_copymove_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_copymove)
		end

	ex_may_print (a_eap: CE_POINTER [PD_EXARG])
		do
			if a_eap.item.flags /= 0 then
				ex_cmds_inst.print_line (globals_inst.curwin.item.w_cursor.lnum, (a_eap.item.flags).bit_and (2), (a_eap.item.flags).bit_and (1))
				globals_inst.ex_no_reprint := 1
			end
		end

	ex_submagic (a_eap: CE_POINTER [PD_EXARG])
		local
			l_magic_save: INTEGER_32
		do
			l_magic_save := option_inst.p_magic
			option_inst.p_magic := (a_eap.item.cmdidx = 379).to_integer
			ex_cmds_inst.do_sub (a_eap)
			option_inst.p_magic := l_magic_save
		end

	ex_submagic_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_submagic)
		end

	ex_join (a_eap: CE_POINTER [PD_EXARG])
		local
			js: JUMP_STATE
		do
			globals_inst.curwin.item.w_cursor.lnum := a_eap.item.line1
			if a_eap.item.line1 = a_eap.item.line2 then
				if a_eap.item.addr_count >= 2 then
					js.return
				end
				if not js.return_called and then (a_eap.item.line2 = globals_inst.curbuf.item.b_ml.ml_line_count) then
					misc1_inst.beep_flush
					js.return
				end
				if not js.return_called then
					a_eap.item.line2 := (a_eap.item.line2) + 1
				end
			end
			if not js.return_called then
				ops_inst.do_join ((a_eap.item.line2 - a_eap.item.line1) + 1, (not (a_eap.item.forceit).to_boolean).to_integer, 1).do_nothing
				edit_inst.beginline (5)
				ex_may_print (a_eap)
			end
		end

	ex_join_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_join)
		end

	ex_at (a_eap: CE_POINTER [PD_EXARG])
		local
			l_c: INTEGER_32
			l_prev_len: INTEGER_32
			l_save_efr: INTEGER_32
			js: JUMP_STATE
		do
			l_prev_len := globals_inst.typebuf.tb_len
			globals_inst.curwin.item.w_cursor.lnum := a_eap.item.line2
			globals_inst.dont_scroll := 1
			l_c := ((a_eap.item.arg).item).to_integer_32
			if l_c = 0 then
				l_c := ('@').code
			elseif l_c = 42 then
				if ((a_eap.item.cmd).item).to_integer_32 = 42 then
					l_c := ('@').code
				end
			end
			if (ops_inst.do_execreg (l_c, 1, (((misc2_inst.vim_strchr (option_inst.p_cpo, ('e').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 1)) = 0 then
				misc1_inst.beep_flush
			else
				l_save_efr := globals_inst.exec_from_reg
				globals_inst.exec_from_reg := 1
				from
				until
					js.loop_left
				loop
					js.reset
					if (getchar_inst.stuff_empty).to_boolean then
						if not (globals_inst.typebuf.tb_len > l_prev_len) then
							js.break
						end
					end
					if not js.loop_jumped then
						do_cmdline (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), ex_getln_inst.getexline_address, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3).do_nothing
					end
				end
				js.reset
				globals_inst.exec_from_reg := l_save_efr
			end
		end

	ex_at_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_at)
		end

	ex_bang (a_eap: CE_POINTER [PD_EXARG])
		do
			ex_cmds_inst.do_bang (a_eap.item.addr_count, a_eap, a_eap.item.forceit, 1, 1)
		end

	ex_bang_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_bang)
		end

	ex_undo (a_eap: CE_POINTER [PD_EXARG])
		do
			if a_eap.item.addr_count = 1 then
				undo_inst.undo_time (a_eap.item.line2, 0, 0, 1)
			else
				undo_inst.u_undo (1)
			end
		end

	ex_undo_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_undo)
		end

	ex_wundo (a_eap: CE_POINTER [PD_EXARG])
		local
			l_hash: CE_ARRAY [NATURAL_8]
		do
			create l_hash.make (<<32>>)

			undo_inst.u_compute_hash (l_hash)
			undo_inst.u_write_undo (a_eap.item.arg, a_eap.item.forceit, globals_inst.curbuf, l_hash)
		end

	ex_wundo_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_wundo)
		end

	ex_rundo (a_eap: CE_POINTER [PD_EXARG])
		local
			l_hash: CE_ARRAY [NATURAL_8]
		do
			create l_hash.make (<<32>>)

			undo_inst.u_compute_hash (l_hash)
			undo_inst.u_read_undo (a_eap.item.arg, l_hash, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
		end

	ex_rundo_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_rundo)
		end

	ex_redo (a_eap: CE_POINTER [PD_EXARG])
		do
			undo_inst.u_redo (1)
		end

	ex_redo_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_redo)
		end

	ex_later (a_eap: CE_POINTER [PD_EXARG])
		local
			l_count___2: INTEGER_32
			l_sec: INTEGER_32
			l_file: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2 := 0
					l_sec := 0
					l_file := 0
					l_p___0.ce_gets (a_eap.item.arg)
					if (l_p___0.item).to_integer_32 /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_count___2 := 1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if not (((((ctype_b_loc).item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (2048)).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						l_count___2 := charset_inst.getdigits (l_p___0.address)
						inspect (l_p___0.item).to_integer_32 -- switch 1 head
						when 115 then l_pos := -1 + 5
						when 109 then l_pos := -1 + 6
						when 104 then l_pos := -1 + 7
						when 100 then l_pos := -1 + 8
						when 102 then l_pos := -1 + 9
						else l_pos := -1 + 10
						end
				when 5 then -- switch 1, case 115
						l_p___0.ce_gets (l_p___0 + 1)
						l_sec := 1
						l_pos := -1 + 10 -- switch 1; break
				when 6 then -- switch 1, case 109
						l_p___0.ce_gets (l_p___0 + 1)
						l_sec := 1
						l_count___2 := l_count___2 * (60)
						l_pos := -1 + 10 -- switch 1; break
				when 7 then -- switch 1, case 104
						l_p___0.ce_gets (l_p___0 + 1)
						l_sec := 1
						l_count___2 := l_count___2 * (3600)
						l_pos := -1 + 10 -- switch 1; break
				when 8 then -- switch 1, case 100
						l_p___0.ce_gets (l_p___0 + 1)
						l_sec := 1
						l_count___2 := l_count___2 * (86400)
						l_pos := -1 + 10 -- switch 1; break
				when 9 then -- switch 1, case 102
						l_p___0.ce_gets (l_p___0 + 1)
						l_file := 1
						l_pos := -1 + 10 -- switch 1; break
				when 10 then -- switch 1, done: | if done | if done
						if (l_p___0.item).to_integer_32 /= 0 then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg2)))), a_eap.item.arg).do_nothing
						else
							if a_eap.item.cmdidx = 121 then
								l_tmp___1 := -l_count___2
							else
								l_tmp___1 := l_count___2
							end
							undo_inst.undo_time (l_tmp___1, l_sec, l_file, 0)
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_later_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_later)
		end

	ex_redir (a_eap: CE_POINTER [PD_EXARG])
		local
			l_mode: CE_POINTER [INTEGER_8]
			l_fname: CE_POINTER [NATURAL_8]
			l_arg: CE_POINTER [NATURAL_8]
			l_browseFile: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_append: INTEGER_32
			l_tmp___6: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_mode.make
			create l_fname.make
			create l_arg.make
			create l_browseFile.make
			create l_tmp___0.make
			create l_tmp___6.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_arg.ce_gets (a_eap.item.arg)
					if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg), ce_string ("END"))) /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						close_redir
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 3 then -- else:
						if (l_arg.item).to_integer_32 /= 62 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_arg.ce_gets (l_arg + 1)
						if (l_arg.item).to_integer_32 = 62 then
							l_arg.ce_gets (l_arg + 1)
							l_mode.ce_gets (ce_string ("a"))
						else
							l_mode.ce_gets (ce_string ("w"))
						end
						l_arg.ce_gets (charset_inst.skipwhite (l_arg))
						close_redir
						l_fname.ce_gets (misc1_inst.expand_env_save (l_arg))
						if (l_fname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.return
						end
						if not js.return_called and then ((globals_inst.cmdmod.browse).to_boolean) then
							l_browseFile.ce_gets (message_inst.do_browse (1, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Save Redirection")))), l_fname, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("All Files (*)%T*%N")), globals_inst.curbuf))
							if (l_browseFile.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.return
							end
							if not js.return_called then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fname))
								l_fname.ce_gets (l_browseFile)
								a_eap.item.forceit := 1
							end
						end
						if not js.return_called then
							globals_inst.redir_fd.ce_gets (open_exfile (l_fname, a_eap.item.forceit, l_mode))
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fname))
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 6 then -- else:
						if (l_arg.item).to_integer_32 /= 64 then
							l_pos := -1 + 23 -- skip if block
						end
				when 7 then -- if:
						close_redir
						l_arg.ce_gets (l_arg + 1)
						if not ((l_arg.item).to_integer_32 < 127) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if ((((ctype_b_loc).item[(l_arg.item).to_integer_32]).to_integer_32).bit_and (1024)).to_boolean then
							l_pos := -1 + 17 -- goto _L___0
						else
							l_pos := -1 + 10 -- goto _L___1
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 10 then -- else: | _L___1:
						if (l_arg.item).to_integer_32 /= 42 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 17 -- goto _L___0
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 13 then -- else:
						if (l_arg.item).to_integer_32 /= 43 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 16 then -- else:
						if (l_arg.item).to_integer_32 /= 34 then
							l_pos := -1 + 21 -- skip if block
						end
				when 17 then -- if: | _L___0:
						l_tmp___0.ce_gets (l_arg)
						l_arg.ce_gets (l_arg + 1)
						globals_inst.redir_reg := (l_tmp___0.item).to_integer_32
						if (l_arg.item).to_integer_32 /= 62 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						if (l_arg[1]).to_integer_32 = 62 then
							l_arg.ce_gets (l_arg + (2))
						else
							l_pos := -1 + 20 -- goto _L
						end
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else: | _L:
						if (l_arg.item).to_integer_32 = 62 then
							l_arg.ce_gets (l_arg + 1)
						end
						if (l_arg.item).to_integer_32 = 0 then
							if not ((((ctype_b_loc).item[globals_inst.redir_reg]).to_integer_32).bit_and (256)).to_boolean then
								ops_inst.write_reg_contents (globals_inst.redir_reg, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), -1, 0)
							end
						end
				when 21 then -- if done | if done | if done | if done
						if (l_arg.item).to_integer_32 /= 0 then
							globals_inst.redir_reg := 0
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg2)))), a_eap.item.arg).do_nothing
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else:
						if (l_arg.item).to_integer_32 = 61 then
							if (l_arg[1]).to_integer_32 = 62 then
								close_redir
								l_arg.ce_gets (l_arg + (2))
								if (l_arg.item).to_integer_32 = 62 then
									l_arg.ce_gets (l_arg + 1)
									l_append := 1
								else
									l_append := 0
								end
								if (eval_inst.var_redir_start ((charset_inst.skipwhite (l_arg)), l_append)) = 1 then
									globals_inst.redir_vname := 1
								end
							else
								l_tmp___6.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg2)))
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___6), a_eap.item.arg).do_nothing
							end
						else
							l_tmp___6.ce_gets (gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg2)))
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___6), a_eap.item.arg).do_nothing
						end
				when 24 then -- if done | if done | if done
						if not js.return_called then
							if (globals_inst.redir_fd.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								globals_inst.redir_off := 0
							elseif globals_inst.redir_reg.to_boolean then
								globals_inst.redir_off := 0
							elseif globals_inst.redir_vname.to_boolean then
								globals_inst.redir_off := 0
							end
						end
				when 25 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_redir_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_redir)
		end

	ex_redraw (a_eap: CE_POINTER [PD_EXARG])
		local
			l_r: INTEGER_32
			l_p___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			l_r := globals_inst.RedrawingDisabled
			l_p___0 := option_inst.p_lz
			globals_inst.RedrawingDisabled := 0
			option_inst.p_lz := 0
			move_inst.update_topline
			if (a_eap.item.forceit).to_boolean then
				l_tmp___0 := 50
			else
				if globals_inst.VIsual_active.to_boolean then
					l_tmp := 20
				else
					l_tmp := 0
				end
				l_tmp___0 := l_tmp
			end
			screen_inst.update_screen (l_tmp___0)
			if globals_inst.need_maketitle.to_boolean then
				buffer_inst.maketitle
			end
			globals_inst.RedrawingDisabled := l_r
			option_inst.p_lz := l_p___0
			globals_inst.msg_didout := 0
			globals_inst.msg_col := 0
			term_inst.out_flush
		end

	ex_redraw_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_redraw)
		end

	ex_redrawstatus (a_eap: CE_POINTER [PD_EXARG])
		local
			l_r: INTEGER_32
			l_p___0: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_r := globals_inst.RedrawingDisabled
			l_p___0 := option_inst.p_lz
			globals_inst.RedrawingDisabled := 0
			option_inst.p_lz := 0
			if (a_eap.item.forceit).to_boolean then
				screen_inst.status_redraw_all
			else
				screen_inst.status_redraw_curbuf
			end
			if globals_inst.VIsual_active.to_boolean then
				l_tmp := 20
			else
				l_tmp := 0
			end
			screen_inst.update_screen (l_tmp)
			globals_inst.RedrawingDisabled := l_r
			option_inst.p_lz := l_p___0
			term_inst.out_flush
		end

	ex_redrawstatus_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_redrawstatus)
		end

	close_redir
		do
			if (globals_inst.redir_fd.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				fclose (globals_inst.redir_fd).do_nothing
				globals_inst.redir_fd.ce_gets (create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer))
			end
			globals_inst.redir_reg := 0
			if globals_inst.redir_vname.to_boolean then
				eval_inst.var_redir_stop
				globals_inst.redir_vname := 0
			end
		end

	ex_mkrc (a_eap: CE_POINTER [PD_EXARG])
		local
			l_fd: CE_POINTER [SD_IO_FILE]
			l_failed: INTEGER_32
			l_fname: CE_POINTER [NATURAL_8]
			l_browseFile: CE_POINTER [NATURAL_8]
			l_view_session: INTEGER_32
			l_using_vdir: INTEGER_32
			l_viewFile: CE_POINTER [NATURAL_8]
			l_flagp: CE_POINTER [NATURAL_32]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___9: INTEGER_32
			l_dirnow: CE_ARRAY [NATURAL_8]
			l_tbuf: CE_ARRAY [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fd.make
			create l_fname.make
			create l_browseFile.make
			create l_viewFile.make
			create l_flagp.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_dirnow.make (<<4096>>)
			create l_tbuf.make (<<4096>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_failed := 0
					l_browseFile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_view_session := 0
					l_using_vdir := 0
					l_viewFile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					if a_eap.item.cmdidx = 258 then
						l_view_session := 1
					elseif a_eap.item.cmdidx = 261 then
						l_view_session := 1
					end
					did_lcd := 0
					if a_eap.item.cmdidx /= 261 then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if ((a_eap.item.arg).item).to_integer_32 /= 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 6 -- goto _L___0
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else:
						if not ((charset_inst.vim_isdigit (((a_eap.item.arg).item).to_integer_32)).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if (a_eap.item.arg[1]).to_integer_32 /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L___0:
						a_eap.item.forceit := 1
						l_fname.ce_gets (get_view_file (((a_eap.item.arg).item).to_integer_32))
						if (l_fname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.return
						end
						if not js.return_called then
							l_viewFile.ce_gets (l_fname)
							l_using_vdir := 1
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_pos := -1 + 12 -- goto _L
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_pos := -1 + 12 -- goto _L
				when 11 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						if ((a_eap.item.arg).item).to_integer_32 /= 0 then
							l_fname.ce_gets (a_eap.item.arg)
						elseif a_eap.item.cmdidx = 260 then
							l_fname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".vimrc")))
						elseif a_eap.item.cmdidx = 258 then
							l_fname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Session.vim")))
						else
							l_fname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".exrc")))
						end
				when 13 then
					if js.return_called then
						l_pos := -1 + 43 -- skip if block
					end
				when 14 then -- if:
						if not ((globals_inst.cmdmod.browse).to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if a_eap.item.cmdidx = 261 then
							l_tmp___4.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Save View")))))
						else
							if a_eap.item.cmdidx = 258 then
								l_tmp___3.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Save Session")))))
							else
								l_tmp___3.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Save Setup")))))
							end
							l_tmp___4.ce_gets (l_tmp___3)
						end
						l_browseFile.ce_gets (message_inst.do_browse (1, l_tmp___4, l_fname, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("vim")), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vim macro files (*.vim)%T*.vim%NAll Files (*)%T*%N")), create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)))
						if (l_browseFile.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 42 -- goto theend
						end
				when 16 then
						l_fname.ce_gets (l_browseFile)
						a_eap.item.forceit := 1
				when 17 then -- if done
						if l_using_vdir.to_boolean then
							if not (os_unix_inst.mch_isdir (option_inst.p_vdir)).to_boolean then
								vim_mkdir_emsg (option_inst.p_vdir, 493).do_nothing
							end
						end
						l_fd.ce_gets (open_exfile (l_fname, a_eap.item.forceit, ce_string ("w")))
						if (l_fd.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 42 -- skip if block
						end
				when 18 then -- if:
						if a_eap.item.cmdidx = 261 then
							l_flagp.ce_gets (option_inst.vop_flags_address)
						else
							l_flagp.ce_gets (option_inst.ssop_flags_address)
						end
						if a_eap.item.cmdidx = 260 then
							put_line (l_fd, ce_string ("version 6.0")).do_nothing
						end
						if a_eap.item.cmdidx = 258 then
							if (put_line (l_fd, ce_string ("let SessionLoad = 1"))) = 0 then
								l_failed := 1
							end
						end
						if a_eap.item.cmdidx /= 261 then
							if option_inst.p_cp.to_boolean then
								put_line (l_fd, ce_string ("if !&cp | set cp | endif")).do_nothing
							else
								put_line (l_fd, ce_string ("if &cp | set nocp | endif")).do_nothing
							end
						end
						if l_view_session.to_boolean then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 23 -- goto _L___1
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 21 then -- else:
						if a_eap.item.cmdidx /= 258 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if not (((l_flagp.item).bit_and ({NATURAL_32} 32)).to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 23 then -- if: | _L___1:
						if (getchar_inst.makemap (l_fd, create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))) = 0 then
							l_tmp___9 := 1
						elseif (option_inst.makeset (l_fd, 2, 0)) = 0 then
							l_tmp___9 := 1
						else
							l_tmp___9 := 0
						end
						l_failed := (l_failed).bit_or (l_tmp___9)
				when 24 then -- if done | if done
						if l_failed.to_boolean then
							l_pos := -1 + 41 -- skip if block
						end
				when 25 then -- if:
						if not (l_view_session.to_boolean) then
							l_pos := -1 + 41 -- skip if block
						end
				when 26 then -- if:
						if (put_line (l_fd, ce_string ("let s:so_save = &so | let s:siso_save = &siso | set so=0 siso=0"))) = 0 then
							l_failed := 1
						end
						if a_eap.item.cmdidx /= 258 then
							l_pos := -1 + 39 -- skip if block
						end
				when 27 then -- if:
						if (os_unix_inst.mch_dirname (l_dirnow, 4096)) = 0 then
							l_dirnow[0] := (('%/0/').code).to_natural_8
						elseif (os_unix_inst.mch_chdir (create {CE_POINTER [INTEGER_8]}.make_cast (l_dirnow))) /= 0 then
							l_dirnow[0] := (('%/0/').code).to_natural_8
						end
						if (l_dirnow[0]).to_integer_32 = 0 then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						if ((option_inst.ssop_flags).bit_and ({NATURAL_32} 2048)).to_boolean then
							if (misc2_inst.vim_chdirfile (l_fname)) = 1 then
								fileio_inst.shorten_fnames (1)
							end
						else
							l_pos := -1 + 30 -- goto _L___2
						end
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else: | _L___2:
						if (l_dirnow[0]).to_integer_32 /= 0 then
							if ((option_inst.ssop_flags).bit_and ({NATURAL_32} 4096)).to_boolean then
								if (globals_inst.globaldir.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if (os_unix_inst.mch_chdir (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.globaldir))) = 0 then
										fileio_inst.shorten_fnames (1)
									end
								end
							end
						end
				when 31 then
						l_failed := (l_failed).bit_or (((makeopens (l_fd, l_dirnow)) = 0).to_integer)
						if (l_dirnow[0]).to_integer_32 = 0 then
							l_pos := -1 + 38 -- skip if block
						end
				when 32 then -- if:
						if not (((option_inst.ssop_flags).bit_and ({NATURAL_32} 2048)).to_boolean) then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 37 -- goto _L___3
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 35 then -- else:
						if not (((option_inst.ssop_flags).bit_and ({NATURAL_32} 4096)).to_boolean) then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if:
						if (globals_inst.globaldir.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 38 -- skip if block
						end
				when 37 then -- if: | _L___3:
						if (os_unix_inst.mch_chdir (create {CE_POINTER [INTEGER_8]}.make_cast (l_dirnow))) /= 0 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_prev_dir))))).do_nothing
						end
						fileio_inst.shorten_fnames (1)
				when 38 then -- if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 40
				when 39 then -- else:
						l_failed := (l_failed).bit_or (((put_view (l_fd, globals_inst.curwin, (not l_using_vdir.to_boolean).to_integer, l_flagp, -1)) = 0).to_integer)
				when 40 then
						if (put_line (l_fd, ce_string ("let &so = s:so_save | let &siso = s:siso_save"))) = 0 then
							l_failed := 1
						end
						if (put_line (l_fd, ce_string ("doautoall SessionLoadPost"))) = 0 then
							l_failed := 1
						end
						if a_eap.item.cmdidx = 258 then
							if (put_line (l_fd, ce_string ("unlet SessionLoad"))) = 0 then
								l_failed := 1
							end
						end
				when 41 then -- if done | if done
						if (put_line (l_fd, ce_string ("%" vim: set ft=vim :"))) = 0 then
							l_failed := 1
						end
						l_failed := (l_failed).bit_or ((fclose (l_fd)))
						if l_failed.to_boolean then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_write))))).do_nothing
						elseif a_eap.item.cmdidx = 258 then
							if (window_inst.vim_FullName (l_fname, l_tbuf, 4096, 0)) = 1 then
								eval_inst.set_vim_var_string (7, l_tbuf, -1)
							end
						end
				when 42 then -- theend:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_browseFile))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_viewFile))
				when 43 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_mkrc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_mkrc)
		end

	vim_mkdir_emsg (a_name___1: CE_POINTER [NATURAL_8]; a_prot: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (mkdir (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), a_prot.to_natural_32)) /= 0 then
				message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E739: Cannot create directory: %%s")))), a_name___1).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 1
			end
		end

	open_exfile (a_fname: CE_POINTER [NATURAL_8]; a_forceit: INTEGER_32; a_mode: CE_POINTER [INTEGER_8]): CE_POINTER [SD_IO_FILE]
		local
			l_fd: CE_POINTER [SD_IO_FILE]
			js: JUMP_STATE
		do
			create l_fd.make

			if (os_unix_inst.mch_isdir (a_fname)).to_boolean then
				message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_isadir2)))), a_fname).do_nothing
				Result := (create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called and then (not a_forceit.to_boolean) then
				if (a_mode[0]).to_integer_32 /= 97 then
					if (misc1_inst.vim_fexists (a_fname)).to_boolean then
						message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E189: %"%%s%" exists (add ! to override)")))), a_fname).do_nothing
						Result := (create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer))
						js.return
					end
				end
			end
			if not js.return_called then
				l_fd.ce_gets (fopen (create {CE_POINTER [INTEGER_8]}.make_cast (a_fname), a_mode))
				if (l_fd.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E190: Cannot open %"%%s%" for writing")))), a_fname).do_nothing
				end
				Result := l_fd
			end
		end

	ex_mark (a_eap: CE_POINTER [PD_EXARG])
		local
			l_pos___3: PD_POS_T
		do
			create l_pos___3.make

			if ((a_eap.item.arg).item).to_integer_32 = 0 then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_argreq))))).do_nothing
			elseif (a_eap.item.arg[1]).to_integer_32 /= 0 then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_trailing))))).do_nothing
			else
				l_pos___3.ce_gets (globals_inst.curwin.item.w_cursor)
				globals_inst.curwin.item.w_cursor.lnum := a_eap.item.line2
				edit_inst.beginline (5)
				if (mark_inst.setmark (((a_eap.item.arg).item).to_integer_32)) = 0 then
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E191: Argument must be a letter or forward/backward quote"))))).do_nothing
				end
				globals_inst.curwin.item.w_cursor := l_pos___3
			end
		end

	ex_mark_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_mark)
		end

	update_topline_cursor
		do
			misc2_inst.check_cursor
			move_inst.update_topline
			if not (globals_inst.curwin.item.w_onebuf_opt.wo_wrap).to_boolean then
				move_inst.validate_cursor
			end
			move_inst.update_curswant
		end

	ex_normal (a_eap: CE_POINTER [PD_EXARG])
		local
			l_save_msg_scroll: INTEGER_32
			l_save_restart_edit: INTEGER_32
			l_save_msg_didout: INTEGER_32
			l_save_State: INTEGER_32
			l_tabuf: PD_TASAVE_T
			l_save_insertmode: INTEGER_32
			l_save_finish_op: INTEGER_32
			l_save_opcount: INTEGER_32
			l_arg: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_tabuf.make
			create l_arg.make
			create l_p___0.make
			create l_tmp___14.make

			l_save_msg_scroll := globals_inst.msg_scroll
			l_save_restart_edit := globals_inst.restart_edit
			l_save_msg_didout := globals_inst.msg_didout
			l_save_State := globals_inst.State
			l_save_insertmode := option_inst.p_im
			l_save_finish_op := globals_inst.finish_op
			l_save_opcount := globals_inst.opcount
			l_arg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			if globals_inst.ex_normal_lock > 0 then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_secure))))).do_nothing
				js.return
			end
			if not js.return_called and then (globals_inst.ex_normal_busy.to_integer_32 >= option_inst.p_mmd) then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E192: Recursive use of :normal too deep"))))).do_nothing
				js.return
			end
			if not js.return_called then
				globals_inst.ex_normal_busy := globals_inst.ex_normal_busy + 1
				globals_inst.msg_scroll := 0
				globals_inst.restart_edit := 0
				option_inst.p_im := 0
				if globals_inst.has_mbyte.to_boolean then
					l_len := 0
					l_p___0.ce_gets (a_eap.item.arg)
					from
					until
						not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0))
					loop
						if (l_p___0.item).to_integer_32 = 155 then
							l_len := l_len + (2)
						end
						l_l := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0])) - 1
						from
						until
							not (l_l > 0)
						loop
							l_p___0.ce_gets (l_p___0 + 1)
							if (l_p___0.item).to_integer_32 = 128 then
								l_len := l_len + (2)
							elseif (l_p___0.item).to_integer_32 = 155 then
								l_len := l_len + (2)
							end
							l_l := l_l - 1
						end
						l_p___0.ce_gets (l_p___0 + 1)
					end
					if l_len > 0 then
						l_arg.ce_gets (misc2_inst.alloc (((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg))) + l_len.to_natural_32) + {NATURAL_32} 1))
						if (l_arg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_len := 0
							l_p___0.ce_gets (a_eap.item.arg)
							from
							until
								not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0))
							loop
								l_tmp___3 := l_len
								l_len := l_len + 1
								l_arg[l_tmp___3] := l_p___0.item
								if (l_p___0.item).to_integer_32 = 155 then
									l_tmp___4 := l_len
									l_len := l_len + 1
									l_arg[l_tmp___4] := (253).to_natural_8
									l_tmp___5 := l_len
									l_len := l_len + 1
									l_arg[l_tmp___5] := (81).to_natural_8
								end
								l_l := (globals_inst.mb_ptr2len.integer_32_item ([l_p___0])) - 1
								from
								until
									not (l_l > 0)
								loop
									l_tmp___7 := l_len
									l_len := l_len + 1
									l_p___0.ce_gets (l_p___0 + 1)
									l_arg[l_tmp___7] := l_p___0.item
									if (l_p___0.item).to_integer_32 = 128 then
										l_tmp___8 := l_len
										l_len := l_len + 1
										l_arg[l_tmp___8] := (254).to_natural_8
										l_tmp___9 := l_len
										l_len := l_len + 1
										l_arg[l_tmp___9] := (('X').code).to_natural_8
									elseif (l_p___0.item).to_integer_32 = 155 then
										l_tmp___10 := l_len
										l_len := l_len + 1
										l_arg[l_tmp___10] := (253).to_natural_8
										l_tmp___11 := l_len
										l_len := l_len + 1
										l_arg[l_tmp___11] := (81).to_natural_8
									end
									l_l := l_l - 1
								end
								l_arg[l_len] := (('%/0/').code).to_natural_8
								l_p___0.ce_gets (l_p___0 + 1)
							end
						end
					end
				end
				getchar_inst.save_typeahead (l_tabuf.address)
				if (l_tabuf.typebuf_valid).to_boolean then
					from
					until
						js.loop_left
					loop
						js.reset
						if a_eap.item.addr_count /= 0 then
							l_tmp___12 := a_eap.item.line1
							a_eap.item.line1 := (a_eap.item.line1) + 1
							globals_inst.curwin.item.w_cursor.lnum := l_tmp___12
							globals_inst.curwin.item.w_cursor.col := 0
						end
						if (a_eap.item.forceit).to_boolean then
							l_tmp___13 := -1
						else
							l_tmp___13 := 0
						end
						if (l_arg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_tmp___14.ce_gets (l_arg)
						else
							l_tmp___14.ce_gets (a_eap.item.arg)
						end
						exec_normal_cmd (l_tmp___14, l_tmp___13, 0)
						if a_eap.item.addr_count > 0 then
							if a_eap.item.line1 <= a_eap.item.line2 then
								if globals_inst.got_int.to_boolean then
									js.break
								end
							else
								js.break
							end
						else
							js.break
						end
					end
					js.reset
				end
				update_topline_cursor
				getchar_inst.restore_typeahead (l_tabuf.address)
				globals_inst.ex_normal_busy := globals_inst.ex_normal_busy - 1
				globals_inst.msg_scroll := l_save_msg_scroll
				globals_inst.restart_edit := l_save_restart_edit
				option_inst.p_im := l_save_insertmode
				globals_inst.finish_op := l_save_finish_op
				globals_inst.opcount := l_save_opcount
				globals_inst.msg_didout := (globals_inst.msg_didout).bit_or (l_save_msg_didout)
				globals_inst.State := l_save_State
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_arg))
			end
		end

	ex_normal_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_normal)
		end

	ex_startinsert (a_eap: CE_POINTER [PD_EXARG])
		local
			js: JUMP_STATE
		do
			if (a_eap.item.forceit).to_boolean then
				misc2_inst.coladvance ((2147483647).to_integer_32).do_nothing
				globals_inst.curwin.item.w_curswant := (2147483647).to_integer_32
				globals_inst.curwin.item.w_set_curswant := 0
			end
			if ((globals_inst.State).bit_and (16)).to_boolean then
				js.return
			end
			if not js.return_called then
				if a_eap.item.cmdidx = 401 then
					globals_inst.restart_edit := ('a').code
				elseif a_eap.item.cmdidx = 403 then
					globals_inst.restart_edit := ('R').code
				else
					globals_inst.restart_edit := ('V').code
				end
				if not (a_eap.item.forceit).to_boolean then
					if a_eap.item.cmdidx = 401 then
						globals_inst.restart_edit := ('i').code
					end
					globals_inst.curwin.item.w_curswant := 0
				end
			end
		end

	ex_startinsert_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_startinsert)
		end

	ex_stopinsert (a_eap: CE_POINTER [PD_EXARG])
		do
			globals_inst.restart_edit := 0
			globals_inst.stop_insert_mode := 1
		end

	ex_stopinsert_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_stopinsert)
		end

	exec_normal_cmd (a_cmd: CE_POINTER [NATURAL_8]; a_remap: INTEGER_32; a_silent: INTEGER_32)
		local
			l_oa: PD_OPARG_S
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_oa.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					ops_inst.clear_oparg (l_oa.address)
					globals_inst.finish_op := 0
					getchar_inst.ins_typebuf (a_cmd, a_remap, 0, 1, a_silent).do_nothing
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 13 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if not ((getchar_inst.stuff_empty).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						if not ((getchar_inst.typebuf_typed).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						js.break
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not (globals_inst.typebuf.tb_len > 0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						if globals_inst.got_int.to_boolean then
							js.break
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						js.break
				when 10 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_pos := -1 + 7 -- goto _L
				when 12 then
						if not js.loop_jumped then
							update_topline_cursor
							normal_inst.normal_cmd (l_oa.address, 0)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 13 then -- loop done
					js.reset
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_checkpath (a_eap: CE_POINTER [PD_EXARG])
		local
			l_tmp: INTEGER_32
		do
			if (a_eap.item.forceit).to_boolean then
				l_tmp := 4
			else
				l_tmp := 1
			end
			search_inst.find_pattern_in_path (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, 0, 0, 0, 3, 1, l_tmp, (1).to_integer_32, 2147483647)
		end

	ex_checkpath_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_checkpath)
		end

	ex_psearch (a_eap: CE_POINTER [PD_EXARG])
		do
			globals_inst.g_do_tagpreview := option_inst.p_pvh.to_integer_32
			ex_findpat (a_eap)
			globals_inst.g_do_tagpreview := 0
		end

	ex_psearch_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_psearch)
		end

	ex_findpat (a_eap: CE_POINTER [PD_EXARG])
		local
			l_whole: INTEGER_32
			l_n: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_action: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_tmp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_whole := 1
					inspect (ex_cmds_inst.cmdnames[a_eap.item.cmdidx].cmd_name[2]).to_integer_32 -- switch 1 head
					when 101 then l_pos := -1 + 1
					when 105 then l_pos := -1 + 2
					when 117 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 101
					if (ex_cmds_inst.cmdnames[a_eap.item.cmdidx].cmd_name[0]).to_integer_32 = 112 then
						l_action := 2
					else
						l_action := 1
					end
					l_pos := -1 + 5 -- switch 1; break
				when 2 then -- switch 1, case 105
					l_action := 4
					l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case 117
					l_action := 2
					l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, default:
					l_action := 3
					l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done:
					l_n := 1
					if (charset_inst.vim_isdigit (((a_eap.item.arg).item).to_integer_32)).to_boolean then
						l_n := charset_inst.getdigits (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (a_eap.c_pointer + {PD_EXARG}.arg_offset))
						a_eap.item.arg := charset_inst.skipwhite (a_eap.item.arg)
					end
					if ((a_eap.item.arg).item).to_integer_32 = 47 then
						l_whole := 0
						a_eap.item.arg := (a_eap.item.arg) + 1
						l_p___0.ce_gets (regexp_inst.skip_regexp (a_eap.item.arg, ('/').code, option_inst.p_magic, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
						if (l_p___0.item).to_boolean then
							l_tmp___0.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___0.item := (('%/0/').code).to_natural_8
							l_p___0.ce_gets (charset_inst.skipwhite (l_p___0))
							if (ends_excmd ((l_p___0.item).to_integer_32)).to_boolean then
								a_eap.item.nextcmd := check_nextcmd (l_p___0)
							else
								a_eap.item.errmsg := globals_inst.e_trailing
							end
						end
					end
					if not (a_eap.item.skip).to_boolean then
						if ((a_eap.item.cmd).item).to_integer_32 = 100 then
							l_tmp___2 := 2
						else
							l_tmp___2 := 1
						end
						search_inst.find_pattern_in_path (a_eap.item.arg, 0, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg))).to_integer_32, l_whole, (not (a_eap.item.forceit).to_boolean).to_integer, l_tmp___2, l_n, l_action, a_eap.item.line1, a_eap.item.line2)
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_findpat_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_findpat)
		end

	ex_ptag (a_eap: CE_POINTER [PD_EXARG])
		do
			globals_inst.g_do_tagpreview := option_inst.p_pvh.to_integer_32
			ex_tag_cmd (a_eap, ex_cmds_inst.cmdnames[a_eap.item.cmdidx].cmd_name + 1)
		end

	ex_ptag_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_ptag)
		end

	ex_pedit (a_eap: CE_POINTER [PD_EXARG])
		local
			l_curwin_save: CE_POINTER [PD_WINDOW_S]
		do
			create l_curwin_save.make

			l_curwin_save.ce_gets (globals_inst.curwin)
			globals_inst.g_do_tagpreview := option_inst.p_pvh.to_integer_32
			ex_cmds_inst.prepare_tagpreview (1).do_nothing
			globals_inst.keep_help_flag := (l_curwin_save.item.w_buffer).item.b_help
			do_exedit (a_eap, create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
			globals_inst.keep_help_flag := 0
			if (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 /= (l_curwin_save.c_pointer.to_integer_32).to_natural_32 then
				if (window_inst.win_valid (l_curwin_save)).to_boolean then
					move_inst.validate_cursor
					screen_inst.redraw_later (10)
					window_inst.win_enter (l_curwin_save, 1)
				end
			end
			globals_inst.g_do_tagpreview := 0
		end

	ex_pedit_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_pedit)
		end

	ex_stag (a_eap: CE_POINTER [PD_EXARG])
		do
			globals_inst.postponed_split := -1
			globals_inst.postponed_split_flags := globals_inst.cmdmod.split
			globals_inst.postponed_split_tab := globals_inst.cmdmod.tab
			ex_tag_cmd (a_eap, ex_cmds_inst.cmdnames[a_eap.item.cmdidx].cmd_name + 1)
			globals_inst.postponed_split_flags := 0
			globals_inst.postponed_split_tab := 0
		end

	ex_stag_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_stag)
		end

	ex_tag (a_eap: CE_POINTER [PD_EXARG])
		do
			ex_tag_cmd (a_eap, ex_cmds_inst.cmdnames[a_eap.item.cmdidx].cmd_name)
		end

	ex_tag_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_tag)
		end

	ex_tag_cmd (a_eap: CE_POINTER [PD_EXARG]; a_name___1: CE_POINTER [NATURAL_8])
		local
			l_cmd: INTEGER_32
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect (a_name___1[1]).to_integer_32 -- switch 1 head
					when 106 then l_pos := -1 + 1
					when 115 then l_pos := -1 + 2
					when 112 then l_pos := -1 + 3
					when 78 then l_pos := -1 + 4
					when 110 then l_pos := -1 + 5
					when 111 then l_pos := -1 + 6
					when 102 then l_pos := -1 + 7
					when 114 then l_pos := -1 + 7
					when 108 then l_pos := -1 + 8
					else l_pos := -1 + 9
					end
				when 1 then -- switch 1, case 106
					l_cmd := 9
					l_pos := -1 + 10 -- switch 1; break
				when 2 then -- switch 1, case 115
					l_cmd := 7
					l_pos := -1 + 10 -- switch 1; break
				when 3 then -- switch 1, case 112
					l_cmd := 4
					l_pos := -1 + 10 -- switch 1; break
				when 4 then -- switch 1, case 78
					l_cmd := 4
					l_pos := -1 + 10 -- switch 1; break
				when 5 then -- switch 1, case 110
					l_cmd := 3
					l_pos := -1 + 10 -- switch 1; break
				when 6 then -- switch 1, case 111
					l_cmd := 2
					l_pos := -1 + 10 -- switch 1; break
				when 7 then -- switch 1, case 102 | switch 1, case 114
					l_cmd := 5
					l_pos := -1 + 10 -- switch 1; break
				when 8 then -- switch 1, case 108
					l_cmd := 6
					l_pos := -1 + 10 -- switch 1; break
				when 9 then -- switch 1, default:
					l_cmd := 1
					l_pos := -1 + 10 -- switch 1; break
				when 10 then -- switch 1, done:
					if (a_name___1[0]).to_integer_32 = 108 then
						l_cmd := 11
					end
					if a_eap.item.addr_count > 0 then
						l_tmp := (a_eap.item.line2).to_integer_32
					else
						l_tmp := 1
					end
					tag_inst.do_tag (a_eap.item.arg, l_cmd, l_tmp, a_eap.item.forceit, 1).do_nothing
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	find_cmdline_var (a_src: CE_POINTER [NATURAL_8]; a_usedlen: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (l_i___0 < ((Pointer_bytes.to_natural_32 * (10).to_natural_32) // Pointer_bytes.to_natural_32).to_integer_32))
			loop
				l_len := (strlen (spec_str[l_i___0])).to_integer_32
				if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_src), spec_str[l_i___0], l_len.to_natural_32)) = 0 then
					a_usedlen.item := l_len
					Result := l_i___0
					js.return
				end
				if not js.return_called then
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	eval_vars (a_src: CE_POINTER [NATURAL_8]; a_srcstart: CE_POINTER [NATURAL_8]; a_usedlen: CE_POINTER [INTEGER_32]; a_lnump: CE_POINTER [INTEGER_32]; a_errormsg: CE_POINTER [CE_POINTER [NATURAL_8]]; a_escaped: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		local
			l_i___0: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_result___2: CE_POINTER [NATURAL_8]
			l_resultbuf: CE_POINTER [NATURAL_8]
			l_resultlen: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_valid: INTEGER_32
			l_spec_idx: INTEGER_32
			l_skip_mod: INTEGER_32
			l_strbuf: CE_ARRAY [NATURAL_8]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_result___2.make
			create l_resultbuf.make
			create l_buf___6.make
			create l_strbuf.make (<<30>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_resultbuf.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_valid := 3
					l_skip_mod := 0
					a_errormsg.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					if (a_escaped.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						a_escaped.item := 0
					end
					l_spec_idx := find_cmdline_var (a_src, a_usedlen)
					if l_spec_idx < 0 then
						a_usedlen.item := 1
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called and then ((a_src.c_pointer.to_integer_32).to_natural_32 > (a_srcstart.c_pointer.to_integer_32).to_natural_32) then
						if (a_src[-1]).to_integer_32 = 92 then
							a_usedlen.item := 0
							memmove (create {CE_POINTER [ANY]}.make_cast ((a_src - 1)), create {CE_POINTER [ANY]}.make_cast (a_src), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_src))) + {NATURAL_32} 1).do_nothing
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 18 -- skip if block
					end
				when 1 then -- if:
						if l_spec_idx /= 2 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 4 then -- else:
						if l_spec_idx /= 3 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						if l_spec_idx = 2 then
							l_tmp___0 := 3
						else
							l_tmp___0 := 2
						end
						l_resultlen := normal_inst.find_ident_under_cursor (l_result___2.address, l_tmp___0)
						if l_resultlen = 0 then
							a_errormsg.item := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 7 then -- else:
						inspect l_spec_idx -- switch 1 head
						when 0 then l_pos := -1 + 8
						when 1 then l_pos := -1 + 9
						when 4 then l_pos := -1 + 11
						when 6 then l_pos := -1 + 12
						when 7 then l_pos := -1 + 13
						when 8 then l_pos := -1 + 14
						when 5 then l_pos := -1 + 15
						when 9 then l_pos := -1 + 16
						else l_pos := -1 + 17
						end
				when 8 then -- switch 1, case 0
						if ((globals_inst.curbuf.item.b_fname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_result___2.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
							l_valid := 0
						else
							l_result___2.ce_gets (globals_inst.curbuf.item.b_fname)
						end
						l_pos := -1 + 17 -- switch 1; break
				when 9 then -- switch 1, case 1
						if (a_src[1]).to_integer_32 = 35 then
							l_result___2.ce_gets (arg_all)
							l_resultbuf.ce_gets (l_result___2)
							a_usedlen.item := 2
							if (a_escaped.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								a_escaped.item := 1
							end
							l_skip_mod := 1
							l_pos := -1 + 17 -- switch 1; break
						end
				when 10 then
						l_s.ce_gets (a_src + 1)
						if (l_s.item).to_integer_32 = 60 then
							l_s.ce_gets (l_s + 1)
						end
						l_i___0 := (charset_inst.getdigits (l_s.address)).to_integer_32
						a_usedlen.item := l_s.distance (a_src)
						if (a_src[1]).to_integer_32 = 60 then
							if a_usedlen.item < 2 then
								a_usedlen.item := 1
								Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								js.return
							end
							if not js.return_called then
								l_result___2.ce_gets (eval_inst.list_find_str ((eval_inst.get_vim_var_list (54)), l_i___0.to_integer_32))
								if (l_result___2.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									a_errormsg.item := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
									Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
									js.return
								end
							end
						else
							l_buf___6.ce_gets (buffer_inst.buflist_findnr (l_i___0))
							if (l_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								a_errormsg.item := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E194: No alternate file name to substitute for %'#%'"))))
								Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								js.return
							end
							if not js.return_called then
								if (a_lnump.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									a_lnump.item := (-1).to_integer_32
								end
								if ((l_buf___6.item.b_fname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_result___2.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
									l_valid := 0
								else
									l_result___2.ce_gets (l_buf___6.item.b_fname)
								end
							end
						end
						l_pos := -1 + 17 -- switch 1; break
				when 11 then -- switch 1, case 4
						l_result___2.ce_gets (window_inst.file_name_at_cursor (5, 1, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
						if (l_result___2.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							a_errormsg.item := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called then
							l_resultbuf.ce_gets (l_result___2)
						end
						l_pos := -1 + 17 -- switch 1; break
				when 12 then -- switch 1, case 6
						l_result___2.ce_gets (globals_inst.autocmd_fname)
						if (l_result___2.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if not globals_inst.autocmd_fname_full.to_boolean then
								globals_inst.autocmd_fname_full := 1
								l_result___2.ce_gets (misc1_inst.FullName_save (globals_inst.autocmd_fname, 0))
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.autocmd_fname))
								globals_inst.autocmd_fname.ce_gets (l_result___2)
							end
						end
						if (l_result___2.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							a_errormsg.item := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E495: no autocommand file name to substitute for %"<afile>%""))))
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called then
							l_result___2.ce_gets (fileio_inst.shorten_fname1 (l_result___2))
						end
						l_pos := -1 + 17 -- switch 1; break
				when 13 then -- switch 1, case 7
						if globals_inst.autocmd_bufnr <= 0 then
							a_errormsg.item := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E496: no autocommand buffer number to substitute for %"<abuf>%""))))
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called then
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_strbuf), ce_string ("%%d"), globals_inst.autocmd_bufnr]).do_nothing
							l_result___2.ce_gets (l_strbuf)
						end
						l_pos := -1 + 17 -- switch 1; break
				when 14 then -- switch 1, case 8
						l_result___2.ce_gets (globals_inst.autocmd_match)
						if (l_result___2.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							a_errormsg.item := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E497: no autocommand match name to substitute for %"<amatch>%""))))
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
						l_pos := -1 + 17 -- switch 1; break
				when 15 then -- switch 1, case 5
						l_result___2.ce_gets (globals_inst.sourcing_name)
						if (l_result___2.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							a_errormsg.item := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E498: no :source file name to substitute for %"<sfile>%""))))
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
						l_pos := -1 + 17 -- switch 1; break
				when 16 then -- switch 1, case 9
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_strbuf), ce_string ("0x%%lx"), globals_inst.clientWindow]).do_nothing
						l_result___2.ce_gets (l_strbuf)
						l_pos := -1 + 17 -- switch 1; break
				when 17 then -- switch 1, done:
						if not js.return_called then
							l_resultlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_result___2))).to_integer_32
							if (a_src[a_usedlen.item]).to_integer_32 = 60 then
								a_usedlen.item := (a_usedlen.item) + 1
								l_s.ce_gets (misc2_inst.vim_strrchr (l_result___2, ('.').code))
								if (l_s.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if (l_s.c_pointer.to_integer_32).to_natural_32 >= ((misc1_inst.gettail (l_result___2)).c_pointer.to_integer_32).to_natural_32 then
										l_resultlen := l_s.distance (l_result___2)
									end
								end
							elseif not l_skip_mod.to_boolean then
								l_valid := (l_valid).bit_or ((eval_inst.modify_fname (a_src, a_usedlen, l_result___2.address, l_resultbuf.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_resultlen))))
								if (l_result___2.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									a_errormsg.item := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
									Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
									js.return
								end
							end
						end
				when 18 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 27 -- skip if block
						end
				when 19 then -- if:
							if l_resultlen /= 0 then
								l_pos := -1 + 22 -- skip if block
							end
				when 20 then -- if:
							l_pos := -1 + 23 -- goto _L___0
				when 21 then -- if block done, skip else block:
							l_pos := -1 + 26
				when 22 then -- else:
							if l_valid = 3 then
								l_pos := -1 + 25 -- skip if block
							end
				when 23 then -- if: | _L___0:
							if l_valid /= 3 then
								a_errormsg.item := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E499: Empty file name for %'%%%' or %'#%', only works with %":p:h%""))))
							else
								a_errormsg.item := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E500: Evaluates to an empty string"))))
							end
							l_result___2.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				when 24 then -- if block done, skip else block:
							l_pos := -1 + 26
				when 25 then -- else:
							l_result___2.ce_gets (misc2_inst.vim_strnsave (l_result___2, l_resultlen))
				when 26 then -- if done
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_resultbuf))
							Result := l_result___2
				when 27 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	arg_all: CE_POINTER [NATURAL_8]
		local
			l_len: INTEGER_32
			l_idx: INTEGER_32
			l_retval: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_retval.make
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_retval.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 15 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_len := 0
						l_idx := 0
				when 3 then -- loop condition:
						if not (not js.loop_left and then (l_idx < (globals_inst.curwin.item.w_alist).item.al_ga.ga_len)) then
							l_pos := -1 + 14 -- skip loop
						end
				when 4 then -- loop body:
						l_p___0.ce_gets (buffer_inst.alist_name (create {CE_POINTER [PD_ARGENTRY]}.make_cast ((globals_inst.curwin.item.w_alist).item.al_ga.ga_data) + l_idx))
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 13 -- skip if block
						end
				when 5 then -- if:
						if l_len > 0 then
							if (l_retval.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_retval[l_len] := ((' ').code).to_natural_8
							end
							l_len := l_len + 1
						end
				when 6 then -- loop condition:
						if (l_p___0.item).to_integer_32 = 0 then
							l_pos := -1 + 13 -- skip loop
						end
				when 7 then -- loop body:
						if (l_p___0.item).to_integer_32 /= 32 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else:
						if (l_p___0.item).to_integer_32 /= 92 then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L:
						if (l_retval.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_retval[l_len] := (('\').code).to_natural_8
						end
						l_len := l_len + 1
				when 12 then -- if done
						if (l_retval.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_retval[l_len] := l_p___0.item
						end
						l_len := l_len + 1
						l_p___0.ce_gets (l_p___0 + 1)
						l_pos := -1 + 6 -- back to loop condition
				when 13 then -- loop done | if done
						l_idx := l_idx + 1
						l_pos := -1 + 3 -- back to loop condition
				when 14 then -- loop done
						if (l_retval.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_retval[l_len] := (('%/0/').code).to_natural_8
							js.break
						end
						if not js.loop_jumped then
							l_retval.ce_gets (misc2_inst.alloc (l_len.to_natural_32 + {NATURAL_32} 1))
							if (l_retval.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.break
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 15 then -- loop done
					js.reset
					Result := l_retval
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	expand_sfile (a_arg: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_errormsg: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_result___2: CE_POINTER [NATURAL_8]
			l_newres: CE_POINTER [NATURAL_8]
			l_repl: CE_POINTER [NATURAL_8]
			l_srclen: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_errormsg.make
			create l_result___2.make
			create l_newres.make
			create l_repl.make
			create l_p___0.make

			l_result___2.ce_gets (misc2_inst.vim_strsave (a_arg))
			if (l_result___2.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_p___0.ce_gets (l_result___2)
				from
				until
					not (not js.loop_left and then ((l_p___0.item).to_boolean))
				loop
					js.reset
					if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("<sfile>"), (7).to_natural_32)) /= 0 then
						l_p___0.ce_gets (l_p___0 + 1)
					else
						l_repl.ce_gets (eval_vars (l_p___0, l_result___2, create {CE_POINTER [INTEGER_32]}.make_shared ($l_srclen), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_errormsg.address, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
						if (l_errormsg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (l_errormsg.item).to_boolean then
								message_inst.emsg (l_errormsg).do_nothing
							end
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_result___2))
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called then
							if (l_repl.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_p___0.ce_gets (l_p___0 + l_srclen)
								js.continue
							end
							if not js.loop_jumped then
								l_tmp := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_result___2))
								l_len := ((l_tmp.to_integer_32 - l_srclen) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_repl))).to_integer_32) + 1
								l_newres.ce_gets (misc2_inst.alloc (l_len.to_natural_32))
								if (l_newres.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_repl))
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_result___2))
									Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
									js.return
								end
								if not js.return_called then
									memmove (create {CE_POINTER [ANY]}.make_cast (l_newres), create {CE_POINTER [ANY]}.make_cast (l_result___2), (l_p___0.distance (l_result___2)).to_natural_32).do_nothing
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_newres + (l_p___0.distance (l_result___2)))), create {CE_POINTER [INTEGER_8]}.make_cast (l_repl)).do_nothing
									l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_newres))).to_integer_32
									strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_newres), create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + l_srclen))).do_nothing
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_repl))
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_result___2))
									l_result___2.ce_gets (l_newres)
									l_p___0.ce_gets (l_newres + l_len)
								end
							end
						end
					end
					if not js.loop_left then
						
					end
				end
			end
			if not js.return_called then
				Result := l_result___2
			end
		end

	makeopens (a_fd: CE_POINTER [SD_IO_FILE]; a_dirnow: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_only_save_windows: INTEGER_32
			l_nr: INTEGER_32
			l_cnr: INTEGER_32
			l_restore_size: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_sname: CE_POINTER [NATURAL_8]
			l_edited_win: CE_POINTER [PD_WINDOW_S]
			l_tabnr: INTEGER_32
			l_tab_firstwin: CE_POINTER [PD_WINDOW_S]
			l_tab_topframe: CE_POINTER [PD_FRAME_S]
			l_cur_arg_idx: INTEGER_32
			l_next_arg_idx: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___11: INTEGER_32
			l_x___0: INTEGER_32
			l_y: INTEGER_32
			l_need_tabnew: INTEGER_32
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_tmp___21: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___6.make
			create l_wp___0.make
			create l_sname.make
			create l_edited_win.make
			create l_tab_firstwin.make
			create l_tab_topframe.make
			create l_tmp___3.make
			create l_tp.make
			create l_tmp___21.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_only_save_windows := 1
					l_cnr := 1
					l_restore_size := 1
					l_edited_win.ce_gets (create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
					l_cur_arg_idx := 0
					l_next_arg_idx := 0
					if ((option_inst.ssop_flags).bit_and ({NATURAL_32} 1)).to_boolean then
						l_only_save_windows := 0
					end
					if (put_line (a_fd, ce_string ("let v:this_session=expand(%"<sfile>:p%")"))) = 0 then
						Result := 0
						js.return
					end
					if not js.return_called and then (((option_inst.ssop_flags).bit_and ({NATURAL_32} 256)).to_boolean) then
						if (eval_inst.store_session_globals (a_fd)) = 0 then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						if (put_line (a_fd, ce_string ("silent only"))) = 0 then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						if ((option_inst.ssop_flags).bit_and ({NATURAL_32} 2048)).to_boolean then
							if (put_line (a_fd, ce_string ("exe %"cd %" . escape(expand(%"<sfile>:p:h%"), %' %')"))) = 0 then
								Result := 0
								js.return
							end
						elseif ((option_inst.ssop_flags).bit_and ({NATURAL_32} 4096)).to_boolean then
							if (globals_inst.globaldir.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_tmp___3.ce_gets (globals_inst.globaldir)
							else
								l_tmp___3.ce_gets (a_dirnow)
							end
							l_sname.ce_gets (misc1_inst.home_replace_save (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_tmp___3))
							if (l_sname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_sname))
								Result := 0
								js.return
							elseif (fputs (ce_string ("cd "), a_fd)) < 0 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_sname))
								Result := 0
								js.return
							elseif (ses_put_fname (a_fd, l_sname, option_inst.ssop_flags_address)) = 0 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_sname))
								Result := 0
								js.return
							elseif (put_eol (a_fd)) = 0 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_sname))
								Result := 0
								js.return
							end
							if not js.return_called then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_sname))
							end
						end
					end
					if not js.return_called then
						if (put_line (a_fd, ce_string ("if expand(%'%%%') == %'%' && !&modified && line(%'$%') <= 1 && getline(1) == %'%'"))) = 0 then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						if (put_line (a_fd, ce_string ("  let s:wipebuf = bufnr(%'%%%')"))) = 0 then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						if (put_line (a_fd, ce_string ("endif"))) = 0 then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						if (put_line (a_fd, ce_string ("set shortmess=aoO"))) = 0 then
							Result := 0
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						l_buf___6.ce_gets (globals_inst.firstbuf)
				when 2 then -- loop condition:
						if not (not js.loop_left and then ((l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 3 then -- loop body:
						if not (l_only_save_windows.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_buf___6.item.b_nwindows /= 0 then
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else: | _L___0:
						if not ((l_buf___6.item.b_help).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if ((option_inst.ssop_flags).bit_and ({NATURAL_32} 64)).to_boolean then
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if ((l_buf___6.item.b_fname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (l_buf___6.item.b_p_bl).to_boolean then
								if ((l_buf___6.item.b_wininfo).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_tmp___11 := 1
								else
									l_tmp___11 := (l_buf___6.item.b_wininfo).item.wi_fpos.lnum
								end
								if (fprintf ([a_fd, ce_string ("badd +%%ld "), l_tmp___11])) < 0 then
									Result := 0
									js.return
								elseif (ses_fname (a_fd, l_buf___6, option_inst.ssop_flags_address)) = 0 then
									Result := 0
									js.return
								end
							end
						end
				when 10 then -- if done
						if not js.return_called then
							l_buf___6.ce_gets (l_buf___6.item.b_next)
						end
						l_pos := -1 + 2 -- back to loop condition
				when 11 then -- loop done | if done
						if not js.return_called then
							if (ses_arglist (a_fd, ce_string ("args"), create {CE_POINTER [PD_GROWARRAY]}.make_shared (globals_inst.global_alist.c_pointer + {PD_ARGLIST}.al_ga_offset), (not ((option_inst.ssop_flags).bit_and ({NATURAL_32} 4096)).to_boolean).to_integer, option_inst.ssop_flags_address)) = 0 then
								Result := 0
								js.return
							end
						end
						if not js.return_called and then (((option_inst.ssop_flags).bit_and ({NATURAL_32} 4)).to_boolean) then
							if (fprintf ([a_fd, ce_string ("set lines=%%ld columns=%%ld"), globals_inst.Rows, globals_inst.Columns])) < 0 then
								Result := 0
								js.return
							elseif (put_eol (a_fd)) = 0 then
								Result := 0
								js.return
							end
						end
						if not js.return_called and then ((gui_inst.gui.in_use).to_boolean) then
							if ((option_inst.ssop_flags).bit_and ({NATURAL_32} 2)).to_boolean then
								if (gui_gtk_x11_inst.gui_mch_get_winpos (create {CE_POINTER [INTEGER_32]}.make_shared ($l_x___0), create {CE_POINTER [INTEGER_32]}.make_shared ($l_y))) = 1 then
									if (fprintf ([a_fd, ce_string ("winpos %%d %%d"), l_x___0, l_y])) < 0 then
										Result := 0
										js.return
									elseif (put_eol (a_fd)) = 0 then
										Result := 0
										js.return
									end
								end
							end
						end
						if not js.return_called then
							l_tab_firstwin.ce_gets (globals_inst.firstwin)
							l_tab_topframe.ce_gets (globals_inst.topframe)
							l_tabnr := 1
							from
							until
								js.loop_left
							loop
								js.reset
								l_need_tabnew := 0
								if ((option_inst.ssop_flags).bit_and ({NATURAL_32} 32768)).to_boolean then
									l_tp.ce_gets ((window_inst.find_tabpage (l_tabnr)))
									if (l_tp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										js.break
									end
									if not js.loop_jumped then
										if (l_tp.c_pointer.to_integer_32).to_natural_32 = (globals_inst.curtab.c_pointer.to_integer_32).to_natural_32 then
											l_tab_firstwin.ce_gets (globals_inst.firstwin)
											l_tab_topframe.ce_gets (globals_inst.topframe)
										else
											l_tab_firstwin.ce_gets (l_tp.item.tp_firstwin)
											l_tab_topframe.ce_gets (l_tp.item.tp_topframe)
										end
										if l_tabnr > 1 then
											l_need_tabnew := 1
										end
									end
								end
								if not js.loop_jumped then
									l_wp___0.ce_gets (l_tab_firstwin)
									from
									until
										not (not js.loop_left and then ((l_wp___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
									loop
										js.reset
										if (ses_do_win (l_wp___0)).to_boolean then
											if (((l_wp___0.item.w_buffer).item.b_ffname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
												if not ((l_wp___0.item.w_buffer).item.b_help).to_boolean then
													if not (quickfix_inst.bt_nofile (l_wp___0.item.w_buffer)).to_boolean then
														if l_need_tabnew.to_boolean then
															l_tmp___21.ce_gets (ce_string ("tabedit "))
														else
															l_tmp___21.ce_gets (ce_string ("edit "))
														end
														if (fputs (l_tmp___21, a_fd)) < 0 then
															Result := 0
															js.return
														elseif (ses_fname (a_fd, l_wp___0.item.w_buffer, option_inst.ssop_flags_address)) = 0 then
															Result := 0
															js.return
														end
														if not js.return_called then
															l_need_tabnew := 0
															if not (l_wp___0.item.w_arg_idx_invalid).to_boolean then
																l_edited_win.ce_gets (l_wp___0)
															end
															js.break
														end
													end
												end
											end
										end
										if not js.loop_jumped then
											l_wp___0.ce_gets (l_wp___0.item.w_next)
										end
									end
									js.reset
									if not js.return_called and then (l_need_tabnew.to_boolean) then
										if (put_line (a_fd, ce_string ("tabnew"))) = 0 then
											Result := 0
											js.return
										end
									end
									if not js.return_called then
										if (put_line (a_fd, ce_string ("set splitbelow splitright"))) = 0 then
											Result := 0
											js.return
										end
									end
									if not js.return_called then
										if (ses_win_rec (a_fd, l_tab_topframe)) = 0 then
											Result := 0
											js.return
										end
									end
									if not js.return_called and then (not option_inst.p_sb.to_boolean) then
										if (put_line (a_fd, ce_string ("set nosplitbelow"))) = 0 then
											Result := 0
											js.return
										end
									end
									if not js.return_called and then (not option_inst.p_spr.to_boolean) then
										if (put_line (a_fd, ce_string ("set nosplitright"))) = 0 then
											Result := 0
											js.return
										end
									end
									if not js.return_called then
										l_nr := 0
										l_wp___0.ce_gets (l_tab_firstwin)
										from
										until
											(l_wp___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
										loop
											if (ses_do_win (l_wp___0)).to_boolean then
												l_nr := l_nr + 1
											else
												l_restore_size := 0
											end
											if (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 = (l_wp___0.c_pointer.to_integer_32).to_natural_32 then
												l_cnr := l_nr
											end
											l_wp___0.ce_gets (l_wp___0.item.w_next)
										end
										if (put_line (a_fd, ce_string ("wincmd t"))) = 0 then
											Result := 0
											js.return
										end
									end
									if not js.return_called then
										if (put_line (a_fd, ce_string ("set winheight=1 winwidth=1"))) = 0 then
											Result := 0
											js.return
										end
									end
									if not js.return_called and then (l_nr > 1) then
										if (ses_winsizes (a_fd, l_restore_size, l_tab_firstwin)) = 0 then
											Result := 0
											js.return
										end
									end
									if not js.return_called then
										l_wp___0.ce_gets (l_tab_firstwin)
										from
										until
											not (not js.loop_left and then ((l_wp___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
										loop
											js.reset
											if not (ses_do_win (l_wp___0)).to_boolean then
												js.continue
											end
											if not js.loop_jumped then
												if (put_view (a_fd, l_wp___0, ((l_wp___0.c_pointer.to_integer_32).to_natural_32 /= (l_edited_win.c_pointer.to_integer_32).to_natural_32).to_integer, option_inst.ssop_flags_address, l_cur_arg_idx)) = 0 then
													Result := 0
													js.return
												end
												if not js.return_called and then (l_nr > 1) then
													if (put_line (a_fd, ce_string ("wincmd w"))) = 0 then
														Result := 0
														js.return
													end
												end
												if not js.return_called then
													l_next_arg_idx := l_wp___0.item.w_arg_idx
												end
											end
											if not js.loop_left then
												l_wp___0.ce_gets (l_wp___0.item.w_next)
											end
										end
									end
									if not js.return_called then
										l_cur_arg_idx := l_next_arg_idx
										if l_cnr > 1 then
											if (fprintf ([a_fd, ce_string ("%%dwincmd w"), l_cnr])) < 0 then
												Result := 0
												js.return
											elseif (put_eol (a_fd)) = 0 then
												Result := 0
												js.return
											end
										end
									end
									if not js.return_called and then (l_nr > 1) then
										if (ses_winsizes (a_fd, l_restore_size, l_tab_firstwin)) = 0 then
											Result := 0
											js.return
										end
									end
									if not js.return_called then
										if not ((option_inst.ssop_flags).bit_and ({NATURAL_32} 32768)).to_boolean then
											js.break
										end
										if not js.loop_jumped then
											l_tabnr := l_tabnr + 1
										end
									end
								end
							end
							js.reset
						end
						if not js.return_called and then (((option_inst.ssop_flags).bit_and ({NATURAL_32} 32768)).to_boolean) then
							if (fprintf ([a_fd, ce_string ("tabnext %%d"), (window_inst.tabpage_index (globals_inst.curtab))])) < 0 then
								Result := 0
								js.return
							elseif (put_eol (a_fd)) = 0 then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							if (put_line (a_fd, ce_string ("if exists(%'s:wipebuf%')"))) = 0 then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							if (put_line (a_fd, ce_string ("  silent exe %'bwipe %' . s:wipebuf"))) = 0 then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							if (put_line (a_fd, ce_string ("endif"))) = 0 then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							if (put_line (a_fd, ce_string ("unlet! s:wipebuf"))) = 0 then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							if (fprintf ([a_fd, ce_string ("set winheight=%%ld winwidth=%%ld shortmess=%%s"), option_inst.p_wh, option_inst.p_wiw, option_inst.p_shm])) < 0 then
								Result := 0
								js.return
							elseif (put_eol (a_fd)) = 0 then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							if (put_line (a_fd, ce_string ("let s:sx = expand(%"<sfile>:p:r%").%"x.vim%""))) = 0 then
								Result := 0
								js.return
							elseif (put_line (a_fd, ce_string ("if file_readable(s:sx)"))) = 0 then
								Result := 0
								js.return
							elseif (put_line (a_fd, ce_string ("  exe %"source %" . fnameescape(s:sx)"))) = 0 then
								Result := 0
								js.return
							elseif (put_line (a_fd, ce_string ("endif"))) = 0 then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							Result := 1
						end
				when 12 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ses_winsizes (a_fd: CE_POINTER [SD_IO_FILE]; a_restore_size: INTEGER_32; a_tab_firstwin: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			l_n: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_wp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_n := 0
					if not (a_restore_size.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if ((option_inst.ssop_flags).bit_and ({NATURAL_32} 8)).to_boolean then
							l_wp___0.ce_gets (a_tab_firstwin)
							from
							until
								not (not js.loop_left and then ((l_wp___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
							loop
								js.reset
								if not (ses_do_win (l_wp___0)).to_boolean then
									js.continue
								end
								if not js.loop_jumped then
									l_n := l_n + 1
									if l_wp___0.item.w_height + l_wp___0.item.w_status_height < globals_inst.topframe.item.fr_height then
										if (fprintf ([a_fd, ce_string ("exe %'%%dresize %' . ((&lines * %%ld + %%ld) / %%ld)"), l_n, (l_wp___0.item.w_height).to_integer_32, globals_inst.Rows // 2, globals_inst.Rows])) < 0 then
											Result := 0
											js.return
										elseif (put_eol (a_fd)) = 0 then
											Result := 0
											js.return
										end
									end
									if not js.return_called and then ((l_wp___0.item.w_width).to_integer_32 < globals_inst.Columns) then
										if (fprintf ([a_fd, ce_string ("exe %'vert %%dresize %' . ((&columns * %%ld + %%ld) / %%ld)"), l_n, (l_wp___0.item.w_width).to_integer_32, globals_inst.Columns // 2, globals_inst.Columns])) < 0 then
											Result := 0
											js.return
										elseif (put_eol (a_fd)) = 0 then
											Result := 0
											js.return
										end
									end
								end
								if not js.loop_left then
									l_wp___0.ce_gets (l_wp___0.item.w_next)
								end
							end
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if (put_line (a_fd, ce_string ("wincmd ="))) = 0 then
							Result := 0
							js.return
						end
				when 4 then
					if not js.return_called then
						Result := 1
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ses_win_rec (a_fd: CE_POINTER [SD_IO_FILE]; a_fr: CE_POINTER [PD_FRAME_S]): INTEGER_32
		local
			l_frc: CE_POINTER [PD_FRAME_S]
			l_count___2: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_frc.make
			create l_tmp___0.make
			create l_tmp___2.make

			l_count___2 := 0
			if (a_fr.item.fr_layout).to_integer_32 /= 0 then
				l_frc.ce_gets (ses_skipframe (a_fr.item.fr_child))
				if (l_frc.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						l_frc.ce_gets (ses_skipframe (l_frc.item.fr_next))
						if (l_frc.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						end
						if not js.loop_jumped then
							if (put_line (a_fd, ce_string ("wincmd _ | wincmd |"))) = 0 then
								Result := 0
								js.return
							else
								if (a_fr.item.fr_layout).to_integer_32 = 2 then
									l_tmp___0.ce_gets (ce_string ("split"))
								else
									l_tmp___0.ce_gets (ce_string ("vsplit"))
								end
								if (put_line (a_fd, l_tmp___0)) = 0 then
									Result := 0
									js.return
								end
							end
							if not js.return_called then
								l_count___2 := l_count___2 + 1
							end
						end
					end
					js.reset
				end
				if not js.return_called and then (l_count___2 > 0) then
					if (a_fr.item.fr_layout).to_integer_32 = 2 then
						l_tmp___2.ce_gets (ce_string ("%%dwincmd k"))
					else
						l_tmp___2.ce_gets (ce_string ("%%dwincmd h"))
					end
					if (fprintf ([a_fd, l_tmp___2, l_count___2])) < 0 then
						Result := 0
						js.return
					elseif (put_eol (a_fd)) = 0 then
						Result := 0
						js.return
					end
				end
				if not js.return_called then
					l_frc.ce_gets (ses_skipframe (a_fr.item.fr_child))
					from
					until
						not (not js.loop_left and then ((l_frc.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
					loop
						ses_win_rec (a_fd, l_frc).do_nothing
						l_frc.ce_gets (ses_skipframe (l_frc.item.fr_next))
						if (l_frc.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (put_line (a_fd, ce_string ("wincmd w"))) = 0 then
								Result := 0
								js.return
							end
						end
					end
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	ses_skipframe (a_fr: CE_POINTER [PD_FRAME_S]): CE_POINTER [PD_FRAME_S]
		local
			l_frc: CE_POINTER [PD_FRAME_S]
			js: JUMP_STATE
		do
			create l_frc.make

			l_frc.ce_gets (a_fr)
			from
			until
				not (not js.loop_left and then ((l_frc.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				js.reset
				if (ses_do_frame (l_frc)).to_boolean then
					js.break
				end
				if not js.loop_jumped then
					l_frc.ce_gets (l_frc.item.fr_next)
				end
			end
			js.reset
			Result := l_frc
		end

	ses_do_frame (a_fr: CE_POINTER [PD_FRAME_S]): INTEGER_32
		local
			l_frc: CE_POINTER [PD_FRAME_S]
			js: JUMP_STATE
		do
			create l_frc.make

			if (a_fr.item.fr_layout).to_integer_32 = 0 then
				Result := (ses_do_win (a_fr.item.fr_win))
				js.return
			end
			if not js.return_called then
				l_frc.ce_gets (a_fr.item.fr_child)
				from
				until
					not (not js.loop_left and then ((l_frc.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
				loop
					if (ses_do_frame (l_frc)).to_boolean then
						Result := 1
						js.return
					end
					if not js.return_called then
						l_frc.ce_gets (l_frc.item.fr_next)
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	ses_do_win (a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (((a_wp___0.item.w_buffer).item.b_fname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := ((option_inst.ssop_flags).bit_and ({NATURAL_32} 128)).to_integer_32
				js.return
			elseif (quickfix_inst.bt_nofile (a_wp___0.item.w_buffer)).to_boolean then
				Result := ((option_inst.ssop_flags).bit_and ({NATURAL_32} 128)).to_integer_32
				js.return
			end
			if not js.return_called and then (((a_wp___0.item.w_buffer).item.b_help).to_boolean) then
				Result := ((option_inst.ssop_flags).bit_and ({NATURAL_32} 64)).to_integer_32
				js.return
			end
			if not js.return_called then
				Result := 1
			end
		end

	put_view (a_fd: CE_POINTER [SD_IO_FILE]; a_wp___0: CE_POINTER [PD_WINDOW_S]; a_add_edit: INTEGER_32; a_flagp: CE_POINTER [NATURAL_32]; a_current_arg_idx: INTEGER_32): INTEGER_32
		local
			l_save_curwin: CE_POINTER [PD_WINDOW_S]
			l_f: INTEGER_32
			l_do_cursor: INTEGER_32
			l_did_next: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___12: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_save_curwin.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_did_next := 0
					if (a_flagp.c_pointer.to_integer_32).to_natural_32 = ((option_inst.ssop_flags_address).c_pointer.to_integer_32).to_natural_32 then
						l_tmp := 1
					elseif ((a_flagp.item).bit_and ({NATURAL_32} 16384)).to_boolean then
						l_tmp := 1
					else
						l_tmp := 0
					end
					l_do_cursor := l_tmp
					if ((a_wp___0.item.w_alist).c_pointer.to_integer_32).to_natural_32 = ((globals_inst.global_alist.address).c_pointer.to_integer_32).to_natural_32 then
						if (put_line (a_fd, ce_string ("argglobal"))) = 0 then
							Result := 0
							js.return
						end
					else
						if (a_flagp.c_pointer.to_integer_32).to_natural_32 = ((option_inst.vop_flags_address).c_pointer.to_integer_32).to_natural_32 then
							l_tmp___1 := 1
						elseif not ((a_flagp.item).bit_and ({NATURAL_32} 4096)).to_boolean then
							l_tmp___1 := 1
						elseif ((a_wp___0.item.w_localdir).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_tmp___1 := 1
						else
							l_tmp___1 := 0
						end
						if (ses_arglist (a_fd, ce_string ("arglocal"), create {CE_POINTER [PD_GROWARRAY]}.make_shared ((a_wp___0.item.w_alist).c_pointer + {PD_ARGLIST}.al_ga_offset), l_tmp___1, a_flagp)) = 0 then
							Result := 0
							js.return
						end
					end
					if not js.return_called and then (a_wp___0.item.w_arg_idx /= a_current_arg_idx) then
						if a_wp___0.item.w_arg_idx < (a_wp___0.item.w_alist).item.al_ga.ga_len then
							if (a_flagp.c_pointer.to_integer_32).to_natural_32 = ((option_inst.ssop_flags_address).c_pointer.to_integer_32).to_natural_32 then
								if (fprintf ([a_fd, ce_string ("%%ldargu"), (a_wp___0.item.w_arg_idx).to_integer_32 + 1])) < 0 then
									Result := 0
									js.return
								elseif (put_eol (a_fd)) = 0 then
									Result := 0
									js.return
								end
								if not js.return_called then
									l_did_next := 1
								end
							end
						end
					end
					if not (not js.return_called and then (a_add_edit.to_boolean)) then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if l_did_next.to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L___0
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 4 then -- else:
						if not ((a_wp___0.item.w_arg_idx_invalid).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 5 then -- if: | _L___0:
						if (((a_wp___0.item.w_buffer).item.b_ffname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (quickfix_inst.bt_nofile (a_wp___0.item.w_buffer)).to_boolean then
							l_pos := -1 + 8 -- goto _L
						elseif (fputs (ce_string ("edit "), a_fd)) < 0 then
							Result := 0
							js.return
						elseif (ses_fname (a_fd, a_wp___0.item.w_buffer, a_flagp)) = 0 then
							Result := 0
							js.return
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if (put_line (a_fd, ce_string ("enew"))) = 0 then
							Result := 0
							js.return
						end
						if not js.return_called and then ((((a_wp___0.item.w_buffer).item.b_ffname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32) then
							if (fputs (ce_string ("file "), a_fd)) < 0 then
								Result := 0
								js.return
							elseif (ses_fname (a_fd, a_wp___0.item.w_buffer, a_flagp)) = 0 then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							l_do_cursor := 0
						end
				when 9 then -- if done | if done | if done
						if not js.return_called and then (((a_flagp.item).bit_and ({NATURAL_32} 48)).to_boolean) then
							if (getchar_inst.makemap (a_fd, a_wp___0.item.w_buffer)) = 0 then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							l_save_curwin.ce_gets (globals_inst.curwin)
							globals_inst.curwin.ce_gets (a_wp___0)
							globals_inst.curbuf.ce_gets (globals_inst.curwin.item.w_buffer)
							if ((a_flagp.item).bit_and ({NATURAL_32} 48)).to_boolean then
								if (a_flagp.c_pointer.to_integer_32).to_natural_32 = ((option_inst.vop_flags_address).c_pointer.to_integer_32).to_natural_32 then
									l_tmp___12 := 1
								elseif not ((a_flagp.item).bit_and ({NATURAL_32} 32)).to_boolean then
									l_tmp___12 := 1
								else
									l_tmp___12 := 0
								end
								l_f := option_inst.makeset (a_fd, 4, l_tmp___12)
							elseif ((a_flagp.item).bit_and ({NATURAL_32} 8192)).to_boolean then
								l_f := option_inst.makefoldset (a_fd)
							else
								l_f := 1
							end
							globals_inst.curwin.ce_gets (l_save_curwin)
							globals_inst.curbuf.ce_gets (globals_inst.curwin.item.w_buffer)
							if l_f = 0 then
								Result := 0
								js.return
							end
						end
						if not (not js.return_called and then (((a_flagp.item).bit_and ({NATURAL_32} 8192)).to_boolean)) then
							l_pos := -1 + 16 -- skip if block
						end
				when 10 then -- if:
							if (((a_wp___0.item.w_buffer).item.b_ffname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_pos := -1 + 16 -- skip if block
							end
				when 11 then -- if:
							if (((a_wp___0.item.w_buffer).item.b_p_bt).item).to_integer_32 /= 0 then
								l_pos := -1 + 14 -- skip if block
							end
				when 12 then -- if:
							l_pos := -1 + 15 -- goto _L___1
				when 13 then -- if block done, skip else block:
							l_pos := -1 + 16
				when 14 then -- else:
							if not (((a_wp___0.item.w_buffer).item.b_help).to_boolean) then
								l_pos := -1 + 16 -- skip if block
							end
				when 15 then -- if: | _L___1:
							if (fold_inst.put_folds (a_fd, a_wp___0)) = 0 then
								Result := 0
								js.return
							end
				when 16 then -- if done | if done | if done
							if not (not js.return_called and then (l_do_cursor.to_boolean)) then
								l_pos := -1 + 25 -- skip if block
							end
				when 17 then -- if:
								if (fprintf ([a_fd, ce_string ("let s:l = %%ld - ((%%ld * winheight(0) + %%ld) / %%ld)"), a_wp___0.item.w_cursor.lnum, a_wp___0.item.w_cursor.lnum - a_wp___0.item.w_topline, (a_wp___0.item.w_height).to_integer_32 // 2, (a_wp___0.item.w_height).to_integer_32])) < 0 then
									Result := 0
									js.return
								elseif (put_eol (a_fd)) = 0 then
									Result := 0
									js.return
								elseif (put_line (a_fd, ce_string ("if s:l < 1 | let s:l = 1 | endif"))) = 0 then
									Result := 0
									js.return
								elseif (put_line (a_fd, ce_string ("exe s:l"))) = 0 then
									Result := 0
									js.return
								elseif (put_line (a_fd, ce_string ("normal! zt"))) = 0 then
									Result := 0
									js.return
								elseif (fprintf ([a_fd, ce_string ("%%ld"), a_wp___0.item.w_cursor.lnum])) < 0 then
									Result := 0
									js.return
								elseif (put_eol (a_fd)) = 0 then
									Result := 0
									js.return
								end
								if js.return_called then
									l_pos := -1 + 25 -- skip if block
								end
				when 18 then -- if:
								if a_wp___0.item.w_cursor.col /= 0 then
									l_pos := -1 + 21 -- skip if block
								end
				when 19 then -- if:
								if (put_line (a_fd, ce_string ("normal! 0"))) = 0 then
									Result := 0
									js.return
								end
				when 20 then -- if block done, skip else block:
								l_pos := -1 + 25
				when 21 then -- else:
								if (a_wp___0.item.w_onebuf_opt.wo_wrap).to_boolean then
									l_pos := -1 + 24 -- skip if block
								end
				when 22 then -- if:
								if a_wp___0.item.w_leftcol > 0 then
									if a_wp___0.item.w_width > 0 then
										if (fprintf ([a_fd, ce_string ("let s:c = %%ld - ((%%ld * winwidth(0) + %%ld) / %%ld)"), (a_wp___0.item.w_cursor.col).to_integer_32, (a_wp___0.item.w_cursor.col - a_wp___0.item.w_leftcol).to_integer_32, (a_wp___0.item.w_width).to_integer_32 // 2, (a_wp___0.item.w_width).to_integer_32])) < 0 then
											Result := 0
											js.return
										elseif (put_eol (a_fd)) = 0 then
											Result := 0
											js.return
										elseif (put_line (a_fd, ce_string ("if s:c > 0"))) = 0 then
											Result := 0
											js.return
										elseif (fprintf ([a_fd, ce_string ("  exe %'normal! 0%' . s:c . %'lzs%' . (%%ld - s:c) . %'l%'"), (a_wp___0.item.w_cursor.col).to_integer_32])) < 0 then
											Result := 0
											js.return
										elseif (put_eol (a_fd)) = 0 then
											Result := 0
											js.return
										elseif (put_line (a_fd, ce_string ("else"))) = 0 then
											Result := 0
											js.return
										elseif (fprintf ([a_fd, ce_string ("  normal! 0%%dl"), a_wp___0.item.w_cursor.col])) < 0 then
											Result := 0
											js.return
										elseif (put_eol (a_fd)) = 0 then
											Result := 0
											js.return
										elseif (put_line (a_fd, ce_string ("endif"))) = 0 then
											Result := 0
											js.return
										end
									else
										l_pos := -1 + 24 -- goto _L___3
									end
								else
									l_pos := -1 + 24 -- goto _L___3
								end
				when 23 then -- if block done, skip else block:
								l_pos := -1 + 25
				when 24 then -- else: | _L___3:
								if (fprintf ([a_fd, ce_string ("normal! 0%%dl"), a_wp___0.item.w_cursor.col])) < 0 then
									Result := 0
									js.return
								elseif (put_eol (a_fd)) = 0 then
									Result := 0
									js.return
								end
				when 25 then -- if done | if done | if done
								if not js.return_called and then (((a_wp___0.item.w_localdir).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32) then
									if (fputs (ce_string ("lcd "), a_fd)) < 0 then
										Result := 0
										js.return
									elseif (ses_put_fname (a_fd, a_wp___0.item.w_localdir, a_flagp)) = 0 then
										Result := 0
										js.return
									elseif (put_eol (a_fd)) = 0 then
										Result := 0
										js.return
									end
									if not js.return_called then
										did_lcd := 1
									end
								end
								if not js.return_called then
									Result := 1
								end
				when 26 then
								l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
					end

	ses_arglist (a_fd: CE_POINTER [SD_IO_FILE]; a_cmd: CE_POINTER [INTEGER_8]; a_gap: CE_POINTER [PD_GROWARRAY]; a_fullname: INTEGER_32; a_flagp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_buf___6.make (<<4096>>)
			create l_s.make

			if a_gap.item.ga_len = 0 then
				Result := (put_line (a_fd, ce_string ("silent! argdel *")))
				js.return
			end
			if not js.return_called then
				if (fputs (a_cmd, a_fd)) < 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_i___0 := 0
				from
				until
					not (not js.loop_left and then (l_i___0 < a_gap.item.ga_len))
				loop
					l_s.ce_gets (buffer_inst.alist_name (create {CE_POINTER [PD_ARGENTRY]}.make_cast (a_gap.item.ga_data) + l_i___0))
					if (l_s.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						if a_fullname.to_boolean then
							window_inst.vim_FullName (l_s, l_buf___6, 4096, 0).do_nothing
							l_s.ce_gets (l_buf___6)
						end
						if (fputs (ce_string (" "), a_fd)) < 0 then
							Result := 0
							js.return
						elseif (ses_put_fname (a_fd, l_s, a_flagp)) = 0 then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not js.return_called then
				Result := (put_eol (a_fd))
			end
		end

	ses_fname (a_fd: CE_POINTER [SD_IO_FILE]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_flagp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_name___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_name___1.make

			if ((a_buf___6.item.b_sfname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (a_flagp.c_pointer.to_integer_32).to_natural_32 = ((option_inst.ssop_flags_address).c_pointer.to_integer_32).to_natural_32 then
					if ((option_inst.ssop_flags).bit_and ({NATURAL_32} 6144)).to_boolean then
						if not option_inst.p_acd.to_boolean then
							if not did_lcd.to_boolean then
								l_name___1.ce_gets (a_buf___6.item.b_sfname)
							else
								l_name___1.ce_gets (a_buf___6.item.b_ffname)
							end
						else
							l_name___1.ce_gets (a_buf___6.item.b_ffname)
						end
					else
						l_name___1.ce_gets (a_buf___6.item.b_ffname)
					end
				else
					l_name___1.ce_gets (a_buf___6.item.b_ffname)
				end
			else
				l_name___1.ce_gets (a_buf___6.item.b_ffname)
			end
			if (ses_put_fname (a_fd, l_name___1, a_flagp)) = 0 then
				Result := 0
				js.return
			elseif (put_eol (a_fd)) = 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 1
			end
		end

	ses_put_fname (a_fd: CE_POINTER [SD_IO_FILE]; a_name___1: CE_POINTER [NATURAL_8]; a_flagp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_name___1: CE_POINTER [NATURAL_8]
			l_sname: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
			l_c: INTEGER_32
			l_l: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_name___1.make
			create l_sname.make
			create l_tmp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_name___1.ce_gets (a_name___1)
					l_retval := 1
					l_sname.ce_gets (misc1_inst.home_replace_save (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_name___1))
					if (l_sname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_name___1.ce_gets (l_sname)
					end
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_name___1.item).to_integer_32 /= 0)) then
						l_pos := -1 + 16 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if globals_inst.has_mbyte.to_boolean then
							l_l := globals_inst.mb_ptr2len.integer_32_item ([l_name___1])
							if l_l > 1 then
								from
								until
									js.loop_left
								loop
									js.reset
									l_l := l_l - 1
									if not (l_l >= 0) then
										js.break
									end
									if not js.loop_jumped then
										if (IO_putc ((l_name___1.item).to_integer_32, a_fd)) /= (l_name___1.item).to_integer_32 then
											l_retval := 0
										end
										l_name___1.ce_gets (l_name___1 + 1)
									end
								end
								js.reset
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 15 -- skip if block
						end
				when 3 then -- if:
						l_tmp___0.ce_gets (l_name___1)
						l_name___1.ce_gets (l_name___1 + 1)
						l_c := (l_tmp___0.item).to_integer_32
						if l_c /= 92 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if ((a_flagp.item).bit_and ({NATURAL_32} 512)).to_boolean then
							l_c := ('/').code
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 6 then -- else: | _L___0:
						if ((misc2_inst.vim_strchr (globals_inst.escape_chars, l_c)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 9 then -- else:
						if l_c /= 35 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 12 then -- else:
						if l_c /= 37 then
							l_pos := -1 + 14 -- skip if block
						end
				when 13 then -- if: | _L:
						if (IO_putc (('\').code, a_fd)) /= 92 then
							l_retval := 0
						end
				when 14 then -- if done | if done | if done
						if (IO_putc (l_c, a_fd)) /= l_c then
							l_retval := 0
						end
				when 15 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 16 then -- loop done
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_sname))
					Result := l_retval
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_loadview (a_eap: CE_POINTER [PD_EXARG])
		local
			l_fname: CE_POINTER [NATURAL_8]
		do
			create l_fname.make

			l_fname.ce_gets (get_view_file (((a_eap.item.arg).item).to_integer_32))
			if (l_fname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				ex_cmds2_inst.do_source (l_fname, 0, 0).do_nothing
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fname))
			end
		end

	ex_loadview_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_loadview)
		end

	get_view_file (a_c: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_len: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_retval: CE_POINTER [NATURAL_8]
			l_sname: CE_POINTER [NATURAL_8]
			l_tmp___1: NATURAL_32
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___11: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_s.make
			create l_retval.make
			create l_sname.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___7.make
			create l_tmp___8.make
			create l_tmp___10.make
			create l_tmp___11.make

			l_len := 0
			if ((globals_inst.curbuf.item.b_ffname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_noname))))).do_nothing
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_sname.ce_gets (misc1_inst.home_replace_save (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), globals_inst.curbuf.item.b_ffname))
				if (l_sname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				l_p___0.ce_gets (l_sname)
				from
				until
					not ((l_p___0.item).to_boolean)
				loop
					if (l_p___0.item).to_integer_32 = 61 then
						l_len := l_len + 1
					elseif (misc1_inst.vim_ispathsep ((l_p___0.item).to_integer_32)).to_boolean then
						l_len := l_len + 1
					end
					l_p___0.ce_gets (l_p___0 + 1)
				end
				l_tmp___1 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_sname))
				l_retval.ce_gets (misc2_inst.alloc (((l_tmp___1 + l_len.to_natural_32) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_vdir)))) + {NATURAL_32} 9))
				if (l_retval.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_retval), create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_vdir)).do_nothing
					misc1_inst.add_pathsep (l_retval)
					l_s.ce_gets (l_retval + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_retval))).to_integer_32)
					l_p___0.ce_gets (l_sname)
					from
					until
						not ((l_p___0.item).to_boolean)
					loop
						if (l_p___0.item).to_integer_32 = 61 then
							l_tmp___4.ce_gets (l_s)
							l_s.ce_gets (l_s + 1)
							l_tmp___4.item := (('=').code).to_natural_8
							l_tmp___5.ce_gets (l_s)
							l_s.ce_gets (l_s + 1)
							l_tmp___5.item := (('=').code).to_natural_8
						elseif (misc1_inst.vim_ispathsep ((l_p___0.item).to_integer_32)).to_boolean then
							l_tmp___6.ce_gets (l_s)
							l_s.ce_gets (l_s + 1)
							l_tmp___6.item := (('=').code).to_natural_8
							l_tmp___7.ce_gets (l_s)
							l_s.ce_gets (l_s + 1)
							l_tmp___7.item := (('+').code).to_natural_8
						else
							l_tmp___8.ce_gets (l_s)
							l_s.ce_gets (l_s + 1)
							l_tmp___8.item := l_p___0.item
						end
						l_p___0.ce_gets (l_p___0 + 1)
					end
					l_tmp___10.ce_gets (l_s)
					l_s.ce_gets (l_s + 1)
					l_tmp___10.item := (('=').code).to_natural_8
					l_tmp___11.ce_gets (l_s)
					l_s.ce_gets (l_s + 1)
					l_tmp___11.item := a_c.to_natural_8
					strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string (".vim")).do_nothing
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_sname))
				Result := l_retval
			end
		end

	put_eol (a_fd: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (IO_putc (('%N').code, a_fd)) < 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 1
			end
		end

	put_line (a_fd: CE_POINTER [SD_IO_FILE]; a_s: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (fputs (a_s, a_fd)) < 0 then
				Result := 0
				js.return
			elseif (put_eol (a_fd)) = 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 1
			end
		end

	ex_viminfo (a_eap: CE_POINTER [PD_EXARG])
		local
			l_save_viminfo: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
		do
			create l_save_viminfo.make

			l_save_viminfo.ce_gets (option_inst.p_viminfo)
			if (option_inst.p_viminfo.item).to_integer_32 = 0 then
				option_inst.p_viminfo.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%'100")))
			end
			if a_eap.item.cmdidx = 348 then
				if (a_eap.item.forceit).to_boolean then
					l_tmp___0 := 4
				else
					l_tmp___0 := 0
				end
				if (ex_cmds_inst.read_viminfo (a_eap.item.arg, (3).bit_or (l_tmp___0))) = 0 then
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E195: Cannot open viminfo file for reading"))))).do_nothing
				end
			else
				ex_cmds_inst.write_viminfo (a_eap.item.arg, a_eap.item.forceit)
			end
			option_inst.p_viminfo.ce_gets (l_save_viminfo)
		end

	ex_viminfo_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_viminfo)
		end

	dialog_msg (a_buff: CE_POINTER [NATURAL_8]; a_format: CE_POINTER [INTEGER_8]; a_fname: CE_POINTER [NATURAL_8])
		local
			l_fname: CE_POINTER [NATURAL_8]
		do
			create l_fname.make

			l_fname.ce_gets (a_fname)
			if (l_fname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_fname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Untitled")))))
			end
			message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (a_buff), (1025).to_natural_32, a_format, l_fname]).do_nothing
		end

	ex_behave (a_eap: CE_POINTER [PD_EXARG])
		do
			if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg), ce_string ("mswin"))) = 0 then
				option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("selection")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("exclusive")), 0)
				option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("selectmode")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mouse,key")), 0)
				option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mousemodel")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("popup")), 0)
				option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("keymodel")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("startsel,stopsel")), 0)
			elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg), ce_string ("xterm"))) = 0 then
				option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("selection")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("inclusive")), 0)
				option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("selectmode")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 0)
				option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mousemodel")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("extend")), 0)
				option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("keymodel")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 0)
			else
				message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg2)))), a_eap.item.arg).do_nothing
			end
		end

	ex_behave_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_behave)
		end

	get_behave_arg (a_xp: CE_POINTER [PD_EXPAND]; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			js: JUMP_STATE
		do
			if a_idx = 0 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mswin")))
				js.return
			end
			if not js.return_called and then (a_idx = 1) then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("xterm")))
				js.return
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	get_behave_arg_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent get_behave_arg)
		end

	ex_filetype (a_eap: CE_POINTER [PD_EXARG])
		local
			l_arg: CE_POINTER [NATURAL_8]
			l_plugin: INTEGER_32
			l_indent: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_arg.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_arg.ce_gets (a_eap.item.arg)
					l_plugin := 0
					l_indent := 0
					if ((a_eap.item.arg).item).to_integer_32 = 0 then
						if filetype_indent.to_boolean then
							if filetype_detect.to_boolean then
								l_tmp.ce_gets (ce_string ("ON"))
							else
								l_tmp.ce_gets (ce_string ("(on)"))
							end
							l_tmp___0.ce_gets (l_tmp)
						else
							l_tmp___0.ce_gets (ce_string ("OFF"))
						end
						if filetype_plugin.to_boolean then
							if filetype_detect.to_boolean then
								l_tmp___1.ce_gets (ce_string ("ON"))
							else
								l_tmp___1.ce_gets (ce_string ("(on)"))
							end
							l_tmp___2.ce_gets (l_tmp___1)
						else
							l_tmp___2.ce_gets (ce_string ("OFF"))
						end
						if filetype_detect.to_boolean then
							l_tmp___3.ce_gets (ce_string ("ON"))
						else
							l_tmp___3.ce_gets (ce_string ("OFF"))
						end
						message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("filetype detection:%%s  plugin:%%s  indent:%%s")), l_tmp___3, l_tmp___2, l_tmp___0]).do_nothing
						js.return
					end
					if js.return_called then
						l_pos := -1 + 22 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("plugin"), (6).to_natural_32)) = 0 then
								l_plugin := 1
								l_arg.ce_gets (charset_inst.skipwhite (l_arg + 6))
								js.continue
							end
							if not js.loop_jumped then
								if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("indent"), (6).to_natural_32)) = 0 then
									l_indent := 1
									l_arg.ce_gets (charset_inst.skipwhite (l_arg + 6))
									js.continue
								end
							end
							if not js.loop_jumped then
								js.break
							end
							if not js.loop_left then
								
							end
						end
						js.reset
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("on"))) /= 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L___1
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 4 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("detect"))) /= 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 5 then -- if: | _L___1:
						if (l_arg.item).to_integer_32 /= 111 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if filetype_detect.to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						ex_cmds2_inst.source_runtime (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("filetype.vim")), 1).do_nothing
						filetype_detect := 1
						if l_plugin.to_boolean then
							ex_cmds2_inst.source_runtime (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftplugin.vim")), 1).do_nothing
							filetype_plugin := 1
						end
						if l_indent.to_boolean then
							ex_cmds2_inst.source_runtime (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("indent.vim")), 1).do_nothing
							filetype_indent := 1
						end
				when 10 then -- if done
						if (l_arg.item).to_integer_32 = 100 then
							fileio_inst.do_doautocmd (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("filetypedetect BufRead")), 1).do_nothing
							buffer_inst.do_modelines (0)
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 12 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("off"))) /= 0 then
							l_pos := -1 + 21 -- skip if block
						end
				when 13 then -- if:
						if not (l_plugin.to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 16 then -- else:
						if not (l_indent.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if: | _L___0:
						if l_plugin.to_boolean then
							ex_cmds2_inst.source_runtime (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftplugof.vim")), 1).do_nothing
							filetype_plugin := 0
						end
						if l_indent.to_boolean then
							ex_cmds2_inst.source_runtime (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("indoff.vim")), 1).do_nothing
							filetype_indent := 0
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:
						ex_cmds2_inst.source_runtime (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftoff.vim")), 1).do_nothing
						filetype_detect := 0
				when 20 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg2)))), l_arg).do_nothing
				when 22 then -- if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_filetype_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_filetype)
		end

	ex_setfiletype (a_eap: CE_POINTER [PD_EXARG])
		do
			if not globals_inst.did_filetype.to_boolean then
				option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("filetype")), 0, a_eap.item.arg, 4)
			end
		end

	ex_setfiletype_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_setfiletype)
		end

	ex_digraphs (a_eap: CE_POINTER [PD_EXARG])
		do
			if ((a_eap.item.arg).item).to_integer_32 /= 0 then
				digraph_inst.putdigraph (a_eap.item.arg)
			else
				digraph_inst.listdigraphs
			end
		end

	ex_digraphs_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_digraphs)
		end

	ex_set (a_eap: CE_POINTER [PD_EXARG])
		local
			l_flags___0: INTEGER_32
		do
			l_flags___0 := 0
			if a_eap.item.cmdidx = 370 then
				l_flags___0 := 4
			elseif a_eap.item.cmdidx = 369 then
				l_flags___0 := 2
			end
			if (globals_inst.cmdmod.browse).to_boolean then
				if l_flags___0 = 0 then
					ex_cmds2_inst.ex_options (a_eap)
				else
					option_inst.do_set (a_eap.item.arg, l_flags___0).do_nothing
				end
			else
				option_inst.do_set (a_eap.item.arg, l_flags___0).do_nothing
			end
		end

	ex_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_set)
		end

	ex_nohlsearch (a_eap: CE_POINTER [PD_EXARG])
		do
			globals_inst.no_hlsearch := 1
			screen_inst.redraw_all_later (35)
		end

	ex_nohlsearch_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_nohlsearch)
		end

	ex_match (a_eap: CE_POINTER [PD_EXARG])
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_g: CE_POINTER [NATURAL_8]
			l_end: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_id: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_g.make
			create l_end.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_g.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					if a_eap.item.line2 <= 3 then
						l_id := (a_eap.item.line2).to_integer_32
					else
						message_inst.emsg (globals_inst.e_invcmd).do_nothing
						js.return
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if not (a_eap.item.skip).to_boolean then
							window_inst.match_delete (globals_inst.curwin, l_id, 0).do_nothing
						end
						if not ((ends_excmd (((a_eap.item.arg).item).to_integer_32)).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_end.ce_gets (a_eap.item.arg)
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg), ce_string ("none"), (4).to_natural_32)) /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (a_eap.item.arg[4]).to_integer_32 = 32 then
							l_end.ce_gets (a_eap.item.arg + 4)
						elseif (a_eap.item.arg[4]).to_integer_32 = 9 then
							l_end.ce_gets (a_eap.item.arg + 4)
						elseif (ends_excmd ((a_eap.item.arg[4]).to_integer_32)).to_boolean then
							l_end.ce_gets (a_eap.item.arg + 4)
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						l_p___0.ce_gets (charset_inst.skiptowhite (a_eap.item.arg))
						if not (a_eap.item.skip).to_boolean then
							l_g.ce_gets (misc2_inst.vim_strnsave (a_eap.item.arg, l_p___0.distance ((a_eap.item.arg))))
						end
						l_p___0.ce_gets (charset_inst.skipwhite (l_p___0))
						if (l_p___0.item).to_integer_32 = 0 then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg2)))), a_eap.item.arg).do_nothing
							js.return
						end
						if not js.return_called then
							l_end.ce_gets (regexp_inst.skip_regexp (l_p___0 + 1, (l_p___0.item).to_integer_32, 1, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
							if not (a_eap.item.skip).to_boolean then
								if (l_end.item).to_integer_32 /= 0 then
									if not (ends_excmd (((charset_inst.skipwhite (l_end + 1)).item).to_integer_32)).to_boolean then
										a_eap.item.errmsg := globals_inst.e_trailing
										js.return
									end
								end
								if not js.return_called and then ((l_end.item).to_integer_32 /= (l_p___0.item).to_integer_32) then
									message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg2)))), l_p___0).do_nothing
									js.return
								end
								if not js.return_called then
									l_c := (l_end.item).to_integer_32
									l_end.item := (('%/0/').code).to_natural_8
									window_inst.match_add (globals_inst.curwin, l_g, l_p___0 + 1, 10, l_id).do_nothing
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_g))
									l_end.item := l_c.to_natural_8
								end
							end
						end
				when 8 then -- if done | if done
						if not js.return_called then
							a_eap.item.nextcmd := find_nextcmd (l_end)
						end
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ex_match_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_match)
		end

	ex_X (a_eap: CE_POINTER [PD_EXARG])
		do
			if (misc2_inst.get_crypt_method (globals_inst.curbuf)) = 0 then
				misc2_inst.get_crypt_key (1, 1).do_nothing
			elseif (blowfish_inst.blowfish_self_test) = 1 then
				misc2_inst.get_crypt_key (1, 1).do_nothing
			end
		end

	ex_X_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_X)
		end

	ex_fold (a_eap: CE_POINTER [PD_EXARG])
		do
			if (fold_inst.foldManualAllowed (1)).to_boolean then
				fold_inst.foldCreate (a_eap.item.line1, a_eap.item.line2)
			end
		end

	ex_fold_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_fold)
		end

	ex_foldopen (a_eap: CE_POINTER [PD_EXARG])
		do
			fold_inst.opFoldRange (a_eap.item.line1, a_eap.item.line2, (a_eap.item.cmdidx = 152).to_integer, a_eap.item.forceit, 0)
		end

	ex_foldopen_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_foldopen)
		end

	ex_folddo (a_eap: CE_POINTER [PD_EXARG])
		local
			l_lnum: INTEGER_32
		do
			l_lnum := a_eap.item.line1
			from
			until
				not (l_lnum <= a_eap.item.line2)
			loop
				if (fold_inst.hasFolding (l_lnum, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))).to_boolean = (a_eap.item.cmdidx = 151) then
					memline_inst.ml_setmarked (l_lnum)
				end
				l_lnum := l_lnum + 1
			end
			ex_cmds_inst.global_exe (a_eap.item.arg)
			memline_inst.ml_clearmarked
		end

	ex_folddo_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_folddo)
		end

end
