class
	P_FILEIO

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create crypt_magic.make (<<2>>)
			create crypt_magic_head.make (<<10>>)
			create crypt_salt_len.make (<<2>>)
			create crypt_seed_len.make (<<2>>)
			create e_auchangedbuf.make
			create err_readonly.make
			create tempdirs.make (<<4>>)
			create event_names.make (<<82>>)
			create first_autopat.make (<<77>>)
			create active_apc_list.make
			create augroups.make
			create old_termresponse.make
		end

feature {ANY} -- attributes

	crypt_magic: CE_ARRAY [CE_POINTER [INTEGER_8]]

	crypt_magic_head: CE_ARRAY [INTEGER_8]

	crypt_salt_len: CE_ARRAY [INTEGER_32]

	crypt_seed_len: CE_ARRAY [INTEGER_32]

	e_auchangedbuf: CE_POINTER [INTEGER_8]

	err_readonly: CE_POINTER [INTEGER_8]

	already_warned: INTEGER_32 assign set_already_warned

	set_already_warned (a_already_warned: INTEGER_32)
		do
			already_warned := a_already_warned
		end

	busy: INTEGER_32 assign set_busy

	set_busy (a_busy: INTEGER_32)
		do
			busy := a_busy
		end

	temp_count: INTEGER_32 assign set_temp_count

	set_temp_count (a_temp_count: INTEGER_32)
		do
			temp_count := a_temp_count
		end

	tempdirs: CE_ARRAY [CE_POINTER [INTEGER_8]]

	event_names: CE_ARRAY [PD_EVENT_NAME]

	first_autopat: CE_ARRAY [CE_POINTER [PD_AUTOPAT]]

	active_apc_list: CE_POINTER [PD_AUTOPATCMD]

	augroups: PD_GROWARRAY

	current_augroup: INTEGER_32 assign set_current_augroup

	set_current_augroup (a_current_augroup: INTEGER_32)
		do
			current_augroup := a_current_augroup
		end

	au_need_clean: INTEGER_32 assign set_au_need_clean

	set_au_need_clean (a_au_need_clean: INTEGER_32)
		do
			au_need_clean := a_au_need_clean
		end

	last_event: INTEGER_32 assign set_last_event

	set_last_event (a_last_event: INTEGER_32)
		do
			last_event := a_last_event
		end

	last_group: INTEGER_32 assign set_last_group

	set_last_group (a_last_group: INTEGER_32)
		do
			last_group := a_last_group
		end

	autocmd_blocked: INTEGER_32 assign set_autocmd_blocked

	set_autocmd_blocked (a_autocmd_blocked: INTEGER_32)
		do
			autocmd_blocked := a_autocmd_blocked
		end

	autocmd_nested: INTEGER_32 assign set_autocmd_nested

	set_autocmd_nested (a_autocmd_nested: INTEGER_32)
		do
			autocmd_nested := a_autocmd_nested
		end

	nesting: INTEGER_32 assign set_nesting

	set_nesting (a_nesting: INTEGER_32)
		do
			nesting := a_nesting
		end

	filechangeshell_busy: INTEGER_32 assign set_filechangeshell_busy

	set_filechangeshell_busy (a_filechangeshell_busy: INTEGER_32)
		do
			filechangeshell_busy := a_filechangeshell_busy
		end

	old_termresponse: CE_POINTER [NATURAL_8]

	include_groups: INTEGER_32 assign set_include_groups

	set_include_groups (a_include_groups: INTEGER_32)
		do
			include_groups := a_include_groups
		end

feature {ANY} -- routines

	filemess (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_name___1: CE_POINTER [NATURAL_8]; a_s: CE_POINTER [NATURAL_8]; a_attr: INTEGER_32)
		local
			l_msg_scroll_save: INTEGER_32
			js: JUMP_STATE
		do
			if globals_inst.msg_silent /= 0 then
				js.return
			end
			if not js.return_called then
				msg_add_fname (a_buf___6, a_name___1)
				if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff))) > {NATURAL_32} 945 then
					globals_inst.IObuff[945] := (('%/0/').code).to_natural_8
				end
				strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), create {CE_POINTER [INTEGER_8]}.make_cast (a_s)).do_nothing
				l_msg_scroll_save := globals_inst.msg_scroll
				if (option_inst.shortmess (('O').code)).to_boolean then
					if not globals_inst.exiting.to_boolean then
						if option_inst.p_verbose = 0 then
							globals_inst.msg_scroll := 0
						end
					end
				end
				if not globals_inst.msg_scroll.to_boolean then
					screen_inst.check_for_delay (0)
				end
				message_inst.msg_start
				globals_inst.msg_scroll := l_msg_scroll_save
				globals_inst.msg_scrolled_ign := 1
				message_inst.msg_outtrans_attr ((message_inst.msg_may_trunc (0, globals_inst.IObuff)), a_attr).do_nothing
				message_inst.msg_clr_eos
				term_inst.out_flush
				globals_inst.msg_scrolled_ign := 0
			end
		end

	readfile (a_fname: CE_POINTER [NATURAL_8]; a_sfname: CE_POINTER [NATURAL_8]; a_from: INTEGER_32; a_lines_to_skip: INTEGER_32; a_lines_to_read: INTEGER_32; a_eap: CE_POINTER [PD_EXARG]; a_flags___0: INTEGER_32): INTEGER_32
		local
			l_fname: CE_POINTER [NATURAL_8]
			l_sfname: CE_POINTER [NATURAL_8]
			l_fd: INTEGER_32
			l_newfile: INTEGER_32
			l_check_readonly___0: INTEGER_32
			l_filtering: INTEGER_32
			l_read_stdin___0: INTEGER_32
			l_read_buffer: INTEGER_32
			l_set_options: INTEGER_32
			l_tmp: INTEGER_32
			l_read_buf_lnum: INTEGER_32
			l_read_buf_col: INTEGER_32
			l_c: NATURAL_8
			l_lnum: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_buffer: CE_POINTER [NATURAL_8]
			l_new_buffer: CE_POINTER [NATURAL_8]
			l_line_start: CE_POINTER [NATURAL_8]
			l_wasempty: INTEGER_32
			l_len: INTEGER_32
			l_size: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_filesize: INTEGER_32
			l_skip_read: INTEGER_32
			l_cryptkey: CE_POINTER [NATURAL_8]
			l_did_ask_for_key: INTEGER_32
			l_sha_ctx: PD_CONTEXT_SHA256_T
			l_read_undo_file: INTEGER_32
			l_split: INTEGER_32
			l_linecnt: INTEGER_32
			l_error: INTEGER_32
			l_ff_error: INTEGER_32
			l_linerest: INTEGER_32
			l_perm: INTEGER_32
			l_swap_mode: INTEGER_32
			l_fileformat: INTEGER_32
			l_keep_fileformat: INTEGER_32
			l_st: SD_STAT
			l_file_readonly: INTEGER_32
			l_skip_count: INTEGER_32
			l_read_count: INTEGER_32
			l_msg_save: INTEGER_32
			l_read_no_eol_lnum: INTEGER_32
			l_try_mac: INTEGER_32
			l_try_dos: INTEGER_32
			l_try_unix: INTEGER_32
			l_file_rewind: INTEGER_32
			l_can_retry: INTEGER_32
			l_conv_error: INTEGER_32
			l_illegal_byte: INTEGER_32
			l_keep_dest_enc: INTEGER_32
			l_bad_char_behavior: INTEGER_32
			l_tmpname: CE_POINTER [NATURAL_8]
			l_fio_flags: INTEGER_32
			l_fenc: CE_POINTER [NATURAL_8]
			l_fenc_alloced: INTEGER_32
			l_fenc_next: CE_POINTER [NATURAL_8]
			l_advance_fenc: INTEGER_32
			l_real_size: INTEGER_32
			l_iconv_fd: CE_POINTER [ANY]
			l_did_iconv: INTEGER_32
			l_converted: INTEGER_32
			l_notconverted: INTEGER_32
			l_conv_rest: CE_ARRAY [NATURAL_8]
			l_conv_restlen: INTEGER_32
			l_old_curbuf: CE_POINTER [PD_FILE_BUFFER]
			l_old_b_ffname: CE_POINTER [NATURAL_8]
			l_old_b_fname: CE_POINTER [NATURAL_8]
			l_using_b_ffname: INTEGER_32
			l_using_b_fname: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_pos___3: PD_POS_T
			l_tmp___8: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___17: CE_POINTER [INTEGER_8]
			l_oldval: INTEGER_32
			l_tmp___25: INTEGER_32
			l_tmp___28: CE_POINTER [INTEGER_8]
			l_tmp___39: CE_POINTER [INTEGER_8]
			l_tmp___41: CE_POINTER [INTEGER_8]
			l_m: INTEGER_32
			l_n: INTEGER_32
			l_firstline: CE_ARRAY [NATURAL_8]
			l_fc: INTEGER_32
			l_tmp___53: INTEGER_32
			l_tmp___55: INTEGER_32
			l_tmp___58: CE_POINTER [NATURAL_8]
			l_tmp___61: INTEGER_32
			l_tmp___62: INTEGER_32
			l_n___0: INTEGER_32
			l_ni: INTEGER_32
			l_tlen: INTEGER_32
			l_tmp___65: INTEGER_32
			l_tmp___66: INTEGER_32
			l_tmp___67: INTEGER_32
			l_tmp___68: INTEGER_32
			l_tmp___69: INTEGER_32
			l_ccname: CE_POINTER [NATURAL_8]
			l_blen: INTEGER_32
			l_tmp___72: INTEGER_32
			l_fromp: CE_POINTER [INTEGER_8]
			l_top: CE_POINTER [INTEGER_8]
			l_from_size: NATURAL_32
			l_to_size: NATURAL_32
			l_tmp___73: CE_POINTER [INTEGER_8]
			l_tmp___74: CE_POINTER [INTEGER_8]
			l_u8c: INTEGER_32
			l_dest: CE_POINTER [NATURAL_8]
			l_tail: CE_POINTER [NATURAL_8]
			l_u16c: INTEGER_32
			l_incomplete_tail: INTEGER_32
			l_todo: INTEGER_32
			l_l: INTEGER_32
			l_fdflags: INTEGER_32
			l_tmp___89: CE_POINTER [INTEGER_8]
			l_tmp___96: CE_POINTER [INTEGER_8]
			l_tmp___98: CE_POINTER [INTEGER_8]
			l_hash: CE_ARRAY [NATURAL_8]
			l_m___0: INTEGER_32
			l_n___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fname.make
			create l_sfname.make
			create l_ptr.make
			create l_buffer.make
			create l_new_buffer.make
			create l_line_start.make
			create l_p___0.make
			create l_cryptkey.make
			create l_sha_ctx.make
			create l_st.make
			create l_tmpname.make
			create l_fenc.make
			create l_fenc_next.make
			create l_iconv_fd.make
			create l_conv_rest.make (<<30>>)
			create l_old_curbuf.make
			create l_old_b_ffname.make
			create l_old_b_fname.make
			create l_pos___3.make
			create l_tmp___17.make
			create l_tmp___28.make
			create l_tmp___39.make
			create l_tmp___41.make
			create l_firstline.make (<<80>>)
			create l_tmp___58.make
			create l_ccname.make
			create l_fromp.make
			create l_top.make
			create l_tmp___73.make
			create l_tmp___74.make
			create l_dest.make
			create l_tail.make
			create l_tmp___89.make
			create l_tmp___96.make
			create l_tmp___98.make
			create l_hash.make (<<32>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fname.ce_gets (a_fname)
					l_sfname.ce_gets (a_sfname)
					l_fd := 0
					l_newfile := (a_flags___0).bit_and (1)
					l_filtering := (a_flags___0).bit_and (2)
					l_read_stdin___0 := (a_flags___0).bit_and (4)
					l_read_buffer := (a_flags___0).bit_and (8)
					if l_newfile.to_boolean then
						l_tmp := 1
					elseif l_read_buffer.to_boolean then
						l_tmp := 1
					elseif (a_eap.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						if (a_eap.item.read_edit).to_boolean then
							l_tmp := 1
						else
							l_tmp := 0
						end
					else
						l_tmp := 0
					end
					l_set_options := l_tmp
					l_read_buf_lnum := (1).to_integer_32
					l_read_buf_col := 0
					l_lnum := a_from
					l_ptr.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_buffer.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_new_buffer.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_line_start.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_size := 0
					l_filesize := (0).to_integer_32
					l_skip_read := 0
					l_cryptkey.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_did_ask_for_key := 0
					l_read_undo_file := 0
					l_split := 0
					l_error := 0
					l_ff_error := -1
					l_linerest := 0
					l_perm := 0
					l_swap_mode := -1
					l_fileformat := 0
					l_keep_fileformat := 0
					l_skip_count := (0).to_integer_32
					l_read_count := (0).to_integer_32
					l_msg_save := globals_inst.msg_scroll
					l_read_no_eol_lnum := (0).to_integer_32
					l_try_mac := (((misc2_inst.vim_strchr (option_inst.p_ffs, ('m').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
					l_try_dos := (((misc2_inst.vim_strchr (option_inst.p_ffs, ('d').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
					l_try_unix := (((misc2_inst.vim_strchr (option_inst.p_ffs, ('x').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
					l_file_rewind := 0
					l_conv_error := (0).to_integer_32
					l_illegal_byte := (0).to_integer_32
					l_keep_dest_enc := 0
					l_bad_char_behavior := ('?').code
					l_tmpname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_fio_flags := 0
					l_fenc_next.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_advance_fenc := 0
					l_real_size := 0
					l_iconv_fd.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer + -1))
					l_did_iconv := 0
					l_converted := 0
					l_notconverted := 0
					l_conv_restlen := 0
					globals_inst.write_no_eol_lnum := (0).to_integer_32
					if ((globals_inst.curbuf.item.b_ffname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						if not l_filtering.to_boolean then
							if (l_fname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('f').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if not ((a_flags___0).bit_and (16)).to_boolean then
										if (set_rw_fname (l_fname, l_sfname)) = 0 then
											Result := 0
											js.return
										end
									end
								end
							end
						end
					end
					if not js.return_called then
						l_old_curbuf.ce_gets (globals_inst.curbuf)
						l_old_b_ffname.ce_gets (globals_inst.curbuf.item.b_ffname)
						l_old_b_fname.ce_gets (globals_inst.curbuf.item.b_fname)
						if (l_fname.c_pointer.to_integer_32).to_natural_32 = ((globals_inst.curbuf.item.b_ffname).c_pointer.to_integer_32).to_natural_32 then
							l_tmp___5 := 1
						elseif (l_sfname.c_pointer.to_integer_32).to_natural_32 = ((globals_inst.curbuf.item.b_ffname).c_pointer.to_integer_32).to_natural_32 then
							l_tmp___5 := 1
						else
							l_tmp___5 := 0
						end
						l_using_b_ffname := l_tmp___5
						if (l_fname.c_pointer.to_integer_32).to_natural_32 = ((globals_inst.curbuf.item.b_fname).c_pointer.to_integer_32).to_natural_32 then
							l_tmp___6 := 1
						elseif (l_sfname.c_pointer.to_integer_32).to_natural_32 = ((globals_inst.curbuf.item.b_fname).c_pointer.to_integer_32).to_natural_32 then
							l_tmp___6 := 1
						else
							l_tmp___6 := 0
						end
						l_using_b_fname := l_tmp___6
						globals_inst.ex_no_reprint := 1
						globals_inst.need_fileinfo := 0
						if (l_sfname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_sfname.ce_gets (l_fname)
						end
						l_fname.ce_gets (l_sfname)
						if not l_filtering.to_boolean then
							if not l_read_stdin___0.to_boolean then
								if not l_read_buffer.to_boolean then
									l_pos___3.ce_gets (globals_inst.curbuf.item.b_op_start)
									if a_from = 0 then
										globals_inst.curbuf.item.b_op_start.lnum := (1).to_integer_32
									else
										globals_inst.curbuf.item.b_op_start.lnum := a_from
									end
									globals_inst.curbuf.item.b_op_start.col := 0
									if l_newfile.to_boolean then
										if (apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_BUFREADCMD, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_sfname, 0, globals_inst.curbuf, a_eap)).to_boolean then
											if (ex_eval_inst.aborting).to_boolean then
												l_tmp___8 := 0
											else
												l_tmp___8 := 1
											end
											Result := l_tmp___8
											js.return
										end
									elseif (apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEREADCMD, l_sfname, l_sfname, 0, create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), a_eap)).to_boolean then
										if (ex_eval_inst.aborting).to_boolean then
											l_tmp___12 := 0
										else
											l_tmp___12 := 1
										end
										Result := l_tmp___12
										js.return
									end
									if not js.return_called then
										globals_inst.curbuf.item.b_op_start := l_pos___3
									end
								end
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if not ((option_inst.shortmess (('o').code)).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if not ((globals_inst.curbuf.item.b_help).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						if option_inst.p_verbose = 0 then
							globals_inst.msg_scroll := 0
						else
							globals_inst.msg_scroll := 1
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						globals_inst.msg_scroll := 1
				when 8 then -- if done
						if (l_fname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (l_fname.item).to_integer_32 /= 0 then
								l_p___0.ce_gets (l_fname + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname))).to_integer_32)
								if (misc2_inst.after_pathsep (l_fname, l_p___0)).to_boolean then
									l_tmp___17.ce_gets (gettext (ce_string ("Illegal file name")))
									filemess (globals_inst.curbuf, l_fname, create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___17), 0)
									message_inst.msg_end.do_nothing
									globals_inst.msg_scroll := l_msg_save
									Result := 0
									js.return
								elseif (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname))) >= {NATURAL_32} 4096 then
									l_tmp___17.ce_gets (gettext (ce_string ("Illegal file name")))
									filemess (globals_inst.curbuf, l_fname, create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___17), 0)
									message_inst.msg_end.do_nothing
									globals_inst.msg_scroll := l_msg_save
									Result := 0
									js.return
								end
							end
						end
				when 9 then -- if done
					if not js.return_called and then (not l_read_stdin___0.to_boolean) then
						if not l_read_buffer.to_boolean then
							l_perm := (os_unix_inst.mch_getperm (l_fname)).to_integer_32
							if l_perm >= 0 then
								if ((l_perm).bit_and (61440)) /= 32768 then
									if ((l_perm).bit_and (61440)) /= 4096 then
										if ((l_perm).bit_and (61440)) /= 49152 then
											if ((l_perm).bit_and (61440)) = 16384 then
												filemess (globals_inst.curbuf, l_fname, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("is a directory")))), 0)
											else
												filemess (globals_inst.curbuf, l_fname, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("is not a file")))), 0)
											end
											message_inst.msg_end.do_nothing
											globals_inst.msg_scroll := l_msg_save
											Result := 0
											js.return
										end
									end
								end
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 33 -- skip if block
					end
				when 10 then -- if:
						if not (l_set_options.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 11 then -- if:
						if (a_eap.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if a_eap.item.force_ff /= 0 then
							misc2_inst.set_fileformat ((misc2_inst.get_fileformat_force (globals_inst.curbuf, a_eap)), 4)
						else
							l_pos := -1 + 14 -- goto _L___0
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else: | _L___0:
						if (option_inst.p_ffs.item).to_integer_32 /= 0 then
							misc2_inst.set_fileformat ((misc2_inst.default_fileformat), 4)
						end
				when 15 then -- if done
						if (a_eap.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if a_eap.item.force_bin /= 0 then
								l_oldval := globals_inst.curbuf.item.b_p_bin
								globals_inst.curbuf.item.b_p_bin := (a_eap.item.force_bin = 1).to_integer
								option_inst.set_options_bin (l_oldval, globals_inst.curbuf.item.b_p_bin, 4)
							end
						end
						if l_newfile.to_boolean then
							if ((globals_inst.curbuf.item.b_flags).bit_and (2)).to_boolean then
								l_tmp___25 := 1
							else
								l_tmp___25 := 0
							end
						else
							l_tmp___25 := 0
						end
						l_check_readonly___0 := l_tmp___25
						if l_check_readonly___0.to_boolean then
							if not globals_inst.readonlymode.to_boolean then
								globals_inst.curbuf.item.b_p_ro := 0
							end
						end
						if l_newfile.to_boolean then
							if not l_read_stdin___0.to_boolean then
								if not l_read_buffer.to_boolean then
									if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), (l_st.address))) >= 0 then
										buf_store_time (globals_inst.curbuf, l_st.address, l_fname)
										globals_inst.curbuf.item.b_mtime_read := globals_inst.curbuf.item.b_mtime
										l_swap_mode := ((((l_st.st_mode).bit_and ({NATURAL_32} 420))).bit_or ({NATURAL_32} 384)).to_integer_32
									else
										globals_inst.curbuf.item.b_mtime := 0
										globals_inst.curbuf.item.b_mtime_read := 0
										globals_inst.curbuf.item.b_orig_size := (0).to_integer_32
										globals_inst.curbuf.item.b_orig_mode := 0
									end
									globals_inst.curbuf.item.b_flags := (globals_inst.curbuf.item.b_flags).bit_and ((-49))
								end
							end
						end
						l_file_readonly := 0
						if not l_read_stdin___0.to_boolean then
							if not l_read_buffer.to_boolean then
								if not ((l_perm).bit_and (146)).to_boolean then
									l_file_readonly := 1
								elseif (access (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), 2)).to_boolean then
									l_file_readonly := 1
								end
								l_fd := open ([create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), 0, 0])
							end
						end
						if not (l_fd < 0) then
							l_pos := -1 + 33 -- skip if block
						end
				when 16 then -- if:
						globals_inst.msg_scroll := l_msg_save
						if not (l_newfile.to_boolean) then
							l_pos := -1 + 32 -- skip if block
						end
				when 17 then -- if:
						if not (l_perm < 0) then
							l_pos := -1 + 31 -- skip if block
						end
				when 18 then -- if:
						if (errno_location).item /= 2 then
							l_pos := -1 + 29 -- skip if block
						end
				when 19 then -- if:
						globals_inst.curbuf.item.b_flags := (globals_inst.curbuf.item.b_flags).bit_or ((16))
						if (quickfix_inst.bt_dontwrite (globals_inst.curbuf)).to_boolean then
							l_pos := -1 + 27 -- skip if block
						end
				when 20 then -- if:
						memline_inst.check_need_swap (l_newfile)
						if (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 = (l_old_curbuf.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_tmp___28.ce_gets (gettext (e_auchangedbuf))
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___28)).do_nothing
						Result := 0
						js.return
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 23 then -- else:
						if not (l_using_b_ffname.to_boolean) then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						if (l_old_b_ffname.c_pointer.to_integer_32).to_natural_32 /= ((globals_inst.curbuf.item.b_ffname).c_pointer.to_integer_32).to_natural_32 then
							l_tmp___28.ce_gets (gettext (e_auchangedbuf))
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___28)).do_nothing
							Result := 0
							js.return
						else
							l_pos := -1 + 26 -- goto _L___1
						end
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else: | _L___1:
						if l_using_b_fname.to_boolean then
							if (l_old_b_fname.c_pointer.to_integer_32).to_natural_32 /= ((globals_inst.curbuf.item.b_fname).c_pointer.to_integer_32).to_natural_32 then
								l_tmp___28.ce_gets (gettext (e_auchangedbuf))
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___28)).do_nothing
								Result := 0
								js.return
							end
						end
				when 27 then -- if done | if done
						if not js.return_called then
							if (misc1_inst.dir_of_file_exists (l_fname)).to_boolean then
								filemess (globals_inst.curbuf, l_sfname, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("[New File]")))), 0)
							else
								filemess (globals_inst.curbuf, l_sfname, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("[New DIRECTORY]")))), 0)
							end
							check_marks_read
							if (a_eap.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if a_eap.item.force_enc /= 0 then
									l_fenc.ce_gets (mbyte_inst.enc_canonize (a_eap.item.cmd + a_eap.item.force_enc))
									if (l_fenc.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										option_inst.set_string_option_direct (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("fenc")), -1, l_fenc, 5, 0)
									end
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fenc))
								end
							end
							apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_BUFNEWFILE, l_sfname, l_sfname, 0, globals_inst.curbuf, a_eap).do_nothing
							option_inst.save_file_ff (globals_inst.curbuf)
							if (ex_eval_inst.aborting).to_boolean then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							Result := 1
							js.return
						end
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else:
						l_pos := -1 + 31 -- goto _L___2
				when 30 then -- if done | if block done, skip else block:
						l_pos := -1 + 32
				when 31 then -- else: | _L___2:
						if (errno_location).item = 27 then
							l_tmp___41.ce_gets ((gettext (ce_string ("[File too big]"))))
						else
							if (errno_location).item = 75 then
								l_tmp___39.ce_gets ((gettext (ce_string ("[File too big]"))))
							else
								l_tmp___39.ce_gets ((gettext (ce_string ("[Permission Denied]"))))
							end
							l_tmp___41.ce_gets (l_tmp___39)
						end
						filemess (globals_inst.curbuf, l_sfname, create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___41), 0)
						globals_inst.curbuf.item.b_p_ro := 1
				when 32 then -- if done
						if not js.return_called then
							Result := 0
							js.return
						end
				when 33 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 50 -- skip if block
						end
				when 34 then -- if:
							if not (l_check_readonly___0.to_boolean) then
								l_pos := -1 + 37 -- skip if block
							end
				when 35 then -- if:
							if l_file_readonly.to_boolean then
								globals_inst.curbuf.item.b_p_ro := 1
							else
								l_pos := -1 + 37 -- goto _L___3
							end
				when 36 then -- if block done, skip else block:
							l_pos := -1 + 38
				when 37 then -- else: | _L___3:
							if (globals_inst.curbuf.item.b_help).to_boolean then
								globals_inst.curbuf.item.b_p_ro := 1
							end
				when 38 then
							if l_set_options.to_boolean then
								if not l_read_buffer.to_boolean then
									globals_inst.curbuf.item.b_p_eol := 1
									globals_inst.curbuf.item.b_start_eol := 1
								end
								globals_inst.curbuf.item.b_p_bomb := 0
								globals_inst.curbuf.item.b_start_bomb := 0
							end
							if (quickfix_inst.bt_dontwrite (globals_inst.curbuf)).to_boolean then
								l_pos := -1 + 50 -- skip if block
							end
				when 39 then -- if:
							memline_inst.check_need_swap (l_newfile)
							if l_read_stdin___0.to_boolean then
								l_pos := -1 + 49 -- skip if block
							end
				when 40 then -- if:
							if (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 = (l_old_curbuf.c_pointer.to_integer_32).to_natural_32 then
								l_pos := -1 + 43 -- skip if block
							end
				when 41 then -- if:
							l_pos := -1 + 48 -- goto _L___4
				when 42 then -- if block done, skip else block:
							l_pos := -1 + 49
				when 43 then -- else:
							if not (l_using_b_ffname.to_boolean) then
								l_pos := -1 + 46 -- skip if block
							end
				when 44 then -- if:
							if (l_old_b_ffname.c_pointer.to_integer_32).to_natural_32 /= ((globals_inst.curbuf.item.b_ffname).c_pointer.to_integer_32).to_natural_32 then
								l_pos := -1 + 48 -- goto _L___4
							else
								l_pos := -1 + 46 -- goto _L___5
							end
				when 45 then -- if block done, skip else block:
							l_pos := -1 + 49
				when 46 then -- else: | _L___5:
							if not (l_using_b_fname.to_boolean) then
								l_pos := -1 + 49 -- skip if block
							end
				when 47 then -- if:
							if (l_old_b_fname.c_pointer.to_integer_32).to_natural_32 = ((globals_inst.curbuf.item.b_fname).c_pointer.to_integer_32).to_natural_32 then
								l_pos := -1 + 49 -- skip if block
							end
				when 48 then -- if: | _L___4:
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (e_auchangedbuf)))).do_nothing
							if not l_read_buffer.to_boolean then
								close (l_fd).do_nothing
							end
							Result := 0
							js.return
				when 49 then -- if done | if done | if done | if done
							if not js.return_called and then (l_swap_mode > 0) then
								if ((globals_inst.curbuf.item.b_ml.ml_mfp).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if (((globals_inst.curbuf.item.b_ml.ml_mfp).item.mf_fname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										os_unix_inst.mch_setperm ((globals_inst.curbuf.item.b_ml.ml_mfp).item.mf_fname, l_swap_mode.to_integer_32).do_nothing
									end
								end
							end
				when 50 then -- if done | if done
							if not js.return_called and then (globals_inst.swap_exists_action = 2) then
								if not l_read_buffer.to_boolean then
									if not l_read_stdin___0.to_boolean then
										close (l_fd).do_nothing
									end
								end
								Result := 0
								js.return
							end
							if js.return_called then
								l_pos := -1 + 64 -- skip if block
							end
				when 51 then -- if:
								globals_inst.no_wait_return := globals_inst.no_wait_return + 1
								if a_from = 0 then
									globals_inst.curbuf.item.b_op_start.lnum := (1).to_integer_32
								else
									globals_inst.curbuf.item.b_op_start.lnum := a_from
								end
								globals_inst.curbuf.item.b_op_start.col := 0
								if l_read_buffer.to_boolean then
									l_pos := -1 + 64 -- skip if block
								end
				when 52 then -- if:
								l_m := globals_inst.msg_scroll
								l_n := globals_inst.msg_scrolled
								if not l_read_stdin___0.to_boolean then
									close (l_fd).do_nothing
								end
								globals_inst.msg_scroll := 1
								if l_filtering.to_boolean then
									apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILTERREADPRE, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_sfname, 0, globals_inst.curbuf, a_eap).do_nothing
								elseif l_read_stdin___0.to_boolean then
									apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_STDINREADPRE, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_sfname, 0, globals_inst.curbuf, a_eap).do_nothing
								elseif l_newfile.to_boolean then
									apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_BUFREADPRE, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_sfname, 0, globals_inst.curbuf, a_eap).do_nothing
								else
									apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEREADPRE, l_sfname, l_sfname, 0, create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), a_eap).do_nothing
								end
								if globals_inst.msg_scrolled = l_n then
									globals_inst.msg_scroll := l_m
								end
								if (ex_eval_inst.aborting).to_boolean then
									globals_inst.no_wait_return := globals_inst.no_wait_return - 1
									globals_inst.msg_scroll := l_msg_save
									globals_inst.curbuf.item.b_p_ro := 1
									Result := 0
									js.return
								end
								if not (not js.return_called and then (not l_read_stdin___0.to_boolean)) then
									l_pos := -1 + 64 -- skip if block
								end
				when 53 then -- if:
								if (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 = (l_old_curbuf.c_pointer.to_integer_32).to_natural_32 then
									l_pos := -1 + 56 -- skip if block
								end
				when 54 then -- if:
								l_pos := -1 + 63 -- goto _L___6
				when 55 then -- if block done, skip else block:
								l_pos := -1 + 64
				when 56 then -- else:
								if not (l_using_b_ffname.to_boolean) then
									l_pos := -1 + 59 -- skip if block
								end
				when 57 then -- if:
								if (l_old_b_ffname.c_pointer.to_integer_32).to_natural_32 /= ((globals_inst.curbuf.item.b_ffname).c_pointer.to_integer_32).to_natural_32 then
									l_pos := -1 + 63 -- goto _L___6
								else
									l_pos := -1 + 59 -- goto _L___8
								end
				when 58 then -- if block done, skip else block:
								l_pos := -1 + 64
				when 59 then -- else: | _L___8:
								if not (l_using_b_fname.to_boolean) then
									l_pos := -1 + 62 -- skip if block
								end
				when 60 then -- if:
								if (l_old_b_fname.c_pointer.to_integer_32).to_natural_32 /= ((globals_inst.curbuf.item.b_fname).c_pointer.to_integer_32).to_natural_32 then
									l_pos := -1 + 63 -- goto _L___6
								else
									l_pos := -1 + 62 -- goto _L___7
								end
				when 61 then -- if block done, skip else block:
								l_pos := -1 + 64
				when 62 then -- else: | _L___7:
								l_fd := open ([create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), 0, 0])
								if not (l_fd < 0) then
									l_pos := -1 + 64 -- skip if block
								end
				when 63 then -- if: | _L___6:
								globals_inst.no_wait_return := globals_inst.no_wait_return - 1
								globals_inst.msg_scroll := l_msg_save
								if l_fd < 0 then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E200: *ReadPre autocommands made the file unreadable"))))).do_nothing
								else
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E201: *ReadPre autocommands must not change current buffer"))))).do_nothing
								end
								globals_inst.curbuf.item.b_p_ro := 1
								Result := 0
								js.return
				when 64 then -- if done | if done | if done | if done | if done | if done
								if js.return_called then
									l_pos := -1 + 280 -- skip if block
								end
				when 65 then -- if:
									l_wasempty := (globals_inst.curbuf.item.b_ml.ml_flags).bit_and (1)
									if not globals_inst.recoverymode.to_boolean then
										if not l_filtering.to_boolean then
											if not ((a_flags___0).bit_and (16)).to_boolean then
												if l_read_stdin___0.to_boolean then
													message_inst.mch_msg ((gettext (ce_string ("Vim: Reading from stdin...%N"))))
													if (gui_inst.gui.in_use).to_boolean then
														if not (gui_inst.gui.dying).to_boolean then
															if not (gui_inst.gui.starting).to_boolean then
																l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Reading from stdin...")))))
																gui_inst.gui_write (l_p___0, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32)
															end
														end
													end
												elseif not l_read_buffer.to_boolean then
													filemess (globals_inst.curbuf, l_sfname, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 0)
												end
											end
										end
									end
									globals_inst.msg_scroll := 0
									l_linecnt := globals_inst.curbuf.item.b_ml.ml_line_count
									if (a_eap.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										if a_eap.item.bad_char /= 0 then
											l_bad_char_behavior := a_eap.item.bad_char
											if l_set_options.to_boolean then
												globals_inst.curbuf.item.b_bad_char := a_eap.item.bad_char
											end
										else
											globals_inst.curbuf.item.b_bad_char := 0
										end
									else
										globals_inst.curbuf.item.b_bad_char := 0
									end
									if (a_eap.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										l_pos := -1 + 68 -- skip if block
									end
				when 66 then -- if:
									if a_eap.item.force_enc /= 0 then
										l_fenc.ce_gets (mbyte_inst.enc_canonize (a_eap.item.cmd + a_eap.item.force_enc))
										l_fenc_alloced := 1
										l_keep_dest_enc := 1
									else
										l_pos := -1 + 68 -- goto _L___9
									end
				when 67 then -- if block done, skip else block:
									l_pos := -1 + 69
				when 68 then -- else: | _L___9:
									if (globals_inst.curbuf.item.b_p_bin).to_boolean then
										l_fenc.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
										l_fenc_alloced := 0
									elseif (globals_inst.curbuf.item.b_help).to_boolean then
										l_fenc.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("latin1")))
										l_c := globals_inst.enc_utf8.to_natural_8
										if not l_c.to_boolean then
											if not l_read_stdin___0.to_boolean then
												l_fc := (l_fname[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname))) - {NATURAL_32} 1).to_integer_32]).to_integer_32
												if l_fc < 65 then
													l_tmp___53 := l_fc
												elseif l_fc > 90 then
													l_tmp___53 := l_fc
												else
													l_tmp___53 := l_fc + 32
												end
												if l_tmp___53 = 120 then
													l_len := read (l_fd, create {CE_POINTER [ANY]}.make_cast (l_firstline), (80).to_natural_32)
													lseek (l_fd, 0, 0).do_nothing
													l_p___0.ce_gets (l_firstline)
													from
													until
														not (not js.loop_left and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_firstline + l_len).c_pointer.to_integer_32).to_natural_32))
													loop
														js.reset
														if (l_p___0.item).to_integer_32 >= 128 then
															l_c := (1).to_natural_8
															js.break
														end
														if not js.loop_jumped then
															l_p___0.ce_gets (l_p___0 + 1)
														end
													end
													js.reset
												end
											end
										end
										if l_c.to_boolean then
											l_fenc_next.ce_gets (l_fenc)
											l_fenc.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("utf-8")))
											if not globals_inst.enc_utf8.to_boolean then
												l_keep_dest_enc := 1
											end
										end
										l_fenc_alloced := 0
									elseif (option_inst.p_fencs.item).to_integer_32 = 0 then
										l_fenc.ce_gets (globals_inst.curbuf.item.b_p_fenc)
										l_fenc_alloced := 0
									else
										l_fenc_next.ce_gets (option_inst.p_fencs)
										l_fenc.ce_gets (next_fenc (l_fenc_next.address))
										l_fenc_alloced := 1
									end
				when 69 then -- retry:
									if not (l_file_rewind.to_boolean) then
										l_pos := -1 + 72 -- skip if block
									end
				when 70 then -- if:
									if l_read_buffer.to_boolean then
										l_read_buf_lnum := (1).to_integer_32
										l_read_buf_col := 0
									elseif l_read_stdin___0.to_boolean then
										l_error := 1
										l_pos := -1 + 268 -- goto failed
									elseif (lseek (l_fd, 0, 0)) /= 0 then
										l_error := 1
										l_pos := -1 + 268 -- goto failed
									end
				when 71 then
									from
									until
										not (l_lnum > a_from)
									loop
										l_tmp___55 := l_lnum
										l_lnum := l_lnum - 1
										memline_inst.ml_delete (l_tmp___55, 0).do_nothing
									end
									l_file_rewind := 0
									if l_set_options.to_boolean then
										globals_inst.curbuf.item.b_p_bomb := 0
										globals_inst.curbuf.item.b_start_bomb := 0
									end
									l_conv_error := (0).to_integer_32
				when 72 then -- if done
									if (l_cryptkey.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										misc2_inst.crypt_pop_state
									end
									if not (l_keep_fileformat.to_boolean) then
										l_pos := -1 + 75 -- skip if block
									end
				when 73 then -- if:
									l_keep_fileformat := 0
				when 74 then -- if block done, skip else block:
									l_pos := -1 + 79
				when 75 then -- else:
									if (a_eap.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										l_pos := -1 + 78 -- skip if block
									end
				when 76 then -- if:
									if a_eap.item.force_ff /= 0 then
										l_fileformat := misc2_inst.get_fileformat_force (globals_inst.curbuf, a_eap)
										l_try_mac := 0
										l_try_dos := l_try_mac
										l_try_unix := l_try_dos
									else
										l_pos := -1 + 78 -- goto _L___10
									end
				when 77 then -- if block done, skip else block:
									l_pos := -1 + 79
				when 78 then -- else: | _L___10:
									if (globals_inst.curbuf.item.b_p_bin).to_boolean then
										l_fileformat := 0
									elseif (option_inst.p_ffs.item).to_integer_32 = 0 then
										l_fileformat := misc2_inst.get_fileformat (globals_inst.curbuf)
									else
										l_fileformat := -1
									end
				when 79 then -- if done
									if (l_iconv_fd.c_pointer.to_integer_32).to_natural_32 /= (-1).to_natural_32 then
										iconv_close (l_iconv_fd).do_nothing
										l_iconv_fd.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer + -1))
									end
									if not (l_advance_fenc.to_boolean) then
										l_pos := -1 + 85 -- skip if block
									end
				when 80 then -- if:
									l_advance_fenc := 0
									if (a_eap.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										l_pos := -1 + 83 -- skip if block
									end
				when 81 then -- if:
									if a_eap.item.force_enc /= 0 then
										l_notconverted := 1
										l_conv_error := (0).to_integer_32
										if l_fenc_alloced.to_boolean then
											misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fenc))
										end
										l_fenc.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
										l_fenc_alloced := 0
									else
										l_pos := -1 + 83 -- goto _L___11
									end
				when 82 then -- if block done, skip else block:
									l_pos := -1 + 84
				when 83 then -- else: | _L___11:
									if l_fenc_alloced.to_boolean then
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fenc))
									end
									if (l_fenc_next.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										l_fenc.ce_gets (next_fenc (l_fenc_next.address))
										l_fenc_alloced := ((l_fenc_next.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
									else
										l_fenc.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
										l_fenc_alloced := 0
									end
				when 84 then
									if (l_tmpname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmpname)).do_nothing
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tmpname))
										l_tmpname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
									end
				when 85 then -- if done
									l_fio_flags := 0
									l_converted := need_conversion (l_fenc)
									if not (l_converted.to_boolean) then
										l_pos := -1 + 105 -- skip if block
									end
				when 86 then -- if:
									if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_fenc), ce_string ("ucs-bom"))) = 0 then
										l_fio_flags := 16384
									elseif globals_inst.enc_utf8.to_boolean then
										l_fio_flags := get_fio_flags (l_fenc)
									elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_enc), ce_string ("latin1"))) = 0 then
										l_fio_flags := get_fio_flags (l_fenc)
									end
									if l_fio_flags = 0 then
										if not l_did_iconv.to_boolean then
											if globals_inst.enc_utf8.to_boolean then
												l_tmp___58.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("utf-8")))
											else
												l_tmp___58.ce_gets (option_inst.p_enc)
											end
											l_iconv_fd.ce_gets ((mbyte_inst.my_iconv_open (l_tmp___58, l_fenc)))
										end
									end
									if l_fio_flags /= 0 then
										l_pos := -1 + 104 -- skip if block
									end
				when 87 then -- if:
									if l_read_stdin___0.to_boolean then
										l_pos := -1 + 102 -- skip if block
									end
				when 88 then -- if:
									if l_read_buffer.to_boolean then
										l_pos := -1 + 100 -- skip if block
									end
				when 89 then -- if:
									if (option_inst.p_ccv.item).to_integer_32 = 0 then
										l_pos := -1 + 98 -- skip if block
									end
				when 90 then -- if:
									if (l_iconv_fd.c_pointer.to_integer_32).to_natural_32 /= (-1).to_natural_32 then
										l_pos := -1 + 96 -- skip if block
									end
				when 91 then -- if:
									l_did_iconv := 0
									if (l_tmpname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										l_pos := -1 + 95 -- skip if block
									end
				when 92 then -- if:
									l_tmpname.ce_gets (readfile_charconvert (l_fname, l_fenc, create {CE_POINTER [INTEGER_32]}.make_shared ($l_fd)))
									if (l_tmpname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										l_pos := -1 + 95 -- skip if block
									end
				when 93 then -- if:
									l_advance_fenc := 1
									if l_fd < 0 then
										message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E202: Conversion made file unreadable!"))))).do_nothing
										l_error := 1
										l_pos := -1 + 268 -- goto failed
									end
				when 94 then
									l_pos := -1 + 69 -- goto retry
				when 95 then -- if done | if done | if block done, skip else block:
									l_pos := -1 + 97
				when 96 then -- else:
									l_pos := -1 + 104 -- goto _L___15
				when 97 then -- if done | if block done, skip else block:
									l_pos := -1 + 99
				when 98 then -- else:
									l_pos := -1 + 104 -- goto _L___15
				when 99 then -- if done | if block done, skip else block:
									l_pos := -1 + 101
				when 100 then -- else:
									l_pos := -1 + 104 -- goto _L___15
				when 101 then -- if done | if block done, skip else block:
									l_pos := -1 + 103
				when 102 then -- else:
									l_pos := -1 + 104 -- goto _L___15
				when 103 then -- if done | if block done, skip else block:
									l_pos := -1 + 105
				when 104 then -- else: | _L___15:
									if l_fio_flags = 0 then
										if (l_iconv_fd.c_pointer.to_integer_32).to_natural_32 = (-1).to_natural_32 then
											l_advance_fenc := 1
											l_pos := -1 + 69 -- goto retry
										end
									end
				when 105 then -- if done
									if (l_fenc.item).to_integer_32 /= 0 then
										if not l_read_stdin___0.to_boolean then
											if not l_keep_dest_enc.to_boolean then
												l_tmp___61 := 1
											else
												l_tmp___61 := 0
											end
										else
											l_tmp___61 := 0
										end
									else
										l_tmp___61 := 0
									end
									l_can_retry := l_tmp___61
									if not l_skip_read.to_boolean then
										l_linerest := 0
										l_filesize := (0).to_integer_32
										l_skip_count := a_lines_to_skip
										l_read_count := a_lines_to_read
										l_conv_restlen := 0
										if l_newfile.to_boolean then
											if ((a_flags___0).bit_and (32)) = 0 then
												if ((globals_inst.curbuf.item.b_ffname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
													if (globals_inst.curbuf.item.b_p_udf).to_boolean then
														if not l_filtering.to_boolean then
															if not l_read_stdin___0.to_boolean then
																if not l_read_buffer.to_boolean then
																	l_tmp___62 := 1
																else
																	l_tmp___62 := 0
																end
															else
																l_tmp___62 := 0
															end
														else
															l_tmp___62 := 0
														end
													else
														l_tmp___62 := 0
													end
												else
													l_tmp___62 := 0
												end
											else
												l_tmp___62 := 0
											end
										else
											l_tmp___62 := 0
										end
										l_read_undo_file := l_tmp___62
										if l_read_undo_file.to_boolean then
											sha256_inst.sha256_start (l_sha_ctx.address)
										end
									end
				when 106 then -- loop condition:
									if js.loop_left then
										l_pos := -1 + 267 -- skip loop
									end
				when 107 then -- loop body:
									js.reset
									if not l_error.to_boolean then
										if globals_inst.got_int.to_boolean then
											js.break
										end
									else
										js.break
									end
									if not (not js.loop_jumped and then (not l_skip_read.to_boolean)) then
										l_pos := -1 + 132 -- skip if block
									end
				when 108 then -- if:
									l_size := 65536
									from
									until
										not (not js.loop_left and then (l_size >= 10))
									loop
										js.reset
										l_new_buffer.ce_gets (misc2_inst.lalloc (((l_size + l_linerest) + 1).to_natural_32, 0))
										if (l_new_buffer.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
											js.break
										end
										if not js.loop_jumped then
											l_size := ((l_size.to_natural_32).bit_shift_right (1)).to_integer_32
										end
									end
									js.reset
									if (l_new_buffer.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										misc2_inst.do_outofmem_msg (((l_size * 2 + l_linerest) + 1).to_natural_32)
										l_error := 1
										js.break
									end
									if js.loop_jumped then
										l_pos := -1 + 132 -- skip if block
									end
				when 109 then -- if:
									if l_linerest.to_boolean then
										memmove (create {CE_POINTER [ANY]}.make_cast (l_new_buffer), create {CE_POINTER [ANY]}.make_cast ((l_ptr - l_linerest)), l_linerest.to_natural_32).do_nothing
									end
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buffer))
									l_buffer.ce_gets (l_new_buffer)
									l_ptr.ce_gets (l_buffer + l_linerest)
									l_line_start.ce_gets (l_buffer)
									l_real_size := l_size
									if (l_iconv_fd.c_pointer.to_integer_32).to_natural_32 /= (-1).to_natural_32 then
										l_size := l_size // (8)
									elseif ((l_fio_flags).bit_and (1)).to_boolean then
										l_size := l_size // (2)
									elseif ((l_fio_flags).bit_and (20)).to_boolean then
										l_size := ((l_size * 2) // 3).bit_and (-2)
									elseif ((l_fio_flags).bit_and (8)).to_boolean then
										l_size := ((l_size * 2) // 3).bit_and (-4)
									elseif l_fio_flags = 16384 then
										l_size := l_size // (8)
									end
									if l_conv_restlen > 0 then
										memmove (create {CE_POINTER [ANY]}.make_cast (l_ptr), create {CE_POINTER [ANY]}.make_cast (l_conv_rest), l_conv_restlen.to_natural_32).do_nothing
										l_ptr.ce_gets (l_ptr + l_conv_restlen)
										l_size := l_size - l_conv_restlen.to_integer_32
									end
									if l_read_buffer.to_boolean then
										if l_read_buf_lnum > a_from then
											l_size := 0
										else
											l_tlen := 0
											from
											until
												js.loop_left
											loop
												js.reset
												l_p___0.ce_gets ((memline_inst.ml_get (l_read_buf_lnum)) + l_read_buf_col)
												l_n___0 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32
												if ((l_tlen.to_integer_32 + l_n___0) + 1).to_integer_32 > l_size then
													l_n___0 := (l_size - l_tlen).to_integer_32
													l_ni := 0
													from
													until
														not (l_ni < l_n___0)
													loop
														if (l_p___0[l_ni]).to_integer_32 = 10 then
															l_tmp___65 := l_tlen
															l_tlen := l_tlen + 1
															l_ptr[l_tmp___65] := (('%/0/').code).to_natural_8
														else
															l_tmp___66 := l_tlen
															l_tlen := l_tlen + 1
															l_ptr[l_tmp___66] := l_p___0[l_ni]
														end
														l_ni := l_ni + 1
													end
													l_read_buf_col := l_read_buf_col + l_n___0
													js.break
												else
													l_ni := 0
													from
													until
														not (l_ni < l_n___0)
													loop
														if (l_p___0[l_ni]).to_integer_32 = 10 then
															l_tmp___67 := l_tlen
															l_tlen := l_tlen + 1
															l_ptr[l_tmp___67] := (('%/0/').code).to_natural_8
														else
															l_tmp___68 := l_tlen
															l_tlen := l_tlen + 1
															l_ptr[l_tmp___68] := l_p___0[l_ni]
														end
														l_ni := l_ni + 1
													end
													l_tmp___69 := l_tlen
													l_tlen := l_tlen + 1
													l_ptr[l_tmp___69] := (('%N').code).to_natural_8
													l_read_buf_col := 0
													l_read_buf_lnum := l_read_buf_lnum + 1
													if l_read_buf_lnum > a_from then
														if not (globals_inst.curbuf.item.b_p_eol).to_boolean then
															l_tlen := l_tlen - 1
														end
														l_size := l_tlen
														js.break
													end
												end
											end
											js.reset
										end
									else
										l_size := (read (l_fd, create {CE_POINTER [ANY]}.make_cast (l_ptr), l_size.to_natural_32)).to_integer_32
									end
									if not (l_size <= 0) then
										l_pos := -1 + 131 -- skip if block
									end
				when 110 then -- if:
									if not (l_size < 0) then
										l_pos := -1 + 113 -- skip if block
									end
				when 111 then -- if:
									l_error := 1
				when 112 then -- if block done, skip else block:
									l_pos := -1 + 131
				when 113 then -- else:
									if not (l_conv_restlen > 0) then
										l_pos := -1 + 131 -- skip if block
									end
				when 114 then -- if:
									if l_fio_flags = 0 then
										l_pos := -1 + 117 -- skip if block
									end
				when 115 then -- if:
									l_pos := -1 + 118 -- goto _L___16
				when 116 then -- if block done, skip else block:
									l_pos := -1 + 121
				when 117 then -- else:
									if (l_iconv_fd.c_pointer.to_integer_32).to_natural_32 = (-1).to_natural_32 then
										l_pos := -1 + 120 -- skip if block
									end
				when 118 then -- if: | _L___16:
									if l_conv_error = 0 then
										l_conv_error := (globals_inst.curbuf.item.b_ml.ml_line_count - l_linecnt) + 1
									end
				when 119 then -- if block done, skip else block:
									l_pos := -1 + 121
				when 120 then -- else:
									if l_illegal_byte = 0 then
										l_illegal_byte := (globals_inst.curbuf.item.b_ml.ml_line_count - l_linecnt) + 1
									end
				when 121 then -- if done
									if l_bad_char_behavior /= -2 then
										l_pos := -1 + 124 -- skip if block
									end
				when 122 then -- if:
									l_ptr[-l_conv_restlen] := (('%/0/').code).to_natural_8
									l_conv_restlen := 0
				when 123 then -- if block done, skip else block:
									l_pos := -1 + 131
				when 124 then -- else:
									if l_bad_char_behavior = -1 then
										l_pos := -1 + 130 -- skip if block
									end
				when 125 then -- if:
									if l_fio_flags = 0 then
										l_pos := -1 + 128 -- skip if block
									end
				when 126 then -- if:
									l_pos := -1 + 129 -- goto _L___17
				when 127 then -- if block done, skip else block:
									l_pos := -1 + 130
				when 128 then -- else:
									if (l_iconv_fd.c_pointer.to_integer_32).to_natural_32 = (-1).to_natural_32 then
										l_pos := -1 + 130 -- skip if block
									end
				when 129 then -- if: | _L___17:
									from
									until
										not (l_conv_restlen > 0)
									loop
										l_ptr.ce_gets (l_ptr - 1)
										l_ptr.item := l_bad_char_behavior.to_natural_8
										l_conv_restlen := l_conv_restlen - 1
									end
				when 130 then -- if done | if done
									l_fio_flags := 0
									if (l_iconv_fd.c_pointer.to_integer_32).to_natural_32 /= (-1).to_natural_32 then
										iconv_close (l_iconv_fd).do_nothing
										l_iconv_fd.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer + -1))
									end
				when 131 then -- if done | if done | if done | if done
									if l_filesize = 0 then
										l_cryptkey.ce_gets (check_for_cryptkey (l_cryptkey, l_ptr, create {CE_POINTER [INTEGER_32]}.make_shared ($l_size), create {CE_POINTER [INTEGER_32]}.make_shared ($l_filesize), l_newfile, l_sfname, create {CE_POINTER [INTEGER_32]}.make_shared ($l_did_ask_for_key)))
									end
									if (l_cryptkey.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										if l_size > 0 then
											misc2_inst.crypt_decode (l_ptr, l_size)
										end
									end
				when 132 then -- if done | if done
									if js.loop_jumped then
										l_pos := -1 + 150 -- skip if block
									end
				when 133 then -- if:
									l_skip_read := 0
									if l_filesize /= 0 then
										l_pos := -1 + 136 -- skip if block
									end
				when 134 then -- if:
									l_pos := -1 + 138 -- goto _L___20
				when 135 then -- if block done, skip else block:
									l_pos := -1 + 149
				when 136 then -- else:
									if l_filesize /= ((12 + crypt_salt_len[globals_inst.use_crypt_method]) + crypt_seed_len[globals_inst.use_crypt_method]).to_integer_32 then
										l_pos := -1 + 149 -- skip if block
									end
				when 137 then -- if:
									if (l_cryptkey.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										l_pos := -1 + 149 -- skip if block
									end
				when 138 then -- if: | _L___20:
									if l_fio_flags /= 16384 then
										l_pos := -1 + 141 -- skip if block
									end
				when 139 then -- if:
									l_pos := -1 + 148 -- goto _L___19
				when 140 then -- if block done, skip else block:
									l_pos := -1 + 149
				when 141 then -- else:
									if (globals_inst.curbuf.item.b_p_bomb).to_boolean then
										l_pos := -1 + 149 -- skip if block
									end
				when 142 then -- if:
									if (l_tmpname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										l_pos := -1 + 149 -- skip if block
									end
				when 143 then -- if:
									if (l_fenc.item).to_integer_32 /= 117 then
										l_pos := -1 + 146 -- skip if block
									end
				when 144 then -- if:
									l_pos := -1 + 148 -- goto _L___19
				when 145 then -- if block done, skip else block:
									l_pos := -1 + 149
				when 146 then -- else:
									if (l_fenc.item).to_integer_32 /= 0 then
										l_pos := -1 + 149 -- skip if block
									end
				when 147 then -- if:
									if not (globals_inst.enc_utf8.to_boolean) then
										l_pos := -1 + 149 -- skip if block
									end
				when 148 then -- if: | _L___19:
									if l_size < 2 then
										l_ccname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
									elseif (globals_inst.curbuf.item.b_p_bin).to_boolean then
										l_ccname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
									else
										if l_fio_flags = 16384 then
											l_tmp___72 := -1
										else
											l_tmp___72 := (get_fio_flags (l_fenc))
										end
										l_ccname.ce_gets (check_for_bom (l_ptr, l_size, create {CE_POINTER [INTEGER_32]}.make_shared ($l_blen), l_tmp___72))
									end
									if (l_ccname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										l_filesize := l_filesize + l_blen.to_integer_32
										l_size := l_size - l_blen.to_integer_32
										memmove (create {CE_POINTER [ANY]}.make_cast (l_ptr), create {CE_POINTER [ANY]}.make_cast ((l_ptr + l_blen)), l_size.to_natural_32).do_nothing
										if l_set_options.to_boolean then
											globals_inst.curbuf.item.b_p_bomb := 1
											globals_inst.curbuf.item.b_start_bomb := 1
										end
									end
									if l_fio_flags = 16384 then
										if (l_ccname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
											l_advance_fenc := 1
										else
											if l_fenc_alloced.to_boolean then
												misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fenc))
											end
											l_fenc.ce_gets (l_ccname)
											l_fenc_alloced := 0
										end
										l_skip_read := 1
										l_pos := -1 + 69 -- goto retry
									end
				when 149 then -- if done | if done | if done | if done | if done | if done | if done | if done
									l_ptr.ce_gets (l_ptr - l_conv_restlen)
									l_size := l_size + l_conv_restlen.to_integer_32
									l_conv_restlen := 0
									if l_size <= 0 then
										js.break
									end
				when 150 then -- if done
									if js.loop_jumped then
										l_pos := -1 + 266 -- skip if block
									end
				when 151 then -- if:
									if (l_iconv_fd.c_pointer.to_integer_32).to_natural_32 = (-1).to_natural_32 then
										l_pos := -1 + 163 -- skip if block
									end
				when 152 then -- if:
									l_fromp.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr))
									l_from_size := l_size.to_natural_32
									l_ptr.ce_gets (l_ptr + l_size)
									l_top.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr))
									l_to_size := (l_real_size - l_size).to_natural_32
				when 153 then -- loop condition:
									if js.loop_left then
										l_pos := -1 + 162 -- skip loop
									end
				when 154 then -- loop body:
									js.reset
									if (iconv (l_iconv_fd, (l_fromp.address), (create {CE_POINTER [NATURAL_32]}.make_shared ($l_from_size)), (l_top.address), (create {CE_POINTER [NATURAL_32]}.make_shared ($l_to_size)))) /= {NATURAL_32} 4294967295 then
										l_pos := -1 + 157 -- skip if block
									end
				when 155 then -- if:
									if (errno_location).item = 22 then
										l_pos := -1 + 157 -- goto _L___21
									end
				when 156 then -- if block done, skip else block:
									l_pos := -1 + 158
				when 157 then -- else: | _L___21:
									if not (l_from_size > {NATURAL_32} 30) then
										js.break
									end
				when 158 then
									if js.loop_jumped then
										l_pos := -1 + 161 -- skip if block
									end
				when 159 then -- if:
									if l_can_retry.to_boolean then
										l_pos := -1 + 228 -- goto rewind_retry
									end
				when 160 then
									if l_conv_error = 0 then
										l_conv_error := readfile_linenr (l_linecnt, l_ptr, create {CE_POINTER [NATURAL_8]}.make_cast (l_top))
									end
									l_fromp.ce_gets (l_fromp + 1)
									l_from_size := l_from_size - 1
									if l_bad_char_behavior = -1 then
										l_tmp___73.ce_gets (l_top)
										l_top.ce_gets (l_top + 1)
										l_tmp___73[0] := l_fromp[-1]
										l_to_size := l_to_size - 1
									elseif l_bad_char_behavior /= -2 then
										l_tmp___74.ce_gets (l_top)
										l_top.ce_gets (l_top + 1)
										l_tmp___74[0] := l_bad_char_behavior.to_integer_8
										l_to_size := l_to_size - 1
									end
				when 161 then -- if done
									l_pos := -1 + 153 -- back to loop condition
				when 162 then -- loop done
									js.reset
									if l_from_size > {NATURAL_32} 0 then
										memmove (create {CE_POINTER [ANY]}.make_cast (l_conv_rest), create {CE_POINTER [ANY]}.make_cast (l_fromp), l_from_size).do_nothing
										l_conv_restlen := l_from_size.to_integer_32
									end
									l_line_start.ce_gets (l_ptr - l_linerest)
									memmove (create {CE_POINTER [ANY]}.make_cast (l_line_start), create {CE_POINTER [ANY]}.make_cast (l_buffer), l_linerest.to_natural_32).do_nothing
									l_size := ((create {CE_POINTER [NATURAL_8]}.make_cast (l_top)).distance (l_ptr)).to_integer_32
				when 163 then -- if done
									if l_fio_flags = 0 then
										l_pos := -1 + 212 -- skip if block
									end
				when 164 then -- if:
									l_tail.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
									l_dest.ce_gets (l_ptr + l_real_size)
									if l_fio_flags /= 1 then
										l_pos := -1 + 167 -- skip if block
									end
				when 165 then -- if:
									l_pos := -1 + 168 -- goto _L___22
				when 166 then -- if block done, skip else block:
									l_pos := -1 + 171
				when 167 then -- else:
									if l_fio_flags /= 2 then
										l_pos := -1 + 170 -- skip if block
									end
				when 168 then -- if: | _L___22:
									l_p___0.ce_gets (l_ptr + l_size)
									if l_fio_flags = 2 then
										l_tail.ce_gets ((l_ptr + l_size) - 1)
										from
										until
											js.loop_left
										loop
											js.reset
											if (l_tail.c_pointer.to_integer_32).to_natural_32 > (l_ptr.c_pointer.to_integer_32).to_natural_32 then
												if (((l_tail.item).to_integer_32).bit_and (192)) /= 128 then
													js.break
												end
											else
												js.break
											end
											if not js.loop_jumped then
												l_tail.ce_gets (l_tail - 1)
											end
										end
										js.reset
										if ((l_tail + (mbyte_inst.utf_byte2len ((l_tail.item).to_integer_32))).c_pointer.to_integer_32).to_natural_32 <= ((l_ptr + l_size).c_pointer.to_integer_32).to_natural_32 then
											l_tail.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
										else
											l_p___0.ce_gets (l_tail)
										end
									end
				when 169 then -- if block done, skip else block:
									l_pos := -1 + 171
				when 170 then -- else:
									if ((l_fio_flags).bit_and (20)).to_boolean then
										l_p___0.ce_gets (l_ptr + ((l_size).bit_and (-2)))
										if ((l_size).bit_and (1)).to_boolean then
											l_tail.ce_gets (l_p___0)
										end
										if ((l_fio_flags).bit_and (16)).to_boolean then
											if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_ptr.c_pointer.to_integer_32).to_natural_32 then
												if ((l_fio_flags).bit_and (128)).to_boolean then
													l_p___0.ce_gets (l_p___0 - 1)
													l_u8c := ((l_p___0.item).to_integer_32).bit_shift_left (8)
													l_p___0.ce_gets (l_p___0 - 1)
													l_u8c := l_u8c + (l_p___0.item).to_integer_32
												else
													l_p___0.ce_gets (l_p___0 - 1)
													l_u8c := (l_p___0.item).to_integer_32
													l_p___0.ce_gets (l_p___0 - 1)
													l_u8c := l_u8c + (((l_p___0.item).to_integer_32).bit_shift_left (8))
												end
												if l_u8c >= 55296 then
													if l_u8c <= 56319 then
														l_tail.ce_gets (l_p___0)
													else
														l_p___0.ce_gets (l_p___0 + (2))
													end
												else
													l_p___0.ce_gets (l_p___0 + (2))
												end
											end
										end
									else
										l_p___0.ce_gets (l_ptr + ((l_size).bit_and (-4)))
										if ((l_size).bit_and (3)).to_boolean then
											l_tail.ce_gets (l_p___0)
										end
									end
				when 171 then -- if done
									if (l_tail.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										l_conv_restlen := (l_ptr + l_size).distance (l_tail)
										memmove (create {CE_POINTER [ANY]}.make_cast (l_conv_rest), create {CE_POINTER [ANY]}.make_cast (l_tail), l_conv_restlen.to_natural_32).do_nothing
										l_size := l_size - l_conv_restlen.to_integer_32
									end
				when 172 then -- loop condition:
									if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_ptr.c_pointer.to_integer_32).to_natural_32) then
										l_pos := -1 + 210 -- skip loop
									end
				when 173 then -- loop body:
									js.reset
									if not (((l_fio_flags).bit_and (1)).to_boolean) then
										l_pos := -1 + 176 -- skip if block
									end
				when 174 then -- if:
									l_p___0.ce_gets (l_p___0 - 1)
									l_u8c := (l_p___0.item).to_integer_32
				when 175 then -- if block done, skip else block:
									l_pos := -1 + 200
				when 176 then -- else:
									if not (((l_fio_flags).bit_and (20)).to_boolean) then
										l_pos := -1 + 191 -- skip if block
									end
				when 177 then -- if:
									if ((l_fio_flags).bit_and (128)).to_boolean then
										l_p___0.ce_gets (l_p___0 - 1)
										l_u8c := ((l_p___0.item).to_integer_32).bit_shift_left (8)
										l_p___0.ce_gets (l_p___0 - 1)
										l_u8c := l_u8c + (l_p___0.item).to_integer_32
									else
										l_p___0.ce_gets (l_p___0 - 1)
										l_u8c := (l_p___0.item).to_integer_32
										l_p___0.ce_gets (l_p___0 - 1)
										l_u8c := l_u8c + (((l_p___0.item).to_integer_32).bit_shift_left (8))
									end
									if not (((l_fio_flags).bit_and (16)).to_boolean) then
										l_pos := -1 + 190 -- skip if block
									end
				when 178 then -- if:
									if not (l_u8c >= 56320) then
										l_pos := -1 + 190 -- skip if block
									end
				when 179 then -- if:
									if not (l_u8c <= 57343) then
										l_pos := -1 + 190 -- skip if block
									end
				when 180 then -- if:
									if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (l_ptr.c_pointer.to_integer_32).to_natural_32 then
										l_pos := -1 + 183 -- skip if block
									end
				when 181 then -- if:
									if l_can_retry.to_boolean then
										l_pos := -1 + 228 -- goto rewind_retry
									end
				when 182 then
									if l_conv_error = 0 then
										l_conv_error := readfile_linenr (l_linecnt, l_ptr, l_p___0)
									end
									if l_bad_char_behavior = -2 then
										js.continue
									end
									if not js.loop_jumped and then (l_bad_char_behavior /= -1) then
										l_u8c := l_bad_char_behavior
									end
				when 183 then -- if done
									if js.loop_jumped then
										l_pos := -1 + 190 -- skip if block
									end
				when 184 then -- if:
									if ((l_fio_flags).bit_and (128)).to_boolean then
										l_p___0.ce_gets (l_p___0 - 1)
										l_u16c := ((l_p___0.item).to_integer_32).bit_shift_left (8)
										l_p___0.ce_gets (l_p___0 - 1)
										l_u16c := l_u16c + (l_p___0.item).to_integer_32
									else
										l_p___0.ce_gets (l_p___0 - 1)
										l_u16c := (l_p___0.item).to_integer_32
										l_p___0.ce_gets (l_p___0 - 1)
										l_u16c := l_u16c + (((l_p___0.item).to_integer_32).bit_shift_left (8))
									end
									l_u8c := (65536 + ((((l_u16c).bit_and (1023))).bit_shift_left (10))) + ((l_u8c).bit_and (1023))
									if not (l_u16c < 55296) then
										l_pos := -1 + 187 -- skip if block
									end
				when 185 then -- if:
									l_pos := -1 + 188 -- goto _L___23
				when 186 then -- if block done, skip else block:
									l_pos := -1 + 190
				when 187 then -- else:
									if not (l_u16c > 56319) then
										l_pos := -1 + 190 -- skip if block
									end
				when 188 then -- if: | _L___23:
									if l_can_retry.to_boolean then
										l_pos := -1 + 228 -- goto rewind_retry
									end
				when 189 then
									if l_conv_error = 0 then
										l_conv_error := readfile_linenr (l_linecnt, l_ptr, l_p___0)
									end
									if l_bad_char_behavior = -2 then
										js.continue
									end
									if not js.loop_jumped and then (l_bad_char_behavior /= -1) then
										l_u8c := l_bad_char_behavior
									end
				when 190 then -- if done | if done | if done | if done | if done | if done | if block done, skip else block:
									l_pos := -1 + 200
				when 191 then -- else:
									if not (((l_fio_flags).bit_and (8)).to_boolean) then
										l_pos := -1 + 194 -- skip if block
									end
				when 192 then -- if:
									if ((l_fio_flags).bit_and (128)).to_boolean then
										l_p___0.ce_gets (l_p___0 - 1)
										l_u8c := ((l_p___0.item).to_integer_32).bit_shift_left (24)
										l_p___0.ce_gets (l_p___0 - 1)
										l_u8c := l_u8c + (((l_p___0.item).to_integer_32).bit_shift_left (16))
										l_p___0.ce_gets (l_p___0 - 1)
										l_u8c := l_u8c + (((l_p___0.item).to_integer_32).bit_shift_left (8))
										l_p___0.ce_gets (l_p___0 - 1)
										l_u8c := l_u8c + (l_p___0.item).to_integer_32
									else
										l_p___0.ce_gets (l_p___0 - 1)
										l_u8c := (l_p___0.item).to_integer_32
										l_p___0.ce_gets (l_p___0 - 1)
										l_u8c := l_u8c + (((l_p___0.item).to_integer_32).bit_shift_left (8))
										l_p___0.ce_gets (l_p___0 - 1)
										l_u8c := l_u8c + (((l_p___0.item).to_integer_32).bit_shift_left (16))
										l_p___0.ce_gets (l_p___0 - 1)
										l_u8c := l_u8c + (((l_p___0.item).to_integer_32).bit_shift_left (24))
									end
				when 193 then -- if block done, skip else block:
									l_pos := -1 + 200
				when 194 then -- else:
									l_p___0.ce_gets (l_p___0 - 1)
									if not ((l_p___0.item).to_integer_32 < 128) then
										l_pos := -1 + 197 -- skip if block
									end
				when 195 then -- if:
									l_u8c := (l_p___0.item).to_integer_32
				when 196 then -- if block done, skip else block:
									l_pos := -1 + 200
				when 197 then -- else:
									l_len := mbyte_inst.utf_head_off (l_ptr, l_p___0)
									l_p___0.ce_gets (l_p___0 - l_len)
									l_u8c := mbyte_inst.utf_ptr2char (l_p___0)
									if l_len /= 0 then
										l_pos := -1 + 200 -- skip if block
									end
				when 198 then -- if:
									if l_can_retry.to_boolean then
										l_pos := -1 + 228 -- goto rewind_retry
									end
				when 199 then
									if l_conv_error = 0 then
										l_conv_error := readfile_linenr (l_linecnt, l_ptr, l_p___0)
									end
									if l_bad_char_behavior = -2 then
										js.continue
									end
									if not js.loop_jumped and then (l_bad_char_behavior /= -1) then
										l_u8c := l_bad_char_behavior
									end
				when 200 then -- if done | if done | if done | if done
									if js.loop_jumped then
										l_pos := -1 + 209 -- skip if block
									end
				when 201 then -- if:
									if not (globals_inst.enc_utf8.to_boolean) then
										l_pos := -1 + 204 -- skip if block
									end
				when 202 then -- if:
									l_dest.ce_gets (l_dest - (mbyte_inst.utf_char2len (l_u8c)))
									mbyte_inst.utf_char2bytes (l_u8c, l_dest).do_nothing
				when 203 then -- if block done, skip else block:
									l_pos := -1 + 209
				when 204 then -- else:
									l_dest.ce_gets (l_dest - 1)
									if not (l_u8c >= 256) then
										l_pos := -1 + 208 -- skip if block
									end
				when 205 then -- if:
									if l_can_retry.to_boolean then
										l_pos := -1 + 228 -- goto rewind_retry
									end
				when 206 then
									if l_conv_error = 0 then
										l_conv_error := readfile_linenr (l_linecnt, l_ptr, l_p___0)
									end
									if l_bad_char_behavior = -2 then
										l_dest.ce_gets (l_dest + 1)
									elseif l_bad_char_behavior = -1 then
										l_dest.item := l_u8c.to_natural_8
									elseif (a_eap.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										if a_eap.item.bad_char /= 0 then
											l_dest.item := l_bad_char_behavior.to_natural_8
										else
											l_dest.item := (191).to_natural_8
										end
									else
										l_dest.item := (191).to_natural_8
									end
				when 207 then -- if block done, skip else block:
									l_pos := -1 + 209
				when 208 then -- else:
									l_dest.item := l_u8c.to_natural_8
				when 209 then -- if done | if done | if done
									l_pos := -1 + 172 -- back to loop condition
				when 210 then -- loop done
									l_line_start.ce_gets (l_dest - l_linerest)
									memmove (create {CE_POINTER [ANY]}.make_cast (l_line_start), create {CE_POINTER [ANY]}.make_cast (l_buffer), l_linerest.to_natural_32).do_nothing
									l_size := ((l_ptr + l_real_size).distance (l_dest)).to_integer_32
									l_ptr.ce_gets (l_dest)
				when 211 then -- if block done, skip else block:
									l_pos := -1 + 229
				when 212 then -- else:
									if not (globals_inst.enc_utf8.to_boolean) then
										l_pos := -1 + 229 -- skip if block
									end
				when 213 then -- if:
									if (globals_inst.curbuf.item.b_p_bin).to_boolean then
										l_pos := -1 + 229 -- skip if block
									end
				when 214 then -- if:
									l_incomplete_tail := 0
									l_p___0.ce_gets (l_ptr)
				when 215 then -- loop condition:
									if js.loop_left then
										l_pos := -1 + 226 -- skip loop
									end
				when 216 then -- loop body:
									js.reset
									l_todo := (l_ptr + l_size).distance (l_p___0)
									if l_todo <= 0 then
										js.break
									end
									if not (not js.loop_jumped and then ((l_p___0.item).to_integer_32 >= 128)) then
										l_pos := -1 + 225 -- skip if block
									end
				when 217 then -- if:
									l_l := mbyte_inst.utf_ptr2len_len (l_p___0, l_todo)
									if l_l > l_todo then
										if not l_incomplete_tail.to_boolean then
											if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_ptr.c_pointer.to_integer_32).to_natural_32 then
												l_incomplete_tail := 1
											elseif l_filesize > 0 then
												l_incomplete_tail := 1
											end
											if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_ptr.c_pointer.to_integer_32).to_natural_32 then
												l_conv_restlen := l_todo
												memmove (create {CE_POINTER [ANY]}.make_cast (l_conv_rest), create {CE_POINTER [ANY]}.make_cast (l_p___0), l_conv_restlen.to_natural_32).do_nothing
												l_size := l_size - l_conv_restlen.to_integer_32
												js.break
											end
										end
									end
									if js.loop_jumped then
										l_pos := -1 + 225 -- skip if block
									end
				when 218 then -- if:
									if l_l /= 1 then
										l_pos := -1 + 221 -- skip if block
									end
				when 219 then -- if:
									l_pos := -1 + 222 -- goto _L___24
				when 220 then -- if block done, skip else block:
									l_pos := -1 + 225
				when 221 then -- else:
									if not (l_l > l_todo) then
										l_pos := -1 + 224 -- skip if block
									end
				when 222 then -- if: | _L___24:
									if l_can_retry.to_boolean then
										if not l_incomplete_tail.to_boolean then
											js.break
										end
									end
									if not js.loop_jumped then
										if (l_iconv_fd.c_pointer.to_integer_32).to_natural_32 /= (-1).to_natural_32 then
											if l_conv_error = 0 then
												l_conv_error := readfile_linenr (l_linecnt, l_ptr, l_p___0)
											end
										end
										if l_conv_error = 0 then
											if l_illegal_byte = 0 then
												l_illegal_byte := readfile_linenr (l_linecnt, l_ptr, l_p___0)
											end
										end
										if l_bad_char_behavior = -2 then
											memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 1)), (l_todo - 1).to_natural_32).do_nothing
											l_p___0.ce_gets (l_p___0 - 1)
											l_size := l_size - 1
										elseif l_bad_char_behavior /= -1 then
											l_p___0.item := l_bad_char_behavior.to_natural_8
										end
									end
				when 223 then -- if block done, skip else block:
									l_pos := -1 + 225
				when 224 then -- else:
									l_p___0.ce_gets (l_p___0 + (l_l - 1))
				when 225 then -- if done | if done | if done
									if not js.loop_jumped then
										l_p___0.ce_gets (l_p___0 + 1)
									end
									l_pos := -1 + 215 -- back to loop condition
				when 226 then -- loop done
									js.reset
									if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_ptr + l_size).c_pointer.to_integer_32).to_natural_32) then
										l_pos := -1 + 229 -- skip if block
									end
				when 227 then -- if:
									if l_incomplete_tail.to_boolean then
										l_pos := -1 + 229 -- skip if block
									end
				when 228 then -- if: | rewind_retry:
									if (option_inst.p_ccv.item).to_integer_32 /= 0 then
										if (l_iconv_fd.c_pointer.to_integer_32).to_natural_32 /= (-1).to_natural_32 then
											l_did_iconv := 1
										else
											l_advance_fenc := 1
										end
									else
										l_advance_fenc := 1
									end
									l_file_rewind := 1
									l_pos := -1 + 69 -- goto retry
				when 229 then -- if done | if done | if done | if done
									l_filesize := l_filesize + l_size
									if l_fileformat /= -1 then
										l_pos := -1 + 236 -- skip if block
									end
				when 230 then -- if:
									if not (l_try_dos.to_boolean) then
										l_pos := -1 + 233 -- skip if block
									end
				when 231 then -- if:
									l_pos := -1 + 234 -- goto _L___25
				when 232 then -- if block done, skip else block:
									l_pos := -1 + 235
				when 233 then -- else:
									if not (l_try_unix.to_boolean) then
										l_pos := -1 + 235 -- skip if block
									end
				when 234 then -- if: | _L___25:
									l_p___0.ce_gets (l_ptr)
									from
									until
										not (not js.loop_left and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_ptr + l_size).c_pointer.to_integer_32).to_natural_32))
									loop
										js.reset
										if (l_p___0.item).to_integer_32 = 10 then
											if not l_try_unix.to_boolean then
												l_fileformat := 1
											elseif l_try_dos.to_boolean then
												if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_ptr.c_pointer.to_integer_32).to_natural_32 then
													if (l_p___0[-1]).to_integer_32 = 13 then
														l_fileformat := 1
													else
														l_fileformat := 0
													end
												else
													l_fileformat := 0
												end
											else
												l_fileformat := 0
											end
											js.break
										end
										if not js.loop_jumped then
											l_p___0.ce_gets (l_p___0 + 1)
										end
									end
									js.reset
									if l_fileformat = 0 then
										if l_try_mac.to_boolean then
											l_try_mac := 1
											l_try_unix := 1
											from
											until
												js.loop_left
											loop
												js.reset
												if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_ptr.c_pointer.to_integer_32).to_natural_32 then
													if (l_p___0.item).to_integer_32 = 13 then
														js.break
													end
												else
													js.break
												end
												if not js.loop_jumped then
													l_p___0.ce_gets (l_p___0 - 1)
												end
											end
											js.reset
											if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_ptr.c_pointer.to_integer_32).to_natural_32 then
												l_p___0.ce_gets (l_ptr)
												from
												until
													not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_ptr + l_size).c_pointer.to_integer_32).to_natural_32)
												loop
													if (l_p___0.item).to_integer_32 = 10 then
														l_try_unix := l_try_unix + 1
													elseif (l_p___0.item).to_integer_32 = 13 then
														l_try_mac := l_try_mac + 1
													end
													l_p___0.ce_gets (l_p___0 + 1)
												end
												if l_try_mac > l_try_unix then
													l_fileformat := 2
												end
											end
										end
									end
				when 235 then -- if done
									if l_fileformat = -1 then
										if l_try_mac.to_boolean then
											l_fileformat := 2
										end
									end
									if l_fileformat = -1 then
										l_fileformat := misc2_inst.default_fileformat
									end
									if l_set_options.to_boolean then
										misc2_inst.set_fileformat (l_fileformat, 4)
									end
				when 236 then -- if done
									if l_fileformat /= 2 then
										l_pos := -1 + 239 -- skip if block
									end
				when 237 then -- if:
									l_ptr.ce_gets (l_ptr - 1)
									from
									until
										js.loop_left
									loop
										js.reset
										l_ptr.ce_gets (l_ptr + 1)
										l_size := l_size - 1
										if not (l_size >= 0) then
											js.break
										end
										if not js.loop_jumped then
											l_c := l_ptr.item
											if l_c.to_integer_32 /= 0 then
												if l_c.to_integer_32 /= 13 then
													if l_c.to_integer_32 /= 10 then
														js.continue
													end
												end
											end
										end
										if not js.loop_jumped then
											if l_c.to_integer_32 = 0 then
												l_ptr.item := (('%N').code).to_natural_8
											elseif l_c.to_integer_32 = 10 then
												l_ptr.item := (('%R').code).to_natural_8
											else
												if l_skip_count = 0 then
													l_ptr.item := (('%/0/').code).to_natural_8
													l_len := (l_ptr.distance (l_line_start)) + 1
													if (memline_inst.ml_append (l_lnum, l_line_start, l_len, l_newfile)) = 0 then
														l_error := 1
														js.break
													end
													if not js.loop_jumped then
														if l_read_undo_file.to_boolean then
															sha256_inst.sha256_update (l_sha_ctx.address, l_line_start, l_len.to_natural_32)
														end
														l_lnum := l_lnum + 1
														l_read_count := l_read_count - 1
														if l_read_count = 0 then
															l_error := 1
															l_line_start.ce_gets (l_ptr)
															js.break
														end
													end
												else
													l_skip_count := l_skip_count - 1
												end
												if not js.loop_jumped then
													l_line_start.ce_gets (l_ptr + 1)
												end
											end
										end
									end
									js.reset
				when 238 then -- if block done, skip else block:
									l_pos := -1 + 265
				when 239 then -- else:
									l_ptr.ce_gets (l_ptr - 1)
				when 240 then -- loop condition:
									if js.loop_left then
										l_pos := -1 + 264 -- skip loop
									end
				when 241 then -- loop body:
									js.reset
									l_ptr.ce_gets (l_ptr + 1)
									l_size := l_size - 1
									if not (l_size >= 0) then
										js.break
									end
									if not js.loop_jumped then
										l_c := l_ptr.item
										if l_c.to_integer_32 /= 0 then
											if l_c.to_integer_32 /= 10 then
												js.continue
											end
										end
									end
									if js.loop_jumped then
										l_pos := -1 + 263 -- skip if block
									end
				when 242 then -- if:
									if l_c.to_integer_32 /= 0 then
										l_pos := -1 + 245 -- skip if block
									end
				when 243 then -- if:
									l_ptr.item := (('%N').code).to_natural_8
				when 244 then -- if block done, skip else block:
									l_pos := -1 + 263
				when 245 then -- else:
									if l_skip_count /= 0 then
										l_pos := -1 + 261 -- skip if block
									end
				when 246 then -- if:
									l_ptr.item := (('%/0/').code).to_natural_8
									l_len := (l_ptr.distance (l_line_start)) + 1
									if l_fileformat /= 1 then
										l_pos := -1 + 259 -- skip if block
									end
				when 247 then -- if:
									if (l_ptr[-1]).to_integer_32 /= 13 then
										l_pos := -1 + 250 -- skip if block
									end
				when 248 then -- if:
									l_ptr[-1] := (('%/0/').code).to_natural_8
									l_len := l_len - 1
				when 249 then -- if block done, skip else block:
									l_pos := -1 + 259
				when 250 then -- else:
									if l_ff_error = 1 then
										l_pos := -1 + 259 -- skip if block
									end
				when 251 then -- if:
									if not (l_try_unix.to_boolean) then
										l_pos := -1 + 258 -- skip if block
									end
				when 252 then -- if:
									if l_read_stdin___0.to_boolean then
										l_pos := -1 + 258 -- skip if block
									end
				when 253 then -- if:
									if not (l_read_buffer.to_boolean) then
										l_pos := -1 + 256 -- skip if block
									end
				when 254 then -- if:
									l_pos := -1 + 257 -- goto _L___26
				when 255 then -- if block done, skip else block:
									l_pos := -1 + 258
				when 256 then -- else:
									if (lseek (l_fd, 0, 0)) /= 0 then
										l_pos := -1 + 258 -- skip if block
									end
				when 257 then -- if: | _L___26:
									l_fileformat := 0
									if l_set_options.to_boolean then
										misc2_inst.set_fileformat (0, 4)
									end
									l_file_rewind := 1
									l_keep_fileformat := 1
									l_pos := -1 + 69 -- goto retry
				when 258 then -- if done | if done | if done
									l_ff_error := 1
				when 259 then -- if done | if done | if done
									if (memline_inst.ml_append (l_lnum, l_line_start, l_len, l_newfile)) = 0 then
										l_error := 1
										js.break
									end
									if not js.loop_jumped then
										if l_read_undo_file.to_boolean then
											sha256_inst.sha256_update (l_sha_ctx.address, l_line_start, l_len.to_natural_32)
										end
										l_lnum := l_lnum + 1
										l_read_count := l_read_count - 1
										if l_read_count = 0 then
											l_error := 1
											l_line_start.ce_gets (l_ptr)
											js.break
										end
									end
				when 260 then -- if block done, skip else block:
									l_pos := -1 + 262
				when 261 then -- else:
									l_skip_count := l_skip_count - 1
				when 262 then -- if done
									if not js.loop_jumped then
										l_line_start.ce_gets (l_ptr + 1)
									end
				when 263 then -- if done | if done
									l_pos := -1 + 240 -- back to loop condition
				when 264 then -- loop done
									js.reset
				when 265 then -- if done
									l_linerest := (l_ptr.distance (l_line_start)).to_integer_32
									ui_inst.ui_breakcheck
				when 266 then -- if done
									l_pos := -1 + 106 -- back to loop condition
				when 267 then -- loop done
									js.reset
				when 268 then -- failed:
									if l_error.to_boolean then
										if l_read_count = 0 then
											l_error := 0
										end
									end
									if l_error.to_boolean then
										l_pos := -1 + 275 -- skip if block
									end
				when 269 then -- if:
									if globals_inst.got_int.to_boolean then
										l_pos := -1 + 275 -- skip if block
									end
				when 270 then -- if:
									if l_linerest = 0 then
										l_pos := -1 + 275 -- skip if block
									end
				when 271 then -- if:
									if (globals_inst.curbuf.item.b_p_bin).to_boolean then
										l_pos := -1 + 274 -- skip if block
									end
				when 272 then -- if:
									if l_fileformat = 1 then
										if (l_line_start.item).to_integer_32 = 26 then
											if (l_ptr.c_pointer.to_integer_32).to_natural_32 /= ((l_line_start + 1).c_pointer.to_integer_32).to_natural_32 then
												l_pos := -1 + 274 -- goto _L___29
											end
										else
											l_pos := -1 + 274 -- goto _L___29
										end
									else
										l_pos := -1 + 274 -- goto _L___29
									end
				when 273 then -- if block done, skip else block:
									l_pos := -1 + 275
				when 274 then -- else: | _L___29:
									if l_set_options.to_boolean then
										globals_inst.curbuf.item.b_p_eol := 0
									end
									l_ptr.item := (('%/0/').code).to_natural_8
									l_len := (l_ptr.distance (l_line_start)) + 1
									if (memline_inst.ml_append (l_lnum, l_line_start, l_len, l_newfile)) = 0 then
										l_error := 1
									else
										if l_read_undo_file.to_boolean then
											sha256_inst.sha256_update (l_sha_ctx.address, l_line_start, l_len.to_natural_32)
										end
										l_lnum := l_lnum + 1
										l_read_no_eol_lnum := l_lnum
									end
				when 275 then -- if done | if done | if done
									if l_set_options.to_boolean then
										option_inst.save_file_ff (globals_inst.curbuf)
									end
									if (l_cryptkey.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										misc2_inst.crypt_pop_state
										if (l_cryptkey.c_pointer.to_integer_32).to_natural_32 /= ((globals_inst.curbuf.item.b_p_key).c_pointer.to_integer_32).to_natural_32 then
											misc2_inst.free_crypt_key (l_cryptkey)
										end
									end
									if l_set_options.to_boolean then
										option_inst.set_string_option_direct (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("fenc")), -1, l_fenc, 5, 0)
									end
									if l_fenc_alloced.to_boolean then
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fenc))
									end
									if (l_iconv_fd.c_pointer.to_integer_32).to_natural_32 /= (-1).to_natural_32 then
										iconv_close (l_iconv_fd).do_nothing
										l_iconv_fd.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer + -1))
									end
									if l_read_buffer.to_boolean then
										l_pos := -1 + 278 -- skip if block
									end
				when 276 then -- if:
									if not l_read_stdin___0.to_boolean then
										close (l_fd).do_nothing
									else
										l_pos := -1 + 278 -- goto _L___30
									end
				when 277 then -- if block done, skip else block:
									l_pos := -1 + 279
				when 278 then -- else: | _L___30:
									l_fdflags := (fcntl ([l_fd, 1]))
									if l_fdflags >= 0 then
										if ((l_fdflags).bit_and (1)) = 0 then
											fcntl ([l_fd, 2, (l_fdflags).bit_or (1)]).do_nothing
										end
									end
				when 279 then
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buffer))
									if l_read_stdin___0.to_boolean then
										close (0).do_nothing
										globals_inst.ignored := dup (2)
									end
									if (l_tmpname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmpname)).do_nothing
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tmpname))
									end
									globals_inst.no_wait_return := globals_inst.no_wait_return - 1
									if not globals_inst.recoverymode.to_boolean then
										if l_newfile.to_boolean then
											if l_wasempty.to_boolean then
												if not ((globals_inst.curbuf.item.b_ml.ml_flags).bit_and (1)).to_boolean then
													globals_inst.netbeansFireChanges := 0
													memline_inst.ml_delete (globals_inst.curbuf.item.b_ml.ml_line_count, 0).do_nothing
													globals_inst.netbeansFireChanges := 1
													l_linecnt := l_linecnt - 1
												end
											end
										end
										l_linecnt := globals_inst.curbuf.item.b_ml.ml_line_count - l_linecnt
										if l_filesize = 0 then
											l_linecnt := (0).to_integer_32
										end
										if l_newfile.to_boolean then
											screen_inst.redraw_curbuf_later (40)
											diff_inst.diff_invalidate (globals_inst.curbuf)
											fold_inst.foldUpdateAll (globals_inst.curwin)
										elseif l_read_buffer.to_boolean then
											screen_inst.redraw_curbuf_later (40)
											diff_inst.diff_invalidate (globals_inst.curbuf)
											fold_inst.foldUpdateAll (globals_inst.curwin)
										elseif l_linecnt.to_boolean then
											misc1_inst.appended_lines_mark (a_from, l_linecnt)
										end
										if l_read_stdin___0.to_boolean then
											term_inst.settmode (2)
											term_inst.starttermcap
											screen_inst.screenclear
										end
										if globals_inst.got_int.to_boolean then
											if not ((a_flags___0).bit_and (16)).to_boolean then
												filemess (globals_inst.curbuf, l_sfname, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_interr)))), 0)
												if l_newfile.to_boolean then
													globals_inst.curbuf.item.b_p_ro := 1
												end
											end
											globals_inst.msg_scroll := l_msg_save
											check_marks_read
											Result := 1
											js.return
										end
										if not js.return_called then
											if not l_filtering.to_boolean then
												if not ((a_flags___0).bit_and (16)).to_boolean then
													msg_add_fname (globals_inst.curbuf, l_sfname)
													l_c := (0).to_natural_8
													if ((l_perm).bit_and (61440)) = 4096 then
														strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("[fifo/socket]")))).do_nothing
														l_c := (1).to_natural_8
													end
													if (globals_inst.curbuf.item.b_p_ro).to_boolean then
														if (option_inst.shortmess (('r').code)).to_boolean then
															l_tmp___89.ce_gets ((gettext (ce_string ("[RO]"))))
														else
															l_tmp___89.ce_gets ((gettext (ce_string ("[readonly]"))))
														end
														strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), l_tmp___89).do_nothing
														l_c := (1).to_natural_8
													end
													if l_read_no_eol_lnum.to_boolean then
														msg_add_eol
														l_c := (1).to_natural_8
													end
													if l_ff_error = 1 then
														strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("[CR missing]")))).do_nothing
														l_c := (1).to_natural_8
													end
													if l_split.to_boolean then
														strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("[long lines split]")))).do_nothing
														l_c := (1).to_natural_8
													end
													if l_notconverted.to_boolean then
														strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("[NOT converted]")))).do_nothing
														l_c := (1).to_natural_8
													elseif l_converted.to_boolean then
														strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("[converted]")))).do_nothing
														l_c := (1).to_natural_8
													end
													if (l_cryptkey.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
														strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("[crypted]")))).do_nothing
														l_c := (1).to_natural_8
													end
													if l_conv_error /= 0 then
														l_tmp___96.ce_gets (gettext (ce_string ("[CONVERSION ERROR in line %%ld]")))
														sprintf ([(create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff))).to_integer_32), l_tmp___96, l_conv_error]).do_nothing
														l_c := (1).to_natural_8
													elseif l_illegal_byte > 0 then
														l_tmp___98.ce_gets (gettext (ce_string ("[ILLEGAL BYTE in line %%ld]")))
														sprintf ([(create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff) + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff))).to_integer_32), l_tmp___98, l_illegal_byte]).do_nothing
														l_c := (1).to_natural_8
													elseif l_error.to_boolean then
														strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("[READ ERRORS]")))).do_nothing
														l_c := (1).to_natural_8
													end
													if (msg_add_fileformat (l_fileformat)).to_boolean then
														l_c := (1).to_natural_8
													end
													if (l_cryptkey.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
														msg_add_lines (l_c.to_integer_32, l_linecnt, ((l_filesize - 12) - (crypt_salt_len[globals_inst.use_crypt_method]).to_integer_32) - (crypt_seed_len[globals_inst.use_crypt_method]).to_integer_32)
													else
														msg_add_lines (l_c.to_integer_32, l_linecnt, l_filesize)
													end
													misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.keep_msg))
													globals_inst.keep_msg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
													globals_inst.msg_scrolled_ign := 1
													l_p___0.ce_gets (message_inst.msg_trunc_attr (globals_inst.IObuff, 0, 0))
													if l_read_stdin___0.to_boolean then
														message_inst.set_keep_msg (l_p___0, 0)
													elseif l_read_buffer.to_boolean then
														message_inst.set_keep_msg (l_p___0, 0)
													elseif globals_inst.restart_edit /= 0 then
														message_inst.set_keep_msg (l_p___0, 0)
													elseif globals_inst.msg_scrolled /= 0 then
														if not globals_inst.need_wait_return.to_boolean then
															message_inst.set_keep_msg (l_p___0, 0)
														end
													end
													globals_inst.msg_scrolled_ign := 0
												end
											end
											if l_newfile.to_boolean then
												if l_error.to_boolean then
													globals_inst.curbuf.item.b_p_ro := 1
												elseif l_conv_error /= 0 then
													globals_inst.curbuf.item.b_p_ro := 1
												elseif l_illegal_byte > 0 then
													if l_bad_char_behavior /= -1 then
														globals_inst.curbuf.item.b_p_ro := 1
													end
												end
											end
											undo_inst.u_clearline
											if globals_inst.exmode_active.to_boolean then
												globals_inst.curwin.item.w_cursor.lnum := a_from + l_linecnt
											else
												globals_inst.curwin.item.w_cursor.lnum := a_from + 1
											end
											misc2_inst.check_cursor_lnum
											edit_inst.beginline (5)
											globals_inst.curbuf.item.b_op_start.lnum := a_from + 1
											globals_inst.curbuf.item.b_op_start.col := 0
											globals_inst.curbuf.item.b_op_end.lnum := a_from + l_linecnt
											globals_inst.curbuf.item.b_op_end.col := 0
										end
									end
				when 280 then -- if done
								if not js.return_called then
									globals_inst.msg_scroll := l_msg_save
									check_marks_read
									globals_inst.write_no_eol_lnum := l_read_no_eol_lnum
									if ((a_flags___0).bit_and (32)).to_boolean then
										undo_inst.u_find_first_changed
									end
									if l_read_undo_file.to_boolean then
										sha256_inst.sha256_finish (l_sha_ctx.address, create {CE_POINTER [NATURAL_8]}.make_cast (l_hash))
										undo_inst.u_read_undo (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_hash, l_fname)
									end
									if not l_read_stdin___0.to_boolean then
										if not l_read_buffer.to_boolean then
											l_m___0 := globals_inst.msg_scroll
											l_n___1 := globals_inst.msg_scrolled
											if l_set_options.to_boolean then
												option_inst.save_file_ff (globals_inst.curbuf)
											end
											globals_inst.msg_scroll := 1
											if l_filtering.to_boolean then
												apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILTERREADPOST, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_sfname, 0, globals_inst.curbuf, a_eap).do_nothing
											elseif l_newfile.to_boolean then
												apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_BUFREADPOST, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_sfname, 0, globals_inst.curbuf, a_eap).do_nothing
											else
												apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEREADPOST, l_sfname, l_sfname, 0, create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), a_eap).do_nothing
											end
											if globals_inst.msg_scrolled = l_n___1 then
												globals_inst.msg_scroll := l_m___0
											end
											if (ex_eval_inst.aborting).to_boolean then
												Result := 0
												js.return
											end
										end
									end
								end
								if not js.return_called and then (globals_inst.recoverymode.to_boolean) then
									if l_error.to_boolean then
										Result := 0
										js.return
									end
								end
								if not js.return_called then
									Result := 1
								end
				when 281 then
								l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
					end

	readfile_linenr (a_linecnt: INTEGER_32; a_p___0: CE_POINTER [NATURAL_8]; a_endp: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_lnum: INTEGER_32
		do
			create l_s.make

			l_lnum := (globals_inst.curbuf.item.b_ml.ml_line_count - a_linecnt) + 1
			l_s.ce_gets (a_p___0)
			from
			until
				not ((l_s.c_pointer.to_integer_32).to_natural_32 < (a_endp.c_pointer.to_integer_32).to_natural_32)
			loop
				if (l_s.item).to_integer_32 = 10 then
					l_lnum := l_lnum + 1
				end
				l_s.ce_gets (l_s + 1)
			end
			Result := l_lnum
		end

	prep_exarg (a_eap: CE_POINTER [PD_EXARG]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			l_tmp := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6.item.b_p_ff))
			a_eap.item.cmd := misc2_inst.alloc ((l_tmp + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6.item.b_p_fenc)))) + {NATURAL_32} 15)
			if ((a_eap.item.cmd).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 0
				js.return
			end
			if not js.return_called then
				sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.cmd), ce_string ("e ++ff=%%s ++enc=%%s"), a_buf___6.item.b_p_ff, a_buf___6.item.b_p_fenc]).do_nothing
				a_eap.item.force_enc := 14 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6.item.b_p_ff))).to_integer_32
				a_eap.item.bad_char := a_buf___6.item.b_bad_char
				a_eap.item.force_ff := 7
				if (a_buf___6.item.b_p_bin).to_boolean then
					a_eap.item.force_bin := 1
				else
					a_eap.item.force_bin := 2
				end
				a_eap.item.read_edit := 0
				a_eap.item.forceit := 0
				Result := 1
			end
		end

	next_fenc (a_pp: CE_POINTER [CE_POINTER [NATURAL_8]]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_r: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_r.make

			if ((a_pp.item).item).to_integer_32 = 0 then
				a_pp.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
				js.return
			end
			if not js.return_called then
				l_p___0.ce_gets (misc2_inst.vim_strchr (a_pp.item, (',').code))
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_r.ce_gets (mbyte_inst.enc_canonize (a_pp.item))
					a_pp.item := a_pp.item + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_pp.item))).to_integer_32
				else
					l_r.ce_gets (misc2_inst.vim_strnsave (a_pp.item, l_p___0.distance ((a_pp.item))))
					a_pp.item := l_p___0 + 1
					if (l_r.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_p___0.ce_gets (mbyte_inst.enc_canonize (l_r))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_r))
						l_r.ce_gets (l_p___0)
					end
				end
				if (l_r.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_r.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
					a_pp.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				end
				Result := l_r
			end
		end

	readfile_charconvert (a_fname: CE_POINTER [NATURAL_8]; a_fenc: CE_POINTER [NATURAL_8]; a_fdp: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		local
			l_tmpname: CE_POINTER [NATURAL_8]
			l_errmsg: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___4: INTEGER_32
		do
			create l_tmpname.make
			create l_errmsg.make
			create l_tmp___1.make

			l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			l_tmpname.ce_gets (vim_tempname (('r').code))
			if (l_tmpname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Can%'t find temp file for conversion")))))
			else
				close (a_fdp.item).do_nothing
				a_fdp.item := -1
				if globals_inst.enc_utf8.to_boolean then
					l_tmp___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("utf-8")))
				else
					l_tmp___1.ce_gets (option_inst.p_enc)
				end
				if (eval_inst.eval_charconvert (a_fenc, l_tmp___1, a_fname, l_tmpname)) = 0 then
					l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Conversion with %'charconvert%' failed")))))
				end
				if (l_errmsg.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_tmp___4 := open ([create {CE_POINTER [INTEGER_8]}.make_cast (l_tmpname), 0, 0])
					a_fdp.item := l_tmp___4
					if l_tmp___4 < 0 then
						l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("can%'t read output of %'charconvert%'")))))
					end
				end
			end
			if (l_errmsg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				message_inst.msg (l_errmsg).do_nothing
				if (l_tmpname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmpname)).do_nothing
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tmpname))
					l_tmpname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				end
			end
			if a_fdp.item < 0 then
				a_fdp.item := open ([create {CE_POINTER [INTEGER_8]}.make_cast (a_fname), 0, 0])
			end
			Result := l_tmpname
		end

	check_marks_read
		do
			if not (globals_inst.curbuf.item.b_marks_read).to_boolean then
				if (option_inst.get_viminfo_parameter (('%'').code)) > 0 then
					if ((globals_inst.curbuf.item.b_ffname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						ex_cmds_inst.read_viminfo (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 2).do_nothing
					end
				end
			end
			globals_inst.curbuf.item.b_marks_read := 1
		end

	crypt_method_from_magic (a_ptr: CE_POINTER [INTEGER_8]; a_len: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (l_i___0 < ((Pointer_bytes.to_natural_32 * (2).to_natural_32) // Pointer_bytes.to_natural_32).to_integer_32))
			loop
				js.reset
				if a_len < (12 + crypt_salt_len[l_i___0]) + crypt_seed_len[l_i___0] then
					js.continue
				end
				if not js.loop_jumped then
					if (memcmp (create {CE_POINTER [ANY]}.make_cast (a_ptr), create {CE_POINTER [ANY]}.make_cast (crypt_magic[l_i___0]), (12).to_natural_32)) = 0 then
						Result := l_i___0
						js.return
					end
				end
				if not js.loop_left then
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				l_i___0 := (strlen (crypt_magic_head)).to_integer_32
				if a_len >= l_i___0 then
					if (memcmp (create {CE_POINTER [ANY]}.make_cast (a_ptr), create {CE_POINTER [ANY]}.make_cast (crypt_magic_head), l_i___0.to_natural_32)) = 0 then
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E821: File is encrypted with unknown method"))))).do_nothing
					end
				end
				Result := (-1)
			end
		end

	check_for_cryptkey (a_cryptkey: CE_POINTER [NATURAL_8]; a_ptr: CE_POINTER [NATURAL_8]; a_sizep: CE_POINTER [INTEGER_32]; a_filesizep: CE_POINTER [INTEGER_32]; a_newfile: INTEGER_32; a_fname: CE_POINTER [NATURAL_8]; a_did_ask: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		local
			l_cryptkey: CE_POINTER [NATURAL_8]
			l_method: INTEGER_32
			l_seed_len: INTEGER_32
			l_salt_len: INTEGER_32
		do
			create l_cryptkey.make

			l_cryptkey.ce_gets (a_cryptkey)
			l_method := (crypt_method_from_magic (create {CE_POINTER [INTEGER_8]}.make_cast (a_ptr), (a_sizep.item).to_integer_32))
			if l_method >= 0 then
				misc2_inst.set_crypt_method (globals_inst.curbuf, l_method)
				if l_method > 0 then
					blowfish_inst.blowfish_self_test.do_nothing
				end
				if (l_cryptkey.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					if not (a_did_ask.item).to_boolean then
						if ((globals_inst.curbuf.item.b_p_key).item).to_boolean then
							l_cryptkey.ce_gets (globals_inst.curbuf.item.b_p_key)
						else
							message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (globals_inst.need_key_msg))), a_fname]).do_nothing
							globals_inst.msg_scroll := 1
							l_cryptkey.ce_gets (misc2_inst.get_crypt_key (a_newfile, 0))
							a_did_ask.item := 1
							if (l_cryptkey.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if (l_cryptkey.item).to_integer_32 = 0 then
									if (l_cryptkey.c_pointer.to_integer_32).to_natural_32 /= ((globals_inst.curbuf.item.b_p_key).c_pointer.to_integer_32).to_natural_32 then
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cryptkey))
									end
									l_cryptkey.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								end
							end
						end
					end
				end
				if (l_cryptkey.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					l_seed_len := crypt_seed_len[l_method]
					l_salt_len := crypt_salt_len[l_method]
					misc2_inst.crypt_push_state
					globals_inst.use_crypt_method := l_method
					if l_method = 0 then
						misc2_inst.crypt_init_keys (l_cryptkey)
					else
						blowfish_inst.bf_key_init (l_cryptkey, a_ptr + 12, l_salt_len)
						blowfish_inst.bf_ofb_init ((a_ptr + 12) + l_salt_len, l_seed_len)
					end
					a_filesizep.item := a_filesizep.item + ((12 + l_salt_len) + l_seed_len).to_integer_32
					a_sizep.item := a_sizep.item - ((12 + l_salt_len) + l_seed_len).to_integer_32
					memmove (create {CE_POINTER [ANY]}.make_cast (a_ptr), create {CE_POINTER [ANY]}.make_cast ((((a_ptr + 12) + l_salt_len) + l_seed_len)), (a_sizep.item).to_natural_32).do_nothing
				end
			elseif a_newfile.to_boolean then
				if ((globals_inst.curbuf.item.b_p_key).item).to_integer_32 /= 0 then
					if not globals_inst.starting.to_boolean then
						option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("key")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 4)
					end
				end
			end
			Result := l_cryptkey
		end

	prepare_crypt_read (a_fp: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_method: INTEGER_32
			l_buffer: CE_ARRAY [NATURAL_8]
			l_salt_len: INTEGER_32
			l_seed_len: INTEGER_32
			js: JUMP_STATE
		do
			create l_buffer.make (<<30>>)

			if (fread (create {CE_POINTER [ANY]}.make_cast (l_buffer), (12).to_natural_32, (1).to_natural_32, a_fp)) /= {NATURAL_32} 1 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_method := crypt_method_from_magic (create {CE_POINTER [INTEGER_8]}.make_cast (l_buffer), 28)
				if l_method < 0 then
					Result := 0
					js.return
				elseif l_method /= (misc2_inst.get_crypt_method (globals_inst.curbuf)) then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				misc2_inst.crypt_push_state
				if l_method = 0 then
					misc2_inst.crypt_init_keys (globals_inst.curbuf.item.b_p_key)
				else
					l_salt_len := crypt_salt_len[l_method]
					l_seed_len := crypt_seed_len[l_method]
					if (fread (create {CE_POINTER [ANY]}.make_cast (l_buffer), (l_salt_len + l_seed_len).to_natural_32, (1).to_natural_32, a_fp)) /= {NATURAL_32} 1 then
						Result := 0
						js.return
					end
					if not js.return_called then
						blowfish_inst.bf_key_init (globals_inst.curbuf.item.b_p_key, l_buffer, l_salt_len)
						blowfish_inst.bf_ofb_init (l_buffer + l_salt_len, l_seed_len)
					end
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	prepare_crypt_write (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_lenp: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		local
			l_header: CE_POINTER [NATURAL_8]
			l_seed_len: INTEGER_32
			l_salt_len: INTEGER_32
			l_salt: CE_POINTER [NATURAL_8]
			l_seed: CE_POINTER [NATURAL_8]
		do
			create l_header.make
			create l_salt.make
			create l_seed.make

			l_seed_len := crypt_seed_len[(misc2_inst.get_crypt_method (a_buf___6))]
			l_salt_len := crypt_salt_len[(misc2_inst.get_crypt_method (a_buf___6))]
			l_header.ce_gets (misc2_inst.alloc_clear ({NATURAL_32} 30))
			if (l_header.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				misc2_inst.crypt_push_state
				globals_inst.use_crypt_method := misc2_inst.get_crypt_method (a_buf___6)
				misc2_inst.vim_strncpy (l_header, create {CE_POINTER [NATURAL_8]}.make_cast (crypt_magic[globals_inst.use_crypt_method]), (12).to_natural_32)
				if globals_inst.use_crypt_method = 0 then
					misc2_inst.crypt_init_keys (a_buf___6.item.b_p_key)
				else
					l_salt.ce_gets (l_header + 12)
					l_seed.ce_gets (l_salt + l_salt_len)
					sha256_inst.sha2_seed (l_salt, l_salt_len, l_seed, l_seed_len)
					blowfish_inst.bf_key_init (a_buf___6.item.b_p_key, l_salt, l_salt_len)
					blowfish_inst.bf_ofb_init (l_seed, l_seed_len)
				end
			end
			a_lenp.item := (12 + l_salt_len) + l_seed_len
			Result := l_header
		end

	set_file_time (a_fname: CE_POINTER [NATURAL_8]; a_atime: INTEGER_32; a_mtime: INTEGER_32)
		local
			l_buf___6: SD_UTIMBUF
		do
			create l_buf___6.make

			l_buf___6.actime := a_atime
			l_buf___6.modtime := a_mtime
			utime (create {CE_POINTER [INTEGER_8]}.make_cast (a_fname), (l_buf___6.address)).do_nothing
		end

	check_file_readonly (a_fname: CE_POINTER [NATURAL_8]; a_perm: INTEGER_32): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if ((a_perm).bit_and (146)) = 0 then
				l_tmp___0 := 1
			elseif (access (create {CE_POINTER [INTEGER_8]}.make_cast (a_fname), 2)).to_boolean then
				l_tmp___0 := 1
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	buf_write (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_fname: CE_POINTER [NATURAL_8]; a_sfname: CE_POINTER [NATURAL_8]; a_start___1: INTEGER_32; a_end: INTEGER_32; a_eap: CE_POINTER [PD_EXARG]; a_append: INTEGER_32; a_forceit: INTEGER_32; a_reset_changed: INTEGER_32; a_filtering: INTEGER_32): INTEGER_32
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_fname: CE_POINTER [NATURAL_8]
			l_sfname: CE_POINTER [NATURAL_8]
			l_start___1: INTEGER_32
			l_end: INTEGER_32
			l_fd: INTEGER_32
			l_backup: CE_POINTER [NATURAL_8]
			l_backup_copy: INTEGER_32
			l_dobackup: INTEGER_32
			l_ffname: CE_POINTER [NATURAL_8]
			l_wfname: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_ptr: CE_POINTER [NATURAL_8]
			l_c: NATURAL_8
			l_len: INTEGER_32
			l_lnum: INTEGER_32
			l_nchars: INTEGER_32
			l_errmsg: CE_POINTER [NATURAL_8]
			l_errmsg_allocated: INTEGER_32
			l_errnum: CE_POINTER [NATURAL_8]
			l_buffer: CE_POINTER [NATURAL_8]
			l_smallbuf: CE_ARRAY [NATURAL_8]
			l_backup_ext: CE_POINTER [NATURAL_8]
			l_bufsize: INTEGER_32
			l_perm: INTEGER_32
			l_retval: INTEGER_32
			l_newfile: INTEGER_32
			l_msg_save: INTEGER_32
			l_overwriting: INTEGER_32
			l_no_eol: INTEGER_32
			l_device: INTEGER_32
			l_st_old: SD_STAT
			l_prev_got_int: INTEGER_32
			l_file_readonly: INTEGER_32
			l_made_writable: INTEGER_32
			l_whole: INTEGER_32
			l_tmp: INTEGER_32
			l_old_line_count: INTEGER_32
			l_attr: INTEGER_32
			l_fileformat: INTEGER_32
			l_write_bin: INTEGER_32
			l_write_info: PD_BW_INFO
			l_converted: INTEGER_32
			l_notconverted: INTEGER_32
			l_fenc: CE_POINTER [NATURAL_8]
			l_fenc_tofree: CE_POINTER [NATURAL_8]
			l_wb_flags: INTEGER_32
			l_acl: CE_POINTER [ANY]
			l_write_undo_file: INTEGER_32
			l_sha_ctx: PD_CONTEXT_SHA256_T
			l_aco: PD_ACO_SAVE_T
			l_buf_ffname: INTEGER_32
			l_buf_sfname: INTEGER_32
			l_buf_fname_f: INTEGER_32
			l_buf_fname_s: INTEGER_32
			l_did_cmd: INTEGER_32
			l_nofile_err: INTEGER_32
			l_empty_memline: INTEGER_32
			l_tmp___33: INTEGER_32
			l_st: SD_STAT
			l_i___0: INTEGER_32
			l_lstat_res: INTEGER_32
			l_bfd: INTEGER_32
			l_copybuf: CE_POINTER [NATURAL_8]
			l_wp___0: CE_POINTER [NATURAL_8]
			l_some_error: INTEGER_32
			l_st_new: SD_STAT
			l_dirp: CE_POINTER [NATURAL_8]
			l_rootname: CE_POINTER [NATURAL_8]
			l_did_set_shortname: INTEGER_32
			l_tmp___39: INTEGER_32
			l_tmp___40: NATURAL_32
			l_dirp___0: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_rootname___0: CE_POINTER [NATURAL_8]
			l_tmp___54: INTEGER_32
			l_tmp___55: NATURAL_32
			l_tmp___66: CE_POINTER [NATURAL_8]
			l_st___0: SD_STAT
			l_tmp___70: CE_POINTER [INTEGER_8]
			l_st___1: SD_STAT
			l_tmp___79: INTEGER_32
			l_tmp___80: INTEGER_32
			l_tmp___81: INTEGER_32
			l_header: CE_POINTER [NATURAL_8]
			l_header_len: INTEGER_32
			l_tmp___84: INTEGER_32
			l_tmp___88: CE_POINTER [NATURAL_8]
			l_tmp___89: CE_POINTER [NATURAL_8]
			l_tmp___91: CE_POINTER [NATURAL_8]
			l_st___2: SD_STAT
			l_tmp___99: CE_POINTER [NATURAL_8]
			l_tmp___117: CE_POINTER [INTEGER_8]
			l_tmp___124: CE_POINTER [INTEGER_8]
			l_tmp___129: CE_POINTER [INTEGER_8]
			l_org: CE_POINTER [INTEGER_8]
			l_tmp___134: INTEGER_32
			l_st___3: SD_STAT
			l_empty_fd: INTEGER_32
			l_tmp___138: CE_POINTER [INTEGER_8]
			l_tmp___139: INTEGER_32
			l_numlen: INTEGER_32
			l_tmp___144: INTEGER_32
			l_tmp___146: NATURAL_32
			l_hash: CE_ARRAY [NATURAL_8]
			l_aco___0: PD_ACO_SAVE_T
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___6.make
			create l_fname.make
			create l_sfname.make
			create l_backup.make
			create l_ffname.make
			create l_wfname.make
			create l_s.make
			create l_ptr.make
			create l_errmsg.make
			create l_errnum.make
			create l_buffer.make
			create l_smallbuf.make (<<256>>)
			create l_backup_ext.make
			create l_st_old.make
			create l_write_info.make
			create l_fenc.make
			create l_fenc_tofree.make
			create l_acl.make
			create l_sha_ctx.make
			create l_aco.make
			create l_st.make
			create l_copybuf.make
			create l_wp___0.make
			create l_st_new.make
			create l_dirp.make
			create l_rootname.make
			create l_dirp___0.make
			create l_p___0.make
			create l_rootname___0.make
			create l_tmp___66.make
			create l_st___0.make
			create l_tmp___70.make
			create l_st___1.make
			create l_header.make
			create l_tmp___88.make
			create l_tmp___89.make
			create l_tmp___91.make
			create l_st___2.make
			create l_tmp___99.make
			create l_tmp___117.make
			create l_tmp___124.make
			create l_tmp___129.make
			create l_org.make
			create l_st___3.make
			create l_tmp___138.make
			create l_hash.make (<<32>>)
			create l_aco___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buf___6.ce_gets (a_buf___6)
					l_fname.ce_gets (a_fname)
					l_sfname.ce_gets (a_sfname)
					l_start___1 := a_start___1
					l_end := a_end
					l_backup.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_backup_copy := 0
					l_wfname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_errmsg_allocated := 0
					l_errnum.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_retval := 1
					l_newfile := 0
					l_msg_save := globals_inst.msg_scroll
					l_no_eol := 0
					l_device := 0
					l_prev_got_int := globals_inst.got_int
					l_file_readonly := 0
					l_made_writable := 0
					if l_start___1 = 1 then
						if l_end = l_buf___6.item.b_ml.ml_line_count then
							l_tmp := 1
						else
							l_tmp := 0
						end
					else
						l_tmp := 0
					end
					l_whole := l_tmp
					l_old_line_count := l_buf___6.item.b_ml.ml_line_count
					l_converted := 0
					l_notconverted := 0
					l_fenc_tofree.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_wb_flags := 0
					l_acl.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer))
					l_write_undo_file := 0
					if (l_fname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := 0
						js.return
					elseif (l_fname.item).to_integer_32 = 0 then
						Result := 0
						js.return
					end
					if not js.return_called and then (((l_buf___6.item.b_ml.ml_mfp).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32) then
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_emptybuf))))).do_nothing
						Result := 0
						js.return
					end
					if not js.return_called then
						if (ex_cmds_inst.check_secure).to_boolean then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname))) >= {NATURAL_32} 4096 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_longname))))).do_nothing
							Result := 0
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						l_write_info.bw_conv_buf := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						l_write_info.bw_conv_error := 0
						l_write_info.bw_conv_error_lnum := (0).to_integer_32
						l_write_info.bw_restlen := 0
						l_write_info.bw_iconv_fd := create {CE_POINTER [ANY]}.make_shared (default_pointer + -1)
						globals_inst.ex_no_reprint := 1
						if ((l_buf___6.item.b_ffname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 12 -- skip if block
						end
				when 2 then -- if:
						if not (a_reset_changed.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 3 then -- if:
						if not (l_whole.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 12 -- skip if block
						end
				when 5 then -- if:
						if (quickfix_inst.bt_nofile (l_buf___6)).to_boolean then
							l_pos := -1 + 12 -- skip if block
						end
				when 6 then -- if:
						if a_filtering.to_boolean then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						if a_append.to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else:
						if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('P').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L:
						if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('F').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (set_rw_fname (l_fname, l_sfname)) = 0 then
								Result := 0
								js.return
							end
							if not js.return_called then
								l_buf___6.ce_gets (globals_inst.curbuf)
							end
						end
				when 12 then -- if done | if done | if done | if done | if done | if done | if done | if done
						if js.return_called then
							l_pos := -1 + 37 -- skip if block
						end
				when 13 then -- if:
							if (l_sfname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_sfname.ce_gets (l_fname)
							end
							l_ffname.ce_gets (l_fname)
							l_fname.ce_gets (l_sfname)
							if ((l_buf___6.item.b_ffname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ffname), create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6.item.b_ffname))) = 0 then
									l_overwriting := 1
								else
									l_overwriting := 0
								end
							else
								l_overwriting := 0
							end
							if globals_inst.exiting.to_boolean then
								term_inst.settmode (0)
							end
							globals_inst.no_wait_return := globals_inst.no_wait_return + 1
							l_buf___6.item.b_op_start.lnum := l_start___1
							l_buf___6.item.b_op_start.col := 0
							l_buf___6.item.b_op_end.lnum := l_end
							l_buf___6.item.b_op_end.col := 0
							l_buf_ffname := 0
							l_buf_sfname := 0
							l_buf_fname_f := 0
							l_buf_fname_s := 0
							l_did_cmd := 0
							l_nofile_err := 0
							l_empty_memline := (((l_buf___6.item.b_ml.ml_mfp).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32).to_integer
							if (l_ffname.c_pointer.to_integer_32).to_natural_32 = ((l_buf___6.item.b_ffname).c_pointer.to_integer_32).to_natural_32 then
								l_buf_ffname := 1
							end
							if (l_sfname.c_pointer.to_integer_32).to_natural_32 = ((l_buf___6.item.b_sfname).c_pointer.to_integer_32).to_natural_32 then
								l_buf_sfname := 1
							end
							if (l_fname.c_pointer.to_integer_32).to_natural_32 = ((l_buf___6.item.b_ffname).c_pointer.to_integer_32).to_natural_32 then
								l_buf_fname_f := 1
							end
							if (l_fname.c_pointer.to_integer_32).to_natural_32 = ((l_buf___6.item.b_sfname).c_pointer.to_integer_32).to_natural_32 then
								l_buf_fname_s := 1
							end
							aucmd_prepbuf (l_aco.address, l_buf___6)
							if not (a_append.to_boolean) then
								l_pos := -1 + 16 -- skip if block
							end
				when 14 then -- if:
							l_did_cmd := apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEAPPENDCMD, l_sfname, l_sfname, 0, globals_inst.curbuf, a_eap)
							if not l_did_cmd.to_boolean then
								if l_overwriting.to_boolean then
									if (quickfix_inst.bt_nofile (globals_inst.curbuf)).to_boolean then
										l_nofile_err := 1
									else
										apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEAPPENDPRE, l_sfname, l_sfname, 0, globals_inst.curbuf, a_eap).do_nothing
									end
								else
									apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEAPPENDPRE, l_sfname, l_sfname, 0, globals_inst.curbuf, a_eap).do_nothing
								end
							end
				when 15 then -- if block done, skip else block:
							l_pos := -1 + 23
				when 16 then -- else:
							if not (a_filtering.to_boolean) then
								l_pos := -1 + 19 -- skip if block
							end
				when 17 then -- if:
							apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILTERWRITEPRE, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_sfname, 0, globals_inst.curbuf, a_eap).do_nothing
				when 18 then -- if block done, skip else block:
							l_pos := -1 + 23
				when 19 then -- else:
							if not (a_reset_changed.to_boolean) then
								l_pos := -1 + 22 -- skip if block
							end
				when 20 then -- if:
							if l_whole.to_boolean then
								l_did_cmd := apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_BUFWRITECMD, l_sfname, l_sfname, 0, globals_inst.curbuf, a_eap)
								if not l_did_cmd.to_boolean then
									if l_overwriting.to_boolean then
										if (quickfix_inst.bt_nofile (globals_inst.curbuf)).to_boolean then
											l_nofile_err := 1
										else
											apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_BUFWRITEPRE, l_sfname, l_sfname, 0, globals_inst.curbuf, a_eap).do_nothing
										end
									else
										apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_BUFWRITEPRE, l_sfname, l_sfname, 0, globals_inst.curbuf, a_eap).do_nothing
									end
								end
							else
								l_pos := -1 + 22 -- goto _L___0
							end
				when 21 then -- if block done, skip else block:
							l_pos := -1 + 23
				when 22 then -- else: | _L___0:
							l_did_cmd := apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEWRITECMD, l_sfname, l_sfname, 0, globals_inst.curbuf, a_eap)
							if not l_did_cmd.to_boolean then
								if l_overwriting.to_boolean then
									if (quickfix_inst.bt_nofile (globals_inst.curbuf)).to_boolean then
										l_nofile_err := 1
									else
										apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEWRITEPRE, l_sfname, l_sfname, 0, globals_inst.curbuf, a_eap).do_nothing
									end
								else
									apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEWRITEPRE, l_sfname, l_sfname, 0, globals_inst.curbuf, a_eap).do_nothing
								end
							end
				when 23 then -- if done | if done
							aucmd_restbuf (l_aco.address)
							if not (buffer_inst.buf_valid (l_buf___6)).to_boolean then
								l_buf___6.ce_gets (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
							end
							if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_pos := -1 + 26 -- skip if block
							end
				when 24 then -- if:
							l_pos := -1 + 36 -- goto _L___1
				when 25 then -- if block done, skip else block:
							l_pos := -1 + 37
				when 26 then -- else:
							if ((l_buf___6.item.b_ml.ml_mfp).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_pos := -1 + 29 -- skip if block
							end
				when 27 then -- if:
							if not l_empty_memline.to_boolean then
								l_pos := -1 + 36 -- goto _L___1
							else
								l_pos := -1 + 29 -- goto _L___2
							end
				when 28 then -- if block done, skip else block:
							l_pos := -1 + 37
				when 29 then -- else: | _L___2:
							if not (l_did_cmd.to_boolean) then
								l_pos := -1 + 32 -- skip if block
							end
				when 30 then -- if:
							l_pos := -1 + 36 -- goto _L___1
				when 31 then -- if block done, skip else block:
							l_pos := -1 + 37
				when 32 then -- else:
							if not (l_nofile_err.to_boolean) then
								l_pos := -1 + 35 -- skip if block
							end
				when 33 then -- if:
							l_pos := -1 + 36 -- goto _L___1
				when 34 then -- if block done, skip else block:
							l_pos := -1 + 37
				when 35 then -- else:
							if not ((ex_eval_inst.aborting).to_boolean) then
								l_pos := -1 + 37 -- skip if block
							end
				when 36 then -- if: | _L___1:
							globals_inst.no_wait_return := globals_inst.no_wait_return - 1
							globals_inst.msg_scroll := l_msg_save
							if l_nofile_err.to_boolean then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E676: No matching autocommands for acwrite buffer"))))).do_nothing
							end
							if l_nofile_err.to_boolean then
								Result := 0
								js.return
							elseif (ex_eval_inst.aborting).to_boolean then
								Result := 0
								js.return
							end
							if not js.return_called and then (l_did_cmd.to_boolean) then
								if (l_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									Result := 1
									js.return
								end
								if not js.return_called then
									if l_overwriting.to_boolean then
										memline_inst.ml_timestamp (l_buf___6)
										if a_append.to_boolean then
											l_buf___6.item.b_flags := (l_buf___6.item.b_flags).bit_and ((-17))
										else
											l_buf___6.item.b_flags := (l_buf___6.item.b_flags).bit_and ((-89))
										end
									end
									if a_reset_changed.to_boolean then
										if (l_buf___6.item.b_changed).to_boolean then
											if not a_append.to_boolean then
												if l_overwriting.to_boolean then
													Result := 0
													js.return
												elseif ((misc2_inst.vim_strchr (option_inst.p_cpo, ('+').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
													Result := 0
													js.return
												end
											end
										end
									end
								end
								if not js.return_called then
									Result := 1
									js.return
								end
							end
							if not js.return_called then
								if not (ex_eval_inst.aborting).to_boolean then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E203: Autocommands deleted or unloaded buffer to be written"))))).do_nothing
								end
								Result := 0
								js.return
							end
				when 37 then -- if done | if done | if done | if done | if done
							if not js.return_called and then (l_buf___6.item.b_ml.ml_line_count /= l_old_line_count) then
								if l_whole.to_boolean then
									l_end := l_buf___6.item.b_ml.ml_line_count
								elseif l_buf___6.item.b_ml.ml_line_count > l_old_line_count then
									l_end := l_end + (l_buf___6.item.b_ml.ml_line_count - l_old_line_count)
								else
									l_end := l_end - (l_old_line_count - l_buf___6.item.b_ml.ml_line_count)
									if l_end < l_start___1 then
										globals_inst.no_wait_return := globals_inst.no_wait_return - 1
										globals_inst.msg_scroll := l_msg_save
										message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E204: Autocommand changed number of lines in unexpected way"))))).do_nothing
										Result := 0
										js.return
									end
								end
							end
							if not js.return_called then
								if l_buf_ffname.to_boolean then
									l_ffname.ce_gets (l_buf___6.item.b_ffname)
								end
								if l_buf_sfname.to_boolean then
									l_sfname.ce_gets (l_buf___6.item.b_sfname)
								end
								if l_buf_fname_f.to_boolean then
									l_fname.ce_gets (l_buf___6.item.b_ffname)
								end
								if l_buf_fname_s.to_boolean then
									l_fname.ce_gets (l_buf___6.item.b_sfname)
								end
								if (netbeans_inst.netbeans_active).to_boolean then
									if (netbeans_inst.isNetbeansBuffer (l_buf___6)).to_boolean then
										if l_whole.to_boolean then
											if (l_buf___6.item.b_changed).to_boolean then
												globals_inst.no_wait_return := globals_inst.no_wait_return - 1
												globals_inst.msg_scroll := l_msg_save
												netbeans_inst.netbeans_save_buffer (l_buf___6)
												Result := l_retval
												js.return
											elseif (netbeans_inst.isNetbeansModified (l_buf___6)).to_boolean then
												globals_inst.no_wait_return := globals_inst.no_wait_return - 1
												globals_inst.msg_scroll := l_msg_save
												netbeans_inst.netbeans_save_buffer (l_buf___6)
												Result := l_retval
												js.return
											else
												l_errnum.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E656: ")))
												l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("NetBeans disallows writes of unmodified buffers")))))
												l_buffer.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
												l_pos := -1 + 140 -- goto fail
											end
										else
											l_errnum.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E657: ")))
											l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Partial writes disallowed for NetBeans buffers")))))
											l_buffer.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
											l_pos := -1 + 140 -- goto fail
										end
									end
								end
							end
				when 38 then
							if js.return_called then
								l_pos := -1 + 142 -- skip if block
							end
				when 39 then -- if:
								if (option_inst.shortmess (('o').code)).to_boolean then
									if not globals_inst.exiting.to_boolean then
										globals_inst.msg_scroll := 0
									else
										globals_inst.msg_scroll := 1
									end
								else
									globals_inst.msg_scroll := 1
								end
								if not a_filtering.to_boolean then
									filemess (l_buf___6, l_fname, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 0)
								end
								globals_inst.msg_scroll := 0
								l_buffer.ce_gets (misc2_inst.alloc ({NATURAL_32} 8192))
								if (l_buffer.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_buffer.ce_gets (l_smallbuf)
									l_bufsize := 256
								else
									l_bufsize := 8192
								end
								l_st_old.st_dev := (0).to_natural_64
								l_st_old.st_ino := (0).to_natural_32
								l_perm := -1
								if not ((stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), (l_st_old.address))) < 0) then
									l_pos := -1 + 42 -- skip if block
								end
				when 40 then -- if:
								l_newfile := 1
				when 41 then -- if block done, skip else block:
								l_pos := -1 + 46
				when 42 then -- else:
								l_perm := (l_st_old.st_mode).to_integer_32
								if (((l_st_old.st_mode).bit_and ({NATURAL_32} 61440)) = {NATURAL_32} 32768) then
									l_pos := -1 + 46 -- skip if block
								end
				when 43 then -- if:
								if ((l_st_old.st_mode).bit_and ({NATURAL_32} 61440)) = {NATURAL_32} 16384 then
									l_errnum.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E502: ")))
									l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("is a directory")))))
									l_pos := -1 + 140 -- goto fail
								end
				when 44 then
								if (os_unix_inst.mch_nodetype (l_fname)) /= 1 then
									l_errnum.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E503: ")))
									l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("is not a file or writable device")))))
									l_pos := -1 + 140 -- goto fail
								end
				when 45 then
								l_device := 1
								l_newfile := 1
								l_perm := -1
				when 46 then -- if done | if done
								if l_device.to_boolean then
									l_pos := -1 + 50 -- skip if block
								end
				when 47 then -- if:
								if l_newfile.to_boolean then
									l_pos := -1 + 50 -- skip if block
								end
				when 48 then -- if:
								l_file_readonly := check_file_readonly (l_fname, l_perm.to_integer_32)
								if not a_forceit.to_boolean then
									if l_file_readonly.to_boolean then
										if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('W').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
											l_errnum.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E504: ")))
											l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (err_readonly))))
										else
											l_errnum.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E505: ")))
											l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("is read-only (add ! to override)")))))
										end
										l_pos := -1 + 140 -- goto fail
									end
								end
				when 49 then
								if l_overwriting.to_boolean then
									l_retval := check_mtime (l_buf___6, l_st_old.address)
									if l_retval = 0 then
										l_pos := -1 + 140 -- goto fail
									end
								end
				when 50 then -- if done
								if not l_newfile.to_boolean then
									l_acl.ce_gets (os_unix_inst.mch_get_acl (l_fname))
								end
								if option_inst.p_wb.to_boolean then
									l_tmp___33 := 1
								elseif option_inst.p_bk.to_boolean then
									l_tmp___33 := 1
								elseif (option_inst.p_pm.item).to_integer_32 /= 0 then
									l_tmp___33 := 1
								else
									l_tmp___33 := 0
								end
								l_dobackup := l_tmp___33
								if l_dobackup.to_boolean then
									if (option_inst.p_bsk.item).to_integer_32 /= 0 then
										if (match_file_list (option_inst.p_bsk, l_sfname, l_ffname)).to_boolean then
											l_dobackup := 0
										end
									end
								end
								l_prev_got_int := globals_inst.got_int
								globals_inst.got_int := 0
								l_buf___6.item.b_saving := 1
								if not (a_append.to_boolean) then
									l_pos := -1 + 53 -- skip if block
								end
				when 51 then -- if:
								if (option_inst.p_pm.item).to_integer_32 /= 0 then
									l_pos := -1 + 53 -- goto _L___6
								end
				when 52 then -- if block done, skip else block:
								l_pos := -1 + 84
				when 53 then -- else: | _L___6:
								if a_filtering.to_boolean then
									l_pos := -1 + 84 -- skip if block
								end
				when 54 then -- if:
								if not (l_perm >= 0) then
									l_pos := -1 + 84 -- skip if block
								end
				when 55 then -- if:
								if not (l_dobackup.to_boolean) then
									l_pos := -1 + 84 -- skip if block
								end
				when 56 then -- if:
								if ((option_inst.bkc_flags).bit_and ({NATURAL_32} 1)).to_boolean then
									l_backup_copy := 1
								elseif a_append.to_boolean then
									l_backup_copy := 1
								elseif ((option_inst.bkc_flags).bit_and ({NATURAL_32} 2)).to_boolean then
									if l_st_old.st_nlink > {NATURAL_32} 1 then
										l_backup_copy := 1
									elseif (lstat (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), (l_st.address))) < 0 then
										l_backup_copy := 1
									elseif l_st.st_dev /= l_st_old.st_dev then
										l_backup_copy := 1
									elseif l_st.st_ino /= l_st_old.st_ino then
										l_backup_copy := 1
									else
										strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), create {CE_POINTER [INTEGER_8]}.make_cast (l_fname)).do_nothing
										l_i___0 := 4913
										from
										until
											js.loop_left
										loop
											js.reset
											sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast ((misc1_inst.gettail (globals_inst.IObuff))), ce_string ("%%d"), l_i___0]).do_nothing
											if (lstat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (l_st.address))) < 0 then
												js.break
											end
											if not js.loop_jumped then
												l_i___0 := l_i___0 + (123)
											end
										end
										js.reset
										l_fd := open ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), 131265, l_perm])
										if l_fd < 0 then
											l_backup_copy := 1
										else
											globals_inst.ignored := fchown (l_fd, l_st_old.st_uid, l_st_old.st_gid)
											if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (l_st.address))) < 0 then
												l_backup_copy := 1
											elseif l_st.st_uid /= l_st_old.st_uid then
												l_backup_copy := 1
											elseif l_st.st_gid /= l_st_old.st_gid then
												l_backup_copy := 1
											elseif (l_st.st_mode).to_integer_32 /= l_perm then
												l_backup_copy := 1
											end
											close (l_fd).do_nothing
											unlink (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff)).do_nothing
										end
									end
								end
								if not (((option_inst.bkc_flags).bit_and ({NATURAL_32} 8)).to_boolean) then
									l_pos := -1 + 59 -- skip if block
								end
				when 57 then -- if:
								l_pos := -1 + 60 -- goto _L___3
				when 58 then -- if block done, skip else block:
								l_pos := -1 + 61
				when 59 then -- else:
								if not (((option_inst.bkc_flags).bit_and ({NATURAL_32} 16)).to_boolean) then
									l_pos := -1 + 61 -- skip if block
								end
				when 60 then -- if: | _L___3:
								l_lstat_res := lstat (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), (l_st.address))
								if ((option_inst.bkc_flags).bit_and ({NATURAL_32} 8)).to_boolean then
									if l_lstat_res = 0 then
										if l_st.st_ino /= l_st_old.st_ino then
											l_backup_copy := 0
										end
									end
								end
								if ((option_inst.bkc_flags).bit_and ({NATURAL_32} 16)).to_boolean then
									if l_st_old.st_nlink > {NATURAL_32} 1 then
										if l_lstat_res /= 0 then
											l_backup_copy := 0
										elseif l_st.st_ino = l_st_old.st_ino then
											l_backup_copy := 0
										end
									end
								end
				when 61 then -- if done
								if (option_inst.p_bex.item).to_integer_32 = 0 then
									l_backup_ext.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".bak")))
								else
									l_backup_ext.ce_gets (option_inst.p_bex)
								end
								if not (l_backup_copy.to_boolean) then
									l_pos := -1 + 82 -- skip if block
								end
				when 62 then -- if:
								l_fd := open ([create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), 0, 0])
								if not (l_fd >= 0) then
									l_pos := -1 + 80 -- skip if block
								end
				when 63 then -- if:
								l_some_error := 0
								l_copybuf.ce_gets (misc2_inst.alloc ({NATURAL_32} 8193))
								if (l_copybuf.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_some_error := 1
									l_pos := -1 + 73 -- goto nobackup
								end
				when 64 then
								l_dirp.ce_gets (option_inst.p_bdir)
				when 65 then -- loop condition:
								if not (not js.loop_left and then ((l_dirp.item).to_boolean)) then
									l_pos := -1 + 72 -- skip loop
								end
				when 66 then -- loop body:
								js.reset
								l_st_new.st_ino := (0).to_natural_32
								l_st_new.st_dev := (0).to_natural_64
								l_st_new.st_gid := (0).to_natural_32
								misc2_inst.copy_option_part (l_dirp.address, l_copybuf, 8192, ce_string (",")).do_nothing
								l_rootname.ce_gets (memline_inst.get_file_in_dir (l_fname, l_copybuf))
								if (l_rootname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_some_error := 1
									l_pos := -1 + 73 -- goto nobackup
								end
				when 67 then
								l_did_set_shortname := 0
				when 68 then -- loop condition:
								if js.loop_left then
									l_pos := -1 + 71 -- skip loop
								end
				when 69 then -- loop body:
								js.reset
								if (l_buf___6.item.b_p_sn).to_boolean then
									l_tmp___39 := 1
								elseif (l_buf___6.item.b_shortname).to_boolean then
									l_tmp___39 := 1
								else
									l_tmp___39 := 0
								end
								l_backup.ce_gets (buf_modname (l_tmp___39, l_rootname, l_backup_ext, 0))
								if (l_backup.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_rootname))
									l_some_error := 1
									l_pos := -1 + 73 -- goto nobackup
								end
				when 70 then
								if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_backup), (l_st_new.address))) >= 0 then
									if l_st_new.st_dev = l_st_old.st_dev then
										if l_st_new.st_ino = l_st_old.st_ino then
											misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_backup))
											l_backup.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
											if not (l_buf___6.item.b_shortname).to_boolean then
												if not (l_buf___6.item.b_p_sn).to_boolean then
													l_buf___6.item.b_shortname := 1
													l_did_set_shortname := 1
													js.continue
												end
											end
											if not js.loop_jumped then
												if l_did_set_shortname.to_boolean then
													l_buf___6.item.b_shortname := 0
												end
												js.break
											end
										end
									end
									if not js.loop_jumped and then (not option_inst.p_bk.to_boolean) then
										l_tmp___40 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_backup))
										l_wp___0.ce_gets (((l_backup + l_tmp___40.to_integer_32) - 1) - (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_backup_ext))).to_integer_32)
										if (l_wp___0.c_pointer.to_integer_32).to_natural_32 < (l_backup.c_pointer.to_integer_32).to_natural_32 then
											l_wp___0.ce_gets (l_backup)
										end
										l_wp___0.item := (('z').code).to_natural_8
										from
										until
											js.loop_left
										loop
											js.reset
											if (l_wp___0.item).to_integer_32 > 97 then
												if not ((stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_backup), (l_st_new.address))) >= 0) then
													js.break
												end
											else
												js.break
											end
											if not js.loop_jumped then
												l_wp___0.item := ((l_wp___0.item).to_integer_32 - 1).to_natural_8
											end
										end
										js.reset
										if (l_wp___0.item).to_integer_32 = 97 then
											misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_backup))
											l_backup.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
										end
									end
								end
								if not js.loop_jumped then
									js.break
								end
								if not js.loop_left then
									
								end
								l_pos := -1 + 68 -- back to loop condition
				when 71 then -- loop done
								js.reset
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_rootname))
								if (l_backup.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_backup)).do_nothing
									l_bfd := open ([create {CE_POINTER [INTEGER_8]}.make_cast (l_backup), 131265, (l_perm).bit_and (511)])
									if l_bfd < 0 then
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_backup))
										l_backup.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
									else
										os_unix_inst.mch_setperm (l_backup, (l_perm).bit_and (511)).do_nothing
										if l_st_new.st_gid /= l_st_old.st_gid then
											if (fchown (l_bfd, (-1).to_natural_32, l_st_old.st_gid)) /= 0 then
												os_unix_inst.mch_setperm (l_backup, (((l_perm).bit_and (455))).bit_or (((((l_perm).bit_and (7))).bit_shift_left (3)))).do_nothing
											end
										end
										l_write_info.bw_fd := l_bfd
										l_write_info.bw_buf := l_copybuf
										l_write_info.bw_flags := 8192
										from
										until
											js.loop_left
										loop
											js.reset
											l_write_info.bw_len := read (l_fd, create {CE_POINTER [ANY]}.make_cast (l_copybuf), (8192).to_natural_32)
											if not (l_write_info.bw_len > 0) then
												js.break
											end
											if not js.loop_jumped then
												if (buf_write_bytes (l_write_info.address)) = 0 then
													l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E506: Can%'t write to backup file (add ! to override)")))))
													js.break
												end
											end
											if not js.loop_jumped then
												ui_inst.ui_breakcheck
												if globals_inst.got_int.to_boolean then
													l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_interr)))))
													js.break
												end
											end
										end
										js.reset
										if (close (l_bfd)) < 0 then
											if (l_errmsg.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
												l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E507: Close error for backup file (add ! to override)")))))
											end
										end
										if l_write_info.bw_len < 0 then
											l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E508: Can%'t read file for backup (add ! to override)")))))
										end
										set_file_time (l_backup, l_st_old.st_atim.tv_sec, l_st_old.st_mtim.tv_sec)
										os_unix_inst.mch_set_acl (l_backup, l_acl)
										js.break
									end
								end
								l_pos := -1 + 65 -- back to loop condition
				when 72 then -- loop done
								js.reset
				when 73 then -- nobackup:
								close (l_fd).do_nothing
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_copybuf))
								if (l_backup.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									if (l_errmsg.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E509: Cannot create backup file (add ! to override)")))))
									end
								end
								if not (l_some_error.to_boolean) then
									l_pos := -1 + 76 -- skip if block
								end
				when 74 then -- if:
								l_pos := -1 + 77 -- goto _L___4
				when 75 then -- if block done, skip else block:
								l_pos := -1 + 78
				when 76 then -- else:
								if (l_errmsg.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_pos := -1 + 78 -- skip if block
								end
				when 77 then -- if: | _L___4:
								if not a_forceit.to_boolean then
									l_retval := 0
									l_pos := -1 + 140 -- goto fail
								end
				when 78 then -- if done
								l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				when 79 then -- if block done, skip else block:
								l_pos := -1 + 81
				when 80 then -- else:
								l_pos := -1 + 82 -- goto _L___5
				when 81 then -- if done | if block done, skip else block:
								l_pos := -1 + 84
				when 82 then -- else: | _L___5:
								if l_file_readonly.to_boolean then
									if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('W').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										l_errnum.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E504: ")))
										l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (err_readonly))))
										l_pos := -1 + 140 -- goto fail
									end
								end
				when 83 then
								l_dirp___0.ce_gets (option_inst.p_bdir)
								from
								until
									not (not js.loop_left and then ((l_dirp___0.item).to_boolean))
								loop
									js.reset
									misc2_inst.copy_option_part (l_dirp___0.address, globals_inst.IObuff, 1025, ce_string (",")).do_nothing
									l_rootname___0.ce_gets (memline_inst.get_file_in_dir (l_fname, globals_inst.IObuff))
									if (l_rootname___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										l_backup.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
									else
										if (l_buf___6.item.b_p_sn).to_boolean then
											l_tmp___54 := 1
										elseif (l_buf___6.item.b_shortname).to_boolean then
											l_tmp___54 := 1
										else
											l_tmp___54 := 0
										end
										l_backup.ce_gets (buf_modname (l_tmp___54, l_rootname___0, l_backup_ext, 0))
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_rootname___0))
									end
									if (l_backup.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										if not option_inst.p_bk.to_boolean then
											if (os_unix_inst.mch_getperm (l_backup)) >= 0 then
												l_tmp___55 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_backup))
												l_p___0.ce_gets (((l_backup + l_tmp___55.to_integer_32) - 1) - (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_backup_ext))).to_integer_32)
												if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_backup.c_pointer.to_integer_32).to_natural_32 then
													l_p___0.ce_gets (l_backup)
												end
												l_p___0.item := (('z').code).to_natural_8
												from
												until
													js.loop_left
												loop
													js.reset
													if (l_p___0.item).to_integer_32 > 97 then
														if not ((os_unix_inst.mch_getperm (l_backup)) >= 0) then
															js.break
														end
													else
														js.break
													end
													if not js.loop_jumped then
														l_p___0.item := ((l_p___0.item).to_integer_32 - 1).to_natural_8
													end
												end
												js.reset
												if (l_p___0.item).to_integer_32 = 97 then
													misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_backup))
													l_backup.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
												end
											end
										end
									end
									if (l_backup.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										if (vim_rename (l_fname, l_backup)) = 0 then
											js.break
										end
										if not js.loop_jumped then
											misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_backup))
											l_backup.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
										end
									end
								end
								js.reset
								if (l_backup.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									if not a_forceit.to_boolean then
										l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E510: Can%'t make backup file (add ! to override)")))))
										l_pos := -1 + 140 -- goto fail
									end
								end
				when 84 then -- if done | if done | if done | if done
								if a_forceit.to_boolean then
									if l_perm >= 0 then
										if not ((l_perm).bit_and (128)).to_boolean then
											if l_st_old.st_uid = (getuid) then
												if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('W').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
													l_perm := (l_perm).bit_or ((128))
													os_unix_inst.mch_setperm (l_fname, l_perm).do_nothing
													l_made_writable := 1
												end
											end
										end
									end
								end
								if a_forceit.to_boolean then
									if l_overwriting.to_boolean then
										if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('Z').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
											l_buf___6.item.b_p_ro := 0
											globals_inst.need_maketitle := 1
											screen_inst.status_redraw_all
										end
									end
								end
								if l_end > l_buf___6.item.b_ml.ml_line_count then
									l_end := l_buf___6.item.b_ml.ml_line_count
								end
								if ((l_buf___6.item.b_ml.ml_flags).bit_and (1)).to_boolean then
									l_start___1 := l_end + 1
								end
								if not (a_reset_changed.to_boolean) then
									l_pos := -1 + 91 -- skip if block
								end
				when 85 then -- if:
								if l_newfile.to_boolean then
									l_pos := -1 + 91 -- skip if block
								end
				when 86 then -- if:
								if not (l_overwriting.to_boolean) then
									l_pos := -1 + 91 -- skip if block
								end
				when 87 then -- if:
								if not (globals_inst.exiting.to_boolean) then
									l_pos := -1 + 90 -- skip if block
								end
				when 88 then -- if:
								if (l_backup.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_pos := -1 + 90 -- goto _L___7
								end
				when 89 then -- if block done, skip else block:
								l_pos := -1 + 91
				when 90 then -- else: | _L___7:
								memline_inst.ml_preserve (l_buf___6, 0)
								if globals_inst.got_int.to_boolean then
									l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_interr)))))
									l_pos := -1 + 114 -- goto restore_backup
								end
				when 91 then -- if done | if done | if done
								l_wfname.ce_gets (l_fname)
								if (a_eap.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if a_eap.item.force_enc /= 0 then
										l_fenc.ce_gets (a_eap.item.cmd + a_eap.item.force_enc)
										l_fenc.ce_gets (mbyte_inst.enc_canonize (l_fenc))
										l_fenc_tofree.ce_gets (l_fenc)
									else
										l_fenc.ce_gets (l_buf___6.item.b_p_fenc)
									end
								else
									l_fenc.ce_gets (l_buf___6.item.b_p_fenc)
								end
								l_converted := need_conversion (l_fenc)
								if not (l_converted.to_boolean) then
									l_pos := -1 + 97 -- skip if block
								end
				when 92 then -- if:
								if not (globals_inst.enc_utf8.to_boolean) then
									l_pos := -1 + 95 -- skip if block
								end
				when 93 then -- if:
								l_pos := -1 + 96 -- goto _L___8
				when 94 then -- if block done, skip else block:
								l_pos := -1 + 97
				when 95 then -- else:
								if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_enc), ce_string ("latin1"))) /= 0 then
									l_pos := -1 + 97 -- skip if block
								end
				when 96 then -- if: | _L___8:
								l_wb_flags := get_fio_flags (l_fenc)
								if ((l_wb_flags).bit_and (30)).to_boolean then
									if ((l_wb_flags).bit_and (22)).to_boolean then
										l_write_info.bw_conv_buflen := l_bufsize * 2
									else
										l_write_info.bw_conv_buflen := l_bufsize * 4
									end
									l_write_info.bw_conv_buf := misc2_inst.lalloc ((l_write_info.bw_conv_buflen).to_natural_32, 1)
									if ((l_write_info.bw_conv_buf).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										l_end := (0).to_integer_32
									end
								end
				when 97 then -- if done | if done
								if l_converted.to_boolean then
									if l_wb_flags = 0 then
										if globals_inst.enc_utf8.to_boolean then
											l_tmp___66.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("utf-8")))
										else
											l_tmp___66.ce_gets (option_inst.p_enc)
										end
										l_write_info.bw_iconv_fd := (mbyte_inst.my_iconv_open (l_fenc, l_tmp___66))
										if ((l_write_info.bw_iconv_fd).c_pointer.to_integer_32).to_natural_32 /= (-1).to_natural_32 then
											l_write_info.bw_conv_buflen := l_bufsize * 8
											l_write_info.bw_conv_buf := misc2_inst.lalloc ((l_write_info.bw_conv_buflen).to_natural_32, 1)
											if ((l_write_info.bw_conv_buf).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
												l_end := (0).to_integer_32
											end
											l_write_info.bw_first := 1
										elseif (option_inst.p_ccv.item).to_integer_32 /= 0 then
											l_wfname.ce_gets (vim_tempname (('w').code))
											if (l_wfname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
												l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E214: Can%'t find temp file for writing")))))
												l_pos := -1 + 114 -- goto restore_backup
											end
										end
									end
								end
				when 98 then
								if not (l_converted.to_boolean) then
									l_pos := -1 + 104 -- skip if block
								end
				when 99 then -- if:
								if l_wb_flags /= 0 then
									l_pos := -1 + 104 -- skip if block
								end
				when 100 then -- if:
								if ((l_write_info.bw_iconv_fd).c_pointer.to_integer_32).to_natural_32 /= (-1).to_natural_32 then
									l_pos := -1 + 104 -- skip if block
								end
				when 101 then -- if:
								if (l_wfname.c_pointer.to_integer_32).to_natural_32 /= (l_fname.c_pointer.to_integer_32).to_natural_32 then
									l_pos := -1 + 104 -- skip if block
								end
				when 102 then -- if:
								if not a_forceit.to_boolean then
									l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E213: Cannot convert (add ! to write without conversion)")))))
									l_pos := -1 + 114 -- goto restore_backup
								end
				when 103 then
								l_notconverted := 1
				when 104 then -- if done | if done | if done | if done
								if js.loop_left then
									l_pos := -1 + 116 -- skip loop
								end
				when 105 then -- loop body:
								js.reset
								if l_perm < 0 then
									l_tmp___79 := 438
								else
									l_tmp___79 := (l_perm).bit_and (511)
								end
								if a_append.to_boolean then
									if a_forceit.to_boolean then
										l_tmp___80 := 1088
									else
										l_tmp___80 := 1024
									end
									l_tmp___81 := l_tmp___80
								else
									l_tmp___81 := 576
								end
								l_fd := open ([create {CE_POINTER [INTEGER_8]}.make_cast (l_wfname), (1).bit_or (l_tmp___81), l_tmp___79])
								if not (l_fd < 0) then
									js.break
								end
								if not (not js.loop_jumped and then ((l_errmsg.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32)) then
									l_pos := -1 + 113 -- skip if block
								end
				when 106 then -- if:
								if l_newfile.to_boolean then
									l_pos := -1 + 109 -- skip if block
								end
				when 107 then -- if:
								if l_st_old.st_nlink > {NATURAL_32} 1 then
									l_tmp___70.ce_gets (gettext (ce_string ("E166: Can%'t open linked file for writing")))
									l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___70))
								else
									l_pos := -1 + 109 -- goto _L___10
								end
				when 108 then -- if block done, skip else block:
								l_pos := -1 + 113
				when 109 then -- else: | _L___10:
								if (lstat (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), (l_st___0.address))) /= 0 then
									l_pos := -1 + 112 -- skip if block
								end
				when 110 then -- if:
								if l_st___0.st_dev /= l_st_old.st_dev then
									l_tmp___70.ce_gets (gettext (ce_string ("E166: Can%'t open linked file for writing")))
									l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___70))
								elseif l_st___0.st_ino /= l_st_old.st_ino then
									l_tmp___70.ce_gets (gettext (ce_string ("E166: Can%'t open linked file for writing")))
									l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___70))
								else
									l_pos := -1 + 112 -- goto _L___9
								end
				when 111 then -- if block done, skip else block:
								l_pos := -1 + 113
				when 112 then -- else: | _L___9:
								l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E212: Can%'t open file for writing")))))
								if a_forceit.to_boolean then
									if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('W').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										if l_perm >= 0 then
											if not ((l_perm).bit_and (128)).to_boolean then
												l_made_writable := 1
											end
											l_perm := (l_perm).bit_or ((128))
											if l_st_old.st_uid /= (getuid) then
												l_perm := (l_perm).bit_and ((511))
											elseif l_st_old.st_gid /= (getgid) then
												l_perm := (l_perm).bit_and ((511))
											end
											if not a_append.to_boolean then
												unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_wfname)).do_nothing
											end
											js.continue
										end
									end
								end
				when 113 then -- if done | if done
								if js.loop_jumped then
									l_pos := -1 + 115 -- skip if block
								end
				when 114 then -- if: | restore_backup:
								if (l_backup.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if (l_wfname.c_pointer.to_integer_32).to_natural_32 = (l_fname.c_pointer.to_integer_32).to_natural_32 then
										if l_backup_copy.to_boolean then
											if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), (l_st___1.address))) < 0 then
												vim_rename (l_backup, l_fname).do_nothing
											end
											if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), (l_st___1.address))) >= 0 then
												unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_backup)).do_nothing
											end
										else
											vim_rename (l_backup, l_fname).do_nothing
										end
									end
								end
								if not l_newfile.to_boolean then
									if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), (l_st___1.address))) < 0 then
										l_end := (0).to_integer_32
									end
								end
								if (l_wfname.c_pointer.to_integer_32).to_natural_32 /= (l_fname.c_pointer.to_integer_32).to_natural_32 then
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_wfname))
								end
								l_pos := -1 + 140 -- goto fail
				when 115 then
								l_pos := -1 + 104 -- back to loop condition
				when 116 then -- loop done
								js.reset
								l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								l_write_info.bw_fd := l_fd
								if ((l_buf___6.item.b_p_key).item).to_integer_32 /= 0 then
									if not a_filtering.to_boolean then
										l_header.ce_gets (prepare_crypt_write (l_buf___6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_header_len)))
										if (l_header.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
											l_end := (0).to_integer_32
										else
											l_write_info.bw_buf := l_header
											l_write_info.bw_len := l_header_len
											l_write_info.bw_flags := 8192
											if (buf_write_bytes (l_write_info.address)) = 0 then
												l_end := (0).to_integer_32
											end
											l_wb_flags := (l_wb_flags).bit_or ((4096))
											misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_header))
										end
									end
								end
								l_write_info.bw_buf := l_buffer
								l_nchars := 0
								if (a_eap.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if a_eap.item.force_bin /= 0 then
										l_write_bin := (a_eap.item.force_bin = 1).to_integer
									else
										l_write_bin := l_buf___6.item.b_p_bin
									end
								else
									l_write_bin := l_buf___6.item.b_p_bin
								end
								if not ((l_buf___6.item.b_p_bomb).to_boolean) then
									l_pos := -1 + 123 -- skip if block
								end
				when 117 then -- if:
								if l_write_bin.to_boolean then
									l_pos := -1 + 123 -- skip if block
								end
				when 118 then -- if:
								if a_append.to_boolean then
									l_pos := -1 + 121 -- skip if block
								end
				when 119 then -- if:
								l_pos := -1 + 122 -- goto _L___11
				when 120 then -- if block done, skip else block:
								l_pos := -1 + 123
				when 121 then -- else:
								if not (l_perm < 0) then
									l_pos := -1 + 123 -- skip if block
								end
				when 122 then -- if: | _L___11:
								l_write_info.bw_len := make_bom (l_buffer, l_fenc)
								if l_write_info.bw_len > 0 then
									l_write_info.bw_flags := (8192).bit_or (l_wb_flags)
									if (buf_write_bytes (l_write_info.address)) = 0 then
										l_end := (0).to_integer_32
									else
										l_nchars := l_nchars + (l_write_info.bw_len).to_integer_32
									end
								end
				when 123 then -- if done | if done | if done
								l_write_info.bw_start_lnum := l_start___1
								if (l_buf___6.item.b_p_udf).to_boolean then
									if l_overwriting.to_boolean then
										if not a_append.to_boolean then
											if not a_filtering.to_boolean then
												if a_reset_changed.to_boolean then
													l_tmp___84 := 1
												else
													l_tmp___84 := 0
												end
											else
												l_tmp___84 := 0
											end
										else
											l_tmp___84 := 0
										end
									else
										l_tmp___84 := 0
									end
								else
									l_tmp___84 := 0
								end
								l_write_undo_file := l_tmp___84
								if l_write_undo_file.to_boolean then
									sha256_inst.sha256_start (l_sha_ctx.address)
								end
								l_write_info.bw_len := l_bufsize
								l_write_info.bw_flags := l_wb_flags
								l_fileformat := misc2_inst.get_fileformat_force (l_buf___6, a_eap)
								l_s.ce_gets (l_buffer)
								l_len := 0
								l_lnum := l_start___1
								from
								until
									not (not js.loop_left and then (l_lnum <= l_end))
								loop
									js.reset
									l_ptr.ce_gets ((memline_inst.ml_get_buf (l_buf___6, l_lnum, 0)) - 1)
									if l_write_undo_file.to_boolean then
										sha256_inst.sha256_update (l_sha_ctx.address, l_ptr + 1, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_ptr + 1)))) + {NATURAL_32} 1)
									end
									from
									until
										js.loop_left
									loop
										js.reset
										l_ptr.ce_gets (l_ptr + 1)
										l_c := l_ptr.item
										if l_c.to_integer_32 = 0 then
											js.break
										end
										if not js.loop_jumped then
											if l_c.to_integer_32 = 10 then
												l_s.item := (('%/0/').code).to_natural_8
											elseif l_c.to_integer_32 = 13 then
												if l_fileformat = 2 then
													l_s.item := (('%N').code).to_natural_8
												else
													l_s.item := l_c
												end
											else
												l_s.item := l_c
											end
											l_s.ce_gets (l_s + 1)
											l_len := l_len + 1
											if l_len /= l_bufsize then
												js.continue
											end
										end
										if not js.loop_jumped then
											if (buf_write_bytes (l_write_info.address)) = 0 then
												l_end := (0).to_integer_32
												js.break
											end
										end
										if not js.loop_jumped then
											l_nchars := l_nchars + l_bufsize.to_integer_32
											l_s.ce_gets (l_buffer)
											l_len := 0
											l_write_info.bw_start_lnum := l_lnum
										end
									end
									js.reset
									if l_end = 0 then
										l_lnum := l_lnum + 1
										l_no_eol := 1
										js.break
									elseif l_lnum = l_end then
										if l_write_bin.to_boolean then
											if l_lnum = globals_inst.write_no_eol_lnum then
												l_lnum := l_lnum + 1
												l_no_eol := 1
												js.break
											elseif l_lnum = l_buf___6.item.b_ml.ml_line_count then
												if not (l_buf___6.item.b_p_eol).to_boolean then
													l_lnum := l_lnum + 1
													l_no_eol := 1
													js.break
												end
											end
										end
									end
									if not js.loop_jumped then
										if l_fileformat = 0 then
											l_tmp___88.ce_gets (l_s)
											l_s.ce_gets (l_s + 1)
											l_tmp___88.item := (('%N').code).to_natural_8
										else
											l_tmp___89.ce_gets (l_s)
											l_s.ce_gets (l_s + 1)
											l_tmp___89.item := (('%R').code).to_natural_8
											if l_fileformat = 1 then
												l_len := l_len + 1
												if l_len = l_bufsize then
													if (buf_write_bytes (l_write_info.address)) = 0 then
														l_end := (0).to_integer_32
														js.break
													end
													if not js.loop_jumped then
														l_nchars := l_nchars + l_bufsize.to_integer_32
														l_s.ce_gets (l_buffer)
														l_len := 0
													end
												end
												if not js.loop_jumped then
													l_tmp___91.ce_gets (l_s)
													l_s.ce_gets (l_s + 1)
													l_tmp___91.item := (('%N').code).to_natural_8
												end
											end
										end
									end
									if not js.loop_jumped then
										l_len := l_len + 1
										if l_len = l_bufsize then
											if l_end.to_boolean then
												if (buf_write_bytes (l_write_info.address)) = 0 then
													l_end := (0).to_integer_32
													js.break
												end
												if not js.loop_jumped then
													l_nchars := l_nchars + l_bufsize.to_integer_32
													l_s.ce_gets (l_buffer)
													l_len := 0
													ui_inst.ui_breakcheck
													if globals_inst.got_int.to_boolean then
														l_end := (0).to_integer_32
														js.break
													end
												end
											end
										end
									end
									if not js.loop_jumped then
										l_lnum := l_lnum + 1
									end
								end
								js.reset
								if l_len > 0 then
									if l_end > 0 then
										l_write_info.bw_len := l_len
										if (buf_write_bytes (l_write_info.address)) = 0 then
											l_end := (0).to_integer_32
										end
										l_nchars := l_nchars + l_len.to_integer_32
									end
								end
								if option_inst.p_fs.to_boolean then
									if (fsync (l_fd)) /= 0 then
										if not l_device.to_boolean then
											l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E667: Fsync failed")))))
											l_end := (0).to_integer_32
										end
									end
								end
								if (l_backup.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_pos := -1 + 137 -- skip if block
								end
				when 124 then -- if:
								if l_backup_copy.to_boolean then
									l_pos := -1 + 135 -- skip if block
								end
				when 125 then -- if:
								if not ((stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_wfname), (l_st___2.address))) < 0) then
									l_pos := -1 + 128 -- skip if block
								end
				when 126 then -- if:
								l_pos := -1 + 132 -- goto _L___12
				when 127 then -- if block done, skip else block:
								l_pos := -1 + 133
				when 128 then -- else:
								if l_st___2.st_uid = l_st_old.st_uid then
									l_pos := -1 + 131 -- skip if block
								end
				when 129 then -- if:
								l_pos := -1 + 132 -- goto _L___12
				when 130 then -- if block done, skip else block:
								l_pos := -1 + 133
				when 131 then -- else:
								if l_st___2.st_gid = l_st_old.st_gid then
									l_pos := -1 + 133 -- skip if block
								end
				when 132 then -- if: | _L___12:
								globals_inst.ignored := fchown (l_fd, l_st_old.st_uid, l_st_old.st_gid)
								if l_perm >= 0 then
									os_unix_inst.mch_setperm (l_wfname, l_perm).do_nothing
								end
				when 133 then -- if done | if done
								buffer_inst.buf_setino (l_buf___6)
				when 134 then -- if block done, skip else block:
								l_pos := -1 + 136
				when 135 then -- else:
								l_pos := -1 + 137 -- goto _L___13
				when 136 then -- if done | if block done, skip else block:
								l_pos := -1 + 138
				when 137 then -- else: | _L___13:
								if not (l_buf___6.item.b_dev_valid).to_boolean then
									buffer_inst.buf_setino (l_buf___6)
								end
				when 138 then
								if (close (l_fd)) /= 0 then
									l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E512: Close failed")))))
									l_end := (0).to_integer_32
								end
								if l_made_writable.to_boolean then
									l_perm := (l_perm).bit_and ((-129))
								end
								if l_perm >= 0 then
									os_unix_inst.mch_setperm (l_wfname, l_perm).do_nothing
								end
								if not l_backup_copy.to_boolean then
									os_unix_inst.mch_set_acl (l_wfname, l_acl)
								end
								if ((l_wb_flags).bit_and (4096)).to_boolean then
									misc2_inst.crypt_pop_state
								end
								if (l_wfname.c_pointer.to_integer_32).to_natural_32 /= (l_fname.c_pointer.to_integer_32).to_natural_32 then
									if l_end /= 0 then
										if globals_inst.enc_utf8.to_boolean then
											l_tmp___99.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("utf-8")))
										else
											l_tmp___99.ce_gets (option_inst.p_enc)
										end
										if (eval_inst.eval_charconvert (l_tmp___99, l_fenc, l_wfname, l_fname)) = 0 then
											l_write_info.bw_conv_error := 1
											l_end := (0).to_integer_32
										end
									end
									unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_wfname)).do_nothing
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_wfname))
								end
								if l_end = 0 then
									if (l_errmsg.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										if (l_write_info.bw_conv_error).to_boolean then
											if l_write_info.bw_conv_error_lnum = 0 then
												l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E513: write error, conversion failed (make %'fenc%' empty to override)")))))
											else
												l_errmsg_allocated := 1
												l_errmsg.ce_gets (misc2_inst.alloc ({NATURAL_32} 300))
												message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_errmsg), (300).to_natural_32, (gettext (ce_string ("E513: write error, conversion failed in line %%ld (make %'fenc%' empty to override)"))), l_write_info.bw_conv_error_lnum]).do_nothing
											end
										elseif globals_inst.got_int.to_boolean then
											l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_interr)))))
										else
											l_errmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E514: write error (file system full?)")))))
										end
									end
									if (l_backup.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										if l_backup_copy.to_boolean then
											if globals_inst.got_int.to_boolean then
												message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_interr))))).do_nothing
												term_inst.out_flush
											end
											l_fd := open ([create {CE_POINTER [INTEGER_8]}.make_cast (l_backup), 0, 0])
											if l_fd >= 0 then
												l_write_info.bw_fd := open ([create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), 577, (l_perm).bit_and (511)])
												if l_write_info.bw_fd >= 0 then
													l_write_info.bw_buf := l_smallbuf
													l_write_info.bw_flags := 8192
													from
													until
														js.loop_left
													loop
														js.reset
														l_write_info.bw_len := read (l_fd, create {CE_POINTER [ANY]}.make_cast (l_smallbuf), (256).to_natural_32)
														if not (l_write_info.bw_len > 0) then
															js.break
														end
														if not js.loop_jumped then
															if (buf_write_bytes (l_write_info.address)) = 0 then
																js.break
															end
														end
													end
													js.reset
													if (close (l_write_info.bw_fd)) >= 0 then
														if l_write_info.bw_len = 0 then
															l_end := (1).to_integer_32
														end
													end
												end
												close (l_fd).do_nothing
											end
										elseif (vim_rename (l_backup, l_fname)) = 0 then
											l_end := (1).to_integer_32
										end
									end
									l_pos := -1 + 140 -- goto fail
								end
				when 139 then
								l_lnum := l_lnum - l_start___1
								globals_inst.no_wait_return := globals_inst.no_wait_return - 1
								if not a_filtering.to_boolean then
									msg_add_fname (l_buf___6, l_fname)
									l_c := (0).to_natural_8
									if (l_write_info.bw_conv_error).to_boolean then
										strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string (" CONVERSION ERROR")))).do_nothing
										l_c := (1).to_natural_8
										if l_write_info.bw_conv_error_lnum /= 0 then
											message_inst.vim_snprintf_add ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1025).to_natural_32, (gettext (ce_string (" in line %%ld;"))), l_write_info.bw_conv_error_lnum]).do_nothing
										end
									elseif l_notconverted.to_boolean then
										strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("[NOT converted]")))).do_nothing
										l_c := (1).to_natural_8
									elseif l_converted.to_boolean then
										strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("[converted]")))).do_nothing
										l_c := (1).to_natural_8
									end
									if l_device.to_boolean then
										strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("[Device]")))).do_nothing
										l_c := (1).to_natural_8
									elseif l_newfile.to_boolean then
										if (option_inst.shortmess (('n').code)).to_boolean then
											l_tmp___117.ce_gets ((gettext (ce_string ("[New]"))))
										else
											l_tmp___117.ce_gets ((gettext (ce_string ("[New File]"))))
										end
										strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), l_tmp___117).do_nothing
										l_c := (1).to_natural_8
									end
									if l_no_eol.to_boolean then
										msg_add_eol
										l_c := (1).to_natural_8
									end
									if (msg_add_fileformat (l_fileformat)).to_boolean then
										l_c := (1).to_natural_8
									end
									if ((l_wb_flags).bit_and (4096)).to_boolean then
										strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (gettext (ce_string ("[crypted]")))).do_nothing
										l_c := (1).to_natural_8
									end
									msg_add_lines (l_c.to_integer_32, l_lnum, l_nchars)
									if not (option_inst.shortmess (('W').code)).to_boolean then
										if a_append.to_boolean then
											if (option_inst.shortmess (('w').code)).to_boolean then
												l_tmp___124.ce_gets ((gettext (ce_string (" [a]"))))
											else
												l_tmp___124.ce_gets ((gettext (ce_string (" appended"))))
											end
											strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), l_tmp___124).do_nothing
										else
											if (option_inst.shortmess (('w').code)).to_boolean then
												l_tmp___129.ce_gets ((gettext (ce_string (" [w]"))))
											else
												l_tmp___129.ce_gets ((gettext (ce_string (" written"))))
											end
											strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), l_tmp___129).do_nothing
										end
									end
									message_inst.set_keep_msg ((message_inst.msg_trunc_attr (globals_inst.IObuff, 0, 0)), 0)
								end
								if a_reset_changed.to_boolean then
									if l_whole.to_boolean then
										if not a_append.to_boolean then
											if not (l_write_info.bw_conv_error).to_boolean then
												if l_overwriting.to_boolean then
													misc1_inst.unchanged (l_buf___6, 1)
													undo_inst.u_unchanged (l_buf___6)
													undo_inst.u_update_save_nr (l_buf___6)
												elseif ((misc2_inst.vim_strchr (option_inst.p_cpo, ('+').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
													misc1_inst.unchanged (l_buf___6, 1)
													undo_inst.u_unchanged (l_buf___6)
													undo_inst.u_update_save_nr (l_buf___6)
												end
											end
										end
									end
								end
								if l_overwriting.to_boolean then
									memline_inst.ml_timestamp (l_buf___6)
									if a_append.to_boolean then
										l_buf___6.item.b_flags := (l_buf___6.item.b_flags).bit_and ((-17))
									else
										l_buf___6.item.b_flags := (l_buf___6.item.b_flags).bit_and ((-89))
									end
								end
								if (option_inst.p_pm.item).to_boolean then
									if l_dobackup.to_boolean then
										if (l_buf___6.item.b_p_sn).to_boolean then
											l_tmp___134 := 1
										elseif (l_buf___6.item.b_shortname).to_boolean then
											l_tmp___134 := 1
										else
											l_tmp___134 := 0
										end
										l_org.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((buf_modname (l_tmp___134, l_fname, option_inst.p_pm, 0))))
										if (l_backup.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
											if (l_org.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
												message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E205: Patchmode: can%'t save original file"))))).do_nothing
											elseif (stat (l_org, (l_st___3.address))) < 0 then
												vim_rename (l_backup, create {CE_POINTER [NATURAL_8]}.make_cast (l_org)).do_nothing
												misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_backup))
												l_backup.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
												set_file_time (create {CE_POINTER [NATURAL_8]}.make_cast (l_org), l_st_old.st_atim.tv_sec, l_st_old.st_mtim.tv_sec)
											end
										elseif (l_org.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
											l_tmp___138.ce_gets (gettext (ce_string ("E206: patchmode: can%'t touch empty original file")))
											message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___138)).do_nothing
										else
											if l_perm < 0 then
												l_tmp___139 := 438
											else
												l_tmp___139 := (l_perm).bit_and (511)
											end
											l_empty_fd := open ([l_org, 131264, l_tmp___139])
											if l_empty_fd < 0 then
												l_tmp___138.ce_gets (gettext (ce_string ("E206: patchmode: can%'t touch empty original file")))
												message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___138)).do_nothing
											else
												close (l_empty_fd).do_nothing
											end
										end
										if (l_org.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
											os_unix_inst.mch_setperm (create {CE_POINTER [NATURAL_8]}.make_cast (l_org), ((os_unix_inst.mch_getperm (l_fname))).bit_and (511)).do_nothing
											misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_org))
										end
									end
								end
								if not option_inst.p_bk.to_boolean then
									if (l_backup.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										if (unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_backup))) /= 0 then
											message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E207: Can%'t delete backup file"))))).do_nothing
										end
									end
								end
								l_pos := -1 + 141 -- goto nofail
				when 140 then -- fail:
								globals_inst.no_wait_return := globals_inst.no_wait_return - 1
				when 141 then -- nofail:
								l_buf___6.item.b_saving := 0
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_backup))
								if (l_buffer.c_pointer.to_integer_32).to_natural_32 /= (l_smallbuf.c_pointer.to_integer_32).to_natural_32 then
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buffer))
								end
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fenc_tofree))
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_write_info.bw_conv_buf))
								if ((l_write_info.bw_iconv_fd).c_pointer.to_integer_32).to_natural_32 /= (-1).to_natural_32 then
									iconv_close (l_write_info.bw_iconv_fd).do_nothing
									l_write_info.bw_iconv_fd := create {CE_POINTER [ANY]}.make_shared (default_pointer + -1)
								end
								os_unix_inst.mch_free_acl (l_acl)
								if (l_errmsg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if (l_errnum.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										l_tmp___144 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_errnum))).to_integer_32
									else
										l_tmp___144 := 0
									end
									l_numlen := l_tmp___144
									l_attr := globals_inst.highlight_attr[3]
									msg_add_fname (l_buf___6, l_fname)
									l_tmp___146 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff))
									if (l_tmp___146 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_errmsg)))) + l_numlen.to_natural_32 >= {NATURAL_32} 1025 then
										globals_inst.IObuff[((({NATURAL_32} 1025 - (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_errmsg)))) - l_numlen.to_natural_32) - {NATURAL_32} 1).to_integer_32] := (('%/0/').code).to_natural_8
									end
									if (l_errnum.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										memmove (create {CE_POINTER [ANY]}.make_cast ((globals_inst.IObuff + l_numlen)), create {CE_POINTER [ANY]}.make_cast (globals_inst.IObuff), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff))) + {NATURAL_32} 1).do_nothing
										memmove (create {CE_POINTER [ANY]}.make_cast (globals_inst.IObuff), create {CE_POINTER [ANY]}.make_cast (l_errnum), l_numlen.to_natural_32).do_nothing
									end
									strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), create {CE_POINTER [INTEGER_8]}.make_cast (l_errmsg)).do_nothing
									message_inst.emsg (globals_inst.IObuff).do_nothing
									if l_errmsg_allocated.to_boolean then
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_errmsg))
									end
									l_retval := 0
									if l_end = 0 then
										message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%NWARNING: Original file may be lost or damaged%N")))), (l_attr).bit_or (4096))
										message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("don%'t quit the editor until the file is successfully written!")))), (l_attr).bit_or (4096))
										if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_fname), (l_st_old.address))) >= 0 then
											buf_store_time (l_buf___6, l_st_old.address, l_fname)
											l_buf___6.item.b_mtime_read := l_buf___6.item.b_mtime
										end
									end
								end
								globals_inst.msg_scroll := l_msg_save
								if l_retval = 1 then
									if l_write_undo_file.to_boolean then
										sha256_inst.sha256_finish (l_sha_ctx.address, create {CE_POINTER [NATURAL_8]}.make_cast (l_hash))
										undo_inst.u_write_undo (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, l_buf___6, l_hash)
									end
								end
								if not (ex_eval_inst.should_abort (l_retval)).to_boolean then
									globals_inst.write_no_eol_lnum := (0).to_integer_32
									aucmd_prepbuf (l_aco___0.address, l_buf___6)
									if a_append.to_boolean then
										apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEAPPENDPOST, l_fname, l_fname, 0, globals_inst.curbuf, a_eap).do_nothing
									elseif a_filtering.to_boolean then
										apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILTERWRITEPOST, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_fname, 0, globals_inst.curbuf, a_eap).do_nothing
									elseif a_reset_changed.to_boolean then
										if l_whole.to_boolean then
											apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_BUFWRITEPOST, l_fname, l_fname, 0, globals_inst.curbuf, a_eap).do_nothing
										else
											apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEWRITEPOST, l_fname, l_fname, 0, globals_inst.curbuf, a_eap).do_nothing
										end
									else
										apply_autocmds_exarg ({PC_AUTO_EVENT}.EVENT_FILEWRITEPOST, l_fname, l_fname, 0, globals_inst.curbuf, a_eap).do_nothing
									end
									aucmd_restbuf (l_aco___0.address)
									if (ex_eval_inst.aborting).to_boolean then
										l_retval := 0
									end
								end
								globals_inst.got_int := (globals_inst.got_int).bit_or (l_prev_got_int)
								Result := l_retval
				when 142 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	set_rw_fname (a_fname: CE_POINTER [NATURAL_8]; a_sfname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			js: JUMP_STATE
		do
			create l_buf___6.make

			l_buf___6.ce_gets (globals_inst.curbuf)
			if (globals_inst.curbuf.item.b_p_bl).to_boolean then
				apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFDELETE, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
			end
			apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFWIPEOUT, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
			if (ex_eval_inst.aborting).to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called and then ((globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 /= (l_buf___6.c_pointer.to_integer_32).to_natural_32) then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (e_auchangedbuf)))).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				if (buffer_inst.setfname (globals_inst.curbuf, a_fname, a_sfname, 0)) = 1 then
					globals_inst.curbuf.item.b_flags := (globals_inst.curbuf.item.b_flags).bit_or ((8))
				end
				apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFNEW, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
				if (globals_inst.curbuf.item.b_p_bl).to_boolean then
					apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFADD, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
				end
				if (ex_eval_inst.aborting).to_boolean then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if ((globals_inst.curbuf.item.b_p_ft).item).to_integer_32 = 0 then
					if (au_has_group (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("filetypedetect")))).to_boolean then
						do_doautocmd (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("filetypedetect BufRead")), 0).do_nothing
					end
					buffer_inst.do_modelines (0)
				end
				Result := 1
			end
		end

	msg_add_fname (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_fname: CE_POINTER [NATURAL_8])
		local
			l_fname: CE_POINTER [NATURAL_8]
		do
			create l_fname.make

			l_fname.ce_gets (a_fname)
			if (l_fname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_fname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("-stdin-")))
			end
			misc1_inst.home_replace (a_buf___6, l_fname, globals_inst.IObuff + 1, 1021, 1)
			globals_inst.IObuff[0] := (('%"').code).to_natural_8
			strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), ce_string ("%" ")).do_nothing
		end

	msg_add_fileformat (a_eol_type: INTEGER_32): INTEGER_32
		local
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_tmp___2.make
			create l_tmp___7.make

			if a_eol_type = 1 then
				if (option_inst.shortmess (('x').code)).to_boolean then
					l_tmp___2.ce_gets ((gettext (ce_string ("[dos]"))))
				else
					l_tmp___2.ce_gets ((gettext (ce_string ("[dos format]"))))
				end
				strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), l_tmp___2).do_nothing
				Result := 1
				js.return
			end
			if not js.return_called and then (a_eol_type = 2) then
				if (option_inst.shortmess (('x').code)).to_boolean then
					l_tmp___7.ce_gets ((gettext (ce_string ("[mac]"))))
				else
					l_tmp___7.ce_gets ((gettext (ce_string ("[mac format]"))))
				end
				strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), l_tmp___7).do_nothing
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	msg_add_lines (a_insert_space: INTEGER_32; a_lnum: INTEGER_32; a_nchars: INTEGER_32)
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make
			create l_tmp___0.make

			l_p___0.ce_gets (globals_inst.IObuff + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff))).to_integer_32)
			if a_insert_space.to_boolean then
				l_tmp___0.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___0.item := ((' ').code).to_natural_8
			end
			if (option_inst.shortmess (('l').code)).to_boolean then
				sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("%%ldL, %%ldC"), a_lnum, a_nchars]).do_nothing
			else
				if a_lnum = 1 then
					strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), (gettext (ce_string ("1 line, ")))).do_nothing
				else
					sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), (gettext (ce_string ("%%ld lines, "))), a_lnum]).do_nothing
				end
				l_p___0.ce_gets (l_p___0 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32)
				if a_nchars = 1 then
					strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), (gettext (ce_string ("1 character")))).do_nothing
				else
					sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), (gettext (ce_string ("%%ld characters"))), a_nchars]).do_nothing
				end
			end
		end

	msg_add_eol
		local
			l_tmp___2: CE_POINTER [INTEGER_8]
		do
			create l_tmp___2.make

			if (option_inst.shortmess (('i').code)).to_boolean then
				l_tmp___2.ce_gets ((gettext (ce_string ("[noeol]"))))
			else
				l_tmp___2.ce_gets ((gettext (ce_string ("[Incomplete last line]"))))
			end
			strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), l_tmp___2).do_nothing
		end

	check_mtime (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_st: CE_POINTER [SD_STAT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_buf___6.item.b_mtime_read /= 0 then
				if (time_differs (a_st.item.st_mtim.tv_sec, a_buf___6.item.b_mtime_read)).to_boolean then
					globals_inst.msg_scroll := 1
					globals_inst.msg_silent := 0
					message_inst.msg_attr (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("WARNING: The file has been changed since reading it!!!")))), globals_inst.highlight_attr[3]).do_nothing
					if (misc1_inst.ask_yesno (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Do you really want to write to it")))), 1)) = 110 then
						Result := 0
						js.return
					end
					if not js.return_called then
						globals_inst.msg_scroll := 0
					end
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	time_differs (a_t1: INTEGER_32; a_t2: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if a_t1 - a_t2 > 1 then
				l_tmp := 1
			elseif a_t2 - a_t1 > 1 then
				l_tmp := 1
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	buf_write_bytes (a_ip: CE_POINTER [PD_BW_INFO]): INTEGER_32
		local
			l_wlen: INTEGER_32
			l_buf___6: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_flags___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_c: NATURAL_32
			l_n: INTEGER_32
			l_l: INTEGER_32
			l_from: CE_POINTER [INTEGER_8]
			l_fromlen: NATURAL_32
			l_to: CE_POINTER [INTEGER_8]
			l_tolen: NATURAL_32
			l_fp: CE_POINTER [INTEGER_8]
			l_save_len: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___6.make
			create l_p___0.make
			create l_from.make
			create l_to.make
			create l_fp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buf___6.ce_gets (a_ip.item.bw_buf)
					l_len := a_ip.item.bw_len
					l_flags___0 := a_ip.item.bw_flags
					if ((l_flags___0).bit_and (8192)).to_boolean then
						l_pos := -1 + 19 -- skip if block
					end
				when 1 then -- if:
						if not (((l_flags___0).bit_and (2)).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_p___0.ce_gets (a_ip.item.bw_conv_buf)
						l_wlen := 0
						from
						until
							not (l_wlen < l_len)
						loop
							l_p___0.ce_gets (l_p___0 + (mbyte_inst.utf_char2bytes ((l_buf___6[l_wlen]).to_integer_32, l_p___0)))
							l_wlen := l_wlen + 1
						end
						l_buf___6.ce_gets (a_ip.item.bw_conv_buf)
						l_len := l_p___0.distance ((a_ip.item.bw_conv_buf))
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 4 then -- else:
						if not (((l_flags___0).bit_and (29)).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 5 then -- if:
						if ((l_flags___0).bit_and (1)).to_boolean then
							l_p___0.ce_gets (l_buf___6)
						else
							l_p___0.ce_gets (a_ip.item.bw_conv_buf)
						end
						l_wlen := 0
				when 6 then -- loop condition:
						if not (not js.loop_left and then (l_wlen < l_len)) then
							l_pos := -1 + 12 -- skip loop
						end
				when 7 then -- loop body:
						js.reset
						if l_wlen /= 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if a_ip.item.bw_restlen /= 0 then
							l_l := 30 - a_ip.item.bw_restlen
							if l_l > l_len then
								l_l := l_len
							end
							memmove (create {CE_POINTER [ANY]}.make_cast ((a_ip.item.bw_rest + a_ip.item.bw_restlen)), create {CE_POINTER [ANY]}.make_cast (l_buf___6), l_l.to_natural_32).do_nothing
							l_n := mbyte_inst.utf_ptr2len_len (a_ip.item.bw_rest, a_ip.item.bw_restlen + l_l)
							if l_n > a_ip.item.bw_restlen + l_len then
								if a_ip.item.bw_restlen + l_len > 30 then
									Result := 0
									js.return
								end
								if not js.return_called then
									a_ip.item.bw_restlen := a_ip.item.bw_restlen + l_len
									js.break
								end
							end
							if not js.loop_jumped then
								if l_n > 1 then
									l_c := (mbyte_inst.utf_ptr2char (a_ip.item.bw_rest)).to_natural_32
								else
									l_c := (a_ip.item.bw_rest[0]).to_natural_32
								end
								if l_n >= a_ip.item.bw_restlen then
									l_n := l_n - (a_ip.item.bw_restlen)
									a_ip.item.bw_restlen := 0
								else
									a_ip.item.bw_restlen := a_ip.item.bw_restlen - l_n
									memmove (create {CE_POINTER [ANY]}.make_cast ((a_ip.item.bw_rest)), create {CE_POINTER [ANY]}.make_cast ((a_ip.item.bw_rest + l_n)), (a_ip.item.bw_restlen).to_natural_32).do_nothing
									l_n := 0
								end
							end
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						l_n := mbyte_inst.utf_ptr2len_len (l_buf___6 + l_wlen, l_len - l_wlen)
						if l_n > l_len - l_wlen then
							if l_len - l_wlen > 30 then
								Result := 0
								js.return
							end
							if not js.return_called then
								a_ip.item.bw_restlen := l_len - l_wlen
								memmove (create {CE_POINTER [ANY]}.make_cast ((a_ip.item.bw_rest)), create {CE_POINTER [ANY]}.make_cast ((l_buf___6 + l_wlen)), (a_ip.item.bw_restlen).to_natural_32).do_nothing
								js.break
							end
						end
						if not js.loop_jumped then
							if l_n > 1 then
								l_c := (mbyte_inst.utf_ptr2char (l_buf___6 + l_wlen)).to_natural_32
							else
								l_c := (l_buf___6[l_wlen]).to_natural_32
							end
						end
				when 11 then
						if not js.loop_jumped then
							if (ucs2bytes (l_c, l_p___0.address, l_flags___0)).to_boolean then
								if not (a_ip.item.bw_conv_error).to_boolean then
									a_ip.item.bw_conv_error := 1
									a_ip.item.bw_conv_error_lnum := a_ip.item.bw_start_lnum
								end
							end
							if l_c = {NATURAL_32} 10 then
								a_ip.item.bw_start_lnum := (a_ip.item.bw_start_lnum) + 1
							end
							l_wlen := l_wlen + l_n
						end
						l_pos := -1 + 6 -- back to loop condition
				when 12 then -- loop done
						js.reset
						if not js.return_called then
							if ((l_flags___0).bit_and (1)).to_boolean then
								l_len := l_p___0.distance (l_buf___6)
							else
								l_buf___6.ce_gets (a_ip.item.bw_conv_buf)
								l_len := l_p___0.distance ((a_ip.item.bw_conv_buf))
							end
						end
				when 13 then -- if done | if done
						if not (not js.return_called and then (((a_ip.item.bw_iconv_fd).c_pointer.to_integer_32).to_natural_32 /= (-1).to_natural_32)) then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						if a_ip.item.bw_restlen > 0 then
							l_fromlen := (l_len + a_ip.item.bw_restlen).to_natural_32
							l_fp.ce_gets ((create {CE_POINTER [INTEGER_8]}.make_cast (a_ip.item.bw_conv_buf) + a_ip.item.bw_conv_buflen) - l_fromlen.to_integer_32)
							memmove (create {CE_POINTER [ANY]}.make_cast (l_fp), create {CE_POINTER [ANY]}.make_cast ((a_ip.item.bw_rest)), (a_ip.item.bw_restlen).to_natural_32).do_nothing
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_fp + a_ip.item.bw_restlen)), create {CE_POINTER [ANY]}.make_cast (l_buf___6), l_len.to_natural_32).do_nothing
							l_from.ce_gets (l_fp)
							l_tolen := (a_ip.item.bw_conv_buflen).to_natural_32 - l_fromlen
						else
							l_from.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6))
							l_fromlen := l_len.to_natural_32
							l_tolen := (a_ip.item.bw_conv_buflen).to_natural_32
						end
						l_to.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (a_ip.item.bw_conv_buf))
						if (a_ip.item.bw_first).to_boolean then
							l_save_len := l_tolen
							iconv (a_ip.item.bw_iconv_fd, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer), (l_to.address), (create {CE_POINTER [NATURAL_32]}.make_shared ($l_tolen))).do_nothing
							if (l_to.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_to.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (a_ip.item.bw_conv_buf))
								l_tolen := l_save_len
							end
							a_ip.item.bw_first := 0
						end
						if (iconv (a_ip.item.bw_iconv_fd, (l_from.address), (create {CE_POINTER [NATURAL_32]}.make_shared ($l_fromlen)), (l_to.address), (create {CE_POINTER [NATURAL_32]}.make_shared ($l_tolen)))) /= {NATURAL_32} 4294967295 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if (errno_location).item /= 22 then
							a_ip.item.bw_conv_error := 1
							Result := 0
							js.return
						else
							l_pos := -1 + 17 -- goto _L___0
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else: | _L___0:
						if l_fromlen > {NATURAL_32} 30 then
							a_ip.item.bw_conv_error := 1
							Result := 0
							js.return
						end
				when 18 then
						if not js.return_called then
							if l_fromlen > {NATURAL_32} 0 then
								memmove (create {CE_POINTER [ANY]}.make_cast ((a_ip.item.bw_rest)), create {CE_POINTER [ANY]}.make_cast (l_from), l_fromlen).do_nothing
							end
							a_ip.item.bw_restlen := l_fromlen.to_integer_32
							l_buf___6.ce_gets (a_ip.item.bw_conv_buf)
							l_len := (create {CE_POINTER [NATURAL_8]}.make_cast (l_to)).distance ((a_ip.item.bw_conv_buf))
						end
				when 19 then -- if done | if done
						if not js.return_called then
							if ((l_flags___0).bit_and (4096)).to_boolean then
								misc2_inst.crypt_encode (l_buf___6, l_len.to_natural_32, l_buf___6)
							end
							from
							until
								not (not js.loop_left and then (l_len > 0))
							loop
								l_wlen := write (a_ip.item.bw_fd, create {CE_POINTER [ANY]}.make_cast (l_buf___6), l_len.to_natural_32)
								if l_wlen <= 0 then
									Result := 0
									js.return
								end
								if not js.return_called then
									l_len := l_len - l_wlen
									l_buf___6.ce_gets (l_buf___6 + l_wlen)
								end
							end
						end
						if not js.return_called then
							Result := 1
						end
				when 20 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ucs2bytes (a_c: NATURAL_32; a_pp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_flags___0: INTEGER_32): INTEGER_32
		local
			l_c: NATURAL_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_error: INTEGER_32
			l_cc___0: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___11: CE_POINTER [NATURAL_8]
			l_tmp___12: CE_POINTER [NATURAL_8]
			l_tmp___13: CE_POINTER [NATURAL_8]
			l_tmp___14: CE_POINTER [NATURAL_8]
			l_tmp___15: CE_POINTER [NATURAL_8]
			l_tmp___16: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___7.make
			create l_tmp___8.make
			create l_tmp___9.make
			create l_tmp___10.make
			create l_tmp___11.make
			create l_tmp___12.make
			create l_tmp___13.make
			create l_tmp___14.make
			create l_tmp___15.make
			create l_tmp___16.make

			l_c := a_c
			l_p___0.ce_gets (a_pp.item)
			l_error := 0
			if ((a_flags___0).bit_and (8)).to_boolean then
				if ((a_flags___0).bit_and (128)).to_boolean then
					l_tmp.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp.item := l_c.to_natural_8
					l_tmp___0.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___0.item := ((l_c).bit_shift_right (8)).to_natural_8
					l_tmp___1.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___1.item := ((l_c).bit_shift_right (16)).to_natural_8
					l_tmp___2.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___2.item := ((l_c).bit_shift_right (24)).to_natural_8
				else
					l_tmp___3.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___3.item := ((l_c).bit_shift_right (24)).to_natural_8
					l_tmp___4.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___4.item := ((l_c).bit_shift_right (16)).to_natural_8
					l_tmp___5.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___5.item := ((l_c).bit_shift_right (8)).to_natural_8
					l_tmp___6.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___6.item := l_c.to_natural_8
				end
			elseif ((a_flags___0).bit_and (20)).to_boolean then
				if l_c >= {NATURAL_32} 65536 then
					if ((a_flags___0).bit_and (16)).to_boolean then
						l_c := l_c - ({NATURAL_32} 65536)
						if l_c >= {NATURAL_32} 1048576 then
							l_error := 1
						end
						l_cc___0 := (((((l_c).bit_shift_right (10))).bit_and ({NATURAL_32} 1023)) + {NATURAL_32} 55296).to_integer_32
						if ((a_flags___0).bit_and (128)).to_boolean then
							l_tmp___7.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___7.item := l_cc___0.to_natural_8
							l_tmp___8.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___8.item := ((l_cc___0.to_natural_32).bit_shift_right (8)).to_natural_8
						else
							l_tmp___9.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___9.item := ((l_cc___0.to_natural_32).bit_shift_right (8)).to_natural_8
							l_tmp___10.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___10.item := l_cc___0.to_natural_8
						end
						l_c := ((l_c).bit_and ({NATURAL_32} 1023)) + {NATURAL_32} 56320
					else
						l_error := 1
					end
				end
				if ((a_flags___0).bit_and (128)).to_boolean then
					l_tmp___11.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___11.item := l_c.to_natural_8
					l_tmp___12.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___12.item := ((l_c).bit_shift_right (8)).to_natural_8
				else
					l_tmp___13.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___13.item := ((l_c).bit_shift_right (8)).to_natural_8
					l_tmp___14.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_tmp___14.item := l_c.to_natural_8
				end
			elseif l_c >= {NATURAL_32} 256 then
				l_error := 1
				l_tmp___15.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___15.item := (191).to_natural_8
			else
				l_tmp___16.ce_gets (l_p___0)
				l_p___0.ce_gets (l_p___0 + 1)
				l_tmp___16.item := l_c.to_natural_8
			end
			a_pp.item := l_p___0
			Result := l_error
		end

	need_conversion (a_fenc: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_same_encoding: INTEGER_32
			l_enc_flags: INTEGER_32
			l_fenc_flags: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			if (a_fenc.item).to_integer_32 = 0 then
				l_same_encoding := 1
				l_fenc_flags := 0
			elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_enc), create {CE_POINTER [INTEGER_8]}.make_cast (a_fenc))) = 0 then
				l_same_encoding := 1
				l_fenc_flags := 0
			else
				l_enc_flags := get_fio_flags (option_inst.p_enc)
				l_fenc_flags := get_fio_flags (a_fenc)
				if l_enc_flags /= 0 then
					if l_fenc_flags = l_enc_flags then
						l_tmp := 1
					else
						l_tmp := 0
					end
				else
					l_tmp := 0
				end
				l_same_encoding := l_tmp
			end
			if l_same_encoding.to_boolean then
				Result := (globals_inst.enc_unicode /= 0).to_integer
				js.return
			end
			if not js.return_called then
				if globals_inst.enc_utf8.to_boolean then
					if l_fenc_flags = 2 then
						l_tmp___1 := 0
					else
						l_tmp___1 := 1
					end
				else
					l_tmp___1 := 1
				end
				Result := l_tmp___1
			end
		end

	get_fio_flags (a_ptr: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_ptr: CE_POINTER [NATURAL_8]
			l_prop: INTEGER_32
			js: JUMP_STATE
		do
			create l_ptr.make

			l_ptr.ce_gets (a_ptr)
			if (l_ptr.item).to_integer_32 = 0 then
				l_ptr.ce_gets (option_inst.p_enc)
			end
			l_prop := mbyte_inst.enc_canon_props (l_ptr)
			if ((l_prop).bit_and (4)).to_boolean then
				if ((l_prop).bit_and (64)).to_boolean then
					if ((l_prop).bit_and (32)).to_boolean then
						Result := 132
						js.return
					end
					if not js.return_called then
						Result := 4
						js.return
					end
				end
				if not js.return_called and then (((l_prop).bit_and (128)).to_boolean) then
					if ((l_prop).bit_and (32)).to_boolean then
						Result := 136
						js.return
					end
					if not js.return_called then
						Result := 8
						js.return
					end
				end
				if not js.return_called and then (((l_prop).bit_and (256)).to_boolean) then
					if ((l_prop).bit_and (32)).to_boolean then
						Result := 144
						js.return
					end
					if not js.return_called then
						Result := 16
						js.return
					end
				end
				if not js.return_called then
					Result := 2
					js.return
				end
			end
			if not js.return_called and then (((l_prop).bit_and (512)).to_boolean) then
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	check_for_bom (a_p___0: CE_POINTER [NATURAL_8]; a_size: INTEGER_32; a_lenp: CE_POINTER [INTEGER_32]; a_flags___0: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_name___1: CE_POINTER [INTEGER_8]
			l_len: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_name___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_name___1.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					l_len := 2
					if (a_p___0[0]).to_integer_32 /= 239 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (a_p___0[1]).to_integer_32 = 187 then
							if a_size >= 3 then
								if (a_p___0[2]).to_integer_32 = 191 then
									if a_flags___0 = -1 then
										l_name___1.ce_gets (ce_string ("utf-8"))
										l_len := 3
									elseif a_flags___0 = 2 then
										l_name___1.ce_gets (ce_string ("utf-8"))
										l_len := 3
									elseif a_flags___0 = 0 then
										l_name___1.ce_gets (ce_string ("utf-8"))
										l_len := 3
									else
										l_pos := -1 + 3 -- goto _L___9
									end
								else
									l_pos := -1 + 3 -- goto _L___9
								end
							else
								l_pos := -1 + 3 -- goto _L___9
							end
						else
							l_pos := -1 + 3 -- goto _L___9
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 3 then -- else: | _L___9:
						if (a_p___0[0]).to_integer_32 /= 255 then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if (a_p___0[1]).to_integer_32 /= 254 then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if not (a_size >= 4) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (a_p___0[2]).to_integer_32 = 0 then
							if (a_p___0[3]).to_integer_32 = 0 then
								if a_flags___0 = -1 then
									l_name___1.ce_gets (ce_string ("ucs-4le"))
									l_len := 4
								elseif a_flags___0 = 136 then
									l_name___1.ce_gets (ce_string ("ucs-4le"))
									l_len := 4
								else
									l_pos := -1 + 8 -- goto _L___1
								end
							else
								l_pos := -1 + 8 -- goto _L___1
							end
						else
							l_pos := -1 + 8 -- goto _L___1
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L___1:
						if a_flags___0 = 132 then
							l_name___1.ce_gets (ce_string ("ucs-2le"))
						elseif a_flags___0 = -1 then
							l_name___1.ce_gets (ce_string ("utf-16le"))
						elseif a_flags___0 = 144 then
							l_name___1.ce_gets (ce_string ("utf-16le"))
						end
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_pos := -1 + 12 -- goto _L___5
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 28
				when 12 then -- else: | _L___5:
						if (a_p___0[0]).to_integer_32 /= 254 then
							l_pos := -1 + 27 -- skip if block
						end
				when 13 then -- if:
						if (a_p___0[1]).to_integer_32 /= 255 then
							l_pos := -1 + 25 -- skip if block
						end
				when 14 then -- if:
						if a_flags___0 /= -1 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 21 -- goto _L___3
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 17 then -- else:
						if a_flags___0 /= 4 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 21 -- goto _L___3
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 20 then -- else:
						if a_flags___0 /= 16 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if: | _L___3:
						if a_flags___0 = 4 then
							l_name___1.ce_gets (ce_string ("ucs-2"))
						else
							l_name___1.ce_gets (ce_string ("utf-16"))
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else:
						l_pos := -1 + 27 -- goto _L___4
				when 24 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else:
						l_pos := -1 + 27 -- goto _L___4
				when 26 then -- if done | if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else: | _L___4:
						if a_size >= 4 then
							if (a_p___0[0]).to_integer_32 = 0 then
								if (a_p___0[1]).to_integer_32 = 0 then
									if (a_p___0[2]).to_integer_32 = 254 then
										if (a_p___0[3]).to_integer_32 = 255 then
											if a_flags___0 = -1 then
												l_name___1.ce_gets (ce_string ("ucs-4"))
												l_len := 4
											elseif a_flags___0 = 8 then
												l_name___1.ce_gets (ce_string ("ucs-4"))
												l_len := 4
											end
										end
									end
								end
							end
						end
				when 28 then -- if done | if done
						a_lenp.item := l_len
						Result := (create {CE_POINTER [NATURAL_8]}.make_cast (l_name___1))
				when 29 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	make_bom (a_buf___6: CE_POINTER [NATURAL_8]; a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_flags___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make

			l_flags___0 := get_fio_flags (a_name___1)
			if l_flags___0 = 1 then
				Result := 0
				js.return
			elseif l_flags___0 = 0 then
				Result := 0
				js.return
			end
			if not js.return_called and then (l_flags___0 = 2) then
				a_buf___6[0] := (239).to_natural_8
				a_buf___6[1] := (187).to_natural_8
				a_buf___6[2] := (191).to_natural_8
				Result := 3
				js.return
			end
			if not js.return_called then
				l_p___0.ce_gets (a_buf___6)
				ucs2bytes ({NATURAL_32} 65279, l_p___0.address, l_flags___0).do_nothing
				Result := (l_p___0.distance (a_buf___6))
			end
		end

	shorten_fname1 (a_full_path: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_dirname: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_dirname.make (<<4096>>)
			create l_p___0.make

			l_p___0.ce_gets (a_full_path)
			if (os_unix_inst.mch_dirname (l_dirname, 4096)) = 1 then
				l_p___0.ce_gets (shorten_fname (a_full_path, l_dirname))
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_p___0.ce_gets (a_full_path)
				elseif (l_p___0.item).to_integer_32 = 0 then
					l_p___0.ce_gets (a_full_path)
				end
			end
			Result := l_p___0
		end

	shorten_fname (a_full_path: CE_POINTER [NATURAL_8]; a_dir_name: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_len: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make

			if (a_full_path.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_dir_name))).to_integer_32
				if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_dir_name), create {CE_POINTER [INTEGER_8]}.make_cast (a_full_path), l_len.to_natural_32)) = 0 then
					l_p___0.ce_gets (a_full_path + l_len)
					if (misc1_inst.vim_ispathsep ((l_p___0.item).to_integer_32)).to_boolean then
						l_p___0.ce_gets (l_p___0 + 1)
					else
						l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					end
				else
					l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				end
				Result := l_p___0
			end
		end

	shorten_fnames (a_force: INTEGER_32)
		local
			l_dirname: CE_ARRAY [NATURAL_8]
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_p___0: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_dirname.make (<<4096>>)
			create l_buf___6.make
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					os_unix_inst.mch_dirname (l_dirname, 4096).do_nothing
					l_buf___6.ce_gets (globals_inst.firstbuf)
				when 1 then -- loop condition:
					if (l_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_pos := -1 + 14 -- skip loop
					end
				when 2 then -- loop body:
						if ((l_buf___6.item.b_fname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 13 -- skip if block
						end
				when 3 then -- if:
						if (quickfix_inst.bt_nofile (l_buf___6)).to_boolean then
							l_pos := -1 + 13 -- skip if block
						end
				when 4 then -- if:
						if (window_inst.path_with_url (l_buf___6.item.b_fname)).to_boolean then
							l_pos := -1 + 13 -- skip if block
						end
				when 5 then -- if:
						if not (a_force.to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 8 then -- else:
						if ((l_buf___6.item.b_sfname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if not ((os_unix_inst.mch_isFullName (l_buf___6.item.b_sfname)).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6.item.b_sfname))
						l_buf___6.item.b_sfname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						l_p___0.ce_gets (shorten_fname (l_buf___6.item.b_ffname, l_dirname))
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_buf___6.item.b_sfname := misc2_inst.vim_strsave (l_p___0)
							l_buf___6.item.b_fname := l_buf___6.item.b_sfname
						end
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_buf___6.item.b_fname := l_buf___6.item.b_ffname
						elseif ((l_buf___6.item.b_fname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_buf___6.item.b_fname := l_buf___6.item.b_ffname
						end
				when 13 then -- if done | if done | if done | if done | if done
						memfile_inst.mf_fullname (l_buf___6.item.b_ml.ml_mfp)
						l_buf___6.ce_gets (l_buf___6.item.b_next)
						l_pos := -1 + 1 -- back to loop condition
				when 14 then -- loop done
					screen_inst.status_redraw_all
					globals_inst.redraw_tabline := 1
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	shorten_filenames (a_fnames: CE_POINTER [CE_POINTER [NATURAL_8]]; a_count___2: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_dirname: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_dirname.make (<<4096>>)
			create l_p___0.make

			if (a_fnames.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			elseif a_count___2 < 1 then
				js.return
			end
			if not js.return_called then
				os_unix_inst.mch_dirname (l_dirname, (Natural_8_bytes.to_natural_32 * (4096).to_natural_32).to_integer_32).do_nothing
				l_i___0 := 0
				from
				until
					not (l_i___0 < a_count___2)
				loop
					l_p___0.ce_gets (shorten_fname (a_fnames[l_i___0], l_dirname))
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_p___0.ce_gets (misc2_inst.vim_strsave (l_p___0))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_fnames[l_i___0]))
						a_fnames[l_i___0] := l_p___0
					end
					l_i___0 := l_i___0 + 1
				end
			end
		end

	modname (a_fname: CE_POINTER [NATURAL_8]; a_ext: CE_POINTER [NATURAL_8]; a_prepend_dot: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_tmp: INTEGER_32
		do
			if (globals_inst.curbuf.item.b_p_sn).to_boolean then
				l_tmp := 1
			elseif (globals_inst.curbuf.item.b_shortname).to_boolean then
				l_tmp := 1
			else
				l_tmp := 0
			end
			Result := (buf_modname (l_tmp, a_fname, a_ext, a_prepend_dot))
		end

	buf_modname (a_shortname: INTEGER_32; a_fname: CE_POINTER [NATURAL_8]; a_ext: CE_POINTER [NATURAL_8]; a_prepend_dot: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_prepend_dot: INTEGER_32
			l_retval: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [NATURAL_8]
			l_ptr: CE_POINTER [NATURAL_8]
			l_fnamelen: INTEGER_32
			l_extlen: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___11: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_retval.make
			create l_s.make
			create l_e.make
			create l_ptr.make
			create l_tmp___10.make
			create l_tmp___11.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_prepend_dot := a_prepend_dot
					l_extlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_ext))).to_integer_32
					if (a_fname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if (a_fname.item).to_integer_32 /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_retval.ce_gets (misc2_inst.alloc (((4096 + l_extlen) + 3).to_natural_32))
						if (l_retval.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called then
							if (os_unix_inst.mch_dirname (l_retval, 4096)) = 0 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_retval))
								Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								js.return
							else
								l_fnamelen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_retval))).to_integer_32
								if l_fnamelen = 0 then
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_retval))
									Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
									js.return
								end
							end
						end
						if not js.return_called then
							if not (misc2_inst.after_pathsep (l_retval, l_retval + l_fnamelen)).to_boolean then
								l_tmp___2 := l_fnamelen
								l_fnamelen := l_fnamelen + 1
								l_retval[l_tmp___2] := (('/').code).to_natural_8
								l_retval[l_fnamelen] := (('%/0/').code).to_natural_8
							end
							l_prepend_dot := 0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_fnamelen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_fname))).to_integer_32
						l_retval.ce_gets (misc2_inst.alloc (((l_fnamelen + l_extlen) + 3).to_natural_32))
						if (l_retval.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_retval), create {CE_POINTER [INTEGER_8]}.make_cast (a_fname)).do_nothing
						end
				when 7 then -- if done
						if js.return_called then
							l_pos := -1 + 20 -- skip if block
						end
				when 8 then -- if:
							l_ptr.ce_gets (l_retval + l_fnamelen)
							from
							until
								not (not js.loop_left and then ((l_ptr.c_pointer.to_integer_32).to_natural_32 > (l_retval.c_pointer.to_integer_32).to_natural_32))
							loop
								js.reset
								if (a_ext.item).to_integer_32 = 46 then
									if a_shortname.to_boolean then
										if (l_ptr.item).to_integer_32 = 46 then
											l_ptr.item := (('_').code).to_natural_8
										end
									end
								end
								if (misc1_inst.vim_ispathsep ((l_ptr.item).to_integer_32)).to_boolean then
									l_ptr.ce_gets (l_ptr + 1)
									js.break
								end
								if not js.loop_jumped then
									if globals_inst.has_mbyte.to_boolean then
										l_tmp___6 := (globals_inst.mb_head_off.integer_32_item ([l_retval, l_ptr - 1])) + 1
									else
										l_tmp___6 := 1
									end
									l_ptr.ce_gets (l_ptr - l_tmp___6)
								end
							end
							js.reset
							if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr))) > {NATURAL_32} 250 then
								l_ptr[250] := (('%/0/').code).to_natural_8
							end
							l_s.ce_gets (l_ptr + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr))).to_integer_32)
							if not (a_shortname.to_boolean) then
								l_pos := -1 + 19 -- skip if block
							end
				when 9 then -- if:
							if (a_fname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_pos := -1 + 12 -- skip if block
							end
				when 10 then -- if:
							l_pos := -1 + 16 -- goto _L___0
				when 11 then -- if block done, skip else block:
							l_pos := -1 + 19
				when 12 then -- else:
							if (a_fname.item).to_integer_32 /= 0 then
								l_pos := -1 + 15 -- skip if block
							end
				when 13 then -- if:
							l_pos := -1 + 16 -- goto _L___0
				when 14 then -- if block done, skip else block:
							l_pos := -1 + 19
				when 15 then -- else:
							if not ((misc1_inst.vim_ispathsep ((a_fname[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_fname))) - {NATURAL_32} 1).to_integer_32]).to_integer_32)).to_boolean) then
								l_pos := -1 + 18 -- skip if block
							end
				when 16 then -- if: | _L___0:
							if (a_ext.item).to_integer_32 = 46 then
								l_tmp___10.ce_gets (l_s)
								l_s.ce_gets (l_s + 1)
								l_tmp___10.item := (('_').code).to_natural_8
							end
				when 17 then -- if block done, skip else block:
							l_pos := -1 + 19
				when 18 then -- else:
							if (a_ext.item).to_integer_32 = 46 then
								if (l_s.distance (l_ptr)).to_natural_32 > {NATURAL_32} 8 then
									l_s.ce_gets (l_ptr + 8)
									l_s.item := (('%/0/').code).to_natural_8
								end
							else
								l_e.ce_gets (misc2_inst.vim_strchr (l_ptr, ('.').code))
								if (l_e.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_tmp___11.ce_gets (l_s)
									l_s.ce_gets (l_s + 1)
									l_tmp___11.item := (('.').code).to_natural_8
								elseif (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_e))).to_integer_32 + l_extlen > 4 then
									l_s.ce_gets ((l_e + 4) - l_extlen)
								end
							end
				when 19 then -- if done | if done | if done
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), create {CE_POINTER [INTEGER_8]}.make_cast (a_ext)).do_nothing
							if l_prepend_dot.to_boolean then
								if not a_shortname.to_boolean then
									l_e.ce_gets (misc1_inst.gettail (l_retval))
									if (l_e.item).to_integer_32 /= 46 then
										memmove (create {CE_POINTER [ANY]}.make_cast ((l_e + 1)), create {CE_POINTER [ANY]}.make_cast (l_e), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_e))) + {NATURAL_32} 1).do_nothing
										l_e.item := (('.').code).to_natural_8
									end
								end
							end
							if (a_fname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_fname), create {CE_POINTER [INTEGER_8]}.make_cast (l_retval))) = 0 then
									from
									until
										js.loop_left
									loop
										js.reset
										l_s.ce_gets (l_s - 1)
										if not ((l_s.c_pointer.to_integer_32).to_natural_32 >= (l_ptr.c_pointer.to_integer_32).to_natural_32) then
											js.break
										end
										if not js.loop_jumped and then ((l_s.item).to_integer_32 /= 95) then
											l_s.item := (('_').code).to_natural_8
											js.break
										end
									end
									js.reset
									if (l_s.c_pointer.to_integer_32).to_natural_32 < (l_ptr.c_pointer.to_integer_32).to_natural_32 then
										l_ptr.item := (('v').code).to_natural_8
									end
								end
							end
							Result := l_retval
				when 20 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	vim_fgets (a_buf___6: CE_POINTER [NATURAL_8]; a_size: INTEGER_32; a_fp: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_eof: CE_POINTER [INTEGER_8]
			l_tbuf: CE_ARRAY [INTEGER_8]
			js: JUMP_STATE
		do
			create l_eof.make
			create l_tbuf.make (<<200>>)

			a_buf___6[(a_size - 2)] := (('%/0/').code).to_natural_8
			l_eof.ce_gets (fgets (create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6), a_size, a_fp))
			if (a_buf___6[(a_size - 2)]).to_integer_32 /= 0 then
				if (a_buf___6[(a_size - 2)]).to_integer_32 /= 10 then
					a_buf___6[(a_size - 1)] := (('%/0/').code).to_natural_8
					from
					until
						js.loop_left
					loop
						js.reset
						l_tbuf[198] := (('%/0/').code).to_integer_8
						globals_inst.ignoredp.ce_gets (fgets (l_tbuf, 200, a_fp))
						if (l_tbuf[198]).to_integer_32 /= 0 then
							if (l_tbuf[198]).to_integer_32 = 10 then
								js.break
							end
						else
							js.break
						end
					end
					js.reset
				end
			end
			Result := ((l_eof.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32).to_integer
		end

	vim_rename (a_from: CE_POINTER [NATURAL_8]; a_to: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_to: CE_POINTER [NATURAL_8]
			l_fd_in: INTEGER_32
			l_fd_out: INTEGER_32
			l_n: INTEGER_32
			l_errmsg: CE_POINTER [INTEGER_8]
			l_buffer: CE_POINTER [INTEGER_8]
			l_st: SD_STAT
			l_perm: INTEGER_32
			l_acl: CE_POINTER [ANY]
			l_use_tmp_file: INTEGER_32
			l_st_to: SD_STAT
			l_tempname: CE_ARRAY [INTEGER_8]
			js: JUMP_STATE
		do
			create l_to.make
			create l_errmsg.make
			create l_buffer.make
			create l_st.make
			create l_acl.make
			create l_st_to.make
			create l_tempname.make (<<4097>>)

			l_to.ce_gets (a_to)
			l_errmsg.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
			l_use_tmp_file := 0
			if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_from), create {CE_POINTER [INTEGER_8]}.make_cast (l_to))) = 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (a_from), (l_st.address))) < 0 then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				if (stat (create {CE_POINTER [INTEGER_8]}.make_cast (l_to), (l_st_to.address))) >= 0 then
					if l_st.st_dev = l_st_to.st_dev then
						if l_st.st_ino = l_st_to.st_ino then
							l_use_tmp_file := 1
						end
					end
				end
				if l_use_tmp_file.to_boolean then
					if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_from))) >= {NATURAL_32} 4091 then
						Result := (-1)
						js.return
					end
					if not js.return_called then
						strcpy (l_tempname, create {CE_POINTER [INTEGER_8]}.make_cast (a_from)).do_nothing
						l_n := 123
						from
						until
							not (not js.loop_left and then (l_n < 99999))
						loop
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast ((misc1_inst.gettail (create {CE_POINTER [NATURAL_8]}.make_cast (l_tempname)))), ce_string ("%%d"), l_n]).do_nothing
							if (stat (l_tempname, (l_st.address))) < 0 then
								if (rename2 (create {CE_POINTER [INTEGER_8]}.make_cast (a_from), l_tempname)) = 0 then
									if (rename2 (l_tempname, create {CE_POINTER [INTEGER_8]}.make_cast (l_to))) = 0 then
										Result := 0
										js.return
									end
									if not js.return_called then
										rename2 (l_tempname, create {CE_POINTER [INTEGER_8]}.make_cast (a_from)).do_nothing
										Result := (-1)
										js.return
									end
								end
								if not js.return_called then
									Result := (-1)
									js.return
								end
							end
							if not js.return_called then
								l_n := l_n + 1
							end
						end
					end
					if not js.return_called then
						Result := (-1)
						js.return
					end
				end
			end
			if not js.return_called then
				unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_to)).do_nothing
				if (rename2 (create {CE_POINTER [INTEGER_8]}.make_cast (a_from), create {CE_POINTER [INTEGER_8]}.make_cast (l_to))) = 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_perm := os_unix_inst.mch_getperm (a_from)
				l_acl.ce_gets (os_unix_inst.mch_get_acl (a_from))
				l_fd_in := open ([create {CE_POINTER [INTEGER_8]}.make_cast (a_from), 0, 0])
				if l_fd_in = -1 then
					os_unix_inst.mch_free_acl (l_acl)
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				l_fd_out := open ([create {CE_POINTER [INTEGER_8]}.make_cast (l_to), 131265, l_perm.to_integer_32])
				if l_fd_out = -1 then
					close (l_fd_in).do_nothing
					os_unix_inst.mch_free_acl (l_acl)
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				l_buffer.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((misc2_inst.alloc ({NATURAL_32} 8192))))
				if (l_buffer.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					close (l_fd_out).do_nothing
					close (l_fd_in).do_nothing
					os_unix_inst.mch_free_acl (l_acl)
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_n := read (l_fd_in, create {CE_POINTER [ANY]}.make_cast (l_buffer), (8192).to_natural_32)
					if not (l_n > 0) then
						js.break
					end
					if not js.loop_jumped then
						if (write (l_fd_out, create {CE_POINTER [ANY]}.make_cast (l_buffer), l_n.to_natural_32)) /= l_n then
							l_errmsg.ce_gets (gettext (ce_string ("E208: Error writing to %"%%s%"")))
							js.break
						end
					end
				end
				js.reset
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buffer))
				close (l_fd_in).do_nothing
				if (close (l_fd_out)) < 0 then
					l_errmsg.ce_gets (gettext (ce_string ("E209: Error closing %"%%s%"")))
				end
				if l_n < 0 then
					l_errmsg.ce_gets (gettext (ce_string ("E210: Error reading %"%%s%"")))
					l_to.ce_gets (a_from)
				end
				os_unix_inst.mch_set_acl (l_to, l_acl)
				os_unix_inst.mch_free_acl (l_acl)
				if (l_errmsg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_errmsg), l_to).do_nothing
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				unlink (create {CE_POINTER [INTEGER_8]}.make_cast (a_from)).do_nothing
				Result := 0
			end
		end

	check_timestamps (a_focus: INTEGER_32): INTEGER_32
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_didit: INTEGER_32
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			create l_buf___6.make

			l_didit := 0
			if globals_inst.no_check_timestamps > 0 then
				Result := 0
				js.return
			end
			if not js.return_called and then (a_focus.to_boolean) then
				if globals_inst.did_check_timestamps.to_boolean then
					globals_inst.need_check_timestamps := 1
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if (getchar_inst.stuff_empty).to_boolean then
					if globals_inst.global_busy.to_boolean then
						globals_inst.need_check_timestamps := 1
					elseif (getchar_inst.typebuf_typed).to_boolean then
						if globals_inst.autocmd_busy.to_boolean then
							globals_inst.need_check_timestamps := 1
						elseif globals_inst.curbuf_lock > 0 then
							globals_inst.need_check_timestamps := 1
						elseif globals_inst.allbuf_lock > 0 then
							globals_inst.need_check_timestamps := 1
						else
							globals_inst.no_wait_return := globals_inst.no_wait_return + 1
							globals_inst.did_check_timestamps := 1
							already_warned := 0
							l_buf___6.ce_gets (globals_inst.firstbuf)
							from
							until
								(l_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
							loop
								js.reset
								if l_buf___6.item.b_nwindows > 0 then
									l_n := buf_check_timestamp (l_buf___6, a_focus)
									if l_didit < l_n then
										l_didit := l_n
									end
									if l_n > 0 then
										if not (buffer_inst.buf_valid (l_buf___6)).to_boolean then
											l_buf___6.ce_gets (globals_inst.firstbuf)
											js.continue
										end
									end
								end
								if not js.loop_jumped then
									l_buf___6.ce_gets (l_buf___6.item.b_next)
								end
								
							end
							globals_inst.no_wait_return := globals_inst.no_wait_return - 1
							globals_inst.need_check_timestamps := 0
							if globals_inst.need_wait_return.to_boolean then
								if l_didit = 2 then
									message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
									term_inst.out_flush
								end
							end
						end
					else
						globals_inst.need_check_timestamps := 1
					end
				else
					globals_inst.need_check_timestamps := 1
				end
				Result := l_didit
			end
		end

	move_lines (a_frombuf: CE_POINTER [PD_FILE_BUFFER]; a_tobuf: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			l_tbuf: CE_POINTER [PD_FILE_BUFFER]
			l_retval: INTEGER_32
			l_lnum: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_tbuf.make
			create l_p___0.make

			l_tbuf.ce_gets (globals_inst.curbuf)
			l_retval := 1
			globals_inst.curbuf.ce_gets (a_tobuf)
			l_lnum := (1).to_integer_32
			from
			until
				not (not js.loop_left and then (l_lnum <= a_frombuf.item.b_ml.ml_line_count))
			loop
				js.reset
				l_p___0.ce_gets (misc2_inst.vim_strsave ((memline_inst.ml_get_buf (a_frombuf, l_lnum, 0))))
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
					l_retval := 0
					js.break
				elseif (memline_inst.ml_append (l_lnum - 1, l_p___0, 0, 0)) = 0 then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
					l_retval := 0
					js.break
				end
				if not js.loop_jumped then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
					l_lnum := l_lnum + 1
				end
			end
			js.reset
			if l_retval /= 0 then
				globals_inst.curbuf.ce_gets (a_frombuf)
				l_lnum := globals_inst.curbuf.item.b_ml.ml_line_count
				from
				until
					not (not js.loop_left and then (l_lnum > 0))
				loop
					js.reset
					if (memline_inst.ml_delete (l_lnum, 0)) = 0 then
						l_retval := 0
						js.break
					end
					if not js.loop_jumped then
						l_lnum := l_lnum - 1
					end
				end
				js.reset
			end
			globals_inst.curbuf.ce_gets (l_tbuf)
			Result := l_retval
		end

	buf_check_timestamp (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_focus: INTEGER_32): INTEGER_32
		local
			l_st: SD_STAT
			l_stat_res: INTEGER_32
			l_retval: INTEGER_32
			l_path: CE_POINTER [NATURAL_8]
			l_tbuf: CE_POINTER [NATURAL_8]
			l_mesg: CE_POINTER [INTEGER_8]
			l_mesg2: CE_POINTER [INTEGER_8]
			l_helpmesg: INTEGER_32
			l_reload: INTEGER_32
			l_can_reload: INTEGER_32
			l_orig_size: INTEGER_32
			l_orig_mode: INTEGER_32
			l_save_mouse_correct: INTEGER_32
			l_n: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_reason: CE_POINTER [INTEGER_8]
			l_tmp___6: INTEGER_32
			l_tmp___11: NATURAL_32
			l_tmp___12: NATURAL_32
			l_tmp___14: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_st.make
			create l_path.make
			create l_tbuf.make
			create l_mesg.make
			create l_mesg2.make
			create l_s.make
			create l_reason.make
			create l_tmp___14.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_retval := 0
					l_mesg.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					l_mesg2.ce_gets (ce_string (""))
					l_helpmesg := 0
					l_reload := 0
					l_can_reload := 0
					l_orig_size := a_buf___6.item.b_orig_size
					l_orig_mode := a_buf___6.item.b_orig_mode
					l_save_mouse_correct := globals_inst.need_mouse_correct
					if ((a_buf___6.item.b_ffname).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := 0
						js.return
					elseif ((a_buf___6.item.b_ml.ml_mfp).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := 0
						js.return
					elseif ((a_buf___6.item.b_p_bt).item).to_integer_32 /= 0 then
						Result := 0
						js.return
					elseif (a_buf___6.item.b_saving).to_boolean then
						Result := 0
						js.return
					elseif busy.to_boolean then
						Result := 0
						js.return
					elseif (netbeans_inst.isNetbeansBuffer (a_buf___6)).to_boolean then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 26 -- skip if block
					end
				when 1 then -- if:
						if ((a_buf___6.item.b_flags).bit_and (8)).to_boolean then
							l_pos := -1 + 25 -- skip if block
						end
				when 2 then -- if:
						if a_buf___6.item.b_mtime = 0 then
							l_pos := -1 + 23 -- skip if block
						end
				when 3 then -- if:
						l_stat_res := stat (create {CE_POINTER [INTEGER_8]}.make_cast (a_buf___6.item.b_ffname), (l_st.address))
						if not (l_stat_res < 0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L___3
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 6 then -- else:
						if not ((time_differs (l_st.st_mtim.tv_sec, a_buf___6.item.b_mtime)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___3
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 9 then -- else:
						if (l_st.st_mode).to_integer_32 = a_buf___6.item.b_orig_mode then
							l_pos := -1 + 21 -- skip if block
						end
				when 10 then -- if: | _L___3:
						l_retval := 1
						if l_stat_res < 0 then
							a_buf___6.item.b_mtime := 0
							a_buf___6.item.b_orig_size := (0).to_integer_32
							a_buf___6.item.b_orig_mode := 0
						else
							buf_store_time (a_buf___6, l_st.address, a_buf___6.item.b_ffname)
						end
						if (os_unix_inst.mch_isdir (a_buf___6.item.b_fname)).to_boolean then
							l_pos := -1 + 20 -- skip if block
						end
				when 11 then -- if:
						if a_buf___6.item.b_p_ar >= 0 then
							l_tmp___6 := a_buf___6.item.b_p_ar
						else
							l_tmp___6 := option_inst.p_ar
						end
						if not (l_tmp___6.to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if (undo_inst.bufIsChanged (a_buf___6)).to_boolean then
							l_pos := -1 + 14 -- goto _L___1
						elseif l_stat_res >= 0 then
							l_reload := 1
						else
							l_pos := -1 + 14 -- goto _L___1
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 14 then -- else: | _L___1:
						if l_stat_res < 0 then
							l_reason.ce_gets (ce_string ("deleted"))
						elseif (undo_inst.bufIsChanged (a_buf___6)).to_boolean then
							l_reason.ce_gets (ce_string ("conflict"))
						elseif l_orig_size /= a_buf___6.item.b_orig_size then
							l_reason.ce_gets (ce_string ("changed"))
						elseif (buffer_inst.buf_contents_changed (a_buf___6)).to_boolean then
							l_reason.ce_gets (ce_string ("changed"))
						elseif l_orig_mode /= a_buf___6.item.b_orig_mode then
							l_reason.ce_gets (ce_string ("mode"))
						else
							l_reason.ce_gets (ce_string ("time"))
						end
						busy := 1
						eval_inst.set_vim_var_string (37, create {CE_POINTER [NATURAL_8]}.make_cast (l_reason), -1)
						eval_inst.set_vim_var_string (38, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), -1)
						globals_inst.allbuf_lock := globals_inst.allbuf_lock + 1
						l_n := apply_autocmds ({PC_AUTO_EVENT}.EVENT_FILECHANGEDSHELL, a_buf___6.item.b_fname, a_buf___6.item.b_fname, 0, a_buf___6)
						globals_inst.allbuf_lock := globals_inst.allbuf_lock - 1
						busy := 0
						if not (l_n.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 15 then -- if:
						if not (buffer_inst.buf_valid (a_buf___6)).to_boolean then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E246: FileChangedShell autocommand deleted buffer"))))).do_nothing
						end
						l_s.ce_gets (eval_inst.get_vim_var_str (38))
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("reload"))) /= 0 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if (l_reason[0]).to_integer_32 /= 100 then
							l_reload := 1
						else
							l_pos := -1 + 18 -- goto _L
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), ce_string ("ask"))) = 0 then
							l_n := 0
						else
							Result := 2
							js.return
						end
				when 19 then -- if done
						if not js.return_called and then (not l_n.to_boolean) then
							if (l_reason[0]).to_integer_32 = 100 then
								l_mesg.ce_gets (gettext (ce_string ("E211: File %"%%s%" no longer available")))
							else
								l_helpmesg := 1
								l_can_reload := 1
								if (l_reason[2]).to_integer_32 = 110 then
									l_mesg.ce_gets (gettext (ce_string ("W12: Warning: File %"%%s%" has changed and the buffer was changed in Vim as well")))
									l_mesg2.ce_gets (gettext (ce_string ("See %":help W12%" for more info.")))
								elseif (l_reason[1]).to_integer_32 = 104 then
									l_mesg.ce_gets (gettext (ce_string ("W11: Warning: File %"%%s%" has changed since editing started")))
									l_mesg2.ce_gets (gettext (ce_string ("See %":help W11%" for more info.")))
								elseif (l_reason[0]).to_integer_32 = 109 then
									l_mesg.ce_gets (gettext (ce_string ("W16: Warning: Mode of file %"%%s%" has changed since editing started")))
									l_mesg2.ce_gets (gettext (ce_string ("See %":help W16%" for more info.")))
								else
									a_buf___6.item.b_mtime_read := a_buf___6.item.b_mtime
								end
							end
						end
				when 20 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						l_pos := -1 + 25 -- goto _L___4
				when 22 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else:
						l_pos := -1 + 25 -- goto _L___4
				when 24 then -- if done | if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else: | _L___4:
						if ((a_buf___6.item.b_flags).bit_and (16)).to_boolean then
							if not ((a_buf___6.item.b_flags).bit_and (32)).to_boolean then
								if (misc1_inst.vim_fexists (a_buf___6.item.b_ffname)).to_boolean then
									l_retval := 1
									l_mesg.ce_gets (gettext (ce_string ("W13: Warning: File %"%%s%" has been created after editing started")))
									a_buf___6.item.b_flags := (a_buf___6.item.b_flags).bit_or ((32))
									l_can_reload := 1
								end
							end
						end
				when 26 then -- if done
						if js.return_called then
							l_pos := -1 + 44 -- skip if block
						end
				when 27 then -- if:
							if (l_mesg.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_pos := -1 + 43 -- skip if block
							end
				when 28 then -- if:
							l_path.ce_gets (misc1_inst.home_replace_save (a_buf___6, a_buf___6.item.b_fname))
							if (l_path.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_pos := -1 + 43 -- skip if block
							end
				when 29 then -- if:
							if not l_helpmesg.to_boolean then
								l_mesg2.ce_gets (ce_string (""))
							end
							l_tmp___11 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_path))
							l_tmp___12 := strlen (l_mesg)
							l_tbuf.ce_gets (misc2_inst.alloc (((l_tmp___11 + l_tmp___12) + (strlen (l_mesg2))) + {NATURAL_32} 2))
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_tbuf), l_mesg, l_path]).do_nothing
							eval_inst.set_vim_var_string (4, l_tbuf, -1)
							if not (l_can_reload.to_boolean) then
								l_pos := -1 + 32 -- skip if block
							end
				when 30 then -- if:
							if (l_mesg2[0]).to_integer_32 /= 0 then
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_tbuf), ce_string ("%N")).do_nothing
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_tbuf), l_mesg2).do_nothing
							end
							l_tmp___14.ce_gets (gettext (ce_string ("&OK%N&Load File")))
							if (message_inst.do_dialog (2, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Warning")))), l_tbuf, create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___14), 1, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))) = 2 then
								l_reload := 1
							end
				when 31 then -- if block done, skip else block:
							l_pos := -1 + 42
				when 32 then -- else:
							if not (globals_inst.State > 257) then
								l_pos := -1 + 35 -- skip if block
							end
				when 33 then -- if:
							l_pos := -1 + 39 -- goto _L___5
				when 34 then -- if block done, skip else block:
							l_pos := -1 + 42
				when 35 then -- else:
							if not (((globals_inst.State).bit_and (8)).to_boolean) then
								l_pos := -1 + 38 -- skip if block
							end
				when 36 then -- if:
							l_pos := -1 + 39 -- goto _L___5
				when 37 then -- if block done, skip else block:
							l_pos := -1 + 42
				when 38 then -- else:
							if not (already_warned.to_boolean) then
								l_pos := -1 + 41 -- skip if block
							end
				when 39 then -- if: | _L___5:
							if (l_mesg2[0]).to_integer_32 /= 0 then
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_tbuf), ce_string ("; ")).do_nothing
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_tbuf), l_mesg2).do_nothing
							end
							message_inst.emsg (l_tbuf).do_nothing
							l_retval := 2
				when 40 then -- if block done, skip else block:
							l_pos := -1 + 42
				when 41 then -- else:
							if not globals_inst.autocmd_busy.to_boolean then
								message_inst.msg_start
								message_inst.msg_puts_attr (l_tbuf, globals_inst.highlight_attr[3] + 4096)
								if (l_mesg2[0]).to_integer_32 /= 0 then
									message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast (l_mesg2), globals_inst.highlight_attr[17] + 4096)
								end
								message_inst.msg_clr_eos
								message_inst.msg_end.do_nothing
								if globals_inst.emsg_silent = 0 then
									term_inst.out_flush
									if not a_focus.to_boolean then
										ui_inst.ui_delay (1000, 1)
									end
									globals_inst.redraw_cmdline := 0
								end
							end
							already_warned := 1
				when 42 then -- if done | if done | if done
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_path))
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tbuf))
				when 43 then -- if done | if done
							if l_reload.to_boolean then
								buf_reload (a_buf___6, l_orig_mode)
							end
							if (buffer_inst.buf_valid (a_buf___6)).to_boolean then
								if l_retval /= 0 then
									apply_autocmds ({PC_AUTO_EVENT}.EVENT_FILECHANGEDSHELLPOST, a_buf___6.item.b_fname, a_buf___6.item.b_fname, 0, a_buf___6).do_nothing
								end
							end
							globals_inst.need_mouse_correct := l_save_mouse_correct
							Result := l_retval
				when 44 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	buf_reload (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_orig_mode: INTEGER_32)
		local
			l_ea: PD_EXARG
			l_old_cursor: PD_POS_T
			l_old_topline___0: INTEGER_32
			l_old_ro: INTEGER_32
			l_savebuf: CE_POINTER [PD_FILE_BUFFER]
			l_saved: INTEGER_32
			l_aco: PD_ACO_SAVE_T
			l_flags___0: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_tp: CE_POINTER [PD_TABPAGE_S]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ea.make
			create l_old_cursor.make
			create l_savebuf.make
			create l_aco.make
			create l_tmp.make
			create l_wp___0.make
			create l_tp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_old_ro := a_buf___6.item.b_p_ro
					l_saved := 1
					l_flags___0 := 1
					aucmd_prepbuf (l_aco.address, a_buf___6)
					if (prep_exarg (l_ea.address, a_buf___6)) /= 1 then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_old_cursor.ce_gets (globals_inst.curwin.item.w_cursor)
						l_old_topline___0 := globals_inst.curwin.item.w_topline
						if option_inst.p_ur < 0 then
							undo_inst.u_sync (0)
							l_saved := undo_inst.u_savecommon ((0).to_integer_32, globals_inst.curbuf.item.b_ml.ml_line_count + 1, (0).to_integer_32, 1)
							l_flags___0 := (l_flags___0).bit_or ((32))
						elseif globals_inst.curbuf.item.b_ml.ml_line_count <= option_inst.p_ur then
							undo_inst.u_sync (0)
							l_saved := undo_inst.u_savecommon ((0).to_integer_32, globals_inst.curbuf.item.b_ml.ml_line_count + 1, (0).to_integer_32, 1)
							l_flags___0 := (l_flags___0).bit_or ((32))
						end
						if globals_inst.curbuf.item.b_ml.ml_line_count /= 1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if ((memline_inst.ml_get ((1).to_integer_32)).item).to_integer_32 = 0 then
							l_savebuf.ce_gets (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_saved = 0 then
							l_savebuf.ce_gets (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
						else
							l_savebuf.ce_gets (buffer_inst.buflist_new (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), (1).to_integer_32, 4))
							if (l_savebuf.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if (a_buf___6.c_pointer.to_integer_32).to_natural_32 = (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 then
									globals_inst.curbuf.ce_gets (l_savebuf)
									globals_inst.curwin.item.w_buffer := l_savebuf
									l_saved := memline_inst.ml_open (globals_inst.curbuf)
									globals_inst.curbuf.ce_gets (a_buf___6)
									globals_inst.curwin.item.w_buffer := a_buf___6
								end
							end
							if (l_savebuf.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_tmp.ce_gets (gettext (ce_string ("E462: Could not prepare for reloading %"%%s%"")))
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp), a_buf___6.item.b_fname).do_nothing
								l_saved := 0
							elseif l_saved = 0 then
								l_tmp.ce_gets (gettext (ce_string ("E462: Could not prepare for reloading %"%%s%"")))
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp), a_buf___6.item.b_fname).do_nothing
								l_saved := 0
							elseif (a_buf___6.c_pointer.to_integer_32).to_natural_32 /= (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 then
								l_tmp.ce_gets (gettext (ce_string ("E462: Could not prepare for reloading %"%%s%"")))
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp), a_buf___6.item.b_fname).do_nothing
								l_saved := 0
							elseif (move_lines (a_buf___6, l_savebuf)) = 0 then
								l_tmp.ce_gets (gettext (ce_string ("E462: Could not prepare for reloading %"%%s%"")))
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp), a_buf___6.item.b_fname).do_nothing
								l_saved := 0
							end
						end
				when 5 then
						if l_saved = 1 then
							globals_inst.curbuf.item.b_flags := (globals_inst.curbuf.item.b_flags).bit_or ((2))
							globals_inst.keep_filetype := 1
							if (readfile (a_buf___6.item.b_ffname, a_buf___6.item.b_fname, (0).to_integer_32, (0).to_integer_32, 2147483647, l_ea.address, l_flags___0)) = 0 then
								if not (ex_eval_inst.aborting).to_boolean then
									message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E321: Could not reload %"%%s%"")))), a_buf___6.item.b_fname).do_nothing
								end
								if (l_savebuf.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if (buffer_inst.buf_valid (l_savebuf)).to_boolean then
										if (a_buf___6.c_pointer.to_integer_32).to_natural_32 = (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 then
											from
											until
												js.loop_left
											loop
												js.reset
												if globals_inst.curbuf.item.b_ml.ml_line_count = 1 then
													if ((memline_inst.ml_get ((1).to_integer_32)).item).to_integer_32 = 0 then
														js.break
													end
												end
												if not js.loop_jumped then
													if (memline_inst.ml_delete (a_buf___6.item.b_ml.ml_line_count, 0)) = 0 then
														js.break
													end
												end
											end
											js.reset
											move_lines (l_savebuf, a_buf___6).do_nothing
										end
									end
								end
							elseif (a_buf___6.c_pointer.to_integer_32).to_natural_32 = (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 then
								misc1_inst.unchanged (a_buf___6, 1)
								if ((l_flags___0).bit_and (32)) = 0 then
									undo_inst.u_blockfree (a_buf___6)
									undo_inst.u_clearall (a_buf___6)
								else
									undo_inst.u_unchanged (globals_inst.curbuf)
								end
							end
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ea.cmd))
						if (l_savebuf.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (buffer_inst.buf_valid (l_savebuf)).to_boolean then
								buffer_inst.wipe_buffer (l_savebuf, 0)
							end
						end
						diff_inst.diff_invalidate (globals_inst.curbuf)
						if l_old_topline___0 > globals_inst.curbuf.item.b_ml.ml_line_count then
							globals_inst.curwin.item.w_topline := globals_inst.curbuf.item.b_ml.ml_line_count
						else
							globals_inst.curwin.item.w_topline := l_old_topline___0
						end
						globals_inst.curwin.item.w_cursor := l_old_cursor
						misc2_inst.check_cursor
						move_inst.update_topline
						globals_inst.keep_filetype := 0
						l_tp.ce_gets (globals_inst.first_tabpage)
						from
						until
							not (not js.loop_left and then ((l_tp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
						loop
							if (l_tp.c_pointer.to_integer_32).to_natural_32 = (globals_inst.curtab.c_pointer.to_integer_32).to_natural_32 then
								l_wp___0.ce_gets (globals_inst.firstwin)
							else
								l_wp___0.ce_gets (l_tp.item.tp_firstwin)
							end
							from
							until
								(l_wp___0).c_pointer = default_pointer
							loop
								if ((l_wp___0.item.w_buffer).c_pointer.to_integer_32).to_natural_32 = ((globals_inst.curwin.item.w_buffer).c_pointer.to_integer_32).to_natural_32 then
									if not (fold_inst.foldmethodIsManual (l_wp___0)).to_boolean then
										fold_inst.foldUpdateAll (l_wp___0)
									end
								end
								l_wp___0.ce_gets (l_wp___0.item.w_next)
							end
							l_tp.ce_gets (l_tp.item.tp_next)
						end
						if a_orig_mode = globals_inst.curbuf.item.b_orig_mode then
							globals_inst.curbuf.item.b_p_ro := (globals_inst.curbuf.item.b_p_ro).bit_or (l_old_ro)
						end
				when 6 then -- if done
					aucmd_restbuf (l_aco.address)
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	buf_store_time (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_st: CE_POINTER [SD_STAT]; a_fname: CE_POINTER [NATURAL_8])
		do
			a_buf___6.item.b_mtime := a_st.item.st_mtim.tv_sec
			a_buf___6.item.b_orig_size := a_st.item.st_size
			a_buf___6.item.b_orig_mode := (a_st.item.st_mode).to_integer_32
		end

	write_lnum_adjust (a_offset: INTEGER_32)
		do
			if globals_inst.write_no_eol_lnum /= 0 then
				globals_inst.write_no_eol_lnum := globals_inst.write_no_eol_lnum + a_offset
			end
		end

	vim_deltempdir
		local
			l_files: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_file_count: INTEGER_32
			l_i___0: INTEGER_32
		do
			create l_files.make

			if (globals_inst.vim_tempdir.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff), ce_string ("%%s*"), globals_inst.vim_tempdir]).do_nothing
				if (misc1_inst.gen_expand_wildcards (1, globals_inst.NameBuff.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_file_count), l_files.address, 35)) = 1 then
					l_i___0 := 0
					from
					until
						not (l_i___0 < l_file_count)
					loop
						unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_files[l_i___0])).do_nothing
						l_i___0 := l_i___0 + 1
					end
					misc1_inst.FreeWild (l_file_count, l_files)
				end
				(misc1_inst.gettail (globals_inst.NameBuff))[-1] := (('%/0/').code).to_natural_8
				rmdir (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff)).do_nothing
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.vim_tempdir))
				globals_inst.vim_tempdir.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	vim_settempdir (a_tempdir: CE_POINTER [NATURAL_8])
		local
			l_buf___6: CE_POINTER [NATURAL_8]
		do
			create l_buf___6.make

			l_buf___6.ce_gets (misc2_inst.alloc ({NATURAL_32} 4098))
			if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (window_inst.vim_FullName (a_tempdir, l_buf___6, 4096, 0)) = 0 then
					strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), create {CE_POINTER [INTEGER_8]}.make_cast (a_tempdir)).do_nothing
				end
				misc1_inst.add_pathsep (l_buf___6)
				globals_inst.vim_tempdir.ce_gets (misc2_inst.vim_strsave (l_buf___6))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
			end
		end

	vim_tempname (a_extra_char: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_itmp: CE_ARRAY [NATURAL_8]
			l_i___0: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_itmp.make (<<256>>)

			if (globals_inst.vim_tempdir.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_i___0 := 0
				from
				until
					not (not js.loop_left and then (l_i___0 < ((Pointer_bytes.to_natural_32 * (4).to_natural_32) // Pointer_bytes.to_natural_32).to_integer_32))
				loop
					js.reset
					misc1_inst.expand_env (create {CE_POINTER [NATURAL_8]}.make_cast (tempdirs[l_i___0]), l_itmp, 236)
					if (os_unix_inst.mch_isdir (l_itmp)).to_boolean then
						misc1_inst.add_pathsep (l_itmp)
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_itmp), ce_string ("vXXXXXX")).do_nothing
						if ((mkdtemp (create {CE_POINTER [INTEGER_8]}.make_cast (l_itmp))).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							vim_settempdir (l_itmp)
						end
						if (globals_inst.vim_tempdir.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							js.break
						end
					end
					if not js.loop_jumped then
						l_i___0 := l_i___0 + 1
					end
				end
				js.reset
			end
			if (globals_inst.vim_tempdir.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_tmp___1 := temp_count
				temp_count := temp_count + 1
				sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_itmp), ce_string ("%%s%%ld"), globals_inst.vim_tempdir, l_tmp___1]).do_nothing
				Result := (misc2_inst.vim_strsave (l_itmp))
				js.return
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	show_autocmd (a_ap___0: CE_POINTER [PD_AUTOPAT]; a_event: INTEGER_32)
		local
			l_ac: CE_POINTER [PD_AUTOCMD]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ac.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if globals_inst.got_int.to_boolean then
						js.return
					end
					if not js.return_called and then (((a_ap___0.item.pat).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32) then
						js.return
					end
					if not js.return_called then
						message_inst.msg_putchar (('%N').code)
						if globals_inst.got_int.to_boolean then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if a_event.to_natural_32 = last_event.to_natural_32 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if a_ap___0.item.group = last_group then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if a_ap___0.item.group /= -1 then
							if ((create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (augroups.ga_data)[a_ap___0.item.group]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("--Deleted--")))), globals_inst.highlight_attr[3])
							else
								message_inst.msg_puts_attr (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (augroups.ga_data)[a_ap___0.item.group], globals_inst.highlight_attr[14])
							end
							message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("  ")))
						end
						message_inst.msg_puts_attr ((event_nr2name (a_event)), globals_inst.highlight_attr[14])
						last_event := a_event
						last_group := a_ap___0.item.group
						message_inst.msg_putchar (('%N').code)
						if globals_inst.got_int.to_boolean then
							js.return
						end
				when 6 then -- if done | if done
						if not js.return_called then
							globals_inst.msg_col := 4
							message_inst.msg_outtrans (a_ap___0.item.pat).do_nothing
							l_ac.ce_gets (a_ap___0.item.cmds)
							from
							until
								not (not js.loop_left and then ((l_ac.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
							loop
								if ((l_ac.item.cmd).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if globals_inst.msg_col >= 14 then
										message_inst.msg_putchar (('%N').code)
									end
									globals_inst.msg_col := 14
									if globals_inst.got_int.to_boolean then
										js.return
									end
									if not js.return_called then
										message_inst.msg_outtrans (l_ac.item.cmd).do_nothing
										if option_inst.p_verbose > 0 then
											eval_inst.last_set_msg (l_ac.item.scriptID)
										end
										if globals_inst.got_int.to_boolean then
											js.return
										end
									end
									if not js.return_called and then (((l_ac.item.next).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32) then
										message_inst.msg_putchar (('%N').code)
										if globals_inst.got_int.to_boolean then
											js.return
										end
									end
								end
								if not js.return_called then
									l_ac.ce_gets (l_ac.item.next)
								end
							end
						end
						if not js.return_called then
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	au_remove_pat (a_ap___0: CE_POINTER [PD_AUTOPAT])
		do
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_ap___0.item.pat))
			a_ap___0.item.pat := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			a_ap___0.item.buflocal_nr := -1
			au_need_clean := 1
		end

	au_remove_cmds (a_ap___0: CE_POINTER [PD_AUTOPAT])
		local
			l_ac: CE_POINTER [PD_AUTOCMD]
		do
			create l_ac.make

			l_ac.ce_gets (a_ap___0.item.cmds)
			from
			until
				(l_ac.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
			loop
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ac.item.cmd))
				l_ac.item.cmd := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				l_ac.ce_gets (l_ac.item.next)
			end
			au_need_clean := 1
		end

	au_cleanup
		local
			l_ap___0: CE_POINTER [PD_AUTOPAT]
			l_prev_ap: CE_POINTER [CE_POINTER [PD_AUTOPAT]]
			l_ac: CE_POINTER [PD_AUTOCMD]
			l_prev_ac: CE_POINTER [CE_POINTER [PD_AUTOCMD]]
			l_event: INTEGER_32
			js: JUMP_STATE
		do
			create l_ap___0.make
			create l_prev_ap.make
			create l_ac.make
			create l_prev_ac.make

			if globals_inst.autocmd_busy.to_boolean then
				js.return
			elseif not au_need_clean.to_boolean then
				js.return
			end
			if not js.return_called then
				l_event := {PC_AUTO_EVENT}.EVENT_BUFADD
				from
				until
					not (not js.loop_left and then (l_event < 77))
				loop
					l_prev_ap.ce_gets (first_autopat + l_event)
					l_ap___0.ce_gets (l_prev_ap.item)
					from
					until
						not (not js.loop_left and then ((l_ap___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
					loop
						l_prev_ac.ce_gets (create {CE_POINTER [CE_POINTER [PD_AUTOCMD]]}.make_shared (l_ap___0.c_pointer + {PD_AUTOPAT}.cmds_offset))
						l_ac.ce_gets (l_prev_ac.item)
						from
						until
							(l_ac.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
						loop
							if ((l_ap___0.item.pat).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_prev_ac.item := l_ac.item.next
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ac.item.cmd))
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ac))
							elseif ((l_ac.item.cmd).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_prev_ac.item := l_ac.item.next
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ac.item.cmd))
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ac))
							else
								l_prev_ac.ce_gets (create {CE_POINTER [CE_POINTER [PD_AUTOCMD]]}.make_shared (l_ac.c_pointer + {PD_AUTOCMD}.next_offset))
							end
							l_ac.ce_gets (l_prev_ac.item)
						end
						if ((l_ap___0.item.pat).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_prev_ap.item := l_ap___0.item.next
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ap___0.item.reg_prog))
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ap___0))
						else
							l_prev_ap.ce_gets (create {CE_POINTER [CE_POINTER [PD_AUTOPAT]]}.make_shared (l_ap___0.c_pointer + {PD_AUTOPAT}.next_offset))
						end
						l_ap___0.ce_gets (l_prev_ap.item)
					end
					l_event := (l_event + 1)
				end
				au_need_clean := 0
			end
		end

	aubuflocal_remove (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		local
			l_ap___0: CE_POINTER [PD_AUTOPAT]
			l_event: INTEGER_32
			l_apc: CE_POINTER [PD_AUTOPATCMD]
			l_tmp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_ap___0.make
			create l_apc.make
			create l_tmp.make

			l_apc.ce_gets (active_apc_list)
			from
			until
				(l_apc).c_pointer = default_pointer
			loop
				if a_buf___6.item.b_fnum = l_apc.item.arg_bufnr then
					l_apc.item.arg_bufnr := 0
				end
				l_apc.ce_gets (l_apc.item.next)
			end
			l_event := {PC_AUTO_EVENT}.EVENT_BUFADD
			from
			until
				not (not js.loop_left and then (l_event < 77))
			loop
				l_ap___0.ce_gets (first_autopat[l_event])
				from
				until
					(l_ap___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
				loop
					if l_ap___0.item.buflocal_nr = a_buf___6.item.b_fnum then
						au_remove_pat (l_ap___0)
						if option_inst.p_verbose >= 6 then
							message_inst.verbose_enter
							l_tmp.ce_gets (event_nr2name (l_event))
							message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("auto-removing autocommand: %%s <buffer=%%d>")))), l_tmp, a_buf___6.item.b_fnum]).do_nothing
							message_inst.verbose_leave
						end
					end
					l_ap___0.ce_gets (l_ap___0.item.next)
				end
				l_event := (l_event + 1)
			end
			au_cleanup
		end

	au_new_group (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := au_find_group (a_name___1)
			if l_i___0 = -2 then
				l_i___0 := 0
				from
				until
					not (not js.loop_left and then (l_i___0 < augroups.ga_len))
				loop
					js.reset
					if ((create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (augroups.ga_data)[l_i___0]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.break
					end
					if not js.loop_jumped then
						l_i___0 := l_i___0 + 1
					end
				end
				js.reset
				if l_i___0 = augroups.ga_len then
					if (misc2_inst.ga_grow (augroups.address, 1)) = 0 then
						Result := (-2)
						js.return
					end
				end
				if not js.return_called then
					create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (augroups.ga_data)[l_i___0] := misc2_inst.vim_strsave (a_name___1)
					if ((create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (augroups.ga_data)[l_i___0]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := (-2)
						js.return
					end
				end
				if not js.return_called and then (l_i___0 = augroups.ga_len) then
					augroups.ga_len := (augroups.ga_len) + 1
				end
			end
			if not js.return_called then
				Result := l_i___0
			end
		end

	au_del_group (a_name___1: CE_POINTER [NATURAL_8])
		local
			l_i___0: INTEGER_32
		do
			l_i___0 := au_find_group (a_name___1)
			if l_i___0 = -2 then
				message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E367: No such group: %"%%s%"")))), a_name___1).do_nothing
			else
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (augroups.ga_data)[l_i___0]))
				create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (augroups.ga_data)[l_i___0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			end
		end

	au_find_group (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (l_i___0 < augroups.ga_len))
			loop
				if ((create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (augroups.ga_data)[l_i___0]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (augroups.ga_data)[l_i___0]), create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1))) = 0 then
						Result := l_i___0
						js.return
					end
				end
				if not js.return_called then
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				Result := (-2)
			end
		end

	au_has_group (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := ((au_find_group (a_name___1)) /= -2).to_integer
		end

	do_augroup (a_arg: CE_POINTER [NATURAL_8]; a_del_group: INTEGER_32)
		local
			l_i___0: INTEGER_32
		do
			if a_del_group.to_boolean then
				if (a_arg.item).to_integer_32 = 0 then
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_argreq))))).do_nothing
				else
					au_del_group (a_arg)
				end
			elseif (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_arg), ce_string ("end"))) = 0 then
				current_augroup := -1
			elseif (a_arg.item).to_boolean then
				l_i___0 := au_new_group (a_arg)
				if l_i___0 /= -2 then
					current_augroup := l_i___0
				end
			else
				message_inst.msg_start
				l_i___0 := 0
				from
				until
					not (l_i___0 < augroups.ga_len)
				loop
					if ((create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (augroups.ga_data)[l_i___0]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						message_inst.msg_puts (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (augroups.ga_data)[l_i___0])
						message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("  ")))
					end
					l_i___0 := l_i___0 + 1
				end
				message_inst.msg_clr_eos
				message_inst.msg_end.do_nothing
			end
		end

	event_name2nr (a_start___1: CE_POINTER [NATURAL_8]; a_end: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0.ce_gets (a_start___1)
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_p___0.item).to_boolean then
					if (l_p___0.item).to_integer_32 = 32 then
						js.break
					elseif (l_p___0.item).to_integer_32 = 9 then
						js.break
					elseif (l_p___0.item).to_integer_32 = 44 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_p___0.ce_gets (l_p___0 + 1)
				end
			end
			js.reset
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (((event_names[l_i___0].name).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				js.reset
				l_len := (strlen (event_names[l_i___0].name)).to_integer_32
				if l_len = l_p___0.distance (a_start___1) then
					if (strncasecmp (event_names[l_i___0].name, create {CE_POINTER [INTEGER_8]}.make_cast (a_start___1), l_len.to_natural_32)) = 0 then
						js.break
					end
				end
				if not js.loop_jumped then
					l_i___0 := l_i___0 + 1
				end
			end
			js.reset
			if (l_p___0.item).to_integer_32 = 44 then
				l_p___0.ce_gets (l_p___0 + 1)
			end
			a_end.item := l_p___0
			if ((event_names[l_i___0].name).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := ({PC_AUTO_EVENT}.NUM_EVENTS)
				js.return
			end
			if not js.return_called then
				Result := (event_names[l_i___0].event)
			end
		end

	event_nr2name (a_event: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (((event_names[l_i___0].name).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				if (event_names[l_i___0].event).to_natural_32 = a_event.to_natural_32 then
					Result := (create {CE_POINTER [NATURAL_8]}.make_cast (event_names[l_i___0].name))
					js.return
				end
				if not js.return_called then
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Unknown")))
			end
		end

	find_end_event (a_arg: CE_POINTER [NATURAL_8]; a_have_group: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_pat: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_pat.make
			create l_p___0.make

			if (a_arg.item).to_integer_32 = 42 then
				if (a_arg[1]).to_boolean then
					if (a_arg[1]).to_integer_32 /= 32 then
						if (a_arg[1]).to_integer_32 /= 9 then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E215: Illegal character after *: %%s")))), a_arg).do_nothing
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
					end
				end
				if not js.return_called then
					l_pat.ce_gets (a_arg + 1)
				end
			else
				l_pat.ce_gets (a_arg)
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_pat.item).to_boolean then
						if (l_pat.item).to_integer_32 = 32 then
							js.break
						elseif (l_pat.item).to_integer_32 = 9 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						if (event_name2nr (l_pat, l_p___0.address)) >= 77 then
							if a_have_group.to_boolean then
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E216: No such event: %%s")))), l_pat).do_nothing
							else
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E216: No such group or event: %%s")))), l_pat).do_nothing
							end
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called then
							l_pat.ce_gets (l_p___0)
						end
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := l_pat
			end
		end

	event_ignored (a_event: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0.ce_gets (option_inst.p_ei)
			from
			until
				not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0))
			loop
				if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("all"), (3).to_natural_32)) = 0 then
					if (l_p___0[3]).to_integer_32 = 0 then
						Result := 1
						js.return
					elseif (l_p___0[3]).to_integer_32 = 44 then
						Result := 1
						js.return
					end
				end
				if not js.return_called then
					if (event_name2nr (l_p___0, l_p___0.address)).to_natural_32 = a_event.to_natural_32 then
						Result := 1
						js.return
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	check_ei: INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (option_inst.p_ei)
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_p___0.item).to_boolean)) then
						l_pos := -1 + 13 -- skip loop
					end
				when 2 then -- loop body:
						if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("all"), (3).to_natural_32)) /= 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						if (l_p___0[3]).to_integer_32 /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if (l_p___0[3]).to_integer_32 /= 44 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___0:
						l_p___0.ce_gets (l_p___0 + (3))
						if (l_p___0.item).to_integer_32 = 44 then
							l_p___0.ce_gets (l_p___0 + 1)
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_pos := -1 + 11 -- goto _L
				when 10 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L:
						if (event_name2nr (l_p___0, l_p___0.address)).to_natural_32 = {NATURAL_32} 77 then
							Result := 0
							js.return
						end
				when 12 then
						l_pos := -1 + 1 -- back to loop condition
				when 13 then -- loop done
					if not js.return_called then
						Result := 1
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	au_event_disable (a_what: CE_POINTER [INTEGER_8]): CE_POINTER [NATURAL_8]
		local
			l_new_ei: CE_POINTER [NATURAL_8]
			l_save_ei: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
		do
			create l_new_ei.make
			create l_save_ei.make

			l_save_ei.ce_gets (misc2_inst.vim_strsave (option_inst.p_ei))
			if (l_save_ei.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_tmp := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_ei))
				l_new_ei.ce_gets (misc2_inst.vim_strnsave (option_inst.p_ei, (l_tmp + (strlen (a_what))).to_integer_32))
				if (l_new_ei.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if (a_what[0]).to_integer_32 = 44 then
						if (option_inst.p_ei.item).to_integer_32 = 0 then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_new_ei), (a_what + 1)).do_nothing
						else
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_new_ei), a_what).do_nothing
						end
					else
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_new_ei), a_what).do_nothing
					end
					option_inst.set_string_option_direct (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ei")), -1, l_new_ei, 1, -6)
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_new_ei))
				end
			end
			Result := l_save_ei
		end

	au_event_restore (a_old_ei: CE_POINTER [NATURAL_8])
		do
			if (a_old_ei.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				option_inst.set_string_option_direct (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ei")), -1, a_old_ei, 1, -6)
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_old_ei))
			end
		end

	do_autocmd (a_arg: CE_POINTER [NATURAL_8]; a_forceit: INTEGER_32)
		local
			l_arg: CE_POINTER [NATURAL_8]
			l_pat: CE_POINTER [NATURAL_8]
			l_envpat: CE_POINTER [NATURAL_8]
			l_cmd: CE_POINTER [NATURAL_8]
			l_event: INTEGER_32
			l_need_free: INTEGER_32
			l_nested___0: INTEGER_32
			l_group: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_arg.make
			create l_pat.make
			create l_envpat.make
			create l_cmd.make
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_arg.ce_gets (a_arg)
					l_envpat.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_need_free := 0
					l_nested___0 := 0
					l_group := au_get_grouparg (l_arg.address)
					if (l_arg.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.return
					end
					if not js.return_called then
						l_pat.ce_gets (find_end_event (l_arg, (l_group /= -3).to_integer))
						if (l_pat.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 18 -- skip if block
					end
				when 1 then -- if:
						l_pat.ce_gets (charset_inst.skipwhite (l_pat))
						l_cmd.ce_gets (l_pat)
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 12 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if not ((l_cmd.item).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						if (l_cmd.item).to_integer_32 /= 32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if (l_cmd.item).to_integer_32 /= 9 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if (l_cmd[-1]).to_integer_32 /= 92 then
							js.break
						end
				when 9 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						js.break
				when 11 then
						if not js.loop_jumped then
							l_cmd.ce_gets (l_cmd + 1)
						end
						l_pos := -1 + 2 -- back to loop condition
				when 12 then -- loop done
						js.reset
						if (l_cmd.item).to_boolean then
							l_tmp.ce_gets (l_cmd)
							l_cmd.ce_gets (l_cmd + 1)
							l_tmp.item := (('%/0/').code).to_natural_8
						end
						if ((misc2_inst.vim_strchr (l_pat, ('$').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L___0
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 15 then -- else:
						if ((misc2_inst.vim_strchr (l_pat, ('~').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L___0:
						l_envpat.ce_gets (misc1_inst.expand_env_save (l_pat))
						if (l_envpat.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pat.ce_gets (l_envpat)
						end
				when 17 then -- if done
						l_cmd.ce_gets (charset_inst.skipwhite (l_cmd))
						if (l_cmd.item).to_integer_32 /= 0 then
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_cmd), ce_string ("nested"), (6).to_natural_32)) = 0 then
								if (l_cmd[6]).to_integer_32 = 32 then
									l_nested___0 := 1
									l_cmd.ce_gets (charset_inst.skipwhite (l_cmd + 6))
								elseif (l_cmd[6]).to_integer_32 = 9 then
									l_nested___0 := 1
									l_cmd.ce_gets (charset_inst.skipwhite (l_cmd + 6))
								end
							end
						end
						if (l_cmd.item).to_integer_32 /= 0 then
							l_cmd.ce_gets (ex_docmd_inst.expand_sfile (l_cmd))
							if (l_cmd.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.return
							end
							if not js.return_called then
								l_need_free := 1
							end
						end
				when 18 then -- if done
					if js.return_called then
						l_pos := -1 + 27 -- skip if block
					end
				when 19 then -- if:
						if not a_forceit.to_boolean then
							if (l_cmd.item).to_integer_32 = 0 then
								message_inst.msg_puts_title (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%N--- Auto-Commands ---")))))
							end
						end
						last_event := -1
						last_group := -2
						if (l_arg.item).to_integer_32 /= 42 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 23 -- goto _L___1
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 22 then -- else:
						if (l_arg.item).to_integer_32 /= 0 then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if: | _L___1:
						l_event := {PC_AUTO_EVENT}.EVENT_BUFADD
						from
						until
							not (not js.loop_left and then (l_event < 77))
						loop
							js.reset
							if (do_autocmd_event (l_event, l_pat, l_nested___0, l_cmd, a_forceit, l_group)) = 0 then
								js.break
							end
							if not js.loop_jumped then
								l_event := (l_event + 1)
							end
						end
						js.reset
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else:
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_arg.item).to_boolean then
								if (l_arg.item).to_integer_32 = 32 then
									js.break
								elseif (l_arg.item).to_integer_32 = 9 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if (do_autocmd_event ((event_name2nr (l_arg, l_arg.address)), l_pat, l_nested___0, l_cmd, a_forceit, l_group)) = 0 then
									js.break
								end
							end
						end
						js.reset
				when 26 then -- if done
						if l_need_free.to_boolean then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cmd))
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_envpat))
				when 27 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	au_get_grouparg (a_argp: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_group_name: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_arg: CE_POINTER [NATURAL_8]
			l_group: INTEGER_32
			js: JUMP_STATE
		do
			create l_group_name.make
			create l_p___0.make
			create l_arg.make

			l_arg.ce_gets (a_argp.item)
			l_group := -3
			l_p___0.ce_gets (charset_inst.skiptowhite (l_arg))
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_arg.c_pointer.to_integer_32).to_natural_32 then
				l_group_name.ce_gets (misc2_inst.vim_strnsave (l_arg, l_p___0.distance (l_arg)))
				if (l_group_name.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := (-2)
					js.return
				end
				if not js.return_called then
					l_group := au_find_group (l_group_name)
					if l_group = -2 then
						l_group := -3
					else
						a_argp.item := charset_inst.skipwhite (l_p___0)
					end
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_group_name))
				end
			end
			if not js.return_called then
				Result := l_group
			end
		end

	do_autocmd_event (a_event: INTEGER_32; a_pat: CE_POINTER [NATURAL_8]; a_nested___0: INTEGER_32; a_cmd: CE_POINTER [NATURAL_8]; a_forceit: INTEGER_32; a_group: INTEGER_32): INTEGER_32
		local
			l_pat: CE_POINTER [NATURAL_8]
			l_ap___0: CE_POINTER [PD_AUTOPAT]
			l_prev_ap: CE_POINTER [CE_POINTER [PD_AUTOPAT]]
			l_ac: CE_POINTER [PD_AUTOCMD]
			l_prev_ac: CE_POINTER [CE_POINTER [PD_AUTOCMD]]
			l_brace_level: INTEGER_32
			l_endpat: CE_POINTER [NATURAL_8]
			l_findgroup: INTEGER_32
			l_allgroups: INTEGER_32
			l_patlen: INTEGER_32
			l_is_buflocal: INTEGER_32
			l_buflocal_nr: INTEGER_32
			l_buflocal_pat: CE_ARRAY [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_reg_pat: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_pat.make
			create l_ap___0.make
			create l_prev_ap.make
			create l_ac.make
			create l_prev_ac.make
			create l_endpat.make
			create l_buflocal_pat.make (<<25>>)
			create l_tmp___5.make
			create l_reg_pat.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pat.ce_gets (a_pat)
					if a_group = -3 then
						l_findgroup := current_augroup
					else
						l_findgroup := a_group
					end
					if a_group = -3 then
						if not a_forceit.to_boolean then
							if (a_cmd.item).to_integer_32 = 0 then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
					else
						l_tmp := 0
					end
					l_allgroups := l_tmp
					if (l_pat.item).to_integer_32 = 0 then
						l_ap___0.ce_gets (first_autopat[a_event])
						from
						until
							(l_ap___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
						loop
							if a_forceit.to_boolean then
								if l_ap___0.item.group = l_findgroup then
									au_remove_pat (l_ap___0)
								end
							elseif a_group = -3 then
								show_autocmd (l_ap___0, a_event)
							elseif l_ap___0.item.group = a_group then
								show_autocmd (l_ap___0, a_event)
							end
							l_ap___0.ce_gets (l_ap___0.item.next)
						end
					end
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_pat.item).to_boolean)) then
						l_pos := -1 + 26 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_brace_level := 0
						l_endpat.ce_gets (l_pat)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_endpat.item).to_boolean then
								if (l_endpat.item).to_integer_32 = 44 then
									if not l_brace_level.to_boolean then
										if (l_endpat[-1]).to_integer_32 /= 92 then
											js.break
										end
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if (l_endpat.item).to_integer_32 = 123 then
									l_brace_level := l_brace_level + 1
								elseif (l_endpat.item).to_integer_32 = 125 then
									l_brace_level := l_brace_level - 1
								end
								l_endpat.ce_gets (l_endpat + 1)
							end
						end
						js.reset
						if (l_pat.c_pointer.to_integer_32).to_natural_32 = (l_endpat.c_pointer.to_integer_32).to_natural_32 then
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 25 -- skip if block
						end
				when 3 then -- if:
						l_patlen := l_endpat.distance (l_pat)
						l_is_buflocal := 0
						l_buflocal_nr := 0
						if not (l_patlen >= 7) then
							l_pos := -1 + 15 -- skip if block
						end
				when 4 then -- if:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_pat), ce_string ("<buffer"), (7).to_natural_32)) /= 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 5 then -- if:
						if (l_pat[(l_patlen - 1)]).to_integer_32 /= 62 then
							l_pos := -1 + 15 -- skip if block
						end
				when 6 then -- if:
						l_is_buflocal := 1
						if l_patlen /= 8 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_buflocal_nr := globals_inst.curbuf.item.b_fnum
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 9 then -- else:
						if not (l_patlen > 9) then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if:
						if (l_pat[7]).to_integer_32 /= 61 then
							l_pos := -1 + 15 -- skip if block
						end
				when 11 then -- if:
						if l_patlen /= 13 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_pat), ce_string ("<buffer=abuf>"), (13).to_natural_32)).to_boolean then
							l_buflocal_nr := globals_inst.autocmd_bufnr
						else
							l_pos := -1 + 14 -- goto _L
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else: | _L:
						if ((charset_inst.skipdigits (l_pat + 8)).c_pointer.to_integer_32).to_natural_32 = (((l_pat + l_patlen) - 1).c_pointer.to_integer_32).to_natural_32 then
							l_buflocal_nr := atoi ((create {CE_POINTER [INTEGER_8]}.make_cast (l_pat) + 8))
						end
				when 15 then -- if done | if done | if done | if done | if done | if done
						if l_is_buflocal.to_boolean then
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buflocal_pat), ce_string ("<buffer=%%d>"), l_buflocal_nr]).do_nothing
							l_pat.ce_gets (l_buflocal_pat)
							l_patlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_buflocal_pat))).to_integer_32
						end
						l_prev_ap.ce_gets (first_autopat + a_event)
				when 16 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 24 -- skip loop
						end
				when 17 then -- loop body:
						js.reset
						l_ap___0.ce_gets (l_prev_ap.item)
						if (l_ap___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						end
						if not (not js.loop_jumped and then (((l_ap___0.item.pat).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32)) then
							l_pos := -1 + 23 -- skip if block
						end
				when 18 then -- if:
						if not (l_allgroups.to_boolean) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 22 -- goto _L___0
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 21 then -- else:
						if l_ap___0.item.group /= l_findgroup then
							l_pos := -1 + 23 -- skip if block
						end
				when 22 then -- if: | _L___0:
						if l_ap___0.item.patlen = l_patlen then
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_pat), create {CE_POINTER [INTEGER_8]}.make_cast (l_ap___0.item.pat), l_patlen.to_natural_32)) = 0 then
								if a_forceit.to_boolean then
									if (a_cmd.item).to_integer_32 /= 0 then
										if ((l_ap___0.item.next).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
											au_remove_cmds (l_ap___0)
											js.break
										end
									end
									if not js.loop_jumped then
										au_remove_pat (l_ap___0)
									end
								elseif (a_cmd.item).to_integer_32 = 0 then
									show_autocmd (l_ap___0, a_event)
								elseif ((l_ap___0.item.next).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									js.break
								end
							end
						end
				when 23 then -- if done | if done
						if not js.loop_jumped then
							l_prev_ap.ce_gets (create {CE_POINTER [CE_POINTER [PD_AUTOPAT]]}.make_shared (l_ap___0.c_pointer + {PD_AUTOPAT}.next_offset))
						end
						l_pos := -1 + 16 -- back to loop condition
				when 24 then -- loop done
						js.reset
						if (a_cmd.item).to_integer_32 /= 0 then
							if (l_ap___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								if l_is_buflocal.to_boolean then
									if l_buflocal_nr = 0 then
										l_tmp___5.ce_gets (gettext (ce_string ("E680: <buffer=%%d>: invalid buffer number ")))
										misc2_inst.emsgn (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___5), l_buflocal_nr.to_integer_32).do_nothing
										Result := 0
										js.return
									elseif ((buffer_inst.buflist_findnr (l_buflocal_nr)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										l_tmp___5.ce_gets (gettext (ce_string ("E680: <buffer=%%d>: invalid buffer number ")))
										misc2_inst.emsgn (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___5), l_buflocal_nr.to_integer_32).do_nothing
										Result := 0
										js.return
									end
								end
								if not js.return_called then
									l_ap___0.ce_gets (create {CE_POINTER [PD_AUTOPAT]}.make_cast ((misc2_inst.alloc ({PD_AUTOPAT}.sizeof.to_natural_32))))
									if (l_ap___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										Result := 0
										js.return
									end
								end
								if not js.return_called then
									l_ap___0.item.pat := misc2_inst.vim_strnsave (l_pat, l_patlen)
									l_ap___0.item.patlen := l_patlen
									if ((l_ap___0.item.pat).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ap___0))
										Result := 0
										js.return
									end
								end
								if not js.return_called then
									if l_is_buflocal.to_boolean then
										l_ap___0.item.buflocal_nr := l_buflocal_nr
										l_ap___0.item.reg_prog := create {CE_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
									else
										l_ap___0.item.buflocal_nr := 0
										l_reg_pat.ce_gets (file_pat_to_reg_pat (l_pat, l_endpat, create {CE_POINTER [INTEGER_8]}.make_shared (l_ap___0.c_pointer + {PD_AUTOPAT}.allow_dirs_offset), 1))
										if (l_reg_pat.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
											l_ap___0.item.reg_prog := regexp_inst.vim_regcomp (l_reg_pat, 1)
										end
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_reg_pat))
										if (l_reg_pat.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
											misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ap___0.item.pat))
											misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ap___0))
											Result := 0
											js.return
										elseif ((l_ap___0.item.reg_prog).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
											misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ap___0.item.pat))
											misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ap___0))
											Result := 0
											js.return
										end
									end
								end
								if not js.return_called then
									l_ap___0.item.cmds := create {CE_POINTER [PD_AUTOCMD]}.make_shared (default_pointer)
									l_prev_ap.item := l_ap___0
									l_ap___0.item.next := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
									if a_group = -3 then
										l_ap___0.item.group := current_augroup
									else
										l_ap___0.item.group := a_group
									end
								end
							end
							if not js.return_called then
								l_prev_ac.ce_gets (create {CE_POINTER [CE_POINTER [PD_AUTOCMD]]}.make_shared (l_ap___0.c_pointer + {PD_AUTOPAT}.cmds_offset))
								from
								until
									js.loop_left
								loop
									js.reset
									l_ac.ce_gets (l_prev_ac.item)
									if (l_ac.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										js.break
									end
									if not js.loop_jumped then
										l_prev_ac.ce_gets (create {CE_POINTER [CE_POINTER [PD_AUTOCMD]]}.make_shared (l_ac.c_pointer + {PD_AUTOCMD}.next_offset))
									end
								end
								js.reset
								l_ac.ce_gets (create {CE_POINTER [PD_AUTOCMD]}.make_cast ((misc2_inst.alloc ({PD_AUTOCMD}.sizeof.to_natural_32))))
								if (l_ac.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									Result := 0
									js.return
								end
							end
							if not js.return_called then
								l_ac.item.cmd := misc2_inst.vim_strsave (a_cmd)
								l_ac.item.scriptID := globals_inst.current_SID
								if ((l_ac.item.cmd).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ac))
									Result := 0
									js.return
								end
							end
							if not js.return_called then
								l_ac.item.next := create {CE_POINTER [PD_AUTOCMD]}.make_shared (default_pointer)
								l_prev_ac.item := l_ac
								l_ac.item.nested := a_nested___0.to_integer_8
							end
						end
				when 25 then -- if done
						if not js.loop_left then
							if (l_endpat.item).to_integer_32 = 44 then
								l_pat.ce_gets (l_endpat + 1)
							else
								l_pat.ce_gets (l_endpat)
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 26 then -- loop done
					if not js.return_called then
						au_cleanup
						Result := 1
					end
				when 27 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_doautocmd (a_arg: CE_POINTER [NATURAL_8]; a_do_msg: INTEGER_32): INTEGER_32
		local
			l_arg: CE_POINTER [NATURAL_8]
			l_fname: CE_POINTER [NATURAL_8]
			l_nothing_done: INTEGER_32
			l_group: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
		do
			create l_arg.make
			create l_fname.make

			l_arg.ce_gets (a_arg)
			l_nothing_done := 1
			l_group := au_get_grouparg (l_arg.address)
			if (l_arg.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 0
				js.return
			end
			if not js.return_called and then ((l_arg.item).to_integer_32 = 42) then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E217: Can%'t execute autocommands for ALL events"))))).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				l_fname.ce_gets (find_end_event (l_arg, (l_group /= -3).to_integer))
				if (l_fname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_fname.ce_gets (charset_inst.skipwhite (l_fname))
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_arg.item).to_boolean then
						if (l_arg.item).to_integer_32 = 32 then
							js.break
						elseif (l_arg.item).to_integer_32 = 9 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						if (apply_autocmds_group ((event_name2nr (l_arg, l_arg.address)), l_fname, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 1, l_group, globals_inst.curbuf, create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer))).to_boolean then
							l_nothing_done := 0
						end
					end
				end
				js.reset
				if l_nothing_done.to_boolean then
					if a_do_msg.to_boolean then
						message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("No matching autocommands"))))).do_nothing
					end
				end
				if (ex_eval_inst.aborting).to_boolean then
					l_tmp___4 := 0
				else
					l_tmp___4 := 1
				end
				Result := l_tmp___4
			end
		end

	ex_doautoall (a_eap: CE_POINTER [PD_EXARG])
		local
			l_retval: INTEGER_32
			l_aco: PD_ACO_SAVE_T
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_aco.make
			create l_buf___6.make

			l_buf___6.ce_gets (globals_inst.firstbuf)
			from
			until
				not (not js.loop_left and then ((l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				js.reset
				if ((l_buf___6.item.b_ml.ml_mfp).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					aucmd_prepbuf (l_aco.address, l_buf___6)
					l_retval := do_doautocmd (a_eap.item.arg, 0)
					if (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 = (globals_inst.aucmd_win.c_pointer.to_integer_32).to_natural_32 then
						l_tmp := 32
					else
						l_tmp := 0
					end
					buffer_inst.do_modelines (l_tmp)
					aucmd_restbuf (l_aco.address)
					if l_retval = 0 then
						js.break
					elseif not (buffer_inst.buf_valid (l_buf___6)).to_boolean then
						js.break
					end
				end
				if not js.loop_jumped then
					l_buf___6.ce_gets (l_buf___6.item.b_next)
				end
			end
			js.reset
			misc2_inst.check_cursor
		end

	ex_doautoall_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_doautoall)
		end

	aucmd_prepbuf (a_aco: CE_POINTER [PD_ACO_SAVE_T]; a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		local
			l_win: CE_POINTER [PD_WINDOW_S]
			l_save_ea: INTEGER_32
			js: JUMP_STATE
		do
			create l_win.make

			if (a_buf___6.c_pointer.to_integer_32).to_natural_32 = (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 then
				l_win.ce_gets (globals_inst.curwin)
			else
				l_win.ce_gets (globals_inst.firstwin)
				from
				until
					not (not js.loop_left and then ((l_win.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
				loop
					js.reset
					if ((l_win.item.w_buffer).c_pointer.to_integer_32).to_natural_32 = (a_buf___6.c_pointer.to_integer_32).to_natural_32 then
						js.break
					end
					if not js.loop_jumped then
						l_win.ce_gets (l_win.item.w_next)
					end
				end
				js.reset
			end
			if (l_win.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				if (globals_inst.aucmd_win.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					window_inst.win_alloc_aucmd_win
					if (globals_inst.aucmd_win.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_win.ce_gets (globals_inst.curwin)
					end
				end
			end
			if (l_win.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				if globals_inst.aucmd_win_used.to_boolean then
					l_win.ce_gets (globals_inst.curwin)
				end
			end
			a_aco.item.save_curwin := globals_inst.curwin
			a_aco.item.save_curbuf := globals_inst.curbuf
			if (l_win.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				a_aco.item.use_aucmd_win := 0
				globals_inst.curwin.ce_gets (l_win)
			else
				a_aco.item.use_aucmd_win := 1
				globals_inst.aucmd_win_used := 1
				globals_inst.aucmd_win.item.w_buffer := a_buf___6
				globals_inst.aucmd_win.item.w_s := create {CE_POINTER [PD_SYNBLOCK_T]}.make_shared (a_buf___6.c_pointer + {PD_FILE_BUFFER}.b_s_offset)
				a_buf___6.item.b_nwindows := (a_buf___6.item.b_nwindows) + 1
				window_inst.win_init_empty (globals_inst.aucmd_win)
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.aucmd_win.item.w_localdir))
				globals_inst.aucmd_win.item.w_localdir := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				globals_inst.aucmd_win.item.w_localdir := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				a_aco.item.globaldir := globals_inst.globaldir
				globals_inst.globaldir.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				block_autocmds
				window_inst.make_snapshot (1)
				l_save_ea := option_inst.p_ea
				option_inst.p_ea := 0
				window_inst.win_split_ins (0, 4, globals_inst.aucmd_win, 0).do_nothing
				window_inst.win_comp_pos.do_nothing
				option_inst.p_ea := l_save_ea
				unblock_autocmds
				globals_inst.curwin.ce_gets (globals_inst.aucmd_win)
			end
			globals_inst.curbuf.ce_gets (a_buf___6)
			a_aco.item.new_curwin := globals_inst.curwin
			a_aco.item.new_curbuf := globals_inst.curbuf
		end

	aucmd_restbuf (a_aco: CE_POINTER [PD_ACO_SAVE_T])
		local
			l_dummy___0: INTEGER_32
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			js: JUMP_STATE
		do
			create l_tp.make
			create l_wp___0.make

			if (a_aco.item.use_aucmd_win).to_boolean then
				globals_inst.curbuf.item.b_nwindows := (globals_inst.curbuf.item.b_nwindows) - 1
				block_autocmds
				if (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 /= (globals_inst.aucmd_win.c_pointer.to_integer_32).to_natural_32 then
					l_tp.ce_gets (globals_inst.first_tabpage)
					from
					until
						not (not js.loop_left and then ((l_tp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
					loop
						if (l_tp.c_pointer.to_integer_32).to_natural_32 = (globals_inst.curtab.c_pointer.to_integer_32).to_natural_32 then
							l_wp___0.ce_gets (globals_inst.firstwin)
						else
							l_wp___0.ce_gets (l_tp.item.tp_firstwin)
						end
						from
						until
							not (not js.loop_left and then ((l_wp___0).c_pointer /= default_pointer))
						loop
							js.reset
							if (l_wp___0.c_pointer.to_integer_32).to_natural_32 = (globals_inst.aucmd_win.c_pointer.to_integer_32).to_natural_32 then
								if (l_tp.c_pointer.to_integer_32).to_natural_32 /= (globals_inst.curtab.c_pointer.to_integer_32).to_natural_32 then
									window_inst.goto_tabpage_tp (l_tp)
								end
								window_inst.win_goto (globals_inst.aucmd_win)
								js.break
							end
							if not js.loop_jumped then
								l_wp___0.ce_gets (l_wp___0.item.w_next)
							end
						end
						js.reset
						l_tp.ce_gets (l_tp.item.tp_next)
					end
				end
				window_inst.winframe_remove (globals_inst.curwin, create {CE_POINTER [INTEGER_32]}.make_shared ($l_dummy___0), create {CE_POINTER [PD_TABPAGE_S]}.make_shared (default_pointer)).do_nothing
				window_inst.win_remove (globals_inst.curwin, create {CE_POINTER [PD_TABPAGE_S]}.make_shared (default_pointer))
				globals_inst.aucmd_win_used := 0
				window_inst.last_status (0)
				window_inst.restore_snapshot (1, 0)
				window_inst.win_comp_pos.do_nothing
				unblock_autocmds
				if (window_inst.win_valid (a_aco.item.save_curwin)).to_boolean then
					globals_inst.curwin.ce_gets (a_aco.item.save_curwin)
				else
					globals_inst.curwin.ce_gets (globals_inst.firstwin)
				end
				eval_inst.vars_clear (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (globals_inst.aucmd_win.c_pointer + {PD_WINDOW_S}.w_vars_offset + {PD_DICTVAR_S}.dv_hashtab_offset))
				hashtab_inst.hash_init (create {CE_POINTER [PD_HASHTABLE_S]}.make_shared (globals_inst.aucmd_win.c_pointer + {PD_WINDOW_S}.w_vars_offset + {PD_DICTVAR_S}.dv_hashtab_offset))
				globals_inst.curbuf.ce_gets (globals_inst.curwin.item.w_buffer)
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.globaldir))
				globals_inst.globaldir.ce_gets (a_aco.item.globaldir)
				misc2_inst.check_cursor
				if globals_inst.curwin.item.w_topline > globals_inst.curbuf.item.b_ml.ml_line_count then
					globals_inst.curwin.item.w_topline := globals_inst.curbuf.item.b_ml.ml_line_count
					globals_inst.curwin.item.w_topfill := 0
				end
				gui_gtk_x11_inst.gui_mch_enable_scrollbar (globals_inst.aucmd_win.item.w_scrollbars + 0, 0)
				gui_gtk_x11_inst.gui_mch_enable_scrollbar (globals_inst.aucmd_win.item.w_scrollbars + 1, 0)
				gui_inst.gui_may_update_scrollbars
			elseif (window_inst.win_valid (a_aco.item.save_curwin)).to_boolean then
				if (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 = ((a_aco.item.new_curwin).c_pointer.to_integer_32).to_natural_32 then
					if (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 /= ((a_aco.item.new_curbuf).c_pointer.to_integer_32).to_natural_32 then
						if (buffer_inst.buf_valid (a_aco.item.new_curbuf)).to_boolean then
							if (((a_aco.item.new_curbuf).item.b_ml.ml_mfp).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								globals_inst.curbuf.item.b_nwindows := (globals_inst.curbuf.item.b_nwindows) - 1
								globals_inst.curbuf.ce_gets (a_aco.item.new_curbuf)
								globals_inst.curwin.item.w_buffer := globals_inst.curbuf
								globals_inst.curbuf.item.b_nwindows := (globals_inst.curbuf.item.b_nwindows) + 1
							end
						end
					end
				end
				globals_inst.curwin.ce_gets (a_aco.item.save_curwin)
				globals_inst.curbuf.ce_gets (globals_inst.curwin.item.w_buffer)
			end
		end

	apply_autocmds (a_event: INTEGER_32; a_fname: CE_POINTER [NATURAL_8]; a_fname_io: CE_POINTER [NATURAL_8]; a_force: INTEGER_32; a_buf___6: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		do
			Result := (apply_autocmds_group (a_event, a_fname, a_fname_io, a_force, -3, a_buf___6, create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer)))
		end

	apply_autocmds_exarg (a_event: INTEGER_32; a_fname: CE_POINTER [NATURAL_8]; a_fname_io: CE_POINTER [NATURAL_8]; a_force: INTEGER_32; a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_eap: CE_POINTER [PD_EXARG]): INTEGER_32
		do
			Result := (apply_autocmds_group (a_event, a_fname, a_fname_io, a_force, -3, a_buf___6, a_eap))
		end

	apply_autocmds_retval (a_event: INTEGER_32; a_fname: CE_POINTER [NATURAL_8]; a_fname_io: CE_POINTER [NATURAL_8]; a_force: INTEGER_32; a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_retval: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_did_cmd: INTEGER_32
			js: JUMP_STATE
		do
			if (ex_eval_inst.should_abort (a_retval.item)).to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_did_cmd := apply_autocmds_group (a_event, a_fname, a_fname_io, a_force, -3, a_buf___6, create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer))
				if l_did_cmd.to_boolean then
					if (ex_eval_inst.aborting).to_boolean then
						a_retval.item := 0
					end
				end
				Result := l_did_cmd
			end
		end

	has_cursorhold: INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (misc2_inst.get_real_state) = 257 then
				l_tmp___0 := 63
			else
				l_tmp___0 := 64
			end
			Result := (((first_autopat[l_tmp___0]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
		end

	trigger_cursorhold: INTEGER_32
		local
			l_state: INTEGER_32
			js: JUMP_STATE
		do
			if not globals_inst.did_cursorhold.to_boolean then
				if (has_cursorhold).to_boolean then
					if not globals_inst.Recording.to_boolean then
						if not (edit_inst.ins_compl_active).to_boolean then
							l_state := misc2_inst.get_real_state
							if l_state = 257 then
								Result := 1
								js.return
							elseif ((l_state).bit_and (16)) /= 0 then
								Result := 1
								js.return
							end
						end
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	has_cursormoved: INTEGER_32
		do
			Result := (((first_autopat[71]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
		end

	has_cursormovedI: INTEGER_32
		do
			Result := (((first_autopat[72]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
		end

	apply_autocmds_group (a_event: INTEGER_32; a_fname: CE_POINTER [NATURAL_8]; a_fname_io: CE_POINTER [NATURAL_8]; a_force: INTEGER_32; a_group: INTEGER_32; a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_eap: CE_POINTER [PD_EXARG]): INTEGER_32
		local
			l_fname: CE_POINTER [NATURAL_8]
			l_sfname: CE_POINTER [NATURAL_8]
			l_tail: CE_POINTER [NATURAL_8]
			l_save_changed: INTEGER_32
			l_old_curbuf: CE_POINTER [PD_FILE_BUFFER]
			l_retval: INTEGER_32
			l_save_sourcing_name: CE_POINTER [NATURAL_8]
			l_save_sourcing_lnum: INTEGER_32
			l_save_autocmd_fname: CE_POINTER [NATURAL_8]
			l_save_autocmd_fname_full: INTEGER_32
			l_save_autocmd_bufnr: INTEGER_32
			l_save_autocmd_match: CE_POINTER [NATURAL_8]
			l_save_autocmd_busy: INTEGER_32
			l_save_autocmd_nested: INTEGER_32
			l_patcmd: PD_AUTOPATCMD
			l_ap___0: CE_POINTER [PD_AUTOPAT]
			l_save_current_SID: INTEGER_32
			l_save_funccalp: CE_POINTER [ANY]
			l_save_cmdarg: CE_POINTER [NATURAL_8]
			l_save_cmdbang: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_fname.make
			create l_sfname.make
			create l_tail.make
			create l_old_curbuf.make
			create l_save_sourcing_name.make
			create l_save_autocmd_fname.make
			create l_save_autocmd_match.make
			create l_patcmd.make
			create l_ap___0.make
			create l_save_funccalp.make
			create l_save_cmdarg.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fname.ce_gets (a_fname)
					l_sfname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_retval := 0
					if ((first_autopat[a_event]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_pos := -1 + 41 -- goto BYPASS_AU
					elseif autocmd_blocked > 0 then
						l_pos := -1 + 41 -- goto BYPASS_AU
					end
				when 1 then
					if globals_inst.autocmd_busy.to_boolean then
						if not a_force.to_boolean then
							if not autocmd_nested.to_boolean then
								l_pos := -1 + 41 -- goto BYPASS_AU
							end
						end
					end
				when 2 then
					if (ex_eval_inst.aborting).to_boolean then
						l_pos := -1 + 41 -- goto BYPASS_AU
					end
				when 3 then
					if filechangeshell_busy.to_boolean then
						if a_event.to_natural_32 = {NATURAL_32} 25 then
							l_pos := -1 + 41 -- goto BYPASS_AU
						elseif a_event.to_natural_32 = {NATURAL_32} 26 then
							l_pos := -1 + 41 -- goto BYPASS_AU
						end
					end
				when 4 then
					if (event_ignored (a_event)).to_boolean then
						l_pos := -1 + 41 -- goto BYPASS_AU
					end
				when 5 then
					if nesting = 10 then
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E218: autocommand nesting too deep"))))).do_nothing
						l_pos := -1 + 41 -- goto BYPASS_AU
					end
				when 6 then
					if not (globals_inst.autocmd_no_enter.to_boolean) then
						l_pos := -1 + 9 -- skip if block
					end
				when 7 then -- if:
						if a_event.to_natural_32 = {NATURAL_32} 60 then
							l_pos := -1 + 41 -- goto BYPASS_AU
						elseif a_event.to_natural_32 = {NATURAL_32} 4 then
							l_pos := -1 + 41 -- goto BYPASS_AU
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if globals_inst.autocmd_no_leave.to_boolean then
							if a_event.to_natural_32 = {NATURAL_32} 61 then
								l_pos := -1 + 41 -- goto BYPASS_AU
							elseif a_event.to_natural_32 = {NATURAL_32} 7 then
								l_pos := -1 + 41 -- goto BYPASS_AU
							end
						end
				when 10 then
					l_save_autocmd_fname.ce_gets (globals_inst.autocmd_fname)
					l_save_autocmd_fname_full := globals_inst.autocmd_fname_full
					l_save_autocmd_bufnr := globals_inst.autocmd_bufnr
					l_save_autocmd_match.ce_gets (globals_inst.autocmd_match)
					l_save_autocmd_busy := globals_inst.autocmd_busy
					l_save_autocmd_nested := autocmd_nested
					l_save_changed := globals_inst.curbuf.item.b_changed
					l_old_curbuf.ce_gets (globals_inst.curbuf)
					if (a_fname_io.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_pos := -1 + 16 -- skip if block
					end
				when 11 then -- if:
						if (l_fname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if (l_fname.item).to_integer_32 /= 0 then
							globals_inst.autocmd_fname.ce_gets (l_fname)
						else
							l_pos := -1 + 14 -- goto _L___0
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else: | _L___0:
						if (a_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							globals_inst.autocmd_fname.ce_gets (a_buf___6.item.b_ffname)
						else
							globals_inst.autocmd_fname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						end
				when 15 then -- if done | if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						globals_inst.autocmd_fname.ce_gets (a_fname_io)
				when 17 then
					if (globals_inst.autocmd_fname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						globals_inst.autocmd_fname.ce_gets (misc2_inst.vim_strsave (globals_inst.autocmd_fname))
					end
					globals_inst.autocmd_fname_full := 0
					if (a_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						globals_inst.autocmd_bufnr := 0
					else
						globals_inst.autocmd_bufnr := a_buf___6.item.b_fnum
					end
					if (l_fname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_pos := -1 + 20 -- skip if block
					end
				when 18 then -- if:
						l_pos := -1 + 21 -- goto _L___1
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 20 then -- else:
						if (l_fname.item).to_integer_32 /= 0 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if: | _L___1:
						if (a_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_fname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						elseif a_event.to_natural_32 = {NATURAL_32} 52 then
							l_fname.ce_gets (a_buf___6.item.b_p_syn)
						elseif a_event.to_natural_32 = {NATURAL_32} 31 then
							l_fname.ce_gets (a_buf___6.item.b_p_ft)
						else
							if ((a_buf___6.item.b_sfname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_sfname.ce_gets (misc2_inst.vim_strsave (a_buf___6.item.b_sfname))
							end
							l_fname.ce_gets (a_buf___6.item.b_ffname)
						end
						if (l_fname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_fname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
						end
						l_fname.ce_gets (misc2_inst.vim_strsave (l_fname))
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else:
						l_sfname.ce_gets (misc2_inst.vim_strsave (l_fname))
						if a_event.to_natural_32 = {NATURAL_32} 31 then
							l_fname.ce_gets (misc2_inst.vim_strsave (l_fname))
						elseif a_event.to_natural_32 = {NATURAL_32} 52 then
							l_fname.ce_gets (misc2_inst.vim_strsave (l_fname))
						elseif a_event.to_natural_32 = {NATURAL_32} 65 then
							l_fname.ce_gets (misc2_inst.vim_strsave (l_fname))
						elseif a_event.to_natural_32 = {NATURAL_32} 66 then
							l_fname.ce_gets (misc2_inst.vim_strsave (l_fname))
						elseif a_event.to_natural_32 = {NATURAL_32} 70 then
							l_fname.ce_gets (misc2_inst.vim_strsave (l_fname))
						elseif a_event.to_natural_32 = {NATURAL_32} 48 then
							l_fname.ce_gets (misc2_inst.vim_strsave (l_fname))
						elseif a_event.to_natural_32 = {NATURAL_32} 47 then
							l_fname.ce_gets (misc2_inst.vim_strsave (l_fname))
						else
							l_fname.ce_gets (misc1_inst.FullName_save (l_fname, 0))
						end
				when 24 then -- if done
						if (l_fname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_sfname))
							l_retval := 0
							l_pos := -1 + 41 -- goto BYPASS_AU
						end
				when 25 then
						globals_inst.autocmd_match.ce_gets (l_fname)
						globals_inst.RedrawingDisabled := globals_inst.RedrawingDisabled + 1
						l_save_sourcing_name.ce_gets (globals_inst.sourcing_name)
						globals_inst.sourcing_name.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						l_save_sourcing_lnum := globals_inst.sourcing_lnum
						globals_inst.sourcing_lnum := (0).to_integer_32
						l_save_current_SID := globals_inst.current_SID
						l_save_funccalp.ce_gets (eval_inst.save_funccal)
						if not globals_inst.autocmd_busy.to_boolean then
							search_inst.save_search_patterns
							getchar_inst.saveRedobuff
							globals_inst.did_filetype := globals_inst.keep_filetype
						end
						globals_inst.autocmd_busy := 1
						filechangeshell_busy := (a_event.to_natural_32 = {NATURAL_32} 25).to_integer
						nesting := nesting + 1
						if a_event.to_natural_32 = {NATURAL_32} 31 then
							globals_inst.did_filetype := 1
						end
						l_tail.ce_gets (misc1_inst.gettail (l_fname))
						l_patcmd.curpat := first_autopat[a_event]
						l_patcmd.nextcmd := create {CE_POINTER [PD_AUTOCMD]}.make_shared (default_pointer)
						l_patcmd.group := a_group
						l_patcmd.fname := l_fname
						l_patcmd.sfname := l_sfname
						l_patcmd.tail := l_tail
						l_patcmd.event := a_event
						l_patcmd.arg_bufnr := globals_inst.autocmd_bufnr
						l_patcmd.next := create {CE_POINTER [PD_AUTOPATCMD]}.make_shared (default_pointer)
						auto_next_pat (l_patcmd.address, 0)
						if ((l_patcmd.curpat).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_patcmd.next := active_apc_list
							active_apc_list.ce_gets (l_patcmd.address)
							l_save_cmdbang := eval_inst.get_vim_var_nr (32)
							if (a_eap.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_save_cmdarg.ce_gets (eval_inst.set_cmdarg (a_eap, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)))
								eval_inst.set_vim_var_nr (32, (a_eap.item.forceit).to_integer_32)
							else
								l_save_cmdarg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							end
							l_retval := 1
							l_ap___0.ce_gets (l_patcmd.curpat)
							from
							until
								((l_ap___0.item.next).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
							loop
								l_ap___0.item.last := (0).to_integer_8
								l_ap___0.ce_gets (l_ap___0.item.next)
							end
							l_ap___0.item.last := (1).to_integer_8
							window_inst.check_lnums (1)
							ex_docmd_inst.do_cmdline (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), getnextac_address, create {CE_POINTER [ANY]}.make_cast ((l_patcmd.address)), 7).do_nothing
							if (a_eap.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								eval_inst.set_cmdarg (create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer), l_save_cmdarg).do_nothing
								eval_inst.set_vim_var_nr (32, l_save_cmdbang)
							end
							if (active_apc_list.c_pointer.to_integer_32).to_natural_32 = ((l_patcmd.address).c_pointer.to_integer_32).to_natural_32 then
								active_apc_list.ce_gets (l_patcmd.next)
							end
						end
						globals_inst.RedrawingDisabled := globals_inst.RedrawingDisabled - 1
						globals_inst.autocmd_busy := l_save_autocmd_busy
						filechangeshell_busy := 0
						autocmd_nested := l_save_autocmd_nested
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.sourcing_name))
						globals_inst.sourcing_name.ce_gets (l_save_sourcing_name)
						globals_inst.sourcing_lnum := l_save_sourcing_lnum
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.autocmd_fname))
						globals_inst.autocmd_fname.ce_gets (l_save_autocmd_fname)
						globals_inst.autocmd_fname_full := l_save_autocmd_fname_full
						globals_inst.autocmd_bufnr := l_save_autocmd_bufnr
						globals_inst.autocmd_match.ce_gets (l_save_autocmd_match)
						globals_inst.current_SID := l_save_current_SID
						eval_inst.restore_funccal (l_save_funccalp)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fname))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_sfname))
						nesting := nesting - 1
						if not globals_inst.autocmd_busy.to_boolean then
							search_inst.restore_search_patterns
							getchar_inst.restoreRedobuff
							globals_inst.did_filetype := 0
						end
						if (globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 /= (l_old_curbuf.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 40 -- skip if block
						end
				when 26 then -- if:
							if a_event.to_natural_32 /= {NATURAL_32} 9 then
								l_pos := -1 + 29 -- skip if block
							end
				when 27 then -- if:
							l_pos := -1 + 39 -- goto _L___2
				when 28 then -- if block done, skip else block:
							l_pos := -1 + 40
				when 29 then -- else:
							if a_event.to_natural_32 /= {NATURAL_32} 16 then
								l_pos := -1 + 32 -- skip if block
							end
				when 30 then -- if:
							l_pos := -1 + 39 -- goto _L___2
				when 31 then -- if block done, skip else block:
							l_pos := -1 + 40
				when 32 then -- else:
							if a_event.to_natural_32 /= {NATURAL_32} 22 then
								l_pos := -1 + 35 -- skip if block
							end
				when 33 then -- if:
							l_pos := -1 + 39 -- goto _L___2
				when 34 then -- if block done, skip else block:
							l_pos := -1 + 40
				when 35 then -- else:
							if a_event.to_natural_32 /= {NATURAL_32} 57 then
								l_pos := -1 + 38 -- skip if block
							end
				when 36 then -- if:
							l_pos := -1 + 39 -- goto _L___2
				when 37 then -- if block done, skip else block:
							l_pos := -1 + 40
				when 38 then -- else:
							if a_event.to_natural_32 /= {NATURAL_32} 58 then
								l_pos := -1 + 40 -- skip if block
							end
				when 39 then -- if: | _L___2:
							if globals_inst.curbuf.item.b_changed /= l_save_changed then
								globals_inst.need_maketitle := 1
							end
							globals_inst.curbuf.item.b_changed := l_save_changed
				when 40 then -- if done | if done | if done | if done | if done
							au_cleanup
				when 41 then -- BYPASS_AU:
							if a_event.to_natural_32 = {NATURAL_32} 3 then
								if (a_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									aubuflocal_remove (a_buf___6)
								end
							end
							Result := l_retval
				when 42 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	block_autocmds
		do
			if autocmd_blocked = 0 then
				old_termresponse.ce_gets (eval_inst.get_vim_var_str (10))
			end
			autocmd_blocked := autocmd_blocked + 1
		end

	unblock_autocmds
		do
			autocmd_blocked := autocmd_blocked - 1
			if autocmd_blocked = 0 then
				if ((eval_inst.get_vim_var_str (10)).c_pointer.to_integer_32).to_natural_32 /= (old_termresponse.c_pointer.to_integer_32).to_natural_32 then
					apply_autocmds ({PC_AUTO_EVENT}.EVENT_TERMRESPONSE, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
				end
			end
		end

	auto_next_pat (a_apc: CE_POINTER [PD_AUTOPATCMD]; a_stop_at_last: INTEGER_32)
		local
			l_ap___0: CE_POINTER [PD_AUTOPAT]
			l_cp: CE_POINTER [PD_AUTOCMD]
			l_name___1: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [INTEGER_8]
			l_tmp: NATURAL_32
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ap___0.make
			create l_cp.make
			create l_name___1.make
			create l_s.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.sourcing_name))
					globals_inst.sourcing_name.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_ap___0.ce_gets (a_apc.item.curpat)
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 11 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if (l_ap___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if globals_inst.got_int.to_boolean then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if:
						a_apc.item.curpat := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
						if ((l_ap___0.item.pat).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						if ((l_ap___0.item.cmds).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if a_apc.item.group /= -3 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if a_apc.item.group /= l_ap___0.item.group then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if l_ap___0.item.buflocal_nr = 0 then
							l_tmp___3 := (match_file_pat (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_ap___0.item.reg_prog, a_apc.item.fname, a_apc.item.sfname, a_apc.item.tail, (l_ap___0.item.allow_dirs).to_integer_32))
						else
							l_tmp___3 := (l_ap___0.item.buflocal_nr = a_apc.item.arg_bufnr).to_integer
						end
						if l_tmp___3.to_boolean then
							l_name___1.ce_gets (event_nr2name (a_apc.item.event))
							l_s.ce_gets (gettext (ce_string ("%%s Auto commands for %"%%s%"")))
							l_tmp := strlen (l_s)
							globals_inst.sourcing_name.ce_gets (misc2_inst.alloc (((l_tmp + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_name___1)))) + (l_ap___0.item.patlen).to_natural_32) + {NATURAL_32} 1))
							if (globals_inst.sourcing_name.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.sourcing_name), l_s, create {CE_POINTER [INTEGER_8]}.make_cast (l_name___1), create {CE_POINTER [INTEGER_8]}.make_cast (l_ap___0.item.pat)]).do_nothing
								if option_inst.p_verbose >= 8 then
									message_inst.verbose_enter
									message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Executing %%s")))), globals_inst.sourcing_name]).do_nothing
									message_inst.verbose_leave
								end
							end
							a_apc.item.curpat := l_ap___0
							a_apc.item.nextcmd := l_ap___0.item.cmds
							l_cp.ce_gets (l_ap___0.item.cmds)
							from
							until
								((l_cp.item.next).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
							loop
								l_cp.item.last := (0).to_integer_8
								l_cp.ce_gets (l_cp.item.next)
							end
							l_cp.item.last := (1).to_integer_8
						end
						misc1_inst.line_breakcheck
						if ((a_apc.item.curpat).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							js.break
						end
				when 10 then -- if done | if done | if done | if done
						if not js.loop_jumped and then (a_stop_at_last.to_boolean) then
							if (l_ap___0.item.last).to_boolean then
								js.break
							end
						end
						if not js.loop_jumped then
							l_ap___0.ce_gets (l_ap___0.item.next)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 11 then -- loop done
					js.reset
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	getnextac (a_c: INTEGER_32; a_cookie: CE_POINTER [ANY]; a_indent: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_acp: CE_POINTER [PD_AUTOPATCMD]
			l_retval: CE_POINTER [NATURAL_8]
			l_ac: CE_POINTER [PD_AUTOCMD]
			js: JUMP_STATE
		do
			create l_acp.make
			create l_retval.make
			create l_ac.make

			l_acp.ce_gets (create {CE_POINTER [PD_AUTOPATCMD]}.make_cast (a_cookie))
			if ((l_acp.item.curpat).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						if ((l_acp.item.nextcmd).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (((l_acp.item.nextcmd).item.cmd).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							if ((l_acp.item.nextcmd).item.last).to_boolean then
								l_acp.item.nextcmd := create {CE_POINTER [PD_AUTOCMD]}.make_shared (default_pointer)
							else
								l_acp.item.nextcmd := (l_acp.item.nextcmd).item.next
							end
						end
					end
					js.reset
					if ((l_acp.item.nextcmd).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						js.break
					end
					if not js.loop_jumped then
						if ((l_acp.item.curpat).item.last).to_boolean then
							l_acp.item.curpat := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
						else
							l_acp.item.curpat := (l_acp.item.curpat).item.next
						end
						if ((l_acp.item.curpat).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							auto_next_pat (l_acp, 1)
						end
						if ((l_acp.item.curpat).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
					end
				end
				js.reset
			end
			if not js.return_called then
				l_ac.ce_gets (l_acp.item.nextcmd)
				if option_inst.p_verbose >= 9 then
					message_inst.verbose_enter_scroll
					message_inst.smsg ([create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("autocommand %%s")))), l_ac.item.cmd]).do_nothing
					message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
					message_inst.verbose_leave_scroll
				end
				l_retval.ce_gets (misc2_inst.vim_strsave (l_ac.item.cmd))
				autocmd_nested := (l_ac.item.nested).to_integer_32
				globals_inst.current_SID := l_ac.item.scriptID
				if (l_ac.item.last).to_boolean then
					l_acp.item.nextcmd := create {CE_POINTER [PD_AUTOCMD]}.make_shared (default_pointer)
				else
					l_acp.item.nextcmd := l_ac.item.next
				end
				Result := l_retval
			end
		end

	getnextac_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent getnextac)
		end

	has_autocmd (a_event: INTEGER_32; a_sfname: CE_POINTER [NATURAL_8]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			l_ap___0: CE_POINTER [PD_AUTOPAT]
			l_fname: CE_POINTER [NATURAL_8]
			l_tail: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_ap___0.make
			create l_fname.make
			create l_tail.make

			l_tail.ce_gets ((misc1_inst.gettail (a_sfname)))
			l_retval := 0
			l_fname.ce_gets (misc1_inst.FullName_save (a_sfname, 0))
			if (l_fname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_ap___0.ce_gets (first_autopat[a_event])
				from
				until
					not (not js.loop_left and then ((l_ap___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
				loop
					js.reset
					if ((l_ap___0.item.pat).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						if ((l_ap___0.item.cmds).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if l_ap___0.item.buflocal_nr = 0 then
								l_tmp___2 := (match_file_pat (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), l_ap___0.item.reg_prog, l_fname, a_sfname, l_tail, (l_ap___0.item.allow_dirs).to_integer_32))
							else
								if (a_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if l_ap___0.item.buflocal_nr = a_buf___6.item.b_fnum then
										l_tmp___1 := 1
									else
										l_tmp___1 := 0
									end
								else
									l_tmp___1 := 0
								end
								l_tmp___2 := l_tmp___1
							end
							if l_tmp___2.to_boolean then
								l_retval := 1
								js.break
							end
						end
					end
					if not js.loop_jumped then
						l_ap___0.ce_gets (l_ap___0.item.next)
					end
				end
				js.reset
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fname))
				Result := l_retval
			end
		end

	get_augroup_name (a_xp: CE_POINTER [PD_EXPAND]; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			js: JUMP_STATE
		do
			if a_idx = augroups.ga_len then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("END")))
				js.return
			end
			if not js.return_called and then (a_idx >= augroups.ga_len) then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called and then (((create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (augroups.ga_data)[a_idx]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32) then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
				js.return
			end
			if not js.return_called then
				Result := (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (augroups.ga_data)[a_idx])
			end
		end

	get_augroup_name_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent get_augroup_name)
		end

	set_context_in_autocmd (a_xp: CE_POINTER [PD_EXPAND]; a_arg: CE_POINTER [NATURAL_8]; a_doautocmd: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_arg: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_group: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_arg.make
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_arg.ce_gets (a_arg)
					include_groups := 0
					l_p___0.ce_gets (l_arg)
					l_group := au_get_grouparg (l_arg.address)
					if l_group = -2 then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						if (l_arg.item).to_integer_32 = 0 then
							if l_group /= -3 then
								if (l_arg[-1]).to_integer_32 /= 32 then
									if (l_arg[-1]).to_integer_32 /= 9 then
										l_arg.ce_gets (l_p___0)
										l_group := -3
									end
								end
							end
						end
						l_p___0.ce_gets (l_arg)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_p___0.item).to_integer_32 /= 0 then
								if (l_p___0.item).to_integer_32 = 32 then
									js.break
								elseif (l_p___0.item).to_integer_32 = 9 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if (l_p___0.item).to_integer_32 = 44 then
									l_arg.ce_gets (l_p___0 + 1)
								end
								l_p___0.ce_gets (l_p___0 + 1)
							end
						end
						js.reset
						if (l_p___0.item).to_integer_32 = 0 then
							if l_group = -3 then
								include_groups := 1
							end
							a_xp.item.xp_context := 10
							a_xp.item.xp_pattern := l_arg
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						l_arg.ce_gets (charset_inst.skipwhite (l_p___0))
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 12 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if not ((l_arg.item).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						if (l_arg.item).to_integer_32 /= 32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if (l_arg.item).to_integer_32 /= 9 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if (l_arg[-1]).to_integer_32 /= 92 then
							js.break
						end
				when 9 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						js.break
				when 11 then
						if not js.loop_jumped then
							l_arg.ce_gets (l_arg + 1)
						end
						l_pos := -1 + 2 -- back to loop condition
				when 12 then -- loop done
						js.reset
						if (l_arg.item).to_boolean then
							Result := l_arg
							js.return
						end
				when 13 then -- if done
					if not js.return_called then
						if a_doautocmd.to_boolean then
							a_xp.item.xp_context := 2
						else
							a_xp.item.xp_context := 0
						end
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_event_name (a_xp: CE_POINTER [PD_EXPAND]; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			js: JUMP_STATE
		do
			if a_idx < augroups.ga_len then
				if not include_groups.to_boolean then
					Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
					js.return
				elseif ((create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (augroups.ga_data)[a_idx]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
					js.return
				end
				if not js.return_called then
					Result := (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast (augroups.ga_data)[a_idx])
					js.return
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (event_names[a_idx - augroups.ga_len].name))
			end
		end

	get_event_name_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent get_event_name)
		end

	autocmd_supported (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make

			Result := ((event_name2nr (a_name___1, l_p___0.address)).to_natural_32 /= {NATURAL_32} 77).to_integer
		end

	au_exists (a_arg: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_arg_save: CE_POINTER [NATURAL_8]
			l_pattern: CE_POINTER [NATURAL_8]
			l_event_name: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_event: INTEGER_32
			l_ap___0: CE_POINTER [PD_AUTOPAT]
			l_buflocal_buf: CE_POINTER [PD_FILE_BUFFER]
			l_group: INTEGER_32
			l_retval: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_arg_save.make
			create l_pattern.make
			create l_event_name.make
			create l_p___0.make
			create l_ap___0.make
			create l_buflocal_buf.make
			create l_tmp.make
			create l_tmp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pattern.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_buflocal_buf.ce_gets (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
					l_retval := 0
					l_arg_save.ce_gets (misc2_inst.vim_strsave (a_arg))
					if (l_arg_save.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 20 -- skip if block
					end
				when 1 then -- if:
						l_p___0.ce_gets (misc2_inst.vim_strchr (l_arg_save, ('#').code))
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_tmp.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp.item := (('%/0/').code).to_natural_8
						end
						l_group := au_find_group (l_arg_save)
						if l_group /= -2 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_group := -3
						l_event_name.ce_gets (l_arg_save)
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_retval := 1
							l_pos := -1 + 19 -- goto theend
						end
				when 5 then
						l_event_name.ce_gets (l_p___0)
						l_p___0.ce_gets (misc2_inst.vim_strchr (l_event_name, ('#').code))
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_tmp___0.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___0.item := (('%/0/').code).to_natural_8
						end
				when 6 then -- if done
						l_pattern.ce_gets (l_p___0)
						l_event := event_name2nr (l_event_name, l_p___0.address)
						if l_event.to_natural_32 = {NATURAL_32} 77 then
							l_pos := -1 + 19 -- goto theend
						end
				when 7 then
						l_ap___0.ce_gets (first_autopat[l_event])
						if (l_ap___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 19 -- goto theend
						end
				when 8 then
						if (l_pattern.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_pattern), ce_string ("<buffer>"))) = 0 then
								l_buflocal_buf.ce_gets (globals_inst.curbuf)
							end
						end
				when 9 then -- loop condition:
						if not (not js.loop_left and then ((l_ap___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32)) then
							l_pos := -1 + 18 -- skip loop
						end
				when 10 then -- loop body:
						js.reset
						if ((l_ap___0.item.pat).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 17 -- skip if block
						end
				when 11 then -- if:
						if ((l_ap___0.item.cmds).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 17 -- skip if block
						end
				when 12 then -- if:
						if l_group /= -3 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 15 then -- else:
						if l_ap___0.item.group /= l_group then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L:
						if (l_pattern.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_retval := 1
							js.break
						else
							if (l_buflocal_buf.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_tmp___3 := ((strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ap___0.item.pat), create {CE_POINTER [INTEGER_8]}.make_cast (l_pattern))) = 0).to_integer
							else
								l_tmp___3 := (l_ap___0.item.buflocal_nr = l_buflocal_buf.item.b_fnum).to_integer
							end
							if l_tmp___3.to_boolean then
								l_retval := 1
								js.break
							end
						end
				when 17 then -- if done | if done | if done
						if not js.loop_jumped then
							l_ap___0.ce_gets (l_ap___0.item.next)
						end
						l_pos := -1 + 9 -- back to loop condition
				when 18 then -- loop done
						js.reset
				when 19 then -- theend:
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_arg_save))
						Result := l_retval
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	match_file_pat (a_pattern: CE_POINTER [NATURAL_8]; a_prog: CE_POINTER [PD_REGPROG_T]; a_fname: CE_POINTER [NATURAL_8]; a_sfname: CE_POINTER [NATURAL_8]; a_tail: CE_POINTER [NATURAL_8]; a_allow_dirs: INTEGER_32): INTEGER_32
		local
			l_regmatch___0: PD_REGMATCH_T
			l_result___2: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_regmatch___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result___2 := 0
					l_regmatch___0.rm_ic := 0
					if (a_prog.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_regmatch___0.regprog := a_prog
					else
						l_regmatch___0.regprog := regexp_inst.vim_regcomp (a_pattern, 1)
					end
					if ((l_regmatch___0.regprog).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if not (a_allow_dirs.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (regexp_inst.vim_regexec (l_regmatch___0.address, a_fname, 0)).to_boolean then
							l_result___2 := 1
						elseif (a_sfname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (regexp_inst.vim_regexec (l_regmatch___0.address, a_sfname, 0)).to_boolean then
								l_result___2 := 1
							else
								l_pos := -1 + 4 -- goto _L
							end
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if not a_allow_dirs.to_boolean then
							if (regexp_inst.vim_regexec (l_regmatch___0.address, a_tail, 0)).to_boolean then
								l_result___2 := 1
							end
						end
				when 5 then -- if done
						if (a_prog.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_regmatch___0.regprog))
						end
						Result := l_result___2
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	match_file_list (a_list: CE_POINTER [NATURAL_8]; a_sfname: CE_POINTER [NATURAL_8]; a_ffname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_tail: CE_POINTER [NATURAL_8]
			l_regpat: CE_POINTER [NATURAL_8]
			l_allow_dirs: INTEGER_8
			l_match: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_buf___6.make (<<100>>)
			create l_tail.make
			create l_regpat.make
			create l_p___0.make

			l_tail.ce_gets (misc1_inst.gettail (a_sfname))
			l_p___0.ce_gets (a_list)
			from
			until
				not (not js.loop_left and then ((l_p___0.item).to_boolean))
			loop
				js.reset
				misc2_inst.copy_option_part (l_p___0.address, l_buf___6, 100, ce_string (",")).do_nothing
				l_regpat.ce_gets (file_pat_to_reg_pat (l_buf___6, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_8]}.make_shared ($l_allow_dirs), 0))
				if (l_regpat.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					js.break
				end
				if not js.loop_jumped then
					l_match := match_file_pat (l_regpat, create {CE_POINTER [PD_REGPROG_T]}.make_shared (default_pointer), a_ffname, a_sfname, l_tail, l_allow_dirs.to_integer_32)
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_regpat))
					if l_match.to_boolean then
						Result := 1
						js.return
					end
				end
			end
			js.reset
			if not js.return_called then
				Result := 0
			end
		end

	file_pat_to_reg_pat (a_pat: CE_POINTER [NATURAL_8]; a_pat_end: CE_POINTER [NATURAL_8]; a_allow_dirs: CE_POINTER [INTEGER_8]; a_no_bslash: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_pat: CE_POINTER [NATURAL_8]
			l_pat_end: CE_POINTER [NATURAL_8]
			l_size: INTEGER_32
			l_endp: CE_POINTER [NATURAL_8]
			l_reg_pat: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_nested___0: INTEGER_32
			l_add_dollar: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_tmp___19: INTEGER_32
			l_tmp___20: CE_POINTER [NATURAL_8]
			l_tmp___23: INTEGER_32
			l_tmp___24: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_pat.make
			create l_pat_end.make
			create l_endp.make
			create l_reg_pat.make
			create l_p___0.make
			create l_tmp___20.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pat.ce_gets (a_pat)
					l_pat_end.ce_gets (a_pat_end)
					l_nested___0 := 0
					l_add_dollar := 1
					if (a_allow_dirs.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						a_allow_dirs[0] := (0).to_integer_8
					end
					if (l_pat_end.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_pat_end.ce_gets (l_pat + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_pat))).to_integer_32)
					end
					l_size := 2
					l_p___0.ce_gets (l_pat)
				when 1 then -- loop condition:
					if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_pat_end.c_pointer.to_integer_32).to_natural_32) then
						l_pos := -1 + 6 -- skip loop
					end
				when 2 then -- loop body:
						inspect (l_p___0.item).to_integer_32 -- switch 1 head
						when 42 then l_pos := -1 + 3
						when 46 then l_pos := -1 + 3
						when 44 then l_pos := -1 + 3
						when 123 then l_pos := -1 + 3
						when 125 then l_pos := -1 + 3
						when 126 then l_pos := -1 + 3
						else l_pos := -1 + 4
						end
				when 3 then -- switch 1, case 42 | switch 1, case 46 | switch 1, case 44 | switch 1, case 123 | switch 1, case 125 | switch 1, case 126
						l_size := l_size + (2)
						l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, default:
						l_size := l_size + 1
						if globals_inst.enc_dbcs /= 0 then
							if (globals_inst.mb_ptr2len.integer_32_item ([l_p___0])) > 1 then
								l_p___0.ce_gets (l_p___0 + 1)
								l_size := l_size + 1
							end
						end
						l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done:
						l_p___0.ce_gets (l_p___0 + 1)
						l_pos := -1 + 1 -- back to loop condition
				when 6 then -- loop done
					l_reg_pat.ce_gets (misc2_inst.alloc ((l_size + 1).to_natural_32))
					if (l_reg_pat.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 27 -- skip if block
					end
				when 7 then -- if:
						l_i___0 := 0
						if (l_pat[0]).to_integer_32 = 42 then
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_pat[0]).to_integer_32 = 42 then
									if not ((l_pat.c_pointer.to_integer_32).to_natural_32 < ((l_pat_end - 1).c_pointer.to_integer_32).to_natural_32) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_pat.ce_gets (l_pat + 1)
								end
							end
							js.reset
						else
							l_tmp___1 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___1] := (('^').code).to_natural_8
						end
						l_endp.ce_gets (l_pat_end - 1)
						if (l_endp.item).to_integer_32 = 42 then
							from
							until
								js.loop_left
							loop
								js.reset
								if l_endp.distance (l_pat) > 0 then
									if (l_endp.item).to_integer_32 /= 42 then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_endp.ce_gets (l_endp - 1)
								end
							end
							js.reset
							l_add_dollar := 0
						end
						l_p___0.ce_gets (l_pat)
				when 8 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 26 -- skip loop
						end
				when 9 then -- loop body:
						js.reset
						if (l_p___0.item).to_boolean then
							if l_nested___0 >= 0 then
								if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 <= (l_endp.c_pointer.to_integer_32).to_natural_32) then
									js.break
								end
							else
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 25 -- skip if block
						end
				when 10 then -- if:
						inspect (l_p___0.item).to_integer_32 -- switch 2 head
						when 42 then l_pos := -1 + 11
						when 46 then l_pos := -1 + 12
						when 126 then l_pos := -1 + 12
						when 63 then l_pos := -1 + 13
						when 92 then l_pos := -1 + 14
						when 123 then l_pos := -1 + 16
						when 125 then l_pos := -1 + 17
						when 44 then l_pos := -1 + 18
						else l_pos := -1 + 19
						end
				when 11 then -- switch 2, case 42
						l_tmp___2 := l_i___0
						l_i___0 := l_i___0 + 1
						l_reg_pat[l_tmp___2] := (('.').code).to_natural_8
						l_tmp___3 := l_i___0
						l_i___0 := l_i___0 + 1
						l_reg_pat[l_tmp___3] := (('*').code).to_natural_8
						from
						until
							(l_p___0[1]).to_integer_32 /= 42
						loop
							l_p___0.ce_gets (l_p___0 + 1)
						end
						l_pos := -1 + 24 -- switch 2; break
				when 12 then -- switch 2, case 46 | switch 2, case 126
						l_tmp___4 := l_i___0
						l_i___0 := l_i___0 + 1
						l_reg_pat[l_tmp___4] := (('\').code).to_natural_8
						l_tmp___5 := l_i___0
						l_i___0 := l_i___0 + 1
						l_reg_pat[l_tmp___5] := l_p___0.item
						l_pos := -1 + 24 -- switch 2; break
				when 13 then -- switch 2, case 63
						l_tmp___6 := l_i___0
						l_i___0 := l_i___0 + 1
						l_reg_pat[l_tmp___6] := (('.').code).to_natural_8
						l_pos := -1 + 24 -- switch 2; break
				when 14 then -- switch 2, case 92
						if (l_p___0[1]).to_integer_32 = 0 then
							l_pos := -1 + 24 -- switch 2; break
						end
				when 15 then
						l_p___0.ce_gets (l_p___0 + 1)
						if (l_p___0.item).to_integer_32 = 63 then
							l_tmp___7 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___7] := (('?').code).to_natural_8
						elseif (l_p___0.item).to_integer_32 = 44 then
							l_tmp___8 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___8] := l_p___0.item
						elseif (l_p___0.item).to_integer_32 = 37 then
							l_tmp___8 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___8] := l_p___0.item
						elseif (l_p___0.item).to_integer_32 = 35 then
							l_tmp___8 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___8] := l_p___0.item
						elseif (l_p___0.item).to_integer_32 = 32 then
							l_tmp___8 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___8] := l_p___0.item
						else
							if (a_allow_dirs.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if (misc1_inst.vim_ispathsep ((l_p___0.item).to_integer_32)).to_boolean then
									a_allow_dirs[0] := (1).to_integer_8
								end
							end
							l_tmp___10 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___10] := (('\').code).to_natural_8
							l_tmp___11 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___11] := l_p___0.item
						end
						l_pos := -1 + 24 -- switch 2; break
				when 16 then -- switch 2, case 123
						l_tmp___12 := l_i___0
						l_i___0 := l_i___0 + 1
						l_reg_pat[l_tmp___12] := (('\').code).to_natural_8
						l_tmp___13 := l_i___0
						l_i___0 := l_i___0 + 1
						l_reg_pat[l_tmp___13] := (('(').code).to_natural_8
						l_nested___0 := l_nested___0 + 1
						l_pos := -1 + 24 -- switch 2; break
				when 17 then -- switch 2, case 125
						l_tmp___14 := l_i___0
						l_i___0 := l_i___0 + 1
						l_reg_pat[l_tmp___14] := (('\').code).to_natural_8
						l_tmp___15 := l_i___0
						l_i___0 := l_i___0 + 1
						l_reg_pat[l_tmp___15] := ((')').code).to_natural_8
						l_nested___0 := l_nested___0 - 1
						l_pos := -1 + 24 -- switch 2; break
				when 18 then -- switch 2, case 44
						if l_nested___0.to_boolean then
							l_tmp___16 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___16] := (('\').code).to_natural_8
							l_tmp___17 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___17] := (('|').code).to_natural_8
						else
							l_tmp___18 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___18] := ((',').code).to_natural_8
						end
						l_pos := -1 + 24 -- switch 2; break
				when 19 then -- switch 2, default:
						if globals_inst.enc_dbcs = 0 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if (globals_inst.mb_ptr2len.integer_32_item ([l_p___0])) > 1 then
							l_tmp___19 := l_i___0
							l_i___0 := l_i___0 + 1
							l_tmp___20.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_reg_pat[l_tmp___19] := l_tmp___20.item
						else
							l_pos := -1 + 22 -- goto _L
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else: | _L:
						if (a_allow_dirs.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (misc1_inst.vim_ispathsep ((l_p___0.item).to_integer_32)).to_boolean then
								a_allow_dirs[0] := (1).to_integer_8
							end
						end
				when 23 then
						l_tmp___23 := l_i___0
						l_i___0 := l_i___0 + 1
						l_reg_pat[l_tmp___23] := l_p___0.item
						l_pos := -1 + 24 -- switch 2; break
				when 24 then -- switch 2, done:
						l_p___0.ce_gets (l_p___0 + 1)
				when 25 then -- if done
						l_pos := -1 + 8 -- back to loop condition
				when 26 then -- loop done
						js.reset
						if l_add_dollar.to_boolean then
							l_tmp___24 := l_i___0
							l_i___0 := l_i___0 + 1
							l_reg_pat[l_tmp___24] := (('$').code).to_natural_8
						end
						l_reg_pat[l_i___0] := (('%/0/').code).to_natural_8
						if l_nested___0 /= 0 then
							if l_nested___0 < 0 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E219: Missing {."))))).do_nothing
							else
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E220: Missing }."))))).do_nothing
							end
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_reg_pat))
							l_reg_pat.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						end
						Result := l_reg_pat
				when 27 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
