class
	P_GETCHAR

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create redobuff.make
			create old_redobuff.make
			create save_redobuff.make
			create save_old_redobuff.make
			create recordbuff.make
			create maphash.make (<<256>>)
			create first_abbr.make
			create typebuf_init.make (<<265>>)
			create noremapbuf_init.make (<<265>>)
			create bp.make
			create p.make
			create saved_typebuf.make (<<15>>)
		end

feature {ANY} -- attributes

	redobuff: PD_BUFFHEADER

	old_redobuff: PD_BUFFHEADER

	save_redobuff: PD_BUFFHEADER

	save_old_redobuff: PD_BUFFHEADER

	recordbuff: PD_BUFFHEADER

	typeahead_char: INTEGER_32 assign set_typeahead_char

	set_typeahead_char (a_typeahead_char: INTEGER_32)
		do
			typeahead_char := a_typeahead_char
		end

	block_redo: INTEGER_32 assign set_block_redo

	set_block_redo (a_block_redo: INTEGER_32)
		do
			block_redo := a_block_redo
		end

	maphash: CE_ARRAY [CE_POINTER [PD_MAPBLOCK]]

	maphash_valid: INTEGER_32 assign set_maphash_valid

	set_maphash_valid (a_maphash_valid: INTEGER_32)
		do
			maphash_valid := a_maphash_valid
		end

	first_abbr: CE_POINTER [PD_MAPBLOCK]

	KeyNoremap: INTEGER_32 assign set_KeyNoremap

	set_KeyNoremap (a_KeyNoremap: INTEGER_32)
		do
			KeyNoremap := a_KeyNoremap
		end

	typebuf_init: CE_ARRAY [NATURAL_8]

	noremapbuf_init: CE_ARRAY [NATURAL_8]

	last_recorded_len: INTEGER_32 assign set_last_recorded_len

	set_last_recorded_len (a_last_recorded_len: INTEGER_32)
		do
			last_recorded_len := a_last_recorded_len
		end

	save_level: INTEGER_32 assign set_save_level

	set_save_level (a_save_level: INTEGER_32)
		do
			save_level := a_save_level
		end

	bp: CE_POINTER [PD_BUFFBLOCK]

	p: CE_POINTER [NATURAL_8]

	saved_typebuf: CE_ARRAY [PD_TYPEBUF_T]

	old_char: INTEGER_32 assign set_old_char

	set_old_char (a_old_char: INTEGER_32)
		do
			old_char := a_old_char
		end

	old_mod_mask: INTEGER_32 assign set_old_mod_mask

	set_old_mod_mask (a_old_mod_mask: INTEGER_32)
		do
			old_mod_mask := a_old_mod_mask
		end

	count___0: INTEGER_32 assign set_count___0

	set_count___0 (a_count___0: INTEGER_32)
		do
			count___0 := a_count___0
		end

	tc: INTEGER_32 assign set_tc

	set_tc (a_tc: INTEGER_32)
		do
			tc := a_tc
		end

	expand_mapmodes: INTEGER_32 assign set_expand_mapmodes

	set_expand_mapmodes (a_expand_mapmodes: INTEGER_32)
		do
			expand_mapmodes := a_expand_mapmodes
		end

	expand_isabbrev: INTEGER_32 assign set_expand_isabbrev

	set_expand_isabbrev (a_expand_isabbrev: INTEGER_32)
		do
			expand_isabbrev := a_expand_isabbrev
		end

	expand_buffer: INTEGER_32 assign set_expand_buffer

	set_expand_buffer (a_expand_buffer: INTEGER_32)
		do
			expand_buffer := a_expand_buffer
		end

feature {ANY} -- routines

	free_buff (a_buf___6: CE_POINTER [PD_BUFFHEADER])
		local
			l_p___0: CE_POINTER [PD_BUFFBLOCK]
			l_np: CE_POINTER [PD_BUFFBLOCK]
		do
			create l_p___0.make
			create l_np.make

			l_p___0.ce_gets (a_buf___6.item.bh_first.b_next)
			from
			until
				(l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
			loop
				l_np.ce_gets (l_p___0.item.b_next)
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
				l_p___0.ce_gets (l_np)
			end
			a_buf___6.item.bh_first.b_next := create {CE_POINTER [PD_BUFFBLOCK]}.make_shared (default_pointer)
		end

	get_buffcont (a_buffer: CE_POINTER [PD_BUFFHEADER]; a_dozero: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_count___2: NATURAL_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_p2: CE_POINTER [NATURAL_8]
			l_str___1: CE_POINTER [NATURAL_8]
			l_bp___0: CE_POINTER [PD_BUFFBLOCK]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_p2.make
			create l_str___1.make
			create l_bp___0.make
			create l_tmp___0.make
			create l_tmp___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2 := (0).to_natural_32
					l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_bp___0.ce_gets (a_buffer.item.bh_first.b_next)
					from
					until
						(l_bp___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
					loop
						l_count___2 := l_count___2 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_bp___0.item.b_str)))).to_natural_32
						l_bp___0.ce_gets (l_bp___0.item.b_next)
					end
					if not (l_count___2.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (a_dozero.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_p___0.ce_gets (misc2_inst.lalloc (l_count___2 + {NATURAL_32} 1, 1))
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_p2.ce_gets (l_p___0)
							l_bp___0.ce_gets (a_buffer.item.bh_first.b_next)
							from
							until
								not (not js.loop_left and then ((l_bp___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
							loop
								l_str___1.ce_gets (l_bp___0.item.b_str)
								from
								until
									not ((l_str___1.item).to_boolean)
								loop
									l_tmp___0.ce_gets (l_p2)
									l_p2.ce_gets (l_p2 + 1)
									l_tmp___1.ce_gets (l_str___1)
									l_str___1.ce_gets (l_str___1 + 1)
									l_tmp___0.item := l_tmp___1.item
								end
								l_bp___0.ce_gets (l_bp___0.item.b_next)
							end
							l_p2.item := (('%/0/').code).to_natural_8
						end
				when 5 then -- if done
						Result := l_p___0
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	get_recorded: CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: NATURAL_32
		do
			create l_p___0.make

			l_p___0.ce_gets (get_buffcont (recordbuff.address, 1))
			free_buff (recordbuff.address)
			l_len := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))
			if l_len.to_integer_32 >= last_recorded_len then
				l_len := l_len - last_recorded_len.to_natural_32
				l_p___0[l_len.to_integer_32] := (('%/0/').code).to_natural_8
			end
			if l_len > {NATURAL_32} 0 then
				if globals_inst.restart_edit /= 0 then
					if (l_p___0[(l_len - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 15 then
						l_p___0[(l_len - {NATURAL_32} 1).to_integer_32] := (('%/0/').code).to_natural_8
					end
				end
			end
			Result := l_p___0
		end

	get_inserted: CE_POINTER [NATURAL_8]
		do
			Result := (get_buffcont (redobuff.address, 0))
		end

	add_buff (a_buf___6: CE_POINTER [PD_BUFFHEADER]; a_s: CE_POINTER [NATURAL_8]; a_slen: INTEGER_32)
		local
			l_slen: INTEGER_32
			l_p___0: CE_POINTER [PD_BUFFBLOCK]
			l_len: NATURAL_32
			js: JUMP_STATE
		do
			create l_p___0.make

			l_slen := a_slen
			if l_slen < 0 then
				l_slen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_s))).to_integer_32
			end
			if l_slen = 0 then
				js.return
			end
			if not js.return_called then
				if ((a_buf___6.item.bh_first.b_next).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					a_buf___6.item.bh_space := 0
					a_buf___6.item.bh_curr := create {CE_POINTER [PD_BUFFBLOCK]}.make_shared (a_buf___6.c_pointer + {PD_BUFFHEADER}.bh_first_offset)
				elseif ((a_buf___6.item.bh_curr).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E222: Add to read buffer"))))).do_nothing
					js.return
				elseif a_buf___6.item.bh_index /= 0 then
					memmove (create {CE_POINTER [ANY]}.make_cast (((a_buf___6.item.bh_first.b_next).item.b_str)), create {CE_POINTER [ANY]}.make_cast (((a_buf___6.item.bh_first.b_next).item.b_str + a_buf___6.item.bh_index)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (((a_buf___6.item.bh_first.b_next).item.b_str + a_buf___6.item.bh_index)))) + {NATURAL_32} 1).do_nothing
				end
			end
			if not js.return_called then
				a_buf___6.item.bh_index := 0
				if a_buf___6.item.bh_space >= l_slen.to_integer_32 then
					l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (((a_buf___6.item.bh_curr).item.b_str)))).to_natural_32
					misc2_inst.vim_strncpy ((a_buf___6.item.bh_curr).item.b_str + l_len.to_integer_32, a_s, l_slen.to_natural_32)
					a_buf___6.item.bh_space := ((a_buf___6.item.bh_space).to_integer_32 - l_slen).to_integer_32
				else
					if l_slen < 20 then
						l_len := (20).to_natural_32
					else
						l_len := l_slen.to_natural_32
					end
					l_p___0.ce_gets (create {CE_POINTER [PD_BUFFBLOCK]}.make_cast ((misc2_inst.lalloc (({PD_BUFFBLOCK}.sizeof.to_natural_32).to_natural_32 + l_len, 1))))
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.return
					end
					if not js.return_called then
						a_buf___6.item.bh_space := (l_len - l_slen.to_natural_32).to_integer_32
						misc2_inst.vim_strncpy (l_p___0.item.b_str, a_s, l_slen.to_natural_32)
						l_p___0.item.b_next := (a_buf___6.item.bh_curr).item.b_next;
						(a_buf___6.item.bh_curr).item.b_next := l_p___0
						a_buf___6.item.bh_curr := l_p___0
					end
				end
			end
			if not js.return_called then
			end
		end

	add_num_buff (a_buf___6: CE_POINTER [PD_BUFFHEADER]; a_n: INTEGER_32)
		local
			l_number: CE_ARRAY [NATURAL_8]
		do
			create l_number.make (<<32>>)

			sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_number), ce_string ("%%ld"), a_n]).do_nothing
			add_buff (a_buf___6, l_number, -1)
		end

	add_char_buff (a_buf___6: CE_POINTER [PD_BUFFHEADER]; a_c: INTEGER_32)
		local
			l_c: INTEGER_32
			l_bytes___0: CE_ARRAY [NATURAL_8]
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			l_temp: CE_ARRAY [NATURAL_8]
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_bytes___0.make (<<22>>)
			create l_temp.make (<<4>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := a_c
					if l_c < 0 then
						l_len := 1
					else
						l_len := globals_inst.mb_char2bytes.integer_32_item ([l_c, l_bytes___0])
					end
					l_i___0 := 0
				when 1 then -- loop condition:
					if not (l_i___0 < l_len) then
						l_pos := -1 + 13 -- skip loop
					end
				when 2 then -- loop body:
						if not (l_c < 0) then
							l_c := (l_bytes___0[l_i___0]).to_integer_32
						end
						if not (l_c < 0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 5 then -- else:
						if l_c /= 128 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 8 then -- else:
						if l_c /= 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if: | _L:
						l_temp[0] := (128).to_natural_8
						if l_c = 128 then
							l_temp[1] := (254).to_natural_8
						else
							if l_c = 0 then
								l_tmp := 255
							else
								l_tmp := (-l_c).bit_and (255)
							end
							l_temp[1] := l_tmp.to_natural_8
						end
						if l_c = 128 then
							l_temp[2] := (('X').code).to_natural_8
						elseif l_c = 0 then
							l_temp[2] := (('X').code).to_natural_8
						else
							l_temp[2] := (((((-l_c).to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 255)).to_natural_8
						end
						l_temp[3] := (('%/0/').code).to_natural_8
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						if l_c = 155 then
							l_temp[0] := (155).to_natural_8
							l_temp[1] := (253).to_natural_8
							l_temp[2] := (81).to_natural_8
							l_temp[3] := (('%/0/').code).to_natural_8
						else
							l_temp[0] := l_c.to_natural_8
							l_temp[1] := (('%/0/').code).to_natural_8
						end
				when 12 then -- if done | if done
						add_buff (a_buf___6, l_temp, -1)
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 1 -- back to loop condition
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	read_stuff (a_advance: INTEGER_32): INTEGER_32
		local
			l_c: NATURAL_8
			l_curr: CE_POINTER [PD_BUFFBLOCK]
			js: JUMP_STATE
		do
			create l_curr.make

			if ((globals_inst.stuffbuff.bh_first.b_next).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (('%/0/').code)
				js.return
			end
			if not js.return_called then
				l_curr.ce_gets (globals_inst.stuffbuff.bh_first.b_next)
				l_c := l_curr.item.b_str[globals_inst.stuffbuff.bh_index]
				if a_advance.to_boolean then
					globals_inst.stuffbuff.bh_index := (globals_inst.stuffbuff.bh_index) + 1
					if (l_curr.item.b_str[globals_inst.stuffbuff.bh_index]).to_integer_32 = 0 then
						globals_inst.stuffbuff.bh_first.b_next := l_curr.item.b_next
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_curr))
						globals_inst.stuffbuff.bh_index := 0
					end
				end
				Result := l_c.to_integer_32
			end
		end

	start_stuff
		do
			if ((globals_inst.stuffbuff.bh_first.b_next).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				globals_inst.stuffbuff.bh_curr := create {CE_POINTER [PD_BUFFBLOCK]}.make_shared (globals_inst.stuffbuff.c_pointer + {PD_BUFFHEADER}.bh_first_offset)
				globals_inst.stuffbuff.bh_space := 0
			end
		end

	stuff_empty: INTEGER_32
		do
			Result := (((globals_inst.stuffbuff.bh_first.b_next).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32).to_integer
		end

	typeahead_noflush (a_c: INTEGER_32)
		do
			typeahead_char := a_c
		end

	flush_buffers (a_typeahead: INTEGER_32)
		local
			js: JUMP_STATE
		do
			init_typebuf
			start_stuff
			from
			until
				js.loop_left
			loop
				js.reset
				if (read_stuff (1)) = 0 then
					js.break
				end
			end
			js.reset
			if a_typeahead.to_boolean then
				from
				until
					js.loop_left
				loop
					js.reset
					if (inchar (globals_inst.typebuf.tb_buf, globals_inst.typebuf.tb_buflen - 1, 10, globals_inst.typebuf.tb_change_cnt)) = 0 then
						js.break
					end
				end
				js.reset
				globals_inst.typebuf.tb_off := 50
				globals_inst.typebuf.tb_len := 0
			else
				globals_inst.typebuf.tb_off := globals_inst.typebuf.tb_off + (globals_inst.typebuf.tb_maplen)
				globals_inst.typebuf.tb_len := globals_inst.typebuf.tb_len - (globals_inst.typebuf.tb_maplen)
			end
			globals_inst.typebuf.tb_maplen := 0
			globals_inst.typebuf.tb_silent := 0
			globals_inst.cmd_silent := 0
			globals_inst.typebuf.tb_no_abbr_cnt := 0
		end

	ResetRedobuff
		do
			if not block_redo.to_boolean then
				free_buff (old_redobuff.address)
				old_redobuff.ce_gets (redobuff)
				redobuff.bh_first.b_next := create {CE_POINTER [PD_BUFFBLOCK]}.make_shared (default_pointer)
			end
		end

	saveRedobuff
		local
			l_s: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
		do
			create l_s.make

			l_tmp := save_level
			save_level := save_level + 1
			if l_tmp = 0 then
				save_redobuff.ce_gets (redobuff)
				redobuff.bh_first.b_next := create {CE_POINTER [PD_BUFFBLOCK]}.make_shared (default_pointer)
				save_old_redobuff.ce_gets (old_redobuff)
				old_redobuff.bh_first.b_next := create {CE_POINTER [PD_BUFFBLOCK]}.make_shared (default_pointer)
				l_s.ce_gets (get_buffcont (save_redobuff.address, 0))
				if (l_s.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					add_buff (redobuff.address, l_s, -1)
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_s))
				end
			end
		end

	restoreRedobuff
		do
			save_level := save_level - 1
			if save_level = 0 then
				free_buff (redobuff.address)
				redobuff.ce_gets (save_redobuff)
				free_buff (old_redobuff.address)
				old_redobuff.ce_gets (save_old_redobuff)
			end
		end

	AppendToRedobuff (a_s: CE_POINTER [NATURAL_8])
		do
			if not block_redo.to_boolean then
				add_buff (redobuff.address, a_s, -1)
			end
		end

	AppendToRedobuffLit (a_str___1: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_s: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_start___1: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make
			create l_start___1.make
			create l_tmp.make

			l_s.ce_gets (a_str___1)
			if block_redo.to_boolean then
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					if a_len < 0 then
						l_tmp___0 := ((l_s.item).to_integer_32 /= 0).to_integer
					else
						l_tmp___0 := (l_s.distance (a_str___1) < a_len).to_integer
					end
					if not l_tmp___0.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_start___1.ce_gets (l_s)
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_s.item).to_integer_32 >= 32 then
								if (l_s.item).to_integer_32 < 127 then
									if not (a_len < 0) then
										if not (l_s.distance (a_str___1) < a_len) then
											js.break
										end
									end
								else
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_s.ce_gets (l_s + 1)
							end
						end
						js.reset
						if (l_s.item).to_integer_32 = 0 then
							if (l_s[-1]).to_integer_32 = 48 then
								l_s.ce_gets (l_s - 1)
							elseif (l_s[-1]).to_integer_32 = 94 then
								l_s.ce_gets (l_s - 1)
							end
						end
						if (l_s.c_pointer.to_integer_32).to_natural_32 > (l_start___1.c_pointer.to_integer_32).to_natural_32 then
							add_buff (redobuff.address, l_start___1, (l_s.distance (l_start___1)).to_integer_32)
						end
						if (l_s.item).to_integer_32 = 0 then
							js.break
						elseif a_len >= 0 then
							if l_s.distance (a_str___1) >= a_len then
								js.break
							end
						end
					end
					if not js.loop_jumped then
						if globals_inst.has_mbyte.to_boolean then
							l_c := mbyte_inst.mb_cptr2char_adv (l_s.address)
						else
							l_tmp.ce_gets (l_s)
							l_s.ce_gets (l_s + 1)
							l_c := (l_tmp.item).to_integer_32
						end
						if l_c < 32 then
							add_char_buff (redobuff.address, 22)
						elseif l_c = 127 then
							add_char_buff (redobuff.address, 22)
						elseif (l_s.item).to_integer_32 = 0 then
							if l_c = 48 then
								add_char_buff (redobuff.address, 22)
							elseif l_c = 94 then
								add_char_buff (redobuff.address, 22)
							end
						end
						if (l_s.item).to_integer_32 = 0 then
							if l_c = 48 then
								add_buff (redobuff.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("048")), 3)
							else
								add_char_buff (redobuff.address, l_c)
							end
						else
							add_char_buff (redobuff.address, l_c)
						end
					end
				end
				js.reset
			end
		end

	AppendCharToRedobuff (a_c: INTEGER_32)
		do
			if not block_redo.to_boolean then
				add_char_buff (redobuff.address, a_c)
			end
		end

	AppendNumberToRedobuff (a_n: INTEGER_32)
		do
			if not block_redo.to_boolean then
				add_num_buff (redobuff.address, a_n)
			end
		end

	stuffReadbuff (a_s: CE_POINTER [NATURAL_8])
		do
			add_buff (globals_inst.stuffbuff.address, a_s, -1)
		end

	stuffReadbuffLen (a_s: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		do
			add_buff (globals_inst.stuffbuff.address, a_s, a_len)
		end

	stuffReadbuffSpec (a_s: CE_POINTER [NATURAL_8])
		local
			l_s: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
		do
			create l_s.make

			l_s.ce_gets (a_s)
			from
			until
				(l_s.item).to_integer_32 = 0
			loop
				if (l_s.item).to_integer_32 = 128 then
					if (l_s[1]).to_integer_32 /= 0 then
						if (l_s[2]).to_integer_32 /= 0 then
							stuffReadbuffLen (l_s, 3)
							l_s.ce_gets (l_s + (3))
						else
							l_tmp := mbyte_inst.mb_ptr2char_adv (l_s.address)
							stuffcharReadbuff (l_tmp)
						end
					else
						l_tmp := mbyte_inst.mb_ptr2char_adv (l_s.address)
						stuffcharReadbuff (l_tmp)
					end
				else
					l_tmp := mbyte_inst.mb_ptr2char_adv (l_s.address)
					stuffcharReadbuff (l_tmp)
				end
			end
		end

	stuffcharReadbuff (a_c: INTEGER_32)
		do
			add_char_buff (globals_inst.stuffbuff.address, a_c)
		end

	stuffnumReadbuff (a_n: INTEGER_32)
		do
			add_num_buff (globals_inst.stuffbuff.address, a_n)
		end

	read_redo (a_init: INTEGER_32; a_old_redo: INTEGER_32): INTEGER_32
		local
			l_c: INTEGER_32
			l_n: INTEGER_32
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___6.make (<<21>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_init.to_boolean then
						if a_old_redo.to_boolean then
							bp.ce_gets (old_redobuff.bh_first.b_next)
						else
							bp.ce_gets (redobuff.bh_first.b_next)
						end
						if (bp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							Result := 0
							js.return
						end
						if not js.return_called then
							p.ce_gets (bp.item.b_str)
							Result := 1
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						l_c := (p.item).to_integer_32
						if l_c = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 2 then -- if:
						if not (globals_inst.has_mbyte.to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						if l_c = 128 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if (p[1]).to_integer_32 /= 254 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						if l_c < 0 then
							l_n := 1
						elseif l_c > 255 then
							l_n := 1
						else
							l_n := (globals_inst.mb_bytelen_tab[l_c]).to_integer_32
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_n := 1
				when 10 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_n := 1
				when 12 then
						l_i___0 := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if l_c = 128 then
								if (p[1]).to_integer_32 = 254 then
									l_c := 128
								else
									if (p[1]).to_integer_32 = 255 then
										l_tmp := -(255 + ((88).bit_shift_left (8)))
									else
										l_tmp := -((p[1]).to_integer_32 + (((p[2]).to_integer_32).bit_shift_left (8)))
									end
									l_c := l_tmp
								end
								p.ce_gets (p + (2))
							end
							if l_c = 155 then
								p.ce_gets (p + (2))
							end
							p.ce_gets (p + 1)
							if (p.item).to_integer_32 = 0 then
								if ((bp.item.b_next).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									bp.ce_gets (bp.item.b_next)
									p.ce_gets (bp.item.b_str)
								end
							end
							l_buf___6[l_i___0] := l_c.to_natural_8
							if l_i___0 = l_n - 1 then
								if l_n /= 1 then
									l_c := globals_inst.mb_ptr2char.integer_32_item ([l_buf___6])
								end
								js.break
							end
							if not js.loop_jumped then
								l_c := (p.item).to_integer_32
								if l_c = 0 then
									js.break
								end
							end
							if not js.loop_jumped then
								l_i___0 := l_i___0 + 1
							end
						end
						js.reset
				when 13 then -- if done
						Result := l_c
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	copy_redo (a_old_redo: INTEGER_32)
		local
			l_c: INTEGER_32
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				l_c := read_redo (0, a_old_redo)
				if l_c = 0 then
					js.break
				end
				if not js.loop_jumped then
					stuffcharReadbuff (l_c)
				end
			end
			js.reset
		end

	start_redo (a_count___2: INTEGER_32; a_old_redo: INTEGER_32): INTEGER_32
		local
			l_c: INTEGER_32
			js: JUMP_STATE
		do
			if (read_redo (1, a_old_redo)) = 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_c := read_redo (0, a_old_redo)
				if l_c = 34 then
					add_buff (globals_inst.stuffbuff.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%"")), 1)
					l_c := read_redo (0, a_old_redo)
					if l_c >= 49 then
						if l_c < 57 then
							l_c := l_c + 1
						end
					end
					add_char_buff (globals_inst.stuffbuff.address, l_c)
					l_c := read_redo (0, a_old_redo)
				end
				if l_c = 118 then
					globals_inst.VIsual.ce_gets (globals_inst.curwin.item.w_cursor)
					globals_inst.VIsual_active := 1
					globals_inst.VIsual_select := 0
					globals_inst.VIsual_reselect := 1
					globals_inst.redo_VIsual_busy := 1
					l_c := read_redo (0, a_old_redo)
				end
				if a_count___2.to_boolean then
					from
					until
						js.loop_left
					loop
						js.reset
						if l_c >= 48 then
							if not (l_c <= 57) then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_c := read_redo (0, a_old_redo)
						end
					end
					js.reset
					add_num_buff (globals_inst.stuffbuff.address, a_count___2)
				end
				add_char_buff (globals_inst.stuffbuff.address, l_c)
				copy_redo (a_old_redo)
				Result := 1
			end
		end

	start_redo_ins: INTEGER_32
		local
			l_c: INTEGER_32
			js: JUMP_STATE
		do
			if (read_redo (1, 0)) = 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				start_stuff
				from
				until
					js.loop_left
				loop
					js.reset
					l_c := read_redo (0, 0)
					if l_c = 0 then
						js.break
					end
					if not js.loop_jumped then
						if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("AaIiRrOo")), l_c)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if l_c = 79 then
								stuffReadbuff (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
							elseif l_c = 111 then
								stuffReadbuff (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
							end
							js.break
						end
					end
				end
				js.reset
				copy_redo (0)
				block_redo := 1
				Result := 1
			end
		end

	stop_redo_ins
		do
			block_redo := 0
		end

	init_typebuf
		do
			if ((globals_inst.typebuf.tb_buf).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				globals_inst.typebuf.tb_buf := typebuf_init
				globals_inst.typebuf.tb_noremap := noremapbuf_init
				globals_inst.typebuf.tb_buflen := 265
				globals_inst.typebuf.tb_len := 0
				globals_inst.typebuf.tb_off := 0
				globals_inst.typebuf.tb_change_cnt := 1
			end
		end

	ins_typebuf (a_str___1: CE_POINTER [NATURAL_8]; a_noremap: INTEGER_32; a_offset: INTEGER_32; a_nottyped: INTEGER_32; a_silent: INTEGER_32): INTEGER_32
		local
			l_s1: CE_POINTER [NATURAL_8]
			l_s2: CE_POINTER [NATURAL_8]
			l_newlen: INTEGER_32
			l_addlen: INTEGER_32
			l_i___0: INTEGER_32
			l_newoff: INTEGER_32
			l_val___0: INTEGER_32
			l_nrm: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s1.make
			create l_s2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					init_typebuf
					globals_inst.typebuf.tb_change_cnt := (globals_inst.typebuf.tb_change_cnt) + 1
					if globals_inst.typebuf.tb_change_cnt = 0 then
						globals_inst.typebuf.tb_change_cnt := 1
					end
					l_addlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_str___1))).to_integer_32
					if a_offset /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_addlen <= globals_inst.typebuf.tb_off then
							globals_inst.typebuf.tb_off := globals_inst.typebuf.tb_off - l_addlen
							memmove (create {CE_POINTER [ANY]}.make_cast ((globals_inst.typebuf.tb_buf + globals_inst.typebuf.tb_off)), create {CE_POINTER [ANY]}.make_cast (a_str___1), l_addlen.to_natural_32).do_nothing
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						l_newoff := 54
						l_newlen := ((globals_inst.typebuf.tb_len + l_addlen) + l_newoff) + 216
						if l_newlen < 0 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_toocompl))))).do_nothing
							screen_inst.setcursor
							Result := 0
							js.return
						end
						if not js.return_called then
							l_s1.ce_gets (misc2_inst.alloc (l_newlen.to_natural_32))
							if (l_s1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							l_s2.ce_gets (misc2_inst.alloc (l_newlen.to_natural_32))
							if (l_s2.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_s1))
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							globals_inst.typebuf.tb_buflen := l_newlen
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_s1 + l_newoff)), create {CE_POINTER [ANY]}.make_cast ((globals_inst.typebuf.tb_buf + globals_inst.typebuf.tb_off)), a_offset.to_natural_32).do_nothing
							memmove (create {CE_POINTER [ANY]}.make_cast (((l_s1 + l_newoff) + a_offset)), create {CE_POINTER [ANY]}.make_cast (a_str___1), l_addlen.to_natural_32).do_nothing
							memmove (create {CE_POINTER [ANY]}.make_cast ((((l_s1 + l_newoff) + a_offset) + l_addlen)), create {CE_POINTER [ANY]}.make_cast (((globals_inst.typebuf.tb_buf + globals_inst.typebuf.tb_off) + a_offset)), ((globals_inst.typebuf.tb_len - a_offset) + 1).to_natural_32).do_nothing
							if ((globals_inst.typebuf.tb_buf).c_pointer.to_integer_32).to_natural_32 /= (typebuf_init.c_pointer.to_integer_32).to_natural_32 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.typebuf.tb_buf))
							end
							globals_inst.typebuf.tb_buf := l_s1
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_s2 + l_newoff)), create {CE_POINTER [ANY]}.make_cast ((globals_inst.typebuf.tb_noremap + globals_inst.typebuf.tb_off)), a_offset.to_natural_32).do_nothing
							memmove (create {CE_POINTER [ANY]}.make_cast ((((l_s2 + l_newoff) + a_offset) + l_addlen)), create {CE_POINTER [ANY]}.make_cast (((globals_inst.typebuf.tb_noremap + globals_inst.typebuf.tb_off) + a_offset)), (globals_inst.typebuf.tb_len - a_offset).to_natural_32).do_nothing
							if ((globals_inst.typebuf.tb_noremap).c_pointer.to_integer_32).to_natural_32 /= (noremapbuf_init.c_pointer.to_integer_32).to_natural_32 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.typebuf.tb_noremap))
							end
							globals_inst.typebuf.tb_noremap := l_s2
							globals_inst.typebuf.tb_off := l_newoff
						end
				when 4 then
					if not js.return_called then
						globals_inst.typebuf.tb_len := globals_inst.typebuf.tb_len + l_addlen
						if a_noremap = -2 then
							l_val___0 := 2
						elseif a_noremap = -3 then
							l_val___0 := 4
						else
							l_val___0 := 1
						end
						if a_noremap = -3 then
							l_nrm := 1
						elseif a_noremap < 0 then
							l_nrm := l_addlen
						else
							l_nrm := a_noremap
						end
						l_i___0 := 0
						from
						until
							not (l_i___0 < l_addlen)
						loop
							l_nrm := l_nrm - 1
							if l_nrm >= 0 then
								globals_inst.typebuf.tb_noremap[((globals_inst.typebuf.tb_off + l_i___0) + a_offset)] := l_val___0.to_natural_8
							else
								globals_inst.typebuf.tb_noremap[((globals_inst.typebuf.tb_off + l_i___0) + a_offset)] := (0).to_natural_8
							end
							l_i___0 := l_i___0 + 1
						end
						if a_nottyped.to_boolean then
							globals_inst.typebuf.tb_maplen := globals_inst.typebuf.tb_maplen + l_addlen
						elseif globals_inst.typebuf.tb_maplen > a_offset then
							globals_inst.typebuf.tb_maplen := globals_inst.typebuf.tb_maplen + l_addlen
						end
						if a_silent.to_boolean then
							globals_inst.typebuf.tb_silent := globals_inst.typebuf.tb_silent + l_addlen
							globals_inst.cmd_silent := 1
						elseif globals_inst.typebuf.tb_silent > a_offset then
							globals_inst.typebuf.tb_silent := globals_inst.typebuf.tb_silent + l_addlen
							globals_inst.cmd_silent := 1
						end
						if (globals_inst.typebuf.tb_no_abbr_cnt).to_boolean then
							if a_offset = 0 then
								globals_inst.typebuf.tb_no_abbr_cnt := globals_inst.typebuf.tb_no_abbr_cnt + l_addlen
							end
						end
						Result := 1
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ins_char_typebuf (a_c: INTEGER_32)
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_tmp: INTEGER_32
		do
			create l_buf___6.make (<<21>>)

			if a_c < 0 then
				l_buf___6[0] := (128).to_natural_8
				if a_c = 128 then
					l_buf___6[1] := (254).to_natural_8
				else
					if a_c = 0 then
						l_tmp := 255
					else
						l_tmp := (-a_c).bit_and (255)
					end
					l_buf___6[1] := l_tmp.to_natural_8
				end
				if a_c = 128 then
					l_buf___6[2] := (('X').code).to_natural_8
				elseif a_c = 0 then
					l_buf___6[2] := (('X').code).to_natural_8
				else
					l_buf___6[2] := (((((-a_c).to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 255)).to_natural_8
				end
				l_buf___6[3] := (('%/0/').code).to_natural_8
			else
				l_buf___6[(globals_inst.mb_char2bytes.integer_32_item ([a_c, l_buf___6]))] := (('%/0/').code).to_natural_8
			end
			ins_typebuf (l_buf___6, KeyNoremap, 0, (not globals_inst.KeyTyped.to_boolean).to_integer, globals_inst.cmd_silent).do_nothing
		end

	typebuf_changed (a_tb_change_cnt: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if a_tb_change_cnt /= 0 then
				if globals_inst.typebuf.tb_change_cnt /= a_tb_change_cnt then
					l_tmp := 1
				elseif globals_inst.typebuf_was_filled.to_boolean then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	typebuf_typed: INTEGER_32
		do
			Result := (globals_inst.typebuf.tb_maplen = 0).to_integer
		end

	typebuf_maplen: INTEGER_32
		do
			Result := (globals_inst.typebuf.tb_maplen)
		end

	del_typebuf (a_len: INTEGER_32; a_offset: INTEGER_32)
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_len = 0 then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						globals_inst.typebuf.tb_len := globals_inst.typebuf.tb_len - a_len
						if a_offset /= 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if globals_inst.typebuf.tb_buflen - (globals_inst.typebuf.tb_off + a_len) >= 153 then
							globals_inst.typebuf.tb_off := globals_inst.typebuf.tb_off + a_len
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						l_i___0 := globals_inst.typebuf.tb_off + a_offset
						if globals_inst.typebuf.tb_off > 50 then
							memmove (create {CE_POINTER [ANY]}.make_cast ((globals_inst.typebuf.tb_buf + 50)), create {CE_POINTER [ANY]}.make_cast ((globals_inst.typebuf.tb_buf + globals_inst.typebuf.tb_off)), a_offset.to_natural_32).do_nothing
							memmove (create {CE_POINTER [ANY]}.make_cast ((globals_inst.typebuf.tb_noremap + 50)), create {CE_POINTER [ANY]}.make_cast ((globals_inst.typebuf.tb_noremap + globals_inst.typebuf.tb_off)), a_offset.to_natural_32).do_nothing
							globals_inst.typebuf.tb_off := 50
						end
						memmove (create {CE_POINTER [ANY]}.make_cast (((globals_inst.typebuf.tb_buf + globals_inst.typebuf.tb_off) + a_offset)), create {CE_POINTER [ANY]}.make_cast (((globals_inst.typebuf.tb_buf + l_i___0) + a_len)), ((globals_inst.typebuf.tb_len - a_offset) + 1).to_natural_32).do_nothing
						memmove (create {CE_POINTER [ANY]}.make_cast (((globals_inst.typebuf.tb_noremap + globals_inst.typebuf.tb_off) + a_offset)), create {CE_POINTER [ANY]}.make_cast (((globals_inst.typebuf.tb_noremap + l_i___0) + a_len)), (globals_inst.typebuf.tb_len - a_offset).to_natural_32).do_nothing
				when 5 then
						if globals_inst.typebuf.tb_maplen > a_offset then
							if globals_inst.typebuf.tb_maplen < a_offset + a_len then
								globals_inst.typebuf.tb_maplen := a_offset
							else
								globals_inst.typebuf.tb_maplen := globals_inst.typebuf.tb_maplen - a_len
							end
						end
						if globals_inst.typebuf.tb_silent > a_offset then
							if globals_inst.typebuf.tb_silent < a_offset + a_len then
								globals_inst.typebuf.tb_silent := a_offset
							else
								globals_inst.typebuf.tb_silent := globals_inst.typebuf.tb_silent - a_len
							end
						end
						if globals_inst.typebuf.tb_no_abbr_cnt > a_offset then
							if globals_inst.typebuf.tb_no_abbr_cnt < a_offset + a_len then
								globals_inst.typebuf.tb_no_abbr_cnt := a_offset
							else
								globals_inst.typebuf.tb_no_abbr_cnt := globals_inst.typebuf.tb_no_abbr_cnt - a_len
							end
						end
						globals_inst.typebuf_was_filled := 0
						globals_inst.typebuf.tb_change_cnt := (globals_inst.typebuf.tb_change_cnt) + 1
						if globals_inst.typebuf.tb_change_cnt = 0 then
							globals_inst.typebuf.tb_change_cnt := 1
						end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gotchars (a_chars: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_s: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_todo: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make
			create l_buf___6.make (<<2>>)
			create l_tmp.make

			l_s.ce_gets (a_chars)
			l_todo := a_len
			if globals_inst.Recording.to_boolean then
				last_recorded_len := last_recorded_len + a_len
			end
			l_buf___6[1] := (('%/0/').code).to_natural_8
			from
			until
				js.loop_left
			loop
				js.reset
				l_tmp___0 := l_todo
				l_todo := l_todo - 1
				if not l_tmp___0.to_boolean then
					js.break
				end
				if not js.loop_jumped then
					l_tmp.ce_gets (l_s)
					l_s.ce_gets (l_s + 1)
					l_c := (l_tmp.item).to_integer_32
					updatescript (l_c)
					if globals_inst.Recording.to_boolean then
						l_buf___6[0] := l_c.to_natural_8
						add_buff (recordbuff.address, l_buf___6, 1)
					end
				end
			end
			js.reset
			may_sync_undo
			globals_inst.debug_did_msg := 0
			globals_inst.maptick := globals_inst.maptick + 1
		end

	may_sync_undo
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((globals_inst.State).bit_and (24)).to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (globals_inst.arrow_used.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if ((globals_inst.scriptin[globals_inst.curscript]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							undo_inst.u_sync (0)
						end
				when 5 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	alloc_typebuf: INTEGER_32
		local
			js: JUMP_STATE
		do
			globals_inst.typebuf.tb_buf := misc2_inst.alloc ({NATURAL_32} 265)
			globals_inst.typebuf.tb_noremap := misc2_inst.alloc ({NATURAL_32} 265)
			if ((globals_inst.typebuf.tb_buf).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				free_typebuf
				Result := 0
				js.return
			elseif ((globals_inst.typebuf.tb_noremap).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				free_typebuf
				Result := 0
				js.return
			end
			if not js.return_called then
				globals_inst.typebuf.tb_buflen := 265
				globals_inst.typebuf.tb_off := 0
				globals_inst.typebuf.tb_len := 0
				globals_inst.typebuf.tb_maplen := 0
				globals_inst.typebuf.tb_silent := 0
				globals_inst.typebuf.tb_no_abbr_cnt := 0
				globals_inst.typebuf.tb_change_cnt := (globals_inst.typebuf.tb_change_cnt) + 1
				if globals_inst.typebuf.tb_change_cnt = 0 then
					globals_inst.typebuf.tb_change_cnt := 1
				end
				Result := 1
			end
		end

	free_typebuf
		do
			if ((globals_inst.typebuf.tb_buf).c_pointer.to_integer_32).to_natural_32 = (typebuf_init.c_pointer.to_integer_32).to_natural_32 then
				message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_intern2)))), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Free typebuf 1"))).do_nothing
			else
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.typebuf.tb_buf))
			end
			if ((globals_inst.typebuf.tb_noremap).c_pointer.to_integer_32).to_natural_32 = (noremapbuf_init.c_pointer.to_integer_32).to_natural_32 then
				message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_intern2)))), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Free typebuf 2"))).do_nothing
			else
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.typebuf.tb_noremap))
			end
		end

	save_typebuf: INTEGER_32
		local
			js: JUMP_STATE
		do
			init_typebuf
			saved_typebuf[globals_inst.curscript] := globals_inst.typebuf
			if (alloc_typebuf) = 0 then
				closescript
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 1
			end
		end

	save_typeahead (a_tp: CE_POINTER [PD_TASAVE_T])
		do
			a_tp.item.save_typebuf := globals_inst.typebuf
			a_tp.item.typebuf_valid := ((alloc_typebuf) = 1).to_integer
			if not (a_tp.item.typebuf_valid).to_boolean then
				globals_inst.typebuf.ce_gets (a_tp.item.save_typebuf)
			end
			a_tp.item.old_char := old_char
			a_tp.item.old_mod_mask := old_mod_mask
			old_char := -1
			a_tp.item.save_stuffbuff := globals_inst.stuffbuff
			globals_inst.stuffbuff.bh_first.b_next := create {CE_POINTER [PD_BUFFBLOCK]}.make_shared (default_pointer)
			a_tp.item.save_inputbuf := ui_inst.get_input_buf
		end

	restore_typeahead (a_tp: CE_POINTER [PD_TASAVE_T])
		do
			if (a_tp.item.typebuf_valid).to_boolean then
				free_typebuf
				globals_inst.typebuf.ce_gets (a_tp.item.save_typebuf)
			end
			old_char := a_tp.item.old_char
			old_mod_mask := a_tp.item.old_mod_mask
			free_buff (globals_inst.stuffbuff.address)
			globals_inst.stuffbuff.ce_gets (a_tp.item.save_stuffbuff)
			ui_inst.set_input_buf (a_tp.item.save_inputbuf)
		end

	openscript (a_name___1: CE_POINTER [NATURAL_8]; a_directly: INTEGER_32)
		local
			l_tmp___1: CE_POINTER [SD_IO_FILE]
			l_oa: PD_OPARG_S
			l_oldcurscript: INTEGER_32
			l_save_State: INTEGER_32
			l_save_restart_edit: INTEGER_32
			l_save_insertmode: INTEGER_32
			l_save_finish_op: INTEGER_32
			l_save_msg_scroll: INTEGER_32
			js: JUMP_STATE
		do
			create l_tmp___1.make
			create l_oa.make

			if globals_inst.curscript + 1 = 15 then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_nesting))))).do_nothing
				js.return
			end
			if not js.return_called and then (globals_inst.ignore_script.to_boolean) then
				js.return
			end
			if not js.return_called then
				if ((globals_inst.scriptin[globals_inst.curscript]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					globals_inst.curscript := globals_inst.curscript + 1
				end
				misc1_inst.expand_env (a_name___1, globals_inst.NameBuff, 4096)
				l_tmp___1.ce_gets (fopen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff), ce_string ("r")))
				globals_inst.scriptin[globals_inst.curscript] := l_tmp___1
				if (l_tmp___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_notopen)))), a_name___1).do_nothing
					if globals_inst.curscript.to_boolean then
						globals_inst.curscript := globals_inst.curscript - 1
					end
					js.return
				end
			end
			if not js.return_called then
				if (save_typebuf) = 0 then
					js.return
				end
			end
			if not js.return_called and then (a_directly.to_boolean) then
				l_save_State := globals_inst.State
				l_save_restart_edit := globals_inst.restart_edit
				l_save_insertmode := option_inst.p_im
				l_save_finish_op := globals_inst.finish_op
				l_save_msg_scroll := globals_inst.msg_scroll
				globals_inst.State := 1
				globals_inst.msg_scroll := 0
				globals_inst.restart_edit := 0
				option_inst.p_im := 0
				ops_inst.clear_oparg (l_oa.address)
				globals_inst.finish_op := 0
				l_oldcurscript := globals_inst.curscript
				from
				until
					js.loop_left
				loop
					js.reset
					ex_docmd_inst.update_topline_cursor
					normal_inst.normal_cmd (l_oa.address, 0)
					vpeekc.do_nothing
					if ((globals_inst.scriptin[l_oldcurscript]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.break
					end
				end
				js.reset
				globals_inst.State := l_save_State
				globals_inst.msg_scroll := l_save_msg_scroll
				globals_inst.restart_edit := l_save_restart_edit
				option_inst.p_im := l_save_insertmode
				globals_inst.finish_op := l_save_finish_op
			end
		end

	closescript
		do
			free_typebuf
			globals_inst.typebuf.ce_gets (saved_typebuf[globals_inst.curscript])
			fclose (globals_inst.scriptin[globals_inst.curscript]).do_nothing
			globals_inst.scriptin[globals_inst.curscript] := create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
			if globals_inst.curscript > 0 then
				globals_inst.curscript := globals_inst.curscript - 1
			end
		end

	using_script: INTEGER_32
		do
			Result := (((globals_inst.scriptin[globals_inst.curscript]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
		end

	before_blocking
		do
			updatescript (0)
			if globals_inst.may_garbage_collect.to_boolean then
				eval_inst.garbage_collect.do_nothing
			end
		end

	updatescript (a_c: INTEGER_32)
		do
			if a_c.to_boolean then
				if ((globals_inst.scriptout).c_pointer /= default_pointer) then
					IO_putc (a_c, globals_inst.scriptout).do_nothing
				end
			end
			if a_c = 0 then
				memline_inst.ml_sync_all ((a_c = 0).to_integer, 1)
				count___0 := 0
			elseif option_inst.p_uc > 0 then
				count___0 := count___0 + 1
				if count___0.to_integer_32 >= option_inst.p_uc then
					memline_inst.ml_sync_all ((a_c = 0).to_integer, 1)
					count___0 := 0
				end
			end
		end

	vgetc: INTEGER_32
		local
			l_c: INTEGER_32
			l_c2: INTEGER_32
			l_n: INTEGER_32
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_i___0: INTEGER_32
			l_save_allow_keys: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___6.make (<<21>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if globals_inst.may_garbage_collect.to_boolean then
						if globals_inst.want_garbage_collect.to_boolean then
							eval_inst.garbage_collect.do_nothing
						end
					end
					if old_char = -1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_c := old_char
						old_char := -1
						globals_inst.mod_mask := old_mod_mask
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 3 then -- else:
						globals_inst.mod_mask := 0
						last_recorded_len := 0
				when 4 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 47 -- skip loop
						end
				when 5 then -- loop body:
						js.reset
						if globals_inst.mod_mask.to_boolean then
							globals_inst.no_mapping := globals_inst.no_mapping + 1
							globals_inst.allow_keys := globals_inst.allow_keys + 1
						end
						l_c := vgetorpeek (1)
						if globals_inst.mod_mask.to_boolean then
							globals_inst.no_mapping := globals_inst.no_mapping - 1
							globals_inst.allow_keys := globals_inst.allow_keys - 1
						end
						if l_c /= 128 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if l_c /= 155 then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						l_save_allow_keys := globals_inst.allow_keys
						globals_inst.no_mapping := globals_inst.no_mapping + 1
						globals_inst.allow_keys := 0
						l_c2 := vgetorpeek (1)
						l_c := vgetorpeek (1)
						globals_inst.no_mapping := globals_inst.no_mapping - 1
						globals_inst.allow_keys := l_save_allow_keys
						if l_c2 = 252 then
							globals_inst.mod_mask := l_c
							js.continue
						end
						if not js.loop_jumped then
							if l_c2 = 254 then
								l_c := 128
							else
								if l_c2 = 255 then
									l_tmp := -(255 + ((88).bit_shift_left (8)))
								else
									l_tmp := -(l_c2 + ((l_c).bit_shift_left (8)))
								end
								l_c := l_tmp
							end
							if l_c = -(107 + ((59).bit_shift_left (8))) then
								if ((gui_inst.gui.menubar).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									gtk_menu_shell_select_first (create {CE_POINTER [SD_GTKMENUSHELL]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.menubar), (gtk_menu_shell_get_type)))), 0)
									js.continue
								end
							end
						end
						if not js.loop_jumped then
							if l_c = -(253 + ((98).bit_shift_left (8))) then
								ui_inst.ui_focus_change ((l_c = -(253 + ((98).bit_shift_left (8)))).to_integer)
								l_c := -(253 + ((53).bit_shift_left (8)))
							elseif l_c = -(253 + ((99).bit_shift_left (8))) then
								ui_inst.ui_focus_change ((l_c = -(253 + ((98).bit_shift_left (8)))).to_integer)
								l_c := -(253 + ((53).bit_shift_left (8)))
							end
							if l_c = -(253 + ((81).bit_shift_left (8))) then
								l_c := 155
							end
						end
				when 10 then -- if done
						if js.loop_jumped then
							l_pos := -1 + 46 -- skip if block
						end
				when 11 then -- if:
						inspect l_c -- switch 1 head
						when -13899 then l_pos := -1 + 12
						when -14155 then l_pos := -1 + 13
						when -14411 then l_pos := -1 + 14
						when -14667 then l_pos := -1 + 15
						when -16715 then l_pos := -1 + 16
						when -16971 then l_pos := -1 + 17
						when -17227 then l_pos := -1 + 18
						when -17483 then l_pos := -1 + 19
						when -17739 then l_pos := -1 + 20
						when -17995 then l_pos := -1 + 21
						when -18251 then l_pos := -1 + 22
						when -18507 then l_pos := -1 + 23
						when -18763 then l_pos := -1 + 24
						when -19019 then l_pos := -1 + 25
						when -19275 then l_pos := -1 + 26
						when -19531 then l_pos := -1 + 27
						when -16381 then l_pos := -1 + 28
						when -16637 then l_pos := -1 + 28
						when -15869 then l_pos := -1 + 29
						when -16125 then l_pos := -1 + 29
						when -16893 then l_pos := -1 + 30
						when -17149 then l_pos := -1 + 31
						when -17405 then l_pos := -1 + 32
						when -17661 then l_pos := -1 + 33
						else l_pos := -1 + 34
						end
				when 12 then -- switch 1, case -(75 + (54 << 8))
						l_c := ('+').code
						l_pos := -1 + 34 -- switch 1; break
				when 13 then -- switch 1, case -(75 + (55 << 8))
						l_c := ('-').code
						l_pos := -1 + 34 -- switch 1; break
				when 14 then -- switch 1, case -(75 + (56 << 8))
						l_c := ('/').code
						l_pos := -1 + 34 -- switch 1; break
				when 15 then -- switch 1, case -(75 + (57 << 8))
						l_c := ('*').code
						l_pos := -1 + 34 -- switch 1; break
				when 16 then -- switch 1, case -(75 + (65 << 8))
						l_c := ('%R').code
						l_pos := -1 + 34 -- switch 1; break
				when 17 then -- switch 1, case -(75 + (66 << 8))
						l_c := ('.').code
						l_pos := -1 + 34 -- switch 1; break
				when 18 then -- switch 1, case -(75 + (67 << 8))
						l_c := ('0').code
						l_pos := -1 + 34 -- switch 1; break
				when 19 then -- switch 1, case -(75 + (68 << 8))
						l_c := ('1').code
						l_pos := -1 + 34 -- switch 1; break
				when 20 then -- switch 1, case -(75 + (69 << 8))
						l_c := ('2').code
						l_pos := -1 + 34 -- switch 1; break
				when 21 then -- switch 1, case -(75 + (70 << 8))
						l_c := ('3').code
						l_pos := -1 + 34 -- switch 1; break
				when 22 then -- switch 1, case -(75 + (71 << 8))
						l_c := ('4').code
						l_pos := -1 + 34 -- switch 1; break
				when 23 then -- switch 1, case -(75 + (72 << 8))
						l_c := ('5').code
						l_pos := -1 + 34 -- switch 1; break
				when 24 then -- switch 1, case -(75 + (73 << 8))
						l_c := ('6').code
						l_pos := -1 + 34 -- switch 1; break
				when 25 then -- switch 1, case -(75 + (74 << 8))
						l_c := ('7').code
						l_pos := -1 + 34 -- switch 1; break
				when 26 then -- switch 1, case -(75 + (75 << 8))
						l_c := ('8').code
						l_pos := -1 + 34 -- switch 1; break
				when 27 then -- switch 1, case -(75 + (76 << 8))
						l_c := ('9').code
						l_pos := -1 + 34 -- switch 1; break
				when 28 then -- switch 1, case -(253 + (63 << 8)) | switch 1, case -(253 + (64 << 8))
						if globals_inst.mod_mask = 2 then
							l_c := -(35 + ((50).bit_shift_left (8)))
							globals_inst.mod_mask := 0
						elseif globals_inst.mod_mask = 4 then
							l_c := -(253 + ((87).bit_shift_left (8)))
							globals_inst.mod_mask := 0
						else
							l_c := -(107 + ((104).bit_shift_left (8)))
						end
						l_pos := -1 + 34 -- switch 1; break
				when 29 then -- switch 1, case -(253 + (61 << 8)) | switch 1, case -(253 + (62 << 8))
						if globals_inst.mod_mask = 2 then
							l_c := -(42 + ((55).bit_shift_left (8)))
							globals_inst.mod_mask := 0
						elseif globals_inst.mod_mask = 4 then
							l_c := -(253 + ((88).bit_shift_left (8)))
							globals_inst.mod_mask := 0
						else
							l_c := -(64 + ((55).bit_shift_left (8)))
						end
						l_pos := -1 + 34 -- switch 1; break
				when 30 then -- switch 1, case -(253 + (65 << 8))
						l_c := -(107 + ((117).bit_shift_left (8)))
						l_pos := -1 + 34 -- switch 1; break
				when 31 then -- switch 1, case -(253 + (66 << 8))
						l_c := -(107 + ((100).bit_shift_left (8)))
						l_pos := -1 + 34 -- switch 1; break
				when 32 then -- switch 1, case -(253 + (67 << 8))
						l_c := -(107 + ((108).bit_shift_left (8)))
						l_pos := -1 + 34 -- switch 1; break
				when 33 then -- switch 1, case -(253 + (68 << 8))
						l_c := -(107 + ((114).bit_shift_left (8)))
						l_pos := -1 + 34 -- switch 1; break
				when 34 then -- switch 1, done:
						if not (globals_inst.has_mbyte.to_boolean) then
							l_pos := -1 + 45 -- skip if block
						end
				when 35 then -- if:
						if l_c < 0 then
							l_n := 1
						elseif l_c > 255 then
							l_n := 1
						else
							l_n := (globals_inst.mb_bytelen_tab[l_c]).to_integer_32
						end
						if not (l_n > 1) then
							l_pos := -1 + 45 -- skip if block
						end
				when 36 then -- if:
						globals_inst.no_mapping := globals_inst.no_mapping + 1
						l_buf___6[0] := l_c.to_natural_8
						l_i___0 := 1
				when 37 then -- loop condition:
						if not (l_i___0 < l_n) then
							l_pos := -1 + 44 -- skip loop
						end
				when 38 then -- loop body:
						l_buf___6[l_i___0] := (vgetorpeek (1)).to_natural_8
						if (l_buf___6[l_i___0]).to_integer_32 /= 128 then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						l_pos := -1 + 42 -- goto _L___0
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 41 then -- else:
						if (l_buf___6[l_i___0]).to_integer_32 /= 155 then
							l_pos := -1 + 43 -- skip if block
						end
				when 42 then -- if: | _L___0:
						l_c := vgetorpeek (1)
						if (vgetorpeek (1)) = 81 then
							if l_c = 253 then
								l_buf___6[l_i___0] := (155).to_natural_8
							end
						end
				when 43 then -- if done
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 37 -- back to loop condition
				when 44 then -- loop done
						globals_inst.no_mapping := globals_inst.no_mapping - 1
						l_c := globals_inst.mb_ptr2char.integer_32_item ([l_buf___6])
				when 45 then -- if done | if done
						js.break
				when 46 then -- if done
						if not js.loop_left then
							
						end
						l_pos := -1 + 4 -- back to loop condition
				when 47 then -- loop done
						js.reset
				when 48 then -- if done
					globals_inst.may_garbage_collect := 0
					Result := l_c
				when 49 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	safe_vgetc: INTEGER_32
		local
			l_c: INTEGER_32
		do
			l_c := vgetc
			if l_c = 0 then
				l_c := misc1_inst.get_keystroke
			end
			Result := l_c
		end

	plain_vgetc: INTEGER_32
		local
			l_c: INTEGER_32
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				l_c := safe_vgetc
				if l_c /= -(253 + ((53).bit_shift_left (8))) then
					if l_c /= -(249 + ((88).bit_shift_left (8))) then
						if l_c /= -(248 + ((88).bit_shift_left (8))) then
							js.break
						end
					end
				end
			end
			js.reset
			Result := l_c
		end

	vpeekc: INTEGER_32
		local
			js: JUMP_STATE
		do
			if old_char /= -1 then
				Result := old_char
				js.return
			end
			if not js.return_called then
				Result := (vgetorpeek (0))
			end
		end

	vpeekc_nomap: INTEGER_32
		local
			l_c: INTEGER_32
		do
			globals_inst.no_mapping := globals_inst.no_mapping + 1
			globals_inst.allow_keys := globals_inst.allow_keys + 1
			l_c := vpeekc
			globals_inst.no_mapping := globals_inst.no_mapping - 1
			globals_inst.allow_keys := globals_inst.allow_keys - 1
			Result := l_c
		end

	vpeekc_any: INTEGER_32
		local
			l_c: INTEGER_32
		do
			l_c := vpeekc
			if l_c = 0 then
				if globals_inst.typebuf.tb_len > 0 then
					l_c := ('%/27/').code
				end
			end
			Result := l_c
		end

	char_avail: INTEGER_32
		local
			l_retval: INTEGER_32
		do
			globals_inst.no_mapping := globals_inst.no_mapping + 1
			l_retval := vpeekc
			globals_inst.no_mapping := globals_inst.no_mapping - 1
			Result := (l_retval /= 0).to_integer
		end

	vungetc (a_c: INTEGER_32)
		do
			old_char := a_c
			old_mod_mask := globals_inst.mod_mask
		end

	vgetorpeek (a_advance: INTEGER_32): INTEGER_32
		local
			l_c: INTEGER_32
			l_c1: INTEGER_32
			l_keylen: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_mp: CE_POINTER [PD_MAPBLOCK]
			l_mp2: CE_POINTER [PD_MAPBLOCK]
			l_mp_match: CE_POINTER [PD_MAPBLOCK]
			l_mp_match_len: INTEGER_32
			l_timedout: INTEGER_32
			l_mapdepth: INTEGER_32
			l_mode_deleted: INTEGER_32
			l_local_State: INTEGER_32
			l_mlen: INTEGER_32
			l_max_mlen: INTEGER_32
			l_i___0: INTEGER_32
			l_new_wcol: INTEGER_32
			l_new_wrow: INTEGER_32
			l_idx: INTEGER_32
			l_shape_changed: INTEGER_32
			l_n: INTEGER_32
			l_old_wcol: INTEGER_32
			l_old_wrow: INTEGER_32
			l_wait_tb_len: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_save_keylen: INTEGER_32
			l_save_m_expr: INTEGER_32
			l_save_m_noremap: INTEGER_32
			l_save_m_silent: INTEGER_32
			l_save_m_keys: CE_POINTER [NATURAL_8]
			l_save_m_str: CE_POINTER [NATURAL_8]
			l_tabuf: PD_TASAVE_T
			l_save_vgetc_busy: INTEGER_32
			l_noremap: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___7: INTEGER_32
			l_col: INTEGER_32
			l_vcol: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_save_State: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_tmp___19: INTEGER_32
			l_tmp___20: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_mp.make
			create l_mp2.make
			create l_mp_match.make
			create l_tmp___2.make
			create l_save_m_keys.make
			create l_save_m_str.make
			create l_tabuf.make
			create l_tmp___5.make
			create l_ptr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_mp_match_len := 0
					l_timedout := 0
					l_mapdepth := 0
					l_mode_deleted := 0
					l_shape_changed := 0
					if globals_inst.vgetc_busy > 0 then
						if globals_inst.ex_normal_busy = 0 then
							Result := (('%/0/').code)
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 149 -- skip if block
					end
				when 1 then -- if:
						l_local_State := misc2_inst.get_real_state
						globals_inst.vgetc_busy := globals_inst.vgetc_busy + 1
						if a_advance.to_boolean then
							globals_inst.KeyStuffed := 0
						end
						init_typebuf
						start_stuff
						if a_advance.to_boolean then
							if globals_inst.typebuf.tb_maplen = 0 then
								globals_inst.Exec_reg := 0
							end
						end
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 140 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if typeahead_char /= 0 then
							l_c := typeahead_char
							if a_advance.to_boolean then
								typeahead_char := 0
							end
						else
							l_c := read_stuff (a_advance)
						end
						if l_c = 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if not globals_inst.got_int.to_boolean then
							if a_advance.to_boolean then
								globals_inst.KeyStuffed := 1
							end
							if globals_inst.typebuf.tb_no_abbr_cnt = 0 then
								globals_inst.typebuf.tb_no_abbr_cnt := 1
							end
						else
							l_pos := -1 + 6 -- goto _L___16
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 139
				when 6 then -- else: | _L___16:
						if js.loop_left then
							l_pos := -1 + 138 -- skip loop
						end
				when 7 then -- loop body:
						js.reset
						if (globals_inst.typebuf.tb_maplen).to_boolean then
							misc1_inst.line_breakcheck
						else
							ui_inst.ui_breakcheck
						end
						l_keylen := 0
						if not (globals_inst.got_int.to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 8 then -- if:
						l_c := inchar (globals_inst.typebuf.tb_buf, globals_inst.typebuf.tb_buflen - 1, 0, globals_inst.typebuf.tb_change_cnt)
						if not (l_c.to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 11 then -- else:
						if not ((globals_inst.typebuf.tb_maplen).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if: | _L:
						if ((globals_inst.State).bit_and (24)).to_boolean then
							l_c := ('%/27/').code
						else
							l_c := 3
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						l_c := 3
				when 15 then -- if done
						flush_buffers (1)
						if a_advance.to_boolean then
							(globals_inst.typebuf.tb_buf).item := l_c.to_natural_8
							gotchars (globals_inst.typebuf.tb_buf, 1)
						end
						globals_inst.cmd_silent := 0
						js.break
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 87
				when 17 then -- else:
						if not (globals_inst.typebuf.tb_len > 0) then
							l_pos := -1 + 87 -- skip if block
						end
				when 18 then -- if:
						l_mp.ce_gets (create {CE_POINTER [PD_MAPBLOCK]}.make_shared (default_pointer))
						l_max_mlen := 0
						l_c1 := (globals_inst.typebuf.tb_buf[globals_inst.typebuf.tb_off]).to_integer_32
						if globals_inst.no_mapping /= 0 then
							l_pos := -1 + 63 -- skip if block
						end
				when 19 then -- if:
						if not (maphash_valid.to_boolean) then
							l_pos := -1 + 63 -- skip if block
						end
				when 20 then -- if:
						if globals_inst.no_zero_mapping /= 0 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 24 -- goto _L___8
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 63
				when 23 then -- else:
						if l_c1 = 48 then
							l_pos := -1 + 63 -- skip if block
						end
				when 24 then -- if: | _L___8:
						if globals_inst.typebuf.tb_maplen /= 0 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 29 -- goto _L___7
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 63
				when 27 then -- else:
						if not (option_inst.p_remap.to_boolean) then
							l_pos := -1 + 63 -- skip if block
						end
				when 28 then -- if:
						if (((globals_inst.typebuf.tb_noremap[globals_inst.typebuf.tb_off]).to_integer_32).bit_and (5)) /= 0 then
							l_pos := -1 + 63 -- skip if block
						end
				when 29 then -- if: | _L___7:
						if not (option_inst.p_paste.to_boolean) then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						if not ((globals_inst.State).bit_and (24)).to_boolean then
							l_pos := -1 + 32 -- goto _L___6
						end
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 63
				when 32 then -- else: | _L___6:
						if globals_inst.State /= 513 then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						if l_c1 /= 13 then
							if l_c1 /= 32 then
								l_pos := -1 + 35 -- goto _L___5
							end
						end
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 63
				when 35 then -- else: | _L___5:
						if globals_inst.State = 768 then
							l_pos := -1 + 63 -- skip if block
						end
				when 36 then -- if:
						if globals_inst.State = 2048 then
							l_pos := -1 + 63 -- skip if block
						end
				when 37 then -- if:
						if globals_inst.ctrl_x_mode = 0 then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						if not (edit_inst.vim_is_ctrl_x_key (l_c1)).to_boolean then
							l_pos := -1 + 40 -- goto _L___4
						end
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 63
				when 40 then -- else: | _L___4:
						if not (((globals_inst.compl_cont_status).bit_and (32)).to_boolean) then
							l_pos := -1 + 43 -- skip if block
						end
				when 41 then -- if:
						if l_c1 /= 14 then
							if l_c1 /= 16 then
								l_pos := -1 + 43 -- goto _L___3
							end
						end
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 63
				when 43 then -- else: | _L___3:
						if ((l_local_State).bit_and (4103)).to_boolean then
							l_tmp := l_c1
						else
							l_tmp := (l_c1).bit_xor (128)
						end
						l_mp.ce_gets (globals_inst.curbuf.item.b_maphash[l_tmp])
						if ((l_local_State).bit_and (4103)).to_boolean then
							l_tmp___0 := l_c1
						else
							l_tmp___0 := (l_c1).bit_xor (128)
						end
						l_mp2.ce_gets (maphash[l_tmp___0])
						if (l_mp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_mp.ce_gets (l_mp2)
							l_mp2.ce_gets (create {CE_POINTER [PD_MAPBLOCK]}.make_shared (default_pointer))
						end
						l_mp_match.ce_gets (create {CE_POINTER [PD_MAPBLOCK]}.make_shared (default_pointer))
						l_mp_match_len := 0
				when 44 then -- loop condition:
						if not (not js.loop_left and then ((l_mp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32)) then
							l_pos := -1 + 62 -- skip loop
						end
				when 45 then -- loop body:
						js.reset
						if (l_mp.item.m_keys[0]).to_integer_32 /= l_c1 then
							l_pos := -1 + 61 -- skip if block
						end
				when 46 then -- if:
						if not (((l_mp.item.m_mode).bit_and (l_local_State)).to_boolean) then
							l_pos := -1 + 61 -- skip if block
						end
				when 47 then -- if:
						if ((l_mp.item.m_mode).bit_and (32)) /= 0 then
							l_pos := -1 + 50 -- skip if block
						end
				when 48 then -- if:
						l_pos := -1 + 51 -- goto _L___2
				when 49 then -- if block done, skip else block:
						l_pos := -1 + 61
				when 50 then -- else:
						if globals_inst.typebuf.tb_maplen /= 0 then
							l_pos := -1 + 61 -- skip if block
						end
				when 51 then -- if: | _L___2:
						l_mlen := 1
						from
						until
							not (not js.loop_left and then (l_mlen < globals_inst.typebuf.tb_len))
						loop
							js.reset
							if (l_mp.item.m_keys[l_mlen]).to_integer_32 /= (globals_inst.typebuf.tb_buf[(globals_inst.typebuf.tb_off + l_mlen)]).to_integer_32 then
								js.break
							end
							if not js.loop_jumped then
								l_mlen := l_mlen + 1
							end
						end
						js.reset
						if globals_inst.has_mbyte.to_boolean then
							if (globals_inst.mb_bytelen_tab[l_c1]).to_integer_32 > (globals_inst.mb_ptr2len.integer_32_item ([l_mp.item.m_keys])) then
								l_mlen := 0
							end
						end
						l_keylen := l_mp.item.m_keylen
						if l_mlen /= l_keylen then
							l_pos := -1 + 54 -- skip if block
						end
				when 52 then -- if:
						l_pos := -1 + 56 -- goto _L___0
				when 53 then -- if block done, skip else block:
						l_pos := -1 + 61
				when 54 then -- else:
						if l_mlen /= globals_inst.typebuf.tb_len then
							l_pos := -1 + 60 -- skip if block
						end
				when 55 then -- if:
						if not (globals_inst.typebuf.tb_len < l_keylen) then
							l_pos := -1 + 58 -- skip if block
						end
				when 56 then -- if: | _L___0:
						l_s.ce_gets (globals_inst.typebuf.tb_noremap + globals_inst.typebuf.tb_off)
						if (l_s.item).to_integer_32 = 2 then
							if (l_mp.item.m_keys[0]).to_integer_32 /= 128 then
								js.continue
							elseif (l_mp.item.m_keys[1]).to_integer_32 /= 253 then
								js.continue
							elseif (l_mp.item.m_keys[2]).to_integer_32 /= 82 then
								js.continue
							end
						end
						if not js.loop_jumped then
							l_n := l_mlen
							from
							until
								js.loop_left
							loop
								js.reset
								l_n := l_n - 1
								if not (l_n >= 0) then
									js.break
								end
								if not js.loop_jumped then
									l_tmp___2.ce_gets (l_s)
									l_s.ce_gets (l_s + 1)
									if (((l_tmp___2.item).to_integer_32).bit_and (5)).to_boolean then
										js.break
									end
								end
							end
							js.reset
							if l_n >= 0 then
								js.continue
							end
						end
						if not js.loop_jumped then
							if l_keylen > globals_inst.typebuf.tb_len then
								if not l_timedout.to_boolean then
									l_keylen := -2
									js.break
								end
							elseif l_keylen > l_mp_match_len then
								l_mp_match.ce_gets (l_mp)
								l_mp_match_len := l_keylen
							end
						end
				when 57 then -- if block done, skip else block:
						l_pos := -1 + 59
				when 58 then -- else:
						l_pos := -1 + 60 -- goto _L___1
				when 59 then -- if done | if block done, skip else block:
						l_pos := -1 + 61
				when 60 then -- else: | _L___1:
						if l_max_mlen < l_mlen then
							l_max_mlen := l_mlen
						end
				when 61 then -- if done | if done | if done | if done | if done
						if not js.loop_left then
							if ((l_mp.item.m_next).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_mp.ce_gets (l_mp2)
								l_mp2.ce_gets (create {CE_POINTER [PD_MAPBLOCK]}.make_shared (default_pointer))
							else
								l_mp.ce_gets (l_mp.item.m_next)
							end
						end
						l_pos := -1 + 44 -- back to loop condition
				when 62 then -- loop done
						js.reset
						if l_keylen /= -2 then
							l_mp.ce_gets (l_mp_match)
							l_keylen := l_mp_match_len
						end
				when 63 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
						if (option_inst.p_pt.item).to_integer_32 /= 0 then
							if (l_mp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								if ((globals_inst.State).bit_and (17)).to_boolean then
									l_mlen := 0
									from
									until
										js.loop_left
									loop
										js.reset
										if l_mlen < globals_inst.typebuf.tb_len then
											if not (option_inst.p_pt[l_mlen]).to_boolean then
												js.break
											end
										else
											js.break
										end
										if not js.loop_jumped and then ((option_inst.p_pt[l_mlen]).to_integer_32 /= (globals_inst.typebuf.tb_buf[(globals_inst.typebuf.tb_off + l_mlen)]).to_integer_32) then
											js.break
										end
										if not js.loop_jumped then
											l_mlen := l_mlen + 1
										end
									end
									js.reset
									if (option_inst.p_pt[l_mlen]).to_integer_32 = 0 then
										if l_mlen > globals_inst.typebuf.tb_maplen then
											gotchars ((globals_inst.typebuf.tb_buf + globals_inst.typebuf.tb_off) + globals_inst.typebuf.tb_maplen, l_mlen - globals_inst.typebuf.tb_maplen)
										end
										del_typebuf (l_mlen, 0)
										option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("paste")), (not option_inst.p_paste.to_boolean).to_integer, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0)
										if not ((globals_inst.State).bit_and (16)).to_boolean then
											globals_inst.msg_col := 0
											globals_inst.msg_row := (globals_inst.Rows - 1).to_integer_32
											message_inst.msg_clr_eos
										end
										screen_inst.showmode.do_nothing
										screen_inst.setcursor
										js.continue
									end
									if not js.loop_jumped then
										if l_mlen = globals_inst.typebuf.tb_len then
											l_keylen := -1
										elseif l_max_mlen < l_mlen then
											l_max_mlen := l_mlen + 1
										end
									end
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 86 -- skip if block
						end
				when 64 then -- if:
						if (l_mp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 67 -- skip if block
						end
				when 65 then -- if:
						l_pos := -1 + 68 -- goto _L___11
				when 66 then -- if block done, skip else block:
						l_pos := -1 + 86
				when 67 then -- else:
						if not (l_max_mlen >= l_mp_match_len) then
							l_pos := -1 + 86 -- skip if block
						end
				when 68 then -- if: | _L___11:
						if l_keylen = -2 then
							l_pos := -1 + 86 -- skip if block
						end
				when 69 then -- if:
						l_save_keylen := l_keylen
						if globals_inst.no_mapping /= 0 then
							l_pos := -1 + 72 -- skip if block
						end
				when 70 then -- if:
						l_pos := -1 + 73 -- goto _L___10
				when 71 then -- if block done, skip else block:
						l_pos := -1 + 85
				when 72 then -- else:
						if globals_inst.allow_keys = 0 then
							l_pos := -1 + 84 -- skip if block
						end
				when 73 then -- if: | _L___10:
						if globals_inst.typebuf.tb_maplen /= 0 then
							l_pos := -1 + 76 -- skip if block
						end
				when 74 then -- if:
						l_pos := -1 + 78 -- goto _L___9
				when 75 then -- if block done, skip else block:
						l_pos := -1 + 83
				when 76 then -- else:
						if not (option_inst.p_remap.to_boolean) then
							l_pos := -1 + 82 -- skip if block
						end
				when 77 then -- if:
						if (globals_inst.typebuf.tb_noremap[globals_inst.typebuf.tb_off]).to_integer_32 /= 0 then
							l_pos := -1 + 80 -- skip if block
						end
				when 78 then -- if: | _L___9:
						if not l_timedout.to_boolean then
							l_keylen := term_inst.check_termcode (l_max_mlen + 1, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0)
							if l_keylen = 0 then
								if l_save_keylen = -1 then
									l_keylen := -1
								end
							end
							if l_keylen < 0 then
								if globals_inst.typebuf.tb_len = globals_inst.typebuf.tb_maplen then
									l_keylen := 0
								end
							end
						else
							l_keylen := 0
						end
				when 79 then -- if block done, skip else block:
						l_pos := -1 + 81
				when 80 then -- else:
						l_keylen := 0
				when 81 then -- if done | if block done, skip else block:
						l_pos := -1 + 83
				when 82 then -- else:
						l_keylen := 0
				when 83 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 85
				when 84 then -- else:
						l_keylen := 0
				when 85 then -- if done
						if l_keylen = 0 then
							if (l_mp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_c := ((globals_inst.typebuf.tb_buf[globals_inst.typebuf.tb_off]).to_integer_32).bit_and (255)
								if a_advance.to_boolean then
									globals_inst.cmd_silent := (globals_inst.typebuf.tb_silent > 0).to_integer
									if globals_inst.typebuf.tb_maplen > 0 then
										globals_inst.KeyTyped := 0
									else
										globals_inst.KeyTyped := 1
										gotchars (globals_inst.typebuf.tb_buf + globals_inst.typebuf.tb_off, 1)
									end
									KeyNoremap := (globals_inst.typebuf.tb_noremap[globals_inst.typebuf.tb_off]).to_integer_32
									del_typebuf (1, 0)
								end
								js.break
							end
						end
						if not js.loop_jumped and then (l_keylen > 0) then
							if (globals_inst.typebuf.tb_buf[globals_inst.typebuf.tb_off]).to_integer_32 = 128 then
								if (globals_inst.typebuf.tb_buf[(globals_inst.typebuf.tb_off + 1)]).to_integer_32 = 250 then
									may_sync_undo
									del_typebuf (3, 0)
									l_idx := menu_inst.get_menu_index (globals_inst.current_menu, l_local_State)
									if l_idx /= -1 then
										if globals_inst.VIsual_active.to_boolean then
											if globals_inst.VIsual_select.to_boolean then
												if ((globals_inst.current_menu.item.modes).bit_and (2)).to_boolean then
													globals_inst.VIsual_select := 0
													ins_typebuf (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/128/%/245/X")), -1, 0, 1, 0).do_nothing
												end
											end
										end
										ins_typebuf (globals_inst.current_menu.item.strings[l_idx], globals_inst.current_menu.item.noremap[l_idx], 0, 1, (globals_inst.current_menu.item.silent[l_idx]).to_integer_32).do_nothing
									end
								end
							end
							js.continue
						end
						if not js.loop_jumped then
							if (l_mp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_keylen := -1
							elseif l_keylen < 0 then
								l_keylen := -1
							else
								l_keylen := l_mp_match_len
							end
						end
				when 86 then -- if done | if done | if done
						if not js.loop_jumped and then (l_keylen >= 0) then
							if l_keylen <= globals_inst.typebuf.tb_len then
								if l_keylen > globals_inst.typebuf.tb_maplen then
									gotchars ((globals_inst.typebuf.tb_buf + globals_inst.typebuf.tb_off) + globals_inst.typebuf.tb_maplen, l_keylen - globals_inst.typebuf.tb_maplen)
								end
								globals_inst.cmd_silent := (globals_inst.typebuf.tb_silent > 0).to_integer
								del_typebuf (l_keylen, 0)
								l_mapdepth := l_mapdepth + 1
								if l_mapdepth.to_integer_32 >= option_inst.p_mmd then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E223: recursive mapping"))))).do_nothing
									if ((globals_inst.State).bit_and (8)).to_boolean then
										ex_getln_inst.redrawcmdline
									else
										screen_inst.setcursor
									end
									flush_buffers (0)
									l_mapdepth := 0
									l_c := -1
									js.break
								end
								if not js.loop_jumped then
									if globals_inst.VIsual_active.to_boolean then
										if globals_inst.VIsual_select.to_boolean then
											if ((l_mp.item.m_mode).bit_and (2)).to_boolean then
												globals_inst.VIsual_select := 0
												ins_typebuf (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/128/%/245/X")), -1, 0, 1, 0).do_nothing
											end
										end
									end
									l_save_m_expr := (l_mp.item.m_expr).to_integer_32
									l_save_m_noremap := l_mp.item.m_noremap
									l_save_m_silent := (l_mp.item.m_silent).to_integer_32
									l_save_m_keys.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
									l_save_m_str.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
									if (l_mp.item.m_expr).to_boolean then
										l_save_vgetc_busy := globals_inst.vgetc_busy
										save_typeahead (l_tabuf.address)
										if (l_tabuf.typebuf_valid).to_boolean then
											globals_inst.vgetc_busy := 0
											l_save_m_keys.ce_gets (misc2_inst.vim_strsave (l_mp.item.m_keys))
											l_save_m_str.ce_gets (misc2_inst.vim_strsave (l_mp.item.m_str))
											l_s.ce_gets (eval_map_expr (l_save_m_str, ('%/0/').code))
											globals_inst.vgetc_busy := l_save_vgetc_busy
										else
											l_s.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
										end
										restore_typeahead (l_tabuf.address)
									else
										l_s.ce_gets (l_mp.item.m_str)
									end
									if (l_s.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										l_i___0 := 0
									else
										if l_save_m_noremap /= 0 then
											l_noremap := l_save_m_noremap
										else
											if (l_save_m_keys.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
												l_tmp___5.ce_gets (l_save_m_keys)
											else
												l_tmp___5.ce_gets (l_mp.item.m_keys)
											end
											if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___5), l_keylen.to_natural_32)) /= 0 then
												l_noremap := 0
											else
												l_noremap := -3
											end
										end
										if globals_inst.cmd_silent.to_boolean then
											l_tmp___7 := 1
										elseif l_save_m_silent.to_boolean then
											l_tmp___7 := 1
										else
											l_tmp___7 := 0
										end
										l_i___0 := ins_typebuf (l_s, l_noremap, 0, 1, l_tmp___7)
										if l_save_m_expr.to_boolean then
											misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_s))
										end
									end
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_save_m_keys))
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_save_m_str))
									if l_i___0 = 0 then
										l_c := -1
										js.break
									end
								end
								if not js.loop_jumped then
									js.continue
								end
							end
						end
				when 87 then -- if done | if done
						if js.loop_jumped then
							l_pos := -1 + 102 -- skip if block
						end
				when 88 then -- if:
						l_c := 0
						l_new_wcol := globals_inst.curwin.item.w_wcol
						l_new_wrow := globals_inst.curwin.item.w_wrow
						if not (a_advance.to_boolean) then
							l_pos := -1 + 101 -- skip if block
						end
				when 89 then -- if:
						if globals_inst.typebuf.tb_len /= 1 then
							l_pos := -1 + 101 -- skip if block
						end
				when 90 then -- if:
						if (globals_inst.typebuf.tb_buf[globals_inst.typebuf.tb_off]).to_integer_32 /= 27 then
							l_pos := -1 + 101 -- skip if block
						end
				when 91 then -- if:
						if globals_inst.no_mapping.to_boolean then
							l_pos := -1 + 101 -- skip if block
						end
				when 92 then -- if:
						if globals_inst.ex_normal_busy /= 0 then
							l_pos := -1 + 101 -- skip if block
						end
				when 93 then -- if:
						if globals_inst.typebuf.tb_maplen /= 0 then
							l_pos := -1 + 101 -- skip if block
						end
				when 94 then -- if:
						if not (((globals_inst.State).bit_and (16)).to_boolean) then
							l_pos := -1 + 101 -- skip if block
						end
				when 95 then -- if:
						if not (option_inst.p_timeout.to_boolean) then
							l_pos := -1 + 98 -- skip if block
						end
				when 96 then -- if:
						l_pos := -1 + 100 -- goto _L___12
				when 97 then -- if block done, skip else block:
						l_pos := -1 + 101
				when 98 then -- else:
						if l_keylen /= -1 then
							l_pos := -1 + 101 -- skip if block
						end
				when 99 then -- if:
						if not (option_inst.p_ttimeout.to_boolean) then
							l_pos := -1 + 101 -- skip if block
						end
				when 100 then -- if: | _L___12:
						l_c := inchar ((globals_inst.typebuf.tb_buf + globals_inst.typebuf.tb_off) + globals_inst.typebuf.tb_len, 3, 25, globals_inst.typebuf.tb_change_cnt)
						if l_c = 0 then
							l_col := 0
							if globals_inst.mode_displayed.to_boolean then
								screen_inst.unshowmode (1)
								l_mode_deleted := 1
							end
							if (gui_inst.gui.in_use).to_boolean then
								l_save_State := globals_inst.State
								globals_inst.State := 1
								gui_inst.gui_update_cursor (1, 0)
								globals_inst.State := l_save_State
								l_shape_changed := 1
							end
							move_inst.validate_cursor
							l_old_wcol := globals_inst.curwin.item.w_wcol
							l_old_wrow := globals_inst.curwin.item.w_wrow
							if globals_inst.curwin.item.w_cursor.col /= 0 then
								if globals_inst.curwin.item.w_wcol > 0 then
									if globals_inst.did_ai.to_boolean then
										l_tmp___8 := 0
										globals_inst.curwin.item.w_wcol := l_tmp___8
										l_vcol := l_tmp___8
										l_col := l_vcol
										l_ptr.ce_gets (memline_inst.ml_get_curline)
										from
										until
											not (l_col < globals_inst.curwin.item.w_cursor.col)
										loop
											if (l_ptr[l_col]).to_integer_32 /= 32 then
												if (l_ptr[l_col]).to_integer_32 /= 9 then
													globals_inst.curwin.item.w_wcol := l_vcol
												end
											end
											l_vcol := l_vcol + (charset_inst.lbr_chartabsize (l_ptr + l_col, l_vcol))
											if globals_inst.has_mbyte.to_boolean then
												l_col := l_col + (globals_inst.mb_ptr2len.integer_32_item ([l_ptr + l_col]))
											else
												l_col := l_col + 1
											end
										end
										globals_inst.curwin.item.w_wrow := globals_inst.curwin.item.w_cline_row + globals_inst.curwin.item.w_wcol // globals_inst.curwin.item.w_width
										globals_inst.curwin.item.w_wcol := globals_inst.curwin.item.w_wcol \\ (globals_inst.curwin.item.w_width)
										globals_inst.curwin.item.w_wcol := globals_inst.curwin.item.w_wcol + (move_inst.curwin_col_off)
										l_col := 0
									else
										globals_inst.curwin.item.w_wcol := (globals_inst.curwin.item.w_wcol) - 1
										l_col := globals_inst.curwin.item.w_cursor.col - 1
									end
								elseif (globals_inst.curwin.item.w_onebuf_opt.wo_wrap).to_boolean then
									if (globals_inst.curwin.item.w_wrow).to_boolean then
										globals_inst.curwin.item.w_wrow := (globals_inst.curwin.item.w_wrow) - 1
										globals_inst.curwin.item.w_wcol := globals_inst.curwin.item.w_width - 1
										l_col := globals_inst.curwin.item.w_cursor.col - 1
									end
								end
								if globals_inst.has_mbyte.to_boolean then
									if l_col > 0 then
										if globals_inst.curwin.item.w_wcol > 0 then
											l_ptr.ce_gets (memline_inst.ml_get_curline)
											l_col := l_col - (globals_inst.mb_head_off.integer_32_item ([l_ptr, l_ptr + l_col]))
											if (globals_inst.mb_ptr2cells.integer_32_item ([l_ptr + l_col])) > 1 then
												globals_inst.curwin.item.w_wcol := (globals_inst.curwin.item.w_wcol) - 1
											end
										end
									end
								end
							end
							screen_inst.setcursor
							term_inst.out_flush
							l_new_wcol := globals_inst.curwin.item.w_wcol
							l_new_wrow := globals_inst.curwin.item.w_wrow
							globals_inst.curwin.item.w_wcol := l_old_wcol
							globals_inst.curwin.item.w_wrow := l_old_wrow
						end
				when 101 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done
						if l_c < 0 then
							js.continue
						end
				when 102 then -- if done
						if not js.loop_jumped then
							globals_inst.typebuf.tb_len := globals_inst.typebuf.tb_len + l_c
							if globals_inst.typebuf.tb_len >= globals_inst.typebuf.tb_maplen + 50 then
								l_timedout := 1
								js.continue
							end
						end
						if not (not js.loop_jumped and then (globals_inst.ex_normal_busy > 0)) then
							l_pos := -1 + 109 -- skip if block
						end
				when 103 then -- if:
						if globals_inst.typebuf.tb_len > 0 then
							l_timedout := 1
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 109 -- skip if block
						end
				when 104 then -- if:
						if not (option_inst.p_im.to_boolean) then
							l_pos := -1 + 107 -- skip if block
						end
				when 105 then -- if:
						if ((globals_inst.State).bit_and (16)).to_boolean then
							l_c := 12
						else
							l_pos := -1 + 107 -- goto _L___13
						end
				when 106 then -- if block done, skip else block:
						l_pos := -1 + 108
				when 107 then -- else: | _L___13:
						if ((globals_inst.State).bit_and (8)).to_boolean then
							l_c := 3
						elseif globals_inst.cmdwin_type > 0 then
							if tc = 27 then
								l_c := 3
							else
								l_c := ('%/27/').code
							end
						else
							l_c := ('%/27/').code
						end
				when 108 then
						tc := l_c
						js.break
				when 109 then -- if done | if done
						if js.loop_jumped then
							l_pos := -1 + 137 -- skip if block
						end
				when 110 then -- if:
						if ((globals_inst.State).bit_and (16)).to_boolean then
							if a_advance.to_boolean then
								if globals_inst.must_redraw /= 0 then
									screen_inst.update_screen (0)
									screen_inst.setcursor
								end
							end
						end
						l_i___0 := 0
						l_c1 := 0
						if not (globals_inst.typebuf.tb_len > 0) then
							l_pos := -1 + 119 -- skip if block
						end
				when 111 then -- if:
						if not (a_advance.to_boolean) then
							l_pos := -1 + 119 -- skip if block
						end
				when 112 then -- if:
						if globals_inst.exmode_active.to_boolean then
							l_pos := -1 + 119 -- skip if block
						end
				when 113 then -- if:
						if not (((globals_inst.State).bit_and (17)).to_boolean) then
							l_pos := -1 + 116 -- skip if block
						end
				when 114 then -- if:
						l_pos := -1 + 117 -- goto _L___14
				when 115 then -- if block done, skip else block:
						l_pos := -1 + 118
				when 116 then -- else:
						if globals_inst.State /= 32 then
							l_pos := -1 + 118 -- skip if block
						end
				when 117 then -- if: | _L___14:
						if globals_inst.State /= 513 then
							if ((globals_inst.State).bit_and (16)).to_boolean then
								if (charset_inst.ptr2cells (((globals_inst.typebuf.tb_buf + globals_inst.typebuf.tb_off) + globals_inst.typebuf.tb_len) - 1)) = 1 then
									edit_inst.edit_putchar ((globals_inst.typebuf.tb_buf[((globals_inst.typebuf.tb_off + globals_inst.typebuf.tb_len) - 1)]).to_integer_32, 0)
									screen_inst.setcursor
									l_c1 := 1
								end
							end
							l_old_wcol := globals_inst.curwin.item.w_wcol
							l_old_wrow := globals_inst.curwin.item.w_wrow
							globals_inst.curwin.item.w_wcol := l_new_wcol
							globals_inst.curwin.item.w_wrow := l_new_wrow
							normal_inst.push_showcmd
							if globals_inst.typebuf.tb_len > 10 then
								l_i___0 := globals_inst.typebuf.tb_len - 10
							end
							from
							until
								not (l_i___0 < globals_inst.typebuf.tb_len)
							loop
								l_tmp___15 := l_i___0
								l_i___0 := l_i___0 + 1
								normal_inst.add_to_showcmd ((globals_inst.typebuf.tb_buf[(globals_inst.typebuf.tb_off + l_tmp___15)]).to_integer_32).do_nothing
							end
							globals_inst.curwin.item.w_wcol := l_old_wcol
							globals_inst.curwin.item.w_wrow := l_old_wrow
						end
				when 118 then -- if done
						if ((globals_inst.State).bit_and (8)).to_boolean then
							if globals_inst.cmdline_star = 0 then
								if (charset_inst.ptr2cells (((globals_inst.typebuf.tb_buf + globals_inst.typebuf.tb_off) + globals_inst.typebuf.tb_len) - 1)) = 1 then
									ex_getln_inst.putcmdline ((globals_inst.typebuf.tb_buf[((globals_inst.typebuf.tb_off + globals_inst.typebuf.tb_len) - 1)]).to_integer_32, 0)
									l_c1 := 1
								end
							end
						end
				when 119 then -- if done | if done | if done
						l_wait_tb_len := globals_inst.typebuf.tb_len
						if a_advance.to_boolean then
							l_pos := -1 + 122 -- skip if block
						end
				when 120 then -- if:
						l_tmp___19 := 0
				when 121 then -- if block done, skip else block:
						l_pos := -1 + 136
				when 122 then -- else:
						if globals_inst.typebuf.tb_len /= 0 then
							l_pos := -1 + 125 -- skip if block
						end
				when 123 then -- if:
						l_tmp___18 := -1
				when 124 then -- if block done, skip else block:
						l_pos := -1 + 135
				when 125 then -- else:
						if not (option_inst.p_timeout.to_boolean) then
							l_pos := -1 + 128 -- skip if block
						end
				when 126 then -- if:
						l_pos := -1 + 130 -- goto _L___15
				when 127 then -- if block done, skip else block:
						l_pos := -1 + 135
				when 128 then -- else:
						if not (option_inst.p_ttimeout.to_boolean) then
							l_pos := -1 + 134 -- skip if block
						end
				when 129 then -- if:
						if l_keylen /= -1 then
							l_pos := -1 + 132 -- skip if block
						end
				when 130 then -- if: | _L___15:
						if l_keylen = -1 then
							if option_inst.p_ttm >= 0 then
								l_tmp___17 := option_inst.p_ttm
							else
								l_tmp___17 := option_inst.p_tm
							end
						else
							l_tmp___17 := option_inst.p_tm
						end
						l_tmp___18 := l_tmp___17
				when 131 then -- if block done, skip else block:
						l_pos := -1 + 133
				when 132 then -- else:
						l_tmp___18 := -1
				when 133 then -- if done | if block done, skip else block:
						l_pos := -1 + 135
				when 134 then -- else:
						l_tmp___18 := -1
				when 135 then -- if done | if done
						l_tmp___19 := l_tmp___18
				when 136 then -- if done
						l_c := inchar ((globals_inst.typebuf.tb_buf + globals_inst.typebuf.tb_off) + globals_inst.typebuf.tb_len, ((globals_inst.typebuf.tb_buflen - globals_inst.typebuf.tb_off) - globals_inst.typebuf.tb_len) - 1, l_tmp___19, globals_inst.typebuf.tb_change_cnt)
						if l_i___0 /= 0 then
							normal_inst.pop_showcmd
						end
						if l_c1 = 1 then
							if ((globals_inst.State).bit_and (16)).to_boolean then
								edit_inst.edit_unputchar
							end
							if ((globals_inst.State).bit_and (8)).to_boolean then
								ex_getln_inst.unputcmdline
							end
							screen_inst.setcursor
						end
						if l_c < 0 then
							js.continue
						end
				when 137 then -- if done
						if not js.loop_jumped then
							if l_c = 0 then
								if not a_advance.to_boolean then
									js.break
								end
								if not js.loop_jumped and then (l_wait_tb_len > 0) then
									l_timedout := 1
									js.continue
								end
							else
								from
								until
									(globals_inst.typebuf.tb_buf[(globals_inst.typebuf.tb_off + globals_inst.typebuf.tb_len)]).to_integer_32 = 0
								loop
									l_tmp___20 := globals_inst.typebuf.tb_len
									globals_inst.typebuf.tb_len := (globals_inst.typebuf.tb_len) + 1
									globals_inst.typebuf.tb_noremap[(globals_inst.typebuf.tb_off + l_tmp___20)] := (0).to_natural_8
								end
								globals_inst.vgetc_im_active := mbyte_inst.im_get_status
							end
						end
						if not js.loop_left then
							
						end
						l_pos := -1 + 6 -- back to loop condition
				when 138 then -- loop done
						js.reset
				when 139 then
						if not (l_c < 0) then
							if a_advance.to_boolean then
								if l_c /= 0 then
									js.break
								end
							else
								js.break
							end
						end
						l_pos := -1 + 2 -- back to loop condition
				when 140 then -- loop done
						js.reset
						if not (a_advance.to_boolean) then
							l_pos := -1 + 148 -- skip if block
						end
				when 141 then -- if:
						if not (option_inst.p_smd.to_boolean) then
							l_pos := -1 + 148 -- skip if block
						end
				when 142 then -- if:
						if globals_inst.msg_silent /= 0 then
							l_pos := -1 + 148 -- skip if block
						end
				when 143 then -- if:
						if not (((globals_inst.State).bit_and (16)).to_boolean) then
							l_pos := -1 + 148 -- skip if block
						end
				when 144 then -- if:
						if l_c /= 27 then
							l_pos := -1 + 147 -- skip if block
						end
				when 145 then -- if:
						if not l_mode_deleted.to_boolean then
							if not globals_inst.no_mapping.to_boolean then
								if globals_inst.mode_displayed.to_boolean then
									if (globals_inst.typebuf.tb_len).to_boolean then
										if not globals_inst.KeyTyped.to_boolean then
											globals_inst.redraw_cmdline := 1
										else
											screen_inst.unshowmode (0)
										end
									else
										screen_inst.unshowmode (0)
									end
								else
									l_pos := -1 + 147 -- goto _L___19
								end
							else
								l_pos := -1 + 147 -- goto _L___19
							end
						else
							l_pos := -1 + 147 -- goto _L___19
						end
				when 146 then -- if block done, skip else block:
						l_pos := -1 + 148
				when 147 then -- else: | _L___19:
						if l_c /= 27 then
							if l_mode_deleted.to_boolean then
								if (globals_inst.typebuf.tb_len).to_boolean then
									if not globals_inst.KeyTyped.to_boolean then
										globals_inst.redraw_cmdline := 1
									else
										screen_inst.showmode.do_nothing
									end
								else
									screen_inst.showmode.do_nothing
								end
							end
						end
				when 148 then -- if done | if done | if done | if done
						if (gui_inst.gui.in_use).to_boolean then
							if l_shape_changed.to_boolean then
								gui_inst.gui_update_cursor (1, 0)
							end
						end
						globals_inst.vgetc_busy := globals_inst.vgetc_busy - 1
						Result := l_c
				when 149 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	inchar (a_buf___6: CE_POINTER [NATURAL_8]; a_maxlen: INTEGER_32; a_wait_time: INTEGER_32; a_tb_change_cnt: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			l_retesc: INTEGER_32
			l_script_char: INTEGER_32
			l_dum: CE_ARRAY [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_dum.make (<<154>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := 0
					l_retesc := 0
					if a_wait_time /= -1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (a_wait_time > 100) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						term_inst.cursor_on
						term_inst.out_flush
						if (gui_inst.gui.in_use).to_boolean then
							gui_inst.gui_update_cursor (0, 0)
							if globals_inst.postponed_mouseshape.to_boolean then
								misc2_inst.update_mouseshape (-1)
							end
						end
				when 5 then -- if done
						if globals_inst.State /= 513 then
							globals_inst.did_outofmem_msg := 0
							globals_inst.did_swapwrite_msg := 0
						end
						globals_inst.undo_off := 0
						l_script_char := -1
				when 6 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 16 -- skip loop
						end
				when 7 then -- loop body:
							js.reset
							if ((globals_inst.scriptin[globals_inst.curscript]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if l_script_char < 0 then
									if globals_inst.ignore_script.to_boolean then
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
							if js.loop_jumped then
								l_pos := -1 + 15 -- skip if block
							end
				when 8 then -- if:
							netbeans_inst.netbeans_parse_messages
							if not (globals_inst.got_int.to_boolean) then
								l_pos := -1 + 11 -- skip if block
							end
				when 9 then -- if:
							l_pos := -1 + 12 -- goto _L___0
				when 10 then -- if block done, skip else block:
							l_pos := -1 + 15
				when 11 then -- else:
							l_script_char := IO_getc (globals_inst.scriptin[globals_inst.curscript])
							if not (l_script_char < 0) then
								l_pos := -1 + 14 -- skip if block
							end
				when 12 then -- if: | _L___0:
							closescript
							if globals_inst.got_int.to_boolean then
								l_retesc := 1
							else
								Result := (-1)
								js.return
							end
				when 13 then -- if block done, skip else block:
							l_pos := -1 + 15
				when 14 then -- else:
							a_buf___6[0] := l_script_char.to_natural_8
							l_len := 1
				when 15 then -- if done | if done
							l_pos := -1 + 6 -- back to loop condition
				when 16 then -- loop done
						js.reset
						if not js.return_called and then (l_script_char < 0) then
							if globals_inst.got_int.to_boolean then
								from
								until
									js.loop_left
								loop
									js.reset
									l_len := ui_inst.ui_inchar (l_dum, 153, 0, 0)
									if l_len = 0 then
										js.break
									elseif l_len = 1 then
										if (l_dum[0]).to_integer_32 = 3 then
											js.break
										end
									end
								end
								js.reset
								Result := l_retesc
								js.return
							end
							if not js.return_called then
								term_inst.out_flush
								l_len := ui_inst.ui_inchar (a_buf___6, a_maxlen // 3, a_wait_time, a_tb_change_cnt)
							end
						end
						if not js.return_called then
							if (typebuf_changed (a_tb_change_cnt)).to_boolean then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							Result := (fix_input_buffer (a_buf___6, l_len, (l_script_char >= 0).to_integer))
						end
				when 17 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	fix_input_buffer (a_buf___6: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_script: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_tmp.make
			create l_tmp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := a_len
					l_p___0.ce_gets (a_buf___6)
					l_i___0 := l_len
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 24 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_i___0 := l_i___0 - 1
						if not (l_i___0 >= 0) then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 23 -- skip if block
						end
				when 3 then -- if:
						if not ((gui_inst.gui.in_use).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (l_p___0[0]).to_integer_32 = 155 then
							if l_i___0 >= 2 then
								l_p___0.ce_gets (l_p___0 + (2))
								l_i___0 := l_i___0 - (2)
							else
								l_pos := -1 + 6 -- goto _L___3
							end
						else
							l_pos := -1 + 6 -- goto _L___3
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 6 then -- else: | _L___3:
						if (gui_inst.gui.in_use).to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if (l_p___0[0]).to_integer_32 = 155 then
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 3)), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 1)), l_i___0.to_natural_32).do_nothing
							l_tmp.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp.item := (128).to_natural_8
							l_tmp___0.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___0.item := (253).to_natural_8
							l_p___0.item := (81).to_natural_8
							l_len := l_len + (2)
						else
							l_pos := -1 + 9 -- goto _L___1
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 9 then -- else: | _L___1:
						if (l_p___0[0]).to_integer_32 /= 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 21 -- goto _L___0
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 12 then -- else:
						if (l_p___0[0]).to_integer_32 /= 128 then
							l_pos := -1 + 22 -- skip if block
						end
				when 13 then -- if:
						if a_script.to_boolean then
							l_pos := -1 + 22 -- skip if block
						end
				when 14 then -- if:
						if not (l_i___0 < 2) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 21 -- goto _L___0
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 17 then -- else:
						if (l_p___0[1]).to_integer_32 = 253 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 21 -- goto _L___0
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 20 then -- else:
						if (l_p___0[2]).to_integer_32 = 96 then
							l_pos := -1 + 22 -- skip if block
						end
				when 21 then -- if: | _L___0:
						memmove (create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 3)), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 1)), l_i___0.to_natural_32).do_nothing
						if (l_p___0[0]).to_integer_32 = 128 then
							l_p___0[2] := (('X').code).to_natural_8
						elseif (l_p___0[0]).to_integer_32 = 0 then
							l_p___0[2] := (('X').code).to_natural_8
						else
							l_p___0[2] := (((((-(l_p___0[0]).to_integer_32).to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 255)).to_natural_8
						end
						if (l_p___0[0]).to_integer_32 = 128 then
							l_p___0[1] := (254).to_natural_8
						else
							if (l_p___0[0]).to_integer_32 = 0 then
								l_tmp___1 := 255
							else
								l_tmp___1 := (-(l_p___0[0]).to_integer_32).bit_and (255)
							end
							l_p___0[1] := l_tmp___1.to_natural_8
						end
						l_p___0[0] := (128).to_natural_8
						l_p___0.ce_gets (l_p___0 + (2))
						l_len := l_len + (2)
				when 22 then -- if done | if done | if done | if done | if done | if done | if done
						l_p___0.ce_gets (l_p___0 + 1)
				when 23 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 24 then -- loop done
					js.reset
					l_p___0.item := (('%/0/').code).to_natural_8
					Result := l_len
				when 25 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	input_available: INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (ui_inst.vim_is_input_buf_empty).to_boolean then
				if globals_inst.typebuf_was_filled.to_boolean then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 1
			end
			Result := l_tmp___0
		end

	do_map (a_maptype: INTEGER_32; a_arg: CE_POINTER [NATURAL_8]; a_mode: INTEGER_32; a_abbrev: INTEGER_32): INTEGER_32
		local
			l_keys___0: CE_POINTER [NATURAL_8]
			l_mp: CE_POINTER [PD_MAPBLOCK]
			l_mpp: CE_POINTER [CE_POINTER [PD_MAPBLOCK]]
			l_rhs: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			l_len: INTEGER_32
			l_newstr: CE_POINTER [NATURAL_8]
			l_hasarg: INTEGER_32
			l_haskey: INTEGER_32
			l_did_it: INTEGER_32
			l_did_local: INTEGER_32
			l_round: INTEGER_32
			l_keys_buf: CE_POINTER [NATURAL_8]
			l_arg_buf: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
			l_do_backslash: INTEGER_32
			l_hash: INTEGER_32
			l_new_hash: INTEGER_32
			l_abbr_table: CE_POINTER [CE_POINTER [PD_MAPBLOCK]]
			l_map_table: CE_POINTER [CE_POINTER [PD_MAPBLOCK]]
			l_unique: INTEGER_32
			l_silent: INTEGER_32
			l_special: INTEGER_32
			l_expr: INTEGER_32
			l_noremap: INTEGER_32
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_first___0: INTEGER_32
			l_last: INTEGER_32
			l_same: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___23: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_keys___0.make
			create l_mp.make
			create l_mpp.make
			create l_rhs.make
			create l_p___0.make
			create l_newstr.make
			create l_keys_buf.make
			create l_arg_buf.make
			create l_abbr_table.make
			create l_map_table.make
			create l_tmp___6.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := 0
					l_did_it := 0
					l_did_local := 0
					l_keys_buf.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_arg_buf.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_retval := 0
					l_unique := 0
					l_silent := 0
					l_special := 0
					l_expr := 0
					l_keys___0.ce_gets (a_arg)
					l_map_table.ce_gets (maphash)
					l_abbr_table.ce_gets (first_abbr.address)
					if a_maptype = 2 then
						l_noremap := -1
					else
						l_noremap := 0
					end
					from
					until
						js.loop_left
					loop
						js.reset
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_keys___0), ce_string ("<buffer>"), (8).to_natural_32)) = 0 then
							l_keys___0.ce_gets (charset_inst.skipwhite (l_keys___0 + 8))
							l_map_table.ce_gets (globals_inst.curbuf.item.b_maphash)
							l_abbr_table.ce_gets (create {CE_POINTER [CE_POINTER [PD_MAPBLOCK]]}.make_shared (globals_inst.curbuf.c_pointer + {PD_FILE_BUFFER}.b_first_abbr_offset))
							js.continue
						end
						if not js.loop_jumped then
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_keys___0), ce_string ("<silent>"), (8).to_natural_32)) = 0 then
								l_keys___0.ce_gets (charset_inst.skipwhite (l_keys___0 + 8))
								l_silent := 1
								js.continue
							end
						end
						if not js.loop_jumped then
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_keys___0), ce_string ("<special>"), (9).to_natural_32)) = 0 then
								l_keys___0.ce_gets (charset_inst.skipwhite (l_keys___0 + 9))
								l_special := 1
								js.continue
							end
						end
						if not js.loop_jumped then
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_keys___0), ce_string ("<script>"), (8).to_natural_32)) = 0 then
								l_keys___0.ce_gets (charset_inst.skipwhite (l_keys___0 + 8))
								l_noremap := -2
								js.continue
							end
						end
						if not js.loop_jumped then
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_keys___0), ce_string ("<expr>"), (6).to_natural_32)) = 0 then
								l_keys___0.ce_gets (charset_inst.skipwhite (l_keys___0 + 6))
								l_expr := 1
								js.continue
							end
						end
						if not js.loop_jumped then
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_keys___0), ce_string ("<unique>"), (8).to_natural_32)) = 0 then
								l_keys___0.ce_gets (charset_inst.skipwhite (l_keys___0 + 8))
								l_unique := 1
								js.continue
							end
						end
						if not js.loop_jumped then
							js.break
						end
						if not js.loop_left then
							
						end
					end
					js.reset
					validate_maphash
					l_p___0.ce_gets (l_keys___0)
					l_do_backslash := (((misc2_inst.vim_strchr (option_inst.p_cpo, ('B').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32).to_integer
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 11 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if (l_p___0.item).to_boolean then
							if a_maptype /= 1 then
								if (l_p___0.item).to_integer_32 = 32 then
									js.break
								elseif (l_p___0.item).to_integer_32 = 9 then
									js.break
								end
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if:
						if (l_p___0[0]).to_integer_32 /= 22 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 6 then -- else:
						if not (l_do_backslash.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if (l_p___0[0]).to_integer_32 /= 92 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if (l_p___0[1]).to_integer_32 /= 0 then
							l_p___0.ce_gets (l_p___0 + 1)
						end
				when 9 then -- if done | if done
						l_p___0.ce_gets (l_p___0 + 1)
				when 10 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 11 then -- loop done
					js.reset
					if (l_p___0.item).to_integer_32 /= 0 then
						l_tmp___6.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_tmp___6.item := (('%/0/').code).to_natural_8
					end
					l_p___0.ce_gets (charset_inst.skipwhite (l_p___0))
					l_rhs.ce_gets (l_p___0)
					l_hasarg := ((l_rhs.item).to_integer_32 /= 0).to_integer
					l_haskey := ((l_keys___0.item).to_integer_32 /= 0).to_integer
					if a_maptype = 1 then
						if not l_haskey.to_boolean then
							l_retval := 1
							l_pos := -1 + 95 -- goto theend
						end
					end
				when 12 then
					if l_haskey.to_boolean then
						l_keys___0.ce_gets (term_inst.replace_termcodes (l_keys___0, l_keys_buf.address, 1, 1, l_special))
					end
					if l_hasarg.to_boolean then
						if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_rhs), ce_string ("<nop>"))) = 0 then
							l_rhs.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
						else
							l_rhs.ce_gets (term_inst.replace_termcodes (l_rhs, l_arg_buf.address, 0, 1, l_special))
						end
					end
					if not (l_haskey.to_boolean) then
						l_pos := -1 + 28 -- skip if block
					end
				when 13 then -- if:
						l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_keys___0))).to_integer_32
						if l_len > 50 then
							l_retval := 1
							l_pos := -1 + 95 -- goto theend
						end
				when 14 then
						if not (a_abbrev.to_boolean) then
							l_pos := -1 + 28 -- skip if block
						end
				when 15 then -- if:
						if a_maptype = 1 then
							l_pos := -1 + 28 -- skip if block
						end
				when 16 then -- if:
						if not (globals_inst.has_mbyte.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_same := -1
						l_first___0 := charset_inst.vim_iswordp (l_keys___0)
						l_last := l_first___0
						l_p___0.ce_gets (l_keys___0 + (globals_inst.mb_ptr2len.integer_32_item ([l_keys___0])))
						l_n := 1
						from
						until
							not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_keys___0 + l_len).c_pointer.to_integer_32).to_natural_32)
						loop
							l_n := l_n + 1
							l_last := charset_inst.vim_iswordp (l_p___0)
							if l_same = -1 then
								if l_last /= l_first___0 then
									l_same := l_n - 1
								end
							end
							l_p___0.ce_gets (l_p___0 + (globals_inst.mb_ptr2len.integer_32_item ([l_p___0])))
						end
						if l_last.to_boolean then
							if l_n > 2 then
								if l_same >= 0 then
									if l_same < l_n - 1 then
										l_retval := 1
										l_pos := -1 + 95 -- goto theend
									end
								end
							end
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 19 then -- else:
						if not ((charset_inst.vim_iswordc ((l_keys___0[(l_len - 1)]).to_integer_32)).to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 20 then -- if:
						l_n := 0
				when 21 then -- loop condition:
						if not (l_n < l_len - 2) then
							l_pos := -1 + 24 -- skip loop
						end
				when 22 then -- loop body:
						l_tmp___11 := charset_inst.vim_iswordc ((l_keys___0[l_n]).to_integer_32)
						if l_tmp___11 /= (charset_inst.vim_iswordc ((l_keys___0[(l_len - 2)]).to_integer_32)) then
							l_retval := 1
							l_pos := -1 + 95 -- goto theend
						end
				when 23 then
						l_n := l_n + 1
						l_pos := -1 + 21 -- back to loop condition
				when 24 then -- loop done | if done
						l_n := 0
				when 25 then -- loop condition:
						if not (l_n < l_len) then
							l_pos := -1 + 28 -- skip loop
						end
				when 26 then -- loop body:
						if (l_keys___0[l_n]).to_integer_32 = 32 then
							l_retval := 1
							l_pos := -1 + 95 -- goto theend
						elseif (l_keys___0[l_n]).to_integer_32 = 9 then
							l_retval := 1
							l_pos := -1 + 95 -- goto theend
						end
				when 27 then
						l_n := l_n + 1
						l_pos := -1 + 25 -- back to loop condition
				when 28 then -- loop done | if done | if done | if done
						if l_haskey.to_boolean then
							if l_hasarg.to_boolean then
								if a_abbrev.to_boolean then
									globals_inst.no_abbr := 0
								end
							end
						end
						if not l_haskey.to_boolean then
							message_inst.msg_start
						elseif a_maptype /= 1 then
							if not l_hasarg.to_boolean then
								message_inst.msg_start
							end
						end
						if (l_map_table.c_pointer.to_integer_32).to_natural_32 /= ((globals_inst.curbuf.item.b_maphash).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 43 -- skip if block
						end
				when 29 then -- if:
							if not (l_haskey.to_boolean) then
								l_pos := -1 + 43 -- skip if block
							end
				when 30 then -- if:
							if not (l_hasarg.to_boolean) then
								l_pos := -1 + 43 -- skip if block
							end
				when 31 then -- if:
							if a_maptype = 1 then
								l_pos := -1 + 43 -- skip if block
							end
				when 32 then -- if:
							l_hash := 0
				when 33 then -- loop condition:
							if js.loop_left then
								l_pos := -1 + 42 -- skip loop
							end
				when 34 then -- loop body:
							js.reset
							if l_hash < 256 then
								if globals_inst.got_int.to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if a_abbrev.to_boolean then
									if l_hash /= 0 then
										js.break
									end
									if not js.loop_jumped then
										l_mp.ce_gets (first_abbr)
									end
								else
									l_mp.ce_gets (maphash[l_hash])
								end
							end
							if js.loop_jumped then
								l_pos := -1 + 41 -- skip if block
							end
				when 35 then -- if: | loop condition:
							if js.loop_left then
								l_pos := -1 + 40 -- skip loop
							end
				when 36 then -- loop body:
							js.reset
							if (l_mp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if globals_inst.got_int.to_boolean then
									js.break
								end
							else
								js.break
							end
							if js.loop_jumped then
								l_pos := -1 + 39 -- skip if block
							end
				when 37 then -- if:
							if ((l_mp.item.m_mode).bit_and (a_mode)) /= 0 then
								if l_mp.item.m_keylen = l_len then
									if l_unique.to_boolean then
										if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_mp.item.m_keys), create {CE_POINTER [INTEGER_8]}.make_cast (l_keys___0), l_len.to_natural_32)) = 0 then
											if a_abbrev.to_boolean then
												message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E224: global abbreviation already exists for %%s")))), l_mp.item.m_keys).do_nothing
											else
												message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E225: global mapping already exists for %%s")))), l_mp.item.m_keys).do_nothing
											end
											l_retval := 5
											l_pos := -1 + 95 -- goto theend
										end
									end
								end
							end
				when 38 then
							l_mp.ce_gets (l_mp.item.m_next)
				when 39 then -- if done
							l_pos := -1 + 35 -- back to loop condition
				when 40 then -- loop done
							js.reset
							l_hash := l_hash + 1
				when 41 then -- if done
							l_pos := -1 + 33 -- back to loop condition
				when 42 then -- loop done
							js.reset
				when 43 then -- if done | if done | if done | if done
							if (l_map_table.c_pointer.to_integer_32).to_natural_32 /= ((globals_inst.curbuf.item.b_maphash).c_pointer.to_integer_32).to_natural_32 then
								if not l_hasarg.to_boolean then
									if a_maptype /= 1 then
										l_hash := 0
										from
										until
											js.loop_left
										loop
											js.reset
											if l_hash < 256 then
												if globals_inst.got_int.to_boolean then
													js.break
												end
											else
												js.break
											end
											if not js.loop_jumped then
												if a_abbrev.to_boolean then
													if l_hash /= 0 then
														js.break
													end
													if not js.loop_jumped then
														l_mp.ce_gets (globals_inst.curbuf.item.b_first_abbr)
													end
												else
													l_mp.ce_gets (globals_inst.curbuf.item.b_maphash[l_hash])
												end
											end
											if not js.loop_jumped then
												from
												until
													js.loop_left
												loop
													js.reset
													if (l_mp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
														if globals_inst.got_int.to_boolean then
															js.break
														end
													else
														js.break
													end
													if not js.loop_jumped then
														if ((l_mp.item.m_mode).bit_and (a_mode)) /= 0 then
															if not l_haskey.to_boolean then
																showmap (l_mp, 1)
																l_did_local := 1
															else
																l_n := l_mp.item.m_keylen
																if l_n < l_len then
																	l_tmp___17 := l_n
																else
																	l_tmp___17 := l_len
																end
																if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_mp.item.m_keys), create {CE_POINTER [INTEGER_8]}.make_cast (l_keys___0), l_tmp___17.to_natural_32)) = 0 then
																	showmap (l_mp, 1)
																	l_did_local := 1
																end
															end
														end
														l_mp.ce_gets (l_mp.item.m_next)
													end
												end
												js.reset
												l_hash := l_hash + 1
											end
										end
										js.reset
									end
								end
							end
							l_round := 0
				when 44 then -- loop condition:
							if js.loop_left then
								l_pos := -1 + 85 -- skip loop
							end
				when 45 then -- loop body:
								js.reset
								if l_round /= 0 then
									l_pos := -1 + 48 -- skip if block
								end
				when 46 then -- if:
								l_pos := -1 + 49 -- goto _L___0
				when 47 then -- if block done, skip else block:
								l_pos := -1 + 52
				when 48 then -- else:
								if a_maptype /= 1 then
									l_pos := -1 + 51 -- skip if block
								end
				when 49 then -- if: | _L___0:
								if l_round <= 1 then
									if not l_did_it.to_boolean then
										if globals_inst.got_int.to_boolean then
											js.break
										end
									else
										js.break
									end
								else
									js.break
								end
				when 50 then -- if block done, skip else block:
								l_pos := -1 + 52
				when 51 then -- else:
								js.break
				when 52 then -- if done
								if js.loop_jumped then
									l_pos := -1 + 84 -- skip if block
								end
				when 53 then -- if:
								l_hash := 0
				when 54 then -- loop condition:
								if js.loop_left then
									l_pos := -1 + 83 -- skip loop
								end
				when 55 then -- loop body:
								js.reset
								if l_hash < 256 then
									if globals_inst.got_int.to_boolean then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									if a_abbrev.to_boolean then
										if l_hash > 0 then
											js.break
										end
										if not js.loop_jumped then
											l_mpp.ce_gets (l_abbr_table)
										end
									else
										l_mpp.ce_gets (l_map_table + l_hash)
									end
								end
								if js.loop_jumped then
									l_pos := -1 + 82 -- skip if block
								end
				when 56 then -- if:
								l_mp.ce_gets (l_mpp.item)
				when 57 then -- loop condition:
								if js.loop_left then
									l_pos := -1 + 81 -- skip loop
								end
				when 58 then -- loop body:
								js.reset
								if (l_mp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if globals_inst.got_int.to_boolean then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped and then (not ((l_mp.item.m_mode).bit_and (a_mode)).to_boolean) then
									l_mpp.ce_gets (create {CE_POINTER [CE_POINTER [PD_MAPBLOCK]]}.make_shared (l_mp.c_pointer + {PD_MAPBLOCK}.m_next_offset))
									js.continue
								end
								if js.loop_jumped then
									l_pos := -1 + 80 -- skip if block
								end
				when 59 then -- if:
								if l_haskey.to_boolean then
									l_pos := -1 + 62 -- skip if block
								end
				when 60 then -- if:
								showmap (l_mp, ((l_map_table.c_pointer.to_integer_32).to_natural_32 /= (maphash.c_pointer.to_integer_32).to_natural_32).to_integer)
								l_did_it := 1
				when 61 then -- if block done, skip else block:
								l_pos := -1 + 80
				when 62 then -- else:
								if l_round.to_boolean then
									l_n := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_mp.item.m_str))).to_integer_32
									l_p___0.ce_gets (l_mp.item.m_str)
								else
									l_n := l_mp.item.m_keylen
									l_p___0.ce_gets (l_mp.item.m_keys)
								end
								if l_n < l_len then
									l_tmp___23 := l_n
								else
									l_tmp___23 := l_len
								end
								if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), create {CE_POINTER [INTEGER_8]}.make_cast (l_keys___0), l_tmp___23.to_natural_32)) /= 0 then
									l_pos := -1 + 80 -- skip if block
								end
				when 63 then -- if:
								if a_maptype /= 1 then
									l_pos := -1 + 66 -- skip if block
								end
				when 64 then -- if:
								if l_n /= l_len then
									if not a_abbrev.to_boolean then
										l_mpp.ce_gets (create {CE_POINTER [CE_POINTER [PD_MAPBLOCK]]}.make_shared (l_mp.c_pointer + {PD_MAPBLOCK}.m_next_offset))
										js.continue
									elseif l_round.to_boolean then
										l_mpp.ce_gets (create {CE_POINTER [CE_POINTER [PD_MAPBLOCK]]}.make_shared (l_mp.c_pointer + {PD_MAPBLOCK}.m_next_offset))
										js.continue
									elseif l_n > l_len then
										l_mpp.ce_gets (create {CE_POINTER [CE_POINTER [PD_MAPBLOCK]]}.make_shared (l_mp.c_pointer + {PD_MAPBLOCK}.m_next_offset))
										js.continue
									elseif ((charset_inst.skipwhite (l_keys___0 + l_n)).item).to_integer_32 /= 0 then
										l_mpp.ce_gets (create {CE_POINTER [CE_POINTER [PD_MAPBLOCK]]}.make_shared (l_mp.c_pointer + {PD_MAPBLOCK}.m_next_offset))
										js.continue
									end
								end
								if not js.loop_jumped then
									l_mp.item.m_mode := (l_mp.item.m_mode).bit_and (((a_mode).bit_not))
									l_did_it := 1
								end
				when 65 then -- if block done, skip else block:
								l_pos := -1 + 79
				when 66 then -- else:
								if l_hasarg.to_boolean then
									l_pos := -1 + 69 -- skip if block
								end
				when 67 then -- if:
								showmap (l_mp, ((l_map_table.c_pointer.to_integer_32).to_natural_32 /= (maphash.c_pointer.to_integer_32).to_natural_32).to_integer)
								l_did_it := 1
				when 68 then -- if block done, skip else block:
								l_pos := -1 + 79
				when 69 then -- else:
								if l_n = l_len then
									l_pos := -1 + 72 -- skip if block
								end
				when 70 then -- if:
								l_mpp.ce_gets (create {CE_POINTER [CE_POINTER [PD_MAPBLOCK]]}.make_shared (l_mp.c_pointer + {PD_MAPBLOCK}.m_next_offset))
								js.continue
				when 71 then -- if block done, skip else block:
								l_pos := -1 + 79
				when 72 then -- else:
								if not (l_unique.to_boolean) then
									l_pos := -1 + 75 -- skip if block
								end
				when 73 then -- if:
								if a_abbrev.to_boolean then
									message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E226: abbreviation already exists for %%s")))), l_p___0).do_nothing
								else
									message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E227: mapping already exists for %%s")))), l_p___0).do_nothing
								end
								l_retval := 5
								l_pos := -1 + 95 -- goto theend
				when 74 then -- if block done, skip else block:
								l_pos := -1 + 79
				when 75 then -- else:
								l_mp.item.m_mode := (l_mp.item.m_mode).bit_and (((a_mode).bit_not))
								if l_mp.item.m_mode /= 0 then
									l_pos := -1 + 79 -- skip if block
								end
				when 76 then -- if:
								if l_did_it.to_boolean then
									l_pos := -1 + 79 -- skip if block
								end
				when 77 then -- if:
								l_newstr.ce_gets (misc2_inst.vim_strsave (l_rhs))
								if (l_newstr.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_retval := 4
									l_pos := -1 + 95 -- goto theend
								end
				when 78 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_mp.item.m_str))
								l_mp.item.m_str := l_newstr
								l_mp.item.m_noremap := l_noremap
								l_mp.item.m_silent := l_silent.to_integer_8
								l_mp.item.m_mode := a_mode
								l_mp.item.m_expr := l_expr.to_integer_8
								l_mp.item.m_script_ID := globals_inst.current_SID
								l_did_it := 1
				when 79 then -- if done | if done | if done | if done | if done
								if not js.loop_jumped and then (l_mp.item.m_mode = 0) then
									map_free (l_mpp)
									js.continue
								end
								if not js.loop_jumped then
									if ((l_mp.item.m_mode).bit_and (4103)).to_boolean then
										l_new_hash := (l_mp.item.m_keys[0]).to_integer_32
									else
										l_new_hash := ((l_mp.item.m_keys[0]).to_integer_32).bit_xor (128)
									end
									if not a_abbrev.to_boolean then
										if l_new_hash /= l_hash then
											l_mpp.item := l_mp.item.m_next
											l_mp.item.m_next := l_map_table[l_new_hash]
											l_map_table[l_new_hash] := l_mp
											js.continue
										end
									end
								end
				when 80 then -- if done | if done | if done
								if not js.loop_jumped then
									l_mpp.ce_gets (create {CE_POINTER [CE_POINTER [PD_MAPBLOCK]]}.make_shared (l_mp.c_pointer + {PD_MAPBLOCK}.m_next_offset))
								end
								if not js.loop_left then
									l_mp.ce_gets (l_mpp.item)
								end
								l_pos := -1 + 57 -- back to loop condition
				when 81 then -- loop done
								js.reset
								l_hash := l_hash + 1
				when 82 then -- if done
								l_pos := -1 + 54 -- back to loop condition
				when 83 then -- loop done
								js.reset
								l_round := l_round + 1
				when 84 then -- if done
								l_pos := -1 + 44 -- back to loop condition
				when 85 then -- loop done
							js.reset
							if a_maptype = 1 then
								if not l_did_it.to_boolean then
									l_retval := 2
								end
								l_pos := -1 + 95 -- goto theend
							end
				when 86 then
							if l_haskey.to_boolean then
								l_pos := -1 + 89 -- skip if block
							end
				when 87 then -- if:
								l_pos := -1 + 90 -- goto _L___1
				when 88 then -- if block done, skip else block:
								l_pos := -1 + 91
				when 89 then -- else:
								if l_hasarg.to_boolean then
									l_pos := -1 + 91 -- skip if block
								end
				when 90 then -- if: | _L___1:
								if not l_did_it.to_boolean then
									if not l_did_local.to_boolean then
										if a_abbrev.to_boolean then
											message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("No abbreviation found"))))).do_nothing
										else
											message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("No mapping found"))))).do_nothing
										end
									end
								end
								l_pos := -1 + 95 -- goto theend
				when 91 then -- if done
								if l_did_it.to_boolean then
									l_pos := -1 + 95 -- goto theend
								end
				when 92 then
								l_mp.ce_gets (create {CE_POINTER [PD_MAPBLOCK]}.make_cast ((misc2_inst.alloc ({PD_MAPBLOCK}.sizeof.to_natural_32))))
								if (l_mp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_retval := 4
									l_pos := -1 + 95 -- goto theend
								end
				when 93 then
								if (l_keys___0.item).to_integer_32 = 3 then
									globals_inst.mapped_ctrl_c := 1
								end
								l_mp.item.m_keys := misc2_inst.vim_strsave (l_keys___0)
								l_mp.item.m_str := misc2_inst.vim_strsave (l_rhs)
								if ((l_mp.item.m_keys).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_mp.item.m_keys))
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_mp.item.m_str))
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_mp))
									l_retval := 4
									l_pos := -1 + 95 -- goto theend
								elseif ((l_mp.item.m_str).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_mp.item.m_keys))
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_mp.item.m_str))
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_mp))
									l_retval := 4
									l_pos := -1 + 95 -- goto theend
								end
				when 94 then
								l_mp.item.m_keylen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_mp.item.m_keys))).to_integer_32
								l_mp.item.m_noremap := l_noremap
								l_mp.item.m_silent := l_silent.to_integer_8
								l_mp.item.m_mode := a_mode
								l_mp.item.m_expr := l_expr.to_integer_8
								l_mp.item.m_script_ID := globals_inst.current_SID
								if a_abbrev.to_boolean then
									l_mp.item.m_next := l_abbr_table.item
									l_abbr_table.item := l_mp
								else
									if ((l_mp.item.m_mode).bit_and (4103)).to_boolean then
										l_n := (l_mp.item.m_keys[0]).to_integer_32
									else
										l_n := ((l_mp.item.m_keys[0]).to_integer_32).bit_xor (128)
									end
									l_mp.item.m_next := l_map_table[l_n]
									l_map_table[l_n] := l_mp
								end
				when 95 then -- theend:
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_keys_buf))
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_arg_buf))
								Result := l_retval
				when 96 then
								l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
					end

	map_free (a_mpp: CE_POINTER [CE_POINTER [PD_MAPBLOCK]])
		local
			l_mp: CE_POINTER [PD_MAPBLOCK]
		do
			create l_mp.make

			l_mp.ce_gets (a_mpp.item)
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_mp.item.m_keys))
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_mp.item.m_str))
			a_mpp.item := l_mp.item.m_next
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_mp))
		end

	validate_maphash
		do
			if not maphash_valid.to_boolean then
				memset (create {CE_POINTER [ANY]}.make_cast (maphash), 0, (Pointer_bytes.to_natural_32 * (256).to_natural_32)).do_nothing
				maphash_valid := 1
			end
		end

	get_map_mode (a_cmdp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_forceit: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_modec: INTEGER_32
			l_mode: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (a_cmdp.item)
					l_tmp.ce_gets (l_p___0)
					l_p___0.ce_gets (l_p___0 + 1)
					l_modec := (l_tmp.item).to_integer_32
					if l_modec /= 105 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_mode := 16
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if l_modec /= 108 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_mode := 32
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if l_modec /= 99 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_mode := 8
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if l_modec /= 110 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if (l_p___0.item).to_integer_32 /= 111 then
							l_mode := 1
						else
							l_pos := -1 + 12 -- goto _L
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						if l_modec = 118 then
							l_mode := 4098
						elseif l_modec = 120 then
							l_mode := 2
						elseif l_modec = 115 then
							l_mode := 4096
						elseif l_modec = 111 then
							l_mode := 4
						else
							l_p___0.ce_gets (l_p___0 - 1)
							if a_forceit.to_boolean then
								l_mode := 24
							else
								l_mode := 4103
							end
						end
				when 13 then -- if done | if done | if done
						a_cmdp.item := l_p___0
						Result := l_mode
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	map_clear (a_cmdp: CE_POINTER [NATURAL_8]; a_arg: CE_POINTER [NATURAL_8]; a_forceit: INTEGER_32; a_abbr: INTEGER_32)
		local
			l_cmdp: CE_POINTER [NATURAL_8]
			l_mode: INTEGER_32
			l_local: INTEGER_32
			js: JUMP_STATE
		do
			create l_cmdp.make

			l_cmdp.ce_gets (a_cmdp)
			l_local := ((strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_arg), ce_string ("<buffer>"))) = 0).to_integer
			if not l_local.to_boolean then
				if (a_arg.item).to_integer_32 /= 0 then
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_invarg))))).do_nothing
					js.return
				end
			end
			if not js.return_called then
				l_mode := get_map_mode (l_cmdp.address, a_forceit)
				map_clear_int (globals_inst.curbuf, l_mode, l_local, a_abbr)
			end
		end

	map_clear_int (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_mode: INTEGER_32; a_local: INTEGER_32; a_abbr: INTEGER_32)
		local
			l_mp: CE_POINTER [PD_MAPBLOCK]
			l_mpp: CE_POINTER [CE_POINTER [PD_MAPBLOCK]]
			l_hash: INTEGER_32
			l_new_hash: INTEGER_32
			js: JUMP_STATE
		do
			create l_mp.make
			create l_mpp.make

			validate_maphash
			l_hash := 0
			from
			until
				not (not js.loop_left and then (l_hash < 256))
			loop
				js.reset
				if a_abbr.to_boolean then
					if l_hash > 0 then
						js.break
					end
					if not js.loop_jumped then
						if a_local.to_boolean then
							l_mpp.ce_gets (create {CE_POINTER [CE_POINTER [PD_MAPBLOCK]]}.make_shared (a_buf___6.c_pointer + {PD_FILE_BUFFER}.b_first_abbr_offset))
						else
							l_mpp.ce_gets (first_abbr.address)
						end
					end
				elseif a_local.to_boolean then
					l_mpp.ce_gets (a_buf___6.item.b_maphash + l_hash)
				else
					l_mpp.ce_gets (maphash + l_hash)
				end
				if not js.loop_jumped then
					from
					until
						((l_mpp.item).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
					loop
						js.reset
						l_mp.ce_gets (l_mpp.item)
						if ((l_mp.item.m_mode).bit_and (a_mode)).to_boolean then
							l_mp.item.m_mode := (l_mp.item.m_mode).bit_and (((a_mode).bit_not))
							if l_mp.item.m_mode = 0 then
								map_free (l_mpp)
								js.continue
							end
							if not js.loop_jumped then
								if ((l_mp.item.m_mode).bit_and (4103)).to_boolean then
									l_new_hash := (l_mp.item.m_keys[0]).to_integer_32
								else
									l_new_hash := ((l_mp.item.m_keys[0]).to_integer_32).bit_xor (128)
								end
								if not a_abbr.to_boolean then
									if l_new_hash /= l_hash then
										l_mpp.item := l_mp.item.m_next
										if a_local.to_boolean then
											l_mp.item.m_next := a_buf___6.item.b_maphash[l_new_hash]
											a_buf___6.item.b_maphash[l_new_hash] := l_mp
										else
											l_mp.item.m_next := maphash[l_new_hash]
											maphash[l_new_hash] := l_mp
										end
										js.continue
									end
								end
							end
						end
						if not js.loop_jumped then
							l_mpp.ce_gets (create {CE_POINTER [CE_POINTER [PD_MAPBLOCK]]}.make_shared (l_mp.c_pointer + {PD_MAPBLOCK}.m_next_offset))
						end
					end
					l_hash := l_hash + 1
				end
			end
			js.reset
		end

	showmap (a_mp: CE_POINTER [PD_MAPBLOCK]; a_local: INTEGER_32)
		local
			l_len: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := 1
					if not (globals_inst.msg_didout.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if globals_inst.msg_silent = 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						message_inst.msg_putchar (('%N').code)
						if globals_inst.got_int.to_boolean then
							js.return
						end
				when 5 then -- if done
						if not js.return_called then
							if ((a_mp.item.m_mode).bit_and (24)) = 24 then
								message_inst.msg_putchar (('!').code)
							elseif ((a_mp.item.m_mode).bit_and (16)).to_boolean then
								message_inst.msg_putchar (('i').code)
							elseif ((a_mp.item.m_mode).bit_and (32)).to_boolean then
								message_inst.msg_putchar (('l').code)
							elseif ((a_mp.item.m_mode).bit_and (8)).to_boolean then
								message_inst.msg_putchar (('c').code)
							elseif ((a_mp.item.m_mode).bit_and (4103)) = 4103 then
								message_inst.msg_putchar ((' ').code)
							else
								l_len := 0
								if ((a_mp.item.m_mode).bit_and (1)).to_boolean then
									message_inst.msg_putchar (('n').code)
									l_len := l_len + 1
								end
								if ((a_mp.item.m_mode).bit_and (4)).to_boolean then
									message_inst.msg_putchar (('o').code)
									l_len := l_len + 1
								end
								if ((a_mp.item.m_mode).bit_and (4098)) = 4098 then
									message_inst.msg_putchar (('v').code)
									l_len := l_len + 1
								else
									if ((a_mp.item.m_mode).bit_and (2)).to_boolean then
										message_inst.msg_putchar (('x').code)
										l_len := l_len + 1
									end
									if ((a_mp.item.m_mode).bit_and (4096)).to_boolean then
										message_inst.msg_putchar (('s').code)
										l_len := l_len + 1
									end
								end
							end
							from
							until
								js.loop_left
							loop
								js.reset
								l_len := l_len + 1
								if not (l_len <= 3) then
									js.break
								end
								if not js.loop_jumped then
									message_inst.msg_putchar ((' ').code)
								end
							end
							js.reset
							l_len := message_inst.msg_outtrans_special (a_mp.item.m_keys, 1)
							from
							until
								js.loop_left
							loop
								js.reset
								message_inst.msg_putchar ((' ').code)
								l_len := l_len + 1
								if not (l_len < 12) then
									js.break
								end
							end
							js.reset
							if a_mp.item.m_noremap = -1 then
								message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("*")), globals_inst.highlight_attr[0])
							elseif a_mp.item.m_noremap = -2 then
								message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("&")), globals_inst.highlight_attr[0])
							else
								message_inst.msg_putchar ((' ').code)
							end
							if a_local.to_boolean then
								message_inst.msg_putchar (('@').code)
							else
								message_inst.msg_putchar ((' ').code)
							end
							if ((a_mp.item.m_str).item).to_integer_32 = 0 then
								message_inst.msg_puts_attr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<Nop>")), globals_inst.highlight_attr[0])
							else
								message_inst.msg_outtrans_special (a_mp.item.m_str, 0).do_nothing
							end
							if option_inst.p_verbose > 0 then
								eval_inst.last_set_msg (a_mp.item.m_script_ID)
							end
							term_inst.out_flush
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	map_to_exists (a_str___1: CE_POINTER [NATURAL_8]; a_modechars: CE_POINTER [NATURAL_8]; a_abbr: INTEGER_32): INTEGER_32
		local
			l_mode: INTEGER_32
			l_rhs: CE_POINTER [NATURAL_8]
			l_buf___6: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
		do
			create l_rhs.make
			create l_buf___6.make

			l_mode := 0
			l_rhs.ce_gets (term_inst.replace_termcodes (a_str___1, l_buf___6.address, 0, 1, 0))
			if ((misc2_inst.vim_strchr (a_modechars, ('n').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_mode := (l_mode).bit_or ((1))
			end
			if ((misc2_inst.vim_strchr (a_modechars, ('v').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_mode := (l_mode).bit_or ((4098))
			end
			if ((misc2_inst.vim_strchr (a_modechars, ('x').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_mode := (l_mode).bit_or ((2))
			end
			if ((misc2_inst.vim_strchr (a_modechars, ('s').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_mode := (l_mode).bit_or ((4096))
			end
			if ((misc2_inst.vim_strchr (a_modechars, ('o').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_mode := (l_mode).bit_or ((4))
			end
			if ((misc2_inst.vim_strchr (a_modechars, ('i').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_mode := (l_mode).bit_or ((16))
			end
			if ((misc2_inst.vim_strchr (a_modechars, ('l').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_mode := (l_mode).bit_or ((32))
			end
			if ((misc2_inst.vim_strchr (a_modechars, ('c').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_mode := (l_mode).bit_or ((8))
			end
			l_retval := map_to_exists_mode (l_rhs, l_mode, a_abbr)
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
			Result := l_retval
		end

	map_to_exists_mode (a_rhs: CE_POINTER [NATURAL_8]; a_mode: INTEGER_32; a_abbr: INTEGER_32): INTEGER_32
		local
			l_mp: CE_POINTER [PD_MAPBLOCK]
			l_hash: INTEGER_32
			l_expand_buffer___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_mp.make

			l_expand_buffer___0 := 0
			validate_maphash
			from
			until
				js.loop_left
			loop
				js.reset
				l_hash := 0
				from
				until
					not (not js.loop_left and then (l_hash < 256))
				loop
					js.reset
					if a_abbr.to_boolean then
						if l_hash > 0 then
							js.break
						end
						if not js.loop_jumped then
							if l_expand_buffer___0.to_boolean then
								l_mp.ce_gets (globals_inst.curbuf.item.b_first_abbr)
							else
								l_mp.ce_gets (first_abbr)
							end
						end
					elseif l_expand_buffer___0.to_boolean then
						l_mp.ce_gets (globals_inst.curbuf.item.b_maphash[l_hash])
					else
						l_mp.ce_gets (maphash[l_hash])
					end
					if not js.loop_jumped then
						from
						until
							not (not js.loop_left and then ((l_mp).c_pointer /= default_pointer))
						loop
							if ((l_mp.item.m_mode).bit_and (a_mode)).to_boolean then
								if ((strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_mp.item.m_str), create {CE_POINTER [INTEGER_8]}.make_cast (a_rhs))).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									Result := 1
									js.return
								end
							end
							if not js.return_called then
								l_mp.ce_gets (l_mp.item.m_next)
							end
						end
						if not js.return_called then
							l_hash := l_hash + 1
						end
					end
				end
				js.reset
				if not js.return_called then
					if l_expand_buffer___0.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_expand_buffer___0 := 1
					end
				end
			end
			js.reset
			if not js.return_called then
				Result := 0
			end
		end

	set_context_in_map_cmd (a_xp: CE_POINTER [PD_EXPAND]; a_cmd: CE_POINTER [NATURAL_8]; a_arg: CE_POINTER [NATURAL_8]; a_forceit: INTEGER_32; a_isabbrev: INTEGER_32; a_isunmap: INTEGER_32; a_cmdidx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_cmd: CE_POINTER [NATURAL_8]
			l_arg: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_cmd.make
			create l_arg.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_cmd.ce_gets (a_cmd)
					l_arg.ce_gets (a_arg)
					if not (a_forceit.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_cmdidx /= 250 then
							if a_cmdidx /= 457 then
								a_xp.item.xp_context := 0
							else
								l_pos := -1 + 3 -- goto _L___0
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___0:
						if a_isunmap.to_boolean then
							if a_forceit.to_boolean then
								l_tmp := 1
							elseif a_isabbrev.to_boolean then
								l_tmp := 1
							else
								l_tmp := 0
							end
							expand_mapmodes := get_map_mode (l_cmd.address, l_tmp)
						else
							expand_mapmodes := 24
							if not a_isabbrev.to_boolean then
								expand_mapmodes := expand_mapmodes + (4103)
							end
						end
						expand_isabbrev := a_isabbrev
						a_xp.item.xp_context := 16
						expand_buffer := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("<buffer>"), (8).to_natural_32)) = 0 then
								expand_buffer := 1
								l_arg.ce_gets (charset_inst.skipwhite (l_arg + 8))
								js.continue
							end
							if not js.loop_jumped then
								if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("<unique>"), (8).to_natural_32)) = 0 then
									l_arg.ce_gets (charset_inst.skipwhite (l_arg + 8))
									js.continue
								end
							end
							if not js.loop_jumped then
								if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("<silent>"), (8).to_natural_32)) = 0 then
									l_arg.ce_gets (charset_inst.skipwhite (l_arg + 8))
									js.continue
								end
							end
							if not js.loop_jumped then
								if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("<script>"), (8).to_natural_32)) = 0 then
									l_arg.ce_gets (charset_inst.skipwhite (l_arg + 8))
									js.continue
								end
							end
							if not js.loop_jumped then
								if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_arg), ce_string ("<expr>"), (6).to_natural_32)) = 0 then
									l_arg.ce_gets (charset_inst.skipwhite (l_arg + 6))
									js.continue
								end
							end
							if not js.loop_jumped then
								js.break
							end
							if not js.loop_left then
								
							end
						end
						js.reset
						a_xp.item.xp_pattern := l_arg
				when 4 then
					Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ExpandMappings (a_regmatch___0: CE_POINTER [PD_REGMATCH_T]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]): INTEGER_32
		local
			l_mp: CE_POINTER [PD_MAPBLOCK]
			l_hash: INTEGER_32
			l_count___2: INTEGER_32
			l_round: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			l_ptr1: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_ptr2: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_ptr3: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_tmp___4: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_tmp___5: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_tmp___7: INTEGER_32
			js: JUMP_STATE
		do
			create l_mp.make
			create l_p___0.make
			create l_ptr1.make
			create l_ptr2.make
			create l_ptr3.make
			create l_tmp___4.make
			create l_tmp___5.make

			validate_maphash
			a_num_file.item := 0
			a_file.item := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
			l_round := 1
			from
			until
				not (not js.loop_left and then (l_round <= 2))
			loop
				js.reset
				l_count___2 := 0
				l_i___0 := 0
				from
				until
					not (l_i___0 < 5)
				loop
					js.reset
					if l_i___0 = 0 then
						l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<silent>")))
					elseif l_i___0 = 1 then
						l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<unique>")))
					elseif l_i___0 = 2 then
						l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<script>")))
					elseif l_i___0 = 3 then
						l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<expr>")))
					elseif l_i___0 = 4 then
						if not expand_buffer.to_boolean then
							l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<buffer>")))
						else
							js.continue
						end
					else
						js.continue
					end
					if not js.loop_jumped then
						if (regexp_inst.vim_regexec (a_regmatch___0, l_p___0, 0)).to_boolean then
							if l_round = 1 then
								l_count___2 := l_count___2 + 1
							else
								l_tmp := l_count___2
								l_count___2 := l_count___2 + 1
								a_file.item[l_tmp] := misc2_inst.vim_strsave (l_p___0)
							end
						end
					end
					l_i___0 := l_i___0 + 1
				end
				l_hash := 0
				from
				until
					not (not js.loop_left and then (l_hash < 256))
				loop
					js.reset
					if expand_isabbrev.to_boolean then
						if l_hash > 0 then
							js.break
						end
						if not js.loop_jumped then
							l_mp.ce_gets (first_abbr)
						end
					elseif expand_buffer.to_boolean then
						l_mp.ce_gets (globals_inst.curbuf.item.b_maphash[l_hash])
					else
						l_mp.ce_gets (maphash[l_hash])
					end
					if not js.loop_jumped then
						from
						until
							(l_mp).c_pointer = default_pointer
						loop
							if ((l_mp.item.m_mode).bit_and (expand_mapmodes)).to_boolean then
								l_p___0.ce_gets (term_inst.translate_mapping (l_mp.item.m_keys, 1))
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if (regexp_inst.vim_regexec (a_regmatch___0, l_p___0, 0)).to_boolean then
										if l_round = 1 then
											l_count___2 := l_count___2 + 1
										else
											l_tmp___1 := l_count___2
											l_count___2 := l_count___2 + 1
											a_file.item[l_tmp___1] := l_p___0
											l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
										end
									end
								end
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
							end
							l_mp.ce_gets (l_mp.item.m_next)
						end
						l_hash := l_hash + 1
					end
				end
				js.reset
				if l_count___2 = 0 then
					js.break
				end
				if not js.loop_jumped then
					if l_round = 1 then
						a_file.item := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((misc2_inst.alloc (l_count___2.to_natural_32 * Pointer_bytes.to_natural_32)))
						if ((a_file.item).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						l_round := l_round + 1
					end
				end
			end
			js.reset
			if not js.return_called then
				if l_count___2 > 1 then
					misc2_inst.sort_strings (a_file.item, l_count___2)
					l_ptr1.ce_gets (a_file.item)
					l_ptr2.ce_gets (l_ptr1 + 1)
					l_ptr3.ce_gets (l_ptr1 + l_count___2)
					from
					until
						not ((l_ptr2.c_pointer.to_integer_32).to_natural_32 < (l_ptr3.c_pointer.to_integer_32).to_natural_32)
					loop
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr1.item), create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr2.item))).to_boolean then
							l_ptr1.ce_gets (l_ptr1 + 1)
							l_tmp___4.ce_gets (l_ptr2)
							l_ptr2.ce_gets (l_ptr2 + 1)
							l_ptr1.item := l_tmp___4.item
						else
							l_tmp___5.ce_gets (l_ptr2)
							l_ptr2.ce_gets (l_ptr2 + 1)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tmp___5.item))
							l_count___2 := l_count___2 - 1
						end
					end
				end
				a_num_file.item := l_count___2
				if l_count___2 = 0 then
					l_tmp___7 := 0
				else
					l_tmp___7 := 1
				end
				Result := l_tmp___7
			end
		end

	check_abbr (a_c: INTEGER_32; a_ptr: CE_POINTER [NATURAL_8]; a_col: INTEGER_32; a_mincol: INTEGER_32): INTEGER_32
		local
			l_c: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_scol: INTEGER_32
			l_j: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_tb: CE_ARRAY [NATURAL_8]
			l_mp: CE_POINTER [PD_MAPBLOCK]
			l_mp2: CE_POINTER [PD_MAPBLOCK]
			l_clen: INTEGER_32
			l_is_id: INTEGER_32
			l_vim_abbr: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___16: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ptr.make
			create l_s.make
			create l_tb.make (<<25>>)
			create l_mp.make
			create l_mp2.make
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := a_c
					l_ptr.ce_gets (a_ptr)
					l_clen := 0
					l_is_id := 1
					if (globals_inst.typebuf.tb_no_abbr_cnt).to_boolean then
						Result := 0
						js.return
					end
					if not js.return_called and then (((KeyNoremap).bit_and (3)) /= 0) then
						Result := 0
						js.return
					end
					if not js.return_called and then (a_col = 0) then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						if globals_inst.has_mbyte.to_boolean then
							l_p___0.ce_gets (mbyte_inst.mb_prevptr (l_ptr, l_ptr + a_col))
							if (charset_inst.vim_iswordp (l_p___0)).to_boolean then
								l_vim_abbr := 0
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_ptr.c_pointer.to_integer_32).to_natural_32 then
									l_is_id := charset_inst.vim_iswordp ((mbyte_inst.mb_prevptr (l_ptr, l_p___0)))
								end
							else
								l_vim_abbr := 1
							end
							l_clen := 1
							from
							until
								not (not js.loop_left and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 > ((l_ptr + a_mincol).c_pointer.to_integer_32).to_natural_32))
							loop
								js.reset
								l_p___0.ce_gets (mbyte_inst.mb_prevptr (l_ptr, l_p___0))
								if (misc2_inst.vim_isspace ((l_p___0.item).to_integer_32)).to_boolean then
									l_tmp___1 := globals_inst.mb_ptr2len.integer_32_item ([l_p___0])
									l_p___0.ce_gets (l_p___0 + l_tmp___1)
									js.break
								elseif not l_vim_abbr.to_boolean then
									if l_is_id /= (charset_inst.vim_iswordp (l_p___0)) then
										l_tmp___1 := globals_inst.mb_ptr2len.integer_32_item ([l_p___0])
										l_p___0.ce_gets (l_p___0 + l_tmp___1)
										js.break
									end
								end
								if not js.loop_jumped then
									l_clen := l_clen + 1
								end
							end
							js.reset
							l_scol := l_p___0.distance (l_ptr)
						else
							if (charset_inst.vim_iswordc ((l_ptr[(a_col - 1)]).to_integer_32)).to_boolean then
								l_vim_abbr := 0
								if a_col > 1 then
									l_is_id := charset_inst.vim_iswordc ((l_ptr[(a_col - 2)]).to_integer_32)
								end
							else
								l_vim_abbr := 1
							end
							l_scol := a_col - 1
							from
							until
								js.loop_left
							loop
								js.reset
								if l_scol > 0 then
									if (misc2_inst.vim_isspace ((l_ptr[(l_scol - 1)]).to_integer_32)).to_boolean then
										js.break
									elseif not l_vim_abbr.to_boolean then
										if l_is_id /= (charset_inst.vim_iswordc ((l_ptr[(l_scol - 1)]).to_integer_32)) then
											js.break
										end
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_scol := l_scol - 1
								end
							end
							js.reset
						end
						if l_scol < a_mincol then
							l_scol := a_mincol
						end
						if not (l_scol < a_col) then
							l_pos := -1 + 13 -- skip if block
						end
				when 2 then -- if:
						l_ptr.ce_gets (l_ptr + l_scol)
						l_len := a_col - l_scol
						l_mp.ce_gets (globals_inst.curbuf.item.b_first_abbr)
						l_mp2.ce_gets (first_abbr)
						if (l_mp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_mp.ce_gets (l_mp2)
							l_mp2.ce_gets (create {CE_POINTER [PD_MAPBLOCK]}.make_shared (default_pointer))
						end
						from
						until
							not (not js.loop_left and then ((l_mp).c_pointer /= default_pointer))
						loop
							js.reset
							if ((l_mp.item.m_mode).bit_and (globals_inst.State)).to_boolean then
								if l_mp.item.m_keylen = l_len then
									if not (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_mp.item.m_keys), create {CE_POINTER [INTEGER_8]}.make_cast (l_ptr), l_len.to_natural_32)).to_boolean then
										js.break
									end
								end
							end
							if not js.loop_jumped then
								if ((l_mp.item.m_next).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_mp.ce_gets (l_mp2)
									l_mp2.ce_gets (create {CE_POINTER [PD_MAPBLOCK]}.make_shared (default_pointer))
								else
									l_mp.ce_gets (l_mp.item.m_next)
								end
							end
						end
						js.reset
						if (l_mp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 13 -- skip if block
						end
				when 3 then -- if:
						l_j := 0
						if l_c = 29 then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if not (l_c < 0) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if l_c /= 128 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L:
						l_tmp___8 := l_j
						l_j := l_j + 1
						l_tb[l_tmp___8] := (128).to_natural_8
						l_tmp___9 := l_j
						l_j := l_j + 1
						if l_c = 128 then
							l_tb[l_tmp___9] := (254).to_natural_8
						else
							if l_c = 0 then
								l_tmp___10 := 255
							else
								l_tmp___10 := (-l_c).bit_and (255)
							end
							l_tb[l_tmp___9] := l_tmp___10.to_natural_8
						end
						l_tmp___11 := l_j
						l_j := l_j + 1
						if l_c = 128 then
							l_tb[l_tmp___11] := (('X').code).to_natural_8
						elseif l_c = 0 then
							l_tb[l_tmp___11] := (('X').code).to_natural_8
						else
							l_tb[l_tmp___11] := (((((-l_c).to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 255)).to_natural_8
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						if l_c < 256 then
							if l_c < 32 then
								l_tmp___12 := l_j
								l_j := l_j + 1
								l_tb[l_tmp___12] := (22).to_natural_8
							elseif l_c > 126 then
								l_tmp___12 := l_j
								l_j := l_j + 1
								l_tb[l_tmp___12] := (22).to_natural_8
							end
						end
						if globals_inst.has_mbyte.to_boolean then
							if l_c >= 256 then
								l_c := l_c - (256)
							end
							l_j := l_j + (globals_inst.mb_char2bytes.integer_32_item ([l_c, l_tb + l_j]))
						else
							l_tmp___14 := l_j
							l_j := l_j + 1
							l_tb[l_tmp___14] := l_c.to_natural_8
						end
				when 11 then -- if done
						l_tb[l_j] := (('%/0/').code).to_natural_8
						ins_typebuf (l_tb, 1, 0, 1, (l_mp.item.m_silent).to_integer_32).do_nothing
				when 12 then -- if done
						if (l_mp.item.m_expr).to_boolean then
							l_s.ce_gets (eval_map_expr (l_mp.item.m_str, l_c))
						else
							l_s.ce_gets (l_mp.item.m_str)
						end
						if (l_s.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							ins_typebuf (l_s, l_mp.item.m_noremap, 0, 1, (l_mp.item.m_silent).to_integer_32).do_nothing
							globals_inst.typebuf.tb_no_abbr_cnt := globals_inst.typebuf.tb_no_abbr_cnt + (((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))).to_integer_32 + l_j) + 1)
							if (l_mp.item.m_expr).to_boolean then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_s))
							end
						end
						l_tb[0] := (8).to_natural_8
						l_tb[1] := (('%/0/').code).to_natural_8
						if globals_inst.has_mbyte.to_boolean then
							l_len := l_clen
						end
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp___16 := l_len
							l_len := l_len - 1
							if not (l_tmp___16 > 0) then
								js.break
							end
							if not js.loop_jumped then
								ins_typebuf (l_tb, 1, 0, 1, (l_mp.item.m_silent).to_integer_32).do_nothing
							end
						end
						js.reset
						Result := 1
						js.return
				when 13 then -- if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	eval_map_expr (a_str___1: CE_POINTER [NATURAL_8]; a_c: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_res: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_save_cmd: CE_POINTER [NATURAL_8]
			l_save_cursor: PD_POS_T
			js: JUMP_STATE
		do
			create l_res.make
			create l_p___0.make
			create l_save_cmd.make
			create l_save_cursor.make

			l_save_cmd.ce_gets (ex_getln_inst.save_cmdline_alloc)
			if (l_save_cmd.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				globals_inst.textlock := globals_inst.textlock + 1
				globals_inst.ex_normal_lock := globals_inst.ex_normal_lock + 1
				eval_inst.set_vim_var_char (a_c)
				l_save_cursor.ce_gets (globals_inst.curwin.item.w_cursor)
				l_p___0.ce_gets (eval_inst.eval_to_string (a_str___1, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), 0))
				globals_inst.textlock := globals_inst.textlock - 1
				globals_inst.ex_normal_lock := globals_inst.ex_normal_lock - 1
				globals_inst.curwin.item.w_cursor := l_save_cursor
				ex_getln_inst.restore_cmdline_alloc (l_save_cmd)
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				l_res.ce_gets (vim_strsave_escape_csi (l_p___0))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
				Result := l_res
			end
		end

	vim_strsave_escape_csi (a_p___0: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_res: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___7: INTEGER_32
			l_tmp___9: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_res.make
			create l_s.make
			create l_d.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_res.ce_gets (misc2_inst.alloc ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_p___0))) * {NATURAL_32} 3 + {NATURAL_32} 1))
					if (l_res.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						l_d.ce_gets (l_res)
						l_s.ce_gets (a_p___0)
				when 2 then -- loop condition:
						if (l_s.item).to_integer_32 = 0 then
							l_pos := -1 + 8 -- skip loop
						end
				when 3 then -- loop body:
						if (l_s[0]).to_integer_32 /= 128 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (l_s[1]).to_integer_32 /= 0 then
							if (l_s[2]).to_integer_32 /= 0 then
								l_tmp___0.ce_gets (l_d)
								l_d.ce_gets (l_d + 1)
								l_tmp___1.ce_gets (l_s)
								l_s.ce_gets (l_s + 1)
								l_tmp___0.item := l_tmp___1.item
								l_tmp___2.ce_gets (l_d)
								l_d.ce_gets (l_d + 1)
								l_tmp___3.ce_gets (l_s)
								l_s.ce_gets (l_s + 1)
								l_tmp___2.item := l_tmp___3.item
								l_tmp___4.ce_gets (l_d)
								l_d.ce_gets (l_d + 1)
								l_tmp___5.ce_gets (l_s)
								l_s.ce_gets (l_s + 1)
								l_tmp___4.item := l_tmp___5.item
							else
								l_pos := -1 + 6 -- goto _L___0
							end
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L___0:
						if globals_inst.has_mbyte.to_boolean then
							l_tmp___7 := (globals_inst.mb_ptr2char.integer_32_item ([l_s]))
						else
							l_tmp___7 := (l_s.item).to_integer_32
						end
						l_d.ce_gets (edit_inst.add_char2buf (l_tmp___7, l_d))
						if globals_inst.has_mbyte.to_boolean then
							l_tmp___9 := (globals_inst.mb_ptr2len.integer_32_item ([l_s]))
						else
							l_tmp___9 := 1
						end
						l_s.ce_gets (l_s + l_tmp___9)
				when 7 then
						l_pos := -1 + 2 -- back to loop condition
				when 8 then -- loop done
						l_d.item := (('%/0/').code).to_natural_8
				when 9 then -- if done
					Result := l_res
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	vim_unescape_csi (a_p___0: CE_POINTER [NATURAL_8])
		local
			l_s: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_d.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s.ce_gets (a_p___0)
					l_d.ce_gets (a_p___0)
				when 1 then -- loop condition:
					if (l_s.item).to_integer_32 = 0 then
						l_pos := -1 + 13 -- skip loop
					end
				when 2 then -- loop body:
						if (l_s[0]).to_integer_32 /= 128 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (l_s[1]).to_integer_32 = 254 then
							if (l_s[2]).to_integer_32 = 88 then
								l_tmp.ce_gets (l_d)
								l_d.ce_gets (l_d + 1)
								l_tmp.item := (128).to_natural_8
								l_s.ce_gets (l_s + (3))
							else
								l_pos := -1 + 5 -- goto _L___1
							end
						else
							l_pos := -1 + 5 -- goto _L___1
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 5 then -- else: | _L___1:
						if (l_s[0]).to_integer_32 /= 128 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 8 then -- else:
						if (l_s[0]).to_integer_32 /= 155 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if: | _L:
						if (l_s[1]).to_integer_32 = 253 then
							if (l_s[2]).to_integer_32 = 81 then
								l_tmp___0.ce_gets (l_d)
								l_d.ce_gets (l_d + 1)
								l_tmp___0.item := (155).to_natural_8
								l_s.ce_gets (l_s + (3))
							else
								l_tmp___1.ce_gets (l_d)
								l_d.ce_gets (l_d + 1)
								l_tmp___2.ce_gets (l_s)
								l_s.ce_gets (l_s + 1)
								l_tmp___1.item := l_tmp___2.item
							end
						else
							l_tmp___1.ce_gets (l_d)
							l_d.ce_gets (l_d + 1)
							l_tmp___2.ce_gets (l_s)
							l_s.ce_gets (l_s + 1)
							l_tmp___1.item := l_tmp___2.item
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_tmp___1.ce_gets (l_d)
						l_d.ce_gets (l_d + 1)
						l_tmp___2.ce_gets (l_s)
						l_s.ce_gets (l_s + 1)
						l_tmp___1.item := l_tmp___2.item
				when 12 then -- if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 13 then -- loop done
					l_d.item := (('%/0/').code).to_natural_8
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	makemap (a_fd: CE_POINTER [SD_IO_FILE]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			l_mp: CE_POINTER [PD_MAPBLOCK]
			l_c1: NATURAL_8
			l_c2: NATURAL_8
			l_c3: NATURAL_8
			l_p___0: CE_POINTER [NATURAL_8]
			l_cmd: CE_POINTER [INTEGER_8]
			l_abbr: INTEGER_32
			l_hash: INTEGER_32
			l_did_cpo: INTEGER_32
			l_i___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_mp.make
			create l_p___0.make
			create l_cmd.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_did_cpo := 0
					validate_maphash
					l_abbr := 0
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_abbr < 2)) then
						l_pos := -1 + 33 -- skip loop
					end
				when 2 then -- loop body:
						l_hash := 0
				when 3 then -- loop condition:
						if not (not js.loop_left and then (l_hash < 256)) then
							l_pos := -1 + 32 -- skip loop
						end
				when 4 then -- loop body:
						js.reset
						if l_abbr.to_boolean then
							if l_hash > 0 then
								js.break
							end
							if not js.loop_jumped then
								if (a_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_mp.ce_gets (a_buf___6.item.b_first_abbr)
								else
									l_mp.ce_gets (first_abbr)
								end
							end
						elseif (a_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_mp.ce_gets (a_buf___6.item.b_maphash[l_hash])
						else
							l_mp.ce_gets (maphash[l_hash])
						end
						if js.loop_jumped then
							l_pos := -1 + 31 -- skip if block
						end
				when 5 then -- if: | loop condition:
						if not (not js.loop_left and then ((l_mp).c_pointer /= default_pointer)) then
							l_pos := -1 + 30 -- skip loop
						end
				when 6 then -- loop body:
						js.reset
						if l_mp.item.m_noremap = -2 then
							js.continue
						end
						if not js.loop_jumped then
							l_p___0.ce_gets (l_mp.item.m_str)
							from
							until
								not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0))
							loop
								js.reset
								if (l_p___0[0]).to_integer_32 = 128 then
									if (l_p___0[1]).to_integer_32 = 253 then
										if (l_p___0[2]).to_integer_32 = 82 then
											js.break
										end
									end
								end
								if not js.loop_jumped then
									l_p___0.ce_gets (l_p___0 + 1)
								end
							end
							js.reset
							if (l_p___0.item).to_integer_32 /= 0 then
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 29 -- skip if block
						end
				when 7 then -- if:
						l_c1 := (('%/0/').code).to_natural_8
						l_c2 := (('%/0/').code).to_natural_8
						l_c3 := (('%/0/').code).to_natural_8
						if l_abbr.to_boolean then
							l_cmd.ce_gets (ce_string ("abbr"))
						else
							l_cmd.ce_gets (ce_string ("map"))
						end
						inspect l_mp.item.m_mode -- switch 1 head
						when 4103 then l_pos := -1 + 8
						when 1 then l_pos := -1 + 9
						when 2 then l_pos := -1 + 10
						when 4096 then l_pos := -1 + 11
						when 4 then l_pos := -1 + 12
						when 3 then l_pos := -1 + 13
						when 4097 then l_pos := -1 + 14
						when 5 then l_pos := -1 + 15
						when 4098 then l_pos := -1 + 16
						when 6 then l_pos := -1 + 17
						when 4100 then l_pos := -1 + 18
						when 4099 then l_pos := -1 + 19
						when 7 then l_pos := -1 + 20
						when 4101 then l_pos := -1 + 21
						when 4102 then l_pos := -1 + 22
						when 24 then l_pos := -1 + 23
						when 8 then l_pos := -1 + 24
						when 16 then l_pos := -1 + 25
						when 32 then l_pos := -1 + 26
						else l_pos := -1 + 27
						end
				when 8 then -- switch 1, case 4103
						l_pos := -1 + 28 -- switch 1; break
				when 9 then -- switch 1, case 1
						l_c1 := (('n').code).to_natural_8
						l_pos := -1 + 28 -- switch 1; break
				when 10 then -- switch 1, case 2
						l_c1 := (('x').code).to_natural_8
						l_pos := -1 + 28 -- switch 1; break
				when 11 then -- switch 1, case 4096
						l_c1 := (('s').code).to_natural_8
						l_pos := -1 + 28 -- switch 1; break
				when 12 then -- switch 1, case 4
						l_c1 := (('o').code).to_natural_8
						l_pos := -1 + 28 -- switch 1; break
				when 13 then -- switch 1, case 3
						l_c1 := (('n').code).to_natural_8
						l_c2 := (('x').code).to_natural_8
						l_pos := -1 + 28 -- switch 1; break
				when 14 then -- switch 1, case 4097
						l_c1 := (('n').code).to_natural_8
						l_c2 := (('s').code).to_natural_8
						l_pos := -1 + 28 -- switch 1; break
				when 15 then -- switch 1, case 5
						l_c1 := (('n').code).to_natural_8
						l_c2 := (('o').code).to_natural_8
						l_pos := -1 + 28 -- switch 1; break
				when 16 then -- switch 1, case 4098
						l_c1 := (('v').code).to_natural_8
						l_pos := -1 + 28 -- switch 1; break
				when 17 then -- switch 1, case 6
						l_c1 := (('x').code).to_natural_8
						l_c2 := (('o').code).to_natural_8
						l_pos := -1 + 28 -- switch 1; break
				when 18 then -- switch 1, case 4100
						l_c1 := (('s').code).to_natural_8
						l_c2 := (('o').code).to_natural_8
						l_pos := -1 + 28 -- switch 1; break
				when 19 then -- switch 1, case 4099
						l_c1 := (('n').code).to_natural_8
						l_c2 := (('v').code).to_natural_8
						l_pos := -1 + 28 -- switch 1; break
				when 20 then -- switch 1, case 7
						l_c1 := (('n').code).to_natural_8
						l_c2 := (('x').code).to_natural_8
						l_c3 := (('o').code).to_natural_8
						l_pos := -1 + 28 -- switch 1; break
				when 21 then -- switch 1, case 4101
						l_c1 := (('n').code).to_natural_8
						l_c2 := (('s').code).to_natural_8
						l_c3 := (('o').code).to_natural_8
						l_pos := -1 + 28 -- switch 1; break
				when 22 then -- switch 1, case 4102
						l_c1 := (('v').code).to_natural_8
						l_c2 := (('o').code).to_natural_8
						l_pos := -1 + 28 -- switch 1; break
				when 23 then -- switch 1, case 24
						if not l_abbr.to_boolean then
							l_cmd.ce_gets (ce_string ("map!"))
						end
						l_pos := -1 + 28 -- switch 1; break
				when 24 then -- switch 1, case 8
						l_c1 := (('c').code).to_natural_8
						l_pos := -1 + 28 -- switch 1; break
				when 25 then -- switch 1, case 16
						l_c1 := (('i').code).to_natural_8
						l_pos := -1 + 28 -- switch 1; break
				when 26 then -- switch 1, case 32
						l_c1 := (('l').code).to_natural_8
						l_pos := -1 + 28 -- switch 1; break
				when 27 then -- switch 1, default:
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E228: makemap: Illegal mode"))))).do_nothing
						Result := 0
						js.return
				when 28 then -- switch 1, done:
						if not js.return_called then
							from
							until
								js.loop_left
							loop
								js.reset
								if not l_did_cpo.to_boolean then
									if ((l_mp.item.m_str).item).to_integer_32 = 0 then
										l_did_cpo := 1
									else
										l_i___0 := 0
										from
										until
											not (not js.loop_left and then (l_i___0 < 2))
										loop
											if l_i___0.to_boolean then
												l_p___0.ce_gets (l_mp.item.m_str)
											else
												l_p___0.ce_gets (l_mp.item.m_keys)
											end
											from
											until
												not ((l_p___0.item).to_boolean)
											loop
												if (l_p___0.item).to_integer_32 = 128 then
													l_did_cpo := 1
												elseif (l_p___0.item).to_integer_32 = 10 then
													l_did_cpo := 1
												end
												l_p___0.ce_gets (l_p___0 + 1)
											end
											l_i___0 := l_i___0 + 1
										end
									end
									if l_did_cpo.to_boolean then
										if (fprintf ([a_fd, ce_string ("let s:cpo_save=&cpo")])) < 0 then
											Result := 0
											js.return
										elseif (ex_docmd_inst.put_eol (a_fd)) < 0 then
											Result := 0
											js.return
										elseif (fprintf ([a_fd, ce_string ("set cpo&vim")])) < 0 then
											Result := 0
											js.return
										elseif (ex_docmd_inst.put_eol (a_fd)) < 0 then
											Result := 0
											js.return
										end
									end
								end
								if not js.return_called and then (l_c1.to_boolean) then
									if (IO_putc (l_c1.to_integer_32, a_fd)) < 0 then
										Result := 0
										js.return
									end
								end
								if not js.return_called and then (l_mp.item.m_noremap /= 0) then
									if (fprintf ([a_fd, ce_string ("nore")])) < 0 then
										Result := 0
										js.return
									end
								end
								if not js.return_called then
									if (fputs (l_cmd, a_fd)) < 0 then
										Result := 0
										js.return
									end
								end
								if not js.return_called and then ((a_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32) then
									if (fputs (ce_string (" <buffer>"), a_fd)) < 0 then
										Result := 0
										js.return
									end
								end
								if not js.return_called and then ((l_mp.item.m_silent).to_boolean) then
									if (fputs (ce_string (" <silent>"), a_fd)) < 0 then
										Result := 0
										js.return
									end
								end
								if not js.return_called and then (l_mp.item.m_noremap = -2) then
									if (fputs (ce_string ("<script>"), a_fd)) < 0 then
										Result := 0
										js.return
									end
								end
								if not js.return_called and then ((l_mp.item.m_expr).to_boolean) then
									if (fputs (ce_string (" <expr>"), a_fd)) < 0 then
										Result := 0
										js.return
									end
								end
								if not js.return_called then
									if (IO_putc ((' ').code, a_fd)) < 0 then
										Result := 0
										js.return
									elseif (put_escstr (a_fd, l_mp.item.m_keys, 0)) = 0 then
										Result := 0
										js.return
									elseif (IO_putc ((' ').code, a_fd)) < 0 then
										Result := 0
										js.return
									elseif (put_escstr (a_fd, l_mp.item.m_str, 1)) = 0 then
										Result := 0
										js.return
									elseif (ex_docmd_inst.put_eol (a_fd)) < 0 then
										Result := 0
										js.return
									end
								end
								if not js.return_called then
									l_c1 := l_c2
									l_c2 := l_c3
									l_c3 := (('%/0/').code).to_natural_8
									if l_c1.to_integer_32 = 0 then
										js.break
									end
								end
							end
							js.reset
						end
				when 29 then -- if done
						if not js.loop_left then
							l_mp.ce_gets (l_mp.item.m_next)
						end
						l_pos := -1 + 5 -- back to loop condition
				when 30 then -- loop done
						if not js.return_called then
							l_hash := l_hash + 1
						end
				when 31 then -- if done
						l_pos := -1 + 3 -- back to loop condition
				when 32 then -- loop done
						js.reset
						if not js.return_called then
							l_abbr := l_abbr + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 33 then -- loop done
					if not js.return_called and then (l_did_cpo.to_boolean) then
						if (fprintf ([a_fd, ce_string ("let &cpo=s:cpo_save")])) < 0 then
							Result := 0
							js.return
						elseif (ex_docmd_inst.put_eol (a_fd)) < 0 then
							Result := 0
							js.return
						elseif (fprintf ([a_fd, ce_string ("unlet s:cpo_save")])) < 0 then
							Result := 0
							js.return
						elseif (ex_docmd_inst.put_eol (a_fd)) < 0 then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						Result := 1
					end
				when 34 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	put_escstr (a_fd: CE_POINTER [SD_IO_FILE]; a_strstart: CE_POINTER [NATURAL_8]; a_what: INTEGER_32): INTEGER_32
		local
			l_str___1: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_modifiers: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_str___1.make
			create l_p___0.make
			create l_tmp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_str___1.ce_gets (a_strstart)
					if (l_str___1.item).to_integer_32 = 0 then
						if a_what = 1 then
							if (fprintf ([a_fd, ce_string ("<Nop>")])) < 0 then
								Result := 0
								js.return
							end
							if not js.return_called then
								Result := 1
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 48 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if not (not js.loop_left and then ((l_str___1.item).to_integer_32 /= 0)) then
							l_pos := -1 + 48 -- skip loop
						end
				when 2 then -- loop body:
						js.reset
						l_p___0.ce_gets (mbyte_inst.mb_unescape (l_str___1.address))
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							from
							until
								not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0))
							loop
								l_tmp___0.ce_gets (l_p___0)
								l_p___0.ce_gets (l_p___0 + 1)
								if (fputc ((l_tmp___0.item).to_integer_32, a_fd)) < 0 then
									Result := 0
									js.return
								end
							end
							if not js.return_called then
								l_str___1.ce_gets (l_str___1 - 1)
								js.continue
							end
						end
						if js.return_called then
							l_pos := -1 + 47 -- skip if block
						end
				when 3 then -- if:
						if js.loop_jumped then
							l_pos := -1 + 11 -- skip if block
						end
				when 4 then -- if:
						l_c := (l_str___1.item).to_integer_32
						if l_c /= 128 then
							l_pos := -1 + 11 -- skip if block
						end
				when 5 then -- if:
						if a_what = 2 then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if:
						l_modifiers := 0
						if (l_str___1[1]).to_integer_32 = 252 then
							l_modifiers := (l_str___1[2]).to_integer_32
							l_str___1.ce_gets (l_str___1 + (3))
							l_c := (l_str___1.item).to_integer_32
						end
						if l_c = 128 then
							if (l_str___1[1]).to_integer_32 = 254 then
								l_c := 128
							else
								if (l_str___1[1]).to_integer_32 = 255 then
									l_tmp___2 := -(255 + ((88).bit_shift_left (8)))
								else
									l_tmp___2 := -((l_str___1[1]).to_integer_32 + (((l_str___1[2]).to_integer_32).bit_shift_left (8)))
								end
								l_c := l_tmp___2
							end
							l_str___1.ce_gets (l_str___1 + (2))
						end
						if not (l_c < 0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if not (l_modifiers.to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						if (fputs (create {CE_POINTER [INTEGER_8]}.make_cast ((misc2_inst.get_special_key_name (l_c, l_modifiers))), a_fd)) < 0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							js.continue
						end
				when 11 then -- if done | if done | if done | if done
						if not js.loop_jumped and then (l_c = 10) then
							if a_what = 2 then
								if (fprintf ([a_fd, ce_string ("\%/22/%N")])) < 0 then
									Result := 0
									js.return
								end
							elseif (fprintf ([a_fd, ce_string ("<NL>")])) < 0 then
								Result := 0
								js.return
							end
							if not js.return_called then
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 46 -- skip if block
						end
				when 12 then -- if:
						if a_what /= 2 then
							l_pos := -1 + 27 -- skip if block
						end
				when 13 then -- if:
						if l_c /= 32 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 23 -- goto _L___5
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 16 then -- else:
						if l_c /= 9 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 23 -- goto _L___5
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 19 then -- else:
						if l_c /= 34 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 23 -- goto _L___5
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 22 then -- else:
						if l_c /= 92 then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if: | _L___5:
						if (IO_putc (('\').code, a_fd)) < 0 then
							Result := 0
							js.return
						end
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else:
						l_pos := -1 + 27 -- goto _L___4
				when 26 then -- if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 45
				when 27 then -- else: | _L___4:
						if not (l_c < 32) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						l_pos := -1 + 44 -- goto _L___0
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 30 then -- else:
						if not (l_c > 126) then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						l_pos := -1 + 44 -- goto _L___0
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 33 then -- else:
						if l_c /= 124 then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						l_pos := -1 + 44 -- goto _L___0
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 36 then -- else:
						if a_what /= 0 then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						if l_c = 32 then
							l_pos := -1 + 44 -- goto _L___0
						else
							l_pos := -1 + 39 -- goto _L___3
						end
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 39 then -- else: | _L___3:
						if a_what /= 1 then
							l_pos := -1 + 42 -- skip if block
						end
				when 40 then -- if:
						if (l_str___1.c_pointer.to_integer_32).to_natural_32 = (a_strstart.c_pointer.to_integer_32).to_natural_32 then
							if l_c = 32 then
								l_pos := -1 + 44 -- goto _L___0
							else
								l_pos := -1 + 42 -- goto _L___2
							end
						else
							l_pos := -1 + 42 -- goto _L___2
						end
				when 41 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 42 then -- else: | _L___2:
						if a_what = 2 then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if:
						if l_c /= 60 then
							l_pos := -1 + 45 -- skip if block
						end
				when 44 then -- if: | _L___0:
						if (IO_putc (22, a_fd)) < 0 then
							Result := 0
							js.return
						end
				when 45 then -- if done | if done | if done | if done | if done | if done | if done
						if not js.return_called then
							if (IO_putc (l_c, a_fd)) < 0 then
								Result := 0
								js.return
							end
						end
				when 46 then -- if done
						if not js.loop_left then
							l_str___1.ce_gets (l_str___1 + 1)
						end
				when 47 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 48 then -- loop done | if done
						if not js.return_called then
							Result := 1
						end
				when 49 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	check_map_keycodes
		local
			l_mp: CE_POINTER [PD_MAPBLOCK]
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_save_name: CE_POINTER [NATURAL_8]
			l_abbr: INTEGER_32
			l_hash: INTEGER_32
			l_bp___0: CE_POINTER [PD_FILE_BUFFER]
			js: JUMP_STATE
		do
			create l_mp.make
			create l_p___0.make
			create l_buf___6.make (<<3>>)
			create l_save_name.make
			create l_bp___0.make

			validate_maphash
			l_save_name.ce_gets (globals_inst.sourcing_name)
			globals_inst.sourcing_name.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mappings")))
			l_bp___0.ce_gets (globals_inst.firstbuf)
			from
			until
				js.loop_left
			loop
				js.reset
				l_abbr := 0
				from
				until
					not (not js.loop_left and then (l_abbr <= 1))
				loop
					l_hash := 0
					from
					until
						not (not js.loop_left and then (l_hash < 256))
					loop
						js.reset
						if l_abbr.to_boolean then
							if l_hash.to_boolean then
								js.break
							end
							if not js.loop_jumped then
								if (l_bp___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_mp.ce_gets (l_bp___0.item.b_first_abbr)
								else
									l_mp.ce_gets (first_abbr)
								end
							end
						elseif (l_bp___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_mp.ce_gets (l_bp___0.item.b_maphash[l_hash])
						else
							l_mp.ce_gets (maphash[l_hash])
						end
						if not js.loop_jumped then
							from
							until
								not (not js.loop_left and then ((l_mp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
							loop
								l_i___0 := 0
								from
								until
									not (not js.loop_left and then (l_i___0 <= 1))
								loop
									if l_i___0 = 0 then
										l_p___0.ce_gets (l_mp.item.m_keys)
									else
										l_p___0.ce_gets (l_mp.item.m_str)
									end
									from
									until
										not ((l_p___0.item).to_boolean)
									loop
										if (l_p___0.item).to_integer_32 = 128 then
											l_p___0.ce_gets (l_p___0 + 1)
											if (l_p___0.item).to_integer_32 < 128 then
												l_buf___6[0] := l_p___0[0]
												l_buf___6[1] := l_p___0[1]
												l_buf___6[2] := (('%/0/').code).to_natural_8
												term_inst.add_termcap_entry (l_buf___6, 0).do_nothing
											end
											l_p___0.ce_gets (l_p___0 + 1)
										end
										l_p___0.ce_gets (l_p___0 + 1)
									end
									l_i___0 := l_i___0 + 1
								end
								l_mp.ce_gets (l_mp.item.m_next)
							end
							l_hash := l_hash + 1
						end
					end
					js.reset
					l_abbr := l_abbr + 1
				end
				if (l_bp___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					js.break
				end
				if not js.loop_jumped then
					l_bp___0.ce_gets (l_bp___0.item.b_next)
				end
			end
			js.reset
			globals_inst.sourcing_name.ce_gets (l_save_name)
		end

	check_map (a_keys___0: CE_POINTER [NATURAL_8]; a_mode: INTEGER_32; a_exact: INTEGER_32; a_ign_mod: INTEGER_32; a_abbr: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_hash: INTEGER_32
			l_len: INTEGER_32
			l_minlen: INTEGER_32
			l_mp: CE_POINTER [PD_MAPBLOCK]
			l_s: CE_POINTER [NATURAL_8]
			l_local: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_mp.make
			create l_s.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					validate_maphash
					l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_keys___0))).to_integer_32
					l_local := 1
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_local >= 0)) then
						l_pos := -1 + 16 -- skip loop
					end
				when 2 then -- loop body:
						l_hash := 0
				when 3 then -- loop condition:
						if not (not js.loop_left and then (l_hash < 256)) then
							l_pos := -1 + 15 -- skip loop
						end
				when 4 then -- loop body:
						js.reset
						if a_abbr.to_boolean then
							if l_hash > 0 then
								js.break
							end
							if not js.loop_jumped then
								if l_local.to_boolean then
									l_mp.ce_gets (globals_inst.curbuf.item.b_first_abbr)
								else
									l_mp.ce_gets (first_abbr)
								end
							end
						elseif l_local.to_boolean then
							l_mp.ce_gets (globals_inst.curbuf.item.b_maphash[l_hash])
						else
							l_mp.ce_gets (maphash[l_hash])
						end
						if js.loop_jumped then
							l_pos := -1 + 14 -- skip if block
						end
				when 5 then -- if: | loop condition:
						if not (not js.loop_left and then ((l_mp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 6 then -- loop body:
						if not (((l_mp.item.m_mode).bit_and (a_mode)).to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						if a_exact.to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else:
						if l_mp.item.m_keylen /= l_len then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L:
						if l_len > l_mp.item.m_keylen then
							l_minlen := l_mp.item.m_keylen
						else
							l_minlen := l_len
						end
						l_s.ce_gets (l_mp.item.m_keys)
						if a_ign_mod.to_boolean then
							if (l_s[0]).to_integer_32 = 128 then
								if (l_s[1]).to_integer_32 = 252 then
									if (l_s[2]).to_integer_32 /= 0 then
										l_s.ce_gets (l_s + (3))
										if l_len > l_mp.item.m_keylen - 3 then
											l_minlen := l_mp.item.m_keylen - 3
										end
									end
								end
							end
						end
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), create {CE_POINTER [INTEGER_8]}.make_cast (a_keys___0), l_minlen.to_natural_32)) = 0 then
							Result := (l_mp.item.m_str)
							js.return
						end
				when 12 then -- if done | if done
						if not js.return_called then
							l_mp.ce_gets (l_mp.item.m_next)
						end
						l_pos := -1 + 5 -- back to loop condition
				when 13 then -- loop done
						if not js.return_called then
							l_hash := l_hash + 1
						end
				when 14 then -- if done
						l_pos := -1 + 3 -- back to loop condition
				when 15 then -- loop done
						js.reset
						if not js.return_called then
							l_local := l_local - 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 16 then -- loop done
					if not js.return_called then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	init_mappings
		do
		end

	add_map (a_map: CE_POINTER [NATURAL_8]; a_mode: INTEGER_32)
		local
			l_s: CE_POINTER [NATURAL_8]
			l_cpo_save: CE_POINTER [NATURAL_8]
		do
			create l_s.make
			create l_cpo_save.make

			l_cpo_save.ce_gets (option_inst.p_cpo)
			option_inst.p_cpo.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
			l_s.ce_gets (misc2_inst.vim_strsave (a_map))
			if (l_s.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				do_map (0, l_s, a_mode, 0).do_nothing
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_s))
			end
			option_inst.p_cpo.ce_gets (l_cpo_save)
		end

end
