class
	P_GUI_GTK_X11

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create selection_targets.make (<<7>>)
			create dnd_targets.make (<<5>>)
			create wm_protocols_atom.make
			create save_yourself_atom.make
			create html_atom.make
			create utf8_string_atom.make
			create vim_atom___0.make
			create vimenc_atom___0.make
			create special_keys.make (<<81>>)
			create cmdline_options.make (<<32>>)
			create gui_argv.make
			create role_argument.make
			create tabline_menu.make
			create tabline_tooltip.make
			create cjk_langs.make (<<5>>)
			create default_shape_engine.make
			create vimnames.make (<<28, 2>>)
			create val.make (<<8>>)
			create mshape_ids.make (<<17>>)
		end

feature {ANY} -- attributes

	clipboard_event_time: NATURAL_32 assign set_clipboard_event_time

	set_clipboard_event_time (a_clipboard_event_time: NATURAL_32)
		do
			clipboard_event_time := a_clipboard_event_time
		end

	selection_targets: CE_ARRAY [SD_GTKTARGETENTRY]

	dnd_targets: CE_ARRAY [SD_GTKTARGETENTRY]

	wm_protocols_atom: CE_POINTER [ANY]

	save_yourself_atom: CE_POINTER [ANY]

	html_atom: CE_POINTER [ANY]

	utf8_string_atom: CE_POINTER [ANY]

	vim_atom___0: CE_POINTER [ANY]

	vimenc_atom___0: CE_POINTER [ANY]

	special_keys: CE_ARRAY [PD_SPECIAL_KEY]

	cmdline_options: CE_ARRAY [PD_CMDLINE_OPTION_T]

	gui_argc: INTEGER_32 assign set_gui_argc
		do
			Result := gui_argc_address[0]
		end

	set_gui_argc (a_gui_argc: INTEGER_32)
		do
			gui_argc_address[0] := a_gui_argc
		end

	gui_argc_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	gui_argv: CE_POINTER [CE_POINTER [INTEGER_8]]

	role_argument: CE_POINTER [INTEGER_8]

	found_iconic_arg: INTEGER_32 assign set_found_iconic_arg

	set_found_iconic_arg (a_found_iconic_arg: INTEGER_32)
		do
			found_iconic_arg := a_found_iconic_arg
		end

	blink_state: INTEGER_32 assign set_blink_state

	set_blink_state (a_blink_state: INTEGER_32)
		do
			blink_state := a_blink_state
		end

	blink_waittime: NATURAL_32 assign set_blink_waittime

	set_blink_waittime (a_blink_waittime: NATURAL_32)
		do
			blink_waittime := a_blink_waittime
		end

	blink_ontime: NATURAL_32 assign set_blink_ontime

	set_blink_ontime (a_blink_ontime: NATURAL_32)
		do
			blink_ontime := a_blink_ontime
		end

	blink_offtime: NATURAL_32 assign set_blink_offtime

	set_blink_offtime (a_blink_offtime: NATURAL_32)
		do
			blink_offtime := a_blink_offtime
		end

	blink_timer: NATURAL_32 assign set_blink_timer

	set_blink_timer (a_blink_timer: NATURAL_32)
		do
			blink_timer := a_blink_timer
		end

	received_selection: INTEGER_32 assign set_received_selection

	set_received_selection (a_received_selection: INTEGER_32)
		do
			received_selection := a_received_selection
		end

	mouse_click_timer: NATURAL_32 assign set_mouse_click_timer

	set_mouse_click_timer (a_mouse_click_timer: NATURAL_32)
		do
			mouse_click_timer := a_mouse_click_timer
		end

	mouse_timed_out: INTEGER_32 assign set_mouse_timed_out
		do
			Result := mouse_timed_out_address[0]
		end

	set_mouse_timed_out (a_mouse_timed_out: INTEGER_32)
		do
			mouse_timed_out_address[0] := a_mouse_timed_out
		end

	mouse_timed_out_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	motion_repeat_timer: NATURAL_32 assign set_motion_repeat_timer

	set_motion_repeat_timer (a_motion_repeat_timer: NATURAL_32)
		do
			motion_repeat_timer := a_motion_repeat_timer
		end

	motion_repeat_offset: INTEGER_32 assign set_motion_repeat_offset

	set_motion_repeat_offset (a_motion_repeat_offset: INTEGER_32)
		do
			motion_repeat_offset := a_motion_repeat_offset
		end

	init_window_hints_state: INTEGER_32 assign set_init_window_hints_state

	set_init_window_hints_state (a_init_window_hints_state: INTEGER_32)
		do
			init_window_hints_state := a_init_window_hints_state
		end

	old_width: INTEGER_32 assign set_old_width

	set_old_width (a_old_width: INTEGER_32)
		do
			old_width := a_old_width
		end

	old_height: INTEGER_32 assign set_old_height

	set_old_height (a_old_height: INTEGER_32)
		do
			old_height := a_old_height
		end

	old_min_width: INTEGER_32 assign set_old_min_width

	set_old_min_width (a_old_min_width: INTEGER_32)
		do
			old_min_width := a_old_min_width
		end

	old_min_height: INTEGER_32 assign set_old_min_height

	set_old_min_height (a_old_min_height: INTEGER_32)
		do
			old_min_height := a_old_min_height
		end

	old_char_width: INTEGER_32 assign set_old_char_width

	set_old_char_width (a_old_char_width: INTEGER_32)
		do
			old_char_width := a_old_char_width
		end

	old_char_height: INTEGER_32 assign set_old_char_height

	set_old_char_height (a_old_char_height: INTEGER_32)
		do
			old_char_height := a_old_char_height
		end

	ignore_tabline_evt: INTEGER_32 assign set_ignore_tabline_evt

	set_ignore_tabline_evt (a_ignore_tabline_evt: INTEGER_32)
		do
			ignore_tabline_evt := a_ignore_tabline_evt
		end

	tabline_menu: CE_POINTER [SD_GTKWIDGET]

	tabline_tooltip: CE_POINTER [SD_GTKTOOLTIPS]

	clicked_page: INTEGER_32 assign set_clicked_page

	set_clicked_page (a_clicked_page: INTEGER_32)
		do
			clicked_page := a_clicked_page
		end

	cjk_langs: CE_ARRAY [CE_POINTER [INTEGER_8]]

	default_shape_engine: CE_POINTER [ANY]

	vimnames: CE_ARRAY [CE_ARRAY [CE_POINTER [INTEGER_8]]]

	val: CE_ARRAY [INTEGER_32]

	timed_out: INTEGER_32 assign set_timed_out
		do
			Result := timed_out_address[0]
		end

	set_timed_out (a_timed_out: INTEGER_32)
		do
			timed_out_address[0] := a_timed_out
		end

	timed_out_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	last_shape: INTEGER_32 assign set_last_shape

	set_last_shape (a_last_shape: INTEGER_32)
		do
			last_shape := a_last_shape
		end

	mshape_ids: CE_ARRAY [INTEGER_32]

feature {ANY} -- routines

	gui_mch_prepare (a_argc: CE_POINTER [INTEGER_32]; a_argv: CE_POINTER [CE_POINTER [INTEGER_8]])
		local
			l_option: CE_POINTER [PD_CMDLINE_OPTION_T]
			l_i___0: INTEGER_32
			l_len: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___6: INTEGER_32
			l_value: CE_POINTER [INTEGER_8]
			l_n_strip: INTEGER_32
			l_tmp___8: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_option.make
			create l_value.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_i___0 := 0
					l_len := 0
					Current.gui_argc := 0
					gui_argv.ce_gets (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast ((misc2_inst.alloc ((a_argc.item + 1).to_natural_32 * Pointer_bytes.to_natural_32))))
					from
					until
						js.loop_left
					loop
						js.reset
						if (gui_argv.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							g_return_if_fail_warning (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("gui_mch_prepare"), ce_string ("gui_argv != NULL"))
							js.return
						end
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if js.return_called then
						l_pos := -1 + 21 -- skip if block
					end
				when 1 then -- if:
						l_tmp___0 := gui_argc
						Current.gui_argc := gui_argc + 1
						l_tmp___1 := l_i___0
						l_i___0 := l_i___0 + 1
						gui_argv[l_tmp___0] := a_argv[l_tmp___1]
				when 2 then -- loop condition:
						if not (not js.loop_left and then (l_i___0 < a_argc.item)) then
							l_pos := -1 + 20 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if ((a_argv[l_i___0])[0]).to_integer_32 /= 45 then
							if ((a_argv[l_i___0])[0]).to_integer_32 /= 43 then
								l_i___0 := l_i___0 + 1
								js.continue
							end
						end
						if not js.loop_jumped then
							l_option.ce_gets (cmdline_options + 0)
							from
							until
								not (not js.loop_left and then (((l_option.item.name).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
							loop
								js.reset
								l_len := (strlen (l_option.item.name)).to_integer_32
								if (strncmp (a_argv[l_i___0], l_option.item.name, l_len.to_natural_32)) = 0 then
									if ((a_argv[l_i___0])[l_len]).to_integer_32 = 0 then
										js.break
									end
									if not js.loop_jumped and then (((a_argv[l_i___0])[l_len]).to_integer_32 = 61) then
										if ((l_option.item.flags).bit_and ({NATURAL_32} 256)).to_boolean then
											js.break
										end
									end
									if not js.loop_jumped then
										if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (":=")), ((a_argv[l_i___0])[l_len]).to_integer_32)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
											if ((l_option.item.flags).bit_and ({NATURAL_32} 255)) = {NATURAL_32} 9 then
												js.break
											end
										end
									end
								elseif ((l_option.item.flags).bit_and ({NATURAL_32} 2048)).to_boolean then
									if (strcmp (a_argv[l_i___0], (l_option.item.name + 1))) = 0 then
										a_argv[l_i___0] := l_option.item.name
										js.break
									end
								end
								if not js.loop_jumped then
									l_option.ce_gets (l_option + 1)
								end
							end
							js.reset
							if ((l_option.item.name).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_i___0 := l_i___0 + 1
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 19 -- skip if block
						end
				when 4 then -- if:
						if not (((l_option.item.flags).bit_and ({NATURAL_32} 1024)).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_tmp___6 := gui_argc
						Current.gui_argc := gui_argc + 1
						gui_argv[l_tmp___6] := a_argv[l_i___0]
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 7 then -- else:
						l_value.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
						if ((l_option.item.flags).bit_and ({NATURAL_32} 256)).to_boolean then
							if ((a_argv[l_i___0])[l_len]).to_integer_32 = 61 then
								l_value.ce_gets (a_argv[l_i___0] + (l_len + 1))
							elseif l_i___0 + 1 < a_argc.item then
								if (strcmp (a_argv[(l_i___0 + 1)], ce_string ("--"))) /= 0 then
									l_value.ce_gets (a_argv[(l_i___0 + 1)])
								end
							end
						end
						inspect ((l_option.item.flags).bit_and ({NATURAL_32} 255)).to_integer_32 -- switch 1 head
						when 3 then l_pos := -1 + 8
						when 4 then l_pos := -1 + 9
						when 1 then l_pos := -1 + 10
						when 2 then l_pos := -1 + 11
						when 5 then l_pos := -1 + 12
						when 6 then l_pos := -1 + 13
						when 7 then l_pos := -1 + 14
						when 8 then l_pos := -1 + 15
						when 9 then l_pos := -1 + 16
						else l_pos := -1 + 17
						end
				when 8 then -- switch 1, case 3
						globals_inst.found_reverse_arg := 1
						l_pos := -1 + 18 -- switch 1; break
				when 9 then -- switch 1, case 4
						globals_inst.found_reverse_arg := 0
						l_pos := -1 + 18 -- switch 1; break
				when 10 then -- switch 1, case 1
						globals_inst.font_argument.ce_gets (l_value)
						l_pos := -1 + 18 -- switch 1; break
				when 11 then -- switch 1, case 2
						if (l_value.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							gui_inst.gui.geom := misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (l_value))
						end
						l_pos := -1 + 18 -- switch 1; break
				when 12 then -- switch 1, case 5
						globals_inst.background_argument.ce_gets (l_value)
						l_pos := -1 + 18 -- switch 1; break
				when 13 then -- switch 1, case 6
						globals_inst.foreground_argument.ce_gets (l_value)
						l_pos := -1 + 18 -- switch 1; break
				when 14 then -- switch 1, case 7
						found_iconic_arg := 1
						l_pos := -1 + 18 -- switch 1; break
				when 15 then -- switch 1, case 8
						role_argument.ce_gets (l_value)
						l_pos := -1 + 18 -- switch 1; break
				when 16 then -- switch 1, case 9
						gui_inst.gui.dofork := 0
						globals_inst.netbeansArg.ce_gets (a_argv[l_i___0])
						l_pos := -1 + 18 -- switch 1; break
				when 17 then -- switch 1, default:
						l_pos := -1 + 18 -- switch 1; break
				when 18 then -- switch 1, done: | if done
						if ((l_option.item.flags).bit_and ({NATURAL_32} 512)).to_boolean then
							gui_inst.gui.starting := 1
						end
						if ((l_option.item.flags).bit_and ({NATURAL_32} 4096)).to_boolean then
							l_i___0 := l_i___0 + 1
						else
							a_argc.item := (a_argc.item) - 1
							if a_argc.item > l_i___0 then
								l_n_strip := 1
								if ((l_option.item.flags).bit_and ({NATURAL_32} 256)).to_boolean then
									if ((a_argv[l_i___0])[l_len]).to_integer_32 /= 61 then
										if (strcmp (a_argv[(l_i___0 + 1)], ce_string ("--"))) /= 0 then
											l_n_strip := l_n_strip + 1
											a_argc.item := (a_argc.item) - 1
											if ((l_option.item.flags).bit_and ({NATURAL_32} 1024)).to_boolean then
												l_tmp___8 := gui_argc
												Current.gui_argc := gui_argc + 1
												gui_argv[l_tmp___8] := a_argv[(l_i___0 + 1)]
											end
										end
									end
								end
								if a_argc.item > l_i___0 then
									memmove (create {CE_POINTER [ANY]}.make_cast ((a_argv + l_i___0)), create {CE_POINTER [ANY]}.make_cast ((a_argv + (l_i___0 + l_n_strip))), (a_argc.item - l_i___0).to_natural_32 * Pointer_bytes.to_natural_32).do_nothing
								end
							end
							a_argv[a_argc.item] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						end
				when 19 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 20 then -- loop done
						gui_argv[gui_argc] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	visibility_event (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTVISIBILITY]; a_data: CE_POINTER [ANY]): INTEGER_32
		do
			gui_inst.gui.visibility := a_event.item.state
			if ((gui_inst.gui.text_gc).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				gdk_gc_set_exposures (gui_inst.gui.text_gc, (gui_inst.gui.visibility /= 0).to_integer)
			end
			Result := 0
		end

	visibility_event_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent visibility_event)
		end

	expose_event (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTEXPOSE]; a_data: CE_POINTER [ANY]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (gui_inst.gui.starting).to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				term_inst.out_flush
				gui_inst.gui_redraw (a_event.item.area.x, a_event.item.area.y, a_event.item.area.width, a_event.item.area.height)
				if a_event.item.area.x < gui_inst.gui.border_offset then
					gdk_window_clear_area ((gui_inst.gui.drawarea).item.window, 0, 0, gui_inst.gui.border_offset, 0)
				end
				if a_event.item.area.y < gui_inst.gui.border_offset then
					gdk_window_clear_area ((gui_inst.gui.drawarea).item.window, 0, 0, 0, gui_inst.gui.border_offset)
				end
				if (a_event.item.area.x).to_integer_32 > globals_inst.Columns * (gui_inst.gui.char_width).to_integer_32 + (gui_inst.gui.border_offset).to_integer_32 then
					gdk_window_clear_area ((gui_inst.gui.drawarea).item.window, globals_inst.Columns.to_integer_32 * gui_inst.gui.char_width + gui_inst.gui.border_offset, 0, 0, 0)
				end
				if (a_event.item.area.y).to_integer_32 > globals_inst.Rows * (gui_inst.gui.char_height).to_integer_32 + (gui_inst.gui.border_offset).to_integer_32 then
					gdk_window_clear_area ((gui_inst.gui.drawarea).item.window, 0, globals_inst.Rows.to_integer_32 * gui_inst.gui.char_height + gui_inst.gui.border_offset, 0, 0)
				end
				Result := 0
			end
		end

	expose_event_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent expose_event)
		end

	property_event (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTPROPERTY]; a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_xev: SD_XEVENT
		do
			create l_xev.make

			if a_event.item.type = 16 then
				if a_event.item.state = {NATURAL_32} 0 then
					if (gdk_x11_drawable_get_xid (a_event.item.window)) = globals_inst.commWindow then
						if (gdk_x11_atom_to_xatom_for_display ((gtk_widget_get_display (gui_inst.gui.mainwin)), a_event.item.atom)) = globals_inst.commProperty then
							l_xev.xproperty.type := 28
							l_xev.xproperty.atom := globals_inst.commProperty
							l_xev.xproperty.window := globals_inst.commWindow
							l_xev.xproperty.state := 0
							if_xcmdsrv_inst.serverEventProc ((gdk_x11_drawable_get_xdisplay ((gdk_x11_window_get_drawable_impl (a_widget.item.window)))), l_xev.address)
						end
					end
				end
			end
			Result := 0
		end

	property_event_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent property_event)
		end

	gui_mch_set_blinking (a_waittime: INTEGER_32; a_on: INTEGER_32; a_off___0: INTEGER_32)
		do
			blink_waittime := a_waittime.to_natural_32
			blink_ontime := a_on.to_natural_32
			blink_offtime := a_off___0.to_natural_32
		end

	gui_mch_stop_blink
		do
			if blink_timer.to_boolean then
				gtk_timeout_remove (blink_timer)
				blink_timer := (0).to_natural_32
			end
			if blink_state = 1 then
				gui_inst.gui_update_cursor (1, 0)
			end
			blink_state := 0
		end

	blink_cb (a_data: CE_POINTER [ANY]): INTEGER_32
		do
			if blink_state = 2 then
				gui_inst.gui_undraw_cursor
				blink_state := 1
				blink_timer := gtk_timeout_add (blink_offtime.to_natural_32, blink_cb_address, create {CE_POINTER [ANY]}.make_shared (default_pointer))
			else
				gui_inst.gui_update_cursor (1, 0)
				blink_state := 2
				blink_timer := gtk_timeout_add (blink_ontime.to_natural_32, blink_cb_address, create {CE_POINTER [ANY]}.make_shared (default_pointer))
			end
			Result := 0
		end

	blink_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent blink_cb)
		end

	gui_mch_start_blink
		do
			if blink_timer.to_boolean then
				gtk_timeout_remove (blink_timer)
			end
			if blink_waittime.to_boolean then
				if blink_ontime.to_boolean then
					if blink_offtime.to_boolean then
						if (gui_inst.gui.in_focus).to_boolean then
							blink_timer := gtk_timeout_add (blink_waittime.to_natural_32, blink_cb_address, create {CE_POINTER [ANY]}.make_shared (default_pointer))
							blink_state := 2
							gui_inst.gui_update_cursor (1, 0)
						end
					end
				end
			end
		end

	enter_notify_event (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTCROSSING]; a_data: CE_POINTER [ANY]): INTEGER_32
		do
			if blink_state = 0 then
				gui_mch_start_blink
			end
			if globals_inst.gtk_socket_id = {NATURAL_32} 0 then
				gtk_widget_grab_focus (gui_inst.gui.drawarea)
			elseif (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.drawarea), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 4096)) = {NATURAL_32} 0 then
				gtk_widget_grab_focus (gui_inst.gui.drawarea)
			end
			Result := 0
		end

	enter_notify_event_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent enter_notify_event)
		end

	leave_notify_event (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTCROSSING]; a_data: CE_POINTER [ANY]): INTEGER_32
		do
			if blink_state /= 0 then
				gui_mch_stop_blink
			end
			Result := 0
		end

	leave_notify_event_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent leave_notify_event)
		end

	focus_in_event (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTFOCUS]; a_data: CE_POINTER [ANY]): INTEGER_32
		do
			gui_inst.gui_focus_change (1)
			if blink_state = 0 then
				gui_mch_start_blink
			end
			if (a_widget.c_pointer.to_integer_32).to_natural_32 /= ((gui_inst.gui.drawarea).c_pointer.to_integer_32).to_natural_32 then
				gtk_widget_grab_focus (gui_inst.gui.drawarea)
			end
			Result := 1
		end

	focus_in_event_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent focus_in_event)
		end

	focus_out_event (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTFOCUS]; a_data: CE_POINTER [ANY]): INTEGER_32
		do
			gui_inst.gui_focus_change (0)
			if blink_state /= 0 then
				gui_mch_stop_blink
			end
			Result := 1
		end

	focus_out_event_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent focus_out_event)
		end

	keyval_to_string (a_keyval: NATURAL_32; a_state: NATURAL_32; a_string___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_len: INTEGER_32
			l_uc: NATURAL_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_uc := gdk_keyval_to_unicode (a_keyval)
					if l_uc = {NATURAL_32} 0 then
						l_pos := -1 + 22 -- skip if block
					end
				when 1 then -- if:
						if not (((a_state).bit_and ({NATURAL_32} 4)).to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 2 then -- if:
						if not (l_uc >= {NATURAL_32} 32) then
							l_pos := -1 + 18 -- skip if block
						end
				when 3 then -- if:
						if not (l_uc < {NATURAL_32} 128) then
							l_pos := -1 + 16 -- skip if block
						end
				when 4 then -- if:
						if not (l_uc >= {NATURAL_32} 64) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						a_string___0[0] := ((l_uc).bit_and ({NATURAL_32} 31)).to_natural_8
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 7 then -- else:
						if l_uc /= {NATURAL_32} 50 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						a_string___0[0] := (('%/0/').code).to_natural_8
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if not (l_uc >= {NATURAL_32} 51) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if l_uc <= {NATURAL_32} 55 then
							a_string___0[0] := ((l_uc).bit_xor ({NATURAL_32} 40)).to_natural_8
						else
							l_pos := -1 + 13 -- goto _L
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L:
						if l_uc = {NATURAL_32} 56 then
							a_string___0[0] := (('%B').code).to_natural_8
						elseif l_uc = {NATURAL_32} 63 then
							a_string___0[0] := (127).to_natural_8
						else
							a_string___0[0] := l_uc.to_natural_8
						end
				when 14 then -- if done | if done
						l_len := 1
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						l_len := mbyte_inst.utf_char2bytes (l_uc.to_integer_32, a_string___0)
				when 17 then -- if done | if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						l_len := mbyte_inst.utf_char2bytes (l_uc.to_integer_32, a_string___0)
				when 19 then -- if done | if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						l_len := mbyte_inst.utf_char2bytes (l_uc.to_integer_32, a_string___0)
				when 21 then -- if done | if block done, skip else block:
						l_pos := -1 + 28
				when 22 then -- else:
						l_len := 1
						inspect a_keyval.to_integer_32 -- switch 1 head
						when 65289 then l_pos := -1 + 23
						when 65417 then l_pos := -1 + 23
						when 65056 then l_pos := -1 + 23
						when 65290 then l_pos := -1 + 24
						when 65293 then l_pos := -1 + 25
						when 65076 then l_pos := -1 + 25
						when 64798 then l_pos := -1 + 25
						when 65307 then l_pos := -1 + 26
						else l_pos := -1 + 27
						end
				when 23 then -- switch 1, case 65289 | switch 1, case 65417 | switch 1, case 65056
						a_string___0[0] := (('%T').code).to_natural_8
						l_pos := -1 + 28 -- switch 1; break
				when 24 then -- switch 1, case 65290
						a_string___0[0] := (('%N').code).to_natural_8
						l_pos := -1 + 28 -- switch 1; break
				when 25 then -- switch 1, case 65293 | switch 1, case 65076 | switch 1, case 64798
						a_string___0[0] := (('%R').code).to_natural_8
						l_pos := -1 + 28 -- switch 1; break
				when 26 then -- switch 1, case 65307
						a_string___0[0] := (('%/27/').code).to_natural_8
						l_pos := -1 + 28 -- switch 1; break
				when 27 then -- switch 1, default:
						l_len := 0
						l_pos := -1 + 28 -- switch 1; break
				when 28 then -- switch 1, done: | if done
						a_string___0[l_len] := (('%/0/').code).to_natural_8
						Result := l_len
				when 29 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	modifiers_gdk2vim (a_state: NATURAL_32): INTEGER_32
		local
			l_modifiers: INTEGER_32
		do
			l_modifiers := 0
			if ((a_state).bit_and ({NATURAL_32} 1)).to_boolean then
				l_modifiers := (l_modifiers).bit_or ((2))
			end
			if ((a_state).bit_and ({NATURAL_32} 4)).to_boolean then
				l_modifiers := (l_modifiers).bit_or ((4))
			end
			if ((a_state).bit_and ({NATURAL_32} 8)).to_boolean then
				l_modifiers := (l_modifiers).bit_or ((8))
			end
			if ((a_state).bit_and ({NATURAL_32} 67108864)).to_boolean then
				l_modifiers := (l_modifiers).bit_or ((16))
			end
			if ((a_state).bit_and ({NATURAL_32} 64)).to_boolean then
				l_modifiers := (l_modifiers).bit_or ((16))
			end
			Result := l_modifiers
		end

	modifiers_gdk2mouse (a_state: NATURAL_32): INTEGER_32
		local
			l_modifiers: INTEGER_32
		do
			l_modifiers := 0
			if ((a_state).bit_and ({NATURAL_32} 1)).to_boolean then
				l_modifiers := (l_modifiers).bit_or ((4))
			end
			if ((a_state).bit_and ({NATURAL_32} 4)).to_boolean then
				l_modifiers := (l_modifiers).bit_or ((16))
			end
			if ((a_state).bit_and ({NATURAL_32} 8)).to_boolean then
				l_modifiers := (l_modifiers).bit_or ((8))
			end
			Result := l_modifiers
		end

	key_press_event (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTKEY]; a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_string___0: CE_ARRAY [NATURAL_8]
			l_string2: CE_ARRAY [NATURAL_8]
			l_key_sym: NATURAL_32
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			l_modifiers: INTEGER_32
			l_key: INTEGER_32
			l_state: NATURAL_32
			l_s: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_string___0.make (<<32>>)
			create l_string2.make (<<32>>)
			create l_s.make
			create l_d.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					clipboard_event_time := a_event.item.time
					l_key_sym := a_event.item.keyval
					l_state := a_event.item.state
					if (mbyte_inst.xim_queue_key_press_event (a_event, 1)).to_boolean then
						Result := 1
						js.return
					end
					if not js.return_called then
						if l_key_sym = {NATURAL_32} 268828432 then
							l_len := 0
						elseif l_key_sym = {NATURAL_32} 268828433 then
							l_len := 0
						else
							l_len := keyval_to_string (l_key_sym, l_state, l_string2)
							if l_len > 1 then
								if globals_inst.input_conv.vc_type /= 0 then
									l_len := mbyte_inst.convert_input (l_string2, l_len, (Natural_8_bytes.to_natural_32 * (32).to_natural_32).to_integer_32)
								end
							end
							l_s.ce_gets (l_string2)
							l_d.ce_gets (l_string___0)
							l_i___0 := 0
							from
							until
								not (l_i___0 < l_len)
							loop
								l_tmp___0.ce_gets (l_d)
								l_d.ce_gets (l_d + 1)
								l_tmp___0.item := l_s[l_i___0]
								if (l_d[-1]).to_integer_32 = 155 then
									if ((l_d + 2).c_pointer.to_integer_32).to_natural_32 < ((l_string___0 + (Natural_8_bytes.to_natural_32 * (32).to_natural_32).to_integer_32).c_pointer.to_integer_32).to_natural_32 then
										l_tmp___1.ce_gets (l_d)
										l_d.ce_gets (l_d + 1)
										l_tmp___1.item := (253).to_natural_8
										l_tmp___2.ce_gets (l_d)
										l_d.ce_gets (l_d + 1)
										l_tmp___2.item := (81).to_natural_8
									end
								end
								l_i___0 := l_i___0 + 1
							end
							l_len := l_d.distance (l_string___0)
						end
						if l_key_sym = {NATURAL_32} 65056 then
							l_key_sym := (65289).to_natural_32
							l_state := (l_state).bit_or (({NATURAL_32} 1))
						end
						if ((l_state).bit_and ({NATURAL_32} 8)).to_boolean then
							if (gui_inst.gui.menu_is_active).to_boolean then
								if (option_inst.p_wak.item).to_integer_32 = 121 then
									Result := 0
									js.return
								elseif (option_inst.p_wak.item).to_integer_32 = 109 then
									if l_len = 1 then
										if (menu_inst.gui_is_menu_shortcut ((l_string___0[0]).to_integer_32)).to_boolean then
											Result := 0
											js.return
										end
									end
								end
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 19 -- skip if block
					end
				when 1 then -- if:
						if l_len /= 1 then
							l_pos := -1 + 13 -- skip if block
						end
				when 2 then -- if:
						if not (((l_state).bit_and ({NATURAL_32} 8)).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L___0
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 5 then -- else:
						if not (((l_state).bit_and ({NATURAL_32} 67108864)).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 6 then -- if: | _L___0:
						if (l_key_sym = {NATURAL_32} 65288) then
							l_pos := -1 + 13 -- skip if block
						end
				when 7 then -- if:
						if (l_key_sym = {NATURAL_32} 65535) then
							l_pos := -1 + 13 -- skip if block
						end
				when 8 then -- if:
						if (((l_string___0[0]).to_integer_32).bit_and (128)) /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 9 then -- if:
						if l_key_sym /= {NATURAL_32} 65289 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if not ((l_state).bit_and ({NATURAL_32} 1)).to_boolean then
							l_pos := -1 + 12 -- goto _L
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						if not globals_inst.enc_dbcs.to_boolean then
							l_string___0[0] := (((l_string___0[0]).to_integer_32).bit_or (128)).to_natural_8
							l_state := (l_state).bit_and (({NATURAL_32} 4294967287))
							if globals_inst.enc_utf8.to_boolean then
								l_string___0[1] := (((l_string___0[0]).to_integer_32).bit_and (191)).to_natural_8
								l_string___0[0] := ((((l_string___0[0]).to_natural_32).bit_shift_right (6)) + {NATURAL_32} 192).to_natural_8
								if (l_string___0[1]).to_integer_32 = 155 then
									l_string___0[2] := (253).to_natural_8
									l_string___0[3] := (81).to_natural_8
									l_len := 4
								else
									l_len := 2
								end
							end
						end
				when 13 then -- if done | if done | if done | if done | if done | if done
						if l_len /= 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___1
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if l_len /= 1 then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L___1:
						l_i___0 := 0
						from
						until
							not (not js.loop_left and then (special_keys[l_i___0].key_sym /= {NATURAL_32} 0))
						loop
							js.reset
							if special_keys[l_i___0].key_sym = l_key_sym then
								l_string___0[0] := (155).to_natural_8
								l_string___0[1] := special_keys[l_i___0].code0
								l_string___0[2] := special_keys[l_i___0].code1
								l_len := -3
								js.break
							end
							if not js.loop_jumped then
								l_i___0 := l_i___0 + 1
							end
						end
						js.reset
				when 18 then -- if done
						if l_len = 0 then
							Result := 1
							js.return
						end
				when 19 then -- if done
					if js.return_called then
						l_pos := -1 + 60 -- skip if block
					end
				when 20 then -- if:
						if l_len /= -3 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 53 -- goto _L___3
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 23 then -- else:
						if l_key_sym /= {NATURAL_32} 32 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_pos := -1 + 53 -- goto _L___3
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 26 then -- else:
						if l_key_sym /= {NATURAL_32} 65289 then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						l_pos := -1 + 53 -- goto _L___3
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 29 then -- else:
						if l_key_sym /= {NATURAL_32} 65293 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						l_pos := -1 + 53 -- goto _L___3
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 32 then -- else:
						if l_key_sym /= {NATURAL_32} 65290 then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 53 -- goto _L___3
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 35 then -- else:
						if l_key_sym /= {NATURAL_32} 65307 then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if:
						l_pos := -1 + 53 -- goto _L___3
				when 37 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 38 then -- else:
						if l_key_sym /= {NATURAL_32} 65417 then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						l_pos := -1 + 53 -- goto _L___3
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 41 then -- else:
						if l_key_sym /= {NATURAL_32} 65076 then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if:
						l_pos := -1 + 53 -- goto _L___3
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 44 then -- else:
						if l_key_sym /= {NATURAL_32} 64798 then
							l_pos := -1 + 47 -- skip if block
						end
				when 45 then -- if:
						l_pos := -1 + 53 -- goto _L___3
				when 46 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 47 then -- else:
						if not (globals_inst.enc_dbcs.to_boolean) then
							l_pos := -1 + 54 -- skip if block
						end
				when 48 then -- if:
						if l_len /= 1 then
							l_pos := -1 + 54 -- skip if block
						end
				when 49 then -- if:
						if not (((l_state).bit_and ({NATURAL_32} 8)).to_boolean) then
							l_pos := -1 + 52 -- skip if block
						end
				when 50 then -- if:
						l_pos := -1 + 53 -- goto _L___3
				when 51 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 52 then -- else:
						if not (((l_state).bit_and ({NATURAL_32} 67108864)).to_boolean) then
							l_pos := -1 + 54 -- skip if block
						end
				when 53 then -- if: | _L___3:
						l_modifiers := modifiers_gdk2vim (l_state)
						if l_len = -3 then
							if (l_string___0[1]).to_integer_32 = 254 then
								l_key := 128
							else
								if (l_string___0[1]).to_integer_32 = 255 then
									l_tmp___4 := -(255 + ((88).bit_shift_left (8)))
								else
									l_tmp___4 := -((l_string___0[1]).to_integer_32 + (((l_string___0[2]).to_integer_32).bit_shift_left (8)))
								end
								l_key := l_tmp___4
							end
						else
							l_key := (l_string___0[0]).to_integer_32
						end
						l_key := misc2_inst.simplify_key (l_key, create {CE_POINTER [INTEGER_32]}.make_shared ($l_modifiers))
						if l_key = 155 then
							l_key := -(253 + ((81).bit_shift_left (8)))
						end
						if l_key < 0 then
							l_string___0[0] := (155).to_natural_8
							if l_key = 128 then
								l_string___0[1] := (254).to_natural_8
							else
								if l_key = 0 then
									l_tmp___5 := 255
								else
									l_tmp___5 := (-l_key).bit_and (255)
								end
								l_string___0[1] := l_tmp___5.to_natural_8
							end
							if l_key = 128 then
								l_string___0[2] := (('X').code).to_natural_8
							elseif l_key = 0 then
								l_string___0[2] := (('X').code).to_natural_8
							else
								l_string___0[2] := (((((-l_key).to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 255)).to_natural_8
							end
							l_len := 3
						else
							l_string___0[0] := l_key.to_natural_8
							l_len := 1
						end
						if l_modifiers /= 0 then
							l_string2[0] := (155).to_natural_8
							l_string2[1] := (252).to_natural_8
							l_string2[2] := l_modifiers.to_natural_8
							ui_inst.add_to_input_buf (l_string2, 3)
						end
				when 54 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
						if l_len /= 1 then
							l_pos := -1 + 59 -- skip if block
						end
				when 55 then -- if:
						if (l_string___0[0]).to_integer_32 /= 3 then
							l_pos := -1 + 58 -- skip if block
						end
				when 56 then -- if:
						if globals_inst.ctrl_c_interrupts.to_boolean then
							ui_inst.trash_input_buf
							globals_inst.got_int := 1
						else
							l_pos := -1 + 58 -- goto _L___4
						end
				when 57 then -- if block done, skip else block:
						l_pos := -1 + 59
				when 58 then -- else: | _L___4:
						if (l_string___0[0]).to_integer_32 = globals_inst.intr_char then
							if globals_inst.intr_char /= 3 then
								ui_inst.trash_input_buf
								globals_inst.got_int := 1
							end
						end
				when 59 then -- if done
						ui_inst.add_to_input_buf (l_string___0, l_len)
						if option_inst.p_mh.to_boolean then
							gui_mch_mousehide (1)
						end
						Result := 1
				when 60 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	key_press_event_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent key_press_event)
		end

	key_release_event (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTKEY]; a_data: CE_POINTER [ANY]): INTEGER_32
		do
			clipboard_event_time := a_event.item.time
			Result := (mbyte_inst.xim_queue_key_press_event (a_event, 0))
		end

	key_release_event_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent key_release_event)
		end

	selection_clear_event (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTSELECTION]; a_user_data: CE_POINTER [ANY]): INTEGER_32
		do
			if ((a_event.item.selection).c_pointer.to_integer_32).to_natural_32 = ((globals_inst.clip_plus.gtk_sel_atom).c_pointer.to_integer_32).to_natural_32 then
				ui_inst.clip_lose_selection (globals_inst.clip_plus.address)
			else
				ui_inst.clip_lose_selection (globals_inst.clip_star.address)
			end
			Result := 1
		end

	selection_clear_event_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent selection_clear_event)
		end

	selection_received_cb (a_widget: CE_POINTER [SD_GTKWIDGET]; a_data: CE_POINTER [SD_GTKSELECTIONDATA]; a_time_: NATURAL_32; a_user_data: CE_POINTER [ANY])
		local
			l_cbd: CE_POINTER [PD_VIMCLIPBOARD]
			l_text: CE_POINTER [NATURAL_8]
			l_tmpbuf: CE_POINTER [NATURAL_8]
			l_tmpbuf_utf8: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_motion_type: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_enc: CE_POINTER [NATURAL_8]
			l_conv: PD_VIMCONV_T
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_conv___0: PD_VIMCONV_T
			js: JUMP_STATE
		do
			create l_cbd.make
			create l_text.make
			create l_tmpbuf.make
			create l_tmpbuf_utf8.make
			create l_tmp.make
			create l_enc.make
			create l_conv.make
			create l_tmp___0.make
			create l_conv___0.make

			l_tmpbuf.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			l_tmpbuf_utf8.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			if ((a_data.item.selection).c_pointer.to_integer_32).to_natural_32 = ((globals_inst.clip_plus.gtk_sel_atom).c_pointer.to_integer_32).to_natural_32 then
				l_cbd.ce_gets (globals_inst.clip_plus.address)
			else
				l_cbd.ce_gets (globals_inst.clip_star.address)
			end
			l_text.ce_gets (a_data.item.data)
			l_len := a_data.item.length
			l_motion_type := 0
			if (l_text.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				received_selection := 2
				js.return
			elseif l_len <= 0 then
				received_selection := 2
				js.return
			end
			if not js.return_called then
				if ((a_data.item.type).c_pointer.to_integer_32).to_natural_32 = (vim_atom___0.c_pointer.to_integer_32).to_natural_32 then
					l_tmp.ce_gets (l_text)
					l_text.ce_gets (l_text + 1)
					l_motion_type := (l_tmp.item).to_integer_32
					l_len := l_len - 1
				elseif ((a_data.item.type).c_pointer.to_integer_32).to_natural_32 = (vimenc_atom___0.c_pointer.to_integer_32).to_natural_32 then
					l_tmp___0.ce_gets (l_text)
					l_text.ce_gets (l_text + 1)
					l_motion_type := (l_tmp___0.item).to_integer_32
					l_len := l_len - 1
					l_enc.ce_gets (l_text)
					l_text.ce_gets (l_text + ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_text))) + {NATURAL_32} 1).to_integer_32)
					l_len := l_len - (l_text.distance (l_enc))
					l_conv.vc_type := 0
					mbyte_inst.convert_setup (l_conv.address, l_enc, option_inst.p_enc).do_nothing
					if l_conv.vc_type /= 0 then
						l_tmpbuf.ce_gets (mbyte_inst.string_convert (l_conv.address, l_text, create {CE_POINTER [INTEGER_32]}.make_shared ($l_len)))
						if (l_tmpbuf.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_text.ce_gets (l_tmpbuf)
						end
						mbyte_inst.convert_setup (l_conv.address, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
					end
				else
					l_tmpbuf_utf8.ce_gets (gtk_selection_data_get_text (a_data))
					if (l_tmpbuf_utf8.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmpbuf_utf8))).to_integer_32
						if globals_inst.input_conv.vc_type /= 0 then
							l_tmpbuf.ce_gets (mbyte_inst.string_convert (globals_inst.input_conv.address, l_tmpbuf_utf8, create {CE_POINTER [INTEGER_32]}.make_shared ($l_len)))
							if (l_tmpbuf.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_text.ce_gets (l_tmpbuf)
							end
						else
							l_text.ce_gets (l_tmpbuf_utf8)
						end
					elseif l_len >= 2 then
						if (l_text[0]).to_integer_32 = 255 then
							if (l_text[1]).to_integer_32 = 254 then
								l_conv___0.vc_type := 0
								mbyte_inst.convert_setup_ext (l_conv___0.address, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("utf-16le")), 0, option_inst.p_enc, 1).do_nothing
								if l_conv___0.vc_type /= 0 then
									l_text.ce_gets (l_text + (2))
									l_len := l_len - (2)
									l_tmpbuf.ce_gets (mbyte_inst.string_convert (l_conv___0.address, l_text, create {CE_POINTER [INTEGER_32]}.make_shared ($l_len)))
									mbyte_inst.convert_setup (l_conv___0.address, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
								end
								if (l_tmpbuf.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_text.ce_gets (l_tmpbuf)
								end
							end
						end
					end
				end
				from
				until
					js.loop_left
				loop
					js.reset
					if l_len > 0 then
						if (l_text[(l_len - 1)]).to_integer_32 /= 0 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_len := l_len - 1
					end
				end
				js.reset
				ops_inst.clip_yank_selection (l_motion_type, l_text, l_len.to_integer_32, l_cbd)
				received_selection := 1
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tmpbuf))
				g_free (create {CE_POINTER [ANY]}.make_cast (l_tmpbuf_utf8))
			end
		end

	selection_received_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent selection_received_cb)
		end

	selection_get_cb (a_widget: CE_POINTER [SD_GTKWIDGET]; a_selection_data: CE_POINTER [SD_GTKSELECTIONDATA]; a_info: NATURAL_32; a_time_: NATURAL_32; a_user_data: CE_POINTER [ANY])
		local
			l_string___0: CE_POINTER [NATURAL_8]
			l_tmpbuf: CE_POINTER [NATURAL_8]
			l_tmplen: NATURAL_32
			l_length: INTEGER_32
			l_motion_type: INTEGER_32
			l_type: CE_POINTER [ANY]
			l_cbd: CE_POINTER [PD_VIMCLIPBOARD]
			l_conv: PD_VIMCONV_T
			l_l: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_string___0.make
			create l_tmpbuf.make
			create l_type.make
			create l_cbd.make
			create l_conv.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((a_selection_data.item.selection).c_pointer.to_integer_32).to_natural_32 = ((globals_inst.clip_plus.gtk_sel_atom).c_pointer.to_integer_32).to_natural_32 then
						l_cbd.ce_gets (globals_inst.clip_plus.address)
					else
						l_cbd.ce_gets (globals_inst.clip_star.address)
					end
					if not (l_cbd.item.owned).to_boolean then
						js.return
					end
					if not (not js.return_called and then (a_info /= {NATURAL_32} 2)) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if globals_inst.clip_html.to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if a_info = {NATURAL_32} 4 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if a_info /= {NATURAL_32} 1 then
							if a_info /= {NATURAL_32} 9 then
								if a_info /= {NATURAL_32} 8 then
									if a_info /= {NATURAL_32} 3 then
										if a_info /= {NATURAL_32} 5 then
											js.return
										end
									end
								end
							end
						end
				when 6 then -- if done | if done
						if not js.return_called then
							ops_inst.clip_get_selection (l_cbd)
							l_motion_type := ops_inst.clip_convert_selection (l_string___0.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_tmplen), l_cbd)
							if l_motion_type < 0 then
								js.return
							elseif (l_string___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.return
							end
						end
						if not js.return_called then
							if l_tmplen < {NATURAL_32} 2147483646 then
								l_length := l_tmplen.to_integer_32
							else
								l_length := 2147483646
							end
							if a_info = {NATURAL_32} 8 then
								l_tmpbuf.ce_gets (misc2_inst.alloc (l_length.to_natural_32 + {NATURAL_32} 1))
								if (l_tmpbuf.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_tmpbuf[0] := l_motion_type.to_natural_8
									memmove (create {CE_POINTER [ANY]}.make_cast ((l_tmpbuf + 1)), create {CE_POINTER [ANY]}.make_cast (l_string___0), l_length.to_natural_32).do_nothing
								end
								l_length := l_length + 1
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_string___0))
								l_string___0.ce_gets (l_tmpbuf)
								l_type.ce_gets (vim_atom___0)
							elseif a_info = {NATURAL_32} 4 then
								l_conv.vc_type := 0
								mbyte_inst.convert_setup_ext (l_conv.address, option_inst.p_enc, 1, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("utf-16le")), 0).do_nothing
								if l_conv.vc_type /= 0 then
									l_tmpbuf.ce_gets (mbyte_inst.string_convert (l_conv.address, l_string___0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_length)))
									mbyte_inst.convert_setup (l_conv.address, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_string___0))
									l_string___0.ce_gets (l_tmpbuf)
								end
								if (l_string___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_tmpbuf.ce_gets (misc2_inst.alloc ((l_length + 2).to_natural_32))
									l_tmpbuf[0] := (255).to_natural_8
									l_tmpbuf[1] := (254).to_natural_8
									memmove (create {CE_POINTER [ANY]}.make_cast ((l_tmpbuf + 2)), create {CE_POINTER [ANY]}.make_cast (l_string___0), l_length.to_natural_32).do_nothing
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_string___0))
									l_string___0.ce_gets (l_tmpbuf)
									l_length := l_length + (2)
									a_selection_data.item.type := a_selection_data.item.target
									a_selection_data.item.format := 16
									gtk_selection_data_set (a_selection_data, html_atom, 16, l_string___0, l_length)
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_string___0))
								end
								js.return
							elseif a_info = {NATURAL_32} 9 then
								l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_enc))).to_integer_32
								l_tmpbuf.ce_gets (misc2_inst.alloc ((l_length.to_natural_32 + l_l.to_natural_32) + {NATURAL_32} 2))
								if (l_tmpbuf.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_tmpbuf[0] := l_motion_type.to_natural_8
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_tmpbuf + 1)), create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_enc)).do_nothing
									memmove (create {CE_POINTER [ANY]}.make_cast (((l_tmpbuf + l_l) + 2)), create {CE_POINTER [ANY]}.make_cast (l_string___0), l_length.to_natural_32).do_nothing
								end
								l_length := l_length + (l_l + 2)
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_string___0))
								l_string___0.ce_gets (l_tmpbuf)
								l_type.ce_gets (vimenc_atom___0)
							else
								if globals_inst.output_conv.vc_type /= 0 then
									l_tmpbuf.ce_gets (mbyte_inst.string_convert (globals_inst.output_conv.address, l_string___0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_length)))
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_string___0))
									if (l_tmpbuf.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										js.return
									end
									if not js.return_called then
										l_string___0.ce_gets (l_tmpbuf)
									end
								end
								if not js.return_called then
									if (g_utf8_validate (create {CE_POINTER [INTEGER_8]}.make_cast (l_string___0), l_length, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer))).to_boolean then
										gtk_selection_data_set_text (a_selection_data, create {CE_POINTER [INTEGER_8]}.make_cast (l_string___0), l_length).do_nothing
									end
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_string___0))
									js.return
								end
							end
						end
						if not js.return_called and then ((l_string___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32) then
							a_selection_data.item.type := a_selection_data.item.target
							a_selection_data.item.format := 8
							gtk_selection_data_set (a_selection_data, l_type, 8, l_string___0, l_length)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_string___0))
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	selection_get_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent selection_get_cb)
		end

	gui_mch_init_check: INTEGER_32
		local
			js: JUMP_STATE
		do
			if not (gtk_init_check (gui_argc_address, gui_argv.address)).to_boolean then
				gui_inst.gui.dying := 1
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_opendisp))))).do_nothing
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 1
			end
		end

	mouse_click_timer_cb (a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_timed_out___0: CE_POINTER [INTEGER_32]
		do
			create l_timed_out___0.make

			l_timed_out___0.ce_gets (create {CE_POINTER [INTEGER_32]}.make_cast (a_data))
			l_timed_out___0.item := 1
			Result := 0
		end

	mouse_click_timer_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent mouse_click_timer_cb)
		end

	process_motion_notify (a_x___0: INTEGER_32; a_y: INTEGER_32; a_state: INTEGER_32)
		local
			l_button: INTEGER_32
			l_vim_modifiers: NATURAL_32
			l_dx: INTEGER_32
			l_dy: INTEGER_32
			l_offshoot: INTEGER_32
			l_delay: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((a_state.to_natural_32).bit_and ({NATURAL_32} 7936)).to_boolean then
						l_button := 67
					else
						l_button := (' ').code
					end
					gui_mch_mousehide (0)
					if l_button /= 67 then
						gui_inst.gui_mouse_moved (a_x___0, a_y)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						l_vim_modifiers := (modifiers_gdk2mouse (a_state.to_natural_32)).to_natural_32
						gui_inst.gui_send_mouse_event (l_button, a_x___0, a_y, 0, l_vim_modifiers)
						if not (a_x___0 < 0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 4 then -- else:
						if not (a_y < 0) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 7 then -- else:
						if not (a_x___0 >= (gui_inst.gui.drawarea).item.allocation.width) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else:
						if not (a_y >= (gui_inst.gui.drawarea).item.allocation.height) then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L:
						l_delay := 10
						if a_x___0 < 0 then
							l_dx := -a_x___0
						else
							l_dx := a_x___0 - (gui_inst.gui.drawarea).item.allocation.width
						end
						if a_y < 0 then
							l_dy := -a_y
						else
							l_dy := a_y - (gui_inst.gui.drawarea).item.allocation.height
						end
						if l_dx > l_dy then
							l_offshoot := l_dx
						else
							l_offshoot := l_dy
						end
						if l_offshoot > 127 then
							l_delay := 5
						else
							l_delay := (130 * (127 - l_offshoot)) // 127 + 5
						end
						if not motion_repeat_timer.to_boolean then
							motion_repeat_timer := gtk_timeout_add (l_delay.to_natural_32, motion_repeat_timer_cb_address, create {CE_POINTER [ANY]}.make_shared (default_pointer))
						end
				when 12 then -- if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	motion_repeat_timer_cb (a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_x___0: INTEGER_32
			l_y: INTEGER_32
			l_state: INTEGER_32
			js: JUMP_STATE
		do
			gdk_window_get_pointer ((gui_inst.gui.drawarea).item.window, create {CE_POINTER [INTEGER_32]}.make_shared ($l_x___0), create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), create {CE_POINTER [INTEGER_32]}.make_shared ($l_state)).do_nothing
			if not ((l_state.to_natural_32).bit_and ({NATURAL_32} 7936)).to_boolean then
				motion_repeat_timer := (0).to_natural_32
				Result := 0
				js.return
			end
			if not js.return_called then
				if (ui_inst.vim_used_in_input_buf) > 10 then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				motion_repeat_timer := (0).to_natural_32
				if motion_repeat_offset.to_boolean then
					l_x___0 := l_x___0 + (gui_inst.gui.char_width)
				end
				motion_repeat_offset := (not motion_repeat_offset.to_boolean).to_integer
				process_motion_notify (l_x___0, l_y, l_state)
				Result := 0
			end
		end

	motion_repeat_timer_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent motion_repeat_timer_cb)
		end

	motion_notify_event (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTMOTION]; a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_x___0: INTEGER_32
			l_y: INTEGER_32
			l_state: INTEGER_32
		do
			if (a_event.item.is_hint).to_boolean then
				gdk_window_get_pointer (a_widget.item.window, create {CE_POINTER [INTEGER_32]}.make_shared ($l_x___0), create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), create {CE_POINTER [INTEGER_32]}.make_shared ($l_state)).do_nothing
				process_motion_notify (l_x___0, l_y, l_state)
			else
				process_motion_notify ((a_event.item.x).truncated_to_integer, (a_event.item.y).truncated_to_integer, (a_event.item.state).to_integer_32)
			end
			Result := 1
		end

	motion_notify_event_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent motion_notify_event)
		end

	button_press_event (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTBUTTON]; a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_button: INTEGER_32
			l_repeated_click: INTEGER_32
			l_x___0: INTEGER_32
			l_y: INTEGER_32
			l_vim_modifiers: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_repeated_click := 0
					clipboard_event_time := a_event.item.time
					if globals_inst.gtk_socket_id /= {NATURAL_32} 0 then
						if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 4096)) = {NATURAL_32} 0 then
							gtk_widget_grab_focus (a_widget)
						end
					end
					if a_event.item.type /= 4 then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_x___0 := (a_event.item.x).truncated_to_integer
						l_y := (a_event.item.y).truncated_to_integer
						if not mouse_timed_out.to_boolean then
							if mouse_click_timer.to_boolean then
								gtk_timeout_remove (mouse_click_timer)
								mouse_click_timer := (0).to_natural_32
								l_repeated_click := 1
							end
						end
						Current.mouse_timed_out := 0
						mouse_click_timer := gtk_timeout_add (option_inst.p_mouset.to_natural_32, mouse_click_timer_cb_address, create {CE_POINTER [ANY]}.make_cast ((mouse_timed_out_address)))
						inspect (a_event.item.button).to_integer_32 -- switch 1 head
						when 1 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 2 then -- switch 1, case 1
						l_button := 0
						l_pos := -1 + 6 -- switch 1; break
				when 3 then -- switch 1, case 2
						l_button := 1
						l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 3
						l_button := 2
						l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, default:
						Result := 0
						js.return
				when 6 then -- switch 1, done: | if done
						if not js.return_called then
							if (mbyte_inst.im_is_preediting).to_boolean then
								mbyte_inst.xim_reset
							end
							l_vim_modifiers := (modifiers_gdk2mouse (a_event.item.state)).to_natural_32
							gui_inst.gui_send_mouse_event (l_button, l_x___0, l_y, l_repeated_click, l_vim_modifiers)
							Result := 1
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	button_press_event_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent button_press_event)
		end

	scroll_event (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTSCROLL]; a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_button: INTEGER_32
			l_vim_modifiers: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if globals_inst.gtk_socket_id /= {NATURAL_32} 0 then
						if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 4096)) = {NATURAL_32} 0 then
							gtk_widget_grab_focus (a_widget)
						end
					end
					inspect a_event.item.direction -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 0
					l_button := 256
					l_pos := -1 + 6 -- switch 1; break
				when 2 then -- switch 1, case 1
					l_button := 512
					l_pos := -1 + 6 -- switch 1; break
				when 3 then -- switch 1, case 2
					l_button := 1536
					l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 3
					l_button := 1280
					l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, default:
					Result := 0
					js.return
				when 6 then -- switch 1, done:
					if not js.return_called then
						if (mbyte_inst.im_is_preediting).to_boolean then
							mbyte_inst.xim_reset
						end
						l_vim_modifiers := (modifiers_gdk2mouse (a_event.item.state)).to_natural_32
						gui_inst.gui_send_mouse_event (l_button, (a_event.item.x).truncated_to_integer, (a_event.item.y).truncated_to_integer, 0, l_vim_modifiers)
						Result := 1
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	scroll_event_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent scroll_event)
		end

	button_release_event (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTBUTTON]; a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_x___0: INTEGER_32
			l_y: INTEGER_32
			l_vim_modifiers: NATURAL_32
		do
			clipboard_event_time := a_event.item.time
			if motion_repeat_timer.to_boolean then
				gtk_timeout_remove (motion_repeat_timer)
				motion_repeat_timer := (0).to_natural_32
			end
			l_x___0 := (a_event.item.x).truncated_to_integer
			l_y := (a_event.item.y).truncated_to_integer
			l_vim_modifiers := (modifiers_gdk2mouse (a_event.item.state)).to_natural_32
			gui_inst.gui_send_mouse_event (3, l_x___0, l_y, 0, l_vim_modifiers)
			Result := 1
		end

	button_release_event_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent button_release_event)
		end

	count_and_decode_uri_list (a_out: CE_POINTER [NATURAL_8]; a_raw: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_count___2: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (a_out)
					l_count___2 := 0
					l_i___0 := 0
				when 1 then -- loop condition:
					if not (l_i___0 < a_len) then
						l_pos := -1 + 13 -- skip loop
					end
				when 2 then -- loop body:
						if (a_raw[l_i___0]).to_integer_32 /= 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 5 then -- else:
						if (a_raw[l_i___0]).to_integer_32 /= 10 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 8 then -- else:
						if (a_raw[l_i___0]).to_integer_32 /= 13 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if: | _L:
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (a_out.c_pointer.to_integer_32).to_natural_32 then
							if (l_p___0[-1]).to_integer_32 /= 0 then
								l_count___2 := l_count___2 + 1
								l_tmp.ce_gets (l_p___0)
								l_p___0.ce_gets (l_p___0 + 1)
								l_tmp.item := (('%/0/').code).to_natural_8
							end
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						if (a_raw[l_i___0]).to_integer_32 = 37 then
							if l_i___0 + 2 < a_len then
								if (charset_inst.hexhex2nr ((a_raw + l_i___0) + 1)) > 0 then
									l_tmp___0.ce_gets (l_p___0)
									l_p___0.ce_gets (l_p___0 + 1)
									l_tmp___0.item := (charset_inst.hexhex2nr ((a_raw + l_i___0) + 1)).to_natural_8
									l_i___0 := l_i___0 + (2)
								else
									l_tmp___2.ce_gets (l_p___0)
									l_p___0.ce_gets (l_p___0 + 1)
									l_tmp___2.item := a_raw[l_i___0]
								end
							else
								l_tmp___2.ce_gets (l_p___0)
								l_p___0.ce_gets (l_p___0 + 1)
								l_tmp___2.item := a_raw[l_i___0]
							end
						else
							l_tmp___2.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___2.item := a_raw[l_i___0]
						end
				when 12 then -- if done | if done
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 1 -- back to loop condition
				when 13 then -- loop done
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (a_out.c_pointer.to_integer_32).to_natural_32 then
						if (l_p___0[-1]).to_integer_32 /= 0 then
							l_p___0.item := (('%/0/').code).to_natural_8
							l_count___2 := l_count___2 + 1
						end
					end
					Result := l_count___2
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	filter_uri_list (a_outlist: CE_POINTER [CE_POINTER [NATURAL_8]]; a_max: INTEGER_32; a_src: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_src: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_src.make

			l_src.ce_gets (a_src)
			l_j := 0
			l_i___0 := l_j
			from
			until
				not (not js.loop_left and then (l_i___0 < a_max))
			loop
				a_outlist[l_i___0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_src), ce_string ("file:"), (5).to_natural_32)) = 0 then
					l_src.ce_gets (l_src + (5))
					if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_src), ce_string ("//localhost"), (11).to_natural_32)) = 0 then
						l_src.ce_gets (l_src + (11))
					end
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_src[0]).to_integer_32 = 47 then
							if (l_src[1]).to_integer_32 /= 47 then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_src.ce_gets (l_src + 1)
						end
					end
					js.reset
					l_tmp___0 := l_j
					l_j := l_j + 1
					a_outlist[l_tmp___0] := misc2_inst.vim_strsave (l_src)
				end
				l_src.ce_gets (l_src + ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_src))) + {NATURAL_32} 1).to_integer_32)
				l_i___0 := l_i___0 + 1
			end
			Result := l_j
		end

	parse_uri_list (a_count___2: CE_POINTER [INTEGER_32]; a_data: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): CE_POINTER [CE_POINTER [NATURAL_8]]
		local
			l_n: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_array: CE_POINTER [CE_POINTER [NATURAL_8]]
		do
			create l_tmp.make
			create l_array.make

			l_n := 0
			l_tmp.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			l_array.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))
			if (a_data.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if a_len > 0 then
					l_tmp.ce_gets ((misc2_inst.alloc ((a_len + 1).to_natural_32)))
					if (l_tmp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_n := count_and_decode_uri_list (l_tmp, a_data, a_len)
						if l_n > 0 then
							l_array.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((misc2_inst.alloc (l_n.to_natural_32 * Pointer_bytes.to_natural_32))))
							if (l_array.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_n := filter_uri_list (l_array, l_n, l_tmp)
							end
						end
					end
				end
			end
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tmp))
			a_count___2.item := l_n
			Result := l_array
		end

	drag_handle_uri_list (a_context: CE_POINTER [SD_GDKDRAGCONTEXT]; a_data: CE_POINTER [SD_GTKSELECTIONDATA]; a_time_: NATURAL_32; a_state: INTEGER_32; a_x___0: INTEGER_32; a_y: INTEGER_32)
		local
			l_fnames: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_nfiles: INTEGER_32
			l_modifiers: NATURAL_32
		do
			create l_fnames.make

			l_nfiles := 0
			l_fnames.ce_gets (parse_uri_list (create {CE_POINTER [INTEGER_32]}.make_shared ($l_nfiles), a_data.item.data, a_data.item.length))
			if (l_fnames.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if l_nfiles > 0 then
					gtk_drag_finish (a_context, 1, 0, a_time_)
					l_modifiers := (modifiers_gdk2mouse (a_state.to_natural_32)).to_natural_32
					gui_inst.gui_handle_drop (a_x___0, a_y, l_modifiers, l_fnames, l_nfiles)
				else
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fnames))
				end
			else
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fnames))
			end
		end

	drag_handle_text (a_context: CE_POINTER [SD_GDKDRAGCONTEXT]; a_data: CE_POINTER [SD_GTKSELECTIONDATA]; a_time_: NATURAL_32; a_state: INTEGER_32)
		local
			l_dropkey: CE_ARRAY [NATURAL_8]
			l_text: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmpbuf: CE_POINTER [NATURAL_8]
		do
			create l_dropkey.make (<<6>>)
			create l_text.make
			create l_tmpbuf.make

			l_dropkey[0] := (155).to_natural_8
			l_dropkey[1] := (252).to_natural_8
			l_dropkey[2] := (0).to_natural_8
			l_dropkey[3] := (155).to_natural_8
			l_dropkey[4] := (253).to_natural_8
			l_dropkey[5] := (95).to_natural_8
			l_tmpbuf.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			l_text.ce_gets (a_data.item.data)
			l_len := a_data.item.length
			if ((a_data.item.type).c_pointer.to_integer_32).to_natural_32 = (utf8_string_atom.c_pointer.to_integer_32).to_natural_32 then
				if globals_inst.input_conv.vc_type /= 0 then
					l_tmpbuf.ce_gets (mbyte_inst.string_convert (globals_inst.input_conv.address, l_text, create {CE_POINTER [INTEGER_32]}.make_shared ($l_len)))
				end
				if (l_tmpbuf.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					l_text.ce_gets (l_tmpbuf)
				end
			end
			ops_inst.dnd_yank_drag_data (l_text, l_len.to_integer_32)
			gtk_drag_finish (a_context, 1, 0, a_time_)
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tmpbuf))
			l_dropkey[2] := (modifiers_gdk2vim (a_state.to_natural_32)).to_natural_8
			if (l_dropkey[2]).to_integer_32 /= 0 then
				ui_inst.add_to_input_buf (l_dropkey, (Natural_8_bytes.to_natural_32 * (6).to_natural_32).to_integer_32)
			else
				ui_inst.add_to_input_buf (l_dropkey + 3, ((Natural_8_bytes.to_natural_32 * (6).to_natural_32) - {NATURAL_32} 3).to_integer_32)
			end
		end

	drag_data_received_cb (a_widget: CE_POINTER [SD_GTKWIDGET]; a_context: CE_POINTER [SD_GDKDRAGCONTEXT]; a_x___0: INTEGER_32; a_y: INTEGER_32; a_data: CE_POINTER [SD_GTKSELECTIONDATA]; a_info: NATURAL_32; a_time_: NATURAL_32; a_user_data: CE_POINTER [ANY])
		local
			l_state: INTEGER_32
			js: JUMP_STATE
		do
			if ((a_data.item.data).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				gtk_drag_finish (a_context, 0, 0, a_time_)
				js.return
			elseif a_data.item.length <= 0 then
				gtk_drag_finish (a_context, 0, 0, a_time_)
				js.return
			elseif a_data.item.format /= 8 then
				gtk_drag_finish (a_context, 0, 0, a_time_)
				js.return
			elseif (a_data.item.data[a_data.item.length]).to_integer_32 /= 0 then
				gtk_drag_finish (a_context, 0, 0, a_time_)
				js.return
			end
			if not js.return_called then
				gdk_window_get_pointer (a_widget.item.window, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_state)).do_nothing
				if a_info = {NATURAL_32} 6 then
					drag_handle_uri_list (a_context, a_data, a_time_, l_state, a_x___0, a_y)
				else
					drag_handle_text (a_context, a_data, a_time_, l_state)
				end
			end
		end

	drag_data_received_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent drag_data_received_cb)
		end

	local_xsmp_handle_requests (a_source: CE_POINTER [SD_GIOCHANNEL]; a_condition: INTEGER_32; a_data: CE_POINTER [ANY]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_condition.to_natural_32 = {NATURAL_32} 1 then
				if (os_unix_inst.xsmp_handle_requests) = 0 then
					g_io_channel_unref (create {CE_POINTER [SD_GIOCHANNEL]}.make_cast (a_data))
				end
				Result := 1
				js.return
			end
			if not js.return_called then
				g_io_channel_unref (create {CE_POINTER [SD_GIOCHANNEL]}.make_cast (a_data))
				os_unix_inst.xsmp_close
				Result := 1
			end
		end

	local_xsmp_handle_requests_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent local_xsmp_handle_requests)
		end

	setup_save_yourself
		local
			l_existing_atoms: CE_POINTER [NATURAL_32]
			l_count___2: INTEGER_32
			l_g_io: CE_POINTER [SD_GIOCHANNEL]
			l_new_atoms: CE_POINTER [NATURAL_32]
			l_save_yourself_xatom: NATURAL_32
			l_i___0: INTEGER_32
			l_tmp___2: NATURAL_32
			l_tmp___5: NATURAL_32
			js: JUMP_STATE
		do
			create l_existing_atoms.make
			create l_g_io.make
			create l_new_atoms.make

			l_existing_atoms.ce_gets (create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer))
			l_count___2 := 0
			if globals_inst.xsmp_icefd /= -1 then
				l_g_io.ce_gets ((g_io_channel_unix_new (globals_inst.xsmp_icefd)))
				g_io_add_watch (l_g_io, 25, local_xsmp_handle_requests_address, create {CE_POINTER [ANY]}.make_cast (l_g_io)).do_nothing
			else
				l_tmp___5 := gdk_x11_drawable_get_xid ((gui_inst.gui.mainwin).item.window)
				if (XGetWMProtocols ((gdk_x11_drawable_get_xdisplay ((gdk_x11_window_get_drawable_impl ((gui_inst.gui.mainwin).item.window)))), l_tmp___5, l_existing_atoms.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_count___2))).to_boolean then
					l_save_yourself_xatom := gdk_x11_atom_to_xatom_for_display ((gtk_widget_get_display (gui_inst.gui.mainwin)), save_yourself_atom)
					l_i___0 := 0
					from
					until
						not (not js.loop_left and then (l_i___0 < l_count___2))
					loop
						js.reset
						if l_existing_atoms[l_i___0] = l_save_yourself_xatom then
							js.break
						end
						if not js.loop_jumped then
							l_i___0 := l_i___0 + 1
						end
					end
					js.reset
					if l_i___0 = l_count___2 then
						l_new_atoms.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((misc2_inst.alloc ((l_count___2 + 1).to_natural_32 * Natural_32_bytes.to_natural_32))))
						if (l_new_atoms.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_new_atoms), create {CE_POINTER [ANY]}.make_cast (l_existing_atoms), l_count___2.to_natural_32 * Natural_32_bytes.to_natural_32).do_nothing
							l_new_atoms[l_count___2] := l_save_yourself_xatom
							l_tmp___2 := gdk_x11_drawable_get_xid ((gui_inst.gui.mainwin).item.window)
							XSetWMProtocols ((gdk_x11_drawable_get_xdisplay ((gdk_x11_window_get_drawable_impl ((gui_inst.gui.mainwin).item.window)))), l_tmp___2, l_new_atoms, l_count___2 + 1).do_nothing
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_new_atoms))
						end
					end
					XFree (create {CE_POINTER [ANY]}.make_cast (l_existing_atoms)).do_nothing
				end
			end
		end

	global_event_filter (a_xev: CE_POINTER [ANY]; a_event: CE_POINTER [SD_GDKEVENT]; a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_xevent: CE_POINTER [SD_XEVENT]
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_xevent.make

			l_xevent.ce_gets (create {CE_POINTER [SD_XEVENT]}.make_cast (a_xev))
			if (l_xevent.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if l_xevent.item.type = 33 then
					if l_xevent.item.xclient.message_type = (gdk_x11_atom_to_xatom_for_display ((gtk_widget_get_display (gui_inst.gui.mainwin)), wm_protocols_atom)) then
						if (l_xevent.item.xclient.data.l[0]).to_natural_32 = (gdk_x11_atom_to_xatom_for_display ((gtk_widget_get_display (gui_inst.gui.mainwin)), save_yourself_atom)) then
							term_inst.out_flush
							memline_inst.ml_sync_all (0, 0)
							l_tmp := gdk_x11_drawable_get_xid ((gui_inst.gui.mainwin).item.window)
							XSetCommand ((gdk_x11_drawable_get_xdisplay ((gdk_x11_window_get_drawable_impl ((gui_inst.gui.mainwin).item.window)))), l_tmp, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), 0).do_nothing
							Result := ({SC_GDKFILTERRETURN}.GDK_FILTER_REMOVE)
							js.return
						end
					end
				end
			end
			if not js.return_called then
				Result := ({SC_GDKFILTERRETURN}.GDK_FILTER_CONTINUE)
			end
		end

	global_event_filter_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent global_event_filter)
		end

	mainwin_realize (a_widget: CE_POINTER [SD_GTKWIDGET]; a_data: CE_POINTER [ANY])
		local
			l_icons: CE_POINTER [SD_GLIST]
			l_tmp___8: NATURAL_32
			l_tmp___9: CE_POINTER [SD_GDKDRAWABLE]
			l_tmp___10: CE_POINTER [ANY]
		do
			create l_icons.make
			create l_tmp___9.make
			create l_tmp___10.make

			if globals_inst.echo_wid_arg.to_boolean then
				printf ([ce_string ("WID: %%ld%N"), (gdk_x11_drawable_get_xid ((gui_inst.gui.mainwin).item.window)).to_integer_32]).do_nothing
				Io.standard_default.flush
			end
			if ((misc2_inst.vim_strchr (option_inst.p_go, ('i').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_icons.ce_gets (create {CE_POINTER [SD_GLIST]}.make_shared (default_pointer))
				l_icons.ce_gets (g_list_prepend (l_icons, (gdk_pixbuf_new_from_xpm_data (runtime_vim16x16_inst.vim16x16))))
				l_icons.ce_gets (g_list_prepend (l_icons, (gdk_pixbuf_new_from_xpm_data (runtime_vim32x32_inst.vim32x32))))
				l_icons.ce_gets (g_list_prepend (l_icons, (gdk_pixbuf_new_from_xpm_data (runtime_vim48x48_inst.vim48x48))))
				gtk_window_set_icon_list (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_window_get_type)))), l_icons)
				g_list_foreach (l_icons, (g_object_unref_address), create {CE_POINTER [ANY]}.make_shared (default_pointer))
				g_list_free (l_icons)
			end
			gdk_window_add_filter (create {CE_POINTER [SD_GDKDRAWABLE]}.make_shared (default_pointer), global_event_filter_address, create {CE_POINTER [ANY]}.make_shared (default_pointer))
			setup_save_yourself
			if (globals_inst.serverName.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				if (globals_inst.serverDelayedStartName.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					globals_inst.commWindow := gdk_x11_drawable_get_xid ((gui_inst.gui.mainwin).item.window)
					if_xcmdsrv_inst.serverRegisterName ((gdk_x11_drawable_get_xdisplay ((gdk_x11_window_get_drawable_impl ((gui_inst.gui.mainwin).item.window)))), globals_inst.serverDelayedStartName).do_nothing
				else
					l_tmp___8 := gdk_x11_drawable_get_xid ((gui_inst.gui.mainwin).item.window)
					l_tmp___9.ce_gets (gdk_x11_window_get_drawable_impl ((gui_inst.gui.mainwin).item.window))
					l_tmp___10.ce_gets (gdk_x11_drawable_get_xdisplay (l_tmp___9))
					if_xcmdsrv_inst.serverChangeRegisteredWindow (l_tmp___10, l_tmp___8)
				end
			else
				l_tmp___8 := gdk_x11_drawable_get_xid ((gui_inst.gui.mainwin).item.window)
				l_tmp___9.ce_gets (gdk_x11_window_get_drawable_impl ((gui_inst.gui.mainwin).item.window))
				l_tmp___10.ce_gets (gdk_x11_drawable_get_xdisplay (l_tmp___9))
				if_xcmdsrv_inst.serverChangeRegisteredWindow (l_tmp___10, l_tmp___8)
			end
			gtk_widget_add_events (gui_inst.gui.mainwin, 65536)
			gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_object_get_type)))), ce_string ("property_notify_event"), (property_event_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
		end

	mainwin_realize_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent mainwin_realize)
		end

	create_blank_pointer: CE_POINTER [SD_GDKCURSOR]
		local
			l_root_window: CE_POINTER [SD_GDKDRAWABLE]
			l_blank_mask: CE_POINTER [SD_GDKDRAWABLE]
			l_cursor: CE_POINTER [SD_GDKCURSOR]
			l_color: SD_GDKCOLOR
			l_blank_data: CE_ARRAY [INTEGER_8]
		do
			create l_root_window.make
			create l_blank_mask.make
			create l_cursor.make
			create l_color.make
			create l_blank_data.make (<<1>>)

			l_root_window.ce_gets (create {CE_POINTER [SD_GDKDRAWABLE]}.make_shared (default_pointer))
			l_color.pixel := (0).to_natural_32
			l_color.red := (0).to_natural_16
			l_color.green := (0).to_natural_16
			l_color.blue := (0).to_natural_16
			l_blank_data[0] := (0).to_integer_8
			l_root_window.ce_gets (gtk_widget_get_root_window (gui_inst.gui.mainwin))
			l_blank_mask.ce_gets (gdk_bitmap_create_from_data (l_root_window, l_blank_data, 1, 1))
			l_cursor.ce_gets (gdk_cursor_new_from_pixmap (l_blank_mask, l_blank_mask, (l_color.address), (l_color.address), 0, 0))
			g_object_unref (create {CE_POINTER [ANY]}.make_cast (l_blank_mask))
			Result := l_cursor
		end

	mainwin_screen_changed_cb (a_widget: CE_POINTER [SD_GTKWIDGET]; a_previous_screen: CE_POINTER [SD_GDKSCREEN]; a_data: CE_POINTER [ANY])
		local
			js: JUMP_STATE
		do
			if not (gtk_widget_has_screen (a_widget)).to_boolean then
				js.return
			end
			if not js.return_called then
				if ((gui_inst.gui.blank_pointer).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					gdk_cursor_unref (gui_inst.gui.blank_pointer)
				end
				gui_inst.gui.blank_pointer := create_blank_pointer
				if (gui_inst.gui.pointer_hidden).to_boolean then
					if (((gui_inst.gui.drawarea).item.window).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						gdk_window_set_cursor ((gui_inst.gui.drawarea).item.window, gui_inst.gui.blank_pointer)
					end
				end
				if ((gui_inst.gui.text_context).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					g_object_unref (gui_inst.gui.text_context)
				end
				gui_inst.gui.text_context := gtk_widget_create_pango_context (a_widget)
				pango_context_set_base_dir (gui_inst.gui.text_context, {SC_PANGODIRECTION}.PANGO_DIRECTION_LTR)
				if ((gui_inst.gui.norm_font).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					gui_mch_init_font (option_inst.p_guifont, 0).do_nothing
					gui_inst.gui_set_shellsize (0, 0, 15)
				end
			end
		end

	mainwin_screen_changed_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent mainwin_screen_changed_cb)
		end

	drawarea_realize_cb (a_widget: CE_POINTER [SD_GTKWIDGET]; a_data: CE_POINTER [ANY])
		local
			l_sbar: CE_POINTER [SD_GTKWIDGET]
		do
			create l_sbar.make

			mbyte_inst.xim_init
			gui_mch_new_colors
			gui_inst.gui.text_gc := gdk_gc_new ((gui_inst.gui.drawarea).item.window)
			gui_inst.gui.blank_pointer := create_blank_pointer
			if (gui_inst.gui.pointer_hidden).to_boolean then
				gdk_window_set_cursor (a_widget.item.window, gui_inst.gui.blank_pointer)
			end
			l_sbar.ce_gets (globals_inst.firstwin.item.w_scrollbars[0].id)
			if (l_sbar).c_pointer = default_pointer then
				l_sbar.ce_gets (globals_inst.firstwin.item.w_scrollbars[1].id)
			elseif not (gui_inst.gui.which_scrollbars[0]).to_boolean then
				if ((globals_inst.firstwin.item.w_scrollbars[1].id).c_pointer /= default_pointer) then
					l_sbar.ce_gets (globals_inst.firstwin.item.w_scrollbars[1].id)
				end
			end
			if ((l_sbar).c_pointer /= default_pointer) then
				if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_sbar), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 64)) /= {NATURAL_32} 0 then
					if (l_sbar.item.allocation.width).to_boolean then
						gui_inst.gui.scrollbar_width := l_sbar.item.allocation.width
					end
				end
			end
			l_sbar.ce_gets (gui_inst.gui.bottom_sbar.id)
			if ((l_sbar).c_pointer /= default_pointer) then
				if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_sbar), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 64)) /= {NATURAL_32} 0 then
					if (l_sbar.item.allocation.height).to_boolean then
						gui_inst.gui.scrollbar_height := l_sbar.item.allocation.height
					end
				end
			end
		end

	drawarea_realize_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent drawarea_realize_cb)
		end

	drawarea_unrealize_cb (a_widget: CE_POINTER [SD_GTKWIDGET]; a_data: CE_POINTER [ANY])
		do
			globals_inst.full_screen := 0
			mbyte_inst.im_shutdown
			if ((gui_inst.gui.ascii_glyphs).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				pango_glyph_string_free (gui_inst.gui.ascii_glyphs)
				gui_inst.gui.ascii_glyphs := create {CE_POINTER [SD_PANGOGLYPHSTRING]}.make_shared (default_pointer)
			end
			if ((gui_inst.gui.ascii_font).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				g_object_unref (gui_inst.gui.ascii_font)
				gui_inst.gui.ascii_font := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			end
			g_object_unref (gui_inst.gui.text_context)
			gui_inst.gui.text_context := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			g_object_unref (create {CE_POINTER [ANY]}.make_cast (gui_inst.gui.text_gc))
			gui_inst.gui.text_gc := create {CE_POINTER [SD_GDKGC]}.make_shared (default_pointer)
			gdk_cursor_unref (gui_inst.gui.blank_pointer)
			gui_inst.gui.blank_pointer := create {CE_POINTER [SD_GDKCURSOR]}.make_shared (default_pointer)
		end

	drawarea_unrealize_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent drawarea_unrealize_cb)
		end

	drawarea_style_set_cb (a_widget: CE_POINTER [SD_GTKWIDGET]; a_previous_style: CE_POINTER [SD_GTKSTYLE]; a_data: CE_POINTER [ANY])
		do
			gui_mch_new_colors
		end

	drawarea_style_set_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent drawarea_style_set_cb)
		end

	delete_event_cb (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTANY]; a_data: CE_POINTER [ANY]): INTEGER_32
		do
			gui_inst.gui_shell_closed
			Result := 1
		end

	delete_event_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent delete_event_cb)
		end

	get_item_dimensions (a_widget: CE_POINTER [SD_GTKWIDGET]; a_orientation: INTEGER_32): INTEGER_32
		local
			l_item_orientation: INTEGER_32
			js: JUMP_STATE
		do
			l_item_orientation := {SC_GTKORIENTATION}.GTK_ORIENTATION_HORIZONTAL
			if (a_widget.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if l_item_orientation.to_natural_32 = a_orientation.to_natural_32 then
					if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 64)) /= {NATURAL_32} 0 then
						if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 256)) /= {NATURAL_32} 0 then
							if a_orientation.to_natural_32 = {NATURAL_32} 0 then
								Result := (a_widget.item.allocation.height)
								js.return
							else
								Result := (a_widget.item.allocation.width)
								js.return
							end
						end
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	get_menu_tool_width: INTEGER_32
		local
			l_width: INTEGER_32
		do
			l_width := 0
			Result := l_width
		end

	get_menu_tool_height: INTEGER_32
		local
			l_height: INTEGER_32
		do
			l_height := 0
			l_height := l_height + (get_item_dimensions (gui_inst.gui.menubar, {SC_GTKORIENTATION}.GTK_ORIENTATION_HORIZONTAL))
			l_height := l_height + (get_item_dimensions (gui_inst.gui.toolbar, {SC_GTKORIENTATION}.GTK_ORIENTATION_HORIZONTAL))
			if ((gui_inst.gui.tabline).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_height := l_height + (get_item_dimensions (gui_inst.gui.tabline, {SC_GTKORIENTATION}.GTK_ORIENTATION_HORIZONTAL))
			end
			Result := l_height
		end

	update_window_manager_hints (a_force_width: INTEGER_32; a_force_height: INTEGER_32)
		local
			l_width: INTEGER_32
			l_height: INTEGER_32
			l_min_width: INTEGER_32
			l_min_height: INTEGER_32
			l_geometry: SD_GDKGEOMETRY
			l_geometry_mask: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_geometry.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_force_width.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if not a_force_height.to_boolean then
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if init_window_hints_state > 0 then
							init_window_hints_state := 2
							js.return
						end
				when 4 then
					if js.return_called then
						l_pos := -1 + 22 -- skip if block
					end
				when 5 then -- if:
						l_width := gui_inst.gui_get_base_width
						l_height := gui_inst.gui_get_base_height
						l_height := l_height + ((window_inst.tabline_height) * gui_inst.gui.char_height)
						l_width := l_width + (get_menu_tool_width)
						l_height := l_height + (get_menu_tool_height)
						if a_force_width.to_boolean then
							if a_force_height.to_boolean then
								l_min_width := a_force_width
								l_min_height := a_force_height
							else
								l_min_width := l_width + 12 * gui_inst.gui.char_width
								l_min_height := l_height + 2 * gui_inst.gui.char_height
							end
						else
							l_min_width := l_width + 12 * gui_inst.gui.char_width
							l_min_height := l_height + 2 * gui_inst.gui.char_height
						end
						if l_width = old_width then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 21 -- goto _L___0
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 8 then -- else:
						if l_height = old_height then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 21 -- goto _L___0
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 11 then -- else:
						if l_min_width = old_min_width then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 21 -- goto _L___0
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 14 then -- else:
						if l_min_height = old_min_height then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 21 -- goto _L___0
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 17 then -- else:
						if gui_inst.gui.char_width = old_char_width then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 21 -- goto _L___0
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 20 then -- else:
						if gui_inst.gui.char_height = old_char_height then
							l_pos := -1 + 22 -- skip if block
						end
				when 21 then -- if: | _L___0:
						l_geometry.width_inc := gui_inst.gui.char_width
						l_geometry.height_inc := gui_inst.gui.char_height
						l_geometry.base_width := l_width
						l_geometry.base_height := l_height
						l_geometry.min_width := l_min_width
						l_geometry.min_height := l_min_height
						l_geometry_mask := 42
						gtk_window_set_geometry_hints (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_window_get_type)))), gui_inst.gui.mainwin, l_geometry.address, l_geometry_mask)
						old_width := l_width
						old_height := l_height
						old_min_width := l_min_width
						old_min_height := l_min_height
						old_char_width := gui_inst.gui.char_width
						old_char_height := gui_inst.gui.char_height
				when 22 then -- if done | if done | if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	icon_size_changed_foreach (a_widget: CE_POINTER [SD_GTKWIDGET]; a_user_data: CE_POINTER [ANY])
		local
			l_image: CE_POINTER [SD_GTKIMAGE]
			l_icon_set: CE_POINTER [ANY]
			l_icon_size: INTEGER_32
			l_inst: CE_POINTER [SD_GTYPEINSTANCE]
			l_t: NATURAL_32
			l_r: INTEGER_32
			l_inst___0: CE_POINTER [SD_GTYPEINSTANCE]
			l_t___0: NATURAL_32
			l_r___0: INTEGER_32
		do
			create l_image.make
			create l_icon_set.make
			create l_inst.make
			create l_inst___0.make

			l_inst___0.ce_gets (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget))
			l_t___0 := (gtk_image_get_type)
			if (l_inst___0).c_pointer = default_pointer then
				l_r___0 := 0
			elseif ((l_inst___0.item.g_class).c_pointer /= default_pointer) then
				if (l_inst___0.item.g_class).item.g_type = l_t___0 then
					l_r___0 := 1
				else
					l_r___0 := g_type_check_instance_is_a (l_inst___0, l_t___0)
				end
			else
				l_r___0 := g_type_check_instance_is_a (l_inst___0, l_t___0)
			end
			if l_r___0.to_boolean then
				l_image.ce_gets (create {CE_POINTER [SD_GTKIMAGE]}.make_cast (a_widget))
				if (gtk_image_get_storage_type (l_image)).to_natural_32 = {NATURAL_32} 5 then
					gtk_image_get_icon_set (l_image, l_icon_set.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_icon_size))
					l_icon_size := (a_user_data.c_pointer.to_integer_32).to_integer_32
					gtk_icon_set_ref (l_icon_set).do_nothing
					gtk_image_set_from_icon_set (l_image, l_icon_set, l_icon_size)
					gtk_icon_set_unref (l_icon_set)
				end
			else
				l_inst.ce_gets (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget))
				l_t := (gtk_container_get_type)
				if (l_inst).c_pointer = default_pointer then
					l_r := 0
				elseif ((l_inst.item.g_class).c_pointer /= default_pointer) then
					if (l_inst.item.g_class).item.g_type = l_t then
						l_r := 1
					else
						l_r := g_type_check_instance_is_a (l_inst, l_t)
					end
				else
					l_r := g_type_check_instance_is_a (l_inst, l_t)
				end
				if l_r.to_boolean then
					gtk_container_foreach (create {CE_POINTER [SD_GTKCONTAINER]}.make_cast (a_widget), icon_size_changed_foreach_address, a_user_data)
				end
			end
		end

	icon_size_changed_foreach_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent icon_size_changed_foreach)
		end

	set_toolbar_style (a_toolbar: CE_POINTER [SD_GTKTOOLBAR])
		local
			l_style: INTEGER_32
			l_size: INTEGER_32
			l_oldsize: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((option_inst.toolbar_flags).bit_and ({NATURAL_32} 11)) = {NATURAL_32} 11 then
						l_style := {SC_GTKTOOLBARSTYLE}.GTK_TOOLBAR_BOTH_HORIZ
					elseif ((option_inst.toolbar_flags).bit_and ({NATURAL_32} 3)) = {NATURAL_32} 3 then
						l_style := {SC_GTKTOOLBARSTYLE}.GTK_TOOLBAR_BOTH
					elseif ((option_inst.toolbar_flags).bit_and ({NATURAL_32} 1)).to_boolean then
						l_style := {SC_GTKTOOLBARSTYLE}.GTK_TOOLBAR_TEXT
					else
						l_style := {SC_GTKTOOLBARSTYLE}.GTK_TOOLBAR_ICONS
					end
					gtk_toolbar_set_style (a_toolbar, l_style)
					gtk_toolbar_set_tooltips (a_toolbar, (((option_inst.toolbar_flags).bit_and ({NATURAL_32} 4)) /= {NATURAL_32} 0).to_integer)
					inspect option_inst.tbis_flags.to_integer_32 -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 4 then l_pos := -1 + 3
					when 8 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 1
					l_size := {SC_GTKICONSIZE}.GTK_ICON_SIZE_MENU
					l_pos := -1 + 6 -- switch 1; break
				when 2 then -- switch 1, case 2
					l_size := {SC_GTKICONSIZE}.GTK_ICON_SIZE_SMALL_TOOLBAR
					l_pos := -1 + 6 -- switch 1; break
				when 3 then -- switch 1, case 4
					l_size := {SC_GTKICONSIZE}.GTK_ICON_SIZE_BUTTON
					l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 8
					l_size := {SC_GTKICONSIZE}.GTK_ICON_SIZE_LARGE_TOOLBAR
					l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, default:
					l_size := {SC_GTKICONSIZE}.GTK_ICON_SIZE_INVALID
					l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done:
					l_oldsize := gtk_toolbar_get_icon_size (a_toolbar)
					if l_size.to_natural_32 = {NATURAL_32} 0 then
						gtk_toolbar_unset_icon_size (a_toolbar)
						l_size := gtk_toolbar_get_icon_size (a_toolbar)
					end
					if l_size.to_natural_32 /= l_oldsize.to_natural_32 then
						gtk_container_foreach (create {CE_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_toolbar), (gtk_container_get_type)))), icon_size_changed_foreach_address, create {CE_POINTER [ANY]}.make_shared (default_pointer + l_size))
					end
					gtk_toolbar_set_icon_size (a_toolbar, l_size)
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	tabline_menu_handler (a_item: CE_POINTER [SD_GTKMENUITEM]; a_user_data: CE_POINTER [ANY])
		do
			gui_inst.send_tabline_menu_event (clicked_page, (a_user_data.c_pointer.to_integer_32).to_integer_32)
		end

	tabline_menu_handler_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent tabline_menu_handler)
		end

	add_tabline_menu_item (a_menu___1: CE_POINTER [SD_GTKWIDGET]; a_text: CE_POINTER [NATURAL_8]; a_resp: INTEGER_32)
		local
			l_item: CE_POINTER [SD_GTKWIDGET]
			l_utf_text: CE_POINTER [NATURAL_8]
		do
			create l_item.make
			create l_utf_text.make

			if globals_inst.output_conv.vc_type = 0 then
				l_utf_text.ce_gets (a_text)
			elseif (a_text.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_utf_text.ce_gets (a_text)
			else
				l_utf_text.ce_gets ((mbyte_inst.string_convert (globals_inst.output_conv.address, a_text, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))))
			end
			l_item.ce_gets (gtk_menu_item_new_with_label (create {CE_POINTER [INTEGER_8]}.make_cast (l_utf_text)))
			gtk_widget_show (l_item)
			if globals_inst.output_conv.vc_type = 0 then
				l_utf_text.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			else
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_utf_text))
				l_utf_text.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
			gtk_container_add (create {CE_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_menu___1), (gtk_container_get_type)))), l_item)
			gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_item), (gtk_object_get_type)))), ce_string ("activate"), (tabline_menu_handler_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer + a_resp), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
		end

	create_tabline_menu: CE_POINTER [SD_GTKWIDGET]
		local
			l_menu___1: CE_POINTER [SD_GTKWIDGET]
		do
			create l_menu___1.make

			l_menu___1.ce_gets (gtk_menu_new)
			add_tabline_menu_item (l_menu___1, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Close")))), 1)
			add_tabline_menu_item (l_menu___1, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("New tab")))), 2)
			add_tabline_menu_item (l_menu___1, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Open Tab...")))), 3)
			Result := l_menu___1
		end

	on_tabline_menu (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENT]): INTEGER_32
		local
			l_bevent: CE_POINTER [SD_GDKEVENTBUTTON]
			l_x___0: INTEGER_32
			l_y: INTEGER_32
			l_tabwidget: CE_POINTER [SD_GTKWIDGET]
			l_tabwin: CE_POINTER [SD_GDKDRAWABLE]
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
		do
			create l_bevent.make
			create l_tabwidget.make
			create l_tabwin.make

			if a_event.item.type = 4 then
				l_bevent.ce_gets (create {CE_POINTER [SD_GDKEVENTBUTTON]}.make_cast (a_event))
				l_x___0 := (l_bevent.item.x).truncated_to_integer
				l_y := (l_bevent.item.y).truncated_to_integer
				if globals_inst.hold_gui_events.to_boolean then
					Result := 1
					js.return
				elseif globals_inst.cmdwin_type /= 0 then
					Result := 1
					js.return
				end
				if not js.return_called then
					l_tabwin.ce_gets (gdk_window_at_pointer (create {CE_POINTER [INTEGER_32]}.make_shared ($l_x___0), create {CE_POINTER [INTEGER_32]}.make_shared ($l_y)))
					gdk_window_get_user_data (l_tabwin, create {CE_POINTER [CE_POINTER [ANY]]}.make_cast ((l_tabwidget.address)))
					clicked_page := ((gtk_object_get_user_data (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_tabwidget), (gtk_object_get_type)))))).c_pointer.to_integer_32).to_integer_32
					if l_bevent.item.button = {NATURAL_32} 3 then
						gtk_menu_popup (create {CE_POINTER [SD_GTKMENU]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget), (gtk_menu_get_type)))), create {CE_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), l_bevent.item.button, l_bevent.item.time)
						Result := 1
						js.return
					elseif l_bevent.item.button = {NATURAL_32} 1 then
						if clicked_page = 0 then
							if l_x___0 < 50 then
								l_tmp___4 := -1
							else
								l_tmp___4 := 0
							end
							gui_inst.send_tabline_event (l_tmp___4).do_nothing
						end
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	on_tabline_menu_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent on_tabline_menu)
		end

	on_select_tab (a_notebook: CE_POINTER [SD_GTKNOTEBOOK]; a_page: CE_POINTER [ANY]; a_idx: INTEGER_32; a_data: CE_POINTER [ANY])
		do
			if not ignore_tabline_evt.to_boolean then
				gui_inst.send_tabline_event (a_idx + 1).do_nothing
			end
		end

	on_select_tab_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent on_select_tab)
		end

	gui_mch_show_tabline (a_showit: INTEGER_32)
		local
			l_tmp___1: NATURAL_32
			l_tmp___4: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___8: INTEGER_32
			js: JUMP_STATE
		do
			create l_tmp___4.make

			if ((gui_inst.gui.tabline).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				if (gtk_notebook_get_show_tabs (create {CE_POINTER [SD_GTKNOTEBOOK]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.tabline), (gtk_notebook_get_type)))))).to_boolean then
					l_tmp___8 := 0
				else
					l_tmp___8 := 1
				end
				if not a_showit.to_boolean /= l_tmp___8.to_boolean then
					gtk_notebook_set_show_tabs (create {CE_POINTER [SD_GTKNOTEBOOK]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.tabline), (gtk_notebook_get_type)))), a_showit)
					update_window_manager_hints (0, 0)
					if a_showit.to_boolean then
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp___1 := gtk_object_get_type
							l_tmp___4.ce_gets (g_type_check_instance_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.tabline), (gtk_widget_get_type))), l_tmp___1));
							(create {CE_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___4)).item.flags := ((create {CE_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___4)).item.flags).bit_and (({NATURAL_32} 4294965247))
							js.break
						end
						js.reset
					end
				end
				gui_mch_update
			end
		end

	gui_mch_showing_tabline: INTEGER_32
		local
			l_tmp___2: INTEGER_32
		do
			if ((gui_inst.gui.tabline).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (gtk_notebook_get_show_tabs (create {CE_POINTER [SD_GTKNOTEBOOK]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.tabline), (gtk_notebook_get_type)))))).to_boolean then
					l_tmp___2 := 1
				else
					l_tmp___2 := 0
				end
			else
				l_tmp___2 := 0
			end
			Result := l_tmp___2
		end

	gui_mch_update_tabline
		local
			l_page: CE_POINTER [SD_GTKWIDGET]
			l_event_box: CE_POINTER [SD_GTKWIDGET]
			l_label: CE_POINTER [SD_GTKWIDGET]
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_nr: INTEGER_32
			l_tab_num: INTEGER_32
			l_curtabidx: INTEGER_32
			l_labeltext: CE_POINTER [NATURAL_8]
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
		do
			create l_page.make
			create l_event_box.make
			create l_label.make
			create l_tp.make
			create l_labeltext.make

			l_nr := 0
			l_curtabidx := 0
			if ((gui_inst.gui.tabline).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				ignore_tabline_evt := 1
				l_tp.ce_gets (globals_inst.first_tabpage)
				from
				until
					(l_tp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
				loop
					if (l_tp.c_pointer.to_integer_32).to_natural_32 = (globals_inst.curtab.c_pointer.to_integer_32).to_natural_32 then
						l_curtabidx := l_nr
					end
					l_tab_num := l_nr + 1
					l_page.ce_gets (gtk_notebook_get_nth_page (create {CE_POINTER [SD_GTKNOTEBOOK]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.tabline), (gtk_notebook_get_type)))), l_nr))
					if (l_page.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_page.ce_gets (gtk_vbox_new (0, 0))
						gtk_widget_show (l_page)
						l_event_box.ce_gets (gtk_event_box_new)
						gtk_widget_show (l_event_box)
						l_label.ce_gets (gtk_label_new (ce_string ("-Empty-")))
						gtk_misc_set_padding (create {CE_POINTER [SD_GTKMISC]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_label), (gtk_misc_get_type)))), 2, 2)
						gtk_container_add (create {CE_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_event_box), (gtk_container_get_type)))), l_label)
						gtk_widget_show (l_label)
						l_tmp___5 := l_nr
						l_nr := l_nr + 1
						gtk_notebook_insert_page (create {CE_POINTER [SD_GTKNOTEBOOK]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.tabline), (gtk_notebook_get_type)))), l_page, l_event_box, l_tmp___5).do_nothing
					end
					l_event_box.ce_gets (gtk_notebook_get_tab_label (create {CE_POINTER [SD_GTKNOTEBOOK]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.tabline), (gtk_notebook_get_type)))), l_page))
					gtk_object_set_user_data (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_event_box), (gtk_object_get_type)))), create {CE_POINTER [ANY]}.make_shared (default_pointer + l_tab_num))
					l_label.ce_gets ((create {CE_POINTER [SD_GTKBIN]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_event_box), (gtk_bin_get_type))))).item.child)
					gui_inst.get_tabline_label (l_tp, 0)
					if globals_inst.output_conv.vc_type = 0 then
						l_labeltext.ce_gets (globals_inst.NameBuff)
					elseif (globals_inst.NameBuff.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_labeltext.ce_gets (globals_inst.NameBuff)
					else
						l_labeltext.ce_gets ((mbyte_inst.string_convert (globals_inst.output_conv.address, globals_inst.NameBuff, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))))
					end
					gtk_label_set_text (create {CE_POINTER [SD_GTKLABEL]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_label), (gtk_label_get_type)))), create {CE_POINTER [INTEGER_8]}.make_cast (l_labeltext))
					if globals_inst.output_conv.vc_type = 0 then
						l_labeltext.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					else
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_labeltext))
						l_labeltext.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					end
					gui_inst.get_tabline_label (l_tp, 1)
					if globals_inst.output_conv.vc_type = 0 then
						l_labeltext.ce_gets (globals_inst.NameBuff)
					elseif (globals_inst.NameBuff.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_labeltext.ce_gets (globals_inst.NameBuff)
					else
						l_labeltext.ce_gets ((mbyte_inst.string_convert (globals_inst.output_conv.address, globals_inst.NameBuff, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))))
					end
					gtk_tooltips_set_tip (create {CE_POINTER [SD_GTKTOOLTIPS]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (tabline_tooltip), (gtk_tooltips_get_type)))), l_event_box, create {CE_POINTER [INTEGER_8]}.make_cast (l_labeltext), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					if globals_inst.output_conv.vc_type = 0 then
						l_labeltext.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					else
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_labeltext))
						l_labeltext.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					end
					l_tp.ce_gets (l_tp.item.tp_next)
					l_nr := l_nr + 1
				end
				from
				until
					js.loop_left
				loop
					js.reset
					if ((gtk_notebook_get_nth_page (create {CE_POINTER [SD_GTKNOTEBOOK]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.tabline), (gtk_notebook_get_type)))), l_nr)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.break
					end
					if not js.loop_jumped then
						gtk_notebook_remove_page (create {CE_POINTER [SD_GTKNOTEBOOK]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.tabline), (gtk_notebook_get_type)))), l_nr)
					end
				end
				js.reset
				if (gtk_notebook_get_current_page (create {CE_POINTER [SD_GTKNOTEBOOK]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.tabline), (gtk_notebook_get_type)))))) /= l_curtabidx then
					gtk_notebook_set_current_page (create {CE_POINTER [SD_GTKNOTEBOOK]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.tabline), (gtk_notebook_get_type)))), l_curtabidx)
				end
				gui_mch_update
				ignore_tabline_evt := 0
			end
		end

	gui_mch_set_curtab (a_nr: INTEGER_32)
		local
			js: JUMP_STATE
		do
			if ((gui_inst.gui.tabline).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				ignore_tabline_evt := 1
				if (gtk_notebook_get_current_page (create {CE_POINTER [SD_GTKNOTEBOOK]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.tabline), (gtk_notebook_get_type)))))) /= a_nr - 1 then
					gtk_notebook_set_current_page (create {CE_POINTER [SD_GTKNOTEBOOK]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.tabline), (gtk_notebook_get_type)))), a_nr - 1)
				end
				ignore_tabline_evt := 0
			end
		end

	gui_gtk_set_selection_targets
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_n_targets: INTEGER_32
			l_targets: CE_ARRAY [SD_GTKTARGETENTRY]
			l_tmp: INTEGER_32
		do
			create l_targets.make (<<(({SD_GTKTARGETENTRY}.sizeof.to_natural_32 * (7).to_natural_32) // {SD_GTKTARGETENTRY}.sizeof.to_natural_32).to_integer_32>>)

			l_j := 0
			l_n_targets := (({SD_GTKTARGETENTRY}.sizeof.to_natural_32 * (7).to_natural_32) // {SD_GTKTARGETENTRY}.sizeof.to_natural_32).to_integer_32
			l_i___0 := 0
			from
			until
				not (l_i___0 < (({SD_GTKTARGETENTRY}.sizeof.to_natural_32 * (7).to_natural_32) // {SD_GTKTARGETENTRY}.sizeof.to_natural_32).to_integer_32)
			loop
				if not globals_inst.clip_html.to_boolean then
					if selection_targets[l_i___0].info = {NATURAL_32} 4 then
						l_n_targets := l_n_targets - 1
					else
						l_tmp := l_j
						l_j := l_j + 1
						l_targets[l_tmp] := selection_targets[l_i___0]
					end
				else
					l_tmp := l_j
					l_j := l_j + 1
					l_targets[l_tmp] := selection_targets[l_i___0]
				end
				l_i___0 := l_i___0 + 1
			end
			gtk_selection_clear_targets (gui_inst.gui.drawarea, create {CE_POINTER [ANY]}.make_shared (default_pointer + 1))
			gtk_selection_clear_targets (gui_inst.gui.drawarea, globals_inst.clip_plus.gtk_sel_atom)
			gtk_selection_add_targets (gui_inst.gui.drawarea, create {CE_POINTER [ANY]}.make_shared (default_pointer + 1), create {CE_POINTER [SD_GTKTARGETENTRY]}.make_cast (l_targets), l_n_targets.to_natural_32)
			gtk_selection_add_targets (gui_inst.gui.drawarea, globals_inst.clip_plus.gtk_sel_atom, create {CE_POINTER [SD_GTKTARGETENTRY]}.make_cast (l_targets), l_n_targets.to_natural_32)
		end

	gui_gtk_set_dnd_targets
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_n_targets: INTEGER_32
			l_targets: CE_ARRAY [SD_GTKTARGETENTRY]
			l_tmp: INTEGER_32
		do
			create l_targets.make (<<(({SD_GTKTARGETENTRY}.sizeof.to_natural_32 * (5).to_natural_32) // {SD_GTKTARGETENTRY}.sizeof.to_natural_32).to_integer_32>>)

			l_j := 0
			l_n_targets := (({SD_GTKTARGETENTRY}.sizeof.to_natural_32 * (5).to_natural_32) // {SD_GTKTARGETENTRY}.sizeof.to_natural_32).to_integer_32
			l_i___0 := 0
			from
			until
				not (l_i___0 < (({SD_GTKTARGETENTRY}.sizeof.to_natural_32 * (5).to_natural_32) // {SD_GTKTARGETENTRY}.sizeof.to_natural_32).to_integer_32)
			loop
				if not globals_inst.clip_html.to_boolean then
					if selection_targets[l_i___0].info = {NATURAL_32} 4 then
						l_n_targets := l_n_targets - 1
					else
						l_tmp := l_j
						l_j := l_j + 1
						l_targets[l_tmp] := dnd_targets[l_i___0]
					end
				else
					l_tmp := l_j
					l_j := l_j + 1
					l_targets[l_tmp] := dnd_targets[l_i___0]
				end
				l_i___0 := l_i___0 + 1
			end
			gtk_drag_dest_unset (gui_inst.gui.drawarea)
			gtk_drag_dest_set (gui_inst.gui.drawarea, {SC_GTKDESTDEFAULTS}.GTK_DEST_DEFAULT_ALL, create {CE_POINTER [SD_GTKTARGETENTRY]}.make_cast (l_targets), l_n_targets, {SC_GDKDRAGACTION}.GDK_ACTION_COPY)
		end

	gui_mch_init: INTEGER_32
		local
			l_vbox: CE_POINTER [SD_GTKWIDGET]
			l_plug: CE_POINTER [SD_GTKWIDGET]
			l_gtk_settings: CE_POINTER [SD_GTKSETTINGS]
			l_page: CE_POINTER [SD_GTKWIDGET]
			l_label: CE_POINTER [SD_GTKWIDGET]
			l_event_box: CE_POINTER [SD_GTKWIDGET]
			l_tmp___49: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___62: CE_POINTER [SD_GTKOBJECT]
			l_tmp___65: CE_POINTER [SD_GOBJECT]
			l_tmp___73: CE_POINTER [SD_GTYPEINSTANCE]
			js: JUMP_STATE
		do
			create l_vbox.make
			create l_plug.make
			create l_gtk_settings.make
			create l_page.make
			create l_label.make
			create l_event_box.make
			create l_tmp___49.make
			create l_tmp___62.make
			create l_tmp___65.make
			create l_tmp___73.make

			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (gui_argv))
			gui_argv.ce_gets (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer))
			g_set_application_name (ce_string ("Vim"))
			option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("termencoding")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("utf-8")), 0)
			gui_gtk_inst.gui_gtk_register_stock_icons
			gui_inst.gui.border_width := 2
			gui_inst.gui.scrollbar_width := 16
			gui_inst.gui.scrollbar_height := 16
			gui_inst.gui.fgcolor := create {CE_POINTER [SD_GDKCOLOR]}.make_cast ((g_malloc0_n ((1).to_natural_32, {SD_GDKCOLOR}.sizeof.to_natural_32)))
			gui_inst.gui.bgcolor := create {CE_POINTER [SD_GDKCOLOR]}.make_cast ((g_malloc0_n ((1).to_natural_32, {SD_GDKCOLOR}.sizeof.to_natural_32)))
			gui_inst.gui.spcolor := create {CE_POINTER [SD_GDKCOLOR]}.make_cast ((g_malloc0_n ((1).to_natural_32, {SD_GDKCOLOR}.sizeof.to_natural_32)))
			html_atom.ce_gets (gdk_atom_intern (ce_string ("text/html"), 0))
			utf8_string_atom.ce_gets (gdk_atom_intern (ce_string ("UTF8_STRING"), 0))
			gui_inst.gui.norm_pixel := gui_inst.gui.def_norm_pixel
			gui_inst.gui.back_pixel := gui_inst.gui.def_back_pixel
			if globals_inst.gtk_socket_id /= {NATURAL_32} 0 then
				l_plug.ce_gets (gtk_plug_new_for_display ((gdk_display_get_default), globals_inst.gtk_socket_id))
				if (l_plug.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if (((create {CE_POINTER [SD_GTKPLUG]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_plug), (gtk_plug_get_type))))).item.socket_window).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						gui_inst.gui.mainwin := l_plug
					else
						g_log ([create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), {SC_GLOGLEVELFLAGS}.G_LOG_LEVEL_WARNING, ce_string ("Connection to GTK+ socket (ID %%u) failed"), globals_inst.gtk_socket_id])
						globals_inst.gtk_socket_id := (0).to_natural_32
					end
				else
					g_log ([create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), {SC_GLOGLEVELFLAGS}.G_LOG_LEVEL_WARNING, ce_string ("Connection to GTK+ socket (ID %%u) failed"), globals_inst.gtk_socket_id])
					globals_inst.gtk_socket_id := (0).to_natural_32
				end
			end
			if globals_inst.gtk_socket_id = {NATURAL_32} 0 then
				gui_inst.gui.mainwin := gtk_window_new ({SC_GTKWINDOWTYPE}.GTK_WINDOW_TOPLEVEL)
			end
			gtk_widget_set_name (gui_inst.gui.mainwin, ce_string ("vim-main-window"))
			gui_inst.gui.text_context := gtk_widget_create_pango_context (gui_inst.gui.mainwin)
			pango_context_set_base_dir (gui_inst.gui.text_context, {SC_PANGODIRECTION}.PANGO_DIRECTION_LTR)
			gtk_container_set_border_width (create {CE_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_container_get_type)))), (0).to_natural_32)
			gtk_widget_add_events (gui_inst.gui.mainwin, 131072)
			gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_object_get_type)))), ce_string ("delete_event"), (delete_event_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_object_get_type)))), ce_string ("realize"), (mainwin_realize_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			g_signal_connect_data (create {CE_POINTER [ANY]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), ((20).bit_shift_left (2)).to_natural_32))), ce_string ("screen_changed"), (mainwin_screen_changed_cb_address), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0).do_nothing
			gui_inst.gui.accel_group := gtk_accel_group_new
			gtk_window_add_accel_group (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_window_get_type)))), gui_inst.gui.accel_group)
			l_vbox.ce_gets (gtk_vbox_new (0, 0))
			gtk_container_add (create {CE_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_container_get_type)))), l_vbox)
			gtk_widget_show (l_vbox)
			gui_inst.gui.menubar := gtk_menu_bar_new
			gtk_widget_set_name (gui_inst.gui.menubar, ce_string ("vim-menubar"))
			l_gtk_settings.ce_gets (gtk_settings_get_for_screen ((gdk_screen_get_default)))
			g_object_set ([create {CE_POINTER [ANY]}.make_cast (l_gtk_settings), ce_string ("gtk-menu-bar-accel"), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer)])
			gtk_widget_show (gui_inst.gui.menubar)
			gtk_box_pack_start (create {CE_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_vbox), (gtk_box_get_type)))), gui_inst.gui.menubar, 0, 0, (0).to_natural_32)
			gtk_rc_parse_string (ce_string ("style %"vim-toolbar-style%" {%N  GtkToolbar::button_relief = GTK_RELIEF_NONE%N}%Nwidget %"*.vim-toolbar%" style %"vim-toolbar-style%"%N"))
			gui_inst.gui.toolbar := gtk_toolbar_new
			gtk_widget_set_name (gui_inst.gui.toolbar, ce_string ("vim-toolbar"))
			set_toolbar_style (create {CE_POINTER [SD_GTKTOOLBAR]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.toolbar), (gtk_toolbar_get_type)))))
			if ((misc2_inst.vim_strchr (option_inst.p_go, ('T').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if ((option_inst.toolbar_flags).bit_and ({NATURAL_32} 3)).to_boolean then
					gtk_widget_show (gui_inst.gui.toolbar)
				end
			end
			gtk_box_pack_start (create {CE_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_vbox), (gtk_box_get_type)))), gui_inst.gui.toolbar, 0, 0, (0).to_natural_32)
			gui_inst.gui.tabline := gtk_notebook_new
			gtk_widget_show (gui_inst.gui.tabline)
			gtk_box_pack_start (create {CE_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_vbox), (gtk_box_get_type)))), gui_inst.gui.tabline, 0, 0, (0).to_natural_32)
			gtk_notebook_set_show_border (create {CE_POINTER [SD_GTKNOTEBOOK]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.tabline), (gtk_notebook_get_type)))), 0)
			gtk_notebook_set_show_tabs (create {CE_POINTER [SD_GTKNOTEBOOK]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.tabline), (gtk_notebook_get_type)))), 0)
			gtk_notebook_set_scrollable (create {CE_POINTER [SD_GTKNOTEBOOK]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.tabline), (gtk_notebook_get_type)))), 1)
			gtk_notebook_set_tab_border (create {CE_POINTER [SD_GTKNOTEBOOK]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.tabline), (gtk_notebook_get_type)))), (0).to_natural_32)
			tabline_tooltip.ce_gets (gtk_tooltips_new)
			gtk_tooltips_enable (create {CE_POINTER [SD_GTKTOOLTIPS]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (tabline_tooltip), (gtk_tooltips_get_type)))))
			l_page.ce_gets (gtk_vbox_new (0, 0))
			gtk_widget_show (l_page)
			gtk_container_add (create {CE_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.tabline), (gtk_container_get_type)))), l_page)
			l_label.ce_gets (gtk_label_new (ce_string ("-Empty-")))
			gtk_widget_show (l_label)
			l_event_box.ce_gets (gtk_event_box_new)
			gtk_widget_show (l_event_box)
			gtk_object_set_user_data (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_event_box), (gtk_object_get_type)))), create {CE_POINTER [ANY]}.make_shared (default_pointer + 1))
			gtk_misc_set_padding (create {CE_POINTER [SD_GTKMISC]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_label), (gtk_misc_get_type)))), 2, 2)
			gtk_container_add (create {CE_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_event_box), (gtk_container_get_type)))), l_label)
			gtk_notebook_set_tab_label (create {CE_POINTER [SD_GTKNOTEBOOK]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.tabline), (gtk_notebook_get_type)))), l_page, l_event_box)
			gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.tabline), (gtk_object_get_type)))), ce_string ("switch_page"), (on_select_tab_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			tabline_menu.ce_gets (create_tabline_menu)
			l_tmp___49.ce_gets (g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (tabline_menu), (gtk_object_get_type)))
			gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.tabline), (gtk_object_get_type)))), ce_string ("button_press_event"), (on_tabline_menu_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_cast (l_tmp___49), create {CE_ROUTINE}.make_shared (default_pointer), 1, 0).do_nothing
			gui_inst.gui.formwin := gui_gtk_f_inst.gtk_form_new
			gtk_container_set_border_width (create {CE_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.formwin), (gtk_container_get_type)))), (0).to_natural_32)
			gtk_widget_set_events (gui_inst.gui.formwin, 2)
			gui_inst.gui.drawarea := gtk_drawing_area_new
			gtk_widget_set_events (gui_inst.gui.drawarea, 2113294)
			gtk_widget_show (gui_inst.gui.drawarea)
			gui_gtk_f_inst.gtk_form_put (create {CE_POINTER [PD_GTKFORM]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.formwin), (gui_gtk_f_inst.gtk_form_get_type)))), gui_inst.gui.drawarea, 0, 0)
			gtk_widget_show (gui_inst.gui.formwin)
			gtk_box_pack_start (create {CE_POINTER [SD_GTKBOX]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_vbox), (gtk_box_get_type)))), gui_inst.gui.formwin, 1, 1, (0).to_natural_32)
			if globals_inst.gtk_socket_id = {NATURAL_32} 0 then
				l_tmp___62.ce_gets (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_object_get_type)))))
			else
				l_tmp___62.ce_gets (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.drawarea), (gtk_object_get_type)))))
			end
			gtk_signal_connect_full (l_tmp___62, ce_string ("key_press_event"), (key_press_event_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			if globals_inst.gtk_socket_id = {NATURAL_32} 0 then
				l_tmp___65.ce_gets (create {CE_POINTER [SD_GOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), ((20).bit_shift_left (2)).to_natural_32))))
			else
				l_tmp___65.ce_gets (create {CE_POINTER [SD_GOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.drawarea), ((20).bit_shift_left (2)).to_natural_32))))
			end
			g_signal_connect_data (create {CE_POINTER [ANY]}.make_cast (l_tmp___65), ce_string ("key_release_event"), (key_release_event_address), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0).do_nothing
			gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.drawarea), (gtk_object_get_type)))), ce_string ("realize"), (drawarea_realize_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.drawarea), (gtk_object_get_type)))), ce_string ("unrealize"), (drawarea_unrealize_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.drawarea), (gtk_object_get_type)))), ce_string ("style_set"), (drawarea_style_set_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 1).do_nothing
			gui_inst.gui.visibility := 0
			wm_protocols_atom.ce_gets (gdk_atom_intern (ce_string ("WM_PROTOCOLS"), 0))
			save_yourself_atom.ce_gets (gdk_atom_intern (ce_string ("WM_SAVE_YOURSELF"), 0))
			if globals_inst.gtk_socket_id /= {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					l_tmp___73.ce_gets (g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.drawarea), (gtk_object_get_type)));
					(create {CE_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___73)).item.flags := ((create {CE_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___73)).item.flags).bit_or (({NATURAL_32} 2048))
					js.break
				end
				js.reset
			end
			vim_atom___0.ce_gets (gdk_atom_intern (ce_string ("_VIM_TEXT"), 0))
			vimenc_atom___0.ce_gets (gdk_atom_intern (ce_string ("_VIMENC_TEXT"), 0))
			globals_inst.clip_star.gtk_sel_atom := create {CE_POINTER [ANY]}.make_shared (default_pointer + 1)
			globals_inst.clip_plus.gtk_sel_atom := gdk_atom_intern (ce_string ("CLIPBOARD"), 0)
			gui_inst.gui.border_offset := gui_inst.gui.border_width
			gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_object_get_type)))), ce_string ("visibility_notify_event"), (visibility_event_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.drawarea), (gtk_object_get_type)))), ce_string ("expose_event"), (expose_event_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			if ((misc2_inst.vim_strchr (option_inst.p_go, ('p').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.drawarea), (gtk_object_get_type)))), ce_string ("leave_notify_event"), (leave_notify_event_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
				gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.drawarea), (gtk_object_get_type)))), ce_string ("enter_notify_event"), (enter_notify_event_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			end
			if globals_inst.gtk_socket_id = {NATURAL_32} 0 then
				gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_object_get_type)))), ce_string ("focus_out_event"), (focus_out_event_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
				gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_object_get_type)))), ce_string ("focus_in_event"), (focus_in_event_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			else
				gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.drawarea), (gtk_object_get_type)))), ce_string ("focus_out_event"), (focus_out_event_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
				gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.drawarea), (gtk_object_get_type)))), ce_string ("focus_in_event"), (focus_in_event_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
				gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.tabline), (gtk_object_get_type)))), ce_string ("focus_out_event"), (focus_out_event_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
				gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.tabline), (gtk_object_get_type)))), ce_string ("focus_in_event"), (focus_in_event_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			end
			gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.drawarea), (gtk_object_get_type)))), ce_string ("motion_notify_event"), (motion_notify_event_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.drawarea), (gtk_object_get_type)))), ce_string ("button_press_event"), (button_press_event_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.drawarea), (gtk_object_get_type)))), ce_string ("button_release_event"), (button_release_event_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			g_signal_connect_data (create {CE_POINTER [ANY]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.drawarea), ((20).bit_shift_left (2)).to_natural_32))), ce_string ("scroll_event"), (scroll_event_address), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0).do_nothing
			gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.drawarea), (gtk_object_get_type)))), ce_string ("selection_clear_event"), (selection_clear_event_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.drawarea), (gtk_object_get_type)))), ce_string ("selection_received"), (selection_received_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			gui_gtk_set_selection_targets
			gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.drawarea), (gtk_object_get_type)))), ce_string ("selection_get"), (selection_get_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			gui_inst.gui.in_focus := 0
			Result := 1
		end

	gui_mch_new_colors
		local
			l_color: SD_GDKCOLOR
		do
			create l_color.make

			if ((gui_inst.gui.drawarea).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (((gui_inst.gui.drawarea).item.window).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					l_color.pixel := (0).to_natural_32
					l_color.red := (0).to_natural_16
					l_color.green := (0).to_natural_16
					l_color.blue := (0).to_natural_16
					l_color.pixel := (gui_inst.gui.back_pixel).to_natural_32
					gdk_window_set_background ((gui_inst.gui.drawarea).item.window, (l_color.address))
				end
			end
		end

	form_configure_event (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTCONFIGURE]; a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_usable_height: INTEGER_32
		do
			l_usable_height := a_event.item.height
			if globals_inst.gtk_socket_id /= {NATURAL_32} 0 then
				l_usable_height := l_usable_height - (gui_inst.gui.char_height - gui_inst.gui.char_height // 2)
			end
			gui_gtk_f_inst.gtk_form_freeze (create {CE_POINTER [PD_GTKFORM]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.formwin), (gui_gtk_f_inst.gtk_form_get_type)))))
			gui_inst.gui_resize_shell (a_event.item.width, l_usable_height)
			gui_gtk_f_inst.gtk_form_thaw (create {CE_POINTER [PD_GTKFORM]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.formwin), (gui_gtk_f_inst.gtk_form_get_type)))))
			Result := 1
		end

	form_configure_event_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent form_configure_event)
		end

	mainwin_destroy_cb (a_object: CE_POINTER [SD_GTKOBJECT]; a_data: CE_POINTER [ANY])
		do
			globals_inst.full_screen := 0
			gui_inst.gui.mainwin := create {CE_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer)
			gui_inst.gui.drawarea := create {CE_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer)
			if not globals_inst.exiting.to_boolean then
				misc2_inst.vim_strncpy (globals_inst.IObuff, create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Vim: Main window unexpectedly destroyed%N")))), (1024).to_natural_32)
				misc1_inst.preserve_exit
			end
		end

	mainwin_destroy_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent mainwin_destroy_cb)
		end

	check_startup_plug_hints (a_data: CE_POINTER [ANY]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if init_window_hints_state = 1 then
				init_window_hints_state := 0
				update_window_manager_hints (0, 0)
				Result := 0
				js.return
			end
			if not js.return_called then
				init_window_hints_state := 1
				Result := 1
			end
		end

	check_startup_plug_hints_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent check_startup_plug_hints)
		end

	gui_mch_open: INTEGER_32
		local
			l_fg_pixel: INTEGER_32
			l_bg_pixel: INTEGER_32
			l_pixel_width: NATURAL_32
			l_pixel_height: NATURAL_32
			l_role: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: NATURAL_32
			l_mask: INTEGER_32
			l_w: NATURAL_32
			l_h: NATURAL_32
			l_x___0: INTEGER_32
			l_y: INTEGER_32
			l_ww: INTEGER_32
			l_hh: INTEGER_32
		do
			create l_role.make

			l_fg_pixel := (-11111).to_integer_32
			l_bg_pixel := (-11111).to_integer_32
			if (role_argument.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				gtk_window_set_role (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_window_get_type)))), role_argument)
			else
				l_tmp___1 := time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
				l_tmp___2 := g_random_int
				l_role.ce_gets (g_strdup_printf ([ce_string ("vim-%%u-%%u-%%u"), (os_unix_inst.mch_get_pid).to_natural_32, l_tmp___2, l_tmp___1.to_natural_32]))
				gtk_window_set_role (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_window_get_type)))), l_role)
				g_free (create {CE_POINTER [ANY]}.make_cast (l_role))
			end
			if globals_inst.gui_win_x /= -1 then
				if globals_inst.gui_win_y /= -1 then
					gtk_window_move (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_window_get_type)))), globals_inst.gui_win_x, globals_inst.gui_win_y)
				end
			end
			if ((gui_inst.gui.geom).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_x___0 := 0
				l_y := 0
				l_mask := XParseGeometry (create {CE_POINTER [INTEGER_8]}.make_cast (gui_inst.gui.geom), create {CE_POINTER [INTEGER_32]}.make_shared ($l_x___0), create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), create {CE_POINTER [NATURAL_32]}.make_shared ($l_w), create {CE_POINTER [NATURAL_32]}.make_shared ($l_h))
				if ((l_mask).bit_and (4)).to_boolean then
					globals_inst.Columns := l_w.to_integer_32
				end
				if ((l_mask).bit_and (8)).to_boolean then
					if option_inst.p_window > l_h.to_integer_32 - 1 then
						option_inst.p_window := (l_h - {NATURAL_32} 1).to_integer_32
					elseif not (option_inst.option_was_set (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("window")))).to_boolean then
						option_inst.p_window := (l_h - {NATURAL_32} 1).to_integer_32
					end
					globals_inst.Rows := l_h.to_integer_32
				end
				l_pixel_width := ((gui_inst.gui_get_base_width).to_integer_32 + globals_inst.Columns * (gui_inst.gui.char_width).to_integer_32).to_natural_32
				l_pixel_height := ((gui_inst.gui_get_base_height).to_integer_32 + globals_inst.Rows * (gui_inst.gui.char_height).to_integer_32).to_natural_32
				l_pixel_width := l_pixel_width + (get_menu_tool_width).to_natural_32
				l_pixel_height := l_pixel_height + (get_menu_tool_height).to_natural_32
				if ((l_mask).bit_and (3)).to_boolean then
					gui_mch_get_screen_dimensions (create {CE_POINTER [INTEGER_32]}.make_shared ($l_ww), create {CE_POINTER [INTEGER_32]}.make_shared ($l_hh))
					l_hh := (l_hh.to_integer_32 + (option_inst.p_ghr + (get_menu_tool_height).to_integer_32)).to_integer_32
					l_ww := l_ww + (get_menu_tool_width)
					if ((l_mask).bit_and (16)).to_boolean then
						l_x___0 := (l_x___0.to_natural_32 + (l_ww.to_natural_32 - l_pixel_width)).to_integer_32
					end
					if ((l_mask).bit_and (32)).to_boolean then
						l_y := (l_y.to_natural_32 + (l_hh.to_natural_32 - l_pixel_height)).to_integer_32
					end
					gtk_window_move (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_window_get_type)))), l_x___0, l_y)
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (gui_inst.gui.geom))
				gui_inst.gui.geom := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				if globals_inst.gtk_socket_id /= {NATURAL_32} 0 then
					if ((l_mask).bit_and (4)).to_boolean then
						update_window_manager_hints (l_pixel_width.to_integer_32, l_pixel_height.to_integer_32)
						init_window_hints_state := 1
						g_timeout_add ((1000).to_natural_32, check_startup_plug_hints_address, create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
					elseif ((l_mask).bit_and (8)).to_boolean then
						update_window_manager_hints (l_pixel_width.to_integer_32, l_pixel_height.to_integer_32)
						init_window_hints_state := 1
						g_timeout_add ((1000).to_natural_32, check_startup_plug_hints_address, create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
					end
				end
			end
			l_pixel_width := ((gui_inst.gui_get_base_width).to_integer_32 + globals_inst.Columns * (gui_inst.gui.char_width).to_integer_32).to_natural_32
			l_pixel_height := ((gui_inst.gui_get_base_height).to_integer_32 + globals_inst.Rows * (gui_inst.gui.char_height).to_integer_32).to_natural_32
			if globals_inst.gtk_socket_id = {NATURAL_32} 0 then
				gtk_window_resize (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_window_get_type)))), l_pixel_width.to_integer_32, l_pixel_height.to_integer_32)
			end
			update_window_manager_hints (0, 0)
			if (globals_inst.foreground_argument.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_fg_pixel := gui_inst.gui_get_color (create {CE_POINTER [NATURAL_8]}.make_cast (globals_inst.foreground_argument))
			end
			if l_fg_pixel = -11111 then
				l_fg_pixel := gui_inst.gui_get_color (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Black")))
			end
			if (globals_inst.background_argument.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_bg_pixel := gui_inst.gui_get_color (create {CE_POINTER [NATURAL_8]}.make_cast (globals_inst.background_argument))
			end
			if l_bg_pixel = -11111 then
				l_bg_pixel := gui_inst.gui_get_color (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("White")))
			end
			if globals_inst.found_reverse_arg.to_boolean then
				gui_inst.gui.def_norm_pixel := l_bg_pixel
				gui_inst.gui.def_back_pixel := l_fg_pixel
			else
				gui_inst.gui.def_norm_pixel := l_fg_pixel
				gui_inst.gui.def_back_pixel := l_bg_pixel
			end
			syntax_inst.set_normal_colors
			gui_inst.gui_check_colors
			syntax_inst.highlight_gui_started
			gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_object_get_type)))), ce_string ("destroy"), (mainwin_destroy_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.formwin), (gtk_object_get_type)))), ce_string ("configure_event"), (form_configure_event_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			gui_gtk_set_dnd_targets
			gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.drawarea), (gtk_object_get_type)))), ce_string ("drag_data_received"), (drag_data_received_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			if found_iconic_arg.to_boolean then
				if globals_inst.gtk_socket_id = {NATURAL_32} 0 then
					gui_mch_iconify
				end
			end
			gtk_widget_show (gui_inst.gui.mainwin)
			Result := 1
		end

	gui_mch_exit (a_rc: INTEGER_32)
		do
			if ((gui_inst.gui.mainwin).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				gtk_widget_destroy (gui_inst.gui.mainwin)
			end
		end

	gui_mch_get_winpos (a_x___0: CE_POINTER [INTEGER_32]; a_y: CE_POINTER [INTEGER_32]): INTEGER_32
		do
			gtk_window_get_position (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_window_get_type)))), a_x___0, a_y)
			Result := 1
		end

	gui_mch_set_winpos (a_x___0: INTEGER_32; a_y: INTEGER_32)
		do
			gtk_window_move (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_window_get_type)))), a_x___0, a_y)
		end

	gui_mch_maximized: INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if ((gui_inst.gui.mainwin).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (((gui_inst.gui.mainwin).item.window).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if (((gdk_window_get_state ((gui_inst.gui.mainwin).item.window)).to_natural_32).bit_and ({NATURAL_32} 4)).to_boolean then
						l_tmp___0 := 1
					else
						l_tmp___0 := 0
					end
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	gui_mch_unmaximize
		do
			if ((gui_inst.gui.mainwin).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				gtk_window_unmaximize (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_window_get_type)))))
			end
		end

	gui_mch_set_shellsize (a_width: INTEGER_32; a_height: INTEGER_32; a_min_width: INTEGER_32; a_min_height: INTEGER_32; a_base_width: INTEGER_32; a_base_height: INTEGER_32; a_direction: INTEGER_32)
		local
			l_width: INTEGER_32
			l_height: INTEGER_32
		do
			l_width := a_width
			l_height := a_height
			gui_mch_update
			if globals_inst.gtk_socket_id = {NATURAL_32} 0 then
				update_window_manager_hints (0, 0)
			end
			l_width := l_width + (get_menu_tool_width)
			l_height := l_height + (get_menu_tool_height)
			if globals_inst.gtk_socket_id = {NATURAL_32} 0 then
				gtk_window_resize (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_window_get_type)))), l_width, l_height)
			else
				update_window_manager_hints (l_width, l_height)
			end
			gui_mch_update
		end

	gui_mch_get_screen_dimensions (a_screen_w: CE_POINTER [INTEGER_32]; a_screen_h: CE_POINTER [INTEGER_32])
		local
			l_screen: CE_POINTER [SD_GDKSCREEN]
		do
			create l_screen.make

			if ((gui_inst.gui.mainwin).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (gtk_widget_has_screen (gui_inst.gui.mainwin)).to_boolean then
					l_screen.ce_gets (gtk_widget_get_screen (gui_inst.gui.mainwin))
				else
					l_screen.ce_gets (gdk_screen_get_default)
				end
			else
				l_screen.ce_gets (gdk_screen_get_default)
			end
			a_screen_w.item := gdk_screen_get_width (l_screen)
			a_screen_h.item := ((gdk_screen_get_height (l_screen)).to_integer_32 - option_inst.p_ghr).to_integer_32
			a_screen_w.item := a_screen_w.item - (get_menu_tool_width)
			a_screen_h.item := a_screen_h.item - (get_menu_tool_height)
		end

	gui_mch_settitle (a_title: CE_POINTER [NATURAL_8]; a_icon: CE_POINTER [NATURAL_8])
		local
			l_title: CE_POINTER [NATURAL_8]
		do
			create l_title.make

			l_title.ce_gets (a_title)
			if (l_title.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if globals_inst.output_conv.vc_type /= 0 then
					l_title.ce_gets (mbyte_inst.string_convert (globals_inst.output_conv.address, l_title, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
				end
			end
			gtk_window_set_title (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_window_get_type)))), create {CE_POINTER [INTEGER_8]}.make_cast (l_title))
			if globals_inst.output_conv.vc_type /= 0 then
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_title))
			end
		end

	gui_mch_enable_menu (a_showit: INTEGER_32)
		local
			l_widget: CE_POINTER [SD_GTKWIDGET]
			l_tmp___1: INTEGER_32
		do
			create l_widget.make

			l_widget.ce_gets (gui_inst.gui.menubar)
			if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_widget), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 256)) /= {NATURAL_32} 0 then
				l_tmp___1 := 0
			else
				l_tmp___1 := 1
			end
			if not a_showit.to_boolean /= l_tmp___1.to_boolean then
				if not (gui_inst.gui.starting).to_boolean then
					if a_showit.to_boolean then
						gtk_widget_show (l_widget)
					else
						gtk_widget_hide (l_widget)
					end
					update_window_manager_hints (0, 0)
				end
			end
		end

	gui_mch_show_toolbar (a_showit: INTEGER_32)
		local
			l_widget: CE_POINTER [SD_GTKWIDGET]
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
		do
			create l_widget.make

			if ((gui_inst.gui.toolbar).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				l_widget.ce_gets (gui_inst.gui.toolbar)
				if a_showit.to_boolean then
					set_toolbar_style (create {CE_POINTER [SD_GTKTOOLBAR]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.toolbar), (gtk_toolbar_get_type)))))
				end
				if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_widget), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 256)) /= {NATURAL_32} 0 then
					l_tmp___3 := 0
				else
					l_tmp___3 := 1
				end
				if not a_showit.to_boolean /= l_tmp___3.to_boolean then
					if a_showit.to_boolean then
						gtk_widget_show (l_widget)
					else
						gtk_widget_hide (l_widget)
					end
					update_window_manager_hints (0, 0)
				end
			end
		end

	is_cjk_font (a_font_desc: CE_POINTER [ANY]): INTEGER_32
		local
			l_font: CE_POINTER [ANY]
			l_i___0: NATURAL_32
			l_is_cjk: INTEGER_32
			l_coverage: CE_POINTER [ANY]
			l_uc: NATURAL_32
			js: JUMP_STATE
		do
			create l_font.make
			create l_coverage.make

			l_is_cjk := 0
			l_font.ce_gets (pango_context_load_font (gui_inst.gui.text_context, a_font_desc))
			if (l_font.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_i___0 := {NATURAL_32} 0
				from
				until
					js.loop_left
				loop
					js.reset
					if not l_is_cjk.to_boolean then
						if not (l_i___0 < (Pointer_bytes.to_natural_32 * (5).to_natural_32) // Pointer_bytes.to_natural_32) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_coverage.ce_gets (pango_font_get_coverage (l_font, (pango_language_from_string (cjk_langs[l_i___0.to_integer_32]))))
						if (l_coverage.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if ((cjk_langs[l_i___0.to_integer_32])[0]).to_integer_32 = 107 then
								l_uc := (44032).to_natural_32
							else
								l_uc := (19968).to_natural_32
							end
							l_is_cjk := ((pango_coverage_get (l_coverage, l_uc.to_integer_32)).to_natural_32 = {NATURAL_32} 3).to_integer
							pango_coverage_unref (l_coverage)
						end
						l_i___0 := l_i___0 + 1
					end
				end
				js.reset
				g_object_unref (l_font)
				Result := l_is_cjk
			end
		end

	gui_mch_adjust_charheight: INTEGER_32
		local
			l_metrics: CE_POINTER [ANY]
			l_ascent: INTEGER_32
			l_descent: INTEGER_32
		do
			create l_metrics.make

			l_metrics.ce_gets (pango_context_get_metrics (gui_inst.gui.text_context, gui_inst.gui.norm_font, (pango_context_get_language (gui_inst.gui.text_context))))
			l_ascent := pango_font_metrics_get_ascent (l_metrics)
			l_descent := pango_font_metrics_get_descent (l_metrics)
			pango_font_metrics_unref (l_metrics)
			gui_inst.gui.char_height := (((((l_ascent + l_descent) + 1024) - 1) // 1024).to_integer_32 + option_inst.p_linespace).to_integer_32
			gui_inst.gui.char_ascent := (((l_ascent.to_integer_32 + (option_inst.p_linespace * 1024) // 2).to_integer_32 + 512)).bit_shift_right (10)
			if gui_inst.gui.char_ascent > 0 then
				gui_inst.gui.char_ascent := gui_inst.gui.char_ascent
			else
				gui_inst.gui.char_ascent := 0
			end
			if gui_inst.gui.char_height > gui_inst.gui.char_ascent + 1 then
				gui_inst.gui.char_height := gui_inst.gui.char_height
			else
				gui_inst.gui.char_height := gui_inst.gui.char_ascent + 1
			end
			Result := 1
		end

	gui_mch_font_dialog (a_oldval: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_dialog: CE_POINTER [SD_GTKWIDGET]
			l_response: INTEGER_32
			l_fontname: CE_POINTER [NATURAL_8]
			l_oldname: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [SD_GTYPEINSTANCE]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___12: NATURAL_32
			l_tmp___13: CE_POINTER [SD_GTYPEINSTANCE]
			l_name___1: CE_POINTER [INTEGER_8]
			l_p___1: CE_POINTER [NATURAL_8]
		do
			create l_dialog.make
			create l_fontname.make
			create l_oldname.make
			create l_tmp___0.make
			create l_p___0.make
			create l_tmp___13.make
			create l_name___1.make
			create l_p___1.make

			l_fontname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			l_dialog.ce_gets (gtk_font_selection_dialog_new (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)))
			l_tmp___0.ce_gets (g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_window_get_type)))
			gtk_window_set_transient_for (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dialog), (gtk_window_get_type)))), create {CE_POINTER [SD_GTKWINDOW]}.make_cast (l_tmp___0))
			gtk_window_set_destroy_with_parent (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dialog), (gtk_window_get_type)))), 1)
			if (a_oldval.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (a_oldval[0]).to_integer_32 /= 0 then
					if globals_inst.output_conv.vc_type /= 0 then
						l_oldname.ce_gets (mbyte_inst.string_convert (globals_inst.output_conv.address, a_oldval, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
					else
						l_oldname.ce_gets (a_oldval)
					end
					if not (charset_inst.vim_isdigit ((l_oldname[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_oldname))) - {NATURAL_32} 1).to_integer_32]).to_integer_32)).to_boolean then
						l_p___0.ce_gets ((misc2_inst.vim_strnsave (l_oldname, ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_oldname))) + {NATURAL_32} 3).to_integer_32)))
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))).to_integer_32)), ce_string (" 10")).do_nothing
							if (l_oldname.c_pointer.to_integer_32).to_natural_32 /= (a_oldval.c_pointer.to_integer_32).to_natural_32 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_oldname))
							end
							l_oldname.ce_gets (l_p___0)
						end
					end
					gtk_font_selection_dialog_set_font_name (create {CE_POINTER [SD_GTKFONTSELECTIONDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dialog), (gtk_font_selection_dialog_get_type)))), create {CE_POINTER [INTEGER_8]}.make_cast (l_oldname)).do_nothing
					if (l_oldname.c_pointer.to_integer_32).to_natural_32 /= (a_oldval.c_pointer.to_integer_32).to_natural_32 then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_oldname))
					end
				else
					l_tmp___12 := gtk_font_selection_dialog_get_type
					l_tmp___13.ce_gets (g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dialog), l_tmp___12))
					gtk_font_selection_dialog_set_font_name (create {CE_POINTER [SD_GTKFONTSELECTIONDIALOG]}.make_cast (l_tmp___13), ce_string ("Monospace 10")).do_nothing
				end
			else
				l_tmp___12 := gtk_font_selection_dialog_get_type
				l_tmp___13.ce_gets (g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dialog), l_tmp___12))
				gtk_font_selection_dialog_set_font_name (create {CE_POINTER [SD_GTKFONTSELECTIONDIALOG]}.make_cast (l_tmp___13), ce_string ("Monospace 10")).do_nothing
			end
			l_response := gtk_dialog_run (create {CE_POINTER [SD_GTKDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dialog), (gtk_dialog_get_type)))))
			if l_response = -5 then
				l_name___1.ce_gets (gtk_font_selection_dialog_get_font_name (create {CE_POINTER [SD_GTKFONTSELECTIONDIALOG]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_dialog), (gtk_font_selection_dialog_get_type))))))
				if (l_name___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					l_p___1.ce_gets (misc2_inst.vim_strsave_escaped (create {CE_POINTER [NATURAL_8]}.make_cast (l_name___1), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (","))))
					g_free (create {CE_POINTER [ANY]}.make_cast (l_name___1))
					if (l_p___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						if globals_inst.input_conv.vc_type /= 0 then
							l_fontname.ce_gets (mbyte_inst.string_convert (globals_inst.input_conv.address, l_p___1, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___1))
						else
							l_fontname.ce_gets (l_p___1)
						end
					else
						l_fontname.ce_gets (l_p___1)
					end
				end
			end
			if l_response /= -1 then
				gtk_widget_destroy (l_dialog)
			end
			Result := l_fontname
		end

	get_styled_font_variants
		local
			l_bold_font_desc: CE_POINTER [ANY]
			l_plain_font: CE_POINTER [ANY]
			l_bold_font: CE_POINTER [ANY]
			js: JUMP_STATE
		do
			create l_bold_font_desc.make
			create l_plain_font.make
			create l_bold_font.make

			gui_inst.gui.font_can_bold := 0
			l_plain_font.ce_gets (pango_context_load_font (gui_inst.gui.text_context, gui_inst.gui.norm_font))
			if (l_plain_font.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				l_bold_font_desc.ce_gets (pango_font_description_copy_static (gui_inst.gui.norm_font))
				pango_font_description_set_weight (l_bold_font_desc, {SC_PANGOWEIGHT}.PANGO_WEIGHT_BOLD)
				l_bold_font.ce_gets (pango_context_load_font (gui_inst.gui.text_context, l_bold_font_desc))
				if (l_bold_font.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					gui_inst.gui.font_can_bold := ((l_bold_font.c_pointer.to_integer_32).to_natural_32 /= (l_plain_font.c_pointer.to_integer_32).to_natural_32).to_integer
					g_object_unref (l_bold_font)
				end
				pango_font_description_free (l_bold_font_desc)
				g_object_unref (l_plain_font)
			end
		end

	ascii_glyph_table_init
		local
			l_ascii_chars: CE_ARRAY [NATURAL_8]
			l_attr_list: CE_POINTER [ANY]
			l_item_list: CE_POINTER [SD_GLIST]
			l_i___0: INTEGER_32
			l_item: CE_POINTER [SD_PANGOITEM]
			l_width: INTEGER_32
			l_geom: CE_POINTER [SD_PANGOGLYPHGEOMETRY]
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_ascii_chars.make (<<128>>)
			create l_attr_list.make
			create l_item_list.make
			create l_item.make
			create l_geom.make

			if ((gui_inst.gui.ascii_glyphs).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				pango_glyph_string_free (gui_inst.gui.ascii_glyphs)
			end
			if ((gui_inst.gui.ascii_font).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				g_object_unref (gui_inst.gui.ascii_font)
			end
			gui_inst.gui.ascii_glyphs := create {CE_POINTER [SD_PANGOGLYPHSTRING]}.make_shared (default_pointer)
			gui_inst.gui.ascii_font := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			l_i___0 := 0
			from
			until
				not (l_i___0 < 32)
			loop
				l_ascii_chars[l_i___0] := (('?').code).to_natural_8
				l_i___0 := l_i___0 + 1
			end
			from
			until
				not (l_i___0 < 127)
			loop
				l_ascii_chars[l_i___0] := l_i___0.to_natural_8
				l_i___0 := l_i___0 + 1
			end
			l_ascii_chars[l_i___0] := (('?').code).to_natural_8
			l_attr_list.ce_gets (pango_attr_list_new)
			l_item_list.ce_gets (pango_itemize (gui_inst.gui.text_context, create {CE_POINTER [INTEGER_8]}.make_cast (l_ascii_chars), 0, (Natural_8_bytes.to_natural_32 * (128).to_natural_32).to_integer_32, l_attr_list, create {CE_POINTER [ANY]}.make_shared (default_pointer)))
			if (l_item_list.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if ((l_item_list.item.next).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_item.ce_gets (create {CE_POINTER [SD_PANGOITEM]}.make_cast (l_item_list.item.data))
					l_width := gui_inst.gui.char_width * 1024
					default_shape_engine.ce_gets (l_item.item.analysis.shape_engine)
					gui_inst.gui.ascii_font := l_item.item.analysis.font
					g_object_ref (gui_inst.gui.ascii_font).do_nothing
					gui_inst.gui.ascii_glyphs := pango_glyph_string_new
					pango_shape (create {CE_POINTER [INTEGER_8]}.make_cast (l_ascii_chars), (Natural_8_bytes.to_natural_32 * (128).to_natural_32).to_integer_32, (create {CE_POINTER [SD_PANGOANALYSIS]}.make_shared (l_item.c_pointer + {SD_PANGOITEM}.analysis_offset)), gui_inst.gui.ascii_glyphs)
					from
					until
						js.loop_left
					loop
						js.reset
						if ((gui_inst.gui.ascii_glyphs).item.num_glyphs).to_natural_32 /= (Natural_8_bytes.to_natural_32 * (128).to_natural_32) then
							g_return_if_fail_warning (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("ascii_glyph_table_init"), ce_string ("gui.ascii_glyphs->num_glyphs == sizeof(ascii_chars)"))
							js.return
						end
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if not js.return_called then
						l_i___0 := 0
						from
						until
							not (l_i___0 < (gui_inst.gui.ascii_glyphs).item.num_glyphs)
						loop
							l_geom.ce_gets (create {CE_POINTER [SD_PANGOGLYPHGEOMETRY]}.make_shared (((gui_inst.gui.ascii_glyphs).item.glyphs + l_i___0).c_pointer + {SD_PANGOGLYPHINFO}.geometry_offset))
							if 0 > l_width - l_geom.item.width then
								l_tmp := 0
							else
								l_tmp := l_width - l_geom.item.width
							end
							l_geom.item.x_offset := l_geom.item.x_offset + (l_tmp // 2)
							l_geom.item.width := l_width
							l_i___0 := l_i___0 + 1
						end
					end
				end
			end
			if not js.return_called then
				g_list_foreach (l_item_list, (pango_item_free_address), create {CE_POINTER [ANY]}.make_shared (default_pointer))
				g_list_free (l_item_list)
				pango_attr_list_unref (l_attr_list)
			end
		end

	gui_mch_init_font (a_font_name: CE_POINTER [NATURAL_8]; a_fontset: INTEGER_32): INTEGER_32
		local
			l_font_name: CE_POINTER [NATURAL_8]
			l_font_desc: CE_POINTER [ANY]
			l_layout: CE_POINTER [ANY]
			l_width: INTEGER_32
			l_cjk_width: INTEGER_32
			l_w: INTEGER_32
			l_h: INTEGER_32
			js: JUMP_STATE
		do
			create l_font_name.make
			create l_font_desc.make
			create l_layout.make

			l_font_name.ce_gets (a_font_name)
			if (l_font_name.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_font_name.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Monospace 10")))
			end
			l_font_desc.ce_gets (gui_mch_get_font (l_font_name, 0))
			if (l_font_desc.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 0
				js.return
			end
			if not js.return_called then
				gui_mch_free_font (gui_inst.gui.norm_font)
				gui_inst.gui.norm_font := l_font_desc
				pango_context_set_font_description (gui_inst.gui.text_context, l_font_desc)
				l_layout.ce_gets (pango_layout_new (gui_inst.gui.text_context))
				pango_layout_set_text (l_layout, ce_string ("MW"), 2)
				pango_layout_get_size (l_layout, create {CE_POINTER [INTEGER_32]}.make_shared ($l_width), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
				if (is_cjk_font (gui_inst.gui.norm_font)).to_boolean then
					pango_layout_set_text (l_layout, ce_string ("%/228/%/184/%/128/%/228/%/186/%/140/"), -1)
					pango_layout_get_size (l_layout, create {CE_POINTER [INTEGER_32]}.make_shared ($l_cjk_width), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
					if l_width = l_cjk_width then
						l_width := l_width // (2)
					end
				end
				g_object_unref (l_layout)
				gui_inst.gui.char_width := ((l_width // 2 + 1024) - 1) // 1024
				if gui_inst.gui.char_width <= 0 then
					gui_inst.gui.char_width := 8
				end
				gui_mch_adjust_charheight.do_nothing
				syntax_inst.hl_set_font_name (l_font_name)
				get_styled_font_variants
				ascii_glyph_table_init
				if ((gui_inst.gui.wide_font).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if (pango_font_description_equal (gui_inst.gui.norm_font, gui_inst.gui.wide_font)).to_boolean then
						pango_font_description_free (gui_inst.gui.wide_font)
						gui_inst.gui.wide_font := create {CE_POINTER [ANY]}.make_shared (default_pointer)
					end
				end
				if (gui_mch_maximized).to_boolean then
					gtk_window_get_size (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_window_get_type)))), create {CE_POINTER [INTEGER_32]}.make_shared ($l_w), create {CE_POINTER [INTEGER_32]}.make_shared ($l_h))
					l_w := l_w - (get_menu_tool_width)
					l_h := l_h - (get_menu_tool_height)
					gui_inst.gui_resize_shell (l_w, l_h)
				else
					update_window_manager_hints (0, 0)
				end
				Result := 1
			end
		end

	gui_mch_get_font (a_name___1: CE_POINTER [NATURAL_8]; a_report_error: INTEGER_32): CE_POINTER [ANY]
		local
			l_font: CE_POINTER [ANY]
			l_buf___6: CE_POINTER [NATURAL_8]
			l_real_font: CE_POINTER [ANY]
			js: JUMP_STATE
		do
			create l_font.make
			create l_buf___6.make
			create l_real_font.make

			if not (gui_inst.gui.in_use).to_boolean then
				Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
				js.return
			elseif (a_name___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				if globals_inst.output_conv.vc_type /= 0 then
					l_buf___6.ce_gets (mbyte_inst.string_convert (globals_inst.output_conv.address, a_name___1, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
					if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_font.ce_gets (pango_font_description_from_string (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6)))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
					else
						l_font.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer))
					end
				else
					l_font.ce_gets (pango_font_description_from_string (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1)))
				end
				if (l_font.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if (pango_font_description_get_size (l_font)) <= 0 then
						pango_font_description_set_size (l_font, 10240)
					end
					l_real_font.ce_gets (pango_context_load_font (gui_inst.gui.text_context, l_font))
					if (l_real_font.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						pango_font_description_free (l_font)
						l_font.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer))
					else
						g_object_unref (l_real_font)
					end
				end
				if (l_font.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					if a_report_error.to_boolean then
						message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_font)))), a_name___1).do_nothing
					end
					Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				Result := l_font
			end
		end

	gui_mch_get_fontname (a_font: CE_POINTER [ANY]; a_name___1: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_pangoname: CE_POINTER [INTEGER_8]
			l_s: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_pangoname.make
			create l_s.make

			if (a_font.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_pangoname.ce_gets ((pango_font_description_to_string (a_font)))
				if (l_pangoname.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					l_s.ce_gets ((misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (l_pangoname))))
					g_free (create {CE_POINTER [ANY]}.make_cast (l_pangoname))
					Result := l_s
					js.return
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	gui_mch_free_font (a_font: CE_POINTER [ANY])
		do
			if (a_font.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				pango_font_description_free (a_font)
			end
		end

	gui_mch_get_color (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_name___1: CE_POINTER [NATURAL_8]
			l_color: SD_GDKCOLOR
			l_parsed: INTEGER_32
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_name___1.make
			create l_color.make

			l_name___1.ce_gets (a_name___1)
			if not (gui_inst.gui.in_use).to_boolean then
				Result := (-11111).to_integer_32
				js.return
			end
			if not js.return_called then
				from
				until
					not (not js.loop_left and then ((l_name___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
				loop
					l_parsed := gdk_color_parse (create {CE_POINTER [INTEGER_8]}.make_cast (l_name___1), l_color.address)
					if l_parsed.to_boolean then
						gdk_colormap_alloc_color ((gtk_widget_get_colormap (gui_inst.gui.drawarea)), l_color.address, 0, 1).do_nothing
						Result := (l_color.pixel).to_integer_32
						js.return
					end
					if not js.return_called then
						l_i___0 := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if (((vimnames[l_i___0])[0]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_name___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								js.break
							end
							if not js.loop_jumped then
								if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_name___1), (vimnames[l_i___0])[0])) = 0 then
									l_name___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((vimnames[l_i___0])[1]))
									js.break
								end
							end
							if not js.loop_jumped then
								l_i___0 := l_i___0 + 1
							end
						end
						js.reset
					end
				end
			end
			if not js.return_called then
				Result := (-11111).to_integer_32
			end
		end

	gui_mch_set_fg_color (a_color: INTEGER_32)
		do
			(gui_inst.gui.fgcolor).item.pixel := a_color.to_natural_32
		end

	gui_mch_set_bg_color (a_color: INTEGER_32)
		do
			(gui_inst.gui.bgcolor).item.pixel := a_color.to_natural_32
		end

	gui_mch_set_sp_color (a_color: INTEGER_32)
		do
			(gui_inst.gui.spcolor).item.pixel := a_color.to_natural_32
		end

	apply_wide_font_attr (a_s: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_attr_list: CE_POINTER [ANY])
		local
			l_start___1: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_uc: INTEGER_32
			l_tmp_attr_: CE_POINTER [SD_PANGOATTRIBUTE]
			l_tmp_attr____0: CE_POINTER [SD_PANGOATTRIBUTE]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_start___1.make
			create l_p___0.make
			create l_tmp_attr_.make
			create l_tmp_attr____0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_start___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_p___0.ce_gets (a_s)
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((a_s + a_len).c_pointer.to_integer_32).to_natural_32)) then
						l_pos := -1 + 12 -- skip loop
					end
				when 2 then -- loop body:
						l_uc := mbyte_inst.utf_ptr2char (l_p___0)
						if (l_start___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_uc >= 128 then
							if (mbyte_inst.utf_char2cells (l_uc)) = 2 then
								l_start___1.ce_gets (l_p___0)
							end
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 5 then -- else:
						if not (l_uc < 128) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 8 then -- else:
						if (mbyte_inst.utf_char2cells (l_uc)) = 2 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if (mbyte_inst.utf_iscomposing (l_uc)).to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp_attr_.ce_gets (pango_attr_font_desc_new (gui_inst.gui.wide_font))
							l_tmp_attr_.item.start_index := (l_start___1.distance (a_s)).to_natural_32
							l_tmp_attr_.item.end_index := (l_p___0.distance (a_s)).to_natural_32
							pango_attr_list_insert (a_attr_list, l_tmp_attr_)
							js.break
						end
						js.reset
						l_start___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				when 11 then -- if done | if done | if done
						l_p___0.ce_gets (l_p___0 + (mbyte_inst.utf_byte2len ((l_p___0.item).to_integer_32)))
						l_pos := -1 + 1 -- back to loop condition
				when 12 then -- loop done
					if (l_start___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp_attr____0.ce_gets (pango_attr_font_desc_new (gui_inst.gui.wide_font))
							l_tmp_attr____0.item.start_index := (l_start___1.distance (a_s)).to_natural_32
							l_tmp_attr____0.item.end_index := a_len.to_natural_32
							pango_attr_list_insert (a_attr_list, l_tmp_attr____0)
							js.break
						end
						js.reset
					end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	count_cluster_cells (a_s: CE_POINTER [NATURAL_8]; a_item: CE_POINTER [SD_PANGOITEM]; a_glyphs: CE_POINTER [SD_PANGOGLYPHSTRING]; a_i___0: INTEGER_32; a_cluster_width: CE_POINTER [INTEGER_32]; a_last_glyph_rbearing: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_next: INTEGER_32
			l_start___1: INTEGER_32
			l_end: INTEGER_32
			l_width: INTEGER_32
			l_uc: INTEGER_32
			l_cellcount: INTEGER_32
			l_tmp: INTEGER_32
			l_ink_rect: SD_PANGORECTANGLE
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_ink_rect.make

			l_cellcount := 0
			l_width := (a_glyphs.item.glyphs + a_i___0).item.geometry.width
			l_next := a_i___0 + 1
			from
			until
				not (not js.loop_left and then (l_next < a_glyphs.item.num_glyphs))
			loop
				js.reset
				if ((a_glyphs.item.glyphs + l_next).item.attr.is_cluster_start).to_boolean then
					js.break
				elseif (a_glyphs.item.glyphs + l_next).item.geometry.width > l_width then
					l_width := (a_glyphs.item.glyphs + l_next).item.geometry.width
				end
				if not js.loop_jumped then
					l_next := l_next + 1
				end
			end
			js.reset
			l_start___1 := a_item.item.offset + a_glyphs.item.log_clusters[a_i___0]
			if l_next < a_glyphs.item.num_glyphs then
				l_tmp := a_glyphs.item.log_clusters[l_next]
			else
				l_tmp := a_item.item.length
			end
			l_end := a_item.item.offset + l_tmp
			l_p___0.ce_gets (a_s + l_start___1)
			from
			until
				not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((a_s + l_end).c_pointer.to_integer_32).to_natural_32)
			loop
				l_uc := mbyte_inst.utf_ptr2char (l_p___0)
				if l_uc < 128 then
					l_cellcount := l_cellcount + 1
				elseif not (mbyte_inst.utf_iscomposing (l_uc)).to_boolean then
					l_cellcount := l_cellcount + (mbyte_inst.utf_char2cells (l_uc))
				end
				l_p___0.ce_gets (l_p___0 + (mbyte_inst.utf_byte2len ((l_p___0.item).to_integer_32)))
			end
			if (a_last_glyph_rbearing.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if l_cellcount > 0 then
					if l_next = a_glyphs.item.num_glyphs then
						pango_font_get_glyph_extents (a_item.item.analysis.font, (a_glyphs.item.glyphs + a_i___0).item.glyph, l_ink_rect.address, create {CE_POINTER [SD_PANGORECTANGLE]}.make_shared (default_pointer))
						if l_ink_rect.x + l_ink_rect.width > 0 then
							a_last_glyph_rbearing.item := l_ink_rect.x + l_ink_rect.width
						end
					end
				end
			end
			if l_cellcount > 0 then
				a_cluster_width.item := l_width
			end
			Result := l_cellcount
		end

	setup_zero_width_cluster (a_item: CE_POINTER [SD_PANGOITEM]; a_glyph: CE_POINTER [SD_PANGOGLYPHINFO]; a_last_cellcount: INTEGER_32; a_last_cluster_width: INTEGER_32; a_last_glyph_rbearing: INTEGER_32)
		local
			l_ink_rect: SD_PANGORECTANGLE
			l_logical_rect: SD_PANGORECTANGLE
			l_width: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			create l_ink_rect.make
			create l_logical_rect.make

			l_width := (a_last_cellcount * gui_inst.gui.char_width) * 1024
			if 0 > l_width - a_last_cluster_width then
				l_tmp := 0
			else
				l_tmp := l_width - a_last_cluster_width
			end
			a_glyph.item.geometry.x_offset := -l_width + l_tmp // 2
			a_glyph.item.geometry.width := 0
			pango_font_get_glyph_extents (a_item.item.analysis.font, a_glyph.item.glyph, l_ink_rect.address, l_logical_rect.address)
			if l_ink_rect.x < 0 then
				a_glyph.item.geometry.x_offset := a_glyph.item.geometry.x_offset + a_last_glyph_rbearing
				a_glyph.item.geometry.y_offset := ((l_logical_rect.height).to_integer_32 - ((gui_inst.gui.char_height).to_integer_32 - option_inst.p_linespace) * 1024).to_integer_32
			else
				if 0 > l_width - l_ink_rect.width then
					l_tmp___0 := 0
				else
					l_tmp___0 := l_width - l_ink_rect.width
				end
				a_glyph.item.geometry.x_offset := -l_width + l_tmp___0 // 2
			end
		end

	draw_glyph_string (a_row: INTEGER_32; a_col: INTEGER_32; a_num_cells: INTEGER_32; a_flags___0: INTEGER_32; a_font: CE_POINTER [ANY]; a_glyphs: CE_POINTER [SD_PANGOGLYPHSTRING])
		do
			if not ((a_flags___0).bit_and (1)).to_boolean then
				gdk_gc_set_foreground (gui_inst.gui.text_gc, gui_inst.gui.bgcolor)
				gdk_draw_rectangle ((gui_inst.gui.drawarea).item.window, gui_inst.gui.text_gc, 1, a_col * gui_inst.gui.char_width + gui_inst.gui.border_offset, a_row * gui_inst.gui.char_height + gui_inst.gui.border_offset, a_num_cells * gui_inst.gui.char_width, gui_inst.gui.char_height)
			end
			gdk_gc_set_foreground (gui_inst.gui.text_gc, gui_inst.gui.fgcolor)
			gdk_draw_glyphs ((gui_inst.gui.drawarea).item.window, gui_inst.gui.text_gc, a_font, a_col * gui_inst.gui.char_width + gui_inst.gui.border_offset, (a_row * gui_inst.gui.char_height + gui_inst.gui.char_ascent) + gui_inst.gui.border_offset, a_glyphs)
			if ((a_flags___0).bit_and (2)).to_boolean then
				if not (gui_inst.gui.font_can_bold).to_boolean then
					gdk_draw_glyphs ((gui_inst.gui.drawarea).item.window, gui_inst.gui.text_gc, a_font, (a_col * gui_inst.gui.char_width + gui_inst.gui.border_offset) + 1, (a_row * gui_inst.gui.char_height + gui_inst.gui.char_ascent) + gui_inst.gui.border_offset, a_glyphs)
				end
			end
		end

	draw_under (a_flags___0: INTEGER_32; a_row: INTEGER_32; a_col: INTEGER_32; a_cells: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_offset: INTEGER_32
			l_y: INTEGER_32
		do
			l_y := ((a_row + 1) * gui_inst.gui.char_height + gui_inst.gui.border_offset) - 1
			if ((a_flags___0).bit_and (8)).to_boolean then
				gdk_gc_set_foreground (gui_inst.gui.text_gc, gui_inst.gui.spcolor)
				l_i___0 := a_col * gui_inst.gui.char_width + gui_inst.gui.border_offset
				from
				until
					not (l_i___0 < (a_col + a_cells) * gui_inst.gui.char_width + gui_inst.gui.border_offset)
				loop
					l_offset := val[l_i___0 \\ 8]
					gdk_draw_point ((gui_inst.gui.drawarea).item.window, gui_inst.gui.text_gc, l_i___0, l_y - l_offset)
					l_i___0 := l_i___0 + 1
				end
				gdk_gc_set_foreground (gui_inst.gui.text_gc, gui_inst.gui.fgcolor)
			end
			if ((a_flags___0).bit_and (4)).to_boolean then
				if option_inst.p_linespace > 1 then
					l_y := (l_y.to_integer_32 - (option_inst.p_linespace - 1)).to_integer_32
				end
				gdk_draw_line ((gui_inst.gui.drawarea).item.window, gui_inst.gui.text_gc, a_col * gui_inst.gui.char_width + gui_inst.gui.border_offset, l_y, ((a_col + a_cells) * gui_inst.gui.char_width + gui_inst.gui.border_offset) - 1, l_y)
			end
		end

	gui_gtk2_draw_string (a_row: INTEGER_32; a_col: INTEGER_32; a_s: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_flags___0: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_area: SD_GDKRECTANGLE
			l_glyphs: CE_POINTER [SD_PANGOGLYPHSTRING]
			l_column_offset: INTEGER_32
			l_i___0: INTEGER_32
			l_conv_buf: CE_POINTER [NATURAL_8]
			l_new_conv_buf: CE_POINTER [NATURAL_8]
			l_convlen: INTEGER_32
			l_sp: CE_POINTER [NATURAL_8]
			l_bp___0: CE_POINTER [NATURAL_8]
			l_plen: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_attr_list: CE_POINTER [ANY]
			l_item_list: CE_POINTER [SD_GLIST]
			l_cluster_width: INTEGER_32
			l_last_glyph_rbearing: INTEGER_32
			l_cells: INTEGER_32
			l_tmp_attr_: CE_POINTER [SD_PANGOATTRIBUTE]
			l_tmp_attr____0: CE_POINTER [SD_PANGOATTRIBUTE]
			l_item: CE_POINTER [SD_PANGOITEM]
			l_item_cells: INTEGER_32
			l_glyph: CE_POINTER [SD_PANGOGLYPHINFO]
			l_cellcount: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_32]
			l_width: INTEGER_32
			l_tmp___4: INTEGER_32
			l_width___0: INTEGER_32
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_area.make
			create l_glyphs.make
			create l_conv_buf.make
			create l_new_conv_buf.make
			create l_sp.make
			create l_bp___0.make
			create l_p___0.make
			create l_attr_list.make
			create l_item_list.make
			create l_tmp_attr_.make
			create l_tmp_attr____0.make
			create l_item.make
			create l_glyph.make
			create l_tmp___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s.ce_gets (a_s)
					l_len := a_len
					l_column_offset := 0
					l_conv_buf.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					if ((gui_inst.gui.text_context).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := l_len
						js.return
					elseif (((gui_inst.gui.drawarea).item.window).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := l_len
						js.return
					end
					if not js.return_called and then (globals_inst.output_conv.vc_type /= 0) then
						l_convlen := l_len
						l_conv_buf.ce_gets (mbyte_inst.string_convert (globals_inst.output_conv.address, l_s, create {CE_POINTER [INTEGER_32]}.make_shared ($l_convlen)))
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_conv_buf.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								g_return_if_fail_warning (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("gui_gtk2_draw_string"), ce_string ("conv_buf != NULL"))
								Result := l_len
								js.return
							end
							if not js.return_called then
								js.break
							end
						end
						js.reset
						if not js.return_called then
							l_sp.ce_gets (l_s)
							l_bp___0.ce_gets (l_conv_buf)
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_sp.c_pointer.to_integer_32).to_natural_32 < ((l_s + l_len).c_pointer.to_integer_32).to_natural_32 then
									if not ((l_bp___0.c_pointer.to_integer_32).to_natural_32 < ((l_conv_buf + l_convlen).c_pointer.to_integer_32).to_natural_32) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_plen := mbyte_inst.utf_ptr2len (l_bp___0)
									if (globals_inst.mb_ptr2cells.integer_32_item ([l_sp])) = 2 then
										if (mbyte_inst.utf_ptr2cells (l_bp___0)) = 1 then
											l_new_conv_buf.ce_gets (misc2_inst.alloc ((l_convlen + 2).to_natural_32))
											if (l_new_conv_buf.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
												Result := l_len
												js.return
											end
											if not js.return_called then
												l_plen := l_plen + (l_bp___0.distance (l_conv_buf))
												memmove (create {CE_POINTER [ANY]}.make_cast (l_new_conv_buf), create {CE_POINTER [ANY]}.make_cast (l_conv_buf), l_plen.to_natural_32).do_nothing
												l_new_conv_buf[l_plen] := ((' ').code).to_natural_8
												memmove (create {CE_POINTER [ANY]}.make_cast (((l_new_conv_buf + l_plen) + 1)), create {CE_POINTER [ANY]}.make_cast ((l_conv_buf + l_plen)), ((l_convlen - l_plen) + 1).to_natural_32).do_nothing
												misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_conv_buf))
												l_conv_buf.ce_gets (l_new_conv_buf)
												l_convlen := l_convlen + 1
												l_bp___0.ce_gets (l_conv_buf + l_plen)
												l_plen := 1
											end
										end
									end
									if not js.return_called then
										l_sp.ce_gets (l_sp + (globals_inst.mb_ptr2len.integer_32_item ([l_sp])))
										l_bp___0.ce_gets (l_bp___0 + l_plen)
									end
								end
							end
							js.reset
						end
						if not js.return_called then
							l_s.ce_gets (l_conv_buf)
							l_len := l_convlen
						end
					end
					if js.return_called then
						l_pos := -1 + 17 -- skip if block
					end
				when 1 then -- if:
						l_area.x := gui_inst.gui.border_offset
						l_area.y := a_row * gui_inst.gui.char_height + gui_inst.gui.border_offset
						l_area.width := gui_inst.gui.num_cols * gui_inst.gui.char_width
						l_area.height := gui_inst.gui.char_height
						gdk_gc_set_clip_origin (gui_inst.gui.text_gc, 0, 0)
						gdk_gc_set_clip_rectangle (gui_inst.gui.text_gc, (l_area.address))
						l_glyphs.ce_gets (pango_glyph_string_new)
						if ((a_flags___0).bit_and (16)).to_boolean then
							l_pos := -1 + 14 -- skip if block
						end
				when 2 then -- if:
						if not (((a_flags___0).bit_and (2)).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (gui_inst.gui.font_can_bold).to_boolean then
							l_pos := -1 + 14 -- goto not_ascii
						else
							l_pos := -1 + 5 -- goto _L___1
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 5 then -- else: | _L___1:
						if ((gui_inst.gui.ascii_glyphs).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 12 -- skip if block
						end
				when 6 then -- if:
						l_p___0.ce_gets (l_s)
				when 7 then -- loop condition:
						if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_s + l_len).c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 10 -- skip loop
						end
				when 8 then -- loop body:
						if (((l_p___0.item).to_integer_32).bit_and (128)).to_boolean then
							l_pos := -1 + 14 -- goto not_ascii
						end
				when 9 then
						l_p___0.ce_gets (l_p___0 + 1)
						l_pos := -1 + 7 -- back to loop condition
				when 10 then -- loop done
						pango_glyph_string_set_size (l_glyphs, l_len)
						l_i___0 := 0
						from
						until
							not (l_i___0 < l_len)
						loop
							l_glyphs.item.glyphs[l_i___0] := (gui_inst.gui.ascii_glyphs).item.glyphs[(l_s[l_i___0]).to_integer_32]
							l_glyphs.item.log_clusters[l_i___0] := l_i___0
							l_i___0 := l_i___0 + 1
						end
						draw_glyph_string (a_row, a_col, l_len, a_flags___0, gui_inst.gui.ascii_font, l_glyphs)
						l_column_offset := l_len
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						l_pos := -1 + 14 -- goto not_ascii
				when 13 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 16
				when 14 then -- else: | not_ascii:
						l_cells := 0
						if not (mbyte_inst.utf_valid_string (l_s, l_s + l_len)).to_boolean then
							l_column_offset := l_len
							l_pos := -1 + 16 -- goto skipitall
						end
				when 15 then
						l_cluster_width := 1024 * gui_inst.gui.char_width
						l_last_glyph_rbearing := 1024 * gui_inst.gui.char_width
						l_attr_list.ce_gets (pango_attr_list_new)
						if ((gui_inst.gui.wide_font).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							apply_wide_font_attr (l_s, l_len, l_attr_list)
						end
						if ((a_flags___0).bit_and (2)).to_boolean then
							if (gui_inst.gui.font_can_bold).to_boolean then
								from
								until
									js.loop_left
								loop
									js.reset
									l_tmp_attr_.ce_gets (pango_attr_weight_new ({SC_PANGOWEIGHT}.PANGO_WEIGHT_BOLD))
									l_tmp_attr_.item.start_index := (0).to_natural_32
									l_tmp_attr_.item.end_index := l_len.to_natural_32
									pango_attr_list_insert (l_attr_list, l_tmp_attr_)
									js.break
								end
								js.reset
							end
						end
						if ((a_flags___0).bit_and (16)).to_boolean then
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp_attr____0.ce_gets (pango_attr_style_new ({SC_PANGOSTYLE}.PANGO_STYLE_ITALIC))
								l_tmp_attr____0.item.start_index := (0).to_natural_32
								l_tmp_attr____0.item.end_index := l_len.to_natural_32
								pango_attr_list_insert (l_attr_list, l_tmp_attr____0)
								js.break
							end
							js.reset
						end
						l_item_list.ce_gets (pango_itemize (gui_inst.gui.text_context, create {CE_POINTER [INTEGER_8]}.make_cast (l_s), 0, l_len, l_attr_list, create {CE_POINTER [ANY]}.make_shared (default_pointer)))
						from
						until
							not (not js.loop_left and then ((l_item_list.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
						loop
							l_item_cells := 0
							l_item.ce_gets (create {CE_POINTER [SD_PANGOITEM]}.make_cast (l_item_list.item.data))
							l_item_list.ce_gets (g_list_delete_link (l_item_list, l_item_list))
							l_item.item.analysis.level := ((((l_item.item.analysis.level).to_integer_32 + 1).to_natural_32).bit_and ({NATURAL_32} 4294967294)).to_natural_8
							l_item.item.analysis.shape_engine := default_shape_engine
							pango_shape (create {CE_POINTER [INTEGER_8]}.make_cast (l_s) + l_item.item.offset, l_item.item.length, (create {CE_POINTER [SD_PANGOANALYSIS]}.make_shared (l_item.c_pointer + {SD_PANGOITEM}.analysis_offset)), l_glyphs)
							l_i___0 := 0
							from
							until
								not (l_i___0 < l_glyphs.item.num_glyphs)
							loop
								l_glyph.ce_gets (l_glyphs.item.glyphs + l_i___0)
								if (l_glyph.item.attr.is_cluster_start).to_boolean then
									if (l_item_list.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										l_tmp___3.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared ($l_last_glyph_rbearing))
									else
										l_tmp___3.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
									end
									l_cellcount := count_cluster_cells (l_s, l_item, l_glyphs, l_i___0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_cluster_width), l_tmp___3)
									if l_cellcount > 0 then
										l_width := (l_cellcount * gui_inst.gui.char_width) * 1024
										if 0 > l_width - l_cluster_width then
											l_tmp___4 := 0
										else
											l_tmp___4 := l_width - l_cluster_width
										end
										l_glyph.item.geometry.x_offset := l_glyph.item.geometry.x_offset + (l_tmp___4 // 2)
										l_glyph.item.geometry.width := l_width
									else
										setup_zero_width_cluster (l_item, l_glyph, l_cells, l_cluster_width, l_last_glyph_rbearing)
									end
									l_item_cells := l_item_cells + l_cellcount
									l_cells := l_cellcount
								elseif l_i___0 > 0 then
									if l_glyph.item.geometry.x_offset >= 0 then
										(l_glyphs.item.glyphs + l_i___0).item.geometry.width := (l_glyphs.item.glyphs + (l_i___0 - 1)).item.geometry.width;
										(l_glyphs.item.glyphs + (l_i___0 - 1)).item.geometry.width := 0
									end
									l_width___0 := (l_cells * gui_inst.gui.char_width) * 1024
									if 0 > l_width___0 - l_cluster_width then
										l_tmp___5 := 0
									else
										l_tmp___5 := l_width___0 - l_cluster_width
									end
									l_glyph.item.geometry.x_offset := l_glyph.item.geometry.x_offset + (l_tmp___5 // 2)
								else
									l_glyph.item.geometry.width := 0
								end
								l_i___0 := l_i___0 + 1
							end
							draw_glyph_string (a_row, a_col + l_column_offset, l_item_cells, a_flags___0, l_item.item.analysis.font, l_glyphs)
							pango_item_free (l_item)
							l_column_offset := l_column_offset + l_item_cells
						end
						pango_attr_list_unref (l_attr_list)
				when 16 then -- skipitall:
						draw_under (a_flags___0, a_row, a_col, l_column_offset)
						pango_glyph_string_free (l_glyphs)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_conv_buf))
						gdk_gc_set_clip_rectangle (gui_inst.gui.text_gc, create {CE_POINTER [SD_GDKRECTANGLE]}.make_shared (default_pointer))
						Result := l_column_offset
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gui_mch_haskey (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (special_keys[l_i___0].key_sym /= {NATURAL_32} 0))
			loop
				if (a_name___1[0]).to_integer_32 = (special_keys[l_i___0].code0).to_integer_32 then
					if (a_name___1[1]).to_integer_32 = (special_keys[l_i___0].code1).to_integer_32 then
						Result := 1
						js.return
					end
				end
				if not js.return_called then
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gui_get_x11_windis (a_win: CE_POINTER [NATURAL_32]; a_dis: CE_POINTER [CE_POINTER [ANY]]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if ((gui_inst.gui.mainwin).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (((gui_inst.gui.mainwin).item.window).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					a_dis.item := gdk_x11_drawable_get_xdisplay ((gdk_x11_window_get_drawable_impl ((gui_inst.gui.mainwin).item.window)))
					a_win.item := gdk_x11_drawable_get_xid ((gui_inst.gui.mainwin).item.window)
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				a_dis.item := create {CE_POINTER [ANY]}.make_shared (default_pointer)
				a_win.item := (0).to_natural_32
				Result := 0
			end
		end

	gui_mch_get_display: CE_POINTER [ANY]
		do
			if ((gui_inst.gui.mainwin).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (((gui_inst.gui.mainwin).item.window).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					Result := (gdk_x11_drawable_get_xdisplay ((gdk_x11_window_get_drawable_impl ((gui_inst.gui.mainwin).item.window))))
				else
					Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
				end
			else
				Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
			end
		end

	gui_mch_beep
		local
			l_display: CE_POINTER [SD_GDKDISPLAY]
		do
			create l_display.make

			if ((gui_inst.gui.mainwin).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 64)) /= {NATURAL_32} 0 then
					l_display.ce_gets (gtk_widget_get_display (gui_inst.gui.mainwin))
				else
					l_display.ce_gets (gdk_display_get_default)
				end
			else
				l_display.ce_gets (gdk_display_get_default)
			end
			if (l_display.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				gdk_display_beep (l_display)
			end
		end

	gui_mch_flash (a_msec: INTEGER_32)
		local
			l_values: SD_GDKGCVALUES
			l_invert_gc: CE_POINTER [SD_GDKGC]
			js: JUMP_STATE
		do
			create l_values.make
			create l_invert_gc.make

			if (((gui_inst.gui.drawarea).item.window).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				l_values.foreground.pixel := ((gui_inst.gui.norm_pixel).bit_xor (gui_inst.gui.back_pixel)).to_natural_32
				l_values.background.pixel := ((gui_inst.gui.norm_pixel).bit_xor (gui_inst.gui.back_pixel)).to_natural_32
				l_values.function := {SC_GDKFUNCTION}.GDK_XOR
				l_invert_gc.ce_gets (gdk_gc_new_with_values ((gui_inst.gui.drawarea).item.window, l_values.address, 11))
				gdk_gc_set_exposures (l_invert_gc, (gui_inst.gui.visibility /= 0).to_integer)
				gdk_draw_rectangle ((gui_inst.gui.drawarea).item.window, l_invert_gc, 1, 0, 0, (globals_inst.Columns.to_integer_32 * gui_inst.gui.char_width + gui_inst.gui.border_offset) + gui_inst.gui.border_offset, (globals_inst.Rows.to_integer_32 * gui_inst.gui.char_height + gui_inst.gui.border_offset) + gui_inst.gui.border_offset)
				gui_mch_flush
				ui_inst.ui_delay (a_msec.to_integer_32, 1)
				gdk_draw_rectangle ((gui_inst.gui.drawarea).item.window, l_invert_gc, 1, 0, 0, (globals_inst.Columns.to_integer_32 * gui_inst.gui.char_width + gui_inst.gui.border_offset) + gui_inst.gui.border_offset, (globals_inst.Rows.to_integer_32 * gui_inst.gui.char_height + gui_inst.gui.border_offset) + gui_inst.gui.border_offset)
				g_object_unref (create {CE_POINTER [ANY]}.make_cast (l_invert_gc))
			end
		end

	gui_mch_invert_rectangle (a_r: INTEGER_32; a_c: INTEGER_32; a_nr: INTEGER_32; a_nc: INTEGER_32)
		local
			l_values: SD_GDKGCVALUES
			l_invert_gc: CE_POINTER [SD_GDKGC]
			js: JUMP_STATE
		do
			create l_values.make
			create l_invert_gc.make

			if (((gui_inst.gui.drawarea).item.window).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				l_values.foreground.pixel := ((gui_inst.gui.norm_pixel).bit_xor (gui_inst.gui.back_pixel)).to_natural_32
				l_values.background.pixel := ((gui_inst.gui.norm_pixel).bit_xor (gui_inst.gui.back_pixel)).to_natural_32
				l_values.function := {SC_GDKFUNCTION}.GDK_XOR
				l_invert_gc.ce_gets (gdk_gc_new_with_values ((gui_inst.gui.drawarea).item.window, l_values.address, 11))
				gdk_gc_set_exposures (l_invert_gc, (gui_inst.gui.visibility /= 0).to_integer)
				gdk_draw_rectangle ((gui_inst.gui.drawarea).item.window, l_invert_gc, 1, a_c * gui_inst.gui.char_width + gui_inst.gui.border_offset, a_r * gui_inst.gui.char_height + gui_inst.gui.border_offset, a_nc * gui_inst.gui.char_width, a_nr * gui_inst.gui.char_height)
				g_object_unref (create {CE_POINTER [ANY]}.make_cast (l_invert_gc))
			end
		end

	gui_mch_iconify
		do
			gtk_window_iconify (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_window_get_type)))))
		end

	gui_mch_set_foreground
		do
			gtk_window_present (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_window_get_type)))))
		end

	gui_mch_draw_hollow_cursor (a_color: INTEGER_32)
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 1
			if (((gui_inst.gui.drawarea).item.window).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				gui_mch_set_fg_color (a_color)
				gdk_gc_set_foreground (gui_inst.gui.text_gc, gui_inst.gui.fgcolor)
				if (mbyte_inst.mb_lefthalve (gui_inst.gui.row, gui_inst.gui.col)).to_boolean then
					l_i___0 := 2
				end
				gdk_draw_rectangle ((gui_inst.gui.drawarea).item.window, gui_inst.gui.text_gc, 0, gui_inst.gui.col * gui_inst.gui.char_width + gui_inst.gui.border_offset, gui_inst.gui.row * gui_inst.gui.char_height + gui_inst.gui.border_offset, l_i___0 * gui_inst.gui.char_width - 1, gui_inst.gui.char_height - 1)
			end
		end

	gui_mch_draw_part_cursor (a_w: INTEGER_32; a_h: INTEGER_32; a_color: INTEGER_32)
		local
			js: JUMP_STATE
		do
			if (((gui_inst.gui.drawarea).item.window).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				gui_mch_set_fg_color (a_color)
				gdk_gc_set_foreground (gui_inst.gui.text_gc, gui_inst.gui.fgcolor)
				gdk_draw_rectangle ((gui_inst.gui.drawarea).item.window, gui_inst.gui.text_gc, 1, gui_inst.gui.col * gui_inst.gui.char_width + gui_inst.gui.border_offset, ((gui_inst.gui.row * gui_inst.gui.char_height + gui_inst.gui.border_offset) + gui_inst.gui.char_height) - a_h, a_w, a_h)
			end
		end

	gui_mch_update
		local
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				if (g_main_context_pending (create {CE_POINTER [ANY]}.make_shared (default_pointer))).to_boolean then
					if (ui_inst.vim_is_input_buf_full).to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					g_main_context_iteration (create {CE_POINTER [ANY]}.make_shared (default_pointer), 1).do_nothing
				end
			end
			js.reset
		end

	input_timer_cb (a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_timed_out___0: CE_POINTER [INTEGER_32]
		do
			create l_timed_out___0.make

			l_timed_out___0.ce_gets (create {CE_POINTER [INTEGER_32]}.make_cast (a_data))
			l_timed_out___0.item := 1
			Result := 0
		end

	input_timer_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent input_timer_cb)
		end

	gui_mch_wait_for_chars (a_wtime: INTEGER_32): INTEGER_32
		local
			l_focus: INTEGER_32
			l_timer: NATURAL_32
			js: JUMP_STATE
		do
			Current.timed_out := 0
			if a_wtime > 0 then
				l_timer := gtk_timeout_add (a_wtime.to_natural_32, input_timer_cb_address, create {CE_POINTER [ANY]}.make_cast ((timed_out_address)))
			else
				l_timer := (0).to_natural_32
			end
			l_focus := gui_inst.gui.in_focus
			from
			until
				js.loop_left
			loop
				js.reset
				if gui_inst.gui.in_focus /= l_focus then
					if (gui_inst.gui.in_focus).to_boolean then
						gui_mch_start_blink
					else
						gui_mch_stop_blink
					end
					l_focus := gui_inst.gui.in_focus
				end
				netbeans_inst.netbeans_parse_messages
				if not (getchar_inst.input_available).to_boolean then
					g_main_context_iteration (create {CE_POINTER [ANY]}.make_shared (default_pointer), 1).do_nothing
				end
				if (getchar_inst.input_available).to_boolean then
					if l_timer /= {NATURAL_32} 0 then
						if not timed_out.to_boolean then
							gtk_timeout_remove (l_timer)
						end
					end
					Result := 1
					js.return
				end
				if not js.return_called and then (not (a_wtime < 0)) then
					if timed_out.to_boolean then
						js.break
					end
				end
			end
			js.reset
			if not js.return_called then
				gui_mch_update
				Result := 0
			end
		end

	gui_mch_flush
		do
			if ((gui_inst.gui.mainwin).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (gui_inst.gui.mainwin), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 64)) /= {NATURAL_32} 0 then
					gdk_display_sync ((gtk_widget_get_display (gui_inst.gui.mainwin)))
				end
			end
			if ((gui_inst.gui.drawarea).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (((gui_inst.gui.drawarea).item.window).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					gdk_window_process_updates ((gui_inst.gui.drawarea).item.window, 0)
				end
			end
		end

	gui_mch_clear_block (a_row1: INTEGER_32; a_col1: INTEGER_32; a_row2: INTEGER_32; a_col2: INTEGER_32)
		local
			l_color: SD_GDKCOLOR
			js: JUMP_STATE
		do
			create l_color.make

			if (((gui_inst.gui.drawarea).item.window).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				l_color.pixel := (gui_inst.gui.back_pixel).to_natural_32
				gdk_gc_set_foreground (gui_inst.gui.text_gc, (l_color.address))
				gdk_draw_rectangle ((gui_inst.gui.drawarea).item.window, gui_inst.gui.text_gc, 1, a_col1 * gui_inst.gui.char_width + gui_inst.gui.border_offset, a_row1 * gui_inst.gui.char_height + gui_inst.gui.border_offset, ((a_col2 - a_col1) + 1) * gui_inst.gui.char_width + (a_col2.to_integer_32 = globals_inst.Columns - 1).to_integer, ((a_row2 - a_row1) + 1) * gui_inst.gui.char_height)
			end
		end

	gui_mch_clear_all
		do
			if (((gui_inst.gui.drawarea).item.window).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				gdk_window_clear ((gui_inst.gui.drawarea).item.window)
			end
		end

	check_copy_area
		local
			l_event: CE_POINTER [SD_GDKEVENT]
			l_expose_count: INTEGER_32
			js: JUMP_STATE
		do
			create l_event.make

			if gui_inst.gui.visibility /= 1 then
				js.return
			end
			if not js.return_called then
				gui_inst.gui_dont_update_cursor
				from
				until
					js.loop_left
				loop
					js.reset
					l_event.ce_gets (gdk_event_get_graphics_expose ((gui_inst.gui.drawarea).item.window))
					if (l_event.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.break
					end
					if not js.loop_jumped then
						gui_inst.gui_redraw (l_event.item.expose.area.x, l_event.item.expose.area.y, l_event.item.expose.area.width, l_event.item.expose.area.height)
						l_expose_count := l_event.item.expose.count
						gdk_event_free (l_event)
						if not (l_expose_count > 0) then
							js.break
						end
					end
				end
				js.reset
				gui_inst.gui_can_update_cursor
			end
		end

	gui_mch_delete_lines (a_row: INTEGER_32; a_num_lines: INTEGER_32)
		local
			js: JUMP_STATE
		do
			if gui_inst.gui.visibility = 2 then
				js.return
			end
			if not js.return_called then
				gdk_gc_set_foreground (gui_inst.gui.text_gc, gui_inst.gui.fgcolor)
				gdk_gc_set_background (gui_inst.gui.text_gc, gui_inst.gui.bgcolor)
				gdk_draw_drawable ((gui_inst.gui.drawarea).item.window, gui_inst.gui.text_gc, (gui_inst.gui.drawarea).item.window, gui_inst.gui.scroll_region_left * gui_inst.gui.char_width + gui_inst.gui.border_offset, (a_row + a_num_lines) * gui_inst.gui.char_height + gui_inst.gui.border_offset, gui_inst.gui.scroll_region_left * gui_inst.gui.char_width + gui_inst.gui.border_offset, a_row * gui_inst.gui.char_height + gui_inst.gui.border_offset, gui_inst.gui.char_width * ((gui_inst.gui.scroll_region_right - gui_inst.gui.scroll_region_left) + 1) + 1, gui_inst.gui.char_height * (((gui_inst.gui.scroll_region_bot - a_row) - a_num_lines) + 1))
				gui_inst.gui_clear_block ((gui_inst.gui.scroll_region_bot - a_num_lines) + 1, gui_inst.gui.scroll_region_left, gui_inst.gui.scroll_region_bot, gui_inst.gui.scroll_region_right)
				check_copy_area
			end
		end

	gui_mch_insert_lines (a_row: INTEGER_32; a_num_lines: INTEGER_32)
		local
			js: JUMP_STATE
		do
			if gui_inst.gui.visibility = 2 then
				js.return
			end
			if not js.return_called then
				gdk_gc_set_foreground (gui_inst.gui.text_gc, gui_inst.gui.fgcolor)
				gdk_gc_set_background (gui_inst.gui.text_gc, gui_inst.gui.bgcolor)
				gdk_draw_drawable ((gui_inst.gui.drawarea).item.window, gui_inst.gui.text_gc, (gui_inst.gui.drawarea).item.window, gui_inst.gui.scroll_region_left * gui_inst.gui.char_width + gui_inst.gui.border_offset, a_row * gui_inst.gui.char_height + gui_inst.gui.border_offset, gui_inst.gui.scroll_region_left * gui_inst.gui.char_width + gui_inst.gui.border_offset, (a_row + a_num_lines) * gui_inst.gui.char_height + gui_inst.gui.border_offset, gui_inst.gui.char_width * ((gui_inst.gui.scroll_region_right - gui_inst.gui.scroll_region_left) + 1) + 1, gui_inst.gui.char_height * (((gui_inst.gui.scroll_region_bot - a_row) - a_num_lines) + 1))
				gui_inst.gui_clear_block (a_row, gui_inst.gui.scroll_region_left, (a_row + a_num_lines) - 1, gui_inst.gui.scroll_region_right)
				check_copy_area
			end
		end

	clip_mch_request_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		local
			l_target: CE_POINTER [ANY]
			l_i___0: NATURAL_32
			l_start___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_target.make

			l_i___0 := {NATURAL_32} 0
			from
			until
				not (not js.loop_left and then (l_i___0 < ({SD_GTKTARGETENTRY}.sizeof.to_natural_32 * (7).to_natural_32) // {SD_GTKTARGETENTRY}.sizeof.to_natural_32))
			loop
				js.reset
				if not globals_inst.clip_html.to_boolean then
					if selection_targets[l_i___0.to_integer_32].info = {NATURAL_32} 4 then
						js.continue
					end
				end
				if not js.loop_jumped then
					received_selection := 0
					l_target.ce_gets (gdk_atom_intern (selection_targets[l_i___0.to_integer_32].target, 0))
					gtk_selection_convert (gui_inst.gui.drawarea, a_cbd.item.gtk_sel_atom, l_target, (0).to_natural_32).do_nothing
					l_start___1 := time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
					from
					until
						js.loop_left
					loop
						js.reset
						if received_selection = 0 then
							if not ((time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))) < l_start___1 + 3) then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							g_main_context_iteration (create {CE_POINTER [ANY]}.make_shared (default_pointer), 1).do_nothing
						end
					end
					js.reset
					if received_selection /= 2 then
						js.return
					end
				end
				if not js.loop_left then
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				ui_inst.yank_cut_buffer0 ((gdk_x11_drawable_get_xdisplay ((gdk_x11_window_get_drawable_impl ((gui_inst.gui.mainwin).item.window)))), a_cbd)
			end
		end

	clip_mch_lose_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		do
		end

	clip_mch_own_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD]): INTEGER_32
		local
			l_success___0: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_success___0 := gtk_selection_owner_set (gui_inst.gui.drawarea, a_cbd.item.gtk_sel_atom, clipboard_event_time)
			gui_mch_update
			if l_success___0.to_boolean then
				l_tmp := 1
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	clip_mch_set_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		do
		end

	gui_mch_menu_grey (a_menu___1: CE_POINTER [PD_VIMMENU]; a_grey: INTEGER_32)
		local
			l_grey: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			l_grey := a_grey
			if ((a_menu___1.item.id).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				if (menu_inst.menu_is_separator (a_menu___1.item.name)).to_boolean then
					l_grey := 1
				end
				gui_mch_menu_hidden (a_menu___1, 0)
				if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_menu___1.item.id), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 512)) /= {NATURAL_32} 0 then
					l_tmp___2 := 0
				else
					l_tmp___2 := 1
				end
				if l_tmp___2.to_boolean = not l_grey.to_boolean then
					gtk_widget_set_sensitive (a_menu___1.item.id, (not l_grey.to_boolean).to_integer)
					gui_mch_update
				end
			end
		end

	gui_mch_menu_hidden (a_menu___1: CE_POINTER [PD_VIMMENU]; a_hidden: INTEGER_32)
		local
			js: JUMP_STATE
		do
			if ((a_menu___1.item.id).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				if a_hidden.to_boolean then
					if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_menu___1.item.id), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 256)) /= {NATURAL_32} 0 then
						gtk_widget_hide (a_menu___1.item.id)
						gui_mch_update
					end
				elseif (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_menu___1.item.id), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 256)) = {NATURAL_32} 0 then
					gtk_widget_show (a_menu___1.item.id)
					gui_mch_update
				end
			end
		end

	gui_mch_draw_menubar
		do
			gui_mch_update
		end

	gui_mch_enable_scrollbar (a_sb: CE_POINTER [PD_GUISCROLLBAR]; a_flag: INTEGER_32)
		local
			js: JUMP_STATE
		do
			if ((a_sb.item.id).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				if a_flag.to_boolean then
					gtk_widget_show (a_sb.item.id)
				else
					gtk_widget_hide (a_sb.item.id)
				end
				update_window_manager_hints (0, 0)
			end
		end

	gui_mch_get_rgb (a_pixel: INTEGER_32): NATURAL_32
		local
			l_color: SD_GDKCOLOR
		do
			create l_color.make

			gdk_colormap_query_color ((gtk_widget_get_colormap (gui_inst.gui.drawarea)), a_pixel.to_natural_32, l_color.address)
			Result := (((((((((l_color.red).to_natural_32).bit_and ({NATURAL_32} 65280))).bit_shift_left (8))).bit_or ((((l_color.green).to_natural_32).bit_and ({NATURAL_32} 65280))))).bit_or ((((((l_color.blue).to_natural_32).bit_and ({NATURAL_32} 65280))).bit_shift_right (8)))).to_natural_32
		end

	gui_mch_getmouse (a_x___0: CE_POINTER [INTEGER_32]; a_y: CE_POINTER [INTEGER_32])
		do
			gdk_window_get_pointer ((gui_inst.gui.drawarea).item.window, a_x___0, a_y, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)).do_nothing
		end

	gui_mch_setmouse (a_x___0: INTEGER_32; a_y: INTEGER_32)
		local
			l_tmp: NATURAL_32
		do
			l_tmp := gdk_x11_drawable_get_xid ((gui_inst.gui.drawarea).item.window)
			XWarpPointer ((gdk_x11_drawable_get_xdisplay ((gdk_x11_window_get_drawable_impl ((gui_inst.gui.drawarea).item.window)))), (0).to_natural_32, l_tmp, 0, 0, {NATURAL_32} 0, {NATURAL_32} 0, a_x___0, a_y).do_nothing
		end

	gui_mch_mousehide (a_hide: INTEGER_32)
		do
			if gui_inst.gui.pointer_hidden /= a_hide then
				gui_inst.gui.pointer_hidden := a_hide
				if (((gui_inst.gui.drawarea).item.window).c_pointer /= default_pointer) then
					if ((gui_inst.gui.blank_pointer).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						if a_hide.to_boolean then
							gdk_window_set_cursor ((gui_inst.gui.drawarea).item.window, gui_inst.gui.blank_pointer)
						else
							mch_set_mouse_shape (last_shape)
						end
					end
				end
			end
		end

	mch_set_mouse_shape (a_shape: INTEGER_32)
		local
			l_id: INTEGER_32
			l_c: CE_POINTER [SD_GDKCURSOR]
			js: JUMP_STATE
		do
			create l_c.make

			if (((gui_inst.gui.drawarea).item.window).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				if a_shape = 1 then
					gdk_window_set_cursor ((gui_inst.gui.drawarea).item.window, gui_inst.gui.blank_pointer)
				elseif (gui_inst.gui.pointer_hidden).to_boolean then
					gdk_window_set_cursor ((gui_inst.gui.drawarea).item.window, gui_inst.gui.blank_pointer)
				else
					if a_shape >= 1000 then
						l_id := a_shape - 1000
						if l_id >= 153 then
							l_id := 68
						else
							l_id := (l_id).bit_and ((-2))
						end
					elseif a_shape < ((Integer_32_bytes.to_natural_32 * (17).to_natural_32) // Integer_32_bytes.to_natural_32).to_integer_32 then
						l_id := mshape_ids[a_shape]
					else
						js.return
					end
					if not js.return_called then
						l_c.ce_gets (gdk_cursor_new_for_display ((gtk_widget_get_display (gui_inst.gui.drawarea)), l_id))
						gdk_window_set_cursor ((gui_inst.gui.drawarea).item.window, l_c)
						gdk_cursor_unref (l_c)
					end
				end
			end
			if not js.return_called and then (a_shape /= 1) then
				last_shape := a_shape
			end
		end

	gui_mch_drawsign (a_row: INTEGER_32; a_col: INTEGER_32; a_typenr: INTEGER_32)
		local
			l_sign: CE_POINTER [ANY]
			l_width: INTEGER_32
			l_height: INTEGER_32
			l_xoffset: INTEGER_32
			l_yoffset: INTEGER_32
			l_need_scale: INTEGER_32
			l_tmp___0: INTEGER_32
			l_aspect: REAL_64
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			js: JUMP_STATE
		do
			create l_sign.make

			l_sign.ce_gets ((ex_cmds_inst.sign_get_image (a_typenr)))
			if (l_sign.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if ((gui_inst.gui.drawarea).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if (((gui_inst.gui.drawarea).item.window).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_width := gdk_pixbuf_get_width (l_sign)
						l_height := gdk_pixbuf_get_height (l_sign)
						if l_width > 2 * gui_inst.gui.char_width + 2 then
							l_tmp___0 := 1
						elseif l_height > gui_inst.gui.char_height + 2 then
							l_tmp___0 := 1
						elseif l_width < (3 * (2 * gui_inst.gui.char_width)) // 4 then
							if l_height < (3 * gui_inst.gui.char_height) // 4 then
								l_tmp___0 := 1
							else
								l_tmp___0 := 0
							end
						else
							l_tmp___0 := 0
						end
						l_need_scale := l_tmp___0
						if l_need_scale.to_boolean then
							l_aspect := l_height.to_double / l_width.to_double
							l_width := (((2 * gui_inst.gui.char_width).to_double * ((gui_inst.gui.char_height).to_double / (2 * gui_inst.gui.char_width).to_double)) / l_aspect).truncated_to_integer
							if l_width < 2 * gui_inst.gui.char_width then
								l_width := l_width
							else
								l_width := 2 * gui_inst.gui.char_width
							end
							l_height := (l_width.to_double * l_aspect).truncated_to_integer
							l_sign.ce_gets (gdk_pixbuf_scale_simple (l_sign, l_width, l_height, {SC_GDKINTERPTYPE}.GDK_INTERP_BILINEAR))
							if (l_sign.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.return
							end
						end
						if not js.return_called then
							l_xoffset := (l_width - 2 * gui_inst.gui.char_width) // 2
							l_yoffset := (l_height - gui_inst.gui.char_height) // 2
							gdk_gc_set_foreground (gui_inst.gui.text_gc, gui_inst.gui.bgcolor)
							gdk_draw_rectangle ((gui_inst.gui.drawarea).item.window, gui_inst.gui.text_gc, 1, a_col * gui_inst.gui.char_width + gui_inst.gui.border_offset, a_row * gui_inst.gui.char_height + gui_inst.gui.border_offset, 2 * gui_inst.gui.char_width, gui_inst.gui.char_height)
							if l_height < gui_inst.gui.char_height then
								l_tmp___1 := l_height
							else
								l_tmp___1 := gui_inst.gui.char_height
							end
							if l_width < 2 * gui_inst.gui.char_width then
								l_tmp___2 := l_width
							else
								l_tmp___2 := 2 * gui_inst.gui.char_width
							end
							if 0 < l_yoffset then
								l_tmp___3 := 0
							else
								l_tmp___3 := l_yoffset
							end
							if 0 < l_xoffset then
								l_tmp___4 := 0
							else
								l_tmp___4 := l_xoffset
							end
							if 0 > l_yoffset then
								l_tmp___5 := 0
							else
								l_tmp___5 := l_yoffset
							end
							if 0 > l_xoffset then
								l_tmp___6 := 0
							else
								l_tmp___6 := l_xoffset
							end
							gdk_pixbuf_render_to_drawable_alpha (l_sign, (gui_inst.gui.drawarea).item.window, l_tmp___6, l_tmp___5, (a_col * gui_inst.gui.char_width + gui_inst.gui.border_offset) - l_tmp___4, (a_row * gui_inst.gui.char_height + gui_inst.gui.border_offset) - l_tmp___3, l_tmp___2, l_tmp___1, {SC_GDKPIXBUFALPHAMODE}.GDK_PIXBUF_ALPHA_BILEVEL, 127, {SC_GDKRGBDITHER}.GDK_RGB_DITHER_NORMAL, 0, 0)
							if l_need_scale.to_boolean then
								g_object_unref (l_sign)
							end
						end
					end
				end
			end
			if not js.return_called then
			end
		end

	gui_mch_register_sign (a_signfile: CE_POINTER [NATURAL_8]): CE_POINTER [ANY]
		local
			l_sign: CE_POINTER [ANY]
			l_error: CE_POINTER [SD_GERROR]
			l_message: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_sign.make
			create l_error.make
			create l_message.make

			if (a_signfile[0]).to_integer_32 /= 0 then
				if (a_signfile[0]).to_integer_32 /= 45 then
					if (gui_inst.gui.in_use).to_boolean then
						l_error.ce_gets (create {CE_POINTER [SD_GERROR]}.make_shared (default_pointer))
						l_sign.ce_gets (gdk_pixbuf_new_from_file (create {CE_POINTER [INTEGER_8]}.make_cast (a_signfile), l_error.address))
						if (l_error.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							Result := l_sign
							js.return
						end
						if not js.return_called then
							l_message.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (l_error.item.message))
							if (l_message.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if globals_inst.input_conv.vc_type /= 0 then
									l_message.ce_gets (mbyte_inst.string_convert (globals_inst.input_conv.address, l_message, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
								end
							end
							if (l_message.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E255: %%s")), l_message).do_nothing
								if globals_inst.input_conv.vc_type /= 0 then
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_message))
								end
							end
							g_error_free (l_error)
						end
					end
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
			end
		end

	gui_mch_destroy_sign (a_sign: CE_POINTER [ANY])
		do
			if (a_sign.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				g_object_unref (a_sign)
			end
		end

end
