class
	P_MBYTE

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create utf8len_tab.make (<<256>>)
			create utf8len_tab_zero.make (<<256>>)
			create enc_canon_table.make (<<60>>)
			create enc_alias_table.make (<<61>>)
			create doublewidth.make (<<38>>)
			create ambiguous.make (<<181>>)
			create combining.make (<<188>>)
			create nonprint.make (<<9>>)
			create classes.make (<<62>>)
			create foldCase.make (<<156>>)
			create toLower2.make (<<144>>)
			create toUpper2.make (<<150>>)
			create buf___1.make (<<22>>)
		end

feature {ANY} -- attributes

	utf8len_tab: CE_ARRAY [INTEGER_8]

	utf8len_tab_zero: CE_ARRAY [INTEGER_8]

	enc_canon_table: CE_ARRAY [PD_ENC_CANON_TABLE]

	enc_alias_table: CE_ARRAY [PD_ENC_ALIAS_TABLE]

	doublewidth: CE_ARRAY [PD_INTERVAL]

	ambiguous: CE_ARRAY [PD_INTERVAL]

	combining: CE_ARRAY [PD_INTERVAL]

	nonprint: CE_ARRAY [PD_INTERVAL]

	classes: CE_ARRAY [PD_CLINTERVAL]

	foldCase: CE_ARRAY [PD_CONVERTSTRUCT]

	toLower2: CE_ARRAY [PD_CONVERTSTRUCT]

	toUpper2: CE_ARRAY [PD_CONVERTSTRUCT]

	buf___1: CE_ARRAY [NATURAL_8]

	iconv_ok: INTEGER_32 assign set_iconv_ok

	set_iconv_ok (a_iconv_ok: INTEGER_32)
		do
			iconv_ok := a_iconv_ok
		end

	xim_has_preediting: INTEGER_32 assign set_xim_has_preediting

	set_xim_has_preediting (a_xim_has_preediting: INTEGER_32)
		do
			xim_has_preediting := a_xim_has_preediting
		end

	im_is_active: INTEGER_32 assign set_im_is_active

	set_im_is_active (a_im_is_active: INTEGER_32)
		do
			im_is_active := a_im_is_active
		end

	preedit_is_active: INTEGER_32 assign set_preedit_is_active

	set_preedit_is_active (a_preedit_is_active: INTEGER_32)
		do
			preedit_is_active := a_preedit_is_active
		end

	im_preedit_cursor: INTEGER_32 assign set_im_preedit_cursor

	set_im_preedit_cursor (a_im_preedit_cursor: INTEGER_32)
		do
			im_preedit_cursor := a_im_preedit_cursor
		end

	im_preedit_trailing: INTEGER_32 assign set_im_preedit_trailing

	set_im_preedit_trailing (a_im_preedit_trailing: INTEGER_32)
		do
			im_preedit_trailing := a_im_preedit_trailing
		end

	im_commit_handler_id: NATURAL_32 assign set_im_commit_handler_id

	set_im_commit_handler_id (a_im_commit_handler_id: NATURAL_32)
		do
			im_commit_handler_id := a_im_commit_handler_id
		end

	im_activatekey_keyval: NATURAL_32 assign set_im_activatekey_keyval
		do
			Result := im_activatekey_keyval_address[0]
		end

	set_im_activatekey_keyval (a_im_activatekey_keyval: NATURAL_32)
		do
			im_activatekey_keyval_address[0] := a_im_activatekey_keyval
		end

	im_activatekey_keyval_address: CE_POINTER [NATURAL_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Natural_32_bytes))
		end

	im_activatekey_state: NATURAL_32 assign set_im_activatekey_state
		do
			Result := im_activatekey_state_address[0]
		end

	set_im_activatekey_state (a_im_activatekey_state: NATURAL_32)
		do
			im_activatekey_state_address[0] := a_im_activatekey_state
		end

	im_activatekey_state_address: CE_POINTER [NATURAL_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Natural_32_bytes))
		end

	xim_expected_char: INTEGER_32 assign set_xim_expected_char

	set_xim_expected_char (a_xim_expected_char: INTEGER_32)
		do
			xim_expected_char := a_xim_expected_char
		end

	xim_ignored_char: INTEGER_32 assign set_xim_ignored_char

	set_xim_ignored_char (a_xim_ignored_char: INTEGER_32)
		do
			xim_ignored_char := a_xim_ignored_char
		end

feature {ANY} -- routines

	enc_canon_search (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (l_i___0 < 60))
			loop
				if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), enc_canon_table[l_i___0].name)) = 0 then
					Result := l_i___0
					js.return
				end
				if not js.return_called then
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	enc_canon_props (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := enc_canon_search (a_name___1)
			if l_i___0 >= 0 then
				Result := (enc_canon_table[l_i___0].prop)
				js.return
			end
			if not js.return_called then
				if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("2byte-"), (6).to_natural_32)) = 0 then
					Result := 2
					js.return
				end
			end
			if not js.return_called then
				if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("8bit-"), (5).to_natural_32)) = 0 then
					Result := 1
					js.return
				elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("iso-8859-"), (9).to_natural_32)) = 0 then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	mb_init: CE_POINTER [NATURAL_8]
		local
			l_i___0: INTEGER_32
			l_idx: INTEGER_32
			l_n: INTEGER_32
			l_enc_dbcs_new: INTEGER_32
			l_vimconv: PD_VIMCONV_T
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
			l_tmp___5: INTEGER_32
			l_buf___6: CE_ARRAY [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_vimconv.make
			create l_p___0.make
			create l_buf___6.make (<<21>>)
			create l_tmp___9.make

			l_enc_dbcs_new := 0
			if (option_inst.p_enc.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_i___0 := 0
				from
				until
					not (l_i___0 < 256)
				loop
					globals_inst.mb_bytelen_tab[l_i___0] := (1).to_integer_8
					l_i___0 := l_i___0 + 1
				end
				globals_inst.input_conv.vc_type := 0
				globals_inst.input_conv.vc_factor := 1
				globals_inst.output_conv.vc_type := 0
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_enc), ce_string ("8bit-"), (5).to_natural_32)) = 0 then
				globals_inst.enc_unicode := 0
				globals_inst.enc_utf8 := 0
			elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_enc), ce_string ("iso-8859-"), (9).to_natural_32)) = 0 then
				globals_inst.enc_unicode := 0
				globals_inst.enc_utf8 := 0
			elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_enc), ce_string ("2byte-"), (6).to_natural_32)) = 0 then
				l_enc_dbcs_new := 1
			else
				l_idx := enc_canon_search (option_inst.p_enc)
				if l_idx >= 0 then
					l_i___0 := enc_canon_table[l_idx].prop
					if ((l_i___0).bit_and (4)).to_boolean then
						globals_inst.enc_utf8 := 1
						if ((l_i___0).bit_and (320)).to_boolean then
							globals_inst.enc_unicode := 2
						elseif ((l_i___0).bit_and (128)).to_boolean then
							globals_inst.enc_unicode := 4
						else
							globals_inst.enc_unicode := 0
						end
					elseif ((l_i___0).bit_and (2)).to_boolean then
						l_enc_dbcs_new := enc_canon_table[l_idx].codepage
					else
						globals_inst.enc_unicode := 0
						globals_inst.enc_utf8 := 0
					end
				else
					Result := globals_inst.e_invarg
					js.return
				end
			end
			if not js.return_called then
				if l_enc_dbcs_new /= 0 then
					globals_inst.enc_unicode := 0
					globals_inst.enc_utf8 := 0
				end
				globals_inst.enc_dbcs := l_enc_dbcs_new
				if globals_inst.enc_dbcs /= 0 then
					l_tmp___2 := 1
				elseif globals_inst.enc_utf8.to_boolean then
					l_tmp___2 := 1
				else
					l_tmp___2 := 0
				end
				globals_inst.has_mbyte := l_tmp___2
				if globals_inst.enc_utf8.to_boolean then
					l_tmp___5 := 1
				elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_enc), ce_string ("latin1"))) = 0 then
					l_tmp___5 := 1
				elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_enc), ce_string ("iso-8859-15"))) = 0 then
					l_tmp___5 := 1
				else
					l_tmp___5 := 0
				end
				globals_inst.enc_latin1like := l_tmp___5
				if globals_inst.enc_utf8.to_boolean then
					globals_inst.mb_ptr2len.ce_gets (utfc_ptr2len_address)
					globals_inst.mb_ptr2len_len.ce_gets (utfc_ptr2len_len_address)
					globals_inst.mb_char2len.ce_gets (utf_char2len_address)
					globals_inst.mb_char2bytes.ce_gets (utf_char2bytes_address)
					globals_inst.mb_ptr2cells.ce_gets (utf_ptr2cells_address)
					globals_inst.mb_ptr2cells_len.ce_gets (utf_ptr2cells_len_address)
					globals_inst.mb_char2cells.ce_gets (utf_char2cells_address)
					globals_inst.mb_off2cells.ce_gets (utf_off2cells_address)
					globals_inst.mb_ptr2char.ce_gets (utf_ptr2char_address)
					globals_inst.mb_head_off.ce_gets (utf_head_off_address)
				elseif globals_inst.enc_dbcs /= 0 then
					globals_inst.mb_ptr2len.ce_gets (dbcs_ptr2len_address)
					globals_inst.mb_ptr2len_len.ce_gets (dbcs_ptr2len_len_address)
					globals_inst.mb_char2len.ce_gets (dbcs_char2len_address)
					globals_inst.mb_char2bytes.ce_gets (dbcs_char2bytes_address)
					globals_inst.mb_ptr2cells.ce_gets (dbcs_ptr2cells_address)
					globals_inst.mb_ptr2cells_len.ce_gets (dbcs_ptr2cells_len_address)
					globals_inst.mb_char2cells.ce_gets (dbcs_char2cells_address)
					globals_inst.mb_off2cells.ce_gets (dbcs_off2cells_address)
					globals_inst.mb_ptr2char.ce_gets (dbcs_ptr2char_address)
					globals_inst.mb_head_off.ce_gets (dbcs_head_off_address)
				else
					globals_inst.mb_ptr2len.ce_gets (latin_ptr2len_address)
					globals_inst.mb_ptr2len_len.ce_gets (latin_ptr2len_len_address)
					globals_inst.mb_char2len.ce_gets (latin_char2len_address)
					globals_inst.mb_char2bytes.ce_gets (latin_char2bytes_address)
					globals_inst.mb_ptr2cells.ce_gets (latin_ptr2cells_address)
					globals_inst.mb_ptr2cells_len.ce_gets (latin_ptr2cells_len_address)
					globals_inst.mb_char2cells.ce_gets (latin_char2cells_address)
					globals_inst.mb_off2cells.ce_gets (latin_off2cells_address)
					globals_inst.mb_ptr2char.ce_gets (latin_ptr2char_address)
					globals_inst.mb_head_off.ce_gets (latin_head_off_address)
				end
				l_vimconv.vc_type := 0
				if globals_inst.enc_dbcs.to_boolean then
					l_p___0.ce_gets (enc_locale)
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						convert_setup (l_vimconv.address, option_inst.p_enc, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("utf-8"))).do_nothing
						l_vimconv.vc_fail := 1
					elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_enc))) /= 0 then
						convert_setup (l_vimconv.address, option_inst.p_enc, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("utf-8"))).do_nothing
						l_vimconv.vc_fail := 1
					end
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
				end
				l_i___0 := 0
				from
				until
					not (l_i___0 < 256)
				loop
					if globals_inst.enc_utf8.to_boolean then
						l_n := (utf8len_tab[l_i___0]).to_integer_32
					elseif globals_inst.enc_dbcs = 0 then
						l_n := 1
					elseif l_i___0 = 0 then
						l_n := 1
					else
						l_buf___6[0] := l_i___0.to_integer_8
						l_buf___6[1] := (0).to_integer_8
						if l_vimconv.vc_type /= 0 then
							l_p___0.ce_gets (string_convert (l_vimconv.address, create {CE_POINTER [NATURAL_8]}.make_cast (l_buf___6), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
								l_n := 1
							else
								l_n := 2
							end
						else
							globals_inst.ignored := mblen (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), (0).to_natural_32)
							if (mblen (l_buf___6, (1).to_natural_32)) <= 0 then
								l_n := 2
							else
								l_n := 1
							end
						end
					end
					globals_inst.mb_bytelen_tab[l_i___0] := l_n.to_integer_8
					l_i___0 := l_i___0 + 1
				end
				convert_setup (l_vimconv.address, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
				charset_inst.init_chartab.do_nothing
				screen_inst.screenalloc (0)
				if globals_inst.enc_utf8.to_boolean then
					if not (option_inst.option_was_set (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("fencs")))).to_boolean then
						option_inst.set_string_option_direct (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("fencs")), -1, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ucs-bom,utf-8,default,latin1")), 1, 0)
					end
				end
				if globals_inst.enc_utf8.to_boolean then
					l_tmp___9.ce_gets (ce_string ("utf-8"))
				else
					l_tmp___9.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_enc))
				end
				bind_textdomain_codeset (ce_string ("vim"), l_tmp___9).do_nothing
				fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_ENCODINGCHANGED, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 0, globals_inst.curbuf).do_nothing
				spell_inst.spell_reload
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	bomb_size: INTEGER_32
		local
			l_n: INTEGER_32
		do
			l_n := 0
			if (globals_inst.curbuf.item.b_p_bomb).to_boolean then
				if not (globals_inst.curbuf.item.b_p_bin).to_boolean then
					if ((globals_inst.curbuf.item.b_p_fenc).item).to_integer_32 = 0 then
						if globals_inst.enc_utf8.to_boolean then
							if globals_inst.enc_unicode /= 0 then
								l_n := globals_inst.enc_unicode
							else
								l_n := 3
							end
						end
					elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.curbuf.item.b_p_fenc), ce_string ("utf-8"))) = 0 then
						l_n := 3
					elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.curbuf.item.b_p_fenc), ce_string ("ucs-2"), (5).to_natural_32)) = 0 then
						l_n := 2
					elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.curbuf.item.b_p_fenc), ce_string ("utf-16"), (6).to_natural_32)) = 0 then
						l_n := 2
					elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.curbuf.item.b_p_fenc), ce_string ("ucs-4"), (5).to_natural_32)) = 0 then
						l_n := 4
					end
				end
			end
			Result := l_n
		end

	mb_get_class (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (globals_inst.mb_bytelen_tab[(a_p___0[0]).to_integer_32]).to_integer_32 = 1 then
				if (a_p___0[0]).to_integer_32 = 0 then
					Result := 0
					js.return
				elseif (a_p___0[0]).to_integer_32 = 32 then
					Result := 0
					js.return
				elseif (a_p___0[0]).to_integer_32 = 9 then
					Result := 0
					js.return
				end
				if not js.return_called then
					if (charset_inst.vim_iswordc ((a_p___0[0]).to_integer_32)).to_boolean then
						Result := 2
						js.return
					end
				end
				if not js.return_called then
					Result := 1
					js.return
				end
			end
			if not js.return_called and then (globals_inst.enc_dbcs /= 0) then
				if (a_p___0[0]).to_integer_32 /= 0 then
					if (a_p___0[1]).to_integer_32 /= 0 then
						Result := (dbcs_class ((a_p___0[0]).to_natural_32, (a_p___0[1]).to_natural_32))
						js.return
					end
				end
			end
			if not js.return_called and then (globals_inst.enc_utf8.to_boolean) then
				Result := (utf_class ((utf_ptr2char (a_p___0))))
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	dbcs_class (a_lead: NATURAL_32; a_trail: NATURAL_32): INTEGER_32
		local
			l_lb: NATURAL_8
			l_tb: NATURAL_8
			l_c1: NATURAL_8
			l_c2: NATURAL_8
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect globals_inst.enc_dbcs -- switch 1 head
					when 9932 then l_pos := -1 + 1
					when 932 then l_pos := -1 + 1
					when 9949 then l_pos := -1 + 15
					when 949 then l_pos := -1 + 15
					else l_pos := -1 + 32
					end
				when 1 then -- switch 1, case 9932 | switch 1, case 932
					l_lb := a_lead.to_natural_8
					l_tb := a_trail.to_natural_8
					l_lb := ((l_lb.to_integer_32).bit_and (127)).to_natural_8
					l_tb := ((l_tb.to_integer_32).bit_and (127)).to_natural_8
					inspect (((l_lb.to_integer_32).bit_shift_left (8))).bit_or (l_tb.to_integer_32) -- switch 2 head
					when 8481 then l_pos := -1 + 2
					when 8482 then l_pos := -1 + 3
					when 8483 then l_pos := -1 + 3
					when 8484 then l_pos := -1 + 3
					when 8485 then l_pos := -1 + 3
					when 8508 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 2 then -- switch 2, case 8481
					Result := 0
					js.return
				when 3 then -- switch 2, case 8482 | switch 2, case 8483 | switch 2, case 8484 | switch 2, case 8485
					if not js.return_called then
						Result := 1
						js.return
					end
				when 4 then -- switch 2, case 8508
					if not js.return_called then
						Result := 13
						js.return
					end
				when 5 then -- switch 2, done:
					if js.return_called then
						l_pos := -1 + 15 -- skip if block
					end
				when 6 then -- if:
						inspect l_lb.to_integer_32 -- switch 3 head
						when 33 then l_pos := -1 + 7
						when 34 then l_pos := -1 + 7
						when 35 then l_pos := -1 + 8
						when 36 then l_pos := -1 + 9
						when 37 then l_pos := -1 + 10
						when 38 then l_pos := -1 + 11
						when 39 then l_pos := -1 + 12
						when 40 then l_pos := -1 + 13
						else l_pos := -1 + 14
						end
				when 7 then -- switch 3, case 33 | switch 3, case 34
						Result := 10
						js.return
				when 8 then -- switch 3, case 35
						if not js.return_called then
							Result := 11
							js.return
						end
				when 9 then -- switch 3, case 36
						if not js.return_called then
							Result := 12
							js.return
						end
				when 10 then -- switch 3, case 37
						if not js.return_called then
							Result := 13
							js.return
						end
				when 11 then -- switch 3, case 38
						if not js.return_called then
							Result := 14
							js.return
						end
				when 12 then -- switch 3, case 39
						if not js.return_called then
							Result := 15
							js.return
						end
				when 13 then -- switch 3, case 40
						if not js.return_called then
							Result := 16
							js.return
						end
				when 14 then -- switch 3, default:
						if not js.return_called then
							Result := 17
							js.return
						end
				when 15 then -- switch 3, done: | switch 1, case 9949 | switch 1, case 949
						if js.return_called then
							l_pos := -1 + 32 -- skip if block
						end
				when 16 then -- if:
							l_c1 := a_lead.to_natural_8
							l_c2 := a_trail.to_natural_8
							if not (l_c1.to_integer_32 >= 176) then
								l_pos := -1 + 19 -- skip if block
							end
				when 17 then -- if:
							if l_c1.to_integer_32 <= 200 then
								Result := 20
								js.return
							else
								l_pos := -1 + 19 -- goto _L___0
							end
				when 18 then -- if block done, skip else block:
							l_pos := -1 + 32
				when 19 then -- else: | _L___0:
							if not (l_c1.to_integer_32 >= 202) then
								l_pos := -1 + 22 -- skip if block
							end
				when 20 then -- if:
							if l_c1.to_integer_32 <= 253 then
								Result := 21
								js.return
							else
								l_pos := -1 + 22 -- goto _L
							end
				when 21 then -- if block done, skip else block:
							l_pos := -1 + 32
				when 22 then -- else: | _L:
							inspect l_c1.to_integer_32 -- switch 4 head
							when 161 then l_pos := -1 + 23
							when 162 then l_pos := -1 + 23
							when 163 then l_pos := -1 + 24
							when 164 then l_pos := -1 + 25
							when 165 then l_pos := -1 + 26
							when 166 then l_pos := -1 + 27
							when 167 then l_pos := -1 + 28
							when 168 then l_pos := -1 + 29
							when 169 then l_pos := -1 + 29
							when 170 then l_pos := -1 + 30
							when 171 then l_pos := -1 + 30
							when 172 then l_pos := -1 + 31
							else l_pos := -1 + 32
							end
				when 23 then -- switch 4, case 161 | switch 4, case 162
							Result := 22
							js.return
				when 24 then -- switch 4, case 163
							if not js.return_called then
								Result := 23
								js.return
							end
				when 25 then -- switch 4, case 164
							if not js.return_called then
								Result := 24
								js.return
							end
				when 26 then -- switch 4, case 165
							if not js.return_called then
								Result := 25
								js.return
							end
				when 27 then -- switch 4, case 166
							if not js.return_called then
								Result := 26
								js.return
							end
				when 28 then -- switch 4, case 167
							if not js.return_called then
								Result := 27
								js.return
							end
				when 29 then -- switch 4, case 168 | switch 4, case 169
							if not js.return_called then
								if l_c2.to_integer_32 <= 175 then
									Result := 25
									js.return
								elseif l_c2.to_integer_32 >= 246 then
									Result := 22
									js.return
								else
									Result := 28
									js.return
								end
							end
				when 30 then -- switch 4, case 170 | switch 4, case 171
							if not js.return_called then
								Result := 29
								js.return
							end
				when 31 then -- switch 4, case 172
							if not js.return_called then
								Result := 30
								js.return
							end
				when 32 then -- switch 4, done: | if done | if done | switch 1, default:
							l_pos := -1 + 33 -- switch 1; break
				when 33 then -- switch 1, done:
							if not js.return_called then
								Result := 3
							end
				when 34 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	latin_char2len (a_c: INTEGER_32): INTEGER_32
		do
			Result := 1
		end

	latin_char2len_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent latin_char2len)
		end

	dbcs_char2len (a_c: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_c >= 256 then
				Result := 2
				js.return
			end
			if not js.return_called then
				Result := 1
			end
		end

	dbcs_char2len_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dbcs_char2len)
		end

	latin_char2bytes (a_c: INTEGER_32; a_buf___6: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			a_buf___6[0] := a_c.to_natural_8
			Result := 1
		end

	latin_char2bytes_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent latin_char2bytes)
		end

	dbcs_char2bytes (a_c: INTEGER_32; a_buf___6: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_c >= 256 then
				a_buf___6[0] := ((a_c.to_natural_32).bit_shift_right (8)).to_natural_8
				a_buf___6[1] := a_c.to_natural_8
				if (a_buf___6[1]).to_integer_32 = 0 then
					a_buf___6[1] := (('%N').code).to_natural_8
				end
				Result := 2
				js.return
			end
			if not js.return_called then
				a_buf___6[0] := a_c.to_natural_8
				Result := 1
			end
		end

	dbcs_char2bytes_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dbcs_char2bytes)
		end

	latin_ptr2len (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := (globals_inst.mb_bytelen_tab[(a_p___0.item).to_integer_32]).to_integer_32
		end

	latin_ptr2len_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent latin_ptr2len)
		end

	dbcs_ptr2len (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_len: INTEGER_32
		do
			l_len := (globals_inst.mb_bytelen_tab[(a_p___0.item).to_integer_32]).to_integer_32
			if l_len = 2 then
				if (a_p___0[1]).to_integer_32 = 0 then
					l_len := 1
				end
			end
			Result := l_len
		end

	dbcs_ptr2len_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dbcs_ptr2len)
		end

	latin_ptr2len_len (a_p___0: CE_POINTER [NATURAL_8]; a_size: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_size < 1 then
				Result := 0
				js.return
			elseif (a_p___0.item).to_integer_32 = 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 1
			end
		end

	latin_ptr2len_len_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent latin_ptr2len_len)
		end

	dbcs_ptr2len_len (a_p___0: CE_POINTER [NATURAL_8]; a_size: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			if a_size < 1 then
				Result := 0
				js.return
			elseif (a_p___0.item).to_integer_32 = 0 then
				Result := 0
				js.return
			end
			if not js.return_called and then (a_size = 1) then
				Result := 1
				js.return
			end
			if not js.return_called then
				l_len := (globals_inst.mb_bytelen_tab[(a_p___0.item).to_integer_32]).to_integer_32
				if l_len = 2 then
					if (a_p___0[1]).to_integer_32 = 0 then
						l_len := 1
					end
				end
				Result := l_len
			end
		end

	dbcs_ptr2len_len_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dbcs_ptr2len_len)
		end

	intable (a_table: CE_POINTER [PD_INTERVAL]; a_size: NATURAL_32; a_c: INTEGER_32): INTEGER_32
		local
			l_mid: INTEGER_32
			l_bot: INTEGER_32
			l_top: INTEGER_32
			js: JUMP_STATE
		do
			if a_c.to_integer_32 < (a_table + 0).item.first then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_bot := 0
				l_top := (a_size // {PD_INTERVAL}.sizeof.to_natural_32 - {NATURAL_32} 1).to_integer_32
				from
				until
					not (not js.loop_left and then (l_top >= l_bot))
				loop
					l_mid := (l_bot + l_top) // 2
					if (a_table + l_mid).item.last < a_c.to_integer_32 then
						l_bot := l_mid + 1
					elseif (a_table + l_mid).item.first > a_c.to_integer_32 then
						l_top := l_mid - 1
					else
						Result := 1
						js.return
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	utf_char2cells (a_c: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_c >= 256 then
				if not (utf_printable (a_c)).to_boolean then
					Result := 6
					js.return
				end
				if not js.return_called then
					if (intable (doublewidth, ({PD_INTERVAL}.sizeof.to_natural_32 * (38).to_natural_32), a_c)).to_boolean then
						Result := 2
						js.return
					end
				end
			elseif a_c >= 128 then
				if not (charset_inst.vim_isprintc (a_c)).to_boolean then
					Result := 4
					js.return
				end
			end
			if not js.return_called and then (a_c >= 128) then
				if (option_inst.p_ambw.item).to_integer_32 = 100 then
					if (intable (ambiguous, ({PD_INTERVAL}.sizeof.to_natural_32 * (181).to_natural_32), a_c)).to_boolean then
						Result := 2
						js.return
					end
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	utf_char2cells_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent utf_char2cells)
		end

	latin_ptr2cells (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := 1
		end

	latin_ptr2cells_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent latin_ptr2cells)
		end

	utf_ptr2cells (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_c: INTEGER_32
			js: JUMP_STATE
		do
			if (a_p___0.item).to_integer_32 >= 128 then
				l_c := utf_ptr2char (a_p___0)
				if (utf_ptr2len (a_p___0)) = 1 then
					Result := 4
					js.return
				elseif l_c = 0 then
					Result := 4
					js.return
				end
				if not js.return_called and then (l_c < 128) then
					Result := (charset_inst.char2cells (l_c))
					js.return
				end
				if not js.return_called then
					Result := (utf_char2cells (l_c))
					js.return
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	utf_ptr2cells_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent utf_ptr2cells)
		end

	dbcs_ptr2cells (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if globals_inst.enc_dbcs = 9932 then
				if (a_p___0.item).to_integer_32 = 142 then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				Result := (globals_inst.mb_bytelen_tab[(a_p___0.item).to_integer_32]).to_integer_32
			end
		end

	dbcs_ptr2cells_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dbcs_ptr2cells)
		end

	latin_ptr2cells_len (a_p___0: CE_POINTER [NATURAL_8]; a_size: INTEGER_32): INTEGER_32
		do
			Result := 1
		end

	latin_ptr2cells_len_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent latin_ptr2cells_len)
		end

	utf_ptr2cells_len (a_p___0: CE_POINTER [NATURAL_8]; a_size: INTEGER_32): INTEGER_32
		local
			l_c: INTEGER_32
			js: JUMP_STATE
		do
			if a_size > 0 then
				if (a_p___0.item).to_integer_32 >= 128 then
					if (utf_ptr2len_len (a_p___0, a_size)) < (utf8len_tab[(a_p___0.item).to_integer_32]).to_integer_32 then
						Result := 1
						js.return
					end
					if not js.return_called then
						l_c := utf_ptr2char (a_p___0)
						if (utf_ptr2len (a_p___0)) = 1 then
							Result := 4
							js.return
						elseif l_c = 0 then
							Result := 4
							js.return
						end
					end
					if not js.return_called and then (l_c < 128) then
						Result := (charset_inst.char2cells (l_c))
						js.return
					end
					if not js.return_called then
						Result := (utf_char2cells (l_c))
						js.return
					end
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	utf_ptr2cells_len_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent utf_ptr2cells_len)
		end

	dbcs_ptr2cells_len (a_p___0: CE_POINTER [NATURAL_8]; a_size: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_size <= 1 then
				Result := 1
				js.return
			elseif globals_inst.enc_dbcs = 9932 then
				if (a_p___0.item).to_integer_32 = 142 then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				Result := (globals_inst.mb_bytelen_tab[(a_p___0.item).to_integer_32]).to_integer_32
			end
		end

	dbcs_ptr2cells_len_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dbcs_ptr2cells_len)
		end

	latin_char2cells (a_c: INTEGER_32): INTEGER_32
		do
			Result := 1
		end

	latin_char2cells_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent latin_char2cells)
		end

	dbcs_char2cells (a_c: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if globals_inst.enc_dbcs = 9932 then
				if (a_c.to_natural_32).bit_shift_right (8) = {NATURAL_32} 142 then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				Result := (globals_inst.mb_bytelen_tab[((a_c.to_natural_32).bit_shift_right (8)).to_integer_32]).to_integer_32
			end
		end

	dbcs_char2cells_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dbcs_char2cells)
		end

	mb_string2cells (a_p___0: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_clen: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_clen := 0
					l_i___0 := 0
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if not (a_len < 0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else:
						if not (l_i___0 < a_len) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L:
						if (a_p___0[l_i___0]).to_integer_32 = 0 then
							js.break
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						js.break
				when 9 then -- if done
						if not js.loop_jumped then
							l_clen := l_clen + (globals_inst.mb_ptr2cells.integer_32_item ([a_p___0 + l_i___0]))
							l_i___0 := l_i___0 + (globals_inst.mb_ptr2len.integer_32_item ([a_p___0 + l_i___0]))
						end
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					js.reset
					Result := l_clen
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	latin_off2cells (a_off___0: NATURAL_32; a_max_off: NATURAL_32): INTEGER_32
		do
			Result := 1
		end

	latin_off2cells_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent latin_off2cells)
		end

	dbcs_off2cells (a_off___0: NATURAL_32; a_max_off: NATURAL_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_off___0 >= a_max_off then
				Result := 1
				js.return
			end
			if not js.return_called and then (globals_inst.enc_dbcs = 9932) then
				if (globals_inst.ScreenLines[a_off___0.to_integer_32]).to_integer_32 = 142 then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				Result := (globals_inst.mb_bytelen_tab[(globals_inst.ScreenLines[a_off___0.to_integer_32]).to_integer_32]).to_integer_32
			end
		end

	dbcs_off2cells_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dbcs_off2cells)
		end

	utf_off2cells (a_off___0: NATURAL_32; a_max_off: NATURAL_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if a_off___0 + {NATURAL_32} 1 < a_max_off then
				if (globals_inst.ScreenLines[(a_off___0 + {NATURAL_32} 1).to_integer_32]).to_integer_32 = 0 then
					l_tmp := 2
				else
					l_tmp := 1
				end
			else
				l_tmp := 1
			end
			Result := l_tmp
		end

	utf_off2cells_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent utf_off2cells)
		end

	latin_ptr2char (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := (a_p___0.item).to_integer_32
		end

	latin_ptr2char_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent latin_ptr2char)
		end

	dbcs_ptr2char (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (globals_inst.mb_bytelen_tab[(a_p___0.item).to_integer_32]).to_integer_32 > 1 then
				if (a_p___0[1]).to_integer_32 /= 0 then
					Result := ((((a_p___0[0]).to_integer_32).bit_shift_left (8)) + (a_p___0[1]).to_integer_32)
					js.return
				end
			end
			if not js.return_called then
				Result := (a_p___0.item).to_integer_32
			end
		end

	dbcs_ptr2char_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dbcs_ptr2char)
		end

	utf_ptr2char (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			if (a_p___0[0]).to_integer_32 < 128 then
				Result := (a_p___0[0]).to_integer_32
				js.return
			end
			if not js.return_called then
				l_len := (utf8len_tab_zero[(a_p___0[0]).to_integer_32]).to_integer_32
				if l_len > 1 then
					if (((a_p___0[1]).to_integer_32).bit_and (192)) = 128 then
						if l_len = 2 then
							Result := ((((((a_p___0[0]).to_integer_32).bit_and (31))).bit_shift_left (6)) + (((a_p___0[1]).to_integer_32).bit_and (63)))
							js.return
						end
						if not js.return_called and then ((((a_p___0[2]).to_integer_32).bit_and (192)) = 128) then
							if l_len = 3 then
								Result := (((((((a_p___0[0]).to_integer_32).bit_and (15))).bit_shift_left (12)) + (((((a_p___0[1]).to_integer_32).bit_and (63))).bit_shift_left (6))) + (((a_p___0[2]).to_integer_32).bit_and (63)))
								js.return
							end
							if not js.return_called and then ((((a_p___0[3]).to_integer_32).bit_and (192)) = 128) then
								if l_len = 4 then
									Result := ((((((((a_p___0[0]).to_integer_32).bit_and (7))).bit_shift_left (18)) + (((((a_p___0[1]).to_integer_32).bit_and (63))).bit_shift_left (12))) + (((((a_p___0[2]).to_integer_32).bit_and (63))).bit_shift_left (6))) + (((a_p___0[3]).to_integer_32).bit_and (63)))
									js.return
								end
								if not js.return_called and then ((((a_p___0[4]).to_integer_32).bit_and (192)) = 128) then
									if l_len = 5 then
										Result := (((((((((a_p___0[0]).to_integer_32).bit_and (3))).bit_shift_left (24)) + (((((a_p___0[1]).to_integer_32).bit_and (63))).bit_shift_left (18))) + (((((a_p___0[2]).to_integer_32).bit_and (63))).bit_shift_left (12))) + (((((a_p___0[3]).to_integer_32).bit_and (63))).bit_shift_left (6))) + (((a_p___0[4]).to_integer_32).bit_and (63)))
										js.return
									end
									if not js.return_called and then ((((a_p___0[5]).to_integer_32).bit_and (192)) = 128) then
										if l_len = 6 then
											Result := ((((((((((a_p___0[0]).to_integer_32).bit_and (1))).bit_shift_left (30)) + (((((a_p___0[1]).to_integer_32).bit_and (63))).bit_shift_left (24))) + (((((a_p___0[2]).to_integer_32).bit_and (63))).bit_shift_left (18))) + (((((a_p___0[3]).to_integer_32).bit_and (63))).bit_shift_left (12))) + (((((a_p___0[4]).to_integer_32).bit_and (63))).bit_shift_left (6))) + (((a_p___0[5]).to_integer_32).bit_and (63)))
											js.return
										end
									end
								end
							end
						end
					end
				end
			end
			if not js.return_called then
				Result := (a_p___0[0]).to_integer_32
			end
		end

	utf_ptr2char_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent utf_ptr2char)
		end

	mb_ptr2char_adv (a_pp: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_c: INTEGER_32
		do
			l_c := globals_inst.mb_ptr2char.integer_32_item ([a_pp.item])
			a_pp.item := a_pp.item + (globals_inst.mb_ptr2len.integer_32_item ([a_pp.item]))
			Result := l_c
		end

	mb_cptr2char_adv (a_pp: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_c: INTEGER_32
		do
			l_c := globals_inst.mb_ptr2char.integer_32_item ([a_pp.item])
			if globals_inst.enc_utf8.to_boolean then
				a_pp.item := a_pp.item + (utf_ptr2len (a_pp.item))
			else
				a_pp.item := a_pp.item + (globals_inst.mb_ptr2len.integer_32_item ([a_pp.item]))
			end
			Result := l_c
		end

	utfc_ptr2char (a_p___0: CE_POINTER [NATURAL_8]; a_pcc: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_len: INTEGER_32
			l_c: INTEGER_32
			l_cc___0: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_i___0 := 0
					l_c := utf_ptr2char (a_p___0)
					l_len := utf_ptr2len (a_p___0)
					if not (l_len > 1) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((a_p___0.item).to_integer_32 < 128) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if (a_p___0[l_len]).to_integer_32 >= 128 then
							if (utf_iscomposing ((utf_ptr2char (a_p___0 + l_len)))).to_boolean then
								l_cc___0 := utf_ptr2char (a_p___0 + l_len)
								from
								until
									js.loop_left
								loop
									js.reset
									l_tmp := l_i___0
									l_i___0 := l_i___0 + 1
									a_pcc[l_tmp] := l_cc___0
									if l_i___0 = 6 then
										js.break
									end
									if not js.loop_jumped then
										l_len := l_len + (utf_ptr2len (a_p___0 + l_len))
										if (a_p___0[l_len]).to_integer_32 < 128 then
											js.break
										else
											l_cc___0 := utf_ptr2char (a_p___0 + l_len)
											if not (utf_iscomposing (l_cc___0)).to_boolean then
												js.break
											end
										end
									end
								end
								js.reset
							end
						end
				when 5 then -- if done
						if l_i___0 < 6 then
							a_pcc[l_i___0] := 0
						end
						Result := l_c
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	utfc_ptr2char_len (a_p___0: CE_POINTER [NATURAL_8]; a_pcc: CE_POINTER [INTEGER_32]; a_maxlen: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			l_c: INTEGER_32
			l_cc___0: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_i___0 := 0
					l_c := utf_ptr2char (a_p___0)
					l_len := utf_ptr2len_len (a_p___0, a_maxlen)
					if not (l_len > 1) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((a_p___0.item).to_integer_32 < 128) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if l_len < a_maxlen then
							if (a_p___0[l_len]).to_integer_32 >= 128 then
								if (utf_iscomposing ((utf_ptr2char (a_p___0 + l_len)))).to_boolean then
									l_cc___0 := utf_ptr2char (a_p___0 + l_len)
									from
									until
										js.loop_left
									loop
										js.reset
										l_tmp := l_i___0
										l_i___0 := l_i___0 + 1
										a_pcc[l_tmp] := l_cc___0
										if l_i___0 = 6 then
											js.break
										end
										if not js.loop_jumped then
											l_len := l_len + (utf_ptr2len_len (a_p___0 + l_len, a_maxlen - l_len))
											if l_len >= a_maxlen then
												js.break
											elseif (a_p___0[l_len]).to_integer_32 < 128 then
												js.break
											else
												l_cc___0 := utf_ptr2char (a_p___0 + l_len)
												if not (utf_iscomposing (l_cc___0)).to_boolean then
													js.break
												end
											end
										end
									end
									js.reset
								end
							end
						end
				when 5 then -- if done
						if l_i___0 < 6 then
							a_pcc[l_i___0] := 0
						end
						Result := l_c
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	utfc_char2bytes (a_off___0: INTEGER_32; a_buf___6: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_len := utf_char2bytes ((globals_inst.ScreenLinesUC[a_off___0]).to_integer_32, a_buf___6)
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (l_i___0 < globals_inst.Screen_mco))
			loop
				js.reset
				if (globals_inst.ScreenLinesC[l_i___0])[a_off___0] = {NATURAL_32} 0 then
					js.break
				end
				if not js.loop_jumped then
					l_len := l_len + (utf_char2bytes (((globals_inst.ScreenLinesC[l_i___0])[a_off___0]).to_integer_32, a_buf___6 + l_len))
					l_i___0 := l_i___0 + 1
				end
			end
			js.reset
			Result := l_len
		end

	utf_ptr2len (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			if (a_p___0.item).to_integer_32 = 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_len := (utf8len_tab[(a_p___0.item).to_integer_32]).to_integer_32
				l_i___0 := 1
				from
				until
					not (not js.loop_left and then (l_i___0 < l_len))
				loop
					if (((a_p___0[l_i___0]).to_integer_32).bit_and (192)) /= 128 then
						Result := 1
						js.return
					end
					if not js.return_called then
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not js.return_called then
				Result := l_len
			end
		end

	utf_byte2len (a_b: INTEGER_32): INTEGER_32
		do
			Result := (utf8len_tab[a_b]).to_integer_32
		end

	utf_ptr2len_len (a_p___0: CE_POINTER [NATURAL_8]; a_size: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			l_m: INTEGER_32
			js: JUMP_STATE
		do
			l_len := (utf8len_tab[(a_p___0.item).to_integer_32]).to_integer_32
			if l_len = 1 then
				Result := 1
				js.return
			end
			if not js.return_called then
				if l_len > a_size then
					l_m := a_size
				else
					l_m := l_len
				end
				l_i___0 := 1
				from
				until
					not (not js.loop_left and then (l_i___0 < l_m))
				loop
					if (((a_p___0[l_i___0]).to_integer_32).bit_and (192)) /= 128 then
						Result := 1
						js.return
					end
					if not js.return_called then
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not js.return_called then
				Result := l_len
			end
		end

	utfc_ptr2len (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_len: INTEGER_32
			l_b0: INTEGER_32
			js: JUMP_STATE
		do
			l_b0 := (a_p___0.item).to_integer_32
			if l_b0 = 0 then
				Result := 0
				js.return
			end
			if not js.return_called and then (l_b0 < 128) then
				if (a_p___0[1]).to_integer_32 < 128 then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				l_len := utf_ptr2len (a_p___0)
				if l_len = 1 then
					if l_b0 >= 128 then
						Result := 1
						js.return
					end
				end
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					if (a_p___0[l_len]).to_integer_32 < 128 then
						Result := l_len
						js.return
					elseif not (utf_iscomposing ((utf_ptr2char (a_p___0 + l_len)))).to_boolean then
						Result := l_len
						js.return
					end
					if not js.return_called then
						l_len := l_len + (utf_ptr2len (a_p___0 + l_len))
					end
				end
			end
		end

	utfc_ptr2len_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent utfc_ptr2len)
		end

	utfc_ptr2len_len (a_p___0: CE_POINTER [NATURAL_8]; a_size: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			l_len_next_char: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_size < 1 then
						Result := 0
						js.return
					elseif (a_p___0.item).to_integer_32 = 0 then
						Result := 0
						js.return
					end
					if not js.return_called and then ((a_p___0[0]).to_integer_32 < 128) then
						if a_size = 1 then
							Result := 1
							js.return
						elseif (a_p___0[1]).to_integer_32 < 128 then
							Result := 1
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						l_len := utf_ptr2len_len (a_p___0, a_size)
						if l_len /= 1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (a_p___0[0]).to_integer_32 >= 128 then
							Result := 1
							js.return
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_len > a_size then
							Result := 1
							js.return
						end
				when 5 then -- if done
						if not js.return_called then
							from
							until
								not (not js.loop_left and then (l_len < a_size))
							loop
								js.reset
								if (a_p___0[l_len]).to_integer_32 < 128 then
									js.break
								end
								if not js.loop_jumped then
									l_len_next_char := utf_ptr2len_len (a_p___0 + l_len, a_size - l_len)
									if l_len_next_char > a_size - l_len then
										js.break
									end
								end
								if not js.loop_jumped then
									if not (utf_iscomposing ((utf_ptr2char (a_p___0 + l_len)))).to_boolean then
										js.break
									end
								end
								if not js.loop_jumped then
									l_len := l_len + l_len_next_char
								end
							end
							js.reset
							Result := l_len
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	utfc_ptr2len_len_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent utfc_ptr2len_len)
		end

	utf_char2len (a_c: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_c < 128 then
				Result := 1
				js.return
			end
			if not js.return_called and then (a_c < 2048) then
				Result := 2
				js.return
			end
			if not js.return_called and then (a_c < 65536) then
				Result := 3
				js.return
			end
			if not js.return_called and then (a_c < 2097152) then
				Result := 4
				js.return
			end
			if not js.return_called and then (a_c < 67108864) then
				Result := 5
				js.return
			end
			if not js.return_called then
				Result := 6
			end
		end

	utf_char2len_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent utf_char2len)
		end

	utf_char2bytes (a_c: INTEGER_32; a_buf___6: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_c < 128 then
				a_buf___6[0] := a_c.to_natural_8
				Result := 1
				js.return
			end
			if not js.return_called and then (a_c < 2048) then
				a_buf___6[0] := ({NATURAL_32} 192 + ((a_c.to_natural_32).bit_shift_right (6))).to_natural_8
				a_buf___6[1] := (128 + ((a_c).bit_and (63))).to_natural_8
				Result := 2
				js.return
			end
			if not js.return_called and then (a_c < 65536) then
				a_buf___6[0] := ({NATURAL_32} 224 + ((a_c.to_natural_32).bit_shift_right (12))).to_natural_8
				a_buf___6[1] := ({NATURAL_32} 128 + ((((a_c.to_natural_32).bit_shift_right (6))).bit_and ({NATURAL_32} 63))).to_natural_8
				a_buf___6[2] := (128 + ((a_c).bit_and (63))).to_natural_8
				Result := 3
				js.return
			end
			if not js.return_called and then (a_c < 2097152) then
				a_buf___6[0] := ({NATURAL_32} 240 + ((a_c.to_natural_32).bit_shift_right (18))).to_natural_8
				a_buf___6[1] := ({NATURAL_32} 128 + ((((a_c.to_natural_32).bit_shift_right (12))).bit_and ({NATURAL_32} 63))).to_natural_8
				a_buf___6[2] := ({NATURAL_32} 128 + ((((a_c.to_natural_32).bit_shift_right (6))).bit_and ({NATURAL_32} 63))).to_natural_8
				a_buf___6[3] := (128 + ((a_c).bit_and (63))).to_natural_8
				Result := 4
				js.return
			end
			if not js.return_called and then (a_c < 67108864) then
				a_buf___6[0] := ({NATURAL_32} 248 + ((a_c.to_natural_32).bit_shift_right (24))).to_natural_8
				a_buf___6[1] := ({NATURAL_32} 128 + ((((a_c.to_natural_32).bit_shift_right (18))).bit_and ({NATURAL_32} 63))).to_natural_8
				a_buf___6[2] := ({NATURAL_32} 128 + ((((a_c.to_natural_32).bit_shift_right (12))).bit_and ({NATURAL_32} 63))).to_natural_8
				a_buf___6[3] := ({NATURAL_32} 128 + ((((a_c.to_natural_32).bit_shift_right (6))).bit_and ({NATURAL_32} 63))).to_natural_8
				a_buf___6[4] := (128 + ((a_c).bit_and (63))).to_natural_8
				Result := 5
				js.return
			end
			if not js.return_called then
				a_buf___6[0] := ({NATURAL_32} 252 + ((a_c.to_natural_32).bit_shift_right (30))).to_natural_8
				a_buf___6[1] := ({NATURAL_32} 128 + ((((a_c.to_natural_32).bit_shift_right (24))).bit_and ({NATURAL_32} 63))).to_natural_8
				a_buf___6[2] := ({NATURAL_32} 128 + ((((a_c.to_natural_32).bit_shift_right (18))).bit_and ({NATURAL_32} 63))).to_natural_8
				a_buf___6[3] := ({NATURAL_32} 128 + ((((a_c.to_natural_32).bit_shift_right (12))).bit_and ({NATURAL_32} 63))).to_natural_8
				a_buf___6[4] := ({NATURAL_32} 128 + ((((a_c.to_natural_32).bit_shift_right (6))).bit_and ({NATURAL_32} 63))).to_natural_8
				a_buf___6[5] := (128 + ((a_c).bit_and (63))).to_natural_8
				Result := 6
			end
		end

	utf_char2bytes_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent utf_char2bytes)
		end

	utf_iscomposing (a_c: INTEGER_32): INTEGER_32
		do
			Result := (intable (combining, ({PD_INTERVAL}.sizeof.to_natural_32 * (188).to_natural_32), a_c))
		end

	utf_printable (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (intable (nonprint, ({PD_INTERVAL}.sizeof.to_natural_32 * (9).to_natural_32), a_c)).to_boolean then
				l_tmp___0 := 0
			else
				l_tmp___0 := 1
			end
			Result := l_tmp___0
		end

	utf_class (a_c: INTEGER_32): INTEGER_32
		local
			l_bot: INTEGER_32
			l_top: INTEGER_32
			l_mid: INTEGER_32
			js: JUMP_STATE
		do
			l_bot := 0
			l_top := (({PD_CLINTERVAL}.sizeof.to_natural_32 * (62).to_natural_32) // {PD_CLINTERVAL}.sizeof.to_natural_32 - {NATURAL_32} 1).to_integer_32
			if a_c < 256 then
				if a_c = 32 then
					Result := 0
					js.return
				elseif a_c = 9 then
					Result := 0
					js.return
				elseif a_c = 0 then
					Result := 0
					js.return
				elseif a_c = 160 then
					Result := 0
					js.return
				end
				if not js.return_called then
					if (charset_inst.vim_iswordc (a_c)).to_boolean then
						Result := 2
						js.return
					end
				end
				if not js.return_called then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				from
				until
					not (not js.loop_left and then (l_top >= l_bot))
				loop
					l_mid := (l_bot + l_top) // 2
					if (classes[l_mid].last).to_integer_32 < a_c then
						l_bot := l_mid + 1
					elseif (classes[l_mid].first).to_integer_32 > a_c then
						l_top := l_mid - 1
					else
						Result := (classes[l_mid].class2).to_integer_32
						js.return
					end
				end
			end
			if not js.return_called then
				Result := 2
			end
		end

	utf_convert (a_a: INTEGER_32; a_table: CE_POINTER [PD_CONVERTSTRUCT]; a_tableSize: INTEGER_32): INTEGER_32
		local
			l_start___1: INTEGER_32
			l_mid: INTEGER_32
			l_end: INTEGER_32
		do
			l_start___1 := 0
			l_end := (a_tableSize.to_natural_32 // {PD_CONVERTSTRUCT}.sizeof.to_natural_32).to_integer_32
			from
			until
				not (l_start___1 < l_end)
			loop
				l_mid := (l_end + l_start___1) // 2
				if (a_table + l_mid).item.rangeEnd < a_a then
					l_start___1 := l_mid + 1
				else
					l_end := l_mid
				end
			end
			if (a_table + l_start___1).item.rangeStart <= a_a then
				if a_a <= (a_table + l_start___1).item.rangeEnd then
					if (a_a - (a_table + l_start___1).item.rangeStart) \\ (a_table + l_start___1).item.step = 0 then
						Result := (a_a + (a_table + l_start___1).item.offset)
					else
						Result := a_a
					end
				else
					Result := a_a
				end
			else
				Result := a_a
			end
		end

	utf_fold (a_a: INTEGER_32): INTEGER_32
		do
			Result := (utf_convert (a_a, foldCase, ({PD_CONVERTSTRUCT}.sizeof.to_natural_32 * (156).to_natural_32).to_integer_32))
		end

	utf_toupper (a_a: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			if a_a < 128 then
				if ((option_inst.cmp_flags).bit_and ({NATURAL_32} 2)).to_boolean then
					if a_a < 97 then
						l_tmp := a_a
					elseif a_a > 122 then
						l_tmp := a_a
					else
						l_tmp := a_a - 32
					end
					Result := l_tmp
					js.return
				end
			end
			if not js.return_called and then (not ((option_inst.cmp_flags).bit_and ({NATURAL_32} 1)).to_boolean) then
				Result := (towupper (a_a.to_natural_32)).to_integer_32
				js.return
			end
			if not js.return_called and then (a_a < 128) then
				Result := (toupper (a_a))
				js.return
			end
			if not js.return_called then
				Result := (utf_convert (a_a, toUpper2, ({PD_CONVERTSTRUCT}.sizeof.to_natural_32 * (150).to_natural_32).to_integer_32))
			end
		end

	utf_islower (a_a: INTEGER_32): INTEGER_32
		do
			Result := ((utf_toupper (a_a)) /= a_a).to_integer
		end

	utf_tolower (a_a: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			if a_a < 128 then
				if ((option_inst.cmp_flags).bit_and ({NATURAL_32} 2)).to_boolean then
					if a_a < 65 then
						l_tmp := a_a
					elseif a_a > 90 then
						l_tmp := a_a
					else
						l_tmp := a_a + 32
					end
					Result := l_tmp
					js.return
				end
			end
			if not js.return_called and then (not ((option_inst.cmp_flags).bit_and ({NATURAL_32} 1)).to_boolean) then
				Result := (towlower (a_a.to_natural_32)).to_integer_32
				js.return
			end
			if not js.return_called and then (a_a < 128) then
				Result := (tolower (a_a))
				js.return
			end
			if not js.return_called then
				Result := (utf_convert (a_a, toLower2, ({PD_CONVERTSTRUCT}.sizeof.to_natural_32 * (144).to_natural_32).to_integer_32))
			end
		end

	utf_isupper (a_a: INTEGER_32): INTEGER_32
		do
			Result := ((utf_tolower (a_a)) /= a_a).to_integer
		end

	mb_strnicmp (a_s1: CE_POINTER [NATURAL_8]; a_s2: CE_POINTER [NATURAL_8]; a_nn: NATURAL_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_l: INTEGER_32
			l_cdiff: INTEGER_32
			l_incomplete: INTEGER_32
			l_n: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
		do
			l_incomplete := 0
			l_n := a_nn.to_integer_32
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (l_i___0 < l_n))
			loop
				if (a_s1[l_i___0]).to_integer_32 = 0 then
					if (a_s2[l_i___0]).to_integer_32 = 0 then
						Result := 0
						js.return
					end
				end
				if not js.return_called then
					if globals_inst.enc_utf8.to_boolean then
						l_l := utf_byte2len ((a_s1[l_i___0]).to_integer_32)
						if l_l > l_n - l_i___0 then
							l_l := l_n - l_i___0
							l_incomplete := 1
						end
						l_j := 0
						from
						until
							not (not js.loop_left and then (l_j < l_l))
						loop
							js.reset
							if (a_s1[(l_i___0 + l_j)]).to_integer_32 /= (a_s2[(l_i___0 + l_j)]).to_integer_32 then
								js.break
							end
							if not js.loop_jumped then
								if (a_s1[(l_i___0 + l_j)]).to_integer_32 = 0 then
									l_l := l_j
								end
								l_j := l_j + 1
							end
						end
						js.reset
						if l_j < l_l then
							if l_incomplete.to_boolean then
								Result := (-1)
								js.return
							elseif l_i___0 + (utf_byte2len ((a_s2[l_i___0]).to_integer_32)) > l_n then
								Result := (-1)
								js.return
							end
							if not js.return_called then
								l_tmp___1 := utf_fold ((utf_ptr2char (a_s1 + l_i___0)))
								l_cdiff := l_tmp___1 - (utf_fold ((utf_ptr2char (a_s2 + l_i___0))))
								if l_cdiff /= 0 then
									Result := l_cdiff
									js.return
								end
							end
						end
					else
						l_l := globals_inst.mb_ptr2len.integer_32_item ([a_s1 + l_i___0])
						if l_l <= 1 then
							if (a_s1[l_i___0]).to_integer_32 /= (a_s2[l_i___0]).to_integer_32 then
								l_tmp___4 := charset_inst.vim_tolower ((a_s1[l_i___0]).to_integer_32)
								l_cdiff := l_tmp___4 - (charset_inst.vim_tolower ((a_s2[l_i___0]).to_integer_32))
								if l_cdiff /= 0 then
									Result := l_cdiff
									js.return
								end
							end
						else
							if l_l > l_n - l_i___0 then
								l_l := l_n - l_i___0
							end
							l_cdiff := strncmp (create {CE_POINTER [INTEGER_8]}.make_cast ((a_s1 + l_i___0)), create {CE_POINTER [INTEGER_8]}.make_cast ((a_s2 + l_i___0)), l_l.to_natural_32)
							if l_cdiff /= 0 then
								Result := l_cdiff
								js.return
							end
						end
					end
				end
				if not js.return_called then
					l_i___0 := l_i___0 + l_l
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	show_utf8
		local
			l_len: INTEGER_32
			l_rlen: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_clen: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_line.make

			l_rlen := 0
			l_line.ce_gets (memline_inst.ml_get_cursor)
			l_len := utfc_ptr2len (l_line)
			if l_len = 0 then
				message_inst.msg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("NUL"))).do_nothing
				js.return
			end
			if not js.return_called then
				l_clen := 0
				l_i___0 := 0
				from
				until
					not (not js.loop_left and then (l_i___0 < l_len))
				loop
					js.reset
					if l_clen = 0 then
						if l_i___0 > 0 then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((globals_inst.IObuff + l_rlen)), ce_string ("+ ")).do_nothing
							l_rlen := l_rlen + (2)
						end
						l_clen := utf_ptr2len (l_line + l_i___0)
					end
					if (l_line[l_i___0]).to_integer_32 = 10 then
						l_tmp := ('%/0/').code
					else
						l_tmp := (l_line[l_i___0]).to_integer_32
					end
					sprintf ([(create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff) + l_rlen), ce_string ("%%02x "), l_tmp]).do_nothing
					l_clen := l_clen - 1
					l_rlen := l_rlen + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((globals_inst.IObuff + l_rlen)))).to_integer_32
					if l_rlen > 1005 then
						js.break
					end
					if not js.loop_jumped then
						l_i___0 := l_i___0 + 1
					end
				end
				js.reset
				message_inst.msg (globals_inst.IObuff).do_nothing
			end
		end

	latin_head_off (a_base: CE_POINTER [NATURAL_8]; a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := 0
		end

	latin_head_off_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent latin_head_off)
		end

	dbcs_head_off (a_base: CE_POINTER [NATURAL_8]; a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_q: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_q.make

			if (a_p___0.c_pointer.to_integer_32).to_natural_32 <= (a_base.c_pointer.to_integer_32).to_natural_32 then
				Result := 0
				js.return
			elseif (globals_inst.mb_bytelen_tab[(a_p___0[-1]).to_integer_32]).to_integer_32 = 1 then
				Result := 0
				js.return
			elseif (a_p___0.item).to_integer_32 = 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_q.ce_gets (a_base)
				from
				until
					not ((l_q.c_pointer.to_integer_32).to_natural_32 < (a_p___0.c_pointer.to_integer_32).to_natural_32)
				loop
					l_q.ce_gets (l_q + (dbcs_ptr2len (l_q)))
				end
				if (l_q.c_pointer.to_integer_32).to_natural_32 = (a_p___0.c_pointer.to_integer_32).to_natural_32 then
					l_tmp___0 := 0
				else
					l_tmp___0 := 1
				end
				Result := l_tmp___0
			end
		end

	dbcs_head_off_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dbcs_head_off)
		end

	dbcs_screen_head_off (a_base: CE_POINTER [NATURAL_8]; a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_q: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_q.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((a_p___0.c_pointer.to_integer_32).to_natural_32 <= (a_base.c_pointer.to_integer_32).to_natural_32) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						Result := 0
						js.return
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if globals_inst.enc_dbcs /= 9932 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (a_p___0[-1]).to_integer_32 = 142 then
							Result := 0
							js.return
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if (globals_inst.mb_bytelen_tab[(a_p___0[-1]).to_integer_32]).to_integer_32 = 1 then
							Result := 0
							js.return
						elseif (a_p___0.item).to_integer_32 = 0 then
							Result := 0
							js.return
						end
				when 7 then -- if done
						if not js.return_called then
							l_q.ce_gets (a_base)
							from
							until
								not ((l_q.c_pointer.to_integer_32).to_natural_32 < (a_p___0.c_pointer.to_integer_32).to_natural_32)
							loop
								if globals_inst.enc_dbcs = 9932 then
									if (l_q.item).to_integer_32 = 142 then
										l_q.ce_gets (l_q + 1)
									else
										l_tmp := dbcs_ptr2len (l_q)
										l_q.ce_gets (l_q + l_tmp)
									end
								else
									l_tmp := dbcs_ptr2len (l_q)
									l_q.ce_gets (l_q + l_tmp)
								end
							end
							if (l_q.c_pointer.to_integer_32).to_natural_32 = (a_p___0.c_pointer.to_integer_32).to_natural_32 then
								l_tmp___0 := 0
							else
								l_tmp___0 := 1
							end
							Result := l_tmp___0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	utf_head_off (a_base: CE_POINTER [NATURAL_8]; a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_q: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			create l_q.make
			create l_s.make

			if (a_p___0.item).to_integer_32 < 128 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_q.ce_gets (a_p___0)
				from
				until
					js.loop_left
				loop
					js.reset
					l_s.ce_gets (l_q)
					from
					until
						(((l_s[1]).to_integer_32).bit_and (192)) /= 128
					loop
						l_s.ce_gets (l_s + 1)
					end
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_q.c_pointer.to_integer_32).to_natural_32 > (a_base.c_pointer.to_integer_32).to_natural_32 then
							if (((l_q.item).to_integer_32).bit_and (192)) /= 128 then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_q.ce_gets (l_q - 1)
						end
					end
					js.reset
					l_len := (utf8len_tab[(l_q.item).to_integer_32]).to_integer_32
					if l_len /= (l_s.distance (l_q)) + 1 then
						if l_len /= (a_p___0.distance (l_q)) + 1 then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						if (l_q.c_pointer.to_integer_32).to_natural_32 <= (a_base.c_pointer.to_integer_32).to_natural_32 then
							js.break
						end
						if not js.loop_jumped then
							l_c := utf_ptr2char (l_q)
							if (utf_iscomposing (l_c)).to_boolean then
								js.continue
							end
						end
						if not js.loop_jumped then
							js.break
						end
						if not js.loop_left then
							l_q.ce_gets (l_q - 1)
						end
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := (a_p___0.distance (l_q))
			end
		end

	utf_head_off_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent utf_head_off)
		end

	mb_copy_char (a_fp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_tp: CE_POINTER [CE_POINTER [NATURAL_8]])
		local
			l_l: INTEGER_32
		do
			l_l := (globals_inst.mb_ptr2len.integer_32_item ([a_fp.item]))
			memmove (create {CE_POINTER [ANY]}.make_cast (a_tp.item), create {CE_POINTER [ANY]}.make_cast (a_fp.item), l_l.to_natural_32).do_nothing
			a_tp.item := a_tp.item + l_l
			a_fp.item := a_fp.item + l_l
		end

	mb_off_next (a_base: CE_POINTER [NATURAL_8]; a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			js: JUMP_STATE
		do
			if globals_inst.enc_utf8.to_boolean then
				if (a_p___0.item).to_integer_32 < 128 then
					Result := 0
					js.return
				end
				if not js.return_called then
					l_i___0 := 0
					from
					until
						(((a_p___0[l_i___0]).to_integer_32).bit_and (192)) /= 128
					loop
						l_i___0 := l_i___0 + 1
					end
					if l_i___0 > 0 then
						l_j := 0
						from
						until
							not (not js.loop_left and then (((a_p___0 - l_j).c_pointer.to_integer_32).to_natural_32 > (a_base.c_pointer.to_integer_32).to_natural_32))
						loop
							js.reset
							if (((a_p___0[-l_j]).to_integer_32).bit_and (192)) /= 128 then
								js.break
							end
							if not js.loop_jumped then
								l_j := l_j + 1
							end
						end
						js.reset
						if (utf8len_tab[(a_p___0[-l_j]).to_integer_32]).to_integer_32 /= l_i___0 + l_j then
							Result := 0
							js.return
						end
					end
				end
				if not js.return_called then
					Result := l_i___0
					js.return
				end
			end
			if not js.return_called then
				Result := (globals_inst.mb_head_off.integer_32_item ([a_base, a_p___0]))
			end
		end

	mb_tail_off (a_base: CE_POINTER [NATURAL_8]; a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			js: JUMP_STATE
		do
			if (a_p___0.item).to_integer_32 = 0 then
				Result := 0
				js.return
			end
			if not js.return_called and then (globals_inst.enc_utf8.to_boolean) then
				l_i___0 := 0
				from
				until
					(((a_p___0[(l_i___0 + 1)]).to_integer_32).bit_and (192)) /= 128
				loop
					l_i___0 := l_i___0 + 1
				end
				l_j := 0
				from
				until
					not (not js.loop_left and then (((a_p___0 - l_j).c_pointer.to_integer_32).to_natural_32 > (a_base.c_pointer.to_integer_32).to_natural_32))
				loop
					js.reset
					if (((a_p___0[-l_j]).to_integer_32).bit_and (192)) /= 128 then
						js.break
					end
					if not js.loop_jumped then
						l_j := l_j + 1
					end
				end
				js.reset
				if (utf8len_tab[(a_p___0[-l_j]).to_integer_32]).to_integer_32 /= (l_i___0 + l_j) + 1 then
					Result := 0
					js.return
				end
				if not js.return_called then
					Result := l_i___0
					js.return
				end
			end
			if not js.return_called then
				if globals_inst.enc_dbcs = 0 then
					Result := 0
					js.return
				elseif (a_p___0[1]).to_integer_32 = 0 then
					Result := 0
					js.return
				elseif (globals_inst.mb_bytelen_tab[(a_p___0.item).to_integer_32]).to_integer_32 = 1 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := (1 - (dbcs_head_off (a_base, a_p___0)))
			end
		end

	utf_find_illegal
		local
			l_pos___3: PD_POS_T
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_vimconv: PD_VIMCONV_T
			l_tofree: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_pos___3.make
			create l_p___0.make
			create l_vimconv.make
			create l_tofree.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pos___3.ce_gets (globals_inst.curwin.item.w_cursor)
					l_tofree.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_vimconv.vc_type := 0
					if globals_inst.enc_utf8.to_boolean then
						if (((enc_canon_props (globals_inst.curbuf.item.b_p_fenc))).bit_and (1)).to_boolean then
							convert_setup (l_vimconv.address, option_inst.p_enc, globals_inst.curbuf.item.b_p_fenc).do_nothing
						end
					end
					globals_inst.curwin.item.w_cursor.coladd := 0
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 13 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_p___0.ce_gets (memline_inst.ml_get_cursor)
						if l_vimconv.vc_type /= 0 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tofree))
							l_tofree.ce_gets (string_convert (l_vimconv.address, l_p___0, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
							if (l_tofree.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								js.break
							end
							if not js.loop_jumped then
								l_p___0.ce_gets (l_tofree)
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 12 -- skip if block
						end
				when 3 then -- if: | loop condition:
						if not (not js.loop_left and then ((l_p___0.item).to_integer_32 /= 0)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 4 then -- loop body:
						l_len := utf_ptr2len (l_p___0)
						if not ((l_p___0.item).to_integer_32 >= 128) then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if l_len /= 1 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if (utf_char2len ((utf_ptr2char (l_p___0)))) = l_len then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if l_vimconv.vc_type = 0 then
							globals_inst.curwin.item.w_cursor.col := globals_inst.curwin.item.w_cursor.col + (l_p___0.distance ((memline_inst.ml_get_cursor)))
						else
							l_len := l_p___0.distance (l_tofree)
							l_p___0.ce_gets (memline_inst.ml_get_cursor)
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_p___0.item).to_integer_32 /= 0 then
									l_tmp___1 := l_len
									l_len := l_len - 1
									if not (l_tmp___1 > 0) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_l := utf_ptr2len (l_p___0)
									globals_inst.curwin.item.w_cursor.col := globals_inst.curwin.item.w_cursor.col + l_l
									l_p___0.ce_gets (l_p___0 + l_l)
								end
							end
							js.reset
						end
						l_pos := -1 + 14 -- goto theend
				when 10 then -- if done | if done
						l_p___0.ce_gets (l_p___0 + l_len)
						l_pos := -1 + 3 -- back to loop condition
				when 11 then -- loop done
						if globals_inst.curwin.item.w_cursor.lnum = globals_inst.curbuf.item.b_ml.ml_line_count then
							js.break
						end
				when 12 then -- if done
						if not js.loop_jumped then
							globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
							globals_inst.curwin.item.w_cursor.col := 0
						end
						l_pos := -1 + 1 -- back to loop condition
				when 13 then -- loop done
					js.reset
					globals_inst.curwin.item.w_cursor := l_pos___3
					misc1_inst.beep_flush
				when 14 then -- theend:
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tofree))
					convert_setup (l_vimconv.address, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	utf_valid_string (a_s: CE_POINTER [NATURAL_8]; a_end: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_l: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_tmp.make

			l_p___0.ce_gets (a_s)
			from
			until
				js.loop_left
			loop
				js.reset
				if (a_end.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_tmp___0 := ((l_p___0.item).to_integer_32 /= 0).to_integer
				else
					l_tmp___0 := ((l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32).to_integer
				end
				if not l_tmp___0.to_boolean then
					js.break
				end
				if not js.loop_jumped then
					l_l := (utf8len_tab_zero[(l_p___0.item).to_integer_32]).to_integer_32
					if l_l = 0 then
						Result := 0
						js.return
					end
					if not js.return_called and then ((a_end.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32) then
						if ((l_p___0 + l_l).c_pointer.to_integer_32).to_natural_32 > (a_end.c_pointer.to_integer_32).to_natural_32 then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						l_p___0.ce_gets (l_p___0 + 1)
						from
						until
							js.loop_left
						loop
							js.reset
							l_l := l_l - 1
							if not (l_l > 0) then
								js.break
							end
							if not js.loop_jumped then
								l_tmp.ce_gets (l_p___0)
								l_p___0.ce_gets (l_p___0 + 1)
								if (((l_tmp.item).to_integer_32).bit_and (192)) /= 128 then
									Result := 0
									js.return
								end
							end
						end
						js.reset
					end
				end
			end
			js.reset
			if not js.return_called then
				Result := 1
			end
		end

	dbcs_screen_tail_off (a_base: CE_POINTER [NATURAL_8]; a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_p___0.item).to_integer_32 /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						Result := 0
						js.return
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if (a_p___0[1]).to_integer_32 /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						Result := 0
						js.return
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if globals_inst.enc_dbcs /= 9932 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if (a_p___0.item).to_integer_32 = 142 then
							Result := 0
							js.return
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if (globals_inst.mb_bytelen_tab[(a_p___0.item).to_integer_32]).to_integer_32 = 1 then
							Result := 0
							js.return
						end
				when 10 then -- if done | if done
						if not js.return_called then
							Result := (1 - (dbcs_screen_head_off (a_base, a_p___0)))
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	mb_adjust_cursor
		do
			mb_adjustpos (create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset))
		end

	mb_adjustpos (a_lp: CE_POINTER [PD_POS_T])
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_lp.item.col > 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (a_lp.item.coladd > 1) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_p___0.ce_gets (memline_inst.ml_get (a_lp.item.lnum))
						a_lp.item.col := a_lp.item.col - (globals_inst.mb_head_off.integer_32_item ([l_p___0, l_p___0 + a_lp.item.col]))
						if a_lp.item.coladd = 1 then
							if (l_p___0[a_lp.item.col]).to_integer_32 /= 9 then
								if (charset_inst.vim_isprintc ((globals_inst.mb_ptr2char.integer_32_item ([l_p___0 + a_lp.item.col])))).to_boolean then
									if (charset_inst.ptr2cells (l_p___0 + a_lp.item.col)) > 1 then
										a_lp.item.coladd := 0
									end
								end
							end
						end
				when 5 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	mb_prevptr (a_line: CE_POINTER [NATURAL_8]; a_p___0: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
		do
			create l_p___0.make

			l_p___0.ce_gets (a_p___0)
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (a_line.c_pointer.to_integer_32).to_natural_32 then
				if globals_inst.has_mbyte.to_boolean then
					l_tmp___0 := (globals_inst.mb_head_off.integer_32_item ([a_line, l_p___0 - 1])) + 1
				else
					l_tmp___0 := 1
				end
				l_p___0.ce_gets (l_p___0 - l_tmp___0)
			end
			Result := l_p___0
		end

	mb_charlen (a_str___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_count___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0.ce_gets (a_str___1)
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_count___2 := 0
				from
				until
					(l_p___0.item).to_integer_32 = 0
				loop
					l_p___0.ce_gets (l_p___0 + (globals_inst.mb_ptr2len.integer_32_item ([l_p___0])))
					l_count___2 := l_count___2 + 1
				end
				Result := l_count___2
			end
		end

	mb_charlen_len (a_str___1: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_count___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0.ce_gets (a_str___1)
			l_count___2 := 0
			from
			until
				js.loop_left
			loop
				js.reset
				if (l_p___0.item).to_integer_32 /= 0 then
					if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((a_str___1 + a_len).c_pointer.to_integer_32).to_natural_32) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_p___0.ce_gets (l_p___0 + (globals_inst.mb_ptr2len.integer_32_item ([l_p___0])))
					l_count___2 := l_count___2 + 1
				end
			end
			js.reset
			Result := l_count___2
		end

	mb_unescape (a_pp: CE_POINTER [CE_POINTER [NATURAL_8]]): CE_POINTER [NATURAL_8]
		local
			l_n: INTEGER_32
			l_m: INTEGER_32
			l_str___1: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_str___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_m := 0
					l_str___1.ce_gets (a_pp.item)
					l_n := 0
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 14 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if (l_str___1[l_n]).to_integer_32 /= 0 then
							if not (l_m <= 21) then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 13 -- skip if block
						end
				when 3 then -- if:
						if (l_str___1[l_n]).to_integer_32 /= 128 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (l_str___1[(l_n + 1)]).to_integer_32 = 254 then
							if (l_str___1[(l_n + 2)]).to_integer_32 = 88 then
								l_tmp := l_m
								l_m := l_m + 1
								buf___1[l_tmp] := (128).to_natural_8
								l_n := l_n + (2)
							else
								l_pos := -1 + 6 -- goto _L___3
							end
						else
							l_pos := -1 + 6 -- goto _L___3
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else: | _L___3:
						if (l_str___1[l_n]).to_integer_32 /= 128 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___1
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if (l_str___1[l_n]).to_integer_32 /= 155 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L___1:
						if (l_str___1[(l_n + 1)]).to_integer_32 = 253 then
							if (l_str___1[(l_n + 2)]).to_integer_32 = 81 then
								l_tmp___0 := l_m
								l_m := l_m + 1
								buf___1[l_tmp___0] := (155).to_natural_8
								l_n := l_n + (2)
							else
								l_pos := -1 + 12 -- goto _L___0
							end
						else
							l_pos := -1 + 12 -- goto _L___0
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___0:
						if (l_str___1[l_n]).to_integer_32 = 128 then
							js.break
						elseif (l_str___1[l_n]).to_integer_32 = 155 then
							js.break
						else
							l_tmp___1 := l_m
							l_m := l_m + 1
							buf___1[l_tmp___1] := l_str___1[l_n]
						end
				when 13 then -- if done | if done | if done
						if not js.loop_jumped then
							buf___1[l_m] := (('%/0/').code).to_natural_8
							if (globals_inst.mb_ptr2len.integer_32_item ([buf___1])) > 1 then
								a_pp.item := (l_str___1 + l_n) + 1
								Result := buf___1
								js.return
							end
							if not js.return_called then
								l_n := l_n + 1
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 14 then -- loop done
					js.reset
					if not js.return_called then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mb_lefthalve (a_row: INTEGER_32; a_col: INTEGER_32): INTEGER_32
		do
			Result := ((globals_inst.mb_off2cells.integer_32_item ([globals_inst.LineOffset[a_row] + a_col.to_natural_32, globals_inst.LineOffset[a_row] + globals_inst.screen_Columns.to_natural_32])) > 1).to_integer
		end

	mb_fix_col (a_col: INTEGER_32; a_row: INTEGER_32): INTEGER_32
		local
			l_col: INTEGER_32
			l_row: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_col := a_col
					l_row := a_row
					l_col := ui_inst.check_col (l_col)
					l_row := ui_inst.check_row (l_row)
					if not (globals_inst.has_mbyte.to_boolean) then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if (globals_inst.ScreenLines.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if not (l_col > 0) then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if:
						if not (globals_inst.enc_dbcs.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (globals_inst.ScreenLines[(globals_inst.LineOffset[l_row] + l_col.to_natural_32).to_integer_32]).to_integer_32 /= 0 then
							if (dbcs_screen_head_off (globals_inst.ScreenLines + (globals_inst.LineOffset[l_row]).to_integer_32, (globals_inst.ScreenLines + (globals_inst.LineOffset[l_row]).to_integer_32) + l_col)).to_boolean then
								Result := (l_col - 1)
								js.return
							else
								l_pos := -1 + 6 -- goto _L___0
							end
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L___0:
						if globals_inst.enc_utf8.to_boolean then
							if (globals_inst.ScreenLines[(globals_inst.LineOffset[l_row] + l_col.to_natural_32).to_integer_32]).to_integer_32 = 0 then
								Result := (l_col - 1)
								js.return
							end
						end
				when 7 then -- if done | if done | if done
						if not js.return_called then
							Result := l_col
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	enc_skip (a_p___0: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			js: JUMP_STATE
		do
			if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_p___0), ce_string ("2byte-"), (6).to_natural_32)) = 0 then
				Result := (a_p___0 + 6)
				js.return
			end
			if not js.return_called then
				if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_p___0), ce_string ("8bit-"), (5).to_natural_32)) = 0 then
					Result := (a_p___0 + 5)
					js.return
				end
			end
			if not js.return_called then
				Result := a_p___0
			end
		end

	enc_canonize (a_enc: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_r: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_r.make
			create l_p___0.make
			create l_s.make
			create l_tmp___2.make
			create l_tmp___3.make

			if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_enc), ce_string ("default"))) = 0 then
				l_r.ce_gets (option_inst.get_encoding_default)
				if (l_r.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_r.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("latin1")))
				end
				Result := (misc2_inst.vim_strsave (l_r))
				js.return
			end
			if not js.return_called then
				l_r.ce_gets (misc2_inst.alloc ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_enc))) + {NATURAL_32} 3))
				if (l_r.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					l_p___0.ce_gets (l_r)
					l_s.ce_gets (a_enc)
					from
					until
						(l_s.item).to_integer_32 = 0
					loop
						if (l_s.item).to_integer_32 = 95 then
							l_tmp___2.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_tmp___2.item := (('-').code).to_natural_8
						else
							l_tmp___3.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							if (l_s.item).to_integer_32 < 65 then
								l_tmp___3.item := l_s.item
							elseif (l_s.item).to_integer_32 > 90 then
								l_tmp___3.item := l_s.item
							else
								l_tmp___3.item := ((l_s.item).to_integer_32 + 32).to_natural_8
							end
						end
						l_s.ce_gets (l_s + 1)
					end
					l_p___0.item := (('%/0/').code).to_natural_8
					l_p___0.ce_gets (enc_skip (l_r))
					if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("microsoft-cp"), (12).to_natural_32)) = 0 then
						memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 10)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 10)))) + {NATURAL_32} 1).do_nothing
					end
					if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("iso8859"), (7).to_natural_32)) = 0 then
						memmove (create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 4)), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 3)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 3)))) + {NATURAL_32} 1).do_nothing
						l_p___0[3] := (('-').code).to_natural_8
					end
					if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("iso-8859"), (8).to_natural_32)) = 0 then
						if (l_p___0[8]).to_integer_32 /= 45 then
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 9)), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 8)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 8)))) + {NATURAL_32} 1).do_nothing
							l_p___0[8] := (('-').code).to_natural_8
						end
					end
					if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("latin-"), (6).to_natural_32)) = 0 then
						memmove (create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 5)), create {CE_POINTER [ANY]}.make_cast ((l_p___0 + 6)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p___0 + 6)))) + {NATURAL_32} 1).do_nothing
					end
					if (enc_canon_search (l_p___0)) >= 0 then
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (l_r.c_pointer.to_integer_32).to_natural_32 then
							memmove (create {CE_POINTER [ANY]}.make_cast (l_r), create {CE_POINTER [ANY]}.make_cast (l_p___0), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))) + {NATURAL_32} 1).do_nothing
						end
					else
						l_i___0 := enc_alias_search (l_p___0)
						if l_i___0 >= 0 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_r))
							l_r.ce_gets (misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (enc_canon_table[l_i___0].name)))
						end
					end
				end
				Result := l_r
			end
		end

	enc_alias_search (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (((enc_alias_table[l_i___0].name).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), enc_alias_table[l_i___0].name)) = 0 then
					Result := (enc_alias_table[l_i___0].canon)
					js.return
				end
				if not js.return_called then
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	enc_locale: CE_POINTER [NATURAL_8]
		local
			l_s: CE_POINTER [INTEGER_8]
			l_p___0: CE_POINTER [INTEGER_8]
			l_i___0: INTEGER_32
			l_buf___6: CE_ARRAY [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_p___0.make
			create l_buf___6.make (<<50>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s.ce_gets (nl_langinfo (14))
					if (l_s.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if (l_s[0]).to_integer_32 /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 4 then -- if: | _L___1:
						l_s.ce_gets (setlocale (0, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)))
						if (l_s.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L___0
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 7 then -- else:
						if (l_s[0]).to_integer_32 /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 8 then -- if: | _L___0:
						l_s.ce_gets (getenv (ce_string ("LC_ALL")))
						if (l_s.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if (l_s[0]).to_integer_32 /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L:
						l_s.ce_gets (getenv (ce_string ("LC_CTYPE")))
						if (l_s.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_s.ce_gets (getenv (ce_string ("LANG")))
						elseif (l_s[0]).to_integer_32 = 0 then
							l_s.ce_gets (getenv (ce_string ("LANG")))
						end
				when 13 then -- if done | if done | if done | if done | if done
						if (l_s.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						elseif (l_s[0]).to_integer_32 = 0 then
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called then
							l_p___0.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (l_s), ('.').code))))
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 > ((l_s + 2).c_pointer.to_integer_32).to_natural_32 then
									if (strncasecmp ((l_p___0 + 1), ce_string ("EUC"), (3).to_natural_32)) = 0 then
										if ((((ctype_b_loc).item[(l_p___0[4]).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
											l_s.ce_gets (l_p___0 + 1)
										elseif (l_p___0[4]).to_integer_32 /= 45 then
											if (l_p___0[-3]).to_integer_32 = 95 then
												strcpy ((l_buf___6 + 10), ce_string ("euc-")).do_nothing
												l_buf___6[14] := l_p___0[-2]
												l_buf___6[15] := l_p___0[-1]
												l_buf___6[16] := (0).to_integer_8
												l_s.ce_gets (l_buf___6 + 10)
											else
												l_s.ce_gets (l_p___0 + 1)
											end
										else
											l_s.ce_gets (l_p___0 + 1)
										end
									else
										l_s.ce_gets (l_p___0 + 1)
									end
								else
									l_s.ce_gets (l_p___0 + 1)
								end
							end
							l_i___0 := 0
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_s[l_i___0]).to_integer_32 /= 0 then
									if not (l_i___0 < (Integer_8_bytes.to_natural_32 * (50).to_natural_32).to_integer_32 - 1) then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									if (l_s[l_i___0]).to_integer_32 = 95 then
										l_buf___6[l_i___0] := (('-').code).to_integer_8
									elseif (l_s[l_i___0]).to_integer_32 = 45 then
										l_buf___6[l_i___0] := (('-').code).to_integer_8
									elseif ((((ctype_b_loc).item[(l_s[l_i___0]).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
										if (l_s[l_i___0]).to_integer_32 < 65 then
											l_buf___6[l_i___0] := l_s[l_i___0]
										elseif (l_s[l_i___0]).to_integer_32 > 90 then
											l_buf___6[l_i___0] := l_s[l_i___0]
										else
											l_buf___6[l_i___0] := ((l_s[l_i___0]).to_integer_32 + 32).to_integer_8
										end
									else
										js.break
									end
								end
								if not js.loop_jumped then
									l_i___0 := l_i___0 + 1
								end
							end
							js.reset
							l_buf___6[l_i___0] := (('%/0/').code).to_integer_8
							Result := (enc_canonize (create {CE_POINTER [NATURAL_8]}.make_cast (l_buf___6)))
						end
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	my_iconv_open (a_to: CE_POINTER [NATURAL_8]; a_from: CE_POINTER [NATURAL_8]): CE_POINTER [ANY]
		local
			l_fd: CE_POINTER [ANY]
			l_tobuf: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [INTEGER_8]
			l_tolen: NATURAL_32
			l_tmp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_fd.make
			create l_tobuf.make (<<400>>)
			create l_p___0.make
			create l_tmp.make

			if iconv_ok = 0 then
				Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer + -1))
				js.return
			end
			if not js.return_called then
				l_tmp.ce_gets (enc_skip (a_from))
				l_fd.ce_gets (iconv_open (create {CE_POINTER [INTEGER_8]}.make_cast ((enc_skip (a_to))), create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp)))
				if (l_fd.c_pointer.to_integer_32).to_natural_32 /= (-1).to_natural_32 then
					if iconv_ok = -1 then
						l_p___0.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (l_tobuf))
						l_tolen := (400).to_natural_32
						iconv (l_fd, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer), (l_p___0.address), (create {CE_POINTER [NATURAL_32]}.make_shared ($l_tolen))).do_nothing
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							iconv_ok := 0
							iconv_close (l_fd).do_nothing
							l_fd.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer + -1))
						else
							iconv_ok := 1
						end
					end
				end
				Result := l_fd
			end
		end

	iconv_string (a_vcp: CE_POINTER [PD_VIMCONV_T]; a_str___1: CE_POINTER [NATURAL_8]; a_slen: INTEGER_32; a_unconvlenp: CE_POINTER [INTEGER_32]; a_resultlenp: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		local
			l_from: CE_POINTER [INTEGER_8]
			l_fromlen: NATURAL_32
			l_to: CE_POINTER [INTEGER_8]
			l_tolen: NATURAL_32
			l_len: NATURAL_32
			l_done___2: NATURAL_32
			l_result___2: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_from.make
			create l_to.make
			create l_result___2.make
			create l_p___0.make
			create l_tmp___1.make
			create l_tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := (0).to_natural_32
					l_done___2 := (0).to_natural_32
					l_result___2.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					l_from.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (a_str___1))
					l_fromlen := a_slen.to_natural_32
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 28 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if l_len /= {NATURAL_32} 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if (errno_location).item /= 7 then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						l_len := (l_len + l_fromlen * {NATURAL_32} 2) + {NATURAL_32} 40
						l_p___0.ce_gets (misc2_inst.alloc (l_len))
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if l_done___2 > {NATURAL_32} 0 then
								memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast (l_result___2), l_done___2).do_nothing
							end
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_result___2))
						l_result___2.ce_gets (l_p___0)
						if (l_result___2.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						end
				when 7 then -- if done
						if not js.loop_jumped then
							l_to.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (l_result___2) + l_done___2.to_integer_32)
							l_tolen := (l_len - l_done___2) - {NATURAL_32} 2
							if (iconv (a_vcp.item.vc_fd, (l_from.address), (create {CE_POINTER [NATURAL_32]}.make_shared ($l_fromlen)), (l_to.address), (create {CE_POINTER [NATURAL_32]}.make_shared ($l_tolen)))) /= {NATURAL_32} 4294967295 then
								l_to[0] := (('%/0/').code).to_integer_8
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 27 -- skip if block
						end
				when 8 then -- if:
						if (a_vcp.item.vc_fail).to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if (a_unconvlenp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if (errno_location).item = 22 then
								l_to[0] := (('%/0/').code).to_integer_8
								a_unconvlenp.item := l_fromlen.to_integer_32
								js.break
							elseif (errno_location).item = 22 then
								l_to[0] := (('%/0/').code).to_integer_8
								a_unconvlenp.item := l_fromlen.to_integer_32
								js.break
							else
								l_pos := -1 + 11 -- goto _L___3
							end
						else
							l_pos := -1 + 11 -- goto _L___3
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 11 then -- else: | _L___3:
						if (a_vcp.item.vc_fail).to_boolean then
							l_pos := -1 + 26 -- skip if block
						end
				when 12 then -- if:
						if (errno_location).item /= 84 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 22 -- goto _L___1
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 15 then -- else:
						if (errno_location).item /= 84 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 22 -- goto _L___1
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 18 then -- else:
						if (errno_location).item /= 22 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 22 -- goto _L___1
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 21 then -- else:
						if (errno_location).item /= 22 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if: | _L___1:
						l_tmp___1.ce_gets (l_to)
						l_to.ce_gets (l_to + 1)
						l_tmp___1[0] := (('?').code).to_integer_8
						if (globals_inst.mb_ptr2cells.integer_32_item ([create {CE_POINTER [NATURAL_8]}.make_cast (l_from)])) > 1 then
							l_tmp___2.ce_gets (l_to)
							l_to.ce_gets (l_to + 1)
							l_tmp___2[0] := (('?').code).to_integer_8
						end
						if globals_inst.enc_utf8.to_boolean then
							l_l := utfc_ptr2len_len (create {CE_POINTER [NATURAL_8]}.make_cast (l_from), l_fromlen.to_integer_32)
						else
							l_l := globals_inst.mb_ptr2len.integer_32_item ([create {CE_POINTER [NATURAL_8]}.make_cast (l_from)])
							if l_l > l_fromlen.to_integer_32 then
								l_l := l_fromlen.to_integer_32
							end
						end
						l_from.ce_gets (l_from + l_l)
						l_fromlen := l_fromlen - l_l.to_natural_32
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:
						l_pos := -1 + 26 -- goto _L___0
				when 25 then -- if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else: | _L___0:
						if (errno_location).item /= 7 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_result___2))
							l_result___2.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.break
						end
				when 27 then -- if done | if done
						if not js.loop_jumped then
							l_done___2 := (l_to.distance ((create {CE_POINTER [INTEGER_8]}.make_cast (l_result___2)))).to_natural_32
						end
						l_pos := -1 + 1 -- back to loop condition
				when 28 then -- loop done
					js.reset
					if (a_resultlenp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						a_resultlenp.item := l_to.distance ((create {CE_POINTER [INTEGER_8]}.make_cast (l_result___2)))
					end
					Result := l_result___2
				when 29 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	init_preedit_start_col
		do
			if ((globals_inst.State).bit_and (8)).to_boolean then
				globals_inst.preedit_start_col := ex_getln_inst.cmdline_getvcol_cursor
			elseif (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				charset_inst.getvcol (globals_inst.curwin, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset), globals_inst.preedit_start_col_address, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
			end
			globals_inst.xim_changed_while_preediting := globals_inst.curbuf.item.b_changed
		end

	im_set_active (a_active: INTEGER_32)
		local
			l_was_active: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_was_active := (im_is_active.to_boolean).to_integer
			if a_active.to_boolean then
				if not option_inst.p_imdisable.to_boolean then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			im_is_active := l_tmp
			if im_is_active /= l_was_active then
				xim_reset
			end
		end

	xim_set_focus (a_focus: INTEGER_32)
		do
			if (globals_inst.xic.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if a_focus.to_boolean then
					gtk_im_context_focus_in (globals_inst.xic)
				else
					gtk_im_context_focus_out (globals_inst.xic)
				end
			end
		end

	im_set_position (a_row: INTEGER_32; a_col: INTEGER_32)
		local
			l_area: SD_GDKRECTANGLE
			l_tmp___0: INTEGER_32
		do
			create l_area.make

			if (globals_inst.xic.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_area.x := a_col * gui_inst.gui.char_width + gui_inst.gui.border_offset
				l_area.y := a_row * gui_inst.gui.char_height + gui_inst.gui.border_offset
				if (mb_lefthalve (a_row, a_col)).to_boolean then
					l_tmp___0 := 2
				else
					l_tmp___0 := 1
				end
				l_area.width := gui_inst.gui.char_width * l_tmp___0
				l_area.height := gui_inst.gui.char_height
				gtk_im_context_set_cursor_location (globals_inst.xic, (l_area.address))
			end
		end

	im_add_to_input (a_str___1: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_str___1: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			create l_str___1.make

			l_str___1.ce_gets (a_str___1)
			l_len := a_len
			if globals_inst.input_conv.vc_type /= 0 then
				l_str___1.ce_gets (string_convert (globals_inst.input_conv.address, l_str___1, create {CE_POINTER [INTEGER_32]}.make_shared ($l_len)))
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_str___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						g_return_if_fail_warning (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("im_add_to_input"), ce_string ("str != NULL"))
						js.return
					end
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				ui_inst.add_to_input_buf_csi (l_str___1, l_len)
				if globals_inst.input_conv.vc_type /= 0 then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_str___1))
				end
				if option_inst.p_mh.to_boolean then
					gui_gtk_x11_inst.gui_mch_mousehide (1)
				end
			end
		end

	im_delete_preedit
		local
			l_bskey: CE_ARRAY [NATURAL_8]
			l_delkey: CE_ARRAY [NATURAL_8]
			js: JUMP_STATE
		do
			create l_bskey.make (<<3>>)
			create l_delkey.make (<<3>>)

			l_bskey[0] := (155).to_natural_8
			l_bskey[1] := (('k').code).to_natural_8
			l_bskey[2] := (('b').code).to_natural_8
			l_delkey[0] := (155).to_natural_8
			l_delkey[1] := (('k').code).to_natural_8
			l_delkey[2] := (('D').code).to_natural_8
			if ((globals_inst.State).bit_and (1)).to_boolean then
				im_preedit_cursor := 0
				js.return
			end
			if not js.return_called then
				from
				until
					not (im_preedit_cursor > 0)
				loop
					ui_inst.add_to_input_buf (l_bskey, (Natural_8_bytes.to_natural_32 * (3).to_natural_32).to_integer_32)
					im_preedit_cursor := im_preedit_cursor - 1
				end
				from
				until
					not (im_preedit_trailing > 0)
				loop
					ui_inst.add_to_input_buf (l_delkey, (Natural_8_bytes.to_natural_32 * (3).to_natural_32).to_integer_32)
					im_preedit_trailing := im_preedit_trailing - 1
				end
			end
		end

	im_correct_cursor (a_num_move_back: INTEGER_32)
		local
			l_num_move_back: INTEGER_32
			l_backkey: CE_ARRAY [NATURAL_8]
			js: JUMP_STATE
		do
			create l_backkey.make (<<3>>)

			l_num_move_back := a_num_move_back
			l_backkey[0] := (155).to_natural_8
			l_backkey[1] := (('k').code).to_natural_8
			l_backkey[2] := (('l').code).to_natural_8
			if ((globals_inst.State).bit_and (1)).to_boolean then
				js.return
			end
			if not js.return_called then
				from
				until
					not (l_num_move_back > 0)
				loop
					ui_inst.add_to_input_buf (l_backkey, (Natural_8_bytes.to_natural_32 * (3).to_natural_32).to_integer_32)
					l_num_move_back := l_num_move_back - 1
				end
			end
		end

	im_show_info
		local
			l_old_vgetc_busy: INTEGER_32
		do
			l_old_vgetc_busy := globals_inst.vgetc_busy
			globals_inst.vgetc_busy := 1
			screen_inst.showmode.do_nothing
			globals_inst.vgetc_busy := l_old_vgetc_busy
			screen_inst.setcursor
			term_inst.out_flush
		end

	im_commit_cb (a_context: CE_POINTER [SD_GTKIMCONTEXT]; a_str___1: CE_POINTER [INTEGER_8]; a_data: CE_POINTER [ANY])
		local
			l_slen: INTEGER_32
			l_add_to_input: INTEGER_32
			l_clen: INTEGER_32
			l_len: INTEGER_32
			l_commit_with_preedit: INTEGER_32
			l_im_str: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_im_str.make

			l_slen := (strlen (a_str___1)).to_integer_32
			l_add_to_input := 1
			l_len := l_slen
			l_commit_with_preedit := 1
			im_delete_preedit
			if globals_inst.preedit_start_col.to_integer_32 = 2147483647 then
				init_preedit_start_col
				l_commit_with_preedit := 0
			end
			if globals_inst.input_conv.vc_type /= 0 then
				l_im_str.ce_gets (string_convert (globals_inst.input_conv.address, create {CE_POINTER [NATURAL_8]}.make_cast (a_str___1), create {CE_POINTER [INTEGER_32]}.make_shared ($l_len)))
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_im_str.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						g_return_if_fail_warning (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("im_commit_cb"), ce_string ("im_str != NULL"))
						js.return
					end
					if not js.return_called then
						js.break
					end
				end
				js.reset
			else
				l_im_str.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (a_str___1))
			end
			if not js.return_called then
				l_clen := mb_string2cells (l_im_str, l_len)
				if globals_inst.input_conv.vc_type /= 0 then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_im_str))
				end
				globals_inst.preedit_start_col := globals_inst.preedit_start_col + l_clen
				if xim_expected_char /= 0 then
					if l_slen = 1 then
						if (a_str___1[0]).to_integer_32 = xim_expected_char then
							xim_ignored_char := 1
							l_add_to_input := 0
						else
							xim_ignored_char := 0
						end
					else
						xim_ignored_char := 0
					end
				end
				if l_add_to_input.to_boolean then
					im_add_to_input (create {CE_POINTER [NATURAL_8]}.make_cast (a_str___1), l_slen)
				end
				if not l_commit_with_preedit.to_boolean then
					globals_inst.preedit_start_col := (2147483647).to_integer_32
				end
				globals_inst.xim_changed_while_preediting := 1
				if (gtk_main_level) > {NATURAL_32} 0 then
					gtk_main_quit
				end
			end
		end

	im_commit_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent im_commit_cb)
		end

	im_preedit_start_cb (a_context: CE_POINTER [SD_GTKIMCONTEXT]; a_data: CE_POINTER [ANY])
		do
			im_is_active := 1
			preedit_is_active := 1
			gui_inst.gui_update_cursor (1, 0)
			im_show_info
		end

	im_preedit_start_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent im_preedit_start_cb)
		end

	im_preedit_end_cb (a_context: CE_POINTER [SD_GTKIMCONTEXT]; a_data: CE_POINTER [ANY])
		do
			im_delete_preedit
			globals_inst.preedit_start_col := (2147483647).to_integer_32
			xim_has_preediting := 0
			preedit_is_active := 0
			gui_inst.gui_update_cursor (1, 0)
			im_show_info
		end

	im_preedit_end_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent im_preedit_end_cb)
		end

	im_preedit_changed_cb (a_context: CE_POINTER [SD_GTKIMCONTEXT]; a_data: CE_POINTER [ANY])
		local
			l_preedit_string: CE_POINTER [INTEGER_8]
			l_cursor_index: INTEGER_32
			l_num_move_back: INTEGER_32
			l_str___1: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_is_composing: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_preedit_string.make
			create l_str___1.make
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_preedit_string.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					l_cursor_index := 0
					l_num_move_back := 0
					gtk_im_context_get_preedit_string (a_context, l_preedit_string.address, create {CE_POINTER [CE_POINTER [ANY]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_cursor_index))
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_preedit_string.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							g_return_if_fail_warning (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("im_preedit_changed_cb"), ce_string ("preedit_string != NULL"))
							js.return
						end
						if not js.return_called then
							js.break
						end
					end
					js.reset
					if js.return_called then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						if globals_inst.preedit_start_col.to_integer_32 /= 2147483647 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (l_preedit_string[0]).to_integer_32 /= 0 then
							xim_has_preediting := 1
							init_preedit_start_col
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_cursor_index = 0 then
							if (l_preedit_string[0]).to_integer_32 = 0 then
								xim_has_preediting := 0
								globals_inst.preedit_start_col := (2147483647).to_integer_32
							end
						end
				when 5 then
						im_delete_preedit
						if globals_inst.preedit_start_col.to_integer_32 /= 2147483647 then
							globals_inst.preedit_end_col := globals_inst.preedit_start_col
						end
						l_str___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (l_preedit_string))
						l_p___0.ce_gets (l_str___1)
						l_i___0 := 0
				when 6 then -- loop condition:
						if (l_p___0.item).to_integer_32 = 0 then
							l_pos := -1 + 13 -- skip loop
						end
				when 7 then -- loop body:
						if (((l_p___0.item).to_integer_32).bit_and (128)) /= 0 then
							if (utf_iscomposing ((utf_ptr2char (l_p___0)))).to_boolean then
								l_tmp___2 := 1
							else
								l_tmp___2 := 0
							end
						else
							l_tmp___2 := 0
						end
						l_is_composing := l_tmp___2
						if l_is_composing.to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L___0
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else:
						if not (option_inst.p_deco.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L___0:
						if l_i___0 < l_cursor_index then
							im_preedit_cursor := im_preedit_cursor + 1
						else
							im_preedit_trailing := im_preedit_trailing + 1
						end
				when 12 then -- if done
						if not l_is_composing.to_boolean then
							if l_i___0 >= l_cursor_index then
								l_num_move_back := l_num_move_back + 1
							end
						end
						if globals_inst.preedit_start_col.to_integer_32 /= 2147483647 then
							globals_inst.preedit_end_col := globals_inst.preedit_end_col + (utf_ptr2cells (l_p___0))
						end
						l_p___0.ce_gets (l_p___0 + (utf_byte2len ((l_p___0.item).to_integer_32)))
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 6 -- back to loop condition
				when 13 then -- loop done
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_str___1.c_pointer.to_integer_32).to_natural_32 then
							im_add_to_input (l_str___1, l_p___0.distance (l_str___1))
							im_correct_cursor (l_num_move_back)
						end
						g_free (create {CE_POINTER [ANY]}.make_cast (l_preedit_string))
						if (gtk_main_level) > {NATURAL_32} 0 then
							gtk_main_quit
						end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	im_preedit_changed_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent im_preedit_changed_cb)
		end

	translate_pango_attributes (a_iter: CE_POINTER [ANY]): INTEGER_32
		local
			l_attr: CE_POINTER [SD_PANGOATTRIBUTE]
			l_char_attr: INTEGER_32
			l_color: CE_POINTER [SD_PANGOCOLOR]
		do
			create l_attr.make
			create l_color.make

			l_char_attr := 0
			l_attr.ce_gets (pango_attr_iterator_get (a_iter, {SC_PANGOATTRTYPE}.PANGO_ATTR_UNDERLINE))
			if (l_attr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (create {CE_POINTER [SD_PANGOATTRINT]}.make_cast (l_attr)).item.value /= 0 then
					l_char_attr := (l_char_attr).bit_or ((8))
				end
			end
			l_attr.ce_gets (pango_attr_iterator_get (a_iter, {SC_PANGOATTRTYPE}.PANGO_ATTR_WEIGHT))
			if (l_attr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (create {CE_POINTER [SD_PANGOATTRINT]}.make_cast (l_attr)).item.value >= 700 then
					l_char_attr := (l_char_attr).bit_or ((2))
				end
			end
			l_attr.ce_gets (pango_attr_iterator_get (a_iter, {SC_PANGOATTRTYPE}.PANGO_ATTR_STYLE))
			if (l_attr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (create {CE_POINTER [SD_PANGOATTRINT]}.make_cast (l_attr)).item.value /= 0 then
					l_char_attr := (l_char_attr).bit_or ((4))
				end
			end
			l_attr.ce_gets (pango_attr_iterator_get (a_iter, {SC_PANGOATTRTYPE}.PANGO_ATTR_BACKGROUND))
			if (l_attr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_color.ce_gets ((create {CE_POINTER [SD_PANGOCOLOR]}.make_shared ((create {CE_POINTER [SD_PANGOATTRCOLOR]}.make_cast (l_attr)).c_pointer + {SD_PANGOATTRCOLOR}.color_offset)))
				if (((((l_color.item.red).to_integer_32).bit_or ((l_color.item.green).to_integer_32))).bit_or ((l_color.item.blue).to_integer_32)) = 0 then
					l_char_attr := (l_char_attr).bit_or ((1))
				end
			end
			Result := l_char_attr
		end

	im_get_feedback_attr (a_col: INTEGER_32): INTEGER_32
		local
			l_col: INTEGER_32
			l_preedit_string: CE_POINTER [INTEGER_8]
			l_attr_list: CE_POINTER [ANY]
			l_char_attr: INTEGER_32
			l_idx: INTEGER_32
			l_iter: CE_POINTER [ANY]
			l_start___1: INTEGER_32
			l_end: INTEGER_32
			js: JUMP_STATE
		do
			create l_preedit_string.make
			create l_attr_list.make
			create l_iter.make

			l_col := a_col
			l_preedit_string.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
			l_attr_list.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer))
			l_char_attr := -1
			if (globals_inst.xic.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := l_char_attr
				js.return
			end
			if not js.return_called then
				gtk_im_context_get_preedit_string (globals_inst.xic, l_preedit_string.address, l_attr_list.address, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
				if (l_preedit_string.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if (l_attr_list.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_idx := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if l_col > 0 then
								if (l_preedit_string[l_idx]).to_integer_32 = 0 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_idx := l_idx + (utfc_ptr2len (create {CE_POINTER [NATURAL_8]}.make_cast (l_preedit_string) + l_idx))
								l_col := l_col - 1
							end
						end
						js.reset
						if (l_preedit_string[l_idx]).to_integer_32 /= 0 then
							l_char_attr := 0
							l_iter.ce_gets (pango_attr_list_get_iterator (l_attr_list))
							from
							until
								js.loop_left
							loop
								js.reset
								pango_attr_iterator_range (l_iter, create {CE_POINTER [INTEGER_32]}.make_shared ($l_start___1), create {CE_POINTER [INTEGER_32]}.make_shared ($l_end))
								if l_idx >= l_start___1 then
									if l_idx < l_end then
										l_char_attr := (l_char_attr).bit_or ((translate_pango_attributes (l_iter)))
									end
								end
								if not (pango_attr_iterator_next (l_iter)).to_boolean then
									js.break
								end
							end
							js.reset
							pango_attr_iterator_destroy (l_iter)
						end
					end
				end
				if (l_attr_list.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					pango_attr_list_unref (l_attr_list)
				end
				g_free (create {CE_POINTER [ANY]}.make_cast (l_preedit_string))
				Result := l_char_attr
			end
		end

	xim_init
		local
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				if ((gui_inst.gui.drawarea).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					g_return_if_fail_warning (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("xim_init"), ce_string ("gui.drawarea != NULL"))
					js.return
				end
				if not js.return_called then
					js.break
				end
			end
			js.reset
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					if (((gui_inst.gui.drawarea).item.window).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						g_return_if_fail_warning (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("xim_init"), ce_string ("gui.drawarea->window != NULL"))
						js.return
					end
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				globals_inst.xic.ce_gets (gtk_im_multicontext_new)
				g_object_ref (create {CE_POINTER [ANY]}.make_cast (globals_inst.xic)).do_nothing
				im_commit_handler_id := g_signal_connect_data (create {CE_POINTER [ANY]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (globals_inst.xic), ((20).bit_shift_left (2)).to_natural_32))), ce_string ("commit"), (im_commit_cb_address), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0)
				g_signal_connect_data (create {CE_POINTER [ANY]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (globals_inst.xic), ((20).bit_shift_left (2)).to_natural_32))), ce_string ("preedit_changed"), (im_preedit_changed_cb_address), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0).do_nothing
				g_signal_connect_data (create {CE_POINTER [ANY]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (globals_inst.xic), ((20).bit_shift_left (2)).to_natural_32))), ce_string ("preedit_start"), (im_preedit_start_cb_address), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0).do_nothing
				g_signal_connect_data (create {CE_POINTER [ANY]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (globals_inst.xic), ((20).bit_shift_left (2)).to_natural_32))), ce_string ("preedit_end"), (im_preedit_end_cb_address), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0).do_nothing
				gtk_im_context_set_client_window (globals_inst.xic, (gui_inst.gui.drawarea).item.window)
			end
		end

	im_shutdown
		do
			if (globals_inst.xic.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				gtk_im_context_focus_out (globals_inst.xic)
				g_object_unref (create {CE_POINTER [ANY]}.make_cast (globals_inst.xic))
				globals_inst.xic.ce_gets (create {CE_POINTER [SD_GTKIMCONTEXT]}.make_shared (default_pointer))
			end
			im_is_active := 0
			im_commit_handler_id := {NATURAL_32} 0
			globals_inst.preedit_start_col := (2147483647).to_integer_32
			xim_has_preediting := 0
		end

	im_string_to_keyval (a_str___1: CE_POINTER [INTEGER_8]; a_keyval: CE_POINTER [NATURAL_32]; a_state: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_str___1: CE_POINTER [INTEGER_8]
			l_mods_end: CE_POINTER [INTEGER_8]
			l_tmp_keyval: NATURAL_32
			l_tmp_state: NATURAL_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_str___1.make
			create l_mods_end.make
			create l_tmp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_str___1.ce_gets (a_str___1)
					l_tmp_state := {NATURAL_32} 0
					l_mods_end.ce_gets ((strrchr (l_str___1, ('-').code)))
					if (l_mods_end.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						l_mods_end.ce_gets (l_mods_end + 1)
					else
						l_mods_end.ce_gets (l_str___1)
					end
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_str___1.c_pointer.to_integer_32).to_natural_32 < (l_mods_end.c_pointer.to_integer_32).to_natural_32)) then
						l_pos := -1 + 14 -- skip loop
					end
				when 2 then -- loop body:
						l_tmp___0.ce_gets (l_str___1)
						l_str___1.ce_gets (l_str___1 + 1)
						inspect (l_tmp___0[0]).to_integer_32 -- switch 1 head
						when 45 then l_pos := -1 + 3
						when 83 then l_pos := -1 + 4
						when 115 then l_pos := -1 + 4
						when 76 then l_pos := -1 + 5
						when 108 then l_pos := -1 + 5
						when 67 then l_pos := -1 + 6
						when 99 then l_pos := -1 + 6
						when 49 then l_pos := -1 + 7
						when 50 then l_pos := -1 + 8
						when 51 then l_pos := -1 + 9
						when 52 then l_pos := -1 + 10
						when 53 then l_pos := -1 + 11
						else l_pos := -1 + 12
						end
				when 3 then -- switch 1, case 45
						l_pos := -1 + 13 -- switch 1; break
				when 4 then -- switch 1, case 83 | switch 1, case 115
						l_tmp_state := (l_tmp_state).bit_or (({NATURAL_32} 1))
						l_pos := -1 + 13 -- switch 1; break
				when 5 then -- switch 1, case 76 | switch 1, case 108
						l_tmp_state := (l_tmp_state).bit_or (({NATURAL_32} 2))
						l_pos := -1 + 13 -- switch 1; break
				when 6 then -- switch 1, case 67 | switch 1, case 99
						l_tmp_state := (l_tmp_state).bit_or (({NATURAL_32} 4))
						l_pos := -1 + 13 -- switch 1; break
				when 7 then -- switch 1, case 49
						l_tmp_state := (l_tmp_state).bit_or (({NATURAL_32} 8))
						l_pos := -1 + 13 -- switch 1; break
				when 8 then -- switch 1, case 50
						l_tmp_state := (l_tmp_state).bit_or (({NATURAL_32} 16))
						l_pos := -1 + 13 -- switch 1; break
				when 9 then -- switch 1, case 51
						l_tmp_state := (l_tmp_state).bit_or (({NATURAL_32} 32))
						l_pos := -1 + 13 -- switch 1; break
				when 10 then -- switch 1, case 52
						l_tmp_state := (l_tmp_state).bit_or (({NATURAL_32} 64))
						l_pos := -1 + 13 -- switch 1; break
				when 11 then -- switch 1, case 53
						l_tmp_state := (l_tmp_state).bit_or (({NATURAL_32} 128))
						l_pos := -1 + 13 -- switch 1; break
				when 12 then -- switch 1, default:
						Result := 0
						js.return
				when 13 then -- switch 1, done:
						l_pos := -1 + 1 -- back to loop condition
				when 14 then -- loop done
					if not js.return_called then
						l_tmp_keyval := gdk_keyval_from_name (l_str___1)
						if l_tmp_keyval = {NATURAL_32} 0 then
							Result := 0
							js.return
						elseif l_tmp_keyval = {NATURAL_32} 16777215 then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						if (a_keyval.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							a_keyval.item := l_tmp_keyval
						end
						if (a_state.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							a_state.item := l_tmp_state
						end
						Result := 1
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	im_xim_isvalid_imactivate: INTEGER_32
		local
			js: JUMP_STATE
		do
			if (option_inst.p_imak[0]).to_integer_32 = 0 then
				Current.im_activatekey_keyval := {NATURAL_32} 16777215
				Current.im_activatekey_state := {NATURAL_32} 0
				Result := 1
				js.return
			end
			if not js.return_called then
				Result := (im_string_to_keyval (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_imak), im_activatekey_keyval_address, im_activatekey_state_address))
			end
		end

	im_synthesize_keypress (a_keyval: NATURAL_32; a_state: NATURAL_32)
		local
			l_event: CE_POINTER [SD_GDKEVENTKEY]
		do
			create l_event.make

			l_event.ce_gets (create {CE_POINTER [SD_GDKEVENTKEY]}.make_cast ((gdk_event_new ({SC_GDKEVENTTYPE}.GDK_KEY_PRESS))))
			g_object_ref (create {CE_POINTER [ANY]}.make_cast ((gui_inst.gui.drawarea).item.window)).do_nothing
			l_event.item.window := (gui_inst.gui.drawarea).item.window
			l_event.item.send_event := (1).to_integer_8
			l_event.item.time := (0).to_natural_32
			l_event.item.state := a_state
			l_event.item.keyval := a_keyval
			l_event.item.hardware_keycode := (XKeysymToKeycode ((gdk_x11_drawable_get_xdisplay ((gdk_x11_window_get_drawable_impl (l_event.item.window)))), a_keyval.to_natural_32)).to_natural_16
			l_event.item.length := 0
			l_event.item.string := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			gtk_im_context_filter_keypress (globals_inst.xic, l_event).do_nothing
			l_event.item.type := {SC_GDKEVENTTYPE}.GDK_KEY_RELEASE
			l_event.item.send_event := (0).to_integer_8
			gtk_im_context_filter_keypress (globals_inst.xic, l_event).do_nothing
			gdk_event_free (create {CE_POINTER [SD_GDKEVENT]}.make_cast (l_event))
		end

	xim_reset
		do
			if (globals_inst.xic.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if im_activatekey_keyval /= {NATURAL_32} 16777215 then
					if im_is_active.to_boolean then
						im_synthesize_keypress ({NATURAL_32} 65307, {NATURAL_32} 0)
					end
				end
				gtk_im_context_reset (globals_inst.xic)
				gtk_im_context_set_use_preedit (globals_inst.xic, 0)
				if option_inst.p_imdisable.to_boolean then
					im_shutdown
				else
					gtk_im_context_set_use_preedit (globals_inst.xic, 1)
					xim_set_focus (gui_inst.gui.in_focus)
					if im_activatekey_keyval /= {NATURAL_32} 16777215 then
						if im_is_active.to_boolean then
							g_signal_handler_block (create {CE_POINTER [ANY]}.make_cast (globals_inst.xic), im_commit_handler_id)
							im_synthesize_keypress (im_activatekey_keyval, im_activatekey_state)
							g_signal_handler_unblock (create {CE_POINTER [ANY]}.make_cast (globals_inst.xic), im_commit_handler_id)
						end
					else
						im_shutdown
						xim_init
						xim_set_focus (gui_inst.gui.in_focus)
					end
				end
			end
			globals_inst.preedit_start_col := (2147483647).to_integer_32
			xim_has_preediting := 0
		end

	xim_queue_key_press_event (a_event: CE_POINTER [SD_GDKEVENTKEY]; a_down: INTEGER_32): INTEGER_32
		local
			l_state_mask: NATURAL_32
			l_imresult: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_down.to_boolean) then
						l_pos := -1 + 21 -- skip if block
					end
				when 1 then -- if:
						inspect (a_event.item.keyval).to_integer_32 -- switch 1 head
						when 65451 then l_pos := -1 + 2
						when 65453 then l_pos := -1 + 3
						when 65455 then l_pos := -1 + 4
						when 65450 then l_pos := -1 + 5
						when 65454 then l_pos := -1 + 6
						when 65469 then l_pos := -1 + 7
						when 65456 then l_pos := -1 + 8
						when 65457 then l_pos := -1 + 9
						when 65458 then l_pos := -1 + 10
						when 65459 then l_pos := -1 + 11
						when 65460 then l_pos := -1 + 12
						when 65461 then l_pos := -1 + 13
						when 65462 then l_pos := -1 + 14
						when 65463 then l_pos := -1 + 15
						when 65464 then l_pos := -1 + 16
						when 65465 then l_pos := -1 + 17
						when 32 then l_pos := -1 + 18
						else l_pos := -1 + 19
						end
				when 2 then -- switch 1, case 65451
						xim_expected_char := ('+').code
						l_pos := -1 + 20 -- switch 1; break
				when 3 then -- switch 1, case 65453
						xim_expected_char := ('-').code
						l_pos := -1 + 20 -- switch 1; break
				when 4 then -- switch 1, case 65455
						xim_expected_char := ('/').code
						l_pos := -1 + 20 -- switch 1; break
				when 5 then -- switch 1, case 65450
						xim_expected_char := ('*').code
						l_pos := -1 + 20 -- switch 1; break
				when 6 then -- switch 1, case 65454
						xim_expected_char := ('.').code
						l_pos := -1 + 20 -- switch 1; break
				when 7 then -- switch 1, case 65469
						xim_expected_char := ('=').code
						l_pos := -1 + 20 -- switch 1; break
				when 8 then -- switch 1, case 65456
						xim_expected_char := ('0').code
						l_pos := -1 + 20 -- switch 1; break
				when 9 then -- switch 1, case 65457
						xim_expected_char := ('1').code
						l_pos := -1 + 20 -- switch 1; break
				when 10 then -- switch 1, case 65458
						xim_expected_char := ('2').code
						l_pos := -1 + 20 -- switch 1; break
				when 11 then -- switch 1, case 65459
						xim_expected_char := ('3').code
						l_pos := -1 + 20 -- switch 1; break
				when 12 then -- switch 1, case 65460
						xim_expected_char := ('4').code
						l_pos := -1 + 20 -- switch 1; break
				when 13 then -- switch 1, case 65461
						xim_expected_char := ('5').code
						l_pos := -1 + 20 -- switch 1; break
				when 14 then -- switch 1, case 65462
						xim_expected_char := ('6').code
						l_pos := -1 + 20 -- switch 1; break
				when 15 then -- switch 1, case 65463
						xim_expected_char := ('7').code
						l_pos := -1 + 20 -- switch 1; break
				when 16 then -- switch 1, case 65464
						xim_expected_char := ('8').code
						l_pos := -1 + 20 -- switch 1; break
				when 17 then -- switch 1, case 65465
						xim_expected_char := ('9').code
						l_pos := -1 + 20 -- switch 1; break
				when 18 then -- switch 1, case 32
						xim_expected_char := (' ').code
						l_pos := -1 + 20 -- switch 1; break
				when 19 then -- switch 1, default:
						xim_expected_char := ('%/0/').code
				when 20 then -- switch 1, done:
						xim_ignored_char := 0
				when 21 then -- if done
					if (globals_inst.xic.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_pos := -1 + 30 -- skip if block
					end
				when 22 then -- if:
						if option_inst.p_imdisable.to_boolean then
							l_pos := -1 + 30 -- skip if block
						end
				when 23 then -- if:
						if ((globals_inst.State).bit_and (1561)) = 0 then
							l_pos := -1 + 30 -- skip if block
						end
				when 24 then -- if:
						if a_event.item.keyval = im_activatekey_keyval then
							if ((a_event.item.state).bit_and (im_activatekey_state)) = im_activatekey_state then
								l_state_mask := im_activatekey_state
								l_state_mask := (l_state_mask).bit_or (({NATURAL_32} 13))
								if ((a_event.item.state).bit_and (l_state_mask)) /= im_activatekey_state then
									Result := 0
									js.return
								end
								if not js.return_called and then (a_event.item.type /= 8) then
									Result := 1
									js.return
								end
								if not js.return_called then
									if (getchar_inst.map_to_exists_mode (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 32, 0)).to_boolean then
										im_set_active (0)
										globals_inst.State := (globals_inst.State).bit_xor ((32))
										if ((globals_inst.State).bit_and (32)).to_boolean then
											globals_inst.curbuf.item.b_p_iminsert := 0
											globals_inst.State := (globals_inst.State).bit_and ((-33))
										else
											globals_inst.curbuf.item.b_p_iminsert := 1
											globals_inst.State := (globals_inst.State).bit_or ((32))
										end
										Result := 1
										js.return
									end
								end
								if not js.return_called then
									Result := (gtk_im_context_filter_keypress (globals_inst.xic, a_event))
									js.return
								end
							end
						end
						if js.return_called then
							l_pos := -1 + 30 -- skip if block
						end
				when 25 then -- if:
						if im_activatekey_keyval /= {NATURAL_32} 16777215 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_pos := -1 + 29 -- goto _L
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 28 then -- else:
						if not (im_is_active.to_boolean) then
							l_pos := -1 + 30 -- skip if block
						end
				when 29 then -- if: | _L:
						l_imresult := (gtk_im_context_filter_keypress (globals_inst.xic, a_event))
						if not l_imresult.to_boolean then
							if globals_inst.preedit_start_col.to_integer_32 /= 2147483647 then
								if a_event.item.keyval = {NATURAL_32} 65293 then
									im_synthesize_keypress ({NATURAL_32} 65293, {NATURAL_32} 0)
									Result := 0
									js.return
								end
							end
						end
						if not js.return_called and then (xim_expected_char /= 0) then
							if xim_ignored_char.to_boolean then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							Result := l_imresult
							js.return
						end
				when 30 then -- if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 31 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	im_get_status: INTEGER_32
		do
			Result := im_is_active
		end

	preedit_get_status: INTEGER_32
		do
			Result := preedit_is_active
		end

	im_is_preediting: INTEGER_32
		do
			Result := xim_has_preediting
		end

	convert_setup (a_vcp: CE_POINTER [PD_VIMCONV_T]; a_from: CE_POINTER [NATURAL_8]; a_to: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := (convert_setup_ext (a_vcp, a_from, 1, a_to, 1))
		end

	convert_setup_ext (a_vcp: CE_POINTER [PD_VIMCONV_T]; a_from: CE_POINTER [NATURAL_8]; a_from_unicode_is_utf8: INTEGER_32; a_to: CE_POINTER [NATURAL_8]; a_to_unicode_is_utf8: INTEGER_32): INTEGER_32
		local
			l_from_prop: INTEGER_32
			l_to_prop: INTEGER_32
			l_from_is_utf8: INTEGER_32
			l_to_is_utf8: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tmp___0.make
			create l_tmp___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_vcp.item.vc_type = 5 then
						if ((a_vcp.item.vc_fd).c_pointer.to_integer_32).to_natural_32 /= (-1).to_natural_32 then
							iconv_close (a_vcp.item.vc_fd).do_nothing
						end
					end
					a_vcp.item.vc_type := 0
					a_vcp.item.vc_factor := 1
					a_vcp.item.vc_fail := 0
					if (a_from.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := 1
						js.return
					elseif (a_from.item).to_integer_32 = 0 then
						Result := 1
						js.return
					elseif (a_to.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						Result := 1
						js.return
					elseif (a_to.item).to_integer_32 = 0 then
						Result := 1
						js.return
					elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_from), create {CE_POINTER [INTEGER_8]}.make_cast (a_to))) = 0 then
						Result := 1
						js.return
					end
					if js.return_called then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						l_from_prop := enc_canon_props (a_from)
						l_to_prop := enc_canon_props (a_to)
						if a_from_unicode_is_utf8.to_boolean then
							l_from_is_utf8 := (l_from_prop).bit_and (4)
						else
							l_from_is_utf8 := (l_from_prop = 4).to_integer
						end
						if a_to_unicode_is_utf8.to_boolean then
							l_to_is_utf8 := (l_to_prop).bit_and (4)
						else
							l_to_is_utf8 := (l_to_prop = 4).to_integer
						end
						if not (((l_from_prop).bit_and (512)).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_to_is_utf8.to_boolean then
							a_vcp.item.vc_type := 1
							a_vcp.item.vc_factor := 2
						else
							l_pos := -1 + 4 -- goto _L___2
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 4 then -- else: | _L___2:
						if not (((l_from_prop).bit_and (1024)).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_to_is_utf8.to_boolean then
							a_vcp.item.vc_type := 2
							a_vcp.item.vc_factor := 3
						else
							l_pos := -1 + 7 -- goto _L___1
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 7 then -- else: | _L___1:
						if not (l_from_is_utf8.to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if ((l_to_prop).bit_and (512)).to_boolean then
							a_vcp.item.vc_type := 3
						else
							l_pos := -1 + 10 -- goto _L___0
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else: | _L___0:
						if not (l_from_is_utf8.to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if ((l_to_prop).bit_and (1024)).to_boolean then
							a_vcp.item.vc_type := 4
						else
							l_pos := -1 + 13 -- goto _L
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L:
						if l_from_is_utf8.to_boolean then
							l_tmp___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("utf-8")))
						else
							l_tmp___0.ce_gets (a_from)
						end
						if l_to_is_utf8.to_boolean then
							l_tmp___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("utf-8")))
						else
							l_tmp___1.ce_gets (a_to)
						end
						a_vcp.item.vc_fd := (my_iconv_open (l_tmp___1, l_tmp___0))
						if ((a_vcp.item.vc_fd).c_pointer.to_integer_32).to_natural_32 /= (-1).to_natural_32 then
							a_vcp.item.vc_type := 5
							a_vcp.item.vc_factor := 4
						end
				when 14 then -- if done | if done | if done
						if a_vcp.item.vc_type = 0 then
							Result := 0
							js.return
						end
				when 15 then -- if done
					if not js.return_called then
						Result := 1
					end
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	convert_input (a_ptr: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_maxlen: INTEGER_32): INTEGER_32
		do
			Result := (convert_input_safe (a_ptr, a_len, a_maxlen, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
		end

	convert_input_safe (a_ptr: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_maxlen: INTEGER_32; a_restp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_restlenp: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_d: CE_POINTER [NATURAL_8]
			l_dlen: INTEGER_32
			l_unconvertlen: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_32]
		do
			create l_d.make
			create l_tmp.make

			l_dlen := a_len
			l_unconvertlen := 0
			if (a_restp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_tmp.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
			else
				l_tmp.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared ($l_unconvertlen))
			end
			l_d.ce_gets (string_convert_ext (globals_inst.input_conv.address, a_ptr, create {CE_POINTER [INTEGER_32]}.make_shared ($l_dlen), l_tmp))
			if (l_d.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if l_dlen <= a_maxlen then
					if l_unconvertlen > 0 then
						a_restp.item := misc2_inst.alloc (l_unconvertlen.to_natural_32)
						if ((a_restp.item).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							memmove (create {CE_POINTER [ANY]}.make_cast (a_restp.item), create {CE_POINTER [ANY]}.make_cast (((a_ptr + a_len) - l_unconvertlen)), l_unconvertlen.to_natural_32).do_nothing
						end
						a_restlenp.item := l_unconvertlen
					end
					memmove (create {CE_POINTER [ANY]}.make_cast (a_ptr), create {CE_POINTER [ANY]}.make_cast (l_d), l_dlen.to_natural_32).do_nothing
				else
					l_dlen := a_len
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_d))
			end
			Result := l_dlen
		end

	string_convert (a_vcp: CE_POINTER [PD_VIMCONV_T]; a_ptr: CE_POINTER [NATURAL_8]; a_lenp: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		do
			Result := (string_convert_ext (a_vcp, a_ptr, a_lenp, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)))
		end

	string_convert_ext (a_vcp: CE_POINTER [PD_VIMCONV_T]; a_ptr: CE_POINTER [NATURAL_8]; a_lenp: CE_POINTER [INTEGER_32]; a_unconvlenp: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		local
			l_retval: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			l_l: INTEGER_32
			l_c: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_l_w: INTEGER_32
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_retval.make
			create l_d.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___7.make
			create l_tmp___8.make
			create l_tmp___9.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_retval.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					if (a_lenp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_ptr))).to_integer_32
					else
						l_len := a_lenp.item
					end
					if l_len = 0 then
						Result := (misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 42 -- skip if block
					end
				when 1 then -- if:
						inspect a_vcp.item.vc_type -- switch 1 head
						when 1 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 4
						when 3 then l_pos := -1 + 18
						when 4 then l_pos := -1 + 18
						when 5 then l_pos := -1 + 41
						else l_pos := -1 + 42
						end
				when 2 then -- switch 1, case 1
						l_retval.ce_gets (misc2_inst.alloc ((l_len * 2 + 1).to_natural_32))
						if (l_retval.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 42 -- switch 1; break
						end
				when 3 then
						l_d.ce_gets (l_retval)
						l_i___0 := 0
						from
						until
							not (l_i___0 < l_len)
						loop
							l_c := (a_ptr[l_i___0]).to_integer_32
							if l_c < 128 then
								l_tmp___1.ce_gets (l_d)
								l_d.ce_gets (l_d + 1)
								l_tmp___1.item := l_c.to_natural_8
							else
								l_tmp___2.ce_gets (l_d)
								l_d.ce_gets (l_d + 1)
								l_tmp___2.item := ({NATURAL_32} 192 + ((l_c.to_natural_32).bit_shift_right (6))).to_natural_8
								l_tmp___3.ce_gets (l_d)
								l_d.ce_gets (l_d + 1)
								l_tmp___3.item := (128 + ((l_c).bit_and (63))).to_natural_8
							end
							l_i___0 := l_i___0 + 1
						end
						l_d.item := (('%/0/').code).to_natural_8
						if (a_lenp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							a_lenp.item := l_d.distance (l_retval)
						end
						l_pos := -1 + 42 -- switch 1; break
				when 4 then -- switch 1, case 2
						l_retval.ce_gets (misc2_inst.alloc ((l_len * 3 + 1).to_natural_32))
						if (l_retval.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 42 -- switch 1; break
						end
				when 5 then
						l_d.ce_gets (l_retval)
						l_i___0 := 0
				when 6 then -- loop condition:
						if not (l_i___0 < l_len) then
							l_pos := -1 + 17 -- skip loop
						end
				when 7 then -- loop body:
						l_c := (a_ptr[l_i___0]).to_integer_32
						inspect l_c -- switch 2 head
						when 164 then l_pos := -1 + 8
						when 166 then l_pos := -1 + 9
						when 168 then l_pos := -1 + 10
						when 180 then l_pos := -1 + 11
						when 184 then l_pos := -1 + 12
						when 188 then l_pos := -1 + 13
						when 189 then l_pos := -1 + 14
						when 190 then l_pos := -1 + 15
						else l_pos := -1 + 16
						end
				when 8 then -- switch 2, case 164
						l_c := 8364
						l_pos := -1 + 16 -- switch 2; break
				when 9 then -- switch 2, case 166
						l_c := 352
						l_pos := -1 + 16 -- switch 2; break
				when 10 then -- switch 2, case 168
						l_c := 353
						l_pos := -1 + 16 -- switch 2; break
				when 11 then -- switch 2, case 180
						l_c := 381
						l_pos := -1 + 16 -- switch 2; break
				when 12 then -- switch 2, case 184
						l_c := 382
						l_pos := -1 + 16 -- switch 2; break
				when 13 then -- switch 2, case 188
						l_c := 338
						l_pos := -1 + 16 -- switch 2; break
				when 14 then -- switch 2, case 189
						l_c := 339
						l_pos := -1 + 16 -- switch 2; break
				when 15 then -- switch 2, case 190
						l_c := 376
						l_pos := -1 + 16 -- switch 2; break
				when 16 then -- switch 2, done:
						l_d.ce_gets (l_d + (utf_char2bytes (l_c, l_d)))
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 6 -- back to loop condition
				when 17 then -- loop done
						l_d.item := (('%/0/').code).to_natural_8
						if (a_lenp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							a_lenp.item := l_d.distance (l_retval)
						end
						l_pos := -1 + 42 -- switch 1; break
				when 18 then -- switch 1, case 3 | switch 1, case 4
						l_retval.ce_gets (misc2_inst.alloc ((l_len + 1).to_natural_32))
						if (l_retval.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 42 -- switch 1; break
						end
				when 19 then
						l_d.ce_gets (l_retval)
						l_i___0 := 0
				when 20 then -- loop condition:
						if not (not js.loop_left and then (l_i___0 < l_len)) then
							l_pos := -1 + 40 -- skip loop
						end
				when 21 then -- loop body:
						js.reset
						l_l := utf_ptr2len_len (a_ptr + l_i___0, l_len - l_i___0)
						if l_l /= 0 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_tmp___5.ce_gets (l_d)
						l_d.ce_gets (l_d + 1)
						l_tmp___5.item := (('%/0/').code).to_natural_8
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 24 then -- else:
						if l_l /= 1 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_l_w := (utf8len_tab_zero[(a_ptr[l_i___0]).to_integer_32]).to_integer_32
						if l_l_w = 0 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_retval))
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called then
							if (a_unconvlenp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if l_l_w > l_len - l_i___0 then
									a_unconvlenp.item := l_len - l_i___0
									js.break
								end
							end
							if not js.loop_jumped then
								l_tmp___6.ce_gets (l_d)
								l_d.ce_gets (l_d + 1)
								l_tmp___6.item := a_ptr[l_i___0]
							end
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 27 then -- else:
						l_c := utf_ptr2char (a_ptr + l_i___0)
						if a_vcp.item.vc_type /= 4 then
							l_pos := -1 + 38 -- skip if block
						end
				when 28 then -- if:
						inspect l_c -- switch 3 head
						when 8364 then l_pos := -1 + 29
						when 352 then l_pos := -1 + 30
						when 353 then l_pos := -1 + 31
						when 381 then l_pos := -1 + 32
						when 382 then l_pos := -1 + 33
						when 338 then l_pos := -1 + 34
						when 339 then l_pos := -1 + 35
						when 376 then l_pos := -1 + 36
						when 164 then l_pos := -1 + 37
						when 166 then l_pos := -1 + 37
						when 168 then l_pos := -1 + 37
						when 180 then l_pos := -1 + 37
						when 184 then l_pos := -1 + 37
						when 188 then l_pos := -1 + 37
						when 189 then l_pos := -1 + 37
						when 190 then l_pos := -1 + 37
						else l_pos := -1 + 38
						end
				when 29 then -- switch 3, case 8364
						l_c := 164
						l_pos := -1 + 38 -- switch 3; break
				when 30 then -- switch 3, case 352
						l_c := 166
						l_pos := -1 + 38 -- switch 3; break
				when 31 then -- switch 3, case 353
						l_c := 168
						l_pos := -1 + 38 -- switch 3; break
				when 32 then -- switch 3, case 381
						l_c := 180
						l_pos := -1 + 38 -- switch 3; break
				when 33 then -- switch 3, case 382
						l_c := 184
						l_pos := -1 + 38 -- switch 3; break
				when 34 then -- switch 3, case 338
						l_c := 188
						l_pos := -1 + 38 -- switch 3; break
				when 35 then -- switch 3, case 339
						l_c := 189
						l_pos := -1 + 38 -- switch 3; break
				when 36 then -- switch 3, case 376
						l_c := 190
						l_pos := -1 + 38 -- switch 3; break
				when 37 then -- switch 3, case 164 | switch 3, case 166 | switch 3, case 168 | switch 3, case 180 | switch 3, case 184 | switch 3, case 188 | switch 3, case 189 | switch 3, case 190
						l_c := 256
						l_pos := -1 + 38 -- switch 3; break
				when 38 then -- switch 3, done: | if done
						if not (utf_iscomposing (l_c)).to_boolean then
							if l_c < 256 then
								l_tmp___7.ce_gets (l_d)
								l_d.ce_gets (l_d + 1)
								l_tmp___7.item := l_c.to_natural_8
							elseif (a_vcp.item.vc_fail).to_boolean then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_retval))
								Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								js.return
							else
								l_tmp___8.ce_gets (l_d)
								l_d.ce_gets (l_d + 1)
								l_tmp___8.item := (191).to_natural_8
								if (utf_char2cells (l_c)) > 1 then
									l_tmp___9.ce_gets (l_d)
									l_d.ce_gets (l_d + 1)
									l_tmp___9.item := (('?').code).to_natural_8
								end
							end
						end
						if not js.return_called then
							l_i___0 := l_i___0 + (l_l - 1)
						end
				when 39 then -- if done | if done
						if not js.loop_jumped then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 20 -- back to loop condition
				when 40 then -- loop done
						js.reset
						if not js.return_called then
							l_d.item := (('%/0/').code).to_natural_8
							if (a_lenp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								a_lenp.item := l_d.distance (l_retval)
							end
						end
						l_pos := -1 + 42 -- switch 1; break
				when 41 then -- switch 1, case 5
						l_retval.ce_gets (iconv_string (a_vcp, a_ptr, l_len, a_unconvlenp, a_lenp))
						l_pos := -1 + 42 -- switch 1; break
				when 42 then -- switch 1, done: | if done
						if not js.return_called then
							Result := l_retval
						end
				when 43 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
